angularApp.directive('angularStarRating', angularStarRating);

  function angularStarRating() {
    var directive = {

      restrict: 'EA',
	  require: "?ngModel",
      scope: {
        'value': '=value',
        'max': '=max',
        'hover': '=hover',
        'isReadonly': '=isReadonly',
		'status': '=status'
      },
      link: linkFunc,
      template: '<span ng-class="{isReadonly: isReadonly}">' +
      '<i ng-class="renderObj" ' +
      'ng-repeat="renderObj in renderAry" ' +
      'ng-click="setValue($index)" ' +
      'ng-mouseenter="changeValue($index, changeOnHover )" >' +
      '</i>' +
      '</span>',
      replace: true
    };
    return directive;
  }

  function linkFunc(scope, element, attrs, ngModelCtrl) {
	  console.log(ngModelCtrl);
    if (scope.max === undefined){
      scope.max = 5; // default
    }
    //console.log(scope.test);
    function renderValue() {
      scope.renderAry = [];
      for (var i = 0; i < scope.max; i++) {
        if (i < scope.value) {
          scope.renderAry.push({
            'star icon ion-star active': true
          });
        } else {
          scope.renderAry.push({
            'star icon ion-star': true
          });
        }
      }
	  
	  switch(scope.value){
		case 1:
			scope.status = "TERRIBLE";
		break;
		case 2:
			scope.status = "BAD";
		break;
		case 3:
			scope.status = "OK";
		break;
		case 4:
			scope.status = "GOOD";
		break;
		case 5:
			scope.status = "EXCELLENT";
		break;
		
	  }
	  
    }

    scope.setValue = function (index) {
      if (!scope.isReadonly && scope.isReadonly !== undefined) {
        scope.value = index + 1;
		ngModelCtrl.$setViewValue(scope.value);
        ngModelCtrl.$render();
      }
    };

    scope.changeValue = function (index) {
      if (scope.hover) {
        scope.setValue(index);
      } else {
        // !scope.changeOnhover && scope.changeOnhover != undefined
      }
    };

    scope.$watch('value', function (newValue, oldValue) {
      // console.log('oldValue -> newValue', oldValue, newValue);
      if (newValue) {
        renderValue();
      }
    });

    scope.$watch('max', function (newValue, oldValue) {
      // console.log('oldValue -> newValue', oldValue, newValue);
      if (newValue) {
        renderValue();
      }
    });
  }