/**
*   @ngdoc directive
*   @name angularApp.directive : clickStream
*   @restrict A
*   @description
*	Captures user click event
*   @example
*   <button id="SUBMIT_BTN" click-stream="click" ng-click="submit()"> Submit </button>
*   <input id="RED_RDO" click-stream="change" type="radio" name="red"   ng-model="color" ng-change="selectedColor(color)">
*   <ion-checkbox id="RED_CHK" click-stream="change" ng-model="red" ng-change="fselectedColor(color)" >
*/

angularApp.directive("clickStream", function ($state, clickStreamService, mPinLoginService) {
    return {
        restrict: 'A',
        link: function (scope, element, attribute) {
            // check for prelogin case
            if(!mPinLoginService.isLoggedIn)
            {   // check for OMP module/page request in pre login case
               if($state.current.data.pageId == 'OMP_MRCHT' || $state.current.data.pageId == 'OMP_VIEWALLCATEGORIES' || $state.current.data.pageId == 'OMP_MRCHTLST' || $state.current.data.pageId == 'OMP_SHP' || $state.current.data.pageId == 'OMP_SRCH' || $state.current.data.pageId == 'OMP_CTGYLST' || $state.current.data.pageId == 'OMP_SHPCTGY' || $state.current.data.pageId == 'OMP_CMPNCHRT' || $state.current.data.pageId == 'OMP_ELTRNCS' || $state.current.data.pageId ==  'OMP_SRCHLST' || $state.current.data.pageId == 'OMP_FLTR' || $state.current.data.pageId == 'OMP_FLTCTGY' || $state.current.data.pageId == 'OMP_PRDTDESC' || $state.current.data.pageId == 'OMP_SPCFPYMT' || $state.current.data.pageId == 'OMP_WSHLST' || $state.current.data.pageId == 'OMP_LOCLWSHLST' || $state.current.data.pageId == 'OMP_FLTCTGYLIST' || $state.current.data.pageId == 'OMP_REDISCLAIM'){
                // added pre-login to clickstream attribute
                attribute.id = "PRE_LOGIN_" + $state.current.data.pageId + "_" + attribute.id + clickStreamService.appTypeIdentifier;
               }else{
                // no change in attribute if not login but accessing module other than OMP   
                attribute.id = $state.current.data.pageId + "_" + attribute.id + clickStreamService.appTypeIdentifier;
               }
            }else{
                // no change in attribute after login
                attribute.id = $state.current.data.pageId + "_" + attribute.id + clickStreamService.appTypeIdentifier;
            }
            
            element.on((attribute.clickStream = "" ? "click" : attribute.clickStream), function () {
                setClickStreamData(attribute);
            });
            
            function setClickStreamData(attribute) {
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData(attribute.id));
            }
        }
    };
});
