/*
    Module Name  : Common,
    File Name    : directives.js,
    Description  : contains common directives for application
*/
/* $ionicHistory.clearCache();
$ionicHistory.clearHistory();*/

//(function() {
'use strict';
//directives list
angularApp.directive('customDatePicker', customDatePicker);
angularApp.directive('customFooter', customFooter);
angularApp.directive('validPhoneNumber', validPhoneNumber);
angularApp.directive('allowAlphanumericOnly', allowAlphanumericOnly);
angularApp.directive('allowAlphanumericywOnly', allowAlphanumericywOnly);
angularApp.directive('allowNomineeOnly', allowNomineeOnly);
angularApp.directive('allowNomineeOnlyname', allowNomineeOnlyname);
angularApp.directive('hcPieChart', hcPieChart);
angularApp.directive('ftallowAlphanumericOnly', ftallowAlphanumericOnly);
angularApp.directive('nfsallowAlphanumericOnly', nfsallowAlphanumericOnly);
angularApp.directive('mfallowAlphanumericOnly', mfallowAlphanumericOnly);
angularApp.directive('fssallowAlphanumericOnly', fssallowAlphanumericOnly);
angularApp.directive('ssallowAlphanumericOnly', ssallowAlphanumericOnly);
angularApp.directive('bhimallowAlphanumericOnly', bhimallowAlphanumericOnly);
angularApp.directive('alphanumericSpecialOnly', alphanumericSpecialOnly);
angularApp.directive('patwlAlphanumericSpecialOnly', patwlAlphanumericSpecialOnly);
angularApp.directive('allowAlphaOnly', allowAlphaOnly);
angularApp.directive('allowAlphaOnlyWithoutSpace', allowAlphaOnlyWithoutSpace);
angularApp.directive('allowAlphaOnlyAo', allowAlphaOnlyAo);
angularApp.directive('allowSpecialCharacters', allowSpecialCharacters);
angularApp.directive('numericOnly', numericOnly);
angularApp.directive('numericOnlyWithDot', numericOnlyWithDot);
angularApp.directive('numericOnlyStartNonZero', numericOnlyStartNonZero);
angularApp.directive('addressLineValidator', addressLineValidator);
angularApp.directive('validAmountField', validAmountField);
angularApp.directive('fssAmountInput', fssAmountInput);
angularApp.directive('hlInterestInput', hlInterestInput);
angularApp.directive('ftAmountInput', ftAmountInput);
angularApp.directive('validPinCode', validPinCode);
angularApp.directive('validAreaCode', validAreaCode);
angularApp.directive('validOfficeNo', validOfficeNo);
angularApp.directive('validEmailId', validEmailId);
angularApp.directive('validPanNo', validPanNo);
angularApp.directive('validName', validName);
angularApp.directive('validateName', validateName);
angularApp.directive('validAadharNo', validAadharNo);
angularApp.directive('input', input);
angularApp.directive('validPassportNo', validPassportNo);
angularApp.directive('validVehicleNo', validVehicleNo);
angularApp.directive('ngMax', ngMax);
angularApp.directive('ngMaxFloat', ngMaxFloat);
angularApp.directive('ngMin', ngMin);
angularApp.directive('heightInFeet', heightInFeet);
angularApp.directive('fssBindHtml', fssBindHtml);
angularApp.directive('fssToolTip', fssToolTip);
angularApp.directive('ssToolTip', ssToolTip);
angularApp.directive('inputAmount', inputAmount);
angularApp.directive('ompInputAmount', ompInputAmount);
angularApp.directive('educationInputAmount', educationInputAmount);
angularApp.directive('journeyBar', journeyBar);
angularApp.directive('ngmaxLength', ngmaxLength);
angularApp.directive('nfsMaxlength', nfsMaxlength);
angularApp.directive('atmCardNumber', atmCardNumber);
angularApp.directive('compileTemplate', compileTemplate);
angularApp.directive('eyeIconTmpl', eyeIconTmpl);
angularApp.directive('cardExpiry', cardExpiry);
angularApp.directive('allowAlphanumericSpecialWithoutSpace', allowAlphanumericSpecialWithoutSpace);
angularApp.directive('regAccDetAllowAlphanumericOnly', regAccDetAllowAlphanumericOnly);
angularApp.directive('inbAllowalphaNumericSpecial', inbAllowalphaNumericSpecial);
angularApp.directive('amountTransferStandard', amountTransferStandard);
angularApp.directive('rrName', rrName);
angularApp.directive('validNameGi', validNameGi);
angularApp.directive('plotNoVerifyGi', plotNoVerifyGi);
angularApp.directive('buildingNameGi', buildingNameGi);
angularApp.directive('streetNameGi', streetNameGi);
angularApp.directive('onlyCharacter',onlyCharacter);
angularApp.directive('validNameArsa',validNameArsa);
angularApp.directive('alphanumericSomeSpecialOnly',alphanumericSomeSpecialOnly)
angularApp.directive('ppsAmountInput', ppsAmountInput);
angularApp.directive('validCompanyName', validCompanyName);
angularApp.directive('currencyAmount', currencyAmount);




// Directive to show eye icon used for various fields like Acc No.,etc
function eyeIconTmpl() {
     return{
        restrict: 'E',
        scope: {
            eyesOnFunc: "&",
            eyesOffFunc: "&",
            mobileCloseEye: "=",
            mobileOpenEye: "=",
            moduleName: "@"   
        },
        require: '?ngModel',
        transclude : false,
        replace: false,
        templateUrl:'common/directives/templates/eyeIconTmpl.html',
        link:function (scope, element, attrs,ngModel) {  
     },    
 };
}

//Directive for page number template with/without elipses in starting and ending
function journeyBar() {
    return {
        restrict: 'E',
        replace: true,
        scope: {
            totalLength: '=?',
            activeBar: '=',
            items: '=?',
            hasPre: '=',
            hasPost: '=',
            postStart: '='
        },
        templateUrl: 'pages/lifeInsurance/journeyBar.html',
        link: function(scope, elm, attrs) {
            scope.items = [];

            var count = 7;
            if (scope.hasPre) {
                count--;
            }
            if (scope.hasPost) {
                count--;
            }
            for (var i = scope.postStart; i < (scope.postStart + count); i++) {
                scope.items.push(i);
            }
        }
    };
}

//Directive add/remove active class for input floating label
function input() {
    var directive = {
        priority: 4,
        restrict: 'E',
        link: link
    }
    return directive;

    function link(scope, element, attrs) {
        if (element.parent().hasClass('fss-input-box')) {
			element[0].setAttribute('autocomplete','off');
            element.bind("focus", function($event) {
                element.parent().addClass('fss-input-box-active');
            });
            element.bind("blur", function() {
                element.parent().removeClass('fss-input-box-active');
            });
			 if(!element[0].hasAttribute('maxlength')) {
                element[0].setAttribute('maxlength', '60');
            }

        }
    }
}


inputAmount.$inject = ["$filter", "$timeout"];
//Directive for amount input with max value attribute (LI)
function inputAmount($filter, $timeout) {
    var directive = {
        require: "?ngModel",
        link: link
    }
    return directive;

    function link(scope, element, attrs, ngModelCtrl) {
        var clean = ngModelCtrl.$viewValue;
        var cleanedVal;
        var f = element[0];

        var symbol = String.fromCharCode(8377);
        if (!ngModelCtrl) {
            return;
        }

        ngModelCtrl.$formatters.push(function(val) {
            if (val) {
                cleanedVal = $filter('INR')(val);
                return symbol + cleanedVal;
            } else {
                return '';
            }
        });

        ngModelCtrl.$parsers.unshift(function(val) {

            if (angular.isUndefined(val)) {
                val = '';
            }
            //val = val.replace(/^0/g,'');  
            clean = val.toString().replace(/[^0-9]/g, '');

            if (clean) {
                if(attrs.maxAmount && (Number(clean) > Number(attrs.maxAmount))) {
                    clean = attrs.maxAmount;
                }
                cleanedVal = $filter('INR')(Number(clean));
                cleanedVal = symbol + cleanedVal;
                ngModelCtrl.$viewValue = cleanedVal;
                ngModelCtrl.$commitViewValue();
                ngModelCtrl.$render();
                $timeout(function() {
                    f.selectionStart = f.value.length + 1;
                    f.selectionEnd = f.value.length + 1;
                }, 10);

                return clean;
            } else {
                ngModelCtrl.$viewValue = "";
                ngModelCtrl.$commitViewValue();
                ngModelCtrl.$render();
                $timeout(function() {
                    f.selectionStart = f.value.length + 1;
                    f.selectionEnd = f.value.length + 1;
                }, 10);

                return clean;
            }
        });
        if(attrs.maxAmount) {
            var max = $filter('INR')(attrs.maxAmount);
            attrs.$set('maxlength', max.length+1);
        }

        element.bind('keypress', function(event) {
            if (event.keyCode == 32) {
                event.preventDefault();
            }
        });
    }
}

educationInputAmount.$inject = ["$filter", "$timeout"];
function educationInputAmount($filter, $timeout) {
    var directive = {
        require: "?ngModel",
        link: link
    }
    return directive;

    function link(scope, element, attrs, ngModelCtrl) {
        var clean = ngModelCtrl.$viewValue;
        var cleanedVal;
        var f = element[0];

        var symbol = String.fromCharCode(8377);
        if (!ngModelCtrl) {
            return;
        }

        ngModelCtrl.$formatters.push(function (val) {
            if (val) {
                cleanedVal = $filter('INR')(val);
                return symbol + " " + cleanedVal;
            } else {
                return '';
            }
        });

        ngModelCtrl.$parsers.unshift(function (val) {

            if (angular.isUndefined(val)) {
                val = '';
            }
            //val = val.replace(/^0/g,'');  
            clean = val.toString().replace(/[^0-9]/g, '');

            if (clean) {
                if (attrs.maxAmount && (Number(clean) > Number(attrs.maxAmount))) {
                    clean = attrs.maxAmount;
                }
                cleanedVal = $filter('INR')(clean);
                cleanedVal = symbol + " " + cleanedVal;
                ngModelCtrl.$viewValue = cleanedVal;
                ngModelCtrl.$commitViewValue();
                ngModelCtrl.$render();
                $timeout(function () {
                    f.selectionStart = f.value.length + 1;
                    f.selectionEnd = f.value.length + 1;
                }, 10);

                return clean;
            } else {
                ngModelCtrl.$viewValue = "";
                ngModelCtrl.$commitViewValue();
                ngModelCtrl.$render();
                $timeout(function () {
                    f.selectionStart = f.value.length + 1;
                    f.selectionEnd = f.value.length + 1;
                }, 10);

                return clean;
            }
        });
        if (attrs.maxAmount) {
            var max = $filter('INR')(attrs.maxAmount);
            attrs.$set('maxlength', max.length + 1);
        }

        element.bind('keypress', function (event) {
            if (event.keyCode == 32) {
                event.preventDefault();
            }
        });
    }
}
currencyAmount.$inject = ["$filter", "$timeout", "constantConfig"];
function currencyAmount($filter, $timeout, constantConfig) {
    var directive = {
        require: "?ngModel",
        link: link
    }
    return directive;

    function link(scope, element, attrs, ngModelCtrl) {
        var clean = ngModelCtrl.$viewValue;
        var cleanedVal;
        var f = element[0];

        var symbol = String.fromCharCode(8377);
        if (!ngModelCtrl) {
            return;
        }
        var max = $filter(constantConfig.profile.currency)(attrs.maxAmount);
        ngModelCtrl.$formatters.push(function (val) {
            if (val) {
                cleanedVal = $filter('INR')(val);
                return symbol + " " + cleanedVal;
            } else {
                return '';
            }
        });

        ngModelCtrl.$parsers.unshift(function (val) {

            if (angular.isUndefined(val)) {
                val = '';
            }
            attrs.$set('maxlength', max.length + 2);
            val = val.replace(/^0+/, '');
            clean = val.toString().replace(/[^0-9]/g, '');
            if (clean) {
                if (attrs.maxAmount && (Number(clean) > Number(attrs.maxAmount))) {
                    clean = clean.slice(0, 9);
                }
                cleanedVal = $filter('INR')(clean);
                cleanedVal = symbol + " " + cleanedVal;
                ngModelCtrl.$viewValue = cleanedVal;
                ngModelCtrl.$commitViewValue();
                ngModelCtrl.$render();
                $timeout(function () {
                    f.selectionStart = f.value.length + 1;
                    f.selectionEnd = f.value.length + 1;
                }, 10);

                return clean;
            } else {
                ngModelCtrl.$viewValue = "";
                ngModelCtrl.$commitViewValue();
                ngModelCtrl.$render();
                return clean;
            }
        });

        element.bind('keypress', function (event) {
            if (event.keyCode == 32) {
                event.preventDefault();
            }
        });
    }
}
//Directive to open datePicker
//We can set default date,Min date,Max date and label
customDatePicker.$inject = ["$filter", "ionicDatePicker"];

function customDatePicker($filter, ionicDatePicker) {
    var directive = {
        restrict: "A",
        require: "?ngModel",
        priority: 1,
        scope: {
            defaultValue: '=',
            pickerLabel: '@',
            maxDate: '=',
            minDate: '=',
            todayButton: '@'
        },
        link: link
    }
    return directive;

    function link(scope, element, attrs, ngModelCtrl) {
        scope.todayButton = (angular.isDefined(scope.todayButton)) ? scope.todayButton : "true";

        element.bind('click', function() {
            if (attrs.customDatePicker == 'false') {
                return false;
            }
            var datePickerObj = {
                inputDate: (scope.defaultValue) ? new Date(scope.defaultValue) : new Date(),

                titleLabel: (scope.pickerLabel) ? scope.pickerLabel : 'Select a Date',
                setLabel: 'OK',
                closeLabel: 'Back',
                mondayFirst: false,
                weeksList: ["S", "M", "T", "W", "T", "F", "S"],
                monthsList: ["Jan", "Feb", "March", "April", "May", "June", "July", "Aug", "Sept", "Oct", "Nov", "Dec"],
                templateType: 'popup',
                showTodayButton: (scope.todayButton == "true") ? true : false,
                from: (scope.minDate) ? scope.minDate : '',
                to: (scope.maxDate) ? scope.maxDate : '',
                dateFormat: 'dd MMM yyyy',
                closeOnSelect: false,
                disableWeekdays: [],
                callback: function(val) {
                    var viewValue = $filter('chosenDate')(val);
                    ngModelCtrl.$setViewValue(viewValue);
                    ngModelCtrl.$render();
                    //  scope.$apply();
                }
            };
            ionicDatePicker.openDatePicker(datePickerObj);
        });
    }
}

//Directive to validate phone number
validPhoneNumber.$inject = ["$filter", "$timeout"];

function validPhoneNumber($filter, $timeout) {
    var directive = {
        require: "?ngModel",
        priority: 1,
        link: link
    }
    return directive;

    function link(scope, element, attrs, ngModelCtrl) {
        var f = element[0];

        if (!ngModelCtrl) {
            return;
        }
        ngModelCtrl.$parsers.unshift(function(val) {

            if (val && val.length > 10) {
                val = val.substring(0, val.length - 1);
            }


            if (angular.isUndefined(val)) {
                val = '';
            }
            var clean;
            /*if (val.length >= 3) {
                clean = val.toString().substr(3).replace(/[^0-9]/g, '');
            } else {*/
            clean = val;
            //}

            var cleanedVal;

            if (val !== clean) {
                cleanedVal = clean;
                //cleanedVal = '+91' + cleanedVal;
                ngModelCtrl.$viewValue = cleanedVal;
                ngModelCtrl.$render();
                $timeout(function() {
                    f.selectionStart = f.value.length + 1;
                    f.selectionEnd = f.value.length + 1;
                }, 10);
                return cleanedVal;
            }
            if (val) {
                cleanedVal = val;
                //cleanedVal = '+91' + cleanedVal;
                ngModelCtrl.$viewValue = cleanedVal;
                ngModelCtrl.$render();
                $timeout(function() {
                    f.selectionStart = f.value.length + 1;
                    f.selectionEnd = f.value.length + 1;
                }, 10);
                return cleanedVal;
            } else {
                //ngModelCtrl.$viewValue = '+91';
                ngModelCtrl.$viewValue = '';
                ngModelCtrl.$render();
                $timeout(function() {
                    f.selectionStart = f.value.length + 1;
                    f.selectionEnd = f.value.length + 1;
                }, 10);
                //return '+91';
                return '';
            }
        });
        attrs.$set('maxlength', '10');
        element.bind('keypress', function(event) {
            if (event.keyCode === 32 || (this.value.length == 10)) {
                event.preventDefault();
            }
        });
    }
}


ngMax.$inject = ["$filter", "$timeout"];

function ngMax($filter, $timeout) {

    var directive = {
        require: "?ngModel",
        priority: 1,
        link: link
    }
    return directive;

    function link(scope, element, attrs, ngModelCtrl) {

        if (!ngModelCtrl) {
            return;
        }
        ngModelCtrl.$parsers.unshift(function(val) {
            if (parseInt(ngModelCtrl.$viewValue) > parseInt(attrs.ngMax)) {
                ngModelCtrl.$modelValue = attrs.ngMax;
                ngModelCtrl.$viewValue = attrs.ngMax;
                ngModelCtrl.$render();
                return attrs.ngMax;

            } else {
                return val;
            }
        });
        if(attrs.ngMax) {
            attrs.$set('maxlength', attrs.ngMax.length);
        }
    }
}


// @Krishna Singh
ngMaxFloat.$inject = ["$filter", "$timeout"];

function ngMaxFloat($filter, $timeout) {

    var directive = {
        require: "?ngModel",
        priority: 1,
        link: link
    }
    return directive;

    function link(scope, element, attrs, ngModelCtrl) {

        if (!ngModelCtrl) {
            return;
        }
        ngModelCtrl.$parsers.unshift(function (val) {
            if (parseFloat(ngModelCtrl.$viewValue) > parseFloat(attrs.ngMaxFloat)) {
                ngModelCtrl.$modelValue = attrs.ngMaxFloat;
                ngModelCtrl.$viewValue = attrs.ngMaxFloat;
                ngModelCtrl.$render();
                return attrs.ngMaxFloat;

            } else {
                // var findsDot = new RegExp(/\./g);
                // var containsDot = val.match(findsDot);

                var indexOfDot = val.indexOf(".");
                if (indexOfDot != -1 && (parseFloat(ngModelCtrl.$viewValue) < parseFloat(attrs.ngMaxFloat))) {
                    attrs.$set('maxlength', (indexOfDot+2));
                    var res = val.substring((indexOfDot + 1), (indexOfDot + 2));
                    if (res) {
                        var newVal = val.replace(new RegExp(res + '$'), "5");
                        //ngModelCtrl.$modelValue = newVal;
                        ngModelCtrl.$viewValue = newVal;
                        ngModelCtrl.$commitViewValue();
                        ngModelCtrl.$render();
                        return newVal;
                    } else {
                        return val;
                    }
                }else if (indexOfDot != -1 && (parseFloat(ngModelCtrl.$viewValue) == parseFloat(attrs.ngMaxFloat))) {
                    var newVal = parseInt(val).toString();
                    ngModelCtrl.$viewValue = newVal;
                    ngModelCtrl.$commitViewValue();
                    ngModelCtrl.$render();
                    return newVal;
                } else {
                    return val;
                }


                // console.log("containsDot :" + containsDot);
                // console.log("newVal :" + newVal);

            }
        });
        if (attrs.ngMaxFloat) {
            attrs.$set('maxlength', attrs.ngMaxFloat.length);
        }
    }
}


ngMin.$inject = ["$filter", "$timeout"];

function ngMin($filter, $timeout) {

    var directive = {
        require: "?ngModel",
        priority: 1,
        link: link
    }
    return directive;

    function link(scope, element, attrs, ngModelCtrl) {
        if (!ngModelCtrl) {
            return;
        }
        ngModelCtrl.$parsers.unshift(function(val) {
            if (parseInt(ngModelCtrl.$viewValue) < parseInt(attrs.ngMin)) {
                ngModelCtrl.$modelValue = attrs.ngMin;
                ngModelCtrl.$viewValue = attrs.ngMin;
                ngModelCtrl.$render();
                return attrs.ngMin;

            } else {
                return val;
            }
        });
        if(attrs.ngMin) {
            attrs.$set('maxlength', attrs.ngMin.length);
        }
    }
}

ngmaxLength.$inject = ["$filter", "$timeout"];

function ngmaxLength($filter, $timeout) {

    var directive = {
        require: "?ngModel",
        priority: 1,
        link: link
    }
    return directive;

    function link(scope, element, attrs, ngModelCtrl) {
        if (!ngModelCtrl) {
            return;
        }
        ngModelCtrl.$parsers.unshift(function(val) {
            if (ngModelCtrl.$viewValue.length > parseInt(attrs.ngmaxLength)) {
                var viewValueDetail = ngModelCtrl.$viewValue;
                viewValueDetail =  viewValueDetail.slice(0,Number(attrs.ngmaxLength));
                //ngModelCtrl.$modelValue = viewValueDetail;
                ngModelCtrl.$viewValue = viewValueDetail;
                ngModelCtrl.$commitViewValue();
                ngModelCtrl.$render();
                return viewValueDetail;
            } else {
                return val;
            }
        });
        if(attrs.ngmaxLength) {
           // attrs.$set('maxlength', attrs.ngmaxLength);
        }
    }
}


// function ngmaxLength($filter, $timeout) {

//     var directive = {
//         require: "?ngModel",
//         priority: 1,
//         link: link
//     }
//     return directive;

//     function link(scope, element, attrs, ngModelCtrl) {
//         if (!ngModelCtrl) {
//             return;
//         }
//         ngModelCtrl.$parsers.unshift(function(val) {
//             if (ngModelCtrl.$viewValue.length > parseInt(attrs.ngmaxLength)) {
//                 var viewValueDetail = ngModelCtrl.$viewValue;
//                 var tempValue;
//                 //viewValueDetail =  viewValueDetail.slice(0,Number(attrs.ngmaxLength));
//                 tempValue = viewValueDetail.split("");
//                 if(element[0].selectionStart >= attrs.ngmaxLength){
//                     viewValueDetail =  viewValueDetail.slice(0,Number(attrs.ngmaxLength));
//                 }
//                 else{
//                     tempValue.splice(element[0].selectionStart,1);
//                     viewValueDetail =  tempValue.join("");
//                 }
//                 //ngModelCtrl.$modelValue = viewValueDetail;
//                 ngModelCtrl.$viewValue = viewValueDetail;
//                 ngModelCtrl.$commitViewValue();
//                 ngModelCtrl.$render();
//                 return viewValueDetail;
//             } else {
//                 return val;
//             }
//         });
//         if(attrs.ngmaxLength) {
//            // attrs.$set('maxlength', attrs.ngmaxLength);
//         }
//     }
// }

/* NFS max length start here */
nfsMaxlength.$inject = ["$filter", "$timeout"];

function nfsMaxlength($filter, $timeout) {

    var directive = {
        require: "?ngModel",
        priority: 1,
        link: link
    }
    return directive;

    function link(scope, element, attrs, ngModelCtrl) {
        if (!ngModelCtrl) {
            return;
        }
        ngModelCtrl.$parsers.unshift(function(val) {
            if (ngModelCtrl.$viewValue.length > parseInt(attrs.nfsMaxlength)) {
                var viewValueDetail = ngModelCtrl.$viewValue;
                var tempValue;
                //viewValueDetail =  viewValueDetail.slice(0,Number(attrs.ngmaxLength));
                tempValue = viewValueDetail.split("");
                if(element[0].selectionStart >= attrs.nfsMaxlength){
                    viewValueDetail =  viewValueDetail.slice(0,Number(attrs.nfsMaxlength));
                }
                else{
                    tempValue.splice(element[0].selectionStart-1,1);
                    viewValueDetail =  tempValue.join("");
                }
                //ngModelCtrl.$modelValue = viewValueDetail;
                ngModelCtrl.$viewValue = viewValueDetail;
                ngModelCtrl.$commitViewValue();
                ngModelCtrl.$render();
                return viewValueDetail;
            } else {
                return val;
            }
        });
        if(attrs.nfsMaxlength) {
           // attrs.$set('maxlength', attrs.ngmaxLength);
        }
    }
}
/* NFS max length  end here  */




/*maxAmount.$inject = ["$filter", "$timeout"];

function maxAmount($filter, $timeout) {
    var directive = {
        require: "?ngModel",
        priority: 1,
        link: link
    }
    return directive;

    function link(scope, element, attrs, ngModelCtrl) {
        if (!ngModelCtrl) {
            return;
        }
        ngModelCtrl.$parsers.unshift(function(val) {
            if (val) {
                val = $filter('formatAmount')(val);
                if (parseInt(val) > parseInt(attrs.maxAmount)) {
                    ngModelCtrl.$modelValue = attrs.maxAmount;
                    ngModelCtrl.$viewValue = attrs.maxAmount;
                    ngModelCtrl.$render();
                    return attrs.maxAmount;
                }
            } else {
                return val;
            }
        });
    }
}*/


//Directive to validate pincode
validPinCode.$inject = ["$filter", "$timeout"];

function validPinCode($filter, $timeout) {
    var directive = {
        require: "?ngModel",
        priority: 1,
        link: link
    }
    return directive;

    function link(scope, element, attrs, ngModelCtrl) {
        if (!ngModelCtrl) {
            return;
        }
        ngModelCtrl.$parsers.unshift(function(val) {

            if (val && val.length > 6) {
                val = val.substring(0, val.length - 1);
            }

            if (angular.isUndefined(val)) {
                val = '';
            }
            var clean = val.toString().replace(/[^0-9]/g, '');
            if (val !== clean) {
                ngModelCtrl.$setViewValue(clean);
                ngModelCtrl.$render();
            }
            return clean;
        });
        attrs.$set('maxlength', '6');
        element.bind('keypress', function(event) {
            if (event.keyCode === 32 || (this.value.length == 6)) {
                event.preventDefault();
            }
        });
    }
}
//Directive to validate company name
function validCompanyName() {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }
            function userInput(text) {
                var transformedInputVal = text.replace(/[^A-Za-z0-9\s]/g, '');
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
            element.bind('keypress', function (event) {
                if (event.keyCode == 45) {
                    event.preventDefault();
                }
            });
        }
    }
}
//Directive to validate area code
function validAreaCode($filter, $timeout) {
    var directive = {
        require: "?ngModel",
        priority: 1,
        link: link
    }
    return directive;

    function link(scope, element, attrs, ngModelCtrl) {
        if (!ngModelCtrl) {
            return;
        }

        element.bind('keypress', function(event) {
            if (event.keyCode === 32 || (this.value.length == 3)) {
                event.preventDefault();
            }
        });
    }
}
//Directive to validate area code
function validOfficeNo($filter, $timeout) {
    var directive = {
        require: "?ngModel",
        priority: 1,
        link: link
    }
    return directive;

    function link(scope, element, attrs, ngModelCtrl) {
        if (!ngModelCtrl) {
            return;
        }

        element.bind('keypress', function(event) {
            if (event.keyCode === 32 || (this.value.length == 8)) {
                event.preventDefault();
            }
        });
    }
}
//validate amount field and place INR filter and rs symbol.
validAmountField.$inject = ["$filter", "$timeout"];

function validAmountField($filter, $timeout) {
    var directive = {
        require: "?ngModel",
        link: link
    }
    return directive;

    function link(scope, element, attrs, ngModelCtrl) {
        attrs.$set('maxlength', '15');
        var clean = ngModelCtrl.$viewValue;
        var cleanedVal;
        var f = element[0];
        var symbol = String.fromCharCode(8377);
        if (!ngModelCtrl) {
            return;
        }
        ngModelCtrl.$parsers.unshift(function(val) {
            if (angular.isUndefined(val)) {
                val = '';
            }
            val = val.replace(/^0/g,'');    
            clean = val.toString().replace(/[^0-9]/g, '');
            if (clean) {
                cleanedVal = symbol + $filter('INR')(clean);
                ngModelCtrl.$viewValue = cleanedVal;
                ngModelCtrl.$commitViewValue();
                ngModelCtrl.$render();
                setTimeout(function() {
                    f.selectionStart = f.value.length + 1;
                    f.selectionEnd = f.value.length + 1;
                }, 10);

                // el.setSelectionRange(el.selectionStart, cleanedVal.length);
                return cleanedVal;
            } else {
                ngModelCtrl.$viewValue = "";
                ngModelCtrl.$commitViewValue();
                ngModelCtrl.$render();
                setTimeout(function() {
                    f.selectionStart = f.value.length + 1;
                    f.selectionEnd = f.value.length + 1;
                }, 10);
                return symbol;
            }

        });
        element.bind('keypress', function(event) {
            if (event.keyCode === 32) {
                event.preventDefault();
            }
        });
    }
}



/* Allow Only numbers 2 decimal places  */
fssAmountInput.$inject = ["$filter", "$browser", "utilityService","$timeout"];

function fssAmountInput($filter, $browser, utilityService,$timeout) {
    var directive = {
        require: "?ngModel",
        link: link
    }
    return directive;

    function link(scope, element, attrs, ngModelCtrl) {


         var f = element[0];
         var cursorLocation = 0;
         var currentCursorLocation;
         var previousCursorLocation;
         var currentLength;
         var previousDetail;
         var cursorchanged = false;


        var symbol = String.fromCharCode(8377);
        if (!ngModelCtrl) {
            return;
        }
        var listener = function() {
            var value = element.val().replace(/,/g, '')
            element.val($filter('INR')(value, false))
        }
        ngModelCtrl.$parsers.push(function(val) {
            val = symbol + val;
            if (angular.isUndefined(val)) {
                var val = '';
            }

            var clean = utilityService.isUndefined(attrs.noDecimal) ? val.replace(/[^0-9\.]/g, '') : val.replace(/[^0-9]/g, '');
            var negativeCheck = clean.split('-');
            var decimalCheck = clean.split('.');
            if (!angular.isUndefined(negativeCheck[1])) {
                negativeCheck[1] = negativeCheck[1].slice(0, negativeCheck[1].length);
                clean = negativeCheck[0] + '-' + negativeCheck[1];
                if (negativeCheck[0].length > 0) {
                    clean = negativeCheck[0];
                }
            }
            if (!angular.isUndefined(decimalCheck[1])) {
                decimalCheck[1] = decimalCheck[1].slice(0, 2);
                clean = decimalCheck[0] + '.' + decimalCheck[1];
            }

            if (val !== clean) {
                ngModelCtrl.$setViewValue(clean);
                ngModelCtrl.$render();
                ngModelCtrl.$render = function() {
                    element.val(symbol + $filter('INR')(ngModelCtrl.$viewValue, false))
                }
            }
               $timeout(function() {
                    f.selectionStart = f.value.length + 1;
                    f.selectionEnd = f.value.length + 1;
                }, 10);
            return clean;
        });

        element.bind('keypress', function(event) {
            if (event.keyCode === 32) {
                event.preventDefault();
            }
        });
        element.bind('change', listener);
        element.bind('keydown', function(event) {
            $browser.defer(listener) // Have to do this or changes don't get picked up properly
        });
        element.bind('focus', function(event) {
            $browser.defer(listener) // Have to do this or changes don't get picked up properly
        });
        element.bind('click', function(event) {
            $browser.defer(listener) // Have to do this or changes don't get picked up properly
            previousCursorLocation = f.selectionEnd -1;
            cursorchanged = true;
        });
    }
}

/* hlInterestInput*/
hlInterestInput.$inject = ["$filter", "$browser", "utilityService", "$timeout"];

function hlInterestInput($filter, $browser, utilityService, $timeout) {
    var directive = {
        require: "?ngModel",
        link: link
    }
    return directive;

    function link(scope, element, attrs, ngModelCtrl) {


        var f = element[0];
        var cursorLocation = 0;
        var currentCursorLocation;
        var previousCursorLocation;
        var currentLength;
        var previousDetail;
        var cursorchanged = false;


        /*var symbol = String.fromCharCode(8377);
        if (!ngModelCtrl) {
            return;
        }*/
        // var listener = function () {)
        //     var value = element.val(.replace(/,/g, '')
        //     element.val(value, fals)
        // }
        ngModelCtrl.$parsers.push(function (val) {
            //val = symbol + val;
            if (angular.isUndefined(val)) {
                var val = '';
            }

            var clean = utilityService.isUndefined(attrs.noDecimal) ? val.replace(/[^0-9\.]/g, '') : val.replace(/[^0-9]/g, '');
            var negativeCheck = clean.split('-');
            var decimalCheck = clean.split('.');
            if (!angular.isUndefined(negativeCheck[1])) {
                negativeCheck[1] = negativeCheck[1].slice(0, negativeCheck[1].length);
                clean = negativeCheck[0] + '-' + negativeCheck[1];
                if (negativeCheck[0].length > 0) {
                    clean = negativeCheck[0];
                }
            }
            if (!angular.isUndefined(decimalCheck[1])) {
                decimalCheck[1] = decimalCheck[1].slice(0, 2);
                clean = decimalCheck[0] + '.' + decimalCheck[1];
            }

            if (val !== clean) {
                ngModelCtrl.$setViewValue(clean);
                ngModelCtrl.$render();
                ngModelCtrl.$render = function () {
                    //element.val(symbol + (ngModelCtrl.$viewValue, false))
                    element.val(ngModelCtrl.$viewValue, false)
                }
            }
            $timeout(function () {
                f.selectionStart = f.value.length + 1;
                f.selectionEnd = f.value.length + 1;
            }, 10);
            return clean;
        });

        element.bind('keypress', function (event) {
            if (event.keyCode === 32) {
                event.preventDefault();
            }
        });
        element.bind('change', listener);
        element.bind('keydown', function (event) {
            $browser.defer(listener) // Have to do this or changes don't get picked up properly
        });
        element.bind('focus', function (event) {
            $browser.defer(listener) // Have to do this or changes don't get picked up properly
        });
        element.bind('click', function (event) {
            $browser.defer(listener) // Have to do this or changes don't get picked up properly
            previousCursorLocation = f.selectionEnd - 1;
            cursorchanged = true;
        });
    }
}

/* Allow Only numbers 2 decimal places  (in this directive amount symbol will not bind)*/
ftAmountInput.$inject = ["$filter", "$browser", "utilityService","$timeout"];

function ftAmountInput($filter, $browser, utilityService,$timeout) {
    var directive = {
        require: "?ngModel",
        link: link
    }
    return directive;

    function link(scope, element, attrs, ngModelCtrl) {


         var f = element[0];
         var cursorLocation = 0;
         var currentCursorLocation;
         var previousCursorLocation;
         var currentLength;
         var previousDetail;
         var cursorchanged = false;

        if (!ngModelCtrl) {
            return;
        }
        var listener = function() {
            var value = element.val().replace(/,/g, '')
            element.val($filter('INR')(value, false))
        }
        ngModelCtrl.$parsers.push(function(val) {
            if (angular.isUndefined(val)) {
                var val = '';
            }

            var clean = utilityService.isUndefined(attrs.noDecimal) ? val.replace(/[^0-9\.]/g, '') : val.replace(/[^0-9]/g, '');
            var negativeCheck = clean.split('-');
            var decimalCheck = clean.split('.');
            if (!angular.isUndefined(negativeCheck[1])) {
                negativeCheck[1] = negativeCheck[1].slice(0, negativeCheck[1].length);
                clean = negativeCheck[0] + '-' + negativeCheck[1];
                if (negativeCheck[0].length > 0) {
                    clean = negativeCheck[0];
                }
            }
            if (!angular.isUndefined(decimalCheck[1])) {
                decimalCheck[1] = decimalCheck[1].slice(0, 2);
                clean = decimalCheck[0] + '.' + decimalCheck[1];
            }

            if (val !== clean) {
                ngModelCtrl.$setViewValue(clean);
                ngModelCtrl.$render();
                ngModelCtrl.$render = function() {
                    element.val(symbol + $filter('INR')(ngModelCtrl.$viewValue, false))
                }
            }
               $timeout(function() {
                    f.selectionStart = f.value.length + 1;
                    f.selectionEnd = f.value.length + 1;
                }, 10);
            return clean;
        });

        element.bind('keypress', function(event) {
            if (event.keyCode === 32) {
                event.preventDefault();
            }
        });
        element.bind('change', listener);
        element.bind('keydown', function(event) {
            $browser.defer(listener) // Have to do this or changes don't get picked up properly
        });
        element.bind('focus', function(event) {
            $browser.defer(listener) // Have to do this or changes don't get picked up properly
        });
        element.bind('click', function(event) {
            $browser.defer(listener) // Have to do this or changes don't get picked up properly
            previousCursorLocation = f.selectionEnd -1;
            cursorchanged = true;
        });
    }
}

//directive allows user to enter Alphanumeric Only 
allowAlphanumericOnly.$inject = ["$filter", "$timeout"];

function allowAlphanumericOnly($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }
            attrs.$set('maxlength', '50');

            function userInput(text) {
                var transformedInputVal = text.replace(/[^A-Za-z0-9\s]/g, '');
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
        }
    }

}

//directive allows user to enter Alphanumeric Only  maxlength 20
allowAlphanumericywOnly.$inject = ["$filter", "$timeout"];

function allowAlphanumericywOnly($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }
            attrs.$set('maxlength', '20');

            function userInput(text) {
                var transformedInputVal = text.replace(/[^A-Za-z0-9\s]/g, '');
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
        }
    }

}

//directive allows user to enter Alphanumeric Only 
regAccDetAllowAlphanumericOnly.$inject = ["$filter", "$timeout"];

function regAccDetAllowAlphanumericOnly($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }

            function userInput(text) {
                var transformedInputVal = text.replace(/[^A-Za-z0-9]/g, '');
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
        }
    }

}
hcPieChart.$inject = ["$filter", "$timeout"];
function hcPieChart($filter, $timeout) {
    return {
        restrict: 'E',
        template: '<div></div>',
        scope: { 
            data: '='
        },
        link: function (scope, element) {
            Highcharts.chart(element[0], {
                chart: {
                    plotBorderWidth: null,
                    plotShadow: false
                },
                credits: {
                    enabled: false
                },
                title: {
                    text: 'Investments',
                    floating: true,
                    align: "left",
                    useHTML: true,
                    style: { "color": "#3F3F3F", "fontSize": "14px", "font-family": "'Roboto-Medium'", "left": "16px !important" }
                },
                tooltip: {
                    enabled: false
                },
                legend: {
                    labelFormat: '{name} {y:.1f}%',
                },
                plotOptions: {
                    pie: {
                        colorIndex: 0,
                        shadow: false,
                        center: ['50%', '50%'],
                        size: '60%',
                        innerSize: '70%',
                        allowPointSelect: true,
                        dataLabels: {
                            alignTo: "toPlotEdges",//toPlotEdges,connectors
                            enabled: true,
                            allowOverlap: true,
                            connectorPadding: 0,
                            connectorShape: 'crookedLine',//straight,crookedLine,fixedOffset
                            crookDistance: '90%',
                            distance: 25,
                            useHTML: true,
                            formatter: function () {
                                var str;
                                if (this.point.name !== 'Remaining' && this.point.y !== 0) {
                                    var percentage = this.point.y / this.point.total * 100;
                                    str = "<span style='font-size: 10px;font-family: Roboto-Light;color:"+this.point.color+"'>" + this.point.name + "</span><br><span style='font-size: 10px;font-family: Roboto-Light;color:#3F3F3F;' class='amount'>&#8377; " + (this.point.y).toFixed(2) + "  (" + percentage.toFixed(2) + "%)</span>";
                                }
                                return str;
                            },
                            style: { "fontSize": "10px", "font-family": "Roboto-Regular" }
                        }
                    },
                    series: {
                        gapSize: 0,
                        enableMouseTracking: false
                    }
                },
                series: [{
                    type: 'pie',
                    name: 'Investment share',
                    data: scope.data
                }]
            });
        }
    };
}

//directive allows user to enter Alphanumeric Only 
ftallowAlphanumericOnly.$inject = ["$filter", "$timeout"];

function ftallowAlphanumericOnly($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }
            attrs.$set('maxlength', '80');

            function userInput(text) {
                var transformedInputVal = text.replace(/[^A-Za-z0-9\s]/g, '');
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
        }
    }

}

//directive allows user to enter Alphanumeric Only 
ssallowAlphanumericOnly.$inject = ["$filter", "$timeout"];

function ssallowAlphanumericOnly($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }
            attrs.$set('maxlength', '15');

            function userInput(text) {
                var transformedInputVal = text.replace(/[^A-Za-z0-9\s]/g, '');
                transformedInputVal = transformedInputVal.replace(" ","");
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
        }
    }

}

//directive allows user to enter Alphanumeric Only 
bhimallowAlphanumericOnly.$inject = ["$filter", "$timeout"];

function bhimallowAlphanumericOnly($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }
            // attrs.$set('maxlength', '40');

            function userInput(text) {
                var transformedInputVal = text.replace(/[^a-zA-Z0-9@()#._;: '/,-\s]/g, '');
                //var transformedInputVal = text.replace(/[^0-9]/g, '');
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
        }
    }

}



//directive allows user to enter Alphanumeric Only 
mfallowAlphanumericOnly.$inject = ["$filter", "$timeout"];

function mfallowAlphanumericOnly($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }
            // attrs.$set('maxlength', '40');

            function userInput(text) {
                 var transformedInputVal = text.replace(/[^A-Za-z0-9-,]/g, '');
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
        }
    }

}
//directive allows user to enter Alphanumeric Only 
nfsallowAlphanumericOnly.$inject = ["$filter", "$timeout"];

function nfsallowAlphanumericOnly($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }
            // attrs.$set('maxlength', '40');

            function userInput(text) {
                var transformedInputVal = text.replace(/[^a-zA-Z0-9- ,._\/]/g, '');
                //var transformedInputVal = text.replace(/[^0-9]/g, '');
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
        }
    }

}


allowNomineeOnly.$inject = ["$filter", "$timeout"];

function allowNomineeOnly($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }

            function userInput(text) {
                 var transformedInputVal = text.replace(/[^A-Za-z0-9./,\/()\-=+_\.\s]/g, '');
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
        }
    }

}


allowNomineeOnlyname.$inject = ["$filter", "$timeout"];

function allowNomineeOnlyname($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }

            function userInput(text) {
                var transformedInputVal = text.replace(/[^A-Za-z\.\s]/g, '');
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
        }
    }

}
//directive allows user to enter Alphanumeric Only 
alphanumericSpecialOnly.$inject = ["$filter", "$timeout"];

function alphanumericSpecialOnly($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }
            // attrs.$set('maxlength', '40');

            function userInput(text) {
                var transformedInputVal = text.replace(/[^A-Za-z0-9@()#._;:'/,-\s]/g, '');
            //var transformedInputVal = text.replace(/[^A-Za-z0-9@(#).-_:/';s]/g, '');
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
        }
    }

}

patwlAlphanumericSpecialOnly.$inject = ["$filter", "$timeout"];

function patwlAlphanumericSpecialOnly($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }
            // attrs.$set('maxlength', '40');

            function userInput(text) {
                var transformedInputVal = text.replace(/[^A-Za-z0-9&@()#._;:'/,-\s]/g, '');
            //var transformedInputVal = text.replace(/[^A-Za-z0-9@(#).-_:/';s]/g, '');
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
        }
    }
}

inbAllowalphaNumericSpecial.$inject = ["$filter", "$timeout"];

function inbAllowalphaNumericSpecial($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }
            // attrs.$set('maxlength', '40');

            function userInput(text) {
                var transformedInputVal = text.replace(/[^A-Za-z0-9`~!@\$#%^*&;.\\]/g, '');
            //var transformedInputVal = text.replace(/[^A-Za-z0-9@(#).-_:/';s]/g, '');
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
        }
    }

}
inbProfilePassword.$inject = ["$filter", "$timeout"];

function inbProfilePassword($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }
            // attrs.$set('maxlength', '40');

            function userInput(text) {
                var transformedInputVal = text.replace(/[^A-Za-z0-9@#&*!]/g, '');
            //var transformedInputVal = text.replace(/[^A-Za-z0-9@(#).-_:/';s]/g, '');
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
        }
    }

}
//directive restricts user to enter space
allowAlphanumericSpecialWithoutSpace.$inject = ["$filter", "$timeout"];

function allowAlphanumericSpecialWithoutSpace($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }
            // attrs.$set('maxlength', '40');

            function userInput(text) {
                //  var transformedInputVal = text.replace(/[^A-Za-z0-9`~!@#$%^&*\.,;]/g, '');
              var transformedInputVal = text.replace(/[^A-Za-z0-9!@#$%*&^~`.,;]/g, '');
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
        }
    }

}

atmCardNumber.$inject = ["$filter", "$timeout"];
function atmCardNumber($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }



            function cc_format(value) {
                var v = value.replace(/\s+/g, '').replace(/[^0-9]/gi, '')
                var matches = v.match(/\d{4,20}/g);
                var match = matches && matches[0] || '';
                var parts = [];

                for (var i = 0, len = match.length; i < len; i += 4) {
                    parts.push(match.substring(i, i + 4));
                }
                var result= '';
                if (parts.length > 1) {
                    var transformedInputVal = parts.join('-');
                     ngModelCtrl.$viewValue = transformedInputVal;
                    //ngModelCtrl.$modelValue=v;
                    ngModelCtrl.$render();
                    return  v;
                } else {
                    return value;
                }
            }
           
            ngModelCtrl.$parsers.push(cc_format);
           
           
           
        }
    }

}

cardExpiry.$inject = ["$filter", "$timeout"];
function cardExpiry($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }



            function cc_format(value) {
                var v = value.replace(/\s+/g, '').replace(/[^0-9]/gi, '')
                var matches = v.match(/\d{2,20}/g);
                var match = matches && matches[0] || '';
                var parts = [];

                for (var i = 0, len = match.length; i < len; i += 2) {
                    parts.push(match.substring(i, i + 2));
                }
                var result= '';
                if (parts.length > 1) {
                    var transformedInputVal = parts.join('/');
                     ngModelCtrl.$viewValue = transformedInputVal;
                    //ngModelCtrl.$modelValue=v;
                    ngModelCtrl.$render();
                    return  v;
                } else {
                    return value;
                }
            }
           
            ngModelCtrl.$parsers.push(cc_format);
           
           
           
        }
    }

}


//directive allows user to enter Special cahracters  
allowSpecialCharacters.$inject = ["$filter", "$timeout"];

function allowSpecialCharacters($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }
            attrs.$set('maxlength', '30');

            function userInput(text) {
                var transformedInputVal = text.replace(/[^A-Za-z0-9./,-\s]/g, '');
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
        }
    }

}


//directive allows user to enter Alpha Only 
allowAlphaOnly.$inject = ["$filter", "$timeout"];

function allowAlphaOnly($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }

            function userInput(text) {
                var transformedInputVal = text.replace(/[^A-Za-z\s]/g, '');
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
        }
    }

}

//directive allows user to enter Alpha Only without space
//@krishna Singh 
allowAlphaOnlyWithoutSpace.$inject = ["$filter", "$timeout"];

function allowAlphaOnlyWithoutSpace($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }

            function userInput(text) {
                var transformedInputVal = text.replace(/[^A-Za-z]/g, '');
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
        }
    }

}

//directive allows user to enter Alpha Only (Account Opening)
allowAlphaOnlyAo.$inject = ["$filter", "$timeout"];

function allowAlphaOnlyAo($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }

            function userInput(text) {
                var transformedInputVal = text.replace(/[^A-Za-z.'\s]/g, '');
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
        }
    }

}

//directive allows user to enter numbers Only 
numericOnly.$inject = ["$filter", "$timeout"];

function numericOnly($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }

            function userInput(text) {
                text = text + "";
                var transformedInputVal = text.replace(/[^0-9]/g, '');
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
        }
    }

}

//directive allows user to enter numbers Only with Dot
//@krishna Singh 
numericOnlyWithDot.$inject = ["$filter", "$timeout"];

function numericOnlyWithDot($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }

            function userInput(text) {
                text = text + "";
                var transformedInputVal = text.replace(/[^0-9.]/g, '');
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
        }
    }

}

//directive allows user to enter numbers Only starts with non zero
//@krishna Singh 
numericOnlyStartNonZero.$inject = ["$filter", "$timeout"];

function numericOnlyStartNonZero($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }

            function userInput(text) {
                text = text + "";
                var transformedInputVal = text.replace(/^[0][0-9]/g, '');
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
        }
    }

}
//directive allows user to enter numbers, one dot Only with maximum two decimal places.
amountTransferStandard.$inject = ["$filter", "$timeout", "$browser"];

function amountTransferStandard($filter, $timeout, $browser) {
    return {
        require: '?ngModel',
        link: function (scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }

            ngModelCtrl.$parsers.push(function (val) {
                if (angular.isUndefined(val)) {
                    var val = '';
                }

                var clean = val.replace(/[^0-9\.]/g, '');
                var negativeCheck = clean.split('-');
                var decimalCheck = clean.split('.');
                if (!angular.isUndefined(negativeCheck[1])) {
                    negativeCheck[1] = negativeCheck[1].slice(0, negativeCheck[1].length);
                    clean = negativeCheck[0] + '-' + negativeCheck[1];
                    if (negativeCheck[0].length > 0) {
                        clean = negativeCheck[0];
                    }

                }

                if (!angular.isUndefined(decimalCheck[1])) {
                    decimalCheck[1] = decimalCheck[1].slice(0, 2);
                    clean = decimalCheck[0] + '.' + decimalCheck[1];
                }

                if (val !== clean) {
                    ngModelCtrl.$setViewValue(clean);
                    ngModelCtrl.$render();
                }
                return clean;
            });

            element.bind('keypress', function (event) {
                if (event.keyCode === 32) {
                    event.preventDefault();
                }
            });
        }
    };
}

//directive allows user to validate Adress Line with allowed characters
addressLineValidator.$inject = ["$filter", "$timeout"];

function addressLineValidator($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }

            function userInput(text) {
                var transformedInputVal = text.replace(/[^A-Za-z-& ,._\/()\s]/g, '');
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
        }
    }

}
//directive allows user to enter Alphanumeric,underscore,dot and hypen Only 
validEmailId.$inject = ["$filter", "$timeout"];

function validEmailId($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }

            function userInput(text) {
                var transformedInputVal = text.replace(/[^A-Za-z0-9_@.-\s]/g, '');
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
            element.bind('keypress', function(event) {
                if (event.keyCode === 32 || event.which === 32) {
                    event.preventDefault();
                }
            });
        }
    }

}


//directive allows user to enter Alphanumeric and first letter uppercase 
validName.$inject = ["$filter", "$timeout"];

function validName($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }

            function userInput(text) {

                if (text && text.length > 30) {
                    text = text.substring(0, text.length - 1);
                }
                var transformedInputVal = text.replace(/[^A-Za-z\s]/g, '');
                // var transformedInputVal = text; //.replace(/S/g,'');
                var transformedInputVal = transformedInputVal.charAt(0).toUpperCase() + transformedInputVal.substr(1);
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            // element[0].setAttribute('maxlength','30');
            attrs.$set('maxlength', '30');

            ngModelCtrl.$parsers.push(userInput);
            element.bind('keypress', function(event) {
                if ((this.value.length >= 30)) {
                    event.preventDefault();
                }
            });
        }
    }

}

//directive allows user to enter characters only
validateName.$inject = ["$filter", "$timeout"];

function validateName($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }
            function userInput(text) {
                if (text && text.length > 25) {
                    text = text.substring(0, text.length - 1);
                }
                var transformedInputVal = text.replace(/[^A-Za-z\s]/g, '');
                var transformedInputVal = transformedInputVal.charAt(0).toUpperCase() + transformedInputVal.substr(1);
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
            element.bind('keypress', function(event) {
                if ((this.value.length >= 25)) {
                    event.preventDefault();
                }
            });
        }
    }
}



heightInFeet.$inject = ["$filter", "$timeout"];

function heightInFeet($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            var f = element[0];
            var feetInches;

            ngModelCtrl.$formatters.push(function(val) {
                if (val) {
                    var realFeet = ((val * 0.393700) / 12);
                    var feet = Math.floor(realFeet);
                    var inches = Math.round((realFeet - feet) * 12);
                    return feet + "'" + inches + '"';
                }
                return '';
            });


            ngModelCtrl.$parsers.unshift(function(val) {
                if (angular.isUndefined(val)) {
                    val = '';
                }

                if (val) {
                    var updatedVlue = val;
                    var modelValue = ngModelCtrl.$modelValue;
                    if (!/^(\d{1})('(\d{0,2}))?$/.test(val)) {
                        updatedVlue = val.substr(0, val.length - 1);
                    } else {
                        if (+val[3] > 1 && +val[2] > 0) {
                            updatedVlue = val.substr(0, 3) + '' + val.substr(4);
                        }
                        if (+val[2] > 1 && +val[3] >= 0) {
                            updatedVlue = val.substr(0, 3) + '' + val.substr(4);
                        }
                        if (val.length == 1) {
                            updatedVlue = val + "'";
                        }
                    }
                    ngModelCtrl.$viewValue = updatedVlue;
                    ngModelCtrl.$render();
                    $timeout(function() {
                        f.selectionStart = f.value.length + 1;
                        f.selectionEnd = f.value.length + 1;
                    }, 10);

                    var heightInCm = $filter('getHeightInCm')(updatedVlue);
                    return heightInCm;
                }
            });

            element.bind('blur', function(event) {
                var found = ngModelCtrl.$viewValue.search('"');
                if (found == -1 && ngModelCtrl.$viewValue.length > 2) {
                    ngModelCtrl.$viewValue = ngModelCtrl.$viewValue + '"';
                    ngModelCtrl.$render();
                }
                if (found == -1 && ngModelCtrl.$viewValue.length == 2) {
                    ngModelCtrl.$viewValue = ngModelCtrl.$viewValue + '0"';
                    ngModelCtrl.$render();
                }
                if (found != -1) {
                    ngModelCtrl.$viewValue = ngModelCtrl.$viewValue.substr(0, found + 1);
                    ngModelCtrl.$render();
                }
                var value = ngModelCtrl.$viewValue;
                if (value.length > 2 && value.charAt(2) > 1) {
                    ngModelCtrl.$viewValue = value.substr(0, 3) + '"';
                    ngModelCtrl.$render();
                    ngModelCtrl.$modelValue = $filter('getHeightInCm')(ngModelCtrl.$viewValue);
                }
                if (value.length > 3 && value.charAt(3) > 1) {
                    ngModelCtrl.$viewValue = value.substr(0, 3) + '"';
                    ngModelCtrl.$render();
                    ngModelCtrl.$modelValue = $filter('getHeightInCm')(ngModelCtrl.$viewValue);
                }
            });
            attrs.$set('maxlength', '5');
        }
    }

}


//directive validate PAN NO , allows user to enter Alphanumeric. and convert into upper case 
validPanNo.$inject = ["$filter", "$timeout"];

function validPanNo($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }

            function userInput(text) {
                var transformedInputVal = text.replace(/[^A-Za-z0-9\s]/g, '');
                transformedInputVal = transformedInputVal.toUpperCase();
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
            attrs.$set('maxlength', '10');
            element.bind('keypress', function(event) {
                if (event.keyCode === 32 || (this.value.length == 10)) {
                    event.preventDefault();
                }
            });
        }
    }

}

//directive validate aadhar card no 
validAadharNo.$inject = ["$filter", "$timeout"];

function validAadharNo($filter, $timeout) {
    return {
        require: 'ngModel',
        link: function(scope, element, attr, ngModelCtrl) {
            function fromUser(text) {
                if (text) {
                    var transformedInput = text.replace(/[^0-9]/g, '');
                    if (transformedInput !== text) {
                        ngModelCtrl.$setViewValue(transformedInput);
                        ngModelCtrl.$render();
                    }
                    return transformedInput;
                }
                return undefined;
            }
            ngModelCtrl.$parsers.push(fromUser);
            attrs.$set('maxlength', '12');
            element.bind('keypress', function(event) {
                if (event.keyCode === 32 || (this.value.length == 12)) {
                    event.preventDefault();
                }
            });
        }
    };
}
//
//validate PassportNo directive allows user to enter Alphanumeric 
validPassportNo.$inject = ["$filter", "$timeout"];

function validPassportNo($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }

            function userInput(text) {
                var transformedInputVal = text.replace(/^[0-9][A-Za-z0-9\s]{7}$/, '');
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
            attrs.$set('maxlength', '10');
            element.bind('keypress', function(event) {
                if (event.keyCode === 32 || (this.value.length == 10)) {
                    event.preventDefault();
                }
            });
        }
    }

}

//directive validate Address , allows user to enter Alphanumeric with limited special chracters
validAddress.$inject = ["$filter", "$timeout"];

function validAddress($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }

            function userInput(text) {
                var transformedInputVal = text.replace(/[^A-Za-z0-9,-.\/\s#\'\(\)]/g, '');
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
            attrs.$set('maxlength', '40');
            element.bind('keypress', function(event) {
                if (this.value.length == 40) {
                    event.preventDefault();
                }
            });
        }
    }

}

//directive allows user to enter Alphanumeric Only 
fssallowAlphanumericOnly.$inject = ["$filter", "$timeout"];

function fssallowAlphanumericOnly($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }
            // attrs.$set('maxlength', '40');

            function userInput(text) {
                var transformedInputVal = text.replace(/[^0-9]/g, '');
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
        }
    }

}
//directive allows user to enter Alphanumeric Only 
validVehicleNo.$inject = ["$filter", "$timeout"];

function validVehicleNo($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }

            function userInput(text) {
                var transformedInputVal = text.replace(/[^A-Za-z0-9\s]/g, '');
                transformedInputVal = transformedInputVal.toUpperCase();
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
            attrs.$set('maxlength', '10');
            element.bind('keypress', function(event) {
                if (event.keyCode === 32 || (this.value.length == 10)) {
                    event.preventDefault();
                }
            });
        }
    }

}

//Directive function to show and hide footer elements
function customFooter() {
    return {
        restrict: 'E',
        scope: {
            goBack: "&",
            goNext: "&",
            showcancel: '=',
            showconfirm: '=',
            disablecancel: "=",
            disableconfirm: "=",
            nextButtonName: "@",
            backButtonName: "@",
            showBack: "@",
            showNext: "@",
            aofooter: "="


        },
        require: '?ngModel',
        transclude: false,
        replace: false,
        templateUrl: 'pages/generalInsurance/common/customfooter.html',
        link: function(scope, element, attrs, ngModel) {

        },
    };
};




//})();




fssBindHtml.$inject = ['$parse', '$compile'];

/**
 * [fssBindHtml : Directive for the input floating property]
 * @param  {[type]} timeout         [description]    
 */
function fssBindHtml($parse, $compile) {
    return {
        restrict: 'EA',
        link: link
    };

    //////

    function link(scope, element, attrs) {
        scope.$watch(attrs.fssBindHtml, function() {
            element.html($parse(attrs.fssBindHtml)(scope));
            $compile(element.contents())(scope);
        }, true)
    }
}


compileTemplate.$inject = ['$parse', '$compile'];

/**
 * [compileTemplate : Directive for the compile on popup htmls]
     
 */
function compileTemplate($parse, $compile) {
     return {
        link: function(scope, element, attr){
            var parsed = $parse(attr.ngBindHtml);
            function getStringValue() { return (parsed(scope) || '').toString(); }
            
            //Recompile if the template changes
            scope.$watch(getStringValue, function() {
                $compile(element, null, -9999)(scope);  //The -9999 makes it skip directives so that we do not recompile ourselves
            });
        }         
    }
}





fssToolTip.$inject = ['$parse', '$compile', '$document','$filter'];

/**
 * [fssBindHtml : Directive for the input floating property]
 * @param  {[type]} timeout         [description]    
 */
function fssToolTip($parse, $compile, $document,$filter) {
    return {
        restrict: 'EA',
        scope: true,
        link: link
    };

    


    function link(scope, element, attrs) {
        var tip = $compile('<div ng-class="tipClass" ng-bind-html="text"><div class="tooltip-arrow"></div></div>')(scope),
            tipClassName = 'tooltip',
            tipActiveClassName = 'tooltip-show';
        var backdrop = $compile('<div class="fss-custom-backdop"></div>')(scope);
        scope.tipClass = [tipClassName];
        scope.text = attrs.fssToolTip;


        $document.bind('click', function(element) {

            scope.text = $filter('ngBindHtmlFilter')(attrs.fssToolTip);
            if (element.target.hasAttribute("fss-tool-tip") || element.target.classList.contains("tooltip")) {} else {
                tip.removeClass(tipActiveClassName);
                tip.remove();
                backdrop.remove();

                // $ionicBackdrop.release();
            }
        });

        if (attrs.tooltipPosition) {
            scope.tipClass.push('tooltip-' + attrs.tooltipPosition);
        } else {
            scope.tipClass.push('tooltip-down');
        }





        element.bind('click', function(e) {

            $document.find('body').append(tip);
            $document.find('body').append(backdrop);
            //fss-custom-backdop
            //  $ionicBackdrop.retain();

            tip.addClass(tipActiveClassName);
            var pos = e.target.getBoundingClientRect(),
                offset = {},
                tipHeight = tip[0].clientHeight,
                tipWidth = tip[0].clientWidth,
                elWidth = pos.width || pos.right - pos.left,
                elHeight = pos.height || pos.bottom - pos.top,
                tipOffset = 10;
            offset = {
                top: pos.top + document.body.scrollTop,
                left: pos.left + document.body.scrollLeft
            }
            if (tip.hasClass('tooltip-right')) {
                offset.top = pos.top - (tipHeight / 2) + (elHeight / 2);
                offset.left = pos.right + tipOffset;
                tip[0].style.top = offset.top + 'px';
                tip[0].style.left = offset.left + 'px';
                if(offset.top < 0 ){
                        tip[0].style.top =  5 + 'px';
                }
                if(offset.left < 0 ){
                        tip[0].style.left =  5 + 'px';
                }
            } else if (tip.hasClass('tooltip-left')) {
                offset.top = pos.top - (tipHeight / 2) + (elHeight / 2);
                offset.left = pos.left - tipWidth - tipOffset;
                tip[0].style.top = offset.top + 'px';
                tip[0].style.left = offset.left + 'px';
                 if(offset.top < 0 ){
                        tip[0].style.top =   5 + 'px';
                }
                if(offset.left < 0 ){
                        tip[0].style.left =   5 + 'px';
                }
            } else if (tip.hasClass('tooltip-down')) {
                offset.top = pos.top + elHeight + tipOffset;
                offset.left = pos.left - (tipWidth / 2) + (elWidth / 2);
                tip[0].style.top = offset.top + 'px';
                tip[0].style.left = offset.left + 'px';
                 if(offset.top < 0 ){
                        tip[0].style.top =  5 + 'px';
                }
                if(offset.left < 0 ){
                     tip[0].style.left =   5 + 'px';
                }
            } else {
                offset.top = pos.top - tipHeight - tipOffset;
                offset.left = pos.left - (tipWidth / 2) + (elWidth / 2);
                tip[0].style.top = offset.top + 'px';
                tip[0].style.left = offset.left + 'px';
                 if(offset.top < 0 ){
                        tip[0].style.top =  5 + 'px';
                }
                if(offset.left < 0 ){
                        tip[0].style.left =   5 + 'px';
                }
            }

            //tip[0].offset = offset;
        });



        // element.bind('mouseout', function () {
        //   tip.removeClass(tipActiveClassName);
        // });

        // tip.bind('mouseover', function () {
        //   tip.addClass(tipActiveClassName);
        // });

        // tip.bind('mouseout', function () {
        //   tip.removeClass(tipActiveClassName);
        // });

    }
}

ssToolTip.$inject = ['$parse', '$compile', '$document', '$filter'];

/**
 * [fssBindHtml : Directive for the input floating property]
 * @param  {[type]} timeout         [description]    
 */
function ssToolTip($parse, $compile, $document, $filter) {
    return {
        restrict: 'EA',
        scope: true,
        link: link
    };




    function link(scope, element, attrs) {
        var tip = $compile('<div ng-class="tipClass"><div class="row font-size-12">'+
							    '<div class="col-md-8">'+
								  '<p class="test ss-m-b">PDF Password Hint Eg.</p>'+
								  '<p class="ss-m-b">Date of birth + !  +  Mobile number = Password</p><p>'+								  
								  '<span class="ss-dashed-border">30Mar</span>ch + '+
								  '<span class="ss-dashed-border ss-p-l-r-3">!</span>  +  '+
								  '880044 <span class="ss-dashed-border">6047</span> = '+
								  '<span class="ss-dashed-border">30Mar!6047</span></p></div></div><div class="tooltip-arrow"></div></div>')(scope),
            tipClassName = 'tooltip',
            tipActiveClassName = 'tooltip-show';
        var backdrop = $compile('<div class="fss-custom-backdop"></div>')(scope);
        scope.tipClass = [tipClassName];
        scope.text = attrs.ssToolTip;


        $document.bind('click', function (element) {
            if (element.target.hasAttribute("ss-tool-tip") || element.target.classList.contains("tooltip")) { } else {
                tip.removeClass(tipActiveClassName);
                tip.remove();
            //    backdrop.remove();

                // $ionicBackdrop.release();
            }
        });

        if (attrs.tooltipPosition) {
            scope.tipClass.push('tooltip-' + attrs.tooltipPosition);
        } else {
            scope.tipClass.push('tooltip-down');
        }





        element.bind('click', function (e) {

            $document.find('body').append(tip);
          //  $document.find('body').append(backdrop);
            //fss-custom-backdop
            //  $ionicBackdrop.retain();

            tip.addClass(tipActiveClassName);
            var pos = e.target.getBoundingClientRect(),
                offset = {},
                tipHeight = tip[0].clientHeight,
                tipWidth = tip[0].clientWidth,
                elWidth = pos.width || pos.right - pos.left,
                elHeight = pos.height || pos.bottom - pos.top,
                tipOffset = 10;
            offset = {
                top: pos.top + document.body.scrollTop,
                left: pos.left + document.body.scrollLeft
            }
            if (tip.hasClass('tooltip-right')) {
                offset.top = pos.top - (tipHeight / 2) + (elHeight / 2);
                offset.left = pos.right + tipOffset;
                tip[0].style.top = offset.top + 'px';
                tip[0].style.left = offset.left + 'px';
                if (offset.top < 0) {
                    tip[0].style.top = 5 + 'px';
                }
                if (offset.left < 0) {
                    tip[0].style.left = 5 + 'px';
                }
            } else if (tip.hasClass('tooltip-left')) {
                offset.top = pos.top - (tipHeight / 2) + (elHeight / 2);
                offset.left = pos.left - tipWidth - tipOffset;
                tip[0].style.top = offset.top + 'px';
                tip[0].style.left = offset.left + 'px';
               
                if (offset.top < 0) {
                    tip[0].style.top = 5 + 'px';
                }
                if (offset.left < 0) {
                    tip[0].style.left = 5 + 'px';
                }
            } else if (tip.hasClass('tooltip-down')) {
                tip[0].style.maxWidth = '100%';
                tip[0].style.width = '92%';
                offset.top = pos.top + elHeight + tipOffset;
                //offset.left = pos.left - (tipWidth / 2) + (elWidth / 2);
                tip[0].style.top = offset.top + 'px';
                tip[0].style.left = '4%';
                if (offset.top < 0) {
                    tip[0].style.top = 5 + 'px';
                }
                if (offset.left < 0) {
                    tip[0].style.left = 5 + 'px';
                }
            } else {
                offset.top = pos.top - tipHeight - tipOffset;
                offset.left = pos.left - (tipWidth / 2) + (elWidth / 2);
                tip[0].style.top = offset.top + 'px';
                tip[0].style.left = offset.left + 'px';
                if (offset.top < 0) {
                    tip[0].style.top = 5 + 'px';
                }
                if (offset.left < 0) {
                    tip[0].style.left = 5 + 'px';
                }
            }

 
        });


    }
}
//directive allows user to enter Characters only and first letter uppercase and allow DOT for GI
validNameGi.$inject = ["$filter", "$timeout"];

function validNameGi($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }

            function userInput(text) {

                if (text && text.length > 30) {
                    text = text.substring(0, text.length - 1);
                }
                var transformedInputVal = text.replace(/[^A-Za-z.\s]/g, '');
                // var transformedInputVal = text; //.replace(/S/g,'');
                var transformedInputVal = transformedInputVal.charAt(0).toUpperCase() + transformedInputVal.substr(1);
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            // element[0].setAttribute('maxlength','30');
            attrs.$set('maxlength', '30');

            ngModelCtrl.$parsers.push(userInput);
            element.bind('keypress', function(event) {
                if ((this.value.length >= 30)) {
                    event.preventDefault();
                }
            });
        }
    }

}

    //directive allows rinnraksha user to enter characters only
rrName.$inject = ["$filter", "$timeout"];

function rrName($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }
            
            function userInput(text) {
                var transformedInputVal = text.replace(/[^A-Za-z\s]/g, '');
                var transformedInputVal = transformedInputVal.charAt(0).toUpperCase() + transformedInputVal.substr(1);
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
            element.bind('keypress', function (event) {
                if ((this.value.length >= 60)) {
                    event.preventDefault();
                }
            });
        }
    }
}


//directive allows to enter only characters
onlyCharacter.$inject = ["$filter", "$timeout"];

function onlyCharacter($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }
            
            function userInput(text) {
                var transformedInputVal = text.replace(/[^A-Za-z\s]/g, '');
                transformedInputVal = transformedInputVal.charAt(0).toUpperCase() + transformedInputVal.substr(1);
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
        }
    }
}

//directive allows user to enter Characters only and first letter uppercase and allow DOT for GI
validNameArsa.$inject = ["$filter", "$timeout"];

function validNameArsa($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }

            function userInput(text) {
                var transformedInputVal = text.replace(/[^A-Za-z.\s]/g, '');
                transformedInputVal = transformedInputVal.charAt(0).toUpperCase() + transformedInputVal.substr(1);
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
        }
    }

}


//directive allows user to enter . , - only and for GI plotNo
plotNoVerifyGi.$inject = ["$filter", "$timeout"];

function plotNoVerifyGi($filter, $timeout) {
     return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }
            attrs.$set('maxlength', '50');

            function userInput(text) {
                var transformedInputVal = text.replace(/[^A-Za-z0-9./,-\s]/g, '');
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
        }
    }

}

//directive allows user to enter Special cahracters  for Building Name in GI 
buildingNameGi.$inject = ["$filter", "$timeout"];

function buildingNameGi($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }
            attrs.$set('maxlength', '40');

            function userInput(text) {
                var transformedInputVal = text.replace(/[^A-Za-z0-9./,-\s]/g, '');
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
        }
    }

}

//directive allows user to enter Special cahracters  for Street Name in GI 
streetNameGi.$inject = ["$filter", "$timeout"];

function streetNameGi($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }
            attrs.$set('maxlength', '60');

            function userInput(text) {
                var transformedInputVal = text.replace(/[^A-Za-z0-9./,-\s]/g, '');
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
        }
    }

}

//directive allows user to enter Alphanumeric and few special Only  
alphanumericSomeSpecialOnly.$inject = ["$filter", "$timeout"];

function alphanumericSomeSpecialOnly($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }
            // attrs.$set('maxlength', '40');

            function userInput(text) {
                var transformedInputVal = text.replace(/[^A-Za-z0-9._',\s]/g, '');
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
        }
    }

}
ompInputAmount.$inject = ["$filter", "$timeout"];
//Directive for amount input with max value attribute (LI)
function ompInputAmount($filter, $timeout) {
    var directive = {
        require: "?ngModel",
        link: link
    }
    return directive;

    function link(scope, element, attrs, ngModelCtrl) {
        var clean = ngModelCtrl.$viewValue;
        var cleanedVal;
        var f = element[0];

        var symbol = String.fromCharCode(8377);
        if (!ngModelCtrl) {
            return;
        }

        ngModelCtrl.$formatters.push(function (val) {
            if (val) {
                cleanedVal = $filter('INR')(val);
                return symbol + ' ' + cleanedVal;
            } else {
                return '';
            }
        });

        ngModelCtrl.$parsers.unshift(function (val) {

            if (angular.isUndefined(val)) {
                val = '';
            }
            //val = val.replace(/^0/g,'');  
            clean = val.toString().replace(/[^0-9]/g, '');

            if (clean) {
                if (attrs.maxAmount && (Number(clean) > Number(attrs.maxAmount))) {
                    clean = attrs.maxAmount;
                }
                cleanedVal = $filter('INR')(Number(clean));
                cleanedVal = symbol + cleanedVal;
                ngModelCtrl.$viewValue = cleanedVal;
                ngModelCtrl.$commitViewValue();
                ngModelCtrl.$render();
                $timeout(function () {
                    f.selectionStart = f.value.length + 1;
                    f.selectionEnd = f.value.length + 1;
                }, 10);

                return clean;
            } else {
                ngModelCtrl.$viewValue = "";
                ngModelCtrl.$commitViewValue();
                ngModelCtrl.$render();
                $timeout(function () {
                    f.selectionStart = f.value.length + 1;
                    f.selectionEnd = f.value.length + 1;
                }, 10);

                return clean;
            }
        });
        if (attrs.maxAmount) {
            var max = $filter('INR')(attrs.maxAmount);
            attrs.$set('maxlength', max.length + 1);
        }

        element.bind('keypress', function (event) {
            if (event.keyCode == 32) {
                event.preventDefault();
            }
        });
    }
}

/* Allow Only numbers 2 decimal places  */
ppsAmountInput.$inject = ["$filter", "$browser", "utilityService", "$timeout"];

function ppsAmountInput($filter, $browser, utilityService, $timeout) {
    var directive = {
        require: "?ngModel",
        link: link
    }
    return directive;

    function link(scope, element, attrs, ngModelCtrl) {


        var f = element[0];

        var symbol = String.fromCharCode(8377);
        if (!ngModelCtrl) {
            return;
        }
        var listener = function () {
            var value = element.val();
            element.val($filter('INR')(value, false));
        }
        ngModelCtrl.$parsers.push(function (val) {
            val = symbol + val;
            if (angular.isUndefined(val)) {
                val = '';
            }

            var clean = utilityService.isUndefined(attrs.noDecimal) ? val.replace(/[^0-9\.]/g, '') : val.replace(/[^0-9]/g, '');
            var negativeCheck = clean.split('-');
            var decimalCheck = clean.split('.');
            if (!angular.isUndefined(negativeCheck[1])) {
                negativeCheck[1] = negativeCheck[1].slice(0, negativeCheck[1].length);
                clean = negativeCheck[0] + '-' + negativeCheck[1];
                if (negativeCheck[0].length > 0) {
                    clean = negativeCheck[0];
                }
            }
            if (!angular.isUndefined(decimalCheck[1])) {
                decimalCheck[1] = decimalCheck[1].slice(0, 2);
                clean = decimalCheck[0] + '.' + decimalCheck[1];
            }

            if (val !== clean) {
                ngModelCtrl.$setViewValue(clean);
                ngModelCtrl.$render();
                ngModelCtrl.$render = function () {
                    element.val(symbol +" "+ $filter('INR')(ngModelCtrl.$viewValue, false))
                }
            }
            $timeout(function () {
                f.selectionStart = f.value.length + 1;
                f.selectionEnd = f.value.length + 1;
            }, 10);
            return clean;
        });

        element.bind('keypress', function (event) {
            if (event.keyCode === 32) {
                event.preventDefault();
            }
        });
        element.bind('change', listener);
        element.bind('keydown', function (event) {
            $browser.defer(listener) // Have to do this or changes don't get picked up properly
        });
        element.bind('focus', function (event) {
            $browser.defer(listener) // Have to do this or changes don't get picked up properly
        });
        element.bind('click', function (event) {
            $browser.defer(listener) // Have to do this or changes don't get picked up properly
        });
    }
}
