angularApp.directive('inputFocus', function() {

        function getCaretPosition(elem) {
            // Internet Explorer Caret Position
            if (document.selection && document.selection.createRange) {
                var range = document.selection.createRange();
                var bookmark = range.getBookmark();
                return bookmark.charCodeAt(2) - 2;
            }

            // Firefox Caret Position
            return elem.setSelectionRange && elem.selectionStart;
        }

        return {
            restrict: 'AEC',
			require: 'ngModel',
            link: function(scope, elem, attr,ngModel) {
                var tabindex = parseInt(attr.tabindex);
                var maxlength = parseInt(attr.maxlength);

                elem.on('input keydown', function(e) {
                    var val = elem.val(),
                        cp,
                        code = e.which || e.keyCode;

                    if([8, 37, 38, 39, 40, 46].indexOf(code) === -1) {
                        if (val.length === maxlength) {
                            var next = document.querySelectorAll('.mpin-input-wrap .mpin' + (tabindex + 1));
                            next.length && next[0].focus();
                            return;
                        }
                        else if(val.length !== maxlength) {
                            return;
                        }
                    }

                    cp = getCaretPosition(this);
					if(code === undefined){
						code = 8;
					}
                    if ((cp === 0 && code === 46) || (cp === 1 && code === 8) || (cp === 0 && code === 8)) {
                        var prev = document.querySelectorAll('.mpin-input-wrap .mpin' + (tabindex - 1));
                        e.preventDefault();
                        elem.val(val.substring(1));
						ngModel.$setViewValue('');
						ngModel.$render();
                        prev.length && prev[0].focus();
                        return;
                    }
                });
            }
        };
    });
