angularApp.directive('countdown', ['$interval', 'irctcService', '$ionicPopup', '$state', '$rootScope', '$ionicHistory', function ($interval, irctcService, $ionicPopup, $state, $rootScope, $ionicHistory) {
    return {
        scope: {
            startTimer: '=starttimer',
            showTimerPopUp: '=showtimerpopup',
            dynamicVar: '=dynamicvar'

        },
        restrict: 'E',
        templateUrl: 'common/directives/templates/irctcInfoTimer.html',
        link: function (scope, element, attrs) {
            scope.startorStopTimer = scope.startTimer;
            scope.alertTimer = false;
            scope.redBar = "1%";
            scope.greenBar = "100%";
            $rootScope.tryAgain = function () {
                scope.$broadcast('runTimer',{});
                scope[scope.dynamicVar].close();
                scope[scope.dynamicVar] =  undefined;
                $interval.cancel(scope.timeinterval);
                $state.go('menu.travellerMyList');
               
            }
            $rootScope.replanJourney = function () {
                scope.$broadcast('runTimer',{});
                scope[scope.dynamicVar].close();
                scope[scope.dynamicVar] =  undefined;
                $interval.cancel(scope.timeinterval);
                irctcService.searchTrainObj="";
                irctcService.myList="";
                irctcService.selectedTrainData="";
                irctcService.myListFullData="";
                $state.go('menu.irctcBookTicketSearch');
            }

            scope.update_clock = function (endtime) {
                var tData = scope.time_remaining(endtime);
                //var zeroPad = (num, places) => String(num).padStart(places, '0');

                var zeroPad=function(num, places){
                    return String(num).padStart(places, '0');
                }
                var timer = zeroPad(tData.minutes, 2) + ':' + zeroPad(tData.seconds, 2) + ' min';
                var timerInM=zeroPad(tData.minutes, 2);
                var timerInS= zeroPad(tData.seconds, 2);
                if (tData.total <= 0) {
                    $interval.cancel(scope.timeinterval);
                    scope.startorStopTimer = false;
                    var confirmMsg = "";
                    if(scope.dynamicVar == 'forgotPass') {
                        confirmMsg = '<p>You have exceeded the time limit of 10 minutes for booking. You will get the refund within 5-7 working days. To continue booking with existing details, please try again.';
                    }
                    else {
                        confirmMsg = '<p>You have exceeded the time limit of 10 minutes for booking. To continue booking with existing details, please try again.</p>';
                    }
                    
                    if (scope.showTimerPopUp && !scope[scope.dynamicVar]) {
                        var heading = '<h2 class="irctc-popup-heading">Your session has expired!</h2>';
                        var imageURL = 'img/irctc/icon-timeout-clock.svg';
                        var btnTemplate="<div><button ng-click='tryAgain()' class='button-assertive irctc-try-btn'>Try Again</button><br/><button  ng-click='replanJourney()' class='button-assertive irctc-replan-btn'>Replan your journey</button></div>";

                        var alertMsg = '<div class="textAlignCenter">' + heading + '</div><div class="popup-padding font-dark-grey"><div><center><img class="irctc-approvedIconPosition" src="' + imageURL + '"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><span class="irctc-popup-msg">' + confirmMsg + '</span></div></div>'+btnTemplate;
                        
                        scope[scope.dynamicVar] = $ionicPopup.show({
                            title: null,
                            template: alertMsg,
                            cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup irctc-exception'
                           
                        });
                    }



                    
                } else if (tData.minutes < 2) {
                    scope.alertTimer = true;
                }
                var greenProgressBar = ((tData.total/600000)*100);
                scope.greenBar = greenProgressBar+"%";
                scope.redBar = (100 - greenProgressBar)+"%";

                scope.countDownTimer = {timerInS : timerInS, timerInM : timerInM, t: tData,timer: timer,startorStopTimer: scope.startorStopTimer,alertTimer: scope.alertTimer};
                irctcService.settimerData(scope.countDownTimer);
            }
            
            scope.time_remaining = function (endtime) {
                var t = Date.parse(endtime) - Date.parse(new Date());

                return {'total': t,'days': Math.floor(t / (1000 * 60 * 60 * 24)),'hours': Math.floor((t / (1000 * 60 * 60)) % 24),'minutes': Math.floor((t / 1000 / 60) % 60),'seconds': Math.floor((t / 1000) % 60)};
            }
            scope.start_timer = function (minutes, seconds) {
                scope.startorStopTimer = true;
                var deadline = new Date(Date.parse(new Date()) + minutes * 60 * 1000 + seconds * 1000);
                if (scope.timeinterval) {
                    $interval.cancel(scope.timeinterval);
                }
                scope.update_clock(deadline); // run function once at first to avoid delay
                scope.timeinterval = $interval(function () {
                    scope.update_clock(deadline)
                }, 1000);
            }
            if (irctcService.getTimerData()) {
                var data = irctcService.getTimerData();
                var time_in_minutes = data.t.minutes;
                var time_in_second = data.t.seconds;
                scope.start_timer(time_in_minutes, time_in_second - 1)
            }
            scope.$on('runTimer', function () {
                if (!irctcService.getTimerData()) {
                    var time_in_min = 9;
                    var time_in_sec = 59;
                    scope.start_timer(time_in_min, time_in_sec);
                }
            });
            scope.$on('$destroy', function () {
                // if (!scope.paynowPage) {
                    $interval.cancel(scope.timeinterval);
                //}
            });
        }
    };
}]);