angularApp.directive('allowAlphanumericNospaceOnly', allowAlphanumericNospaceOnly);
angularApp.directive('allowSpecialXpressCharacters', allowSpecialXpressCharacters);
angularApp.directive('allowAlphanumericXpressOnly', allowAlphanumericXpressOnly);
angularApp.directive('validNameXpress', validNameXpress);

//directive allows user to enter Alphanumeric Only FOR Xpress Credit
allowAlphanumericNospaceOnly.$inject = ["$filter", "$timeout"];

function allowAlphanumericNospaceOnly($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }
            // attrs.$set('maxlength', '50');

            function userInput(text) {
                var transformedInputVal = text.replace(/[^A-Za-z0-9]/g, '');
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
        }
    }

}

//directive allows user to enter Special cahracters  
allowSpecialXpressCharacters.$inject = ["$filter", "$timeout"];

function allowSpecialXpressCharacters($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }
            // attrs.$set('maxlength', '30');

            function userInput(text) {
                var transformedInputVal = text.replace(/[^A-Za-z0-9./,-\s]/g, '');
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
        }
    }

}

//directive allows user to enter Alphanumeric Only 
allowAlphanumericXpressOnly.$inject = ["$filter", "$timeout"];

function allowAlphanumericXpressOnly($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }
            // attrs.$set('maxlength', '30');

            function userInput(text) {
                var transformedInputVal = text.replace(/[^A-Za-z0-9\s]/g, '');
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            ngModelCtrl.$parsers.push(userInput);
        }
    }

}

//directive allows user to enter Alphanumeric and first letter uppercase 
validNameXpress.$inject = ["$filter", "$timeout"];

function validNameXpress($filter, $timeout) {
    return {
        require: "?ngModel",
        link: function link(scope, element, attrs, ngModelCtrl) {
            if (!ngModelCtrl) {
                return;
            }

            function userInput(text) {
                
                var transformedInputVal = text.replace(/[^A-Za-z\s]/g, '');
                // var transformedInputVal = text; //.replace(/S/g,'');
                var transformedInputVal = transformedInputVal.charAt(0).toUpperCase() + transformedInputVal.substr(1);
                if (transformedInputVal !== text) {
                    ngModelCtrl.$setViewValue(transformedInputVal);
                    ngModelCtrl.$render();
                }
                return transformedInputVal;
            }
            // element[0].setAttribute('maxlength','30');
            // attrs.$set('maxlength', '30');

            ngModelCtrl.$parsers.push(userInput);
        }
    }

}