var slidingTabsDirective = angular.module("ionic").directive('ycionSlideTabs',
    ['$timeout', '$compile', '$interval', '$ionicSlideBoxDelegate', '$ionicScrollDelegate', '$ionicGesture', "utilityService","requestYCService",
        function ($timeout, $compile, $interval, $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicGesture,utilityService,requestYCService) {
            return {
                require: "^ionSlideBox",
                restrict: 'A',
                link: function (scope, element, attrs, parent) {
                    var ionicSlideBoxDelegate;
                    var ionicScrollDelegate;
                    var ionicScrollDelegateID;
                    var slideTabs;
                    var indicator;
                    var slider;
                    var tabsBar;
                    var options = {
                        "slideTabsScrollable": true
                    }
                    var init = function () {
                        if (angular.isDefined(attrs.slideTabsScrollable) && attrs.slideTabsScrollable === "false") {
                            options.slideTabsScrollable = false;
                        }
                        var tabItems = '<li ng-click="onTabTabbed($event, 0);"  id="YC_ALL_TAB" click-stream="click" class="slider-slide-tab yc-font-grey yc_font-content" ><div class="selectedTab">All</div></li>'
                            + '<li ng-click="onTabTabbed($event, 1);"  id="YC_ACT_TAB" click-stream="click" class="slider-slide-tab yc-font-grey yc_font-content" style="width:65px;"><div class="selectedTab">Active</div></li>'
                            + '<li ng-click="onTabTabbed($event, 2);" id="YC_COMP_TAB" click-stream="click" class="slider-slide-tab yc-font-grey yc_font-content" style="width:100px;"><div class="selectedTab">Completed</div></li>'
                            + '<li ng-click="onTabTabbed($event, 3);"  id="YC_CAN_TAB" click-stream="click" class="slider-slide-tab yc-font-grey yc_font-content" style="width:95px;"><div class="selectedTab">Canceled</div></li>'
                            + '<li ng-click="onTabTabbed($event, 4);" id="YC_EXP_TAB" click-stream="click" class="slider-slide-tab yc-font-grey yc_font-content" style="width:100px;"><div class="selectedTab">Expired</div></li>'
                            
                        if (options.slideTabsScrollable) {
                            ionicScrollDelegateID = "ycion-slide-tabs-handle-" + Math.floor((Math.random() * 10000) + 1);
                            tabsBar = angular.element('<ion-scroll has-bouncing ="false" overflow-scroll="false" delegate-handle="' + ionicScrollDelegateID + '" class="ycslidingTabs" direction="x" ><ul>' + tabItems + '</ul> <div class="tab-indicator-wrapper"><div class="tab-indicator"></div></div> </ion-scroll>');
                        }
                        else {
                            tabsBar = angular.element('<div class="ycslidingTabs"><ul>' + tabItems + '</ul> <div class="tab-indicator-wrapper"><div class="tab-indicator"></div></div> </div>');
                        }
                        slider = angular.element(element);
                        var compiled = $compile(tabsBar);
                        slider.parent().prepend(tabsBar);
                        compiled(scope);
                        //get Tabs DOM Elements
                        indicator = angular.element(tabsBar[0].querySelector(".tab-indicator"));
                        //get the slideBoxHandle
                        var slideHandle = slider.attr('delegate-handle');
                        var scrollHandle = tabsBar.attr('delegate-handle');
                        ionicSlideBoxDelegate = $ionicSlideBoxDelegate;
                        if (slideHandle) {
                            ionicSlideBoxDelegate = ionicSlideBoxDelegate.$getByHandle(slideHandle);
                        }
                        if (options.slideTabsScrollable) {

                            ionicScrollDelegate = $ionicScrollDelegate;
                            if (scrollHandle) {
                                ionicScrollDelegate = ionicScrollDelegate.$getByHandle(scrollHandle);
                            }
                        }
                        addEvents();
                        setTabBarWidth();
                        slideToCurrentPosition();
                        //scope.onTabTabbed(event, requestYCService.tabIndex.tabIndex);
                        scope.onTabTabbed(event, 0);
                    };

                    var addEvents = function () {
                        ionic.onGesture("dragleft", scope.onSlideMove, slider[0]);
                        ionic.onGesture("dragright", scope.onSlideMove, slider[0]);
                        ionic.onGesture("release", scope.onSlideChange, slider[0]);
                    }

                    var setTabBarWidth = function () {
                        if (!angular.isDefined(slideTabs) || slideTabs.length == 0) {
                            return false;
                        }

                        var tabsList = tabsBar.find("ul");
                        var tabsWidth = 0;

                        angular.forEach(slideTabs, function (currentElement, index) {

                            var currentLi = angular.element(currentElement);
                            tabsWidth += currentLi[0].offsetWidth + 2;
                        });

                        if (options.slideTabsScrollable) {
                            angular.element(tabsBar[0].querySelector(".scroll")).css("width", tabsWidth + 1 + "px");
                        }
                        else {
                            slideTabs.css("width", tabsList[0].offsetWidth / slideTabs.length + "px");
                        }
                        slideToCurrentPosition();
                    };

                    var addTabTouchAnimation = function (event, currentElement) {
                        var ink = angular.element(null);
                        if (!angular.isDefined(ink) || ink.length == 0) {
                            ink = angular.element("<span class='ink'></span>");
                            currentElement.prepend(ink);
                        }
                        ink.removeClass("animate");
                        if (!ink.offsetHeight && !ink.offsetWidth) {
                            var d = Math.max(currentElement[0].offsetWidth, currentElement[0].offsetHeight);
                            ink.css("height", d + "px");
                            ink.css("width", d + "px");
                        }
                        var x = event.offsetX - ink[0].offsetWidth / 2;
                        var y = event.offsetY - ink[0].offsetHeight / 2;
                        ink.css("top", y + 'px');
                        ink.css("left", x + 'px');
                        ink.addClass("animate");
                    }

                    var slideToCurrentPosition = function () {
                        if (!angular.isDefined(slideTabs) || slideTabs.length == 0) {
                            return false;
                        }
                        var targetSlideIndex = ionicSlideBoxDelegate.currentIndex();
                        var targetTab = angular.element(slideTabs[targetSlideIndex]);
                        var targetLeftOffset = targetTab.prop("offsetLeft");
                        var targetWidth = targetTab[0].offsetWidth;
                        indicator.css({
                            "-webkit-transition-duration": "3ms",
                            "-webkit-transform": "translateZ(0)",
                            "width": targetWidth + "px"
                        });
                        indicator.css({
                            "-webkit-transform": "translate(" + targetLeftOffset + "px,0px)"
                        });
                        if (options.slideTabsScrollable && ionicScrollDelegate) {
                            var scrollOffset = 80;
                            ionicScrollDelegate.scrollTo(targetLeftOffset - scrollOffset, 0, true);
                        }
                        slideTabs.removeClass("tab-active");
                        targetTab.addClass("tab-active");
                    }


                    var setIndicatorPosition = function (currentSlideIndex, targetSlideIndex, position, slideDirection) {

                        var targetTab = angular.element(slideTabs[targetSlideIndex]);
                        var currentTab = angular.element(slideTabs[currentSlideIndex]);
                        var targetLeftOffset = targetTab.prop("offsetLeft");
                        var currentLeftOffset = currentTab.prop("offsetLeft");
                        var offsetLeftDiff = Math.abs(targetLeftOffset - currentLeftOffset);

                        if (currentSlideIndex == 0 && targetSlideIndex == ionicSlideBoxDelegate.slidesCount() - 1 && slideDirection == "right" ||
                            targetSlideIndex == 0 && currentSlideIndex == ionicSlideBoxDelegate.slidesCount() - 1 && slideDirection == "left") {
                            return;
                        }

                        var targetWidth = targetTab[0].offsetWidth;
                        var currentWidth = currentTab[0].offsetWidth;
                        var widthDiff = targetWidth - currentWidth;

                        var indicatorPos = 0;
                        var indicatorWidth = 0;

                        if (currentSlideIndex > targetSlideIndex) {
                            indicatorPos = targetLeftOffset - (offsetLeftDiff * (position - 1));
                            indicatorWidth = targetWidth - ((widthDiff * (1 - position)));
                        } else if (targetSlideIndex > currentSlideIndex) {
                            indicatorPos = targetLeftOffset + (offsetLeftDiff * (position - 1));
                            indicatorWidth = targetWidth + ((widthDiff * (position - 1)));
                        }

                        indicator.css({
                            "-webkit-transition-duration": "300ms",
                            "-webkit-transform": "translate(" + indicatorPos + "px,0px)",
                            "width": indicatorWidth + "px"
                        });

                        if (options.slideTabsScrollable && ionicScrollDelegate) {
                            var scrollOffset = 80;
                            ionicScrollDelegate.scrollTo(indicatorPos - scrollOffset, 0, false);
                        }
                    }

                    scope.onTabTabbed = function (event, index) {
                        requestYCService.tabIndex.tabIndex = index;
                        addTabTouchAnimation(event, angular.element(event.currentTarget));
                        ionicSlideBoxDelegate.slide(index);
                        slideToCurrentPosition();
                    }
                    scope.tabs = [];
                    scope.addTabContent = function ($content) {
                        scope.tabs.push($content);
                        setTimeout(function () {
                            scope.$apply();
                            slideTabs = angular.element(tabsBar[0].querySelector("ul").querySelectorAll(".slider-slide-tab"));
                            slideToCurrentPosition();
                            setTabBarWidth()
                        }, 100);
                    }

                    scope.onSlideChange = function (slideIndex) {
                        slideToCurrentPosition();
                    };

                    scope.onSlideMove = function () {
                        var scrollDiv = slider[0].getElementsByClassName("slider-slide");
                        var currentSlideIndex = ionicSlideBoxDelegate.currentIndex();
                        var currentSlide = angular.element(scrollDiv[currentSlideIndex]);
                        var currentSlideLeftOffset = currentSlide.css('-webkit-transform').replace(/[^0-9\-.,]/g, '').split(',')[0];
                        var targetSlideIndex = (currentSlideIndex + 1) % scrollDiv.length;
                        if (currentSlideLeftOffset > slider.prop("offsetLeft")) {
                            targetSlideIndex = currentSlideIndex - 1;
                            if (targetSlideIndex < 0) {
                                targetSlideIndex = scrollDiv.length - 1;
                            }
                        }
                        var targetSlide = angular.element(scrollDiv[targetSlideIndex]);
                        var position = currentSlideLeftOffset / slider[0].offsetWidth;
                        var slideDirection = position > 0 ? "right" : "left";
                        position = Math.abs(position);
                        setIndicatorPosition(currentSlideIndex, targetSlideIndex, position, slideDirection);
                    };
                    init();
                },
                controller: ['$scope', function ($scope) {
                    this.addTab = function ($content) {
                        $timeout(function () {
                            if ($scope.addTabContent) {
                                $scope.addTabContent($content);
                            }
                        });
                    }
                }]
            };
        }]);

slidingTabsDirective.directive('ycionSlideTabLabel', [function () {
    return {
        require: "^ycionSlideTabs",
        scope: { data: '=ycionSlideTabLabel' },
        link: function ($scope, $element, $attrs, $parent) {
            $parent.addTab($scope.data);
        }
    }
}]);
