angularApp.filter('INR', function() {
    return function(input) {
        if (!isNaN(input)) {
            var currencySymbol = '?';
            var negSign = input * 1 <0 ? true : false;
            if(negSign) input = input * -1 + "";
            //var output = Number(input).toLocaleString('en-IN');   <-- This method is not working fine in all browsers!           
            var result = input.toString().split('.');

            var lastThree = result[0].substring(result[0].length - 3);
            var otherNumbers = result[0].substring(0, result[0].length - 3);
            if (otherNumbers != '')
                lastThree = ',' + lastThree;
            var output = otherNumbers.replace(/\B(?=(\d{2})+(?!\d))/g, ",") + lastThree;

            if (result.length > 1) {
                output += "." + result[1];
            }

            if(output && negSign) {
                output = "-" + output;
            }

            return output;
        }
        else {
            return input || "";
        }
    }
});
angularApp.filter('limitlessFilter', function($filter){
  return function(objects, limit, showAll) {
    if(showAll){
      return objects;
    } else {
      return $filter('limitTo')(objects, limit);
    }
  }
});

//INR For integrer Value
angularApp.filter('INRINT', function() {
    return function(input) {
        if (!isNaN(input)) {
			input=parseInt(input);
            var currencySymbol = '?';
            //var output = Number(input).toLocaleString('en-IN');   <-- This method is not working fine in all browsers!           
            var result = input.toString().split('.');

            var lastThree = result[0].substring(result[0].length - 3);
            var otherNumbers = result[0].substring(0, result[0].length - 3);
            if (otherNumbers != '')
                lastThree = ',' + lastThree;
            var output = otherNumbers.replace(/\B(?=(\d{2})+(?!\d))/g, ",") + lastThree;

            if (result.length > 1) {
                output += "." + result[1];
            }

            return output;
        }
    }
});

angularApp.filter('removeSpaces', [function() {
    return function(string) {
        if (!angular.isString(string)) {
            return string;
        }
        return string.replace(/[\s]/g, '');
    };
}])

//INR For Float Value
angularApp.filter('INRFLOAT', function() {
    return function(input,count) {
    	 if (isNaN(input) &&  undefined!=input) {
    		 input=input.replace(/,/g,"");
    	 }
    
        if (!isNaN(input)) {
        
			var temp='';
            var currencySymbol = '?';
            //var output = Number(input).toLocaleString('en-IN');   <-- This method is not working fine in all browsers!   
            input=parseFloat(input);
            input=input.toFixed(count);
            var result = input.toString().split('.');

            var lastThree = result[0].substring(result[0].length - 3);
            var otherNumbers = result[0].substring(0, result[0].length - 3);
            if (otherNumbers != '')
                lastThree = ',' + lastThree;
            var output = otherNumbers.replace(/\B(?=(\d{2})+(?!\d))/g, ",") + lastThree;
          
            if (result.length > 1) {
					
				if(count){
					temp = result[1].substring(0, count);
					if(temp!=''){
						//if(temp.length==1){
						//	output += "." + temp+'0';
						//}else{
							output += "." + temp;
						//}
						
					}
					
				}else{
						output += "." + result[1];
				}
            }//else if(result.length == 1){
            	//output += ".00";
           // }
           
            return output;
        }
    }
});

//INR Filter for amount which contains string(eg: 10,100 CR)
angularApp.filter('INRSTRING', function() {
    return function(input) {
        if (isNaN(input)) {
            var currencySymbol = '?';
            var negSign = input * 1 <0 ? true : false;
            if(negSign) input = input * -1 + "";
            //var output = Number(input).toLocaleString('en-IN');   <-- This method is not working fine in all browsers!           
            var result = input.toString().split('.');

            var lastThree = result[0].substring(result[0].length - 3);
            var otherNumbers = result[0].substring(0, result[0].length - 3);
            if (otherNumbers != '')
                lastThree = ',' + lastThree;
            var output = otherNumbers.replace(/\B(?=(\d{2})+(?!\d))/g, ",") + lastThree;

            if (result.length > 1) {
                output += "." + result[1];
            }

            if(output && negSign) {
                output = "-" + output;
            }

            return output;
        }
        else {
            return input || "";
        }
    }
});


angularApp.filter('INRQUICKPAY', function() {
    return function(input) {
        if (!isNaN(input)) {
            var currencySymbol = '?';
            var negSign = input * 1 <0 ? true : false;
            if(negSign) input = input * -1 + "";
            //var output = Number(input).toLocaleString('en-IN');   <-- This method is not working fine in all browsers!           
            var result = input.toString().split('.');

            var lastThree = result[0].substring(result[0].length - 3);
            var otherNumbers = result[0].substring(0, result[0].length - 3);
            if (otherNumbers != '')
                lastThree = ',' + lastThree;
            var output = otherNumbers.replace(/\B(?=(\d{2})+(?!\d))/g, ",") + lastThree;

            if (result.length > 1) {
                output += ".";
                output += "<span class='small-decimal'>";
                output += result[1];
                output += "</span>"
            }

            if(output && negSign) {
                output = "-" + output;
            }

            return "&#8377;" + output;
        }
        else {
            return input || "";
        }
    }
});
