/*
    Module Name  : Common,
    File Name    : filters.js,
    Description  : contains common filters for application
*/

'use strict';
angularApp.filter('accountNo', accountNo)
angularApp.filter('chosenDate', chosenDate)
angularApp.filter('dateFormat', dateFormat)
angularApp.filter('newdateFormat', newdateFormat)
angularApp.filter('formatAmount', formatAmount)
angularApp.filter('arrayFilter', arrayFilter)
angularApp.filter('arrayFilterBasedIndex', arrayFilterBasedIndex)
angularApp.filter('dateDifferenceInDays', dateDifferenceInDays)
angularApp.filter('amountInWords', amountInWords)
angularApp.filter('amountWithPaiseInWords',amountWithPaiseInWords)
angularApp.filter('ngBindHtmlFilter', ngBindHtmlFilter)
angularApp.filter('startFrom', startFrom)
angularApp.filter('retireFilter', retireFilter)
angularApp.filter('rupeeSymbol', rupeeSymbol)
angularApp.filter('rupeeSymArsa', rupeeSymArsa)
angularApp.filter('arsaDate', arsaDate)
angularApp.filter('formatCbsDate', formatCbsDate)
angularApp.filter('formatAadharDate', formatAadharDate)
angularApp.filter('formatSIPInstallmentDate', formatSIPInstallmentDate)
angularApp.filter('formatSIPStartEndDate', formatSIPStartEndDate)
angularApp.filter('formatSIPStartEndDate1', formatSIPStartEndDate1)
angularApp.filter('uniqueArr', uniqueArr)
angularApp.filter('findIndexByKeyValue', findIndexByKeyValue)

angularApp.filter('formatNavDate', formatNavDate)
angularApp.filter('formatNavDateDtl', formatNavDateDtl) 
angularApp.filter('selectBoxFilter', selectBoxFilter)
angularApp.filter('negativeToZero', negativeToZero)
angularApp.filter('cmInFeetAndInches', cmInFeetAndInches)
angularApp.filter('getHeightInCm', getHeightInCm)
angularApp.filter('timeStampToDate', timeStampToDate)
angularApp.filter('timeStampToDateDay', timeStampToDateDay)
angularApp.filter('timeStampToDateMonth', timeStampToDateMonth)
angularApp.filter('ageMaturitySC', ageMaturitySC)
angularApp.filter('getObjectByValue', getObjectByValue)
angularApp.filter('startDateWithTimezone', startDateWithTimezone)
angularApp.filter('endDateWithTimezone', endDateWithTimezone)
angularApp.filter('removeSelf', removeSelf)
angularApp.filter('salutationFilter', salutationFilter)
angularApp.filter('INRFss', INRFss)
angularApp.filter('calculateMonth', calculateMonth)
angularApp.filter('percent', percent)
angularApp.filter('homeDateFormat', homeDateFormat)
angularApp.filter('ssDateFormat', ssDateFormat)
angularApp.filter('ncmcTransactionDateFormat', ncmcTransactionDateFormat)
angularApp.filter('getNameInitials', getNameInitials)
angularApp.filter('advancefilter', advancefilter)
angularApp.filter('quickPayPendingReqDate', quickPayPendingReqDate)
angularApp.filter('ompadvancefilter', ompadvancefilter)


//Search text from list, words starts with first character typed filter
ompadvancefilter.$inject = ['$filter'];
function ompadvancefilter() {
    return function (input, text) {

        var results = input.reduce(function (res, state) {
            var idx = state.toLowerCase().indexOf(text.toLowerCase());
            if (idx === 0) {
                res[0].push(state)
            } else if (idx > 0) {
                if (state.toLowerCase().includes(" " + text.toLowerCase())) {
                    res[1].push(state)
                }

            }
            return res;
        }, [[], []])

        if (results[0].concat(results[1]).length < 5) {
            var searchterms = text.split(' ');
            searchterms.forEach(function (element) {
                var temp = input.reduce(function (res, state) {
                    var idx = state.toLowerCase().indexOf(element.toLowerCase());
                    if (idx === 0) {
                        res[0].push(state)
                    } else if (idx > 0) {
                        if (state.toLowerCase().includes(" " + element.toLowerCase())) {
                            res[1].push(state)
                        }
                    }
                    return res;
                }, [[], []]);
                results[1] = results[1].concat(temp[0]);
                results[1] = results[1].concat(temp[1]);
            }, this);
        }
        var mergedArr = results[0].concat(results[1]);
        var uniqueArray = mergedArr.filter(function (item, pos) {
            return mergedArr.indexOf(item) == pos;
        })

        return uniqueArray;
    };
}
//Search text from list, words starts with first character typed filter
advancefilter.$inject = ['$filter'];
function advancefilter() {
    return function (input, text) {

        var results = input.reduce(function (res, state) {
                var idx = state.toLowerCase().indexOf(text.toLowerCase());
            if (idx === 0) {
                res[0].push(state)
            } else if (idx > 0) {
                    if(state.toLowerCase().includes(" "+text.toLowerCase())){
                    res[1].push(state)
                }

            }
            return res;
        }, [[], []])
        return results[0].concat(results[1]);
    };
}

//Filter returns gender based on salutation
salutationFilter.$inject = ['$filter'];

function salutationFilter($filter) {
    return function(obj, val) {

        var filteredObj = [];
        if (val) {
            angular.forEach(obj, function(element) {
                if (element.ikey == val) {
                    filteredObj.push(element);
                }
            });
            return filteredObj;
        }
        return obj;

    }
}

//Filter to return lase 4 digits of account number with masked format
function accountNo() {
    return function(accno) {
        if (accno) {
            var maskedCharecter = "";
            for (var count = 0; count < accno.length - 4; count++) {
                maskedCharecter = maskedCharecter + "X";
            }
            accno = accno.toString();
            return maskedCharecter + accno.substr(accno.length - 4, accno.length);
        }

    }
}

function getHeightInCm() {
    return function(height) {
        var regX = /['"]/g;
        var res = regX.test(height);
        if (res) {
            var newHeight = height.replace('"', '');
            var feet = newHeight.split("'");
            feet[0] = feet[0].charAt(0);
            console.log(feet[1].length, feet[1].charAt(0));
            if (feet[1].length >= 1 && feet[1].charAt(0) > 1) {
                feet[1] = feet[1].substr(0, 1);
            }
            console.log(feet[1].length, feet[1].charAt(1));
            if (feet[1].length >= 2 && feet[1].charAt(1) > 1) {
                feet[1] = feet[1].substr(0, 2);
            }
            var centemeter = (feet[0] * 30.48) + (feet[1] * 2.54);
            return centemeter;
        } else {
            return height;
        }
    }
}

function cmInFeetAndInches() {
    return function(value) {
        if (value) {
            var realFeet = ((value * 0.393700) / 12);
            var feet = Math.floor(realFeet);
            var inches = Math.round((realFeet - feet) * 12);
            return feet + "'" + inches + '"';
        }
        return '';
    }
}


//Filter to return lase 4 digits of account number with masked format

function selectBoxFilter() {
    return function(list, key, keyName) {
        var keys = keyName;
        if (list && key) {

            if (list.length >= 0) {

                for (var count = 0; count < list.length; count++) {
                    if (keyName) {
                        if (list[count][keyName] == key) {
                            return list[count]
                        }
                    } else {
                        if (list[count].key == key) {
                            return list[count]
                        }
                    }
                }
            }
        }
    }
}

//filter to get object from the array list based on value
function getObjectByValue() {
    return function(array, keyName, value) {
        if (array) {
            for (var count = 0; count < array.length; count++) {
                if (array[count][keyName] == value) {
                    return array[count];
                }
            }
            return {};
        }
    }
}


//Filter to return lase 4 digits of account number with masked format
function negativeToZero() {
    return function(amount) {
        if (amount) {
            amount = Number(amount);
            if (amount < 0) {
                return 0;
            } else {
                return amount
            }

        }

    }
}
//Filter to convert to html
ngBindHtmlFilter.$inject = ['$sce'];

function ngBindHtmlFilter($sce) {
    return function(htmlData) {
        if (htmlData) {
            var div = document.createElement("div");
            div.innerHTML = htmlData;
            div.innerHTML = div.textContent;
            return $sce.trustAsHtml(div.innerHTML)
        }

    }
}

function startFrom() {
    return function(input, value) {
        if (input && value) {
            var startIndex = input.indexOf(value);
            return input.slice(startIndex);
        }
        return input;
    }
}


function retireFilter() {
    return function(input, value) {
        if (input && value) {
            if (value >= 40 && value <= 80) {
                value = value.toString();
                var startIndex = input.indexOf(value);
                return input.slice(startIndex);
            }
        }
        return input;
    }
}


//Filter to Format the given date into unique format DD MMM YYYY
chosenDate.$inject = ['$filter'];

function chosenDate($filter) {
    return function(selectedDate) {
        return $filter('date')(selectedDate, 'dd MMM yyyy');
    }
}


timeStampToDate.$inject = ['$filter'];

function timeStampToDate($filter) {
    return function(timestamp) {
        var date = new Date(parseInt(timestamp));
        return $filter('date')(date, 'dd MMM yyyy');
    }
}

//get only transaction day from timestamp
timeStampToDateDay.$inject = ['$filter'];

function timeStampToDateDay($filter) {
    return function(timestamp) {
        var date = new Date(parseInt(timestamp));
        return $filter('date')(date, 'dd');
    }
}
//get only transaction month from timestamp like JUN, AUG
timeStampToDateMonth.$inject = ['$filter'];

function timeStampToDateMonth($filter) {
    return function(timestamp) {
        var date = new Date(parseInt(timestamp));
        return $filter('date')(date, 'MMM');
    }
}
//Filter to Format the given date into unique format DD MMM YYYY
formatCbsDate.$inject = ['$filter'];

function formatCbsDate($filter) {
    return function(dob) {
        var month = parseInt(dob.slice(2, 4));
        var monthInWords = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];
        var birthDate = dob.slice(0, 2) + " " + monthInWords[month - 1] + " " + dob.slice(4, 8);
        return birthDate;
    }
}


//Filter to Format the given date into unique format DD MMM YYYY
formatAadharDate.$inject = ['$filter'];

function formatAadharDate($filter) {
    return function(dob) {
        var month = parseInt(dob.slice(3, 5));
        var monthInWords = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];
        var birthDate = dob.slice(0, 2) + " " + monthInWords[month - 1] + " " + dob.slice(6, 10);
        return birthDate;
    }
}

formatSIPInstallmentDate.$inject = ['$filter'];

function formatSIPInstallmentDate($filter) {
    return function(dob) {
        var birthDate = "";
        if(dob && dob != ""){
            var currDate = dob.split(" ");
            var month = currDate[1];
            var monthlist = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];
            var index = monthlist.indexOf(month);
            var monthInWords = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
            if(currDate[0].slice(0,1) == "0"){
                currDate[0] = currDate[0].slice(1,2);
            }
            if(currDate[0] == '1' || currDate[0] == '31' || currDate[0] == '21'){currDate[0] = currDate[0]+"st";}
            else if(currDate[0] == '2' || currDate[0] == '22' ){currDate[0] = currDate[0]+"nd";}
            else if(currDate[0] == '3' || currDate[0] == '23' ){currDate[0] = currDate[0]+"rd";}
            else{currDate[0] = currDate[0]+"th";}

            birthDate = currDate[0] + " " + monthInWords[index] + " " + currDate[2];
            return birthDate;
        }
        else{
            return birthDate;
        }
    }
}

formatSIPStartEndDate.$inject = ['$filter'];

function formatSIPStartEndDate($filter) {
    return function(dob) {
        var birthDate = "";
        if(dob && dob != ""){
            var currDate = dob.split(" ");
            var month = currDate[1];
            var monthlist = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];
            var index = monthlist.indexOf(month);
            var monthInWords = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
            if(currDate[0].slice(0,1) == "0"){
                currDate[0] = currDate[0].slice(1,2);
            }
            if(currDate[0] == '1' || currDate[0] == '31' || currDate[0] == '21'){currDate[0] = currDate[0]+"st";}
            else if(currDate[0] == '2' || currDate[0] == '22' ){currDate[0] = currDate[0]+"nd";}
            else if(currDate[0] == '3' || currDate[0] == '23' ){currDate[0] = currDate[0]+"rd";}
            else{currDate[0] = currDate[0]+"th";}

            birthDate = currDate[0] + " " + monthInWords[index] + " " + currDate[2];
            return birthDate;
        }
        else{
            return birthDate;
        }
    }
}


formatSIPStartEndDate1.$inject = ['$filter'];

function formatSIPStartEndDate1($filter) {
    return function(dob) {
        var birthDate = "";
        if(dob && dob != ""){
            dob = $filter('date')(dob,'dd MMM yyyy' );
            var currDate = dob.split(" ");
            var month = currDate[1];
            var monthlist = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];
            var index = monthlist.indexOf(month);
            var monthInWords = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
            if(currDate[0].slice(0,1) == "0"){
                currDate[0] = currDate[0].slice(1,2);
            }
            if(currDate[0] == '1' || currDate[0] == '31' || currDate[0] == '21'){currDate[0] = currDate[0]+"st";}
            else if(currDate[0] == '2' || currDate[0] == '22' ){currDate[0] = currDate[0]+"nd";}
            else if(currDate[0] == '3' || currDate[0] == '23' ){currDate[0] = currDate[0]+"rd";}
            else{currDate[0] = currDate[0]+"th";}

            birthDate = currDate[0] + " " + monthInWords[index] + " " + currDate[2];
            return birthDate;
        }
        else{
            return birthDate;
        }
    }
}

uniqueArr.$inject = ['$filter'];
function uniqueArr($filter) {
    return function (arr, field) {
        var o = {}, i, l = arr.length, r = [];
        for(i=0; i<l;i+=1) {
        o[arr[i][field]] = arr[i];
        }
        for(i in o) {
        r.push(o[i]);
        }
        return r;
  };
}

findIndexByKeyValue.$inject = ['$filter'];

function findIndexByKeyValue($filter){
    return function(_array, key, value) {
        for (var i = 0; i < _array.length; i++) { 
            if (_array[i][key] == value) {
                return i;
            }
        }
        return -1;
    }
}

formatNavDate.$inject = ['$filter'];

function formatNavDate($filter) {
    return function(dob) {
        var birthDate = "";
        if(dob && dob != ""){
            dob = $filter('date')(dob,'dd MMM yyyy' );
            var currDate = dob.split(" ");
            var month = currDate[1];
            var monthlist = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];
            var index = monthlist.indexOf(month);
            var monthInWords = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];
            if(currDate[0].slice(0,1) == "0"){
                currDate[0] = currDate[0].slice(1,2);
            }
            if(currDate[0] == '1' || currDate[0] == '31' || currDate[0] == '21'){currDate[0] = currDate[0]+"st";}
            else if(currDate[0] == '2' || currDate[0] == '22' ){currDate[0] = currDate[0]+"nd";}
            else if(currDate[0] == '3' || currDate[0] == '23' ){currDate[0] = currDate[0]+"rd";}
            else{currDate[0] = currDate[0]+"th";}

            birthDate = currDate[0] + " " + monthInWords[index];
            return birthDate;
        }
        else{
            return birthDate;
        }
    }
}

formatNavDateDtl.$inject = ['$filter'];

function formatNavDateDtl($filter) {
    return function(dob) {
        var birthDate = "";
        if(dob && dob != ""){
            dob = $filter('date')(dob,'dd MMM yyyy' );
            var currDate = dob.split(" ");
            var month = currDate[1];
            var monthlist = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];
            var index = monthlist.indexOf(month);
            var monthInWords = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];
            if(currDate[0].slice(0,1) == "0"){
                currDate[0] = currDate[0].slice(1,2);
            }
            if(currDate[0] == '1' || currDate[0] == '31' || currDate[0] == '21'){currDate[0] = currDate[0]+"st";}
            else if(currDate[0] == '2' || currDate[0] == '22' ){currDate[0] = currDate[0]+"nd";}
            else if(currDate[0] == '3' || currDate[0] == '23' ){currDate[0] = currDate[0]+"rd";}
            else{currDate[0] = currDate[0]+"th";}

            birthDate = currDate[0] + " " + monthInWords[index] + " " + currDate[2];
            return birthDate;
        }
        else{
            return birthDate;
        }
    }
}



//Filter to Format the given date into unique format YYYY MM DD
dateFormat.$inject = ['$filter'];

function dateFormat($filter) {
    return function(selectedDate) {
        selectedDate = new Date(selectedDate);
        return $filter('date')(selectedDate, 'yyyy-MM-dd');
    }
}

//Filter to Format the given date into unique format DD/MM/YYYY
newdateFormat.$inject = ['$filter'];

function newdateFormat($filter) {
    return function(selectedDate) {
        selectedDate = new Date(selectedDate);
        return $filter('date')(selectedDate, 'dd/MM/yyyy');
    }
}


//2017-03-29T00:00:00.000+05:30
startDateWithTimezone.$inject = ['$filter'];

function startDateWithTimezone($filter) {
    return function(selectedDate) {
        selectedDate = new Date(selectedDate);
        return $filter('date')(selectedDate, 'yyyy-MM-ddT00:00:00.000+05:30');
    }
}

//2017-03-29T00:00:00.000+05:30
endDateWithTimezone.$inject = ['$filter'];

function endDateWithTimezone($filter) {
    return function(selectedDate) {
        selectedDate = new Date(selectedDate);
        return $filter('date')(selectedDate, 'yyyy-MM-ddT23:59:59.999+05:30');
    }
}







//Filter to Format amount
formatAmount.$inject = ['$filter'];

function formatAmount($filter) {
    return function(typedAmount) {
        var convertedamount;
        var symbol = String.fromCharCode(8377);
        if (typedAmount && typedAmount.length > 1) {

            if (typedAmount[0] == symbol) {
                convertedamount = typedAmount.substr(1);
            } else {
                convertedamount = typedAmount;
            }
            convertedamount = convertedamount.replace(/,/g, "");
        }
        return convertedamount;
    }
}


//Filter to Format amount
rupeeSymbol.$inject = ['$filter'];

function rupeeSymbol($filter) {
    return function(typedAmount) {
        var symbol = String.fromCharCode(8377);
        var formatedAmount = $filter('INR')(typedAmount)
        formatedAmount = symbol + formatedAmount;
        return formatedAmount;
    }
}

//Filter to Format amount
rupeeSymArsa.$inject = ['$filter'];

function rupeeSymArsa($filter) {
    return function(typedAmount) {
        var symbol = String.fromCharCode(8377);
        var formatedAmount = $filter('INR')(typedAmount)
        formatedAmount = symbol +' '+ formatedAmount;
        return formatedAmount;
    }
}

//Filter to Format amount
arsaDate.$inject = ['$filter'];

function arsaDate($filter) {
    return function(typedAmount) {
        var originalDate = new Date(typedAmount);
        var month = originalDate.getMonth()+1;
        if(month<10){
            month = "0"+month;
        }
        var formattedDate = originalDate.getDate()+"/"+month+"/"+originalDate.getFullYear();
        return formattedDate;
    }
}



//Filter return number of days between dates
dateDifferenceInDays.$inject = ['$filter'];

function dateDifferenceInDays($filter) {
    return function(date1, date2) {
        if (date1 && date2) {
            var dt1 = new Date(date1);
            var dt2 = new Date(date2);
            var diffDays = Math.floor((Date.UTC(dt2.getFullYear(), dt2.getMonth(), dt2.getDate()) - Date.UTC(dt1.getFullYear(), dt1.getMonth(), dt1.getDate())) / (1000 * 60 * 60 * 24));

            return diffDays + 1;
        } else return '';
    }
}

//Filter return number of days between dates
arrayFilter.$inject = ['$filter'];

function arrayFilter($filter) {
    return function(obj, val) {

        var filteredObj = [];
        if (!val) {
            angular.forEach(obj, function(element) {

                if (element.locId != 208 && element.locId != 36) {
                    filteredObj.push(element);
                }
            });
            return filteredObj;
        }
        return obj;

    }
}


//Filter return number of days between dates
removeSelf.$inject = ['$filter'];

function removeSelf($filter) {
    return function(obj, val) {

        var filteredObj = [];
        if (val) {
            angular.forEach(obj, function(element) {
                if (element.key != '1' && element.value != 'Self') {
                    filteredObj.push(element);
                }
            });
            return filteredObj;
        }
        return obj;

    }
}


//Filter returns given amount in words
amountInWords.$inject = ['$filter'];

function amountInWords($filter) {
    return function(amount) {
        var words = [];
        words[0] = '';
        words[1] = 'One';
        words[2] = 'Two';
        words[3] = 'Three';
        words[4] = 'Four';
        words[5] = 'Five';
        words[6] = 'Six';
        words[7] = 'Seven';
        words[8] = 'Eight';
        words[9] = 'Nine';
        words[10] = 'Ten';
        words[11] = 'Eleven';
        words[12] = 'Twelve';
        words[13] = 'Thirteen';
        words[14] = 'Fourteen';
        words[15] = 'Fifteen';
        words[16] = 'Sixteen';
        words[17] = 'Seventeen';
        words[18] = 'Eighteen';
        words[19] = 'Nineteen';
        words[20] = 'Twenty';
        words[30] = 'Thirty';
        words[40] = 'Forty';
        words[50] = 'Fifty';
        words[60] = 'Sixty';
        words[70] = 'Seventy';
        words[80] = 'Eighty';
        words[90] = 'Ninety';
        amount = amount.toString();
        var atemp = amount.split(".");
        var number = atemp[0].split(",").join("");
        var n_length = number.length;
        var words_string = "";
        if (n_length <= 9) {
            var n_array = [0, 0, 0, 0, 0, 0, 0, 0, 0];
            var received_n_array = [];
            for (var i = 0; i < n_length; i++) {
                received_n_array[i] = number.substr(i, 1);
            }
            for (var i = 9 - n_length, j = 0; i < 9; i++, j++) {
                n_array[i] = received_n_array[j];
            }
            for (var i = 0, j = 1; i < 9; i++, j++) {
                if (i == 0 || i == 2 || i == 4 || i == 7) {
                    if (n_array[i] == 1) {
                        n_array[j] = 10 + parseInt(n_array[j], 10);
                        n_array[i] = 0;
                    }
                }
            }
            var value = "";
            for (var i = 0; i < 9; i++) {
                if (i == 0 || i == 2 || i == 4 || i == 7) {
                    value = n_array[i] * 10;
                } else {
                    value = n_array[i];
                }
                if (value != 0) {
                    words_string += words[value] + " ";
                }
                if ((i == 1 && value != 0) || (i == 0 && value != 0 && n_array[i + 1] == 0)) {
                    words_string += "Crores ";
                }
                if ((i == 3 && value != 0) || (i == 2 && value != 0 && n_array[i + 1] == 0)) {
                    words_string += "Lakhs ";
                }
                if ((i == 5 && value != 0) || (i == 4 && value != 0 && n_array[i + 1] == 0)) {
                    words_string += "Thousand ";
                }
                if (i == 6 && value != 0 && (n_array[i + 1] != 0 && n_array[i + 2] != 0)) {
                    words_string += "Hundred and ";
                } else if (i == 6 && value != 0) {
                    words_string += "Hundred ";
                }
            }
            words_string = words_string.split("  ").join(" ");
        }
        return words_string;
    }
}

amountWithPaiseInWords.$inject = ['$filter'];

function amountWithPaiseInWords($filter) {
    return function(amount) {
      var nums = [];
      var words_string = "";
      nums = amount.toString().split('.');
      var whole = $filter('amountInWords')(nums[0]);
      if(nums[1]==null)nums[1]=0;
      if(nums[1].length == 1 )nums[1]=nums[1]+'0';
      if(nums[1].length> 2){nums[1]=nums[1].substring(2,length - 1)}
      if(nums.length == 2)
      {
        if(nums[0]<=9){nums[0]=nums[0]*10}
        var fraction = $filter('amountInWords')(nums[1]);
        if(whole=='' && fraction==''){words_string= 'Zero only.';}
        if(whole=='' && fraction!=''){words_string= 'paise ' + fraction + ' only.';}
        if(whole!='' && fraction==''){words_string='Rupees ' + whole + ' only.';}
        if(whole!='' && fraction!=''){words_string='Rupees ' + whole + 'and ' + fraction + ' paise only.';}

      }
        return words_string;
      }
    }
arrayFilterBasedIndex.$inject = ['$filter'];

function arrayFilterBasedIndex($filter) {
    return function(obj, index) {
        var filteredObj = [];
        if (index) {

            index = Number(index);
            var count;
            for (count = 0; count < obj.length; count++) {
                if (count >= index) {
                    filteredObj.push(obj[count]);
                }

            }

            return filteredObj;


        }
        return obj;

    }
}




function ageMaturitySC() {
    return function(childage, assuredage) {
        var newAge = [];
        for (var i = 0; i < childage.length; i++) {
            if ((21 - Number(childage[i])) + Number(assuredage) <= 70) {
                newAge.push(childage[i]);

            }
        };
        return newAge;

    }
}

function INRFss() {
     return function(input) {
        if (! isNaN(input)) {
            var currencySymbol = '?';
            //var output = Number(input).toLocaleString('en-IN');   <-- This method is not working fine in all browsers!           
            var result = input.toString().split('.');

            var lastThree = result[0].substring(result[0].length - 3);
            var otherNumbers = result[0].substring(0, result[0].length - 3);
            if (otherNumbers != '')
                lastThree = ',' + lastThree;
            var output = otherNumbers.replace(/\B(?=(\d{2})+(?!\d))/g, ",") + lastThree;
            
            if (result.length > 1) {
                output += "." + result[1];
            }            

            return currencySymbol + output;
        }

     }
}


function calculateMonth(){
    return function(startDate,endDate) {
        startDate = new Date(startDate);
        endDate = new Date(endDate);
        var months;

         months = ((endDate.getFullYear() -  startDate.getFullYear()) * 12) + ((endDate.getMonth() -  startDate.getMonth()));
         if(endDate.getDate() < startDate.getDate()){
            months--;
         }
         months =  months < 0 ? 0 : months;
       
        months =  months/ 12;
        var result  = months.toString().split('.');
        if(result[1]){
             result[1] = result[1].substring(0,2);
        }
       
        if (result.length > 1) {
           return result[0]+"."+result[1];
        }else{
             return result[0];
        }
    }
}

function percent(){
    return function(input) {
       if(!input || isNaN(input)){
            return
       }else{
           return input + '%';
       }
    }
}

function homeDateFormat(){
    return function(input) {
       var monList = ["JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC"];
       var dateSplit = input.split('/');
       if(dateSplit.length != 3){
           return "";
       }else{
           return dateSplit[0] + " " + monList[parseInt(dateSplit[1])-1]  + " " + dateSplit[2];
       }
    }
}

function ssDateFormat(){
    return function(input) {
       var monList = ["JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC"];
       var dateSplit = input.split(' ');
       if(dateSplit.length != 3){
           return "";
       }else{
           var month = parseInt(monList.indexOf(dateSplit[1]));
           var date = parseInt(dateSplit[0]);
           month++;
           if(month < 10){
               dateSplit[1] = "0" + month;
           }else{
               dateSplit[1] = month
           }
           if(date < 10){
               dateSplit[0] = "0" + date;
           }
           return dateSplit[0] + "/" + dateSplit[1]  + "/" + dateSplit[2];
       }
    }
}

function ncmcTransactionDateFormat(){

return function(input) {
        var monList = ["JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC"];
        var dateSplit = input.split('-');
        dateSplit[1] = monList[dateSplit[1]-1];
        dateSplit[2] = dateSplit[2].substring(0,2);
        return dateSplit[0] + " " + dateSplit[1] + " " + dateSplit[2];
    }

    
}

function getNameInitials(){

return function(cust_name) {
         if(cust_name){
            var name_array = cust_name.split(" ");
            var first_initial = "";
          var last_initial = "";
          if(name_array.length == 0){
            first_initial = "";
                last_initial = "";
          }
            else if(name_array.length == 1)
            {
                first_initial = name_array[0].charAt(0);
                last_initial = "";
            }
            else{
                first_initial = name_array[0].charAt(0);
                last_initial = name_array[1].charAt(0);
            }
          
         return first_initial + last_initial;
        }
        else{
            return '';
        }
         
    }

    
}
function quickPayPendingReqDate(){

return function(input) {
        
        
        var d = new Date(input);

        return d;
    }
 
}
