'use strict';
/**
*   @ngdoc service
*   @name angularApp.service : appRateService
*   @restrict A
*   @description
*	Rate Application on Playstore and Appstore
*/
angularApp.service('appRateService',
    function ($ionicPopup, utilityService, constantConfig, loggedInUserService, $q,clickStreamService,$state,$filter) {
        var appRateService = this;
        var myPopup;

        appRateService.showAppRatePopup = function(){
            var q = $q.defer();
            loggedInUserService.manageLocalData('', "AppRatingStorageData.json", false, 'read').then(function (res) {
                if(res.skipDate || res.ratingDate ) {
                    var date = new Date();
                    var sD = new Date(res.skipDate);
                    var rD = new Date(res.ratingDate);

                    sD.setDate(sD.getDate() + 7);
                    rD.setDate(rD.getDate() + 30);

                    if(sD < date || rD < date) {
                        appRateService.displayPopup().then(function () {
                            q.resolve();
                        });
                    }
                    else q.resolve();
                }
                else {
                    appRateService.displayPopup().then(function () {
                        q.resolve();
                    });
                }
            }, function (e) {
                q.resolve();
            });

            return q.promise;
        }
        appRateService.displayPopup = function () {
            var q1 = $q.defer();
            var template = '<div class="align_center ">' +
                '<img class="margin-bottom-10" src="img/landingPage/AppRating.svg"/>' +
                '<div class="opinion"><span translate="APPRATE_OPINION"></span></div>' +
                '<div class="font-14 margin-bottom-20 padding-hor-50">' +
                '<span ng-if="'+utilityService.isAndroidPlatform()+'" translate="APPRATE_EXPERIENCE_ANDROID"></span>' +
                '<span ng-if="'+utilityService.isIOSPlatform()+'" translate="APPRATE_EXPERIENCE_iOS"></span>' +
                '</div>' +
                '</div>';
            myPopup = $ionicPopup.show({
                cssClass: 'dialog apprate-popup',
                template: template,
                scope: '',
                buttons: [{
                    text: $filter('translate')('APPRATE_RATE_NOW'),
                    onTap: function (e) {
                        appRateService.saveAppRateData('rate').then(function () {
                            myPopup.close();
                            utilityService.upgradeApp();
                            q1.resolve();
                        });
                    }
                },{
                    text: $filter('translate')('APPRATE_NO_THANKS'),
                    onTap: function (e) {
                        appRateService.saveAppRateData('skip').then(function () {
                            myPopup.close();
                            q1.resolve();
                        });
                    }
                }]
            });
            return q1.promise;
        };
        appRateService.saveAppRateData = function (type) {
            var q2 = $q.defer();
            var skipDate = (type === "skip") ? new Date() : "";
            var ratingDate = (type === "rate") ? new Date() : "";
            var appRateData = '"skipDate": "'+skipDate+'","ratingDate": "'+ratingDate+'"';
            var clickStreamData = (type === "rate") ? "RATE_NOW_BTN_MOB" : "RATE_SKIP_BTN_MOB";

            clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId+"_"+clickStreamData));

            loggedInUserService.manageLocalData(appRateData,"AppRatingStorageData.json",false,'write').then(function(res){
                q2.resolve();
            },function(e){
                q2.resolve();
            });
            return q2.promise;
        };

        return appRateService;
    });
