'use strict';
/**
*   @ngdoc service
*   @name angularApp.service : autoOtpReadService
*   @restrict A
*   @description
*	read OTP value from received SMS
*/
angularApp.service('autoOtpReadService',
    function ($q, $ionicPopup, $interval, $rootScope, $ionicPlatform, $timeout) {
        var autoOtpReadService = this;
        var deregisterBackButton;
        autoOtpReadService.isOtpReadingStarted = false;
        $rootScope.otpReadData = {otp1: '', otp2: '', otp3: '', otp4: '', otp5: '', otp6: ''};
        $rootScope.otpTimerData = {otpTimeout: {}, countDown: 180};
        var SMSRetriever = cordova.plugins.SMSRetriever;

        autoOtpReadService.otpTimer = function() {
        };

        autoOtpReadService.showPopup = function () {
            console.log("calling showpop");
            $rootScope.otpTimerData.countDown = 180;
            $rootScope.otpTimerInterval = $interval(function () {
                if($rootScope.otpTimerData.countDown > 0)
                    $rootScope.otpTimerData.countDown--;
                else
                    $interval.cancel($rootScope.otpTimerInterval);
            }, 1000, 0);
            deregisterBackButton = $ionicPlatform.registerBackButtonAction(function (e) { }, 401);

            $rootScope.closeOTP = function () {
                autoOtpReadService.stopOtpReading();
            };
            autoOtpReadService.otpPopup = $ionicPopup.show({
                template: '	<div class="otpread-popup align_center">' +
                    '<img class="margin-bottom-10" src="img/autoReadOTPClock.gif"/>' +
                    '<div class="font-16 margin-bottom-10">Sit back & Relax!<br>While we auto detect the OTP</div> ' +
                    '<div class="font-12 grey-icon-color margin-bottom-15 padding-bottom-20 border-bottom"><span translate="OTP_VALID_TIME" translate-values="{countdown: otpTimerData.countDown}"></span></div> ' +
                    '<button class="trans-theme-footer-btn" ng-click="closeOTP()">Enter OTP Manually</button>' +
                    '</div>',
                title: '',
                cssClass: 'dialog otpread-popup',
                scope: $rootScope
            });
        };
        autoOtpReadService.startOtpReading = function () {
            $interval.cancel($rootScope.otpTimerInterval);
            var q = $q.defer();
                if (SMSRetriever && !autoOtpReadService.isOtpReadingStarted) {
                    autoOtpReadService.isOtpReadingStarted = true;
                    autoOtpReadService.showPopup();
                    SMSRetriever.startWatch(function (message) {
                        var sms = message;
                        if (sms.toLowerCase().match("[0-9]{6}")) {
                            var otp = sms.toLowerCase().match("[0-9]{6}").toString();

                            $rootScope.otpReadData.otp1 = otp[0];
                            $rootScope.otpReadData.otp2 = otp[1];
                            $rootScope.otpReadData.otp3 = otp[2];
                            $rootScope.otpReadData.otp4 = otp[3];
                            $rootScope.otpReadData.otp5 = otp[4];
                            $rootScope.otpReadData.otp6 = otp[5];
                            q.resolve(otp);
                            autoOtpReadService.stopOtpReading();
                        }
                        else {
                            q.notify("Watching");
                        }
                    }, function (error) {
                        q.notify("NotWatching");
                        autoOtpReadService.isOtpReadingStarted = false;
                    });

                } else {
                    q.notify("AlreadyWatching");
                }
            return q.promise;
        };
        autoOtpReadService.stopOtpReading = function () {
            SMSRetriever.stopWatch(function (msg) {
                autoOtpReadService.otpPopup.close();
                deregisterBackButton();
                autoOtpReadService.isOtpReadingStarted = false;
            }, function (err) {
                autoOtpReadService.otpPopup.close();
                deregisterBackButton();
                autoOtpReadService.isOtpReadingStarted = false;
                console.log('failed to stop watching',err);
            });
        };
        return autoOtpReadService;
    });