angularApp.service('billDeskService',
  function ($q, AdapterUtils, getAccountDetailsService, $ionicPopup, utilityService) {
    var billDeskService = this;
    billDeskService.timerFlag = false;
    var refInAppBrowser;
    billDeskService.getBillDeskToken = function () {
      var obj = {};
      var q = $q.defer();
      AdapterUtils.postDataWithOutEncryption("adapters/BillDeskAdapter/getBDSessionToken", obj, true).then(
        function (response) {
          q.resolve(response.data);
        },
        function (error) {
          q.reject(error);
        }
      );
      return q.promise;
    };

    billDeskService.checkHeartBeatApi = function (data) {
      var obj = {
        "pseudoCustId": data.pseudoCustId
      };
      var q = $q.defer();
      AdapterUtils.postDataWithOutEncryption("adapters/BillDeskAdapter/heartBeatApi", obj, true).then(
        function (response) {
          q.resolve(response.data);
        },
        function (error) {
          q.reject(error);
        }
      );
      return q.promise;
    };

    billDeskService.checkHeartBeat = function () {
      billDeskService.checkHeartBeatApi(billDeskService).then(function (data) {
        var sessionState = data.responseString;
        if (sessionState == "INACTIVE") {
          var havingPrblmPopUp = $ionicPopup.show({
            template: '<p>Your Bill Payment session is timed out.</p>',
            title: '',
            cssClass: 'dialog',
            scope: '',
            buttons: [{
              text: 'OK',
              type: 'button-positive'
            }]
          });
          refInAppBrowser.close();
          billDeskService.timerFlag = false;
        }
      }, function (error) {
      });
    }

    billDeskService.billDeskToken = function () {
      billDeskService.getBillDeskToken().then(function (data) {
        var custID = data.pseudoCustId;
        var sessionToken = data.sessionToken;
        var oldURL = data.url;
        billDeskService.pseudoCustId = custID;
        var url = oldURL + "?CustId=" + custID + "&SessionId=" + sessionToken + "&Channel=APP";
        refInAppBrowser = cordova.ThemeableBrowser.open(url, '_blank', {
          statusbar: {
            color: '#ffffffff'
          },
          toolbar: {
            height: 37,
            color: '#ffffffff',
            image: 'share'
          },
          closeButton: {
            image: 'back',
            height: 37,
            width: 32,
            align: 'left',
            event: 'closePressed'
          },
          backButtonCanClose: true
        });
        refInAppBrowser.addEventListener('loadstart', loadStartCallBack);
        refInAppBrowser.addEventListener('loadstop', loadStopCallBack);
        refInAppBrowser.addEventListener('loaderror', loadErrorCallBack);
        refInAppBrowser.addEventListener('exit', exitCallBack);
        refInAppBrowser.addEventListener('closePressed', closePressedcallback);
      }, function (error) {

      });
    };

    function closePressedcallback() {
      //getAccountDetailsService.accountOverviewData = "";
    }

    function loadStartCallBack() {

    }

    function loadStopCallBack() {
      billDeskService.timerFlag = true;
      billDeskService.loadTimer();
    }

    function loadErrorCallBack() {

    }

    function exitCallBack() {
      billDeskService.timerFlag = false;
    }

    billDeskService.loadTimer = function () {
      //loadTimer
      var heartbeat = setInterval(function () {
        if (!billDeskService.timerFlag) {
          clearInterval(heartbeat);
        }
        else {
          billDeskService.checkHeartBeat();
        }
      }, 240000);
    }

    return billDeskService;

  });