/**
*   @ngdoc service
*   @name angularApp.directive : clickStreamService
*   @restrict A
*   @description
*	Sends ClickStream data to the server
*/
angularApp.service('clickStreamService',
	function ($q, $filter, $translate, AdapterUtils, mPinLoginService,loggedInUserService,constantConfig) {
		var clickStreamService = this;
		$translate(['VERSION_NO']).then(function (translations) {
			clickStreamService.appVersion = translations['VERSION_NO'];
		});
		clickStreamService.currentLocation = "";
		clickStreamService.devicePlatform = device.platform.toUpperCase();
		clickStreamService.deviceVersion = device.version;
		clickStreamService.appType = "MobileApp";
		clickStreamService.appTypeIdentifier = "_MOB";
		clickStreamService.deviceId = device.uuid;
		clickStreamService.sessionId = "";
		clickStreamService.lotusId = "";
		clickStreamService.clickStreamData = "";

		clickStreamService.setClickStreamData = function (attribute) {
                var data = [];
                data.push(clickStreamService.appVersion);
                data.push($filter('date')(new Date(), 'yyyyMMddHHmmssZ'));
                data.push(clickStreamService.currentLocation != "" ? clickStreamService.currentLocation : "");
                data.push(clickStreamService.devicePlatform);
                data.push(clickStreamService.deviceVersion);
                data.push(clickStreamService.appType);
                data.push(clickStreamService.deviceId);
                data.push(clickStreamService.sessionId);
                data.push(clickStreamService.lotusId);
                data.push(attribute);
                data.push(clickStreamService.clickStreamData);
				var clickedData = data.join("|");
				data.length = 0;
                clickStreamService.clickStreamData = "";
                return clickedData;
            };

		clickStreamService.sendClickStreamData = function (data) {
			var tempData = { "clickStreamData" : data };
			
			if(mPinLoginService.isLoggedIn){
				clickStreamService.submitClickStreamSecure(tempData).then(function (response) {
                    // success
                }, function (error) {
                    // failure
                });
			}else{
				clickStreamService.submitClickStream(tempData).then(function (response) {
                    // success
                }, function (error) {
                    // failure
                });
			}
		};
	
		clickStreamService.submitClickStreamSecure = function (data) {
			var q = $q.defer();
			var adapterURL= loggedInUserService.shopNOrderPre ? constantConfig.omp.submitClickStreamSecurePre : constantConfig.omp.submitClickStreamSecure; 
			AdapterUtils.postData(adapterURL, data, false).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		
		clickStreamService.submitClickStream = function (data) {
			var q = $q.defer();
			var adapterURL= loggedInUserService.shopNOrderPre ? constantConfig.omp.submitClickStreamPre : constantConfig.omp.submitClickStream; 
			AdapterUtils.postData(adapterURL, data, false).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		
		return clickStreamService;
	});