
'use strict';
angularApp.service('currentLocationService', function($q){
	function getCurrentPosition() {
        var q = $q.defer();
        navigator.geolocation.getCurrentPosition(
            function (position) {
                q.resolve(position);
            },
            function (err) {
                q.reject(err);
            },
            {enableHighAccuracy: true, timeout: 9000, maximumAge:8000});
        return q.promise;
    }

    function watchPosition() {
        var q = $q.defer();
        navigator.geolocation.watchPosition(
            function (position) {
                q.resolve(position);
            },  
            function (err) {
                q.reject(err);
            },
            { enableHighAccuracy: true });
        return q.promise;
    };

    function clearWatch(){        
        var watchId = watchPosition();
        navigator.geolocation.clearWatch(watchId);
    }

    return {
        getCurrentPosition: getCurrentPosition,
        watchPosition:watchPosition,
        clearWatch:clearWatch
    };

}); 