angularApp.service('encryptionService', function (utilityService) {
	var encryptionService = this;
	encryptionService.keySize = 128;
	encryptionService.iterationCount = 1000;
	encryptionService.iv = "";
	encryptionService.passphrase = "";
	encryptionService.salt = "";
	encryptionService.key = "";

	// Function for  AES 256 key generation
	encryptionService.generateAES256Key = function () {
		encryptionService.iv = encryptionService.generateRandomHex();
		encryptionService.passphrase = encryptionService.generateRandomHex();
		encryptionService.salt = encryptionService.generateRandomHex();
		encryptionService.key = CryptoJS.PBKDF2(
			encryptionService.passphrase,
			CryptoJS.enc.Hex.parse(encryptionService.salt),
			{ keySize: encryptionService.keySize / 32, iterations: encryptionService.iterationCount });
	}

	// Function for generate random Hex
	encryptionService.generateRandomHex = function () {
		var wordArray = CryptoJS.lib.WordArray.random(16);
		return CryptoJS.enc.Hex.stringify(wordArray);
	}

	// Function for  AES 256 Encryption
	encryptionService.getAES256EncryptedData = function (data) {
		try {
			var encrypted = CryptoJS.AES.encrypt(
				data,
				encryptionService.key,
				{ iv: CryptoJS.enc.Hex.parse(encryptionService.iv) });
			return encrypted.ciphertext.toString(CryptoJS.enc.Base64);
		}
		catch (err) {
			return "Something went wrong";
		}
	}

	// Function for  AES 256 Decryption
	encryptionService.getAES256DecryptedData = function (data) {
		try {
			var cipherParams = CryptoJS.lib.CipherParams.create({
				ciphertext: CryptoJS.enc.Base64.parse(data)
			});
			var decrypted = CryptoJS.AES.decrypt(
				cipherParams,
				encryptionService.key,
				{ iv: CryptoJS.enc.Hex.parse(encryptionService.iv) });
			return decrypted.toString(CryptoJS.enc.Utf8);
		}
		catch (err) {
			return "Something went wrong";
		}
	}

	return encryptionService;
});