angularApp.service('loggedInUserService', function (cryptoService, $rootScope, utilityService, $ionicPopup, $q, constantConfig) {
  var loggedInUserService = this;
  loggedInUserService.userProfile = "";
  loggedInUserService.productClicked = "";
  loggedInUserService.lotusKey = "";
  loggedInUserService.deviceIdForMpin = "";
  loggedInUserService.aesOldPassword = "";
  loggedInUserService.encryptionKey = "";
  loggedInUserService.mobileNo = "";
  loggedInUserService.tokenLotus = "";
  loggedInUserService.deviceInfo = "";
  loggedInUserService.billDeskUrl = "https://bbps.onlinesbi.com/AgentService/invokeBillFetchPage?source=Lotus&channel=mobile";
  loggedInUserService.sbiCollectUrl = "https://uat.onlinesbi.com/sbicollect/icollecthome.htm";
  loggedInUserService.keyId = "";
  loggedInUserService.keyIdINB = "";
  loggedInUserService.serviceIdINB = "";
  loggedInUserService.finalSHA512Val = "";
  loggedInUserService.tempUserName = "";
  loggedInUserService.keystoreValue = "";
  loggedInUserService.isServerConnected = false;
  loggedInUserService.mpinConsent = false;
  loggedInUserService.max_file_length = 100;
  loggedInUserService.isNormalRegistration = true;
  loggedInUserService.isLoggedInDetails = {};
  loggedInUserService.fileDirectory = utilityService.isAndroidPlatform() ? cordova.file.applicationStorageDirectory : cordova.file.dataDirectory;  
  loggedInUserService.setUserProfileDetails = function (userProfileDetails) {
    loggedInUserService.userProfile = userProfileDetails;
  }

  loggedInUserService.getUserProfileDetails = function () {
    return loggedInUserService.userProfile;
  }
  loggedInUserService.setInbUserId = function (data) {
    loggedInUserService.inbUserId = data;
  }

  loggedInUserService.getInbUserId = function () {
    return loggedInUserService.inbUserId;
  }

  loggedInUserService.generateINBSHA512Val = function (userName, password) {
    var SaltValue = "#";
    loggedInUserService.aesOldPassword = password;
    var formatedINBSHA512Val = cryptoService.getSHA512EncryptedData(userName + SaltValue + password).toString() + SaltValue + loggedInUserService.keyIdINB;
    return cryptoService.getSHA512EncryptedData(formatedINBSHA512Val).toString();
  }

  loggedInUserService.generateMPINSHA512Val = function (mPIN) {
    var SHA512HashedVal = cryptoService.getSHA512EncryptedData(mPIN + loggedInUserService.deviceInfo).toString() + loggedInUserService.keyId;
    return cryptoService.getSHA512EncryptedData(SHA512HashedVal).toString();
  }
  loggedInUserService.generateMPINSHA512ValWithSim = function (mPIN, simInfo) {
    var SHA512HashedVal = "";
    if(utilityService.isAndroidPlatform()){
      SHA512HashedVal = cryptoService.getSHA512EncryptedData(mPIN + loggedInUserService.deviceInfo + simInfo).toString() + loggedInUserService.keyId;
    }
    else{
      SHA512HashedVal = cryptoService.getSHA512EncryptedData(mPIN + loggedInUserService.deviceInfo).toString() + loggedInUserService.keyId;
    }
    return cryptoService.getSHA512EncryptedData(SHA512HashedVal).toString();
  }
  loggedInUserService.setMFPUrl = function(obtainAccess) {
    var successCallback = function() {
      if(obtainAccess) {
        WLAuthorizationManager.obtainAccessToken();
      } else {
        loggedInUserService.reloadUser();
      }
    };
    var failureCallback = function() {
      if(obtainAccess) {
        WLAuthorizationManager.obtainAccessToken();
      } else {
        loggedInUserService.reloadUser();
      }
    };
    WL.App.setServerUrl(constantConfig.MFPURL.MFPPROD, successCallback, failureCallback);
  }

  loggedInUserService.reloadUser = function() {
    sessionStorage.setItem('getNRICounterFromLocalStorage',"0");
    window.location = $rootScope.initialLocation;
  }

  loggedInUserService.logoutMFP = function(exitApplication) {
    utilityService.showSpinner();
    loggedInUserService.isLoggedInDetails.isLoggedIn = false;
    WLAuthorizationManager.logout("AuthenticateMPinSecurityCheck").then(function (data) {
      utilityService.hideSpinner();
      if (exitApplication) {
        loggedInUserService.exitApplication();
      } else {
        window.location = $rootScope.initialLocation;
      }
    }, function (error) {
      utilityService.hideSpinner();
      if(error.errorCode == "INVALID_REQUEST" || error.errorCode == "invalid_client"){
        loggedInUserService.setMFPUrl(true);
      }
      if (exitApplication) {
        loggedInUserService.exitApplication();
      } else {
        window.location = $rootScope.initialLocation;
      }
    });
  }

  loggedInUserService.logoutUser = function (exitApplication) {
    sessionStorage.setItem('getNRICounterFromLocalStorage',"0");
    if(loggedInUserService.isLoggedInDetails.isLoggedIn){
      loggedInUserService.logoutMFP(exitApplication);
    } else {
      if (exitApplication) {
        loggedInUserService.exitApplication();
      } else {
        window.location = $rootScope.initialLocation;
      }
    }
  }
  
  
  loggedInUserService.logoutAOUser = function (exitApplication) {
    utilityService.showSpinner();
    WLAuthorizationManager.logout("AOSecurityCheck").then(function (data) {
      console.log("Logout success !!");
      utilityService.hideSpinner();
      if (exitApplication) {
        // loggedInUserService.exitConfirmation();
        loggedInUserService.exitApplication();
      } else {
        window.location = $rootScope.initialLocation;
      }
    }, function (error) {
      console.log("Logout failure !!!");
      utilityService.hideSpinner();
      if (exitApplication) {
        // loggedInUserService.exitConfirmation();
        loggedInUserService.exitApplication();
      } else {
        window.location = $rootScope.initialLocation;
      }
    });
  }

  loggedInUserService.exitConfirmation = function () {
    var exitConfirmationPopup = $ionicPopup.show({
      title: null,
      cssClass: 'my-custom-popup',
      template: '<div class="button_fund fontSize-subHeading roboto-light font-dark-grey" translate="LOGOUT_CONFIRMATION"></div>',
      buttons: [{
        text: 'Ok',
        type: 'button-assertive',
        onTap: function () {
          loggedInUserService.exitApplication();
        }
      }],
    });
  }

  loggedInUserService.exitApplication = function () {
    if (utilityService.isAndroidPlatform()) {
      var successCallback = function (data) {
        console.log(data);
      }
      var failureCallback = function (error) {
        console.log(error);
      }
      cordova.exec(successCallback, failureCallback, "Utils", "exitApplication", []);
    } else {
      window.location = $rootScope.initialLocation;
    }
  }

  loggedInUserService.fileForStorageData = function(obj){
    var defer = $q.defer();
    var fileDirectory = "";
				if(utilityService.isAndroidPlatform()){
					fileDirectory = cordova.file.applicationStorageDirectory;
				} else {
					fileDirectory = cordova.file.dataDirectory;
				}
    window.resolveLocalFileSystemURL(fileDirectory, function (fs) {
        createFile(fs,"YONOLocalStorageFile.json",false);
    });
    function createFile(dirEntry, fileName, isAppend) {
      dirEntry.getFile(fileName, {create: true, exclusive: false}, function(fileEntry) {
          writeFile(fileEntry,obj);
      }, function(e){
        loggedInUserService.isFileWrite = false;
      });

    }
    function writeFile(fileEntry, dataObj) {
      fileEntry.createWriter(function(fileWriter){
        var blob = new Blob([dataObj],{type:'text/plain'});
 //       if((dataObj.length + fileWriter.length) <= loggedInUserService.max_file_length){
          fileWriter.write(blob);
//        }
        fileWriter.onwriteend = function() {
          loggedInUserService.isFileWrite = true;
          defer.resolve("success");
        };
        fileWriter.onerror = function (e) {
          loggedInUserService.isFileWrite = false;
          defer.reject(e);
        };
      })
    }
     return defer.promise; 
  }

  loggedInUserService.manageLocalData = function(data, fileName, appendData, action){
    var defer = $q.defer();
    data = (data.charAt(data.length-1) == ',') ? data : data + ",";
    var isAppend = appendData || false;
    var localFileName = fileName;

    window.resolveLocalFileSystemURL(loggedInUserService.fileDirectory, function (direEntry) {
      createLocalFile(direEntry);

      function createLocalFile(directoryEntry){
        directoryEntry.getFile(localFileName, {create: true, exclusive: false}, function(fileEntry) {
          if(action == 'write') writeLocalFile(fileEntry)
          else if(action == 'read') readLocalFile(fileEntry)
        }, function(e){});
      }

      function writeLocalFile(fileEntry){
        fileEntry.createWriter(function(fileWriter){
          var blob = new Blob([data],{type:'text/plain'});

          fileWriter.onwriteend = function() {
            loggedInUserService.isFileWrite = true;
            defer.resolve("success");
          };

          fileWriter.onerror = function (e) {
            loggedInUserService.isFileWrite = false;
            defer.reject(e);
          };
          if (isAppend) {
            try {
              fileWriter.seek(fileWriter.length);
            }
            catch (e) {}
          }
          fileWriter.write(blob);
        })
      }

      function readLocalFile(fileEntry){
        fileEntry.file(function (file) {
          var reader = new FileReader();
          reader.onloadend = function() {
            var result = this.result ? JSON.parse("{" + this.result.toString().slice(0, -1) + "}") : "";
            defer.resolve(result);
          };
          reader.readAsText(file);
        }, function(e){});
      }
    });
    return defer.promise;
  }
  return loggedInUserService;
})
