/**
 * FILE NAME : pwdProtectedPdfDownload.js
 * DESC : Common service to download the pwd protected PDF
 * JOUNIES IMPACTED : RD, FD And Account Overview PDF Download 
 */
angularApp.service('pwdProtectedPdfDownloadService',
    function ($q, AdapterUtils, utilityService, constantConfig, $ionicPopup, $state, $rootScope) {

        var pwdProtectedPdfDownloadService = this;
        var finalPath = "";
        var folderpath = "";

        pwdProtectedPdfDownloadService.savePDF = function (filename, content, deatils) {
            var defer = $q.defer();
            const contentType = "application/pdf";
            var contentStr = atob(content);
            var contentLen = contentStr.length;
            var response = {};
            if (contentLen >= constantConfig.accOverview.pdfSize) {
                defer.reject(constantConfig.accOverview.sizeLimitMessage);
                return defer.promise;
            }
            // Convert the base64 string in a Blob
            var DataBlob = pwdProtectedPdfDownloadService.b64toBlob(content, contentType);

            // fix for android 10 file save issue
            if (utilityService.isAndroidPlatform()) {
                if (device.version == 10) {
                    folderpath = cordova.file.externalDataDirectory;
                    pwdProtectedPdfDownloadService.popupFolderpath = folderpath.replace(cordova.file.externalRootDirectory, "") + filename;
                    window.resolveLocalFileSystemURL(folderpath, function (dir) {
                        dir.getFile(filename, { create: true }, function (file) {
                            file.createWriter(function (fileWriter) {
                                fileWriter.write(DataBlob);
                                response = { folderpath: pwdProtectedPdfDownloadService.popupFolderpath }
                                defer.resolve(response);
                            }, function (error) { defer.reject(error); });
                        }, function (error) { defer.reject(error); });
                    }, function (error) { defer.reject(error); });
                }
                else {
                    //for Android below 10 and Android 11 not for 10
                    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fileSystem) {
                        fileSystem.root.getDirectory("Download", { create: true, exclusive: false }, function (dir) {
                            pwdProtectedPdfDownloadService.popupFolderpath = dir.fullPath + filename;
                            dir.getFile(filename, { create: true, exclusive: false }, function (file) {
                                file.createWriter(function (fileWriter) {
                                    fileWriter.write(DataBlob);
                                    response = { folderpath: pwdProtectedPdfDownloadService.popupFolderpath }
                                    defer.resolve(response);
                                }, function (error) {defer.reject(error); });
                            });
                        });
                    });
                }
            }
            if (utilityService.isIOSPlatform()) {
                finalPath = cordova.file.documentsDirectory + filename;
                window.resolveLocalFileSystemURL(cordova.file.documentsDirectory, function (dir) {
                    dir.getFile(filename, { create: true }, function (file) {
                        file.createWriter(function (fileWriter) {
                            fileWriter.write(DataBlob);
                            defer.resolve("success");
                        }, function () { defer.reject(error);});
                    });
                });
               
            }
            return defer.promise;
        }

        pwdProtectedPdfDownloadService.b64toBlob = function (b64Data, contentType, sliceSize) {
            contentType = contentType || '';
            sliceSize = sliceSize || 512;

            var byteCharacters = atob(b64Data);
            var byteArrays = [];

            for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
                var slice = byteCharacters.slice(offset, offset + sliceSize);
                var byteNumbers = [];
                for (var i = 0; i < slice.length; i++) {
                    byteNumbers[i] = slice.charCodeAt(i);
                }

                var byteArray = new Uint8Array(byteNumbers);

                byteArrays.push(byteArray);
            }

            var blob = new Blob(byteArrays, {
                type: contentType
            });
            return blob;
        }

        pwdProtectedPdfDownloadService.pwdCommonTemplate = function () {
            pwdProtectedPdfDownloadService.pwdProtectedPopUp = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head popupBackgroundDark',
                templateUrl: "pages/accountOverview/csrDepositAccount/commonCSRDepositAccountModal.html"
            });
        }

        $rootScope.csrDepositOkClicked = function () {
            pwdProtectedPdfDownloadService.pwdProtectedPopUp.close();
            if (utilityService.isIOSPlatform()) {
                cordova.plugins.fileOpener2.open(
                    finalPath,
                    'application/pdf', {
                    error: function (e) {
                    },
                    success: function () {
                    }
                });
            }
        }

        return pwdProtectedPdfDownloadService;

    });
