angularApp.constant('constantConfig', {
    appName: 'SBILotus',
    appVersion: 2.0,
    numberMasking: 4,
    successCode: "0000",
    hexaSpace: "\u0020",
    rupeeSymbol: "\u20B9",
    SBILogo: 'img/FT/SBI-logo.svg',
    SBITIMEOUT: 3,
    SBITIMEOUTPRE: 15,
    commonObj:{
        bankCode:"0",
        channel:"lotus",
        cif:"",
        type:"INB"
    },
    ftAdapterUrl: {
        addBeneficiary: 'adapters/FundsTransferAdapter/addBeneficiary',
        beneficiaries: 'adapters/FundsTransferAdapter/beneficiaries',
        cancelScheduleddPayment: 'adapters/FundsTransferAdapter/cancelScheduleddPayment',
        deleteBeneficiary: 'adapters/FundsTransferAdapter/deleteBeneficiary',
        getIFSCCode: 'adapters/FundsTransferAdapter/getIFSCCode',
        getTransactionFee: 'adapters/FundsTransferAdapter/getTransactionFee',
        resolveQRCode: 'adapters/FundsTransferAdapter/resolveQRCode',
        schedulePayment: 'adapters/FundsTransferAdapter/schedulePayment',
        scheduledPayments: 'adapters/FundsTransferAdapter/scheduledPayments',
        transferFunds: 'adapters/FundsTransferAdapter/transferFunds',
        updateBeneficiary: 'adapters/FundsTransferAdapter/updateBeneficiary',
        updateScheduledPayment: 'adapters/FundsTransferAdapter/updateScheduledPayment',
        uploadBeneficiaryPicture: 'adapters/FundsTransferAdapter/uploadImage',
        updateBeneficiaryPicture: 'adapters/FundsTransferAdapter/updateImage',
        retriveBeneficiaryPicture: 'adapters/FundsTransferAdapter/retriveImage',
        deleteBeneficiaryPicture: 'adapters/FundsTransferAdapter/deleteImage',
        searchBeneficiaryPicture: 'adapters/FundsTransferAdapter/searchImage',
        searchBeneficiaryPictureByIds: 'adapters/FundsTransferAdapter/searchImageByIds',
        getTermsCondition: 'adapters/FundsTransferAdapter/getTnC'
    },
    ft: {
        mobileNoLen: 10,
        defaultBenImg: 'img/FT/contacts.svg',
        defaultEditBenImg: 'img/FT/beneficiary_edit.svg',
        SBI: 'SBI',
        SavingAcc: 'Savings a/c',
        ftText: 'Frequent Transfer',
        otherAccText: 'Other Accounts',
        scheduledTracsfText: 'Scheduled Transfer List',
        ownAccText: 'Own Accounts',
        validAmtTxt: 'Please Enter Valid Amount',
        modeBalancetxt :'Currently we are encountering temporary issues , please try after some time.',
        amtGrtThanZero: 'Amount can not be less than 1',
        inSuffAmt: 'Insufficient Amount',
        excMaxAmt: 'Exceeded Maximun Limit',
        savingsAcc: 'Savings A/c',
        currentAccount: 'Current A/c',
        validMaxAmtTxt: 'Maximum Transfer Limit Exceeds',
        qtDefaultMaxLimit:25000,
        ownAccValidationError :"Unable to transfer funds as Name contains special characters. Please contact branch for resolution"
    },
    omp: {
        dealImg: 'img/OMP/only_for_you.svg',
        defaultProductDisplay: 6,
        discount: 'Upto',
        getWhatNewMerchantsPre:'adapters/OMPAdapter/preLogin/getWhatNewMerchants',
        getPopularOfferPre:'adapters/OMPAdapter/preLogin/getPopularOffer',
        merchantByKeywordsPre:'adapters/OMPAdapter/preLogin/merchantByKeywords',
        searchKeywordsPre:'adapters/OMPAdapter/preLogin/searchKeywords',
        getMerchantsByCategoryPre:'adapters/OMPAdapter/preLogin/getMerchantsByCategory',
        getTopCategoryPre:'adapters/OMPAdapter/preLogin/getTopCategory',
        getAllCategoryPre:'adapters/OMPAdapter/preLogin/getAllCategory',
        submitClickStreamSecurePre:'adapters/ClickStreamAdapter/preLogin/omp/submitClickStreamSecure',
        submitClickStreamPre:'adapters/ClickStreamAdapter/preLogin/omp/submitClickStream',
        saveLeadPre:'adapters/OMPAdapter/preLogin/saveLeadRedirect',
        newOnYONOPre:'adapters/OMPAdapter/preLogin/new-on-yono',

        getWhatNewMerchants:'adapters/OMPAdapter/getWhatNewMerchants',
        getPopularOffer:'adapters/OMPAdapter/get_popular_offer',
        merchantByKeywords:'adapters/OMPAdapter/merchant-by-keywords',
        searchKeywords:'adapters/OMPAdapter/search-keywords',
        getMerchantsByCategory:'adapters/OMPAdapter/getMerchantsByCategory',
        getTopCategory:'adapters/OMPAdapter/getTopCategory',
        getAllCategory:'adapters/OMPAdapter/getAllCategory',
        saveLead:'adapters/OMPAdapter/save-lead-redirect',
        submitClickStreamSecure:'adapters/ClickStreamAdapter/submitClickStreamSecure',
        submitClickStream:'adapters/ClickStreamAdapter/submitClickStream',
        newOnYONO:'adapters/OMPAdapter/new-on-yono',
        saveCrmLead:'adapters/OMPAdapter/saveCrmLeadRedirect'

        
    },
    acOpeningAdapterUrl: {
        getProductFeatures: 'adapters/AccountOpeningAdapter/getProductFeatures',
        uploadPhoto: 'adapters/AccountOpeningAdapter/uploadDocument',
        updateAdditionalDetail: 'adapters/AccountOpeningAdapter/updateAdditionalDetail',
        registerCustomer: 'adapters/AccountOpeningAdapter/registerCustomer',
        getInTouchBranchesByCity: 'adapters/AccountOpeningAdapter/getInTouchBranchesByCity',
        getCities: 'adapters/AccountOpeningAdapter/getCities',
        registerDBUser: 'adapters/AccountOpeningAdapter/registerDBUser',
        requestOTP: 'adapters/AccountOpeningAdapter/requestOTP',
        getOTP: 'adapters/AccountOpeningAdapter/requestOTP',
        validateOTP: 'adapters/OTPAdapter/validateOTPToken',
        setAccountMPin: 'adapters/AccountOpeningAdapter/setAccountMPin',
        registerInternetBanking: 'adapters/AccountOpeningAdapter/registerInternetBanking',
        createNominee: 'adapters/AccountOpeningAdapter/createNominee',
        getAreaDetailForPincode: 'adapters/AccountOpeningAdapter/getPostalDetailByPinCode',
        updateGuardianDetails: 'adapters/AccountOpeningAdapter/updateGuardianDetails',
        updatePANNumber: 'adapters/AccountOpeningAdapter/updatePANNumber',
        adharcard: 'adapters/AccountOpeningAdapter/aadhaarCard',
        updateCorrespondenceAddress: 'adapters/AccountOpeningAdapter/updateCorrespondenceAddress',
        getBranchesForGeo: 'adapters/AccountOpeningAdapter/getBranchesForGeo?longitude=',
        //getAtmForGeo: 'adapters/FundsTransferAdapter/getATMForGeo?longitude=',
        getAtmForGeo: 'adapters/FundsTransferAdapter/getATMForGeoLocation',
        getBranchesForLocality: 'adapters/AccountOpeningAdapter/getBranchesForLocality',
        getTermsAndConditions: 'adapters/AccountOpeningAdapter/getTermsAndConditions',
        setFactaFlag: 'adapters/AccountOpeningAdapter/setFactaFlag',
        setDebitCardNameDetails: 'adapters/AccountOpeningAdapter/setDebitCardNameDetails',
        receiveDebitCard: 'adapters/AccountOpeningAdapter/receiveDebitCard',
        getReferenceNo: 'adapters/AccountOpeningAdapter/getReferenceNumber',
        setSelectedBranch: 'adapters/AccountOpeningAdapter/setSelectedBranch',
        getFatcaInfoDetails: 'adapters/AccountOpeningAdapter/fatcaDetails',
        getFatcaDeclaration: 'adapters/AccountOpeningAdapter/fatcaDeclaration',
        getOtherProductInfo: 'adapters/AccountOpeningAdapter/otherProductInfo',
        getPersonalDetails: 'adapters/AccountOpeningAdapter/personalDetails',
        locateBranch: 'adapters/AccountOpeningAdapter/locateBranch',
        locateBranchAadhar: 'adapters/AccountOpeningAdapter/locateBranchAadhar',
        justStepMore: 'adapters/AccountOpeningAdapter/justStep',
        detailsExist: 'adapters/AccountOpeningAdapter/details',
        pageDetails: 'adapters/AccountOpeningAdapter/resumeDocument/',
        customerDocumentDetails: 'adapters/AccountOpeningAdapter/customerDocument/',
        updateCityAndCountry: 'adapters/AccountOpeningAdapter/updateCityAndCountry',
        getCountries: 'adapters/AccountOpeningAdapter/getCountries',
        setPanAuthorizeFlag: 'adapters/AccountOpeningAdapter/panAuthorizeFlag',
        productFeatureKnowMore: 'adapters/AccountOpeningAdapter/getProductFeaturesKnowMore',
        postTAndCDetails: 'adapters/AccountOpeningAdapter/termsAndConditionsFlag',
        postProductOfferingDetails: 'adapters/AccountOpeningAdapter/productOfferFlag',
        setReferralCode: 'adapters/ReferralAdapter/setReferralNo',
        retrieveDocument: 'adapters/AccountOpeningAdapter/retrieveDocument/',
        emailServiceForOtp: 'adapters/AccountOpeningAdapter/smsService',
        loadMasterData: 'adapters/AccountOpeningAdapter/fetchDropDownList/',
        completeRegistration: 'adapters/AccountOpeningAdapter/updateCommonId',
        validateAccount: 'adapters/AccountOpeningAdapter/validateAccount',
        getSecurityQuestions: 'adapters/AccountOpeningAdapter/getSecurityQuestions',
        updateCif: 'adapters/AccountOpeningAdapter/updateCifStatus',
        guardianAddress: 'adapters/AccountOpeningAdapter/guardianAddress',
        getAllCities: 'adapters/AccountOpeningAdapter/getAllCities',
        passwordRecoveryRequest: 'adapters/AccountOpeningAdapter/passwordRecoveryRequest',
        validatePanNumber: 'adapters/AccountOpeningAdapter/validatePanNumber',
        panValidation: 'adapters/AccountOpeningAdapter/panValidation',
        fetchDistrict: 'adapters/AccountOpeningAdapter/fetchDistrict',
        fetchSubDistrict: 'adapters/AccountOpeningAdapter/fetchSubDistrict',
        fetchVillage: 'adapters/AccountOpeningAdapter/fetchVillage',
        getReferenceDetails: 'adapters/AccountOpeningAdapter/getReferenceDetails',
        getFeatureComparison: 'adapters/AccountOpeningAdapter/getFeatureComparison',
        getAccOpenContent: 'adapters/AccountOpeningAdapter/getAccOpenContent',
        getInfoCardDelivery: 'adapters/AccountOpeningAdapter/getInfoCardDelivery',
        getInfoOtherProduct: 'adapters/AccountOpeningAdapter/getInfoOtherProduct',
        getCustomerInfo: 'adapters/AccountOpeningAdapter/getCustomerInformation',
        getInfoList: 'adapters/AccountOpeningAdapter/getInfoList',
        getRefNo: 'adapters/AccountOpeningAdapter/getRefNo',
        getAddressProofDetails : "adapters/AccountOpeningAdapter/getAddressProofDetails",
        kycInformation : "adapters/AccountOpeningAdapter/kycInformation",
        uploadKycDocument : "adapters/AccountOpeningAdapter/uploadKycDocument",
        generateAadharOtp: 'adapters/AccountOpeningAdapter/generateAadharOtp',
        getEKycOTPSecure: 'adapters/AccountOpeningAdapter/getEKycOTPSecure',
        getPostalDetailByPinCode: 'adapters/AccountOpeningAdapter/getPostalDetailByPinCode'
        
    },
    jTSixOpeningAdapterUrl: {
        getProductFeatures: 'adapters/ExistingCustomerAccountOpeningAdapter/getProductFeatures',
        uploadPhoto: 'adapters/ExistingCustomerAccountOpeningAdapter/uploadDocument',
        updateAdditionalDetail: 'adapters/ExistingCustomerAccountOpeningAdapter/updateAdditionalDetail',
        registerCustomer: 'adapters/ExistingCustomerAccountOpeningAdapter/registerCustomer',
        getInTouchBranchesByCity: 'adapters/ExistingCustomerAccountOpeningAdapter/getInTouchBranchesByCity',
        getCities: 'adapters/ExistingCustomerAccountOpeningAdapter/getCities',
        registerDBUser: 'adapters/ExistingCustomerAccountOpeningAdapter/registerDBUser',
        requestOTP: 'adapters/ExistingCustomerAccountOpeningAdapter/requestOTP',
        getOTP: 'adapters/ExistingCustomerAccountOpeningAdapter/requestOTP',
        validateOTP: 'adapters/OTPAdapter/validateOTPToken',
        setAccountMPin: 'adapters/ExistingCustomerAccountOpeningAdapter/setAccountMPin',
        registerInternetBanking: 'adapters/ExistingCustomerAccountOpeningAdapter/registerInternetBanking',
        createNominee: 'adapters/ExistingCustomerAccountOpeningAdapter/createNominee',
        getAreaDetailForPincode: 'adapters/ExistingCustomerAccountOpeningAdapter/getPostalDetailByPinCode',
        updateGuardianDetails: 'adapters/ExistingCustomerAccountOpeningAdapter/updateGuardianDetails',
        updatePANNumber: 'adapters/ExistingCustomerAccountOpeningAdapter/updatePANNumber',
        adharcard: 'adapters/ExistingCustomerAccountOpeningAdapter/aadhaarCard',
        updateCorrespondenceAddress: 'adapters/ExistingCustomerAccountOpeningAdapter/updateCorrespondenceAddress',
        getBranchesForGeo: 'adapters/ExistingCustomerAccountOpeningAdapter/getBranchesForGeo?longitude=',
        getBranchesForLocality: 'adapters/ExistingCustomerAccountOpeningAdapter/getBranchesForLocality',
        getTermsAndConditions: 'adapters/ExistingCustomerAccountOpeningAdapter/getTermsAndConditions',
        setFactaFlag: 'adapters/ExistingCustomerAccountOpeningAdapter/setFactaFlag',
        setDebitCardNameDetails: 'adapters/ExistingCustomerAccountOpeningAdapter/setDebitCardNameDetails',
        receiveDebitCard: 'adapters/ExistingCustomerAccountOpeningAdapter/receiveDebitCard',
        getReferenceNo: 'adapters/ExistingCustomerAccountOpeningAdapter/getReferenceNumber',
        setSelectedBranch: 'adapters/ExistingCustomerAccountOpeningAdapter/setSelectedBranch',
        getFatcaInfoDetails: 'adapters/ExistingCustomerAccountOpeningAdapter/fatcaDetails',
        getFatcaDeclaration: 'adapters/ExistingCustomerAccountOpeningAdapter/fatcaDeclaration',
        getOtherProductInfo: 'adapters/ExistingCustomerAccountOpeningAdapter/otherProductInfo',
        getPersonalDetails: 'adapters/ExistingCustomerAccountOpeningAdapter/personalDetails',
        locateBranch: 'adapters/ExistingCustomerAccountOpeningAdapter/locateBranch',
        locateBranchAadhar: 'adapters/ExistingCustomerAccountOpeningAdapter/locateBranchAadhar',
        justStepMore: 'adapters/ExistingCustomerAccountOpeningAdapter/justStep',
        detailsExist: 'adapters/ExistingCustomerAccountOpeningAdapter/details',
        pageDetails: 'adapters/ExistingCustomerAccountOpeningAdapter/resumeDocument/',
        customerDocumentDetails: 'adapters/ExistingCustomerAccountOpeningAdapter/customerDocument/',
        updateCityAndCountry: 'adapters/ExistingCustomerAccountOpeningAdapter/updateCityAndCountry',
        getCountries: 'adapters/ExistingCustomerAccountOpeningAdapter/getCountries',
        setPanAuthorizeFlag: 'adapters/ExistingCustomerAccountOpeningAdapter/panAuthorizeFlag',
        productFeatureKnowMore: 'adapters/ExistingCustomerAccountOpeningAdapter/getProductFeaturesKnowMore',
        postTAndCDetails: 'adapters/ExistingCustomerAccountOpeningAdapter/termsAndConditionsFlag',
        postProductOfferingDetails: 'adapters/ExistingCustomerAccountOpeningAdapter/productOfferFlag',
        setReferralCode: 'adapters/ExistingCustomerReferralAdapter/setReferralNo',
        retrieveDocument: 'adapters/ExistingCustomerAccountOpeningAdapter/retrieveDocument/',
        emailServiceForOtp: 'adapters/ExistingCustomerAccountOpeningAdapter/smsService',
        loadMasterData: 'adapters/ExistingCustomerAccountOpeningAdapter/fetchDropDownList/',
        completeRegistration: 'adapters/ExistingCustomerAccountOpeningAdapter/updateCommonId',
        validateAccount: 'adapters/ExistingCustomerAccountOpeningAdapter/validateAccount',
        getSecurityQuestions: 'adapters/ExistingCustomerAccountOpeningAdapter/getSecurityQuestions',
        updateCif: 'adapters/ExistingCustomerAccountOpeningAdapter/updateCifStatus',
        guardianAddress: 'adapters/ExistingCustomerAccountOpeningAdapter/guardianAddress',
        getAllCities: 'adapters/ExistingCustomerAccountOpeningAdapter/getAllCities',
        passwordRecoveryRequest: 'adapters/ExistingCustomerAccountOpeningAdapter/passwordRecoveryRequest',
        validatePanNumber: 'adapters/ExistingCustomerAccountOpeningAdapter/validatePanNumber',
        panValidation: 'adapters/ExistingCustomerAccountOpeningAdapter/panValidation',
        fetchDistrict: 'adapters/ExistingCustomerAccountOpeningAdapter/fetchDistrict',
        fetchSubDistrict: 'adapters/ExistingCustomerAccountOpeningAdapter/fetchSubDistrict',
        fetchVillage: 'adapters/ExistingCustomerAccountOpeningAdapter/fetchVillage',
        getReferenceDetails: 'adapters/ExistingCustomerAccountOpeningAdapter/getReferenceDetails',
        getFeatureComparison: 'adapters/ExistingCustomerAccountOpeningAdapter/getFeatureComparison',
        getAccOpenContent: 'adapters/ExistingCustomerAccountOpeningAdapter/getAccOpenContent',
        getInfoCardDelivery: 'adapters/ExistingCustomerAccountOpeningAdapter/getInfoCardDelivery',
        getInfoOtherProduct: 'adapters/ExistingCustomerAccountOpeningAdapter/getInfoOtherProduct',
        getCustomerInfo: 'adapters/ExistingCustomerAccountOpeningAdapter/getCustomerInformation',
        getInfoList: 'adapters/ExistingCustomerAccountOpeningAdapter/getInfoList',
        getRefNo: 'adapters/ExistingCustomerAccountOpeningAdapter/getRefNo',
        getRegularSavingsAccountFeaturesJThirty : "adapters/ExistingCustomerAccountOpeningAdapter/getRegularSavingsAccountFeatures",
        personalDetailsJThirty : "adapters/ExistingCustomerAccountOpeningAdapter/personalDetailsJ30", 
        justStepMoreJThirty: 'adapters/ExistingCustomerAccountOpeningAdapter/justStepMore',
        validateOTPJThirty: 'adapters/ExistingCustomerAccountOpeningAdapter/validateOTPToken',
	getAddressProofDetails : "adapters/ExistingCustomerAccountOpeningAdapter/getAddressProofDetails",
        kycInformation : "adapters/ExistingCustomerAccountOpeningAdapter/kycInformation",
        uploadKycDocument : "adapters/ExistingCustomerAccountOpeningAdapter/uploadKycDocument",
        generateAadharOtp: 'adapters/ExistingCustomerAccountOpeningAdapter/generateAadharOtp',
        getEKycOTPSecure: 'adapters/ExistingCustomerAccountOpeningAdapter/getEKycOTPSecure',
        getPostalDetailByPinCode: 'adapters/ExistingCustomerAccountOpeningAdapter/getPostalDetailByPinCode'
        
    },
    InstaAcOpeningAdapterUrl: {
        getProductFeatures: 'adapters/InstaAccountOpeningAdapter/getProductFeatures',
        uploadPhoto: 'adapters/InstaAccountOpeningAdapter/uploadDocument',
        updateAdditionalDetail: 'adapters/InstaAccountOpeningAdapter/updateAdditionalDetail',
        registerCustomer: 'adapters/InstaAccountOpeningAdapter/registerCustomer',
        getInTouchBranchesByCity: 'adapters/InstaAccountOpeningAdapter/getInTouchBranchesByCity',
        getCities: 'adapters/InstaAccountOpeningAdapter/getCities',
        registerDBUser: 'adapters/InstaAccountOpeningAdapter/registerDBUser',
        requestOTP: 'adapters/InstaAccountOpeningAdapter/requestOTP',
        getOTP: 'adapters/InstaAccountOpeningAdapter/requestOTP',
        validateOTP: 'adapters/OTPAdapter/validateOTPTokenOVD',
        instaValidateOTP: 'adapters/InstaAccountOpeningAdapter/validateOTPTokenOVD',
        setAccountMPin: 'adapters/InstaAccountOpeningAdapter/setAccountMPin',
        registerInternetBanking: 'adapters/InstaAccountOpeningAdapter/registerInternetBanking',
        createNominee: 'adapters/InstaAccountOpeningAdapter/createNominee',
        getAreaDetailForPincode: 'adapters/InstaAccountOpeningAdapter/getPostalDetailByPinCode',
        updateGuardianDetails: 'adapters/InstaAccountOpeningAdapter/updateGuardianDetails',
        updatePANNumber: 'adapters/InstaAccountOpeningAdapter/updatePANNumber',
        adharcard: 'adapters/InstaAccountOpeningAdapter/aadhaarCard',
        updateCorrespondenceAddress: 'adapters/InstaAccountOpeningAdapter/updateCorrespondenceAddress',
        getBranchesForGeo: 'adapters/InstaAccountOpeningAdapter/getBranchesForGeo?longitude=',
        getBranchesForLocality: 'adapters/InstaAccountOpeningAdapter/getBranchesForLocality',
        getTermsAndConditions: 'adapters/InstaAccountOpeningAdapter/getTermsAndConditions',
        setFactaFlag: 'adapters/InstaAccountOpeningAdapter/setFactaFlag',
        setDebitCardNameDetails: 'adapters/InstaAccountOpeningAdapter/setDebitCardNameDetails',
        receiveDebitCard: 'adapters/InstaAccountOpeningAdapter/receiveDebitCard',
        getReferenceNo: 'adapters/InstaAccountOpeningAdapter/getReferenceNumber',
        setSelectedBranch: 'adapters/InstaAccountOpeningAdapter/setSelectedBranch',
        getFatcaInfoDetails: 'adapters/InstaAccountOpeningAdapter/fatcaDetails',
        getFatcaDeclaration: 'adapters/InstaAccountOpeningAdapter/fatcaDeclaration',
        getOtherProductInfo: 'adapters/InstaAccountOpeningAdapter/otherProductInfo',
        getPersonalDetails: 'adapters/InstaAccountOpeningAdapter/personalDetails',
        locateBranch: 'adapters/InstaAccountOpeningAdapter/locateBranch',
        locateBranchAadhar: 'adapters/InstaAccountOpeningAdapter/locateBranchAadhar',
        justStepMore: 'adapters/InstaAccountOpeningAdapter/justStep',
        detailsExist: 'adapters/InstaAccountOpeningAdapter/details',
        pageDetails: 'adapters/InstaAccountOpeningAdapter/resumeDocument/',
        customerDocumentDetails: 'adapters/InstaAccountOpeningAdapter/customerDocument/',
        updateCityAndCountry: 'adapters/InstaAccountOpeningAdapter/updateCityAndCountry',
        getCountries: 'adapters/InstaAccountOpeningAdapter/getCountries',
        setPanAuthorizeFlag: 'adapters/InstaAccountOpeningAdapter/panAuthorizeFlag',
        productFeatureKnowMore: 'adapters/InstaAccountOpeningAdapter/getProductFeaturesKnowMore',
        postTAndCDetails: 'adapters/InstaAccountOpeningAdapter/termsAndConditionsFlag',
        postProductOfferingDetails: 'adapters/InstaAccountOpeningAdapter/productOfferFlag',
        setReferralCode: 'adapters/ReferralAdapter/setReferralNo',
        retrieveDocument: 'adapters/InstaAccountOpeningAdapter/retrieveDocument/',
        emailServiceForOtp: 'adapters/InstaAccountOpeningAdapter/smsService',
        loadMasterData: 'adapters/InstaAccountOpeningAdapter/fetchDropDownList/',
        completeRegistration: 'adapters/InstaAccountOpeningAdapter/updateCommonId',
        validateAccount: 'adapters/InstaAccountOpeningAdapter/validateAccount',
        getSecurityQuestions: 'adapters/InstaAccountOpeningAdapter/getSecurityQuestions',
        updateCif: 'adapters/InstaAccountOpeningAdapter/updateCifStatus',
        guardianAddress: 'adapters/InstaAccountOpeningAdapter/guardianAddress',
        getAllCities: 'adapters/InstaAccountOpeningAdapter/getAllCities',
        passwordRecoveryRequest: 'adapters/InstaAccountOpeningAdapter/passwordRecoveryRequest',
        validatePanNumber: 'adapters/InstaAccountOpeningAdapter/validatePanNumber',
        panValidation: 'adapters/InstaAccountOpeningAdapter/panValidation',
        fetchDistrict: 'adapters/InstaAccountOpeningAdapter/fetchDistrict',
        fetchSubDistrict: 'adapters/InstaAccountOpeningAdapter/fetchSubDistrictFromCencus',
        fetchVillage: 'adapters/InstaAccountOpeningAdapter/fetchVillageFromCencus',
        getReferenceDetails: 'adapters/InstaAccountOpeningAdapter/getReferenceDetails',
        getAccOpenContent: 'adapters/InstaAccountOpeningAdapter/getAccOpenContent',
        getInfoCardDelivery: 'adapters/InstaAccountOpeningAdapter/getInfoCardDelivery',
        getInfoOtherProduct: 'adapters/InstaAccountOpeningAdapter/getInfoOtherProduct',
        getPersonalDetailsConcent: 'adapters/InstaAccountOpeningAdapter/personalDetailsInsta',
        generateAadharOtp: 'adapters/InstaAccountOpeningAdapter/generateAadharOtp',
        getEKycOTPSecure: 'adapters/InstaAccountOpeningAdapter/getEKycOTPSecure',
        openInstaAccount: 'adapters/InstaAccountOpeningAdapter/openInstaAccount',
        generateVKYCToken: 'adapters/InstaAccountOpeningAdapter/generateVKYCToken',
        getFeatureComparison: 'adapters/InstaAccountOpeningAdapter/getFeatureComparison',
        getFeatureComparisonInsta: 'adapters/InstaAccountOpeningAdapter/getFeatureComparisonInsta',
        getCitizenship: 'adapters/InstaAccountOpeningAdapter/getCitizenship',
        getNationality: 'adapters/InstaAccountOpeningAdapter/getNationality',
        getEkycCertificate: 'adapters/InstaAccountOpeningAdapter/getEkycCertificate',
        getInfoList: 'adapters/InstaAccountOpeningAdapter/getInfoList',
        getPostalDetailByPinCode: 'adapters/InstaAccountOpeningAdapter/getPostalDetailByPinCode',
        getInstaPlusDetail: 'adapters/InstaAccountOpeningAdapter/getInstaPlusDetail',
        startVKYCUser: 'adapters/InstaAccountOpeningAdapter/user',
        openInstaPlusAccount: 'adapters/InstaAccountOpeningAdapter/openInstaPlusAccount',
        companyDetails : 'adapters/InstaAccountOpeningAdapter/openInstaPlusAccount',
        salaryUploadDoc : 'adapters/InstaAccountOpeningAdapter/uploadDocument',
        salaryUploadDocVkyc : 'adapters/InstaAccountOpeningAdapter/uploadVkycDocument',
        saveVkycConsent : 'adapters/InstaAccountOpeningAdapter/saveVkycConsent',
        getStateMaster : 'adapters/InstaAccountOpeningAdapter/getStateMaster'
    },

    JTSix: {
        getCustomerInfromation: 'adapters/AccountOpeningAdapter/getCustomerInformation',
        getCustomerInfromationPost: 'adapters/ExistingCustomerAccountOpeningAdapter/getCustomerInformation'
    },
    acOpeningAdapterOVDUrl :{
			uploadDocumentOVD : "adapters/AccountOpeningAdapter/uploadDocumentOVD",
			retrieveDocumentOVD : "adapters/AccountOpeningAdapter/retrieveDocumentOVD/",
			fetchDropDownListOVD : "adapters/AccountOpeningAdapter/fetchDropDownListOVD/",
			updateAdditionalDetailOVD : "adapters/AccountOpeningAdapter/updateAdditionalDetailOVD",
			getReligionMaster : "adapters/AccountOpeningAdapter/getReligionMaster",
			registerCustomerOVD : "adapters/AccountOpeningAdapter/registerCustomerOVD",
			setDebitCardKitDetailsOVD : "adapters/AccountOpeningAdapter/setDebitCardKitDetailsOVD",
			setServicesDetailsOVD : "adapters/AccountOpeningAdapter/setServicesDetailsOVD",
			getCardVariantOVD : "adapters/AccountOpeningAdapter/getCardVariantOVD",
			requestOTPOVD : "adapters/AccountOpeningAdapter/requestOTPOVD",
			validateOTPTokenOVD : "adapters/OTPAdapter/validateOTPTokenOVD",
			getReferenceNumberOVD : "adapters/AccountOpeningAdapter/getReferenceNumberOVD",
			getReferenceDetailsOVD : "adapters/AccountOpeningAdapter/getReferenceDetailsOVD",
			resumeDocumentOVD : "adapters/AccountOpeningAdapter/resumeDocumentOVD/",
			createNomineeOVD : "adapters/AccountOpeningAdapter/createNomineeOVD",
			getPostalDetailByPinCodeOVD : "adapters/AccountOpeningAdapter/getPostalDetailByPinCodeOVD",
			updateGuardianDetailsOVD : "adapters/AccountOpeningAdapter/updateGuardianDetailsOVD",
			guardianAddressOVD : "adapters/AccountOpeningAdapter/guardianAddressOVD",
			getCountries : "adapters/AccountOpeningAdapter/getCountries",
			getInfoList : "adapters/AccountOpeningAdapter/getInfoList",
			savePersonalDetailsOVD : "adapters/AccountOpeningAdapter/savePersonalDetailsOVD",
			customerDocumentOVD : "adapters/AccountOpeningAdapter/customerDocumentOVD/",
			updateCorrespondenceAddressOVD : "adapters/AccountOpeningAdapter/updateCorrespondenceAddressOVD",
			updateCorrespondenceAddress : "adapters/AccountOpeningAdapter/updateCorrespondenceAddress",
			fetchIdAndAddressProofDropdownOVD : "adapters/AccountOpeningAdapter/fetchIdAndAddressProofDropdownOVD",
			savePoiOrPoaInfoOVD : "adapters/AccountOpeningAdapter/savePoiOrPoaInfoOVD",
			getProductFeaturesKnowMoreOVD : "adapters/AccountOpeningAdapter/getProductFeaturesKnowMoreOVD",
			getProductFeaturesOVD : "adapters/AccountOpeningAdapter/getProductFeaturesOVD",
			customerDocumentCheckOVD : "adapters/AccountOpeningAdapter/customerDocumentCheckOVD",
			getTermsAndConditionsOVD : "adapters/AccountOpeningAdapter/getTermsAndConditionsOVD",
			termsAndConditionsFlagOVD : "adapters/AccountOpeningAdapter/termsAndConditionsFlagOVD",
			setFactaFlagWithPanOVD : "adapters/AccountOpeningAdapter/setFactaFlagWithPanOVD",
			fatcaDeclarationOVD : "adapters/AccountOpeningAdapter/fatcaDeclarationOVD",
			fatcaDetailsOVD : "adapters/AccountOpeningAdapter/fatcaDetailsOVD",
			productOfferFlagOVD : "adapters/AccountOpeningAdapter/productOfferFlagOVD",
			authenticateResumeJourney : "adapters/AccountOpeningAdapter/authenticateResumeJourney",
            justStepOVD : "adapters/AccountOpeningAdapter/justStepOVD",
            checkUserAvailability : "adapters/AccountOpeningAdapter/checkUserAvailability",
            registerCustomerInINB : "adapters/AccountOpeningAdapter/registerCustomerInINB",
            fetchdropDownForFatherOVD : "adapters/AccountOpeningAdapter/fetchdropDownForFatherOVD",
            fetchdropDownForMotherOVD : "adapters/AccountOpeningAdapter/fetchdropDownForMotherOVD",
            getPolicyContentOVD : "adapters/AccountOpeningAdapter/getPolicyContentOVD",
            getUsernamePasswordFormat : "adapters/AccountOpeningAdapter/getUsernamePasswordFormat",
            generateAadharOtpOVD: 'adapters/AccountOpeningAdapter/generateAadharOtpOVD',
            getEKycOTPSecureOVD: 'adapters/AccountOpeningAdapter/getEKycOTPSecureOVD',
            removeCustomerDocument: 'adapters/AccountOpeningAdapter/removeCustomerDocument',

    },

    acOpeningAdapterOVDConstant :{
        digitalAadhaar : "DIGITAL-AADHAAR",
        digitalOVD : "DIGITAL-OVD",
        vkycInsta: "INSTA-PLUS",
        insta: "INSTA-AADHAR",
        salaryAcc:"VKYC-CSP"
    },

    acOp: {
        gender: 'Gender',
        maleGender: 'male',
        femaleGender: 'female',
        transGender: 'transgender',
        title: 'Title',
        india: 'india',
        nomineeAge: 18,
        panLength: 10

    },
    templateUrl: {
        addressTmpl: 'common/directives/templates/addressTmpl.html',
        gpsBranchesTmpl: 'common/directives/templates/gpsBranchesTmpl.html',
        branchesTmpl: 'common/directives/templates/branchesTmpl.html',
        cardlessAtmTmpl: 'common/directives/templates/cardlessAtmTmpl.html',
        additionalDetailsTmpl: 'common/directives/templates/additionalDetailsTmpl.html',
        footerTmpl: 'common/directives/templates/footerTmpl.html',
        headerTmpl: 'common/directives/templates/headerTmpl.html',
        headerTmplOld: 'common/directives/templates/headerTmplOld.html',
        locateBranchTmpl: 'common/directives/templates/locateBranchTmpl.html',
        titleTmpl: 'common/directives/templates/titleTmpl.html',
        progressBarTmpl: 'common/directives/templates/progressBarTmpl.html',
        passwordFooterTmpl: 'common/directives/templates/passwordFooterTmpl.html',
        otpFooterTmpl: 'common/directives/templates/otpFooterTmpl.html',
        instaAddressTmpl: 'common/directives/templates/instaAddressTmpl.html',
        menuTmpl: 'common/directives/templates/menuTmpl.html',
        percentageBar: 'common/directives/templates/percentageBar.html',
        ycFooterTmpl:'common/directives/templates/ycFooterTmpl.html',
        rinRakshaFooter:'common/directives/templates/rinRakshaFooter.html'

        
    },
    keysForOTP: {
        ftEditBenificary: 'FT_EditBen',
        ftNormalFundTransfer: 'FT_Normal',
        ftScheduleFundTransfer: 'FT_Schedule',
        setMpin: 'Set_MPIN',
        Register: 'Register_User',
        BillPay: 'Bill_Pay',
        AORegister: 'AO_Reg',
        AOReferenceNumber: 'AO_RefNo',
        SAFALOTP:'',
        CARDOTP:''
    },
    adapter: {
        CHALLENGE_HANDLING_CANCELED: 'Your session has expired. Please login again.',
        REQUEST_TIMEOUT: 'Sorry due to poor connectivity we are unable to process your request now. Please try after sometime.',
        UNRESPONSIVE_HOST: 'Sorry due to some technical issue your request could not be processed now. Please try later.',
        CANNOT_PROCESS_NOW: 'Sorry we are unable process your request. Please try after sometime.',
        SESSION_INACTIVITY: 'Your session has expired due to inactivity. Please login again.',
        INVALID_JWT: 'Please change and enable your mobile time settings to auto update, use network provided time and retry.',
        INTERNAL_SERVER_ERROR: 'Internal server error, Please try after sometime.',
        AUTHORIZATION_FAILURE: 'Server authorization error, Please try after sometime.',
        // LOGIN_ALREADY_IN_PROCESS: 'Your last session was terminated incorrectly or is currently active. Please try after sometime.',
        LOGIN_ALREADY_IN_PROCESS: 'Your Session is expired.Please re-launch the application and login.',
        UNABLE_TO_REACH_SERVER: 'Unable to reach server, Please try after sometime.',
        SOMETHING_WENT_WRONG: 'Something went wrong, Please try after sometime.',
        SLOW_OR_NO_CONNECTION: 'Sorry, there seems to be internet connectivity issue, please try again later.',
        UPDATE_DATE_AND_TIME_SETTINGS: 'Sorry for the inconvenience, please set your mobile device date and time to Automatic using Settings option.',
        UPDATE_APPLICATION : 'Sorry it seems you are not using the latest version of the app. Please download the latest version for smooth and better experience.',
        USER_ID_BLOCKED : 'Your User id is blocked. Please visit onlinesbi.com for unlocking the Userid and then proceed with the registration process.',
        INVALID_REQUEST: 'Invalid Request'
    },
    mfAndsecConst: {
        tradeNow: "TradeNow",
        current: "current",
        inv: "inv",
        invest: "invest",
        qnt: "qnt",
        gainloss: "gainloss",
        txnLength: "16",
        lumpsum: "lumpsum",
        yes: "YES",
        yesAvailable: "yes",
        quarterly: "quarterly",
        monthly: "monthly",
		    perpetualDate:"31 DEC 2099",
        transactionTypeSIP: "P",
        transactionTypeRedeem: "R",
        transactionTypeSwitch: "SO",
        savingAccountInOpenAccount: "Savings A/c",
        currentAccountInOpenAccount: "Current A/c",
        odAccountInOpenAccount: "Overdraft A/c",
        distributor: "distributor",
        popularFunds: "Popular Funds",
        nfoList: "NFO",
        riskText: "riskProfile",
        openAccountText: "openAccount",
        titleInMF: "title",
        genderInMF: "gender",
        occupationInMF: "occupation",
        cityInMF: "city", stateInMF: "state",
        taxStatusInMF: "taxStatus",
        countryInMF: "country",
        pepInMF: "pep",
        grossAmountInMF: "grossAmount",
        netWorthInMF: "netWorth",
        identificationTypeInMF: "identificationType",
        shareOneInMF: "share1", shareTwoInMF: "share2",
        shareThreeInMF: "share3",
        performanceTime: "12",
        sysInvestPlanTermsAndC: "SystematicInvestmentPlan",
        ekycRegister: "eKYCRegistration",
        lumpsumInvestTermsAndC: "LumpsumInvestments",
        redempationTermsAndC: "Redemption",
        kycCompliantText: "KYCComplience",
        STP: "STP",
        SIP: "SIP",
        SWP: "SWP",
        redeem: "redeem",
        cancel: "cancel",
        SIPFresh: "SIPFresh",
        switchTxt: "switch",
        swpTermsAndC: "SWP",
        amount: "amount",
        units: "units",
        SWITCH: "Switch",
        helpMeInvest: "HelpmeInvest",
        lumpsumMf: "Lumpsum",
        lumpsumAdditional: "LumpsumAdditional",
        lumpsumFresh: "LumpsumFresh",
        SIPAdditional: "SIPAdditional",
        dividendOption: "N",
        AOTermsAndConditions: "Purchase",
        schemeAction: "schemeActions",
        riskInfoEmptyText: "Can not process now, Please try after sometime.",
        redeemMf: "Redeem",
        taxStatus: "01",
        country: "IN",
        CBSPanError: "Your MF Investment Account’s PAN number is not matching with Bank Account’s  PAN number. Please update your correct PAN number at your home branch.",
        purchaseNotAvailTxt: "Oops!! Purchase is not available for this Scheme.",
        redeemNotAvailTxt: "Oops!! Redemption is not available for this Scheme.",
        switchNotAvailTxt: "Oops!! This fund is not eligible for Switch.",
        STPNotAvailTxt: "Oops!! STP is not available for this Scheme.",
        SWPNotAvailTxt: "Oops!! SWP is not available for this Scheme.",
        SIPNotAvailTxt: "Oops!! SIP is not available for this Scheme.",
        CancelNotAvailTxt: "Oops!! Cancellation is not available for this Scheme.",
        sip4QtrError: "You can register SIP for a minimum of 4 quarters/ 1year.",
        sip12MonthsError: "SIP can only be accepted for minimum 12 months period.",
        stp4QtrError: "STP can only be accepted for minimum 4 Quarters period.",
        stp12MonthsError: "STP can only be accepted for minimum 12 months period.",
        swp4QtrError: "SWP can only be accepted for minimum 4 Quarters period.",
        swp12MonthsError: "SWP can only be accepted for minimum 12 months period.",
        minInstallments4: "4",
        minInstallments12: "12",
        sipIsLotusFolio:"SIP is available for the Yono Folio only.",
        lumpsumIsLotusFolio:"Lumpsum Purchase is available for the Yono Folio only.",
        sip31stDateErrorMsg:"31st date is not allowed as SIP Start Date for this scheme."

    },
    upiConstant: {
        addInfo10: "NA",
        addInfo9: "NA",
        bankCode: "",
        recoveryOptionFlag: 0,
        pspId: 202,
        updateFlag: 0,
        isMerchant: false,
        showMerchant: false,
        defVPAStatus: false,
        secretAnswer : "",
        secretQuestionId : 0,
        secretQuestionName : "",
        requestType_M: "M",
        requestType_E: "E",
        requestType_R: "R",
        requestType_D: "D",
        requestType_A : "A",
        requestType_P: "P",
        requestType_RA : "RA",
        requestType_DA : "DA",
        credentialDataValue: "142536",
        simNo: "",
        vAReqType_R: "R",
        vAReqType_T: "T",
        failureRespStatus: "F",
        successRespStatus: "S",
        defVPAStatus: false,
        vpaNotExist: "This Virtual Address is available.",
        vpaExist: "This Virtual address is already exists. Please try with different virtual address.",
        vpaType: "VA",
        //UPI service calls
        scanqrcode : "scanqrcode",
        initializeIOSsdk : "initializeIOSsdk",
        getBeneficiaryList : "getBeneficiaryList",
        updateBeneficiary : "updateBeneficiary",
        onUnBlockVPA : "onUnBlockVPA",
		getSpamVPAList : "getSpamVPAList",
        onCollectApprove : "onCollectApprove",
        onCollectInitiation : "onCollectInitiation",
        onSetMpin: "onSetMpin",
        getDisputeList : "getDisputeList",
        getDisputeTypeList : "getDisputeTypeList",
        onRaiseDispute : "onRaiseDispute",
        onChangeMpin : "onChangeMpin",
        onUpdateAccountList : "onUpdateAccountList",
        onSubmitNewAccount : "onSubmitNewAccount",
        onBalanceEnquiry : "onBalanceEnquiry",
        getaccountListAPI: "getaccountListAPI",
        getcollectList : "getcollectList",
        getTransactionHistoryList : "getTransactionHistoryList",
        getSecurityQuestionsList: "getSecurityQuestionsList",
        getSelectedSecurityQuestion: "getSelectedSecurityQuestion",
        getProfile: "getProfile",
        checkVirtualAddressAPI: "checkVirtualAddressAPI",
        checkDevice: "checkDevice",
        onCreateNewVPA: "onCreateNewVPA",
        updateDevice: "updateDevice",
        sendsms: "sendsms",
        onRegisterSubmit: "onRegisterSubmit",
        getpermission: "getpermission",
        getsimslot: "getsimslot",
        onRemoveVPA: "onRemoveVPA",
        onPayInitiation: "onPayInitiation",
        getcontactpermission: "getcontactpermission",
        getbankListAPI : "getbankListAPI",
        deRegisterAccount : "deRegisterAccount",
        //Server errors
        minusOne: "U001: There are some technical issues. Please try after sometime.", //GET_ACCESS_TOKEN
        minusTwo: "U002: There are some technical issues. Please try after sometime.", //GET_REFRESH_TOKEN
        minusThree: "U003: BHIM UPI session has been expired.", //SESSION_EXPIRED
        minusFour: "U004: There are some technical issues. Please try after sometime.", //TOKEN_FAILED
        minusFive: "U005: There is some technical issue while communicating with UPI server. Please try after sometime.", //SSL_PINNING_FALIED
        minusSix: "U006: There is some technical issue while communicating with UPI server. Please try after sometime.", //PSP_HANDSHAKE_FAILED
        minusSeven: "U007: UPI server is not responding. Please try after sometime.",//SERVER DOWN
        //Payment Failure messages
        paymentFail_ND: "Transaction Failed",
        paymentFail_NC: "Transaction Failed",
        paymentFail_Z0: "UPI PIN Authentication Failed",
        paymentFail_AM: "UPI PIN not linked to account.",
        paymentFail_ZG: "RESTRICTED VPA, DECLINE",
        paymentFail_ZI: "SUSPECTED FRAUD, DECLINE / TRANSACTIONS DECLINED BASED ON RISK SCORE BY BENEFICIARY",
        paymentFail_ZJ: "BENEFICIARY OR ACQURING SWITCH IS INOPERATIVE/NODE OFFLINE",
        paymentFail_ZK: "REMITTER SWITCH IS INOPERATIVE /NODE OFFLINE",
        paymentFail_ZL: "RECEIVED LATE RESPONSE",
        paymentFail_ZU: "LIMIT EXCEEDED FOR REMITING BANK/ISSUING BANK",
        paymentFail_ZN: "FUNCTIONALITY NOT YET AVAILABLE FOR MERCHANT THROUGH THE ACQURING BANK",
        paymentFail_ZO: "FUNCTIONALITY NOT YET AVAILABLE FOR CUSTOMER THROUGH THE PAYEE PSP",
        paymentFail_ZP: "BANKS AS BENEFICIARY NOT LIVE ON PARTICULAR TXN TYPE",
        paymentFail_ZQ: "UNABLE TO PROCESS REVERSAL",
        paymentFail_ZX: "INACTIVE OR DORMANT ACCOUNT (REMITTER)",
        paymentFail_ZY: "INACTIVE OR DORMANT ACCOUNT (BENEFICIARY)",
        paymentFail_XB: "INVALID TRANSACTION OR IF MEMBER IS NOT ABLE TO FIND ANY APPROPRIATE RESPONSE CODE (REMITTER)",
        paymentFail_XC: "INVALID TRANSACTION CODE",
        paymentFail_XD: "INVALID AMOUNT (REMITTER)",
        paymentFail_XE: "INVALID AMOUNT (BENEFICIARY)",
        paymentFail_XF: "FORMAT ERROR (INVALID FORMAT) (REMITTER)",
        paymentFail_XG: "FORMAT ERROR (INVALID FORMAT) (BENEFICIARY)",
        paymentFail_XH: "ACCOUNT DOES NOT EXIST (REMITTER)",
        paymentFail_XI: "ACCOUNT DOES NOT EXIST (BENEFICIARY)",
        paymentFail_XJ: "REQUESTED FUNCTION NOT SUPPORTED",
        paymentFail_XK: "REQUESTED FUNCTION NOT SUPPORTED",
        paymentFail_XP: "TRANSACTION NOT PERMITTED TO CARDHOLDER (REMITTER)",
        paymentFail_XQ: "TRANSACTION NOT PERMITTED TO CARDHOLDER (BENEFICIARY)",
        paymentFail_XT: "CUT-OFF IS IN PROCESS (REMITTER)",
        paymentFail_XU: "CUT-OFF IS IN PROCESS (BENEFICIARY)",
        paymentFail_XV: "TRANSACTION CANNOT BE COMPLETED. COMPLIANCE VIOLATION (REMITTER)",
        paymentFail_XW: "TRANSACTION CANNOT BE COMPLETED. COMPLIANCE VIOLATION (BENEFICIARY)",
        paymentFail_XX: "NO FINANCIAL ADDRESS RECORD FOUND",
        paymentFail_XY: "REMITTER CBS OFFLINE",
        paymentFail_XZ: "BENEFICIARY CBS OFFLINE",
        paymentFail_YC: "DO NOT HONOUR (REMITTER)",
        paymentFail_YD: "DO NOT HONOUR (BENEFICIARY)",
        paymentFail_YE: "REMITTING ACCOUNT BLOCKED/FROZEN",
        paymentFail_YF: "BENEFICIARY ACCOUNT BLOCKED/FROZEN",
        paymentFail_YG: "MERCHANT ERROR (PAYEE PSP)",
        paymentFail_YH: "MERCHANT ERROR (ACQURING BANK)",
        paymentFail_YI: "INVALID RESPONSE CODE",
        paymentFail_U08: "SYSTEM EXCEPTION",
        paymentFail_U31: "Credit was failed",
        paymentFail_U30: "Debit was failed",
        paymentFail_U67: "Debit TimeOut",
        paymentFail_U68: "Credit TimeOut",
        paymentFail_U69: "Collect Expired",
        paymentFail_U70: "Received Late Response",
        paymentFail_ZA: "INVALID MERCHANT( ACQUIRING BANK)",
        paymentFail_ZB: "INVALID MERCHANT  (PAYEE PSP)",
        paymentFail_Z9: "INSUFFICIENT FUNDS IN CUSTOMER (REMITTER) ACCOUNT",
        paymentFail_K1: "SUSPECTED FRAUD, DECLINE / TRANSACTIONS DECLINED BASED ON RISK SCORE BY REMITTER",
        paymentFail_Z8: "EXCEEDS PER TRANSACTION LIMIT BY REMITTING MEMBER",
        paymentFail_Z7: "EXCEEDS TRANSACTION FREQUENCY LIMIT (REMITTER)",
        paymentFail_Z6: "ALLOWABLE NUMBER OF PIN TRIES EXCEEDED, DECLINE",
        paymentFail_ZC: "ACQUIRER/BENEFICIARY UNAVAILABLE",
        paymentFail_UA: "PSP NOT SUPPORTED BY UPI",
        paymentFail_UP: "PSP TIME-OUT",
        paymentFail_UT: "UPI ISSUER TIMEOUT",
        paymentFail_ZM: "UPIPIN authentication failed",
        paymentFail_ZD: "VALIDATION ERROR",
        paymentFail_ZE: "TRANSACTION NOT PERMITTED TO VPA",
        paymentFail_ZF: "TRANSACTION NOT PERMITTED TO DEVICE",
        paymentFail_U66: "Device Fingerprint mismatch",
        paymentFail_Z5: "Invalid Benificiary Details",
        paymentFail_32: "PARTIAL REVERSAL",
        paymentFail_21: "NO ACTION TAKEN (FULL REVERSAL)",
        paymentFail_00: "APPROVED OR COMPLETED SUCCESSFULLY",
        paymentFail_14: "INVALID BENEFICIARY CREDENTIALS",
        paymentFail_15: "ISSUER NOT LIVE ON UPI",
        paymentFail_17: "TRANSACTION CANCELLED BY CUSTOMER",
        paymentFail_63: "SECURITY VIOLATION(DIGITAL SIGNATURE MIS MATCH",
        paymentFail_68: "ACQUIRER TIME-OUT",
        paymentFail_94: "ACQUIRER/BENEFICIARY UNAVAILABLE",
        paymentFail_96: "SYSTEM ERROR",
        //Something went wrong error msg
        someWentWrong: "Can not process now, Please try after sometime."
    },
    DC_PIN: {
        USERNAME_EXIST: "Please choose a different user name.This user name has already been taken"
    },
    keyGuard: {
        KEYGUARD_ERR_MSG: "Please enable Device/Pattern Lock and reopen application."
    },
    version:{
    	versionHide : true
    },
    accOverview: {
        pdfSize: 5000000,
        sizeLimitMessage: "File size should be less than 5 MB"
    },
    npsDetails:{
        equity:"Equity",
        coporateDebt:"Corporate Debt",
        governmentBond:"Government Bond",
        alternativeFunds:"Alternative Funds"
    },
    loginBannerURL:"https://www.sbiyono.sbi",
    quickTransferAdapterURL:{
        getTransaction:'adapters/FundsTransferAdapter/quickTransfer/getTransaction',
        payToContact:'adapters/FundsTransferAdapter/yqp/payToContact',
        transferFunds:'adapters/FundsTransferAdapter/transferFunds',
        getTransactionFeeQuickTransfer : 'adapters/FundsTransferAdapter/quickTransfer/getTransactionFeeQuickTransfer',
        transferFundsQuickTransfer:'adapters/FundsTransferAdapter/quickTransfer/transferFundsQuickTransfer',
        addBeneficiary: 'adapters/FundsTransferAdapter/quickTransfer/addNewBeneficiary',
        getOTPTokenSecure: 'adapters/OTPAdapter/getOTPTokenSecure',
        validateOTP: 'adapters/OTPAdapter/validateOTPTokenSecure',
        imageSizeMessage:'Maximum file size to upload is 5MB.',
        imgSize : 5000000
    },
    MFPURL : {
        MFPSIT: 'https://msit.intouch.onlinesbi.com/mfp/',
        MFPUAT: 'https://muat.intouch.onlinesbi.com/mfp/',
        MFPISD: 'https://mdev.intouch.onlinesbi.com/mfp/',
        MFPPROD: 'https://mobile.sbiyono.sbi/mfp/'
    },
    yonoLiteRedirectionURL : {
        iOSAppleStore : 'https://apps.apple.com/in/app/yono-lite-sbi/id872982272',
        androidPlayStore : 'https://play.google.com/store/apps/details?id=com.sbi.SBIFreedomPlus',
        androidPackSchema : 'com.sbi.SBIFreedomPlus://',
        iOSPackSchema : 'SBAnywhere://',
        yonoLiteAppPackageName : 'com.sbi.SBIFreedomPlus'

    },
    secKeyErrors:{
        technicalError : "Technical error, please try later."
    },
    profile: {
        currency: "INR"
    },
    SB : {
        errorCodeSB002 : "SB002",
        errorCodeSB003 : "SB003",
        fileName:"VelocityCheck.json",
        technicalError:"Technical error, please try later."
    },
    appRate: {
        skipDateFrequency: 7,
        ratingDateFrequency: 30
    },
    FORCE_PWD_ERROR_CODES:{
        FP01:"FP01"
    },
    CSAT : {
        CSAT_CSR : "CSR",
        CSAT_NPR : "NPR",
        CSAT_RATING_CHECK : 3
    },
    // Deposit calculator
    depositCalc : {
        amountMaximum: "9999999",
        taxSaverAmtMax: "150000",
        nonSeniorAmtMin: "1000",
        seniorAmtMin: "10000",
        rdAmtMin: "100"
    },
    rogueAppsData : {

        rogueApps: [
            {
                appName: "Anydesk",
                appIcon: "img/vurnableApp/anyDesk.png",
                appBundleName: "com.anydesk.anydeskandroid",
                appSchemaName: "anydesk"
            },
            {
                appName: "TeamViewer",
                appIcon: "img/vurnableApp/TeamViewer.png",
                appBundleName: "com.teamviewer.teamviewer.market.mobile",
                appSchemaName: "teamviewerTVCv1"
            },
            {
                appName: "TeamViewer QuickSupport",
                appIcon: "img/vurnableApp/Quicksupport.png",
                appBundleName: "com.teamviewer.quicksupport.market",
                appSchemaName: "tvqs"
            },
            {
                appName: "Alpemix",
                appIcon: "img/vurnableApp/alpemix.png",
                appBundleName: "com.teknopars.AlpemixPro",
                appSchemaName: ""
            },
            {
                appName: "SBI KYC",
                appIcon: "img/vurnableApp/SBI_KYC.png",
                appBundleName: "srthk.pthk.smsforwarder",
                appSchemaName: ""
            },
            {
                appName: "ISL",
                appIcon: "img/vurnableApp/ISL.png",
                appBundleName: "com.islonline.isllight.mobile.android",
                appSchemaName: "isllight"
            }
           
        ],
        disclaimer_hi: "आपके खाते से पैसे की धोखाधड़ी करने के लिए धोकेबाज़ इंस्टाल किए हुए निमनालिखित ऐप्स का उपयोग कर सकते हैं",
        disclaimer_en: "Following installed apps can be used by fraudsters to steal your money",
        tnc_hi: "में सुरक्षा झोखिम को समझता हूं की इन ऐप्स का दुरूपयोग स्क्रीन को रिकॉर्ड करने या खाते से पैसे की धोखाधड़ी करने के लिए किया जा सकता है। में जारी रखने के लिए सहमत हूं।",
        tnc_en: "I understand the security risk that these apps can be misused by some one to record screeen or steal money from the Account. I agree to continue"
    },
    OTP_EMAIL_SMS_TEMPLATE :{
        YONO_REGISTRATION_OTP:"REGISTRATION_OTP",
        RESET_PROFILE_PASS: "RESET_PROFILEPASSWORD_OTP",  
        RESET_LOGIN_PASS: "RESET_LOGINPASSWORD_OTP",
        SET_MPIN:"SET_MPIN_OTP"
    }
});
