angularApp.service('utilityService',
	function ($ionicPopup, $ionicHistory, $q, $timeout, $translate, constantConfig, $ionicPlatform, $state, cryptoService) {
	        var utilityService = this;
		var platform = window.navigator.platform;
		var isIPad = ionic.Platform.isIPad();
		var isIOS = ionic.Platform.isIOS();
		var isAndroid = ionic.Platform.isAndroid();
		var androidPlatform = (isAndroid && !(platform.toLowerCase() == "win32" || platform.toLowerCase() == "win64"));
		var iOSPlatform = ((isIPad || isIOS) && !(platform.toLowerCase() == "win32" || platform.toLowerCase() == "win64"));
		var deregisterBackButton;
		var accessRestricted = '';
		var mPinAuthRequire = 'mPinAuthRequire';
		var AOAuthRequired = 'AOAuthRequired';
		var csatJournies = [];
		var timeSpent = 0;
		var doNotShowErrorMsg = false;
		var lastTimeStamp = "";
		$translate(['M001_LOGIN_ALREADY_IN_PROCESS', 'M002_REQUEST_TIMEOUT', 'M003_UNRESPONSIVE_HOST', 'M004_AUTHORIZATION_FAILURE', 'M005_INTERNAL_SERVER_ERROR', 'M006_INVALID_CLIENT' ,'M007_APPLICATION_DOES_NOT_EXIST','M008_400','M009_409','M010_500','M011','M012']).then(function (translations) {
			    utilityService.m001LoginProcess = translations['M001_LOGIN_ALREADY_IN_PROCESS'];
				utilityService.m002RequestTimeout = translations['M002_REQUEST_TIMEOUT'];
				utilityService.m003UnResponsiveHost = translations['M003_UNRESPONSIVE_HOST'];
				utilityService.m004AuthFailure = translations["M004_AUTHORIZATION_FAILURE"];
				utilityService.m005InternalServerError = translations["M005_INTERNAL_SERVER_ERROR"];
				utilityService.m006InvalidClient = translations["M006_INVALID_CLIENT"];
				utilityService.m007ApplicationNotExist = translations["M007_APPLICATION_DOES_NOT_EXIST"];
				utilityService.m008E400 = translations["M008_400"];
				utilityService.m009E409 = translations["M009_409"];
				utilityService.m010E500 = translations["M010_500"];
				utilityService.m011 = translations["M011"];
				utilityService.m012 = translations["M012"];
		});
		

		var getCsatJournies = function () {
			return removeDuplicates(this.csatJournies, "journeyName");
		};

		var setCsatJournies = function (jname) {
			var n = this.csatJournies.length;
			var timeSpentTemp = 0;
			if (jname === "ompShoppingDeals") {
				timeSpentTemp = this.timeSpent;
			}
			this.csatJournies[n] = { 'sequence': n, 'journeyName': jname, 'timeSpent': timeSpentTemp };
		};

		function removeDuplicates(originalArray, prop) {
			var newArray = [];
			var lookupObject = {};

			for (var i in originalArray) {
				lookupObject[originalArray[i][prop]] = originalArray[i];
			}
			for (i in lookupObject) {
				newArray.push(lookupObject[i]);
			}
			return newArray;
		}

		/**
		 * It returns true if given data is undefined or null or "null" and empty 
		 * @param obj 
		 * @return {boolean} isUndefined
		 */
		var isUndefined = function (obj) {
			return (typeof obj === "undefined" || obj === null || obj === '' || obj === 'null' || obj === 'string');
		};

		/**
		 * It checks whether the given data is empty or not
		 * @param obj 
		 * @return {boolean} isEmpty
		 */
		var isEmpty = function (obj) {
			return (obj === "");
		};
		var isArray = function (obj) {
			angular.isArray(obj);
		}

		/**
		 * It returns empty string if given value is null or undefined otherwise it returns given value
		 * @param  {String} inputValue 
		 * @return  {String} getValue
		 */
		var getValue = function (inputValue) {
			return (inputValue && inputValue != null && inputValue != "null" && inputValue != undefined) ? inputValue.toString() : "";
		};
		var spinnerPopup;
		var isShowSpinner = false;
		var showContSpinner = false
		/**
		 * Starts Spinner
		 */
		var showSpinner = function () {
			if (isShowSpinner) {
				return;
			}
			//if(showContSpinner){ return "";}

			isShowSpinner = true;
			if (isAndroidPlatform()) {
				deregisterBackButton = $ionicPlatform.registerBackButtonAction(function (e) { }, 401);
			}
			spinnerPopup = $ionicPopup.show({
				cssClass: 'removePopupHeader removePopupBodyPading spinnerPopup',
				templateUrl: 'common/directives/templates/spinner.html'
			});
		}

		var doNotShowSpinner = function () {
			isShowSpinner = true;
		}

		/**
		 * Stops Spinner
		 */
		var hideSpinner = function () {
			if (showContSpinner) { return ""; }
			isShowSpinner = false;
			if (isAndroidPlatform()) {
				deregisterBackButton();
			}
			spinnerPopup.close();
		}

		var doNotHideSpinner = function (stopHiding) {
			//showContSpinner = stopHiding;
			isShowSpinner = false;
		}

		var showAlertModal = function (title, template, onTapgo, $scope, $state, buttontext,minorForAO,accountOpeningHomeService) {
			var alertPopup = $ionicPopup.alert({
				title: title,
				template: template,
				scope: $scope,
				cssClass: 'sbi-alert-popup',
				buttons: [
					{
						text: buttontext,
						type: 'button-positive',
						onTap: function () {
							if (onTapgo !== '' && onTapgo !== null) {
								$state.go(onTapgo);
							} if(minorForAO){
								accountOpeningHomeService.homeNav();
							}
						}
					}
				],
			});
			alertPopup.then(function (res) {
			});
		};
		//showForcePassword PopUP

		var showForcePasswordPopup = function(message,onTapgo){
			let ErrorPopup = $ionicPopup.alert({
				template: '<div class="alertSysmbol"><img class="approvedIconPosition" src="img/FT/BhimUpi/alertSymbol.svg" /></div><div class="popupTextBottomPadding"><div class="textAlignCenter"><span>'
				+ message + '</span></div></div></div>', //template,
				cssClass: 'inbFP-alert-popup',
				buttons: [
					{
						text: "OK",
						type: 'button-positive',
						onTap: function () {
							if (onTapgo) {
								$state.go(onTapgo);
							}
						}
					}
				],
			});
			ErrorPopup.then(function (res) {
			});
		}

		//BHIM UPI ERROR MSG	
		    var showBhimUpiAlert = function (imageType, message, onTapgo, buttontext, $scope) {
			switch (message) {
				case -1: message = constantConfig.upiConstant.minusOne;
				break;

				case -2: message = constantConfig.upiConstant.minusTwo;
				break;

				case -3: message = constantConfig.upiConstant.minusThree;
				break;

				case -4: message = constantConfig.upiConstant.minusFour;
				break;

				case -5: message = constantConfig.upiConstant.minusFive;
				break;

				case -6: message = constantConfig.upiConstant.minusSix;
				break;

				case -7: message = constantConfig.upiConstant.minusSeven;
				break;

				default: (message && typeof message == 'string') ? message = message : message = constantConfig.upiConstant.someWentWrong;
			}

			if(message.indexOf("U00") !== -1){
				onTapgo = "menu.fundsTransferLanding";
			}

			if(imageType && imageType.toLowerCase() == 'error'){
				imageType = 'img/FT/BhimUpi/errorSymbol.svg';
			} else if(imageType && imageType.toLowerCase() == 'success'){
				imageType = 'img/FT/BhimUpi/successSymbol.svg';
			}else{
				imageType = 'img/FT/BhimUpi/alertSymbol.svg';
			}
			var bhimErrorPopup = $ionicPopup.alert({
				template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src='+imageType+' /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'
				+ message + '</span></div></div></div>', //template,
				scope: $scope,
				cssClass: 'bhim-alert-popup',
				buttons: [
					{
						text: buttontext || "OK",
						type: 'button-positive',
						onTap: function () {
							if (onTapgo) {
								$state.go(onTapgo);
							}
						}
					}
				],
			});
			bhimErrorPopup.then(function (res) {
			});
		};
		
		//NFS error MSG

		var showNfsAlertModal = function (title, message, onTapgo, $scope, $state, buttontext,className) {
			var alertPopup = $ionicPopup.alert({
				title: title,
				template: '<div class="popupBodyPadding font-dark-grey"><div><img class="approvedIconPosition" src="img/errorImage.png"></div><div translate="ERROR_TITLE" class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'
				+ message + '</span></div></div></div>',
				cssClass: 'removePopup-head popupWidth90 popupMargin ftpopup-body popupBackgroundWhite textAlignCenter'+' '+className,
				scope: $scope,
				buttons: [
					{
						text: buttontext,
						type: 'button-positive',
						onTap: function () {
							if (onTapgo !== '' && onTapgo !== null) {
								$state.go(onTapgo);
							} else {
							}
						}
					}
				],
			});
			alertPopup.then(function (res) {
			});
		};

		var comingSoon = function (){
			var comingsoonPopup = $ionicPopup.alert({
				template: '<div class="CSPadding font-dark-grey "><div class="parentCS"><img class="imgwidthCS" src="img/Coming_Soon_Illustration.svg"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="childCS">'
				+ "Coming Soon" + '</div></div></div></div></div></div>',
				cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter custButtonCS button0pd',
				buttons: [
				{
					text: 'OK',
					type: 'button-positive',
					onTap: function (e) {
					comingsoonPopup.close();
					// $state.go("menu.innerPage");
					}
				}
				]
			});
		};
		

		//NFS email Mask and mobile number masking start here
		var maskData = function (str, sequence, digit, splitstring) {
			var backCharacters = "";
			var frontCharacters = "";
			var combinedCharacters = "";

			if (splitstring) {
				var testarray = str.split(splitstring);
				var backCharacters = "";
				var frontCharacters = "";
				// for(var i=0;i<testarray[1].length;i++)
				// {
				//  backCharacters=backCharacters+"x";
				// }

				for (var i = 0; i < testarray[0].length; i++) {
					if (i != digit) {
						frontCharacters = frontCharacters + "x";
					}
					else {
						frontCharacters = testarray[0][i];
					}
				}

				combinedCharacters = frontCharacters + splitstring + testarray[1];

			}
			else {
				var backCharacters = str.substring(str.length - digit);



				var data2 = str.substring(0, str.length - digit);


				// var data3="";
				// var data4="";

				for (var i = 0; i < data2.length; i++) {
					frontCharacters = frontCharacters + "X";
				}



				if (sequence == "front") {
					combinedCharacters = frontCharacters + backCharacters
				}
				else {
					combinedCharacters = data2 + frontCharacters;
				}
			}




			return combinedCharacters;

		}
		//NFS email Mask and mobile number masking end here

		// Email Masking starts here
		//@ Krishna Singh
		var maskEmail = function (str, digit) {
			var frontCharacters = "";
			var frontCharacters2 = "";
			var combinedCharacters = "";

			
				var testarray = str.split("@");

				for (var i = 0; i < testarray[0].length; i++) {
					if (i == digit || i == (testarray[0].length - 1)) {
						frontCharacters = frontCharacters + testarray[0][i];
					}
					else {
						frontCharacters = frontCharacters + "x";
					}
				}

				// var testarray2 = testarray[1].splice(0, testarray[1].indexOf('.'));
				var testarray2 = testarray[1].split(".");

				for (var i = 0; i < testarray2[0].length; i++) {
					if (i == digit || i == (testarray2[0].length - 1)) {
						frontCharacters2 = frontCharacters2 + testarray2[0][i];
					}
					else {
						frontCharacters2 = frontCharacters2 + "x";
					}
				}

				combinedCharacters = frontCharacters + "@" + frontCharacters2 + "." + testarray2[1];

			



			return combinedCharacters;

		}

		// Email Masking ends here

		// Get text from dropdown with ng-options
		//@ Krishna Singh
		
		// key : Key of the known value
		// value : known value i.e ng-model value
		// array : array of the select dropdown
		// desiredValueKey : 'key' of the value you want to retrieve
		var getTextFromDropdown = function (key, value, array, desiredValueKey) {
			if(value){

				//var selectedArrayObject = $filter('filter')(array,{ [key] : value});

				var selectedArrayObject =  array.filter(function(obj) {
					return obj[key] == value;
				});

				var dropdownText = selectedArrayObject[0][desiredValueKey];
	
				return dropdownText;

				}else{
					return "";
				}
		}

		// Calculate Age from DOB
		//@ Krishna Singh
		var getAge = function (dobString) {
			var dob = new Date(dobString);
			var dobYear = dob.getUTCFullYear();
			var currentYear = new Date().getUTCFullYear();

			var age = currentYear - dobYear;

			return age;
		}

		// Amount Format i.e puts coma while entering amount
		//@ Krishna Singh
		var amountFormat = function (params) {

			if(params){

				if(params.length < 5){
					return params.toString().replace(/\B(\.\d*)?(?=(\d{3})+(?!\d))/g, ",");
				}else{
					var x = params.slice(params.length-3,params.length); 
					var y = params.slice(0,params.length-3);  
					var z = y.toString().replace(/\B(\.\d*)?(?=(\d{2})+(?!\d))/g, ","); 
					return z.concat(",",x);
				}
				
			}else{
				return "";
			}

		}
		// Function added to format amount for decimal inputs
		var amtFmtDecml = function (value) {
			var decVal = value.slice(-3);
			var fmtVal = null;

			if(value.includes(".")){				
				value = value.slice(0,-3);
				if(value.length < 5){
					fmtVal = value.toString().replace(/\B(\.\d*)?(?=(\d{3})+(?!\d))/g, ",");
				}else{
					var x = value.slice(value.length-3,value.length); 
					var y = value.slice(0,value.length-3);  
					var z = y.toString().replace(/\B(\.\d*)?(?=(\d{2})+(?!\d))/g, ","); 
					fmtVal = z.concat(",",x);
				}
				fmtVal = fmtVal.concat(decVal);
			}
			return fmtVal;
		}

		// Resets Amount Format i.e removes coma from amount
		//@ Krishna Singh
		var resetAmountFormat = function (params) {

			if(params){
				return params.replace(/\,/g,'');
			}else{
				return "";
			}

		}




		/**
		 * To Clear History
		 */
		var clearViewHistory = function () {
			$ionicHistory.nextViewOptions({
				historyRoot: true
			});
		};

		/**
		 * To Clear History Except Current View
		 */
		var clearHistoryExceptCurrentView = function () {
			$ionicHistory.clearHistory();
		};

		/**
		 * Shows Error Message
		 * @param {string/object} message 
		 */
		var enableShowErrorMessage = function (message, openSetting) {
			doNotShowErrorMsg = false;
		}

		var disableShowErrorMessage = function (message, openSetting) {
			doNotShowErrorMsg = true;
		}

		var showErrorMessage = function (message, openSetting) {
			if (doNotShowErrorMsg) {
				return true;
			}
			if (message && message.errorMsg) {
				message = "Unable to connect to Internet. Please check your connectivity." + message.errorMsg;
			} else {
				message = isUndefined(message) ? "Something went wrong. Please try again after sometime." : message;
			}	
			if (message == "Conflict") {
				message = "Unable to process now, Please try after sometime.";
			} else if (message == "Incorrect JWT Format") {
				message = "Unable to process now,Please try after sometime.";
			}
			var deferred = $q.defer();
			$ionicPopup.alert({
				title: "",
				template: '<div class="popup-padding font-dark-grey"><div><center><img class="approvedIconPosition" src="img/FT/BhimUpi/errorSymbol.svg"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><span class="popUp-msg-color">'
				+ message + '</span></div></div></div>',
				cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup',

			}).then(function (res) {
				deferred.resolve(res);
				if (res & openSetting) {
					if (typeof cordova.plugins.settings.openSetting != undefined) {
						//cordova.plugins.settings.openSetting("security", function(){
						cordova.plugins.settings.openSetting("settings", function () {

						},
							function () {

							});
					}
				}
			});
			return deferred.promise;
		};


			// @Krishna Singh
			var customAlertPopup = function (params){
				$ionicPopup.alert({
					title: "",
					template: '<div class="customAlertPopupPadding font-dark-grey"><div ng-hide="'+params.icon+'" style="height: 10px;"></div><div><center><img ng-show="'+params.icon+'" class="w-70" src="img/errorImage.png"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><span class="popUp-msg-color">'
					+ params.message + '</span></div></div></div>',
					cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup',
					buttons: [{
						text: params.buttonText ? params.buttonText : 'Ok',
						type: 'button-positive',
						onTap: function () {
							params.redirectUrl ? $state.go(params.redirectUrl) : customAlertPopup.close();
						}
					}]
				})
			}



		// @Krishna Singh
		var confirmPopup = function (popupParams){
		var confirmPopupIonic = $ionicPopup.alert({
			title: "",
			template: '<div class="confirmPopupPadding font-dark-grey"><div><img class="confirmIcon" src="img/errorImage.png"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter mb-20"><span>'
			+ popupParams.message + '</span></div></div></div>',
			cssClass: 'removePopup-head popupWidth90 popupMargin ftpopup-body popupBackgroundWhite textAlignCenter inb-pop-btn confirmPopup ss-popup',
			buttons: [{
				text: popupParams.cancelButtonText ? popupParams.cancelButtonText : 'Cancel',
				type: 'button-positive',
				onTap: function () {
					popupParams.cancelRedirectUrl ? $state.go(popupParams.cancelRedirectUrl) : confirmPopupIonic.close();
				}
			},{
				text: popupParams.confirmButtonText ? popupParams.confirmButtonText : 'Confirm',
				type: 'button-positive',
				onTap: function () {
					popupParams.confirmRedirectUrl ? $state.go(popupParams.confirmRedirectUrl) : confirmPopupIonic.close();
				}
			}]

		})
	}

		/**
		 *  For UPI error(exception) message			
		 * 
		 */
		var showUPIErrorMessage = function (errorCode) {
			switch (errorCode) {
				case -1:
					utilityService.showErrorMessage("GET_ACCESS_TOKEN (-1)");
					break;

				case -2:
					utilityService.showErrorMessage("GET_REFRESH_TOKEN (-2)");
					break;

				case -3:
					utilityService.showErrorMessage("Your session has expired. Please login again.");
					break;

				case -4:
					utilityService.showErrorMessage("TOKEN_FAILED (-4)");
					break;

				case -5:
					utilityService.showErrorMessage("SSL_PINNING_FALIED (-5)");
					break;

				case -6:
					utilityService.showErrorMessage("PSP_HANDSHAKE_FAILED (-6)");
					break;

				case -7:
					utilityService.showErrorMessage("Can not process now, Please try after sometime.");
					break;

				default:
					utilityService.showErrorMessage("Can not process now, Please try after sometime.");
			}
		};

		/**
		 *  For offline message			
		 * 
		 */
		var offlineAlert = function (openSetting) {
			var message = "";
			$translate(['OFFLINE_MSG']).then(function (translations) {
				message = translations['OFFLINE_MSG'];

				$ionicPopup.alert({
					title: "",
					template: '<div class="popupBodyPadding font-dark-grey"><div><img class="approvedIconPosition" src="img/errorImage.png"></div><div translate="ERROR_TITLE" class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'
					+ message + '</span></div></div></div>',
					cssClass: 'removePopup-head popupWidth90 popupMargin ftpopup-body popupBackgroundWhite textAlignCenter',

				}).then(function (res) {

				});
			});
		};

		/**
		 * Returns true if the platform used is Android
		 * @return  {boolean} isAndroidPlatform 
		 */
		var isAndroidPlatform = function () {
			return androidPlatform;
		};

		/**
		 * Returns true if the platform used is iOS
		 * @return  {boolean} isIOSPlatform 
		 */
		var isIOSPlatform = function () {
			return iOSPlatform;
		};

		var getRandomNumber = function (length) {
			var text = "";
			if (null == length) {
				length = parseInt(constantConfig.mfAndsecConst.txnLength);
			}
			var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
			for (var i = 0; i < length; i++)
				text += possible.charAt(Math.floor(Math.random() * possible.length));
			return text;
		}

		//Function for INB exception handling  
		function getServerExceptionMessage(error) {
			var messageToBedisplayed = "";
			if (error.errorCode) {
			if (error.errorCode == "LOGIN_ALREADY_IN_PROCESS") {  
				messageToBedisplayed = utilityService.m001LoginProcess;
				} else if (error.errorCode == 'REQUEST_TIMEOUT') {
					messageToBedisplayed = utilityService.m002RequestTimeout;
				} else if (error.errorCode == 'UNRESPONSIVE_HOST') {
					messageToBedisplayed = utilityService.m003UnResponsiveHost;
				} else if (error.errorCode == 'AUTHORIZATION_FAILURE') {
					messageToBedisplayed  = utilityService.m004AuthFailure ;
				} else if (error.errorCode == 'UNEXPECTED_ERROR') {
					if ((error.errorMsg.indexOf("Unexpected errorCode occurred") !== -1 && error.responseText == "" && error.status == -1) 
						|| error.errorMsg.indexOf("Unable to resolve host") !== -1 
						|| error.errorMsg.indexOf("Handshake failed") !== -1 
						|| error.errorMsg.indexOf("SSL hand-shake aborted") !== -1
						|| error.errorMsg.indexOf("Failed to connect to") !== -1) {
						messageToBedisplayed = constantConfig.adapter.SLOW_OR_NO_CONNECTION;
					} else {
						messageToBedisplayed = utilityService.m005InternalServerError;
					}
				} else if (error.errorCode == 'invalid_client') { 
						messageToBedisplayed = utilityService.m006InvalidClient;
				} else if (error.errorCode == 'APPLICATION_DOES_NOT_EXIST') { 
						messageToBedisplayed = utilityService.m007ApplicationNotExist;


					var upgradePuoup = $ionicPopup.alert({
						title: "",
						template: '<div class="popupBodyPadding font-dark-grey"><div><img class="approvedIconPosition" src="img/errorImage.png"></div><div translate="ERROR_TITLE" class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'
						 + messageToBedisplayed + '</span></div></div></div>',
						cssClass: 'removePopup-head popupWidth90 popupMargin ftpopup-body popupBackgroundWhite textAlignCenter',
						buttons: [{
							text: 'Dismiss',
							type: 'button-positive',
							onTap: function () {
								upgradePuoup.close();
							}
						},{
							text: 'Upgrade',
							type: 'button-positive',
							onTap: function () {
							upgradeApp();
							}
						}]
		
					})


				} else if (error.errorCode == '400') {
					
						messageToBedisplayed = utilityService.m008E400;
				} else if (error.errorCode == '409') {
					
					messageToBedisplayed = utilityService.m009E409;
				} else if (error.errorCode == '500') {
					
					messageToBedisplayed =  utilityService.m010E500;
					
				} else if (error.errorMsg) {
					messageToBedisplayed = error.errorMsg; 
				} else { 
					 
						messageToBedisplayed = utilityService.m011;
				}
				
			} else if (error.errorMsg) {
				messageToBedisplayed = error.errorMsg;
			} else {  
				  	messageToBedisplayed = utilityService.m012;
			}
			
			return messageToBedisplayed.toString();
		}

			/* Application upgrade Functionality */
			var upgrade = function() {
			var url = "https://goo.gl/ccfchV";
			if(!isAndroidPlatform()){
				 url = "https://goo.gl/X6WDiX";
			}	 
			cordova.ThemeableBrowser.open(url, '_system', {
			});
		}	

		var upgradeApp = function() {
			var url = "";
			if(isAndroidPlatform()){
				url = "https://play.google.com/store/apps/details?id=com.sbi.lotusintouch";
				
		   }else{
				url = "https://itunes.apple.com/in/app/yono-sbi-banking-and-lifestyle/id1231393474";
		   }
			cordova.ThemeableBrowser.open(url, '_system', {
			});
		}	

			var showUpgradeMessage = function (message) {
			var deferred = $q.defer();
			$ionicPopup.alert({
				title: "",
				template: '<div class="popupBodyPadding font-dark-grey"><div><img class="approvedIconPosition" src="img/errorImage.png"></div><div translate="ERROR_TITLE" class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'
				+ message + '</span></div></div></div>',
				cssClass: 'removePopup-head popupWidth90 popupMargin ftpopup-body popupBackgroundWhite textAlignCenter',
				buttons: [{
					text: 'Upgrade',
					type: 'button-positive',
					onTap: function () {
					upgrade();
					}
				}]

			}).then(function (res) {
				deferred.resolve(res);		
			});
			return deferred.promise;
		}
		/* End of Application upgrade Functionality */

		/*Utility functions used during connect server call */
		/*Login Flow Improvement*/
		var isJSON = function(data) {
			var ret = true;
			try {
				JSON.parse(data);
			} catch (e) {
				ret = false;
			}
			return ret;
		}

		//Function for set UPI permission key.
		var getUPIPermissions = function(keys) {
			keys = keys != null ? keys.split("^") : { "key1": "", "key2": "" };
			var json = JSON.stringify({
				"key1": keys[2],
				"key2": keys[1]
			});
			getNativeData('getUPISecretKeys', function (data) {
				// Success block
			}, function (error) {
				// Failure block
			}, json);
		};
		/*End of Login Flow Improvement*/
		/*End of Utility functions used during connect server call */

		var commonFunValidateProfilePass = function(options){
			var finalObj = {};
			var saltValue = "|";
			var strCombinedUsername = options.inbUserName + saltValue + options.strPass;

			/*Logic for SHA512 */
			var strSHPass = cryptoService.getSHA512EncryptedData(strCombinedUsername);
			var strSHPassSecond = strSHPass + saltValue + options.keyId;
			var strFinalSH = cryptoService.getSHA512EncryptedData(strSHPassSecond);
			/*Logic for SHA512 */

			/*Logic for MD5 */
			var strMDPass = cryptoService.getMD5EncryptedData(strCombinedUsername);
			var strMDPassSecond = strMDPass + saltValue + options.keyId;
			var strFinalMD = cryptoService.getMD5EncryptedData(strMDPassSecond);
			/*Logic for MD5 */

			/*Convert final MD5 string to SHA512 */
			var strSHPassMD = strFinalMD + saltValue + options.keyId;
			var strFinalSHMD = cryptoService.getSHA512EncryptedData(strSHPassMD);
			/*Convert final MD5 string to SHA512 */

			finalObj["strFinalSH"] = strFinalSH.toString();
			finalObj["strFinalSHMD"] = strFinalSHMD.toString();

			return finalObj;
		}

		var commonRequestForValidateProfilePass = function(options){
			var finalRequest = {};
			var finalSHPassObj = commonFunValidateProfilePass(options);
			finalRequest["sha512Password"] = finalSHPassObj.strFinalSH;
			finalRequest["sha512Ofmd5Pwd"] = finalSHPassObj.strFinalSHMD;
			finalRequest["bankCode"] = constantConfig.commonObj.bankCode;
			finalRequest["channel"] = constantConfig.commonObj.channel;
			finalRequest["cifNo"] = constantConfig.commonObj.cif;
			finalRequest["osName"] = options.osName;
			finalRequest["userName"] = options.inbUserName;
			finalRequest["serviceId"] = options.serviceId;
			if(options.deviceId){
				finalRequest["deviceId"] = options.deviceId;
			}
			if(options.journeyName){
				finalRequest["journeyName"] = options.journeyName;
			}
			if(options.type || options.type === ""){
				finalRequest["type"] = options.type;
			}
			return finalRequest;
		}
		var numberToTime = function(s){
			var m = (s-(s%=60))/60;
			return (9<m?'':'0')+m+(9<s?':':':0')+s;
		}

		var showExitAlertPopup = function(msg){
			if(iOSPlatform){
				msg += '. Please close the application.'
			}
			var showExitPopup = $ionicPopup.show({
				template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src="img/FT/BhimUpi/alertSymbol.svg" /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'
					+ msg + '</span></div></div></div>',
				cssClass: 'bhim-alert-popup',
				buttons: [{
					text: 'OK',
					type: 'button-positive',
					onTap: function(e) {
						if(iOSPlatform){
							showExitPopup.close();
						}
						else {
							ionic.Platform.exitApp();
							navigator.app.exitApp();
						}

					}
				}]
			});
		}

		var showAlertPopUp = function (imageType, message, onTapgo, buttontext, $scope, cssClass) {
			if(imageType && imageType.toLowerCase() == 'error'){
				imageType = 'img/FT/BhimUpi/errorSymbol.svg';
			} else if(imageType && imageType.toLowerCase() == 'success'){
				imageType = 'img/FT/BhimUpi/successSymbol.svg';
			}else{
				imageType = 'img/FT/BhimUpi/alertSymbol.svg';
			}
			var errorMsgPopup = $ionicPopup.alert({
				template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src='+imageType+' /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'
				+ message + '</span></div></div></div>', 
				scope: $scope,
				cssClass: 'bhim-alert-popup '+cssClass,
				buttons: [
					{
						text: buttontext || "OK",
						type: 'button-positive',
						onTap: function () {
							if (onTapgo) {
								$state.go(onTapgo);
							}
						}
					}
				],
			});
			errorMsgPopup.then(function (res) {});
		};

		return {
			isUndefined: isUndefined,
			isArray: isArray,
			isEmpty: isEmpty,
			showSpinner: showSpinner,
			hideSpinner: hideSpinner,
			showAlertModal: showAlertModal,
			showBhimUpiAlert:showBhimUpiAlert,
			showForcePasswordPopup:showForcePasswordPopup,
			showNfsAlertModal:showNfsAlertModal,
			maskData:maskData,
			maskEmail:maskEmail,
			getTextFromDropdown:getTextFromDropdown,
			getAge:getAge,
			amountFormat:amountFormat,
			amtFmtDecml:amtFmtDecml,
			resetAmountFormat:resetAmountFormat,
			clearViewHistory: clearViewHistory,
			clearHistoryExceptCurrentView: clearHistoryExceptCurrentView,
			comingSoon : comingSoon,
			showErrorMessage: showErrorMessage,
			showUpgradeMessage: showUpgradeMessage,
			getValue: getValue,
			isAndroidPlatform: isAndroidPlatform,
			isIOSPlatform: isIOSPlatform,
			offlineAlert: offlineAlert,
			doNotHideSpinner: doNotHideSpinner,
			csatJournies: csatJournies,
			getCsatJournies: getCsatJournies,
			setCsatJournies: setCsatJournies,
			doNotShowSpinner: doNotShowSpinner,
			enableShowErrorMessage: enableShowErrorMessage,
			disableShowErrorMessage: disableShowErrorMessage,
			getRandomNumber: getRandomNumber,
			timeSpent: timeSpent,
			lastTimeStamp: lastTimeStamp,
			accessRestricted: accessRestricted,
			mPinAuthRequire: mPinAuthRequire,
			AOAuthRequired: AOAuthRequired,
			getServerExceptionMessage: getServerExceptionMessage,
			upgrade: upgrade,
			upgradeApp: upgradeApp,
			isJSON: isJSON,
			getUPIPermissions: getUPIPermissions,
			commonFunValidateProfilePass:commonFunValidateProfilePass,
			commonRequestForValidateProfilePass:commonRequestForValidateProfilePass,
			confirmPopup:confirmPopup,
			customAlertPopup:customAlertPopup,
			numberToTime:numberToTime,
			showExitAlertPopup:showExitAlertPopup,
			showAlertPopUp:showAlertPopUp
		};
	});
