'use strict';

//The angular app is initialized from here
var angularApp = angular.module('app', ['ngSanitize', 'pascalprecht.translate', 'ionic', 'ngAnimate', 'ui.router', 'ngCordova', 'rzModule', 'ionic-datepicker', 'ion-floating-menu', 'angularjs-dropdown-multiselect', 'ionic-toast', 'angular.filter', 'utf8-base64', 'nzToggle','ionic-pullup','ionic-monthpicker','ngDraggable',  'ion-digit-keyboard','morphCarousel','ui.bootstrap']);

angularApp.init = function () {
	angular.bootstrap(document, ['app']);
};

angularApp.config(function (ionicDatePickerProvider) {
	var datePickerObj = {
		inputDate: new Date(),
		titleLabel: 'Select a Date',
		setLabel: 'OK',
		closeLabel: 'Back',
		mondayFirst: false,
		weeksList: ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"],
		monthsList: ["JANUARY", "FEBRUARY", "MARCH", "APRIL", "MAY", "JUNE", "JULY", "AUGUST", "SEPTEMBER", "OCTOBER", "NOVEMBER", "DECEMBER"],
		templateType: 'popup',
		showTodayButton: false,
		dateFormat: 'dd MMM yyyy',
		closeOnSelect: false,
		disableWeekdays: []
	};
	ionicDatePickerProvider.configDatePicker(datePickerObj);
});
angularApp.run(function ($ionicPlatform, $state, $rootScope, $ionicPopup, AdapterUtils, utilityService, internetBankingService, loggedInUserService, keyGuardService, ConnectivityMonitorUtils, constantConfig,$translate,agriMandiService,mPinLoginService,ompOffersService,homeScreenService, irctcService) {
	if(ionic.Platform.isIPad()){
		var viewport = document.querySelector("meta[name=viewport]");
		viewport.setAttribute('content', 'user-scalable=no, initial-scale=0.85, maximum-scale=1, minimum-scale=0.85, width=device-width');
	}
	var that = this;
	// Android back button handling
	$rootScope.initialLocation = window.location.href;

	$rootScope.$on('$stateChangeStart', 
	function(event, toState, toParams, fromState, fromParams){
	    if(toParams.agri)
	    {
	    	$translate.use(agriMandiService.selectLanguage);
	    }
	    else
	    {
	    	$translate.use('en');
	    }
	});

	$ionicPlatform.registerBackButtonAction(function () {
		var backPopup = $ionicPopup.show({
			title: null,
			cssClass: 'my-custom-popup',
			template: '<div class="button_fund fontSize-subHeading roboto-light font-dark-grey" translate="EXIT_APP"></div>',
			scope: that,
			buttons: [{
				text: 'YES',
				type: 'button-assertive',
				onTap: function () {
					loggedInUserService.exitApplication();
				}
			},
			{
				text: 'NO',
				type: 'button-assertive',
				onTap: function () {
					backPopup.close();
				}
			}],
		});

	}, 100);

	var db=null;
	if (utilityService.isAndroidPlatform()) {
		db = window.sqlitePlugin.openDatabase({
											  name: 'my.db',
											  location:'default',
											  });
		
		} else {
		db = window.sqlitePlugin.openDatabase({name: 'my.db', iosDatabaseLocation: 'Library'});
	}
	
	/* Push notification initialization */
	var initiliazePush = function () {
		// Push notification handling in case app is not opened from notification, assuming app will initialize completely in 4 seconds, 
		// giving notification receiver enough time to handle incoming data otherwise.
		setTimeout(function () {
			localStorage.setItem('showNotification', 'false')
		}, 4000);
		irctcService.pushNotificationData = '';
		try {
			MFPPush.initialize(
				function (successResponse) {
					WL.Logger.debug("Successfully intialized");
					MFPPush.registerNotificationsCallback($rootScope.notificationReceived);
					$state.go('menu.landingPage');
				}, function (failureResponse) {
					WL.Logger.debug("Failed to initialize");
					$state.go('menu.landingPage');
				});
		}
		catch (err) {
			console.log(err);
		}

	
}

	function formatDate(date) {
		var d = new Date(date),
			month = '' + (d.getMonth() + 1),
			day = '' + d.getDate(),
			year = d.getFullYear();
		if (month.length < 2) month = '0' + month;
		if (day.length < 2) day = '0' + day;
		return [year, month, day].join('-');
	}

	function redirectToOfferPage(){
		ompOffersService.fromPush=true;
		ompOffersService.notificationRecieved=true;
		if(ompOffersService.fromPush)
		{
			ompOffersService.fromPush=false;
			if(mPinLoginService.isLoggedIn === true){
				ompOffersService.notificationRecieved=false;
			}
			else{
				homeScreenService.menuOption="ompOffers";
				if (homeScreenService.dummymenuCheck == true) {
					$state.go('menu.menudummy');
				}
				else {
					$state.go('menu.ompOffers');
				}
			}
		} 
			else{
			$state.go('menu.landingPage');
			}
	}
	function redirectToIRCTCPage(payload) {
		irctcService.pushNotificationData = payload;
		ompOffersService.irctcNotificationRecieved = true;
		ompOffersService.fromPush = false;
		const showNotification = localStorage.getItem('showNotification');
		console.log('Do we show notifcation: ' + showNotification);
		if (mPinLoginService.isLoggedIn === true) {
			utilityService.hideSpinner();
			ompOffersService.irctcNotificationRecieved = false;
		}
		else {
			homeScreenService.menuOption = "irctcNotification";
			utilityService.hideSpinner();
			if (payload.isTargeted) {
				irctcService.selTab = "Y";

			}
		}

	}

	function initDatabase(data) {
		utilityService.showSpinner();
		if (data && "string" == typeof (data.payload)) {
			data.payload = JSON.parse(data.payload);
		}
		// if (pushData.startsWith("RTXCDXC")) {
		// 	rxtcService.rtxcPush = true;
		// 	rxtcService.setPushData(data.alert);
		// 	redirectRTXCPage();
		if (data.payload && (data.payload.fromStn!=undefined && data.payload.fromStn!= null && data.payload.fromStn!="")) {
			setTimeout(function () {
				redirectToIRCTCPage(data.payload);
			}, 1000);
		} else {
			db.transaction(function (transaction) {
				transaction.executeSql('CREATE TABLE IF NOT EXISTS OfferTable (headerTxt, logoUrl,headerDetails,expiryDate date,redirectUrl,tnc,nid,buttonTxt,promoCode,publishDate,categoryCode,categoryTitle)', [], function () {
					utilityService.hideSpinner();
					var payloadDataFormat = data.payload;
					var payloadData = JSON.parse(JSON.stringify(payloadDataFormat).replace(/\\/g, ""));
					var currentDate = formatDate(new Date());
					if (payloadData.isTargeted) {
						if (payloadData.expiryDate < currentDate) {
							ompOffersService.isOfferExpired = true;
							redirectToOfferPage();
						}
						else {
							utilityService.showSpinner();
							db.transaction(function (transaction) {
								transaction.executeSql('INSERT INTO OfferTable VALUES (?,?,?,?,?,?,?,?,?,?,?,?)', [payloadData.headerTxt, payloadData.logoUrl, payloadData.headerDetails, payloadData.expiryDate, payloadData.redirectUrl, payloadData.tnc, payloadData.nid, payloadData.buttonTxt, payloadData.promoCode, payloadData.publishDate, payloadData.categoryCode, payloadData.categoryTitle], function () {
									utilityService.hideSpinner();
									redirectToOfferPage();
								});
							}, function (error) {
								utilityService.hideSpinner();
							});
						}
					}
					else if (payloadData.isTargeted === false) {
						if (payloadData.expiryDate < currentDate) {
							ompOffersService.isOfferExpired = true;
						}
						redirectToOfferPage();
					}
				});
			}, function (error) {
				utilityService.hideSpinner();
			});
		}
		// Push notification handling in case notification is not IRCTC
		setTimeout(function () {
			localStorage.setItem('showNotification', 'false');
		}, 2000);
	}

	$rootScope.notificationReceived = function (data) {
		utilityService.showSpinner();
		homeScreenService.dummymenuCheck = true;
		utilityService.hideSpinner();
		initDatabase(data);
	}

	initiliazePush();
	
	
/*End Push notification initialization */
	
	cordova.plugins.Keyboard.disableScroll(true);
	if (device.platform != "windows") {
		cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
	}
});