
var Messages = {
	// Add here your messages for the default language.
	// Generate a similar file with a language suffix containing the translated messages.
	// key1 : message1,
};

var wlInitOptions = {
	// Options to initialize with the WL.Client object.
	// For initialization options please refer to IBM MobileFirst Platform Foundation Knowledge Center.
};

function wlCommonInit() {
	app.init(); //mobilefirst init
	// Code for certificate-pinning
	WL.Client.pinTrustedCertificatePublicKey(["mobilesbiyononewder.crt","mobilesbiyono.der"]).then(function(){}, function(error){ });
	var options = {
		capture: false,
		autoSendLogs: false
	};
	WL.Logger.config(options);
	WL.Analytics.disable().then(function () {
		console.log("Analytics Disabled");
	}).fail(function (error) {
		console.log("Analytics Failure" + error);
	});
}

var app = {
	//initialize app
	"init": function init() {
		console.log("MobileFirst Platform 8.0 has been initialized");
		document.addEventListener('deviceready', this.onDeviceReady, false);
		// Push notification handling
		document.addEventListener('resume', this.onDeviceResume, false);
	},
	onDeviceReady: function () {
		/*Keeping the alignment consistent even after font size is changed through OS level */
		if (window.MobileAccessibility) {
			window.MobileAccessibility.usePreferredTextZoom(false);
		}
		angularApp.init();
		IonicDeeplink.route({
			'/openInYono': '/openInYono'
		}, function (match) {
			localStorage.setItem('reraId', '');
			var str = '';
			var params = match.$args;
			if (params.hasOwnProperty('reraId')) {
				// if redirection params contain the key for rera id
				str = params.reraId;
				str = decodeURI(str);
  if(str){
  localStorage.setItem('reraId', str);
  localStorage.setItem('isRedirectedTowdsLoan', "false");
				} else {
				// in case of no rera id user will still be redirected to loans page
				localStorage.setItem('redirectOnlyFlow', "true");
  }
			}
			
		}, function (nomatch) {
			// do nothing
		});
		// Push notification handling, handle notification when app is fresh starting
		localStorage.setItem('showNotification', 'true');	
	},
	// Push notification handling
	onDevicePause: ()  => {
		localStorage.setItem('showNotification', 'true');
	},
	onDeviceResume: ()  => {
		// showNotification will stay true for 2 sec after resume, 
		// giving notification handler enough time to handle encoming data in case app resumed from notification click.
		setTimeout(function() {localStorage.setItem('showNotification', 'false')}, 2000);
	}
}

function handleOpenURL(url) {
	// do nothing
}
//Function for UPI sdk call
function getNativeData(type, successCallback, failureCallback, data) {
	console.log("Request  : " + type);
	if (data === undefined) {
		data = '';
	}
	cordova.exec(successCallback, failureCallback, "Upisdk", type, [data]);
}

//Function for random number generation with prefix - "SBI"
function generateRandomString(length) {
	var text = "";
	var charSet = "ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890"
	for (var i = 0; i < length; i++) {
		text += charSet.charAt(Math.floor(Math.random() * charSet.length))
	}
	return "SBI" + text;
}

window.addEventListener('native.keyboardhide', function () {
	var footer = document.getElementsByClassName("button-footer");
	var hasFooter = document.getElementsByClassName("has-footer");
	var appfooter = document.getElementsByClassName("app-footer");
	var bhimfooter = document.getElementsByClassName("bhim-footer");
	var len = appfooter.length;
	if (len > 0) {
		for (var j = 0; j < len; j++) {
			appfooter[j].style.display = 'block';
		}
	}
	len = footer.length;
	if (len > 0) {
		for (var i = 0; i < len; i++) {
			footer[i].style.display = 'block';
		}
	}
	var len = hasFooter.length;
	if (len > 0) {
		for (var k = 0; k < len; k++) {
			hasFooter[k].style.bottom = "44px";
		}
	}
		var len = bhimfooter.length;
	if (len > 0) {
		for (var l = 0; l < len; l++) {
			bhimfooter[l].style.display = 'block';
		}
	}
});

window.addEventListener('native.keyboardshow', function () {
	var footer = document.getElementsByClassName("button-footer");
	var hasFooter = document.getElementsByClassName("has-footer");
	var appfooter = document.getElementsByClassName("app-footer");
	var bhimfooter = document.getElementsByClassName("bhim-footer");
	var len = appfooter.length;
	if (len > 0) {
		for (var j = 0; j < len; j++) {
			appfooter[j].style.display = 'none';
		}
	}
	len = footer.length;
	if (len > 0) {
		for (var i = 0; i < len; i++) {
			footer[i].style.display = 'none';
		}
	}
	len = hasFooter.length;
	if (len > 0) {
		for (var k = 0; k < len; k++) {
			hasFooter[k].style.bottom = "0px";
		}
	}
		var len = bhimfooter.length;
	if (len > 0) {
		for (var l = 0; l < len; l++) {
			bhimfooter[l].style.display = 'none';
		}
	}
});
