'use strict';

angularApp.controller('MPINController', ["$state",
    "$scope",
    "aoMpinService",
    "aoService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        aoMpinService,
        aoService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var mPINVm = this;

        function initPage() {
        }

        mPINVm.goBacktoPrevious = function() {
            $state.go('menu.netBankingRegister'); 
        }

        mPINVm.goToNextPage = function() {
            
                 var requestParams = {
                "accountMpin" : mPINVm.concatMpinData(),
                "lotusId" : aoService.customer.lotusId
            }
            aoMpinService.setAccountMpin(requestParams).then(function(response) {
                    $state.go('menu.addFundsOptions');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        mPINVm.comparePins = function(isValid){
            var enterPin = mPINVm.concatMpinData();
            var reEnterPin = mPINVm.concatReMpinData();
            if(enterPin === reEnterPin && isValid == true){
                mPINVm.showErrorMsg = false;
                mPINVm.goToNextPage();
            }
            else{
                mPINVm.showErrorMsg = true;
            }
        }

        mPINVm.focusPin = function(){
                mPINVm.accountReMpinOne = "";
                mPINVm.accountReMpinTwo = "";
                mPINVm.accountReMpinThree = "";
                mPINVm.accountReMpinFour = "";
                mPINVm.accountReMpinFive = "";
                mPINVm.accountReMpinSix = "";
        }

        mPINVm.concatMpinData = function(){
            var clubbedData = "";
            clubbedData = mPINVm.accountMpinOne + mPINVm.accountMpinTwo + mPINVm.accountMpinThree + mPINVm.accountMpinFour + mPINVm.accountMpinFive + mPINVm.accountMpinSix;
            return clubbedData;
        }

        mPINVm.concatReMpinData = function(){
            var reclubbedData = "";
            reclubbedData = mPINVm.accountReMpinOne + mPINVm.accountReMpinTwo + mPINVm.accountReMpinThree + mPINVm.accountReMpinFour + mPINVm.accountReMpinFive + mPINVm.accountReMpinSix;
            return reclubbedData;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);   
        });

        return this;
    }
]);
