'use strict';

angularApp.controller('VIDDetailsController', ["$state",
    "$scope",
    "VIDDataService",
    "aoService",
    "utilityService",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "$translate",

    function($state,
        $scope,
        VIDDataService,
        aoService,
        utilityService,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService,
        $translate) {

        var VIDDetailsVm = this;

        function initPage() {
            VIDDetailsVm.showBack = true;
            VIDDetailsVm.showNext = true;
            VIDDetailsVm.disableNext = true;
            VIDDetailsVm.aofooter = true;
            VIDDetailsVm.otpNumberInput = true;
            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                VIDDetailsVm.okBtntext = translatedvalue;
            });
            VIDDetailsVm.isSubmitNotTapped  = true;    
        }

        VIDDetailsVm.goBacktoPrevious = function() {
            $state.go('menu.personalDetails');            
        }

        VIDDetailsVm.goToNextPage = function() {
            //$state.go('menu.instaKit_pdetailsAN');
            VIDDetailsVm.getAadharDetails();
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        VIDDetailsVm.updateAadhaarNumber = function(){
            if(aoService.customerAadhaarCardDetails.vid){
                VIDDetailsVm.vidnumber = aoService.customerAadhaarCardDetails.vid;
            }
        }

        VIDDetailsVm.checkFormValid = function(isValid){
            if(isValid){
                VIDDetailsVm.disableNext = false;
            }
            else{
                VIDDetailsVm.disableNext = true;
            }
        }


        VIDDetailsVm.generateAadharOtp = function(isResendClicked) {
        	if(!isResendClicked){
 		       	VIDDetailsVm.isSubmitNotTapped = false;	
        	}
			VIDDataService.aadhrOTPattempt = VIDDataService.aadhrOTPattempt  +1 ;
        	if(VIDDataService.aadhrOTPattempt > 5 && isResendClicked){
        		return true;
        	}
            VIDDetailsVm.getOTPNumber = "";
            var requestParams = {
            	"vidNumber" : VIDDetailsVm.vidnumber ? VIDDetailsVm.vidnumber : "",
                "aadharNumber": "",
				"udiType" : "2"
            };
            VIDDataService.generateAadharOtp(requestParams).then(function(response) {
            	if(response.data.status == "0"){                
                	var title = '';
                    var template = '{{"OTP_SUCCESS" | translate}}';
                    var onTap = '';
                    var buttontext = '<b>' + VIDDetailsVm.okBtntext + '</b>';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                    VIDDetailsVm.otpNumberInput = false;    
               }
               else if(response.data.status == "-1" || response.data.status == "-2"){                
                    var title = '';
                    var template = response.data.details;//'{{"SERVICE_ERR_MSG" | translate}}';
                    var onTap = '';
                    var buttontext = '<b>' + VIDDetailsVm.okBtntext + '</b>';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
               }
               else{                    
                    var title = '';
                    var template = '{{"SERVICE_ERR_MSG" | translate}}';
                    var onTap = '';
                    var buttontext = '<b>' + VIDDetailsVm.okBtntext + '</b>';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
               }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage); 
            });
        };

        VIDDetailsVm.getAadharDetails = function() {
        	var requestParams = {
                "aadharNumber": "",//VIDDetailsVm.aadhaarnumber,
                "vidNumber": VIDDetailsVm.vidnumber,
                "otp": VIDDetailsVm.getOTPNumber,
                "uidType" : "2"
            }
            VIDDataService.getEKycOTPSecure(requestParams).then(function(response) {
                var aadharDetails = response.data;
                if(!utilityService.isUndefined(response.data)){
                        aoService.isAadharManualEntry = true;
	                    aoService.customerAadhaarCardDetails = {
				                uid: "",
				                name: "",
				                firstName: "",
				                middleName: "",
				                lastName: "",
				                gender: "",
				                title: "",
				                yob: "",
				                co: "",
				                house: "",
				                street: "",
				                lm: "",
				                loc: "",
				                vtc: "",
				                po: "",
				                dist: "",
				                subdist: "",
				                state: "",
				                pc: "",
				                dob: "",
				                isAadharScanned: false,
				                locality: "",
				                addressLine1: "",
				                addressLine2: ""
				            }
				            aoService.isVID = true;
				            aoService.customerAadhaarCardDetails.uid = response.data.kycResponse.uidData.aadharNumber;
				            $state.go('menu.aadhaarManualEntry');
                }
                else{
                    var title = '';
                    var template = '{{"INVALID_OTP" | translate}}';
                    var onTap = '';
                    var buttontext = '<b>' + VIDDetailsVm.okBtntext + '</b>';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                }              
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage); 
            });
        };

             
               
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            VIDDetailsVm.updateAadhaarNumber();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });
        return this;
    }
]);