'use strict';

angularApp.service('aadhaarManualAddressService',
    function($q, AdapterUtils, constantConfig) {
        var aadhaarManualAddressService = this;

        //Get City and Country based on Pincode input parameter
        aadhaarManualAddressService.getAreaDetailForPincode = function(inputparams) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.getPostalDetailByPinCode , inputparams, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        //Update Correspondence address when aadhaar address is not matching with the user's current address
        aadhaarManualAddressService.updateCorrespondenceAddress = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.updateCorrespondenceAddress, requestData, true).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        //Update user aadhaar details
        aadhaarManualAddressService.updateAadhaarDetails = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.adharcard, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        //Load Title List
        aadhaarManualAddressService.getTitleList = function(requestData) {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.loadMasterData + requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        //Load gender
        aadhaarManualAddressService.getGenderList = function(requestData) {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.loadMasterData + requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        return aadhaarManualAddressService;
    });
