'use strict';

angularApp.controller('aadhaarManualEntryAddressController', ["$state",
    "$scope",
    "$ionicHistory",
    "aoService",
    "aadhaarManualAddressService",
    "utilityService",
    "$translate",
    "constantConfig",

    function($state,
        $scope,
        $ionicHistory,
        aoService,
        aadhaarManualAddressService,
        utilityService,
        $translate,
        constantConfig) {

        var aadhaarManualAddressVm = this;

        function initPage() {
            aadhaarManualAddressVm.showBack = true;
            aadhaarManualAddressVm.showNext = true;
            aadhaarManualAddressVm.disableNext = true;
            aadhaarManualAddressVm.aofooter = true;
            aadhaarManualAddressVm.disableCity = true;
            aadhaarManualAddressVm.disableState = true;
            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                aadhaarManualAddressVm.okBtntext = translatedvalue;
            });
        }

        aadhaarManualAddressVm.goBacktoPrevious = function() {
            aoService.isCustManualCorresChkBox = false;
            $state.go("menu.aDCityCountry");
        }

        /* Functionality : Watch the form for validation
           Conditions : If(In resume journey, all data comes populated in the fields[Form is valid] and therefore "Next" button will be enabled)
           Else(If the form is invalid, disable "Next" button)
        */
        $scope.$watch("aadhaarManualAddressVm.aadharManualEntryAddressForm.$valid", function(value) {
            if(value === true){
                aadhaarManualAddressVm.disableNext = false;
            } else {
                aadhaarManualAddressVm.disableNext = true;
            }
        });

        /* Functionality : Set the request parameters and post the data on click of "next" button */
        aadhaarManualAddressVm.goToNextPage = function() {
            aoService.aadhaarManualPermanentAddress.address1 = aadhaarManualAddressVm.addressAboveData;
            aoService.aadhaarManualPermanentAddress.address2 = aadhaarManualAddressVm.addressBelowData;
            aoService.aadhaarManualPermanentAddress.pincode = aadhaarManualAddressVm.pincodeData;
            aoService.aadhaarManualPermanentAddress.city = aadhaarManualAddressVm.cityData;
            aoService.aadhaarManualPermanentAddress.state = aadhaarManualAddressVm.stateData;
            aoService.aadhaarManualPermanentAddress.locality = aadhaarManualAddressVm.localityData;

            var requestParams = {
                "id": aoService.customer.mobileNo,
                "data": {
                    "personalDetails": {
                        "uid": aoService.customerManualEntryDetails.aadharNumber,
                        "name": aoService.customerManualEntryDetails.fullName,
                        "firstName": aoService.customerManualEntryDetails.firstName,
                        "middleName": aoService.customerManualEntryDetails.middleName,
                        "lastName": aoService.customerManualEntryDetails.lastName,
                        "title": aoService.customerManualEntryDetails.title,
                        "gender": aoService.customerManualEntryDetails.gender,
                        "dob": aoService.customerManualEntryDetails.dob,
                        "isAadhaarScanned": false,     
                        "nationality":aoService.customerAdditionalDetails.nationality,
                        "nationalityCode":aoService.customerAdditionalDetails.nationalityID,
                        "citizenship": aoService.customerAdditionalDetails.citizenship,
                        "citizenshipCode": aoService.customerAdditionalDetails.citizenshipID,
                        "cityOfBirth": aoService.customerAdditionalDetails.cityOfBirth,
                        "placeOfBirth": aoService.customerAdditionalDetails.cityOfBirth,
                        "countryOfBirth": aoService.customerAdditionalDetails.countryOfBirth,                   
                        "additionalDetails":{
                            "cityOfBirth": aoService.customerAdditionalDetails.cityOfBirth,
                            "placeOfBirth": aoService.customerAdditionalDetails.cityOfBirth,
                            "countryOfBirth": aoService.customerAdditionalDetails.countryOfBirth
                        },
                        "address": [{
                            "type": "aadhaar",
                            "addressLine1": aoService.aadhaarManualPermanentAddress.address1,
                            "addressLine2": aoService.aadhaarManualPermanentAddress.address2,
                            "pincode": aoService.aadhaarManualPermanentAddress.pincode,
                            "city": aoService.aadhaarManualPermanentAddress.city,
                            "cityCode":"",
                            "state": aoService.aadhaarManualPermanentAddress.state,
                            "stateCode":"",
                            "locality": aoService.aadhaarManualPermanentAddress.locality
                        }]
                    },
                    "commonId": $state.$current.data.commonId
                }
            }
            aadhaarManualAddressService.updateAadhaarDetails(requestParams).then(function(response) {
                if (response.responseCode === constantConfig.successCode) {
                    $state.go('menu.panDetails');
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        /* Event : Click on cross icon in the page (Close account opening module) */
        $scope.goToHome = function() {
            aoService.homeNav();
        }

        /* Functionality : Enable or disable next button on change of every field in the form to check for validation
           Event : On Change of the form field
           Parameter : param - Form validity whether it is valid or not
           Returns : param - true / false
        */
        aadhaarManualAddressVm.changefn = function(param) {
            aadhaarManualAddressVm.disableNext = !param;
        }

        /* Functionality : Enable or disable next button on change of every field in the form to check for validation
           Parameter : param - Form validity whether it is valid or not
           Returns : param - true / false
        */
        aadhaarManualAddressVm.updatedvalue = function(param) {
            (param) ? aadhaarManualAddressVm.disableNext = false: aadhaarManualAddressVm.disableNext = true;
            return aadhaarManualAddressVm.disableNext;
        }

        /* Functionality : Service to return city and state based on the pincode entered
           Event : On change of pincode
        */
        aadhaarManualAddressVm.updatearea = function(param) {
            var inputparams = {
                "pinCode": aadhaarManualAddressVm.pincodeData
            }
            if (aadhaarManualAddressVm.aadharManualEntryAddressForm.pincode.$valid === true && !utilityService.isUndefined(aadhaarManualAddressVm.pincodeData)) {
                aadhaarManualAddressService.getAreaDetailForPincode(inputparams).then(function(data) {
                    if (utilityService.isUndefined(data)) {
                        var title = '';
                        var template = '{{"PINCODE_MATCH" | translate}}';
                        var onTap = '';
                        var buttontext = '<b>' + aadhaarManualAddressVm.okBtntext + '</b>';
                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                        aadhaarManualAddressVm.disableState = false;
                        aadhaarManualAddressVm.disableCity = false;
                    } else{
                        aoService.customer.city = utilityService.getValue(data.cityName);
                        aoService.customer.state = utilityService.getValue(data.stateName);
                        aadhaarManualAddressVm.cityData = aoService.customer.city;
                        aadhaarManualAddressVm.stateData = aoService.customer.state;
                        aadhaarManualAddressVm.disableCity = true;
                        aadhaarManualAddressVm.disableState = true;

                    }
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else if (aadhaarManualAddressVm.pincodeData === "" || (!utilityService.isUndefined(aadhaarManualAddressVm.pincodeData)).length != 6) {
                aadhaarManualAddressVm.cityData = "";
                aadhaarManualAddressVm.stateData = "";
            }

        }

        /* Functionality : Check for city and state validation
           Event : On Blur
        */
        aadhaarManualAddressVm.checkUpdatedCityStateValid = function(param) {
            aadhaarManualAddressVm.updatedvalue(param);
        }

        /* Functionality : Auto populate the data
           Event : On load
        */
        aadhaarManualAddressVm.populateResumeData = function() {
            aadhaarManualAddressVm.addressAboveData = aoService.aadhaarManualPermanentAddress.address1;
            aadhaarManualAddressVm.addressBelowData = aoService.aadhaarManualPermanentAddress.address2;
            aadhaarManualAddressVm.pincodeData = aoService.aadhaarManualPermanentAddress.pincode;
            aadhaarManualAddressVm.cityData = aoService.aadhaarManualPermanentAddress.city;
            aadhaarManualAddressVm.stateData = aoService.aadhaarManualPermanentAddress.state;
            aadhaarManualAddressVm.localityData = aoService.aadhaarManualPermanentAddress.locality;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            if(aoService.isResumeJourney == true)
            aadhaarManualAddressVm.populateResumeData();
        });

        return this;
    }
]);
