'use strict';

angularApp.controller('aadhaarManualEntryCAddressController', ["$state",
    "$scope",
    "$ionicHistory",
    "aoService",
    "aadhaarManualAddressService",
    "utilityService",
    "$translate",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        $ionicHistory,
        aoService,
        aadhaarManualAddressService,
        utilityService,
        $translate,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var aadhaarManualCaddressVm = this;

        function initPage() {
            aadhaarManualCaddressVm.showBack = true;
            aadhaarManualCaddressVm.showNext = true;
            aadhaarManualCaddressVm.disableNext = true;
            aadhaarManualCaddressVm.aofooter = true;
            aadhaarManualCaddressVm.disableCity = true;
            aadhaarManualCaddressVm.disableState = true;
            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                aadhaarManualCaddressVm.okBtntext = translatedvalue;
            });
        }

        aadhaarManualCaddressVm.goBacktoPrevious = function() {
            aoService.isCustManualCorresChkBox = true;
            $state.go("menu.aDCityCountry");
        }

        /* Functionality : Watch the form for validation
           Conditions : If(In resume journey, all data comes populated in the fields[Form is valid] and therefore "Next" button will be enabled)
           Else(If the form is invalid, disable "Next" button)
        */
        $scope.$watch("aadhaarManualCaddressVm.aadharManualEntryCAddressForm.$valid", function(value) {
            if (value === true) {
                aadhaarManualCaddressVm.disableNext = false;
            } else {
                aadhaarManualCaddressVm.disableNext = true;
            }
        });

        /* Functionality : Set the request parameters and post the data on click of "next" button */
        aadhaarManualCaddressVm.goToNextPage = function() {
            aoService.aadhaarManualCorrespondenceAddress.address1 = aadhaarManualCaddressVm.addressAboveData;
            aoService.aadhaarManualCorrespondenceAddress.address2 = aadhaarManualCaddressVm.addressBelowData;
            aoService.aadhaarManualCorrespondenceAddress.pincode = aadhaarManualCaddressVm.pincodeData;
            aoService.aadhaarManualCorrespondenceAddress.city = aadhaarManualCaddressVm.cityData;
            aoService.aadhaarManualCorrespondenceAddress.state = aadhaarManualCaddressVm.stateData;
            aoService.aadhaarManualCorrespondenceAddress.locality = aadhaarManualCaddressVm.localityData;

            var requestParams = {
                "id": aoService.customer.mobileNo,
                "data": {
                    "personalDetails": {
                        "uid": aoService.customerManualEntryDetails.aadharNumber,
                        "name": aoService.customerManualEntryDetails.fullName,
                        "firstName": aoService.customerManualEntryDetails.firstName,
                        "middleName": aoService.customerManualEntryDetails.middleName,
                        "lastName": aoService.customerManualEntryDetails.lastName,
                        "title": aoService.customerManualEntryDetails.title,
                        "titleCode":aoService.customerManualEntryDetails.titleCode,
                        "gender": aoService.customerManualEntryDetails.gender,
                        "genderCode":aoService.customerManualEntryDetails.genderCode,
                        "dob": aoService.customerManualEntryDetails.dob,
                        "isAadhaarScanned": false,
                        "scannedCorrespondenceAddFlag": aoService.isCustManualCorresChkBox,
                        "emailId" : aoService.customer.emailId,
                        "mobileNumber" : aoService.customer.mobileNo,
                        "nationality":aoService.customerAdditionalDetails.nationality,
                        "nationalityCode":aoService.customerAdditionalDetails.nationalityID,
                        "citizenship": aoService.customerAdditionalDetails.citizenship,
                        "citizenshipCode": aoService.customerAdditionalDetails.citizenshipID,
                         "cityOfBirth": aoService.customerAdditionalDetails.cityOfBirth,
                        "placeOfBirth": aoService.customerAdditionalDetails.cityOfBirth,
                        "countryOfBirth": aoService.customerAdditionalDetails.countryOfBirth,
                        "address": [{
                            "type": "CORRESPONDENCE",
                            "addressLine1": aoService.aadhaarManualCorrespondenceAddress.address1,
                            "addressLine2": aoService.aadhaarManualCorrespondenceAddress.address2,
                            "pincode": aoService.aadhaarManualCorrespondenceAddress.pincode,
                            "city": aoService.aadhaarManualCorrespondenceAddress.city,
                            "cityCode":aoService.aadhaarManualCorrespondenceAddress.cityCode,
                            "state": aoService.aadhaarManualCorrespondenceAddress.state,
                            "stateCode":aoService.aadhaarManualCorrespondenceAddress.stateCode,
                            "locality": aoService.aadhaarManualCorrespondenceAddress.locality,
							"district":aoService.aadhaarManualCorrespondenceAddress.district,
                            "districtCode": aoService.aadhaarManualCorrespondenceAddress.districtCode
                        }]
                    },
                    "additionalDetails":{
                        "cityOfBirth": aoService.customerAdditionalDetails.cityOfBirth,
                        "placeOfBirth": aoService.customerAdditionalDetails.cityOfBirth,
                        "countryOfBirth": aoService.customerAdditionalDetails.countryOfBirth
                    },
                    "commonId": $state.$current.data.commonId
                }
            }

            aadhaarManualAddressService.updateAadhaarDetails(requestParams).then(function(response) {
                if (response.responseCode === constantConfig.successCode) {
                    	$state.go('menu.panDetails');
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        /* Event : Click on cross icon in the page (Close account opening module) */
        $scope.goToHome = function() {
            aoService.homeNav();
        }

        /* Functionality : Enable or disable next button on change of the field in the form to check for validation
           Event : On Change of the form field
           Parameter : param - Form validity whether it is valid or not
           Returns : param - true / false
        */
        aadhaarManualCaddressVm.changefn = function(param) {
            aadhaarManualCaddressVm.disableNext = !param;
        }

        /* Functionality : Enable or disable next button on change of the field in the form to check for validation
           Parameter : param - Form validity whether it is valid or not
           Returns : param - true / false
        */
        aadhaarManualCaddressVm.updatedvalue = function(param) {
            (param) ? aadhaarManualCaddressVm.disableNext = false: aadhaarManualCaddressVm.disableNext = true;
            return aadhaarManualCaddressVm.disableNext;
        }

        /* Functionality : Service to return city and state based on the pincode entered
           Event : On change of pincode
        */
        aadhaarManualCaddressVm.updatearea = function(param) {
            var inputparams = {
                "pinCode": aadhaarManualCaddressVm.pincodeData
            }
            if (aadhaarManualCaddressVm.aadharManualEntryCAddressForm.pincode.$valid === true && !utilityService.isUndefined(aadhaarManualCaddressVm.pincodeData)) {
                aadhaarManualAddressService.getAreaDetailForPincode(inputparams).then(function(data) {
                    if (utilityService.isUndefined(data)) {
                        var title = '';
                        var template = '{{"PINCODE_MATCH" | translate}}';
                        var onTap = '';
                        var buttontext = '<b>' + aadhaarManualCaddressVm.okBtntext + '</b>';
                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                        aadhaarManualCaddressVm.disableState = false;
                        aadhaarManualCaddressVm.disableCity = false;
                        aadhaarManualCaddressVm.stateList = "";
                    } else{
                    	aadhaarManualCaddressVm.stateList = data;
                        aoService.customer.city = utilityService.getValue(data.cityName);
                        aoService.customer.state = utilityService.getValue(data.stateName);
                        aoService.aadhaarManualCorrespondenceAddress.cityCode = utilityService.getValue(data.cityCode);
                        aoService.aadhaarManualCorrespondenceAddress.stateCode = utilityService.getValue(data.stateCode);
                        aadhaarManualCaddressVm.cityData = aoService.customer.city;
                        aadhaarManualCaddressVm.stateData = aoService.customer.state;
                        aadhaarManualCaddressVm.disableCity = true;
                        aadhaarManualCaddressVm.disableState = true;

                    }
                }, function(error) {
                    aadhaarManualCaddressVm.stateList = "";
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else if (aadhaarManualCaddressVm.pincodeData === "" || (!utilityService.isUndefined(aadhaarManualCaddressVm.pincodeData)).length != 6) {
                aadhaarManualCaddressVm.cityData = "";
                aadhaarManualCaddressVm.stateData = "";
            }

        }

        /* Functionality : Check if city and state is valid
           Event : On blur of city and state fields
        */
        aadhaarManualCaddressVm.checkUpdatedCityStateValid = function(param) {
            aadhaarManualCaddressVm.updatedvalue(param);
        }

        /* Functionality : Auto populate data
           Event : On load
        */
        aadhaarManualCaddressVm.populateResumeData = function() {
            aadhaarManualCaddressVm.addressAboveData = aoService.aadhaarManualCorrespondenceAddress.address1;
            aadhaarManualCaddressVm.addressBelowData = aoService.aadhaarManualCorrespondenceAddress.address2;
            aadhaarManualCaddressVm.pincodeData = aoService.aadhaarManualCorrespondenceAddress.pincode;
            aadhaarManualCaddressVm.cityData = aoService.aadhaarManualCorrespondenceAddress.city;
            aadhaarManualCaddressVm.stateData = aoService.aadhaarManualCorrespondenceAddress.state;
            aadhaarManualCaddressVm.localityData = aoService.aadhaarManualCorrespondenceAddress.locality;
        }

		aadhaarManualCaddressVm.setstate = function(data) {
					var arr = aadhaarManualCaddressVm.stateList;
					if(data){
					var arrLength = arr.length;	
					for (var i = 0; i < arrLength; i++) {
						if (arr[i].stateCode == data) {
							var tempData = arr[i];
							aoService.customer.city = utilityService.getValue(tempData.cityName);
	                        aoService.customer.state = utilityService.getValue(tempData.stateName);
	                        aoService.aadhaarManualCorrespondenceAddress.cityCode = utilityService.getValue(tempData.cityCode);
	                        aoService.aadhaarManualCorrespondenceAddress.stateCode = utilityService.getValue(tempData.stateCode);
							aoService.aadhaarManualCorrespondenceAddress.district = utilityService.getValue(tempData.districtName);
	                        aoService.aadhaarManualCorrespondenceAddress.districtCode = utilityService.getValue(tempData.districtCode);
	                        aadhaarManualCaddressVm.cityData = aoService.customer.city;
	                        aadhaarManualCaddressVm.stateData = aoService.customer.state;
	                        aadhaarManualCaddressVm.disableCity = true;
	                        aadhaarManualCaddressVm.disableState = true;
						}
					};
					}else{
						aadhaarManualCaddressVm.stateData = "";
						aoService.aadhaarManualCorrespondenceAddress.state = "";
					}
			
			};  
		aadhaarManualCaddressVm.loadStateList = function(data) {
				 var inputparams = {
	                "pinCode": aoService.aadhaarManualCorrespondenceAddress.pincode
	           };
	           if(!aadhaarManualCaddressVm.stateList){
				aadhaarManualAddressService.getAreaDetailForPincode(inputparams).then(function(data) {
	                    if (!utilityService.isUndefined(data)) {
	                        aadhaarManualCaddressVm.stateList = data;
	                        aadhaarManualCaddressVm.stateitemData = aoService.aadhaarManualCorrespondenceAddress.stateCode;
                        
	                    }
	                }, function(error) {
                    
	                });
	            }    
		};	
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
                aadhaarManualCaddressVm.populateResumeData();
                $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
                try{
                aadhaarManualCaddressVm.aadharManualEntryCAddressForm.$setPristine();
                }catch(err){}
                aadhaarManualCaddressVm.loadStateList();
        });

        return this;
    }
]);
