'use strict';

angularApp.controller('aadhaarManualEntryController', ["$state",
    "$scope",
    "aoService",
    "utilityService",
    "$translate",
    "aadhaarManualAddressService",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        aoService,
        utilityService,
        $translate,
        aadhaarManualAddressService,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var aadhaarManualEntryVm = this;

        function initPage() {
            aadhaarManualEntryVm.showBack = true;
            aadhaarManualEntryVm.showNext = true;
            aadhaarManualEntryVm.aofooter = true;
            aadhaarManualEntryVm.invalid = false;
            aadhaarManualEntryVm.properDate = false;
            aadhaarManualEntryVm.disableNext = true;
            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                aadhaarManualEntryVm.okBtntext = translatedvalue;
            });
        }

        /* Functionality : Load titles (Master data)
           Event : On load
        */
        aadhaarManualEntryVm.loadTitles = function(){
            var requestData = "TitleLotus";
            
            if(aoService.isJTSixPostLoginStarted || aoService.isPreJTSixStarted ){
            	requestData = "TitleLotus,Title";
            }else{
            	requestData = "TitleLotus";
            }
            if(!aadhaarManualEntryVm.isErorr){
 		       	aadhaarManualEntryVm.isErorr = false;	
        	}
        	utilityService.showSpinner();
            aadhaarManualAddressService.getTitleList(requestData).then(function(response) {
            	utilityService.hideSpinner();
            	aadhaarManualEntryVm.isErorr = false;
                aadhaarManualEntryVm.selectTitles = response.data;
                if(aoService.isJTSixPostLoginStarted){
            		    aadhaarManualEntryVm.selectedTitle = aoService.isJTSixPostLoginData.titleCode; 
            			aadhaarManualEntryVm.disableSelectedTitle = true;
            	}
            }, function(error) {
            	aadhaarManualEntryVm.isErorr = true;
            	utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        /* Functionality : Load gender (Master data)
           Event : On load
        */
        aadhaarManualEntryVm.loadGenderList = function(){
            var requestParam = "Gender";
            aadhaarManualAddressService.getGenderList(requestParam).then(function(response) {
                aadhaarManualEntryVm.genderList = response.data;
                if(aoService.isJTSixPostLoginStarted && aoService.isJTSixPostLoginData.genderCode){
                 aadhaarManualEntryVm.selectedGender = aoService.isJTSixPostLoginData.genderCode;
                 aadhaarManualEntryVm.disableSelectedGender = true;
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        /* Functionality :  Set the model values to common service for using it in other controller
           Event : on click of "next" button 
        */
        aadhaarManualEntryVm.goToNextPage = function() {
            aadhaarManualEntryVm.ageCheck = aadhaarManualEntryVm.checkAge();
            if (aadhaarManualEntryVm.aadhaarnumber != aoService.nomineeAadhaarCardDetails.uid) {
                if (aadhaarManualEntryVm.ageCheck > 0) {
                    aoService.isCustManualCorresChkBox = aadhaarManualEntryVm.isChecked;

                    if(aoService.isCustManualCorresChkBox == false){
                        aoService.aadhaarManualCorrespondenceAddress.address1 = "";

                        aoService.aadhaarManualCorrespondenceAddress.address2 = "";
                        aoService.aadhaarManualCorrespondenceAddress.pincode = "";
                        aoService.aadhaarManualCorrespondenceAddress.city = "";
                        aoService.aadhaarManualCorrespondenceAddress.state = "";
                        aoService.aadhaarManualCorrespondenceAddress.locality = "";                        
                    }
                    $state.go('menu.aDCityCountry');
                } else {
                    var title = '';
                    var template = '{{"AGE_CHECK" | translate}}';
                    var onTap = 'menu.aadhaarManualEntry';
                    var buttontext = '<b>' + aadhaarManualEntryVm.okBtntext + '</b>';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                }
                aoService.customerManualEntryDetails.aadharNumber = aadhaarManualEntryVm.aadhaarnumber;
                aoService.customerManualEntryDetails.firstName = aadhaarManualEntryVm.fatherFname;
                aoService.customerManualEntryDetails.lastName = aadhaarManualEntryVm.fatherLname;
                aoService.customerManualEntryDetails.middleName = aadhaarManualEntryVm.fatherMname;
                aoService.customerManualEntryDetails.fullName = aadhaarManualEntryVm.fatherFname + ' ' + aadhaarManualEntryVm.fatherMname + ' ' + aadhaarManualEntryVm.fatherLname;
                aoService.customerManualEntryDetails.genderCode = aadhaarManualEntryVm.selectedGender;
                aoService.customerManualEntryDetails.titleCode = aadhaarManualEntryVm.selectedTitle;
                aoService.customerManualEntryDetails.title = aoService.getValueById(aadhaarManualEntryVm.selectTitles,aadhaarManualEntryVm.selectedTitle);
                aoService.customerManualEntryDetails.gender = aoService.getValueById(aadhaarManualEntryVm.genderList,aadhaarManualEntryVm.selectedGender);               
                aoService.customerManualEntryDetails.dob = aadhaarManualEntryVm.date + '/' + aadhaarManualEntryVm.month + '/' + aadhaarManualEntryVm.year;
            } else {
                var title = '';
                var template = "{{'AADHAAR_BOTH_SAME'| translate}}";
                var onTap = '';
                var buttontext = "<b>" + aadhaarManualEntryVm.okBtntext + "</b>";
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            }
        }

        aadhaarManualEntryVm.goBacktoPrevious = function() {
        	if(aoService.isVID){
        		$state.go('menu.VIDDetails');
        	}else{
        		$state.go('menu.personalDetails');	
        	}
        }

        //Auto populate the data in resume journey
        aadhaarManualEntryVm.populateResumeData = function() {
                aadhaarManualEntryVm.aadhaarnumber = aoService.customerManualEntryDetails.aadharNumber;
                aadhaarManualEntryVm.fatherFname = aoService.customerManualEntryDetails.firstName;
                aadhaarManualEntryVm.fatherMname = aoService.customerManualEntryDetails.middleName;
                aadhaarManualEntryVm.fatherLname = aoService.customerManualEntryDetails.lastName;
                aadhaarManualEntryVm.selectedGender = aoService.customerManualEntryDetails.genderCode;
                aadhaarManualEntryVm.selectedTitle = aoService.customerManualEntryDetails.titleCode;
                aadhaarManualEntryVm.isChecked = aoService.isCustManualCorresChkBox;
        }

        $scope.$watch("aadhaarManualEntryVm.personalDetailsForm.$valid", function(value) {
            if (value === true && aadhaarManualEntryVm.invalid == false) {
                aadhaarManualEntryVm.disableNext = false;
            } else {
                aadhaarManualEntryVm.disableNext = true;
            }
        });

        // On page load - populate aadhaar dob
        aadhaarManualEntryVm.populateDobAadhaar = function() {
            if (!utilityService.isUndefined(aoService.customerManualEntryDetails.dob)) {
                aoService.customerManualEntryDetails.dob = moment(aoService.customerManualEntryDetails.dob, ["DD/MM/YYYY", "MM/DD/YYYY", "DD-MM-YYYY", "MM-DD-YYYY", "YYYY-MM-DD", "YYYY-DD-MM" ,"YYYY/MM/DD", "YYYY/DD/MM"]);
                var dateFormat = new Date(aoService.customerManualEntryDetails.dob);
                var day = dateFormat.getDate();
                var month = dateFormat.getMonth() + 1;
                var year = dateFormat.getFullYear();
                var formattedDate = day.toString();
                if (formattedDate.length == 1) {
                    formattedDate = "0" + formattedDate;
                    aadhaarManualEntryVm.date = formattedDate;
                } else {
                    aadhaarManualEntryVm.date = parseInt(day);
                }
                var formattedMonth = month.toString();
                if (formattedMonth.length == 1) {
                    formattedMonth = "0" + formattedMonth;
                    aadhaarManualEntryVm.month = formattedMonth;
                } else {
                    aadhaarManualEntryVm.month = parseInt(month);
                }
                aadhaarManualEntryVm.year = parseInt(year);
            } else if (!utilityService.isUndefined(aoService.customerManualEntryDetails.yob) && utilityService.isUndefined(aoService.customerManualEntryDetails.dob)) {
                aadhaarManualEntryVm.date = "";
                aadhaarManualEntryVm.month = "";
                aadhaarManualEntryVm.year = parseInt(aoService.customerManualEntryDetails.yob);
            }else if (utilityService.isUndefined(aoService.customerManualEntryDetails.yob) && (aoService.customerManualEntryDetails.dob == "")) {
                aadhaarManualEntryVm.date = "";
                aadhaarManualEntryVm.month = "";
                aadhaarManualEntryVm.year = "";
            }
        }
        $scope.goToHome = function() {
            aoService.homeNav();
        }

        aadhaarManualEntryVm.validateForm = function(isValid) {
            aadhaarManualEntryVm.disableNext = !isValid;
        }

        /* Based on the title change, populate the gender dropdown */
        aadhaarManualEntryVm.genderUpdate = function(value) {
            if (utilityService.isUndefined(value)) {
                aadhaarManualEntryVm.selectedGender = constantConfig.acOp.gender;
            } else if (value === "01") {
                aadhaarManualEntryVm.selectedGender = "M";
            } else {
                aadhaarManualEntryVm.selectedGender = "F";
            }
        }

        /* Based on gender change, populate title dropdown */
        aadhaarManualEntryVm.titleUpdate = function(value) {
            if (utilityService.isUndefined(value)) {
                aadhaarManualEntryVm.selectedTitle = constantConfig.acOp.title;
            } else if (value.toLowerCase() === constantConfig.acOp.male || value.toLowerCase() === "m") {
                aadhaarManualEntryVm.selectedTitle = "01";
            } else {
                aadhaarManualEntryVm.selectedTitle = "02";
            }
        }

        // Validate date
        aadhaarManualEntryVm.validDateFormat = function(isValid , monthOrDay) {
        	
            var fullDate = aadhaarManualEntryVm.month + '/' + aadhaarManualEntryVm.date + '/' + aadhaarManualEntryVm.year;
            var dobMonth = aadhaarManualEntryVm.month;
            var dobDay = aadhaarManualEntryVm.date;
            var dobYr = aadhaarManualEntryVm.year;
            var fullDateInMilliSeconds = Date.parse(fullDate);
            var formattedDate = new Date();
            var formattedDateYr = formattedDate.getFullYear();
            var currDate = new Date();
            var curYear = currDate.getFullYear();
            var curDateInMilliSeconds = new Date().getTime();
            formattedDate.setFullYear(dobYr, dobMonth - 1, dobDay);
            var months30 = ['04', '06', '09', '11', "4", "6", "9"];
            var monthIndex = months30.indexOf(dobMonth);

            // If entered date is greater than the current date
            if (fullDateInMilliSeconds > curDateInMilliSeconds) {
                aadhaarManualEntryVm.disableNext = true;
                aadhaarManualEntryVm.invalid = true;
                aadhaarManualEntryVm.properDate = false;
            }
            // Leap year validation
            else if (dobYr % 4 == 0 && (dobYr % 100 != 0 || dobYr % 400 == 0)) {
                if (dobMonth == 2 && dobDay > 29) {
                    aadhaarManualEntryVm.disableNext = true;
                    aadhaarManualEntryVm.invalid = true;
                    aadhaarManualEntryVm.properDate = false;
                } else if (monthIndex != -1 && dobDay == 31) {
                    aadhaarManualEntryVm.disableNext = true;
                    aadhaarManualEntryVm.invalid = true;
                    aadhaarManualEntryVm.properDate = false;
                } else {
                    aadhaarManualEntryVm.disableNext = !isValid;
                    aadhaarManualEntryVm.invalid = false;
                    aadhaarManualEntryVm.properDate = true;
                }
            } else if (dobMonth == 2 && dobDay >= 29) {
                aadhaarManualEntryVm.disableNext = true;
                aadhaarManualEntryVm.invalid = true;
                aadhaarManualEntryVm.properDate = false;
            }
            // If the month has only 30 days
            else if (monthIndex != -1 && dobDay == 31) {
                aadhaarManualEntryVm.disableNext = true;
                aadhaarManualEntryVm.invalid = true;
                aadhaarManualEntryVm.properDate = false;
            } else {
                aadhaarManualEntryVm.disableNext = !isValid;
                aadhaarManualEntryVm.invalid = false;
                aadhaarManualEntryVm.properDate = true;
            }
            if(aadhaarManualEntryVm.date  < 10  && aadhaarManualEntryVm.date.length == 1 ){
            	aadhaarManualEntryVm.disableNext = true;
                aadhaarManualEntryVm.invalid = true;
                aadhaarManualEntryVm.properDate = false;
            }
            if(aadhaarManualEntryVm.month  < 10 && aadhaarManualEntryVm.month.length == 1 ){
            	aadhaarManualEntryVm.disableNext = true;
                aadhaarManualEntryVm.invalid = true;
                aadhaarManualEntryVm.properDate = false;
            }
            return aadhaarManualEntryVm.properDate;
        }

        //Method to calculate customer age
        aadhaarManualEntryVm.checkAge = function() {
                aadhaarManualEntryVm.validDate = aadhaarManualEntryVm.validDateFormat();
                if (aadhaarManualEntryVm.validDate == true) {
                    var fullDate = aadhaarManualEntryVm.month + '/' + aadhaarManualEntryVm.date + '/' + aadhaarManualEntryVm.year;

                    var formattedDate = new Date();
                    formattedDate.setFullYear(aadhaarManualEntryVm.year, aadhaarManualEntryVm.month - 1, aadhaarManualEntryVm.date);
                    var todayDate = new Date();
                    var currentYear = todayDate.getFullYear();
                    var validYear = todayDate.setFullYear(currentYear - 18);
                    aadhaarManualEntryVm.customerAge = validYear - formattedDate;
                    aadhaarManualEntryVm.dob = fullDate;
                    aadhaarManualEntryVm.disableNext = false;
                } else if (aadhaarManualEntryVm.validDate == false) {
                    aadhaarManualEntryVm.disableNext = true;
                }
                return aadhaarManualEntryVm.customerAge;
            }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            aadhaarManualEntryVm.loadTitles();
            aadhaarManualEntryVm.loadGenderList();
            aadhaarManualEntryVm.populateResumeData();
            aadhaarManualEntryVm.populateDobAadhaar();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            
            
             if(aoService.isJTSixPostLoginStarted){
            	aadhaarManualEntryVm.disableFatherFname = true;
            	aadhaarManualEntryVm.disableFatherLname = true;
            	
            	aadhaarManualEntryVm.fatherFname = aoService.isJTSixPostLoginData.firstName;
            	aadhaarManualEntryVm.fatherLname = aoService.isJTSixPostLoginData.lastName;
            	
            	if(aoService.isJTSixPostLoginData.dob){
            		if(aoService.isJTSixPostLoginData.dob.length == 8){
            			aadhaarManualEntryVm.year = aoService.isJTSixPostLoginData.dob.substring(0,2) ;
            			aadhaarManualEntryVm.month = aoService.isJTSixPostLoginData.dob.substring(2,4) ;
            			aadhaarManualEntryVm.date = aoService.isJTSixPostLoginData.dob.substring(4,8) ;
            			aadhaarManualEntryVm.disableYear = true ;
            			aadhaarManualEntryVm.disableMonth = true;
            			aadhaarManualEntryVm.disableDate = true;
            		}
            		if(aoService.isJTSixPostLoginData.dob.length == 10){
            			aadhaarManualEntryVm.date  = aoService.isJTSixPostLoginData.dob.substring(0,2) ;
            			aadhaarManualEntryVm.month = aoService.isJTSixPostLoginData.dob.substring(3,5) ;
            			aadhaarManualEntryVm.year = aoService.isJTSixPostLoginData.dob.substring(6,10) ;
            			aadhaarManualEntryVm.disableYear = true ;
            			aadhaarManualEntryVm.disableMonth = true;
            			aadhaarManualEntryVm.disableDate = true;
            		}
            	}
            	if(aoService.isJTSixPostLoginData.gender && aadhaarManualEntryVm.selectedGender){
            			  aadhaarManualEntryVm.selectedGender = aoService.isJTSixPostLoginData.genderCode;
                          aadhaarManualEntryVm.disableSelectedGender = true;
            	}
            	if(aoService.isJTSixPostLoginData.middleName){
            			aadhaarManualEntryVm.disableFatherMname = true;
            			aadhaarManualEntryVm.fatherMname = aoService.isJTSixPostLoginData.middleName;
            	}
            	if(aoService.isJTSixPostLoginData.title && aadhaarManualEntryVm.selectTitles){
            		   aadhaarManualEntryVm.selectedTitle = aoService.isJTSixPostLoginData.titleCode;
                       aadhaarManualEntryVm.disableSelectedTitle = true;
            	}
            	
            	
            	
            	if(aoService.isJTSixPostLoginData.uid){
					var uidCheck = aoService.isJTSixPostLoginData.uid;
		            if (uidCheck ) {
		            	aadhaarManualEntryVm.aadhaarnumber = aoService.isJTSixPostLoginData.uid;
		            	aadhaarManualEntryVm.disableuid  = true;
					 }
			  	}	 
            	
            }
           if(aoService.isVID && aoService.customerAadhaarCardDetails){
            	aadhaarManualEntryVm.vid = aoService.customerAadhaarCardDetails.uid;
				aadhaarManualEntryVm.aadhaarnumber = aoService.customerAadhaarCardDetails.uid;
           }
		   aadhaarManualEntryVm.isVID = aoService.isVID;
        });

        return this;
    }
]);
