'use strict';

angularApp.controller('accountOpeningController', ["$state",
    "$scope",
    "accountOpeningService",
    "aoService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "resumeJourneyService",
    "encryptionService",
    "cryptoService",
    "$translate",
    "constantConfig",
    function ($state,
        $scope,
        accountOpeningService,
        aoService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        resumeJourneyService,
        encryptionService,
        cryptoService,
        $translate,
        constantConfig) {

        var accountOpeningVm = this;

        accountOpeningVm.isChallenged = false;
        accountOpeningVm.securityCheckName = "AOSecurityCheck";
        accountOpeningVm.aoAuthChallengeHandler = WL.Client.createSecurityCheckChallengeHandler(accountOpeningVm.securityCheckName);
        accountOpeningVm.aoAuthChallengeHandler.securityCheckName = accountOpeningVm.securityCheckName;

        accountOpeningVm.showBack = false;
        accountOpeningVm.showNext = true;

        function initPage() {
            accountOpeningVm.aofooter = true;
            accountOpeningVm.loadProductFeatures();
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                accountOpeningVm.okBtntext = translatedvalue;
            });
        }

        /* Functionality : WCM service to load product features
           Event : On load
        */
        accountOpeningVm.loadProductFeatures = function () {
            accountOpeningService.getProductFeatures().then(function (data) {
                accountOpeningVm.featuresJson = data;
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        accountOpeningVm.goToNextPage = function () {
            /*mPinLoginService.isLoggedIn = true;
            var mobileNoExists = true;*/
            //$state.go('menu.mobileEntryPage');
            accountOpeningVm.userLoginCall();
        }

        accountOpeningVm.knowmoreLink = function () {
            $state.go('menu.knowMore');
        }

        accountOpeningVm.goBacktoPrevious = function () {
            $state.go('menu.applyNewOrResume');
        }

        accountOpeningVm.userLoginCall = function () {
            if (mPinLoginService.isLoggedIn == true) {
                //trigger the service to check for the mobile number
                accountOpeningVm.loggedUserDetails();
                /*if(mobileNoExists == true){
                    //land him in the respective page where he left and populate the data - resume journey
                    accountOpeningVm.getDocumentDetails(mobileNoExists);
                }
                else{
                    //redirect to the mobile and email entry page and still trigger resume journey to populate the data
                    accountOpeningVm.getDocumentDetails(mobileNoExists);
                }*/
            } else {
                //accountOpeningVm.loginWithResume();
                aoService.isResumeJourney = false;
                $state.go('menu.mobileEntryPage');
                //The user is not logged in, new journey
            }
        }

        accountOpeningVm.loggedUserDetails = function () {
            accountOpeningService.getLoggedUserDetails().then(function (response) {
                aoService.isResumeJourney = true;
                aoService.getResumeDocument(response.data);

                accountOpeningVm.getPageDetails(response.data.personalDetails.mobileNumber);

            }, function (error) {

            });
        }

        //Resume journey - retrieve document service call
        /* accountOpeningVm.getDocumentDetails = function(mobileNoExists){
             var requestParams = {
                 "id": accountOpeningVm.resumeMobile,
                 "password": accountOpeningVm.encoded
             }
             resumeJourneyService.getCustomerDetails(requestParams).then(function(data) {
                 aoService.getResumeDocument(response.data);
                 if(mobileNoExists == true){
                     accountOpeningVm.getPageDetails(response.data.personalDetails.mobileNumber);
                 }
                 else{
                     $state.go("menu.mobileEntryPage");
                 }
                 
             }, function(error) {
                 var title = '';
                 var template = '{{"RESUME_DATA_NO_MATCH" | translate}}';
                 var onTap = '';
                 var buttontext = '<b>' + resumeJourneyVm.okBtntext + '</b>';
                 utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
             });
         }*/

        //Challenge Handler
        accountOpeningVm.loginWithResume = function () {
            utilityService.showSpinner();
            accountOpeningVm.aoAuthChallengeHandler.handleChallenge = function (challenge) {
                accountOpeningVm.isChallenged = true;
                utilityService.hideSpinner();
                if (challenge.errorMsg !== null) {
                    utilityService.showErrorMessage(utilityService.getServerExceptionMessage(challenge));
                } else {
                    utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
                }
            };

            accountOpeningVm.aoAuthChallengeHandler.handleSuccess = function (data) {
                accountOpeningVm.isChallenged = false;
                utilityService.hideSpinner();
                if (data.user) {
                    loggedInUserService.keyId = AdapterUtils.secretData == "" ? data.user.attributes.keyId : encryptionService.getAES256DecryptedData(data.user.attributes.keyId);
                    loggedInUserService.tokenLotus = AdapterUtils.secretData == "" ? data.user.attributes.lotusToken : encryptionService.getAES256DecryptedData(data.user.attributes.lotusToken);
                }
            };

            accountOpeningVm.aoAuthChallengeHandler.handleFailure = function (error) {
                accountOpeningVm.aoAuthChallengeHandler.cancel();
                accountOpeningVm.isChallenged = false;
                utilityService.hideSpinner();
                if (error.failure) {
                    utilityService.showErrorMessage(error.failure);
                } else {
                    utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
                }
            }

            var requestParams = {
                "mobileKey": accountOpeningVm.resumeMobile,
                "passKey": accountOpeningVm.resumePassword
            }
            var passphraseSession;
            if (sessionStorage) {
                passphraseSession = sessionStorage.getItem('passphrase');
            }
            var passphrase = passphraseSession ? passphraseSession : encryptionService.passphrase;
            var src = cryptoService.encryptRSAWithPublicKey(encryptionService.iv + "^" + passphrase + "^" + encryptionService.salt, cryptoService.rsaPublicKey);

            var payload = {
                "data": encryptionService.getAES256EncryptedData(JSON.stringify(requestParams)),
                "src": src
            }

            if (accountOpeningVm.isChallenged) {
                accountOpeningVm.aoAuthChallengeHandler.submitChallengeAnswer(payload);
            } else {
                WLAuthorizationManager.login(accountOpeningVm.aoAuthChallengeHandler.securityCheckName, payload).then(
                    function (data) {
                        utilityService.accessRestricted = utilityService.AOAuthRequired;
                        utilityService.hideSpinner();
                        accountOpeningVm.loggedUserDetails();
                    },
                    function (error) {
                        utilityService.accessRestricted = "";
                        utilityService.hideSpinner();
                        if (error.errorCode == 'CHALLENGE_HANDLING_CANCELED' || error.errorCode == 'APPLICATION_DISABLED') {
                            return;
                        }
                        if (error.errorCode == "LOGIN_ALREADY_IN_PROCESS") {
                            accountOpeningVm.aoAuthChallengeHandler.cancel();
                        }
                        utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
                    });
            }
        }

        //Resume journey - retrieve page details
        accountOpeningVm.getPageDetails = function (mobileNo) {
            //var requestParams = mobileNo;
            resumeJourneyService.getPageDetails(mobileNo).then(function (response) {

                var splitUrls = [];
                var splittedUrl1, splittedUrl2;
                if (!utilityService.isUndefined(response.payLoad)) {
                    if (response.payLoad.commonId == "FATCA") {
                        if (aoService.fatcaFlag == false) {
                            $state.go("menu.locateBranch");
                        } else {
                            $state.go(response.payLoad.mobileURL);
                        }
                    } else if (response.payLoad.commonId == "AadharManual") {
                        splitUrls = response.payLoad.mobileURL.split("/");
                        splittedUrl1 = splitUrls[0];
                        splittedUrl2 = splitUrls[1];
                        if (aoService.isCustManualCorresChkBox == true) {
                            $state.go(splittedUrl1);
                        } else {
                            $state.go(splittedUrl2);
                        }

                    } else if (response.payLoad.commonId == "AadharScanned") {
                        splitUrls = response.payLoad.mobileURL.split("/");
                        splittedUrl1 = splitUrls[0];
                        splittedUrl2 = splitUrls[1];
                        if (aoService.correspondenceCheckStatus == true) {
                            $state.go(splittedUrl1);
                        } else {
                            $state.go(splittedUrl2);
                        }

                    } else if (response.payLoad.commonId == "NomineeDetails") {
                        splitUrls = response.payLoad.mobileURL.split("/");
                        splittedUrl1 = splitUrls[0];
                        splittedUrl2 = splitUrls[1];
                        if (parseInt(aoService.nomineeAadhaarCardDetails.age) < 18 || parseInt(aoService.nominee.age) < 18) {
                            if (aoService.nominee.guardianAddressFlag == "nomineeAddress") {
                                $state.go("menu.nomineeEnteredAddress");
                            } else if (aoService.nominee.guardianAddressFlag == "applicantAddress") {
                                $state.go("menu.nomineeAddress");
                            } else if (aoService.nominee.guardianAddressFlag == "newAddress") {
                                $state.go("menu.nomineeCAddress");
                            } else {
                                $state.go(splittedUrl1);
                            }
                        } else {
                            $state.go(splittedUrl2);
                        }
                    } else if (response.payLoad.commonId == "PAN") {
                        if (aoService.cifNumber == '0000') {
                            $state.go(response.payLoad.mobileURL);
                        } else if (aoService.cifNumber == "0001") {
                            $state.go("menu.multipleCustomer");
                        } else {
                            //$state.go("menu.passbookDetails");
                            $state.go("menu.multipleCustomer");
                        }

                    } else if (response.payLoad.commonId == "OIOO") {
                        $state.go("menu.productOffering");
                    } else {
                        $state.go(response.payLoad.mobileURL);
                    }
                } else {
                    $state.go("menu.mobileEntryPage");
                    aoService.iibCall = true;
                }

            }, function (error) {
                var title = '';
                var template = '{{"RESUME_DATA_NO_MATCH" | translate}}';
                var onTap = '';
                var buttontext = '<b>' + accountOpeningVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            });
        }

        $scope.goToHome = function () {
            aoService.homeNav();
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        $scope.$on('$ionicView.beforeLeave', function () {
            
        });

        return this;
    }
]);