'use strict';

angularApp.controller('accountOpeningGetPictureController', ["$state",
    "$scope",
    "$translate",
    "cameraService",
    "utilityService",
    "aoService",
    "$ionicPopover",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        $translate,
        cameraService,
        utilityService,
        aoService,
        $ionicPopover,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var aOGetPictureVm = this;

        aOGetPictureVm.showBack = true;
        aOGetPictureVm.showNext = false;
        aOGetPictureVm.aofooter = true;

        function initPage() {
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                aOGetPictureVm.okBtntext = translatedvalue;  
            });
        }

        aOGetPictureVm.goBacktoPrevious = function() {
            $state.go("menu.panAuthorise");
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        aOGetPictureVm.takeSelfie = function() {
            $state.go('menu.aOTakeSelfie');
        }

        /* Fetch image from gallery */
        aOGetPictureVm.imageFromGallery = function() {
            cameraService.getImageFromGallery().then(function(data) {
                aoService.customer.photo = data;
                $state.go('menu.aOLooksGreat');
            }, function(error) {
                var title = '';
                var template = '{{"SERVICE_ERR_MSG" | translate}}';
                var onTap = '';
                var buttontext = '<b>' + aOGetPictureVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            });
        }

        /* Info Popup */
        var template = '<ion-popover-view class="ao-tooltip ao-popupInfo roboto-regular ao-twoLinesHt">' + '<ion-content>' +
                        '<div class="" translate="CLEAR_PICTURE"></div>' + '</ion-content>' + '</ion-popover-view>';

        $scope.popover = $ionicPopover.fromTemplate(template, {
            scope: $scope
        });

        aOGetPictureVm.infoPopup = function($event) {
            $scope.popover.show($event);
        };

        aOGetPictureVm.closePopover = function() {
            $scope.popover.hide();
        };
       /* Info Popup */
        
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });
        
        return this;
    }
]);
