'use strict';

angularApp.controller('accountOpeningLooksGreatController', ["$state",
    "$scope",
    "accountOpeningLooksGreatService",
    "aoService",
    "utilityService",
    "$translate",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        accountOpeningLooksGreatService,
        aoService,
        utilityService,
        $translate,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var aOLooksGreatVm = this;

        function initPage() {
          /*  if (aoService.isResumeJourney == true && !utilityService.isUndefined(aoService.picId)) {
                aOLooksGreatVm.retrievePhotoCall();
            }*/
            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                aOLooksGreatVm.okBtntext = translatedvalue;
            });
        }

        aOLooksGreatVm.goBacktoPrevious = function() {
            $state.go('menu.aOGetPicture');
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        aOLooksGreatVm.imgSizeValidation = function(){
            var imgBase = aoService.customer.photo;

            var blob = new Blob([imgBase], {type: 'image/jpeg'});

            if(blob.size<54 *1024){
                aOLooksGreatVm.handleApply();   
            }
            else{
                var title = '';
                var template = '{{"UPLOAD_IMG_SIZE" | translate}}';
                var onTap = 'menu.aOLooksGreat';
                var buttontext = '<b>' + aOLooksGreatVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            }
        }

        /* Functionality : Service to upload the customer photo
           Event : On click of "tick" image
        */
        aOLooksGreatVm.handleApply = function() {
            var newImg = aoService.customer.photo;
            var baseImg = newImg.split("base64,")[1];
            var param = {
                "documentClass": "LT_AccountOpening",
                "mimeType": "image/jpg",
                "documentTitle": "Customer Photo",
                "documentData": baseImg,
                "documentType": "Photograph",
                "documentID": aoService.customer.mobileNo,
                "commonId": $state.$current.data.commonId
            }
            accountOpeningLooksGreatService.uploadPhoto(param).then(function(response) {
                $state.go('menu.additionalDetails');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        /* Functionality : Service to upload the customer photo
           Event : On click of "tick" image
        */
        aOLooksGreatVm.retrievePhotoCall = function() {
            var param = aoService.picId;

            accountOpeningLooksGreatService.retrievePhoto(param).then(function(response) {

                aOLooksGreatVm.croppedImage = "data:image/jpeg;base64," + response.data.documentData;
                aoService.customer.photo = aOLooksGreatVm.croppedImage;
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            if(!aoService.customer.photo){
            if (aoService.isResumeJourney == true && !utilityService.isUndefined(aoService.picId)) {
                aOLooksGreatVm.retrievePhotoCall();
            }
            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                aOLooksGreatVm.okBtntext = translatedvalue;
            });
        }
        else{
            aOLooksGreatVm.croppedImage = aoService.customer.photo;

        }

        $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);

        });

        return this;
    }
]);
