'use strict';

angularApp.service('accountOpeningService',
    function($q, AdapterUtils, constantConfig) {
        var accountOpeningService = this;
        accountOpeningService.getProductFeatures = function() {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.getProductFeatures, true).then(

                function(response) {
                    q.resolve(response.data.productFeatures);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        accountOpeningService.getLoggedUserDetails = function() {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.getCustomerInfo, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        return accountOpeningService;
    });
