'use strict';

angularApp.controller('accountOpeningTakeSelfieController', ["$state",
    "$scope",
    "$translate",
    "cameraService",
    "aoService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        $translate,
        cameraService,
        aoService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var aOTakeSelfieVm = this;

        function initPage() {
            aOTakeSelfieVm.showBack = true;
            aOTakeSelfieVm.aofooter = true;
        
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                aOTakeSelfieVm.okBtntext = translatedvalue;  
            });
        }

        aOTakeSelfieVm.goBacktoPrevious = function() {
            $state.go('menu.aOGetPicture');
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        /* Opens Mobile Camera */
        aOTakeSelfieVm.openCamera = function() {
            cameraService.getnewImage().then(function(data) {
                aOTakeSelfieVm.setImage(data);
                $state.go('menu.aOLooksGreat');
            }, function(error) {
                var title = '';
                var template = '{{"SERVICE_ERR_MSG" | translate}}';
                var onTap = '';
                var buttontext = '<b>' + aOTakeSelfieVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            });
        }

        /* Set the image captured in camera */
        aOTakeSelfieVm.setImage = function(img) {
            aOTakeSelfieVm.selfieImage = img;
            aoService.customer.photo = aOTakeSelfieVm.selfieImage;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            aOTakeSelfieVm.selfieImage = "img/client-img.png";
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });
        
        return this;
    }
]);
