'use strict';

angularApp.controller('knowMoreController', ["$state",
    "$scope",
    "knowMoreService",
    "aoService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        knowMoreService,
        aoService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var knowMoreVm = this;

        knowMoreVm.showBack = true;
        knowMoreVm.showNext = false;

        function initPage() {
            knowMoreVm.aofooter = true;
            knowMoreVm.loadProductFeatures();
        }

        knowMoreVm.loadProductFeatures = function() {
            knowMoreService.productKnowMore().then(function(data) {
                knowMoreVm.featuresJson = data;
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        knowMoreVm.goBacktoPrevious = function() {
            $state.go('menu.accountOpening');
        }

        $scope.goToHome = function(){
            aoService.homeNav();
        }
        
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });
        
        return this;
    }
]);
