'use strict';

angularApp.controller('accountOpeningDetailsController', ["$state",
    "$scope",
    "aoService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "utilityService",

    function($state,
        $scope,
        aoService,
        $ionicSideMenuDelegate,
        mPinLoginService,utilityService) {

        var accountOpeningDetailsVm = this;

        function initPage() {
            accountOpeningDetailsVm.showBack = false;
            accountOpeningDetailsVm.showNext = true;
            accountOpeningDetailsVm.aofooter = true;
        }

        accountOpeningDetailsVm.goToNextPage = function() {
            $state.go('menu.netBankingRegister');
        }

        accountOpeningDetailsVm.saveAsImg = function(){
            if(accountOpeningDetailsVm.isChecked == true){
                navigator.screenshot.save(function(error,res){
                  if(error){
                    utilityService.showErrorMessage(error);
                  }else{
                    utilityService.showErrorMessage('Saved',res.filePath);
                  }
                },'jpg',50);
            }
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
