'use strict';

angularApp.controller('aDAnnualIncomeController', ["$state",
    "$scope",
    "aoService",
    "adDetailsCommonService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        aoService,
        adDetailsCommonService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var aDAnnualIncomeVm = this;

        function initPage() {
            aDAnnualIncomeVm.showBack = true;
            aDAnnualIncomeVm.showNext = false;
            aDAnnualIncomeVm.aofooter = true;
            aDAnnualIncomeVm.loadAnnualIncome();
        }

        aDAnnualIncomeVm.getOccupation = function() {
            $state.go("menu.aDOccupation");
        }

        aDAnnualIncomeVm.loadAnnualIncome = function(){
            var requestParam = "IncomeLotus";
            utilityService.showSpinner();
            aDAnnualIncomeVm.isErorr = false;
            adDetailsCommonService.getAnnualIncome(requestParam).then(function(data) {
				aDAnnualIncomeVm.isErorr = false;
				utilityService.hideSpinner();
                aDAnnualIncomeVm.subAnnualIncome = data;
            }, function(error) {
            	utilityService.hideSpinner();
            	aDAnnualIncomeVm.isErorr = true;
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        aDAnnualIncomeVm.goBacktoPrevious = function() {
            $state.go("menu.aDFamilyDetails");
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        aDAnnualIncomeVm.populateResumeData = function(){
            if(aoService.isResumeJourney == true){
                aDAnnualIncomeVm.activeStatus = aoService.getIdByValue(aDAnnualIncomeVm.subAnnualIncome, aoService.customerAdditionalDetails.annualIncome);
            }
        }

        aDAnnualIncomeVm.goToNextPage = function(param) {
            aoService.activeAdditionalDetails.income = param.value;
            aoService.customerAdditionalDetails.annualIncome = param.description;
            $state.go("menu.aDOccupation");
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            aDAnnualIncomeVm.activeStatus = aoService.activeAdditionalDetails.income;
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            //aDAnnualIncomeVm.populateResumeData();
        });

        return this;
    }
]);
