'use strict';

angularApp.controller('aDFamilyDetailsController', ["$state",
    "$scope",
    "aoService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "adDetailsCommonService",
    "utilityService",

    function($state,
        $scope,
        aoService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        adDetailsCommonService,
        utilityService) {

        var aDFamilyDetailsVm = this;

        function initPage() {
            aDFamilyDetailsVm.showBack = true;
            aDFamilyDetailsVm.showNext = true;
            aDFamilyDetailsVm.disableNext = true;
            aDFamilyDetailsVm.aofooter = true;
        }

        aDFamilyDetailsVm.goBacktoPrevious = function() {
            $state.go("menu.aDMaritalStatus"); 
        }

        aDFamilyDetailsVm.goToNextPage = function() {
            aoService.customerAdditionalDetails.maidenName = aDFamilyDetailsVm.maidenName;
            aoService.customerAdditionalDetails.motherMaidenName = aDFamilyDetailsVm.motherMname;
            aoService.customerAdditionalDetails.spouseName = aDFamilyDetailsVm.spouseName;
            aoService.customerAdditionalDetails.fatherFirstName = aDFamilyDetailsVm.fatherFname;
            aoService.customerAdditionalDetails.fatherMiddleName = aDFamilyDetailsVm.fatherMname;
            aoService.customerAdditionalDetails.fatherLastName = aDFamilyDetailsVm.fatherLname;
            aoService.customerAdditionalDetails.fatherName = aDFamilyDetailsVm.fatherFname + '' + aDFamilyDetailsVm.fatherLname;
            aoService.customerAdditionalDetails.motherFirstname = aDFamilyDetailsVm.motherFname;
            aoService.customerAdditionalDetails.motherMiddlename = aDFamilyDetailsVm.motherMname;
            aoService.customerAdditionalDetails.motherLastname = aDFamilyDetailsVm.motherLname;
            $state.go("menu.aDAnnualIncome");
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        aDFamilyDetailsVm.changeFn = function(isValid) {
            aDFamilyDetailsVm.disableNext = !isValid;
        }

        aDFamilyDetailsVm.fatherTitleSelection = function(value){
           aoService.customerAdditionalDetails.fatherTitleCode = value;
            aoService.customerAdditionalDetails.fatherTitle = aoService.getValueById(aDFamilyDetailsVm.selectTitles, aoService.customerAdditionalDetails.fatherTitleCode);
        }

        aDFamilyDetailsVm.motherTitleSelection = function(value){
            aoService.customerAdditionalDetails.motherTitleCode = value;
            aoService.customerAdditionalDetails.motherTitle = aoService.getValueById(aDFamilyDetailsVm.selectTitles, aoService.customerAdditionalDetails.motherTitleCode);
        }

        //Load Title Dropdown
        aDFamilyDetailsVm.loadTitles = function(){
            var requestData = "TitleLotus";
            utilityService.showSpinner();
            aDFamilyDetailsVm.isErorr = false;
            adDetailsCommonService.loadTitle(requestData).then(function(response) {
            	utilityService.hideSpinner();
            	aDFamilyDetailsVm.isErorr = false;
                aDFamilyDetailsVm.selectTitles = response.data;   
                aDFamilyDetailsVm.fatherTitleSelection(aoService.customerAdditionalDetails.fatherTitleCode);
                aDFamilyDetailsVm.motherTitleSelection(aoService.customerAdditionalDetails.motherTitleCode);             
            }, function(error) {
            	aDFamilyDetailsVm.isErorr = true;
            	utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });
        }       

        //Required check for Spouse name based on marital status
        aDFamilyDetailsVm.enterSpouseName = function(isValid) {
            var required = false;
            if (aoService.activeAdditionalDetails.marital === "M") {
                required = true;
            } else {
                aDFamilyDetailsVm.spouseName = "";
                required = false;
            }
            aDFamilyDetailsVm.disableNext = !isValid;
            return required;
        }

        //Enable/disable Spouse name based on marital status
        aDFamilyDetailsVm.disableSpouse = function() {
            var disable = true;
            if (aoService.activeAdditionalDetails.marital === "M") {
                disable = false;
            } else {
                aDFamilyDetailsVm.spouseName = "";
                disable = true;
            }
            return disable;
        }

        // If married and female - Maiden name is required 
        // Else Maiden name not required
        aDFamilyDetailsVm.maidenFn = function(){
            var disable = true;
            var titleAadhaar = aoService.customerAadhaarCardDetails.title.toLowerCase();
            var titleManual = aoService.customerManualEntryDetails.title.toLowerCase();
            if (titleAadhaar == "mrs" || titleManual == "mrs") {
                disable = false;
            } else {
                aDFamilyDetailsVm.maidenName = "";
                disable = true;
            }
            return disable;
        }
	   
        //Populate data in resume / Omnichannel
	    aDFamilyDetailsVm.populateResumeData = function(){
            aDFamilyDetailsVm.maidenName = aoService.customerAdditionalDetails.maidenName;
            aDFamilyDetailsVm.motherMname = aoService.customerAdditionalDetails.motherMaidenName;
            aDFamilyDetailsVm.spouseName = aoService.customerAdditionalDetails.spouseName;
            aDFamilyDetailsVm.fatherFname = aoService.customerAdditionalDetails.fatherFirstName;
            aDFamilyDetailsVm.fatherMname = aoService.customerAdditionalDetails.fatherMiddleName;
            aDFamilyDetailsVm.fatherLname = aoService.customerAdditionalDetails.fatherLastName;
            aDFamilyDetailsVm.motherFname = aoService.customerAdditionalDetails.motherFirstname;
            aDFamilyDetailsVm.motherMname = aoService.customerAdditionalDetails.motherMiddlename;
            aDFamilyDetailsVm.motherLname = aoService.customerAdditionalDetails.motherLastname;  
            aDFamilyDetailsVm.motherTitle = aoService.customerAdditionalDetails.motherTitleCode;
            aDFamilyDetailsVm.fatherTitle = aoService.customerAdditionalDetails.fatherTitleCode; 
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            aDFamilyDetailsVm.populateResumeData();
            aDFamilyDetailsVm.enterSpouseName();
            aDFamilyDetailsVm.disableSpouse();
            aDFamilyDetailsVm.loadTitles();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
