'use strict';

angularApp.controller('aDMaritalStatusController', ["$state",
    "$scope",
    "aoService",
    "adDetailsCommonService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        aoService,
        adDetailsCommonService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var aDMaritalStatusVm = this;

        function initPage() {
            aDMaritalStatusVm.showBack = true;
            aDMaritalStatusVm.showNext = false;
            aDMaritalStatusVm.aofooter = true;
            aDMaritalStatusVm.loadMaritalStatus();
        }

        aDMaritalStatusVm.getFamilyInfo = function() {
            $state.go("menu.aDFamilyDetails");
        }

        aDMaritalStatusVm.populateResumeData = function(){
            if(aoService.isResumeJourney == true){
                aDMaritalStatusVm.activeStatus = aoService.getIdByValue(aoService.maritalStatusList, aoService.customerAdditionalDetails.maritalStatus);
            }
        }

        aDMaritalStatusVm.loadMaritalStatus = function(){
            var requestParam = "MaritalLotus";
            aDMaritalStatusVm.isErorr = false;
            utilityService.showSpinner();
            adDetailsCommonService.getMaritalStatus(requestParam).then(function(data) {
                aDMaritalStatusVm.isErorr = false;
                utilityService.hideSpinner();
                aoService.maritalStatusList = data;
                aDMaritalStatusVm.maritalStatusList = aoService.maritalStatusList;
            }, function(error) {
            	utilityService.hideSpinner();
            	aDMaritalStatusVm.isErorr = true;
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        aDMaritalStatusVm.goBacktoPrevious = function() {
            $state.go("menu.additionalDetails");
        }

        aDMaritalStatusVm.goToNextPage = function(param) {
            aoService.activeAdditionalDetails.marital = param.value;
            aoService.customerAdditionalDetails.maritalStatus = param.description;
            $state.go("menu.aDFamilyDetails"); 
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            aDMaritalStatusVm.activeStatus = aoService.activeAdditionalDetails.marital;
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            //aDMaritalStatusVm.populateResumeData();
        });

        return this;
    }
]);
