'use strict';

angularApp.controller('aDOccupationController', ["$state",
    "$scope",
    "aoService",
    "$translate",
    "adDetailsCommonService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        aoService,
        $translate,
        adDetailsCommonService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var aDOccupationVm = this;

        function initPage() {
            aDOccupationVm.showBack = true;
            aDOccupationVm.showNext = false;
            aDOccupationVm.aofooter = true;
            aDOccupationVm.loadOccupation();
           /* aDOccupationVm.occupationList = [
                { "value": "AO_OCCSERV_BTN", "description": "Service" },
                { "value": "AO_OCCBUS_BTN", "description": "Business" },
                { "value": "AO_OCCOTHER_BTN", "description": "Others" },
                { "value": "AO_OCCNONCAT_BTN", "description": "Non-Categorized" }
            ];*/
        }

        aDOccupationVm.populateResumeData = function(){
            if(aoService.isResumeJourney == true){
                aDOccupationVm.activeStatus = aoService.getIdByValue(aDOccupationVm.occupationList, aoService.customerAdditionalDetails.occupation);
            }
        }

        aDOccupationVm.loadOccupation = function(){
			aDOccupationVm.isErorr = false;
			 utilityService.showSpinner();
            var requestParam = "OccupationLotusLevel1";
            adDetailsCommonService.getOccupation(requestParam).then(function(data) {
               aDOccupationVm.isErorr = false;
			    utilityService.hideSpinner();
                aDOccupationVm.occupationList = data;
            }, function(error) {
				 utilityService.hideSpinner();
				aDOccupationVm.isErorr = true;
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        aDOccupationVm.getReligion = function() {
            $state.go("menu.aDReligion");
        }

        aDOccupationVm.getOService = function() {
            $state.go("menu.aDOccupationService");
        }

        aDOccupationVm.goBacktoPrevious = function() {
            $state.go("menu.aDAnnualIncome");
        }

        aDOccupationVm.goToNextPage = function() {
            $state.go("menu.aDReligion");
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        /* Based on main occupation, redirect to respective sub occupation pages */
        aDOccupationVm.showHideSubOcc = function(param) {
            aoService.activeAdditionalDetails.occupation = param.value;
            aoService.customerAdditionalDetails.service = aDOccupationVm.selectedOccupation;
            aoService.customerAdditionalDetails.occupation = param.description; 
            if (param.value === "0001") {
                $state.go("menu.aDSubOccupationService");
            } 
            else if (param.value === "0002") {
                $state.go("menu.aDSubOccupationOthers");
            }
            else{
                $state.go("menu.aDReligion");
            } 
            
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            aDOccupationVm.activeStatus = aoService.activeAdditionalDetails.occupation;
            //aDOccupationVm.populateResumeData();
        });

        return this;
    }
]);
