'use strict';

angularApp.controller('aDReligionController', ["$state",
    "$scope",
    "aoService",
    "adDetailsCommonService",
    "utilityService",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        aoService,
        adDetailsCommonService,
        utilityService,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var aDReligionVm = this;

        function initPage() {
            aDReligionVm.showBack = true;
            aDReligionVm.showNext = true;
            aDReligionVm.aofooter = true;
            aDReligionVm.religionList = [{ "value": "AO_RELHINDU_BTN", "description": "Hindu" },
                { "value": "AO_RELCHRIST_BTN", "description": "Christian" },
                { "value": "AO_RELMUSLIM_BTN", "description": "Muslim" },
                { "value": "AO_RELSIKH_BTN", "description": "Sikh" },
                { "value": "AO_RELOTHER_BTN", "description": "Others" }
            ];
        }

        aDReligionVm.goBacktoPrevious = function() {
            if(!utilityService.isUndefined(aoService.customerAdditionalDetails.subOccupation)){
                if(aoService.activeAdditionalDetails.occupation == "0001"){
                    $state.go("menu.aDSubOccupationService");
                }
                else if(aoService.activeAdditionalDetails.occupation == "0002"){
                    $state.go("menu.aDSubOccupationOthers");
                }
                else{
                    $state.go("menu.aDOccupation");
                }
            }
            else{
                 $state.go("menu.aDOccupation");
            }
        }

        //If Religion is not selected and clicked on "Next" navigate to the next page
        aDReligionVm.goToNextPage = function() {
            aDReligionVm.updateAdditionalDetailsCall();
        }

        //If Religion is selected, get religion data and navigate
        aDReligionVm.goToNextPageReligion = function(param) {
            aoService.activeAdditionalDetails.religion = param.value;
            aoService.customerAdditionalDetails.religion = param.description;
            aDReligionVm.updateAdditionalDetailsCall();
        }

        aDReligionVm.populateResumeData = function(){
            
                aDReligionVm.activeStatus = aoService.getIdByValue(aDReligionVm.religionList, aoService.customerAdditionalDetails.religion);
            
        }

        //Service to update additional detail
        aDReligionVm.updateAdditionalDetailsCall = function() {
            var requestParams = {
                "id": aoService.customer.mobileNo,
                "data":{
                    "additionalDetails":{
                        "maidenName": aoService.customerAdditionalDetails.maidenName,
                        "fatherName": aoService.customerAdditionalDetails.fatherName,
                        "fatherFirstName": aoService.customerAdditionalDetails.fatherFirstName,
                        "fatherMiddleName":aoService.customerAdditionalDetails.fatherMiddleName,
                        "fatherLastName":aoService.customerAdditionalDetails.fatherLastName,
                        "spouseName": aoService.customerAdditionalDetails.spouseName,
                        "motherMaidenName": aoService.customerAdditionalDetails.motherMaidenName,
                        "maritalStatus": aoService.customerAdditionalDetails.maritalStatus,
                        "maritalStatusCode":aoService.activeAdditionalDetails.marital,
                        "annualIncome": aoService.customerAdditionalDetails.annualIncome,
                        "annualIncomeCode":aoService.activeAdditionalDetails.income,
                        "religion": aoService.customerAdditionalDetails.religion,
                        "religionCode":aoService.activeAdditionalDetails.religion,
                        "education": aoService.customerAdditionalDetails.education,
                        "educationCode":aoService.activeAdditionalDetails.education,
                        "occupation": aoService.customerAdditionalDetails.occupation,
                        "occupationCode":aoService.activeAdditionalDetails.occupation,
                        "subOccupation": aoService.customerAdditionalDetails.subOccupation,
                        "subOccupationCode":aoService.activeAdditionalDetails.suboccupation,
                        "motherFirstName":aoService.customerAdditionalDetails.motherFirstname,
                        "motherMiddleName":aoService.customerAdditionalDetails.motherMiddlename,
                        "motherLastName":aoService.customerAdditionalDetails.motherLastname,
                        "motherTitle":aoService.customerAdditionalDetails.motherTitle,
                        "motherTitleCode":aoService.customerAdditionalDetails.motherTitleCode, 
                        "fatherTitle":aoService.customerAdditionalDetails.fatherTitle,
                        "fatherTitleCode":aoService.customerAdditionalDetails.fatherTitleCode
                    },
                    "commonId":$state.$current.data.commonId
                }             
            }
            adDetailsCommonService.updateAdditionalDetails(requestParams).then(function(response) {
                var responseCode = response.responseCode;
                if (responseCode === constantConfig.successCode) {
                    $state.go("menu.nomineeDetails"); 
                }
                
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            //aDReligionVm.activeStatus = aoService.activeAdditionalDetails.religion;
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            aDReligionVm.populateResumeData();
        });

        return this;
    }
]);
