'use strict';

angularApp.controller('aDSubOccupationController', ["$state",
    "$scope",
    "aoService",
    "adDetailsCommonService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        aoService,
        adDetailsCommonService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var aDSubOccupationVm = this;

        function initPage() {
            aDSubOccupationVm.showBackService = true;
            aDSubOccupationVm.showNextService = false;
            aDSubOccupationVm.showBackOthers = true;
            aDSubOccupationVm.showNextOthers = false;
            aDSubOccupationVm.aofooter = true;
            aDSubOccupationVm.loadSubOccupationService();
            aDSubOccupationVm.loadSubOccupationOthers();
            aDSubOccupationVm.mainOccupationLabel = aoService.customerAdditionalDetails.occupation;
        }

        aDSubOccupationVm.goBacktoPrevious = function() {
            $state.go("menu.aDOccupation");
        }

        aDSubOccupationVm.goToNextPage = function(param) {
            aoService.activeAdditionalDetails.suboccupation = param.value;
            aoService.customerAdditionalDetails.subOccupation = param.description;
            $state.go("menu.aDReligion");
        }

        aDSubOccupationVm.populateResumeData = function(){
            if(aoService.isResumeJourney == true){
                if(aoService.activeAdditionalDetails.occupation == "0001"){
                    aDSubOccupationVm.activeStatus = aoService.getIdByValue(aDSubOccupationVm.serviceOccupationList, aoService.customerAdditionalDetails.subOccupation);
                }
                else{
                    aDSubOccupationVm.activeStatus = aoService.getIdByValue(aDSubOccupationVm.othersOccupationList, aoService.customerAdditionalDetails.subOccupation);
                }
                
            }
        }

        aDSubOccupationVm.loadSubOccupationService = function(){
        	aDSubOccupationVm.isErorr = false;
			utilityService.showSpinner();
            var requestParam = "OccupationLotusService";
            adDetailsCommonService.getOccupation(requestParam).then(function(data) {
            	aDSubOccupationVm.isErorr = false;
			    utilityService.hideSpinner();
                       
                aDSubOccupationVm.serviceOccupationList = data;
            }, function(error) {
            	aDSubOccupationVm.isErorr = true;
			    utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        aDSubOccupationVm.loadSubOccupationOthers = function(){
        	aDSubOccupationVm.isErorr = false;
			utilityService.showSpinner();
            var requestParam = "OccupationLotusOthers";
            adDetailsCommonService.getOccupation(requestParam).then(function(data) {
                aDSubOccupationVm.isErorr = false;
			    utilityService.hideSpinner();         
                aDSubOccupationVm.othersOccupationList = data;
            }, function(error) {
            	aDSubOccupationVm.isErorr = true;
			    utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            if(aoService.activeAdditionalDetails.occupation == "0001"){
                aDSubOccupationVm.activeStatusService = aoService.activeAdditionalDetails.suboccupation;
            }
            else if(aoService.activeAdditionalDetails.occupation == "0002"){
                aDSubOccupationVm.activeStatusOthers = aoService.activeAdditionalDetails.suboccupation;
            }
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            //aDSubOccupationVm.populateResumeData();
        });

        return this;
    }
]);
