'use strict';

angularApp.service('adDetailsCommonService',
    function($q, AdapterUtils, constantConfig) {
        var adDetailsCommonService = this;
        adDetailsCommonService.updateAdditionalDetails = function(requestData) {
            var q = $q.defer();

            //Service to update all the additional details of the customer
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.updateAdditionalDetail, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };

        adDetailsCommonService.getAnnualIncome = function(param) {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.loadMasterData + param, true).then(

                function(response) {
                    q.resolve(response.data);                    
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        
        adDetailsCommonService.getQualification = function(param) {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.loadMasterData + param, true).then(

                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        adDetailsCommonService.getMaritalStatus = function(param) {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.loadMasterData + param, true).then(

                function(response) {
                    q.resolve(response.data);
               
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        adDetailsCommonService.getOccupation = function(param) {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.loadMasterData + param, true).then(

                function(response) {
                    q.resolve(response.data);
         
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        adDetailsCommonService.loadTitle = function(param) {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.loadMasterData + param, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };



        return adDetailsCommonService;
    });
