'use strict';

angularApp.controller('additionalDetailsController', ["$state",
    "$scope",
    "aoService",
    "adDetailsCommonService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        aoService,
        adDetailsCommonService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var additionalDetailsVm = this;

        function initPage() {
            additionalDetailsVm.showBack = true;
            additionalDetailsVm.showNext = false;
            additionalDetailsVm.aofooter= true;
            additionalDetailsVm.loadQualification();
        }

        additionalDetailsVm.getMariatlStatus = function() {
            $state.go("menu.aDMaritalStatus")
        }

        additionalDetailsVm.loadQualification = function(){
            var requestParam = "EducationLotus";
            additionalDetailsVm.isErorr = false;
            utilityService.showSpinner();
            adDetailsCommonService.getQualification(requestParam).then(function(data) {
                additionalDetailsVm.isErorr = false;
                utilityService.hideSpinner();
                additionalDetailsVm.eduQualificationList = data;
            }, function(error) {
            	utilityService.hideSpinner();
            	additionalDetailsVm.isErorr = true;
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        additionalDetailsVm.populateResumeData = function(){
            if(aoService.isResumeJourney == true){
                additionalDetailsVm.activeStatus = aoService.getIdByValue(additionalDetailsVm.eduQualificationList, aoService.customerAdditionalDetails.education);
            }
        }

        additionalDetailsVm.goBacktoPrevious = function() {            
            $state.go("menu.aOLooksGreat");
        }


        additionalDetailsVm.goToNextPage = function(param) {
            aoService.activeAdditionalDetails.education = param.value;
            aoService.customerAdditionalDetails.education = param.description;
            $state.go("menu.aDMaritalStatus"); 
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            additionalDetailsVm.activeStatus = aoService.activeAdditionalDetails.education;
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            //additionalDetailsVm.populateResumeData();
        });

        return this;
    }
]);
