/**
*   @ngdoc config
*   @name angularApp.config : aoConfig
*   @description
*	configuration file for account opening module
*/

'use strict';

/*State definition with respective names, urls, controllers and templates */
angularApp.config(['$stateProvider',
	function ($stateProvider) {

		//Account Opening start
		$stateProvider
			.state('menu.applyNewOrResume', {
				url: '/applyNewOrResume',
				data: {
					pageId: 'AO_NWORRSM',
					sectionId: 'applyNewOrResumeSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/applyNewOrResume/applyNewOrResume.html',
						controller: 'applyNewOrResumeController',
						controllerAs: 'applyNewOrResumeVm',
					}
				}
			})
			.state('menu.accountOpening', {
				url: '/accountOpening',
				data: {
					pageId: 'AO_HOM',
					sectionId: 'accountOpeningSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/accountOpening/accountOpening.html',
						controller: 'accountOpeningController',
						controllerAs: 'accountOpeningVm',
					}
				}
			})
			.state('menu.passwordRecovery', {
				url: '/passwordRecovery',
				data: {
					pageId: 'AO_PWDRCVRY',
					sectionId: 'accountOpeningSection'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/passwordRecovery/passwordRecovery.html',
						controller: 'passwordRecoveryController',
						controllerAs: 'passwordRecoveryVm',
					}
				}
			})
			.state('menu.passwordOTP', {
				url: '/passwordOTP',
				data: {
					pageId: 'AO_PWDOTP',
					sectionId: 'accountOpeningSection'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/passwordOTP/passwordOTP.html',
						controller: 'passwordOTPController',
						controllerAs: 'passwordOTPVm',
					}
				}
			})
			.state('menu.knowMore', {
				url: '/knowMore',
				data: {
					pageId: 'AO_KNOWMORE',
					sectionId: 'accountOpeningSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/accountOpening/knowMore.html',
						controller: 'knowMoreController',
						controllerAs: 'knowMoreVm',
					}
				}
			})
			.state('menu.aOGetPicture', {
				url: '/aOGetPicture',
				data: {
					pageId: 'AO_AOGETPIC',
					sectionId: 'sub.aoCustomerImage'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/accountOpening/accountOpeningGetPicture.html',
						controller: 'accountOpeningGetPictureController',
						controllerAs: 'aOGetPictureVm',
					}
				}
			})
			.state('menu.aOTakeSelfie', {
				url: '/aOTakeSelfie',
				data: {
					pageId: 'AO_AOTKSLF',
					sectionId: 'sub.aoCustomerImage'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/accountOpening/accountOpeningTakeSelfie.html',
						controller: 'accountOpeningTakeSelfieController',
						controllerAs: 'aOTakeSelfieVm',
					}
				}
			})
			.state('menu.aOLooksGreat', {
				url: '/aOLooksGreat',
				data: {
					pageId: 'AO_AOLOKGRT',
					sectionId: 'sub.aoCustomerImage',
					commonId: 'PersonalDetailsPHOTO'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/accountOpening/accountOpeningLooksGreat.html',
						controller: 'accountOpeningLooksGreatController',
						controllerAs: 'aOLooksGreatVm',
					}
				}
			})
			.state('menu.getOTP', {
				url: '/getOTP',
				data: {
					pageId: 'AO_GETOTP',
					sectionId: 'getOTPSection'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/getOTP/getOTP.html',
						controller: 'getOTPController',
						controllerAs: 'getOTPVm',
					}
				}
			})
			.state('menu.mobileEntryPage', {
				url: '/mobileEntryPage',
				data: {
					pageId: 'AO_ENTERMOBNO',
					sectionId: 'getOTPSection'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/mobileEntryPage/mobileEntryPage.html',
						controller: 'mobileEntryPageController',
						controllerAs: 'mobileEntryPageVm',
					}
				}
			})
			.state('menu.appPassword', {
				url: '/appPassword',
				data: {
					pageId: 'AO_APPPWD',
					sectionId: 'aoPasswordSection',
					commonId: 'createPassword'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/appPassword/appPassword.html',
						controller: 'appPasswordController',
						controllerAs: 'appPasswordVm',
					}
				}
			})
			.state('menu.regenerateAppPassword', {
				url: '/regenerateAppPassword',
				data: {
					pageId: 'AO_REGAPPPWD',
					sectionId: 'aoPasswordSection'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/regenerateAppPassword/regenerateAppPassword.html',
						controller: 'regenerateAppPasswordController',
						controllerAs: 'regenerateAppPasswordVm',
					}
				}
			})
			.state('menu.tax', {
				url: '/tax',
				data: {
					pageId: 'AO_TAX',
					sectionId: 'sub.customeraoFatcaCrsDeclare',
					commonId: 'FATCA'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/tax/tax.html',
						controller: 'taxController',
						controllerAs: 'taxVm',
					}
				}
			})
			.state('menu.pdetailsAN', {
				url: '/pdetailsAN',
				data: {
					pageId: 'AO_PRSLDETLAN',
					sectionId: 'sub.customeraoAadharDetails'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/personalDetails/personalDetailsAN.html',
						controller: 'personalDetailsANController',
						controllerAs: 'pdetailsANVm',
					}
				}
			})
			.state('menu.pdetailsAddress', {
				url: '/pdetailsAddress',
				data: {
					pageId: 'AO_PRSLDETLADR',
					sectionId: 'aoPersonalDetailsSection',
					commonId: 'AadharScanned'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/personalDetails/personalDetailsAddress.html',
						controller: 'personalDetailsAddressController',
						controllerAs: 'pdetailsAddressVm',
					}
				}
			})
			.state('menu.pdetailsCAddress', {
				url: '/pdetailsCAddress',
				data: {
					pageId: 'AO_PRSLDETLCADR',
					sectionId: 'sub.aoCustomerAddresss',
					commonId: 'CorrespondenceAddress'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/personalDetails/personalDetailsCAddress.html',
						controller: 'personalDetailsCAddressController',
						controllerAs: 'pdetailsCAddressVm',
					}
				}
			})
			.state('menu.panDetails', {
				url: '/panDetails',
				data: {
					pageId: 'AO_PANDETL',
					sectionId: 'sub.aoEnterPAN',
					commonId: 'PAN'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/panDetails/panDetails.html',
						controller: 'panDetailsController',
						controllerAs: 'panDetailsVm',
					}
				}
			})
			.state('menu.panAuthorise', {
				url: '/panAuthorise',
				data: {
					pageId: 'AO_PANAUTH',
					sectionId: 'sub.customerAOagreeTerms',
					commonId: 'AaDharPANDeclaration'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/panAuthorise/panAuthorise.html',
						controller: 'panAuthoriseController',
						controllerAs: 'panAuthoriseVm',
					}
				}
			})
			.state('menu.foreign', {
				url: '/foreign',
				data: {
					pageId: 'AO_FRGN',
					sectionId: 'aoTaxSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/foreign/foreign.html',
						controller: 'foreignController',
						controllerAs: 'foreignVm',
					}
				}
			})
			.state('menu.personalDetails', {
				url: '/personalDetails',
				data: {
					pageId: 'AO_PRSLDETL',
					sectionId: 'aoPersonalDetailsSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/personalDetails/personalDetails.html',
						controller: 'personalDetailsController',
						controllerAs: 'personalDetailsVm',
					}
				}
			})
			.state('menu.aadhar', {
				url: '/aadhar',
				data: {
					pageId: 'AO_ADHRSCN',
					sectionId: 'aoPersonalDetailsSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/personalDetails/aadharscan.html',
						controller: 'aadharscanController',
						controllerAs: 'aadharvm',
					}
				}
			})
			.state('menu.additionalDetails', {
				url: '/additionalDetails',
				data: {
					pageId: 'AO_ADNLDETL',
					sectionId: 'sub.customeraoAdditionalDetailsMore'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/additionalDetails/additionalDetails.html',
						controller: 'additionalDetailsController',
						controllerAs: 'additionalDetailsVm',
					}
				}
			})
			.state('menu.aDMaritalStatus', {
				url: '/aDMaritalStatus',
				data: {
					pageId: 'AO_MRTLSTUS',
					sectionId: 'sub.customeraoAdditionalDetails'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/additionalDetails/aDMaritalStatus.html',
						controller: 'aDMaritalStatusController',
						controllerAs: 'aDMaritalStatusVm',
					}
				}
			})
			.state('menu.aDFamilyDetails', {
				url: '/aDFamilyDetails',
				data: {
					pageId: 'AO_FMLYDETL',
					sectionId: 'sub.customeraoAdditionalDetails'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/additionalDetails/aDFamilyDetails.html',
						controller: 'aDFamilyDetailsController',
						controllerAs: 'aDFamilyDetailsVm',
					}
				}
			})
			.state('menu.aDAnnualIncome', {
				url: '/aDAnnualIncome',
				data: {
					pageId: 'AO_ANULINCM',
					sectionId: 'sub.customeraoAdditionalDetailsMore'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/additionalDetails/aDAnnualIncome.html',
						controller: 'aDAnnualIncomeController',
						controllerAs: 'aDAnnualIncomeVm',
					}
				}
			})
			.state('menu.aDOccupation', {
				url: '/aDOccupation',
				data: {
					pageId: 'AO_OCPTN',
					sectionId: 'sub.customeraoAdditionalDetails'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/additionalDetails/aDOccupation.html',
						controller: 'aDOccupationController',
						controllerAs: 'aDOccupationVm',
					}
				}
			})
			.state('menu.aDSubOccupationService', {
				url: '/aDSubOccupationService',
				data: {
					pageId: 'AO_SUBOCPTN',
					sectionId: 'aoAdditionalDetailsSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/additionalDetails/aDSubOccupationService.html',
						controller: 'aDSubOccupationController',
						controllerAs: 'aDSubOccupationVm',
					}
				}
			})
			.state('menu.aDSubOccupationOthers', {
				url: '/aDSubOccupationOthers',
				data: {
					pageId: 'AO_SUBOCPTNOTHR',
					sectionId: 'aoAdditionalDetailsSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/additionalDetails/aDSubOccupationOthers.html',
						controller: 'aDSubOccupationController',
						controllerAs: 'aDSubOccupationVm',
					}
				}
			})
			.state('menu.aDReligion', {
				url: '/aDReligion',
				data: {
					pageId: 'AO_RLGN',
					sectionId: 'sub.customeraoAdditionalDetailsMore',
					commonId: 'AdditionalDetails'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/additionalDetails/aDReligion.html',
						controller: 'aDReligionController',
						controllerAs: 'aDReligionVm',
					}
				}
			})
			.state('menu.aDCityCountry', {
				url: '/aDCityCountry',
				data: {
					pageId: 'AO_CTYCNTY',
					sectionId: 'aoPersonalDetailsSection',
					commonId: 'AadharManual'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/birthCityCountry/aDCityCountry.html',
						controller: 'aDCityCountryController',
						controllerAs: 'aDCityCountryVm',
					}
				}
			})
			.state('menu.termsAndConditions', {
				url: '/termsAndConditions',
				data: {
					pageId: 'AO_TNC',
					sectionId: 'sub.customerTandC',
					commonId: 'TnC'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/termsAndConditions/termsAndConditions.html',
						controller: 'termsAndConditionsController',
						controllerAs: 'termsAndConditionsVm',
					}
				}
			})
			.state('menu.productOffering', {
				url: '/productOffering',
				data: {
					pageId: 'AO_PRDTOFRG',
					sectionId: 'sub.customerproductoffer',
					commonId: 'OIOO'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/productOffering/productOffering.html',
						controller: 'productOfferingController',
						controllerAs: 'productOfferingVm',
					}
				}
			})
			.state('menu.enterOTP', {
				url: '/enterOTP',
				data: {
					pageId: 'AO_ENTROTP',
					sectionId: 'aoTermsConditionSection',
					commonId: 'tncOtp'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/enterOTP/enterOTP.html',
						controller: 'enterOTPAoController',
						controllerAs: 'enterOTPAoVm',
					}
				}
			})
			.state('menu.tempLogin', {
				url: '/tempLogin',
				data: {
					pageId: 'AO_TMPLGN',
					sectionId: 'aoTempLoginSection'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/tempLogin/tempLogin.html',
						controller: 'tempLoginController',
						controllerAs: 'tempLoginVm',
					}
				}
			})
			.state('menu.accountOpeningDetails', {
				url: '/accountOpeningDetails',
				data: {
					pageId: 'AO_AODETL',
					sectionId: 'aoAccountopeningDetailSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/accountOpeningDetails/accountOpeningDetails.html',
						controller: 'accountOpeningDetailsController',
						controllerAs: 'accountOpeningDetailsVm',
					}
				}
			})
			.state('menu.netBankingRegister', {
				url: '/netBankingRegister',
				data: {
					pageId: 'AO_NETBNKGREG',
					sectionId: 'netBankingRegisterSection'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/netBankingRegistration/netBankingRegister.html',
						controller: 'netBankingRegisterController',
						controllerAs: 'netBankingRegisterVm',
					}
				}
			})
			.state('menu.addFundsOptions', {
				url: '/addFundsOptions',
				data: {
					pageId: 'AO_ADDFUNDOPTN',
					sectionId: 'aoAddFundsSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/addFundsToAccountOptions/addFundsOptions.html',
						controller: 'addFundsOptionsController',
						controllerAs: 'addFundsOptionsVm',
					}
				}
			})
			.state('menu.map', {
				url: '/map',
				data: {
					pageId: 'AO_MAP',
					sectionId: 'aoMapSection'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/map/map.html',
						controller: 'mapController',
						controllerAs: 'mapVm',
					}
				}
			})
			.state('menu.nomineeDetails', {
				url: '/nomineeDetails',
				data: {
					pageId: 'AO_NOMDETL',
					sectionId: 'aoNomineeDetailsSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/nomineeDetails/nomineeDetails.html',
						controller: 'nomineeDetailsController',
						controllerAs: 'nomineeDetailsVm',
					}
				}
			})
			.state('menu.nominationRelated', {
				url: '/nominationRelated',
				data: {
					pageId: 'AO_NOMDETLRLTDFRST',
					sectionId: 'sub.customeraoNomineeDetails'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/nomineeDetails/nomineeDetailsRelatedFirst.html',
						controller: 'nomineeDetailsRelatedController',
						controllerAs: 'nomineeDetailsRelatedVm',
					}
				}
			})
			.state('menu.nomineeDetailsNext', {
				url: '/nomineeDetailsNext',
				data: {
					pageId: 'AO_NOMDETLRLTD',
					sectionId: 'sub.customeraoNomineeDetails',
					commonId: 'NomineeDetails'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/nomineeDetails/nomineeDetailsRelated.html',
						controller: 'nomineeDetailsRelatedController',
						controllerAs: 'nomineeDetailsRelatedVm',
					}
				}
			})
			.state('menu.nomineeDetailsAddressOption', {
				url: '/nomineeDetailsAddressOption',
				data: {
					pageId: 'AO_NOMDETLADDOPTN',
					sectionId: 'sub.customeraoNomineeDetailsMore'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/nomineeDetails/nomineeDetailsAddressOption.html',
						controller: 'nomineeDetailsAddressOptionController',
						controllerAs: 'nomineeDetailsAddressOptionVm',
					}
				}
			})
			.state('menu.nomineeEnteredAddress', {
				url: '/nomineeEnteredAddress',
				data: {
					pageId: 'AO_NOMENTDADD',
					sectionId: 'sub.customeraoNomineeDetailsMore',
					commonId: 'GuardianDetails'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/nomineeDetails/nomineeEnteredAddress.html',
						controller: 'nomineeEnteredAddressController',
						controllerAs: 'nomineeEnteredAddressVm',
					}
				}
			})
			.state('menu.nomineeAddress', {
				url: '/nomineeAddress',
				data: {
					pageId: 'AO_NOMADD',
					sectionId: 'sub.customeraoNomineeDetailsMore',
					commonId: 'GuardianDetails'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/nomineeDetails/nomineeAddress.html',
						controller: 'nomineeAddressController',
						controllerAs: 'nomineeAddressVm',
					}
				}
			})
			.state('menu.nomineeCAddress', {
				url: '/nomineeCAddress',
				data: {
					pageId: 'AO_NOMCADD',
					sectionId: 'sub.customeraoNomineeDetailsMore',
					commonId: 'GuardianDetails'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/nomineeDetails/nomineeCAddress.html',
						controller: 'nomineeCAddressController',
						controllerAs: 'nomineeCAddressVm',
					}
				}
			})
			.state('menu.aadhaarManualEntry', {
				url: '/aadhaarManualEntry',
				data: {
					pageId: 'AO_COPDADD',
					sectionId: 'sub.customeraoAadharDetails',
					commonId: 'AadharManual'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/aadhaarManualEntry/aadhaarManualEntry.html',
						controller: 'aadhaarManualEntryController',
						controllerAs: 'aadhaarManualEntryVm',
					}
				}
			})
			.state('menu.aadhaarManualEntryAddress', {
				url: '/aadhaarManualEntryAddress',
				data: {
					pageId: 'AO_COPDADD',
					sectionId: 'aoAadhaarManualEntrySection',
					commonId: 'AadharManual'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/aadhaarManualEntry/aadhaarManualEntryAddress.html',
						controller: 'aadhaarManualEntryAddressController',
						controllerAs: 'aadhaarManualAddressVm',
					}
				}
			})
			.state('menu.aadhaarManualEntryCAddress', {
				url: '/aadhaarManualEntryCAddress',
				data: {
					pageId: 'AO_COPDADD',
					sectionId: 'aoAadhaarManualEntrySection',
					commonId: 'CorrespondenceAddress'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/aadhaarManualEntry/aadhaarManualEntryCAddress.html',
						controller: 'aadhaarManualEntryCAddressController',
						controllerAs: 'aadhaarManualCaddressVm',
					}
				}
			})
			.state('menu.selectBranchOption', {
				url: '/selectBranchOption',
				data: {
					pageId: 'AO_SELBRCHOPTN',
					sectionId: 'sub.customerAOhomeBranchGPS'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/selectBranch/selectBranchOption.html',
						controller: 'selectBranchOptionController',
						controllerAs: 'selectBranchOptionVm',
					}
				}
			})
			.state('menu.selectBranchListGps', {
				url: '/selectBranchListGps',
				data: {
					pageId: 'AO_SELBRCHLSTGPS',
					sectionId: 'sub.customerlocationByGPS',
					commonId: 'HomeBranch'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/selectBranch/selectBranchListGps.html',
						controller: 'selectBranchListGpsController',
						controllerAs: 'selectBranchListGpsVm',
					}
				}
			})
			.state('menu.selectBranchListLocality', {
				url: '/selectBranchListLocality',
				data: {
					pageId: 'AO_SELBRCHLSTLCTY',
					sectionId: 'sub.customerByLocality',
					commonId: 'HomeBranch'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/selectBranch/selectBranchListLocality.html',
						controller: 'selectBranchListLocController',
						controllerAs: 'selectBranchListLocVm',
					}
				}
			})
			.state('menu.locateBranch', {
				url: '/locateBranch',
				data: {
					pageId: 'AO_LCTBRCH',
					sectionId: 'aoTaxSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/locateBranch/locateBranch.html',
						controller: 'locateBranchController',
						controllerAs: 'locateBranchVm',
					}
				}
			})
			.state('menu.updateAadhaar', {
				url: '/updateAadhaar',
				data: {
					pageId: 'AO_UPDADHR',
					sectionId: 'updateAadhaarSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/updateAadhaar/updateAadhaar.html',
						controller: 'updateAadhaarController',
						controllerAs: 'updateAadhaarVm',
					}
				}
			})
			.state('menu.multipleCustomer', {
				url: '/multipleCustomer',
				data: {
					pageId: 'AO_MULCUST',
					commonId: 'AaDharPANDeclaration'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/multipleCustomer/multipleCustomer.html',
						controller: 'multipleCustomerController',
						controllerAs: 'multipleCustomerVm',
					}
				}
			})
			.state('menu.passbookDetails', {
				url: '/passbookDetails',
				data: {
					pageId: 'AO_PASSBOOKDETL',
					commonId: 'AaDharPANDeclaration'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/passbookDetails/passbookDetails.html',
						controller: 'passbookDetailsController',
						controllerAs: 'passbookDetailsVm',
					}
				}
			})
			.state('menu.debitCardDetails', {
				url: '/debitCardDetails',
				data: {
					pageId: 'AO_DBTCRDDETL',
					sectionId: 'sub.customerDebitdetails',
					commonId: 'DebitCard'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/debitCardDetails/debitCardDetails.html',
						controller: 'debitCardDetailsController',
						controllerAs: 'debitCardDetailsVm',
					}
				}
			})
			.state('menu.branchDetails', {
				url: '/branchDetails',
				data: {
					pageId: 'AO_BRCHDETL',
					sectionId: 'aoDebitCardDetailSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/branchDetails/branchDetails.html',
						controller: 'branchDetailsController',
						controllerAs: 'branchDetailsVm',
					}
				}
			})
			.state('menu.receiveDebitCard', {
				url: '/receiveDebitCard',
				data: {
					pageId: 'AO_RCVDBTCRD',
					sectionId: 'sub.customerDebitdetails',
					commonId: 'DebitCard'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/receiveDebitCard/receiveDebitCard.html',
						controller: 'receiveDebitCardController',
						controllerAs: 'receiveDebitCardVm',
					}
				}
			})
			.state('menu.enterOTPReferenceCode', {
				url: '/enterOTPReferenceCode',
				data: {
					pageId: 'AO_ENTROTPREFCOD',
					sectionId: 'aoReferenceCodeSection'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/enterOTPReferenceCode/enterOTPReferenceCode.html',
						controller: 'enterOTPReferenceCodeController',
						controllerAs: 'enterOTPReferenceCodeVm',
					}
				}
			})
			.state('menu.locateNearestBranch', {
				url: '/locateNearestBranch',
				data: {
					pageId: 'AO_LOCNEARBRCH',
					sectionId: 'aoLocateNearestBranchSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/locateNearestBranch/locateNearestBranch.html',
						controller: 'locateNearestBranchController',
						controllerAs: 'locateNearestBranchVm',
					}
				}
			})
			.state('menu.locateBranchByLocality', {
				url: '/locateBranchByLocality',
				data: {
					pageId: 'AO_LOCNEARBRCH',
					sectionId: 'aoLocateNearestBranchSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/locateNearestBranch/locateBranchByLocality.html',
						controller: 'locateBranchByLocalityController',
						controllerAs: 'locateBranchLocVm',
					}
				}
			})
			.state('menu.sbiInTouchRegisterOptions', {
				url: '/sbiInTouchRegisterOptions',
				data: {
					pageId: 'AO_SBIINTCHREGOPTN',
					sectionId: 'aoSbiIntouchRegisterSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/sbiInTouch/sbiInTouchRegisterOptions.html',
						controller: 'sbiInTouchRegisterOptionsController',
						controllerAs: 'sbiInTouchRegisterOptionsVm',
					}
				}
			})
			.state('menu.homePage', {
				url: '/homePage',
				data: {
					pageId: 'AO_HOMPG',
					sectionId: 'aoHomePageSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/homePage/homePage.html',
						controller: 'homePageController',
						controllerAs: 'homePageVm',
					}
				}
			})
			.state('menu.addFundsToYourAccount', {
				url: '/addFundsToYourAccount',
				data: {
					pageId: 'AO_ADDFNDTOACCT',
					sectionId: 'aoAddFundSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/addFundsToYourAccount/addFundsToYourAccount.html',
						controller: 'addFundsToYourAccountController',
						controllerAs: 'addFundsToYourAccountVm',
					}
				}
			})
			.state('menu.aoMpin', {
				url: '/MPIN',
				data: {
					pageId: 'AO_MPIN',
					sectionId: 'aoMPINSection'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/MPIN/MPIN.html',
						controller: 'MPINController',
						controllerAs: 'mPINVm',
					}
				}
			})
			.state('menu.detailsExist', {
				url: '/detailsExist',
				data: {
					pageId: 'AO_DETLEXST',
					sectionId: 'aodetailsExistSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/detailsExist/detailsExist.html',
						controller: 'detailsExistController',
						controllerAs: 'detailsExistVm',
					}
				}
			})
			.state('menu.resumeJourney', {
				url: '/resumeJourney',
				data: {
					pageId: 'AO_RESMJRNY',
					sectionId: 'aoResumeSection'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/resumeJourney/resumeJourney.html',
						controller: 'resumeJourneyController',
						controllerAs: 'resumeJourneyVm',
					}
				}
			})
			.state('menu.direction', {
				url: '/direction',
				data: {
					pageId: 'AO_DIRECTION',
					sectionId: 'aoDirectionSection'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/direction/direction.html',
						controller: 'directionController',
						controllerAs: 'directionVm',
					}
				}
			})
			.state('menu.locateBranchByGps', {
				url: '/locateBranchByGps',
				data: {
					pageId: 'AO_LOCNEARBRCHBYGPS',
					sectionId: 'aoLocateNearestBranchSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/locateNearestBranch/locateBranchByGps.html',
						controller: 'locateBranchByGpsController',
						controllerAs: 'locateBranchGpsVm',
					}
				}
			})
			.state('menu.locateNearestBranchByGPS', {
				url: '/locateNearestBranchByGPS',
				data: {
					pageId: 'AO_LOCNEARBRCH',
					sectionId: 'aoLocateNearestBranchSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/preHomeLogin/locateNearestBranchByGPS.html',
						controller: 'locateBranchByGpsController',
						controllerAs: 'locateBranchGpsVm',
					}
				}
			})
			.state('menu.VIDDetails', {
				url: '/VIDDetails',
				data: {
					pageId: 'AO_VID',
					sectionId: 'sub.VIDDetails',
					commonId: 'VIDDetails'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/AO/VID/VIDDetails.html',
						controller: 'VIDDetailsController',
						controllerAs: 'VIDDetailsVm',
					}
				}
			})
	}]);