'use strict';

angularApp.service('aoService', ['$state', "utilityService","mPinLoginService",
    function($state, utilityService, mPinLoginService) {
        var AOservice = this;

        AOservice.customer = {
            aadharNumber: '',
            title: '',
            name: '',
            gender: '',
            dateOfYear: '',
            address: '',
            pincode: '',
            city: '',
            state: '',
            emailId: '',
            mobileNo: '',
            panNumber: '',
            lotusId: '1234',
            image: 'abc',
            deviceUid: '',
            deviceOS: '',
            referenceCode: '',
            photo: '',
            guardian: '',
            latitude: '',
            longitude: '',
            encodephoto: ''
        }

        AOservice.customerAdditionalDetails = {
            "maidenName": "",
            "fatherName": "",
            "fatherFirstName": "",
            "fatherMiddleName": "",
            "fatherLastName": "",
            "spouseName": "",
            "motherMaidenName": "",
            "maritalStatus": "",
            "annualIncome": "",
            "occupation": "",
            "subOccupation": "",
            "religion": "",
            "education": "",
            "cityOfBirth": "",
            "countryOfBirth": "",
            "nationality":"",
            "nationalityID":"",
            "citizenship":"",
            "citizenshipID":"",
            "motherFirstname":"",
            "motherMiddlename":"",
            "motherLastname":"",
            "motherTitle":"",
            "motherTitleCode":"",
            "fatherTitle":"",
            "fatherTitleCode":""
        }

        AOservice.mapCoords = {
            latitude:'',
            longitude:''
        }

        AOservice.mapGPS = [];

        AOservice.debitCardDetails = {
            "firstName": '',
            "lastName": ''
        }

        AOservice.selectByGPS = [];
        AOservice.locateByGPS = [];


        AOservice.customerCorrespondenceAddress = {
            address1: "",
            address2: "",
            state: "",
            stateCode: "",
            city: "",
            cityCode: "",
            pincode: "",
            isAadharScanned: false,
            locality: ""
        }

        AOservice.customerManualEntryDetails = {
            aadharNumber: "",
            firstName: "",
            lastName: "",
            middleName: "",
            fullName: "",
            gender: "",
            genderCode:"",
            title: "",
            titleCode:"",
            dob: "",
            address1: "",
            address2: "",
            city: "",
            cityCode: "",
            state: "",
            stateCode: "",
            pincode: "",
            isAadharScanned: false,
            locality: "",
            addressLine1: "",
            addressLine2: ""

        }

        AOservice.customerAadhaarCardDetails = {
            uid: "",
            name: "",
            firstName: "",
            middleName: "",
            lastName: "",
            gender: "",
            genderCode:"",
            title: "",
            titleCode:"",
            yob: "",
            co: "",
            house: "",
            street: "",
            lm: "",
            loc: "",
            vtc: "",
            po: "",
            dist: "",
            distCode:"",
            subdist: "",
            state: "",
            stateCode:"",
            pc: "",
            dob: "",
            isAadharScanned: false,
            locality: "",
            addressLine1: "",
            addressLine2: ""
        }

        AOservice.nomineeAadhaarCardDetails = {
            uid: "",
            name: "",
            gender: "",
            yob: "",
            co: "",
            house: "",
            street: "",
            lm: "",
            loc: "",
            vtc: "",
            po: "",
            dist: "",
            distCode:"",
            subdist: "",
            state: "",
            stateCode: "",
            pc: "",
            dob: "",
            relationship: "",
            guardianName: "",
            guardianAge:"",
            age: "",
            address1: "",
            address2: ""
        }

        AOservice.activeAdditionalDetails = {

        }

        AOservice.selectedBranch = {
            branchname: "",
            branchaddress: ""
        }

        AOservice.iibCall = false;

        AOservice.nominee = {
            uid: '',
            name: '',
            firstName: '',
            middleName: '',
            lastName: '',
            relationship: '',
            guardianName: '',
            guardianAge:'',
            age: '',
            address1: '',
            address2: '',
            pincode: '',
            dob: '',
            city: '',
            cityCode: '',
            state: '',
            stateCode: '',
            guardianAddressFlag: ''
        }

        AOservice.branches = [];

        AOservice.nomineeGuardianDetails = {
            address1: '',
            address2: '',
            pincode: '',
            city: '',
            cityCode: '',
            state: '',
            stateCode: '',
            locality: '',
            guardianConsent:''
        }

        AOservice.direction = {
            latitude: '',
            longitude: '',
            branchname: '',
            address: '',
            state: ''
        }

        AOservice.aadhaarManualPermanentAddress = {
            address1: "",
            address2: "",
            state: "",
            stateCode: "",
            city: "",
            cityCode:"",
            pincode: "",
            isAadharScanned: false,
            locality: ""
        }

        AOservice.aadhaarManualCorrespondenceAddress = {
            address1: "",
            address2: "",
            state: "",
            stateCode: "",
            city: "",
            cityCode: "",
            pincode: "",
            isAadharScanned: false,
            locality: ""
        }

        AOservice.localityNav = "";
        AOservice.isNomineeAddress1Changed = false;
        AOservice.isNomineeAddress2Changed = false;
        AOservice.nomineeNav = "";
        AOservice.isNomineeScanned = false;
        AOservice.localityNextDisable = "";
        AOservice.isResumeJourney = false;
        AOservice.isAadharManualEntry = false;
        AOservice.panAuthorizeFlag = false;
        AOservice.cardReadyForCollection = "";
        AOservice.isCustManualCorresChkBox = false;
        AOservice.fatcaFlag;
        AOservice.termsAndConditionsFlag = false;
        AOservice.productOfferingFlag = true;
        AOservice.homeBranchLocalityCity = "";
        AOservice.homeBranchLocalityId = "";
        AOservice.homeBranchGpsId = "";
        AOservice.picId = '';
        AOservice.appPassword = '';
        AOservice.cifNumber = '';
        AOservice.acNumber = '';
        AOservice.debitNumber = '';
        AOservice.tncOtpValue = '';


        AOservice.maritalStatusList = [];

        AOservice.getIdByValue = function(obj, selectedValue) {
            var selectedId;
            for (var i = 0; i < obj.length; i++) {
                if (obj[i].description == selectedValue) {
                    selectedId = obj[i].value;
                }
            }
            return selectedId;
        }

        AOservice.getValueById = function(obj, selectedId) {
            var selectedValue;
            for (var i = 0; i < obj.length; i++) {
                if (obj[i].value == selectedId) {
                    selectedValue = obj[i].description;
                }
            }
            return selectedValue;
        }

        //Method to check null / undefined values and append commas
        AOservice.nullCheck = function(value) {
            var checkedVal = "";
            if (value != undefined && value != "") {
                checkedVal = value + ', ';
            }
            return checkedVal;
        }

        //Method to check for html tags
        AOservice.checkHtmlTags = function(data) {
            var validData;
            if ((/<(.|\n)*?>/g).test(data) == false) {
                validData = data;
            } else {
                validData = '';
            }
            return validData;
        }

        //Method to pass regular expression and values for secured data
        AOservice.checkSecuredData = function(regex, value) {
            var validValue;
            if (!utilityService.isUndefined(value)) {
                if (regex.test(value) == true) {
                    validValue = value;
                }
            } else {
                validValue = '';
            }
            return validValue;
        }

        /* ----------Click on cross icon - reset all data and redirect to homepage-------------*/
        AOservice.homeNav = function() {
            AOservice.customerManualEntryDetails = {
                aadharNumber: "",
                firstName: "",
                lastName: "",
                middleName: "",
                fullName: "",
                gender: "",
                genderCode:"",
                title: "",
                titleCode:"",
                dob: "",
                address1: "",
                address2: "",
                city: "",
                cityCode: "",
                state: "",
                stateCode: "",
                pincode: "",
                isAadharScanned: false,
                locality: "",
                addressLine1: "",
                addressLine2: ""

            }
            AOservice.tncOtpValue = '';
            AOservice.branches = [];
            AOservice.customer.photo = "";
            AOservice.picId = '';

            AOservice.nomineeGuardianDetails = {
                address1: '',
                address2: '',
                pincode: '',
                city: '',
                cityCode: '',
                state: '',
                stateCode: '',
                locality: ''
            }

            AOservice.direction = {
                latitude: '',
                longitude: '',
                branchname: '',
                address: '',
                state: ''
            }

            AOservice.iibCall = false;

            AOservice.nominee = {
                uid: '',
                name: '',
                firstName: '',
                middleName: '',
                lastName: '',
                relationship: '',
                guardianName: '',
                guardianAge:'',
                age: '',
                address1: '',
                address2: '',
                pincode: '',
                dob: '',
                city: '',
                cityCode: '',
                state: '',
                stateCode: '',
                guardianAddressFlag: ''
            }

            AOservice.customer = {
                aadharNumber: '',
                title: '',
                name: '',
                gender: '',
                dateOfYear: '',
                address: '',
                pincode: '',
                city: '',
                state: '',
                emailId: '',
                mobileNo: '',
                panNumber: '',
                lotusId: '1234',
                image: 'abc',
                deviceUid: '',
                deviceOS: '',
                referenceCode: '',
                photo: '',
                guardian: '',
                latitude: '',
                longitude: '',
                encodephoto: ''
            }

            AOservice.customerAdditionalDetails = {
                "maidenName": "",
                "fatherName": "",
                "fatherFirstName": "",
                "fatherMiddleName": "",
                "fatherLastName": "",
                "spouseName": "",
                "motherMaidenName": "",
                "maritalStatus": "",
                "annualIncome": "",
                "occupation": "",
                "subOccupation": "",
                "religion": "",
                "education": "",
                "cityOfBirth": "",
                "countryOfBirth": "",
                "nationality":"",
                "nationalityID":"",
                "citizenship":"",
                "citizenshipID":"",
                "motherFirstname":"",
                "motherMiddlename":"",
                "motherLastname":"",
                "motherTitle":"",
                "motherTitleCode":"",
                "fatherTitle":"",
                "fatherTitleCode":""
            }

            AOservice.customerCorrespondenceAddress = {
                address1: "",
                address2: "",
                state: "",
                stateCode: "",
                city: "",
                cityCode: "",
                pincode: "",
                isAadhaarScanned: false,
                locality: ""

            }

            AOservice.customerAadhaarCardDetails = {
                uid: "",
                name: "",
                firstName: "",
                middleName: "",
                lastName: "",
                gender: "",
                genderCode:"",
                title: "",
                titleCode:"",
                yob: "",
                co: "",
                house: "",
                street: "",
                lm: "",
                loc: "",
                vtc: "",
                po: "",
                dist: "",
                subdist: "",
                state: "",
                pc: "",
                dob: "",
                isAadharScanned: false,
                locality: "",
                addressLine1: "",
                addressLine2: ""
            }

            AOservice.nomineeAadhaarCardDetails = {
                uid: "",
                name: "",
                gender: "",
                yob: "",
                co: "",
                house: "",
                street: "",
                lm: "",
                loc: "",
                vtc: "",
                po: "",
                dist: "",
                subdist: "",
                state: "",
                pc: "",
                dob: "",
                relationship: "",
                guardianName: "",
                guardianAge:'',
                age: "",
                address1: "",
                address2: ""
            }

            AOservice.activeAdditionalDetails = {

            }

            AOservice.selectedBranch = {
                branchname: "",
                branchaddress: ""
            }
            AOservice.aadhaarManualPermanentAddress = {
                address1: "",
                address2: "",
                state: "",
                stateCode: "",
                city: "",
                cityCode: "",
                pincode: "",
                isAadharScanned: false,
                locality: ""
            }

            AOservice.aadhaarManualCorrespondenceAddress = {
                address1: "",
                address2: "",
                state: "",
                stateCode: "",
                city: "",
                cityCode:"",
                pincode: "",
                isAadharScanned: false,
                locality: ""
            }

            AOservice.debitCardDetails = {
                firstName: "",
                lastName: ""
            }

            AOservice.localityNav = "";
            AOservice.isNomineeAddress1Changed = false;
            AOservice.isNomineeAddress2Changed = false;
            AOservice.nomineeNav = "";
            AOservice.isNomineeScanned = false;
            AOservice.localityNextDisable = "";
            AOservice.isResumeJourney = false;
            AOservice.isAadharManualEntry = false;
            AOservice.panAuthorizeFlag = false;
            AOservice.cardReadyForCollection = "";
            AOservice.isCustManualCorresChkBox = false;
            AOservice.fatcaFlag;
            AOservice.termsAndConditionsFlag = false;
            AOservice.productOfferingFlag = true;
            AOservice.homeBranchLocalityCity = "";
            AOservice.homeBranchLocalityId = "";
            AOservice.homeBranchGpsId = "";
            AOservice.appPassword = "";
            AOservice.cifNumber = "";
            AOservice.acNumber = '';
            AOservice.debitNumber = '';
            if(mPinLoginService.isLoggedIn == true){
			    $state.go('menu.accountOverviewMyBalance');
            }
            else{
                $state.go('menu.landingWithOptions');
            }
        }


        //Common method for resuming the data in resume/omnichannel/dedupe journey
        AOservice.getResumeDocument = function(customerDetails) {
            var addressCount = 0;
     
            AOservice.customer.panNumber = utilityService.getValue(customerDetails.personalDetails.pan);
            AOservice.cifNumber = utilityService.getValue(customerDetails.personalDetails.cifStatus);
            AOservice.fatcaFlag = customerDetails.fatcaFlag;
			AOservice.fatcaResumeStatus = customerDetails.fatcaResumeStatus ? customerDetails.fatcaResumeStatus : "";
            AOservice.panAuthorizeFlag = customerDetails.panAuthorizeFlag;
            AOservice.customer.mobileNo = utilityService.getValue(customerDetails.personalDetails.mobileNumber);
            //AOservice.appPassword = utilityService.getValue(customerDetails.auth.password);
            AOservice.customer.emailId = utilityService.getValue(customerDetails.personalDetails.emailId);
            if (!utilityService.isUndefined(customerDetails.additionalDetails)) {
                
                AOservice.customerAdditionalDetails.annualIncome = utilityService.getValue(customerDetails.additionalDetails.annualIncome);
                AOservice.activeAdditionalDetails.income = utilityService.getValue(customerDetails.additionalDetails.annualIncomeCode);
                AOservice.customerAdditionalDetails.education = utilityService.getValue(customerDetails.additionalDetails.education);
                AOservice.activeAdditionalDetails.education = utilityService.getValue(customerDetails.additionalDetails.educationCode);
                AOservice.customerAdditionalDetails.maritalStatus = utilityService.getValue(customerDetails.additionalDetails.maritalStatus);
                AOservice.activeAdditionalDetails.marital = utilityService.getValue(customerDetails.additionalDetails.maritalStatusCode);
                AOservice.customerAdditionalDetails.occupation = utilityService.getValue(customerDetails.additionalDetails.occupation);
                AOservice.activeAdditionalDetails.occupation = utilityService.getValue(customerDetails.additionalDetails.occupationCode);
                AOservice.customerAdditionalDetails.religion = utilityService.getValue(customerDetails.additionalDetails.religion);
                AOservice.activeAdditionalDetails.religion = utilityService.getValue(customerDetails.additionalDetails.religionCode);
                AOservice.customerAdditionalDetails.subOccupation = utilityService.getValue(customerDetails.additionalDetails.subOccupation);
                AOservice.activeAdditionalDetails.suboccupation = utilityService.getValue(customerDetails.additionalDetails.subOccupationCode);
                
                AOservice.customerAdditionalDetails.fatherFirstName = utilityService.getValue(customerDetails.additionalDetails.fatherFirstName);
                AOservice.customerAdditionalDetails.fatherMiddleName = utilityService.getValue(customerDetails.additionalDetails.fatherMiddleName);
                AOservice.customerAdditionalDetails.fatherLastName = utilityService.getValue(customerDetails.additionalDetails.fatherLastName);
                AOservice.customerAdditionalDetails.spouseName = utilityService.getValue(customerDetails.additionalDetails.spouseName);
                AOservice.customerAdditionalDetails.motherMaidenName = utilityService.getValue(customerDetails.additionalDetails.motherMaidenName);
                AOservice.customerAdditionalDetails.maidenName = utilityService.getValue(customerDetails.additionalDetails.maidenName);
                AOservice.customerAdditionalDetails.motherFirstname = utilityService.getValue(customerDetails.additionalDetails.motherFirstName);
                AOservice.customerAdditionalDetails.motherMiddlename = utilityService.getValue(customerDetails.additionalDetails.motherMiddleName);
                AOservice.customerAdditionalDetails.motherLastname = utilityService.getValue(customerDetails.additionalDetails.motherLastName);
                AOservice.customerAdditionalDetails.motherTitle = utilityService.getValue(customerDetails.additionalDetails.motherTitle);
                AOservice.customerAdditionalDetails.motherTitleCode = utilityService.getValue(customerDetails.additionalDetails.motherTitleCode);
                AOservice.customerAdditionalDetails.fatherTitle = utilityService.getValue(customerDetails.additionalDetails.fatherTitle);
                AOservice.customerAdditionalDetails.fatherTitleCode = utilityService.getValue(customerDetails.additionalDetails.fatherTitleCode);
            }

            if(customerDetails.personalDetails.isAadhaarScanned == true){
                AOservice.customerAadhaarCardDetails.title = utilityService.getValue(customerDetails.personalDetails.title);
                AOservice.customerAadhaarCardDetails.titleCode = utilityService.getValue(customerDetails.personalDetails.titleCode);
                AOservice.customerAadhaarCardDetails.name = utilityService.getValue(customerDetails.personalDetails.name);
                AOservice.customerAadhaarCardDetails.firstName = utilityService.getValue(customerDetails.personalDetails.firstName);
                AOservice.customerAadhaarCardDetails.middleName = utilityService.getValue(customerDetails.personalDetails.middleName);
                AOservice.customerAadhaarCardDetails.lastName = utilityService.getValue(customerDetails.personalDetails.lastName);
                AOservice.customerAadhaarCardDetails.gender = utilityService.getValue(customerDetails.personalDetails.gender);
                AOservice.customerAadhaarCardDetails.genderCode = utilityService.getValue(customerDetails.personalDetails.genderCode);
                AOservice.customerAadhaarCardDetails.uid = utilityService.getValue(customerDetails.personalDetails.uid);
                AOservice.customerAadhaarCardDetails.dob = utilityService.getValue(customerDetails.personalDetails.dob);
                AOservice.customerAdditionalDetails.cityOfBirth = utilityService.getValue(customerDetails.personalDetails.cityOfBirth);
                AOservice.customerAdditionalDetails.countryOfBirth = utilityService.getValue(customerDetails.personalDetails.countryOfBirth);
                AOservice.customerAdditionalDetails.nationality = utilityService.getValue(customerDetails.personalDetails.nationality);
                AOservice.customerAdditionalDetails.nationalityID = utilityService.getValue(customerDetails.personalDetails.nationalityCode);
                AOservice.customerAdditionalDetails.citizenship = utilityService.getValue(customerDetails.personalDetails.citizenship);
                AOservice.customerAdditionalDetails.citizenshipID = utilityService.getValue(customerDetails.personalDetails.citizenshipCode);
            }

            else if(customerDetails.personalDetails.isAadhaarScanned == false){
                AOservice.customerManualEntryDetails.title = utilityService.getValue(customerDetails.personalDetails.title);
                AOservice.customerManualEntryDetails.titleCode = utilityService.getValue(customerDetails.personalDetails.titleCode);
                AOservice.customerManualEntryDetails.fullName = utilityService.getValue(customerDetails.personalDetails.name);
                AOservice.customerManualEntryDetails.firstName = utilityService.getValue(customerDetails.personalDetails.firstName);
                AOservice.customerManualEntryDetails.middleName = utilityService.getValue(customerDetails.personalDetails.middleName);
                AOservice.customerManualEntryDetails.lastName = utilityService.getValue(customerDetails.personalDetails.lastName);
                AOservice.customerManualEntryDetails.gender = utilityService.getValue(customerDetails.personalDetails.gender);
                AOservice.customerManualEntryDetails.genderCode = utilityService.getValue(customerDetails.personalDetails.genderCode);
                AOservice.customerManualEntryDetails.aadharNumber = utilityService.getValue(customerDetails.personalDetails.uid);
                AOservice.customerManualEntryDetails.dob = utilityService.getValue(customerDetails.personalDetails.dob);
                AOservice.customerAdditionalDetails.cityOfBirth = utilityService.getValue(customerDetails.personalDetails.placeOfBirth);
                AOservice.customerAdditionalDetails.placeOfBirth = utilityService.getValue(customerDetails.personalDetails.placeOfBirth);
                AOservice.customerAdditionalDetails.countryOfBirth = utilityService.getValue(customerDetails.personalDetails.countryOfBirth);
                AOservice.customerAdditionalDetails.nationality = utilityService.getValue(customerDetails.personalDetails.nationality);
                AOservice.customerAdditionalDetails.nationalityID = utilityService.getValue(customerDetails.personalDetails.nationalityCode);
                AOservice.customerAdditionalDetails.citizenship = utilityService.getValue(customerDetails.personalDetails.citizenship);
                AOservice.customerAdditionalDetails.citizenshipID = utilityService.getValue(customerDetails.personalDetails.citizenshipCode);
				AOservice.isAadharManualEntry = true;
            }

            

            if (!utilityService.isUndefined(customerDetails.personalDetails.address) && customerDetails.personalDetails.address.length > 0) {
                for (var i = 0; i < customerDetails.personalDetails.address.length; i++) {
                    if (customerDetails.personalDetails.isAadhaarScanned == true) {
                        //aoService.correspondenceCheckStatus = customerDetails.personalDetails.scannedCorrespondenceAddFlag;
                        if (customerDetails.personalDetails.address[i].type == "CORRESPONDENCE") {
                            AOservice.customerCorrespondenceAddress.address1 = utilityService.getValue(customerDetails.personalDetails.address[i].addressLine1);
                            AOservice.customerCorrespondenceAddress.address2 = utilityService.getValue(customerDetails.personalDetails.address[i].addressLine2);
                            AOservice.customerCorrespondenceAddress.pincode = utilityService.getValue(customerDetails.personalDetails.address[i].pincode);
                            AOservice.customerCorrespondenceAddress.city = utilityService.getValue(customerDetails.personalDetails.address[i].city);
                            AOservice.customerCorrespondenceAddress.state = utilityService.getValue(customerDetails.personalDetails.address[i].state);
                            AOservice.customerCorrespondenceAddress.cityCode = utilityService.getValue(customerDetails.personalDetails.address[i].cityCode);
                            AOservice.customerCorrespondenceAddress.stateCode = utilityService.getValue(customerDetails.personalDetails.address[i].stateCode);
                            AOservice.customerCorrespondenceAddress.locality = utilityService.getValue(customerDetails.personalDetails.address[i].locality);
                            addressCount++;
                        } else if (customerDetails.personalDetails.address[i].type == "aadhaar") {
                            AOservice.customerAadhaarCardDetails.addressLine1 = utilityService.getValue(customerDetails.personalDetails.address[i].addressLine1);
                            AOservice.customerAadhaarCardDetails.addressLine2 = utilityService.getValue(customerDetails.personalDetails.address[i].addressLine2);
                            AOservice.customerAadhaarCardDetails.dist = utilityService.getValue(customerDetails.personalDetails.address[i].city);
                            AOservice.customerAadhaarCardDetails.state = utilityService.getValue(customerDetails.personalDetails.address[i].state);
                            AOservice.customerAadhaarCardDetails.distCode = utilityService.getValue(customerDetails.personalDetails.address[i].cityCode);
                            AOservice.customerAadhaarCardDetails.stateCode = utilityService.getValue(customerDetails.personalDetails.address[i].stateCode);
                            AOservice.customerAadhaarCardDetails.pc = utilityService.getValue(customerDetails.personalDetails.address[i].pincode);
                            AOservice.customerAadhaarCardDetails.locality = utilityService.getValue(customerDetails.personalDetails.address[i].locality);
                        }
                        AOservice.isAadharManualEntry = false;
                        AOservice.customerCorrespondenceAddress.isAadhaarScanned = true;
                        if (addressCount == 1) {
                            AOservice.correspondenceCheckStatus = true;

                        } else {
                            AOservice.correspondenceCheckStatus = false;
                        }

                    } else if (customerDetails.personalDetails.isAadhaarScanned == false) {
                        if (customerDetails.personalDetails.address[i].type == "aadhaar") {
                            AOservice.aadhaarManualPermanentAddress.address1 = utilityService.getValue(customerDetails.personalDetails.address[i].addressLine1);
                            AOservice.aadhaarManualPermanentAddress.address2 = utilityService.getValue(customerDetails.personalDetails.address[i].addressLine2);
                            AOservice.aadhaarManualPermanentAddress.pincode = utilityService.getValue(customerDetails.personalDetails.address[i].pincode);
                            AOservice.aadhaarManualPermanentAddress.city = utilityService.getValue(customerDetails.personalDetails.address[i].city);
                            AOservice.aadhaarManualPermanentAddress.state = utilityService.getValue(customerDetails.personalDetails.address[i].state);
                            AOservice.aadhaarManualPermanentAddress.cityCode = utilityService.getValue(customerDetails.personalDetails.address[i].cityCode);
                            AOservice.aadhaarManualPermanentAddress.stateCode = utilityService.getValue(customerDetails.personalDetails.address[i].stateCode);
                            AOservice.aadhaarManualPermanentAddress.locality = utilityService.getValue(customerDetails.personalDetails.address[i].locality);
                            AOservice.aadhaarManualPermanentAddress.isAadhaarScanned = false;
                            //aoService.isCustManualCorresChkBox = customerDetails.personalDetails.scannedCorrespondenceAddFlag;
                        } else if (customerDetails.personalDetails.address[i].type == "CORRESPONDENCE") {
                            AOservice.aadhaarManualCorrespondenceAddress.address1 = utilityService.getValue(customerDetails.personalDetails.address[i].addressLine1);
                            AOservice.aadhaarManualCorrespondenceAddress.address2 = utilityService.getValue(customerDetails.personalDetails.address[i].addressLine2);
                            AOservice.aadhaarManualCorrespondenceAddress.pincode = utilityService.getValue(customerDetails.personalDetails.address[i].pincode);
                            AOservice.aadhaarManualCorrespondenceAddress.city = utilityService.getValue(customerDetails.personalDetails.address[i].city);
                            AOservice.aadhaarManualCorrespondenceAddress.state = utilityService.getValue(customerDetails.personalDetails.address[i].state);
                            AOservice.aadhaarManualCorrespondenceAddress.cityCode = utilityService.getValue(customerDetails.personalDetails.address[i].cityCode);
                            AOservice.aadhaarManualCorrespondenceAddress.stateCode = utilityService.getValue(customerDetails.personalDetails.address[i].stateCode);
                            AOservice.aadhaarManualCorrespondenceAddress.locality = utilityService.getValue(customerDetails.personalDetails.address[i].locality);
                            AOservice.aadhaarManualCorrespondenceAddress.isAadhaarScanned = false;
                            //aoService.isCustManualCorresChkBox = customerDetails.personalDetails.scannedCorrespondenceAddFlag;
                        }
                        AOservice.isAadharManualEntry = true;
                        AOservice.isCustManualCorresChkBox = customerDetails.personalDetails.scannedCorrespondenceAddFlag;
                    }
            
                }
            } else if (!utilityService.isUndefined(customerDetails.personalDetails.address) && customerDetails.personalDetails.address.length == 0) {
                if (customerDetails.personalDetails.isAadhaarScanned == true) {
                    AOservice.isAadharManualEntry = false;
                    AOservice.customerCorrespondenceAddress.isAadhaarScanned = true;
                } else if (customerDetails.personalDetails.isAadhaarScanned == false) {
                    AOservice.isAadharManualEntry = true;
                }
            }

            if (!utilityService.isUndefined(customerDetails.doc) && customerDetails.doc.length > 0) {
                for (var i = 0; i < customerDetails.doc.length; i++) {
                    if (customerDetails.doc[i].docType.toLowerCase() == "photograph") {
                        AOservice.picId = customerDetails.doc[i].docRef;
                    }
                }
            }

            if (!utilityService.isUndefined(customerDetails.nominees) && customerDetails.nominees.length > 0) {
                AOservice.isNomineeScanned = customerDetails.nominees[0].isNomineeAadhaarScanned;

                if (AOservice.isNomineeScanned === true) {
                    AOservice.nomineeAadhaarCardDetails.uid = utilityService.getValue(customerDetails.nominees[0].uid);
                    AOservice.nomineeAadhaarCardDetails.name = utilityService.getValue(customerDetails.nominees[0].name);
                    AOservice.nomineeAadhaarCardDetails.relationship = utilityService.getValue(customerDetails.nominees[0].relationship);
                    AOservice.nomineeAadhaarCardDetails.age = utilityService.getValue(customerDetails.nominees[0].age);
                    AOservice.nomineeAadhaarCardDetails.dob = utilityService.getValue(customerDetails.nominees[0].dob);
                    AOservice.nomineeAadhaarCardDetails.sameAsApplicantAddress = customerDetails.nominees[0].sameAsApplicantAddress;
                    if (!utilityService.isUndefined(customerDetails.nominees[0].address)) {
                        AOservice.nomineeAadhaarCardDetails.address1 = utilityService.getValue(customerDetails.nominees[0].address.addressLine1);
                        AOservice.nomineeAadhaarCardDetails.address2 = utilityService.getValue(customerDetails.nominees[0].address.addressLine2);
                        AOservice.nomineeAadhaarCardDetails.pc = utilityService.getValue(customerDetails.nominees[0].address.pincode);
                        AOservice.nomineeAadhaarCardDetails.dist = utilityService.getValue(customerDetails.nominees[0].address.city);
                        AOservice.nomineeAadhaarCardDetails.state = utilityService.getValue(customerDetails.nominees[0].address.state);
                        AOservice.nomineeAadhaarCardDetails.distCode = utilityService.getValue(customerDetails.nominees[0].address.cityCode);
                        AOservice.nomineeAadhaarCardDetails.stateCode = utilityService.getValue(customerDetails.nominees[0].address.stateCode);
                    }
                    if (!utilityService.isUndefined(customerDetails.nominees[0].guardian)){
                        AOservice.nomineeAadhaarCardDetails.guardianName = utilityService.getValue(customerDetails.nominees[0].guardian.name);
                        AOservice.nomineeAadhaarCardDetails.guardianAge = utilityService.getValue(customerDetails.nominees[0].guardian.guardianAge);
                    }

                } else if (AOservice.isNomineeScanned === false) {
                    AOservice.nominee.name = utilityService.getValue(customerDetails.nominees[0].name);
                    AOservice.nominee.relationship = utilityService.getValue(customerDetails.nominees[0].relationship);
                    AOservice.nominee.age = utilityService.getValue(customerDetails.nominees[0].age);
                    AOservice.nominee.sameAsApplicantAddress = customerDetails.nominees[0].sameAsApplicantAddress;
                    
                    if (!utilityService.isUndefined(customerDetails.nominees[0].address)) {
                        AOservice.nominee.address1 = utilityService.getValue(customerDetails.nominees[0].address.addressLine1);
                        AOservice.nominee.address2 = utilityService.getValue(customerDetails.nominees[0].address.addressLine2);
                        AOservice.nominee.pincode = utilityService.getValue(customerDetails.nominees[0].address.pincode);
                        AOservice.nominee.city = utilityService.getValue(customerDetails.nominees[0].address.city);
                        AOservice.nominee.state = utilityService.getValue(customerDetails.nominees[0].address.state);
                        AOservice.nominee.cityCode = utilityService.getValue(customerDetails.nominees[0].address.cityCode);
                        AOservice.nominee.stateCode = utilityService.getValue(customerDetails.nominees[0].address.stateCode);
                    }

                    AOservice.nominee.dob = utilityService.getValue(customerDetails.nominees[0].dob);
                    if (!utilityService.isUndefined(customerDetails.nominees[0].guardian)){
                        AOservice.nominee.guardianName = utilityService.getValue(customerDetails.nominees[0].guardian.name);
                        AOservice.nominee.guardianAge = utilityService.getValue(customerDetails.nominees[0].guardian.guardianAge);
                    }
                }

                if (!utilityService.isUndefined(customerDetails.nominees[0].guardian)) {
                    AOservice.nominee.guardianAddressFlag = utilityService.getValue(customerDetails.nominees[0].guardian.guardianAddressFlag);
                    if (!utilityService.isUndefined(AOservice.nominee.guardianAddressFlag)) {
                        AOservice.nomineeGuardianDetails.address1 = utilityService.getValue(customerDetails.nominees[0].guardian.address.addressLine1);
                        AOservice.nomineeGuardianDetails.address2 = utilityService.getValue(customerDetails.nominees[0].guardian.address.addressLine2);
                        AOservice.nomineeGuardianDetails.locality = utilityService.getValue(customerDetails.nominees[0].guardian.address.locality);
                        AOservice.nomineeGuardianDetails.city = utilityService.getValue(customerDetails.nominees[0].guardian.address.city);
                        AOservice.nomineeGuardianDetails.state = utilityService.getValue(customerDetails.nominees[0].guardian.address.state);
                        AOservice.nomineeGuardianDetails.cityCode = utilityService.getValue(customerDetails.nominees[0].guardian.address.cityCode);
                        AOservice.nomineeGuardianDetails.stateCode = utilityService.getValue(customerDetails.nominees[0].guardian.address.stateCode);
                        AOservice.nomineeGuardianDetails.pincode = utilityService.getValue(customerDetails.nominees[0].guardian.address.pincode);
                        AOservice.nomineeGuardianDetails.guardianConsent = customerDetails.nominees[0].guardian.guardianConsent;
                        //AOservice.nominee.guardianName = utilityService.getValue(customerDetails.nominees[0].guardian.name);
                        //AOservice.nominee.guardianAge = utilityService.getValue(customerDetails.nominees[0].guardian.guardianAge);
                    }
                }
            }
   
            if (!utilityService.isUndefined(customerDetails.homeBranch)) {
                AOservice.homeBranchLocalityCity = utilityService.getValue(customerDetails.homeBranch.city);
                AOservice.homeBranchLocalityId = utilityService.getValue(customerDetails.homeBranch.branchId);
            }

            if (!utilityService.isUndefined(AOservice.homeBranchLocalityCity)) {
                AOservice.isGpsClicked = false;
            } else if (utilityService.isUndefined(AOservice.homeBranchLocalityCity)) {
                AOservice.isGpsClicked = true;
            }

            AOservice.cardReadyForCollection = utilityService.getValue(customerDetails.cardReadyForCollection);
            AOservice.debitCardDetails.firstName = utilityService.getValue(customerDetails.debitCardFirstName);
            AOservice.debitCardDetails.lastName = utilityService.getValue(customerDetails.debitCardLastName);
            AOservice.customer.referenceCode = utilityService.getValue(customerDetails.refNo);
            AOservice.termsAndConditionsFlag = customerDetails.termsAndConditionsFlag;
            //AOservice.productOfferingFlag = customerDetails.productOfferingFlag;
			if(customerDetails.personalDetails.scannedCorrespondenceAddFlag){
							AOservice.isresumeCustManualCorresChkBox = customerDetails.personalDetails.scannedCorrespondenceAddFlag;
			}
        }

        AOservice.getCommonId = function(commonId, flag){
   
            if(commonId == "OIOO" || commonId == "DebitCard" || commonId == "tncOtp"){
                AOservice.productOfferingFlag = flag;
            }
            else{
                AOservice.productOfferingFlag = true;
            }
        }
		
		 AOservice.setDateFormatDDMMYYY = function(data) {
            if(data){
            	data = data.replace(/-/g, '/');
            	data =data.replace(/\:/g, '/');
            	data =data.replace(/\./g, '/');
            	
            	data =data.replace(/ /g, '');
            	data =data.replace(/Jan/g, '01');
            	data =data.replace(/Feb/g, '02');
            	data =data.replace(/Mar/g, '03');
            	data =data.replace(/Apr/g, '04');
            	data =data.replace(/May/g, '05');
            	data =data.replace(/Jun/g, '06');
            	data =data.replace(/Jul/g, '07');
            	data =data.replace(/Aug/g, '08');
            	data =data.replace(/Sep/g, '09');
            	data =data.replace(/Oct/g, '10');
            	data =data.replace(/Nov/g, '11');
            	data =data.replace(/Dec/g, '12');
            }
            return data;
       };
       
       AOservice.isPreJTSixStarted = false; 
       AOservice.isJTSixPostLoginStarted = false;
      
	AOservice.isJTSixPostLoginData = {
		"newMobile" : "",
		"newMail" : "",
		"firstName" : "",
		"middleName" : "",
		"lastName" : "",
		"dob" : "",
		"panNumber" : "",
		"idNumber" : "",
		"uidNumber" : "",
		"accountNumber" : "",
		"cifNumber" : "",
		"addressLine1" : "",
		"addressLine2" : "",
		"addressLine3" : "",
		"homeBranch" : "",
		"fatherName" : "",
		"motherName" : "",
		"mobileNumber" : "",
		"emailId" : "",
		"gender" : "",
		"genderCode" : "",
		"title" : "",
		"titleCode" : ""

	}; 

       AOservice.preJTSixdata = {
       	     "firstName":"",
       	     "middleName":"",
       	     "lastName":"",
       	     "dateOfBirth":"",
       	     "panNumber":"",
       	     "idNumber":"",
       	     "uidNumber":"",
       	     "accountNumber":"",
       	     "cifNumber":"",
       	     "addressLine1":"",
       	     "addressLine2":"",
       	     "addressLine3":"",
       	     "homeBranch":"",
       	     "fatherName":"",
       	     "motherName":"",
			 "maxCIFEntered":""
       	    };
	 AOservice.kyc = {}; 
	 AOservice.doc = {}; 	
	 AOservice.isVID = false; 	
	
     return AOservice;

    }
]);
