'use strict';

angularApp.controller('appPasswordController', ["$state",
    "$scope",
    "aoService",
    "utilityService",
    "appPasswordService",
    "$ionicPopover",
    "$cordovaDevice",
    "cryptoService",
    "encryptionService",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
	"instaService",
    function($state,
        $scope,
        aoService,
        utilityService,
        appPasswordService,
        $ionicPopover,
        $cordovaDevice,
        cryptoService,
        encryptionService,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService,
        instaService) {

        var appPasswordVm = this;

        function initPage() {
            appPasswordVm.showBack = false;
            appPasswordVm.showNext = true;
            appPasswordVm.reAppPasswordCheck = false;
            appPasswordVm.disableNext = true;
            appPasswordVm.aofooter = true;
            //To get the device Operating system
            var deviceOs = $cordovaDevice.getPlatform();
            var deviceUid = $cordovaDevice.getUUID();
            aoService.customer.deviceOS = deviceOs;
            aoService.customer.deviceUid = deviceUid;
            appPasswordVm.encoded = '';
            appPasswordVm.securityQuestions = [];
            appPasswordVm.loadSecurityQuestion();
        }

        /* Info Popup */
        var template = '<ion-popover-view class="ao-tooltip ao-popupInfo roboto-regular ao-passwordHt">' + '<ion-content>' +
                        '<div class="" translate="APP_NOTIFICATION"></div>' + '</ion-content>' + '</ion-popover-view>';

        $scope.popover = $ionicPopover.fromTemplate(template, {
            scope: $scope
        });

        appPasswordVm.infoPopup = function($event) {
            $scope.popover.show($event);
        };

        appPasswordVm.closePopover = function() {
            $scope.popover.hide();
        };
       /* Info Popup */

        appPasswordVm.goBacktoPrevious = function() {
            $state.go('menu.getOTP');
        }

        appPasswordVm.goToNextPage = function() {
            //var hashedAppPassword = cryptoService.getSHA512EncryptedData(appPasswordVm.appPasswordData);
            //appPasswordVm.encoded = encryptionService.getAES256EncryptedData(hashedAppPassword);
            appPasswordVm.encoded = appPasswordVm.appPasswordData;
            aoService.appPassword = appPasswordVm.encoded;
            var requestParams = {
                "id": aoService.customer.mobileNo,
		"commonId":$state.$current.data.commonId,
                "data": {
                    "secQ":appPasswordVm.selectedSecQuestion,
                    "secA":appPasswordVm.secAnswer,
                    "auth" : {
                        "password" :appPasswordVm.encoded
                    },
                    "deviceInfo": {
                        "deviceIMEI" : aoService.customer.deviceUid,
                        "deviceOS" : aoService.customer.deviceOS
                    },
                    "personalDetails": {
                        "emailId" : aoService.customer.emailId,
                        "mobileNumber" : aoService.customer.mobileNo,
                        "custMobNo" : aoService.customer.mobileNo
                    }
                }
            }
            appPasswordService.registerCustomer(requestParams).then(function(response) {
                aoService.customer.lotusId = utilityService.getValue(response.data.lotusId);
                var responseCode = response.responseCode;
                if (responseCode === constantConfig.successCode) {
                    $state.go('menu.tax');
                }

            }, function(error) {
               utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        appPasswordVm.changePassword = function() {
            if (appPasswordVm.reAppPasswordData !== appPasswordVm.appPasswordData) {
                appPasswordVm.reAppPasswordData = "";
                appPasswordVm.reAppPasswordCheck = true;
                appPasswordVm.disableNext = true;
                return true;
            }
            appPasswordVm.reAppPasswordCheck = false;
            return true;
        }

       appPasswordVm.loadSecurityQuestion = function(){
       	if(instaService.setSecurityQuestion.length == 0){
        	appPasswordVm.isErorr = false;
		utilityService.showSpinner();
            appPasswordService.loadSecurityQuestions().then(function(response) {
               utilityService.hideSpinner()
	       appPasswordVm.isErorr = false;
                appPasswordVm.securityQuestions = response.data.masterDetails;
            }, function(error) {
	       utilityService.hideSpinner()
               appPasswordVm.isErorr = true;
               utilityService.showErrorMessage(error.responseMessage);
            });
            }else{
            	appPasswordVm.securityQuestions = instaService.setSecurityQuestion;
            }
        }

        appPasswordVm.changeCPassword = function() {
            if (appPasswordVm.reAppPasswordData !== appPasswordVm.appPasswordData) {
                appPasswordVm.reAppPasswordCheck = false;
            }
            return true;
        }

        appPasswordVm.proceedSuccess = function(isValid) {
            isValid ? appPasswordVm.disableNext = false : appPasswordVm.disableNext = true;
            return appPasswordVm.disableNext;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
