'use strict';

angularApp.controller('aDCityCountryController', ["$state",
    "$scope",
    "$translate",
    "aoService",
    "utilityService",
    "aDCityCountryService",
    "aadhaarManualAddressService",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "$ionicPopover",
    "$ionicPopup",
    function($state,
        $scope,
        $translate,
        aoService,
        utilityService,
        aDCityCountryService,
        aadhaarManualAddressService,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService,
        $ionicPopover,
        $ionicPopup) {

        var aDCityCountryVm = this;

        function initPage() {
            aDCityCountryVm.showBack = true;
            aDCityCountryVm.showNext = true;
            aDCityCountryVm.disableNext = true;
            aDCityCountryVm.country = "";
			aDCityCountryVm.getInfoMsg = "";
            aDCityCountryVm.selectCountries = [];
            aDCityCountryVm.selectCitizen = [];
            aDCityCountryVm.selectNationality = [];
            aDCityCountryVm.aofooter = true;

            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                aDCityCountryVm.okBtntext = translatedvalue;
            });
            aDCityCountryVm.getCountriesList();
            aDCityCountryVm.getNationalityList();
            aDCityCountryVm.getCitizenshipList();
        }

        aDCityCountryVm.getCountriesList = function() {
            aDCityCountryService.getCountries().then(function(body) {
                if(!utilityService.isUndefined(body)){
                    for (var i = 0; i < body.length; i++) {
                        aDCityCountryVm.selectCountries.push(body[i].name);
                        aDCityCountryVm.selectCountries.sort();
                    }
                }                
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        aDCityCountryVm.getNationalityList = function() {
            aDCityCountryService.getNationality().then(function(body) {
                if(!utilityService.isUndefined(body)){
                    aDCityCountryVm.selectNationality = body;
                }                
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        aDCityCountryVm.getCitizenshipList = function() {
            aDCityCountryService.getCitizenship().then(function(body) {
                if(!utilityService.isUndefined(body)){
                    for (var i = 0; i < body.length; i++) {
                        aDCityCountryVm.selectCitizen = body;
                    }
                }                
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        aDCityCountryVm.showHideFilterDropDown = function(isValid) {
            if (!utilityService.isUndefined(aDCityCountryVm.country)) {
                aDCityCountryVm.hideOptions = true;
                //aDCityCountryVm.disableNext = false;
            } 
           else {
                aDCityCountryVm.hideOptions = false;
                aDCityCountryVm.disableNext = true;
            }
        }

        aDCityCountryVm.showHideCitizen = function(isValid) {
            if (!utilityService.isUndefined(aDCityCountryVm.citizen)) {
                aDCityCountryVm.citizenList = true;
                //aDCityCountryVm.disableNext = false;
            } 
           else {
                aDCityCountryVm.citizenList = false;
                aDCityCountryVm.disableNext = true;
            }
        }

        aDCityCountryVm.showHideNationality = function(isValid) {
            if (!utilityService.isUndefined(aDCityCountryVm.nationality)) {
                aDCityCountryVm.nationList = true;
                //aDCityCountryVm.disableNext = false;
            } 
           else {
                aDCityCountryVm.nationList = false;
                aDCityCountryVm.disableNext = true;
            }
        }

        aDCityCountryVm.goBacktoPrevious = function() {
            if (aoService.isAadharManualEntry == true) {
                $state.go("menu.aadhaarManualEntry");
            } else {
                $state.go("menu.pdetailsAN");
            }
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        aDCityCountryVm.goToNextPage = function() {
            if (!utilityService.isUndefined(aDCityCountryVm.city) && !utilityService.isUndefined(aDCityCountryVm.country) && aDCityCountryVm.country.toLowerCase() == constantConfig.acOp.india.toLowerCase() && !utilityService.isUndefined(aDCityCountryVm.nationality) && !utilityService.isUndefined(aDCityCountryVm.citizen) && aDCityCountryVm.citizen.toLowerCase() == constantConfig.acOp.india.toLowerCase() && aDCityCountryVm.nationality.toLowerCase() == constantConfig.acOp.india.toLowerCase()) {
                aoService.customerAdditionalDetails.cityOfBirth = aDCityCountryVm.city;
                aoService.customerAdditionalDetails.countryOfBirth = aDCityCountryVm.country;
                aoService.customerAdditionalDetails.nationality = aDCityCountryVm.nationality;
                aoService.customerAdditionalDetails.citizenship = aDCityCountryVm.citizen;
                if (aoService.isAadharManualEntry == true) {
                    var requestParams = {
                        "id": aoService.customer.mobileNo,
                        "data": {
                            "personalDetails": {
                                "uid": aoService.customerManualEntryDetails.aadharNumber,
                                "name": aoService.customerManualEntryDetails.fullName,
                                "firstName": aoService.customerManualEntryDetails.firstName,
                                "middleName": aoService.customerManualEntryDetails.middleName,
                                "lastName": aoService.customerManualEntryDetails.lastName,
                                "title": aoService.customerManualEntryDetails.title,
                                "gender": aoService.customerManualEntryDetails.gender,
                                "titleCode": aoService.customerManualEntryDetails.titleCode,
                                "genderCode": aoService.customerManualEntryDetails.genderCode,
                                "dob": aoService.customerManualEntryDetails.dob,
                                "scannedCorrespondenceAddFlag": aoService.isCustManualCorresChkBox,
                                "isAadhaarScanned": false,
                                "nationality":aoService.customerAdditionalDetails.nationality,
                                "nationalityCode":aoService.customerAdditionalDetails.nationalityID,
                                "citizenship": aoService.customerAdditionalDetails.citizenship,
                                "citizenshipCode": aoService.customerAdditionalDetails.citizenshipID,
                                "cityOfBirth": aoService.customerAdditionalDetails.cityOfBirth,
                                "placeOfBirth": aoService.customerAdditionalDetails.cityOfBirth,
                                "countryOfBirth": aoService.customerAdditionalDetails.countryOfBirth,
                                "address": [{
                                    "type": "aadhaar",
                                    "addressLine1": aoService.aadhaarManualPermanentAddress.address1,
                                    "addressLine2": aoService.aadhaarManualPermanentAddress.address2,
                                    "pincode": aoService.aadhaarManualPermanentAddress.pincode,
                                    "city": aoService.aadhaarManualPermanentAddress.city,
                                    "state": aoService.aadhaarManualPermanentAddress.state,
                                    "locality": aoService.aadhaarManualPermanentAddress.locality
                                }]
                            },
                            "additionalDetails": {
                                    "cityOfBirth": aoService.customerAdditionalDetails.cityOfBirth,
                                    "placeOfBirth": aoService.customerAdditionalDetails.cityOfBirth,
                                    "countryOfBirth": aoService.customerAdditionalDetails.countryOfBirth
                            },
                            "commonId": $state.$current.data.commonId
                        }
                    }
                    aadhaarManualAddressService.updateAadhaarDetails(requestParams).then(function(response) {
                        if (response.responseCode === constantConfig.successCode) {
                            if (aoService.isAadharManualEntry) {
                                if (aoService.isCustManualCorresChkBox) {
                                    $state.go('menu.aadhaarManualEntryCAddress');
                                } else {
                                    $state.go('menu.panDetails');
                                }
                            }
                        }
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                } else {
                    $state.go('menu.pdetailsAddress');
                }
            }
            else{
				 var template = '{{"CITYCOUNTRY_NOTINDIA" | translate}}';
				if(aDCityCountryVm.country.toLowerCase() != constantConfig.acOp.india.toLowerCase()){
					 var template = '{{"CITYCOUNTRY_NOTINDIA" | translate}}';
				}else if(aDCityCountryVm.citizen.toLowerCase() != constantConfig.acOp.india.toLowerCase()){
					 var template = '{{"CITYCOUNTRY_CITIZENSHIP_NOTINDIA" | translate}}';
				} else if(aDCityCountryVm.nationality.toLowerCase() != constantConfig.acOp.india.toLowerCase()){
					 var template = '{{"CITYCOUNTRY_NATIONALITY_NOTINDIA" | translate}}';
				}
                var title = '';
               
                var onTap = 'menu.aDCityCountry';
                var buttontext = '<b>' + aDCityCountryVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            }
        }
        aDCityCountryVm.validateForm = function(isValid) {
            if (isValid === true && aDCityCountryVm.country.toLowerCase() === constantConfig.acOp.india.toLowerCase() && !utilityService.isUndefined(aDCityCountryVm.citizen) && !utilityService.isUndefined(aDCityCountryVm.nationality)) {
                aDCityCountryVm.disableNext = false;
                aDCityCountryVm.cityValidate = true;
            } else {
                aDCityCountryVm.disableNext = true;
                aDCityCountryVm.cityValidate = false;
            }
        }

        aDCityCountryVm.abortProcess = function(selectValue) {
            aDCityCountryVm.country = selectValue;
            aDCityCountryVm.hideOptions = false;
            if (utilityService.isUndefined(aDCityCountryVm.country)) {
                aDCityCountryVm.disableNext = true;
            } else if (selectValue.toLowerCase() !== constantConfig.acOp.india.toLowerCase() && !utilityService.isUndefined(aDCityCountryVm.country)) {
                var title = '';
                var template = '{{"CITYCOUNTRY_NOTINDIA" | translate}}';
                var onTap = 'menu.aDCityCountry';
                var buttontext = '<b>' + aDCityCountryVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);

                aDCityCountryVm.disableNext = true;

            } else {
                aDCityCountryVm.disableNext = utilityService.isUndefined(aDCityCountryVm.city);
            }
        }

        aDCityCountryVm.abortNationality = function(param) {
            aDCityCountryVm.nationality = param.name;
            aoService.customerAdditionalDetails.nationalityID = param.code;
            aDCityCountryVm.nationList = false;
            if (utilityService.isUndefined(aDCityCountryVm.nationality)) {
                aDCityCountryVm.disableNext = true;
            } else if (param.name.toLowerCase() !== constantConfig.acOp.india.toLowerCase() && !utilityService.isUndefined(aDCityCountryVm.nationality)) {
                var title = '';
                var template = '{{"CITYCOUNTRY_NOTINDIA" | translate}}';
                var onTap = 'menu.aDCityCountry';
                var buttontext = '<b>' + aDCityCountryVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);

                aDCityCountryVm.disableNext = true;

            }
        }

        aDCityCountryVm.abortCitizenship = function(value) {
            aDCityCountryVm.citizen = value.name;
            aoService.customerAdditionalDetails.citizenshipID = value.code;
            aDCityCountryVm.citizenList = false;
            if (utilityService.isUndefined(aDCityCountryVm.citizen)) {
                aDCityCountryVm.disableNext = true;
            } else if (value.name.toLowerCase() !== constantConfig.acOp.india.toLowerCase() && !utilityService.isUndefined(aDCityCountryVm.citizen)) {
                var title = '';
                var template = '{{"CITYCOUNTRY_CITIZENSHIP_NOTINDIA" | translate}}';
                var onTap = 'menu.aDCityCountry';
                var buttontext = '<b>' + aDCityCountryVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);

                aDCityCountryVm.disableNext = true;

            } 
        }

         /* Info Popup */
        var template = '<ion-popover-view class="tooltiptext ao-popupInfo roboto-regular ao-aadhaarInfoHt">' + '<ion-content>' +
                        '<div class="" ng-bind="aDCityCountryVm.getInfoMsg"></div>' + '</ion-content>' + '</ion-popover-view>';

        $scope.popover = $ionicPopover.fromTemplate(template, {
            scope: $scope
        });

        aDCityCountryVm.infoPopup = function($event,clickId) {
			 aDCityCountryService.getInfoList().then(function(body) {
				 if(clickId == "citizen"){
				 	aDCityCountryVm.getInfoMsg = body.infoList.citizenshipContent;
				 }else if(clickId == "nationality"){
				 	aDCityCountryVm.getInfoMsg = body.infoList.nationalityContent;
				 }
				 
            	$scope.popover.show($event);                   
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
			
			
            
        };

        aDCityCountryVm.closePopover = function() {
            $scope.popover.hide();
        };
       /* Info Popup */

        aDCityCountryVm.populateResumeData = function() {
            /*if (aoService.isResumeJourney == true) {*/
                aDCityCountryVm.city = aoService.customerAdditionalDetails.cityOfBirth;
                aDCityCountryVm.country = aoService.customerAdditionalDetails.countryOfBirth;
                aDCityCountryVm.nationality = aoService.customerAdditionalDetails.nationality;
                aDCityCountryVm.citizen = aoService.customerAdditionalDetails.citizenship;
                if(!utilityService.isUndefined(aDCityCountryVm.city) && !utilityService.isUndefined(aDCityCountryVm.country) && aDCityCountryVm.country.toLowerCase() == constantConfig.acOp.india.toLowerCase() && !utilityService.isUndefined(aDCityCountryVm.nationality) && !utilityService.isUndefined(aDCityCountryVm.citizen) && aDCityCountryVm.citizen.toLowerCase() == constantConfig.acOp.india.toLowerCase() && aDCityCountryVm.nationality.toLowerCase() == constantConfig.acOp.india.toLowerCase())
                aDCityCountryVm.disableNext = false;
                aDCityCountryVm.hideOptions = false;
                aDCityCountryVm.nationList = false;
                aDCityCountryVm.citizenList = false;
            /*}*/
        }

        /* Clear the Search field */
        $scope.clearSearch = function() {
            aDCityCountryVm.country = "";
        };

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            aDCityCountryVm.populateResumeData();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            if(aoService.isJTSixPostLoginStarted || aoService.isPreJTSixStarted){
            	if(aoService.customer.countryOfBirth){
            	   if(aoService.customer.countryOfBirth == "IN" ||aoService.customer.countryOfBirth == "in" || 
            	      aoService.customer.countryOfBirth == "INDIA" || aoService.customer.countryOfBirth == "India" || 
            	      aoService.customer.countryOfBirth == "india"){
            	      	aDCityCountryVm.diasabledCountry = true;
            	      	aDCityCountryVm.country = "India";
            	      }else{
            	      		var alertPopup = $ionicPopup.alert({
								title: "Alert",
								template: "Only Indain residance are allow to open account. Please visit branch.",
								scope: $scope,
								cssClass: 'sbi-alert-popup',
								buttons: [
									{
										text: "Ok",
										type: 'button-positive',
										onTap: function () {
											 aoService.homeNav();
										}
									}
								],
							});
							alertPopup.then(function (res) {
							});
						};            	      
                } 
            }
			aDCityCountryVm.cityCountryForm.$setPristine();
        });
        return this;
    }
]);
