'use strict';

angularApp.controller('branchDetailsController', ["$state",
    "$scope",
    "branchDetailsService",
    "aoService",
    "$translate",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        branchDetailsService,
        aoService,
        $translate,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var branchDetailsVm = this;

        function initPage() {
            branchDetailsVm.showBack = true;
            //branchDetailsVm.loadInTouchBranchDetails();
            branchDetailsVm.showLink = true;
            branchDetailsVm.showRadioBtn = false;
            branchDetailsVm.aofooter = true;
            branchDetailsVm.selectBranches = [];
            branchDetailsVm.loadInTouchCities();
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                branchDetailsVm.okBtntext = translatedvalue;  
            });   
        }

        branchDetailsVm.goBacktoPrevious = function() {
            $state.go('menu.debitCardDetails');
        }

        branchDetailsVm.goToNextPage = function(param) {
            aoService.direction.latitude = param.latitude;
            aoService.direction.longitude = param.longitude;
            aoService.direction.branchname = param.branchName;
            aoService.direction.address = param.address +"<br/>"+ param.city +'-' + param.pincode +"<br/>"+ param.state;
           // $state.go('menu.direction');      
            var geocoords = aoService.direction.latitude + ',' + aoService.direction.longitude;
            if(utilityService.isUndefined(aoService.direction.latitude) || utilityService.isUndefined(aoService.direction.longitude)){
                var title = '';
                var template = '{{"NO_DIR" | translate}}';
                var onTap = 'menu.branchDetails';
                var buttontext = '<b>' + branchDetailsVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            }
            else{
                if (utilityService.isIOSPlatform()) {
                  window.open('maps://?q=' + geocoords, '_system');
                }
                else {
                  var label = encodeURI('Your Destination'); // encode the label!
                  window.open('geo:0,0?q=' + geocoords + '(' + label + ')', '_system');
                }  
            }
                              
        }
	
        $scope.goToHome = function() {
            aoService.homeNav();
        }
	
        branchDetailsVm.loadInTouchBranchDetails = function() {
            //Service to get InTouch branch by city
            var params = {
                "city": branchDetailsVm.selectedName
            }
            branchDetailsService.loadBranchDetails(params).then(function(response) {
                branchDetailsVm.bankList = response.data.branches;
            }, function(error) {
              utilityService.showErrorMessage(error.responseMessage);
            });
        }

        branchDetailsVm.loadInTouchCities = function() {
            branchDetailsService.getCities().then(function(body) {
                if(!utilityService.isUndefined(body)){
                    for (var i = 0; i < body.length; i++) {
                        branchDetailsVm.selectBranches.push(body[i]);
                        branchDetailsVm.selectBranches.sort();
                    }
                }                
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });


        return this;
    }
]);
