'use strict';

angularApp.controller('debitCardDetailsController', ["$state",
    "$scope",
    "aoService",
    "utilityService",
    "debitCardDetailsService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        aoService,
        utilityService,
        debitCardDetailsService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var debitCardDetailsVm = this;

        function initPage() {
            debitCardDetailsVm.showBack = true;
            debitCardDetailsVm.showNext = true;
            debitCardDetailsVm.disableNext = true;
            debitCardDetailsVm.aofooter = true;
            debitCardDetailsVm.selectedMethod = "";
        }

        debitCardDetailsVm.goBacktoPrevious = function() {
            $state.go("menu.productOffering");
        }

        debitCardDetailsVm.goToNextPage = function() {
            aoService.debitCardDetails.firstName = debitCardDetailsVm.fatherFname;
            aoService.debitCardDetails.lastName = "";
            //debitCardDetailsVm.getReferenceNumber();
            debitCardDetailsVm.receiveDebitCardDetails();                         
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        debitCardDetailsVm.validateForm = function(isValid) {
            debitCardDetailsVm.disableNext = !isValid;
        }

        debitCardDetailsVm.selectCities = function() {
            $state.go('menu.branchDetails');
        }

        debitCardDetailsVm.receiveDebitCardDetails = function(){ 
             var arr = [{
             	"name" : debitCardDetailsVm.fatherFname
             }];
            var requestParams = {
                "id" : aoService.customer.mobileNo,                
                "data":{
                    "cardReadyForCollection":debitCardDetailsVm.selectedMethod,
                    "debitCardFirstName" : debitCardDetailsVm.fatherFname,
                    "kit" : arr,
                    "debitCardLastName" : "",
                    "commonId":$state.$current.data.commonId
                }
            }
            
            debitCardDetailsService.receiveDebitCard(requestParams).then(function(response) {    
                debitCardDetailsVm.getReferenceNumber();
                //$state.go('menu.enterOTPReferenceCode');            
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }


        debitCardDetailsVm.clickValidation = function(value){
         
            if(value == "corres"){
                debitCardDetailsVm.selectedMethod = "correspondance"; 
            }
            else{
                debitCardDetailsVm.selectedMethod = "Intouch";
            }        
        }

        debitCardDetailsVm.getReferenceNumber = function(){
            var requestParams = {
                "id" : aoService.customer.mobileNo,                
                "data":{
                    "commonId":$state.$current.data.commonId
                }
            }
  
            debitCardDetailsService.getReferenceNo(requestParams).then(function(response) {
                //debitCardDetailsVm.receiveDebitCardDetails();
                aoService.customer.referenceCode = utilityService.getValue(response.data.referenceCode);
                
                debitCardDetailsVm.refEmailSms();
                $state.go('menu.enterOTPReferenceCode');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        debitCardDetailsVm.refEmailSms = function(){
            var requestParams = {
                "id":aoService.customer.mobileNo,
                "receipientMailId":aoService.customer.emailId,
                "referenceCode":aoService.customer.referenceCode
            }
            
            debitCardDetailsService.sendRefEmailAndSms(requestParams).then(function(response) {
                         
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        debitCardDetailsVm.updateName = function() {
            if (aoService.isResumeJourney == false) {
                if (!utilityService.isUndefined(aoService.customerManualEntryDetails.firstName) && !utilityService.isUndefined(aoService.customerManualEntryDetails.lastName)) {
                    debitCardDetailsVm.fatherFname = aoService.customerManualEntryDetails.firstName + " " + aoService.customerManualEntryDetails.lastName;;
                    debitCardDetailsVm.fatherLname = "";

                } else if (!utilityService.isUndefined(aoService.customerAadhaarCardDetails.name)) {
                    debitCardDetailsVm.splitDebitName(aoService.customerAadhaarCardDetails.name);
                }
            } else if (aoService.isResumeJourney == true) {
                if (!utilityService.isUndefined(aoService.debitCardDetails.firstName) && !utilityService.isUndefined(aoService.debitCardDetails.lastName)) {
                    debitCardDetailsVm.fatherFname = aoService.debitCardDetails.firstName + " " + aoService.debitCardDetails.lastName;
                    debitCardDetailsVm.fatherLname = "";
                } else if (!utilityService.isUndefined(aoService.customerManualEntryDetails.firstName) && !utilityService.isUndefined(aoService.customerManualEntryDetails.lastName)) {
                    debitCardDetailsVm.fatherFname = aoService.customerManualEntryDetails.firstName + " " + aoService.customerManualEntryDetails.lastName;
                    debitCardDetailsVm.fatherLname = "";
                } else if (!utilityService.isUndefined(aoService.customerAadhaarCardDetails.name)) {
                    debitCardDetailsVm.splitDebitName(aoService.customerAadhaarCardDetails.name);
                }
                debitCardDetailsVm.selectedMethod = aoService.cardReadyForCollection;
                
            }
        }

        debitCardDetailsVm.splitDebitName = function(names) {
            var cname = names;
            var res = cname.split(" ");
            var firstname = "";
            var lastname = res[res.length - 1];
            for (var i = 0; i < res.length - 1; i++) {
                firstname += res[i] + " ";
            }
			/* debitCardDetailsVm.fatherFname = firstname.trim();
            debitCardDetailsVm.fatherLname = lastname.trim(); */
			debitCardDetailsVm.fatherFname = firstname.trim() + " " + lastname.trim();
            debitCardDetailsVm.fatherLname = "";
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
            debitCardDetailsVm.updateName();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
