'use strict';

angularApp.controller('detailsExistController', ["$state",
    "$scope",
    "detailsExistService",
    "aoService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        detailsExistService,
        aoService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var detailsExistVm = this;

        function initPage() {
            detailsExistVm.showBack = false;
            detailsExistVm.showNext = false;
            detailsExistVm.loadLocateBranchContent();
        }

        $scope.goToHome = function() {
           aoService.homeNav();
        }

        detailsExistVm.displaymap = function() {
            $state.go('menu.locateNearestBranch');
        }

        detailsExistVm.loadLocateBranchContent = function() {
            detailsExistService.getDetailsExistContent().then(function(data) {
                detailsExistVm.detailsExistMsg = data;
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }


        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        
        return this;
    }
]);
