'use strict';

angularApp.controller('directionController', ["$state",
    "$scope",
    "utilityService",
    "$translate",
    "$ionicHistory",
    "currentLocationService",
    "aoService",

    function($state,
        $scope,
        utilityService,
        $translate,
        $ionicHistory,
        currentLocationService,
        aoService) {

        var directionVm = this;
        var Map;
        var Infowindow;
        var Latitude = undefined;
        var Longitude = undefined;
        var service;
        var curt_lat;
        var curt_long;
        var directionsService;
        var directionsDisplay;
        var dest_lat = aoService.direction.latitude;
        var dest_lng = aoService.direction.longitude;

        function initPage() {
            directionVm.showBack = true;
            directionVm.showNext = false;
            directionVm.aofooter = true;
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                directionVm.okBtntext = translatedvalue;
            });
        }

         function loadScript(src){
            var script = document.createElement("script");
            script.type = "text/javascript";
            //if(callback)script.onload=callback;
            document.getElementsByTagName("head")[0].appendChild(script);
            script.src = src;
          }

        directionVm.mapInitialize = function() {
            currentLocationService.getCurrentPosition().then(
                function(position) {
                    Latitude = position.coords.latitude;
                    Longitude = position.coords.longitude;
                    curt_lat = position.coords.latitude;
                    curt_long = position.coords.longitude;
                    directionVm.getMap(Latitude, Longitude);
                },
                function(err) {
                    var title = '';
                    var template = err.message;
                    var onTap = '';
                    var buttontext = '<b>' + directionVm.okBtntext + '</b>';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                }
            );
        }

        directionVm.getMap = function(latitude, longitude) {
            var latLong = new google.maps.LatLng(latitude, longitude);
            var mapOptions = {
                center: new google.maps.LatLng(latitude, longitude),
                zoom: 1,
                mapTypeId: google.maps.MapTypeId.ROADMAP
            };

            Map = new google.maps.Map(document.getElementById("directionMap"), mapOptions);
            directionsService = new google.maps.DirectionsService;
            directionsDisplay = new google.maps.DirectionsRenderer({
                map: Map
            });

            var latLong = new google.maps.LatLng(latitude, longitude);

            directionVm.createMarker(dest_lat, dest_lng);
            document.getElementById("branchName").innerHTML = aoService.direction.branchname;
            document.getElementById("branchAddress").innerHTML = aoService.direction.address;
        }

        directionVm.createMarker = function(dest_lat, dest_lng) {
            var destloc = new google.maps.LatLng(dest_lat, dest_lng);
            var marker = new google.maps.Marker({
                map: Map,
                position: destloc
            });
            directionVm.calculateAndDisplayRoute(directionsService, directionsDisplay);
         }

        //Calculate direction and display the direction
        directionVm.calculateAndDisplayRoute = function(directionsService, directionsDisplay) {
            var start = new google.maps.LatLng(curt_lat, curt_long);
            var end = new google.maps.LatLng(dest_lat, dest_lng);
            directionsService.route({
                origin:  start,
                destination: end,
                travelMode: 'DRIVING'
              }, function(response, status) {
                if (status === 'OK') {
                  directionsDisplay.setDirections(response);
                } else {
                  utilityService.showErrorMessage('Please select a destination');
                }
            });
        }

        //Set the height of the map
        directionVm.setMapHeight = function() {
            var screenheight = Math.round(window.innerHeight * .54) + 'px';
            document.getElementById("directionMap").style.height = screenheight;
        }

        directionVm.goBacktoPrevious = function() {
            $state.go('menu.branchDetails');
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            directionVm.setMapHeight();
            directionVm.mapInitialize();
            loadScript('http://maps.googleapis.com/maps/api/js?key=AIzaSyD36sPDwe0BMMnTuAvXCh6K7k4StShJ-V8');
        });

        return this;
    }
]);
