'use strict';

angularApp.controller('enterOTPAoController', ["$state",
    "$scope",
    "$translate",
    "enterOTPService",
    "utilityService",
    "aoService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        $translate,
        enterOTPService,
        utilityService,
        aoService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var enterOTPAoVm = this;

        function initPage() {
            enterOTPAoVm.showBack = true;
            enterOTPAoVm.showNext = true;
            enterOTPAoVm.showOtpView = true;
            enterOTPAoVm.otpvalue = "";
            enterOTPAoVm.disableNext = true;
            enterOTPAoVm.aofooter = true;
            enterOTPAoVm.requestOtpCall();
            enterOTPAoVm.isDisabledOTP = false;
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                enterOTPAoVm.okBtntext = translatedvalue;  
            });
        }

        enterOTPAoVm.goBacktoPrevious = function() {
            $state.go("menu.productOffering");
        }

        enterOTPAoVm.goToNextPage = function() {
            /* Send the OTP */
            aoService.tncOtpValue = enterOTPAoVm.otpvalue;
            var requestParams = {
                "mobile":aoService.customer.mobileNo,
                "otp": enterOTPAoVm.otpvalue
            }
            
            enterOTPService.OTPValidation(requestParams).then(function(response) {
                
                if (response.data.status.toLowerCase() == "success") {
                    setTimeout(function() {
                        enterOTPAoVm.updateCommonId();
                    }, 500);
                } else {
                    utilityService.showErrorMessage(response.data.status);
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        enterOTPAoVm.updateCommonId = function() {
        	
        if(aoService.customer.mobileNo == ""){
        		if(aoService.isJTSixPostLoginStarted ){
            	aoService.customer.mobileNo  =  aoService.isJTSixPostLoginData.newMobile;
              }
        	}
            var requestParams = {
                "id": aoService.customer.mobileNo,
                "data": {
                    "commonId": $state.$current.data.commonId
                }
            }
            
            enterOTPService.sendCommonId(requestParams).then(function(response) {
               
                if (response.responseCode == "0000") {
                    $state.go('menu.debitCardDetails');
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

		 enterOTPAoVm.requestOtpCallOnce = function() {
		 	if(enterOTPAoVm.isDisabledOTP){return true}
		 	enterOTPAoVm.requestOtpCall();
                var title = '';
                var template = '{{"OTP_SENT_SUCCESS" | translate}}';
                var onTap = '';
                var buttontext = '<b>' + enterOTPAoVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
		 	enterOTPAoVm.isDisabledOTP = true;
		 };
        /* Request for OTP on page load to the registered mobile number */
        enterOTPAoVm.requestOtpCall = function() {
            var requestParams = {
                "id": aoService.customer.mobileNo,
                "recipientMailId": aoService.customer.emailId
            }
            
            enterOTPService.requestOtp(requestParams).then(function(response) {
                //enterOTPAoVm.otpvalue = utilityService.getValue(response.data.otp);
                /*if (!utilityService.isUndefined(enterOTPAoVm.otpvalue)) {
                    enterOTPAoVm.disableNext = false;
                }*/
                
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        enterOTPAoVm.validateOTP = function(isValid) {
            enterOTPAoVm.disableNext = !isValid;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
