'use strict';

angularApp.service('enterOTPService',
    function($q, AdapterUtils, constantConfig) {
        var enterOTPService = this;
        
        /* Send the OTP and ID to complete the registration */
        enterOTPService.OTPValidation = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.validateOTP, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        /* Request for OTP on page load to the registered mobile number */
        enterOTPService.requestOtp = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.getOTP, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };

        /* Request for OTP on page load to the registered mobile number */
        enterOTPService.sendCommonId = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.completeRegistration, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };
        return enterOTPService;
    });
