'use strict';

angularApp.controller('enterOTPReferenceCodeController', ["$state",
    "$scope",
    "aoService",
    "enterOTPReferenceCodeService",
    "$timeout",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        aoService,
        enterOTPReferenceCodeService,
        $timeout,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var enterOTPReferenceCodeVm = this;

        function initPage() {
            enterOTPReferenceCodeVm.showBack = false;
            enterOTPReferenceCodeVm.showNext = true;
            enterOTPReferenceCodeVm.showOtpView = true;
            enterOTPReferenceCodeVm.otpFooterView = true;
            enterOTPReferenceCodeVm.disableNext = true;
            enterOTPReferenceCodeVm.disableResendOtp = true;  
            enterOTPReferenceCodeVm.getReferenceContent();
            //enterOTPReferenceCodeVm.refEmailSms();
        }

        enterOTPReferenceCodeVm.goToNextPage = function() {
            enterOTPReferenceCodeVm.showOtpView = false;
            enterOTPReferenceCodeVm.otpFooterView = false;
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        enterOTPReferenceCodeVm.locateBranch = function() {
            $state.go('menu.locateNearestBranch');
        }

        enterOTPReferenceCodeVm.validateOTP = function(isValid) {
            enterOTPReferenceCodeVm.disableNext = !isValid;
            enterOTPReferenceCodeVm.disableResendOtp = false;
        }

        enterOTPReferenceCodeVm.getReferenceContent = function(){ 
            enterOTPReferenceCodeService.getRefContent().then(function(response) {
                enterOTPReferenceCodeVm.otpReferenceText = response.data.justStep;
                    $timeout(function() {
                        utilityService.setCsatJournies('accountOpeningDigitalCustomer');
                        var referenceDiv = document.getElementById('refcode');
                        referenceDiv.innerHTML = aoService.customer.referenceCode;
                    });             
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
           initPage(); 
           $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);   
        });

        return this;
    }
]);
