'use strict';

angularApp.controller('foreignController', ["$state",
    "$scope",
    "foreignService",
    "aoService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        foreignService,
        aoService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var foreignVm = this;

        function initPage() {
            foreignVm.showBack = true;
            foreignVm.showNext = false;
            foreignVm.getFatcaInfoDetails();
        }

        foreignVm.goBacktoPrevious = function() {
            $state.go('menu.tax'); 
        }

         //Get Tax info details on click of "i" icon
        foreignVm.getFatcaInfoDetails = function(){
            foreignService.getFatcaInfoDetails().then(function(data) {
                foreignVm.fatcaInfo = data;
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
           $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);   
        });

        return this;
    }
]);
