'use strict';

angularApp.controller('getOTPController', ["$state",
    "$scope",
    "$translate",
    "getOTPService",
    "aoService",
    "utilityService",
    "resumeJourneyService",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "encryptionService",
    "cryptoService",
    "loggedInUserService",
    "AdapterUtils",
    function ($state,
        $scope,
        $translate,
        getOTPService,
        aoService,
        utilityService,
        resumeJourneyService,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService,
        encryptionService,
        cryptoService,
        loggedInUserService,
        AdapterUtils) {

        var getOTPVm = this;

        getOTPVm.isChallenged = false;
        getOTPVm.securityCheckName = "AOSecurityCheck";
        getOTPVm.aoAuthChallengeHandler = WL.Client.createSecurityCheckChallengeHandler(getOTPVm.securityCheckName);
        getOTPVm.aoAuthChallengeHandler.securityCheckName = getOTPVm.securityCheckName;

        function initPage() {
            getOTPVm.showBack = true;
            getOTPVm.showNext = false;
            //getOTPVm.otpSentMsg = false;
            getOTPVm.resendOtpLink = true;
            //getOTPVm.otpNumberInput = true;
            getOTPVm.otpSentMsg = true;
            getOTPVm.aofooter = true;
            getOTPVm.disableFields = false;
            getOTPVm.isEnableOTPOnce = true;
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                getOTPVm.okBtntext = translatedvalue;
            });
            //countdown(3);
        }

        getOTPVm.goBacktoPrevious = function () {
            $state.go('menu.mobileEntryPage');
        }

        $scope.goToHome = function () {
            aoService.homeNav();
        }

        getOTPVm.invokeGetOTPService = function () {
            var requestParams = {
                "id": aoService.customer.mobileNo,
                "recipientMailId": aoService.customer.emailId
            }
            getOTPService.getOtp(requestParams).then(function (response) {
                //Success - Data

                //getOTPVm.resendOtpLink = false;
                //getOTPVm.otpNumberInput = false;
                //getOTPVm.getOTPNumber = utilityService.getValue(response.data.otp);
                aoService.customer.otpNo = utilityService.getValue(response.data.otp);
                var title = '';
                var template = '{{"OTP_SENT_SUCCESS" | translate}}';
                var onTap = '';
                var buttontext = '<b>' + getOTPVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);

                //getOTPVm.getOtpFromEmail(mobilenumber);
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        var timeoutHandle;

        function countdown(minutes) {
            var seconds = 60;
            var mins = minutes;

            function tick() {
                var counter = document.getElementById("timer");
                var current_minutes = mins - 1;
                seconds--;
                counter.innerHTML = current_minutes.toString() + ":" + (seconds < 10 ? "0" : "") + String(seconds);
                if (seconds > 0) {
                    timeoutHandle = setTimeout(tick, 1000);

                } else {

                    if (mins > 1) {

                        // countdown(mins-1);   never reach �00? issue solved:Contributed by Victor Streithorst
                        setTimeout(function () { countdown(mins - 1); }, 1000);


                    }
                }
            }
            tick();
        }



        //On click of Resend OTP link
        getOTPVm.resendOTPService = function () {
            if (getOTPVm.isEnableOTPOnce == false) { return true }
            getOTPVm.invokeGetOTPService();
            getOTPVm.isEnableOTPOnce = false;
        }

        // Validate OTP service call and redirect to next page
        getOTPVm.validateOtpCall = function () {

            getOTPVm.loginWithOTP();
            /* var inputData = {
              "mobile":aoService.customer.mobileNo,
                  "otp": getOTPVm.getOTPNumber
              }
          	
              getOTPService.validateOtp(inputData).then(function(response) {
                  
                  if (response.data.status.toLowerCase() == "success") {
                      $state.go('menu.appPassword');
                  } else {
                      getOTPVm.resendOtpLink = false;
                      utilityService.showErrorMessage(response.data.status);
                  }
              }, function(error) {
                  utilityService.showErrorMessage(error.responseMessage);
              });
              */
        }

        //Challenge Handler
        getOTPVm.loginWithOTP = function () {
            utilityService.showSpinner();
            getOTPVm.aoAuthChallengeHandler.handleChallenge = function (challenge) {
                getOTPVm.isChallenged = true;
                utilityService.hideSpinner();
                if (challenge.errorMsg !== null) {
                    utilityService.showErrorMessage(utilityService.getServerExceptionMessage(challenge));
                } else {
                    utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
                }
            };

            getOTPVm.aoAuthChallengeHandler.handleSuccess = function (data) {
                utilityService.hideSpinner();
                getOTPVm.isChallenged = false;
                if (data.user) {
                    loggedInUserService.keyId = AdapterUtils.secretData == "" ? data.user.attributes.keyId : encryptionService.getAES256DecryptedData(data.user.attributes.keyId);
                    loggedInUserService.tokenLotus = AdapterUtils.secretData == "" ? data.user.attributes.lotusToken : encryptionService.getAES256DecryptedData(data.user.attributes.lotusToken);
                }
            };

            getOTPVm.aoAuthChallengeHandler.handleFailure = function (error) {
                getOTPVm.aoAuthChallengeHandler.cancel();
                getOTPVm.isChallenged = false;
                utilityService.hideSpinner();
                if (error.failure) {
                    utilityService.showErrorMessage(error.failure);
                } else {
                    utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
                }
            }

            var payload = {};
            var requestParams = {
                "mobileOTPKey": aoService.customer.mobileNo,
                "passOTPKey": getOTPVm.getOTPNumber,
                "mfDeviceId": loggedInUserService.deviceIdForMpin
            }
            var src = cryptoService.encryptRSAWithPublicKey(encryptionService.iv + "^" + encryptionService.passphrase + "^" + encryptionService.salt, cryptoService.rsaPublicKey);
            payload = {
                "data": AdapterUtils.secretData + encryptionService.getAES256EncryptedData(JSON.stringify(requestParams)),
                "src": src
            }

            payload = AdapterUtils.secretData == "" ? requestParams : payload;

            if (getOTPVm.isChallenged) {
                getOTPVm.aoAuthChallengeHandler.submitChallengeAnswer(payload);
            } else {
                WLAuthorizationManager.login(getOTPVm.aoAuthChallengeHandler.securityCheckName, payload).then(
                    function (data) {
                        utilityService.accessRestricted = utilityService.AOAuthRequired;
                        utilityService.hideSpinner();
                        $state.go('menu.appPassword');
                    },
                    function (error) {
                        utilityService.accessRestricted = "";
                        utilityService.hideSpinner();
                        if (error.errorCode == 'CHALLENGE_HANDLING_CANCELED' || error.errorCode == 'APPLICATION_DISABLED') {
                            return;
                        }
                        if (error.errorCode == "LOGIN_ALREADY_IN_PROCESS") {
                            getOTPVm.aoAuthChallengeHandler.cancel();
                        }
                        utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
                    });
            }

        }


        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        $scope.$on('$ionicView.beforeLeave', function () {
            
        });

        return this;
    }
]);
