'use strict';

angularApp.service('getOTPService',
    function($q, AdapterUtils, constantConfig) {
        var getOTPService = this;
        getOTPService.getOtp = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.getOTP, requestData, true).then(
                
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };

        getOTPService.setReferralMobNo = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.setReferralCode, requestData, true).then(
                
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };

        getOTPService.validateOtp = function(requestParams) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.validateOTP, requestParams, true).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };

        getOTPService.emailServiceOtp = function(requestParams){
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.emailServiceForOtp, requestParams, true).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        }

        getOTPService.getCustomerDetails = function(requestData) {
            
            var q = $q.defer();
           
           AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.customerDocumentDetails, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        return getOTPService;
    });
