'use strict';

angularApp.controller('locateBranchController', ["$state",
    "$scope",
    "locateBranchService",
    "aoService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        locateBranchService,
        aoService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var locateBranchVm = this;

        function initPage() {
            locateBranchVm.showBack = true;
            locateBranchVm.showNext = false;
            locateBranchVm.loadLocateBranchContent();
            locateBranchVm.aofooter = true;
        }

        $scope.goToHome = function() {
           aoService.homeNav();
        }

        locateBranchVm.goBacktoPrevious = function() {
            $state.go("menu.tax");
        }

        locateBranchVm.displaymap = function() {
            $state.go('menu.locateNearestBranch');
        }

        locateBranchVm.loadLocateBranchContent = function() {
            locateBranchService.getLocateBranchContent().then(function(data) {
                locateBranchVm.locateBranchMsg = data;
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
           $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);   
        });
        
        return this;
    }
]);
