'use strict';

angularApp.controller('locateBranchByGpsController', ["$state",
    "$scope",
    "locateNearestBranchService",
    "aoService",
    "utilityService",
    "currentLocationService",
    "$timeout",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
	"$rootScope",
  "$ionicHistory",
	"homeScreenService",
    function($state,
        $scope,
        locateNearestBranchService,
        aoService,
        utilityService,
        currentLocationService,
        $timeout,
        $ionicSideMenuDelegate,
        mPinLoginService, $rootScope,$ionicHistory,homeScreenService) {

        var locateBranchGpsVm = this;

        function initPage() {
            locateBranchGpsVm.showBack = true;
            //locateBranchGpsVm.showNext = true;
            //locateBranchGpsVm.disableNext = true;
            locateBranchGpsVm.showRadioBtn = true;
            locateBranchGpsVm.showLink = true;
            locateBranchGpsVm.aofooter = true;
            locateBranchGpsVm.gpsLink = true;
        }

        locateBranchGpsVm.goBacktoPrevious = function() {
            $state.go('menu.locateNearestBranch');
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        locateBranchGpsVm.validateForm = function(isValid) {
            if (isValid) {
                locateBranchGpsVm.disableNext = false;
            }
        }

        locateBranchGpsVm.navigatePage = function(param){
           var geocoords = param.latitude + ',' + param.longitude;
           if(utilityService.isUndefined(param.latitude) || utilityService.isUndefined(param.longitude)){
                var title = '';
                var template = '{{"NO_DIR" | translate}}';
                var onTap = 'menu.locateBranchByLocality';
                var buttontext = '<b>' + locateBranchGpsVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            }
            else{
                if (utilityService.isIOSPlatform()) {
                  window.open('maps://?q=' + geocoords, '_system');
                }
                else {
                  var label = encodeURI('Your Destination'); // encode the label!
                  window.open('geo:0,0?q=' + geocoords + '(' + label + ')', '_system');
                }  
            }
        }

        //Service for displaying branch list for latitude and longitude
        locateBranchGpsVm.loadBranchesGps = function() {            
            locateBranchGpsVm.bankListGps = aoService.locateByGPS;
        }
		
		locateBranchGpsVm.closeView = function(){
      $scope.isLoggedin = mPinLoginService.isLoggedIn;
      locateBranchGpsVm.isLoggedin = $scope.isLoggedin;

        if (!locateBranchGpsVm.isLoggedin) {
          $state.go('menu.userLogin');
        } else {
          $ionicHistory.clearCache().then(function () {
            $ionicHistory.goBack(-1);
          })
        }

		//	$state.go('menu.userLogin');
		};

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        $scope.$on('$ionicView.beforeEnter', function() {
            locateBranchGpsVm.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            locateBranchGpsVm.loadBranchesGps(); 
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn); 
        });

        return this;
    }
]);
