'use strict';

angularApp.controller('locateNearestBranchController', ["$state",
    "$scope",
    "aoService",
    "$ionicHistory",    
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "currentLocationService",
    "$translate",
    "utilityService",
    "locateNearestBranchService",

    function($state,
        $scope,
        aoService,
        $ionicHistory,
        $ionicSideMenuDelegate,
        mPinLoginService,
        currentLocationService,
        $translate,
        utilityService,
        locateNearestBranchService) {

        var locateNearestBranchVm = this;

        function initPage() {
            locateNearestBranchVm.showBack = true;
            locateNearestBranchVm.showNext = true;
            locateNearestBranchVm.disableNext = true;
            locateNearestBranchVm.byLocalityInput = true;
            locateNearestBranchVm.aofooter = true;
	 $translate('AO_OK_LABEL').then(function(translatedvalue) {
                locateNearestBranchVm.okBtntext  = translatedvalue;
            });
        }

        locateNearestBranchVm.goBacktoPrevious = function() {
            $ionicHistory.goBack();
        }

        locateNearestBranchVm.goToNextPage = function() {
            locateNearestBranchVm.redirectState();
        }
        
        $scope.goToHome = function() {
            aoService.homeNav();
        }

        locateNearestBranchVm.redirectState = function() {
            if (locateNearestBranchVm.isGpsClicked === true) {
                $state.go('menu.locateBranchByGps');
            } else {
                $state.go('menu.locateBranchByLocality');
            }  
        }

        locateNearestBranchVm.bylocality = function() {
            locateNearestBranchVm.isGpsClicked = false;
            locateNearestBranchVm.disableNext = false;
            locateNearestBranchVm.byLocalityInput = false;
        }

         locateNearestBranchVm.bygps = function() {  
            
            CheckGPS.check(function(){
                currentLocationService.getCurrentPosition().then(
                function(position) {
                    var latitude = position.coords.latitude;
                    var longitude = position.coords.longitude;
            
                    aoService.locateByGPS.length = 0; 
                    var params = {
                        "latitude": latitude,
                        "longitude":longitude
                    }
                    if(utilityService.isUndefined(aoService.locateByGPS) || aoService.locateByGPS.length === 0){
                        locateNearestBranchService.getBranchesForGeo(params).then(function(data) {
                            if(!utilityService.isUndefined(data)){
                                for (var i = 0; i < data.branches.length; i++) {
                                    aoService.locateByGPS.push(data.branches[i]);
                                    setTimeout(function() { 
                                    
                                    if(aoService.locateByGPS.length == 0){
                                        var title = '';
                                        var template = '{{"UNABLE_TO_GET_BRANCH" | translate}}';
                                        var onTap = 'menu.selectBranchOption';
                                        var buttontext = 'OK';
                                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                                    }
                                }, 300);
                                }
                            }                            
                        }, function(error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    }
                    else{
                        
                    }
                },
                function(err) {
                    var title = '';
                    var template = '{{"ON_GPS" | translate}}';
                    var onTap = '';
                    var buttontext = '<b>' + locateNearestBranchVm.okBtntext + '</b>';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                }
            );   
            },
            function(){
                var title = '';
                var template = '{{"ENABLE_GPS" | translate}}';
                var onTap = '';
                var buttontext = 'OK';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            });               
            locateNearestBranchVm.isGpsClicked = true;
            locateNearestBranchVm.disableNext = false;
            locateNearestBranchVm.byLocalityInput = true;
        }

        locateNearestBranchVm.validateform = function(isValid) {
            locateNearestBranchVm.disableNext = false;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            aoService.localityNav = "locateBranch";
            aoService.localityNextDisable="locateBranchList";
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);   
        });

        return this;
    }
]);
