'use strict';

angularApp.controller('mobileEntryPageController', ["$state",
    "$scope",
    "mobileEntryPageService",
    "aoService",
    "utilityService",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "instaService",
    "JTSixService",
    "customerInfoService",
    "resumeJourneyService",
    "$ionicPopup",
	"$translate",
    function($state,
        $scope,
        mobileEntryPageService,
        aoService,
        utilityService,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService,
	instaService,
	JTSixService,
	customerInfoService,
	resumeJourneyService,
	$ionicPopup,
	$translate) {

        var mobileEntryPageVm = this;

        function initPage() {
            mobileEntryPageVm.showBack = true;
            mobileEntryPageVm.showNext = true;
            mobileEntryPageVm.disableNext = true;
            mobileEntryPageVm.aofooter = true;
            mobileEntryPageVm.checkReferralField = false;
            mobileEntryPageVm.referralMobNo = '';
            mobileEntryPageVm.policyWording = instaService.getFeature() ? instaService.getFeature():"";
            mobileEntryPageVm.isJTSixPostLoginStarted = aoService.isJTSixPostLoginStarted ;
            if(aoService.isJTSixPostLoginStarted ){
            	aoService.isJTSixPostLoginStarted = true;
            	mobileEntryPageVm.newMobile  =  aoService.isJTSixPostLoginData.newMobile;
            	mobileEntryPageVm.newMail  =  aoService.isJTSixPostLoginData.newMail;
            	mobileEntryPageVm.newMailDisable  =  aoService.isJTSixPostLoginData.newMail;
            }
        }

        mobileEntryPageVm.goBacktoPrevious = function() {
          if(aoService.isJTSixPostLoginStarted ){
	        aoService.homeNav();
            	return true;
            }
            $state.go('menu.accountOpening');
        }

        mobileEntryPageVm.goToNextPage = function(isValid, mobNo) {
       	if(aoService.isJTSixPostLoginStarted ){
            	mobileEntryPageVm.checkPasswordAvailability(); 
            	return "";
            }
        	
            mobileEntryPageVm.submitForm(isValid, mobNo);
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        mobileEntryPageVm.checkFormValid = function(isValid){
           
            if(isValid == true && mobileEntryPageVm.restrictedDomainNames == false){
                mobileEntryPageVm.disableNext = false;
            }
            else{
                mobileEntryPageVm.disableNext = true;
            }
        }

        //Get OTP Service call
        mobileEntryPageVm.submitForm = function(isValid, mobNo) {
            if (isValid) {
				if(!utilityService.isUndefined(mobileEntryPageVm.referralMobNo)){
                    this.setReferralMobNo(mobNo,mobileEntryPageVm.referralMobNo)
                }
                mobileEntryPageVm.checkIfDetailsExists(mobNo);
                //this.invokeGetOTPService(mobNo);
               
            }
        }

        mobileEntryPageVm.checkReferralCode = function(){
            if(utilityService.isUndefined(mobileEntryPageVm.referralMobNo)){
                mobileEntryPageVm.checkReferralField = false;
            }
            else{
                mobileEntryPageVm.checkReferralField = true;
            }   
        }

		mobileEntryPageVm.checkPasswordAvailability = function(mobilenumber) {	
					var obj = {
						"id" : customerInfoService.customer.mobile ? customerInfoService.customer.mobile : "",
						"email" :  customerInfoService.customer.emailID ? customerInfoService.customer.emailID : ""
					};
		            JTSixService.checkPasswordAvailability(obj).then(function(response) {
		            	
			        	if(response.data){
					        		if(response.data.cloudStatusFlag === true){
				            				var title = '';
					                        var template = response.responseMessage;
					                        var onTap = '';
					                        var buttontext = '<b>' + 'OK' + '</b>';
					                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
					                        return true; 
				            	}
				            	if((!response.data.personalDetails.firstName) || (!response.data.personalDetails.lastName)){
				            		var title = '';
									$translate('PLEASEVISIT_AO').then(function(translatedvalue) {
											 var template = translatedvalue;
					                        var onTap = '';
					                        var buttontext = '<b>' + 'OK' + '</b>';
					                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
					                        return true; 
										});
					                       
				            	}
				            	
			              		aoService.isJTSixPostLoginData.firstName = response.data.personalDetails.firstName  ? response.data.personalDetails.firstName : "";
								aoService.isJTSixPostLoginData.lastName = response.data.personalDetails.lastName ? response.data.personalDetails.lastName : "";
								aoService.isJTSixPostLoginData.mobileNumber = aoService.isJTSixPostLoginData.newMobile;//response.data.personalDetails.mobileNumber ? response.data.personalDetails.mobileNumber  :"";
								aoService.isJTSixPostLoginData.emailId = response.data.personalDetails.emailId ? response.data.personalDetails.emailId : "";
								aoService.isJTSixPostLoginData.gender = response.data.personalDetails.gender ? response.data.personalDetails.gender : "";
								aoService.isJTSixPostLoginData.genderCode = response.data.personalDetails.genderCode ? response.data.personalDetails.genderCode : "";
								aoService.isJTSixPostLoginData.dob = response.data.personalDetails.dob ? response.data.personalDetails.dob  : "";
								aoService.isJTSixPostLoginData.middleName = response.data.personalDetails.middleName ? response.data.personalDetails.middleName : "";
								aoService.isJTSixPostLoginData.title =  response.data.personalDetails.title ? response.data.personalDetails.title  : "";
								aoService.isJTSixPostLoginData.titleCode =  response.data.personalDetails.titleCode ? response.data.personalDetails.titleCode  : "";	
								//aoService.isJTSixPostLoginData.newMobile =  response.data.personalDetails.mobileNumber ? response.data.personalDetails.mobileNumber  : "";
								aoService.isJTSixPostLoginData.newMail =  response.data.personalDetails.emailId ? response.data.personalDetails.emailId  : "";
								aoService.isJTSixPostLoginData.pan =  response.data.personalDetails.pan? response.data.personalDetails.pan : "";
								aoService.isJTSixPostLoginData.uid =  response.data.personalDetails.uid? response.data.personalDetails.uid : "";
			              		aoService.customer.mobileNo = aoService.isJTSixPostLoginData.newMobile;//response.data.personalDetails.mobileNumber ? response.data.personalDetails.mobileNumber  : "";
			              		aoService.customer.countryOfBirth = response.data.personalDetails.countryOfBirth ? response.data.personalDetails.countryOfBirth  : "";
			              		
				              	constantConfig.JTSix.getCustomerInfromation = constantConfig.JTSix.getCustomerInfromationPost;
				              	constantConfig.acOpeningAdapterUrl = constantConfig.jTSixOpeningAdapterUrl;
			              		mobileEntryPageVm.getCustomerDetails(); 
			              	}
			              	 }, function(error) {
                utilityService.showErrorMessage(error.responseMessage); 
            });
		};


	mobileEntryPageVm.getCustomerDetails = function () {
	          var requestParams = {
	                "id": aoService.isJTSixPostLoginData.newMobile,
	                "password": ""
	            }
	            resumeJourneyService.getCustomerDetails(requestParams).then(function (response) {
	                var customerDetails = response.data;
	                aoService.getResumeDocument(response.data);
	                mobileEntryPageVm.getPageDetails(response.data.productOfferingFlag);
	            }, function (error) {
	                if(!utilityService.isUndefined(error.data)){
	                    if(error.data.type.toLowerCase() == "ao_insta"){
	                        var title = '';
	                        var template = '{{"NOT_J23_ACC" | translate}}';
	                        var onTap = 'menu.instaKit_resumeJourney';
	                        var buttontext = '<b>' + "OK" + '</b>';
	                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);  
	                    }
	                }else if(error.responseCode == "0008"){
	                    var title = '';
	                    var template = error.responseMessage;
	                    var onTap = '';
	                    var buttontext = '<b>' + "OK" + '</b>';
	                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
	                }else{
	                    var title = '';
	                    var template = 'Details do not match.';
	                    var onTap = '';
	                    var buttontext = '<b>' + "OK" + '</b>';
	                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
	                }
                
	            });
	        }

	mobileEntryPageVm.getCommonId = function (commonId, proFlag) {
            aoService.getCommonId(commonId, proFlag);
        }
     mobileEntryPageVm.resumestate = function (state) {
        	if(state == 'menu.tax'){
        	$state.go(state);	
        	}else{
	        		var alertPopup = $ionicPopup.alert({
									title: "Alert",
									template: "System detects a partially filled application. Please complete the same.",
									scope: $scope,
									cssClass: 'sbi-alert-popup',
									buttons: [
										{
											text: "Ok",
											type: 'button-positive',
											onTap: function () {
												$state.go(state);	
											}
										}
									],
								});
								alertPopup.then(function (res) {
								});
        	}
        };   
        
	mobileEntryPageVm.getPageDetails = function (proFlag) {
	            resumeJourneyService.getPageDetails(aoService.isJTSixPostLoginData.newMobile).then(function (response) {
	                if((!response.payLoad) || (!response.payLoad.commonId)){
	                	$state.go("menu.tax");
	                }
	                var splitUrls = [];
	                var splittedUrl1, splittedUrl2;
	                if (response.payLoad.commonId == "FATCA") {
	                    if (aoService.fatcaFlag == false) {
	                        mobileEntryPageVm.resumestate("menu.locateBranch");
	                    }
	                    else {
	                        mobileEntryPageVm.resumestate(response.payLoad.mobileURL);
	                    }
	                }
	                else if (response.payLoad.commonId == "AadharManual") {
	                    splitUrls = response.payLoad.mobileURL.split("/");
	                    splittedUrl1 = splitUrls[0];
	                    splittedUrl2 = splitUrls[1];
	                    if (aoService.isCustManualCorresChkBox == true || aoService.isresumeCustManualCorresChkBox == true) {
	                        mobileEntryPageVm.resumestate(splittedUrl1);
	                    } else {
	                        mobileEntryPageVm.resumestate(splittedUrl2);
	                    }

	                } else if (response.payLoad.commonId == "AadharScanned") {
	                    splitUrls = response.payLoad.mobileURL.split("/");
	                    splittedUrl1 = splitUrls[0];
	                    splittedUrl2 = splitUrls[1];
	                    if (aoService.correspondenceCheckStatus == true) {
	                        mobileEntryPageVm.resumestate(splittedUrl1);
	                    } else {
	                        mobileEntryPageVm.resumestate(splittedUrl2);
	                    }

	                } else if (response.payLoad.commonId == "NomineeDetails") {
	                    splitUrls = response.payLoad.mobileURL.split("/");
	                    splittedUrl1 = splitUrls[0];
	                    splittedUrl2 = splitUrls[1];
	                    if (parseInt(aoService.nomineeAadhaarCardDetails.age) < 18 || parseInt(aoService.nominee.age) < 18) {
	                        if (aoService.nominee.guardianAddressFlag == "nomineeAddress") {
	                            mobileEntryPageVm.resumestate("menu.nomineeEnteredAddress");
	                        }
	                        else if (aoService.nominee.guardianAddressFlag == "applicantAddress") {
	                            mobileEntryPageVm.resumestate("menu.nomineeAddress");
	                        }
	                        else if (aoService.nominee.guardianAddressFlag == "newAddress") {
	                            mobileEntryPageVm.resumestate("menu.nomineeCAddress");
	                        }
	                        else {
	                            mobileEntryPageVm.resumestate(splittedUrl1);
	                        }
	                    } else {
	                        mobileEntryPageVm.resumestate(splittedUrl2);
	                    }
	                }
	                else if (response.payLoad.commonId == "PAN") {
	                    if (aoService.cifNumber == '0000') {
	                        mobileEntryPageVm.resumestate(response.payLoad.mobileURL);
	                    }
	                    else if (aoService.cifNumber == "0001") {
	                        mobileEntryPageVm.resumestate('menu.panDetails');
	                    }else if (aoService.cifNumber == '1000') {
		                        mobileEntryPageVm.resumestate('menu.panDetails');
		                    }
	                    else {
	                        mobileEntryPageVm.resumestate("menu.tax");
	                    }

	                } else {
	                    mobileEntryPageVm.resumestate(response.payLoad.mobileURL);
	                }

	                mobileEntryPageVm.getCommonId(response.payLoad.commonId, proFlag);

	            }, function (error) {
	                var title = '';
	                var template = error.responseMessage;
	                var onTap = '';
	                var buttontext = '<b> OK </b>';
	                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
	            });
	        }


        mobileEntryPageVm.invokeGetOTPService = function(mobilenumber) {
            var requestParams = {
                "id": mobilenumber,
                "recipientMailId": mobileEntryPageVm.newMail
            }
            mobileEntryPageService.getOtp(requestParams).then(function(response) {
                //Success - Data
                aoService.customer.otpNo = utilityService.getValue(response.data.otp);
                
                aoService.customer.emailId = mobileEntryPageVm.newMail;
                aoService.customer.mobileNo = mobileEntryPageVm.newMobile;
                $state.go("menu.getOTP");
                //mobileEntryPageVm.getOtpFromEmail(mobilenumber);
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage); 
            });
        }

        mobileEntryPageVm.setReferralMobNo = function(user_mob_no,ref_mob_no) {
            var requestParams = {
                "mobileNo": user_mob_no,
                "referralMobNo":ref_mob_no,
				"journeyName":"AO",
				"status" : "Inprogress"
            }
            mobileEntryPageService.setReferralMobNo(requestParams).then(function(response) {
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage); 
            });
        }

        mobileEntryPageVm.restrictEmailDomains = function(){
            if(mobileEntryPageVm.getOtpForm.emailId.$valid == true){
                var newmail =  mobileEntryPageVm.newMail; 
                var newmailCase = newmail.toLowerCase();      
                var mailSplit = newmailCase.split("@")[0];
                var postMailSplit = newmailCase.split("@")[1];
                
                if(mailSplit.indexOf("sbi")!=-1 && (/\d/g.test(mailSplit))===true){
                    mobileEntryPageVm.restrictedDomainNames = true;
                }
                else if(postMailSplit.indexOf("gmail") != -1 && postMailSplit.indexOf(".com") === -1){
                    mobileEntryPageVm.restrictedDomainNames = true;
                }
                else if(postMailSplit.indexOf("yahoo") != -1){
                    var yahooExtensions = [".com", ".co.in", ".in"];
                    var count = 0;
                    for (var i = 0; i < yahooExtensions.length; i++){
                        if (postMailSplit.indexOf(yahooExtensions[i]) != -1){
                            count++;
                        }
                    }
                    if(count > 0){
                        mobileEntryPageVm.restrictedDomainNames = false;
                    }
                    else{
                        mobileEntryPageVm.restrictedDomainNames = true;
                    }
                }
                else if(postMailSplit.indexOf("rediffmail") != -1 && postMailSplit.indexOf(".com") === -1){
                    mobileEntryPageVm.restrictedDomainNames = true;
                }
                else{
                    mobileEntryPageVm.restrictedDomainNames = false;
                }
            }
        }
        var mobNoExists = "";
        mobileEntryPageVm.checkIfDetailsExists = function(mobileNumber) {
            var requestParams = {
                "id": mobileNumber
            }
            
            mobileEntryPageService.getCustomerDetails(requestParams).then(function(response) {
                //var customerDetails = response.data;
                if(response.data == null && response.responseCode == constantConfig.successCode){
                    if(mPinLoginService.isLoggedIn == true){
                        mobNoExists = response.responseCode;
                        var title = '';
                        var template = 'Mobile number is already registered. Kindly resume';
                        var onTap = 'menu.resumeJourney';
                        var buttontext = '<b>' + 'OK' + '</b>';
                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext); 
                    }
                    else{
                        mobNoExists = response.responseCode;
                        var title = '';
                        var template = 'Mobile number is already registered. Kindly resume';
                        var onTap = 'menu.resumeJourney';
                        var buttontext = '<b>' + 'OK' + '</b>';
                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext); 
                    }
                    
                }
               
                //aoService.getResumeDocument(response.data);
                //resumeJourneyVm.getPageDetails();
            }, function(error) {
                mobNoExists = error.responseCode;
                if(!utilityService.isUndefined(error.data)){
                    if(error.data.type.toLowerCase() == 'ao_insta'){
                        var title = '';
                        var template = '{{"NOT_J23_ACC" | translate}}';
                        var onTap = 'menu.instaKit_resumeJourney';
                        var buttontext = '<b>' + 'OK' + '</b>';
                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                    }
                }
                
                else{
                    mobileEntryPageVm.invokeGetOTPService(mobileNumber);
                }
            });
        }
        
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
            if(aoService.isJTSixPostLoginStarted ){
            	mobileEntryPageVm.disableNext = false;
            }
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);   
        });

        return this;
    }
]);
