'use strict';

angularApp.service('mobileEntryPageService',
    function($q, AdapterUtils, constantConfig) {
        var mobileEntryPageService = this;
        mobileEntryPageService.getOtp = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.getOTP, requestData, true).then(
                
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };

        mobileEntryPageService.setReferralMobNo = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.setReferralCode, requestData, true).then(
                
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };


        mobileEntryPageService.emailServiceOtp = function(requestParams){
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.emailServiceForOtp, requestParams, true).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        }

        mobileEntryPageService.getCustomerDetails = function(requestData) {
            
            var q = $q.defer();
           
           AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.customerDocumentDetails, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        return mobileEntryPageService;
    });
