'use strict';

angularApp.controller('netBankingRegisterController', ["$state",
    "$scope",
    "netBankingRegisterService",
    "aoService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",


    function($state,
        $scope,
        netBankingRegisterService,
        aoService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var netBankingRegisterVm = this;

        function initPage() {
            netBankingRegisterVm.showBack = true;
            netBankingRegisterVm.showNext = true;
            netBankingRegisterVm.reAppPasswordCheck = false;
            netBankingRegisterVm.disableNext = true;
            netBankingRegisterVm.aofooter = true;
        }

        netBankingRegisterVm.goBacktoPrevious = function() {
            $state.go('menu.accountOpeningDetails');
        }

        netBankingRegisterVm.goToNextPage = function() {
            var requestParams = {
                "lotusId" : aoService.customer.lotusId,
                "tempUsername": netBankingRegisterVm.tempUsername,
                "internetBankingUsername": netBankingRegisterVm.ibUsername,
                "password": netBankingRegisterVm.password
            }
            netBankingRegisterService.registerInternetBanking(requestParams).then(function(response) {
               $state.go('menu.aoMpin');
            }, function(error) {
              utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        netBankingRegisterVm.changePassword = function() {
            if (netBankingRegisterVm.cpassword != netBankingRegisterVm.password) {
                netBankingRegisterVm.cpassword = "";
                netBankingRegisterVm.reAppPasswordCheck = true;
                netBankingRegisterVm.disableNext = true;
                return true;
            }
            netBankingRegisterVm.reAppPasswordCheck = false;
            return true;
        }

        netBankingRegisterVm.changeCPassword = function() {
            if (netBankingRegisterVm.cpassword != netBankingRegisterVm.password) {
                netBankingRegisterVm.reAppPasswordCheck = false;
            }
            return true;
        }

        netBankingRegisterVm.proceedSuccess = function(isValid) {
            isValid ? netBankingRegisterVm.disableNext = false : netBankingRegisterVm.disableNext = true;
            return netBankingRegisterVm.disableNext;
        }
        
        netBankingRegisterVm.validateForm = function(isValid) {
            netBankingRegisterVm.disableNext = !isValid;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);   
        });

        return this;
    }
]);
