'use strict';

angularApp.controller('nomineeAddressController', ["$state",
    "$scope",
    "aoService",
    "nomineeDetailsRelatedService",
    "utilityService",
    "$timeout",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        aoService,
        nomineeDetailsRelatedService,
        utilityService,
        $timeout,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var nomineeAddressVm = this;

        function initPage() {
            nomineeAddressVm.personalDetails = {};
            nomineeAddressVm.showBack = true;
            nomineeAddressVm.showNext = true;
            nomineeAddressVm.aofooter = true;
            nomineeAddressVm.disableNext = true;
        }

        nomineeAddressVm.goBacktoPrevious = function() {
            $state.go("menu.nomineeDetailsAddressOption");
        }

        nomineeAddressVm.setGuardianDetails = function() {
            var guardianDetails = {};
            if (aoService.isNomineeScanned === true) {
                guardianDetails.nomineeName = aoService.nomineeAadhaarCardDetails.name;
                guardianDetails.guardianName = aoService.nomineeAadhaarCardDetails.guardianName;
            } else {
                guardianDetails.nomineeName = aoService.nominee.name;
                guardianDetails.guardianName = aoService.nominee.guardianName;
            }
            return guardianDetails;
        }

        /*$scope.$watch("nomineeAddressVm.guardian-appoint.$valid", function(value) {
            
            if (value === true) {
                nomineeAddressVm.disableNext = false;
            } else {
                nomineeAddressVm.disableNext = true;
            }
        });*/

        nomineeAddressVm.changefn = function() {
            //nomineeAddressVm.disableNext = !isValid;
            if (nomineeAddressVm.isChecked) {
                nomineeAddressVm.disableNext = false;
            } else {
                nomineeAddressVm.disableNext = true;
            }
        }

        nomineeAddressVm.goToNextPage = function() {
            //Service to update guardian details
            var guardianDetailParams = nomineeAddressVm.setGuardianDetails();
            aoService.nomineeGuardianDetails.guardianConsent = nomineeAddressVm.isChecked;
            if(utilityService.isUndefined(guardianDetailParams.guardianName)){
              var title = '';
              var template = '{{"IF_GUARDIAN_NAME_EMPTY" | translate}}';
              var onTap = 'menu.nominationRelated';
              var buttontext = 'OK';
              utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            }
            else{
            var params = {
                "id": aoService.customer.mobileNo,
                "data": {
                    "nominees": [{
                        "guardian": {
                            "address": {
                                "addressLine1": nomineeAddressVm.personalDetails.addressLine1,
                                "addressLine2": nomineeAddressVm.personalDetails.addressLine2,
                                "pincode": nomineeAddressVm.personalDetails.pincode,
                                "city": nomineeAddressVm.personalDetails.city,
                                "cityCode":"",
                                "state": nomineeAddressVm.personalDetails.state,
                                "stateCode":"",
                                "locality": ""
                            },
                            "name": guardianDetailParams.guardianName,
                            "guardianAddressFlag": aoService.nominee.guardianAddressFlag,
                            "guardianConsent" : aoService.nomineeGuardianDetails.guardianConsent
                        },
                        "name": guardianDetailParams.nomineeName
                    }],
                    "commonId": $state.$current.data.commonId
                }
            }
            
            nomineeDetailsRelatedService.updateGuardian(params).then(function(response) {
                $state.go("menu.selectBranchOption");
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
          }
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        nomineeAddressVm.displayGuardianAddress = function() {
           
            nomineeAddressVm.isChecked = aoService.nomineeGuardianDetails.guardianConsent;
            if (aoService.isAadharManualEntry === false) {
                if (aoService.isResumeJourney === false && aoService.correspondenceCheckStatus == false) {
                    nomineeAddressVm.personalDetails.addressLine1 = aoService.nullCheck(aoService.customerAadhaarCardDetails.house) + aoService.nullCheck(aoService.customerAadhaarCardDetails.street);
                    nomineeAddressVm.personalDetails.addressLine2 = aoService.nullCheck(aoService.customerAadhaarCardDetails.lm) + aoService.nullCheck(aoService.customerAadhaarCardDetails.loc) + aoService.nullCheck(aoService.customerAadhaarCardDetails.vtc) + aoService.nullCheck(aoService.customerAadhaarCardDetails.po);
                    nomineeAddressVm.personalDetails.address = aoService.nullCheck(aoService.customerAadhaarCardDetails.house) + aoService.nullCheck(aoService.customerAadhaarCardDetails.street) + aoService.nullCheck(aoService.customerAadhaarCardDetails.lm) + aoService.nullCheck(aoService.customerAadhaarCardDetails.loc) + aoService.nullCheck(aoService.customerAadhaarCardDetails.vtc) + aoService.nullCheck(aoService.customerAadhaarCardDetails.po) + aoService.nullCheck(aoService.customerAadhaarCardDetails.dist) + aoService.nullCheck(aoService.customerAadhaarCardDetails.state);
                    nomineeAddressVm.personalDetails.pincode = aoService.customerAadhaarCardDetails.pc;
                    nomineeAddressVm.personalDetails.city = aoService.customerAadhaarCardDetails.dist;
                    nomineeAddressVm.personalDetails.state = aoService.customerAadhaarCardDetails.state;
                } else if (aoService.correspondenceCheckStatus == true) {
                    nomineeAddressVm.personalDetails.addressLine1 = aoService.nullCheck(aoService.customerCorrespondenceAddress.address1);
                    nomineeAddressVm.personalDetails.addressLine2 = aoService.nullCheck(aoService.customerCorrespondenceAddress.address2);
                    nomineeAddressVm.personalDetails.address = aoService.nullCheck(aoService.customerCorrespondenceAddress.address1) + aoService.nullCheck(aoService.customerCorrespondenceAddress.address2);
                    nomineeAddressVm.personalDetails.pincode = aoService.customerCorrespondenceAddress.pincode;
                    nomineeAddressVm.personalDetails.city = aoService.customerCorrespondenceAddress.city;
                    nomineeAddressVm.personalDetails.state = aoService.customerCorrespondenceAddress.state;
                } else {
                    nomineeAddressVm.personalDetails.addressLine1 = aoService.nullCheck(aoService.customerAadhaarCardDetails.addressLine1);
                    nomineeAddressVm.personalDetails.addressLine2 = aoService.nullCheck(aoService.customerAadhaarCardDetails.addressLine2);
                    nomineeAddressVm.personalDetails.address = aoService.nullCheck(aoService.customerAadhaarCardDetails.addressLine1) + aoService.nullCheck(aoService.customerAadhaarCardDetails.addressLine2);
                    nomineeAddressVm.personalDetails.pincode = aoService.customerAadhaarCardDetails.pc;
                    nomineeAddressVm.personalDetails.city = aoService.customerAadhaarCardDetails.dist;
                    nomineeAddressVm.personalDetails.state = aoService.customerAadhaarCardDetails.state;
                }
            } else if (aoService.isAadharManualEntry === true) {

                if (aoService.isCustManualCorresChkBox == true) {
                    nomineeAddressVm.personalDetails.addressLine1 = aoService.nullCheck(aoService.aadhaarManualCorrespondenceAddress.address1);
                    nomineeAddressVm.personalDetails.addressLine2 = aoService.nullCheck(aoService.aadhaarManualCorrespondenceAddress.address2);
                    nomineeAddressVm.personalDetails.address = aoService.nullCheck(aoService.aadhaarManualCorrespondenceAddress.address1) + aoService.nullCheck(aoService.aadhaarManualCorrespondenceAddress.address2);
                    nomineeAddressVm.personalDetails.pincode = aoService.aadhaarManualCorrespondenceAddress.pincode;
                    nomineeAddressVm.personalDetails.city = aoService.aadhaarManualCorrespondenceAddress.city;
                    nomineeAddressVm.personalDetails.state = aoService.aadhaarManualCorrespondenceAddress.state;
                } else {
                    var title = '';
                    var template = '{{"APPLICANT_ADDRESS_IF_EMPTY" | translate}}';
                    var onTap = 'menu.nomineeDetailsAddressOption';
                    var buttontext = 'OK';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                }
            }
            if (!utilityService.isUndefined(nomineeAddressVm.personalDetails.addressLine1)) {
                var index = nomineeAddressVm.personalDetails.addressLine1.lastIndexOf(",");
                nomineeAddressVm.personalDetails.addressLine1 = nomineeAddressVm.personalDetails.addressLine1.substring(0, index) + nomineeAddressVm.personalDetails.addressLine1.substring(index + 1);
            }
            if (!utilityService.isUndefined(nomineeAddressVm.personalDetails.addressLine2)) {
                var index = nomineeAddressVm.personalDetails.addressLine2.lastIndexOf(",");
                nomineeAddressVm.personalDetails.addressLine2 = nomineeAddressVm.personalDetails.addressLine2.substring(0, index) + nomineeAddressVm.personalDetails.addressLine2.substring(index + 1);
            }
            if (!utilityService.isUndefined(nomineeAddressVm.personalDetails.address)) {
                var index = nomineeAddressVm.personalDetails.address.lastIndexOf(",");
                nomineeAddressVm.personalDetails.address = nomineeAddressVm.personalDetails.address.substring(0, index) + nomineeAddressVm.personalDetails.address.substring(index + 1);
            }
        }

        nomineeAddressVm.guardianDetails = function(){
          if(aoService.isNomineeScanned === true){
                nomineeAddressVm.guardianConName = aoService.nomineeAadhaarCardDetails.guardianName;
                nomineeAddressVm.guardianConAge = aoService.nomineeAadhaarCardDetails.guardianAge;
            }
            else{
                nomineeAddressVm.guardianConName = aoService.nominee.guardianName;
                nomineeAddressVm.guardianConAge = aoService.nominee.guardianAge;
            }
      }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            nomineeAddressVm.displayGuardianAddress();
            if(nomineeAddressVm.isChecked == true){
                nomineeAddressVm.disableNext = false;
            }
            else{
                nomineeAddressVm.disableNext = true;
            }
	        
            nomineeAddressVm.guardianDetails();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);   
            
        });

        return this;
    }
]);
