'use strict';

angularApp.controller('nomineeCAddressController', ["$state",
    "$scope",
    "aoService",
    "nomineeDetailsRelatedService",
    "utilityService",
    "$translate",
    "$timeout",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        aoService,
        nomineeDetailsRelatedService,
        utilityService,
        $translate,
        $timeout,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var nomineeCAddressVm = this;

        function initPage() {
            nomineeCAddressVm.showBack = true;
            nomineeCAddressVm.showNext = true;
            nomineeCAddressVm.disableNext = true;
            nomineeCAddressVm.aofooter = true;
            nomineeCAddressVm.disableState = true;
            nomineeCAddressVm.disableCity = true;
            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                nomineeCAddressVm.okBtntext = translatedvalue;
            });
        }

        nomineeCAddressVm.goBacktoPrevious = function() {
            $state.go("menu.nomineeDetailsAddressOption");
        }

        /*$scope.$watch("nomineeCAddressVm.guardianNewAddrForm.$valid", function(value) {
            if (value === true) {
                nomineeCAddressVm.disableNext = false;
            } else {
                nomineeCAddressVm.disableNext = true;
            }
        });*/

         $scope.$watchGroup(['nomineeCAddressVm.guardianNewAddrForm.$valid','nomineeCAddressVm.guardian-appoint.$valid'], function(value,isValid) {
           
            if (value == true & isValid == true) {
                nomineeCAddressVm.disableNext = false;
            } else {
                nomineeCAddressVm.disableNext = true;
            }
        });

        nomineeCAddressVm.setGuardianDetails = function() {
            var guardianDetails = {};
            if (aoService.isNomineeScanned === true) {
                guardianDetails.nomineeName = aoService.nomineeAadhaarCardDetails.name;
                guardianDetails.guardianName = aoService.nomineeAadhaarCardDetails.guardianName;
            } else {
                guardianDetails.nomineeName = aoService.nominee.name;
                guardianDetails.guardianName = aoService.nominee.guardianName;
            }
            return guardianDetails;
        }

        nomineeCAddressVm.goToNextPage = function() {
            aoService.nomineeGuardianDetails.address1 = nomineeCAddressVm.addressAboveData;
            aoService.nomineeGuardianDetails.address2 = nomineeCAddressVm.addressBelowData;
            aoService.nomineeGuardianDetails.pincode = nomineeCAddressVm.pincodeData;
            aoService.nomineeGuardianDetails.city = nomineeCAddressVm.cityData;
            aoService.nomineeGuardianDetails.state = nomineeCAddressVm.stateData;
            aoService.nomineeGuardianDetails.locality = nomineeCAddressVm.localityData;
            aoService.nomineeGuardianDetails.guardianConsent = nomineeCAddressVm.isChecked;
            var guardianDetailParams = nomineeCAddressVm.setGuardianDetails();
            if(utilityService.isUndefined(guardianDetailParams.guardianName)){
              var title = '';
              var template = '{{"IF_GUARDIAN_NAME_EMPTY" | translate}}';
              var onTap = 'menu.nominationRelated';
              var buttontext = 'OK';
              utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            }
            else{
            //Service to update guardian details
            var params = {
                "id": aoService.customer.mobileNo,
                "data": {
                    "nominees": [{
                        "guardian": {
                            "address": {
                                "addressLine1": aoService.nomineeGuardianDetails.address1,
                                "addressLine2": aoService.nomineeGuardianDetails.address2,
                                "pincode": aoService.nomineeGuardianDetails.pincode,
                                "city": aoService.nomineeGuardianDetails.city,
                                "cityCode": aoService.nomineeGuardianDetails.cityCode,
                                "state": aoService.nomineeGuardianDetails.state,
                                "stateCode": aoService.nomineeGuardianDetails.stateCode,
                                "locality": aoService.nomineeGuardianDetails.locality
                            },
                            "name": guardianDetailParams.guardianName,
                            "guardianAddressFlag": aoService.nominee.guardianAddressFlag,
                            "guardianConsent" : aoService.nomineeGuardianDetails.guardianConsent
                        },
                        "name": guardianDetailParams.nomineeName
                    }],
                    "commonId": $state.$current.data.commonId
                }
            }

            
            nomineeDetailsRelatedService.updateGuardian(params).then(function(response) {
                $state.go("menu.selectBranchOption");
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
          }
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        nomineeCAddressVm.changefn = function(param) {
             if (param) {
                if(nomineeCAddressVm.isChecked){
                    nomineeCAddressVm.disableNext = false;
                } 
                else{
                    nomineeCAddressVm.disableNext = true;
                }               
            } else {
                nomineeCAddressVm.disableNext = true;
            }
        }

        nomineeCAddressVm.clickCheck = function(isValid){
            if (nomineeCAddressVm.isChecked) {
                if(isValid){
                    nomineeCAddressVm.disableNext = false;
                } 
                else{
                    nomineeCAddressVm.disableNext = true;
                }               
            } else {
                nomineeCAddressVm.disableNext = true;
            }
        }

        nomineeCAddressVm.updatedvalue = function(param) {
             if (param) {
                if(nomineeCAddressVm.isChecked){
                    nomineeCAddressVm.disableNext = false;
                } 
                else{
                    nomineeCAddressVm.disableNext = true;
                }               
            } else {
                nomineeCAddressVm.disableNext = true;
            }
            return nomineeCAddressVm.disableNext;
        }

        nomineeCAddressVm.updatearea = function(param) {
            //Service to return city and state based on the pincode entered
            var inputparams = {
                "pinCode": nomineeCAddressVm.pincodeData
            }
            if (!utilityService.isUndefined(nomineeCAddressVm.pincodeData) && nomineeCAddressVm.pincodeData.length == 6 && /^[0-9]{1,6}$/.test(nomineeCAddressVm.pincodeData) == true) {
                nomineeDetailsRelatedService.getAreaDetailForPincode(inputparams).then(function(data) {

                    if (utilityService.isUndefined(data)) {
                        var title = '';
                        var template = '{{"PINCODE_MATCH" | translate}}';
                        var onTap = '';
                        var buttontext = '<b>' + nomineeCAddressVm.okBtntext + '</b>';
                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                        nomineeCAddressVm.disableState = false;
                        nomineeCAddressVm.disableCity = false;
                        nomineeCAddressVm.stateList = "";
                    } else {
                        nomineeCAddressVm.stateList = data;	
                        aoService.customer.city = utilityService.getValue(data.cityName);
                        aoService.customer.state = utilityService.getValue(data.stateName);
                        aoService.nomineeGuardianDetails.cityCode = utilityService.getValue(data.cityCode);
                        aoService.nomineeGuardianDetails.stateCode = utilityService.getValue(data.stateCode);
                        nomineeCAddressVm.cityData = aoService.customer.city;
                        nomineeCAddressVm.stateData = aoService.customer.state;
                        nomineeCAddressVm.disableCity = true;
                        nomineeCAddressVm.disableState = true;
                    }

                }, function(error) {
                	nomineeCAddressVm.stateList = "";
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        }

        nomineeCAddressVm.pincodeChange = function() {
            if (nomineeCAddressVm.pincodeData === "" || (!utilityService.isUndefined(nomineeCAddressVm.pincodeData)).length != 6) {
                nomineeCAddressVm.cityData = "";
                nomineeCAddressVm.stateData = "";
            }
        }

        nomineeCAddressVm.checkUpdatedCityStateValid = function(param) {
            nomineeCAddressVm.updatedvalue(param);
        }

        nomineeCAddressVm.populateResumeData = function() {
            nomineeCAddressVm.addressAboveData = utilityService.getValue(aoService.nomineeGuardianDetails.address1);
            nomineeCAddressVm.addressBelowData = utilityService.getValue(aoService.nomineeGuardianDetails.address2);
            nomineeCAddressVm.pincodeData = utilityService.getValue(aoService.nomineeGuardianDetails.pincode);
            nomineeCAddressVm.cityData = utilityService.getValue(aoService.nomineeGuardianDetails.city);
            nomineeCAddressVm.stateData = utilityService.getValue(aoService.nomineeGuardianDetails.state);
            nomineeCAddressVm.localityData = utilityService.getValue(aoService.nomineeGuardianDetails.locality);
            nomineeCAddressVm.isChecked = aoService.nomineeGuardianDetails.guardianConsent;
            
        }

         nomineeCAddressVm.guardianDetails = function(){
          if(aoService.isNomineeScanned === true){
                nomineeCAddressVm.guardianConName = aoService.nomineeAadhaarCardDetails.guardianName;
                nomineeCAddressVm.guardianConAge = aoService.nomineeAadhaarCardDetails.guardianAge;
            }
            else{
                nomineeCAddressVm.guardianConName = aoService.nominee.guardianName;
                nomineeCAddressVm.guardianConAge = aoService.nominee.guardianAge;
            }
      }
      nomineeCAddressVm.setstate = function(data) {
		          if(data){
		            var arr = nomineeCAddressVm.stateList;
					var arrLength = arr.length;	
		            for (var i = 0; i < arrLength; i++) {
		                if (arr[i].stateCode == data) {
		                    var tempData = arr[i];
		                    aoService.customer.city = utilityService.getValue(tempData.cityName);
		                            aoService.customer.state = utilityService.getValue(tempData.stateName);
		                            aoService.nomineeGuardianDetails.cityCode = utilityService.getValue(tempData.cityCode);
		                            aoService.nomineeGuardianDetails.stateCode = utilityService.getValue(tempData.stateCode);
		                            nomineeCAddressVm.cityData = aoService.customer.city;
		                            nomineeCAddressVm.stateData = aoService.customer.state;
		                            nomineeCAddressVm.disableCity = true;
		                            nomineeCAddressVm.disableState = true;
		                }
		            };
		            nomineeCAddressVm.changefn(true);
		          }else{
		            nomineeCAddressVm.stateData = ""; 
		            aoService.nomineeGuardianDetails.state = "";
		          }
		        
		
		};
		nomineeCAddressVm.loadStateList = function(data) {
				 var inputparams = {
	                "pinCode": aoService.nomineeGuardianDetails.pincode
	           };
	           if(!nomineeCAddressVm.stateList){
				nomineeDetailsRelatedService.getAreaDetailForPincode(inputparams).then(function(data) {
	                    if (!utilityService.isUndefined(data)) {
	                        nomineeCAddressVm.stateList = data;
	                        nomineeCAddressVm.stateitemData = aoService.nomineeGuardianDetails.stateCode;
                        
	                    }
	                }, function(error) {
                    
	                });
	            }    
		};	  
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            nomineeCAddressVm.populateResumeData();
            nomineeCAddressVm.guardianDetails();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);  
            nomineeCAddressVm.loadStateList();
        });

        return this;
    }
]);
