'use strict';

angularApp.controller('nomineeDetailsAddressOptionController', ["$state",
    "$scope",
    "aoService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        aoService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var nomineeDetailsAddressOptionVm = this;

        function initPage() {
            nomineeDetailsAddressOptionVm.showBack = true;
            nomineeDetailsAddressOptionVm.showNext = false;
            nomineeDetailsAddressOptionVm.btnWhite = true;
            nomineeDetailsAddressOptionVm.aofooter = true;
            aoService.nomineeNav = "nomineeoption";

            nomineeDetailsAddressOptionVm.addressOptions = [{ "value": "AO_SAMEASNOM_BTN", "description": "nomineeAddress" },
                { "value": "AO_SAMEASAPP_BTN", "description": "applicantAddress" },
                { "value": "AO_NEWADDR_BTN", "description": "newAddress" }
            ];
        }

        nomineeDetailsAddressOptionVm.goBacktoPrevious = function() {
            $state.go('menu.nomineeDetailsNext');
        }

        nomineeDetailsAddressOptionVm.goToNextPage = function(param) {
            aoService.nominee.guardianAddressFlag = param.description;
            if (param.value === "AO_SAMEASNOM_BTN") {
                $state.go("menu.nomineeEnteredAddress");
            } else if (param.value === "AO_SAMEASAPP_BTN") {
                $state.go("menu.nomineeAddress");
            } else if (param.value === "AO_NEWADDR_BTN") {
                $state.go("menu.nomineeCAddress");
            }
        }

        nomineeDetailsAddressOptionVm.populateResumeData = function() {
            nomineeDetailsAddressOptionVm.activeStatus = aoService.getIdByValue(nomineeDetailsAddressOptionVm.addressOptions, aoService.nominee.guardianAddressFlag);
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            nomineeDetailsAddressOptionVm.populateResumeData();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
