'use strict';

angularApp.controller('nomineeDetailsController', ["$state",
    "$scope",
    "$cordovaBarcodeScanner",
    "aoService",
    "utilityService",
    "$translate",
    "$ionicPopover",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        $cordovaBarcodeScanner,
        aoService,
        utilityService,
        $translate,
        $ionicPopover,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var nomineeDetailsVm = this;
        var alphabets = /^([ \.]?[a-zA-Z]+)+$/;
        var numbers = /^[0-9]*$/;
        var addressRegex = /^[A-z().,-/0-9 #']*$/;

        function initPage() {
            nomineeDetailsVm.showBack = true;
            nomineeDetailsVm.showNext = false;
            nomineeDetailsVm.aofooter = true;
            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                nomineeDetailsVm.okBtntext = translatedvalue;
            });
        }

        nomineeDetailsVm.clearNomineeAadhaarDetails = function(){
             aoService.nomineeAadhaarCardDetails = {
                    uid: "",
                    name: "",
                    gender: "",
                    yob: "",
                    co: "",
                    house: "",
                    street: "",
                    lm: "",
                    loc: "",
                    vtc: "",
                    po: "",
                    dist: "",
                    subdist: "",
                    state: "",
                    pc: "",
                    dob: "",
                    relationship: "",
                    guardian: ""
                }
        }

        /* Info Popup */
        var template = '<ion-popover-view class="tooltiptext ao-popupInfo roboto-regular ao-aadhaarInfoHt">' + '<ion-content>' +
                        '<div class="" translate="SCAN_AADHAAR_QRCODE"></div>' + '</ion-content>' + '</ion-popover-view>';

        $scope.popover = $ionicPopover.fromTemplate(template, {
            scope: $scope
        });

        nomineeDetailsVm.infoPopup = function($event) {
            $scope.popover.show($event);
        };

        nomineeDetailsVm.closePopover = function() {
            $scope.popover.hide();
        };
       /* Info Popup */

        //QR code scanner code
        nomineeDetailsVm.goToQRCodeDetails = function() {
            $cordovaBarcodeScanner.scan().then(function(barcodeData) {
                if(!utilityService.isUndefined(barcodeData.text)){
                var xmlText = barcodeData.text;
                var formattedXml = xmlText.replace("/?xml","?xml");
                formattedXml = formattedXml.replace("xml?","?xml");
                var x2js = new X2JS();
                var jsonObj = x2js.xml_str2json(formattedXml);
                if(utilityService.isUndefined(jsonObj)){
                    var title = '';
                    var template = "{{'AADHAAR_POPUP'| translate}}";
                    var onTap = '';
                    var buttontext = "<b>" +nomineeDetailsVm.okBtntext+ "</b>";
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext); 
                }
                else{                    
                var jsonStr = JSON.stringify(jsonObj);
                nomineeDetailsVm.clearNomineeAadhaarDetails();
                aoService.nominee = {
                    uid:'',
                    name: '',
                    firstName:'',
                    middleName:'',
                    lastName:'',
                    relationship: '',
                    guardianName:'',
                    age: '',
                    address1: '',
                    address2: '',
                    pincode: '',
                    dob: '',
                    city: '',
                    state: ''
                }
                var securedScannedData = {
                    _co:aoService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._uid),
                    _dist:aoService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._dist),
                    _dob:aoService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._dob),
                    _gender:aoService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._gender),
                    _house:aoService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._house),
                    _name:aoService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._name),
                    _pc:aoService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._pc),
                    _po:aoService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._po),
                    _state:aoService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._state),
                    _street:aoService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._street),
                    _subdist:aoService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._subdist),
                    _uid:aoService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._uid),
                    _vtc:aoService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._vtc),
                    _yob:aoService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._yob),
                    _loc:aoService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._loc),
                    _lm:aoService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._lm)
                }
				
				
				securedScannedData._dob =  aoService.setDateFormatDDMMYYY(securedScannedData._dob);
                    if(aoService.checkSecuredData(numbers, securedScannedData._uid) === (aoService.customerAadhaarCardDetails.uid || aoService.customerManualEntryDetails.aadharNumber)){
                        var title = '';
                        var template = "{{'AADHAAR_BOTH_SAME'| translate}}";
                        var onTap = '';
                        var buttontext = "<b>" +nomineeDetailsVm.okBtntext+ "</b>";
                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext); 
                    }
                    else{
                        setTimeout(function() { 
                            aoService.nomineeAadhaarCardDetails.uid = aoService.checkSecuredData(numbers, securedScannedData._uid);
                            aoService.nomineeAadhaarCardDetails.name = aoService.checkSecuredData(alphabets, securedScannedData._name);
                            aoService.nomineeAadhaarCardDetails.gender = aoService.checkSecuredData(alphabets, securedScannedData._gender);
                            aoService.nomineeAadhaarCardDetails.yob = aoService.checkSecuredData(numbers, securedScannedData._yob);
                            aoService.nomineeAadhaarCardDetails.house = aoService.checkSecuredData(addressRegex, securedScannedData._house);
                            aoService.nomineeAadhaarCardDetails.street = aoService.checkSecuredData(addressRegex, securedScannedData._street);
                            aoService.nomineeAadhaarCardDetails.lm = aoService.checkSecuredData(addressRegex, securedScannedData._lm);
                            aoService.nomineeAadhaarCardDetails.loc = aoService.checkSecuredData(addressRegex, securedScannedData._loc);
                            aoService.nomineeAadhaarCardDetails.vtc = aoService.checkSecuredData(addressRegex, securedScannedData._vtc);
                            aoService.nomineeAadhaarCardDetails.po = aoService.checkSecuredData(addressRegex, securedScannedData._po);
                            aoService.nomineeAadhaarCardDetails.dist = aoService.checkSecuredData(addressRegex, securedScannedData._dist);
                            aoService.nomineeAadhaarCardDetails.subdist = aoService.checkSecuredData(addressRegex, securedScannedData._subdist);
                            aoService.nomineeAadhaarCardDetails.state = aoService.checkSecuredData(addressRegex, securedScannedData._state);
                            aoService.nomineeAadhaarCardDetails.pc = aoService.checkSecuredData(numbers, securedScannedData._pc);
                            aoService.nomineeAadhaarCardDetails.dob = securedScannedData._dob;
                            aoService.isNomineeScanned = true;
                            $state.go('menu.nominationRelated'); 
                        }, 500);
                    }
            }
            }
            }, 
			function(error) {
                utilityService.showErrorMessage(error);
            });
        }

        nomineeDetailsVm.goBacktoPrevious = function() {
            $state.go("menu.aDReligion");
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }
        
        nomineeDetailsVm.getNominationRelated = function() {
            aoService.isNomineeScanned = false;
            nomineeDetailsVm.clearNomineeAadhaarDetails();
            $state.go('menu.nominationRelated');
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
