'use strict';

angularApp.controller('nomineeDetailsRelatedController', ["$state",
    "$scope",
    "utilityService",
    "nomineeDetailsRelatedService",
    "aoService",
    "$translate",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        utilityService,
        nomineeDetailsRelatedService,
        aoService,
        $translate,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var nomineeDetailsRelatedVm = this;

        function initPage() {
            nomineeDetailsRelatedVm.showBack = true;
            nomineeDetailsRelatedVm.showNext = true;
            nomineeDetailsRelatedVm.nomineeAge;
            nomineeDetailsRelatedVm.dob;
            nomineeDetailsRelatedVm.nomineeGuardianName = "";
            nomineeDetailsRelatedVm.guardianAge = "";
            nomineeDetailsRelatedVm.aofooter = true;
            nomineeDetailsRelatedVm.invalid = false;
            nomineeDetailsRelatedVm.properDate = false;
            aoService.nomineeNav = "nomineedetails";
            nomineeDetailsRelatedVm.validCityState = false;
            nomineeDetailsRelatedVm.isAddress1Modified = false;
            nomineeDetailsRelatedVm.isAddress2Modified = false;
            nomineeDetailsRelatedVm.isCityModified = false;
            nomineeDetailsRelatedVm.isStateModified = false;
            nomineeDetailsRelatedVm.isPincodeModified = false;
            nomineeDetailsRelatedVm.disableAddress1 = false;
            nomineeDetailsRelatedVm.disableAddress2 = false;
            nomineeDetailsRelatedVm.disableCity = true;
            nomineeDetailsRelatedVm.disablePincode = false;
            nomineeDetailsRelatedVm.disableState = true;
            nomineeDetailsRelatedVm.nomineeStateShow=true;
            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                nomineeDetailsRelatedVm.okBtntext = translatedvalue;
            });
        }

        nomineeDetailsRelatedVm.goBacktoPrevious = function() {
            if (aoService.isNomineeScanned == true) {
                aoService.nomineeAadhaarCardDetails.address1 = nomineeDetailsRelatedVm.addressAboveData;
                aoService.nomineeAadhaarCardDetails.address2 = nomineeDetailsRelatedVm.addressBelowData;
                aoService.nomineeAadhaarCardDetails.pc = nomineeDetailsRelatedVm.pincodeData;
                aoService.nomineeAadhaarCardDetails.dist = nomineeDetailsRelatedVm.cityData;
                aoService.nomineeAadhaarCardDetails.state = nomineeDetailsRelatedVm.stateData;
                aoService.nomineeAadhaarCardDetails.sameAsApplicantAddress = nomineeDetailsRelatedVm.applicantChecked;
            } else {
                aoService.nominee.address1 = nomineeDetailsRelatedVm.addressAboveData;
                aoService.nominee.address2 = nomineeDetailsRelatedVm.addressBelowData;
                aoService.nominee.pincode = nomineeDetailsRelatedVm.pincodeData;
                aoService.nominee.city = nomineeDetailsRelatedVm.cityData;
                aoService.nominee.state = nomineeDetailsRelatedVm.stateData;
                aoService.nominee.sameAsApplicantAddress = nomineeDetailsRelatedVm.applicantChecked;
            }

            $state.go('menu.nominationRelated');
        }

        nomineeDetailsRelatedVm.setRequestParams = function() {
            var params = {};
            if (nomineeDetailsRelatedVm.isNomineeScanned === true) {
                params = {
                    "id": aoService.customer.mobileNo,
                    "data": {
                        "nominees": [{

                            "uid": aoService.nomineeAadhaarCardDetails.uid,
                            "name": aoService.nomineeAadhaarCardDetails.name,
                            "relationship": aoService.nomineeAadhaarCardDetails.relationship,
                            "age": nomineeDetailsRelatedVm.calculateAge(),
                            "guardianName": aoService.nomineeAadhaarCardDetails.guardianName,
                            "guardianAge": aoService.nomineeAadhaarCardDetails.guardianAge,
                            "dob": aoService.nomineeAadhaarCardDetails.dob,
                            "isNomineeAadhaarScanned": nomineeDetailsRelatedVm.isNomineeScanned,
                            "sameAsApplicantAddress": nomineeDetailsRelatedVm.applicantChecked,
                            "type": "",
                            "address": {
                                "addressLine1": aoService.nomineeAadhaarCardDetails.address1,
                                "addressLine2": aoService.nomineeAadhaarCardDetails.address2,
                                "pincode": aoService.nomineeAadhaarCardDetails.pc,
                                "city": aoService.nomineeAadhaarCardDetails.dist,
                                "state": aoService.nomineeAadhaarCardDetails.state
                            },
                            "guardian": {
                                "name": aoService.nomineeAadhaarCardDetails.guardianName,
                                "guardianAge": aoService.nomineeAadhaarCardDetails.guardianAge
                            }

                        }],
                        "commonId": $state.$current.data.commonId
                    }
                }
            } else {
                params = {
                    "id": aoService.customer.mobileNo,
                    "data": {
                        "nominees": [{

                            "uid": aoService.nominee.uid,
                            "name": aoService.nominee.name,
                            "relationship": aoService.nominee.relationship,
                            "age": nomineeDetailsRelatedVm.calculateAge(),
                            "guardianName": aoService.nominee.guardianName,
                            "dob": aoService.nominee.dob,
                            "isNomineeAadhaarScanned": nomineeDetailsRelatedVm.isNomineeScanned,
                            "sameAsApplicantAddress": nomineeDetailsRelatedVm.applicantChecked,
                            "address": {
                                "addressLine1": aoService.nominee.address1,
                                "addressLine2": aoService.nominee.address2,
                                "pincode": aoService.nominee.pincode,
                                "city": aoService.nominee.city,
                                "cityCode": aoService.nominee.cityCode,
                                "state": aoService.nominee.state,
                                "stateCode": aoService.nominee.stateCode
                            },
                            "guardian": {
                                "name": aoService.nominee.guardianName,
                                "guardianAge": aoService.nominee.guardianAge
                            }

                        }],
                        "commonId": $state.$current.data.commonId
                    }
                }
            }

            return params;
        }
        nomineeDetailsRelatedVm.goToNextPage = function() {
            var addressLength;
            if (aoService.isNomineeScanned == true) {
                aoService.nomineeAadhaarCardDetails.address1 = nomineeDetailsRelatedVm.addressAboveData;
                aoService.nomineeAadhaarCardDetails.address2 = nomineeDetailsRelatedVm.addressBelowData;
                aoService.nomineeAadhaarCardDetails.pc = nomineeDetailsRelatedVm.pincodeData;
                aoService.nomineeAadhaarCardDetails.dist = nomineeDetailsRelatedVm.cityData;
                aoService.nomineeAadhaarCardDetails.state = nomineeDetailsRelatedVm.stateData;
                aoService.nomineeAadhaarCardDetails.sameAsApplicantAddress = nomineeDetailsRelatedVm.applicantChecked;
                addressLength = aoService.nomineeAadhaarCardDetails.address1.length + aoService.nomineeAadhaarCardDetails.address2.length;
            } else if (aoService.isNomineeScanned == false) {
                aoService.nominee.address1 = nomineeDetailsRelatedVm.addressAboveData;
                aoService.nominee.address2 = nomineeDetailsRelatedVm.addressBelowData;
                aoService.nominee.pincode = nomineeDetailsRelatedVm.pincodeData;
                aoService.nominee.city = nomineeDetailsRelatedVm.cityData;
                aoService.nominee.state = nomineeDetailsRelatedVm.stateData;
                aoService.nominee.sameAsApplicantAddress = nomineeDetailsRelatedVm.applicantChecked;
                addressLength = aoService.nominee.address1.length + aoService.nominee.address2.length;
            }

            /* If nominee address length is greater than 40 */
            if (addressLength > 40) {
                var title = '';
                var template = '{{"MAX_CHAR" | translate}}';
                var onTap = '';
                var buttontext = '<b>' + nomineeDetailsRelatedVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            } else {
                //Service to update nominee details
                var requestParams = nomineeDetailsRelatedVm.setRequestParams();
                nomineeDetailsRelatedService.createNominee(requestParams).then(function(response) {
                    if (!utilityService.isUndefined(nomineeDetailsRelatedVm.nomineeGuardianName) || nomineeDetailsRelatedVm.nomineeAge < constantConfig.acOp.nomineeAge) {
                        $state.go("menu.nomineeDetailsAddressOption");
                    } else {
                        $state.go("menu.selectBranchOption");
                    }

                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        nomineeDetailsRelatedVm.goBack = function() {
            nomineeDetailsRelatedVm.nomineeName = "";
            nomineeDetailsRelatedVm.nomineeDetailsFirstForm.$setPristine();
            nomineeDetailsRelatedVm.nomineeRelationship = "";
            nomineeDetailsRelatedVm.nomineeAge = null;
            nomineeDetailsRelatedVm.dob = "";
            nomineeDetailsRelatedVm.nomineeGuardianName = "";
            nomineeDetailsRelatedVm.guardianAge = "";
            nomineeDetailsRelatedVm.addressAboveData = "";
            nomineeDetailsRelatedVm.addressBelowData = "";
            nomineeDetailsRelatedVm.pincodeData = null;
            nomineeDetailsRelatedVm.cityData = "";
            nomineeDetailsRelatedVm.stateData = "";
            nomineeDetailsRelatedVm.nomineeDobDay = null;
            nomineeDetailsRelatedVm.nomineeDobMonth = null;
            nomineeDetailsRelatedVm.nomineeDobYear = null;
            aoService.isNomineeAddress1Changed = false;
            aoService.isNomineeAddress2Changed = false;
            $state.go('menu.nomineeDetails');
        }

        nomineeDetailsRelatedVm.goNext = function() {
                if (aoService.isNomineeScanned == true) {
                    aoService.nomineeAadhaarCardDetails.name = nomineeDetailsRelatedVm.nomineeName;

                    aoService.nomineeAadhaarCardDetails.relationship = nomineeDetailsRelatedVm.nomineeRelationship;
                    aoService.nomineeAadhaarCardDetails.age = nomineeDetailsRelatedVm.nomineeAge;
                    aoService.nomineeAadhaarCardDetails.dob = nomineeDetailsRelatedVm.nomineeDobDay + '-' + nomineeDetailsRelatedVm.nomineeDobMonth + '-' + nomineeDetailsRelatedVm.nomineeDobYear;
                    aoService.nomineeAadhaarCardDetails.guardianName = nomineeDetailsRelatedVm.nomineeGuardianName;
                    aoService.nomineeAadhaarCardDetails.guardianAge = nomineeDetailsRelatedVm.guardianAge;
                } else if (aoService.isNomineeScanned == false) {
                    aoService.nominee.name = nomineeDetailsRelatedVm.nomineeName;
                    aoService.nominee.relationship = nomineeDetailsRelatedVm.nomineeRelationship;
                    aoService.nominee.age = nomineeDetailsRelatedVm.nomineeAge;
                    aoService.nominee.dob = nomineeDetailsRelatedVm.dob;
                    aoService.nominee.guardianName = nomineeDetailsRelatedVm.nomineeGuardianName;
                    aoService.nominee.guardianAge = nomineeDetailsRelatedVm.guardianAge;
                }
                $state.go('menu.nomineeDetailsNext');
            };
            //On page load - Split the aadhaar card holder's name and display accordingly
        nomineeDetailsRelatedVm.displayNames = function(value) {
            var fullName = value;
            var splittedName = value.split(" ");
            var splitLen = value.split(" ").length;
            var i;
            var middleName = [];

            if (splitLen === 2) {
                nomineeDetailsRelatedVm.firstName = splittedName[0];
                nomineeDetailsRelatedVm.lastName = splittedName[1];
                nomineeDetailsRelatedVm.isMName = false;
            } else {
                nomineeDetailsRelatedVm.isMName = true;
                nomineeDetailsRelatedVm.firstName = splittedName[0];
                for (i = 1; i < splitLen - 1; i++) {
                    middleName[i] = splittedName[i];
                }
                nomineeDetailsRelatedVm.middleName = middleName.join(' ');
                nomineeDetailsRelatedVm.lastName = splittedName[splitLen - 1];
            }
        };

        /* Display Nominee details after scan or manual entry */
        nomineeDetailsRelatedVm.displayNomineeAdharDetails = function() {
            if (aoService.isNomineeScanned == true) {
                nomineeDetailsRelatedVm.nomineeName = aoService.nomineeAadhaarCardDetails.name;
                nomineeDetailsRelatedVm.nomineeGuardianName = aoService.nomineeAadhaarCardDetails.guardianName;
                nomineeDetailsRelatedVm.guardianAge = aoService.nomineeAadhaarCardDetails.guardianAge;
                nomineeDetailsRelatedVm.nomineeRelationship = aoService.nomineeAadhaarCardDetails.relationship;
                nomineeDetailsRelatedVm.dob = aoService.nomineeAadhaarCardDetails.dob;
                nomineeDetailsRelatedVm.addressAboveData = nomineeDetailsRelatedVm.concatAadharAddress1();
                nomineeDetailsRelatedVm.addressBelowData = nomineeDetailsRelatedVm.concatAadharAddress2();
                nomineeDetailsRelatedVm.applicantChecked = aoService.nomineeAadhaarCardDetails.sameAsApplicantAddress;
                if(!utilityService.isUndefined(aoService.nomineeAadhaarCardDetails.pc))
                nomineeDetailsRelatedVm.pincodeData = parseInt(aoService.nomineeAadhaarCardDetails.pc);
                nomineeDetailsRelatedVm.cityData = aoService.nomineeAadhaarCardDetails.dist;
                nomineeDetailsRelatedVm.stateData = aoService.nomineeAadhaarCardDetails.state;
            } else {
                nomineeDetailsRelatedVm.nomineeName = aoService.nominee.name;
                nomineeDetailsRelatedVm.nomineeGuardianName = aoService.nominee.guardianName;
                nomineeDetailsRelatedVm.guardianAge = aoService.nominee.guardianAge;
                nomineeDetailsRelatedVm.nomineeRelationship = aoService.nominee.relationship;
                nomineeDetailsRelatedVm.dob = aoService.nominee.dob;
                nomineeDetailsRelatedVm.addressAboveData = aoService.nominee.address1;
                nomineeDetailsRelatedVm.addressBelowData = aoService.nominee.address2;
                nomineeDetailsRelatedVm.applicantChecked = aoService.nominee.sameAsApplicantAddress;
                if(!utilityService.isUndefined(aoService.nominee.pincode))
                nomineeDetailsRelatedVm.pincodeData = parseInt(aoService.nominee.pincode);
                nomineeDetailsRelatedVm.cityData = aoService.nominee.city;
                nomineeDetailsRelatedVm.stateData = aoService.nominee.state;
            }

        }

        /* Method to calculate age */
        nomineeDetailsRelatedVm.calculateAge = function() {
            var todayDateAge = new Date();
            var bornNewDate = new Date(nomineeDetailsRelatedVm.nomineeDobYear, nomineeDetailsRelatedVm.nomineeDobMonth - 1, nomineeDetailsRelatedVm.nomineeDobDay);
            var age = Math.floor((todayDateAge.getTime() - bornNewDate.getTime()) / (365.25 * 24 * 60 * 60 * 1000));
            return age;
        }

        /* Populate Date of birth from aadhaar / resume journey  -
        If (From aadhaar, dob format is different and therefore formatting it)
        Else(From aadhaar, yob alone received, then keep date and month fields empty to make the user to enter)
        */
        nomineeDetailsRelatedVm.populateDobAadhaar = function(dateValue) {
            if (utilityService.isUndefined(nomineeDetailsRelatedVm.nomineeDobYear) || utilityService.isUndefined(nomineeDetailsRelatedVm.nomineeDobMonth) || utilityService.isUndefined(nomineeDetailsRelatedVm.nomineeDobDay)) {
                if (!utilityService.isUndefined(dateValue)) {
                    dateValue = moment(dateValue, ["DD/MM/YYYY", "MM/DD/YYYY", "DD-MM-YYYY", "MM-DD-YYYY", "YYYY-MM-DD", "YYYY-DD-MM","YYYY/MM/DD", "YYYY/DD/MM"]);
                    var dateFormat = new Date(dateValue);
                    var day = dateFormat.getDate();
                    var month = dateFormat.getMonth() + 1;
                    var year = dateFormat.getFullYear();
                    var formattedDate = day.toString();
                    if (formattedDate.length == 1) {
                        formattedDate = "0" + formattedDate;
                        nomineeDetailsRelatedVm.nomineeDobDay = formattedDate;
                    } else {
                        nomineeDetailsRelatedVm.nomineeDobDay = parseInt(day);
                    }
                    var formattedMonth = month.toString();
                    if (formattedMonth.length == 1) {
                        formattedMonth = "0" + formattedMonth;
                        nomineeDetailsRelatedVm.nomineeDobMonth = formattedMonth;
                    } else {
                        nomineeDetailsRelatedVm.nomineeDobMonth = parseInt(month);
                    }
                    nomineeDetailsRelatedVm.nomineeDobYear = parseInt(year);
                    var fullDate = nomineeDetailsRelatedVm.nomineeDobMonth + '-' + nomineeDetailsRelatedVm.nomineeDobDay + '-' + nomineeDetailsRelatedVm.nomineeDobYear;

                    var formattedNewDate = new Date();
                    formattedNewDate.setFullYear(nomineeDetailsRelatedVm.nomineeDobYear, nomineeDetailsRelatedVm.nomineeDobMonth - 1, nomineeDetailsRelatedVm.nomineeDobDay);

                    var todayDate = new Date();
                    var currentYear = todayDate.getFullYear();
                    var validYear = todayDate.setFullYear(currentYear - constantConfig.acOp.nomineeAge);
                    nomineeDetailsRelatedVm.nomineeAge = nomineeDetailsRelatedVm.calculateAge();


                } else if (!utilityService.isUndefined(aoService.nomineeAadhaarCardDetails.yob) && utilityService.isUndefined(aoService.nomineeAadhaarCardDetails.dob)) {
                    nomineeDetailsRelatedVm.nomineeDobDay = "";
                    nomineeDetailsRelatedVm.nomineeDobMonth = "";
                    nomineeDetailsRelatedVm.nomineeDobYear = parseInt(aoService.nomineeAadhaarCardDetails.yob);
                }
            }
        }

        /* From aadhaar, address comes splitted and therefore clubbing the fields which are required for address line 1 */
        nomineeDetailsRelatedVm.concatAadharAddress1 = function() {
            var fullAddr = "";
            if (utilityService.isUndefined(aoService.nomineeAadhaarCardDetails.address1)) {
                fullAddr = aoService.nullCheck(aoService.nomineeAadhaarCardDetails.house) + aoService.nullCheck(aoService.nomineeAadhaarCardDetails.street);
                var index = fullAddr.lastIndexOf(",");
                fullAddr = fullAddr.substring(0, index) + fullAddr.substring(index + 1);
            } else {
                fullAddr = aoService.nomineeAadhaarCardDetails.address1;
            }
            return fullAddr;
        }

        /* From aadhaar, address comes splitted and therefore clubbing the fields which are required for address line 2 */
        nomineeDetailsRelatedVm.concatAadharAddress2 = function() {
            var fullAddr = "";
            if (utilityService.isUndefined(aoService.nomineeAadhaarCardDetails.address2)) {
                fullAddr = aoService.nullCheck(aoService.nomineeAadhaarCardDetails.loc) + aoService.nullCheck(aoService.nomineeAadhaarCardDetails.vtc) + aoService.nullCheck(aoService.nomineeAadhaarCardDetails.po) + aoService.nullCheck(aoService.nomineeAadhaarCardDetails.subdist);
                var index = fullAddr.lastIndexOf(",");
                fullAddr = fullAddr.substring(0, index) + fullAddr.substring(index + 1);
            } else {
                fullAddr = aoService.nomineeAadhaarCardDetails.address2;
            }
            return fullAddr;
        }

        nomineeDetailsRelatedVm.validateInputs = function(isValid) {
            if (nomineeDetailsRelatedVm.validDate === true && isValid === true) {
                nomineeDetailsRelatedVm.disableNext = !isValid;
            } else if (nomineeDetailsRelatedVm.validDate === true && isValid === false) {
                nomineeDetailsRelatedVm.disableNext = true;
            } else if (nomineeDetailsRelatedVm.validDate === false && isValid === false) {
                nomineeDetailsRelatedVm.disableNext = true;
            }
            return nomineeDetailsRelatedVm.disableNext;
        }

        /* Date Validation */
        nomineeDetailsRelatedVm.dateValidation = function(isValid) {
            var fullDate = nomineeDetailsRelatedVm.nomineeDobMonth + '-' + nomineeDetailsRelatedVm.nomineeDobDay + '-' + nomineeDetailsRelatedVm.nomineeDobYear;
            var dobMonth = nomineeDetailsRelatedVm.nomineeDobMonth;
            var dobDay = nomineeDetailsRelatedVm.nomineeDobDay;
            var dobYr = nomineeDetailsRelatedVm.nomineeDobYear;
            var fullDateInMilliSeconds = Date.parse(fullDate);
            var formattedDate = new Date();
            var formattedDateYr = formattedDate.getFullYear();
            var currDate = new Date();
            var curYear = currDate.getFullYear();
            var curDateInMilliSeconds = new Date().getTime();
            formattedDate.setFullYear(dobYr, dobMonth - 1, dobDay);
            var months30 = ["04", "06", "09", "11", "4", "6", "9"];
            var monthIndex = months30.indexOf(dobMonth);

            if (fullDateInMilliSeconds > curDateInMilliSeconds) {
                nomineeDetailsRelatedVm.disableNext = true;
                nomineeDetailsRelatedVm.invalid = true;
                nomineeDetailsRelatedVm.properDate = false;
            } else if (dobYr % 4 == 0 && (dobYr % 100 != 0 || dobYr % 400 == 0)) {
                if (dobMonth == 2 && dobDay > 29) {
                    nomineeDetailsRelatedVm.disableNext = true;
                    nomineeDetailsRelatedVm.invalid = true;
                    nomineeDetailsRelatedVm.properDate = false;
                } else if (monthIndex != -1 && dobDay == 31) {
                    nomineeDetailsRelatedVm.disableNext = true;
                    nomineeDetailsRelatedVm.invalid = true;
                    nomineeDetailsRelatedVm.properDate = false;
                } else {
                    nomineeDetailsRelatedVm.disableNext = !isValid;
                    nomineeDetailsRelatedVm.invalid = false;
                    nomineeDetailsRelatedVm.properDate = true;
                }

            } else if (dobMonth == 2 && dobDay >= 29) {
                nomineeDetailsRelatedVm.disableNext = true;
                nomineeDetailsRelatedVm.invalid = true;
                nomineeDetailsRelatedVm.properDate = false;
            } else if (monthIndex != -1 && dobDay == 31) {
                nomineeDetailsRelatedVm.disableNext = true;
                nomineeDetailsRelatedVm.invalid = true;
                nomineeDetailsRelatedVm.properDate = false;

            } else {
                nomineeDetailsRelatedVm.disableNext = !isValid;
                nomineeDetailsRelatedVm.invalid = false;
                nomineeDetailsRelatedVm.properDate = true;

            }
             if(dobDay  < 10  && dobDay.length == 1 ){
            	nomineeDetailsRelatedVm.disableNext = true;
                nomineeDetailsRelatedVm.invalid = true;
                nomineeDetailsRelatedVm.properDate = false;
            }
            if(dobMonth  < 10 && dobMonth.length == 1 ){
            	nomineeDetailsRelatedVm.disableNext = true;
                nomineeDetailsRelatedVm.invalid = true;
                nomineeDetailsRelatedVm.properDate = false;
            }
            return nomineeDetailsRelatedVm.properDate; 
        }

        /* Date Validation */
        nomineeDetailsRelatedVm.checkValidDate = function(isValid) {

            nomineeDetailsRelatedVm.validDateFormat = nomineeDetailsRelatedVm.dateValidation();

            if (nomineeDetailsRelatedVm.validDateFormat == true) {
                var fullDate = nomineeDetailsRelatedVm.nomineeDobMonth + '/' + nomineeDetailsRelatedVm.nomineeDobDay + '/' + nomineeDetailsRelatedVm.nomineeDobYear;
                var dateDMY = nomineeDetailsRelatedVm.nomineeDobDay + '-' + nomineeDetailsRelatedVm.nomineeDobMonth + '-' + nomineeDetailsRelatedVm.nomineeDobYear;
                var formattedDate = new Date();
                formattedDate.setFullYear(nomineeDetailsRelatedVm.nomineeDobYear, nomineeDetailsRelatedVm.nomineeDobMonth - 1, nomineeDetailsRelatedVm.nomineeDobDay);
                var todayDate = new Date();
                var currentYear = todayDate.getFullYear();
                var validYear = todayDate.setFullYear(currentYear - constantConfig.acOp.nomineeAge);
                nomineeDetailsRelatedVm.nomineeAge = nomineeDetailsRelatedVm.calculateAge();

                nomineeDetailsRelatedVm.dob = dateDMY;
                if (isNaN(nomineeDetailsRelatedVm.nomineeAge) === false && nomineeDetailsRelatedVm.nomineeAge >= constantConfig.acOp.nomineeAge || nomineeDetailsRelatedVm.nomineeAge < constantConfig.acOp.nomineeAge) {
                    nomineeDetailsRelatedVm.validDate = true;
                } else if (isNaN(nomineeDetailsRelatedVm.nomineeAge) === true) {
                    nomineeDetailsRelatedVm.validDate = false;
                }
                if (nomineeDetailsRelatedVm.validDate === true && isValid === true) {
                    nomineeDetailsRelatedVm.disableNext = false;
                } else if (nomineeDetailsRelatedVm.validDate === false && isValid === false) {
                    nomineeDetailsRelatedVm.disableNext = true;
                } else if (nomineeDetailsRelatedVm.validDate === true && isValid === false) {
                    nomineeDetailsRelatedVm.disableNext = true;
                }

            } else if (nomineeDetailsRelatedVm.validDateFormat === false) {
                nomineeDetailsRelatedVm.disableNext = true;
            }
            return nomineeDetailsRelatedVm.disableNext;
        }

        nomineeDetailsRelatedVm.checkGuardian = function() {
            var required = false;

            if (isNaN(nomineeDetailsRelatedVm.nomineeAge) === false && !utilityService.isUndefined(nomineeDetailsRelatedVm.nomineeAge)) {
                if (nomineeDetailsRelatedVm.nomineeAge >= constantConfig.acOp.nomineeAge) {
                    required = false;
                } else {
                    required = true;
                }
            }
            return required;
        }

        nomineeDetailsRelatedVm.disableGuardian = function() {
            var disable = true;
            if (isNaN(nomineeDetailsRelatedVm.nomineeAge) === false && !utilityService.isUndefined(nomineeDetailsRelatedVm.nomineeAge)) {
                if (nomineeDetailsRelatedVm.nomineeAge >= constantConfig.acOp.nomineeAge) {
                    disable = true;
                    nomineeDetailsRelatedVm.nomineeGuardianName = "";
                    nomineeDetailsRelatedVm.guardianAge = "";
                } else {
                    disable = false;
                }
            }
            return disable;
        }

        $scope.ageAbove18Pattern = (function() {
            var regexp = /^(1[89]|[2-9][0-9])$/;
            return {
                test: function(value) {
                    if (nomineeDetailsRelatedVm.checkGuardian() === false) {
                        return true;
                    }
                    return regexp.test(value);
                }
            };
        })();

        $scope.namePattern = (function() {
            var regexp = /^([ \.]?[a-zA-Z]+)+$/;
            return {
                test: function(value) {
                    if (nomineeDetailsRelatedVm.checkGuardian() === false) {
                        return true;
                    }
                    return regexp.test(value);
                }
            };
        })();

        nomineeDetailsRelatedVm.concatCustomerAddressline1 = function() {
            var fullAddr = "";
            if (aoService.isResumeJourney === false) {
                fullAddr = aoService.nullCheck(aoService.customerAadhaarCardDetails.house) + aoService.nullCheck(aoService.customerAadhaarCardDetails.street);
                var index = fullAddr.lastIndexOf(",");
                fullAddr = fullAddr.substring(0, index) + fullAddr.substring(index + 1);
            } else {
                fullAddr = aoService.customerAadhaarCardDetails.addressLine1;
            }
            return fullAddr;
        }

        nomineeDetailsRelatedVm.concatCustomerAddressline2 = function() {
            var fullAddr = "";
            if (aoService.isResumeJourney === false) {
                fullAddr = aoService.nullCheck(aoService.customerAadhaarCardDetails.loc) + aoService.nullCheck(aoService.customerAadhaarCardDetails.vtc) + aoService.nullCheck(aoService.customerAadhaarCardDetails.po) + aoService.nullCheck(aoService.customerAadhaarCardDetails.subdist);
                var index = fullAddr.lastIndexOf(",");
                fullAddr = fullAddr.substring(0, index) + fullAddr.substring(index + 1);
            } else {
                fullAddr = aoService.customerAadhaarCardDetails.addressLine2;
            }

            return fullAddr;
        }

        nomineeDetailsRelatedVm.validateNomineeAddrInputs = function(isValid) {
            nomineeDetailsRelatedVm.disableNomineeAddrNext = !isValid;
        }

        /* Based on Pincode, auto-populate city and state fields*/
        nomineeDetailsRelatedVm.updateCityState = function(isValid) {
            nomineeDetailsRelatedVm.npincode = nomineeDetailsRelatedVm.pincodeData;
            if (!utilityService.isUndefined(nomineeDetailsRelatedVm.npincode)) {
                nomineeDetailsRelatedVm.isPincodeModified = true;
            }
            if (nomineeDetailsRelatedVm.nomineeAddressForm.pincode.$valid === true) {
                var inputparams = {
                    "pinCode": nomineeDetailsRelatedVm.pincodeData
                }
                nomineeDetailsRelatedService.getAreaDetailForPincode(inputparams).then(function(data) {
                    //Success - Data
                    if (utilityService.isUndefined(data)) {
                        var title = '';
                        var template = '{{"PINCODE_MATCH" | translate}}';
                        var onTap = '';
                        var buttontext = '<b>' + nomineeDetailsRelatedVm.okBtntext + '</b>';
                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                        nomineeDetailsRelatedVm.disableState = false;
                        nomineeDetailsRelatedVm.disableCity = false;
                        nomineeDetailsRelatedVm.selectStateList = "";
                    } else {
                    	nomineeDetailsRelatedVm.selectStateList = data;	
                        aoService.customer.city = utilityService.getValue(data.cityName);
                        aoService.customer.state = utilityService.getValue(data.stateName);
                        aoService.nominee.cityCode = utilityService.getValue(data.cityCode);
                        aoService.nominee.stateCode = utilityService.getValue(data.stateCode);
                        nomineeDetailsRelatedVm.cityData = aoService.customer.city;
                        nomineeDetailsRelatedVm.stateData = aoService.customer.state;
                        nomineeDetailsRelatedVm.ncity = nomineeDetailsRelatedVm.cityData;
                        nomineeDetailsRelatedVm.nstate = nomineeDetailsRelatedVm.stateData;
                        if (!utilityService.isUndefined(nomineeDetailsRelatedVm.ncity)) {
                            nomineeDetailsRelatedVm.isCityModified = true;
                        }
                        if (!utilityService.isUndefined(nomineeDetailsRelatedVm.nstate)) {
                            nomineeDetailsRelatedVm.isStateModified = true;
                        }
                    }
                    nomineeDetailsRelatedVm.disableNext  = true;
                }, function(error) {
                	nomineeDetailsRelatedVm.selectStateList = "";
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else if (nomineeDetailsRelatedVm.pincodeData === "" || (!utilityService.isUndefined(nomineeDetailsRelatedVm.pincodeData)).length != 6) {
                nomineeDetailsRelatedVm.cityData = "";
                nomineeDetailsRelatedVm.stateData = "";
            }
        }

        /* If city and state fields are valid, enable/disable Next button */
        nomineeDetailsRelatedVm.updatedValue = function(isValid) {

            nomineeDetailsRelatedVm.disableNomineeAddrNext = !(isValid);
            nomineeDetailsRelatedVm.ncity = nomineeDetailsRelatedVm.cityData;
            nomineeDetailsRelatedVm.nstate = nomineeDetailsRelatedVm.stateData;
            if (!utilityService.isUndefined(nomineeDetailsRelatedVm.ncity)) {
                nomineeDetailsRelatedVm.isCityModified = true;
            }
            if (!utilityService.isUndefined(nomineeDetailsRelatedVm.nstate)) {
                nomineeDetailsRelatedVm.isStateModified = true;
            }
            return nomineeDetailsRelatedVm.disableNext;
        }

        /* Disable nominee address page fields */
        nomineeDetailsRelatedVm.disableAddressFields = function() {
            nomineeDetailsRelatedVm.disableAddress1 = true;
            nomineeDetailsRelatedVm.disableAddress2 = true;
            nomineeDetailsRelatedVm.disablePincode = true;
            nomineeDetailsRelatedVm.disableCity = true;
            nomineeDetailsRelatedVm.disableState = true;
            nomineeDetailsRelatedVm.nomineeStateShow = false;
        }

        nomineeDetailsRelatedVm.assignAddress = function() {
            if (aoService.isNomineeScanned == true) {
                aoService.nomineeAadhaarCardDetails.address1 = nomineeDetailsRelatedVm.addressAboveData;
                aoService.nomineeAadhaarCardDetails.address2 = nomineeDetailsRelatedVm.addressBelowData;
                aoService.nomineeAadhaarCardDetails.pc = nomineeDetailsRelatedVm.pincodeData;
                aoService.nomineeAadhaarCardDetails.dist = nomineeDetailsRelatedVm.cityData;
                aoService.nomineeAadhaarCardDetails.state = nomineeDetailsRelatedVm.stateData;
            } else if (aoService.isNomineeScanned == false) {
                aoService.nominee.address1 = nomineeDetailsRelatedVm.addressAboveData;
                aoService.nominee.address2 = nomineeDetailsRelatedVm.addressBelowData;
                aoService.nominee.pincode = nomineeDetailsRelatedVm.pincodeData;
                aoService.nominee.city = nomineeDetailsRelatedVm.cityData;
                aoService.nominee.state = nomineeDetailsRelatedVm.stateData;
            }
        }
		
		nomineeDetailsRelatedVm.stateListChange = function(data) {
			var arr = nomineeDetailsRelatedVm.selectStateList;
			if(data){
				var arrLength = arr.length;	
			for (var i = 0; i < arrLength; i++) {
				if (arr[i].stateCode == data) {
					var tempData = arr[i];
					aoService.customer.city = utilityService.getValue(tempData.cityName);
					aoService.customer.state = utilityService.getValue(tempData.stateName);
					aoService.nominee.cityCode = utilityService.getValue(tempData.cityCode);
					aoService.nominee.stateCode = utilityService.getValue(tempData.stateCode);
					nomineeDetailsRelatedVm.cityData = aoService.customer.city;
					nomineeDetailsRelatedVm.stateData = aoService.customer.state;
					nomineeDetailsRelatedVm.ncity = nomineeDetailsRelatedVm.cityData;
					nomineeDetailsRelatedVm.nstate = nomineeDetailsRelatedVm.stateData;
					if (!utilityService.isUndefined(nomineeDetailsRelatedVm.ncity)) {
						nomineeDetailsRelatedVm.isCityModified = true;
					}
					if (!utilityService.isUndefined(nomineeDetailsRelatedVm.nstate)) {
						nomineeDetailsRelatedVm.isStateModified = true;
					}
				}
			};
			}else{
				aoService.customer.state ="";
				nomineeDetailsRelatedVm.stateData ="";
				nomineeDetailsRelatedVm.disableNext  = true;
			}
		}; 

        /* Based on "Same as Applicant Address" checkbox, reload the address fields  */
        nomineeDetailsRelatedVm.checkboxValidation = function() {
            
            if (nomineeDetailsRelatedVm.applicantChecked) {
                if (aoService.isAadharManualEntry == false && aoService.correspondenceCheckStatus === true) {
                    nomineeDetailsRelatedVm.addressAboveData = aoService.customerCorrespondenceAddress.address1;
                    nomineeDetailsRelatedVm.addressBelowData = aoService.customerCorrespondenceAddress.address2;
                    nomineeDetailsRelatedVm.pincodeData = parseInt(aoService.customerCorrespondenceAddress.pincode);
                    nomineeDetailsRelatedVm.cityData = aoService.customerCorrespondenceAddress.city;
                    nomineeDetailsRelatedVm.stateData = aoService.customerCorrespondenceAddress.state;
                    nomineeDetailsRelatedVm.disableAddressFields();
                    nomineeDetailsRelatedVm.loadState(aoService.customerCorrespondenceAddress.pincode , aoService.customerCorrespondenceAddress.stateCode);
                } else if (aoService.isAadharManualEntry == false && aoService.correspondenceCheckStatus === false) {
                    nomineeDetailsRelatedVm.addressAboveData = nomineeDetailsRelatedVm.concatCustomerAddressline1();
                    nomineeDetailsRelatedVm.addressBelowData = nomineeDetailsRelatedVm.concatCustomerAddressline2();
                    nomineeDetailsRelatedVm.pincodeData = parseInt(aoService.customerAadhaarCardDetails.pc);
                    nomineeDetailsRelatedVm.cityData = aoService.customerAadhaarCardDetails.dist;
                    nomineeDetailsRelatedVm.stateData = aoService.customerAadhaarCardDetails.state;
                    nomineeDetailsRelatedVm.disableAddressFields();
                    nomineeDetailsRelatedVm.loadState(aoService.customerAadhaarCardDetails.pc , aoService.customerAadhaarCardDetails.stateCode);
                } else if (aoService.isAadharManualEntry == true && aoService.isCustManualCorresChkBox == true) {
                    nomineeDetailsRelatedVm.addressAboveData = aoService.aadhaarManualCorrespondenceAddress.address1;
                    nomineeDetailsRelatedVm.addressBelowData = aoService.aadhaarManualCorrespondenceAddress.address2;
                    nomineeDetailsRelatedVm.pincodeData = parseInt(aoService.aadhaarManualCorrespondenceAddress.pincode);
                    nomineeDetailsRelatedVm.cityData = aoService.aadhaarManualCorrespondenceAddress.city;
                    nomineeDetailsRelatedVm.stateData = aoService.aadhaarManualCorrespondenceAddress.state;
                    nomineeDetailsRelatedVm.disableAddressFields();
                    nomineeDetailsRelatedVm.loadState(aoService.aadhaarManualCorrespondenceAddress.pincode , aoService.aadhaarManualCorrespondenceAddress.stateCode);
                } else if (aoService.isAadharManualEntry == true && aoService.isCustManualCorresChkBox == false) {

                    var title = '';
                    var template = '{{"APPLICANT_NOMINEE_ADDRESS_IF_EMPTY" | translate}}';
                    var onTap = 'menu.nomineeDetailsNext';
                    var buttontext = 'OK';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                    nomineeDetailsRelatedVm.applicantChecked = false;
                    nomineeDetailsRelatedVm.disableAddress1 = false;
                    nomineeDetailsRelatedVm.disableAddress2 = false;
                    nomineeDetailsRelatedVm.disablePincode = false;
                    nomineeDetailsRelatedVm.disableCity = false;
                    nomineeDetailsRelatedVm.disableState = false;
                }
            } else if (!nomineeDetailsRelatedVm.applicantChecked) {
                nomineeDetailsRelatedVm.disableAddress1 = false;
                nomineeDetailsRelatedVm.disableAddress2 = false;
                nomineeDetailsRelatedVm.disablePincode = false;
                nomineeDetailsRelatedVm.disableCity = true;
                nomineeDetailsRelatedVm.disableState = true;

                nomineeDetailsRelatedVm.addressAboveData = '';
                nomineeDetailsRelatedVm.addressBelowData = '';
                nomineeDetailsRelatedVm.pincodeData = '';
                nomineeDetailsRelatedVm.cityData = '';
                nomineeDetailsRelatedVm.stateData = '';
                aoService.nomineeAadhaarCardDetails.house = '';
                aoService.nomineeAadhaarCardDetails.street = '';
                aoService.nomineeAadhaarCardDetails.loc = '';
                aoService.nomineeAadhaarCardDetails.vtc = '';
                aoService.nomineeAadhaarCardDetails.po = '';
                aoService.nomineeAadhaarCardDetails.subdist = '';
                nomineeDetailsRelatedVm.nomineeStateShow = true;
                nomineeDetailsRelatedVm.selectStateList = "";
                nomineeDetailsRelatedVm.nomineeAddressForm.$setPristine();
            }
            if(nomineeDetailsRelatedVm.applicantChecked){
                if(nomineeDetailsRelatedVm.addressAboveData.length > 40 || nomineeDetailsRelatedVm.addressBelowData.length > 40){
                    var title = '';
                    var template = '{{"MAX_CHAR" | translate}}';
                    var onTap = '';
                    var buttontext = '<b>' + nomineeDetailsRelatedVm.okBtntext + '</b>';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                }
            }
        };
		nomineeDetailsRelatedVm.loadState = function(pincode ,stateCodeData) {
			var inputparams = {
                    "pinCode": pincode
                }
               // if(!nomineeDetailsRelatedVm.selectStateList){
                nomineeDetailsRelatedService.getAreaDetailForPincode(inputparams).then(function(data) {
                    //Success - Data
                    if (!utilityService.isUndefined(data)) {
                       nomineeDetailsRelatedVm.selectStateList = data;
                       nomineeDetailsRelatedVm.selectdState = stateCodeData; 
                    }
                }, function(error) {
                });
               // }
		};
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            nomineeDetailsRelatedVm.showBack = true;
            nomineeDetailsRelatedVm.showNext = true;
            nomineeDetailsRelatedVm.isAddress1 = false;
            nomineeDetailsRelatedVm.isAddress2 = false;
            nomineeDetailsRelatedVm.validDateFormat = false;
            nomineeDetailsRelatedVm.isMName = false;
            nomineeDetailsRelatedVm.isNomineeScanned = aoService.isNomineeScanned;

            nomineeDetailsRelatedVm.displayNomineeAdharDetails();

            if (nomineeDetailsRelatedVm.isNomineeScanned === true) {
                nomineeDetailsRelatedVm.nomineeAge = aoService.nomineeAadhaarCardDetails.age;
                nomineeDetailsRelatedVm.displayNames(aoService.nomineeAadhaarCardDetails.name);
                nomineeDetailsRelatedVm.populateDobAadhaar(aoService.nomineeAadhaarCardDetails.dob);
            } else {
                nomineeDetailsRelatedVm.nomineeAge = aoService.nominee.age;
                nomineeDetailsRelatedVm.populateDobAadhaar(aoService.nominee.dob);
            }
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            nomineeDetailsRelatedVm.loadState(nomineeDetailsRelatedVm.pincodeData , aoService.nominee.stateCode);
        });

        return this;
    }
]);
