'use strict';

angularApp.service('nomineeDetailsRelatedService',
    function($q, AdapterUtils, constantConfig) {
        var nomineeDetailsRelatedService = this;

        nomineeDetailsRelatedService.createNominee = function(data) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.createNominee, data, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        nomineeDetailsRelatedService.getAreaDetailForPincode = function(inputparams) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.getPostalDetailByPinCode , inputparams, true).then(

                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        nomineeDetailsRelatedService.updateGuardian = function(data) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.updateGuardianDetails, data, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        nomineeDetailsRelatedService.guardianCheck = function(data) {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.guardianAddress, data, true).then(

                function(response) {
                    q.resolve(response.data.guardianAddress);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        return nomineeDetailsRelatedService;
    });
