'use strict';

angularApp.controller('nomineeEnteredAddressController', ["$state",
    "$scope",
    "aoService",
    "nomineeDetailsRelatedService",
    "utilityService",
    "$timeout",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        aoService,
        nomineeDetailsRelatedService,
        utilityService,
        $timeout,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var nomineeEnteredAddressVm = this;

        function initPage() {

            nomineeEnteredAddressVm.showBack = true;
            nomineeEnteredAddressVm.showNext = true;
            nomineeEnteredAddressVm.aofooter = true;
            nomineeEnteredAddressVm.disableNext = true;
        }

        nomineeEnteredAddressVm.goBacktoPrevious = function() {
            $state.go("menu.nomineeDetailsAddressOption");
        }

        nomineeEnteredAddressVm.changefn = function() {
            if (nomineeEnteredAddressVm.isChecked) {
                nomineeEnteredAddressVm.disableNext = false;
            } else {
                nomineeEnteredAddressVm.disableNext = true;
            }
        }

        /*$scope.$watch("nomineeEnteredAddressVm.guardian-appoint.$valid", function(value) {
            
            if (value == true) {
                nomineeEnteredAddressVm.disableNext = false;
            } else {
                nomineeEnteredAddressVm.disableNext = true;
            }
        });*/


        nomineeEnteredAddressVm.setGuardianDetails = function() {
            var guardianDetails = {};
            if (aoService.isNomineeScanned === true) {
                guardianDetails.nomineeName = aoService.nomineeAadhaarCardDetails.name;
                guardianDetails.guardianName = aoService.nomineeAadhaarCardDetails.guardianName;
            } else {
                guardianDetails.nomineeName = aoService.nominee.name;
                guardianDetails.guardianName = aoService.nominee.guardianName;
            }
            return guardianDetails;
        }

        nomineeEnteredAddressVm.goToNextPage = function() {
            var guardianDetailParams = nomineeEnteredAddressVm.setGuardianDetails();
            
            aoService.nomineeGuardianDetails.guardianConsent = nomineeEnteredAddressVm.isChecked;
            if (utilityService.isUndefined(guardianDetailParams.guardianName)) {
                var title = '';
                var template = '{{"IF_GUARDIAN_NAME_EMPTY" | translate}}';
                var onTap = 'menu.nominationRelated';
                var buttontext = 'OK';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            } else {
                //Service to update guardian details
                var params = {
                    "id": aoService.customer.mobileNo,
                    "data": {
                        "nominees": [{
                            "guardian": {
                                "address": {
                                    "addressLine1": nomineeEnteredAddressVm.personalDetails.addressLine1,
                                    "addressLine2": nomineeEnteredAddressVm.personalDetails.addressLine2,
                                    "pincode": nomineeEnteredAddressVm.personalDetails.pincode,
                                    "city": nomineeEnteredAddressVm.personalDetails.city,
                                    "state": nomineeEnteredAddressVm.personalDetails.state,
                                    "locality": ""
                                },
                                "name": guardianDetailParams.guardianName,
                                "guardianAddressFlag": aoService.nominee.guardianAddressFlag,
                                "guardianConsent": aoService.nomineeGuardianDetails.guardianConsent
                            },
                            "name": guardianDetailParams.nomineeName
                        }],
                        "commonId": $state.$current.data.commonId
                    }
                }
               
                nomineeDetailsRelatedService.updateGuardian(params).then(function(response) {
                    $state.go("menu.selectBranchOption");
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        nomineeEnteredAddressVm.fullAddress = function() {
            var address = "";
            
            nomineeEnteredAddressVm.isChecked = aoService.nomineeGuardianDetails.guardianConsent;
            if (aoService.isNomineeScanned === true) {
                nomineeEnteredAddressVm.personalDetails.addressLine1 = aoService.nullCheck(aoService.nomineeAadhaarCardDetails.address1);
                nomineeEnteredAddressVm.personalDetails.addressLine2 = aoService.nullCheck(aoService.nomineeAadhaarCardDetails.address2);
                nomineeEnteredAddressVm.personalDetails.address = aoService.nullCheck(aoService.nomineeAadhaarCardDetails.address1) + aoService.nullCheck(aoService.nomineeAadhaarCardDetails.address2);
                nomineeEnteredAddressVm.personalDetails.pincode = aoService.nomineeAadhaarCardDetails.pc;
                nomineeEnteredAddressVm.personalDetails.city = aoService.nomineeAadhaarCardDetails.dist;
                nomineeEnteredAddressVm.personalDetails.state = aoService.nomineeAadhaarCardDetails.state;
            } else {
                nomineeEnteredAddressVm.personalDetails.addressLine1 = aoService.nullCheck(aoService.nominee.address1);
                nomineeEnteredAddressVm.personalDetails.addressLine2 = aoService.nullCheck(aoService.nominee.address2);
                nomineeEnteredAddressVm.personalDetails.address = aoService.nullCheck(aoService.nominee.address1) + aoService.nullCheck(aoService.nominee.address2);
                nomineeEnteredAddressVm.personalDetails.pincode = aoService.nominee.pincode;
                nomineeEnteredAddressVm.personalDetails.city = aoService.nominee.city;
                nomineeEnteredAddressVm.personalDetails.state = aoService.nominee.state;
            }
            if (!utilityService.isUndefined(nomineeEnteredAddressVm.personalDetails.addressLine1)) {
                var index = nomineeEnteredAddressVm.personalDetails.addressLine1.lastIndexOf(",");
                nomineeEnteredAddressVm.personalDetails.addressLine1 = nomineeEnteredAddressVm.personalDetails.addressLine1.substring(0, index) + nomineeEnteredAddressVm.personalDetails.addressLine1.substring(index + 1);
            }
            if (!utilityService.isUndefined(nomineeEnteredAddressVm.personalDetails.addressLine2)) {
                var index = nomineeEnteredAddressVm.personalDetails.addressLine2.lastIndexOf(",");
                nomineeEnteredAddressVm.personalDetails.addressLine2 = nomineeEnteredAddressVm.personalDetails.addressLine2.substring(0, index) + nomineeEnteredAddressVm.personalDetails.addressLine2.substring(index + 1);
            }
            if (!utilityService.isUndefined(nomineeEnteredAddressVm.personalDetails.address)) {
                var index = nomineeEnteredAddressVm.personalDetails.address.lastIndexOf(",");
                nomineeEnteredAddressVm.personalDetails.address = nomineeEnteredAddressVm.personalDetails.address.substring(0, index) + nomineeEnteredAddressVm.personalDetails.address.substring(index + 1);
            }
        }

        nomineeEnteredAddressVm.guardianDetails = function() {
            if (aoService.isNomineeScanned === true) {
                nomineeEnteredAddressVm.guardianConName = aoService.nomineeAadhaarCardDetails.guardianName;
                nomineeEnteredAddressVm.guardianConAge = aoService.nomineeAadhaarCardDetails.guardianAge;
            } else {
                nomineeEnteredAddressVm.guardianConName = aoService.nominee.guardianName;
                nomineeEnteredAddressVm.guardianConAge = aoService.nominee.guardianAge;
            }
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            nomineeEnteredAddressVm.personalDetails = {};
            nomineeEnteredAddressVm.fullAddress();
            if (nomineeEnteredAddressVm.isChecked == true) {
                nomineeEnteredAddressVm.disableNext = false;
            } else {
                nomineeEnteredAddressVm.disableNext = true;
            }
            nomineeEnteredAddressVm.guardianDetails();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
