'use strict';

angularApp.controller('panAuthoriseController', ["$state",
    "$scope",
    "panAuthoriseService",
    "aoService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        panAuthoriseService,
        aoService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var panAuthoriseVm = this;

        function initPage() {
            panAuthoriseVm.showBack = true;
            panAuthoriseVm.showNext = true;
            panAuthoriseVm.isChecked = '';
            panAuthoriseVm.disableNext = true;
            panAuthoriseVm.aofooter = true;
            panAuthoriseVm.loadAuthorizeDetails();
            $scope.isiPhone = utilityService.isIOSPlatform();
            panAuthoriseVm.isChecked = aoService.panAuthorizeFlag;
            panAuthoriseVm.agreeToAuthorize();
        }

        panAuthoriseVm.goBacktoPrevious = function() {
        	if(( aoService.isJTSixPostLoginStarted && aoService.cifNumber == '1000' )||
        	    (aoService.isPreJTSixStarted && aoService.cifNumber == '1000' )
        	    ||(aoService.cifNumber == '1000' )){
        		$state.go('menu.panDetails');
        		return true;
        	}
        	
            if (!utilityService.isUndefined(aoService.cifNumber)) {
                if (aoService.cifNumber == '0000') {
                    $state.go('menu.panDetails');
                } else {
                    $state.go('menu.multipleCustomer');
                }
            }
            else{
                $state.go('menu.panDetails');
            }
        }

        panAuthoriseVm.goToNextPage = function() {
            panAuthoriseVm.postAuthorizeDetails();
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        panAuthoriseVm.agreeToAuthorize = function() {
            if (panAuthoriseVm.isChecked) {
                panAuthoriseVm.disableNext = false;
            } else {
                panAuthoriseVm.disableNext = true;
            }
        }

        panAuthoriseVm.loadAuthorizeDetails = function() {
            panAuthoriseService.getAuthorizationDetails().then(function(data) {
                panAuthoriseVm.authorisationDetails = data;
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        panAuthoriseVm.postAuthorizeDetails = function() {
            aoService.panAuthorizeFlag = panAuthoriseVm.isChecked;
            var requestParams = {
                "id": aoService.customer.mobileNo,
                "data": {
                    "panAuthorizeFlag": panAuthoriseVm.isChecked,
                    "commonId": $state.$current.data.commonId
                }
            }

            panAuthoriseService.setPanAuthorizeFlag(requestParams).then(function(data) {
                $state.go('menu.aOGetPicture');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }


        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
			panAuthoriseService.isComingfromPanAuthPage = true;
        });

        return this;
    }
]);
