'use strict';

angularApp.controller('panDetailsController', ["$state",
    "$scope",
    "$translate",
    "$ionicHistory",
    "utilityService",
    "panDetailsService",
    "aoService",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
	"$ionicPopup",
	"panAuthoriseService",
    function($state,
        $scope,
        $translate,
        $ionicHistory,
        utilityService,
        panDetailsService,
        aoService,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService,
        $ionicPopup,
		panAuthoriseService) {

        var panDetailsVm = this;

        function initPage() {
            panDetailsVm.showBack = true;
            panDetailsVm.showNext = true;
            panDetailsVm.aofooter = true;
            panDetailsVm.disableNext = true;
	    panDetailsVm.showJTSixForm = false;
            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                panDetailsVm.okBtntext = translatedvalue;
            });
            panDetailsVm.maxAttepmtForCIF = 0; 
        }

        panDetailsVm.goBacktoPrevious = function() {
        	if(panDetailsVm.showJTSixForm){
        		panDetailsVm.showJTSixForm = false;
        		return true;
        	}
        	
            if (aoService.correspondenceCheckStatus == false && aoService.isAadharManualEntry == false) {
                $state.go("menu.pdetailsAddress");
            } else if (aoService.correspondenceCheckStatus == true && aoService.isAadharManualEntry == false) {
                $state.go("menu.pdetailsCAddress");
            } else if (aoService.isCustManualCorresChkBox == false && aoService.isAadharManualEntry == true) {
                $state.go("menu.aDCityCountry");
            } else if (aoService.isCustManualCorresChkBox == true && aoService.isAadharManualEntry == true) {
                $state.go("menu.aadhaarManualEntryCAddress");
            }
        }

        panDetailsVm.setValidateParams = function() {
            var params = {};
            var validateManualDob = aoService.customerManualEntryDetails.dob.split("/").join("");
            var validateAadhaarDob = aoService.customerAadhaarCardDetails.dob.split("/").join("");
            if (aoService.isAadharManualEntry == true) {
                params = {
                    "pan": aoService.customer.panNumber.toLowerCase(),                            
                    "firstName": aoService.customerManualEntryDetails.firstName,
                    "lastName": aoService.customerManualEntryDetails.lastName,
                    "dob": validateManualDob,
                    "uid": aoService.customerManualEntryDetails.aadharNumber
                }
            } else {
                params = {
                    "pan": aoService.customer.panNumber.toLowerCase(),                            
                    "firstName":aoService.customerAadhaarCardDetails.firstName,
                    "lastName": aoService.customerAadhaarCardDetails.lastName,
                    "dob": validateAadhaarDob,
                    "uid": aoService.customerAadhaarCardDetails.uid
                }
            }
            return params;
        }

		panDetailsVm.openUserNameInfoPopupDebitCard = function(){
					var userInfoPopUp = $ionicPopup.show({
					template: '<p>Please enter 16 digit ATM/Debit card number printed on card issued in your name</p>',
			        title: '',
			        cssClass: 'dialog',
			        scope: $scope,
			        buttons: [{
			            text: 'OK',
			            type: 'button-positive'
			            }]
					});
				};
				
		panDetailsVm.openUserNameInfoPopupAccountNo = function(){
					var userInfoPopUp = $ionicPopup.show({
					template: '<p>Please enter your 11 digit account number</p>',
			        title: '',
			        cssClass: 'dialog',
			        scope: $scope,
			        buttons: [{
			            text: 'OK',
			            type: 'button-positive'
			            }]
					});
				};

		panDetailsVm.openUserNameInfoPopupCIF = function(){
					var userInfoPopUp = $ionicPopup.show({
					template:  '<p>Please enter your 11 CIF (Customer Information Number), available in Passbook/Account statement</p>',
			        title: '',
			        cssClass: 'dialog',
			        scope: $scope,
			        buttons: [{
			            text: 'OK',
			            type: 'button-positive'
			            }]
					});
				};			

		panDetailsVm.validateJTSixForm = function(isValid) {
			if(panDetailsVm.debitCard || panDetailsVm.accountNo || panDetailsVm.CIFNo){					
				var params = {
					value : "",
					key : ""
				}; 
				
				if(panDetailsVm.debitCard){
					params.key = "debitCard";
					params.value = panDetailsVm.debitCard;
					if(panDetailsVm.debitCard.length != 16){
						utilityService.showErrorMessage("Please enter 16 digit Debit card number");
						return true;
					}
				}else if(panDetailsVm.accountNo){
					params.key = "accountNo";
					params.value = panDetailsVm.accountNo;
					if(panDetailsVm.accountNo.length != 11){
						utilityService.showErrorMessage("Please enter 11 digit Account number");
						return true;
					}
				}else if(panDetailsVm.CIFNo){
					params.key = "CIFNo";
					params.value = panDetailsVm.CIFNo;
					if(panDetailsVm.CIFNo.length != 11){
						utilityService.showErrorMessage("Please enter 11 digit CIF number");
						return true;
					}
				}
				panDetailsService.getDetailsforJTSix(params).then(function(response) {
					aoService.preJTSixdata = response.data;
					aoService.preJTSixdata.isLocalBanchLoaded = true;
					$state.go('menu.panAuthorise');
					}, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
			}else{
					utilityService.showErrorMessage("Please enter Debit card/CIF/Account number");
					
			}
		};	
	
        panDetailsVm.goToNextPage = function(isValid) {
            if(panDetailsVm.showJTSixForm){
            	if(panDetailsVm.maxAttepmtForCIF >= 5){
            		utilityService.showErrorMessage("Maximum retries has been done! Please logout and login again.");
            		return true;
            	}else{
            		panDetailsVm.maxAttepmtForCIF = panDetailsVm.maxAttepmtForCIF +1;
            	}
            	panDetailsVm.validateJTSixForm();
            	aoService.isPreJTSixStarted = true;  
            	return true;
            }
            var panCheck = panDetailsVm.pannumber;
            var validPan = panCheck.toUpperCase();
            if (isValid && validPan.substring(3, 4) == "P") {
                aoService.customer.panNumber = validPan;
                var params = panDetailsVm.setValidateParams();
               
                //Service to update the pan number
                panDetailsService.validatePanNumber(params).then(function(response) {
                    
                    if (!utilityService.isUndefined(response.data.cif)) {
                         if (response.data.cif == "1001" || response.data.cif == "0002") {
                         	utilityService.showErrorMessage(response.data.details);
                         	return true;
                         }else if (response.data.cif == "1000") {
                         	panDetailsVm.CIFNo = ""; 
			            	panDetailsVm.accountNo = "";
			            	panDetailsVm.debitCard = "";
                            aoService.cifNumber = response.data.cif;
                            panDetailsVm.disableNext = false; 
                            panDetailsVm.showJTSixForm = true;
                            
			            	panDetailsVm.disableDebitCardNo = false;
			            	panDetailsVm.disableAccountNo = false;
			            	panDetailsVm.disableCIF = false;
							panDetailsVm.panDetailNextForm.$setPristine();
                            if(aoService.isJTSixPostLoginStarted){
			                     panDetailsVm.disableNext = false; 
			                     panDetailsVm.showJTSixForm = true;
			                     return true;
			                }
                        } else if (response.data.cif == "0000") {
                            aoService.cifNumber = response.data.cif;
                            $state.go('menu.panAuthorise');
                        } else if (response.data.cif == "0001") {
                            aoService.cifNumber = response.data.cif;
                            $state.go('menu.multipleCustomer');
                        } else {
                            aoService.cifNumber = response.data.cif;
                            $state.go('menu.multipleCustomer');
                            //$state.go('menu.passbookDetails');
                        }
                        panDetailsVm.updateCifStatus();
                        //panDetailsVm.validatePan();
                    }
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else {
                var title = '';
                var template = '{{"INCORRECT_PAN_MSG" | translate}}';
                var onTap = 'menu.panDetails';
                var buttontext = '<b>' + panDetailsVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            }
        }
    
        panDetailsVm.updateCifStatus = function() {
            var params = {
                "id": aoService.customer.mobileNo,
                "data": {
                    "personalDetails": {
                        "pan": aoService.customer.panNumber.toLowerCase(),
                        "cifStatus": aoService.cifNumber
                    }
                }
            }
            
            panDetailsService.updateCif(params).then(function(response) {
                
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }        

        panDetailsVm.populateResumeData = function() {
            /*if (aoService.isResumeJourney == true) {*/
            panDetailsVm.pannumber = aoService.customer.panNumber;
            /*}*/
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        panDetailsVm.enableNext = function() {
            if (!utilityService.isUndefined(panDetailsVm.pannumber)) {
                if (panDetailsVm.pannumber.length == constantConfig.acOp.panLength && (panDetailsVm.panDetailForm.panNumber.$invalid == true || panDetailsVm.panDetailForm.panNumber.$valid == true)) {
                    panDetailsVm.panDetailForm.$valid = true;
                } else {
                    panDetailsVm.panDetailForm.$valid = false;
                }
            }
        }
        
        
         panDetailsVm.debitCardNoChange = function() {
            if(panDetailsVm.debitCard.length == 0){
            	panDetailsVm.disableDebitCardNo = false;
            	panDetailsVm.disableAccountNo = false;
            	panDetailsVm.disableCIF = false;
            }else{
            	panDetailsVm.disableDebitCardNo = false;
            	panDetailsVm.disableAccountNo = true;
            	panDetailsVm.disableCIF = true;
            }
            panDetailsVm.validateInputJTSix();
        };
         panDetailsVm.accountNoChange = function() {
            if(panDetailsVm.accountNo.length == 0){
            	panDetailsVm.disableDebitCardNo = false;
            	panDetailsVm.disableAccountNo = false;
            	panDetailsVm.disableCIF = false;
            }else{
            	panDetailsVm.disableDebitCardNo = true;
            	panDetailsVm.disableAccountNo = false;
            	panDetailsVm.disableCIF = true;
            }
            panDetailsVm.validateInputJTSix();
        };
         panDetailsVm.CIFChange = function() {
             if(panDetailsVm.CIFNo.length == 0){
            	panDetailsVm.disableDebitCardNo = false;
            	panDetailsVm.disableAccountNo = false;
            	panDetailsVm.disableCIF = false;
            }else{
            	panDetailsVm.disableDebitCardNo = true;
            	panDetailsVm.disableAccountNo = true;
            	panDetailsVm.disableCIF = false;
            } 
            panDetailsVm.validateInputJTSix();
        };
       panDetailsVm.validateInputJTSix = function() {
       	try{
           if(panDetailsVm.debitCard.length == 16 || panDetailsVm.accountNo.length == 11 || panDetailsVm.CIFNo.length == 11){
		       panDetailsVm.isValidJTSixForm = false;
           }else{
           	panDetailsVm.isValidJTSixForm = true;
           }
           }catch(err){
           	panDetailsVm.isValidJTSixForm = true;
           }		
        };
      
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            panDetailsVm.populateResumeData();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            
            if(panDetailsVm.CIFNo ||  	panDetailsVm.accountNo || panDetailsVm.debitCard ){
				if(panAuthoriseService.isComingfromPanAuthPage){
					panAuthoriseService.isComingfromPanAuthPage = false;
					 panDetailsVm.showJTSixForm = true;
				} 
            }
            if(aoService.isJTSixPostLoginStarted && aoService.isJTSixPostLoginData.pan){
	            var panCheck = aoService.isJTSixPostLoginData.pan;
	            var validPan = panCheck.toUpperCase();
	            if (validPan.substring(3, 4) == "P") {
	            	panDetailsVm.pannumber = aoService.isJTSixPostLoginData.pan;
	            	panDetailsVm.disablePannumber  = true;
				 }
			}	 
			if(aoService.preJTSixdata.maxCIFEntered == 0){
				  panDetailsVm.maxAttepmtForCIF = 0; 
				  aoService.preJTSixdata.maxCIFEntered = 5;
			}
			panDetailsVm.validateInputJTSix();
        });


        return this;
    }
]);
