'use strict';

angularApp.controller('passbookDetailsController', ["$state",
    "$scope",
    "utilityService",
    "aoService",
    "passbookDetailsService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        utilityService,
        aoService,
        passbookDetailsService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var passbookDetailsVm = this;

        function initPage() {
            passbookDetailsVm.showBack = true;
            passbookDetailsVm.showNext = true;
            passbookDetailsVm.disableNext = true;
        }

        var noOfAttempts = 0;
        var parameters = {};
        passbookDetailsVm.goToNextPage = function() {
            noOfAttempts++;
            if (noOfAttempts < 5) {
                if (passbookDetailsVm.passbookForm.$valid == true) {
                    passbookDetailsVm.getDedupeData();
                }
            } else {
                var title = '';
                var template = '{{"NO_OF_ATTEMPTS_EXCEED" | translate}}';
                var onTap = 'menu.locateNearestBranch';
                var buttontext = 'Locate Nearest Branch';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                passbookDetailsVm.disableNext = true;
            }
        }

        passbookDetailsVm.getDedupeData = function() {
            var requestParams = parameters;
            passbookDetailsService.dedupeService(requestParams).then(function(response) {
               
                if (requestParams.requestType == 'cif') {
                    aoService.cifNumber = response.data.cif;
                    $state.go("menu.panAuthorise");
                } else if (requestParams.requestType == 'account') {
                    aoService.acNumber = response.data.cif;
                    aoService.cifNumber = response.data.cifNumber;
                    $state.go("menu.panAuthorise");
                } else if (requestParams.requestType == 'debit') {
                    aoService.debitNumber = response.data.cif;
                    aoService.cifNumber = response.data.cifNumber;
                    $state.go("menu.panAuthorise");
                }
            }, function(error) {
                
                if (error.responseCode == "0001") {
                    var title = '';
                    var template = '{{"DEDUPE_NOT_MATCHED" | translate}}';
                    var onTap = 'menu.locateNearestBranch';
                    var buttontext = 'Locate Nearest Branch';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                }
               
            });

        }

        passbookDetailsVm.emptyOnFocus = function(type) {
            if (type == 'cif') {
                passbookDetailsVm.accountNumber = '';
                passbookDetailsVm.debitCardNumber = '';
                passbookDetailsVm.disableAccount = true;
                passbookDetailsVm.disableDebit = true;
            } else if (type == 'account') {
                passbookDetailsVm.cifNumber = '';
                passbookDetailsVm.debitCardNumber = '';
                passbookDetailsVm.disableCif = true;
                passbookDetailsVm.disableDebit = true;
            } else if (type == 'debit') {
                passbookDetailsVm.cifNumber = '';
                passbookDetailsVm.accountNumber = '';
                passbookDetailsVm.disableCif = true;
                passbookDetailsVm.disableAccount = true;
            }
        }

        passbookDetailsVm.dedupeCheck = function(type, modelValue) {
            var reqParameters = {};
            
            if (!utilityService.isUndefined(modelValue)) {
                if (type == 'cif') {
                    reqParameters.requestType = type;
                    reqParameters.requestData = passbookDetailsVm.cifNumber;
                    passbookDetailsVm.accountNumber = '';
                    passbookDetailsVm.debitCardNumber = '';
                    passbookDetailsVm.passbookForm.debitNumber.$setPristine();
                    passbookDetailsVm.passbookForm.acNumber.$setPristine();
                    passbookDetailsVm.passbookForm.debitNumber.$setUntouched();
                    passbookDetailsVm.passbookForm.acNumber.$setUntouched();
                    passbookDetailsVm.disableAccount = true;
                    passbookDetailsVm.disableDebit = true;
                } else if (type == 'account') {
                    reqParameters.requestType = type;
                    reqParameters.requestData = passbookDetailsVm.accountNumber;
                    passbookDetailsVm.cifNumber = '';
                    passbookDetailsVm.debitCardNumber = '';
                    passbookDetailsVm.passbookForm.debitNumber.$setPristine();
                    passbookDetailsVm.passbookForm.cifNumber.$setPristine();
                    passbookDetailsVm.passbookForm.debitNumber.$setUntouched();
                    passbookDetailsVm.passbookForm.cifNumber.$setUntouched();
                    passbookDetailsVm.disableCif = true;
                    passbookDetailsVm.disableDebit = true;
                } else if (type == 'debit') {
                    reqParameters.requestType = type;
                    reqParameters.requestData = passbookDetailsVm.debitCardNumber;
                    passbookDetailsVm.cifNumber = '';
                    passbookDetailsVm.accountNumber = '';
                    passbookDetailsVm.passbookForm.acNumber.$setPristine();
                    passbookDetailsVm.passbookForm.cifNumber.$setPristine();
                    passbookDetailsVm.passbookForm.acNumber.$setUntouched();
                    passbookDetailsVm.passbookForm.cifNumber.$setUntouched();
                    passbookDetailsVm.disableCif = true;
                    passbookDetailsVm.disableAccount = true;
                }

            } else if (utilityService.isUndefined(modelValue)) {
                passbookDetailsVm.passbookForm.debitNumber.$setPristine();
                passbookDetailsVm.passbookForm.acNumber.$setPristine();
                passbookDetailsVm.passbookForm.cifNumber.$setPristine();
                passbookDetailsVm.passbookForm.debitNumber.$setUntouched();
                passbookDetailsVm.passbookForm.acNumber.$setUntouched();
                passbookDetailsVm.passbookForm.cifNumber.$setUntouched();
                passbookDetailsVm.disableCif = false;
                passbookDetailsVm.disableAccount = false;
                passbookDetailsVm.disableDebit = false;
            }
            
            parameters = reqParameters;
        }

        passbookDetailsVm.goBacktoPrevious = function() {
            noOfAttempts = 0;
            $state.go("menu.panDetails");
        }

        passbookDetailsVm.getCustomerDetails = function() {
            var requestParams = {
                "id": aoService.customer.mobileNo,
                "password": aoService.appPassword
            }

            passbookDetailsService.getCustomerDetails(requestParams).then(function(response) {
                var customerDetails = response.data;
               
                aoService.getResumeDocument(response.data);
                $state.go("menu.panAuthorise");
            }, function(error) {
                var title = '';
                var template = '{{"RESUME_DATA_NO_MATCH" | translate}}';
                var onTap = '';
                var buttontext = '<b>' + resumeJourneyVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            });
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
