'use strict';

angularApp.controller('passwordOTPController', ["$state",
    "$scope",
    "$translate",
    "passwordOTPService",
    "utilityService",
    "aoService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        $translate,
        passwordOTPService,
        utilityService,
        aoService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var passwordOTPVm = this;

        function initPage() {
            passwordOTPVm.showBack = false;
            passwordOTPVm.showNext = true;
            passwordOTPVm.showOtpView = true;
            passwordOTPVm.otpvalue = "";
            passwordOTPVm.disableNext = true;
            passwordOTPVm.aofooter = true;
            //passwordOTPVm.requestOtpCall();
            pwdOtpForm.isDisabledOTP = false;
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                pwdOtpForm.okBtntext = translatedvalue;  
            });
        }

        passwordOTPVm.goBacktoPrevious = function() {
            $state.go("menu.productOffering");
        }

        passwordOTPVm.goToNextPage = function() {
            /* Send the OTP */
            aoService.tncOtpValue = passwordOTPVm.otpvalue;
            var requestParams = {
                "mobile":aoService.customer.mobileNo,
                "otp": passwordOTPVm.otpvalue
            }

            passwordOTPService.OTPValidation(requestParams).then(function(response) {

                if (response.data.status.toLowerCase() == "success") {
                    $state.go("menu.regenerateAppPassword");
                    //$state.go('menu.debitCardDetails');
                } else {
                    var message = "Please enter valid OTP";
                    utilityService.showErrorMessage(message);
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

       

         passwordOTPVm.requestOtpCallOnce = function() {
         	if(pwdOtpForm.isDisabledOTP){return true}
         	passwordOTPVm.requestOtpCall();
                var title = '';
                var template = '{{"OTP_SENT_SUCCESS" | translate}}';
                var onTap = '';
                var buttontext = '<b>' + pwdOtpForm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
         	pwdOtpForm.isDisabledOTP = true;

         };
        /* Request for OTP on page load to the registered mobile number */
        passwordOTPVm.requestOtpCall = function() {
            var requestParams = {
                "id": aoService.customer.mobileNo,
                "recipientMailId": aoService.customer.emailId
            }

            passwordOTPService.requestOtp(requestParams).then(function(response) {
                //passwordOTPVm.otpvalue = utilityService.getValue(response.data.otp);
                /*if (!utilityService.isUndefined(passwordOTPVm.otpvalue)) {
                    passwordOTPVm.disableNext = false;
                }*/

            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        passwordOTPVm.validateOTP = function(isValid) {
            passwordOTPVm.disableNext = !isValid;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
