'use strict';

angularApp.controller('passwordRecoveryController', ["$state",
    "$scope",
    "$translate",
    "aoService",
    "utilityService",
    "passwordRecoveryService",
    "constantConfig",
    "appPasswordService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        $translate,
        aoService,
        utilityService,
        passwordRecoveryService,
        constantConfig,
        appPasswordService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var passwordRecoveryVm = this;

        function initPage() {
            passwordRecoveryVm.showBack = false;
            passwordRecoveryVm.showNext = true;
            passwordRecoveryVm.disableNext = true;
            passwordRecoveryVm.aofooter = true;
            passwordRecoveryVm.securityQuestions = [];
            passwordRecoveryVm.loadSecurityQuestion();
            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                passwordRecoveryVm.okBtntext = translatedvalue;
            });
        }

        passwordRecoveryVm.goToNextPage = function() {
            var requestParams = {
                "mobileNumber": passwordRecoveryVm.newMobile,
                "securityQues": passwordRecoveryVm.selectedSecQuestion,
                "securityAns": passwordRecoveryVm.secAnswer
            }            
            passwordRecoveryService.checkUser(requestParams).then(function(response) {                
                if(response.data.status.toLowerCase() == 'success'){
					aoService.customer.mobileNo = passwordRecoveryVm.newMobile;
                    $state.go("menu.passwordOTP");
                }
                else{
                    var title = '';
                    var template = '{{"DETAIL_NO_MATCH_WITH_MOB" | translate}}';
                    var onTap = 'menu.applyNewOrResume';
                    var buttontext = '<b>' + passwordRecoveryVm.okBtntext + '</b>';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                }
            }, function(error) {
                if(!utilityService.isUndefined(error.data)){
                    if(error.data.status.toLowerCase() == 'ao_insta'){
                    var title = '';
                    var template = '{{"NOT_J23_ACC" | translate}}';
                    var onTap = 'menu.instaKit_resumeJourney';
                    var buttontext = '<b>' + passwordRecoveryVm.okBtntext + '</b>';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                    }
                }
                    else{
                        var title = '';
                        var template = '{{"DETAIL_NO_MATCH" | translate}}';
                        var onTap = 'menu.applyNewOrResume';
                        var buttontext = '<b>' + passwordRecoveryVm.okBtntext + '</b>';
                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                    }
                
            });
        };

        $scope.goToHome = function() {
            aoService.homeNav();
        }

         passwordRecoveryVm.loadSecurityQuestion = function(){
			utilityService.showSpinner();
        	if(!passwordRecoveryVm.isErorr){
 		       	passwordRecoveryVm.isErorr = false;	
        	}
            appPasswordService.loadSecurityQuestions().then(function(response) {
				utilityService.hideSpinner()
            	passwordRecoveryVm.isErorr = false;
                passwordRecoveryVm.securityQuestions = response.data.masterDetails;
            }, function(error) {
				utilityService.hideSpinner()
            	passwordRecoveryVm.isErorr = true;
               utilityService.showErrorMessage(error.responseMessage);
            });
        };

        passwordRecoveryVm.proceedSuccess = function(isValid) {
            isValid ? passwordRecoveryVm.disableNext = false : passwordRecoveryVm.disableNext = true;
            return passwordRecoveryVm.disableNext;
        }

        passwordRecoveryVm.forgotSecurityQA = function(){
            var title = '';
            var template = '{{"FORGOT_QA_MSG" | translate}}';
            var onTap = 'menu.passwordRecovery';
            var buttontext = '<b>' + passwordRecoveryVm.okBtntext + '</b>';
            utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
