'use strict';

angularApp.controller('aadharscanController', ["$state",
    "$scope",
    "$cordovaBarcodeScanner",
    "aoService",
    "utilityService",
    "$translate",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        $cordovaBarcodeScanner,
        aoService,
        utilityService,
        $translate,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var aadharvm = this;
        var alphabets = /^([ \.]?[a-zA-Z]+)+$/;
        var numbers = /^[0-9]*$/;
        var addressRegex = /^[A-z().,-/0-9 #']*$/;

        function initPage() {
            aadharvm.showBack = true;
            aadharvm.showNext = false;
            aadharvm.aofooter = true;
            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                aadharvm.okBtntext = translatedvalue;
            });
        }

        aadharvm.goBacktoPrevious = function() {
            $state.go('menu.personalDetails');
        }

        aadharvm.goToNextPage = function() {
            $state.go('menu.pdetailsAN');
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        //QR code scanner code
        aadharvm.goToQRCodeDetails = function() {
            $cordovaBarcodeScanner.scan().then(function(barcodeData) {
                if (!utilityService.isUndefined(barcodeData.text)) {
                    var xmlText = barcodeData.text;
                    var formattedXml = xmlText.replace("/?xml", "?xml");
                    formattedXml = formattedXml.replace("xml?", "?xml");
                    var x2js = new X2JS();
                    var jsonObj = x2js.xml_str2json(formattedXml);
                    if (utilityService.isUndefined(jsonObj)) {
                        var title = '';
                        var template = "{{'AADHAAR_POPUP'| translate}}";
                        var onTap = '';
                        var buttontext = "<b>" + aadharvm.okBtntext + "</b>";
                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                    } else {
                        aoService.isResumeJourney = false;
                        var jsonStr = JSON.stringify(jsonObj);
                        aoService.customerManualEntryDetails = {
                            aadharNumber: "",
                            firstName: "",
                            lastName: "",
                            middleName: "",
                            fullName: "",
                            gender: "",
                            title: "",
                            dob: "",
                            address1: "",
                            address2: "",
                            city: "",
                            state: "",
                            pincode: "",
                            isAadharScanned: false,
                            locality: "",
                            addressLine1: "",
                            addressLine2: ""

                        }

                        aoService.customerAadhaarCardDetails = {
                            uid: "",
                            name: "",
                            firstName: "",
                            middleName: "",
                            lastName: "",
                            gender: "",
                            title: "",
                            yob: "",
                            co: "",
                            house: "",
                            street: "",
                            lm: "",
                            loc: "",
                            vtc: "",
                            po: "",
                            dist: "",
                            subdist: "",
                            state: "",
                            pc: "",
                            dob: "",
                            isAadharScanned: false,
                            locality: "",
                            addressLine1: "",
                            addressLine2: ""
                        }
                        
                        var securedScannedData = {
                            _co: aoService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._uid),
                            _dist: aoService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._dist),
                            _dob: aoService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._dob),
                            _gender: aoService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._gender),
                            _house: aoService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._house),
                            _name: aoService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._name),
                            _pc: aoService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._pc),
                            _po: aoService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._po),
                            _state: aoService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._state),
                            _street: aoService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._street),
                            _subdist: aoService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._subdist),
                            _uid: aoService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._uid),
                            _vtc: aoService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._vtc),
                            _yob: aoService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._yob),
                            _loc: aoService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._loc),
                            _lm: aoService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._lm)

                        }
                       securedScannedData._dob =  aoService.setDateFormatDDMMYYY(securedScannedData._dob);
                        if (aoService.nomineeAadhaarCardDetails.uid === aoService.checkSecuredData(numbers, securedScannedData._uid)) {
                            var title = '';
                            var template = "{{'AADHAAR_BOTH_SAME'| translate}}";
                            var onTap = '';
                            var buttontext = "<b>" + aadharvm.okBtntext + "</b>";
                            utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                        } else {
                            setTimeout(function() {
                                aoService.customerAadhaarCardDetails.uid = aoService.checkSecuredData(numbers, securedScannedData._uid);
                                aoService.customerAadhaarCardDetails.name = aoService.checkSecuredData(alphabets, securedScannedData._name);
                                aoService.customerAadhaarCardDetails.gender = aoService.checkSecuredData(alphabets, securedScannedData._gender);
                                aoService.customerAadhaarCardDetails.yob = aoService.checkSecuredData(numbers, securedScannedData._yob);
                                aoService.customerAadhaarCardDetails.house = aoService.checkSecuredData(addressRegex, securedScannedData._house);
                                aoService.customerAadhaarCardDetails.street = aoService.checkSecuredData(addressRegex, securedScannedData._street);
                                aoService.customerAadhaarCardDetails.lm = aoService.checkSecuredData(addressRegex, securedScannedData._lm);
                                aoService.customerAadhaarCardDetails.loc = aoService.checkSecuredData(addressRegex, securedScannedData._loc);
                                aoService.customerAadhaarCardDetails.vtc = aoService.checkSecuredData(addressRegex, securedScannedData._vtc);
                                aoService.customerAadhaarCardDetails.po = aoService.checkSecuredData(addressRegex, securedScannedData._po);
                                aoService.customerAadhaarCardDetails.dist = aoService.checkSecuredData(addressRegex, securedScannedData._dist);
                                aoService.customerAadhaarCardDetails.subdist = aoService.checkSecuredData(addressRegex, securedScannedData._subdist);
                                aoService.customerAadhaarCardDetails.state = aoService.checkSecuredData(addressRegex, securedScannedData._state);
                                aoService.customerAadhaarCardDetails.pc = aoService.checkSecuredData(numbers, securedScannedData._pc);
                                aoService.customerAadhaarCardDetails.dob = securedScannedData._dob;
                                aadharvm.isScanned = true;
                                $state.go('menu.pdetailsAN');
                            }, 500);
                        }
                    }
                }

            }, function(error) {
                var title = '';
                var template = "{{'ACCESS_APP'| translate}}";
                var onTap = '';
                var buttontext = "<b>" + aadharvm.okBtntext + "</b>";
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            });
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
