'use strict';

angularApp.controller('personalDetailsANController', ["$state",
    "$scope",
    "$translate",
    "utilityService",
    "aoService",
    "personalDataService",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        $translate,
        utilityService,
        aoService,
        personalDataService,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var pdetailsANVm = this;

        function initPage() {
            pdetailsANVm.showBack = true;
            pdetailsANVm.showNext = true;
            pdetailsANVm.invalid = false;
            pdetailsANVm.aofooter = true;
            pdetailsANVm.properDate = false;

            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                pdetailsANVm.okBtntext = translatedvalue;
            });
        }

        pdetailsANVm.loadTitles = function(){
            var requestData = "TitleLotus";
            personalDataService.loadTitleDropdown(requestData).then(function(response) {
                pdetailsANVm.selectTitles = response.data;
                pdetailsANVm.personalDetails.title = pdetailsANVm.populateTitle(aoService.customerAadhaarCardDetails.gender);
                
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        pdetailsANVm.goBacktoPrevious = function() {
            pdetailsANVm.personalDetailsDate = null;
            pdetailsANVm.personalDetailsMonth = null;
            $state.go('menu.personalDetails');
        }

        pdetailsANVm.goToNextPage = function() {
            pdetailsANVm.ageCheck = pdetailsANVm.checkAge();
            if (pdetailsANVm.ageCheck > 0) {
                $state.go('menu.aDCityCountry');
            } else {
                var title = '';
                var template = '{{"AGE_CHECK" | translate}}';
                var onTap = 'menu.pdetailsAN';
                var buttontext = '<b>' + pdetailsANVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            }
            $state.go('menu.aDCityCountry');
            aoService.customerAadhaarCardDetails.dob = pdetailsANVm.personalDetailsDate + "/" + pdetailsANVm.personalDetailsMonth + "/" + pdetailsANVm.personalDetails.yob;
            aoService.customerAadhaarCardDetails.firstName = pdetailsANVm.firstName;
            aoService.customerAadhaarCardDetails.middleName = pdetailsANVm.middleName;
            aoService.customerAadhaarCardDetails.lastName = pdetailsANVm.lastName;
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        // Form validation
        pdetailsANVm.validateForm = function(isValid) {
            pdetailsANVm.disableNext = !(isValid);
        }

        pdetailsANVm.disableNextIfEmpty = function() {
            if (utilityService.isUndefined(aoService.customerAadhaarCardDetails.uid) || utilityService.isUndefined(aoService.customerAadhaarCardDetails.name)) {
                var title = '';
                var template = '{{"AADHAAR_DETAILS_IF_EMPTY" | translate}}';
                var onTap = 'menu.locateNearestBranch';
                var buttontext = 'Locate Nearest Branch';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                pdetailsANVm.showNext = false;
            }
        }

        // On page load - populate aadhaar dob
        pdetailsANVm.populateDobAadhaar = function() {
            if (!utilityService.isUndefined(aoService.customerAadhaarCardDetails.dob)) {
                aoService.customerAadhaarCardDetails.dob = moment(aoService.customerAadhaarCardDetails.dob, ["DD/MM/YYYY", "MM/DD/YYYY", "DD-MM-YYYY", "MM-DD-YYYY", "YYYY-MM-DD", "YYYY-DD-MM","YYYY/MM/DD", "YYYY/DD/MM"]);
                var dateFormat = new Date(aoService.customerAadhaarCardDetails.dob);
                var day = dateFormat.getDate();
                var month = dateFormat.getMonth() + 1;
                var year = dateFormat.getFullYear();
                var formattedDate = day.toString();
                if (formattedDate.length == 1) {
                    formattedDate = "0" + formattedDate;
                    pdetailsANVm.personalDetailsDate = formattedDate;
                } else {
                    pdetailsANVm.personalDetailsDate = parseInt(day);
                }
                var formattedMonth = month.toString();
                if (formattedMonth.length == 1) {
                    formattedMonth = "0" + formattedMonth;
                    pdetailsANVm.personalDetailsMonth = formattedMonth;
                } else {
                    pdetailsANVm.personalDetailsMonth = parseInt(month);
                }
                pdetailsANVm.personalDetails.yob = parseInt(year);
            } else if (!utilityService.isUndefined(aoService.customerAadhaarCardDetails.yob) && utilityService.isUndefined(aoService.customerAadhaarCardDetails.dob)) {
                pdetailsANVm.personalDetailsDate = "";
                pdetailsANVm.personalDetailsMonth = "";
                pdetailsANVm.personalDetailsDateForm.personalDetailsDate.$setPristine();
                pdetailsANVm.personalDetailsDateForm.personalDetailsMonth.$setPristine();
                pdetailsANVm.personalDetails.yob = parseInt(aoService.customerAadhaarCardDetails.yob);
            }
        }

        // On change - Gender will be changed on title selection
        pdetailsANVm.titleSelection = function() {
            if (pdetailsANVm.personalDetails.title == "01") {
                pdetailsANVm.personalDetails.gender = "Male";
            } else {
                pdetailsANVm.personalDetails.gender = "Female";
            }
            aoService.customerAadhaarCardDetails.titleCode = pdetailsANVm.personalDetails.title;
            aoService.customerAadhaarCardDetails.title = aoService.getValueById(pdetailsANVm.selectTitles, aoService.customerAadhaarCardDetails.titleCode);
            aoService.customerAadhaarCardDetails.gender = pdetailsANVm.personalDetails.gender;
        }

        // On page load - If date/month is undefined, trigger the popup
        pdetailsANVm.showHidePopup = function() {
            if (utilityService.isUndefined(pdetailsANVm.personalDetailsDate) || utilityService.isUndefined(pdetailsANVm.personalDetailsMonth)) {
                var title = '';
                var template = '{{"VALID_AGE_PROOF" | translate}}';
                var onTap = 'menu.pdetailsAN';
                var buttontext = 'OK';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            }
        }

        //On page load - if gender is "M" / "F" - Change to full text
        pdetailsANVm.displayGender = function(value) {
            var genderLabel;
            var genderValue = value.toLowerCase();
            if (genderValue == "m" || genderValue == constantConfig.acOp.maleGender) {
                genderLabel = "Male";
            } else {
                genderLabel = "Female";
            }
            return genderLabel;
        }

        //On page load - change title dropdown based on the gender
        pdetailsANVm.populateTitle = function(value) {
            var title;
            var genderValue = value.toLowerCase();
            if (genderValue == "m" || genderValue == constantConfig.acOp.maleGender) {
                title = "01";
            } else {
                title = "02";
            }
            aoService.customerAadhaarCardDetails.titleCode = title;
            aoService.customerAadhaarCardDetails.title = aoService.getValueById(pdetailsANVm.selectTitles, aoService.customerAadhaarCardDetails.titleCode);
            aoService.customerAadhaarCardDetails.gender = genderValue;
            return title;
        }

        //On page load - Split the aadhaar card holder's name and display accordingly
        pdetailsANVm.displayNames = function(value) {
            var fullName = value;
            var splittedName = value.split(" ");
            var splitLen = value.split(" ").length;
            var i;
            var middleName = [];
            if (splitLen === 1) {
                pdetailsANVm.firstName = splittedName[0];
                pdetailsANVm.isMName = false;
                pdetailsANVm.isLName = false;
            } else if (splitLen === 2) {
                pdetailsANVm.isLName = true;
                pdetailsANVm.firstName = splittedName[0];
                pdetailsANVm.lastName = splittedName[1];
                pdetailsANVm.isMName = false;
            } else {
                pdetailsANVm.isLName = true;
                pdetailsANVm.isMName = true;
                pdetailsANVm.firstName = splittedName[0];
                for (i = 1; i < splitLen - 1; i++) {
                    middleName[i] = splittedName[i];
                }
                pdetailsANVm.middleName = middleName.join(' ');
                pdetailsANVm.lastName = splittedName[splitLen - 1];
            }
        }

        pdetailsANVm.validDateFormat = function(isValid) {
            var fullDate = pdetailsANVm.personalDetailsMonth + '-' + pdetailsANVm.personalDetailsDate + '-' + pdetailsANVm.personalDetails.yob;
            var dobMonth = pdetailsANVm.personalDetailsMonth;
            var dobDay = pdetailsANVm.personalDetailsDate;
            var dobYr = pdetailsANVm.personalDetails.yob;
            var fullDateInMilliSeconds = Date.parse(fullDate);
            var formattedDate = new Date();
            var formattedDateYr = formattedDate.getFullYear();
            var currDate = new Date();
            var curYear = currDate.getFullYear();
            var curDateInMilliSeconds = new Date().getTime();
            formattedDate.setFullYear(dobYr, dobMonth - 1, dobDay);
            var months30 = ["04", "06", "09", "11", "4", "6", "9"];
            var monthIndex = months30.indexOf(dobMonth);

            if (fullDateInMilliSeconds > curDateInMilliSeconds) {
                pdetailsANVm.disableNext = true;
                pdetailsANVm.properDate = false;
                pdetailsANVm.invalid = true;
            } else if (dobYr % 4 == 0 && (dobYr % 100 != 0 || dobYr % 400 == 0)) {
                if (dobMonth == 2 && dobDay > 29) {
                    pdetailsANVm.disableNext = true;
                    pdetailsANVm.invalid = true;
                    pdetailsANVm.properDate = false;
                } else if (monthIndex != -1 && dobDay == 31) {
                    pdetailsANVm.disableNext = true;
                    pdetailsANVm.invalid = true;
                    pdetailsANVm.properDate = false;
                } else {
                    pdetailsANVm.disableNext = !isValid;
                    pdetailsANVm.invalid = false;
                    pdetailsANVm.properDate = true;
                }
            } else if (dobMonth == 2 && dobDay >= 29) {
                pdetailsANVm.disableNext = true;
                pdetailsANVm.invalid = true;
                pdetailsANVm.properDate = false;
            } else if (monthIndex != -1 && dobDay == 31) {
                pdetailsANVm.disableNext = true;
                pdetailsANVm.invalid = true;
                pdetailsANVm.properDate = false;
            } else {
                pdetailsANVm.disableNext = !isValid;
                pdetailsANVm.invalid = false;
                pdetailsANVm.properDate = true;
            }
            
            if(pdetailsANVm.personalDetailsDate  < 10  && pdetailsANVm.personalDetailsDate.length == 1 ){
            	 pdetailsANVm.disableNext = true;
                pdetailsANVm.invalid = true;
                pdetailsANVm.properDate = false;
            }
            if(pdetailsANVm.personalDetailsMonth < 10 && pdetailsANVm.personalDetailsMonth.length == 1 ){
            	 pdetailsANVm.disableNext = true;
                pdetailsANVm.invalid = true;
                pdetailsANVm.properDate = false;
            }
            return pdetailsANVm.properDate;
        }

        pdetailsANVm.checkAge = function() {
            pdetailsANVm.validDate = pdetailsANVm.validDateFormat();

            if (pdetailsANVm.validDate == true) {
                var fullDate = pdetailsANVm.personalDetailsMonth + '/' + pdetailsANVm.personalDetailsDate + '/' + pdetailsANVm.personalDetails.yob;

                var formattedDate = new Date();
                formattedDate.setFullYear(pdetailsANVm.personalDetails.yob, pdetailsANVm.personalDetailsMonth - 1, pdetailsANVm.personalDetailsDate);
                var todayDate = new Date();
                var currentYear = todayDate.getFullYear();
                var validYear = todayDate.setFullYear(currentYear - 18);
                pdetailsANVm.customerAge = validYear - formattedDate;
                pdetailsANVm.dob = fullDate;
                pdetailsANVm.disableNext = false;
            } else if (pdetailsANVm.validDate == false) {
                pdetailsANVm.disableNext = true;
            }
            return pdetailsANVm.customerAge;
        }

        pdetailsANVm.populateResumeNames = function() {
            if (!utilityService.isUndefined(aoService.customerAadhaarCardDetails.firstName)) {
                pdetailsANVm.firstName = aoService.customerAadhaarCardDetails.firstName;
            }
            if (!utilityService.isUndefined(aoService.customerAadhaarCardDetails.middleName)) {
                pdetailsANVm.isMName = true;
                pdetailsANVm.middleName = aoService.customerAadhaarCardDetails.middleName;
            }
            if (!utilityService.isUndefined(aoService.customerAadhaarCardDetails.lastName)) {
                pdetailsANVm.isLName = true;
                pdetailsANVm.lastName = aoService.customerAadhaarCardDetails.lastName;
            }
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            pdetailsANVm.personalDetails = {};
            pdetailsANVm.personalDetails.uid = aoService.customerAadhaarCardDetails.uid;
            pdetailsANVm.personalDetails.name = aoService.customerAadhaarCardDetails.name;
            pdetailsANVm.personalDetails.yob = aoService.customerAadhaarCardDetails.yob;
            pdetailsANVm.personalDetails.gender = pdetailsANVm.displayGender(aoService.customerAadhaarCardDetails.gender);
            pdetailsANVm.selectTitles = [];
            pdetailsANVm.loadTitles();
            pdetailsANVm.isLName = false;
            pdetailsANVm.isMName = false;
            if (aoService.isResumeJourney == false) {
                pdetailsANVm.displayNames(aoService.customerAadhaarCardDetails.name);
                pdetailsANVm.disableNextIfEmpty();
            } else {
                pdetailsANVm.populateResumeNames();
            }

            pdetailsANVm.populateDobAadhaar();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
