'use strict';

angularApp.controller('personalDetailsAddressController', ["$state",
    "$scope",
    "aoService",
    "utilityService",
    "personalDetailsService",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        aoService,
        utilityService,
        personalDetailsService,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var pdetailsAddressVm = this;
        var isAddressEmpty = false;

        function initPage() {
            pdetailsAddressVm.showBack = true;
            pdetailsAddressVm.showNext = true;
            if(aoService.isResumeJourney == false)
            pdetailsAddressVm.isChecked = false;
            pdetailsAddressVm.aofooter = true;
        }

        pdetailsAddressVm.goBacktoPrevious = function() {
            $state.go('menu.aDCityCountry');
        }

        pdetailsAddressVm.goToNextPage = function() {
            if (pdetailsAddressVm.isChecked) {
                aoService.correspondenceCheckStatus = true;
                pdetailsAddressVm.updateAadharDetailsCall('menu.pdetailsCAddress');
            } else {
                aoService.correspondenceCheckStatus = false;
                aoService.customerCorrespondenceAddress.address1 = "";
                aoService.customerCorrespondenceAddress.address2 = "";
                aoService.customerCorrespondenceAddress.pincode = "";
                aoService.customerCorrespondenceAddress.city = "";
                aoService.customerCorrespondenceAddress.state = "";
                aoService.customerCorrespondenceAddress.locality = "";
                pdetailsAddressVm.updateAadharDetailsCall('menu.panDetails');
            }
        }

        pdetailsAddressVm.setGender = function(){
            var genderDetails = {};
            if(aoService.customerAadhaarCardDetails.gender.toLowerCase() == "m" || aoService.customerAadhaarCardDetails.gender.toLowerCase() == constantConfig.acOp.maleGender){
                genderDetails.genderValue = "Male";
                genderDetails.genderCode = "M";
            }
            else if(aoService.customerAadhaarCardDetails.gender.toLowerCase() == "f" || aoService.customerAadhaarCardDetails.gender.toLowerCase() == constantConfig.acOp.femaleGender){
                genderDetails.genderValue = "Female";
                genderDetails.genderCode = "F";
            }
            else if(aoService.customerAadhaarCardDetails.gender.toLowerCase() == constantConfig.acOp.transGender){
                genderDetails.genderValue = "Transgender";
                genderDetails.genderCode = "T";
            }
            return genderDetails;
        }

        pdetailsAddressVm.updateAadharDetailsCall = function(navigationPage) {
            var genderDetails = pdetailsAddressVm.setGender();

            var requestParams = {
                "id": aoService.customer.mobileNo,
                "data": {
                    "personalDetails": {
                        "uid": aoService.customerAadhaarCardDetails.uid,
                        "name": aoService.customerAadhaarCardDetails.name,
                        "firstName": aoService.customerAadhaarCardDetails.firstName,
                        "middleName": aoService.customerAadhaarCardDetails.middleName,
                        "lastName": aoService.customerAadhaarCardDetails.lastName,
                        "title": aoService.customerAadhaarCardDetails.title,
                        "titleCode":aoService.customerAadhaarCardDetails.titleCode,
                        "gender": genderDetails.genderValue,
                        "genderCode":genderDetails.genderCode,
                        "dob": aoService.customerAadhaarCardDetails.dob,
                        "scannedCorrespondenceAddFlag":aoService.correspondenceCheckStatus,
                        "isAadhaarScanned": true,
                        "emailId" : aoService.customer.emailId,
                        "mobileNumber" : aoService.customer.mobileNo,
                        "nationality":aoService.customerAdditionalDetails.nationality,
                        "nationalityCode":aoService.customerAdditionalDetails.nationalityID,
                        "citizenship": aoService.customerAdditionalDetails.citizenship,
                        "citizenshipCode": aoService.customerAdditionalDetails.citizenshipID,
                        "cityOfBirth": aoService.customerAdditionalDetails.cityOfBirth,
                        "placeOfBirth": aoService.customerAdditionalDetails.cityOfBirth,
                        "countryOfBirth": aoService.customerAdditionalDetails.countryOfBirth,
                        "address": [{
                            "type": "aadhaar",
                            "addressLine1": pdetailsAddressVm.concatAddressLine1(),
                            "addressLine2": pdetailsAddressVm.concatAddressLine2(),
                            "pincode": aoService.customerAadhaarCardDetails.pc,
                            "city": aoService.customerAadhaarCardDetails.dist,
                            "cityCode":"",
                            "state": aoService.customerAadhaarCardDetails.state,
                            "stateCode":"",
                            "locality": ""
                        }]
                    },
                    "additionalDetails":{
                        "cityOfBirth": aoService.customerAdditionalDetails.cityOfBirth,
                        "placeOfBirth": aoService.customerAdditionalDetails.cityOfBirth,
                        "countryOfBirth": aoService.customerAdditionalDetails.countryOfBirth
                    },
                    "commonId": $state.$current.data.commonId
                }
            }
            personalDetailsService.updateAadhaarDetails(requestParams).then(function(response) {
                $state.go(navigationPage);
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        pdetailsAddressVm.updateAadhaarLink = function() {
            $state.go('menu.updateAadhaar');
        }

        pdetailsAddressVm.concatAadharAddress = function() {
            var fullAddr = "";
            if (aoService.isResumeJourney == false) {
                fullAddr = aoService.nullCheck(aoService.customerAadhaarCardDetails.house) + aoService.nullCheck(aoService.customerAadhaarCardDetails.street) + aoService.nullCheck(aoService.customerAadhaarCardDetails.lm) + aoService.nullCheck(aoService.customerAadhaarCardDetails.loc) + aoService.nullCheck(aoService.customerAadhaarCardDetails.vtc) + aoService.nullCheck(aoService.customerAadhaarCardDetails.po) + aoService.nullCheck(aoService.customerAadhaarCardDetails.dist) + aoService.nullCheck(aoService.customerAadhaarCardDetails.state);
            } else {
                fullAddr = aoService.nullCheck(aoService.customerAadhaarCardDetails.addressLine1) + aoService.nullCheck(aoService.customerAadhaarCardDetails.addressLine2);
            }
            var index = fullAddr.lastIndexOf(",");
            fullAddr = fullAddr.substring(0, index) + fullAddr.substring(index + 1);
            return fullAddr;
        }

        pdetailsAddressVm.concatAddressLine1 = function() {
            var addressLine1 = "";
            addressLine1 = aoService.nullCheck(aoService.customerAadhaarCardDetails.house) + aoService.nullCheck(aoService.customerAadhaarCardDetails.street);
            var index = addressLine1.lastIndexOf(",");
            addressLine1 = addressLine1.substring(0, index) + addressLine1.substring(index + 1);
            return addressLine1;
        }

        pdetailsAddressVm.concatAddressLine2 = function() {
            var addressLine2 = "";
            addressLine2 = aoService.nullCheck(aoService.customerAadhaarCardDetails.lm) + aoService.nullCheck(aoService.customerAadhaarCardDetails.loc) + aoService.nullCheck(aoService.customerAadhaarCardDetails.vtc) + aoService.nullCheck(aoService.customerAadhaarCardDetails.po) + aoService.nullCheck(aoService.customerAadhaarCardDetails.dist) + aoService.nullCheck(aoService.customerAadhaarCardDetails.state);
            var index = addressLine2.lastIndexOf(",");
            addressLine2 = addressLine2.substring(0, index) + addressLine2.substring(index + 1);
            return addressLine2;
        }

        pdetailsAddressVm.checkForAddressLine1 = function() {
            var customerAddressLine1 = "";
            if (utilityService.isUndefined(aoService.customerAadhaarCardDetails.house) && utilityService.isUndefined(aoService.customerAadhaarCardDetails.street)) {
                customerAddressLine1 = "";
            } else {
                customerAddressLine1 = aoService.nullCheck(aoService.customerAadhaarCardDetails.house) + aoService.nullCheck(aoService.customerAadhaarCardDetails.street);
            }
            return customerAddressLine1;
        }

        pdetailsAddressVm.checkForAddressLine2 = function() {
            var customerAddressLine2 = "";
            if (utilityService.isUndefined(aoService.customerAadhaarCardDetails.lm) && utilityService.isUndefined(aoService.customerAadhaarCardDetails.vtc) && utilityService.isUndefined(aoService.customerAadhaarCardDetails.loc)) {
                customerAddressLine2 = "";
            } else {
                customerAddressLine2 = aoService.nullCheck(aoService.customerAadhaarCardDetails.lm) + aoService.nullCheck(aoService.customerAadhaarCardDetails.loc) + utilityService.isUndefined(aoService.customerAadhaarCardDetails.vtc);
            }
            return customerAddressLine2;
        }

        //Abort the process if the address is empty and navigate to map page
        pdetailsAddressVm.abortIfAddressEmpty = function() {
            if (utilityService.isUndefined(pdetailsAddressVm.concatAadharAddress()) || utilityService.isUndefined(pdetailsAddressVm.checkForAddressLine1()) || utilityService.isUndefined(pdetailsAddressVm.checkForAddressLine2())) {
                var title = '';
                var template = '{{"AADHAAR_ADDRESS_IF_EMPTY" | translate}}';
                var onTap = 'menu.locateNearestBranch';
                var buttontext = 'Locate Nearest Branch';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                pdetailsAddressVm.showNext = false;
                isAddressEmpty = true;
            }
            else{
                pdetailsAddressVm.showNext = true;
            }
            return isAddressEmpty;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            pdetailsAddressVm.personalDetails = {
                address: pdetailsAddressVm.concatAadharAddress(),
                pincode: aoService.customerAadhaarCardDetails.pc,
                city: aoService.customerAadhaarCardDetails.dist,
                state: aoService.customerAadhaarCardDetails.state,
            };
            pdetailsAddressVm.isChecked = aoService.correspondenceCheckStatus;
            /*if (aoService.isResumeJourney == false) {
                pdetailsAddressVm.abortIfAddressEmpty();
            }*/

            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);

        });

        return this;
    }
]);
