'use strict';

angularApp.controller('personalDetailsCAddressController', ["$state",
    "$scope",
    "$ionicHistory",
    "aoService",
    "pdetailsCAddressService",
    "utilityService",
    "$translate",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        $ionicHistory,
        aoService,
        pdetailsCAddressService,
        utilityService,
        $translate,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var pdetailsCAddressVm = this;

        function initPage() {
            pdetailsCAddressVm.showBack = true;
            pdetailsCAddressVm.showNext = true;
            pdetailsCAddressVm.disableNext = true;
            pdetailsCAddressVm.aofooter = true;
            pdetailsCAddressVm.disableCity = true;
            pdetailsCAddressVm.disableState = true;
            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                pdetailsCAddressVm.okBtntext = translatedvalue;
            });
        }

        pdetailsCAddressVm.goBacktoPrevious = function() {
            if (aoService.isAadharManualEntry == false && aoService.correspondenceCheckStatus == true) {
                $state.go("menu.pdetailsAddress");
            }
        }

        $scope.$watch("pdetailsCAddressVm.pdetailsCForm.$valid", function(value) {
            if (value === true) {
                pdetailsCAddressVm.disableNext = false;
            } else {
                pdetailsCAddressVm.disableNext = true;
            }
        });

        pdetailsCAddressVm.goToNextPage = function() {

            if (aoService.isAadharManualEntry == false && aoService.correspondenceCheckStatus == true) {
                //Service to update corresspondence address
                aoService.customerCorrespondenceAddress.address1 = pdetailsCAddressVm.addressAboveData;
                aoService.customerCorrespondenceAddress.address2 = pdetailsCAddressVm.addressBelowData;
                aoService.customerCorrespondenceAddress.pincode = pdetailsCAddressVm.pincodeData;
                aoService.customerCorrespondenceAddress.city = pdetailsCAddressVm.cityData;
                aoService.customerCorrespondenceAddress.state = pdetailsCAddressVm.stateData;
                aoService.customerCorrespondenceAddress.locality = pdetailsCAddressVm.localityData;
                pdetailsCAddressVm.ifAadharScanAddressUpdate();
            }
        }

        pdetailsCAddressVm.ifAadharScanAddressUpdate = function() {
            var requestParams1 = {
                "id": aoService.customer.mobileNo,
                "data": {
                    "personalDetails": {
                        "isAadhaarScanned": true,
                        "address": [{
                            "type": "CORRESPONDENCE",
                            "addressLine1": aoService.customerCorrespondenceAddress.address1,
                            "addressLine2": aoService.customerCorrespondenceAddress.address2,
                            "pincode": aoService.customerCorrespondenceAddress.pincode,
                            "city": aoService.customerCorrespondenceAddress.city,
                            "cityCode": aoService.customerCorrespondenceAddress.cityCode,
                            "state": aoService.customerCorrespondenceAddress.state,
                            "stateCode": aoService.customerCorrespondenceAddress.stateCode,
                            "locality": aoService.customerCorrespondenceAddress.locality
                        }]
                    },
                    "commonId": $state.$current.data.commonId
                }
                
            }
            
            pdetailsCAddressService.updateCorrespondenceAddress(requestParams1).then(function(response) {
                if (response.responseCode === constantConfig.successCode) {
                    $state.go('menu.panDetails');
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        pdetailsCAddressVm.changefn = function(param) {
            pdetailsCAddressVm.disableNext = !param;
        }

        pdetailsCAddressVm.updatedvalue = function(param) {
            (param) ? pdetailsCAddressVm.disableNext = false: pdetailsCAddressVm.disableNext = true;
            return pdetailsCAddressVm.disableNext;
        }

        pdetailsCAddressVm.pincodeChange = function() {
            var pincodevalue = (!utilityService.isUndefined(pdetailsCAddressVm.pincodeData));
            if (pdetailsCAddressVm.pincodeData === "" || (!utilityService.isUndefined(pdetailsCAddressVm.pincodeData)).length != 6) {
                pdetailsCAddressVm.cityData = "";
                pdetailsCAddressVm.stateData = "";
            }
        }

        //Service to return city and state based on the pincode entered 
        pdetailsCAddressVm.updatearea = function(param) {
            var inputparams = {
                "pinCode": pdetailsCAddressVm.pincodeData
            }
            if (pdetailsCAddressVm.pdetailsCForm.pincode.$valid === true && !utilityService.isUndefined(pdetailsCAddressVm.pincodeData)) {
                pdetailsCAddressService.getAreaDetailForPincode(inputparams).then(function(data) {
                    if (utilityService.isUndefined(data)) {
                        var title = '';
                        var template = '{{"PINCODE_MATCH" | translate}}';
                        var onTap = '';
                        var buttontext = '<b>' + pdetailsCAddressVm.okBtntext + '</b>';
                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                        pdetailsCAddressVm.disableState = false;
                        pdetailsCAddressVm.disableCity = false;
                        pdetailsCAddressVm.stateList = "";
                    } else if (!utilityService.isUndefined(data.cityName) && !utilityService.isUndefined(data.stateName)) {
                        pdetailsCAddressVm.stateList = data;
                        aoService.customer.city = utilityService.getValue(data.cityName);
                        aoService.customer.state = utilityService.getValue(data.stateName);
                        aoService.customerCorrespondenceAddress.cityCode = utilityService.getValue(data.cityCode);
                        aoService.customerCorrespondenceAddress.stateCode = utilityService.getValue(data.stateCode);
                        pdetailsCAddressVm.cityData = aoService.customer.city;
                        pdetailsCAddressVm.stateData = aoService.customer.state;
                        pdetailsCAddressVm.disableCity = true;
                        pdetailsCAddressVm.disableState = true;

                    }
                }, function(error) {
                	pdetailsCAddressVm.stateList = "";
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else if (pdetailsCAddressVm.pincodeData === "" || (!utilityService.isUndefined(pdetailsCAddressVm.pincodeData)).length != 6) {
                pdetailsCAddressVm.cityData = "";
                pdetailsCAddressVm.stateData = "";
            }

        }

        pdetailsCAddressVm.checkUpdatedCityStateValid = function(param) {
            pdetailsCAddressVm.updatedvalue(param);
        }

        pdetailsCAddressVm.populateResumeData = function() {
            if (aoService.customerCorrespondenceAddress.isAadhaarScanned == true) {
                pdetailsCAddressVm.addressAboveData = aoService.customerCorrespondenceAddress.address1;
                pdetailsCAddressVm.addressBelowData = aoService.customerCorrespondenceAddress.address2;
                pdetailsCAddressVm.pincodeData = aoService.customerCorrespondenceAddress.pincode;
                pdetailsCAddressVm.cityData = aoService.customerCorrespondenceAddress.city;
                pdetailsCAddressVm.stateData = aoService.customerCorrespondenceAddress.state;
                pdetailsCAddressVm.localityData = aoService.customerCorrespondenceAddress.locality;
            }
        };
        
        pdetailsCAddressVm.setstate = function(data) {
					var arr = pdetailsCAddressVm.stateList;
					if(data){
						var arrLength = arr.length;	
					for (var i = 0; i < arrLength; i++) {
						if (arr[i].stateCode == data) {
							var tempData = arr[i];
							aoService.customer.city = utilityService.getValue(data.cityName);
	                        aoService.customer.state = utilityService.getValue(data.stateName);
	                        aoService.customerCorrespondenceAddress.cityCode = utilityService.getValue(data.cityCode);
	                        aoService.customerCorrespondenceAddress.stateCode = utilityService.getValue(data.stateCode);
	                        pdetailsCAddressVm.cityData = aoService.customer.city;
	                        pdetailsCAddressVm.stateData = aoService.customer.state;
	                        pdetailsCAddressVm.disableCity = true;
	                        pdetailsCAddressVm.disableState = true;
						}
					};
					}else{
						pdetailsCAddressVm.stateData = "";
						aoService.customerCorrespondenceAddress.state = "";
					}
			};  

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            pdetailsCAddressVm.populateResumeData();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
