'use strict';

angularApp.controller('productOfferingController', ["$state",
    "$scope",
    "productOfferingService",
    "aoService",
    "utilityService",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        productOfferingService,
        aoService,
        utilityService,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var productOfferingVm = this;

        function initPage() {
            productOfferingVm.showBack = true;
            productOfferingVm.showNext = true;
            productOfferingVm.aofooter = true;
            if(aoService.isResumeJourney == false)
            productOfferingVm.isChecked = true;
            productOfferingVm.loadOtherProductOffers();
        }

        productOfferingVm.goBacktoPrevious = function(){
            $state.go('menu.termsAndConditions');
        }
        
        productOfferingVm.goToNextPage = function() {
            productOfferingVm.postPODetails();
        }

        productOfferingVm.loadOtherProductOffers = function(){
            productOfferingService.getOtherProductOfferings().then(function(data) {
                productOfferingVm.productOfferingContent = data;
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        productOfferingVm.postPODetails = function(){
            aoService.productOfferingFlag = productOfferingVm.isChecked;
            var requestParams = {
                "id" : aoService.customer.mobileNo,                
                "data":{
                    "commonId":$state.$current.data.commonId,
                    "productOfferingFlag" : productOfferingVm.isChecked
                }
            }
            
            productOfferingService.postProdOffers(requestParams).then(function(response) {
               
                if(response.responseCode == constantConfig.successCode){
                    
                    /*if(!utilityService.isUndefined(aoService.tncOtpValue)){
                        $state.go('menu.debitCardDetails');
                    }
                    else{*/
                        $state.go('menu.enterOTP');
                    /*}*/
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        productOfferingVm.populateResumeData = function(){
            productOfferingVm.isChecked = aoService.productOfferingFlag;
        }
        
        $scope.goToHome = function() {
            aoService.homeNav();
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            if(aoService.isResumeJourney == true){
                productOfferingVm.populateResumeData();
            }
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
