'use strict';

angularApp.controller('receiveDebitCardController', ["$state",
    "$scope",
    "receiveDebitCardService",
    "aoService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        receiveDebitCardService,
        aoService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var receiveDebitCardVm = this;

        function initPage() {
            receiveDebitCardVm.showBack = true;
            receiveDebitCardVm.showNext = true;
            receiveDebitCardVm.disableNext = true;
            receiveDebitCardVm.aofooter = true;
            receiveDebitCardVm.selectedMethod = "";
        }

        receiveDebitCardVm.goBacktoPrevious = function() {
            $state.go('menu.debitCardDetails');
        }

        receiveDebitCardVm.goToNextPage = function() {
           receiveDebitCardVm.getReferenceNumber();
        }

        receiveDebitCardVm.receiveDebitCardDetails = function(){
             var arr = [{
             	"name" : aoService.debitCardDetails.firstName
             }];
             var requestParams = {
                "id" : aoService.customer.mobileNo,                
                "data":{
                    "cardReadyForCollection":receiveDebitCardVm.selectedMethod,
                    "debitCardFirstName" : aoService.debitCardDetails.firstName,
                    "kit" : arr,
                    "debitCardLastName" : aoService.debitCardDetails.lastName,
                    "commonId":$state.$current.data.commonId
                }
            }
            receiveDebitCardService.receiveDebitCard(requestParams).then(function(response) {
                
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        receiveDebitCardVm.getReferenceNumber = function(){
            var requestParams = {
                "id" : aoService.customer.mobileNo,                
                "data":{
                    "commonId":$state.$current.data.commonId
                }
            }
            receiveDebitCardService.getReferenceNo(requestParams).then(function(response) {
                receiveDebitCardVm.receiveDebitCardDetails();
                aoService.customer.referenceCode = utilityService.getValue(response.data.referenceCode);
                $state.go('menu.enterOTPReferenceCode');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        receiveDebitCardVm.atSBI = function() {
            receiveDebitCardVm.isSBIClicked = true;
            receiveDebitCardVm.disableNext = false;
            receiveDebitCardVm.selectedMethod = "Intouch";
        }

        receiveDebitCardVm.atCorrespondence = function() {
            receiveDebitCardVm.isSBIClicked = false;
            receiveDebitCardVm.disableNext = false;
            receiveDebitCardVm.selectedMethod = "correspondance";
        }

        receiveDebitCardVm.populateResumeData = function(){
            receiveDebitCardVm.selectedMethod = aoService.cardReadyForCollection;
            if(receiveDebitCardVm.selectedMethod == "Intouch"){
                receiveDebitCardVm.isSBIClicked = true;
            }
            else if(receiveDebitCardVm.selectedMethod == "correspondance"){
                receiveDebitCardVm.isSBIClicked = false;
            }
            receiveDebitCardVm.disableNext = false;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            if(aoService.isResumeJourney == true){
                receiveDebitCardVm.populateResumeData();
            }
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            
        });

        return this;
    }
]);
