'use strict';

angularApp.controller('regenerateAppPasswordController', ["$state",
    "$scope",
    "aoService",
    "utilityService",
    "regenerateAppPasswordService",
    "$ionicPopover",
    "$cordovaDevice",
    "cryptoService",
    "encryptionService",
    "constantConfig",
    "$translate",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        aoService,
        utilityService,
        regenerateAppPasswordService,
        $ionicPopover,
        $cordovaDevice,
        cryptoService,
        encryptionService,
        constantConfig,
        $translate,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var regenerateAppPasswordVm = this;
        function initPage() {
            regenerateAppPasswordVm.showBack = false;
            regenerateAppPasswordVm.showNext = true;
            regenerateAppPasswordVm.reAppPasswordCheck = false;
            regenerateAppPasswordVm.disableNext = true;
            regenerateAppPasswordVm.aofooter = true;
            //To get the device Operating system
            var deviceOs = $cordovaDevice.getPlatform();
            var deviceUid = $cordovaDevice.getUUID();
            aoService.customer.deviceOS = deviceOs;
            aoService.customer.deviceUid = deviceUid;
            regenerateAppPasswordVm.encoded = '';
             $translate('AO_OK_LABEL').then(function(translatedvalue) {
                regenerateAppPasswordVm.okBtntext = translatedvalue;
            });
        }

        /* Info Popup */
        var template = '<ion-popover-view class="ao-tooltip ao-popupInfo roboto-regular ao-passwordHt">' + '<ion-content>' +
                        '<div class="" translate="APP_NOTIFICATION"></div>' + '</ion-content>' + '</ion-popover-view>';

        $scope.popover = $ionicPopover.fromTemplate(template, {
            scope: $scope
        });

        regenerateAppPasswordVm.infoPopup = function($event) {
            $scope.popover.show($event);
        };

        regenerateAppPasswordVm.closePopover = function() {
            $scope.popover.hide();
        };
       /* Info Popup */

        regenerateAppPasswordVm.goToNextPage = function() {
            //var hashedAppPassword = cryptoService.getSHA512EncryptedData(regenerateAppPasswordVm.appPasswordData);
            //regenerateAppPasswordVm.encoded = encryptionService.getAES256EncryptedData(regenerateAppPasswordVm.appPasswordData);
            regenerateAppPasswordVm.encoded = regenerateAppPasswordVm.appPasswordData;
            aoService.appPassword = regenerateAppPasswordVm.encoded;
            var requestParams = {
                "id": aoService.customer.mobileNo,
                "data": {
                    "auth" : {
                        "password" :regenerateAppPasswordVm.encoded
                    }
                }
            }
            regenerateAppPasswordService.registerCustomer(requestParams).then(function(response) {
                aoService.customer.lotusId = utilityService.getValue(response.data.lotusId);
                var responseCode = response.responseCode;
                if (responseCode === constantConfig.successCode) {
                    var title = '';
                    var template = 'Your password is changed successfully. Please login again.';
                    var onTap = 'menu.applyNewOrResume';
                    var buttontext = '<b>' + regenerateAppPasswordVm.okBtntext + '</b>';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                }

            }, function(error) {
               utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        regenerateAppPasswordVm.changePassword = function() {
            if (regenerateAppPasswordVm.reAppPasswordData !== regenerateAppPasswordVm.appPasswordData) {
                regenerateAppPasswordVm.reAppPasswordData = "";
                regenerateAppPasswordVm.reAppPasswordCheck = true;
                regenerateAppPasswordVm.disableNext = true;
                return true;
            }
            regenerateAppPasswordVm.reAppPasswordCheck = false;
            return true;
        }


        regenerateAppPasswordVm.changeCPassword = function() {
            if (regenerateAppPasswordVm.reAppPasswordData !== regenerateAppPasswordVm.appPasswordData) {
                regenerateAppPasswordVm.reAppPasswordCheck = false;
            }
            return true;
        }

        regenerateAppPasswordVm.proceedSuccess = function(isValid) {
            isValid ? regenerateAppPasswordVm.disableNext = false : regenerateAppPasswordVm.disableNext = true;
            return regenerateAppPasswordVm.disableNext;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
