'use strict';

angularApp.controller('selectBranchListGpsController', ["$state",
    "$scope",
    "selectBranchListService",
    "aoService",
    "utilityService",
    "currentLocationService",
    "$timeout",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        selectBranchListService,
        aoService,
        utilityService,
        currentLocationService,
        $timeout,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var selectBranchListGpsVm = this;

        function initPage() {
            selectBranchListGpsVm.showBack = true;
            selectBranchListGpsVm.showNext = true;
            selectBranchListGpsVm.disableNext = true;
            selectBranchListGpsVm.showRadioBtn = true;
            selectBranchListGpsVm.showLink = false;
            selectBranchListGpsVm.aofooter = true;
            selectBranchListGpsVm.gpsLink = true;
        }

        selectBranchListGpsVm.goBacktoPrevious = function() {
            $state.go('menu.selectBranchOption');
        }

        selectBranchListGpsVm.goToNextPage = function() {
            var requestParams = {
                "id": aoService.customer.mobileNo,
                "data": {
                    "homeBranch": {
                        "city": "",
                        "branchId": aoService.homeBranchGpsId
                    },
                    "commonId": $state.$current.data.commonId
                }
            }
            selectBranchListService.setSelectedBranch(requestParams).then(function(response) {
                $state.go('menu.termsAndConditions');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        selectBranchListGpsVm.validateForm = function(isValid) {
            if (isValid) {
                selectBranchListGpsVm.disableNext = false;
            }
        }

        selectBranchListGpsVm.selectedBranch = function(param) {
            aoService.branchname = param.branchName;
            aoService.branchaddress = param.address;
            aoService.homeBranchGpsId = param.id;
        }

        //Make the radio button checked if the respective div is clicked
        selectBranchListGpsVm.checkDiv = function(param) {
            selectBranchListGpsVm.branchList = param.id;
            selectBranchListGpsVm.disableNext = false;
            aoService.homeBranchGpsId = param.id;
        }

        //Service for displaying branch list for latitude and longitude
        selectBranchListGpsVm.loadBranchesGps = function() {            
            selectBranchListGpsVm.bankListGps = aoService.selectByGPS;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        $scope.$on('$ionicView.beforeEnter', function() {
            selectBranchListGpsVm.loadBranchesGps(); 
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn); 
        });

        return this;
    }
]);
