'use strict';

angularApp.controller('selectBranchListLocController', ["$state",
    "$scope",
    "selectBranchListService",
    "aoService",
    "utilityService",
    "$ionicHistory",
    "$translate",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        selectBranchListService,
        aoService,
        utilityService,
        $ionicHistory,
        $translate,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var selectBranchListLocVm = this;

        function initPage() {
            selectBranchListLocVm.showBack = true;
            selectBranchListLocVm.showNext = true;
            selectBranchListLocVm.disableNext = true;
            selectBranchListLocVm.bankListLocality = [];
            selectBranchListLocVm.aofooter = true;
            selectBranchListLocVm.showRadioBtn = true;
            selectBranchListLocVm.showLink = false;
            selectBranchListLocVm.localityname = "";
            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                selectBranchListLocVm.okBtntext = translatedvalue;
            });
        }

        selectBranchListLocVm.goBacktoPrevious = function() {
            //$ionicHistory.goBack();
            $state.go("menu.selectBranchOption");
        }

        selectBranchListLocVm.goToNextPage = function() {
            //if (aoService.localityNav === "selectBranch") {
            var requestParams = {
                "id": aoService.customer.mobileNo,
                "data": {
                    "homeBranch": {
                        "city": aoService.homeBranchLocalityCity,
                        "branchId": aoService.homeBranchLocalityId
                    },
                    "commonId": $state.$current.data.commonId
                }
            }
            selectBranchListService.setSelectedBranch(requestParams).then(function(response) {
                $state.go('menu.termsAndConditions');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

        }

        selectBranchListLocVm.getCountriesList = function(locality) {
            selectBranchListService.getAllCities().then(function(body) {
                if (!utilityService.isUndefined(body)) {
                    for (var i = 0; i < body.length; i++) {
                        selectBranchListLocVm.displayCities.push(body[i]);
                        selectBranchListLocVm.displayCities.sort();
                    }
                }
                selectBranchListLocVm.showHideFilterDropDown(locality);

            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }


        selectBranchListLocVm.onChangeFn = function(value) {
            if (!utilityService.isUndefined(value)) {
                if (value.length == 3) {
                    selectBranchListLocVm.loadBranchesLocality();
                }
            } else {
                selectBranchListLocVm.bankListLocality = [];
                selectBranchListLocVm.disableNext = true;
            }

        }

        selectBranchListLocVm.showHideFilterDropDown = function(city) {
            if (!utilityService.isUndefined(city)) {
                selectBranchListLocVm.localityname = city;
                selectBranchListLocVm.loadBranchesLocality();
            } else {
                selectBranchListLocVm.hideOptions = false;
            }
            selectBranchListLocVm.onclickValidation();
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        //Make the radio button checked if the respective div is clicked
        selectBranchListLocVm.checkDiv = function(param) {
            selectBranchListLocVm.branchList = param.id;
            selectBranchListLocVm.disableNext = false;
            aoService.homeBranchLocalityId = param.id;
        }

        selectBranchListLocVm.changeLoc = function(locModel, isValid) {
            if (utilityService.isUndefined(locModel)) {
                selectBranchListLocVm.bankListLocality = [];
                selectBranchListLocVm.disableNext = true;
                aoService.homeBranchLocalityId = '';
                aoService.homeBranchLocalityCity = '';
            }
        }

        selectBranchListLocVm.onclickValidation = function(isValid) {
            selectBranchListLocVm.hideOptions = true;
            for (var i = 0; i < selectBranchListLocVm.displayCities.length; i++) {
                if (!utilityService.isUndefined(selectBranchListLocVm.localityname)) {
                    if (selectBranchListLocVm.displayCities[i].toLowerCase() == selectBranchListLocVm.localityname.toLowerCase()) {
                        selectBranchListLocVm.loadBranchesLocality();
                    }
                } else {
                    selectBranchListLocVm.bankListLocality = [];
                    selectBranchListLocVm.disableNext = true;
                }

            }
        }

        selectBranchListLocVm.validateForm = function(isValid) {
            if (isValid) {
                selectBranchListLocVm.disableNext = false;
            } else {
                selectBranchListLocVm.disableNext = true;
            }
        }

        selectBranchListLocVm.selectedBranch = function(param) {
            aoService.branchname = param.branchName;
            aoService.branchaddress = param.address;
            aoService.homeBranchLocalityId = param.id;
        }

        //Service for displaying branch list for locality
        selectBranchListLocVm.loadBranchesLocality = function() {
            selectBranchListLocVm.hideOptions = false;
            selectBranchListLocVm.bankListLocality.length = 0;
            var params = {
                "locality": selectBranchListLocVm.localityname
            }
            aoService.homeBranchLocalityCity = selectBranchListLocVm.localityname;
            selectBranchListService.getBranchesForLocality(params).then(function(data) {
                
                if (utilityService.isUndefined(data)) {
                    var title = '';
                    var template = '{{"BRANCH_UNAVLBL" | translate}}';
                    var onTap = 'menu.selectBranchListLocality';
                    var buttontext = '<b>' + selectBranchListLocVm.okBtntext + '</b>';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                } else {
                    if (data.branches.length == 0) {
                        var title = '';
                        var template = '{{"BRANCH_UNAVLBL" | translate}}';
                        var onTap = 'menu.selectBranchListLocality';
                        var buttontext = '<b>' + selectBranchListLocVm.okBtntext + '</b>';
                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                    } else {
                        for (var i = 0; i < data.branches.length; i++) {
                            selectBranchListLocVm.bankListLocality.push(data.branches[i]);
                            if (selectBranchListLocVm.bankListLocality[i].id == aoService.homeBranchLocalityId) {
                               
                                selectBranchListLocVm.branchList = selectBranchListLocVm.bankListLocality[i].id;
                                selectBranchListLocVm.disableNext = false;
                            }
                        }
                    }

                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            selectBranchListLocVm.displayCities = [];
            //selectBranchListLocVm.getCountriesList();
            selectBranchListLocVm.localityname = aoService.homeBranchLocalityCity;
           
            if (!utilityService.isUndefined(selectBranchListLocVm.localityname)) {
                selectBranchListLocVm.loadBranchesLocality();
            } else if (utilityService.isUndefined(selectBranchListLocVm.localityname)) {
                selectBranchListLocVm.bankListLocality = [];
                selectBranchListLocVm.disableNext = true;
                aoService.homeBranchLocalityId = '';
                aoService.homeBranchLocalityCity = '';

            }
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);         
            if(aoService.preJTSixdata.isLocalBanchLoaded){
            	if(aoService.isPreJTSixStarted){
		            if(aoService.preJTSixdata.homeBranch && (aoService.preJTSixdata.homeBranch  != aoService.homeBranchLocalityCity)){
		            	selectBranchListLocVm.localityname = aoService.preJTSixdata.homeBranch;
		            	var data = aoService.preJTSixdata.homeBranch;
		            	data = data.split('');
		            	if(data.length > 0){
		            		data.length = 3;
		            	}
		            	selectBranchListLocVm.onChangeFn(data);
		            }
            }
            aoService.preJTSixdata.isLocalBanchLoaded = false;
            }
        });
        return this;
    }
]);
