'use strict';

angularApp.service('selectBranchListService',
    function($q, AdapterUtils, constantConfig) {

        var selectBranchListService = this;

        selectBranchListService.getBranchesForGeo = function(params) {

            var q = $q.defer(); 
            AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.getBranchesForGeo + params.longitude + "&latitude=" + params.latitude + "&branchLocator=" + params.branchLocator, false).then(

                function(response){ 
                    q.resolve(response.data);
                },
                function(error){    
                    q.reject(error);
                }
            );
            return q.promise;
        };

        selectBranchListService.getBranchesForLocality = function(params) {
           
             var q = $q.defer(); 
             AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.getBranchesForLocality, params, true).then(
                function(response){ 
                    q.resolve(response.data);
                },
                function(error){    
                    q.reject(error);
                }
            );
            return q.promise;

        };

         selectBranchListService.setSelectedBranch = function(requestParams) {
           
             var q = $q.defer(); 
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.setSelectedBranch, requestParams, true).then(
                function(response){ 
                    q.resolve(response);
                },
                function(error){    
                    q.reject(error);
                }
            );
            return q.promise;

        };

        selectBranchListService.getAllCities = function() {
           
             var q = $q.defer(); 
             AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.getAllCities, true).then(
                function(response){ 
                    q.resolve(response.body);
                },
                function(error){    
                    q.reject(error);
                }
            );
            return q.promise;


        };


        return selectBranchListService;
    });
