'use strict';

angularApp.controller('selectBranchOptionController', ["$state",
    "$scope",
    "aoService",
    "$ionicHistory",
    "$translate",
    "currentLocationService",
    "utilityService",
    "selectBranchListService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        aoService,
        $ionicHistory,
        $translate,
        currentLocationService,
        utilityService,
        selectBranchListService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var selectBranchOptionVm = this;

        function initPage() {
            selectBranchOptionVm.showBack = true;
            selectBranchOptionVm.showNext = true;
            selectBranchOptionVm.disableNext = true;
            selectBranchOptionVm.aofooter = true;
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                selectBranchOptionVm.okBtntext = translatedvalue;  
            });
        }

        selectBranchOptionVm.goBacktoPrevious = function() {
          
                if(parseInt(aoService.nomineeAadhaarCardDetails.age) < 18 || parseInt(aoService.nominee.age) < 18){
                    if(aoService.nominee.guardianAddressFlag == "nomineeAddress"){
                        $state.go("menu.nomineeEnteredAddress");
                    }
                    else if(aoService.nominee.guardianAddressFlag == "applicantAddress"){
                        $state.go("menu.nomineeAddress");
                    }
                    else if(aoService.nominee.guardianAddressFlag == "newAddress"){
                        $state.go("menu.nomineeCAddress");
                    }
                    else{
                        $state.go("menu.nomineeDetailsAddressOption");
                    }
                }
                else{
                    $state.go("menu.nomineeDetailsNext");
                }
          
        }

        selectBranchOptionVm.goToNextPage = function() {            
            if (selectBranchOptionVm.isGpsClicked === true) {
                $state.go('menu.selectBranchListGps');
            } else {
                $state.go('menu.selectBranchListLocality');
            }
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        selectBranchOptionVm.bylocality = function() {
            selectBranchOptionVm.isGpsClicked = false;
            aoService.isGpsClicked = false;
            selectBranchOptionVm.disableNext = false;
        }

        selectBranchOptionVm.bygps = function() {  
             CheckGPS.check(function(){
                currentLocationService.getCurrentPosition().then(
                function(position) {
                    var latitude = position.coords.latitude;
                    var longitude = position.coords.longitude;
                    /*var latNew = latitude.toFixed(1);
                    var lonNew = longitude.toFixed(1);*/
                    aoService.customer.latitude = latitude;
                    aoService.customer.longitude = longitude;
                    aoService.selectByGPS.length = 0; 
                    var params = {
                        "latitude": aoService.customer.latitude,
                        "longitude": aoService.customer.longitude
                    }
                    if(utilityService.isUndefined(aoService.selectByGPS) || aoService.selectByGPS.length === 0){
                        selectBranchListService.getBranchesForGeo(params).then(function(data) {
                            if(!utilityService.isUndefined(data)){
                                for (var i = 0; i < data.branches.length; i++) {
                                    aoService.selectByGPS.push(data.branches[i]);
                                    setTimeout(function() { 
                                   
                                    if(aoService.selectByGPS.length == 0){
                                        var title = '';
                                        var template = '{{"UNABLE_TO_GET_BRANCH" | translate}}';
                                        var onTap = 'menu.selectBranchOption';
                                        var buttontext = 'OK';
                                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                                    }
                                }, 300);
                                }
                            }                            
                        }, function(error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    }
                    else{
                        
                    }
                },
                function(err) {
                    var title = '';
                    var template = 'Please turn on GPS in your mobile to select branch by GPS';
                    var onTap = '';
                    var buttontext = '<b>' + selectBranchOptionVm.okBtntext + '</b>';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                }
            );   
            },
            function(){
                var title = '';
                var template = '{{"ENABLE_GPS" | translate}}';
                var onTap = '';
                var buttontext = 'OK';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            });                    
            selectBranchOptionVm.isGpsClicked = true;
            aoService.isGpsClicked = true;
            selectBranchOptionVm.disableNext = false;
        }

        selectBranchOptionVm.validateform = function(isValid) {
            selectBranchOptionVm.disableNext = false;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            aoService.localityNav = "selectBranch";
            aoService.localityNextDisable="selectBranchList";
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn); 
        });

        return this;
    }
]);
