'use strict';

angularApp.controller('taxController', ["$state",
    "$scope",
    "aoService",
    "taxService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        aoService,
        taxService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var taxVm = this;

        function initPage() {
            taxVm.showBack = false;
            taxVm.showNext = false;
            taxVm.aofooter = true;
            taxVm.showNext = true;
            taxVm.showBack = false;
            taxVm.getFatcaDeclarationDetail();
        }

        //Go to Personal details page if user has clicked "No"
        taxVm.goToNextPage = function(value){
        	value = "yes";
            if(value == "yes"){
                taxVm.isYesBtnClicked = true;
            }
            else{
                taxVm.isYesBtnClicked = false;
            }
          var requestParams = {
                "id" : aoService.customer.mobileNo,
                "data":{
                    "fatcaFlag": taxVm.isYesBtnClicked,
                    "commonId":$state.$current.data.commonId
                }
            }
            taxService.setFactaFlag(requestParams).then(function(response) {
                if(value=="yes"){
                    $state.go('menu.personalDetails');
                }
                else{
                    $state.go('menu.locateBranch');
                } 
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });  
        }

        taxVm.getFatcaDeclarationDetail = function(){
            taxService.getFatcaDeclaration().then(function(data) {
                taxVm.fatcaQuestion = data;
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        //Show Info page on click of "i" icon
        taxVm.showTaxInfo = function() {
            $state.go('menu.foreign');
        }

        taxVm.populateResumeData = function(){
			if(aoService.fatcaResumeStatus === true){
            taxVm.isYesBtnClicked = aoService.fatcaFlag;
			}
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
            if(aoService.isResumeJourney == true){
                taxVm.populateResumeData();
            }else{
				 taxVm.isYesBtnClicked = null;
			}
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn); 
			if(aoService.isResumeJourney == true){
                taxVm.populateResumeData();
            }else{
				 taxVm.isYesBtnClicked = null;
			}
        });

        return this;
    }
]);
