'use strict';

angularApp.controller('termsAndConditionsController', ["$state",
    "$scope",
    "$translate",
    "$ionicScrollDelegate",
    "utilityService",
    "termsAndConditionsService",
    "aoService",
    "$timeout",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        $translate,
        $ionicScrollDelegate,
        utilityService,
        termsAndConditionsService,
        aoService,
        $timeout,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var termsAndConditionsVm = this;

        function initPage() {
            termsAndConditionsVm.showBack = true;
            termsAndConditionsVm.showNext = true;
            termsAndConditionsVm.disableNext = true;
            termsAndConditionsVm.aofooter = true;
            termsAndConditionsVm.ConditionsJson = [];
            termsAndConditionsVm.conditionsList();
            var title = 'Terms & Conditions';
            var template = '{{"TERMS_CONDITIONS_POPUP" | translate}}';
            var onTap = 'menu.termsAndConditions';
            var buttontext = 'Read T&C';
            utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            termsAndConditionsVm.disableCheckbox = true;
        }

        termsAndConditionsVm.goBacktoPrevious = function() {
            
            if(aoService.isGpsClicked == false){
                $state.go("menu.selectBranchListLocality");
            }
            else{
                $state.go("menu.selectBranchListGps");
            }
            
        }

        termsAndConditionsVm.goToNextPage = function() {
            termsAndConditionsVm.postTAndCDetails();
        }

        termsAndConditionsVm.checkScrollOnLoad = function(){
            var tc = document.getElementById("tcId").offsetHeight;
            var tcContent = document.getElementById("tcContent").offsetHeight;
            if(tcContent <= tc){
                termsAndConditionsVm.disableCheckbox = false;
                var childNodes = document.getElementById('TERMCOND_CHK').children[0].children[0].removeAttribute("disabled");
            }
        }

        termsAndConditionsVm.checkScroll = function() {
            var currentTop = $ionicScrollDelegate.$getByHandle('scroller').getScrollPosition().top;
            var maxTop = $ionicScrollDelegate.$getByHandle('scroller').getScrollView().__maxScrollTop;
            if (currentTop >= maxTop) {
                termsAndConditionsVm.disableCheckbox = false;
                var childNodes = document.getElementById('TERMCOND_CHK').children[0].children[0].removeAttribute("disabled");
            }
        }

        //Service call to get terms and conditions data
        termsAndConditionsVm.conditionsList = function() {
            termsAndConditionsService.getTermsAndConditions().then(function(data) {
                termsAndConditionsVm.ConditionsJson = data;
                $timeout(function() {
                    termsAndConditionsVm.checkScrollOnLoad();
                });
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        // Service to send the terms and conditions checkbox flag
        termsAndConditionsVm.postTAndCDetails = function() {
             var requestParams = {
                "id" : aoService.customer.mobileNo,                
                "data":{
                    "commonId":$state.$current.data.commonId,
                    "termsAndConditionsFlag" : termsAndConditionsVm.isChecked
                }
            }
            termsAndConditionsService.postTAndC(requestParams).then(function(data) {
                if(data.responseCode == constantConfig.successCode){
                    $state.go('menu.productOffering');
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        termsAndConditionsVm.populateResumeData = function(){
            termsAndConditionsVm.isChecked = aoService.termsAndConditionsFlag;
        }

        termsAndConditionsVm.agreeChkBox = function() {
            if (termsAndConditionsVm.isChecked) {
                termsAndConditionsVm.disableNext = false;
            } else {
                termsAndConditionsVm.disableNext = true;
            }
        }

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
            if(aoService.isResumeJourney == true){
                termsAndConditionsVm.populateResumeData();
            }
            termsAndConditionsVm.agreeChkBox();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn); 
        });

        return this;
    }
]);
