'use strict';

angularApp.controller('updateAadhaarController', ["$state",
    "$scope","updateAadhaarService","aoService","utilityService","$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        updateAadhaarService,
        aoService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var updateAadhaarVm = this;

        function initPage() {
            updateAadhaarVm.showBack = true;
            updateAadhaarVm.showNext = false;
            updateAadhaarVm.loadUpdateAadharContent();
        }
        
        updateAadhaarVm.goBacktoPrevious = function() {
            $state.go('menu.pdetailsAddress');
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        updateAadhaarVm.displaymap = function() {
            $state.go('menu.locateNearestBranch');
        }

        updateAadhaarVm.loadUpdateAadharContent = function(){
            updateAadhaarService.getLocateBranchAadharContent().then(function(data) {
                updateAadhaarVm.locateBranchAadharDesc = data;
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn); 
        });

        return this;
    }
]);
