'use strict';

angularApp.controller('aglAdditionalDetailsController', [
    "$state",
    "$scope",
    "$translate",
    "fTBeneficiaryService",
    "cancelScheduledPaymentService",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService",
    "constantConfig",
    "AdapterUtils",
    "$ionicScrollDelegate",
    "fTReviewService",
    "ionicToast",
    "loggedInUserService",
    "cryptoService",
    "getAccountDetailsService",
    "customerInfoService",
    "homeScreenService",
    "$rootScope",
    "billDeskService",
    "applyNowService",
    "personalLoanService",
    "sampoornSurakshaService",
    "cardsService",
    "lifeInsuranceBasicApplicationService",
    "requestYCService",
    "$ionicSideMenuDelegate",
    "$filter", "agriMandiService",

    function($state,
        $scope,
        $translate,
        fTBeneficiaryService,
        cancelScheduledPaymentService,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        constantConfig,
        AdapterUtils,
        $ionicScrollDelegate,
        fTReviewService, ionicToast,
        loggedInUserService, cryptoService,
        getAccountDetailsService,
        customerInfoService,
        homeScreenService,
        $rootScope,
        billDeskService,
        applyNowService,
        personalLoanService,
        sampoornSurakshaService,
        cardsService,
        lifeInsuranceBasicApplicationService,
        requestYCService,
        $ionicSideMenuDelegate,
        $filter, agriMandiService) {

        var aglAdditionalDetailsVm = this;




        aglAdditionalDetailsVm.goBack = function() {
            $ionicHistory.goBack(-1);;
        }


        $scope.$on('$ionicView.beforeEnter', function() {

            if (utilityService.isIOSPlatform()) {
                aglAdditionalDetailsVm.scroll = false;
            } else {
                aglAdditionalDetailsVm.scroll = true;
            }
            aglAdditionalDetailsVm.detail = {};

            aglAdditionalDetailsVm.customStyle = agriMandiService.getCustomStyle(agriMandiService.selectLanguage);

            //aglAdditionalDetailsVm.categories = agriMandiService.masterdata.master.categories;
            if (agriMandiService.resumeData) {
                aglAdditionalDetailsVm.master = agriMandiService.resumeData.master;


            } else {
                aglAdditionalDetailsVm.master = agriMandiService.masterdata.master;
            }

            aglAdditionalDetailsVm.showSelect = true;



            agriMandiService.getAccounts().then(function(data) {

                aglAdditionalDetailsVm.accounts = data.accList;
                if (data.accList.length == 1) {
                    aglAdditionalDetailsVm.showSelect = false;
                    aglAdditionalDetailsVm.detail.branchName = data.accList[0].branchName;
                    aglAdditionalDetailsVm.detail.accountType = data.accList[0].accountType;
                    aglAdditionalDetailsVm.detail.accountNumber = data.accList[0].accountNumber;
                }
                if (agriMandiService.addData) {
                    aglAdditionalDetailsVm.detail = agriMandiService.addData;
                      aglAdditionalDetailsVm.showSelect = false;
                }

                else if(agriMandiService.resumeData)
                {
                      aglAdditionalDetailsVm.showSelect = false;
                    aglAdditionalDetailsVm.detail = agriMandiService.resumeData;
                }



            }, function(error) {

                utilityService.showErrorMessage(error.responseMessage);
            });


        });


        aglAdditionalDetailsVm.showPop = function() {
            if (aglAdditionalDetailsVm.accounts.length > 0) {
                aglAdditionalDetailsVm.popUP = $ionicPopup.show({
                    title: '',
                    cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter ftpopup-body',
                    templateUrl: 'pages/Agl/dropdown.html',
                    scope: $scope
                });
            }

        }


        aglAdditionalDetailsVm.close = function(index) {
            aglAdditionalDetailsVm.popUP.close();
            aglAdditionalDetailsVm.detail.branchName = aglAdditionalDetailsVm.accounts[index].branchName;
            aglAdditionalDetailsVm.detail.accountType = aglAdditionalDetailsVm.accounts[index].accountType;
            aglAdditionalDetailsVm.detail.accountNumber = aglAdditionalDetailsVm.accounts[index].accountNumber;
            aglAdditionalDetailsVm.showSelect = false;


        }





        aglAdditionalDetailsVm.goToMandi = function() {
            agriMandiService.branchName = aglAdditionalDetailsVm.detail.branchName;
            $state.go('menu.agriMandiLanding');
        };


        aglAdditionalDetailsVm.goToLoan = function() {

            var comingsoonPopup = $ionicPopup.alert({
                template: '<div class="CSPadding font-dark-grey "><div class="parentCS"><img class="imgwidthCS" src="img/Coming_Soon_Illustration.svg"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="childCS">' +
                    "Coming Soon" + '</div></div></div></div></div></div>',
                cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter custButtonCS button0pd',
                buttons: [{
                    text: 'OK',
                    type: 'button-positive',
                    onTap: function(e) {
                        comingsoonPopup.close();

                    }
                }]
            });
            // utilityService.showErrorMessage(selectedObj.message);
        };

        aglAdditionalDetailsVm.validateForm = function() {
            aglAdditionalDetailsVm.errObj = {};


            if (!aglAdditionalDetailsVm.detail.maritalStatus) {
                aglAdditionalDetailsVm.errObj.maritalStatus = true;
            }
            if (!aglAdditionalDetailsVm.detail.eduQualification) {
                aglAdditionalDetailsVm.errObj.educationQualification = true;
            }

            if (!aglAdditionalDetailsVm.detail.category) {
                aglAdditionalDetailsVm.errObj.category = true;
            }

            if (!aglAdditionalDetailsVm.detail.farmerType) {
                aglAdditionalDetailsVm.errObj.farmerType = true;
            }

             if (!aglAdditionalDetailsVm.detail.accountNumber) {
                aglAdditionalDetailsVm.errObj.loanAccount = true;
            }

            




            return (angular.equals({}, aglAdditionalDetailsVm.errObj)) ? true : false;
        }

        aglAdditionalDetailsVm.goToNextPage = function()

        {

            if (aglAdditionalDetailsVm.validateForm()) {
                var saveObj = {
                    "loanType": "string",
                    "custFlag": "string",
                    "page": "additionalDetails",
                    "cif": "string",
                    "yonoRef": "string",
                    "losRef": "string",
                    "loanStatus": "string",
                    "startDate": "string",
                    "loanAccountNumber": "string",
                    "homeBranchCode": "string",
                    "firstName": "string",
                    "middleName": "string",
                    "lastName": "string",
                    "title": "string",
                    "gender": "string",
                    "email": "string",
                    "mobile": "string",
                    "pan": "string",
                    "aadhar": "string",
                    "dob": "string",
                    "maritalStatus": aglAdditionalDetailsVm.detail.maritalStatus,
                    "permanentAddress": {
                        "addressLine1": "string",
                        "addressLine2": "string",
                        "addressLine3": "string",
                        "district": "string",
                        "pincode": "string"
                    },
                    "loanPurpose": "string",
                    "loanAmount": "string",
                    "eduQualification": aglAdditionalDetailsVm.detail.eduQualification,
                    "farmerType": aglAdditionalDetailsVm.detail.farmerType,
                    "category": aglAdditionalDetailsVm.detail.category,
                    "landHolding": "string",
                    "yearlyIncome": "string",
                    "activityDescription": "string",
                    "accountNumber": aglAdditionalDetailsVm.detail.accountNumber,
                    "accountType": aglAdditionalDetailsVm.detail.accountType,
                    "branchCode": "string",
                    "branchName": aglAdditionalDetailsVm.detail.branchName,
                    "lang": "string",
                    "loanIntersetRate": "string",
                    "loanTenure": "string",
                    "loanStage": "string",
                    "consent": true
                }


                agriMandiService.losData = saveObj;


                agriMandiService.saveData(saveObj).then(function(data) {

                    agriMandiService.addData = aglAdditionalDetailsVm.detail

                    
                    $state.go("menu.aglLoanDetails");

                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);

                    
                });


            }


        }





        return this;
    }
]);