'use strict';

angularApp.controller('aglKnowMoreController', [
    "$state",
    "$scope",
    "$translate",
    "fTBeneficiaryService",
    "cancelScheduledPaymentService",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService",
    "constantConfig",
    "AdapterUtils",
    "$ionicScrollDelegate",
    "fTReviewService",
    "ionicToast",
    "loggedInUserService",
    "cryptoService",
    "getAccountDetailsService",
    "customerInfoService",
    "homeScreenService",
    "$rootScope",
    "billDeskService",
    "applyNowService",
    "personalLoanService",
    "sampoornSurakshaService",
    "cardsService",
    "lifeInsuranceBasicApplicationService",
    "requestYCService",
    "$ionicSideMenuDelegate",
    "$filter", "agriMandiService", "homeLoanService",

    function ($state,
        $scope,
        $translate,
        fTBeneficiaryService,
        cancelScheduledPaymentService,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        constantConfig,
        AdapterUtils,
        $ionicScrollDelegate,
        fTReviewService, ionicToast,
        loggedInUserService, cryptoService,
        getAccountDetailsService,
        customerInfoService,
        homeScreenService,
        $rootScope,
        billDeskService,
        applyNowService,
        personalLoanService,
        sampoornSurakshaService,
        cardsService,
        lifeInsuranceBasicApplicationService,
        requestYCService,
        $ionicSideMenuDelegate,
        $filter, agriMandiService, homeLoanService) {

        var aglKnowMoreVm = this;

        aglKnowMoreVm.goback = function () {
            $state.go('menu.kccKhataLanding')
        };
        $scope.$on('$ionicView.beforeEnter', function () {
            agriMandiService.clearData();
            aglKnowMoreVm.customStyle = agriMandiService.getCustomStyle(agriMandiService.selectLanguage);
            aglKnowMoreVm.status = agriMandiService.WCMData.status;
            aglKnowMoreVm.features = agriMandiService.WCMData.tabContent.features;
            aglKnowMoreVm.eligibility = agriMandiService.WCMData.tabContent.eligibility;
            aglKnowMoreVm.documentation = agriMandiService.WCMData.tabContent.documentation;
            aglKnowMoreVm.interest = agriMandiService.WCMData.tabContent.interestRateAndCharges;
            if (agriMandiService.selectLanguage == 'hi') {

                aglKnowMoreVm.source = "img/agri/HinProcess.svg"


            } else if (agriMandiService.selectLanguage == 'en') {

                aglKnowMoreVm.source = "img/agri/EngProcess.svg"
            } else if (agriMandiService.selectLanguage == 'ma') {
                aglKnowMoreVm.source = "img/agri/MalProcess.svg"

            } else if (agriMandiService.selectLanguage == 'te') {

                aglKnowMoreVm.source = "img/agri/TelProcess.svg"

            } else if (agriMandiService.selectLanguage == 'ta') {

                aglKnowMoreVm.source = "img/agri/TamProcess.svg";

            }
            else if (agriMandiService.selectLanguage == 'mar') {

                aglKnowMoreVm.source = "img/agri/MarathiProcess.svg";

            }
            else if (agriMandiService.selectLanguage == 'ka') {

                aglKnowMoreVm.source = "img/agri/KannadaProcess.svg";

            }
            else if (agriMandiService.selectLanguage == 'be') {

                aglKnowMoreVm.source = "img/agri/ProcessBengali.svg";

            }
            else if (agriMandiService.selectLanguage == 'pu') {

                aglKnowMoreVm.source = "img/agri/ProcessPunjabi.svg";

            }

            else if (agriMandiService.selectLanguage == 'or') {

                aglKnowMoreVm.source = "img/agri/ProcessOriya.svg";

            }
            else if (agriMandiService.selectLanguage == 'as') {

                aglKnowMoreVm.source = "img/agri/ProcessAssamese.svg";

            }
            else if (agriMandiService.selectLanguage == 'gu') {

                aglKnowMoreVm.source = "img/agri/ProcessGujrati.svg";

            }




            else {
                aglKnowMoreVm.source = "img/agri/EngProcess.svg"

            }





            aglKnowMoreVm.tab = 1;

        });

        aglKnowMoreVm.selTab = function (sel) {
            aglKnowMoreVm.tab = sel;
        }


        aglKnowMoreVm.goToAGL = function () {

            var request = {};
            request.language = agriMandiService.selectLanguage;

            agriMandiService.executeBusinessEligibilty(request).then(function (data) {

                agriMandiService.masterdata = data;

                if (data.status == "AL02") {

                    agriMandiService.dedupErrors = data.reasons;
                    $state.go('menu.aglError');
                } else {


                    var request = {};
                    request.locality = data.homeBranchCode;


                    homeLoanService.getBranchDetails(request).then(function (data) {

                        agriMandiService.masterdata.homeBranchName = data.branches[0].branchName
                        $state.go('menu.aglPersonalDetails');


                    }, function (error) {


                        utilityService.showErrorMessage(error.responseMessage);
                    });


                }







            }, function (error) {
                $state.go('menu.aglPersonalDetails');

                utilityService.showErrorMessage(error.responseMessage);
            });



        }

        aglKnowMoreVm.resume = function () {

            $state.go('menu.aglResume');


        }

        aglKnowMoreVm.cancel = function () {
            aglKnowMoreVm.myPopup.close();
        }

        aglKnowMoreVm.checkStatus = function () {

            var request = {};
            request.language = agriMandiService.selectLanguage;

            agriMandiService.checkStatus(request).then(function (data) {

                aglKnowMoreVm.applicationStatus = data.applicationStatus;
                aglKnowMoreVm.description = data.statusDesc;

                if (aglKnowMoreVm.applicationStatus == 'AP' || aglKnowMoreVm.applicationStatus == 'AC' || aglKnowMoreVm.applicationStatus == 'CN' || aglKnowMoreVm.applicationStatus == 'RJ' || aglKnowMoreVm.applicationStatus == 'EXP') {
                    aglKnowMoreVm.showApply = true;
                    aglKnowMoreVm.showOK = false;

                    if (aglKnowMoreVm.applicationStatus == 'AP' || aglKnowMoreVm.applicationStatus == 'AC') {
                        aglKnowMoreVm.showSucessImg = true;
                        aglKnowMoreVm.showErrorImg = false;

                    } else {
                        aglKnowMoreVm.showSucessImg = false;
                        aglKnowMoreVm.showErrorImg = true;
                    }
                } else {
                    aglKnowMoreVm.showOK = true;
                    aglKnowMoreVm.showApply = false;
                }

                aglKnowMoreVm.myPopup = $ionicPopup.show({
                    title: '',
                    cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',
                    templateUrl: "pages/Agl/aglCheckStatus.html",
                    scope: $scope
                });

                var alertPopup = $ionicPopup.alert({
                    title: heading,
                    template: '<div class=""></div><div class="inb-alert-msg popupTextBottomPadding fontSize-subHeading inb-p20 fss-common-ul-list">' +
                    message + '</div></div>',
                    cssClass: 'removePopup-head popupWidth90 popupMargin ftpopup-body popupBackgroundWhite ss-medical-page inb-popUp-sub-btn',
                    buttons: [{
                        text: buttonText[0],
                        onTap: function (e) {
                            button1();
                        }
                    },
                    {
                        text: buttonText[1],
                        onTap: function (e) {
                            button2();
                        }
                    }
                    ],
                });


            }, function (error) {

                utilityService.showErrorMessage(error.responseMessage);
            });



        }

        aglKnowMoreVm.cancel = function () {
            aglKnowMoreVm.myPopup.close();
        }

        aglKnowMoreVm.applyNow = function () {

            aglKnowMoreVm.myPopup.close();
            aglKnowMoreVm.goToAGL();
        }

        aglKnowMoreVm.ok = function () {
            aglKnowMoreVm.myPopup.close();
        }



        aglKnowMoreVm.goToMandi = function () {
            $state.go('menu.agriMandiLanding');
        };




        aglKnowMoreVm.goToLoan = function () {


            // utilityService.showErrorMessage(selectedObj.message);
        };



        return this;
    }
]);