'use strict';

angularApp.controller('aglLoanDetailsController', [
    "$state",
    "$scope",
    "$translate",
    "fTBeneficiaryService",
    "cancelScheduledPaymentService",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService",
    "constantConfig",
    "AdapterUtils",
    "$ionicScrollDelegate",
    "fTReviewService",
    "ionicToast",
    "loggedInUserService",
    "cryptoService",
    "getAccountDetailsService",
    "customerInfoService",
    "homeScreenService",
    "$rootScope",
    "billDeskService",
    "applyNowService",
    "personalLoanService",
    "sampoornSurakshaService",
    "cardsService",
    "lifeInsuranceBasicApplicationService",
    "requestYCService",
    "$ionicSideMenuDelegate",
    "$filter", "agriMandiService", "homeLoanService",

    function($state,
        $scope,
        $translate,
        fTBeneficiaryService,
        cancelScheduledPaymentService,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        constantConfig,
        AdapterUtils,
        $ionicScrollDelegate,
        fTReviewService, ionicToast,
        loggedInUserService, cryptoService,
        getAccountDetailsService,
        customerInfoService,
        homeScreenService,
        $rootScope,
        billDeskService,
        applyNowService,
        personalLoanService,
        sampoornSurakshaService,
        cardsService,
        lifeInsuranceBasicApplicationService,
        requestYCService,
        $ionicSideMenuDelegate,
        $filter, agriMandiService, homeLoanService) {

        var aglLoanDetailsVm = this;

        aglLoanDetailsVm.goToPrevious = function() {
            $state.go('menu.homeScreen')
        };


        $scope.$on('$ionicView.beforeEnter', function() {

            if (utilityService.isIOSPlatform()) {
                aglLoanDetailsVm.scroll = false;
            } else {
                aglLoanDetailsVm.scroll = true;
            }

            aglLoanDetailsVm.detail = {};
            aglLoanDetailsVm.showDescription = false;

            aglLoanDetailsVm.customStyle = agriMandiService.getCustomStyle(agriMandiService.selectLanguage);
            
          if (agriMandiService.resumeData) {
               aglLoanDetailsVm.master = agriMandiService.resumeData.master;

            } else {
                 aglLoanDetailsVm.master = agriMandiService.masterdata.master;
            }


             if (agriMandiService.loanData) {
                    aglLoanDetailsVm.detail = agriMandiService.loanData;
                }

                  else if(agriMandiService.resumeData)
                {
                   aglLoanDetailsVm.detail = agriMandiService.resumeData;
                }

          


        });





        aglLoanDetailsVm.goToNextPage = function() {

            if (aglLoanDetailsVm.validateForm()) {
                var saveObj = agriMandiService.losData;
                saveObj.landHolding = aglLoanDetailsVm.detail.landHolding;
                saveObj.activityDescription = aglLoanDetailsVm.detail.description;

                saveObj.yearlyIncome = aglLoanDetailsVm.detail.yearlyIncome;
                saveObj.loanAmount = aglLoanDetailsVm.detail.loanAmount;
                saveObj.loanPurpose = aglLoanDetailsVm.detail.loanPurpose;
                saveObj.lang = agriMandiService.selectLanguage;
                saveObj.page="loanDetails"

                for(var i=0;i<aglLoanDetailsVm.master.loanPurposes.length;i++)
                {
                    if(aglLoanDetailsVm.master.loanPurposes[i].key == saveObj.loanPurpose)
                    {
                        saveObj.loanPurposeValue=aglLoanDetailsVm.master.loanPurposes[i].value;
                    }
                    
                }
                

                  agriMandiService.losData=saveObj;

              

                agriMandiService.saveData(saveObj).then(function(data) {

                    agriMandiService.loanData = aglLoanDetailsVm.detail;

                   $state.go("menu.aglLoanSummary");

                }, function(error) {
                    
                    utilityService.showErrorMessage(error.responseMessage);
                });

            //     agriMandiService.losDataPush(saveObj).then(function(data) {

            //         agriMandiService.finalContent = data;

            //         $state.go("menu.aglRefNo");

            //     }, function(error) {

            //         utilityService.showErrorMessage(error.responseMessage);
            //     });
            // }
           // referralCode
           // consentFlag
            

            }

        }

        aglLoanDetailsVm.changeKey = function() {
            if (aglLoanDetailsVm.detail.loanPurpose == '2') {
                aglLoanDetailsVm.showDescription = true;

            } else {
                aglLoanDetailsVm.showDescription = false;
            }

        }


        aglLoanDetailsVm.validateForm = function() {
            aglLoanDetailsVm.errObj = {};


            if (!aglLoanDetailsVm.detail.loanAmount || parseInt(aglLoanDetailsVm.detail.loanAmount) <= 0 || parseInt(aglLoanDetailsVm.detail.loanAmount) > 2500000) {
                aglLoanDetailsVm.errObj.loanAmount = true;
            }
            if (!aglLoanDetailsVm.detail.loanPurpose) {
                aglLoanDetailsVm.errObj.loanPurpose = true;
            }

            if (!aglLoanDetailsVm.detail.description && aglLoanDetailsVm.showDescription ==true) {
                aglLoanDetailsVm.errObj.description = true;
            }

            if (!aglLoanDetailsVm.detail.landHolding || parseFloat(aglLoanDetailsVm.detail.landHolding) <= 0) {
                aglLoanDetailsVm.errObj.landHolding = true;
            }
            if (!aglLoanDetailsVm.detail.yearlyIncome || parseInt(aglLoanDetailsVm.detail.yearlyIncome) < 0 || parseInt(aglLoanDetailsVm.detail.yearlyIncome) > 100000000) {
                aglLoanDetailsVm.errObj.yearlyIncome = true;
            }






            return (angular.equals({}, aglLoanDetailsVm.errObj)) ? true : false;
        }



        aglLoanDetailsVm.goBack = function() {
            $ionicHistory.goBack(-1);;
        }




        aglLoanDetailsVm.goToLoan = function() {

            var comingsoonPopup = $ionicPopup.alert({
                template: '<div class="CSPadding font-dark-grey "><div class="parentCS"><img class="imgwidthCS" src="img/Coming_Soon_Illustration.svg"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="childCS">' +
                    "Coming Soon" + '</div></div></div></div></div></div>',
                cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter custButtonCS button0pd',
                buttons: [{
                    text: 'OK',
                    type: 'button-positive',
                    onTap: function(e) {
                        comingsoonPopup.close();

                    }
                }]
            });
            // utilityService.showErrorMessage(selectedObj.message);
        };



        return this;
    }
]);