'use strict';

angularApp.controller('aglLoanSummaryController', [
    "$state",
    "$scope",
    "$translate",
    "fTBeneficiaryService",
    "cancelScheduledPaymentService",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService",
    "constantConfig",
    "AdapterUtils",
    "$ionicScrollDelegate",
    "fTReviewService",
    "ionicToast",
    "loggedInUserService",
    "cryptoService",
    "getAccountDetailsService",
    "customerInfoService",
    "homeScreenService",
    "$rootScope",
    "billDeskService",
    "applyNowService",
    "personalLoanService",
    "sampoornSurakshaService",
    "cardsService",
    "lifeInsuranceBasicApplicationService",
    "requestYCService",
    "$ionicSideMenuDelegate",
    "$filter", "agriMandiService", "homeLoanService","$ionicPopover",

    function($state,
        $scope,
        $translate,
        fTBeneficiaryService,
        cancelScheduledPaymentService,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        constantConfig,
        AdapterUtils,
        $ionicScrollDelegate,
        fTReviewService, ionicToast,
        loggedInUserService, cryptoService,
        getAccountDetailsService,
        customerInfoService,
        homeScreenService,
        $rootScope,
        billDeskService,
        applyNowService,
        personalLoanService,
        sampoornSurakshaService,
        cardsService,
        lifeInsuranceBasicApplicationService,
        requestYCService,
        $ionicSideMenuDelegate,
        $filter, agriMandiService, homeLoanService,$ionicPopover) {

        var aglLoanSummaryVm = this;

        aglLoanSummaryVm.goToPrevious = function() {
            $state.go('menu.homeScreen')
        };


        $scope.$on('$ionicView.beforeEnter', function() {

            if (utilityService.isIOSPlatform()) {
                aglLoanSummaryVm.scroll = false;
            } else {
                aglLoanSummaryVm.scroll = true;
            }

            aglLoanSummaryVm.detail = {};
            aglLoanSummaryVm.showDescription = false;

            aglLoanSummaryVm.customStyle = agriMandiService.getCustomStyle(agriMandiService.selectLanguage);

            // if (agriMandiService.resumeData) {
            //     aglLoanSummaryVm.master = agriMandiService.resumeData.master;

            //   } else {
            //       aglLoanSummaryVm.master = agriMandiService.masterdata.master;
            //   }


            aglLoanSummaryVm.detail.loanAmount = agriMandiService.losData.loanAmount;
            aglLoanSummaryVm.detail.loanPurpose = agriMandiService.losData.loanPurposeValue;
            aglLoanSummaryVm.detail.accountNumber = agriMandiService.losData.accountNumber;
            aglLoanSummaryVm.detail.accountType = agriMandiService.losData.accountType;
            aglLoanSummaryVm.detail.branchName = agriMandiService.losData.branchName;
            
            




        });





        aglLoanSummaryVm.goToNextPage = function() {

          
                var saveObj = agriMandiService.losData;
                if(aglLoanSummaryVm.detail.referralCode)
                {
                    saveObj.referralCode = aglLoanSummaryVm.detail.referralCode

                }

                saveObj.consentFlag  ="Y";
                agriMandiService.losDataPush(saveObj).then(function(data) {

                    agriMandiService.finalContent = data;

                    $state.go("menu.aglRefNo");

                }, function(error) {

                    utilityService.showErrorMessage(error.responseMessage);
                });
            
        }

        aglLoanSummaryVm.changeKey = function() {
            if (aglLoanSummaryVm.detail.loanPurpose == '2') {
                aglLoanSummaryVm.showDescription = true;

            } else {
                aglLoanSummaryVm.showDescription = false;
            }

        }


        aglLoanSummaryVm.validateForm = function() {
            aglLoanSummaryVm.errObj = {};


            if (!aglLoanSummaryVm.detail.loanAmount || parseInt(aglLoanSummaryVm.detail.loanAmount) <= 0 || parseInt(aglLoanSummaryVm.detail.loanAmount) > 2500000) {
                aglLoanSummaryVm.errObj.loanAmount = true;
            }
            if (!aglLoanSummaryVm.detail.loanPurpose) {
                aglLoanSummaryVm.errObj.loanPurpose = true;
            }

            if (!aglLoanSummaryVm.detail.description && aglLoanSummaryVm.showDescription == true) {
                aglLoanSummaryVm.errObj.description = true;
            }

            if (!aglLoanSummaryVm.detail.landHoldings || parseInt(aglLoanSummaryVm.detail.landHoldings) < 0) {
                aglLoanSummaryVm.errObj.landHoldings = true;
            }
            if (!aglLoanSummaryVm.detail.yearlyIncome || parseInt(aglLoanSummaryVm.detail.yearlyIncome) < 0 || parseInt(aglLoanSummaryVm.detail.yearlyIncome) > 100000000) {
                aglLoanSummaryVm.errObj.yearlyIncome = true;
            }






            return (angular.equals({}, aglLoanSummaryVm.errObj)) ? true : false;
        }


         aglLoanSummaryVm.infoDetails = function ($event) {
            var template = '<ion-popover-view class="loginnewarrow agl-pop-over" id="runtimeHeight" >' + '<div class="agri-arrow-popover"></div>' + '<ion-content class="col-100" scroll="true" style="top: 1% !important;margin: 0px !important;">' +'<div class="agl-label agl-text-justify" translate="AGL_REF_INFO"> </div>'+'</ion-content>' + '</ion-popover-view>';
           $scope.popover = $ionicPopover.fromTemplate(template, {
            scope: $scope
        });
            $scope.popover.show($event);
}

        aglLoanSummaryVm.goBack = function() {
            $ionicHistory.goBack(-1);;
        }




        aglLoanSummaryVm.goToLoan = function() {

            var comingsoonPopup = $ionicPopup.alert({
                template: '<div class="CSPadding font-dark-grey "><div class="parentCS"><img class="imgwidthCS" src="img/Coming_Soon_Illustration.svg"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="childCS">' +
                    "Coming Soon" + '</div></div></div></div></div></div>',
                cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter custButtonCS button0pd',
                buttons: [{
                    text: 'OK',
                    type: 'button-positive',
                    onTap: function(e) {
                        comingsoonPopup.close();

                    }
                }]
            });
            // utilityService.showErrorMessage(selectedObj.message);
        };



        return this;
    }
]);