'use strict';

angularApp.controller('aglPersonalDetailsController', [
    "$state",
    "$scope",
    "$translate",
    "fTBeneficiaryService",
    "cancelScheduledPaymentService",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService",
    "constantConfig",
    "AdapterUtils",
    "$ionicScrollDelegate",
    "fTReviewService",
    "ionicToast",
    "loggedInUserService",
    "cryptoService",
    "getAccountDetailsService",
    "customerInfoService",
    "homeScreenService",
    "$rootScope",
    "billDeskService",
    "applyNowService",
    "personalLoanService",
    "sampoornSurakshaService",
    "cardsService",
    "lifeInsuranceBasicApplicationService",
    "requestYCService",
    "$ionicSideMenuDelegate",
    "$filter", "agriMandiService", "homeLoanService",

    function($state,
        $scope,
        $translate,
        fTBeneficiaryService,
        cancelScheduledPaymentService,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        constantConfig,
        AdapterUtils,
        $ionicScrollDelegate,
        fTReviewService, ionicToast,
        loggedInUserService, cryptoService,
        getAccountDetailsService,
        customerInfoService,
        homeScreenService,
        $rootScope,
        billDeskService,
        applyNowService,
        personalLoanService,
        sampoornSurakshaService,
        cardsService,
        lifeInsuranceBasicApplicationService,
        requestYCService,
        $ionicSideMenuDelegate,
        $filter, agriMandiService, homeLoanService) {

        var aglPersonalDetailsVm = this;

        aglPersonalDetailsVm.goToPrevious = function() {
            $state.go('menu.homeScreen')
        };



        $scope.$on('$ionicView.beforeEnter', function() {
            aglPersonalDetailsVm.detail = {};
            if (utilityService.isIOSPlatform()) {
                aglPersonalDetailsVm.scroll = false;
            } else {
                aglPersonalDetailsVm.scroll = true;
            }

            if (agriMandiService.resumeData) {
                aglPersonalDetailsVm.masterdata = angular.copy(agriMandiService.resumeData);

            } else {

                aglPersonalDetailsVm.masterdata = angular.copy(agriMandiService.masterdata);
            }

            aglPersonalDetailsVm.detail = angular.copy(aglPersonalDetailsVm.masterdata);
            aglPersonalDetailsVm.detail.name = aglPersonalDetailsVm.masterdata.firstName  +' '+ aglPersonalDetailsVm.masterdata.lastName;

            if (!aglPersonalDetailsVm.detail.permanentAddress.addressLine1) {
                aglPersonalDetailsVm.detail.addressLine1 = "";
            } else {
                if (aglPersonalDetailsVm.detail.permanentAddress.addressLine1.indexOf(',') == -1) {
                    aglPersonalDetailsVm.detail.addressLine1 = aglPersonalDetailsVm.detail.permanentAddress.addressLine1 + ",";
                } else {
                    aglPersonalDetailsVm.detail.addressLine1 = aglPersonalDetailsVm.detail.permanentAddress.addressLine1;
                }

            }
            if (!aglPersonalDetailsVm.detail.permanentAddress.addressLine2) {
                aglPersonalDetailsVm.detail.addressLine2 = "";
            } else {

                if (aglPersonalDetailsVm.detail.permanentAddress.addressLine2.indexOf(',') == -1) {
                    aglPersonalDetailsVm.detail.addressLine2 = aglPersonalDetailsVm.detail.permanentAddress.addressLine2 + ",";
                } else {
                    aglPersonalDetailsVm.detail.addressLine2 = aglPersonalDetailsVm.detail.permanentAddress.addressLine2;
                }
            }


            if (!aglPersonalDetailsVm.detail.permanentAddress.addressLine3) {
                aglPersonalDetailsVm.detail.addressLine3 = "";
            } else {

                if (aglPersonalDetailsVm.detail.permanentAddress.addressLine3.indexOf(',') == -1) {
                    aglPersonalDetailsVm.detail.addressLine3 = aglPersonalDetailsVm.detail.permanentAddress.addressLine3 + ",";
                } else {
                    aglPersonalDetailsVm.detail.addressLine3 = aglPersonalDetailsVm.detail.permanentAddress.addressLine3;
                }
            }

            if (!aglPersonalDetailsVm.detail.permanentAddress.pincode) {
                aglPersonalDetailsVm.detail.pincode = "";
            } else {
                if (aglPersonalDetailsVm.detail.permanentAddress.pincode.indexOf('-') == -1) {
                    aglPersonalDetailsVm.detail.pincode = "-" + aglPersonalDetailsVm.detail.permanentAddress.pincode;
                } else {
                    aglPersonalDetailsVm.detail.pincode = aglPersonalDetailsVm.detail.permanentAddress.pincode;
                }

            }

            // aglPersonalDetailsVm.detail.permanentAddress = agriMandiService.masterdata.permanentAddress.addressLine1 + agriMandiService.masterdata.permanentAddress.addressLine2+agriMandiService.masterdata.permanentAddress.addressLine3
            aglPersonalDetailsVm.detail.permanentAddress = aglPersonalDetailsVm.detail.addressLine1 + aglPersonalDetailsVm.detail.addressLine2 + aglPersonalDetailsVm.detail.addressLine3 + aglPersonalDetailsVm.detail.permanentAddress.district + aglPersonalDetailsVm.detail.pincode;;

            aglPersonalDetailsVm.customStyle = agriMandiService.getCustomStyle(agriMandiService.selectLanguage);

            aglPersonalDetailsVm.detail.dob = $filter('homeDateFormat')(aglPersonalDetailsVm.masterdata.dob);
            var str = aglPersonalDetailsVm.detail.dob.split(' ');
            var year = str[2];
            var Mask = year.replace(year, 'XXXX');
            aglPersonalDetailsVm.detail.dobMask = str[0] + ' ' + str[1] + ' ' + Mask;

            aglPersonalDetailsVm.isMaskPan = true;
            aglPersonalDetailsVm.isMaskAd = true;
            aglPersonalDetailsVm.isMaskEmail = true;
            aglPersonalDetailsVm.isMaskMobile = true;
            aglPersonalDetailsVm.isMaskDob = true;


        });


        aglPersonalDetailsVm.unmaskDob = function() {
            aglPersonalDetailsVm.isMaskDob = !aglPersonalDetailsVm.isMaskDob;
        }


        aglPersonalDetailsVm.goToNextPage = function() {
            $state.go('menu.aglAdditionalDetails');

        }

        aglPersonalDetailsVm.goBack = function() {
            $ionicHistory.goBack(-1);;
        }

        aglPersonalDetailsVm.unmaskData = function(idType) {
            var request = {
                "type": idType,
                "loanType": "AGRI"
            }
            if (idType == 'pan' || idType == 'aadhaar' || idType == 'mobile' || idType == 'email' || idType == 'dob') {
                homeLoanService.getUnmaskData(request).then(function(data) {
                    if (idType == 'pan') {
                        aglPersonalDetailsVm.isMaskPan = false;
                        aglPersonalDetailsVm.detail.pan = data;
                    } else if (idType == 'aadhaar') {
                        aglPersonalDetailsVm.isMaskAd = false;
                        aglPersonalDetailsVm.detail.aadhaar = data;
                    } else if (idType == 'mobile') {
                        aglPersonalDetailsVm.isMaskMobile = false;
                        aglPersonalDetailsVm.detail.mobile = data;
                    } else if (idType == 'email') {
                        aglPersonalDetailsVm.isMaskEmail = false;
                        aglPersonalDetailsVm.detail.email = data;
                    } else if (idType == 'dob') {
                        aglPersonalDetailsVm.isMaskDob = false;
                        aglPersonalDetailsVm.detail.dob = data;
                    }

                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else {
                if (idType == 'npan') {
                    aglPersonalDetailsVm.isMaskPan = true;
                    aglPersonalDetailsVm.detail.pan = aglPersonalDetailsVm.masterdata.pan;
                } else if (idType == 'naadhaar') {
                    aglPersonalDetailsVm.isMaskAd = true;
                    aglPersonalDetailsVm.detail.aadhaar = aglPersonalDetailsVm.masterdata.aadhaar;
                } else if (idType == 'nmobile') {
                    aglPersonalDetailsVm.isMaskMobile = true;
                    aglPersonalDetailsVm.detail.mobile = aglPersonalDetailsVm.masterdata.mobile;
                } else if (idType == 'nemail') {
                    aglPersonalDetailsVm.isMaskEmail = true;
                    aglPersonalDetailsVm.detail.email = aglPersonalDetailsVm.masterdata.email;
                } else if (idType == 'ndob') {
                    aglPersonalDetailsVm.isMaskDob = true;
                    aglPersonalDetailsVm.detail.dob = aglPersonalDetailsVm.masterdata.dob;

                }

            }

        }




        /* Navigate to QRCode Page */


        /* Navigate to New Beneficiary Page */
        aglPersonalDetailsVm.goToMandi = function() {
            $state.go('menu.agriMandiLanding');
        };





        return this;
    }
]);