'use strict';

angularApp.controller('agriLandingController', [
    "$state",
    "$scope",
    "$translate",
    "fTBeneficiaryService",
    "cancelScheduledPaymentService",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService",
    "constantConfig",
    "AdapterUtils",
    "$ionicScrollDelegate",
    "fTReviewService",
    "ionicToast",
    "loggedInUserService",
    "cryptoService",
    "getAccountDetailsService",
    "customerInfoService",
    "homeScreenService",
    "$rootScope",
    "billDeskService",
    "applyNowService",
    "personalLoanService",
    "sampoornSurakshaService",
    "cardsService",
    "lifeInsuranceBasicApplicationService",
    "requestYCService",
    "$ionicSideMenuDelegate",
    "$filter", "agriMandiService", "clickStreamService",

    function ($state,
        $scope,
        $translate,
        fTBeneficiaryService,
        cancelScheduledPaymentService,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        constantConfig,
        AdapterUtils,
        $ionicScrollDelegate,
        fTReviewService, ionicToast,
        loggedInUserService, cryptoService,
        getAccountDetailsService,
        customerInfoService,
        homeScreenService,
        $rootScope,
        billDeskService,
        applyNowService,
        personalLoanService,
        sampoornSurakshaService,
        cardsService,
        lifeInsuranceBasicApplicationService,
        requestYCService,
        $ionicSideMenuDelegate,
        $filter, agriMandiService, clickStreamService) {

        var agriLandingVm = this;
        agriLandingVm.showLongText = false;

        agriLandingVm.goToPrevious = function () {
            $state.go('menu.homeScreen')
        };

        agriLandingVm.goToKhata = function () {
            $state.go('menu.kccKhataLanding');
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            agriMandiService.category = "";
            agriMandiService.recentSearchedList = "";
            agriMandiService.keywords = "";
            agriMandiService.banners = "";
            agriLandingVm.customStyle = agriMandiService.getCustomStyle(agriMandiService.selectLanguage);
            if(agriMandiService.selectLanguage == 'ta' || agriMandiService.selectLanguage == 'ka')
            {
                agriLandingVm.showLongText = true;
            }
            var request = {};
             request.language = agriMandiService.selectLanguage;
            //request.language = "en";
            agriLandingVm.kucFlag = agriMandiService.kucFlag;
            if(agriMandiService.kucFlag == "true"){
                agriMandiService.getKUCBanner().then(function(data) {
                        agriLandingVm.bannerImg = data.yonoAgriBanner.imageURL;
                    }, function (error) {
                        //utilityService.showErrorMessage(error.responseMessage);//comment/remove afterwards this line
                    });
            }

            agriMandiService.getWCMContent(request).then(function (data) {
                agriLandingVm.products = data;
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        });

        agriLandingVm.goToBachat = function(){
            var request = {};
            request.language = agriMandiService.selectLanguage;
            agriMandiService.bachatInsurance(request).then(function (data) {
                agriMandiService.bachatMerchants = data;
                $state.go('menu.bachat');
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        /* function call on click of KUC banner */
        agriLandingVm.goToKUC = function(){
            agriMandiService.kucBannerFlag = true;
            agriMandiService.getKnowMoreDetails().then(function (data) {
                agriMandiService.kucKnowMoreData = data;
                //Added below check for ISD 
                if(data !== null){
                    if(data.krishakUnnatiCard){
                        $state.go('menu.kucLanding');
                    }    
                }else{
                    utilityService.showErrorMessage("Unable to process.Please try again later");
                }
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        agriLandingVm.goToMandi = function (product) {
            agriMandiService.sourceText = product.text;
            agriMandiService.sourceSubText = product.subText;
            if (product.uniqueName.toLowerCase() == "khata") {
                clickStreamService.clickStreamData = "khata," + agriMandiService.selectLanguage;
                agriLandingVm.goToKhata();
            } else if (product.uniqueName.toLowerCase() == "bachat") {
                clickStreamService.clickStreamData = "bachat," + agriMandiService.selectLanguage;
                agriLandingVm.goToBachat();
            } else if (product.uniqueName.toLowerCase() == "mitra") {
                clickStreamService.clickStreamData = "mitra," + agriMandiService.selectLanguage;
                agriMandiService.source = "mitra";
                $state.go("menu.agriMandiLanding")
            } else if (product.uniqueName.toLowerCase() == "mandi") {
                clickStreamService.clickStreamData = "mandi," + agriMandiService.selectLanguage;
                agriMandiService.source = "mandi";
                $state.go("menu.agriMandiLanding")
            }
        };

        agriLandingVm.goToLoan = function () {
            var comingsoonPopup = $ionicPopup.alert({
                template: '<div class="CSPadding font-dark-grey "><div class="parentCS"><img class="imgwidthCS" src="img/Coming_Soon_Illustration.svg"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="childCS">' +
                "Coming Soon" + '</div></div></div></div></div></div>',
                cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter custButtonCS button0pd',
                buttons: [{
                    text: 'OK',
                    type: 'button-positive',
                    onTap: function (e) {
                        comingsoonPopup.close();
                    }
                }]
            });
        };

        agriLandingVm.chooseLanguage = function(){
            if(agriMandiService.selectLanguage){
                $state.go('menu.agriSelectLanguage');
            }
        }

        return this;
    }

]);