'use strict';

angularApp.controller('agriMandiLandingController', [
    "$state",
    "$scope",
    "$translate",
    "fTBeneficiaryService",
    "cancelScheduledPaymentService",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService",
    "constantConfig",
    "AdapterUtils",
    "$ionicScrollDelegate",
    "fTReviewService",
    "ionicToast",
    "loggedInUserService",
    "cryptoService",
    "getAccountDetailsService",
    "customerInfoService",
    "homeScreenService",
    "$rootScope",
    "billDeskService",
    "applyNowService",
    "personalLoanService",
    "sampoornSurakshaService",
    "cardsService",
    "lifeInsuranceBasicApplicationService",
    "requestYCService",
    "$ionicSideMenuDelegate",
    "$filter", "ompMerchantsService",
    "mPinLoginService", "agriMandiService", "clickStreamService",

    function ($state,
        $scope,
        $translate,
        fTBeneficiaryService,
        cancelScheduledPaymentService,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        constantConfig,
        AdapterUtils,
        $ionicScrollDelegate,
        fTReviewService, ionicToast,
        loggedInUserService, cryptoService,
        getAccountDetailsService,
        customerInfoService,
        homeScreenService,
        $rootScope,
        billDeskService,
        applyNowService,
        personalLoanService,
        sampoornSurakshaService,
        cardsService,
        lifeInsuranceBasicApplicationService,
        requestYCService,
        $ionicSideMenuDelegate,
        $filter, ompMerchantsService, mPinLoginService, agriMandiService, clickStreamService) {

        var agriMandiLandingVm = this;
        
        $scope.agrioptions = {
            loop: false,
		    slidesPerView: 'auto',
			effect: 'slide',
            speed: 500,
            autoplay: 3000
        }
        
        $scope.$on('$ionicView.beforeEnter', function () {
            agriMandiLandingVm.searchLength="70";
            agriMandiLandingVm.search = "";
            agriMandiLandingVm.recentSearch = "";
            agriMandiLandingVm.closeButton = false;
            agriMandiLandingVm.showRecentSearchDiv = false;
            agriMandiLandingVm.showAutocompleteDiv = false;
            agriMandiLandingVm.showErrorMsg=false;
            agriMandiLandingVm.showBannercategory = true;
            agriMandiLandingVm.keywords = [];
            agriMandiLandingVm.recentSearchedList = [];
            agriMandiLandingVm.source = agriMandiService.source;
            agriMandiLandingVm.selectedLanguage =  agriMandiService.selectLanguage;
            (agriMandiService.category) ? agriMandiLandingVm.saveData() : agriMandiLandingVm.getAgriMerchantsWithCategory();
        });

        agriMandiLandingVm.saveData = function(){
            agriMandiLandingVm.category =  agriMandiService.category; 
            agriMandiLandingVm.recentSearchedList = agriMandiService.recentSearchedList;
            agriMandiLandingVm.keywords = agriMandiService.keywords;
            agriMandiLandingVm.banners =  agriMandiService.banners; 
        }

        // Function to call Categoty 
        agriMandiLandingVm.getAgriMerchantsWithCategory = function(){
            let request = {
                "type": agriMandiLandingVm.source
            };
            agriMandiService.getAgriMerchantsWithCategory(request).then(function (data) {
                if(data){
                    agriMandiService.category = data[0].data ? data[0].data : [];
                    agriMandiLandingVm.category =  agriMandiService.category; 
                }
                agriMandiLandingVm.getAgriBanner();   
            }, function (error) {
                agriMandiLandingVm.getAgriBanner();   
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        //Function to call the banner
        agriMandiLandingVm.getAgriBanner = function(){
            let request = {
                "type": agriMandiLandingVm.source
            };
            agriMandiService.getAgriBanner(request).then(function (data) {
                if(data){    
                    agriMandiService.banners = data.getMandiMitraBannerDetails ? data.getMandiMitraBannerDetails : [];
                    agriMandiLandingVm.banners =  agriMandiService.banners; 
                }
                agriMandiLandingVm.agriMitraMandiSerachResult("search");   
            }, function (error) {
                agriMandiLandingVm.agriMitraMandiSerachResult("search");   
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        // Function to call top 5 recent search result from cloudant and to save data 
        agriMandiLandingVm.agriMitraMandiSerachResult = function(action,keyword){
            let request = {
                "keyword": keyword || "",
                "type": agriMandiLandingVm.source,
                "action": action
            }
            agriMandiService.agriMitraMandiSerachResult(request).then(function (data) {
                if(data){
                    agriMandiService.recentSearchedList = data ? data : [];
                    agriMandiLandingVm.recentSearchedList = agriMandiService.recentSearchedList;
                }
                agriMandiLandingVm.getAgriAutosuggestKeyword();
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
                agriMandiLandingVm.recentSearchedList = [];
                agriMandiLandingVm.getAgriAutosuggestKeyword();
            });
        }

        // Function to call Auto suggest keyword on search
        agriMandiLandingVm.getAgriAutosuggestKeyword = function(){
            let request = {
                "type": agriMandiLandingVm.source
            };
            agriMandiService.getAgriAutosuggestKeyword(request).then(function (data) {
                if(data){
                    agriMandiService.keywords = data.keywords ? data.keywords : [];
                    agriMandiLandingVm.keywords = agriMandiService.keywords;
                    agriMandiService.searchLength = data.searchCharacterLimit ? data.searchCharacterLimit : "70";
                    agriMandiLandingVm.searchLength = agriMandiService.searchLength;
                }
                
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
                agriMandiLandingVm.keywords = [];
            });
        }

        agriMandiLandingVm.showRecentSearchHistory = function(){
            if(agriMandiLandingVm.search){
                agriMandiLandingVm.showRecentSearchDiv = false;
                agriMandiLandingVm.showAutocompleteDiv = true;
                agriMandiLandingVm.hideNoResult = false;
                agriMandiLandingVm.showErrorMsg=false;
            }
            else{
                agriMandiLandingVm.showRecentSearchDiv = true;
                agriMandiLandingVm.showAutocompleteDiv = false;
                agriMandiLandingVm.hideNoResult = true;
                agriMandiLandingVm.showErrorMsg=false;
            }
        }

        agriMandiLandingVm.inputBoxChangeEvent = function(){
            agriMandiLandingVm.hideNoResult = false;
            agriMandiLandingVm.closeButton = false;
            agriMandiLandingVm.showAutocompleteDiv = false;
            agriMandiLandingVm.showErrorMsg=false;
            
            if(agriMandiLandingVm.search){
                agriMandiLandingVm.showRecentSearchDiv = false;
                agriMandiLandingVm.showAutocompleteDiv = true;
            } else{
                agriMandiLandingVm.showRecentSearchDiv = true;
                agriMandiLandingVm.showAutocompleteDiv = false;
                agriMandiLandingVm.showBannercategory = true;
            } 
        }

        agriMandiLandingVm.focusOutChange = function(){
            agriMandiLandingVm.showRecentSearchDiv = false;
            agriMandiLandingVm.showAutocompleteDiv = false;
            agriMandiLandingVm.hideNoResult = true;
        }

        agriMandiLandingVm.closeSearchButton = function(){
             agriMandiLandingVm.search='';
             agriMandiLandingVm.showBannercategory = true;
             agriMandiLandingVm.closeButton = false;
             agriMandiLandingVm.showErrorMsg = false;
        }

        agriMandiLandingVm.searchMerchant = function(keyword){           
            if(keyword) agriMandiLandingVm.search = keyword;
            agriMandiLandingVm.showRecentSearchDiv = false;
            agriMandiLandingVm.showAutocompleteDiv = false;
            if(agriMandiLandingVm.search.length>=3){
                agriMandiLandingVm.recentSearch = agriMandiLandingVm.search;
                clickStreamService.clickStreamData = 'q,' + agriMandiLandingVm.recentSearch;
                agriMandiLandingVm.hideNoResult = true;
                agriMandiLandingVm.showBannercategory = false;                
                agriMandiLandingVm.closeButton = true;
                agriMandiLandingVm.showErrorMsg=false;
                let request = { 
                    "type": agriMandiLandingVm.source,
                    "keyword": agriMandiLandingVm.search
                }
                agriMandiService.getAgriMerchantSearch(request).then(function (data) {
                    agriMandiLandingVm.merchantSearch = data.merchantList;                    
                    agriMandiLandingVm.agriMitraMandiSerachResult("save",agriMandiLandingVm.search);
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    agriMandiLandingVm.agriMitraMandiSerachResult("save",agriMandiLandingVm.search);
                });

                if(agriMandiLandingVm.recentSearchedList){
                    let value = agriMandiLandingVm.recentSearchedList.some(function (item) { 
                            return item.keyword.toLowerCase() == agriMandiLandingVm.search.toLowerCase() ? true : false;
                        });
                    if(!value) agriMandiLandingVm.recentSearchedList.unshift({"keyword" : agriMandiLandingVm.search});
                }
                else{
                    agriMandiService.recentSearchedList=[];
                    agriMandiService.recentSearchedList.push({"keyword" : agriMandiLandingVm.search});
                }
                
            }else{
                agriMandiLandingVm.showErrorMsg=true;
            }
            
        }

        agriMandiLandingVm.goToMerchant = function(merchant){
            clickStreamService.clickStreamData = "websiteId," + merchant.affiliateId;
            var request = {};
            request.language = agriMandiService.selectLanguage;
            request.type = 'agriMandiDisclaimer';
            agriMandiService.getDisclaimerContent(request).then(function (data) {
                agriMandiLandingVm.disclamerText = data.text1;
                agriMandiLandingVm.disclamerContent = data.text2;
                agriMandiLandingVm.agreeText = data.button1;
                agriMandiLandingVm.cancelText = data.button2;
                agriMandiLandingVm.myPopup = $ionicPopup.show({
                    title: '',
                    cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',
                    templateUrl: "pages/Agl/aglDisclamerPopupSearch.html",
                    scope: $scope
                });
                agriMandiLandingVm.merchant = merchant;
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        agriMandiLandingVm.agree = function () {
            var merchant = agriMandiLandingVm.merchant;
            clickStreamService.clickStreamData = "websiteId," + merchant.affiliateId;
            var saveLeadObj = {
                "leadId": "",
                "websiteId": merchant.websiteId,
                "affiliateId": merchant.affiliateId,
                "request": {
                    "ompCcustToken": "",
                    "loggedIn": "",
                    "channel": "",
                    "segId": "",
                    "ompTokenId": "",
                    "merchantSku": "",
                    "prdPrice": "",
                    "wishlistSkus": "",
                    "ompDisValue": "",
                    "ompDisPct": "",
                    "ompDisType": "",
                    "isLoggedIn": mPinLoginService.isLoggedIn
                },
                "leadParam": merchant.leadParam,
                "segmentParam": merchant.segmentParam,
                "affiliateIdParam": merchant.affiliateIdParam,
                "mobileRedirectUrl": merchant.mobileRedirectUrl

            }
            agriMandiService.saveMerchantLead(saveLeadObj).then(function (data) {
                agriMandiLandingVm.myPopup.close();
                ompMerchantsService.inAppBrowser(data.mobileUrl);
            }, function (error) {
                agriMandiLandingVm.myPopup.close();
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        agriMandiLandingVm.cancel = function () {
            var merchant = agriMandiLandingVm.merchant;
            agriMandiLandingVm.myPopup.close();
            clickStreamService.clickStreamData = "websiteId," + merchant.affiliateId;
        }

        agriMandiLandingVm.selectedCategory = function(category){
            clickStreamService.clickStreamData = "categoryCode," + category.categoryCode;
            agriMandiService.SelectedCategory = category;
            $state.go('menu.agriMandiMitraMerchant');
        }

        agriMandiLandingVm.goToPrevious = function () {
            $state.go('menu.agriLanding');
        }

        return this;
    }
]);
