'use strict';

angularApp.controller('agriMandiMitraMerchantController', [
    "$state",
    "$scope",
    "$translate",
    "fTBeneficiaryService",
    "cancelScheduledPaymentService",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService",
    "constantConfig",
    "AdapterUtils",
    "$ionicScrollDelegate",
    "fTReviewService",
    "ionicToast",
    "loggedInUserService",
    "cryptoService",
    "getAccountDetailsService",
    "customerInfoService",
    "homeScreenService",
    "$rootScope",
    "billDeskService",
    "applyNowService",
    "personalLoanService",
    "sampoornSurakshaService",
    "cardsService",
    "lifeInsuranceBasicApplicationService",
    "requestYCService",
    "$ionicSideMenuDelegate",
    "$filter", "ompMerchantsService",
    "mPinLoginService", "agriMandiService", "clickStreamService",

    function ($state,
        $scope,
        $translate,
        fTBeneficiaryService,
        cancelScheduledPaymentService,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        constantConfig,
        AdapterUtils,
        $ionicScrollDelegate,
        fTReviewService, ionicToast,
        loggedInUserService, cryptoService,
        getAccountDetailsService,
        customerInfoService,
        homeScreenService,
        $rootScope,
        billDeskService,
        applyNowService,
        personalLoanService,
        sampoornSurakshaService,
        cardsService,
        lifeInsuranceBasicApplicationService,
        requestYCService,
        $ionicSideMenuDelegate,
        $filter, ompMerchantsService, mPinLoginService, agriMandiService, clickStreamService) {

        var agriMandiMitraMerchantVm = this;
        agriMandiMitraMerchantVm.SelectedCategory = agriMandiService.SelectedCategory;
        agriMandiMitraMerchantVm.categoryCode = agriMandiService.SelectedCategory.categoryCode

        agriMandiMitraMerchantVm.goToPrevious = function(){
            $state.go('menu.agriMandiLanding');
        }

        agriMandiMitraMerchantVm.goToMerchant = function(merchant){
            console.dir(merchant);
            clickStreamService.clickStreamData = "websiteId," + merchant.affiliateId + "^categoryCode," + agriMandiMitraMerchantVm.categoryCode;
            var request = {};
            request.language = agriMandiService.selectLanguage;
            request.type = 'agriMandiDisclaimer';
            agriMandiService.getDisclaimerContent(request).then(function (data) {
                agriMandiMitraMerchantVm.disclamerText = data.text1;
                agriMandiMitraMerchantVm.disclamerContent = data.text2;
                agriMandiMitraMerchantVm.agreeText = data.button1;
                agriMandiMitraMerchantVm.cancelText = data.button2;
                agriMandiMitraMerchantVm.myPopup = $ionicPopup.show({
                    title: '',
                    cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',
                    templateUrl: "pages/Agl/aglDisclamerPopup.html",
                    scope: $scope
                });
                agriMandiMitraMerchantVm.merchant = merchant;
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        agriMandiMitraMerchantVm.agree = function () {
            var merchant = agriMandiMitraMerchantVm.merchant;
            clickStreamService.clickStreamData = "websiteId," + merchant.affiliateId + "^categoryCode," + agriMandiMitraMerchantVm.categoryCode;
            var saveLeadObj = {
                "leadId": "",
                "websiteId": merchant.websiteId,
                "affiliateId": merchant.affiliateId,
                "request": {
                    "ompCcustToken": "",
                    "loggedIn": "",
                    "channel": "",
                    "segId": "",
                    "ompTokenId": "",
                    "merchantSku": "",
                    "prdPrice": "",
                    "wishlistSkus": "",
                    "ompDisValue": "",
                    "ompDisPct": "",
                    "ompDisType": "",
                    "isLoggedIn": mPinLoginService.isLoggedIn
                },
                "leadParam": merchant.leadParam,
                "segmentParam": merchant.segmentParam,
                "affiliateIdParam": merchant.affiliateIdParam,
                "mobileRedirectUrl": merchant.mobileRedirectUrl

            }
            console.dir(saveLeadObj);
            agriMandiService.saveMerchantLead(saveLeadObj).then(function (data) {
                agriMandiMitraMerchantVm.myPopup.close();
                ompMerchantsService.inAppBrowser(data.mobileUrl);
            }, function (error) {
                agriMandiMitraMerchantVm.myPopup.close();
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        agriMandiMitraMerchantVm.cancel = function () {
            var merchant = agriMandiMitraMerchantVm.merchant;
            agriMandiMitraMerchantVm.myPopup.close();
            clickStreamService.clickStreamData = "websiteId," + merchant.affiliateId + "^categoryCode," + agriMandiMitraMerchantVm.categoryCode;
        }

        return this;
    }
]);