angularApp.service('agriMandiService',
    function($q, AdapterUtils, utilityService, constantConfig) {

        var agriMandiService = this;
        
        agriMandiService.selectLanguageText = "Language";
        agriMandiService.selectLanguageIndex = 0;
        agriMandiService.isUserFromSettings = false;

        agriMandiService.saveMerchantLead = function(request) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/OMPAdapter/saveMerchantLead", request, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

         agriMandiService.getAgriBanner = function(request) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/OMPAdapter/getAgriBanner", request, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        agriMandiService.getAgriMerchantsWithCategory = function(request) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/OMPAdapter/getAgriMerchantsWithCategory", request, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        agriMandiService.getAgriAutosuggestKeyword = function(request) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/OMPAdapter/getAgriAutosuggestKeyword", request, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        agriMandiService.agriMitraMandiSerachResult = function(request) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/OMPAdapter/agriMitraMandiSerachResult", request, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        agriMandiService.getAgriMerchantSearch = function(request) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/OMPAdapter/getAgriMerchantSearch", request, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        agriMandiService.getAgriMerchants = function(request) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/OMPAdapter/getAgriMerchants", request, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        agriMandiService.getCustomStyle = function(family) {

            var fontFamily = "";
            if (family == "en") {

                fontFamily = { 'font-family': '' };
            } else if (family == "hi") {

                fontFamily = 'font-family : Lohit-Hindi!important;';

            } else if (family == "ma") {


                fontFamily = 'font-family : Lohit-Malyalam!important;';

            } else if (family == "ta") {

                fontFamily = 'font-family :Lohit-Tamil!important;';
            } else if (family == "te") {

                fontFamily = 'font-family : Lohit-Telgu!important;';
            }
            else if(family == "mar")
            {
                 fontFamily = 'font-family : Lohit-Marathi!important;';
            }
             else if(family == "ka")
            {
                fontFamily = 'font-family : Lohit-Kannada!important;';
                
            } else if (family == "be") {
                fontFamily = 'font-family : Lohit-Bengali!important;';
            } else if (family == "as") {
                fontFamily = 'font-family : Lohit-Assamese!important;';
            } else if (family == "gu") {
                fontFamily = 'font-family : Lohit-Gujarati!important;';
            } else if (family == "or") {
                fontFamily = 'font-family : Lohit-Oriya!important;';
            } else if (family == "pu") {
                fontFamily = 'font-family : Lohit-Punjabi!important;';
            }

           

            return fontFamily;
        }

        agriMandiService.getWCMContent = function(request) {
           var request = { 
                "language": request.language,
                "type": "KCC"
            };
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/AgriGold/getWCMContent", request, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;


        }

         agriMandiService.getDisclaimerContent = function(request) {
           
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/AgriGold/getDisclaimerContent", request, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;    


        }

           agriMandiService.executeYonoDedup = function() {
            var request = {};
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/AgriGold/executeYonoDedup", request, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;


        }
          agriMandiService.executeYonoDedupe = function() {
            var request = {};
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/AgriGold/executeYonoDedupe", request, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;


        }

         agriMandiService.executeBusinessEligibilty = function(request) {
           
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/AgriGold/executeBusinessEligibility", request, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;


        }

            agriMandiService.saveData = function(request) {
           
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/AgriGold/saveData", request, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;


        }

           agriMandiService.getAccounts = function() {
            var request = {};
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/AgriGold/getAccounts", request, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;


        }

          agriMandiService.losDataPush = function(request) {
            
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/AgriGold/losDataPush", request, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;


        }

          agriMandiService.checkStatus = function(request) {
            
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/AgriGold/checkStatus", request, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;


        }

          agriMandiService.resumeApplication = function(request) {
            
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/AgriGold/resumeApplication", request, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;


        }

        agriMandiService.updateLanguage = function(request) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/AgriGold/updateLanguage", request, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

         agriMandiService.clearData = function(request) {
            
            agriMandiService.addData ="";
            agriMandiService.resumeData="";
           


        }

                agriMandiService.bachatInsurance = function(request) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/AgriGold/bachatInsurance", request, true).then(
                function(response) {
                    q.resolve(response.agriData);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        /* KUC services start here */
        agriMandiService.checkEligibilityKUC = function() {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/KUC/checkEligibility", {}, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        agriMandiService.getKUCBanner = function() {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/KUC/getKUCBanner", {}, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        agriMandiService.getKnowMoreDetails = function() {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/KUC/getKnowMoreDetails", {}, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        

        return agriMandiService;

    });