'use strict';

angularApp.controller('bachatController', [
    "$state",
    "$scope",
    "utilityService",
    "sampoornSurakshaService",
    "agriMandiService",
    "generalInsurenceHomeService",

    function ($state,
        $scope,
        utilityService,
        sampoornSurakshaService,
        agriMandiService,
        generalInsurenceHomeService) {

        var bachatVm = this;

        bachatVm.goToPrevious = function () {
            $state.go('menu.agriLanding')
        };

        bachatVm.goToAGL = function () {
            agriMandiService.executeYonoDedupe().then(function (data) {
                agriMandiService.WCMData = data;
                $state.go('menu.aglKnowMore');
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            bachatVm.merchants = agriMandiService.bachatMerchants;
            bachatVm.sourceText = agriMandiService.sourceText;
            // var request = {};
            // request.language = agriMandiService.selectLanguage;
            // agriMandiService.bachatInsurance(request).then(function (data) {
            //     bachatVm.merchants = data;
            // }, function (error) {
            //     utilityService.showErrorMessage(error.responseMessage);
            // });
        });

        bachatVm.goToMerchant = function (merchant) {
            if (merchant.redirectionUrl == "111N040V04") {
                sampoornSurakshaService.getPremiumAndNomineeInfo().then(function (data) {
                    sampoornSurakshaService.clearAll();
                    sampoornSurakshaService.setPremiumDetails(data);
                    $state.go('menu.ssPremiumCalculation');
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }else if(merchant.redirectionUrl == "krishak-unnati-card"){
                agriMandiService.getKnowMoreDetails().then(function (data) {
                    agriMandiService.kucKnowMoreData = data;
                    $state.go('menu.kucLanding');
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else {
                generalInsurenceHomeService.setGIProductsID(merchant.redirectionUrl);
                $state.go("menu.declaimer");
            }
        };

        return this;
    }
]);