'use strict';

angularApp.controller('kccKhataLandingController', [
    "$state",
    "$scope",
    "$translate",
    "$ionicSideMenuDelegate",
    "$filter", "$ionicPopover", "$ionicScrollDelegate", "utilityService","kccService", "agriMandiService","AdapterUtils",

    function ($state,
        $scope,
        $translate,
        $ionicSideMenuDelegate,
        $filter, $ionicPopover, $ionicScrollDelegate, utilityService,kccService, agriMandiService,AdapterUtils) {

        var kccKhataLandingVm = this;

        kccKhataLandingVm.goBack = function () {
            $state.go("menu.agriLanding");
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            if (utilityService.isIOSPlatform()) {
                kccKhataLandingVm.scroll = false;
            } else {
                kccKhataLandingVm.scroll = true;
            }
           
            kccKhataLandingVm.customStyle = agriMandiService.getCustomStyle(agriMandiService.selectLanguage);
           
        });

        kccKhataLandingVm.goToKCC = function () {
             kccService.executeYonoDedup().then(function (data) {
                kccService.WCMData = data;
                kccService.appData = data;
                $state.go('menu.kccKnowMore');
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        };

        kccKhataLandingVm.goToAGL = function () {
            agriMandiService.executeYonoDedupe().then(function (data) {
                agriMandiService.WCMData = data;
                $state.go('menu.aglKnowMore');
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            kccKhataLandingVm.customStyle = agriMandiService.getCustomStyle(agriMandiService.selectLanguage);
            kccKhataLandingVm.sourceText = agriMandiService.sourceText;
        });

        return this;
    }
]);