'use strict';
angularApp.controller('kccKnowMoreController', [
    "$state",
    "$scope",
    "$translate",
    "$ionicPopup",
    "utilityService",
    "constantConfig",
    "kccService",
    "agriMandiService",
    "AdapterUtils",
    function ($state,
        $scope,
        $translate,
        $ionicPopup,
        utilityService,
        constantConfig,
        kccService,
        agriMandiService,AdapterUtils) {
        var kccKnowMoreVm = this;
        kccKnowMoreVm.goback = function () {
            $state.go('menu.kccKhataLanding');
        };
        $scope.$on('$ionicView.beforeEnter', function () {
            kccKnowMoreVm.appExist = kccService.appData.appExist;
            kccKnowMoreVm.customStyle = agriMandiService.getCustomStyle(agriMandiService.selectLanguage);
            kccKnowMoreVm.process = kccService.WCMData.tabContent.process;
            kccKnowMoreVm.features = kccService.WCMData.tabContent.features;
            kccKnowMoreVm.preRequisites = kccService.WCMData.tabContent.preRequisites;
            kccKnowMoreVm.interest = kccService.WCMData.tabContent.interestAndFee;
            kccKnowMoreVm.tab = 1;
        });
        kccKnowMoreVm.selTab = function (sel) {
            kccKnowMoreVm.tab = sel;
        }
        kccKnowMoreVm.goToKCC = function (appStatus) {
            if (appStatus == 'KCC_APPLY') {
                var request = {};
                request.language = agriMandiService.selectLanguage;
                kccService.executeBusinessEligibility(request).then(function (data) {
                    {
                        kccService.masterdata = data;
                        if (data.status == "AL02") {
                            kccService.dedupErrors = data.reasons;
                            $state.go('menu.kccError');
                        } else {
                            $state.go('menu.kccPersonalDetails');
                        }
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else {
                if (kccService.appData.yonoRef && kccService.appData.appStatus && kccService.appData.appStatus.toLowerCase() == 'rejected') {
                    utilityService.showBhimUpiAlert("error", kccService.appData.multilingualAppStatus);
                } else if (kccService.appData.yonoRef && kccService.appData.appStatus && kccService.appData.appStatus.toLowerCase() !== 'approved') {
                    utilityService.showErrorMessage(kccService.appData.multilingualAppStatus);
                } else if (kccService.appData.yonoRef && kccService.appData.appStatus && kccService.appData.appStatus.toLowerCase() == 'approved') {
                    $state.go('menu.kccApproved');
                } else {
                    utilityService.showBhimUpiAlert("error", "Dear customer we are facing technical issues, please retry after sometime.");
                }
            }
        }
        return this;
    }
]);