'use strict';
angularApp.controller('kccOtpController', [
    "$state",
    "$scope",
    "$ionicHistory",
    "utilityService",
    "customerInfoService",
    "homeScreenService",
    "instaHomeService",
    "agriMandiService", "kccService","AdapterUtils","fTSetOTPService",
    function ($state,
        $scope,
        $ionicHistory,
        utilityService,
        customerInfoService,
        homeScreenService,
        instaHomeService,
        agriMandiService, kccService,AdapterUtils,fTSetOTPService) {
        var kccOtpVm = this;
        kccOtpVm.goToPrevious = function () {
            $state.go('menu.homeScreen')
        };
        kccOtpVm.closeView = function () {
            $state.go('menu.kccKhataLanding');
        }
        $scope.$on('$ionicView.beforeEnter', function () {
            kccOtpVm.clickCount = 0;
            kccOtpVm.isDisabledOTP = false;
            if (utilityService.isIOSPlatform()) {
                kccOtpVm.scroll = false;
            } else {
                kccOtpVm.scroll = true;
            }
            kccOtpVm.detail = {};
            kccOtpVm.showDescription = false;
            kccOtpVm.customStyle = agriMandiService.getCustomStyle(agriMandiService.selectLanguage);
            kccOtpVm.masterdata = angular.copy(kccService.masterdata);
            kccOtpVm.detail = angular.copy(kccOtpVm.masterdata);
            kccOtpVm.showSelect = true;
            kccOtpVm.detail.mobileNo = customerInfoService.customer.mobile;
            kccOtpVm.disableNext = true;
        });
        kccOtpVm.submit = function () {
            if (kccOtpVm.otp) {
                var reqParams = {};
                reqParams["otp"] = kccOtpVm.otp;
                reqParams["mobile"] = customerInfoService.customer.mobile;
                fTSetOTPService.validateOTP(reqParams).then(function (response) {
                    if (response.status.toLowerCase() == 'success') {
                        var req = {};
                        req.isPmfby = kccService.pmfby;
                        req.consent = kccService.consent;
                        kccService.submitApplication(req).then(function (data) {
                            kccService.kccDetails = data;
                            $state.go("menu.kccrefNumber");
                        }, function (error) {
                            kccOtpVm.otp = "";
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    } else {
                        kccOtpVm.otp = "";
                        utilityService.showErrorMessage("Please enter valid OTP");
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else {
                kccOtpVm.otp = "";
                utilityService.showErrorMessage("Please enter 6 digit otp to proceed.");
            }
        }
        kccOtpVm.resendOTP = function () {
            kccOtpVm.otp = "";
            var reqObj = {
                "id": customerInfoService.customer.mobile,
                "emailId": customerInfoService.customer.emailID
            }
            instaHomeService.requestOtp(reqObj).then(function (data) {
                if (kccOtpVm.clickCount == 2) {
                    kccOtpVm.isDisabledOTP = true;
                } else {
                    kccOtpVm.isDisabledOTP = false;
                    kccOtpVm.clickCount = kccOtpVm.clickCount + 1;
                }
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        };
        kccOtpVm.goBack = function () {
            $ionicHistory.goBack(-1);
        }
        return this;
    }
]);