'use strict';

angularApp.controller('kccPersonalDetailsController', [
    "$state",
    "$scope",
    "$ionicHistory",
    "utilityService",
    "agriMandiService",
    "kccService",
    "homeLoanService",
    "AdapterUtils",
    "$ionicPopup",
    function ($state,
        $scope,
        $ionicHistory,
        utilityService, agriMandiService, kccService, homeLoanService,AdapterUtils,$ionicPopup) {
        var kccPersonalDetailsVm = this;
        kccPersonalDetailsVm.goToPrevious = function () {
            $state.go('menu.homeScreen')
        };
        kccPersonalDetailsVm.goToCross = function () {
            $state.go('menu.kccKhataLanding')
        };
        $scope.$on('$ionicView.beforeEnter', function () {
            kccPersonalDetailsVm.detail = {};
            if (utilityService.isIOSPlatform()) {
                kccPersonalDetailsVm.scroll = false;
            } else {
                kccPersonalDetailsVm.scroll = true;
            }
            kccPersonalDetailsVm.masterdata = angular.copy(kccService.masterdata);
            kccPersonalDetailsVm.detail = angular.copy(kccPersonalDetailsVm.masterdata);
            
            kccPersonalDetailsVm.detail.name = kccPersonalDetailsVm.masterdata.firstName + "  " + kccPersonalDetailsVm.masterdata.lastName;
            kccPersonalDetailsVm.detail.kccAccountNo = kccPersonalDetailsVm.masterdata.kccAccountNo;
            kccPersonalDetailsVm.detail.aadharNo = kccPersonalDetailsVm.masterdata.aadharNo;
            kccPersonalDetailsVm.detail.maritalStatus = kccPersonalDetailsVm.masterdata.maritalStatus;

            //Check all details are coming from server

            
            kccPersonalDetailsVm.personalDetails = (kccPersonalDetailsVm.detail && kccPersonalDetailsVm.detail.firstName && kccPersonalDetailsVm.detail.lastName && kccPersonalDetailsVm.detail.kccAccountNo && kccPersonalDetailsVm.detail.aadharNo && kccPersonalDetailsVm.detail.maritalStatus && kccPersonalDetailsVm.detail.eduQualification && kccPersonalDetailsVm.detail.category) ? true : false;

            if (kccPersonalDetailsVm.personalDetails) {
                if (kccPersonalDetailsVm.detail.maritalStatus) {
                    for (var i = 0; i < kccPersonalDetailsVm.masterdata.master.maritalStatuses.length; i++) {
                        if (kccPersonalDetailsVm.detail.maritalStatus == kccPersonalDetailsVm.masterdata.master.maritalStatuses[i].key) {
                            kccPersonalDetailsVm.detail.maritalStatus = kccPersonalDetailsVm.masterdata.master.maritalStatuses[i].value;
                        }
                    }
                }
                kccPersonalDetailsVm.detail.eduQualification = kccPersonalDetailsVm.masterdata.eduQualification;
                if (kccPersonalDetailsVm.detail.eduQualification) {
                    for (var i = 0; i < kccPersonalDetailsVm.masterdata.master.qualifications.length; i++) {
                        if (Number(kccPersonalDetailsVm.detail.eduQualification) == Number(kccPersonalDetailsVm.masterdata.master.qualifications[i].key)) {
                            kccPersonalDetailsVm.detail.eduQualification = kccPersonalDetailsVm.masterdata.master.qualifications[i].value;
                        }
                    }
                }
                kccPersonalDetailsVm.detail.category = kccPersonalDetailsVm.masterdata.category;
                if (kccPersonalDetailsVm.detail.category) {
                    for (var i = 0; i < kccPersonalDetailsVm.masterdata.master.categories.length; i++) {
                        if (kccPersonalDetailsVm.detail.category == kccPersonalDetailsVm.masterdata.master.categories[i].key) {
                            kccPersonalDetailsVm.detail.category = kccPersonalDetailsVm.masterdata.master.categories[i].value;
                        }
                    }
                }
            } else {
                // Display info message 
                var popup = $ionicPopup.alert({
                    title: "",
                    template: '<div class="popup-padding font-dark-grey"><div><center><img class="approvedIconPosition" src="img/agri/Error.svg"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><span class="popUp-msg-color">'
                    + '{{"KCC_PD_SHLD_AVAILABLE" | translate}}' + '</span></div></div></div>',
                    cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup',
                    buttons: [{
                        text: '<b>OK</b>',
                        type: 'button-positive',
                        onTap: function () {
                            popup.close();
                            $state.go("menu.agriLanding");
                        }
                    }]
                });

            }
            kccPersonalDetailsVm.customStyle = agriMandiService.getCustomStyle(agriMandiService.selectLanguage);
            if (agriMandiService.loanData) {
                kccPersonalDetailsVm.detail = agriMandiService.loanData;
            }
            kccPersonalDetailsVm.isMaskAcc = true;
            kccPersonalDetailsVm.isMaskAd = true;
            
        });
        kccPersonalDetailsVm.goToNextPage = function () {
            var saveObj = "";
            kccService.getLandAndCropDetails(saveObj).then(function (data) {
                kccService.dataForKCC = data;
                $state.go("menu.kccLandholding");
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
        kccPersonalDetailsVm.goBack = function () {
            $ionicHistory.goBack(-1);;
        }
        kccPersonalDetailsVm.unmaskData = function (idType) {
            var request = {
                "type": idType,
                "loanType": "kccReview"
            }
            if (idType == 'accountNumber' || idType == 'aadhaar') {
                homeLoanService.getUnmaskData(request).then(function (data) {
                    if (idType == 'accountNumber') {
                        kccPersonalDetailsVm.isMaskAcc = false;
                        kccPersonalDetailsVm.detail.kccAccountNo = data;
                    } else if (idType == 'aadhaar') {
                        kccPersonalDetailsVm.isMaskAd = false;
                        kccPersonalDetailsVm.detail.aadharNo = data;
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else {
                if (idType == 'naccountNumber') {
                    kccPersonalDetailsVm.isMaskAcc = true;
                    kccPersonalDetailsVm.detail.kccAccountNo = kccPersonalDetailsVm.masterdata.kccAccountNo;
                } else if (idType == 'naadhaar') {
                    kccPersonalDetailsVm.isMaskAd = true;
                    kccPersonalDetailsVm.detail.aadharNo = kccPersonalDetailsVm.masterdata.aadharNo;
                }

            }

        }
        return this;
    }
]);
