'use strict';
angularApp.controller('kccReviewController', [
    "$state",
    "$scope",
    "$ionicHistory",
    "utilityService",
    "customerInfoService",
    "instaHomeService",
    "agriMandiService", "kccService", "homeLoanService","AdapterUtils",
    function ($state,
        $scope,
        $ionicHistory,
        utilityService,
        customerInfoService,
        instaHomeService,
        agriMandiService, kccService, homeLoanService,AdapterUtils) {
        var kccReviewVm = this;
        kccReviewVm.goToPrevious = function () {
            $state.go('menu.homeScreen')
        };
        kccReviewVm.closeView = function () {
            $state.go('menu.kccKhataLanding');
        }
        $scope.$on('$ionicView.beforeEnter', function () {
            kccReviewVm.consent = false;
            
            kccReviewVm.detail = {};
            kccReviewVm.customStyle = agriMandiService.getCustomStyle(agriMandiService.selectLanguage);
            kccReviewVm.selectedLanguage = agriMandiService.selectLanguage;

            kccReviewVm.masterdata = angular.copy(kccService.masterdata);
            kccReviewVm.detail = angular.copy(kccReviewVm.masterdata);
            kccReviewVm.showSelect = true;
            kccReviewVm.detail = angular.copy(kccReviewVm.masterdata);
            kccReviewVm.detail.name = kccReviewVm.masterdata.firstName + " " + kccReviewVm.masterdata.lastName;
            kccReviewVm.detail.kccAccountNo = kccReviewVm.masterdata.kccAccountNo;
            kccReviewVm.detail.aadharNo = kccReviewVm.masterdata.aadharNo;
            kccReviewVm.detail.currYearEligibleMdl = kccReviewVm.masterdata.currYearEligibleMdl;
            kccReviewVm.detail.pmsbyAmount = kccReviewVm.masterdata.pmsbyAmount;
            kccReviewVm.detail.totlLandArea = kccService.dataForKCC.totalLandArea;
            kccReviewVm.detail.croppatern = kccService.dataForKCC.cropPattern;
            kccReviewVm.detail.maritalStatus = kccReviewVm.masterdata.maritalStatus;
            if (kccReviewVm.detail.maritalStatus && kccReviewVm.detail.maritalStatus !== '-') {
                for (var i = 0; i < kccReviewVm.masterdata.master.maritalStatuses.length; i++) {
                    if (kccReviewVm.detail.maritalStatus == kccReviewVm.masterdata.master.maritalStatuses[i].key) {
                        kccReviewVm.detail.maritalStatus = kccReviewVm.masterdata.master.maritalStatuses[i].value;
                    }
                }
            } else {
                kccReviewVm.detail.maritalStatus = '-';
            }
            kccReviewVm.detail.eduQualification = kccReviewVm.masterdata.eduQualification;
            if (kccReviewVm.detail.eduQualification && kccReviewVm.detail.eduQualification !== '-') {
                for (var i = 0; i < kccReviewVm.masterdata.master.qualifications.length; i++) {
                    if (Number(kccReviewVm.detail.eduQualification) == Number(kccReviewVm.masterdata.master.qualifications[i].key)) {
                        kccReviewVm.detail.eduQualification = kccReviewVm.masterdata.master.qualifications[i].value;
                    }
                }
            } else {
                kccReviewVm.detail.eduQualification = '-';
            }
            kccReviewVm.detail.category = kccReviewVm.masterdata.category;
            if (kccReviewVm.detail.category && kccReviewVm.detail.category !== '-') {
                for (var i = 0; i < kccReviewVm.masterdata.master.categories.length; i++) {
                    if (kccReviewVm.detail.category == kccReviewVm.masterdata.master.categories[i].key) {
                        kccReviewVm.detail.category = kccReviewVm.masterdata.master.categories[i].value;
                    }
                }
            } else {
                kccReviewVm.detail.category = '-';
            }
            kccReviewVm.isMaskAcc = true;
            kccReviewVm.isMaskAd = true;
        });
        kccReviewVm.confirm = function () {
            kccService.pmfby = kccReviewVm.pmfby ? 'true' : 'false';
            kccService.consent = kccReviewVm.consent;
            var reqObj = {
                "id": customerInfoService.customer.mobile,
                "emailId": customerInfoService.customer.emailID
            }
            instaHomeService.requestOtp(reqObj).then(function (data) {
                $state.go('menu.kccOtp');
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
        kccReviewVm.goBack = function () {
            $ionicHistory.goBack(-1);
        }
        kccReviewVm.unmaskData = function (idType) {
            var request = {
                "type": idType,
                "loanType": "kccReview"
            }
            if (idType == 'accountNumber' || idType == 'aadhaar') {
                homeLoanService.getUnmaskData(request).then(function (data) {
                    if (idType == 'accountNumber') {
                        kccReviewVm.isMaskAcc = false;
                        kccReviewVm.detail.kccAccountNo = data;
                    } else if (idType == 'aadhaar') {
                        kccReviewVm.isMaskAd = false;
                        kccReviewVm.detail.aadharNo = data;
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else {
                if (idType == 'naccountNumber') {
                    kccReviewVm.isMaskAcc = true;
                    kccReviewVm.detail.kccAccountNo = kccReviewVm.masterdata.kccAccountNo;
                } else if (idType == 'naadhaar') {
                    kccReviewVm.isMaskAd = true;
                    kccReviewVm.detail.aadharNo = kccReviewVm.masterdata.aadharNo;
                }
            }
        }
        return this;
    }
]);