'use strict';

angularApp.controller('safalIntroductionController', [
    "$state",
    "$scope",
    "$translate",
    "fTBeneficiaryService",
    "cancelScheduledPaymentService",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService",
    "constantConfig",
    "AdapterUtils",
    "$ionicScrollDelegate",
    "fTReviewService",
    "ionicToast",
    "loggedInUserService",
    "cryptoService",
    "getAccountDetailsService",
    "customerInfoService",
    "homeScreenService",
    "$rootScope",
    "billDeskService",
    "applyNowService",
    "personalLoanService",
    "sampoornSurakshaService",
    "cardsService",
    "lifeInsuranceBasicApplicationService",
    "requestYCService",
    "$ionicSideMenuDelegate",
    "$filter","safalService","agriMandiService",

    function($state,
        $scope,
        $translate,
        fTBeneficiaryService,
        cancelScheduledPaymentService,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        constantConfig,
        AdapterUtils,
        $ionicScrollDelegate,
        fTReviewService, ionicToast,
        loggedInUserService, cryptoService,
        getAccountDetailsService,
        customerInfoService,
        homeScreenService,
        $rootScope,
        billDeskService,
        applyNowService,
        personalLoanService,
        sampoornSurakshaService,
        cardsService,
        lifeInsuranceBasicApplicationService,
        requestYCService,
        $ionicSideMenuDelegate,
        $filter,safalService,agriMandiService) {

        var safalIntroductionVm = this;
        
        safalService.Errors = [];
        $scope.$on('$ionicView.beforeEnter', function() {
            safalIntroductionVm.isCropProduction = "";
            safalIntroductionVm.ProductTitle ="";
            safalIntroductionVm.ProductBody = "";
            safalIntroductionVm.InterestTitle = "";
            safalIntroductionVm.InterestBody = "";
            safalIntroductionVm.isCropProduction = safalService.isCropProduction;
            var request = {};
            request.languageCode = agriMandiService.selectLanguage;
            if(safalIntroductionVm.isCropProduction){
                request.loanType ="CROP";
           }
           else{
               request.loanType ="DAIRY";
           }
           safalService.getProductDetails(request).then(function (data) {
                 
            if (data.safalLoanAlreadyAvailed == true){
                safalService.successDetails = data.safalDedupeData;
                $state.go('menu.safalSuccess')
            }
            else{
                safalIntroductionVm.ProductTitle = data.productDetailData.productDetails;
                safalIntroductionVm.ProductBody = data.productDetailData.productDetailsBody;
                safalIntroductionVm.InterestTitle = data.productDetailData.interestRate;
                safalIntroductionVm.InterestBody = data.productDetailData.interestRateBody;
                safalService.masterCloudData = data.productDetailData.sflMasterData;
                }
            }, function (err) {
                

               if(err.data === "" || err.data === null){


                 $ionicPopup.alert({
                        title: "",
                        template:  '<div class="popup-padding font-dark-grey"><div><center><img class="approvedIconPosition" src="img/FT/BhimUpi/errorSymbol.svg"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><span class="popUp-msg-color">'
                        + err.responseMessage + '</span></div></div></div>',
                        scope: $scope,
                        cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup',
                        buttons: [
                            {
                                text: "OK",
                                type: 'button-positive',
                                onTap: function () {
                                 
                                        $state.go('menu.homeScreen');
                                   
                                }
                            }
                        ],
                    });
              
                    
                }
                else{
                    utilityService.showErrorMessage(err.responseMessage);
                }
                       
            });         
        });

        safalIntroductionVm.goBack = function() {
            $state.go('menu.homeScreen')
        }

        safalIntroductionVm.goToPersonalDetails = function() {
         
            var reqData = {};
            reqData.loanType = "SAFAL";
            reqData.loanCategory = safalService.loanType;
            reqData.languageCode = agriMandiService.selectLanguage;
                   
        
                    safalService.safalPersonalAndCorporateDetails(reqData).then(function (data) {
                        safalService.masterdata = data;
                        $state.go('menu.safalPersonalDetails')
                    }, function (err) {

                        var errString = err.errorCode.substring(0, 6);

                        if (errString == "SFL_01") {

                            safalService.Errors =  err.data.ruleViolations;
                           
                            $state.go('menu.safalError')

                        }
                        else{
                            utilityService.showErrorMessage(err.responseMessage);
                       
                         }
                         
                    });

         
        }

 
    }

]);