'use strict';

angularApp.controller('safalLoanDetailsController', [
    "$state",
    "$scope",
    "$translate",
    "fTBeneficiaryService",
    "cancelScheduledPaymentService",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService",
    "constantConfig",
    "AdapterUtils",
    "$ionicScrollDelegate",
    "fTReviewService",
    "ionicToast",
    "loggedInUserService",
    "cryptoService",
    "getAccountDetailsService",
    "customerInfoService",
    "homeScreenService",
    "$rootScope",
    "billDeskService",
    "applyNowService",
    "personalLoanService",
    "sampoornSurakshaService",
    "cardsService",
    "lifeInsuranceBasicApplicationService",
    "requestYCService",
    "$ionicSideMenuDelegate",
    "$filter","safalService","agriMandiService","$timeout",

    function($state,
        $scope,
        $translate,
        fTBeneficiaryService,
        cancelScheduledPaymentService,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        constantConfig,
        AdapterUtils,
        $ionicScrollDelegate,
        fTReviewService, ionicToast,
        loggedInUserService, cryptoService,
        getAccountDetailsService,
        customerInfoService,
        homeScreenService,
        $rootScope,
        billDeskService,
        applyNowService,
        personalLoanService,
        sampoornSurakshaService,
        cardsService,
        lifeInsuranceBasicApplicationService,
        requestYCService,
        $ionicSideMenuDelegate,
        $filter,safalService,agriMandiService, $timeout) {

        var safalLoanDetailsVm = this;
        safalLoanDetailsVm.languageSelectionTNCLeft = false; 
        safalLoanDetailsVm.languageSelectionTNCRight = false; 
        safalLoanDetailsVm.languageSelectionTNCMiddle = false;
        safalLoanDetailsVm.pmfby = false;
        safalLoanDetailsVm.months = 12;
        safalLoanDetailsVm.mReduction = 0;
        $scope.$on('$ionicView.beforeEnter', function() {

           safalLoanDetailsVm.isCropProduction = safalService.isCropProduction;
           safalLoanDetailsVm.disablesubmit = true;
           safalLoanDetailsVm.emiAmount = 0;
           safalLoanDetailsVm.maxEligibleLoanAmt = 0;
           safalLoanDetailsVm.masterdata = angular.copy(safalService.masterdata);
           safalLoanDetailsVm.detail = angular.copy(safalLoanDetailsVm.masterdata);
           safalLoanDetailsVm.masterCloudData = angular.copy(safalService.masterCloudData);
           safalLoanDetailsVm.step = 1;
           safalLoanDetailsVm.errorInAmount = false;
           safalLoanDetailsVm.errorInMinAmount = false;
           safalLoanDetailsVm.errorInMaxAmount = false;
        
           if(agriMandiService.selectLanguage === "en" || agriMandiService.selectLanguage === "ma" ){
                safalLoanDetailsVm.languageSelectionTNCLeft = true;
                safalLoanDetailsVm.languageSelectionTNCRight = false;
                safalLoanDetailsVm.languageSelectionTNCMiddle = false;
           }
           else if(agriMandiService.selectLanguage === "gu"){
                safalLoanDetailsVm.languageSelectionTNCLeft = false;
                safalLoanDetailsVm.languageSelectionTNCRight = true;
                safalLoanDetailsVm.languageSelectionTNCMiddle = false;
           }
           else if(agriMandiService.selectLanguage === "as" || agriMandiService.selectLanguage === "mar" || agriMandiService.selectLanguage === "pu" || agriMandiService.selectLanguage === "ta" || agriMandiService.selectLanguage === "be" || agriMandiService.selectLanguage === "hi" || agriMandiService.selectLanguage === "ka" || agriMandiService.selectLanguage === "te" || agriMandiService.selectLanguage === "or"){
                safalLoanDetailsVm.languageSelectionTNCLeft = false;
                safalLoanDetailsVm.languageSelectionTNCRight = false;
                safalLoanDetailsVm.languageSelectionTNCMiddle = true;
           }
            

     

           if(safalLoanDetailsVm.isCropProduction){
                   
                    safalLoanDetailsVm.cropLoanTenure = parseInt(safalLoanDetailsVm.masterCloudData.cropLoanTenure);
                    $timeout(function () { 
                        safalLoanDetailsVm.cropAmountSlider = {
                            value: Number(safalLoanDetailsVm.detail.maxEligibleLoanAmt),
                            options: {
                                showSelectionBar: true,
                                floor: Number(safalLoanDetailsVm.masterCloudData.cropMinLoanAmount),
                                ceil: Number(safalLoanDetailsVm.detail.maxEligibleLoanAmt),
                                step: Number(safalLoanDetailsVm.step),
                                onChange : function(id,model){
                                    safalLoanDetailsVm.checkCropAmountLimit();
                                 },
                            }
                        };
                    }, 500);
               }
           else{
               safalLoanDetailsVm.dairyLoanTenure = parseInt(safalLoanDetailsVm.masterCloudData.dairyLoanTenure);
                    $timeout(function () {
                    safalLoanDetailsVm.dairyAmountSlider = {
                        value: Number(safalLoanDetailsVm.detail.maxEligibleLoanAmt),
                        options: {
                            showSelectionBar: true,
                            floor : Number(safalLoanDetailsVm.masterCloudData.dairyMinLoanAmount),
                            ceil : Number(safalLoanDetailsVm.detail.maxEligibleLoanAmt),
                            step : Number(safalLoanDetailsVm.step),
                            onChange : function(id,model){
                                safalLoanDetailsVm.checkDairyAmountLimit();
                               safalLoanDetailsVm.monthlyReduction();
                            },
                            translate : function(value){
                                return rupeeSymbol + $filter('INR')(value);
                            }
                        }
                    };
                    safalLoanDetailsVm.monthlyReduction();
                }, 500);
            }


    });

        safalLoanDetailsVm.monthlyReduction = function () {
            safalLoanDetailsVm.isMonthlyReductionNull = false;
            var p = parseInt(safalLoanDetailsVm.dairyAmountSlider.value);
            var dairyMinLoanAmount = parseInt(safalLoanDetailsVm.masterCloudData.dairyMinLoanAmount);
            var maxEligibleLoanAmt = parseInt(safalLoanDetailsVm.detail.maxEligibleLoanAmt);
            if(p >= dairyMinLoanAmount && p <= maxEligibleLoanAmt){
                  
                safalLoanDetailsVm.mReduction = parseFloat(p/safalLoanDetailsVm.masterCloudData.dairyLoanTenure);
                console.log("monthly reduction",+safalLoanDetailsVm.mReduction);  
            }
            else{
                safalLoanDetailsVm.isMonthlyReductionNull = true;
            }
        }


        safalLoanDetailsVm.checkCropAmountLimit = function () {
            var cropAmountSlider = parseInt(safalLoanDetailsVm.cropAmountSlider.value);
            var cropMinAmount = parseInt(safalLoanDetailsVm.masterCloudData.cropMinLoanAmount);
            var maxEligibleAmount = parseInt(safalLoanDetailsVm.detail.maxEligibleLoanAmt);
            safalLoanDetailsVm.errorInMinAmount = false;
            safalLoanDetailsVm.errorInMaxAmount = false;
            
            if(cropAmountSlider >= cropMinAmount && cropAmountSlider<= maxEligibleAmount){
                
                safalLoanDetailsVm.errorInAmount = false;
                safalLoanDetailsVm.disablesubmit = false;
                safalLoanDetailsVm.getCheckBoxValue(safalLoanDetailsVm.isChecked);

            } else {

                if(cropAmountSlider <= cropMinAmount){
                    safalLoanDetailsVm.errorInAmount = true;
                    safalLoanDetailsVm.errorInMinAmount = true;
                    safalLoanDetailsVm.disablesubmit = true;
                }
                else if(cropAmountSlider >= maxEligibleAmount)
                {
                        safalLoanDetailsVm.errorInAmount = true;
                        safalLoanDetailsVm.errorInMaxAmount = true;
                        safalLoanDetailsVm.disablesubmit = true;
                  
                }
            }
        }
        safalLoanDetailsVm.checkDairyAmountLimit = function () {
            var maxEligibleAmount = parseInt(safalLoanDetailsVm.detail.maxEligibleLoanAmt);
            var dairyAmountSlider = parseInt(safalLoanDetailsVm.dairyAmountSlider.value);
            var dairyMinAmount = parseInt(safalLoanDetailsVm.masterCloudData.dairyMinLoanAmount);
            safalLoanDetailsVm.errorInMinAmount = false;
            safalLoanDetailsVm.errorInMaxAmount = false;
            if(dairyAmountSlider >= dairyMinAmount && dairyAmountSlider <= maxEligibleAmount){
                safalLoanDetailsVm.errorInAmount = false;
                safalLoanDetailsVm.disablesubmit = false;
                safalLoanDetailsVm.getCheckBoxValue(safalLoanDetailsVm.isChecked);
                safalLoanDetailsVm.monthlyReduction();
                
            } else {

                if(dairyAmountSlider <= dairyMinAmount){
                        safalLoanDetailsVm.errorInAmount = true;
                        safalLoanDetailsVm.errorInMinAmount = true;
                        safalLoanDetailsVm.disablesubmit = true;
                    }
                    else if(dairyAmountSlider >= maxEligibleAmount)
                    {
                            safalLoanDetailsVm.errorInAmount = true;
                            safalLoanDetailsVm.errorInMaxAmount = true;
                            safalLoanDetailsVm.disablesubmit = true;
                      
                    }
                    safalLoanDetailsVm.monthlyReduction();
            }
        }

        safalLoanDetailsVm.getCheckBoxValue = function (isChecked) {
            
            if (isChecked === true) {
                        
                        var maxEligibleAmount = parseInt(safalLoanDetailsVm.detail.maxEligibleLoanAmt);
                        
                if(safalLoanDetailsVm.isCropProduction){
                    var cropAmountSlider = parseInt(safalLoanDetailsVm.cropAmountSlider.value);
                        var cropMinAmount = parseInt(safalLoanDetailsVm.masterCloudData.cropMinLoanAmount);
                        safalLoanDetailsVm.errorInMinAmount = false;
                        safalLoanDetailsVm.errorInMaxAmount = false;
                    if(cropAmountSlider >= cropMinAmount && cropAmountSlider <= maxEligibleAmount){
                                safalLoanDetailsVm.disablesubmit = false;
                
                            } else {
                                if(cropAmountSlider <= cropMinAmount){
                                        safalLoanDetailsVm.errorInAmount = true;
                                        safalLoanDetailsVm.errorInMinAmount = true;
                                        safalLoanDetailsVm.disablesubmit = true;
                                    }
                                    else if(cropAmountSlider >= maxEligibleAmount)
                                    {
                                            safalLoanDetailsVm.errorInAmount = true;
                                            safalLoanDetailsVm.errorInMaxAmount = true;
                                            safalLoanDetailsVm.disablesubmit = true;
                                      
                                    }
                                    
                            }
                }
                else{
                        var dairyAmountSlider = parseInt(safalLoanDetailsVm.dairyAmountSlider.value);
                        var dairyMinAmount = parseInt(safalLoanDetailsVm.masterCloudData.dairyMinLoanAmount);
                        safalLoanDetailsVm.errorInMinAmount = false;
                        safalLoanDetailsVm.errorInMaxAmount = false;
                         if(dairyAmountSlider >= dairyMinAmount && dairyAmountSlider <= maxEligibleAmount){
                                 safalLoanDetailsVm.disablesubmit = false;

                         } else {
                            if(dairyAmountSlider <= dairyMinAmount){
                                    safalLoanDetailsVm.errorInAmount = true;
                                    safalLoanDetailsVm.errorInMinAmount = true;
                                    safalLoanDetailsVm.disablesubmit = true;
                                }
                                else if(dairyAmountSlider >= maxEligibleAmount)
                                {
                                        safalLoanDetailsVm.errorInAmount = true;
                                        safalLoanDetailsVm.errorInMaxAmount = true;
                                        safalLoanDetailsVm.disablesubmit = true;
                                  
                                }
                                safalLoanDetailsVm.monthlyReduction();
                        }
                }

            } else {
                safalLoanDetailsVm.disablesubmit = true;
            }
        }


        safalLoanDetailsVm.getPMFBYCheckBoxValue = function(isPMFBYChecked){
            if (isPMFBYChecked === true) {
                safalLoanDetailsVm.pmfby = true;

           } else {
               safalLoanDetailsVm.pmfby = false;
           }
        }
    
        
        safalLoanDetailsVm.goToTNC = function() {

       
            var reqData = {};   
            reqData.loanType = "SAFAL";
            reqData.languageCode = agriMandiService.selectLanguage;
            safalService.safalTermsAndConditions(reqData).then(function(data) {

                safalLoanDetailsVm.TNCTitle = data.body1;
                safalLoanDetailsVm.TNCBody = data.body2;
                
                safalLoanDetailsVm.myPopup = $ionicPopup.show({
                title: safalLoanDetailsVm.TNCTitle,
                cssClass: 'new-TNC-popup',
                   templateUrl: 'pages/Agl/safal/LoanDetailsTNCPOPUP.html',
                    scope: $scope,
                    buttons: [
                        {
                            text: 'OK',
                            type: 'new-TNC-popup',
                            onTap: function (e) {
                                return true;
                            }
                        }]
                })



            }, function(error) {

                utilityService.showErrorMessage(error.responseMessage);
             });
             

            }

            safalLoanDetailsVm.OK = function() {
                safalLoanDetailsVm.myPopup.close();
              
            }


        safalLoanDetailsVm.goBack = function() {
            $ionicHistory.goBack(-1);;
        }




        safalLoanDetailsVm.goToOTP = function() {
          
            if(safalLoanDetailsVm.isCropProduction){

               
                var updateCropData = {
                    "selectedLoan": safalLoanDetailsVm.cropAmountSlider.value,
                    "pmfby": safalLoanDetailsVm.pmfby,
                };
                safalService.updateData = updateCropData;
          
          
            } 
            else{

                var updateDairyData = {
                    "selectedLoan": safalLoanDetailsVm.dairyAmountSlider.value,
                    "pmfby": "false",
                };

                safalService.updateData = updateDairyData;
               
            }


            $state.go('menu.safalOTP');

            
          
           
        }

      
       
    }
]);