'use strict';

angularApp.controller('safalOTPController', [
    "$state",
    "$scope",
    "$translate",
    "fTBeneficiaryService",
    "cancelScheduledPaymentService",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService",
    "constantConfig",
    "AdapterUtils",
    "$ionicScrollDelegate",
    "fTReviewService",
    "ionicToast",
    "loggedInUserService",
    "cryptoService",
    "getAccountDetailsService",
    "customerInfoService",
    "homeScreenService",
    "fTSetOTPService",
    "$rootScope",
    "billDeskService",
    "applyNowService",
    "personalLoanService",
    "sampoornSurakshaService",
    "cardsService",
    "lifeInsuranceBasicApplicationService",
    "requestYCService",
    "$ionicSideMenuDelegate",
    "$filter","safalService","$timeout",

    function($state,
        $scope,
        $translate,
        fTBeneficiaryService,
        cancelScheduledPaymentService,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        constantConfig,
        AdapterUtils,
        $ionicScrollDelegate,
        fTReviewService, ionicToast,
        loggedInUserService, cryptoService,
        getAccountDetailsService,
        customerInfoService,
        homeScreenService,
        fTSetOTPService,
        $rootScope,
        billDeskService,
        applyNowService,
        personalLoanService,
        sampoornSurakshaService,
        cardsService,
        lifeInsuranceBasicApplicationService,
        requestYCService,
        $ionicSideMenuDelegate,
        $filter,safalService,$timeout) {

        var safalOTPVm = this;
        

        $scope.$on('$ionicView.beforeEnter', function() {         
           
			safalOTPVm.userMobile = $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4);
		    safalOTPVm.isResendDisabled=false;
		    safalOTPVm.clickCount=0;
		    safalOTPVm.disableNext=true;
            safalOTPVm.isSubmitEnabled = true;
            safalOTPVm.clickSubmitCount = 0;
            
            var reqData = {};
			reqData["id"] = $rootScope.mobileNo;
			reqData.otpCode = constantConfig.keysForOTP.SAFALOTP;
			reqData.ocHash = cryptoService.getSHA512EncryptedData(constantConfig.keysForOTP.SAFALOTP).toString();
            fTSetOTPService.generateOTP(reqData).then(function (response) {
                safalOTPVm.isResendDisabled=true;
                $timeout(function () {
                    safalOTPVm.isResendDisabled=false;
                }, 30000);
               
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
         });


        safalOTPVm.resendOTP=function()
          {
            safalOTPVm.getOTPNumber="";
            safalOTPVm.isResendOTP=true;
            var reqData = {};

			reqData["id"] = $rootScope.mobileNo;
			reqData.otpCode = constantConfig.keysForOTP.SAFALOTP;
			reqData.ocHash = cryptoService.getSHA512EncryptedData(constantConfig.keysForOTP.SAFALOTP).toString();
            fTSetOTPService.generateOTP(reqData).then(function (response) {
                safalOTPVm.clickCount++;
                if(safalOTPVm.clickCount>=2){
                    safalOTPVm.isResendDisabled=true;
                }
                else{
                    safalOTPVm.isResendDisabled=true;
                    $timeout(function () {
                        safalOTPVm.isResendDisabled=false;
                    }, 30000);
                }

            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
          }

          safalOTPVm.checkOTPLength = function(){
          	if(safalOTPVm.getOTPNumber.length==6 || !safalOTPVm.getOTPNumber)
		       {
		        safalOTPVm.isSubmitEnabled=false;
		       }
		       else
		       {
		        safalOTPVm.isSubmitEnabled=true;
		       }
        }


        safalOTPVm.goToSuccess = function(){
           
     
            var reqParams = {};
			reqParams["otp"] = safalOTPVm.getOTPNumber;
            reqParams["mobile"] = $rootScope.mobileNo;
            safalOTPVm.clickSubmitCount++;
            if(safalOTPVm.clickSubmitCount<=3){
                
           
			fTSetOTPService.validateOTP(reqParams).then(function (response) {
			if (response.status.toLowerCase() == 'success') {
					var updateData = safalService.updateData;
          
          
        	        safalService.submitSafalApplication(updateData).then(function(response){
                        safalService.successData = response;
                             $state.go('menu.safalSuccess')
				
			}, function(error) {

                $ionicPopup.alert({
                    title: "",
                    template:  '<div class="popup-padding font-dark-grey"><div><center><img class="approvedIconPosition" src="img/FT/BhimUpi/errorSymbol.svg"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><span class="popUp-msg-color">'
                    + error.responseMessage + '</span></div></div></div>',
                    scope: $scope,
                    cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup',
                    buttons: [
                        {
                            text: "OK",
                            type: 'button-positive',
                            onTap: function () {
                             
                                    $state.go('menu.homeScreen');
                               
                            }
                        }
                    ],
                });
			    
            });

           
            } else {
                utilityService.showErrorMessage(response.status);
            }
        }, function (error) {
            utilityService.showErrorMessage(error.responseMessage);
        });

        }
        else{
            safalOTPVm.isSubmitEnabled=true;
        }
    }

        safalOTPVm.goBack = function() {
            $ionicHistory.goBack(-1);;
        }

    
    }
]);