'use strict';
angularApp.controller('selectLanguageController', [
    "$state",
    "$ionicPopup",
    "$scope",
    "ionicToast",
    "customerInfoService",
    "utilityService",
    "constantConfig",
    "loggedInUserService",
    "validationService", "$translate", "agriMandiService", "$ionicHistory","getAccountDetailsService",

    function($state, $ionicPopup, $scope, ionicToast, customerInfoService, utilityService, constantConfig, loggedInUserService, validationService, $translate, agriMandiService, $ionicHistory,getAccountDetailsService) {

        var selectLanguageVm = this;


        selectLanguageVm.goBack = function() {
            $ionicHistory.goBack(-1);
        }


        $scope.$on('$ionicView.beforeEnter', function() {
            if (!getAccountDetailsService.accountOverviewData) {
                getAccountDetailsService.getAccountDetails().then(function (data) {
                    getAccountDetailsService.accountOverviewData = data;
                }, function (error) {});
            }
            agriMandiService.clearData();

            if(agriMandiService.langError)
            {
                selectLanguageVm.showerror =true;
            }
            else
            {
                selectLanguageVm.showerror =false;
            }
            //selectLanguageVm.selectedIndexLocation = 0;
            selectLanguageVm.selectedIndexLocation = agriMandiService.selectLanguageIndex;
            selectLanguageVm.customStyle = agriMandiService.getCustomStyle(agriMandiService.selectLanguage);

            selectLanguageVm.languages = [{ lang: '', key: 'en', vernacular: 'English' },{lang: 'Hindi', key: 'hi', vernacular: 'हिंदी' },{lang: 'Assamese', key: 'as', vernacular: 'অসমীয়া' },{lang: 'Bengali', key: 'be', vernacular: 'বাঙালি' },{lang: 'Gujarati', key: 'gu', vernacular: 'ગુજરાતી' },{ lang: 'Kannada', key: 'ka', vernacular: 'ಕನ್ನಡ' },{ lang: 'Malayalam', key: 'ma', vernacular: 'മലയാളം' },{ lang: 'Marathi', key: 'mar', vernacular: 'मराठी' }, { lang: 'Oriya', key: 'or', vernacular: 'ଓଡ଼ିଆ' },{ lang: 'Punjabi', key: 'pu', vernacular: 'ਪੰਜਾਬੀ' } , { lang: 'Tamil', key: 'ta', vernacular: 'தமிழ்' }, { lang: 'Telugu', key: 'te', vernacular: 'తెలుగు' }];
            if(!selectLanguageVm.selectedIndexLocation && selectLanguageVm.customStyle){
                for(var i=0; i< selectLanguageVm.languages.length; i++){
                    if(selectLanguageVm.languages[i].key == agriMandiService.selectLanguage){
                        selectLanguageVm.selectedIndexLocation = i;
                        agriMandiService.selectLanguageIndex = i;
                    }
                }
            }

        });





        selectLanguageVm.changeLanguage = function(lang, index) {


            selectLanguageVm.selectedIndexLocation = index;
           

        }

        selectLanguageVm.continue = function(lang) {
            agriMandiService.selectLanguage = selectLanguageVm.languages[selectLanguageVm.selectedIndexLocation].key;
            // agriMandiService.selectLanguageText = selectLanguageVm.languages[selectLanguageVm.selectedIndexLocation].vernacular;
            // agriMandiService.selectLanguageIndex = selectLanguageVm.selectedIndexLocation;

            var request = {};
            request.language = agriMandiService.selectLanguage;
            request.type = 'language';
            agriMandiService.getDisclaimerContent(request).then(function(data) {

              
                selectLanguageVm.disclamerText = data.text1;
                selectLanguageVm.disclamerContent = data.text2;
                selectLanguageVm.agreeText = data.button1;
                selectLanguageVm.cancelText = data.button2;
                selectLanguageVm.myPopup = $ionicPopup.show({
                    title: '',
                    cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',
                    templateUrl: "pages/Agl/LanguagePopup.html",
                    scope: $scope
                });



            }, function(error) {

                utilityService.showErrorMessage(error.responseMessage);

            });


        }

        /*Save preferred language */
        selectLanguageVm.savePreferredLanguage = function() {
            var request = {};
            request.language = agriMandiService.selectLanguage;
            //request.type = 'language';
            agriMandiService.updateLanguage(request).then(function(data){
                localStorage.setItem("customerlanguage", agriMandiService.selectLanguage);
                 getAccountDetailsService.accountOverviewData.customerInformation.language = agriMandiService.selectLanguage;

                selectLanguageVm.myPopup.close();
              
                if(agriMandiService.isUserFromSettings) {
                    $state.go('menu.settings');
                    agriMandiService.isUserFromSettings = false;
                }else{
                    agriMandiService.checkEligibilityKUC().then(function(data) {
                            agriMandiService.kucFlag = data.eligibilityStatus;
                            $state.go('menu.agriLanding');
                        }, function (error) {
                            $state.go('menu.agriLanding'); 
                        });
                }
            },function(error){
                selectLanguageVm.myPopup.close();
                utilityService.showErrorMessage(error.responseMessage);
            })
        }
        /*Save preferred language Ends*/

        selectLanguageVm.agree = function(lang) {
            agriMandiService.selectLanguageText = selectLanguageVm.languages[selectLanguageVm.selectedIndexLocation].vernacular;
            agriMandiService.selectLanguageIndex = selectLanguageVm.selectedIndexLocation;
            selectLanguageVm.savePreferredLanguage();   
        }
        
        selectLanguageVm.cancel = function() {
            selectLanguageVm.myPopup.close();
            selectLanguageVm.selectedIndexLocation = agriMandiService.selectLanguageIndex;
            agriMandiService.selectLanguage = getAccountDetailsService.accountOverviewData.customerInformation.language.toLowerCase();
            selectLanguageVm.customStyle = agriMandiService.getCustomStyle(agriMandiService.selectLanguage);
        }




        return this;
    }
]);