'use strict';

angularApp.controller('feedbackController',
	["$timeout",
		"$state",
		"$location",
		"$scope",
		"$rootScope",
		"feedebackService",
		"utilityService",
		"mPinLoginService",
		"$ionicSideMenuDelegate",
		"loggedInUserService",
		"AdapterUtils",

		function ($timeout,
			$state,
			$location,
			$scope,
			$rootScope,
			feedebackService,
			utilityService,
			mPinLoginService,
			$ionicSideMenuDelegate,
			loggedInUserService, AdapterUtils) {

			var feedbackVm = this;
			function initPage() {
				feedbackVm.displaySpinner = true;
				feedbackVm.showBack = false;
				feedbackVm.showNext = true;
				feedbackVm.percentage = $rootScope.profileScore;
				feedbackVm.profilePic = $rootScope.profileImageUrl;
				feedbackVm.profileName = $rootScope.customerName;
				feedbackVm.getFeedback();
				feedbackVm.limit = 2;
				feedbackVm.ratingValue = {}
				feedbackVm.comment = {}
				feedbackVm.setUserFeedback = [];
				$ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
			}

			feedbackVm.getFeedback = function () {
				feedbackVm.displaySpinner = false;
				var data = feedebackService.data;
				feedbackVm.npsData = data.nps;
				if (data.nps) {
					feedbackVm.npsQuestion = data.nps.questionText;
					feedbackVm.npsType = data.nps.type;
				}
				if (data.csat) {
					feedbackVm.feedbackList = data.csat.journies;
					feedbackVm.csatType = data.csat.type;
					feedbackVm.feedbackListLength = data.csat.journies.length;
					feedbackVm.feedbackQuestion = data.csat.questionText;
				}
			}

			feedbackVm.setFeedback = function (index) {
				if (index == undefined) {
					index = 0;
				} else { index = index; }
				try {
					for (var fb = 0; fb < 2; fb++) {
						if (feedbackVm.ratingValue[fb]) {
							feedbackVm.feedbackListLength = feedbackVm.feedbackListLength - 1;
						}
						var type = '';
						var question = ''
						if (feedbackVm.journeyName1[fb] === 'NPS') {
							type = 'NPS';
							question = feedbackVm.npsQuestion;
						} else { type = 'CSAT'; question = feedbackVm.feedbackQuestion; }

						var feedBackObj = {
							"journeyName": feedbackVm.journeyName1[fb],
							"rating": feedbackVm.ratingValue[fb],
							"comment": feedbackVm.comment[fb] || '',
							"feedbackQuestion": question,
							"type": type
						}
						feedbackVm.setUserFeedbackLength = (feedbackVm.setUserFeedback.length + 1);
						if (feedbackVm.journeyName1[fb] != "" && feedbackVm.ratingValue[fb] != "") {
							feedbackVm.setUserFeedback[feedbackVm.setUserFeedbackLength - 1] = feedBackObj;
						}

						feedbackVm.comment[fb] = "";
						feedbackVm.journeyName1[fb] = "";
						feedbackVm.ratingValue[fb] = "";
						var strTypeArray = [];
					}
					feedbackVm.rateLater(index);
				}
				catch (e) {}
			}

			feedbackVm.setCSAT = function () {
				var reqParams = {
					"feedback": feedbackVm.setUserFeedback
				}
				if (mPinLoginService.isLoggedIn) {
					feedebackService.setFeedbackData(reqParams).then(function (data) {
						feedbackVm.rateMeLater();
					}, function (error) {
						feedbackVm.rateMeLater();
					});
				} else {
					feedebackService.setFeedbackDataPreLogin(reqParams).then(function (data) {
						feedbackVm.rateMeLater();
					}, function (error) {
						feedbackVm.rateMeLater();
					});
				}
			}
			feedbackVm.rateLater = function (index) {
				index = index - 1;
				if (feedbackVm.feedbackList != "" && feedbackVm.feedbackList != null && feedbackVm.feedbackList != undefined) {
					if (feedbackVm.feedbackList.length >= 2) {
						feedbackVm.feedbackList.splice(0, 2);
						feedbackVm.feedbackList = feedbackVm.feedbackList;
						feedbackVm.ratingValue[index] = undefined;
						feedbackVm.ratingValue[index + 1] = undefined;
						if (feedbackVm.npsData == null && feedbackVm.feedbackList.length <= 0) {
							feedbackVm.submitCSAT();
						}
					} else if (feedbackVm.feedbackList.length == 1) {
						// feedbackVm.feedbackList.splice(index, 1);
						feedbackVm.feedbackList = feedbackVm.feedbackList;
						feedbackVm.ratingValue[index] = undefined;
						feedbackVm.ratingValue[index + 1] = undefined;
						if(feedbackVm.npsData==null){
							feedbackVm.submitCSAT();
						}
					}
				} else {
					feedbackVm.submitCSAT();
				}
			}

			feedbackVm.submitCSAT = function () {
				feedbackVm.setCSAT();
			}
			feedbackVm.rateMeLater = function () {
				utilityService.csatJournies = [];
			if(mPinLoginService.isLoggedIn)
			{
				feedbackVm.sessionLogout();
			}
			else
			{
				loggedInUserService.logoutUser(true);
			}
			}

			feedbackVm.sessionLogout = function () {
				AdapterUtils.sessionLogout().then(
					function (response) {
						console.log("Logout success !!");
						loggedInUserService.logoutUser(true);
					},
					function (error) {
						console.log("Logout failure !!!");
						loggedInUserService.logoutUser(true);
					}
				);
			}
			
			$scope.$on('$ionicView.beforeEnter', function () {
				initPage();
			});

			return this;
		}]);