'use strict';

angularApp.controller('automallCarListController', ["$state", "$scope", "$rootScope", "$ionicHistory", "utilityService", "clickStreamService", "$ionicSideMenuDelegate", "$ionicPopup", "$ionicSlideBoxDelegate", "$ionicScrollDelegate", "paclService", "carLoanService", "loggedInUserService", "cryptoService", "$filter", "automallService", "$ionicModal", "$timeout",
    function ($state, $scope, $rootScope, $ionicHistory, utilityService, clickStreamService, $ionicSideMenuDelegate, $ionicPopup, $ionicSlideBoxDelegate, $ionicScrollDelegate, paclService, carLoanService, loggedInUserService, cryptoService, $filter, automallService, $ionicModal, $timeout) {
        var automallCarListVm = this;



        automallCarListVm.filters = {};

        automallCarListVm.upperRangeInput = '';
        automallCarListVm.lowerRangeInput = '';

        automallCarListVm.goBack = function () {
            $ionicHistory.goBack();
            automallService.setPageId(1);
            automallService.setSearchTerm('');
        };

        var init = function () {
            automallCarListVm.filters = { 'brands': [], 'price': { 'lowerRange': automallCarListVm.options.floor, 'upperRange': automallCarListVm.options.ceil }, 'bodyType': [] };
            automallCarListVm.showFilters = automallService.getShowSearchFilters();


            automallCarListVm.productList.init();

            // get search auto suggestion list
            automallService.getSearchList().then(function (success) {
                automallCarListVm.search.filteredList = success.data;
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

        };

        /**
         * Filters
         */
        $ionicModal.fromTemplateUrl('pages/OMP/automall/automallFilters_tmpl.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            automallCarListVm.modal = modal;
        });

        automallCarListVm.openModal = function () {
            automallCarListVm.modal.show();
            automallCarListVm.selectedFilter = 1;
        };

        automallCarListVm.closeModal = function () {
            // remove search text
            automallCarListVm.search.searchTerm = '';
            automallCarListVm.modal.hide();

            if (automallCarListVm.showFilters != true) {
                automallCarListVm.filters = { 'brands': [], 'price': { 'lowerRange': automallCarListVm.options.floor, 'upperRange': automallCarListVm.options.ceil }, 'bodyType': [] };

                automallCarListVm.upperRangeInput = automallCarListVm.filters.price.upperRange;
                automallCarListVm.lowerRangeInput = automallCarListVm.filters.price.lowerRange;
            }
        };

        $scope.$on('$destroy', function () {
            automallCarListVm.modal.remove();
        });
        $scope.$on('emimodal.hidden', function () {
        });
        $scope.$on('emimodal.removed', function () {
        });

        automallCarListVm.createAvailableCarPayload = function (pageId, filter) {
            var input = {};
            input.pageId = pageId;
            input.filterApplied = {};
            input.filterApplied.oem = [];

            if (filter.brands == null || filter.brands == undefined) {
                filter.brands = [];
            }
            if (filter.bodyType == null || filter.bodyType == undefined) {
                filter.bodyType = [];
            }
            if (filter.price == null || filter.price == undefined) {
                filter.price = {
                    lowerRange: 0,
                    upperRange: 999999999
                };
            }

            if (automallCarListVm.availableBrands != undefined) {
                for (var index = 0; index < automallCarListVm.availableBrands.length; index++) {
                    if (filter.brands.indexOf(automallCarListVm.availableBrands[index].oemCode) != -1) {
                        input.filterApplied.oem.push(automallCarListVm.availableBrands[index]);
                    }
                }
            } else {
                input.filterApplied.oem = filter.brands;
            }
            input.filterApplied.bodyType = filter.bodyType;
            input.filterApplied.priceRange = {};
            input.filterApplied.priceRange.minPrice = filter.price.lowerRange;
            input.filterApplied.priceRange.maxPrice = filter.price.upperRange;

            automallService.setFiltersApplied(input.filterApplied);

            return input;
        };

        automallCarListVm.searchCars = function () {
            // remove search term
            automallCarListVm.search.searchTerm = '';
            automallCarListVm.search.lastSearchTerm = '';

            automallCarListVm.filters.price.upperRange = automallCarListVm.upperRangeInput;
            automallCarListVm.filters.price.lowerRange = automallCarListVm.lowerRangeInput;

            clickStreamService.clickStreamData = 'oem,' + automallCarListVm.filters.brands.join(',') + '^body,' + automallCarListVm.filters.bodyType.join(',') + '^price,' + automallCarListVm.filters.price.lowerRange + ',' + automallCarListVm.filters.price.upperRange;

            automallCarListVm.showFilters = true;
            automallService.setShowSearchFilters(true);
            var input = automallCarListVm.createAvailableCarPayload(1, automallCarListVm.filters);
            automallCarListVm.callAvailableCarService(input);
        };

        automallCarListVm.callAvailableCarService = function (input) {
            automallCarListVm.search.lastSearchTerm = '';
            console.log('Car search input' + JSON.stringify(input));
            automallService.getAvailableCarListService(input).then(function (response) {
                automallCarListVm.productList.carList = response.data[0];
                automallCarListVm.productList.filterApplied = automallService.getFiltersApplied();

                automallService.setSelectedOem(undefined);
                automallCarListVm.refreshData();
                $ionicScrollDelegate.scrollTop();
                automallCarListVm.closeModal();

                if (automallCarListVm.isClearCall) {
                    automallCarListVm.isClearCall = false;
                    automallCarListVm.productList.filterApplied = { priceRange: { minPrice: automallCarListVm.options.floor, maxPrice: automallCarListVm.options.ceil }, bodyType: [], oem: [] };
                    automallCarListVm.upperRangeInput = automallCarListVm.filters.price.upperRange;
                    automallCarListVm.lowerRangeInput = automallCarListVm.filters.price.lowerRange;
                    automallService.setShowSearchFilters(false);
                    automallCarListVm.showFilters = false;
                }

            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        };

        automallCarListVm.refreshData = function () {
            automallCarListVm.productList.carList.pageId = parseInt(automallCarListVm.productList.carList.pageId);
            automallCarListVm.productList.carList.paginationLimit = parseInt(automallCarListVm.productList.carList.paginationLimit);
            automallCarListVm.productList.carList.count = parseInt(automallCarListVm.productList.carList.count);
            automallCarListVm.productList.carList.totalPages = Math.ceil(automallCarListVm.productList.carList.count / automallCarListVm.productList.carList.paginationLimit);
            automallCarListVm.productList.availableFilters = automallCarListVm.productList.carList.allFilters;

            if (automallCarListVm.productList.availableFilters != undefined) {
                automallCarListVm.availablebodyType = automallCarListVm.productList.availableFilters.bodyType;
                automallCarListVm.availableBrands = automallCarListVm.productList.availableFilters.oem;
                if (automallCarListVm.productList.availableFilters.priceRange != null && automallCarListVm.productList.availableFilters.priceRange != undefined) {
                    if (automallCarListVm.productList.availableFilters.priceRange.maxPrice != undefined && automallCarListVm.productList.availableFilters.priceRange.maxPrice != null)
                        automallCarListVm.filters.price.upperRange = parseFloat(automallCarListVm.productList.availableFilters.priceRange.maxPrice);
                    if (automallCarListVm.productList.availableFilters.priceRange.minPrice != undefined && automallCarListVm.productList.availableFilters.priceRange.minPrice != null)
                        automallCarListVm.filters.price.lowerRange = parseFloat(automallCarListVm.productList.availableFilters.priceRange.minPrice);
                    automallCarListVm.options.floor = automallCarListVm.filters.price.lowerRange;
                    automallCarListVm.options.ceil = automallCarListVm.filters.price.upperRange;
                    automallCarListVm.lowerRangeInput = automallCarListVm.filters.price.lowerRange;
                    automallCarListVm.upperRangeInput = automallCarListVm.filters.price.upperRange;
                    $timeout(function () {
                        $scope.$broadcast('rzSliderForceRender');
                    });
                }
            }

            automallService.setAvailableFilters(automallCarListVm.productList.carList.allFilters);
        };

        automallCarListVm.isClearCall = false;

        automallCarListVm.clearFilters = function () {
            automallCarListVm.filters = { 'brands': [], 'price': { 'lowerRange': automallCarListVm.options.floor, 'upperRange': automallCarListVm.options.ceil }, 'bodyType': [] };
            automallCarListVm.isClearCall = true;
            var input = automallCarListVm.createAvailableCarPayload(1, automallCarListVm.filters);
            automallCarListVm.callAvailableCarService(input);
            automallCarListVm.selectedFilter = 1;
        };

        automallCarListVm.breadcrumbList = [{ 'id': 1, 'title': 'Price Range' }, { 'id': 2, 'title': 'Body Type' }, { 'id': 3, 'title': 'Brands' }];

        automallCarListVm.selectedFilter = 1;
        automallCarListVm.gotoFilter = function (id) {
            automallCarListVm.selectedFilter = id;
        }


        /**
         * Search functionality
         */
        automallCarListVm.search = {
            searchTerm: '',
            lastSearchTerm: '',
            filteredList: [],

            searchProduct: function (item, pageId) {
                automallCarListVm.search.lastSearchTerm = item;
                var input = {};
                input.keyword = item;
                if (pageId == undefined) {
                    input.pageId = '1';
                } else {
                    input.pageId = pageId;
                }

                clickStreamService.clickStreamData = 'q,' + item;

                automallService.carSearchService(input).then(function (success) {
                    $ionicScrollDelegate.scrollTop();
                    automallCarListVm.filters = { 'brands': [], 'price': { 'lowerRange': automallCarListVm.options.floor, 'upperRange': automallCarListVm.options.ceil }, 'bodyType': [] };
                    automallCarListVm.productList.filterApplied = { priceRange: { minPrice: automallCarListVm.options.floor, maxPrice: automallCarListVm.options.ceil }, bodyType: [], oem: [] };
                    automallCarListVm.search.searchTerm = '';
                    automallService.setShowSearchFilters(false);
                    automallCarListVm.showFilters = false;
                    automallCarListVm.productList.carList = success.data[0];
                    automallCarListVm.refreshData();
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });

            },

            showRecentSearchHistory: function () {
                $scope.onFocusFlag = true;
                $scope.hideAutocompleteDiv = true;
                $scope.hideRecentSearchDiv = false;
                automallCarListVm.searchLenError = false;
            },

            focusOutChange: function () {
                $scope.onFocusFlag = false;
                $scope.hideAutocompleteDiv = false;
                $scope.hideRecentSearchDiv = true;
            },

            inputBoxChangeEvent: function () {

                automallCarListVm.searchLenError = false;
                $scope.hideAutocompleteDiv = true;
                if (automallCarListVm.search.searchTerm.length <= 3) {
                    $scope.searchTrue = false;
                    if (automallCarListVm.search.searchTerm.length == 0) {
                        $scope.hideRecentSearchDiv = false;
                    }
                }
            }
        };

        automallCarListVm.gotoProductDetails = function (product) {

            clickStreamService.clickStreamData = 'oem,' + product.oemCode + '^name,' + product.modelName + '^carId,' + product.modelCode;

            automallService.setProductDetails(product);
            automallService.setOfferDetails(product);
            automallService.setProductDetailSelected(true);
            $state.go('menu.automallPdp');
        };

        automallCarListVm.toggleBodyTypeFilter = function (id) {
            if (automallCarListVm.filters.bodyType.indexOf(id) != -1) {
                automallCarListVm.filters.bodyType.splice(automallCarListVm.filters.bodyType.indexOf(id), 1);
            } else {
                automallCarListVm.filters.bodyType.push(id);
            }
        };

        automallCarListVm.toggleBrandFilter = function (id) {
            if (automallCarListVm.filters.brands.indexOf(id) != -1) {
                automallCarListVm.filters.brands.splice(automallCarListVm.filters.brands.indexOf(id), 1);
            } else {
                automallCarListVm.filters.brands.push(id);
            }
        };

        automallCarListVm.checkAmounts = function (id) {
            if (id == 'low') {
                // lower range validations
                if (automallCarListVm.lowerRangeInput > automallCarListVm.upperRangeInput) {
                    automallCarListVm.lowerRangeInput = automallCarListVm.options.floor;
                }
                if (automallCarListVm.lowerRangeInput < automallCarListVm.options.floor) {
                    automallCarListVm.lowerRangeInput = automallCarListVm.options.floor;
                }
            } else {
                // upper range validations
                if (automallCarListVm.upperRangeInput < automallCarListVm.lowerRangeInput) {
                    automallCarListVm.upperRangeInput = automallCarListVm.options.ceil;
                }
                if (automallCarListVm.upperRangeInput > automallCarListVm.options.ceil) {
                    automallCarListVm.upperRangeInput = automallCarListVm.options.ceil;
                }
            }

            automallCarListVm.filters.price.upperRange = automallCarListVm.upperRangeInput;
            automallCarListVm.filters.price.lowerRange = automallCarListVm.lowerRangeInput;
        };

        /**
         * Car list and pagination
         */
        automallCarListVm.productList = {
            carlist: {},
            availableFilters: [],
            filterApplied: [],

            init: function () {
                automallCarListVm.productList.availableFilters = automallService.getAvailableFilters();
                if (automallCarListVm.productList.availableFilters.priceRange == undefined || automallCarListVm.productList.availableFilters.priceRange == null) {
                    automallCarListVm.productList.availableFilters.priceRange = {};
                }

                if (automallCarListVm.productList.availableFilters.priceRange.minPrice != undefined && automallCarListVm.productList.availableFilters.priceRange.minPrice != null)
                    automallCarListVm.options.floor = parseFloat(automallCarListVm.productList.availableFilters.priceRange.minPrice);
                if (automallCarListVm.productList.availableFilters.priceRange.maxPrice != undefined && automallCarListVm.productList.availableFilters.priceRange.maxPrice != null)
                    automallCarListVm.options.ceil = parseFloat(automallCarListVm.productList.availableFilters.priceRange.maxPrice);

                $timeout(function () {
                    $scope.$broadcast('rzSliderForceRender')
                });


                automallCarListVm.productList.filterApplied = automallService.getFiltersApplied();
                automallCarListVm.availableBrands = automallCarListVm.productList.availableFilters.oem;

                automallCarListVm.filters = {};
                automallCarListVm.filters.bodyType = automallCarListVm.productList.filterApplied.bodyType;
                automallCarListVm.filters.price = {};
                if (automallCarListVm.productList.filterApplied.priceRange.maxPrice == '') {
                    automallCarListVm.productList.filterApplied.priceRange.maxPrice = automallCarListVm.options.ceil;
                    automallCarListVm.productList.filterApplied.priceRange.minPrice = automallCarListVm.options.floor;
                }
                automallCarListVm.filters.price.upperRange = automallCarListVm.productList.filterApplied.priceRange.maxPrice;
                automallCarListVm.filters.price.lowerRange = automallCarListVm.productList.filterApplied.priceRange.minPrice;
                automallCarListVm.upperRangeInput = automallCarListVm.filters.price.upperRange;
                automallCarListVm.lowerRangeInput = automallCarListVm.filters.price.lowerRange;
                automallCarListVm.filters.brands = [];
                // automallCarListVm.productList.filterApplied.oem.forEach(function (item, index) {
                //     automallCarListVm.filters.brands.push(item.oemId);
                // });
                for (var index = 0; index < automallCarListVm.productList.filterApplied.oem.length; index++) {
                    automallCarListVm.filters.brands.push(automallCarListVm.productList.filterApplied.oem[index].oemCode);
                }

                if (undefined != automallService.getSelectedOem()) {
                    automallCarListVm.productList.carList = automallService.getSelectedOem().availableCars;
                    automallCarListVm.refreshData();
                } else {
                    var pageId = undefined;
                    pageId = automallService.getPageId();
                    if (!pageId) {
                        pageId = 1
                    }
                    automallCarListVm.search.lastSearchTerm = automallService.getSearchTerm();
                    if (automallCarListVm.search.lastSearchTerm == '') {
                        var input = automallCarListVm.createAvailableCarPayload(pageId, automallCarListVm.filters);
                        automallCarListVm.callAvailableCarService(input);
                    } else {
                        automallCarListVm.search.searchProduct(automallCarListVm.search.lastSearchTerm, pageId);
                    }

                }
            },

            setPage: function (pageNo) {
                if (automallCarListVm.search.lastSearchTerm == '') {
                    automallCarListVm.productList.filterApplied = automallService.getFiltersApplied();
                    automallCarListVm.filters.brands = [];
                    automallCarListVm.productList.filterApplied.oem.forEach(function(element) {
                        automallCarListVm.filters.brands.push(element.oemCode);
                    }, this);
                    // automallCarListVm.filters.brands = automallCarListVm.productList.filterApplied.oem;
                    automallCarListVm.filters.bodyType = automallCarListVm.productList.filterApplied.bodyType;
                    automallCarListVm.filters.price = {
                        lowerRange: automallCarListVm.productList.filterApplied.priceRange.minPrice,
                        upperRange: automallCarListVm.productList.filterApplied.priceRange.maxPrice
                    };
                }

                var input = automallCarListVm.createAvailableCarPayload(pageNo, automallCarListVm.filters);
                automallService.setPageId(pageNo);
                if (automallCarListVm.search.lastSearchTerm == '') {
                    automallCarListVm.callAvailableCarService(input);
                    automallService.setSearchTerm('');
                } else {
                    automallService.setSearchTerm(automallCarListVm.search.lastSearchTerm);
                    automallCarListVm.search.searchProduct(automallCarListVm.search.lastSearchTerm, pageNo);
                }
            },

            getEmi: function (amt) {
                amt = parseFloat(amt);
                automallService.emiCalc.loanAmount = amt;
                automallService.emiCalc.calculateEmi();
                return automallService.emiCalc.emi;
            }
        };

        $scope.range = function (min, max, step) {
            step = step || 1;
            var input = [];
            for (var i = min; i <= max; i += step) {
                input.push(i);
            }
            return input;
        };

        $scope.isNumber = function (value) {
            return typeof (value) === 'number';
        };


        automallCarListVm.options = {
            floor: 15000,
            ceil: 9999999999,
            step: 5000,
            hideLimitLabels: true,
            hidePointerLabels: true,
            onChange: function (sliderId) {
                automallCarListVm.upperRangeInput = automallCarListVm.filters.price.upperRange;
                automallCarListVm.lowerRangeInput = automallCarListVm.filters.price.lowerRange;
            }
        };

        $scope.$on('$ionicView.beforeEnter', function () {
            init();
        }, false);

        $scope.$on('$ionicView.afterEnter', function () {
            setTimeout(function () {
                var topBar = document.querySelectorAll('.app-header');
                if (topBar) {
                    topBar[1].classList.add('automall-header');
                }
            }, 500);
        });

        $scope.$on('$ionicView.beforeLeave', function () {
            var topBar = document.querySelectorAll('.app-header');
            if (topBar) {
                topBar[1].classList.remove('automall-header');
            }
        });

        return this;
    }]);