/**
*   @ngdoc config
*   @name angularApp.config : automallConfig
*   @description
*	configuration file for Automall module
*/

'use strict';
/*State defination with respective names, urls, controllers and templates */
angularApp.config(['$stateProvider',
    function ($stateProvider) {
        $stateProvider
            .state('menu.automall', {
                url: '/automall',
                data: {
                    pageId: 'OMP_ATMLIDX'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/OMP/automall/automallLandingPage.html',
                        controller: 'automallController',
                        controllerAs: 'automallVm',
                    }
                }
            })
            .state('menu.automallPdp', {
                url: '/automallPdp',
                data: {
                    pageId: 'OMP_ATMLPDP'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/OMP/automall/automallProductDetailsPage.html',
                        controller: 'automallPDPController',
                        controllerAs: 'automallPDPVm',
                    }
                }
            })
            .state('menu.automallEmiCalc', {
                url: '/automallEmiCalc',
                data: {
                    pageId: 'OMP_ATMLEMICALC'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/OMP/automall/automallEmiCalculator.html',
                        controller: 'automallEmiController',
                        controllerAs: 'automallEmiVm',
                    }
                }
            })
            .state('menu.offerListPage', {
                url: '/offerListPage',
                data: {
                    pageId: 'OMP_ATMLOFLST'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/OMP/automall/automallOfferListPage.html',
                        controller: 'automallOfferListController',
                        controllerAs: 'automallOfferListVm',
                    }
                }
            })
            .state('menu.offerDetailsPage', {
                url: '/offerDetailsPage',
                data: {
                    pageId: 'OMP_ATMLOFDET'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/OMP/automall/automallOfferDetailsPage.html',
                        controller: 'automallOfferDetailsController',
                        controllerAs: 'automallOfferDetailsVm',
                    }
                }
            })
            .state('menu.leadCapturePage', {
                url: '/leadCapturePage',
                data: {
                    pageId: 'OMP_ATMLLDCAP'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/OMP/automall/automallLeadCapturePage.html',
                        controller: 'automallLeadCaptureController',
                        controllerAs: 'automallLeadCaptureVm',
                    }
                }
            })
            .state('menu.successPage', {
                url: '/successPage',
                data: {
                    pageId: 'OMP_ATMLLEADSUC'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/OMP/automall/automallLeadCaptureSuccessPage.html',
                        controller: 'automallLeadCaptureSuccessController',
                        controllerAs: 'automallLeadCaptureSuccessVm',
                    }
                }
            })
            .state('menu.carListPage', {
                url: '/carListPage',
                data: {
                    pageId: 'OMP_ATMLCLIST'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/OMP/automall/automallCarListPage.html',
                        controller: 'automallCarListController',
                        controllerAs: 'automallCarListVm',
                    }
                }
            })
            .state('menu.automobileLanding', {
                url: '/automobileLanding',
                data: {
                    pageId: 'OMP_CARLANDING'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/OMP/automall/ompAutomobileLandingPage.html',
                        controller: 'automobileController',
                        controllerAs: 'automobileVm',
                    }
                }
            })
            .state('menu.automallCompareCars', {
                url: '/automallCompareCars',
                data: {
                    pageId: 'OMP_CMPCARS'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/OMP/automall/automallCompareCarsPage.html',
                        controller: 'automallCompareCarsController',
                        controllerAs: 'automallCompareCarsVm',
                    }
                }
            })
    }]);