'use strict';

angularApp.controller('automallController', ["$state", "$scope", "ompMerchantsService", "$ionicHistory", "utilityService", "mPinLoginService", "clickStreamService", "$ionicSideMenuDelegate", "$ionicPopup", "$ionicSlideBoxDelegate", "homeScreenService", "$ionicScrollDelegate", "paclService", "carLoanService", "loggedInUserService", "cryptoService", "$ionicModal", "$morphCarousel", "homeLoanService", "$filter", "automallService", "$timeout",
    function ($state, $scope, ompMerchantsService, $ionicHistory, utilityService, mPinLoginService, clickStreamService, $ionicSideMenuDelegate, $ionicPopup, $ionicSlideBoxDelegate, homeScreenService, $ionicScrollDelegate, paclService, carLoanService, loggedInUserService, cryptoService, $ionicModal, $morphCarousel, homeLoanService, $filter, automallService, $timeout) {
        var automallVm = this;

        automallVm.paclAmount = 0;
        automallVm.paclMessage = '';

        automallVm.next = function () {
            $ionicSlideBoxDelegate.next();
        };
        automallVm.previous = function () {
            $ionicSlideBoxDelegate.previous();
        };
        $scope.slideChanged = function (index) {
            $scope.slideIndex = index;
        };

        automallVm.initPageData = function () {
            automallVm.landing.init();
        };

        // Landing Page 
        automallVm.landing = {
            banners: [],
            paclBanners: [],

            init: function () {
                automallVm.emiCalc.clear();
                automallService.setSelectedVariant(undefined);
                automallVm.emiCalc.init();
                automallVm.landing.initBanners();
                automallVm.productOffer.init();
                automallVm.oemOffers.init();
            },

            clear: function () {
                automallVm.emiCalc.clear();
                automallVm.oemOffers.clear();
                automallVm.productOffer.clear();
            },

            sliderTimer: 3000,
            initBanners: function (data) {
                automallVm.landing.banners = [];
                automallVm.landing.paclBanners = [];
                var temp = automallService.getLandingBanners().data[0].banners;
                automallVm.landing.sliderTimer = automallService.getLandingBanners().data[0].bannerTime;
                for (var index = 0; index < temp.length; index++) {
                    if (temp[index].userType.toLowerCase() != 'automall' && (temp[index].userType.toLowerCase() == 'pacl' || temp[index].userType.toLowerCase() == 'nonpacl')) {
                        automallVm.landing.paclBanners.push(temp[index]);
                    } else {
                        automallVm.landing.banners.push(temp[index]);
                    }
                }
            },

            // Banner redirections
            bannerClicked: function (banner) {

                clickStreamService.clickStreamData = 'bannerId,' + banner.bannerCode + '^bannerType,' + banner.bannerType;

                if (banner.bannerType == "CUSTOM") {
                    if (banner.bannerURL == 'menu.carLoanKnowMore') {
                        homeScreenService.ishamMenu = true;
                        homeScreenService.menuOption = "loans";
                        homeScreenService.isBackCheck = true;
                        homeLoanService.hambergerSelectedLoanType = 'car';
                        if (homeScreenService.dummymenuCheck == true) {
                            $state.go('menu.menudummy');
                        }
                        else {
                            $state.go('menu.loans');
                        }
                    } else {
                        $state.go(banner.bannerURL);
                    }
                } else if (banner.bannerType == 'OEM') {
                    // goto oem car list
                    var oem = {};
                    automallVm.oemOffers.oemList.forEach(function (element) {
                        if (element.oemCode == banner.oemCode) {
                            oem = element;
                        }
                    }, this);
                    automallVm.searchOemCars(oem);

                } else if (banner.bannerType == 'MODEL' || banner.bannerType == 'VARIENT') {
                    // goto product details
                    automallService.getProductDetailsService({ 'modelCode': banner.modelCode }).then(function (success) {
                        automallService.setProductDetails(success.data);
                        automallService.setOfferDetails(success.data);
                        automallService.setProductDetailSelected(true);
                        $state.go('menu.automallPdp');
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                } else if (banner.bannerType == 'OFFER' && banner.bannerURL == "OFFER-DETAILS") {
                    // goto offer details
                    automallVm.oemOffers.gotoOfferDetails({ 'offerCode': banner.offerCode });
                } else if (banner.bannerType == 'OFFER' && banner.bannerURL == "OFFER-LIST") {
                    // goto offer list page
                    automallService.getOfferListService().then(function (success) {
                        automallService.oemSelected = false;
                        automallService.setOfferList(success.data);
                        automallService.setSelectedOem(undefined);
                        automallService.setSelectedOemName('');

                        var offerList = success.data;
                        for (var index in offerList) {
                            if (offerList[index].oemCode == banner.oemCode) {
                                automallService.oemSelected = true;
                                automallService.setSelectedOem(offerList[index].oemCode);
                                automallService.setSelectedOemName(offerList[index].oemName);
                            }
                        }
                        $state.go('menu.offerListPage')
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }
            }
        };

        //EMI Calculator
        automallVm.emiCalc = automallService.emiCalc;
        automallVm.emiCalc.showCalculator = function (flag) {

            if (flag == 'PACL') {
                automallVm.emiCalc.isPaclCustomer = true;
                automallVm.emiCalc.loanAmount = automallVm.emiCalc.paclData.amount;
            } else {
                if (automallVm.emiCalc.paclData != undefined) {
                    clickStreamService.clickStreamData = 'isPaclCustomer,true';
                } else {
                    clickStreamService.clickStreamData = 'isPaclCustomer,false';
                }
                automallVm.emiCalc.isPaclCustomer = false;
                automallVm.emiCalc.loanAmount = automallVm.emiCalc.defaultLoanAmount;
            }
            automallVm.emiCalc.amountChanaged();
            $scope.openModal();
            automallVm.emiCalc.updateCarousel();
        };


        // EMI Calculator modal
        $ionicModal.fromTemplateUrl('pages/OMP/automall/emiCalculator_tmpl.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.emimodal = modal;
        });
        $scope.openModal = function () {
            $scope.emimodal.show();
        };
        $scope.closeModal = function () {
            $scope.emimodal.hide();
            automallVm.emiCalc.init();
        };
        $scope.$on('$destroy', function () {
            $scope.emimodal.remove();
        });
        $scope.$on('emimodal.hidden', function () {
        });
        $scope.$on('emimodal.removed', function () {
        });

        $scope.$watch('automallVm.emiCalc.selectedTenure', function (value) {
            automallVm.emiCalc.calculateEmi();
        });
        // EMI Calculator modal ends
        $scope.$watch('automallVm.oemOffers.selectedOem', function () {
            automallVm.productOffer.updateFilter();
            automallVm.productOffer.pagination.initPages();
        });


        automallVm.oemOffers = {
            oemList: [],
            selectedOem: '',

            init: function () {
                automallVm.oemOffers.clear();
                automallVm.oemOffers.oemList = automallService.getOemList().data;
            },

            clear: function () {
                automallVm.oemOffers.oemList = [];
                automallVm.oemOffers.selectedOem = '';
            },

            moreOffersClicked: function () {
                automallService.oemSelected = false;
                automallService.setSelectedOem(undefined);
                automallService.getOfferListService().then(function (success) {
                    automallService.setOfferList(success.data);
                    $state.go('menu.offerListPage')
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            },

            gotoOfferDetails: function (offer) {
                automallService.getOfferDetailsService(offer.offerCode).then(function (response) {
                    automallService.setSelectedOffer(offer);
                    automallService.setOfferDetails(response.data);
                    $state.go('menu.offerDetailsPage');
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                })
            }
        };



        automallVm.applyCarLoan = function () {
            var request = {
                "loanType": "car"
            };
            var isPaclCustomer = (automallVm.emiCalc.paclData != undefined);

            clickStreamService.clickStreamData = 'tenure,' + automallVm.emiCalc.selectedTenure + '^amount,' + automallVm.emiCalc.loanAmount + '^emi,' + automallVm.emiCalc.emi + '^isPaclCustomer,' + isPaclCustomer;
            if (isPaclCustomer) {
                $state.go('menu.paclReqDetails');
            } else {
                carLoanService.getYonoDedupe(request).then(function (data) {
                    carLoanService.YonodedupeData = data;
                    if (carLoanService.YonodedupeData.status == '0') {
                        carLoanService.getEligiblityCheck(request).then(function (data1) {
                            carLoanService.userMaster = data1;
                            carLoanService.homeBranch = data1.homeBranch;
                            if (data1.status == "CL02") {
                                homeLoanService.source = 'car';
                                homeLoanService.dedupErrors = data1.reasons;
                                $state.go('menu.homeLoanError');
                            } else if (data1.status == "0000") {
                                $state.go('menu.carPersonaldetails');
                            } else if (data1.status == "CL03") {
                                $state.go('menu.cLExtinginLos');
                            }
                        }, function (error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    } else {
                        $state.go('menu.clApplicationStatus');
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        };

        automallVm.productOffer = {
            selectedCarType: 0,
            offerList: [],
            filter: {},
            totalItems: 64,
            currentPage: 4,

            clear: function () {
                automallVm.productOffer.selectedCarType = 0;
                automallVm.productOffer.offerList = [];
                automallVm.productOffer.filter = {};
                automallVm.productOffer.totalItems = 0;
                automallVm.productOffer.currentPage = 1;
            },

            init: function (data) {
                automallVm.productOffer.offerList = [{ 'brand': 'Toyota', 'carType': '0', 'productName': 'Toyota 1', 'id': '1', 'price': '2,00,000', 'offerDetails': 'Free accessories', 'image': 'img/OMP/automall/car_default.png' },
                { 'brand': 'Toyota', 'carType': '1', 'productName': 'Toyota 2', 'id': '2', 'price': '2,00,000', 'offerDetails': 'Free accessories', 'image': 'img/OMP/automall/car_default.png' },
                { 'brand': 'Toyota', 'carType': '2', 'productName': 'Toyota 3', 'id': '3', 'price': '2,00,000', 'offerDetails': 'Free accessories', 'image': 'img/OMP/automall/car_default.png' },
                { 'brand': 'Toyota', 'carType': '3', 'productName': 'Toyota 4', 'id': '4', 'price': '2,00,000', 'offerDetails': 'Free accessories', 'image': 'img/OMP/automall/car_default.png' },
                { 'brand': 'Hyundai', 'carType': '0', 'productName': 'Hyundai 1', 'id': '5', 'price': '2,00,000', 'offerDetails': 'Free accessories', 'image': 'img/OMP/automall/car_default.png' },
                { 'brand': 'Hyundai', 'carType': '1', 'productName': 'Hyundai 2', 'id': '6', 'price': '2,00,000', 'offerDetails': 'Free accessories', 'image': 'img/OMP/automall/car_default.png' },
                { 'brand': 'Hyundai', 'carType': '2', 'productName': 'Hyundai 3', 'id': '7', 'price': '2,00,000', 'offerDetails': 'Free accessories', 'image': 'img/OMP/automall/car_default.png' },
                { 'brand': 'Hyundai', 'carType': '3', 'productName': 'Hyundai 4', 'id': '8', 'price': '2,00,000', 'offerDetails': 'Free accessories', 'image': 'img/OMP/automall/car_default.png' },
                { 'brand': 'Maruti', 'carType': '0', 'productName': 'Maruti 1', 'id': '9', 'price': '2,00,000', 'offerDetails': 'Free accessories', 'image': 'img/OMP/automall/car_default.png' },
                { 'brand': 'Maruti', 'carType': '1', 'productName': 'Maruti 2', 'id': '10', 'price': '2,00,000', 'offerDetails': 'Free accessories', 'image': 'img/OMP/automall/car_default.png' },
                { 'brand': 'Maruti', 'carType': '2', 'productName': 'Maruti 3', 'id': '11', 'price': '2,00,000', 'offerDetails': 'Free accessories', 'image': 'img/OMP/automall/car_default.png' },
                { 'brand': 'Maruti', 'carType': '3', 'productName': 'Maruti 4', 'id': '12', 'price': '2,00,000', 'offerDetails': 'Free accessories', 'image': 'img/OMP/automall/car_default.png' },
                { 'brand': 'Honda', 'carType': '0', 'productName': 'Honda 1', 'id': '13', 'price': '2,00,000', 'offerDetails': 'Free accessories', 'image': 'img/OMP/automall/car_default.png' },
                { 'brand': 'Honda', 'carType': '1', 'productName': 'Honda 2', 'id': '14', 'price': '2,00,000', 'offerDetails': 'Free accessories', 'image': 'img/OMP/automall/car_default.png' },
                { 'brand': 'Honda', 'carType': '2', 'productName': 'Honda 3', 'id': '15', 'price': '2,00,000', 'offerDetails': 'Free accessories', 'image': 'img/OMP/automall/car_default.png' },
                { 'brand': 'Honda', 'carType': '3', 'productName': 'Honda 4', 'id': '16', 'price': '2,00,000', 'offerDetails': 'Free accessories', 'image': 'img/OMP/automall/car_default.png' }];

                automallVm.productOffer.updateFilter();
                automallVm.productOffer.pagination.initPages();
            },


            updateFilter: function () {
                automallVm.productOffer.filter = {};
                if (automallVm.productOffer.selectedCarType != undefined && (automallVm.productOffer.selectedCarType !== '')) {
                    automallVm.productOffer.filter.carType = automallVm.productOffer.selectedCarType;
                }
                if (automallVm.oemOffers.selectedOem != "" && automallVm.oemOffers.selectedOem != "All") {
                    automallVm.productOffer.filter.brand = automallVm.oemOffers.selectedOem;
                }
            },

            selectedCarTypeChanged: function (id) {
                automallVm.productOffer.selectedCarType = id;
                automallVm.productOffer.updateFilter();
                automallVm.productOffer.pagination.initPages();
            },

            pagination: {
                selectedPage: 0,
                pages: [],
                pageSize: 6,
                filteredList: [],

                clear: function () {
                    automallVm.productOffer.pagination.pages = [];
                    automallVm.productOffer.pagination.filteredList = [];
                    automallVm.productOffer.pagination.selectedPage = 0;
                },

                initPages: function () {
                    var page = [];
                    var count = 0;
                    automallVm.productOffer.pagination.pages = [];
                    automallVm.productOffer.pagination.filteredList = $filter('filter')(automallVm.productOffer.offerList, automallVm.productOffer.filter);
                    for (var index = 0; index < automallVm.productOffer.pagination.filteredList.length; index++) {
                        if (count == automallVm.productOffer.pagination.pageSize) {
                            count = 1;
                            automallVm.productOffer.pagination.pages.push(page);
                            page = [];
                            page.push(automallVm.productOffer.pagination.filteredList[index]);
                        } else if (index == automallVm.productOffer.pagination.filteredList.length - 1) {
                            page.push(automallVm.productOffer.pagination.filteredList[index]);
                            automallVm.productOffer.pagination.pages.push(page);
                        } else {
                            page.push(automallVm.productOffer.pagination.filteredList[index]);
                            count++;
                        }
                    }

                },

                setPage: function (pageNumber) {
                    automallVm.productOffer.pagination.selectedPage = pageNumber;
                }
            }
        };

        automallVm.searchOemCars = function (oem) {

            automallService.setPageId(1);
            clickStreamService.clickStreamData = 'merchantId,' + oem.oemCode + '^name,' + oem.oemName;


            if (automallVm.oemOffers.oemList[0].availableCars.carList.length > 0) {
                automallService.setShowSearchFilters(true);
                automallService.setFiltersApplied({ "bodyType": [], "oem": [oem], "priceRange": { "maxPrice": "", "minPrice": "" } });
                automallService.setAvailableFilters(automallVm.oemOffers.oemList[0].availableCars.allFilters);
                automallService.setSelectedOem(oem);
            } else {
                automallService.setShowSearchFilters(false);
                automallService.setFiltersApplied({ "bodyType": [], "oem": [], "priceRange": { "maxPrice": "", "minPrice": "" } });
                automallService.setAvailableFilters({ "bodyType": [], "oem": [oem], "priceRange": { "maxPrice": "", "minPrice": "" } });
                automallService.setSelectedOem(undefined);
            }
            $state.go('menu.carListPage');
        };

        automallVm.gotoSearch = function () {
            automallService.setPageId(1);
            automallService.setShowSearchFilters(false);
            automallService.setFiltersApplied({ "bodyType": [], "oem": [], "priceRange": { "maxPrice": "", "minPrice": "" } });
            automallService.setSelectedOem(undefined);
            $state.go('menu.carListPage');
        };

        $scope.$on('$ionicView.beforeEnter', function () {
        }, false);

        $scope.$on('$ionicView.afterEnter', function () {
            setTimeout(function () {
                var topBar = document.querySelectorAll('.app-header');
                if (topBar) {
                    topBar[1].classList.add('automall-header');
                }
            }, 500);
        });

        $scope.$on('$ionicView.beforeLeave', function () {
            var topBar = document.querySelectorAll('.app-header');
            if (topBar) {
                topBar[1].classList.remove('automall-header');
            }
        });


        automallVm.initPageData();
        return this;
    }]);

