'use strict';

angularApp.controller('automallEmiController', ["$state", "$scope", "ompMerchantsService", "$ionicHistory", "utilityService", "mPinLoginService", "clickStreamService", "$ionicSideMenuDelegate", "$ionicPopup", "$ionicSlideBoxDelegate", "homeScreenService", "$ionicScrollDelegate", "paclService", "carLoanService", "loggedInUserService", "cryptoService", "$ionicModal", "$morphCarousel", "homeLoanService", "$filter", "automallService",
    function ($state, $scope, ompMerchantsService, $ionicHistory, utilityService, mPinLoginService, clickStreamService, $ionicSideMenuDelegate, $ionicPopup, $ionicSlideBoxDelegate, homeScreenService, $ionicScrollDelegate, paclService, carLoanService, loggedInUserService, cryptoService, $ionicModal, $morphCarousel, homeLoanService, $filter, automallService) {
        var automallEmiVm = this;

        //EMI Calculator
        automallEmiVm.emiCalc = automallService.emiCalc;

        automallEmiVm.emiCalc.getOffers = function () {
            automallService.getSbiOffers().then(function (response) {
                automallEmiVm.offers = response.data;
            }, function (error) {
                utilityService.showErrorMessage('Unable to fetch offers: ' + error.responseMessage);
            })

            $ionicSideMenuDelegate.$getByHandle('postLogin').canDragContent(false);
        }

        $scope.$watch('automallEmiVm.emiCalc.selectedTenure', function (value) {
            automallEmiVm.emiCalc.calculateEmi();
        });
        // EMI Calculator modal ends


        automallEmiVm.applyCarLoan = function () {

            $scope.isPaclCustomer = (automallEmiVm.emiCalc.paclData != undefined);
            clickStreamService.clickStreamData = 'tenure,' + automallEmiVm.emiCalc.selectedTenure + '^amount,' + automallEmiVm.emiCalc.loanAmount + '^emi,' + automallEmiVm.emiCalc.emi + '^isPaclCustomer,' + $scope.isPaclCustomer;

            var request = {
                "loanType": "car"
            };
            if ($scope.isPaclCustomer) {
                $state.go('menu.paclReqDetails');
            } else {
                carLoanService.getYonoDedupe(request).then(function (data) {
                    carLoanService.YonodedupeData = data;
                    if (carLoanService.YonodedupeData.status == '0') {
                        carLoanService.getEligiblityCheck(request).then(function (data1) {
                            carLoanService.userMaster = data1;
                            carLoanService.homeBranch = data1.homeBranch;
                            if (data1.status == "CL02") {
                                homeLoanService.source = 'car';
                                homeLoanService.dedupErrors = data1.reasons;
                                $state.go('menu.homeLoanError');
                            } else if (data1.status == "0000") {
                                $state.go('menu.carPersonaldetails');
                            } else if (data1.status == "CL03") {
                                $state.go('menu.cLExtinginLos');
                            }
                        }, function (error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    } else {
                        $state.go('menu.clApplicationStatus');
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        };

        $scope.$on('$ionicView.beforeEnter', function () {
            setTimeout(function () {
                $morphCarousel.update('emi-carousel');
            }, 500);


        }, false);

        $scope.$on('$ionicView.afterEnter', function () {
            setTimeout(function () {
                var topBar = document.querySelectorAll('.app-header');
                if (topBar) {
                    topBar[1].classList.add('automall-header');
                }
            }, 500);
        });

        $scope.$on('$ionicView.beforeLeave', function () {
            var topBar = document.querySelectorAll('.app-header');
            if (topBar) {
                topBar[1].classList.remove('automall-header');
            }
        });

        automallEmiVm.emiCalc.init();

        return this;
    }]);

