'use strict';

angularApp.controller('automallLeadCaptureController', ["$state", "$scope", "ompMerchantsService", "$ionicHistory", "utilityService", "mPinLoginService", "clickStreamService", "$ionicSideMenuDelegate", "$ionicPopup", "$ionicSlideBoxDelegate", "homeScreenService", "$ionicScrollDelegate", "paclService", "carLoanService", "loggedInUserService", "customerInfoService", "cryptoService", "$ionicModal", "$morphCarousel", "homeLoanService", "$filter", "automallService",
    function ($state, $scope, ompMerchantsService, $ionicHistory, utilityService, mPinLoginService, clickStreamService, $ionicSideMenuDelegate, $ionicPopup, $ionicSlideBoxDelegate, homeScreenService, $ionicScrollDelegate, paclService, carLoanService, loggedInUserService, customerInfoService, cryptoService, $ionicModal, $morphCarousel, homeLoanService, $filter, automallService) {
        var automallLeadCaptureVm = this;

        var phnReg = /^[123456789]\d{9}$/;
        var mailformat = /^([\w\.\-]+)@([\w\-]+)((\.(\w){2,63}){1,2})$/;

        automallLeadCaptureVm.productDetails = {};
        automallLeadCaptureVm.selectedOffer = {};
        automallLeadCaptureVm.leadDetails = {};
        automallLeadCaptureVm.stateList = [];
        automallLeadCaptureVm.cityList = [];
        automallLeadCaptureVm.dealerList = [];
        automallLeadCaptureVm.emailMaskUnmask = false;
        automallLeadCaptureVm.mobileMaskUnmask = false;
        automallLeadCaptureVm.termsAndConditionsFlag = false;
        automallLeadCaptureVm.offerDetailBlock = false;
        automallLeadCaptureVm.productDetailBlock = false;
        automallLeadCaptureVm.variantName = '';
        automallLeadCaptureVm.errObj = {
            'mobileError': '',
            'emailError': '',
            'dealerError': '',
            'stateError': '',
            'cityError': ''
        };

        automallLeadCaptureVm.initPage = function () {
            automallLeadCaptureVm.leadDetails = { 'mobileNo': '', 'email': '', 'state': '', 'city': '', 'dealer': '' };
            automallLeadCaptureVm.leadDetails.email = customerInfoService.customer.emailID;
            automallLeadCaptureVm.leadDetails.mobileNo = loggedInUserService.userProfile.mobileNumber;
            automallLeadCaptureVm.selectedOffer = automallService.getOfferDetails();

            if (automallLeadCaptureVm.selectedOffer[0] != undefined) {
                automallLeadCaptureVm.selectedOffer = automallLeadCaptureVm.selectedOffer[0];
            }

            var getOEMCode;
            if (automallService.getProductDetailSelected() == true) {
                automallLeadCaptureVm.productDetails = automallService.getProductDetails();

                if (automallLeadCaptureVm.productDetails[0] != undefined) {
                    automallLeadCaptureVm.productDetails = automallLeadCaptureVm.productDetails[0];
                }

                automallLeadCaptureVm.variantName = automallLeadCaptureVm.productDetails.variantDetails[0].variantName
                automallLeadCaptureVm.offerDetailBlock = false;
                automallLeadCaptureVm.productDetailBlock = true;
                getOEMCode = automallLeadCaptureVm.productDetails.oemCode
            }
            else {
                automallLeadCaptureVm.productDetailBlock = false;
                automallLeadCaptureVm.offerDetailBlock = true;
                getOEMCode = automallLeadCaptureVm.selectedOffer.oemCode;
            }
            automallService.getStateCityDealerList(getOEMCode).then(function (response) {
                automallLeadCaptureVm.stateList = response.data;
            }, function (error) {
                console.log(error);
                utilityService.showErrorMessage(error.responseMessage);
            });

        };

        automallLeadCaptureVm.stateChanged = function () {
            automallLeadCaptureVm.cityList = [];
            automallLeadCaptureVm.dealerList = [];
            automallLeadCaptureVm.leadDetails.city = "";
            automallLeadCaptureVm.leadDetails.dealer = "";

            automallLeadCaptureVm.cityList = automallLeadCaptureVm.getCityList();
        };

        automallLeadCaptureVm.getCityList = function () {
            for (var index = 0; index < automallLeadCaptureVm.stateList.length; index++) {
                if (automallLeadCaptureVm.stateList[index].stateName == automallLeadCaptureVm.leadDetails.state) {
                    return automallLeadCaptureVm.stateList[index].cityList;
                }
            }
        };

        automallLeadCaptureVm.cityChanged = function () {
            automallLeadCaptureVm.dealerList = [];
            automallLeadCaptureVm.leadDetails.dealer = "";
            automallLeadCaptureVm.dealerList = automallLeadCaptureVm.getdealerList();
        };

        automallLeadCaptureVm.getdealerList = function () {
            for (var index = 0; index < automallLeadCaptureVm.stateList.length; index++) {
                if (automallLeadCaptureVm.stateList[index].stateName == automallLeadCaptureVm.leadDetails.state) {
                    for (var y = 0; y < automallLeadCaptureVm.stateList[index].cityList.length; y++) {
                        if (automallLeadCaptureVm.stateList[index].cityList[y].cityName == automallLeadCaptureVm.leadDetails.city) {
                            return automallLeadCaptureVm.stateList[index].cityList[y].dealers;
                        }
                    }
                }
            }
        };

        automallLeadCaptureVm.toggleEye = function (type) {
            if ('email' == type) {
                automallLeadCaptureVm.emailMaskUnmask = !automallLeadCaptureVm.emailMaskUnmask;
            } else {
                automallLeadCaptureVm.mobileMaskUnmask = !automallLeadCaptureVm.mobileMaskUnmask
            }
        };

        automallLeadCaptureVm.submitLead = function () {
            var formError = automallLeadCaptureVm.validateForm();
            // if (formError) {
            //     utilityService.showErrorMessage(formError);
            // } else {
            if (!formError && automallLeadCaptureVm.leadDetails.mobileNo && automallLeadCaptureVm.leadDetails.state && automallLeadCaptureVm.leadDetails.city && automallLeadCaptureVm.leadDetails.dealer && automallLeadCaptureVm.termsAndConditionsFlag) {
                var variantCodeReq;
                if (automallService.getProductDetailSelected() == true) {
                    var variant = automallService.getSelectedVariant();
                    variantCodeReq = variant.variantCode;
                }

                clickStreamService.clickStreamData = 'pName,' + automallLeadCaptureVm.selectedOffer.modelName + '^state,' + automallLeadCaptureVm.leadDetails.state + '^city,' + automallLeadCaptureVm.leadDetails.city + '^dealer,' + automallLeadCaptureVm.leadDetails.dealer + '^pCode,' + automallLeadCaptureVm.selectedOffer.modelCode + '^oem,' + automallLeadCaptureVm.selectedOffer.oemCode;

                var dealerDetails = {};
                automallLeadCaptureVm.dealerList.forEach(function (item, index) {
                    if (item.dealerId == automallLeadCaptureVm.leadDetails.dealer) {
                        dealerDetails = item.dealerDetails;
                    }
                });

                if (!automallLeadCaptureVm.leadDetails.email) {
                    automallLeadCaptureVm.leadDetails.email = '';
                }

                var requestParam = {
                    "oemCode": automallLeadCaptureVm.selectedOffer.oemCode,
                    "modelCode": automallLeadCaptureVm.selectedOffer.modelCode,
                    "oemName": automallLeadCaptureVm.selectedOffer.oemName,
                    "modelName": automallLeadCaptureVm.selectedOffer.modelName,
                    "variantCode": variantCodeReq,
                    "phoneNumber": automallLeadCaptureVm.leadDetails.mobileNo,
                    "emailId": automallLeadCaptureVm.leadDetails.email,
                    "state": automallLeadCaptureVm.leadDetails.state,
                    "city": automallLeadCaptureVm.leadDetails.city,
                    "dealerCode": automallLeadCaptureVm.leadDetails.dealer,
                    "dealerDetails": dealerDetails[0],
                    "phoneNumberEmailIdKey": cryptoService.getSHA512EncryptedData(loggedInUserService.tokenLotus + automallLeadCaptureVm.leadDetails.mobileNo + automallLeadCaptureVm.leadDetails.email).toString()
                };

                automallService.leadCaptureService(requestParam).then(function (response) {
                    $state.go('menu.successPage');
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }

        };

        automallLeadCaptureVm.validateForm = function () {
            if (!automallLeadCaptureVm.leadDetails.mobileNo) {
                automallLeadCaptureVm.errObj.mobileError = 'Enter phone number';
                return true;
            } else if (!phnReg.test(automallLeadCaptureVm.leadDetails.mobileNo)) {
                automallLeadCaptureVm.errObj.mobileError = 'Enter valid phone number';
                return true;
            } else {
                automallLeadCaptureVm.errObj.mobileError = '';
            }
            if (automallLeadCaptureVm.leadDetails.email && !mailformat.test(automallLeadCaptureVm.leadDetails.email)) {
                automallLeadCaptureVm.errObj.emailError = 'Enter valid email';
                return true;
            } else {
                automallLeadCaptureVm.errObj.emailError = '';
            }
            if (!automallLeadCaptureVm.leadDetails.state) {
                automallLeadCaptureVm.errObj.stateError = 'Select a State';
                return true;
            } else {
                automallLeadCaptureVm.errObj.stateError = '';
            }
            if (!automallLeadCaptureVm.leadDetails.city) {
                automallLeadCaptureVm.errObj.cityError = 'Select a city';
                return true;
            } else {
                automallLeadCaptureVm.errObj.cityError = '';
            }
            if (!automallLeadCaptureVm.leadDetails.dealer) {
                automallLeadCaptureVm.errObj.dealerError = 'Select a dealer';
                return true;
            } else {
                automallLeadCaptureVm.errObj.dealerError = '';
            }
            if (!automallLeadCaptureVm.termsAndConditionsFlag) {
                utilityService.showErrorMessage('Please click on agree to avail offer');
                return true;
            }

            return false;
        };

        automallLeadCaptureVm.validateMobile = function () {
            automallLeadCaptureVm.errObj.mobileError = '';
            if (!automallLeadCaptureVm.leadDetails.mobileNo) {
                automallLeadCaptureVm.errObj.mobileError = 'Enter phone number';
            } else if (!phnReg.test(automallLeadCaptureVm.leadDetails.mobileNo)) {
                automallLeadCaptureVm.errObj.mobileError = 'Enter valid phone number';
            }
        };

        automallLeadCaptureVm.validateEmail = function () {
            automallLeadCaptureVm.errObj.emailError = '';
            if (automallLeadCaptureVm.leadDetails.email && !mailformat.test(automallLeadCaptureVm.leadDetails.email)) {
                automallLeadCaptureVm.errObj.emailError = 'Enter valid email';
            }
        };

        $scope.$on('$ionicView.beforeEnter', function () {

        }, false);

        $scope.$on('$ionicView.afterEnter', function () {
           setTimeout(function () {
                var topBar = document.querySelectorAll('.app-header');
                if (topBar) {
                    topBar[1].classList.add('automall-header');
                }
            }, 500);

            setTimeout(function () {
                document.getElementsByClassName('automall-lead-capture-container')[0].style.marginBottom=document.getElementById('lead-capture-footer').offsetHeight+'px';
            }, 1000);
        });

        $scope.$on('$ionicView.beforeLeave', function () {
            var topBar = document.querySelectorAll('.app-header');
            if (topBar) {
                topBar[1].classList.remove('automall-header');
            }
        });


        automallLeadCaptureVm.initPage();

        return this;
    }]);

