'use strict';

angularApp.controller('automallOfferDetailsController', ["$state", "$scope", "ompMerchantsService", "$ionicHistory", "utilityService", "mPinLoginService", "clickStreamService", "$ionicSideMenuDelegate", "$ionicPopup", "$ionicSlideBoxDelegate", "homeScreenService", "$ionicScrollDelegate", "paclService", "carLoanService", "loggedInUserService", "cryptoService", "$ionicModal", "$morphCarousel", "homeLoanService", "$filter", "automallService",
    function ($state, $scope, ompMerchantsService, $ionicHistory, utilityService, mPinLoginService, clickStreamService, $ionicSideMenuDelegate, $ionicPopup, $ionicSlideBoxDelegate, homeScreenService, $ionicScrollDelegate, paclService, carLoanService, loggedInUserService, cryptoService, $ionicModal, $morphCarousel, homeLoanService, $filter, automallService) {
        var automallOfferDetailsVm = this;

        automallOfferDetailsVm.offerDetails = [];
        automallOfferDetailsVm.selectedOffer = {};

        automallOfferDetailsVm.initPage = function () {
            automallOfferDetailsVm.offerDetails = automallService.getOfferDetails()[0];
            automallOfferDetailsVm.selectedOffer = automallService.getSelectedOffer();

            $scope.showDynamicDisclaimer = false; 
            if(automallOfferDetailsVm.offerDetails.disclaimerContent == undefined){
                $scope.showDynamicDisclaimer = false;  
            }else if(automallOfferDetailsVm.offerDetails.disclaimerContent != '' && automallOfferDetailsVm.offerDetails.disclaimerContent != null && automallOfferDetailsVm.offerDetails.disclaimerContent != undefined){
                $scope.showDynamicDisclaimer = true;
                $scope.disclaimerContent = decodeURIComponent(automallOfferDetailsVm.offerDetails.disclaimerContent).replace(new RegExp("\\+","g"),' ');
            }else{
                $scope.disclaimerContent = '';
            }
        };

        automallOfferDetailsVm.grabOffer = function () {
            clickStreamService.clickStreamData = 'productName,' + automallOfferDetailsVm.offerDetails.modelName + '^code,' + automallOfferDetailsVm.selectedOffer.offerCode;
            if (automallOfferDetailsVm.offerDetails.mobileRedirectionUrl == '') {
                if (automallOfferDetailsVm.offerDetails.modelCode != '') {
                    automallService.getProductDetailsService({ 'modelCode': automallOfferDetailsVm.offerDetails.modelCode }).then(function (response) {
                        automallService.setProductDetails(response.data);
                        automallService.setProductDetailSelected(true);
                        $state.go('menu.automallPdp');
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                } else {
                    automallService.setProductDetailSelected(false);
                    $state.go('menu.leadCapturePage');
                }
            } else {


                $scope.disclaimer = function (data) {
                    automallOfferDetailsVm.myPopup = $ionicPopup.show({
                        title: '',
                        cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',
                        templateUrl: "pages/OMP/automall/disclaimerPopup.html",
                        scope: $scope
                    });
                };
                var mobileRedirectKey = cryptoService.getSHA512EncryptedData(loggedInUserService.tokenLotus + automallOfferDetailsVm.offerDetails.mobileRedirectionUrl).toString();
                $scope.disclaimer({});
                var saveLeadObj = {
                    "leadId": "",
                    "websiteId": "",
                    "affiliateId": automallOfferDetailsVm.offerDetails.oemCode,
                    "request": {
                        "ompCcustToken": "",
                        "loggedIn": "",
                        "channel": "",
                        "segId": "",
                        "ompTokenId": "",
                        "merchantSku": "",
                        "prdPrice": "",
                        "wishlistSkus": "",
                        "ompDisValue": "",
                        "ompDisPct": "",
                        "ompDisType": "",
                        "isLoggedIn": mPinLoginService.isLoggedIn
                    },
                    "leadParam": "lead",
                    "segmentParam": "st",
                    "affiliateIdParam": "",
                    "mobileRedirectUrl": automallOfferDetailsVm.offerDetails.mobileRedirectionUrl,
                    "mobileRedirectKey": mobileRedirectKey
                }

                $scope.cancel = function () {
                    automallOfferDetailsVm.myPopup.close();
                };

                $scope.agree = function () {
                    automallOfferDetailsVm.myPopup.close();
                    var loadPopup = $ionicPopup.show({
                        title: '',
                        cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head textAlignCenter popupBackgroundDark',
                        templateUrl: "pages/OMP/ompMerchants/loading.html",
                        scope: $scope
                    });

                    ompMerchantsService.saveLead(saveLeadObj).then(function (data) {
                        loadPopup.close();
                        ompMerchantsService.inAppBrowser(data.data.mobileUrl, undefined);
                    }, function (error) {
                        loadPopup.close();
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                };
            }
        };


        $scope.$on('$ionicView.beforeEnter', function () {

        }, false);
        automallOfferDetailsVm.initPage();

        $scope.$on('$ionicView.afterEnter', function () {
            setTimeout(function () {
                var topBar = document.querySelectorAll('.app-header');
                if (topBar) {
                    topBar[1].classList.add('automall-header');
                }
            }, 500);
        });

        $scope.$on('$ionicView.beforeLeave', function () {
            var topBar = document.querySelectorAll('.app-header');
            if (topBar) {
                topBar[1].classList.remove('automall-header');
            }
        });
        return this;
    }]);

