'use strict';

angularApp.controller('automallOfferListController', ["$state", "$scope", "ompMerchantsService", "$ionicHistory", "utilityService", "mPinLoginService", "clickStreamService", "$ionicSideMenuDelegate", "$ionicPopup", "$ionicSlideBoxDelegate", "homeScreenService", "$ionicScrollDelegate", "paclService", "carLoanService", "loggedInUserService", "cryptoService", "$ionicModal", "$morphCarousel", "homeLoanService", "$filter", "automallService",
    function ($state, $scope, ompMerchantsService, $ionicHistory, utilityService, mPinLoginService, clickStreamService, $ionicSideMenuDelegate, $ionicPopup, $ionicSlideBoxDelegate, homeScreenService, $ionicScrollDelegate, paclService, carLoanService, loggedInUserService, cryptoService, $ionicModal, $morphCarousel, homeLoanService, $filter, automallService) {
        var automallOfferListVm = this;
        var limitlength = 5;

        automallOfferListVm.oemOfferList = [];
        automallOfferListVm.offerList = [];
        automallOfferListVm.Offerlimit = limitlength;
        automallOfferListVm.firstOemLogoVal = '';

        automallOfferListVm.initPage = function () {

            automallOfferListVm.offerList = automallService.getOfferList();

            automallOfferListVm.oemSelected = automallService.oemSelected;
            automallOfferListVm.selectedOem = automallService.getSelectedOem();
            automallOfferListVm.selectedOemName = automallService.getSelectedOemName();

            var oem = {};
            for (var index in automallOfferListVm.offerList) {
                oem[automallOfferListVm.offerList[index]["oemCode"]] = automallOfferListVm.offerList[index];
            }

            for (index in oem) {
                automallOfferListVm.oemOfferList.push(oem[index]);
            }

        };

        automallOfferListVm.moreOffersClicked = function (oemCode, oemName) {

            clickStreamService.clickStreamData = 'oemCode,' + oemCode + '^oemName,' + oemName;

            if (oemCode == undefined) {
                automallService.oemSelected = false;
                automallService.setSelectedOem(undefined);
            } else {
                automallService.oemSelected = true;
                automallService.setSelectedOem(oemCode);
                automallService.setSelectedOemName(oemName);
            }

            automallOfferListVm.oemSelected = automallService.oemSelected;
            automallOfferListVm.selectedOem = automallService.getSelectedOem();
            automallOfferListVm.selectedOemName = automallService.getSelectedOemName();
            $ionicScrollDelegate.scrollTop();
            $ionicScrollDelegate.resize();
        };


        automallOfferListVm.getOemImage = function (oemCode) {
            for (var index = 0; index < automallOfferListVm.oemOfferList.length; index++) {
                if (oemCode == automallOfferListVm.oemOfferList[index].oemCode) {
                    return automallOfferListVm.oemOfferList[index].oemLogo;
                }
            }
        };

        automallOfferListVm.gotoOfferDetails = function (offer, offerDetails) {

            clickStreamService.clickStreamData = 'productName,' + offerDetails[0].modelName + '^code,' + offer.offerCode + '^oem,' + offerDetails[0].oemCode;

            automallService.setSelectedOffer(offer);
            automallService.setOfferDetails(offerDetails);
            $state.go('menu.offerDetailsPage');
            $ionicScrollDelegate.scrollTop();
        };


        automallOfferListVm.moreOffersList = function () {
            automallOfferListVm.Offerlimit += limitlength;
            setTimeout(function () {
                $ionicScrollDelegate.resize();
            }, 500);
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            if (utilityService.isIOSPlatform()) {
                $scope.isAndroidPlatform = false;
            } else {
                $scope.isAndroidPlatform = true;
            }
        }, false);

        $scope.$on('$ionicView.afterEnter', function () {
            setTimeout(function () {
                var topBar = document.querySelectorAll('.app-header');
                if (topBar) {
                    topBar[1].classList.add('automall-header');
                }
            }, 500);
        });

        $scope.$on('$ionicView.beforeLeave', function () {
            var topBar = document.querySelectorAll('.app-header');
            if (topBar) {
                topBar[1].classList.remove('automall-header');
            }
        });

        automallOfferListVm.initPage();

        return this;
    }]);

