'use strict';

angularApp.controller('automallPDPController', ["$state", "$scope", "$ionicHistory", "utilityService", "clickStreamService", "$ionicSideMenuDelegate", "$ionicPopup", "$ionicSlideBoxDelegate", "$ionicScrollDelegate", "paclService", "carLoanService", "loggedInUserService", "cryptoService", "$filter", "automallService", "$translate", "ompMerchantsService", "mPinLoginService",
    function ($state, $scope, $ionicHistory, utilityService, clickStreamService, $ionicSideMenuDelegate, $ionicPopup, $ionicSlideBoxDelegate, $ionicScrollDelegate, paclService, carLoanService, loggedInUserService, cryptoService, $filter, automallService, $translate, ompMerchantsService, mPinLoginService) {
        var automallPDPVm = this;


        automallPDPVm.productDetails = {};
        automallPDPVm.offerDetails = [];
        automallPDPVm.selectedCity = '';
        automallPDPVm.selectedVariant = 0;
        automallPDPVm.defaultEmi = 0;
        automallPDPVm.errObj = {
            'modelError': '',
            'varientError': ''
        };
        /**
         * Page initialization
         */
        automallPDPVm.initPage = function () {
            automallPDPVm.productDetails = automallService.getProductDetails();
            automallPDPVm.offerDetails = automallService.getProductDetails();
            if (automallPDPVm.productDetails[0] != undefined) {
                automallPDPVm.productDetails = automallPDPVm.productDetails[0];
                automallPDPVm.offerDetails = automallPDPVm.productDetails[0];
            }
            automallPDPVm.selectedVariant = 0;
            automallPDPVm.selectedCity = 'Delhi';
            automallPDPVm.updateDefaultEmi();

            $scope.banners = automallPDPVm.productDetails.banners;

            automallPDPVm.compareCars.init();

            $scope.isPaclCustomer = (automallService.emiCalc.paclData != undefined);

            $scope.showDynamicDisclaimer = false;
            if(automallPDPVm.productDetails.disclaimerContent == undefined){
                $scope.showDynamicDisclaimer = false;  
            }
            if(automallPDPVm.productDetails.disclaimerContent != '' && automallPDPVm.productDetails.disclaimerContent != null && automallPDPVm.productDetails.disclaimerContent != undefined){
                $scope.showDynamicDisclaimer = true;
                $scope.disclaimerContent = decodeURIComponent(automallPDPVm.productDetails.disclaimerContent).replace(new RegExp("\\+","g"),' ');
            }

            if (!automallPDPVm.productDetails.bannerTime) {
                automallPDPVm.productDetails.bannerTime = 3000;
            }

            if (automallPDPVm.productDetails.banners.length < 1) {
                $scope.options.pagination = false;
            }

            automallPDPVm.productDetails.bannerTime = parseInt(automallPDPVm.productDetails.bannerTime);

            $scope.options = {
                loop: true,
                effect: 'slide',
                speed: 500,
                autoplay: automallPDPVm.productDetails.bannerTime
            }

        };

     

        $scope.$on("$ionicSlides.sliderInitialized", function (event, data) {
            // data.slider is the instance of Swiper
            $scope.slider = data.slider;
        });

        $scope.$on("$ionicSlides.slideChangeStart", function (event, data) {
            console.log('Slide change is beginning');
        });

        $scope.$on("$ionicSlides.slideChangeEnd", function (event, data) {
            // note: the indexes are 0-based
            $scope.activeIndex = data.slider.activeIndex;
            $scope.previousIndex = data.slider.previousIndex;
        });

        $scope.slideChanged = function () {
            var delegate = $ionicSlideBoxDelegate.$getByHandle('product-banners');
            if (delegate.currentIndex() == delegate.slidesCount() - 1) {
                setTimeout(function () {
                    delegate.slide(0);
                }, automallPDPVm.productDetails.bannerTime);
            }
        }

        /**
         * Clear the controller attributes
         */
        automallPDPVm.clear = function () {
            automallPDPVm.productDetails = {};
            automallPDPVm.selectedCity = '';
            automallPDPVm.selectedVariant = 0;
        };

        // initialize emi calculator object from service
        automallPDPVm.emiCalc = automallService.emiCalc;

        /**
         * Calculate default EMI to display based on city and variant selected.
         */
        automallPDPVm.updateDefaultEmi = function () {
            automallPDPVm.productDetails.variantDetails[automallPDPVm.selectedVariant].cityPrice.forEach(function (item, index) {
                if (automallPDPVm.selectedCity == automallPDPVm.productDetails.variantDetails[automallPDPVm.selectedVariant].cityPrice[index].city) {
                    automallPDPVm.emiCalc.loanAmount = automallPDPVm.productDetails.variantDetails[automallPDPVm.selectedVariant].cityPrice[index].price;
                    automallPDPVm.emiCalc.calculateEmi();
                    automallPDPVm.defaultEmi = automallPDPVm.emiCalc.emi;
                }
            });
        };

        /**
         * return price for selected variant based on the city selected
         */
        automallPDPVm.getVariantPrice = function (index) {
            var variant = automallPDPVm.productDetails.variantDetails[index];
            for (var i = 0; i < variant.cityPrice.length; i++) {
                if (variant.cityPrice[i].city == automallPDPVm.selectedCity) {
                    return variant.cityPrice[i].price;
                }
            }
        };

        /**
         * change selected variant
         */
        automallPDPVm.variantSelected = function (index) {
            automallPDPVm.selectedVariant = index;

            clickStreamService.clickStreamData = 'vName,' + automallPDPVm.productDetails.variantDetails[automallPDPVm.selectedVariant].variantName + '^pName,' + automallPDPVm.productDetails.modelName + '^vCode,' + automallPDPVm.productDetails.variantDetails[automallPDPVm.selectedVariant].variantCode + '^pCode,' + automallPDPVm.productDetails.modelCode + '^oem,' + automallPDPVm.productDetails.oemCode;

            // scroll to selected variant
            setTimeout(function () {
                var collection = document.getElementsByClassName('pdp-variant');
                var selectedItem = [];
                for (var i = 0; i < collection.length; i++) {
                    if (collection[i].className.indexOf('selected') != -1) {
                        selectedItem = collection[i];
                    }
                }
                if (selectedItem.offsetLeft != undefined)
                    $ionicScrollDelegate.$getByHandle('variantScroll').scrollTo((selectedItem.offsetLeft - 30), 0, true);

            }, 500);

            automallPDPVm.updateDefaultEmi();
        }


        var errorVariant = '';
        var errorModel = '';
        $translate(['OMP_AUTOMALL_SELECT_MODEL_ERROR', 'OMP_AUTOMALL_SELECT_VARIANT_ERROR']).then(function (translations) {
            errorVariant = translations['OMP_AUTOMALL_SELECT_VARIANT_ERROR'];
            errorModel = translations['OMP_AUTOMALL_SELECT_MODEL_ERROR'];
        });

        /**
         * All links placed here
         */
        automallPDPVm.links = {

            compareCars: function () {
                if (automallPDPVm.compareCars.selectedVariant != '' && automallPDPVm.compareCars.selectedModel != '') {
                    var input = {};
                    input.city = automallPDPVm.selectedCity;
                    input.variantcode1 = automallPDPVm.productDetails.variantDetails[automallPDPVm.selectedVariant].variantCode;
                    input.modelcode1 = automallPDPVm.productDetails.modelCode;
                    input.variantcode2 = automallPDPVm.compareCars.selectedVariant;
                    input.modelcode2 = automallPDPVm.compareCars.selectedModel;

                    clickStreamService.clickStreamData = 'modelCode1,' + input.modelcode1 + '^modelCode2,' + input.modelcode2 + '^variantCode1,' + input.variantcode1 + '^variantCode2,' + input.variantcode2;

                    automallService.compareCarService(input).then(function (compareCarsData) {
                        automallService.setComparisonData(compareCarsData);
                        $state.go('menu.automallCompareCars');
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                } else {
                    if (automallPDPVm.compareCars.selectedModel == '') {
                        automallPDPVm.errObj.modelError = errorModel;
                        automallPDPVm.errObj.varientError = "";
                    } else {
                        automallPDPVm.errObj.varientError = errorVariant;
                        automallPDPVm.errObj.modelError = "";
                    }
                }

            },

            gotoCalculator: function () {

                clickStreamService.clickStreamData = 'vName,' + automallPDPVm.productDetails.variantDetails[automallPDPVm.selectedVariant].variantName + '^pName,' + automallPDPVm.productDetails.modelName + '^vCode,' + automallPDPVm.productDetails.variantDetails[automallPDPVm.selectedVariant].variantCode + '^pCode,' + automallPDPVm.productDetails.modelCode + '^oem,' + automallPDPVm.productDetails.oemCode;

                automallPDPVm.productDetails.variantDetails[automallPDPVm.selectedVariant].cityPrice.forEach(function (item, index) {
                    if (automallPDPVm.selectedCity == automallPDPVm.productDetails.variantDetails[automallPDPVm.selectedVariant].cityPrice[index].city) {
                        automallPDPVm.productDetails.variantDetails[automallPDPVm.selectedVariant].price = automallPDPVm.productDetails.variantDetails[automallPDPVm.selectedVariant].cityPrice[index].price;
                    }
                });
                automallService.setSelectedVariant(automallPDPVm.productDetails.variantDetails[automallPDPVm.selectedVariant]);
                $state.go('menu.automallEmiCalc');
            },

            gotoOfferDetails: function (id) {

                clickStreamService.clickStreamData = 'vName,' + automallPDPVm.productDetails.variantDetails[automallPDPVm.selectedVariant].variantName + '^pName,' + automallPDPVm.productDetails.modelName + '^vCode,' + automallPDPVm.productDetails.variantDetails[automallPDPVm.selectedVariant].variantCode + '^pCode,' + automallPDPVm.productDetails.modelCode + '^oem,' + automallPDPVm.productDetails.oemCode + '^offerCode,' + id;


                automallService.getOfferDetailsService(id).then(function (response) {
                    automallService.setOfferDetails(response.data);
                    automallPDPVm.offerDetails = response.data[0];
                    var automallOfferDetailsPopup = $ionicPopup.show({
                        templateUrl: 'pages/OMP/automall/automallOfferDetails_tmpl.html',
                        cssClass: 'popup-offer-details',
                        scope: $scope,
                        buttons: []
                    });

                    automallOfferDetailsPopup.then(function (res) {
                        automallOfferDetailsPopup.close();
                    });

                    $scope.closePopup = function () {
                        automallOfferDetailsPopup.close();
                    }
                }, function (error) {
                    utilityService.showErrorMessage();
                })
            },

            gotoLeadCapture: function () {
                clickStreamService.clickStreamData = 'vName,' + automallPDPVm.productDetails.variantDetails[automallPDPVm.selectedVariant].variantName + '^pName,' + automallPDPVm.productDetails.modelName + '^vCode,' + automallPDPVm.productDetails.variantDetails[automallPDPVm.selectedVariant].variantCode + '^pCode,' + automallPDPVm.productDetails.modelCode + '^oem,' + automallPDPVm.productDetails.oemCode

                // if redirection URL is there, open the link in inApp browser, otherwise go to lead capture page
                if (automallPDPVm.productDetails.mobileRedirectionUrl == '') {
                    automallService.getProductDetailSelected(true);

                    automallPDPVm.productDetails.variantDetails[automallPDPVm.selectedVariant].cityPrice.forEach(function (item, index) {
                        if (automallPDPVm.selectedCity == automallPDPVm.productDetails.variantDetails[automallPDPVm.selectedVariant].cityPrice[index].city) {
                            automallPDPVm.productDetails.variantDetails[automallPDPVm.selectedVariant].price = automallPDPVm.productDetails.variantDetails[automallPDPVm.selectedVariant].cityPrice[index].price;
                        }
                    });
                    automallService.setSelectedVariant(automallPDPVm.productDetails.variantDetails[automallPDPVm.selectedVariant]);
                    $state.go('menu.leadCapturePage');
                } else {
                    // open disclaimer
                    $scope.disclaimer = function (data) {
                        automallPDPVm.myPopup = $ionicPopup.show({
                            title: '',
                            cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',
                            templateUrl: "pages/OMP/automall/disclaimerPopup.html",
                            scope: $scope
                        });
                    };

                    // generate hash using the redirection URL
                    var mobileRedirectKey = cryptoService.getSHA512EncryptedData(loggedInUserService.tokenLotus + automallPDPVm.productDetails.mobileRedirectionUrl).toString();
                    $scope.disclaimer({});
                    var saveLeadObj = {
                        "leadId": "",
                        "websiteId": "",
                        "affiliateId": automallPDPVm.productDetails.oemCode,
                        "request": {
                            "ompCcustToken": "",
                            "loggedIn": "",
                            "channel": "",
                            "segId": "",
                            "ompTokenId": "",
                            "merchantSku": "",
                            "prdPrice": "",
                            "wishlistSkus": "",
                            "ompDisValue": "",
                            "ompDisPct": "",
                            "ompDisType": "",
                            "isLoggedIn": mPinLoginService.isLoggedIn
                        },
                        "leadParam": "lead",
                        "segmentParam": "st",
                        "affiliateIdParam": "",
                        "mobileRedirectUrl": automallPDPVm.productDetails.mobileRedirectionUrl,
                        "mobileRedirectKey": mobileRedirectKey
                    }

                    $scope.cancel = function () {
                        automallPDPVm.myPopup.close();
                    };

                    $scope.agree = function () {
                        automallPDPVm.myPopup.close();
                        var loadPopup = $ionicPopup.show({
                            title: '',
                            cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head textAlignCenter popupBackgroundDark',
                            templateUrl: "pages/OMP/ompMerchants/loading.html",
                            scope: $scope
                        });

                        // on click of agree on disclaimer call save-lead-redirect to get the product specific URL from adapter
                        ompMerchantsService.saveLead(saveLeadObj).then(function (data) {
                            loadPopup.close();
                            ompMerchantsService.inAppBrowser(data.data.mobileUrl, undefined);
                        }, function (error) {
                            loadPopup.close();
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    };
                }
            }
        };

        automallPDPVm.compareCars = {
            modelList: [],
            selectedModel: '',
            selectedVariant: '',

            init: function () {
                automallPDPVm.compareCars.selectedModel = '';
                automallPDPVm.compareCars.selectedVariant = '';
                var input = { 'oemCode': automallPDPVm.productDetails.oemCode };

                automallService.getOemModelsService(input).then(function (list) {
                    automallPDPVm.compareCars.modelList = list.data;
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                })
            },

            modelChanged: function () {
                console.log(automallPDPVm.compareCars.selectedModel);
                console.log(JSON.stringify(automallPDPVm.compareCars.modelList[automallPDPVm.compareCars.selectedModel]));
            }
        };

        /**
         * Redirect to external URL
         */
        automallPDPVm.redirectExternal = function (url) {
            // open disclaimer
            automallPDPVm.disclaimer(url);
        };

        automallPDPVm.disclaimer = function (data) {
            $scope.data = data;
            automallPDPVm.myPopup = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',
                templateUrl: "pages/OMP/automall/disclaimerPopup.html",
                scope: $scope
            });
        };

        $scope.cancel = function () {
            automallPDPVm.myPopup.close();
        };

        $scope.agree = function () {
            automallPDPVm.myPopup.close();
            // create hash using redirection url for book online link
            var mobileRedirectKey = cryptoService.getSHA512EncryptedData(loggedInUserService.tokenLotus + $scope.data).toString();

            var saveLeadObj = {
                "leadId": "",
                "websiteId": "",
                "affiliateId": automallPDPVm.productDetails.oemCode,
                "request": {
                    "ompCcustToken": "",
                    "loggedIn": "",
                    "channel": "",
                    "segId": "",
                    "ompTokenId": "",
                    "merchantSku": "",
                    "prdPrice": "",
                    "wishlistSkus": "",
                    "ompDisValue": "",
                    "ompDisPct": "",
                    "ompDisType": "",
                    "isLoggedIn": mPinLoginService.isLoggedIn
                },
                "leadParam": "lead",
                "segmentParam": "st",
                "affiliateIdParam": "",
                "mobileRedirectUrl": $scope.data,
                "mobileRedirectKey": mobileRedirectKey
            }

            var loadPopup = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head textAlignCenter popupBackgroundDark',
                templateUrl: "pages/OMP/ompMerchants/loading.html",
                scope: $scope
            });
            // on click of agree on disclaimer save-lead-redirect service to get the product specific URL.
            ompMerchantsService.saveCrmLead(saveLeadObj).then(function (data) {
                loadPopup.close();
                ompMerchantsService.inAppBrowser(data.data.mobileUrl, undefined);
            }, function (error) {
                loadPopup.close();
                utilityService.showErrorMessage(error.responseMessage);
            });
        };

        $scope.isNumber = function (value) {
            return typeof (value) === 'number';
        };


        $scope.$on('$ionicView.beforeEnter', function () {
            automallPDPVm.initPage();
        }, false);

        $scope.$on('$ionicView.afterEnter', function () {
            setTimeout(function () {
                var topBar = document.querySelectorAll('.app-header');
                if (topBar) {
                    topBar[1].classList.add('automall-header');
                }
            }, 500);
        });

        $scope.$on('$ionicView.beforeLeave', function () {
            var topBar = document.querySelectorAll('.app-header');
            if (topBar) {
                topBar[1].classList.remove('automall-header');
            }
        });

        return this;
    }]);

