'use strict';

angularApp.controller('automobileController', ["$state", "$scope", "$ionicHistory", "utilityService", "clickStreamService", "$ionicSideMenuDelegate", "$ionicPopup", "$ionicSlideBoxDelegate", "$ionicScrollDelegate", "paclService", "carLoanService", "loggedInUserService", "cryptoService", "$filter", "automallService", "homeScreenService", "ompMerchantsService", "mPinLoginService",
    function ($state, $scope, $ionicHistory, utilityService, clickStreamService, $ionicSideMenuDelegate, $ionicPopup, $ionicSlideBoxDelegate, $ionicScrollDelegate, paclService, carLoanService, loggedInUserService, cryptoService, $filter, automallService, homeScreenService, ompMerchantsService, mPinLoginService) {
        var automobileVm = this;
        var isWebviewLoadingCanceled = false;

        automobileVm.goBack = function () {
            $ionicHistory.goBack();
        };

        automobileVm.backgroundBanner = '';

        automobileVm.loanSteps = [];

        var init = function () {
            automallService.clear();
            automobileVm.showLoanSteps = false;
            automobileVm.merchantData = ompMerchantsService.merchantsListData;

            var obj = {
                "categoryCode": automobileVm.merchantData.categoryCode ? automobileVm.merchantData.categoryCode : homeScreenService.categoryCode
            };
            ompMerchantsService.getMerchantsByCategory(obj).then(function (data) {
                $scope.selectedCategory = data[0].merchant.label;
                automobileVm.dataForIndividualMerchant = data[0].merchant.mobileData;
                $scope.merchantData = [];
                for (var index = 0; index < automobileVm.dataForIndividualMerchant.length; index++) {
                    var temp = automobileVm.dataForIndividualMerchant[index].row;
                    for (var rowIndex = 0; rowIndex < temp.length; rowIndex++) {
                        $scope.merchantData.push(temp[rowIndex]);
                    }
                }

            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

            setTimeout(function() {
                $ionicScrollDelegate.resize();
                $ionicScrollDelegate.scrollToTop();
            }, 500);


            // fetch the loan steps
            automallService.getLoanSteps().then(function (response) {
                automobileVm.loanSteps = response.data;
            }, function (error) {
                automobileVm.loanSteps = [];
                utilityService.showErrorMessage(error.responseMessage);

            });


            automallService.getAutomallBanners().then(function (banner) {
                automobileVm.backgroundBanner = banner.data[0].landingPageImage;
                if (automobileVm.backgroundBanner) {
                    $scope.customStyle = {
                        'background-image': "url('" + automobileVm.backgroundBanner + "')",
                        'background-size': '100% 100%',
                        'background-repeat': 'no-repeat'
                    }
                } else {
                    $scope.customStyle = {};
                }
                automallService.setLandingBanners(banner);

            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

            $scope.showDynamicDisclaimer = false;
        };

        automobileVm.toggleList = function () {
            automobileVm.showLoanSteps = !automobileVm.showLoanSteps;
            $ionicScrollDelegate.resize();
        };

        automobileVm.goNext = function (merchant) {
            $scope.merchantDetails = merchant;
            $scope.merchantDetails.pageId = $state.current.data.pageId;
            clickStreamService.clickStreamData = "websiteId," + merchant.affiliateId + "^merchantId," + merchant.merchantId + "^name," + merchant.name;
            ompMerchantsService.listName = merchant;
            ompMerchantsService.merchantWishlistCount = merchant.merchantWishlistCount;
            if (ompMerchantsService.merchantWishlistCount > 0) {
                ompMerchantsService.isMerchantsWishListAvl = "S"
            } else {
                ompMerchantsService.isMerchantsWishListAvl = "N"
            }
            if (merchant.merchantType === 'Redirection') {
                if ((merchant.coupons || merchant.offerPoints) && (merchant.coupons.length > 0 || merchant.offerPoints.length > 0)) {
                    $state.go('menu.redirectionDiscliamer');
                } else {
                    $scope.disclaimerContent = decodeURIComponent(merchant.disclaimerContent).replace(new RegExp("\\+", "g"), ' ');
                    $scope.showDynamicDisclaimer = true;   
                    automobileVm.disclaimer(merchant);                    
                    if (ompMerchantsService) {
                        if (merchant.websiteId) {
                            clickStreamService.clickStreamData = "websiteId," + merchant.affiliateId;
                        }
                    }
                }
            }
        };

        automobileVm.disclaimer = function (data) {
            automobileVm.merchantsList = data
            automobileVm.myPopup = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',
                templateUrl: "pages/OMP/automall/disclaimerPopup.html",
                scope: $scope
            });
        };

        $scope.cancel = function () {
            // isBannerClicked = false;
            clickStreamService.clickStreamData = "websiteId," + automobileVm.merchantsList.affiliateId;
            automobileVm.myPopup.close();
        };

        $scope.agree = function () {
            clickStreamService.clickStreamData = "websiteId," + automobileVm.merchantsList.affiliateId;
            isWebviewLoadingCanceled = false;
            automobileVm.myPopup.close();

            automobileVm.loadPopup = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head textAlignCenter popupBackgroundDark',
                templateUrl: "pages/OMP/automall/loading.html",
                scope: $scope
            })
            var mobileRedirectKey = cryptoService.getSHA512EncryptedData(loggedInUserService.tokenLotus + automobileVm.merchantsList.mobileRedirectUrl).toString();
            var saveLeadObj = {
                "leadId": "",
                "websiteId": automobileVm.merchantsList.websiteId,
                "affiliateId": automobileVm.merchantsList.affiliateId,
                "request": {
                    "ompCcustToken": "",
                    "loggedIn": "",
                    "channel": "",
                    "segId": "",
                    "ompTokenId": "",
                    "merchantSku": "",
                    "prdPrice": "",
                    "wishlistSkus": "",
                    "ompDisValue": "",
                    "ompDisPct": "",
                    "ompDisType": "",
                    "isLoggedIn": mPinLoginService.isLoggedIn
                },
                "leadParam": automobileVm.merchantsList.leadParam,
                "segmentParam": automobileVm.merchantsList.segmentParam,
                "affiliateIdParam": automobileVm.merchantsList.affiliateIdParam,
                "mobileRedirectUrl": automobileVm.merchantsList.mobileRedirectUrl,
                "mobileRedirectKey": mobileRedirectKey

            }
            ompMerchantsService.saveLead(saveLeadObj).then(function (data) {
                automobileVm.saveLeadData = data;
                automobileVm.loadPopup.close();
                if (isWebviewLoadingCanceled == true) {
                    return "";
                }
                isWebviewLoadingCanceled = true;
                if (mPinLoginService.isLoggedIn) {
                    if (automobileVm.merchantsList.browserType === 'inApp') {
                        ompMerchantsService.inAppBrowser(data.data.mobileUrl, $scope.merchantDetails);
                    } else if (automobileVm.merchantsList.browserType === 'default') {
                        ompMerchantsService.inChromeBrowser(data.data.mobileUrl);
                    } else if (automobileVm.merchantsList.browserType === 'chrome_tab') {
                        ompMerchantsService.inChromeTabBrowser(data.data.mobileUrl);
                    }
                }
            }, function (error) {
                automobileVm.loadPopup.close();
                utilityService.showErrorMessage(error.responseMessage);
            });
        };


        automobileVm.gotoLanding = function () {
            automallService.getEmiMasterService().then(function (emiMaster) {
                automallService.setMasterEmiData(emiMaster);
                automallService.getOEMListService().then(function (oemList) {
                    automallService.setOemList(oemList);
                    $state.go('menu.automall');
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                })
                // automallService.getAutomallBanners().then(function (banner) {
                //     automallService.setLandingBanners(banner);

                // }, function (error) {
                //     utilityService.showErrorMessage(error.responseMessage);
                // });
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });


        };


        $scope.$on('$ionicView.beforeEnter', function () {
            init();
        }, false);

        $scope.$on('$ionicView.afterEnter', function () {
            
            setTimeout(function () {
                var topBar = document.querySelectorAll('.app-header');
                if (topBar) {
                    topBar[1].classList.add('automall-header');
                }
            }, 500);
        });


        $scope.$on('$ionicView.beforeLeave', function () {
            var topBar = document.querySelectorAll('.app-header');
            if (topBar) {
                topBar[1].classList.remove('automall-header');
            }
        });
        return this;
    }]);

