'use strict';

angularApp.controller('categoryListController', [
	"$state",
	"$scope",
	"$translate",
	"ompShopService",
	"$ionicHistory",
	"utilityService",
	"filterService",
	"searchListServices",
	"ompMerchantsService",
	"mPinLoginService",
	"clickStreamService",
    "$ionicSideMenuDelegate",
	function ($state,
		$scope,
		$translate,
		ompShopService,
		$ionicHistory,
		utilityService,
		filterService,
		searchListServices,
		ompMerchantsService,
		mPinLoginService,
		clickStreamService,
		$ionicSideMenuDelegate) {
		
		var categoryListVm = this;
			categoryListVm.item = "f";
			categoryListVm.goNext = function(data) {
				categoryListVm.item = data;
				ompShopService.category = data.name;
				if (data.childrenData.length > 0) {
					ompShopService.subCategory = data.childrenData;
					$state.go('menu.electronics');
				} else {
					filterService.selectedLevelThreeData = data.name;
					searchListServices.searchFor = data.name;
					filterService.selectedCategoryId = data.id;
					var obj = {
						"category" : data.id,
						"websiteId" : ompMerchantsService.listName.websiteId,
						"filters" : [],
						"sort" : {},
						"isLoggedIn":mPinLoginService.isLoggedIn
					}
					searchListServices.getSelectedCategoryProduct(obj).then(function(data) {
						filterService.filterOldData = searchListServices.filterData;
						searchListServices.allProductsList = data;
						searchListServices.isCompareAvailable = true;
						searchListServices.serviceFrom = 'getSelectedCategoryProduct';
						searchListServices.serviceFromObj = obj;
						searchListServices.products.length = 0
						filterService.addedFilterFullData.length = 0
						filterService.addedFilterData.length = 0
						filterService.selectedColour.length = 0
						searchListServices.filterNewData = {
						                	          		categoryList : [],
						                	          		subCategoryList : [],
						                	          		colorList : [],
						                	          		priceList : [],
						                	          		callFunctionsList : []
						                	          	};
						filterService.isFilterApplied = false;
						searchListServices.isSortApplied = false;
						$state.go('menu.searchList');
					}, function(error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				
				}
				
			};
			categoryListVm.goBack = function() {
				$ionicHistory.goBack(-1);
			};
			$scope.$on('$ionicView.afterEnter', function() {
				ompMerchantsService.startTimer();
			});
			$scope.$on('$ionicView.beforeEnter', function() {
				    categoryListVm.catList = ompShopService.categoryList;
					$scope.addDataToClickStream();
					$ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
           
			});
			$scope.$on('$ionicView.beforeLeave', function(){
				   ompMerchantsService.endTimer();
			});
			$scope.addDataToClickStream = function() {
					if(ompMerchantsService){
						if(ompMerchantsService.listName){
							clickStreamService.clickStreamData = "websiteId,"+ompMerchantsService.listName.affiliateId;
					 }	
					};	
			};
			return this;
		}
]);
