'use strict';

angularApp.controller('comparisonChartController', [
	"$state",
	"$scope",
	"$translate",
	"comparisonChartService",
	"$ionicHistory",
	"constantConfig",
	"productDescriptionServices",
	"utilityService",
	"ompShopService",
	"mPinLoginService",
       "ompMerchantsService",
       "clickStreamService",
       "$ionicSideMenuDelegate",
	function ($state,
		$scope,
		$translate,
		comparisonChartService,
		$ionicHistory,
		constantConfig,
		productDescriptionServices,
		utilityService,
		ompShopService,
		mPinLoginService,
		ompMerchantsService,
		clickStreamService,
		$ionicSideMenuDelegate) {

			var comparisonChartVm = this;
			comparisonChartVm.detailDescLeft = function() {
				var productLeft = {
					"websiteId" : ompShopService.merWebId,
					"productId" : comparisonChartVm.merNamesL.id,
					"isLoggedIn":mPinLoginService.isLoggedIn
				};
				productDescriptionServices.getProductDetails(productLeft).then(function(data) {
					productDescriptionServices.productData = data;
					$state.go('menu.productDescription');
				}, function(error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			};
			comparisonChartVm.detailDescRight = function() {
				var productRight = {
					"websiteId" : ompShopService.merWebId,
					"productId" : comparisonChartVm.merNamesR.id,
					"isLoggedIn":mPinLoginService.isLoggedIn
				};
				productDescriptionServices.getProductDetails(productRight).then(function(data) {
					productDescriptionServices.productData = data;
					$state.go('menu.productDescription');
				}, function(error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			};
			comparisonChartVm.goBack = function() {
				$ionicHistory.goBack(-1);
			};
			
			$scope.$on('$ionicView.beforeLeave', function(){
				   ompMerchantsService.endTimer();
				});
			$scope.$on('$ionicView.afterEnter', function() {
				ompMerchantsService.startTimer();
			});	
			$scope.$on('$ionicView.beforeEnter', function() {
				comparisonChartVm.dealImg = constantConfig.omp.dealImg;
				comparisonChartVm.disc = constantConfig.omp.discount;
				comparisonChartVm.merWebId = ompShopService.merWebId;
				comparisonChartVm.compareData = comparisonChartService.compareData;
				comparisonChartVm.merNamesL = comparisonChartVm.compareData[0];
				comparisonChartVm.merNamesR = comparisonChartVm.compareData[1];
				comparisonChartVm.specifications = [];
				var specificationLen = comparisonChartVm.merNamesL.specification.length;
				for (var i = 0; i < specificationLen; i++) {
					var obj = {
						label : comparisonChartVm.merNamesL.specification[i].label,
						value1 : comparisonChartVm.merNamesL.specification[i].value,
						value2 : comparisonChartVm.merNamesR.specification[i].value
					};
					comparisonChartVm.specifications.push(obj);
				};
				$scope.addDataToClickStream();
				$ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
			});
			$scope.addDataToClickStream = function() {
									if(ompMerchantsService){
										if(ompMerchantsService.listName){
											clickStreamService.clickStreamData = "websiteId,"+ompMerchantsService.listName.affiliateId;
									 }	
									};	
							};
			return this;
		}
]);
