'use strict';

angularApp.controller('electronicsController', 
						["$state",
						 "$scope",
						 "$translate",
						 "searchListServices",
						 "ompShopService",
						 "$ionicHistory",
						 "filterService",
						 "ompMerchantsService",
						 "utilityService",
						"mPinLoginService",
						"clickStreamService",
						"$ionicSideMenuDelegate",
function ($state,
		 $scope,
		 $translate,
		 searchListServices,
		 ompShopService,
		 $ionicHistory,
		 filterService,
		 ompMerchantsService,
		 utilityService,
		 mPinLoginService,
		 clickStreamService,
		 $ionicSideMenuDelegate) {
	
			var electronicsVm = this;
			electronicsVm.item = "";
			electronicsVm.subItem = "";
			electronicsVm.goNext = function(data) {
				electronicsVm.subItem = data.name;
				filterService.selectedLevelThreeData = data.name;
				searchListServices.searchFor = data.name;
				filterService.selectedCategoryId = data.id;
				var obj = {
					"category" : data.id,
					"websiteId" : ompMerchantsService.listName.websiteId,
					"filters" : [],
					"sort" : {},
					"isLoggedIn":mPinLoginService.isLoggedIn
				}
				searchListServices.getSelectedCategoryProduct(obj).then(function(data) {
					filterService.filterOldData = searchListServices.filterData;
					searchListServices.allProductsList = data;
					searchListServices.isCompareAvailable = true;
					searchListServices.serviceFrom = 'getSelectedCategoryProduct';
					searchListServices.serviceFromObj = obj;
					searchListServices.products.length = 0
					filterService.addedFilterFullData.length = 0
					filterService.addedFilterData.length = 0
					filterService.selectedColour.length = 0
					searchListServices.filterNewData = {
					                	          		categoryList : [],
					                	          		subCategoryList : [],
					                	          		colorList : [],
					                	          		priceList : [],
					                	          		callFunctionsList : []
					                	          	};
					filterService.isFilterApplied = false;
					searchListServices.isSortApplied = false;
					$state.go('menu.searchList');
				}, function(error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			};
			electronicsVm.goBack = function() {
				$ionicHistory.goBack(-1);
			};
			$scope.toggleGroup = function(category) {
				electronicsVm.item = category.name;
				filterService.selectedLevelTwoData = category.name;
				if (category.childrenData.length > 0) {
					if ($scope.isGroupShown(category.name)) {
						$scope.shownGroup = null;
					} else {
						$scope.shownGroup = category.name;
					}
				} else {
					electronicsVm.goNext(category);
				}
			};
			$scope.isGroupShown = function(category) {
				return ($scope.shownGroup === category);
			};
			$scope.$on('$ionicView.beforeLeave', function(){
				   ompMerchantsService.endTimer();
				});
			$scope.$on('$ionicView.afterEnter', function() {
				ompMerchantsService.startTimer();
			});	
			$scope.$on('$ionicView.beforeEnter', function() {
				electronicsVm.categoryName = ompShopService.category;
				electronicsVm.catList = ompShopService.subCategory;
				filterService.selectedLevelOneData = ompShopService.category;
				filterService.selectedLevelTwoData = "";
				filterService.selectedLevelThreeData = "";
				$scope.addDataToClickStream();
				$ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
			});
			$scope.addDataToClickStream = function() {
									if(ompMerchantsService){
										if(ompMerchantsService.listName){
											clickStreamService.clickStreamData = "websiteId,"+ompMerchantsService.listName.affiliateId;
									 }	
									};	
							};
			return this;
		}
]);
