'use strict';

angularApp.controller('localWishlistController', 
	["$state",
	"$scope",
	"$translate",
	"localWishlistService",
	"ompMerchantsService",
	"$ionicHistory",
	"constantConfig",
	"productDescriptionServices",
	"utilityService",
	"ompShopService",
	"wishListService",
	"$ionicPopup",
     "mPinLoginService",
     "$ionicSideMenuDelegate",
     "clickStreamService",
	function ( $state,
		$scope,
		$translate,
		localWishlistService,
		ompMerchantsService,
		$ionicHistory,
		constantConfig,
		productDescriptionServices,
		utilityService,
		ompShopService,
		wishListService,
		$ionicPopup,
		mPinLoginService,
		$ionicSideMenuDelegate,
		clickStreamService) {

		var localWishlistVm = this;
			localWishlistVm.goBack = function() {
				$ionicHistory.clearCache().then(function() {
					$ionicHistory.goBack(-1);
				})
			};
			localWishlistVm.productDescription = function(data) {
				var product = {
					"websiteId" : ompMerchantsService.listName.websiteId,
					"productId" : data.id,
					"isLoggedIn":mPinLoginService.isLoggedIn
				};
				productDescriptionServices.getProductDetails(product).then(function(data) {
					productDescriptionServices.productData = data;
					$state.go('menu.productDescription');
				}, function(error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			};
			
		    localWishlistVm.goToShopPage = function(index, product) {
				$state.go('menu.ompShop');
			
			},
			
			localWishlistVm.removeWhishlistBulk=function()
			{
				
				if(localWishlistVm.myPopup)
            	{
					localWishlistVm.myPopup.close();
            	}
				
				
			}

			localWishlistVm.wishDelete = function(index, product) {
				var clearWishList = {
					"websiteId" : ompMerchantsService.listName.websiteId,
					"productId" : product.id,
					"isLoggedIn":mPinLoginService.isLoggedIn
				};
				productDescriptionServices.clearProductWishList(clearWishList).then(function(data) {
					localWishlistVm.searchResult.splice(index, 1);
					$scope.resultCont = localWishlistVm.searchResult.length;
					wishListService.wishCount = data.globalWishlistCount;
					if (data.merchantWishlistCount > 0) {
						ompMerchantsService.isMerchantsWishListAvl = 'S';
					} else {
						ompMerchantsService.isMerchantsWishListAvl = 'N';
					}
					ompMerchantsService.merchantWishlistCount = data.merchantWishlistCount;
					
					if(productDescriptionServices.productData.productDescription[0].id===product.id)
					{
						
						productDescriptionServices.productData.productDescription[0].isWishlist = false;
						
					}
				}, function(error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			};
			$scope.$on('$ionicView.beforeLeave', function(){
				   ompMerchantsService.endTimer();
				});
				$scope.$on('$ionicView.afterEnter', function() {
					ompMerchantsService.startTimer();
				});
			$scope.$on('$ionicView.beforeEnter', function() {
				$scope.resultCont = 0;
				$translate('TOTALITEMS').then(function(transValue) {
					localWishlistVm.total = transValue;
				});
				localWishlistVm.dealImg = constantConfig.omp.dealImg;
				localWishlistVm.disc = constantConfig.omp.discount;
				localWishlistVm.merchantName = ompMerchantsService.listName.name;
				localWishlistVm.pids = localWishlistService.pids;
				var wishList = {
					"websiteId" : ompMerchantsService.listName.websiteId,
					"isLoggedIn":mPinLoginService.isLoggedIn
				};
				localWishlistService.getMerchantWishList(wishList).then(function(data) {
			
					var bulkarray=[];
					var discontinuedProducts=[];
					var bulkWishListObj={};
					var dataArray = data.length;
					if(data.length==0)
						{
						
						data=[];
						
						}
					else
						{
						data=data[0].products
						
						}
					for (var i=0; i < dataArray; i++) {
						  var isActive=  data[i].productStatus;
						if(isActive!="active")
						{
							discontinuedProducts.push(data[i]);
							var clearWishList = {
									"websiteId" : ompMerchantsService.listName.websiteId,
									"productId" : data[i].id,
									
								}
							bulkarray.push(clearWishList);
						}
					}
					
			
					if(discontinuedProducts.length>0)
					{
						bulkWishListObj.wishlist=bulkarray;
						bulkWishListObj.isLoggedIn=mPinLoginService.isLoggedIn;					
					productDescriptionServices.clearProductWishListBulk(bulkWishListObj).then(function(wishlistdata) {
					localWishlistVm.searchResult = data;
							var arr = localWishlistVm.searchResult;
							var discontinuedProductsLen = discontinuedProducts.length;
							for(var i=0;i<discontinuedProductsLen;i++)
								{
							var arrLen = arr.length;
							for (var j=0; j < arrLen; j++) {
							  if(arr[j].id ==  discontinuedProducts[i].id){
								  localWishlistVm.searchResult.splice(j, 1);
							  }
							}
								}
							  
								$scope.resultCont = localWishlistVm.searchResult.length;
								wishListService.wishCount = wishlistdata.globalWishlistCount;
								localWishlistVm.resultCont=wishlistdata.merchantWishlistCount;;
						       
								if (wishlistdata.merchantWishlistCount > 0) {
									ompMerchantsService.isMerchantsWishListAvl = 'S';
								} else {
									ompMerchantsService.isMerchantsWishListAvl = 'N';
								}
								ompMerchantsService.merchantWishlistCount = data.merchantWishlistCount;
								
								$scope.discontProducts=discontinuedProducts;
								
								localWishlistVm.myPopup = $ionicPopup.show({
								     title: '',
								     cssClass : 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',
									 templateUrl: "pages/OMP/localWishlist/RemoveLocalWhishlist.html",
								     scope : $scope
								});
							
						}, function(error) {
							utilityService.showErrorMessage(error.responseMessage);
						});
					}
					
					else
						{
						  localWishlistVm.searchResult = data;
							$scope.resultCont = localWishlistVm.searchResult.length;
						}

				}, function(error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
				$scope.addDataToClickStream();
				$ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
			});
			
			$scope.addDataToClickStream = function() {
									if(ompMerchantsService){
										if(ompMerchantsService.listName){
											clickStreamService.clickStreamData = "websiteId,"+ompMerchantsService.listName.affiliateId;
									 }	
									};	
							};
			return this;
		}
]);
