'use strict';

angularApp.controller('merchantListController', [
    "$state",
    "$scope",
    "ompMerchantsService",
    "$ionicHistory",
    "utilityService",
    "mPinLoginService",
    "clickStreamService",
    "$ionicSideMenuDelegate",
    "$ionicPopup",
    "$ionicSlideBoxDelegate",
    "homeScreenService",
    "$ionicScrollDelegate",
    "irctcService",
    "paclService",
    "homeLoanService", "loggedInUserService", "cryptoService", "$translate", "automallService",
    "quickPayService", "$ionicPopover", "internetBankingService", "ConnectivityMonitorUtils", "constantConfig", "$rootScope", "$ionicPlatform","registerWithSimService","ompOffersService",

    function ($state,
        $scope,
        ompMerchantsService,
        $ionicHistory,
        utilityService,
        mPinLoginService,
        clickStreamService,
        $ionicSideMenuDelegate,
        $ionicPopup, $ionicSlideBoxDelegate, homeScreenService, $ionicScrollDelegate, irctcService, paclService, homeLoanService, loggedInUserService, cryptoService,
        $translate, automallService,
        quickPayService, $ionicPopover, internetBankingService, ConnectivityMonitorUtils, constantConfig, $rootScope, $ionicPlatform, registerWithSimService, ompOffersService) {
        var isWebviewLoadingCanceled = false;
        var merchantListVm = this;
        $scope.selectBoxOpened = true;
        //authUser
        merchantListVm.keystoreValue = loggedInUserService.keystoreValue;
        merchantListVm.authFlag = "";
        merchantListVm.mpinErrorMsg = "";
        merchantListVm.mpinErrorMsgFlag = false;
        merchantListVm.isLoginBtnClicked = false;
        ompMerchantsService.redirectUrlModif = false;
        ompMerchantsService.pseudoId = "";
        ompMerchantsService.psudoIdEnble = false;
        merchantListVm.userAuthPopoverTemplate = quickPayService.userAuthPopoverTemplateOmp("", "merchantListVm");
        $scope.popover = $ionicPopover.fromTemplate(merchantListVm.userAuthPopoverTemplate, {
            scope: $scope
        });

        function initPage() {
            $translate(['YQP_USERNAME', 'YQP_PASSWORD']).then(function (translations) {
                merchantListVm.usernameTxt = translations['YQP_USERNAME'];
                merchantListVm.passwordTxt = translations['YQP_PASSWORD'];
            });
            merchantListVm.isImageAvl = false;
            merchantListVm.toggle.checked = false;
            merchantListVm.isFingerprintAvl = quickPayService.isFingerprintAviFlag;
            merchantListVm.isMpinSet = loggedInUserService.mpinConsent;
            $scope.passLenLimitReached = false;
            if (!merchantListVm.isMpinSet) {
                merchantListVm.toggle.checked = true;
            }
            if (quickPayService.customerInfo != '')
                merchantListVm.accountList = quickPayService.customerInfo.accounts;
            quickPayService.isFingerprintAvailable().then(function (response) {
                merchantListVm.isFingerprintAvl = response.responseMessage;
            }, function (error) {
                console.log(error);
            });
            merchantListVm.bio_text = "";
            if (quickPayService.isBiometricType == 'face') {
                merchantListVm.bio_text = "Face ID";
            } else {
                merchantListVm.bio_text = "Touch ID";
            }
            $translate(['ENABLE_FACEID', 'ENABLE_FACEID_DESC', 'YQP_AUTH_MSG'], { FIELD_1: merchantListVm.bio_text }).then(function (translations) {
                merchantListVm.ENABLE_FACEID = translations['ENABLE_FACEID'];
                merchantListVm.ENABLE_FACEID_DESC = translations['ENABLE_FACEID_DESC'];
                merchantListVm.YQP_AUTH_MSG = translations['YQP_AUTH_MSG'];
            });
            if (!merchantListVm.isImageAvl) {
                var full_name = localStorage.getItem("customername");
                if (full_name != "" && full_name !== null) {
                    var name_array = full_name.split(" ");
                    var first_initial = name_array[0].charAt(0);
                    var last_initial = name_array[name_array.length - 1].charAt(0);
                    merchantListVm.customerNameInitials = first_initial + last_initial;
                    merchantListVm.customerFirstName = full_name;
                } else {
                    merchantListVm.customerNameInitials = "";
                    merchantListVm.customerFirstName = "";
                }
            }
        }

        $scope.openPopover = function ($event) {
            merchantListVm.authFailure = false;
            $scope.popover.show($event);
            merchantListVm.isFingerprintAvl = false;
            merchantListVm.isFingerprintAvlDevice = false;
            quickPayService.isFingerprintAvailable().then(function (response) {
                merchantListVm.isFingerprintAvlDevice = true;
                var fingerprintToken = "";
                cordova.plugins.SecureKeyStore.get(function (res) {
                    fingerprintToken = res;
                    if (fingerprintToken == null || fingerprintToken == "null" || fingerprintToken == undefined || fingerprintToken == "undefined" || fingerprintToken == "") {
                        merchantListVm.isFingerprintAvl = false;
                    } else {
                        merchantListVm.isFingerprintAvl = true;
                        //to auto populate fingerprint option
                        merchantListVm.checkBiometric();
                    }
                }, function (error) {
                    console.log(error);
                }, loggedInUserService.deviceInfo);
            }, function (error) {
                console.log(error);
            });
        };

        $scope.closePopover = function ($event) {
            $scope.popover.hide();
        };

        $scope.$on('$destroy', function () {
            $scope.popover.hide();
            $scope.popover.remove();
        });

        $scope.clearMpin = function () {
            for (var iterate = 0; iterate <= 5; iterate++) {
                $scope.doErase();
            }
        }

        merchantListVm.popoverBbackdrop = function () {
            var backDrop = document.getElementsByClassName("popover-backdrop");
            if (backDrop && backDrop[0]) {
                backDrop[0].setAttribute("style", "background-color: rgba(0, 0, 0, 0.7) !important;");
            }
        }

        merchantListVm.toggle = function () {
            $scope.hideKeyboard();
            if (merchantListVm.toggle.checked) {
                var userAuthModalICId = document.getElementById("userAuthModalICId");
                if (userAuthModalICId) {
                    userAuthModalICId.setAttribute("style", "bottom:0px !important;");
                }
            }
        }

        merchantListVm.checkBiometric = function () {
            if (quickPayService.isFingerprintAviFlag && !merchantListVm.authfailure) {
                var encryptConfig = {
                    clientId: "SBI YONO", //Android: Used for encryption. iOS: used for dialogue if no `localizedReason` is given.
                    clientSecret: loggedInUserService.deviceInfo, //Necessary for Android encrpytion of keys. Use random secret key.
                    disableBackup: true,
                };
                Fingerprint.show(encryptConfig, successCallback, errorCallback);
            }
        }

        function successCallback(result) {
                //call service to Auth
                authByBiometric();
        }

        function errorCallback(error) {
            console.log(error);
        }

        function authByBiometric() {
            if (utilityService.isAndroidPlatform() && registerWithSimService.isSimLogin && !registerWithSimService.userWithoutSimReg && (merchantListVm.isSimChanged || merchantListVm.simList == undefined || merchantListVm.simList.length == 0)) {
                if (merchantListVm.isSimChanged)
                    registerWithSimService.reloadAppSimOk(registerWithSimService.changedSimMsg);
                else if (merchantListVm.simList == undefined || merchantListVm.simList.length == 0)
                    utilityService.showBhimUpiAlert("alert", registerWithSimService.noSimMsg);
                return;
            }
            var hasedSimInfo = "";
            if (utilityService.isAndroidPlatform()) {
                hasedSimInfo = merchantListVm.hasedSimInfo ? merchantListVm.hasedSimInfo : "";
            }
            var params = { 'type': 'biometric', 'source': 'omp', "simId": hasedSimInfo.toString() };
            //call service to retrieve token at adapter
            quickPayService.userAuthentication(params).then(function (data) {
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "OMP_MERC_AUTHBYBIOSUCCESS"));
                afterUserAuthSuccess(data);
            }, function (error) {
                merchantListVm.authFailure = true;
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "OMP_MERC_AUTHBYBIOFAIL"));
                if (error.responseCode == constantConfig.FORCE_PWD_ERROR_CODES.FP01) {
                    merchantListVm.authFailure = false;
                    utilityService.showForcePasswordPopup(error.responseMessage, "");
                } else {
                    quickPayService.showAuthFailurePopup('error', error.responseMessage, '', '', 'OK', '', $scope, true, function () { merchantListVm.authFailure = false; });
                }
            });
        }

        merchantListVm.loginWithMpin = function () {
            if (utilityService.isAndroidPlatform() && registerWithSimService.isSimLogin && !registerWithSimService.userWithoutSimReg && (merchantListVm.isSimChanged || merchantListVm.simList == undefined || merchantListVm.simList.length == 0)) {
                if (merchantListVm.isSimChanged)
                    registerWithSimService.reloadAppSimOk(registerWithSimService.changedSimMsg);
                else if (merchantListVm.simList == undefined || merchantListVm.simList.length == 0)
                    utilityService.showBhimUpiAlert("alert", registerWithSimService.noSimMsg);
                return;
            }
            var newMpin = merchantListVm.first.trim() +
                merchantListVm.second.trim() +
                merchantListVm.third.trim() +
                merchantListVm.fourth.trim() +
                merchantListVm.fifth.trim() +
                merchantListVm.sixth.trim();
            if (newMpin.length == 6) {
                if (ConnectivityMonitorUtils.isOffline()) {
                    merchantListVm.emptyValues();
                    $scope.clearMpin();
                    /*login flow improvement*/
                    var inputElement = document.getElementById('InputTxt1');
                    inputElement.disabled = false;
                    utilityService.offlineAlert();
                    return;
                }
                var hasedSimInfo = "";
                if (utilityService.isAndroidPlatform()) {
                    hasedSimInfo = merchantListVm.hasedSimInfo ? merchantListVm.hasedSimInfo : "";
                }
                var requestParams = {
                    "mPinNumber": newMpin,
                    "type": "mpin",
                    "source": "omp",
                    "simId": hasedSimInfo.toString(),
                    "simSubId" : merchantListVm.simSubscriptionId
                };
                quickPayService.userAuthentication(requestParams).then(function (data) {
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "OMP_MERC_AUTHBYMPINSUCCESS"));
                    $scope.hideKeyboard();
                    afterUserAuthSuccess(data);
                    merchantListVm.emptyValues();
                    $scope.passLenLimitReached = false;
                    $scope.clearMpin();
                }, function (error) {
                    $scope.passLenLimitReached = false;
                    merchantListVm.emptyValues();
                    $scope.clearMpin();
                    merchantListVm.enabledThisInput(1);
                    merchantListVm.authFailure = true;
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "OMP_MERC_AUTHBYMPINFAIL"));
                    if (error.responseCode == constantConfig.FORCE_PWD_ERROR_CODES.FP01) {
                        merchantListVm.authFailure = false;
                        utilityService.showForcePasswordPopup(error.responseMessage, "");
                    } else {
                        quickPayService.showAuthFailurePopup('error', error.responseMessage, '', '', 'OK', '', $scope, true, function () { merchantListVm.authFailure = false; });
                    }
                });
            } else {
                merchantListVm.emptyValues();
                $scope.clearMpin();
                merchantListVm.enabledThisInput(1);
                merchantListVm.authFailure = true;
                quickPayService.showAuthFailurePopup('error', 'Please Enter 6 digit valid MPIN', '', '', 'OK', '', $scope, true, function () { merchantListVm.authFailure = false; });
            }
        };

        merchantListVm.changeInput = function ($event, index) {
            cordova.plugins.Keyboard.close();
            /*login flow improvements*/
            if (loggedInUserService.isServerConnected) {
                merchantListVm.loginWithMpin();
            }
        }

        merchantListVm.enabledThisInput = function (index) {
            try {
                merchantListVm.mpinErrorMsgFlag = false;
                for (var i = 1; i <= 6; i++) {
                    var inputElement = document.getElementById('InputTxt' + i);
                    if (index == i) {
                        inputElement.disabled = false;
                        inputElement.style = "border-bottom:1px solid #0095da !important;"
                    } else {
                        inputElement.disabled = true;
                        inputElement.style = "border-bottom:1px solid #bcbebf !important;"
                    }
                }
            } catch (err) { console.log(err); }
        }

        merchantListVm.authenticate = function () {
            merchantListVm.userLoginErrorFlag = false;
            merchantListVm.isLoginBtnClicked = true;
            if (merchantListVm.userName && merchantListVm.pswd) {
                merchantListVm.isLoginBtnClicked = false;
                utilityService.showSpinner();
                internetBankingService.getServiceIdAndKey().then(function (data) {
                    loggedInUserService.keyIdINB = data.keyId;
                    loggedInUserService.serviceIdINB = data.serviceId;
                    loggedInUserService.finalSHA512Val = loggedInUserService.generateINBSHA512Val(merchantListVm.userName, merchantListVm.pswd);
                    utilityService.hideSpinner();
                    merchantListVm.userloginStart();
                }, function (error) {
                    merchantListVm.userName = '';
                    merchantListVm.pswd = '';
                    utilityService.hideSpinner();
                    merchantListVm.authFailure = true;
                    if (error.responseMessage) {
                        quickPayService.showAuthFailurePopup('error', error.responseMessage, '', '', 'OK', '', $scope, true, function () { merchantListVm.authFailure = false; });
                    } else {
                        quickPayService.showAuthFailurePopup('error', constantConfig.adapter.CANNOT_PROCESS_NOW, '', '', 'OK', '', $scope, true, function () { merchantListVm.authFailure = false; });
                    }
                });
            }
        }

        merchantListVm.userloginStart = function () {
            var hasedSimInfo = "";
            if (utilityService.isAndroidPlatform()) {
                hasedSimInfo = merchantListVm.hasedSimInfo ? merchantListVm.hasedSimInfo : "";
            }
            var requestParams = {
                "userName": merchantListVm.userName,
                "sha512Password": loggedInUserService.finalSHA512Val,
                "type": "username",
                "source": "omp",
                "simId": hasedSimInfo.toString()
            };
            quickPayService.userAuthentication(requestParams).then(function (data) {
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "OMP_MERC_AUTHBYUSERNAMESUCCESS"));
                $scope.hideKeyboard();
                merchantListVm.userName = "";
                merchantListVm.pswd = "";
                afterUserAuthSuccess(data);
            }, function (error) {
                merchantListVm.authFailure = true;
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "OMP_MERC_AUTHBYUSERNAMEFAIL"));
                if (error.responseCode == constantConfig.FORCE_PWD_ERROR_CODES.FP01) {
                    merchantListVm.authFailure = false;
                    utilityService.showForcePasswordPopup(error.responseMessage, "");
                } else {
                    quickPayService.showAuthFailurePopup('error', error.responseMessage, '', '', 'OK', '', $scope, true, function () { merchantListVm.authFailure = false; });
                }
            });
        }

        function afterUserAuthSuccess(data) {
            if (data) {
                quickPayService.customerInfo = data;
                quickPayService.yqpBiometricLimit = quickPayService.customerInfo.yqpBiometricLimit;
                quickPayService.yqpVpaLimit = quickPayService.customerInfo.yqpVpaLimit;
                quickPayService.yqpBeneficiaryLimit = quickPayService.customerInfo.yqpBeneficiaryLimit;
                quickPayService.yqpRaiseRequestLimit = quickPayService.customerInfo.yqpRaiseRequestLimit;
                localStorage.setItem('customerImageId', quickPayService.customerInfo.customerInformation.imageUrl);
                ompMerchantsService.redirectUrlModif = true;
                ompMerchantsService.pseudoId = data.lotusId;
            }
            // store pseudo id in cache and append in mobile URI.
            quickPayService.viewbalAvl = false;
            if (($scope.merchantDetails.coupons || $scope.merchantDetails.offerPoints) && ($scope.merchantDetails.coupons.length > 0 || $scope.merchantDetails.offerPoints.length > 0)) {
                $state.go('menu.redirectionDiscliamer');
            } else {
                $scope.closePopover();
                merchantListVm.dynamicDisclaimer = decodeURIComponent($scope.merchantDetails.disclaimerContent).replace(new RegExp("\\+", "g"), ' ');
                merchantListVm.disclaimer($scope.merchantDetails);
                if (ompMerchantsService) {
                    if ($scope.merchantDetails.websiteId) {
                        clickStreamService.clickStreamData = "websiteId," + $scope.merchantDetails.affiliateId;
                    }
                }
            }
        }

        /*Custom Keypad for MPIN*/
        $scope.pswd = '';
        $scope.canErase = false;
        $scope.pinDotVisible = {};
        $scope.success = null;
        $scope.keyboardVisible = false;
        $scope.pinArray = [];
        $scope.keyboardSettings = {
            // settings here
            action: function (number) {
                var pass;
                if ($scope.pswd.length < 6) {
                    $scope.pswd += number;
                    $scope.pinArray.push(number);
                    $scope.pinDotVisible[$scope.pswd.length] = true;
                    $scope.canErase = true;
                    $scope.success = null;
                    pass = $scope.pswd;
                    pass = pass.split("");
                    try {
                        merchantListVm.first = pass[0];
                        merchantListVm.second = pass[1];
                        merchantListVm.third = pass[2];
                        merchantListVm.fourth = pass[3];
                        merchantListVm.fifth = pass[4];
                        merchantListVm.sixth = pass[5];
                    } catch (err) { console.log(err); }
                }
                if ($scope.pswd && $scope.pswd.length === 6 && !$scope.passLenLimitReached) {
                    $scope.passLenLimitReached = true;
                    var e = {};
                    $scope.newMpin = $scope.pswd;
                    pass = $scope.pswd;
                    pass = pass.split("");
                    try {
                        merchantListVm.first = pass[0];
                        merchantListVm.second = pass[1];
                        merchantListVm.third = pass[2];
                        merchantListVm.fourth = pass[3];
                        merchantListVm.fifth = pass[4];
                        merchantListVm.sixth = pass[5];
                        e = {};
                        e.srcElement = {};
                        e.srcElement.value = 2;
                        merchantListVm.changeInput(e, 6);
                    } catch (err) { console.log(err); }
                }
            },
            // Clear
            leftButton: {
                html: '<i class="icon ion-backspace"></i>',
                action: function () {
                    $scope.doErase();
                },
                style: {
                    bgColor: '#fff',
                    activeBgColor: '#dfdfdf',
                    borderColor: '#dfdfdf',
                    fontSize: '20px'
                }
            },
            // Submit login
            rightButton: {
                html: '<i class="icon ion-eye"></i> <i class="icon ion-eye-disabled login-eye-btn" ></i>',
                action: function () {
                    var elementHide;
                    var elementShow;
                    if ($scope.isPassVisible) {
                        elementHide = document.getElementsByClassName("ion-eye-disabled")[0];
                        elementHide.classList.add("login-eye-btn");
                        elementShow = document.getElementsByClassName("ion-eye")[0];
                        elementShow.classList.remove("login-eye-btn");
                        $scope.isPassVisible = false;
                    } else {
                        $scope.isPassVisible = true;
                        elementHide = document.getElementsByClassName("ion-eye")[0];
                        elementHide.classList.add("login-eye-btn");
                        elementShow = document.getElementsByClassName("ion-eye-disabled")[0];
                        elementShow.classList.remove("login-eye-btn");
                    }
                },
                style: {
                    bgColor: '#fff',
                    activeBgColor: '#dfdfdf',
                    borderColor: '#dfdfdf',
                    fontSize: '30px'
                }
            }
        }

        $scope.doErase = function () {
            $scope.pinDotVisible[$scope.pswd.length] = false;
            $scope.pswd = $scope.pswd.slice(0, -1);
            if ($scope.pswd.length == 0) $scope.canErase = false;
            try {
                var pass = $scope.pswd;
                pass = pass.split("");
                merchantListVm.first = pass[0] ? pass[0] : "";
                merchantListVm.second = pass[1] ? pass[1] : "";
                merchantListVm.third = pass[2] ? pass[2] : "";
                merchantListVm.fourth = pass[3] ? pass[3] : "";
                merchantListVm.fifth = pass[4] ? pass[4] : "";
                merchantListVm.sixth = pass[5] ? pass[5] : "";
            } catch (err) { console.log(err); }
        }

        $scope.rightAction = function () {
            pinDotVisible[0] = false;
            pinDotVisible[1] = false;
            pinDotVisible[2] = false;
            pinDotVisible[3] = false;
            pinDotVisible[4] = false;
            pinDotVisible[5] = false;
        }

        $scope.showKeyboard = function () {
            $scope.keyboardVisible = true;
        }

        $rootScope.hidekeypad = function ($event) {
            switch ($event.target.className) {
                case "mpin1 activated":
                // code block
                case "digit-keyboard-key":
                // code block
                case "digit-keyboard-key-action ng-binding":
                // code block
                case "icon ion-record":
                // code block
                case "digit-keyboard-key activated":
                // code block
                case "icon ion-backspace":
                // code block
                case "mpin1 ng-pristine ng-untouched ng-valid ng-empty activated":
                // code block
                case "mpin1 ng-binding":
                // code block
                case "icon ion-eye-disabled login-eye-btn":
                // code block
                case "icon ion-eye login-eye-btn":
                // code block
                case "digit-keyboard-key-number":
                    // code block
                    if (!$scope.keyboardVisible) {
                        $scope.showKeyboard();
                    }
                    break;
                default:
                    // code block
                    if ($scope.keyboardVisible) {
                        $scope.hideKeyboard();
                    }
                    break;
            }
        }

        $scope.hideKeyboard = function () {
            $scope.keyboardVisible = false;
        }
        /*End of Custom Keypad for MPIN*/
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
            navigator.splashscreen.hide();
        });

        merchantListVm.emptyValues = function () {
            merchantListVm.first = '';
            merchantListVm.second = '';
            merchantListVm.third = '';
            merchantListVm.fourth = '';
            merchantListVm.fifth = '';
            merchantListVm.sixth = '';
        }
        //authUser end

        merchantListVm.goBack = function () {
            $state.go('menu.viewAllCategories');
        }
        merchantListVm.next = function () {
            $ionicSlideBoxDelegate.next();
        }
        merchantListVm.previous = function () {
            $ionicSlideBoxDelegate.previous();
        }
        merchantListVm.openSelectBoxPopup = function () {
            if ($scope.selectBoxOpened == true) {
                $scope.selectBoxOpened = false;
            } else {
                $scope.selectBoxOpened = true;
            }
        }
        merchantListVm.goToTopBrands = function () {
            $ionicScrollDelegate.scrollTop();
            $scope.selectedCategory = "Top Brands";
            $scope.isTopBrands = true;
            merchantListVm.openSelectBoxPopup();
            var obj = {
            };
            obj.shopNOrder = $scope.shopNOrderPreHash;
            ompMerchantsService.getTopBrands(obj).then(function (data) {
                ompMerchantsService.isLoggedIn = data.isLoggedIn;
                var topBrandsArray = [];
                for (var i = 0; i < data.length; i++) {
                    if (data[i].contentID === "OMPTB000101") {
                        topBrandsArray[0] = data[i];
                    } else if (data[i].contentID === "OMPTB000102") {
                        topBrandsArray[1] = data[i];
                    } else if (data[i].contentID === "OMPTB000104") {
                        topBrandsArray[2] = data[i];
                    } else if (data[i].contentID === "OMPTB000107") {
                        topBrandsArray[3] = data[i];
                    } else if (data[i].contentID === "OMPTB000106") {
                        topBrandsArray[4] = data[i];
                    } else if (data[i].contentID === "OMPTB000103") {
                        topBrandsArray[5] = data[i];
                    } else if (data[i].contentID === "OMPTB000105") {
                        topBrandsArray[6] = data[i];
                    } else if (data[i].contentID === "OMPTB000108") {
                        topBrandsArray[7] = data[i];
                    } else if (data[i].contentID === "OMPTB000109") {
                        topBrandsArray[8] = data[i];
                    }
                }
                merchantListVm.dataForTopBrands = topBrandsArray;
                $scope.merchantDataTopBrands = merchantListVm.dataForTopBrands;
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        merchantListVm.goToRespectiveStores = function (store) {
            merchantListVm.paclBannerFlag = false;
            $scope.categoryCode = store.categoryCode;
            homeScreenService.categoryCode = store.categoryCode;
            if (store.title == "Top Brands") {
                merchantListVm.goToTopBrands();
            }
            if (homeScreenService.categoryCode == 'OMPS100' && store.isAutomobileLandingPage === true) {
                if (!mPinLoginService.isLoggedIn) {
                    localStorage.setItem('isRedirectedTowdsLoan', "");
                    localStorage.setItem('redirectOnlyFlow', "");
                    homeScreenService.irctcCallAfterSuccLogin = false;
                    homeScreenService.automallCallAfterSuccLogin = false;
                    homeScreenService.automobileCallAfterSuccLogin = true;
                    loggedInUserService.productClicked = 'menu.homeScreen'; // 'menu.irctcBookTicketSearch';
                    $state.go('menu.userLogin');
                } else {
                    $state.go('menu.automobileLanding');
                }
            } else {
                $ionicScrollDelegate.scrollTop();
                clickStreamService.clickStreamData = "websiteId," + store.categoryCode;
                $scope.selectedCategory = store.title;
                $scope.isTopBrands = false;
                merchantListVm.openSelectBoxPopup();
                var obj = {
                    "categoryCode": store.categoryCode
                };
                obj.shopNOrder = $scope.shopNOrderPreHash;
                ompMerchantsService.getMerchantsByCategory(obj).then(function (data) {
                    ompMerchantsService.isLoggedIn = data.isLoggedIn;
                    $scope.selectedCategory = data[0].merchant.label;
                    merchantListVm.dataForIndividualMerchant = data[0].merchant.mobileData;
                    $scope.merchantData = merchantListVm.dataForIndividualMerchant;
                    if ($scope.categoryCode === "OMPS100" && (!$scope.shopNOrderPre)) {
                        merchantListVm.paclBannerShow();
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        }

        merchantListVm.goNext = function (merchant, $event) {
            $scope.merchantDetails = merchant;
            $scope.merchantDetails.pageId = $state.current.data.pageId;
            clickStreamService.clickStreamData = "websiteId," + merchant.affiliateId;
            ompMerchantsService.listName = merchant;
            ompMerchantsService.listName.pageId = $state.current.data.pageId;
            ompMerchantsService.merchantWishlistCount = merchant.merchantWishlistCount;
            if (ompMerchantsService.merchantWishlistCount > 0) {
                ompMerchantsService.isMerchantsWishListAvl = "S"
            } else {
                ompMerchantsService.isMerchantsWishListAvl = "N"
            }
            if (merchant.merchantType === 'Redirection') {
                //check for merchant pseudo flag value
                if (merchant.psudoIdEnble && !mPinLoginService.isLoggedIn) {
                    ompMerchantsService.psudoIdEnble = true;
                    ompMerchantsService.redirectUrlModif = true;
                    merchantListVm.clickOn = 'omp';
                    merchantListVm.emptyValues();
                    $scope.clearMpin();
                    $scope.openPopover($event);
                    //dynamically adding background colour
                    merchantListVm.popoverBbackdrop();
                } else {
                    ompMerchantsService.psudoIdEnble = merchant.psudoIdEnble;
                    ompMerchantsService.redirectUrlModif = false;
                    if ((merchant.coupons || merchant.offerPoints) && (merchant.coupons.length > 0 || merchant.offerPoints.length > 0)) {
                        $state.go('menu.redirectionDiscliamer');
                    } else {
                        merchantListVm.dynamicDisclaimer = decodeURIComponent(merchant.disclaimerContent).replace(new RegExp("\\+", "g"), ' ');
                        merchantListVm.disclaimer(merchant);
                        if (ompMerchantsService) {
                            if (merchant.websiteId) {
                                clickStreamService.clickStreamData = "websiteId," + merchant.affiliateId;
                            }
                        }
                    }
                }
            } else if (merchant.merchantType === 'Custom') {
                if (merchant.affiliateId == $scope.irctcAffliateId) { //IRCTC
                    //condition to check if user logeded in or not
                    if (!mPinLoginService.isLoggedIn) {
                        localStorage.setItem('isRedirectedTowdsLoan', "");
                        localStorage.setItem('redirectOnlyFlow', "");
                        homeScreenService.irctcCallAfterSuccLogin = true;
                        homeScreenService.automallCallAfterSuccLogin = false;
                        homeScreenService.automobileCallAfterSuccLogin = false;
                        homeScreenService.storeSelected = $scope.selectedCategory;
                        homeScreenService.categoryCode = $scope.categoryCode;
                        loggedInUserService.productClicked = 'menu.homeScreen'; // 'menu.irctcBookTicketSearch';
                        $state.go('menu.userLogin');
                    } else {
                        homeScreenService.storeSelected = $scope.selectedCategory;
                        homeScreenService.categoryCode = $scope.categoryCode;
                        irctcService.searchTrainObj = "";
                        irctcService.myList = "";
                        irctcService.masterData = "";
                        irctcService.selectedTrainData = "";
                        irctcService.myListFullData = "";
                        irctcService.infantArray = [];
                        irctcService.passArray = [];
                        $state.go('menu.irctcBookTicketSearch');
                    }

                } else if (merchant.affiliateId == $scope.homeLoanAffliateId) { // Home Loan
                    $scope.saveOMPLead(merchant);
                    try {
                        homeScreenService.isOMPMenu = true;
                        homeLoanService.hambergerSelectedLoanType = 'home';
                        $state.go('menu.loans');
                    } catch (error) {
                        homeScreenService.isOMPMenu = false;
                        utilityService.showErrorMessage(merchantListVm.pathError);
                    }
                } else if (merchant.affiliateId == $scope.carLoanAffliateId) { // Car Loan
                    try {
                        $scope.saveOMPLead(merchant);
                        homeScreenService.isOMPMenu = true;
                        homeLoanService.hambergerSelectedLoanType = 'car';
                        $state.go('menu.loans');
                    } catch (error) {
                        homeScreenService.isOMPMenu = false;
                        utilityService.showErrorMessage(merchantListVm.pathError);
                    }
                }
            } else if (merchant.merchantType === 'Automall') {
                //condition to check if user logeded in or not
                if (!mPinLoginService.isLoggedIn) {
                    localStorage.setItem('isRedirectedTowdsLoan', "");
                    localStorage.setItem('redirectOnlyFlow', "");
                    homeScreenService.irctcCallAfterSuccLogin = false;
                    homeScreenService.automallCallAfterSuccLogin = true;
                    homeScreenService.automobileCallAfterSuccLogin = false;
                    loggedInUserService.productClicked = 'menu.homeScreen'; // 'menu.irctcBookTicketSearch';
                    $state.go('menu.userLogin');
                } else {
                    automallService.getEmiMasterService().then(function (emiMaster) {
                        automallService.setMasterEmiData(emiMaster);
                        automallService.getAutomallBanners().then(function (banner) {
                            automallService.setLandingBanners(banner);
                            automallService.getOEMListService().then(function (oemList) {
                                automallService.setOemList(oemList);
                                $state.go('menu.automall');
                            }, function (error) {
                                utilityService.showErrorMessage(error.responseMessage);
                            })

                        }, function (error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }
            }
        }

        $scope.$on('$ionicView.beforeLeave', function () {
            var headerElem = document.querySelector('body');
            var topBar = document.querySelectorAll('.app-header');
            if (headerElem) {
                headerElem.classList.remove('hiddenExtraButton');
            }
            if (topBar) {
                topBar[2].classList.remove('discliamerContent');
            }
            ompMerchantsService.endTimer();
        });

        $scope.$on('$ionicView.afterEnter', function () {
            var headerElem = document.querySelector('body');
            var topBar = document.querySelectorAll('.app-header');
            if (headerElem) {
                headerElem.classList.add('hiddenExtraButton');
            }
            if (headerElem) {
                headerElem.classList.remove('popover-open');
            }
            if (topBar) {
                topBar[2].classList.add('discliamerContent');
            }

            // In case if merchant site is redirected in chrome tab option then popover-open css need to be removed on app resume
            $ionicPlatform.on('resume', function () {
                headerElem = document.querySelector('body');
                if (headerElem) {
                    headerElem.classList.remove('popover-open');
                }
            })

            $translate(['OMP_PATH_ERROR', 'HOME_LOAN_AFFLIATEID', 'CAR_LOAN_AFFLIATEID', 'IRCTC_AFFLIATEID']).then(function (translations) {
                merchantListVm.pathError = translations['OMP_PATH_ERROR'];
                $scope.homeLoanAffliateId = translations['HOME_LOAN_AFFLIATEID'];
                $scope.carLoanAffliateId = translations['CAR_LOAN_AFFLIATEID'];
                $scope.irctcAffliateId = translations['IRCTC_AFFLIATEID'];
            });
            ompMerchantsService.startTimer();
            $scope.isTopBrands = false;
            if (homeScreenService.ishamburgerMenuShop) {
                merchantListVm.isHamCheck = true;
                merchantListVm.isBackCheck = true;
            } else {
                merchantListVm.isHamCheck = false;
                merchantListVm.isBackCheck = false;
            }
            homeScreenService.dummymenuCheck = true;
            merchantListVm.catgList = ompMerchantsService.merchantsListData;
            $scope.selectedCategory = homeScreenService.storeSelected;
            $scope.categoryCode = homeScreenService.categoryCode;
            if ($scope.selectedCategory === "Top Brands") {
                $scope.isTopBrands = true;
            } else {
                $scope.isTopBrands = false;
            }
            var req = {
                "pageId": "1",
                "shopNOrder": $scope.shopNOrderPreHash
            };
            ompMerchantsService.getAllCategory(req).then(function (data) {
                ompMerchantsService.isLoggedIn = data.isLoggedIn;
                merchantListVm.dataForViewAllDropDown = data;
                var dropDownCategory = merchantListVm.dataForViewAllDropDown;
                $scope.dataForViewAllCategoryDropDown = dropDownCategory;
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
            var obj = {};
            obj = {
                "categoryCode": $scope.categoryCode
            };

            obj.shopNOrder = $scope.shopNOrderPreHash;
            ompMerchantsService.getMerchantsByCategory(obj).then(function (data) {
                ompMerchantsService.isLoggedIn = data.isLoggedIn;
                $scope.selectedCategory = data[0].merchant.label;
                merchantListVm.dataForIndividualMerchant = data[0].merchant.mobileData;
                $scope.merchantData = merchantListVm.dataForIndividualMerchant;
                if ($scope.categoryCode === "OMPS100" && (!$scope.shopNOrderPre)) {
                    merchantListVm.paclBannerShow();
                }
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        $scope.$on('$ionicView.beforeEnter', function () {
            //authUser
            merchantListVm.authFailure = false;
            merchantListVm.isUserAuthQuickPay = false;
            merchantListVm.isSimChanged = ompOffersService.isSimChangedForOmpPreLogin;
            merchantListVm.simList = ompOffersService.simListForOmpPreLogin;
            merchantListVm.simSubscriptionId = ompOffersService.simSubscriptionIdForOmpPreLogin;
            merchantListVm.hasedSimInfo = ompOffersService.hasedSimInfoForOmpPreLogin;
            //Check device is locked or not, depend on that go to User ID tab as default
            merchantListVm.keyguardValue = internetBankingService.checkKeyguardValue;
            //authUser
            merchantListVm.paclBannerFlag = false;
            $scope.shopNOrderPre = "";
            $scope.shopNOrderPreHash = "";
            loggedInUserService.shopNOrderPreHash = "";
            if (loggedInUserService.shopNOrderPre) {
                $scope.shopNOrderPre = loggedInUserService.shopNOrderPre;
                $scope.shopNOrderPreHash = $scope.shopNOrderPre ? cryptoService.getSHA512EncryptedData($scope.shopNOrderPre).toString() : '';
                loggedInUserService.shopNOrderPreHash = $scope.shopNOrderPreHash;
            }
        });

        merchantListVm.paclBannerShow = function () {
            merchantListVm.paclData = paclService.getPACLData();
            if (merchantListVm.paclData.bannerFlag) {
                merchantListVm.paclBannerFlag = merchantListVm.paclData.bannerFlag;
                if (merchantListVm.paclData.ompMessage) {
                    merchantListVm.paclData.ompMessage = merchantListVm.paclData.ompMessage.replace("Rs. FIELD_1}}.", "");
                } else {
                    merchantListVm.paclData.ompMessage = "You’re eligible for a Pre-approved Car Loan upto";
                }
            }
        }

        merchantListVm.goToPACL = function () {
            $state.go('menu.paclReqDetails');
        }

        $scope.addDataToClickStream = function () {
            if (ompMerchantsService) {
                if (ompMerchantsService.listName) {
                    clickStreamService.clickStreamData = "websiteId," + ompMerchantsService.listName.affiliateId;
                }
            }
        }

        merchantListVm.disclaimer = function (data) {
            merchantListVm.merchantsList = data
            merchantListVm.myPopup = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',
                templateUrl: "pages/OMP/merchantList/disclaimerPopup.html",
                scope: $scope
            });
        }

        merchantListVm.cancel = function () {
            clickStreamService.clickStreamData = "websiteId," + merchantListVm.merchantsList.affiliateId;
            merchantListVm.myPopup.close();
            var headerElem = document.querySelector('body');
            if (headerElem) {
                headerElem.classList.remove('popover-open');
            }
        }

        merchantListVm.agree = function () {
            clickStreamService.clickStreamData = "websiteId," + merchantListVm.merchantsList.affiliateId;
            isWebviewLoadingCanceled = false;
            merchantListVm.myPopup.close();
            merchantListVm.loadPopup = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head textAlignCenter popupBackgroundDark',
                templateUrl: "pages/OMP/merchantList/loading.html",
                scope: $scope
            })
            var mobileRedirectKey = '';
            if ($scope.shopNOrderPre) {
                mobileRedirectKey = cryptoService.getSHA512EncryptedData(merchantListVm.merchantsList.mobileRedirectUrl).toString();
            } else {
                mobileRedirectKey = cryptoService.getSHA512EncryptedData(loggedInUserService.tokenLotus + merchantListVm.merchantsList.mobileRedirectUrl).toString();
            }
            var saveLeadObj = {
                "leadId": "",
                "websiteId": merchantListVm.merchantsList.websiteId,
                "affiliateId": merchantListVm.merchantsList.affiliateId,
                "request": {
                    "ompCcustToken": "",
                    "loggedIn": "",
                    "channel": "",
                    "segId": "",
                    "ompTokenId": "",
                    "merchantSku": "",
                    "prdPrice": "",
                    "wishlistSkus": "",
                    "ompDisValue": "",
                    "ompDisPct": "",
                    "ompDisType": "",
                    "isLoggedIn": mPinLoginService.isLoggedIn
                },
                "leadParam": merchantListVm.merchantsList.leadParam,
                "segmentParam": merchantListVm.merchantsList.segmentParam,
                "affiliateIdParam": merchantListVm.merchantsList.affiliateIdParam,
                "mobileRedirectUrl": merchantListVm.merchantsList.mobileRedirectUrl,
                "mobileRedirectKey": mobileRedirectKey,
                "shopNOrder": $scope.shopNOrderPreHash,
                "psudoIdEnble": ompMerchantsService.psudoIdEnble
            }
            ompMerchantsService.saveLead(saveLeadObj).then(function (response) {
                const hRespCheck = response.data.resourceParameter;
                if (hRespCheck == undefined || hRespCheck == null || hRespCheck == "" || hRespCheck == cryptoService.getSHA512EncryptedData(response.data.mobileUrl).toString()) {
                    merchantListVm.saveLeadData = response;
                    merchantListVm.loadPopup.close();
                    if (isWebviewLoadingCanceled == true) {
                        return "";
                    }
                    isWebviewLoadingCanceled = true;
                    if (mPinLoginService.isLoggedIn || $scope.shopNOrderPre) {
                        var tempUrl = new URL(response.data.mobileUrl);
                        if (ompMerchantsService.psudoIdEnble && ompMerchantsService.redirectUrlModif) {
                            response.data.mobileUrl = response.data.mobileUrl.replaceAll("PSEUDO_CODE", ompMerchantsService.pseudoId ? ompMerchantsService.pseudoId : '');
                            var tempUrl = new URL(response.data.mobileUrl);
                            response.data.mobileUrl = tempUrl;
                            ompMerchantsService.redirectUrlModif = false;
                            ompMerchantsService.psudoIdEnble = false;
                        }
                        if (merchantListVm.merchantsList.merchantCode == "ubr") {
                            if (utilityService.isAndroidPlatform()) {
                                appAvailability.check('com.ubercab',
                                    function () {
                                        var url = response.data.mobileUrl;
                                        ompMerchantsService.inChromeBrowser(url);
                                    },
                                    function () {
                                        var url = "https://m.uber.com/sign-up?client_id=<CLIENT_ID>";
                                        ompMerchantsService.inChromeBrowser(url);
                                    });
                            } else {
                                appAvailability.check('uber://', function () {
                                    var url = response.data.mobileUrl;
                                    ompMerchantsService.inChromeBrowser(url);
                                }, function () {
                                    var url = "https://m.uber.com/sign-up?client_id=<CLIENT_ID>";
                                    ompMerchantsService.inChromeBrowser(url);
                                });
                            }
                            return true;
                        } else if (merchantListVm.merchantsList.browserType === 'inApp') {
                            ompMerchantsService.inAppBrowser(response.data.mobileUrl, $scope.merchantDetails);
                        } else if (merchantListVm.merchantsList.browserType === 'default') {
                            ompMerchantsService.inChromeBrowser(response.data.mobileUrl);
                        } else if (merchantListVm.merchantsList.browserType === 'chrome_tab') {
                            ompMerchantsService.inChromeTabBrowser(response.data.mobileUrl);
                        }
                    }
                } else {
                    merchantListVm.loadPopup.close();
                    utilityService.showErrorMessage("Invalid request");
                }
            }, function (error) {
                merchantListVm.loadPopup.close();
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
        /**Function to save lead for loan tile  starts here*/
        $scope.saveOMPLead = function (data) {
            merchantListVm.merchantsList = data;
            var mobileRedirectKey = '';
            if ($scope.shopNOrderPre) {
                mobileRedirectKey = cryptoService.getSHA512EncryptedData(merchantListVm.merchantsList.mobileRedirectUrl).toString();
            } else {
                mobileRedirectKey = cryptoService.getSHA512EncryptedData(loggedInUserService.tokenLotus + merchantListVm.merchantsList.mobileRedirectUrl).toString();
            }
            var saveLeadObj = {
                "leadId": "",
                "websiteId": merchantListVm.merchantsList.websiteId,
                "affiliateId": merchantListVm.merchantsList.affiliateId,
                "request": {
                    "ompCcustToken": "",
                    "loggedIn": "",
                    "channel": "",
                    "segId": "",
                    "ompTokenId": "",
                    "merchantSku": "",
                    "prdPrice": "",
                    "wishlistSkus": "",
                    "ompDisValue": "",
                    "ompDisPct": "",
                    "ompDisType": "",
                    "isLoggedIn": mPinLoginService.isLoggedIn
                },
                "leadParam": merchantListVm.merchantsList.leadParam,
                "segmentParam": merchantListVm.merchantsList.segmentParam,
                "affiliateIdParam": merchantListVm.merchantsList.affiliateIdParam,
                "mobileRedirectUrl": merchantListVm.merchantsList.mobileRedirectUrl,
                "mobileRedirectKey": mobileRedirectKey,
                "shopNOrder": $scope.shopNOrderPreHash
            }
            ompMerchantsService.saveLead(saveLeadObj).then(function (response) {
                merchantListVm.saveLeadData = response;
                if (isWebviewLoadingCanceled == true) {
                    return "";
                }
                isWebviewLoadingCanceled = true;
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
        /**Function to save lead for loan tile  ends here*/
        merchantListVm.tapCancel = function () {
            merchantListVm.loadPopup.close();
            $state.go('menu.ompMerchants');
        }
        return this;
    }
]);
