'use strict';

angularApp.controller('redirectionalDisclamerCtrl', [
    "$state",
    "$scope",
    "ompMerchantsService",
     "$window",
    "$ionicHistory",
    "utilityService",
    "mPinLoginService",
    "clickStreamService",
    "$ionicSideMenuDelegate",
    "$ionicPopup",
    "$ionicSlideBoxDelegate",
    "homeScreenService",
    "$ionicScrollDelegate",
    "irctcService",
    "paclService",
    "homeLoanService", "loggedInUserService", "cryptoService", "$translate", "$timeout", "$anchorScroll", "$location",

    function ($state,
        $scope,
        ompMerchantsService,
        $window,
        $ionicHistory,
        utilityService,
        mPinLoginService,
        clickStreamService,
        $ionicSideMenuDelegate,
        $ionicPopup, $ionicSlideBoxDelegate, homeScreenService, $ionicScrollDelegate, irctcService, paclService, homeLoanService, loggedInUserService, cryptoService, $translate, $timeout, $anchorScroll, $location) {
        var isWebviewLoadingCanceled = false;
        var redirectionDisclaimerVm = this;
        $scope.selectBoxOpened = true;
        $scope.showDisclaimerError=false;

        redirectionDisclaimerVm.goBack = function () {
            $ionicHistory.goBack(-1);
        };
        $scope.hamBack = function () {
            ompMerchantsService.ompSearchHistory="";
        };

        redirectionDisclaimerVm.openDiscliamer = function () {
            var elem = document.querySelector(".popup-open");
            if (elem) {
                return false;
            }
            redirectionDisclaimerVm.disclaimerPopup = $ionicPopup.show({
                templateUrl: "pages/OMP/merchantList/redirectionPopupContent.html",
                title: '<h3 class="popup-title>Disclaimer</h3><img src="img/OMP/close_btn.PNG" class="close_disclaimer_btn" alt="close_btn"/>',
                scope: $scope,
                cssClass: 'redirectionalDisclaimerPopup'
            });
        }
        redirectionDisclaimerVm.closeDisclaimer = function () {
            redirectionDisclaimerVm.disclaimerPopup.close();
        }

        redirectionDisclaimerVm.Continue = function () {
            $scope.showDisclaimerError=false;
            if(!redirectionDisclaimerVm.agreeCheckBox){
                $scope.showDisclaimerError=true;
                return false;
            }
           

            clickStreamService.clickStreamData = "websiteId," + redirectionDisclaimerVm.merchantData.affiliateId;
            isWebviewLoadingCanceled = false;
            if (redirectionDisclaimerVm.disclaimerPopup) {
                redirectionDisclaimerVm.disclaimerPopup.close();
            }

            redirectionDisclaimerVm.loadPopup = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head textAlignCenter popupBackgroundDark',
                templateUrl: "pages/OMP/merchantList/discliamerLoading.html",
                scope: $scope
            })
            var mobileRedirectKey='';
            if($scope.shopNOrderPre){
                mobileRedirectKey= cryptoService.getSHA512EncryptedData(redirectionDisclaimerVm.merchantData.mobileRedirectUrl).toString();
            }else{
                mobileRedirectKey= cryptoService.getSHA512EncryptedData(loggedInUserService.tokenLotus + redirectionDisclaimerVm.merchantData.mobileRedirectUrl).toString();
            }
            var saveLeadObj = {
                "leadId": "",
                "websiteId": redirectionDisclaimerVm.merchantData.websiteId,
                "affiliateId": redirectionDisclaimerVm.merchantData.affiliateId,
                "request": {
                    "ompCcustToken": "",
                    "loggedIn": "",
                    "channel": "",
                    "segId": "",
                    "ompTokenId": "",
                    "merchantSku": "",
                    "prdPrice": "",
                    "wishlistSkus": "",
                    "ompDisValue": "",
                    "ompDisPct": "",
                    "ompDisType": "",
                    "isLoggedIn": mPinLoginService.isLoggedIn
                },
                "leadParam": redirectionDisclaimerVm.merchantData.leadParam,
                "segmentParam": redirectionDisclaimerVm.merchantData.segmentParam,
                "affiliateIdParam": redirectionDisclaimerVm.merchantData.affiliateIdParam,
                "mobileRedirectUrl": redirectionDisclaimerVm.merchantData.mobileRedirectUrl,
                "mobileRedirectKey": mobileRedirectKey,
                "shopNOrder": $scope.shopNOrderPreHash,
                "psudoIdEnble": ompMerchantsService.psudoIdEnble
            }
            ompMerchantsService.saveLead(saveLeadObj).then(function (data) {
                const hRespCheck = data.data.resourceParameter;
                if (hRespCheck == undefined || hRespCheck == null || hRespCheck == "" || hRespCheck == cryptoService.getSHA512EncryptedData(data.data.mobileUrl).toString()){
                redirectionDisclaimerVm.saveLeadData = data;
                redirectionDisclaimerVm.loadPopup.close();
                if (isWebviewLoadingCanceled == true) {
                    return "";
                }
                isWebviewLoadingCanceled = true;
                if (mPinLoginService.isLoggedIn || $scope.shopNOrderPre) {
                    var tempUrl = new URL(data.data.mobileUrl);
                    if(ompMerchantsService.psudoIdEnble && ompMerchantsService.redirectUrlModif){
                        data.data.mobileUrl = data.data.mobileUrl.replaceAll("PSEUDO_CODE", ompMerchantsService.pseudoId ? ompMerchantsService.pseudoId : ''); 
                        var tempUrl = new URL(data.data.mobileUrl);
                        data.data.mobileUrl = tempUrl;
                        ompMerchantsService.redirectUrlModif = false;
                        ompMerchantsService.psudoIdEnble = false;
                    }
                    if (redirectionDisclaimerVm.merchantData.merchantCode == "ubr") {
                        if (utilityService.isAndroidPlatform()) {
                            appAvailability.check('com.ubercab',
                                function () {
                                    var url = data.data.mobileUrl;
                                    ompMerchantsService.inChromeBrowser(url);
                                },
                                function () {
                                    var url = "https://m.uber.com/sign-up?client_id=<CLIENT_ID>";
                                    ompMerchantsService.inChromeBrowser(url);
                                });
                        } else {
                            appAvailability.check('uber://', function () {
                                var url = data.data.mobileUrl;
                                ompMerchantsService.inChromeBrowser(url);
                            }, function () {
                                var url = "https://m.uber.com/sign-up?client_id=<CLIENT_ID>";
                                ompMerchantsService.inChromeBrowser(url);
                            });
                        }
                        return true;
                    } else if (redirectionDisclaimerVm.merchantData.browserType === 'inApp') {

                        ompMerchantsService.inAppBrowser(data.data.mobileUrl, redirectionDisclaimerVm.merchantData);
                    } else if (redirectionDisclaimerVm.merchantData.browserType === 'default') {

                        ompMerchantsService.inChromeBrowser(data.data.mobileUrl);
                    }

                    $ionicHistory.goBack(-1);
                }
                } else {
                        redirectionDisclaimerVm.loadPopup.close();
						utilityService.showErrorMessage("Invalid request");
					}
            }, function (error) {
                redirectionDisclaimerVm.loadPopup.close();
                utilityService.showErrorMessage(error.responseMessage);
            });
        };

        redirectionDisclaimerVm.tapCancel = function () {
            redirectionDisclaimerVm.loadPopup.close();
            //$state.go('menu.redirectionDiscliamer');
        };

        redirectionDisclaimerVm.slideChanged = function (index) {
            var classSlider = '.sliderOpac' + index;
            var elem = document.querySelector(classSlider);
            var nextElemnt = elem.nextElementSibling;
            elem.classList.remove('opacSlider');
            if (nextElemnt) {
                elem.nextElementSibling.classList.add('opacSlider');
            }
        }
        redirectionDisclaimerVm.next = function () {
            $ionicSlideBoxDelegate.next();
        };
        redirectionDisclaimerVm.previous = function () {
            $ionicSlideBoxDelegate.previous();
        };

        $scope.$on("$ionicSlides.sliderInitialized", function (event, data) {
            redirectionDisclaimerVm.slider = data.slider;
            //first slide loads here
            redirectionDisclaimerVm.activeIndex = data.slider.activeIndex;
            console.log(redirectionDisclaimerVm.activeIndex); //will return 0
        });

        $scope.$on("$ionicSlides.slideChangeStart", function (event, data) {
            redirectionDisclaimerVm.activeIndex = data.slider.activeIndex;
            console.log(redirectionDisclaimerVm.activeIndex); //will return the current index of your slide
        });
    
    redirectionDisclaimerVm.scrollToPage=function(){
        if(redirectionDisclaimerVm.showBrandSection){
            var removeClass= document.getElementById('showBrandSection');
            removeClass.classList.remove('ng-hide');
            redirectionDisclaimerVm.showBrandSection = false;
        }
       
    }
    $scope.checkboxChangeEvent=function(){
        if(redirectionDisclaimerVm.agreeCheckBox){
            $scope.showDisclaimerError=false;
        }
    }

    $scope.$on('$ionicView.afterEnter', function () {
        $timeout(function () {
            // $ionicScrollDelegate.$getByHandle('mainScroll').anchorScroll("#"+ $location.hash('offerDiv'))
            if (utilityService.isAndroidPlatform()) {
                var offerDivHtml = document.getElementById('offerDiv');
                offerDivHtml.scrollIntoView(true);
            }else {
                if(redirectionDisclaimerVm.merchantData.offerPoints.length > 0) {
                    redirectionDisclaimerVm.showBrandSection = true;
                }
            }
        }, 2000);
            var headerElem = document.querySelector('body');
            var topBar = document.querySelectorAll('.app-header');
            if (headerElem) {
                headerElem.classList.add('hiddenExtraButton');
            }
            if (topBar) {
                topBar[2].classList.add('discliamerContent');
            }
    });
        $scope.$on('$ionicView.beforeEnter', function () {
            /** YONO splash */
            $scope.shopNOrderPre="";
            $scope.shopNOrderPreHash="";
            if(loggedInUserService.shopNOrderPre){
                $scope.shopNOrderPre=loggedInUserService.shopNOrderPre;
                $scope.shopNOrderPreHash=$scope.shopNOrderPre ? cryptoService.getSHA512EncryptedData($scope.shopNOrderPre).toString() : '';
            }
            /** YONO splash */
            if (utilityService.isIOSPlatform()) {
                $scope.isAndroidPlatform = false;
            } else {
                $scope.isAndroidPlatform = true;
            }
            redirectionDisclaimerVm.showBrandSection = false;
            if (homeScreenService.ishamburgerMenuShop) {
                redirectionDisclaimerVm.isHamCheck = true;
                redirectionDisclaimerVm.isBackCheck = true;
            } else {
                redirectionDisclaimerVm.isHamCheck = false;
                redirectionDisclaimerVm.isBackCheck = false;
            }
             redirectionDisclaimerVm.merchantData = ompMerchantsService.listName;
             var footerHeight = document.querySelector(".disclaimerFooter").offsetHeight;
             var screenHeight= $window.innerHeight;
             var contentHeight= (screenHeight) - (footerHeight) -  (44);

             document.getElementById("redirectionContent").style.height = (contentHeight + 10)+"px";                

            redirectionDisclaimerVm.disclaimerConatent = decodeURIComponent(redirectionDisclaimerVm.merchantData.disclaimerContent).replace(new RegExp("\\+", "g"), ' ');
             $timeout(function(){
                var offerDivheight= document.getElementById('offerList').offsetHeight;
                var disclaimerFooterHght= document.getElementById('disclaimerFooter').offsetHeight;
                document.getElementById("offersContainer").style.height=offerDivheight+disclaimerFooterHght+"px";

            },500);
        });
        $scope.$on('$ionicView.beforeLeave', function () {
            var headerElem = document.querySelector('body');
            var topBar = document.querySelectorAll('.app-header');
            if (headerElem) {
                headerElem.classList.remove('hiddenExtraButton');
            }
            if (topBar) {
                topBar[2].classList.remove('discliamerContent');
            }
        });
    }
]);
