'use strict';

angularApp.controller('viewAllCategoriesController', ["$timeout",
    "$state",
    "$scope",
    "ompMerchantsService",
    "$ionicHistory",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "mPinLoginService",
    "clickStreamService",
    "$ionicSideMenuDelegate",
    "homeScreenService","cryptoService","loggedInUserService","$ionicScrollDelegate",
    function ($timeout,
        $state,
        $scope,
        ompMerchantsService,
        $ionicHistory,
        $ionicSlideBoxDelegate,
        utilityService,
        mPinLoginService,
        clickStreamService,
        $ionicSideMenuDelegate,
        homeScreenService,cryptoService,loggedInUserService,$ionicScrollDelegate) {

        var viewAllCategoriesVm = this;
        var scrollTop=0;
        $scope.getScrollPosition = function () {
           scrollTop = $ionicScrollDelegate.$getByHandle('scroller').getScrollPosition().top;
        }

        viewAllCategoriesVm.goBack = function () {
            $state.go('menu.ompMerchants');
        };
        viewAllCategoriesVm.next = function () {
            $ionicSlideBoxDelegate.next();
        };
        viewAllCategoriesVm.previous = function () {
            $ionicSlideBoxDelegate.previous();
        };
        viewAllCategoriesVm.gotoMerchantsList = function (data) {
            utilityService.clearHistoryExceptCurrentView();
            ompMerchantsService.merchantsListData = data;
           homeScreenService.ishamburgerMenuShop=false;
            homeScreenService.categoryCode=data.categoryCode;
            homeScreenService.storeSelected=data.title;
           clickStreamService.clickStreamData = "websiteId," + data.categoryCode;
           if (homeScreenService.categoryCode == 'OMPS100' && data.isAutomobileLandingPage === true) {
            if(!mPinLoginService.isLoggedIn){
                localStorage.setItem('isRedirectedTowdsLoan', "");
                localStorage.setItem('redirectOnlyFlow', ""); 
                homeScreenService.irctcCallAfterSuccLogin = false;
                homeScreenService.automallCallAfterSuccLogin = false;
                homeScreenService.automobileCallAfterSuccLogin = true;
                loggedInUserService.productClicked = 'menu.homeScreen'; // 'menu.irctcBookTicketSearch';
                $state.go('menu.userLogin');

            }else{
                $state.go('menu.automobileLanding');
            }
           } else {
                ompMerchantsService.scrollTop=scrollTop;
                $state.go('menu.merchantList');
           }
        }

      


        $scope.$on('$ionicView.enter', function (e) {
            viewAllCategoriesVm.showAll = false;
            $timeout(function () {
                ompMerchantsService.showHeader();
            }, 1000);
        });
        $scope.$on('$ionicView.beforeLeave', function () {
            var headerElem = document.querySelector('body');
            var topBar = document.querySelectorAll('.app-header');
            if (headerElem) {
                headerElem.classList.remove('hiddenExtraButton');
            }
            if (topBar) {
                topBar[2].classList.remove('discliamerContent');
            }
            ompMerchantsService.endTimer();
        });

        $scope.$on('$ionicView.afterEnter', function () {
            ompMerchantsService.startTimer();
            viewAllCategoriesVm.isHamCheck = false;
            viewAllCategoriesVm.isBackCheck = false;
            if(ompMerchantsService.scrollTop){
                scrollTop=ompMerchantsService.scrollTop;
                ompMerchantsService.scrollTop=0;
            }
            
            var headerElem = document.querySelector('body');
            var topBar = document.querySelectorAll('.app-header');
            if (headerElem) {
                headerElem.classList.add('hiddenExtraButton');
            }
            if (topBar) {
                topBar[2].classList.add('discliamerContent');
            }
        });
       
        $scope.$on('$ionicView.beforeEnter', function () {
            $scope.shopNOrderPre="";
            if(loggedInUserService.shopNOrderPre){
                $scope.shopNOrderPre=loggedInUserService.shopNOrderPre;
            }
            if (!mPinLoginService.isLoggedIn) {
                mPinLoginService.isLoggedIn = false;
            }
            var obj = {
               "pageId": "1",
               "shopNOrder": $scope.shopNOrderPre ? cryptoService.getSHA512EncryptedData($scope.shopNOrderPre).toString() : '' 
            };
            ompMerchantsService.getAllCategory(obj).then(function (data) {
                viewAllCategoriesVm.isMerchAvailable = true;
                ompMerchantsService.isLoggedIn = data.isLoggedIn;
                viewAllCategoriesVm.stores = data;
                $timeout(function () {
                    //document.getElementById("viewAllCategories").style.height=document.getElementById('viewAllCategories').offsetHeight+"px";
                    $timeout(function(){
                        if(scrollTop){
                            $ionicScrollDelegate.scrollTo(0,scrollTop);
                        }
                        
                     },500);
                },800);

            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
            $scope.addDataToClickStream();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        $scope.addDataToClickStream = function () {
            clickStreamService.clickStreamData = "";
        };
        return this;
    }
]);
