/**
*   @ngdoc config
*   @name angularApp.config : ompConfig
*   @description
*	configuration file for online market place module
*/

'use strict';
/*State defination with respective names, urls, controllers and templates */
angularApp.config(['$stateProvider',
	function ($stateProvider) {
		$stateProvider
			.state('menu.ompMerchants', {
				url: '/ompMerchants',
				data: {
					pageId: 'OMP_MRCHT'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/OMP/ompMerchants/ompMerchants.html',
						controller: 'ompMerchantsController',
						controllerAs: 'ompMerchantsVm',
					}
				}
			})
			

			.state('menu.viewAllCategories', {
				url: '/viewAllCategories',
				data: {
					pageId: 'OMP_VIEWALLCATEGORIES'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/OMP/merchantList/viewAllCategories.html',
						controller: 'viewAllCategoriesController',
						controllerAs: 'viewAllCategoriesVm',
					}
				}
			})
			.state('menu.merchantList', {
				url: '/merchantList',
				data: {
					pageId: 'OMP_MRCHTLST'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/OMP/merchantList/merchantList.html',
						controller: 'merchantListController',
						controllerAs: 'merchantListVm',
					}
				}
			})
			.state('menu.ompShop', {
				url: '/ompShop',
				data: {
					pageId: 'OMP_SHP'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/OMP/ompShop/ompShop.html',
						controller: 'ompShopController',
						controllerAs: 'ompShopVm',
					}
				}
			})
			.state('menu.ompSearch', {
				url: '/ompSearch',
				data: {
					pageId: 'OMP_SRCH'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/OMP/ompSearch/ompSearch.html',
						controller: 'ompSearchController',
						controllerAs: 'ompSearchVm',
					}
				}
			})
			.state('menu.categoryList', {
				url: '/categoryList',
				data: {
					pageId: 'OMP_CTGYLST'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/OMP/categoryList/categoryList.html',
						controller: 'categoryListController',
						controllerAs: 'categoryListVm',
					}
				}
			})
			.state('menu.shopCategories', {
				url: '/shopCategories',
				data: {
					pageId: 'OMP_SHPCTGY'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/OMP/shopCategories/shopCategories.html',
						controller: 'shopCategoriesController',
						controllerAs: 'shopCategoriesVm',
					}
				}
			})
			.state('menu.comparisonChart', {
				url: '/comparisonChart',
				data: {
					pageId: 'OMP_CMPNCHRT'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/OMP/comparisonChart/comparisonChart.html',
						controller: 'comparisonChartController',
						controllerAs: 'comparisonChartVm',
					}
				}
			})
			.state('menu.electronics', {
				url: '/electronics',
				data: {
					pageId: 'OMP_ELTRNCS'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/OMP/electronics/electronics.html',
						controller: 'electronicsController',
						controllerAs: 'electronicsVm',
					}
				}
			})
			.state('menu.searchList', {
				url: '/searchList',
				data: {
					pageId: 'OMP_SRCHLST'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/OMP/searchList/searchList.html',
						controller: 'searchListController',
						controllerAs: 'searchListVm',
					}
				}
			})
			.state('menu.filter', {
				url: '/filter',
				data: {
					pageId: 'OMP_FLTR'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/OMP/filter/filter.html',
						controller: 'filterController',
						controllerAs: 'filterControllerVm',
					}
				}
			})
			.state('menu.filterCategory', {
				url: '/filterCategory',
				data: {
					pageId: 'OMP_FLTCTGY'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/OMP/filter/filterCategory.html',
						controller: 'filterCategoryController',
						controllerAs: 'filterCategoryControllerVm',
					}
				}
			})
			.state('menu.productDescription', {
				url: '/productDescription',
				data: {
					pageId: 'OMP_PRDTDESC'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/OMP/productDescription/productDescription.html',
						controller: 'productDescriptionController',
						controllerAs: 'productDescriptionVm',
					}
				}
			})
			.state('menu.specificPayment', {
				url: '/specificPayment',
				data: {
					pageId: 'OMP_SPCFPYMT'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/OMP/specificPayment/specificPayment.html',
						controller: 'specificPaymentController',
						controllerAs: 'specificPaymentVm',
					}
				}
			})
			.state('menu.wishList', {
				url: '/wishList',
				data: {
					pageId: 'OMP_WSHLST'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/OMP/wishList/wishList.html',
						controller: 'wishListController',
						controllerAs: 'wishListVm',
					}
				}
			})
			.state('menu.localWishlist', {
				url: '/localWishlist',
				data: {
					pageId: 'OMP_LOCLWSHLST'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/OMP/localWishlist/localWishlist.html',
						controller: 'localWishlistController',
						controllerAs: 'localWishlistVm',
					}
				}
			})
			.state('menu.filterCategoryList', {
				url: '/filterCategoryList',
				data: {
					pageId: 'OMP_FLTCTGYLIST'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/OMP/filter/filterCategoryList.html',
						controller: 'filterCategoryListController',
						controllerAs: 'filterCategoryListControllerVm',
					}
				}
			})
			.state('menu.redirectionDiscliamer', {
				url: '/redirectionDis',
				data: {
					pageId: 'OMP_REDISCLAIM'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/OMP/merchantList/redirectionalDisclaimer.html',
						controller: 'redirectionalDisclamerCtrl',
						controllerAs: 'redirectionDisclaimerVm',
					}
				}
			})
			// NTB Customer Best Offer
			.state('menu.NTBBestOffer',{
				url: '/NtbBestOffer',
				data: {
					pageId: 'NTB_BEST_OFFER',
					sectionId: 'NTBBestOfferSection',
					commonId: ""
				},
				views: {
					'menuContent':{
						templateUrl: 'pages/accountOpening/ntbBestOffers/ntbBestOffers.html',
						controller: 'ntbBestOfferController',
						controllerAs: 'ntbBestOfferControllerVm',
					}
				}
			})
			// NTB Customer Best Offer - END
	}]);