'use strict';

angularApp.controller('ompMerchantsController', ["$timeout",
    "$state",
    "$scope",
    "ompMerchantsService",
    "$translate",
    "$ionicScrollDelegate",
    "$ionicSlideBoxDelegate",
    "$interval",
    "utilityService",
    "mPinLoginService",
    "searchListServices",
    "filterService",
    "$ionicPopup",
    "$ionicLoading",
    "personalLoanService",
    "clickStreamService",
    "$ionicSideMenuDelegate",
    "homeScreenService",
    "generalInsurenceHomeService",
    "cardsService",
    "irctcService", "loggedInUserService", "cryptoService", "homeLoanService", "automallService",
    "quickPayService", "$ionicPopover", "internetBankingService", "ConnectivityMonitorUtils", "constantConfig", "$rootScope", "$ionicPlatform","registerWithSimService","ompOffersService",
    function ($timeout,
        $state,
        $scope,
        ompMerchantsService,
        $translate,
        $ionicScrollDelegate,
        $ionicSlideBoxDelegate,
        $interval,
        utilityService,
        mPinLoginService,
        searchListServices,
        filterService,
        $ionicPopup,
        $ionicLoading,
        personalLoanService,
        clickStreamService,
        $ionicSideMenuDelegate,
        homeScreenService, generalInsurenceHomeService, cardsService, irctcService, loggedInUserService, cryptoService, homeLoanService, automallService, quickPayService, $ionicPopover, internetBankingService, ConnectivityMonitorUtils, constantConfig, $rootScope, $ionicPlatform, registerWithSimService, ompOffersService) {
        var isWebviewLoadingCanceled = false;
        var ompMerchantsVm = this;
        var isBannerClicked = false;
        //authUser
        ompMerchantsVm.keystoreValue = loggedInUserService.keystoreValue;
        ompMerchantsVm.authFlag = "";
        ompMerchantsVm.mpinErrorMsg = "";
        ompMerchantsVm.mpinErrorMsgFlag = false;
        ompMerchantsVm.isLoginBtnClicked = false;
        ompMerchantsService.redirectUrlModif = false;
        ompMerchantsService.pseudoId = "";
        ompMerchantsService.psudoIdEnble = false;
        ompMerchantsVm.userAuthPopoverTemplate = quickPayService.userAuthPopoverTemplateOmp("", "ompMerchantsVm");
        $scope.popover = $ionicPopover.fromTemplate(ompMerchantsVm.userAuthPopoverTemplate, {
            scope: $scope
        });

        function initPage() {
            $translate(['YQP_USERNAME', 'YQP_PASSWORD']).then(function (translations) {
                ompMerchantsVm.usernameTxt = translations['YQP_USERNAME'];
                ompMerchantsVm.passwordTxt = translations['YQP_PASSWORD'];
            });
            ompMerchantsVm.isImageAvl = false;
            ompMerchantsVm.toggle.checked = false;
            ompMerchantsVm.isFingerprintAvl = quickPayService.isFingerprintAviFlag;
            ompMerchantsVm.isMpinSet = loggedInUserService.mpinConsent;
            $scope.passLenLimitReached = false;
            if (!ompMerchantsVm.isMpinSet) {
                ompMerchantsVm.toggle.checked = true;
            }
            if (quickPayService.customerInfo != '')
                ompMerchantsVm.accountList = quickPayService.customerInfo.accounts;
            quickPayService.isFingerprintAvailable().then(function (response) {
                ompMerchantsVm.isFingerprintAvl = response.responseMessage;
            }, function (error) {
                console.log(error);
            });
            ompMerchantsVm.bio_text = "";
            if (quickPayService.isBiometricType == 'face') {
                ompMerchantsVm.bio_text = "Face ID";
            } else {
                ompMerchantsVm.bio_text = "Touch ID";
            }
            $translate(['ENABLE_FACEID', 'ENABLE_FACEID_DESC', 'YQP_AUTH_MSG'], { FIELD_1: ompMerchantsVm.bio_text }).then(function (translations) {
                ompMerchantsVm.ENABLE_FACEID = translations['ENABLE_FACEID'];
                ompMerchantsVm.ENABLE_FACEID_DESC = translations['ENABLE_FACEID_DESC'];
                ompMerchantsVm.YQP_AUTH_MSG = translations['YQP_AUTH_MSG'];
            });
            if (!ompMerchantsVm.isImageAvl) {
                var full_name = localStorage.getItem("customername");
                if (full_name != "" && full_name !== null) {
                    var name_array = full_name.split(" ");
                    var first_initial = name_array[0].charAt(0);
                    var last_initial = name_array[name_array.length - 1].charAt(0);
                    ompMerchantsVm.customerNameInitials = first_initial + last_initial;
                    ompMerchantsVm.customerFirstName = full_name;
                }
                else {
                    ompMerchantsVm.customerNameInitials = "";
                    ompMerchantsVm.customerFirstName = "";
                }
            }
        }

        $scope.openPopover = function ($event) {
            ompMerchantsVm.authFailure = false;
            $scope.popover.show($event);
            ompMerchantsVm.isFingerprintAvl = false;
            ompMerchantsVm.isFingerprintAvlDevice = false;
            quickPayService.isFingerprintAvailable().then(function (response) {
                ompMerchantsVm.isFingerprintAvlDevice = true;
                var fingerprintToken = "";
                cordova.plugins.SecureKeyStore.get(function (res) {
                    fingerprintToken = res;
                    if (fingerprintToken == null || fingerprintToken == "null" || fingerprintToken == undefined || fingerprintToken == "undefined" || fingerprintToken == "") {
                        ompMerchantsVm.isFingerprintAvl = false;
                    } else {
                        ompMerchantsVm.isFingerprintAvl = true;
                        //to auto populate fingerprint option
                        ompMerchantsVm.checkBiometric();
                    }
                }, function (error) {
                    console.log(error);
                }, loggedInUserService.deviceInfo);
            }, function (error) {
                console.log(error);
            });
        };
        $scope.closePopover = function ($event) {
            $scope.popover.hide();
        };

        $scope.$on('$destroy', function () {
            $scope.popover.hide();
            $scope.popover.remove();
        });

        $scope.clearMpin = function () {
            for (var iterate = 0; iterate <= 5; iterate++) {
                $scope.doErase();
            }
        }

        ompMerchantsVm.popoverBbackdrop = function () {
            var backDrop = document.getElementsByClassName("popover-backdrop");
            if (backDrop && backDrop[0]) {
                backDrop[0].setAttribute("style", "background-color: rgba(0, 0, 0, 0.7) !important;");
            }
        }

        ompMerchantsVm.toggle = function () {
            $scope.hideKeyboard();
            if (ompMerchantsVm.toggle.checked) {
                var userAuthModalICId = document.getElementById("userAuthModalICId");
                if (userAuthModalICId) {
                    userAuthModalICId.setAttribute("style", "bottom:0px !important;");
                }
            }
        }

        ompMerchantsVm.checkBiometric = function () {
            if (quickPayService.isFingerprintAviFlag && !ompMerchantsVm.authfailure) {
                var encryptConfig = {
                    clientId: "SBI YONO", //Android: Used for encryption. iOS: used for dialogue if no `localizedReason` is given.
                    clientSecret: loggedInUserService.deviceInfo, //Necessary for Android encrpytion of keys. Use random secret key.
                    disableBackup: true,
                };
                Fingerprint.show(encryptConfig, successCallback, errorCallback);
            }
        }

        function successCallback(result) {
                //call service to Auth
                authByBiometric();
        }

        function errorCallback(error) {
            console.log(error);
        }

        function authByBiometric() {
            if (utilityService.isAndroidPlatform() && registerWithSimService.isSimLogin && !registerWithSimService.userWithoutSimReg && (ompMerchantsVm.isSimChanged || ompMerchantsVm.simList == undefined || ompMerchantsVm.simList.length == 0)) {
                if (ompMerchantsVm.isSimChanged)
                    registerWithSimService.reloadAppSimOk(registerWithSimService.changedSimMsg);
                else if (ompMerchantsVm.simList == undefined || ompMerchantsVm.simList.length == 0)
                    utilityService.showBhimUpiAlert("alert", registerWithSimService.noSimMsg);
                return;
            }
            var hasedSimInfo = "";
            if(utilityService.isAndroidPlatform()){
                hasedSimInfo = ompMerchantsVm.hasedSimInfo ? ompMerchantsVm.hasedSimInfo : "";
            }
            var params = { 'type': 'biometric', 'source': 'omp', "simId": hasedSimInfo.toString() };
            //call service to retrieve token at adapter
            quickPayService.userAuthentication(params).then(function (data) {
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "OMP_MERC_AUTHBYBIOSUCCESS"));
                afterUserAuthSuccess(data);
            }, function (error) {
                ompMerchantsVm.authFailure = true;
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "OMP_MERC_AUTHBYBIOFAIL"));
                if (error.responseCode == constantConfig.FORCE_PWD_ERROR_CODES.FP01) {
                    ompMerchantsVm.authFailure = false;
                    utilityService.showForcePasswordPopup(error.responseMessage, "");
                } else {
                    quickPayService.showAuthFailurePopup('error', error.responseMessage, '', '', 'OK', '', $scope, true, function () { ompMerchantsVm.authFailure = false; });
                }
            });
        }

        ompMerchantsVm.loginWithMpin = function () {
            if (utilityService.isAndroidPlatform() && registerWithSimService.isSimLogin && !registerWithSimService.userWithoutSimReg && (ompMerchantsVm.isSimChanged || ompMerchantsVm.simList == undefined || ompMerchantsVm.simList.length == 0)) {
                if (ompMerchantsVm.isSimChanged)
                    registerWithSimService.reloadAppSimOk(registerWithSimService.changedSimMsg);
                else if (ompMerchantsVm.simList == undefined || ompMerchantsVm.simList.length == 0)
                    utilityService.showBhimUpiAlert("alert", registerWithSimService.noSimMsg);
                return;
            }
            var newMpin = ompMerchantsVm.first.trim() +
                ompMerchantsVm.second.trim() +
                ompMerchantsVm.third.trim() +
                ompMerchantsVm.fourth.trim() +
                ompMerchantsVm.fifth.trim() +
                ompMerchantsVm.sixth.trim();
            if (newMpin.length == 6) {
                if (ConnectivityMonitorUtils.isOffline()) {
                    ompMerchantsVm.emptyValues();
                    $scope.clearMpin();
                    /*login flow improvement*/
                    var inputElement = document.getElementById('InputTxt1');
                    inputElement.disabled = false;
                    utilityService.offlineAlert();
                    return;
                }
                var hasedSimInfo = "";
				if(utilityService.isAndroidPlatform()){
					hasedSimInfo = ompMerchantsVm.hasedSimInfo ? ompMerchantsVm.hasedSimInfo : "";
				}
                var requestParams = {
                    "mPinNumber": newMpin,
                    "type": "mpin",
                    "source": "omp",
                    "simId": hasedSimInfo.toString(),
                    "simSubId" : ompMerchantsVm.simSubscriptionId
                };
                quickPayService.userAuthentication(requestParams).then(function (data) {
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "OMP_MERC_AUTHBYMPINSUCCESS"));
                    $scope.hideKeyboard();
                    afterUserAuthSuccess(data);
                    ompMerchantsVm.emptyValues();
                    $scope.passLenLimitReached = false;
                    $scope.clearMpin();
                }, function (error) {
                    $scope.passLenLimitReached = false;
                    ompMerchantsVm.emptyValues();
                    $scope.clearMpin();
                    ompMerchantsVm.enabledThisInput(1);
                    ompMerchantsVm.authFailure = true;
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "OMP_MERC_AUTHBYMPINFAIL"));
                    if (error.responseCode == constantConfig.FORCE_PWD_ERROR_CODES.FP01) {
                        ompMerchantsVm.authFailure = false;
                        utilityService.showForcePasswordPopup(error.responseMessage, "");
                    } else {
                        quickPayService.showAuthFailurePopup('error', error.responseMessage, '', '', 'OK', '', $scope, true, function () { ompMerchantsVm.authFailure = false; });
                    }
                });
            } else {
                ompMerchantsVm.emptyValues();
                $scope.clearMpin();
                ompMerchantsVm.enabledThisInput(1);
                ompMerchantsVm.authFailure = true;
                quickPayService.showAuthFailurePopup('error', 'Please Enter 6 digit valid MPIN', '', '', 'OK', '', $scope, true, function () { ompMerchantsVm.authFailure = false; });
            }
        };

        ompMerchantsVm.changeInput = function ($event, index) {
            cordova.plugins.Keyboard.close();
            /*login flow improvements*/
            if (loggedInUserService.isServerConnected) {
                ompMerchantsVm.loginWithMpin();
            }
        }

        ompMerchantsVm.enabledThisInput = function (index) {
            try {
                ompMerchantsVm.mpinErrorMsgFlag = false;
                for (var i = 1; i <= 6; i++) {
                    var inputElement = document.getElementById('InputTxt' + i);
                    if (index == i) {
                        inputElement.disabled = false;
                        inputElement.style = "border-bottom:1px solid #0095da !important;"
                    } else {
                        inputElement.disabled = true;
                        inputElement.style = "border-bottom:1px solid #bcbebf !important;"
                    }
                }
            } catch (err) { console.log(err); }
        }

        ompMerchantsVm.authenticate = function () {
            ompMerchantsVm.userLoginErrorFlag = false;
            ompMerchantsVm.isLoginBtnClicked = true;
            if (ompMerchantsVm.userName && ompMerchantsVm.pswd) {
                ompMerchantsVm.isLoginBtnClicked = false;
                utilityService.showSpinner();
                internetBankingService.getServiceIdAndKey().then(function (data) {
                    loggedInUserService.keyIdINB = data.keyId;
                    loggedInUserService.serviceIdINB = data.serviceId;
                    loggedInUserService.finalSHA512Val = loggedInUserService.generateINBSHA512Val(ompMerchantsVm.userName, ompMerchantsVm.pswd);
                    utilityService.hideSpinner();
                    ompMerchantsVm.userloginStart();
                }, function (error) {
                    ompMerchantsVm.userName = '';
                    ompMerchantsVm.pswd = '';
                    utilityService.hideSpinner();
                    ompMerchantsVm.authFailure = true;
                    if (error.responseMessage) {
                        quickPayService.showAuthFailurePopup('error', error.responseMessage, '', '', 'OK', '', $scope, true, function () { ompMerchantsVm.authFailure = false; });
                    } else {
                        quickPayService.showAuthFailurePopup('error', constantConfig.adapter.CANNOT_PROCESS_NOW, '', '', 'OK', '', $scope, true, function () { ompMerchantsVm.authFailure = false; });
                    }
                });
            }
        }

        ompMerchantsVm.userloginStart = function () {
            var hasedSimInfo = "";
            if (utilityService.isAndroidPlatform()) {
                hasedSimInfo = ompMerchantsVm.hasedSimInfo ? ompMerchantsVm.hasedSimInfo : "";
            }
            var requestParams = {
                "userName": ompMerchantsVm.userName,
                "sha512Password": loggedInUserService.finalSHA512Val,
                "type": "username",
                "source": "omp",
                "simId": hasedSimInfo.toString()
            };
            quickPayService.userAuthentication(requestParams).then(function (data) {
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "OMP_MERC_AUTHBYUSERNAMESUCCESS"));
                $scope.hideKeyboard();
                ompMerchantsVm.userName = "";
                ompMerchantsVm.pswd = "";
                afterUserAuthSuccess(data);
            }, function (error) {
                ompMerchantsVm.authFailure = true;
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "OMP_MERC_AUTHBYUSERNAMEFAIL"));
                if (error.responseCode == constantConfig.FORCE_PWD_ERROR_CODES.FP01) {
                    ompMerchantsVm.authFailure = false;
                    utilityService.showForcePasswordPopup(error.responseMessage, "");
                } else {
                    quickPayService.showAuthFailurePopup('error', error.responseMessage, '', '', 'OK', '', $scope, true, function () { ompMerchantsVm.authFailure = false; });
                }
            });
        }

        function afterUserAuthSuccess(data) {
            if (data) {
                quickPayService.customerInfo = data;
                quickPayService.yqpBiometricLimit = quickPayService.customerInfo.yqpBiometricLimit;
                quickPayService.yqpVpaLimit = quickPayService.customerInfo.yqpVpaLimit;
                quickPayService.yqpBeneficiaryLimit = quickPayService.customerInfo.yqpBeneficiaryLimit;
                quickPayService.yqpRaiseRequestLimit = quickPayService.customerInfo.yqpRaiseRequestLimit;
                localStorage.setItem('customerImageId', quickPayService.customerInfo.customerInformation.imageUrl);
                ompMerchantsService.redirectUrlModif = true;
                ompMerchantsService.pseudoId = data.lotusId;
            }
            // store pseudo id in cache and append in mobile URI.
            quickPayService.viewbalAvl = false;
            if (($scope.merchantDetails.coupons || $scope.merchantDetails.offerPoints) && ($scope.merchantDetails.coupons.length > 0 || $scope.merchantDetails.offerPoints.length > 0)) {
                $state.go('menu.redirectionDiscliamer');
            } else {
                $scope.closePopover();
                ompMerchantsVm.dynamicDisclaimer = decodeURIComponent($scope.merchantDetails.disclaimerContent).replace(new RegExp("\\+", "g"), ' ');
                ompMerchantsVm.disclaimer($scope.merchantDetails);
            }
        }

        /*Custom Keypad for MPIN*/
        $scope.pswd = '';
        $scope.canErase = false;
        $scope.pinDotVisible = {};
        $scope.success = null;
        $scope.keyboardVisible = false;
        $scope.pinArray = [];
        $scope.keyboardSettings = {
            // settings here
            action: function (number) {
                var pass;
                if ($scope.pswd.length < 6) {
                    $scope.pswd += number;
                    $scope.pinArray.push(number);
                    $scope.pinDotVisible[$scope.pswd.length] = true;
                    $scope.canErase = true;
                    $scope.success = null;
                    pass = $scope.pswd;
                    pass = pass.split("");
                    try {
                        ompMerchantsVm.first = pass[0];
                        ompMerchantsVm.second = pass[1];
                        ompMerchantsVm.third = pass[2];
                        ompMerchantsVm.fourth = pass[3];
                        ompMerchantsVm.fifth = pass[4];
                        ompMerchantsVm.sixth = pass[5];
                    } catch (err) { console.log(err); }
                }
                if ($scope.pswd && $scope.pswd.length === 6 && !$scope.passLenLimitReached) {
                    $scope.passLenLimitReached = true;
                    var e = {};
                    $scope.newMpin = $scope.pswd;
                    pass = $scope.pswd;
                    pass = pass.split("");
                    try {
                        ompMerchantsVm.first = pass[0];
                        ompMerchantsVm.second = pass[1];
                        ompMerchantsVm.third = pass[2];
                        ompMerchantsVm.fourth = pass[3];
                        ompMerchantsVm.fifth = pass[4];
                        ompMerchantsVm.sixth = pass[5];
                        e = {};
                        e.srcElement = {};
                        e.srcElement.value = 2;
                        ompMerchantsVm.changeInput(e, 6);
                    } catch (err) { console.log(err); }
                }
            },
            // Clear
            leftButton: {
                html: '<i class="icon ion-backspace"></i>',
                action: function () {
                    $scope.doErase();
                },
                style: {
                    bgColor: '#fff',
                    activeBgColor: '#dfdfdf',
                    borderColor: '#dfdfdf',
                    fontSize: '20px'
                }
            },
            // Submit login
            rightButton: {
                html: '<i class="icon ion-eye"></i> <i class="icon ion-eye-disabled login-eye-btn" ></i>',
                action: function () {
                    var elementHide;
                    var elementShow;
                    if ($scope.isPassVisible) {
                        elementHide = document.getElementsByClassName("ion-eye-disabled")[0];
                        elementHide.classList.add("login-eye-btn");
                        elementShow = document.getElementsByClassName("ion-eye")[0];
                        elementShow.classList.remove("login-eye-btn");
                        $scope.isPassVisible = false;
                    } else {
                        $scope.isPassVisible = true;
                        elementHide = document.getElementsByClassName("ion-eye")[0];
                        elementHide.classList.add("login-eye-btn");
                        elementShow = document.getElementsByClassName("ion-eye-disabled")[0];
                        elementShow.classList.remove("login-eye-btn");
                    }
                },
                style: {
                    bgColor: '#fff',
                    activeBgColor: '#dfdfdf',
                    borderColor: '#dfdfdf',
                    fontSize: '30px'
                }
            }
        }

        $scope.doErase = function () {
            $scope.pinDotVisible[$scope.pswd.length] = false;
            $scope.pswd = $scope.pswd.slice(0, -1);
            if ($scope.pswd.length == 0) $scope.canErase = false;
            try {
                var pass = $scope.pswd;
                pass = pass.split("");
                ompMerchantsVm.first = pass[0] ? pass[0] : "";
                ompMerchantsVm.second = pass[1] ? pass[1] : "";
                ompMerchantsVm.third = pass[2] ? pass[2] : "";
                ompMerchantsVm.fourth = pass[3] ? pass[3] : "";
                ompMerchantsVm.fifth = pass[4] ? pass[4] : "";
                ompMerchantsVm.sixth = pass[5] ? pass[5] : "";
            } catch (err) { console.log(err); }
        }

        $scope.rightAction = function () {
            pinDotVisible[0] = false;
            pinDotVisible[1] = false;
            pinDotVisible[2] = false;
            pinDotVisible[3] = false;
            pinDotVisible[4] = false;
            pinDotVisible[5] = false;
        }

        $scope.showKeyboard = function () {
            $scope.keyboardVisible = true;
        }

        $rootScope.hidekeypad = function ($event) {
            switch ($event.target.className) {
                case "mpin1 activated":
                // code block
                case "digit-keyboard-key":
                // code block
                case "digit-keyboard-key-action ng-binding":
                // code block
                case "icon ion-record":
                // code block
                case "digit-keyboard-key activated":
                // code block
                case "icon ion-backspace":
                // code block
                case "mpin1 ng-pristine ng-untouched ng-valid ng-empty activated":
                // code block
                case "mpin1 ng-binding":
                // code block
                case "icon ion-eye-disabled login-eye-btn":
                // code block
                case "icon ion-eye login-eye-btn":
                // code block
                case "digit-keyboard-key-number":
                    // code block
                    if (!$scope.keyboardVisible) {
                        $scope.showKeyboard();
                    }
                    break;
                default:
                    // code block
                    if ($scope.keyboardVisible) {
                        $scope.hideKeyboard();
                    }
                    break;
            }
        }

        $scope.hideKeyboard = function () {
            $scope.keyboardVisible = false;
        }
        /*End of Custom Keypad for MPIN*/
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
            navigator.splashscreen.hide();
        });

        ompMerchantsVm.emptyValues = function () {
            ompMerchantsVm.first = '';
            ompMerchantsVm.second = '';
            ompMerchantsVm.third = '';
            ompMerchantsVm.fourth = '';
            ompMerchantsVm.fifth = '';
            ompMerchantsVm.sixth = '';
        }
        //authUser end
        /** Init function to initialize search placeholder starts**/
        $scope.$on('$ionicView.beforeEnter', function () {
            //authUser
            ompMerchantsVm.simSubscriptionId = ompOffersService.simSubscriptionIdForOmpPreLogin;
            ompMerchantsVm.hasedSimInfo = ompOffersService.hasedSimInfoForOmpPreLogin;
            ompMerchantsVm.authFailure = false;
            ompMerchantsVm.isUserAuthQuickPay = false;
            ompMerchantsVm.isSimChanged = ompOffersService.isSimChangedForOmpPreLogin;
            ompMerchantsVm.simList = ompOffersService.simListForOmpPreLogin;
            //Check device is locked or not, depend on that go to User ID tab as default
            ompMerchantsVm.keyguardValue = internetBankingService.checkKeyguardValue;
            //authUser end
            ompMerchantsVm.searchLenError = false;
            $scope.slideIndex = 0;
            ompMerchantsVm.searchMerProCateText = "";
            $scope.searchTrue = false;
            $scope.onFocusFlag = false;
            $scope.hideAutocompleteDiv = true;
            $scope.hideRecentSearchDiv = true;
            $scope.currentPageId = 1;
            $scope.searchLength = "70"; /**Default character length -Shiv */
            $scope.noOfMerchants = "0";
            $scope.noOfSuggetions = "0";
            ompMerchantsVm.filteredList = [];
            $scope.androidPlatform = true;
            /** YONO splash */
            $scope.shopNOrderPre = "";
            $scope.shopNOrderPreHash = "";
            loggedInUserService.shopNOrderPreHash = "";
            if (loggedInUserService.shopNOrderPre) {
                $scope.shopNOrderPre = loggedInUserService.shopNOrderPre;
                $scope.shopNOrderPreHash = $scope.shopNOrderPre ? cryptoService.getSHA512EncryptedData($scope.shopNOrderPre).toString() : '';
                loggedInUserService.shopNOrderPreHash = $scope.shopNOrderPreHash;
            }
            //Condition for Yono cashback card banner pre and post login
            /*if($scope.shopNOrderPre!="1"){                
                applyNowService.getOmpToCardsWcmBanner().then(function(data) {
                  // ompMerchantsVm.bannerImg1 = data.data.imgUrl;
                  ompMerchantsVm.bannerImg1 = '<img src="https://sit.intouch.onlinesbi.com/wps/wcm/connect/04775217-6e71-4dc3-940c-4154d1e889de/Banner+12.png?MOD=AJPERES&amp;CACHEID=ROOTWORKSPACE-04775217-6e71-4dc3-940c-4154d1e889de-nzFqHoO" alt="" width="611" height="200">';
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });    
            }*/
            if (utilityService.isAndroidPlatform()) {
                $scope.androidPlatform = true;
            } else {
                $scope.androidPlatform = false;
            }
            /** YONO splash */
            /** YONO splash */
            $translate(['BEST_OF_YONO', 'OMP_SERACH_PLACEHOLDER', 'OMP_PATH_ERROR', 'HOME_LOAN_AFFLIATEID', 'CAR_LOAN_AFFLIATEID', 'IRCTC_AFFLIATEID', 'NEW_ON_YONO']).then(function (translations) {
                $scope.popularOfferTitle = translations['BEST_OF_YONO'];
                ompMerchantsVm.searchPlace = translations['OMP_SERACH_PLACEHOLDER'];
                ompMerchantsVm.pathError = translations['OMP_PATH_ERROR'];
                $scope.homeLoanAffliateId = translations['HOME_LOAN_AFFLIATEID'];
                $scope.carLoanAffliateId = translations['CAR_LOAN_AFFLIATEID'];
                $scope.irctcAffliateId = translations['IRCTC_AFFLIATEID'];
                $scope.newOnYONOTitle = translations['NEW_ON_YONO'];
            });
            ompMerchantsVm.getAllMerchantKeyword();
        });
        /** Init function to initialize search placeholder ends**/

        $scope.scrollEvent = function (id) {
            var handler = id;
            $timeout(function () {
                var sv = $ionicScrollDelegate.$getByHandle(handler).getScrollView();
                var container = sv.__container;
                var originaltouchStart = sv.touchStart;
                var originaltouchMove = sv.touchMove;
                container.removeEventListener('touchstart', sv.touchStart);
                document.removeEventListener('touchmove', sv.touchMove);
                sv.touchStart = function (e) {
                    e.preventDefault = function () { }
                    originaltouchStart.apply(sv, [
                        e
                    ]);
                }
                sv.touchMove = function (e) {
                    e.preventDefault = function () { }
                    originaltouchMove.apply(sv, [
                        e
                    ]);
                }
                container.addEventListener("touchstart", sv.touchStart, false);
                document.addEventListener("touchmove", sv.touchMove, false);
            });
        }


        //Function call for apply button of yono cashback card(commenting code till business confirmation)
        /*function allowApplication() {
            applyNowService.resetApplyForm();
            newCardService.setParams({ "applyCardType": "PRSE" });
            newCardService.setParams({ "applyCardName": "YONO SimplyEARN SBI Card" });
            newCardService.setParams({ "applyPictureURL": "https://www.sbicard.com/sbi-card-en/assets/media/images/personal/credit-cards/rewards/simply-earn-yono-card/simplyearn-card-face.png" });
            newCardService.setParams({ "applyCardCategory": "reward"});

            applyNowService.getCities().then(function(response) {
                cardsService.errorLogger(response);
                cardsService.setParams({ "city": response.data.cities });
                cardsService.setParams({ 'pendingApplication': false });
                
                $state.go('menu.cardPersonalDetails1');
                //}
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        //Function on click of apply now button of cashback card
        ompMerchantsVm.buyoffer = function(){
                 //Logic for Yono cashback card apply button
            utilityService.showSpinner();
            linkCardService.getPendingApplicationStatus({})
            .then(function(response) {
                    cardsService.errorLogger(response);
                    if (response.data) {            
                            if (response.data.allow == "false"){
                                utilityService.hideSpinner();
                                utilityService.enableShowErrorMessage(); 
                                utilityService.showErrorMessage(response.data.allowMessage);   
                                return false;       
                            }
                            else{   
                                allowApplication();
                            }   
                    }
                },
                function(error) {
                    allowApplication();
                });
            }
            //Function on click of know more button of cashback card
            ompMerchantsVm.knowMoreOffer = function(){
                homeScreenService.yccKnowMoreFlag = true;
                cardsService.setParams({ "cardName": "YONO SimplyEARN SBI Card" });
                $state.go('menu.cardPlatinum');
            }
*/
        ompMerchantsVm.goToAllCategories = function () {
            homeScreenService.ishamburgerShop = true;
            homeScreenService.isBackCheck = false;
            homeScreenService.menuOption = "allCategories";
            utilityService.clearHistoryExceptCurrentView();
            clickStreamService.clickStreamData = "websiteId," + "";
            $state.go('menu.viewAllCategories');
        }

        ompMerchantsVm.gotoMerchantsList = function (data) {
            homeScreenService.isBackCheck = false;
            homeScreenService.categoryCode = data.categoryCode;
            homeScreenService.storeSelected = data.title;
            utilityService.clearHistoryExceptCurrentView();
            ompMerchantsService.merchantsListData = data;
            homeScreenService.ishamburgerMenuShop = false;
            clickStreamService.clickStreamData = "websiteId," + data.categoryCode;
            if (homeScreenService.categoryCode == 'OMPS100' && data.isAutomobileLandingPage === true) {
                if (!mPinLoginService.isLoggedIn) {
                    localStorage.setItem('isRedirectedTowdsLoan', "");
                    localStorage.setItem('redirectOnlyFlow', "");
                    homeScreenService.irctcCallAfterSuccLogin = false;
                    homeScreenService.automallCallAfterSuccLogin = false;
                    homeScreenService.automobileCallAfterSuccLogin = true;
                    loggedInUserService.productClicked = 'menu.homeScreen'; // 'menu.irctcBookTicketSearch';
                    $state.go('menu.userLogin');

                } else {
                    $state.go('menu.automobileLanding');
                }
            } else {
                $state.go('menu.merchantList');
            }
        }

        $scope.registerSkip = function () {
            ompMerchantsVm.loginPop.close();
        }

        $scope.regPopup = function () {
            ompMerchantsVm.loginPop.close();
            $state.go('menu.openNewDigitalAccount');
        }

        ompMerchantsVm.shop = function (merchant, $event, searchFlag) {
            $scope.merchantDetails = merchant;
            $scope.merchantDetails.pageId = $state.current.data.pageId;
            isWebviewLoadingCanceled = false;
            ompMerchantsService.listName = merchant;
            ompMerchantsService.listName.pageId = $state.current.data.pageId;
            ompMerchantsService.merchantWishlistCount = merchant.merchantWishlistCount;
            if (ompMerchantsService.merchantWishlistCount > 0) {
                ompMerchantsService.isMerchantsWishListAvl = "S"
            } else {
                ompMerchantsService.isMerchantsWishListAvl = "N"
            }
            if (merchant.merchantType === 'Custom') {
                $scope.saveOMPLead(merchant);
                if (merchant.affiliateId === $scope.homeLoanAffliateId) {
                    try {
                        homeScreenService.isOMPMenu = true;
                        homeLoanService.hambergerSelectedLoanType = 'home';
                        $state.go('menu.loans');
                    } catch (error) {
                        homeScreenService.isOMPMenu = false;
                        utilityService.showErrorMessage(ompMerchantsVm.pathError);
                    }
                } else if (merchant.affiliateId === $scope.carLoanAffliateId) {
                    try {
                        homeScreenService.isOMPMenu = true;
                        homeLoanService.hambergerSelectedLoanType = 'car';
                        $state.go('menu.loans');
                    } catch (error) {
                        homeScreenService.isOMPMenu = false;
                        utilityService.showErrorMessage(merchantListVm.pathError);
                    }
                } else if (merchant.affiliateId === $scope.irctcAffliateId) { //IRCTC
                    if (!mPinLoginService.isLoggedIn) {
                        localStorage.setItem('isRedirectedTowdsLoan', "");
                        localStorage.setItem('redirectOnlyFlow', "");
                        homeScreenService.irctcCallAfterSuccLogin = true;
                        homeScreenService.automallCallAfterSuccLogin = false;
                        homeScreenService.automobileCallAfterSuccLogin = false;
                        loggedInUserService.productClicked = 'menu.homeScreen'; // 'menu.irctcBookTicketSearch';
                        $state.go('menu.userLogin');

                    } else {
                        irctcService.searchTrainObj = "";
                        irctcService.myList = "";
                        irctcService.masterData = "";
                        irctcService.selectedTrainData = "";
                        irctcService.myListFullData = "";
                        irctcService.infantArray = [];
                        irctcService.passArray = [];
                        $state.go('menu.irctcBookTicketSearch');
                    }
                }
            } else if (merchant.merchantType === 'Automall') {
                if (!mPinLoginService.isLoggedIn) {
                    localStorage.setItem('isRedirectedTowdsLoan', "");
                    localStorage.setItem('redirectOnlyFlow', "");
                    homeScreenService.irctcCallAfterSuccLogin = false;
                    homeScreenService.automallCallAfterSuccLogin = true;
                    homeScreenService.automobileCallAfterSuccLogin = false;
                    loggedInUserService.productClicked = 'menu.homeScreen'; // 'menu.irctcBookTicketSearch';
                    $state.go('menu.userLogin');

                } else {
                    automallService.getEmiMasterService().then(function (emiMaster) {
                        automallService.setMasterEmiData(emiMaster);
                        automallService.getAutomallBanners().then(function (banner) {
                            automallService.setLandingBanners(banner);
                            automallService.getOEMListService().then(function (oemList) {
                                automallService.setOemList(oemList);
                                $state.go('menu.automall');
                            }, function (error) {
                                utilityService.showErrorMessage(error.responseMessage);
                            })
                        }, function (error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }
            } else {
                //check for merchant pseudo flag value
                if (merchant.psudoIdEnble && !mPinLoginService.isLoggedIn) {
                    ompMerchantsService.psudoIdEnble = true;
                    ompMerchantsService.redirectUrlModif = true;
                    ompMerchantsVm.clickOn = 'omp';
                    ompMerchantsVm.emptyValues();
                    $scope.clearMpin();
                    $scope.openPopover($event);
                    //dynamically adding background colour
                    ompMerchantsVm.popoverBbackdrop();
                } else {
                    ompMerchantsService.psudoIdEnble = merchant.psudoIdEnble;
                    ompMerchantsService.redirectUrlModif = false;
                    if ((merchant.coupons || merchant.offerPoints) && (merchant.coupons.length > 0 || merchant.offerPoints.length > 0)) {
                        $state.go('menu.redirectionDiscliamer');
                    } else {
                        ompMerchantsVm.dynamicDisclaimer = decodeURIComponent(merchant.disclaimerContent).replace(new RegExp("\\+", "g"), ' ');
                        ompMerchantsVm.disclaimer(merchant);
                    }
                }
            }
            if (searchFlag) {
                var merKeyword = ompMerchantsVm.searchMerProCateText ? ompMerchantsVm.searchMerProCateText : '0';
                var affiliateId = merchant.affiliateId ? merchant.affiliateId : '0';
                clickStreamService.clickStreamData = affiliateId + "^" + merKeyword + "^" + $scope.noOfMerchants + "^" + $scope.noOfSuggetions;
            } else if (merchant.affiliateId) {
                clickStreamService.clickStreamData = "websiteId," + merchant.affiliateId;
            }
        }

        ompMerchantsVm.disclaimer = function (data) {
            ompMerchantsVm.merchantsList = data
            ompMerchantsVm.myPopup = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',
                templateUrl: "pages/OMP/ompMerchants/disclaimerPopup.html",
                scope: $scope
            });
        }

        ompMerchantsVm.cancel = function () {
            isBannerClicked = false;
            clickStreamService.clickStreamData = "websiteId," + ompMerchantsVm.merchantsList.affiliateId;
            ompMerchantsVm.myPopup.close();
            var headerElem = document.querySelector('body');
            if (headerElem) {
                headerElem.classList.remove('popover-open');
            }
        }

        ompMerchantsVm.agree = function () {
            ompMerchantsVm.resetSearchbox();
            ompMerchantsVm.myPopup.close();
            if (isBannerClicked) {
                isBannerClicked = false;
                ompMerchantsVm.gotoSelBanner(ompMerchantsVm.merchantsList);
                return true;
            }
            if (ompMerchantsVm.merchantsList.merchantType === 'Redirection') {
                clickStreamService.clickStreamData = "websiteId," + ompMerchantsVm.merchantsList.affiliateId;
                ompMerchantsVm.loadPopup = $ionicPopup.show({
                    title: '',
                    cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head textAlignCenter popupBackgroundDark',
                    templateUrl: "pages/OMP/ompMerchants/loading.html",
                    scope: $scope
                })
                var mobileRedirectKey = '';
                if ($scope.shopNOrderPre) {
                    mobileRedirectKey = cryptoService.getSHA512EncryptedData(ompMerchantsVm.merchantsList.mobileRedirectUrl).toString();
                } else {
                    mobileRedirectKey = cryptoService.getSHA512EncryptedData(loggedInUserService.tokenLotus + ompMerchantsVm.merchantsList.mobileRedirectUrl).toString();
                }
                var saveLeadObj = {
                    "leadId": "",
                    "websiteId": ompMerchantsVm.merchantsList.websiteId,
                    "affiliateId": ompMerchantsVm.merchantsList.affiliateId,
                    "request": {
                        "ompCcustToken": "",
                        "loggedIn": "",
                        "channel": "",
                        "segId": "",
                        "ompTokenId": "",
                        "merchantSku": "",
                        "prdPrice": "",
                        "wishlistSkus": "",
                        "ompDisValue": "",
                        "ompDisPct": "",
                        "ompDisType": "",
                        "isLoggedIn": mPinLoginService.isLoggedIn
                    },
                    "leadParam": ompMerchantsVm.merchantsList.leadParam,
                    "segmentParam": ompMerchantsVm.merchantsList.segmentParam,
                    "affiliateIdParam": ompMerchantsVm.merchantsList.affiliateIdParam,
                    "mobileRedirectUrl": ompMerchantsVm.merchantsList.mobileRedirectUrl,
                    "mobileRedirectKey": mobileRedirectKey,
                    "shopNOrder": $scope.shopNOrderPreHash,
                    "psudoIdEnble": ompMerchantsService.psudoIdEnble
                }
                ompMerchantsService.saveLead(saveLeadObj).then(function (response) {
                    const hRespCheck = response.data.resourceParameter;
                    if (hRespCheck == undefined || hRespCheck == null || hRespCheck == "" || hRespCheck == cryptoService.getSHA512EncryptedData(response.data.mobileUrl).toString()) {
                        ompMerchantsVm.saveLeadData = response;
                        ompMerchantsVm.loadPopup.close();
                        if (isWebviewLoadingCanceled == true) {
                            return "";
                        }
                        isWebviewLoadingCanceled = true;
                        if (mPinLoginService.isLoggedIn || $scope.shopNOrderPre) {
                            var tempUrl = new URL(response.data.mobileUrl);
                            if (ompMerchantsService.psudoIdEnble && ompMerchantsService.redirectUrlModif) {
                                response.data.mobileUrl = response.data.mobileUrl.replaceAll("PSEUDO_CODE", ompMerchantsService.pseudoId ? ompMerchantsService.pseudoId : '');
                                var tempUrl = new URL(response.data.mobileUrl);
                                response.data.mobileUrl = tempUrl;
                                ompMerchantsService.redirectUrlModif = false;
                                ompMerchantsService.psudoIdEnble = false;
                            }
                            if (ompMerchantsVm.merchantsList.merchantCode == "ubr") {
                                if (utilityService.isAndroidPlatform()) {
                                    appAvailability.check('com.ubercab',
                                        function () {
                                            var url = response.data.mobileUrl;
                                            ompMerchantsService.inChromeBrowser(url);
                                        },
                                        function () {
                                            var url = "https://m.uber.com/sign-up?client_id=<CLIENT_ID>";
                                            ompMerchantsService.inChromeBrowser(url);
                                        });
                                } else {
                                    appAvailability.check('uber://', function () {
                                        var url = response.data.mobileUrl;
                                        ompMerchantsService.inChromeBrowser(url);
                                    }, function () {
                                        var url = "https://m.uber.com/sign-up?client_id=<CLIENT_ID>";
                                        ompMerchantsService.inChromeBrowser(url);
                                    });
                                }
                                return true;
                            }
                            else if (ompMerchantsVm.merchantsList.browserType === 'inApp') {
                                ompMerchantsService.inAppBrowser(response.data.mobileUrl, $scope.merchantDetails);
                            } else if (ompMerchantsVm.merchantsList.browserType === 'default') {
                                ompMerchantsService.inChromeBrowser(response.data.mobileUrl);
                            } else if (ompMerchantsVm.merchantsList.browserType === 'chrome_tab') {
                                ompMerchantsService.inChromeTabBrowser(response.data.mobileUrl);
                            }
                        }
                    } else {
                        ompMerchantsVm.loadPopup.close();
                        utilityService.showErrorMessage("Invalid request");
                    }

                }, function (error) {
                    ompMerchantsVm.loadPopup.close();
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } /*else if(ompMerchantsVm.merchantsList.merchantType === 'Custom') {

                if(ompMerchantsVm.merchantsList.affiliateId=="SBOMPI04"){ //IRCTC

                    irctcService.searchTrainObj = "";
                    irctcService.myList = "";
                    irctcService.masterData = "";
                    irctcService.selectedTrainData = "";
                    irctcService.myListFullData = "";
                    irctcService.infantArray = [];
                    irctcService.passArray = [];
                    $state.go('menu.irctcBookTicketSearch');

                }

            }*/
        }
        /**Function to save lead for loan tile  starts here*/
        $scope.saveOMPLead = function (data) {
            ompMerchantsVm.merchantsList = data;
            var mobileRedirectKey = '';
            if ($scope.shopNOrderPre) {
                mobileRedirectKey = cryptoService.getSHA512EncryptedData(ompMerchantsVm.merchantsList.mobileRedirectUrl).toString();
            } else {
                mobileRedirectKey = cryptoService.getSHA512EncryptedData(loggedInUserService.tokenLotus + ompMerchantsVm.merchantsList.mobileRedirectUrl).toString();
            }
            var saveLeadObj = {
                "leadId": "",
                "websiteId": ompMerchantsVm.merchantsList.websiteId,
                "affiliateId": ompMerchantsVm.merchantsList.affiliateId,
                "request": {
                    "ompCcustToken": "",
                    "loggedIn": "",
                    "channel": "",
                    "segId": "",
                    "ompTokenId": "",
                    "merchantSku": "",
                    "prdPrice": "",
                    "wishlistSkus": "",
                    "ompDisValue": "",
                    "ompDisPct": "",
                    "ompDisType": "",
                    "isLoggedIn": mPinLoginService.isLoggedIn
                },
                "leadParam": ompMerchantsVm.merchantsList.leadParam,
                "segmentParam": ompMerchantsVm.merchantsList.segmentParam,
                "affiliateIdParam": ompMerchantsVm.merchantsList.affiliateIdParam,
                "mobileRedirectUrl": ompMerchantsVm.merchantsList.mobileRedirectUrl,
                "mobileRedirectKey": mobileRedirectKey,
                "shopNOrder": $scope.shopNOrderPreHash
            }
            ompMerchantsService.saveLead(saveLeadObj).then(function (response) {
                ompMerchantsVm.saveLeadData = response;
                if (isWebviewLoadingCanceled == true) {
                    return "";
                }
                isWebviewLoadingCanceled = true;
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
        /**Function to save lead for loan tile  ends here*/

        ompMerchantsVm.tapCancel = function () {
            ompMerchantsVm.loadPopup.close();
            isWebviewLoadingCanceled = true;
            $state.go('menu.ompMerchants');
        }

        ompMerchantsVm.next = function () {
            $ionicSlideBoxDelegate.next();
        }

        ompMerchantsVm.previous = function () {
            $ionicSlideBoxDelegate.previous();
        }

        ompMerchantsVm.gotoSelBannerPre = function (img) {
            if (img.redirectionType == "External") {
                isBannerClicked = true;
                ompMerchantsVm.merchantsList = img;
                ompMerchantsVm.disclaimer(ompMerchantsVm.merchantsList);
            } else {
                ompMerchantsVm.gotoSelBanner(img);
            }
        }

        ompMerchantsVm.gotoSelBanner = function (img) {
            if (ompMerchantsService) {
                if (img.affiliateId) {
                    clickStreamService.clickStreamData = "websiteId," + img.affiliateId;
                } else {
                    clickStreamService.clickStreamData = "websiteId," + "";
                }
            }
            isWebviewLoadingCanceled = false;
            var redirectUrl = img.redirectUrl;

            if (img.redirectionType == "External") {
                ompMerchantsVm.loadPopup = $ionicPopup.show({
                    title: '',
                    cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head textAlignCenter popupBackgroundDark',
                    templateUrl: "pages/OMP/ompMerchants/loading.html",
                    scope: $scope
                });
                if (!img.affiliateId) {
                    img.affiliateId = "";
                }
                var reqParam = {
                    "sessionId": img.sessionId,
                    "merchantName": img.merchantName,
                    "type": "accept",
                    "treatmentCode": img.treatmentCode,
                    "isLoggedIn": mPinLoginService.isLoggedIn,
                    "affiliateId": img.affiliateId,
                    "websiteId": ""
                };
                ompMerchantsService.submitBannerAction(reqParam).then(function (data) {
                    ompMerchantsVm.loadPopup.close();
                    if (isWebviewLoadingCanceled == true) {
                        return "";
                    }
                    isWebviewLoadingCanceled = true;
                    if (img.redirectUrl.indexOf('?') != -1) {
                        if (mPinLoginService.isLoggedIn || $scope.shopNOrderPre) {
                            ompMerchantsService.inAppBrowser(img.redirectUrl + "&" + data.data.parameter, $scope.merchantDetails);
                        }
                    } else {
                        if (mPinLoginService.isLoggedIn || $scope.shopNOrderPre) {
                            ompMerchantsService.inAppBrowser(img.redirectUrl + "?" + data.data.parameter, $scope.merchantDetails);
                        }
                    }
                }, function (error) {
                    ompMerchantsVm.loadPopup.close();
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else {
                var bannerinfoobj = JSON.parse(redirectUrl)
                if (!ompMerchantsService.listName.websiteId) {
                    ompMerchantsService.listName = {};
                    ompMerchantsService.listName.websiteId = "";
                }
                ompMerchantsService.listName.websiteId = bannerinfoobj.WebsiteId;
                if (bannerinfoobj.pageId.toLowerCase() == "shop") {
                    var merchantobj = "";
                    var storesLen = ompMerchantsVm.stores.length;
                    for (var i = 0; i < storesLen; i++) {
                        var merchantTotalData = ompMerchantsVm.stores[i].data;
                        var merchantTotalDataLength = merchantTotalData.length;
                        for (var j = 0; j < merchantTotalDataLength; j++)
                            if (merchantTotalData[j].websiteId == bannerinfoobj.WebsiteId) {
                                if (merchantTotalData[0].merchantType === "Native") {
                                    merchantobj = merchantTotalData[j];
                                    break;
                                }
                            }
                        if (merchantobj != "") {
                            break;
                        }
                    }
                    ompMerchantsService.listName = merchantobj
                    $state.go('menu.ompShop');
                } else if (bannerinfoobj.pageId.toLowerCase() == "productdescription") {
                    var product = {
                        "websiteId": bannerinfoobj.WebsiteId,
                        "productId": bannerinfoobj.productId,
                        "isLoggedIn": mPinLoginService.isLoggedIn
                    };
                    productDescriptionServices.getProductDetails(product).then(function (data) {
                        productDescriptionServices.productData = data;
                        $state.go('menu.productDescription');

                        ompMerchantsService.listName.websiteId = bannerinfoobj.WebsiteId;
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                } else if (bannerinfoobj.pageId == 'menu.creditCards') {
                    cardsService.setParams({ "cardName": bannerinfoobj.productId });
                    $state.go('menu.cardPlatinum');
                } else if (bannerinfoobj.pageId.toLowerCase() == "list") {
                    if (bannerinfoobj.listType == "deal") {
                        var dealList = {
                            "type": "deal",
                            "websiteId": bannerinfoobj.WebsiteId,
                            "filters": [],
                            "sort": {},
                            "isLoggedIn": mPinLoginService.isLoggedIn
                        }
                        searchListServices.getDealList(dealList).then(function (data) {
                            filterService.filterOldData = searchListServices.filterData;
                            searchListServices.allProductsList = data;
                            filterService.selectedLevelOneData = '';
                            filterService.selectedLevelTwoData = "";
                            filterService.selectedLevelThreeData = "";
                            searchListServices.products.length = 0;
                            filterService.addedFilterFullData.length = 0;
                            filterService.addedFilterData.length = 0;
                            filterService.selectedColour.length = 0;
                            searchListServices.isCompareAvailable = false;
                            searchListServices.serviceFrom = 'deal';
                            searchListServices.serviceFromObj = dealList;
                            searchListServices.searchFor = "Deals for you";
                            filterService.isFilterApplied = false;
                            searchListServices.isSortApplied = false;
                            searchListServices.filterNewData = {
                                categoryList: [],
                                subCategoryList: [],
                                colorList: [],
                                priceList: [],
                                callFunctionsList: []
                            };
                            $state.go('menu.searchList');
                        }, function (error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    } else if (bannerinfoobj.listType.toLowerCase() == "category") {
                        var obj = {
                            "category": bannerinfoobj.categoryId,
                            "websiteId": bannerinfoobj.WebsiteId,
                            "filters": [],
                            "sort": {},
                            "isLoggedIn": mPinLoginService.isLoggedIn
                        }
                        searchListServices.getSelectedCategoryProduct(obj).then(function (data) {
                            filterService.filterOldData = searchListServices.filterData;
                            searchListServices.allProductsList = data;
                            filterService.selectedLevelOneData = '';
                            filterService.selectedLevelTwoData = "";
                            filterService.selectedLevelThreeData = "";
                            searchListServices.products.length = 0;
                            filterService.addedFilterFullData.length = 0;
                            filterService.addedFilterData.length = 0;
                            filterService.selectedColour.length = 0;
                            searchListServices.isCompareAvailable = true;
                            searchListServices.serviceFrom = 'getSelectedCategoryProduct';
                            searchListServices.serviceFromObj = obj;
                            filterService.isFilterApplied = false;
                            searchListServices.isSortApplied = false;
                            searchListServices.filterNewData = {
                                categoryList: [],
                                subCategoryList: [],
                                colorList: [],
                                priceList: [],
                                callFunctionsList: []
                            };
                            $state.go('menu.searchList');
                        }, function (error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    } else if (bannerinfoobj.listType.toLowerCase() == "whatsnew") {
                        var newList = {
                            "type": "whatsnew",
                            "websiteId": bannerinfoobj.WebsiteId,
                            "filters": [],
                            "sort": {},
                            "isLoggedIn": mPinLoginService.isLoggedIn
                        }
                        searchListServices.getDealList(newList).then(function (data) {
                            filterService.filterOldData = searchListServices.filterData;
                            searchListServices.allProductsList = data;
                            filterService.selectedLevelOneData = '';
                            filterService.selectedLevelTwoData = "";
                            filterService.selectedLevelThreeData = "";
                            searchListServices.products.length = 0;
                            filterService.addedFilterFullData.length = 0;
                            filterService.addedFilterData.length = 0;
                            filterService.selectedColour.length = 0;
                            searchListServices.isCompareAvailable = false;
                            searchListServices.serviceFrom = 'whatsnew';
                            searchListServices.serviceFromObj = newList;
                            searchListServices.searchFor = "Whats New";
                            filterService.isFilterApplied = false;
                            searchListServices.isSortApplied = false;
                            searchListServices.filterNewData = {
                                categoryList: [],
                                subCategoryList: [],
                                colorList: [],
                                priceList: [],
                                callFunctionsList: []
                            };
                            $state.go('menu.searchList');
                        }, function (error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    } else if (bannerinfoobj.listType.toLowerCase() == "trending") {
                        var trendList = {
                            "type": "trending",
                            "websiteId": bannerinfoobj.WebsiteId,
                            "filters": [],
                            "sort": {},
                            "isLoggedIn": mPinLoginService.isLoggedIn
                        }
                        searchListServices.getDealList(trendList).then(function (data) {
                            filterService.filterOldData = searchListServices.filterData;
                            searchListServices.allProductsList = data;
                            filterService.selectedLevelOneData = '';
                            filterService.selectedLevelTwoData = "";
                            filterService.selectedLevelThreeData = "";
                            searchListServices.products.length = 0;
                            filterService.addedFilterFullData.length = 0;
                            filterService.addedFilterData.length = 0;
                            filterService.selectedColour.length = 0;
                            searchListServices.isCompareAvailable = false;
                            searchListServices.serviceFrom = 'trending';
                            searchListServices.searchFor = "Trending";
                            searchListServices.serviceFromObj = trendList;
                            filterService.isFilterApplied = false;
                            searchListServices.isSortApplied = false;
                            searchListServices.filterNewData = {
                                categoryList: [],
                                subCategoryList: [],
                                colorList: [],
                                priceList: [],
                                callFunctionsList: []
                            };
                            $state.go('menu.searchList');
                        }, function (error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    }
                } else if (bannerinfoobj.pageId.toLowerCase() == "menu.personalloan") {
                    personalLoanService.clearAll();
                    personalLoanService.getLoanDetails().then(function (data) {
                        personalLoanService.personalLoanData = data;
                        personalLoanService.minDuration = data.minTenure;
                        personalLoanService.maxDuration = data.maxTenure;
                        personalLoanService.interestRate = data.interestRate;
                        personalLoanService.product = data.productCode;
                        personalLoanService.maxEmiLimit = data.maxPermissibleEMI;
                        personalLoanService.processingFee = data.processingFee;
                        personalLoanService.minBestOffer = data.minPalAmount;
                        personalLoanService.activityCode = data.activityCode;
                        personalLoanService.schemeCode = data.schemeCode;
                        $state.go('menu.personalLoan');
                    }, function (error) {
                        utilityService.showErrorMessage(error);
                    });
                } else if (bannerinfoobj.pageId == "menu.declaimer") {
                    generalInsurenceHomeService.setGIProductsID(bannerinfoobj.productId)
                    $state.go(bannerinfoobj.pageId);
                } else {
                    $state.go(bannerinfoobj.pageId);
                }
            }
        }
        $scope.slideChanged = function (index) {
            $scope.slideIndex = index;
        }
        $scope.$on('$ionicView.enter', function (e) {
            ompMerchantsVm.showAll = false;
            $timeout(function () {
                ompMerchantsService.showHeader();
            }, 1000);
        });

        $scope.$on('$ionicView.beforeLeave', function () {
            var headerElem = document.querySelector('body');
            var topBar = document.querySelectorAll('.app-header');
            if (headerElem) {
                headerElem.classList.remove('hiddenExtraButton');
            }
            if (topBar) {
                topBar[2].classList.remove('discliamerContent');
            }
            ompMerchantsService.endTimer();
        });
        $scope.$on('$ionicView.afterEnter', function () {
            var headerElem = document.querySelector('body');
            var topBar = document.querySelectorAll('.app-header');
            if (headerElem) {
                headerElem.classList.add('hiddenExtraButton');
            }
            if (headerElem) {
                headerElem.classList.remove('popover-open');
            }
            if (topBar) {
                topBar[2].classList.add('discliamerContent');
            }
            ompMerchantsService.startTimer();
        });

        // In case if merchant site is redirected in chrome tab option then popover-open css need to be removed on app resume
        $ionicPlatform.on('resume', function () {
            var headerElem = document.querySelector('body');
            if (headerElem) {
                headerElem.classList.remove('popover-open');
            }
        })

        $scope.isEnergized = true;

        $scope.toggleEnergized = function () {
            $scope.isEnergized = !$scope.isEnergized;
        }
        $scope.footerExpand = function () {
            console.log('Footer expanded');
            ompMerchantsVm.showAll = true;
        }
        $scope.footerCollapse = function () {
            console.log('Footer collapsed');
            ompMerchantsVm.showAll = false;
        }

        ompMerchantsVm.loadPAPL = function () {
            personalLoanService.clearAll();
            personalLoanService.getLoanDetails().then(function (data) {
                personalLoanService.personalLoanData = data;
                personalLoanService.minDuration = data.minTenure;
                personalLoanService.maxDuration = data.maxTenure;
                personalLoanService.interestRate = data.interestRate;
                personalLoanService.product = data.productCode;
                personalLoanService.maxEmiLimit = data.maxPermissibleEMI;
                personalLoanService.processingFee = data.processingFee;
                personalLoanService.minBestOffer = data.minPalAmount;
                personalLoanService.activityCode = data.activityCode;
                personalLoanService.schemeCode = data.schemeCode;
                $state.go('menu.personalLoan');
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
        $scope.$on('$ionicView.beforeEnter', function () {
            if (!mPinLoginService.isLoggedIn) {
                mPinLoginService.isLoggedIn = false;
            }
            ompMerchantsService.dataForPAPLFlag = false;
            if (!$scope.shopNOrderPre) {
                ompMerchantsVm.dataForPAPL = homeScreenService.offersData;
                angular.forEach(ompMerchantsVm.dataForPAPL, function (value, key) {
                    if (value.category == "PAPL") {
                        ompMerchantsVm.dataForPAPLFlag = true;
                        ompMerchantsVm.textForPAPL = value.palAmount;
                    }
                });
            }
            var obj = {};
            obj.shopNOrder = $scope.shopNOrderPreHash;
            ompMerchantsService.getBestOfYono(obj).then(function (data) {
                $scope.bestOfYonoArray = [];
                if (data && data.length > 0) {
                    $scope.bestOfYonoArray = angular.copy(data[0].merchant);
                }
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
            ompMerchantsService.getTopCategory(obj).then(function (data) {
                ompMerchantsService.isLoggedIn = data.isLoggedIn;
                ompMerchantsVm.topCategoriesData = data;
                $scope.topCategoriesData = ompMerchantsVm.topCategoriesData;
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
            var objWhatsNew = {
                "isLoggedIn": mPinLoginService.isLoggedIn,
                "shopNOrder": $scope.shopNOrderPreHash
            }
            ompMerchantsService.getWhatNewMerchants(objWhatsNew).then(function (data) {
                $scope.dataForWhatsNew = [];
                if (data && data.length > 0) {
                    $scope.dataForWhatsNew = data[0].merchant;
                }
                //$scope.individualMerchantList=$scope.dataForWhatsNew.mobileData;

            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

            /* Funtion no longer needed 
                ompMerchantsService.getFreqViewMerchants(obj).then(function (data) {
                ompMerchantsService.isLoggedIn = data.isLoggedIn;
                ompMerchantsVm.dataForFrequentlyViewed=data;
                $scope.dataForFrequentlyViewed=ompMerchantsVm.dataForFrequentlyViewed;
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        
                ompMerchantsVm.images = [];
                var bannerobj = {
                    "type": "OMP_MRCHT",
                    "sessionId": "",
                    "isLoggedIn": mPinLoginService.isLoggedIn,
                    "affiliateId": ""
                };
                ompMerchantsService.getBannerInformation(bannerobj).then(function (data) {
                    var bannerInformationsLen = data.data.bannerInformations.length;
                    ompMerchantsVm.images = data.data.bannerInformations;
                    $ionicSlideBoxDelegate.update();
                    $ionicSlideBoxDelegate.loop(true);
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
        */
            $scope.addDataToClickStream();
            if (ompMerchantsService.ompSearchHistory && ompMerchantsService.ompSearchHistory.filteredMerchantList) {
                ompMerchantsVm.filteredMerchantList = ompMerchantsService.ompSearchHistory.filteredMerchantList;
                $scope.noOfMerchants = ompMerchantsService.ompSearchHistory.noOfMerchants;
                $scope.noOfSuggetions = ompMerchantsService.ompSearchHistory.noOfSuggetions;
                $scope.currentPageId = ompMerchantsService.ompSearchHistory.currentPageId;
                $scope.searchTrue = ompMerchantsService.ompSearchHistory.searchTrue;
                $scope.onFocusFlag = ompMerchantsService.ompSearchHistory.onFocusFlag;
                ompMerchantsVm.searchMerProCateText = ompMerchantsService.ompSearchHistory.searchMerProCateText;
                document.getElementById("searchInputBox").type = "text";
                $scope.hideAutocompleteDiv = false;
            }
        });
        $scope.addDataToClickStream = function () {
            clickStreamService.clickStreamData = "";
        }
        $scope.resumeSession = function (mpin) {
            var myState = $state;
            var myScope = $scope;
            ompMerchantsService.loginAuthChallengeHandler(mpin, myState, mPinLoginService, myScope);
        }
        ompMerchantsVm.loginSkip = function () {
            ompMerchantsVm.loginPop.close();
        }
        ompMerchantsVm.loginPopup = function () {
            ompMerchantsVm.showCollapse = !ompMerchantsVm.showCollapse;
        }
        /******** Search functionality starts here ******/
        /** Funtion to get selected item details **/
        ompMerchantsVm.selectSearchedItem = function (item) {
            $scope.searchTrue = true;
        }
        /** Funtion to get selected item details ends**/

        /** Funtion to get searched Merchant/category/product details on click of search button **/
        ompMerchantsVm.searchMerchant = function (populatedTxt) {
            ompMerchantsService.ompSearchHistory = "";
            $scope.hideAutocompleteDiv = false;
            if (populatedTxt) {
                ompMerchantsVm.searchMerProCateText = populatedTxt;
            }
            ompMerchantsVm.searchMerProCateText = ompMerchantsVm.searchMerProCateText.trim();
            if (ompMerchantsVm.searchMerProCateText.length <= 2) {
                ompMerchantsVm.searchLenError = true;
                return false;
            }
            $scope.hideRecentSearchDiv = true;
            $scope.currentPageId = 1;
            utilityService.showSpinner();
            clickStreamService.clickStreamData = ompMerchantsVm.searchMerProCateText ? ompMerchantsVm.searchMerProCateText : '0';  // defaultValues|keyword
            var requestParam = {
                "pageId": $scope.currentPageId ? $scope.currentPageId.toString() : "1",
                "keyword": ompMerchantsVm.searchMerProCateText ? ompMerchantsVm.searchMerProCateText : '',
                "searchCharacterLimit": $scope.searchLength,
                "shopNOrder": $scope.shopNOrderPreHash
            };
            ompMerchantsService.getCateMerProdFliteredList(requestParam).then(function (data) {
                utilityService.hideSpinner();
                ompMerchantsVm.saveRecentSearch();
                if (data && data.length > 0) {
                    ompMerchantsVm.filteredMerchantList = data;
                    $scope.noOfMerchants = ompMerchantsVm.filteredMerchantList[0].count ? ompMerchantsVm.filteredMerchantList[0].count : "0";
                    $scope.noOfSuggetions = ompMerchantsVm.filteredMerchantList[0].suggestionCount ? ompMerchantsVm.filteredMerchantList[0].suggestionCount : "0";
                    $scope.currentPageId = $scope.currentPageId + 1;
                    $scope.searchTrue = true;
                    $scope.onFocusFlag = true;
                    var searchHistory = {};
                    searchHistory.filteredMerchantList = ompMerchantsVm.filteredMerchantList;
                    searchHistory.noOfMerchants = $scope.noOfMerchants;
                    searchHistory.noOfSuggetions = $scope.noOfSuggetions;
                    searchHistory.currentPageId = $scope.currentPageId;
                    searchHistory.searchTrue = $scope.searchTrue;
                    searchHistory.onFocusFlag = $scope.onFocusFlag;
                    searchHistory.searchMerProCateText = ompMerchantsVm.searchMerProCateText;
                    ompMerchantsService.ompSearchHistory = searchHistory;
                    if (ompMerchantsVm.filteredMerchantList[0].merchant.length == 0) {
                        var merKeyword = ompMerchantsVm.searchMerProCateText ? ompMerchantsVm.searchMerProCateText : '0';
                        clickStreamService.clickStreamData = merKeyword + "^" + $scope.noOfMerchants + "^" + $scope.noOfSuggetions;
                        if (!mPinLoginService.isLoggedIn) {
                            clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("PRE_LOGIN_" + $state.current.data.pageId + "_" + "SEARCH_RESPONSE_NO_DATA_FOUND"));
                        } else {
                            clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "SEARCH_RESPONSE_NO_DATA_FOUND"));
                        }
                    } else {
                        var merKeywordTwo = ompMerchantsVm.searchMerProCateText ? ompMerchantsVm.searchMerProCateText : '0';
                        clickStreamService.clickStreamData = merKeywordTwo + "^" + $scope.noOfMerchants + "^" + $scope.noOfSuggetions;
                        if (!mPinLoginService.isLoggedIn) {
                            clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("PRE_LOGIN_" + $state.current.data.pageId + "_" + "SEARCH_RESPONSE"));
                        } else {
                            clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "SEARCH_RESPONSE"));
                        }
                    }
                }
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
                $scope.searchTrue = false;
                $scope.onFocusFlag = true;
                ompMerchantsVm.filteredMerchantList = [];
                utilityService.hideSpinner();
                ompMerchantsVm.saveRecentSearch();
            });
        }
        /**  Funtion to get searched Merchant/category/product details on click of search button ends**/

        /** function to save searched keyword  starts**/
        ompMerchantsVm.saveRecentSearch = function () {
            if (!$scope.shopNOrderPre) {
                var requestParam = {
                    "data": [{
                        "keyword": (ompMerchantsVm.searchMerProCateText ? ompMerchantsVm.searchMerProCateText : ""),
                        "shopNOrder": $scope.shopNOrderPreHash
                    }]
                };
                ompMerchantsService.saveRecentSearchHistory(requestParam).then(function (data) {
                    //var index =  ompMerchantsVm.recentSearchedtList.findIndex(item => ompMerchantsVm.searchMerProCateText.toLowerCase() === item.keyword.toLowerCase());
                    var index = -1;
                    ompMerchantsVm.recentSearchedtList.some(function (item, indexVal) {
                        return item.keyword.toLowerCase() == ompMerchantsVm.searchMerProCateText.toLowerCase() ? index = indexVal : false;
                    });
                    if (index !== -1) {
                        ompMerchantsVm.recentSearchedtList.splice(index, 1);
                    }
                    ompMerchantsVm.recentSearchedtList.unshift({ "keyword": ompMerchantsVm.searchMerProCateText });
                    if (ompMerchantsVm.recentSearchedtList.length >= 5) {
                        ompMerchantsVm.recentSearchedtList.length = 5;
                    }

                }, function (error) {
                });
            }
        }
        /** function to save searched keyword  ends**/

        ompMerchantsVm.showRecentSearchHistory = function () {
            $scope.onFocusFlag = true;
            $scope.hideAutocompleteDiv = true;
            $scope.hideRecentSearchDiv = false;
            ompMerchantsVm.searchLenError = false;
        }

        /**Function to remove input box  css **/
        $scope.focusOutChange = function () {
            $scope.onFocusFlag = false;
            $scope.hideAutocompleteDiv = false;
            $scope.hideRecentSearchDiv = true;
        }
        /**Function to remove input box  css ends here**/

        /**Function to update div on input box change event starts**/
        $scope.inputBoxChangeEvent = function () {
            ompMerchantsVm.searchLenError = false;
            $scope.hideAutocompleteDiv = true;
            if (ompMerchantsVm.searchMerProCateText.length <= 2) {
                $scope.searchTrue = false;
                if (ompMerchantsVm.searchMerProCateText.length == 0) {
                    $scope.hideRecentSearchDiv = false;
                }
            }
        }
        /**Function to update div on input box  change event ends here**/

        /** Funtion to get latest 5 recent searched item starts**/
        ompMerchantsVm.getRecentSearch = function () {
            if (!$scope.shopNOrderPre) {
                var requestParam = {};
                requestParam.shopNOrder = $scope.shopNOrderPreHash;
                ompMerchantsService.getRecentSearches(requestParam).then(function (res) {
                    if (res) {
                        ompMerchantsVm.recentSearchedtList = res.data ? res.data : [];
                    }
                    utilityService.hideSpinner();
                }, function (error) {
                    utilityService.hideSpinner();
                    ompMerchantsVm.recentSearchedtList = [];
                });
            }
        }
        /** Funtion to get latest 5 recent searched item ends**/

        /**Function to get list of merchant/category and product for auto complete event starts***/
        ompMerchantsVm.getAllMerchantKeyword = function () {
            var requestParam = {};
            requestParam.shopNOrder = $scope.shopNOrderPreHash;
            utilityService.showSpinner();
            ompMerchantsService.getAllMerchantKeywordList(requestParam).then(function (data) {
                ompMerchantsVm.getRecentSearch();
                if (data && data.data && data.data.length > 0) {
                    ompMerchantsVm.filteredList = data.data[0].keywords ? data.data[0].keywords : [];
                    $scope.searchLength = data.data[0].searchCharacterLimit ? data.data[0].searchCharacterLimit : "70";
                }

            }, function (error) {
                ompMerchantsVm.getRecentSearch();
                ompMerchantsVm.filteredList = [];
            });
        }
        /**Function to get list of merchant/category and product for auto complete event ends***/

        /** Function scroll to load more searched result starts**/
        $scope.loadMoreResult = function () {
            var requestParam = {
                "pageId": $scope.currentPageId ? $scope.currentPageId.toString() : "1",
                "keyword": ompMerchantsVm.searchMerProCateText ? ompMerchantsVm.searchMerProCateText : "",
                "searchCharacterLimit": $scope.searchLength,
                "shopNOrder": $scope.shopNOrderPreHash
            };
            utilityService.showSpinner();
            ompMerchantsService.getCateMerProdFliteredList(requestParam).then(function (data) {
                if (data && data.length > 0) {
                    $scope.mergedArray = ompMerchantsVm.filteredMerchantList[0].merchant.concat(data[0].merchant);
                    ompMerchantsVm.filteredMerchantList[0].merchant = [];
                    ompMerchantsVm.filteredMerchantList[0].merchant = angular.copy($scope.mergedArray);
                    $scope.currentPageId = $scope.currentPageId + 1;
                    $scope.onFocusFlag = true;
                }
                utilityService.hideSpinner();
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
                $scope.onFocusFlag = true;
                utilityService.hideSpinner();
            });
        }
        /** Function scroll to load more searched result ends**/
        ompMerchantsVm.goBack = function () {
            $scope.searchTrue = false;
            $scope.onFocusFlag = false;
            ompMerchantsVm.searchLenError = false;
            ompMerchantsVm.searchMerProCateText = "";
            ompMerchantsVm.filteredMerchantList = [];
            ompMerchantsService.ompSearchHistory = "";
        }
        /**Function to reset searchbox when user clicks on any merchant on omphomepage */
        ompMerchantsVm.resetSearchbox = function () {
            if (!$scope.searchTrue) {
                $scope.onFocusFlag = false;
                ompMerchantsVm.searchLenError = false;
                ompMerchantsVm.searchMerProCateText = "";
                ompMerchantsVm.filteredMerchantList = [];
            }
        }
        /******Search functionality ends here ******/
        /** OMP UI Improvement  */
        ompMerchantsVm.goBackToPreviousPage = function () {
            if ($scope.searchTrue) {
                $scope.searchTrue = false;
                ompMerchantsVm.searchLenError = false;
                ompMerchantsVm.searchMerProCateText = "";
                ompMerchantsVm.filteredMerchantList = [];
            } else {
                if (loggedInUserService.shopNOrderPre) {
                    loggedInUserService.shopNOrderPre = ''; //Reset OMP value after login  
                    loggedInUserService.shopNOrderPreHash = "";
                    setTimeout(function () {
                        $state.go('menu.userLanding');
                    }, 600);
                } else {
                    $state.go('menu.homeScreen');
                }
                //$ionicHistory.goBack(-1);
            }
            ompMerchantsService.ompSearchHistory = "";
        };
        return this;
    }
]);
