'use strict';
angularApp.controller('ompSearchController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"ompShopService",
		"ompSearchService",
		"searchListServices",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ompMerchantsService",
		"filterService",
		"mPinLoginService",
		"clickStreamService",
		"$ionicSideMenuDelegate",
		function($state, $scope, $ionicPopup, ompShopService, ompSearchService, searchListServices, $translate, $ionicHistory, utilityService, ompMerchantsService, filterService,mPinLoginService,clickStreamService,$ionicSideMenuDelegate) {
			var ompSearchVm = this;
			ompSearchVm.goBack = function() {
				$ionicHistory.clearCache().then(function() {
					$ionicHistory.goBack(-1);
				})
			};
			ompSearchVm.clearSearchBox = function() {
				ompSearchVm.searchText = "";
			}
			ompSearchVm.clearSearchHistory = function() {
				ompSearchVm.searchItems = [];
				ompSearchVm.showClearHis = false;
				var obj = {
					"websiteId" : ompMerchantsService.listName.websiteId,
					"isLoggedIn":mPinLoginService.isLoggedIn
				}
				ompSearchService.clearSearches(obj).then(function(data) {
				}, function(error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}
			ompSearchVm.gotoResult = function(item) {
				if (item != "") {
					searchListServices.searchFor = item;
					var obj = {
						"websiteId" : ompMerchantsService.listName.websiteId,
						"keyword" : item,
						"filters" : [],
						"sort" : {},
						"isLoggedIn":mPinLoginService.isLoggedIn
					}
					searchListServices.getSearchProductsList(obj).then(function(data) {
						filterService.filterOldData = searchListServices.filterData;
						searchListServices.allProductsList = data;
						filterService.selectedLevelOneData = '';
						filterService.selectedLevelTwoData = "";
						filterService.selectedLevelThreeData = "";
						searchListServices.products.length = 0
						filterService.addedFilterFullData.length = 0
						filterService.addedFilterData.length = 0
						filterService.selectedColour.length = 0
						searchListServices.isCompareAvailable = true;
						searchListServices.serviceFrom = 'getSearchProductsList';
						searchListServices.serviceFromObj = obj;
						filterService.isFilterApplied = false;
						searchListServices.isSortApplied = false;
						searchListServices.filterNewData = {
						                	          		categoryList : [],
						                	          		subCategoryList : [],
						                	          		colorList : [],
						                	          		priceList : [],
						                	          		callFunctionsList : []
						                	          	};
						$state.go('menu.searchList');
					}, function(error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				} else {
					$state.go('menu.ompSearch');
				}
			}
			ompSearchVm.search = function($event) {
				if ($event.keyCode == 13 || $event.which == 13) {
					ompSearchVm.gotoResult(ompSearchVm.searchText);
				}
			}
			ompSearchVm.autoSuggest = function() {
				if (ompSearchVm.searchText.length === 3) {
					var autoSuggestObj = {
						"websiteId" : ompMerchantsService.listName.websiteId,
						"isLoggedIn":mPinLoginService.isLoggedIn
					};
					ompSearchService.getAutosuggestKeyword(autoSuggestObj).then(function(data) {
						ompSearchVm.getAutoSuggestData = data
						ompSearchVm.searchItems = ompSearchVm.searchItems.concat(ompSearchVm.getAutoSuggestData);
					}, function(error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				}
			};
			$scope.$on('$ionicView.beforeLeave', function(){
				   ompMerchantsService.endTimer();
				});
			$scope.$on('$ionicView.afterEnter', function() {
				ompMerchantsService.startTimer();
			});	
			$scope.$on('$ionicView.beforeEnter', function() {
				ompSearchVm.searchText = "";
				ompSearchVm.searchItems = [];
				ompSearchVm.showClearHis = true;
				$translate('OMPSEARCH').then(function(transValue) {
					ompSearchVm.searchPlace = transValue;
				});
				var searchResposnse = {
					"websiteId" : ompMerchantsService.listName.websiteId,
					"isLoggedIn":mPinLoginService.isLoggedIn
				};
				ompSearchService.getRecentSearches(searchResposnse).then(function(data) {
					if(data.keywords){
					ompSearchVm.searchItems = data.keywords;	
					}
				}, function(error) {
					ompSearchVm.searchItems = [];
					//utilityService.showErrorMessage(error.responseMessage);
				});
				$scope.addDataToClickStream();
				$ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
			});
			$scope.addDataToClickStream = function() {
									if(ompMerchantsService){
										if(ompMerchantsService.listName){
											clickStreamService.clickStreamData = "websiteId,"+ompMerchantsService.listName.affiliateId;
									 }	
									};	
							};
			return this;
		}
]);
