'use strict';
angularApp.service('ompSearchService', function($q, utilityService, AdapterUtils) {
	var getRecentSearches = function(obj) {
		var q = $q.defer();
		AdapterUtils.postData("adapters/OMPAdapter/getRecentSearches", obj, true).then(function(response) {
			q.resolve(response.data);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};
	var clearSearches = function(obj) {
		var q = $q.defer();
		AdapterUtils.postData("adapters/OMPAdapter/clearSearches", obj, true).then(function(response) {
			q.resolve(response);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};
	var getAutosuggestKeyword = function(obj) {
		var q = $q.defer();
		AdapterUtils.postData("adapters/OMPAdapter/getAutosuggestKeyword", obj, false).then(function(response) {
			q.resolve(response.data);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};
	return {
		getRecentSearches : getRecentSearches,
		clearSearches : clearSearches,
		getAutosuggestKeyword :getAutosuggestKeyword 
	};
});
