'use strict';
angularApp.service('ompShopService', function($q, utilityService, AdapterUtils, ompMerchantsService) {
	var category = "";
	var merWebId = "";
	var selectedFeature = "";
	var categoryList = [];
	var featuredCategoriesList = '';
	var subCategory = [];
	var merAffiliateiId="";
	
	var getProductMediaGallery = function(obj) {
		var q = $q.defer();
		AdapterUtils.postData("adapters/OMPAdapter/getProductMediaGallery", obj, true).then(function(response) {
			if (!utilityService.isUndefined(response.datas)) {
				q.resolve(response.datas);
			} else {
				q.reject(response.responseMessage);
			}
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};
	var getFeaturedCategories = function(obj) {
		var q = $q.defer();
		AdapterUtils.postData("adapters/OMPAdapter/getFeaturedCategories", obj, false).then(function(response) {
			q.resolve(response.data);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};
	var getDeals = function(obj) {
		var q = $q.defer();
		AdapterUtils.postData("adapters/OMPAdapter/getDeals", obj, false).then(function(response) {
			q.resolve(response.data[0]);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};
	var getRecentlyViewed = function(obj) {
		var q = $q.defer();
		AdapterUtils.postData("adapters/OMPAdapter/getRecentlyViewed", obj, false).then(function(response) {
			q.resolve(response.data[0]);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};
	var getNavigationCategoryList = function(obj) {
		var q = $q.defer();
		AdapterUtils.postData("adapters/OMPAdapter/getNavigationCategoryList", obj, true).then(function(response) {
			q.resolve(response.data);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};
	return {
		category : category,
		categoryList : categoryList,
		subCategory : subCategory,
		selectedFeature : selectedFeature,
		getNavigationCategoryList : getNavigationCategoryList,
		getDeals : getDeals,
		getFeaturedCategories : getFeaturedCategories,
		getRecentlyViewed : getRecentlyViewed,
		getProductMediaGallery : getProductMediaGallery,
		merWebId : merWebId,
		merAffiliateiId:merAffiliateiId,
		featuredCategoriesList : featuredCategoriesList
	};
});
