'use strict';
angularApp.service('productDescriptionServices', function($q, utilityService, AdapterUtils, searchListServices, ompShopService ,filterService) {
	var productData = "";
	var categoryFiltersData = [];
	var getProductDetails = function(obj) {
		var q = $q.defer();
		AdapterUtils.postData("adapters/OMPAdapter/getProductDetails", obj, true).then(function(response) {
			q.resolve(response.data);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};
	var getSimilarProducts = function(obj) {
		var q = $q.defer();
		AdapterUtils.postData("adapters/OMPAdapter/getSimilarProducts", obj, true).then(function(response) {
			q.resolve(response.data[0]);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};
	var saveProductWishList = function(obj) {
		var q = $q.defer();
		AdapterUtils.postData("adapters/OMPAdapter/saveProductWishList", obj, false).then(function(response) {
			q.resolve(response.data);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};
	var clearProductWishList = function(obj) {
		var q = $q.defer();
		AdapterUtils.postData("adapters/OMPAdapter/clearProductWishList", obj, true).then(function(response) {
			q.resolve(response.data);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};
	
	
	var clearProductWishListBulk = function(obj) {
		var q = $q.defer();
		AdapterUtils.postData("adapters/OMPAdapter/clearProductWishListBulk", obj, true).then(function(response) {
			q.resolve(response.data);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};
	
	
	
	var getSimilarProductList = function(obj,isLoad) {
		searchListServices.filterData.categoryList = [];
		searchListServices.filterData.subCategoryList = [];
		searchListServices.filterData.colorList = [];
		searchListServices.filterData.priceList = [];
		searchListServices.filterData.callFunctionsList = [];
		var loadFlag;
		if(isLoad){
			loadFlag = false;
		}else{
			loadFlag = true;
		}
		var q = $q.defer();
		AdapterUtils.postData("adapters/OMPAdapter/getSimilarProductList", obj, loadFlag).then(function(response) {
			if (response.data.length === 0) {
				q.reject('');
			} else {
				searchListServices.filterData.categoryList = response.data[0];
				angular.forEach(response.data[0].filters, function(value, key) {
					if (value.code === "color")
						searchListServices.filterData.colorList = value.data;
					else if (value.code === "price")
						searchListServices.filterData.priceList = value.data;
					else if (value.code === "cf")
						searchListServices.filterData.callFunctionsList = value.data;
					else if (value.code === "category")
						searchListServices.filterData.subCategoryList = value.data;
				});
				categoryFiltersData = searchListServices.filterData.subCategoryList;
				q.resolve(response.data[0]);
			}
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};

	var getSimilarProductCategoryList = function(obj,isLoad) {
		searchListServices.filterData.categoryList = [];
		searchListServices.filterData.subCategoryList = [];
		searchListServices.filterData.colorList = [];
		searchListServices.filterData.priceList = [];
		searchListServices.filterData.callFunctionsList = [];
		var loadFlag;
		if(isLoad){
			loadFlag = false;
		}else{
			loadFlag = true;
		}
		var q = $q.defer();
		AdapterUtils.postData("adapters/OMPAdapter/getSimilarProductList", obj, loadFlag).then(function(response) {
			if (response.data.length === 0) {
				q.reject('');
			} else {
				searchListServices.filterData.categoryList = response.data[0];
				angular.forEach(response.data[0].filters, function(value, key) {
					if (value.code === "color")
						searchListServices.filterData.colorList = value.data;
					else if (value.code === "price")
						searchListServices.filterData.priceList = value.data;
					else if (value.code === "cf")
						searchListServices.filterData.callFunctionsList = value.data;
					else if (value.code === "category")
						searchListServices.filterData.subCategoryList = categoryFiltersData;
				});
				q.resolve(response.data[0]);
			}
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};

	var getSimilarProductNewList = function(obj,isLoad) {
		filterService.filterNewData.categoryList = [];
		filterService.filterNewData.subCategoryList = [];
		filterService.filterNewData.colorList = [];
		filterService.filterNewData.priceList = [];
		filterService.filterNewData.callFunctionsList = [];
		var loadFlag;
		if(isLoad){
			loadFlag = false;
		}else{
			loadFlag = true;
		}
		var q = $q.defer();
		AdapterUtils.postData("adapters/OMPAdapter/getSimilarProductList", obj, loadFlag).then(function(response) {
			if (response.data.length === 0) {
				q.reject('');
			} else {
				searchListServices.filterNewData.categoryList = response.data[0];
				angular.forEach(response.data[0].filters, function(value, key) {
					if (value.code === "colour")
						searchListServices.filterNewData.colorList = value.data;
					else if (value.code === "price")
						searchListServices.filterNewData.priceList = value.data;
					else if (value.code === "cf")
						searchListServices.filterNewData.callFunctionsList = value.data;
					else if (value.code === "category")
						searchListServices.filterNewData.subCategoryList = categoryFiltersData;
				});
				q.resolve(response.data[0]);
			}
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};
	
	return {
		productData : productData,
		getProductDetails : getProductDetails,
		getSimilarProducts : getSimilarProducts,
		getSimilarProductList : getSimilarProductList,
		saveProductWishList : saveProductWishList,
		clearProductWishList : clearProductWishList,
		getSimilarProductNewList:getSimilarProductNewList,
		getSimilarProductCategoryList:getSimilarProductCategoryList,
		clearProductWishListBulk:clearProductWishListBulk
	};
});
