'use strict';
angularApp.service('searchListServices', function($q, utilityService, AdapterUtils, ompShopService,filterService) {
	var searchFor = "";
	var allProductsList = "";
	var products = [];
	var isCompareAvailable = '';
	var serviceFromObj = '';
	var serviceFrom = '';
	var sortObjectData ={};
	var isSortApplied = '';
	var selectedSortOption = '';
	var filterData = {
	          		categoryList : [],
	          		subCategoryList : [],
	          		colorList : [],
	          		priceList : [],
	          		callFunctionsList : []
	          	};
	var categoryFilters=[];
	

	var maxValue = -1;
	var minValue = -1;

	var getMax = function(max) {
		return maxValue;
	};

	var getMin = function(max) {
		return minValue;
	};
	var setMin = function(min) {
		minValue = min;
	};
	var setMax = function(max) {
		maxValue = max;
	}; 

	  
	var getSelectedCategoryProduct = function(obj,isLoad) {
		filterData.categoryList = [];
		filterData.subCategoryList = ompShopService.categoryList;
		filterData.colorList = [];
		filterData.priceList = [];
		filterData.callFunctionsList = [];
		var loadFlag;
		if(isLoad){
			loadFlag = false;
		}else{
			loadFlag = true;
		}
		var q = $q.defer();
		AdapterUtils.postData("adapters/OMPAdapter/getSelectedCategoryProduct", obj, loadFlag).then(function(response) {
			filterData.categoryList = response.data[0];
			angular.forEach(response.data[0].filters, function(value, key) {
				switch (value.code) {
				case "color" :
					filterData.colorList = value.data;
					break;
				case "price" :
					filterData.priceList = value.data;
					break;
				case "cf" :
					filterData.callFunctionsList = value.data;
					break;
				}
			});
			categoryFilters = filterData.subCategoryList;
			var arrLen = response.data[0].products.length;
			if(arrLen === 0){
							angular.forEach(obj.filters, function(value, key) {
										if(value.value == "price"){
										setMin(value.data[0].split('-')[0]);
										setMax(value.data[0].split('-')[1]);
									 }
									});						
			}
			q.resolve(response.data[0]);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};
	var getSearchProductsList = function(obj,isLoad) {
		filterData.categoryList = [];
		filterData.subCategoryList = [];
		filterData.colorList = [];
		filterData.priceList = [];
		filterData.callFunctionsList = [];
		var loadFlag;
		if(isLoad){
			loadFlag = false;
		}else{
			loadFlag = true;
		}
		var q = $q.defer();
		AdapterUtils.postData("adapters/OMPAdapter/getSearchProductsList", obj, loadFlag).then(function(response) {
			filterData.categoryList = response.data[0];
			angular.forEach(response.data[0].filters, function(value, key) {
				switch (value.code) {
				case "color" :
					filterData.colorList = value.data;
					break;
				case "price" :
					filterData.priceList = value.data;
					break;
				case "category" :
					filterData.subCategoryList = value.data;
					break;
				case "cf" :
					filterData.callFunctionsList = value.data;
					break;
				}
			});
			categoryFilters = filterData.subCategoryList;
			q.resolve(response.data[0]);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	}
	var getRecentlyViewedListing = function(obj,isLoad) {
		filterData.categoryList = [];
		filterData.subCategoryList = [];
		filterData.colorList = [];
		filterData.priceList = [];
		filterData.callFunctionsList = [];
		var loadFlag;
		if(isLoad){
			loadFlag = false;
		}else{
			loadFlag = true;
		}
		var q = $q.defer();
		AdapterUtils.postData("adapters/OMPAdapter/getRecentlyViewedListing", obj, loadFlag).then(function(response) {
			filterData.categoryList = response.data[0];
			angular.forEach(response.data[0].filters, function(value, key) {
				switch (value.code) {
				case "color" :
					filterData.colorList = value.data;
					break;
				case "price" :
					filterData.priceList = value.data;
					break;
				case "category" :
					filterData.subCategoryList = value.data;
					break;
				case "cf" :
					filterData.callFunctionsList = value.data;
					break;
				}
			});
			categoryFilters = filterData.subCategoryList;
			var arrLen = response.data[0].products.length;
			if(arrLen === 0){
							angular.forEach(obj.filters, function(value, key) {
										if(value.value == "price"){
										setMin(value.data[0].split('-')[0]);
										setMax(value.data[0].split('-')[1]);
										 }
									});						
			}
			q.resolve(response.data[0]);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};
	var getDealList = function(obj,isLoad) {
		filterData.categoryList = [];
		filterData.subCategoryList = [];
		filterData.colorList = [];
		filterData.priceList = [];
		filterData.callFunctionsList = [];
		var loadFlag;
		if(isLoad){
			loadFlag = false;
		}else{
			loadFlag = true;
		}
		var q = $q.defer();
		AdapterUtils.postData("adapters/OMPAdapter/getDealList", obj, loadFlag).then(function(response) {
			if (response.data.length === 0) {
				q.reject('');
			} else {
				filterData.categoryList = response.data[0];
				angular.forEach(response.data[0].filters, function(value, key) {
					switch (value.code) {
					case "color" :
						filterData.colorList = value.data;
						break;
					case "price" :
						filterData.priceList = value.data;
						break;
					case "category" :
						filterData.subCategoryList = value.data;
						break;
					case "cf" :
						filterData.callFunctionsList = value.data;
						break;
					}
				});
				categoryFilters = filterData.subCategoryList;
				var arrLen = response.data[0].products.length;
			if(arrLen === 0){
							angular.forEach(obj.filters, function(value, key) {
										if(value.value == "price"){
										setMin(value.data[0].split('-')[0]);
										setMax(value.data[0].split('-')[1]);
										 }
									});						
			}
				q.resolve(response.data[0]);
			}
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};

	var getSearchProductsCategoryList = function(obj,isLoad) {
		filterData.categoryList = [];
		filterData.subCategoryList = [];
		filterData.colorList = [];
		filterData.priceList = [];
		filterData.callFunctionsList = [];
		var loadFlag;
		if(isLoad){
			loadFlag = false;
		}else{
			loadFlag = true;
		}
		var q = $q.defer();
		AdapterUtils.postData("adapters/OMPAdapter/getSearchProductsList", obj, loadFlag).then(function(response) {
			filterData.categoryList = response.data[0];
			angular.forEach(response.data[0].filters, function(value, key) {
				switch (value.code) {
				case "color" :
					filterData.colorList = value.data;
					break;
				case "price" :
					filterData.priceList = value.data;
					break;
				case "category" :
					filterData.subCategoryList = categoryFilters;
					break;
				case "cf" :
					filterData.callFunctionsList = value.data;
					break;
				}
			});
			q.resolve(response.data[0]);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	}
	var getRecentlyViewedCategoryListing = function(obj,isLoad) {
		filterData.categoryList = [];
		filterData.subCategoryList = [];
		filterData.colorList = [];
		filterData.priceList = [];
		filterData.callFunctionsList = [];
		var loadFlag;
		if(isLoad){
			loadFlag = false;
		}else{
			loadFlag = true;
		}
		var q = $q.defer();
		AdapterUtils.postData("adapters/OMPAdapter/getRecentlyViewedListing", obj, loadFlag).then(function(response) {
			filterData.categoryList = response.data[0];
			angular.forEach(response.data[0].filters, function(value, key) {
				switch (value.code) {
				case "color" :
					filterData.colorList = value.data;
					break;
				case "price" :
					filterData.priceList = value.data;
					break;
				case "category" :
					filterData.subCategoryList = categoryFilters;
					break;
				case "cf" :
					filterData.callFunctionsList = value.data;
					break;
				}
			});
			q.resolve(response.data[0]);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};
	var getDealCategoryList = function(obj,isLoad) {
		filterData.categoryList = [];
		filterData.subCategoryList = [];
		filterData.colorList = [];
		filterData.priceList = [];
		filterData.callFunctionsList = [];
		var loadFlag;
		if(isLoad){
			loadFlag = false;
		}else{
			loadFlag = true;
		}
		var q = $q.defer();
		AdapterUtils.postData("adapters/OMPAdapter/getDealList", obj, loadFlag).then(function(response) {
			if (response.data.length === 0) {
				q.reject('');
			} else {
				filterData.categoryList = response.data[0];
				angular.forEach(response.data[0].filters, function(value, key) {
					switch (value.code) {
					case "color" :
						filterData.colorList = value.data;
						break;
					case "price" :
						filterData.priceList = value.data;
						break;
					case "category" :
						filterData.subCategoryList = categoryFilters;
						break;
					case "cf" :
						filterData.callFunctionsList = value.data;
						break;
					}
				});
				q.resolve(response.data[0]);
			}
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};
	
	

	var getSelectedCategoryNewProduct = function(obj,isLoad) {
		filterService.filterNewData.categoryList = [];
		filterService.filterNewData.subCategoryList = ompShopService.categoryList;
		filterService.filterNewData.colorList = [];
		filterService.filterNewData.priceList = [];
		filterService.filterNewData.callFunctionsList = [];
		var loadFlag;
		if(isLoad){
			loadFlag = false;
		}else{
			loadFlag = true;
		}
		var q = $q.defer();
		AdapterUtils.postData("adapters/OMPAdapter/getSelectedCategoryProduct", obj, loadFlag).then(function(response) {
			filterService.filterNewData.categoryList = response.data[0];
			angular.forEach(response.data[0].filters, function(value, key) {
				switch (value.code) {
				case "color" :
					filterService.filterNewData.colorList = value.data;
					break;
				case "price" :
					filterService.filterNewData.priceList = value.data;
					break;
				case "cf" :
					filterService.filterNewData.callFunctionsList = value.data;
					break;
				}
			});
			
			var arrLen = response.data[0].products.length;
			if(arrLen === 0){
							angular.forEach(obj.filters, function(value, key) {
										if(value.value == "price"){
										setMin(value.data[0].split('-')[0]);
										setMax(value.data[0].split('-')[1]);
									 }
									});						
			}
			q.resolve(response.data[0]);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};
	var getSearchNewProductsList = function(obj,isLoad) {
		filterService.filterNewData.categoryList = [];
		filterService.filterNewData.subCategoryList = [];
		filterService.filterNewData.colorList = [];
		filterService.filterNewData.priceList = [];
		filterService.filterNewData.callFunctionsList = [];
		var loadFlag;
		if(isLoad){
			loadFlag = false;
		}else{
			loadFlag = true;
		}
		var q = $q.defer();
		AdapterUtils.postData("adapters/OMPAdapter/getSearchProductsList", obj, loadFlag).then(function(response) {
			filterService.filterNewData.categoryList = response.data[0];
			angular.forEach(response.data[0].filters, function(value, key) {
				switch (value.code) {
				case "color" :
					filterService.filterNewData.colorList = value.data;
					break;
				case "price" :
					filterService.filterNewData.priceList = value.data;
					break;
				case "category" :
					filterData.subCategoryList = categoryFilters;
					break;
				case "cf" :
					filterService.filterNewData.callFunctionsList = value.data;
					break;
				}
			});
			q.resolve(response.data[0]);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	}
	var getRecentlyViewedNewListing = function(obj,isLoad) {
		filterService.filterNewData.categoryList = [];
		filterService.filterNewData.subCategoryList = [];
		filterService.filterNewData.colorList = [];
		filterService.filterNewData.priceList = [];
		filterService.filterNewData.callFunctionsList = [];
		var loadFlag;
		if(isLoad){
			loadFlag = false;
		}else{
			loadFlag = true;
		}
		var q = $q.defer();
		AdapterUtils.postData("adapters/OMPAdapter/getRecentlyViewedListing", obj, loadFlag).then(function(response) {
			filterService.filterNewData.categoryList = response.data[0];
			angular.forEach(response.data[0].filters, function(value, key) {
				switch (value.code) {
				case "color" :
					filterService.filterNewData.colorList = value.data;
					break;
				case "price" :
					filterService.filterNewData.priceList = value.data;
					break;
				case "category" :
					filterData.subCategoryList = categoryFilters;
					break;
				case "cf" :
					filterService.filterNewData.callFunctionsList = value.data;
					break;
				}
			});
			q.resolve(response.data[0]);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};
	var getDealNewList = function(obj,isLoad) {
		filterService.filterNewData.categoryList = [];
		filterService.filterNewData.subCategoryList = [];
		filterService.filterNewData.colorList = [];
		filterService.filterNewData.priceList = [];
		filterService.filterNewData.callFunctionsList = [];
		var loadFlag;
		if(isLoad){
			loadFlag = false;
		}else{
			loadFlag = true;
		}
		var q = $q.defer();
		AdapterUtils.postData("adapters/OMPAdapter/getDealList", obj, loadFlag).then(function(response) {
			if (response.data.length === 0) {
				q.reject('');
			} else {
				filterService.filterNewData.categoryList = response.data[0];
				angular.forEach(response.data[0].filters, function(value, key) {
					switch (value.code) {
					case "color" :
						filterService.filterNewData.colorList = value.data;
						break;
					case "price" :
						filterService.filterNewData.priceList = value.data;
						break;
					case "category" :
						filterData.subCategoryList = categoryFilters;
						break;
					case "cf" :
						filterService.filterNewData.callFunctionsList = value.data;
						break;
					}
				});
			var arrLen = response.data[0].products.length;
			if(arrLen === 0){
							angular.forEach(obj.filters, function(value, key) {
										if(value.value == "price"){
										setMin(value.data[0].split('-')[0]);
										setMax(value.data[0].split('-')[1]);
									 }
									});						
			}
		    q.resolve(response.data[0]);
			}
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};
	
	return {
		searchFor : searchFor,
		products : products,
		filterData : filterData,
		getSelectedCategoryProduct : getSelectedCategoryProduct,
		getSelectedCategoryNewProduct : getSelectedCategoryNewProduct,
		allProductsList : allProductsList,
		getRecentlyViewedListing : getRecentlyViewedListing,
		getSearchProductsList : getSearchProductsList,
		getDealList : getDealList,
		getRecentlyViewedCategoryListing : getRecentlyViewedCategoryListing,
		getSearchProductsCategoryList : getSearchProductsCategoryList,
		getDealCategoryList : getDealCategoryList,
		getRecentlyViewedNewListing : getRecentlyViewedNewListing,
		getSearchNewProductsList : getSearchNewProductsList,
		getDealNewList : getDealNewList,
		isCompareAvailable : isCompareAvailable,
		serviceFromObj : serviceFromObj,
		serviceFrom : serviceFrom,
		sortObjectData : sortObjectData,
		selectedSortOption : selectedSortOption,
		setMax : setMax,
		getMax : getMax,
		setMin : setMin,
		getMin : getMin,
		
	};
});
