'use strict';
angularApp.controller('wishListController', [
	"$state",
	"$scope",
	"$translate",
	"wishListService",
	"searchListServices",
	"ompMerchantsService",
	"$ionicPopup",
	"constantConfig",
	"productDescriptionServices",
	"utilityService",
	"ompShopService",
	"closePopupService",
	"mPinLoginService",
	"clickStreamService",
	"$ionicSideMenuDelegate",
	function ($state,
		$scope,
		$translate,
		wishListService,
		searchListServices,
		ompMerchantsService,
		$ionicPopup,
		constantConfig,
		productDescriptionServices,
		utilityService,
		ompShopService,
		closePopupService,
		mPinLoginService,
		clickStreamService,
		$ionicSideMenuDelegate) {
		var wishListVm = this;
		wishListVm.productDescription = function (data) {
			var product = {
				"websiteId": data.websiteId,
				"productId": data.id,
				"isLoggedIn": mPinLoginService.isLoggedIn
			};
			ompShopService.merWebId = data.websiteId;
			var myMrchntName = data.merchantName;
			productDescriptionServices.getProductDetails(product).then(function (data) {
				productDescriptionServices.productData = data;
				ompMerchantsService.listName = {};
				ompMerchantsService.listName.name = myMrchntName;
				ompMerchantsService.listName.websiteId = ompShopService.merWebId;
				ompMerchantsService.listName.affiliateId = ompShopService.merAffiliateiId;
				$state.go('menu.productDescription');
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		};

		wishListVm.removeWhishlistBulk = function () {
			if (wishListVm.myPopup) {
				wishListVm.myPopup.close();
			}
		}

		wishListVm.wishDelete = function (index, product) {
			var clearWishList = {
				"websiteId": product.websiteId,
				"productId": product.id,
				"isLoggedIn": mPinLoginService.isLoggedIn
			};
			productDescriptionServices.clearProductWishList(clearWishList).then(function (data) {
				var arr = wishListVm.searchResult.products;
				var ArrLen = arr.length;
				for (var i = 0; i < ArrLen; i++) {
					if (arr[i].id == product.id) {
						wishListVm.searchResult.products.splice(i, 1);
					}
				};
				$scope.resultCont = wishListVm.searchResult.products.length;
				wishListService.wishCount = data.globalWishlistCount;
				if (data.merchantWishlistCount > 0) {
					ompMerchantsService.isMerchantsWishListAvl = 'S';
				} else {
					ompMerchantsService.isMerchantsWishListAvl = 'N';
				}
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		}

		wishListVm.displaySort = function () {
			wishListVm.sortPopup = $ionicPopup.show({
				templateUrl: 'pages/OMP/wishList/sortPopup.html',
				scope: $scope,
				cssClass: 'my-sort-popup'
			});
			closePopupService.register(wishListVm.sortPopup);
			setTimeout(function () {
				var element = angular.element(document.getElementsByClassName('mostRecent'));
				if (element[0].checked == false && element[1].checked == false) {
					element[0].checked = true;
				}
			}, 200);

		}

		wishListVm.getSort = function (sorting) {
			var sortObj = {
				"key": sorting.key,
				"direction": sorting.dir
			}
			var sortKey = "";
			wishListVm.desc = false;
			switch (sorting.key) {
				case "merchantName":
					sortKey = "merchantName";
					break;
				case "mostRecent":
					sortKey = "createdAt";
					wishListVm.desc = true;
					break;
				default:
					sortKey = "merchantName";
			}
			wishListVm.orderBy = sortKey;

			if (wishListVm.sortPopup) {
				wishListVm.sortPopup.close();
			}
		};

		wishListVm.goToMarchantPage = function (index, product) {
			$state.go('menu.ompMerchants');
		};

		wishListVm.getGlobalWishlistCount = function () {
			var data = {};
			data.isLoggedIn = mPinLoginService.isLoggedIn;
			wishListService.getGlobalWishlistCount(data).then(function (data) {
				wishListService.wishCount = utilityService.isUndefined(data.globalWishlistCount) ? '0' : data.globalWishlistCount;
				if (!data.globalWishlistCount) {
					wishListService.wishCount = 0;
				}
			}, function (error) {
				wishListService.wishCount = "";
			});
		};

		$scope.$on('$ionicView.leave', function () {
			ompMerchantsService.endTimer();
		});

		$scope.$on('$ionicView.afterEnter', function () {
			ompMerchantsService.startTimer();
		});

		$scope.$on('$ionicView.loaded', function () {
			if(!wishListService.wishCount){
				wishListVm.getGlobalWishlistCount();
			}
		});

		$scope.$on('$ionicView.beforeEnter', function () {
			$scope.resultCont = 0;
			$translate('TOTALITEMS').then(function (transValue) {
				wishListVm.total = transValue;
			});
			wishListVm.dealImg = constantConfig.omp.dealImg;
			wishListVm.disc = constantConfig.omp.discount;
			var obj = {
				"sort": {},
				"isLoggedIn": mPinLoginService.isLoggedIn
			}
			wishListService.getGlobalWishList(obj).then(function (data) {
				if (data.products) {
					var bulkarray = [];
					var bulkWishListObj = {};
					var discontinuedProducts = [];
					var productsLen = data.products.length;
					for (var i = 0; i < productsLen; i++) {
						data.products[i].createdAt = parseInt(data.products[i].createdAt);
						var isActive = data.products[i].productStatus;
						if (isActive != "active") {
							discontinuedProducts.push(data.products[i]);
							var clearWishList = {
								"websiteId": data.products[i].websiteId,
								"productId": data.products[i].id,
							}
							bulkarray.push(clearWishList);
						}
					};
					if (discontinuedProducts.length > 0) {
						bulkWishListObj.wishlist = bulkarray;
						bulkWishListObj.isLoggedIn = mPinLoginService.isLoggedIn;
						productDescriptionServices.clearProductWishListBulk(bulkWishListObj).then(function (wishlistdata) {
							wishListVm.searchResult = data;

							var arr = wishListVm.searchResult.products;
							var discontinuedProductsLen = discontinuedProducts.length;
							for (var i = 0; i < discontinuedProductsLen; i++) {
								var arrayLen = arr.length;
								for (var j = 0; j < arrayLen; j++) {
									if (arr[j].id == discontinuedProducts[i].id) {
										wishListVm.searchResult.products.splice(j, 1);
									}
								}
							}
							$scope.resultCont = wishListVm.searchResult.products.length;
							wishListService.wishCount = wishlistdata.globalWishlistCount;
							if (wishlistdata.merchantWishlistCount > 0) {
								ompMerchantsService.isMerchantsWishListAvl = 'S';
							} else {
								ompMerchantsService.isMerchantsWishListAvl = 'N';
							}
							wishListVm.sortOptions = data.sort;

							var sorting = {};
							sorting.key = 'mostRecent';
							wishListVm.getSort(sorting);

							$scope.discontProducts = discontinuedProducts;


							wishListVm.myPopup = $ionicPopup.show({
								title: "",
								cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',
								templateUrl: "pages/OMP/wishList/RemoveWhishlist.html",
								scope: $scope
							});

						}, function (error) {
							utilityService.showErrorMessage(error.responseMessage);
							if (wishListVm.myPopup) {
								wishListVm.myPopup.close();
							}
						});
					}
					else {
						wishListVm.searchResult = data;
						$scope.resultCont = wishListVm.searchResult.products.length;
						wishListService.wishCount = wishListVm.searchResult.products.length;
						wishListVm.sortOptions = data.sort;
						var sorting = {};
						sorting.key = 'mostRecent';
						wishListVm.getSort(sorting);

					}
				}
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
			$scope.addDataToClickStream();
			$ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
		});

		$scope.addDataToClickStream = function () {
			if (ompMerchantsService) {
				if (ompMerchantsService.listName) {
					clickStreamService.clickStreamData = "websiteId," + ompMerchantsService.listName.affiliateId;
				}
			};
		};
		return this;
	}
]);
