'use strict';

angularApp.controller('POCADetailsAOController', ["$state",
    "$scope",
    "accountOpeningHomeService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",	
	"POCADetailsService",
	"$translate",
	"userLoginDetailsService",
	"ionicDatePicker",
	"enterOTPAOService",
    function($state,
        $scope,
        accountOpeningHomeService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        POCADetailsService,
        $translate,
		userLoginDetailsService,
		ionicDatePicker,
		enterOTPAOService) {

        var POCADetailsVm = this;

        function initPage() {
	        POCADetailsVm.showBack = true;
	        POCADetailsVm.showNext = true; 
	        POCADetailsVm.disableNextButton  =true; 
			POCADetailsVm.aofooter = true;
	        POCADetailsVm.fatcaQuestion = "Same as Proof of Identity";
	        $translate('ADDPROOF_PERSONALDETAILS_PAGE_AO').then(function(translatedvalue) {
			POCADetailsVm.optionText = translatedvalue;
		});
        };
		
		$scope.goToHome = function() {
            accountOpeningHomeService.homeNav();
		}


		POCADetailsVm.openDatePickerExp = function () {
			ionicDatePicker.openDatePicker(POCADetailsVm.dateObjExp);
        };
        POCADetailsVm.openDatePickerIssue = function () {
			ionicDatePicker.openDatePicker(POCADetailsVm.dateObjIssue);
        };
		
        POCADetailsVm.goBacktoPrevious = function() {
			 
			$state.go("menu.POIDetailsAO"); 
        }
        POCADetailsVm.goToNextPage = function() {
        	var proofList = document.getElementById("addressProof");
			var proofSelValue = proofList.options[proofList.selectedIndex].text;
			var dd = moment(POCADetailsService.expiryCompleteDate, ["DD/MM/YYYY"]);
			var expiryCompleteDate;
			if(POCADetailsService.expiryCompleteDate){
				if(POCADetailsService.expiryCompleteDate.length != 10){
					expiryCompleteDate = moment(POCADetailsService.expiryCompleteDate).format('DD-MM-YYYY');
				}else{
					expiryCompleteDate = POCADetailsService.expiryCompleteDate;
				}
			}else{
				expiryCompleteDate = "";
			}
			var issuedCompleteDate;
			if(POCADetailsService.issuedCompleteDate){
				if(POCADetailsService.issuedCompleteDate.length != 10){
			    	issuedCompleteDate = moment(POCADetailsService.issuedCompleteDate).format('DD-MM-YYYY');
				}else{
					issuedCompleteDate = POCADetailsService.issuedCompleteDate;
				}			    
			}else{
				issuedCompleteDate = "";
			}
			
        	POCADetailsService.pageData = {
				  "id": userLoginDetailsService.mobile,
				  "type" : "AO",
				  "data": {
				    "status": "open",
				    "expired": false,
				    "poi": 
				      {
				        "type": POCADetailsService.proofSelValue,
				        "docNo": POCADetailsService.docNumber,
				        "expiryDate": expiryCompleteDate,
				        "issuedBy": POCADetailsService.issuedBy,
				        "issuedAt": POCADetailsService.issuedAt,
				        "issuedDate": issuedCompleteDate				      
				        },
				      "poa": 
				      {
				        "type": POCADetailsService.proofSelValue,
				        "docNo": POCADetailsVm.docNumber,
				        "expiryDate": expiryCompleteDate,
				        "issuedBy": POCADetailsVm.issuedBy,
				        "issuedAt": POCADetailsVm.issuedAt,
				        "issuedDate": issuedCompleteDate
				      },
				      "commonId":$state.$current.data.commonId
				  },
				   //"commonId":$state.$current.data.commonId
        	}
        	POCADetailsService.savePoiOrPoaInfoOVD(POCADetailsService.pageData).then(function(data) {
				 $state.go("menu.personalDetailsAO");
			}, function(error) {
				 utilityService.showErrorMessage(error.responseMessage);
			});
        };
      POCADetailsVm.validDateFormat = function(isValid , monthOrDay) {
            var fullDate = POCADetailsVm.expMonth + '/' + POCADetailsVm.expDate + '/' + POCADetailsVm.expYear;
            var dobMonth = POCADetailsVm.expMonth;
            var dobDay = POCADetailsVm.expDate;
            var dobYr = POCADetailsVm.expYear;
            var fullDateInMilliSeconds = Date.parse(fullDate);
            var formattedDate = new Date();
            var formattedDateYr = formattedDate.getFullYear();
            var currDate = new Date();
            var curYear = currDate.getFullYear();
            var curDateInMilliSeconds = new Date().getTime();
            formattedDate.setFullYear(dobYr, dobMonth - 1, dobDay);
            var months30 = ['04', '06', '09', '11', "4", "6", "9"];
            var monthIndex = months30.indexOf(dobMonth);

            // If entered date is greater than the current date
            if (fullDateInMilliSeconds < curDateInMilliSeconds) {
                POCADetailsVm.disableNext = true;
                POCADetailsVm.invalid = true;
                POCADetailsVm.properDate = false;
            }
            // Leap year validation
            else if (dobYr % 4 == 0 && (dobYr % 100 != 0 || dobYr % 400 == 0)) {
                if (dobMonth == 2 && dobDay > 29) {
                    POCADetailsVm.disableNext = true;
                    POCADetailsVm.invalid = true;
                    POCADetailsVm.properDate = false;
                } else if (monthIndex != -1 && dobDay == 31) {
                    POCADetailsVm.disableNext = true;
                    POCADetailsVm.invalid = true;
                    POCADetailsVm.properDate = false;
                } else {
                    POCADetailsVm.disableNext = !isValid;
                    POCADetailsVm.invalid = false;
                    POCADetailsVm.properDate = true;
                }
            } else if (dobMonth == 2 && dobDay >= 29) {
                POCADetailsVm.disableNext = true;
                POCADetailsVm.invalid = true;
                POCADetailsVm.properDate = false;
            }
            // If the month has only 30 days
            else if (monthIndex != -1 && dobDay == 31) {
                POCADetailsVm.disableNext = true;
                POCADetailsVm.invalid = true;
                POCADetailsVm.properDate = false;
            } else {
                POCADetailsVm.disableNext = !isValid;
                POCADetailsVm.invalid = false;
                POCADetailsVm.properDate = true;
            }
            if(POCADetailsVm.expDate  < 10  && POCADetailsVm.expDate.length == 1 ){
            	POCADetailsVm.disableNext = true;
                POCADetailsVm.invalid = true;
                POCADetailsVm.properDate = false;
            }
            if(POCADetailsVm.expMonth  < 10 && POCADetailsVm.expMonth.length == 1 ){
            	POCADetailsVm.disableNext = true;
                POCADetailsVm.invalid = true;
                POCADetailsVm.properDate = false;
            }
            return POCADetailsVm.properDate;
        }

       POCADetailsVm.validDateFormatForIssedDate = function(isValid , monthOrDay) {
            var fullDate = POCADetailsVm.issedMonth + '/' + POCADetailsVm.issedDate + '/' + POCADetailsVm.issuedYear;
            var dobMonth = POCADetailsVm.issedMonth;
            var dobDay = POCADetailsVm.issedDate;
            var dobYr = POCADetailsVm.issuedYear;
            var fullDateInMilliSeconds = Date.parse(fullDate);
            var formattedDate = new Date();
            var formattedDateYr = formattedDate.getFullYear();
            var currDate = new Date();
            var curYear = currDate.getFullYear();
            var curDateInMilliSeconds = new Date().getTime();
            formattedDate.setFullYear(dobYr, dobMonth - 1, dobDay);
            var months30 = ['04', '06', '09', '11', "4", "6", "9"];
            var monthIndex = months30.indexOf(dobMonth);

            // If entered date is greater than the current date
            if (fullDateInMilliSeconds > curDateInMilliSeconds) {
                POCADetailsVm.disableNext = true;
                POCADetailsVm.invalidIssedDate = true;
                POCADetailsVm.properDate = false;
            }
            // Leap year validation
            else if (dobYr % 4 == 0 && (dobYr % 100 != 0 || dobYr % 400 == 0)) {
                if (dobMonth == 2 && dobDay > 29) {
                    POCADetailsVm.disableNext = true;
                    POCADetailsVm.invalidIssedDate = true;
                    POCADetailsVm.properDate = false;
                } else if (monthIndex != -1 && dobDay == 31) {
                    POCADetailsVm.disableNext = true;
                    POCADetailsVm.invalidIssedDate = true;
                    POCADetailsVm.properDate = false;
                } else {
                    POCADetailsVm.disableNext = !isValid;
                    POCADetailsVm.invalidIssedDate = false;
                    POCADetailsVm.properDate = true;
                }
            } else if (dobMonth == 2 && dobDay >= 29) {
                POCADetailsVm.disableNext = true;
                POCADetailsVm.invalidIssedDate = true;
                POCADetailsVm.properDate = false;
            }
            // If the month has only 30 days
            else if (monthIndex != -1 && dobDay == 31) {
                POCADetailsVm.disableNext = true;
                POCADetailsVm.invalidIssedDate = true;
                POCADetailsVm.properDate = false;
            } else {
                POCADetailsVm.disableNext = !isValid;
                POCADetailsVm.invalidIssedDate = false;
                POCADetailsVm.properDate = true;
            }
            if(POCADetailsVm.issedDate  < 10  && POCADetailsVm.issedDate.length == 1 ){
            	POCADetailsVm.disableNext = true;
                POCADetailsVm.invalidIssedDate = true;
                POCADetailsVm.properDate = false;
            }
            if(POCADetailsVm.issedMonth  < 10 && POCADetailsVm.issedMonth.length == 1 ){
            	POCADetailsVm.disableNext = true;
                POCADetailsVm.invalidIssedDate = true;
                POCADetailsVm.properDate = false;
            }
            return POCADetailsVm.properDate;
        };
       
	POCADetailsVm.disableEnavleNextButton = function() {
		POCADetailsVm.disableNextButton = true;
		if (!POCADetailsVm.docNumber||
			(!POCADetailsVm.expDate) ||
			(!POCADetailsVm.expMonth) ||
			(!POCADetailsVm.expYear) ||
			(!POCADetailsVm.issuedAt) ||
			(!POCADetailsVm.issuedBy) ||
			(!POCADetailsVm.issedDate) ||
			(!POCADetailsVm.issedMonth) ||
			(!POCADetailsVm.issuedYear)) {
			return true;
		}
		if (!POCADetailsVm.properDate||
		   (!POCADetailsVm.expDate) ||
		   (POCADetailsVm.invalidIssedDate) || 
		   (!POCADetailsVm.properDate)) {
			return true;
		}
		try {
			var proofList = document.getElementById("addressProof");
			var villegeSelValue = proofList.options[proofList.selectedIndex].text;
			if (villegeSelValue == POCADetailsVm.optionText) {
				return true;
			}
		} catch(err) {
		}
		POCADetailsVm.disableNextButton = false;
	}
	
	POCADetailsVm.fetchProofList = function() {

		if (!POCADetailsVm.proofList) {
			POCADetailsService.fetchProofList().then(function(responce) {
				POCADetailsVm.proofList = responce.data[0].identifyprooves;
				POCADetailsService.proofListPOI = POCADetailsVm.proofList ;
				if (enterOTPAOService.isResumeJourney == true) {
					for (var i = 0; i < POCADetailsVm.proofList.length; i++) {
						if (POCADetailsVm.proofList[i].name == POCADetailsService.proofSelValue) {
							POCADetailsVm.addressProof = POCADetailsVm.proofList[i].id;
							POCADetailsService.addressProof = POCADetailsVm.addressProof ;
						}
					}
				};
			}, function(error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		}
		
		
	}
		
		POCADetailsVm.agreeToAuthorize = function(isChecked) {
			if (isChecked) {
				POCADetailsVm.proofSelValue = POCADetailsService.proofSelValue;
				POCADetailsVm.docNumber = POCADetailsService.docNumber;
				POCADetailsVm.issuedBy = POCADetailsService.issuedBy;
				POCADetailsVm.issuedAt = POCADetailsService.issuedAt;
				POCADetailsVm.proofList = POCADetailsService.proofListPOI;
				POCADetailsVm.addressProof = POCADetailsService.addressProof;
				POCADetailsVm.issuedate = "";
				POCADetailsVm.expdate = "";
				if (POCADetailsService.issuedCompleteDate) {
					POCADetailsVm.issuedate = POCADetailsService.issuedCompleteDate;
				}
				if (POCADetailsService.expiryCompleteDate) {
					POCADetailsVm.expdate = POCADetailsService.expiryCompleteDate;
				}
				try {
					if (POCADetailsService.issuedCompleteDate.indexOf('-') != -1) {
						POCADetailsVm.issuedate = moment(POCADetailsService.issuedCompleteDate, 'DD-MM-YYYY').format("DD MMM YYYY")
					}
					if (POCADetailsService.expiryCompleteDate.indexOf('-') != -1) {
						POCADetailsVm.expdate = moment(POCADetailsService.expiryCompleteDate, 'DD-MM-YYYY').format("DD MMM YYYY")
					}
				} catch(err) {
				}
				POCADetailsVm.disableNextButton = false;
			} else {
				POCADetailsVm.proofSelValue = "";
				POCADetailsVm.docNumber = "";
				POCADetailsVm.issuedBy = "";
				POCADetailsVm.issuedAt = "";
				POCADetailsVm.expdate = "";
				POCADetailsVm.issuedate = "";
				POCADetailsVm.proofList = "";
				POCADetailsVm.addressProof = "";
				POCADetailsVm.proofList = POCADetailsService.pocProofList;
				POCADetailsVm.disableNextButton = true;
			}
		}

	//one time initialization to be done when the controller is loaded
	$scope.$on('$ionicView.loaded', function() {
		initPage();
		
	});

	//actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function() {
		
		POCADetailsVm.isChecked = true;
		$ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
		POCADetailsVm.fetchProofList();
		POCADetailsVm.agreeToAuthorize(POCADetailsVm.isChecked);



		POCADetailsVm.dateObjExp = {
            callback: function (val) {
                POCADetailsVm.expdate = new Date(val);
                //POCADetailsVm.checkDate();
            },
            inputDate: new Date(),
            from: new Date(), // from:(new Date().setYear(new Date().getFullYear() - 120)) --for help
            to: (new Date().setYear(new Date().getFullYear() + 120)), 
            mondayFirst: true,
            closeOnSelect: false,
            templateType: 'popup',
            dateFormat: 'dd MMM yyyy'
        };

        POCADetailsVm.dateObjIssue = {
            callback: function (val) {
                POCADetailsVm.issuedate = new Date(val);
                //POCADetailsVm.checkDate();
            },
            inputDate: new Date(),
            from:(new Date().setYear(new Date().getFullYear() - 120)),
            to: new Date(), 
            mondayFirst: true,
            closeOnSelect: false,
            templateType: 'popup',
            dateFormat: 'dd MMM yyyy'
        };
        
	});

	return this;
	}
	]);
