'use strict';

angularApp.controller('POIDetailsAOController', ["$state",
    "$scope",
    "accountOpeningHomeService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "POCADetailsService",
    "$translate",
    "ionicDatePicker",
    "enterOTPAOService",
    function ($state,
        $scope,
        accountOpeningHomeService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        POCADetailsService,
        $translate,
        ionicDatePicker,
        enterOTPAOService) {

        var POIDetailsVm = this;

        POIDetailsVm.docNumberMaxLength = 14;

        function initPage() {
            POIDetailsVm.showBack = true;
            POIDetailsVm.showNext = true;
            POIDetailsVm.issuedAtFlag = false;
            POIDetailsVm.issuedByFlag = false;
            POIDetailsVm.expdateFlag = false;
            POIDetailsVm.issuedateFlag = false;
            POIDetailsVm.disableNextButton = true;
            POIDetailsVm.aofooter = true;
        };

        POIDetailsVm.goBacktoPrevious = function () {
            $state.go('menu.taxFatcaDetailsAO');
            //$state.go('menu.aadhaarOption');
        }

        $scope.goToHome = function () {
            accountOpeningHomeService.homeNav();
        }

        POIDetailsVm.openDatePickerExp = function () {
            if (!POIDetailsVm.expdateFlag) {
                ionicDatePicker.openDatePicker(POIDetailsVm.dateObjExp);
            }
        };
        POIDetailsVm.openDatePickerIssue = function () {
            if (!POIDetailsVm.issuedateFlag) {
                ionicDatePicker.openDatePicker(POIDetailsVm.dateObjIssue);
            }
        };


        POIDetailsVm.validDateFormat = function (isValid, monthOrDay) {
            var fullDate = POIDetailsVm.expMonth + '/' + POIDetailsVm.expDate + '/' + POIDetailsVm.expYear;
            var dobMonth = POIDetailsVm.expMonth;
            var dobDay = POIDetailsVm.expDate;
            var dobYr = POIDetailsVm.expYear;
            var fullDateInMilliSeconds = Date.parse(fullDate);
            var formattedDate = new Date();
            var formattedDateYr = formattedDate.getFullYear();
            var currDate = new Date();
            var curYear = currDate.getFullYear();
            var curDateInMilliSeconds = new Date().getTime();
            formattedDate.setFullYear(dobYr, dobMonth - 1, dobDay);
            var months30 = ['04', '06', '09', '11', "4", "6", "9"];
            var monthIndex = months30.indexOf(dobMonth);

            // If entered date is greater than the current date
            if (fullDateInMilliSeconds < curDateInMilliSeconds) {
                POIDetailsVm.disableNext = true;
                POIDetailsVm.invalid = true;
                POIDetailsVm.properDate = false;
            }
            // Leap year validation
            else if (dobYr % 4 == 0 && (dobYr % 100 != 0 || dobYr % 400 == 0)) {
                if (dobMonth == 2 && dobDay > 29) {
                    POIDetailsVm.disableNext = true;
                    POIDetailsVm.invalid = true;
                    POIDetailsVm.properDate = false;
                } else if (monthIndex != -1 && dobDay == 31) {
                    POIDetailsVm.disableNext = true;
                    POIDetailsVm.invalid = true;
                    POIDetailsVm.properDate = false;
                } else {
                    POIDetailsVm.disableNext = !isValid;
                    POIDetailsVm.invalid = false;
                    POIDetailsVm.properDate = true;
                }
            } else if (dobMonth == 2 && dobDay >= 29) {
                POIDetailsVm.disableNext = true;
                POIDetailsVm.invalid = true;
                POIDetailsVm.properDate = false;
            }
            // If the month has only 30 days
            else if (monthIndex != -1 && dobDay == 31) {
                POIDetailsVm.disableNext = true;
                POIDetailsVm.invalid = true;
                POIDetailsVm.properDate = false;
            } else {
                POIDetailsVm.disableNext = !isValid;
                POIDetailsVm.invalid = false;
                POIDetailsVm.properDate = true;
            }
            if (POIDetailsVm.expDate < 10 && POIDetailsVm.expDate.length == 1) {
                POIDetailsVm.disableNext = true;
                POIDetailsVm.invalid = true;
                POIDetailsVm.properDate = false;
            }
            if (POIDetailsVm.expMonth < 10 && POIDetailsVm.expMonth.length == 1) {
                POIDetailsVm.disableNext = true;
                POIDetailsVm.invalid = true;
                POIDetailsVm.properDate = false;
            }
            return POIDetailsVm.properDate;
        }

        POIDetailsVm.validDateFormatForIssedDate = function (isValid, monthOrDay) {
            var fullDate = POIDetailsVm.issedMonth + '/' + POIDetailsVm.issedDate + '/' + POIDetailsVm.issuedYear;
            var dobMonth = POIDetailsVm.issedMonth;
            var dobDay = POIDetailsVm.issedDate;
            var dobYr = POIDetailsVm.issuedYear;
            var fullDateInMilliSeconds = Date.parse(fullDate);
            var formattedDate = new Date();
            var formattedDateYr = formattedDate.getFullYear();
            var currDate = new Date();
            var curYear = currDate.getFullYear();
            var curDateInMilliSeconds = new Date().getTime();
            formattedDate.setFullYear(dobYr, dobMonth - 1, dobDay);
            var months30 = ['04', '06', '09', '11', "4", "6", "9"];
            var monthIndex = months30.indexOf(dobMonth);

            // If entered date is greater than the current date
            if (fullDateInMilliSeconds > curDateInMilliSeconds) {
                POIDetailsVm.disableNext = true;
                POIDetailsVm.invalidIssedDate = true;
                POIDetailsVm.properDate = false;
            }
            // Leap year validation
            else if (dobYr % 4 == 0 && (dobYr % 100 != 0 || dobYr % 400 == 0)) {
                if (dobMonth == 2 && dobDay > 29) {
                    POIDetailsVm.disableNext = true;
                    POIDetailsVm.invalidIssedDate = true;
                    POIDetailsVm.properDate = false;
                } else if (monthIndex != -1 && dobDay == 31) {
                    POIDetailsVm.disableNext = true;
                    POIDetailsVm.invalidIssedDate = true;
                    POIDetailsVm.properDate = false;
                } else {
                    POIDetailsVm.disableNext = !isValid;
                    POIDetailsVm.invalidIssedDate = false;
                    POIDetailsVm.properDate = true;
                }
            } else if (dobMonth == 2 && dobDay >= 29) {
                POIDetailsVm.disableNext = true;
                POIDetailsVm.invalidIssedDate = true;
                POIDetailsVm.properDate = false;
            }
            // If the month has only 30 days
            else if (monthIndex != -1 && dobDay == 31) {
                POIDetailsVm.disableNext = true;
                POIDetailsVm.invalidIssedDate = true;
                POIDetailsVm.properDate = false;
            } else {
                POIDetailsVm.disableNext = !isValid;
                POIDetailsVm.invalidIssedDate = false;
                POIDetailsVm.properDate = true;
            }
            if (POIDetailsVm.issedDate < 10 && POIDetailsVm.issedDate.length == 1) {
                POIDetailsVm.disableNext = true;
                POIDetailsVm.invalidIssedDate = true;
                POIDetailsVm.properDate = false;
            }
            if (POIDetailsVm.issedMonth < 10 && POIDetailsVm.issedMonth.length == 1) {
                POIDetailsVm.disableNext = true;
                POIDetailsVm.invalidIssedDate = true;
                POIDetailsVm.properDate = false;
            }
            return POIDetailsVm.properDate;
        };

        POIDetailsVm.disableEnavleNextButton = function (id) {
            POIDetailsVm.disableNextButton = true;
            if (id) {
                

                POIDetailsVm.selectedObject = function findObjectByKey(array, key, value) {
                        for (var i = 0; i < array.length; i++) {
                            if (array[i][key] === value) {
                                return array[i];
                            }
                        }
                        return null;
                    }
                var dropdownSelectedObject = POIDetailsVm.selectedObject(POIDetailsVm.proofList,"id",id);
                POIDetailsVm.proofSelValue = dropdownSelectedObject.name;
                POCADetailsService.enableDisableId = id;
                POIDetailsVm.issuedAt = "";
                POIDetailsVm.issuedBy = "";
                POIDetailsVm.expdate = "";
                POIDetailsVm.issuedate = "";
                POIDetailsVm.docNumber = "";
                POIDetailsVm.personalDetailsKYCDetailsForm.$setPristine();
            }
            if (POCADetailsService.enableDisableId == "01") {
                POIDetailsVm.expdate = "";
                POIDetailsVm.issuedate = "";

                POIDetailsVm.issuedAtFlag = false;
                POIDetailsVm.issuedByFlag = false;
                POIDetailsVm.expdateFlag = true;
                POIDetailsVm.issuedateFlag = true;
                POIDetailsVm.docNumberMaxLength = 14;

                if (!POIDetailsVm.docNumber ||
                    (!POIDetailsVm.issuedAt) ||
                    (!POIDetailsVm.issuedBy)) {
                    return true;
                }
            }
            else if (POCADetailsService.enableDisableId == "02") {
                POIDetailsVm.issuedAtFlag = false;
                POIDetailsVm.issuedByFlag = false;
                POIDetailsVm.expdateFlag = false;
                POIDetailsVm.issuedateFlag = false;
                POIDetailsVm.docNumberMaxLength = 14;

                if (!POIDetailsVm.docNumber ||
                    (!POIDetailsVm.expdate) ||
                    (!POIDetailsVm.issuedAt) ||
                    (!POIDetailsVm.issuedBy) ||
                    (!POIDetailsVm.issuedate)) {
                    return true;
                }
            }
            else if (POCADetailsService.enableDisableId == "04") {
                POIDetailsVm.issuedAtFlag = false;
                POIDetailsVm.issuedByFlag = false;
                POIDetailsVm.expdateFlag = false;
                POIDetailsVm.issuedateFlag = false;
                POIDetailsVm.docNumberMaxLength = 14;

                if (!POIDetailsVm.docNumber ||
                    (!POIDetailsVm.expdate) ||
                    (!POIDetailsVm.issuedAt) ||
                    (!POIDetailsVm.issuedBy) ||
                    (!POIDetailsVm.issuedate)) {
                    return true;
                }
            }
            else if (POCADetailsService.enableDisableId == "30") {
                POIDetailsVm.issuedAtFlag = false;
                POIDetailsVm.issuedByFlag = false;
                POIDetailsVm.expdateFlag = false;
                POIDetailsVm.issuedateFlag = false;
                POIDetailsVm.docNumberMaxLength = 14;

                if (!POIDetailsVm.docNumber ||
                    (!POIDetailsVm.expdate) ||
                    (!POIDetailsVm.issuedAt) ||
                    (!POIDetailsVm.issuedBy) ||
                    (!POIDetailsVm.issuedate)) {
                    return true;
                }
            }
            else if (POCADetailsService.enableDisableId == "49") {
                POIDetailsVm.issuedAt = "";
                POIDetailsVm.issuedBy = "";
                POIDetailsVm.expdate = "";
                POIDetailsVm.issuedate = "";
                POIDetailsVm.issuedAtFlag = true;
                POIDetailsVm.issuedByFlag = true;
                POIDetailsVm.expdateFlag = true;
                POIDetailsVm.issuedateFlag = true;
                POIDetailsVm.docNumberMaxLength = 12;

                if (!POIDetailsVm.docNumber) {
                    return true;
                }
            }
            if (!POIDetailsVm.addressProof) {
                return true;
            }
            POIDetailsVm.disableNextButton = false;
        }

        POIDetailsVm.disableEnavleNextButtonResume = function (id) {
            POIDetailsVm.disableNextButton = true;

            if (id) {
                POIDetailsVm.proofSelValue = POCADetailsService.proofSelValue;
                POCADetailsService.enableDisableId = id;
            }

            if (POCADetailsService.enableDisableId == "01") {
                POIDetailsVm.expdate = "";
                POIDetailsVm.issuedate = "";

                POIDetailsVm.issuedAtFlag = false;
                POIDetailsVm.issuedByFlag = false;
                POIDetailsVm.expdateFlag = true;
                POIDetailsVm.issuedateFlag = true;
                POIDetailsVm.docNumberMaxLength = 14;

                if (!POIDetailsVm.docNumber ||
                    (!POIDetailsVm.issuedAt) ||
                    (!POIDetailsVm.issuedBy)) {
                    return true;
                }
            }
            else if (POCADetailsService.enableDisableId == "02") {
                POIDetailsVm.issuedAtFlag = false;
                POIDetailsVm.issuedByFlag = false;
                POIDetailsVm.expdateFlag = false;
                POIDetailsVm.issuedateFlag = false;
                POIDetailsVm.docNumberMaxLength = 14;

                if (!POIDetailsVm.docNumber ||
                    (!POIDetailsVm.expdate) ||
                    (!POIDetailsVm.issuedAt) ||
                    (!POIDetailsVm.issuedBy) ||
                    (!POIDetailsVm.issuedate)) {
                    return true;
                }
            }
            else if (POCADetailsService.enableDisableId == "04") {
                POIDetailsVm.issuedAtFlag = false;
                POIDetailsVm.issuedByFlag = false;
                POIDetailsVm.expdateFlag = false;
                POIDetailsVm.issuedateFlag = false;
                POIDetailsVm.docNumberMaxLength = 14;

                if (!POIDetailsVm.docNumber ||
                    (!POIDetailsVm.expdate) ||
                    (!POIDetailsVm.issuedAt) ||
                    (!POIDetailsVm.issuedBy) ||
                    (!POIDetailsVm.issuedate)) {
                    return true;
                }
            }
            else if (POCADetailsService.enableDisableId == "30") {
                POIDetailsVm.issuedAtFlag = false;
                POIDetailsVm.issuedByFlag = false;
                POIDetailsVm.expdateFlag = false;
                POIDetailsVm.issuedateFlag = false;
                POIDetailsVm.docNumberMaxLength = 14;

                if (!POIDetailsVm.docNumber ||
                    (!POIDetailsVm.expdate) ||
                    (!POIDetailsVm.issuedAt) ||
                    (!POIDetailsVm.issuedBy) ||
                    (!POIDetailsVm.issuedate)) {
                    return true;
                }
            }
            else if (POCADetailsService.enableDisableId == "49") {
                POIDetailsVm.issuedAt = "";
                POIDetailsVm.issuedBy = "";
                POIDetailsVm.expdate = "";
                POIDetailsVm.issuedate = "";
                POIDetailsVm.issuedAtFlag = true;
                POIDetailsVm.issuedByFlag = true;
                POIDetailsVm.expdateFlag = true;
                POIDetailsVm.issuedateFlag = true;
                POIDetailsVm.docNumberMaxLength = 12;

                if (!POIDetailsVm.docNumber) {
                    return true;
                }
            }
            if (!POIDetailsVm.addressProof) {
                return true;
            }
            POIDetailsVm.disableNextButton = false;
        }
	       
		POIDetailsVm.populateResumeData = function() {
            POIDetailsVm.addressProof = POCADetailsService.addressProof;
			POIDetailsVm.docNumber = POCADetailsService.docNumber;
			POIDetailsVm.issuedAt = POCADetailsService.issuedAt;
            POIDetailsVm.issuedBy = POCADetailsService.issuedBy;
            POIDetailsVm.disableEnavleNextButtonResume(POCADetailsService.addressProof);
			POIDetailsVm.properDate = true;
			POIDetailsVm.invalidIssedDate = false;
			try {
				if (POCADetailsService.issuedCompleteDate) {
					POIDetailsVm.issuedate = POCADetailsService.issuedCompleteDate;
				}
				if (POCADetailsService.expiryCompleteDate) {
					POIDetailsVm.expdate = POCADetailsService.expiryCompleteDate;
				}
				if (POCADetailsService.issuedCompleteDate.indexOf('-') != -1) {
					POIDetailsVm.issuedate = moment(POCADetailsService.issuedCompleteDate, 'DD-MM-YYYY').format("DD MMM YYYY")
				}
				if (POCADetailsService.expiryCompleteDate.indexOf('-') != -1) {
					POIDetailsVm.expdate = moment(POCADetailsService.expiryCompleteDate, 'DD-MM-YYYY').format("DD MMM YYYY")
				}
			} catch(err) {
			}
		}; 

        POIDetailsVm.fetchProofList = function () {
            if (!POIDetailsVm.proofList) {
                POCADetailsService.fetchProofList().then(function (responce) {
                    POCADetailsService.identifyprooves = responce.data[0].identifyprooves;
                    POCADetailsService.addressprooves = responce.data[0].addressprooves;

                    POIDetailsVm.proofList = responce.data[0].identifyprooves;
                    POCADetailsService.proofListPOI = responce.data[0].identifyprooves;
                    if (enterOTPAOService.isResumeJourney == true) {
                        for (var i = 0; i < POIDetailsVm.proofList.length; i++) {
                            if (POIDetailsVm.proofList[i].name == POCADetailsService.proofSelValue) {
                                POIDetailsVm.addressProof = POIDetailsVm.proofList[i].id;
                            }
                        };
                        POIDetailsVm.disableEnavleNextButton();
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }

        }

        POIDetailsVm.goToNextPage = function () {
            //var proofList = document.getElementById("addressProof");
            POCADetailsService.proofSelValue = POIDetailsVm.proofSelValue;
            POCADetailsService.addressProof = POIDetailsVm.addressProof;
            POCADetailsService.docNumber = POIDetailsVm.docNumber;
            POCADetailsService.expiryCompleteDate = POIDetailsVm.expdate;
            // POCADetailsService.expMonth =  POIDetailsVm.expMonth;
            // POCADetailsService.expYear =  POIDetailsVm.expYear;
            // POCADetailsService.expiryDate = POIDetailsVm.expDate;


            POCADetailsService.issuedAt = POIDetailsVm.issuedAt;
            POCADetailsService.issuedBy = POIDetailsVm.issuedBy;
            POCADetailsService.issuedCompleteDate = POIDetailsVm.issuedate;
            // POCADetailsService.issuedDate = POIDetailsVm.issedDate ;
            // POCADetailsService.issedMonth = POIDetailsVm.issedMonth;
            // POCADetailsService.issuedYear = POIDetailsVm.issuedYear;

            if (POCADetailsService.addressProof != "110") {
                POCADetailsService.pocProofList = POCADetailsService.identifyprooves;
            } else {
                POCADetailsService.pocProofList = POCADetailsService.addressprooves;
            }

            $state.go("menu.POCADetailsAO");
        };
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            POIDetailsVm.fetchProofList();
            $translate('ADDPROOF_PERSONALDETAILS_PAGE_AO').then(function (translatedvalue) {
                POIDetailsVm.optionText = translatedvalue;
            });
			//const today     = moment();
			var tomorrow  = moment().add(1, 'days');
			tomorrow = tomorrow._d;
            POIDetailsVm.dateObjExp = {
                callback: function (val) {
                    POIDetailsVm.expdate = new Date(val);
                    //POIDetailsVm.checkDate();
                    POIDetailsVm.disableEnavleNextButton();
                },
                inputDate: tomorrow,
                from: tomorrow, // from:(new Date().setYear(new Date().getFullYear() - 120)) --for help
                to: (new Date().setYear(new Date().getFullYear() + 120)),
                mondayFirst: true,
                closeOnSelect: false,
                templateType: 'popup',
                dateFormat: 'dd MMM yyyy'
            };

            POIDetailsVm.dateObjIssue = {
                callback: function (val) {
                    POIDetailsVm.issuedate = new Date(val);
                    //POIDetailsVm.checkDate();
                    POIDetailsVm.disableEnavleNextButton();
                },
                inputDate: new Date(),
                from: (new Date().setYear(new Date().getFullYear() - 120)),
                to: new Date(),
                mondayFirst: true,
                closeOnSelect: false,
                templateType: 'popup',
                dateFormat: 'dd MMM yyyy'
            };
            if (enterOTPAOService.isResumeJourney == true || POCADetailsService.proofSelValue) {
                POIDetailsVm.populateResumeData();
                if(POCADetailsService.enableDisableId){
                	POIDetailsVm.addressProof = POCADetailsService.enableDisableId;
                }
            }
        });

        return this;
    }
]);
