'use strict';
angularApp.service('additionalDetailsAOService', function($q, AdapterUtils, constantConfig) {
	var additionalDetailsAOService = this;
	additionalDetailsAOService.customer = {};
	additionalDetailsAOService.customerAdditionalDetails = {};
	additionalDetailsAOService.activeAdditionalDetails = {};
	additionalDetailsAOService.customerAadhaarCardDetails = {};

	additionalDetailsAOService.uploadPhoto = function(requestData) {
		var q = $q.defer();
		AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.uploadDocumentOVD, requestData, true).then(function(response) {
			q.resolve(response);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};

	additionalDetailsAOService.retrievePhoto = function(requestData) {
		var q = $q.defer();
		AdapterUtils.getData(constantConfig.acOpeningAdapterOVDUrl.retrieveDocumentOVD + requestData, true).then(function(response) {
			q.resolve(response);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};

	additionalDetailsAOService.getAnnualIncome = function(param) {
		var q = $q.defer();
		AdapterUtils.getData(constantConfig.acOpeningAdapterOVDUrl.fetchDropDownListOVD + param, true).then(function(response) {
			q.resolve(response.data);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};

	additionalDetailsAOService.getQualification = function(param) {
		var q = $q.defer();
		AdapterUtils.getData(constantConfig.acOpeningAdapterOVDUrl.fetchDropDownListOVD  + param, true).then(function(response) {
			q.resolve(response.data);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};

	additionalDetailsAOService.getMaritalStatus = function(param) {
		var q = $q.defer();
		AdapterUtils.getData(constantConfig.acOpeningAdapterOVDUrl.fetchDropDownListOVD  + param, true).then(function(response) {
			q.resolve(response.data);

		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};

	additionalDetailsAOService.getOccupation = function(param) {
		var q = $q.defer();
		AdapterUtils.getData(constantConfig.acOpeningAdapterOVDUrl.fetchDropDownListOVD  + param, true).then(function(response) {
			q.resolve(response.data);

		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};

	additionalDetailsAOService.loadTitle = function(param) {
		var q = $q.defer();
		AdapterUtils.getData(constantConfig.acOpeningAdapterOVDUrl.fetchDropDownListOVD  + param, true).then(function(response) {
			q.resolve(response);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};

	//new Load title APIs

	additionalDetailsAOService.loadTitleFather = function(param) {
		var q = $q.defer();
		AdapterUtils.getData(constantConfig.acOpeningAdapterOVDUrl.fetchdropDownForFatherOVD  + param, true).then(function(response) {
			q.resolve(response);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};

	additionalDetailsAOService.loadTitleMother = function(param) {
		var q = $q.defer();
		AdapterUtils.getData(constantConfig.acOpeningAdapterOVDUrl.fetchdropDownForMotherOVD  + param, true).then(function(response) {
			q.resolve(response);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};
	
	additionalDetailsAOService.updateAdditionalDetails = function(param) {
		var q = $q.defer();
		AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.updateAdditionalDetailOVD , param, true).then(function(response) {
			q.resolve(response);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};

	
	additionalDetailsAOService.getReligionStatus = function(param) {
		var q = $q.defer();
		AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.getReligionMaster, true).then(function(response) {
			q.resolve(response);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};
	
	 additionalDetailsAOService.getIdByValue = function(obj, selectedValue) {
            var selectedId = "";
            try{
            for (var i = 0; i < obj.length; i++) {
                if (obj[i].description == selectedValue) {
                    selectedId = obj[i].value;
                }
            }
            }catch(err){}
            return selectedId;
        }


	return additionalDetailsAOService;
}); 