'use strict';

angularApp.controller('annualIncomeAOController', ["$state",
    "$scope",
    "additionalDetailsAOService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "accountOpeningHomeService",
    "enterOTPAOService",
    function($state,
        $scope,
        additionalDetailsAOService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        accountOpeningHomeService,
        enterOTPAOService) {

        var annualIncomeAOVm = this;

        function initPage() {
            annualIncomeAOVm.showBack = true;
            annualIncomeAOVm.showNext = false;
            annualIncomeAOVm.aofooter = true;
            
        }

        annualIncomeAOVm.getOccupation = function() {
            $state.go("menu.occupationDetailsAO");
        }

        annualIncomeAOVm.loadAnnualIncome = function(){
            var requestParam = "IncomeLotus";
            utilityService.showSpinner();
            annualIncomeAOVm.isErorr = false;
            additionalDetailsAOService.getAnnualIncome(requestParam).then(function(data) {
				annualIncomeAOVm.isErorr = false;
				utilityService.hideSpinner();
                annualIncomeAOVm.subAnnualIncome = data;
                additionalDetailsAOService.subAnnualIncome = data;
                annualIncomeAOVm.populateResumeData();
            }, function(error) {
            	utilityService.hideSpinner();
            	annualIncomeAOVm.isErorr = true;
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        annualIncomeAOVm.goBacktoPrevious = function() {
             $state.go("menu.looksGreatAO");
        }

        $scope.goToHome = function() {
            accountOpeningHomeService.homeNav();
        }

        annualIncomeAOVm.populateResumeData = function(){
            if(enterOTPAOService.isResumeJourney == true){
                annualIncomeAOVm.activeStatus = additionalDetailsAOService.getIdByValue(annualIncomeAOVm.subAnnualIncome, additionalDetailsAOService.customerAdditionalDetails.annualIncome);
            }
        }

        annualIncomeAOVm.goToNextPage = function(param) {
            additionalDetailsAOService.activeAdditionalDetails.annualIncome = param.value;
            additionalDetailsAOService.customerAdditionalDetails.annualIncome = param.description;
            $state.go("menu.eduQualificationListDetailsAO");
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
            
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            if(!additionalDetailsAOService.activeAdditionalDetails){
            	additionalDetailsAOService.activeAdditionalDetails = {};
            }
            if(!additionalDetailsAOService.customerAdditionalDetails){
            	additionalDetailsAOService.customerAdditionalDetails = {};
            }
            if(!annualIncomeAOVm.subAnnualIncome){
            	if(additionalDetailsAOService.subAnnualIncome){
            		annualIncomeAOVm.subAnnualIncome = additionalDetailsAOService.subAnnualIncome;
            	}else{
            		annualIncomeAOVm.loadAnnualIncome();	
            	}	
            }
            if(additionalDetailsAOService.activeAdditionalDetails.annualIncome){
            	annualIncomeAOVm.activeStatus = additionalDetailsAOService.activeAdditionalDetails.annualIncome;
            }
            //annualIncomeAOVm.activeStatus = additionalDetailsAOService.activeAdditionalDetails.income;
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            annualIncomeAOVm.populateResumeData();
           // }
        });

        return this;
    }
]);
