'use strict';

angularApp.controller('categoryController', ["$state",
    "$scope",
    "additionalDetailsAOService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "accountOpeningHomeService",
    "enterOTPAOService",
    function($state,
        $scope,
        additionalDetailsAOService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        accountOpeningHomeService,
        enterOTPAOService) {

        var categoryDetailsVm = this;

        function initPage() {
            categoryDetailsVm.showBack = true;
            categoryDetailsVm.showNext = false;
            categoryDetailsVm.aofooter = true;
            categoryDetailsVm.loadCategory();
        }

        categoryDetailsVm.getFamilyInfo = function() {
            $state.go("menu.familyDetailsAO");
        }

        categoryDetailsVm.populateResumeData = function(){
            if(enterOTPAOService.isResumeJourney == true){
                categoryDetailsVm.activeStatus = additionalDetailsAOService.getIdByValue(additionalDetailsAOService.categoryList, additionalDetailsAOService.customerAdditionalDetails.category);
            }
        }

        categoryDetailsVm.loadCategory = function(){
            var requestParam = "category";
            categoryDetailsVm.isErorr = false;
            utilityService.showSpinner();
                
            additionalDetailsAOService.getMaritalStatus(requestParam).then(function(data) {
                categoryDetailsVm.isErorr = false;
                utilityService.hideSpinner();
                additionalDetailsAOService.categoryList = data;
                categoryDetailsVm.categoryList = additionalDetailsAOService.categoryList;
                categoryDetailsVm.populateResumeData();
            }, function(error) {
            	utilityService.hideSpinner();
            	categoryDetailsVm.isErorr = true;
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        categoryDetailsVm.goBacktoPrevious = function() {
            $state.go("menu.religionDetailsAO"); 
        }

        categoryDetailsVm.goToNextPage = function(param) {
            additionalDetailsAOService.activeAdditionalDetails.category = param.value;
            additionalDetailsAOService.customerAdditionalDetails.category = param.description;
            $state.go("menu.maritalStatusDetailsAO"); 
        }

        $scope.goToHome = function() {
            //additionalDetailsAOService.homeNav();
            accountOpeningHomeService.homeNav();
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            categoryDetailsVm.activeStatus = additionalDetailsAOService.activeAdditionalDetails.marital;
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
             categoryDetailsVm.populateResumeData();
           });

        return this;
    }
]);
