'use strict';

angularApp.controller('eduQualificationListDetailsAOController', ["$state",
    "$scope",
    "additionalDetailsAOService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "accountOpeningHomeService",
    "enterOTPAOService",
    function($state,
        $scope,
        additionalDetailsAOService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        accountOpeningHomeService,
        enterOTPAOService) {

        var eduQualificationListDetailsVm = this;

        function initPage() {
            eduQualificationListDetailsVm.showBack = true;
            eduQualificationListDetailsVm.showNext = false;
            eduQualificationListDetailsVm.aofooter= true;
            eduQualificationListDetailsVm.loadQualification();
        }

        eduQualificationListDetailsVm.getMariatlStatus = function() {
            $state.go("menu.maritalStatusDetailsAO")
        }

        eduQualificationListDetailsVm.loadQualification = function(){
            var requestParam = "EducationLotus";
            eduQualificationListDetailsVm.isErorr = false;
            utilityService.showSpinner();
            additionalDetailsAOService.getQualification(requestParam).then(function(data) {
                eduQualificationListDetailsVm.isErorr = false;
                utilityService.hideSpinner();
                eduQualificationListDetailsVm.eduQualificationList = data;
                eduQualificationListDetailsVm.populateResumeData();
            }, function(error) {
            	utilityService.hideSpinner();
            	eduQualificationListDetailsVm.isErorr = true;
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        eduQualificationListDetailsVm.populateResumeData = function(){
            if(enterOTPAOService.isResumeJourney == true){
                eduQualificationListDetailsVm.activeStatus = additionalDetailsAOService.getIdByValue(eduQualificationListDetailsVm.eduQualificationList, additionalDetailsAOService.customerAdditionalDetails.education);
            }
        }

        eduQualificationListDetailsVm.goBacktoPrevious = function() {
            $state.go('menu.looksGreatAO');
        }


        eduQualificationListDetailsVm.goToNextPage = function(param) {
            additionalDetailsAOService.activeAdditionalDetails.education = param.value;
            additionalDetailsAOService.customerAdditionalDetails.education = param.description;
            $state.go("menu.religionDetailsAO"); 
        }

        $scope.goToHome = function() {
           accountOpeningHomeService.homeNav();
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            eduQualificationListDetailsVm.activeStatus = additionalDetailsAOService.activeAdditionalDetails.education;
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            eduQualificationListDetailsVm.populateResumeData();
        });

        return this;
    }
]);
