'use strict';

angularApp.controller('familyDetailsAOController', ["$state",
    "$scope",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "additionalDetailsAOService",
    "utilityService",
    "accountOpeningHomeService",
    "$ionicPopover",
    "enterOTPAOService",
    "citizenshipDetailsAOService",
    function ($state,
        $scope,
        $ionicSideMenuDelegate,
        mPinLoginService,
        additionalDetailsAOService,
        utilityService,
        accountOpeningHomeService,
        $ionicPopover,
        enterOTPAOService,
        citizenshipDetailsAOService) {

        var familyDetailsAOVm = this;

        function initPage() {
            familyDetailsAOVm.showBack = true;
            familyDetailsAOVm.showNext = true;
            familyDetailsAOVm.disableNext = true;
            familyDetailsAOVm.aofooter = true;
        }

        familyDetailsAOVm.goBacktoPrevious = function () {
            $state.go("menu.maritalStatusDetailsAO");
        }

        familyDetailsAOVm.goToNextPage = function () {
            additionalDetailsAOService.customerAdditionalDetails.maidenName = familyDetailsAOVm.maidenName;
            additionalDetailsAOService.customerAdditionalDetails.motherMaidenName = familyDetailsAOVm.motherMname;
            additionalDetailsAOService.customerAdditionalDetails.spouseName = familyDetailsAOVm.spouseName;
            additionalDetailsAOService.customerAdditionalDetails.fatherFirstName = familyDetailsAOVm.fatherFname;
            additionalDetailsAOService.customerAdditionalDetails.fatherMiddleName = familyDetailsAOVm.fatherMname;
            additionalDetailsAOService.customerAdditionalDetails.fatherLastName = familyDetailsAOVm.fatherLname;
            additionalDetailsAOService.customerAdditionalDetails.fatherName = familyDetailsAOVm.fatherFname + '' + familyDetailsAOVm.fatherLname;
            additionalDetailsAOService.customerAdditionalDetails.motherFirstname = familyDetailsAOVm.motherFname;
            additionalDetailsAOService.customerAdditionalDetails.motherMiddlename = familyDetailsAOVm.motherMname;
            additionalDetailsAOService.customerAdditionalDetails.motherLastname = familyDetailsAOVm.motherLname;
            $state.go("menu.occupationDetailsAO");
        }

        $scope.goToHome = function () {
            accountOpeningHomeService.homeNav();
        }

        familyDetailsAOVm.changeFn = function (isValid) {
            familyDetailsAOVm.disableNext = !isValid;
        }

        familyDetailsAOVm.fatherTitleSelection = function (value) {
            additionalDetailsAOService.customerAdditionalDetails.fatherTitleCode = value;
            additionalDetailsAOService.customerAdditionalDetails.fatherTitle = accountOpeningHomeService.getValueById(familyDetailsAOVm.selectTitlesFather, additionalDetailsAOService.customerAdditionalDetails.fatherTitleCode);
        }

        familyDetailsAOVm.motherTitleSelection = function (value) {
            additionalDetailsAOService.customerAdditionalDetails.motherTitleCode = value;
            additionalDetailsAOService.customerAdditionalDetails.motherTitle = accountOpeningHomeService.getValueById(familyDetailsAOVm.selectTitlesMother, additionalDetailsAOService.customerAdditionalDetails.motherTitleCode);
        }

        //Load Title Dropdown
        // familyDetailsAOVm.loadTitles = function () {
        //     if (!familyDetailsAOVm.selectTitles) {
        //         var requestData = "TitleLotus";
        //         utilityService.showSpinner();
        //         familyDetailsAOVm.isErorr = false;
        //         additionalDetailsAOService.loadTitle(requestData).then(function (response) {
        //             utilityService.hideSpinner();
        //             familyDetailsAOVm.isErorr = false;
        //             familyDetailsAOVm.selectTitles = response.data;
        //             familyDetailsAOVm.fatherTitleSelection(additionalDetailsAOService.customerAdditionalDetails.fatherTitleCode);
        //             familyDetailsAOVm.motherTitleSelection(additionalDetailsAOService.customerAdditionalDetails.motherTitleCode);
        //         }, function (error) {
        //             familyDetailsAOVm.isErorr = true;
        //             utilityService.hideSpinner();
        //             utilityService.showErrorMessage(error.responseMessage);
        //         });
        //     }
        // }


          //Load Title Dropdown Father
          familyDetailsAOVm.loadTitlesFather = function () {
            if (!familyDetailsAOVm.selectTitlesFather) {
                var requestData = "";
                utilityService.showSpinner();
                familyDetailsAOVm.isErorr = false;
                additionalDetailsAOService.loadTitleFather(requestData).then(function (response) {
                    utilityService.hideSpinner();
                    familyDetailsAOVm.isErorr = false;
                    familyDetailsAOVm.selectTitlesFather = response.data;
                    familyDetailsAOVm.fatherTitleSelection(additionalDetailsAOService.customerAdditionalDetails.fatherTitleCode);
                    familyDetailsAOVm.motherTitleSelection(additionalDetailsAOService.customerAdditionalDetails.motherTitleCode);
                }, function (error) {
                    familyDetailsAOVm.isErorr = true;
                    utilityService.hideSpinner();
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        }


          //Load Title Dropdown Mother
          familyDetailsAOVm.loadTitlesMother = function () {
            if (!familyDetailsAOVm.selectTitlesMother) {
                var requestData = "";
                utilityService.showSpinner();
                familyDetailsAOVm.isErorr = false;
                additionalDetailsAOService.loadTitleMother(requestData).then(function (response) {
                    utilityService.hideSpinner();
                    familyDetailsAOVm.isErorr = false;
                    familyDetailsAOVm.selectTitlesMother = response.data;
                    familyDetailsAOVm.fatherTitleSelection(additionalDetailsAOService.customerAdditionalDetails.fatherTitleCode);
                    familyDetailsAOVm.motherTitleSelection(additionalDetailsAOService.customerAdditionalDetails.motherTitleCode);
                }, function (error) {
                    familyDetailsAOVm.isErorr = true;
                    utilityService.hideSpinner();
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        }


        /* Info Popup */
        var template = '<ion-popover-view class="tooltiptext-ovd ao-popupInfo roboto-regular ao-aadhaarInfoHt">' + '<ion-content>' +
            '<div class="" ng-bind="familyDetailsAOVm.getInfoMsg"></div>' + '</ion-content>' + '</ion-popover-view>';

        $scope.popover = $ionicPopover.fromTemplate(template, {
            scope: $scope
        });


        familyDetailsAOVm.infoPopup = function($event) {
            familyDetailsAOVm.getInfoMsg = "Maiden name is name before marriage.";
            $scope.popover.show($event); 
        //     citizenshipDetailsAOService.getInfoList().then(function(body) {
        //         if(clickId == "citizen"){
        //             citizenshipDetailsAOVm.getInfoMsg = body.infoList.citizenshipContent;
        //         }else if(clickId == "nationality"){
        //             citizenshipDetailsAOVm.getInfoMsg = body.infoList.nationalityContent;
        //         }
                
        //        $scope.popover.show($event);                   
        //    }, function(error) {
        //        utilityService.showErrorMessage(error.responseMessage);
        //    });            
       };


        //Required check for Spouse name based on marital status
        familyDetailsAOVm.enterSpouseName = function (isValid) {
            var required = false;
            if (additionalDetailsAOService.activeAdditionalDetails.marital === "M") {
                required = true;
            } else {
                familyDetailsAOVm.spouseName = "";
                required = false;
            }
            familyDetailsAOVm.disableNext = !isValid;
            return required;
        }

        //Enable/disable Spouse name based on marital status
        familyDetailsAOVm.disableSpouse = function () {
            var disable = true;
            if (additionalDetailsAOService.activeAdditionalDetails.marital === "M") {
                disable = false;
            } else {
                familyDetailsAOVm.spouseName = "";
                disable = true;
            }
            return disable;
        }

        // If married and female - Maiden name is required 
        // Else Maiden name not required
        familyDetailsAOVm.maidenFn = function () {
            var disable = true;
            if (additionalDetailsAOService.activeAdditionalDetails.marital === "M" && citizenshipDetailsAOService.customerManualEntryDetails.titleCode === "02") {
                disable = false;
            } else {
                familyDetailsAOVm.maidenName = "";
                disable = true;
            }
            return disable;
        }

        //Populate data in resume / Omnichannel
        familyDetailsAOVm.populateResumeData = function () {
            familyDetailsAOVm.maidenName = additionalDetailsAOService.customerAdditionalDetails.maidenName;
            familyDetailsAOVm.motherMname = additionalDetailsAOService.customerAdditionalDetails.motherMaidenName;
            familyDetailsAOVm.spouseName = additionalDetailsAOService.customerAdditionalDetails.spouseName;
            familyDetailsAOVm.fatherFname = additionalDetailsAOService.customerAdditionalDetails.fatherFirstName;
            familyDetailsAOVm.fatherMname = additionalDetailsAOService.customerAdditionalDetails.fatherMiddleName;
            familyDetailsAOVm.fatherLname = additionalDetailsAOService.customerAdditionalDetails.fatherLastName;
            familyDetailsAOVm.motherFname = additionalDetailsAOService.customerAdditionalDetails.motherFirstname;
            familyDetailsAOVm.motherMname = additionalDetailsAOService.customerAdditionalDetails.motherMiddlename;
            familyDetailsAOVm.motherLname = additionalDetailsAOService.customerAdditionalDetails.motherLastname;
            familyDetailsAOVm.motherTitle = additionalDetailsAOService.customerAdditionalDetails.motherTitleCode;
            familyDetailsAOVm.fatherTitle = additionalDetailsAOService.customerAdditionalDetails.fatherTitleCode;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
        	if(!additionalDetailsAOService.customerAdditionalDetails){
        		additionalDetailsAOService.customerAdditionalDetails = {};
        	}
        	if (enterOTPAOService.isResumeJourney == true || additionalDetailsAOService.customerAdditionalDetails.fatherName) {
            familyDetailsAOVm.populateResumeData();
           }
            familyDetailsAOVm.enterSpouseName();
            familyDetailsAOVm.disableSpouse();
            //familyDetailsAOVm.loadTitles();
            familyDetailsAOVm.loadTitlesFather();
            familyDetailsAOVm.loadTitlesMother();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
