'use strict';

angularApp.controller('looksGreatAOController', ["$state",
    "$scope",
    "additionalDetailsAOService",
    "utilityService",
    "$translate",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "accountOpeningHomeService",
    "enterOTPAOService",
    "userLoginDetailsService",
    function($state,
        $scope,
        additionalDetailsAOService,
        utilityService,
        $translate,
        $ionicSideMenuDelegate,
        mPinLoginService,
        accountOpeningHomeService,
        enterOTPAOService,
        userLoginDetailsService) {

        var looksGreatVm = this;

        function initPage() {
          
            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                looksGreatVm.okBtntext = translatedvalue;
            });
        }

        looksGreatVm.goBacktoPrevious = function() {
            $state.go('menu.getPictureAO');
        }

        $scope.goToHome = function() {
            accountOpeningHomeService.homeNav();
        }

        looksGreatVm.imgSizeValidation = function(){
            var imgBase = additionalDetailsAOService.customer.photo;

            var blob = new Blob([imgBase], {type: 'image/jpeg'});

            if(blob.size<54 *1024){
                looksGreatVm.handleApply();   
            }
            else{
                var title = '';
                var template = '{{"UPLOAD_IMG_SIZE" | translate}}';
                var onTap = 'menu.looksGreatAO';
                var buttontext = '<b>' + looksGreatVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            }
        }

        /* Functionality : Service to upload the customer photo
           Event : On click of "tick" image
        */
        looksGreatVm.handleApply = function() {
            var newImg = additionalDetailsAOService.customer.photo;
            var baseImg = newImg.split("base64,")[1];
            var param = {
                "documentClass": "LT_AccountOpening",
                "mimeType": "image/jpg",
                "documentTitle": "Customer Photo",
                "documentData": baseImg,
                "documentType": "Photograph",
                "accountNo" : "",
                "documentID": userLoginDetailsService.mobile,
                "commonId": $state.$current.data.commonId,
                "id": additionalDetailsAOService.picId
            }
            additionalDetailsAOService.uploadPhoto(param).then(function(response) {
                additionalDetailsAOService.picId = response.data.docRef;
                $state.go("menu.eduQualificationListDetailsAO");
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        looksGreatVm.retrievePhotoCall = function() {
            var param = additionalDetailsAOService.picId;

            additionalDetailsAOService.retrievePhoto(param).then(function(response) {

                looksGreatVm.croppedImage = "data:image/jpeg;base64," + response.data.documentData;
                additionalDetailsAOService.customer.photo = looksGreatVm.croppedImage;
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            if(!additionalDetailsAOService.customer.photo){
            if (enterOTPAOService.isResumeJourney  == true && !utilityService.isUndefined(additionalDetailsAOService.picId)) {
                looksGreatVm.retrievePhotoCall();
            }
            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                looksGreatVm.okBtntext = translatedvalue;
            });
        }
        else{
            looksGreatVm.croppedImage = additionalDetailsAOService.customer.photo;

        }

        $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);

        });

        return this;
    }
]);
