'use strict';

angularApp.controller('maritalStatusDetailsAOController', ["$state",
    "$scope",
    "additionalDetailsAOService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "accountOpeningHomeService",
    "enterOTPAOService",
    function($state,
        $scope,
        additionalDetailsAOService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        accountOpeningHomeService,
        enterOTPAOService) {

        var maritalStatusDetailsVm = this;

        function initPage() {
            maritalStatusDetailsVm.showBack = true;
            maritalStatusDetailsVm.showNext = false;
            maritalStatusDetailsVm.aofooter = true;
            maritalStatusDetailsVm.loadMaritalStatus();
        }

        maritalStatusDetailsVm.getFamilyInfo = function() {
            $state.go("menu.familyDetailsAO");
        }

        maritalStatusDetailsVm.populateResumeData = function(){
            if(enterOTPAOService.isResumeJourney == true){
                maritalStatusDetailsVm.activeStatus = additionalDetailsAOService.getIdByValue(additionalDetailsAOService.maritalStatusList, additionalDetailsAOService.customerAdditionalDetails.maritalStatus);
            }
        }

        maritalStatusDetailsVm.loadMaritalStatus = function(){
            var requestParam = "MaritalLotus";
            maritalStatusDetailsVm.isErorr = false;
            utilityService.showSpinner();
                
            additionalDetailsAOService.getMaritalStatus(requestParam).then(function(data) {
                maritalStatusDetailsVm.isErorr = false;
                utilityService.hideSpinner();
                additionalDetailsAOService.maritalStatusList = data;
                maritalStatusDetailsVm.maritalStatusList = additionalDetailsAOService.maritalStatusList;
                maritalStatusDetailsVm.populateResumeData();
            }, function(error) {
            	utilityService.hideSpinner();
            	maritalStatusDetailsVm.isErorr = true;
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        maritalStatusDetailsVm.goBacktoPrevious = function() {
            $state.go("menu.category"); 
        }

        maritalStatusDetailsVm.goToNextPage = function(param) {
            additionalDetailsAOService.activeAdditionalDetails.marital = param.value;
            additionalDetailsAOService.customerAdditionalDetails.maritalStatus = param.description;
            $state.go("menu.familyDetailsAO"); 
        }

        $scope.goToHome = function() {
            //additionalDetailsAOService.homeNav();
            accountOpeningHomeService.homeNav();
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            maritalStatusDetailsVm.activeStatus = additionalDetailsAOService.activeAdditionalDetails.marital;
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
             maritalStatusDetailsVm.populateResumeData();
           });

        return this;
    }
]);
