'use strict';

angularApp.controller('subOccupationOthersDetailsAOController', ["$state",
    "$scope",
    "additionalDetailsAOService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
	"userLoginDetailsService",
    "constantConfig",
    "accountOpeningHomeService",
    "enterOTPAOService",
    function($state,
        $scope,
        additionalDetailsAOService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        userLoginDetailsService,
        constantConfig,
        accountOpeningHomeService,
        enterOTPAOService) {

        var subOccupationOthersDetailsVm = this;

        function initPage() {
            subOccupationOthersDetailsVm.showBackService = true;
            subOccupationOthersDetailsVm.showNextService = false;
            subOccupationOthersDetailsVm.showBackOthers = true;
            subOccupationOthersDetailsVm.showNextOthers = false;
            subOccupationOthersDetailsVm.aofooter = true;


            if(additionalDetailsAOService.activeAdditionalDetails.occupation == "0001"){
                subOccupationOthersDetailsVm.loadSubOccupationService();
                }
                else if(additionalDetailsAOService.activeAdditionalDetails.occupation == "0002"){
                    subOccupationOthersDetailsVm.loadSubOccupationOthers();
                }
                else if(additionalDetailsAOService.activeAdditionalDetails.occupation == "0303"){
                    subOccupationOthersDetailsVm.loadSubOccupationBusniness();
                }
                
            subOccupationOthersDetailsVm.mainOccupationLabel = additionalDetailsAOService.customerAdditionalDetails.occupation;

            if(subOccupationOthersDetailsVm.annualIncomeValue && additionalDetailsAOService.activeAdditionalDetails && additionalDetailsAOService.activeAdditionalDetails.subOccupation){
                if((additionalDetailsAOService.activeAdditionalDetails.subOccupation !="0700" && additionalDetailsAOService.activeAdditionalDetails.subOccupation !="0600" && additionalDetailsAOService.activeAdditionalDetails.subOccupation != "0500" && additionalDetailsAOService.activeAdditionalDetails.subOccupation != "0493") && (subOccupationOthersDetailsVm.annualIncomeValue == "0" || subOccupationOthersDetailsVm.annualIncomeValue == 0)){
                    subOccupationOthersDetailsVm.annualIncomeError  = true;
                }else{
                    subOccupationOthersDetailsVm.annualIncomeError = false;
                }
            }
        }

        subOccupationOthersDetailsVm.goBacktoPrevious = function() {
            $state.go("menu.occupationDetailsAO");
        }

        subOccupationOthersDetailsVm.goToNextPage = function(param) {
            additionalDetailsAOService.activeAdditionalDetails.subOccupation = param.value;
            additionalDetailsAOService.customerAdditionalDetails.subOccupation = param.description;
            $state.go("menu.annualIncomeNew"); 
            //subOccupationOthersDetailsVm.updateAdditionalDetailsCall();
        }

        subOccupationOthersDetailsVm.populateResumeData = function(){
            if(enterOTPAOService.isResumeJourney == true){
                if(additionalDetailsAOService.activeAdditionalDetails.occupation == "0001"){
                    subOccupationOthersDetailsVm.activeStatus = additionalDetailsAOService.getIdByValue(subOccupationOthersDetailsVm.serviceOccupationList, additionalDetailsAOService.customerAdditionalDetails.subOccupation);
                }
                else{
                    subOccupationOthersDetailsVm.activeStatus = additionalDetailsAOService.getIdByValue(subOccupationOthersDetailsVm.othersOccupationList, additionalDetailsAOService.customerAdditionalDetails.subOccupation);
                }
                
            }
        }

        subOccupationOthersDetailsVm.loadSubOccupationService = function(){
        	subOccupationOthersDetailsVm.isErorr = false;
			utilityService.showSpinner();
            var requestParam = "OccupationLotusService";
            additionalDetailsAOService.getOccupation(requestParam).then(function(data) {
            	subOccupationOthersDetailsVm.isErorr = false;
			    utilityService.hideSpinner();
                       
                subOccupationOthersDetailsVm.serviceOccupationList = data;
                subOccupationOthersDetailsVm.populateResumeData();
            }, function(error) {
            	subOccupationOthersDetailsVm.isErorr = true;
			    utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        subOccupationOthersDetailsVm.loadSubOccupationOthers = function(){
        	subOccupationOthersDetailsVm.isErorr = false;
			utilityService.showSpinner();
            var requestParam = "OccupationLotusOthers";
            
            additionalDetailsAOService.getOccupation(requestParam).then(function(data) {
                subOccupationOthersDetailsVm.isErorr = false;
			    utilityService.hideSpinner();         
                subOccupationOthersDetailsVm.othersOccupationList = data;
            }, function(error) {
            	subOccupationOthersDetailsVm.isErorr = true;
			    utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        subOccupationOthersDetailsVm.loadSubOccupationBusniness = function(){
        	subOccupationOthersDetailsVm.isErorr = false;
			utilityService.showSpinner();
            var requestParam = "OccupationLotusBusiness";
            
            additionalDetailsAOService.getOccupation(requestParam).then(function(data) {
                subOccupationOthersDetailsVm.isErorr = false;
			    utilityService.hideSpinner();         
                subOccupationOthersDetailsVm.busniessOccupationList = data;
            }, function(error) {
            	subOccupationOthersDetailsVm.isErorr = true;
			    utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.goToHome = function() {
            //additionalDetailsAOService.homeNav();
            accountOpeningHomeService.homeNav();
        }
        
        //Service to update additional detail
        subOccupationOthersDetailsVm.updateAdditionalDetailsCall = function() {
            additionalDetailsAOService.customerAdditionalDetails.annualIncomeValue = utilityService.resetAmountFormat(subOccupationOthersDetailsVm.annualIncomeValue);
            var requestParams = {
                "id": userLoginDetailsService.mobile,
                "type":"AO",
                "data":{
                    "additionalDetails":{
                       "maidenName": additionalDetailsAOService.customerAdditionalDetails.maidenName,
                        "fatherName": additionalDetailsAOService.customerAdditionalDetails.fatherName,
                        "maritalStatus": additionalDetailsAOService.customerAdditionalDetails.maritalStatus,
                        "maritalStatusCode":additionalDetailsAOService.activeAdditionalDetails.marital,
                        "annualIncome": additionalDetailsAOService.customerAdditionalDetails.annualIncome,
                        "annualIncomeCode":additionalDetailsAOService.activeAdditionalDetails.annualIncome,
                        "religion": additionalDetailsAOService.customerAdditionalDetails.religion,
                        "religionCode":additionalDetailsAOService.activeAdditionalDetails.religion,
                        "education": additionalDetailsAOService.customerAdditionalDetails.education,
                        "educationCode":additionalDetailsAOService.activeAdditionalDetails.education,
                        "occupation": additionalDetailsAOService.customerAdditionalDetails.occupation,
                        "occupationCode":additionalDetailsAOService.activeAdditionalDetails.occupation,
                        "subOccupation": additionalDetailsAOService.customerAdditionalDetails.subOccupation,
                        "subOccupationCode": additionalDetailsAOService.activeAdditionalDetails.subOccupation,
                        "annualIncomeValue":additionalDetailsAOService.customerAdditionalDetails.annualIncomeValue,
                         "thresholdLimitAmount": "",
                        "motherFirstName":additionalDetailsAOService.customerAdditionalDetails.motherFirstname,
                        "motherMiddleName":additionalDetailsAOService.customerAdditionalDetails.motherMiddlename,
                        "motherLastName":additionalDetailsAOService.customerAdditionalDetails.motherLastname,
                        
                        "motherTitle":additionalDetailsAOService.customerAdditionalDetails.motherTitle,
                        "motherTitleCode":additionalDetailsAOService.customerAdditionalDetails.motherTitleCode, 
                        
                        "motherMaidenName": additionalDetailsAOService.customerAdditionalDetails.motherMaidenName,
                        "spouseName": additionalDetailsAOService.customerAdditionalDetails.spouseName,
                        
                        "fatherFirstName": additionalDetailsAOService.customerAdditionalDetails.fatherFirstName,
                        "fatherMiddleName":additionalDetailsAOService.customerAdditionalDetails.fatherMiddleName,
                        "fatherLastName":additionalDetailsAOService.customerAdditionalDetails.fatherLastName,
                        
                        "fatherTitle":additionalDetailsAOService.customerAdditionalDetails.fatherTitle,
                        "fatherTitleCode":additionalDetailsAOService.customerAdditionalDetails.fatherTitleCode,
                        "category": additionalDetailsAOService.customerAdditionalDetails.category,
                        "categoryCode":additionalDetailsAOService.activeAdditionalDetails.category 
                    },
                    "commonId":$state.$current.data.commonId
                }             
            }
            additionalDetailsAOService.updateAdditionalDetails(requestParams).then(function(response) {
                var responseCode = response.responseCode;
                if (responseCode === constantConfig.successCode) {
                   //$state.go("menu.optionalAdditionalDetails"); 
                   //$state.go("menu.annualIncomeNew"); 
                   $state.go("menu.nomineeDetailsAO");
                }
                
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        subOccupationOthersDetailsVm.numerFormat = function() {

            if(subOccupationOthersDetailsVm.annualIncomeValue){
                subOccupationOthersDetailsVm.annualIncomeValue = utilityService.amountFormat(subOccupationOthersDetailsVm.annualIncomeValue);
                if((additionalDetailsAOService.activeAdditionalDetails.subOccupation !="0700" && additionalDetailsAOService.activeAdditionalDetails.subOccupation !="0600" && additionalDetailsAOService.activeAdditionalDetails.subOccupation != "0500" && additionalDetailsAOService.activeAdditionalDetails.subOccupation != "0493") && (subOccupationOthersDetailsVm.annualIncomeValue == "0" || subOccupationOthersDetailsVm.annualIncomeValue == 0)){
                    subOccupationOthersDetailsVm.annualIncomeError  = true;
                }else{
                    subOccupationOthersDetailsVm.annualIncomeError = false;
                }
                additionalDetailsAOService.customerAdditionalDetails.annualIncomeValue = subOccupationOthersDetailsVm.annualIncomeValue;
             }

        }
        

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
           
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            if(additionalDetailsAOService.activeAdditionalDetails.occupation == "0001"){
                subOccupationOthersDetailsVm.activeStatusService = additionalDetailsAOService.activeAdditionalDetails.subOccupation;
            }
            else if(additionalDetailsAOService.activeAdditionalDetails.occupation == "0002"){
                subOccupationOthersDetailsVm.activeStatusOthers = additionalDetailsAOService.activeAdditionalDetails.subOccupation;
            }
            else if(additionalDetailsAOService.activeAdditionalDetails.occupation == "0303"){
                subOccupationOthersDetailsVm.activeStatusBusiness = additionalDetailsAOService.activeAdditionalDetails.subOccupation;
            }
            subOccupationOthersDetailsVm.annualIncomeValue = additionalDetailsAOService.customerAdditionalDetails.annualIncomeValue;
            if(subOccupationOthersDetailsVm.annualIncomeValue){
                subOccupationOthersDetailsVm.annualIncomeValue = utilityService.amountFormat(subOccupationOthersDetailsVm.annualIncomeValue);
            }

            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
             initPage();
             if((additionalDetailsAOService.activeAdditionalDetails.subOccupation !="0700" && additionalDetailsAOService.activeAdditionalDetails.subOccupation !="0600" && additionalDetailsAOService.activeAdditionalDetails.subOccupation != "0500" && additionalDetailsAOService.activeAdditionalDetails.subOccupation != "0493") && (subOccupationOthersDetailsVm.annualIncomeValue == "0" || subOccupationOthersDetailsVm.annualIncomeValue == 0)){
                subOccupationOthersDetailsVm.annualIncomeError  = true;
            }else{
                subOccupationOthersDetailsVm.annualIncomeError = false;
            }
            subOccupationOthersDetailsVm.populateResumeData();
            //}
        });

        subOccupationOthersDetailsVm.goBacktoPreviousFromIncome = function() {
            
            if(additionalDetailsAOService.activeAdditionalDetails.occupation == "0001"){
                $state.go("menu.subOccupationServiceDetailsAO");
                }
                else if(additionalDetailsAOService.activeAdditionalDetails.occupation == "0002"){
                    $state.go("menu.subOccupationOthersDetailsAO");
                }
                else if(additionalDetailsAOService.activeAdditionalDetails.occupation == "0303"){
                    $state.go("menu.subOccupationBusinessDetailsAO");
                }
                else{
                    $state.go("menu.occupationDetailsAO");	
                }
        }

       

        subOccupationOthersDetailsVm.goToNominee = function(){
            subOccupationOthersDetailsVm.updateAdditionalDetailsCall();
        }

        return this;
    }
]);
