'use strict';

angularApp.controller('takeSelfieAOController', ["$state",
    "$scope",
    "$translate",
    "cameraService",
    "additionalDetailsAOService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "accountOpeningHomeService",
    function($state,
        $scope,
        $translate,
        cameraService,
        additionalDetailsAOService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        accountOpeningHomeService) {

        var takeSelfieAOVm = this;

        function initPage() {
            takeSelfieAOVm.showBack = true;
            takeSelfieAOVm.aofooter = true;
        
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                takeSelfieAOVm.okBtntext = translatedvalue;  
            });
        }

        takeSelfieAOVm.goBacktoPrevious = function() {
            $state.go('menu.getPictureAO');
        }

        $scope.goToHome = function() {
            //additionalDetailsAOService.homeNav();
            accountOpeningHomeService.homeNav();
        }

        /* Opens Mobile Camera */
        takeSelfieAOVm.openCamera = function() {
            cameraService.getnewImage().then(function(data) {
                takeSelfieAOVm.setImage(data);
                $state.go('menu.looksGreatAO');
            }, function(error) {
                var title = '';
                var template = '{{"SERVICE_ERR_MSG" | translate}}';
                var onTap = '';
                var buttontext = '<b>' + takeSelfieAOVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            });
        }

        /* Set the image captured in camera */
        takeSelfieAOVm.setImage = function(img) {
            takeSelfieAOVm.selfieImage = img;
            additionalDetailsAOService.customer.photo = takeSelfieAOVm.selfieImage;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            takeSelfieAOVm.selfieImage = "img/client-img.png";
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });
        
        return this;
    }
]);
