/**
*   @ngdoc config
*   @name angularApp.config : aoConfig
*   @description
*	configuration file for account opening module
*/

'use strict';

/*State definition with respective names, urls, controllers and templates */
angularApp.config(['$stateProvider',
	function ($stateProvider) {

		//Account Opening start
		$stateProvider
			.state('menu.newToSbiLanding', {
				url: '/newToSbiLanding',
				data: {
					pageId: 'NEW_TO_SBI_LANDING',
					sectionId: 'newToSbiLandingSection',
					commonId: ""
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/newToSbi/newToSbiLanding.html',
						controller: 'newToSbiLandingController',
						controllerAs: 'newToSbiLandingVm',
					}
				}
			})
			.state('menu.openDSA', {
				url: '/openDSA',
				data: {
					pageId: 'OPEN_DSA',
					sectionId: 'openDSASection',
					commonId: ""
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/newToSbi/openDSA.html',
						controller: 'openDSAController',
						controllerAs: 'openDSAVm',
					}
				}
			})
			.state('menu.openDsaWithoutVisit', {
				url: '/openDsaWithoutVisit',
				data: {
					pageId: 'OPEN_DSA_WITHOUT_VISIT',
					sectionId: 'openDsaWithoutVisitSection',
					commonId: ""
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/newToSbi/openDsaWithoutVisit.html',
						controller: 'openDsaWithoutVisitController',
						controllerAs: 'openDsaWithoutVisitVm',
					}
				}
			})
			.state('menu.homePageAO', {
				url: '/homePageAO',
				data: {
					pageId: 'AO_HOM',
					sectionId: 'homePageAOSection',
					commonId: ""
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/home/homePageAccountOpening.html',
						controller: 'aoHomePageController',
						controllerAs: 'homePageAccountOpeningVm',
					}
				}
			})
			.state('menu.productInformationPageAO', {
				url: '/productInformationPageAO',
				data: {
					pageId: 'AO_NEW_ACC',
					sectionId: 'productInformationPageAOSection',
					commonId: ""
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/productInformation/productInformation.html',
						controller: 'productInformationControllerAO',
						controllerAs: 'productInformationVm',
					}
				}
			})
			.state('menu.resumeAccountPageAO', {
				url: '/resumeAccountPageAO',
				data: {
					pageId: 'AO_RESM_ACC',
					sectionId: 'resumeAccountPageAOSection',
					commonId: ""
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/resumeAccount/resumeAccount.html',
						controller: 'resumeAccountControllerAO',
						controllerAs: 'resumeAccountAOVm',
					}
				}
			})
			.state('menu.knowMorePageAO', {
				url: '/knowMorePageAO',
				data: {
					pageId: 'AO_KNW_MOR',
					sectionId: 'knowMorePageAOSection',
					commonId: ""
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/productInformation/knowMore.html',
						controller: 'knowMorePageAOController',
						controllerAs: 'knowMoreAOVm',
					}
				}
			})
			.state('menu.ovdAadhaarSplitAO', {
				url: '/ovdAadhaarSplitAO',
				data: {
					pageId: 'AO_OVD_AADHAAR_SPLIT',
					sectionId: 'ovdAadhaarSplitAOSection',
					commonId: ""
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/ovdAadhaarSplit/ovdAadhaarSplit.html',
						controller: 'ovdAadhaarSplitAOController',
						controllerAs: 'ovdAadhaarSplitAOVm',
					}
				}
			})
			.state('menu.enterOTPPageAO', {
				url: '/enterOTPPageAO',
				data: {
					pageId: 'AO_ENTR_OTP',
					sectionId: 'enterOTPPageAOSection',
					commonId: ""
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/enterOTP/enterOTP.html',
						controller: 'enterOTPPageAOController',
						controllerAs: 'enterOTPAOVm',
					}
				}
			})
			.state('menu.enterEmailOTPPageAO', {
				url: '/enterEmailOTPPageAO',
				data: {
					pageId: 'AO_EMAIL_OTP',
					sectionId: 'enterEmailOTPPageAOSection',
					commonId: ""
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/enterOTP/enterEmailOTP.html',
						controller: 'enterEmailOTPPageAOController',
						controllerAs: 'enterEmailOTPAOVm',
					}
				}
			})
			.state('menu.userLoginDetailsAO', {
				url: '/userLoginDetailsAO',
				data: {
					pageId: 'AO_ENTR_OTP',
					sectionId: 'enterOTPPageAOSection',
					commonId: ""
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/userLoginDetails/userLoginDetails.html',
						controller: 'userLoginDetailsAOController',
						controllerAs: 'userLoginDetailsAOVm',
					}
				}
			})
			.state('menu.taxDetailsAO', {
				url: '/taxDetailsAO',
				data: {
					pageId: 'AO_TAX',
					sectionId: 'taxPageAOSection',
					commonId: "FatcaDetails"
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/tax/taxDetails.html',
						controller: 'taxDetailsAOController',
						controllerAs: 'taxDetailsAOVm',
					}
				}
			})
			.state('menu.taxFatcaDetailsAO', {
				url: '/taxFatcaDetailsAO',
				data: {
					pageId: 'AO_FATCA_TAX',
					sectionId: 'taxFatcaPageAOSection',
					commonId: ""
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/tax/taxFatcaDetail.html',
						controller: 'taxFatcaDetailAOController',
						controllerAs: 'taxFatcaDetailsAOVm',
					}
				}
			})
			.state('menu.POIDetailsAO', {
				url: '/POIDetailsAO',
				data: {
					pageId: 'AO_POI',
					sectionId: 'POIDetailsPageAOSection',
					commonId: ""
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/POI/POIDetails.html',
						controller: 'POIDetailsAOController',
						controllerAs: 'POIDetailsVm',
					}
				}
			})
			.state('menu.POCADetailsAO', {
				url: '/POCADetailsAO',
				data: {
					pageId: 'AO_POCA',
					sectionId: 'POCADetailsPageAOSection',
					commonId: "proofOfAddress"
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/POI/POCADetails.html',
						controller: 'POCADetailsAOController',
						controllerAs: 'POCADetailsVm',
					}
				}
			})
			.state('menu.personalDetailsAO', {
				url: '/personalDetailsAO',
				data: {
					pageId: 'AO_PDetails',
					sectionId: 'PDetailsPageAOSection',
					commonId: ""
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/personalDetails/personalDetails.html',
						controller: 'personalDetailsAOController',
						controllerAs: 'personalDetailsAOVm',
					}
				}
			})
			.state('menu.addressNotSameAsAadhaarAO', {
				url: '/addressNotSameAsAadhaarAO',
				data: {
					pageId: 'AO_ADDRESS_NOT_SAME_AADHAAR',
					sectionId: 'addressNotSameAsAadhaarAOSection',
					commonId: ""
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/personalDetails/addressNotSameAsAadhaar.html',
						controller: 'addressNotSameAsAadhaarAOController',
						controllerAs: 'addressNotSameAsAadhaarAOVm',
					}
				}
			})
			.state('menu.aadhaarOption', {
				url: '/aadhaarOption',
				data: {
					pageId: 'AO_ADHROPTION',
					sectionId: 'adhaarOptionAOSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/personalDetails/aadhaarOption.html',
						controller: 'aadhaarOptionAOController',
						controllerAs: 'aadhaarOptionAOVm',
					}
				}
			})
			.state('menu.aadharScan', {
				url: '/aadhar',
				data: {
					pageId: 'AO_ADHRSCN',
					sectionId: 'aadharScanAOSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/personalDetails/aadharscan.html',
						controller: 'aadharscanAOController',
						controllerAs: 'aadharAOVm',
					}
				}
			})
			.state('menu.aadharScanAddress', {
				url: '/aadharScanAddress',
				data: {
					pageId: 'AO_ADHRSCNADDRESS',
					sectionId: 'aadharScanAddressAOSection',
					commonId: "currentAddress"
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/personalDetails/aadhaarAddress.html',
						controller: 'aadhaarAddressAOController',
						controllerAs: 'aadhaarAddressAOVm',
					}
				}
			})
			.state('menu.vidDetailsAO', {
				url: '/vid',
				data: {
					pageId: 'AO_VID',
					sectionId: 'vidDetailsAOSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/VID/VIDDetails.html',
						controller: 'VIDDetailsAOController',
						controllerAs: 'VIDDetailsAOVm',
					}
				}
			})
			.state('menu.vidOTP', {
				url: '/vidOTP',
				data: {
					pageId: 'AO_VIDOTP',
					sectionId: 'vidOTPAOSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/VID/vidOTP.html',
						controller: 'vidOTPPageAOController',
						controllerAs: 'vidOTPAOVm',
					}
				}
			})
			.state('menu.applicationExists', {
				url: '/applicationExists',
				data: {
					pageId: 'AO_APPEXISTS',
					sectionId: 'applicationExistsAOSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/applicationExists/applicationExists.html',
						controller: 'applicationExistsAOController',
						controllerAs: 'applicationExistsAOVm',
					}
				}
			})
			.state('menu.resemblanceWithRecords', {
				url: '/resemblanceWithRecords',
				data: {
					pageId: 'AO_RESEMBLANCEWITHRECORDS',
					sectionId: 'resemblanceWithRecordsAOSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/personalDetails/resemblance.html',
						controller: 'resemblanceAOController',
						controllerAs: 'resemblanceAOVm',
					}
				}
			})
			.state('menu.tempLoginAO', {
				url: '/tempLoginAO',
				data: {
					pageId: 'AO_tempLogin',
					sectionId: 'PDetailsPageAOSection',
					commonId: ""
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/tempLogin/tempLoginDetails.html',
						controller: 'tempLoginAOController',
						controllerAs: 'tempLoginAOVm',
					}
				}
			})
			.state('menu.currentAddressPDAO', {
				url: '/currentAddressPDAO',
				data: {
					pageId: 'AO_currentAddressPDAO',
					sectionId: 'currentAddressPDAOSection',
					commonId: "currentAddress"
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/personalDetails/currentAddressPD.html',
						controller: 'currentAddressPDAOController',
						controllerAs: 'currentAddressPDAOVm',
					}
				}
			})
			.state('menu.citizenshipDetailsAO', {
				url: '/citizenshipDetailsAO',
				data: {
					pageId: 'AO_citizenshipDetailsAO',
					sectionId: 'citizenshipDetailsAOSection',
					commonId: "personalDetails"
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/personalDetails/citizenshipDetails.html',
						controller: 'citizenshipDetailsAOController',
						controllerAs: 'citizenshipDetailsAOVm',
					}
				}
			})
			.state('menu.optionalAdditionalDetails', {
				url: '/optionalAdditionalDetails',
				data: {
					pageId: 'AO_OP_ADNLDETL',
					sectionId: 'optionalAdditionalDetails'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/additionalDetails/optionalAdditionalDetails.html',
						controller: 'optionalAdditionalDetailsController',
						controllerAs: 'optionalAdditionalDetailsAOVm',
					}
				}
			})
			.state('menu.getPictureAO', {
				url: '/getPictureAO',
				data: {
					pageId: 'AO_getPictureAO',
					sectionId: 'getPictureAOSection',
					commonId: ""
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/additionalDetails/getPicture.html',
						controller: 'getPictureAOController',
						controllerAs: 'getPictureAOVm',
					}
				}
			})
			.state('menu.takeSelfieAO', {
				url: '/takeSelfieAO',
				data: {
					pageId: 'AO_takeSelfieAO',
					sectionId: 'takeSelfieAOSection',
					commonId: ""
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/additionalDetails/takeSelfie.html',
						controller: 'takeSelfieAOController',
						controllerAs: 'takeSelfieAOVm',
					}
				}
			})
			.state('menu.looksGreatAO', {
				url: '/looksGreatAO',
				data: {
					pageId: 'AO_looksGreatAO',
					sectionId: 'looksGreatAOSection',
					commonId: "customerPhoto"
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/additionalDetails/looksGreat.html',
						controller: 'looksGreatAOController',
						controllerAs: 'looksGreatVm',
					}
				}
			})
			.state('menu.eduQualificationListDetailsAO', {
				url: '/eduQualificationListDetailsAO',
				data: {
					pageId: 'AO_eduQualificationListDetailsAO',
					sectionId: 'eduQualificationListDetailsAOSection',
					commonId: ""
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/additionalDetails/eduQualificationListDetails.html',
						controller: 'eduQualificationListDetailsAOController',
						controllerAs: 'eduQualificationListDetailsVm',
					}
				}
			})
			.state('menu.maritalStatusDetailsAO', {
				url: '/maritalStatusDetailsAO',
				data: {
					pageId: 'AO_maritalStatusDetailsAO',
					sectionId: 'maritalStatusDetailsAOSection',
					commonId: ""
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/additionalDetails/maritalStatusDetails.html',
						controller: 'maritalStatusDetailsAOController',
						controllerAs: 'maritalStatusDetailsVm',
					}
				}
			})
			.state('menu.familyDetailsAO', {
				url: '/familyDetailsAO',
				data: {
					pageId: 'AO_familyDetailsAO',
					sectionId: 'familyDetailsAOSection',
					commonId: ""
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/additionalDetails/familyDetails.html',
						controller: 'familyDetailsAOController',
						controllerAs: 'familyDetailsAOVm',
					}
				}
			})
			.state('menu.annualIncomeAO', {
				url: '/annualIncomeAO',
				data: {
					pageId: 'AO_annualIncomeAO',
					sectionId: 'annualIncomeAOSection',
					commonId: ""
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/additionalDetails/annualIncome.html',
						controller: 'annualIncomeAOController',
						controllerAs: 'annualIncomeAOVm',
					}
				}
			})
			.state('menu.occupationDetailsAO', {
				url: '/occupationDetailsAO',
				data: {
					pageId: 'AO_occupationDetailsAO',
					sectionId: 'occupationDetailsAOSection',
					commonId: "additionalDetails"
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/additionalDetails/occupationDetails.html',
						controller: 'occupationDetailsAOController',
						controllerAs: 'occupationDetailsVm',
					}
				}
			})
			.state('menu.subOccupationOthersDetailsAO', {
				url: '/subOccupationOthersDetailsAO',
				data: {
					pageId: 'AO_subOccupationOthersDetailsAO',
					sectionId: 'subOccupationOthersDetailsAOSection',
					commonId: "additionalDetails"
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/additionalDetails/subOccupationOthersDetails.html',
						controller: 'subOccupationOthersDetailsAOController',
						controllerAs: 'subOccupationOthersDetailsVm',
					}
				}
			})
			.state('menu.subOccupationBusinessDetailsAO', {
				url: '/subOccupationBusinessDetailsAO',
				data: {
					pageId: 'AO_subOccupationBusinessDetailsAO',
					sectionId: 'subOccupationBusinessDetailsAOSection',
					commonId: "additionalDetails"
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/additionalDetails/subOccupationBusinessDetails.html',
						controller: 'subOccupationOthersDetailsAOController',
						controllerAs: 'subOccupationOthersDetailsVm',
					}
				}
			}) 
			
			.state('menu.annualIncomeNew', {
				url: '/annualIncomeNew',
				data: {
					pageId: 'annualIncomeNew',
					sectionId: 'annualIncomeNew',
					commonId: "additionalDetails"
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/additionalDetails/annualIncomeNew.html',
						controller: 'subOccupationOthersDetailsAOController',
						controllerAs: 'subOccupationOthersDetailsVm',
					}
				}
			}) 
				
			.state('menu.category', {
				url: '/category',
				data: {
					pageId: 'category',
					sectionId: 'category',
					commonId: "additionalDetails"
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/additionalDetails/category.html',
						controller: 'categoryController',
						controllerAs: 'categoryDetailsVm',
					}
				}
			})
			.state('menu.subOccupationServiceDetailsAO', {
				url: '/subOccupationServiceDetailsAO',
				data: {
					pageId: 'AO_subOccupationServiceDetailsAO',
					sectionId: 'subOccupationServiceDetailsAOSection',
					commonId: "additionalDetails"
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/additionalDetails/subOccupationDetails.html',
						controller: 'subOccupationOthersDetailsAOController',
						controllerAs: 'subOccupationOthersDetailsVm',
					}
				}
			})
			.state('menu.religionDetailsAO', {
				url: '/religionDetailsAO',
				data: {
					pageId: 'AO_religionDetailsAO',
					sectionId: 'religionDetailsAOSection',
					commonId: ""
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/additionalDetails/religionDetails.html',
						controller: 'religionDetailsAOController',
						controllerAs: 'religionDetailsVm',
					}
				}
			})
			.state('menu.nomineeDetailsAO', {
				url: '/nomineeDetailsAO',
				data: {
					pageId: 'AO_nomineeDetailsAO',
					sectionId: 'nomineeDetailsAOSection',
					commonId: ""
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/nomineeDetails/nomineeDetails.html',
						controller: 'nomineeDetailsAOController',
						controllerAs: 'nomineeDetailsAOVm',
					}
				}
			})
			.state('menu.nomineeAddressDetailsAO', {
				url: '/nomineeAddressDetailsAO',
				data: {
					pageId: 'AO_nomineeAddressDetailsAO',
					sectionId: 'nomineeAddressDetailsAOSection',
					commonId: "nomineeDetails"
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/nomineeDetails/nomineeAddressDetails.html',
						controller: 'nomineeAddressDetailsAOController',
						controllerAs: 'nomineeAddressDetailsAOVm',
					}
				}
			})
			.state('menu.nomineeDetailsAddressOptionAO', {
				url: '/nomineeDetailsAddressOptionAO',
				data: {
					pageId: 'AO_nomineeDetailsAddressOptionAO',
					sectionId: 'nomineeDetailsAddressOptionAOSection',
					commonId: ""
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/nomineeDetails/nomineeDetailsAddressOption.html',
						controller: 'nomineeDetailsAddressAOOptionController',
						controllerAs: 'nomineeDetailsAddressOptionAOVm',
					}
				}
			})
			.state('menu.guardianApplicantSameAddressAO', {
				url: '/guardianApplicantSameAddressAO',
				data: {
					pageId: 'AO_guardianApplicantSameAddressAO',
					sectionId: 'guardianApplicantSameAddressAOSection',
					commonId: "guardianDetails"
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/nomineeDetails/guardianApplicantSameAddress.html',
						controller: 'guardianApplicantSameAddressAOController',
						controllerAs: 'guardianApplicantSameAddressAOVm',
					}
				}
			})
			.state('menu.nomineeGuardianSameAddressAO', {
				url: '/nomineeGuardianSameAddressAO',
				data: {
					pageId: 'AO_nomineeGuardianSameAddressAO',
					sectionId: 'nomineeGuardianSameAddressAOSection',
					commonId: "guardianDetails"
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/nomineeDetails/nomineeGuardianSameAddress.html',
						controller: 'nomineeGuardianSameAddressAOController',
						controllerAs: 'nomineeGuardianSameAddressAOVm',
					}
				}
			})

			.state('menu.nomineeEnterNewAddressAO', {
				url: '/nomineeEnterNewAddressAO',
				data: {
					pageId: 'AO_nomineeEnterNewAddressAO',
					sectionId: 'nomineeEnterNewAddressAOSection',
					commonId: "guardianDetails"
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/nomineeDetails/nomineeEnterNewAddress.html',
						controller: 'nomineeEnterNewAddressAOController',
						controllerAs: 'nomineeEnterNewAddressAOVm',
					}
				}
			})

			.state('menu.chequeBookServiceDetailsAO', {
				url: '/chequeBookServiceDetailsAO',
				data: {
					pageId: 'AO_chequeBookServiceDetails',
					sectionId: 'chequeBookServiceDetailsAOSection',
					commonId: "servicesRequired"
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/chequeBookService/chequeBookServiceDetails.html',
						controller: 'chequeBookServiceDetailsAOController',
						controllerAs: 'chequeBookServiceDetailsVm',
					}
				}
			})
			.state('menu.personalisedKitAO', {
				url: '/personalisedKitAO',
				data: {
					pageId: 'AO_personalisedKit',
					sectionId: 'personalisedKitAOSection',
					commonId: "personalisedKit"
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/chequeBookService/personalisedKitDetails.html',
						controller: 'personalisedKitDetailsAOController',
						controllerAs: 'personalisedKitDetailsAOVm',
					}
				}
			})
			.state('menu.termsAndConditionsAO', {
				url: '/termsAndConditionsAO',
				data: {
					pageId: 'AO_termsAndConditions',
					sectionId: 'termsAndConditionsAOSection',
					commonId: "customerTnC"
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/termsAndConditions/termsAndConditions.html',
						controller: 'termsAndConditionsAOController',
						controllerAs: 'termsAndConditionsAOVm',
					}
				}
			})
			.state('menu.productOfferingAO', {
				url: '/productOfferingAO',
				data: {
					pageId: 'AO_productOffering',
					sectionId: 'productOfferingAOSection',
					commonId: "productOffer"
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/productOffering/productOffering.html',
						controller: 'productOfferingAOController',
						controllerAs: 'productOfferingAOVm',
					}
				}
			})
			.state('menu.enterOTPProductOfferingAO', {
				url: '/enterOTPProductOfferingAO',
				data: {
					pageId: 'AO_ENTRPRODOFF_OTP',
					sectionId: 'enterOTPProductOfferingAOSection',
					commonId: "RefNumber"
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/enterOTP/enterOTPProdOffering.html',
						controller: 'enterOTPProductOfferingAOController',
						controllerAs: 'enterOTPProductOfferingAOVm',
					}
				}
			})
			.state('menu.enterOTPReferenceCodeAO', {
				url: '/enterOTPReferenceCodeAO',
				data: {
					pageId: 'AO_ENTROTPREFCOD',
					sectionId: 'aoReferenceCodeAOSection'
				},
				//cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/enterOTPReferenceCode/enterOTPReferenceCode.html',
						controller: 'enterOTPReferenceCodeAOController',
						controllerAs: 'enterOTPReferenceCodeAOVm',
					}
				}
			})
			.state('menu.appPasswordAO', {
				url: '/appPasswordAO',
				data: {
					pageId: 'AO_APPPWD',
					sectionId: 'aoPasswordSection',
					commonId: ''
				},
				//cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/appPassword/appPassword.html',
						controller: 'appPasswordAOController',
						controllerAs: 'appPasswordAOVm',
					}
				}
			})
			.state('menu.refPageAO', {
				url: '/refPageAO',
				data: {
					pageId: 'AO_REF',
					sectionId: 'refPageAOSection',
					commonId: "RefNumber"
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/enterOTPReferenceCode/enterOTPReferenceCode.html',
						controller: 'enterOTPReferenceCodeAOController',
						controllerAs: 'enterOTPReferenceCodeAOVm',
					}
				}
			})
			.state('menu.locateNearestBranchAO', {
				url: '/locateNearestBranchAO',
				data: {
					pageId: 'AO_LOCNEARBRCH',
					sectionId: 'aoLocateNearestBranchSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/locateNearestBranch/locateNearestBranch.html',
						controller: 'locateNearestBranchAOController',
						controllerAs: 'locateNearestBranchAOVm',
					}
				}
			})
			.state('menu.locateBranchByGpsAO', {
				url: '/locateBranchByGpsAO',
				data: {
					pageId: 'AO_LOCNEARBRCHBYGPS',
					sectionId: 'aoLocateNearestBranchSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/locateNearestBranch/locateBranchByGps.html',
						controller: 'locateBranchByGpsAOController',
						controllerAs: 'locateBranchGpsAOVm',
					}
				}
			})
			.state('menu.locateBranchByLocalityAO', {
				url: '/locateBranchByLocalityAO',
				data: {
					pageId: 'AO_LOCNEARBRCH',
					sectionId: 'aoLocateNearestBranchSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/locateNearestBranch/locateBranchByLocality.html',
						controller: 'locateBranchByLocalityAOController',
						controllerAs: 'locateBranchLocAOVm',
					}
				}
			})
			.state('menu.resumeAccountEnterOTPAO', {
				url: '/resumeAccountEnterOTPAO',
				data: {
					pageId: 'AO_RSMACCOTP',
					sectionId: 'resumeAccountEnterOTPAOSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/enterOTP/enterResumeAccountOTP.html',
						controller: 'enterOTPResumeAccountAOController',
						controllerAs: 'enterOTPResumeAccountAOVm',
					}
				}
			})
			.state('menu.multipleCustomerAO', {
				url: '/multipleCustomerAO',
				data: {
					pageId: 'AO_MLTPLECUST',
					sectionId: 'multipleCustomerAOSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/multipleCustomer/multipleCustomer.html',
						controller: 'multipleCustomerAOController',
						controllerAs: 'multipleCustomerAOVm',
					}
				}
			})
			.state('menu.employerDetails', {
				url: '/employerDetails',
				data: {
					pageId: 'AO_EMPDET',
					sectionId: 'employerDetailAOSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOpening/employerDetails/employerDetails.html',
						controller: 'employerDetailsController',
						controllerAs: 'employerDetailsVm',
					}
				}
			})
	}]);
