'use strict';

angularApp.controller('appPasswordAOController', ["$state",
    "$scope",
    "accountOpeningHomeService",
    "utilityService",
    "appPasswordServiceAO",
    "$ionicPopover",
    "$cordovaDevice",
    "cryptoService",
    "encryptionService",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "instaService",
    "userLoginDetailsService",
    "chequeBookServiceDetailsService",
    function($state,
        $scope,
        accountOpeningHomeService,
        utilityService,
        appPasswordServiceAO,
        $ionicPopover,
        $cordovaDevice,
        cryptoService,
        encryptionService,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService,
        instaService,
        userLoginDetailsService,
        chequeBookServiceDetailsService) {

        var appPasswordAOVm = this;

        function initPage() {
            appPasswordAOVm.showBack = true;
            appPasswordAOVm.showNext = true;
            appPasswordAOVm.reAppPasswordCheck = false;
            appPasswordAOVm.disableNext = true;
            appPasswordAOVm.aofooter = true;
            //To get the device Operating system
            var deviceOs = $cordovaDevice.getPlatform();
            var deviceUid = $cordovaDevice.getUUID();
            accountOpeningHomeService.customer.deviceOS = deviceOs;
            accountOpeningHomeService.customer.deviceUid = deviceUid;
            appPasswordAOVm.encoded = '';
            appPasswordAOVm.securityQuestions = [];
            appPasswordAOVm.loadSecurityQuestion();
        }

        /* Info Popup */
        var template = '<ion-popover-view class="ao-tooltip ao-popupInfo roboto-regular ao-passwordHt">' + '<ion-content>' +
                        '<div class="" translate="APP_NOTIFICATION"></div>' + '</ion-content>' + '</ion-popover-view>';

        $scope.popover = $ionicPopover.fromTemplate(template, {
            scope: $scope
        });

        appPasswordAOVm.infoPopup = function($event) {
            $scope.popover.show($event);
        };

        appPasswordAOVm.closePopover = function() {
            $scope.popover.hide();
        };
       /* Info Popup */

        appPasswordAOVm.goBacktoPrevious = function() {
            

            $state.go('menu.citizenshipDetailsAO');	
        }

        appPasswordAOVm.goToNextPage = function() {

            //$state.go('menu.currentAddressPDAO');	

            // var hashedAppPassword = cryptoService.getSHA512EncryptedData(appPasswordAOVm.appPasswordData);
            // appPasswordAOVm.encoded = encryptionService.getAES256EncryptedData(hashedAppPassword);




            appPasswordAOVm.encoded = appPasswordAOVm.appPasswordData;
            accountOpeningHomeService.appPassword = appPasswordAOVm.encoded;
            var requestParams = {
                "id": userLoginDetailsService.mobile,
		        "commonId":$state.$current.data.commonId,
                "data": {
                    "auth" : {
                        "password" :appPasswordAOVm.encoded
                    },
                    "deviceInfo": {
                        "deviceIMEI" : accountOpeningHomeService.customer.deviceUid,
                        "deviceOS" : accountOpeningHomeService.customer.deviceOS
                    },
                    "personalDetails": {
                        "emailId" : accountOpeningHomeService.customer.emailId,
                        "mobileNumber" : userLoginDetailsService.mobile,
                        "custMobNo" : userLoginDetailsService.mobile
                    }
                }
            }
            appPasswordServiceAO.registerCustomer(requestParams).then(function(response) {
                accountOpeningHomeService.customer.lotusId = utilityService.getValue(response.data.lotusId);
                var responseCode = response.responseCode;
                if (responseCode === constantConfig.successCode) {
                	chequeBookServiceDetailsService.isPasswordSet = true;
                    $state.go('menu.currentAddressPDAO');
                }

            }, function(error) {
               utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.goToHome = function() {
            accountOpeningHomeService.homeNav();
        }

        appPasswordAOVm.changePassword = function() {
            if (appPasswordAOVm.reAppPasswordData !== appPasswordAOVm.appPasswordData) {
                appPasswordAOVm.reAppPasswordData = "";
                appPasswordAOVm.reAppPasswordCheck = true;
                appPasswordAOVm.disableNext = true;
                return true;
            }
            appPasswordAOVm.reAppPasswordCheck = false;
            return true;
        }

       appPasswordAOVm.loadSecurityQuestion = function(){
       	// if(instaService.setSecurityQuestion.length == 0){
        // 	appPasswordAOVm.isErorr = false;
		// utilityService.showSpinner();
        //     appPasswordServiceAO.loadSecurityQuestions().then(function(response) {
        //        utilityService.hideSpinner()
	    //    appPasswordAOVm.isErorr = false;
        //         appPasswordAOVm.securityQuestions = response.data.masterDetails;
        //     }, function(error) {
	    //    utilityService.hideSpinner()
        //        appPasswordAOVm.isErorr = true;
        //        utilityService.showErrorMessage(error.responseMessage);
        //     });
        //     }else{
        //     	appPasswordAOVm.securityQuestions = instaService.setSecurityQuestion;
        //     }
        }

        appPasswordAOVm.changeCPassword = function() {
            if (appPasswordAOVm.reAppPasswordData !== appPasswordAOVm.appPasswordData) {
                appPasswordAOVm.reAppPasswordCheck = false;
            }
            return true;
        }

        appPasswordAOVm.proceedSuccess = function(isValid) {
           isValid ? appPasswordAOVm.disableNext = false : appPasswordAOVm.disableNext = true;
            return appPasswordAOVm.disableNext;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
