'use strict';

angularApp.controller('chequeBookServiceDetailsAOController', ["$state",
    "$scope",
    "accountOpeningHomeService",
    "utilityService",
    "chequeBookServiceDetailsService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "userLoginDetailsService",
    "nomineeDetailsAOService",
    "enterOTPAOService",
    "$ionicPopover",
    "constantConfig",
    function($state,
        $scope,
        accountOpeningHomeService,
        utilityService,
        chequeBookServiceDetailsService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        userLoginDetailsService,
        nomineeDetailsAOService,
        enterOTPAOService,
        $ionicPopover,
        constantConfig) {

        var chequeBookServiceDetailsVm = this;

        function initPage() {
            chequeBookServiceDetailsVm.showBack = true;
            chequeBookServiceDetailsVm.showNext = true;
            chequeBookServiceDetailsVm.disableNext = true;
            chequeBookServiceDetailsVm.aofooter = true;
            chequeBookServiceDetailsVm.selectedMethodSMS = "";
            chequeBookServiceDetailsVm.selectedMethodCBook = "";
        }

        chequeBookServiceDetailsVm.goBacktoPrevious = function() {
		if (parseInt(nomineeDetailsAOService.nominee.age) > 18) {
			$state.go("menu.nomineeAddressDetailsAO");
		} else if (nomineeDetailsAOService.guardian.guardianAddressFlag == "nomineeAddress") {
			$state.go("menu.nomineeGuardianSameAddressAO");
		} else if (nomineeDetailsAOService.guardian.guardianAddressFlag == "applicantAddress") {
			$state.go("menu.guardianApplicantSameAddressAO");
		} else if (nomineeDetailsAOService.guardian.guardianAddressFlag == "newAddress") {
			$state.go("menu.nomineeEnterNewAddressAO");
		}
        }

        chequeBookServiceDetailsVm.goToNextPage = function() {
        	
        	chequeBookServiceDetailsService.CBPage.selectedMethodCBook = chequeBookServiceDetailsVm.selectedMethodCBook;
        	chequeBookServiceDetailsService.CBPage.selectedMethodSMS = chequeBookServiceDetailsVm.selectedMethodSMS;
        	chequeBookServiceDetailsService.CBPage.bankingRights = chequeBookServiceDetailsVm.bankingRights;
        	//chequeBookServiceDetailsService.CBPage.selectedMethodCBook = ; 
        	
        	 var requestParams = {
        	 	"id": userLoginDetailsService.mobile,
				  "type": "AO",
				  "data": {
				    "services": {
				      "debitCard": true,//
				      "ib": true,
				      "chequeB": chequeBookServiceDetailsVm.selectedMethodCBook,
				      "emailStatFreq": "string",
				      "smsAlert": chequeBookServiceDetailsVm.selectedMethodSMS
				    },
				     "commonId":$state.$current.data.commonId
				}  
        	 };
        	  chequeBookServiceDetailsService.saveBankingRights(requestParams).then(function(response) {    
               	$state.go("menu.personalisedKitAO");                             
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.goToHome = function() {
            accountOpeningHomeService.homeNav();
        }

         /* Info Popup */
         var template = '<ion-popover-view class="tooltiptext ao-long-popupInfo-service roboto-regular">' + '<ion-content>' +
         '<div class="text-left" ng-bind-html="chequeBookServiceDetailsVm.getInfoMsg"></div>' + '</ion-content>' + '</ion-popover-view>';

     $scope.popover = $ionicPopover.fromTemplate(template, {
         scope: $scope
     });


        chequeBookServiceDetailsVm.infoPopupRights = function($event) {
            chequeBookServiceDetailsVm.getInfoMsg = "(a) View rights - In view rights you will be able to only view the account information and do no transaction. <br>(b) Limited transaction rights - In Limited Transaction Rights, you can transfer funds within your own accounts opened under the same CIF, can create e-TDR/e-STDR/e-RD. <br>(c) Full Transaction Rights -In Full Transaction Rights, you can avail all the facilities such as third party transfer, interbank transfer, bills payment etc.";
            $scope.popover.show($event); 
                
       };

        chequeBookServiceDetailsVm.validateForm = function(isValid) {
            chequeBookServiceDetailsVm.disableNext = !isValid;
        }

        chequeBookServiceDetailsVm.clickValidationSMS = function(value){
         
            if(value === "Yes"){
                chequeBookServiceDetailsVm.selectedMethodSMS = true; 
            }
            else{
                chequeBookServiceDetailsVm.selectedMethodSMS = false;
            }        
        }
        
        chequeBookServiceDetailsVm.clickValidationCBook = function(value){
         
            if(value === "Yes"){
                chequeBookServiceDetailsVm.selectedMethodCBook = true; 
            }
            else{
                chequeBookServiceDetailsVm.selectedMethodCBook = false;
            }        
        }

		chequeBookServiceDetailsVm.getbankingRights = function(names) {
			var requestParams = "INBrights"
            chequeBookServiceDetailsService.getbankingRights(requestParams).then(function(response) {    
                chequeBookServiceDetailsService.bankingRightsData = response.data;
                chequeBookServiceDetailsVm.bankingRightsList = response.data;
                if (enterOTPAOService.isResumeJourney == true) {
                chequeBookServiceDetailsVm.bankingRights = chequeBookServiceDetailsService.CBPage.bankingRights;
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
        chequeBookServiceDetailsVm.populateResumeData = function(names) {
			 if (enterOTPAOService.isResumeJourney == true || chequeBookServiceDetailsService.CBPage.selectedMethodSMS) {
			 chequeBookServiceDetailsVm.selectedMethodCBook = Boolean(chequeBookServiceDetailsService.CBPage.selectedMethodCBook);
        	chequeBookServiceDetailsVm.selectedMethodSMS = Boolean(chequeBookServiceDetailsService.CBPage.selectedMethodSMS);
        	chequeBookServiceDetailsVm.bankingRights = chequeBookServiceDetailsService.CBPage.bankingRights;
        	
        	if(chequeBookServiceDetailsVm.selectedMethodSMS == true){
                chequeBookServiceDetailsVm.receiveSMS = "receiveSMSYes";
                chequeBookServiceDetailsVm.selectedMethodSMS = true; 
            }
            else if (chequeBookServiceDetailsVm.selectedMethodSMS == false){
            	chequeBookServiceDetailsVm.receiveSMS = "receiveSMSNo";
                chequeBookServiceDetailsVm.selectedMethodSMS = false;
            }        
        
     
            if(chequeBookServiceDetailsVm.selectedMethodCBook == true){
            	chequeBookServiceDetailsVm.CBook = "CBookYes";
                chequeBookServiceDetailsVm.selectedMethodCBook = true; 
            }
            else if(chequeBookServiceDetailsVm.selectedMethodCBook == false){
            	chequeBookServiceDetailsVm.CBook = "CBookNo";
                chequeBookServiceDetailsVm.selectedMethodCBook = false;
            }      
        
        } 
        }
       
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            if(enterOTPAOService.isResumeJourney == false){
                chequeBookServiceDetailsVm.journeyType = accountOpeningHomeService.journeyType;
            }else{
                chequeBookServiceDetailsVm.journeyType = enterOTPAOService.taxPage.journeyType;
            }

            if(!chequeBookServiceDetailsService.CBPage){
            	chequeBookServiceDetailsService.CBPage ={};
            }
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            if(!chequeBookServiceDetailsService.bankingRightsData){
            		chequeBookServiceDetailsVm.getbankingRights();	
            }else{
            	chequeBookServiceDetailsVm.bankingRightsList = chequeBookServiceDetailsService.bankingRightsData;
            	 if (chequeBookServiceDetailsService.CBPage.bankingRights) {
                chequeBookServiceDetailsVm.bankingRights = chequeBookServiceDetailsService.CBPage.bankingRights;
                }
            }
            chequeBookServiceDetailsVm.populateResumeData();

            if(chequeBookServiceDetailsVm.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar){
                chequeBookServiceDetailsVm.selectedMethodCBook = true; 
                chequeBookServiceDetailsVm.hideCheckbook = false;
            }else{
                chequeBookServiceDetailsVm.hideCheckbook = true;
            }
        });

        return this;
    }
]);
