'use strict';

angularApp.controller('personalisedKitDetailsAOController', ["$state",
    "$scope",
    "accountOpeningHomeService",
    "utilityService",
    "chequeBookServiceDetailsService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "userLoginDetailsService",
    "citizenshipDetailsAOService",
    "enterOTPAOService",
    function($state,
        $scope,
        accountOpeningHomeService,
        utilityService,
        chequeBookServiceDetailsService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        userLoginDetailsService,
        citizenshipDetailsAOService,
        enterOTPAOService) {

        var personalisedKitDetailsAOVm = this;

        function initPage() {
            personalisedKitDetailsAOVm.showBack = true;
            personalisedKitDetailsAOVm.showNext = true;
            personalisedKitDetailsAOVm.disableNext = true;
            personalisedKitDetailsAOVm.aofooter = true;
            personalisedKitDetailsAOVm.selectedMethod = "";
        }

        personalisedKitDetailsAOVm.goBacktoPrevious = function() {
            $state.go("menu.chequeBookServiceDetailsAO");     
        }

        personalisedKitDetailsAOVm.goToNextPage = function() {
            personalisedKitDetailsAOVm.receiveDebitCardDetails();                
        }

        $scope.goToHome = function() {
            accountOpeningHomeService.homeNav();
        }

        personalisedKitDetailsAOVm.validateForm = function(isValid) {
            personalisedKitDetailsAOVm.disableNext = !isValid;
        }

        personalisedKitDetailsAOVm.selectCities = function() {
            $state.go('');
        }

        personalisedKitDetailsAOVm.receiveDebitCardDetails = function(){ 
             var arr = [{
             	"name" : personalisedKitDetailsAOVm.fatherFname
             }];
			var cardVariantList = document.getElementById("cardVariant");
			var cardVariantSelValue = cardVariantList.options[cardVariantList.selectedIndex].text;
			
			 chequeBookServiceDetailsService.CBPage.cardType = personalisedKitDetailsAOVm.cardType  ;
             chequeBookServiceDetailsService.CBPage.cardVariant = cardVariantSelValue;
             chequeBookServiceDetailsService.CBPage.name = personalisedKitDetailsAOVm.fatherFname;
             chequeBookServiceDetailsService.CBPage.cardVariantCode = personalisedKitDetailsAOVm.cardVariant;
			
            var requestParams = {
                "id": userLoginDetailsService.mobile,
                "type": "AO",
                "data": {
                  "kit": [
                    {
                      "type": "personalizedKit",
                      "cardType": personalisedKitDetailsAOVm.cardType,
                      "cardVariant": cardVariantSelValue,
                      "name": personalisedKitDetailsAOVm.fatherFname,
                      "inbRights": chequeBookServiceDetailsService.CBPage.bankingRights,
                      "cardVariantCode": personalisedKitDetailsAOVm.cardVariant
                    }
                  ],
                  "commonId": $state.$current.data.commonId
                }
              }
            
            chequeBookServiceDetailsService.receiveDebitCard(requestParams).then(function(response) {  
                $state.go("menu.termsAndConditionsAO");     
                //personalisedKitDetailsAOVm.getReferenceNumber();
                //$state.go('');            
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }


        personalisedKitDetailsAOVm.clickValidation = function(value){
         
            if(value == "corres"){
                personalisedKitDetailsAOVm.selectedMethod = "correspondance"; 
            }
            else{
                personalisedKitDetailsAOVm.selectedMethod = "Intouch";
            }        
        }

        personalisedKitDetailsAOVm.getReferenceNumber = function(){
            var requestParams = {
                "id" : userLoginDetailsService.mobile,                
                "data":{
                    "commonId":$state.$current.data.commonId
                }
            }
  
            chequeBookServiceDetailsService.getReferenceNo(requestParams).then(function(response) {
                //personalisedKitDetailsAOVm.receiveDebitCardDetails();
                accountOpeningHomeService.customer.referenceCode = utilityService.getValue(response.data.referenceCode);
                
                personalisedKitDetailsAOVm.refEmailSms();
                $state.go('menu.enterOTPReferenceCodeAO');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        personalisedKitDetailsAOVm.refEmailSms = function(){
            var requestParams = {
                "id":userLoginDetailsService.mobile,
                "receipientMailId":accountOpeningHomeService.customer.emailId,
                "referenceCode":accountOpeningHomeService.customer.referenceCode
            }
            
            chequeBookServiceDetailsService.sendRefEmailAndSms(requestParams).then(function(response) {
                         
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        personalisedKitDetailsAOVm.updateName = function() {
            if (accountOpeningHomeService.isResumeJourney == false) {
                if (!utilityService.isUndefined(citizenshipDetailsAOService.customerManualEntryDetails.firstName) && !utilityService.isUndefined(citizenshipDetailsAOService.customerManualEntryDetails.lastName)) {
                    personalisedKitDetailsAOVm.fatherFname = citizenshipDetailsAOService.customerManualEntryDetails.firstName + " " + citizenshipDetailsAOService.customerManualEntryDetails.lastName;
                    personalisedKitDetailsAOVm.fatherLname = "";

                } else if (!utilityService.isUndefined(accountOpeningHomeService.customerAadhaarCardDetails.name)) {
                    personalisedKitDetailsAOVm.splitDebitName(accountOpeningHomeService.customerAadhaarCardDetails.name);
                }
            } else if (accountOpeningHomeService.isResumeJourney == true) {
                if (!utilityService.isUndefined(accountOpeningHomeService.debitCardDetails.firstName) && !utilityService.isUndefined(accountOpeningHomeService.debitCardDetails.lastName)) {
                    personalisedKitDetailsAOVm.fatherFname = accountOpeningHomeService.debitCardDetails.firstName + " " + accountOpeningHomeService.debitCardDetails.lastName;
                    personalisedKitDetailsAOVm.fatherLname = "";
                } else if (!utilityService.isUndefined(citizenshipDetailsAOService.customerManualEntryDetails.firstName) && !utilityService.isUndefined(citizenshipDetailsAOService.customerManualEntryDetails.lastName)) {
                    personalisedKitDetailsAOVm.fatherFname = citizenshipDetailsAOService.customerManualEntryDetails.firstName + " " + citizenshipDetailsAOService.customerManualEntryDetails.lastName;
                    personalisedKitDetailsAOVm.fatherLname = "";
                } else if (!utilityService.isUndefined(accountOpeningHomeService.customerAadhaarCardDetails.name)) {
                    personalisedKitDetailsAOVm.splitDebitName(accountOpeningHomeService.customerAadhaarCardDetails.name);
                }
                personalisedKitDetailsAOVm.selectedMethod = accountOpeningHomeService.cardReadyForCollection;
                
            }
        }

        personalisedKitDetailsAOVm.splitDebitName = function(names) {
            var cname = names;
            var res = cname.split(" ");
            var firstname = "";
            var lastname = res[res.length - 1];
            for (var i = 0; i < res.length - 1; i++) {
                firstname += res[i] + " ";
            }
			/* personalisedKitDetailsAOVm.fatherFname = firstname.trim();
            personalisedKitDetailsAOVm.fatherLname = lastname.trim(); */
			personalisedKitDetailsAOVm.fatherFname = firstname.trim() + " " + lastname.trim();
            personalisedKitDetailsAOVm.fatherLname = "";
        }
        
        personalisedKitDetailsAOVm.getCardtype = function(names) {
			var requestParams = "cardtype"
            chequeBookServiceDetailsService.getCardtype(requestParams).then(function(response) {    
                chequeBookServiceDetailsService.cardTypeData = response.data;
                personalisedKitDetailsAOVm.cardTypeList = response.data;
                if (enterOTPAOService.isResumeJourney == true) {
                      personalisedKitDetailsAOVm.cardType = chequeBookServiceDetailsService.CBPage.cardType;
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
        personalisedKitDetailsAOVm.cardTypeupdate = function(names) {
        	var response = personalisedKitDetailsAOVm.getCardVariantOVDrRsponse;
        	if(!personalisedKitDetailsAOVm.getCardVariantOVD){
        		personalisedKitDetailsAOVm.getCardVariantOVD();	
        	}
        	for (var i=0; i < response.cardVarient.length; i++) {
        		    
				    if(response.cardVarient[i].cardType == personalisedKitDetailsAOVm.cardType ||
				    	response.cardVarient[i].cardType == chequeBookServiceDetailsService.CBPage.cardType
				    	){
				  	   chequeBookServiceDetailsService.cardVariantData = response.cardVarient[i].value;
					   personalisedKitDetailsAOVm.cardVariantList  = response.cardVarient[i].value; 	
				  }
				};
        };
        personalisedKitDetailsAOVm.getCardVariantOVD = function(names) {
			var requestParams = "";
            chequeBookServiceDetailsService.getCardVariantOVD(requestParams).then(function(response) {
            	personalisedKitDetailsAOVm.getCardVariantOVDrRsponse = response;
            	for (var i=0; i < response.cardVarient.length; i++) {
				    if(response.cardVarient[i].cardType == personalisedKitDetailsAOVm.cardType ||
				    	response.cardVarient[i].cardType == chequeBookServiceDetailsService.CBPage.cardType
				    	){
				  	   chequeBookServiceDetailsService.cardVariantData = response.cardVarient[i].value;
					   personalisedKitDetailsAOVm.cardVariantList  = response.cardVarient[i].value; 	
				  }
				};
            	if (enterOTPAOService.isResumeJourney == true) {
                	  personalisedKitDetailsAOVm.cardVariant = chequeBookServiceDetailsService.CBPage.cardVariantCode
				}	
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
		personalisedKitDetailsAOVm.populateResumeData = function(names) {
			if (enterOTPAOService.isResumeJourney == true) {
				      if(!personalisedKitDetailsAOVm.cardVariant){
				      	personalisedKitDetailsAOVm.cardVariant = {};
				      }
                      personalisedKitDetailsAOVm.cardType = chequeBookServiceDetailsService.CBPage.cardType;
                      //personalisedKitDetailsAOVm.cardVariant = chequeBookServiceDetailsService.CBPage.cardVariant;
                      personalisedKitDetailsAOVm.fatherFname = chequeBookServiceDetailsService.CBPage.name;
                      personalisedKitDetailsAOVm.cardVariant = chequeBookServiceDetailsService.CBPage.cardVariantCode;
			}
		};
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
            personalisedKitDetailsAOVm.updateName();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            if(!chequeBookServiceDetailsService.CBPage){
            	chequeBookServiceDetailsService.CBPage = {};
            }
            if(!chequeBookServiceDetailsService.cardTypeData ){
            	personalisedKitDetailsAOVm.getCardtype();
            }else{
            	personalisedKitDetailsAOVm.cardTypeList = chequeBookServiceDetailsService.cardTypeData;
            	if (chequeBookServiceDetailsService.CBPage.cardType) {
                      personalisedKitDetailsAOVm.cardType = chequeBookServiceDetailsService.CBPage.cardType;
                }
            }
            if(!chequeBookServiceDetailsService.cardVariantData ){
            	personalisedKitDetailsAOVm.getCardVariantOVD();
            }else{
            	 personalisedKitDetailsAOVm.cardVariantList = chequeBookServiceDetailsService.cardVariantData;
				 if (chequeBookServiceDetailsService.CBPage.cardVariantCode) {
                	  personalisedKitDetailsAOVm.cardVariant = chequeBookServiceDetailsService.CBPage.cardVariantCode;
				}		
            }
            personalisedKitDetailsAOVm.populateResumeData();
            
            if(!personalisedKitDetailsAOVm.fatherFname 
            	 && !chequeBookServiceDetailsService.CBPage.name){
            	  personalisedKitDetailsAOVm.fatherFname = citizenshipDetailsAOService.customerManualEntryDetails.fullName ? citizenshipDetailsAOService.customerManualEntryDetails.fullName: 
            	  citizenshipDetailsAOService.customerManualEntryDetails.firstName+ " "+ 
            	  citizenshipDetailsAOService.customerManualEntryDetails.middleName+ " "+
            	  citizenshipDetailsAOService.customerManualEntryDetails.lastName;
            }
        });

        return this;
    }
]);
