'use strict';
angularApp.service('employerDetailsService', 
    function($q, AdapterUtils, constantConfig, $ionicPopup, $state, $ionicScrollDelegate, utilityService) {
	var employerDetailsService = this;
	employerDetailsService.employerNotListed = true;

     

        employerDetailsService.registerCustomer = function (payload) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/InstaAccountOpeningAdapter/registerCustomer", payload, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

        employerDetailsService.getEmployerList = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/InstaAccountOpeningAdapter/getEmployerList", {}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
     

        employerDetailsService.showAlertPopup = function (imageType, message1, message2, onTapgo, buttontext1, buttontext2, $scope, obj) {
            var btn_array = [];
            if (buttontext1 != "" && buttontext2 != "") {
                btn_array = [
                    {
                        text: buttontext2 || "Cancel",
                        type: 'button-negative',
                        onTap: function () {
                            obj.addressChangeFlag = false;
                            obj.resiAddressFlag = "";
                        }
                    },
                    {
                        text: buttontext1 || "OK",
                        type: 'button-positive',
                        onTap: function () {
                        }
                    }
                ];
            }
            else {
                btn_array = [
                    {
                        text: buttontext1 || "OK",
                        type: 'button-positive',
                        onTap: function () {
                            if (onTapgo) {
                                $state.go(onTapgo);
                            }
                        }
                    }
                ];
            }

           if (imageType && imageType.toLowerCase() == 'error') {
                imageType = '<div><img class="approvedIconPosition" src="img/FT/BhimUpi/errorSymbol.svg"/></div>';
            } else if (imageType && imageType.toLowerCase() == 'success') {
                imageType = '<div><img class="approvedIconPosition" src="img/FT/BhimUpi/successSymbol.svg"/></div>';
            } else if (imageType && imageType.toLowerCase() == 'alert') {
                imageType = '<div><img class="approvedIconPosition" src="img/FT/BhimUpi/alertSymbol.svg"/></div>';
            } else {
                imageType = "";
            }
            var bhimErrorPopup = $ionicPopup.alert({
                template: '<div class="font-dark-grey ao-corroPopup">' + '<div class="roboto-regular trans-popup fontSize-title errorColor">'+imageType+'</div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter roboto-medium font-size-16 color-darkgrey"><span>'
                    + message1 + '</span><div ng-if="message2" class="textAlignCenter roboto-regular font-size-14 color-darkgrey padTop10">' + message2 + '</div></div></div></div>', //template,
                scope: $scope,
                cssClass: 'bhim-alert-popup',
                buttons: btn_array,
            });
            bhimErrorPopup.then(function (res) {
            });
			console.log(imageType);
        };

	
   return employerDetailsService;
}); 