'use strict';

angularApp.controller('enterEmailOTPPageAOController', ["$state",
    "$scope",
    "$translate",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "customerInfoService",
    // "autoOtpReadService",
    "enterOTPAOService",
    "userLoginDetailsService",
    "loggedInUserService",
    "cryptoService",
    "encryptionService",
	"AdapterUtils",
	"accountOpeningHomeService",
    function($state,
        $scope,
        $translate,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        customerInfoService,
        // autoOtpReadService,
        enterOTPAOService,
        userLoginDetailsService,
        loggedInUserService,
        cryptoService,
        encryptionService,
		AdapterUtils,
		accountOpeningHomeService) {

        var enterEmailOTPAOVm = this;

  		enterEmailOTPAOVm.isChallenged = false;
        enterEmailOTPAOVm.securityCheckName = "AOSecurityCheck";
        enterEmailOTPAOVm.aoAuthChallengeHandler = WL.Client.createSecurityCheckChallengeHandler(enterEmailOTPAOVm.securityCheckName);
        enterEmailOTPAOVm.aoAuthChallengeHandler.securityCheckName = enterEmailOTPAOVm.securityCheckName;


        function initPage() {
            enterEmailOTPAOVm.showBack = true;
            enterEmailOTPAOVm.showNext = true;
            enterEmailOTPAOVm.showOtpView = true;
            enterEmailOTPAOVm.otpvalue = "";
            enterEmailOTPAOVm.disableNext = true;
            enterEmailOTPAOVm.aofooter = true;
            //enterEmailOTPAOVm.requestOtpCall();
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                enterEmailOTPAOVm.okBtntext = translatedvalue;  
            });
            
        }

        enterEmailOTPAOVm.goBacktoPrevious = function() {
        	$state.go('menu.userLoginDetailsAO');
        }

        $scope.goToHome = function() {
			accountOpeningHomeService.homeNav();
            
        }

        enterEmailOTPAOVm.validateOTP = function(isValid) {
            enterEmailOTPAOVm.disableNext = !isValid;
        }

		enterEmailOTPAOVm.invokeGetOTPService = function () {
		            var requestParams = {
		                "id": userLoginDetailsService.mobile,
						"recipientMailId":  userLoginDetailsService.emailId ? userLoginDetailsService.emailId : "",
						"sendOTPFlg": "both" 
		            }
		            enterOTPAOService.getOtp(requestParams).then(function (response) {
		             
		                //customer.otpNo = utilityService.getValue(response.data.otp);
		                var title = '';
		                var template = '{{"OTP_SENT_SUCCESS" | translate}}';
		                var onTap = '';
		                var buttontext = '<b>' + enterEmailOTPAOVm.okBtntext + '</b>';
						//utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
						

		                // if (utilityService.isAndroidPlatform()) {
						// 		autoOtpReadService.startOtpReading().then(function(result) {
						// 			enterEmailOTPAOVm.getOTPNumber = result;
						// 			enterEmailOTPAOVm.disableNext = false;
						// 		}, function(error) {
						// 		}, function(watchStatus) {
						// 		});
						// 	}



		            }, function (error) {
		                utilityService.showErrorMessage(error.responseMessage);
		            });
				}
				
				/* resend OTP */
				
				enterEmailOTPAOVm.requestOtpCallOnce = function() {
					enterEmailOTPAOVm.resendOtp();
				};

				enterEmailOTPAOVm.resendOtp = function () {
		            var requestParams = {
		                "id": userLoginDetailsService.mobile,
						"recipientMailId":  userLoginDetailsService.emailId ? userLoginDetailsService.emailId : "",
						"sendOTPFlg": "mobileOnly" 
		            }
		            enterOTPAOService.getOtp(requestParams).then(function (response) {
		             
		                //.customer.otpNo = utilityService.getValue(response.data.otp);
		                var title = '';
		                var template = '{{"OTP_SENT_SUCCESS" | translate}}';
		                var onTap = '';
		                var buttontext = '<b>' + enterEmailOTPAOVm.okBtntext + '</b>';
						//utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
						


		                // if (utilityService.isAndroidPlatform()) {
						// 		autoOtpReadService.startOtpReading().then(function(result) {
						// 			enterEmailOTPAOVm.getOTPNumber = result;
						// 			enterEmailOTPAOVm.disableNext = false;
						// 		}, function(error) {
						// 		}, function(watchStatus) {
						// 		});
						// 	}


		
		                //enterEmailOTPAOVm.getOtpFromEmail(mobilenumber);
		            }, function (error) {
		                utilityService.showErrorMessage(error.responseMessage);
		            });
				}


				enterEmailOTPAOVm.requestOtpEmail = function() {
					enterEmailOTPAOVm.resendOtpEmail();
				};

				enterEmailOTPAOVm.resendOtpEmail = function () {
		            var requestParams = {
		                "id": userLoginDetailsService.mobile,
						"recipientMailId":  userLoginDetailsService.emailId ? userLoginDetailsService.emailId : "",
						"sendOTPFlg": "emailOnly" 
		            }
		            enterOTPAOService.getOtp(requestParams).then(function (response) {
		             
		                //.customer.otpNo = utilityService.getValue(response.data.otp);
		                var title = '';
		                var template = '{{"OTP_SENT_SUCCESS_EMAIL" | translate}}';
		                var onTap = '';
		                var buttontext = '<b>' + enterEmailOTPAOVm.okBtntext + '</b>';
		                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
		                // if (utilityService.isAndroidPlatform()) {
						// 		autoOtpReadService.startOtpReading().then(function(result) {
						// 			enterEmailOTPAOVm.getOTPNumber = result;
						// 			enterEmailOTPAOVm.disableNext = false;
						// 		}, function(error) {
						// 		}, function(watchStatus) {
						// 		});
						// 	}
		
		                //enterEmailOTPAOVm.getOtpFromEmail(mobilenumber);
		            }, function (error) {
		                utilityService.showErrorMessage(error.responseMessage);
		            });
				}


				/* resend OTP END */


	      enterEmailOTPAOVm.goToNextPage = function () {
	            utilityService.showSpinner();
	            enterEmailOTPAOVm.aoAuthChallengeHandler.handleChallenge = function (challenge) {
	                enterEmailOTPAOVm.isChallenged = true;
	                utilityService.hideSpinner();
	                if (challenge.errorMsg !== null) {
	                    utilityService.showErrorMessage(utilityService.getServerExceptionMessage(challenge));
	                } else {
	                    utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
	                }
	            };
	
	            enterEmailOTPAOVm.aoAuthChallengeHandler.handleSuccess = function (data) {
	                utilityService.hideSpinner();
	                enterEmailOTPAOVm.isChallenged = false;
	                if (data.user) {
	                    loggedInUserService.keyId = AdapterUtils.secretData == "" ? data.user.attributes.keyId : encryptionService.getAES256DecryptedData(data.user.attributes.keyId);
	                    loggedInUserService.tokenLotus = AdapterUtils.secretData == "" ? data.user.attributes.lotusToken : encryptionService.getAES256DecryptedData(data.user.attributes.lotusToken);
	                }
	            };
	
	            enterEmailOTPAOVm.aoAuthChallengeHandler.handleFailure = function (error) {
	                enterEmailOTPAOVm.aoAuthChallengeHandler.cancel();
	                enterEmailOTPAOVm.isChallenged = false;
	                utilityService.hideSpinner();
	                if (error.failure) {
	                    utilityService.showErrorMessage(error.failure);
	                } else {
	                    utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
	                }
	            }
	
	            var payload = {};
	            var requestParams = {
	                "mobileOTPKey": userLoginDetailsService.mobile,
	                "passOTPKey": enterEmailOTPAOVm.otpvalue,
					"mfDeviceId": loggedInUserService.deviceIdForMpin,
					"deviceId": device.uuid,
					"emailOTPKey":  userLoginDetailsService.emailId ? userLoginDetailsService.emailId : "",
					"passEmailOTPKey": enterEmailOTPAOVm.emailOtpvalue,
				    "reqTimeStamp" : (new Date()).toString()
	            }
	            var src = cryptoService.encryptRSAWithPublicKey(encryptionService.iv + "^" + encryptionService.passphrase + "^" + encryptionService.salt, cryptoService.rsaPublicKey);
	            payload = {
	                "data": AdapterUtils.secretData + encryptionService.getAES256EncryptedData(JSON.stringify(requestParams)),
	                "src": src
	            }
	
	            payload = AdapterUtils.secretData == "" ? requestParams : payload;
	
	            if (enterEmailOTPAOVm.isChallenged) {
	                enterEmailOTPAOVm.aoAuthChallengeHandler.submitChallengeAnswer(payload);
	            } else {
	                WLAuthorizationManager.login(enterEmailOTPAOVm.aoAuthChallengeHandler.securityCheckName, payload).then(
	                    function (data) {
	                        utilityService.accessRestricted = utilityService.AOAuthRequired;
	                        utilityService.hideSpinner();
	                        //alert('Success');
	                        $state.go('menu.taxDetailsAO');
	                    },
	                    function (error) {
	                        utilityService.accessRestricted = "";
	                        utilityService.hideSpinner();
	                        if (error.errorCode == 'CHALLENGE_HANDLING_CANCELED' || error.errorCode == 'APPLICATION_DISABLED') {
	                            return;
	                        }
	                        if (error.errorCode == "LOGIN_ALREADY_IN_PROCESS") {
	                            enterEmailOTPAOVm.aoAuthChallengeHandler.cancel();
	                        }
	                        utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
	                    });
	            }
	
	        }


        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            enterEmailOTPAOVm.invokeGetOTPService();
            enterEmailOTPAOVm.otpvalue = "";
			enterEmailOTPAOVm.emailOtpvalue = "";
        });

        return this;
    }
]);
