'use strict';

angularApp.controller('enterOTPPageAOController', ["$state",
    "$scope",
    "$translate",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "customerInfoService",
    // "autoOtpReadService",
    "enterOTPAOService",
    "userLoginDetailsService",
    "loggedInUserService",
    "cryptoService",
    "encryptionService",
	"AdapterUtils",
	"accountOpeningHomeService",
    function($state,
        $scope,
        $translate,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        customerInfoService,
        // autoOtpReadService,
        enterOTPAOService,
        userLoginDetailsService,
        loggedInUserService,
        cryptoService,
        encryptionService,
		AdapterUtils,
		accountOpeningHomeService) {

        var enterOTPAOVm = this;

  		enterOTPAOVm.isChallenged = false;
        enterOTPAOVm.securityCheckName = "AOSecurityCheck";
        enterOTPAOVm.aoAuthChallengeHandler = WL.Client.createSecurityCheckChallengeHandler(enterOTPAOVm.securityCheckName);
        enterOTPAOVm.aoAuthChallengeHandler.securityCheckName = enterOTPAOVm.securityCheckName;


        function initPage() {
            enterOTPAOVm.showBack = true;
            enterOTPAOVm.showNext = true;
            enterOTPAOVm.showOtpView = true;
            enterOTPAOVm.otpvalue = "";
            enterOTPAOVm.disableNext = true;
            enterOTPAOVm.aofooter = true;
            //enterOTPAOVm.requestOtpCall();
            //enterOTPAOVm.isDisabledOTP = false;
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                enterOTPAOVm.okBtntext = translatedvalue;  
            });
            
        }

        enterOTPAOVm.goBacktoPrevious = function() {
        	$state.go('menu.userLoginDetailsAO');
        }

        // enterOTPAOVm.goToNextPage = function() {
           // $state.go('menu.enterEmailOTPPageAO');
        // }

        $scope.goToHome = function() {
			accountOpeningHomeService.homeNav();
        }

        enterOTPAOVm.validateOTP = function(isValid) {
            enterOTPAOVm.disableNext = !isValid;
        }

		enterOTPAOVm.invokeGetOTPService = function () {
		            var requestParams = {
		                "id": userLoginDetailsService.mobile,
						"recipientMailId":  userLoginDetailsService.emailId ? userLoginDetailsService.emailId : "",
						"sendOTPFlg": "mobileOnly" 
		            }
		            enterOTPAOService.getOtp(requestParams).then(function (response) {
		             
		                //.customer.otpNo = utilityService.getValue(response.data.otp);
		                var title = '';
		                var template = '{{"OTP_SENT_SUCCESS" | translate}}';
		                var onTap = '';
		                var buttontext = '<b>' + enterOTPAOVm.okBtntext + '</b>';
						//utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
						



		                // if (utilityService.isAndroidPlatform()) {
						// 		autoOtpReadService.startOtpReading().then(function(result) {
						// 			enterOTPAOVm.getOTPNumber = result;
						// 			enterOTPAOVm.disableNext = false;
						// 		}, function(error) {
						// 		}, function(watchStatus) {
						// 		});
						// 	}


		
		                //enterOTPAOVm.getOtpFromEmail(mobilenumber);
		            }, function (error) {
		                utilityService.showErrorMessage(error.responseMessage);
		            });
				}

				/* resend OTP */
				
				enterOTPAOVm.requestOtpCallOnce = function() {
					//if(enterOTPAOVm.isDisabledOTP){return true}
					enterOTPAOVm.resendOtp();
					//enterOTPAOVm.isDisabledOTP = true;
				};

				enterOTPAOVm.resendOtp = function () {
		            var requestParams = {
		                "id": userLoginDetailsService.mobile,
						"recipientMailId":  userLoginDetailsService.emailId ? userLoginDetailsService.emailId : "",
						"sendOTPFlg": "mobileOnly" 
		            }
		            enterOTPAOService.getOtp(requestParams).then(function (response) {
		             
		                //.customer.otpNo = utilityService.getValue(response.data.otp);
		                var title = '';
		                var template = '{{"OTP_SENT_SUCCESS" | translate}}';
		                var onTap = '';
		                var buttontext = '<b>' + enterOTPAOVm.okBtntext + '</b>';
						//utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
						

		                // if (utilityService.isAndroidPlatform()) {
						// 		autoOtpReadService.startOtpReading().then(function(result) {
						// 			enterOTPAOVm.getOTPNumber = result;
						// 			enterOTPAOVm.disableNext = false;
						// 		}, function(error) {
						// 		}, function(watchStatus) {
						// 		});
						// 	}


		
		                //enterOTPAOVm.getOtpFromEmail(mobilenumber);
		            }, function (error) {
		                utilityService.showErrorMessage(error.responseMessage);
		            });
				}

				/* resend OTP END */


	      enterOTPAOVm.goToNextPage = function () {
	            utilityService.showSpinner();
	            enterOTPAOVm.aoAuthChallengeHandler.handleChallenge = function (challenge) {
	                enterOTPAOVm.isChallenged = true;
	                utilityService.hideSpinner();
	                if (challenge.errorMsg !== null) {
	                    utilityService.showErrorMessage(utilityService.getServerExceptionMessage(challenge));
	                } else {
	                    utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
	                }
	            };
	
	            enterOTPAOVm.aoAuthChallengeHandler.handleSuccess = function (data) {
	                utilityService.hideSpinner();
	                enterOTPAOVm.isChallenged = false;
	                if (data.user) {
	                    loggedInUserService.keyId = AdapterUtils.secretData == "" ? data.user.attributes.keyId : encryptionService.getAES256DecryptedData(data.user.attributes.keyId);
	                    loggedInUserService.tokenLotus = AdapterUtils.secretData == "" ? data.user.attributes.lotusToken : encryptionService.getAES256DecryptedData(data.user.attributes.lotusToken);
	                }
	            };
	
	            enterOTPAOVm.aoAuthChallengeHandler.handleFailure = function (error) {
	                enterOTPAOVm.aoAuthChallengeHandler.cancel();
	                enterOTPAOVm.isChallenged = false;
	                utilityService.hideSpinner();
	                if (error.failure) {
	                    utilityService.showErrorMessage(error.failure);
	                } else {
	                    utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
	                }
	            }
	
	            var payload = {};
	            var requestParams = {
	                "mobileOTPKey": userLoginDetailsService.mobile,
	                "passOTPKey": enterOTPAOVm.otpvalue,
					"mfDeviceId": loggedInUserService.deviceIdForMpin,
					"deviceId": device.uuid,
					"journeyName":accountOpeningHomeService.journeyType,
				    "reqTimeStamp" : (new Date()).toString()
	            }
	            var src = cryptoService.encryptRSAWithPublicKey(encryptionService.iv + "^" + encryptionService.passphrase + "^" + encryptionService.salt, cryptoService.rsaPublicKey);
	            payload = {
	                "data": AdapterUtils.secretData + encryptionService.getAES256EncryptedData(JSON.stringify(requestParams)),
	                "src": src
	            }
	
	            payload = AdapterUtils.secretData == "" ? requestParams : payload;
	
	            if (enterOTPAOVm.isChallenged) {
	                enterOTPAOVm.aoAuthChallengeHandler.submitChallengeAnswer(payload);
	            } else {
	                WLAuthorizationManager.login(enterOTPAOVm.aoAuthChallengeHandler.securityCheckName, payload).then(
	                    function (data) {
	                        utilityService.accessRestricted = utilityService.AOAuthRequired;
	                        utilityService.hideSpinner();
	                        //alert('Success');
	                        $state.go('menu.taxDetailsAO');//("menu.chequeBookServiceDetailsAO");//("menu.nomineeDetailsAO");//("menu.annualIncomeAO");//("menu.getPictureAO");//("menu.currentAddressPDAO");//("menu.personalDetailsAO")//('menu.taxDetailsAO');
	                    },
	                    function (error) {
	                        utilityService.accessRestricted = "";
	                        utilityService.hideSpinner();
	                        if (error.errorCode == 'CHALLENGE_HANDLING_CANCELED' || error.errorCode == 'APPLICATION_DISABLED') {
	                            return;
	                        }
	                        if (error.errorCode == "LOGIN_ALREADY_IN_PROCESS") {
	                            enterOTPAOVm.aoAuthChallengeHandler.cancel();
	                        }
	                        utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
	                    });
	            }
	
	        }


        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            enterOTPAOVm.invokeGetOTPService();
			enterOTPAOVm.otpvalue = "";
        });

        return this;
    }
]);
