'use strict';

angularApp.controller('enterOTPProductOfferingAOController', ["$state",
    "$scope",
    "$translate",
    "enterOTPAOService",
    "utilityService",
    "accountOpeningHomeService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "customerInfoService",
    // "autoOtpReadService",
    "userLoginDetailsService",
    function($state,
        $scope,
        $translate,
        enterOTPAOService,
        utilityService,
        accountOpeningHomeService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        customerInfoService,
        // autoOtpReadService,
        userLoginDetailsService) {

        var enterOTPProductOfferingAOVm = this;

        function initPage() {
            enterOTPProductOfferingAOVm.showBack = true;
            enterOTPProductOfferingAOVm.showNext = true;
            enterOTPProductOfferingAOVm.showOtpView = true;
            enterOTPProductOfferingAOVm.otpvalue = "";
            enterOTPProductOfferingAOVm.disableNext = true;
            enterOTPProductOfferingAOVm.aofooter = true;
            //enterOTPProductOfferingAOVm.isDisabledOTP = false;
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                enterOTPProductOfferingAOVm.okBtntext = translatedvalue;  
            });
             
        }

        enterOTPProductOfferingAOVm.goBacktoPrevious = function() {
             //$state.go('menu.productOfferingAO');
             $state.go('menu.termsAndConditionsAO');
        }

        enterOTPProductOfferingAOVm.goToNextPage = function() {
            /* Send the OTP */
          
            accountOpeningHomeService.tncOtpValue = enterOTPProductOfferingAOVm.otpvalue;
            var requestParams = {
                "mobile":userLoginDetailsService.mobile,
                "otp": enterOTPProductOfferingAOVm.otpvalue
            }
            
            enterOTPAOService.OTPValidation(requestParams,"").then(function(response) {
                
                if (response.data.status.toLowerCase() == "success") {
                    setTimeout(function() {
                        //enterOTPProductOfferingAOVm.updateCommonId();

                        enterOTPProductOfferingAOVm.getReferenceNumber();
                       
                    }, 500);
                } else {
                    utilityService.showErrorMessage(response.data.status);
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        //generate referance number-- as per new flow (krishna)
        enterOTPProductOfferingAOVm.getReferenceNumber = function(){
            var requestParams = {
                "id" : accountOpeningHomeService.customer.mobileNo,                
                "data":{
                    "commonId":$state.$current.data.commonId
                }
            }
  
            enterOTPAOService.getReferenceNo(requestParams).then(function(response) {
                //debitCardDetailsVm.receiveDebitCardDetails();
                accountOpeningHomeService.customer.referenceCode = utilityService.getValue(response.data.referenceCode);
                
                enterOTPProductOfferingAOVm.refEmailSms();
                $state.go('menu.enterOTPReferenceCodeAO');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }


        enterOTPProductOfferingAOVm.refEmailSms = function(){
            var requestParams = {
                "id":userLoginDetailsService.mobile,
                "receipientMailId":userLoginDetailsService.emailId ? userLoginDetailsService.emailId : "",
                "referenceCode":accountOpeningHomeService.customer.referenceCode
            }
            
            enterOTPAOService.sendRefEmailAndSms(requestParams).then(function(response) {
                         
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        //generate referance number END-- as per new flow 

        enterOTPProductOfferingAOVm.updateCommonId = function() {        	
        if(userLoginDetailsService.mobile == ""){
        		if(accountOpeningHomeService.isJTSixPostLoginStarted ){
            	userLoginDetailsService.mobile  =  accountOpeningHomeService.isJTSixPostLoginData.newMobile;
              }
        	}
            var requestParams = {
                "id": userLoginDetailsService.mobile,
                "data": {
                    "commonId": $state.$current.data.commonId
                }
            }
            
            enterOTPAOService.sendCommonId(requestParams,"").then(function(response) {
               
                if (response.responseCode == "0000") {
                		
 		                   $state.go('');	
					// }
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

		 enterOTPProductOfferingAOVm.requestOtpCallOnce = function() {
		 	//if(enterOTPProductOfferingAOVm.isDisabledOTP){return true}
		 	enterOTPProductOfferingAOVm.requestOtpCall();
                // var title = '';
                // var template = '{{"OTP_SENT_SUCCESS" | translate}}';
                // var onTap = '';
                // var buttontext = '<b>' + enterOTPProductOfferingAOVm.okBtntext + '</b>';
                // utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
		 	//enterOTPProductOfferingAOVm.isDisabledOTP = true;
		 };
        /* Request for OTP on page load to the registered mobile number */
        enterOTPProductOfferingAOVm.requestOtpCall = function() {
            var requestParams = {
                "id": userLoginDetailsService.mobile,
                "recipientMailId": userLoginDetailsService.email,
                "sendOTPFlg" : "mobileOnly"
            }
				// if (utilityService.isAndroidPlatform()) {	
				// 	autoOtpReadService.startOtpReading().then(function(result) {
				// 		enterOTPProductOfferingAOVm.otpvalue = result;
				// 		enterOTPProductOfferingAOVm.disableNext = false;
				// 	}, function(error) {
						
				// 	}, function(watchStatus) {
				// 		enterOTPAOService.requestOtp(requestParams,"").then(function(response) {
			    //         }, function(error) {
			    //             utilityService.showErrorMessage(error.responseMessage);
			    //         });
				// 	});
				// } else {
					enterOTPAOService.requestOtp(requestParams,"").then(function(response) {
			            }, function(error) {
			                utilityService.showErrorMessage(error.responseMessage);
			            });
				// }
        }

        $scope.goToHome = function() {
            accountOpeningHomeService.homeNav();
        }

        enterOTPProductOfferingAOVm.validateOTP = function(isValid) {
            enterOTPProductOfferingAOVm.disableNext = !isValid;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            enterOTPProductOfferingAOVm.otpvalue = "";
            enterOTPProductOfferingAOVm.requestOtpCall();
        });

        return this;
    }
]);
