'use strict';

angularApp.service('enterOTPAOService',
    function($state, $q, AdapterUtils, constantConfig,utilityService,POCADetailsService,citizenshipDetailsAOService,
    	     currentAddressPDCService , additionalDetailsAOService , nomineeDetailsAOService , chequeBookServiceDetailsService, userLoginDetailsService, applicationExistsAOService) {
 
	var enterOTPAOService = this;

	/* Send the OTP and ID to complete the registration */
	enterOTPAOService.getOtp = function(requestData) {
		var q = $q.defer();
		AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.requestOTPOVD, requestData, true).then(function(response) {
			q.resolve(response);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};

	enterOTPAOService.requestOtp = function(requestData, isJThirty) {
		var q = $q.defer();
		var url = constantConfig.acOpeningAdapterOVDUrl.requestOTPOVD;
		// if(isJThirty){
		// 	url = constantConfig.jTSixOpeningAdapterUrl.getOTP;
		// }
		AdapterUtils.postData(url, requestData, true).then(function(response) {
			q.resolve(response);
		}, function(error) {
			q.reject(error);
		});

		return q.promise;
	};

	/* Send the OTP and ID to complete the registration */
	enterOTPAOService.OTPValidation = function(requestData) {
		var q = $q.defer();
		AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.validateOTPTokenOVD, requestData, true).then(function(response) {
			q.resolve(response);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};

	/* Request for OTP on page load to the registered mobile number */
	enterOTPAOService.sendCommonId = function(requestData) {
		var q = $q.defer();
		AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.completeRegistration, requestData, true).then(function(response) {
			q.resolve(response);
		}, function(error) {
			q.reject(error);
		});

		return q.promise;
	};

	enterOTPAOService.getReferenceNo = function(requestParams) {

		var q = $q.defer();
		AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.getReferenceNumberOVD, requestParams, true).then(function(response) {
			q.resolve(response);

		}, function(error) {
			q.reject(error);
		});

		return q.promise;
	};

	enterOTPAOService.sendRefEmailAndSms = function(requestParams) {
		var q = $q.defer();
		AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.getReferenceDetailsOVD, requestParams, true).then(function(response) {
			q.resolve(response);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};

	enterOTPAOService.getCustomerDocument = function(requestParams) {
		var q = $q.defer();
		AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.customerDocumentOVD, requestParams).then(function(response) {
			q.resolve(response);
		}, function(error) {
			q.reject(error);
		});
		utilityService.showSpinner();
		return q.promise;
	};

	enterOTPAOService.resumeDocument = function(requestData) {
		var q = $q.defer();
		AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.resumeDocumentOVD + requestData, {}).then(function(response) {
			q.resolve(response);
		}, function(error) {
			q.reject(error);
		});
		utilityService.showSpinner();
		return q.promise;
	};

	enterOTPAOService.setResumeDocumentData = function(response) {
		enterOTPAOService.isResumeJourney = true;
		currentAddressPDCService.isCustomerCorrespondenceAddressSet = false;
		enterOTPAOService.taxPage = {
			journeyType : utilityService.getValue(response.journeyType),
			fatcaFlag : utilityService.getValue(response.fatcaFlag),
			pan : utilityService.getValue(response.personalDetails.pan),
			panAuthorizeFlag : utilityService.getValue(response.panAuthorizeFlag),
			panLinkingAwarenessFlag : utilityService.getValue(response.panLinkingAwarenessFlag)
		};

		if(response.personalDetails.emailId){
			userLoginDetailsService.emailId = utilityService.getValue(response.personalDetails.emailId)
		}

		if (response.poi || response.poa) {
			POCADetailsService.docNumber = utilityService.getValue(response.poi.docNo);
			POCADetailsService.expiryCompleteDate = utilityService.getValue(response.poi.expiryDate);
			POCADetailsService.issuedCompleteDate = utilityService.getValue(response.poi.issuedDate);
			POCADetailsService.type = utilityService.getValue(response.poi.type);
			POCADetailsService.proofSelValue = utilityService.getValue(response.poi.type);
			POCADetailsService.issuedAt = utilityService.getValue(response.poi.issuedAt);
			POCADetailsService.issuedBy = utilityService.getValue(response.poi.issuedBy);
			POCADetailsService.proofSelValue = utilityService.getValue(response.poi.type);
			}

		if (response.personalDetails.countryOfBirth) {
			citizenshipDetailsAOService.customerAdditionalDetails = {
				citizenship : utilityService.getValue(response.personalDetails.citizenship),
				citizenshipID : utilityService.getValue(response.personalDetails.citizenshipCode),
				countryOfBirth : utilityService.getValue(response.personalDetails.countryOfBirth),
				nationality : utilityService.getValue(response.personalDetails.nationality),
				nationalityID : utilityService.getValue(response.personalDetails.nationalityCode),
				placeOfBirth : utilityService.getValue(response.personalDetails.placeOfBirth),
				cityOfBirth : utilityService.getValue(response.personalDetails.placeOfBirth),
				isAadhaarScanned : utilityService.getValue(response.personalDetails.isAadhaarScanned)
			};

			citizenshipDetailsAOService.customerManualEntryDetails = {
				uid : utilityService.getValue(response.personalDetails.uid),
				vid : utilityService.getValue(response.personalDetails.vid),
				dob : utilityService.getValue(response.personalDetails.dob),
				firstName : utilityService.getValue(response.personalDetails.firstName),
				gender : utilityService.getValue(response.personalDetails.gender),
				genderCode : utilityService.getValue(response.personalDetails.genderCode),
				lastName : utilityService.getValue(response.personalDetails.lastName),
				middleName : utilityService.getValue(response.personalDetails.middleName),
				title : utilityService.getValue(response.personalDetails.title),
				titleCode : utilityService.getValue(response.personalDetails.titleCode),
				isCustManualCorresChkBox : response.personalDetails.scannedCorrespondenceAddFlag
			}
		}
		if(response.doc){
			           additionalDetailsAOService.picId = response.doc[0].docRef;
            }	

		if (response.personalDetails.address) {
			currentAddressPDCService.customerCorrespondenceAddress = {};
			currentAddressPDCService.isCustomerCorrespondenceAddressSet = true;
			currentAddressPDCService.customerCorrespondenceAddress.address1 = utilityService.getValue(response.personalDetails.address[0].addressLine1), 
			currentAddressPDCService.customerCorrespondenceAddress.address2 = utilityService.getValue(response.personalDetails.address[0].addressLine2), 
			currentAddressPDCService.customerCorrespondenceAddress.city = utilityService.getValue(response.personalDetails.address[0].city), 
			currentAddressPDCService.customerCorrespondenceAddress.cityCode = utilityService.getValue(response.personalDetails.address[0].cityCode), 
			currentAddressPDCService.customerCorrespondenceAddress.locality = utilityService.getValue(response.personalDetails.address[0].locality), 
			currentAddressPDCService.customerCorrespondenceAddress.pincode = utilityService.getValue(response.personalDetails.address[0].pincode), 
			currentAddressPDCService.customerCorrespondenceAddress.state = utilityService.getValue(response.personalDetails.address[0].state), 
			currentAddressPDCService.customerCorrespondenceAddress.stateCode = utilityService.getValue(response.personalDetails.address[0].stateCode), 
			currentAddressPDCService.customerCorrespondenceAddress.district = utilityService.getValue(response.personalDetails.address[0].district), 
			currentAddressPDCService.customerCorrespondenceAddress.districtCode = utilityService.getValue(response.personalDetails.address[0].districtCode), 
			currentAddressPDCService.customerCorrespondenceAddress.type = utilityService.getValue(response.personalDetails.address[0].type)
		}

		if (response.additionalDetails) {
			additionalDetailsAOService.customerAdditionalDetails = {
				annualIncome : utilityService.getValue(response.additionalDetails.annualIncome),
				annualIncomeCode : utilityService.getValue(response.additionalDetails.annualIncomeCode),
				cityOfBirth : utilityService.getValue(response.additionalDetails.cityOfBirth),
				countryOfBirth : utilityService.getValue(response.additionalDetails.countryOfBirth),
				education : utilityService.getValue(response.additionalDetails.education),
				annualIncomeValue : utilityService.getValue(response.additionalDetails.annualIncomeValue),
				category : utilityService.getValue(response.additionalDetails.category),

				fatherFirstName : utilityService.getValue(response.additionalDetails.fatherFirstName),
				fatherLastName : utilityService.getValue(response.additionalDetails.fatherLastName),
				fatherMiddleName : utilityService.getValue(response.additionalDetails.fatherMiddleName),
				fatherTitle : utilityService.getValue(response.additionalDetails.fatherTitle),

				fatherTitleCode : utilityService.getValue(response.additionalDetails.fatherTitleCode),
				maidenName : utilityService.getValue(response.additionalDetails.maidenName),
				maritalStatus : utilityService.getValue(response.additionalDetails.maritalStatus),
				marital : utilityService.getValue(response.additionalDetails.maritalStatusCode),

				motherFirstname : utilityService.getValue(response.additionalDetails.motherFirstName),
				motherLastname : utilityService.getValue(response.additionalDetails.motherLastName),
				motherMaidenName : utilityService.getValue(response.additionalDetails.motherMaidenName),
				motherMiddlename : utilityService.getValue(response.additionalDetails.motherMiddleName),

				motherTitle : utilityService.getValue(response.additionalDetails.motherTitle),
				motherTitleCode : utilityService.getValue(response.additionalDetails.motherTitleCode),
				occupation : utilityService.getValue(response.additionalDetails.occupation),
				religion : utilityService.getValue(response.additionalDetails.religion),
				religionCode : utilityService.getValue(response.additionalDetails.religionCode),
				spouseName : utilityService.getValue(response.additionalDetails.spouseName),
				subOccupation : utilityService.getValue(response.additionalDetails.subOccupation),
				thresholdLimitAmount : utilityService.getValue(response.additionalDetails.thresholdLimitAmount),
				fatherName : utilityService.getValue(response.additionalDetails.fatherFirstName) + '' + utilityService.getValue(response.additionalDetails.fatherLastName)
			},
			 additionalDetailsAOService.activeAdditionalDetails = {
				annualIncome : utilityService.getValue(response.additionalDetails.annualIncomeCode),
				cityOfBirth : utilityService.getValue(response.additionalDetails.cityOfBirth),
				countryOfBirth : utilityService.getValue(response.additionalDetails.countryOfBirth),
			
				education : utilityService.getValue(response.additionalDetails.educationCode),
				fatherFirstName : utilityService.getValue(response.additionalDetails.fatherFirstName),
				fatherLastName : utilityService.getValue(response.additionalDetails.fatherLastName),
				fatherMiddleName : utilityService.getValue(response.additionalDetails.fatherMiddleName),
				fatherTitle : utilityService.getValue(response.additionalDetails.fatherTitle),
				category : utilityService.getValue(response.additionalDetails.categoryCode),

				fatherTitleCode : utilityService.getValue(response.additionalDetails.fatherTitleCode),
				maidenName : utilityService.getValue(response.additionalDetails.maidenName),
				maritalStatus : utilityService.getValue(response.additionalDetails.maritalStatus),
				marital : utilityService.getValue(response.additionalDetails.maritalStatusCode),

				motherFirstname : utilityService.getValue(response.additionalDetails.motherFirstName),
				motherLastname : utilityService.getValue(response.additionalDetails.motherLastName),
				motherMaidenName : utilityService.getValue(response.additionalDetails.motherMaidenName),
				motherMiddlename : utilityService.getValue(response.additionalDetails.motherMiddleName),

				motherTitle : utilityService.getValue(response.additionalDetails.motherTitle),
				motherTitleCode : utilityService.getValue(response.additionalDetails.motherTitleCode),
				occupation : utilityService.getValue(response.additionalDetails.occupationCode),
				religion : utilityService.getValue(response.additionalDetails.religionCode),
				spouseName : utilityService.getValue(response.additionalDetails.spouseName),
				subOccupation : utilityService.getValue(response.additionalDetails.subOccupationCode),
				thresholdLimitAmount : utilityService.getValue(response.additionalDetails.thresholdLimitAmount),
				fatherName : utilityService.getValue(response.additionalDetails.fatherFirstName) + '' + utilityService.getValue(response.additionalDetails.fatherLastName)
			}
		}

		if (response.nominees) {
			nomineeDetailsAOService.nominee  = {};
			nomineeDetailsAOService.nominee.age = utilityService.getValue(response.nominees[0].age);
			nomineeDetailsAOService.nominee.dob = utilityService.getValue(response.nominees[0].dob);
			nomineeDetailsAOService.nominee.guardian = utilityService.getValue(response.nominees[0].guardian);
			if(response.nominees[0].guardian){
			nomineeDetailsAOService.nominee.guardianName = utilityService.getValue(response.nominees[0].guardian.name);
			nomineeDetailsAOService.nominee.guardianAge = utilityService.getValue(response.nominees[0].guardian.guardianAge);
			}
			nomineeDetailsAOService.nominee.name = utilityService.getValue(response.nominees[0].name);
			nomineeDetailsAOService.nominee.relationship = utilityService.getValue(response.nominees[0].relationship);
			nomineeDetailsAOService.nominee.sameAsApplicantAddress = utilityService.getValue(response.nominees[0].sameAsApplicantAddress);
			nomineeDetailsAOService.nominee.uid = utilityService.getValue(response.nominees[0].uid);
			
			

			if (response.nominees[0].address) {
				nomineeDetailsAOService.nominee.address1 = utilityService.getValue(response.nominees[0].address.addressLine1);
				nomineeDetailsAOService.nominee.address2 = utilityService.getValue(response.nominees[0].address.addressLine2);
				nomineeDetailsAOService.nominee.locality = utilityService.getValue(response.nominees[0].address.locality);
				nomineeDetailsAOService.nominee.city = utilityService.getValue(response.nominees[0].address.city);
				nomineeDetailsAOService.nominee.cityCode = utilityService.getValue(response.nominees[0].address.cityCode);
				nomineeDetailsAOService.nominee.pincode = utilityService.getValue(response.nominees[0].address.pincode);
				nomineeDetailsAOService.nominee.state = utilityService.getValue(response.nominees[0].address.state);
				nomineeDetailsAOService.nominee.stateName = utilityService.getValue(response.nominees[0].address.state);
				nomineeDetailsAOService.nominee.stateCode = utilityService.getValue(response.nominees[0].address.stateCode);
				nomineeDetailsAOService.nominee.district = utilityService.getValue(response.nominees[0].address.district);
                nomineeDetailsAOService.nominee.districtCode = utilityService.getValue(response.nominees[0].address.districtCode);
			}
			if (response.nominees[0].guardian) {
			   nomineeDetailsAOService.guardian = {};
			   nomineeDetailsAOService.guardian.guardianAddressFlag = utilityService.getValue(response.nominees[0].guardian.guardianAddressFlag);
			   nomineeDetailsAOService.guardian.guardianAge = utilityService.getValue(response.nominees[0].guardian.guardianAge);
			   nomineeDetailsAOService.guardian.guardianConsent = utilityService.getValue(response.nominees[0].guardian.guardianConsent);
			   nomineeDetailsAOService.guardian.name = utilityService.getValue(response.nominees[0].guardian.name);
				if(response.nominees[0].guardian.address){
				nomineeDetailsAOService.guardian.address1 = utilityService.getValue(response.nominees[0].guardian.address.addressLine1);
				nomineeDetailsAOService.guardian.address2 = utilityService.getValue(response.nominees[0].guardian.address.addressLine2);
				nomineeDetailsAOService.guardian.city = utilityService.getValue(response.nominees[0].guardian.address.city);
				nomineeDetailsAOService.guardian.cityCode = utilityService.getValue(response.nominees[0].guardian.address.cityCode);
				nomineeDetailsAOService.guardian.district = utilityService.getValue(response.nominees[0].guardian.address.district);
                nomineeDetailsAOService.guardian.districtCode = utilityService.getValue(response.nominees[0].guardian.address.districtCode);
				nomineeDetailsAOService.guardian.locality = utilityService.getValue(response.nominees[0].guardian.address.locality);
				nomineeDetailsAOService.guardian.pincode = utilityService.getValue(response.nominees[0].guardian.address.pincode);
				nomineeDetailsAOService.guardian.state = utilityService.getValue(response.nominees[0].guardian.address.state);
				nomineeDetailsAOService.guardian.stateCode = utilityService.getValue(response.nominees[0].guardian.address.stateCode);
		}
		}
	 }
	 
	 if (response.services) { 
			if(!chequeBookServiceDetailsService.CBPage){
				chequeBookServiceDetailsService.CBPage = {};
			}
		    chequeBookServiceDetailsService.CBPage.selectedMethodCBook = response.services.chequeB;
        	chequeBookServiceDetailsService.CBPage.selectedMethodSMS = response.services.smsAlert;
            if(response.kits){
            	chequeBookServiceDetailsService.CBPage.cardType = utilityService.getValue(response.kits[0].cardType);
            	chequeBookServiceDetailsService.CBPage.cardVariant = utilityService.getValue(response.kits[0].cardVariant);
            	chequeBookServiceDetailsService.CBPage.cardVariantCode = utilityService.getValue(response.kits[0].cardVariantCode);
            	chequeBookServiceDetailsService.CBPage.bankingRights = utilityService.getValue(response.kits[0].inbRights);
            	chequeBookServiceDetailsService.CBPage.name = utilityService.getValue(response.kits[0].name);
            	//utilityService.getValue(response.kits[0].type);
            }
         }
         
         chequeBookServiceDetailsService.termsAndConditionsFlag = response.termsAndConditionsFlag;
         chequeBookServiceDetailsService.productOfferingFlag = response.productOfferingFlag;
         chequeBookServiceDetailsService.refNo = response.refNo;
		 chequeBookServiceDetailsService.isPasswordSet = response.isPasswordSet;
		 


		 if(enterOTPAOService.isResumeJourney && citizenshipDetailsAOService.customerAdditionalDetails && enterOTPAOService.taxPage.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar){
			if(citizenshipDetailsAOService.customerAdditionalDetails.isAadhaarScanned){
				enterOTPAOService.isAadhaarScanEntry = true; 
				enterOTPAOService.isAadhaarManualEntry = false;
				enterOTPAOService.isVID = false; 
			}else{
				if(citizenshipDetailsAOService.customerManualEntryDetails.vid.length > 1){
					enterOTPAOService.isVID = true;
					enterOTPAOService.isAadhaarScanEntry = false; 
					enterOTPAOService.isAadhaarManualEntry = false;			
				}else{
					enterOTPAOService.isAadhaarManualEntry = true; 
					enterOTPAOService.isAadhaarScanEntry = false; 
					enterOTPAOService.isVID = false;
				}
			}
		}




	}



	enterOTPAOService.clearResumeData = function() {
		enterOTPAOService.isResumeJourney = false;
		currentAddressPDCService.isCustomerCorrespondenceAddressSet = false;

		userLoginDetailsService.mobile = "";
		userLoginDetailsService.pannumber = "";
		userLoginDetailsService.emailId = "";
		userLoginDetailsService.reffCode = "";
		applicationExistsAOService.journeyRedirectOption = "";

		enterOTPAOService.taxPage = {
			journeyType : "",
			fatcaFlag : "",
			pan : "",
			panAuthorizeFlag : "",
			panLinkingAwarenessFlag : ""
		};

		
			POCADetailsService.docNumber = "";
			POCADetailsService.expiryCompleteDate = "";
			POCADetailsService.issuedCompleteDate = "";
			POCADetailsService.type = "";
			POCADetailsService.proofSelValue = "";
			POCADetailsService.issuedAt = "";
			POCADetailsService.issuedBy = "";
			POCADetailsService.proofSelValue = "";
		

		
			citizenshipDetailsAOService.customerAdditionalDetails = {
				citizenship : "",
				citizenshipID : "",
				countryOfBirth : "",
				nationality : "",
				nationalityID : "",
				placeOfBirth : "",
				cityOfBirth : "",
				isAadhaarScanned : ""
			}

			citizenshipDetailsAOService.customerManualEntryDetails = {
				uid : "",
				vid : "",
				dob : "",
				firstName : "",
				gender : "",
				genderCode : "",
				lastName : "",
				middleName : "",
				title : "",
				titleCode : ""
			}
		
	
			additionalDetailsAOService.picId = "";
           


			currentAddressPDCService.customerCorrespondenceAddress = {};
			currentAddressPDCService.customerCorrespondenceAddress.address1 = "", 
			currentAddressPDCService.customerCorrespondenceAddress.address2 = "", 
			currentAddressPDCService.customerCorrespondenceAddress.city = "", 
			currentAddressPDCService.customerCorrespondenceAddress.cityCode = "", 
			currentAddressPDCService.customerCorrespondenceAddress.locality = "", 
			currentAddressPDCService.customerCorrespondenceAddress.pincode = "", 
			currentAddressPDCService.customerCorrespondenceAddress.state = "", 
			currentAddressPDCService.customerCorrespondenceAddress.stateCode = "", 
			currentAddressPDCService.customerCorrespondenceAddress.district = "", 
			currentAddressPDCService.customerCorrespondenceAddress.districtCode = "", 
			currentAddressPDCService.customerCorrespondenceAddress.type = ""



			additionalDetailsAOService.customerAdditionalDetails = {
				annualIncome : "",
				annualIncomeCode : "",
				cityOfBirth : "",
				countryOfBirth : "",
				education : "",

				fatherFirstName : "",
				fatherLastName : "",
				fatherMiddleName : "",
				fatherTitle : "",

				fatherTitleCode : "",
				maidenName : "",
				maritalStatus : "",
				marital : "",

				motherFirstname : "",
				motherLastname : "",
				motherMaidenName : "",
				motherMiddlename : "",

				motherTitle : "",
				motherTitleCode : "",
				occupation : "",
				religion : "",
				religionCode : "",
				spouseName : "",
				subOccupation : "",
				thresholdLimitAmount : "",
				fatherName : ""
			},
			 additionalDetailsAOService.activeAdditionalDetails = {
				annualIncome : "",
				cityOfBirth : "",
				countryOfBirth : "",
			
				education : "",
				fatherFirstName : "",
				fatherLastName : "",
				fatherMiddleName : "",
				fatherTitle : "",

				fatherTitleCode : "",
				maidenName : "",
				maritalStatus : "",
				marital : "",

				motherFirstname : "",
				motherLastname : "",
				motherMaidenName : "",
				motherMiddlename : "",

				motherTitle : "",
				motherTitleCode : "",
				occupation : "",
				religion : "",
				spouseName : "",
				subOccupation : "",
				thresholdLimitAmount : "",
				fatherName : ""
			}


			nomineeDetailsAOService.nominee  = {};
			nomineeDetailsAOService.nominee.age = "";
			nomineeDetailsAOService.nominee.dob = "";
			nomineeDetailsAOService.nominee.guardian = "";
	
			nomineeDetailsAOService.nominee.guardianName = "";
			nomineeDetailsAOService.nominee.guardianAge = "";
		
			nomineeDetailsAOService.nominee.name = "";
			nomineeDetailsAOService.nominee.relationship = "";
			nomineeDetailsAOService.nominee.sameAsApplicantAddress = "";
			nomineeDetailsAOService.nominee.uid = "";
			
			


				nomineeDetailsAOService.nominee.address1 = "";
				nomineeDetailsAOService.nominee.address2 = "";
				nomineeDetailsAOService.nominee.locality = "";
				nomineeDetailsAOService.nominee.city = "";
				nomineeDetailsAOService.nominee.cityCode = "";
				nomineeDetailsAOService.nominee.pincode = "";
				nomineeDetailsAOService.nominee.state = "";
				nomineeDetailsAOService.nominee.stateName = "";
				nomineeDetailsAOService.nominee.stateCode = "";
				nomineeDetailsAOService.nominee.district = "";
                nomineeDetailsAOService.nominee.districtCode = "";
	
		
			   nomineeDetailsAOService.guardian = {};
			   nomineeDetailsAOService.guardian.guardianAddressFlag = "";
			   nomineeDetailsAOService.guardian.guardianAge = "";
			   nomineeDetailsAOService.guardian.guardianConsent = "";
			   nomineeDetailsAOService.guardian.name = "";

				nomineeDetailsAOService.guardian.address1 = "";
				nomineeDetailsAOService.guardian.address2 = "";
				nomineeDetailsAOService.guardian.city = "";
				nomineeDetailsAOService.guardian.cityCode = "";
				nomineeDetailsAOService.guardian.district = "";
                nomineeDetailsAOService.guardian.districtCode = "";
				nomineeDetailsAOService.guardian.locality = "";
				nomineeDetailsAOService.guardian.pincode = "";
				nomineeDetailsAOService.guardian.state = "";
				nomineeDetailsAOService.guardian.stateCode = "";


	 

			if(!chequeBookServiceDetailsService.CBPage){
				chequeBookServiceDetailsService.CBPage = {};
			}
		    chequeBookServiceDetailsService.CBPage.selectedMethodCBook = "";
        	chequeBookServiceDetailsService.CBPage.selectedMethodSMS = "";
       
            	chequeBookServiceDetailsService.CBPage.cardType = "";
            	chequeBookServiceDetailsService.CBPage.cardVariant = "";
            	chequeBookServiceDetailsService.CBPage.cardVariantCode = "";
            	chequeBookServiceDetailsService.CBPage.bankingRights = "";
            	chequeBookServiceDetailsService.CBPage.name = "";
            	
        

         
         chequeBookServiceDetailsService.termsAndConditionsFlag = "";
         chequeBookServiceDetailsService.productOfferingFlag = "";
         chequeBookServiceDetailsService.refNo = "";
		 chequeBookServiceDetailsService.isPasswordSet = "";
		 


	
		
				enterOTPAOService.isAadhaarScanEntry = false; 
				enterOTPAOService.isAadhaarManualEntry = false;
				enterOTPAOService.isVID = false; 
			




	}



	enterOTPAOService.navigateToPage = function(response) {
		switch(response.payLoad.commonId) {
			case "FatcaDetails":
				if(enterOTPAOService.taxPage.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar){
					$state.go('menu.aadhaarOption');
				}else{
					$state.go(response.payLoad.mobileURL);
				}
				break;
			case "proofOfAddress":
				$state.go(response.payLoad.mobileURL);
				break;
			case "personalDetails":
				if(enterOTPAOService.taxPage.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar){
					if("menu.currentAddressPDAO" == response.payLoad.mobileURL &&
					chequeBookServiceDetailsService.isPasswordSet !== true && !currentAddressPDCService.isCustomerCorrespondenceAddressSet){
						if(enterOTPAOService.isAadhaarScanEntry || enterOTPAOService.isVID){
							$state.go("menu.aadhaarOption");
						}else{
							$state.go("menu.tempLoginAO");
						}
					 
					 }else if("menu.currentAddressPDAO" == response.payLoad.mobileURL &&
				   chequeBookServiceDetailsService.isPasswordSet !== true){
					$state.go("menu.tempLoginAO");
					}else{
						$state.go('menu.getPictureAO'); 
					}
				}else{
					if("menu.currentAddressPDAO" == response.payLoad.mobileURL &&
				   chequeBookServiceDetailsService.isPasswordSet !== true){
					$state.go("menu.tempLoginAO");
				}else{
					$state.go(response.payLoad.mobileURL);	
				}
				}
				
				//$state.go("menu.citizenshipDetailsAO");
				break;
			case "currentAddress":
			if(enterOTPAOService.taxPage.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar){
				if("menu.getPictureAO" == response.payLoad.mobileURL &&
				chequeBookServiceDetailsService.isPasswordSet !== true){
				$state.go("menu.tempLoginAO");
				}else{
					$state.go(response.payLoad.mobileURL);
				}
			}else{
				$state.go(response.payLoad.mobileURL);
			}				
				break;
			case "customerPhoto":
				$state.go(response.payLoad.mobileURL);
				break;
			case "additionalDetails":
				if (additionalDetailsAOService.activeAdditionalDetails.subOccupation) {
					$state.go(response.payLoad.mobileURL);
				} else {
					$state.go(response.payLoad.mobileURL);
				}
				break;
			case "nomineeDetails":
			if(nomineeDetailsAOService.nominee){
				if(parseInt(nomineeDetailsAOService.nominee.age) > 18){
					$state.go(response.payLoad.mobileURL);
				}
				else{
					if(!nomineeDetailsAOService.nominee.guardianName && !nomineeDetailsAOService.nominee.guardianAge){
						$state.go("menu.nomineeDetailsAO");
					}
					else{
						$state.go("menu.nomineeDetailsAddressOptionAO");
					}
				}
			}
			
				break;

			case "GuardianDetails":
				if (nomineeDetailsAOService.nominee.guardianAddressFlag == "nomineeAddress") {
					$state.go(response.payLoad.mobileURL);
				} else if (nomineeDetailsAOService.nominee.guardianAddressFlag == "applicantAddress") {
					$state.go(response.payLoad.mobileURL);
				} else if (nomineeDetailsAOService.nominee.guardianAddressFlag == "newAddress") {
					$state.go(response.payLoad.mobileURL);
				}
				break;
			case "guardianDetails":
				if (nomineeDetailsAOService.guardian.guardianAddressFlag == "nomineeAddress") {
					$state.go(response.payLoad.mobileURL);
				} else if (nomineeDetailsAOService.guardian.guardianAddressFlag == "applicantAddress") {
					$state.go(response.payLoad.mobileURL);
				} else if (nomineeDetailsAOService.guardian.guardianAddressFlag == "newAddress") {
					$state.go(response.payLoad.mobileURL);
				}
				break;
			case "servicesRequired":
				$state.go(response.payLoad.mobileURL);
				break;
			case "personalisedKit":
				$state.go(response.payLoad.mobileURL);
				break;
			case "customerTnC":
				//$state.go(response.payLoad.mobileURL);
				$state.go("menu.termsAndConditionsAO");
				break;
			case "productOffer":
				$state.go(response.payLoad.mobileURL);
				break;
			case "RefNumber":
				$state.go(response.payLoad.mobileURL);
				break;
			default:
				$state.go(response.payLoad.mobileURL);
		}

	};






        return enterOTPAOService;
    });
