'use strict';

angularApp.controller('enterOTPReferenceCodeAOController', ["$state",
    "$scope",
    "accountOpeningHomeService",
    "enterOTPReferenceCodeAOService",
    "$timeout",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "chequeBookServiceDetailsService",
    "enterOTPAOService",
    "POCADetailsService",
    "userLoginDetailsService",
    function($state,
        $scope,
        accountOpeningHomeService,
        enterOTPReferenceCodeAOService,
        $timeout,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        chequeBookServiceDetailsService,
        enterOTPAOService,
        POCADetailsService,
        userLoginDetailsService) {

        var enterOTPReferenceCodeAOVm = this;

        function initPage() {
            enterOTPReferenceCodeAOVm.showBack = false;
            enterOTPReferenceCodeAOVm.showNext = true;
            enterOTPReferenceCodeAOVm.showOtpView = true;
            enterOTPReferenceCodeAOVm.otpFooterView = true;
            enterOTPReferenceCodeAOVm.disableNext = true;
            enterOTPReferenceCodeAOVm.disableResendOtp = true;  
            enterOTPReferenceCodeAOVm.getReferenceContent();
            //enterOTPReferenceCodeAOVm.refEmailSms();
        }

        enterOTPReferenceCodeAOVm.goToNextPage = function() {
            enterOTPReferenceCodeAOVm.showOtpView = false;
            enterOTPReferenceCodeAOVm.otpFooterView = false;
        }

        $scope.goToHome = function() {
            accountOpeningHomeService.homeNav();
        }

        enterOTPReferenceCodeAOVm.locateBranch = function() {
            $state.go('menu.locateNearestBranchAO');
        }

        enterOTPReferenceCodeAOVm.validateOTP = function(isValid) {
            enterOTPReferenceCodeAOVm.disableNext = !isValid;
            enterOTPReferenceCodeAOVm.disableResendOtp = false;
        }

		enterOTPReferenceCodeAOVm.getReferenceContent = function() {
			var type = POCADetailsService.proofSelValue;
			var pageText = enterOTPReferenceCodeAOService.otpReferenceText;
			var refNo = accountOpeningHomeService.customer.referenceCode ? accountOpeningHomeService.customer.referenceCode : chequeBookServiceDetailsService.refNo;
			
			if (type && pageText && refNo) {
				var str = pageText;
				var arr = str.split('<span id="panNo">')
				str = str.replace("FIELD_1}}", '<span><b style="font-size: 30px; font-family: Verdana,sans-serif; font-weight:800;">'+refNo+'</b></span>' );
				str = str.replace("FIELD_2}}", type);
				enterOTPReferenceCodeAOVm.otpReferenceText = str;
				return true;
			}
	    	var requestParams = {
                "id": userLoginDetailsService.mobile
            }
        	
			enterOTPReferenceCodeAOService.getRefContent(requestParams).then(function(response) {
				enterOTPReferenceCodeAOService.otpReferenceText = response.data.justStep;
				enterOTPReferenceCodeAOVm.otpReferenceText = response.data.justStep;
	
				utilityService.setCsatJournies('accountOpeningDigitalCustomer');
	
				if (enterOTPAOService.isResumeJourney == true && chequeBookServiceDetailsService.refNo) {
					accountOpeningHomeService.customer.referenceCode = chequeBookServiceDetailsService.refNo;
				}
	
				var str = enterOTPReferenceCodeAOVm.otpReferenceText;
				str = str.replace("FIELD_1}}", '<span><b style="font-size: 30px; font-family: Verdana,sans-serif; font-weight:800;">'+refNo+'</b></span>' );
				str = str.replace("FIELD_2}}", type);
				enterOTPReferenceCodeAOVm.otpReferenceText = str;
	
			}, function(error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		}


        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
           if(!accountOpeningHomeService.customer){
           	accountOpeningHomeService.customer = {};
           }
           initPage(); 
           $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
           
        });

        return this;
    }
]);
