'use strict';

angularApp.controller('locateBranchByGpsAOController', ["$state",
    "$scope",
    "locateNearestBranchServiceOVD",
    "accountOpeningHomeService",
    "utilityService",
    "currentLocationService",
    "$timeout",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
	"$rootScope",

    function($state,
        $scope,
        locateNearestBranchServiceOVD,
        accountOpeningHomeService,
        utilityService,
        currentLocationService,
        $timeout,
        $ionicSideMenuDelegate,
        mPinLoginService, $rootScope) {

        var locateBranchGpsAOVm = this;

        function initPage() {
            locateBranchGpsAOVm.showBack = true;
            //locateBranchGpsAOVm.showNext = true;
            //locateBranchGpsAOVm.disableNext = true;
            locateBranchGpsAOVm.showRadioBtn = true;
            locateBranchGpsAOVm.showLink = true;
            locateBranchGpsAOVm.aofooter = true;
            locateBranchGpsAOVm.gpsLink = true;
        }

        locateBranchGpsAOVm.goBacktoPrevious = function() {
            $state.go('menu.locateNearestBranchAO');
        }

        $scope.goToHome = function() {
            accountOpeningHomeService.homeNav();
        }

        locateBranchGpsAOVm.validateForm = function(isValid) {
            if (isValid) {
                locateBranchGpsAOVm.disableNext = false;
            }
        }

        locateBranchGpsAOVm.navigatePage = function(param){
           var geocoords = param.latitude + ',' + param.longitude;
           if(utilityService.isUndefined(param.latitude) || utilityService.isUndefined(param.longitude)){
                var title = '';
                var template = '{{"NO_DIR" | translate}}';
                var onTap = 'menu.locateBranchByLocalityAO';
                var buttontext = '<b>' + locateBranchGpsAOVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            }
            else{
                if (utilityService.isIOSPlatform()) {
                  //window.open('maps://?q=' + geocoords, '_system');
				  cordova.ThemeableBrowser.open('https://www.google.com/maps/search/?api=1&query='+geocoords, '_blank',
				  {
					  statusbar: {
						  color:'#ffffffff'
					  },
					  toolbar: {
						  height: 37,
						  color: '#ffffffff',
						  image: 'share'
					  },

					  closeButton: {
						  image:'back',
						  height: 37,
						  width: 32,
						  align: 'left',
						  event: 'closePressed'
					  },

					  backButtonCanClose: true
				  });
                }
                else {
                  var label = encodeURI('Your Destination'); // encode the label!
                  window.open('geo:0,0?q=' + geocoords + '(' + label + ')', '_system');
                }
            }
        }

        //Service for displaying branch list for latitude and longitude
        locateBranchGpsAOVm.loadBranchesGps = function() {
            locateBranchGpsAOVm.bankListGps = accountOpeningHomeService.locateByGPS;
        }

		locateBranchGpsAOVm.closeView = function(){
      $scope.isLoggedin = mPinLoginService.isLoggedIn;
      locateBranchGpsAOVm.isLoggedin = $scope.isLoggedin;

        if (!locateBranchGpsAOVm.isLoggedin) {
          $state.go('menu.userLogin');
        } else {
         
        }

		//	$state.go('menu.userLogin');
		};

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        $scope.$on('$ionicView.beforeEnter', function() {
            locateBranchGpsAOVm.loadBranchesGps();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
