'use strict';

angularApp.controller('locateBranchByLocalityAOController', ["$state",
    "$scope",
    "locateNearestBranchServiceOVD",
    "accountOpeningHomeService",
    "utilityService",
    "$translate",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        locateNearestBranchServiceOVD,
        accountOpeningHomeService,
        utilityService,
        $translate,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var locateBranchLocAOVm = this;

        function initPage() {
            locateBranchLocAOVm.showBack = true;
            locateBranchLocAOVm.showNext = false;
            locateBranchLocAOVm.disableNext = true;
            locateBranchLocAOVm.bankListLocality = [];
            locateBranchLocAOVm.aofooter = true;
            locateBranchLocAOVm.showRadioBtn = false;
            locateBranchLocAOVm.showLink = true;
            locateBranchLocAOVm.localityname="";


            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                locateBranchLocAOVm.okBtntext = translatedvalue;
            });
        }

        locateBranchLocAOVm.goBacktoPrevious = function() {
            
            $state.go('menu.locateNearestBranchAO');
        }

        locateBranchLocAOVm.navigatePage = function(param){
           var geocoords = param.latitude + ',' + param.longitude;
           if(utilityService.isUndefined(param.latitude) || utilityService.isUndefined(param.longitude)){
                var title = '';
                var template = '{{"NO_DIR" | translate}}';
                var onTap = 'menu.locateBranchByLocalityAO';
                var buttontext = '<b>' + locateBranchLocAOVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            }
            else{
                if (utilityService.isIOSPlatform()) {
                  window.open('maps://?q=' + geocoords, '_system');
                }
                else {
                  var label = encodeURI('Your Destination'); // encode the label!
                  window.open('geo:0,0?q=' + geocoords + '(' + label + ')', '_system');
                }  
            }
        }

        $scope.goToHome = function() {
            accountOpeningHomeService.homeNav();
        }

        locateBranchLocAOVm.onChangeFn = function(value) {
            if (!utilityService.isUndefined(value)) {
                if (value.length == 3) {
                    locateBranchLocAOVm.loadBranchesLocality();
                }
            } else {
                locateBranchLocAOVm.bankListLocality = [];
                locateBranchLocAOVm.disableNext = true;
            }

        }

        //Make the radio button checked if the respective div is clicked
        locateBranchLocAOVm.checkDiv = function(param) {
            locateBranchLocAOVm.branchList = param.id;
            locateBranchLocAOVm.disableNext = false;
            accountOpeningHomeService.homeBranchLocalityId = param.id;
            accountOpeningHomeService.homeBranchLocalityCity = param.city;
        }

        locateBranchLocAOVm.onclickValidation = function(isValid) {
            locateBranchLocAOVm.hideOptions = true;
            for(var i=0;i<locateBranchLocAOVm.displayCities.length;i++){
                if(!utilityService.isUndefined(locateBranchLocAOVm.localityname)){
                    if(locateBranchLocAOVm.displayCities[i].toLowerCase() == locateBranchLocAOVm.localityname.toLowerCase()){
                        locateBranchLocAOVm.loadBranchesLocality();
                    }
                }
                else {
                    locateBranchLocAOVm.bankListLocality = [];
                    locateBranchLocAOVm.disableNext = true;
                }
                
            }
        }

        locateBranchLocAOVm.showHideFilterDropDown = function(city) {
            if (!utilityService.isUndefined(city)) {
                locateBranchLocAOVm.localityname = city;
                locateBranchLocAOVm.loadBranchesLocality();
            } else {
                locateBranchLocAOVm.hideOptions = false;
            }
        }

        locateBranchLocAOVm.getCountriesList = function() {
            locateNearestBranchServiceOVD.getAllCities().then(function(body) {
                if(!utilityService.isUndefined(body)){
                    for (var i = 0; i < body.length; i++) {                    
                        locateBranchLocAOVm.displayCities.push(body[i]);
                        locateBranchLocAOVm.displayCities.sort();
                    }
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }


        locateBranchLocAOVm.validateForm = function(isValid) {
            if (isValid) {
                locateBranchLocAOVm.disableNext = false;
            }
        }

        locateBranchLocAOVm.selectedBranch = function(param) {
            accountOpeningHomeService.branchname = param.branchName;
            accountOpeningHomeService.branchaddress = param.address;
            accountOpeningHomeService.homeBranchLocalityId = param.id;
            accountOpeningHomeService.homeBranchLocalityCity = param.city;
        }

        //Service for displaying branch list for locality
        locateBranchLocAOVm.loadBranchesLocality = function() {
            locateBranchLocAOVm.hideOptions = false;
            locateBranchLocAOVm.bankListLocality.length = 0;
            var params = {
                "locality": locateBranchLocAOVm.localityname
            }
            locateNearestBranchServiceOVD.getBranchesForLocality(params).then(function(data) {
                if (utilityService.isUndefined(data.branches) || data.branches.length === 0) {
                    var title = '';
                    var template = '{{"BRANCH_UNAVLBL" | translate}}';
                    var onTap = 'menu.locateBranchByLocalityAO';
                    var buttontext = '<b>' + locateBranchLocAOVm.okBtntext + '</b>';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                } else {
                    for (var i = 0; i < data.branches.length; i++) {
                        locateBranchLocAOVm.bankListLocality.push(data.branches[i]);
                    }
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            locateBranchLocAOVm.displayCities = [];
            locateBranchLocAOVm.getCountriesList();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);   
        });   

        return this;
    }
]);
