'use strict';

angularApp.controller('locateNearestBranchAOController', ["$state",
    "$scope",
    "accountOpeningHomeService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "currentLocationService",
    "$translate",
    "utilityService",
    "locateNearestBranchServiceOVD",

    function ($state,
        $scope,
        accountOpeningHomeService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        currentLocationService,
        $translate,
        utilityService,
        locateNearestBranchServiceOVD) {

        var locateNearestBranchAOVm = this;

        function initPage() {
            locateNearestBranchAOVm.showBack = true;
            locateNearestBranchAOVm.showNext = true;
            locateNearestBranchAOVm.disableNext = true;
            locateNearestBranchAOVm.byLocalityInput = true;
            locateNearestBranchAOVm.aofooter = true;
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                locateNearestBranchAOVm.okBtntext = translatedvalue;
            });
        }

        locateNearestBranchAOVm.goBacktoPrevious = function () {
            $state.go("menu.refPageAO");
        }

        locateNearestBranchAOVm.goToNextPage = function () {
            locateNearestBranchAOVm.redirectState();
        }

        $scope.goToHome = function () {
            accountOpeningHomeService.homeNav();
        }

        locateNearestBranchAOVm.redirectState = function () {
            if (locateNearestBranchAOVm.isGpsClicked === true) {
                $state.go('menu.locateBranchByGpsAO');
            } else {
                $state.go('menu.locateBranchByLocalityAO');
            }
        }

        locateNearestBranchAOVm.bylocality = function () {
            locateNearestBranchAOVm.isGpsClicked = false;
            locateNearestBranchAOVm.disableNext = false;
            locateNearestBranchAOVm.byLocalityInput = false;
        }

        locateNearestBranchAOVm.bygps = function () {

            CheckGPS.check(function () {
                currentLocationService.getCurrentPosition().then(
                    function (position) {
                        var latitude = position.coords.latitude;
                        var longitude = position.coords.longitude;

                        accountOpeningHomeService.locateByGPS.length = 0;
                        var params = {
                            "latitude": latitude,
                            "longitude": longitude
                        }
                        if (utilityService.isUndefined(accountOpeningHomeService.locateByGPS) || accountOpeningHomeService.locateByGPS.length === 0) {
                            locateNearestBranchServiceOVD.getBranchesForGeo(params).then(function (data) {
                                if (!utilityService.isUndefined(data)) {
                                    for (var i = 0; i < data.branches.length; i++) {
                                        accountOpeningHomeService.locateByGPS.push(data.branches[i]);
                                        locateNearestBranchAOVm.disableNext = false;
                                        setTimeout(function () {

                                            if (accountOpeningHomeService.locateByGPS.length == 0) {
                                                var title = '';
                                                var template = '{{"UNABLE_TO_GET_BRANCH" | translate}}';
                                                var onTap = "";//'menu.selectBranchOption';
                                                var buttontext = 'OK';
                                                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                                            }
                                        }, 300);
                                    }
                                }
                            }, function (error) {
                                utilityService.showErrorMessage(error.responseMessage);
                            });
                        }
                        else {

                        }
                    },
                    function (err) {
                        var title = '';
                        var template = '{{"ON_GPS" | translate}}';
                        var onTap = '';
                        var buttontext = '<b>' + locateNearestBranchAOVm.okBtntext + '</b>';
                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                    }
                );
            },
                function () {
                    var title = '';
                    var template = '{{"ENABLE_GPS" | translate}}';
                    var onTap = '';
                    var buttontext = 'OK';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                });
            locateNearestBranchAOVm.isGpsClicked = true;
            //locateNearestBranchAOVm.disableNext = false;
            locateNearestBranchAOVm.byLocalityInput = true;
        }

        locateNearestBranchAOVm.validateform = function (isValid) {
            locateNearestBranchAOVm.disableNext = false;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            accountOpeningHomeService.localityNav = "locateBranch";
            accountOpeningHomeService.localityNextDisable = "locateBranchList";
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
