'use strict';

angularApp.service('locateNearestBranchServiceOVD',
    function($q, AdapterUtils, constantConfig) {

        var locateNearestBranchServiceOVD = this;

        locateNearestBranchServiceOVD.getBranchesForLocality = function(params) {
           
             var q = $q.defer(); 
             AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.getBranchesForLocality, params, true).then(
                function(response){ 
                    q.resolve(response.data);
                },
                function(error){    
                    q.reject(error);
                }
            );
            return q.promise;

        };

        locateNearestBranchServiceOVD.getAllCities = function() {
           
             var q = $q.defer(); 
             AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.getAllCities, true).then(
                function(response){ 
                    q.resolve(response.body);
                },
                function(error){    
                    q.reject(error);
                }
            );
            return q.promise;


        };

        locateNearestBranchServiceOVD.getBranchesForGeo = function(params) {
            var q = $q.defer(); 
            AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.getBranchesForGeo + params.longitude + "&latitude=" + params.latitude + "&branchLocator=" + params.branchLocator, true).then(
                function(response){ 
                    q.resolve(response.data);
                },
                function(error){    
                    q.reject(error);
                }
            );
            return q.promise;
        };


        return locateNearestBranchServiceOVD;
    });
