'use strict';

angularApp.controller('guardianApplicantSameAddressAOController', ["$state",
    "$scope",
    "accountOpeningHomeService",
    "nomineeDetailsRelatedAOService",
    "utilityService",
    "$timeout",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
	"userLoginDetailsService",
	"currentAddressPDCService",
    "nomineeDetailsAOService",
    "enterOTPAOService",
    function($state,
        $scope,
        accountOpeningHomeService,
        nomineeDetailsRelatedAOService,
        utilityService,
        $timeout,
        $ionicSideMenuDelegate,
        mPinLoginService,
        userLoginDetailsService,
        currentAddressPDCService,
        nomineeDetailsAOService,
        enterOTPAOService) {

        var guardianApplicantSameAddressAOVm = this;

        function initPage() {

            guardianApplicantSameAddressAOVm.showBack = true;
            guardianApplicantSameAddressAOVm.showNext = true;
            guardianApplicantSameAddressAOVm.aofooter = true;
            guardianApplicantSameAddressAOVm.disableNext = true;
        }

        guardianApplicantSameAddressAOVm.goBacktoPrevious = function() {
            $state.go("menu.nomineeDetailsAddressOptionAO");
        }

        guardianApplicantSameAddressAOVm.changefn = function() {
            if (guardianApplicantSameAddressAOVm.isChecked) {
                guardianApplicantSameAddressAOVm.disableNext = false;
            } else {
                guardianApplicantSameAddressAOVm.disableNext = true;
            }
        }

        /*$scope.$watch("guardianApplicantSameAddressAOVm.guardian-appoint.$valid", function(value) {
            
            if (value == true) {
                guardianApplicantSameAddressAOVm.disableNext = false;
            } else {
                guardianApplicantSameAddressAOVm.disableNext = true;
            }
        });*/


        guardianApplicantSameAddressAOVm.setGuardianDetails = function() {
            var guardianDetails = {};
               guardianDetails.nomineeName = nomineeDetailsAOService.nominee.name;
               guardianDetails.guardianName = nomineeDetailsAOService.nominee.guardianName;
            return guardianDetails;
        }

        guardianApplicantSameAddressAOVm.goToNextPage = function() {
            var guardianDetailParams = guardianApplicantSameAddressAOVm.setGuardianDetails();
            
            nomineeDetailsAOService.guardian.guardianConsent = guardianApplicantSameAddressAOVm.isChecked;
            if (utilityService.isUndefined(guardianDetailParams.guardianName)) {
                var title = '';
                var template = '{{"IF_GUARDIAN_NAME_EMPTY" | translate}}';
                var onTap = 'menu.nomineeDetailsAO';
                var buttontext = 'OK';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            } else {
                //Service to update guardian details
                var params = {
                    "id": userLoginDetailsService.mobile,
                    "type" : "AO",
                    "data": {
                        "nominees": [{
                            "guardian": {
                                "address": {
                                    "type": "CURRENT_ADDR",
                                    "addressLine1": guardianApplicantSameAddressAOVm.personalDetails.addressLine1 ? guardianApplicantSameAddressAOVm.personalDetails.addressLine1.trim() : "",
                                    "addressLine2": guardianApplicantSameAddressAOVm.personalDetails.addressLine2 ? guardianApplicantSameAddressAOVm.personalDetails.addressLine2.trim() : "",
                                    "pincode": guardianApplicantSameAddressAOVm.personalDetails.pincode,
                                    "city": guardianApplicantSameAddressAOVm.personalDetails.city,
                                    "cityCode": guardianApplicantSameAddressAOVm.personalDetails.cityCode,
                                    "state": guardianApplicantSameAddressAOVm.personalDetails.state,
                                    "stateCode": guardianApplicantSameAddressAOVm.personalDetails.stateCode,
                                    "locality": guardianApplicantSameAddressAOVm.personalDetails.locality ? guardianApplicantSameAddressAOVm.personalDetails.locality.trim() : "",
                                    "districtCode": guardianApplicantSameAddressAOVm.personalDetails.districtCode,
                                    "district": guardianApplicantSameAddressAOVm.personalDetails.district
                                },
                                "name": guardianDetailParams.guardianName,
                                "guardianAddressFlag": nomineeDetailsAOService.guardian.guardianAddressFlag,
                                "guardianConsent": nomineeDetailsAOService.guardian.guardianConsent,
                                "guardianAge": nomineeDetailsAOService.nominee.guardianAge
                            },
                            "name": guardianDetailParams.nomineeName
                        }],
                        "commonId": $state.$current.data.commonId
                    }
                }
               
                nomineeDetailsRelatedAOService.updateGuardian(params).then(function(response) {
                    $state.go("menu.chequeBookServiceDetailsAO");
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        }

        $scope.goToHome = function() {
            accountOpeningHomeService.homeNav();
        }

        guardianApplicantSameAddressAOVm.fullAddress = function() {
            var address = "";
            if(nomineeDetailsAOService.guardian){
            guardianApplicantSameAddressAOVm.isChecked = Boolean(nomineeDetailsAOService.guardian.guardianConsent);
            }
            	guardianApplicantSameAddressAOVm.personalDetails.addressLine1 = accountOpeningHomeService.nullCheck(currentAddressPDCService.customerCorrespondenceAddress.address1);
                guardianApplicantSameAddressAOVm.personalDetails.addressLine2 = accountOpeningHomeService.nullCheck(currentAddressPDCService.customerCorrespondenceAddress.address2);
                guardianApplicantSameAddressAOVm.personalDetails.pincode = currentAddressPDCService.customerCorrespondenceAddress.pincode;
                guardianApplicantSameAddressAOVm.personalDetails.city = currentAddressPDCService.customerCorrespondenceAddress.city;
                guardianApplicantSameAddressAOVm.personalDetails.cityCode = currentAddressPDCService.customerCorrespondenceAddress.cityCode;
                guardianApplicantSameAddressAOVm.personalDetails.state = currentAddressPDCService.customerCorrespondenceAddress.state;
                guardianApplicantSameAddressAOVm.personalDetails.stateCode = currentAddressPDCService.customerCorrespondenceAddress.stateCode;
                guardianApplicantSameAddressAOVm.personalDetails.district = currentAddressPDCService.customerCorrespondenceAddress.district;
                guardianApplicantSameAddressAOVm.personalDetails.districtCode = currentAddressPDCService.customerCorrespondenceAddress.districtCode;
                guardianApplicantSameAddressAOVm.personalDetails.locality = currentAddressPDCService.customerCorrespondenceAddress.locality;

                if(guardianApplicantSameAddressAOVm.isAadhaarScanEntry || guardianApplicantSameAddressAOVm.isVID){
                    guardianApplicantSameAddressAOVm.personalDetails.address = accountOpeningHomeService.nullCheck(guardianApplicantSameAddressAOVm.personalDetails.addressLine1)+" "+ accountOpeningHomeService.nullCheck(guardianApplicantSameAddressAOVm.personalDetails.locality)+" "+ accountOpeningHomeService.nullCheck(guardianApplicantSameAddressAOVm.personalDetails.addressLine2)+" "+ accountOpeningHomeService.nullCheck(guardianApplicantSameAddressAOVm.personalDetails.district);
                }else{
                    guardianApplicantSameAddressAOVm.personalDetails.address = accountOpeningHomeService.nullCheck(guardianApplicantSameAddressAOVm.personalDetails.addressLine1)+" " + accountOpeningHomeService.nullCheck(guardianApplicantSameAddressAOVm.personalDetails.addressLine2);
                }
                
              
              
            if (!utilityService.isUndefined(guardianApplicantSameAddressAOVm.personalDetails.addressLine1)) {
                var index = guardianApplicantSameAddressAOVm.personalDetails.addressLine1.lastIndexOf(",");
                guardianApplicantSameAddressAOVm.personalDetails.addressLine1 = guardianApplicantSameAddressAOVm.personalDetails.addressLine1.substring(0, index) + guardianApplicantSameAddressAOVm.personalDetails.addressLine1.substring(index + 1);
            }
            if (!utilityService.isUndefined(guardianApplicantSameAddressAOVm.personalDetails.addressLine2)) {
                var index = guardianApplicantSameAddressAOVm.personalDetails.addressLine2.lastIndexOf(",");
                guardianApplicantSameAddressAOVm.personalDetails.addressLine2 = guardianApplicantSameAddressAOVm.personalDetails.addressLine2.substring(0, index) + guardianApplicantSameAddressAOVm.personalDetails.addressLine2.substring(index + 1);
            }
            if (!utilityService.isUndefined(guardianApplicantSameAddressAOVm.personalDetails.address)) {
                var index = guardianApplicantSameAddressAOVm.personalDetails.address.lastIndexOf(",");
                guardianApplicantSameAddressAOVm.personalDetails.address = guardianApplicantSameAddressAOVm.personalDetails.address.substring(0, index) + guardianApplicantSameAddressAOVm.personalDetails.address.substring(index + 1);
            }
        }

        guardianApplicantSameAddressAOVm.guardianDetails = function() {
           
                guardianApplicantSameAddressAOVm.guardianConName = nomineeDetailsAOService.nominee.guardianName;
                guardianApplicantSameAddressAOVm.guardianConAge = nomineeDetailsAOService.nominee.guardianAge;
         
            
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            guardianApplicantSameAddressAOVm.isAadhaarScanEntry = enterOTPAOService.isAadhaarScanEntry;
            guardianApplicantSameAddressAOVm.isVID = enterOTPAOService.isVID;
            guardianApplicantSameAddressAOVm.personalDetails = {};
            guardianApplicantSameAddressAOVm.fullAddress();
            if (guardianApplicantSameAddressAOVm.isChecked == true) {
                guardianApplicantSameAddressAOVm.disableNext = false;
            } else {
                guardianApplicantSameAddressAOVm.disableNext = true;
            }
            guardianApplicantSameAddressAOVm.guardianDetails();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
