'use strict';

angularApp.controller('nomineeAddressDetailsAOController', ["$state",
    "$scope",
    "utilityService",
    "nomineeDetailsRelatedAOService",
    "accountOpeningHomeService",
    "$translate",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "userLoginDetailsService",
    "nomineeDetailsAOService",
    "currentAddressPDCService",
    "enterOTPAOService",
    function ($state,
        $scope,
        utilityService,
        nomineeDetailsRelatedAOService,
        accountOpeningHomeService,
        $translate,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService,
        userLoginDetailsService,
        nomineeDetailsAOService,
        currentAddressPDCService,
        enterOTPAOService) {

        var nomineeAddressDetailsAOVm = this;

        function initPage() {
            nomineeAddressDetailsAOVm.showBack = true;
            nomineeAddressDetailsAOVm.showNext = true;
            nomineeAddressDetailsAOVm.nomineeAge;
            nomineeAddressDetailsAOVm.dob;
            nomineeAddressDetailsAOVm.nomineeGuardianName = "";
            nomineeAddressDetailsAOVm.guardianAge = "";
            nomineeAddressDetailsAOVm.aofooter = true;
            nomineeAddressDetailsAOVm.invalid = false;
            nomineeAddressDetailsAOVm.properDate = false;
            nomineeDetailsAOService.nomineeNav = "nomineedetails";
            nomineeAddressDetailsAOVm.validCityState = false;
            nomineeAddressDetailsAOVm.isAddress1Modified = false;
            nomineeAddressDetailsAOVm.isAddress2Modified = false;
            nomineeAddressDetailsAOVm.isCityModified = false;
            nomineeAddressDetailsAOVm.isStateModified = false;
            nomineeAddressDetailsAOVm.isPincodeModified = false;
            nomineeAddressDetailsAOVm.disableAddress1 = false;
            nomineeAddressDetailsAOVm.disableAddress2 = false;
            nomineeAddressDetailsAOVm.disableCity = true;
            nomineeAddressDetailsAOVm.disablePincode = false;
            nomineeAddressDetailsAOVm.disableState = true;
            nomineeAddressDetailsAOVm.nomineeStateShow = true;
            nomineeAddressDetailsAOVm.digitalAadhaarConstant = constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar;
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                nomineeAddressDetailsAOVm.okBtntext = translatedvalue;
            });
        }

        nomineeAddressDetailsAOVm.goBacktoPrevious = function() {

            if (nomineeAddressDetailsAOVm.applicantChecked && (nomineeAddressDetailsAOVm.isAadhaarScanEntry || nomineeAddressDetailsAOVm.isVID)) {
                nomineeDetailsAOService.nominee.address1 = currentAddressPDCService.customerCorrespondenceAddress.address1;
                nomineeDetailsAOService.nominee.address2 = currentAddressPDCService.customerCorrespondenceAddress.address2;
                }else{
                nomineeDetailsAOService.nominee.address1 = nomineeAddressDetailsAOVm.addressAboveData;
                nomineeDetailsAOService.nominee.address2 = nomineeAddressDetailsAOVm.addressBelowData;
                }
                nomineeDetailsAOService.nominee.pincode = nomineeAddressDetailsAOVm.pincodeData;
                nomineeDetailsAOService.nominee.city = nomineeAddressDetailsAOVm.cityData;
                nomineeDetailsAOService.nominee.locality = nomineeAddressDetailsAOVm.locality;
                nomineeDetailsAOService.nominee.district = nomineeAddressDetailsAOVm.district;
                nomineeDetailsAOService.nominee.state = nomineeAddressDetailsAOVm.stateData;
                nomineeDetailsAOService.nominee.sameAsApplicantAddress = nomineeAddressDetailsAOVm.applicantChecked;
				$state.go("menu.nomineeDetailsAO");
        }

        nomineeAddressDetailsAOVm.setRequestParams = function () {
            var params = {};
            params = {
                "id": userLoginDetailsService.mobile,
                "type": "AO",
                "data": {
                    "nominees": [{
                        "name": nomineeDetailsAOService.nominee.name,
                        "relationship": nomineeDetailsAOService.nominee.relationship,
                        "age": nomineeDetailsAOService.nominee.age,
                        "dob": nomineeDetailsAOService.nominee.dob,
                        "guardianConsent": false,
                        "sameAsApplicantAddress": nomineeAddressDetailsAOVm.applicantChecked,
                        "address": {
                            "type": "CURRENT_ADDR",
                            // "locality": "string",
                            "addressLine1": nomineeDetailsAOService.nominee.address1,
                            "addressLine2": nomineeDetailsAOService.nominee.address2,
                            "pincode": nomineeDetailsAOService.nominee.pincode,
                            "locality": nomineeDetailsAOService.nominee.locality,
                            "city": nomineeDetailsAOService.nominee.city,
                            "cityCode": nomineeDetailsAOService.nominee.cityCode,
                            "state": nomineeDetailsAOService.nominee.stateName,
                            "stateCode": nomineeDetailsAOService.nominee.stateCode,
                            "districtCode": nomineeDetailsAOService.nominee.districtCode,
                            "district": nomineeDetailsAOService.nominee.district //,
                            // "subDist": "",
                            // "subDistrictCode": "",
                            // "village": "",
                            // "villageCode": ""
                        },
                        "guardian": {
                            "name": nomineeDetailsAOService.nominee.guardianName,
                            "guardianAge": nomineeDetailsAOService.nominee.guardianAge
                        }

                    }],
                    "commonId": $state.$current.data.commonId
                }
            }
            return params;
        }
        nomineeAddressDetailsAOVm.goToNextPage = function () {
            var addressLength;
                if (nomineeAddressDetailsAOVm.applicantChecked && (nomineeAddressDetailsAOVm.isAadhaarScanEntry || nomineeAddressDetailsAOVm.isVID)) {
                nomineeDetailsAOService.nominee.address1 = currentAddressPDCService.customerCorrespondenceAddress.address1;
                nomineeDetailsAOService.nominee.address2 = currentAddressPDCService.customerCorrespondenceAddress.address2;
                }else{
                nomineeDetailsAOService.nominee.address1 = nomineeAddressDetailsAOVm.addressAboveData;
                nomineeDetailsAOService.nominee.address2 = nomineeAddressDetailsAOVm.addressBelowData;
                }
                nomineeDetailsAOService.nominee.pincode = nomineeAddressDetailsAOVm.pincodeData;
                nomineeDetailsAOService.nominee.city = nomineeAddressDetailsAOVm.cityData;
                nomineeDetailsAOService.nominee.locality = nomineeAddressDetailsAOVm.locality;
                nomineeDetailsAOService.nominee.district = nomineeAddressDetailsAOVm.district;
                nomineeDetailsAOService.nominee.state = nomineeAddressDetailsAOVm.stateData;
                nomineeDetailsAOService.nominee.sameAsApplicantAddress = nomineeAddressDetailsAOVm.applicantChecked;
                addressLength = nomineeDetailsAOService.nominee.address1.length + nomineeDetailsAOService.nominee.address2.length;
                nomineeDetailsAOService.nominee.stateCode = nomineeAddressDetailsAOVm.selectdState;

            /* If nominee address length is greater than 60 */          
            if (addressLength > 60) {
                var title = '';
                var template = '{{"MAX_CHAR" | translate}}';
                var onTap = '';
                var buttontext = '<b>' + nomineeAddressDetailsAOVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            } else {
                //Service to update nominee details
                var requestParams = nomineeAddressDetailsAOVm.setRequestParams();
                nomineeDetailsRelatedAOService.createNominee(requestParams).then(function (response) {
                    if (!utilityService.isUndefined(nomineeAddressDetailsAOVm.nomineeGuardianName) || nomineeAddressDetailsAOVm.nomineeAge < constantConfig.acOp.nomineeAge) {
                        $state.go("menu.nomineeDetailsAddressOptionAO");
                    } else {
                        $state.go("menu.chequeBookServiceDetailsAO");
                    }

                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        }

        $scope.goToHome = function () {
            //nomineeDetailsAOService.homeNav();
            accountOpeningHomeService.homeNav();
        }

        nomineeAddressDetailsAOVm.goBack = function () {
            nomineeAddressDetailsAOVm.nomineeName = "";
            nomineeAddressDetailsAOVm.nomineeDetailsFirstForm.$setPristine();
            nomineeAddressDetailsAOVm.nomineeRelationship = "";
            nomineeAddressDetailsAOVm.nomineeAge = null;
            nomineeAddressDetailsAOVm.dob = "";
            nomineeAddressDetailsAOVm.nomineeGuardianName = "";
            nomineeAddressDetailsAOVm.guardianAge = "";
            nomineeAddressDetailsAOVm.addressAboveData = "";
            nomineeAddressDetailsAOVm.addressBelowData = "";
            nomineeAddressDetailsAOVm.pincodeData = null;
            nomineeAddressDetailsAOVm.cityData = "";
            nomineeAddressDetailsAOVm.locality = "";
            nomineeAddressDetailsAOVm.district = "";
            nomineeAddressDetailsAOVm.stateData = "";
            nomineeAddressDetailsAOVm.nomineeDobDay = null;
            nomineeAddressDetailsAOVm.nomineeDobMonth = null;
            nomineeAddressDetailsAOVm.nomineeDobYear = null;
            nomineeDetailsAOService.isNomineeAddress1Changed = false;
            nomineeDetailsAOService.isNomineeAddress2Changed = false;
            //$state.go('');
        }

        nomineeAddressDetailsAOVm.goNext = function () {
            nomineeDetailsAOService.nominee.name = nomineeAddressDetailsAOVm.nomineeName;
            nomineeDetailsAOService.nominee.relationship = nomineeAddressDetailsAOVm.nomineeRelationship;
            nomineeDetailsAOService.nominee.age = nomineeAddressDetailsAOVm.nomineeAge;
            nomineeDetailsAOService.nominee.dob = nomineeAddressDetailsAOVm.dob;
            nomineeDetailsAOService.nominee.guardianName = nomineeAddressDetailsAOVm.nomineeGuardianName;
            nomineeDetailsAOService.nominee.guardianAge = nomineeAddressDetailsAOVm.guardianAge;
            $state.go('menu.nomineeAddressDetailsAO');
        };
        //On page load - Split the aadhaar card holder's name and display accordingly
        nomineeAddressDetailsAOVm.displayNames = function (value) {
            var fullName = value;
            var splittedName = value.split(" ");
            var splitLen = value.split(" ").length;
            var i;
            var middleName = [];

            if (splitLen === 2) {
                nomineeAddressDetailsAOVm.firstName = splittedName[0];
                nomineeAddressDetailsAOVm.lastName = splittedName[1];
                nomineeAddressDetailsAOVm.isMName = false;
            } else {
                nomineeAddressDetailsAOVm.isMName = true;
                nomineeAddressDetailsAOVm.firstName = splittedName[0];
                for (i = 1; i < splitLen - 1; i++) {
                    middleName[i] = splittedName[i];
                }
                nomineeAddressDetailsAOVm.middleName = middleName.join(' ');
                nomineeAddressDetailsAOVm.lastName = splittedName[splitLen - 1];
            }
        };

        /* Display Nominee details after scan or manual entry */
        nomineeAddressDetailsAOVm.displayNomineeAdharDetails = function () {
            nomineeAddressDetailsAOVm.nomineeName = nomineeDetailsAOService.nominee.name;
            nomineeAddressDetailsAOVm.nomineeGuardianName = nomineeDetailsAOService.nominee.guardianName;
            nomineeAddressDetailsAOVm.guardianAge = nomineeDetailsAOService.nominee.guardianAge;
            nomineeAddressDetailsAOVm.nomineeRelationship = nomineeDetailsAOService.nominee.relationship;
            nomineeAddressDetailsAOVm.dob = nomineeDetailsAOService.nominee.dob;

            if(nomineeAddressDetailsAOVm.isAadhaarScanEntry || nomineeAddressDetailsAOVm.isVID){
            nomineeAddressDetailsAOVm.addressAboveData = (nomineeDetailsAOService.nominee.address1 ? nomineeDetailsAOService.nominee.address1 : "") + (nomineeDetailsAOService.nominee.locality ? nomineeDetailsAOService.nominee.locality : "");
            nomineeAddressDetailsAOVm.addressBelowData = (nomineeDetailsAOService.nominee.address2 ? nomineeDetailsAOService.nominee.address2 : "") + (nomineeDetailsAOService.nominee.district ? nomineeDetailsAOService.nominee.district : "");  
            }else{
            nomineeAddressDetailsAOVm.addressAboveData = nomineeDetailsAOService.nominee.address1;
            nomineeAddressDetailsAOVm.addressBelowData = nomineeDetailsAOService.nominee.address2;
            }
            

            nomineeAddressDetailsAOVm.applicantChecked = Boolean(nomineeDetailsAOService.nominee.sameAsApplicantAddress);
            
            if (!utilityService.isUndefined(nomineeDetailsAOService.nominee.pincode))
                nomineeAddressDetailsAOVm.pincodeData = parseInt(nomineeDetailsAOService.nominee.pincode);
            nomineeAddressDetailsAOVm.cityData = nomineeDetailsAOService.nominee.city;
            nomineeAddressDetailsAOVm.locality = nomineeDetailsAOService.nominee.locality;
            nomineeAddressDetailsAOVm.district = nomineeDetailsAOService.nominee.district;
            // nomineeDetailsAOService.nominee.cityCode = currentAddressPDCService.customerCorrespondenceAddress.cityCode;
            // nomineeDetailsAOService.nominee.stateCode = currentAddressPDCService.customerCorrespondenceAddress.stateCode;
            // nomineeDetailsAOService.nominee.districtCode = currentAddressPDCService.customerCorrespondenceAddress.districtCode;
            // nomineeDetailsAOService.nominee.district = currentAddressPDCService.customerCorrespondenceAddress.district;
            nomineeAddressDetailsAOVm.stateData = nomineeDetailsAOService.nominee.state;

        }

        /* Method to calculate age */
        nomineeAddressDetailsAOVm.calculateAge = function () {
            var todayDateAge = new Date();
            var bornNewDate = new Date(nomineeAddressDetailsAOVm.nomineeDobYear, nomineeAddressDetailsAOVm.nomineeDobMonth - 1, nomineeAddressDetailsAOVm.nomineeDobDay);
            var age = Math.floor((todayDateAge.getTime() - bornNewDate.getTime()) / (365.25 * 24 * 60 * 60 * 1000));
            return age;
        }

        /* Populate Date of birth from aadhaar / resume journey  -
        If (From aadhaar, dob format is different and therefore formatting it)
        Else(From aadhaar, yob alone received, then keep date and month fields empty to make the user to enter)
        */
        nomineeAddressDetailsAOVm.populateDobAadhaar = function (dateValue) {
            if (utilityService.isUndefined(nomineeAddressDetailsAOVm.nomineeDobYear) || utilityService.isUndefined(nomineeAddressDetailsAOVm.nomineeDobMonth) || utilityService.isUndefined(nomineeAddressDetailsAOVm.nomineeDobDay)) {
                if (!utilityService.isUndefined(dateValue)) {
                    dateValue = moment(dateValue, ["DD/MM/YYYY", "MM/DD/YYYY", "DD-MM-YYYY", "MM-DD-YYYY", "YYYY-MM-DD", "YYYY-DD-MM", "YYYY/MM/DD", "YYYY/DD/MM"]);
                    var dateFormat = new Date(dateValue);
                    var day = dateFormat.getDate();
                    var month = dateFormat.getMonth() + 1;
                    var year = dateFormat.getFullYear();
                    var formattedDate = day.toString();
                    if (formattedDate.length == 1) {
                        formattedDate = "0" + formattedDate;
                        nomineeAddressDetailsAOVm.nomineeDobDay = formattedDate;
                    } else {
                        nomineeAddressDetailsAOVm.nomineeDobDay = parseInt(day);
                    }
                    var formattedMonth = month.toString();
                    if (formattedMonth.length == 1) {
                        formattedMonth = "0" + formattedMonth;
                        nomineeAddressDetailsAOVm.nomineeDobMonth = formattedMonth;
                    } else {
                        nomineeAddressDetailsAOVm.nomineeDobMonth = parseInt(month);
                    }
                    nomineeAddressDetailsAOVm.nomineeDobYear = parseInt(year);
                    var fullDate = nomineeAddressDetailsAOVm.nomineeDobMonth + '-' + nomineeAddressDetailsAOVm.nomineeDobDay + '-' + nomineeAddressDetailsAOVm.nomineeDobYear;

                    var formattedNewDate = new Date();
                    formattedNewDate.setFullYear(nomineeAddressDetailsAOVm.nomineeDobYear, nomineeAddressDetailsAOVm.nomineeDobMonth - 1, nomineeAddressDetailsAOVm.nomineeDobDay);

                    var todayDate = new Date();
                    var currentYear = todayDate.getFullYear();
                    var validYear = todayDate.setFullYear(currentYear - constantConfig.acOp.nomineeAge);
                    nomineeAddressDetailsAOVm.nomineeAge = nomineeAddressDetailsAOVm.calculateAge();


                } else if (!utilityService.isUndefined(nomineeDetailsAOService.nomineeAadhaarCardDetails.yob) && utilityService.isUndefined(nomineeDetailsAOService.nomineeAadhaarCardDetails.dob)) {
                    nomineeAddressDetailsAOVm.nomineeDobDay = "";
                    nomineeAddressDetailsAOVm.nomineeDobMonth = "";
                    nomineeAddressDetailsAOVm.nomineeDobYear = parseInt(nomineeDetailsAOService.nomineeAadhaarCardDetails.yob);
                }
            }
        }

        /* From aadhaar, address comes splitted and therefore clubbing the fields which are required for address line 1 */
        nomineeAddressDetailsAOVm.concatAadharAddress1 = function () {
            var fullAddr = "";
            if (utilityService.isUndefined(nomineeDetailsAOService.nomineeAadhaarCardDetails.address1)) {
                fullAddr = nomineeDetailsAOService.nullCheck(nomineeDetailsAOService.nomineeAadhaarCardDetails.house) + nomineeDetailsAOService.nullCheck(nomineeDetailsAOService.nomineeAadhaarCardDetails.street);
                var index = fullAddr.lastIndexOf(",");
                fullAddr = fullAddr.substring(0, index) + fullAddr.substring(index + 1);
            } else {
                fullAddr = nomineeDetailsAOService.nomineeAadhaarCardDetails.address1;
            }
            return fullAddr;
        }

        /* From aadhaar, address comes splitted and therefore clubbing the fields which are required for address line 2 */
        nomineeAddressDetailsAOVm.concatAadharAddress2 = function () {
            var fullAddr = "";
            if (utilityService.isUndefined(nomineeDetailsAOService.nomineeAadhaarCardDetails.address2)) {
                fullAddr = nomineeDetailsAOService.nullCheck(nomineeDetailsAOService.nomineeAadhaarCardDetails.loc) + nomineeDetailsAOService.nullCheck(nomineeDetailsAOService.nomineeAadhaarCardDetails.vtc) + nomineeDetailsAOService.nullCheck(nomineeDetailsAOService.nomineeAadhaarCardDetails.po) + nomineeDetailsAOService.nullCheck(nomineeDetailsAOService.nomineeAadhaarCardDetails.subdist);
                var index = fullAddr.lastIndexOf(",");
                fullAddr = fullAddr.substring(0, index) + fullAddr.substring(index + 1);
            } else {
                fullAddr = nomineeDetailsAOService.nomineeAadhaarCardDetails.address2;
            }
            return fullAddr;
        }

        nomineeAddressDetailsAOVm.validateInputs = function (isValid) {
            if (nomineeAddressDetailsAOVm.validDate === true && isValid === true) {
                nomineeAddressDetailsAOVm.disableNext = !isValid;
            } else if (nomineeAddressDetailsAOVm.validDate === true && isValid === false) {
                nomineeAddressDetailsAOVm.disableNext = true;
            } else if (nomineeAddressDetailsAOVm.validDate === false && isValid === false) {
                nomineeAddressDetailsAOVm.disableNext = true;
            }
            return nomineeAddressDetailsAOVm.disableNext;
        }

        /* Date Validation */
        nomineeAddressDetailsAOVm.dateValidation = function (isValid) {
            var fullDate = nomineeAddressDetailsAOVm.nomineeDobMonth + '-' + nomineeAddressDetailsAOVm.nomineeDobDay + '-' + nomineeAddressDetailsAOVm.nomineeDobYear;
            var dobMonth = nomineeAddressDetailsAOVm.nomineeDobMonth;
            var dobDay = nomineeAddressDetailsAOVm.nomineeDobDay;
            var dobYr = nomineeAddressDetailsAOVm.nomineeDobYear;
            var fullDateInMilliSeconds = Date.parse(fullDate);
            var formattedDate = new Date();
            var formattedDateYr = formattedDate.getFullYear();
            var currDate = new Date();
            var curYear = currDate.getFullYear();
            var curDateInMilliSeconds = new Date().getTime();
            formattedDate.setFullYear(dobYr, dobMonth - 1, dobDay);
            var months30 = ["04", "06", "09", "11", "4", "6", "9"];
            var monthIndex = months30.indexOf(dobMonth);

            if (fullDateInMilliSeconds > curDateInMilliSeconds) {
                nomineeAddressDetailsAOVm.disableNext = true;
                nomineeAddressDetailsAOVm.invalid = true;
                nomineeAddressDetailsAOVm.properDate = false;
            } else if (dobYr % 4 == 0 && (dobYr % 100 != 0 || dobYr % 400 == 0)) {
                if (dobMonth == 2 && dobDay > 29) {
                    nomineeAddressDetailsAOVm.disableNext = true;
                    nomineeAddressDetailsAOVm.invalid = true;
                    nomineeAddressDetailsAOVm.properDate = false;
                } else if (monthIndex != -1 && dobDay == 31) {
                    nomineeAddressDetailsAOVm.disableNext = true;
                    nomineeAddressDetailsAOVm.invalid = true;
                    nomineeAddressDetailsAOVm.properDate = false;
                } else {
                    nomineeAddressDetailsAOVm.disableNext = !isValid;
                    nomineeAddressDetailsAOVm.invalid = false;
                    nomineeAddressDetailsAOVm.properDate = true;
                }

            } else if (dobMonth == 2 && dobDay >= 29) {
                nomineeAddressDetailsAOVm.disableNext = true;
                nomineeAddressDetailsAOVm.invalid = true;
                nomineeAddressDetailsAOVm.properDate = false;
            } else if (monthIndex != -1 && dobDay == 31) {
                nomineeAddressDetailsAOVm.disableNext = true;
                nomineeAddressDetailsAOVm.invalid = true;
                nomineeAddressDetailsAOVm.properDate = false;

            } else {
                nomineeAddressDetailsAOVm.disableNext = !isValid;
                nomineeAddressDetailsAOVm.invalid = false;
                nomineeAddressDetailsAOVm.properDate = true;

            }
            if (dobDay < 10 && dobDay.length == 1) {
                nomineeAddressDetailsAOVm.disableNext = true;
                nomineeAddressDetailsAOVm.invalid = true;
                nomineeAddressDetailsAOVm.properDate = false;
            }
            if (dobMonth < 10 && dobMonth.length == 1) {
                nomineeAddressDetailsAOVm.disableNext = true;
                nomineeAddressDetailsAOVm.invalid = true;
                nomineeAddressDetailsAOVm.properDate = false;
            }
            return nomineeAddressDetailsAOVm.properDate;
        }

        /* Date Validation */
        nomineeAddressDetailsAOVm.checkValidDate = function (isValid) {

            nomineeAddressDetailsAOVm.validDateFormat = nomineeAddressDetailsAOVm.dateValidation();

            if (nomineeAddressDetailsAOVm.validDateFormat == true) {
                var fullDate = nomineeAddressDetailsAOVm.nomineeDobMonth + '/' + nomineeAddressDetailsAOVm.nomineeDobDay + '/' + nomineeAddressDetailsAOVm.nomineeDobYear;
                var dateDMY = nomineeAddressDetailsAOVm.nomineeDobDay + '-' + nomineeAddressDetailsAOVm.nomineeDobMonth + '-' + nomineeAddressDetailsAOVm.nomineeDobYear;
                var formattedDate = new Date();
                formattedDate.setFullYear(nomineeAddressDetailsAOVm.nomineeDobYear, nomineeAddressDetailsAOVm.nomineeDobMonth - 1, nomineeAddressDetailsAOVm.nomineeDobDay);
                var todayDate = new Date();
                var currentYear = todayDate.getFullYear();
                var validYear = todayDate.setFullYear(currentYear - constantConfig.acOp.nomineeAge);
                nomineeAddressDetailsAOVm.nomineeAge = nomineeAddressDetailsAOVm.calculateAge();

                nomineeAddressDetailsAOVm.dob = dateDMY;
                if (isNaN(nomineeAddressDetailsAOVm.nomineeAge) === false && nomineeAddressDetailsAOVm.nomineeAge >= constantConfig.acOp.nomineeAge || nomineeAddressDetailsAOVm.nomineeAge < constantConfig.acOp.nomineeAge) {
                    nomineeAddressDetailsAOVm.validDate = true;
                } else if (isNaN(nomineeAddressDetailsAOVm.nomineeAge) === true) {
                    nomineeAddressDetailsAOVm.validDate = false;
                }
                if (nomineeAddressDetailsAOVm.validDate === true && isValid === true) {
                    nomineeAddressDetailsAOVm.disableNext = false;
                } else if (nomineeAddressDetailsAOVm.validDate === false && isValid === false) {
                    nomineeAddressDetailsAOVm.disableNext = true;
                } else if (nomineeAddressDetailsAOVm.validDate === true && isValid === false) {
                    nomineeAddressDetailsAOVm.disableNext = true;
                }

            } else if (nomineeAddressDetailsAOVm.validDateFormat === false) {
                nomineeAddressDetailsAOVm.disableNext = true;
            }
            return nomineeAddressDetailsAOVm.disableNext;
        }

        nomineeAddressDetailsAOVm.checkGuardian = function () {
            var required = false;

            if (isNaN(nomineeAddressDetailsAOVm.nomineeAge) === false && !utilityService.isUndefined(nomineeAddressDetailsAOVm.nomineeAge)) {
                if (nomineeAddressDetailsAOVm.nomineeAge >= constantConfig.acOp.nomineeAge) {
                    required = false;
                } else {
                    required = true;
                }
            }
            return required;
        }

        nomineeAddressDetailsAOVm.disableGuardian = function () {
            var disable = true;
            if (isNaN(nomineeAddressDetailsAOVm.nomineeAge) === false && !utilityService.isUndefined(nomineeAddressDetailsAOVm.nomineeAge)) {
                if (nomineeAddressDetailsAOVm.nomineeAge >= constantConfig.acOp.nomineeAge) {
                    disable = true;
                    nomineeAddressDetailsAOVm.nomineeGuardianName = "";
                    nomineeAddressDetailsAOVm.guardianAge = "";
                } else {
                    disable = false;
                }
            }
            return disable;
        }

        $scope.ageAbove18Pattern = (function () {
            var regexp = /^(1[89]|[2-9][0-9])$/;
            return {
                test: function (value) {
                    if (nomineeAddressDetailsAOVm.checkGuardian() === false) {
                        return true;
                    }
                    return regexp.test(value);
                }
            };
        })();

        $scope.namePattern = (function () {
            var regexp = /^([ \.]?[a-zA-Z]+)+$/;
            return {
                test: function (value) {
                    if (nomineeAddressDetailsAOVm.checkGuardian() === false) {
                        return true;
                    }
                    return regexp.test(value);
                }
            };
        })();

        nomineeAddressDetailsAOVm.concatCustomerAddressline1 = function () {
            var fullAddr = "";
            if (nomineeDetailsAOService.isResumeJourney === false) {
                fullAddr = nomineeDetailsAOService.nullCheck(nomineeDetailsAOService.customerAadhaarCardDetails.house) + nomineeDetailsAOService.nullCheck(nomineeDetailsAOService.customerAadhaarCardDetails.street);
                var index = fullAddr.lastIndexOf(",");
                fullAddr = fullAddr.substring(0, index) + fullAddr.substring(index + 1);
            } else {
                fullAddr = nomineeDetailsAOService.customerAadhaarCardDetails.addressLine1;
            }
            return fullAddr;
        }

        nomineeAddressDetailsAOVm.concatCustomerAddressline2 = function () {
            var fullAddr = "";
            if (accountOpeningHomeService.isResumeJourney === false) {
                fullAddr = nomineeDetailsAOService.nullCheck(nomineeDetailsAOService.customerAadhaarCardDetails.loc) + nomineeDetailsAOService.nullCheck(nomineeDetailsAOService.customerAadhaarCardDetails.vtc) + nomineeDetailsAOService.nullCheck(nomineeDetailsAOService.customerAadhaarCardDetails.po) + nomineeDetailsAOService.nullCheck(nomineeDetailsAOService.customerAadhaarCardDetails.subdist);
                var index = fullAddr.lastIndexOf(",");
                fullAddr = fullAddr.substring(0, index) + fullAddr.substring(index + 1);
            } else {
                fullAddr = nomineeDetailsAOService.customerAadhaarCardDetails.addressLine2;
            }

            return fullAddr;
        }

        nomineeAddressDetailsAOVm.validateNomineeAddrInputs = function (isValid) {
            nomineeAddressDetailsAOVm.disableNomineeAddrNext = !isValid;
        }

        /* Based on Pincode, auto-populate city and state fields*/
        nomineeAddressDetailsAOVm.updateCityState = function (isValid) {
            nomineeAddressDetailsAOVm.npincode = nomineeAddressDetailsAOVm.pincodeData;
            if (!utilityService.isUndefined(nomineeAddressDetailsAOVm.npincode)) {
                nomineeAddressDetailsAOVm.isPincodeModified = true;
            }
            if (nomineeAddressDetailsAOVm.nomineeAddressForm.pincode.$valid === true) {
                var inputparams = {
                    "pinCode": nomineeAddressDetailsAOVm.pincodeData
                }
                nomineeDetailsRelatedAOService.getAreaDetailForPincode(inputparams).then(function (data) {
                    //Success - Data
                    if (utilityService.isUndefined(data)) {
                        var title = '';
                        var template = '{{"PINCODE_MATCH" | translate}}';
                        var onTap = '';
                        var buttontext = '<b>' + nomineeAddressDetailsAOVm.okBtntext + '</b>';
                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                        nomineeAddressDetailsAOVm.disableState = false;
                        nomineeAddressDetailsAOVm.disableCity = false;
                        nomineeAddressDetailsAOVm.selectStateList = "";
                    } else {
                        nomineeAddressDetailsAOVm.selectStateList = data;
                        nomineeDetailsAOService.customer.city = utilityService.getValue(data.cityName);
                        nomineeDetailsAOService.customer.state = utilityService.getValue(data.stateName);
                        nomineeDetailsAOService.nominee.cityCode = utilityService.getValue(data.cityCode);
                        nomineeDetailsAOService.nominee.stateCode = utilityService.getValue(data.stateCode);
                        nomineeDetailsAOService.nominee.district = utilityService.getValue(data.districtName);
                        nomineeDetailsAOService.nominee.districtCode = utilityService.getValue(data.districtCode);
                        nomineeAddressDetailsAOVm.cityData = nomineeDetailsAOService.customer.city;
                        nomineeAddressDetailsAOVm.stateData = nomineeDetailsAOService.customer.state;
                        nomineeAddressDetailsAOVm.ncity = nomineeAddressDetailsAOVm.cityData;
                        nomineeAddressDetailsAOVm.nstate = nomineeAddressDetailsAOVm.stateData;
                        if (!utilityService.isUndefined(nomineeAddressDetailsAOVm.ncity)) {
                            nomineeAddressDetailsAOVm.isCityModified = true;
                        }
                        if (!utilityService.isUndefined(nomineeAddressDetailsAOVm.nstate)) {
                            nomineeAddressDetailsAOVm.isStateModified = true;
                        }

                        if(nomineeAddressDetailsAOVm.selectStateList.length == 1){
                            nomineeAddressDetailsAOVm.stateData = nomineeAddressDetailsAOVm.selectStateList[0].stateCode;
                            nomineeDetailsAOService.nominee.stateName = nomineeAddressDetailsAOVm.selectStateList[0].stateName;
                            nomineeDetailsAOService.nominee.district = nomineeAddressDetailsAOVm.selectStateList[0].districtName;
                            nomineeDetailsAOService.nominee.districtCode = nomineeAddressDetailsAOVm.selectStateList[0].districtCode;
                            nomineeDetailsAOService.nominee.stateCode = nomineeAddressDetailsAOVm.selectStateList[0].stateCode;
                            nomineeDetailsAOService.nominee.city = nomineeAddressDetailsAOVm.selectStateList[0].cityName;
                            nomineeDetailsAOService.nominee.cityCode = nomineeAddressDetailsAOVm.selectStateList[0].cityCode;
                            nomineeAddressDetailsAOVm.loadState(nomineeAddressDetailsAOVm.pincodeData, nomineeAddressDetailsAOVm.stateData);
                        }
                    }
                    nomineeAddressDetailsAOVm.disableNext = true;
                }, function (error) {
                    nomineeAddressDetailsAOVm.selectStateList = "";
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else if (nomineeAddressDetailsAOVm.pincodeData === "" || (!utilityService.isUndefined(nomineeAddressDetailsAOVm.pincodeData)).length != 6) {
                nomineeAddressDetailsAOVm.cityData = "";
                nomineeAddressDetailsAOVm.stateData = "";
            }
        }

        /* If city and state fields are valid, enable/disable  button */
        nomineeAddressDetailsAOVm.updatedValue = function (isValid) {

            nomineeAddressDetailsAOVm.disableNomineeAddrNext = !(isValid);
            nomineeAddressDetailsAOVm.ncity = nomineeAddressDetailsAOVm.cityData;
            nomineeAddressDetailsAOVm.nstate = nomineeAddressDetailsAOVm.stateData;
            if (!utilityService.isUndefined(nomineeAddressDetailsAOVm.ncity)) {
                nomineeAddressDetailsAOVm.isCityModified = true;
            }
            if (!utilityService.isUndefined(nomineeAddressDetailsAOVm.nstate)) {
                nomineeAddressDetailsAOVm.isStateModified = true;
            }
            return nomineeAddressDetailsAOVm.disableNext;
        }

        /* Disable nominee address page fields */
        nomineeAddressDetailsAOVm.disableAddressFields = function () {
            nomineeAddressDetailsAOVm.disableAddress1 = true;
            nomineeAddressDetailsAOVm.disableAddress2 = true;
            nomineeAddressDetailsAOVm.disablePincode = true;
            nomineeAddressDetailsAOVm.disableCity = true;
            nomineeAddressDetailsAOVm.disableState = true;
            nomineeAddressDetailsAOVm.nomineeStateShow = false;
        }

        nomineeAddressDetailsAOVm.assignAddress = function () {
            nomineeDetailsAOService.nominee.address1 = nomineeAddressDetailsAOVm.addressAboveData;
            nomineeDetailsAOService.nominee.address2 = nomineeAddressDetailsAOVm.addressBelowData;
            nomineeDetailsAOService.nominee.pincode = nomineeAddressDetailsAOVm.pincodeData;
            nomineeDetailsAOService.nominee.city = nomineeAddressDetailsAOVm.cityData;
            nomineeDetailsAOService.nominee.state = nomineeAddressDetailsAOVm.stateData;

        }

        nomineeAddressDetailsAOVm.stateListChange = function (data) {
            var arr = nomineeAddressDetailsAOVm.selectStateList;
            if (data) {
                var arrLength = arr.length;
                for (var i = 0; i < arrLength; i++) {
                    if (arr[i].stateCode == data) {
                        var tempData = arr[i];
                        nomineeDetailsAOService.customer.city = utilityService.getValue(tempData.cityName);
                        nomineeDetailsAOService.customer.state = utilityService.getValue(tempData.stateName);
                        nomineeDetailsAOService.nominee.cityCode = utilityService.getValue(tempData.cityCode);
                        nomineeDetailsAOService.nominee.stateCode = utilityService.getValue(tempData.stateCode);
                        nomineeDetailsAOService.nominee.district = utilityService.getValue(tempData.districtName);
                        nomineeDetailsAOService.nominee.districtCode = utilityService.getValue(tempData.districtCode);
                        nomineeAddressDetailsAOVm.cityData = nomineeDetailsAOService.customer.city;
                        nomineeAddressDetailsAOVm.stateData = nomineeDetailsAOService.customer.state;
                        nomineeAddressDetailsAOVm.ncity = nomineeAddressDetailsAOVm.cityData;
                        nomineeAddressDetailsAOVm.nstate = nomineeAddressDetailsAOVm.stateData;
                        if (!utilityService.isUndefined(nomineeAddressDetailsAOVm.ncity)) {
                            nomineeAddressDetailsAOVm.isCityModified = true;
                        }
                        if (!utilityService.isUndefined(nomineeAddressDetailsAOVm.nstate)) {
                            nomineeAddressDetailsAOVm.isStateModified = true;
                        }
                    }
                };
            } else {
                accountOpeningHomeService.customer.state = "";
                nomineeAddressDetailsAOVm.stateData = "";
                nomineeAddressDetailsAOVm.disableNext = true;
            }
        };

        /* Based on "Same as Applicant Address" checkbox, reload the address fields  */
        nomineeAddressDetailsAOVm.checkboxValidation = function () {

            if (nomineeAddressDetailsAOVm.applicantChecked) {
                
                if(nomineeAddressDetailsAOVm.isAadhaarScanEntry || nomineeAddressDetailsAOVm.isVID){
                nomineeAddressDetailsAOVm.addressAboveData = currentAddressPDCService.customerCorrespondenceAddress.address1 + currentAddressPDCService.customerCorrespondenceAddress.locality;
                nomineeAddressDetailsAOVm.addressBelowData = currentAddressPDCService.customerCorrespondenceAddress.address2 + currentAddressPDCService.customerCorrespondenceAddress.district;
                }else{
                    nomineeAddressDetailsAOVm.addressAboveData = currentAddressPDCService.customerCorrespondenceAddress.address1;
                nomineeAddressDetailsAOVm.addressBelowData = currentAddressPDCService.customerCorrespondenceAddress.address2;
                }
                
                nomineeAddressDetailsAOVm.pincodeData = parseInt(currentAddressPDCService.customerCorrespondenceAddress.pincode);
                nomineeAddressDetailsAOVm.cityData = currentAddressPDCService.customerCorrespondenceAddress.city;
                nomineeAddressDetailsAOVm.locality = currentAddressPDCService.customerCorrespondenceAddress.locality;
                nomineeAddressDetailsAOVm.district = currentAddressPDCService.customerCorrespondenceAddress.district;
                nomineeAddressDetailsAOVm.stateData = currentAddressPDCService.customerCorrespondenceAddress.state;
                nomineeAddressDetailsAOVm.disableAddressFields();

                nomineeAddressDetailsAOVm.nomineeAddressForm.pincode.$valid = true;

                nomineeAddressDetailsAOVm.updateCityState(true);


               // nomineeAddressDetailsAOVm.loadState(currentAddressPDCService.customerCorrespondenceAddress.pincode, currentAddressPDCService.customerCorrespondenceAddress.stateCode);

            } else if (!nomineeAddressDetailsAOVm.applicantChecked) {
                nomineeAddressDetailsAOVm.disableAddress1 = false;
                nomineeAddressDetailsAOVm.disableAddress2 = false;
                nomineeAddressDetailsAOVm.disablePincode = false;
                nomineeAddressDetailsAOVm.disableCity = true;
                nomineeAddressDetailsAOVm.disableState = true;

                nomineeAddressDetailsAOVm.addressAboveData = '';
                nomineeAddressDetailsAOVm.addressBelowData = '';
                nomineeAddressDetailsAOVm.pincodeData = '';
                nomineeAddressDetailsAOVm.cityData = '';
                nomineeAddressDetailsAOVm.locality = '';
                nomineeAddressDetailsAOVm.district = '';
                nomineeAddressDetailsAOVm.stateData = '';
                nomineeDetailsAOService.nomineeAadhaarCardDetails.house = '';
                nomineeDetailsAOService.nomineeAadhaarCardDetails.street = '';
                nomineeDetailsAOService.nomineeAadhaarCardDetails.loc = '';
                nomineeDetailsAOService.nomineeAadhaarCardDetails.vtc = '';
                nomineeDetailsAOService.nomineeAadhaarCardDetails.po = '';
                nomineeDetailsAOService.nomineeAadhaarCardDetails.subdist = '';
                nomineeAddressDetailsAOVm.nomineeStateShow = true;
                nomineeAddressDetailsAOVm.selectStateList = "";
                nomineeAddressDetailsAOVm.nomineeAddressForm.$setPristine();
            }
            // if (nomineeAddressDetailsAOVm.applicantChecked) {
            //     if (nomineeAddressDetailsAOVm.addressAboveData.length > 30 || nomineeAddressDetailsAOVm.addressBelowData.length > 30) {
            //         var title = '';
            //         var template = '{{"MAX_CHAR" | translate}}';
            //         var onTap = '';
            //         var buttontext = '<b>' + nomineeAddressDetailsAOVm.okBtntext + '</b>';
            //         utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            //     }
            // }
        };
        nomineeAddressDetailsAOVm.loadState = function (pincode, stateCodeData) {
            var inputparams = {
                "pinCode": pincode
            }
            // if(!nomineeAddressDetailsAOVm.selectStateList){
            nomineeDetailsRelatedAOService.getAreaDetailForPincode(inputparams).then(function (data) {
                //Success - Data
                if (!utilityService.isUndefined(data)) {
                    nomineeAddressDetailsAOVm.selectStateList = data;
                    nomineeAddressDetailsAOVm.selectdState = stateCodeData;
                }
            }, function (error) {
            });
            // }
        };
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            if (!nomineeDetailsAOService.nominee) {
                nomineeDetailsAOService.nominee = {};
            }
            if (!nomineeDetailsAOService.nomineeAadhaarCardDetails) {
                nomineeDetailsAOService.nomineeAadhaarCardDetails = {}
            }
            if (!nomineeDetailsAOService.customer) {
                nomineeDetailsAOService.customer = {};
            }

            nomineeAddressDetailsAOVm.isAadhaarScanEntry = enterOTPAOService.isAadhaarScanEntry;
            nomineeAddressDetailsAOVm.isAadhaarManualEntry = enterOTPAOService.isAadhaarManualEntry;
            nomineeAddressDetailsAOVm.isVID = enterOTPAOService.isVID;
            if(enterOTPAOService.isResumeJourney == false){
                nomineeAddressDetailsAOVm.journeyType = accountOpeningHomeService.journeyType;
            }else{
                nomineeAddressDetailsAOVm.journeyType = enterOTPAOService.taxPage.journeyType;
            }

            nomineeAddressDetailsAOVm.showBack = true;
            nomineeAddressDetailsAOVm.showNext = true;
            nomineeAddressDetailsAOVm.isAddress1 = false;
            nomineeAddressDetailsAOVm.isAddress2 = false;
            nomineeAddressDetailsAOVm.validDateFormat = false;
            nomineeAddressDetailsAOVm.isMName = false;
            nomineeAddressDetailsAOVm.isNomineeScanned = nomineeDetailsAOService.isNomineeScanned;

            nomineeAddressDetailsAOVm.displayNomineeAdharDetails();

            if (nomineeAddressDetailsAOVm.isNomineeScanned === true) {
                nomineeAddressDetailsAOVm.nomineeAge = nomineeDetailsAOService.nomineeAadhaarCardDetails.age;
                nomineeAddressDetailsAOVm.displayNames(nomineeDetailsAOService.nomineeAadhaarCardDetails.name);
                nomineeAddressDetailsAOVm.populateDobAadhaar(nomineeDetailsAOService.nomineeAadhaarCardDetails.dob);
            } else {
                nomineeAddressDetailsAOVm.nomineeAge = nomineeDetailsAOService.nominee.age;
                nomineeAddressDetailsAOVm.populateDobAadhaar(nomineeDetailsAOService.nominee.dob);
            }
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            nomineeAddressDetailsAOVm.loadState(nomineeAddressDetailsAOVm.pincodeData, nomineeDetailsAOService.nominee.stateCode);
        });

        return this;
    }
]);
