'use strict';

angularApp.controller('nomineeDetailsAddressAOOptionController', ["$state",
    "$scope",
    "accountOpeningHomeService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "nomineeDetailsAOService",
    "enterOTPAOService",
    "constantConfig",
    function($state,
        $scope,
        accountOpeningHomeService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        nomineeDetailsAOService,
        enterOTPAOService,
        constantConfig) {

        var nomineeDetailsAddressOptionAOVm = this;

        function initPage() {
            nomineeDetailsAddressOptionAOVm.showBack = true;
            nomineeDetailsAddressOptionAOVm.showNext = false;
            nomineeDetailsAddressOptionAOVm.btnWhite = true;
            nomineeDetailsAddressOptionAOVm.aofooter = true;
            accountOpeningHomeService.nomineeNav = "nomineeoption";
 
        }

        nomineeDetailsAddressOptionAOVm.goBacktoPrevious = function() {
            $state.go("menu.nomineeAddressDetailsAO");
        }

        nomineeDetailsAddressOptionAOVm.goToNextPage = function(param) {
            if(!nomineeDetailsAOService.guardian){
				nomineeDetailsAOService.guardian = {};
			}
			nomineeDetailsAOService.guardian.guardianAddressFlag = param.description;
            if (param.value === "AO_SAMEASNOM_BTN") {
               $state.go("menu.nomineeGuardianSameAddressAO"); 
            } else if (param.value === "AO_SAMEASAPP_BTN") {
               $state.go("menu.guardianApplicantSameAddressAO");
            } else if (param.value === "AO_NEWADDR_BTN") {
                $state.go("menu.nomineeEnterNewAddressAO");
            }
        }

        nomineeDetailsAddressOptionAOVm.populateResumeData = function() {
			if(!nomineeDetailsAOService.guardian){
				nomineeDetailsAOService.guardian = {};
			}
            nomineeDetailsAddressOptionAOVm.activeStatus = accountOpeningHomeService.getIdByValue(nomineeDetailsAddressOptionAOVm.addressOptions, nomineeDetailsAOService.guardian.guardianAddressFlag);
        }

        $scope.goToHome = function() {
            accountOpeningHomeService.homeNav();
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            nomineeDetailsAddressOptionAOVm.isAadhaarManualEntry = enterOTPAOService.isAadhaarManualEntry;
            if(enterOTPAOService.isResumeJourney == false){
                nomineeDetailsAddressOptionAOVm.journeyType = accountOpeningHomeService.journeyType;
            }else{
                nomineeDetailsAddressOptionAOVm.journeyType = enterOTPAOService.taxPage.journeyType;
            }

            if(!(nomineeDetailsAddressOptionAOVm.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar && nomineeDetailsAddressOptionAOVm.isAadhaarManualEntry)){

                nomineeDetailsAddressOptionAOVm.addressOptions = [
                    { "value": "AO_SAMEASAPP_BTN", "description": "applicantAddress" },
                    { "value": "AO_SAMEASNOM_BTN", "description": "nomineeAddress" },
                    { "value": "AO_NEWADDR_BTN", "description": "newAddress" }
                ];
            }else{
                nomineeDetailsAddressOptionAOVm.addressOptions = [
                    { "value": "AO_SAMEASNOM_BTN", "description": "nomineeAddress" },
                    { "value": "AO_NEWADDR_BTN", "description": "newAddress" }
                ];
            }

            nomineeDetailsAddressOptionAOVm.populateResumeData();

            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
