'use strict';

angularApp.service('nomineeDetailsRelatedAOService',
    function($q, AdapterUtils, constantConfig) {
        var nomineeDetailsRelatedAOService = this;

        nomineeDetailsRelatedAOService.createNominee = function(data) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.createNomineeOVD, data, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        nomineeDetailsRelatedAOService.getAreaDetailForPincode = function(inputparams) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.getPostalDetailByPinCodeOVD , inputparams, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        nomineeDetailsRelatedAOService.updateGuardian = function(data) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.updateGuardianDetailsOVD, data, true).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        nomineeDetailsRelatedAOService.guardianCheck = function(data) {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.acOpeningAdapterOVDUrl.guardianAddressOVD, data, true).then(
                function(response) {
                    q.resolve(response.data.guardianAddress);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        return nomineeDetailsRelatedAOService;
    });
