'use strict';

angularApp.service('nomineeDetailsAOService',
    function($q, AdapterUtils, constantConfig) {
        var nomineeDetailsAOService = this;

        nomineeDetailsAOService.createNominee = function(data) {
            var q = $q.defer();
            AdapterUtils.postData("", data, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        nomineeDetailsAOService.getAreaDetailForPincode = function(inputparams) {
            var q = $q.defer();
            AdapterUtils.postData("" , inputparams, true).then(

                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        nomineeDetailsAOService.updateGuardian = function(data) {
            var q = $q.defer();
            AdapterUtils.postData("", data, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        nomineeDetailsAOService.guardianCheck = function(data) {
            var q = $q.defer();
            AdapterUtils.getData("", data, true).then(

                function(response) {
                    q.resolve(response.data.guardianAddress);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        return nomineeDetailsAOService;
    });
