'use strict';

angularApp.controller('nomineeEnterNewAddressAOController', ["$state",
    "$scope",
    "accountOpeningHomeService",
    "nomineeDetailsRelatedAOService",
    "utilityService",
    "$translate",
    "$timeout",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
	"userLoginDetailsService",
    "nomineeDetailsAOService",
    "enterOTPAOService",
    function($state,
        $scope,
        accountOpeningHomeService,
        nomineeDetailsRelatedAOService,
        utilityService,
        $translate,
        $timeout,
        $ionicSideMenuDelegate,
        mPinLoginService,
        userLoginDetailsService,
        nomineeDetailsAOService,
        enterOTPAOService) {

        var nomineeEnterNewAddressAOVm = this;

        function initPage() {
            nomineeEnterNewAddressAOVm.showBack = true;
            nomineeEnterNewAddressAOVm.showNext = true;
            nomineeEnterNewAddressAOVm.disableNext = true;
            nomineeEnterNewAddressAOVm.aofooter = true;
            nomineeEnterNewAddressAOVm.disableState = true;
            nomineeEnterNewAddressAOVm.disableCity = true;
            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                nomineeEnterNewAddressAOVm.okBtntext = translatedvalue;
            });
        }

        nomineeEnterNewAddressAOVm.goBacktoPrevious = function() {
            $state.go("menu.nomineeDetailsAddressOptionAO");
        }

        /*$scope.$watch("nomineeEnterNewAddressAOVm.guardianNewAddrForm.$valid", function(value) {
            if (value === true) {
                nomineeEnterNewAddressAOVm.disableNext = false;
            } else {
                nomineeEnterNewAddressAOVm.disableNext = true;
            }
        });*/

         $scope.$watchGroup(['nomineeEnterNewAddressAOVm.guardianNewAddrForm.$valid','nomineeEnterNewAddressAOVm.guardian-appoint.$valid'], function(value,isValid) {
            if (enterOTPAOService.isResumeJourney != true) {
            if (value == true & isValid == true) {
                nomineeEnterNewAddressAOVm.disableNext = false;
            } else {
                nomineeEnterNewAddressAOVm.disableNext = true;
            }
        }
        });

        nomineeEnterNewAddressAOVm.setGuardianDetails = function() {
            var guardianDetails = {};
                guardianDetails.nomineeName = nomineeDetailsAOService.nominee.name;
                guardianDetails.guardianName = nomineeDetailsAOService.nominee.guardianName;
            
            return guardianDetails;
        }

        nomineeEnterNewAddressAOVm.goToNextPage = function() {
            nomineeDetailsAOService.guardian.address1 = nomineeEnterNewAddressAOVm.addressAboveData;
            nomineeDetailsAOService.guardian.address2 = nomineeEnterNewAddressAOVm.addressBelowData;
            nomineeDetailsAOService.guardian.pincode = nomineeEnterNewAddressAOVm.pincodeData;
            nomineeDetailsAOService.guardian.city = nomineeEnterNewAddressAOVm.cityData;
            nomineeDetailsAOService.guardian.stateCode = nomineeEnterNewAddressAOVm.stateData;
            nomineeDetailsAOService.guardian.locality = nomineeEnterNewAddressAOVm.localityData;
            nomineeDetailsAOService.guardian.guardianConsent = nomineeEnterNewAddressAOVm.isChecked;
            var guardianDetailParams = nomineeEnterNewAddressAOVm.setGuardianDetails();
            if(utilityService.isUndefined(guardianDetailParams.guardianName)){
              var title = '';
              var template = '{{"IF_GUARDIAN_NAME_EMPTY" | translate}}';
              var onTap = 'menu.nomineeDetailsAO';
              var buttontext = 'OK';
              utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            }
            else{
            //Service to update guardian details
            var params = {
                "id": userLoginDetailsService.mobile,
                "type":"AO",
                "data": {
                    "nominees": [{
                        "guardian": {
                            "address": {
                                "addressLine1": nomineeDetailsAOService.guardian.address1,
                                "addressLine2": nomineeDetailsAOService.guardian.address2,
                                "pincode": nomineeDetailsAOService.guardian.pincode,
                                "city": nomineeDetailsAOService.guardian.city,
                                "cityCode": nomineeDetailsAOService.guardian.cityCode,
                                "state": nomineeDetailsAOService.guardian.state,
                                "stateCode": nomineeDetailsAOService.guardian.stateCode,
                                "locality": nomineeDetailsAOService.guardian.locality,
                                "districtCode": nomineeDetailsAOService.guardian.districtCode,
                                "district": nomineeDetailsAOService.guardian.district
                            },
                            "name": guardianDetailParams.guardianName,
                            "guardianAddressFlag": nomineeDetailsAOService.guardian.guardianAddressFlag,
                            "guardianConsent" : nomineeDetailsAOService.guardian.guardianConsent,
                            "guardianAge": nomineeDetailsAOService.nominee.guardianAge
                        },
                        "name": guardianDetailParams.nomineeName
                    }],
                    "commonId": $state.$current.data.commonId
                }
            }

            
            nomineeDetailsRelatedAOService.updateGuardian(params).then(function(response) {
                $state.go("menu.chequeBookServiceDetailsAO");
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
          }
        }

        $scope.goToHome = function() {
            accountOpeningHomeService.homeNav();
        }

        nomineeEnterNewAddressAOVm.changefn = function(param) {
             if (param) {
                if(nomineeEnterNewAddressAOVm.isChecked){
                    nomineeEnterNewAddressAOVm.disableNext = false;
                } 
                else{
                    nomineeEnterNewAddressAOVm.disableNext = true;
                }               
            } else {
                nomineeEnterNewAddressAOVm.disableNext = true;
            }
        }

        nomineeEnterNewAddressAOVm.clickCheck = function(isValid){
            if (nomineeEnterNewAddressAOVm.isChecked) {
                if(isValid){
                    nomineeEnterNewAddressAOVm.disableNext = false;
                } 
                else{
                    nomineeEnterNewAddressAOVm.disableNext = true;
                }               
            } else {
                nomineeEnterNewAddressAOVm.disableNext = true;
            }
        }

        nomineeEnterNewAddressAOVm.updatedvalue = function(param) {
             if (param) {
                if(nomineeEnterNewAddressAOVm.isChecked){
                    nomineeEnterNewAddressAOVm.disableNext = false;
                } 
                else{
                    nomineeEnterNewAddressAOVm.disableNext = true;
                }               
            } else {
                nomineeEnterNewAddressAOVm.disableNext = true;
            }
            return nomineeEnterNewAddressAOVm.disableNext;
        }

        nomineeEnterNewAddressAOVm.updatearea = function(param) {
            //Service to return city and state based on the pincode entered
            var inputparams = {
                "pinCode": nomineeEnterNewAddressAOVm.pincodeData
            }
            if (!utilityService.isUndefined(nomineeEnterNewAddressAOVm.pincodeData) && nomineeEnterNewAddressAOVm.pincodeData.length == 6 && /^[0-9]{1,6}$/.test(nomineeEnterNewAddressAOVm.pincodeData) == true) {
                nomineeDetailsRelatedAOService.getAreaDetailForPincode(inputparams).then(function(data) {

                    if (utilityService.isUndefined(data)) {
                        var title = '';
                        var template = '{{"PINCODE_MATCH" | translate}}';
                        var onTap = '';
                        var buttontext = '<b>' + nomineeEnterNewAddressAOVm.okBtntext + '</b>';
                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                        nomineeEnterNewAddressAOVm.disableState = false;
                        nomineeEnterNewAddressAOVm.disableCity = false;
                        nomineeEnterNewAddressAOVm.stateList = "";
                    } else {
                        nomineeEnterNewAddressAOVm.stateList = data;	
                        accountOpeningHomeService.customer.city = utilityService.getValue(data.cityName);
                        accountOpeningHomeService.customer.state = utilityService.getValue(data.stateName);
                        nomineeDetailsAOService.guardian.cityCode = utilityService.getValue(data.cityCode);
                        nomineeDetailsAOService.guardian.stateCode = utilityService.getValue(data.stateCode);
                        nomineeEnterNewAddressAOVm.cityData = accountOpeningHomeService.customer.city;
                        nomineeEnterNewAddressAOVm.stateData = accountOpeningHomeService.customer.state;
                        nomineeEnterNewAddressAOVm.disableCity = true;
                        nomineeEnterNewAddressAOVm.disableState = true;

                        if(nomineeEnterNewAddressAOVm.stateList.length == 1){
                            nomineeEnterNewAddressAOVm.stateData = nomineeEnterNewAddressAOVm.stateList[0].stateCode;
                            nomineeDetailsAOService.guardian.state = nomineeEnterNewAddressAOVm.stateList[0].stateName;
                            nomineeDetailsAOService.guardian.district = nomineeEnterNewAddressAOVm.stateList[0].districtName;
                             nomineeDetailsAOService.guardian.districtCode = nomineeEnterNewAddressAOVm.stateList[0].districtCode;
                            nomineeEnterNewAddressAOVm.loadStateList(nomineeEnterNewAddressAOVm.stateData);
                        }
                    }

                }, function(error) {
                	nomineeEnterNewAddressAOVm.stateList = "";
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        }

        nomineeEnterNewAddressAOVm.pincodeChange = function() {
            if (nomineeEnterNewAddressAOVm.pincodeData === "" || (!utilityService.isUndefined(nomineeEnterNewAddressAOVm.pincodeData)).length != 6) {
                nomineeEnterNewAddressAOVm.cityData = "";
                nomineeEnterNewAddressAOVm.stateData = "";
            }
        }

        nomineeEnterNewAddressAOVm.checkUpdatedCityStateValid = function(param) {
            nomineeEnterNewAddressAOVm.updatedvalue(param);
        }

        nomineeEnterNewAddressAOVm.populateResumeData = function() {
            nomineeEnterNewAddressAOVm.addressAboveData = utilityService.getValue(nomineeDetailsAOService.guardian.address1);
            nomineeEnterNewAddressAOVm.addressBelowData = utilityService.getValue(nomineeDetailsAOService.guardian.address2);
            nomineeEnterNewAddressAOVm.pincodeData = utilityService.getValue(nomineeDetailsAOService.guardian.pincode);
            nomineeEnterNewAddressAOVm.cityData = utilityService.getValue(nomineeDetailsAOService.guardian.city);
            nomineeEnterNewAddressAOVm.stateData = utilityService.getValue(nomineeDetailsAOService.guardian.stateCode);
            nomineeEnterNewAddressAOVm.localityData = utilityService.getValue(nomineeDetailsAOService.guardian.locality);
            nomineeEnterNewAddressAOVm.isChecked = Boolean(nomineeDetailsAOService.guardian.guardianConsent);
            nomineeEnterNewAddressAOVm.changefn(true);
            
        }

         nomineeEnterNewAddressAOVm.guardianDetails = function(){
                 nomineeEnterNewAddressAOVm.guardianConName = nomineeDetailsAOService.nominee.guardianName;
                nomineeEnterNewAddressAOVm.guardianConAge = nomineeDetailsAOService.nominee.guardianAge;
         
      }
      nomineeEnterNewAddressAOVm.setstate = function(data) {
		          if(data){
		            var arr = nomineeEnterNewAddressAOVm.stateList;
					var arrLength = arr.length;	
		            for (var i = 0; i < arrLength; i++) {
		                if (arr[i].stateCode == data) {
		                    var tempData = arr[i];
		                    accountOpeningHomeService.customer.city = utilityService.getValue(tempData.cityName);
		                            accountOpeningHomeService.customer.state = utilityService.getValue(tempData.stateName);
		                            nomineeDetailsAOService.guardian.cityCode = utilityService.getValue(tempData.cityCode);
                                    nomineeDetailsAOService.guardian.stateCode = utilityService.getValue(tempData.stateCode);
                                    nomineeDetailsAOService.guardian.district = utilityService.getValue(tempData.districtName);
                                    nomineeDetailsAOService.guardian.districtCode = utilityService.getValue(tempData.districtCode);
		                            nomineeEnterNewAddressAOVm.cityData = accountOpeningHomeService.customer.city;
		                            nomineeEnterNewAddressAOVm.stateData = accountOpeningHomeService.customer.state;
		                            nomineeEnterNewAddressAOVm.disableCity = true;
		                            nomineeEnterNewAddressAOVm.disableState = true;
		                }
		            };
		            nomineeEnterNewAddressAOVm.changefn(true);
		          }else{
		            nomineeEnterNewAddressAOVm.stateData = ""; 
		            nomineeDetailsAOService.guardian.state = "";
		          }
		        
		
		};
		nomineeEnterNewAddressAOVm.loadStateList = function(data) {
				 var inputparams = {
	                "pinCode": nomineeDetailsAOService.guardian.pincode
	           };
	           if(!nomineeEnterNewAddressAOVm.stateList){
				nomineeDetailsRelatedAOService.getAreaDetailForPincode(inputparams).then(function(data) {
	                    if (!utilityService.isUndefined(data)) {
	                        nomineeEnterNewAddressAOVm.stateList = data;
                            nomineeEnterNewAddressAOVm.stateitemData = nomineeDetailsAOService.guardian.stateCode;
                            setTimeout(function(){ 
							nomineeEnterNewAddressAOVm.changefn(nomineeEnterNewAddressAOVm.guardianNewAddrForm.$valid);
                            }, 30);
                            
                            if(nomineeEnterNewAddressAOVm.stateList.length == 1){
                                nomineeEnterNewAddressAOVm.stateData = nomineeEnterNewAddressAOVm.stateList[0].stateCode;
                                nomineeDetailsAOService.guardian.state = nomineeEnterNewAddressAOVm.stateList[0].stateName;
                                nomineeDetailsAOService.guardian.district = nomineeEnterNewAddressAOVm.stateList[0].districtName;
                                nomineeDetailsAOService.guardian.districtCode = nomineeEnterNewAddressAOVm.stateList[0].districtCode;
                            }

                        }
                        
	                }, function(error) {
                    
	                });
                }
                else{
                    if(nomineeEnterNewAddressAOVm.stateList.length == 1){
                        nomineeEnterNewAddressAOVm.stateData = nomineeEnterNewAddressAOVm.stateList[0].stateCode;
                        nomineeDetailsAOService.guardian.state = nomineeEnterNewAddressAOVm.stateList[0].stateName;
                        nomineeDetailsAOService.guardian.district = nomineeEnterNewAddressAOVm.stateList[0].districtName;
                        nomineeDetailsAOService.guardian.districtCode = nomineeEnterNewAddressAOVm.stateList[0].districtCode;
                    }
                    nomineeEnterNewAddressAOVm.stateitemData = data;
                }    
		};	  
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            if (enterOTPAOService.isResumeJourney == true) {
            nomineeEnterNewAddressAOVm.populateResumeData();
            }
            nomineeEnterNewAddressAOVm.guardianDetails();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);  
            nomineeEnterNewAddressAOVm.loadStateList(nomineeEnterNewAddressAOVm.stateData);
            //nomineeEnterNewAddressAOVm.updatearea();
        });

        return this;
    }
]);
