'use strict';

angularApp.controller('nomineeGuardianSameAddressAOController', ["$state",
    "$scope",
    "accountOpeningHomeService",
    "nomineeDetailsRelatedAOService",
    "utilityService",
    "$timeout",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "userLoginDetailsService",
    "nomineeDetailsAOService",
    "enterOTPAOService",
    function ($state,
        $scope,
        accountOpeningHomeService,
        nomineeDetailsRelatedAOService,
        utilityService,
        $timeout,
        $ionicSideMenuDelegate,
        mPinLoginService,
        userLoginDetailsService,
        nomineeDetailsAOService,
        enterOTPAOService) {

        var nomineeGuardianSameAddressAOVm = this;

        function initPage() {
            nomineeGuardianSameAddressAOVm.personalDetails = {};
            nomineeGuardianSameAddressAOVm.showBack = true;
            nomineeGuardianSameAddressAOVm.showNext = true;
            nomineeGuardianSameAddressAOVm.aofooter = true;
            nomineeGuardianSameAddressAOVm.disableNext = true;
        }

        nomineeGuardianSameAddressAOVm.goBacktoPrevious = function() {
             $state.go("menu.nomineeDetailsAddressOptionAO");
        }

        nomineeGuardianSameAddressAOVm.setGuardianDetails = function () {
            var guardianDetails = {};
            guardianDetails.nomineeName = nomineeDetailsAOService.nominee.name;
            guardianDetails.guardianName = nomineeDetailsAOService.nominee.guardianName;

            return guardianDetails;
        }

        /*$scope.$watch("nomineeGuardianSameAddressAOVm.guardian-appoint.$valid", function(value) {
            
            if (value === true) {
                nomineeGuardianSameAddressAOVm.disableNext = false;
            } else {
                nomineeGuardianSameAddressAOVm.disableNext = true;
            }
        });*/

        nomineeGuardianSameAddressAOVm.changefn = function () {
            //nomineeGuardianSameAddressAOVm.disableNext = !isValid;
            if (nomineeGuardianSameAddressAOVm.isChecked) {
                nomineeGuardianSameAddressAOVm.disableNext = false;
            } else {
                nomineeGuardianSameAddressAOVm.disableNext = true;
            }
        }

        nomineeGuardianSameAddressAOVm.goToNextPage = function () {
            //Service to update guardian details
            var guardianDetailParams = nomineeGuardianSameAddressAOVm.setGuardianDetails();
            nomineeDetailsAOService.guardian.guardianConsent = nomineeGuardianSameAddressAOVm.isChecked;
            if(utilityService.isUndefined(guardianDetailParams.guardianName)){
              var title = '';
              var template = '{{"IF_GUARDIAN_NAME_EMPTY" | translate}}';
              var onTap = 'menu.nomineeDetailsAO';
                var buttontext = 'OK';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            }
            else {
                var params = {
                    "id": userLoginDetailsService.mobile,
                    "type": "AO",
                    "data": {
                        "nominees": [{
                            "guardian": {
                                "address": {
                                    "type": "CURRENT_ADDR",
                                    "addressLine1": nomineeGuardianSameAddressAOVm.personalDetails.addressLine1,
                                    "addressLine2": nomineeGuardianSameAddressAOVm.personalDetails.addressLine2,
                                    "pincode": nomineeGuardianSameAddressAOVm.personalDetails.pincode,
                                    "city": nomineeGuardianSameAddressAOVm.personalDetails.city,
                                    "cityCode": nomineeGuardianSameAddressAOVm.personalDetails.cityCode,
                                    "state": nomineeGuardianSameAddressAOVm.personalDetails.state,
                                    "stateCode": nomineeGuardianSameAddressAOVm.personalDetails.stateCode,
                                    "districtCode": nomineeGuardianSameAddressAOVm.personalDetails.districtCode,
                                    "district": nomineeGuardianSameAddressAOVm.personalDetails.district,
                                    "locality": nomineeGuardianSameAddressAOVm.personalDetails.locality
                                },
                                "name": guardianDetailParams.guardianName,
                                "guardianAddressFlag": nomineeDetailsAOService.guardian.guardianAddressFlag,
                                "guardianConsent": nomineeDetailsAOService.guardian.guardianConsent,
                                "guardianAge": nomineeDetailsAOService.nominee.guardianAge
                            },
                            "name": guardianDetailParams.nomineeName
                        }],
                        "commonId": $state.$current.data.commonId
                    }
                }

                nomineeDetailsRelatedAOService.updateGuardian(params).then(function (response) {
                    $state.go("menu.chequeBookServiceDetailsAO");
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        }

        $scope.goToHome = function () {
            accountOpeningHomeService.homeNav();
        }

        nomineeGuardianSameAddressAOVm.displayGuardianAddress = function () {
           
            nomineeGuardianSameAddressAOVm.isChecked = Boolean(nomineeDetailsAOService.guardian.guardianConsent);
            if (accountOpeningHomeService.isAadharManualEntry === false) {
                if (accountOpeningHomeService.isResumeJourney == false) {

                    nomineeGuardianSameAddressAOVm.personalDetails.addressLine1 = accountOpeningHomeService.nullCheck(nomineeDetailsAOService.nominee.address1);
                    nomineeGuardianSameAddressAOVm.personalDetails.addressLine2 = accountOpeningHomeService.nullCheck(nomineeDetailsAOService.nominee.address2);
                    
                    nomineeGuardianSameAddressAOVm.personalDetails.pincode = nomineeDetailsAOService.nominee.pincode;
                    nomineeGuardianSameAddressAOVm.personalDetails.city = nomineeDetailsAOService.nominee.city;
                    nomineeGuardianSameAddressAOVm.personalDetails.locality = nomineeDetailsAOService.nominee.locality;
                    nomineeGuardianSameAddressAOVm.personalDetails.state = nomineeDetailsAOService.nominee.stateName;
                    nomineeGuardianSameAddressAOVm.personalDetails.cityCode = nomineeDetailsAOService.nominee.cityCode;
                    nomineeGuardianSameAddressAOVm.personalDetails.stateCode = nomineeDetailsAOService.nominee.stateCode;
                    nomineeGuardianSameAddressAOVm.personalDetails.districtCode = nomineeDetailsAOService.nominee.districtCode;
                    nomineeGuardianSameAddressAOVm.personalDetails.district = nomineeDetailsAOService.nominee.district;

                    if(nomineeGuardianSameAddressAOVm.isAadhaarScanEntry || nomineeGuardianSameAddressAOVm.isVID){
                        nomineeGuardianSameAddressAOVm.personalDetails.address = accountOpeningHomeService.nullCheck(nomineeDetailsAOService.nominee.address1)+ " "+ accountOpeningHomeService.nullCheck(nomineeDetailsAOService.nominee.locality) + " "+ accountOpeningHomeService.nullCheck(nomineeDetailsAOService.nominee.address2) +" "+ accountOpeningHomeService.nullCheck(nomineeDetailsAOService.nominee.district);
                    }else{
                        nomineeGuardianSameAddressAOVm.personalDetails.address = accountOpeningHomeService.nullCheck(nomineeDetailsAOService.nominee.address1) + " "+ accountOpeningHomeService.nullCheck(nomineeDetailsAOService.nominee.address2);
                    }

                } else if (accountOpeningHomeService.correspondenceCheckStatus == true) {
                    nomineeGuardianSameAddressAOVm.personalDetails.addressLine1 = accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerCorrespondenceAddress.address1);
                    nomineeGuardianSameAddressAOVm.personalDetails.addressLine2 = accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerCorrespondenceAddress.address2);
                    nomineeGuardianSameAddressAOVm.personalDetails.address = accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerCorrespondenceAddress.address1) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerCorrespondenceAddress.address2);
                    nomineeGuardianSameAddressAOVm.personalDetails.pincode = accountOpeningHomeService.customerCorrespondenceAddress.pincode;
                    nomineeGuardianSameAddressAOVm.personalDetails.city = accountOpeningHomeService.customerCorrespondenceAddress.city;
                    nomineeGuardianSameAddressAOVm.personalDetails.state = accountOpeningHomeService.customerCorrespondenceAddress.state;
                } else {
                    nomineeGuardianSameAddressAOVm.personalDetails.addressLine1 = accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.addressLine1);
                    nomineeGuardianSameAddressAOVm.personalDetails.addressLine2 = accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.addressLine2);
                    nomineeGuardianSameAddressAOVm.personalDetails.address = accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.addressLine1) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.addressLine2);
                    nomineeGuardianSameAddressAOVm.personalDetails.pincode = accountOpeningHomeService.customerAadhaarCardDetails.pc;
                    nomineeGuardianSameAddressAOVm.personalDetails.city = accountOpeningHomeService.customerAadhaarCardDetails.dist;
                    nomineeGuardianSameAddressAOVm.personalDetails.state = accountOpeningHomeService.customerAadhaarCardDetails.state;
                }
            } else if (accountOpeningHomeService.isAadharManualEntry === true) {

                if (accountOpeningHomeService.isCustManualCorresChkBox == true) {
                    nomineeGuardianSameAddressAOVm.personalDetails.addressLine1 = accountOpeningHomeService.nullCheck(accountOpeningHomeService.aadhaarManualCorrespondenceAddress.address1);
                    nomineeGuardianSameAddressAOVm.personalDetails.addressLine2 = accountOpeningHomeService.nullCheck(accountOpeningHomeService.aadhaarManualCorrespondenceAddress.address2);
                    nomineeGuardianSameAddressAOVm.personalDetails.address = accountOpeningHomeService.nullCheck(accountOpeningHomeService.aadhaarManualCorrespondenceAddress.address1) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.aadhaarManualCorrespondenceAddress.address2);
                    nomineeGuardianSameAddressAOVm.personalDetails.pincode = accountOpeningHomeService.aadhaarManualCorrespondenceAddress.pincode;
                    nomineeGuardianSameAddressAOVm.personalDetails.city = accountOpeningHomeService.aadhaarManualCorrespondenceAddress.city;
                    nomineeGuardianSameAddressAOVm.personalDetails.state = accountOpeningHomeService.aadhaarManualCorrespondenceAddress.state;
                } else {
                    var title = '';
                    var template = '{{"APPLICANT_ADDRESS_IF_EMPTY" | translate}}';
                    var onTap = 'menu.nomineeDetailsAddressOptionAO';
                    var buttontext = 'OK';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                }
            }
            if (!utilityService.isUndefined(nomineeGuardianSameAddressAOVm.personalDetails.addressLine1)) {
                var index = nomineeGuardianSameAddressAOVm.personalDetails.addressLine1.lastIndexOf(",");
                nomineeGuardianSameAddressAOVm.personalDetails.addressLine1 = nomineeGuardianSameAddressAOVm.personalDetails.addressLine1.substring(0, index) + nomineeGuardianSameAddressAOVm.personalDetails.addressLine1.substring(index + 1);
            }
            if (!utilityService.isUndefined(nomineeGuardianSameAddressAOVm.personalDetails.addressLine2)) {
                var index = nomineeGuardianSameAddressAOVm.personalDetails.addressLine2.lastIndexOf(",");
                nomineeGuardianSameAddressAOVm.personalDetails.addressLine2 = nomineeGuardianSameAddressAOVm.personalDetails.addressLine2.substring(0, index) + nomineeGuardianSameAddressAOVm.personalDetails.addressLine2.substring(index + 1);
            }
            if (!utilityService.isUndefined(nomineeGuardianSameAddressAOVm.personalDetails.address)) {
                var index = nomineeGuardianSameAddressAOVm.personalDetails.address.lastIndexOf(",");
                nomineeGuardianSameAddressAOVm.personalDetails.address = nomineeGuardianSameAddressAOVm.personalDetails.address.substring(0, index) + nomineeGuardianSameAddressAOVm.personalDetails.address.substring(index + 1);
            }
        }

        nomineeGuardianSameAddressAOVm.guardianDetails = function () {
               nomineeGuardianSameAddressAOVm.guardianConName = nomineeDetailsAOService.nominee.guardianName;
                nomineeGuardianSameAddressAOVm.guardianConAge = nomineeDetailsAOService.nominee.guardianAge;
            
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            nomineeGuardianSameAddressAOVm.isAadhaarScanEntry = enterOTPAOService.isAadhaarScanEntry;
            nomineeGuardianSameAddressAOVm.isVID = enterOTPAOService.isVID;
            nomineeGuardianSameAddressAOVm.displayGuardianAddress();
            if (nomineeGuardianSameAddressAOVm.isChecked == true) {
                nomineeGuardianSameAddressAOVm.disableNext = false;
            }
            else {
                nomineeGuardianSameAddressAOVm.disableNext = true;
            }

            nomineeGuardianSameAddressAOVm.guardianDetails();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);

        });

        return this;
    }
]);
