'use strict';

angularApp.controller('ntbBestOfferController', ["$state", "$scope", "utilityService","mPinLoginService", "$ionicSideMenuDelegate", "homeScreenService", "$ionicPopup", "ntbBestOfferService","clickStreamService","ompMerchantsService","cryptoService",

    function ($state, $scope, utilityService, mPinLoginService, $ionicSideMenuDelegate, homeScreenService, $ionicPopup, ntbBestOfferService, clickStreamService, ompMerchantsService, cryptoService) {

        var ntbBestOfferControllerVm = this;
        homeScreenService.categoryCode = 'OMPBO60';
        homeScreenService.storeSelected = 'Best Offer';
        ntbBestOfferControllerVm.secCheckFailed = false;

        ntbBestOfferControllerVm.goBack = function () {
            ompMerchantsService.NtbBestOfferClicked = false;
            $state.go('menu.newToSbiLanding');
        }

        ntbBestOfferControllerVm.openPopup = function (offer) {
            if(ntbBestOfferControllerVm.secCheckFailed){
                utilityService.showErrorMessage("Invalid request");
            } else { 
                ntbBestOfferControllerVm.selectedOffer = offer;
                clickStreamService.clickStreamData = "websiteId," + offer.affiliateId;
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_MERCHANT_IMG" + clickStreamService.appTypeIdentifier));
                ntbBestOfferControllerVm.myPopup = $ionicPopup.show({
                    title: '',
                    cssClass: 'ntb-popup yono-kcc-popup1',
                    templateUrl: 'pages/accountOpening/ntbBestOffers/openSavingBankAccPopup.html',
                    scope: $scope
                })
            }
        }

        ntbBestOfferControllerVm.proceed = function () {
            ompMerchantsService.NtbBestOfferClicked = true;
            clickStreamService.clickStreamData = "websiteId," + ntbBestOfferControllerVm.selectedOffer.affiliateId;
            clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_POPUP_PROCEED_BTN" + clickStreamService.appTypeIdentifier));
            ntbBestOfferControllerVm.myPopup.close();
            $state.go('menu.openDSA');
        }
        
        ntbBestOfferControllerVm.later = function () {
            clickStreamService.clickStreamData = "websiteId," + ntbBestOfferControllerVm.selectedOffer.affiliateId;
            clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_POPUP_LATER_BTN" + clickStreamService.appTypeIdentifier));
            ntbBestOfferControllerVm.myPopup.close();
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            var obj = {};
            ntbBestOfferService.getNtbOffers(obj).then(function (data) {
                console.log(data);
                ntbBestOfferControllerVm.bestOfferHeader = data.data[0].ntbBestOffer.label;
                $scope.merchantData = data.data[0].ntbBestOffer.merchant;
                ntbBestOfferControllerVm.popupContent = data.data[0].ntbBestOffer.popupContent;
                ntbBestOfferControllerVm.HCheck = data.data[0].ntbBestOffer.resourceParameter;
                ntbBestOfferControllerVm.HCheckStr = data.data[0].ntbBestOffer.label + data.data[0].ntbBestOffer.popupContent.popupHeader + data.data[0].ntbBestOffer.popupContent.popupBodyLine1 + data.data[0].ntbBestOffer.popupContent.popupBodyLine2 + data.data[0].ntbBestOffer.popupContent.popupCTA1 + data.data[0].ntbBestOffer.popupContent.popupCTA2;
                
                if (ntbBestOfferControllerVm.HCheck == cryptoService.getSHA512EncryptedData(ntbBestOfferControllerVm.HCheckStr).toString()) {
                    if (data.data[0].ntbBestOffer.merchant[0].row) {
                        for (var customCheck = 0; customCheck <= data.data[0].ntbBestOffer.merchant[0].row.length - 1; customCheck++) {
                            if (data.data[0].ntbBestOffer.merchant[0].row[customCheck].merchantParameter !== cryptoService.getSHA512EncryptedData(data.data[0].ntbBestOffer.merchant[0].row[customCheck].name + data.data[0].ntbBestOffer.merchant[0].row[customCheck].merchantType + data.data[0].ntbBestOffer.merchant[0].row[customCheck].appLogo).toString()) {
                                 ntbBestOfferControllerVm.secCheckFailed = false;
                            }else{
                                 ntbBestOfferControllerVm.secCheckFailed = false;
                            }
                        }
                    }

                } else {
                    ntbBestOfferControllerVm.secCheckFailed = false;
                }


            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        $scope.$on('$ionicView.beforeLeave', function () {
            var headerElem = document.querySelector('body');
            var topBar = document.querySelectorAll('.app-header');
            if (headerElem) {
                headerElem.classList.remove('hiddenExtraButton');
            }
            if (topBar) {
                topBar[2].classList.remove('discliamerContent');
            }
        });

        $scope.$on('$ionicView.afterEnter', function () {
            var headerElem = document.querySelector('body');
            var topBar = document.querySelectorAll('.app-header');
            if (headerElem) {
                headerElem.classList.add('hiddenExtraButton');
            }
            if (topBar) {
                topBar[2].classList.add('discliamerContent');
            }

        });

        return this;
    }
]);
