'use strict';

angularApp.controller('aadhaarOptionAOController', ["$state",
    "$scope",
    "$cordovaBarcodeScanner",
    "$ionicPopover",
    "utilityService",
    "accountOpeningHomeService",
    "$translate",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "instaaDCityCountryService",
    "enterOTPAOService",
    function($state,
        $scope,
        $cordovaBarcodeScanner,
        $ionicPopover,
        utilityService,
        accountOpeningHomeService,
        $translate,
        $ionicSideMenuDelegate,
        mPinLoginService,
        instaaDCityCountryService,
        enterOTPAOService) {

        var aadhaarOptionAOVm = this;
        var alphabets = /^([ \.]?[a-zA-Z]+)+$/;
        var numbers = /^[0-9]*$/;
        var addressRegex = /^[A-z().,-/0-9 #']*$/;

        function initPage() {
            aadhaarOptionAOVm.showBack = true;
            aadhaarOptionAOVm.showNext = false;
            aadhaarOptionAOVm.aofooter = true;
            aadhaarOptionAOVm.showAadhaarDetails = false;
            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                aadhaarOptionAOVm.okBtntext = translatedvalue;
            });
        }

        aadhaarOptionAOVm.goToScanAADHAR = function() {
            //accountOpeningHomeService.isAadharManualEntry = false;

            enterOTPAOService.isAadhaarScanEntry = true;
            enterOTPAOService.isAadhaarManualEntry = false;
	  	    enterOTPAOService.isVID = false;
            $state.go('menu.aadharScan');
        }

        aadhaarOptionAOVm.goToEnterAadhaar = function() {
            //accountOpeningHomeService.isAadharManualEntry = true;
            
            accountOpeningHomeService.customerAadhaarCardDetails = {
                uid: "",
                name: "",
                firstName: "",
                middleName: "",
                lastName: "",
                gender: "",
                title: "",
                yob: "",
                co: "",
                house: "",
                street: "",
                lm: "",
                loc: "",
                vtc: "",
                po: "",
                dist: "",
                subdist: "",
                state: "",
                pc: "",
                dob: "",
                isAadharScanned: false,
                locality: "",
                addressLine1: "",
                addressLine2: ""
            }
            enterOTPAOService.isVID = false;
            enterOTPAOService.isAadhaarScanEntry = false;
            enterOTPAOService.isAadhaarManualEntry = true;
            //$state.go('menu.aadhaarManualEntry');
            $state.go('menu.personalDetailsAO');
            
        }

        aadhaarOptionAOVm.goBacktoPrevious = function() {
            $state.go('menu.taxFatcaDetailsAO');
        }

        aadhaarOptionAOVm.showAadhaarInfo = function(){
            aadhaarOptionAOVm.showAadhaarDetails = aadhaarOptionAOVm.showAadhaarDetails ? false : true;
        }

        $scope.goToHome = function() {
            accountOpeningHomeService.homeNav();
        }

        /* Info Popup */
       

    //     aadhaarOptionAOVm.infoPopup = function($event) {
	//              var template = '<ion-popover-view class="tooltiptext ao-popupInfo roboto-regular ao-aadhaarInfoHt">' + '<ion-content>' +
	//                         '<div class="" translate="MANUAL_INPUT_AADHAAR"></div>' + '</ion-content>' + '</ion-popover-view>';
	
	//         $scope.popover = $ionicPopover.fromTemplate(template, {
	//             scope: $scope
	//         });
    //         $scope.popover.show($event);
    //    };
       
    //    aadhaarOptionAOVm.infoVIDPopup = function($event) {
	// 		if (!aadhaarOptionAOVm.vidContent) {
	// 			instaaDCityCountryService.getInfoList().then(function(body) {
	// 				var template = '<ion-popover-view class="tooltiptext ao-popupInfo roboto-regular ao-aadhaarInfoHt">' + '<ion-content>' +
	//                         '<div >'+body.infoList.vidContent+'</div>' + '</ion-content>' + '</ion-popover-view>';
	
	// 				$scope.popover = $ionicPopover.fromTemplate(template, {
	// 					scope : $scope
	// 				});
	// 				aadhaarOptionAOVm.vidContent = body.infoList.vidContent;
	// 				$scope.popover.show($event);
	// 			}, function(error) {
	// 				utilityService.showErrorMessage(error.responseMessage);
	// 			});
	// 		} else {
	// 			var template = '<ion-popover-view class="tooltiptext ao-popupInfo roboto-regular ao-aadhaarInfoHt">' + '<ion-content>' +
	//                         '<div >'+aadhaarOptionAOVm.vidContent+'</div>' + '</ion-content>' + '</ion-popover-view>';
	// 			$scope.popover = $ionicPopover.fromTemplate(template, {
	// 				scope : $scope
	// 			});
	// 			$scope.popover.show($event);
	// 		}
			
    //    };

       aadhaarOptionAOVm.closePopover = function() {
            $scope.popover.hide();
       };
       /* Info Popup */
	  aadhaarOptionAOVm.goToVID = function() {
        enterOTPAOService.isAadhaarScanEntry = false;
        enterOTPAOService.isAadhaarManualEntry = false;
	  	enterOTPAOService.isVID = true;
          //$state.go('menu.VIDDetails');
          $state.go('menu.vidDetailsAO');
	  };	
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            //if (enterOTPAOService.isResumeJourney == true){
            aadhaarOptionAOVm.isAadhaarScanEntry = enterOTPAOService.isAadhaarScanEntry;
            aadhaarOptionAOVm.isAadhaarManualEntry = enterOTPAOService.isAadhaarManualEntry;
            aadhaarOptionAOVm.isVID = enterOTPAOService.isVID;
            //}
        });

        return this;
    }
]);
