'use strict';

angularApp.controller('aadharscanAOController', ["$state",
    "$scope",
    "$cordovaBarcodeScanner",
    "accountOpeningHomeService",
    "utilityService",
    "$translate",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "enterOTPAOService",
    "bhimUpiService",

    function($state,
        $scope,
        $cordovaBarcodeScanner,
        accountOpeningHomeService,
        utilityService,
        $translate,
        $ionicSideMenuDelegate,
        mPinLoginService,
        enterOTPAOService,
        bhimUpiService) {

        var aadharAOVm = this;
        var alphabets = /^([ \.]?[a-zA-Z]+)+$/;
        var numbers = /^[0-9]*$/;
        var addressRegex = /^[A-z().,-/0-9 #']*$/;

        function initPage() {
            aadharAOVm.showBack = true;
            aadharAOVm.showNext = false;
            aadharAOVm.aofooter = true;
            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                aadharAOVm.okBtntext = translatedvalue;
            });
        }

        aadharAOVm.goBacktoPrevious = function() {
            $state.go('menu.aadhaarOption');
        }

        aadharAOVm.goToNextPage = function() {
            enterOTPAOService.isVID = false;
            enterOTPAOService.isAadhaarManualEntry = false;
            enterOTPAOService.isAadhaarScanEntry = true;
            $state.go('menu.personalDetailsAO');
        }

        $scope.goToHome = function() {
            accountOpeningHomeService.homeNav();
        }

        //QR code scanner code
        aadharAOVm.goToQRCodeDetails = function() {

// -------------------------------------------------------------------------------------------



            bhimUpiService.getNativeData("scanqrcode", {}).then(function (data) {

                if (device.platform.toLowerCase() == 'android') {
                var barcodeData = data.scanResult;
                }else{
                var barcodeData = data;
                }
                
                var xmlText = barcodeData;
                var formattedXml = xmlText.replace("/?xml", "?xml");
                formattedXml = formattedXml.replace("xml?", "?xml");
                var x2js = new X2JS();
                var jsonObj = x2js.xml_str2json(formattedXml);
                if (utilityService.isUndefined(jsonObj)) {
                    var title = '';
                    var template = "{{'AADHAAR_POPUP'| translate}}";
                    var onTap = '';
                    var buttontext = "<b>" + aadharAOVm.okBtntext + "</b>";
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                } else {
                    accountOpeningHomeService.isResumeJourney = false;
                    var jsonStr = JSON.stringify(jsonObj);
                    accountOpeningHomeService.customerManualEntryDetails = {
                        aadharNumber: "",
                        firstName: "",
                        lastName: "",
                        middleName: "",
                        fullName: "",
                        gender: "",
                        title: "",
                        dob: "",
                        address1: "",
                        address2: "",
                        city: "",
                        state: "",
                        pincode: "",
                        isAadharScanned: false,
                        locality: "",
                        addressLine1: "",
                        addressLine2: ""

                    }

                    accountOpeningHomeService.customerAadhaarCardDetails = {
                        uid: "",
                        name: "",
                        firstName: "",
                        middleName: "",
                        lastName: "",
                        gender: "",
                        title: "",
                        yob: "",
                        co: "",
                        house: "",
                        street: "",
                        lm: "",
                        loc: "",
                        vtc: "",
                        po: "",
                        dist: "",
                        subdist: "",
                        state: "",
                        pc: "",
                        dob: "",
                        isAadharScanned: false,
                        locality: "",
                        addressLine1: "",
                        addressLine2: ""
                    }
                    
                    var securedScannedData = {
                        _co: accountOpeningHomeService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._uid),
                        _dist: accountOpeningHomeService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._dist),
                        _dob: accountOpeningHomeService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._dob),
                        _gender: accountOpeningHomeService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._gender),
                        _house: accountOpeningHomeService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._house),
                        _name: accountOpeningHomeService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._name),
                        _pc: accountOpeningHomeService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._pc),
                        _po: accountOpeningHomeService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._po),
                        _state: accountOpeningHomeService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._state),
                        _street: accountOpeningHomeService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._street),
                        _subdist: accountOpeningHomeService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._subdist),
                        _uid: accountOpeningHomeService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._uid),
                        _vtc: accountOpeningHomeService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._vtc),
                        _yob: accountOpeningHomeService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._yob),
                        _loc: accountOpeningHomeService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._loc),
                        _lm: accountOpeningHomeService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._lm)

                    }
                   securedScannedData._dob =  accountOpeningHomeService.setDateFormatDDMMYYY(securedScannedData._dob);
                    if (accountOpeningHomeService.nomineeAadhaarCardDetails.uid === accountOpeningHomeService.checkSecuredData(numbers, securedScannedData._uid)) {
                        var title = '';
                        var template = "{{'AADHAAR_BOTH_SAME'| translate}}";
                        var onTap = '';
                        var buttontext = "<b>" + aadharAOVm.okBtntext + "</b>";
                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                    } else {
                        setTimeout(function() {
                            accountOpeningHomeService.customerAadhaarCardDetails.uid = accountOpeningHomeService.checkSecuredData(numbers, securedScannedData._uid);
                            accountOpeningHomeService.customerAadhaarCardDetails.name = accountOpeningHomeService.checkSecuredData(alphabets, securedScannedData._name);
                            accountOpeningHomeService.customerAadhaarCardDetails.gender = accountOpeningHomeService.checkSecuredData(alphabets, securedScannedData._gender);
                            accountOpeningHomeService.customerAadhaarCardDetails.yob = accountOpeningHomeService.checkSecuredData(numbers, securedScannedData._yob);
                            accountOpeningHomeService.customerAadhaarCardDetails.house = accountOpeningHomeService.checkSecuredData(addressRegex, securedScannedData._house);
                            accountOpeningHomeService.customerAadhaarCardDetails.street = accountOpeningHomeService.checkSecuredData(addressRegex, securedScannedData._street);
                            accountOpeningHomeService.customerAadhaarCardDetails.lm = accountOpeningHomeService.checkSecuredData(addressRegex, securedScannedData._lm);
                            accountOpeningHomeService.customerAadhaarCardDetails.loc = accountOpeningHomeService.checkSecuredData(addressRegex, securedScannedData._loc);
                            accountOpeningHomeService.customerAadhaarCardDetails.vtc = accountOpeningHomeService.checkSecuredData(addressRegex, securedScannedData._vtc);
                            accountOpeningHomeService.customerAadhaarCardDetails.po = accountOpeningHomeService.checkSecuredData(addressRegex, securedScannedData._po);
                            accountOpeningHomeService.customerAadhaarCardDetails.dist = accountOpeningHomeService.checkSecuredData(addressRegex, securedScannedData._dist);
                            accountOpeningHomeService.customerAadhaarCardDetails.subdist = accountOpeningHomeService.checkSecuredData(addressRegex, securedScannedData._subdist);
                            accountOpeningHomeService.customerAadhaarCardDetails.state = accountOpeningHomeService.checkSecuredData(addressRegex, securedScannedData._state);
                            accountOpeningHomeService.customerAadhaarCardDetails.pc = accountOpeningHomeService.checkSecuredData(numbers, securedScannedData._pc);
                            accountOpeningHomeService.customerAadhaarCardDetails.dob = securedScannedData._dob;
                            if(securedScannedData._dob){
                                accountOpeningHomeService.showAadhaarAgeProofFlag = false;
                            }else{
                                accountOpeningHomeService.showAadhaarAgeProofFlag = true;
                            }
                            aadharAOVm.isScanned = true;
                            enterOTPAOService.isAadhaarScanEntry = true;
                            enterOTPAOService.isVID = false;
                            enterOTPAOService.isAadhaarManualEntry = false;
                            //$state.go('menu.pdetailsAN');
                            $state.go('menu.personalDetailsAO');
                        }, 500);
                    }
                }
                
            }, function (error) {
                utilityService.showBhimUpiAlert("error", error);
            });






// -------------------------------------------------------------------------------------------



        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
