'use strict';

angularApp.controller('citizenshipDetailsAOController', ["$state",
    "$scope",
    "$translate",
    "utilityService",
    "citizenshipDetailsAOService",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "$ionicPopover",
    "$ionicPopup",
    "userLoginDetailsService",
    "currentAddressPDCService",
    "accountOpeningHomeService",
    "enterOTPAOService",
    "chequeBookServiceDetailsService",
    "$ionicHistory",
    function($state,
        $scope,
        $translate,
        utilityService,
        citizenshipDetailsAOService,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService,
        $ionicPopover,
        $ionicPopup,
        userLoginDetailsService,
        currentAddressPDCService,
        accountOpeningHomeService,
        enterOTPAOService,
        chequeBookServiceDetailsService,
        $ionicHistory) {

        var citizenshipDetailsAOVm = this;

        function initPage() {
            citizenshipDetailsAOVm.showBack = true;
            citizenshipDetailsAOVm.showNext = true;
            citizenshipDetailsAOVm.disableNext = true;
            citizenshipDetailsAOVm.country = "";
			citizenshipDetailsAOVm.getInfoMsg = "";
            citizenshipDetailsAOVm.selectCountries = [];
            citizenshipDetailsAOVm.selectCitizen = [];
            citizenshipDetailsAOVm.selectNationality = [];
            citizenshipDetailsAOVm.aofooter = true;

            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                citizenshipDetailsAOVm.okBtntext = translatedvalue;
            });
            
        }

        citizenshipDetailsAOVm.getCountriesList = function() {
            if(citizenshipDetailsAOVm.selectCountries.length == 0){
            citizenshipDetailsAOService.getCountries().then(function(body) {
                if(!utilityService.isUndefined(body)){
                    for (var i = 0; i < body.length; i++) {
                        citizenshipDetailsAOVm.selectCountries.push(body[i].name);
                        citizenshipDetailsAOVm.selectCountries.sort();
                    }
                }                
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
            }
        }

        citizenshipDetailsAOVm.getNationalityList = function() {
            if(citizenshipDetailsAOVm.selectNationality.length == 0){
            citizenshipDetailsAOService.getNationality().then(function(body) {
                if(!utilityService.isUndefined(body)){
                    citizenshipDetailsAOVm.selectNationality = body;
                }                
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
            }
        }

        citizenshipDetailsAOVm.getCitizenshipList = function() {
            if(citizenshipDetailsAOVm.selectCitizen.length == 0){
            citizenshipDetailsAOService.getCitizenship().then(function(body) {
                if(!utilityService.isUndefined(body)){
                    for (var i = 0; i < body.length; i++) {
                        citizenshipDetailsAOVm.selectCitizen = body;
                    }
                }                
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
            }
        }

        citizenshipDetailsAOVm.showHideFilterDropDown = function(isValid) {
            if (!utilityService.isUndefined(citizenshipDetailsAOVm.country)) {
                citizenshipDetailsAOVm.hideOptions = true;
                //citizenshipDetailsAOVm.disableNext = false;
            } 
           else {
                citizenshipDetailsAOVm.hideOptions = false;
                citizenshipDetailsAOVm.disableNext = true;
            }
        }

        citizenshipDetailsAOVm.showHideCitizen = function(isValid) {
            if (!utilityService.isUndefined(citizenshipDetailsAOVm.citizen)) {
                citizenshipDetailsAOVm.citizenList = true;
                //citizenshipDetailsAOVm.disableNext = false;
            } 
           else {
                citizenshipDetailsAOVm.citizenList = false;
                citizenshipDetailsAOVm.disableNext = true;
            }
        }

        citizenshipDetailsAOVm.showHideNationality = function(isValid) {
            if (!utilityService.isUndefined(citizenshipDetailsAOVm.nationality)) {
                citizenshipDetailsAOVm.nationList = true;
            } 
           else {
                citizenshipDetailsAOVm.nationList = false;
                citizenshipDetailsAOVm.disableNext = true;
            }
        }

        citizenshipDetailsAOVm.goBacktoPrevious = function() {
            citizenshipDetailsAOService.previousState = "";
            $state.go('menu.personalDetailsAO'); 
        }

        $scope.goToHome = function() {
            accountOpeningHomeService.homeNav();
        }

        citizenshipDetailsAOVm.goToNextPage = function() {
            if (!utilityService.isUndefined(citizenshipDetailsAOVm.city) && !utilityService.isUndefined(citizenshipDetailsAOVm.country) && citizenshipDetailsAOVm.country.toLowerCase() == constantConfig.acOp.india.toLowerCase() && !utilityService.isUndefined(citizenshipDetailsAOVm.nationality) && !utilityService.isUndefined(citizenshipDetailsAOVm.citizen) && citizenshipDetailsAOVm.citizen.toLowerCase() == constantConfig.acOp.india.toLowerCase() && citizenshipDetailsAOVm.nationality.toLowerCase() == constantConfig.acOp.india.toLowerCase()) {
                citizenshipDetailsAOService.customerAdditionalDetails.cityOfBirth = citizenshipDetailsAOVm.city;
                citizenshipDetailsAOService.customerAdditionalDetails.countryOfBirth = citizenshipDetailsAOVm.country;
                citizenshipDetailsAOService.customerAdditionalDetails.nationality = citizenshipDetailsAOVm.nationality;
                citizenshipDetailsAOService.customerAdditionalDetails.citizenship = citizenshipDetailsAOVm.citizen;
                    var requestParams = {
                        "id": userLoginDetailsService.mobile,
                        "type":"AO",
                        "data": {
                            "personalDetails": {
                                "name": citizenshipDetailsAOService.customerManualEntryDetails.fullName,
                                "firstName": citizenshipDetailsAOService.customerManualEntryDetails.firstName.trim(),
                                "middleName": citizenshipDetailsAOService.customerManualEntryDetails.middleName ? citizenshipDetailsAOService.customerManualEntryDetails.middleName.trim() : "",
                                "lastName": citizenshipDetailsAOService.customerManualEntryDetails.lastName ? citizenshipDetailsAOService.customerManualEntryDetails.lastName.trim() : "",
                                "title": citizenshipDetailsAOService.customerManualEntryDetails.title,
                                "gender": citizenshipDetailsAOService.customerManualEntryDetails.gender,
                                "titleCode": citizenshipDetailsAOService.customerManualEntryDetails.titleCode,
                                "genderCode": citizenshipDetailsAOService.customerManualEntryDetails.genderCode,
                                "dob": citizenshipDetailsAOService.customerManualEntryDetails.dob,
                                "scannedCorrespondenceAddFlag": citizenshipDetailsAOService.customerManualEntryDetails.isCustManualCorresChkBox ? citizenshipDetailsAOService.customerManualEntryDetails.isCustManualCorresChkBox : "",
                                "isAadhaarScanned": citizenshipDetailsAOVm.isAadhaarScanEntry ? citizenshipDetailsAOVm.isAadhaarScanEntry : false,
                                "nationality":citizenshipDetailsAOService.customerAdditionalDetails.nationality,
                                "nationalityCode":citizenshipDetailsAOService.customerAdditionalDetails.nationalityID,
                                "citizenship": citizenshipDetailsAOService.customerAdditionalDetails.citizenship,
                                "citizenshipCode": citizenshipDetailsAOService.customerAdditionalDetails.citizenshipID,
                                "cityOfBirth": citizenshipDetailsAOService.customerAdditionalDetails.cityOfBirth,
                                "placeOfBirth": citizenshipDetailsAOService.customerAdditionalDetails.cityOfBirth,
                                "countryOfBirth": citizenshipDetailsAOService.customerAdditionalDetails.countryOfBirth,
                                "uid": citizenshipDetailsAOVm.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar ? citizenshipDetailsAOService.customerManualEntryDetails.uid : " ",
                                "journeyType": citizenshipDetailsAOVm.journeyType,
                                "vid": citizenshipDetailsAOVm.isVID ? citizenshipDetailsAOService.customerManualEntryDetails.vid : " "
                                
                            },
                            "commonId": $state.$current.data.commonId
                        }
                    }
                    
                    citizenshipDetailsAOService.savePersonaldetailsOVD(requestParams).then(function(response) {
                        if (response.responseCode === constantConfig.successCode) {
		                         
							if (response.data.cif == "0000") {
                                citizenshipDetailsAOService.previousState = "";
                                citizenshipDetailsAOService.citizenshipDetailsSaved = true;
								if (chequeBookServiceDetailsService.isPasswordSet) {
                                    if((citizenshipDetailsAOVm.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar && citizenshipDetailsAOVm.isAadhaarScanEntry) || (citizenshipDetailsAOVm.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar && citizenshipDetailsAOVm.isVID)){
                                        $state.go('menu.aadharScanAddress');
                                    }else if(citizenshipDetailsAOVm.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar && citizenshipDetailsAOVm.isAadhaarManualEntry){
                                        $state.go('menu.getPictureAO');
                                    }else{
                                        $state.go('menu.currentAddressPDAO');
                                    }
								} else {
                                    if((citizenshipDetailsAOVm.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar && citizenshipDetailsAOVm.isAadhaarScanEntry) || (citizenshipDetailsAOVm.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar && citizenshipDetailsAOVm.isVID)){
                                        $state.go('menu.aadharScanAddress');
                                    }else{
                                        $state.go('menu.tempLoginAO');
                                    }
									
								}
							} else {
                                    citizenshipDetailsAOService.previousState = "";
								    enterOTPAOService.ismultipleCustomerAO = true;
									$state.go('menu.multipleCustomerAO');
							}
		
							}

                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                        // $state.go('menu.aadharScanAddress');  //FOR TIME BEING JUST TO TEST
                    });
            }
            else{
				 var template = '{{"CITYCOUNTRY_NOTINDIA" | translate}}';
				if(citizenshipDetailsAOVm.country.toLowerCase() != constantConfig.acOp.india.toLowerCase()){
					 var template = '{{"CITYCOUNTRY_NOTINDIA" | translate}}';
				}else if(citizenshipDetailsAOVm.citizen.toLowerCase() != constantConfig.acOp.india.toLowerCase()){
					 var template = '{{"CITYCOUNTRY_CITIZENSHIP_NOTINDIA" | translate}}';
				} else if(citizenshipDetailsAOVm.nationality.toLowerCase() != constantConfig.acOp.india.toLowerCase()){
					 var template = '{{"CITYCOUNTRY_NATIONALITY_NOTINDIA" | translate}}';
				}
                var title = '';
               
                var onTap = '';
                var buttontext = '<b>' + citizenshipDetailsAOVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            }
        }
       
        citizenshipDetailsAOVm.validateForm = function(isValid) {
            if (isValid === true && citizenshipDetailsAOVm.country.toLowerCase() === constantConfig.acOp.india.toLowerCase() && !utilityService.isUndefined(citizenshipDetailsAOVm.citizen) && !utilityService.isUndefined(citizenshipDetailsAOVm.nationality)) {
                citizenshipDetailsAOVm.disableNext = false;
                citizenshipDetailsAOVm.cityValidate = true;
            } else {
                citizenshipDetailsAOVm.disableNext = true;
                citizenshipDetailsAOVm.cityValidate = false;
            }
        }

        citizenshipDetailsAOVm.abortProcess = function(selectValue) {
            citizenshipDetailsAOVm.country = selectValue;
            citizenshipDetailsAOVm.hideOptions = false;
            if (utilityService.isUndefined(citizenshipDetailsAOVm.country)) {
                citizenshipDetailsAOVm.disableNext = true;
            } else if (selectValue.toLowerCase() !== constantConfig.acOp.india.toLowerCase() && !utilityService.isUndefined(citizenshipDetailsAOVm.country)) {
                var title = '';
                var template = '{{"CITYCOUNTRY_NOTINDIA" | translate}}';
                var onTap = '';
                var buttontext = '<b>' + citizenshipDetailsAOVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);

                citizenshipDetailsAOVm.disableNext = true;

            } else {
                citizenshipDetailsAOVm.disableNext = utilityService.isUndefined(citizenshipDetailsAOVm.city);
            }
        }

        citizenshipDetailsAOVm.abortNationality = function(param) {
            citizenshipDetailsAOVm.nationality = param.name;
            citizenshipDetailsAOService.customerAdditionalDetails.nationalityID = param.code;
            citizenshipDetailsAOVm.nationList = false;
            if (utilityService.isUndefined(citizenshipDetailsAOVm.nationality)) {
                citizenshipDetailsAOVm.disableNext = true;
            } else if (param.name.toLowerCase() !== constantConfig.acOp.india.toLowerCase() && !utilityService.isUndefined(citizenshipDetailsAOVm.nationality)) {
                var title = '';
                var template = '{{"CITYCOUNTRY_NOTINDIA" | translate}}';
                var onTap = '';
                var buttontext = '<b>' + citizenshipDetailsAOVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);

                citizenshipDetailsAOVm.disableNext = true;

            }
        }

        citizenshipDetailsAOVm.abortCitizenship = function(value) {
            citizenshipDetailsAOVm.citizen = value.name;
            citizenshipDetailsAOService.customerAdditionalDetails.citizenshipID = value.code;
            citizenshipDetailsAOVm.citizenList = false;
            if (utilityService.isUndefined(citizenshipDetailsAOVm.citizen)) {
                citizenshipDetailsAOVm.disableNext = true;
            } else if (value.name.toLowerCase() !== constantConfig.acOp.india.toLowerCase() && !utilityService.isUndefined(citizenshipDetailsAOVm.citizen)) {
                var title = '';
                var template = '{{"CITYCOUNTRY_CITIZENSHIP_NOTINDIA" | translate}}';
                var onTap = '';
                var buttontext = '<b>' + citizenshipDetailsAOVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);

                citizenshipDetailsAOVm.disableNext = true;

            } 
        }

         /* Info Popup */
        var template = '<ion-popover-view class="tooltiptext-ovd ao-popupInfo roboto-regular ao-aadhaarInfoHt">' + '<ion-content>' +
                        '<div class="" ng-bind="citizenshipDetailsAOVm.getInfoMsg"></div>' + '</ion-content>' + '</ion-popover-view>';

        $scope.popover = $ionicPopover.fromTemplate(template, {
            scope: $scope
        });

        citizenshipDetailsAOVm.infoPopup = function($event,clickId) {
			 citizenshipDetailsAOService.getInfoList().then(function(body) {
				 if(clickId == "citizen"){
				 	citizenshipDetailsAOVm.getInfoMsg = body.infoList.citizenshipContent;
				 }else if(clickId == "nationality"){
				 	citizenshipDetailsAOVm.getInfoMsg = body.infoList.nationalityContent;
				 }
				 
            	$scope.popover.show($event);                   
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });            
        };

        citizenshipDetailsAOVm.closePopover = function() {
            $scope.popover.hide();
        };

        citizenshipDetailsAOVm.populateResumeData = function() {
                      
               //if(citizenshipDetailsAOVm.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar && currentAddressPDCService.isCustomerCorrespondenceAddressSet || citizenshipDetailsAOVm.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalOVD || (citizenshipDetailsAOVm.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar && ($ionicHistory.viewHistory().backView.stateId = "menu.aadharScanAddress"))){
                if(citizenshipDetailsAOVm.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar && currentAddressPDCService.isCustomerCorrespondenceAddressSet || citizenshipDetailsAOVm.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalOVD || (citizenshipDetailsAOVm.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar && citizenshipDetailsAOVm.isAadhaarManualEntry) || (citizenshipDetailsAOVm.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar && citizenshipDetailsAOService.previousState == "AADHAARADDRESS") || (citizenshipDetailsAOVm.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar && citizenshipDetailsAOService.previousState == "TEMPUSER") || citizenshipDetailsAOService.citizenshipDetailsSaved){

                citizenshipDetailsAOVm.city = citizenshipDetailsAOService.customerAdditionalDetails.cityOfBirth;
                citizenshipDetailsAOVm.country = citizenshipDetailsAOService.customerAdditionalDetails.countryOfBirth;
                citizenshipDetailsAOVm.nationality = citizenshipDetailsAOService.customerAdditionalDetails.nationality;
                citizenshipDetailsAOVm.citizen = citizenshipDetailsAOService.customerAdditionalDetails.citizenship;
                if(!utilityService.isUndefined(citizenshipDetailsAOVm.city) && !utilityService.isUndefined(citizenshipDetailsAOVm.country) && citizenshipDetailsAOVm.country.toLowerCase() == constantConfig.acOp.india.toLowerCase() && !utilityService.isUndefined(citizenshipDetailsAOVm.nationality) && !utilityService.isUndefined(citizenshipDetailsAOVm.citizen) && citizenshipDetailsAOVm.citizen.toLowerCase() == constantConfig.acOp.india.toLowerCase() && citizenshipDetailsAOVm.nationality.toLowerCase() == constantConfig.acOp.india.toLowerCase())
                citizenshipDetailsAOVm.disableNext = false;
                citizenshipDetailsAOVm.hideOptions = false;
                citizenshipDetailsAOVm.nationList = false;
                citizenshipDetailsAOVm.citizenList = false;
                citizenshipDetailsAOVm.journeyType = citizenshipDetailsAOVm.journeyType;

               }else{

                citizenshipDetailsAOVm.city = "";
                citizenshipDetailsAOVm.country = "";
                citizenshipDetailsAOVm.nationality = "";
                citizenshipDetailsAOVm.citizen = "";
                citizenshipDetailsAOVm.journeyType = citizenshipDetailsAOVm.journeyType;

               }
        }

        /* Clear the Search field */
        $scope.clearSearch = function() {
            citizenshipDetailsAOVm.country = "";
        };

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
            if(!citizenshipDetailsAOService.customerAdditionalDetails){
            	citizenshipDetailsAOService.customerAdditionalDetails = {};
            }
            if(!citizenshipDetailsAOService.customerManualEntryDetails){
            	citizenshipDetailsAOService.customerManualEntryDetails = {}
            }
            if(!citizenshipDetailsAOService.aadhaarManualPermanentAddress){
            	citizenshipDetailsAOService.aadhaarManualPermanentAddress = {}
            }
            
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
        	if(!citizenshipDetailsAOService.customerAdditionalDetails){
        		citizenshipDetailsAOService.customerAdditionalDetails = {};
            }
            citizenshipDetailsAOVm.journeyType = accountOpeningHomeService.journeyType;
            citizenshipDetailsAOVm.isAadhaarScanEntry = enterOTPAOService.isAadhaarScanEntry;
            citizenshipDetailsAOVm.isAadhaarManualEntry = enterOTPAOService.isAadhaarManualEntry;
            citizenshipDetailsAOVm.isVID = enterOTPAOService.isVID ;
        	if (enterOTPAOService.isResumeJourney == true ||
        		citizenshipDetailsAOService.customerAdditionalDetails.nationality) {
                    if(enterOTPAOService.isResumeJourney == false){
                        citizenshipDetailsAOVm.journeyType = accountOpeningHomeService.journeyType;
                    }else{
                        citizenshipDetailsAOVm.journeyType = enterOTPAOService.taxPage.journeyType;
                    }
                    
            	citizenshipDetailsAOVm.populateResumeData();
            }else{
                citizenshipDetailsAOVm.journeyType = accountOpeningHomeService.journeyType;
            }
            

            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
			     citizenshipDetailsAOVm.cityCountryForm.$setPristine();
			citizenshipDetailsAOVm.getCountriesList();
            citizenshipDetailsAOVm.getNationalityList();
            citizenshipDetailsAOVm.getCitizenshipList();
        });
        return this;
    }
]);
