'use strict';

angularApp.controller('currentAddressPDAOController', ["$state",
    "$scope",
   // "currentAddressPDCService",
    "currentAddressPDCService",
    "utilityService",
    "$translate",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "userLoginDetailsService",
    "accountOpeningHomeService",
    "enterOTPAOService",
    function($state,
        $scope,
       // currentAddressPDCService,
        currentAddressPDCService,
        utilityService,
        $translate,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService,
        userLoginDetailsService,
        accountOpeningHomeService,
        enterOTPAOService) {

        var currentAddressPDAOVm = this;

        function initPage() {
            currentAddressPDAOVm.showBack = true;
            currentAddressPDAOVm.showNext = true;
            currentAddressPDAOVm.disableNext = true;
            currentAddressPDAOVm.aofooter = true;
            currentAddressPDAOVm.disableCity = true;
            currentAddressPDAOVm.disableState = true;
            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                currentAddressPDAOVm.okBtntext = translatedvalue;
            });
        }

        currentAddressPDAOVm.goBacktoPrevious = function() {
            $state.go('menu.citizenshipDetailsAO'); 
        }

       
        currentAddressPDAOVm.goToNextPage = function() {
                currentAddressPDCService.customerCorrespondenceAddress.address1 = currentAddressPDAOVm.addressAboveData;
                currentAddressPDCService.customerCorrespondenceAddress.address2 = currentAddressPDAOVm.addressBelowData;
                currentAddressPDCService.customerCorrespondenceAddress.pincode = currentAddressPDAOVm.pincodeData;
                currentAddressPDCService.customerCorrespondenceAddress.city = currentAddressPDCService.customer.city;
                currentAddressPDCService.customerCorrespondenceAddress.state = currentAddressPDCService.customer.state;
                currentAddressPDCService.customerCorrespondenceAddress.locality = currentAddressPDAOVm.localityData;
                currentAddressPDCService.customerCorrespondenceAddress.stateCode = currentAddressPDAOVm.stateData;
                currentAddressPDAOVm.ifAadharScanAddressUpdate();
            
        }

        currentAddressPDAOVm.ifAadharScanAddressUpdate = function() {
            var requestParams1 = {
                "id": userLoginDetailsService.mobile,
                "type":"AO",
                "data": {
                    "personalDetails": {
                        "address": [{
                            "type": "PERMANENT",
                            "addressLine1": currentAddressPDCService.customerCorrespondenceAddress.address1,
                            "addressLine2": currentAddressPDCService.customerCorrespondenceAddress.address2,
                            "pincode": currentAddressPDCService.customerCorrespondenceAddress.pincode,
                            "city": currentAddressPDCService.customerCorrespondenceAddress.city,
                            "cityCode": currentAddressPDCService.customerCorrespondenceAddress.cityCode,
                            "state": currentAddressPDCService.customerCorrespondenceAddress.state,
                            "stateCode": currentAddressPDCService.customerCorrespondenceAddress.stateCode,
                            "locality": currentAddressPDCService.customerCorrespondenceAddress.locality,
                            "district": currentAddressPDCService.customerCorrespondenceAddress.district,
                            "districtCode": currentAddressPDCService.customerCorrespondenceAddress.districtCode,
                            "village": "",
          					"villageCode": ""
                        }]
                    },
                    "commonId": $state.$current.data.commonId
                }                
            }
            
            currentAddressPDCService.savePersonalDetailsOVD(requestParams1).then(function(response) {
                if (response.responseCode === constantConfig.successCode) {
                    $state.go('menu.getPictureAO'); 
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.goToHome = function() {
            //currentAddressPDCService.homeNav();
            accountOpeningHomeService.homeNav();
        }

        currentAddressPDAOVm.changefn = function(param) {
            currentAddressPDAOVm.disableNext = !param;
        }

        currentAddressPDAOVm.updatedvalue = function(param) {
            (param) ? currentAddressPDAOVm.disableNext = false: currentAddressPDAOVm.disableNext = true;
            return currentAddressPDAOVm.disableNext;
        }

        currentAddressPDAOVm.pincodeChange = function() {
            var pincodevalue = (!utilityService.isUndefined(currentAddressPDAOVm.pincodeData));
            if (currentAddressPDAOVm.pincodeData === "" || (!utilityService.isUndefined(currentAddressPDAOVm.pincodeData)).length != 6) {
                currentAddressPDAOVm.cityData = "";
                currentAddressPDAOVm.stateData = "";
            }
        }

        //Service to return city and state based on the pincode entered 
        currentAddressPDAOVm.updatearea = function(param) {
            var inputparams = {
                "pinCode": currentAddressPDAOVm.pincodeData
            }
            if (currentAddressPDAOVm.currentAddressPDform.pincode.$valid === true && !utilityService.isUndefined(currentAddressPDAOVm.pincodeData)) {
                currentAddressPDCService.getAreaDetailForPincode(inputparams).then(function(data) {
                    if (utilityService.isUndefined(data)) {
                        var title = '';
                        var template = '{{"PINCODE_MATCH" | translate}}';
                        var onTap = '';
                        var buttontext = '<b>' + currentAddressPDAOVm.okBtntext + '</b>';
                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                        currentAddressPDAOVm.disableState = false;
                        currentAddressPDAOVm.disableCity = false;
                        currentAddressPDAOVm.stateList = "";
                    } else if (!utilityService.isUndefined(data[0].cityName) && !utilityService.isUndefined(data[0].stateName)) {
                        currentAddressPDAOVm.stateList = data;
                        currentAddressPDCService.customer.city = utilityService.getValue(data.cityName);
                        currentAddressPDCService.customer.state = utilityService.getValue(data.stateName);
                        currentAddressPDCService.customerCorrespondenceAddress.district = utilityService.getValue(data.districtName);
                        currentAddressPDCService.customerCorrespondenceAddress.cityCode = utilityService.getValue(data.cityCode);
                        currentAddressPDCService.customerCorrespondenceAddress.stateCode = utilityService.getValue(data.stateCode);
                        currentAddressPDCService.customerCorrespondenceAddress.districtCode = utilityService.getValue(data.districtCode);
                        currentAddressPDAOVm.cityData = currentAddressPDCService.customer.city;
                        currentAddressPDAOVm.stateData = currentAddressPDCService.customer.state;
                        currentAddressPDAOVm.disableCity = true;
                        currentAddressPDAOVm.disableState = true;
                        if(currentAddressPDAOVm.stateList.length == 1){
                            currentAddressPDAOVm.stateData = currentAddressPDAOVm.stateList[0].stateCode;
                            currentAddressPDAOVm.setstate({param: currentAddressPDAOVm.stateList[0].stateCode})
                        }

                    }
                }, function(error) {
                	currentAddressPDAOVm.stateList = "";
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else if (currentAddressPDAOVm.pincodeData === "" || (!utilityService.isUndefined(currentAddressPDAOVm.pincodeData)).length != 6) {
                currentAddressPDAOVm.cityData = "";
                currentAddressPDAOVm.stateData = "";
            }

        }

        currentAddressPDAOVm.checkUpdatedCityStateValid = function(param) {
            currentAddressPDAOVm.updatedvalue(param);
        }

        currentAddressPDAOVm.populateResumeData = function() {
          //  if (currentAddressPDCService.customerCorrespondenceAddress.isAadhaarScanned == true) {
                currentAddressPDAOVm.addressAboveData = currentAddressPDCService.customerCorrespondenceAddress.address1;
                currentAddressPDAOVm.addressBelowData = currentAddressPDCService.customerCorrespondenceAddress.address2;
                currentAddressPDAOVm.pincodeData = currentAddressPDCService.customerCorrespondenceAddress.pincode;
                currentAddressPDAOVm.cityData = currentAddressPDCService.customerCorrespondenceAddress.city;
                currentAddressPDAOVm.stateData = currentAddressPDCService.customerCorrespondenceAddress.state;
                currentAddressPDAOVm.localityData = currentAddressPDCService.customerCorrespondenceAddress.locality;
           // }
        };
        
        currentAddressPDAOVm.setstate = function(data) {
					var arr = currentAddressPDAOVm.stateList;
					if(data){
						var arrLength = arr.length;	
					for (var i = 0; i < arrLength; i++) {
						if (arr[i].stateCode == data.param) {
							var tempData = arr[i];
							currentAddressPDCService.customer.city = utilityService.getValue(tempData.cityName);
	                        currentAddressPDCService.customerCorrespondenceAddress.cityCode = utilityService.getValue(tempData.cityCode);
	                        currentAddressPDCService.customerCorrespondenceAddress.stateCode = utilityService.getValue(tempData.stateCode);
	                        currentAddressPDCService.customer.state = utilityService.getValue(tempData.stateName);
	                        currentAddressPDCService.customerCorrespondenceAddress.district = utilityService.getValue(tempData.districtName);
	                        currentAddressPDCService.customerCorrespondenceAddress.districtCode = utilityService.getValue(tempData.districtCode);
	                        
						}
					};
					}else{
						currentAddressPDAOVm.stateData = "";
						currentAddressPDCService.customerCorrespondenceAddress.state = "";
					}
			};  

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
        	if(!currentAddressPDCService.customer){
        		currentAddressPDCService.customer = {}
        	}
        	if(!currentAddressPDCService.customerCorrespondenceAddress){
        		currentAddressPDCService.customerCorrespondenceAddress = {}
        	}
        	if (enterOTPAOService.isResumeJourney == true ||
        		currentAddressPDCService.customerCorrespondenceAddress.address1) {
            currentAddressPDAOVm.populateResumeData();
            var param = {};
            currentAddressPDAOVm.updatearea({param:currentAddressPDAOVm.currentAddressPDform.$valid});
           }
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
