'use strict';

angularApp.controller('personalDetailsAOController', ["$state",
    "$scope",
    "citizenshipDetailsAOService",
    "utilityService",
    "$translate",
    "personalDetailsAOService",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "accountOpeningHomeService",
    "enterOTPAOService",
    "$ionicPopup",
    function($state,
        $scope,
        citizenshipDetailsAOService,
        utilityService,
        $translate,
        personalDetailsAOService,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService,
        accountOpeningHomeService,
        enterOTPAOService,
        $ionicPopup) {

        var personalDetailsAOVm = this;

        function initPage() {
            personalDetailsAOVm.showBack = true;
            personalDetailsAOVm.showNext = true;
            personalDetailsAOVm.aofooter = true;
            personalDetailsAOVm.invalid = false;
            personalDetailsAOVm.properDate = false;
            personalDetailsAOVm.disableNext = true;
            personalDetailsAOVm.digitalOVDConstant = constantConfig.acOpeningAdapterOVDConstant.digitalOVD;
            personalDetailsAOVm.digitalAadhaarConstant = constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar;
            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                personalDetailsAOVm.okBtntext = translatedvalue;
            });
            if(personalDetailsAOVm.isAadhaarScanEntry || personalDetailsAOVm.isVID){
                personalDetailsAOVm.validateForm(personalDetailsAOVm.personalDetailsForm.$valid);
                }
        }


        personalDetailsAOVm.differentAddressFromAadhaar = function(){
            $state.go('menu.addressNotSameAsAadhaarAO');
        }

         //On page load - change title dropdown based on the gender
         personalDetailsAOVm.populateTitle = function(value) {
            var title;
            var genderValue = value.toLowerCase();
            if (genderValue == "m" || genderValue == constantConfig.acOp.maleGender) {
                title = "01";
            } else {
                title = "02";
            }
            accountOpeningHomeService.customerAadhaarCardDetails.titleCode = title;
            accountOpeningHomeService.customerAadhaarCardDetails.title = accountOpeningHomeService.getValueById(personalDetailsAOVm.selectTitles, accountOpeningHomeService.customerAadhaarCardDetails.titleCode);
            accountOpeningHomeService.customerAadhaarCardDetails.gender = genderValue;
            return title;
        }

        //On page load - if gender is "M" / "F" - Change to full text
        personalDetailsAOVm.displayGender = function(value) {
            var genderLabel;
            var genderValue = value.toLowerCase();
            if (genderValue == "m" || genderValue == constantConfig.acOp.maleGender) {
                genderLabel = "Male";
            } else {
                genderLabel = "Female";
            }
            return genderLabel;
        }

        /* Functionality : Load titles (Master data)
           Event : On load
        */
        personalDetailsAOVm.loadTitles = function(){
            var requestData = "TitleLotus";
            if(!personalDetailsAOVm.selectTitles || personalDetailsAOVm.selectTitles.length < 3){
        	utilityService.showSpinner();
            personalDetailsAOService.getTitleList(requestData).then(function(response) {
            	utilityService.hideSpinner();
            	personalDetailsAOVm.isErorr = false;
                personalDetailsAOVm.selectTitles = response.data;

                if (personalDetailsAOVm.isAadhaarScanEntry || personalDetailsAOVm.isVID) {
                    if(personalDetailsAOVm.selectedGender == "M" || personalDetailsAOVm.selectedGender == "MALE"){
                        personalDetailsAOVm.disableSelectedTitle = true;
                    }
                    else{
                        personalDetailsAOVm.disableSelectedTitle = false;
                        personalDetailsAOVm.selectTitles.shift();
                    }
                }else{
                    personalDetailsAOVm.disableSelectedTitle = false;
                }

                personalDetailsAOVm.validateForm(personalDetailsAOVm.personalDetailsForm.$valid);
            }, function(error) {
            	personalDetailsAOVm.isErorr = true;
            	if(personalDetailsAOVm.genderList){
            	utilityService.hideSpinner();
            	}
                utilityService.showErrorMessage(error.responseMessage);
            });
            }else{
                if (personalDetailsAOVm.isAadhaarScanEntry || personalDetailsAOVm.isVID) {
                    if(personalDetailsAOVm.selectedGender == "M" || personalDetailsAOVm.selectedGender == "MALE"){
                        personalDetailsAOVm.disableSelectedTitle = true;
                    }
                    else{
                        personalDetailsAOVm.disableSelectedTitle = false;
                        personalDetailsAOVm.selectTitles.shift();
                    }
                }else{
                    personalDetailsAOVm.disableSelectedTitle = false;
                }
            }
            
        }

        /* Functionality : Load gender (Master data)
           Event : On load
        */
        personalDetailsAOVm.loadGenderList = function(){
            var requestParam = "Gender";
            if(!personalDetailsAOVm.genderList){
            utilityService.showSpinner();
            personalDetailsAOService.getGenderList(requestParam).then(function(response) {
                personalDetailsAOVm.isErorr = false;
                personalDetailsAOVm.genderList = response.data;
                personalDetailsAOVm.validateForm(personalDetailsAOVm.personalDetailsForm.$valid);
            }, function(error) {
                if(personalDetailsAOVm.selectTitles){
                utilityService.hideSpinner();
                }
                personalDetailsAOVm.isErorr = true;
                utilityService.showErrorMessage(error.responseMessage);
            });
            }
            
        }


                //On page load - Split the aadhaar card holder's name and display accordingly
                personalDetailsAOVm.displayNames = function(value) {

                citizenshipDetailsAOService.customerManualEntryDetails.firstName = "";
                citizenshipDetailsAOService.customerManualEntryDetails.lastName = "";
                citizenshipDetailsAOService.customerManualEntryDetails.middleName = "";
                personalDetailsAOVm.personalFname = "";
                personalDetailsAOVm.personalMname = "";
                personalDetailsAOVm.personalLname = "";


                    var fullName = value;
                    var splittedName = value.split(" ");
                    var splitLen = value.split(" ").length;
                    var i;
                    var middleName = [];
                    if (splitLen === 1) {
                        personalDetailsAOVm.personalFname = splittedName[0];
                        personalDetailsAOVm.isMName = false;
                        personalDetailsAOVm.isLName = false;
                    } else if (splitLen === 2) {
                        personalDetailsAOVm.isLName = true;
                        personalDetailsAOVm.personalFname = splittedName[0];
                        personalDetailsAOVm.personalLname = splittedName[1];
                        personalDetailsAOVm.isMName = false;
                    } else {
                        personalDetailsAOVm.isLName = true;
                        personalDetailsAOVm.isMName = true;
                        personalDetailsAOVm.personalFname = splittedName[0];
                        for (i = 1; i < splitLen - 1; i++) {
                            middleName[i] = splittedName[i];
                        }
                        personalDetailsAOVm.personalMname = middleName.join(' ');
                        personalDetailsAOVm.personalLname = splittedName[splitLen - 1];
                    }
                }


                personalDetailsAOVm.showAadhaarAgeProof=function(){
                    var infoPopup = $ionicPopup.show({
                        template: '<p translate="AADHAAR_AGE_PROOF" ></p>',
                        title:'Alert',
                        cssClass: 'dialog activated-blue',		
                        scope: $scope,
                        buttons: [ {
                            text: 'Ok',
                            onTap: function(e) {
                                $state.go('menu.citizenshipDetailsAO');
                            }
                        }]
                    });
                }



        /* Functionality :  Set the model values to common service for using it in other controller
           Event : on click of "next" button 
        */
        personalDetailsAOVm.goToNextPage = function() {
            personalDetailsAOVm.ageCheck = personalDetailsAOVm.checkAge();
              citizenshipDetailsAOService.customerManualEntryDetails.firstName = personalDetailsAOVm.personalFname;
                citizenshipDetailsAOService.customerManualEntryDetails.lastName = personalDetailsAOVm.personalLname;
                citizenshipDetailsAOService.customerManualEntryDetails.middleName = personalDetailsAOVm.personalMname;
                citizenshipDetailsAOService.customerManualEntryDetails.fullName = personalDetailsAOVm.personalFname + ' ' + personalDetailsAOVm.personalMname + ' ' + personalDetailsAOVm.personalLname;
                citizenshipDetailsAOService.customerManualEntryDetails.genderCode = personalDetailsAOVm.selectedGender;
                citizenshipDetailsAOService.customerManualEntryDetails.titleCode = personalDetailsAOVm.selectedTitle;
                citizenshipDetailsAOService.customerManualEntryDetails.uid = personalDetailsAOVm.uid;
                citizenshipDetailsAOService.customerManualEntryDetails.isCustManualCorresChkBox = personalDetailsAOVm.isChecked;
                citizenshipDetailsAOService.customerManualEntryDetails.title = accountOpeningHomeService.getValueById(personalDetailsAOVm.selectTitles,personalDetailsAOVm.selectedTitle);
                citizenshipDetailsAOService.customerManualEntryDetails.gender = accountOpeningHomeService.getValueById(personalDetailsAOVm.genderList,personalDetailsAOVm.selectedGender);               
                citizenshipDetailsAOService.customerManualEntryDetails.dob = personalDetailsAOVm.date + '/' + personalDetailsAOVm.month + '/' + personalDetailsAOVm.year;
           
                
                accountOpeningHomeService.customerAadhaarCardDetails.uid = "";
                accountOpeningHomeService.customerAadhaarCardDetails.name = "";
                accountOpeningHomeService.customerAadhaarCardDetails.firstName = "";
                accountOpeningHomeService.customerAadhaarCardDetails.middleName = "";
                accountOpeningHomeService.customerAadhaarCardDetails.lastName = "";
                accountOpeningHomeService.customerAadhaarCardDetails.gender = "";
                accountOpeningHomeService.customerAadhaarCardDetails.title = "";
                accountOpeningHomeService.customerAadhaarCardDetails.yob = "";
                accountOpeningHomeService.customerAadhaarCardDetails.dob = "";


                if (personalDetailsAOVm.ageCheck > 0) {
                    if(personalDetailsAOVm.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar){
                        if(accountOpeningHomeService.showAadhaarAgeProofFlag){
                            personalDetailsAOVm.showAadhaarAgeProof();
                        }else{
                            $state.go('menu.citizenshipDetailsAO');
                        }
                    }else{
                        $state.go('menu.citizenshipDetailsAO');
                    }
                } else {

                     var alertPopup = $ionicPopup.alert({
                            title: '',
                            template: '{{"AGE_CHECK" | translate}}',
                            cssClass: 'sbi-alert-popup',
                            buttons: [
                                {
                                    text: '<b>' + personalDetailsAOVm.okBtntext + '</b>',
                                    type: 'button-positive',
                                    onTap: function () {
                                        alertPopup.close();
                                    }
                                }
                            ],
                        });

                }
              
        }

        personalDetailsAOVm.goBacktoPrevious = function() {
            if(enterOTPAOService.isVID){

                citizenshipDetailsAOService.customerManualEntryDetails.firstName = "";
                citizenshipDetailsAOService.customerManualEntryDetails.middleName = "";
                citizenshipDetailsAOService.customerManualEntryDetails.lastName = "";
                citizenshipDetailsAOService.customerManualEntryDetails.genderCode = "";
                citizenshipDetailsAOService.customerManualEntryDetails.gender = "";
                citizenshipDetailsAOService.customerManualEntryDetails.titleCode = "";
                citizenshipDetailsAOService.customerManualEntryDetails.isCustManualCorresChkBox = "";
                citizenshipDetailsAOService.customerManualEntryDetails.uid = "";
                citizenshipDetailsAOService.customerManualEntryDetails.dob = "";
                accountOpeningHomeService.customerAadhaarCardDetails.yob = "";
                accountOpeningHomeService.showAadhaarAgeProofFlag = "";
                personalDetailsAOVm.onlyYob = "";

        		$state.go('menu.vidDetailsAO');
            }else if(enterOTPAOService.isAadhaarScanEntry){

                citizenshipDetailsAOService.customerManualEntryDetails.firstName = "";
                citizenshipDetailsAOService.customerManualEntryDetails.middleName = "";
                citizenshipDetailsAOService.customerManualEntryDetails.lastName = "";
                citizenshipDetailsAOService.customerManualEntryDetails.genderCode = "";
                citizenshipDetailsAOService.customerManualEntryDetails.gender = "";
                citizenshipDetailsAOService.customerManualEntryDetails.titleCode = "";
                citizenshipDetailsAOService.customerManualEntryDetails.isCustManualCorresChkBox = "";
                citizenshipDetailsAOService.customerManualEntryDetails.uid = "";
                citizenshipDetailsAOService.customerManualEntryDetails.dob = "";
                accountOpeningHomeService.customerAadhaarCardDetails.yob = "";
                accountOpeningHomeService.showAadhaarAgeProofFlag = "";
                personalDetailsAOVm.onlyYob = "";

                $state.go('menu.aadharScan');
            }else if(enterOTPAOService.isAadhaarManualEntry){

                // personalDetailsAOVm.personalFname = "";
                // personalDetailsAOVm.personalMname = "";
                // personalDetailsAOVm.personalLname = "";
                // personalDetailsAOVm.selectedGender = "";
                // personalDetailsAOVm.selectedGenderValue = "";
                // personalDetailsAOVm.selectedTitle = "";
                // personalDetailsAOVm.isChecked = "";
                // personalDetailsAOVm.uid = "";

                $state.go('menu.aadhaarOption');
            }else{
        		$state.go('menu.POCADetailsAO');  	
        	}
        }

        //Auto populate the data in resume journey
        personalDetailsAOVm.populateResumeData = function() {
                //personalDetailsAOVm.aadhaarnumber = citizenshipDetailsAOService.customerManualEntryDetails.aadharNumber;
                personalDetailsAOVm.personalFname = citizenshipDetailsAOService.customerManualEntryDetails.firstName;
                personalDetailsAOVm.personalMname = citizenshipDetailsAOService.customerManualEntryDetails.middleName;
                personalDetailsAOVm.personalLname = citizenshipDetailsAOService.customerManualEntryDetails.lastName;
                personalDetailsAOVm.selectedGender = citizenshipDetailsAOService.customerManualEntryDetails.genderCode;
                personalDetailsAOVm.selectedGenderValue = citizenshipDetailsAOService.customerManualEntryDetails.gender;
                personalDetailsAOVm.selectedTitle = citizenshipDetailsAOService.customerManualEntryDetails.titleCode;
                personalDetailsAOVm.isChecked = citizenshipDetailsAOService.customerManualEntryDetails.isCustManualCorresChkBox;
                personalDetailsAOVm.uid = citizenshipDetailsAOService.customerManualEntryDetails.uid;
                if(personalDetailsAOVm.personalDetailsForm){
                	personalDetailsAOVm.validateForm(personalDetailsAOVm.personalDetailsForm.$valid);	
                } 
                personalDetailsAOVm.setResumeDob();
        }


        // On page load - populate aadhaar dob

        personalDetailsAOVm.populateDobAadhaar = function() {
            if (!utilityService.isUndefined(accountOpeningHomeService.customerAadhaarCardDetails.dob)) {
                accountOpeningHomeService.customerAadhaarCardDetails.dob = moment(accountOpeningHomeService.customerAadhaarCardDetails.dob, ["DD/MM/YYYY", "MM/DD/YYYY", "DD-MM-YYYY", "MM-DD-YYYY", "YYYY-MM-DD", "YYYY-DD-MM" ,"YYYY/MM/DD", "YYYY/DD/MM"]);
                var dateFormat = new Date(accountOpeningHomeService.customerAadhaarCardDetails.dob);
                var day = dateFormat.getDate();
                var month = dateFormat.getMonth() + 1;
                var year = dateFormat.getFullYear();
                var formattedDate = day.toString();
                if (formattedDate.length == 1) {
                    formattedDate = "0" + formattedDate;
                    personalDetailsAOVm.date = formattedDate;
                } else {
                    personalDetailsAOVm.date = parseInt(day);
                }
                var formattedMonth = month.toString();
                if (formattedMonth.length == 1) {
                    formattedMonth = "0" + formattedMonth;
                    personalDetailsAOVm.month = formattedMonth;
                } else {
                    personalDetailsAOVm.month = parseInt(month);
                }
                personalDetailsAOVm.year = parseInt(year);
            } else if (!utilityService.isUndefined(accountOpeningHomeService.customerAadhaarCardDetails.yob) && utilityService.isUndefined(accountOpeningHomeService.customerAadhaarCardDetails.dob)) {
                personalDetailsAOVm.date = "";
                personalDetailsAOVm.month = "";
                personalDetailsAOVm.year = parseInt(accountOpeningHomeService.customerAadhaarCardDetails.yob);
            }else if (utilityService.isUndefined(accountOpeningHomeService.customerAadhaarCardDetails.yob) && (accountOpeningHomeService.customerAadhaarCardDetails.dob == "")) {
                personalDetailsAOVm.date = "";
                personalDetailsAOVm.month = "";
                personalDetailsAOVm.year = "";
            }
        }

        personalDetailsAOVm.setResumeDob = function() {
            if (!utilityService.isUndefined(citizenshipDetailsAOService.customerManualEntryDetails.dob)) {
                citizenshipDetailsAOService.customerManualEntryDetails.dob = moment(citizenshipDetailsAOService.customerManualEntryDetails.dob, ["DD/MM/YYYY", "MM/DD/YYYY", "DD-MM-YYYY", "MM-DD-YYYY", "YYYY-MM-DD", "YYYY-DD-MM" ,"YYYY/MM/DD", "YYYY/DD/MM"]);
                var dateFormat = new Date(citizenshipDetailsAOService.customerManualEntryDetails.dob);
                var day = dateFormat.getDate();
                var month = dateFormat.getMonth() + 1;
                var year = dateFormat.getFullYear();
                var formattedDate = day.toString();
                if (formattedDate.length == 1) {
                    formattedDate = "0" + formattedDate;
                    personalDetailsAOVm.date = formattedDate;
                } else {
                    personalDetailsAOVm.date = parseInt(day);
                }
                var formattedMonth = month.toString();
                if (formattedMonth.length == 1) {
                    formattedMonth = "0" + formattedMonth;
                    personalDetailsAOVm.month = formattedMonth;
                } else {
                    personalDetailsAOVm.month = parseInt(month);
                }
                personalDetailsAOVm.year = parseInt(year);
            } else if (!utilityService.isUndefined(citizenshipDetailsAOService.customerManualEntryDetails.yob) && utilityService.isUndefined(citizenshipDetailsAOService.customerManualEntryDetails.dob)) {
                personalDetailsAOVm.date = "";
                personalDetailsAOVm.month = "";
                personalDetailsAOVm.year = parseInt(citizenshipDetailsAOService.customerManualEntryDetails.yob);
            }else if (utilityService.isUndefined(citizenshipDetailsAOService.customerManualEntryDetails.yob) && (citizenshipDetailsAOService.customerManualEntryDetails.dob == "")) {
                personalDetailsAOVm.date = "";
                personalDetailsAOVm.month = "";
                personalDetailsAOVm.year = "";
            }
        }
        $scope.goToHome = function() {
            accountOpeningHomeService.homeNav();
        }

        personalDetailsAOVm.validateForm = function(isValid) {
            personalDetailsAOVm.disableNext = !isValid;
            if(personalDetailsAOVm.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar && personalDetailsAOVm.isAadhaarManualEntry){
            if(isValid){
                if(personalDetailsAOVm.isChecked){
                    personalDetailsAOVm.disableNext = false;
                }else{
                    personalDetailsAOVm.disableNext = true;
                }
            }
            }
        }

        /* Based on the title change, populate the gender dropdown */
        personalDetailsAOVm.genderUpdate = function(value) {
            if (utilityService.isUndefined(value)) {
                personalDetailsAOVm.selectedGender = constantConfig.acOp.gender;
            } else if (value === "01") {
                personalDetailsAOVm.selectedGender = "M";
            } else {
                personalDetailsAOVm.selectedGender = "F";
            }
        }

        /* Based on gender change, populate title dropdown */
        personalDetailsAOVm.titleUpdate = function(value) {
            if (utilityService.isUndefined(value)) {
                personalDetailsAOVm.selectedTitle = constantConfig.acOp.title;
            } else if (value.toLowerCase() === constantConfig.acOp.male || value.toLowerCase() === "m") {
                personalDetailsAOVm.selectedTitle = "01";
            } else if (value.toLowerCase() === constantConfig.acOp.female || value.toLowerCase() === "f"){
                personalDetailsAOVm.selectedTitle = "02";
            }
        }

        // Validate date
        personalDetailsAOVm.validDateFormat = function(isValid , monthOrDay) {
        	
            var fullDate = personalDetailsAOVm.month + '/' + personalDetailsAOVm.date + '/' + personalDetailsAOVm.year;
            var dobMonth = personalDetailsAOVm.month;
            var dobDay = personalDetailsAOVm.date;
            var dobYr = personalDetailsAOVm.year;
            var fullDateInMilliSeconds = Date.parse(fullDate);
            var formattedDate = new Date();
            var formattedDateYr = formattedDate.getFullYear();
            var currDate = new Date();
            var curYear = currDate.getFullYear();
            var curDateInMilliSeconds = new Date().getTime();
            formattedDate.setFullYear(dobYr, dobMonth - 1, dobDay);
            var months30 = ['04', '06', '09', '11', "4", "6", "9"];
            var monthIndex = months30.indexOf(dobMonth);

            // If entered date is greater than the current date
            if (fullDateInMilliSeconds > curDateInMilliSeconds) {
                personalDetailsAOVm.disableNext = true;
                personalDetailsAOVm.invalid = true;
                personalDetailsAOVm.properDate = false;
            }
            // Leap year validation
            else if (dobYr % 4 == 0 && (dobYr % 100 != 0 || dobYr % 400 == 0)) {
                if (dobMonth == 2 && dobDay > 29) {
                    personalDetailsAOVm.disableNext = true;
                    personalDetailsAOVm.invalid = true;
                    personalDetailsAOVm.properDate = false;
                } else if (monthIndex != -1 && dobDay == 31) {
                    personalDetailsAOVm.disableNext = true;
                    personalDetailsAOVm.invalid = true;
                    personalDetailsAOVm.properDate = false;
                } else {
                    personalDetailsAOVm.disableNext = !isValid;
                    personalDetailsAOVm.invalid = false;
                    personalDetailsAOVm.properDate = true;
                }
            } else if (dobMonth == 2 && dobDay >= 29) {
                personalDetailsAOVm.disableNext = true;
                personalDetailsAOVm.invalid = true;
                personalDetailsAOVm.properDate = false;
            }
            // If the month has only 30 days
            else if (monthIndex != -1 && dobDay == 31) {
                personalDetailsAOVm.disableNext = true;
                personalDetailsAOVm.invalid = true;
                personalDetailsAOVm.properDate = false;
            } else {
                personalDetailsAOVm.disableNext = !isValid;
                personalDetailsAOVm.invalid = false;
                personalDetailsAOVm.properDate = true;
            }
            if(personalDetailsAOVm.date  < 10  && personalDetailsAOVm.date.length == 1 ){
            	personalDetailsAOVm.disableNext = true;
                personalDetailsAOVm.invalid = true;
                personalDetailsAOVm.properDate = false;
            }
            if(personalDetailsAOVm.month  < 10 && personalDetailsAOVm.month.length == 1 ){
            	personalDetailsAOVm.disableNext = true;
                personalDetailsAOVm.invalid = true;
                personalDetailsAOVm.properDate = false;
            }
            return personalDetailsAOVm.properDate;
        }

        //Method to calculate customer age
        personalDetailsAOVm.checkAge = function() {
                personalDetailsAOVm.validDate = personalDetailsAOVm.validDateFormat();
                if (personalDetailsAOVm.validDate == true) {
                    var fullDate = personalDetailsAOVm.month + '/' + personalDetailsAOVm.date + '/' + personalDetailsAOVm.year;

                    var formattedDate = new Date();
                    formattedDate.setFullYear(personalDetailsAOVm.year, personalDetailsAOVm.month - 1, personalDetailsAOVm.date);
                    var todayDate = new Date();
                    var currentYear = todayDate.getFullYear();
                    var validYear = todayDate.setFullYear(currentYear - 18);
                    personalDetailsAOVm.customerAge = validYear - formattedDate;
                    personalDetailsAOVm.dob = fullDate;
                    personalDetailsAOVm.disableNext = false;
                } else if (personalDetailsAOVm.validDate == false) {
                    personalDetailsAOVm.disableNext = true;
                }
                return personalDetailsAOVm.customerAge;
            }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
            
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            personalDetailsAOVm.isAadhaarScanEntry = enterOTPAOService.isAadhaarScanEntry;
            personalDetailsAOVm.isVID = enterOTPAOService.isVID;
            personalDetailsAOVm.isAadhaarManualEntry = enterOTPAOService.isAadhaarManualEntry;
            if(enterOTPAOService.isAadhaarScanEntry){
                if(accountOpeningHomeService.redirectStatus != "AADHAARSCAN"){
                    personalDetailsAOVm.uid = "";
                    personalDetailsAOVm.selectedTitle = "";
                    personalDetailsAOVm.personalFname = "";
                    personalDetailsAOVm.personalMname = "";
                    personalDetailsAOVm.personalLname = "";
                    personalDetailsAOVm.selectedGender = "";
                    personalDetailsAOVm.selectedGenderValue = "";
                    personalDetailsAOVm.year ="";
                    personalDetailsAOVm.date = "";
                    personalDetailsAOVm.month ="";
                    accountOpeningHomeService.redirectStatus = "AADHAARSCAN";
                }
                
            }else if(enterOTPAOService.isAadhaarManualEntry){
                if(accountOpeningHomeService.redirectStatus != "AADHAARMANUAL"){
                    personalDetailsAOVm.uid = "";
                    personalDetailsAOVm.selectedTitle = "";
                    personalDetailsAOVm.personalFname = "";
                    personalDetailsAOVm.personalMname = "";
                    personalDetailsAOVm.personalLname = "";
                    personalDetailsAOVm.selectedGender = "";
                    personalDetailsAOVm.selectedGenderValue = "";
                    personalDetailsAOVm.year ="";
                    personalDetailsAOVm.date = "";
                    personalDetailsAOVm.month ="";
                    personalDetailsAOVm.onlyYob = true;
                    accountOpeningHomeService.redirectStatus = "AADHAARMANUAL";
                }
            }else if(enterOTPAOService.isVID){
                    if(accountOpeningHomeService.redirectStatus != "VID"){
                    personalDetailsAOVm.uid = "";
                    personalDetailsAOVm.selectedTitle = "";
                    personalDetailsAOVm.personalFname = "";
                    personalDetailsAOVm.personalMname = "";
                    personalDetailsAOVm.personalLname = "";
                    personalDetailsAOVm.selectedGender = "";
                    personalDetailsAOVm.selectedGenderValue = "";
                    personalDetailsAOVm.year ="";
                    personalDetailsAOVm.date = "";
                    personalDetailsAOVm.month ="";
                    accountOpeningHomeService.redirectStatus = "VID";
                }
            }
        	if(!citizenshipDetailsAOService.customerManualEntryDetails){
            	citizenshipDetailsAOService.customerManualEntryDetails = {}
            }
            
            if (enterOTPAOService.isResumeJourney == true ||
            	citizenshipDetailsAOService.customerManualEntryDetails.firstName) {
                    if(enterOTPAOService.isResumeJourney == false){
                        personalDetailsAOVm.journeyType = accountOpeningHomeService.journeyType;
                    }else{
                        personalDetailsAOVm.journeyType = enterOTPAOService.taxPage.journeyType;
                    }
                    personalDetailsAOVm.populateResumeData();
            }else{
                personalDetailsAOVm.journeyType = accountOpeningHomeService.journeyType;
            }

            if(personalDetailsAOVm.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalOVD){
                personalDetailsAOVm.onlyYob = true;
            }
            
            if (personalDetailsAOVm.isAadhaarScanEntry || personalDetailsAOVm.isVID) {
                //if (personalDetailsAOVm.isAadhaarScanEntry) {
                if(accountOpeningHomeService.customerAadhaarCardDetails.uid){
                personalDetailsAOVm.uid = accountOpeningHomeService.customerAadhaarCardDetails.uid;
                }
                if(accountOpeningHomeService.customerAadhaarCardDetails.name){
                personalDetailsAOVm.displayNames(accountOpeningHomeService.customerAadhaarCardDetails.name);
                 }
                 if(accountOpeningHomeService.customerAadhaarCardDetails.yob){
                 personalDetailsAOVm.year = accountOpeningHomeService.customerAadhaarCardDetails.yob;
                 }
                 if(accountOpeningHomeService.customerAadhaarCardDetails.dob || accountOpeningHomeService.customerAadhaarCardDetails.yob){
                    personalDetailsAOVm.populateDobAadhaar();
                 }
                 if(accountOpeningHomeService.customerAadhaarCardDetails.gender){
                    personalDetailsAOVm.selectedTitle = personalDetailsAOVm.populateTitle(accountOpeningHomeService.customerAadhaarCardDetails.gender);
                    personalDetailsAOVm.selectedGender = accountOpeningHomeService.customerAadhaarCardDetails.gender.toUpperCase();
                    personalDetailsAOVm.selectedGenderValue = personalDetailsAOVm.displayGender(accountOpeningHomeService.customerAadhaarCardDetails.gender);
                }

                personalDetailsAOVm.onlyYob = accountOpeningHomeService.showAadhaarAgeProofFlag;                
                
                //personalDetailsAOVm.disableNextIfEmpty();
            }

                personalDetailsAOVm.loadTitles();
                personalDetailsAOVm.loadGenderList();

            
            
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
