'use strict';

angularApp.controller('productInformationControllerAO', ["$state",
    "$scope",
    "utilityService",
    "$ionicSideMenuDelegate",
    "$translate",
    "knowMoreAOService",
    "productInformationService",
    "accountOpeningHomeService",
    "enterOTPAOService",
    function ($state,
        $scope,
        utilityService,
        $ionicSideMenuDelegate,
        $translate,
        knowMoreAOService,
        productInformationService,
        accountOpeningHomeService,
        enterOTPAOService) {

        var productInformationVm = this;

        productInformationVm.showBack = false;
        productInformationVm.showNext = true;

        function initPage() {
            productInformationVm.aofooter = true;
            
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                productInformationVm.okBtntext = translatedvalue;
            });
        }

        
        productInformationVm.loadProductFeatures = function () {
            if(!productInformationVm.featuresJson ){
            utilityService.showSpinner();
            var reqParams = {
                "journeyType": productInformationVm.journeyType
            }	
            productInformationService.getProductFeatures(reqParams).then(function (data) {
                utilityService.hideSpinner();
                productInformationVm.featuresJson = data.productFeatures;
            }, function (error) {
            	utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });
            }else{
            	//productInformationVm.featuresJson = productInformationVm.featuresJson;
            }
        }


        productInformationVm.knowmoreLink = function () {
            if(!knowMoreAOService.featuresJson){
            var reqParams = {
                 "journeyType": productInformationVm.journeyType
            }	
            productInformationService.knowmoreLinkFeatures(reqParams).then(function(data) {
                knowMoreAOService.featuresJson = data.productFeaturesKnowMore;
                $state.go('menu.knowMorePageAO');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
            }else{
            	$state.go('menu.knowMorePageAO');
            }
        }

       productInformationVm.goToNextPage = function () {
            $state.go('menu.userLoginDetailsAO');
        }
        
        $scope.goToHome = function() {
            accountOpeningHomeService.homeNav();
        }
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
           // $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        if(enterOTPAOService.isResumeJourney == false){
            productInformationVm.journeyType = accountOpeningHomeService.journeyType;
        }else{
            productInformationVm.journeyType = enterOTPAOService.taxPage.journeyType;
        }
           productInformationVm.loadProductFeatures();
        });

        $scope.$on('$ionicView.beforeLeave', function () {
            
        });

        return this;
    }
]);