'use strict';

angularApp.controller('productOfferingAOController', ["$state",
    "$scope",
    "productOfferingAOService",
    "accountOpeningHomeService",
    "utilityService",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "userLoginDetailsService",
    "chequeBookServiceDetailsService",
    "enterOTPAOService",
    function($state,
        $scope,
        productOfferingAOService,
        accountOpeningHomeService,
        utilityService,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService,
        userLoginDetailsService,
        chequeBookServiceDetailsService,
        enterOTPAOService) {

        var productOfferingAOVm = this;

        function initPage() {
            productOfferingAOVm.showBack = true;
            productOfferingAOVm.showNext = true;
            productOfferingAOVm.aofooter = true;
            if(accountOpeningHomeService.isResumeJourney == false)
            productOfferingAOVm.isChecked = false;
        }

        productOfferingAOVm.goBacktoPrevious = function(){
            $state.go('menu.termsAndConditionsAO');
        }
        
        productOfferingAOVm.goToNextPage = function() {
            productOfferingAOVm.postPODetails();
        }

        productOfferingAOVm.loadOtherProductOffers = function(){
            productOfferingAOService.getOtherProductOfferings().then(function(data) {
                productOfferingAOVm.productOfferingContent = data;
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        productOfferingAOVm.postPODetails = function(){
        	chequeBookServiceDetailsService.productOfferingFlag = productOfferingAOVm.isChecked;
            //accountOpeningHomeService.productOfferingFlag = productOfferingAOVm.isChecked;
            var requestParams = {
                "id" : userLoginDetailsService.mobile,                
                "data":{
                    "commonId":$state.$current.data.commonId,
                    "productOfferingFlag" : productOfferingAOVm.isChecked
                }
            }
            
            productOfferingAOService.postProdOffers(requestParams).then(function(response) {
                if(response.responseCode == constantConfig.successCode){
                      $state.go('menu.enterOTPProductOfferingAO');  
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        productOfferingAOVm.populateResumeData = function(){
            productOfferingAOVm.isChecked = chequeBookServiceDetailsService.productOfferingFlag;
        }
        
        $scope.goToHome = function() {
           accountOpeningHomeService.homeNav();
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            	if (enterOTPAOService.isResumeJourney == true) {
                productOfferingAOVm.populateResumeData();
            }
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            productOfferingAOVm.loadOtherProductOffers();
        });
        return this;
    }
]);
