'use strict';

angularApp.controller('resumeAccountControllerAO', ["$state",
    "$scope",
    "accountOpeningHomeService",
    "utilityService",
    "resumeJourneyServiceAO",
    "encryptionService",
    "cryptoService",
    "$translate",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "loggedInUserService",
    "AdapterUtils",
    "constantConfig",
    "ConnectivityMonitorUtils",
    "userLoginDetailsService",
    "nomineeDetailsAOService",
    function ($state,
        $scope,
        accountOpeningHomeService,
        utilityService,
        resumeJourneyServiceAO,
        encryptionService,
        cryptoService,
        $translate,
        $ionicSideMenuDelegate,
        mPinLoginService,
        loggedInUserService,
        AdapterUtils,
        constantConfig,
        ConnectivityMonitorUtils,
        userLoginDetailsService,
        nomineeDetailsAOService) {

        var resumeAccountAOVm = this;

        resumeAccountAOVm.isChallenged = false;
        resumeAccountAOVm.securityCheckName = "AOSecurityCheck";
        resumeAccountAOVm.aoAuthChallengeHandler = WL.Client.createSecurityCheckChallengeHandler(resumeAccountAOVm.securityCheckName);
        resumeAccountAOVm.aoAuthChallengeHandler.securityCheckName = resumeAccountAOVm.securityCheckName;

        function initPage() {
            resumeAccountAOVm.showBack = true;
            resumeAccountAOVm.showNext = true;
            resumeAccountAOVm.aofooter = true;
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                resumeAccountAOVm.okBtntext = translatedvalue;
            });
            

        }

        resumeAccountAOVm.goBacktoPrevious = function () {
            $state.go('menu.homePageAO');
        }

        $scope.goToHome = function () {
           accountOpeningHomeService.homeNav();
        }

        resumeAccountAOVm.resumeJourneyCall = function () {
            if (ConnectivityMonitorUtils.isOffline()) {
                utilityService.showErrorMessage("Unable to connect to Internet. Please check your connectivity.");
                return true;
            }
            resumeAccountAOVm.loginWithResume();
        };

        resumeAccountAOVm.forgotPassword = function () {
            $state.go("menu.passwordRecovery");
        }

        resumeAccountAOVm.getPageDetails = function (proFlag) {
            var requestParams = resumeAccountAOVm.resumeMobile;
            resumeJourneyServiceAO.getPageDetails(resumeAccountAOVm.resumeMobile).then(function (response) {
                var splitUrls = [];
                var splittedUrl1, splittedUrl2;
                if (response.payLoad.commonId == "FATCA") {
                    if (accountOpeningHomeService.fatcaFlag == false) {
                        $state.go("menu.locateBranch");
                    }
                    else {
                        $state.go(response.payLoad.mobileURL);
                    }
                }
                else if (response.payLoad.commonId == "AadharManual") {
                    splitUrls = response.payLoad.mobileURL.split("/");
                    splittedUrl1 = splitUrls[0];
                    splittedUrl2 = splitUrls[1];
                    if (accountOpeningHomeService.isCustManualCorresChkBox == true || accountOpeningHomeService.isresumeCustManualCorresChkBox == true) {
                        $state.go(splittedUrl1);
                    } else {
                        $state.go(splittedUrl2);
                    }

                } else if (response.payLoad.commonId == "AadharScanned") {
                    splitUrls = response.payLoad.mobileURL.split("/");
                    splittedUrl1 = splitUrls[0];
                    splittedUrl2 = splitUrls[1];
                    if (accountOpeningHomeService.correspondenceCheckStatus == true) {
                        $state.go(splittedUrl1);
                    } else {
                        $state.go(splittedUrl2);
                    }

                } else if (response.payLoad.commonId == "NomineeDetails") {
                    splitUrls = response.payLoad.mobileURL.split("/");
                    splittedUrl1 = splitUrls[0];
                    splittedUrl2 = splitUrls[1];
                    if (parseInt(accountOpeningHomeService.nomineeAadhaarCardDetails.age) < 18 || parseInt(accountOpeningHomeService.nominee.age) < 18) {
                        if (nomineeDetailsAOService.guardian.guardianAddressFlag == "nomineeAddress") {
                            $state.go("menu.nomineeEnteredAddress");
                        }
                        else if (nomineeDetailsAOService.guardian.guardianAddressFlag == "applicantAddress") {
                            $state.go("menu.nomineeAddress");
                        }
                        else if (nomineeDetailsAOService.guardian.guardianAddressFlag == "newAddress") {
                            $state.go("menu.nomineeCAddress");
                        }
                        else {
                            $state.go(splittedUrl1);
                        }
                    } else {
                        $state.go(splittedUrl2);
                    }
                }
                else if (response.payLoad.commonId == "PAN") {
                    if (accountOpeningHomeService.cifNumber == '0000') {
                        $state.go(response.payLoad.mobileURL);
                    }
                    else if (accountOpeningHomeService.cifNumber == "0001") {
                        //$state.go("");
                    } else if (accountOpeningHomeService.cifNumber == '1000') {
                       // $state.go('');
                    }
                    else {
                      //  $state.go("");
                    }

                } else {
                    $state.go(response.payLoad.mobileURL);
                }

                resumeAccountAOVm.getCommonId(response.payLoad.commonId, proFlag);

            }, function (error) {
                var title = '';
                var template = error.responseMessage;
                var onTap = '';
                var buttontext = '<b>' + resumeAccountAOVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            });
        }

        resumeAccountAOVm.getCommonId = function (commonId, proFlag) {

            accountOpeningHomeService.getCommonId(commonId, proFlag);
        }

        resumeAccountAOVm.goToNextPage = function () {
            var hashedAppPassword = cryptoService.getSHA512EncryptedData(resumeAccountAOVm.resumePassword);
            resumeAccountAOVm.encoded = hashedAppPassword.toString();
			userLoginDetailsService.mobile = resumeAccountAOVm.mobile;
			userLoginDetailsService.pannumber =  resumeAccountAOVm.pannumber;
            var requestParams = {
                "id": resumeAccountAOVm.mobile,
                "pan": resumeAccountAOVm.pannumber
            }

            resumeJourneyServiceAO.getCustomerDetails(requestParams).then(function (response) {
                $state.go('menu.resumeAccountEnterOTPAO');
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
        //Challenge Handler
        resumeAccountAOVm.loginWithResume = function () {
            utilityService.showSpinner();
            resumeAccountAOVm.aoAuthChallengeHandler.handleChallenge = function (challenge) {
                resumeAccountAOVm.isChallenged = true;
                utilityService.hideSpinner();
                if (challenge.errorMsg !== null) {
                    utilityService.showErrorMessage(utilityService.getServerExceptionMessage(challenge));
                } else {
                    utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
                }
            };

            resumeAccountAOVm.aoAuthChallengeHandler.handleSuccess = function (data) {
                resumeAccountAOVm.isChallenged = false;
                utilityService.hideSpinner();
                if (data.user) {
                    loggedInUserService.keyId = AdapterUtils.secretData == "" ? data.user.attributes.keyId : encryptionService.getAES256DecryptedData(data.user.attributes.keyId);
                    loggedInUserService.tokenLotus = AdapterUtils.secretData == "" ? data.user.attributes.lotusToken : encryptionService.getAES256DecryptedData(data.user.attributes.lotusToken);
                }
            };

            resumeAccountAOVm.aoAuthChallengeHandler.handleFailure = function (error) {
                resumeAccountAOVm.aoAuthChallengeHandler.cancel();
                resumeAccountAOVm.isChallenged = false;
                utilityService.hideSpinner();
                if (error.failure) {
                    utilityService.showErrorMessage(error.failure);
                } else {
                    utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
                }
            }

            var newKey = loggedInUserService.keyId;
            var passKey1Hashed = cryptoService.getSHA512EncryptedData(resumeAccountAOVm.resumePassword);
            var passKeyHashed = cryptoService.getSHA512EncryptedData(passKey1Hashed + newKey);
            resumeAccountAOVm.passKey = passKeyHashed.toString();

            var payload = {};
            var requestParams = {
                "mobileKey": resumeAccountAOVm.resumeMobile,
                "passKey": resumeAccountAOVm.passKey,
                "mfDeviceId": loggedInUserService.deviceIdForMpin,
                "deviceId": device.uuid,
				"reqTimeStamp" : (new Date()).toString()
            }

            var passphraseSession;
            if (sessionStorage) {
                passphraseSession = sessionStorage.getItem('passphrase');
            }
            var passphrase = passphraseSession ? passphraseSession : encryptionService.passphrase;
            var src = cryptoService.encryptRSAWithPublicKey(encryptionService.iv + "^" + passphrase + "^" + encryptionService.salt, cryptoService.rsaPublicKey);
            payload = {
                "data": AdapterUtils.secretData + encryptionService.getAES256EncryptedData(JSON.stringify(requestParams)),
                "src": src
            }

            payload = AdapterUtils.secretData == "" ? requestParams : payload;

            if (resumeAccountAOVm.isChallenged) {
                resumeAccountAOVm.aoAuthChallengeHandler.submitChallengeAnswer(payload);
            } else {
                WLAuthorizationManager.login(resumeAccountAOVm.aoAuthChallengeHandler.securityCheckName, payload).then(
                    function (data) {
                        utilityService.accessRestricted = utilityService.AOAuthRequired;
                        utilityService.hideSpinner();
                        resumeAccountAOVm.getCustomerDetails();
                    },
                    function (error) {
                        utilityService.accessRestricted = "";
                        utilityService.hideSpinner();
                        if (error.errorCode == 'CHALLENGE_HANDLING_CANCELED' || error.errorCode == 'APPLICATION_DISABLED') {
                            return;
                        }
                        if (error.errorCode == "LOGIN_ALREADY_IN_PROCESS") {
                            resumeAccountAOVm.aoAuthChallengeHandler.cancel();
                        }
                        utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
                    });
            }
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
        	 resumeAccountAOVm.mobile = userLoginDetailsService.mobile;
              resumeAccountAOVm.pannumber = userLoginDetailsService.pannumber;  
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        $scope.$on('$ionicView.beforeLeave', function () {
             
        });

        return this;
    }
]);
