'use strict';

angularApp.controller('taxDetailsAOController', ["$state",
    "$scope",
    "taxServiceAO",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "userLoginDetailsService",
    "accountOpeningHomeService",
    "enterOTPAOService",
    "$cordovaDevice",
    function($state,
        $scope,
        taxServiceAO,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        userLoginDetailsService,
        accountOpeningHomeService,
        enterOTPAOService,
        $cordovaDevice) {

        var taxDetailsAOVm = this;

        function initPage() {
            taxDetailsAOVm.showBack = true;
            taxDetailsAOVm.aofooter = true;
            taxDetailsAOVm.showNext = true;
        }

        //Go to Personal details page if user has clicked "No"
        taxDetailsAOVm.goToNextPage = function(value){
        	var deviceOs = $cordovaDevice.getPlatform();
            var deviceUid = $cordovaDevice.getUUID();
            if(!enterOTPAOService.taxPage){
                enterOTPAOService.taxPage = {};
            }
            enterOTPAOService.taxPage.fatcaFlag = taxDetailsAOVm.isFatcaEnabled;
            enterOTPAOService.taxPage.pan = taxDetailsAOVm.pannumber;
            enterOTPAOService.taxPage.panAuthorizeFlag = taxDetailsAOVm.isPanAuthorized;
            enterOTPAOService.taxPage.panLinkingAwarenessFlag = taxDetailsAOVm.isAwareOfPanLinking;

            var requestParams = {
                "id": userLoginDetailsService.mobile,
                "data": {
                    "journeyType": taxDetailsAOVm.journeyType,
                    "fatcaFlag": taxDetailsAOVm.isFatcaEnabled,
                    "commonId":$state.$current.data.commonId,
                    "personalDetails" :{
                    	"pan" : taxDetailsAOVm.pannumber
                    },
                     "deviceInfo": {
                        "deviceIMEI" : deviceUid,
                        "deviceOS" : deviceOs
                    },
                    "panAuthorizeFlag": taxDetailsAOVm.isPanAuthorized,
                    "panLinkingAwarenessFlag": taxDetailsAOVm.isAwareOfPanLinking
                }
            }
            taxServiceAO.setFactaFlag(requestParams).then(function(response) {


                taxServiceAO.getFatcaDetails().then(function(data) {
                    taxServiceAO.fatcaDetails = data;
                    $state.go('menu.taxFatcaDetailsAO');
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });


            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });  
        }
        
        
        taxDetailsAOVm.goBacktoPrevious = function(value){
        	$state.go('menu.userLoginDetailsAO');
        }

        taxDetailsAOVm.getFatcaDeclarationDetail = function(){
            taxServiceAO.getFatcaDeclaration().then(function(data) {
                taxDetailsAOVm.fatcaQuestion = data;
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.goToHome = function() {
            accountOpeningHomeService.homeNav();
        }

        //Show Info page on click of "i" icon
        taxDetailsAOVm.showTaxInfo = function() {
            //$state.go('');
        }

        taxDetailsAOVm.populateResumeData = function(){
        	if(enterOTPAOService.isResumeJourney == true || enterOTPAOService.taxPage.fatcaFlag){
        		taxDetailsAOVm.isFatcaEnabled = JSON.parse(enterOTPAOService.taxPage.fatcaFlag);// : utilityService.getValue(response.data.fatcaFlag),
				taxDetailsAOVm.pannumber = enterOTPAOService.taxPage.pan; //: utilityService.getValue(response.data.personalDetails.pan),
                taxDetailsAOVm.isPanAuthorized = JSON.parse(enterOTPAOService.taxPage.panAuthorizeFlag); //: utilityService.getValue(response.data.panAuthorizeFlag)
                taxDetailsAOVm.isAwareOfPanLinking = JSON.parse(enterOTPAOService.taxPage.panLinkingAwarenessFlag);
                taxDetailsAOVm.journeyType = JSON.parse(enterOTPAOService.taxPage.journeyType);
			};
        }


        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
            
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            if(!enterOTPAOService.taxPage){
            	enterOTPAOService.taxPage = {};
            }
            taxDetailsAOVm.journeyType = accountOpeningHomeService.journeyType;
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn); 
            taxDetailsAOVm.getFatcaDeclarationDetail();
            taxDetailsAOVm.populateResumeData();
        });

        return this;
    }
]);
