'use strict';

angularApp.controller('taxFatcaDetailAOController', ["$state",
    "$scope",
    "taxServiceAO",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "userLoginDetailsService",
    "accountOpeningHomeService",
    "enterOTPAOService",
    "constantConfig",
    function($state,
        $scope,
        taxServiceAO,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        userLoginDetailsService,
        accountOpeningHomeService,
        enterOTPAOService,
        constantConfig) {

        var taxFatcaDetailsAOVm = this;

        function initPage() {
            taxFatcaDetailsAOVm.showBack = true;
            taxFatcaDetailsAOVm.aofooter = true;
            taxFatcaDetailsAOVm.showNext = true;
        }

        //Go to Personal details page if user has clicked "No"
        taxFatcaDetailsAOVm.goToNextPage = function(value){
            //$state.go('menu.POIDetailsAO');
            if(taxFatcaDetailsAOVm.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar){
                $state.go('menu.aadhaarOption');
            }else{
                $state.go('menu.POIDetailsAO');
            }
        }
        
        
        taxFatcaDetailsAOVm.goBacktoPrevious = function(value){
            $state.go('menu.taxDetailsAO');
        }

        $scope.goToHome = function() {
            accountOpeningHomeService.homeNav();
        }

        //Show Info page on click of "i" icon
        taxFatcaDetailsAOVm.showTaxInfo = function() {
            //$state.go('menu.foreign');
        }

        taxFatcaDetailsAOVm.populateResumeData = function(){
            taxFatcaDetailsAOVm.journeyType = enterOTPAOService.taxPage.journeyType;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
            
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn); 
            taxFatcaDetailsAOVm.fatcaDetails = taxServiceAO.fatcaDetails;
            if (enterOTPAOService.isResumeJourney == true){
                taxFatcaDetailsAOVm.populateResumeData();
            }else{
                taxFatcaDetailsAOVm.journeyType = accountOpeningHomeService.journeyType;
            }
               
            if(!taxServiceAO.fatcaDetails ){
            	utilityService.showSpinner();
            	  taxServiceAO.getFatcaDetails().then(function(data) {
	                	taxFatcaDetailsAOVm.fatcaDetails = data; 
	                	taxServiceAO.fatcaDetails = data;
	                    utilityService.hideSpinner();
	                }, function(error) {
	                	utilityService.hideSpinner();
	                    utilityService.showErrorMessage(error.responseMessage);
	                });
            }            
        });

        return this;
    }
]);
