'use strict';

angularApp.controller('termsAndConditionsAOController', ["$state",
    "$scope",
    "$translate",
    "$ionicScrollDelegate",
    "utilityService",
    "termsAndConditionsAOService",
    "accountOpeningHomeService",
    "$timeout",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "userLoginDetailsService",
    "enterOTPAOService",
    "chequeBookServiceDetailsService",
    function($state,
        $scope,
        $translate,
        $ionicScrollDelegate,
        utilityService,
        termsAndConditionsAOService,
        accountOpeningHomeService,
        $timeout,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService,
        userLoginDetailsService,
        enterOTPAOService,
        chequeBookServiceDetailsService) {

        var termsAndConditionsAOVm = this;

        function initPage() {
            termsAndConditionsAOVm.showBack = true;
            termsAndConditionsAOVm.showNext = true;
            termsAndConditionsAOVm.disableNext = true;
            termsAndConditionsAOVm.aofooter = true;
            termsAndConditionsAOVm.ConditionsJson = [];
            termsAndConditionsAOVm.conditionsList();
            var title = 'Terms & Conditions';
            var template = '{{"TERMS_CONDITIONS_POPUP" | translate}}';
            var onTap = 'menu.termsAndConditionsAO';
            var buttontext = 'Read T&C';
            utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            termsAndConditionsAOVm.disableCheckbox = true;
        }

        termsAndConditionsAOVm.goBacktoPrevious = function() {
             $state.go('menu.personalisedKitAO');                   
        }

        termsAndConditionsAOVm.goToNextPage = function() {
            termsAndConditionsAOVm.postTAndCDetails();
        }

        termsAndConditionsAOVm.checkScrollOnLoad = function(){
            var tc = document.getElementById("tcId").offsetHeight;
            var tcContent = document.getElementById("tcContent").offsetHeight;
            if(tcContent <= tc){
                termsAndConditionsAOVm.disableCheckbox = false;
                var childNodes = document.getElementById('TNC_CHK').children[0].children[0].removeAttribute("disabled");
            }
        }

        termsAndConditionsAOVm.checkScroll = function() {
            var currentTop = $ionicScrollDelegate.$getByHandle('scroller').getScrollPosition().top;
            var maxTop = $ionicScrollDelegate.$getByHandle('scroller').getScrollView().__maxScrollTop;
            if (currentTop >= maxTop) {
                termsAndConditionsAOVm.disableCheckbox = false;
                var childNodes = document.getElementById('TNC_CHK').children[0].children[0].removeAttribute("disabled");
            }
        }

        //Service call to get terms and conditions data
        termsAndConditionsAOVm.conditionsList = function() {
            termsAndConditionsAOService.getTermsAndConditions().then(function(data) {
                termsAndConditionsAOVm.ConditionsJson = data;
                $timeout(function() {
                    termsAndConditionsAOVm.checkScrollOnLoad();
                });
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        // Service to send the terms and conditions checkbox flag
        termsAndConditionsAOVm.postTAndCDetails = function() {
             var requestParams = {
                "id" : userLoginDetailsService.mobile,                
                "data":{
                    "commonId":$state.$current.data.commonId,
                    "termsAndConditionsFlag" : termsAndConditionsAOVm.isChecked
                }
            }
            termsAndConditionsAOService.postTAndC(requestParams).then(function(data) {
                if(data.responseCode == constantConfig.successCode){
                    //$state.go('menu.productOfferingAO');
                    $state.go('menu.enterOTPProductOfferingAO'); 
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.goToHome = function() {
            accountOpeningHomeService.homeNav();
        }

        termsAndConditionsAOVm.populateResumeData = function(){
            termsAndConditionsAOVm.isChecked = chequeBookServiceDetailsService.termsAndConditionsFlag;
        }

        termsAndConditionsAOVm.agreeChkBox = function() {
            if (termsAndConditionsAOVm.isChecked) {
                termsAndConditionsAOVm.disableNext = false;
            } else {
                termsAndConditionsAOVm.disableNext = true;
            }
        }

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
            if(enterOTPAOService.isResumeJourney == true){
                termsAndConditionsAOVm.populateResumeData();
            }
            termsAndConditionsAOVm.agreeChkBox();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn); 
        });

        return this;
    }
]);
