'use strict';

angularApp.controller('userLoginDetailsAOController', ["$state",
    "$scope",
    "utilityService",
    "$translate",
    "$ionicSideMenuDelegate",
    "AdapterUtils",
    "constantConfig",
    "userLoginDetailsService",
    "$ionicPopover",
    "accountOpeningHomeService",
    "$ionicPopup",
    function ($state,
        $scope,
        utilityService,
        $translate,
        $ionicSideMenuDelegate,
        AdapterUtils,
        constantConfig,
        userLoginDetailsService,
        $ionicPopover,
        accountOpeningHomeService,
        $ionicPopup) {

        var userLoginDetailsAOVm = this;

      
        function initPage() {
           userLoginDetailsAOVm.showNext = true;
           userLoginDetailsAOVm.showBack = true;
           userLoginDetailsAOVm.disableNext = true;
           userLoginDetailsService.getFeatureComparison().then(function(response) {
            userLoginDetailsAOVm.policyWording = response.policyWording;
           });
           
        }

        userLoginDetailsAOVm.goBacktoPrevious = function () {
            
            $state.go('menu.productInformationPageAO');  
        }
		 userLoginDetailsAOVm.goToNextPage = function () {
		 	userLoginDetailsService.mobile = userLoginDetailsAOVm.mobile;
		 	userLoginDetailsService.emailId = userLoginDetailsAOVm.emailId;
             userLoginDetailsService.reffCode = userLoginDetailsAOVm.reffCode;
            userLoginDetailsAOVm.checkIfDetailsExists();
        }

        $scope.goToHome = function () {
            accountOpeningHomeService.homeNav();
        }

      


         /* Info Popup */
         var template = '<ion-popover-view class="tooltiptext ao-long-popupInfo roboto-regular">' + '<ion-content>' +
         '<div class="" ng-bind="userLoginDetailsAOVm.getInfoMsg"></div>' + '</ion-content>' + '</ion-popover-view>';

     $scope.popover = $ionicPopover.fromTemplate(template, {
         scope: $scope
     });

        userLoginDetailsAOVm.infoPopup = function($event) {
            userLoginDetailsAOVm.getInfoMsg = "Separate OTP would be sent on E-mail and Mobile Number.";
            $scope.popover.show($event); 
                
       };
       
       userLoginDetailsAOVm.infoPopupReferral = function($event) {
        userLoginDetailsAOVm.getInfoMsg = "Please enter Mobile Number of the person who recommended YONO here.";
        $scope.popover.show($event); 
            
   };
        
         userLoginDetailsAOVm.checkIfDetailsExists = function(mobileNumber) {
            var requestParams = {
                "id": userLoginDetailsAOVm.mobile
            }
            
            userLoginDetailsService.getCustomerDetails(requestParams).then(function(response) {
                //var customerDetails = response.data;
                if(response.data != null && response.data.isPresent == false ){
                    /*
                    if(mPinLoginService.isLoggedIn == true){
                                            mobNoExists = response.responseCode;
                                            var title = '';
                                            var template = 'Mobile number is already registered. Kindly resume';
                                            var onTap = 'menu.resumeJourney';
                                            var buttontext = '<b>' + 'OK' + '</b>';
                                            utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext); 
                                        }
                                        else{
                                            mobNoExists = response.responseCode;
                                            var title = '';
                                            var template = 'Mobile number is already registered. Kindly resume';
                                            var onTap = 'menu.resumeJourney';
                                            var buttontext = '<b>' + 'OK' + '</b>';
                                            utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext); 
                                        }*/
                    //alert('succ');
                    if(userLoginDetailsAOVm.emailId){
		                	$state.go('menu.enterEmailOTPPageAO');
		                }else{

                            var infoPopup = $ionicPopup.show({
                                template: '<p translate="EMAIL_NOT_AVAILABLE" ></p>',
                                title:'Alert',
                                cssClass: 'dialog activated-blue',		
                                scope: $scope,
                                buttons: [ {
                                    text: 'Ok',
                                    onTap: function(e) {
                                        $state.go('menu.enterOTPPageAO');
                                    }
                                }]
                            });

		                }
                    
                }
                else{

            /*resume journey code*/

                    // mobNoExists = error.responseCode;
                    // if(!utilityService.isUndefined(error.data)){
                    //     if(error.data.type.toLowerCase() == 'ao_insta'){
                    //         var title = '';
                    //         var template = '{{"NOT_J23_ACC" | translate}}';
                    //         var onTap = 'menu.instaKit_resumeJourney';
                    //         var buttontext = '<b>' + 'OK' + '</b>';
                    //         utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                    //     }
                    // }
                    
                    // else{
                    //     userLoginDetailsAOVm.invokeGetOTPService(mobileNumber);
                    // }
                    $state.go('menu.resumeAccountPageAO');	
                }
               
            }, function(error) {
                console.log(error);
                utilityService.showErrorMessage(error.responseMessage);
                /*
                mobNoExists = error.responseCode;
                                if(!utilityService.isUndefined(error.data)){
                                    if(error.data.type.toLowerCase() == 'ao_insta'){
                                        var title = '';
                                        var template = '{{"NOT_J23_ACC" | translate}}';
                                        var onTap = 'menu.instaKit_resumeJourney';
                                        var buttontext = '<b>' + 'OK' + '</b>';
                                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                                    }
                                }
                                
                                else{
                                    userLoginDetailsAOVm.invokeGetOTPService(mobileNumber);
                                }*/
                
            });
        }
       
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
           // $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            userLoginDetailsAOVm.mobile = userLoginDetailsService.mobile;
		 	userLoginDetailsAOVm.emailId = userLoginDetailsService.emailId;
             userLoginDetailsAOVm.reffCode = userLoginDetailsService.reffCode;
             userLoginDetailsAOVm.userDetailsForm.$setPristine();
        });

        $scope.$on('$ionicView.beforeLeave', function () {
            
        });

        return this;
    }
]);
