'use strict';

angularApp.controller('availableAggregatorsController', ["$state",
    "$rootScope",
    "utilityService",
    "constantConfig",
    "$ionicPlatform",
    "$scope",
    "$interval",
    "$filter",
    "$timeout",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicPopup",
    "accountOverviewService",
    "AdapterUtils",
    "loggedInUserService",

    function ($state,
        $rootScope,
        utilityService,
        constantConfig,
        $ionicPlatform,
        $scope,
        $interval,
        $filter,
        $timeout,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicPopup,
        accountOverviewService,
        AdapterUtils,
        loggedInUserService) {

        var availableAggregatorsVm = this;

        availableAggregatorsVm.toggleGroup = function (group) {
            if (availableAggregatorsVm.isGroupShown(group)) {
                availableAggregatorsVm.shownGroup = null;
                availableAggregatorsVm.isGroupShown(group)
            } else {
                availableAggregatorsVm.shownGroup = group;
                availableAggregatorsVm.isGroupShown(group)
            }
        };

        availableAggregatorsVm.isGroupShown = function (group) {
            return availableAggregatorsVm.shownGroup === group;
        };

        availableAggregatorsVm.goBack = function(){
            $state.go('menu.manageAggregators');
        }

        availableAggregatorsVm.urlRedirection = function(url){
            AdapterUtils.sessionLogout().then(
				function (response) {
					console.log("Logout success !!");
					loggedInUserService.logoutUser(true);
                    cordova.ThemeableBrowser.open(url, '_system', {
		            });
                    //window.location.href = url;
				},
				function (error) {
					console.log("Logout failure !!!");
					loggedInUserService.logoutUser(true);
                    cordova.ThemeableBrowser.open(url, '_system', {
		            });
                    //window.location.href = url;
				}
			);
            // window.location.href = url;
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            availableAggregatorsVm.aggregatorsList = accountOverviewService.aggregatorList;
            availableAggregatorsVm.toggleGroup(availableAggregatorsVm.aggregatorsList[0].name);
        });

    }
]);
