'use strict';

angularApp.service('accountOverviewService',
	function ($q, utilityService, AdapterUtils) {

		var AOVservice = this;
		AOVservice.customer = {
			ODaccount: '',
			FDaccount: '',
			startDate: '',
			operational: '',
			lienAmount: '',
			accountCategory: '',
			loanAmount: '',
			interest: ''
		};

		AOVservice.getOverDraftDetails = function (data) {
			var q = $q.defer();
			var obj = {
				"odAccountNumber": data
			};
			AdapterUtils.postData("adapters/AccountOverViewAdapter/getOverDraftDetails", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		AOVservice.getConsentList = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/AccountOverViewAdapter/Aggregator/getConsentList", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		AOVservice.getAggregatorList = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/AccountOverViewAdapter/Aggregator/getAggregatorList", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		AOVservice.deLinkAggregator = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/AccountOverViewAdapter/Aggregator/delink", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		AOVservice.verifyAggregatorId = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/AccountOverViewAdapter/Aggregator/verifyAggregatorId", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		AOVservice.getOtherBankData = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/AccountOverViewAdapter/Aggregator/getOtherBankData", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		AOVservice.getAggregatorBanner = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/AccountOverViewAdapter/Aggregator/getBanner", obj, false).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		
		AOVservice.setAggregatorBanner = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/AccountOverViewAdapter/Aggregator/setBanner", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};



		return AOVservice;
	});
