'use strict';
angularApp.controller('autoLoanController', ["$timeout",
    "$state",
    "$scope",
    "autoLoanService",
    "utilityService",
	"getAccountDetailsService",
    "transactionService",
    "openUrlInAppbroswerService",
    "$ionicPopup",
    "instaHomeService",
    "constantConfig",
    "educationLoanService",
    "$filter","patwlService","$ionicPopover","$ionicScrollDelegate","rrService",
    function ($timeout,
        $state,
        $scope,
        autoLoanService,
        utilityService,
		getAccountDetailsService,
        transactionService,
        openUrlInAppbroswerService,
        $ionicPopup,
        instaHomeService,
        constantConfig,
        educationLoanService,
        $filter,patwlService,$ionicPopover,$ionicScrollDelegate,rrService) {

        //functions, variables that can be accessed from the HTML come here
        var autoLoanvm = this;
        autoLoanvm.isTncDownloaded = false;
        autoLoanvm.isAccountMasked = false;
        autoLoanvm.custEligibility = false;
        autoLoanvm.pdfContent = "";
        if (utilityService.isAndroidPlatform()) {
            autoLoanvm.showDownloadBtn = true;
        }
        //private methods section start
		autoLoanvm.autoLoanAccNo=getAccountDetailsService.autoLoanAccNo;
		autoLoanvm.loanLabel=getAccountDetailsService.loanLabel;
		autoLoanvm.branchCode=getAccountDetailsService.branchCode;
        autoLoanvm.autoLoanAccType = getAccountDetailsService.autoLoanAccType;
        autoLoanvm.accountTypeCode = getAccountDetailsService.accountTypeCode;
        autoLoanvm.intCategory = getAccountDetailsService.intCategory;
        autoLoanvm.showFooter  = false;
        if(autoLoanvm.loanLabel == "Education Loan"){
            autoLoanvm.showFooter  = true;
        }

        function initPage() {
            autoLoanvm.patwlDocList = [];
            autoLoanvm.showBack = true;
            autoLoanvm.showNext = true;
            if (autoLoanvm.accountTypeCode && autoLoanvm.intCategory) {
                autoLoanvm.patwlTypeCode = autoLoanvm.accountTypeCode + autoLoanvm.intCategory;
                if (autoLoanvm.patwlTypeCode == "64503054") {
                    autoLoanvm.getDocsForLoanAccountSummary();
                }
            }
        }
        
        autoLoanvm.gotoKnowMore = function(){
            $state.go('menu.rrKnowMore'); 
        }
        autoLoanvm.getDocsForLoanAccountSummary = function() {
            var payload = {};
            payload ={
              "loanAccountNo": autoLoanvm.autoLoanAccNo ? autoLoanvm.autoLoanAccNo : ''
            }
            patwlService.getDocsForLoanAccountSummary(payload).then(function(data) {
                autoLoanvm.patwlDocList = data.docList;         
            }, function(error) {
                console.log(error.responseMessage);
            });
        }

        autoLoanvm.goBack = function() {
            $state.go('menu.accountOverviewMyBalance');
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {            
            initPage();
        });

        autoLoanvm.openPasswordInfo = function ($event) {
            autoLoanvm.leftStyle = "left : " + ($event.clientX - 10) + "px";           
            autoLoanvm.template = '<ion-popover-view class="loginnewarrow hmbr-info pswd-info-popnew passwordInfoPopup" id="runtimeHeight">'+ 
                '<div class="goldloan-arrow-upnew" style="{{autoLoanvm.leftStyle}}"></div>'+'<div class="padBottom3"><span class="inb-lock-roboto-bold font-size-14">Password eg. - 05Mar!8899</span></div>'+
                '<a class="iconsubtext closeinfobutton float-right" id="CALL_ANC" click-stream="click" ng-click="autoLoanvm.closePopover()"><img src="img/Close.png" alt="" class="glPwdClose"></a>'+
                '<div class="popupDivider"></div>'+'<ion-content class="nfs-popover" has-bouncing="false">'+'<div class="row roboto-light font-size-12 padTop15">'+
                '<div class="col col-40"><div class="row"><div><span class="inb-lock-roboto-bold font-size-12 text-underline-gl">05Mar</span><span>ch</span></div><span class="padLeft50">+</span></div><div class="row fss-text-center">Birth date and first 3 letters of birth month with first letter capital</div></div>'+
                '<div class="col col-20"><div class="row"><span class="inb-lock-roboto-bold font-size-12 text-underline-gl padLeft25">!</span><span class="padLeft50">+</span></div><div class="row fss-text-center">Mandatory "!" sign</div></div>'+
                '<div class="col col-40"><div class="row"><span class="padLeft50">9XXXXX</span><span class="inb-lock-roboto-bold font-size-12 text-underline-gl">8899</span></div><div class="row fss-text-center padLeft25">Last 4 digits of the registered mobile number</div></div></div></ion-content></ion-popover-view>';
            $scope.popover = $ionicPopover.fromTemplate(autoLoanvm.template, {
                scope: $scope
            });
            $scope.popover.show($event);
        }

        autoLoanvm.viewPATWLDocument = function(doc,isEmail) {
           var request = {
                "document": {
                "docName": doc ? doc.docName : "",
                "docID": doc ? doc.docID : ""
                },
                "isEmail": isEmail
            }
            patwlService.downloadAndEmailDocument(request).then(function (data) {
                if (utilityService.isAndroidPlatform()) {
                    autoLoanvm.folderpathPATWL = cordova.file.externalDataDirectory;
                }
                
                if (utilityService.isIOSPlatform()) {
                    autoLoanvm.folderpathPATWL = cordova.file.documentsDirectory;
                }

                viewsavedbase64AsPDF(autoLoanvm.folderpathPATWL,doc.docName,data.docList.base64,"application/pdf");

                var finalPath = autoLoanvm.folderpathPATWL + doc.docName;
                cordova.plugins.fileOpener2.open(
                    finalPath,
                    'application/pdf', {
                    error: function (e) {
                        console.log('Error status: ' + e.status + ' - Error message: ' + e.message);
                    },
                    success: function () {
                        console.log('file opened successfully');
                    }
                });
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        function viewsavedbase64AsPDF(folderpath, filename, content, contentType) {
            var contentStr = atob(content);
            var contentLen = contentStr.length;
            if (contentLen >= constantConfig.accOverview.pdfSize) {
                utilityService.showErrorMessage(constantConfig.accOverview.sizeLimitMessage);
                return;
            }
            // Convert the base64 string in a Blob
            var DataBlob = b64toBlobPATWL(content, contentType);
            window.resolveLocalFileSystemURL(folderpath, function (dir) {
                dir.getFile(filename, { create: true }, function (file) {
                    file.createWriter(function (fileWriter) {
                        fileWriter.write(DataBlob);
                    }, function () { });
                });
            });
        }

        function savebase64AsPDFPATWL(filename, content, contentType) {
            autoLoanvm.popupFolderpath = "";
            var DataBlob = b64toBlobPATWL(content, contentType);
            if (utilityService.isAndroidPlatform()) {
                if(device.version==10){
                    const folderpath = cordova.file.externalDataDirectory;
                    autoLoanvm.popupFolderpath = folderpath.replace(cordova.file.externalRootDirectory,"") + filename;
                    window.resolveLocalFileSystemURL(folderpath, function(dir) {
                        dir.getFile(filename, { create: true }, function(file) {
                            file.createWriter(function(fileWriter) {
                                fileWriter.write(DataBlob);
                                 //Show popup 
                                var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="PATWL_DOWNLOAD_RECEIPT" translate-values="{filePath:autoLoanvm.popupFolderpath}"></div>';
                                autoLoanvm.downloadPopup = $ionicPopup.show({
                                    title: '',
                                    template: template,
                                    scope: $scope,
                                    cssClass: 'my-custom-popup',
                                    buttons: [{
                                        text:'OK',
                                        type: 'button-assertive',
                                        onTap: function() {
                                            autoLoanvm.downloadPopup.close();
                                        }
                                    }],
                                });
                            }, function() {});
                        });
                    });
                }else{
                    //for Android below 10 and Android 11 not for 10
                    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem){
                        fileSystem.root.getDirectory("Download", {create: true, exclusive: false},function(dir) {
                            autoLoanvm.popupFolderpath = dir.fullPath + filename;
                            dir.getFile(filename, { create: true }, function(file) {
                                file.createWriter(function(fileWriter) {
                                    fileWriter.write(DataBlob);
                                     //Show popup 
                                    var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="PATWL_DOWNLOAD_RECEIPT" translate-values="{filePath:autoLoanvm.popupFolderpath}"></div>';
                                    autoLoanvm.downloadPopup = $ionicPopup.show({
                                        title: '',
                                        template: template,
                                        scope: $scope,
                                        cssClass: 'my-custom-popup',
                                        buttons: [{
                                            text:'OK',
                                            type: 'button-assertive',
                                            onTap: function() {
                                                autoLoanvm.downloadPopup.close();
                                            }
                                        }],
                                    });
                                }, function() {});
                            });
                        });
                    });
                }                
            }
             if (utilityService.isIOSPlatform()) {
                const folderpath = cordova.file.documentsDirectory;
                const finalPath = folderpath + filename;
                window.resolveLocalFileSystemURL(folderpath, function (dir) {
                    dir.getFile(filename, { create: true }, function (file) {
                        file.createWriter(function (fileWriter) {
                            fileWriter.write(DataBlob);
                        }, function () { });
                    });
                });
                cordova.plugins.fileOpener2.open(
                    finalPath,
                    'application/pdf', {
                        error: function (e) {
                            console.log('Error status: ' + e.status + ' - Error message: ' + e.message);
                        },
                        success: function () {
                            console.log('file opened successfully');
                        }
                    }
                );
            }
        }


        function b64toBlobPATWL(b64Data, contentType, sliceSize) {
            contentType = contentType || '';
            sliceSize = sliceSize || 512;
            var byteCharacters = atob(b64Data);
            var byteArrays = [];
            for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
                var slice = byteCharacters.slice(offset, offset + sliceSize);
                var byteNumbers = [];
                for (var i = 0; i < slice.length; i++) {
                    byteNumbers[i] = slice.charCodeAt(i);
                }
                var byteArray = new Uint8Array(byteNumbers);
                byteArrays.push(byteArray);
            }
            var blob = new Blob(byteArrays, { type: contentType });
            return blob;
        }

        autoLoanvm.downloadAndEmailDocumentPATWL = function(doc,isEmail) {
            var payload = {};               
                payload = {
                  "document": {
                    "docName": doc ? doc.docName : "",
                    "docID": doc ? doc.docID : ""
                  },
                  "isEmail": isEmail
                }        

            patwlService.downloadAndEmailDocument(payload).then(function(data) {
                if (isEmail == "Y") {
                    $ionicPopup.alert({
                        template: "<p style='text-align:center;font-weight:bold;font-size:16px'>Email has been sent successfully</p>"
                    });
                }else{
                    var content = data.docList.base64;
                    var filename = doc.docName;
                    var contentType = "application/pdf";
                    savebase64AsPDFPATWL(filename,content,contentType);
                }
            },function(error){
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        autoLoanvm.closePopover = function(){
            $scope.popover.hide();
            $ionicScrollDelegate.resize();
        }

        //Download TNC for PAPL
        autoLoanvm.downloadTermsAndConditions = function () {

            autoLoanService.getTermsAndCondition().then(function(data){

                var myBase64 = autoLoanvm.pdfContent = data.documentData;
                var contentType = "application/pdf";
                if (utilityService.isAndroidPlatform()) {
                    autoLoanvm.folderpath = cordova.file.externalRootDirectory;
                }
                if (utilityService.isIOSPlatform()) {
                    //autoLoanvm.folderpath = cordova.file.documentsDirectory;
                    if (autoLoanvm.pdfContent !== "") {
                        autoLoanvm.isTncDownloaded = true;
                        autoLoanvm.openPdf();
                    }
                }
                // var folderpath = cordova.file.externalRootDirectory;

                if (utilityService.isAndroidPlatform()) {

                    var filename = "terms_and_condition.pdf";



            autoLoanvm.b64toBlob = function (b64Data, contentType, sliceSize) {
                contentType = contentType || '';
                sliceSize = sliceSize || 512;

                var byteCharacters = atob(b64Data);
                var byteArrays = [];

                for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
                    var slice = byteCharacters.slice(offset, offset + sliceSize);

                    var byteNumbers = new Array(slice.length);
                    for (var i = 0; i < slice.length; i++) {
                        byteNumbers[i] = slice.charCodeAt(i);
                    }

                    var byteArray = new Uint8Array(byteNumbers);

                    byteArrays.push(byteArray);
                }

                var blob = new Blob(byteArrays, { type: contentType });
                return blob;
            }


            autoLoanvm.savebase64AsPDF = function (folderpath, filename, content, contentType) {
                var contentStr = atob(content);
                        var contentLen = contentStr.length;
                        if (contentLen >= constantConfig.accOverview.pdfSize) {
                           
                            utilityService.showErrorMessage(constantConfig.accOverview.sizeLimitMessage);
                            return;
                        }
                // Convert the base64 string in a Blob
                var DataBlob = autoLoanvm.b64toBlob(content, contentType);

                console.log("Starting to write the file :3");

                window.resolveLocalFileSystemURL(folderpath, function (dir) {
                    console.log("Access to the directory granted succesfully");
                    dir.getFile(filename, { create: true }, function (file) {
                        console.log("File created succesfully.");
                        file.createWriter(function (fileWriter) {
                            console.log("Writing content to file");
                            fileWriter.write(DataBlob);
                            autoLoanvm.isTncDownloaded = true;
                            // alert("your TnC is downloaded in : " + autoLoanvm.folderpath);

                            autoLoanvm.myPopup = $ionicPopup.show({
                                template: 'File Downloaded to Internal Storage',
                                title: '',
                                cssClass: 'dialog',
                                scope: $scope,
                                buttons: [{
                                    text: 'OK',
                                    type: 'button-positive'
                                }]
                            });

                        }, function () {
                            alert('Unable to save file in path ' + folderpath);
                        });
                    });
                });
            }

            autoLoanvm.savebase64AsPDF(autoLoanvm.folderpath, filename, myBase64, contentType);

                }

            }, function(error) {
                console.log(error);
                utilityService.showErrorMessage(error.responseMessage);
            });


        }

        autoLoanvm.educationViewSummary = function(){
            if(educationLoanService.getKnowMore()){
                    $state.go('menu.eduSummary');
            }else{
                educationLoanService.knowMore().then(function(data) {
                    educationLoanService.setKnowMore(data);
                    $state.go('menu.eduSummary');
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        }

        autoLoanvm.fileAlreadyDownloaded = function(){
            //alert('already downloaded');
            autoLoanvm.myPopup1 = $ionicPopup.show({
                template: 'Your Terms and Condition is already downloaded',
                title: '',
                cssClass: 'dialog',
                scope: $scope,
                buttons: [{
                    text: 'OK',
                    type: 'button-positive'
                }]
            });
        }


        autoLoanvm.openPdf = function () {
            openUrlInAppbroswerService.openUrl("data:application/pdf;base64," + autoLoanvm.pdfContent + "", "");
        }
        autoLoanvm.redirectToInstaHomeLoan = function () {
            instaHomeService.getFetchData().then(function (data) {
                instaHomeService.initialValueInsta();
                if (data) {
                    instaHomeService.customer.accountno = data.loanAccountNumber;
					instaHomeService.customer.bestofferamount = data.maxLoanAmount;
					instaHomeService.customer.selectedamount = data.maxLoanAmount;
					instaHomeService.customer.interestrate = data.interestRate;
					instaHomeService.customer.loanduration = data.duration;
					instaHomeService.customer.processingfees = data.processingFees;
					instaHomeService.customer.creditToAccount = data.disbursementAccountNumber;
					instaHomeService.customer.mclr = data.mclr;
					instaHomeService.customer.nightMode = data.nightMode;
					instaHomeService.customer.reviewProcessingFee = data.reviewProcessingFee;
					instaHomeService.customer.minLoanAmount = data.minLoanAmount;
                    instaHomeService.customer.steppingAmount = data.steppingAmount;
					instaHomeService.customer.customerName = data.customerName;
                }
                $state.go('menu.instaCreate');
            }, function (error) {
                if(error.responseCode == '0002')
                {
                    var instaAlreadyApplied = $ionicPopup.show({
                    title: null,
                    cssClass: 'my-custom-popup',
                    template: '<div style="text-align:center"><img class="approvedIconPosition" src="img/errorImage.png"></div><div class="button_fund fontSize-subHeading roboto-light font-dark-grey">'+error.responseMessage+'</div>',
                    buttons: [{
                        text: 'OK',
                        type: 'button-assertive'
                    }]
                });
                }
                else{
                    utilityService.showErrorMessage(error.responseMessage);
                }
            });
        }
        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            autoLoanvm.isInstaAvail = instaHomeService.isInstaAvail;
            autoLoanvm.currency = getAccountDetailsService.currency ;
            autoLoanService.getTransactionDetails(autoLoanvm.autoLoanAccNo,autoLoanvm.branchCode).then(function(data) {

                autoLoanvm.productDescription=data.productDescription;
                autoLoanvm.loanAccountNumber=data.loanAccountNumber;
                autoLoanvm.remainingDuration=data.remainingDuration;
                autoLoanvm.outstandingAmount=data.outstandingAmount;
                autoLoanvm.rateOfInterest=data.rateOfInterest;
                autoLoanvm.emi=data.emi;
                autoLoanvm.eyesOffFun(autoLoanvm.loanAccountNumber);
            }, function(error) {
                
            });
			
			 transactionService.getTransactions(autoLoanvm.autoLoanAccNo,"L").then(function(data) {
                autoLoanvm.txnsRows=data.transactions.length;
                if (!utilityService.isUndefined(data.transactions)){
        
                    // if data is not null
                   
                    autoLoanvm.historydata = data.transactions;
                    autoLoanvm.currencyTransaction = data.currency ? data.currency : "";
                }

            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

            autoLoanvm.img = autoLoanService.transactionimg;
            autoLoanvm.imgnew = autoLoanService.downloadimg;
            

            
        });

        autoLoanvm.eyesOnFun = function(accNo){
            autoLoanvm.isAccountMasked = false;
            autoLoanvm.loanAccountNumber = autoLoanvm.oldValue;
        }

        autoLoanvm.eyesOffFun = function(accNo){
            autoLoanvm.isAccountMasked = true;
            autoLoanvm.oldValue = accNo;
            autoLoanvm.loanAccountNumber = utilityService.maskData(accNo, "front", 4);
        }


        //actions to done everytime the view is hidden
        $scope.$on('$ionicView.afterLeave', function() {

            //any cleanup needs to be done here: executes everytime when page is left
            
        });
        return this;
    }
]);
