
angularApp.service('autoLoanService',
	function ($q, utilityService, AdapterUtils) {
		var transactionimg = "img/Transactions.png";
		var downloadimg = "img/TransactionDownload.png";

		var getTransactionDetails = function (loanNumber,branchCode) {
			var q = $q.defer();
			var payload = {
				"loanAccountNumber": loanNumber,
				"branchCode": branchCode
			};
			AdapterUtils.postData("adapters/AccountOverViewAdapter/getLoanAccountShortEnquiry", payload, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					
					q.reject(error);
				}
			);
			return q.promise;
		};
		var getDepositAccountShortEnquiry = function (loanNumber,branchCode) {
			var q = $q.defer();
			var payload = {
				"accountNumber": loanNumber,
				"branchCode": branchCode
			};
			AdapterUtils.postData("adapters/AccountOverViewAdapter/getDepositAccountShortEnquiry", payload, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		var getOtherDepositDetails = function (accNo,branchCode) {
			var q = $q.defer();
			var payload = {
				"accountNumber": accNo,
				"branchCode": branchCode
			};
			AdapterUtils.postData("adapters/AccountOverViewAdapter/getOtherDepositDetails", payload, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		var getRecurringDepositDetails = function (loanNumber,branchCode) {
			var q = $q.defer();
			var payload = {
				"accountNumber": loanNumber,
				"branchCode": branchCode
			};
		
			AdapterUtils.postData("adapters/AccountOverViewAdapter/getRecurringDepositDetails", payload, true).then(
				function (response) {
				
					q.resolve(response.data);
				},
				function (error) {
					
					q.reject(error);
				}
			);
			return q.promise;
		};

		var getTermsAndCondition = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/retrieveDocument", {}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		return {
			getTransactionDetails: getTransactionDetails,
			transactionimg: transactionimg,
			downloadimg: downloadimg,
			getDepositAccountShortEnquiry:getDepositAccountShortEnquiry,
			getRecurringDepositDetails:getRecurringDepositDetails,
			getOtherDepositDetails:getOtherDepositDetails,
			getTermsAndCondition:getTermsAndCondition		
		}
	});