'use strict';

angularApp.controller('closeDepositOTPController', ["$timeout", "$state", "$scope", "$translate", "$ionicPopup",
    "loggedInUserService", "closeDepositOTPService", "validationService", "utilityService", "$stateParams", "$ionicSideMenuDelegate", "mPinLoginService", "$rootScope", "cryptoService", "constantConfig", "myDreamsServices","fixedDepositClosureService","getAccountDetailsService","fixedDepositService","fdODDetailService","customerInfoService","rdService","rdClosureService",
    function ($timeout, $state, $scope, $translate, $ionicPopup, loggedInUserService, closeDepositOTPService, validationService, utilityService, $stateParams, $ionicSideMenuDelegate, mPinLoginService, $rootScope, cryptoService, constantConfig, myDreamsServices, fixedDepositClosureService,getAccountDetailsService,fixedDepositService,fdODDetailService,customerInfoService,rdService,rdClosureService) {
        $scope.resendOtpCounter = 0;
        $scope.invalidOtpCounter = 0;
        var closeDepositOTPVm = this;
        closeDepositOTPVm.isValidOtp = true;
        closeDepositOTPVm.isValidOtpLength = true;
        $scope.isDisabledOTPbtn = false;

        closeDepositOTPVm.loggedInUserDetails = loggedInUserService.getUserProfileDetails();
        //closeDepositOTPVm.loggedInUserMobNo = closeDepositOTPVm.loggedInUserDetails.mobileNumber;
        closeDepositOTPVm.loggedInUserMobNo = customerInfoService.customer.mobile;
        closeDepositOTPVm.generateOTP = function () {
            utilityService.showSpinner();
            var reqParams = {};
            reqParams.otpCode = constantConfig.keysForOTP.closeDream;
            reqParams.ocHash = cryptoService.getSHA512EncryptedData(constantConfig.keysForOTP.closeDream).toString();
            reqParams.mobile = closeDepositOTPVm.loggedInUserMobNo;
            reqParams.email = customerInfoService.customer.emailID;
            reqParams.journeyName = closeDepositOTPVm.depositObject.depositType;

            /*if(utilityService.isAndroidPlatform()) {
                autoOtpReadService.startOtpReading().then(function (result) {
                    closeDepositOTPVm.otp = result;
                }, function (error) {
                }, function (watchStatus) {
                    closeDepositOTPService.generateClosureOTP(reqParams).then(function (data) {
                    }, function (error) {
                        autoOtpReadService.stopOtpReading();
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                });
            } else {*/
                closeDepositOTPService.generateClosureOTP(reqParams).then(function (data) {
                    utilityService.hideSpinner();
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            // }
        }
        closeDepositOTPVm.resetOtpField = function () {
            closeDepositOTPVm.isValidOtp = true;
        };

        closeDepositOTPVm.onOTPBlur = function () {
            closeDepositOTPVm.isValidOtpLength = validationService.isValidOTP(closeDepositOTPVm.otp);
        };
        closeDepositOTPVm.resendOTP = function () {

            $scope.invalidOtpCounter = 0;
            if ($scope.isDisabledOTPbtn) {
                return true;
            }
            utilityService.showSpinner();
            closeDepositOTPVm.otp = null;
            closeDepositOTPVm.isValidOtp = true;
            var reqParams = {};
            reqParams.otpCode = constantConfig.keysForOTP.closeDream;
            reqParams.mobile = closeDepositOTPVm.loggedInUserMobNo;
            reqParams.email = customerInfoService.customer.emailID;
            reqParams.journeyName = closeDepositOTPVm.depositObject.depositType;
            reqParams.ocHash = cryptoService.getSHA512EncryptedData(constantConfig.keysForOTP.closeDream).toString();
            /*if(utilityService.isAndroidPlatform()) {
                autoOtpReadService.startOtpReading().then(function (result) {
                    closeDepositOTPVm.otp = result;
                }, function (error) {
                }, function (watchStatus) {
                    closeDepositOTPService.generateClosureOTP(reqParams).then(function (data) {
                        $scope.resendOtpCounter += 1;
                        if($scope.resendOtpCounter === 2){
                            $scope.isDisabledOTPbtn = true;
                        }
                    }, function (error) {
                        autoOtpReadService.stopOtpReading();
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                });
            } else {*/
                closeDepositOTPService.generateClosureOTP(reqParams).then(function (data) {
                    utilityService.hideSpinner();
                    $scope.resendOtpCounter += 1;
                    if($scope.resendOtpCounter === 2){
                        $scope.isDisabledOTPbtn = true;
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            // }
        };
        closeDepositOTPVm.validateDreamOTP = function () {
            utilityService.showSpinner();
            var reqParams = {};
            reqParams.otp = closeDepositOTPVm.otp;
            reqParams.mobile = closeDepositOTPVm.loggedInUserMobNo;
            reqParams.data = {};
            reqParams.journeyName = closeDepositOTPVm.depositObject.depositType;
            closeDepositOTPService.validateClosureOTP(reqParams).then(function (data) {
                utilityService.showSpinner();
                if (data.status.toLowerCase() === 'success') {
                    var closureParams = closeDepositOTPVm.depositObject.closureParams;
                    /* Close dream after validating OTP */
                    if(closeDepositOTPVm.depositObject.depositType === 'myDreamClosure') {
                        if(closeDepositOTPVm.depositObject.isFunded === 'n') {
                            myDreamsServices.closeUnfundedDream(closureParams).then(function (data) {
                                closeDepositOTPVm.confirmPopup = $ionicPopup.confirm({
                                    title: '',
                                    template: '<p class="font-size-20">You have successfully deleted your \n dream for \'{{closeDepositOTPVm.depositObject.dreamName}}\'</p>',
                                    cssClass: 'dialog',
                                    scope: $scope,
                                    buttons: [
                                        {
                                            text: 'Ok',
                                            onTap: function (e) {
                                                closeDepositOTPVm.confirmPopup.close();
                                                getAccountDetailsService.accountOverviewData = "";
                                                $state.go("menu.accountOverviewMyBalance");
                                            }
                                        }
                                    ]
                                });

                            }, function (error) {
                                utilityService.showErrorMessage(error.responseMessage);
                                $state.go("menu.accountOverviewMyBalance");
                            });
                        }
                        else {
                            myDreamsServices.closeDreams(closureParams).then(function (data) {
                                closeDepositOTPVm.depositObject.closeFundedDreamObj.nightmode =  data.nightMode == "Y" ? true : false;
                                closeDepositOTPVm.depositObject.closeFundedDreamObj.storeRefNumber =  data.storeRefNumber;
                                closeDepositOTPVm.depositObject.closeFundedDreamObj.status =  data.closureDetails.status;
                                $rootScope.closeFundedDreamObj = closeDepositOTPVm.depositObject.closeFundedDreamObj;
                                var nightMode = data.nightMode == "Y" ? true : false;
                                if (nightMode) {
                                    $scope.storeRefNumber = data.storeRefNumber;
                                } else {
                                    $scope.status = data.closureDetails.status;
                                }

                                var confirmPopup = $ionicPopup.confirm({
                                    title: '',
                                    templateUrl: 'pages/accountOverview/myDeposits/myDreams/dreamDetails/confirmClosePopup.html',
                                    cssClass: 'dialog',
                                    scope: $scope,
                                    buttons: [
                                        {
                                            text: 'OK',
                                            onTap: function (e) {
                                                confirmPopup.close();
                                                getAccountDetailsService.accountOverviewData = "";
                                                $state.go("menu.accountOverviewMyBalance");
                                            }
                                        }
                                    ]
                                });
                            },
                            function (error) {
                                utilityService.showErrorMessage(error.responseMessage);
                                $state.go("menu.accountOverviewMyBalance");
                            });
                        }
                    }
                    else if(closeDepositOTPVm.depositObject.depositType === 'fdClosure'){
                        $scope.fdParams = closeDepositOTPVm.depositObject.fdParams;
                        $scope.isMod = closeDepositOTPVm.depositObject.fdParams.isMod;
                        fixedDepositClosureService.sendFDClosure(closureParams).then(function (data) {
                            $scope.storeRefNumber = utilityService.getValue(data.storeRefNumber);
                            if (data) {
                                var title = '';
                                var template = '';
                                var onTap = '';
                                if (!(data.nightMode == "Y" ? true : false)) {
                                    getAccountDetailsService.accountOverviewData = "";
                                    template = '<div class="button_fund_closure fontSize-subHeading roboto-light font-dark-grey" translate="FDCLOSEMESSAGE" translate-values="{FDnumber:fdParams.fdNumber}"></div><div class="button_fund_closure closePopup fontSize-subHeading roboto-light font-dark-grey" translate="CLOSE_FD_POPUP" translate-values="{maturityAmount:fdParams.amountCredited, creditAc:fdParams.selectedAccountNumber}"></div>';
                                    onTap = 'menu.accountOverviewMyBalance';
                                    fixedDepositService.showAlertModal(title, template, onTap, $scope, $state);
                                } else {
                                    getAccountDetailsService.accountOverviewData = "";
                                    template = '<div class="button_fund_closure fontSize-subHeading roboto-light font-dark-grey" translate="NM_CLOSEFD" translate-values="{requestNumberCFD:storeRefNumber}"></div><div class="button_fund_closure closePopup fontSize-subHeading roboto-light font-dark-grey" translate="NM_INFO1"></div><div class="button_fund_closure closePopup fontSize-subHeading roboto-light font-dark-grey" translate="NM_INFO2"></div>';
                                    onTap = 'menu.accountOverviewMyBalance';
                                    fixedDepositService.showAlertModal(title, template, onTap, $scope, $state);
                                }
                            }
                        }, function (error) {
                            utilityService.showErrorMessage(error.responseMessage);
                            $state.go("menu.accountOverviewMyBalance");
                        });
                    }
                    else if(closeDepositOTPVm.depositObject.depositType === 'odAgainstFD') {
                        var overdraftVm = closeDepositOTPVm.depositObject.overdraftVm;
                        fdODDetailService.fetchODDetails(overdraftVm,overdraftVm.overdraft).then(function(data){
                            var title ='';
                            var template='';
                            var onTap='';
                            overdraftVm.isChecked = false;
                            if(!(data.nightMode == "Y" ? true : false)){
                                if(data.response === "Success"){
                                    $scope.refNo = utilityService.getValue(data.refNo);
                                    getAccountDetailsService.accountOverviewData = "";
                                    title =null;
                                    template = '<div class="congratsOD"><img src="img/happyface.svg" width="45" height="45" class="happyFaceOD"></div><div class="congratsOD fontSize-heading roboto-regular font-dark-grey">{{overdraftVm.congratulations}}</div><div class="button_fund_closure fontSize-subHeading roboto-light font-dark-grey" translate="OD_CREATE_REQ"></div><div class="button_fund_closure fontSize-subHeading roboto-light font-dark-grey" translate="OD_PROCESS"></div><div class="button_fund_closure fontSize-subHeading roboto-light font-dark-grey" translate="OD_REFNO" translate-values="{refNumber:refNo}"></div>';
                                    onTap = 'menu.accountOverviewMyBalance';
                                    fixedDepositService.showAlertModal(title,template,onTap,$scope,$state);
                                } else {
                                    overdraftVm.disableconfirm = true;
                                    var errorMessage = "Can not process now, Please try after sometime.";
                                    utilityService.showErrorMessage(errorMessage);
                                }
                            } else {
                                $scope.storeRefNumber = utilityService.getValue(data.storeRefNumber);
                                getAccountDetailsService.accountOverviewData = "";
                                title =null;
                                template = '<div class="congratsOD"><img src="img/happyface.svg" width="45" height="45" class="happyFaceOD"></div><div class="congratsOD fontSize-heading roboto-regular font-dark-grey">{{overdraftVm.congratulations}}</div><div class="button_fund_closure fontSize-subHeading roboto-light font-dark-grey" translate="NM_ODCREQUEST" translate-values="{requestNumberOD:storeRefNumber}"></div><div class="button_fund_closure fontSize-subHeading roboto-light font-dark-grey" translate="NM_INFO1"></div><div class="button_fund_closure fontSize-subHeading roboto-light font-dark-grey" translate="NM_INFO2"></div>';
                                onTap = 'menu.accountOverviewMyBalance';
                                fixedDepositService.showAlertModal(title,template,onTap,$scope,$state);
                            }
                        }, function(error){
                            overdraftVm.isChecked = false;
                            utilityService.showErrorMessage(error.responseMessage);
                            $state.go("menu.accountOverviewMyBalance");
                        });
                    }
                    else if(closeDepositOTPVm.depositObject.depositType === 'rdClosure'){
                        $scope.rdDetailsVm = closeDepositOTPVm.depositObject.rdDetailsVm;
                        var params = closeDepositOTPVm.depositObject.rdParams;
                        rdClosureService.sendRDClosure(params).then(function(response) {
                            $scope.rdDetailsVm.storeRefNumber = response.storeRefNumber;
                            if(response) {
                                var title = '';
                                var template='';
                                var onTap ='';
                                getAccountDetailsService.accountOverviewData="";
                                if (response.nightMode) {
                                    if (response.nightMode == "Y") {
                                        template = '<div class ="congratsOD"><img src="img/check.png" height="45" width="45" class="happyFaceOD"></div><div class="button_fund_closure RFDpopup fontSize-heading roboto-regular font-dark-grey">Your request number '+$scope.rdDetailsVm.storeRefNumber+' for closing Recurring Deposit has been received.</div><div class="FDpopup-margin fontSize-subHeading roboto-light font-dark-grey">You will be notified once the request is processed.</div><div class="FDpopup-styling fontSize-subHeading roboto-light font-dark-grey">You can check the status of the request from the menu under service request.</div>';
                                    } else {
                                        template = '<div class="button_fund_closure fontSize-subHeading roboto-light font-dark-grey" translate="RDCLOSEMESSAGE" translate-values="{FDnumber:rdService.viewRdData.accountNumber}"></div><div class="button_fund_closure closePopup fontSize-subHeading roboto-light font-dark-grey" translate="CLOSE_RD_POPUP" translate-values="{maturityAmount:rdDetailsVm.amountCredit, creditAc:rdDetailsVm.selectedAccountNumber}"></div>';
                                    }
                                } else {
                                    template = '<div class="button_fund_closure fontSize-subHeading roboto-light font-dark-grey" translate="RDCLOSEMESSAGE" translate-values="{FDnumber:rdService.viewRdData.accountNumber}"></div><div class="button_fund_closure closePopup fontSize-subHeading roboto-light font-dark-grey" translate="CLOSE_RD_POPUP" translate-values="{maturityAmount:rdDetailsVm.amountCredit, creditAc:rdDetailsVm.selectedAccountNumber}"></div>';
                                }
                                onTap = 'menu.accountOverviewMyBalance';
                                utilityService.setCsatJournies('rdClose');
                                rdService.showAlertModal(title,template,onTap,$scope,$state);
                            }
                        }, function(error){
                            utilityService.showErrorMessage(error.responseMessage);
                            $state.go("menu.accountOverviewMyBalance");
                        });
                    }
                } else {
                    closeDepositOTPVm.isValidOtp = false;
                }
            }, function (error) {
            	closeDepositOTPVm.shortDisableNext = "";
                $scope.invalidOtpCounter += 1;
                if($scope.invalidOtpCounter === 3){
                    closeDepositOTPVm.popup = $ionicPopup.show({
                        template: 'You have exceeded number of attempts. Please login again.',
                        title: '',
                        cssClass: 'dialog',
                        scope: $scope,
                        buttons: [{
                            text: 'OK',
                            type: 'button-positive',
                            onTap: function () {
                                loggedInUserService.logoutUser();
                            }
                        }]
                    });
                }
                else {
                    utilityService.showErrorMessage(error.responseMessage);
                }
            });
        };

        function initPage() {
            closeDepositOTPVm.depositObject = $stateParams.depositObject;
        }
        closeDepositOTPVm.closeView = function () {
            $state.go('menu.accountOverviewMyBalance');
        }
        $scope.$on('$ionicView.loaded', function () {
            $ionicSideMenuDelegate.canDragContent(false);
            initPage();
        });
        $scope.$on('$ionicView.beforeEnter', function () {
            $ionicSideMenuDelegate.canDragContent(false);
            $scope.isDisabledOTPbtn = false;
            closeDepositOTPVm.generateOTP();
        });
        $scope.$on('$ionicView.afterLeave', function () {
            $ionicSideMenuDelegate.canDragContent(false);
        });
    }]);
