angularApp.service('getAccountDetailsService',
	function ($q, utilityService, AdapterUtils, $state, homeScreenService, secKeyValidationServices,constantConfig) {
		var img = "img/personalloan.svg";
		var img1 = "img/autoloan.svg";
		var img2 = "img/Savingaccount.svg";
		var img3 = "img/Currentaccount.svg";
		var handimg = "img/congratulationsnote.svg";
		var overdraft = "img/OverdraftAccount.svg";
		var accountOverviewData = "";
		var lifeInsurance = "";
		var accessRightsData = "";
		var accType = { accno: '', typeId: '', indexId: '', type: '', amount: '', transactionFlag: '', branchName: '' };
		var tabIndex = { tabIndex: 0 };
		var autoLoanAccNo = '';
		var autoLoanAccType = '';
		var loanLabel = '';
		var branchCode = '';
		var availableBalance = '';
		var transactionTag = '';
		var lienAmount = '';
		var dataDisplay = { savingDisplay: false, currentDisplay: false, overdraftDisplay: false, graphDisplay: false };
		var dreamIDData = '';
		var isProfilePwdSet = false;

		var getAccountDetails = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/HomeAdapter/customerAndAccountInfo", {}, false).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		var getAccountsAccessRights = function (homeBranch) {
			var q = $q.defer();
			var obj = {
				"homeBranch": homeBranch
			};
			homeScreenService.isAccessRightsAvail = true;
			AdapterUtils.postData("adapters/HomeAdapter/getAccountsAccessRights", {}, false).then(
				function (response) {
					homeScreenService.isAccessRightsAvail = false;
					q.resolve(response.data);
				},
				function (error) {
					homeScreenService.isAccessRightsAvail = false;
					q.reject(error);
				}
			);
			return q.promise;
		};

		var generatePDF = function (accountNumber, transactionFlag, accountType, branchName, trxns, searchText) {
			var q = $q.defer();
			var requestSecKey = secKeyValidationServices.generatesRandomNums();
			var obj = {
				"accountNumber": accountNumber,
				"transactionFlag": transactionFlag,
				"accountType": accountType,
				"branchName": branchName,
				"transactionObj": trxns,
				"searchString": searchText,
				"secKey":requestSecKey,
				"isNewBuild":"true"
			};
			AdapterUtils.postData("adapters/AccountOverViewAdapter/genereatePDF", obj, false).then(
				function (response) {
					var finalcalculatedKey = secKeyValidationServices.verifySecKey(parseInt(response.secKey));
					if(requestSecKey === finalcalculatedKey){
						q.resolve(response);
					}else{
						q.reject({responseMessage:constantConfig.secKeyErrors.technicalError});
					}
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};


		var getAvgBalance = function (accountNo, period, unit) {
			var q = $q.defer();
			var obj = {
				"accountNumber": accountNo,
				"period": period,
				"unit": unit
			};
			AdapterUtils.postData("adapters/AccountOverViewAdapter/getAvgBalance", obj, false).then(
				function (response) {
					var grapLable = [];
					var grapAmount = [];
					utilityService.hideSpinner();
					angular.forEach(response.data.values, function (value, key) {
						grapAmount.push(value.amount);
						grapLable.push(value.label);
					});
					var lineGraphData = {
						grapLable: grapLable,
						grapAmount: grapAmount,
						max: response.data.max,
						min: response.data.min,
						stepSize: response.data.stepSize
					}
					q.resolve(lineGraphData);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		}

		var getLineGraph = function (accountNo, period, transactionTag) {
			var q = $q.defer();
			var obj = {
				"accountNumber": accountNo,
				"period": period,
				"transactionTag": transactionTag
			};
			AdapterUtils.postData("adapters/AccountOverViewAdapter/getLineGraph", obj, false).then(
				function (response) {
					var grapLable = [];
					var grapAmount = [];
					utilityService.hideSpinner();
					angular.forEach(response.data.values, function (value, key) {
						grapAmount.push(value.amount);
						grapLable.push(value.label);
					});
					var lineGraphData = {
						grapLable: grapLable,
						grapAmount: grapAmount,
						max: response.data.max,
						min: response.data.min,
						stepSize: response.data.stepSize
					}
					q.resolve(lineGraphData);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		}

		var getMiniStatement = function () {
			var q = $q.defer();
			var obj = {
				"lrApiTypeCode": "ID001"
			};
			AdapterUtils.postData("adapters/RewardsAdapter/getMiniStatement", obj, false).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		var getAccountSummary = function () {
			var q = $q.defer();
			var obj = {
				"lrApiTypeCode": "ID001"
			};
			AdapterUtils.postData("adapters/RewardsAdapter/getAccountSummary", obj, false).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		var getRewardsContent = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/RewardsAdapter/getRewardsContent", {}, false).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		var getDateRangeSummary = function (data) {
			var q = $q.defer();
			var obj = {
				"lrApiTypeCode": "ID001",
				"startDate": data.startDate,
				"endDate": data.endDate
			};
			AdapterUtils.postData("adapters/RewardsAdapter/getDateRangeSummary", obj, false).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		var getPointsSummary = function () {
			var q = $q.defer();
			var obj = {
				"lrApiTypeCode": "ID001"
			};
			AdapterUtils.postData("adapters/RewardsAdapter/getPointsSummary", obj, false).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		var getUpcomingExpirySummary = function () {
			var q = $q.defer();
			var obj = {
				"lrApiTypeCode": "ID001"
			};
			AdapterUtils.postData("adapters/RewardsAdapter/getUpcomingExpirySummary", obj, false).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		var getRewardsInfoContent = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/RewardsAdapter/getRewardsInfoContent", {}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		var getTermsAndConditions = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/RewardsAdapter/getTermsAndConditions", {}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		var generateToken = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/RewardsAdapter/generateToken", {}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		var commonfunForProfilePassCheck = function(obj){
			if(obj.accOverviewData != ""){
				if(obj.accOverviewData.profilePasswordFlag){
					$state.go(obj.nextPage);	
				}else{
					utilityService.prevPage = obj.prevPage;
					utilityService.nextPage = obj.nextPage;
					$state.go(obj.goto);
				}
			}
			else{
				var balanceWaitPopUp = obj.ionicPopup.show({
					title: null,
					cssClass: 'my-custom-popup',
					template: '<div class="button_fund fontSize-subHeading roboto-light font-dark-grey" translate="CHECK_PROF_PWD_FLG_MSG"></div>',
					buttons: [{
						text: 'OK',
						type: 'button-assertive'
					}]
				});
			}
			return;
		};
		
		var displayPrimaryAccountAsDefault = function(fssSupportedAccList,priAcc){
			var objPriAcc = {};
			objPriAcc.index = 0;
			for(var i=0;i<fssSupportedAccList.length;i++){
				if(fssSupportedAccList[i]["benAccntNo"] === priAcc){
					objPriAcc = fssSupportedAccList[i];
					objPriAcc.index = i;
					break;
				}
				else{
					objPriAcc = fssSupportedAccList[0];
					objPriAcc.index = 0;
				}
			}
			
			return objPriAcc;
		}

		var displayPrimaryAccountAsDefaultDreams = function(fssSupportedAccList,priAcc){
			var objPriAcc = {};
			objPriAcc.index = 0;
			for(var i=0;i<fssSupportedAccList.length;i++){
				if(fssSupportedAccList[i].accountNumber === priAcc){
					objPriAcc = fssSupportedAccList[i];
					objPriAcc.index = i;
					break;
				}
				else{
					objPriAcc = fssSupportedAccList[0];
					objPriAcc.index = 0;
				}
			}
			
			return objPriAcc;
		}
		
		var displayPrimaryAccountAsDefaultRD = function(fssSupportedAccList,priAcc){
			var objPriAcc = {};
			objPriAcc.index = 0;
			for(var i=0;i<fssSupportedAccList.length;i++){
				var acc = fssSupportedAccList[i].accountNumber.slice(-4);
				if(priAcc.indexOf(acc) != -1){
					objPriAcc = fssSupportedAccList[i];
					objPriAcc.index = i;
					break;
				}
				else{
					objPriAcc = fssSupportedAccList[0];
					objPriAcc.index = 0;
				}
			}
			
			return objPriAcc;
		}

		return {
			getAccountDetails: getAccountDetails,
			getAvgBalance: getAvgBalance,
			getLineGraph: getLineGraph,
			img: img,
			img1: img1,
			img2: img2,
			img3: img3,
			handimg: handimg,
			overdraft: overdraft,
			accType: accType,
			accountOverviewData: accountOverviewData,
			lifeInsurance:lifeInsurance,
			generatePDF: generatePDF,
			tabIndex: tabIndex,
			dataDisplay: dataDisplay,
			getAccountSummary: getAccountSummary,
			getRewardsContent: getRewardsContent,
			getMiniStatement: getMiniStatement,
			loanLabel: loanLabel,
			branchCode: branchCode,
			availableBalance: availableBalance,
			getAccountsAccessRights: getAccountsAccessRights,
			accessRightsData: accessRightsData,
			lienAmount: lienAmount,
			getDateRangeSummary: getDateRangeSummary,
			getPointsSummary: getPointsSummary,
			getUpcomingExpirySummary: getUpcomingExpirySummary,
			getRewardsInfoContent:getRewardsInfoContent,
			getTermsAndConditions:getTermsAndConditions,
			generateToken:generateToken,
			dreamIDData:dreamIDData,
			commonfunForProfilePassCheck:commonfunForProfilePassCheck,
			isProfilePwdSet:isProfilePwdSet,
			displayPrimaryAccountAsDefault : displayPrimaryAccountAsDefault,
			displayPrimaryAccountAsDefaultDreams : displayPrimaryAccountAsDefaultDreams,
			displayPrimaryAccountAsDefaultRD : displayPrimaryAccountAsDefaultRD
		}
	});
