
/*******KYC Controller ******/

'use strict';

angularApp.controller('KYCController', 
						["$timeout",
						 "$state",
						 "$scope",
						 "$translate",
						 "clickStreamService",
						 "$ionicPopup",
						 "$ionicScrollDelegate","ionicDatePicker","$filter","mutualFundsService","$http","openUrlInAppbroswerService","utilityService","constantConfig","$rootScope","$ionicHistory",
				 
function ($timeout,
		 $state,
		 $scope,
		 $translate,
		 clickStreamService,
		 $ionicPopup,
		 $ionicScrollDelegate,ionicDatePicker,$filter,mutualFundsService,$http,openUrlInAppbroswerService,utilityService,constantConfig,$rootScope,$ionicHistory) {
	
   	var KYCVm = this;
	 /*** Initialize the variables that has to show in  the HTML come here ***/
	function initPage(){
		$scope.currentDate = new Date();
		KYCVm.radioGroup="0";	 
		KYCVm.panActive=0;
		KYCVm.aadhaarActive=0;
		KYCVm.getEkycInfoLists();
		KYCVm.getServerUrl();
		KYCVm.getGenderList(); // get gender list
		KYCVm.folioObj=mutualFundsService.getFolioToInvest();
		if(KYCVm.folioObj.mfKyc.ckycNo){
			KYCVm.ckycNumber = KYCVm.folioObj.mfKyc.ckycNo;
		}
	}
	/**
	* Fetch gender From master
	*@param {Object}
	* type
	**/
	KYCVm.getGenderList=function(){
		var reqParams={};
		reqParams['type']=constantConfig.mfAndsecConst.genderInMF;
		mutualFundsService.getMasterCommon(reqParams).then(function(data){
			KYCVm.genderObj=data;
			$timeout(function(){
				KYCVm.gender=data[0].key;
			},400);
		}, function(error){
			utilityService.showErrorMessage(error.responseMessage);

		});
	}

	KYCVm.getServerUrl=function(){
		mutualFundsService.getServerUrl().then(function(data){
			KYCVm.URL=data;			
			if(KYCVm.cbsPan=='' || KYCVm.cbsPan ==null || KYCVm.cbsPan==undefined){
                 KYCVm.panCard=KYCVm.URL.kycNo;  
      }  
		}, function(error){
			utilityService.showErrorMessage(error.responseMessage);
		});
	}
	KYCVm.getEkycInfoLists=function(){
		mutualFundsService.getEkycInfoLists().then(function(data){
			mutualFundsService.addekycInfoList(data.infoList);
		}, function(error){
			utilityService.showErrorMessage(error.responseMessage);
		});
	}
	KYCVm.showEkycInfo=function(para){
		KYCVm.infoMessage=mutualFundsService.getekycInfoList();
		if(para=='kycCompliantMsg'){
			KYCVm.kycCompliantMsg=KYCVm.infoMessage.kycCompliantMsg;
			KYCVm.showEkycInformationPopup(KYCVm.kycCompliantMsg);			
		} else if(para=='kycCompliantCreateAcMsg'){
			KYCVm.kycCompliantCreateAcMsg=KYCVm.infoMessage.kycCompliantCreateAcMsg;
			KYCVm.showEkycInformationPopup(KYCVm.kycCompliantCreateAcMsg);
		}
		else{
			KYCVm.kycNonCompliantMsg=KYCVm.infoMessage.kycNonCompliantMsg;
			KYCVm.showEkycInformationPopup(KYCVm.kycNonCompliantMsg);
		}
	}
		

	/***Function to openDatePickerDiv***/
	KYCVm.openDatePickerDiv = {
		callback: function (val) {  //Mandatory
		var date = $filter('date')(new Date(val), 'dd MMM yyyy');
			KYCVm.dob=date;
		},
		inputDate: new Date(new Date().setYear(new Date().getFullYear() - 18)),      //Optional
		
		dateFormat: 'dd MMM yyyy',//Optional
		closeOnSelect: false,       //Optional
		templateType: 'popup' , 
		to: (new Date().setYear(new Date().getFullYear() - 18)),
		from:(new Date().setYear(new Date().getFullYear() - 120))
	};
	
	/***Function to openDatePicker***/
	KYCVm.openDatePicker = function(){
	      ionicDatePicker.openDatePicker(KYCVm.openDatePickerDiv);
	};

	KYCVm.KycCompliantNavigation=function(){
		if(KYCVm.ckycNumber && KYCVm.ckycNumber!= ""){
			var reqParams={
							"mfKyc": {
								"ckycNo":KYCVm.ckycNumber
							}
						};
			//reqParams['ckcyNo']=KYCVm.ckycNumber;
			mutualFundsService.checkKYCStatus(reqParams).then(function(data) {
				console.log('success');
			}, function(error){
				console.log('fail');
			});
			$state.go('menu.createInvestmentAccount');	
		}
		else{
			$state.go('menu.createInvestmentAccount');
		}
									
			
		 
		// KYCVm.reqParams={};
		// KYCVm.reqParams['action']=constantConfig.mfAndsecConst.kycCompliantText;
		// mutualFundsService.getTermsAndConditions(KYCVm.reqParams).then(function(data) {
		// 	KYCVm.investmentFormIntro=data.message;
		// 	 $state.go('menu.createInvestmentAccount');
			
		// }, function(error) {
		// 	utilityService.showErrorMessage(error.responseMessage);
		// });
		
	}
	KYCVm.KycNonCompliantNavigation=function(){
		KYCVm.ckycNumber=KYCVm.ckycNumber;
		if(KYCVm.ckycNumber && KYCVm.ckycNumber!= ""){
			var reqParams={
							"mfKyc": {
								"ckycNo":KYCVm.ckycNumber
							}
						};
			mutualFundsService.checkKYCStatus(reqParams).then(function(data) {
				console.log('success');
			}, function(error){
				console.log('error');
			});	
		}
		
			$rootScope.ekycPan=KYCVm.panCard.toUpperCase();
			$state.go('menu.eKYC');
		
	}


	/**
		

	* Fetch get Pancard From server
	* @param {id}
	* type
	*/	
	 KYCVm.cbsPan=mutualFundsService.getUserDetails().panNumber; 
    if(KYCVm.cbsPan=='' || KYCVm.cbsPan ==null || KYCVm.cbsPan==undefined){
         KYCVm.getServerUrl();            
     }else{
        KYCVm.panCard= KYCVm.cbsPan;
     }	
		
	
	
	
	/***Function to check KYC Status***/
	KYCVm.checkStatus=function(formData){
		var pageContent="";
		var pageContentUrl="";
		$rootScope.ekycPan=KYCVm.panCard.toUpperCase();
		KYCVm.sessionId = utilityService.getRandomNumber();
		clickStreamService.clickStreamData=KYCVm.sessionId;				
		//KYCVm.kycData =  KYCVm.panCard.toUpperCase()+'|'+KYCVm.emailId+'|'+KYCVm.mobile+'|sbiApp|'+KYCVm.URL.camsUserId+'|'+KYCVm.URL.camsPwd+'|L||sess_id';
			var reqPara={};
            reqPara['panId']=KYCVm.panCard.toUpperCase();
		mutualFundsService.getEncryptString(reqPara).then(function(data){
			KYCVm.encKycData=JSON.parse(data.encryptedString).data.responseString;
		
			 pageContent = '<html><head></head><body><form id="form_Id" enctype="application/x-www-form-urlencoded" name="cbsulogin" action="'+KYCVm.URL.camsUrl+'" method="POST">' +
			'<input type="hidden" name="url" value="'+KYCVm.URL.mobileUrl+'">' +
			'<input type="hidden" name="ekyctype" value="E">' +		
			'<input type="hidden" name="kyc_data" value="'+KYCVm.encKycData+'">'+
			'</form> <script type="text/javascript">document.getElementById("form_Id").submit();</script></body></html>';	

			pageContentUrl = 'data:text/html;base64,' + btoa(pageContent);
			var ref= cordova.ThemeableBrowser.open(pageContentUrl, '_blank', {
				statusbar:{color: '#ffffffff'},
				toolbar: {
					height: 37,
					color: '#ffffffff',
					image: 'share'
				},closeButton: {
					image: 'back',
					height: 37,
					width: 32,
					align: 'left',
					event: 'closePressed'
				},backButtonCanClose: true
			});
		
			ref.addEventListener('loadstart', function(event) {	
				//navigator.notification.activityStart("","Loading...");
				//utilityService.isShowSpinner=true;
				//utilityService.showSpinner();
				var URL=event.url;
				var n = URL.indexOf("result");
				if(n==-1){
					return;
				}
				if (n) {
					var sessId = '';
					var result=URL.split('?')[1];
					result=result.split("=")[1];
					result=decodeURIComponent(result).toString();
				}
				mutualFundsService.getDecryptString(result).then(function(data){
					try{
					var resultData=JSON.parse(data.plainString);
					resultData=resultData.data.responseString.split("|")[2];
					resultData=resultData.replace('&sess_id','');
					KYCVm.todayDate=$scope.currentDate.setDate($scope.currentDate.getDate());
					KYCVm.ekycType=JSON.parse(data.plainString).data.responseString.split("|")[0];
				 }catch(e){
				 	ref.close();
				 	KYCVm.showInformationPopup("Internal Error.Retry after some time");
				 }
			//	if(KYCVm.sessionId==sessId){
					if(n!=-1){
						//navigator.notification.activityStop();
						//if(KYCVm.ekycType=='Y' || KYCVm.ekycType=='B'){
						if(KYCVm.ekycType=='Y' || resultData=='KS100'){
							KYCVm.reqParams={
								"mfKyc": {
									"panNo": $rootScope.ekycPan,
									"aadharNo": KYCVm.aadhaarCard,
									"gender": KYCVm.gender,
									"dob": KYCVm.dob,
									"ekycStatus":"Submitted",
                                    "aofStatus":"",
                                    "ekycType":KYCVm.ekycType,
                                    "ekycTimeStamp":KYCVm.todayDate,
                                    "ekycMaxInvestmentLimit":""
								}
							};					
							utilityService.showSpinner();
							mutualFundsService.checkKYCStatus(KYCVm.reqParams).then(function(data) {
								if(data.id){
									var reqParams={};
									reqParams['id']='';
									mutualFundsService.getPanCardNumber(reqParams).then(function(data){
										KYCVm.getServerUrl();
										KYCVm.divPayOutMechanism=data.mfKyc.divPayOutMechanism;
										KYCVm.redPayOutMechanism=data.mfKyc.redPayOutMechanism;
									
										KYCVm.applicationStatus=data.mfKyc.aofStatus;
										mutualFundsService.addeKycPanDetails(KYCVm.URL.kycNo);										
											$rootScope.kycCompliant=1;
						            	  	$rootScope.checkStatusPage=0;
						            	  	$rootScope.kycNonCompliant=0;
										    utilityService.hideSpinner(); 
											$state.go('menu.KYC');									
										
									}, function(error){
										 utilityService.hideSpinner();
										utilityService.showErrorMessage(error.responseMessage);
									});								
								}
							}, function(error) {
								 utilityService.hideSpinner();
								utilityService.showErrorMessage(error.responseMessage);
							});				
						//}
					}else if(KYCVm.ekycType=='N' || resultData=='KS101'){
						$rootScope.kycCompliant=0;
	            	  	$rootScope.checkStatusPage=0;
	            	  	$rootScope.kycNonCompliant=1;												
						 $state.go('menu.KYC');							
					}else{						
						 if(resultData=='KS102'){
							KYCVm.showInformationPopup("KYC status is incomplete, please update KYC with your current KRA through Point of Service of any Intermediary");
						}else if(resultData=='EK-999'){
							KYCVm.showInformationPopup("Internal Error.Retry after some time");
						}else{
							KYCVm.showInformationPopup("Internal Error.Retry after some time");
						}
					}
						//navigator.notification.activityStop();
						ref.close();
					}
				},function(error){
					ref.close();
					if(error.responseCode=='0002')
			          utilityService.showErrorMessage(error.responseMessage);
			      else 
			      	utilityService.showErrorMessage(error.responseMessage);
		       })
			});
			ref.addEventListener('loadstop', function(event) {
				//navigator.notification.activityStop();
			});
		},function(error){
			ref.close();			
			utilityService.showErrorMessage(error.responseMessage);
		})
			
	} 
	
	
	/*** Function to go to Mutual Funds Introduction Page  ***/
	KYCVm.getAllPopularFunds=function (){
		//Call service to fetch funds list
		mutualFundsService.getAllMutualFunds().then(function(data) {
			KYCVm.fundList=data.fundList;
		}, function(error) {
			utilityService.showErrorMessage(error.responseMessage);
		}); 
	
	}
	/**
	*Back to Home **/
	
	KYCVm.goBack=function(){
		$state.go('menu.mutualFunds');
	}
	
	/***Function to show information popup***/
	KYCVm.showEkycInformationPopup=function(infoMessage){
		var infoPopup = $ionicPopup.show({
			template: '<p>'+infoMessage+'</p>',
			title:'Information',
			scope: $scope,
			cssClass: 'dialog',		
			buttons: [
            {
               text: 'Ok'
            }
			]
		});

	}
	/***Function to show alert POP UP***/
	KYCVm.showInformationPopup=function(message){
		var infoPopup = $ionicPopup.show({
			template: '<p>'+message+'</p>',
			title:'Alert',
			cssClass: 'dialog',		
			scope: $scope,
			buttons: [ {
				text: 'Ok',
				onTap: function(e) {
					$state.go('menu.accountOverviewMyBalance');
				}
			}]
		});
	}
	
	/*** one time initialization to be done when the controller is loaded***/
	$scope.$on('$ionicView.loaded', function() {
		
	});
	
	/*** actions to done everytime the view is shown***/	
	$scope.$on('$ionicView.beforeEnter', function() {
		initPage();
		
	});
	
	 /***any cleanup needs to be done here: executes everytime when page is left***/
	$scope.$on('$ionicView.afterLeave', function() {
	
	});
	return this;
}]);

