/******* STP Controller ******/

'use strict';

angularApp.controller('STPController', 
						["$timeout",
						 "$state",
						 "$scope",
						 "$rootScope",
						 "$translate",
						 "$location","$ionicPopup",
						 "$ionicScrollDelegate","mutualFundsService","utilityService","ionicDatePicker","$filter","constantConfig","clickStreamService","customerInfoService","$ionicLoading",
				 
function ($timeout,
		 $state,
		 $scope,
		 $rootScope,
		 $translate,
		 $location,$ionicPopup,
		 $ionicScrollDelegate,mutualFundsService,utilityService,ionicDatePicker,$filter,constantConfig,clickStreamService,customerInfoService,$ionicLoading) {
	
	var STPVm = this;
	
	/*** Initialize the variables that has to show in  the HTML come here ***/
	function initPage(){
		
		STPVm.isTermsAndConditionChecked=0;
		STPVm.termsAndConditionsFlag=0;
		STPVm.STPVmPage=1;
		STPVm.STPReviewPage=0;
		STPVm.successPage=0;
		STPVm.SIPDate="0";
		STPVm.targetOption='';
		STPVm.dividendOption=''; //constantConfig.mfAndsecConst.dividendOption;
		//STPVm.stpSelect=constantConfig.mfAndsecConst.amount;
		STPVm.targetFundEligible=true;
		STPVm.minUnitFlag=true;
		STPVm.maxAmountFlag=true;
		STPVm.minAmountFlag=true;
		STPVm.successPage=0;	
		STPVm.folio='';
		var currentDate = new Date();
		STPVm.todayDate= currentDate.setDate(currentDate.getDate());
		STPVm.getFundDetails();	
		STPVm.getAllFundList();
		STPVm.getFrequercy();
		STPVm.getPanCard();	
		var rupeeSymbol = String.fromCharCode(8377);
		$rootScope.clickCount = 0;
		$rootScope.isResendOTP = false;
		$rootScope.isResendDisabled=false;           
		$rootScope.mobileNumber = $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4);
		$rootScope.amountToPay = rupeeSymbol + mutualFundsService.getInvedtedAmount();
		
	}
	/** 
	*Function to get Frequency
	@Params:{}
	**/
	STPVm.getFrequercy=function(){
		mutualFundsService.getFrequercyDetails().then(function(data) {
			STPVm.frequencyObj=data;
			$timeout(function() {
				STPVm.frequency =STPVm.frequencyObj[0].frequencyValue;
				STPVm.selectedFrequency= STPVm.frequency; 
				STPVm.changeFrequency();
			}, 400);
		}, function(error) {
			utilityService.showErrorMessage(error.responseMessage);
		});
	}
	/**
	* Fetch get Pancard From server
	* @param {id}
	* type
	*/
	STPVm.getPanCard=function(){
		var reqParams={};
		reqParams['id']='';
		mutualFundsService.getPanCardNumber(reqParams).then(function(data){
			STPVm.panCard=data.mfKyc.panNo;
			STPVm.divPayOutMechanism=data.mfKyc.divPayOutMechanism;
			STPVm.redPayOutMechanism=data.mfKyc.redPayOutMechanism;
			
		}, function(error){
			utilityService.showErrorMessage(error.responseMessage);

		});
	} 
	STPVm.isSchAvailableForSwitch=function(){
		
		STPVm.targetOption='';
		STPVm.dividendOption='';
		STPVm.targetFundId=STPVm.targetSubFundList[parseInt(STPVm.targetSubFund)].amfiCode;
		STPVm.reqParams={};
		STPVm.reqParams['amfiCode']=STPVm.targetFundId;
		
		
		mutualFundsService.getFundDetails(STPVm.reqParams).then(function(data) {
			STPVm.fundDList=data;
			STPVm.scmSTPAvailable=STPVm.fundDList.scmStpAvailable;
			STPVm.targetStpMinAmtMthly=$filter('INRFLOAT')(STPVm.fundDList.stpMinAmtMthly,2);
			STPVm.targetStpMinAmtQuartly=$filter('INRFLOAT')(STPVm.fundDList.stpMinAmtQuartly,2);
			STPVm.targetNav=$filter('INRFLOAT')(STPVm.fundDList.planList[0].nav,4);
			STPVm.targetPlan= STPVm.fundDList.planList[0].plan;
			STPVm.targetOption = STPVm.fundDList.planList[0].option;
			STPVm.fundOption=STPVm.targetPlan;
			if(STPVm.targetOption.indexOf('D')!=-1){
				STPVm.dividendOption='N';
			}
			STPVm.scmStpDateMthly=STPVm.fundDList.scmStpDateMthly.replace('&',',');
			STPVm.scmStpDateMthly=STPVm.scmStpDateMthly.split(',');  //Monthly start Date
			STPVm.scmStpDateQrtrly=STPVm.fundDList.scmStpDateQrtrly.replace('&',','); 
			STPVm.scmStpDateQrtrly=STPVm.scmStpDateQrtrly.split(',');//quarterly start Date
			
			if(STPVm.scmSTPAvailable.toLowerCase()==constantConfig.mfAndsecConst.yesAvailable && STPVm.fundObj.fundId!=STPVm.fundDList.fundId){
				STPVm.targetFundEligible=true;
			}else{
				STPVm.targetFundEligible=false;
			}
		  
		}, function(error) {
			utilityService.showErrorMessage(error.responseMessage);
		});  
	}
	
	/**
	*Function to go to get fund Deatils
    @params:{fundId:''}
	
	**/
	STPVm.getFundDetails=function(){
		STPVm.fundObj=mutualFundsService.getFundToInvest();
		STPVm.fundId=STPVm.fundObj.amfiCode;
		STPVm.availUnit=STPVm.fundObj.availbleUnits;
		STPVm.totalUnit=STPVm.fundObj.quantity;
		if(STPVm.fundObj.folioNumber){
			STPVm.folio=STPVm.fundObj.folioNumber;
		}
		if(STPVm.fundObj.currentValue){
			STPVm.currentValue=STPVm.fundObj.currentValue;
		}else{
			STPVm.currentValue='';
		}
		STPVm.reqParams={};
		STPVm.reqParams['amfiCode']=STPVm.fundId;
		mutualFundsService.getFundDetails(STPVm.reqParams).then(function(data) {
			STPVm.fundDetailList=data;
			STPVm.schemeCode=data.fundId;
			STPVm.fundType=data.fundType;
			//STPVm.minAmount=$filter('INRFLOAT')(STPVm.fundDetailList.stpMinInvestmentAmount,2); 
			STPVm.sourceStpMinAmtMthly=$filter('INRFLOAT')(STPVm.fundDetailList.stpMinAmtMthly,2);
			STPVm.sourceStpMinAmtQuartly=$filter('INRFLOAT')(STPVm.fundDetailList.stpMinAmtQuartly,2);
			
			STPVm.minRedeemUnit=$filter('INRFLOAT')(STPVm.fundDetailList.stpMinInvestmentAmount,4); //Need to check with team
			STPVm.amcCode=STPVm.fundDetailList.scmAmcCd;
			
			if(STPVm.fundObj.plan){
				STPVm.plan= STPVm.fundObj.plan;
				STPVm.option = STPVm.fundObj.option;
				STPVm.nav  = $filter('INRFLOAT')(STPVm.fundObj.nav,4);
				STPVm.navDate =  $filter('date')(STPVm.fundObj.navDate,'d MMM yyyy' );
			
			}else{
				if(STPVm.fundDetailList.planList[0]){
					STPVm.plan  = STPVm.fundDetailList.planList[0].plan;
					STPVm.option =STPVm.fundDetailList.planList[0].option;
					STPVm.nav  = $filter('INRFLOAT')(STPVm.fundDetailList.planList[0].nav,4);
					STPVm.navDate =$filter('date')(STPVm.fundDetailList.planList[0].navDate,'d MMM yyyy' );
				}else{
					STPVm.plan  ='';
					STPVm.option='';
					STPVm.nav  ='';
					STPVm.navDate = '';
				}
			}
			STPVm.sourceNav=STPVm.nav;
		}, function(error) {
			utilityService.showErrorMessage(error.responseMessage);
		});
	}
	
	/**
	*Function to checkMinAmount 
	**/
	STPVm.checkMinAmount=function(){
		
		if(STPVm.frequency.toLowerCase()==constantConfig.mfAndsecConst.quarterly){
			STPVm.targetMinAmount=parseFloat(STPVm.targetStpMinAmtQuartly.replace(",",''));
			STPVm.sourceMinAmount=parseFloat(STPVm.sourceStpMinAmtQuartly.replace(",",''));
			
		} 
		if(STPVm.frequency.toLowerCase()==constantConfig.mfAndsecConst.monthly){
			STPVm.targetMinAmount=parseFloat(STPVm.targetStpMinAmtMthly.replace(",",''));
			STPVm.sourceMinAmount=parseFloat(STPVm.sourceStpMinAmtMthly.replace(",",''));
		}
		
		if(STPVm.sourceMinAmount>=STPVm.targetMinAmount){
			$scope.minAmount=STPVm.sourceMinAmount;
			$scope.minUnit=STPVm.sourceMinAmount/STPVm.sourceNav;
			$scope.minUnit=$filter('INRFLOAT')($scope.minUnit,4);
		}else{
			$scope.minAmount=STPVm.targetMinAmount;
			$scope.minUnit=STPVm.sourceMinAmount/STPVm.targetNav;
			$scope.minUnit=$filter('INRFLOAT')($scope.minUnit,4);
		}
		
		//if(STPVm.stpSelect==constantConfig.mfAndsecConst.amount){
			$scope.enteredAmount=parseFloat(STPVm.stpAmount) ;
			if($scope.minAmount>$scope.enteredAmount){
				STPVm.minAmountFlag=false;
				STPVm.maxAmountFlag=true;
			}else if(STPVm.currentValue<$scope.enteredAmount){
				STPVm.maxAmountFlag=false;
				STPVm.minAmountFlag=true;
			}else{
				STPVm.minAmountFlag=true;
				STPVm.maxAmountFlag=true;
		 	}
		/*}else{
			$scope.enteredAmount=parseFloat(STPVm.stpUnit) ;
			if($scope.minUnit > $scope.enteredAmount){
				STPVm.minUnitFlag=false;
			}else{
				STPVm.minUnitFlag=true;
			}
		} */
		
	}
	/**
	*Function to Switch Redeem details
	**/

	STPVm.submitSTP = function(){
	    var requestSecKey='';
		var reqParams = {};
		if(!STPVm.isTermsAndConditionChecked){
			return false;
		}
		STPVm.txnId = utilityService.getRandomNumber();
		var requestDate = new Date();
		requestDate = requestDate.getTime()
		requestSecKey=Math.floor((Math.random()) + requestDate);
		requestSecKey = (requestSecKey * 10 + 1);
		clickStreamService.clickStreamData=STPVm.txnId;
		
		reqParams["txnType"] = constantConfig.mfAndsecConst.STP;	
		reqParams["schemeId"] = STPVm.schemeCode; 
		reqParams["schemeName"] = STPVm.fundDetailList.fundName;	
		reqParams["schemePlan"] =  STPVm.plan;
		reqParams["schemeOption"] = STPVm.option;
		reqParams["transactionType"] = "P";  
		reqParams["startDate"] = $filter('date')(new Date(STPVm.startDate), 'dd/MM/yyyy') ;
		reqParams["endDate"] =  $filter('date')(new Date(STPVm.endDate), 'dd/MM/yyyy') ;
		reqParams["amount"] = STPVm.stpAmount ;
		reqParams["units"] = '';
		reqParams["accountNo"] =STPVm.savingAccounts;
		reqParams["frequency"] =STPVm.frequency;
		reqParams["isPerpetual"] = "";
		reqParams["amcCode"] = STPVm.amcCode;
		reqParams["folioNo"] =STPVm.folio;
		reqParams["txnDate"] = "";
		reqParams["txnTime"] = "";
		reqParams["sipRegisteredDate"] = "";
		reqParams["numberOfInstallments"] = STPVm.noOfInstallment;
		reqParams["installmentNumber"] = "";
		reqParams["bankName"] = "";
		reqParams["bankCode"] = "";
		reqParams["bankCity"] = "";
		reqParams["accountType"] = "";
		reqParams["panNo"] = STPVm.panCard; 
		reqParams["customerTermandCondition"] = STPVm.isTermsAndConditionChecked;
		reqParams["branchName"] = "";
		reqParams["targetSchemeId"] =STPVm.targetFundIdInsubmit;
		reqParams["targetSchemeName"] = STPVm.targetfundNameInsubmit;
		reqParams["targetSchemePlan"] = STPVm.targetOption;
		reqParams["targetSchemeOption"] =STPVm.targetPlan;
		reqParams["dividendOption"] =STPVm.dividendOption;
		reqParams["divPayoutMechanism"]=STPVm.divPayOutMechanism;
		reqParams["redPayoutMechanism"]=STPVm.redPayOutMechanism;
		reqParams["txnId"]=STPVm.txnId;
		reqParams["amfiCode"]=STPVm.fundId;
		reqParams["closeAc"]='';
		reqParams["secKey"]=requestSecKey;
        
	        $rootScope.fundName=STPVm.fundDetailList.fundName;
			$rootScope.targetFundName=STPVm.targetfundNameInsubmit;
	        $rootScope.amountToPay=STPVm.stpAmount;
	        $rootScope.unitName=constantConfig.mfAndsecConst.amount;

		mutualFundsService.addInvedtedAmount(STPVm.stpAmount);//for OTP page showing
		mutualFundsService.payDuesRequest(reqParams).then(function(data){
			if(data.submitRequest.isOTPRequired == "true"){	    	 	
				$rootScope.stpotpPage=1;
		        $rootScope.redeemotpPage=0;
				$rootScope.cancelotpPage=0;       	
		        $rootScope.sipotpPage=0;
				$rootScope.lumsumotpPage=0;
				$rootScope.swpotpPage=0;									
				$rootScope.switchotpPage=0;	
	            $state.go('menu.stpOTP');
	        }else{
	         	var calCulatedKey=mutualFundsService.verifySecKey(parseInt(data.submitRequest.secKey));
	            if(requestSecKey==calCulatedKey){
					STPVm.message = data.submitRequest.status;
					STPVm.transactionReferenceNo = data.submitRequest.transactionReferenceNo;					
						STPVm.STPVmPage=0;
						STPVm.successPage=1; 
						STPVm.termsAndConditionsFlag=0;
						STPVm.STPReviewPage=0;      
                        STPVm.stpAmount= $rootScope.amountToPay;                
                        STPVm.transactionDate= data.submitRequest.transactionDate;
						utilityService.setCsatJournies("mutualFunds");					
		     	}
			}
		}, function(error){
			utilityService.showErrorMessage(error.responseMessage);
		});
	}

	$scope.validateOTP=function(){
        var reqParams={};
        var requestSecKey;
	var requestDate = new Date();
	requestDate = requestDate.getTime();
	requestSecKey=Math.floor((Math.random()) + requestDate);
	requestSecKey = (requestSecKey * 10 + 1);
        reqParams.otp= $scope.enterOTP;
        reqParams.secKey=requestSecKey; 
        mutualFundsService.validateOTPForPayment(reqParams).then(function(data){
	        if(data.data.otpStatus == "0000"){
	            var calculatedKey=mutualFundsService.verifySecKey(parseInt(data.data.secKey));
	            if(requestSecKey==calculatedKey){   
	             	$rootScope.stpSuccessPage=1; 
	             	$rootScope.lumsumSuccessPage=0; 
	                $rootScope.cancelSuccessPage=0; 
		         	$rootScope.redeemSuccessPage=0;
					$rootScope.swpSuccessPage=0;
					$rootScope.switchSuccessPage=0;                 	              	
					$rootScope.sipSuccessPage=0;  
					$rootScope.transactionReferenceNo=data.data.transactionReferenceNo;      
					$rootScope.fundName=$rootScope.fundName ; 
					$rootScope.stpAmount= $rootScope.amountToPay;                
					$rootScope.transactionDate= new Date(data.data.transactionDate);               
					utilityService.setCsatJournies("mutualFunds");              
					$state.go('menu.stpPaymentSuccess');
	            }
	        }else if(data.data.otpStatus != "0000"){
	        	 mutualFundsService.clearOTP($rootScope.enterOTP);
	            $scope.errorMessage=data.responseMessage;
	        }else{	           
	            STPVm.showErrorInformationPopup(error.responseMessage);
	        }
        },function(error){
        	//utilityService.showErrorMessage(error.responseMessage);
        	STPVm.showErrorInformationPopup(error.responseMessage);
        })
    }

          $scope.resendOTP=function(){
             $scope.enterOTP="";
            var reqParams ={};
            reqParams.id ="";
            reqParams.emailId ="";
            mutualFundsService.getOTPTokenSecure(reqParams).then(function(data){
                 $rootScope.clickCount++;
                 $scope.mutualFundEnterOTPForm={};
                if($rootScope.clickCount==2){
                    $scope.disableLink=true;
                }
            })          
        }


       //****Submit button on OTP Page***//
         $scope.validateOTPNext=function(){
         	$scope.enterOTP=document.getElementById('txt_otp').value;
           if(validateForm()){         
            $scope.validateOTP();
            }           
         }   
       
       
       function validateForm(){
             $rootScope.mutualFundEnterOTPForm={};
            if(mutualFundsService.isValidOTPNum($scope.enterOTP)){
                 $scope.errorMessage=mutualFundsService.isValidOTPNum($scope.enterOTP);
            }
            return (angular.equals({}, $rootScope.mutualFundEnterOTPForm))?true:false;
        }
	
	
	STPVm.openReviewPage=function(){
		STPVm.targetFundIndex=parseInt(STPVm.targetSubFund);
		STPVm.targetFundIdInsubmit=STPVm.targetSubFundList[STPVm.targetFundIndex].fundId;
		STPVm.targetfundNameInsubmit=STPVm.targetSubFundList[STPVm.targetFundIndex].fundName;
		
		STPVm.isTermsAndConditionChecked=0;
		STPVm.termsAndConditionsFlag=0;
		STPVm.STPVmPage=0;
		STPVm.STPReviewPage=1;
		STPVm.successPage=0;
		
	}
	/***Function to GET fund subdata start***/
	STPVm.changeFundScheme = function(){
		var fundSchemeObj=STPVm.targetFundList[parseInt(STPVm.targetFund)];
		STPVm.targetSubFundList=fundSchemeObj.fundSchemeList;
		$timeout(function() {
			STPVm.targetSubFund ="";
		}, 200);
	}
		
	/***Function to GET Fund Detail start***/
	STPVm.getAllFundList = function(){
		 $ionicLoading.show({
           template: '<ion-spinner icon="android"></ion-spinner>'
         });
		mutualFundsService.getAllMutualFunds().then(function(data) {
			STPVm.targetFundList=data.fundList;
			STPVm.firstFundSchemeName=data.fundList[0];
			STPVm.targetFund="0";
			var fundSchemeObj=STPVm.targetFundList[0];
			STPVm.targetSubFundList=fundSchemeObj.fundSchemeList;
			STPVm.targetSubFund ="";			
			$ionicLoading.hide();
		}, function(error) {
			utilityService.showErrorMessage(error.responseMessage);
			$ionicLoading.hide();
		}); 
	}	
	/***Start term and Condition***/
	STPVm.termsAndConditions=function(){
		if(STPVm.termsAndConditionsFlag==1){
			STPVm.termsAndConditionsFlag=0;
		}else{
			/** Call service to fetch termsConditionsMessage**/
			STPVm.reqParams={};
			STPVm.reqParams['action']=constantConfig.mfAndsecConst.STP;
			mutualFundsService.getTermsAndConditions(STPVm.reqParams).then(function(data) {
				STPVm.termsAndConditionsMessage=data.message;
			
			}, function(error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
			
			
			STPVm.termsAndConditionsFlag=1;
		}			
	}
	
	/**
	* Check Eligible dates
	*/
	STPVm.checkDate=function(){
		STPVm.endDate='';
		var currentDate = new Date();
		$translate('SAME_DATE_SIP_ERROR_MESG').then(function(transValue) {
			STPVm.dateErrorMessage = transValue;
		});
		$timeout(function(){
			STPVm.SIPMonthObj='';
			if(currentDate.getDate()==STPVm.SIPDate){
				STPVm.SuccessPop = $ionicPopup.show({
				template: '<p>'+STPVm.dateErrorMessage+'</p>',
				title: '',
				cssClass: 'dialog',
				scope: $scope,
				buttons: [{
					text: 'Change',
					type: 'button-positive',
					onTap: function(e) {
						STPVm.SuccessPop.close(); //close the popup after 1 seconds 
						e.preventDefault();
					}
				},{
					text: 'OK',
					type: 'button-positive',
					onTap: function(e) {
						STPVm.SuccessPop.close(); //close the popup after 1 seconds 
						e.preventDefault();
					}
				}]
				});
				if(currentDate.getMonth()==11){ //Dec 30 == 30 current date
					STPVm.SIPYear=currentDate.getFullYear()+1;
					STPVm.SIPMonth=STPVm.getMonthName(0);
				}else{
					STPVm.SIPYear=currentDate.getFullYear();
					STPVm.SIPMonth=STPVm.getMonthName(currentDate.getMonth()+1);
				}
				
				
			}else if(STPVm.SIPDate=="0"){
				STPVm.SIPYear='';
				STPVm.SIPMonth='';
			}else if((currentDate.getDate()) < STPVm.SIPDate){
				if(currentDate.getMonth()==1 &&  STPVm.SIPDate.trim()=="30"){ 
					STPVm.SIPMonth=STPVm.getMonthName(currentDate.getMonth()+1);
					STPVm.SIPYear=currentDate.getFullYear();
				}else{
					STPVm.SIPMonth=STPVm.getMonthName(currentDate.getMonth());
				STPVm.SIPYear=currentDate.getFullYear();
				}
				
			}else if((currentDate.getDate())>STPVm.SIPDate){
				if(currentDate.getMonth()==11){ 
					STPVm.SIPYear=currentDate.getFullYear()+1;
					STPVm.SIPMonth=STPVm.getMonthName(0);
				}else{
					STPVm.SIPYear=currentDate.getFullYear();
					STPVm.SIPMonth=STPVm.getMonthName(currentDate.getMonth()+1);
				}
			}
			
		},500);
	}   
	STPVm.getMonthName=function(month){
		var monthArray=["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sept","Oct","Nov","Dec" ];
		return monthArray[month];
	}
	
	
	/**
	*Function to set Installment ,min amount
	**/
	STPVm.changeFrequency = function(){
		STPVm.checkMinAmount();
		if(STPVm.endDate){
			STPVm.startDate=$filter('date')(new Date(STPVm.SIPDate+" "+STPVm.SIPMonth+" "+STPVm.SIPYear), 'dd MMM yyyy'); 
			STPVm.sDate=new Date(STPVm.startDate);

			STPVm.noOfYearDiffernce = (new Date(STPVm.endDate).getFullYear()-STPVm.sDate.getFullYear())*12;
            STPVm.noOfYearDiffernce -= STPVm.sDate.getMonth()+1;
            STPVm.noOfYearDiffernce += new Date(STPVm.endDate).getMonth();
            STPVm.noOfMonths = STPVm.noOfYearDiffernce;
            STPVm.noOfMonths= STPVm.noOfMonths <= 0?0: STPVm.noOfMonths;
            if (STPVm.noOfMonths>=1) {
            	STPVm.noOfMonths= STPVm.noOfMonths+2;
            }else{
            	STPVm.noOfMonths= STPVm.noOfMonths+1;
            }
            if (STPVm.frequency.toLowerCase() == constantConfig.mfAndsecConst.quarterly) {
                STPVm.noOfInstallment = ((STPVm.noOfMonths/3)+1);
                STPVm.noOfInstallment = Math.round(STPVm.noOfInstallment);
                STPVm.minInstallments= parseFloat(constantConfig.mfAndsecConst.minInstallments4);
                if(STPVm.noOfInstallment < STPVm.minInstallments){
					utilityService.showErrorMessage(constantConfig.mfAndsecConst.stp4QtrError);
	    		}
            }
            if (STPVm.frequency.toLowerCase() == constantConfig.mfAndsecConst.monthly) {            	
                STPVm.noOfInstallment = STPVm.noOfMonths;
                // CHANGE THE MONTH BASED ON SELECTED FREQUENCY
                STPVm.minInstallments= parseFloat(constantConfig.mfAndsecConst.minInstallments12);
				if(STPVm.noOfInstallment < STPVm.minInstallments){
					utilityService.showErrorMessage(constantConfig.mfAndsecConst.stp12MonthsError);
				}
            }
		}
		
	}
	
	/*** Unit***/
	STPVm.allUnitsCheck= function(){
		if(STPVm.allUnits == "1"){
			STPVm.minUnitFlag=true;
			STPVm.stpUnit = STPVm.totalUnit;
		}
		else{
			STPVm.stpUnit = '';
		}
	}
	STPVm.getMonthName=function(month){
		var monthArray=["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sept","Oct","Nov","Dec" ];
		return monthArray[month];
	}
	/***Function to openDatePicker***/
	STPVm.endDatePicker = function(){
		var date=STPVm.SIPDate+"-"+STPVm.SIPMonth+"-"+STPVm.SIPYear;
		if(!STPVm.endDate){
			STPVm.endDatePickerDiv.inputDate=new Date(date.replace(/\s/g,''));
			STPVm.endDatePickerDiv.from=new Date(date.replace(/\s/g,''));
		}else{
			STPVm.endDatePickerDiv.inputDate=new Date(STPVm.endDate);
			STPVm.endDatePickerDiv.from=new Date(date.replace(/\s/g,''));
		}
	    ionicDatePicker.openDatePicker(STPVm.endDatePickerDiv);
		
	};
	STPVm.endDatePickerDiv = {
		callback: function (val) {
			var date = $filter('date')(new Date(val), 'dd MMM yyyy');
			var filterDate=date.split(' ');
			
			STPVm.endDate=new Date(STPVm.SIPDate+" "+filterDate[1]+" "+filterDate[2]);//date;;
			STPVm.startDate=$filter('date')(new Date(STPVm.SIPDate+" "+STPVm.SIPMonth+" "+STPVm.SIPYear), 'dd MMM yyyy'); 
			STPVm.sDate=new Date(STPVm.startDate);
			STPVm.noOfYearDiffernce = (new Date(STPVm.endDate).getFullYear() - STPVm.sDate.getFullYear()) * 12;
            STPVm.noOfYearDiffernce -= STPVm.sDate.getMonth() + 1;
            STPVm.noOfYearDiffernce += new Date(STPVm.endDate).getMonth();
            STPVm.noOfMonths = STPVm.noOfYearDiffernce;
            STPVm.noOfMonths= STPVm.noOfMonths <= 0?0: STPVm.noOfMonths;
			if (STPVm.noOfMonths>=1) {
            	STPVm.noOfMonths= STPVm.noOfMonths+2;
            }else{
            	STPVm.noOfMonths= STPVm.noOfMonths+1;
            }
            if (STPVm.frequency.toLowerCase() == constantConfig.mfAndsecConst.quarterly) {
                STPVm.noOfInstallment = ((STPVm.noOfMonths/3)+1);
                STPVm.noOfInstallment = Math.round(STPVm.noOfInstallment);
                STPVm.minInstallments= parseFloat(constantConfig.mfAndsecConst.minInstallments4);
                if(STPVm.noOfInstallment < STPVm.minInstallments){
					utilityService.showErrorMessage(constantConfig.mfAndsecConst.stp4QtrError);
	    		}
            }
            if (STPVm.frequency.toLowerCase() == constantConfig.mfAndsecConst.monthly) {            	
                STPVm.noOfInstallment = STPVm.noOfMonths;
                // CHANGE THE MONTH BASED ON SELECTED FREQUENCY
                STPVm.minInstallments= parseFloat(constantConfig.mfAndsecConst.minInstallments12);
				if(STPVm.noOfInstallment < STPVm.minInstallments){
					utilityService.showErrorMessage(constantConfig.mfAndsecConst.stp12MonthsError);
				}
            }
		},
		dateFormat: 'dd MMM yyyy',
		closeOnSelect: false,       
		templateType: 'popup' 
		
	};
	/***Function to show information POP UP***/
	STPVm.showInformationPopup=function(){
		var infoPopup = $ionicPopup.show({
			template: '<p>Message</p>',
			title:'Information',
			scope: $scope,
			buttons: [ {text: 'Ok'}]
		});

		infoPopup.then(function(res) {
        
		});    
	}
	/***Function to show alert POP UP***/
		STPVm.showErrorInformationPopup=function(message){
			var infoPopup = $ionicPopup.show({
				template: '<p>'+message+'</p>',
				title:'Alert',
				cssClass: 'dialog',		
				scope: $scope,
				buttons: [ {
					text: 'Ok',
					onTap: function(e) {
						$state.go('menu.accountOverviewMyBalance');
					}
				}]
			});
		}
	/***Function to show success page***/
	STPVm.showSuccesPage=function(){
		STPVm.STPVmPage=0;
		STPVm.successPage=1;
	}
	/***BACK to page***/
	STPVm.backToSTP=function(){
		STPVm.STPVmPage=1;
		STPVm.STPReviewPage=0;
		STPVm.successPage=0;
	}
	
	/***Close Page ***/ 
	$scope.closePage =function(){
		$state.go("menu.portfolio");		
	}
	/***Function to go to portfolio page***/
	$scope.portfolio=function(){
		$state.go("menu.portfolio");
	}
	
	$scope.$on('$ionicView.beforeEnter', function() {
		initPage();
		
	});
	
	return this;
}]);

