/******* SWP Controller ******/

'use strict';

angularApp.controller('SWPController', 
						["$timeout",
						 "$state",
						 "$scope",
						 "$rootScope",
						 "$translate",
						 "$location","$ionicPopup",
						 "$ionicScrollDelegate","$stateParams","mutualFundsService","utilityService","ionicDatePicker","$filter","constantConfig","clickStreamService","customerInfoService",
				 
function ($timeout,
		 $state,
		 $scope,
		 $rootScope,
		 $translate,
		 $location,$ionicPopup,
		 $ionicScrollDelegate,$stateParams,mutualFundsService,utilityService,ionicDatePicker,$filter,constantConfig,clickStreamService,customerInfoService) {
	
	
	var SWPControllerVm = this;
	
	/*** Initialize the variables that has to show in  the HTML come here ***/
	function initPage(){
		SWPControllerVm.SIPDate="0";
		SWPControllerVm.dividendOption=''; //constantConfig.mfAndsecConst.dividendOption;
		SWPControllerVm.checkDate();
		SWPControllerVm.transactionType=constantConfig.mfAndsecConst.SWP;
		SWPControllerVm.minAmountFlag=true;
		SWPControllerVm.minUnitFlag=true;
		SWPControllerVm.maxAmountFlag=true;
		SWPControllerVm.SWPVmPage=1;
		SWPControllerVm.successPage=0;
		SWPControllerVm.SWPReviewPage=0;
		SWPControllerVm.folio='';
		SWPControllerVm.isTermsAndConditionChecked=0;
		SWPControllerVm.getFrequercy();		
		SWPControllerVm.getFundDetails();	
	    SWPControllerVm.getPanCard();	
		SWPControllerVm.accountDetails();	

		 var rupeeSymbol = String.fromCharCode(8377);
        $rootScope.clickCount = 0;
        $rootScope.isResendOTP = false;
        $rootScope.isResendDisabled=false;           
        $rootScope.mobileNumber = $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4);
        $rootScope.amountToPay = rupeeSymbol + mutualFundsService.getInvedtedAmount();	
	}
	
	/** 
	*Function to get Frequency
	@Params:{}
	**/
	SWPControllerVm.getFrequercy=function(){
		mutualFundsService.getFrequercyDetails().then(function(data) {
			SWPControllerVm.frequencyObj=data;
			$timeout(function() {
				SWPControllerVm.frequency=SWPControllerVm.frequencyObj[0].frequencyValue;
				SWPControllerVm.selectedFrequency= SWPControllerVm.frequency; 
				SWPControllerVm.changeFrequency();
			}, 400);
			
		}, function(error) {
			utilityService.showErrorMessage(error.responseMessage);
		});
	}
	/**
	*Function to go to get fund Deatils
    @params:{fundId:''}
	
	**/
	SWPControllerVm.getFundDetails=function(){
		
		SWPControllerVm.fundObj=mutualFundsService.getFundToInvest();
		SWPControllerVm.fundId=SWPControllerVm.fundObj.amfiCode;
		SWPControllerVm.availUnit=SWPControllerVm.fundObj.currentValue;
		SWPControllerVm.totalUnit=SWPControllerVm.fundObj.quantity;
		SWPControllerVm.sourceNav=SWPControllerVm.fundObj.nav;  
		if(SWPControllerVm.fundObj.folioNumber){
			SWPControllerVm.folio=SWPControllerVm.fundObj.folioNumber;
			SWPControllerVm.folioAccountNo=SWPControllerVm.fundObj.accountNo;
		}
		if(SWPControllerVm.fundObj.currentValue){
			SWPControllerVm.currentValue=SWPControllerVm.fundObj.currentValue;
		}
		SWPControllerVm.reqParams={};
		SWPControllerVm.reqParams['amfiCode']=SWPControllerVm.fundId;
		mutualFundsService.getFundDetails(SWPControllerVm.reqParams).then(function(data) {
			SWPControllerVm.fundDetailList=data;
			SWPControllerVm.schemeCode=data.fundId;
			SWPControllerVm.fundType=data.fundType;
			if(SWPControllerVm.fundDetailList.swpMinAmtMthly){
				SWPControllerVm.swpMinAmtMthly= $filter('INRFLOAT')(SWPControllerVm.fundDetailList.swpMinAmtMthly,2); 
				SWPControllerVm.swpMinAmtQrtrly= $filter('INRFLOAT')(SWPControllerVm.fundDetailList.scmSwpMinAmtQrtrly,2); 
			}else{
				SWPControllerVm.swpMinAmtMthly='';
				SWPControllerVm.swpMinAmtQrtrly='';
			}
			
			SWPControllerVm.scmSwpDateMthly=SWPControllerVm.fundDetailList.scmSwpDateMthly.replace('&',',');
			SWPControllerVm.scmSwpDateMthly=SWPControllerVm.scmSwpDateMthly.split(',');  //Monthly start Date
			SWPControllerVm.scmSwpDateQrtrly=SWPControllerVm.fundDetailList.scmSwpDateQrtrly.replace('&',','); 
			SWPControllerVm.scmSwpDateQrtrly=SWPControllerVm.scmSwpDateQrtrly.split(',');//quarterly start Date
			SWPControllerVm.amcCode=SWPControllerVm.fundDetailList.scmAmcCd;
			
			if(SWPControllerVm.fundObj.plan){
				SWPControllerVm.plan= SWPControllerVm.fundObj.plan;
				SWPControllerVm.option = SWPControllerVm.fundObj.option;
				SWPControllerVm.nav  =$filter('INRFLOAT')(SWPControllerVm.fundObj.nav,4);
				SWPControllerVm.navDate =  $filter('date')(SWPControllerVm.fundObj.navDate,'d MMM yyyy' );
			
			}else{
				if(SWPControllerVm.fundDetailList.planList[0]){
					SWPControllerVm.plan  = SWPControllerVm.fundDetailList.planList[0].plan;
					SWPControllerVm.option =SWPControllerVm.fundDetailList.planList[0].option;
					SWPControllerVm.nav  = $filter('INRFLOAT')(SWPControllerVm.fundDetailList.planList[0].nav,4);
					SWPControllerVm.navDate =$filter('date')(SWPControllerVm.fundDetailList.planList[0].navDate,'d MMM yyyy' );
				}else{
					SWPControllerVm.plan  ='';
					SWPControllerVm.option='';
					SWPControllerVm.nav  ='';
					SWPControllerVm.navDate = '';
				}
			}
		}, function(error) {
			utilityService.showErrorMessage(error.responseMessage);
		});
	}
	/**
	* Fetch get accountDetails service
	* @param {}
	**/
	SWPControllerVm.accountDetails = function(){
		
		SWPControllerVm.accounts=mutualFundsService.getDetails();
		if(SWPControllerVm.accounts){
			$scope.accountListTemp=SWPControllerVm.accounts;
			$scope.accounts=[];
			var accountListTempLength = $scope.accountListTemp.length;
			for(SWPControllerVm.list=0;SWPControllerVm.list < accountListTempLength ;SWPControllerVm.list++){
				if($scope.accountListTemp[SWPControllerVm.list].accountType==constantConfig.mfAndsecConst.savingAccountInOpenAccount){
					$scope.accounts.push($scope.accountListTemp[SWPControllerVm.list]);
				}
			}
			$timeout(function() {
				//SWPControllerVm.accountFirstNo = $scope.accounts[0].accountNumber;
				SWPControllerVm.savingAccounts =$scope.accounts[0].accountNumber ;
			}, 400);
		}
		
	}	
	/**
	*Function to set min amount  
	**/
	SWPControllerVm.checkMinAmount=function(){
		if(SWPControllerVm.frequency.toLowerCase()==constantConfig.mfAndsecConst.quarterly){
			$scope.minAmount=SWPControllerVm.swpMinAmtQrtrly;
			
		} 
		if(SWPControllerVm.frequency.toLowerCase()==constantConfig.mfAndsecConst.monthly){
			$scope.minAmount=SWPControllerVm.swpMinAmtMthly;
		} 
		
		$scope.minAmount=parseFloat($scope.minAmount.replace(",",''));
		$scope.minRedeemUnit=$scope.minAmount/parseFloat(SWPControllerVm.sourceNav);
		
		$scope.enteredAmount=parseFloat(SWPControllerVm.amount);
		$scope.enteredAmount=parseFloat(SWPControllerVm.swpAmount);
		if($scope.minAmount>$scope.enteredAmount){
			SWPControllerVm.minAmountFlag=false;
		}else if(SWPControllerVm.currentValue<$scope.enteredAmount){
			SWPControllerVm.maxAmountFlag=false;
			SWPControllerVm.minAmountFlag=true;
		}else{
			SWPControllerVm.minAmountFlag=true;
			SWPControllerVm.maxAmountFlag=true;
		}
		
	}
	/**
	*Function to submit SWP details
	**/

	SWPControllerVm.submitSWP= function(){	
		var requestSecKey='';
		var reqParams = {};
		if(!SWPControllerVm.isTermsAndConditionChecked){
			return false;
		}
		SWPControllerVm.txnId = utilityService.getRandomNumber();
		var requestDate = new Date();
		requestDate = requestDate.getTime();
		requestSecKey=Math.floor((Math.random()) + requestDate);
		requestSecKey = (requestSecKey * 10 + 1);
		clickStreamService.clickStreamData=SWPControllerVm.txnId;
		
		reqParams["txnType"] = constantConfig.mfAndsecConst.SWP;	 
		reqParams["schemeId"] = SWPControllerVm.schemeCode;
		reqParams["schemeName"] = SWPControllerVm.fundDetailList.fundName;	
		reqParams["schemePlan"] =  SWPControllerVm.plan;
		reqParams["schemeOption"] = SWPControllerVm.option;
		reqParams["transactionType"] =constantConfig.mfAndsecConst.transactionTypeRedeem; // "R";
		reqParams["startDate"] = $filter('date')(new Date(SWPControllerVm.startDate), 'dd/MM/yyyy');
		reqParams["endDate"] =$filter('date')(new Date(SWPControllerVm.endDate), 'dd/MM/yyyy') ; 
		reqParams["amount"] = SWPControllerVm.swpAmount ;
		reqParams["units"] ='';
		reqParams["accountNo"] =SWPControllerVm.savingAccounts;
		reqParams["frequency"] =SWPControllerVm.frequency;
				
		reqParams["isPerpetual"] = "";
		reqParams["amcCode"] = SWPControllerVm.amcCode;
		reqParams["folioNo"] = SWPControllerVm.folio;
		reqParams["txnDate"] = "";
		reqParams["txnTime"] = "";
		reqParams["sipRegisteredDate"] = "";
		reqParams["numberOfInstallments"] = SWPControllerVm.noOfInstallment;
		reqParams["installmentNumber"] = SWPControllerVm.noOfInstallment;
		reqParams["bankName"] = "";
		reqParams["bankCode"] = "";
		reqParams["bankCity"] = "";
		reqParams["accountType"] = "";
		reqParams["panNo"] = SWPControllerVm.panCard;
		reqParams["customerTermandCondition"] = SWPControllerVm.isTermsAndConditionChecked;
		reqParams["branchName"] = "";
		reqParams["targetSchemeId"] = '';
		reqParams["targetSchemeName"] = '';	
		reqParams["targetSchemePlan"] = '';
		reqParams["targetSchemeOption"] = '';
		reqParams["dividendOption"] =SWPControllerVm.dividendOption;
		reqParams["divPayoutMechanism"]=SWPControllerVm.divPayOutMechanism;
		reqParams["redPayoutMechanism"]=SWPControllerVm.redPayOutMechanism;
		reqParams["txnId"]=SWPControllerVm.txnId;
		reqParams["amfiCode"]=SWPControllerVm.fundId;
		reqParams["closeAc"]='';
		reqParams["secKey"]=requestSecKey;

		$rootScope.fundName=SWPControllerVm.fundDetailList.fundName;
		$rootScope.amountToPay=SWPControllerVm.swpAmount;
	       $rootScope.unitName=constantConfig.mfAndsecConst.amount;
		
		mutualFundsService.addInvedtedAmount(SWPControllerVm.swpAmount);//for OTP page showing
		mutualFundsService.payDuesRequest(reqParams).then(function(data){
			$rootScope.stpotpPage=0;
	        $rootScope.redeemotpPage=0;
			$rootScope.cancelotpPage=0;       	
	        $rootScope.sipotpPage=0;
			$rootScope.lumsumotpPage=0;
			$rootScope.swpotpPage=1;									
			$rootScope.switchotpPage=0;				 
			if(data.submitRequest.isOTPRequired == "true"){			    	
			    	$state.go("menu.swpOTP");
			    }else{
			    	var calCulatedKey=mutualFundsService.verifySecKey(parseInt(data.submitRequest.secKey));
	                 if(requestSecKey==calCulatedKey){
						SWPControllerVm.message = data.submitRequest.status;
						SWPControllerVm.transactionReferenceNo = data.submitRequest.transactionReferenceNo;						
							SWPControllerVm.SWPControllerVmPage=0;
							SWPControllerVm.successPage=1; 
							SWPControllerVm.SWPReviewPage=0;     
				            SWPControllerVm.swpAmount= $rootScope.amountToPay;                
				            SWPControllerVm.transactionDate=new Date(data.submitRequest.transactionDate);
							utilityService.setCsatJournies("mutualFunds");						
		          }
		      }
		}, function(error){
			utilityService.showErrorMessage(error.responseMessage);
		});
	}

	 $scope.validateOTP=function(){
            var reqParams={};
            var requestSecKey;
		    var requestDate = new Date();
		    requestDate = requestDate.getTime();
		    requestSecKey=Math.floor((Math.random()) + requestDate);
		    requestSecKey = (requestSecKey * 10 + 1);
            reqParams.otp= $scope.enterOTP;
            reqParams.secKey=requestSecKey; 
            mutualFundsService.validateOTPForPayment(reqParams).then(function(data){
             if(data.data.otpStatus == "0000"){
                 var calculatedKey=mutualFundsService.verifySecKey(parseInt(data.data.secKey));
                 if(requestSecKey==calculatedKey){   
                 $rootScope.transactionReferenceNo=data.data.transactionReferenceNo;      
                 $rootScope.swpSuccessPage=1; 
                 $rootScope.lumsumSuccessPage=0; 
                 $rootScope.cancelSuccessPage=0; 
				 $rootScope.redeemSuccessPage=0;             	
             	 $rootScope.switchSuccessPage=0;
             	 $rootScope.stpSuccessPage=0;                 	
             	 $rootScope.sipSuccessPage=0;                                 
                 $rootScope.transactionDate= new Date(data.data.transactionDate);                
                 utilityService.setCsatJournies("mutualFunds");              
                 $state.go('menu.swpPaymentSuccess');
                 }
             }else if(data.data.otpStatus != "0000"){
             	 mutualFundsService.clearOTP($rootScope.enterOTP);
                 $scope.errorMessage=data.responseMessage;
             }else{
                   SWPControllerVm.showErrorInformationPopup(error.responseMessage);
             }
            },function(error){
            	//utilityService.showErrorMessage(error.responseMessage);
            	SWPControllerVm.showErrorInformationPopup(error.responseMessage);
            })
              
        }

          $scope.resendOTP=function(){
             $scope.enterOTP="";
            var reqParams ={};
            reqParams.id ="";
            reqParams.emailId ="";
            mutualFundsService.getOTPTokenSecure(reqParams).then(function(data){
                 $rootScope.clickCount++;
                 $scope.mutualFundEnterOTPForm={};
                if($rootScope.clickCount==2){
                    $scope.disableLink=true;
                }
            })          
        }

        //****Submit button on OTP Page***//
         $scope.validateOTPNext=function(){
         	 $scope.enterOTP=document.getElementById('txt_otp').value;
           if(validateForm()){         
            $scope.validateOTP();
            }           
        }     
       function validateForm(){
             $rootScope.mutualFundEnterOTPForm={};
            if(mutualFundsService.isValidOTPNum($scope.enterOTP)){
                 $scope.errorMessage=mutualFundsService.isValidOTPNum($scope.enterOTP);
            }
            return (angular.equals({}, $rootScope.mutualFundEnterOTPForm))?true:false;
        }
	
	/***BACK to page***/
	SWPControllerVm.backToSWP=function(){
		SWPControllerVm.SWPVmPage=1;
		SWPControllerVm.successPage=0;
		SWPControllerVm.SWPReviewPage=0;
		SWPControllerVm.isTermsAndConditionChecked=0;
		
	}
	/**
	*Function to review SWP
	**/
	SWPControllerVm.reviewSWP=function(){
		SWPControllerVm.SWPVmPage=0;
		SWPControllerVm.successPage=0;
		SWPControllerVm.SWPReviewPage=1;
		SWPControllerVm.isTermsAndConditionChecked=0;
	}
	/**
	* Fetch get Pancard From server
	* @param {id}
	*/
	SWPControllerVm.getPanCard=function(){
		var reqParams={};
		reqParams['id']='';
		mutualFundsService.getPanCardNumber(reqParams).then(function(data){
			SWPControllerVm.panCard=data.mfKyc.panNo;
			SWPControllerVm.divPayOutMechanism=data.mfKyc.divPayOutMechanism;
			SWPControllerVm.redPayOutMechanism=data.mfKyc.redPayOutMechanism;
			//SWPControllerVm.folio=data.mfKyc.folioNo;
		}, function(error){
			utilityService.showErrorMessage(error.responseMessage);

		});
	}
	
	/**
	* Check Eligible dates
	*/
	SWPControllerVm.checkDate=function(){
		SWPControllerVm.endDate='';
		var currentDate = new Date();
		$translate('SAME_DATE_SIP_ERROR_MESG').then(function(transValue) {
			SWPControllerVm.dateErrorMessage = transValue;
		});
		$timeout(function(){
			SWPControllerVm.SIPMonthObj='';
			if(currentDate.getDate()==SWPControllerVm.SIPDate){
				SWPControllerVm.SuccessPop = $ionicPopup.show({
				template: '<p>'+SWPControllerVm.dateErrorMessage+'</p>',
				title: '',
				cssClass: 'dialog',
				scope: $scope,
				buttons: [{
					text: 'Change',
					type: 'button-positive',
					onTap: function(e) {
						SWPControllerVm.SuccessPop.close(); 
						SWPControllerVm.disableDate=0;
						e.preventDefault();
					}
				},{
					text: 'OK',
					type: 'button-positive',
					onTap: function(e) {
						SWPControllerVm.SuccessPop.close();
						SWPControllerVm.disableDate=0;
						e.preventDefault();
					}
				}]
				});
				
					if(currentDate.getMonth()==11){ //Dec 30 == 30 current date
						SWPControllerVm.SIPYear=currentDate.getFullYear()+1;
						SWPControllerVm.SIPMonth=SWPControllerVm.getMonthName(0);
					}else{
						SWPControllerVm.SIPYear=currentDate.getFullYear();
						SWPControllerVm.SIPMonth=SWPControllerVm.getMonthName(currentDate.getMonth()+1);
					}
			}else if(SWPControllerVm.SIPDate=="0"){
					SWPControllerVm.SIPYear='';
					SWPControllerVm.SIPMonth='';
			}else if((currentDate.getDate()) < SWPControllerVm.SIPDate){
				if(currentDate.getMonth()==1 &&  SWPControllerVm.SIPDate.trim()=="30"){ 
					SWPControllerVm.SIPMonth=SWPControllerVm.getMonthName(currentDate.getMonth()+1);
					SWPControllerVm.SIPYear=currentDate.getFullYear();
				}else{
					SWPControllerVm.SIPMonth=SWPControllerVm.getMonthName(currentDate.getMonth());
					SWPControllerVm.SIPYear=currentDate.getFullYear();
				}
				
			}else if((currentDate.getDate())>SWPControllerVm.SIPDate){
				if(currentDate.getMonth()==11){ 
					SWPControllerVm.SIPYear=currentDate.getFullYear()+1;
					SWPControllerVm.SIPMonth=SWPControllerVm.getMonthName(0);
				}else{
					SWPControllerVm.SIPYear=currentDate.getFullYear();
					SWPControllerVm.SIPMonth=SWPControllerVm.getMonthName(currentDate.getMonth()+1);
				}
			}
		},500);
	}   
	SWPControllerVm.getMonthName=function(month){
		var monthArray=["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sept","Oct","Nov","Dec" ];
		return monthArray[month];
	}
	

	
	/**
	*Function to set Installment ,min amount
	**/
	SWPControllerVm.changeFrequency = function(){
		SWPControllerVm.checkMinAmount();
		
		if(SWPControllerVm.endDate){
			SWPControllerVm.startDate=$filter('date')(new Date(SWPControllerVm.SIPDate+" "+SWPControllerVm.SIPMonth+" "+SWPControllerVm.SIPYear), 'dd MMM yyyy');  
			SWPControllerVm.sDate=new Date(SWPControllerVm.startDate);
			SWPControllerVm.noOfYearDiffernce = (new Date(SWPControllerVm.endDate).getFullYear()-SWPControllerVm.sDate.getFullYear())*12;
            SWPControllerVm.noOfYearDiffernce -= SWPControllerVm.sDate.getMonth()+1;
            SWPControllerVm.noOfYearDiffernce += new Date(SWPControllerVm.endDate).getMonth();
            SWPControllerVm.noOfMonths = SWPControllerVm.noOfYearDiffernce;
            SWPControllerVm.noOfMonths= SWPControllerVm.noOfMonths <= 0?0: SWPControllerVm.noOfMonths;
	    	if (SWPControllerVm.noOfMonths>=1) {
            	SWPControllerVm.noOfMonths= SWPControllerVm.noOfMonths+2;
            }else{
            	SWPControllerVm.noOfMonths= SWPControllerVm.noOfMonths+1;
            }
            if (SWPControllerVm.frequency.toLowerCase() == constantConfig.mfAndsecConst.quarterly) {
                SWPControllerVm.noOfInstallment = ((SWPControllerVm.noOfMonths/3)+1);
                SWPControllerVm.noOfInstallment = Math.round(SWPControllerVm.noOfInstallment);
                SWPControllerVm.minInstallments= parseFloat(constantConfig.mfAndsecConst.minInstallments4);
                if(SWPControllerVm.noOfInstallment < SWPControllerVm.minInstallments){
					utilityService.showErrorMessage(constantConfig.mfAndsecConst.stp4QtrError);
	    		}
            }
            if (SWPControllerVm.frequency.toLowerCase() == constantConfig.mfAndsecConst.monthly) {            	
                SWPControllerVm.noOfInstallment = SWPControllerVm.noOfMonths;
                // CHANGE THE MONTH BASED ON SELECTED FREQUENCY
                SWPControllerVm.minInstallments= parseFloat(constantConfig.mfAndsecConst.minInstallments12);
				if(SWPControllerVm.noOfInstallment < SWPControllerVm.minInstallments){
					utilityService.showErrorMessage(constantConfig.mfAndsecConst.stp12MonthsError);
				}
            } 
		}
		
	}
	/*** Unit***/
	SWPControllerVm.allUnitsCheck= function(){
		if(SWPControllerVm.allUnits == "1"){
			SWPControllerVm.minUnitFlag=true;
			SWPControllerVm.swpUnit = SWPControllerVm.totalUnit;
		}
		else{
			SWPControllerVm.swpUnit = '';
		}
	}
	SWPControllerVm.getMonthName=function(month){
		var monthArray=["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sept","Oct","Nov","Dec" ];
		return monthArray[month];
	}
	/***Function to openDatePicker***/
	SWPControllerVm.endDatePicker = function(){
		var date=SWPControllerVm.SIPDate+"-"+SWPControllerVm.SIPMonth+"-"+SWPControllerVm.SIPYear;
		if(!SWPControllerVm.endDate){
			SWPControllerVm.endDatePickerDiv.inputDate=new Date(date.replace(/\s/g,''));
			SWPControllerVm.endDatePickerDiv.from=new Date(date.replace(/\s/g,''));
		}else{
			SWPControllerVm.endDatePickerDiv.inputDate=new Date(SWPControllerVm.endDate);
			SWPControllerVm.endDatePickerDiv.from=new Date(date.replace(/\s/g,''));
		}
	    ionicDatePicker.openDatePicker(SWPControllerVm.endDatePickerDiv);
		
	};
	SWPControllerVm.endDatePickerDiv = {
		callback: function (val) {
			var date = $filter('date')(new Date(val), 'dd MMM yyyy');
			var filterDate=date.split(' ');
			SWPControllerVm.endDate= new Date(SWPControllerVm.SIPDate+" "+filterDate[1]+" "+filterDate[2]);//date;
			SWPControllerVm.startDate=$filter('date')(new Date(SWPControllerVm.SIPDate+" "+SWPControllerVm.SIPMonth+" "+SWPControllerVm.SIPYear), 'dd MMM yyyy');  
			SWPControllerVm.sDate=new Date(SWPControllerVm.startDate);
			
			SWPControllerVm.noOfYearDiffernce = (new Date(SWPControllerVm.endDate).getFullYear() - SWPControllerVm.sDate.getFullYear()) * 12;
            SWPControllerVm.noOfYearDiffernce -= SWPControllerVm.sDate.getMonth() + 1;
            SWPControllerVm.noOfYearDiffernce += new Date(SWPControllerVm.endDate).getMonth();
            SWPControllerVm.noOfMonths = SWPControllerVm.noOfYearDiffernce;
            SWPControllerVm.noOfMonths= SWPControllerVm.noOfMonths <= 0?0: SWPControllerVm.noOfMonths;
			if (SWPControllerVm.noOfMonths>=1) {
            	SWPControllerVm.noOfMonths= SWPControllerVm.noOfMonths+2;
            }else{
            	SWPControllerVm.noOfMonths= SWPControllerVm.noOfMonths+1;
            }
            if (SWPControllerVm.frequency.toLowerCase() == constantConfig.mfAndsecConst.quarterly) {
                SWPControllerVm.noOfInstallment = ((SWPControllerVm.noOfMonths/3)+1);
                SWPControllerVm.noOfInstallment = Math.round(SWPControllerVm.noOfInstallment);
                SWPControllerVm.minInstallments= parseFloat(constantConfig.mfAndsecConst.minInstallments4);
                if(SWPControllerVm.noOfInstallment < SWPControllerVm.minInstallments){
					utilityService.showErrorMessage(constantConfig.mfAndsecConst.stp4QtrError);
	    		}
            }
            if (SWPControllerVm.frequency.toLowerCase() == constantConfig.mfAndsecConst.monthly) {            	
                SWPControllerVm.noOfInstallment = SWPControllerVm.noOfMonths;
                // CHANGE THE MONTH BASED ON SELECTED FREQUENCY
                SWPControllerVm.minInstallments= parseFloat(constantConfig.mfAndsecConst.minInstallments12);
				if(SWPControllerVm.noOfInstallment < SWPControllerVm.minInstallments){
					utilityService.showErrorMessage(constantConfig.mfAndsecConst.stp12MonthsError);
				}
            }
		},
		dateFormat: 'dd MMM yyyy',
		closeOnSelect: false,       
		templateType: 'popup' 
		
	};
	
	
	
	/***Start term and Condition***/
	SWPControllerVm.termsAndConditions=function(){
		if(SWPControllerVm.termsAndConditionsFlag==1){
			SWPControllerVm.termsAndConditionsFlag=0;
		}else{
			//Call service to fetch termsConditionsMessage
			SWPControllerVm.reqParams={};
			SWPControllerVm.reqParams['action']=constantConfig.mfAndsecConst.swpTermsAndC;
			mutualFundsService.getTermsAndConditions(SWPControllerVm.reqParams).then(function(data) {
				SWPControllerVm.termsAndConditionsMessage=data.message;
			}, function(error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
			SWPControllerVm.termsAndConditionsFlag=1;
		}			
	}
	
	/***Function to show information POP UP***/
	SWPControllerVm.showInformationPopup=function(){
		var infoPopup = $ionicPopup.show({
			template: '<p>Message</p>',
			title:'Information',
			scope: $scope,
			buttons: [ {text: 'Ok'}]
		});

		infoPopup.then(function(res){
        
		});    
	}
	/***Function to show alert POP UP***/
		SWPControllerVm.showErrorInformationPopup=function(message){
			var infoPopup = $ionicPopup.show({
				template: '<p>'+message+'</p>',
				title:'Alert',
				cssClass: 'dialog',		
				scope: $scope,
				buttons: [ {
					text: 'Ok',
					onTap: function(e) {
						$state.go('menu.accountOverviewMyBalance');
					}
				}]
			});
		}
	/***Function to show success page***/
	SWPControllerVm.showSuccesPage=function(){
		SWPControllerVm.SWPVmPage=0;
		SWPControllerVm.successPage=1;
	}
	
	/***Function to go to portfolio page***/
	$scope.portfolio=function(){
		$state.go("menu.portfolio");
		SWPControllerVm.SWPVmPage=1;
		SWPControllerVm.successPage=0;
	}
	//Close Page
	$scope.closePage =function(){
		$state.go("menu.portfolio");		
	}
	
	
	/*** actions to done everytime the view is shown***/
	$scope.$on('$ionicView.beforeEnter', function() {
		initPage();
		
	});
	
	
	return this;
}]);

