/******* SWP Controller ******/

'use strict';

angularApp.controller('cancelFundsController', 
						["$timeout",
						 "$state",
						 "$scope",
						 "$rootScope",
						 "$translate",
						 "$ionicPopup",
						 "mutualFundsService","utilityService","$filter","constantConfig","clickStreamService","customerInfoService","getAccountDetailsService",
				 
function ($timeout,
		$state,
		$scope,
		$rootScope,
		$translate,
		$ionicPopup,
		mutualFundsService,utilityService,$filter,constantConfig,clickStreamService,customerInfoService,getAccountDetailsService) {
		
	var cancelFundsVm = this;
	
	/*** Initialize the variables that has to show in  the HTML come here ***/
	function initPage(){
		
		$scope.currentIndex=-1;
		cancelFundsVm.cancelFundsVmPage=1;
		cancelFundsVm.successPage=0; 
		cancelFundsVm.cancelFundType=constantConfig.mfAndsecConst.SIPAdditional;
		$scope.type=cancelFundsVm.cancelFundType;
		cancelFundsVm.getFundsList();

		var rupeeSymbol = String.fromCharCode(8377);
        $rootScope.clickCount = 0;
        $rootScope.isResendOTP = false;
        $rootScope.isResendDisabled=false;           
        $rootScope.mobileNumber = $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4);
        $rootScope.amountToPay = rupeeSymbol + mutualFundsService.getInvedtedAmount();
		
	}
	/**
	*Function to go to get fund Deatils
    @params:{fundId:''}
	
	**/
	cancelFundsVm.getFundsList=function(){
		cancelFundsVm.folioObj=mutualFundsService.getFolioToInvest();
		cancelFundsVm.fundObj=mutualFundsService.getFundToInvest();
		cancelFundsVm.fundId=cancelFundsVm.fundObj.amfiCode;
		if(cancelFundsVm.folioObj!=''){
			cancelFundsVm.folioNumber=cancelFundsVm.folioObj.mfKyc.folioNo;		
		if(cancelFundsVm.folioNumber){
			cancelFundsVm.folio=cancelFundsVm.folioNumber;
		}
	   }else{	   
		if(cancelFundsVm.fundObj.folioNumber){
			cancelFundsVm.folio=cancelFundsVm.fundObj.folioNumber;
		}
	   }
		cancelFundsVm.cancelFundsList='';
		cancelFundsVm.reqParams={};
		cancelFundsVm.reqParams['amfiCode']=cancelFundsVm.fundId;
		
		mutualFundsService.getFundDetails(cancelFundsVm.reqParams).then(function(data) {
			cancelFundsVm.fundDetailList=data;
			cancelFundsVm.plan  = cancelFundsVm.fundDetailList.planList[0].plan;
			cancelFundsVm.option =cancelFundsVm.fundDetailList.planList[0].option;
			cancelFundsVm.nav  = $filter('INRFLOAT')(cancelFundsVm.fundDetailList.planList[0].nav,4);
			cancelFundsVm.navDate = $filter('date')(cancelFundsVm.fundDetailList.planList[0].navDate,'dd MMM yyyy' );
			
			cancelFundsVm.reqParams={};
			cancelFundsVm.fundName=data.fundName;
			$scope.type=cancelFundsVm.cancelFundType;
			cancelFundsVm.reqParams['schemeType']=cancelFundsVm.cancelFundType;
			cancelFundsVm.reqParams['schemeCode']=data.fundId;
			mutualFundsService.getFundListForCancellation(cancelFundsVm.reqParams).then(function(data) {
				cancelFundsVm.cancelFundsList=data;
				cancelFundsVm.cancelFundsList= $filter('orderBy')(cancelFundsVm.cancelFundsList,'-regDate' );
				$scope.currentIndex=-1;
			
			}, function(error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		}, function(error) {
			utilityService.showErrorMessage(error.responseMessage);
		});
		
		
	}
	
	/*** Function to Show  Details Page  ***/
	cancelFundsVm.showFundListDetails=function(index){
		$scope.currentIndex=index;
		cancelFundsVm.selectedFund='';
		cancelFundsVm.selectedFund=cancelFundsVm.cancelFundsList[index];
		
	}
	
	/**
	*Function to submit cancel details
	**/
	$rootScope.submitCancel= function(){	
		var reqParams = {};	
		var requestSecKey="";

		$rootScope.fundName=cancelFundsVm.fundName;
		$rootScope.fundType=cancelFundsVm.cancelFundType;
		
		
		
        $rootScope.regNo=cancelFundsVm.selectedFund.regNo;
        $rootScope.amountToPay=cancelFundsVm.selectedFund.amount;
		
			var requestDate = new Date();
			requestDate = requestDate.getTime();
			requestSecKey=Math.floor((Math.random()) + requestDate);
			requestSecKey = (requestSecKey * 10 + 1);
			cancelFundsVm.txnId=utilityService.getRandomNumber();
			clickStreamService.clickStreamData=cancelFundsVm.txnId;
			reqParams["transReferNo"] =cancelFundsVm.selectedFund.regNo;
		    reqParams["txnId"]=cancelFundsVm.txnId;
		    reqParams["fromFundName"]=cancelFundsVm.fundName;
		    reqParams["toFundName"]=cancelFundsVm.fundName;
      
           reqParams["secKey"]=requestSecKey;
	       reqParams["fundType"]=cancelFundsVm.cancelFundType;
	       if(cancelFundsVm.selectedFund.amount){
		     reqParams["amount"]=cancelFundsVm.selectedFund.amount;
	       	 reqParams["units"]="0";
	       	 $rootScope.unitName=constantConfig.mfAndsecConst.amount;   
	       }else{		
			  reqParams["units"]=cancelFundsVm.selectedFund.units;
	          reqParams["amount"]="0";  
	          $rootScope.units=cancelFundsVm.selectedFund.units;
		      $rootScope.unitName=constantConfig.mfAndsecConst.units;    
       }
       reqParams["fundName"]=cancelFundsVm.fundName;
       reqParams["folioNo"] = cancelFundsVm.folio;

       mutualFundsService.addInvedtedAmount($rootScope.amountToPay);//for OTP page showing
       mutualFundsService.getCancelFundOTP(reqParams).then(function(data){
         if(data.submitRequest.isOTPRequired=="true"){  
            $rootScope.cancelotpPage=1;       	
            $rootScope.sipotpPage=0;
			$rootScope.lumsumotpPage=0;
			$rootScope.swpotpPage=0;
			$rootScope.stpotpPage=0;
			$rootScope.redeemotpPage=0;    	
			$rootScope.switchotpPage=0;
            $state.go('menu.cancelFundOTP');
         }
	  
	}, function(error){
			utilityService.showErrorMessage(error.responseMessage);
      })

	       }
		//
		
		$scope.validateOTP=function(){
            var reqParams={};
            var requestSecKey="";    

            var requestDate = new Date();
	        requestDate = requestDate.getTime();
	        requestSecKey=Math.floor((Math.random()) + requestDate);
            requestSecKey = (requestSecKey * 10 + 1);
			           

            reqParams.otp= $scope.enterOTP;
            reqParams.secKey=requestSecKey; 
            mutualFundsService.cancelMandateOTPValidate(reqParams).then(function(data){
             if(data.data.otpStatus == "0000"){
                 var calculatedKey=mutualFundsService.verifySecKey(parseInt(data.data.secKey));
                 if(requestSecKey==calculatedKey){  
					 getAccountDetailsService.accountOverviewData="";               
					$rootScope.cancelFundsVmPage=0;
					$rootScope.cancelSuccessPage=1; 
					$rootScope.redeemSuccessPage=0;
                 	$rootScope.swpSuccessPage=0;
                 	$rootScope.switchSuccessPage=0;
                 	$rootScope.stpSuccessPage=0;
                 	$rootScope.lumsumSuccessPage=0;
                 	$rootScope.sipSuccessPage=0;                 	
					$rootScope.transactionReferenceNo=$rootScope.regNo;
					cancelFundsVm.amount=mutualFundsService.getInvedtedAmount();
					$rootScope.transactionDate=new Date(data.data.transactionDate);					           
	                utilityService.setCsatJournies("mutualFunds"); 
	                            
	                $state.go('menu.cancelPaymentSuccess');
                 }
             }else if(data.data.otpStatus != "0000"){
             	  mutualFundsService.clearOTP($rootScope.enterOTP);
                  $scope.errorMessage=data.responseMessage;
             }else{
                   cancelFundsVm.showErrorInformationPopup(error.responseMessage);
             }
            },function(){
            	//utilityService.showErrorMessage(error.responseMessage);
            	cancelFundsVm.showErrorInformationPopup(error.responseMessage);
            })
              
        }

          $scope.resendOTP=function(){
             $scope.enterOTP="";
            var reqParams ={};
            reqParams.id ="";
            reqParams.emailId ="";
            mutualFundsService.getResendOTPTokenSecureCancel(reqParams).then(function(data){
                 $rootScope.clickCount++;
                 $scope.mutualFundEnterOTPForm={};
                if($rootScope.clickCount==2){
                    $scope.disableLink=true;
                }
            })          
        }

        //****Submit button on OTP Page***//
         $scope.validateOTPNext=function(){
         	 $scope.enterOTP=document.getElementById('txt_otp').value;
           if(validateForm()){         
            $scope.validateOTP();
            }           
        }     
       function validateForm(){
             $rootScope.mutualFundEnterOTPForm={};
            if(mutualFundsService.isValidOTPNum($scope.enterOTP)){
                $scope.errorMessage=mutualFundsService.isValidOTPNum($scope.enterOTP);
            }
            return (angular.equals({}, $rootScope.mutualFundEnterOTPForm))?true:false;
        }
	

	/***Function to show alert POP UP***/
		cancelFundsVm.showErrorInformationPopup=function(message){
			var infoPopup = $ionicPopup.show({
				template: '<p>'+message+'</p>',
				title:'Alert',
				cssClass: 'dialog',		
				scope: $scope,
				buttons: [ {
					text: 'Ok',
					onTap: function(e) {
						$state.go('menu.accountOverviewMyBalance');
					}
				}]
			});
		}
	
	/**
	*Function to Cancel Confirmation POPUP
	
	**/
	cancelFundsVm.cancelConfirmation=function(){
		
		if($scope.type==constantConfig.mfAndsecConst.SIPFresh){
			$scope.type=constantConfig.mfAndsecConst.SIP;
		}
		var cancelFundsVm = $ionicPopup.show({       
				template: '<p class="padding-bottom-20" > <span translate="CANCEL_SIP_CONFRM" ></span> '+$scope.type+' ? </p>',
				title: '',
				cssClass: 'dialog',
				scope: $scope,			
				buttons: [{
					text: 'No',
					type: 'button-negative',
						onTap: function(e) {
							cancelFundsVm.close(); 
							e.preventDefault();
						}
					},
					{
					text: 'Yes',
					type: 'button-positive',
						onTap: function(e) {
							cancelFundsVm.close();
							$rootScope.submitCancel();
						    e.preventDefault();
						}
					}]
				});
		
	}



	
	/***Function to go to portfolio page***/
	$scope.closePage=function(){
		$state.go("menu.portfolio");
		
	}
	$scope.portfolio=function(){
		$state.go("menu.portfolio");		
	}
	/*** actions to done everytime the view is shown***/
	$scope.$on('$ionicView.beforeEnter', function() {
		initPage();
		
	});
	
	return this;
}]);

