	/*******SIP Controller ******/

	'use strict';

	angularApp.controller('createSIPController', ["$timeout",
	    "$state",
	    "$scope",
	    "$rootScope",
	    "$translate",
	    "$ionicPopup",
	    "mutualFundsService", "utilityService", "ionicDatePicker", "$filter", "constantConfig", "clickStreamService", "customerInfoService","getAccountDetailsService",

	    function($timeout,
	        $state,
	        $scope,
	        $rootScope,
	        $translate,
	        $ionicPopup,
	        mutualFundsService, utilityService, ionicDatePicker, $filter, constantConfig, clickStreamService, customerInfoService,getAccountDetailsService) {

	        var frequencyData = this;
	        var createSIPVm = this;
	        /*** Initialize the variables that has to show in  the HTML come here ***/
	        function initPage() {
	            createSIPVm.SIPDate = "0";
	            createSIPVm.folio = '';
	            createSIPVm.minAmountFlag = true;
	            createSIPVm.maxAmountFlag = true;
	            createSIPVm.sufficiantBalance=true;
	            createSIPVm.dividendOption = '';
	            createSIPVm.isTermsAndConditionChecked = 0;
	            createSIPVm.createSIPPage = 1;
	            createSIPVm.reviewPage = 0;
	            createSIPVm.successPage = 0;
	            createSIPVm.getFundDetails();
	            createSIPVm.getSBIAccounts();
		    createSIPVm.getTransactionNotes();
	            //createSIPVm.accountDetails();
	            createSIPVm.getPanCard();
	            createSIPVm.getFrequercy();
	            createSIPVm.transactionType = constantConfig.mfAndsecConst.transactionTypeSIP; //"P";
	            createSIPVm.disableDate = 1;
	            createSIPVm.minQuarterlyAmount = 0;
	            createSIPVm.perpetualCheck = false;

	            var rupeeSymbol = String.fromCharCode(8377);
	            $rootScope.clickCount = 0;
	            $rootScope.isResendOTP = false;
	            $rootScope.isResendDisabled = false;
	            $rootScope.mobileNumber = $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4);
	            $rootScope.amountToPay = rupeeSymbol + mutualFundsService.getInvedtedAmount();

	        }

	        
			createSIPVm.getSBIAccounts=function(){
				mutualFundsService.getSBIBankAccounts().then(function(data){
					$scope.accounts=data.beneficiaryList.ownAccounts;
					if($scope.accounts.length > 0){
						createSIPVm.accounts=$scope.accounts;
						createSIPVm.savingAccounts=$scope.accounts[0].benAccntNo;
					}
				})
				createSIPVm.infoMessage=mutualFundsService.getInfoList();
				if(createSIPVm.infoMessage.sip){					
					createSIPVm.refCodeContentMessage=createSIPVm.infoMessage.refCodeContent;
				}else{					
					createSIPVm.refCodeContentMessage=constantConfig.mfAndsecConst.riskInfoEmptyText;
				}	
			}	
	        /**
	         * Fetch get Account and fund  Details From service
	         * @param {fundId}
	         **/
	        createSIPVm.accountDetails = function() {

	            $scope.accounts = [];
	            createSIPVm.accounts = mutualFundsService.getDetails();
	            if (createSIPVm.accounts) {
	                $scope.accountListTemp = createSIPVm.accounts;
	                var accountListTempLength = $scope.accountListTemp.length;
	                for (createSIPVm.list = 0; createSIPVm.list < accountListTempLength; createSIPVm.list++) {
	                    if ($scope.accountListTemp[createSIPVm.list].accountType == constantConfig.mfAndsecConst.savingAccountInOpenAccount || $scope.accountListTemp[createSIPVm.list].accountType == constantConfig.mfAndsecConst.currentAccountInOpenAccount || $scope.accountListTemp[createSIPVm.list].accountType == constantConfig.mfAndsecConst.odAccountInOpenAccount) {
	                        $scope.accounts.push($scope.accountListTemp[createSIPVm.list]);
	                    }
	                }
	                // createSIPVm.accountFirstNo = $scope.accounts[0].accountNumber;
	                $timeout(function() {
	                	createSIPVm.savingAccounts =$scope.accounts[0].accountNumber ;
	                }, 600);
	            }
	        }

			/**
	        *Function to go to get Transaction Notes Message
	        @params:{}
	
	        **/
			createSIPVm.getTransactionNotes = function() {
				mutualFundsService.getTransactionNotes().then(function(data) {
					createSIPVm.commonMssg = data.common;
				}, function(error) {
					createSIPVm.commonMssg = ""; 
					utilityService.showErrorMessage(error.responseMessage);
				}); 
			}

			
	        /**
	        *Function to go to get fund Deatils
	        @params:{fundId:''}
	
	        **/


	        createSIPVm.getFundDetails = function() {
	        	createSIPVm.folioObj=mutualFundsService.getFolioToInvest();
	        	createSIPVm.fundObj = mutualFundsService.getFundToInvest();
	            createSIPVm.fundId = createSIPVm.fundObj.amfiCode;
	        	if(createSIPVm.folioObj!=''){
				createSIPVm.folioNumber=createSIPVm.folioObj.mfKyc.folioNo;
				if (createSIPVm.folioNumber) {
	                createSIPVm.folio = createSIPVm.folioNumber;
	            }
				}else{
					if (createSIPVm.fundObj.folioNumber) {
	                createSIPVm.folio = createSIPVm.fundObj.folioNumber;
	            }
				}

	            
	            
	            createSIPVm.reqParams = {};
	            createSIPVm.reqParams['amfiCode'] = createSIPVm.fundId;

	            mutualFundsService.getFundDetails(createSIPVm.reqParams).then(function(data) {
	                createSIPVm.fundDetailList = data;
	                createSIPVm.schemeCode = data.fundId;
	                createSIPVm.fundType = data.fundType;
	                createSIPVm.amcCode = createSIPVm.fundDetailList.scmAmcCd;
	                createSIPVm.getFrequercy();
	                if (createSIPVm.fundDetailList.maxAppAmount) {
	                    createSIPVm.maxAmount = $filter('INRFLOAT')(createSIPVm.fundDetailList.maxAppAmount, 2);
	                } else {
	                    createSIPVm.maxAmount = '';
	                }
	                createSIPVm.sipMinAmtMthly = $filter('INRFLOAT')(createSIPVm.fundDetailList.sipMinAmtMthly, 2);
	                createSIPVm.sipMinAmtQuarter = $filter('INRFLOAT')(createSIPVm.fundDetailList.sipMinAmtQuarter, 2);

	                createSIPVm.scmSipDateMonthly = createSIPVm.fundDetailList.scmSipDateMonthly.replace('&', ',');
	                createSIPVm.scmSipDateMonthly = createSIPVm.scmSipDateMonthly.split(','); //Monthly start Date
	                createSIPVm.scmSipDateQuarterly = createSIPVm.fundDetailList.scmSipDateQuarterly.replace('&', ',');
	                createSIPVm.scmSipDateQuarterly = createSIPVm.scmSipDateQuarterly.split(','); //quarterly start Date
	                if (createSIPVm.fundObj.plan) {
	                    createSIPVm.plan = createSIPVm.fundObj.plan;
	                    createSIPVm.option = createSIPVm.fundObj.option;
	                    createSIPVm.nav = createSIPVm.fundObj.nav;
	                    createSIPVm.navDate = createSIPVm.fundObj.navDate;

	                } else {
	                    if (createSIPVm.fundDetailList.planList[0]) {
	                        createSIPVm.plan = createSIPVm.fundDetailList.planList[0].plan;
	                        createSIPVm.option = createSIPVm.fundDetailList.planList[0].option;
	                        createSIPVm.nav = createSIPVm.fundDetailList.planList[0].nav;
	                        createSIPVm.navDate = createSIPVm.fundDetailList.planList[0].navDate;
	                    } else {
	                        createSIPVm.plan = '';
	                        createSIPVm.option = '';
	                        createSIPVm.nav = '';
	                        createSIPVm.navDate = '';
	                    }
	                }
	            }, function(error) {
	                utilityService.showErrorMessage(error.responseMessage);
	            });
	        }
	        /** 
	        *Function to get Frequency
	        @Params:{}
	        **/
	        createSIPVm.getFrequercy = function() {
	            mutualFundsService.getFrequercyDetails().then(function(data) {
	                createSIPVm.frequencyObj = data;
                    // createSIPVm.frequency = createSIPVm.frequencyObj[0].frequencyValue;
                    createSIPVm.selectedFrequency = createSIPVm.frequency;
                    createSIPVm.frequency=createSIPVm.frequencyObj[1].frequencyValue;
                    if (createSIPVm.frequency.toLowerCase() == constantConfig.mfAndsecConst.quarterly) {
                        createSIPVm.minQuarterlyAmount = createSIPVm.sipMinAmtQuarter;
                        createSIPVm.minInstallments= 4;
                    }
                    if (createSIPVm.frequency.toLowerCase() == constantConfig.mfAndsecConst.monthly) {
                        createSIPVm.minQuarterlyAmount = createSIPVm.sipMinAmtMthly;
                        createSIPVm.minInstallments = 12;
                    }
                    createSIPVm.changeFrequency();
	            }, function(error) {
	                utilityService.showErrorMessage(error.responseMessage);
	            });
	        }

	        /**
	         * Fetch get Pancard From server
	         * @param {id}
	         */
	        createSIPVm.getPanCard = function() {
	            var reqParams = {};
	            reqParams['id'] = '';
	            mutualFundsService.getPanCardNumber(reqParams).then(function(data) {
	                createSIPVm.panCard = data.mfKyc.panNo.toUpperCase();
	                createSIPVm.divPayOutMechanism = data.mfKyc.divPayOutMechanism;
	                createSIPVm.redPayOutMechanism = data.mfKyc.redPayOutMechanism;
	                createSIPVm.mfkyc = data.mfKyc;
	            }, function(error) {
	                utilityService.showErrorMessage(error.responseMessage);

	            });
	        }

	        /**
	         * Check Eligible dates
	         */
	        createSIPVm.checkDate = function() {
	            createSIPVm.endDate = '';
	            var currentDate = new Date();
	            $translate('SAME_DATE_SIP_ERROR_MESG').then(function(transValue) {
	                createSIPVm.dateErrorMessage = transValue;
	            });
	            $timeout(function() {
	                createSIPVm.SIPMonthObj = '';
	                if (currentDate.getDate() == createSIPVm.SIPDate) {
	                    createSIPVm.SuccessPop = $ionicPopup.show({
	                        template: '<p>' + createSIPVm.dateErrorMessage + '</p>',
	                        title: '',
	                        cssClass: 'dialog',
	                        scope: $scope,
	                        buttons: [{
	                            text: 'Change',
	                            type: 'button-positive',
	                            onTap: function(e) {
	                                createSIPVm.SuccessPop.close(); //close the popup after 1 seconds 
	                                createSIPVm.disableDate = 1;
	                                e.preventDefault();
	                            }
	                        }, {
	                            text: 'OK',
	                            type: 'button-positive',
	                            onTap: function(e) {
	                                createSIPVm.SuccessPop.close(); //close the popup after 1 seconds 
	                                createSIPVm.disableDate = 1;
	                                e.preventDefault();
	                            }
	                        }]
	                    });

	                    if (createSIPVm.disableDate == 1) {
	                        if (currentDate.getMonth() == 11) { //Dec 30 == 30 current date
	                            createSIPVm.SIPYear = currentDate.getFullYear() + 1;
	                            createSIPVm.SIPMonth = createSIPVm.getMonthName(0);

	                        } else {
	                            createSIPVm.SIPYear = currentDate.getFullYear();
	                            createSIPVm.SIPMonth = createSIPVm.getMonthName(currentDate.getMonth() + 1);
	                        }
	                    }

	                } else if (createSIPVm.SIPDate == "0") {
	                    createSIPVm.SIPYear = '';
	                    createSIPVm.SIPMonth = '';
	                } else if ((currentDate.getDate()) < createSIPVm.SIPDate) {

	                    if (currentDate.getMonth() == 1 && createSIPVm.SIPDate.trim() == "30") {
	                        createSIPVm.SIPYear = currentDate.getFullYear();
	                        createSIPVm.SIPMonth = createSIPVm.getMonthName(currentDate.getMonth() + 1);
	                    } else {
	                        createSIPVm.SIPMonth = createSIPVm.getMonthName(currentDate.getMonth());
	                        createSIPVm.SIPYear = currentDate.getFullYear();
	                    }
	                } else if ((currentDate.getDate()) > createSIPVm.SIPDate) {
	                    if (currentDate.getMonth() == 11) {
	                        createSIPVm.SIPYear = currentDate.getFullYear() + 1;
	                        createSIPVm.SIPMonth = createSIPVm.getMonthName(0);
	                    } else {
	                        createSIPVm.SIPYear = currentDate.getFullYear();
	                        createSIPVm.SIPMonth = createSIPVm.getMonthName(currentDate.getMonth() + 1);
	                    }
	                }

	            }, 500);
	        }
	        createSIPVm.getMonthName = function(month) {
	            var monthArray = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sept", "Oct", "Nov", "Dec"];
	            return monthArray[month];
	        }

	        /**
	         *Function to set min amount  
	         **/
	        createSIPVm.checkMinAmount = function() {

	            if (createSIPVm.frequency.toLowerCase() == constantConfig.mfAndsecConst.quarterly) {
	                createSIPVm.minQuarterlyAmount = createSIPVm.sipMinAmtQuarter;
	            }
	            if (createSIPVm.frequency.toLowerCase() == constantConfig.mfAndsecConst.monthly) {
	                createSIPVm.minQuarterlyAmount = createSIPVm.sipMinAmtMthly;
	            }

	            if (createSIPVm.minQuarterlyAmount) {
	                $scope.minAmount = parseFloat(createSIPVm.minQuarterlyAmount.replace(",", ''));
	            } else {
	                $scope.minAmount = parseFloat(createSIPVm.minQuarterlyAmount);
	            }
	            $scope.maxAmount = parseFloat(createSIPVm.maxAmount);
	            $scope.enteredAmount = parseFloat(createSIPVm.amount);


	            for (var i = 0; i < createSIPVm.accounts.length; i++) {
					if(createSIPVm.accounts[i].benAccntNo == createSIPVm.savingAccounts){
						//lumpsumVm.savingAccounts=lumpsumVm.mfkyc.aofAccountNo;
						createSIPVm.selectedAccountAmount= createSIPVm.accounts[i].balance;
						if(parseInt(createSIPVm.selectedAccountAmount)>0){
						if($scope.enteredAmount > parseInt(createSIPVm.selectedAccountAmount)) {
							createSIPVm.sufficiantBalance=false;
						}else{
							createSIPVm.sufficiantBalance=true;
							createSIPVm.maxAmountFlag=true;
						}
					  }else{
					  	createSIPVm.sufficiantBalance=true;
					  	createSIPVm.maxAmountFlag=true;
					  }
					}
				}

				 if ($scope.minAmount > $scope.enteredAmount) {
	                createSIPVm.minAmountFlag = false;
	                createSIPVm.maxAmountFlag = true;
	            } else if ($scope.maxAmount < $scope.enteredAmount) {
	                createSIPVm.maxAmountFlag = false;
	                createSIPVm.minAmountFlag = true;
	            } else {
	                createSIPVm.maxAmountFlag = true;
	                createSIPVm.minAmountFlag = true;
	            }
	        }
	        /**
	         *Function to set Installment ,min amount
	         **/
	        createSIPVm.changeFrequency = function() {
	            createSIPVm.checkMinAmount();
			    if (createSIPVm.endDate) {
			    	createSIPVm.startDate=$filter('date')(new Date(createSIPVm.SIPDate+" "+createSIPVm.SIPMonth+" "+createSIPVm.SIPYear), 'dd MMM yyyy');
					createSIPVm.sDate=new Date(createSIPVm.startDate);
	        
	                createSIPVm.noOfYearDiffernce = (new Date(createSIPVm.endDate).getFullYear()-createSIPVm.sDate.getFullYear())*12;
	                createSIPVm.noOfYearDiffernce -= createSIPVm.sDate.getMonth()+1;
	                createSIPVm.noOfYearDiffernce += new Date(createSIPVm.endDate).getMonth();
	                createSIPVm.noOfMonths = createSIPVm.noOfYearDiffernce;
	                createSIPVm.noOfMonths= createSIPVm.noOfMonths <= 0?0: createSIPVm.noOfMonths;
			    	if (createSIPVm.noOfMonths>=1) {
			    		createSIPVm.noOfMonths= createSIPVm.noOfMonths+2;
			    	}else{
			    		createSIPVm.noOfMonths= createSIPVm.noOfMonths+1;
			    	}
	                if (createSIPVm.frequency.toLowerCase() == constantConfig.mfAndsecConst.quarterly) {
	                    createSIPVm.noOfInstallment = ((createSIPVm.noOfMonths/3)+1);
	                    createSIPVm.noOfInstallment = Math.round(createSIPVm.noOfInstallment);
	                    createSIPVm.minInstallments= parseFloat(constantConfig.mfAndsecConst.minInstallments4);
	                    if(createSIPVm.noOfInstallment < createSIPVm.minInstallments){
							utilityService.showErrorMessage(constantConfig.mfAndsecConst.sip4QtrError);
			    		}
	                }
	                if (createSIPVm.frequency.toLowerCase() == constantConfig.mfAndsecConst.monthly) {	                	
	                    createSIPVm.noOfInstallment = createSIPVm.noOfMonths;
	                    // CHANGE THE MONTH BASED ON SELECTED FREQUENCY
	                    createSIPVm.minInstallments= parseFloat(constantConfig.mfAndsecConst.minInstallments12);
						if(createSIPVm.noOfInstallment < createSIPVm.minInstallments){
							utilityService.showErrorMessage(constantConfig.mfAndsecConst.sip12MonthsError);
						}
	                }
			    }
	        }

	        /***Function to openDatePicker***/
	        createSIPVm.endDatePicker = function() {
	        	var date=createSIPVm.SIPDate+"-"+createSIPVm.SIPMonth+"-"+createSIPVm.SIPYear;
	            if (!createSIPVm.endDate) {
	                createSIPVm.endDatePickerDiv.inputDate = new Date(date.replace(/\s+/g, ''));
	                createSIPVm.endDatePickerDiv.from = new Date(date.replace(/\s+/g, ''));
	            } else {
	                createSIPVm.endDatePickerDiv.inputDate = new Date(createSIPVm.endDate);
	                createSIPVm.endDatePickerDiv.from = new Date(date.replace(/\s+/g, ''));
	            }
	            ionicDatePicker.openDatePicker(createSIPVm.endDatePickerDiv);

	        };
	        createSIPVm.endDatePickerDiv = {
	            callback: function(val) {
	            	var date = $filter('date')(new Date(val), 'dd MMM yyyy');
					var filterDate=date.split(' ');
					createSIPVm.endDate= new Date(createSIPVm.SIPDate+" "+filterDate[1]+" "+filterDate[2]);
			
					createSIPVm.startDate=$filter('date')(new Date(createSIPVm.SIPDate+" "+createSIPVm.SIPMonth+" "+createSIPVm.SIPYear), 'dd MMM yyyy');
					createSIPVm.sDate=new Date(createSIPVm.startDate);
	                createSIPVm.noOfYearDiffernce = (new Date(createSIPVm.endDate).getFullYear() - createSIPVm.sDate.getFullYear()) * 12;
	                createSIPVm.noOfYearDiffernce -= createSIPVm.sDate.getMonth() + 1;
	                createSIPVm.noOfYearDiffernce += new Date(createSIPVm.endDate).getMonth();
	                createSIPVm.noOfMonths = createSIPVm.noOfYearDiffernce;
	                createSIPVm.noOfMonths= createSIPVm.noOfMonths <= 0?0: createSIPVm.noOfMonths;
					if (createSIPVm.noOfMonths>=1) {
			    		createSIPVm.noOfMonths= createSIPVm.noOfMonths+2;
			    	}else{
			    		createSIPVm.noOfMonths= createSIPVm.noOfMonths+1;
			    	}
	                if (createSIPVm.frequency.toLowerCase() == constantConfig.mfAndsecConst.quarterly) {
	                    createSIPVm.noOfInstallment = (Math.round(createSIPVm.noOfMonths/3)+1);
	                    createSIPVm.minInstallments= parseFloat(constantConfig.mfAndsecConst.minInstallments4);
	                    if(createSIPVm.noOfInstallment < createSIPVm.minInstallments){
							utilityService.showErrorMessage(constantConfig.mfAndsecConst.sip4QtrError);
			    		}
	                }
	                if (createSIPVm.frequency.toLowerCase() == constantConfig.mfAndsecConst.monthly) {
	                    createSIPVm.noOfInstallment = createSIPVm.noOfMonths;
	                    // CHANGE THE MONTH BASED ON SELECTED FREQUENCY
	                   createSIPVm.minInstallments= parseFloat(constantConfig.mfAndsecConst.minInstallments12);
						if(createSIPVm.noOfInstallment < createSIPVm.minInstallments){
							utilityService.showErrorMessage(constantConfig.mfAndsecConst.sip12MonthsError);
						}
	                }
	            },
	            dateFormat: 'dd MMM yyyy',
	            closeOnSelect: false,
	            templateType: 'popup'

	        };

	        /***Function to show information POP UP***/
	        createSIPVm.showInformationPopup = function() {
	            var infoPopup = $ionicPopup.show({
	                template: '<p>Message</p>',
	                title: 'Information',
	                scope: $scope,
	                buttons: [{ text: 'Ok' }]
	            });

	            infoPopup.then(function(res) {

	            });
	        }

	         /***Function to show information POP UP***/
	        createSIPVm.showInformationPopupRef= function() {
	        	var infoPopup = $ionicPopup.show({
					template: '<p>'+createSIPVm.refCodeContentMessage+'</p>',
					title:'Information',
					scope: $scope,
					cssClass: 'dialog',		
					buttons: [
		            {
		               text: 'Ok'
		            }
					]
				});

	            
	        }
		/***Function to show alert POP UP***/
			createSIPVm.showErrorInformationPopup=function(message){
				var infoPopup = $ionicPopup.show({
					template: '<p>'+message+'</p>',
					title:'Alert',
					cssClass: 'dialog',		
					scope: $scope,
					buttons: [ {
						text: 'Ok',
						onTap: function(e) {
							$state.go('menu.accountOverviewMyBalance');
						}
					}]
				});
			}

	        /***Click Function to pass data to service Start***/

	        createSIPVm.submitSIP = function() {
	        	var reqParams = {};
	            var requestSecKey = '';

	        	 angular.forEach(mutualFundsService.multiFolio.portFolio, function (value, key) {
                        if (value.isLotusfolio.toLowerCase() == "yes") {
                            createSIPVm.isLotusFolio=value.isLotusfolio;
                            createSIPVm.isLotusFolioNumber=value.folioNumber;
								if(value.fundList!=null || value.fundList!=undefined){
                            if(value.fundList.length>0){
                            if(value.fundList[0].amfiCode==createSIPVm.fundId){
                            	createSIPVm.SIPType = constantConfig.mfAndsecConst.SIPAdditional;
                            	reqParams["txnType"] = constantConfig.mfAndsecConst.SIPAdditional;
                            }
                          }
						}
                        }
                    });
	        	
	            
	            if (!createSIPVm.isTermsAndConditionChecked) {
	                return false;
	            }
	            if (createSIPVm.folio && createSIPVm.isLotusFolio) {
	            	if(createSIPVm.SIPType == undefined || createSIPVm.SIPType == null || createSIPVm.SIPType == ''){
	               		 reqParams["txnType"] = constantConfig.mfAndsecConst.SIPFresh;
	            	}
	            } else {
	            	if(createSIPVm.SIPType =='' || createSIPVm.SIPType == undefined || createSIPVm.SIPType == null){
	            		reqParams["txnType"] = constantConfig.mfAndsecConst.SIPFresh;
	            	}
	               // reqParams["txnType"] = constantConfig.mfAndsecConst.SIPFresh;
	            }

	            createSIPVm.txnId = utilityService.getRandomNumber();
	            clickStreamService.clickStreamData = createSIPVm.txnId;
	             var requestDate = new Date();
			    requestDate = requestDate.getTime()
			    requestSecKey=Math.floor((Math.random()) + requestDate);
			    requestSecKey = (requestSecKey * 10 + 1);

	            reqParams["schemeId"] = createSIPVm.schemeCode;
	            reqParams["schemeName"] = createSIPVm.fundDetailList.fundName;
	            reqParams["schemePlan"] = createSIPVm.plan;
	            reqParams["schemeOption"] = createSIPVm.option;
	            reqParams["transactionType"] = createSIPVm.transactionType;
	            reqParams["startDate"] = $filter('date')(new Date(createSIPVm.startDate), 'dd/MM/yyyy');
	            reqParams["endDate"] = $filter('date')(new Date(createSIPVm.endDate), 'dd/MM/yyyy');
	            reqParams["amount"] = createSIPVm.amount;
	            reqParams["units"] = "";
	            reqParams["accountNo"] = createSIPVm.savingAccounts;
	            reqParams["frequency"] = createSIPVm.frequency;
	            reqParams["isPerpetual"] = createSIPVm.perpetualCheck;
	            reqParams["amcCode"] = createSIPVm.amcCode
	            reqParams["folioNo"] = createSIPVm.folio;
	            reqParams["txnDate"] = "";
	            reqParams["txnTime"] = "";
	            reqParams["sipRegisteredDate"] = "";
	            reqParams["numberOfInstallments"] = createSIPVm.noOfInstallment;
				 reqParams["euin"] = createSIPVm.refCode;
	            reqParams["installmentNumber"] = "";
	            reqParams["bankName"] = "";
	            reqParams["bankCode"] = "";
	            reqParams["bankCity"] = "";
	            reqParams["accountType"] = "";
	            reqParams["panNo"] = createSIPVm.panCard;
	            reqParams["customerTermandCondition"] = createSIPVm.isTermsAndConditionChecked;
	            reqParams["branchName"] = "";
	            reqParams["targetSchemeId"] = '';
	            reqParams["targetSchemeName"] = '';
	            reqParams["targetSchemePlan"] = '';
	            reqParams["targetSchemeOption"] = '';
	            reqParams["dividendOption"] = createSIPVm.dividendOption;
	            reqParams["divPayoutMechanism"] = createSIPVm.divPayOutMechanism;
	            reqParams["redPayoutMechanism"] = createSIPVm.redPayOutMechanism;
	            reqParams["txnId"] = createSIPVm.txnId;
	            reqParams["amfiCode"] = createSIPVm.fundId;
	            reqParams["closeAc"]='';
	            reqParams["secKey"] = requestSecKey;
	            
	               $rootScope.fundName=createSIPVm.fundDetailList.fundName;
	               $rootScope.unitName=constantConfig.mfAndsecConst.amount;
	               $rootScope.amountToPay=createSIPVm.amount;
	            mutualFundsService.addInvedtedAmount(createSIPVm.amount); //for OTP page showing
	            mutualFundsService.payDuesRequest(reqParams).then(function(data) {
					$rootScope.sipotpPage=1;
	            	$rootScope.lumsumotpPage=0;
	            	$rootScope.swpotpPage=0;
	            	$rootScope.stpotpPage=0;
	            	$rootScope.redeemotpPage=0;
	            	$rootScope.cancelotpPage=0;
	            	$rootScope.switchotpPage=0;
	                if (data.submitRequest.isOTPRequired == "true") {
	                	 $rootScope.amount=mutualFundsService.getInvedtedAmount(); 
	                    $state.go('menu.sipOTP');
	                } else {
	                    var calCulatedKey = mutualFundsService.verifySecKey(parseInt(data.submitRequest.secKey));
	                    if (requestSecKey == calCulatedKey) {
	                        createSIPVm.message = data.submitRequest.status;
	                        createSIPVm.transactionReferenceNo = data.submitRequest.transactionReferenceNo;	                        
	                            createSIPVm.createSIPPage = 0;
	                            createSIPVm.successPage = 1;
	                            createSIPVm.reviewPage = 0;
	                            createSIPVm.amount = $rootScope.amountToPay;
	                             createSIPVm.transactionDate = new Date(data.submitRequest.transactionDate);
	                            utilityService.setCsatJournies("mutualFunds");	                        
	                    }
	                }
	            }, function(error) {
	                utilityService.showErrorMessage(error.responseMessage);
	            });
	        }

	        $scope.validateOTP = function() {
	            var reqParams = {};
	           	 var requestSecKey = '';
	            var requestDate = new Date();
		    	requestDate = requestDate.getTime();
		   		requestSecKey=Math.floor((Math.random()) + requestDate);
	            requestSecKey = (requestSecKey * 10 + 1);


	            reqParams.otp = $scope.enterOTP;
	            reqParams.secKey = requestSecKey;
	            mutualFundsService.validateOTPForPayment(reqParams).then(function(data) {
	                if (data.data.otpStatus == "0000") {
	                    var calculatedKey = mutualFundsService.verifySecKey(parseInt(data.data.secKey));
	                    if (requestSecKey == calculatedKey) {
							 getAccountDetailsService.accountOverviewData="";
	                    	 $rootScope.sipSuccessPage = 1;
	                    	 $rootScope.redeemSuccessPage=0;
	                 	 $rootScope.swpSuccessPage=0;
	                 	 $rootScope.switchSuccessPage=0;
	                 	 $rootScope.stpSuccessPage=0;
	                 	 $rootScope.lumsumSuccessPage=0;		                 		
	                 	 $rootScope.cancelSuccessPage=0;
	                    	$rootScope.transactionReferenceNo = data.data.transactionReferenceNo;
	                        $rootScope.fundName =  $rootScope.fundName;	                      
	                        $rootScope.transactionDate = new Date(data.data.transactionDate);
	                        utilityService.setCsatJournies("mutualFunds");
	                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("MF_INVTACCTFORM_MF_END_NXT_BTN"));              
	                        $state.go('menu.sipPaymentSuccess');
	                    }
	                } else if (data.data.otpStatus != "0000") {
	                	mutualFundsService.clearOTP();
	                    $scope.errorMessage = data.responseMessage;
	                } else {	                   
	                      createSIPVm.showErrorInformationPopup(error.responseMessage);
	                }
	            },function(error){
	            	//utilityService.showErrorMessage(error.responseMessage);
	            	 //$state.go('menu.accountOverviewMyBalance');
	            	 createSIPVm.showErrorInformationPopup(error.responseMessage);
	            })

	        }

	        $scope.resendOTP = function() {
	            $scope.enterOTP = "";
	            var reqParams = {};
	            reqParams.id = "";
	            reqParams.emailId = "";
	            mutualFundsService.getOTPTokenSecure(reqParams).then(function(data) {
	                $rootScope.clickCount++;
	                $scope.mutualFundEnterOTPForm = {};
	                if ($rootScope.clickCount == 2) {
	                    $scope.disableLink = true;
	                }
	            })
	        }



	        //****Submit button on OTP Page***//
	        $scope.validateOTPNext = function() {
	            $scope.enterOTP = document.getElementById('txt_otp').value;
	            if (validateForm()) {
	                $scope.validateOTP();
	            }
	        }




	        function validateForm() {
	            $scope.mutualFundEnterOTPForm = {};
	            if (mutualFundsService.isValidOTPNum($scope.enterOTP)) {
	                $scope.errorMessage = mutualFundsService.isValidOTPNum($scope.mutualFundEnterOTPForm.enterOTP);
	            }
	            return (angular.equals({}, $scope.mutualFundEnterOTPForm)) ? true : false;
	        }	       
	        /*** Click Function to pass data to service end***/

	        createSIPVm.openReviewPage = function() {
	            if (createSIPVm.minAmountFlag && createSIPVm.maxAmountFlag) {
	                if (createSIPVm.perpetualCheck) {
	                    createSIPVm.endDate = $filter('date')(new Date(constantConfig.mfAndsecConst.perpetualDate), 'dd MMM yyyy');;
	                    createSIPVm.startDate = $filter('date')(new Date(createSIPVm.SIPDate + " " + createSIPVm.SIPMonth + " " + createSIPVm.SIPYear), 'dd MMM yyyy');
	                    createSIPVm.sDate = new Date(createSIPVm.SIPDate + "-" + createSIPVm.SIPMonth + "-" + createSIPVm.SIPYear);
	                    createSIPVm.noOfYearDiffernce = (new Date(createSIPVm.endDate).getFullYear() - createSIPVm.sDate.getFullYear()) * 12;
	                    createSIPVm.noOfYearDiffernce -= createSIPVm.sDate.getMonth() + 1;
	                    createSIPVm.noOfYearDiffernce += (new Date(createSIPVm.endDate).getMonth() + 1);
	                    createSIPVm.noOfMonths = createSIPVm.noOfYearDiffernce;
	                    if (createSIPVm.frequency.toLowerCase() == constantConfig.mfAndsecConst.quarterly) {
	                        createSIPVm.noOfInstallment = Math.round(createSIPVm.noOfMonths / 3);
	                    }
	                    if (createSIPVm.frequency.toLowerCase() == constantConfig.mfAndsecConst.monthly) {
	                        createSIPVm.noOfInstallment = Math.round(createSIPVm.noOfMonths);
	                    }
	                }
	                createSIPVm.isTermsAndConditionChecked = 0;
	                createSIPVm.createSIPPage = 0;
	                createSIPVm.successPage = 0;
	                createSIPVm.reviewPage = 1;
	            }
	        }

	        /***Start term and Condition***/
	        createSIPVm.termsAndConditions = function() {
	            if (createSIPVm.termsAndConditionsFlag == 1) {
	                createSIPVm.termsAndConditionsFlag = 0;
	            } else {
	                /** Call service to fetch termsConditionsMessage**/
	                createSIPVm.reqParams = {};
	                createSIPVm.reqParams['action'] = constantConfig.mfAndsecConst.sysInvestPlanTermsAndC;
	                mutualFundsService.getTermsAndConditions(createSIPVm.reqParams).then(function(data) {
	                    createSIPVm.termsAndConditionsMessage = data.message;

	                }, function(error) {
	                    utilityService.showErrorMessage(error.responseMessage);
	                });
	                createSIPVm.termsAndConditionsFlag = 1;
	            }
	        }
	        /***BACK tO page***/
	        createSIPVm.backPage = function() {
	            createSIPVm.createSIPPage = 1;
	            createSIPVm.reviewPage = 0;
	            createSIPVm.successPage = 0;
	        }

	        createSIPVm.setEndDate = function() {
	            if (createSIPVm.perpetualCheck) {
	                createSIPVm.endDate =constantConfig.mfAndsecConst.perpetualDate;
	                
	            } else {
	                createSIPVm.endDate = "";
	            }

	        }

	        /***Function to go to Type of investment page***/
	        $scope.closePage = function() {
	            $state.go("menu.portfolio");
	        }
	        $scope.portfolio = function() {
	            $state.go("menu.portfolio");
	        }

	        /*** actions to done everytime the view is shown***/
	        $scope.$on('$ionicView.beforeEnter', function() {
	            initPage();

	        });



	        return this;
	    }
	]);