/*******EKYC Controller ******/

'use strict';

angularApp.controller('eKYCController', 
						["$timeout",
						 "$state",
						 "$scope",
						 "$ionicPopup",
						 "$translate",
						 "$location",
						 "$ionicScrollDelegate","mutualFundsService","constantConfig","$rootScope","openUrlInAppbroswerService","utilityService","clickStreamService","$ionicHistory",
				 
function ($timeout,
		 $state,
		 $scope,
		 $ionicPopup,
		 $translate,
		 $location,
		 $ionicScrollDelegate,mutualFundsService,constantConfig,$rootScope,openUrlInAppbroswerService,utilityService,clickStreamService,$ionicHistory) {
	
	var eKYCVm = this;
	
	/*** Initialize the variables that has to show in  the HTML come here ***/
	
	function initPage(){
	    $scope.currentDate = new Date();
		eKYCVm.eKYCRegistration=0;
		eKYCVm.eKYCTerms=1;
		eKYCVm.ekycTermsAndConditionsFlag=0;
		eKYCVm.showDisclaimer();
		eKYCVm.getServerUrl();
		//KYCVm.ckycNumber=$rootScope.ckycNumber;
	}
	
	/**
	*Fetch Disclaimer of eKYC 
	@params {action:'ekycRegister'}
	**/
	eKYCVm.showDisclaimer=function(){
		//Call service to fetch termsConditionsMessage
		eKYCVm.reqParams={};
		eKYCVm.reqParams['action']=constantConfig.mfAndsecConst.ekycRegister;
		mutualFundsService.getTermsAndConditions(eKYCVm.reqParams).then(function(data) {
			eKYCVm.ekycDisclaimer=data.message;
			
		}, function(error) {
			utilityService.showErrorMessage(error.responseMessage);
		});
	}
	
	/***Function to show Redirection text***/
	
	eKYCVm.goToRedirectionPage=function(){
		eKYCVm.eKYCRegistration=0;
		eKYCVm.eKYCTerms=1;
	}
	
	eKYCVm.getServerUrl=function(){
		mutualFundsService.getServerUrl().then(function(data){
			eKYCVm.URL=data;
		}, function(error){
			utilityService.showErrorMessage(error.responseMessage);
		});
	}
	/***Function to caLL Trem and condition SERVICE***/
	eKYCVm.showeKYCTermsAndCondition=function(){
		if(eKYCVm.ekycTermsAndConditionsFlag==1){
			eKYCVm.ekycTermsAndConditionsFlag=0;
		}else{
			
			//Call service to fetch termsConditionsMessage
			eKYCVm.reqParams={};
			eKYCVm.reqParams['action']=constantConfig.mfAndsecConst.ekycRegister;
			mutualFundsService.getEkycTermsAndConditions().then(function(data) {
				eKYCVm.ekycTermsAndConditionsMessage=data.message;
				
			}, function(error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
			
			
			
			eKYCVm.ekycTermsAndConditionsFlag=1;
		}
	} 
	


	/***Function to check KYC Status***/
	eKYCVm.eKYCConfirmation=function(formData){
		var pageContent="";
		var pageContentUrl="";
		eKYCVm.sessionId = utilityService.getRandomNumber();
		clickStreamService.clickStreamData=eKYCVm.sessionId;	
		//eKYCVm.kycData =  $rootScope.ekycPan.toUpperCase()+'|'+eKYCVm.emailId+'|'+eKYCVm.mobile+'|sbiApp|'+eKYCVm.URL.camsUserId+'|'+eKYCVm.URL.camsPwd+'|L||sess_id';	
		
		
			var reqPara={};
            reqPara['panId']=$rootScope.ekycPan.toUpperCase();
            mutualFundsService.getEncryptString(reqPara).then(function (data) {
			eKYCVm.encKycData=JSON.parse(data.encryptedString).data.responseString;
		
			 pageContent = '<html><head></head><body><form id="form_Id" enctype="application/x-www-form-urlencoded" name="cbsulogin" action="'+eKYCVm.URL.camsUrl+'" method="POST">' +
			'<input type="hidden" name="url" value="'+eKYCVm.URL.mobileUrl+'">' +
			'<input type="hidden" name="ekyctype" value="I">' +		
			'<input type="hidden" name="kyc_data" value="'+eKYCVm.encKycData+'">'+
			'</form> <script type="text/javascript">document.getElementById("form_Id").submit();</script></body></html>';	

			pageContentUrl = 'data:text/html;base64,' + btoa(pageContent);
			var ref= cordova.ThemeableBrowser.open(pageContentUrl, '_blank', {
				statusbar:{color: '#ffffffff'},
				toolbar: {
					height: 37,
					color: '#ffffffff',
					image: 'share'
				},closeButton: {
					image: 'back',
					height: 37,
					width: 32,
					align: 'left',
					event: 'closePressed'
				},backButtonCanClose: true
			});
		
			ref.addEventListener('loadstart', function(event) {				
				var URL=event.url;
				var n = URL.indexOf("result");
				if(n==-1){
					return;
				}
				if (n) {
					var sessId = '';
					var result=URL.split('?')[1];
					result=result.split("=")[1];
					result=decodeURIComponent(result).toString();
				}
				
				mutualFundsService.getDecryptString(result).then(function(data){
					try{
					var resultData=JSON.parse(data.plainString);
					resultData=resultData.data.responseString.split("|")[2];
					resultData=resultData.replace('&sess_id','');
					eKYCVm.todayDate=$scope.currentDate.setDate($scope.currentDate.getDate());
					eKYCVm.ekycType=JSON.parse(data.plainString).data.responseString.split("|")[0];
				 }catch(e){
				 	ref.close();
				 	KYCVm.showInformationPopup("Internal Error.");
				 }
			
					if(n!=-1){						
						if(eKYCVm.ekycType=='Y' || resultData=='KS100'){						
							eKYCVm.reqParams={
								"mfKyc": {
									"panNo": $rootScope.ekycPan.toUpperCase(),
									"aadharNo": eKYCVm.aadhaarCard,
									"gender": eKYCVm.gender,
									"dob": eKYCVm.dob,
									"ekycStatus":"Submitted",
                                    "aofStatus":"",
                                    "ekycType":eKYCVm.ekycType,
                                    "ekycTimeStamp":eKYCVm.todayDate,
                                    "ekycMaxInvestmentLimit":""
								}
							};			
							utilityService.showSpinner();				
							mutualFundsService.checkKYCStatus(eKYCVm.reqParams).then(function(data) {
								if(data.id){
									var reqParams={};
									reqParams['id']='';
									mutualFundsService.getPanCardNumber(reqParams).then(function(data){
										eKYCVm.getServerUrl();
										eKYCVm.divPayOutMechanism=data.mfKyc.divPayOutMechanism;
										eKYCVm.redPayOutMechanism=data.mfKyc.redPayOutMechanism;
									
										eKYCVm.applicationStatus=data.mfKyc.aofStatus;
										mutualFundsService.addeKycPanDetails(eKYCVm.URL.kycNo);
										
                                            $rootScope.kycCompliant=1;
                                            $rootScope.checkStatusPage=0;
                                            $rootScope.kycNonCompliant=0;
											   utilityService.hideSpinner();
                                            //$state.go('menu.createInvestmentAccount');
                                            $state.go('menu.KYC');
                                        
										
									}, function(error){
										   utilityService.hideSpinner();
										utilityService.showErrorMessage(error.responseMessage);

									});								
								}
							}, function(error) {
								   utilityService.hideSpinner();
								utilityService.showErrorMessage(error.responseMessage);
							});				
						//}				
						
					}else{
						  if(resultData=='EK-100'){
							eKYCVm.showInformationPopup("Internal Error.Retry after some time");
						}else if(resultData=='EK-101'){
							eKYCVm.showInformationPopup("Internal Error.Retry after some time");
						}else if(resultData=='EK-103'){
							eKYCVm.showInformationPopup("Please enter your correct Mobile Number registered with Aadhaar");
						}else if(resultData=='EK-104'){
							eKYCVm.showInformationPopup("eSign failure with eMudhra");
						}else if(resultData=='EK-105'){
							eKYCVm.showInformationPopup("Pan verification failed,please ensure your PAN number is valid");
						}else if(resultData=='EK-106'){
							eKYCVm.showInformationPopup("PAN verification failed,please try after some time");
						}else if(resultData=='EK-107'){
							eKYCVm.showInformationPopup("This Aadhaar number already registered in KYC.Please check your Aadhaar");
						}else if(resultData=='EK-108'){
							eKYCVm.showInformationPopup("Internal Error.Retry after some time");
						}else if(resultData=='EK-109'){
							eKYCVm.showInformationPopup("Internal Error.Retry after some time");
						}else if(resultData=='EK-110'){
							eKYCVm.showInformationPopup("Current Status of KYC for the PAN is not eligible for eKYC.");
						}else if(resultData=='EK-111'){
							eKYCVm.showInformationPopup("Error in verifying Kyc Status.");
						}else if(resultData=='EK-112'){
							eKYCVm.showInformationPopup("Pan verification failed,please ensure your PAN number is valid");
						}else if(resultData=='EK-113'){
							eKYCVm.showInformationPopup("Pan verification failed throw IOP Service");
						}else if(resultData=='EK-114'){
							eKYCVm.showInformationPopup("Please ensure your correct Email Id and Mobile Number registered with Aadhaar");
						}else if(resultData=='EK-116'){
							eKYCVm.showInformationPopup("The mobile number or email id provided is not verified with Aadhaar. Please verify and then continue with eKYC");
						}else if(resultData=='EK-117'){
							eKYCVm.showInformationPopup("Aadhaar number does not have both email id and mobile number registered. Hence eKYC cannot be done");
						}else if(resultData=='EK-123'){
							eKYCVm.showInformationPopup("Ekyc Success SMS alert sending failed");
						}else if(resultData=='EK-124'){
							eKYCVm.showInformationPopup("Please enter valid Aadhaar number");
						}else if(resultData=='EK-125'){
							eKYCVm.showInformationPopup("Aadhaar number field should not be allowed");
						}else if(resultData=='EK-127'){
							eKYCVm.showInformationPopup("Invalid return data structure");
						}else if(resultData=='EK-128'){
							eKYCVm.showInformationPopup("Invalid eKYC Type");
						}else if(resultData=='EK-200'){
							eKYCVm.showInformationPopup("Consent not available.Please provide your Consent for KYC verification.");
						}else if(resultData=='EK-999'){
							eKYCVm.showInformationPopup("Internal Error.Retry after some time");
						}else {
							eKYCVm.showInformationPopup("Internal Error.Retry after some time");
						}
					}
						//navigator.notification.activityStop();
						ref.close();
					}
				},function(error){
					ref.close();
					if(error.responseCode=='0002')
			          utilityService.showErrorMessage(error.responseMessage);
			      else 			      	 
			         utilityService.showErrorMessage(error.responseMessage);
		       })
			});
			ref.addEventListener('loadstop', function(event) {
				//navigator.notification.activityStop();
			});
		},function(error){
			ref.close();
			utilityService.showErrorMessage(error.responseMessage);
		})
			
	} 
	
	eKYCVm.showInformationPopup=function(message){
		var infoPopup = $ionicPopup.show({
			template: '<p>'+message+'</p>',
			title:'Alert',
			cssClass: 'dialog',		
			scope: $scope,
			buttons: [ {
				text: 'Ok',
				onTap: function(e) {
					$state.go('menu.accountOverviewMyBalance');
				}
			}]
		});
	}
	/*** one time initialization to be done when the controller is loaded***/
	$scope.$on('$ionicView.loaded', function() {
	
	});
	
	/*** actions to done everytime the view is shown***/
	$scope.$on('$ionicView.beforeEnter', function() {
		initPage();
	});
	
	 /***any cleanup needs to be done here: executes everytime when page is left***/
	$scope.$on('$ionicView.afterLeave', function() {
		
	
	});
	return this;
}]);

