/******* Goal planning Controller ******/
'use strict';

angularApp.controller('goalPlanningController', 
						["$timeout",
						 "$state",
						 "$scope",
						 "$translate",
						 "$location",
						 "$ionicPopup","mutualFundsService","$filter","utilityService","mPinLoginService",
				 
function ($timeout,
		 $state,
		 $scope,
		 $translate,
		 $location,
		 $ionicPopup,mutualFundsService,$filter,utilityService,mPinLoginService) {
	var goalPlanningVm = this;
	
	/*** Initialize the variables that has to show in  the HTML come here ***/
	function initPage(){
		$scope.isLoggedIn = mPinLoginService.isLoggedIn;
		goalPlanningVm.goalPlanningDiv1=1;
		goalPlanningVm.pageVal=1;
		goalPlanningVm.goalPlanningDiv2=0;
		goalPlanningVm.goalPlanningDiv3=0;
		goalPlanningVm.goalPlanningDiv4=0;
		goalPlanningVm.corpus="";
		goalPlanningVm.savedAmount="";
		goalPlanningVm.minAmountFlag=true;
		goalPlanningVm.yearError=true;
		$scope.isLoggedIn = mPinLoginService.isLoggedIn;
		goalPlanningVm.getGoalPlanningList();
	}
	
	/** Function to call get goalplan list**/
	
	goalPlanningVm.getGoalPlanningList=function(){
		if($scope.isLoggedIn){
			 mutualFundsService.getGoalPlanList().then(function(data){
			 goalPlanningVm.goalPlanList=data.goals;
			}, function(error){
					utilityService.showErrorMessage(error.responseMessage);
			});
		}else{
			mutualFundsService.getGoalPlanListPre().then(function(data){
			 goalPlanningVm.goalPlanList=data.goals;
			}, function(error){
					utilityService.showErrorMessage(error.responseMessage);
			});
		}
		
	}	
	
	/*** Function to go to Mutual Funds List Page  ***/
	
		goalPlanningVm.goToHome=function(){
			if($scope.isLoggedIn){
			$state.go('menu.mutualFunds');
			}else{
			$state.go('menu.leadGenerationInvestment');
			}
		}
	
		
	

	
	/**
	Function to call inflation rate,2nds page
	@param:{goalId}
	
	**/
	goalPlanningVm.goalPlan2ndPage=function (labelName,optionId){
		goalPlanningVm.label=labelName;
		goalPlanningVm.selectYear='';
		goalPlanningVm.corpus='';
		goalPlanningVm.savedAmount='';
		
		var reqParams={};
		reqParams['goalId']=optionId;

		if($scope.isLoggedIn){
				mutualFundsService.getGoalPlan(reqParams).then(function(data){
				goalPlanningVm.inflation=data.inflationRate;
				goalPlanningVm.inflation=$filter('INRFLOAT')(goalPlanningVm.inflation,2);
				goalPlanningVm.goalPlanningDiv1=0;
				goalPlanningVm.goalPlanningDiv2=1;		
				goalPlanningVm.pageVal=2;
			}, function(error){
				utilityService.showErrorMessage(error.responseMessage);
			});
		}else{
			mutualFundsService.getGoalPlanPre(reqParams).then(function(data){
				goalPlanningVm.inflation=data.inflationRate;
				goalPlanningVm.inflation=$filter('INRFLOAT')(goalPlanningVm.inflation,2);
				goalPlanningVm.goalPlanningDiv1=0;
				goalPlanningVm.goalPlanningDiv2=1;		
				goalPlanningVm.pageVal=2;
			}, function(error){
				utilityService.showErrorMessage(error.responseMessage);
			});
		}
		
	
	}
	
	/*** Function to show goalPlan 3rd Page  ***/
	/*** Function to get Suggested allocation starts***/
	goalPlanningVm.goalPlan3rdPage=function (formData){
	
		var reqParams={};
		reqParams['goalYear']=goalPlanningVm.selectYear;
		reqParams['corpusAmount']=goalPlanningVm.corpus.replace(/[\,]/g, '');;
		reqParams['savedAmount']=goalPlanningVm.savedAmount.replace(/[\,]/g, '');;
		reqParams['inflationRate']=goalPlanningVm.inflation;
		if($scope.isLoggedIn){
			mutualFundsService.getSuggestion(reqParams).then(function(data){
			goalPlanningVm.goalDetails=data.goalDetails;
			if(parseFloat(goalPlanningVm.goalDetails.yearlyAmount)>0){
				goalPlanningVm.goalPlanningDiv2=0;
				goalPlanningVm.goalPlanningDiv3=1;
				goalPlanningVm.pageVal=3;
			}else{
					$ionicPopup.show({
						template: '<p translate="ENOUGH_INVESTMENT"> </p>',
						title:'Alert',
						cssClass: 'dialog',		
						scope: $scope,
						buttons: [ {text: 'Ok'}]
					});
				}		
		
			}, function(error){
				utilityService.showErrorMessage(error.responseMessage);

			});
		}else{
			mutualFundsService.getSuggestionPre(reqParams).then(function(data){
			goalPlanningVm.goalDetails=data.goalDetails;
			if(parseFloat(goalPlanningVm.goalDetails.yearlyAmount)>0){
				goalPlanningVm.goalPlanningDiv2=0;
				goalPlanningVm.goalPlanningDiv3=1;
				goalPlanningVm.pageVal=3;
			}else{
					$ionicPopup.show({
						template: '<p translate="ENOUGH_INVESTMENT"> </p>',
						title:'Alert',
						cssClass: 'dialog',		
						scope: $scope,
						buttons: [ {text: 'Ok'}]
					});
				}		
		
			}, function(error){
				utilityService.showErrorMessage(error.responseMessage);

			});
		}
	}
	/*** Function to get Suggested allocation ends ***/	
	/*** Function to show goalPlan 3rd Page ends ***/
	
	/*** Function to show goalPlan 4th Page  ***/
	goalPlanningVm.goalPlan4thPage=function (){
		goalPlanningVm.goalPlanningDiv3=0;
		goalPlanningVm.goalPlanningDiv4=1;
		goalPlanningVm.pageVal=4;
		goalPlanningVm.labelArray = [];
		goalPlanningVm.dataArray = [];
		goalPlanningVm.colorSetArray = ["#848f9b", "#9369a8", "#4cb5e5", "#e28572", "#e9b964" ,"#0095da", "#33aae1", "#66bfe9", "#99d5f0"]; //Set of colors
		goalPlanningVm.colorArray = [];
		// PASS SUGGESTED FUND IN SERVICE TO USE IT LATER
		mutualFundsService.addRiskProfile(goalPlanningVm.goalDetails.suggestedFunds);
		var suggestedFundsLength = goalPlanningVm.goalDetails.suggestedFunds.length;
		for (var list = 0; list < suggestedFundsLength; list++) {
			goalPlanningVm.colorArray.push(goalPlanningVm.colorSetArray[list]);
			goalPlanningVm.labelArray.push( goalPlanningVm.goalDetails.suggestedFunds[list].fundName+ "  " +$filter('INRFLOAT')(goalPlanningVm.goalDetails.suggestedFunds[list].fundPercentage, 2)+ "%" );
			goalPlanningVm.dataArray.push($filter('INRFLOAT')(goalPlanningVm.goalDetails.suggestedFunds[list].fundPercentage, 2));
		}
		$timeout(function() {
		var suggestionChart = document.getElementById("suggestionChart");
		var suggestionC = new Chart(suggestionChart, {
			type: 'doughnut',
			data: {
				labels: goalPlanningVm.labelArray,
					datasets: [{
						data: goalPlanningVm.dataArray,
						backgroundColor: goalPlanningVm.colorArray
					}]
			},
			options: {
				tooltips: {
					enabled: false	
				},
				legend: {					 
					display: false 
				},
				animation: {
					animateScale: true,
					animateRotate: true
				},
				cutoutPercentage : 70
			}
		});		
		document.getElementById('js-legend').innerHTML = suggestionC.generateLegend();
	 }, 800);
	}
	
	/*** Function to go to mutual fund list Page  ***/
	goalPlanningVm.mutualFundsList=function(){
		//Call service to fetch funds list
		if($scope.isLoggedIn){
			mutualFundsService.getAllMutualFunds().then(function(data) {
			mutualFundsService.addFundList(data.fundList);
			$state.go('menu.mutualFundsList');
			}, function(error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		}else{
			mutualFundsService.getAllMutualFundsPreLogin().then(function(data) {
			mutualFundsService.addFundList(data.fundList);
			$state.go('menu.mutualFundsList');
			}, function(error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		}
	}
	goalPlanningVm.goBack=function (currentPageNo){
		goalPlanningVm.savedAmount=$filter('INRFLOAT')(goalPlanningVm.savedAmount,2);
		goalPlanningVm.corpus=$filter('INRFLOAT')(goalPlanningVm.corpus,2);
		if(currentPageNo==2){	
			goalPlanningVm.goalPlanningDiv1=1;
			goalPlanningVm.goalPlanningDiv2=0;
			goalPlanningVm.pageVal=1;
		}
		if(currentPageNo==3){	
			goalPlanningVm.goalPlanningDiv2=1;
			goalPlanningVm.goalPlanningDiv3=0;
			goalPlanningVm.pageVal=2;
		}
		if(currentPageNo==4){	
			goalPlanningVm.goalPlanningDiv3=1;
			goalPlanningVm.goalPlanningDiv4=0;
			goalPlanningVm.pageVal=3;
			var ctx = document.getElementById("myChart");
			ctx.destroy();
		}
	
	}
	
	goalPlanningVm.goToRiskProfile=function (){
		$state.go('menu.riskProfileQA');
	}
	/**
	*Function to checkYear 
	**/
	goalPlanningVm.checkYear=function (){
		if(goalPlanningVm.selectYear=="00" || goalPlanningVm.selectYear=="0"){
			goalFormSubmit.$invalid=true;
			goalPlanningVm.yearError=false;
		}else{
			goalPlanningVm.yearError=true;
		}
	} 
	/**
	*Function to checkMinAmount 
	**/
	goalPlanningVm.checkMinAmount=function(){
		$scope.corpusAmount=parseFloat(goalPlanningVm.corpus.replace(",",''));
		$scope.enteredAmount=parseFloat(goalPlanningVm.savedAmount.replace(",",''));
		
		
		if($scope.corpusAmount<$scope.enteredAmount){
			goalPlanningVm.minAmountFlag=false;
		}else{
			goalPlanningVm.minAmountFlag=true;
		}
	}
	/*** one time initialization to be done when the controller is loaded***/
	$scope.$on('$ionicView.loaded', function() {
		
	});
	
	/*** actions to done everytime the view is shown***/	
	$scope.$on('$ionicView.beforeEnter', function() {
		initPage();
	});
	
	 /***any cleanup needs to be done here: executes everytime when page is left***/
	$scope.$on('$ionicView.afterLeave', function() {
	
	});
	return this;
}]);

