/*******Lumsum Controller ******/

'use strict';

angularApp.controller('lumpsumController', 
						["$timeout",
						 "$state",
						 "$scope",
						 "$rootScope",
						 "$translate",
						 "$location","$ionicPopup",
						 "$ionicScrollDelegate","$stateParams","ionicDatePicker","mutualFundsService","utilityService","$filter","constantConfig","clickStreamService","customerInfoService","getAccountDetailsService","homeScreenService","$ionicHistory","$ionicPopover","$ionicLoading",
				 
function ($timeout,
		 $state,
		 $scope,
		 $rootScope,
		 $translate,
		 $location,$ionicPopup,
		 $ionicScrollDelegate,$stateParams,ionicDatePicker,mutualFundsService,utilityService,$filter,constantConfig,clickStreamService,customerInfoService,getAccountDetailsService,homeScreenService,$ionicHistory,$ionicPopover,$ionicLoading) {
	
	
	var lumpsumVm = this;
	
	 /*** Initialize the variables that has to show in  the HTML come here ***/
	function initPage(){
		 if (ionic.Platform.isIOS()) {
                lumpsumVm.lumsumAmount = "text";
            } else {
                lumpsumVm.lumsumAmount = "tel";
            }
		lumpsumVm.amount='';
		lumpsumVm.dividendOption='N';
		lumpsumVm.dividendoptnNm = "Payout";
		lumpsumVm.isTermsAndConditionChecked=0;
		lumpsumVm.fundObj=mutualFundsService.getFundToInvest();
		lumpsumVm.infoMessage=mutualFundsService.getInfoList();
		if(lumpsumVm.infoMessage==''){
			mutualFundsService.getAllInfoLists().then(function(data) {
				 if(data.infoList.nfo){
					 lumpsumVm.infoMessages=data.infoList.nfo;
					 lumpsumVm.refCodeContentMessage=data.infoList.refCodeContent;
				 }
				mutualFundsService.addInfoList(data.infoList);
					}, function(error) {
						utilityService.showErrorMessage(error.responseMessage);
					}); 
		}else{
			if(lumpsumVm.fundObj.isNfo=='Y'){
				lumpsumVm.infoMessages=lumpsumVm.infoMessage.nfo;
				lumpsumVm.refCodeContentMessage=lumpsumVm.infoMessage.refCodeContent;
			}else{
				if(lumpsumVm.infoMessage.lumpsum){
					lumpsumVm.infoMessages=lumpsumVm.infoMessage.lumpsum;
					lumpsumVm.refCodeContentMessage=lumpsumVm.infoMessage.refCodeContent;
				}else{
					lumpsumVm.infoMessages=constantConfig.mfAndsecConst.riskInfoEmptyText;
					lumpsumVm.refCodeContentMessage=constantConfig.mfAndsecConst.riskInfoEmptyText;
				}	
		  }
	 	}
			
		lumpsumVm.reviewNFOPageClosed=0;		
		//lumpsumVm.reviewPage=0;
		lumpsumVm.successPage=0;		
		lumpsumVm.transactionType=constantConfig.mfAndsecConst.lumpsumMf;
		lumpsumVm.folio='';
		lumpsumVm.minAmountFlag=true;
		lumpsumVm.multiplierAmountFlag=true;
		lumpsumVm.maxAmountFlag=true;
		lumpsumVm.invalidAmount=false;
		lumpsumVm.sufficiantBalance=true;
		lumpsumVm.lumsumOptSelected = true;
		lumpsumVm.SIPoptSelected = false;
		lumpsumVm.showAmntLabel = false;

		//SIP INIT Functions start
		lumpsumVm.createSIPPage = 1;
		lumpsumVm.SIPDate = "0";
		lumpsumVm.SIPfolio = '';
		lumpsumVm.SIPminAmountFlag = true;
		lumpsumVm.SIPmaxAmountFlag = true;
		lumpsumVm.SIPsufficiantBalance=true;
		lumpsumVm.RequiredAmount = true;
		lumpsumVm.RequiredStartDt = true;
		lumpsumVm.RequiredEndDt = true;
		lumpsumVm.SIPdividendOption = 'N';
		lumpsumVm.SIPdividendoptnNm = "Payout";
		lumpsumVm.SIPisTermsAndConditionChecked = 0;
		lumpsumVm.createSIPPage = 1;
		lumpsumVm.SIPreviewPage = 0;
		lumpsumVm.SIPsuccessPage = 0;
		if(lumpsumVm.fundObj.isNfo !='Y'){
			lumpsumVm.getSIPFundDetails();
		}
		lumpsumVm.getSIPSBIAccounts();
		lumpsumVm.frequency = "Monthly";
		//createSIPVm.getTransactionNotes();
		//createSIPVm.accountDetails();
		//createSIPVm.getPanCard();
		//lumpsumVm.getFrequercy();
		lumpsumVm.SIPtransactionType = constantConfig.mfAndsecConst.transactionTypeSIP; //"P";
		lumpsumVm.disableDate = 1;
		lumpsumVm.minQuarterlyAmount = 0;
		lumpsumVm.perpetualCheck = false;
		if(window.location.hash != "#/menu/lumpsum" && window.location.hash != "#/menu/sipOTP"){
			$rootScope.nextSIPInstallmentDt = "";
		}
		lumpsumVm.SIPisTermsAndConditionError = false;
		lumpsumVm.isTermsAndConditionError = false;
		//SIP INIT Functions End

		if($rootScope.successPageNFO == 1){
			lumpsumVm.getCustomerInf();
		}else{
			lumpsumVm.getSBIAccounts();
		}	
			
		if($state.current.data && $state.current.data.pageId == "MF_LMPSUM")
		{
            lumpsumVm.getFundDetails();
		}
		
		lumpsumVm.getPanCard();	
		lumpsumVm.getTransactionNotes();
		 //var rupeeSymbol = String.fromCharCode(8377);
            $rootScope.clickCount = 0;
	        $rootScope.isResendOTP = false;
	        $rootScope.isResendDisabled=false;           
	        $rootScope.mobileNumber = $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4);
	        //$rootScope.amountToPay= rupeeSymbol + mutualFundsService.getInvedtedAmount();
	       	        
	}

	lumpsumVm.showPurchaseNtAllowPopup = function (message) {
		$ionicPopup.show({
			template: '<p>' + message + '</p>',
			title: 'Alert',
			cssClass: 'dialog',
			scope: $scope,
			buttons: [{ text: 'Ok' }]
		});
	}

	lumpsumVm.showLumsumpNtAllowPopup = function (message) {
		$ionicPopup.show({
			template: '<p>' + message + '</p>',
			title: 'Alert',
			cssClass: 'dialog',
			scope: $scope,
			buttons: [{
						text: 'Ok',
						onTap: function (e) {
							lumpsumVm.selectTab('Monthly');
						}
					}]
		});
	}

	

	 
	//function to select investment tab
	lumpsumVm.selectTab = function(val){
		if(val == 'Monthly'){
			if(lumpsumVm.fundObj.isNfo!='Y' && lumpsumVm.fundDetailList.scmsipAvailable == 'YES'){ 
				document.getElementsByClassName('mfInvestTabNonSelect1')[0].classList.remove('mfInvestTabSelected');
				document.getElementsByClassName('mfInvestTabNonSelect')[0].classList.remove('mfInvestTabSelected');
				document.getElementsByClassName('mfInvestTabNonSelect2')[0].classList.add('mfInvestTabSelected1');
				lumpsumVm.lumsumOptSelected = false;
				lumpsumVm.SIPoptSelected = true;
				lumpsumVm.frequency = "Monthly";
				lumpsumVm.amount="";
				lumpsumVm.showAmntLabel = false;
				lumpsumVm.ShowEndDtLbl = false;
				lumpsumVm.ShowDtLbl = false;
				lumpsumVm.startDate = "";
				lumpsumVm.startSIPDate = "";
				lumpsumVm.endDate = "";
				lumpsumVm.SIPendDate = "";
				lumpsumVm.nextSIPInstallmentDate = "";
				lumpsumVm.perpetualCheck = false;
				lumpsumVm.RequiredStartDt = true;
				lumpsumVm.RequiredEndDt = true;
				lumpsumVm.hgtAdjst();
				lumpsumVm.getFrequercy();
				lumpsumVm.SIPrefCode = "";
				lumpsumVm.refCode = "";
				//lumpsumVm.endDate = constantConfig.mfAndsecConst.perpetualDate;
				if(document.getElementById("SIPdividentOption")){
					document.getElementById("SIPdividentOption").checked = false;
				}
			}
			else{
				lumpsumVm.showPurchaseNtAllowPopup("SIP purchase is not available for this Scheme");
			}
		}
		else if(val == 'Quarterly'){
			if(lumpsumVm.fundObj.isNfo!='Y' && lumpsumVm.fundDetailList.scmsipAvailable == 'YES'){
				document.getElementsByClassName('mfInvestTabNonSelect2')[0].classList.remove('mfInvestTabSelected1');
				document.getElementsByClassName('mfInvestTabNonSelect')[0].classList.remove('mfInvestTabSelected');
				document.getElementsByClassName('mfInvestTabNonSelect1')[0].classList.add('mfInvestTabSelected');
				lumpsumVm.lumsumOptSelected = false;
				lumpsumVm.SIPoptSelected = true;
				lumpsumVm.frequency = "Quarterly";
				lumpsumVm.amount="";
				lumpsumVm.showAmntLabel = false;
				lumpsumVm.ShowDtLbl = false;
				lumpsumVm.startDate = "";
				lumpsumVm.startSIPDate = "";
				lumpsumVm.ShowEndDtLbl = false;
				lumpsumVm.endDate = "";
				lumpsumVm.SIPendDate = "";
				lumpsumVm.nextSIPInstallmentDate = "";
				lumpsumVm.perpetualCheck = false;
				lumpsumVm.RequiredStartDt = true;
				lumpsumVm.RequiredEndDt = true;
				lumpsumVm.hgtAdjst();
				lumpsumVm.getFrequercy();
				lumpsumVm.SIPrefCode = "";
				lumpsumVm.refCode = "";
				//lumpsumVm.endDate = constantConfig.mfAndsecConst.perpetualDate;
				if(document.getElementById("SIPdividentOption")){
					document.getElementById("SIPdividentOption").checked = false;
				}
			}
			else{
				lumpsumVm.showPurchaseNtAllowPopup("SIP purchase is not available for this Scheme");
			}
		}
		else{
			if (lumpsumVm.fundDetailList.scmPurAvailable == "YES"){
				document.getElementsByClassName('mfInvestTabNonSelect1')[0].classList.remove('mfInvestTabSelected');
				document.getElementsByClassName('mfInvestTabNonSelect2')[0].classList.remove('mfInvestTabSelected1');
				document.getElementsByClassName('mfInvestTabNonSelect')[0].classList.add('mfInvestTabSelected');
				lumpsumVm.lumsumOptSelected = true;
				lumpsumVm.SIPoptSelected = false;
				lumpsumVm.amount="";
				lumpsumVm.showAmntLabel = false;
				$rootScope.nextSIPInstallmentDt = "";
				lumpsumVm.refCode = "";
				lumpsumVm.SIPrefCode = "";
				lumpsumVm.multiplierAmountFlag = true;
				lumpsumVm.hgtAdjst();
			}
			else{
				lumpsumVm.showPurchaseNtAllowPopup("Lumpsum purchase is not available for this Scheme");
			}
		}
	}

	//height adjust
	lumpsumVm.hgtAdjst = function(){
		$timeout(function() {
			if(document.getElementsByClassName('mfInvestPgFndNm') && document.getElementsByClassName('mfInvestPgFndNm')[0].offsetHeight == "40"){	
				document.getElementsByClassName('mfMarginTop')[0].classList.add("mfMarginTopLess");
				document.getElementsByClassName('mfMarginTop')[0].classList.remove("mfMarginTop");	
			}
		},500);
	}

	//function to open account select overlay
	lumpsumVm.openAcntOverlay = function(){
		var element = document.getElementsByClassName("mfSelectAcntFunds")[0];
        element.classList.toggle("mfSelectAcntClose");
		if(document.getElementById("mfoverlay").style.display == "none"){
			document.getElementById("mfoverlay").style.display = "";
		}
		else{
			document.getElementById("mfoverlay").style.display = "none";
		}
	}
	
	lumpsumVm.getCustomerInf=function(){		
		var currentDate = new Date();
		lumpsumVm.lumpsumDate = currentDate.setDate(currentDate.getDate());	
		lumpsumVm.todayDate =lumpsumVm.lumpsumDate;		
		homeScreenService.getCustomerInfo().then(function (data) {					  		
			mutualFundsService.getSBIBankAccounts().then(function(acntdata){
				$scope.accounts=acntdata.beneficiaryList.ownAccounts;
				if($scope.accounts.length > 0){
					//Default display primary account
					var primaryAccount = getAccountDetailsService.accountOverviewData.customerInformation.accountNumber;
					var objPriAcc = getAccountDetailsService.displayPrimaryAccountAsDefault($scope.accounts,primaryAccount);
					lumpsumVm.savingAccounts=objPriAcc.benAccntNo;
					
					lumpsumVm.accounts=$scope.accounts;
					lumpsumVm.savingAccounts=$scope.accounts[objPriAcc.index].benAccntNo;
				}
				
			},function(error){
				
			})
	  },function(error){
		  
	  });
	}

	lumpsumVm.getSBIAccounts=function(){
		var currentDate = new Date();
		lumpsumVm.lumpsumDate = currentDate.setDate(currentDate.getDate());	
		lumpsumVm.todayDate =lumpsumVm.lumpsumDate;		  		
		mutualFundsService.getSBIBankAccounts().then(function(data){
			$scope.accounts=data.beneficiaryList.ownAccounts;
			if($scope.accounts.length > 0){
				lumpsumVm.accounts=$scope.accounts;
				//Default display primary account
				var primaryAccount = getAccountDetailsService.accountOverviewData.customerInformation.accountNumber;
				var objPriAcc = getAccountDetailsService.displayPrimaryAccountAsDefault($scope.accounts,primaryAccount);
				lumpsumVm.savingAccounts=objPriAcc.benAccntNo;
				//lumpsumVm.savingAccounts=$scope.accounts[0].benAccntNo;
			}
		})
	  
	}	

	
	/**
	* Fetch get fund Details From server
	* @param {fundId}
	**/
	lumpsumVm.accountDetails = function(){
		var currentDate = new Date();
		lumpsumVm.lumpsumDate = currentDate.setDate(currentDate.getDate());	
		lumpsumVm.todayDate =lumpsumVm.lumpsumDate;		
		lumpsumVm.accounts=mutualFundsService.getDetails();
		$scope.accounts=[];
		if(lumpsumVm.accounts){
			$scope.accountListTemp=lumpsumVm.accounts;
			var accountListTempLength = $scope.accountListTemp.length ;
			for(lumpsumVm.list=0;lumpsumVm.list < accountListTempLength;lumpsumVm.list++){
				if($scope.accountListTemp[lumpsumVm.list].accountType==constantConfig.mfAndsecConst.savingAccountInOpenAccount || $scope.accountListTemp[lumpsumVm.list].accountType==constantConfig.mfAndsecConst.currentAccountInOpenAccount || $scope.accountListTemp[lumpsumVm.list].accountType==constantConfig.mfAndsecConst.odAccountInOpenAccount){
					$scope.accounts.push($scope.accountListTemp[lumpsumVm.list]);
				}
			}
			lumpsumVm.savingAccounts = $scope.accounts[0].accountNumber;
		}
		

		
		if(lumpsumVm.fundObj.isNfo!='Y'){
			if(lumpsumVm.infoMessage.lumpsum){
				lumpsumVm.infoMessages=lumpsumVm.infoMessage.lumpsum;
				lumpsumVm.refCodeContentMessage=lumpsumVm.infoMessage.refCodeContent;
			}else{
				lumpsumVm.infoMessages=constantConfig.mfAndsecConst.riskInfoEmptyText;
				lumpsumVm.refCodeContentMessage=constantConfig.mfAndsecConst.riskInfoEmptyText;
			}	
		}	
	}	
	
	/**
		
	* Fetch get Pancard From server
	* @param {id}
	* type
	*/
	lumpsumVm.getPanCard=function(){
		var reqParams={};
		reqParams['id']='';
		mutualFundsService.getPanCardNumber(reqParams).then(function(data){
			lumpsumVm.panCard=data.mfKyc.panNo.toUpperCase();
			lumpsumVm.divPayOutMechanism=data.mfKyc.divPayOutMechanism;
			lumpsumVm.redPayOutMechanism=data.mfKyc.redPayOutMechanism;
			lumpsumVm.mfkyc= data.mfKyc;	
		}, function(error){
			utilityService.showErrorMessage(error.responseMessage);

		});
	}   

	/**
	*Function to go to get Transaction Notes Message
	@params:{}

	**/
	lumpsumVm.getTransactionNotes = function() {
		mutualFundsService.getTransactionNotes().then(function(data) {
			lumpsumVm.nfoMssg = data.nfo.slice(1,  data.nfo.length);
			lumpsumVm.nonNfoMssg = data.nonNfo.slice(1,  data.nonNfo.length);
			lumpsumVm.commonMssg = data.common.slice(1,  data.common.length);
		}, function(error) {
			lumpsumVm.nfoMssg = "";
			lumpsumVm.nonNfoMssg = "";
			lumpsumVm.commonMssg = ""; 
			utilityService.showErrorMessage(error.responseMessage);
		}); 
	}

	/**
	*Function to go to get fund Deatils
    @params:{fundId:''}
	
	**/
	lumpsumVm.getFundDetails=function(){
		lumpsumVm.folioObj=mutualFundsService.getFolioToInvest();
		lumpsumVm.fundObj=mutualFundsService.getFundToInvest();
		lumpsumVm.fundId=lumpsumVm.fundObj.amfiCode;
		if(lumpsumVm.folioObj!=''){
		lumpsumVm.folioNumber=lumpsumVm.folioObj.mfKyc.folioNo;
		if(lumpsumVm.folioNumber){
			lumpsumVm.folio=lumpsumVm.folioNumber;
		}
		}else{
		
		if(lumpsumVm.fundObj.folioNumber){
			lumpsumVm.folio=lumpsumVm.fundObj.folioNumber;
		}
		}
		lumpsumVm.reqParams={};
		lumpsumVm.reqParams['amfiCode']=lumpsumVm.fundId;
		if(lumpsumVm.fundObj.isNfo=='Y'){
			lumpsumVm.reqParams['isNfo']=lumpsumVm.fundObj.isNfo;
		}
		mutualFundsService.getFundDetailsNfo(lumpsumVm.reqParams).then(function(data) {
			if(lumpsumVm.fundObj.isNfo=='Y'){
				lumpsumVm.lumpsomPageNFO=1;
				lumpsumVm.lumpsomPage=0;
			}else{
				lumpsumVm.lumpsomPage=1;
				lumpsumVm.lumpsomPageNFO=0;

			}
			
			lumpsumVm.fundDetailList=data;
			
			var optnNmLbl = "";
			if(lumpsumVm.fundObj.isNfo=='Y'){	
				if(lumpsumVm.fundDetailList.planList){
					if(lumpsumVm.fundDetailList.planList[0].option == 'G'){optnNmLbl = 'Growth';}
					else{optnNmLbl = 'Dividend';}
				}
				$rootScope.fundName = lumpsumVm.fundDetailList.fundName.split('-')[0]+" - Regular plan - "+optnNmLbl;
			}
			else{	
				if(lumpsumVm.fundDetailList.planList){
					if(lumpsumVm.fundDetailList.planList[0].option == 'G'){optnNmLbl = 'Growth';}
					else{optnNmLbl = 'Dividend';}
				}
				$rootScope.fundName = lumpsumVm.fundDetailList.fundName.split('-')[0]+"- Regular plan - "+optnNmLbl;
			}
			lumpsumVm.amcCode=lumpsumVm.fundDetailList.scmAmcCd;
		    lumpsumVm.schemeCode=data.fundId;
			lumpsumVm.fundType=data.fundType;
			lumpsumVm.scmElss= data.scmElss;
			if(lumpsumVm.fundDetailList.maxAppAmount){
				lumpsumVm.maxAmount=$filter('INRFLOAT')(lumpsumVm.fundDetailList.maxAppAmount,2);
			}else{
				lumpsumVm.maxAmount='';
			}
		
			if(lumpsumVm.folio){
				if (!mutualFundsService.multiFolio) {
					$ionicLoading.show({
						template: '<ion-spinner icon="android"></ion-spinner>'
					  });
					mutualFundsService.getPortfolio().then(function (data) {
						data = data.multiFolio;
						mutualFundsService.multiFolio = data;
						$ionicLoading.hide();
						angular.forEach(mutualFundsService.multiFolio.portFolio, function (value, key) {
							if (value.isLotusfolio.toLowerCase() == "yes") {
								lumpsumVm.isLotusFolio=value.isLotusfolio;
								lumpsumVm.isLotusFolioNumber=value.folioNumber;
								if(value.fundList!=null || value.fundList!=undefined){							
								if(value.fundList.length>0){
								if(value.fundList[0].amfiCode==lumpsumVm.fundId){
									lumpsumVm.isAdditional=true;
								}
							  }
							}
						  }
						});
					}, function (error) {
						console.log(error);
						$ionicLoading.hide();
					});
				} else {
					angular.forEach(mutualFundsService.multiFolio.portFolio, function (value, key) {
                        if (value.isLotusfolio.toLowerCase() == "yes") {
                            lumpsumVm.isLotusFolio=value.isLotusfolio;
                            lumpsumVm.isLotusFolioNumber=value.folioNumber;
							if(value.fundList!=null || value.fundList!=undefined){							
                            if(value.fundList.length>0){
                            if(value.fundList[0].amfiCode==lumpsumVm.fundId){
                            	lumpsumVm.isAdditional=true;
                            }
                          }
						}
                      }
                    });
				}
				if(lumpsumVm.isAdditional==true){
					lumpsumVm.minAmount=$filter('INRFLOAT')(lumpsumVm.fundDetailList.addMinPurchaseAmt,0);
					lumpsumVm.multiplierAmount=$filter('INRFLOAT')(lumpsumVm.fundDetailList.multiplesInvestmentAdditional,0);
					lumpsumVm.nfoAllotmentDate = $filter('date')(lumpsumVm.fundDetailList.nfoAllotmentDate,'dd MMM yyyy' );
						
				// if(lumpsumVm.fundDetailList.isNfo=='Y'){
				// 	lumpsumVm.minAmount=$filter('INRFLOAT')(lumpsumVm.fundDetailList.minInvestment,2);
				// }
				}else{
						lumpsumVm.minAmount=$filter('INRFLOAT')(lumpsumVm.fundDetailList.minPurchaseAmt,0);
						lumpsumVm.multiplierAmount=$filter('INRFLOAT')(lumpsumVm.fundDetailList.multiplesInvestmentAdditional,0);
						lumpsumVm.nfoAllotmentDate = $filter('date')(lumpsumVm.fundDetailList.nfoAllotmentDate,'dd MMM yyyy' );
						//lumpsumVm.minAmount=$filter('INRFLOAT')(lumpsumVm.fundDetailList.minPurchaseAmt,2);
				}

			}else{
				lumpsumVm.minAmount=$filter('INRFLOAT')(lumpsumVm.fundDetailList.minPurchaseAmt,0);
				lumpsumVm.multiplierAmount=$filter('INRFLOAT')(lumpsumVm.fundDetailList.multiplesInvestmentFresh,0);
			}	
		   if(lumpsumVm.fundObj.plan){
				lumpsumVm.plan= lumpsumVm.fundObj.plan;
				lumpsumVm.option = lumpsumVm.fundObj.option;
				lumpsumVm.nav  = $filter('INRFLOAT')(lumpsumVm.fundObj.nav,4);
				lumpsumVm.navDate = $filter('date')(lumpsumVm.fundObj.navDate,'dd MMM yyyy' );
				lumpsumVm.nfoFaceValue = lumpsumVm.fundDetailList.planList[0].nfoFaceValue;
			
			}else{
				if(lumpsumVm.fundDetailList.planList[0]){
					lumpsumVm.plan  = lumpsumVm.fundDetailList.planList[0].plan;
					lumpsumVm.option =lumpsumVm.fundDetailList.planList[0].option;
					lumpsumVm.nav  = $filter('INRFLOAT')(lumpsumVm.fundDetailList.planList[0].nav,4);
					lumpsumVm.navDate = $filter('date')(lumpsumVm.fundDetailList.planList[0].navDate,'dd MMM yyyy' );
					lumpsumVm.nfoFaceValue = lumpsumVm.fundDetailList.planList[0].nfoFaceValue;
				}else{
					lumpsumVm.plan  ='';
					lumpsumVm.option='';
					lumpsumVm.nav  ='';
					lumpsumVm.navDate = '';
					lumpsumVm.nfoFaceValue='';
				}
			}
			lumpsumVm.hgtAdjst();
			//show lumsum purchase not allow popup by default on load
			if(lumpsumVm.fundDetailList.scmPurAvailable == 'NO'){
				lumpsumVm.showLumsumpNtAllowPopup("Lumpsum purchase is not available for this Scheme");
			}
			//alert(document.getElementsByClassName('mfInvestPgFndNm')[0].offsetHeight); classList.remove("removeSliderCss");
		}, function(error) {
			utilityService.showErrorMessage(error.responseMessage);
		});
	}

	lumpsumVm.nextFocus = function(div){
		if(div == 'mpin1'){document.getElementsByClassName('mpin2')[0].focus();}
		if(div == 'mpin2'){document.getElementsByClassName('mpin3')[0].focus();}
		if(div == 'mpin3'){document.getElementsByClassName('mpin4')[0].focus();}
		if(div == 'mpin4'){document.getElementsByClassName('mpin5')[0].focus();}
		if(div == 'mpin5'){document.getElementsByClassName('mpin6')[0].focus();}
    }
	
	lumpsumVm.submitLumpsum = function(){	
		if(!lumpsumVm.isTermsAndConditionChecked){
			lumpsumVm.isTermsAndConditionError = true;
			return false;
		}
		var reqParams = {};
		var requestSecKey='';
		angular.forEach(mutualFundsService.multiFolio.portFolio, function (value, key) {
                        if (value.isLotusfolio.toLowerCase() == "yes") {
                            lumpsumVm.isLotusFolio=value.isLotusfolio;
                            lumpsumVm.isLotusFolioNumber=value.folioNumber;
							if(value.fundList!=null || value.fundList!=undefined){
                            if(value.fundList.length>0){
                            if(value.fundList[0].amfiCode==lumpsumVm.fundId){
                            	lumpsumVm.lumpsumVmType = constantConfig.mfAndsecConst.lumpsumAdditional;
                            	 lumpsumVm.typeOfTranx = constantConfig.mfAndsecConst.lumpsumAdditional;
                            }
                          }
						}
                      }
                    });


		//if (lumpsumVm.folio && lumpsumVm.isLotusFolio) {
	            	if(lumpsumVm.lumpsumVmType == undefined || lumpsumVm.lumpsumVmType == null || lumpsumVm.lumpsumVmType == ''){
	               		 lumpsumVm.typeOfTranx = constantConfig.mfAndsecConst.lumpsumFresh;						
	            	}
	           // } else {	            	
				//	if(lumpsumVm.lumpsumVmType == undefined || lumpsumVm.lumpsumVmType == null || lumpsumVm.lumpsumVmType == ''){
						// lumpsumVm.typeOfTranx = constantConfig.mfAndsecConst.lumpsumFresh;
				//	}	
	           // }


		if(!lumpsumVm.isTermsAndConditionChecked){
			return false;
		}

		if(lumpsumVm.option.indexOf('D') == -1){
			lumpsumVm.dividendOption = "";
		}
		// if(lumpsumVm.folio){
		//    reqParams["txnType"] = constantConfig.mfAndsecConst.lumpsumAdditional; 
		// }else{
		// 	reqParams["txnType"] = constantConfig.mfAndsecConst.lumpsumFresh;
		// }
		lumpsumVm.txnId = utilityService.getRandomNumber();
		var requestDate = new Date();
		requestDate = requestDate.getTime();
		requestSecKey=Math.floor((Math.random()) + requestDate);
		requestSecKey = (requestSecKey * 10 + 1);

		clickStreamService.clickStreamData=lumpsumVm.txnId;
		reqParams["txnType"] = lumpsumVm.typeOfTranx;
		reqParams["schemeId"] = lumpsumVm.schemeCode; //lumpsumVm.fundId;
		reqParams["schemeName"] = lumpsumVm.fundDetailList.fundName;	
		reqParams["schemePlan"] =  lumpsumVm.plan;
		reqParams["schemeOption"] = lumpsumVm.option;
		reqParams["transactionType"] = constantConfig.mfAndsecConst.lumpsumMf;
		
		reqParams["endDate"] = '';
		reqParams["amount"] = lumpsumVm.amount;
		reqParams["units"] = "";
		reqParams["accountNo"] =lumpsumVm.savingAccounts;
		reqParams["frequency"] ='';	
		reqParams["isPerpetual"] = "";
		reqParams["amcCode"] =  lumpsumVm.amcCode;
		reqParams["folioNo"] =lumpsumVm.folio;
		reqParams["txnDate"] = "";
		reqParams["txnTime"] = "";
		reqParams["sipRegisteredDate"] = "";
		reqParams["numberOfInstallments"] = "";
		reqParams["installmentNumber"] = "";
		reqParams["euin"] = lumpsumVm.refCode;
		reqParams["bankName"] = "";
		reqParams["bankCode"] = "";
		reqParams["bankCity"] = "";
		reqParams["accountType"] = "";
		reqParams["panNo"] =lumpsumVm.panCard;
		reqParams["customerTermandCondition"] = lumpsumVm.isTermsAndConditionChecked;
		reqParams["branchName"] = "";
		reqParams["targetSchemeId"] = '';
		reqParams["targetSchemeName"] = '';	
		reqParams["targetSchemePlan"] = '';
		reqParams["targetSchemeOption"] = '';
		reqParams["dividendOption"] =lumpsumVm.dividendOption;  //No dividend option 
		reqParams["divPayoutMechanism"]=lumpsumVm.divPayOutMechanism;
		reqParams["redPayoutMechanism"]=lumpsumVm.redPayOutMechanism;
		reqParams["txnId"]=lumpsumVm.txnId;
		reqParams["amfiCode"]=lumpsumVm.fundId;
		reqParams["closeAc"]='';
		reqParams["secKey"]=requestSecKey;

		if(lumpsumVm.fundObj.isNfo=='Y'){
			//reqParams["nfoFaceValue"] = lumpsum.nfoFaceValue;
			reqParams["isNfo"]='Y';
			reqParams["startDate"] = $filter('date')(new Date(lumpsumVm.lumpsumDate), 'dd/MM/yyyy');
		}else{
			reqParams["startDate"] = $filter('date')(new Date(lumpsumVm.lumpsumDate), 'dd/MM/yyyy');
			reqParams["isNfo"]='N';
		}
		var optnNmLbl = "";
		if(lumpsumVm.fundObj.isNfo=='Y'){	
				if(lumpsumVm.fundDetailList.planList){
					if(lumpsumVm.fundDetailList.planList[0].option == 'G'){optnNmLbl = 'Growth';}
					else{optnNmLbl = 'Dividend';}
				}
				$rootScope.fundName = lumpsumVm.fundDetailList.fundName.split('-')[0]+" - Regular plan - "+optnNmLbl;
			}
			else{
				if(lumpsumVm.fundDetailList.planList){
					if(lumpsumVm.fundDetailList.planList[0].option == 'G'){optnNmLbl = 'Growth';}
					else{optnNmLbl = 'Dividend';}
				}
				$rootScope.fundName = lumpsumVm.fundDetailList.fundName.split('-')[0]+"- Regular plan - "+optnNmLbl;
			}
		
		$rootScope.unitName=constantConfig.mfAndsecConst.amount;
		$rootScope.amountToPay=lumpsumVm.amount;
	
	    mutualFundsService.addInvedtedAmount(lumpsumVm.amount);//for OTP page showing
		mutualFundsService.payDuesRequest(reqParams).then(function(data){					    
			    if(data.submitRequest.isOTPRequired == "true"){	
			        $rootScope.stpotpPage=0;
			        $rootScope.redeemotpPage=0;
				    $rootScope.cancelotpPage=0;       	
			        $rootScope.sipotpPage=0;
			        if(lumpsumVm.fundObj.isNfo=='Y'){
			        	$rootScope.lumsumotpPage=0;
			        	$rootScope.lumsumNfOotpPage=1;
			        }else{
			        	$rootScope.lumsumNfOotpPage=0;
			        	$rootScope.lumsumotpPage=1;
			        }					
					$rootScope.swpotpPage=0;									
					$rootScope.switchotpPage=0;	 	    	
			    	$state.go("menu.lumpsumOTP");
			    }else{
			    var calCulatedKey=mutualFundsService.verifySecKey(parseInt(data.submitRequest.secKey));
	                 if(requestSecKey==calCulatedKey){
	                  lumpsumVm.message = data.submitRequest.status;
				      lumpsumVm.transactionReferenceNo = data.submitRequest.transactionReferenceNo;	                        
		                     lumpsumVm.lumpsomPage=0;
		                     lumpsumVm.successPage=1; 
		                     lumpsumVm.reviewPage=0;	
		                     lumpsumVm.lumpsomPageNFO=0;	                          
			                 lumpsumVm.amount=mutualFundsService.getInvedtedAmount();                
			                 lumpsumVm.transactionDate=new Date(data.submitRequest.transactionDate);
		                     utilityService.setCsatJournies("mutualFunds");
	                        // }else{
	                        // 	utilityService.showErrorMessage(data.submitRequest.responseMessage);
	                        // }	                 	
	                 }
			    }
			
			
		}, function(error){
			utilityService.showErrorMessage(error.responseMessage);
		});
	}

	
      $scope.lumpsumvalidateOTP=function(){
            var reqParams={};
             var requestSecKey='';
		    var requestDate = new Date();
		    requestDate = requestDate.getTime();
		    requestSecKey=Math.floor((Math.random()) + requestDate);
		    requestSecKey = (requestSecKey * 10 + 1);

            reqParams.otp= $scope.enterOTP;
            reqParams.secKey=requestSecKey; 
            mutualFundsService.validateOTPForPayment(reqParams).then(function(data){
             if(data.data.otpStatus == "0000"){
                 var calculatedKey=mutualFundsService.verifySecKey(parseInt(data.data.secKey));
                 if(requestSecKey==calculatedKey){   
					 //getAccountDetailsService.accountOverviewData="";
                 $rootScope.transactionReferenceNo=data.data.transactionReferenceNo;
                 if(data.data.transactionReferenceNo!="" ||data.data.transactionReferenceNo!=null){ 
	                 if(lumpsumVm.fundObj.isNfo=='Y'){
	                 	$rootScope.successPageNFO=1;
						 $rootScope.lumsumSuccessPage=0; 
	                 }else{
						 $rootScope.successPageNFO=0;  
	                 	$rootScope.lumsumSuccessPage=1; 
	                 }                    
			        	$rootScope.lumsumNfOotpPage=0;					 
                    $rootScope.cancelSuccessPage=0;
					$rootScope.commonErrorPage=0; 
					$rootScope.cancelbtnHide=0; 
			        $rootScope.redeemSuccessPage=0;
                 	$rootScope.swpSuccessPage=0;
                 	$rootScope.switchSuccessPage=0;
                 	$rootScope.stpSuccessPage=0;                 	
                 	$rootScope.sipSuccessPage=0;    
	                //$rootScope.fundName=$rootScope.fundName; 
	               // $rootScope.amount=mutualFundsService.getInvedtedAmount();           
	                $rootScope.transactionDate=new Date(data.data.transactionDate);                
	                utilityService.setCsatJournies("mutualFunds");              
	                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("MF_INVTACCTFORM_MF_END_NXT_BTN"));
	                $state.go('menu.paymentSuccess');
                  }else{
                  	 utilityService.showErrorMessage(data.data.responseMessage);
                  }
                }
             }else if(data.data.otpStatus != "0000"){
				  if(data.data.transactionReferenceNo != "" && data.data.transactionReferenceNo != null){
					$rootScope.sipSuccessPage = 0;
					$rootScope.redeemSuccessPage=0;
					$rootScope.swpSuccessPage=0;
					$rootScope.switchSuccessPage=0;
					$rootScope.stpSuccessPage=0;
					$rootScope.lumsumSuccessPage=0;		                 		
					$rootScope.cancelSuccessPage=0; 
					$rootScope.commonErrorPage=1;
					$rootScope.cancelbtnHide=0;
					$rootScope.transactionReferenceNo = data.data.transactionReferenceNo;
					//$rootScope.fundName =  $rootScope.fundName;
					$rootScope.transactionDate = new Date(data.data.transactionDate);
					$state.go('menu.paymentSuccess');
				}
				else{
					//$state.go('menu.paymentSuccess'); //needs to change
					 getAccountDetailsService.accountOverviewData="";
             		  mutualFundsService.clearOTP();
                	  $scope.errorMessage=data.responseMessage;
				} 
				
             }else{                   
					getAccountDetailsService.accountOverviewData="";
                   lumpsumVm.showErrorInformationPopup(error.responseMessage);
             }
            },function(error){
			getAccountDetailsService.accountOverviewData="";
            	//utilityService.showErrorMessage(error.responseMessage);
            	 lumpsumVm.showErrorInformationPopup(error.responseMessage);
            });
              
        }

         $scope.resendOTP=function(){
             $scope.enterOTP="";
			 $scope.enterOTP1 = ""; $scope.enterOTP2="";$scope.enterOTP3="";$scope.enterOTP4="";$scope.enterOTP5="";$scope.enterOTP6="";
            var reqParams ={};
            reqParams.id ="";
            reqParams.emailId ="";
            mutualFundsService.getOTPTokenSecure(reqParams).then(function(data){
                 $rootScope.clickCount++;
                 $scope.mutualFundEnterOTPForm={};
                if($rootScope.clickCount>2){
                    $scope.disableLink=true;
					utilityService.showErrorMessage($translate.instant('MAX_OTP_GENERATION'));
					//$scope.errorMessage = $translate.instant('MAX_OTP_GENERATION');
                }
            })          
        }
      


 		//****Submit button on OTP Page***//
        $scope.validateOTPNext=function(){
         	//$scope.enterOTP=document.getElementById('txt_otp').value;
			$scope.enterOTP = document.getElementById('txt_otp1').value+document.getElementById('txt_otp2').value+document.getElementById('txt_otp3').value+document.getElementById('txt_otp4').value+document.getElementById('txt_otp5').value+document.getElementById('txt_otp6').value;
           	if(validateForm()){
				if($rootScope.nextSIPInstallmentDt == ""){$scope.lumpsumvalidateOTP();}
				if($rootScope.nextSIPInstallmentDt != ""){$scope.SIPvalidateOTP();} 	
            }           
        }      
       
        
       function validateForm(){
        $scope.mutualFundEnterOTPForm={};
		//$scope.enterOTP = $scope.enterOTP1+$scope.enterOTP2+$scope.enterOTP3+$scope.enterOTP4+$scope.enterOTP5+$scope.enterOTP6;          
        $scope.enterOTP = document.getElementById('txt_otp1').value+document.getElementById('txt_otp2').value+document.getElementById('txt_otp3').value+document.getElementById('txt_otp4').value+document.getElementById('txt_otp5').value+document.getElementById('txt_otp6').value;  
		    // if(mutualFundsService.isValidOTPNum($scope.enterOTP)){
            //      $scope.errorMessage=mutualFundsService.isValidOTPNum($scope.enterOTP);
            // }
			if (!$scope.enterOTP) {
				$scope.errorMessage = 'Please Enter OTP Number';
				return false;
			}
			if ($scope.enterOTP.length < 6) {
				$scope.errorMessage = 'Please Enter Valid OTP Number';
				return false;
			}
            else{
				return true;
			}
        }
		

	/*** Click Function to pass data to service end***/
	lumpsumVm.reviewLumpsum=function(){
		lumpsumVm.isTermsAndConditionError = false;
		//lumpsumVm.checkMinAmount();
		if(!lumpsumVm.amount || lumpsumVm.amount =="" || !lumpsumVm.maxAmountFlag || !lumpsumVm.sufficiantBalance || !lumpsumVm.minAmountFlag || lumpsumForm.$invalid || !lumpsumVm.multiplierAmountFlag || lumpsumVm.invalidAmount)
		{
			if(!lumpsumVm.amount || lumpsumVm.amount ==""){
				lumpsumVm.RequiredAmount = false;
			}
			return false;
		}
		else{
			if(lumpsumVm.fundObj.isNfo=='Y'){
				lumpsumVm.reviewNFOPage=1;
				lumpsumVm.lumpsomPage=0;
				lumpsumVm.reviewPage=0;
				lumpsumVm.successPage=0;
				lumpsumVm.lumpsomPageNFO=0;
				lumpsumVm.isTermsAndConditionChecked=0;			
			}else{	
				if(lumpsumVm.minAmountFlag){	
					lumpsumVm.reviewNFOPage=0;		
					lumpsumVm.lumpsomPage=0;
					lumpsumVm.reviewPage=1;
					lumpsumVm.successPage=0;
					lumpsumVm.lumpsomPageNFO=0;
					lumpsumVm.isTermsAndConditionChecked=0;
				}			
			}
			if(lumpsumVm.option=='D'){lumpsumVm.planOptnNm = "Dividend";}
			if(lumpsumVm.option=='G'){lumpsumVm.planOptnNm = "Growth";}
			if(lumpsumVm.option=='DM'){lumpsumVm.planOptnNm = "Dividend Monthly";}
			if(lumpsumVm.option=='DY'){lumpsumVm.planOptnNm = "Dividend Yearly";}
			if(lumpsumVm.option=='DQ'){lumpsumVm.planOptnNm = "Dividend Quarterly";}
			if(lumpsumVm.option=='DW'){lumpsumVm.planOptnNm = "Dividend Weekly";}
			if(lumpsumVm.option=='DD'){lumpsumVm.planOptnNm = "Dividend Daily";}
			if(lumpsumVm.option=='DF'){lumpsumVm.planOptnNm = "Dividend Fortnightly";}
			if(lumpsumVm.option=='DA'){lumpsumVm.planOptnNm = "Dividend Annually";}				

			lumpsumVm.planOptnNm = lumpsumVm.plan+" "+lumpsumVm.planOptnNm;
		}
		
	}
	
	/***Function to show information popup***/
	lumpsumVm.showInformationPopup=function(){
		$ionicPopup.show({
			template: '<p>'+lumpsumVm.infoMessages+'</p>',
			title:'Information',
			scope: $scope,
			cssClass: 'dialog',		
			buttons: [
            {
               text: 'Ok'
            }
			]
		});

	}
	/***Function to show information popup***/
	lumpsumVm.showInformationPopupRefCode=function(){
		$ionicPopup.show({
			template: '<p>'+lumpsumVm.refCodeContentMessage+'</p>',
			title:'Information',
			scope: $scope,
			cssClass: 'dialog',		
			buttons: [
            {
               text: 'Ok'
            }
			]
		});

	}

	/***Function to show alert POP UP***/
		lumpsumVm.showErrorInformationPopup=function(message){
			$ionicPopup.show({
				template: '<p>'+message+'</p>',
				title:'Alert',
				cssClass: 'dialog',		
				scope: $scope,
				buttons: [ {
					text: 'Ok',
					onTap: function(e) {
						$state.go('menu.accountOverviewMyBalance');
					}
				}]
			});
		}
	/***Start term and Condition***/
	lumpsumVm.termsAndConditions=function(){
		if(lumpsumVm.termsAndConditionsFlag==1){
			lumpsumVm.termsAndConditionsFlag=0;
		}else{
			/** Call service to fetch termsConditionsMessage***/
			lumpsumVm.reqParams={};
			lumpsumVm.reqParams['action']=constantConfig.mfAndsecConst.lumpsumInvestTermsAndC;
			mutualFundsService.getTermsAndConditions(lumpsumVm.reqParams).then(function(data) {
				lumpsumVm.termsAndConditionsMessage=data.message;
			
			}, function(error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
			lumpsumVm.termsAndConditionsFlag=1;
		}			
	};
	
	lumpsumVm.changeAccounts = function(){
		//lumpsumVm.savingAccounts=lumpsumVm.savingAccounts;
		lumpsumVm.accountsLength= $scope.accounts.length;
		for (var i = 0; i < lumpsumVm.accountsLength; i++) {
			if($scope.accounts[i].benAccntNo == lumpsumVm.savingAccounts){
				//lumpsumVm.savingAccounts=lumpsumVm.mfkyc.aofAccountNo;
				lumpsumVm.selectedAccountAmount= $scope.accounts[i].balance;
			}
		}
		lumpsumVm.checkMinAmount();
	}

	lumpsumVm.SIPchangeAccounts = function(){
		//lumpsumVm.savingAccounts=lumpsumVm.savingAccounts;
		lumpsumVm.accountsLength= $scope.accounts.length;
		for (var i = 0; i < lumpsumVm.accountsLength; i++) {
			if($scope.accounts[i].benAccntNo == lumpsumVm.savingAccounts){
				//lumpsumVm.savingAccounts=lumpsumVm.mfkyc.aofAccountNo;
				lumpsumVm.selectedAccountAmount= $scope.accounts[i].balance;
			}
		}
		lumpsumVm.SIPcheckMinAmount();
	}
	
	lumpsumVm.isMultiple = function(x, y) {
		return Math.round(x / y) / (1 / y) === x;
	}
	/**
	*Function to checkMinAmount 
	**/
	lumpsumVm.checkMinAmount=function(){
		if(lumpsumVm.amount && lumpsumVm.amount != ""){
			lumpsumVm.showAmntLabel = true;
			lumpsumVm.RequiredAmount = true;
			$timeout(function() {
				document.getElementById('lumsumAmnt').style.setProperty('margin-top', '0%', 'important');
				document.getElementById('lumsumAmnt').style.setProperty('margin-left', '0.6em', 'important');
			},10);
		}
		else{lumpsumVm.showAmntLabel = false;
			lumpsumVm.RequiredAmount = true;
			$timeout(function() {
				document.getElementById('lumsumAmnt').style.setProperty('margin-top', '2%', 'important');
				document.getElementById('lumsumAmnt').style.setProperty('margin-left', '0em', 'important');
			},10);
		}	
		lumpsumVm.savingAccounts=lumpsumVm.savingAccounts;
		$scope.minAmount=parseFloat(lumpsumVm.minAmount.replace(",",''));
		$scope.maxAmount=parseFloat(lumpsumVm.maxAmount.replace(",",''));
		$scope.enteredAmount=parseFloat(lumpsumVm.amount);
		$scope.multiplierAmount=parseFloat(lumpsumVm.multiplierAmount.replace(",",''));
		lumpsumVm.accountsLength= $scope.accounts.length;
		for (var i = 0; i < lumpsumVm.accountsLength; i++) {
			if($scope.accounts[i].benAccntNo == lumpsumVm.savingAccounts){
				//lumpsumVm.savingAccounts=lumpsumVm.mfkyc.aofAccountNo;
				lumpsumVm.selectedAccountAmount= $scope.accounts[i].balance;
				if(parseInt(lumpsumVm.selectedAccountAmount)>0){
				if($scope.enteredAmount > parseInt(lumpsumVm.selectedAccountAmount)) {
					lumpsumVm.sufficiantBalance=false;
				}else{
					lumpsumVm.sufficiantBalance=true;
					lumpsumVm.invalidAmount=false;
				}
			  }else{
			  	lumpsumVm.sufficiantBalance=true;
			  	lumpsumVm.invalidAmount=true;
			  }
			}
		}
		if($scope.minAmount>$scope.enteredAmount){
			lumpsumVm.minAmountFlag=false;
			lumpsumVm.maxAmountFlag=true;
			lumpsumVm.multiplierAmountFlag=true;
		}else if(($scope.multiplierAmount) && (($scope.enteredAmount%$scope.multiplierAmount)!=0)){
			// lumpsumVm.multiplierAmountFlag=false;
			// lumpsumVm.minAmountFlag=false;
			// lumpsumVm.maxAmountFlag=true;
			lumpsumVm.minAmountFlag=true;
			lumpsumVm.maxAmountFlag=true;
			lumpsumVm.multiplierAmountFlag=false;
		}else if($scope.maxAmount<$scope.enteredAmount){
			lumpsumVm.maxAmountFlag=false;
			lumpsumVm.minAmountFlag=true;
			lumpsumVm.multiplierAmountFlag=true;
		}else{
			lumpsumVm.minAmountFlag=true;
			lumpsumVm.maxAmountFlag=true;
			lumpsumVm.multiplierAmountFlag=true;
		}
	}
	/***BACK to page***/
	lumpsumVm.backToLumpsum=function(){
		if(lumpsumVm.fundObj.isNfo=='Y'){
			lumpsumVm.lumpsomPageNFO=1;
			lumpsumVm.lumpsomPage=0;
			lumpsumVm.reviewPage=0;
			lumpsumVm.successPage=0;
			lumpsumVm.reviewNFOPage=0;
		}else{
			lumpsumVm.lumpsomPage=1;
			lumpsumVm.reviewPage=0;
			lumpsumVm.successPage=0;
	  }
	  if(lumpsumVm.dividendOption == "Y"){
		  $timeout(function() {
		    	document.getElementById("dividentOption").checked = true;
		  },10);
	  }
	  lumpsumVm.checkMinAmount();
	  lumpsumVm.hgtAdjst();
	}
	
	/***Function to go to portfolio***/
	$scope.portfolio=function(){
		$state.go("menu.portfolio");
		lumpsumVm.isTermsAndConditionChecked=0;
		lumpsumVm.lumpsomPage=1;
		lumpsumVm.successPage=0;
	}
	
	$scope.goTofndlist=function(){
		//$state.go("menu.portfolio");
		lumpsumVm.isTermsAndConditionChecked=0;
		lumpsumVm.lumpsomPage=1;
		lumpsumVm.successPage=0;
		mutualFundsService.getAllMutualFunds().then(function(data) {
			var nfoArray=[];			
			if(data.fundList.length > 5){
                    angular.forEach(data, function (value, key) {
                        for(var i in value){
                          if (value[i].fundSchemeName == "NFO") {
                           nfoArray.push(data.fundList[i]);
                           data.fundList.splice(i,1);
                           data.fundList.splice(1,0,nfoArray[0]);
                        }  
                    }                    
                });
			}
			mutualFundsService.addNewFundDetails("false");
			mutualFundsService.addFundList(data.fundList);
			lumpsumVm.isTermsAndConditionChecked=0;
			lumpsumVm.lumpsomPage=0;
			lumpsumVm.successPage=0;
			lumpsumVm.successPageNFO=0;
			$state.go('menu.mutualFundsList');
		},function(error){
			lumpsumVm.showErrorInformationPopup(error.responseMessage);			
		})
	}

	$scope.viewAvailableFund=function(){
		if(mutualFundsService.multiFolio.totalCurrentValue > 0){
			$state.go("menu.portfolio");
			lumpsumVm.isTermsAndConditionChecked=0;
			lumpsumVm.lumpsomPage=1;
			lumpsumVm.successPage=0;
		}else{
		mutualFundsService.getAllMutualFunds().then(function(data) {
			var nfoArray=[];			
			if(data.fundList.length > 5){
                    angular.forEach(data, function (value, key) {
                        for(var i in value){
                          if (value[i].fundSchemeName == "NFO") {
                           nfoArray.push(data.fundList[i]);
                           data.fundList.splice(i,1);
                           data.fundList.splice(1,0,nfoArray[0]);
                        }  
                    }                    
                });
			}
			mutualFundsService.addNewFundDetails("false");
			mutualFundsService.addFundList(data.fundList);
			lumpsumVm.isTermsAndConditionChecked=0;
			lumpsumVm.lumpsomPage=0;
			lumpsumVm.successPage=0;
			lumpsumVm.successPageNFO=0;
			$state.go('menu.mutualFundsList');
		},function(error){
			lumpsumVm.showErrorInformationPopup(error.responseMessage);			
		})
		}
	}

	/***Function to go to portfolio page***/
	$scope.closePage=function(){
		$state.go("menu.portfolio");
		
	}

	//---------------SIP function started---------------------------------------------------------------------------

	lumpsumVm.getSIPSBIAccounts=function(){
		mutualFundsService.getSBIBankAccounts().then(function(data){
			$scope.accounts=data.beneficiaryList.ownAccounts;
			if($scope.accounts.length > 0){
				lumpsumVm.accounts=$scope.accounts;
				//Default display primary account
				var primaryAccount = getAccountDetailsService.accountOverviewData.customerInformation.accountNumber;
				var objPriAcc = getAccountDetailsService.displayPrimaryAccountAsDefault($scope.accounts,primaryAccount);
				lumpsumVm.savingAccounts=objPriAcc.benAccntNo;
				lumpsumVm.selectedAccountAmount= objPriAcc.balance;
				//lumpsumVm.savingAccounts=$scope.accounts[0].benAccntNo;
				//lumpsumVm.savingAccounts=$scope.accounts[0].benAccntNo;
			}
		})
		lumpsumVm.infoMessage=mutualFundsService.getInfoList();
		if(lumpsumVm.infoMessage.sip){					
			lumpsumVm.SIPrefCodeContentMessage=lumpsumVm.infoMessage.refCodeContent;
		}else{					
			lumpsumVm.SIPrefCodeContentMessage=constantConfig.mfAndsecConst.riskInfoEmptyText;
		}	
	}

	/**
	*Function to go to get fund Deatils
	@params:{fundId:''}
	**/
	lumpsumVm.getSIPFundDetails = function() {
		lumpsumVm.folioObj=mutualFundsService.getFolioToInvest();
		lumpsumVm.fundObj = mutualFundsService.getFundToInvest();
		lumpsumVm.fundId = lumpsumVm.fundObj.amfiCode;
		if(lumpsumVm.folioObj!=''){
			lumpsumVm.folioNumber=lumpsumVm.folioObj.mfKyc.folioNo;
			if (lumpsumVm.folioNumber) {
				lumpsumVm.SIPfolio = lumpsumVm.folioNumber;
			}
		}else{
			if (lumpsumVm.fundObj.folioNumber) {
				lumpsumVm.SIPfolio = lumpsumVm.fundObj.folioNumber;
			}
		}
	
		lumpsumVm.reqParams = {};
		lumpsumVm.reqParams['amfiCode'] = lumpsumVm.fundId;

		mutualFundsService.getFundDetails(lumpsumVm.reqParams).then(function(data) {
			lumpsumVm.fundDetailList = data;
			lumpsumVm.schemeCode = data.fundId;
			lumpsumVm.fundType = data.fundType;
			lumpsumVm.amcCode = lumpsumVm.fundDetailList.scmAmcCd;
			lumpsumVm.getFrequercy();
			if (lumpsumVm.fundDetailList.maxAppAmount) {
				lumpsumVm.SIPmaxAmount = $filter('INRFLOAT')(lumpsumVm.fundDetailList.maxAppAmount, 2);
			} else {
				lumpsumVm.SIPmaxAmount = '';
			}
			lumpsumVm.sipMinAmtMthly = $filter('INRFLOAT')(lumpsumVm.fundDetailList.sipMinAmtMthly, 2);
			lumpsumVm.sipMinAmtQuarter = $filter('INRFLOAT')(lumpsumVm.fundDetailList.sipMinAmtQuarter, 2);

			lumpsumVm.scmSipDateMonthly = lumpsumVm.fundDetailList.scmSipDateMonthly.replace('&', ',');
			lumpsumVm.scmSipDateMonthly = lumpsumVm.scmSipDateMonthly.split(','); //Monthly start Date
			lumpsumVm.scmSipDateQuarterly = lumpsumVm.fundDetailList.scmSipDateQuarterly.replace('&', ',');
			lumpsumVm.scmSipDateQuarterly = lumpsumVm.scmSipDateQuarterly.split(','); //quarterly start Date
			if (lumpsumVm.fundObj.plan) {
				lumpsumVm.plan = lumpsumVm.fundObj.plan;
				lumpsumVm.option = lumpsumVm.fundObj.option;
				lumpsumVm.nav = lumpsumVm.fundObj.nav;
				lumpsumVm.navDate = lumpsumVm.fundObj.navDate;

			} else {
				if (lumpsumVm.fundDetailList.planList[0]) {
					lumpsumVm.plan = lumpsumVm.fundDetailList.planList[0].plan;
					lumpsumVm.option = lumpsumVm.fundDetailList.planList[0].option;
					lumpsumVm.nav = lumpsumVm.fundDetailList.planList[0].nav;
					lumpsumVm.navDate = lumpsumVm.fundDetailList.planList[0].navDate;
				} else {
					lumpsumVm.plan = '';
					lumpsumVm.option = '';
					lumpsumVm.nav = '';
					lumpsumVm.navDate = '';
				}
			}
		}, function(error) {
			utilityService.showErrorMessage(error.responseMessage);
		});
	}

	/** 
	*Function to get Frequency
	@Params:{}
	**/	
	lumpsumVm.getFrequercy = function() {
		mutualFundsService.getFrequercyDetails().then(function(data) {
			lumpsumVm.frequencyObj = data;
			// lumpsumVm.frequency = lumpsumVm.frequencyObj[0].frequencyValue;
			lumpsumVm.selectedFrequency = lumpsumVm.frequency;
			//lumpsumVm.frequency=lumpsumVm.frequencyObj[1].frequencyValue;
			if (lumpsumVm.frequency.toLowerCase() == constantConfig.mfAndsecConst.quarterly) {
				lumpsumVm.minQuarterlyAmount = lumpsumVm.sipMinAmtQuarter.slice(0, -3);
				lumpsumVm.minInstallments= 4;
			}
			if (lumpsumVm.frequency.toLowerCase() == constantConfig.mfAndsecConst.monthly) {
				lumpsumVm.minQuarterlyAmount = lumpsumVm.sipMinAmtMthly.slice(0, -3);
				lumpsumVm.minInstallments = 12;
			}
			lumpsumVm.changeFrequency();
		}, function(error) {
			utilityService.showErrorMessage(error.responseMessage);
		});
	}

	 /**
	 * Check Eligible dates
	 */
	lumpsumVm.checkDate = function() {
		lumpsumVm.endDate = '';
		lumpsumVm.SIPendDate = "";
		lumpsumVm.ShowEndDtLbl = false;
		var currentDate = new Date();
		$translate('SAME_DATE_SIP_ERROR_MESG').then(function(transValue) {
			lumpsumVm.dateErrorMessage = transValue;
		});
		$timeout(function() {
			lumpsumVm.SIPMonthObj = '';
			if (currentDate.getDate() == lumpsumVm.SIPDate) {
				lumpsumVm.SuccessPop = $ionicPopup.show({
					template: '<p>' + lumpsumVm.dateErrorMessage + '</p>',
					title: '',
					cssClass: 'dialog',
					scope: $scope,
					buttons: [{
						text: 'Change',
						type: 'button-positive',
						onTap: function(e) {
							lumpsumVm.SuccessPop.close(); //close the popup after 1 seconds 
							lumpsumVm.disableDate = 1;
							e.preventDefault();
						}
					}, {
						text: 'OK',
						type: 'button-positive',
						onTap: function(e) {
							lumpsumVm.SuccessPop.close(); //close the popup after 1 seconds 
							lumpsumVm.disableDate = 1;
							e.preventDefault();
						}
					}]
				});

				if (lumpsumVm.disableDate == 1) {
					if (currentDate.getMonth() == 11) { //Dec 30 == 30 current date
						lumpsumVm.SIPYear = currentDate.getFullYear() + 1;
						lumpsumVm.SIPMonth = lumpsumVm.getMonthName(0);

					} else {
						lumpsumVm.SIPYear = currentDate.getFullYear();
						lumpsumVm.SIPMonth = lumpsumVm.getMonthName(currentDate.getMonth() + 1);
					}
				}

			} else if (lumpsumVm.SIPDate == "0") {
				lumpsumVm.SIPYear = '';
				lumpsumVm.SIPMonth = '';
			} else if ((currentDate.getDate()) < lumpsumVm.SIPDate) {

				if (currentDate.getMonth() == 1 && lumpsumVm.SIPDate.trim() == "30") {
					lumpsumVm.SIPYear = currentDate.getFullYear();
					lumpsumVm.SIPMonth = lumpsumVm.getMonthName(currentDate.getMonth() + 1);
				} else {
					lumpsumVm.SIPMonth = lumpsumVm.getMonthName(currentDate.getMonth());
					lumpsumVm.SIPYear = currentDate.getFullYear();
				}
			} else if ((currentDate.getDate()) > lumpsumVm.SIPDate) {
				if (currentDate.getMonth() == 11) {
					lumpsumVm.SIPYear = currentDate.getFullYear() + 1;
					lumpsumVm.SIPMonth = lumpsumVm.getMonthName(0);
				} else {
					lumpsumVm.SIPYear = currentDate.getFullYear();
					lumpsumVm.SIPMonth = lumpsumVm.getMonthName(currentDate.getMonth() + 1);
				}
			}

		}, 500);
	}
	
	lumpsumVm.getMonthName = function(month) {
		var monthArray = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sept", "Oct", "Nov", "Dec"];
		return monthArray[month];
	}

	/**
	 *Function to set min amount  
	 **/
	lumpsumVm.SIPcheckMinAmount = function() {
		if(lumpsumVm.amount && lumpsumVm.amount != ""){
			lumpsumVm.showAmntLabel = true;
			lumpsumVm.RequiredAmount = true;
			$timeout(function() {
				document.getElementById('lumsumAmnt').style.setProperty('margin-top', '0%', 'important');
				document.getElementById('lumsumAmnt').style.setProperty('margin-left', '0.6em', 'important');
			},10);
		}
		else{lumpsumVm.showAmntLabel = false;
			lumpsumVm.RequiredAmount = true;
			$timeout(function() {
				document.getElementById('lumsumAmnt').style.setProperty('margin-top', '2%', 'important');
				document.getElementById('lumsumAmnt').style.setProperty('margin-left', '0em', 'important');
			},10);
		}	
		
		if (lumpsumVm.frequency.toLowerCase() == constantConfig.mfAndsecConst.quarterly) {
			lumpsumVm.minQuarterlyAmount = lumpsumVm.sipMinAmtQuarter.slice(0, -3);
		}
		if (lumpsumVm.frequency.toLowerCase() == constantConfig.mfAndsecConst.monthly) {
			lumpsumVm.minQuarterlyAmount = lumpsumVm.sipMinAmtMthly.slice(0, -3);
		}

		if (lumpsumVm.minQuarterlyAmount) {
			$scope.minAmount = parseFloat(lumpsumVm.minQuarterlyAmount.replace(",", ''));
		} else {
			$scope.minAmount = parseFloat(lumpsumVm.minQuarterlyAmount);
		}
		$scope.maxAmount = parseFloat(lumpsumVm.SIPmaxAmount);
		$scope.enteredAmount = parseFloat(lumpsumVm.amount);


		for (var i = 0; i < lumpsumVm.accounts.length; i++) {
			if(lumpsumVm.accounts[i].benAccntNo == lumpsumVm.savingAccounts){
				//lumpsumVm.savingAccounts=lumpsumVm.mfkyc.aofAccountNo;
				lumpsumVm.selectedAccountAmount= lumpsumVm.accounts[i].balance;
				if(parseInt(lumpsumVm.selectedAccountAmount)>0){
				if($scope.enteredAmount > parseInt(lumpsumVm.selectedAccountAmount)) {
					lumpsumVm.SIPsufficiantBalance=false;
				}else{
					lumpsumVm.SIPsufficiantBalance=true;
					lumpsumVm.SIPmaxAmountFlag=true;
				}
				}else{
				lumpsumVm.SIPsufficiantBalance=true;
				lumpsumVm.SIPmaxAmountFlag=true;
				}
			}
		}

			if ($scope.minAmount > $scope.enteredAmount) {
			lumpsumVm.SIPminAmountFlag = false;
			lumpsumVm.SIPmaxAmountFlag = true;
		} else if ($scope.maxAmount < $scope.enteredAmount) {
			lumpsumVm.SIPmaxAmountFlag = false;
			lumpsumVm.SIPminAmountFlag = true;
		} else {
			lumpsumVm.SIPmaxAmountFlag = true;
			lumpsumVm.SIPminAmountFlag = true;
		}
	}

	/**
	 *Function to set Installment ,min amount
	 **/
	lumpsumVm.changeFrequency = function() {
		lumpsumVm.SIPcheckMinAmount();
		if (lumpsumVm.endDate) {
			lumpsumVm.startDate=$filter('date')(new Date(lumpsumVm.SIPDate+" "+lumpsumVm.SIPMonth+" "+lumpsumVm.SIPYear), 'dd MMM yyyy');
			lumpsumVm.sDate=new Date(lumpsumVm.startDate);
	
			lumpsumVm.noOfYearDiffernce = (new Date(lumpsumVm.endDate).getFullYear()-lumpsumVm.sDate.getFullYear())*12;
			lumpsumVm.noOfYearDiffernce -= lumpsumVm.sDate.getMonth()+1;
			lumpsumVm.noOfYearDiffernce += new Date(lumpsumVm.endDate).getMonth();
			lumpsumVm.noOfMonths = lumpsumVm.noOfYearDiffernce;
			lumpsumVm.noOfMonths= lumpsumVm.noOfMonths <= 0?0: lumpsumVm.noOfMonths;
			if (lumpsumVm.noOfMonths>=1) {
				lumpsumVm.noOfMonths= lumpsumVm.noOfMonths+2;
			}else{
				lumpsumVm.noOfMonths= lumpsumVm.noOfMonths+1;
			}
			if (lumpsumVm.frequency.toLowerCase() == constantConfig.mfAndsecConst.quarterly) {
				lumpsumVm.noOfInstallment = ((lumpsumVm.noOfMonths/3)+1);
				lumpsumVm.noOfInstallment = Math.round(lumpsumVm.noOfInstallment);
				lumpsumVm.minInstallments= parseFloat(constantConfig.mfAndsecConst.minInstallments4);
				if(lumpsumVm.noOfInstallment < lumpsumVm.minInstallments){
					utilityService.showErrorMessage(constantConfig.mfAndsecConst.sip4QtrError);
				}
			}
			if (lumpsumVm.frequency.toLowerCase() == constantConfig.mfAndsecConst.monthly) {	                	
				lumpsumVm.noOfInstallment = lumpsumVm.noOfMonths;
				// CHANGE THE MONTH BASED ON SELECTED FREQUENCY
				lumpsumVm.minInstallments= parseFloat(constantConfig.mfAndsecConst.minInstallments12);
				if(lumpsumVm.noOfInstallment < lumpsumVm.minInstallments){
					utilityService.showErrorMessage(constantConfig.mfAndsecConst.sip12MonthsError);
				}
			}
		}
	}

	// function daysInMonth (month, year) {
	// 	return new Date(year, month, 0).getDate();
	// }

	/***Function to openDatePicker***/
	lumpsumVm.startDatePicker = function(){
		//var newDate = new Date();
		// var dateLimit = irctcService.masterData.timeLimit;
		// var dateFromAPI = newDate.addDays(dateLimit);
		var DateStartTmp = new Date(); 
		lumpsumVm.ShowDtLbl = false;
		var DateStartVal = new Date(DateStartTmp.setDate(DateStartTmp.getDate() + 1));
		var DateEndVal = new Date(new Date().setMonth(new Date().getMonth() + 1));
		lumpsumVm.dateObj = {
			callback: function (val) {
					//var startdate = new Date(val);
					if(new Date(val).getDate() == "31"){
						lumpsumVm.ShowEndDtLbl = false;
						lumpsumVm.nextSIPInstallmentDate = "";
						lumpsumVm.startSIPDate = "";
						utilityService.showErrorMessage(constantConfig.mfAndsecConst.sip31stDateErrorMsg);
						return false;
					}
					var startdate = $filter('date')(new Date(val), 'dd MMM yyyy');
					lumpsumVm.startSIPDate =  $filter('formatSIPStartEndDate')(startdate);
					lumpsumVm.ShowDtLbl = true;
					lumpsumVm.endDate = "";
					lumpsumVm.SIPendDate = "";
					if (lumpsumVm.perpetualCheck) {
						lumpsumVm.endDate = constantConfig.mfAndsecConst.perpetualDate;
					}
					lumpsumVm.ShowEndDtLbl = false;
					lumpsumVm.SIPDate = startdate.split(' ')[0];
					lumpsumVm.SIPMonth = startdate.split(' ')[1];
					lumpsumVm.SIPYear = startdate.split(' ')[2];
					lumpsumVm.startDate = $filter('date')(new Date(lumpsumVm.SIPDate + " " + lumpsumVm.SIPMonth + " " + lumpsumVm.SIPYear), 'dd MMM yyyy');
					var selectedDate = new Date(val);
					if (lumpsumVm.frequency.toLowerCase() == constantConfig.mfAndsecConst.quarterly) {
						var expiry = selectedDate.getMonth() == 11 ? new Date(selectedDate.getFullYear()+1, 0 , selectedDate.getDate()) : new Date(selectedDate.getFullYear(), selectedDate.getMonth() + 3, selectedDate.getDate());
						//if(expiry.getMonth() - selectedDate.getMonth() != 4){
							//var nextDate = daysInMonth(expiry.getMonth(),expiry.getFullYear());
							//expiry = new Date(expiry.getFullYear(), selectedDate.getMonth() + 2, 1)
						//}
						lumpsumVm.nextSIPInstallmentDate = $filter('date')(expiry, 'dd MMM yyyy');
					}
					if (lumpsumVm.frequency.toLowerCase() == constantConfig.mfAndsecConst.monthly) {
						var expirydt = selectedDate.getMonth() == 11 ? new Date(selectedDate.getFullYear()+1, 0 , selectedDate.getDate()) : new Date(selectedDate.getFullYear(), selectedDate.getMonth() + 1, selectedDate.getDate());
						if(expirydt.getMonth() - selectedDate.getMonth() != 1){
							//var nextDate = daysInMonth(expiry.getMonth(),expiry.getFullYear());
							expirydt = new Date(expirydt.getFullYear(), selectedDate.getMonth() + 2, 1)
						}
						lumpsumVm.nextSIPInstallmentDate = $filter('date')(expirydt, 'dd MMM yyyy');	
					}
					
					if (ionic.Platform.isIOS()) {
						$timeout(function() {
							lumpsumVm.ShowDtLbl = false;
							lumpsumVm.ShowDtLbl = true;
						},1000);
					}
					
					lumpsumVm.nextSIPInstallmentDate = $filter('formatSIPInstallmentDate')(lumpsumVm.nextSIPInstallmentDate);
					$rootScope.nextSIPInstallmentDt = $filter('formatSIPInstallmentDate')(lumpsumVm.startDate);
				},
				inputDate: DateStartVal,
				from: DateStartVal,
				to: DateEndVal,
				mondayFirst: true,
				monthsList: ["JAN", "FEB", "MAR", "APR", "MAY", "JUN", "JUL", "AUG", "SEP", "OCT", "NOV", "DEC"],
				closeOnSelect: false,
				templateType: 'popup',
				dateFormat: 'dd MMM yyyy'

		};
		ionicDatePicker.openDatePicker(lumpsumVm.dateObj);
	};
	
	lumpsumVm.endDatePicker = function() {
		var date=lumpsumVm.SIPDate+"-"+lumpsumVm.SIPMonth+"-"+lumpsumVm.SIPYear;
		if (!lumpsumVm.endDate) {
			//lumpsumVm.endDatePickerDiv.inputDate = new Date(date.replace(/\s+/g, ''));
			//lumpsumVm.endDatePickerDiv.from = new Date(date.replace(/\s+/g, ''));
			var DateEndTmp = new Date(date.replace(/\s+/g, ''));
			var addOneYrDiff = '';
			if (lumpsumVm.frequency.toLowerCase() == constantConfig.mfAndsecConst.quarterly) {
				addOneYrDiff = new Date(DateEndTmp.setMonth(DateEndTmp.getMonth() + 9));
			}
			if (lumpsumVm.frequency.toLowerCase() == constantConfig.mfAndsecConst.monthly) {
				addOneYrDiff = new Date(DateEndTmp.setMonth(DateEndTmp.getMonth() + 11));
			}
			
			//var addOneYrDiff = new Date(DateEndTmp.setFullYear(DateEndTmp.getFullYear() + 1));
			lumpsumVm.endDatePickerDiv.inputDate = addOneYrDiff;
			lumpsumVm.endDatePickerDiv.from = addOneYrDiff;
			lumpsumVm.endDatePickerDiv.to = "Wed Dec 31 2099 00:00:00 GMT+0530 (IST)";
		} else {
			lumpsumVm.endDatePickerDiv.inputDate = new Date(lumpsumVm.endDate);
	        lumpsumVm.endDatePickerDiv.from = new Date(lumpsumVm.endDate);
			lumpsumVm.endDatePickerDiv.to = "Wed Dec 31 2099 00:00:00 GMT+0530 (IST)";

		}
		ionicDatePicker.openDatePicker(lumpsumVm.endDatePickerDiv);

	};
	lumpsumVm.endDatePickerDiv = {
		callback: function(val) {
			lumpsumVm.EndDtErrorShow = false;
			var date = $filter('date')(new Date(val), 'dd MMM yyyy');
			var filterDate=date.split(' ');
			lumpsumVm.endDate= new Date(lumpsumVm.SIPDate+" "+filterDate[1]+" "+filterDate[2]);
			lumpsumVm.endDate= $filter('date')(lumpsumVm.endDate, 'dd MMM yyyy');
			lumpsumVm.SIPendDate = $filter('formatSIPStartEndDate')(lumpsumVm.endDate);
			lumpsumVm.ShowEndDtLbl = true;
			lumpsumVm.startDate=$filter('date')(new Date(lumpsumVm.SIPDate+" "+lumpsumVm.SIPMonth+" "+lumpsumVm.SIPYear), 'dd MMM yyyy');
			lumpsumVm.sDate=new Date(lumpsumVm.startDate);
			lumpsumVm.noOfYearDiffernce = (new Date(lumpsumVm.endDate).getFullYear() - lumpsumVm.sDate.getFullYear()) * 12;
			lumpsumVm.noOfYearDiffernce -= lumpsumVm.sDate.getMonth() + 1;
			lumpsumVm.noOfYearDiffernce += new Date(lumpsumVm.endDate).getMonth();
			lumpsumVm.noOfMonths = lumpsumVm.noOfYearDiffernce;
			lumpsumVm.noOfMonths= lumpsumVm.noOfMonths <= 0?0: lumpsumVm.noOfMonths;
			if (lumpsumVm.noOfMonths>=1) {
				lumpsumVm.noOfMonths= lumpsumVm.noOfMonths+2;
			}else{
				lumpsumVm.noOfMonths= lumpsumVm.noOfMonths+1;
			}
			if (lumpsumVm.frequency.toLowerCase() == constantConfig.mfAndsecConst.quarterly) {
				lumpsumVm.noOfInstallment = (Math.round(lumpsumVm.noOfMonths/3)+1);
				lumpsumVm.minInstallments= parseFloat(constantConfig.mfAndsecConst.minInstallments4);
				if(lumpsumVm.noOfInstallment < lumpsumVm.minInstallments){
					//utilityService.showErrorMessage(constantConfig.mfAndsecConst.sip4QtrError);
					lumpsumVm.EndDtErrorShow = true;
					lumpsumVm.EndDateerrorMessage = constantConfig.mfAndsecConst.sip4QtrError;

				}
			}
			if (lumpsumVm.frequency.toLowerCase() == constantConfig.mfAndsecConst.monthly) {
				lumpsumVm.noOfInstallment = lumpsumVm.noOfMonths;
				// CHANGE THE MONTH BASED ON SELECTED FREQUENCY
				lumpsumVm.minInstallments= parseFloat(constantConfig.mfAndsecConst.minInstallments12);
				if(lumpsumVm.noOfInstallment < lumpsumVm.minInstallments){
					lumpsumVm.EndDtErrorShow = true;
					lumpsumVm.EndDateerrorMessage = constantConfig.mfAndsecConst.sip12MonthsError;
					//utilityService.showErrorMessage(constantConfig.mfAndsecConst.sip12MonthsError);
				}
			}
			if (ionic.Platform.isIOS()) {
				$timeout(function() {
					lumpsumVm.ShowEndDtLbl = false;
					lumpsumVm.ShowEndDtLbl = true;
				},1000);
				//document.getElementsByClassName('mfDateInputLbl')[0].classList.remove('mfInvestTabSelected');
			}
		},
		monthsList: ["JAN", "FEB", "MAR", "APR", "MAY", "JUN", "JUL", "AUG", "SEP", "OCT", "NOV", "DEC"],
		dateFormat: 'dd MMM yyyy',
		closeOnSelect: false,
		templateType: 'popup'
	};

	/***Function to show information POP UP***/
	lumpsumVm.showInformationPopup = function() {
		$ionicPopup.show({
			template: '<p>Message</p>',
			title: 'Information',
			scope: $scope,
			buttons: [{ text: 'Ok' }]
		});
		infoPopup.then(function(res) {
		});
	}

		/***Function to show information POP UP***/
	lumpsumVm.SIPshowInformationPopupRef= function() {
		$ionicPopup.show({
			template: '<p>'+lumpsumVm.SIPrefCodeContentMessage+'</p>',
			title:'Information',
			scope: $scope,
			cssClass: 'dialog',		
			buttons: [
			{
				text: 'Ok'
			}
			]
		});           
	}

	lumpsumVm.numberSuffix = function(i) {
		var j = i % 10;
		var	k = i % 100;
		if (j == 1 && k != 11) {
			return i + "st";
		}
		if (j == 2 && k != 12) {
			return i + "nd";
		}
		if (j == 3 && k != 13) {
			return i + "rd";
		}
		return i + "th";
	}

	/***Click Function to pass data to service Start***/
	lumpsumVm.submitSIP = function() {
		if(!lumpsumVm.SIPisTermsAndConditionChecked){
			lumpsumVm.SIPisTermsAndConditionError = true;
			//utilityService.showErrorMessage("Please accept Terms and Condition");
			return false;
		}
		
		else{
			lumpsumVm.finalSubmitSIP();
		}
		
	}			
	
	lumpsumVm.finalSubmitSIP = function() {
		var reqParams = {};
		var requestSecKey = '';

			angular.forEach(mutualFundsService.multiFolio.portFolio, function (value, key) {
				if (value.isLotusfolio.toLowerCase() == "yes") {
					lumpsumVm.isLotusFolio=value.isLotusfolio;
					lumpsumVm.isLotusFolioNumber=value.folioNumber;
					if(value.fundList!=null || value.fundList!=undefined){
					if(value.fundList.length>0){
					if(value.fundList[0].amfiCode==lumpsumVm.fundId){
						lumpsumVm.SIPType = constantConfig.mfAndsecConst.SIPAdditional;
						reqParams["txnType"] = constantConfig.mfAndsecConst.SIPAdditional;
					}
					}
				}
				}
			});
		
		
		if (!lumpsumVm.SIPisTermsAndConditionChecked) {
			return false;
		}
		if (lumpsumVm.SIPfolio && lumpsumVm.isLotusFolio) {
			if(lumpsumVm.SIPType == undefined || lumpsumVm.SIPType == null || lumpsumVm.SIPType == ''){
					reqParams["txnType"] = constantConfig.mfAndsecConst.SIPFresh;
			}
		} else {
				if(lumpsumVm.SIPType =='' || lumpsumVm.SIPType == undefined || lumpsumVm.SIPType == null){
				reqParams["txnType"] = constantConfig.mfAndsecConst.SIPFresh;
			}
			// reqParams["txnType"] = constantConfig.mfAndsecConst.SIPFresh;
		}

		if(lumpsumVm.option.indexOf('D') == -1){
			lumpsumVm.SIPdividendOption = "";
		}

		lumpsumVm.txnId = utilityService.getRandomNumber();
		clickStreamService.clickStreamData = lumpsumVm.txnId;
			var requestDate = new Date();
		requestDate = requestDate.getTime()
		requestSecKey=Math.floor((Math.random()) + requestDate);
		requestSecKey = (requestSecKey * 10 + 1);

		reqParams["schemeId"] = lumpsumVm.schemeCode;
		reqParams["schemeName"] = lumpsumVm.fundDetailList.fundName;
		reqParams["schemePlan"] = lumpsumVm.plan;
		reqParams["schemeOption"] = lumpsumVm.option;
		reqParams["transactionType"] = lumpsumVm.SIPtransactionType;
		reqParams["startDate"] = $filter('date')(new Date(lumpsumVm.startDate), 'dd/MM/yyyy');
		reqParams["endDate"] = $filter('date')(new Date(lumpsumVm.endDate), 'dd/MM/yyyy');
		reqParams["amount"] = lumpsumVm.amount;
		reqParams["units"] = "";
		reqParams["accountNo"] = lumpsumVm.savingAccounts;
		reqParams["frequency"] = lumpsumVm.frequency;
		reqParams["isPerpetual"] = lumpsumVm.perpetualCheck;
		reqParams["amcCode"] = lumpsumVm.amcCode
		reqParams["folioNo"] = lumpsumVm.SIPfolio;
		reqParams["txnDate"] = "";
		reqParams["txnTime"] = "";
		reqParams["sipRegisteredDate"] = "";
		reqParams["numberOfInstallments"] = lumpsumVm.noOfInstallment;
			reqParams["euin"] = lumpsumVm.SIPrefCode;
		reqParams["installmentNumber"] = "";
		reqParams["bankName"] = "";
		reqParams["bankCode"] = "";
		reqParams["bankCity"] = "";
		reqParams["accountType"] = "";
		reqParams["panNo"] = lumpsumVm.panCard;
		reqParams["customerTermandCondition"] = lumpsumVm.SIPisTermsAndConditionChecked;
		reqParams["branchName"] = "";
		reqParams["targetSchemeId"] = '';
		reqParams["targetSchemeName"] = '';
		reqParams["targetSchemePlan"] = '';
		reqParams["targetSchemeOption"] = '';
		reqParams["dividendOption"] = lumpsumVm.SIPdividendOption;
		reqParams["divPayoutMechanism"] = lumpsumVm.divPayOutMechanism;
		reqParams["redPayoutMechanism"] = lumpsumVm.redPayOutMechanism;
		reqParams["txnId"] = lumpsumVm.txnId;
		reqParams["amfiCode"] = lumpsumVm.fundId;
		reqParams["closeAc"]='';
		reqParams["secKey"] = requestSecKey;
		

			var optnNmLbl = "";
			if(lumpsumVm.fundObj.isNfo=='Y'){
				if(lumpsumVm.fundDetailList.planList){
					if(lumpsumVm.fundDetailList.planList[0].option == 'G'){optnNmLbl = 'Growth';}
					else{optnNmLbl = 'Dividend';}
				}
				$rootScope.fundName = lumpsumVm.fundDetailList.fundName.split('-')[0]+" - Regular plan - "+optnNmLbl;
			}
			else{
				if(lumpsumVm.fundDetailList.planList){
					if(lumpsumVm.fundDetailList.planList[0].option == 'G'){optnNmLbl = 'Growth';}
					else{optnNmLbl = 'Dividend';}
				}
				$rootScope.fundName = lumpsumVm.fundDetailList.fundName.split('-')[0]+"- Regular plan - "+optnNmLbl;
			}
			$rootScope.unitName=constantConfig.mfAndsecConst.amount;
			$rootScope.amountToPay=lumpsumVm.amount;
		mutualFundsService.addInvedtedAmount(lumpsumVm.amount); //for OTP page showing
		mutualFundsService.payDuesRequest(reqParams).then(function(data) {
			$rootScope.sipotpPage=1;
			$rootScope.lumsumotpPage=0;
			$rootScope.swpotpPage=0;
			$rootScope.stpotpPage=0;
			$rootScope.redeemotpPage=0;
			$rootScope.cancelotpPage=0;
			$rootScope.switchotpPage=0;
			if (data.submitRequest.isOTPRequired == "true") {
					$rootScope.amount=mutualFundsService.getInvedtedAmount(); 
				$state.go('menu.sipOTP');
			} else {
				var calCulatedKey = mutualFundsService.verifySecKey(parseInt(data.submitRequest.secKey));
				if (requestSecKey == calCulatedKey) {
					lumpsumVm.message = data.submitRequest.status;
					lumpsumVm.transactionReferenceNo = data.submitRequest.transactionReferenceNo;	                        
						lumpsumVm.createSIPPage = 0;
						lumpsumVm.SIPsuccessPage = 1;
						lumpsumVm.SIPreviewPage = 0;
						lumpsumVm.amount = $rootScope.amountToPay;
							lumpsumVm.transactionDate = new Date(data.submitRequest.transactionDate);
						utilityService.setCsatJournies("mutualFunds");	                        
				}
			}
		}, function(error) {
			utilityService.showErrorMessage(error.responseMessage);
		});
	}

	//SIP validate OTP function
	$scope.SIPvalidateOTP = function() {
		var reqParams = {};
		var requestSecKey = '';
		var requestDate = new Date();
		requestDate = requestDate.getTime();
		requestSecKey=Math.floor((Math.random()) + requestDate);
		requestSecKey = (requestSecKey * 10 + 1);


		reqParams.otp = $scope.enterOTP;
		reqParams.secKey = requestSecKey;
		reqParams.txnType = "createSIP";
		mutualFundsService.validateOTPForPayment(reqParams).then(function(data) {
			console.log(JSON.stringify(data));
			if (data.data.otpStatus == "0000") {
				var calculatedKey = mutualFundsService.verifySecKey(parseInt(data.data.secKey));
				if (requestSecKey == calculatedKey) {
					//getAccountDetailsService.accountOverviewData="";
					$rootScope.sipSuccessPage = 1;
					$rootScope.redeemSuccessPage=0;
				$rootScope.swpSuccessPage=0;
				$rootScope.switchSuccessPage=0;
				$rootScope.stpSuccessPage=0;
				$rootScope.lumsumSuccessPage=0;		                 		
				$rootScope.cancelSuccessPage=0;
				$rootScope.commonErrorPage=0;
				$rootScope.cancelbtnHide=0;
				$rootScope.transactionSIPMessage = data.data.transactionMsg; 
					$rootScope.transactionReferenceNo = data.data.transactionReferenceNo;
					//$rootScope.fundName =  $rootScope.fundName;	                      
					$rootScope.transactionDate = new Date(data.data.transactionDate);
					utilityService.setCsatJournies("mutualFunds");
					 $state.go('menu.sipPaymentSuccess');
				}
			} else if (data.data.otpStatus != "0000") {
				if(data.data.transactionReferenceNo != "" || data.data.transactionReferenceNo != null){
					$rootScope.sipSuccessPage = 0;
					$rootScope.redeemSuccessPage=0;
					$rootScope.swpSuccessPage=0;
					$rootScope.switchSuccessPage=0;
					$rootScope.stpSuccessPage=0;
					$rootScope.lumsumSuccessPage=0;		                 		
					$rootScope.cancelSuccessPage=0;
					$rootScope.commonErrorPage=1;
					$rootScope.cancelbtnHide=0;
					$rootScope.transactionReferenceNo = data.data.transactionReferenceNo;
					//$rootScope.fundName =  $rootScope.fundName;
					$rootScope.transactionDate = new Date(data.data.transactionDate);
					 $state.go('menu.sipPaymentSuccess');
				}
				else{
					mutualFundsService.clearOTP();
					$scope.errorMessage = data.responseMessage;
				}	
			} else {	                   
				lumpsumVm.showErrorInformationPopup(error.responseMessage);
			}
		},function(error){
			//utilityService.showErrorMessage(error.responseMessage);
			//$state.go('menu.accountOverviewMyBalance');
			lumpsumVm.showErrorInformationPopup(error.responseMessage);
		})

	}

	lumpsumVm.SIPopenReviewPage = function() {
		lumpsumVm.SIPisTermsAndConditionError = false;
		if(!lumpsumVm.amount || lumpsumVm.amount =="" || lumpsumVm.EndDtErrorShow || !lumpsumVm.SIPmaxAmountFlag || !lumpsumVm.SIPminAmountFlag || createSIPform.$invalid || !lumpsumVm.endDate || !lumpsumVm.SIPsufficiantBalance || !lumpsumVm.startSIPDate)
		{
			if(!lumpsumVm.amount || lumpsumVm.amount ==""){
				lumpsumVm.RequiredAmount = false;
			}
			if(!lumpsumVm.endDate){lumpsumVm.RequiredEndDt = false;} 
			if(!lumpsumVm.startSIPDate){lumpsumVm.RequiredStartDt = false;}
			return false;
		}
		else{
			if (lumpsumVm.SIPminAmountFlag && lumpsumVm.SIPmaxAmountFlag) {
				if (lumpsumVm.perpetualCheck) {
					lumpsumVm.endDate = $filter('date')(new Date(constantConfig.mfAndsecConst.perpetualDate), 'dd MMM yyyy');
					lumpsumVm.startDate = $filter('date')(new Date(lumpsumVm.SIPDate + " " + lumpsumVm.SIPMonth + " " + lumpsumVm.SIPYear), 'dd MMM yyyy');
					lumpsumVm.sDate = new Date(lumpsumVm.SIPDate + "-" + lumpsumVm.SIPMonth + "-" + lumpsumVm.SIPYear);
					lumpsumVm.noOfYearDiffernce = (new Date(lumpsumVm.endDate).getFullYear() - lumpsumVm.sDate.getFullYear()) * 12;
					lumpsumVm.noOfYearDiffernce -= lumpsumVm.sDate.getMonth() + 1;
					lumpsumVm.noOfYearDiffernce += (new Date(lumpsumVm.endDate).getMonth() + 1);
					lumpsumVm.noOfMonths = lumpsumVm.noOfYearDiffernce;
					if (lumpsumVm.frequency.toLowerCase() == constantConfig.mfAndsecConst.quarterly) {
						lumpsumVm.noOfInstallment = Math.round(lumpsumVm.noOfMonths / 3);
					}
					if (lumpsumVm.frequency.toLowerCase() == constantConfig.mfAndsecConst.monthly) {
						lumpsumVm.noOfInstallment = Math.round(lumpsumVm.noOfMonths);
					}
				}
				lumpsumVm.SIPisTermsAndConditionChecked = 0;
				lumpsumVm.createSIPPage = 0;
				lumpsumVm.SIPsuccessPage = 0;
				lumpsumVm.SIPreviewPage = 1;

				if(lumpsumVm.option=='D'){lumpsumVm.planOptnNm = "Dividend";}
				if(lumpsumVm.option=='G'){lumpsumVm.planOptnNm = "Growth";}
				if(lumpsumVm.option=='DM'){lumpsumVm.planOptnNm = "Dividend Monthly";}
				if(lumpsumVm.option=='DY'){lumpsumVm.planOptnNm = "Dividend Yearly";}
				if(lumpsumVm.option=='DQ'){lumpsumVm.planOptnNm = "Dividend Quarterly";}
				if(lumpsumVm.option=='DW'){lumpsumVm.planOptnNm = "Dividend Weekly";}
				if(lumpsumVm.option=='DD'){lumpsumVm.planOptnNm = "Dividend Daily";}
				if(lumpsumVm.option=='DF'){lumpsumVm.planOptnNm = "Dividend Fortnightly";}
				if(lumpsumVm.option=='DA'){lumpsumVm.planOptnNm = "Dividend Annually";}				

				lumpsumVm.planOptnNm = lumpsumVm.plan+" "+lumpsumVm.planOptnNm;
			}
		}	
	}

	/***Start term and Condition***/
	lumpsumVm.SIPtermsAndConditions = function() {
		if (lumpsumVm.SIPtermsAndConditionsFlag == 1) {
			lumpsumVm.SIPtermsAndConditionsFlag = 0;
		} else {
			/** Call service to fetch termsConditionsMessage**/
			lumpsumVm.reqParams = {};
			lumpsumVm.reqParams['action'] = constantConfig.mfAndsecConst.sysInvestPlanTermsAndC;
			mutualFundsService.getTermsAndConditions(lumpsumVm.reqParams).then(function(data) {
				lumpsumVm.SIPtermsAndConditionsMessage = data.message;

			}, function(error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
			lumpsumVm.SIPtermsAndConditionsFlag = 1;
		}
	}
	/***BACK tO page***/
	lumpsumVm.SIPbackPage = function() {
		lumpsumVm.createSIPPage = 1;
		lumpsumVm.SIPreviewPage = 0;
		lumpsumVm.SIPsuccessPage = 0;
		if(lumpsumVm.SIPdividendOption == "Y"){
			$timeout(function() {
				document.getElementById("SIPdividentOption").checked = true;
			},10);
	  	}
		lumpsumVm.SIPcheckMinAmount();
		lumpsumVm.hgtAdjst();
	}

	lumpsumVm.backHandling = function(){
		if((lumpsumVm.lumpsomPage == 1 || lumpsumVm.lumpsomPageNFO==1) && (lumpsumVm.SIPreviewPage == 0)){
			$ionicHistory.goBack();
		}
		if(lumpsumVm.SIPreviewPage == 1){lumpsumVm.SIPbackPage()}
		if(lumpsumVm.reviewPage == 1 || lumpsumVm.reviewNFOPage == 1){lumpsumVm.backToLumpsum()}
	}

	lumpsumVm.setEndDate = function() {
		if (lumpsumVm.perpetualCheck) {
			lumpsumVm.endDate = constantConfig.mfAndsecConst.perpetualDate;
			lumpsumVm.SIPendDate = $filter('formatSIPStartEndDate')(lumpsumVm.endDate);
			lumpsumVm.ShowEndDtLbl = true;
			lumpsumVm.RequiredEndDt = true;
		} else {
			lumpsumVm.endDate = "";
			lumpsumVm.SIPendDate = "";
			lumpsumVm.ShowEndDtLbl = false;
			lumpsumVm.RequiredEndDt = true;
		}

	}

	lumpsumVm.SIPdividentOptionCheck = function() {
		lumpsumVm.SIPdividendOption = ""; //N payout Y reinvest
		if(document.getElementById("SIPdividentOption").checked){
			lumpsumVm.SIPdividendOption = "Y";
			lumpsumVm.SIPdividendoptnNm = "Reinvest";
		}
		else{
			lumpsumVm.SIPdividendOption = "N";
			lumpsumVm.SIPdividendoptnNm = "Payout";
		}
	}

		//---------------SIP function end------------------------------------------------------------------------------
		

	lumpsumVm.dividentOptionCheck = function() {
		lumpsumVm.dividendOption = ""; //N payout Y reinvest
		if(document.getElementById("dividentOption").checked){
			lumpsumVm.dividendOption = "Y";
			lumpsumVm.dividendoptnNm = "Reinvest";
		}
		else{
			lumpsumVm.dividendOption = "N";
			lumpsumVm.dividendoptnNm = "Payout";
		}
	}

	var template_MPIN_HINT = '<ion-popover-view class="quickpay loginnewarrow hmbr-info mfperpetual-hint-popover" id="runtimeHeight" style="{{userLoginVm.topStyle}}">' + '<div class="username-hint-arrow-upnew"></div>' +
															'<ion-content class="nfs-popover" style="margin: 0px !important;">' +
															'<div id="renderHeight" class="padding-right-10 font-size-12" style="padding-left: 14px !important;">' +
															'<div class="roboto-regular font-sixe-12 color3f3f3f" style="text-align:justify !important;">SIP will continue till you Cancel</div>' +
															'</div>' + '</ion-content>' + '</ion-popover-view>';
	lumpsumVm.perpetualInfo = function($event){
		$scope.popover_hint = $ionicPopover.fromTemplate(template_MPIN_HINT, {
			scope : $scope
		});
		$scope.popover_hint.show($event);
	}

		
		/*** actions to done everytime the view is shown***/	
		$scope.$on('$ionicView.beforeEnter', function() {
			initPage();
			
		});
		return this;
	}]);

