
/******* Mutual Funds Controller ******/

'use strict';
angularApp.controller('mutualFundsController', 
	["$state","$scope","mutualFundsService","utilityService","$ionicSlideBoxDelegate","$rootScope","constantConfig","$ionicLoading","homeScreenService","$filter","mPinLoginService",
				 
function ($state,$scope,mutualFundsService,utilityService,$ionicSlideBoxDelegate,$rootScope,constantConfig,$ionicLoading,homeScreenService,$filter,mPinLoginService) {
	
	var mutualFundsVm = this;  
	$scope.isLoggedIn = mPinLoginService.isLoggedIn;  
	
	/*** Initialize the variables that has to show in  the HTML come here ***/
	function initPage(){
		mutualFundsVm.getAllInfoList();
		//mutualFundsVm.fundsListInMF=mutualFundsService.getFundList();
		//if(!mutualFundsVm.fundsListInMF){
			mutualFundsVm.getAllPopularFunds();
			
		//}
	}
	
	/*** Function to go to Mutual Funds Introduction Page  ***/
	mutualFundsVm.getAllPopularFunds=function (){
		 /*** Call service to fetch funds list**/
		
			mutualFundsService.getAllMutualFunds().then(function(data) {
			mutualFundsVm.popularFunds=data.fundList;
			mutualFundsVm.fundList=[];
			var popularFundsLength = mutualFundsVm.popularFunds.length;
			for(mutualFundsVm.list=0;mutualFundsVm.list<popularFundsLength ; mutualFundsVm.list++ ){
				if(mutualFundsVm.popularFunds[mutualFundsVm.list].fundSchemeName==constantConfig.mfAndsecConst.popularFunds){
					mutualFundsVm.fundList=mutualFundsVm.popularFunds[mutualFundsVm.list].fundSchemeList;					
				}
				if(mutualFundsVm.popularFunds[mutualFundsVm.list].fundSchemeName==constantConfig.mfAndsecConst.nfoList){
					for(var i = 0;i<mutualFundsVm.popularFunds[mutualFundsVm.list].fundSchemeList.length; i++ ){
						mutualFundsVm.fundList.push(mutualFundsVm.popularFunds[mutualFundsVm.list].fundSchemeList[i]);		
					}
								
				}							
			}
			// if($rootScope.successPageNFO==1){
			// 	mutualFundsVm.fundListPage();
			// 	$rootScope.successPageNFO=0;
			// }
			 /*** to resolve ionic slider ng-repeat issue .***/			
			$ionicSlideBoxDelegate.update();
			mutualFundsVm.fundList1 = data.fundList; 
			if(mutualFundsVm.fundList1.length > 0 && mutualFundsVm.fundList1[0].fundSchemeName != "All funds"){
				var temparay=[]; 
				for (var k = 0; k <mutualFundsVm.fundList1.length; k++) {
					if(mutualFundsVm.fundList1[k].fundSchemeName == "Popular Funds"){
						mutualFundsVm.fundList1[k].fundSchemeName = "Popular";
					}
					for (var j = 0; j <mutualFundsVm.fundList1[k].fundSchemeList.length; j++){ 	
						if(mutualFundsVm.fundList1[k].fundSchemeName != "NFO" && mutualFundsVm.fundList1[k].fundSchemeName != "Popular"){	
							temparay.push(mutualFundsVm.fundList1[k].fundSchemeList[j]); 
						}
					}		
				}
				//var unique = (arr, props = []) => [...new Map(arr.map(entry => [props.map(k => entry[k]).join('|'), entry])).values()]; 
				//temparay = unique(temparay, ['fundId']);
				temparay = $filter('uniqueArr')(temparay, 'fundId');
				var allfndsObj = {'fundSchemeList':temparay,'fundSchemeName':"All funds"};
				mutualFundsVm.fundList1.splice(0, 0, allfndsObj);
			}

		}, function(error) {
			utilityService.showErrorMessage(error.responseMessage);
		}); 
	}	
	/*** Call service to fetch IMAGE list**/
	mutualFundsService.GetMFPopularImageResponse().then(function(data) {
		mutualFundsVm.popularFundsImageList=data.popularFundsList;
		/*** to resolve ionic slider ng-repeat issue .***/
		$ionicSlideBoxDelegate.update();  
	}, function(error) {
		utilityService.showErrorMessage(error.responseMessage);
	}); 



	/*** Function to show next slide***/
	$rootScope.goToNextSlide = function() {
		$ionicSlideBoxDelegate.next();
	 }
	 
	/*** Function to show Previous slide***/
	$rootScope.goToPreviousSlide = function() {
		$ionicSlideBoxDelegate.previous();
	 }
	 
	/*** Function to go to Mutual Funds Introduction Page  ***/
	mutualFundsVm.introMutualFunds=function (){
		$state.go('menu.introMutualFunds');
	}
	
	/*** Function to go to Mutual Funds List Page  ***/
	mutualFundsVm.fundListPage=function (){
		homeScreenService.ishamburgerMenuViewMF=false;
		var nfoArray=[];
		mutualFundsService.getAllMutualFunds().then(function (data) {
                    if(data.fundList.length > 5){
                    angular.forEach(data, function (value, key) {
                        for(var i in value){
                          if (value[i].fundSchemeName == "NFO") {
                           nfoArray.push(data.fundList[i]);
                           data.fundList.splice(i,1);
                           data.fundList.splice(1,0,nfoArray[0]);
                        }  
                    }                    
                });
                }
                    
                    //data.fundList.splice(1,0,data.fundList[4])
                    mutualFundsVm.popularFunds = data.fundList;
                    mutualFundsService.addFundList(mutualFundsVm.popularFunds);
                    $ionicLoading.hide();
                    mutualFundsService.setPageId('quickBuy');
					mutualFundsService.addNewFundDetails("false");
                    $state.go('menu.mutualFundsList');
                }, function (error) {
                    $ionicLoading.hide();
                    utilityService.showErrorMessage(error.responseMessage);
                });
		
	}
	
	/*** Function to go to Start investing page  ***/
	mutualFundsVm.helpMeInvest=function (){
		$state.go('menu.startInvesting');
		
	}
	
	/*** Function to go to Mutual Funds Detail Page  ***/
	mutualFundsVm.fundDetails=function (fundObj){
		var fundoptnArr = [];
		if(fundObj.isNfo == "Y"){
			var id = fundObj.fundName;
			fundoptnArr.push(fundObj);
			//mutualFundslistVm.fundList[0].fundSchemeList mutualFundsVm.fundList1
			for (var i = 0; i <mutualFundsVm.fundList1.length; i++) {
				for (var j = 0; j <mutualFundsVm.fundList1[i].fundSchemeList.length; j++){ 
					if(mutualFundsVm.fundList1[i].fundSchemeName == "NFO"){
						if(mutualFundsVm.fundList1[i].fundSchemeList[j].fundName == id){
							fundoptnArr.push(mutualFundsVm.fundList1[i].fundSchemeList[j]);
						}
					}
				}	
			}
		 }
		 else{
			var schFndID = fundObj.schemeFundId;
			//var fundoptnArr = [];
			fundoptnArr.push(fundObj);
			//mutualFundslistVm.fundList[0].fundSchemeList
			for (var k = 0; k <mutualFundsVm.fundList1[0].fundSchemeList.length; k++) {
				//fundObj.fundId
				if(mutualFundsVm.fundList1[0].fundSchemeList[k].schemeFundId == schFndID){
					fundoptnArr.push(mutualFundsVm.fundList1[0].fundSchemeList[k]);
				}
			}
		 }
		//var unique = (arr, props = []) => [...new Map(arr.map(entry => [props.map(k => entry[k]).join('|'), entry])).values()]; 
		//fundoptnArr = unique(fundoptnArr, ['fundId']);
		fundoptnArr = $filter('uniqueArr')(fundoptnArr, 'fundId');
		if(fundoptnArr[0].fundOption != "G"){
			var indexOfG = $filter('findIndexByKeyValue')(fundoptnArr,'fundOption', 'G');
			if(indexOfG != -1){ fundoptnArr.unshift(fundoptnArr.splice(indexOfG, 1)[0]);}
		}
		mutualFundsService.addFundId(fundoptnArr);
		$state.go('menu.fundDetails');
	}
	
	/*** Function to go to Back to Account overview Page  ***/
	mutualFundsVm.goToHome=function (){
		$state.go('menu.accountOverviewMyBalance');
	}
	
	/*** Function to go to Mutual Funds Introduction Page  ***/
	mutualFundsVm.getAllInfoList=function (){
		 /*** Call service to fetch funds list**/
		mutualFundsService.getAllInfoLists().then(function(data) {
			mutualFundsService.addInfoList(data.infoList);
		}, function(error) {
			utilityService.showErrorMessage(error.responseMessage);
		}); 
	
	}	
	/*** actions to done everytime the view is shown***/
	$scope.$on('$ionicView.beforeEnter', function() {
		initPage();
	});
	
	
	
	return this;
}]);

