
/*******Portfolio  Controller ******/
'use strict';

angularApp.controller('portfolioController', 
						["$timeout",
						 "$state",
						 "$scope",
						 "$translate",
						 "$location","$ionicPopup",
						 "$ionicScrollDelegate","mutualFundsService","$rootScope","$ionicSlideBoxDelegate","utilityService","$filter","constantConfig","$ionicLoading","clickStreamService","homeScreenService",
						 "leadGenerationService","newCardService","loggedInUserService",
				 
function ($timeout,
		 $state,
		 $scope,
		 $translate,
		 $location,$ionicPopup,
		 $ionicScrollDelegate,mutualFundsService,$rootScope,$ionicSlideBoxDelegate,utilityService,$filter,constantConfig,$ionicLoading,clickStreamService,homeScreenService,
		 leadGenerationService,newCardService,loggedInUserService) {
	
	
	var portfolioVm = this;
	
	/**
	@Initialize the variables that has to show in  the HTML come here 
	**/
	function initPage(){
		$scope.currentDate = new Date();
		portfolioVm.showMenuFlag=0;
		portfolioVm.showMenuIcon=0;
		portfolioVm.totalSchemeNo = 0;
		portfolioVm.totalFolioNo = 0; 
		portfolioVm.othersPercentage = 0;
		portfolioVm.equityPercentage = 0;
		portfolioVm.debtPercentage = 0;
		portfolioVm.hybridPercentage = 0;
		portfolioVm.solutionPercentage = 0;
		portfolioVm.investmentAndQuantitySelect=constantConfig.mfAndsecConst.invest;
		portfolioVm.getServerUrl();
		portfolioVm.getKYCStatus();
		portfolioVm.getActionsList();
		portfolioVm.getFolioNumber();	
		portfolioVm.getAccountData();
		portfolioVm.getCrmTncConsent();
		
		mutualFundsService.getAllInfoLists().then(function(data) {
			mutualFundsService.addInfoList(data.infoList);
		}, function(error) {
			portfolioVm.getActionsList();
			utilityService.showErrorMessage(error.responseMessage);
		}); 
		portfolioVm.ifFolioView = false;
		portfolioVm.ifSchemeView = true;
		portfolioVm.openOptnDiv = false;
		portfolioVm.selectedTranType = "";
		portfolioVm.investMoreView = false;
		portfolioVm.slctFolioToEmail = false;
	}

	/** Get accountList **/
	portfolioVm.getAccountData=function(){
		$ionicLoading.show({
           template: '<ion-spinner icon="android"></ion-spinner>'
         });
		mutualFundsService.fetchAccountList().then(function() {
			$ionicLoading.hide();
		} ,function(error) {
			$ionicLoading.hide();
            utilityService.showErrorMessage(error.responseMessage);
   		});
	}
	/**
	* Fetch ActionList  From master
	* @param {Object}
	* type
	**/
	portfolioVm.getActionsList=function(){
		var actionList=mutualFundsService.getActionListData();
		if(actionList && actionList.length>0){
			portfolioVm.schemeActionObj=actionList;
		}else{
		$ionicLoading.show({
           template: '<ion-spinner icon="android"></ion-spinner>'
         });
		var reqParams={};
		reqParams['type']=constantConfig.mfAndsecConst.schemeAction;
		mutualFundsService.getMasterCommon(reqParams).then(function(data){
			mutualFundsService.addActionListData(data);
			portfolioVm.schemeActionObj=data;
			$ionicLoading.hide();
		}, function(error){
			utilityService.showErrorMessage(error.responseMessage);
			$ionicLoading.hide();

		});
	  }
	}		
		

		/**Check ekyc completed or not */
		portfolioVm.getKYCStatus=function(){
			var reqParams={};
			reqParams['id']='';
		 	mutualFundsService.getPanCardNumber(reqParams).then(function(data){
				portfolioVm.aofStatus= data.mfKyc.aofStatus;
				portfolioVm.ekycStatus= data.mfKyc.ekycStatus;
				
			}, function(error){
				//utilityService.showErrorMessage(error.responseMessage);

			});
		}

		/** Function to check consent and show the respective screen **/
		portfolioVm.getCrmTncConsent = function(){
			leadGenerationService.checkConsent().then(function (data) {
                portfolioVm.customerRecordExists = data.customerRecordExists;
            }, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
            });
		}
	 /**
		
	* Fetch getfolioNumber From server
	* @param {id}
	* type
	*/
	
	portfolioVm.getFolioNumber=function(){
		var reqParams={};
		reqParams['id']='';
		if(!mutualFundsService.multiFolio){			
				portfolioVm.callPortfolio();
			}else{
				portfolioVm.callPortfolioOffline();
		   }
		// mutualFundsService.getPanCardNumber(reqParams).then(function(data){
		// 	portfolioVm.panNo= $rootScope.customerInfoForProfile.panNumber;//"ASPPK0667G";//data.mfKyc.panNo;
		// 	if(!mutualFundsService.multiFolio){
		// 		portfolioVm.callPortfolio();
		// 	}else{
		// 		portfolioVm.callPortfolioOffline();
		// 	}
		// }, function(error){
		// 	utilityService.showErrorMessage(error.responseMessage);

		// });
	}   
	/**
	@Function to get porfolio Details
    @Params:{}
	**/
	
	portfolioVm.callPortfolio=function(){
       $ionicLoading.show({
           template: '<ion-spinner icon="android"></ion-spinner>'
         });

	var reqParams={};
	reqParams['panNo']=portfolioVm.panNo;  
	mutualFundsService.getPortfolio(reqParams).then(function(data) {
		data=data.multiFolio;
		mutualFundsService.addFolioToInvest(data.portFolio);
		mutualFundsService.multiFolio=data;
		portfolioVm.totalInvestedFund = data.totalInvestedFund;   
		portfolioVm.folioList=data.portFolio;
		portfolioVm.folioList = data.portFolio ? $filter('orderBy')(portfolioVm.folioList,'-isLotusfolio' ) : {};
		 
		portfolioVm.totalCurrentValue =data.totalCurrentValue;
		portfolioVm.kycStatus= portfolioVm.folioList[0].kycStatus;  //By afzal sir to not check any condition based on this.
		portfolioVm.allSchemeList = [];
		for (var i = 0; i <portfolioVm.folioList.length; i++) {
			portfolioVm.folioList[i].avialbelSchemeNo = portfolioVm.folioList[i].fundList.length;
			if(portfolioVm.folioList[i].fundList.length!=0){
				portfolioVm.navDate= portfolioVm.folioList[i].fundList[0].navDate;
				if(portfolioVm.folioList[i].fundList.length == 1){
					portfolioVm.folioList[i].currVal = portfolioVm.folioList[i].fundList[0].currentValue;
				}
				else{
					portfolioVm.folioList[i].currVal = 0;
					for (var m = 0; m <portfolioVm.folioList[i].fundList.length; m++) {
						portfolioVm.folioList[i].currVal = portfolioVm.folioList[i].currVal + portfolioVm.folioList[i].fundList[m].currentValue;
					}
				}
				//return true;
			}
			if(portfolioVm.folioList[i].fundList.length!=0 && portfolioVm.folioList[i].avialbelSchemeNo > 0){
				for (var j = 0; j <portfolioVm.folioList[i].fundList.length; j++) {
					portfolioVm.folioList[i].fundList[j].folioNumber = portfolioVm.folioList[i].folioNumber;
					//added below line to add folio Mobile Number to the allSchemeList array
					portfolioVm.folioList[i].fundList[j].mobileNumber = portfolioVm.folioList[i].mobileNumber;
					portfolioVm.allSchemeList.push(portfolioVm.folioList[i].fundList[j]);
				}		
			}
		}
		 //By afzal sir to take first nav Date of FundList for as on date.
		if(portfolioVm.navDate){
			portfolioVm.navDate=$filter('date')(new Date(portfolioVm.navDate), 'dd MMM yyyy');
		}

		portfolioVm.totalSchemeNo = portfolioVm.allSchemeList.length;
		portfolioVm.totalFolioNo = portfolioVm.folioList.length;
		// "totalInvestedFund":[
		// 	{
		// 		"fundType":"Equity",
		// 		"fundPercentage":100
		// 	}
		// ]

		var totalInvestedFundLength = portfolioVm.totalInvestedFund.length;
		for (var k = 0; k < totalInvestedFundLength; k++) {
			portfolioVm.totalInvestedFund[k].fundPercentage = Math.round(portfolioVm.totalInvestedFund[k].fundPercentage);
			if(portfolioVm.totalInvestedFund[k].fundType.includes("Equity")){
				document.getElementsByClassName('mfEquity')[0].style.setProperty('width', portfolioVm.totalInvestedFund[k].fundPercentage+"%" , 'important');
				portfolioVm.equityPercentage = portfolioVm.totalInvestedFund[k].fundPercentage;
			}
			else{
				document.getElementsByClassName('mfEquity')[0].style.setProperty('width', "0%" , 'important');
			}
			if(portfolioVm.totalInvestedFund[k].fundType.includes("Hybrid")){
				document.getElementsByClassName('mfHybrid')[0].style.setProperty('width', portfolioVm.totalInvestedFund[k].fundPercentage+"%" , 'important');
				portfolioVm.hybridPercentage = portfolioVm.totalInvestedFund[k].fundPercentage;
			}
			else{
				document.getElementsByClassName('mfHybrid')[0].style.setProperty('width', "0%" , 'important');
			}
			if(portfolioVm.totalInvestedFund[k].fundType.includes("Debt")){
				document.getElementsByClassName('mfDebt')[0].style.setProperty('width', portfolioVm.totalInvestedFund[k].fundPercentage+"%" , 'important');
				portfolioVm.debtPercentage = portfolioVm.totalInvestedFund[k].fundPercentage;
			}
			else{
				document.getElementsByClassName('mfDebt')[0].style.setProperty('width', "0%" , 'important');
			}
			if(portfolioVm.totalInvestedFund[k].fundType.includes("Solution")){
				document.getElementsByClassName('mfSolution')[0].style.setProperty('width', portfolioVm.totalInvestedFund[k].fundPercentage+"%" , 'important');
				portfolioVm.solutionPercentage = portfolioVm.totalInvestedFund[k].fundPercentage;
			}
			else{
				document.getElementsByClassName('mfSolution')[0].style.setProperty('width', "0%" , 'important');
			}
			if(portfolioVm.totalInvestedFund[k].fundType.includes("Others")){
				document.getElementsByClassName('mfOthers')[0].style.setProperty('width', portfolioVm.totalInvestedFund[k].fundPercentage+"%" , 'important');
				portfolioVm.othersPercentage = portfolioVm.totalInvestedFund[k].fundPercentage;
			}
			else{
				document.getElementsByClassName('mfOthers')[0].style.setProperty('width', "0%" , 'important');
			}
		}
		// portfolioVm.labelArray = [];
		// portfolioVm.dataArray = [];
		// portfolioVm.colorSetArray = [ "#9369a8","#848f9b",  "#4cb5e5", "#e28572", "#e9b964" ,"#0095da", "#33aae1", "#66bfe9", "#99d5f0"]; //Set of colors
		// portfolioVm.colorArray = [];
		// var totalInvestedFundLength = portfolioVm.totalInvestedFund.length;
		// for (var list = 0; list < totalInvestedFundLength; list++) {
		// 	portfolioVm.colorArray.push(portfolioVm.colorSetArray[list]);
		// 	portfolioVm.labelArray.push($filter('INRFLOAT')(portfolioVm.totalInvestedFund[list].fundPercentage,2) + "% " + portfolioVm.totalInvestedFund[list].fundType);
		// 	portfolioVm.dataArray.push($filter('INRFLOAT')(portfolioVm.totalInvestedFund[list].fundPercentage,2));
		// }
			/** Load Pie chart**/
			//$timeout(function() {
				// var pieChart = document.getElementById("portfolioChart");
				// portfolioVm.pieChartObj = new Chart(pieChart, {
				// 	type: 'doughnut',
				// 	data: {
				// 		labels: portfolioVm.labelArray,
				// 		datasets: [{
				// 			data: portfolioVm.dataArray,
				// 			backgroundColor: portfolioVm.colorArray
				// 		}]
				// 	},
				// 	options: {
				// 		tooltips: {
				// 			enabled: false
				// 		},
				// 		legend: {
				// 			display: false
				// 		},
				// 		animation: {
				// 			animateScale: true,
				// 			animateRotate: true
				// 		},
				// 		cutoutPercentage: 70
				// 	}
				// });
				// document.getElementById('js-legend').innerHTML = portfolioVm.pieChartObj.generateLegend();	
				$ionicLoading.hide();			
			//},2000);
				
		}, function(error) {
		    $ionicLoading.hide();			
			utilityService.showErrorMessage(error.responseMessage);

		});
	}
	/**
	@Function to get porfolio Details offline
    @Params:{}
	**/
	
	portfolioVm.callPortfolioOffline=function(){
	
		var data=mutualFundsService.multiFolio;
		portfolioVm.totalInvestedFund = data.totalInvestedFund;   
		portfolioVm.folioList=data.portFolio;
		portfolioVm.folioList = data.portFolio ? $filter('orderBy')(portfolioVm.folioList,'-isLotusfolio' ) : {};
		portfolioVm.totalCurrentValue =data.totalCurrentValue;
		portfolioVm.kycStatus= portfolioVm.folioList[0].kycStatus;  //By afzal sir to not check any condition based on this.
		//portfolioVm.navDate= portfolioVm.folioList[1].fundList[0].navDate;  //By afzal sir to take first nav Date of FundList for as on date.
		portfolioVm.allSchemeList = [];
		for (var i = 0; i <portfolioVm.folioList.length; i++) {
			portfolioVm.folioList[i].avialbelSchemeNo = portfolioVm.folioList[i].fundList.length;
			if(portfolioVm.folioList[i].fundList.length!=0){
				portfolioVm.navDate= portfolioVm.folioList[i].fundList[0].navDate;
				if(portfolioVm.folioList[i].fundList.length == 1){
					portfolioVm.folioList[i].currVal = portfolioVm.folioList[i].fundList[0].currentValue;
				}
				else{
					portfolioVm.folioList[i].currVal = 0;
					for (var m = 0; m <portfolioVm.folioList[i].fundList.length; m++) {
						portfolioVm.folioList[i].currVal = portfolioVm.folioList[i].currVal + portfolioVm.folioList[i].fundList[m].currentValue;
					}
				} 
				//return true;
			}
			if(portfolioVm.folioList[i].fundList.length!=0 && portfolioVm.folioList[i].avialbelSchemeNo > 0){
				for (var j = 0; j <portfolioVm.folioList[i].fundList.length; j++) {
					portfolioVm.folioList[i].fundList[j].folioNumber = portfolioVm.folioList[i].folioNumber;
					//added below line to add folio Mobile Number to the allSchemeList array
					portfolioVm.folioList[i].fundList[j].mobileNumber = portfolioVm.folioList[i].mobileNumber;
					portfolioVm.allSchemeList.push(portfolioVm.folioList[i].fundList[j]);
				}		
			}
		}
		if(portfolioVm.navDate){
			portfolioVm.navDate=$filter('date')(new Date(portfolioVm.navDate), 'dd MMM yyyy');
		}
		portfolioVm.totalSchemeNo = portfolioVm.allSchemeList.length;
		portfolioVm.totalFolioNo = portfolioVm.folioList.length;

		var totalInvestedFundLength = portfolioVm.totalInvestedFund.length;
		for (var k = 0; k < totalInvestedFundLength; k++) {
			portfolioVm.totalInvestedFund[k].fundPercentage = Math.round(portfolioVm.totalInvestedFund[k].fundPercentage);
			if(portfolioVm.totalInvestedFund[k].fundType.includes("Equity")){
				document.getElementsByClassName('mfEquity')[0].style.setProperty('width', portfolioVm.totalInvestedFund[k].fundPercentage+"%" , 'important');
				portfolioVm.equityPercentage = portfolioVm.totalInvestedFund[k].fundPercentage;
			}
			else{
				document.getElementsByClassName('mfEquity')[0].style.setProperty('width', "0%" , 'important');
			}
			if(portfolioVm.totalInvestedFund[k].fundType.includes("Hybrid")){
				document.getElementsByClassName('mfHybrid')[0].style.setProperty('width', portfolioVm.totalInvestedFund[k].fundPercentage+"%" , 'important');
				portfolioVm.hybridPercentage = portfolioVm.totalInvestedFund[k].fundPercentage;
			}
			else{
				document.getElementsByClassName('mfHybrid')[0].style.setProperty('width', "0%" , 'important');
			}
			if(portfolioVm.totalInvestedFund[k].fundType.includes("Debt")){
				document.getElementsByClassName('mfDebt')[0].style.setProperty('width', portfolioVm.totalInvestedFund[k].fundPercentage+"%" , 'important');
				portfolioVm.debtPercentage = portfolioVm.totalInvestedFund[k].fundPercentage;
			}
			else{
				document.getElementsByClassName('mfDebt')[0].style.setProperty('width', "0%" , 'important');
			}
			if(portfolioVm.totalInvestedFund[k].fundType.includes("Solution")){
				document.getElementsByClassName('mfSolution')[0].style.setProperty('width', portfolioVm.totalInvestedFund[k].fundPercentage+"%" , 'important');
				portfolioVm.solutionPercentage = portfolioVm.totalInvestedFund[k].fundPercentage;
			}
			else{
				document.getElementsByClassName('mfSolution')[0].style.setProperty('width', "0%" , 'important');
			}
			if(portfolioVm.totalInvestedFund[k].fundType.includes("Others")){
				document.getElementsByClassName('mfOthers')[0].style.setProperty('width', portfolioVm.totalInvestedFund[k].fundPercentage+"%" , 'important');
				portfolioVm.othersPercentage = portfolioVm.totalInvestedFund[k].fundPercentage;
			}
			else{
				document.getElementsByClassName('mfOthers')[0].style.setProperty('width', "0%" , 'important');
			}
		}
		// portfolioVm.labelArray = [];
		// portfolioVm.dataArray = [];
		// portfolioVm.colorSetArray =  [ "#9369a8","#848f9b",  "#4cb5e5", "#e28572", "#e9b964" ,"#0095da", "#33aae1", "#66bfe9", "#99d5f0"]; //Set of colors
		// portfolioVm.colorArray = [];
		// var totalInvestedFundLength = portfolioVm.totalInvestedFund.length;
		// for (var list = 0; list < totalInvestedFundLength; list++) {
		// 	portfolioVm.colorArray.push(portfolioVm.colorSetArray[list]);
		// 	portfolioVm.labelArray.push($filter('INRFLOAT')(portfolioVm.totalInvestedFund[list].fundPercentage,2) + "% " + portfolioVm.totalInvestedFund[list].fundType);
		// 	portfolioVm.dataArray.push($filter('INRFLOAT')(portfolioVm.totalInvestedFund[list].fundPercentage,2));
		// }
			/** Load Pie chart**/
			// $timeout(function() {
			// 	var pieChart = document.getElementById("portfolioChart");
			// 	portfolioVm.pieChartObj = new Chart(pieChart, {
			// 		type: 'doughnut',
			// 		data: {
			// 			labels: portfolioVm.labelArray,
			// 			datasets: [{
			// 				data: portfolioVm.dataArray,
			// 				backgroundColor: portfolioVm.colorArray
			// 			}]
			// 		},
			// 		options: {
			// 			tooltips: {
			// 				enabled: false
			// 			},
			// 			legend: {
			// 				display: false
			// 			},
			// 			animation: {
			// 				animateScale: true,
			// 				animateRotate: true
			// 			},
			// 			cutoutPercentage: 70
			// 		}
			// 	});
			// 	document.getElementById('js-legend').innerHTML = portfolioVm.pieChartObj.generateLegend();	
			 	$ionicLoading.hide();				
			// },2000);
				
		
	}
	/***Function to go to Mutual fund home page***/
	portfolioVm.goToHome=function(){
		$state.go('menu.accountOverviewMyBalance');
	}
	
	/***Function to show floting Menu***/
	portfolioVm.showMenu=function(){
		if(portfolioVm.showMenuFlag==1){
			portfolioVm.showMenuFlag=0;
		}
		else if(portfolioVm.showMenuFlag==0){
			portfolioVm.showMenuFlag=1;
		}
	}
	
	 portfolioVm.Urls=function(){
		mutualFundsService.getServerUrl().then(function(data){
			portfolioVm.panCard=data.kycNo;
		})		
		
	}
	portfolioVm.checkInvestedValue=function(index){

		if ($scope.isGroupShown(index)) {
      			$scope.shownGroup = null;      			
		    }else{
		     	 $scope.shownGroup = index;
		     	 if(portfolioVm.folioList[index].fundList.length==0){
					var zeroValueFolioMessage=$translate.instant("ZERO_VALUE_FOLIO_MESSAGE");
					portfolioVm.showInformationPopup(zeroValueFolioMessage);
				}
		  }
		
	}	
	$scope.isGroupShown = function(group) {
     return $scope.shownGroup === group;
  };

	/***Function to show floting Button***/	
	portfolioVm.showMenuIconFunc=function(parentIndex,index){
		portfolioVm.showMenuIcon=1;
		portfolioVm.pageVal=parentIndex;
		portfolioVm.pageValForFund=index;
		portfolioVm.folioNumber=portfolioVm.folioList[parentIndex].folioNumber;
		portfolioVm.isLotusfolio=portfolioVm.folioList[parentIndex].isLotusfolio;
		portfolioVm.fundDetails=portfolioVm.folioList[parentIndex].fundList[index];
	}

	
	
	portfolioVm.panCard=mutualFundsService.getUserDetails().panNumber;
	if(portfolioVm.panCard=='' || portfolioVm.panCard ==null || portfolioVm.panCard==undefined){
		portfolioVm.panCard=mutualFundsService.geteKycPanDetails();
		if(portfolioVm.panCard=='' || portfolioVm.panCard ==null){
			portfolioVm.Urls();
		}
	}

	portfolioVm.hideOpenPopup = function(){
		if(portfolioVm.openOptnDiv){portfolioVm.openOptnDiv = false;}
		document.getElementById("mfoverlay1").style.display = "none";
	}


	/***Function to show transaction page***/
	portfolioVm.goToTransaction=function(transactionType){
		//if(portfolioVm.panNo==$rootScope.customerInfoForProfile.panNumber){
			if(portfolioVm.openOptnDiv){portfolioVm.openOptnDiv = false;}
			
			var fundToApply='';
			fundToApply=portfolioVm.fundDetails;
			$rootScope.mFmobileNumber = $filter('cardmask')(portfolioVm.fundDetails.mobileNumber, 'X', 4);
			fundToApply['folioNumber']=portfolioVm.folioNumber;
			//fundToApply['currentValue']=portfolioVm.totalCurrentValue;
			mutualFundsService.addFundToInvest(fundToApply);
			portfolioVm.fundId=fundToApply.amfiCode;
			
			portfolioVm.reqParams={};
			portfolioVm.reqParams['amfiCode']=portfolioVm.fundId;
			
			if(portfolioVm.fundId==null){
                 portfolioVm.getCommonMessage(transactionType);
                 return false;
			}
            if(portfolioVm.ekycStatus == '' || portfolioVm.ekycStatus==undefined || portfolioVm.ekycStatus==null){
            	$rootScope.ekycPan=portfolioVm.panCard.toUpperCase();
            	if(portfolioVm.panCard=='' || portfolioVm.panCard==null || portfolioVm.panCard==undefined){
            		$rootScope.checkStatusPage=1;
            		$rootScope.kycCompliant=0;
            		$rootScope.kycNonCompliant=0;
               		 $state.go('menu.KYC');
            	}else{
            		portfolioVm.checkStatus();
            	}
            	//$state.go('menu.KYC');
            }else if(portfolioVm.aofStatus == 'Pending' || portfolioVm.aofStatus==null || portfolioVm.aofStatus==undefined || portfolioVm.aofStatus==''){
            	if(portfolioVm.panCard=='' || portfolioVm.panCard==null || portfolioVm.panCard==undefined){
            		$rootScope.checkStatusPage=1;
            		$rootScope.kycCompliant=0;
            		$rootScope.kycNonCompliant=0;
               		 $state.go('menu.KYC');
            	}else{
            		portfolioVm.checkStatus();
            	}
            }else{
			mutualFundsService.getFundDetails(portfolioVm.reqParams).then(function(data) {
			   portfolioVm.fundDetailList=data;
			   portfolioVm.scmPurAvailable=portfolioVm.fundDetailList.scmPurAvailable;
			   portfolioVm.scmRedAvailable=portfolioVm.fundDetailList.scmRedAvailable;
			   portfolioVm.scmSIPAvailable=portfolioVm.fundDetailList.scmsipAvailable;
			   portfolioVm.scmSwitchInAvailable=portfolioVm.fundDetailList.scmSwitchInAvailable;
			   portfolioVm.scmSwitchOutAvailable=portfolioVm.fundDetailList.scmSwitchOutAvailable;
			   portfolioVm.scmSTPAvailable=portfolioVm.fundDetailList.scmStpAvailable;
			   portfolioVm.scmSWPAvailable=portfolioVm.fundDetailList.scmSwpAvailable;
					if(transactionType.toLowerCase()==constantConfig.mfAndsecConst.lumpsum){
						if((portfolioVm.scmPurAvailable==constantConfig.mfAndsecConst.yes || portfolioVm.scmSIPAvailable==constantConfig.mfAndsecConst.yes) && portfolioVm.isLotusfolio.toLowerCase()=="yes"){
							if(portfolioVm.customerRecordExists == "false"){
								newCardService.setPostLoginSelectedMenu('lumpsum');
                    			loggedInUserService.productClicked = 'menu.termsAndConditionsOutboundAnalytics';
                    			$state.go('menu.termsAndConditionsOutboundAnalytics');
							}else{
								clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "MF_START_NXT_BTN"));
								$state.go("menu.lumpsum");
							}
						}else{
							if(portfolioVm.isLotusfolio.toLowerCase()=="no"){
							portfolioVm.showErrorMessageInfo($translate.instant('MF_NEW_PAN_MYINV_LBL'));	
							//portfolioVm.showInformationPopup(constantConfig.mfAndsecConst.lumpsumIsLotusFolio);
						}else{
							portfolioVm.showInformationPopup(constantConfig.mfAndsecConst.purchaseNotAvailTxt);
						}							
						}
						
					}
					if(transactionType==constantConfig.mfAndsecConst.SIP){
						if(portfolioVm.scmSIPAvailable==constantConfig.mfAndsecConst.yes && portfolioVm.isLotusfolio.toLowerCase()=="yes"){
							//$state.go("menu.createSIP");
							$state.go("menu.lumpsum");
						}else{
							if(portfolioVm.isLotusfolio.toLowerCase()=="no"){
								portfolioVm.showInformationPopup(constantConfig.mfAndsecConst.sipIsLotusFolio);
							}else{
								portfolioVm.showInformationPopup(constantConfig.mfAndsecConst.SIPNotAvailTxt);
							}							
							
						}
						 
					}
					if(transactionType.toLowerCase()==constantConfig.mfAndsecConst.redeem){
						if(portfolioVm.scmRedAvailable==constantConfig.mfAndsecConst.yes){
							//MFRegulatory : Added below if-else to check Mobile no. is present or not 
							if($rootScope.mFmobileNumber){
								$state.go("menu.redeem");	
							}else{
								portfolioVm.showMobileNumPopup();
							}
						}else{
							portfolioVm.showInformationPopup(constantConfig.mfAndsecConst.redeemNotAvailTxt);
							
						}
						
					}
					if(transactionType.toLowerCase()==constantConfig.mfAndsecConst.switchTxt){
						if(portfolioVm.scmSwitchOutAvailable==constantConfig.mfAndsecConst.yes){
							//MFRegulatory : Added below if-else to check Mobile no. is present or not 
							if($rootScope.mFmobileNumber){
								$state.go("menu.switch");
							}else{
								portfolioVm.showMobileNumPopup();
							}
						}else{
							portfolioVm.showInformationPopup(constantConfig.mfAndsecConst.switchNotAvailTxt);	
						}
					
					}
					if(transactionType==constantConfig.mfAndsecConst.STP){
						if(portfolioVm.scmSTPAvailable==constantConfig.mfAndsecConst.yes){
							//MFRegulatory : Added below if-else to check Mobile no. is present or not 
							if($rootScope.mFmobileNumber){
							$state.go("menu.STP");
							}else{
								portfolioVm.showMobileNumPopup();
							}
						}else{
							portfolioVm.showInformationPopup(constantConfig.mfAndsecConst.STPNotAvailTxt);
							
						}
						
					}
					if(transactionType.toLowerCase()==constantConfig.mfAndsecConst.cancel){
						//MFRegulatory : Added below if-else to check Mobile no. is present or not for selected folio
						if($rootScope.mFmobileNumber){
							$state.go("menu.cancelFunds");
						}else{
								portfolioVm.showMobileNumPopup();
						}	
					}
					if(transactionType==constantConfig.mfAndsecConst.SWP){
						if(portfolioVm.scmSWPAvailable==constantConfig.mfAndsecConst.yes){
							//MFRegulatory : Added below if-else to check Mobile no. is present or not for selected folio
							if($rootScope.mFmobileNumber){
								$state.go("menu.SWP");
							}else{
								portfolioVm.showMobileNumPopup();
							}
						}else{
							portfolioVm.showInformationPopup(constantConfig.mfAndsecConst.SWPNotAvailTxt);
							
						}
						
					}
			}, function(error) {
				utilityService.showErrorMessage(error.responseMessage);
			});  
			}
			
		//}else{
		//	portfolioVm.showInformationPopup(constantConfig.mfAndsecConst.CBSPanError);
		//}
	}

	portfolioVm.showErrorMessageInfo = function (message) {		
			
			var infoIonicPopup = $ionicPopup.alert({
				title: "",
				template: '<div class="popup-padding font-dark-grey"><div><center><div class="mfNewInfoPopup">Information</div></center></div></div></div><div class="popupTextBottomPadding"><div class="textAlignCenter marBtm20"><span class="mfNewInfoPopupDetail">'
				+ message + '</span></div></div></div>',
				cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup mfPopupInFoDetail',
				buttons: [{
						text: 'ok',
						type: 'button-positive',
						onTap: function () {
							infoIonicPopup.close();
						}
					}]
			})
			
		};




	//if amficode not available
	portfolioVm.getCommonMessage=function(transactionType){
		if(transactionType.toLowerCase()==constantConfig.mfAndsecConst.redeem){			
			 portfolioVm.showInformationPopup(constantConfig.mfAndsecConst.redeemNotAvailTxt);				
		}else if(transactionType.toLowerCase()==constantConfig.mfAndsecConst.switchTxt){			
			portfolioVm.showInformationPopup(constantConfig.mfAndsecConst.switchNotAvailTxt);				
		}else if(transactionType==constantConfig.mfAndsecConst.STP){			
			portfolioVm.showInformationPopup(constantConfig.mfAndsecConst.STPNotAvailTxt);				
		}else if(transactionType==constantConfig.mfAndsecConst.SWP){
			portfolioVm.showInformationPopup(constantConfig.mfAndsecConst.SWPNotAvailTxt);				
		}else if(transactionType==constantConfig.mfAndsecConst.SIP){
			portfolioVm.showInformationPopup(constantConfig.mfAndsecConst.SIPNotAvailTxt);				
		}else if(transactionType==constantConfig.mfAndsecConst.lumpsum){
			portfolioVm.showInformationPopup(constantConfig.mfAndsecConst.purchaseNotAvailTxt);				
		}else if(transactionType==constantConfig.mfAndsecConst.cancel){
			portfolioVm.showInformationPopup(constantConfig.mfAndsecConst.CancelNotAvailTxt);				
		}
			
		
	}
	
	/***Function to show alert POP UP***/
	portfolioVm.showInformationPopup=function(message){
		$ionicPopup.show({
			template: '<p>'+message+'</p>',
			title:'Alert',
			cssClass: 'dialog',		
			scope: $scope,
			buttons: [ {text: 'Ok'}]
		});
	}
	/*** MFRegulatory : Added below popup to show Mobile no. not linked to folio ***/
	portfolioVm.showMobileNumPopup = function(){
		var mobPopup = $ionicPopup.show({						
						template : '<p><div class=""><img class="rrpopupStyleM5" src="img/yc_Group.svg"</div><div class="mfDntSeeFndtxt1" translate="MF_MOBILE_NOT_LINK"></div></p>',
						cssClass: 'removePopup-head popupWidth90 padding4 popupMargin ftpopup-body popupBackgroundWhite textAlignCenter dialogRRFld',
						scope: $scope,
						buttons: [{
							text: 'Ok',
							type: 'button-positive',
							onTap: function (e) {														
								mobPopup.close(); 
								e.preventDefault();   
							}
						}]
					});
	}

	
	/*** Function to show next slide***/
	$rootScope.goToNextSlide = function() {
		$ionicSlideBoxDelegate.next();
	}
	 
	/***Function to show Previous slide***/
	$rootScope.goToPreviousSlide = function() {
		$ionicSlideBoxDelegate.previous();
	}
	/***Function to go for showStatementPopup***/
	portfolioVm.showStatementPopup=function(){
		utilityService.showSpinner();
		portfolioVm.reqParams={};
		portfolioVm.reqParams['folioNumber']=portfolioVm.folioGetSelected;
		//portfolioVm.slctFolioToEmail = false;
		mutualFundsService.getStatement(portfolioVm.reqParams).then(function(data) {
			utilityService.hideSpinner();
			portfolioVm.statementStatus=data.status;
			portfolioVm.statusCode=data.statusCode;
			if(data.statusCode=="00" || data.statusCode=="01"){
				// var swpPopup = $ionicPopup.show({
				// 	template: '<img src="img/mf/bg-approved.svg" alt="Success Screen"><h2 translate="REQUEST_SENT"></h2><p translate="REQUEST_SENT_1"></p>',			
				// 	scope: $scope,
				// 	cssClass: 'dialog',
				// 	buttons: [
				// 	{
				// 	   text: 'Ok',
				// 	   type: 'button-positive',
				// 		  onTap: function(e) {
				// 				swpPopup.close(); 
				// 			}
				// 	}
				//  	]
			  	// });
				  var emailtemplate = '';
				  if(data.statusCode=="00"){
					  	emailtemplate = '<p><div class=""><img class="rrpopupStyleM5" src="img/YCGroup5.svg"</div><div class="mfDntSeeFndtxt1" translate="REQUEST_SENT"></div><div class="sbi-sub-label mfPortFolioEmailLbl" translate="REQUEST_SENT_1"></div> \n\</p>';
				  }
				  if(data.statusCode=="01"){
					  	emailtemplate = '<p><div class=""><img class="rrpopupStyleM5" src="img/YCGroup5.svg"</div><div class="mfDntSeeFndtxt1" translate="REQUEST_SENT"></div><div class="sbi-sub-label mfPortFolioEmailLbl">' + data.status + '</div> \n\</p>';
				  }

				  var swpPopup = $ionicPopup.confirm({
						template: emailtemplate,
						cssClass: 'removePopup-head popupWidth90 padding4 popupMargin ftpopup-body popupBackgroundWhite textAlignCenter dialogRRFld',
						scope: $scope,
						buttons: [{
							text: 'Ok',
							type: 'button-positive',
							onTap: function (e) {														
								swpPopup.close(); 
								e.preventDefault();   
							}
						}]
					});
			}else{
				utilityService.showErrorMessage(data.status);
			}
		}, function(error) {
			utilityService.hideSpinner();
			utilityService.showErrorMessage(error.responseMessage);
		});	
	}		
		
	
	/***Function to go to Fund List***/
	portfolioVm.fundList=function (){
		mutualFundsService.getAllMutualFunds().then(function(data) {
			portfolioVm.funds=data.fundList;
			mutualFundsService.addFundList(portfolioVm.funds);
			mutualFundsService.setPageId('portfolio');
			$state.go('menu.mutualFundsList');
		}, function(error) {
			utilityService.showErrorMessage(error.responseMessage);
		});
		
	}

	portfolioVm.getMenuIcon = function(list){
		var iconPath = "";
		if((list.key == 'lumpsum')){
			iconPath = "img/mf/ico-buy-lumpsum.svg";
		} else if((list.key == 'SIP')){
			iconPath = "img/mf/ico-buy-sip.svg";
		} else if(list.key == 'redeem') {
			iconPath = "img/mf/ico-redeem.svg";
		} else if (list.key == 'STP'){
			iconPath = "img/mf/ico-stp.svg";
		} else if(list.key == 'switch'){
			iconPath = "img/mf/ico-switch.svg";
		} else if(list.key == 'SWP'){
			iconPath = "img/mf/ico-swp.svg";
		} else if(list.key == 'cancel'){
			iconPath = "img/mf/ico-cancel.svg";
		}
		return iconPath;
	}

	portfolioVm.getServerUrl=function(){
		mutualFundsService.getServerUrl().then(function(data){
			portfolioVm.URL=data;
		}, function(error){
			utilityService.showErrorMessage(error.responseMessage);
		});
	}

	/***Function to check KYC Status***/
	portfolioVm.checkStatus=function(formData){
		var pageContent="";
		var pageContentUrl="";
		$rootScope.ekycPan=portfolioVm.panCard.toUpperCase();
		portfolioVm.sessionId = utilityService.getRandomNumber();
		clickStreamService.clickStreamData=portfolioVm.sessionId;		
		//portfolioVm.kycData =  portfolioVm.panCard.toUpperCase()+'|'+portfolioVm.emailId+'|'+portfolioVm.mobile+'|sbiApp|'+portfolioVm.URL.camsUserId+'|'+portfolioVm.URL.camsPwd+'|L||sess_id';	
		var reqPara={};
        reqPara['panId']=portfolioVm.panCard.toUpperCase();	
		mutualFundsService.getEncryptString(reqPara).then(function(data){
			portfolioVm.encKycData=JSON.parse(data.encryptedString).data.responseString;
		
			 pageContent = '<html><head></head><body><form id="form_Id" enctype="application/x-www-form-urlencoded" name="cbsulogin" action="'+portfolioVm.URL.camsUrl+'" method="POST">' +
			'<input type="hidden" name="url" value="'+portfolioVm.URL.mobileUrl+'">' +
			'<input type="hidden" name="ekyctype" value="E">' +		
			'<input type="hidden" name="kyc_data" value="'+portfolioVm.encKycData+'">'+
			'</form> <script type="text/javascript">document.getElementById("form_Id").submit();</script></body></html>';	

			pageContentUrl = 'data:text/html;base64,' + btoa(pageContent);
			var ref= cordova.ThemeableBrowser.open(pageContentUrl, '_blank', {
				statusbar:{color: '#ffffffff'},
				toolbar: {
					height: 37,
					color: '#ffffffff',
					image: 'share'
				},closeButton: {
					image: 'back',
					height: 37,
					width: 32,
					align: 'left',
					event: 'closePressed'
				},backButtonCanClose: true
			});
		
			ref.addEventListener('loadstart', function(event) {	
				//navigator.notification.activityStart("","Loading...");
				//utilityService.isShowSpinner=true;
				//utilityService.showSpinner();
				var URL=event.url;
				var n = URL.indexOf("result");
				if(n==-1){
					return;
				}
				if (n) {
					var sessId = '';
					var result=URL.split('?')[1];
					result=result.split("=")[1];
					result=decodeURIComponent(result).toString();
				}
				mutualFundsService.getDecryptString(result).then(function(data){
					try{
					var resultData=JSON.parse(data.plainString);
					resultData=resultData.data.responseString.split("|")[2];
					resultData=resultData.replace('&sess_id','');
					portfolioVm.todayDate=$scope.currentDate.setDate($scope.currentDate.getDate());
					portfolioVm.ekycType=JSON.parse(data.plainString).data.responseString.split("|")[0];
				 }catch(e){
				 	ref.close();
				 }			
					if(n!=-1){						
						if(portfolioVm.ekycType=='Y' || resultData=='KS100'){
							portfolioVm.reqParams={
                                "mfKyc": {
                                    "panNo": portfolioVm.panCard,
                                    "aadharNo": portfolioVm.aadhaarCard,
                                    "gender": portfolioVm.gender,
                                    "dob": portfolioVm.dob,
                                    "ekycStatus":"Submitted",
                                    "aofStatus":"",
                                    "ekycType":portfolioVm.ekycType,
                                    "ekycTimeStamp":portfolioVm.todayDate,
                                    "ekycMaxInvestmentLimit":""
                                }
                            };   
							utilityService.showSpinner();
							 mutualFundsService.checkKYCStatus(portfolioVm.reqParams).then(function (data) {
                                    if (data.id) {
                                        var reqParams = {};
                                        reqParams['id'] = '';
								mutualFundsService.getPanCardNumber(reqParams).then(function(data){
                                portfolioVm.getServerUrl();
                                portfolioVm.divPayOutMechanism=data.mfKyc.divPayOutMechanism;
                                portfolioVm.redPayOutMechanism=data.mfKyc.redPayOutMechanism;
                                portfolioVm.applicationStatus=data.mfKyc.aofStatus;
                                mutualFundsService.addeKycPanDetails(portfolioVm.URL.kycNo);										
								$rootScope.kycCompliant=1;
			            	  	$rootScope.checkStatusPage=0;
			            	  	$rootScope.kycNonCompliant=0;	
								  utilityService.hideSpinner();										
								$state.go('menu.KYC');
										                                                             
                                
                            }, function(error){
								utilityService.hideSpinner();
                                utilityService.showErrorMessage(error.responseMessage);

                            }); 
						}
					}, function(error) {
							utilityService.hideSpinner();
							utilityService.showErrorMessage(error.responseMessage);
					});	
										
						//}
					}else if(portfolioVm.ekycType=='N' || resultData=='KS101'){						 
	            			$rootScope.kycCompliant=0;
		            		$rootScope.checkStatusPage=0;
		            		$rootScope.kycNonCompliant=1;    							
    					    $state.go('menu.KYC');			
					}						
						ref.close();
					}
				},function(error){
			      	 ref.close();
					if(error.responseCode=='0002')
			          utilityService.showErrorMessage(error.responseMessage);
			      else 			      	 
			         utilityService.showErrorMessage(error.responseMessage);
		       })
			});
			ref.addEventListener('loadstop', function(event) {
				//navigator.notification.activityStop();
			});
		},function(error){
			 ref.close();
			utilityService.showErrorMessage(error.responseMessage);
		})
			
	} 
	portfolioVm.getMenuLabel = function(list){
		// var iconLabel = "";
		// if((portfolioVm.isLotusfolio=='No') && !(list.key=='lumpsum' || list.key=='SIP')){
		// 	iconLabel = ""
		// } else if((list.key == 'lumpsum') && (portfolioVm.isLotusfolio=='Yes')){

		// } else if((list.key == 'SIP') && (portfolioVm.isLotusfolio=='Yes')){

		// } else if(list.key == 'redeem') {

		// } else if (list.key == 'STP'){

		// } else if(list.key == 'switch'){

		// } else if(list.key == 'SWP'){

		// } else if(list.key == 'cancel'){

		// }
		return list.value;
	}

	/** open manage fund option list */
	portfolioVm.openMngFndsOpt=function(){ 
		portfolioVm.openOptnDiv = false;
		var element = document.getElementsByClassName("mfManageFunds")[0];
        element.classList.toggle("mfManageFundsClose");
		if(document.getElementById("mfoverlay").style.display == "none"){
			document.getElementById("mfoverlay").style.display = "";
		}
		else{
			document.getElementById("mfoverlay").style.display = "none";
		}		
		// if(isSort==0){
		// 	 mutualFundslistVm.isSort=1;
		// }else if(isSort==1){
		// 	 mutualFundslistVm.isSort=0;
		// }
	}

	var mfDntSeeFndpopup = "";
	/** open  */
	portfolioVm.dntSeeFndPopup = function(){
		var textToShow = "Don't see your fund here?";
		mfDntSeeFndpopup = $ionicPopup.confirm({
			template: '<p><div class=""> <img src="img/mf/Close-icon.svg" class="mfDntSeeFndCloseImg" click-stream="click" ng-click="portfolioVm.dntSeeFndPopupClose()"><img class="mfDntSeeFndImg" src="img/mf/Find.svg"</div>  <div class="sbi-sub-label"><div class="mfDntSeeFndtxt1">'+textToShow+'</div><div class="mfDntSeeFndtxt2">Only the investment made through SBI Bank Channel are shown here. For all other Mutual Funds investments details, please visit SBIMF website.</div></div> \n\</p>',
			cssClass: 'removePopup-head popupWidth90 padding4 popupMargin ftpopup-body popupBackgroundWhite textAlignCenter dialogRR',
			scope: $scope,
			buttons: []
		});
	}

	portfolioVm.dntSeeFndPopupClose = function(){
		mfDntSeeFndpopup.close();
		e.preventDefault();
	}	   

	portfolioVm.selectTab = function(val){
		if(val == 'Scheme'){
			document.getElementsByClassName('mfTabNonSelect1')[0].classList.remove('mfTabSelected');
			document.getElementsByClassName('mfTabNonSelect')[0].classList.add('mfTabSelected1');
			portfolioVm.ifSchemeView = true;
			portfolioVm.ifFolioView = false;
		}
		else{
			document.getElementsByClassName('mfTabNonSelect')[0].classList.remove('mfTabSelected1');
			document.getElementsByClassName('mfTabNonSelect1')[0].classList.add('mfTabSelected');
			portfolioVm.ifFolioView = true;
			portfolioVm.ifSchemeView = false;
		}
	}

	//Open option div on click of folio view elipsis 
	portfolioVm.openOptnDivShow = function(parentIndex,index){
		//portfolioVm.showMenuIcon=1; portfolioVm.fndGetSelected
		if(document.getElementById("mfoverlay1").style.display == "none"){
			document.getElementById("mfoverlay1").style.display = "";
		}
		else{
			document.getElementById("mfoverlay1").style.display = "none";
		}
		portfolioVm.pageVal=parentIndex;
		portfolioVm.pageValForFund=index;
		portfolioVm.folioNumber=portfolioVm.folioList[parentIndex].folioNumber;
		$rootScope.mFmobileNumber = $filter('cardmask')(portfolioVm.folioList[parentIndex].mobileNumber, 'X', 4);
		portfolioVm.isLotusfolio=portfolioVm.folioList[parentIndex].isLotusfolio;
		portfolioVm.fundDetails=portfolioVm.folioList[parentIndex].fundList[index];
		portfolioVm.openOptnDiv = true;
	}

	//Open option div on click of scheme view elipsis 
	portfolioVm.openSchmeOptnDivShow = function(index){
		if(document.getElementById("mfoverlay1").style.display == "none"){
			document.getElementById("mfoverlay1").style.display = "";
		}
		else{
			document.getElementById("mfoverlay1").style.display = "none";
		}
		//portfolioVm.pageVal=parentIndex;
		portfolioVm.pageValForFund = index;
		portfolioVm.folioNumber = portfolioVm.allSchemeList[index].folioNumber; //portfolioVm.folioList[parentIndex].folioNumber;
		$rootScope.mFmobileNumber = $filter('cardmask')(portfolioVm.allSchemeList[index].mobileNumber, 'X', 4);
		//var folioobj = portfolioVm.folioList.find(o => o.folioNumber === portfolioVm.folioNumber);
		var folioobj = $filter('filter')(portfolioVm.folioList, { folioNumber: portfolioVm.folioNumber });
		
		portfolioVm.isLotusfolio=folioobj[0].isLotusfolio;
		portfolioVm.fundDetails=portfolioVm.allSchemeList[index];
		portfolioVm.openOptnDiv = true;
	}

	//New investment
	portfolioVm.newInvestment = function(){
		homeScreenService.ishamburgerMenuViewMF=false;
		var nfoArray=[];
		mutualFundsService.getAllMutualFunds().then(function (data) {
        if(data.fundList.length > 5){
			angular.forEach(data, function (value, key) {
				for(var i in value){
				if (value[i].fundSchemeName == "NFO") {
				nfoArray.push(data.fundList[i]);
				data.fundList.splice(i,1);
				data.fundList.splice(1,0,nfoArray[0]);
					}  
				}                    
			});
		}
			//data.fundList.splice(1,0,data.fundList[4])
			//mutualFundsVm.popularFunds = data.fundList;
			mutualFundsService.addFundList(data.fundList);
			$ionicLoading.hide();
			mutualFundsService.setPageId('portfolio');
			$state.go('menu.mutualFundsList');
		}, function (error) {
			$ionicLoading.hide();
			utilityService.showErrorMessage(error.responseMessage);
		});
	}

	//Open select folio list to send email
	portfolioVm.OpenslctFolioList  = function(transType){
		portfolioVm.slctFolioToEmail = true;
		portfolioVm.openMngFndsOpt();
		portfolioVm.folioGetSelected = portfolioVm.folioList[0].folioNumber;
	}

	//invest more already invested funds
	portfolioVm.InvestMoreFnd = function(transType){
		portfolioVm.openMngFndsOpt();
		portfolioVm.fndGetSelected = portfolioVm.allSchemeList[0].folioNumber;
		portfolioVm.investMoreView = true;
		portfolioVm.selectedTranType = transType;
	}

	//Select Folio to send email
	portfolioVm.folioSelection = function(index){
		portfolioVm.folioGetSelected = portfolioVm.folioList[index].folioNumber;
	}

	//Select Funds to Invest fndSelection  
	portfolioVm.fndSelection = function(index){
		//alert(portfolioVm.fndGetSelected);
		//portfolioVm.pageValForFund = index;
		portfolioVm.folioNumber = portfolioVm.allSchemeList[index].folioNumber; //portfolioVm.folioList[parentIndex].folioNumber;
		//var folioobj = portfolioVm.folioList.find(o => o.folioNumber === portfolioVm.folioNumber);
		var folioobj = $filter('filter')(portfolioVm.folioList, { folioNumber: portfolioVm.folioNumber });

		portfolioVm.isLotusfolio=folioobj[0].isLotusfolio;
		portfolioVm.fundDetails=portfolioVm.allSchemeList[index];
		//portfolioVm.openOptnDiv = true;
	}
		
	//Go to transaction with selected fund and type which is selected
	portfolioVm.fndSelectedtoInvsrMr = function(){
		if(!portfolioVm.fundDetails){
			portfolioVm.folioNumber = portfolioVm.allSchemeList[0].folioNumber; //portfolioVm.folioList[parentIndex].folioNumber;
			//var folioobj = portfolioVm.folioList.find(o => o.folioNumber === portfolioVm.folioNumber);
			var folioobj = $filter('filter')(portfolioVm.folioList, { folioNumber: portfolioVm.folioNumber });

			portfolioVm.isLotusfolio=folioobj[0].isLotusfolio;
			portfolioVm.fundDetails=portfolioVm.allSchemeList[0];
		}
		//var transactionType = portfolioVm.selectedTranType;
		portfolioVm.goToTransaction(portfolioVm.selectedTranType);
	}

	//back button handlliung
	portfolioVm.backHandling = function(){
		portfolioVm.investMoreView = false;
		portfolioVm.slctFolioToEmail = false;
	}

	
	 // floating menu open event handler
        $scope.$on('floating-menu:open', function(event) {
            var elem = document.querySelectorAll('#floating-backdrop');
            for (var j = 0; j < elem.length; j++) {
                elem[j].className = '';
                elem[j].className = 'backdrop visible active';
            }

        });

        // floating menu close event handler
        $scope.$on('floating-menu:close', function(event) {
            var elem = document.querySelectorAll('#floating-backdrop');
            for (var j = 0; j < elem.length; j++) {
                elem[j].className = '';
                elem[j].className = 'backdrop';
            }
        });
	
	/*** actions to done everytime the view is shown***/	
	$scope.$on('$ionicView.beforeEnter', function() {
		initPage();
	});
	
	
	
	return this;
}]);

