
/*******Redeem Controller ******/

'use strict';

angularApp.controller('redeemController', 
						["$timeout",
						 "$state",
						 "$scope",
						 "$rootScope",
						 "$translate",
						 "$location","$ionicPopup",
						 "$ionicScrollDelegate","$filter","ionicDatePicker","mutualFundsService","utilityService","constantConfig","clickStreamService","customerInfoService",
				 
function ($timeout,
		 $state,
		 $scope,
		 $rootScope,
		 $translate,
		 $location,$ionicPopup,
		 $ionicScrollDelegate,$filter,ionicDatePicker,mutualFundsService,utilityService,constantConfig,clickStreamService,customerInfoService) {
	
	
	var redeemVm = this;
	
	
	/*** Initialize the variables that has to show in  the HTML come here ***/
	function initPage(){
		redeemVm.transactionType=constantConfig.mfAndsecConst.redeemMf;
		redeemVm.redeemVmPage=1;
		redeemVm.redeemReviewPage=0;
		redeemVm.successPage=0;	
		redeemVm.dividendOption=''; //constantConfig.mfAndsecConst.dividendOption;
		redeemVm.minAmountFlag=true;
		redeemVm.maxAmountFlag=true;
		redeemVm.multiplierAmountFlag=true;
		redeemVm.minUnitFlag=true;
		redeemVm.maxUnitFlag=true;
		redeemVm.multiplierUnitFlag=true;
		redeemVm.folio='';
		redeemVm.getPanCard();	
		redeemVm.getFundDetails();
		redeemVm.getTransactionNotes();
		redeemVm.redeemSelect=constantConfig.mfAndsecConst.amount;
		redeemVm.accountDetails();
		 var rupeeSymbol = String.fromCharCode(8377);
        $rootScope.clickCount = 0;
        $rootScope.isResendOTP = false;
        $rootScope.isResendDisabled=false;           
        $rootScope.mobileNumber = $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4);
        $rootScope.amountToPay = rupeeSymbol + mutualFundsService.getInvedtedAmount();
	}
	/**
	* Fetch get accountDetails service
	* @param {}
	**/
	redeemVm.accountDetails = function(){
		
		var currentDate = new Date();
		redeemVm.redeemDate = currentDate.setDate(currentDate.getDate());		
		redeemVm.accounts=mutualFundsService.getDetails();
		if(redeemVm.accounts){
			$scope.accountListTemp=redeemVm.accounts;
			$scope.accounts=[];
			var accountListTempLength = $scope.accountListTemp.length;
			for(redeemVm.list=0;redeemVm.list < accountListTempLength ;redeemVm.list++){
				if($scope.accountListTemp[redeemVm.list].accountType==constantConfig.mfAndsecConst.savingAccountInOpenAccount){
					$scope.accounts.push($scope.accountListTemp[redeemVm.list]);
				}
			}
			$timeout(function() {
				//redeemVm.accountFirstNo = $scope.accounts[0].accountNumber;
				redeemVm.savingAccounts =$scope.accounts[0].accountNumber ;
			}, 400);
		
		}
	}	
	
	/**
		
	* Fetch get Pancard From server
	* @param {id}
	* type
	*/
	redeemVm.getPanCard=function(){
		var reqParams={};
		reqParams['id']='';
		mutualFundsService.getPanCardNumber(reqParams).then(function(data){
			redeemVm.panCard=data.mfKyc.panNo;
			redeemVm.divPayOutMechanism=data.mfKyc.divPayOutMechanism;
			redeemVm.redPayOutMechanism=data.mfKyc.redPayOutMechanism;
			redeemVm.mfKyc=data.mfKyc;
		}, function(error){
			utilityService.showErrorMessage(error.responseMessage);

		});
	} 

	/**
	*Function to go to get Transaction Notes Message
	@params:{}
	**/
	redeemVm.getTransactionNotes = function() {
		mutualFundsService.getTransactionNotes().then(function(data) {
			redeemVm.nonNfoMssg = data.nonNfo;
			redeemVm.commonMssg = data.common;
		}, function(error) {
			redeemVm.nonNfoMssg = "";
			redeemVm.commonMssg = ""; 
			utilityService.showErrorMessage(error.responseMessage);
		}); 
	}

  	/**
	*Function to go to get fund Deatils
    @params:{fundId:''}
	
	**/
	redeemVm.getFundDetails=function(){
		redeemVm.fundObj=mutualFundsService.getFundToInvest();
		if(redeemVm.fundObj.folioNumber){
			redeemVm.folio=redeemVm.fundObj.folioNumber;
			redeemVm.folioAccountNo=redeemVm.accountNo;
		}
		redeemVm.fundId=redeemVm.fundObj.amfiCode;
		redeemVm.availUnit=redeemVm.fundObj.availbleUnits; 
		redeemVm.totalUnit=$filter('INRFLOAT')(redeemVm.fundObj.quantity,4);   //Change request by Ram sir
		redeemVm.reqParams={};
		redeemVm.reqParams['amfiCode']=redeemVm.fundId;
		mutualFundsService.getFundDetails(redeemVm.reqParams).then(function(data) {
			if(data){
				redeemVm.fundDetailList=data;
				redeemVm.schemeCode=data.fundId;
				redeemVm.fundType=data.fundType;
				redeemVm.minAmount=$filter('INRFLOAT')(redeemVm.fundDetailList.minRedeemAmount,2);
				redeemVm.minRedeemUnit=$filter('INRFLOAT')(redeemVm.fundDetailList.minRedeemUnit,4);
				redeemVm.multiplesRedeemAmount=$filter('INRFLOAT')(redeemVm.fundDetailList.multiplesRedeemAmount,2);
				redeemVm.multiplesRedeemUnit=$filter('INRFLOAT')(redeemVm.fundDetailList.multiplesRedeemUnit,4);
			
				redeemVm.amcCode=redeemVm.fundDetailList.scmAmcCd;
				
				if(redeemVm.fundObj.plan){
					redeemVm.plan= redeemVm.fundObj.plan;
					redeemVm.option = redeemVm.fundObj.option;
					redeemVm.nav  = $filter('INRFLOAT')(redeemVm.fundObj.nav,4);
					redeemVm.navDate =  $filter('date')(redeemVm.fundObj.navDate,'d MMM yyyy' );
				
				}else{
					if(redeemVm.fundDetailList.planList[0]){
						redeemVm.plan  = redeemVm.fundDetailList.planList[0].plan;
						redeemVm.option =redeemVm.fundDetailList.planList[0].option;
						redeemVm.nav  = $filter('INRFLOAT')(redeemVm.fundDetailList.planList[0].nav,4);
						redeemVm.navDate = $filter('date')(redeemVm.fundDetailList.planList[0].navDate,'d MMM yyyy' );
					}else{
						redeemVm.plan  ='';
						redeemVm.option='';
						redeemVm.nav  ='';
						redeemVm.navDate = '';
					}
				}
				redeemVm.maxAmount=redeemVm.totalUnit*redeemVm.nav;
			}
		}, function(error) {
			utilityService.showErrorMessage(error.responseMessage);
		});
	}
	

	
	/**
	*Function to submit Redeem details
	**/
	redeemVm.submitRedeem = function(){	
		var requestSecKey='';
		var reqParams = {};
		if(!redeemVm.isTermsAndConditionChecked){
			return false;
		}
		redeemVm.txnId = utilityService.getRandomNumber();
		var requestDate = new Date();
		requestDate = requestDate.getTime();
		requestSecKey=Math.floor((Math.random()) + requestDate);
		requestSecKey = (requestSecKey * 10 + 1);

		clickStreamService.clickStreamData=redeemVm.txnId;
		
		reqParams["txnType"] = constantConfig.mfAndsecConst.redeemMf;
		reqParams["schemeId"] = redeemVm.schemeCode;
		reqParams["schemeName"] = redeemVm.fundDetailList.fundName;	
		reqParams["schemePlan"] =  redeemVm.plan;
		reqParams["schemeOption"] = redeemVm.option;
		reqParams["transactionType"] = constantConfig.mfAndsecConst.transactionTypeRedeem;
		reqParams["startDate"] = $filter('date')(new Date(redeemVm.redeemDate), 'dd/MM/yyyy'); 
		reqParams["endDate"] = '';
		
		if(redeemVm.redeemSelect==constantConfig.mfAndsecConst.amount){
			reqParams["amount"] = redeemVm.redeemAmount;
			$rootScope.amountToPay=redeemVm.redeemAmount;
			mutualFundsService.addInvedtedAmount(redeemVm.redeemAmount);//for OTP page showing
			redeemVm.closeAc="";
		}else{
			//reqParams["units"] = redeemVm.redeemUnit * $filter('INRFLOAT')(redeemVm.fundObj.nav,4);
			reqParams["units"] = redeemVm.redeemUnit;
			reqParams["amount"]="";
			$rootScope.unit=redeemVm.redeemUnit;
			mutualFundsService.addInvedtedAmount(redeemVm.redeemUnit);//for OTP page showing
			if(redeemVm.closeAc!="Y"){
				redeemVm.closeAc="";
			}
		}
	
		reqParams["accountNo"] =redeemVm.savingAccounts;
		reqParams["frequency"] ='';
		reqParams["isPerpetual"] = "";
		reqParams["amcCode"] = redeemVm.amcCode;
		reqParams["folioNo"] =redeemVm.folio;
		reqParams["txnDate"] = "";
		reqParams["txnTime"] = "";
		reqParams["sipRegisteredDate"] = "";
		reqParams["numberOfInstallments"] = "";
		reqParams["installmentNumber"] = "";
		reqParams["bankName"] = "";
		reqParams["bankCode"] = "";
		reqParams["bankCity"] = "";
		reqParams["accountType"] = "";
		reqParams["panNo"] = redeemVm.panCard;
		reqParams["customerTermandCondition"] = redeemVm.isTermsAndConditionChecked;
		reqParams["branchName"] = "";
		reqParams["targetSchemeId"] = '';
		reqParams["targetSchemeName"] = '';	
		reqParams["targetSchemePlan"] = '';
		reqParams["targetSchemeOption"] = '';
		reqParams["dividendOption"] =redeemVm.dividendOption;
		reqParams["divPayoutMechanism"]=redeemVm.divPayOutMechanism;
		reqParams["redPayoutMechanism"]=redeemVm.redPayOutMechanism;
		reqParams["txnId"]=redeemVm.txnId;
		reqParams["secKey"]=requestSecKey;
		reqParams["amfiCode"]=redeemVm.fundId;
		reqParams["closeAc"]=redeemVm.closeAc;
		reqParams["navValue"]= $filter('INRFLOAT')(redeemVm.fundObj.nav,4);
        
	        $rootScope.fundName=redeemVm.fundDetailList.fundName;
	        $rootScope.unitName=redeemVm.redeemSelect;
	
		mutualFundsService.payDuesRequest(reqParams).then(function(data){
			 if(data.submitRequest.isOTPRequired == "true"){
					$rootScope.redeemotpPage=1;
					$rootScope.cancelotpPage=0;       	
			                $rootScope.sipotpPage=0;
					$rootScope.lumsumotpPage=0;
					$rootScope.swpotpPage=0;
					$rootScope.stpotpPage=0;				
					$rootScope.switchotpPage=0;					    	
			    	$state.go("menu.redeemOTP");
			    }else{
			    	var calCulatedKey=mutualFundsService.verifySecKey(parseInt(data.submitRequest.secKey));
	                 if(requestSecKey==calCulatedKey){
						redeemVm.message = data.submitRequest.status;
						redeemVm.transactionReferenceNo = data.submitRequest.transactionReferenceNo;
							redeemVm.redeemVmPage=0;
							redeemVm.redeemReviewPage=0;
							redeemVm.successPage=1;							  
			                 // if($rootScope.amountToPay!=null){
			                 // 	redeemVm.redeemAmount= $rootScope.amountToPay;
			                 // }else{
			                 // 	redeemVm.redeemUnit= mutualFundsService.getInvedtedAmount();
			                 // }                    
			                 redeemVm.transactionDate= data.submitRequest.transactionDate;  
							utilityService.setCsatJournies("mutualFunds");
						
					}
		      }
		}, function(error){
			utilityService.showErrorMessage(error.responseMessage);
		});
	}

	 $scope.validateOTP=function(){
            var reqParams={};
             var requestSecKey='';
		    var requestDate = new Date();
		    requestDate = requestDate.getTime();
		    requestSecKey=Math.floor((Math.random()) + requestDate);
		    requestSecKey = (requestSecKey * 10 + 1);

            reqParams.otp= $scope.enterOTP;
            reqParams.secKey=requestSecKey; 
            mutualFundsService.validateOTPForPayment(reqParams).then(function(data){
             if(data.data.otpStatus == "0000"){
                 var calculatedKey=mutualFundsService.verifySecKey(parseInt(data.data.secKey));
                 if(requestSecKey==calculatedKey){  
                 	 $rootScope.redeemSuccessPage=1;
                 	 $rootScope.swpSuccessPage=0;
                 	 $rootScope.switchSuccessPage=0;
                 	 $rootScope.stpSuccessPage=0;
                 	 $rootScope.lumsumSuccessPage=0;
                 	 $rootScope.sipSuccessPage=0;	
                 	 $rootScope.cancelSuccessPage=0;		
	                 $rootScope.fundName= $rootScope.fundName;
	                 $rootScope.transactionReferenceNo=data.data.transactionReferenceNo;  
	                 //  if($rootScope.amountToPay!=null){
	                 // 	$rootScope.redeemAmount= $rootScope.amountToPay;
	                 // }else{
	                 // 	$rootScope.unit= mutualFundsService.getInvedtedAmount();
                  //   }                    
	                 $rootScope.transactionDate= new Date(data.data.transactionDate);               
	                 utilityService.setCsatJournies("mutualFunds");              
	                 $state.go('menu.redeemPaymentSuccess');
                 }
             }else if(data.data.otpStatus != "0000"){
             	  mutualFundsService.clearOTP($rootScope.enterOTP);
                  $scope.errorMessage=data.responseMessage;
             }else{                   
                   redeemVm.showErrorInformationPopup(error.responseMessage);
             }
            },function(error){
            	//utilityService.showErrorMessage(error.responseMessage);
            	redeemVm.showErrorInformationPopup(error.responseMessage);
            })
              
        }

          $scope.resendOTP=function(){
             $scope.enterOTP="";
            var reqParams ={};
            reqParams.id ="";
            reqParams.emailId ="";
            mutualFundsService.getOTPTokenSecure(reqParams).then(function(data){
                 $rootScope.clickCount++;
                 $scope.mutualFundEnterOTPForm={};
                if($rootScope.clickCount==2){
                    $scope.disableLink=true;
                }
            })          
        }

        //****Submit button on OTP Page***//
         $scope.validateOTPNext=function(){
         	 $scope.enterOTP=document.getElementById('txt_otp').value;
           if(validateForm()){         
            $scope.validateOTP();
            }           
        }     
       function validateForm(){
             $rootScope.mutualFundEnterOTPForm={};
            if(mutualFundsService.isValidOTPNum($scope.enterOTP)){
                $scope.errorMessage=mutualFundsService.isValidOTPNum($scope.enterOTP);
            }
            return (angular.equals({}, $rootScope.mutualFundEnterOTPForm))?true:false;
        }
	
	
	/**
	*Function to checkMinAmount 
	**/
	redeemVm.checkMinAmount=function(){
		
		$scope.minAmount=parseFloat(redeemVm.minAmount);
		$scope.minRedeemUnit=parseFloat(redeemVm.minAmount/redeemVm.nav);
		$scope.multiplesRedeemAmount=parseFloat(redeemVm.multiplesRedeemAmount);
		$scope.multiplesRedeemUnit=parseFloat(redeemVm.multiplesRedeemUnit);
		$scope.maxAmount=parseFloat(redeemVm.maxAmount);
		
		$scope.enteredminUnitCal=redeemVm.nav*redeemVm.redeemUnit;
		if(redeemVm.redeemSelect==constantConfig.mfAndsecConst.amount){
			$scope.enteredAmount=parseFloat(redeemVm.redeemAmount) ;
			if($scope.minAmount>$scope.enteredAmount){
				redeemVm.minAmountFlag=false;
				redeemVm.multiplierAmountFlag=true;
				redeemVm.maxAmountFlag=true;
				
			}else if(($scope.multiplesRedeemAmount%$scope.enteredAmount)==0){
				redeemVm.multiplierAmountFlag=false;
				redeemVm.minAmountFlag=true;
				redeemVm.maxAmountFlag=true;
			}else if($scope.maxAmount<$scope.enteredAmount){
				redeemVm.minAmountFlag=true;
				redeemVm.maxAmountFlag=false;
				redeemVm.multiplierAmountFlag=true;
			}else{
				redeemVm.minAmountFlag=true;
				redeemVm.maxAmountFlag=true;
				redeemVm.multiplierAmountFlag=true;
			}
		}else{
			$scope.enteredAmount=parseFloat(redeemVm.redeemUnit) ;
			$scope.maxUnit=parseFloat(redeemVm.totalUnit);
			
			if($scope.minRedeemUnit>$scope.enteredAmount){
				redeemVm.minUnitFlag=false;
				redeemVm.multiplierUnitFlag=true;
				redeemVm.maxUnitFlag=true;
				
			}else if(($scope.multiplesRedeemUnit%$scope.enteredAmount)==0){
				redeemVm.multiplierUnitFlag=false;
				redeemVm.minUnitFlag=true;
				redeemVm.maxUnitFlag=true;
				
			}else if($scope.maxUnit < $scope.enteredAmount){
				redeemVm.minUnitFlag=true;
				redeemVm.maxUnitFlag=false;
			}else if($scope.enteredminUnitCal<redeemVm.minAmount){
				redeemVm.minUnitFlag=false;
				redeemVm.maxUnitFlag=true;
			}else{
				redeemVm.minUnitFlag=true;
				redeemVm.maxUnitFlag=true;
				redeemVm.multiplierUnitFlag=true;
			}
		}
	}
	/***Function to call review page***/
	redeemVm.reviewRedeem=function(){
		redeemVm.checkMinAmount();
		if(redeemVm.minUnitFlag && redeemVm.minAmountFlag){
			redeemVm.isTermsAndConditionChecked=0;
			redeemVm.redeemVmPage=0;
			redeemVm.redeemReviewPage=1;
			redeemVm.successPage=0;
		}
	}
	
	
	/***Start term and Condition***/
	redeemVm.termsAndConditions=function(){
		if(redeemVm.termsAndConditionsFlag==1){
			redeemVm.termsAndConditionsFlag=0;
		}else{
			/**Call service to fetch termsConditionsMessage**/
			redeemVm.reqParams={};
			redeemVm.reqParams['action']=constantConfig.mfAndsecConst.redempationTermsAndC;
			mutualFundsService.getTermsAndConditions(redeemVm.reqParams).then(function(data) {
				redeemVm.termsAndConditionsMessage=data.message;
			
			}, function(error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
			redeemVm.termsAndConditionsFlag=1;
		}			
	}
	/*** check Unit***/
	redeemVm.allUnitsCheck= function(){
		if(redeemVm.allUnits == "1"){
			redeemVm.closeAc="Y"
		    redeemVm.redeemUnit = redeemVm.totalUnit;
		}else{
			redeemVm.redeemUnit = '';
			redeemVm.closeAc="";
		}
	}
	
	
	/***Function to go to Portfolio page***/
	$scope.portfolio=function(){
		$state.go("menu.portfolio");
		redeemVm.redeemVmPage=1;
		redeemVm.redeemReviewPage=0;
		redeemVm.successPage=0;
	}
	
	$scope.closePage =function(){
		$state.go("menu.portfolio");		
	}
	
	/***Function to show information POP UP for future***/
	redeemVm.showInformationPopup=function(){
		var infoPopup = $ionicPopup.show({
			template: '<p>Message</p>',
			title:'Information',
			scope: $scope,
			buttons: [ {text: 'Ok'}]
		});

		infoPopup.then(function(res) {
        
		});    
	}
	/***Function to show alert POP UP***/
		redeemVm.showErrorInformationPopup=function(message){
			var infoPopup = $ionicPopup.show({
				template: '<p>'+message+'</p>',
				title:'Alert',
				cssClass: 'dialog',		
				scope: $scope,
				buttons: [ {
					text: 'Ok',
					onTap: function(e) {
						$state.go('menu.accountOverviewMyBalance');
					}
				}]
			});
		}
	/***BACK to page***/
	redeemVm.backToRedeem=function(){
		redeemVm.redeemVmPage=1;
		redeemVm.redeemReviewPage=0;
		redeemVm.successPage=0;
		
	}

	/*** actions to done everytime the view is shown***/	
	$scope.$on('$ionicView.beforeEnter', function() {
		initPage();
	});
	
	
	return this;
}]);

