/******* Risk Profile Controller ******/
'use strict';

angularApp.controller('riskProfileQAController', 
						["$timeout",
						 "$state",
						 "$scope",
						 "$ionicPopup",
						 "$translate",
						 "$location",
						 "$ionicScrollDelegate","mutualFundsService","utilityService","constantConfig","mPinLoginService",
				 
function ($timeout,
		 $state,
		 $scope,
		 $ionicPopup,
		 $translate,
		 $location,
		 $ionicScrollDelegate,mutualFundsService,utilityService,constantConfig,mPinLoginService) {
	
	var riskProfileQAVm=this;
	
	/*** Initialize the variables that has to show in  the HTML come here ***/
	function initPage(){
		$scope.middleBreadCrumb=true;
		$scope.lastBreadCrumb=true;
		$scope.firstBreadCrumb=false;
		$scope.pageVal=0;
		$scope.isLoggedIn = mPinLoginService.isLoggedIn;
		riskProfileQAVm.getRiskProfileQA();
		$scope.setOfAnswerArray=[];
		riskProfileQAVm.infoMessage=mutualFundsService.getInfoList();
		if(riskProfileQAVm.infoMessage.riskProfile){
			riskProfileQAVm.infoMessage=riskProfileQAVm.infoMessage.riskProfile;
		}else{
			riskProfileQAVm.infoMessage=constantConfig.mfAndsecConst.riskInfoEmptyText;
		}
	}
	
		/** Function to call get risk profile Qa list**/
		riskProfileQAVm.getRiskProfileQA = function(){
			//call Service to fetch all risk profile list
			if($scope.isLoggedIn){
				mutualFundsService.getRiskProfileQA().then(function(data){
				$scope.questions=data.getRiskProfile.questionList;
				
				}, function(error){
						utilityService.showErrorMessage(error.responseMessage);

				});
			}else{
				mutualFundsService.getRiskProfileQAPre().then(function(data){
				$scope.questions = data.getRiskProfile.questionList;
				
				}, function(error){
						utilityService.showErrorMessage(error.responseMessage);

				});
			}
			
		}	
	
	
	
	
	/*** Function to go back to Mutual Funds home  Page  ***/
	
	riskProfileQAVm.goToHome=function(){
		if($scope.isLoggedIn){
		  $state.go('menu.mutualFunds');
		}else{
			$state.go('menu.leadGenerationInvestment');
		}
		
	}
	
	/*** Function to go back question wise ***/
	riskProfileQAVm.goBack=function (){
		if($scope.setOfAnswerArray.length){
			$scope.setOfAnswerArray.splice(-1,1);
		}
		if($scope.pageVal==5){
			$scope.middleBreadCrumb=true;
			$scope.lastBreadCrumb=true;
			$scope.firstBreadCrumb=false;
		}
		if($scope.pageVal==8 || $scope.pageVal==9){
			$scope.middleBreadCrumb=false;
			$scope.lastBreadCrumb=true;
			$scope.firstBreadCrumb=true;
		}
			
		if($scope.pageVal==0){
			$state.go('menu.startInvesting');
			
		}else{
			$scope.QADiv={};
			$scope.QADiv[$scope.pageVal]=false;
			$scope.QADiv[$scope.pageVal-1]=true;
			$scope.pageVal=$scope.pageVal-1;	
		}
			
		
	}
	/*** Function to go to next question ***/
	riskProfileQAVm.nextQuestion=function (currIndex,ansCurrentIndex){
		$scope.setOfAnswerJson={};
		$scope.setOfAnswerJson={'questionId':$scope.questions[currIndex].questionId,'answerId':$scope.questions[currIndex].optionsList[ansCurrentIndex].optionId};
		$scope.setOfAnswerArray.push($scope.setOfAnswerJson);
			$scope.QADiv={};
			$scope.QADiv[currIndex]=false;
			$scope.QADiv[currIndex+1]=true;
			if(currIndex==4){
				$scope.middleBreadCrumb=false;
				$scope.lastBreadCrumb=true;
				$scope.firstBreadCrumb=true;
			}
			
			if(currIndex==($scope.questions.length-1)){
				var reqParams={};
				reqParams['questionAnswerSet']=$scope.setOfAnswerArray;
				if($scope.isLoggedIn){
					mutualFundsService.setRiskProfileQues(reqParams).then(function(data){
					var showPopup = $ionicPopup.show({
						template: '<img src="img/mf/bg-approved.svg" alt="Success Screen"><h2 translate="YOU_ARE_ALMOST" ></h2><p translate="WE_HAVE_ACCESSED"></p>',
						scope: $scope,
						cssClass: 'dialog',
						buttons: [{
							text: 'Ok',
							type: 'button-positive',
							onTap: function(e) {
								$timeout(function() {
									showPopup.close();  //close the popup after 3 seconds for some reason
								}, 300);
												 
								$state.go('menu.goalPlanning');
								e.preventDefault();
									
							}
						}]
					});

					}, function(error){
						$state.go('menu.goalPlanning');
						utilityService.showErrorMessage(error.responseMessage);

					});
				}else{
					mutualFundsService.setRiskProfileQuesPre(reqParams).then(function(data){
					var showPopup = $ionicPopup.show({
						template: '<img src="img/mf/bg-approved.svg" alt="Success Screen"><h2 translate="YOU_ARE_ALMOST" ></h2><p translate="WE_HAVE_ACCESSED"></p>',
						scope: $scope,
						cssClass: 'dialog',
						buttons: [{
							text: 'Ok',
							type: 'button-positive',
							onTap: function(e) {
								$timeout(function() {
									showPopup.close();  //close the popup after 3 seconds for some reason
								}, 300);
												 
								$state.go('menu.goalPlanning');
								e.preventDefault();
									
							}
						}]
					});

					  }, function(error){
						$state.go('menu.goalPlanning');
						utilityService.showErrorMessage(error.responseMessage);
					});
				}
				
				
			}
			$scope.pageVal = currIndex+1;
		//}
	}
	
	/*** Show information Popup **/
	riskProfileQAVm.showPopup=function(){
		var infoPopup = $ionicPopup.show({
			template: '<p>'+riskProfileQAVm.infoMessage+'</p>',
			cssClass: 'dialog',		
			scope: $scope,
			buttons: [{ 
				text: 'Ok' 
			}]
		});
	}
	
	/*** one time initialization to be done when the controller is loaded***/
	$scope.$on('$ionicView.loaded', function() {
		
	});
	
	/*** actions to done everytime the view is shown***/
	$scope.$on('$ionicView.beforeEnter', function() {
		initPage();
		
	});
	
	 /***any cleanup needs to be done here: executes everytime when page is left***/
	$scope.$on('$ionicView.afterLeave', function() {
		
	});
	return this;
}]);

