
/******* SWITCH Controller ******/

'use strict';

angularApp.controller('switchController', 
	[	"$timeout",
		"$state",
		"$scope",
		"$rootScope",
		"$ionicPopup",
		"mutualFundsService","utilityService","$filter","constantConfig","clickStreamService","customerInfoService","$ionicLoading",
				 
function (	$timeout,
			$state,
			$scope,
			$rootScope,
			$ionicPopup,
			mutualFundsService,utilityService,$filter,constantConfig,clickStreamService,customerInfoService,$ionicLoading) {
	
	

	var switchVm = this;
	/*** Initialize the variables that has to show in  the HTML come here ***/
	function initPage(){
		switchVm.allUnits=0;
		switchVm.targetOption='';
		switchVm.isTermsAndConditionChecked=0;
		switchVm.switchVmPage=1;
		switchVm.switchReviewPage=0;
		switchVm.TermsAndConditionsFlag=0;
		switchVm.successPage=0;
		switchVm.folio='';
		switchVm.dividendOption='';//constantConfig.mfAndsecConst.dividendOption;
		switchVm.minAmountFlag=true;
		switchVm.maxAmountFlag=true;
		switchVm.minUnitFlag=true;
		switchVm.maxUnitFlag=true;
		switchVm.targetFundEligible=true;
		switchVm.selectSwitch=constantConfig.mfAndsecConst.amount;
		var currentDate = new Date();
		switchVm.todayDate= currentDate.setDate(currentDate.getDate());
		switchVm.getFundDetails();	
		switchVm.getAllFundList();
		switchVm.getTransactionNotes();
		switchVm.getPanCard();	
		 var rupeeSymbol = String.fromCharCode(8377);
        $rootScope.clickCount = 0;
        $rootScope.isResendOTP = false;
        $rootScope.isResendDisabled=false;           
        $rootScope.mobileNumber = $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4);
        $rootScope.amountToPay = rupeeSymbol + mutualFundsService.getInvedtedAmount();
        switchVm.accountDetails();
	}
	
	
	/**
		
	* Fetch get Pancard From server
	* @param {id}
	* type
	*/
	switchVm.getPanCard=function(){
		var reqParams={};
		reqParams['id']='';
		mutualFundsService.getPanCardNumber(reqParams).then(function(data){
			switchVm.panCard=data.mfKyc.panNo;
			switchVm.divPayOutMechanism=data.mfKyc.divPayOutMechanism;
			switchVm.redPayOutMechanism=data.mfKyc.redPayOutMechanism;
			//switchVm.folio=data.mfKyc.folioNo;
		}, function(error){
			utilityService.showErrorMessage(error.responseMessage);

		});
	} 

	/**
	         * Fetch get Account and fund  Details From service
	         * @param {fundId}
	         **/
	        switchVm.accountDetails = function() {

	            $scope.accounts = [];
	            switchVm.accounts = mutualFundsService.getDetails();
	            if (switchVm.accounts) {
	                $scope.accountListTemp = switchVm.accounts;
	                var accountListTempLength = $scope.accountListTemp.length;
	                for (switchVm.list = 0; switchVm.list < accountListTempLength; switchVm.list++) {
	                    if ($scope.accountListTemp[switchVm.list].accountType == constantConfig.mfAndsecConst.savingAccountInOpenAccount) {
	                        $scope.accounts.push($scope.accountListTemp[switchVm.list]);
	                    }
	                }
	                // createSIPVm.accountFirstNo = $scope.accounts[0].accountNumber;
	                $timeout(function() {
	                	switchVm.savingAccounts =$scope.accounts[0].accountNumber ;
	                }, 600);
	            }
	        }

	/**
	*Function to go to get Transaction Notes Message
	@params:{}
	**/
	switchVm.getTransactionNotes = function() {
		mutualFundsService.getTransactionNotes().then(function(data) {
			switchVm.nonNfoMssg = data.nonNfo;
			switchVm.commonMssg = data.common;
		}, function(error) {
			switchVm.nonNfoMssg = "";
			switchVm.commonMssg = ""; 
			utilityService.showErrorMessage(error.responseMessage);
		}); 
	}

	/**
	*Function to go to get fund Deatils
    @params:{fundId:''}
	
	**/
	switchVm.getFundDetails=function(){
		switchVm.fundObj=mutualFundsService.getFundToInvest();
		switchVm.fundId=switchVm.fundObj.amfiCode;
		switchVm.availableUnit=switchVm.fundObj.availbleUnits;
		switchVm.totalUnit=switchVm.fundObj.quantity;
		if(switchVm.fundObj.folioNumber){
			switchVm.folio=switchVm.fundObj.folioNumber;
		}
		switchVm.reqParams={};
		switchVm.reqParams['amfiCode']=switchVm.fundId;
		mutualFundsService.getFundDetails(switchVm.reqParams).then(function(data) {
			switchVm.fundDetailList=data;
			switchVm.schemeCode=data.fundId;
			switchVm.fundType=data.fundType;
			if(switchVm.fundDetailList.minRedeemAmount){
				switchVm.sourceMinAmount=$filter('INRFLOAT')(switchVm.fundDetailList.minRedeemAmount,2); 
				switchVm.sourceMinAmount=switchVm.sourceMinAmount.replace(",",'');
			}else{switchVm.sourceMinAmount="";}          
			
			 
			switchVm.amcCode=switchVm.fundDetailList.scmAmcCd;
			
			if(switchVm.fundObj.plan){
				switchVm.plan= switchVm.fundObj.plan;
				switchVm.option = switchVm.fundObj.option;
				switchVm.nav  = $filter('INRFLOAT')(switchVm.fundObj.nav,4);
				switchVm.navDate =  $filter('date')(switchVm.fundObj.navDate,'d MMM yyyy' );
			
			}else{
				if(switchVm.fundDetailList.planList[0]){
					switchVm.plan  = switchVm.fundDetailList.planList[0].plan;
					switchVm.option =switchVm.fundDetailList.planList[0].option;
					switchVm.nav  = $filter('INRFLOAT')(switchVm.fundDetailList.planList[0].nav,4);
					switchVm.navDate = $filter('date')(switchVm.fundDetailList.planList[0].navDate,'d MMM yyyy' );
				}else{
					switchVm.plan  ='';
					switchVm.option='';
					switchVm.nav  ='';
					switchVm.navDate = '';
				}
			}
			if(switchVm.nav){
				switchVm.sourceMinRedeemUnit=switchVm.sourceMinAmount/switchVm.nav; 
				switchVm.maxAmount=switchVm.totalUnit*switchVm.nav; 
			}else{
				switchVm.sourceMinRedeemUnit=switchVm.sourceMinAmount;
			}
		}, function(error) {
			utilityService.showErrorMessage(error.responseMessage);
		});
	}
	
	switchVm.isSchAvailableForSwitch=function(){
		
		switchVm.targetOption='';
		switchVm.dividendOption='';
		switchVm.targetFundId=switchVm.targetSubFundList[parseInt(switchVm.targetSubFund)].amfiCode;
		switchVm.reqParams={};
		switchVm.reqParams['amfiCode']=switchVm.targetFundId;
		
		mutualFundsService.getFundDetails(switchVm.reqParams).then(function(data) {
			switchVm.fundDList=data;
			switchVm.scmSwitchInAvailable=switchVm.fundDList.scmSwitchInAvailable;
			switchVm.targetMinAmount=$filter('INRFLOAT')(switchVm.fundDetailList.addMinPurchaseAmt,2);  //Need to check with team
			switchVm.targetNav=$filter('INRFLOAT')(switchVm.fundDList.planList[0].nav,4);
			switchVm.targetPlan= switchVm.fundDList.planList[0].plan;
			switchVm.targetOption = switchVm.fundDList.planList[0].option;
			switchVm.fundOption=switchVm.targetPlan;
			if(switchVm.targetOption.indexOf('D')!=-1){
				switchVm.dividendOption='N';
			}
			if(switchVm.targetMinAmount){
				switchVm.targetMinAmount=switchVm.targetMinAmount.replace(",",'');
			}
			
			if(switchVm.targetNav){
				switchVm.targetMinRedeemUnit=switchVm.targetMinAmount/switchVm.targetNav; //Need to check with team
			}else{
				switchVm.targetMinRedeemUnit=switchVm.targetMinAmount;
			}
		   if(switchVm.scmSwitchInAvailable.toLowerCase()=="yes" && switchVm.fundObj.fundId!=switchVm.fundDList.fundId){
				switchVm.targetFundEligible=true;
			}else{
				switchVm.targetFundEligible=false;
			
			}
		  
		}, function(error) {
			utilityService.showErrorMessage(error.responseMessage);
		});  
	}
	/**
	*Function to checkMinAmount 
	**/
	switchVm.checkMinAmount=function(){
		// Source Min value
		$scope.sourceMinAmount=parseFloat(switchVm.sourceMinAmount);
		$scope.sourceMinRedeemUnit=parseFloat(switchVm.sourceMinRedeemUnit);
		if(switchVm.sourceMinAmount){
			$scope.sourceMinAmount=parseFloat(switchVm.sourceMinAmount.replace(",",''));
		}else{
			$scope.sourceMinAmount=parseFloat(switchVm.sourceMinAmount);
		}
		$scope.sourceMinRedeemUnit=parseFloat(switchVm.sourceMinRedeemUnit);
		$scope.maxAmount=parseFloat(switchVm.maxAmount);
		
		
		//Target Min value
		$scope.targetMinAmount=parseFloat(switchVm.targetMinAmount);
		$scope.targetMinRedeemUnit=parseFloat(switchVm.targetMinRedeemUnit);
		
		if(switchVm.selectSwitch==constantConfig.mfAndsecConst.amount){
			if($scope.targetMinAmount>=$scope.sourceMinAmount){
				$scope.minAmount=$scope.targetMinAmount;
			}
			else{
				$scope.minAmount=$scope.sourceMinAmount;
			}
			$scope.enteredAmount=parseFloat(switchVm.switchAmount) ;
			if($scope.minAmount>$scope.enteredAmount){
				switchVm.minAmountFlag=false;
				switchVm.maxAmountFlag=true;
			}else if($scope.maxAmount<$scope.enteredAmount){
				switchVm.minAmountFlag=true;
				switchVm.maxAmountFlag=false;
			}
			else{
				switchVm.maxAmountFlag=true;
				switchVm.minAmountFlag=true;
			}
			
			
		}else{
			if($scope.targetMinRedeemUnit>=$scope.sourceMinRedeemUnit){
				$scope.minUnit=$scope.targetMinRedeemUnit;
			}
			else{
				$scope.minUnit=$scope.sourceMinRedeemUnit;
			}
			$scope.maxUnit=parseFloat(switchVm.totalUnit);
			$scope.enteredAmount=parseFloat(switchVm.switchUnit) ;
			
			if($scope.minUnit > $scope.enteredAmount){
				switchVm.minUnitFlag=false;
			}else if($scope.maxUnit<$scope.enteredAmount){
				switchVm.minUnitFlag=true;
				switchVm.maxUnitFlag=false;
			}else{
				switchVm.maxUnitFlag=true;
				switchVm.minUnitFlag=true;
			}
		}
		
		
	}
	/**
	*Function to Switch Redeem details
	**/

	switchVm.submitSwitch = function(){	
		var requestSecKey='';
		var reqParams = {};
		if(!switchVm.isTermsAndConditionChecked){
			return false;
		}
		switchVm.txnId=utilityService.getRandomNumber();
		var requestDate = new Date();
		requestDate = requestDate.getTime();
		requestSecKey=Math.floor((Math.random()) + requestDate);
		requestSecKey = (requestSecKey * 10 + 1);

		clickStreamService.clickStreamData=switchVm.txnId;
		
		reqParams["txnType"] = constantConfig.mfAndsecConst.SWITCH;	
		reqParams["schemeId"] = switchVm.schemeCode; 
		reqParams["schemeName"] = switchVm.fundDetailList.fundName;	
		reqParams["schemePlan"] =  switchVm.plan;
		reqParams["schemeOption"] = switchVm.option;
		reqParams["transactionType"] = constantConfig.mfAndsecConst.transactionTypeSwitch ;   //"SO"; 
		reqParams["startDate"] = $filter('date')(new Date(switchVm.todayDate), 'dd/MM/yyyy') ;
		reqParams["endDate"] = '';
		
		if(switchVm.selectSwitch==constantConfig.mfAndsecConst.amount){
			reqParams["amount"] = switchVm.switchAmount ;
			$rootScope.amountToPay=switchVm.switchAmount;
             $rootScope.unitName=constantConfig.mfAndsecConst.amount;
			mutualFundsService.addInvedtedAmount(switchVm.switchAmount);//for OTP page showing
			switchVm.closeAc="";
		}else{
			//reqParams["units"] = switchVm.switchUnit * $filter('INRFLOAT')(switchVm.fundObj.nav,4);	
			reqParams["units"] = switchVm.switchUnit;	
			$rootScope.unit=switchVm.switchUnit;	
			$rootScope.unitName=constantConfig.mfAndsecConst.units;	
			mutualFundsService.addInvedtedAmount(switchVm.switchUnit);//for OTP page showing
			if(switchVm.closeAc!="Y"){
				switchVm.closeAc="";
			}
		}
		reqParams["accountNo"] =switchVm.savingAccounts;
		reqParams["frequency"] ='';
				
		reqParams["isPerpetual"] = "";
		reqParams["amcCode"] = switchVm.amcCode;
		reqParams["folioNo"] =switchVm.folio;
		reqParams["txnDate"] = "";
		reqParams["txnTime"] = "";
		reqParams["sipRegisteredDate"] = "";
		reqParams["numberOfInstallments"] = "";
		reqParams["installmentNumber"] = "";
		reqParams["bankName"] = "";
		reqParams["bankCode"] = "";
		reqParams["bankCity"] = "";
		reqParams["accountType"] = "";
		reqParams["panNo"] = switchVm.panCard;
		reqParams["customerTermandCondition"] = switchVm.isTermsAndConditionChecked;
		reqParams["branchName"] = "";
		reqParams["targetSchemeId"] =switchVm.targetFundIdInsubmit;
		reqParams["targetSchemeName"] = switchVm.targetfundNameInsubmit;
		reqParams["targetSchemePlan"] = switchVm.targetPlan;
		reqParams["targetSchemeOption"] =switchVm.targetOption;
	
		reqParams["dividendOption"] =switchVm.dividendOption;
		reqParams["divPayoutMechanism"]=switchVm.divPayOutMechanism;
		reqParams["redPayoutMechanism"]=switchVm.redPayOutMechanism;
		reqParams["txnId"]=switchVm.txnId;
		reqParams["amfiCode"]=switchVm.fundId;
		reqParams["closeAc"]=switchVm.closeAc;
		reqParams["secKey"]=requestSecKey;
        reqParams["navValue"]=$filter('INRFLOAT')(switchVm.fundObj.nav,4);

        $rootScope.fundName=switchVm.fundDetailList.fundName;       
		$rootScope.targetfundNameInsubmit=switchVm.targetfundNameInsubmit;
       
		mutualFundsService.payDuesRequest(reqParams).then(function(data){
			if(data.submitRequest.isOTPRequired == "true"){			
			        $rootScope.stpotpPage=0;
			        $rootScope.redeemotpPage=0;
					$rootScope.cancelotpPage=0;       	
			        $rootScope.sipotpPage=0;
					$rootScope.lumsumotpPage=0;
					$rootScope.swpotpPage=0;									
					$rootScope.switchotpPage=1;	 	    	 	
	             $state.go('menu.switchOTP');
	         }else{
	         	var calCulatedKey=mutualFundsService.verifySecKey(parseInt(data.submitRequest.secKey));
	            if(requestSecKey==calCulatedKey){
					switchVm.message = data.submitRequest.status;
					switchVm.transactionReferenceNo = data.submitRequest.transactionReferenceNo;						
					 $rootScope.unitName=constantConfig.mfAndsecConst.amount;					
						switchVm.switchVmPage=0;
						switchVm.switchReviewPage=0;
						switchVm.successPage=1;	  
	                   if($rootScope.amountToPay!=null){
	                 	  switchVm.switchAmount= $rootScope.amountToPay;  
	                   }else{
                         switchVm.switchUnit=  mutualFundsService.getInvedtedAmount();  
	                   }                          
	                   switchVm.transactionDate=new Date(data.submitRequest.transactionDate)
						utilityService.setCsatJournies("mutualFunds");					
	           }
		  }
		}, function(error){
			utilityService.showErrorMessage(error.responseMessage);
		});
	}

	 $scope.validateOTP=function(){
            var reqParams={};
            var requestSecKey='';
		    var requestDate = new Date();
		    requestDate = requestDate.getTime();
		    requestSecKey=Math.floor((Math.random()) + requestDate);
		    requestSecKey = (requestSecKey * 10 + 1);

            reqParams.otp= $scope.enterOTP;
            reqParams.secKey=requestSecKey; 
            mutualFundsService.validateOTPForPayment(reqParams).then(function(data){
             if(data.data.otpStatus == "0000"){
                 var calculatedKey=mutualFundsService.verifySecKey(parseInt(data.data.secKey));
                 if(requestSecKey==calculatedKey){ 
                 	 $rootScope.switchSuccessPage=1;
                 	 $rootScope.lumsumSuccessPage=0; 
                         $rootScope.cancelSuccessPage=0; 
		         $rootScope.redeemSuccessPage=0;
                 	 $rootScope.swpSuccessPage=0;                 	 
                 	 $rootScope.stpSuccessPage=0;                 	
                 	 $rootScope.sipSuccessPage=0;  	  
                     $rootScope.transactionReferenceNo=data.data.transactionReferenceNo;      
	                 $rootScope.fundName= $rootScope.fundName;     
	                 $rootScope.targetfundNameInsubmit=$rootScope.targetfundNameInsubmit ;    
	                 $rootScope.transactionDate= new Date(data.data.transactionDate);	                                        
	                             
	                 utilityService.setCsatJournies("mutualFunds");              
	                 $state.go('menu.switchPaymentSuccess');
	                 }
	             }else if(data.data.otpStatus != "0000"){
	             	  mutualFundsService.clearOTP($rootScope.enterOTP);
	                  $scope.errorMessage=data.responseMessage;
	             }else{                  
                    switchVm.showErrorInformationPopup(error.responseMessage);
               }
            },function(error){
            	//utilityService.showErrorMessage(error.responseMessage);
            	 switchVm.showErrorInformationPopup(error.responseMessage);
            })
              
        }

          $scope.resendOTP=function(){
             $scope.enterOTP="";
            var reqParams ={};
            reqParams.id ="";
            reqParams.emailId ="";
            mutualFundsService.getOTPTokenSecure(reqParams).then(function(data){
                 $rootScope.clickCount++;
                 $scope.mutualFundEnterOTPForm={};
                if($rootScope.clickCount==2){
                    $scope.disableLink=true;
                }
            })          
        }


       //****Submit button on OTP Page***//
         $scope.validateOTPNext=function(){
         	$scope.enterOTP=document.getElementById('txt_otp').value;
           if(validateForm()){         
            $scope.validateOTP();
            }           
         }   
       
       
       function validateForm(){
             $rootScope.mutualFundEnterOTPForm={};
            if(mutualFundsService.isValidOTPNum($scope.enterOTP)){
                 $scope.errorMessage=mutualFundsService.isValidOTPNum($scope.enterOTP);
            }
            return (angular.equals({}, $rootScope.mutualFundEnterOTPForm))?true:false;
        }
	
	
	switchVm.openReviewPage=function(){
		switchVm.targetFundIndex=parseInt(switchVm.targetSubFund);
	   	switchVm.targetFundIdInsubmit=switchVm.targetSubFundList[switchVm.targetFundIndex].fundId;
		switchVm.targetfundNameInsubmit=switchVm.targetSubFundList[switchVm.targetFundIndex].fundName;
		switchVm.isTermsAndConditionChecked=0;
		switchVm.switchVmPage=0;
		switchVm.switchReviewPage=1;
		switchVm.TermsAndConditionsFlag=0;
		switchVm.successPage=0;
		
	}
	/***Function to GET fund subdata start***/
	switchVm.changeFundScheme = function(){

		var fundSchemeObj= switchVm.targetFundList[parseInt(switchVm.targetFund)];
		switchVm.targetSubFundList=fundSchemeObj.fundSchemeList;
	 	$timeout(function() {
			switchVm.targetSubFund ="";
		}, 1000);
		
	}
		
	/***Function to GET Fund Detail start***/
	switchVm.getAllFundList = function(){
		 $ionicLoading.show({
           template: '<ion-spinner icon="android"></ion-spinner>'
         });
		mutualFundsService.getAllMutualFunds().then(function(data) {
			switchVm.targetFundList=data.fundList;
			switchVm.firstFundSchemeName=data.fundList[0];
			switchVm.targetFund="0";
			var fundSchemeObj=switchVm.targetFundList[0];
			switchVm.targetSubFundList=fundSchemeObj.fundSchemeList;
			switchVm.targetSubFund ="";			
			$ionicLoading.hide();
		}, function(error) {
			$ionicLoading.hide();
			utilityService.showErrorMessage(error.responseMessage);
			
		}); 
	}	
	
	
	
	
	/***Start term and Condition***/
	switchVm.termsAndConditions=function(){
		if(switchVm.TermsAndConditionsFlag==1){
			switchVm.TermsAndConditionsFlag=0;
		}else{
			/** Call service to fetch termsConditionsMessage**/
			switchVm.reqParams={};
			switchVm.reqParams['action']=constantConfig.mfAndsecConst.SWITCH;
			mutualFundsService.getTermsAndConditions(switchVm.reqParams).then(function(data) {
				switchVm.TermsAndConditionsMessage=data.message;
			
			}, function(error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
			switchVm.TermsAndConditionsFlag=1;
		}			
	}
	
	
	
	/*** Unit***/
	switchVm.allUnitsCheck= function(){
		if(switchVm.allUnits == "1"){
			switchVm.minUnitFlag=true;	
			switchVm.closeAc="Y"
			switchVm.switchUnit = switchVm.totalUnit;
		}
		else{
			redeemVm.closeAc=""
			switchVm.switchUnit = '';
			
		}
	}
	/***Function to show information POP UP for future use***/
	switchVm.showInformationPopup=function(){
		var infoPopup = $ionicPopup.show({
			template: '<p>Message</p>',
			title:'Information',
			scope: $scope,
			buttons: [ {text: 'Ok'}]
		});

		infoPopup.then(function(res) {
        
		});    
	}
	/***Function to show alert POP UP***/
		switchVm.showErrorInformationPopup=function(message){
			var infoPopup = $ionicPopup.show({
				template: '<p>'+message+'</p>',
				title:'Alert',
				cssClass: 'dialog',		
				scope: $scope,
				buttons: [ {
					text: 'Ok',
					onTap: function(e) {
						$state.go('menu.accountOverviewMyBalance');
					}
				}]
			});
		}
	/***Function to show success page***/
	switchVm.showSuccesPage=function(){
		switchVm.switchVmPage=0;
		switchVm.successPage=1;
	}
	
	/***Function to go to portfolio page***/
	$scope.portfolio=function(){
		$state.go("menu.portfolio");
		switchVm.switchVmPage=1;
		switchVm.successPage=0;
	}
	$scope.closePage =function(){
		$state.go("menu.portfolio");		
	}
	/***BACK to page***/
	switchVm.backToSwitch=function(){
		switchVm.isTermsAndConditionChecked=0;
		switchVm.switchVmPage=1;
		switchVm.switchReviewPage=0;
		switchVm.TermsAndConditionsFlag=0;
		switchVm.successPage=0;
		
		
	}
	/*** actions to done everytime the view is shown***/
	$scope.$on('$ionicView.beforeEnter', function() {
		initPage();
		
	});
	
	
	return this;
}]);

