'use strict';

angularApp.controller('taxSaverController',
	["$timeout",
		"$state",
		"$scope",
		"$ionicHistory",
		"mutualFundsService",
		"$filter",

		function ($timeout,
			$state,
			$scope,
			$ionicHistory,
			mutualFundsService,
			$filter) {


			var taxSaverVm = this;

			/*** Initialize the variables that has to show in  the HTML come here ***/
			taxSaverVm.initPage = function () {
				taxSaverVm.funds = angular.copy(mutualFundsService.taxSaverFunds);
				angular.forEach(taxSaverVm.funds, function (value, key) {
					if (value.aumEffectiveDate) {
						taxSaverVm.funds[key].aumEffectiveDate = $filter('date')(new Date(value.aumEffectiveDate), 'dd/MM/yyyy');
					}
				});
			}

			taxSaverVm.goBack = function () {
				$ionicHistory.goBack(-1);
			}

			taxSaverVm.getFundDetail = function (fund) {
				var request = {
					'amfiCode': fund.amfiCode
				}
				mutualFundsService.getFundDetails(request).then(function (data) {
					data.amfiCode = fund.amfiCode;
					data.riskParameter = fund.riskParameter;
					
					var schFndid = fund.schemeFundId;
					var fundoptnArr = [];
					fundoptnArr.push(fund);
					for (var k = 0; k <mutualFundsService.taxSaverFunds.length; k++) {
						if(mutualFundsService.taxSaverFunds[k].schemeFundId == schFndid){
							fundoptnArr.push(mutualFundsService.taxSaverFunds[k]);
						}
					}
			
					fundoptnArr = $filter('uniqueArr')(fundoptnArr, 'fundId');
					mutualFundsService.addFundId(fundoptnArr);

					$state.go('menu.fundDetails');
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			/*** actions to done everytime the view is shown***/
			$scope.$on('$ionicView.beforeEnter', function () {
				taxSaverVm.initPage();
			});

			return this;
		}]);

