/******* Type of investment Controller ******/

'use strict';

angularApp.controller('typeOfInvestmentController',
	["$timeout",
		"$state",
		"$scope",
		"$translate",
		"$location",
		"$ionicScrollDelegate",
		"mutualFundsService",
		"$filter",
		"$ionicPopup",
		"utilityService",
		"$rootScope","homeScreenService",

		function ($timeout,
			$state,
			$scope,
			$translate,
			$location,
			$ionicScrollDelegate,
			mutualFundsService,
			$filter,
			$ionicPopup,
			utilityService,
			$rootScope,homeScreenService) {
			var typeOfInvestmentVm = this;
			/*** Initialize the variables that has to show in  the HTML come here ***/
			function initPage() {
				typeOfInvestmentVm.getCustomerinfo();
				typeOfInvestmentVm.getAllInfoList();
				typeOfInvestmentVm.getSelectedFundId();
				//typeOfInvestmentVm.getPortfolio();
			}

			typeOfInvestmentVm.getCustomerinfo = function () {
			   homeScreenService.getCustomerInfo().then(function (data) {
			   })
			}	
			/**
			@Function to get Selected Fund
			 @Function to get Fund Details
			* fundId:{object}
			***/
			typeOfInvestmentVm.getSelectedFundId = function () {
				typeOfInvestmentVm.fundObj = mutualFundsService.getFundToInvest();
				typeOfInvestmentVm.folioObj = mutualFundsService.getFolioToInvest();
				typeOfInvestmentVm.folioNumber = typeOfInvestmentVm.folioObj.mfKyc.folioNo;
				typeOfInvestmentVm.amfiCode = typeOfInvestmentVm.fundObj.amfiCode;
				typeOfInvestmentVm.reqParams = {};
				typeOfInvestmentVm.reqParams['amfiCode'] = typeOfInvestmentVm.amfiCode;
				mutualFundsService.getFundDetails(typeOfInvestmentVm.reqParams).then(function (data) {
					typeOfInvestmentVm.fundDetailList = data;
					if (typeOfInvestmentVm.fundDetailList.planList[0]) {
						typeOfInvestmentVm.plan = typeOfInvestmentVm.fundDetailList.planList[0].plan;
						typeOfInvestmentVm.option = typeOfInvestmentVm.fundDetailList.planList[0].option;
						typeOfInvestmentVm.nav = $filter('INRFLOAT')(typeOfInvestmentVm.fundDetailList.planList[0].nav, 4);
						typeOfInvestmentVm.navDate = $filter('date')(typeOfInvestmentVm.fundDetailList.planList[0].navDate, 'd MMM yyyy');
					} else {
						typeOfInvestmentVm.plan = '';
						typeOfInvestmentVm.option = '';
						typeOfInvestmentVm.nav = '';
						typeOfInvestmentVm.navDate = '';
					}
					typeOfInvestmentVm.scmPurAvailable = typeOfInvestmentVm.fundDetailList.scmPurAvailable;
					typeOfInvestmentVm.scmSIPAvailable = typeOfInvestmentVm.fundDetailList.scmsipAvailable;

						       
	                if (!mutualFundsService.multiFolio) {
	                	utilityService.showSpinner();   
	            		mutualFundsService.getPortfolio().then(function (res) {
						mutualFundsService.multiFolio = res.multiFolio;
						utilityService.hideSpinner();
					 },function(error){
					 	utilityService.hideSpinner();
					 })
             	   }
            





				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			/*** Function to go to Mutual Funds Introduction Page  ***/
				typeOfInvestmentVm.getAllInfoList=function (){
					/*** Call service to fetch funds list**/
					mutualFundsService.getAllInfoLists().then(function(data) {
						mutualFundsService.addInfoList(data.infoList);
					}, function(error) {
						utilityService.showErrorMessage(error.responseMessage);
					}); 
				
				}	
			/***Function to show alert POP UP***/
			typeOfInvestmentVm.showInformationPopup = function (message) {
				var infoPopup = $ionicPopup.show({
					template: '<p>' + message + '</p>',
					title: 'Alert',
					cssClass: 'dialog',
					scope: $scope,
					buttons: [{ text: 'Ok' }]
				});
			}

			/***Function to go to lumpsum  page***/
			typeOfInvestmentVm.createLumpsum = function () {
				if (typeOfInvestmentVm.scmPurAvailable == "YES" && mutualFundsService.getDetails()) {
					$state.go("menu.lumpsum");
				} else if (!mutualFundsService.getDetails()) {
					typeOfInvestmentVm.showInformationPopup("Something went wrong. Please try again.");
				} else {
					if (typeOfInvestmentVm.scmPurAvailable == null || typeOfInvestmentVm.scmPurAvailable == '' || typeOfInvestmentVm.scmPurAvailable == undefined) {
						$state.go("menu.lumpsum");
					} else {
						typeOfInvestmentVm.showInformationPopup("Purchase is not available for this Scheme");
					}
				}
			}

			/***Function to go to SIP  page***/
			typeOfInvestmentVm.createSIP = function () {
				if (typeOfInvestmentVm.scmSIPAvailable == "YES" && mutualFundsService.getDetails()) {
					$state.go("menu.createSIP");
				} else if (!mutualFundsService.getDetails()) {
					typeOfInvestmentVm.showInformationPopup("Something went wrong. Please try again.");
				} else {
					if (typeOfInvestmentVm.scmSIPAvailable == null || typeOfInvestmentVm.scmSIPAvailable == '' || typeOfInvestmentVm.scmSIPAvailable == undefined) {
						$state.go("menu.createSIP");
					} else {
						typeOfInvestmentVm.showInformationPopup("SIP is not available for this Scheme");
					}
				}
			}

			/***Function to go to SIP  page***/
			typeOfInvestmentVm.goToHome = function () {
				$state.go("menu.mutualFunds");
			}

			/*** one time initialization to be done when the controller is loaded***/
			$scope.$on('$ionicView.loaded', function () {

			});

			/*** actions to done everytime the view is shown***/
			$scope.$on('$ionicView.beforeEnter', function () {
				initPage();
			});

			/***any cleanup needs to be done here: executes everytime when page is left***/
			$scope.$on('$ionicView.afterLeave', function () {

			});
			return this;
		}]);

