'use strict';

angularApp.controller('myBarrowingsController',
	["$timeout",
		"$state",
		"$scope",
		"$location",
		"$ionicScrollDelegate",
		"getAccountDetailsService",
		"accountOverviewService",

		function ($timeout,
			$state,
			$scope,
			$location,
			$ionicScrollDelegate,
			getAccountDetailsService,
			accountOverviewService) {
			//functions, variables that can be accessed from the HTML come here
			var myBarrowingsVm = this;
			//private methods section start
			function initPage() {
				myBarrowingsVm.showBack = false;
				myBarrowingsVm.showNext = true;
				getAccountDetailsService.getAccountDetails().then(function (data) {
					myBarrowingsVm.headerList = data.headerList;
					myBarrowingsVm.accounts = data.accounts;
					//Success - Data
					myBarrowingsVm.loanDetails = data.loanDetails;
					myBarrowingsVm.preApprovedLoanAmount = data.preApprovedLoanAmount;
				}, function (error) {

				});
				myBarrowingsVm.img = getAccountDetailsService.img;
				myBarrowingsVm.img1 = getAccountDetailsService.img1;
				myBarrowingsVm.handimg = getAccountDetailsService.handimg;
				$location.hash('myBorrowingView');
				// call $ionicScrollDelegate()
				$ionicScrollDelegate.anchorScroll();
			}
			//private methods section end

			//public functions start

			//public functions end
			myBarrowingsVm.goBacktoPrevious = function () {
				//To do
			}

			myBarrowingsVm.goToNextPage = function () {
				$state.go('menu.myBarrowings');
			}

			myBarrowingsVm.transaction = function () {
				$state.go('menu.transaction');
			}

			myBarrowingsVm.autoLoanFun = function () {
				$state.go('menu.autoLoan');
			}

			myBarrowingsVm.overdraftAcc = function (data) {
				accountOverviewService.customer.ODaccount = data;
				$state.go('menu.overdraftAcc');
			}

			//one time initialization to be done when the controller is loaded
			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			//actions to done everytime the view is shown
			$scope.$on('$ionicView.beforeEnter', function () {

			});

			//actions to done everytime the view is hidden
			$scope.$on('$ionicView.afterLeave', function () {
				//any cleanup needs to be done here: executes everytime when page is left
			});
			return this;
		}]);