'use strict';

angularApp.controller('myCardsController', 
						["$timeout",
						 "$state",
						 "$scope",
						 "$ionicPopup",
						 "$location",
						 "$ionicScrollDelegate",
						 "myCardsService",
						 "getAccountDetailsService",
				 
function ($timeout,
		 $state,
		 $scope,
		 $ionicPopup,
		 $location,
		 $ionicScrollDelegate,
		 myCardsService,
		 getAccountDetailsService) {
	
	//functions, variables that can be accessed from the HTML come here
	var myCardsVm = this;
	
 
// Service injection

	myCardsVm.cardListPopup = function() {
		$scope.data = {}
		myCardsVm.myPopup = $ionicPopup.show({
			title:'Select Card',	
			template : '<div style="text-align: center;padding: 6px;border-bottom: 1px solid #206d8c;margin: 0px 30px;color: #206d8c;"ng-repeat="acc in myCardsVm.creditCards" ng-click="myCardsVm.selectedCard(acc.creditCardNo)">{{acc.creditCardNo}}<div>',
			scope: $scope
		});

	};
	myCardsVm.selectedCard =function (e){
		
		myCardsService.getCreditCardDetails(e).then(function(data){
			
			myCardsVm.creditCardDetails=data;
			myCardsVm.creditUsedPer =(myCardsVm.creditCardDetails.creditLimitUsed/myCardsVm.creditCardDetails.creditLimit)*100;
			myCardsVm.cashUsedPer =(myCardsVm.creditCardDetails.cashLimitUsed/myCardsVm.creditCardDetails.cashLimit)*100;
			}, function(error){

			});
	myCardsVm.myPopup.close();
	}
	
	myCardsVm.LinkCreditCards = function(){
		
		$state.go('menu.linkCard');
		
	}
	
	myCardsVm.deLinkCards = function(){
		var alertPopup = $ionicPopup.confirm({
		     title: '',
		     templateUrl: 'pages/cards/delinkPopup.html',
		     okText:'Delink',
		     cancelText:'Cancel'
		   });
		alertPopup.then(function(res) {
			
			if(res){
				var alertPopup = $ionicPopup.alert({
				     title: '',
				     templateUrl: 'pages/cards/delinkPopup2.html'
				   });
			}else{
				alertPopup.close()
			}
			
		   });
		
	}
	
	myCardsVm.getNewCreditCard = function(){
		$state.go('menu.cardIntroduction');
	}
	
	myCardsVm.trackApplication = function(){
		var alertPopup = $ionicPopup.alert({
		     title: '',
		     templateUrl: 'pages/cards/applicationStatusPopup.html'
		   });
		alertPopup.then(function(){
			$state.go("menu.myCards");
		});
	}
	
	this.completeApplication = function(){
		//$state.go('menu.cardCitySelection');
		$state.go('menu.cardPersonalDetails1');
	}





	myCardsVm.transaction= function(){
	$state.go('menu.transaction');	
	}
	//private methods section start
	function initPage(){
		
		myCardsVm.showBack = false;
		myCardsVm.showNext = false;
		 $location.hash('myCardsView');

	     // call $ionicScrollDelegate()
	     $ionicScrollDelegate.anchorScroll();

	     
	}
	myCardsVm.goBacktoPrevious = function(){
	}

	myCardsVm.goToNextPage = function(){
		$state.go('menu.accountOverviewPopup');
	}
	$scope.$on('$ionicView.loaded', function() {
		
		
		initPage();
	});
	
	$scope.$on('$ionicView.beforeEnter', function() {
		 getAccountDetailsService.getAccountDetails().then(function(data){
		 	myCardsVm.headerList=data.headerList;
				//Success - Data
			
			myCardsVm.creditCards=data.creditCards;
			
			myCardsVm.selectedCardNumber=myCardsVm.creditCards[0].creditCardNo;
			myCardsVm.creditCardList=myCardsService.creditCardList;
			myCardsService.getCreditCardDetails(myCardsVm.selectedCardNumber).then(function(data){
			myCardsVm.creditCardDetails=data;
			myCardsVm.creditUsedPer =(myCardsVm.creditCardDetails.creditLimitUsed/myCardsVm.creditCardDetails.creditLimit)*100;
			myCardsVm.cashUsedPer =(myCardsVm.creditCardDetails.cashLimitUsed/myCardsVm.creditCardDetails.cashLimit)*100;
			}, function(error){

			});
		},function(error){
			
		});
		
	});
	
	//actions to done everytime the view is hidden
	$scope.$on('$ionicView.afterLeave', function() {
		
		//any cleanup needs to be done here: executes everytime when page is left
		
	});
	return this;
}]);