'use strict';

angularApp.controller('reviewYourDreamController', 
						["$timeout",
						 "$state",
						 "$location",
						 "$scope",
				         "$ionicPopup",
						 "myDreamsServices",
						 "utilityService",
						 "getAccountDetailsService",
function ($timeout,
		 $state,
		 $location,
		 $scope,
		 $ionicPopup,
		 myDreamsServices,utilityService,getAccountDetailsService) {
	
	//functions, variables that can be accessed from the HTML come here
	var reviewYourDreamVm = this;
	

	//private methods section start
	function initPage(){
		reviewYourDreamVm.checkTnC = false;
		reviewYourDreamVm.currData =  myDreamsServices.getDetails(); 
		reviewYourDreamVm.dreamImage = reviewYourDreamVm.currData.dreamImage;
		
		reviewYourDreamVm.dreamName = reviewYourDreamVm.currData.calculateDreamInterestDetails.dreamName; 
		reviewYourDreamVm.monthlyContribution = reviewYourDreamVm.currData.calculateDreamInterestDetails.monthlyContribution;
		reviewYourDreamVm.monthlyContributionDate = reviewYourDreamVm.currData.calculateDreamInterestDetails.monthlyContributionDate;
		reviewYourDreamVm.totalAmount = reviewYourDreamVm.currData.calculateDreamInterestDetails.totalAmount;
		reviewYourDreamVm.interestRate = reviewYourDreamVm.currData.calculateDreamInterestDetails.intrestRate;
		reviewYourDreamVm.startDateNew = reviewYourDreamVm.currData.calculateDreamInterestDetails.startDate;
		$scope.totalAmount = reviewYourDreamVm.currData.calculateDreamInterestDetails.totalAmount;
		reviewYourDreamVm.startDate =reviewYourDreamVm.currData.startDate;
		reviewYourDreamVm.endDate=reviewYourDreamVm.currData.endDate
		
		reviewYourDreamVm.showBack = true;
		reviewYourDreamVm.showNext = true;
	}
	
	
	reviewYourDreamVm.confirmReviewYourDreamPopup = function(){
		
		var reqParams = {}
		/* dates are passed in mmddyyyy format */
		reqParams = {  
			"dreamName": reviewYourDreamVm.dreamName,  
			"dreamID": reviewYourDreamVm.currData.dreamID,  
			"totalAmount": reviewYourDreamVm.totalAmount.toString().split(',').join(""),  
			"monthlyContribution": reviewYourDreamVm.monthlyContribution.toString().split(',').join(""),  
			"monthlyContributionDate": reviewYourDreamVm.monthlyContributionDate,  
			"intrestRate": reviewYourDreamVm.interestRate,  
			"startDate": reviewYourDreamVm.startDateRequest, 
			"endDate": reviewYourDreamVm.endDateRequest,
			"toAccountNumber":  reviewYourDreamVm.currData.accountNo, 
			"termsNcondition" :reviewYourDreamVm.checkTnC,
			"intCategory":  myDreamsServices.selectedDetails.intCategory,
			"accountTypeCode": myDreamsServices.selectedDetails.accountTypeCode
		};
		utilityService.showSpinner();
		/****************   call add Funds To MyDreams function start**************/
		myDreamsServices.addFundsToMyDreams(reqParams).then(
			function(data) {
			reviewYourDreamVm.nightMode = data.nightMode == "Y" ? true : false;
			if(reviewYourDreamVm.nightMode){
				reviewYourDreamVm.storeRefNumber = data.storeRefNumber;
			}else{
				reviewYourDreamVm.status = data.submitMyDream.status;
			}
			utilityService.hideSpinner();
			var confirmPopup = $ionicPopup.confirm({
				 title: '',
				 templateUrl: 'pages/accountOverview/myDeposits/myDreams/addFund/confirmReviewYourDreamPopup.html',
				 scope : $scope,
				 cssClass : 'dialog',
				 buttons: [
				{
					   text: 'OK',
						  onTap: function(e) {
							utilityService.setCsatJournies("goalBasedSavingMyDreams");
							getAccountDetailsService.accountOverviewData="";
							$state.go('menu.accountOverviewMyBalance');	 
						  }
					}
				 ]
			   });
		},
		function(error) {
			utilityService.hideSpinner();
			utilityService.showErrorMessage(error.responseMessage);
		}
	);
		
		
		/****************   call add Funds To MyDreams function end**************/
	}
	
	//this function is define to call terms and conditions service
	reviewYourDreamVm.getTermsAndConditionsFun = function(){
		utilityService.showSpinner();
		myDreamsServices.getTermsAndConditions().then(function(data) {
			reviewYourDreamVm.termsConditions = data.termsConditions;
			utilityService.hideSpinner();
			$state.go('menu.dreamTerms',{termsObj:reviewYourDreamVm.termsConditions});
		},
		function(error) {
			utilityService.hideSpinner();
			utilityService.showErrorMessage(error.responseMessage);
		});
	}
	
	//go to review dream page 
	reviewYourDreamVm.reviewDream = function(){
		$state.go('menu.reviewDream');
	}
	
	reviewYourDreamVm.openTC = function(){
		reviewYourDreamVm.getTermsAndConditionsFun();
	}	
	
	//back to prev page
	reviewYourDreamVm.goBacktoPrevious = function(){
		//To do
	}
	//Go To homePage
	reviewYourDreamVm.goToHome = function(){
		$state.go('menu.accountOverviewMyBalance');
	}
	//go to next page cancelAddFund
	reviewYourDreamVm.cancelAddFund = function(){
		$state.go("menu.accountOverviewMyBalance");
	}
	reviewYourDreamVm.dreamTransDetails = function(){
		$state.go('menu.dreamTransDetails');
	}
	
	//one time initialization to be done when the controller is loaded
	$scope.$on('$ionicView.loaded', function() {
		
	});
	
	//actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function() {
		initPage();
	});
	
	//actions to done everytime the view is hidden
	$scope.$on('$ionicView.afterLeave', function() {
		
		//any cleanup needs to be done here: executes everytime when page is left
	});
	return this;
}]);