'use strict';

angularApp.controller('createMyDreamController',
	["$timeout",
		"$state",
		"$location",
		"$scope",
		"$ionicPopup",
		"cameraService",
		"myDreamsServices",
		"utilityService",
		"getAccountDetailsService",
		"$ionicPopover",
		"homeScreenService",
		"$ionicHistory",
		"$filter",
		function ($timeout,
			$state,
			$location,
			$scope,
			$ionicPopup,
			cameraService,
			myDreamsServices,
			utilityService,
			getAccountDetailsService,
			$ionicPopover,
			homeScreenService,
		$ionicHistory,
		$filter) {

			//functions, variables that can be accessed from the HTML come here
			var createMyDreamVm = this;
			createMyDreamVm.imageId = "";
			createMyDreamVm.seniorCitizenAge = 60;
			createMyDreamVm.seniorCitizenAmount = 10000;


			//private methods section start
			function initPage() {
				createMyDreamVm.isBackCheck = homeScreenService.isBackCheck;
				homeScreenService.isBackCheck = false;
				$scope.currDreamDetails = '';
				createMyDreamVm.dreamName = "";
				createMyDreamVm.goalAmount = "";
				createMyDreamVm.profieImgSrc = 'img/myDreams/cloud-dreamicon.png';
				createMyDreamVm.showBack = true;
				createMyDreamVm.showNext = true;
				createMyDreamVm.createDisabled = true;
			}

			/****************Create my dream alert function start**************/
			createMyDreamVm.createMyDreamAlert = function () {
				utilityService.showSpinner();
				createMyDreamVm.createDisabled = true;

				var customerDOB = new Date(getAccountDetailsService.accountOverviewData.customerInformation.dob);
				var currentDate = new Date();
				var age = currentDate.getFullYear() - customerDOB.getFullYear();
				
				if(age >= createMyDreamVm.seniorCitizenAge && createMyDreamVm.goalAmount < createMyDreamVm.seniorCitizenAmount){
					//display confirmation 
					var msgForSeniorCitizen = $ionicPopup.confirm({
						title: '',
						template: '<div>'+ $filter('translate')("SENIOR_CITIZEN_CONFIRM_MESSAGE1")+ '</div><br /><div>'+ $filter('translate')("SENIOR_CITIZEN_CONFIRM_MESSAGE2") +'</div>',
						scope: $scope,
						cssClass: 'dialog',
						buttons: [
							{
								text: 'Cancel',
								onTap: function (e) {
									msgForSeniorCitizen.close();
									$state.go('menu.accountOverviewMyBalance');
								}
							}, {
								text: 'Confirm',
								onTap: function (e) {
									msgForSeniorCitizen.close();
									createMyDreamVm.createDream();
								}

							}
						]
					});
				}else{
					createMyDreamVm.createDream();
				}

				
			}

			createMyDreamVm.createDream = function(){

				if(createMyDreamVm.profieImgSrc && createMyDreamVm.profieImgSrc != "img/myDreams/cloud-dreamicon.png"){
							createMyDreamVm.uploadImageData(createMyDreamVm.profieImgSrc);
				}else{
					createMyDreamVm.finalCreatDream();
				}	

				
			}

			createMyDreamVm.finalCreatDream = function(){
				var reqParams = {};
				reqParams["dreamName"] = createMyDreamVm.dreamName;
				reqParams["goalAmount"] = createMyDreamVm.goalAmount.toString().split(',').join("");
				reqParams["dreamImage"] = createMyDreamVm.imageId;
				$scope.dreamName = createMyDreamVm.dreamName;
				$scope.goalAmount = createMyDreamVm.goalAmount;
				myDreamsServices.createDream(reqParams).then(function (data) {											
						createMyDreamVm.dreamID = data.createDream.dreamID;
						$scope.currDreamDetails = {
							"picId": createMyDreamVm.imageId,
							"dreamName": createMyDreamVm.dreamName,
							"goalAmount": createMyDreamVm.goalAmount,
							"dreamImage": createMyDreamVm.profieImgSrc,
							"dreamID": createMyDreamVm.dreamID
						};
						myDreamsServices.addDetails($scope.currDreamDetails);
						utilityService.hideSpinner();
						var okPopup = $ionicPopup.confirm({
							title: '',
							templateUrl: 'pages/accountOverview/myDeposits/myDreams/createDream/createMyDreamAlert.html',
							scope: $scope,
							cssClass: 'dialog',
							buttons: [
								{
									text: 'Add Funds',
									onTap: function (e) {
										okPopup.close();
										$state.go("menu.dreamAddFund");

									}
								}, {
									text: 'OK',
									onTap: function (e) {
										okPopup.close();
										getAccountDetailsService.accountOverviewData = "";
										$state.go('menu.accountOverviewMyBalance');
									}

								}
							]
						});
					},
					function (error) {
						createMyDreamVm.checkVal();
						utilityService.hideSpinner();
						utilityService.showErrorMessage(error.responseMessage);
					}
				);
			}
			/****************Create my dream alert function end**************/

			/****************Create take Image From Camera function start**************/


			createMyDreamVm.takeImageFromCamera = function () {
				cameraService.getnewDreamImage().then(function (data) {
					createMyDreamVm.profieImgSrc = data;

					// $timeout(function () {
					// 	//upload Dream Image call to upload image
					// 	createMyDreamVm.uploadImageData(createMyDreamVm.profieImgSrc);

					// }, 1500);

				}, function (error) { });
			}
			/**************** take Image From Camera function end**************/
			createMyDreamVm.uploadImageData = function (imageData) {
				var reqParams = {};
				reqParams["mimeType"] = "image/jpg";
				reqParams["documentTitle"] = "createDream";
				reqParams["documentData"] = imageData.split(',')[1];
				utilityService.showSpinner();
				//upload Dream Image call to upload image
				myDreamsServices.uploadDreamImage(reqParams).then(function (data) {
					createMyDreamVm.imageId = data.id.replace('{', '').replace('}', '');
					utilityService.hideSpinner();
					createMyDreamVm.finalCreatDream();
				}, function (error) {
					utilityService.hideSpinner();
					utilityService.showErrorMessage(error.responseMessage);
				});
			}
			/*************** take Image From Gallery function start**************/
			createMyDreamVm.takeImageFromGallery = function () {
				cameraService.getSmallImageFromGallery().then(function (data) {
					createMyDreamVm.profieImgSrc = data;
					// $timeout(function () {
					// 	//upload Dream Image call to upload image
					// 	createMyDreamVm.uploadImageData(createMyDreamVm.profieImgSrc);
					// }, 1500);

				}, function (error) { });
			}
			/**************** take Image From Gallery function end**************/

			//go to add fund view page
			createMyDreamVm.addFundsView = function () {
				getAccountDetailsService.accountOverviewData = "";
				$state.go("menu.accountOverviewMyBalance");
			}
			//go to review dream view page
			createMyDreamVm.reviewDream = function () {
				$state.go('menu.reviewDream');
			}
			//go to add fund view page
			createMyDreamVm.dreamAddFund = function () {
				$state.go('menu.dreamAddFund');
			}

			createMyDreamVm.goalAmount = '';
			createMyDreamVm.dreamName = '';
			//handling enable and disable  - create my dream button
			createMyDreamVm.checkVal = function () {
				if (((createMyDreamVm.goalAmount != "") && (createMyDreamVm.goalAmount != null)) && ((createMyDreamVm.dreamName != "") && (createMyDreamVm.dreamName != undefined))) {
					createMyDreamVm.createDisabled = false;
				}
				else {
					createMyDreamVm.createDisabled = true;
				}
			}
			
			
	
		createMyDreamVm.infoPopup = function($event) {
			utilityService.showSpinner();	
			
			myDreamsServices.savingFor().then(function(data) {
				createMyDreamVm.infoData = data;
				var template = '<ion-popover-view class="dreams-popup-tooltip derams-popup-info roboto-regular line-ht-popup-dreams">' + '<ion-content>' + '<div class="info-container-dreams" ng-bind-html="createMyDreamVm.infoData"></div>' +'</ion-content>' + '</ion-popover-view>';
				$scope.popover = $ionicPopover.fromTemplate(template, {
					scope : $scope
				});
				$scope.popover.show($event);
				utilityService.hideSpinner();
			}, function(error) {
				utilityService.hideSpinner();
				utilityService.showErrorMessage(error.responseMessage);
			});
		}; 


			//back to prev page
			createMyDreamVm.goToHome = function () {
				if(homeScreenService.ishamMenu===true){
					//$state.go("menu.homeScreen");
					$ionicHistory.goBack();
					homeScreenService.ishamMenu=false;
				}
				else{
				$state.go("menu.accountOverviewMyBalance");
			}
			}

			//go to next page
			createMyDreamVm.goToNextPage = function () {
				$state.go('menu.accountOverviewPopup');
			}
			createMyDreamVm.dreamTransDetails = function () {
				$state.go('menu.dreamTransDetails');
			}

			//one time initialization to be done when the controller is loaded
			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			//actions to done everytime the view is shown
			$scope.$on('$ionicView.beforeEnter', function () {
				
			});

			//actions to done everytime the view is hidden
			$scope.$on('$ionicView.afterLeave', function () {
				//any cleanup needs to be done here: executes everytime when page is left
			});
			return this;
		}]);