'use strict';

angularApp.controller('reviewCloseDreamController',
	["$timeout",
		"$state",
		"$location",
		"$scope",
		"$ionicPopup",
		"$stateParams",
		"myDreamsServices",
		"utilityService",
		"getAccountDetailsService",

		function ($timeout,
			$state,
			$location,
			$scope,
			$ionicPopup,
			$stateParams,
			myDreamsServices, utilityService, getAccountDetailsService) {

			//functions, variables that can be accessed from the HTML come here
			var reviewCloseDreamVm = this;
			//private methods section start
			function initPage() {
				reviewCloseDreamVm.showBack = true;
				reviewCloseDreamVm.showNext = true;
				reviewCloseDreamVm.dreamIdObj = $stateParams.dreamIdObj;
				reviewCloseDreamVm.rdAccountNumber = $stateParams.rdAccountNumber;
				reviewCloseDreamVm.reviewDreamsObj = $stateParams.reviewDreamsObj;
				reviewCloseDreamVm.imgId = $stateParams.imgId;
				reviewCloseDreamVm.effectiveInterestEarnedInfoData();
			}
			//close review dream popup function
			reviewCloseDreamVm.confirmClosePopup = function () {
				var confirmPopup = $ionicPopup.confirm({
					title: '',
					templateUrl: 'pages/accountOverview/myDeposits/myDreams/dreamDetails/confirmClosePopup.html',
					cssClass: 'dialog',
					scope: $scope,
					buttons: [
						{
							text: 'OK',
							onTap: function (e) {
								confirmPopup.close();
								getAccountDetailsService.accountOverviewData = "";
								$state.go("menu.accountOverviewMyBalance");
							}
						}
					]
				});
			}

			//define reviewDreamCloseDetails function to get review dream details
			reviewCloseDreamVm.closeDreamsCall = function () {
				var reqParams = {};
				reqParams["dreamID"] = reviewCloseDreamVm.dreamIdObj;
				reqParams["termsNcondition"] = reviewCloseDreamVm.checkTerms;
				$state.go('menu.closeDepositOTP',{depositObject: {depositType: 'myDreamClosure',closureParams: reqParams, dreamType:'closeDream', isFunded: 'y',closeFundedDreamObj: reviewCloseDreamVm.reviewDreamsObj}});
				/*utilityService.showSpinner();
				myDreamsServices.closeDreams(reqParams).then(function (data) {
				reviewCloseDreamVm.nightMode = data.nightMode == "Y" ? true : false;
					if(reviewCloseDreamVm.nightMode){
						reviewCloseDreamVm.storeRefNumber = data.storeRefNumber;
					}else{
						reviewCloseDreamVm.status = data.closureDetails.status;
					}
					reviewCloseDreamVm.confirmClosePopup();
					utilityService.hideSpinner();
				},
				function (error) {
					utilityService.hideSpinner();
					utilityService.showErrorMessage(error.responseMessage);
				});*/
			}

			//this function is define to call terms and conditions service
			reviewCloseDreamVm.getTermsAndConditionsFun = function () {
				utilityService.showSpinner();
				myDreamsServices.getTermsAndConditions().then(function (data) {
					reviewCloseDreamVm.termsConditions = data.termsConditions;
					utilityService.hideSpinner();
					$state.go('menu.dreamTerms', { termsObj: reviewCloseDreamVm.termsConditions });
				},
				function (error) {
					utilityService.hideSpinner();
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			reviewCloseDreamVm.effectiveInterestEarnedInfoData = function () {
				utilityService.showSpinner();
				myDreamsServices.effectiveInterestEarnedInfo().then(function (data) {
					reviewCloseDreamVm.effectiveInterestRate = data.infoList.effectiveInterestRate;
					utilityService.hideSpinner();
				},
				function (error) {
					reviewCloseDreamVm.effectiveInterestRate = "Please try again";
					utilityService.hideSpinner();
				});
			}


			reviewCloseDreamVm.effectiveInterestEarnedInfo = function () {
				if (reviewCloseDreamVm.effectiveInterestRate === "Please try again") { reviewCloseDreamVm.effectiveInterestEarnedInfoData(); }
				var userInfoPopUp = $ionicPopup.show({
					template: reviewCloseDreamVm.effectiveInterestRate,
					title: '',
					cssClass: 'dialog',
					scope: $scope,
					buttons: [{
						text: 'OK',
						type: 'button-positive'
					}]
				});
			}

			//go to my dreams trip page
			reviewCloseDreamVm.myDreamsTrip = function () {
				$state.go('menu.myDreamsTrip');
			}

			//go to terms and conditions page
			reviewCloseDreamVm.openTC = function () {
				reviewCloseDreamVm.getTermsAndConditionsFun();
			}

			//private methods section end

			//public functions start

			//public functions end

			//back to prev page
			reviewCloseDreamVm.goBacktoPrevious = function () {
				//To do
			}

			//go to next page
			reviewCloseDreamVm.goToNextPage = function () {
				$state.go('menu.accountOverviewPopup');
			}

			//one time initialization to be done when the controller is loaded
			$scope.$on('$ionicView.loaded', function () {

				initPage();
			});

			//actions to done everytime the view is shown
			$scope.$on('$ionicView.beforeEnter', function () {

			});

			//actions to done everytime the view is hidden
			$scope.$on('$ionicView.afterLeave', function () {

				//any cleanup needs to be done here: executes everytime when page is left
			});
			
			return this;
		}]);
