'use strict';

angularApp.controller('myDreamsController',
	["$timeout",
		"$state",
		"$location",
		"$scope",
		"$ionicPopup",
		"$stateParams",
		"myDreamsServices",
		"$rootScope",
		"utilityService",
		"personalLoanService",
		"fixedDepositService",
		"getAccountDetailsService",
		function ($timeout,
			$state,
			$location,
			$scope,
			$ionicPopup,
			$stateParams,
			myDreamsServices,
			$rootScope,
			utilityService,
			personalLoanService,
			fixedDepositService,
			getAccountDetailsService) {

			/*** initialize initial values **/
			var myDreamsVm = this;
			myDreamsVm.isAccountMasked = false;
			myDreamsVm.isTransactionAvailable = false;

			function initPage() {
				/** Data is missing  **/
				myDreamsVm.showBack = true;
				myDreamsVm.showNext = true;

				myDreamsVm.dreamsObj = myDreamsServices.dreamsObj.dreamsObj;
				myDreamsVm.getDreamInfoCall();

				if (fixedDepositService.customer.preApprovedLoanAmount !== undefined && fixedDepositService.customer.preApprovedLoanAmount !== null && fixedDepositService.customer.preApprovedLoanAmount !== "") {
					myDreamsVm.preApprovedLoanAmount = parseInt(fixedDepositService.customer.preApprovedLoanAmount);
					if (myDreamsVm.preApprovedLoanAmount <= 0) {
						myDreamsVm.preaprovedLoanAmount = '';
					}
				}
				else {
					myDreamsVm.preaprovedLoanAmount = '';
				}
			}

			//to store response data from getDreamInfo service
			myDreamsVm.getDreamInfoCall = function () {

				//Get dreams details from adapter
				var reqParams = {};
				myDreamsVm.dreamId = myDreamsServices.dreamsObj.dreamsObj.dreamId;

				reqParams["dreamID"] = myDreamsVm.dreamId;
				utilityService.showSpinner();
				myDreamsServices.getDreaminfo(reqParams).then(function (data) {
					myDreamsVm.dreamDetails = data.dreamDetails;
					utilityService.hideSpinner();
				}, function (error) {
					utilityService.hideSpinner();
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			myDreamsVm.applyForLoan = function () {
				if (myDreamsVm.confirmPopup) {
					myDreamsVm.confirmPopup.close();
				}
				personalLoanService.clearAll();
				personalLoanService.getLoanDetails().then(function (data) {

					personalLoanService.personalLoanData = data;
					personalLoanService.minDuration = data.minTenure;
					personalLoanService.maxDuration = data.maxTenure;
					personalLoanService.interestRate = data.interestRate;
					personalLoanService.product = data.productCode;
					personalLoanService.maxEmiLimit = data.maxPermissibleEMI;
					personalLoanService.processingFee = data.processingFee;
					personalLoanService.minBestOffer = data.minPalAmount;
					personalLoanService.activityCode = data.activityCode;
					personalLoanService.schemeCode = data.schemeCode;


					$state.go('menu.personalLoan');

				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});

			}

			//alert popup for close dream
			myDreamsVm.dreamCloseAlert = function () {
				if (myDreamsVm.isTransactionAvailable) {
					myDreamsVm.confirmPopup = $ionicPopup.confirm({
						title: '',
						template: '<p class="font-size-20">Are you sure you want to close dream for {{myDreamsVm.dreamsObj.label}}?</p><p class="font-size-16" ng-if="myDreamsVm.preApprovedLoanAmount"><a href="Javascript:void()" ng-click="myDreamsVm.applyForLoan()">Click here</a> to avail a pre-approved personal loan instead of closing this dream.</p>',
						cssClass: 'dialog',
						scope: $scope,
						buttons: [
							{
								text: 'Cancel',
								onTap: function (e) {
									myDreamsVm.confirmPopup.close();
								}
							},
							{
								text: 'OK',
								onTap: function (e) {
									reviewDreamCloseDetails();
									myDreamsVm.confirmPopup.close();
								}
							}
						]
					});
				}
			}

			//define viewTransationDetails function to get transactions details
			myDreamsVm.viewTransationDetails = function () {
				if (myDreamsVm.isTransactionAvailable) {
					var reqParams = {};
					myDreamsServices.dreamId = myDreamsVm.dreamsObj.dreamId;
					reqParams["dreamID"] = myDreamsServices.dreamId;
					utilityService.showSpinner();
					myDreamsServices.getMyDreamTransactions(reqParams).then(
						function (data) {
							myDreamsVm.transactionDetails = data.transactionDetails;
							$state.go('menu.viewTransactions', {
								dreamsObj: myDreamsVm.dreamsObj,
								transDetObj: myDreamsVm.transactionDetails,
								dreamDetailsObj: myDreamsVm.dreamDetails
							});
							utilityService.hideSpinner();
						}, function (error) {
							utilityService.hideSpinner();
							utilityService.showErrorMessage(error.responseMessage);
						}
					);
				}
			}

			//alert popup for close unfunded dream
			myDreamsVm.closeUnfundedDreamAlert = function () {
				myDreamsVm.confirmPopup = $ionicPopup.confirm({
					title: '',
					template: '<p class="font-size-20">Are you sure you want to delete \n dream for \'{{myDreamsVm.dreamsObj.label}}\'?</p>',
					cssClass: 'dialog',
					scope: $scope,
					buttons: [
						{
							text: 'Cancel',
							onTap: function (e) {
								myDreamsVm.confirmPopup.close();
							}
						},
						{
							text: 'Ok',
							onTap: function (e) {
								myDreamsVm.closeUnfundedDream();
								myDreamsVm.confirmPopup.close();
							}
						}
					]
				});
			}

			myDreamsVm.closeUnfundedDream = function (dreamName) {
				var reqParams = {};
				reqParams["dreamID"] = myDreamsVm.dreamsObj.dreamId;
				reqParams["fundStatus"] = myDreamsVm.dreamsObj.fundStatus;
				reqParams["imgId"] = myDreamsVm.dreamsObj.imgId;

				$state.go('menu.closeDepositOTP',{depositObject: {depositType: 'myDreamClosure',closureParams: reqParams, dreamType:'closeDream',dreamName:myDreamsVm.dreamsObj.label, isFunded: 'n'}});
				/*myDreamsServices.closeUnfundedDream(reqParams).then(function (data) {
					myDreamsVm.confirmPopup = $ionicPopup.confirm({
						title: '',
						template: '<p class="font-size-20">You have successfully deleted your \n dream for \'{{myDreamsVm.dreamsObj.label}}\'</p>',
						cssClass: 'dialog',
						scope: $scope,
						buttons: [
							{
								text: 'Ok',
								onTap: function (e) {
									myDreamsVm.confirmPopup.close();
									getAccountDetailsService.accountOverviewData = "";
									$state.go("menu.accountOverviewMyBalance");
								}
							}
						]
					});
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});*/
			}

			//Add funds to my dream
			myDreamsVm.addFunds = function () {
				var currDreamDetails = { "dreamName": myDreamsVm.dreamsObj.label, "goalAmount": myDreamsVm.dreamsObj.totalAmount, "dreamImage": myDreamsVm.dreamsObj.image, "dreamID": myDreamsVm.dreamsObj.dreamID };
				myDreamsServices.addDetails(currDreamDetails);
				$state.go("menu.dreamAddFund");
			}

			//define reviewDreamCloseDetails function to get review dream details
			var reviewDreamCloseDetails = function () {
				var reqParams = {};
				reqParams["dreamID"] = myDreamsVm.dreamsObj.dreamId;
				utilityService.showSpinner();
				myDreamsServices.getDreamDetailsForClosuer(reqParams).then(function (data) {
					myDreamsVm.getReviewDetails = data.getReviewDetails;
					utilityService.hideSpinner();
					$state.go('menu.reviewCloseDream', { dreamIdObj: myDreamsVm.dreamsObj.dreamId, rdAccountNumber: myDreamsVm.dreamsObj.accountNumber, reviewDreamsObj: myDreamsVm.getReviewDetails, imgId: myDreamsVm.dreamsObj.imgId });
				},
					function (error) {
						utilityService.hideSpinner();
						utilityService.showErrorMessage(error.responseMessage);
					});
			}

			//go to view transactions
			myDreamsVm.viewTransationCall = function () {
				myDreamsVm.viewTransationDetails();
			}

			//go to Home page
			myDreamsVm.goToHome = function () {
				$state.go('menu.accountOverviewMyBalance');
			}

			//go to Home page

			myDreamsVm.dreamTransDetails = function () {
				$state.go('menu.dreamTransDetails');
			}

			//one time initialization to be done when the controller is loaded
			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			//actions to done everytime the view is shown
			$scope.$on('$ionicView.beforeEnter', function () {
				myDreamsVm.isTransactionAvailable = myDreamsVm.dreamsObj.fundStatus.toLowerCase() == "created" ? false : true;
			});

			//actions to done everytime the view is hidden
			$scope.$on('$ionicView.afterLeave', function () {
				myDreamsServices.dreamId = myDreamsVm.dreamsObj.dreamId;
				//any cleanup needs to be done here: executes everytime when page is left
			});

			myDreamsVm.eyesOnFun = function(accNo){
				myDreamsVm.isAccountMasked = false;
				myDreamsVm.dreamsObj.accountNumber = myDreamsVm.oldValue;
			}

			
			myDreamsVm.eyesOffFun = function(accNo){
				myDreamsVm.isAccountMasked = true;
				myDreamsVm.oldValue = accNo;
				myDreamsVm.dreamsObj.accountNumber = utilityService.maskData(accNo, "front", 4);
			}


			return this;
		}]);
