'use strict';

angularApp.controller('closeDreamOTPController', ["$timeout", "$state", "$scope", "$translate", "$ionicPopup",
    "loggedInUserService", "fTSetOTPService", "validationService", "utilityService", "$stateParams", "$ionicSideMenuDelegate", "mPinLoginService", "$rootScope", "cryptoService", "constantConfig", "myDreamsService", "fixedDepositClosureService", "getAccountDetailsService", "fixedDepositService", "fdODDetailService", "customerInfoService", "rdService", "rdClosureService", "homeScreenService",
    function ($timeout, $state, $scope, $translate, $ionicPopup, loggedInUserService, fTSetOTPService, validationService, utilityService, $stateParams, $ionicSideMenuDelegate, mPinLoginService, $rootScope, cryptoService, constantConfig, myDreamsService, fixedDepositClosureService, getAccountDetailsService, fixedDepositService, fdODDetailService, customerInfoService, rdService, rdClosureService, homeScreenService) {
        $scope.resendOtpCounter = 0;
        $scope.invalidOtpCounter = 0;
        var closeDreamOTPVm = this;

        closeDreamOTPVm.isValidOtp = true;
        closeDreamOTPVm.isValidOtpLength = true;
        var mpin = $stateParams.mpin;
        $scope.isDisabledOTPbtn = false;

        closeDreamOTPVm.loggedInUserDetails = loggedInUserService.getUserProfileDetails();
        //closeDreamOTPVm.loggedInUserMobNo = closeDreamOTPVm.loggedInUserDetails.mobileNumber;
        closeDreamOTPVm.loggedInUserMobNo = customerInfoService.customer.mobile;
        closeDreamOTPVm.generateOTP = function () {
            var reqParams = {};
            reqParams.otpCode = constantConfig.keysForOTP.closeDream;
            reqParams.ocHash = cryptoService.getSHA512EncryptedData(constantConfig.keysForOTP.closeDream).toString();
            reqParams.mobile = closeDreamOTPVm.loggedInUserMobNo;
            reqParams.email = customerInfoService.customer.emailID;
            reqParams.journeyName = closeDreamOTPVm.depositObject.depositType;
            // console.log("params in genotp",reqParams);
            // console.log("rootscope",$rootScope.mobileNo);
            // if(utilityService.isAndroidPlatform()) {
            //     autoOtpReadService.startOtpReading().then(function (result) {
            //         closeDreamOTPVm.otp = result;
            //     }, function (error) {
            //         console.log(error);
            //     }, function (watchStatus) {
            //         myDreamsService.getOtpSecure(reqParams).then(function (data) {
            //         }, function (error) {
            //             autoOtpReadService.stopOtpReading();
            //             utilityService.showErrorMessage(error.responseMessage);
            //         });
            //     });
            // } else {
                myDreamsService.getOtpSecure(reqParams).then(function (data) {
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            // }
        }
        //Reset OTP text field
        closeDreamOTPVm.resetOtpField = function () {
            closeDreamOTPVm.isValidOtp = true;
        };

        closeDreamOTPVm.onOTPBlur = function () {
            closeDreamOTPVm.isValidOtpLength = validationService.isValidOTP(closeDreamOTPVm.otp);
        };
        //Resend OTP
        closeDreamOTPVm.resendOTP = function () {
            $scope.invalidOtpCounter = 0;
            if ($scope.isDisabledOTPbtn) {
                return true
            }
            closeDreamOTPVm.otp = null;
            closeDreamOTPVm.isValidOtp = true;
            var reqParams = {};
            reqParams.otpCode = constantConfig.keysForOTP.closeDream;
            reqParams.mobile = closeDreamOTPVm.loggedInUserMobNo;
            reqParams.email = customerInfoService.customer.emailID;
            reqParams.journeyName = closeDreamOTPVm.depositObject.depositType;
            reqParams.ocHash = cryptoService.getSHA512EncryptedData(constantConfig.keysForOTP.closeDream).toString();
            // if(utilityService.isAndroidPlatform()) {
            //     autoOtpReadService.startOtpReading().then(function (result) {
            //         closeDreamOTPVm.otp = result;
            //         // closeDreamOTPVm.mpinSetStatus();
            //     }, function (error) {
            //         console.log(error);
            //     }, function (watchStatus) {
            //         myDreamsService.getOtpSecure(reqParams).then(function (data) {
            //             $scope.resendOtpCounter += 1;
            //             if($scope.resendOtpCounter === 2){
            //                 $scope.isDisabledOTPbtn = true;
            //             }
            //         }, function (error) {
            //             autoOtpReadService.stopOtpReading();
            //             utilityService.showErrorMessage(error.responseMessage);
            //         });
            //     });
            // } else {
                myDreamsService.getOtpSecure(reqParams).then(function (data) {
                    $scope.resendOtpCounter += 1;
                    if($scope.resendOtpCounter === 2){
                        $scope.isDisabledOTPbtn = true;
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            // }
        };
        closeDreamOTPVm.validateDreamOTP = function () {
        	closeDreamOTPVm.shortDisableNext = "Y";
            var reqParams = {};
            reqParams["otp"] = closeDreamOTPVm.otp;
            reqParams.mobile = closeDreamOTPVm.loggedInUserMobNo;
            reqParams.data = {};
            reqParams.journeyName = closeDreamOTPVm.depositObject.depositType;
            myDreamsService.validateOtp(reqParams).then(function (data) {
                if (data.status.toLowerCase() === 'success') {
                	closeDreamOTPVm.shortDisableNext = "";
                    var closureParams = closeDreamOTPVm.depositObject.closureParams;

                    /* Close dream after validating OTP */
                    if(closeDreamOTPVm.depositObject.depositType === 'myDreamClosure') {
                        myDreamsService.updateDreamStatus(closureParams).then(function (data) {
                            if(closeDreamOTPVm.depositObject.dreamType === 'closeDream'){
                                $state.go('menu.closeDreamSuccess');
                            }
                            else {
                                // getAccountDetailsService.tabIndex.tabIndex = 1;
                                // $state.go('menu.accountOverviewMyBalance');
                                // homeScreenService.ishamburgerMenuRO=false;
                                homeScreenService.isDepositsFlag = true;
                                getAccountDetailsService.tabIndex.tabIndex = 1;
                                $state.go('menu.accountOverviewMyBalance');
                            }
                        }, function (error) {
                            utilityService.hideSpinner();
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    }
                    else if(closeDreamOTPVm.depositObject.depositType === 'fdClosure'){
                        console.log("entered closure function");
                        $scope.fdParams = closeDreamOTPVm.depositObject.fdParams;
                        // $scope.isMod = closeDreamOTPVm.depositObject.fdParams.isMod;
                        fixedDepositClosureService.sendFDClosure(closureParams).then(function (data) {
                            console.log("in success fd closure");
                            $scope.storeRefNumber = utilityService.getValue(data.storeRefNumber);
                            if (data) {
                                var title = '';
                                var template = '';
                                var onTap = '';
                                if (!(data.nightMode == "Y" ? true : false)) {
                                    getAccountDetailsService.accountOverviewData = "";
                                    template = '<center><img src="img/mf/bg-approved.svg" height="45" width="45" alt="Success Screen"><div class="button_fund_closure RFDpopup fontSize-heading roboto-regular font-dark-grey" translate="CONGRATSNEW"></div><div class="button_fund_closure fontSize-subHeading roboto-light font-dark-grey" translate="FDCLOSEMESSAGE" translate-values="{FDnumber:fdParams.maskedAccNumber}"></div><div class="button_fund_closure closePopup fontSize-subHeading roboto-light font-dark-grey" translate="CLOSE_FD_POPUP" translate-values="{maturityAmount:fdParams.amountCredited, creditAc:fdParams.maskedselectedAccountNumber}"></div></center>';
                                    onTap = 'menu.accountOverviewMyBalance';
                                    fixedDepositService.showAlertModal(title, template, onTap, $scope, $state);
                                } else {
                                    getAccountDetailsService.accountOverviewData = "";
                                    template = '<center><img src="img/mf/bg-approved.svg" height="45" width="45" alt="Success Screen"><div class="button_fund_closure fontSize-subHeading roboto-light font-dark-grey" translate="NM_CLOSEFD" translate-values="{fdParams:storeRefNumber}"></div><div class="button_fund_closure closePopup fontSize-subHeading roboto-light font-dark-grey" translate="NM_INFO1"></div><div class="button_fund_closure closePopup fontSize-subHeading roboto-light font-dark-grey" translate="NM_INFO2"></div></center>';
                                    onTap = 'menu.accountOverviewMyBalance';
                                    fixedDepositService.showAlertModal(title, template, onTap, $scope, $state);
                                }
                            }
                        }, function (error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    }
                    else if(closeDreamOTPVm.depositObject.depositType === 'odAgainstFD') {
                        var overdraftVm = closeDreamOTPVm.depositObject.overdraftVm;
                        fdODDetailService.fetchODDetails(overdraftVm,overdraftVm.overdraft).then(function(data){
                            var title ='';
                            var template='';
                            var onTap='';
                            overdraftVm.isChecked = false;
                            if(!(data.nightMode == "Y" ? true : false)){
                                if(data.response === "Success"){
                                    closeDreamOTPVm.refNo = utilityService.getValue(data.refNo);
                                    getAccountDetailsService.accountOverviewData = "";
                                    title =null;
                                    template = '<div class="congratsOD"><img src="img/happyface.svg" width="45" height="45" class="happyFaceOD"></div><div class="congratsOD fontSize-heading roboto-regular font-dark-grey">{{overdraftVm.congratulations}}</div><div class="button_fund_closure fontSize-subHeading roboto-light font-dark-grey" translate="OD_CREATE_REQ"></div><div class="button_fund_closure fontSize-subHeading roboto-light font-dark-grey" translate="OD_PROCESS"></div><div class="button_fund_closure fontSize-subHeading roboto-light font-dark-grey" translate="OD_REFNO" translate-values="{refNumber:refNo}"></div>';
                                    onTap = 'menu.accountOverviewMyBalance';
                                    fixedDepositService.showAlertModal(title,template,onTap,$scope,$state);
                                } else {
                                    overdraftVm.disableconfirm = true;
                                    var errorMessage = "Can not process now, Please try after sometime.";
                                    utilityService.showErrorMessage(errorMessage);
                                }
                            } else {
                                $scope.storeRefNumber = utilityService.getValue(data.storeRefNumber);
                                getAccountDetailsService.accountOverviewData = "";
                                title =null;
                                template = '<div class="congratsOD"><img src="img/happyface.svg" width="45" height="45" class="happyFaceOD"></div><div class="congratsOD fontSize-heading roboto-regular font-dark-grey">{{overdraftVm.congratulations}}</div><div class="button_fund_closure fontSize-subHeading roboto-light font-dark-grey" translate="NM_ODCREQUEST" translate-values="{requestNumberOD:storeRefNumber}"></div><div class="button_fund_closure fontSize-subHeading roboto-light font-dark-grey" translate="NM_INFO1"></div><div class="button_fund_closure fontSize-subHeading roboto-light font-dark-grey" translate="NM_INFO2"></div>';
                                onTap = 'menu.accountOverviewMyBalance';
                                fixedDepositService.showAlertModal(title,template,onTap,$scope,$state);
                            }
                        }, function(error){
                            overdraftVm.isChecked = false;
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    }
                    else if(closeDreamOTPVm.depositObject.depositType === 'rdClosure'){
                        $scope.rdDetailsVm = closeDreamOTPVm.depositObject.rdDetailsVm;
                        var params = closeDreamOTPVm.depositObject.rdParams;
                        $scope.maskedRDAcc = closeDepositOTPVm.depositObject.maskedRDAcc;
                        $scope.maskedSelectedAcc = utilityService.maskData($scope.rdDetailsVm.selectedAccountNumber, "front", 4);
                        rdClosureService.RDClosureNriValidation(params).then(function (data) {
                            if(data.messageCode == "01"){
                                $scope.rdDetailsVm.cancelPopupName = $ionicPopup.show({
                                    title: "",
                                    cssClass: 'my-custom-popup',
                                    template: data.message,
                                    scope: $scope,
                                    buttons: [
                                        {
                                            text: 'OK',
                                            type: 'button-assertive',
                                            onTap: function () {
                                                $scope.rdDetailsVm.cancelPopupName.close();
                                                var obj = {
                                                    "fromAccount": "",
                                                    "toAccount": $scope.rdDetailsVm.selectedAccountNumber,
                                                    "payableAmount": rdService.viewRdData.amountCredit,
                                                };
                                                rdClosureService.sendRDClosure(obj).then(function(response) {
                                                    $scope.rdDetailsVm.storeRefNumber = response.storeRefNumber;
                                                    if(response) {
                                                        var title = '';
                                                        var template='';
                                                        var onTap ='';
                                                        getAccountDetailsService.accountOverviewData="";
                                                        if (response.nightMode) {
                                                            if (response.nightMode == "Y") {
                                                                template = '<div class ="congratsOD"><img src="img/check.png" height="45" width="45" class="happyFaceOD"></div><div class="button_fund_closure RFDpopup fontSize-heading roboto-regular font-dark-grey">Your request number '+$scope.rdDetailsVm.storeRefNumber+' for closing Recurring Deposit has been received.</div><div class="FDpopup-margin fontSize-subHeading roboto-light font-dark-grey">You will be notified once the request is processed.</div><div class="FDpopup-styling fontSize-subHeading roboto-light font-dark-grey">You can check the status of the request from the menu under service request.</div>';
                                                            } else {
                                                                template = '<div class="button_fund_closure fontSize-subHeading roboto-light font-dark-grey" translate="RDCLOSEMESSAGE" translate-values="{FDnumber:maskedRDAcc}"></div><div class="button_fund_closure closePopup fontSize-subHeading roboto-light font-dark-grey" translate="CLOSE_RD_POPUP" translate-values="{maturityAmount:rdDetailsVm.amountCredit, creditAc:maskedSelectedAcc}"></div>';
                                                            }
                                                        } else {
                                                            template = '<div class="button_fund_closure fontSize-subHeading roboto-light font-dark-grey" translate="RDCLOSEMESSAGE" translate-values="{FDnumber:maskedRDAcc}"></div><div class="button_fund_closure closePopup fontSize-subHeading roboto-light font-dark-grey" translate="CLOSE_RD_POPUP" translate-values="{maturityAmount:rdDetailsVm.amountCredit, creditAc:maskedSelectedAcc}"></div>';
                                                        }
                                                        onTap = 'menu.accountOverviewMyBalance';
                                                        utilityService.setCsatJournies('rdClose');
                                                        rdService.showAlertModal(title,template,onTap,$scope,$state);
                                                    }
                                                }, function(error){
                                                    utilityService.showErrorMessage(error.responseMessage);
                                                });
                                            }
                                        },
                                        {
                                            text: 'Cancel',
                                            type: 'button-assertive',
                                            onTap: function () {
                                                $scope.rdDetailsVm.cancelPopupName.close();
                                            }
                                        }
                                    ],
                                });

                            }
                            else{
                                var obj = {
                                    "fromAccount": "",
                                    "toAccount": $scope.rdDetailsVm.selectedAccountNumber,
                                    "payableAmount": rdService.viewRdData.amountCredit,
                                }
                                rdClosureService.sendRDClosure(obj).then(function(response) {
                                    $scope.rdDetailsVm.storeRefNumber = response.storeRefNumber;
                                    if(response) {
                                        var title = '';
                                        var template='';
                                        var onTap ='';
                                        getAccountDetailsService.accountOverviewData="";
                                        if (response.nightMode) {
                                            if (response.nightMode == "Y") {
                                                template = '<div class ="congratsOD"><img src="img/check.png" height="45" width="45" class="happyFaceOD"></div><div class="button_fund_closure RFDpopup fontSize-heading roboto-regular font-dark-grey">Your request number '+$scope.rdDetailsVm.storeRefNumber+' for closing Recurring Deposit has been received.</div><div class="FDpopup-margin fontSize-subHeading roboto-light font-dark-grey">You will be notified once the request is processed.</div><div class="FDpopup-styling fontSize-subHeading roboto-light font-dark-grey">You can check the status of the request from the menu under service request.</div>';
                                            } else {
                                                template = '<div class="button_fund_closure fontSize-subHeading roboto-light font-dark-grey" translate="RDCLOSEMESSAGE" translate-values="{FDnumber:maskedRDAcc}"></div><div class="button_fund_closure closePopup fontSize-subHeading roboto-light font-dark-grey" translate="CLOSE_RD_POPUP" translate-values="{maturityAmount:rdDetailsVm.amountCredit, creditAc:maskedSelectedAcc}"></div>';
                                            }
                                        } else {
                                            template = '<div class="button_fund_closure fontSize-subHeading roboto-light font-dark-grey" translate="RDCLOSEMESSAGE" translate-values="{FDnumber:maskedRDAcc}"></div><div class="button_fund_closure closePopup fontSize-subHeading roboto-light font-dark-grey" translate="CLOSE_RD_POPUP" translate-values="{maturityAmount:rdDetailsVm.amountCredit, creditAc:maskedSelectedAcc}"></div>';
                                        }
                                        onTap = 'menu.accountOverviewMyBalance';
                                        utilityService.setCsatJournies('rdClose');
                                        rdService.showAlertModal(title,template,onTap,$scope,$state);
                                    }
                                }, function(error){
                                    utilityService.showErrorMessage(error.responseMessage);
                                });

                                // service call after NRI check END

                            }

                        }, function (error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    }
                } else {
                    closeDreamOTPVm.isValidOtp = false;
                }
            }, function (error) {
            	closeDreamOTPVm.shortDisableNext = "";
                $scope.invalidOtpCounter += 1;
                if($scope.invalidOtpCounter === 3){
                    closeDreamOTPVm.popup = $ionicPopup.show({
                        template: 'You have exceeded number of attempts. Please login again.',
                        title: '',
                        cssClass: 'dialog',
                        scope: $scope,
                        buttons: [{
                            text: 'OK',
                            type: 'button-positive',
                            onTap: function () {
                                loggedInUserService.logoutUser();
                            }
                        }]
                    });
                }
                else {
                    utilityService.showErrorMessage(error.responseMessage);
                }
            });
        };

        function initPage() {
            console.log("$stateParams.depositObject: ",JSON.stringify($stateParams.depositObject));
            closeDreamOTPVm.depositObject = $stateParams.depositObject;
        }
        closeDreamOTPVm.closeView = function () {
            $state.go('menu.accountOverviewMyBalance');
        }
        $scope.$on('$ionicView.loaded', function () {
            $ionicSideMenuDelegate.canDragContent(false);
            initPage();
        });
        $scope.$on('$ionicView.beforeEnter', function () {
            $ionicSideMenuDelegate.canDragContent(false);
            $scope.isDisabledOTPbtn = false;
            closeDreamOTPVm.generateOTP();
        });
        $scope.$on('$ionicView.afterLeave', function () {
            $ionicSideMenuDelegate.canDragContent(false);
        });

    }]);
