'use strict';

angularApp.controller('closeDreamReviewController', ["$state",
    "$rootScope",
    "utilityService",
    "constantConfig",
    "$ionicPlatform",
    "$scope",
    "$interval",
    "$filter",
    "myDreamsService",
    "$timeout",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "homeScreenService",
    "fixedDepositService",
    "$ionicPopup",

    function ($state,
        $rootScope,
        utilityService,
        constantConfig,
        $ionicPlatform,
        $scope,
        $interval,
        $filter,
        myDreamsService,
        $timeout,
        $ionicScrollDelegate,
        getAccountDetailsService,
        homeScreenService,
        fixedDepositService,
        $ionicPopup) {

        var closeDreamReviewVm = this;

        // linkDreamReviewVm.closeView = function () {
        //     $state.go('menu.accountOverviewMyBalance');
        // }

        closeDreamReviewVm.goBack = function () {
            $state.go('menu.selectedDream');
        }

        closeDreamReviewVm.getCBValue = function(checkedValue){
            closeDreamReviewVm.tncChecked = checkedValue;
        }


 closeDreamReviewVm.closeCancelPopup = function () {
            closeDreamReviewVm.myDreamClosePopup.close();
        }
        closeDreamReviewVm.closePopup = function () {
               if(!closeDreamReviewVm.isChecked){
                closeDreamReviewVm.tncChecked = false;
                return true;
            }
             closeDreamReviewVm.myDreamClosePopup = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter custOpacity',
                templateUrl: 'pages/accountOverview/myDreams/closeDreamConfirmPopup.html',
                scope: $scope
            });

        }

           closeDreamReviewVm.closeConfirmPopup = function () {
            closeDreamReviewVm.myDreamClosePopup.close();
            var reqParams = {
                "dreamId": myDreamsService.selectedDreamDetails.dreamId,
                "status": "CLOSED"
            };
             $state.go('menu.closeDreamOTP',{depositObject: {depositType: 'myDreamClosure',closureParams: reqParams, dreamType:'closeDream'}});
        }


          closeDreamReviewVm.showTnC = function (tncData) {
            var alertPopup = $ionicPopup.alert({
                title: "Terms and Conditions",
                template: '<div class="popupTextBottomPadding ss-p-r-f-8 ss-popup-list font-size-12 font-light ss-text-color md-color">'
                + tncData + '</div></div>',
                cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite ss-popup ODtncPopup',
                buttons: [
                    {
                        text: "OK",
                        onTap: function (e) { }
                    }
                ],
            });
        }

        closeDreamReviewVm.termcondition = function () {
            if (!myDreamsService.myDreamTnC) {
                var obj = {
                    "type": "getMyDreamsTnC"
                }
                myDreamsService.fetchTermsAndCondition(obj).then(function (data) {
                    if (!utilityService.isUndefined(data)) {
                        myDreamsService.myDreamTnC = data;
                        closeDreamReviewVm.showTnC(myDreamsService.myDreamTnC);
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else {
                closeDreamReviewVm.showTnC(myDreamsService.myDreamTnC);
            }
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            closeDreamReviewVm.tncChecked = true;
            closeDreamReviewVm.dreamDetails = {};
            closeDreamReviewVm.dreamDetails = angular.copy(myDreamsService.selectedDreamDetails);
            closeDreamReviewVm.DreamName = closeDreamReviewVm.dreamDetails.dreamName;
            closeDreamReviewVm.closureDate = closeDreamReviewVm.dreamDetails.endDate;
            closeDreamReviewVm.totalInvestmentAmt = 0;
            closeDreamReviewVm.dateOfClosure = new Date();

            for(var i = 0; i < closeDreamReviewVm.dreamDetails.fixedDeposits.length; i++){
                closeDreamReviewVm.totalInvestmentAmt += Number(closeDreamReviewVm.dreamDetails.fixedDeposits[i].amount);
            }
            for(var i = 0; i < closeDreamReviewVm.dreamDetails.recurringDeposits.length; i++){
                closeDreamReviewVm.totalInvestmentAmt += Number(closeDreamReviewVm.dreamDetails.recurringDeposits[i].amount);
            }
            for(var i = 0; i < closeDreamReviewVm.dreamDetails.mutualFunds.length; i++){
                closeDreamReviewVm.totalInvestmentAmt += Number(closeDreamReviewVm.dreamDetails.mutualFunds[i].amount);
            }
        });

    }
]);
