'use strict';

angularApp.controller('closeDreamSuccessController', ["$state",
    "$rootScope",
    "utilityService",
    "constantConfig",
    "$ionicPlatform",
    "$scope",
    "$interval",
    "$filter",
    "myDreamsService",
    "$timeout",

    function ($state,
        $rootScope,
        utilityService,
        constantConfig,
        $ionicPlatform,
        $scope,
        $interval,
        $filter,
        myDreamsService,
        $timeout) {

        var closeDreamSuccessVm = this;

        closeDreamSuccessVm.close = function(){
            $state.go('menu.accountOverviewMyBalance');
        }

        closeDreamSuccessVm.goToMyDreams = function () {
            $state.go('menu.accountOverviewMyBalance');
        }

        closeDreamSuccessVm.archiveDream = function () {
            var reqParams = {
                "dreamId": myDreamsService.selectedDreamDetails.dreamId,
                "status": "ARCHIVED"
            };
            myDreamsService.updateDreamStatus(reqParams).then(function (data) {
                utilityService.showBhimUpiAlert("success", "Dream has been archived successfully.", "menu.accountOverviewMyBalance");
            }, function (error) {
                utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            closeDreamSuccessVm.selectedDreamDetails = myDreamsService.selectedDreamDetails
        });

        return this;
    }

]);

