'use strict';

angularApp.controller('createNewDreamController', ["$state",
    "$rootScope",
    "utilityService",
    "constantConfig",
    "$ionicPlatform",
    "$scope",
    "$interval",
    "$filter",
    "myDreamsService",
    "homeLoanService",
    "$timeout",
    "$ionicScrollDelegate",
    "$translate",
    "ionicToast",
    "$ionicPopup",

    function ($state,
        $rootScope,
        utilityService,
        constantConfig,
        $ionicPlatform,
        $scope,
        $interval,
        $filter,
        myDreamsService,
        homeLoanService,
        $timeout,
        $ionicScrollDelegate,
        $translate,
        ionicToast,
        $ionicPopup) {

        var createNewDreamVm = this;

        createNewDreamVm.validateFormFields = function () {
            if (!createNewDreamVm.dreamName)
                return false;
            if (!createNewDreamVm.amount || createNewDreamVm.amount <= 0)
                return false;
            if (createNewDreamVm.tenureYears < 1 && createNewDreamVm.tenureMonths < 1)
                return false;
            if (!createNewDreamVm.isChecked)
                return false;
            else
                return true;
        }

        createNewDreamVm.createMyNewDream = function () {
            createNewDreamVm.formSubmitted = true;
            var validationMsg = createNewDreamVm.validateFormFields();
            if (validationMsg == true) {
                var reqParams = {
                    "dreamName": createNewDreamVm.dreamName,
                    "tenureYear": createNewDreamVm.tenureYears,
                    "tenureMonth": createNewDreamVm.tenureMonths,
                    "imageId": createNewDreamVm.imageId || $translate.instant('DREAM_DEFAULT_IMAGE'),
                    "imageType": createNewDreamVm.imageType,
                    "dreamAmount": createNewDreamVm.amount
                };
                myDreamsService.selectedDreamDetails = reqParams;
                myDreamsService.createNewDream(reqParams).then(function (data) {
                    myDreamsService.selectedDreamDetails['dreamId'] = data.dreamId;
                    $state.go('menu.createNewDreamSuccess');
                }, function (error) {
                  
                    utilityService.hideSpinner();
                    utilityService.showBhimUpiAlert("error", error.responseMessage);
                });
            }
        }

        createNewDreamVm.goBack = function () {
            $state.go('menu.accountOverviewMyBalance');
        }

        createNewDreamVm.changeDreamName = function () {
            //createNewDreamVm.selectedDream = "";
        }

        createNewDreamVm.selectDefaultDream = function (defaultDream) {
            createNewDreamVm.selectedDream = defaultDream;
            if (defaultDream.categoryName !== 'Add New') {
                createNewDreamVm.selectedDreamImage = defaultDream.mobileImage;
                createNewDreamVm.dreamName = defaultDream.categoryName;
                createNewDreamVm.imageId = defaultDream.mobileImage;
                createNewDreamVm.imageType = 'wcm';
            } else {
                createNewDreamVm.selectedDreamImage = $translate.instant('DREAM_DEFAULT_IMAGE');
                createNewDreamVm.dreamName = '';
                createNewDreamVm.imageId = '';
                createNewDreamVm.imageType = 'default';
            }
        }

        createNewDreamVm.uploadDreamImage = function () {

            // myDreamsService.getFileForAndroid().then(function (data) {
            //     var sizeInMB = data.length;
            //     var blob = new Blob([data], { type: 'image/jpeg' });
            //     createNewDreamVm.base64Image = data;
            //     var typecheck = data.substring(data.indexOf('/') + 1, data.indexOf(';base64'));
            //     createNewDreamVm.fileExtension = typecheck;
            //     utilityService.hideSpinner();
            //     if (typecheck == "jpeg" || typecheck == "jpg" || typecheck == "tiff" || typecheck == "png" || typecheck == "gif") {
            //         if (sizeInMB < 1000000) {
            //             createNewDreamVm.fileData = data.split('base64,')[1];
            //             createNewDreamVm.uploadDreamImageInFilenet(createNewDreamVm.fileData);
            //         } else {
            //             var errMsg = $translate.instant('HL_ERR_FILE_SIZE');
            //             utilityService.showBhimUpiAlert("error", errMsg);
            //         }
            //     } else {
            //         var errMsg = $translate.instant('HL_ERR_FILE_TYPE');
            //         utilityService.showBhimUpiAlert("error", errMsg);
            //     }
            // }, function (error) {
            //     utilityService.hideSpinner();
            // });


            utilityService.showSpinner();
            if (utilityService.isAndroidPlatform()) {
                myDreamsService.getFileForAndroid().then(function (data) {
                    var sizeInMB = data.length;
                    var blob = new Blob([data], { type: 'image/jpeg' });
                    createNewDreamVm.base64Image = data;
                    var typecheck = data.substring(data.indexOf('/') + 1, data.indexOf(';base64'));
                    createNewDreamVm.fileExtension = typecheck;
                    utilityService.hideSpinner();
                    if (typecheck == "jpeg" || typecheck == "jpg" || typecheck == "tiff" || typecheck == "png" || typecheck == "gif") {
                        if (sizeInMB < 1500000) {
                            createNewDreamVm.fileData = data.split('base64,')[1];
                            createNewDreamVm.uploadDreamImageInFilenet(createNewDreamVm.fileData);
                        } else {
                            var errMsg = $translate.instant('HL_ERR_FILE_SIZE');
                            utilityService.showBhimUpiAlert("error", errMsg);
                        }
                    } else {
                        var errMsg = $translate.instant('HL_ERR_FILE_TYPE');
                        utilityService.showBhimUpiAlert("error", errMsg);
                    }
                }, function (error) {
                    utilityService.hideSpinner();
                });
            } else {
                homeLoanService.getDreamImageForIos().then(function (response) {                
                     var data = response;                               
                     createNewDreamVm.fileData = data.split('base64,')[1];
                     var sizes = ['Bytes', 'KB', 'MB', 'GB', 'TB'];
                     var i = parseInt(Math.floor(Math.log(createNewDreamVm.fileData.length) / Math.log(1024)));
                     var fileSize =  (Math.round(createNewDreamVm.fileData.length / Math.pow(1024, i), 2) + ' ' + sizes[i]) ;
                     createNewDreamVm.base64Image = data;
                     var typecheck = data.substring(data.indexOf('/') + 1, data.indexOf(';base64'));
                     createNewDreamVm.fileExtension = typecheck;
                     utilityService.hideSpinner();
                    if (typecheck == "jpeg" || typecheck == "jpg" || typecheck == "tiff" || typecheck == "png" || typecheck == "gif") {                       
                        if (fileSize == "1 MB" || fileSize.includes("KB")) {                          
                            createNewDreamVm.uploadDreamImageInFilenet(createNewDreamVm.fileData);
                        } else {
                           var errMsg = $translate.instant('HL_ERR_FILE_SIZE');
                            utilityService.showBhimUpiAlert("error", errMsg);
                        }

                    } else {
                      var errMsg = $translate.instant('HL_ERR_FILE_TYPE');
                        utilityService.showBhimUpiAlert("error", errMsg);
                    }

                }, function (error) {
                    utilityService.hideSpinner();
                    utilityService.showBhimUpiAlert("error", error);
                });
            }
        }

        createNewDreamVm.uploadDreamImageInFilenet = function (fileData) {
            var reqParams = {
                "mimeType": "image/" + createNewDreamVm.fileExtension,
                "documentTitle": "image",
                "documentData": fileData
            };
            myDreamsService.uploadDreamImage(reqParams).then(function (response) {
                createNewDreamVm.selectedDreamImage = createNewDreamVm.base64Image;
                createNewDreamVm.imageId = response.id;
                createNewDreamVm.imageType = 'filenet';
                ionicToast.show("Image uploaded successfully", "bottom", false, 2000);
            }, function (error) {
                utilityService.showBhimUpiAlert("error", error.responseMessage);
            });
        }

        createNewDreamVm.showTnC = function (tncData) {
            var alertPopup = $ionicPopup.alert({
                title: "Terms and Conditions",
                template: '<div class="popupTextBottomPadding ss-p-r-f-8 ss-popup-list font-size-12 font-light ss-text-color md-color">'
                + tncData + '</div></div>',
                cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite ss-popup ODtncPopup',
                buttons: [
                    {
                        text: "OK",
                        onTap: function (e) { }
                    }
                ],
            });
        }

        createNewDreamVm.termcondition = function () {
            if (!myDreamsService.myDreamTnC) {
                var obj = {
                    "type": "getMyDreamsTnC"
                }
                myDreamsService.fetchTermsAndCondition(obj).then(function (data) {
                    if (!utilityService.isUndefined(data)) {
                        myDreamsService.myDreamTnC = data;
                        createNewDreamVm.showTnC(myDreamsService.myDreamTnC);
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else {
                createNewDreamVm.showTnC(myDreamsService.myDreamTnC);
            }
        }

        $scope.scrollEvent = function () {
            $timeout(function () {
                var sv = $ionicScrollDelegate.$getByHandle("defaultDreams").getScrollView();
                var container = sv.__container;
                var originaltouchStart = sv.touchStart;
                var originaltouchMove = sv.touchMove;
                container.removeEventListener('touchstart', sv.touchStart);
                document.removeEventListener('touchmove', sv.touchMove);
                sv.touchStart = function (e) {
                    e.preventDefault = function () { }
                    originaltouchStart.apply(sv, [
                        e
                    ]);
                }
                sv.touchMove = function (e) {
                    e.preventDefault = function () { }
                    originaltouchMove.apply(sv, [
                        e
                    ]);
                }
                container.addEventListener("touchstart", sv.touchStart, false);
                document.addEventListener("touchmove", sv.touchMove, false);
            });
        }

        createNewDreamVm.getScrollPosition = function () {
            var moveData = $ionicScrollDelegate.$getByHandle('homeScroll').getScrollPosition().top;
            if (moveData > 200) {
                $scope.$apply(function () {
                    createNewDreamVm.sttButton = true;
                });
            } else {
                $scope.$apply(function () {
                    createNewDreamVm.sttButton = false;
                });
            }
        };

        createNewDreamVm.scrollToTop = function () {
            $ionicScrollDelegate.$getByHandle('homeScroll').scrollTop();
            createNewDreamVm.sttButton = false;
        }

        $scope.$on('$ionicView.enter', function () {
            document.getElementsByClassName("createNewDreamClass")[0].scrollBy(0, -500);
        });

        $scope.$on('$ionicView.beforeEnter', function () {
            createNewDreamVm.formSubmitted = false;
            createNewDreamVm.sttButton = false;
            createNewDreamVm.selectedDream = "";
            createNewDreamVm.isChecked = false;
            createNewDreamVm.selectedDreamImage = $translate.instant('DREAM_DEFAULT_IMAGE');
            createNewDreamVm.dreamName = '';
            createNewDreamVm.imageId = '';
            createNewDreamVm.amount = '';
            createNewDreamVm.imageType = 'default';
            createNewDreamVm.defaultDreams = myDreamsService.defaultDreamsData.categoryList;
            createNewDreamVm.tenureYears = myDreamsService.defaultDreamsData.minTenureYear;
            createNewDreamVm.tenureMonths = myDreamsService.defaultDreamsData.minTenureMonth

            createNewDreamVm.yearsSlider = {
                value: Number(createNewDreamVm.tenureYears),
                options: {
                    showSelectionBar: true,
                    floor: Number(myDreamsService.defaultDreamsData.minTenureYear),//min year
                    ceil: Number(myDreamsService.defaultDreamsData.maxTenureYear),//max year
                    step: 1,
                    onChange: function (id, model) {
                        createNewDreamVm.tenureYears = createNewDreamVm.yearsSlider.value;
                    },
                    translate: function (value, id, label) {
                        if (label === 'ceil') {
                            return value + " yrs";
                        } else if (label === 'floor') {
                            return value + " yr";
                        }
                    }
                }
            };

            createNewDreamVm.monthsSlider = {
                value: Number(createNewDreamVm.tenureMonths),
                options: {
                    showSelectionBar: true,
                    floor: Number(myDreamsService.defaultDreamsData.minTenureMonth),//min month
                    ceil: Number(myDreamsService.defaultDreamsData.maxTenureMonth),//max year
                    step: 1,
                    onChange: function (id, model) {
                        createNewDreamVm.tenureMonths = createNewDreamVm.monthsSlider.value;
                    },
                    translate: function (value, id, label) {
                        return value + " m";
                    }
                }
            };
        });

        return this;
    }

]);

