'use strict';

angularApp.controller('editSelectedDreamController', ["$state",
    "$rootScope",
    "utilityService",
    "constantConfig",
    "$ionicPlatform",
    "$scope",
    "$interval",
    "$filter",
    "myDreamsService",
    "$timeout",
    "ionicToast",
    "$translate",
    "homeLoanService",

    function ($state,
        $rootScope,
        utilityService,
        constantConfig,
        $ionicPlatform,
        $scope,
        $interval,
        $filter,
        myDreamsService,
        $timeout,
        ionicToast,
        $translate,
        homeLoanService) {

        var editSelectedDreamVm = this;

        editSelectedDreamVm.closePage = function () {
            $state.go('menu.accountOverviewMyBalance');
        }

        editSelectedDreamVm.uploadDreamImage = function () {
            utilityService.showSpinner();
            if (utilityService.isAndroidPlatform()) {
                myDreamsService.getFileForAndroid().then(function (data) {
                    var sizeInMB = data.length;
                    var blob = new Blob([data], { type: 'image/jpeg' });
                    editSelectedDreamVm.base64Image = data;
                    var typecheck = data.substring(data.indexOf('/') + 1, data.indexOf(';base64'));
                    editSelectedDreamVm.fileExtension = typecheck;
                    utilityService.hideSpinner();
                    if (typecheck == "jpeg" || typecheck == "jpg" || typecheck == "tiff" || typecheck == "png" || typecheck == "gif") {
                        if (sizeInMB < 1500000) {
                            editSelectedDreamVm.fileData = data.split('base64,')[1];
                            editSelectedDreamVm.uploadDreamImageInFilenet(editSelectedDreamVm.fileData);
                        } else {
                            var errMsg = $translate.instant('HL_ERR_FILE_SIZE');
                            utilityService.showBhimUpiAlert("error", errMsg);
                        }
                    } else {
                        var errMsg = $translate.instant('HL_ERR_FILE_TYPE');
                        utilityService.showBhimUpiAlert("error", errMsg);
                    }
                }, function (error) {
                    utilityService.hideSpinner();
                });
            } else {
                homeLoanService.getFileForiOS().then(function (response) {
                    var sizeInMB = response.size;
                    var data = response.imagedata;
                    var blob = new Blob([data], { type: 'image/jpeg' });
                    editSelectedDreamVm.base64Image = data;
                    var typecheck = data.substring(data.indexOf('/') + 1, data.indexOf(';base64'));
                    editSelectedDreamVm.fileExtension = typecheck;;
                    utilityService.hideSpinner();
                    if (typecheck == "jpeg" || typecheck == "jpg" || typecheck == "tiff" || typecheck == "png" || typecheck == "gif") {
                        if (sizeInMB < 1500000) {
                            editSelectedDreamVm.fileData = data.split('base64,')[1];
                            editSelectedDreamVm.uploadDreamImageInFilenet(editSelectedDreamVm.fileData);
                        } else {
                         var errMsg = $translate.instant('HL_ERR_FILE_SIZE');
                         utilityService.showBhimUpiAlert("error", errMsg);
                        }
                    } else {
                        var errMsg = $translate.instant('HL_ERR_FILE_TYPE');
                        utilityService.showBhimUpiAlert("error", errMsg);
                    }
                }, function (error) {
                    utilityService.hideSpinner();
                });
            }
        }

        editSelectedDreamVm.uploadDreamImageInFilenet = function (fileData) {
            var reqParams = {
                "mimeType": "image/" + editSelectedDreamVm.fileExtension,
                "documentTitle": "image",
                "documentData": fileData
            };
            myDreamsService.uploadDreamImage(reqParams).then(function (response) {
                editSelectedDreamVm.selectedDreamImage = editSelectedDreamVm.base64Image;
                editSelectedDreamVm.imageId = response.id;
                editSelectedDreamVm.imageType = 'filenet';
                myDreamsService.selectedDreamDetails.imageType = 'filenet'
                myDreamsService.selectedDreamDetails.imageId = response.id;
                //ionicToast.show("Image uploaded successfully", "bottom", false, 2000);
            }, function (error) {
                utilityService.showBhimUpiAlert("error", error.responseMessage);
            });
        }

        editSelectedDreamVm.deleteDreamImage = function () {
            // if (editSelectedDreamVm.imageType !== "default") {
            //     editSelectedDreamVm.imageId = $translate.instant('DREAM_DEFAULT_IMAGE');
            //     editSelectedDreamVm.imageType = "default";
            //     editSelectedDreamVm.selectedDreamImage = $translate.instant('DREAM_DEFAULT_IMAGE');
            //     myDreamsService.selectedDreamDetails.imageType = 'default'
            // } else {
                editSelectedDreamVm.uploadDreamImage();
            // }
        }

        // editSelectedDreamVm.clearInput = function(){
        //     editSelectedDreamVm.dreamName = "";
        // }

        editSelectedDreamVm.clearName = function(){
            editSelectedDreamVm.dreamName = "";
        }

        editSelectedDreamVm.updateDream = function () {
            if (!editSelectedDreamVm.dreamName) {
                //utilityService.showErrorMessage("Please Enter Dream Name");
                return false;
            }
            var reqParams = {
                "dreamId": myDreamsService.selectedDreamDetails.dreamId,
                "dreamName": editSelectedDreamVm.dreamName,
                "imageId": editSelectedDreamVm.imageId || "",
                "imageType": editSelectedDreamVm.imageType || ""
            }
            myDreamsService.updateDream(reqParams).then(function (data) {
                myDreamsService.selectedDreamDetails["dreamName"] = editSelectedDreamVm.dreamName;
                myDreamsService.dreamImage = "";
                $state.go('menu.selectedDream');
                //utilityService.showBhimUpiAlert("success", "Dream has been updated successfully.", "menu.selectedDream");
            }, function (error) {
                utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            editSelectedDreamVm.selectedDreamDetails = myDreamsService.selectedDreamDetails
            editSelectedDreamVm.imageId = myDreamsService.selectedDreamDetails.imageId;
            editSelectedDreamVm.imageType = myDreamsService.selectedDreamDetails.imageType;
            editSelectedDreamVm.dreamName = editSelectedDreamVm.selectedDreamDetails.dreamName;
            editSelectedDreamVm.dreamAmount = editSelectedDreamVm.selectedDreamDetails.dreamAmount;
            editSelectedDreamVm.dreamTenureYears = editSelectedDreamVm.selectedDreamDetails.tenureYear;
            editSelectedDreamVm.dreamTenureMonths = editSelectedDreamVm.selectedDreamDetails.tenureMonth;
            editSelectedDreamVm.selectedDreamImage = myDreamsService.dreamImage;
        });

        return this;
    }

]);