'use strict';

angularApp.controller('linkDreamController', ["$state",
    "$rootScope",
    "utilityService",
    "constantConfig",
    "$ionicPlatform",
    "$scope",
    "$interval",
    "$filter",
    "myDreamsService",
    "$timeout",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "homeScreenService",
    "fixedDepositService",
    "$ionicPopup",
    "rdService",

    function ($state,
        $rootScope,
        utilityService,
        constantConfig,
        $ionicPlatform,
        $scope,
        $interval,
        $filter,
        myDreamsService,
        $timeout,
        $ionicScrollDelegate,
        getAccountDetailsService,
        homeScreenService,
        fixedDepositService,
        $ionicPopup,
        rdService) {

        var linkDreamVm = this;

        linkDreamVm.createNewRecurringDeposit = function () {
            linkDreamVm.custResidentialStatus = getAccountDetailsService.accountOverviewData ? getAccountDetailsService.accountOverviewData.customerInformation.residentialStatus : "";
            if (linkDreamVm.custResidentialStatus) {
                rdService.initialValueStage();
                $state.go('menu.createRd');
            }
            else {
                $ionicPopup.show({
                    template: '<p>Please contact your Home Branch for updation of Resident Status.</p>',
                    title: '',
                    cssClass: 'dialog',
                    scope: '',
                    buttons: [{
                        text: 'OK',
                        type: 'button-positive'
                    }]
                });
            }
        };

        linkDreamVm.createNewFixedDeposit = function () {
            homeScreenService.ishamburgerMenuFD = false;
            linkDreamVm.custResidentialStatus = getAccountDetailsService.accountOverviewData ? getAccountDetailsService.accountOverviewData.customerInformation.residentialStatus : "";
            if (linkDreamVm.custResidentialStatus) {
                fixedDepositService.initializeFDvariables();//calling fd service to initialize fd variables
                getAccountDetailsService.tabIndex.tabIndex = 1;
                $state.go('menu.fixedDeposit');
            }
            else {
                $ionicPopup.show({
                    template: '<p>Please contact your Home Branch for updation of Resident Status.</p>',
                    title: '',
                    cssClass: 'dialog',
                    scope: '',
                    buttons: [{
                        text: 'OK',
                        type: 'button-positive'
                    }]
                });
            }
        }

           linkDreamVm.createNewMutualFunds = function () {
               //commented for coming soon popup
            // homeScreenService.ishamburgerMenuMF = false;
            // linkDreamVm.custResidentialStatus = getAccountDetailsService.accountOverviewData ? getAccountDetailsService.accountOverviewData.customerInformation.residentialStatus : "";
            // if (linkDreamVm.custResidentialStatus) {
            //     // fixedDepositService.initializeFDvariables();//calling fd service to initialize fd variables
            //     myDreamsService.thruMyDream = true;
            //     myDreamsService.dreamId = myDreamsService.selectedDreamDetails.dreamId;
            //     getAccountDetailsService.tabIndex.tabIndex = 3;
            //       $state.go('menu.accountOverviewMyBalance');
            // }
            // else {
            //     $ionicPopup.show({
            //         template: '<p>Please contact your Home Branch for updation of Resident Status.</p>',
            //         title: '',
            //         cssClass: 'dialog',
            //         scope: '',
            //         buttons: [{
            //             text: 'OK',
            //             type: 'button-positive'
            //         }]
            //     });
            // }
            //commented for coming soon popup
            utilityService.comingSoon("Coming soon");
        }

        linkDreamVm.linkSelectedAccounts = function () {
            if (linkDreamVm.selectedAccountsArray.length == 0) {
                utilityService.showBhimUpiAlert("alert", "Please select the investment");
                return true;
            }
            myDreamsService.selectedAccountsArray = linkDreamVm.selectedAccountsArray;
            $state.go('menu.linkDreamReview');
        }

        linkDreamVm.linkAccount = function (checked, index, selectedAccount) {
            if (checked) {
                linkDreamVm.mfArray[index] = linkDreamVm.mfArray[index]; 
                linkDreamVm.selectedAccountsArray.push(selectedAccount);
                linkDreamVm.totalSelectedAmount += Number(selectedAccount.amount);
            } else {
                for (var i = 0; i < linkDreamVm.selectedAccountsArray.length; i++) {
                    if (selectedAccount.accountNumber == linkDreamVm.selectedAccountsArray[i].accountNumber) {
                        linkDreamVm.selectedAccountsArray.splice(i, 1);
                    }
                }
                if (selectedAccount.accountType == 'RD') {
                    linkDreamVm.totalSelectedAmount -= Number(linkDreamVm.eligibleAccounts.recurringDeposits[index].amount);
                }
                if (selectedAccount.accountType == 'FD') {
                    linkDreamVm.totalSelectedAmount -= Number(linkDreamVm.eligibleAccounts.fixedDeposits[index].amount);
                }
                if (selectedAccount.accountType == 'MF') {
                    linkDreamVm.totalSelectedAmount -= Number(linkDreamVm.eligibleAccounts.mutualFunds[index].amount);
                }
            }
        }

        linkDreamVm.goBack = function () {
            $state.go('menu.accountOverviewMyBalance');
        }

        linkDreamVm.toggleLoginMenu = function (loginOption) {
            if (loginOption === 'StartNew') {
                linkDreamVm.classForMpinLoginOpt = 'tab-item tabs-style div-bottom bor-bot-active';
                linkDreamVm.classForUserLoginOpt = 'tab-item tabs-style div-bottom';
            }
            if (loginOption === 'LinkExisting') {
                linkDreamVm.classForMpinLoginOpt = 'tab-item tabs-style div-bottom';
                linkDreamVm.classForUserLoginOpt = 'tab-item tabs-style div-bottom bor-bot-active';
            }
        };

        linkDreamVm.selType = function (category) {
            if (category == 'N') {
                linkDreamVm.classForNewOpt = 'tab-item tabs-myDream div-bottom bor-bot-active';
                linkDreamVm.classForExistingOpt = 'tab-item tabs-myDream div-bottom';
                linkDreamVm.newLinkFlag = true;
                linkDreamVm.existingLinkFlag = false;
            }
            if (category == 'E') {
                linkDreamVm.classForNewOpt = 'tab-item tabs-myDream div-bottom';
                linkDreamVm.classForExistingOpt = 'tab-item tabs-myDream div-bottom bor-bot-active';
                linkDreamVm.newLinkFlag = false;
                linkDreamVm.existingLinkFlag = true;
            }
            linkDreamVm.scrollToTop();
        }

        linkDreamVm.toggleGroup = function (group) {
            linkDreamVm.isFolioShown = false;
            if (linkDreamVm.isGroupShown(group)) {
                var id = group.split("_");
                if(id[0] == "Folio"){
                    linkDreamVm.isFolioShown = true;
                }
                linkDreamVm.shownGroup = null;
                linkDreamVm.isGroupShown(group);
            } else {
                var id = group.split("_");
                if(id[0] == "Folio"){
                    linkDreamVm.isFolioShown = true;
                }
                linkDreamVm.shownGroup = group;
                linkDreamVm.isGroupShown(group)
            }
        };

        linkDreamVm.isGroupShown = function (group) {
            return linkDreamVm.shownGroup === group;
        };

        linkDreamVm.startNewInvestment = function(){
            linkDreamVm.selType('N');
        }

        linkDreamVm.getScrollPosition = function () {
            var moveData = $ionicScrollDelegate.$getByHandle('accScroll').getScrollPosition().top;
            if (moveData > 200) {
                $scope.$apply(function () {
                    linkDreamVm.sttButton = true;
                });
            } else {
                $scope.$apply(function () {
                    linkDreamVm.sttButton = false;
                });
            }
        };

        linkDreamVm.scrollToTop = function () {
            $ionicScrollDelegate.$getByHandle('accScroll').scrollTop();
            linkDreamVm.sttButton = false;
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            linkDreamVm.sttButton = false;
            linkDreamVm.shownGroup = null;
            linkDreamVm.selType('N');
            linkDreamVm.totalSelectedAmount = 0;
            linkDreamVm.selectedAccountsArray = [];
            linkDreamVm.selectedDreamDetails = myDreamsService.selectedDreamDetails;
            linkDreamVm.eligibleAccounts = myDreamsService.eligibleLinkingAccounts;
            linkDreamVm.rdAmount = 0;
            linkDreamVm.fdAmount = 0;
            linkDreamVm.mfArray=[] ;
            linkDreamVm.mfAmount = 0;
            

            for (var i = 0; i < linkDreamVm.eligibleAccounts.recurringDeposits.length; i++) {
                if (linkDreamVm.selectedRDAccount)
                    linkDreamVm.selectedRDAccount[i] = false;
                if (i == linkDreamVm.eligibleAccounts.recurringDeposits.length - 1) {
                    linkDreamVm.totalRdAmount = linkDreamVm.rdAmount + Number(linkDreamVm.eligibleAccounts.recurringDeposits[i].amount);
                } else {
                    linkDreamVm.rdAmount = linkDreamVm.rdAmount + Number(linkDreamVm.eligibleAccounts.recurringDeposits[i].amount);
                }
            }

            for (var i = 0; i < linkDreamVm.eligibleAccounts.fixedDeposits.length; i++) {
                if (linkDreamVm.selectedFDAccount)
                    linkDreamVm.selectedFDAccount[i] = false;
                if (i == linkDreamVm.eligibleAccounts.fixedDeposits.length - 1) {
                    linkDreamVm.totalfdAmount = linkDreamVm.fdAmount + Number(linkDreamVm.eligibleAccounts.fixedDeposits[i].amount);
                } else {
                    linkDreamVm.fdAmount = linkDreamVm.fdAmount + Number(linkDreamVm.eligibleAccounts.fixedDeposits[i].amount);
                }
            }
              for (var i = 0; i < linkDreamVm.eligibleAccounts.mutualFunds.length; i++) {
                   linkDreamVm.mutualFundFolios =linkDreamVm.eligibleAccounts.mutualFunds;
                   linkDreamVm.folios = linkDreamVm.eligibleAccounts.mutualFunds;
                    linkDreamVm.mfArray[i]=false;
                     for (var j = 0; j < linkDreamVm.eligibleAccounts.mutualFunds[i].fundList.length; j++) {
                    linkDreamVm.mfAmount = linkDreamVm.mfAmount + Number(linkDreamVm.eligibleAccounts.mutualFunds[i].fundList[j].amount);
                    
                }

                   
            }
        });

    }
]);
