'use strict';

angularApp.controller('linkDreamReviewController', ["$state",
    "$rootScope",
    "utilityService",
    "constantConfig",
    "$ionicPlatform",
    "$scope",
    "$interval",
    "$filter",
    "myDreamsService",
    "$timeout",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "homeScreenService",
    "fixedDepositService",
    "$ionicPopup",

    function ($state,
        $rootScope,
        utilityService,
        constantConfig,
        $ionicPlatform,
        $scope,
        $interval,
        $filter,
        myDreamsService,
        $timeout,
        $ionicScrollDelegate,
        getAccountDetailsService,
        homeScreenService,
        fixedDepositService,
        $ionicPopup) {

        var linkDreamReviewVm = this;

        linkDreamReviewVm.closeView = function () {
            $state.go('menu.accountOverviewMyBalance');
        }

        linkDreamReviewVm.goBack = function () {
            $state.go('menu.linkDream');
        }

        linkDreamReviewVm.getCBValue = function(checkedValue){
            linkDreamReviewVm.tncChecked = checkedValue;
        }

        linkDreamReviewVm.linkSelectedAccounts = function () {
            if(!linkDreamReviewVm.isChecked){
                linkDreamReviewVm.tncChecked = false;
                return true;
            }
            var reqParams = {
                "dreamId": myDreamsService.selectedDreamDetails.dreamId,
                "accounts": myDreamsService.selectedAccountsArray
            }
            myDreamsService.linkMyDreamAccounts(reqParams).then(function (data) {
                //   getAccountDetailsService.tabIndex.tabIndex = 2;
                //   $state.go('menu.accountOverviewMyBalance');
                var requestParam = {
                    "dreamId": myDreamsService.selectedDreamDetails.dreamId
                }
                myDreamsService.getMyDreamDetails(requestParam).then(function (response) {
                    myDreamsService.selectedDreamDetails = response;
                    $state.go('menu.selectedDream');
                }, function (error) {
                    utilityService.showBhimUpiAlert("error", error.responseMessage);
                })
            }, function (error) {
                utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
   linkDreamReviewVm.showTnC = function (tncData) {
            var alertPopup = $ionicPopup.alert({
                title: "Terms and Conditions",
                template: '<div class="popupTextBottomPadding ss-p-r-f-8 ss-popup-list font-size-12 font-light ss-text-color md-color">'
                + tncData + '</div></div>',
                cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite ss-popup ODtncPopup',
                buttons: [
                    {
                        text: "OK",
                        onTap: function (e) { }
                    }
                ],
            });
        }


           linkDreamReviewVm.termcondition = function () {
            if (!myDreamsService.myDreamTnC) {
                var obj = {
                    "type": "getMyDreamsTnC"
                }
                myDreamsService.fetchTermsAndCondition(obj).then(function (data) {
                    if (!utilityService.isUndefined(data)) {
                        linkDreamReviewVm.myDreamTnC = data;
                        linkDreamReviewVm.showTnC(linkDreamReviewVm.myDreamTnC);
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else {
                linkDreamReviewVm.showTnC(myDreamsService.myDreamTnC);
            }
        }
           
        $scope.$on('$ionicView.beforeEnter', function () {
            linkDreamReviewVm.tncChecked = true;
            linkDreamReviewVm.dreamDetails = {};
            linkDreamReviewVm.dreamDetails = angular.copy(myDreamsService.selectedDreamDetails);
            linkDreamReviewVm.totalInvestmentAmt = 0;
            //if(!linkDreamReviewVm.dreamDetails.recurringDeposits)
                linkDreamReviewVm.dreamDetails.recurringDeposits = [];
            //if(!linkDreamReviewVm.dreamDetails.fixedDeposits)
                linkDreamReviewVm.dreamDetails.fixedDeposits = [];
            //if(!linkDreamReviewVm.dreamDetails.mutualFunds)
                linkDreamReviewVm.dreamDetails.mutualFunds = [];
               // linkDreamReviewVm.dreamDetails.recurringDepositsCurrent = [];

            for (var i = 0; i < myDreamsService.selectedAccountsArray.length; i++) {
                if (myDreamsService.selectedAccountsArray[i].accountType == 'RD') {
                    linkDreamReviewVm.totalInvestmentAmt += Number(myDreamsService.selectedAccountsArray[i].amount);
                    linkDreamReviewVm.dreamDetails.recurringDeposits.push(myDreamsService.selectedAccountsArray[i]);
                }
                if (myDreamsService.selectedAccountsArray[i].accountType == 'FD') {
                    linkDreamReviewVm.totalInvestmentAmt += Number(myDreamsService.selectedAccountsArray[i].amount);
                    linkDreamReviewVm.dreamDetails.fixedDeposits.push(myDreamsService.selectedAccountsArray[i]);
                }
                if (myDreamsService.selectedAccountsArray[i].accountType == 'MF') {
                    linkDreamReviewVm.totalInvestmentAmt += Number(myDreamsService.selectedAccountsArray[i].amount);
                    linkDreamReviewVm.dreamDetails.mutualFunds.push(myDreamsService.selectedAccountsArray[i]);
                }
            }
        });

    }
]);
