'use strict';

angularApp.service('myDreamsService',
	function ($q, utilityService, AdapterUtils) {

		var myDreamsService = this;
		myDreamsService.thruMyDream = false;
		myDreamsService.dreamId = '';

		myDreamsService.fetchTermsAndCondition = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MyDreamsAdapter/getMyDreamsTnC", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		myDreamsService.linkMyDreamAccounts = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MyDreamsAdapter/linkMyDreamAccounts", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		myDreamsService.delinkMyDreamAccount = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MyDreamsAdapter/delinkMyDreamAccount", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		myDreamsService.updateDream = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MyDreamsAdapter/editDream", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		myDreamsService.updateDreamStatus = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MyDreamsAdapter/updateDreamStatus", obj, false).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		myDreamsService.retrieveDreamImage = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MyDreamsAdapter/retrieveDreamImage", obj, false).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		myDreamsService.getMyDreamDetails = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MyDreamsAdapter/getMyDreamDetails", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		myDreamsService.uploadDreamImage = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MyDreamsAdapter/uploadDreamImage", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		myDreamsService.createNewDream = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MyDreamsAdapter/createUpdateDream", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		myDreamsService.getEligibleLinkingAccounts = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MyDreamsAdapter/getEligibleLinkingAccounts", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		myDreamsService.getDefaultDreams = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MyDreamsAdapter/getNewDreamContent", {}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		myDreamsService.getDreamList = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MyDreamsAdapter/getDreamList", {}, false).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		myDreamsService.getOtpSecure = function() {
	    var q = $q.defer();
	    AdapterUtils.postData("adapters/OTPAdapter/getOTPTokenSecure", {}, true).then(
		    function(response) {
		        q.resolve(response.data);
		    },
		    function(error) {
		        q.reject(error);
		    }
	    );
        return q.promise;
    };

	  myDreamsService.validateOtp = function(reqParams) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/OTPAdapter/validateOTPTokenSecure", reqParams, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

		myDreamsService.getFileForAndroid = function () {
			var q = $q.defer();
			fileChooser.open(function (imageURI) {
				window.resolveLocalFileSystemURL(imageURI, function (fileEntry) {
					var base64 = "";
					console.log("got image file entry: " + fileEntry.fullPath);
					fileEntry.file(function (file) {
						var reader = new FileReader();
						reader.onloadend = function (evt) {
							console.log("Read complete!");
							base64 = evt.target.result;
							q.resolve(base64);
						};
						reader.readAsDataURL(file);
					}, function (error) {
						q.reject(error);
					});
				}, failSystem);
			}, failureCallback);
			return q.promise;
		};

		function failSystem(err) {
			console.log("got image file entry err: " + err);
		};

		function failureCallback(msg) {
			console.log("File chooser Failed : " + msg);
		};

		return myDreamsService;
	});
