'use strict';

angularApp.controller('selectedDreamController', ["$state",
    "$rootScope",
    "utilityService",
    "constantConfig",
    "$ionicPlatform",
    "$scope",
    "$interval",
    "$filter",
    "myDreamsService",
    "$timeout",
    "$ionicPopup",
    "$translate",
    "fTSetOTPService",

    function ($state,
        $rootScope,
        utilityService,
        constantConfig,
        $ionicPlatform,
        $scope,
        $interval,
        $filter,
        myDreamsService,
        $timeout,
        $ionicPopup,
        $translate,
        fTSetOTPService) {

        var selectedDreamVm = this;

        selectedDreamVm.goBack = function () {
            $state.go('menu.accountOverviewMyBalance');
        }

        selectedDreamVm.delinkMyDreamAccount = function (account) {
            selectedDreamVm.selectedAccount = account;
            myDreamsService.selectedAccount = selectedDreamVm.selectedAccount;
            selectedDreamVm.myPopup = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter custOpacity',
                templateUrl: 'pages/accountOverview/myDreams/delinkConfirmPopup.html',
                scope: $scope
            })
        }

        selectedDreamVm.delinkCancelPopup = function () {
            selectedDreamVm.myPopup.close();
        }

        selectedDreamVm.delinkConfirmPopup = function () {
            selectedDreamVm.myPopup.close();
            var reqParams = {
                "dreamId": myDreamsService.selectedDreamDetails.dreamId,
                "accounts": {
                    "accountNumber": selectedDreamVm.selectedAccount.accountNumber,
                    "amount": selectedDreamVm.selectedAccount.amount,
                    "maturityDate": selectedDreamVm.selectedAccount.maturityDate,
                    "accountType": selectedDreamVm.selectedAccount.accountType,
                    "interest": selectedDreamVm.selectedAccount.interest,
                    "folioNo": selectedDreamVm.selectedAccount.folioNo,
                    "schemeCode": selectedDreamVm.selectedAccount.schemeCode,
                    "amfiCode": selectedDreamVm.selectedAccount.amfiCode,
                    "nav": selectedDreamVm.selectedAccount.nav,
                    "mfQuantity": selectedDreamVm.selectedAccount.mfQuantity,
                    "mfName": selectedDreamVm.selectedAccount.mfName
                }
            }
            myDreamsService.delinkMyDreamAccount(reqParams).then(function (data) {
                $state.go('menu.delinkSuccess');
            }, function (error) {
                utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        selectedDreamVm.editDream = function () {
            $state.go('menu.editSelectedDream');
        }

        selectedDreamVm.closeCancelPopup = function () {
            selectedDreamVm.myDreamClosePopup.close();
        }

        selectedDreamVm.closeConfirmPopup = function () {
            selectedDreamVm.myDreamClosePopup.close();
            var reqParams = {
                "dreamId": myDreamsService.selectedDreamDetails.dreamId,
                "status": "CLOSED"
            };

            // myDreamsService.getOtpSecure().then(function (data) {
            //     $state.go('menu.closeDreamOTP', { depositObject: { depositType: 'myDreamClosure', closureParams: reqParams, dreamType: 'closeDream' } });
            // }, function (error) {
            //     utilityService.showErrorMessage(error.responseMessage);
            // });
             $state.go('menu.closeDreamReview',{depositObject: {depositType: 'myDreamClosure',closureParams: reqParams, dreamType:'closeDream'}});
            /*
            var reqParams = {
                "dreamId": myDreamsService.selectedDreamDetails.dreamId,
                "status": "CLOSED"
            };
            myDreamsService.updateDreamStatus(reqParams).then(function (data) {
                $state.go('menu.closeDreamSuccess');
            }, function (error) {
                utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });*/
        }

        selectedDreamVm.closeDream = function () {
            // selectedDreamVm.myDreamClosePopup = $ionicPopup.show({
            //     title: '',
            //     cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter custOpacity',
            //     templateUrl: 'pages/accountOverview/myDreams/closeDreamConfirmPopup.html',
            //     scope: $scope
            // });

             var reqParams = {
                "dreamId": myDreamsService.selectedDreamDetails.dreamId,
                "status": "CLOSED"
            };
              $state.go('menu.closeDreamReview',{depositObject: {depositType: 'myDreamClosure',closureParams: reqParams, dreamType:'closeDream'}});
        }

        selectedDreamVm.investFunds = function () {
            var reqParams = {
                "dreamId": myDreamsService.selectedDreamDetails.dreamId
            };
             utilityService.doNotHideSpinner();
            myDreamsService.getEligibleLinkingAccounts(reqParams).then(function (data) {
                myDreamsService.eligibleLinkingAccounts = data;
                utilityService.hideSpinner();
                $state.go('menu.linkDream');
            }, function (error) {
                utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        selectedDreamVm.toggleGroup = function (group) {
            if (selectedDreamVm.isGroupShown(group)) {
                selectedDreamVm.shownGroup = null;
                selectedDreamVm.isGroupShown(group)
            } else {
                selectedDreamVm.shownGroup = group;
                selectedDreamVm.isGroupShown(group)
            }
        };

        selectedDreamVm.isGroupShown = function (group) {
            return selectedDreamVm.shownGroup === group;
        };

        $scope.$on('$ionicView.beforeEnter', function () {
            selectedDreamVm.shownGroup = null;
            selectedDreamVm.selectedDreamDetails = myDreamsService.selectedDreamDetails;
            if (!myDreamsService.dreamImage) {
                selectedDreamVm.dreamImage = $translate.instant('DREAM_DEFAULT_IMAGE');
                if (selectedDreamVm.selectedDreamDetails.imageType == 'wcm') {
                    selectedDreamVm.dreamImage = selectedDreamVm.selectedDreamDetails.imageId;
                }
                if (selectedDreamVm.selectedDreamDetails.imageType == 'filenet') {
                    var requestParam = {
                        "id": selectedDreamVm.selectedDreamDetails.imageId
                    }
                    myDreamsService.retrieveDreamImage(requestParam).then(function (response) {
                        console.log(response);
                        selectedDreamVm.dreamImage = "data:image/jpeg;base64," + response.documentData;
                        myDreamsService.dreamImage = selectedDreamVm.dreamImage;
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    })
                }
                myDreamsService.dreamImage = selectedDreamVm.dreamImage;
            } else {
                selectedDreamVm.dreamImage = myDreamsService.dreamImage;
            }

            selectedDreamVm.fdAmount = 0;
            selectedDreamVm.rdAmount = 0;
            selectedDreamVm.mfAmount = 0;
            selectedDreamVm.totalFdAmount = 0;
            selectedDreamVm.totalRdAmount = 0;
            selectedDreamVm.totalMFAmount = 0;
            selectedDreamVm.selectedMfName = [];
            for (var i = 0; i < selectedDreamVm.selectedDreamDetails.fixedDeposits.length; i++) {
                if (i == selectedDreamVm.selectedDreamDetails.fixedDeposits.length - 1) {
                    selectedDreamVm.totalFdAmount = selectedDreamVm.fdAmount + Number(selectedDreamVm.selectedDreamDetails.fixedDeposits[i].amount);
                } else {
                    selectedDreamVm.fdAmount = selectedDreamVm.fdAmount + Number(selectedDreamVm.selectedDreamDetails.fixedDeposits[i].amount);
                }
            }
            for (var i = 0; i < selectedDreamVm.selectedDreamDetails.recurringDeposits.length; i++) {
                if (i == selectedDreamVm.selectedDreamDetails.recurringDeposits.length - 1) {
                    selectedDreamVm.totalRdAmount = selectedDreamVm.rdAmount + Number(selectedDreamVm.selectedDreamDetails.recurringDeposits[i].amount);
                } else {
                    selectedDreamVm.rdAmount = selectedDreamVm.rdAmount + Number(selectedDreamVm.selectedDreamDetails.recurringDeposits[i].amount);
                }
            }
            for (var i = 0; i < selectedDreamVm.selectedDreamDetails.mutualFunds.length; i++) {
                for (var j = 0; j < selectedDreamVm.selectedDreamDetails.mutualFunds[i].fundList.length; j++) {
                    selectedDreamVm.mfAmount = selectedDreamVm.mfAmount + Number(selectedDreamVm.selectedDreamDetails.mutualFunds[i].fundList[j].amount);
                    //  linkDreamVm.mfAmount = linkDreamVm.mfAmount + Number(linkDreamVm.eligibleAccounts.mutualFunds[i].fundList[j].amount);
                    selectedDreamVm.selectedMfName.push(selectedDreamVm.selectedDreamDetails.mutualFunds[i].fundList[j]);
                }

            }

            selectedDreamVm.pieData = [{
                'name': 'Fixed Deposits',
                y: selectedDreamVm.totalFdAmount,
                color: '#673391'
            }, {
                'name': 'Recurring Deposits',
                y: selectedDreamVm.totalRdAmount,
                color: '#B22382'
            }, {
                'name': 'Mutual Funds',
                y: selectedDreamVm.mfAmount,
                color: '#5553AA'
            }, {
                'name': 'Remaining',
                y: Number(selectedDreamVm.selectedDreamDetails.dreamAmount) - (selectedDreamVm.totalFdAmount + selectedDreamVm.totalRdAmount + selectedDreamVm.mfAmount),
                color: '#D8D8D8'
            }];



            selectedDreamVm.totalLinkedInvestment = selectedDreamVm.totalFdAmount + selectedDreamVm.totalRdAmount;
            selectedDreamVm.totalLinkedPercent = (((selectedDreamVm.totalFdAmount + selectedDreamVm.totalRdAmount) / Number(selectedDreamVm.selectedDreamDetails.dreamAmount)) * 100).toFixed(2);
            $scope.dataHasLoaded = true
        });

        return this;
    }

]);

