'use strict';

angularApp.controller('viewDreamController', ["$state",
    "$rootScope",
    "utilityService",
    "constantConfig",
    "$ionicPlatform",
    "$scope",
    "$interval",
    "$filter",
    "myDreamsService",
    "$timeout",
    "$ionicPopup",
    "$translate",

    function ($state,
        $rootScope,
        utilityService,
        constantConfig,
        $ionicPlatform,
        $scope,
        $interval,
        $filter,
        myDreamsService,
        $timeout,
        $ionicPopup,
        $translate) {

        var viewDreamVm = this;

        viewDreamVm.goBack = function () {
            $state.go('menu.accountOverviewMyBalance');
        }

        viewDreamVm.deleteDream = function () {
            viewDreamVm.myDreamDeletePopup = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter custOpacity',
                templateUrl: 'pages/accountOverview/myDreams/deleteDreamConfirmPopup.html',
                scope: $scope
            });
        }

        viewDreamVm.deleteConfirmPopup = function () {
            viewDreamVm.myDreamDeletePopup.close();
            var reqParams = {
                "dreamId": myDreamsService.selectedDreamDetails.dreamId,
                "status": "DELETED"
            };
            $state.go('menu.closeDreamOTP',{depositObject: {depositType: 'myDreamClosure',closureParams: reqParams, dreamType:'deleteDream'}});
            /*myDreamsService.updateDreamStatus(reqParams).then(function (data) {
                $state.go('menu.accountOverviewMyBalance');
            }, function (error) {
                utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });*/
        }

        viewDreamVm.deleteCancelPopup = function () {
            viewDreamVm.myDreamDeletePopup.close();
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            utilityService.doNotHideSpinner();
            viewDreamVm.selectedDreamDetails = myDreamsService.selectedDreamDetails;
            if (myDreamsService.selectedDreamDetails.imageType !== 'default') {
                viewDreamVm.dreamImage = $translate.instant('DREAM_DEFAULT_IMAGE');
                if (myDreamsService.selectedDreamDetails.imageType == 'wcm') {
                    viewDreamVm.dreamImage = viewDreamVm.selectedDreamDetails.imageId;
                } else {
                    var requestParam = {
                        "id": myDreamsService.selectedDreamDetails.imageId
                    }
                    myDreamsService.retrieveDreamImage(requestParam).then(function (response) {
                        viewDreamVm.dreamImage = "data:image/jpeg;base64," + response.documentData;
                    }, function (error) {
                        viewDreamVm.dreamImage = $translate.instant('DREAM_DEFAULT_IMAGE');
                    })
                }
            } else {
                viewDreamVm.dreamImage = viewDreamVm.selectedDreamDetails.imageId;
            }
        });

        return this;
    }

]);

