'use strict';
angularApp.controller('odDetailsController', ["$timeout",
    "$state",
    "$scope",
    "autoLoanService",
    "utilityService",
	"getAccountDetailsService",
	"transactionService",
    "$filter",
    function($timeout,
        $state,
        $scope,
        autoLoanService,
        utilityService,
		getAccountDetailsService,
        transactionService,
        $filter) {

        //functions, variables that can be accessed from the HTML come here
        var odDetailsvm = this;
        odDetailsvm.isAccountMasked = false;
        //private methods section start
		odDetailsvm.autoLoanAccNo=getAccountDetailsService.autoLoanAccNo;
		odDetailsvm.branchCode=getAccountDetailsService.branchCode;
        function initPage() {
            

        }

        odDetailsvm.goBack = function() {
            $state.go('menu.accountOverviewMyBalance');
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {

            
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            odDetailsvm.currency = getAccountDetailsService.currency ;
            autoLoanService.getDepositAccountShortEnquiry(odDetailsvm.autoLoanAccNo,odDetailsvm.branchCode).then(function(data) {

                odDetailsvm.accountNumber=data.accountNumber;
                odDetailsvm.limitAmount=data.limitAmount;
                odDetailsvm.rateOfInterest=data.rateOfInterest;
                if(data.outstandingAmount.search('-') != -1){
                    data.outstandingAmount = data.outstandingAmount.replace('-','');
                    odDetailsvm.outstandingAmount = "-" + $filter('INR')(data.outstandingAmount);
                } else {
                    odDetailsvm.outstandingAmount = $filter('INR')(data.outstandingAmount);
                }
                odDetailsvm.eyesOffFun(odDetailsvm.accountNumber);

            }, function(error) {
                
            });
			
			 transactionService.getTransactions(odDetailsvm.autoLoanAccNo,"D").then(function(data) {
                odDetailsvm.txnsRows=data.transactions.length;	
                if (!utilityService.isUndefined(data.transactions)){
        
                    // if data is not null
                   
                    odDetailsvm.historydata = data.transactions;
                    odDetailsvm.currencyTransaction = data.currency ? data.currency : "";
                    
                      }
					  
            }, function(error) {
				
				
                
            });

            odDetailsvm.img = autoLoanService.transactionimg;
            odDetailsvm.imgnew = autoLoanService.downloadimg;
            

            
        });

        odDetailsvm.eyesOnFun = function(accNo){
            odDetailsvm.isAccountMasked = false;
            odDetailsvm.accountNumber = odDetailsvm.oldValue;
        }

        odDetailsvm.eyesOffFun = function(accNo){
            odDetailsvm.isAccountMasked = true;
            odDetailsvm.oldValue = accNo;
            odDetailsvm.accountNumber = utilityService.maskData(accNo, "front", 4);
        }

        //actions to done everytime the view is hidden
        $scope.$on('$ionicView.afterLeave', function() {

            //any cleanup needs to be done here: executes everytime when page is left
            
        });
        return this;
    }
]);