'use strict';

angularApp.controller('enterAccountAggregatorIDController', [
    "$state",
    "$scope",
    "$ionicPopup",
    "$ionicHistory",
    "OBADServices",
    "$filter",
    "utilityService",
    "clickStreamService",
    "homeScreenService",
    "getAccountDetailsService",
    function (
        $state,
        $scope,
        $ionicPopup,
        $ionicHistory,
        OBADServices,
        $filter,
        utilityService,
        clickStreamService,
        homeScreenService,
        getAccountDetailsService) {
        var enterAccAggId = this;
        $scope.showDisclaimerError = false;

        enterAccAggId.errorObj = {
            aAId: { show: false, error: '' }
        }
        var accountAggregatorPattern = /[A-Za-z0-9]{6,39}@[A-Za-z0-9]{1,33}/;

        enterAccAggId.selectedAccountAggregators = "";
        enterAccAggId.selectedAccAggr = OBADServices.selectedAccAggr;
        enterAccAggId.goBack = function () {
            $ionicHistory.goBack();
        }

        enterAccAggId.disclaimerContent = OBADServices.OBADdisclaimer;

        // VUA validation check
        enterAccAggId.checkPattern = function () {
            if (!accountAggregatorPattern.test(enterAccAggId.accAggrID) || enterAccAggId.accAggrID.length < 7 || enterAccAggId.accAggrID.length > 40) {
                enterAccAggId.errorObj.aAId = {
                    show: true,
                    error: $filter('translate')('OTHERBNAK_ENTER_AA_ID_ERROR')
                };
            } else {
                if ((enterAccAggId.accAggrID.match(new RegExp("@", "g")) || []).length > 1) {
                    enterAccAggId.errorObj.aAId = {
                        show: true,
                        error: $filter('translate')('OTHERBNAK_ENTER_AA_ID_ERROR')
                    };

                } else {
                    enterAccAggId.errorObj.aAId = {
                        show: false,
                        error: ''
                    }
                }

            }
        }

        // Open discliamer
        enterAccAggId.openDiscliamer = function () {
            enterAccAggId.agreeCheckBox = false;
            if (enterAccAggId.accAggrID == undefined || enterAccAggId.accAggrID == "" || enterAccAggId.accAggrID == null) {     
                enterAccAggId.errorObj.aAId = {
                    show: true,
                    error: $filter('translate')('OTHERBNAK_ENTER_AA_ID_ERROR')
                }
            }
            if (!enterAccAggId.errorObj.aAId.show) {
                var elem = document.querySelector(".popup-open");
                if (elem) {
                    return false;
                }
                clickStreamService.clickStreamData = "AA," + enterAccAggId.selectedAccAggr.aAname;
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_NEXT_BTN" + clickStreamService.appTypeIdentifier));

                enterAccAggId.disclaimerPopup = $ionicPopup.show({
                    templateUrl: "pages/accountOverview/otherBankAccountDetails/aARedirectionDisclaimer.html",
                    title: '<h3 class="popup-title>Disclaimer</h3><img src="img/OMP/close_btn.PNG" class="close_disclaimer_btn" alt="close_btn"/>',
                    scope: $scope,
                    cssClass: 'redirectionalDisclaimerPopup'
                });
            }
        }

        // Close disclaimer
        enterAccAggId.closeDisclaimer = function () {
            enterAccAggId.disclaimerPopup.close();
        }

        // validation for T&N checked
        $scope.checkboxChangeEvent = function () {
            if (enterAccAggId.agreeCheckBox) {
                $scope.showDisclaimerError = false;
                clickStreamService.clickStreamData = "AA," + enterAccAggId.selectedAccAggr.aAname;
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_AGREE_CHECK_BOX" + clickStreamService.appTypeIdentifier));

            }
        }

        // Redirecting customer to Account Aggregator page within InApp Browser
        enterAccAggId.Continue = function () {

            clickStreamService.clickStreamData = "AA," + enterAccAggId.selectedAccAggr.aAname;
            clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_CONTINUE_BTN" + clickStreamService.appTypeIdentifier));

            $scope.showDisclaimerError = false;
            if (!enterAccAggId.agreeCheckBox) {
                $scope.showDisclaimerError = true;
                return false;
            }
            if (enterAccAggId.disclaimerPopup) {
                enterAccAggId.disclaimerPopup.close();
            }
            enterAccAggId.reqObj = { "aaId": OBADServices.selectedAccAggr.aAname, "vua": enterAccAggId.accAggrID };
            utilityService.showSpinner();
            OBADServices.getAAUrl(enterAccAggId.reqObj).then(function (response) {
                utilityService.hideSpinner();
                enterAccAggId.inAppBrowser(response.webRedirectionUrl);
            }, function (error) {
                utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);

            });


        };

        // inApp browser theme setting 
        enterAccAggId.inAppBrowser = function (url) {
            var ref;
            ref = cordova.ThemeableBrowser.open(url, '_blank', {
                statusbar: {
                    color: '#ffffffff'
                },
                toolbar: {
                    height: 67,
                    color: '#ffffffff',
                    image: 'share_new',
                },

                closeButton: {
                    wwwImage: 'img/pfm/backarrow_5px down_1x.png',
                    align: 'left',
                    event: 'closePressed'
                },
                backButtonCanClose: true,
                showPOPUP: true
            });

            homeScreenService.ishamburgerMenuRO=false;
            homeScreenService.isAccountsFlag=true;
            getAccountDetailsService.tabIndex.tabIndex=0;
            $state.go('menu.accountOverviewMyBalance');

            ref.addEventListener('closePressed', function (e) {
                clickStreamService.clickStreamData = "AA," + enterAccAggId.selectedAccAggr.aAname;
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("AA" + "_INAPPBROWSER_BACK" + clickStreamService.appTypeIdentifier));
                ref.close();
            });

            ref.addEventListener('loadstart',function(e){                                            
                var inappUrl = "https://www.sbi.co.in/";
                if(e.url){
                    var str = e.url;
                    if(str.includes(inappUrl)){
                        clickStreamService.clickStreamData = "AA," + enterAccAggId.selectedAccAggr.aAname;
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("AA" + "_INAPPBROWSER_CLOSED_AND_REDIRECTED" + clickStreamService.appTypeIdentifier));
                        ref.close();
                    }
                }
            });
        }

        // before leaving page removing hidden buttons like logout, support etc
        $scope.$on('$ionicView.beforeLeave', function () {
            var headerElem = document.querySelector('body');
            if (headerElem) {
                headerElem.classList.remove('hiddenExtraButton');
            }
        });

        // adding css after entering page hidding buttons like logout, support etc
        $scope.$on('$ionicView.afterEnter', function () {
            var headerElem = document.querySelector('body');
            if (headerElem) {
                headerElem.classList.add('hiddenExtraButton');
            }
            utilityService.doNotHideSpinner();
            utilityService.enableShowErrorMessage();
        });

        return this;

    }

])