/**
*   @ngdoc config
*   @name angularApp.config : aoConfig
*   @description
*	configuration file for account opening module
*/

'use strict';

/*State definition with respective names, urls, controllers and templates */
angularApp.config(['$stateProvider',
	function ($stateProvider) {


		$stateProvider
			.state('menu.otherBankAAlanding', {
				url: '/otherBankAAlanding',
				data: {
					pageId: 'OTHER_BANK_AA_LANDING'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOverview/otherBankAccountDetails/otherBankAALandingPage.html',
						controller: 'otherBankAALandingPageController',
						controllerAs: 'otherBankAALandVm',
					}
				}
			})
			.state('menu.otherBankselectAA', {
				url: '/otherBankselectAA',
				data: {
					pageId: 'OTHER_BANK_SELECT_AA'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOverview/otherBankAccountDetails/selectAccountAggregator.html',
						controller: 'selectAccountAggregatorController',
						controllerAs: 'selectAAVm',
					}
				}
			})
			.state('menu.enterAAId', {
				url: '/enterAAId',
				data: {
					pageId: 'OTHER_BANK_ENTER_AA_ID'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOverview/otherBankAccountDetails/enterAccountAggregatorID.html',
						controller: 'enterAccountAggregatorIDController',
						controllerAs: 'enterAccAggId',
					}
				}
			})
			.state('menu.otherBankAccList', {
				url: '/otherBankAccList',
				data: {
					pageId: 'OTHER_BANK_ACCOUNT_LIST'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOverview/otherBankAccountDetails/otherBankAccountList.html',
						controller: 'otherBankAccountListController',
						controllerAs: 'otherBankAccListVm',
					}
				}
			})
			.state('menu.otherBanktrxBalDetails', {
				url: '/otherBanktrxBalDetails',
				data: {
					pageId: 'OTHER_BANK_BAL_TRX_DETAILS'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/accountOverview/otherBankAccountDetails/otherBanktrxBalDetails.html',
						controller: 'otherBanktrxBalDetailsController',
						controllerAs: 'otherBanktrxBalDetailsVm',
					}
				}
			})


	}]);