'use strict';

angularApp.controller('otherBankAccountListController', [
    "$state",
    "$scope",
    "$ionicHistory",
    "OBADServices",
    "utilityService",
    "cryptoService",
    "loggedInUserService",
    "homeScreenService",
    function (
        $state,
        $scope,
        $ionicHistory,
        OBADServices,
        utilityService,
        cryptoService,
        loggedInUserService,
        homeScreenService) {
        var otherBankAccListVm = this;

        // Init page id 1 for pagination effect and pass account details to api
        otherBankAccListVm.getOtherBankData = function (account) {
            var pageId = "1";
            OBADServices.selectedAccountForFiData = account;
            otherBankAccListVm.callService(account, pageId);
        }

        // Get FI data for select Account.
        otherBankAccListVm.callService = function (account, pageId) {
            var reqObj =
            {
                "consentID": account.consentID,
                "linkReferenceNumber": account.linkReferenceNumber,
                "pageId": pageId,
                "key": cryptoService.getSHA512EncryptedData(loggedInUserService.tokenLotus + account.consentID + account.linkReferenceNumber).toString()

            }
            utilityService.doNotHideSpinner();
            utilityService.showSpinner();
            OBADServices.getFiData(reqObj).then(function (response) {
                OBADServices.transList = response;
                OBADServices.txnCount = response.data.txnCount;
                utilityService.hideSpinner();
                $state.go('menu.otherBanktrxBalDetails');
            }, function (error) {
                utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);

            })
        }
        
        // Redirect customer to Account Aggregator landing page.
        otherBankAccListVm.redirectToLandingPage = function () {
            $state.go("menu.otherBankAAlanding");
        }

        // Navigate to previous page
        otherBankAccListVm.goBack = function () {
            homeScreenService.isAccountsFlag = true;
            $ionicHistory.goBack();
        }


        // before leaving page removing hidden buttons like logout, support etc
        $scope.$on('$ionicView.beforeLeave', function () {
            var headerElem = document.querySelector('body');
            if (headerElem) {
                headerElem.classList.remove('hiddenExtraButton');
            }
        });

        // adding css after entering page hidding buttons like logout, support etc
        $scope.$on('$ionicView.afterEnter', function () {
            var headerElem = document.querySelector('body');
            if (headerElem) {
                headerElem.classList.add('hiddenExtraButton');
            }

            utilityService.enableShowErrorMessage();

            // dynamic footer height setting for whole account list view.
            var footerHeight = document.getElementById('pfmFooter').offsetHeight;
            console.log("Footer width = "+ footerHeight);
            
            $scope.footerHeight = {
                "bottom" : footerHeight+"px"
            }

            // Fetching all account from service.
            otherBankAccListVm.accounts = OBADServices.accountBasicDetailsList.data.accounts;
        });
        
        return this;

    }

])