'use strict';

angularApp.controller('otherBanktrxBalDetailsController', [
    "$scope",
    "$ionicHistory",
    "OBADServices",
    "utilityService",
    "cryptoService",
    "loggedInUserService",
    function (
        $scope,
        $ionicHistory,
        OBADServices,
        utilityService,
        cryptoService,
        loggedInUserService) {
        var otherBanktrxBalDetailsVm = this;
        $scope.showDisclaimerError = false;
        var pageCount = 1;
        otherBanktrxBalDetailsVm.showMoreTrxnsEnabled = false;

        if (OBADServices.transList.transactions != null) {
            otherBanktrxBalDetailsVm.trxHistory = OBADServices.transList.transactions.Transaction;
        } else {
            otherBanktrxBalDetailsVm.trxHistory = [];
        }
        otherBanktrxBalDetailsVm.accounts = OBADServices.transList.data
        otherBanktrxBalDetailsVm.selectedAcc = OBADServices.selectedAccountForFiData;

        if (OBADServices.txnCount > OBADServices.transList.data.pageSize) {
            otherBanktrxBalDetailsVm.showMoreTrxnsEnabled = true;
        }

        // Navigate to previous page
        otherBanktrxBalDetailsVm.goBack = function () {
            $ionicHistory.goBack();
        }

        // Get More Transaction from FI data service
        otherBanktrxBalDetailsVm.getMoreTrxData = function () {

            pageCount = pageCount + 1;
            var reqObj =
            {
                "consentID": otherBanktrxBalDetailsVm.selectedAcc.consentID,
                "linkReferenceNumber": otherBanktrxBalDetailsVm.selectedAcc.linkReferenceNumber,
                "pageId": pageCount,
                "key": cryptoService.getSHA512EncryptedData(loggedInUserService.tokenLotus + otherBanktrxBalDetailsVm.selectedAcc.consentID + otherBanktrxBalDetailsVm.selectedAcc.linkReferenceNumber).toString()

            }
            utilityService.showSpinner();
            OBADServices.getFiData(reqObj).then(function (response) {
                otherBanktrxBalDetailsVm.trxHistory.push.apply(otherBanktrxBalDetailsVm.trxHistory, response.transactions.Transaction);
                if (OBADServices.txnCount > otherBanktrxBalDetailsVm.trxHistory.length) {
                    otherBanktrxBalDetailsVm.showMoreTrxnsEnabled = true;
                } else {
                    otherBanktrxBalDetailsVm.showMoreTrxnsEnabled = false;
                }
                utilityService.hideSpinner();
            }, function (error) {
                utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);

            })

        }

        // before leaving page removing hidden buttons like logout, support etc
        $scope.$on('$ionicView.beforeLeave', function () {
            var headerElem = document.querySelector('body');
            if (headerElem) {
                headerElem.classList.remove('hiddenExtraButton');
            }

        });

        // adding css after entering page hidding buttons like logout, support etc
        $scope.$on('$ionicView.afterEnter', function () {
            var headerElem = document.querySelector('body');
            if (headerElem) {
                headerElem.classList.add('hiddenExtraButton');
            }

            utilityService.doNotHideSpinner();
            utilityService.enableShowErrorMessage();

        });

        return this;

    }

])