'use strict';

angularApp.controller('selectAccountAggregatorController', ["$state",
    "$scope",
    "$ionicPopup",
    "$ionicHistory",
    "OBADServices",
    "utilityService",
    "clickStreamService",
    "homeScreenService",
    "getAccountDetailsService",
    function (
        $state,
        $scope,
        $ionicPopup,
        $ionicHistory,
        OBADServices,
        utilityService,
        clickStreamService,
        homeScreenService,
        getAccountDetailsService) {
        var selectAAVm = this;
        $scope.showDisclaimerError = false;

        // Account Aggregator Avail
        selectAAVm.accountAggregators = [{
            icons: "img/pfm/NESL_hires.png",
            aAname: "nadl",
            width: "65",
            height: "25",
            name: "NADL"
        }];

        // Navigate to previous page
        selectAAVm.goBack = function () {
            $ionicHistory.goBack();
        }

        selectAAVm.disclaimerContent = OBADServices.OBADdisclaimer;

        // Check VUA avail & prepare reqObj
        selectAAVm.checkIsIDAvail = function (selectedAA) {
            selectAAVm.agreeCheckBox = false;
            clickStreamService.clickStreamData = "AA," + selectedAA.aAname;
            clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_OPT" + clickStreamService.appTypeIdentifier));
            OBADServices.selectedAccAggr = selectedAA;
            selectAAVm.reqObj = {};
            if (OBADServices.isIdAvailiable) {
                $state.go('menu.enterAAId');
            } else {
                selectAAVm.reqObj = { "aaId": "nadl", "vua": "" };
                selectAAVm.openDiscliamer();
            }
        }

        // Open discliamer
        selectAAVm.openDiscliamer = function () {
            var elem = document.querySelector(".popup-open");
            if (elem) {
                return false;
            }
            selectAAVm.disclaimerPopup = $ionicPopup.show({
                templateUrl: "pages/accountOverview/otherBankAccountDetails/aARedirectionDisclaimerPopup.html",
                title: '<h3 class="popup-title>Disclaimer</h3><img src="img/OMP/close_btn.PNG" class="close_disclaimer_btn" alt="close_btn"/>',
                scope: $scope,
                cssClass: 'redirectionalDisclaimerPopup'
            });
        }

        // Close disclaimer
        selectAAVm.closeDisclaimer = function () {
            selectAAVm.disclaimerPopup.close();
        }

        // validation for T&N checked
        $scope.checkboxChangeEvent = function () {
            if (selectAAVm.agreeCheckBox) {
                $scope.showDisclaimerError = false;
                clickStreamService.clickStreamData = "AA," + OBADServices.selectedAccAggr.aAname;
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "AGREE_CHECK_BOX" + clickStreamService.appTypeIdentifier));
            }
        }

        // Redirecting customer to Account Aggregator page within InApp Browser
        selectAAVm.Continue = function () {

            clickStreamService.clickStreamData = "AA," + OBADServices.selectedAccAggr.aAname;
            clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_CONTINUE_BTN" + clickStreamService.appTypeIdentifier));

            $scope.showDisclaimerError = false;
            if (!selectAAVm.agreeCheckBox) {
                $scope.showDisclaimerError = true;
                return false;
            }
            if (selectAAVm.disclaimerPopup) {
                selectAAVm.disclaimerPopup.close();
            }
            utilityService.showSpinner();
            OBADServices.getAAUrl(selectAAVm.reqObj).then(function (response) {
                utilityService.hideSpinner();
                selectAAVm.inAppBrowser(response.webRedirectionUrl);
            }, function (error) {
                utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);

            });


        };

        // inApp browser theme setting 
        selectAAVm.inAppBrowser = function (url) {
            var ref;

            ref = cordova.ThemeableBrowser.open(url, '_blank', {
                statusbar: {
                    color: '#ffffffff'
                },
                toolbar: {
                    height: 67,
                    color: '#ffffffff',
                    image: 'share_new',
                },

                closeButton: {
                    wwwImage: 'img/pfm/backarrow_5px down_1x.png',
                    align: 'left',
                    event: 'closePressed'
                },
                backButtonCanClose: true,
                showPOPUP: true
            });

            homeScreenService.ishamburgerMenuRO=false;
            homeScreenService.isAccountsFlag=true;
            getAccountDetailsService.tabIndex.tabIndex=0;
            $state.go('menu.accountOverviewMyBalance');

            ref.addEventListener('closePressed', function (e) {
                clickStreamService.clickStreamData = "AA," + OBADServices.selectedAccAggr.aAname;
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("AA" + "_INAPPBROWSER_BACK" + clickStreamService.appTypeIdentifier));
                ref.close();
            });

            ref.addEventListener('loadstart',function(e){                                            
                var inappUrl = "https://www.sbi.co.in/";
                if(e.url){
                    var str = e.url;
                    if(str.includes(inappUrl)){
                        clickStreamService.clickStreamData = "AA," + OBADServices.selectedAccAggr.aAname;
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("AA" + "_INAPPBROWSER_CLOSED_AND_REDIRECTED" + clickStreamService.appTypeIdentifier));
                        ref.close();
                    }
                }
            });
        }

        // before leaving page removing hidden buttons like logout, support etc
        $scope.$on('$ionicView.beforeLeave', function () {
            var headerElem = document.querySelector('body');
            if (headerElem) {
                headerElem.classList.remove('hiddenExtraButton');
            }

        });

        // adding css after entering page hidding buttons like logout, support etc
        $scope.$on('$ionicView.afterEnter', function () {
            var headerElem = document.querySelector('body');
            if (headerElem) {
                headerElem.classList.add('hiddenExtraButton');
            }
            utilityService.doNotHideSpinner();
            utilityService.enableShowErrorMessage();
        });

        return this;

    }

])