'use strict';
angularApp.controller('otherDepositsController', ["$timeout",
    "$state",
    "$scope",
    "autoLoanService",
    "utilityService",
    "getAccountDetailsService",
    "transactionService",
    "ppfExtService",
    "$ionicPopup",
    function ($timeout,
        $state,
        $scope,
        autoLoanService,
        utilityService,
        getAccountDetailsService,
        transactionService,
        ppfExtService,
         $ionicPopup) {

        //functions, variables that can be accessed from the HTML come here
        var otherDepositsVm = this;
        otherDepositsVm.isAccountMasked = false;
        //private methods section start
        otherDepositsVm.autoLoanAccNo = getAccountDetailsService.autoLoanAccNo;

        otherDepositsVm.branchCode = getAccountDetailsService.branchCode;

        otherDepositsVm.productDescription = getAccountDetailsService.loanLabel;
        otherDepositsVm.lienAmount = getAccountDetailsService.lienAmount;
        function initPage() {


        }

        otherDepositsVm.goBack = function () {
            $state.go('menu.accountOverviewMyBalance');
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {


            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {

            otherDepositsVm.otherAccountNumber = "";
            otherDepositsVm.maturityDate = "";
            otherDepositsVm.balanceAmount = "";
            otherDepositsVm.rateOfInterest = "";
            otherDepositsVm.lien = "";

            autoLoanService.getOtherDepositDetails(otherDepositsVm.autoLoanAccNo, otherDepositsVm.branchCode).then(function (data) {
                otherDepositsVm.otherAccountNumber = data.otherAccountNumber;
                otherDepositsVm.maturityDate = data.maturityDate;
                otherDepositsVm.balanceAmount = data.balanceAmount;
                otherDepositsVm.rateOfInterest = data.rateOfInterest;
                ppfExtService.ppfExtOtherdetails = data;
                otherDepositsVm.extensionPPF = data.extensionPPF ? data.extensionPPF : "";
                otherDepositsVm.eyesOffFun(otherDepositsVm.otherAccountNumber);
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

            transactionService.getTransactions(otherDepositsVm.autoLoanAccNo, "D").then(function (data) {
                otherDepositsVm.txnsRows = data.transactions.length;
                if (!utilityService.isUndefined(data.transactions)) {

                    // if data is not null

                    otherDepositsVm.historydata = data.transactions;

                }

            }, function (error) {

                utilityService.showErrorMessage(error.responseMessage);

            });

            otherDepositsVm.img = autoLoanService.transactionimg;
            otherDepositsVm.imgnew = autoLoanService.downloadimg;



        });

        otherDepositsVm.eyesOnFun = function (accNo) {
            otherDepositsVm.isAccountMasked = false;
            otherDepositsVm.otherAccountNumber = otherDepositsVm.oldValue;
        }

        otherDepositsVm.eyesOffFun = function (accNo) {
            otherDepositsVm.isAccountMasked = true;
            otherDepositsVm.oldValue = accNo;
            otherDepositsVm.otherAccountNumber = utilityService.maskData(accNo, "front", 4);
        }

        //actions to done everytime the view is hidden
        $scope.$on('$ionicView.afterLeave', function () {

            //any cleanup needs to be done here: executes everytime when page is left

        });

        otherDepositsVm.extendClick = function () {
            utilityService.showSpinner();
            var commonErrObj = {
                isPanValid : ppfExtService.ppfExtOtherdetails.panValid !== "NO" ? true : false,
                isLienAmount : parseInt(ppfExtService.ppfExtOtherdetails.lien) === 0 ? true : false,
                isKyc : false
            }

            ppfExtService.checkKYC().then(function (data) {
                utilityService.hideSpinner();
                commonErrObj["isKyc"] = true;
                otherDepositsVm.openErrorComnMtd(commonErrObj);

            }, function (error) {
                utilityService.hideSpinner();
                otherDepositsVm.openErrorComnMtd(commonErrObj);

            });
        }

        otherDepositsVm.openErrorComnMtd = function (commonErrObj) {
            if(!commonErrObj.isLienAmount || !commonErrObj.isKyc || !commonErrObj.isPanValid){
                var message = '<div class="ppf_ext_error_popup_container">'
                    + '<div class="font-size-16 roboto-medium" translate="PPF_LBL_KYC_ERROR_INFO_HDR"></div>'
                    + '<ul class="ppf_ext_tnc_ul ppf_ext_lbl_color_3F3F3F ppf_ext_mar_top_16">'
                    + '<li class="ppf_pad_top_10" ng-if="'+!commonErrObj.isLienAmount+'" style="text-align: left;" translate="PPF_LBL_KYC_ERROR_INFO_1"></li>'
                    + '<li class="ppf_pad_top_10" ng-if="'+!commonErrObj.isKyc+'" style="text-align: left;" translate="PPF_LBL_KYC_ERROR_INFO_2"></li>'
                    + '<li class="ppf_pad_top_10" ng-if="'+!commonErrObj.isPanValid+'" style="text-align: left;" translate="PPF_LBL_KYC_ERROR_INFO_3"></li>'
                    + '</ul></div>'
                    + '<div class="roboto-regular font-size-14 ppf_ext_lbl_color_3F3F3F ppf_ext_visit_branch_info" translate="PPF_LBL_KYC_ERROR_INFO_VST_BRANCH"></div>';
                var title = "";
                var template = '<div class="font-dark-grey"><div><img class="approvedIconPosition" src="img/FT/BhimUpi/errorSymbol.svg" /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="fontSize-subHeading"><div class="textAlignCenter"><span>'
                    + message + '</span></div></div></div>';
                var cssClass = 'bhim-alert-popup ppt_ext_popup';
                var btnText = "OK";
                
                $ionicPopup.alert({
                    title: title,
                    template: template,
                    cssClass: cssClass,
                    buttons: [
                        {
                            text: btnText,
                            type: 'button-positive',
                            onTap: function () {
                                
                            }
                        }
                    ],
                });
            }else{
                $state.go("menu.ppfExtReview");
            }
        }

        return this;
    }
]);
