'use strict';
angularApp.controller('ppfExtOTPController', 
["$timeout",
"$state",
"$scope",
"utilityService",
"getAccountDetailsService",
"customerInfoService",
"$ionicHistory",
"cryptoService",
"constantConfig",
"quickTransferService",
"ppfExtService",
function($timeout,
     $state,
     $scope,
     utilityService,
     getAccountDetailsService,
     customerInfoService,
     $ionicHistory,
     cryptoService,
     constantConfig,
     quickTransferService,
     ppfExtService) {

          var ppfExtOTPVM = this;
          ppfExtOTPVM.submitted  = false;
          ppfExtOTPVM.isDisabledOTPbtn = false;
          var otpCounter = 0;
          ppfExtOTPVM.mobileNo = customerInfoService.customerInfo ? customerInfoService.customerInfo.mobile : "";
          
          ppfExtOTPVM.validateOTP = function(){
              ppfExtOTPVM.submitted = true;
              if(ppfExtOTPVM.otp && ppfExtOTPVM.otp.length === 6){
                    ppfExtOTPVM.submitted = false;
                    var reqParams = {};
                    reqParams["otp"] = ppfExtOTPVM.otp;
                    reqParams["mobile"] = ppfExtOTPVM.mobileNo;
                    quickTransferService.validateOTP(reqParams).then(function(data){
                        ppfExtOTPVM.suceess();
                    }, function(error){
                        utilityService.showErrorMessage(error.responseMessage);
                    });
              }
          }

          ppfExtOTPVM.suceess = function(){
                
                //$state.go("menu.ppfExtSuccess");
                ppfExtService.success().then(function(response){
                        console.log("RESPONSE :: "+JSON.stringify(response));
                        ppfExtService.extenInfo1 = response.extenInfo1;
                        ppfExtService.extenInfo2 = response.extenInfo2;
                        $state.go("menu.ppfExtSuccess");
                    }, function(error){
                        utilityService.showErrorMessage(error.responseMessage);
                });
          }

          ppfExtOTPVM.goBack = function(){
              $ionicHistory.goBack();
          }

          ppfExtOTPVM.resendOTP = function(){
                if(!ppfExtOTPVM.isDisabledOTPbtn){
                    var reqParams = {};
                    reqParams["id"] = ppfExtOTPVM.mobileNo;
                    reqParams.otpCode = constantConfig.keysForOTP.ftNormalFundTransfer;
                    reqParams.ocHash = cryptoService.getSHA512EncryptedData(constantConfig.keysForOTP.ftNormalFundTransfer).toString();
                    quickTransferService.generateOTP(reqParams).then(function(data){	
                        var msg = "<div translate='LBL_STEP1_RESEND_OTP_SUCCESS_MSG'></div>";
                        utilityService.showBhimUpiAlert('', msg, 'menu.ppfExtOTP', 'OK', $scope);
                        if(otpCounter != 2){
                            otpCounter = otpCounter+1;
                        }else{
                            ppfExtOTPVM.isDisabledOTPbtn = true;
                        }
                    }, function(error){
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }
                
          }

          $scope.$on('$ionicView.beforeEnter', function () {
                var reqParams = {};
                reqParams["id"] = customerInfoService.customer.mobile;
                reqParams.otpCode = constantConfig.keysForOTP.ftNormalFundTransfer;
                reqParams.ocHash = cryptoService.getSHA512EncryptedData(constantConfig.keysForOTP.ftNormalFundTransfer).toString();
                quickTransferService.generateOTP(reqParams).then(function(data){	

                }, function(error){
                    utilityService.showBhimUpiAlert('error', error.responseMessage, 'menu.ppfExtReview', 'OK', $scope);
                });
          });

          return this;
    }
]);