'use strict';
angularApp.controller('ppfExtReviewController',
    ["$timeout",
        "$state",
        "$scope",
        "utilityService",
        "getAccountDetailsService",
        "ppfExtService",
        "customerInfoService",
        "$ionicHistory",
        "constantConfig",
        "quickTransferService",
        "$ionicPopup",
        "$ionicScrollDelegate",
        function ($timeout,
            $state,
            $scope,
            utilityService,
            getAccountDetailsService,
            ppfExtService,
            customerInfoService,
            $ionicHistory,
            constantConfig,
            quickTransferService,
            $ionicPopup,
            $ionicScrollDelegate) {

            var ppfExtReviewVM = this;
            ppfExtReviewVM.ppfAccDetails = {};
            ppfExtReviewVM.isDownArrow = false;
            ppfExtReviewVM.isAccountMasked = false;
            ppfExtReviewVM.isConfirm = false;
            ppfExtReviewVM.tnc = "";
            ppfExtReviewVM.isiOS = utilityService.isIOSPlatform();
            ppfExtReviewVM.value = "";
            ppfExtReviewVM.nomineeList = [];
            ppfExtReviewVM.isNomineeDetails = true;
            ppfExtReviewVM.submitted = false;

            $scope.$on('$ionicView.beforeEnter', function () {
                ppfExtReviewVM.getppfAccDetails();
            });

            ppfExtReviewVM.getppfAccDetails = function () {
                ppfExtReviewVM.ppfAccDetails = {
                    otherDetails: ppfExtService.ppfExtOtherdetails,
                    accNumber: ppfExtService.ppfExtOtherdetails.otherAccountNumber,
                    ppfExtDetails: ppfExtService.ppfAccDetails,
                    customerName: customerInfoService.customerInfo ? customerInfoService.customerInfo.customerName : {},
                    customerAddress: customerInfoService.customerInfo ? customerInfoService.customerInfo.address + ", " + customerInfoService.customerInfo.pinCode : {}
                };
                ppfExtReviewVM.eyesOffFun(ppfExtReviewVM.ppfAccDetails.accNumber);
                ppfExtReviewVM.getTnC();
            }

            ppfExtReviewVM.eyesOnFun = function (accNo) {
                ppfExtReviewVM.isAccountMasked = false;
                ppfExtReviewVM.ppfAccDetails.accNumber = ppfExtReviewVM.oldValue;
                var eyeElem = document.getElementsByTagName("eye-icon-tmpl")[0];
                eyeElem.classList.remove("ppf_ext_eye_icon");
            }

            ppfExtReviewVM.eyesOffFun = function (accNo) {
                ppfExtReviewVM.isAccountMasked = true;
                ppfExtReviewVM.oldValue = accNo;
                ppfExtReviewVM.ppfAccDetails.accNumber = utilityService.maskData(accNo, "front", 4);
                var eyeElem = document.getElementsByTagName("eye-icon-tmpl")[0];
                eyeElem.classList.add("ppf_ext_eye_icon");
            }

            ppfExtReviewVM.goBack = function () {
                $ionicHistory.goBack();
            }

            ppfExtReviewVM.getNomineeDetails = function () {
                var eleIonConten = document.getElementsByClassName("ppf_ext_ion_cnt_ftr")[0];
                ppfExtReviewVM.isDownArrow = !ppfExtReviewVM.isDownArrow;
                if(ppfExtReviewVM.nomineeList.length === 0 && ppfExtReviewVM.isNomineeDetails){
                    ppfExtService.getNomineeDetails(ppfExtService.ppfAccDetails).then(function (response) {
                        ppfExtReviewVM.isNomineeDetails = true;
                        ppfExtReviewVM.nomineeList = response.nomineeLists;
                        eleIonConten.setAttribute("overflow-scroll","true");
                        $ionicScrollDelegate.resize();
                    }, function (error) {
                        ppfExtReviewVM.isNomineeDetails = false;
                        eleIonConten.setAttribute("overflow-scroll","true");
                        $ionicScrollDelegate.resize();
                        //utilityService.showErrorMessage(error.responseMessage);
                    });
                }
                else{
                    var nomList = ppfExtReviewVM.nomineeList;
                    ppfExtReviewVM.nomineeList = nomList;
		            eleIonConten.setAttribute("overflow-scroll","true");
                    $ionicScrollDelegate.resize();
                }
            }

            ppfExtReviewVM.getTnC = function () {
                if (!ppfExtReviewVM.tnc) {
                    ppfExtService.getTnCDetails().then(function (response) {
                        ppfExtReviewVM.tnc = response;
                        //ppfExtReviewVM.getNomineeDetails(ppfExtService.ppfAccDetails);
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }
            }

            ppfExtReviewVM.openTnC = function () {
                ppfExtReviewVM.submitted = true;
                if(ppfExtReviewVM.isConfirm){
                    ppfExtReviewVM.submitted = false;
                    ppfExtReviewVM.isConfirm = true;
                    var message = ppfExtReviewVM.tnc;
                    var template = '<div class="font-dark-grey"><div></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="fontSize-subHeading"><div class="textAlignCenter"><span>'
                        + message + '</span></div></div></div>';
                    var cssClass = 'bhim-alert-popup ppt_ext_popup';
                    var btnText = "Ok";
                    var goto = "menu.ppfExtOTP";
                    $ionicPopup.alert({
                        template: template,
                        cssClass: cssClass,
                        buttons: [
                            {
                                text: btnText,
                                type: 'button-positive',
                                onTap: function () {
                                    $state.go(goto);
                                }
                            }
                        ],
                    });
                }
                // else{
                //     ppfExtReviewVM.submitted = true;
                //     ppfExtReviewVM.isConfirm = false;
                // }
                
            }



            ppfExtReviewVM.displayForm = function (val) {
                ppfExtReviewVM.value = val;
                ppfExtService.getPDFDetails().then(function (response) {
                    var base64 = response.base64Pdf;
                    var filename = "PPF Extension form.pdf";
                    var contentType = "application/pdf";
                    if (utilityService.isAndroidPlatform()) {
                        ppfExtReviewVM.folderpath = cordova.file.externalDataDirectory;
                    }
                    if (utilityService.isIOSPlatform()) {
                        ppfExtReviewVM.folderpath = cordova.file.documentsDirectory;
                    }

                    savebase64AsPDF(ppfExtReviewVM.folderpath, filename, base64, contentType);
                    
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }

            function b64toBlob(b64Data, contentType, sliceSize) {
                contentType = contentType || '';
                sliceSize = sliceSize || 512;
                var byteCharacters = atob(b64Data);
                var byteArrays = [];
                for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
                    var slice = byteCharacters.slice(offset, offset + sliceSize);
                    var byteNumbers = [];
                    for (var i = 0; i < slice.length; i++) {
                        byteNumbers[i] = slice.charCodeAt(i);
                    }
                    var byteArray = new Uint8Array(byteNumbers);
                    byteArrays.push(byteArray);
                }
                var blob = new Blob(byteArrays, { type: contentType });
                return blob;
            }

            function savebase64AsPDF(folderpath, filename, content, contentType) {
                var contentStr = atob(content);
                var contentLen = contentStr.length;
                if (contentLen >= constantConfig.accOverview.pdfSize) {
                    utilityService.showErrorMessage(constantConfig.accOverview.sizeLimitMessage);
                    return;
                }
                // Convert the base64 string in a Blob
                var DataBlob = b64toBlob(content, contentType);
                
                utilityService.showSpinner();

                if (utilityService.isAndroidPlatform()) {
                    if (device.version == 10) {
                        window.resolveLocalFileSystemURL(folderpath, function (dir) {
                            dir.getFile(filename, { create: true }, function (file) {
                                file.createWriter(function (fileWriter) {
                                    fileWriter.write(DataBlob);
                                    utilityService.hideSpinner();
                                    ppfExtReviewVM.showForm(filename);
                                }, function (error) { utilityService.hideSpinner(); });
                            }, function (error) { utilityService.hideSpinner(); });
                        }, function (error) { utilityService.hideSpinner(); });
                    }else{
                        //for Android below 10 and Android 11 not for 10
                        window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fileSystem) {
                            fileSystem.root.getDirectory("Download", { create: true, exclusive: false }, function (dir) {
                                ppfExtReviewVM.folderpath = dir.fullPath;
                                dir.getFile(filename, { create: true, exclusive: false }, function (file) {
                                    file.createWriter(function (fileWriter) {
                                        fileWriter.write(DataBlob);
                                        utilityService.hideSpinner();
                                        ppfExtReviewVM.moveFile(filename, DataBlob);
                                    }, function (error) {
                                        utilityService.hideSpinner(); 
                                    });
                                }, function (error) {
                                    utilityService.hideSpinner(); 
                                });
                            }, function (error) {
                                utilityService.hideSpinner(); 
                            });
                        }, function (error) {
                            utilityService.hideSpinner(); 
                        });
                    }
                }else{
                    window.resolveLocalFileSystemURL(folderpath, function (dir) {
                        dir.getFile(filename, { create: true }, function (file) {
                            file.createWriter(function (fileWriter) {
                                fileWriter.write(DataBlob);
                                utilityService.hideSpinner();
                                ppfExtReviewVM.showForm(filename);
                            }, function (error) { 
                                utilityService.hideSpinner();
                            });
                        }, function (error) { 
                            utilityService.hideSpinner();
                        });
                    }, function (error) { 
                        utilityService.hideSpinner();
                    });
                }
            }

            ppfExtReviewVM.moveFile = function(filename, DataBlob){
                ppfExtReviewVM.folderpath = cordova.file.dataDirectory;
                window.resolveLocalFileSystemURL(ppfExtReviewVM.folderpath, function (dir) {
                    dir.getFile(filename, { create: true }, function (file) {
                        file.createWriter(function (fileWriter) {
                            fileWriter.write(DataBlob);
                            utilityService.hideSpinner();
                            ppfExtReviewVM.showForm(filename);
                        }, function (error) { 
                            utilityService.hideSpinner(); 
                        });
                    }, function (error) { 
                        utilityService.hideSpinner(); 
                    });
                }, function (error) { 
                    utilityService.hideSpinner(); 
                });
                //ppfExtReviewVM.showForm(filename);
            }

            ppfExtReviewVM.showForm = function(filename){
                if(utilityService.isIOSPlatform() || (ppfExtReviewVM.value === "view" && !utilityService.isIOSPlatform())){                   
                    var finalPath = ppfExtReviewVM.folderpath + filename;
                    cordova.plugins.fileOpener2.open(
                        finalPath,
                        'application/pdf', {
                            error: function (e) {},
                            success: function () {}
                        }
                    );
                }
                else{
                    if(ppfExtReviewVM.value === "download"){
                        ppfExtReviewVM.myPopup = $ionicPopup.show({
                            template: 'File Downloaded to Internal Storage',
                            title: '',
                            cssClass: 'dialog',
                            scope: $scope,
                            buttons: [{
                                text: 'OK',
                                type: 'button-positive'
                            }]
                        });
                    }
                }
            }


            return this;
        }
    ]);
