'use strict';
angularApp.controller('ppfExtSuccessController',
      ["$timeout",
            "$state",
            "$scope",
            "utilityService",
            "getAccountDetailsService",
            "$ionicHistory",
            "customerInfoService",
            "fTBeneficiaryService",
            "ppfExtService",
            "constantConfig",
            "fTReviewService",
            function ($timeout,
                  $state,
                  $scope,
                  utilityService,
                  getAccountDetailsService,
                  $ionicHistory,
                  customerInfoService,
                  fTBeneficiaryService,
                  ppfExtService,
                  constantConfig,
                  fTReviewService) {

                  var ppfExtSuccessVM = this;
                  ppfExtSuccessVM.info1 = ppfExtService.extenInfo1;
                  ppfExtSuccessVM.info2 = ppfExtService.extenInfo2;
                  ppfExtSuccessVM.accountNumber = ppfExtService.ppfExtOtherdetails.otherAccountNumber;
                  ppfExtSuccessVM.accounts = [];
                  fTBeneficiaryService.payingFrom = [];

                  $scope.$on('$ionicView.beforeEnter', function () {
                        if (getAccountDetailsService.accountOverviewData) {
                              ppfExtSuccessVM.accounts = getAccountDetailsService.accountOverviewData.accounts;
                              ppfExtSuccessVM.setValues();
                        } else {
                              utilityService.showSpinner();
                              getAccountDetailsService.getAccountDetails().then(function (data) {
                                    utilityService.hideSpinner();
                                    ppfExtSuccessVM.accounts = getAccountDetailsService.accountOverviewData.accounts;
                                    ppfExtSuccessVM.setValues();
                              }, function (error) {
                                    utilityService.hideSpinner();
                                    utilityService.showErrorMessage(error.responseMessage);
                              });
                        }
                  });

                  ppfExtSuccessVM.goBack = function () {
                        $ionicHistory.goBack();
                  }

                  ppfExtSuccessVM.setValues = function () {
                        var acc = ppfExtSuccessVM.accounts;
                        for (var i = 0; i < acc.length; i++) {
                              var obj = {
                                    img: constantConfig.SBILogo,
                                    accountCategory: acc[i].accountCategory,
                                    accountType: acc[i].accountType,
                                    accountNo: acc[i].accountNumber,
                                    balance: acc[i].accountBalance,
                                    branchCode: acc[i].branchCode,
                                    isActive: acc[i].isActive,
                                    isTransactional: acc[i].isTransactional,
                                    intCategory: acc[i].intCategory ? acc[i].intCategory : "",
                                    accountTypeCode: acc[i].accountTypeCode ? acc[i].accountTypeCode : "",
                                    branchName: acc[i].branchName ? acc[i].branchName : "",
                                    debitNriflag: acc[i].nriFlag ? acc[i].nriFlag : ""
                              }
                              fTBeneficiaryService.payingFrom.push(obj);
                        }

                        if (!getAccountDetailsService.accessRightsData.accounts) {
                              getAccountDetailsService.getAccountsAccessRights('').then(function (data) {
                                    getAccountDetailsService.accessRightsData = data;
                              }, function (error) {                              
                              });
                        }
                  }

                  ppfExtSuccessVM.depositMoney = function () {
                        var otherAcc = getAccountDetailsService.accountOverviewData.otherDeposits;
                        for (var i = 0; i < otherAcc.length; i++) {
                              if(otherAcc[i]["otherAccountNumber"] === ppfExtService.ppfExtOtherdetails["otherAccountNumber"]){
                                    fTBeneficiaryService.customer.accountType = otherAcc[i]["accountType"];
                                    fTBeneficiaryService.customer.conImg = constantConfig.SBILogo;
                                    fTBeneficiaryService.customer.accountCategory = otherAcc[i]["accountCategory"];
                                    fTBeneficiaryService.customer.nameData = customerInfoService.customerInfo.customerName;
                                    fTBeneficiaryService.customer.accountTypeData = otherAcc[i]["accountType"];
                                    fTBeneficiaryService.customer.transAmount = "";
                                    fTBeneficiaryService.customer.mobileNo = customerInfoService.customerInfo.mobile;
                                    fTBeneficiaryService.customer.nickName = "";
                                    fTBeneficiaryService.customer.benType = "";
                                    fTBeneficiaryService.customer.ifsc = "";
                                    fTBeneficiaryService.customer.maxLimit = "";
                                    fTBeneficiaryService.customer.intraBankFlag = "Y";
                                    fTBeneficiaryService.customer.ownAccount = "Y";
                                    fTBeneficiaryService.customer.mmid = "";
                                    fTBeneficiaryService.customer.isActive = true;
                                    fTBeneficiaryService.customer.creditTypeCode = "";
                                    fTBeneficiaryService.customer.creditIntCategory = "";
                                    fTBeneficiaryService.customer.benStatus = "";
                                    fTBeneficiaryService.customer.remarks = "";
                                    fTBeneficiaryService.customer.frequentAmount = "";
                                    fTBeneficiaryService.customer.bankData = "SBI";
                                    fTBeneficiaryService.customer.accountNoData = otherAcc[i]["otherAccountNumber"];
                              }
                        }
                        fTReviewService.isComingFromFTHomePage = true;
                        $state.go('menu.fTPaymentDetails');
                  }

                  return this;
            }
      ]);