angularApp.controller('leadGenerationInvestmentController',
	["$state", "$scope", "loggedInUserService", "mPinLoginService", "$ionicHistory", "$ionicSideMenuDelegate", "utilityService", "mutualFundsService",
		"getAccountDetailsService", "mySecurityProfileService", "openAccountService", "$q", "$rootScope","clickStreamService","$filter","newCardService","$timeout","$ionicSlideBoxDelegate",
		function ($state, $scope, loggedInUserService, mPinLoginService, $ionicHistory, $ionicSideMenuDelegate, utilityService, mutualFundsService,
			getAccountDetailsService, mySecurityProfileService, openAccountService, $q, $rootScope,clickStreamService,$filter,newCardService,$timeout,$ionicSlideBoxDelegate) {

    var leadGenerationInvestmentControllerVm = this;
    //one time initialization to be done when the controller is loaded
    $scope.$on('$ionicView.loaded', function () {
       leadGenerationInvestmentControllerVm.loadTrendingFunds();
       leadGenerationInvestmentControllerVm.loadBottomBanners();  
    });

 leadGenerationInvestmentControllerVm.loadBottomBanners = function () {
    $ionicSideMenuDelegate.canDragContent($scope.isLoggedIn)
    $scope.banners = [];
        mutualFundsService.getInvestmentPreLoginBanners().then(function(data){
                $scope.getBannerD = data;
                angular.forEach($scope.getBannerD, function(value, key) {
			    $scope.outerData=value;
                    angular.forEach($scope.outerData.banners, function(value1, key1) {
                    $scope.banners.push(value1);
                    console.log("one",$scope.banners);
                });
            });

                $ionicSlideBoxDelegate.update();
				$ionicSlideBoxDelegate.loop(true);
           
                
            }, function(error) {
                leadGenerationInvestmentControllerVm.getBannerD = '';
                utilityService.showErrorMessage(error.responseMessage);
        });
 }
 leadGenerationInvestmentControllerVm.loadTrendingFunds = function () {
    $ionicSideMenuDelegate.canDragContent($scope.isLoggedIn);
        leadGenerationInvestmentControllerVm.showFolio = false;
        leadGenerationInvestmentControllerVm.showInvestmentAc = false;
        leadGenerationInvestmentControllerVm.showError = false;
        leadGenerationInvestmentControllerVm.showSpinner = false;
        leadGenerationInvestmentControllerVm.showFolio = true;
        leadGenerationInvestmentControllerVm.showInvestmentAc = true;
        if (!mutualFundsService.mostTrendingFunds) {
            mutualFundsService.trendingFundsPre().then(function (data) {
                leadGenerationInvestmentControllerVm.trendingFunds = data.topTrendingFundsResult;
                mutualFundsService.mostTrendingFunds = data.topTrendingFundsResult;
            }, function (error) {
                leadGenerationInvestmentControllerVm.showError = true;
            });
        } else {
            leadGenerationInvestmentControllerVm.trendingFunds = mutualFundsService.mostTrendingFunds;
        }
 }


leadGenerationInvestmentControllerVm.redirectUrl = function (url) {
		if (url == "menu.mutualFunds") {	
            var nfoArray = [];
            mutualFundsService.getAllMutualFundsPreLogin().then(function (data) {
                if (data.fundList.length > 5) {
                    angular.forEach(data, function (value, key) {
                        for (var i in value) {
                            if (value[i].fundSchemeName == "NFO") {
                                nfoArray.push(data.fundList[i]);
                                data.fundList.splice(i, 1);
                                data.fundList.splice(1, 0, nfoArray[0]);
                            }
                        }
                    });
                }

                mutualFundsService.addFundList(data.fundList);
                mutualFundsService.setPageId('quickBuy');
                $state.go('menu.mutualFundsList');
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
         else {
            newCardService.setPreLoginSelectedMenu('linkOrOpenNewAcc');
            $state.go("menu.securityLanding");
        }
	}
    leadGenerationInvestmentControllerVm.goBack = function() {
		 $state.go('menu.userLanding');
    }

   


    leadGenerationInvestmentControllerVm.checkFolio = function () {
        leadGenerationInvestmentControllerVm.showFolio = true;
    }


    leadGenerationInvestmentControllerVm.redirect = function(page){
        if (page == "investment") {
            newCardService.setPreLoginSelectedMenu('myInvestment');
        }else if(page == "MF_HOM"){
            newCardService.setPreLoginSelectedMenu('invest');
        }
         else if (page == "know") {
            newCardService.setPreLoginSelectedMenu('know');
         }
         else if (page == "open" || page == "DM_HOM") {
            newCardService.setPreLoginSelectedMenu('open');
         }
         else if(page == 'folio'){
             newCardService.setPreLoginSelectedMenu('folio');
         }
         
         loggedInUserService.productClicked = 'menu.termsAndConditionsOutboundAnalytics';         
         $state.go('menu.userLogin');
      
        
    }

    leadGenerationInvestmentControllerVm.bannerRedirect= function (page) {
				if(page == "AOV_MYINVT"){
					newCardService.setPreLoginSelectedMenu('myInvestment');
                    loggedInUserService.productClicked = 'menu.termsAndConditionsOutboundAnalytics';         
                    $state.go('menu.userLogin');
				}else if(page == "AOV_MYINVT_OPENFOLIO" || page == "AOV_MYINVT_OPENDEMATACC"){
					 newCardService.setPreLoginSelectedMenu('open');
                     loggedInUserService.productClicked = 'menu.termsAndConditionsOutboundAnalytics';         
                     $state.go('menu.userLogin');
				}else if(page == "AOV_MYINVT_ELSS"){
					leadGenerationInvestmentControllerVm.redirectSomeUrl('elss');
				}				
			}

leadGenerationInvestmentControllerVm.redirectSomeUrl = function(page){
        if (page == "elss") {
            if (!mutualFundsService.taxSaverFunds) {
                mutualFundsService.taxSaver().then(function (data) {
                    mutualFundsService.taxSaverFunds = data;
                    var index = mutualFundsService.taxSaverFunds.findIndex(function (fund) {
                        return fund.schemeOptions == "G"
                    });
                    if(index > 0){
                        var element = mutualFundsService.taxSaverFunds[index];
                        mutualFundsService.taxSaverFunds.splice(index, 1);
                        mutualFundsService.taxSaverFunds.splice(0, 0, element);
                    }
                    $state.go('menu.mutualTaxSaver');
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else {
                $state.go('menu.mutualTaxSaver');
            }
        }
        else if (page == "know") {
            newCardService.setPreLoginSelectedMenu('know');
            $state.go('menu.startInvesting');
        }
        else if (page == "investment") {
            newCardService.setPreLoginSelectedMenu('myInvestmentAllProducts');
            loggedInUserService.productClicked = 'menu.termsAndConditionsOutboundAnalytics';         
            $state.go('menu.userLogin');
        }
         
        
    }


    //any cleanup needs to be done here: executes everytime when page is left
    $scope.$on('$ionicView.afterLeave', function () {
        $ionicSideMenuDelegate.canDragContent($scope.isLoggedIn);
    });

    leadGenerationInvestmentControllerVm.getFundDetail = function (fund) {
        var request = {
            'amfiCode': fund.amfiCode
        }
        mutualFundsService.getAllMutualFundsPreLogin().then(function(data) {
            leadGenerationInvestmentControllerVm.fundList1 = data.fundList;
            var temparray=[];
            if(leadGenerationInvestmentControllerVm.fundList1.length > 0){	 
                for (var k = 0; k <leadGenerationInvestmentControllerVm.fundList1.length; k++) {
                    for (var j = 0; j <leadGenerationInvestmentControllerVm.fundList1[k].fundSchemeList.length; j++){ 	
                        if(leadGenerationInvestmentControllerVm.fundList1[k].fundSchemeName != "NFO" && leadGenerationInvestmentControllerVm.fundList1[k].fundSchemeName != "Popular"){	
                            temparray.push(leadGenerationInvestmentControllerVm.fundList1[k].fundSchemeList[j]); 
                        }
                    }		
                }
                temparray = $filter('uniqueArr')(temparray, 'fundId');
            }
            var fundobject = "";
            for (var z=0; z<temparray.length; z++){
                if(temparray[z].amfiCode == request.amfiCode){
                    fundobject = temparray[z];
                    break;
                }
            }

            var fundoptnArr = [];
            if(fundobject.isNfo == "Y"){
                var id = fundobject.fundName;
                fundoptnArr.push(fundobject);
                for (var i = 0; i <leadGenerationInvestmentControllerVm.fundList1.length; i++) {
                    for (var m = 0; m <leadGenerationInvestmentControllerVm.fundList1[i].fundSchemeList.length; m++){ 
                        if(leadGenerationInvestmentControllerVm.fundList1[i].fundSchemeName == "NFO"){
                            if(leadGenerationInvestmentControllerVm.fundList1[i].fundSchemeList[m].fundName == id){
                                fundoptnArr.push(leadGenerationInvestmentControllerVm.fundList1[i].fundSchemeList[m]);
                            }
                        }
                    }	
                }
            }
            else{
                var schFndID = fundobject.schemeFundId;
                fundoptnArr.push(fundobject);
                for (var n = 0; n <temparray.length; n++) {
                    if(temparray[n].schemeFundId == schFndID){
                        fundoptnArr.push(temparray[n]);
                    }
                }
            }
            fundoptnArr = $filter('uniqueArr')(fundoptnArr, 'fundId');
            mutualFundsService.addFundId(fundoptnArr);
            $state.go('menu.fundDetails');
        }, function(error) {
            utilityService.showErrorMessage(error.responseMessage);
        });

    }

}]);