'use strict';

angularApp.controller('overdraftAccController', 
	["$timeout",
	"$state",
	"$scope",
	"$translate",
	"accountOverviewService",
	"utilityService",
	"transactionService",


	function ($timeout,
		$state,
		$scope,
		$translate,
		accountOverviewService,
		utilityService,
		transactionService) {

		var overdraftAccVm = this;
		overdraftAccVm.isAccountMasked = false;

	//private methods section start
	function initPage(){
		
		overdraftAccVm.img= "img/Transactions.png";
		$translate(['ACC_NUMBER','TOTAL_LIMIT','AVAILED_AMOUNT','RATE_OF_INT','TRANS_DETAILS']).then(function (translations) {
			overdraftAccVm.accno=translations['ACC_NUMBER'];
			overdraftAccVm.totLimit=translations['TOTAL_LIMIT'];
			overdraftAccVm.availamt=translations['AVAILED_AMOUNT'];
			overdraftAccVm.intrate=translations['RATE_OF_INT'];
			overdraftAccVm.transDetails=translations['TRANS_DETAILS'];
			
			

		});
	}
	//private methods section end
	
	//one time initialization to be done when the controller is loaded
	$scope.$on('$ionicView.loaded', function() {
		
		initPage();
	});
	
	//actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function() {
		overdraftAccVm.overdraftAccVm =[];

		if (!utilityService.isUndefined(accountOverviewService.customer.ODaccount)){
			overdraftAccVm.odaccountNum = accountOverviewService.customer.ODaccount;

		}
		if (!utilityService.isUndefined(accountOverviewService.customer.accountCategory)){
			overdraftAccVm.accountCategory = accountOverviewService.customer.accountCategory;

		}
		if (!utilityService.isUndefined(accountOverviewService.customer.loanAmount)){
			overdraftAccVm.overdraftAccVm.availamnt  = accountOverviewService.customer.loanAmount;

		}
		if (!utilityService.isUndefined(accountOverviewService.customer.interest)){
			overdraftAccVm.overdraftAccVm.intrrate = accountOverviewService.customer.interest;

		}

		accountOverviewService.getOverDraftDetails(overdraftAccVm.odaccountNum).then(function(data){
			if (!utilityService.isUndefined(data.accountNumber)){
				overdraftAccVm.overdraftAccVm.accnum = data.accountNumber;
				overdraftAccVm.eyesOffFun(overdraftAccVm.overdraftAccVm.accnum);
			}
			if (!utilityService.isUndefined(data.limitAmount)){
				overdraftAccVm.overdraftAccVm.totlim = data.limitAmount;
			}
			transactionService.getTransactions(overdraftAccVm.odaccountNum,overdraftAccVm.accountCategory).then(function(data){
				overdraftAccVm.transaction = [];
				if (!utilityService.isUndefined(data.transactions)){
					overdraftAccVm.transaction = data.transactions;
				}

			}, function(error){
				utilityService.showErrorMessage(error.responseMessage);
			});

		}, function(error){
			utilityService.showErrorMessage(error.responseMessage);
		});

	});		

	overdraftAccVm.goBack=function(){
		$state.go('menu.accountOverviewMyBalance');
	}

	overdraftAccVm.eyesOnFun = function(accNo){
		overdraftAccVm.isAccountMasked = false;
		overdraftAccVm.overdraftAccVm.accnum = overdraftAccVm.oldValue;
	}

	overdraftAccVm.eyesOffFun = function(accNo){
		overdraftAccVm.isAccountMasked = true;
		overdraftAccVm.oldValue = accNo;
		overdraftAccVm.overdraftAccVm.accnum = utilityService.maskData(accNo, "front", 4);
	}

	
	//actions to done everytime the view is hidden
	$scope.$on('$ionicView.afterLeave', function() {
		
		//any cleanup needs to be done here: executes everytime when page is left
		
	});
	return this;
}]);