'use strict';
angularApp.controller('recurringDepositsController', ["$timeout",
    "$state",
    "$scope",
    "autoLoanService",
    "utilityService",
	"getAccountDetailsService",
	"transactionService",

    function($timeout,
        $state,
        $scope,
        autoLoanService,
        utilityService,
		getAccountDetailsService,
		transactionService) {

        //functions, variables that can be accessed from the HTML come here
        var recurringDepositsVm = this;
        recurringDepositsVm.isAccountMasked = false;
        //private methods section start
		recurringDepositsVm.autoLoanAccNo=getAccountDetailsService.autoLoanAccNo;
		recurringDepositsVm.availableBalance=getAccountDetailsService.availableBalance;
		recurringDepositsVm.branchCode=getAccountDetailsService.branchCode;
        function initPage() {
            

        }

        recurringDepositsVm.goBack = function() {
            $state.go('menu.accountOverviewMyBalance');
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {

            
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
		
				recurringDepositsVm.rdAccountNumber="";
                recurringDepositsVm.maturityDate="";
                recurringDepositsVm.balanceAmount="";
                recurringDepositsVm.maturityAmount="";
                recurringDepositsVm.rateOfInterest="";
            autoLoanService.getRecurringDepositDetails(recurringDepositsVm.autoLoanAccNo,recurringDepositsVm.branchCode).then(function(data) {

                recurringDepositsVm.rdAccountNumber=data.rdAccountNumber;
                recurringDepositsVm.maturityDate=data.maturityDate;
                recurringDepositsVm.balanceAmount=data.balanceAmount;
                recurringDepositsVm.maturityAmount=data.maturityAmount;
                recurringDepositsVm.rateOfInterest=data.rateOfInterest;
                recurringDepositsVm.eyesOffFun(recurringDepositsVm.rdAccountNumber);
            }, function(error) {
                
            });
			
			 transactionService.getTransactions(recurringDepositsVm.autoLoanAccNo,"D").then(function(data) {
                recurringDepositsVm.txnsRows=data.transactions.length;	
                if (!utilityService.isUndefined(data.transactions)){
        
                    // if data is not null
                   
                    recurringDepositsVm.historydata = data.transactions;
                    
                      }
					  
            }, function(error) {
				
				
                
            });

            recurringDepositsVm.img = autoLoanService.transactionimg;
            recurringDepositsVm.imgnew = autoLoanService.downloadimg;
            

            
        });

        recurringDepositsVm.eyesOnFun = function(accNo){
            recurringDepositsVm.isAccountMasked = false;
            recurringDepositsVm.rdAccountNumber = recurringDepositsVm.oldValue;
        }

        recurringDepositsVm.eyesOffFun = function(accNo){
            recurringDepositsVm.isAccountMasked = true;
            recurringDepositsVm.oldValue = accNo;
            recurringDepositsVm.rdAccountNumber = utilityService.maskData(accNo, "front", 4);
        }

        //actions to done everytime the view is hidden
        $scope.$on('$ionicView.afterLeave', function() {

            //any cleanup needs to be done here: executes everytime when page is left
            
        });
        return this;
    }
]);