'use strict';
angularApp.controller('spendAnalysisController', ["$timeout",
    "$state",
    "$scope",
    "$ionicPopup",
    "spendAnalysisService",
    "closePopupService",
    "getAccountDetailsService",
    "transactionService",
    "utilityService",
	"constantConfig",
	"customerInfoService",
    "$ionicScrollDelegate",
	"openUrlInAppbroswerService",
	"pwdProtectedPdfDownloadService",
    function($timeout,
        $state,
        $scope,
        $ionicPopup,
        spendAnalysisService,
        closePopupService,
        getAccountDetailsService,
        transactionService,
        utilityService,
		constantConfig,
		customerInfoService,
        $ionicScrollDelegate,
		openUrlInAppbroswerService,
		pwdProtectedPdfDownloadService) {
        //functions, variables that can be accessed from the HTML come here
        var spendAnalysisVm = this;

        //Start Txn
        spendAnalysisVm.close_symb = false;
        spendAnalysisVm.txnDiv = true;
        spendAnalysisVm.spendDiv = false;
        spendAnalysisVm.searchKey = '';
        spendAnalysisVm.chartDisplay=false;
		spendAnalysisVm.selectedValue=getAccountDetailsService.accType.accno+","+getAccountDetailsService.accType.transactionFlag+","+getAccountDetailsService.accType.type+","+getAccountDetailsService.accType.branchName;
		spendAnalysisVm.indexId=getAccountDetailsService.accType.indexId;
        spendAnalysisVm.type=getAccountDetailsService.accType.type;
        spendAnalysisVm.transactionFlag=getAccountDetailsService.accType.transactionFlag;
		spendAnalysisVm.chartRows=0;
		spendAnalysisVm.defaultLineChart='Monthly';
		spendAnalysisVm.accNo="";
		spendAnalysisVm.txnFlag="";
		spendAnalysisVm.txnPDFBtn=true;
		spendAnalysisVm.mailBtn=true;
		spendAnalysisVm.maxTransactionsMsg = "";
        
        
        spendAnalysisVm.removeCloseText = function() {            
            spendAnalysisVm.searchKey = '';            
        }
      
	
       
       spendAnalysisVm.editTagPopup = function(trxnId) {
            $scope.data = {}
            var uniqueNames = [];
            
for( var i = 0; i< spendAnalysisVm.history.length; i++){    
    if(uniqueNames.indexOf(spendAnalysisVm.history[i].tagName) === -1){
       if(spendAnalysisVm.history[i].tagName!=null && spendAnalysisVm.history[i].tagName!=''){
    	uniqueNames.push(spendAnalysisVm.history[i].tagName);  
    }
    }        
}
            spendAnalysisVm.tagPopup = $ionicPopup.show({
                title : "",
                cssClass : 'my-custom-popup',
                template: '<div class="button_fund fontSize-subHeading roboto-light font-dark-grey" class="fontSize12">'+
				'<div class="transaction_selectedpopup" ng-repeat="tag in spendAnalysisVm.history" ng-click="spendAnalysisVm.addTagToField(tag.tagName)">'+
				'<span ng-if="tag.tagName!=null">#{{tag.tagName | lowercase}}</span></div>'+
                    '<input type="text"  id="input-border" id="transaction_showpopup" ng-model="spendAnalysisVm.addNewTag" placeholder="#Add a new Tag"></div>',
                scope: $scope,
                buttons: [{
                    text: 'OK',
                    type: 'button-positive font-link-blue',
                    onTap: function(e) {
                        transactionService.createTag(spendAnalysisVm.selectedValue, trxnId, spendAnalysisVm.addNewTag).then(function(data) {
                            
                        }, function(error) {
                            
                        });
                    }
                }]
            });
            closePopupService.register(spendAnalysisVm.tagPopup);
        };
        spendAnalysisVm.addTagToField=function(field){
        spendAnalysisVm.addNewTag=field;    
        }
        spendAnalysisVm.editTagPopupClose = function() {

            spendAnalysisVm.tagPopup.close();
        }

        spendAnalysisVm.getTransactions = function(data) {
			var data=data;
			spendAnalysisVm.accDetails=data.split(",");
			spendAnalysisVm.accNo=spendAnalysisVm.accDetails[0];
			spendAnalysisVm.txnFlag=spendAnalysisVm.accDetails[1];
			//spendAnalysisVm.accNo="30001430348";
			//spendAnalysisVm.txnFlag="D";
			spendAnalysisVm.txnSpinner=true;
			spendAnalysisVm.txnSpinnerError=false;
			spendAnalysisVm.txnDiv=true;
			spendAnalysisVm.trxnFailed=false;
		
            transactionService.getTransactions(spendAnalysisVm.accNo,spendAnalysisVm.txnFlag).then(function(data) {
				if(data.maxTransactionsMsg) {
					spendAnalysisVm.maxTransactionsMsg = data.maxTransactionsMsg;
				} //CMS-55
                spendAnalysisVm.txnsRows=data.transactions.length;
				spendAnalysisVm.txnDiv=true;
				spendAnalysisVm.currency = data.currency;
                if (!utilityService.isUndefined(data.transactions)){
        
                    // if data is not null
                   
                    spendAnalysisVm.history = data.transactions;
                    
                      }
                if (!utilityService.isUndefined(data.tagList)){
                    spendAnalysisVm.tagList = data.tagList;
                      }
					  if(spendAnalysisVm.tagList.length<=0|| spendAnalysisVm.tagList==="" ||spendAnalysisVm.tagList==null){
						spendAnalysisVm.txnSpinnerError=true;  
					  }
					  spendAnalysisVm.txnSpinner=false;
					  
            }, function(error) {
				
				
				spendAnalysisVm.txnsRows='';
				spendAnalysisVm.txnSpinner=false;
				//spendAnalysisVm.txnSpinnerError=true;
				spendAnalysisVm.trxnFailed=true;
                
            });
        }

        //End Txn


        $scope.orderByTag = 'tagName';
        $scope.reverseSort = false;
        spendAnalysisVm.accountPopup = function() {
            $scope.data = {}
            spendAnalysisVm.myPopup = $ionicPopup.show({
                title: 'Select Account',
                template: '<div class="transaction_popup" ng-repeat="acc in spendAnalysisVm.accountDetails" ng-click="spendAnalysisVm.selectedAccount(acc)">{{acc.accountNumber}}</div>',
                scope: $scope
            });
            closePopupService.register(spendAnalysisVm.myPopup);
        };
        spendAnalysisVm.selectedAccount = function() {
        
		 
		 if(spendAnalysisVm.txnDiv){
		spendAnalysisVm.searchKey="";
		spendAnalysisVm.history="";
		   spendAnalysisVm.getTransactions(spendAnalysisVm.selectedValue);
		}
		
		var data=spendAnalysisVm.selectedValue;
			spendAnalysisVm.accDetails=data.split(",");
			spendAnalysisVm.accNo=spendAnalysisVm.accDetails[0];
			spendAnalysisVm.txnFlag=spendAnalysisVm.accDetails[1];
		
		   if(spendAnalysisVm.spendDiv){
		   spendAnalysisService.getSpendAnalysis(spendAnalysisVm.accNo,'overallmonthly').then(function(response) { 

			angular.element(document.querySelector('.week_doughnut')).removeClass('actOverview-button-selected').removeClass('bg-color-grey');
            angular.element(document.querySelector('.month_doughnut')).addClass('actOverview-button-selected').removeClass('bg-color-grey');
            angular.element(document.querySelector('.quarter_doughnut')).removeClass('actOverview-button-selected').removeClass('bg-color-grey');		   
                //if (!utilityService.isUndefined(response.graphDetails)){
					
                    spendAnalysisVm.spendAnalysisData = response.graphDetails;
                  
                     // }
                if (!utilityService.isUndefined(response.totalAmount)){
                    spendAnalysisVm.spendAnalysisTotalAmount = response.totalAmount;
                      }
                var grapLable = [];
                var grapAmount = [];
                var grapPercentage = [];
                var grapColor = [];
                angular.forEach(response.graphDetails, function(value, key) {
                    grapAmount.push(value.amount);
                    grapLable.push(value.tagName);
                    grapPercentage.push(value.percentage);
                    grapColor.push(value.color);
                });
		
                var pieGraphData = {
                    grapLable: grapLable,
                    grapAmount: grapAmount,
                    grapPercentage: grapPercentage,
                    grapColor: grapColor
                }
				
				spendAnalysisVm.dChart();
          //      spendAnalysisVm.doughnutChartView(pieGraphData);
            }, function(error) {
		
            });
		 
		   
		   spendAnalysisVm.dChart();
		}
        }

		 spendAnalysisVm.doughnutChartOnChange = function(accountNumber,type) {
		var accountNumber=accountNumber;
		accountNumber=accountNumber.split(",");
		accountNumber=accountNumber[0];
		
		 spendAnalysisVm.dChartView = true;
            spendAnalysisVm.lChartView = false;

            spendAnalysisVm.txnDiv = false;
            spendAnalysisVm.spendDiv = true;
            spendAnalysisVm.spendSpinner = true;
            
            angular.element(document.querySelector('.spendAnalysisTab')).addClass('accountSummaryTabActive font-link-blue');
            angular.element(document.querySelector('.transactionTab')).removeClass('accountSummaryTabActive font-link-blue');
            /*
		  Feedback Author@Siva 
		  */
		  utilityService.setCsatJournies('spendAnalysis');
			
			if(type==="overallweekly"){
				angular.element(document.querySelector('.week_doughnut')).addClass('actOverview-button-selected').removeClass('bg-color-grey');
            angular.element(document.querySelector('.month_doughnut')).removeClass('actOverview-button-selected').addClass('bg-color-grey');
            angular.element(document.querySelector('.quarter_doughnut')).removeClass('actOverview-button-selected').addClass('bg-color-grey');
			}else if(type==="overallmonthly"){
			angular.element(document.querySelector('.week_doughnut')).removeClass('actOverview-button-selected').addClass('bg-color-grey');
            angular.element(document.querySelector('.month_doughnut')).addClass('actOverview-button-selected').removeClass('bg-color-grey');
            angular.element(document.querySelector('.quarter_doughnut')).removeClass('actOverview-button-selected').addClass('bg-color-grey');
			}else if(type==="overallquarterly"){
				angular.element(document.querySelector('.week_doughnut')).removeClass('actOverview-button-selected').addClass('bg-color-grey');
            angular.element(document.querySelector('.month_doughnut')).removeClass('actOverview-button-selected').addClass('bg-color-grey');
            angular.element(document.querySelector('.quarter_doughnut')).addClass('actOverview-button-selected').removeClass('bg-color-grey');
			}
			
           // spendAnalysisVm.lineChartView(accountNumber,period,type);
             spendAnalysisService.getSpendAnalysis(accountNumber,type).then(function(response) {     
                //if (!utilityService.isUndefined(response.graphDetails)){
					
                    spendAnalysisVm.spendAnalysisData = response.graphDetails;
                  
                     // }
                if (!utilityService.isUndefined(response.totalAmount)){
                    spendAnalysisVm.spendAnalysisTotalAmount = response.totalAmount;
                      }
                var grapLable = [];
                var grapAmount = [];
                var grapPercentage = [];
                var grapColor = [];
                angular.forEach(response.graphDetails, function(value, key) {
                    grapAmount.push(value.amount);
                    grapLable.push(value.tagName);
                    grapPercentage.push(value.percentage);
                    grapColor.push(value.color);
                });
		
                var pieGraphData = {
                    grapLable: grapLable,
                    grapAmount: grapAmount,
                    grapPercentage: grapPercentage,
                    grapColor: grapColor
                }
				
				spendAnalysisVm.dChart();
				spendAnalysisVm.spendSpinner=false;
          //      spendAnalysisVm.doughnutChartView(pieGraphData);
            }, function(error) {
		spendAnalysisVm.spendSpinner=false;
            });
        } 

        spendAnalysisVm.weekData = function(accountNumber,type) {
			var accountNumber=accountNumber;
			accountNumber=accountNumber.split(",");
			accountNumber=accountNumber[0];
			
		spendAnalysisVm.defaultLineChart='Weekly';
            angular.element(document.querySelector('.week')).addClass('actOverview-button-selected').removeClass('bg-color-grey');
            angular.element(document.querySelector('.month')).removeClass('actOverview-button-selected').addClass('bg-color-grey');
            angular.element(document.querySelector('.quarter')).removeClass('actOverview-button-selected').addClass('bg-color-grey');
           // spendAnalysisVm.lineChartView(accountNumber,period,type);
            spendAnalysisVm.lineChartView(accountNumber,type,getAccountDetailsService.transactionTag);
        }

        spendAnalysisVm.monthData = function(accountNumber,type) {
			var accountNumber=accountNumber;
			accountNumber=accountNumber.split(",");
			accountNumber=accountNumber[0];
			spendAnalysisVm.defaultLineChart='Monthly';

            angular.element(document.querySelector('.week')).removeClass('actOverview-button-selected').addClass('bg-color-grey');
            angular.element(document.querySelector('.month')).addClass('actOverview-button-selected').removeClass('bg-color-grey');
            angular.element(document.querySelector('.quarter')).removeClass('actOverview-button-selected').addClass('bg-color-grey');
            spendAnalysisVm.lineChartView(accountNumber,type,getAccountDetailsService.transactionTag);
        }

        spendAnalysisVm.quarterData = function(accountNumber,type) {
			var accountNumber=accountNumber;
			accountNumber=accountNumber.split(",");
			accountNumber=accountNumber[0];
	spendAnalysisVm.defaultLineChart='Quarterly';
            angular.element(document.querySelector('.week')).removeClass('actOverview-button-selected').addClass('bg-color-grey');
            angular.element(document.querySelector('.month')).removeClass('actOverview-button-selected').addClass('bg-color-grey');
            angular.element(document.querySelector('.quarter')).addClass('actOverview-button-selected').removeClass('bg-color-grey');
           spendAnalysisVm.lineChartView(accountNumber,type,getAccountDetailsService.transactionTag);
        }


        spendAnalysisVm.lineChartView = function(accNo, period, transactionTag) {
			
			spendAnalysisVm.chartDisplay=false;
			getAccountDetailsService.transactionTag=transactionTag;

            getAccountDetailsService.getLineGraph(accNo, spendAnalysisVm.defaultLineChart, transactionTag).then(function(lineGraphData) {                
                
              
			
			         var dataLabels = [];
			         var dataAmount = [];
         var scaleSteps= (lineGraphData.grapAmount.length+0);  
for( var i = 0; i< lineGraphData.grapLable.length; i++){    
    if(dataLabels.indexOf(lineGraphData.grapLable[i]) === -1){
       if(lineGraphData.grapLable[i]!=null && lineGraphData.grapLable[i]!=''){
    	dataLabels.push(lineGraphData.grapLable[i]);  
    	dataAmount.push(lineGraphData.grapAmount[i]);  
    }
    }        
}
			
lineGraphData.grapLable	=dataLabels;
lineGraphData.grapAmount=dataAmount;		
                var lineChartData = {
    //labels: ["Jan 2016", "Data 2016", "Data 2016", "Data 2016", "Data 2016", "Data 2016", "Data 2016"],
    labels:lineGraphData.grapLable,
    datasets: [{
        fillColor: "rgba(220,220,220,0)",
        strokeColor: "#0095da",
        pointColor: "#0095da",
        //data: ["600", "3000", "7000", "2000", "4000", "1000", "6000"],
        data: lineGraphData.grapAmount,
        
        
    }],
}

ChartNewObject.defaults.global.animationSteps = 30;
ChartNewObject.defaults.global.tooltipYPadding = 8;
ChartNewObject.defaults.global.tooltipCornerRadius = 0;
ChartNewObject.defaults.global.tooltipTitleFontStyle = "normal";
ChartNewObject.defaults.global.tooltipFillColor = "rgba(0,160,0,0.8)";
ChartNewObject.defaults.global.animationEasing = "easeOutBounce";
ChartNewObject.defaults.global.responsive = true;
ChartNewObject.defaults.global.scaleLineColor = "#bebcbf";
ChartNewObject.defaults.global.scaleFontSize = 14;
var ctx = document.getElementById('lineChart').getContext('2d');
var LineChartDemo = new ChartNewObject(ctx).Line(lineChartData, {
    pointDotRadius: 3,
    bezierCurve: false,
    scaleShowVerticalLines: true,
    scaleGridLineColor: "#e3e4e4",
    scaleShowLabels :true,
    showTooltips:false,
    scaleOverride : true,
    datasetStrokeWidth:1,
          scaleSteps : scaleSteps,//noof steps
          scaleStepWidth : lineGraphData.stepSize,//stepsize
          scaleStartValue : lineGraphData.min,//min
    onAnimationComplete: function () {

        var ctx = this.chart.ctx;
        ctx.font = this.scale.font;
        ctx.fillStyle = this.scale.textColor
        ctx.textAlign = "center";
        ctx.textBaseline = "bottom";

        this.datasets.forEach(function (dataset) {
            dataset.points.forEach(function (points) {
            var coordinateData = "\u20B9\u0020"+ points.value.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
                ctx.fillText(coordinateData, points.x+33, points.y +5);
            });
        })
        
        
        
    }
});
               
            }, function(error) {

            });
        }

        spendAnalysisVm.transaction = function() {
            $state.go('menu.transaction');
        }
        

        spendAnalysisVm.getLineChartView = function(accountNumber,period,type) {
            spendAnalysisVm.dChartView = false;
            
            spendAnalysisVm.lChartView = true;
			var accountNumber=accountNumber;
			var accountNumber=accountNumber.split(",");
			accountNumber=accountNumber[0];
            spendAnalysisVm.lineChartView(accountNumber,period,type);
        }
        
        spendAnalysisVm.dChart = function() {
		
            spendAnalysisVm.chartDisplay=true;
           /* 
            angular.element(document.querySelector('.week_doughnut')).removeClass('actOverview-button-selected').removeClass('bg-color-grey');
            angular.element(document.querySelector('.month_doughnut')).addClass('actOverview-button-selected').removeClass('bg-color-grey');
            angular.element(document.querySelector('.quarter_doughnut')).removeClass('actOverview-button-selected').removeClass('bg-color-grey');
         */
            
                    ChartNewObject.types.Doughnut.extend({
    name: "doughnutAlt",
    draw: function() {
      ChartNewObject.types.Doughnut.prototype.draw.apply(this, arguments);
      
     // var x=151.49780082176608;
     //var y=4.501619661970295;
	 
     var x=0;
     var y=0;
     var segmentsLength = this.segments.length;
      for (var i = 0; i < segmentsLength; i++) {
       // var centerAngle = this.segments[i].startAngle + ((this.segments[i].endAngle - this.segments[i].startAngle) / 2),
        var centerAngle = (this.segments[i].startAngle + ((this.segments[i].endAngle - this.segments[i].startAngle) / 2))+1,
          rangeFromCenter = ((this.segments[i].outerRadius - this.segments[i].innerRadius) / 2 + this.segments[i].innerRadius)+93;
        
		//rangeFromCenter=170.5;
         // x=x+30;
         // y=y+30;
       // x = this.segments[i].x + (Math.cos(centerAngle) * rangeFromCenter);
       // y = this.segments[i].y + (Math.sin(centerAngle) * rangeFromCenter);
        x = (205 + (Math.cos(centerAngle) * rangeFromCenter));
        y = (150 + (Math.sin(centerAngle) * rangeFromCenter));
        
        
        this.chart.ctx.textAlign = 'center';
        this.chart.ctx.textBaseline = 'middle';
       // this.chart.ctx.fillStyle = '#000';
        this.chart.ctx.fillStyle = '#000000';
        this.chart.ctx.font = '23px Roboto-Regular';
       
		
	
       //this.chart.ctx.fillText('\u0020\u0020'+this.segments[i].value + "%", x, y);
	  
        //this.chart.ctx.fillText('\u0020\u0020'+parseInt(x), x, y);
      }
	
    }
  });

  var chartOptions = {
    onAnimationComplete: function() {
      // Always show Tooltip
      this.showTooltip(this.segments, true);
    },
    customTooltips: function(tooltip) {
      // Tooltip Element
     // var tooltipEl = $('#chartjs-tooltip');
      // Hide if no tooltip
     /* if (!tooltip) {
        tooltipEl.css({
          opacity: 1
        });
        return;
      }*/
      // Set caret Position
     // tooltipEl.removeClass('above below');
      //tooltipEl.addClass(tooltip.yAlign);
     // tooltipEl.addClass(tooltip.xAlign);
      // Set Text
     // tooltipEl.html(tooltip.text);
      // Find Y Location on page
     /* var top;
      if (tooltip.yAlign == 'above') {
        top = tooltip.y - tooltip.caretHeight - tooltip.caretPadding;
      } else {
        top = tooltip.y + tooltip.caretHeight + tooltip.caretPadding;
      }*/
      // Display, position, and set styles for font
     /* tooltipEl.css({
        opacity: 0,
        left: tooltip.chart.canvas.offsetLeft + tooltip.x + 'px',
        top: tooltip.chart.canvas.offsetTop + top + 'px',
        fontFamily: tooltip.fontFamily,
        fontSize: tooltip.fontSize,
        fontStyle: tooltip.fontStyle,
        xOffset: tooltip.xOffset,
      });*/
    },
    tooltipEvents: [], // Remove to enable Default Mouseover events
    tooltipFontFamily: "'Helvetica Neue', 'Helvetica', 'Arial', sans-serif",
    tooltipFillColor: "rgba(0,0,0,0.0)",
    tooltipFontColor: "#505050",
    tooltipFontSize: 34,
    tooltipXOffset: 0,
    tooltipXPadding: 0,
    tooltipYPadding: 0,
    tooltipTemplate: "<%= value %>%",
    legends: true,
    showTooltips: true,
    segmentShowStroke: false,
    percentageInnerCutout: 0,
    animationEasing: "easeInOutQuart",
    legendTemplate: "<ul class=\"<%=name.toLowerCase()%>-legend\"><% for (var i=0; i<segments.length; i++){%><li><span style=\"background-color:<%=segments[i].fillColor%>\"></span><%if(segments[i].label){%><%=segments[i].label%><%}%></li><%}%></ul>"
  }

  
  

 spendAnalysisVm.d=[];

spendAnalysisVm.colors=['#FF6384','#36A2EB','#FFCE56','#000000'];
var i=0;
angular.forEach(spendAnalysisVm.spendAnalysisData, function(value, key){
    //if(key.indexOf('$') != 0)
     // spendAnalysisVm.d.push({ value: value.percentage, color: value.color,label:value.tagName});
//get_random_color()
//spendAnalysisVm.spendAnalysisData.push({color:spendAnalysisVm.colors[i]});
      spendAnalysisVm.d.push({ value: parseInt(value.percentage), color: value.color,label:value.tagName});
	  i++;
      //spendAnalysisVm.d.push({ value: 25, color: get_random_color(),label:value.tagName});
  
  
});

  
  
  
  var data=spendAnalysisVm.d;
  
  spendAnalysisVm.chartRows=data.length;
  
  
          $timeout(function(){
			 // for(var i=1;i<=2;i++){
			  var myDoughnutChart = new ChartNewObject(document.getElementById("doughnutChart").getContext("2d")).doughnutAlt(data, chartOptions);
			  //}
			  },1);  
			
            
            spendAnalysisVm.dChartView = true;
            spendAnalysisVm.lChartView = false;

            spendAnalysisVm.txnDiv = false;
            spendAnalysisVm.spendDiv = true;
            
            angular.element(document.querySelector('.spendAnalysisTab')).addClass('accountSummaryTabActive font-link-blue');
            angular.element(document.querySelector('.transactionTab')).removeClass('accountSummaryTabActive font-link-blue');

        }
			function get_random_color(){
				var letters='0123456789ABCDEF'.split('');
				var color='#';
				for(var i=0;i<6;i++){
					color+=letters[Math.round(Math.random()*15)];
				}
				return color;
			}
        //private methods section start
        function initPage() {
          
        }

        $scope.$on('$ionicView.loaded', function() {
            
            angular.element(document.querySelector('.transactionTab')).addClass('accountSummaryTabActive font-link-blue');
            angular.element(document.querySelector('.spendAnalysisTab')).removeClass('accountSummaryTabActive font-link-blue');
            initPage();

        });

        $scope.$on('$ionicView.beforeEnter', function() {
        
			 angular.element(document.querySelector('.transactionTab')).addClass('accountSummaryTabActive font-link-blue');
            angular.element(document.querySelector('.spendAnalysisTab')).removeClass('accountSummaryTabActive font-link-blue');
			//$timeout(function(){spendAnalysisVm.chartDisplay=true;},50);
            spendAnalysisVm.accno='';
        spendAnalysisVm.type='';
        spendAnalysisVm.amount='';
        spendAnalysisVm.indexId='';
        
        spendAnalysisVm.accno=getAccountDetailsService.accType.accno;
        spendAnalysisVm.type=getAccountDetailsService.accType.type;
        spendAnalysisVm.amount=getAccountDetailsService.accType.amount;
        //spendAnalysisVm.indexId=getAccountDetailsService.accType.indexId;
        spendAnalysisVm.transactionFlag=getAccountDetailsService.accType.transactionFlag;
		
		spendAnalysisVm.accNoDetails=getAccountDetailsService.accType.accno+","+spendAnalysisVm.transactionFlag;
            
         spendAnalysisVm.accountDetails = [];
			var accountDetailsData = getAccountDetailsService.accountOverviewData.accounts;
			var sortBasedOnCurrency = [];
			var selectedCurrency = getAccountDetailsService.currency ;
			for( var i=0; i<accountDetailsData.length ; i++){
				if(accountDetailsData[i].currency === 'INR' && selectedCurrency === 'INR'){
					accountDetailsData[i].viewCurrency = '₹';
					sortBasedOnCurrency.push(accountDetailsData[i]);
				}

				if(accountDetailsData[i].currency !== 'INR' && selectedCurrency !== 'INR'){
					accountDetailsData[i].viewCurrency = accountDetailsData[i].currency;
					sortBasedOnCurrency.push(accountDetailsData[i]);
				}

			}
			
			spendAnalysisVm.accountDetails = sortBasedOnCurrency;
			for(var j=0; j<spendAnalysisVm.accountDetails.length;j++){
				if(spendAnalysisVm.accno === spendAnalysisVm.accountDetails[j].accountNumber){
					spendAnalysisVm.indexId = j;
				}
			}			
			spendAnalysisVm.accountDetailsRows = getAccountDetailsService.accountOverviewData.accounts.length;
			
                spendAnalysisVm.getTransactions(spendAnalysisVm.accNoDetails);
      
        });
		
			

spendAnalysisVm.sendEmail = function(accountNumber){
	
	spendAnalysisVm.mailBtn=false;
	spendAnalysisVm.txnMailSpinner=true;
 var accountNumber=accountNumber;
			spendAnalysisVm.accDetails=accountNumber.split(",");
			spendAnalysisVm.accNo=spendAnalysisVm.accDetails[0];
			spendAnalysisVm.txnFlag=spendAnalysisVm.accDetails[1];
			spendAnalysisVm.accountType=spendAnalysisVm.accDetails[2];
			spendAnalysisVm.branchName=spendAnalysisVm.accDetails[3];
			
			spendAnalysisVm.trxns=[];
			spendAnalysisVm.trxns={ "data": {"transactions": spendAnalysisVm.filObj}};
			
			
	transactionService.sendEmail(spendAnalysisVm.accNo,spendAnalysisVm.txnFlag,spendAnalysisVm.accountType,spendAnalysisVm.branchName,customerInfoService.customer.emailID,JSON.stringify(spendAnalysisVm.trxns),spendAnalysisVm.searchKey).then(function(data){
	var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="">Mail has been sent to your registered email id.</div>';
    			spendAnalysisVm.emailPopup = $ionicPopup.show({
    				title: '',
    				template: template,
    				cssClass: 'my-custom-popup',
    				buttons: [{
    					text:'OK',
    					type: 'button-assertive',
    					onTap: function() { 
    						spendAnalysisVm.emailPopup.close();

    					}
    				}],
    			});
				spendAnalysisVm.mailBtn=true;
	spendAnalysisVm.txnMailSpinner=false;
	
	}, function(error){
	
	spendAnalysisVm.mailBtn=true;
	spendAnalysisVm.txnMailSpinner=false;
	var msg = '<div class="font-size-16 roboto-medium">'+error.responseMessage+'</div>'
	utilityService.showBhimUpiAlert("info", msg, "", "OK", $scope);
	
	});
}

spendAnalysisVm.generatePDF = function(accountNumber){
	
	
	spendAnalysisVm.txnPDFSpinner=true;
	spendAnalysisVm.txnPDFBtn=false;
	
	var accountNumber=accountNumber;
	spendAnalysisVm.accDetails=accountNumber.split(",");
			spendAnalysisVm.accNo=spendAnalysisVm.accDetails[0];
			spendAnalysisVm.txnFlag=spendAnalysisVm.accDetails[1];
			spendAnalysisVm.accountType=spendAnalysisVm.accDetails[2];
			spendAnalysisVm.branchName=spendAnalysisVm.accDetails[3];
			spendAnalysisVm.trxns=[];	
	
			spendAnalysisVm.trxns={ "data": {"transactions": spendAnalysisVm.filObj}};
	
	getAccountDetailsService.generatePDF(spendAnalysisVm.accNo,spendAnalysisVm.txnFlag,spendAnalysisVm.accountType,spendAnalysisVm.branchName,JSON.stringify(spendAnalysisVm.trxns),spendAnalysisVm.searchKey).then(function(data){
		var content = data.data.content;
		var fileName = data.data.fileName + '.pdf';
		var deatils = { accountType:spendAnalysisVm.accountType };

		pwdProtectedPdfDownloadService.savePDF(fileName, content, deatils).then(function(response){
			spendAnalysisVm.txnPDFSpinner = false;
			spendAnalysisVm.txnPDFBtn = true;
			spendAnalysisVm.path = response.folderpath ? response.folderpath : "";
			if(spendAnalysisVm.accountType.includes("Savings") || spendAnalysisVm.accountType.includes("Overdraft")){
				pwdProtectedPdfDownloadService.pwdCommonTemplate();	
			}else{
				if (utilityService.isIOSPlatform()) {
					cordova.plugins.fileOpener2.open(
						cordova.file.documentsDirectory + fileName,
						'application/pdf', {
						error: function (e) {
							console.log('Error status: ' + e.status + ' - Error message: ' + e.message);
						},
						success: function () {
							console.log('file opened successfully');
						}
					});
				}else{
					var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="DOWNLOADFDRECEIPT" translate-values="{folderpath:spendAnalysisVm.path}"></div>';
					spendAnalysisVm.downloadPopup = $ionicPopup.show({
						title: '',
						template: template,
						scope: $scope,
						cssClass: 'my-custom-popup',
						buttons: [{
							text:'OK',
							type: 'button-assertive',
							onTap: function() {
								spendAnalysisVm.downloadPopup.close();
								
							}
						}],
					});
				}
			}
		},function error(e){
			spendAnalysisVm.txnPDFSpinner = false;
			spendAnalysisVm.txnPDFBtn = true;
			utilityService.showErrorMessage(e);
		});
		
	}, function (error) {
		spendAnalysisVm.txnPDFSpinner = false;
		spendAnalysisVm.txnPDFBtn = true;
		var msg = '<div class="font-size-16 roboto-medium">'+error.responseMessage+'</div>'
		utilityService.showBhimUpiAlert("info", msg, "menu.accountOverviewMyBalance", "OK", $scope);
	});
}
function sayHelloSuccess(data){
     /*
      WL.SimpleDialog.show(
      "Response from plug-in", data,
      [{text: "OK", handler: function() {WL.Logger.debug("Ok button pressed");}}]
      );
      */
    }
   function sayHelloFailure(data){
     /*
      WL.SimpleDialog.show(
      "Response from plug-in", data,
      [{text: "OK", handler: function() {WL.Logger.debug("Ok button pressed");}}]
      );
      */
     }

 $timeout(function() {
            var aov = $ionicScrollDelegate.$getByHandle('verticalTXNS').getScrollView();
            var container = aov.__container;
            var originaltouchStart = aov.touchStart;
            var originaltouchMove = aov.touchMove;
            container.removeEventListener('touchstart', aov.touchStart);
            document.removeEventListener('touchmove', aov.touchMove);
            aov.touchStart = function(e) {
                e.preventDefault = function() {}
                originaltouchStart.apply(aov, [e]);
            }
            aov.touchMove = function(e) {
                e.preventDefault = function() {}
                originaltouchMove.apply(aov, [e]);
            }
            container.addEventListener("touchstart", aov.touchStart, false);
            document.addEventListener("touchmove", aov.touchMove, false);
        });
		
		
		  spendAnalysisVm.txnDisplay = function() {
            spendAnalysisVm.txnDiv = true;
            spendAnalysisVm.spendDiv = false;
            spendAnalysisVm.chartDisplay = false;
            angular.element(document.querySelector('.transactionTab')).addClass('accountSummaryTabActive font-link-blue');
            angular.element(document.querySelector('.spendAnalysisTab')).removeClass('accountSummaryTabActive font-link-blue');
			
			angular.element(document.querySelector('.week')).removeClass('actOverview-button-selected').addClass('bg-color-grey');
			angular.element(document.querySelector('.month')).addClass('actOverview-button-selected').removeClass('bg-color-grey');
			angular.element(document.querySelector('.quarter')).removeClass('actOverview-button-selected').addClass('bg-color-grey');

        }
		   spendAnalysisVm.filterFn = function(date) {
	var Searchdate = '';
	//replace some unnecessary keywords
	if (angular.isDefined(spendAnalysisVm.searchKey)
			&& spendAnalysisVm.searchKey != '') {
		if (date.date.toLowerCase().indexOf(
				spendAnalysisVm.searchKey.toLowerCase()) != -1
				|| date.comments.toLowerCase().indexOf(
						spendAnalysisVm.searchKey.toLowerCase()) != -1
				|| date.paidAmount.indexOf(spendAnalysisVm.searchKey) != -1
				|| date.type.indexOf(spendAnalysisVm.searchKey) != -1) {
			return true;
		} else {
			Searchdate = spendAnalysisVm.searchKey.toLowerCase().replace(
					'from', '').replace('between', '').replace('till', 'to')
					.replace('and', 'to').replace(' - ', 'to').replace(' : ',
							'to');
		}
	} else if (angular.isDefined(spendAnalysisVm.searchKey)
			&& spendAnalysisVm.searchKey == '') {
		return true;
	} else {
		return true;
	}
	if (angular.isUndefined(spendAnalysisVm.searchKey) || Searchdate.indexOf('to') == -1) {
		//if date fromate has only year or only date formate or it has only tag
		if (Searchdate.indexOf('#') != -1) {
			var removedHashTag = Searchdate.replace('#', '');
			if (date.tagName.indexOf(removedHashTag) != -1) {
				return true;
			} else {
				return false
			}
		}
		//find out if there is only year is there.
		var pattern = /^\d{4}$/;
		if (pattern.test(Searchdate)) {
			if (new Date(date.date).getFullYear() == Searchdate) {
				return true;
			} else {
				return false;
			}
		}
		//get the curent month and year for checking the at last
		var month = new Date().getMonth(), year = new Date().getFullYear(),
		//replace all the charater to / for both the date
		fromDate = Searchdate.replace(/-/g, '/').replace(/\./g, '/').replace(
				/(\d+)(st|nd|rd|th)/, "$1"), fromDateFormat = new Date(fromDate), monthNames = [
				"january", "february", "march", "april", "may", "june", "july",
				"august", "september", "october", "november", "december" ], monthnames = [
				"jan", "feb", "mar", "apr", "may", "jun", "jul", "aug", "sep",
				"oct", "nov", "dec" ];

		if (fromDateFormat == 'Invalid Date') {
			//check if there is dd-mm-yy formate
			if (fromDate.indexOf('/') != -1) {
				var temp = fromDate.split('/');
				fromDate = '';
				if (angular.isDefined(temp[1])) {
					if (temp[1] <= 11) {
						fromDate += monthnames[temp[1] - 1];
						fromDate += ' ';
					} else {
						fromDate += temp[1];
						fromDate += ' ';
					}
				}
				if (angular.isDefined(temp[0])) {
					if (temp[1] <= 11) {
						fromDate = temp[0] + ' ' + fromDate;
					} else {
						fromDate += monthnames[temp[0] - 1];
						fromDate += ' ';
					}
					//  fromDate += ' ';
				}
				if (angular.isDefined(temp[2])) {
					fromDate += temp[2];
				} else {
					if (angular.isDefined(temp[1]) && temp[1] > month + 1) {
						fromDate += (year - 1);
					}
					if (angular.isDefined(temp[1]) && temp[1] <= month + 1) {
						fromDate += (year);
					}
				}
				fromDateFormat = new Date(fromDate);
			}
			// check if there is only month name is there or not
			if (fromDateFormat == 'Invalid Date') {
				if ((monthNames.indexOf(fromDate.toLowerCase()) != -1 && monthNames
						.indexOf(fromDate.toLowerCase()) > month)
						|| monthnames.indexOf(fromDate.toLowerCase()) != -1
						&& monthnames.indexOf(fromDate.toLowerCase()) > month) {
					fromDate += (year - 1);
				} else {
					fromDate += (year);
				}
				fromDateFormat = new Date(fromDate);
			}
		}
		//if invalid date or there is no year in date 2001 is for the checking the default yeaer and if there is no 2001 in search box
		if (fromDateFormat.getFullYear() == 2001
				&& Searchdate[0].indexOf('2001') == -1) {
			// if month is greatether then current month then less one year
			if (fromDateFormat.getMonth() > month) {
				fromDateFormat.setFullYear(year - 1);
			} else {
				fromDateFormat.setFullYear(year);
			}
		}
		if (fromDateFormat == 'Invalid Date') {
			// return true;
		} else {
			// if only date is there then retur
			if (fromDateFormat.getTime() === new Date(date.date).getTime()) {
				return true;
			} else {
				return false;
			}
		}
		// return true;
	} else {
		var monthNames = [ "january", "february", "march", "april", "may",
				"june", "july", "august", "september", "october", "november",
				"december" ], monthnames = [ "jan", "feb", "mar", "apr", "may",
				"jun", "jul", "aug", "sep", "oct", "nov", "dec" ];
		// split the form date and to date for comparision
		Searchdate = Searchdate.split(' to ');
		if (angular.isUndefined(Searchdate[0])
				|| angular.isUndefined(Searchdate[1])) {
			return true;
		}
		// get the month
		var month = new Date().getMonth(), year = new Date().getFullYear();
		var fromDate = Searchdate[0].replace(/-/g, '/').replace(/\./g, '/')
				.replace(/(\d+)(st|nd|rd|th)/, "$1"), toDate = Searchdate[1]
				.replace(/-/g, '/').replace(/\./g, '/').replace(
						/(\d+)(st|nd|rd|th)/, "$1");
		// if only ther is today in today
		if (toDate.toLowerCase() == 'today') {
			toDate = new Date();
		}
		var fromDateFormat = new Date(fromDate), toDateFormat = new Date(toDate);
		// if dd/mm/yy then set it to mm/dd/yy
		if (fromDateFormat == 'Invalid Date') {
			if (fromDate.indexOf('/') != -1) {
				var temp = fromDate.split('/');
				fromDate = '';
				if (angular.isDefined(temp[1])) {
					if (temp[1] <= 11) {
						fromDate += monthnames[temp[1] - 1];
						fromDate += ' ';
					} else {
						fromDate += temp[1];
						fromDate += ' ';
					}
				}
				if (angular.isDefined(temp[0])) {
					if (temp[1] <= 11) {
						fromDate = temp[0] + ' ' + fromDate;
					} else {
						fromDate += monthnames[temp[0] - 1];
						fromDate += ' ';
					}
					/*  fromDate += monthnames[temp[0] - 1];
					  fromDate += ' '; */
				}
				if (angular.isDefined(temp[2])) {
					fromDate += temp[2];
				} else {
					if (angular.isDefined(temp[1]) && temp[1] > month + 1) {
						fromDate += (year - 1);
					}
					if (angular.isDefined(temp[1]) && temp[1] <= month + 1) {
						fromDate += (year);
					}
				}
				fromDateFormat = new Date(fromDate);
			}
			// if only month is there then set the year
			if (fromDateFormat == 'Invalid Date') {
				if ((monthNames.indexOf(fromDate.toLowerCase()) != -1 && monthNames
						.indexOf(fromDate.toLowerCase()) > month)
						|| monthnames.indexOf(fromDate.toLowerCase()) != -1
						&& monthnames.indexOf(fromDate.toLowerCase()) > month) {
					fromDate += (year - 1);
				} else {
					fromDate += (year);
				}
				fromDateFormat = new Date(fromDate);
			}
		}
		// if dd/mm/yy formate change it to mm/dd/yy
		if (toDateFormat == 'Invalid Date') {
			if (toDate.indexOf('/') != -1) {
				var temp = toDate.split('/');
				toDate = '';
				if (angular.isDefined(temp[1])) {
					if (temp[1] <= 11) {
						toDate += monthnames[temp[1] - 1];
						toDate += ' ';
					} else {
						toDate += temp[1];
						toDate += ' ';
					}
				}
				if (angular.isDefined(temp[0])) {
					if (temp[1] <= 11) {
						toDate = temp[0] + ' ' + toDate;
					} else {
						toDate += monthnames[temp[0] - 1];
						toDate += ' ';
					}
					/*  toDate += monthnames[temp[0] - 1];
					  toDate += ' '; */
				}
				if (angular.isDefined(temp[2])) {
					toDate += temp[2];
				} else {
					if (angular.isDefined(temp[1]) && temp[1] > month + 1) {
						toDate += (year - 1);
					}
					if (angular.isDefined(temp[1]) && temp[1] <= month + 1) {
						toDate += (year);
					}
				}
				toDateFormat = new Date(toDate);
			}
			if (fromDateFormat == 'Invalid Date') {
				if ((monthNames.indexOf(toDate.toLowerCase()) != -1 && monthNames
						.indexOf(toDate.toLowerCase()) > month)
						|| monthnames.indexOf(toDate.toLowerCase()) != -1
						&& monthnames.indexOf(toDate.toLowerCase()) > month) {
					toDate += (year - 1);
				} else {
					toDate += (year);
				}
				toDateFormat = new Date(toDate);
			}
		}
		//for anglar js 2001 is default year
		if (fromDateFormat.getFullYear() == 2001 && Searchdate[0].indexOf('2001') == -1) {
			if (fromDateFormat.getMonth() > month) {
				fromDateFormat.setFullYear(year - 1);
			} else {
				fromDateFormat.setFullYear(year);
			}
		}
		// set the year if not set by user
		if (toDateFormat.getFullYear() == 2001 && Searchdate[1].indexOf('2001') == -1) {
			if (toDateFormat.getMonth() > month) {
				toDateFormat.setFullYear(year - 1);
			} else {
				toDateFormat.setFullYear(year);
			}
		}

		// If date matches its return true
		if (fromDateFormat == 'Invalid Date' || toDateFormat == 'Invalid Date') {
			//return true;
		} else {
			if (fromDateFormat <= new Date(date.date)
					&& new Date(date.date) <= toDateFormat) {
				return true;
			} else {
				return false;
			}
		}

                //return true;
            }
			
			
        };
		
		spendAnalysisVm.goBack=function(){
			$state.go('menu.accountOverviewMyBalance');
		}
 $scope.$on('$ionicView.afterEnter', function() {


            //any cleanup needs to be done here: executes everytime when page is left
            
        });
        //actions to done everytime the view is hidden
        $scope.$on('$ionicView.afterLeave', function() {

			spendAnalysisVm.spendDiv = false;
			spendAnalysisVm.txnDiv = true;
			angular.element(document.querySelector('.transactionTab')).addClass('accountSummaryTabActive font-link-blue');
			angular.element(document.querySelector('.spendAnalysisTab')).removeClass('accountSummaryTabActive font-link-blue');
			angular.element(document.querySelector('.week')).removeClass('actOverview-button-selected').addClass('bg-color-grey');
			angular.element(document.querySelector('.month')).addClass('actOverview-button-selected').removeClass('bg-color-grey');
			
			angular.element(document.querySelector('.quarter')).removeClass('actOverview-button-selected').addClass('bg-color-grey');
			//any cleanup needs to be done here: executes everytime when page is left

		});
		return this;
	}
]);