angularApp.service('transactionService',
	function($q,utilityService,AdapterUtils,constantConfig,secKeyValidationServices){
		var transactionimg = "img/Transactions.png";
		var downloadimg = "img/TransactionDownload.PNG";
								
	var getTransactions = function(accountNumber,transactionFlag) {
					
				var q = $q.defer();
				var obj={
					"accountNumber": accountNumber,
					"transactionFlag":transactionFlag
				};
			AdapterUtils.postData("adapters/AccountOverViewAdapter/getTransactions",obj,false).then(
				function(response){	
                
					q.resolve(response.data);
				},
				function(error){	
				
					q.reject(error);
				}
				); 
			return q.promise;
			
		};						
		var createTag=function(accountNo,tid,tag){
			
			var q = $q.defer();
				var obj={
					"accountNumber": accountNo,
					"transactionId": tid,
					"tagName": tag
				};
			AdapterUtils.postData("adapters/AccountOverViewAdapter/createTag",obj,false).then(
				function(response){	

					q.resolve(response.data);
				},
				function(error){	
					q.reject(error);
				}
				); 
			return q.promise;

		}	
		
		var sendEmail=function(accountNo,transactionFlag,accountType,branchName,emailId,transactionObj,searchString){
			var requestSecKey = secKeyValidationServices.generatesRandomNums();
			var q = $q.defer();
				var obj={
					"accountNumber": accountNo,
					"transactionFlag":transactionFlag,
					"accountType": accountType,
					"branchName":branchName,
					"emailId":emailId,
					"transactionObj":transactionObj,
					"searchString":searchString,
					"secKey":requestSecKey
				};
				
			AdapterUtils.postData("adapters/AccountOverViewAdapter/sendEmail",obj,false).then(
				function(response){	
					var finalcalculatedKey = secKeyValidationServices.verifySecKey(parseInt(response.secKey));
					if(requestSecKey === finalcalculatedKey){
						q.resolve(response);
					}else{
						q.reject({responseMessage:constantConfig.secKeyErrors.technicalError});
					}
				},
				function(error){	
					q.reject(error);
				}
				); 
			return q.promise;

		} 

		return {
		getTransactions:getTransactions,	
		createTag:createTag,
		sendEmail:sendEmail
		}

});

