'use strict';

angularApp.controller('bQRCodeController', [
	"$state",
	"$scope",
	"$ionicPopup",
	"$cordovaBarcodeScanner",
	"cameraService",
	"utilityService",
	"fTBeneficiaryService",
	"$rootScope",
	"cryptoService",
	"constantConfig",
	"bQRService",

	function ($state,
		$scope,
		$ionicPopup,
		$cordovaBarcodeScanner,
		cameraService,
		utilityService,
		fTBeneficiaryService,
		$rootScope,
		cryptoService,
		constantConfig,
		bQRService) {

		var bQRCodeVm = this;
		bQRCodeVm.scannedImage = "img/FT/PayQRCode.svg";
		bQRCodeVm.headerImage = "img/bharatQR/Bharat_QR.svg";
		
		//Toggle QR
		bQRCodeVm.classForPayQR = 'tab-item border-left tabs-style div-bottom bor-bot-active';
		bQRCodeVm.classForMyQR = 'tab-item border-left tabs-style div-bottom';

		bQRCodeVm.PayQRFlag = true;
		bQRCodeVm.MyQRFlag = false;
		bQRCodeVm.toggleLoginMenu = function (qrOption) {
			if (qrOption === 'Pay') {
				bQRCodeVm.PayQRFlag = true;
				bQRCodeVm.MyQRFlag = false;
				bQRCodeVm.classForPayQR = 'tab-item border-left tabs-style div-bottom bor-bot-active';
				bQRCodeVm.classForMyQR = 'tab-item border-left tabs-style div-bottom';
			}
			if (qrOption === 'My') {
				bQRCodeVm.PayQRFlag = false;
				bQRCodeVm.MyQRFlag = true;
				bQRCodeVm.classForPayQR = 'tab-item border-left tabs-style div-bottom';
				bQRCodeVm.classForMyQR = 'tab-item border-left tabs-style div-bottom bor-bot-active';
			}
		};
		
			//Scan the QR Code
			bQRCodeVm.goToQRCodeDetails = function () {
				$cordovaBarcodeScanner.scan().then(function (barcodeData) {
							console.log("barCode",barcodeData.text)
						bQRService.getQRCode(barcodeData.text).then(function(data) {
							bQRService.merchantDetails.version = data.version;
							bQRService.merchantDetails.mobileNum = data.mobileNumber;
							bQRService.merchantDetails.qrType = data.qrType;
							bQRService.merchantDetails.merchantName = data.merchantName;
							bQRService.merchantDetails.purpose = data.purpose;
							bQRService.merchantDetails.terminalId = data.terminalId;
							bQRService.merchantDetails.referenceId = data.referenceId;
							bQRService.merchantDetails.loyaltyNumber = data.loyaltyNumber;
							bQRService.merchantDetails.storeId = data.storeId;
							bQRService.merchantDetails.billNumber = data.billNumber;
							bQRService.merchantDetails.merchantCity = data.merchantCity;
							bQRService.merchantDetails.convenienceFeeFixed = data.convenienceFeeFixed;
							bQRService.merchantDetails.transactionAmount = data.transactionAmount;
							bQRService.merchantDetails.customerId = data.customerId;
							bQRService.merchantDetails.rupayRid = data.rupayRid;
							bQRService.merchantDetails.virtualPaymentAddress = data.virtualPaymentAddress;
							$state.go("menu.scanPay");
							bQRService.merchantDetails.redirectType = "fundsTransfer";		
						},function(error) {
							utilityService.showErrorMessage(error.responseMessage);
						});
					
			}, function (error) {
							console.log("barCodeerror",error)
						utilityService.showErrorMessage(error.responseMessage);
			});
		};
		
		//Select the QR Code from gallery
		bQRCodeVm.selectImagefromGallery = function () {
			cameraService.getImageFromGallery().then(function (imageData) {
				//try {
					bQRCodeVm.scannedImage = imageData;
					qrcode.decode(imageData);
					qrcode.callback = function (decodedData) {
						bQRService.getQRCode(decodedData).then(function(data) {
							console.log("decodedData",data)

							bQRService.merchantDetails.version = data.version;
							bQRService.merchantDetails.mobileNum = data.mobileNumber;
							bQRService.merchantDetails.qrType = data.qrType;
							bQRService.merchantDetails.merchantName = data.merchantName;
							bQRService.merchantDetails.purpose = data.purpose;
							bQRService.merchantDetails.terminalId = data.terminalId;
							bQRService.merchantDetails.referenceId = data.referenceId;
							bQRService.merchantDetails.loyaltyNumber = data.loyaltyNumber;
							bQRService.merchantDetails.storeId = data.storeId;
							bQRService.merchantDetails.billNumber = data.billNumber;
							bQRService.merchantDetails.merchantCity = data.merchantCity;
							bQRService.merchantDetails.convenienceFeeFixed = data.convenienceFeeFixed;
							bQRService.merchantDetails.transactionAmount = data.transactionAmount;
							bQRService.merchantDetails.customerId = data.customerId;
							bQRService.merchantDetails.rupayRid = data.rupayRid;
							bQRService.merchantDetails.virtualPaymentAddress = data.virtualPaymentAddress;
							
							$state.go("menu.scanPay");
							bQRService.merchantDetails.redirectType = "fundsTransfer";

						},function(error) {
								console.log("barCodeerror",error)
							utilityService.showErrorMessage(error.responseMessage);
						});
					}
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		};
		
		 //Close and Navigate to Funds Transfer Home
		$scope.goToHome = function () {
			$state.go('menu.fundsTransfer');
		}                                                                                    		

		$scope.$on('$ionicView.beforeEnter', function () {
			
		});
		
		return this;
	}]);