/**
 *   @ngdoc config
 *   @name angularApp.config : bQRConfig
 *   @description
 *  configuration file for bharat QR module
 */

/*This function defines all the constants named  Adapters url for bharat QR module*/
angularApp
    /*State defination with respective names, urls, controllers and templates */
    .config([
        '$stateProvider',
        function ($stateProvider) {
            //Cards start
            $stateProvider
                .state('menu.scanPay2', {
                    url: '/scanPay',
                    data: {
                        pageId: 'BQ_SCANPAY'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/bharatQR/scanPay/scanPay.html',
                            controller: 'scanPayController',
                            controllerAs: 'scanPayVm'
                        }
                    }
                })
                 .state('menu.bQRCode', {
                    url: '/bQRCode',
                    data: {
                        pageId: 'BQ_QRCODE'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/bharatQR/bQRCode/bQRCode.html',
                            controller: 'bQRCodeController',
                            controllerAs: 'bQRCodeVm'
                        }
                    }
                })
                .state('menu.ftPayment2', {
                    url: '/ftPayment',
                    data: {
                        pageId: 'BQ_FTPAYMENT'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/bharatQR/ftPayment/ftPayment.html',
                            controller: 'ftPaymentController',
                            controllerAs: 'ftPaymentVm'
                        }
                    }
                })
                .state('menu.reviewPayment2', {
                    url: '/reviewPayment',
                    data: {
                        pageId: 'BQ_REVIEWPAYMENT'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/bharatQR/reviewPayment/reviewPayment.html',
                            controller: 'reviewPaymentController',
                            controllerAs: 'reviewPaymentVm'
                        }
                    }
                })
                .state('menu.bqrOtp', {
                    url: '/bqrOtp',
                    data: {
                        pageId: 'BQ_OTP'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/bharatQR/bqrOtp/bqrOtp.html',
                            controller: 'bqrOtpController',
                            controllerAs: 'bqrOtpVm'
                        }
                    }
                })
                .state('menu.bqrUpi', {
                    url: '/bqrUpi',
                    data: {
                        pageId: 'BQ_UPI'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/bharatQR/bqrUpi/bqrUpi.html',
                            controller: 'bqrUpiController',
                            controllerAs: 'bqrUpiVm'
                        }
                    }
                })
                .state('menu.scanQRCode', {
                    url: '/scanQRCode',
                    data: {
                        pageId: 'BQ_SCANQRCODE'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/bharatQR/scanQRCode/scanQRCode.html',
                            controller: 'scanQRCodeController',
                            controllerAs: 'scanQRCodeVm'
                        }
                    }
                })
                .state('menu.bqrLogin', {
                    url: '/bqrLogin',
                    data: {
                        pageId: 'BQ_LOGIN'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/bharatQR/bqrLogin/bqrLogin.html',
                            controller: 'bqrLoginController',
                            controllerAs: 'bqrLoginVm'
                        }
                    }
                })
        }
    ]);
