angularApp.service('bQRService',
	function ($q, AdapterUtils, $ionicPopup) {
		var bQRService = this;

		bQRService.accountDetails = [];
		bQRService.accountDetailsSelected = [];
		bQRService.accountUserSelected = [];
		bQRService.accountUserSelectedMain = [];
		bQRService.normalBharatTnC = "";
		
		bQRService.selectedDetails = {
			accountNumber: '',
			accountBalance: '',
			accountType: '',
			branchCode: '',
			branchName: '',
			productCode: ''
		};

		bQRService.merchantDetails = {
			version:'',
			mobileNumber:'',
			qrType:'',
			merchantName :'',	
			purpose:'',
			terminalId:'',
			referenceId:'',
			loyaltyNumber:'',
			storeId:'',
			billNumber:'',
			merchantCity:'',
			convenienceFeeFixed:'',
			convenienceFeeFixedIfNull:'',
			convenienceFeePercentage:'',
			transactionAmount:'',
			transactionAmountIfNull:'',
			customerId:'',
			consumerId:'',
			aadharNumber:'',
			upiVpaReference:'',
			rupayRid:'',
			redirectType:'',
			virtualPaymentAddress:''

		};

		bQRService.selectedVpaDetails = {
			remarks:'',
			vpaName:'',
			selectedValue:'',
			accountSelected:'',
			availBalance:'',
			accountIdSelected:'',
			cardSelectedType:'',
			selectedVPAAccount:'',
			selectedVPAAccountDetails:'',
			bankCode:''
		};

		//bharatQR pay flow
		bQRService.payByCard = {
			payByCardObj : '',
			accountDetails : '',
			cardList : '',
			accountList : '',
			availBalance:'',
			merchantName :'',	
			transactionAmount:'',
			loyaltyNumber:'',
			convenienceFeeFixed:'',
			convenienceFeeFixed:'',
		}

		bQRService.initialValueStage = function() {
			bQRService.selectedDetails = {
				accountNumber: '',
				accountBalance: '',
				accountType: '',
				branchCode: '',
				branchName: '',
				productCode: ''
			};

			bQRService.merchantDetails = {
				version:'',
				mobileNumber:'',
				qrType:'',
				merchantName :'',	
				purpose:'',
				terminalId:'',
				referenceId:'',
				loyaltyNumber:'',
				storeId:'',
				billNumber:'',
				merchantCity:'',
				convenienceFeeFixed:'',
				convenienceFeeFixedIfNull:'',
				convenienceFeePercentage:'',
				transactionAmount:'',
				transactionAmountIfNull:'',
				customerId:'',
				consumerId:'',
				aadharNumber:'',
				upiVpaReference:'',
				rupayRid:'',
				redirectType:'',
				virtualPaymentAddress:''
			};

			bQRService.selectedVpaDetails = {
				remarks:'',
				vpaName:'',
				selectedValue:'',
				accountSelected:'',
				availBalance:'',
				accountIdSelected:'',
				cardSelectedType:'',
				selectedVPAAccount:'',
				selectedVPAAccountDetails:'',
				bankCode:''
			};
			
			bQRService.payByCard = {
				payByCardObj : '',
				accountDetails : '',
				cardList : '',
				accountList : '',
				availBalance:'',
				merchantName :'',	
				transactionAmount:'',
				loyaltyNumber:'',
				convenienceFeeFixed:'',
				convenienceFeeFixed:'',
			}
		}

		bQRService.getQRCode = function (scan_qr) {
			var q = $q.defer();
			var obj = {
				"scanQRCode": scan_qr
			};
			AdapterUtils.postData("adapters/FundsTransferAdapter/getQRCode", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		bQRService.processPayment = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FundsTransferAdapter/getProcessPayment", {}, true).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		bQRService.fetchRtermcondition = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/getTnC", obj, true).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		bQRService.requestOtp = function(obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/OTPAdapter/getOTPTokenSecure",obj, true).then(
				function(response){	

					q.resolve(response.data);
				},
				function(error){	
					q.reject(error);
				}
				); 
			return q.promise;
		};


		bQRService.validateOtp = function(obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/OTPAdapter/validateOTPTokenSecure",obj, true).then(
				function(response){	

					q.resolve(response.data);
				},
				function(error){	
					q.reject(error);
				}
				); 
			return q.promise;
		};

		bQRService.accountFilter = function() {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FundsTransferAdapter/accountFilterRequest",{},true).then(
				function(response){	

					q.resolve(response.data);
				},
				function(error){	
					q.reject(error);
				}
				); 
			return q.promise;
		};

		bQRService.viewDebitCards = function (acc_num) {
			var q = $q.defer();
			var obj = {
				"accountNumber": acc_num
			};
			AdapterUtils.postData("adapters/FundsTransferAdapter/viewDebitCards", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		bQRService.showAlertModal = function (title, template, onTapgo, $scope, $state) {
			var alertPopup = $ionicPopup.show({
				title: title,
				template: template,
				scope: $scope,
				cssClass: 'my-custom-popup',
				buttons: [{
					text: 'OK',
					type: 'button-assertive',
					onTap: function () {
						if (onTapgo !== '' && onTapgo !== null) {
							$state.go(onTapgo);
						}
					}
				}],
			});
		}

		bQRService.showTnCAlertModal = function (heading,message,onTapgo,cssClass,buttonText,callBack) {
			var alertPopup = $ionicPopup.alert({
            title: heading,
            template: '<div class="popupTextBottomPadding ss-p-r-f-8 ss-popup-list font-size-12 font-light ss-text-color">'
            + message + '</div></div>',
            cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite ss-popup' + cssClass,
            buttons: [
					{
						text: buttonText || "OK",
						onTap: function(e) {
							//callBack();
						}
					}
				],
        	});
		}

		return bQRService;
	});  

		
