'use strict';
angularApp.controller('bqrOtpController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"bQRService",
		"customerInfoService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, bQRService, customerInfoService) {
			
			var bqrOtpVm = this;
			var count = 0;
			
			function initPage() {
				bqrOtpVm.availod = true;
				bqrOtpVm.closeDetails = [];
				bqrOtpVm.nightMode = false;
				bqrOtpVm.isNextEnabled = false;
				bqrOtpVm.isDisabledOTP = false;
				bqrOtpVm.showDateDiv = true;
				bqrOtpVm.indexId = 0;
			};

			bqrOtpVm.goToAO = function () {
				$state.go('menu.accountOverviewMyBalance');
			}

			bqrOtpVm.otpFinal = function () {
				if (bqrOtpVm.otp.length < 6) {
					bqrOtpVm.changeOtp();
				} else {
					if (bQRService.customer.otpClick == "instacreate") {
						var requestParams = {
							"otp": bqrOtpVm.otp,
							"mobile": customerInfoService.customer.mobile
						}
						console.log("requestOtp requestParams",requestParams)
						bQRService.validateOtp(requestParams).then(function (data) {
							console.log("validateOtp",data)
							if (data.status == "Success") {
								var obj = {
									"sanctionedAmount": bQRService.customer.selectedamount,
									"siStartDate": bQRService.customer.emipaymentday
								}
								console.log("requestOtp obj",obj)
								bQRService.createInstaHomeLoan(obj).then(function (data) {
									console.log("createInstaHomeLoan",data)
									var template =  '<div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter">Thanks for applying Insta Home Top-up Loan Reference Number 34234234234</div><div class="button_fund_closure RFDpopup fontSize-heading roboto-regular font-dark-grey">We will process the application.<br>You will be notified on your registered mobile and email shortly.</div></div>';
									$ionicPopup.show({
										title: '',
										template: template,
										scope: $scope,
										cssClass: 'my-custom-popup',
										buttons: [{
											text: 'OK',
											type: 'button-assertive',
											onTap: function () {
												$state.go('menu.accountOverviewMyBalance');
											}
										}],
									});
								}, function (error) {
									utilityService.showErrorMessage(error.responseMessage);
								});
							} else {
								utilityService.showErrorMessage(data.status);
							}
						}, function (error) {
							utilityService.showErrorMessage(error.responseMessage);
						});
					} else {
						var obj = {
							"fromAccount": "",
							"toAccount": bqrOtpVm.selectedAccountNumber,
							"payableAmount": rdService.viewRdData.amountCredit,
						}
						// console.log("rd closure data",obj)
						bQRService.sendInstaClosure(obj).then(function(response) {
							// console.log("closure",response)
							bqrOtpVm.storeRefNumber = response.storeRefNumber;
							if(response) {
								var title = '';
								var template='';
								var onTap ='';
								getAccountDetailsService.accountOverviewData="";
								if (response.nightMode) {
									if (response.nightMode == "Y") {
										template = '<div class ="congratsOD"><img src="img/check.png" height="45" width="45" class="happyFaceOD"></div><div class="button_fund_closure RFDpopup fontSize-heading roboto-regular font-dark-grey">Your request number '+rdDetailsVm.storeRefNumber+' for closing Recurring Deposit has been received.</div><div class="FDpopup-margin fontSize-subHeading roboto-light font-dark-grey">You will be notified once the request is processed.</div><div class="FDpopup-styling fontSize-subHeading roboto-light font-dark-grey">You can check the status of the request from the menu under service request.</div>';
									} else {
										template =  '<div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter">Congratulations Your Insta Top up home loan with A/c no. 234234234 has been closed</div></div>';
									}
								} else {
									template =  '<div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter">Congratulations Your Insta Top up home loan with A/c no. 234234234 has been closed</div></div>';
								}
								onTap = 'menu.accountOverviewMyBalance';
								// utilityService.setCsatJournies('rdClose');
								rdService.showAlertModal(title,template,onTap,$scope,$state);
							}
						}, function(error) {
							utilityService.showErrorMessage(error.responseMessage);
						});	
					}
				}
			}

			bqrOtpVm.changeOtp = function () {
				bqrOtpVm.showNameError = bqrOtpVm.otp.length;
				// if (bqrOtpVm.otp === bqrOtpVm.otpValue)
				// 	bqrOtpVm.isNextEnabled = false;
				// else
				// 	bqrOtpVm.isNextEnabled = true;
			}

			bqrOtpVm.resendOtp = function () {
				count += 1;
				if (count >= 3) {
					bqrOtpVm.isNextEnabled = true;
					bqrOtpVm.isDisabledOTP = true;
				} else {
					bqrOtpVm.resendOtp= function () {
						bqrOtpVm.otp = "";
						var reqData = {
							"id": customerInfoService.customer.mobile,
							"emailId": customerInfoService.customer.emailID
						}
						bQRService.requestOtp(reqData).then(function (data) {

						}, function (error) {
							utilityService.showErrorMessage(error.responseMessage);
						});
					}
				}
			}

			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				bqrOtpVm.accountNumber = bQRService.customer.accountno;
			});

			return this;
		}
]);


