'use strict';

angularApp.controller('ftPaymentController', [
	"$state",
	"$scope",
	"$ionicPopup",
	"utilityService",
	"$rootScope",
	"constantConfig",
	"bQRService",
	"ionicToast",

	function ($state,
		$scope,
		$ionicPopup,
		utilityService,
		$rootScope,
		constantConfig,
		bQRService,
		ionicToast) {

		var ftPaymentVm = this;

		function initPage() {
			ftPaymentVm.merchantImage = "img/bharatQR/QR_Code.png";
			ftPaymentVm.cardImage = "img/bharatQR/MasterCard.png";

			ftPaymentVm.disablesubmit = true;
			ftPaymentVm.cardHideShow = false;
			ftPaymentVm.vpaHideShow = false;
			ftPaymentVm.checkBalanceFlag = false;
			ftPaymentVm.availBalanceFlag = false;
			ftPaymentVm.accountSelectFlag = false;
			ftPaymentVm.checkbalance = false
			ftPaymentVm.AvailFlag = false;
			ftPaymentVm.showRemarkError = false;


			if (bQRService.selectedVpaDetails.cardSelectedType) {
				if (bQRService.selectedVpaDetails.cardSelectedType == "card") {
					ftPaymentVm.valChecked = "card";
					ftPaymentVm.cardHideShow = true;
					ftPaymentVm.vpaHideShow = false;
				} else {
					ftPaymentVm.valChecked = "vpa";
					ftPaymentVm.cardHideShow = false;
					ftPaymentVm.vpaHideShow = true;
				}
			}

			if (bQRService.accountUserSelected) {
				ftPaymentVm.accountArray = bQRService.accountUserSelected;
			}

			if (bQRService.accountUserSelectedMain) {
				ftPaymentVm.accountSelectedArray = bQRService.accountUserSelectedMain;
			}

			ftPaymentVm.remark = bQRService.selectedVpaDetails.remarks;
			ftPaymentVm.Vpa = bQRService.selectedVpaDetails.selectedVPAAccount;
			ftPaymentVm.selectedValueVpa = bQRService.selectedVpaDetails.selectedVPAAccountDetails;

			if (ftPaymentVm.Vpa && ftPaymentVm.selectedValueVpa) {
				ftPaymentVm.disablesubmit = false;
			}
		};

		ftPaymentVm.getCheckedbalance = function () {
			ftPaymentVm.checkbalance = false;
			ftPaymentVm.accountSelectFlag = true;
		}
		
		ftPaymentVm.selectAccount = function () {
			if (ftPaymentVm.selectedValueCard) {
				var data = ftPaymentVm.selectedValueCard.split(",");
				var a = [];
				a.accountNumber = data[0];
				a.accountBalance = data[1];
				a.accountType = data[2];
				a.indexPos = data[3];
				ftPaymentVm.indexPos = a.indexPos;
				ftPaymentVm.selectedAccountNumber = a.accountNumber;
				ftPaymentVm.availCardBalance = a.accountBalance;
				// ftPaymentVm.accountSelectFlag = true;

				bQRService.viewDebitCards(ftPaymentVm.selectedAccountNumber).then(function (response) {
					console.log(response);
					ftPaymentVm.cardList = response.cardList;
					
					/*var cardDesc = ftPaymentVm.cardList.cardType;

					if (cardDesc == "Master") {
							ftPaymentVm.cardImage = "img/bharatQR/MasterCard.png";
						} else if(cardDesc == "Visa") {
							ftPaymentVm.cardImage = "img/bharatQR/Visa.png";
						}else {
							ftPaymentVm.cardImage = "img/bharatQR/Rupay.png";
						}*/

				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});

				
			}
		};

		/*ftPaymentVm.selectAccountVpa = function(){
			var json = JSON.stringify({
    		"addInfo": {
			        "addInfo10": constantConfig.upiConstant.addInfo10,
			        "addInfo9": constantConfig.upiConstant.addInfo9
    		},
   				"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
			    "requestInfo": {
			        "pspId": constantConfig.upiConstant.pspId,
			        "pspRefNo": generateRandomString(27)
			    },
    		"updateFlag": constantConfig.upiConstant.updateFlag
		});
			upiService.getData(constantConfig.upiConstant.checkDevice, json).then(function (data) { //Here service name will be the first parameter.All service names are available in ("constantConfig.upiConstant") and second parameter will be your request in string
    			console.log(data);
			}, function (error) {
    			console.log(error);
    			utilityService.hideSpinner();
    			utilityService.showErrorMessage("You don't have necessary access for this transaction.");
			});
		};
		*/


		ftPaymentVm.selectVpaAccount = function() {
			bQRService.accountDetailsSelected = [];
			 if (device.platform.toLowerCase() == 'android') {
			 	 utilityService.showSpinner();
                var json = JSON.stringify({});
                getNativeData(constantConfig.upiConstant.getpermission, function(data) {
                    if (data.permission === 'Allowed') {
                        ftPaymentVm.checkDeviceForQrCode();
                    } else {
                        utilityService.hideSpinner();
                        utilityService.showErrorMessage("You don't have necessary access for this transaction.");
                    }
                }, function(msg) {
                    utilityService.hideSpinner();
                    ftPaymentVm.showUPIErrorMessage(msg);
                }, json);
			}else if (device.platform.toLowerCase() == 'windows') {
                ionicToast.show("The functionality is not available in windows currently.", 'bottom', false, 3000);
            }else {
                ionicToast.show("The functionality is not available in iOS currently.", 'bottom', false, 3000);
            }
		}

		ftPaymentVm.checkDeviceForQrCode = function() {
            var json = JSON.stringify({
                "addInfo": {
                    "addInfo10": constantConfig.upiConstant.addInfo10,
                    "addInfo9": constantConfig.upiConstant.addInfo9
                },
                "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "updateFlag": constantConfig.upiConstant.updateFlag,
				"smsSent": device.platform.toLowerCase() == 'android' ? false : "false"
            });
            getNativeData(constantConfig.upiConstant.checkDevice, function(data) {
                $rootScope.checkDeviceInfo = JSON.parse(data);
                utilityService.hideSpinner();
                if ($rootScope.checkDeviceInfo.status !== 'F') {
                    if ($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNN') {
                        utilityService.showErrorMessage("Please create a VPA to get your QR code.");
                        //Bhim UPI page
                    } else if (($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNN') || ($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNM')) {
                        utilityService.showErrorMessage("You have changed either device or sim card.Please do the registration through manage VPA option.");
                        //Bhim UPI page
                    } else {
                    	// ftPaymentVm.getUserProfile();
                    	ftPaymentVm.getVpaListByAcc();
                    }
                } else {
                    utilityService.showErrorMessage($rootScope.checkDeviceInfo.statusDesc);
                }
            }, function(msg) {
                utilityService.hideSpinner();
                ftPaymentVm.showUPIErrorMessage(msg);
            }, json);
        }

       /*  ftPaymentVm.accountArray = [];
        ftPaymentVm.getVpaListByAcc = function(){
        	utilityService.showSpinner();
        		ftPaymentVm.accountArray = [];
				var json = JSON.stringify({
					"recoveryOptionFlag":constantConfig.upiConstant.recoveryOptionFlag,
					"requestInfo":{
						"pspId": constantConfig.upiConstant.pspId,
						"pspRefNo": generateRandomString(27)
					},
					"updateFlag":constantConfig.upiConstant.updateFlag
				});
			getNativeData(constantConfig.upiConstant.getProfile, function(data){
				if (JSON.parse(data).status === "S") {
					ftPaymentVm.accountsListArr = [];
					var profileObject = JSON.parse(data);
					for(var i = 0; i < profileObject.vpaAccountDetails.length; i++){
					for(var j = 0; j < profileObject.vpaAccountDetails[i].accountInfo.length; j++){
						profileObject.vpaAccountDetails[i].accountInfo[j]["virtualAddress"] = profileObject.vpaAccountDetails[i].virtualAddress;
						ftPaymentVm.accountsListArr.push(profileObject.vpaAccountDetails[i].accountInfo[j]);
					}
				}
				ftPaymentVm.accountArray = ftPaymentVm.accountsListArr;	
				utilityService.hideSpinner();
				}else {
                    utilityService.hideSpinner();
                    utilityService.showErrorMessage(JSON.parse(data).statusDesc);
                }	
			}, function(msg){
				utilityService.hideSpinner();
				ftPaymentVm.showUPIErrorMessage(msg);
			},json);
  
        };
		*/

       ftPaymentVm.getVpaListByAcc = function(){
       		console.log(ftPaymentVm.Vpa)
       		if(ftPaymentVm.Vpa){
       			bQRService.selectedVpaDetails.selectedVPAAccount = ftPaymentVm.Vpa;
       			var indexValue = ftPaymentVm.Vpa.split(',');
       			var indexValueData = indexValue[1];
       			// var indexValueData = ftPaymentVm.Vpa;
       		}
       		
        	ftPaymentVm.accountArray = [];
        	// if (bQRService.accountUserSelected.length == 0) {
	        	utilityService.showSpinner();
				var json = JSON.stringify({
					"recoveryOptionFlag":constantConfig.upiConstant.recoveryOptionFlag,
					"requestInfo":{
						"pspId": constantConfig.upiConstant.pspId,
						"pspRefNo": generateRandomString(27)
					},
					"updateFlag":constantConfig.upiConstant.updateFlag
				});   
				getNativeData(constantConfig.upiConstant.getProfile, function(data){
					if (JSON.parse(data).status === "S") {
						var profileObject = JSON.parse(data);
							bQRService.accountDetailsSelected = profileObject.vpaAccountDetails;
							for(var i = 0; i < profileObject.vpaAccountDetails.length; i++){
									ftPaymentVm.accountArray.push(profileObject.vpaAccountDetails[i].virtualAddress);
									// bQRService.accountDetailsSelected = profileObject.vpaAccountDetails[i];
							}
							bQRService.accountUserSelected = ftPaymentVm.accountArray;
							if (ftPaymentVm.Vpa) {
	        					ftPaymentVm.accountSelectedArray = [];
								ftPaymentVm.accountSelectedArray = profileObject.vpaAccountDetails[indexValueData].accountInfo;
								bQRService.accountUserSelectedMain = ftPaymentVm.accountSelectedArray;
							}
							utilityService.hideSpinner();
						}else {
		                    utilityService.hideSpinner();
		                    utilityService.showErrorMessage(JSON.parse(data).statusDesc);
	                	}	
					}, function(msg){
					utilityService.hideSpinner();
					ftPaymentVm.showUPIErrorMessage(msg);
				},json);
			// } else {
			// 	if(indexValueData){
			// 		ftPaymentVm.accountArray = [];
			// 		ftPaymentVm.accountSelectedArray = [];
			// 		ftPaymentVm.accountArray = bQRService.accountUserSelected;
			// 		ftPaymentVm.accountSelectedArray = bQRService.accountDetailsSelected[indexValueData].accountInfo;
			// 	}
			// }
        }

		ftPaymentVm.selectVpaAccountList = function() {
			bQRService.selectedVpaDetails.selectedVPAAccountDetails = ftPaymentVm.selectedValueVpa;
        	var obj = JSON.parse(ftPaymentVm.selectedValueVpa);
        	if(obj.bankCode === "SBIN"){
        		//account Comparison add
        		ftPaymentVm.balanceEnquiry();
        		ftPaymentVm.AvailFlag = true;
        		ftPaymentVm.checkBalanceFlag = false;
        		ftPaymentVm.availBalanceFlag = false;
        	}else{
        		ftPaymentVm.availBalanceFlag = true;
        		ftPaymentVm.checkBal();
        		ftPaymentVm.checkBalanceFlag = true;
        	}
        }

        ftPaymentVm.balanceEnquiry = function(){
        	utilityService.showSpinner();
        	var selectedObject = JSON.parse(ftPaymentVm.selectedValueVpa);
        	var indexValue = ftPaymentVm.Vpa.split(',');
       		var indexValueData = indexValue[0];
       		bQRService.selectedVpaDetails.vpaName = indexValueData;
       		bQRService.selectedVpaDetails.accountSelected = selectedObject.maskedAccountNumber;
       		bQRService.selectedVpaDetails.accountIdSelected = selectedObject.accId;
       		bQRService.selectedVpaDetails.bankCode = selectedObject.bankCode;
        	var json = JSON.stringify({
        		"accountId":selectedObject.accId,
        		"addInfo": {
                    "addInfo10": constantConfig.upiConstant.addInfo10,
                    "addInfo9": constantConfig.upiConstant.addInfo9
                },
        		"requestInfo":{
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"virtualAddress":indexValueData
        	});
        	getNativeData(constantConfig.upiConstant.onBalanceEnquiry, function(data){
        		var checkBalRes = JSON.parse(data).apiResp;
        		 utilityService.hideSpinner();
        		 if (checkBalRes.status === 'S') {
        		 	console.log(checkBalRes);
        		 	ftPaymentVm.availBalance = checkBalRes.accountInfo.accountBalance;
        		 	bQRService.selectedVpaDetails.availBalance = ftPaymentVm.availBalance;
        		 } else {
        		 	 	utilityService.hideSpinner();
                    	utilityService.showErrorMessage(JSON.parse(data).statusDesc);
                }
        	},function(msg){
				utilityService.hideSpinner();
				ftPaymentVm.showUPIErrorMessage(msg);
			},json);
        }

        ftPaymentVm.showUPIErrorMessage = function(errorCode) {
            switch(errorCode){
				case -1 : utilityService.showErrorMessage(constantConfig.upiConstant.minusOne);
				break;

				case -2 : utilityService.showErrorMessage(constantConfig.upiConstant.minusTwo);
				break;

				case -3 : utilityService.showErrorMessage(constantConfig.upiConstant.minusThree);
				break;

				case -4 : utilityService.showErrorMessage(constantConfig.upiConstant.minusFour);
				break;

				case -5 : utilityService.showErrorMessage(constantConfig.upiConstant.minusFive);
				break;

				case -6 : utilityService.showErrorMessage(constantConfig.upiConstant.minusSix);
				break;

				case -7 : utilityService.showErrorMessage(constantConfig.upiConstant.minusSeven);
				break;

				default : utilityService.showErrorMessage(constantConfig.upiConstant.someWentWrong);
			}
        };

		ftPaymentVm.getCheckedValue = function (value) {
			bQRService.selectedVpaDetails.cardSelectedType = value;
			console.log(value)
			if (value == "card") {
				ftPaymentVm.cardHideShow = true;
				ftPaymentVm.vpaHideShow = false;
				ftPaymentVm.disablesubmit = false;
				ftPaymentVm.accountFilterRequest();
			} else {
				ftPaymentVm.cardHideShow = false;
				ftPaymentVm.vpaHideShow = true;
				ftPaymentVm.selectVpaAccount();
				ftPaymentVm.disablesubmit = false;
			}
			ftPaymentVm.valChecked = value;
			bQRService.selectedVpaDetails.selectedValue = value;
		} 

			$scope.$on('$ionicView.beforeEnter', function () {
				

				ftPaymentVm.merchantNameVal = bQRService.merchantDetails.merchantName;
				ftPaymentVm.amountVal = bQRService.merchantDetails.transactionAmount;
				var indexValueData = bQRService.selectedVpaDetails.vpaName;
				var accountSelected = bQRService.selectedVpaDetails.accountSelected;

				if (bQRService.selectedVpaDetails.availBalance) {
					ftPaymentVm.availBalance = bQRService.selectedVpaDetails.availBalance;
					ftPaymentVm.checkBalanceFlag = true;
				}
				
				var accountIdSelected = bQRService.selectedVpaDetails.accountIdSelected;
				var bankCode = bQRService.selectedVpaDetails.bankCode;
				//ftPaymentVm.validateRemark();
				ftPaymentVm.showRemarkError = false;
			});

			ftPaymentVm.goBacktoPrevious = function(){
				$state.go("menu.scanPay");
			}

			ftPaymentVm.checkBal = function () {
				ftPaymentVm.availBalanceFlag = false;
				ftPaymentVm.balanceEnquiry();
				ftPaymentVm.checkBalanceFlag = true; 
			}

			/*ftPaymentVm.validateRemark = function() {
				if (!utilityService.isEmpty(ftPaymentVm.remark)) {
					ftPaymentVm.showRemarkError = false;
					ftPaymentVm.disablePayBtn();
				} else {
					ftPaymentVm.showRemarkError = true;	
					ftPaymentVm.disablePayBtn();
				}
			};

			ftPaymentVm.disablePayBtn = function() {
				if (!utilityService.isEmpty(ftPaymentVm.remark) && ftPaymentVm.Vpa !== "") {
					ftPaymentVm.disablesubmit = false;
				} else {
					ftPaymentVm.disablesubmit = true;
				}
			};*/

			ftPaymentVm.accountFilterRequest = function() {
				if (!bQRService.accountDetails.length) {
					bQRService.accountFilter().then(function(data) {
						console.log(data)
						ftPaymentVm.accountDetails = data.accList;
                    	bQRService.accountDetails = ftPaymentVm.accountDetails;  
					}, function (error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				} else {
					ftPaymentVm.accountDetails = bQRService.accountDetails;
                    bQRService.accountDetails = ftPaymentVm.accountDetails;
				}
            }



			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			ftPaymentVm.goToNextPage = function(){
				bQRService.selectedVpaDetails.remarks = ftPaymentVm.remark;
				bQRService.selectedVpaDetails.selectedVPAAccount = ftPaymentVm.Vpa;
				bQRService.selectedVpaDetails.selectedVPAAccountDetails = ftPaymentVm.selectedValueVpa;
				$state.go("menu.reviewPayment");
			}
			 //Close and Navigate to Funds Transfer Home
			$scope.goToHome = function () {
				$state.go('menu.fundsTransfer');
			}    
	
		return this;
	}]);