'use strict';

angularApp.controller('reviewPaymentController', [
	"$state",
	"$scope",
	"$ionicPopup",
	"utilityService",
	"$rootScope",
	"constantConfig",
	"bQRService",
	"fTReviewDetails_VPAService",

	function ($state,
		$scope,
		$ionicPopup,
		utilityService,
		$rootScope,
		constantConfig,
		bQRService,
		fTReviewDetails_VPAService) {

		var reviewPaymentVm = this;

		function initPage() {

			reviewPaymentVm.cardSelected = false;
			reviewPaymentVm.vpaSelected = false;
			reviewPaymentVm.disablesubmit = true;


			reviewPaymentVm.merchantNameVal = bQRService.merchantDetails.merchantName;
			reviewPaymentVm.amountVal = bQRService.merchantDetails.transactionAmount;
			reviewPaymentVm.accountType = bQRService.merchantDetails.accountType;
			reviewPaymentVm.remarks = bQRService.selectedVpaDetails.remarks;
          
          if(bQRService.selectedVpaDetails.selectedValue == "card"){
          		reviewPaymentVm.cardSelected = true;
          	}else{
	          	reviewPaymentVm.vpaSelected = true;
				reviewPaymentVm.vpa = bQRService.selectedVpaDetails.vpaName;
				reviewPaymentVm.accountNumber = bQRService.selectedVpaDetails.accountSelected;
				reviewPaymentVm.bankLogo = bQRService.selectedVpaDetails.bankCode;
			}
        }

          reviewPaymentVm.getCBValue = function (isChecked) {
				if (isChecked === true) {
					reviewPaymentVm.disablesubmit = false;
				}else {
					reviewPaymentVm.disablesubmit = true;
				}
			}
		
		reviewPaymentVm.goBacktoPrevious = function () {
			$state.go('menu.ftPayment');
		}                                                                                    
		
		 //Close and Navigate to Funds Transfer Home
			$scope.goToHome = function () {
				$state.go('menu.fundsTransfer');
			}    
	

		$scope.$on('$ionicView.beforeEnter', function () {
			
		});

		reviewPaymentVm.goToNextPage = function(){
			reviewPaymentVm.payment();
		}
		reviewPaymentVm.payment = function(){
			utilityService.showSpinner();
			var json = JSON.stringify({  
			   "addInfo":{  
				  "addInfo10":constantConfig.upiConstant.addInfo10,
				  "addInfo9":constantConfig.upiConstant.addInfo9
			   },
			   "amount":reviewPaymentVm.amountVal,
			   "expiryTime":0,
			   "payeeType":{  
				  "name":reviewPaymentVm.merchantNameVal,
				  "virtualAddress":bQRService.merchantDetails.virtualPaymentAddress,
				  "vpaType":constantConfig.upiConstant.vpaType
			   },
			   "payerType":{  
				  "accountId":bQRService.selectedVpaDetails.accountIdSelected,
				  "virtualAddress":reviewPaymentVm.vpa
			   },
			   "requestInfo":{  
				  "pspId":constantConfig.upiConstant.pspId,
				  "pspRefNo":generateRandomString(27)
			   },
			   "transactionNote":reviewPaymentVm.remarks || "",
			   "upiTransRefNo":0
			});
			getNativeData(constantConfig.upiConstant.onPayInitiation, function(data){
				reviewPaymentVm.paymentResponse = data;
				var auditDataInput = JSON.parse(reviewPaymentVm.paymentResponse).apiResp
				var jsonObj = {
					service : "FundsTransfer",
					amount : auditDataInput.amount,
					payeeVPA : auditDataInput.payeeVPA,
					payerVPA : auditDataInput.payerVPA,
					transactionRefNo : auditDataInput.custRefNo,
					npciTransId : auditDataInput.npciTransId,
					status : auditDataInput.status
				};
				var reqParams = {};
				reqParams["auditData"] = JSON.stringify(jsonObj);
				fTReviewDetails_VPAService.getAuditLogs(reqParams).then(function(data){
						reviewPaymentVm.displayPaymentResp(reviewPaymentVm.paymentResponse);
					}, function(error){
						reviewPaymentVm.displayPaymentResp(reviewPaymentVm.paymentResponse);
				});
			}, function(msg){
				utilityService.hideSpinner();
				reviewPaymentVm.showVpaErrorMessage(msg);
			},json);
		}

		reviewPaymentVm.displayPaymentResp = function(data){
			utilityService.hideSpinner();
			reviewPaymentVm.balance = utilityService.getValue(data.balance);
			if(JSON.parse(data).apiResp.status === 'S'){
				utilityService.setCsatJournies("fundTransfer");
				//bQRService.vpaPaymentDetails["upiTransRefNo"] = JSON.parse(data).apiResp.upiTransRefNo;
				//$state.go('menu.bqrOtp');

				reviewPaymentVm.successPopup = $ionicPopup.show({
						title: '',
						template: '<div>Transaction Successful!</div><div class="button_fund_closure RFDpopup fontSize-heading roboto-regular font-dark-grey">You have paid '+reviewPaymentVm.amountVal+' successfully to '+reviewPaymentVm.merchantNameVal +'.</div><div class="FDpopup-margin fontSize-subHeading roboto-light font-dark-grey">Remaining Balance in A/c '+reviewPaymentVm.accountNumber+' is '+bQRService.selectedVpaDetails.availBalance+'.</div>',
						scope: $scope,
						cssClass: 'my-custom-popup',
						buttons: [{
							text: 'OK',
							type: 'button-assertive',
							onTap: function () {
								reviewPaymentVm.successPopup.close();
								$state.go('menu.fundsTransfer');
							}
						}],
					});
			} else if(JSON.parse(data).apiResp.status === 'F'){
				if(JSON.parse(data).apiResp.responseCode){
					reviewPaymentVm.showPaymentFailureMessage(JSON.parse(data).apiResp.responseCode);
				}else {
					utilityService.showErrorMessage(JSON.parse(data).apiResp.statusDesc);
				}
			} else {
				utilityService.showErrorMessage(JSON.parse(data).apiResp.statusDesc);
			}
		};
		
		reviewPaymentVm.showVpaErrorMessage = function(errorCode) {
            switch(errorCode){
				case -1 : utilityService.showErrorMessage(constantConfig.upiConstant.minusOne);
				break;

				case -2 : utilityService.showErrorMessage(constantConfig.upiConstant.minusTwo);
				break;

				case -3 : utilityService.showErrorMessage(constantConfig.upiConstant.minusThree);
				break;

				case -4 : utilityService.showErrorMessage(constantConfig.upiConstant.minusFour);
				break;

				case -5 : utilityService.showErrorMessage(constantConfig.upiConstant.minusFive);
				break;

				case -6 : utilityService.showErrorMessage(constantConfig.upiConstant.minusSix);
				break;

				case -7 : utilityService.showErrorMessage(constantConfig.upiConstant.minusSeven);
				break;

				default : utilityService.showErrorMessage(constantConfig.upiConstant.someWentWrong);
			}
        };

        reviewPaymentVm.showPaymentFailureMessage = function(errorCode) {
			switch (errorCode) {
				case "ND":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ND);
				break;
				
				case "NC":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_NC);
				break;
				
				case "Z0":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_Z0);
					break;
					
				case "AM":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_AM);
					break;
				
				case "ZG":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZG);
					break;
				
				case "ZI":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZI);
					break;

				case "ZJ":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZJ);
					break;

				case "ZH":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZH);
					break;
		
				case "ZK":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZK);
					break;

				case "ZL":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZL);
					break;
					
				case "ZU":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZU);
					break;

				case "ZN":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZN);
					break;
					
				case "ZO":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZO);
					break;

				case "ZP":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZP);
					break;
					
				case "ZQ":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZQ);
					break;

				case "ZX":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZX);
					break;

				case "ZY":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZY);
					break;
				
				case "XB":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XB);
					break;
				
				case "XC":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XC);
					break;
				
				case "XD":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XD);
					break;
				
				case "XE":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XE);
					break;
				
				case "XF":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XF);
					break;
				
				case "XG":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XG);
					break;
				
				case "XH":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XH);
					break;
				
				case "XI":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XI);
					break;
				
				case "XJ":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XJ);
					break;
				
				case "XK":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XK);
					break;
				
				case "XP":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XP);
					break;
					
				
				case "XQ":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XQ);
					break;
				
				case "XT":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XT);
					break;
				
				case "XU":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XU);
					break;
				
				case "XV":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XV);
					break;
				
				case "XW":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XW);
					break;
				
				case "XX":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XX);
					break;
				
				case "XY":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XY);
					break;
							
				
				case "XZ":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XZ);
					break;
				
				case "YC":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_YC);
					break;
				
				case "YD":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_YD);
					break;
				
				case "YE":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_YE);
					break;
				
				case "YF":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_YF);
					break;
				
				case "YG":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_YG);
					break;
				
				case "YH":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_YH);
					break;
								
				
				case "YI":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_YI);
					break;
				
				case "U08":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_U08);
					break;
				
				case "U31":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_U31);
					break;
							
				
				case "U30":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_U30);
					break;
				
				case "U67":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_U67);
					break;
				
				case "U68":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_U68);
					break;
							
				
				case "U69":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_U69);
					break;
				
				case "U70":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_U70);
					break;
				
				case "ZA":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZA);
					break;
							
				case "ZB":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZB);
					break;
					
				case "Z9":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_Z9);
					break;
					
				case "K1":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_K1);
					break;
					
				case "Z8":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_Z8);
					break;
					
				case "Z7":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_Z7);
					break;
					
				case "Z6":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_Z6);
					break;
					
				case "ZC":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZC);
					break;
					
				case "UA":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_UA);
					break;
					
				case "UP":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_UP);
					break;
					
				case "UT":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_UT);
					break;
					
				case "ZM":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZM);
					break;
					
				case "ZD":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZD);
					break;
					
				case "ZE":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZE);
					break;
					
				case "ZF":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZF);
					break;
					
				case "U66":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_U66);
					break;
					
				case "Z5":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_Z5);
					break;
					
				case "32":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_32);
					break;
					
				case "21":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_21);
					break;
					
				case "00":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_00);
					break;
					
				case "14":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_14);
					break;
					
				case "15":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_15);
					break;
					
				case "17":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_17);
					break;
					
				case "63":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_63);
					break;
					
				case "68":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_68);
					break;
					
				case "94":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_94);
					break;
					
				case "96":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_96);
					break;
					
				default:
					utilityService.showErrorMessage(constantConfig.upiConstant.someWentWrong);
			}
		};

		$scope.$on('$ionicView.loaded', function () {
				initPage();
		});
		
		return this;
	}]);