'use strict';
angularApp.controller('scanPayController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"bQRService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService,bQRService) {
			
			var scanPayVm = this;

			
			function initPage() {
				scanPayVm.disableNext = false;
				scanPayVm.amountDValue = true;
				scanPayVm.amountSValue = false;

				$translate(['MNAME','AMOUNT','TIP','PURPOSE','RUPAY','REFID','TERM','BILL','LOC','STORE','MASK','CUSTOMER','LOYALTY','MOB_NUM','TID','TRANAMNT']).then(function (translations) {
					scanPayVm.merchantName = translations['MNAME'];
					scanPayVm.amount = translations['AMOUNT'];
					scanPayVm.tip = translations['TIP'];
					scanPayVm.purpose = translations['PURPOSE'];
					scanPayVm.ruPay = translations['RUPAY'];
					scanPayVm.ref = translations['REFID'];
					scanPayVm.terminal = translations['TERM'];
					scanPayVm.bill = translations['BILL'];
					scanPayVm.loc = translations['LOC'];
					scanPayVm.store = translations['STORE'];
					scanPayVm.maskC = translations['MASK'];
					scanPayVm.cust = translations['CUSTOMER'];
					scanPayVm.loNum = translations['LOYALTY'];
					scanPayVm.mobile = translations['MOB_NUM'];
					scanPayVm.tID = translations['TID'];
					scanPayVm.transAmount = translations['TRANAMNT'];
					
				});
				
			};
			scanPayVm.goToNext = function(){

				bQRService.merchantDetails.mobileNum = scanPayVm.mobileNumber;
				bQRService.merchantDetails.merchantName = scanPayVm.merchantNameVal;
				bQRService.merchantDetails.qrType = scanPayVm.qrType;
				bQRService.merchantDetails.convenienceFeeFixed = scanPayVm.tipVal;
				bQRService.merchantDetails.purpose = scanPayVm.purposeVal;
				bQRService.merchantDetails.rupayRid = scanPayVm.ruPayM;
				bQRService.merchantDetails.referenceId = scanPayVm.refID;
				bQRService.merchantDetails.terminalId = scanPayVm.terminalID;
				bQRService.merchantDetails.billNumber = scanPayVm.billNum;
				bQRService.merchantDetails.merchantCity = scanPayVm.location;
				bQRService.merchantDetails.storeId = scanPayVm.storeID;
				bQRService.merchantDetails.customerId = scanPayVm.custID;
				bQRService.merchantDetails.loyaltyNumber = scanPayVm.loNumber;

				if (scanPayVm.amountSValue == true) {
					bQRService.merchantDetails.transactionAmount = scanPayVm.transAmountVal;
					bQRService.merchantDetails.convenienceFeeFixed = scanPayVm.convenienceFeeAmountVal;
				}

				if(bQRService.merchantDetails.redirectType == "scan"){
					$state.go("menu.bqrLogin");
				}else{
					$state.go("menu.ftPayment");
				}

			}
			scanPayVm.goToBack = function () {
				if(bQRService.merchantDetails.redirectType == "scan"){
					$state.go("menu.scanQRCode");
				}else{
					$state.go("menu.bQRCode");
				}

			}

			$scope.$on('$ionicView.beforeEnter', function () {
				if(bQRService.merchantDetails.redirectType == "scan"){
					scanPayVm.title = "SCAN & PAY";
				}else{
					scanPayVm.title = "FUNDS TRANSFER";
				}
				scanPayVm.mobileNumber = bQRService.merchantDetails.mobileNum;
				scanPayVm.merchantNameVal = bQRService.merchantDetails.merchantName;
				scanPayVm.qrType = bQRService.merchantDetails.qrType;
				scanPayVm.tipVal = bQRService.merchantDetails.convenienceFeeFixed;
				scanPayVm.purposeVal = bQRService.merchantDetails.purpose;
				scanPayVm.ruPayM = bQRService.merchantDetails.rupayRid;
				scanPayVm.refID = bQRService.merchantDetails.referenceId;
				scanPayVm.terminalID = bQRService.merchantDetails.terminalId;
				scanPayVm.billNum = bQRService.merchantDetails.billNumber;
				scanPayVm.location = bQRService.merchantDetails.merchantCity;
				scanPayVm.storeID = bQRService.merchantDetails.storeId;
				scanPayVm.custID = bQRService.merchantDetails.customerId;
				scanPayVm.loNumber = bQRService.merchantDetails.loyaltyNumber;


				if(bQRService.merchantDetails.transactionAmount == '0.0' && scanPayVm.qrType == "qrDynamic"){
					utilityService.showErrorMessage("Invalid Amount");
					scanPayVm.disableNext = true;
					scanPayVm.amountDValue = true;
					scanPayVm.amountSValue = false;
					scanPayVm.amountVal= bQRService.merchantDetails.transactionAmount;
				} else if((bQRService.merchantDetails.transactionAmount == null || bQRService.merchantDetails.transactionAmount == "" )&& scanPayVm.qrType == "qrStatic"){
					scanPayVm.disableNext = true;
					scanPayVm.amountSValue = true;
					scanPayVm.amountDValue = false;
					
					// bQRService.merchantDetails.transactionAmount = scanPayVm.transAmountVal;
					scanPayVm.transAmountVal = bQRService.merchantDetails.transactionAmount;
					scanPayVm.convenienceFeeAmountVal = bQRService.merchantDetails.convenienceFeeFixed;

					scanPayVm.disableNext = false;
				}else{
					scanPayVm.disableNext = false;
					scanPayVm.amountDValue = true;
					scanPayVm.amountSValue = false;
					scanPayVm.amountVal = bQRService.merchantDetails.transactionAmount;
				}
			});
          
			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});


			scanPayVm.goToHome = function () {
				if(bQRService.merchantDetails.redirectType == "scan"){
					$state.go("menu.scanQRCode");
				}else{
					$state.go("menu.bQRCode");
				}

			}	

			$scope.$on('$ionicView.afterLeave', function () {
				//any cleanup needs to be done here: executes everytime when page is left
			});

			return this;
		}
]);


