'use strict';

angularApp.controller('scanQRCodeController', [
	"$state",
	"$scope",
	"$ionicPopup",
	"$cordovaBarcodeScanner",
	"cameraService",
	"utilityService",
	"$rootScope",
	"constantConfig",
	"bQRService",
	"bhimUpiService",
	"customerInfoService",
	"loggedInUserService",

	function ($state,
		$scope,
		$ionicPopup,
		$cordovaBarcodeScanner,
		cameraService,
		utilityService,
		$rootScope,
		constantConfig,
		bQRService,
		bhimUpiService,
		customerInfoService,
		loggedInUserService) {

		var scanQRCodeVm = this;

		scanQRCodeVm.scannedImage = "img/FT/qrScanTap.svg";
		scanQRCodeVm.headerImage = "img/bharatQR/Bharat_QR.svg";

		//Get query parameter from URL
		scanQRCodeVm.getParameterByName = function (name, url) {
			if (!url) url = window.location.href;
			name = name.replace(/[\[\]]/g, "\\$&");
			var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)"),
				results = regex.exec(url);
			if (!results) return null;
			if (!results[2]) return '';
			if(name=='am'){
				if(results[2].search("E")!==-1 || results[2].search("e")!==-1){
                return results[2];
			}
		}
		   
			
			return decodeURIComponent(results[2].replace(/\+/g, " "));
		}

		scanQRCodeVm.goToBhimUpiPayment = function (barcodeData) {
			try {
				scanQRCodeVm.isBarcodeScanned = !utilityService.isEmpty(barcodeData);
				if (scanQRCodeVm.isBarcodeScanned) {
					scanQRCodeVm.payeeVpa = scanQRCodeVm.getParameterByName('pa', barcodeData);
					scanQRCodeVm.scannedImage = "img/FT/qrScanTap.svg";
					if (scanQRCodeVm.getParameterByName('am', barcodeData))
						scanQRCodeVm.amount = Number(scanQRCodeVm.getParameterByName('am', barcodeData));
					if (scanQRCodeVm.getParameterByName('tn', barcodeData))
						scanQRCodeVm.remark = scanQRCodeVm.getParameterByName('tn', barcodeData);

					if (scanQRCodeVm.getParameterByName('cu', barcodeData))
                        scanQRCodeVm.currencyCode = scanQRCodeVm.getParameterByName('cu', barcodeData);
                    if (scanQRCodeVm.getParameterByName('tr', barcodeData))
                        scanQRCodeVm.ref_id = scanQRCodeVm.getParameterByName('tr', barcodeData);
                    if (scanQRCodeVm.getParameterByName('mc', barcodeData))
                        scanQRCodeVm.merchantCatCode = scanQRCodeVm.getParameterByName('mc', barcodeData);
                    if (scanQRCodeVm.getParameterByName('mam', barcodeData))
                        scanQRCodeVm.minAmount = scanQRCodeVm.getParameterByName('mam', barcodeData);
                    if (scanQRCodeVm.getParameterByName('url', barcodeData))
                        scanQRCodeVm.ref_url = scanQRCodeVm.getParameterByName('url', barcodeData);
                    if (scanQRCodeVm.getParameterByName('tid', barcodeData))
                        scanQRCodeVm.tid = scanQRCodeVm.getParameterByName('tid', barcodeData);
				
					scanQRCodeVm.checkVpaAvailability();
				} else {
					scanQRCodeVm.scannedImage = "img/FT/qrScanTap.svg";
				}
			} catch (e) { }
		}

		scanQRCodeVm.checkVpaAvailability = function () {
			if (!scanQRCodeVm.payeeVpa) {
				utilityService.showBhimUpiAlert("alert", "Please Enter Payee UPI Id");
				return false;
			}

			utilityService.showSpinner();
			var json = JSON.stringify({
				"addInfo": {
					"addInfo10": constantConfig.upiConstant.addInfo10,
					"addInfo9": constantConfig.upiConstant.addInfo9
				},
				"payeeType": {
					"virtualAddress": scanQRCodeVm.payeeVpa.toString()
				},
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"vAReqType": constantConfig.upiConstant.vAReqType_T
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.checkVirtualAddressAPI, json).then(function (data) {
				var checkVpaResponse = JSON.parse(data);
				if (checkVpaResponse.status == 'VE') {
					customerInfoService.payeeDetails = {
						payeeType: "QR",
						requestType: 'pay',
						accountNo: "",
						ifsc: "",
						name: checkVpaResponse.payeeType.name || "",
						vpa: checkVpaResponse.payeeType.virtualAddress || "",
						amount: scanQRCodeVm.amount || "",
						remark: scanQRCodeVm.remark || "",
						nickName: "",
						phoneNumber: "",
						savePayee: false,
						currencyCode : scanQRCodeVm.currencyCode || "",
                        ref_id : scanQRCodeVm.ref_id || "",
                        merchantCatCode : scanQRCodeVm.merchantCatCode || "",
                        minAmount : scanQRCodeVm.minAmount || "",
                        ref_url : scanQRCodeVm.ref_url || "",
                        tid : scanQRCodeVm.tid || ""
					}
					scanQRCodeVm.getProfile();
				} else {
					utilityService.hideSpinner();
					utilityService.showBhimUpiAlert("error", checkVpaResponse.statusDesc);
				}
			}, function (msg) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", "There is some technical issue while proceeding. Please retry.", "menu.userLogin");
			});
		}

		scanQRCodeVm.getProfile = function () {
			utilityService.showSpinner();
			var json = JSON.stringify({
				"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"updateFlag": constantConfig.upiConstant.updateFlag
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.getProfile, json).then(function (data) {
				utilityService.hideSpinner();
				var getProfileResponse = JSON.parse(data);
				if (getProfileResponse.status == "S") {
					customerInfoService.payerProfileDtls = getProfileResponse;
					loggedInUserService.productClicked = 'menu.payToVpa_PayeeDetails';
					$state.go('menu.userLogin');
				} else {
					utilityService.showBhimUpiAlert("error", getProfileResponse.statusDesc);
				}
			}, function (msg) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", "There is some technical issue while proceeding. Please retry.", "menu.userLogin");
			});
		}

		//Scan the QR Code
		scanQRCodeVm.goToQRCodeDetails = function () {
			if (device.platform.toLowerCase() == 'android') {
				bhimUpiService.getNativeData("scanqrcode", {}).then(function (data) {
					var barcodeData = data.scanResult;
					if (barcodeData.indexOf('upi://') == -1) {
						bhimUpiService.getQRCode(barcodeData).then(function (data) {
							if (data.validStatus == 0) {
								if (data.isQRValid == true) {
									bQRService.merchantDetails = data;
									bQRService.merchantDetails.redirectType = "scan";
									$state.go("menu.scanPay");
								} else {
									utilityService.showBhimUpiAlert("error", "Invalid QR");
								}
							} else {
								//utilityService.showBhimUpiAlert("error", "Please ensure that you are scanning valid Merchant/Bharat QR code");
								scanQRCodeVm.goToBhimUpiPayment(barcodeData);
							}
						}, function (error) {
							utilityService.showBhimUpiAlert("error", error.responseMessage);
						});
					} else {
						scanQRCodeVm.goToBhimUpiPayment(barcodeData);
					}
				}, function (error) {
					utilityService.showBhimUpiAlert("error", "There is some technical issue while proceeding. Please retry.");
				});
			} else {
				bhimUpiService.getNativeData("scanqrcode", {}).then(function (data) {
					var barcodeData = data;

					if (barcodeData.indexOf("upi://pay?") !== 0) {
						bhimUpiService.getQRCode(barcodeData).then(function (data) {
							if (data.validStatus == 0) {
								if (data.isQRValid == true) {
									bQRService.merchantDetails = data;
									bQRService.merchantDetails.redirectType = "fundsTransfer";
									$state.go("menu.scanPay");
								} else {
									utilityService.showBhimUpiAlert("error", "Invalid QR");
								}
							} else {
								scanQRCodeVm.goToBhimUpiPayment(barcodeData);
							}
						}, function (error) {
							utilityService.showBhimUpiAlert("error", error.responseMessage);
						});
					} else {
						scanQRCodeVm.goToBhimUpiPayment(barcodeData);
					}

				}, function (error) {
					utilityService.showBhimUpiAlert("error", "There is some technical issue while proceeding. Please retry.");
				});
			}
		};

		//Select the QR Code from gallery
		scanQRCodeVm.selectImagefromGallery = function () {
			cameraService.getImageFromGallery().then(function (imageData) {
				scanQRCodeVm.scannedImage = imageData;
				qrcode.decode(imageData);
				qrcode.callback = function (decodedData) {
					scanQRCodeVm.isBarcodeScanned = !utilityService.isEmpty(decodedData);
					if (scanQRCodeVm.isBarcodeScanned) {
						bhimUpiService.getQRCode(decodedData).then(function (data) {
							if (data.validStatus == 0) {
								if (data.isQRValid == true) {
									scanQRCodeVm.qrData = data;
									bQRService.merchantDetails = data;
									scanQRCodeVm.isValidQrFlag = true;
									scanQRCodeVm.goToNext();
								} else {
									// utilityService.showBhimUpiAlert("error", data.invalidQRMsg, "menu.payToQR");
									utilityService.showBhimUpiAlert("error", "Invalid QR");
								}
							} else {
								scanQRCodeVm.isValidQrFlag = false;
								utilityService.showBhimUpiAlert("error", "Invalid QR");
							}
						}, function (error) {
							scanQRCodeVm.isValidQrFlag = false;
							utilityService.showBhimUpiAlert("error", error.responseMessage);
						});
					}
				}
			}, function (error) {
				if (error != "error")
					utilityService.showBhimUpiAlert("error", error);
			});
		};

		scanQRCodeVm.goToNext = function () {
			if (scanQRCodeVm.isValidQrFlag) {
				bQRService.merchantDetails.redirectType = "scan";
				$state.go("menu.scanPay");
			} else {
				utilityService.showBhimUpiAlert("error", "Invalid QR");
			}
		}

		$scope.goToHome = function () {
			$state.go('menu.userLogin');
		}

		$scope.$on('$ionicView.beforeEnter', function () {
			bQRService.convenienceFee = "";
			bQRService.transactionAmount = "";
			bQRService.purpose = "";
			bQRService.billNumber = "";
			bQRService.loyaltyNumber = "";
			bQRService.merchantDetails = {};


			scanQRCodeVm.isValidQrFlag = false;
			scanQRCodeVm.isBarcodeScanned = false;
		});

		return this;
	}]);