'use strict';

angularApp.controller('bookingListController', [
    "$state",
    "$scope",
    "$translate",
    "ompMerchantsService",
    "$ionicHistory",
    "utilityService",
    "bookingsService",
    "$ionicPopup",
    "$timeout",
    "mPinLoginService",
    "clickStreamService",
    "$ionicSlideBoxDelegate",
    "productDescriptionServices",
    "searchListServices",
    "filterService",
    "personalLoanService",
    "generalInsurenceHomeService",
    "irctcService",
    "cardsService",
    "homeScreenService",

    function($state,
        $scope,
        $translate,
        ompMerchantsService,
        $ionicHistory,
        utilityService,
        bookingsService,
        $ionicPopup,
        $timeout,
        mPinLoginService,
        clickStreamService, $ionicSlideBoxDelegate, productDescriptionServices, searchListServices, filterService, personalLoanService, generalInsurenceHomeService, irctcService, cardsService,homeScreenService) {


        var bookingListVm = this;
        var isWebviewLoadingCanceled = false;
        var isBannerClicked = false;

        bookingListVm.goBack = function () {
            $ionicHistory.goBack(-1);
        };

        bookingListVm.next = function() {
            $ionicSlideBoxDelegate.next();
        };

        bookingListVm.previous = function() {
            $ionicSlideBoxDelegate.previous();
        };

        bookingListVm.disclaimer = function(data) {
            bookingListVm.merchantsList = data;
            if (bookingListVm.merchantsList.merchantType != 'Custom'){
                bookingListVm.myPopup = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',
                templateUrl: "pages/bookAndOrder/bookingList/disclaimerPopup.html",
                scope: $scope
                });
                isWebviewLoadingCanceled = false;
                if (ompMerchantsService) {
                    if (data.affiliateId) {
                        clickStreamService.clickStreamData = "websiteId," + data.affiliateId;
                    }
                };
            }else{
                irctcService.searchTrainObj="";
                irctcService.myList="";
                irctcService.masterData="";
                irctcService.selectedTrainData="";
                irctcService.myListFullData="";
                $state.go('menu.irctcBookTicketSearch');
            }
        };

        bookingListVm.cancel = function () {
        	isBannerClicked = false;
            clickStreamService.clickStreamData = "websiteId," + bookingListVm.merchantsList.affiliateId;
            isWebviewLoadingCanceled = true;
            bookingListVm.myPopup.close();
        };

        bookingListVm.agree = function() {
            clickStreamService.clickStreamData = "websiteId," + bookingListVm.merchantsList.affiliateId;
            isWebviewLoadingCanceled = false;
            bookingListVm.myPopup.close();
			if(isBannerClicked){
        		isBannerClicked = false;
        		bookingListVm.gotoSelBanner(bookingListVm.merchantsList);
        		return true;
        	}

 if(bookingListVm.merchantsList.merchantType === 'Redirection')
 {
            bookingListVm.loadPopup = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head textAlignCenter popupBackgroundDark',
                templateUrl: "pages/bookAndOrder/bookingList/loading.html",

                scope: $scope
            })
            $timeout(function() {

                if (bookingListVm.merchantsList.merchantType === 'Redirection') {
                var myArr = bookingListVm.stores;
                var saveLeadObj = {
                    "leadId": "",
                    "websiteId": bookingListVm.merchantsList.websiteId,
                    "affiliateId": bookingListVm.merchantsList.affiliateId,
                    "request": {
                        "ompCcustToken": "",
                        "loggedIn": "",
                        "channel": "",
                        "segId": "",
                        "ompTokenId": "",
                        "merchantSku": "",
                        "prdPrice": "",
                        "wishlistSkus": "",
                        "ompDisValue": "",
                        "ompDisPct": "",
                        "ompDisType": "",
                        "isLoggedIn": mPinLoginService.isLoggedIn
                    },
                    "leadParam": bookingListVm.merchantsList.leadParam,
                    "segmentParam": bookingListVm.merchantsList.segmentParam,
                    "affiliateIdParam": bookingListVm.merchantsList.affiliateIdParam,
                    "mobileRedirectUrl" : bookingListVm.merchantsList.mobileRedirectUrl

                        }
                        ompMerchantsService.saveLead(saveLeadObj).then(function (data) {
                            bookingListVm.loadPopup.close();
                            if (isWebviewLoadingCanceled == true) {
                                return "";
                            }
                            isWebviewLoadingCanceled = true;
                            if (bookingListVm.merchantsList.redirectUrl.indexOf('?') != -1) {
                                if (mPinLoginService.isLoggedIn) {
                                    if (bookingListVm.merchantsList.merchantCode == "ubr") {
                                        if (utilityService.isAndroidPlatform()) {
                                            appAvailability.check('com.ubercab',
                                                function () {
                                                    var url = data.data.mobileUrl;
                                                    ompMerchantsService.inChromeBrowser(url);

                                        },
                                        function() {
                                            var url = "https://m.uber.com/sign-up?client_id=<CLIENT_ID>";
                                            ompMerchantsService.inChromeBrowser(url);

                                        });

                                        } else {
                                            appAvailability.check('uber://', function () {
                                                var url = data.data.mobileUrl;
                                                ompMerchantsService.inChromeBrowser(url);

                                            }, function () {
                                                var url = "https://m.uber.com/sign-up?client_id=<CLIENT_ID>";
                                                ompMerchantsService.inChromeBrowser(url);

                                    });
                                }

                                bookingListVm.myPopup.close();
                                return true;
                                    } else if (bookingListVm.merchantsList.browserType === 'inApp') {
                                    ompMerchantsService.inAppBrowser(data.data.mobileUrl);
                                    } else if (bookingListVm.merchantsList.browserType === 'default') {
                                    ompMerchantsService.inChromeBrowser(data.data.mobileUrl);
                                    } else if (bookingListVm.merchantsList.browserType === 'chrome_tab') {
                                    ompMerchantsService.inChromeTabBrowser(data.data.mobileUrl);
                                    }
                                }
                            } else {
                                if (mPinLoginService.isLoggedIn) {
                                    if (bookingListVm.merchantsList.merchantCode == "ubr") {
                                        if (utilityService.isAndroidPlatform()) {
                                            appAvailability.check('com.ubercab',
                                                function () {
                                                    var url = data.data.mobileUrl;
                                                    ompMerchantsService.inChromeBrowser(url);

                                        },
                                        function() {
                                            var url = "https://m.uber.com/sign-up?client_id=<CLIENT_ID>";
                                            ompMerchantsService.inChromeBrowser(url);

                                        });

                                        } else {
                                            appAvailability.check('uber://', function () {
                                                var url = data.data.mobileUrl;
                                                ompMerchantsService.inChromeBrowser(url);

                                            }, function () {
                                                var url = "https://m.uber.com/sign-up?client_id=<CLIENT_ID>";
                                                ompMerchantsService.inChromeBrowser(url);

                                    });
                                }

                                bookingListVm.myPopup.close();
                                return true;
                                    } else if (bookingListVm.merchantsList.browserType === 'inApp') {
                                    ompMerchantsService.inAppBrowser(data.data.mobileUrl);
                                    } else if (bookingListVm.merchantsList.browserType === 'default') {
                                    ompMerchantsService.inChromeBrowser(data.data.mobileUrl);
                                    } else if (bookingListVm.merchantsList.browserType === 'chrome_tab') {
                                    ompMerchantsService.inChromeTabBrowser(data.data.mobileUrl);
                                    }
                        }
                    }

                }, function(error) {
                    bookingListVm.loadPopup.close();
                    utilityService.showErrorMessage(error.responseMessage);
                });
                      }
                      
            }, 5000);
        }

        else if (bookingListVm.merchantsList.merchantType === 'Custom') {
                irctcService.searchTrainObj="";
                    irctcService.myList="";
                    irctcService.masterData="";
                    irctcService.selectedTrainData="";
                    irctcService.myListFullData="";
                homeScreenService.ishamburgerMenuIRCTC=true;
                   $state.go('menu.irctcBookTicketSearch');
                }
            

        };

        bookingListVm.tapCancel = function() {
            bookingListVm.loadPopup.close();
            isWebviewLoadingCanceled = true;
            $state.go('menu.bookingList');
        };
        $scope.$on('$ionicView.beforeLeave', function() {
            ompMerchantsService.endTimer();
        });
        $scope.$on('$ionicView.beforeEnter', function() {
          // bookingListVm.isBackCheck=homeScreenService.isBackCheck;
          // homeScreenService.isBackCheck	=false;
          homeScreenService.dummymenuCheck = true;
          if(homeScreenService.ishamburgerMenuBook){
            bookingListVm.isHamCheck = true;
            bookingListVm.isBackCheck = true;
          }else {
            bookingListVm.isBackCheck = false;
          }
            bookingListVm.stores = bookingsService.moreScore;

            bookingListVm.images = [];
            var bannerobj = {

                "type": "category",
                "sessionId": "",
                "isLoggedIn": mPinLoginService.isLoggedIn,
                "affiliateId": bookingListVm.stores.categoryCode,
            };
            ompMerchantsService.getBannerInformation(bannerobj).then(function(data) {

                bookingListVm.images = data.data.bannerInformations;

                $ionicSlideBoxDelegate.update();
                $ionicSlideBoxDelegate.loop(true);
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        });
        bookingListVm.gotoSelBannerPre = function (img) {
        	 if (img.redirectionType == "External") {
        	isBannerClicked = true;
        	bookingListVm.merchantsList = img;
        	bookingListVm.disclaimer(bookingListVm.merchantsList);
        	}else{
        		bookingListVm.gotoSelBanner(img);
        	}
        }
        
        bookingListVm.gotoSelBanner = function (img) {
            if (ompMerchantsService) {
                if (img.affiliateId) {
                    clickStreamService.clickStreamData = "websiteId," + img.affiliateId;
                } else {
                    clickStreamService.clickStreamData = "websiteId," + "";
                     img.affiliateId = "";
                }
            };
            isWebviewLoadingCanceled = false;
            var redirectUrl = img.redirectUrl;

            if (img.redirectionType == "External") {

                bookingListVm.loadPopup = $ionicPopup.show({
                    title: '',
                    cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head textAlignCenter popupBackgroundDark',
                    templateUrl: "pages/bookAndOrder/bookings/loading.html",
                    scope: $scope
                });
                // if (!img.affiliateId) {
                //     img.affiliateId = "";
                // }
                var obj = {
                    "sessionId": img.sessionId,
                    "merchantName": img.merchantName,
                    "type": "accept",
                    "treatmentCode": img.treatmentCode,
                    "isLoggedIn": mPinLoginService.isLoggedIn,
                    "affiliateId": img.affiliateId,
                    "websiteId": ""

                };
                ompMerchantsService.submitBannerAction(obj).then(function(data) {
                    bookingListVm.loadPopup.close();
                    if (isWebviewLoadingCanceled) {
                        return "";
                    }
                    isWebviewLoadingCanceled = true;
                    if (img.redirectUrl.indexOf('?') != -1) {
                        if (mPinLoginService.isLoggedIn) {
                            ompMerchantsService.inAppBrowser(img.redirectUrl + "&" + data.data.parameter);
                            // logoutChallangeHandler();
                        }
                    } else {
                        if (mPinLoginService.isLoggedIn) {
                            ompMerchantsService.inAppBrowser(img.redirectUrl + "?" + data.data.parameter);
                            // logoutChallangeHandler();
                        }
                    }
                }, function(error) {
                    bookingListVm.loadPopup.close();
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else {
                var bannerinfoobj = JSON.parse(redirectUrl);
                if (!ompMerchantsService.listName.websiteId) {
                    ompMerchantsService.listName = {};
                    ompMerchantsService.listName.websiteId = "";
                }
                ompMerchantsService.listName.websiteId = bannerinfoobj.WebsiteId;

                if (bannerinfoobj.pageId.toLowerCase() == "shop") {
                    var merchantobj = "";
                    for (var i = 0; i < bookingListVm.stores.length; i++) {
                        var merchantTotalData = bookingListVm.stores[i].data
                        for (var j = 0; j < merchantTotalData.length; j++)
                            if (merchantTotalData[j].websiteId == bannerinfoobj.WebsiteId) {
                                if (merchantTotalData[0].merchantType === "Native") {
                                    merchantobj = merchantTotalData[j];
                                    break;
                                }
                            }

                        if (merchantobj != "") {
                            break;
                        }
                    }
                    ompMerchantsService.listName = merchantobj
                    $state.go('menu.ompShop');
                } else if (bannerinfoobj.pageId.toLowerCase() == "productdescription") {

                    var product = {
                        "websiteId": bannerinfoobj.WebsiteId,
                        "productId": bannerinfoobj.productId,
                        "isLoggedIn": mPinLoginService.isLoggedIn
                    };
                    productDescriptionServices.getProductDetails(product).then(function(data) {
                        productDescriptionServices.productData = data;
                        $state.go('menu.productDescription');
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });

                } else if (bannerinfoobj.pageId == 'menu.creditCards') {
                        cardsService.setParams({ "cardName": bannerinfoobj.productId });
                        $state.go('menu.cardPlatinum');
                } else if (bannerinfoobj.pageId.toLowerCase() == "list") {

                    if (bannerinfoobj.listType.toLowerCase() == "deal") {


                        var dealList = {
                            "type": "deal",
                            "websiteId": bannerinfoobj.WebsiteId,
                            "filters": [],
                            "sort": {},
                            "isLoggedIn": mPinLoginService.isLoggedIn
                        }
                        searchListServices.getDealList(dealList).then(function(data) {
                            filterService.filterOldData = searchListServices.filterData;
                            searchListServices.allProductsList = data;
                            filterService.selectedLevelOneData = '';
                            filterService.selectedLevelTwoData = "";
                            filterService.selectedLevelThreeData = "";
                            searchListServices.products.length = 0
                            filterService.addedFilterFullData.length = 0
                            filterService.addedFilterData.length = 0
                            filterService.selectedColour.length = 0
                            searchListServices.isCompareAvailable = false;
                            searchListServices.serviceFrom = 'deal';
                            searchListServices.serviceFromObj = dealList;
                            searchListServices.searchFor = "Deals for You";
                            filterService.isFilterApplied = false;
                            searchListServices.isSortApplied = false;
                            searchListServices.filterNewData = {
                                categoryList: [],
                                subCategoryList: [],
                                colorList: [],
                                priceList: [],
                                callFunctionsList: []
                            };
                            $state.go('menu.searchList');
                        }, function(error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });






                    } else if (bannerinfoobj.listType.toLowerCase() == "category") {
                        var obj = {
                            "category": bannerinfoobj.categoryId,
                            "websiteId": bannerinfoobj.WebsiteId,
                            "filters": [],
                            "sort": {},
                            "isLoggedIn": mPinLoginService.isLoggedIn
                        }
                        searchListServices.getSelectedCategoryProduct(obj).then(function(data) {
                            filterService.filterOldData = searchListServices.filterData;
                            searchListServices.allProductsList = data;
                            filterService.selectedLevelOneData = '';
                            filterService.selectedLevelTwoData = "";
                            filterService.selectedLevelThreeData = "";
                            searchListServices.products.length = 0
                            filterService.addedFilterFullData.length = 0
                            filterService.addedFilterData.length = 0
                            filterService.selectedColour.length = 0
                            searchListServices.isCompareAvailable = true;
                            searchListServices.serviceFrom = 'getSelectedCategoryProduct';
                            searchListServices.serviceFromObj = obj;
                            filterService.isFilterApplied = false;
                            searchListServices.isSortApplied = false;
                            searchListServices.filterNewData = {
                                categoryList: [],
                                subCategoryList: [],
                                colorList: [],
                                priceList: [],
                                callFunctionsList: []
                            };
                            $state.go('menu.searchList');
                        }, function(error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });


                    } else if (bannerinfoobj.listType.toLowerCase() == "whatsnew") {

                        var newList = {
                            "type": "whatsnew",
                            "websiteId": bannerinfoobj.WebsiteId,
                            "filters": [],
                            "sort": {},
                            "isLoggedIn": mPinLoginService.isLoggedIn
                        }
                        searchListServices.getDealList(newList).then(function(data) {
                            filterService.filterOldData = searchListServices.filterData;
                            searchListServices.allProductsList = data;
                            filterService.selectedLevelOneData = '';
                            filterService.selectedLevelTwoData = "";
                            filterService.selectedLevelThreeData = "";
                            searchListServices.products.length = 0
                            filterService.addedFilterFullData.length = 0
                            filterService.addedFilterData.length = 0
                            filterService.selectedColour.length = 0
                            searchListServices.isCompareAvailable = false;
                            searchListServices.serviceFrom = 'whatsnew';
                            searchListServices.searchFor = "Whats New";
                            searchListServices.serviceFromObj = newList;
                            filterService.isFilterApplied = false;
                            searchListServices.isSortApplied = false;
                            searchListServices.filterNewData = {
                                categoryList: [],
                                subCategoryList: [],
                                colorList: [],
                                priceList: [],
                                callFunctionsList: []
                            };
                            $state.go('menu.searchList');
                        }, function(error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });


                    } else if (bannerinfoobj.listType.toLowerCase() == "trending") {
                        var trendList = {
                            "type": "trending",
                            "websiteId": bannerinfoobj.WebsiteId,
                            "filters": [],
                            "sort": {},
                            "isLoggedIn": mPinLoginService.isLoggedIn
                        }
                        searchListServices.getDealList(trendList).then(function(data) {
                            filterService.filterOldData = searchListServices.filterData;
                            searchListServices.allProductsList = data;
                            filterService.selectedLevelOneData = '';
                            filterService.selectedLevelTwoData = "";
                            filterService.selectedLevelThreeData = "";
                            searchListServices.products.length = 0
                            filterService.addedFilterFullData.length = 0
                            filterService.addedFilterData.length = 0
                            filterService.selectedColour.length = 0
                            searchListServices.isCompareAvailable = false;
                            searchListServices.serviceFrom = 'trending';
                            searchListServices.searchFor = "Trending";
                            searchListServices.serviceFromObj = trendList;
                            filterService.isFilterApplied = false;
                            searchListServices.isSortApplied = false;
                            searchListServices.filterNewData = {
                                categoryList: [],
                                subCategoryList: [],
                                colorList: [],
                                priceList: [],
                                callFunctionsList: []
                            };
                            $state.go('menu.searchList');
                        }, function(error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });



                    }





                } else if (bannerinfoobj.pageId.toLowerCase() == "menu.personalloan") {
                    personalLoanService.clearAll();
                    personalLoanService.getLoanDetails().then(function (data) {

                        personalLoanService.personalLoanData = data;
                        personalLoanService.minDuration = data.minTenure;
                        personalLoanService.maxDuration = data.maxTenure;
                        personalLoanService.interestRate = data.interestRate;
                        personalLoanService.product = data.productCode;
                        personalLoanService.maxEmiLimit = data.maxPermissibleEMI;
                        personalLoanService.processingFee = data.processingFee;
                        personalLoanService.minBestOffer = data.minPalAmount;
                        personalLoanService.activityCode = data.activityCode;
                        personalLoanService.schemeCode = data.schemeCode;


                        $state.go('menu.personalLoan');

                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });

                }
                  else if(bannerinfoobj.pageId=="menu.declaimer")
                  {
                     generalInsurenceHomeService.setGIProductsID(bannerinfoobj.productId)
                      $state.go(bannerinfoobj.pageId);

                  }

                 else {

                    $state.go(bannerinfoobj.pageId);
                }




            }
        }

        $scope.$on('$ionicView.afterEnter', function() {
            ompMerchantsService.startTimer();
        });

        return this;
    }
]);

