'use strict';

angularApp.service('bookingsService', function ($q, utilityService, AdapterUtils) {
	var store = "";
	var moreScore = '';


	var getProductMediaGallery = function (sku) {
		var q = $q.defer();
		var payload = {
			"sku": sku
		};
		AdapterUtils.postData("adapters/BOAdapter/getProductMediaGallery", payload, true).then(
			function (response) {
				q.resolve(response.data);
			},
			function (error) {
				q.reject(error);
			}
		);
		return q.promise;
	};



	var getStores = function (obj) {
		var q = $q.defer();
		var payload = {};
		AdapterUtils.postData("adapters/OMPAdapter/getMerchant", payload, true).then(
			function (response) {
				q.resolve(response.data);
			},
			function (error) {
				q.reject(error);
			}
		);
		return q.promise;
	};

	return {
		getStores: getStores,
		getProductMediaGallery: getProductMediaGallery,
		store: store,
		moreScore: moreScore
	};
});