'use strict';

angularApp.controller('calculateFdRdController', 
	[
	"$translate",	
	"$scope",	
	"calculateFdRdService",	
	"utilityService",	
	"homeScreenService",
	"getAccountDetailsService",
	"rdService",
	"interestrateService",
	"customerInfoService",
	"fixedDepositService",
	"constantConfig",

    function (
		$translate,		
		$scope,		
		calculateFdRdService,		
		utilityService,		
		homeScreenService,
		getAccountDetailsService,
		rdService,
		interestrateService,
		customerInfoService,
		fixedDepositService,
		constantConfig		
		) {		
		
        var calcFdRdVm = this;	
		
		$scope.$on('$ionicView.beforeEnter', function() {			
			
			var newDate = new Date();
			var year, month, days;
			year = newDate.getFullYear();
			month = newDate.getMonth() + 1;
			days = newDate.getDate();
			if (month <= 9) {
				month = "0" + month;
			}
			if (days <= 9) {
				days = "0" + days;
			}
			calcFdRdVm.startDate = "" + days + month + year;

			fetchCustInfo(calcFdRdVm);
			setCusType (calcFdRdVm);
			accNumMask(calcFdRdVm);						
		});

		$scope.$on('$ionicView.loaded', function() {
			calcFdRdVm.initPage();
		});

		// Function to initialize default values of variables.
		calcFdRdVm.initPage = function () {
			calcFdRdVm.amountData = null;
			calcFdRdVm.isSenior = false;
			calcFdRdVm.isTaxSaver = false;
			calcFdRdVm.yearsData = null;
			calcFdRdVm.monthsData = null;
			calcFdRdVm.daysData = null;
			calcFdRdVm.isvalidDays = false;				
			calcFdRdVm.customerType = "";
			calcFdRdVm.isStaffFlag = "";			
			calcFdRdVm.durationRate = [];			
			calcFdRdVm.newDates = '';
			calcFdRdVm.toggleChecked = false;
			calcFdRdVm.isValidError = false;
			calcFdRdVm.validErrorMessage = "";												
			calcFdRdVm.isTenureInvalid = false;
			calcFdRdVm.invalidTenureMessage = "";
			calcFdRdVm.matAmtCalctd = false;									
			calcFdRdVm.intPayCode = null;
			calcFdRdVm.intPayout = null;								
		}		
		 		
		$translate(['TENURE_LIMIT', 'FD_AMT_ERR', 'SENIOR_AMOUNT_LIMIT', 'TAXSAV_TEN_LIM', 'NRE_NRO_TEN_LIM', 'TAX_AMOUNT', 'SENIOR_TAX_AMOUNT', 'REG_SB_CHQ_ACC_TYP', 'REG_SB_CHQ_INT_CAT',
					'NRML_CUST', 'SNR_CTZN', 'STAFF_CUST', 'STAFF_SNR', 'RD_MULTIPLE_ERR', 'RD_AMT_ERR', 'RD_TENR_MNTH_LIM', 'ACC_TYP_KEY', 
					'INT_PAY_KEY','MAT_INS_KEY', 'INT_PAY_OPT1', 'INT_PAY_OPT2', 'INT_PAY_OPT3', 'INT_PAY_OPT4']).then(function (translations) {
			
			calcFdRdVm.normalAmountLimit = translations['FD_AMT_ERR'];
			calcFdRdVm.senioramountLimit = translations['SENIOR_AMOUNT_LIMIT'];
			calcFdRdVm.taxAmounLimit = translations['TAX_AMOUNT'];
			calcFdRdVm.seniorTaxAmounLimit = translations['SENIOR_TAX_AMOUNT'];
			calcFdRdVm.rdAmountLimit = translations['RD_AMT_ERR'];
			calcFdRdVm.rdMultipleChk = translations['RD_MULTIPLE_ERR'];
			
			calcFdRdVm.tenureLimit =translations['TENURE_LIMIT'];	
			calcFdRdVm.taxTenureLim = translations['TAXSAV_TEN_LIM'];	
			calcFdRdVm.nreNroTenrLim = translations['NRE_NRO_TEN_LIM'];
			calcFdRdVm.rdMonthTenrLim = translations['RD_TENR_MNTH_LIM'];

			calcFdRdVm.accTypKey = translations['ACC_TYP_KEY'];
			calcFdRdVm.intPayKey = translations['INT_PAY_KEY'];
			calcFdRdVm.matInsKey = translations['MAT_INS_KEY'];
			calcFdRdVm.loadFDMasterData();
			calcFdRdVm.loadRDMasterData();			

			calcFdRdVm.accTypeCode = translations['REG_SB_CHQ_ACC_TYP'];
			calcFdRdVm.intCategory = translations['REG_SB_CHQ_INT_CAT'];

			fixedDepositService.customer.intCategory = calcFdRdVm.intCategory;	// Persisted in Service to re-use existing Fetch Interest rate service
			fixedDepositService.customer.accountTypeCode = calcFdRdVm.accTypeCode;
			calcFdRdVm.nrmlCust = translations['NRML_CUST'];
			calcFdRdVm.snrCtzn = translations['SNR_CTZN'];
			calcFdRdVm.staffCust = translations['STAFF_CUST'];
			calcFdRdVm.staffSenr = translations['STAFF_SNR'];

			calcFdRdVm.monthlyPayout = translations['INT_PAY_OPT1'];
			calcFdRdVm.quarterlyPayout = translations['INT_PAY_OPT2'];
			calcFdRdVm.halfyearlyPayout = translations['INT_PAY_OPT3'];
			calcFdRdVm.maturityPayout = translations['INT_PAY_OPT4'];			
		});	
		
		// Function to load Fixed Deposit dropdown data
		calcFdRdVm.loadFDMasterData = function(){
			calcFdRdVm.fdAccTypeList = [];
			calcFdRdVm.fdIntPayMaster = [];
			calcFdRdVm.fdIntPayList = [];
			calcFdRdVm.fdMatInstMaster = [];
			calcFdRdVm.fdMatInstnList = [];
			
			utilityService.showSpinner();
			calculateFdRdService.getFDMasterdata().then(function(data){
				utilityService.hideSpinner();
				if(data.responseCode == "0000" && data.responseMessage=="success" && !utilityService.isUndefined(data.data)){						
					for(var key in data.data){
						try {
							switch(key) {
								case calcFdRdVm.accTypKey:
									for(var i=0; i<data.data[key].length;i++){
										calcFdRdVm.fdAccTypeList.push(data.data[key][i]);
									}
									if(!utilityService.isUndefined(calcFdRdVm.fdAccTypeList[0])){
										calcFdRdVm.fdSelAccType = calcFdRdVm.fdAccTypeList[0];
									}									
								break;
								case calcFdRdVm.intPayKey:
									for(var i=0; i<data.data[key].length;i++){
										calcFdRdVm.fdIntPayMaster.push(data.data[key][i]);
									}
									if(!utilityService.isUndefined(calcFdRdVm.fdIntPayMaster[3])){
										calcFdRdVm.fdSelIntPayout = calcFdRdVm.fdIntPayMaster[3];
										calcFdRdVm.fdIntPayList.push(calcFdRdVm.fdSelIntPayout);
										if(calcFdRdVm.fdIntPayMaster[3] == calcFdRdVm.maturityPayout){
											calcFdRdVm.intPayCode = "M";
											calcFdRdVm.intPayout = calcFdRdVm.maturityPayout;
										}										
									}																								
								break;
								case calcFdRdVm.matInsKey:
									for(var i=0; i<data.data[key].length;i++){
										calcFdRdVm.fdMatInstMaster.push(data.data[key][i]);
										if(i!=0){
											calcFdRdVm.fdMatInstnList.push(data.data[key][i]);
										}
									}
									if(!utilityService.isUndefined(calcFdRdVm.fdMatInstMaster[2])){
										calcFdRdVm.fdSelMatInstrn = calcFdRdVm.fdMatInstMaster[2];
									}																	
								break;								
							}	
						} catch (error) {
							utilityService.enableShowErrorMessage();
							utilityService.showErrorMessage(null);
							utilityService.disableShowErrorMessage();							
						}												
					}							
				} else {
					utilityService.hideSpinner();
					utilityService.enableShowErrorMessage();
					utilityService.showErrorMessage(data.responseMessage);
					utilityService.disableShowErrorMessage();
				}
			}, function (error){
				errMsgdisp(error);
			});
		}
		
		// Function to load Recurring Deposit dropdown data
		calcFdRdVm.loadRDMasterData = function(){

			calcFdRdVm.rdAccTypeList =[];
			utilityService.showSpinner();
			calculateFdRdService.getRDMasterdata().then(function(data){
				utilityService.hideSpinner();
				if(data.responseCode == "0000" && data.responseMessage=="success" && !utilityService.isUndefined(data.data)){						
					for(var key in data.data){
						if(key == calcFdRdVm.accTypKey) {
							for(var i=0; i<data.data[key].length;i++){
								calcFdRdVm.rdAccTypeList.push(data.data[key][i]);
							}
							try {
								if(!utilityService.isUndefined(calcFdRdVm.rdAccTypeList[0])){
									calcFdRdVm.rdSelAccType = calcFdRdVm.rdAccTypeList[0];
								}
							} catch (error) {
								utilityService.enableShowErrorMessage();
								utilityService.showErrorMessage(null);
								utilityService.disableShowErrorMessage();							
							}																																				
						}							
					}						
				} else {
					utilityService.hideSpinner();
					utilityService.enableShowErrorMessage();
					utilityService.showErrorMessage(data.responseMessage);
					utilityService.disableShowErrorMessage();
				}
			}, function (error){
				errMsgdisp(error);
			});
		}
		
		// Function to select between FD and RD calculator 
		calcFdRdVm.togglefdrdValues = function(selected){
									
			if(selected == 'FD'){
				calcFdRdVm.toggleChecked = false;
			} else if (selected == 'RD'){
				calcFdRdVm.toggleChecked = true;
			} else{
				calcFdRdVm.toggleChecked = null;
			}		

			calcFdRdVm.isvalidDays = false;
			calcFdRdVm.isValidError = false;
			calcFdRdVm.validErrorMessage = "";
			calcFdRdVm.isTenureInvalid = false;
			calcFdRdVm.invalidTenureMessage = "";
			calcFdRdVm.matAmtCalctd = false;
			calcFdRdVm.showAutoRenew = false;							
			defaultMatInst();
			// Check to validate FD, RD specific amount criteria while toggling and initiate maturity amount calculation.
			if(calcFdRdVm.amountData !== undefined && calcFdRdVm.amountData !== "" && calcFdRdVm.amountData !== null) {
				calcFdRdVm.changeAmount();
			}										
		}
		
		// Function to validate amount entered.
		calcFdRdVm.changeAmount = function () {

			calcFdRdVm.isValidError = false;
			calcFdRdVm.validErrorMessage = "";

			if (calcFdRdVm.amountData !== undefined && calcFdRdVm.amountData !== "" && calcFdRdVm.amountData !== null) {
				calcFdRdVm.amountData = parseFloat(calcFdRdVm.amountData);
			} else {
				calcFdRdVm.amountData = null;													
			}			

			if(!calcFdRdVm.toggleChecked){
				if (calcFdRdVm.isTaxSaver === false) {
					if (calcFdRdVm.isSenior === false) {
						if (calcFdRdVm.amountData > constantConfig.depositCalc.amountMaximum || calcFdRdVm.amountData < constantConfig.depositCalc.nonSeniorAmtMin || calcFdRdVm.amountData === "" 
							|| calcFdRdVm.amountData === null || calcFdRdVm.amountData === undefined) {
							calcFdRdVm.isValidError = true;
							calcFdRdVm.validErrorMessage = calcFdRdVm.normalAmountLimit;
							calcFdRdVm.matAmtCalctd = false;				
													
						} else {
							calcFdRdVm.isValidError = false;
						}
					} else {
						if (calcFdRdVm.amountData > constantConfig.depositCalc.amountMaximum || calcFdRdVm.amountData < constantConfig.depositCalc.seniorAmtMin || calcFdRdVm.amountData === "" 
							|| calcFdRdVm.amountData === null || calcFdRdVm.amountData === undefined) {
							calcFdRdVm.isValidError = true;
							calcFdRdVm.validErrorMessage = calcFdRdVm.senioramountLimit;
							calcFdRdVm.matAmtCalctd = false;
							
						} else {						
							calcFdRdVm.isValidError = false;						
						}
					}
				} else {
	
					if (calcFdRdVm.isSenior === false) {
						if (calcFdRdVm.amountData > constantConfig.depositCalc.taxSaverAmtMax || calcFdRdVm.amountData < constantConfig.depositCalc.nonSeniorAmtMin || calcFdRdVm.amountData === "" 
							|| calcFdRdVm.amountData === null || calcFdRdVm.amountData === undefined) {
							calcFdRdVm.isValidError = true;
							calcFdRdVm.validErrorMessage = calcFdRdVm.taxAmounLimit;
							calcFdRdVm.matAmtCalctd = false;
							
						} else {
							calcFdRdVm.isValidError = false;						
						}
					} else {
						if (calcFdRdVm.amountData > constantConfig.depositCalc.taxSaverAmtMax || calcFdRdVm.amountData < constantConfig.depositCalc.seniorAmtMin || calcFdRdVm.amountData === "" 
							|| calcFdRdVm.amountData === null || calcFdRdVm.amountData === undefined) {
							calcFdRdVm.isValidError = true;
							calcFdRdVm.validErrorMessage = calcFdRdVm.seniorTaxAmounLimit;
							calcFdRdVm.matAmtCalctd = false;
							
						} else {						
							calcFdRdVm.isValidError = false;						
						}
					}
				}
			} else {
				var amtString = String(calcFdRdVm.amountData);				
				var multipleCheck = amtString.split('').pop();				
				if (multipleCheck != 0) {
					calcFdRdVm.isValidError = true;
					calcFdRdVm.validErrorMessage = calcFdRdVm.rdMultipleChk;

				} else if(calcFdRdVm.amountData > constantConfig.depositCalc.amountMaximum || calcFdRdVm.amountData < constantConfig.depositCalc.rdAmtMin || calcFdRdVm.amountData === "" 
							|| calcFdRdVm.amountData === null || calcFdRdVm.amountData === undefined){
					calcFdRdVm.isValidError = true;
					calcFdRdVm.validErrorMessage = calcFdRdVm.rdAmountLimit;

				}else {
					calcFdRdVm.isValidError = false;					
				}
			}	
			// condition to initiate interest rate and maturity amount calculation 
			if((calcFdRdVm.yearsData || calcFdRdVm.monthsData || calcFdRdVm.daysData) && !calcFdRdVm.isValidError){
				if(!calcFdRdVm.toggleChecked) {
					calcFdRdVm.retSelPayout = true;
					getFdMaturityDate(calcFdRdVm);
				} else {
					chkRdTenure (calcFdRdVm);
				}
			}
		};
		
		// Function to select tax saver option and validate amount entered accordingly
		calcFdRdVm.setTaxSaver = function (value){
			if(value == 'Yes'){
				calcFdRdVm.isTaxSaver = true;
			} else if(value == 'No') {
				calcFdRdVm.isTaxSaver = false;
			}
			calcFdRdVm.changeAmount();			
		}

		// Function to select senior citizen option and change customer type & validate amount entered accordingly
		calcFdRdVm.setSenior = function(value){
			if(value == 'Yes'){
				calcFdRdVm.isSenior = true;
			} else if(value == 'No') {
				calcFdRdVm.isSenior = false;
			}
			fixedDepositService.customer.isSenior = calcFdRdVm.isSenior;	// Persisted in Service to re-use existing Fetch Interest rate service
			setCusType (calcFdRdVm);
			calcFdRdVm.changeAmount();
		}

		// Function to initiate interest rate and maturity amount calculation according to account type selection.
		calcFdRdVm.selectAccType = function(){
			if(calcFdRdVm.amountData !=null && (calcFdRdVm.yearsData || calcFdRdVm.monthsData || calcFdRdVm.daysData) && !calcFdRdVm.isValidError){
				if(!calcFdRdVm.toggleChecked) {
					calcFdRdVm.retSelPayout = true;
					getFdMaturityDate(calcFdRdVm);
				} else {
					chkRdTenure (calcFdRdVm);
				}
			}			
		}		
		
		// Function to initiate interest rate and maturity amount calculation on change of tenure
		calcFdRdVm.getTenure = function(){
			if(calcFdRdVm.yearsData){
				calcFdRdVm.yearsData = parseInt(calcFdRdVm.yearsData);
			} else {
				calcFdRdVm.yearsData = 0;
			}

			if(calcFdRdVm.monthsData){
				calcFdRdVm.monthsData = parseInt(calcFdRdVm.monthsData);
			} else {
				calcFdRdVm.monthsData = 0;
			}

			if(calcFdRdVm.daysData){
				calcFdRdVm.daysData = parseInt(calcFdRdVm.daysData);
			} else {
				calcFdRdVm.daysData = 0;
			}	

			if(!calcFdRdVm.toggleChecked) {
				calcFdRdVm.retSelPayout = false;
				getFdMaturityDate(calcFdRdVm);
			} else {
				chkRdTenure (calcFdRdVm);
			}												
		}	
		
		// Function to initiate interest rate and maturity amount calculation on change of interest payout
		calcFdRdVm.selectIntPayout = function (payout){

			if(!calcFdRdVm.toggleChecked) {

				if(payout == calcFdRdVm.monthlyPayout){	
					calcFdRdVm.intPayCode = "1A";
					calcFdRdVm.showAutoRenew = true;
				} else if (payout == calcFdRdVm.quarterlyPayout){
					calcFdRdVm.intPayCode = "3A";
					calcFdRdVm.showAutoRenew = true;				
				} else if (payout == calcFdRdVm.halfyearlyPayout){
					calcFdRdVm.intPayCode = "6A";	
					calcFdRdVm.showAutoRenew = true;			
				} else if (payout == calcFdRdVm.maturityPayout){
					calcFdRdVm.intPayCode = "M";
					calcFdRdVm.showAutoRenew = false;			
				}				
				calcFdRdVm.intPayout = payout;				
				defaultMatInst();	// function call to load maturity instruction according to the interest payout selected.		
			}
			if(calcFdRdVm.amountData !=null && (calcFdRdVm.yearsData || calcFdRdVm.monthsData || calcFdRdVm.daysData) && !calcFdRdVm.isValidError){
				calcFdRdVm.retSelPayout = true;
				getFdMaturityDate(calcFdRdVm);
			}					
		}

		// Function to load maturity instruction according to the interest payout selected.
		function defaultMatInst() {
			calcFdRdVm.fdMatInstnList = [];
			if(calcFdRdVm.showAutoRenew){				
				calcFdRdVm.fdMatInstnList = calcFdRdVm.fdMatInstMaster;
			} else {
				calcFdRdVm.fdMatInstnList.push(calcFdRdVm.fdMatInstMaster[1]);
				calcFdRdVm.fdMatInstnList.push(calcFdRdVm.fdMatInstMaster[2]);					
				calcFdRdVm.fdSelMatInstrn = calcFdRdVm.fdMatInstMaster[2];
			}
		}
		
		//Function to validate RD tenure and initiate interest rate and maturity amount calculation
		function chkRdTenure (calcFdRdVm){
			if(calcFdRdVm.monthsData!=null && calcFdRdVm.monthsData > 11){
				calcFdRdVm.isTenureInvalid = true;
				calcFdRdVm.invalidTenureMessage = calcFdRdVm.rdMonthTenrLim;
				calcFdRdVm.matAmtCalctd = false;

			} else {
				calcFdRdVm.tenureInMths = ((parseInt(calcFdRdVm.yearsData) * 12) + parseInt(calcFdRdVm.monthsData));

				if(calcFdRdVm.tenureInMths <12  || calcFdRdVm.tenureInMths > 120){
					calcFdRdVm.isTenureInvalid = true;
					calcFdRdVm.invalidTenureMessage = calcFdRdVm.nreNroTenrLim;
					calcFdRdVm.matAmtCalctd = false;			

				} else {
					calcFdRdVm.isTenureInvalid = false;				
					calcFdRdVm.invalidTenureMessage = "";		
					if(calcFdRdVm.amountData!=null && !calcFdRdVm.isValidError){
						getRdRateMaturityInfo(calcFdRdVm);
					} else {
						calcFdRdVm.changeAmount();
					}				
				}
			}						
		}

		// Function call to RD interest rate and maturity amount service  
		function getRdRateMaturityInfo(calcFdRdVm){	
			
					
			var endDate = new Date();			
			endDate.setMonth(endDate.getMonth() + parseInt(calcFdRdVm.monthsData));
			endDate.setFullYear(endDate.getFullYear() + parseInt(calcFdRdVm.yearsData));
			var finalDate = endDate.toISOString().slice(0, 10);
			
			calcFdRdVm.aggMthContri = calcFdRdVm.tenureInMths*parseFloat(calcFdRdVm.amountData);
			calcFdRdVm.aggMthContriDisp = utilityService.amtFmtDecml(String(round(calcFdRdVm.aggMthContri)));

			var obj = {
				"dob": calcFdRdVm.dob,
				"endDate": finalDate,
				"tenure": calcFdRdVm.tenureInMths,
				"installmentAmount": String(calcFdRdVm.amountData),
				"amount": constantConfig.depositCalc.amountMaximum,
				"siDate": "1",
				"accountNumber": calcFdRdVm.accountNumber,
				"pfNumber": calcFdRdVm.pfNumber,
				"customerType": calcFdRdVm.customerType,
				"panNumber": calcFdRdVm.panNumber,
				"accountTypeCode": calcFdRdVm.accTypeCode,
				"intCategory": calcFdRdVm.intCategory,
				"startDate": "",
				"isSenior": calcFdRdVm.isSenior,
				"debitNriflag": "",				
			}			
			utilityService.showSpinner();
			rdService.getcheckAccessRights().then(function (respData) {				
				
				rdService.checkPreEvaluation(obj).then(function (data) {
					utilityService.hideSpinner();
					calcFdRdVm.interestrate = utilityService.getValue(data.interestRate);
					calcFdRdVm.payoutamt = utilityService.getValue(data.maturityAmount);
					calcFdRdVm.payoutamtDisp = utilityService.amtFmtDecml(String(round(calcFdRdVm.payoutamt)));
					calcFdRdVm.aggIntAmt = utilityService.amtFmtDecml(String(round(calcFdRdVm.payoutamt - calcFdRdVm.aggMthContri)));
					calcFdRdVm.matAmtCalctd = true;
					
				}, function (error) {
					errMsgdisp(error);
					calcFdRdVm.matAmtCalctd = false;
				});			
			}, function (error) {
				errMsgdisp(error);
				calcFdRdVm.matAmtCalctd = false;
			});			
		}
		   
		/**
		* calcualte the maturity date for Fixed Deposit based on days,months, years entered		 
		* @param {controller object} calcFdRdVm
		*/
		function getFdMaturityDate(calcFdRdVm) {	
					

			var maxDate = new Date(); 
			calcFdRdVm.currentDate = "" + maxDate.getDate()  + "/" +(maxDate.getMonth()+1) + "/" + maxDate.getFullYear();
			maxDate.setFullYear(maxDate.getFullYear() + 10); 
			maxDate.setTime(maxDate.getTime() + (1*60*60*1000));
			calcFdRdVm.maxdate = maxDate;

			var mindate = new Date();
			var millis = Date.parse(mindate);			
			if(calcFdRdVm.isTaxSaver) {
				mindate.setFullYear(mindate.getFullYear()+5);
			}else {
				if(calcFdRdVm.fdSelAccType == calcFdRdVm.fdAccTypeList[0]){
					var daysvalue = 7;
					mindate.setTime(millis  + daysvalue *24*60*60*1000);
				} else {
					mindate.setFullYear(mindate.getFullYear()+1);
				}
			}						
			calcFdRdVm.mindate = mindate;

			if((!calcFdRdVm.yearsData) && (!calcFdRdVm.monthsData) && (!calcFdRdVm.daysData)){
				calcFdRdVm.isvalidDays = false;								
				calcFdRdVm.newDates ='';
			} else {
				calcFdRdVm.isvalidDays = true;				
				calcFdRdVm.newDates = new Date(); 

				var daysvalue = parseInt(calcFdRdVm.daysData);
				if(calcFdRdVm.yearsData){
					calcFdRdVm.newDates.setFullYear(calcFdRdVm.newDates.getFullYear() + parseInt(calcFdRdVm.yearsData));
				}
				if(calcFdRdVm.monthsData){
					calcFdRdVm.newDates.setMonth(calcFdRdVm.newDates.getMonth() + parseInt(calcFdRdVm.monthsData));
				}
				if(daysvalue){					  
					calcFdRdVm.newDates.setDate(calcFdRdVm.newDates.getDate() + daysvalue);
				}				  
			}
			
			if(!calcFdRdVm.newDates){
				calcFdRdVm.isvalidDays = false;
				calcFdRdVm.isTenureInvalid = true;				
				calcFdRdVm.matAmtCalctd = false;
				calcFdRdVm.maturityDate ="" ;
				calcFdRdVm.maturityDateFull = "";				

				if(calcFdRdVm.isTaxSaver){
					calcFdRdVm.invalidTenureMessage = calcFdRdVm.taxTenureLim;					
				} else {
					if(calcFdRdVm.fdSelAccType == calcFdRdVm.fdAccTypeList[0]){
						calcFdRdVm.invalidTenureMessage = calcFdRdVm.tenureLimit;
					} else {
						calcFdRdVm.invalidTenureMessage = calcFdRdVm.nreNroTenrLim;
					}					
				}					

			} else if (calcFdRdVm.newDates > calcFdRdVm.maxdate || calcFdRdVm.newDates < calcFdRdVm.mindate){
				if(calcFdRdVm.isvalidDays){
					calcFdRdVm.isTenureInvalid = true;					
					if(calcFdRdVm.isTaxSaver){
						calcFdRdVm.invalidTenureMessage = calcFdRdVm.taxTenureLim;
					} else {
						if(calcFdRdVm.fdSelAccType == calcFdRdVm.fdAccTypeList[0]){
							calcFdRdVm.invalidTenureMessage = calcFdRdVm.tenureLimit;
						} else {
							calcFdRdVm.invalidTenureMessage = calcFdRdVm.nreNroTenrLim;
						}						
					}
				}	
				calcFdRdVm.isvalidDays = false;				
				calcFdRdVm.matAmtCalctd = false;
				calcFdRdVm.maturityDate ="" ;
				calcFdRdVm.maturityDateFull = "";
					
			} else {
				var month = ["JAN", "FEB", "MAR", "APR", "MAY", "JUN","JUL", "AUG", "SEP", "OCT", "NOV", "DEC"];				
				calcFdRdVm.maturityDateFull = calcFdRdVm.newDates;				   
				calcFdRdVm.newDates=new Date(calcFdRdVm.newDates.getTime());
				calcFdRdVm.maturityDate = "" + calcFdRdVm.newDates.getDate() + " " + month[(calcFdRdVm.newDates.getMonth())] +" "+calcFdRdVm.newDates.getFullYear();				

				var year, month, days;
				year = calcFdRdVm.newDates.getFullYear();
				month = calcFdRdVm.newDates.getMonth()+1;
				days = calcFdRdVm.newDates.getDate();
				if(month <= 9){
					month = "0" + month;
				}
				if(days <= 9){
					days = "0" + days;
				}
				calcFdRdVm.maturitydateRequest = ""+days+month+year;							
				calcFdRdVm.isTenureInvalid = false;				
				calcFdRdVm.invalidTenureMessage = "";
				// condition to initiate interest rate and maturity amount calculation
				if(calcFdRdVm.amountData!=null && !calcFdRdVm.isValidError){
					getInterestRateValue(calcFdRdVm);
				} else {
					calcFdRdVm.changeAmount();
			    }				
			}
		}

		// Function call to FD interest rate service.
		function getInterestRateValue(calcFdRdVm) {	
			
			var currentDate = new Date(); 
			var maturityDateFull = calcFdRdVm.maturityDateFull;
			var timeDiff = Math.abs(maturityDateFull.getTime() - currentDate.getTime());			
			calcFdRdVm.diffDays = Math.ceil(timeDiff / (1000 * 3600 * 24));			

			if (calcFdRdVm.durationRate.length === 0){
				utilityService.showSpinner();
				interestrateService.fetchInterestRate(calcFdRdVm).then(function(data){
					utilityService.hideSpinner();
					if(!utilityService.isUndefined(data.fdInterestDetails)){	

						for (var i=0; i<data.fdInterestDetails.length; i++){
							calcFdRdVm.durationRate.push(data.fdInterestDetails[i]);							
						}
						calculateFdRdService.interestRate = calcFdRdVm.durationRate;
						for(var j=0;j<calcFdRdVm.durationRate.length;j++){
							if((calcFdRdVm.diffDays >= parseInt(calcFdRdVm.durationRate[j].minTenure) && 
								calcFdRdVm.diffDays <= parseInt(calcFdRdVm.durationRate[j].maxTenure)) || calcFdRdVm.diffDays == 3653) {
								calcFdRdVm.interestrate = calcFdRdVm.durationRate[j].interestRate;
							} 
						}							
					}
				}, function (error){
					errMsgdisp(error);
					calcFdRdVm.matAmtCalctd = false;
				});

			} else {
				for(var k=0;k<calculateFdRdService.interestRate.length;k++){
					if((calcFdRdVm.diffDays >= parseInt(calculateFdRdService.interestRate[k].minTenure) && 
						calcFdRdVm.diffDays <= parseInt(calculateFdRdService.interestRate[k].maxTenure)) || calcFdRdVm.diffDays == 3653){
						calcFdRdVm.interestrate = calculateFdRdService.interestRate[k].interestRate;
					} 
				}
			}
			// Condition to re-load interest payload based on tenure.
			if(!calcFdRdVm.retSelPayout){
				showIntPayout(calcFdRdVm);
			}					    			
			getPayoutAmt(calcFdRdVm);
		}

		// Function to load interest payout based on tenure provided.
		function showIntPayout (calcFdRdVm){
			if(!calcFdRdVm.toggleChecked){

				calcFdRdVm.fdIntPayList = [];
				if(calcFdRdVm.diffDays <= 180){
					calcFdRdVm.fdIntPayList.push(calcFdRdVm.fdIntPayMaster[3]);  
				
				} else if (calcFdRdVm.diffDays >= 181 && calcFdRdVm.diffDays <=365) {
					calcFdRdVm.fdIntPayList.push(calcFdRdVm.fdIntPayMaster[1]);
					calcFdRdVm.fdIntPayList.push(calcFdRdVm.fdIntPayMaster[3]);
				
				} else if (calcFdRdVm.diffDays >365 && calcFdRdVm.diffDays <= 3653) {
					calcFdRdVm.fdIntPayList = calcFdRdVm.fdIntPayMaster;
				}
				calcFdRdVm.fdSelIntPayout = calcFdRdVm.fdIntPayMaster[3];			
			}			
			if(calcFdRdVm.fdIntPayMaster[3] == calcFdRdVm.maturityPayout){
				calcFdRdVm.intPayCode = "M";
				calcFdRdVm.intPayout = calcFdRdVm.maturityPayout;
			}										
		}

		// Function to set customer type based on staff and senior option
		function setCusType (calcFdRdVm){
			if(calcFdRdVm.isStaffFlag === 'Y'){
				if(calcFdRdVm.isSenior === true){
					calcFdRdVm.custype = calcFdRdVm.staffSenr;					
				} else {
					calcFdRdVm.custype = calcFdRdVm.staffCust;					
				}
			}
			if(calcFdRdVm.isStaffFlag === 'N'){
				if(calcFdRdVm.isSenior === true){
					calcFdRdVm.custype = calcFdRdVm.snrCtzn;					
				} else {
					calcFdRdVm.custype = calcFdRdVm.nrmlCust;					
				}
			}
		}
		
		// Function to calculate FD maturity amount based on the service response.
		function getPayoutAmt (calcFdRdVm){
			utilityService.showSpinner();
			calculateFdRdService.getMaturityAmtDetails(calcFdRdVm).then(function (data) {
				utilityService.hideSpinner();				
				if (!utilityService.isUndefined(data.fdGetMaturityDetails)) {
					
					var maturityAmt = parseFloat(utilityService.getValue(data.fdGetMaturityDetails.maturityAmount));
					
					if(calcFdRdVm.intPayCode === "M"){
						calcFdRdVm.payoutamtDisp = utilityService.amtFmtDecml(String(round(maturityAmt)));										
						calcFdRdVm.interestamt = utilityService.amtFmtDecml(String(round(maturityAmt - calcFdRdVm.amountData)));						
					} else {
						var tenure = parseFloat(calcFdRdVm.yearsData)+calcFdRdVm.monthsData/12+calcFdRdVm.daysData/365;
						if(calcFdRdVm.intPayCode === "1A"){
							var monPayout = utilityService.getValue(data.fdGetMaturityDetails.payoutAmount);
							var yearlyamt = 12*monPayout;
							
						} else if(calcFdRdVm.intPayCode === "3A"){
							var quarPayout = utilityService.getValue(data.fdGetMaturityDetails.payoutAmount);
							var yearlyamt = 4*quarPayout;

						} else if(calcFdRdVm.intPayCode === "6A"){
							var halfyrPayout = utilityService.getValue(data.fdGetMaturityDetails.payoutAmount);
							var yearlyamt = 2*halfyrPayout;
						}
						var interestamt = tenure*yearlyamt;
						calcFdRdVm.payoutamt = round(maturityAmt + interestamt);
						calcFdRdVm.payoutamtDisp = utilityService.amtFmtDecml(String(calcFdRdVm.payoutamt));
						calcFdRdVm.interestamt = utilityService.amtFmtDecml(String(round(interestamt))); 						
					}	
					calcFdRdVm.amountDisp = utilityService.amtFmtDecml(String(round(calcFdRdVm.amountData)));
				}
				calcFdRdVm.matAmtCalctd = true;				
			}, function (error) {
				errMsgdisp(error);
				calcFdRdVm.matAmtCalctd = false;
			});
		}

		// Function to round decimal to 2 places
		function round(value) {
			var temp = Number((Math.abs(value) * 100).toPrecision(15));
			return (Math.round(temp) / 100 * Math.sign(value)).toFixed(2);
		}

		
		// Function to optionally call homescreen service if customer information after login is not available.
		function fetchCustInfo(calcFdRdVm) {
			if(getAccountDetailsService.accountOverviewData == undefined || getAccountDetailsService.accountOverviewData == null || getAccountDetailsService.accountOverviewData == ""){
				if(customerInfoService.customerInfo == undefined || customerInfoService.customerInfo == null || customerInfoService.customerInfo == ""){
					utilityService.showSpinner();
					homeScreenService.getCustomerInfo().then(function (data) {
						utilityService.hideSpinner();
						if(!utilityService.isUndefined(data.customerInformation)){
							try {
								setCustomerInfo(data.customerInformation);
							} catch (error) {
								utilityService.enableShowErrorMessage();
								utilityService.showErrorMessage(null);
								utilityService.disableShowErrorMessage();
								$state.go('menu.accountOverviewMyBalance');
							}						
						}										
					},
					function (error) {
						errMsgdisp(error);
						$state.go('menu.accountOverviewMyBalance');
					});
				} else {
					setCustomerInfo(customerInfoService.customerInfo);
				}				
			} else {
				try {					
					setCustomerInfo(getAccountDetailsService.accountOverviewData.customerInformation);
				} catch (error) {
					utilityService.enableShowErrorMessage();
					utilityService.showErrorMessage(null);
					utilityService.disableShowErrorMessage();
					$state.go('menu.accountOverviewMyBalance');
				}				
			}
		}

		// Function to set default customer information from profile data after login
		function setCustomerInfo(custInfo){
			if(!utilityService.isUndefined(custInfo.customerType)){
				calcFdRdVm.customerType = utilityService.getValue(custInfo.customerType);
			}	
			if(!utilityService.isUndefined(custInfo.isStaffFlag)){
				calcFdRdVm.isStaffFlag  = utilityService.getValue(custInfo.isStaffFlag);
			}	
			if(!utilityService.isUndefined(custInfo.homeBranch)){
				calcFdRdVm.branchCode = utilityService.getValue(custInfo.homeBranch);
			}								
			if(!utilityService.isUndefined(custInfo.accountNumber)){
				calcFdRdVm.accountNumber = utilityService.getValue(custInfo.accountNumber);
			}
			if(!utilityService.isUndefined(custInfo.dob)){
				calcFdRdVm.dob = utilityService.getValue(custInfo.dob);
			}			
			if(!utilityService.isUndefined(custInfo.panNumber)){
				calcFdRdVm.panNumber = utilityService.getValue(custInfo.panNumber);
			}			
			if(!utilityService.isUndefined(custInfo.pfNumber)){
				calcFdRdVm.pfNumber = utilityService.getValue(custInfo.pfNumber);
			}
		}

		// Function to mask account number for RD service call
		function accNumMask(calcFdRdVm){
			var accno = calcFdRdVm.accountNumber;
			if (accno) {
				var maskedChar = "";
				for (var count = 0; count < accno.length - 4; count++) {
					maskedChar = maskedChar + "X";
				}
				accno = accno.toString();
				accno = maskedChar + accno.substr(accno.length - 4, accno.length);
			}	
			calcFdRdVm.accountNumber = accno;
		}

		// Function to display error messages in service failure
		function errMsgdisp(error){
			utilityService.hideSpinner();
			utilityService.enableShowErrorMessage();
			utilityService.showErrorMessage(error.responseMessage);	
			utilityService.disableShowErrorMessage();
		}

		$scope.$on('$ionicView.afterLeave', function () {			
			calcFdRdVm.durationRate.length = 0;
		});	

        return this;
    }

]);





