angularApp.service('calculateFdRdService',
	function ($q, AdapterUtils, cryptoService) {

		var calcFdRdServ = this;
		calcFdRdServ.interestRate = [];	

		// Service to get Maturity amount details for Fixed Deposit
		calcFdRdServ.getMaturityAmtDetails = function (data) {
			var q = $q.defer();
			data.yearsData = data.yearsData? data.yearsData.toString() : "0";
			data.monthsData = data.monthsData? data.monthsData.toString() : "0";
			data.daysData = data.daysData? data.daysData.toString() : "0";

			var obj = {
				"years": data.yearsData,
				"months": data.monthsData,
				"days": data.daysData,
				"amount": parseFloat(data.amountData),
				"taxSaver": data.isTaxSaver,
				"isSeniorCitizen": data.isSenior,
				"accountTypeCode": data.accTypeCode,
				"intCategory": data.intCategory,
				"isStaffFlag": data.isStaffFlag,
				"branchCode": data.branchCode,
				"interestPayout": data.intPayCode,
				"intPayout":data.intPayout,
				"maturityInstruction": data.fdSelMatInstrn,				
				"startDate": data.startDate,
				"maturityDate": data.maturitydateRequest,				
				"fd": (cryptoService.getSHA512EncryptedData(data.amountData + data.yearsData + data.monthsData + data.daysData)).toString()
			};
			AdapterUtils.postData("adapters/FixedDepositAdapter/validatemasterdata", obj, true).then(
				function (response) {
					q.resolve(response.data);
				}, function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		//Service to load FD master data
        calcFdRdServ.getFDMasterdata = function() {
            var q = $q.defer();
            AdapterUtils.postData("adapters/FixedDepositAdapter/allMasterData",{},false).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

		//Service to load RD master data
		calcFdRdServ.getRDMasterdata = function() {
            var q = $q.defer();
            AdapterUtils.postData("adapters/RecurringDepositAdapter/allMasterData",{},false).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

		return calcFdRdServ;
	});  