/*
    Module Name  : Cards,
    File Name    : applyNowService.js,
    Description  : contains apply now service functions
*/

//(function() {
'use strict';

angularApp.service('applyNowService', ["$q", "$filter", "cardConfig", "AdapterUtils", "newCardService", "cardsService", "payNowServices","$ionicPopup","homeScreenService","fTBeneficiaryService","getAccountDetailsService","$state",
    function($q, $filter, cardConfig, AdapterUtils, newCardService, cardsService, payNowServices, $ionicPopup, homeScreenService, fTBeneficiaryService, getAccountDetailsService, $state) {


        var applyNowService = this;
        var params = {},
            state;
        var applyCardData = {};
        applyCardData.personalDetails = {};
        applyCardData.professionalDetails = {};
        var applyCardResponse = {};
        var customerInfo = {};
        var currentState="";
        var isCardFlag=false;
        var eapplyForm = {
            "cardType": "",
            "applicantDetails": {
                "accountHolderDetails": {
                    "personalDetails": {
                        "salutation": "",
                        "name": {
                            "first": "",
                            "middle": "",
                            "last": ""
                        },
                        "dob": "",
                        "gender": "",
                        "qualification": "",
                        "occupation": "",
                        "grossIncome": "",
                        "panCardNumber": "",
                        "email": "",
                        "mobileNumber": "",
                        "landLineNumber": {
                            "countryCode": "+91",
                            "areaCode": "",
                            "number": ""
                        },
                        "address": {
                            "address": "",
                            "street": "",
                            "locality": "",
                            "pinCode": "",
                            "city": "",
                            "state": ""
                        },
                        "residentialStatus":""
                    },
                    "professionalDetails": {
                        "companyName": "",                       
                        "designation": "",
                        "yearsInEmployment": "",
                        "officePhoneNumber": {
                            "areaCode": "",
                            "number": ""
                        },
                        "address": {
                            "address": "",
                            "street": "",
                            "locality": "",
                            "pinCode": "",
                            "city": "",
                            "state": ""
                        }
                    },
                    "mailingAddress": "",
                    "StatementPreference": "",
                    "alternativeCreditCard": "",
                    "payment": {
                        "bankAccountNumber": ""
                    }
                }
            }
        }

        var newEApplyForm = {
  "loan": {
    "ckycDetails":"",
    "breReferralCode":"",
    "referralCode":"",
    "lstLoanProduct": [
      {
        
      }
    ],
    "cardDetails": {
      "cardName": "",
      "cardType": "",
      "cardCategory": "PLAT"
    },
    "lstApplicants": [
      {
        "gender": "",  //gender needs to send
        "motherMaidenName": "",
        "applicantContact": { 
          "applicantAddress1Temp": "",
          "applicantAddress2Temp": "",
          "applicantPostalCodeTemp": "",
          "applicantCityTemp": "",
          "applicantStateTemp": "",
          "applicantAddressLine1": "",
          "applicantAddressLine2": "",
          "applicantPostalCode": "",
          "applicantCity": "",
          "applicantState": ""
        },
        "applicantEmployment": {
          "employmentType": "",
          "nameOfCurrentEmployer": "",
          "designationOfEmployee": ""
        }
      }
    ]
  },
  "yonoOthDetails": {
    "addressMatchwithCBS": "",
    "endofFileFlag": "N",
    "intFrom": "", // todays date
    "intAvl": "0.00",
    "intPaid1": "0.00",
    "intPaid2": "0.00",
    "intRate": "0.00"
  },
  "lstTransactions": [
  ]
} 

      

        applyNowService.getDisclaimer17 = function() {

            var q = $q.defer();
            AdapterUtils.getData(cardConfig.adapterURL.getDisclaimer17[0], null, true).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        /*
                   Function Name: getDisclaimer18,
                   Input: (callback function),
                   Output: none,
                   Description: Description
               */
        applyNowService.getDisclaimerInfo = function(callback) {

            var q = $q.defer();
            AdapterUtils.getData(cardConfig.adapterURL.getDisclaimer18[0], null, true).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };




        applyNowService.getEapplyForm = function(callback) {

            callback(customerInfo);
        };


        /*
            Function Name: getCities,
            Input: (callback function),
            Output: none,
            Description: Makes cities get service call
        */

        applyNowService.getCities = function() {

            var q = $q.defer();
            AdapterUtils.getData(cardConfig.adapterURL.getCities[0], null, true).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

         /*
            Function Name: getCities,
            Input: (callback function),
            Output: none,
            Description: Makes cities get service call
        */

        applyNowService.getToolTipContent = function() {

            var q = $q.defer();
            AdapterUtils.getData(cardConfig.adapterURL.getToolTipContent[0], null, true).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };



        applyNowService.getAllowApply = function(data) {

            var q = $q.defer();
            AdapterUtils.postData(cardConfig.adapterURL.getAllowApply[0], data, true).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };



        /*
            Function Name: getStatePIN,
            Input: (callback function),
            Output: none,
            Description: Makes state and PIN get service call
        */

        applyNowService.getStatePIN = function(requestParams) {

            var q = $q.defer();
            AdapterUtils.postData(cardConfig.adapterURL.getStatePIN[0], requestParams, true).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;

        };







        /*
            Function Name: saveApplication,
            Input: (post data, callback function) ,
            Output: none,
            Description: Saves the application
        */

        applyNowService.saveApplication = function(isLoader) {
            // resetApplyForm();
            // applyNowService.resetParams();

            // if (cardsService.getParams().userAccounts == "" || cardsService.getParams().userAccounts == undefined) {
            //     payNowServices.getUserAccounts({}).then(function(response) {
            //         cardsService.errorLogger(response);
            //         if (response.responseCode == cardConfig.responseCode.success) {

            //             if (response.data.beneficiaryList && response.data.beneficiaryList.ownAccounts) {
            //                 cardsService.setParams({ "userAccounts": response.data.beneficiaryList.ownAccounts });
            //                 var accounts = cardsService.getParams().userAccounts;
            //                 var bankAccountNumber = accounts[0].benAccntNo;
            //                 applyCardData.payment = {
            //                     "bankAccountNumber": bankAccountNumber
            //                 }

            //             }
            //         }

            //     }, function(error) {
            //         utilityService.showErrorMessage(error.responseMessage);
            //     });
            // } else {
            //     var accounts = cardsService.getParams().userAccounts;
            //     var bankAccountNumber = accounts[0].benAccntNo;
            //     applyCardData.payment = {
            //         "bankAccountNumber": bankAccountNumber
            //     }

            // }

            var bankAccountNumber = applyNowService.getParams().accountNum;


            applyCardData.payment = {
                "bankAccountNumber": bankAccountNumber
            }


           // applyCardData.imageUrl = newCardService.getParams().applyPictureURL;
            var payload = {
                "cardType": newCardService.getParams().applyCardType,
                "cardName": newCardService.getParams().applyCardName,
                "applicantDetails": applyCardData,
                "pageNo": applyNowService.getParams().pageNo,
                "isMobileVerified": applyNowService.getParams().applyCardMobileVerify ? "true" : "false"
            };






            var q = $q.defer();
            if (isLoader == undefined || isLoader == null) {
                isLoader = true;
            }

            AdapterUtils.postData(cardConfig.adapterURL.saveApplication[0], payload, isLoader).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;

        };
        /*
            Function Name: applyCard,
            Input: (post data, callback function) ,
            Output: none,
            Description: apply for card on submit click
        */

        applyNowService.saveCardApplication = function(isLoader,request,response) {         
            var payload = {
                    "pageNo": "1",
                    "isMobileVerified": "",
                    "cardType": request.loan.cardDetails.cardType,
                    "cardName": request.loan.cardDetails.cardName,
                        "applicantDetails": {
                            "imageUrl": "",
                            "personalDetails": {
                                "salutation": "",
                                "name": {
                                    "first": "",
                                    "middle": "",
                                    "last": ""
                                },
                                "dob": "",
                                "gender": request.loan.lstApplicants[0].gender,
                                "qualification": "",
                                "occupation": applyNowService.getParams().occupation,
                                "grossIncome": "",
                                "panCardNumber": "",
                                "email": "",
                                "mobileNumber": "",
                                "landLineNumber": {
                                    "countryCode": "",
                                    "areaCode": "",
                                    "number": ""
                                },
                                "address": {
                                    "address": request.loan.lstApplicants[0].applicantContact.applicantAddressLine1,
                                        "street": request.loan.lstApplicants[0].applicantContact.applicantAddressLine2,
                                        "locality": "",
                                        "pinCode": request.loan.lstApplicants[0].applicantContact.applicantPostalCode ,
                                        "city": request.loan.lstApplicants[0].applicantContact.applicantCity,
                                        "state": request.loan.lstApplicants[0].applicantContact.applicantState 
                                },
                                "ckycDetails": "",
                                "mothersName": request.loan.lstApplicants[0].motherMaidenName
                            },
                            "professionalDetails": {
                                "companyName": request.loan.lstApplicants[0].applicantEmployment.nameOfCurrentEmployer,
                                "designation": request.loan.lstApplicants[0].applicantEmployment.designationOfEmployee,
                                "yearsInEmployment": "",
                                "officePhoneNumber": {
                                    "countryCode": "",
                                    "areaCode": "",
                                    "number": ""
                                },
                                "address": {
                                    "address":"",
                                    "street": "",
                                    "locality": "",
                                    "pinCode": "" ,
                                    "city": "",
                                    "state": "" 
                                }
                            },
                            "mailingOption": "",
                            "statementPreference": "",
                            "alternativeCreditCard": "",
                            "payment": {
                                "bankAccountNumber": applyNowService.getParams().accountNum, //mandatory
                                "transBranchCode": ""
                            },
                            "referralCode": "",
                            "leadReferNo": response.data.applicationResponse.leadRefNumber,
                            "applicationNumber": response.data.applicationResponse.applicationNumber ? response.data.applicationResponse.applicationNumber : "",
                            "applicationStatus": response.data.applicationResponse.applicationStatusDesc,
                            "applicationCreditLimit": "",
                            "transBranchCode": "",
                            "processingCode": "",
                            "creditLimit": response.data.applicationResponse.creditLimit
                        }
                    };

            var q = $q.defer();
            if (isLoader == undefined || isLoader == null) {
                isLoader = true;
            }
            AdapterUtils.postData(cardConfig.adapterURL.saveApplication[0], payload, isLoader).then(
                function(saveresponse) {
                    q.resolve(saveresponse);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        applyNowService.applyCard = function() {
            var bankAccountNumber = applyNowService.getParams().accountNum;


            applyCardData.payment = {
                "bankAccountNumber": bankAccountNumber
            };
            applyCardData.referralCode = applyNowService.getParams().referralCode;
            applyCardData.breReferralCode = applyNowService.getParams().breReferralCode;
            applyCardData.personalDetails.occupation = applyNowService.getParams().occupation;
            

            // new journey modification         
            newEApplyForm.loan.cardDetails.cardName = newCardService.getParams().applyCardName;  
            newEApplyForm.loan.cardDetails.cardCategory = "PLAT";
            newEApplyForm.loan.cardDetails.cardType = newCardService.getParams().applyCardType ? newCardService.getParams().applyCardType : "";
            newEApplyForm.loan.lstApplicants[0].motherMaidenName = applyCardData.personalDetails.mothersName;
            newEApplyForm.loan.lstApplicants[0].gender = applyCardData.personalDetails.gender;

            newEApplyForm.yonoOthDetails.addressMatchwithCBS = applyNowService.getParams().addressMatchwithCBS;
            if(newEApplyForm.yonoOthDetails.addressMatchwithCBS == 'N'){
                 applyCardData.personalDetails.CBSaddress = applyNowService.getParams().CBSaddress;
            }       
            
            newEApplyForm.yonoOthDetails.intFrom = (new Date()).toISOString().split('T')[0]+"T00:00:00";
            newEApplyForm.loan.ckycDetails = applyCardData.personalDetails.ckycDetails ? applyCardData.personalDetails.ckycDetails : "";
            newEApplyForm.loan.breReferralCode=applyNowService.getParams().breReferralCode ? applyNowService.getParams().breReferralCode : "";
            newEApplyForm.loan.referralCode = applyNowService.getParams().referralCode ? applyNowService.getParams().referralCode : "";
            

            if(newEApplyForm.yonoOthDetails.addressMatchwithCBS == 'Y'){
                newEApplyForm.loan.lstApplicants[0].applicantContact.applicantAddress1Temp = applyCardData.personalDetails.address.address;
                newEApplyForm.loan.lstApplicants[0].applicantContact.applicantAddress2Temp = applyCardData.personalDetails.address.street+" "+applyCardData.personalDetails.address.locality;
                
                newEApplyForm.loan.lstApplicants[0].applicantContact.applicantPostalCodeTemp = applyCardData.personalDetails.address.pinCode;
                newEApplyForm.loan.lstApplicants[0].applicantContact.applicantCityTemp = applyCardData.personalDetails.address.city;
                newEApplyForm.loan.lstApplicants[0].applicantContact.applicantStateTemp = applyCardData.personalDetails.address.state;

                newEApplyForm.loan.lstApplicants[0].applicantContact.applicantAddressLine1 = applyCardData.personalDetails.address.address;
                newEApplyForm.loan.lstApplicants[0].applicantContact.applicantAddressLine2 = applyCardData.personalDetails.address.street+" "+applyCardData.personalDetails.address.locality;
                
                newEApplyForm.loan.lstApplicants[0].applicantContact.applicantPostalCode = applyCardData.personalDetails.address.pinCode;
                newEApplyForm.loan.lstApplicants[0].applicantContact.applicantCity = applyCardData.personalDetails.address.city;
                newEApplyForm.loan.lstApplicants[0].applicantContact.applicantState = applyCardData.personalDetails.address.state;
            }else{        
                if(applyCardData.personalDetails.CBSaddress.street){
                    applyCardData.personalDetails.CBSaddress.street = applyCardData.personalDetails.CBSaddress.street+" "+applyCardData.personalDetails.CBSaddress.locality;
                }    
                else{
                    applyCardData.personalDetails.CBSaddress.street = applyCardData.personalDetails.CBSaddress.locality;
                }                                                                
                newEApplyForm.loan.lstApplicants[0].applicantContact.applicantAddressLine1 = applyCardData.personalDetails.CBSaddress.address ? applyCardData.personalDetails.CBSaddress.address : "";
                newEApplyForm.loan.lstApplicants[0].applicantContact.applicantAddressLine2 = applyCardData.personalDetails.CBSaddress.street;
                
                newEApplyForm.loan.lstApplicants[0].applicantContact.applicantPostalCode = applyCardData.personalDetails.CBSaddress.pinCode ? applyCardData.personalDetails.CBSaddress.pinCode : "";
                newEApplyForm.loan.lstApplicants[0].applicantContact.applicantCity = applyCardData.personalDetails.CBSaddress.city ? applyCardData.personalDetails.CBSaddress.city : "";
                newEApplyForm.loan.lstApplicants[0].applicantContact.applicantState = applyCardData.personalDetails.CBSaddress.state ? applyCardData.personalDetails.CBSaddress.state : "";

                newEApplyForm.loan.lstApplicants[0].applicantContact.applicantAddress1Temp = applyCardData.personalDetails.address.address;
                newEApplyForm.loan.lstApplicants[0].applicantContact.applicantAddress2Temp = applyCardData.personalDetails.address.street+" "+applyCardData.personalDetails.address.locality;
               
                newEApplyForm.loan.lstApplicants[0].applicantContact.applicantPostalCodeTemp = applyCardData.personalDetails.address.pinCode;
                newEApplyForm.loan.lstApplicants[0].applicantContact.applicantCityTemp = applyCardData.personalDetails.address.city;
                newEApplyForm.loan.lstApplicants[0].applicantContact.applicantStateTemp = applyCardData.personalDetails.address.state;

            }

            newEApplyForm.loan.lstApplicants[0].applicantEmployment.employmentType = applyNowService.getParams().occupation;
            newEApplyForm.loan.lstApplicants[0].applicantEmployment.nameOfCurrentEmployer=applyCardData.professionalDetails.companyName;
            newEApplyForm.loan.lstApplicants[0].applicantEmployment.designationOfEmployee=applyCardData.professionalDetails.designation;

             var q = $q.defer();
            
            AdapterUtils.postDataWithTimeOut(cardConfig.adapterURL.applyCard[0], newEApplyForm, false, 180000).then(
                function(response) {
                    response.cardname = newCardService.getParams().applyCardName;
                    applyCardResponse = response;
                   
                        applyNowService.saveCardApplication(true,newEApplyForm,response).then(function(responsesaveData) {
                        cardsService.errorLogger(responsesaveData);
                           console.log("card save response "+ responsesaveData)
                        },
                        function(error) {
                            console.log("card save error "+ error)
                        });
                    q.resolve(response);
                },
                function(error) {
                    //q.reject(error);
                    getErrorPopup(error.responseMessage);
                }
            );
             return q.promise;
        };

        function getErrorPopup(message) {
            var errorPopup = $ionicPopup.alert({
                title: "",
                template: '<div class="customAlertPopupPadding font-dark-grey"><div><center><img class="w-70" src="img/errorImage.png"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><span class="popUp-msg-color">'
                + message + '</span></div></div></div>',
                cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup',
                buttons: [{
                    text: 'Ok',
                    type: 'button-positive',
                    onTap: function (e) {
                        errorPopup.close();
                        homeScreenService.ishamburgerMenuRO=false;
                        fTBeneficiaryService.isCreditCardFlag=true;
                        getAccountDetailsService.setRewTab = true;
                        getAccountDetailsService.tabIndex.tabIndex=5;
                        $state.go('menu.accountOverviewMyBalance');
                        e.preventDefault();
                    }
                }]
            });
        }

        /*
            Function Name: setParams,
            Input: state params object,
            Output: none,
            Description: Set state params
        */

        applyNowService.setParams = function(obj) {
            var setParams = angular.extend(params, obj);
        }

        /*
            Function Name: getParams,
            Input: none,
            Output: none,
            Description: Get state params
        */
        applyNowService.getParams = function() {
                return params;
            }
            /*
                Function Name: resetParams,
                Input: none,
                Output: none,
                Description: reset state params
            */
        applyNowService.resetParams = function() {
            params = {};
        }

        applyNowService.getPersonalDetails = function(callback) {
            var q = $q.defer();
            AdapterUtils.getData(cardConfig.adapterURL.getPersonalDetails[0], {}, false).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        applyNowService.getDesignationList = function(callback) {
            var q = $q.defer();
            AdapterUtils.getData(cardConfig.adapterURL.getDesignationList[0], null, false).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;

        };

        applyNowService.setPersonalData1 = function(data) {

            applyCardData.personalDetails = {
                "salutation": data.salutation,
                name: {
                    "first": data.name.first,
                    "middle": data.name.middle || "",
                    "last": data.name.last || ""
                },
                // "dob": $filter('postDate')(data.dob),
                "dob": data.dob,
                "gender": data.gender,
                "qualification": data.qualification,
                "occupation": data.occupation,
                "grossIncome": data.grossIncome,
                "panCardNumber": data.panCardNumber,
                "email": data.email,
                "address":{},
                "mobileNumber": data.mobileNumber,
                "ckycDetails": data.ckycDetails,
                "mothersName":data.mothersName,
                "residentialStatus":data.residentialStatus
            };

            applyNowService.setPersonalData2(data);


        };

        applyNowService.setPersonalData2 = function(data) {
            data.address = data.address || {};
            data.landLineNumber = data.landLineNumber || {};
            applyCardData.personalDetails.address = {
                "address": data.address.address || "",
                "street": data.address.street || "",
                "locality": data.address.locality || "",
                "pinCode": data.address.pinCode,
                "city": data.address.city,
                "state": data.address.state,
               
            }

            data.landLineNumber= {
                    "areaCode": data.landLineNumber.areaCode,
                    "number": data.landLineNumber.number,
                    "countryCode": data.landLineNumber.countryCode
                }
            applyCardData.personalDetails.landLineNumber = data.landLineNumber || "";
            if (applyCardData.personalDetails.occupation && (applyCardData.personalDetails.occupation == 'P' || applyCardData.personalDetails.occupation == 'p')) {
                applyCardData.statementPreference = data.StatementPreference;
                applyCardData.mailingOption = 'residential';
            }

        };

        applyNowService.setProfessionalData1 = function(data) {
            applyCardData.professionalDetails = {
                "companyName": data.companyName ? (data.companyName.key || data.companyName) : "",
                "designation": data.designation,
                "yearsInEmployment": data.yearsInEmployment

            };
            applyNowService.setProfessionalData2(data);
        };

        applyNowService.setProfessionalData2 = function(data) {

             data.address = data.address || {};
              data.officePhoneNumber= data.officePhoneNumber || {};


         //   applyCardData.professionalDetails.officePhoneNumber = data.officePhoneNumber;
            applyCardData.professionalDetails.address = {
                "address": data.address.address || "",
                "street": data.address.street || "",
                "locality": data.address.locality || "",
                "pinCode": data.address.pinCode,
                "city": data.address.city,
                "state": data.address.state
            }
              applyCardData.professionalDetails.officePhoneNumber= {
                    "areaCode": data.officePhoneNumber.areaCode,
                    "number": data.officePhoneNumber.number,
                    "countryCode": data.officePhoneNumber.countryCode
                }
            applyCardData.mailingOption = data.accountHolderDetails ? data.accountHolderDetails.mailingAddress : "";
            applyCardData.alternativeCreditCard = data.alternativeCreditCard || "";
            applyCardData.statementPreference = data.accountHolderDetails ? data.accountHolderDetails.StatementPreference : "";


        };
        applyNowService.applyCardResponse = function(callback) {
            callback(applyCardResponse);
        };

        applyNowService.sendEapplyOTP = function(payload) {
            var q = $q.defer();
            AdapterUtils.postData(cardConfig.adapterURL.sendOTP[0], payload, true).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;

        };

        applyNowService.validateEapplyOTP = function(payload) {
            //it's not correct one
            var q = $q.defer();
            AdapterUtils.postData(cardConfig.adapterURL.validateOTP[0], payload, true).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;

        };
        applyNowService.getCompany = function(payload) {
            var q = $q.defer();
            AdapterUtils.postData(cardConfig.adapterURL.getCompanies[0], payload, true).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;

        };

        applyNowService.getDeclaration = function() {
            var q = $q.defer();
            AdapterUtils.getData(cardConfig.adapterURL.getDeclaration[0], true).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;

        };
        applyNowService.getBankingRelationDeclaration = function() {
            var q = $q.defer();
            AdapterUtils.getData(cardConfig.adapterURL.getBankTNCContent[0], true).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;

        };

        applyNowService.setEapplyForm = function(data) {
            var q = $q.defer();
            AdapterUtils.postData(cardConfig.adapterURL.getBankAccountHolderDetails[0], data, true).then(
                function(response) {
                    customerInfo = response.data.cbsData || {};
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                });
            return q.promise;
        };

        applyNowService.getStateCityByPinCode = function(data) {
            var q = $q.defer();
            AdapterUtils.postData(cardConfig.adapterURL.getStateCityDetails[0], data, true).then(
                function(response) {                   
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                });
            return q.promise;
        };

        

        applyNowService.setCity = function() {
            applyCardData.personalDetails.address = {
                "city": cardsService.getParams().citySelected
            };
        };

        applyNowService.resetApplyForm = function() {
            applyCardData = {};
            applyCardData.personalDetails = {};
            applyCardData.professionalDetails = {};
        };


         applyNowService.getDesignationsInfo = function(payload) {
            var q = $q.defer();
            AdapterUtils.postData(cardConfig.adapterURL.getDesignationsInfo[0], payload, true).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;

        };

        applyNowService.applyNowCallCheck = function() {
            var payload = {
					
            };
            var q = $q.defer();
            AdapterUtils.postData(cardConfig.adapterURL.getSavedApplicationData[0], payload, false).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        /* Function to load cards banner at OMP page - Commenting code until business confirmation */
        /*applyNowService.getOmpToCardsWcmBanner = function (){
          var q = $q.defer();
            AdapterUtils.postData(cardConfig.adapterURL.getOmpToCardsWcmBanner[0], {}, true).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };*/

        return applyNowService;


    }
]);
