

'use strict';

angularApp.controller('cardCitySelectionController', ["$state",
    "$scope",
    "applyNowService",
    "newCardService",
    "cardsService",
    "payNowServices",
    "cardConfig", "utilityService","validateService",
    "clickStreamService","agriMandiService",
    function($state,
        $scope,
        applyNowService,
        newCardService,
        cardsService,
        payNowServices,
        cardConfig, utilityService,validateService,clickStreamService,agriMandiService) {
        var sbiCardVm = this;

        //Function to initialize variable when page loads
        function initPage() {
           
            sbiCardVm.cities = cardsService.getParams().city;
        }

        sbiCardVm.validateService = validateService;

     

        sbiCardVm.goback=function(){
        if(agriMandiService.redirectionFlag == true){
            agriMandiService.redirectionFlag = false;
            $state.go("menu.kucLanding") ;   
        }else
        {
            $state.go("menu.cardPlatinum") ;

        }
    }

        //redirect to link card/platinum page based on btn status
        sbiCardVm.goContinue = function(btn) {
             if (validateForm()) {
         clickStreamService.clickStreamData = cardsService.getParams().cardName;
            if (btn == 'continue') {
                resetApplyForm();
                 cardsService.setParams({ "citySelected": sbiCardVm.selectedCity });

                payNowServices.getUserAccounts({}).then(function(response) {
                    cardsService.errorLogger(response);
                    if (response.responseCode == cardConfig.responseCode.success) {

                        if (response.data.beneficiaryList && response.data.beneficiaryList.ownAccounts) {
                            cardsService.setParams({ "userAccounts": response.data.beneficiaryList.ownAccounts });
                            $state.go('menu.cardLinkAccount');
                        }
                    }

                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });

            } else {
                $state.go('menu.cardPlatinum');
            }
        }
        }

        function resetApplyForm() {
            applyNowService.resetParams();
        }

         function validateForm() {
            sbiCardVm.sbiCardForm = {};
             if (sbiCardVm.validateService.isValidCityCards(sbiCardVm.selectedCity)) {
                    sbiCardVm.sbiCardForm.selectedCity = sbiCardVm.validateService.isValidCityCards(sbiCardVm.selectedCity);
                }

                 return (angular.equals({}, sbiCardVm.sbiCardForm)) ? true : false;

        }
      
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
