


'use strict';

angularApp.controller('cardProfessionalDetails3Controller', ["$state", "$scope", "$translate", "validateService", "applyNowService", "cardsService", "cardConfig", "$timeout", "utilityService", "$ionicPopup","clickStreamService",
    function($state, $scope, $translate, validateService, applyNowService, cardsService, cardConfig, $timeout, utilityService, $ionicPopup,clickStreamService) {
     
        var step3Vm = this;
        var pendingApplication;
        var companyListDetail;

        
        function initPage() {
            step3Vm.isDisabled = false;
              step3Vm.professionalDetails = {};
            step3Vm.occupation = applyNowService.getParams().occupation;


            getMasterData();
            pendingApplication = cardsService.getParams().pendingApplication;
            if (pendingApplication) {

                var trackPersonalDetails = cardsService.getApplicationDetail();

                if (trackPersonalDetails) {
                    step3Vm.professionalDetails.companyName = trackPersonalDetails.applicantDetails.professionalDetails.companyName;
                    step3Vm.professionalDetails.designation = trackPersonalDetails.applicantDetails.professionalDetails.designation;
                    step3Vm.professionalDetails.yearsInEmployment = trackPersonalDetails.applicantDetails.professionalDetails.yearsInEmployment;

                      step3Vm.professionalDetails.address = trackPersonalDetails.applicantDetails.professionalDetails.address || {};
                      step3Vm.professionalDetails.officePhoneNumber = trackPersonalDetails.applicantDetails.professionalDetails.officePhoneNumber || {};

                      step3Vm.professionalDetails.accountHolderDetails =trackPersonalDetails.applicantDetails.accountHolderDetails ||{};

                      step3Vm.professionalDetails.alternativeCreditCard = trackPersonalDetails.applicantDetails.alternativeCreditCard;
                      if(step3Vm.professionalDetails.accountHolderDetails!={})
                      {
                      step3Vm.professionalDetails.accountHolderDetails.StatementPreference = trackPersonalDetails.applicantDetails.statementPreference;
                       step3Vm.professionalDetails.accountHolderDetails.mailingAddress = trackPersonalDetails.applicantDetails.mailingOption;

                  }

                }

            }

            var professionalDetails = applyNowService.getParams().professionalDetails1;
            if (professionalDetails) {
                step3Vm.professionalDetails = professionalDetails;
            }


        }

        //Back button click

        step3Vm.goBacktoPrevious = function() {
                applyNowService.setParams({ professionalDetails1: step3Vm.professionalDetails });
                $state.go('menu.cardPersonalDetails2');
            }
            // Next button click
        step3Vm.goToNextPage = function() {
                if (validateForm()) {
                     clickStreamService.clickStreamData = cardsService.getParams().cardName;
                    applyNowService.setParams({ pageNo: "2" });
                    applyNowService.setProfessionalData1(step3Vm.professionalDetails);
                    applyNowService.setParams({ professionalDetails1: step3Vm.professionalDetails });
                    applyNowService.saveApplication().then(function(response) {
                        cardsService.errorLogger(response);

                        $state.go('menu.cardProfessional2');
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });


                }
            }
            // Close application journey and take user to card account overview
        step3Vm.closeJourney = function() {
            applyNowService.setParams({ pageNo: "2" });
            applyNowService.setProfessionalData1(step3Vm.professionalDetails);
            applyNowService.setParams({ professionalDetails1: step3Vm.professionalDetails });


            var journeyConfirmation = {
                cssClass: 'sbi-alert-popup',
                buttons: [{
                    text: cardConfig.buttons.OK_LABEL,
                    type: 'button-positive',
                    onTap: function(e) {
                        cardsService.setParams({ 'pendingApplication': false });
                        $state.go('menu.accountOverviewMyBalance');
                    }
                }]
            };
            var alertObj = {
                template: '<div class="text-align-center font-content roboto-regular" translate="JOURNEY_CLOSE"></div>',
                cssClass: 'sbi-alert-popup',
                buttons: [{
                    text: cardConfig.buttons.CANCEL_LABEL,
                    type: 'button-positive'
                }, {
                    text: cardConfig.buttons.YES_LABEL,
                    type: 'button-positive',
                    onTap: function(e) {
                        journeyConfirmation.template = '<img class="fss-popup-activated-img" src="img/FSS/Approved.svg"><div class="text-align-center font-content sbi-sub-label roboto-regular" translate="JOURNEY_CLOSE_CONFIRM"></div>';
                
                        applyNowService.saveApplication().then(function(response) {
                            cardsService.errorLogger(response);
                            cardsService.alertModal(journeyConfirmation, null);
                        }, function(error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    }
                }]
            };
            cardsService.alertModal(alertObj, function(res) {

            });
        };

       
        step3Vm.step3Form = {};

        
        step3Vm.validateService = validateService;

        
        function validateForm() {
            step3Vm.step3Form = {};
              var occupation = applyNowService.getParams().occupation;
            if (occupation == 'E' || occupation == 'S') {
                if (step3Vm.validateService.isValidCompanyName(step3Vm.professionalDetails.companyName)) {
                    step3Vm.step3Form.companyName = step3Vm.validateService.isValidCompanyName(step3Vm.professionalDetails.companyName);
                }

                if (step3Vm.validateService.isValidDesignation(step3Vm.professionalDetails.designation)) {
                    step3Vm.step3Form.designation = step3Vm.validateService.isValidDesignation(step3Vm.professionalDetails.designation);
                }
                if (step3Vm.validateService.isValidNoOfYearsEmployement(step3Vm.professionalDetails.yearsInEmployment)) {
                    step3Vm.step3Form.yearsInEmployment = step3Vm.validateService.isValidNoOfYearsEmployement(step3Vm.professionalDetails.yearsInEmployment);
                }
            }


            return (angular.equals({}, step3Vm.step3Form)) ? true : false;
        }

        
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        function getMasterData() {

            step3Vm.designation = cardsService.getParams().designationsMaster;


            step3Vm.searchCompany = function() {
                companyListDetail = false;
                
                 if (step3Vm.professionalDetails.companyName.length == 3) {
                    step3Vm.isDisabled = true;
                    applyNowService.getCompany({ "searchKey": step3Vm.professionalDetails.companyName })
                        .then(function(response) {
                             step3Vm.isDisabled = false;
                            // document.getElementById('focusCompanyName').focus();
                            cardsService.errorLogger(response);
                            step3Vm.dataList = response.data.companies;
                        }, function(error) {
                            // utilityService.showErrorMessage(error.responseMessage);
                            //   step3Vm.professionalDetails.companyName = "";
                            step3Vm.isDisabled = true;
                               var alertPop = $ionicPopup.alert({
                                title: 'Error',
                                template: error.responseMessage
                            });
                            alertPop.then(function(res) {

                                if (res) {

                                    step3Vm.isDisabled = false;
                                     step3Vm.professionalDetails.companyName = "";
                                   
                                }

                            });
                        });

                }

            }
            step3Vm.selectCompany = function(data) {
                step3Vm.professionalDetails.companyName = data.value;
                step3Vm.dataList = [];
                companyListDetail = true;
            }

            step3Vm.clearData = function() {
                if (companyListDetail) {
                    step3Vm.professionalDetails.companyName = "";
                }
            }

        }



    }
]);
