/**
 *   @ngdoc config
 *   @name angularApp.config : cardConfig
 *   @description
 *  configuration file for cards module
 */

/*This function defines all the constants named  Adapters url for cards module*/
angularApp
    .value(
        'cardConfig', {
            "adapterURL": {
                "sendOTP": ['adapters/CardsAdapterv2/sendOTP', 'post'],
                "linkCard": ['adapters/CardsAdapterv2/linkCard', 'post'],
                "getLinkedCards": ['adapters/CardsAdapterv2/getLinkedCards', 'post'],
                "getPendingApplications": ['adapters/CardsAdapterv2/getPendingCardApplications', 'get'],
                "getIncompleteApplications": ['adapters/CardsAdapterv2/getIncompleteApplications', 'get'],
                "deLink": ['adapters/CardsAdapterv2/delinkCard', 'post'],
                "cardOverview": ['adapters/CardsAdapterv2/getCardAccountDetails', 'get'],
                "userAccount": ['adapters/CardsAdapterv2/getSBIUserAccounts', 'get'],
                "payDues": ['adapters/CardsAdapterv2/payDues', 'post'],
                "resetPin": ['adapters/CardsAdapterv2/resetPin', 'post'],
                "rewards": ['adapters/CardsAdapterv2/getRewardDetails', 'get'],
                "transactions": ['adapters/CardsAdapterv2/getTransactions', 'post'],
                "blockCard": ['adapters/CardsAdapterv2/blockCard', 'post'],
                "getInternationalUsage": ['adapters/CardsAdapterv2/getInternationalUsageStatus', 'get'],
                "changeInternationalUsage": ['adapters/CardsAdapterv2/changeInternationalUsageStatus', 'post'],
                "getRecommendedCards": ['adapters/CardsAdapterv2/getRecommendedCards', 'post'],
                "getRecommendedCardsPreLogin": ['adapters/FSSCommonAdapter/oa/v1/getCardsTopPicksForPreLogin', 'post'],
                "getTnCOA": ['adapters/FSSCommonAdapter/oa/v1/getDndOverrideDisclaimer', 'post'],
                "getCardsList": ['adapters/CardsAdapterv2/getAllCards', 'post'],
                "getCardsListPreLogin": ['adapters/CardsAdapterv2/oa/v1/getAllCardsForPreLogin', 'post'],
                "getCities": ['adapters/CardsAdapterv2/getCities', 'get'],
                "cityCheck": ['adapters/CardsAdapterv2/checkCityAvailabilityForCard', 'post'],
                "applyCard": ['adapters/CardsAdapterv2/eApplyCard', 'post'],
                //"applyCard": ['adapters/CardsAdapterv2/applyForCard', 'post'],
                "getCard": ['adapters/CardsAdapterv2/getCardDetails', 'post'],
                "getCardPreLogin": ['adapters/CardsAdapterv2/oa/v1/getCardDetails', 'post'],
                "suggestedCards": ['adapters/CardsAdapterv2/getSuggestedCards', 'post'],
                "simplifierRule": ['', 'get'],
                //"getAccountHolderDetails": ['adapters/CardsAdapterv2/getAccountHolderDetails', 'post'],
                "getSavedApplication": ['adapters/CardsAdapterv2/getSavedApplication', 'post'],
                "saveApplication": ['adapters/CardsAdapterv2/saveApplication', 'post'],
                "getCardComparison": ['adapters/CardsAdapterv2/getCardComparison', 'post'],
                "getCardComparisonPreLogin": ['adapters/CardsAdapterv2/oa/v1/getCardComparison', 'post'],
                "getPersonalDetails": ['adapters/CardsAdapterv2/getPersonalDetailsMasters', 'get'],
                "getCallCenterNumber": ['adapters/CardsAdapterv2/getCallCenterNumber', 'get'],
                "getWelcomeMessages": ['adapters/CardsAdapterv2/getWelcomeMessage', 'get'],
                "getStatePIN": ['adapters/CardsAdapterv2/getStatesAndPinCodes', 'post'],
                "getDesignationList": ['adapters/CardsAdapterv2/getDesignations', 'get'],
                // "getSBIBankAccounts": ['adapters/FSSCommonAdapter/getSBIBankAccounts', 'post'],
                "getBankAccountHolderDetails": ['adapters/FSSCommonAdapter/getBankAccountHolderDetails', 'post'],
                "getAddOnCards": ['adapters/CardsAdapterv2/getAddOnCards', 'post'],
                //"getAddOnCards": ['adapters/CardsAdapterv2/getAddOnCards', 'post'],
                "getHandShakeToken": ['adapters/CardsAdapterv2/getHandShakeToken', 'post'],
                "getApplicationStatus": ['adapters/CardsAdapterv2/getApplicationStatus', 'post'],
                "getSavedApplicationData": ['adapters/CardsAdapterv2/getSavedApplicationData', 'post'],
                "getCardPrivileges": ['adapters/CardsAdapterv2/getCardPrivileges', 'get'],
                "getExpenseList": ['adapters/CardsAdapterv2/getExpenseList', 'get'],
                "getDisclaimer17": ['adapters/CardsAdapterv2/getDisclaimer17', 'get'],
                "getDisclaimer18": ['adapters/CardsAdapterv2/getDisclaimer18', 'get'],
                "getRedirectionMessage": ['adapters/CardsAdapterv2/getRedirectionMessage', 'get'],
                "sendOTPForResetPIN": ['adapters/CardsAdapterv2/sendOTPForResetPIN', 'post'],
                "validateOTP": ['adapters/CardsAdapterv2/validateOTP', 'post'],
                "getCompanies": ['adapters/CardsAdapterv2/getCompanies', 'post'],
                "getOwnAccounts": ['adapters/FSSCommonAdapter/getOwnAccounts', 'post'],
                "getTermsAndConditions": ['adapters/CardsAdapterv2/getTermsAndConditions', 'get'],
                "getDeclaration": ['adapters/CardsAdapterv2/getDeclaration', 'get'],
                "getCardHolderDetails": ['adapters/CardsAdapterv2/getCardHolderDetails', 'post'],
                "validateOTPForResetPIN": ['adapters/CardsAdapterv2/validateOTPForResetPIN', 'post'],
                "getSimplifierLogic": ['adapters/CardsAdapterv2/getSimplifierLogic', 'post'],
                "getAllowApply": ['adapters/CardsAdapterv2/getAllowApply', 'post'],
                "removeSavedApplication": ['adapters/CardsAdapterv2/removeSavedApplication', 'post'],
                "validateOTPForPayment": ['adapters/CardsAdapterv2/validateOTPForPayment', 'post'],
                "getRedirectUrls": ['adapters/CardsAdapterv2/getRedirectUrls', 'post'],
                "resendOTPForPayDues": ['adapters/CardsAdapterv2/resendOTPForPayDues', 'post'],
                "getToolTipContent": ['adapters/CardsAdapterv2/getToolTipContent', 'post'],
                "getBankTNCContent": ['adapters/CardsAdapterv2/getBankTNCContent', 'get'],
				"getPendingApplicationStatus": ['adapters/CardsAdapterv2/getPendingApplicationStatus', 'post'],
                "getStateCityDetails": ['adapters/CardsAdapterv2/getStageCityByPincode', 'post'],
                "getDesignationsInfo": ['adapters/CardsAdapterv2/getDesignationInfo', 'post'],
                "getOmpToCardsWcmBanner" : ['adapters/CardsAdapterv2/getOmpToCardsWcmBanner', 'post']

            },
            "responseCode": {
                "success": "0000",
                "dataSuccess": "000",
                "failed": "1111"

            },

            "buttons": {
                "OK_LABEL": "OK",
                "CANCEL_LABEL": "Cancel",
                "YES_LABEL": "Yes",
                "RESETPIN_LABEL": "Reset pin",

            },
            "initPage": {
                "Phone_code": "+91"
            },

            "cardUrl": {
                "tata_card": "https://tata-pvt.sbicard.com",
                "other_card": "https://sbi-pvt"

            },

            "links": {
                "register": "https://www.sbicard.com/",
                "forgotPassword": "https://www.sbicard.com/creditcards/app/user/forgotpassword-page",
                "linkCard": ["uat2.sbicard.com/creditcards/app/msw/user-registration?hs_token=", "&channel=lotus"],
                "rewardRedemption": ["uat2.sbicard.com/creditcards/app/msw/sso-login/?hs_token=", "&channel=lotus", "&feature=rewrem"],
                "blockCard": ["uat2.sbicard.com/creditcards/app/msw/sso-login/?hs_token=", "&channel=lotus", "&feature=mpqadd"],
                "managePin": ["uat2.sbicard.com/creditcards/app/msw/sso-login/?hs_token=", "&channel=lotus", "&feature=mpqcon"]

            }
        })

    /*State defination with respective names, urls, controllers and templates */

    .config([
        '$stateProvider',
        function ($stateProvider) {

            //Cards start
            $stateProvider
                .state('menu.linkCard', {
                    url: '/linkCard',
                    data: {
                        pageId: 'CRDS_LNKCRD'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/cards/linkCard/linkCard.html',
                            controller: 'linkCardController',
                            controllerAs: 'linkCardVm'
                        }
                    }
                })
                .state('menu.enterCardOTP', {
                    url: '/enterCardOTP',
                    data: {
                        pageId: 'CRDS_ENTROTP'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/cards/linkCard/enterOTP.html',
                            controller: 'enterOTPController',
                            controllerAs: 'enterOTPVm'
                        }
                    }
                })
                .state('menu.cardOverview', {
                    url: '/cardOverview',
                    data: {
                        pageId: 'CRDS_CRDDETL'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/cards/payNow/cardDetails.html',
                            controller: 'cardDetailsController',
                            controllerAs: 'cardDetailsVm',
                        }
                    }
                })
                .state('menu.cardPayment', {
                    url: '/cardPayment',
                    data: {
                        pageId: 'CRDS_LNKCRD'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/cards/payNow/cardPayment.html',
                            controller: 'cardPaymentController',
                            controllerAs: 'cardPaymentVm'
                        }
                    }
                })
                .state('menu.paymentSuccessful', {
                    url: '/paymentSuccessful',
                    data: {
                        pageId: 'CRDS_PYMTSUC'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/cards/payNow/paymentSuccessful.html',
                            controller: 'paymentSuccessfulController',
                            controllerAs: 'paymentSuccessfulVm'
                        }
                    }
                })
                .state('menu.resetPin', {
                    url: '/resetPin',
                    data: {
                        pageId: 'CRDS_RSTPIN'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/cards/floatingMenu/resetPin/resetPin.html',
                            controller: 'resetPinController',
                            controllerAs: 'resetPinVm'
                        }
                    }
                })
                .state('menu.resendOTPPin', {
                    url: '/resendOTPPin',
                    data: {
                        pageId: 'CRDS_RSNDOTPPIN'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/cards/floatingMenu/resetPin/resendOTPPin.html',
                            controller: 'resendOTPPinController',
                            controllerAs: 'resendOTPPinVm'
                        }
                    }
                })
                .state('menu.newPin', {
                    url: '/newPin',
                    data: {
                        pageId: 'CRDS_NEWPIN'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/cards/floatingMenu/resetPin/newPin.html',
                            controller: 'newPinController',
                            controllerAs: 'newPinVm'
                        }
                    }
                })
                .state('menu.rewards', {
                    url: '/rewards',
                    data: {
                        pageId: 'CRDS_RWDS'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/cards/floatingMenu/rewards/rewards.html',
                            controller: 'rewardsController',
                            controllerAs: 'rewardsVm'
                        }
                    }
                })
                .state('menu.rewardsAgree', {
                    url: '/rewardsAgree',
                    data: {
                        pageId: 'CRDS_RWDSAGREE'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/cards/floatingMenu/rewards/rewardsAgree.html',
                            controller: 'rewardsAgreeController',
                            controllerAs: 'rewardsAgreeVm'
                        }
                    }
                })
                .state('menu.rewardsTermsCondition', {
                    url: '/rewardsTermsCondition',
                    data: {
                        pageId: 'CRDS_RWDSTNC'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/cards/floatingMenu/rewards/rewardsTermsCondition.html',
                            controller: 'rewardsTermsConditionController',
                            controllerAs: 'rewardsTermsConditionVm'
                        }
                    }
                })
                .state('menu.cardTransactions', {
                    url: '/cardTransactions',
                    data: {
                        pageId: 'CRDS_CRDTRNS'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/cards/floatingMenu/pastTransaction/cardTransactions.html',
                            controller: 'cardTransactionsController',
                            controllerAs: 'cardTransactionsVm',
                        }
                    }
                })
                .state('menu.selectCardBlockHotlist', {
                    url: '/selectCardBlockHotlist',
                    data: {
                        pageId: 'CRDS_SELCRDBLKHOTLST'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/cards/floatingMenu/blockHotlist/selectCardBlockHotlist.html',
                            controller: 'selectCardBlockHotlistController',
                            controllerAs: 'selectCardBlockHotlistVm',
                        }
                    }
                })
                .state('menu.confirmCardBlockHotlist', {
                    url: '/confirmCardBlockHotlist',
                    data: {
                        pageId: 'CRDS_CNFMCRDBLKHOTLST'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/cards/floatingMenu/blockHotlist/confirmCardBlockHotlist.html',
                            controller: 'confirmCardBlockHotlistController',
                            controllerAs: 'confirmCardBlockHotlistVm',
                        }
                    }
                })
                .state('menu.selectInternationalUsage', {
                    url: '/selectInternationalUsage',
                    data: {
                        pageId: 'CRDS_SELINTUSGACT'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/cards/floatingMenu/internationalUsage/selectInternationalUsage.html',
                            controller: 'selectInternationalUsageController',
                            controllerAs: 'selectInternationalUsageVm',
                        }
                    }
                })
                .state('menu.internationalUsageActivate', {
                    url: '/internationalUsageActivate',
                    data: {
                        pageId: 'CRDS_INTUSGACT'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/cards/floatingMenu/internationalUsage/internationalUsageActivate.html',
                            controller: 'internationalUsageActivateController',
                            controllerAs: 'internationalUsageActivateVm',
                        }
                    }
                })
				.state('menu.cardServices', {
                    url: '/cardServices',
                    data: {
                        pageId: 'CRDS_SERVICE'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/cards/floatingMenu/cardServices/cardServices.html',
                            controller: 'cardServicesController',
                            controllerAs: 'cardServicesVm',
                        }
                    }
                })
                .state('menu.cardIntroduction', {
                    url: '/cardIntroduction',
                    data: {
                        pageId: 'CRDS_CRDINTRO'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/cards/getNewCard/cardIntroduction.html',
                            controller: 'cardIntroductionController',
                            controllerAs: 'cardIntroVm'
                        }
                    }
                })
                .state('menu.browseCards', {
                    url: '/cardAddCompare',
                    data: {
                        pageId: 'CRDS_CRDADDCMPR'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/cards/getNewCard/browseCards/browseCards.html',
                            controller: 'browseCardsController',
                            controllerAs: 'browseCardsVm'
                        }
                    }
                })
                .state('menu.cardCitySelection', {
                    url: '/cardCitySelection',
                    data: {
                        pageId: 'CRDS_CRDCTYSEL'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/cards/applyNow/cardCitySelection.html',
                            controller: 'cardCitySelectionController',
                            controllerAs: 'sbiCardVm',
                        }
                    }
                })
                .state('menu.cardLinkAccount', {
                    url: '/cardLinkAccount',
                    data: {
                        pageId: 'CRDS_CRDLNKACCT'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/cards/applyNow/cardLinkAccount.html',
                            controller: 'cardLinkAccountController',
                            controllerAs: 'linkAccountVm',
                        }
                    }
                })
                .state('menu.cardPersonalDetails1', {
                    url: '/cardPersonalDetails',
                    data: {
                        pageId: 'CRDS_CRDPRSLDETL'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/cards/applyNow/cardPersonalDetails1.html',
                            controller: 'cardPersonalDetails1Controller',
                            controllerAs: 'step1Vm'
                        }
                    }
                })
                .state('menu.cardPersonalDetails2', {
                    url: '/cardAddressDetails',
                    data: {
                        pageId: 'CRDS_CRDADRSDETL'
                    },
                    cache: false,

                    views: {
                        'menuContent': {
                            templateUrl: 'pages/cards/applyNow/cardPersonalDetails2.html',
                            controller: 'cardPersonalDetails2Controller',
                            controllerAs: 'step2Vm'
                        }
                    }
                })
                .state('menu.cardProfessional1', {
                    url: '/cardProfessionalA',
                    data: {
                        pageId: 'CRDS_CRDPFNLDETLA'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/cards/applyNow/cardProfessionalDetails3.html',
                            controller: 'cardProfessionalDetails3Controller',
                            controllerAs: 'step3Vm',
                        }
                    }
                })
                .state('menu.cardProfessional2', {
                    url: '/cardProfessionalB',
                    data: {
                        pageId: 'CRDS_CRDPFNLDETLB'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/cards/applyNow/cardProfessionalDetails4.html',
                            controller: 'cardProfessionalDetails4Controller',
                            controllerAs: 'step4Vm',
                        }
                    }
                })
                .state('menu.cardRequestApprove', {
                    url: '/cardRequestApprove',
                    data: {
                        pageId: 'CRDS_CRDRQSTAPRV'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/cards/applyNow/cardRequestApprove.html',
                            controller: 'cardRequestApproveController',
                            controllerAs: 'cardApproveVm',
                        }
                    }
                })
                .state('menu.cardWelcome', {
                    url: '/cardWelcome',
                    data: {
                        pageId: 'CRDS_CRDWLC'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/cards/getNewCard/needAnalysis/cardWelcome.html',
                            controller: 'cardWelcomeController',
                            controllerAs: 'cardWelcomeVm',
                        }
                    }
                })
                .state('menu.cardAnnualIncome', {
                    url: '/cardAnnualIncome',
                    data: {
                        pageId: 'CRDS_CRDANLINC'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/cards/getNewCard/needAnalysis/cardAnnualIncome.html',
                            controller: 'cardAnnualIncomeController',
                            controllerAs: 'incomeVm',
                        }
                    }
                })
                .state('menu.cardPrivileges', {
                    url: '/cardPrivileges',
                    data: {
                        pageId: 'CRDS_CRDPVLGS'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/cards/getNewCard/needAnalysis/cardPrivileges.html',
                            controller: 'cardPrivilegesController',
                            controllerAs: 'privilegesVm',
                        }
                    }
                })
                .state('menu.cardExpenses', {
                    url: '/cardExpenses',
                    data: {
                        pageId: 'CRDS_CRDEXPS'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/cards/getNewCard/needAnalysis/cardExpenses.html',
                            controller: 'cardExpensesController',
                            controllerAs: 'expensesVm',
                        }
                    }
                })
                .state('menu.cardSuggestion', {
                    url: '/cardSuggestion',
                    data: {
                        pageId: 'CRDS_CRDSUGN'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/cards/getNewCard/needAnalysis/cardSuggestion.html',
                            controller: 'cardSuggestionController',
                            controllerAs: 'suggestionVm',
                        }
                    }
                })
                .state('menu.cardPlatinum', {
                    url: '/cardPlatinum',
                    data: {
                        pageId: 'CRDS_CRDPLTM'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/cards/cardFeatures/cardPlatinum.html',
                            controller: 'cardPlatinumController',
                            controllerAs: 'cardPlatinumVm',
                        }
                    }
                })
                .state('menu.cardComparison', {
                    url: '/cardComparison',
                    data: {
                        pageId: 'CRDS_CRDCMPN'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/cards/common/cardComparison.html',
                            controller: 'cardComparisonController',
                            controllerAs: 'compareVm',
                        }
                    }
                })
                .state('menu.cardPaymentOtp', {
                    url: '/cardPaymentOtp',
                    data: {
                        pageId: 'CRDS_CRDPAYMNTOTP'
                    },
                    cache: false,
                    views: {
                        'menuContent': {

                            templateUrl: 'pages/cards/payNow/cardPaymentOtp.html',
                            controller: 'cardPaymentOtpController',
                            controllerAs: 'cardPaymentOtpVm',
                        }
                    }
                })

                .state('menu.retrieveTrackApplication', {
                    url: '/retrieveTrackApplication',
                    data: {
                        pageId: 'CRDS_RTRVTRCKAPPCTN'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/cards/linkCard/retrieveTrackApplication.html',
                            controller: 'retrieveTrackApplicationController',
                            controllerAs: 'retrieveTrackApplicationVm',
                        }
                    }
                })
            //PAC Docs collection screen navigation
            .state('menu.documentCollection', {
                url: '/documentCollection',
                data: {
                    pageId: 'CRDS_PAC_DOCSCOLLECT'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/cards/preApprovedCard/documentCollection.html',
                        controller: 'viewAllPACController',
                        controllerAs: 'viewAllPacListVm'
                    }
                }
            })
				//shikhar cards screen navigation
            .state('menu.shikharCards', {
                url: '/shikharCards',
                data: {
                    pageId: 'CRDS_SHIKHAR'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/cards/shikhar/shikharCards.html',
                        controller: 'shikharCardsController',
                        controllerAs: 'shikharCardsVm'
                    }
                }
            })
            .state('menu.ccdocumentCollection', {
                url: '/ccdocumentCollection',
                data: {
                    pageId: 'CRDS_PAC_DOCSCOLLECT'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/cards/applyNow/documentCollection.html',
                        controller: 'documentCollectionController',
                        controllerAs: 'documentCollectionVm'
                    }
                }
            })

            .state('menu.leadGenerationCreditCard', {
                url: '/leadGenerationCreditCard',
                data: {
                    pageId: 'LEAD_GEN_CREDIT_CARD'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/accountOverview/outboundAnalytics/leadGenerationCreditCard.html',
                        controller: 'leadGenerationCreditCardController',
                        controllerAs: 'leadGenerationCreditCardVm'
                    }
                }
            })

    }
    ]);
