

'use strict';

angularApp.controller('cardPlatinumController', ["$state", "$scope", "newCardService", "cardConfig", "linkCardService", "cardsService", "applyNowService", "utilityService", "mPinLoginService", "clickStreamService", "$ionicPopup", "cardCompareService","$ionicScrollDelegate","$timeout","$ionicHistory","homeScreenService","loggedInUserService","leadGenerationService",
    function($state, $scope, newCardService, cardConfig, linkCardService, cardsService, applyNowService, utilityService, mPinLoginService, clickStreamService, $ionicPopup, cardCompareService,$ionicScrollDelegate,$timeout,$ionicHistory,homeScreenService,loggedInUserService,leadGenerationService) {

        
        var cardPlatinumVm = this;
        cardPlatinumVm.blockApply = true;

        
        function initPage() {
            validToApply();
            cardPlatinumVm.goToCard();
			$scope.cardPlatinumVm.divShow = false;
        }


        function resetApplyForm() {
            applyNowService.resetParams();

        }

		 var scrollTimer;
		$scope.ScrollerPosition = function(){  
			console.log("Scroll pos from top")
			
			if (scrollTimer) {
			  $timeout.cancel(scrollTimer);
			}
			var position = $ionicScrollDelegate.$getByHandle('mapDelegate').getScrollPosition();
			scrollTimer = $timeout(function() {
			  scrollEnded(position);
			  if(position.top > 10){
				$scope.cardPlatinumVm.divShow = true;
				document.getElementsByClassName('scrollchange')[0].style.setProperty('margin-top', '36%', 'important');
			  }
			  else{
				$scope.cardPlatinumVm.divShow = false;
				document.getElementsByClassName('scrollchange')[0].style.setProperty('margin-top', '59%', 'important');
			  }
			}, 100);
						  	
		}

        $scope.ScrollerPositionReset = function(){  
			console.log("Scroll pos from top")
			if (scrollTimer) {
			  $timeout.cancel(scrollTimer);
			}
			//var position = $ionicScrollDelegate.$getByHandle('mapDelegate').getScrollPosition();
			scrollTimer = $timeout(function() {
			  //scrollEnded(position);
                if($scope.cardPlatinumVm.divShow == true){
                    $scope.cardPlatinumVm.divShow = false;
                    document.getElementsByClassName('scrollchange')[0].style.setProperty('margin-top', '59%', 'important'); 
                }
                $timeout(function() {
                    $ionicScrollDelegate.$getByHandle().scrollTop();
                },10);
			}, 100);
						  	
		}
		
		function scrollEnded(position) {
			
		}
		
        function allowApplication() {
            applyNowService.resetApplyForm();
            newCardService.setParams({ "applyCardType": cardPlatinumVm.cardDetail.cardType });
            newCardService.setParams({ "applyCardName": cardPlatinumVm.cardDetail.cardName });
            newCardService.setParams({ "applyPictureURL": cardPlatinumVm.cardDetail.pictureURL });
            newCardService.setParams({ "applyCardCategory": cardPlatinumVm.cardDetail.categoryName });
            if(loggedInUserService.isLoggedInDetails.isLoggedIn){
                applyNowService.getCities().then(function(response) {
                cardsService.errorLogger(response);
                cardsService.setParams({ "city": response.data.cities });
                cardsService.setParams({ 'pendingApplication': false });                
                //Adding below code for centralised consent sprint 2 journey
                leadGenerationService.checkConsent().then(function(response){
                    if(response.customerRecordExists == "false"){
                        newCardService.setPreLoginSelectedMenu('cards');
                        loggedInUserService.productClicked = 'menu.termsAndConditionsOutboundAnalytics';
                        $state.go('menu.termsAndConditionsOutboundAnalytics');
                    }else{
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "CC_START_NXT_BTN"));
                        $state.go('menu.cardPersonalDetails1');    
                    }
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }else{
                newCardService.setPreLoginSelectedMenu('cards');
                newCardService.setTermsAndConditionsOutboundAnalyticsData(cardPlatinumVm.cardDetail);
                loggedInUserService.productClicked = 'menu.termsAndConditionsOutboundAnalytics';
                $state.go('menu.userLogin');
            }
            
        }

        //go to city selection page
        cardPlatinumVm.applyNow = function() {
            if(loggedInUserService.isLoggedInDetails.isLoggedIn){
                utilityService.showSpinner();
                if(linkCardService.getAllowAppStatus() == ""){
                    linkCardService.getPendingApplicationStatus({})
                    .then(function(response) {
                            cardsService.errorLogger(response);
                            if (response.data) {
                                    if (response.data.allow == "false"){
                                        linkCardService.setAllowAppStatus(response.data);
                                        utilityService.hideSpinner();
                                        utilityService.enableShowErrorMessage(); 
                                        utilityService.showErrorMessage(response.data.allowMessage);   
                                        return false;       
                                    }
                                    else{
                                        linkCardService.setAllowAppStatus(response.data);
                                        allowApplication();
                                    }
                            }
                        },
                        function(error) {
                            utilityService.hideSpinner();
                            allowApplication();
                        });
                }
                else{
                    if(linkCardService.getAllowAppStatus().allow == "false"){
                        utilityService.hideSpinner();
                        utilityService.enableShowErrorMessage(); 
                        utilityService.showErrorMessage(linkCardService.getAllowAppStatus().allowMessage);   
                        return false;       
                    }
                    else{
                        utilityService.hideSpinner();
                        allowApplication();
                    }
                }
            }else{
                    allowApplication();
            } 

            
            
        }


		// OMP Banner changes start
		cardPlatinumVm.OMPGoBack = function() {
          cardCompareService.getShikharEligibilityCheck().then(function(response){
    			        //Commenting below code to fix the issue of Tabs not visible
                        // cardCompareService.shikharFlag = response.data.shikharFlag;
                //   if(cardCompareService.shikharFlag == true || cardCompareService.shikharFlag == "true"){
              		// 	$state.go('menu.shikharCards');
              		// }else 
                    //Commenting below if for cashback card until business confirmation
                    // if(homeScreenService.yccKnowMoreFlag == true){
                    //     homeScreenService.yccKnowMoreFlag = false;
                    //     $ionicHistory.goBack(-1);

                    // }else{
            				newCardService.getCardsList().then(function(response) {
            				  cardsService.errorLogger(response);
            				  if (response.data && response.data.cards.length > 0) {
            					cardsService.setParams({ "browseAllCards": response.data.cards });
                                cardsService.setParams({ "browseCardsTabSelected": 'All' });//added this line for YONO cashback navigation
            					$state.go('menu.browseCards');
            				  }
            				}, function(error) {
            				  utilityService.showErrorMessage(error.responseMessage);
            				});
            		//	}
    		},function(error){
    			   cardCompareService.shikharFlag = "";
    		});
		}
		

        cardPlatinumVm.goToCard = function() {
            if(!loggedInUserService.isLoggedInDetails.isLoggedIn){
                var payload = {
                cardName: cardsService.getParams().cardName
                };
                newCardService.getCardPreLogin(payload).then(function(response) {
                    cardsService.errorLogger(response);
                    if (response.data && response.data.cardFeatures.length > 0 && response.data.pictureURL) {
                        response.data.pictureURL = response.data.pictureURL.replace(cardConfig.cardUrl.other_card, "https://www");
                        response.data.pictureURL = response.data.pictureURL.replace(cardConfig.cardUrl.tata_card, "https://www.tatacard.com");

                        cardsService.setParams({ "cardDetail": response.data });
                        cardPlatinumVm.getCard();
                    } else {
                        var erroObj = {
                            cssClass: 'sbi-alert-popup',
                            template: '<div class="text-align-center font-content roboto-regular" translate="ResponseError"> </div>',
                            buttons: [{
                                text: cardConfig.buttons.OK_LABEL,
                                type: 'button-positive'
                            }]
                        };
                        cardsService.alertModal(erroObj, null);

                    }
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }else{
                var payload = {
                    cardName: cardsService.getParams().cardName
                };
                newCardService.getCard(payload).then(function(response) {
                    cardsService.errorLogger(response);
                    if (response.data && response.data.cardFeatures.length > 0 && response.data.pictureURL) {
                        response.data.pictureURL = response.data.pictureURL.replace(cardConfig.cardUrl.other_card, "https://www");
                        response.data.pictureURL = response.data.pictureURL.replace(cardConfig.cardUrl.tata_card, "https://www.tatacard.com");
                        cardsService.setParams({ "cardDetail": response.data });
                        cardPlatinumVm.getCard();
                    } else {
                        var erroObj = {
                            cssClass: 'sbi-alert-popup',
                            template: '<div class="text-align-center font-content roboto-regular" translate="ResponseError"> </div>',
                            buttons: [{
                                text: cardConfig.buttons.OK_LABEL,
                                type: 'button-positive'
                            }]
                        };
                        cardsService.alertModal(erroObj, null);
                    }
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }

        }


        function validToApply() {
            cardPlatinumVm.blockApply = false;
        }

        cardPlatinumVm.getCard = function() {
            cardPlatinumVm.cardDetail = cardsService.getParams().cardDetail;
            cardPlatinumVm.cardDetail.pictureURL = cardPlatinumVm.cardDetail.pictureURL.replace(cardConfig.cardUrl.other_card, "https://www");
            cardPlatinumVm.cardDetail.pictureURL = cardPlatinumVm.cardDetail.pictureURL.replace(cardConfig.cardUrl.tata_card, "https://www.tatacard.com");
            cardPlatinumVm.headerList = [];
            angular.forEach(cardPlatinumVm.cardDetail.cardFeatures, function(value, key) {
                cardPlatinumVm.headerList.push(value.title);
            });
            cardPlatinumVm.showCategory = cardPlatinumVm.headerList[0];
            cardPlatinumVm.cardRewards = cardPlatinumVm.cardDetail.cardFeatures[0]['cardSubFeatures'][1]['descriptions'][0];
        }

       
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
