
'use strict';

angularApp.controller('cardComparisonController', ["$state", "$scope", "cardCompareService", "newCardService", "cardsService", "utilityService", "cardConfig","clickStreamService","applyNowService","linkCardService","loggedInUserService","leadGenerationService",
    function($state, $scope, cardCompareService, newCardService, cardsService, utilityService, cardConfig,clickStreamService,applyNowService,linkCardService,loggedInUserService,leadGenerationService) {

        
        var compareVm = this;

        //private methods section start
        function initPage() {
            compareVm.cardDetails = [];
            compareVm.getCardsToCompare();
        }

        // get cards to compare list
        compareVm.getCardsToCompare = function() {
            compareVm.cardDetails = cardsService.getParams().cardCompareData;
            angular.forEach(compareVm.cardDetails, function(value, key) {

              
                value.pictureURL = value.pictureURL.replace(cardConfig.cardUrl.other_card, "https://www");
                value.pictureURL = value.pictureURL.replace(cardConfig.cardUrl.tata_card, "https://www.tatacard.com");
            });
        }

        compareVm.goToCard = function(card) {
            //clickStreamService.clickStreamData = cardsService.getParams().cardName;

            cardsService.setParams({ "cardName": card.cardName });

            $state.go('menu.cardPlatinum');
        }

      
        
		compareVm.applyNow = function(card) {
            if(!loggedInUserService.isLoggedInDetails.isLoggedIn){
                newCardService.setPreLoginSelectedMenu('cards');
                newCardService.setTermsAndConditionsOutboundAnalyticsData(card);
                loggedInUserService.productClicked = 'menu.termsAndConditionsOutboundAnalytics';
                $state.go('menu.userLogin');
            }else{
                utilityService.showSpinner();
                if(linkCardService.getAllowAppStatus() == ""){
                    linkCardService.getPendingApplicationStatus({})
                    .then(function(response) {
                            cardsService.errorLogger(response);
                            if (response.data) {
                                    if (response.data.allow == "false"){
                                        linkCardService.setAllowAppStatus(response.data);
                                        utilityService.hideSpinner();
                                        utilityService.enableShowErrorMessage(); 
                                        utilityService.showErrorMessage(response.data.allowMessage);   
                                        return false;       
                                    }
                                    else{
                                        linkCardService.setAllowAppStatus(response.data);
                                        allowApplication(card);
                                    }
                            }
                        },
                        function(error) {
                            utilityService.hideSpinner();
                            allowApplication(card);
                        });
                }
                else{
                    if(linkCardService.getAllowAppStatus().allow == "false"){
                        utilityService.hideSpinner();
                        utilityService.enableShowErrorMessage(); 
                        utilityService.showErrorMessage(linkCardService.getAllowAppStatus().allowMessage);   
                        return false;       
                    }
                    else{
                        utilityService.hideSpinner();
                        allowApplication(card);
                    }
                }
            }            
        };

		function allowApplication(card) {
            applyNowService.resetApplyForm();
            newCardService.setParams({ "applyCardType": card.cardType });
            newCardService.setParams({ "applyCardName": card.cardName });
            newCardService.setParams({ "applyPictureURL": card.pictureURL });
            newCardService.setParams({ "applyCardCategory": card.categoryName });

            applyNowService.getCities().then(function(response) {
                cardsService.errorLogger(response);
                cardsService.setParams({ "city": response.data.cities });
                cardsService.setParams({ 'pendingApplication': false });
                
                //$state.go('menu.cardPersonalDetails1');
                //Adding below code for centralised consent sprint 2 journey 
                leadGenerationService.checkConsent().then(function(response){
                    if(response.customerRecordExists == "false"){
                        newCardService.setPreLoginSelectedMenu('cards');
                        loggedInUserService.productClicked = 'menu.termsAndConditionsOutboundAnalytics';
                        $state.go('menu.termsAndConditionsOutboundAnalytics');
                    }else{
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "CC_START_NXT_BTN"));
                        $state.go('menu.cardPersonalDetails1');    
                    }
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
               
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }




       
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
