'use strict';

angularApp.controller('confirmCardBlockHotlistController', ["$state",
    "$scope",
    "$stateParams",
    "$translate",
    "cardsService",
    "floatingMenuService",
    "$filter",
    "cardConfig",
    "$timeout",
    "linkCardService", "utilityService",
    "cardCompareService",
    "getAccountDetailsService", "$ionicPopup",

    function($state,
        $scope,
        $stateParams,
        $translate,
        cardsService,
        floatingMenuService,
        $filter,
        cardConfig,
        $timeout,
        linkCardService, utilityService,
        cardCompareService,
        getAccountDetailsService,
        $ionicPopup) {

        //functions, variables that can be accessed from the HTML come here
        var confirmCardBlockHotlistVm = this;
        //Entry point
        function initPage() {
           confirmCardBlockHotlistVm.cardDisabled = false;
            confirmCardBlockHotlistVm.reissueChecked = false;
            confirmCardBlockHotlistVm.cardNumber = floatingMenuService.getParams().floatingCard;
            confirmCardBlockHotlistVm.maskedCardNumber = $filter('cardmask')(confirmCardBlockHotlistVm.cardNumber, 'X', '4', '-');
            confirmCardBlockHotlistVm.translationData = {
                cardNumber: confirmCardBlockHotlistVm.maskedCardNumber
            }
            confirmCardBlockHotlistVm.sbiLink = cardConfig.links.register;
            confirmCardBlockHotlistVm.address1 = "The card will be sent to your registered address:"
            getCardHolderDetails();
        }
        // cancel Block card and take user to card account overview
        confirmCardBlockHotlistVm.cancelHotlist = function() {
                $state.go('menu.selectCardBlockHotlist');
            }
            // confirm Block card 
        confirmCardBlockHotlistVm.confirmHotlist = function() {
            var str = '<img class="fss-popup-activated-img" src="img/FSS/Approved.svg"><div class="text-align-center font-content sbi-sub-label roboto-regular">';
            var data = {
                cardNumber: confirmCardBlockHotlistVm.cardNumber,
                reissue: confirmCardBlockHotlistVm.reissueChecked
               // accountId : cardCompareService.accountId
            };


            var alertObj = {
                cssClass: 'sbi-alert-popup',
                buttons: [{
                    text: cardConfig.buttons.OK_LABEL,
                    type: 'button-positive',
                    onTap: function(e) {

                    }
                }]
            };
            floatingMenuService.hotlist(data)
                .then(function(response) {
                    confirmCardBlockHotlistVm.cardDisabled = true;
                        if (confirmCardBlockHotlistVm.reissueChecked) {
                            if (response.responseCode == cardConfig.responseCode.success) {
                                
                                var temp = response.data.srNumber;
                                 if(temp == null || temp == undefined || temp == ""){
                                    $translate('REISSUE_TXT_1', { cardNumber: confirmCardBlockHotlistVm.maskedCardNumber})
                                    .then(function(translation) {
                                        alertObj.template = str + translation + '</div>';
                                        cardsService.alertModal(alertObj, function(res) {
                                             refreshCardsDetail();
                                    });      
                                });

                            }else{

                                if(response.data.status.toLowerCase() ==='pvr')
                                {
                                 $translate('REISSUE_TXT_1_SR_PVR', { cardNumber: confirmCardBlockHotlistVm.maskedCardNumber,desc:response.data.desc,srNumber:response.data.srNumber})
                                    .then(function(translation) {
                                        alertObj.template = str + translation + '</div>';
                                        cardsService.alertModal(alertObj, function(res) {
                                             refreshCardsDetail();
                                    });
                                         
                                });
                            }

                            else
                            {
                                $translate('REISSUE_TXT_1_SR', { cardNumber: confirmCardBlockHotlistVm.maskedCardNumber,srNumber:response.data.srNumber})
                                    .then(function(translation) {
                                        alertObj.template = str + translation + '</div>';
                                        cardsService.alertModal(alertObj, function(res) {
                                             refreshCardsDetail();
                                    });
                                         
                                });

                            }
                        }

                           }

                        } else {

                            if (response.responseCode == cardConfig.responseCode.success) {                                                         
                                 var temp = response.data.srNumber;
                                 if(temp == null || temp == undefined || temp == ""){
                                $translate('HOTLIST_TXT', { cardNumber: confirmCardBlockHotlistVm.maskedCardNumber}).then(function(translation) {
                                    alertObj.template = str + translation + '</div>';
                                     cardsService.alertModal(alertObj, function(res) {
                                         refreshCardsDetail();
                                     });
                                });
                             }

                        else{
                         $translate('HOTLIST_TXT_SR', {cardNumber :confirmCardBlockHotlistVm.maskedCardNumber, srNumber:response.data.srNumber}).then(function(translation) {
                                 alertObj.template = str + translation + '</div>';
                                 cardsService.alertModal(alertObj, function(res) {
                                     refreshCardsDetail();
                                    });
                                });
                            }
                            }
                        }


                        cardsService.errorLogger(response);

                    },
                    function(error) {
                        //utilityService.showErrorMessage(error.responseMessage);
                        var messageTitle = "";
                        if(error.responseCode == "8505"){
                            messageTitle = "message";
                        }
                        var alertPop = $ionicPopup.alert({
                                title: messageTitle,
                                template: error.responseMessage
                            });
                            alertPop.then(function(res) {

                                if (res) {
                                   // getAccountDetailsService.tabIndex.tabIndex = 5;
                                    //$state.go('menu.cardOverview');
                                     refreshCardsDetail();

                                }

                            });

                    });



            
        }

        function getCardHolderDetails() {

            confirmCardBlockHotlistVm.address2 = cardsService.getParams().reissueAddress;

        }
        
        $timeout(function() {
            document.getElementById("e45-e0ed-erf3-d34d").addEventListener("click", function() {
                floatingMenuService.getRedirectionMessage().then(function(response) {
                    cardsService.errorLogger(response);
                    if (response.data && response.data.message) {
                        cardsService.setParams({ "rewardsAgreeContent": response.data.message });
                        floatingMenuService.setParams({ "sourceRedirect": "blockCard" });
                        $state.go('menu.rewardsAgree');
                    }
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });

            });
        }, 50);

        //actions to done everytime the view is shown

        $scope.$on('$ionicView.beforeEnter', function(event, data) {
            initPage(data.stateParams);
            confirmCardBlockHotlistVm.disablecheck = cardCompareService.disableBlock;
        });

         confirmCardBlockHotlistVm.toRewardsAgree = function() {
        floatingMenuService.getRedirectionMessage().then(function(response) {
            cardsService.errorLogger(response);
            if (response.data && response.data.message) {
                cardsService.setParams({ "rewardsAgreeContent": response.data.message });
                floatingMenuService.setParams({ "sourceRedirect": "blockCard" });
                $state.go("menu.rewardsAgree");
            }


        }, function(error) {
            utilityService.showErrorMessage(error.responseMessage);
        });
    };

        function refreshCardsDetail() {
            linkCardService.getLinkedCards({})
                .then(function(response) {
                    cardsService.errorLogger(response);
                    switch (response.responseCode) {
                        case cardConfig.responseCode["success"]:
                            if (response) {
                                var cardList = (response.data.cards) ? response.data.cards : [];
                                cardsService.setCardList(cardList); // setting card list
                               // $state.go('menu.cardOverview');
                               getAccountDetailsService.tabIndex.tabIndex=5;
                            $state.go('menu.accountOverviewMyBalance');

                            }
                            break;
                    }
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
        }

    }
]);

