/*
    Module Name  : Cards,
    File Name    : floatingMenuService.js,
    Description  : All floating menu related service calls
*/


'use strict';


angularApp.service('floatingMenuService', ['commonAPIService', 'cardConfig', '$q', 'AdapterUtils',
    function(commonAPIService, cardConfig, $q, AdapterUtils) {

        var floatingMenuService = this;
        var params = {};
        var isResend;

        floatingMenuService.setIsResend = function(value) {
            isResend = value;
        };

        floatingMenuService.getIsResend = function() {
            return isResend;
        };

        floatingMenuService.isResesndExhaust=false;
        floatingMenuService.isTextExhaust=false;

        // adapter call for reset pin page
        floatingMenuService.resetPin = function(requestParams) {
                var q = $q.defer();
                AdapterUtils.postData(cardConfig.adapterURL.resetPin[0], requestParams, true).then(
                    function(response) {

                        q.resolve(response);
                    },
                    function(error) {
                        q.reject(error);
                    }
                );
                return q.promise;
            }

                 floatingMenuService.validateOTPForPayment = function(requestParams) {
                var q = $q.defer();
                AdapterUtils.postDataWithTimeOut(cardConfig.adapterURL.validateOTPForPayment[0], requestParams, false,130000).then(
                    function(response) {

                        q.resolve(response);
                    },
                    function(error) {
                        q.reject(error);
                    }
                );
                return q.promise;
            }



            // adapter call for rewards page
        floatingMenuService.rewards = function(queryParam, callback) {
            var path = cardConfig.adapterURL.rewards[0] + '?cardNumber=' + queryParam;
            commonAPIService.invokeAdapter(path, cardConfig.adapterURL.rewards[1], null, callback);
        };

        // adapter call for transaction page
        floatingMenuService.transaction = function(payload, callback) {
            var q = $q.defer();
            AdapterUtils.postData(cardConfig.adapterURL.transactions[0], payload, false).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        // adapter call for hotlist/ block card page
        floatingMenuService.hotlist = function(requestParams, callback) {
             var q = $q.defer();
            AdapterUtils.postData(cardConfig.adapterURL.blockCard[0], requestParams, true).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        // adapter call for user re-issue address
        floatingMenuService.getCardHolderDetails = function(data) {

            var q = $q.defer();
            AdapterUtils.postData(cardConfig.adapterURL.getCardHolderDetails[0], data, true).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        // adapter call for international usage page
        floatingMenuService.getInternationalUsage = function(queryParam, callback) {
            var path = cardConfig.adapterURL.getInternationalUsage[0] + '?cardNumber=' + queryParam;
            commonAPIService.invokeAdapter(path, cardConfig.adapterURL.getInternationalUsage[1], null, callback);
        };
        // adapter call for changing international usage page
        floatingMenuService.changeInternationalUsage = function(requestParams, callback) {
              var q = $q.defer();
            AdapterUtils.postData(cardConfig.adapterURL.changeInternationalUsage[0], requestParams, true).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        // adapter call for redirection message
        floatingMenuService.getRedirectionMessage = function(callback) {
              var q = $q.defer();
            AdapterUtils.getData(cardConfig.adapterURL.getRedirectionMessage[0], {}, true).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        // set params object
        floatingMenuService.setParams = function(obj) {
                var setParams = angular.extend(params, obj);
            }
            // get params object
        floatingMenuService.getParams = function() {
                return params;
            }
            // reset params object
        floatingMenuService.resetParams = function() {
            params = {};
        }
        floatingMenuService.sendOTP = function(queryParam) {
            var q = $q.defer();
            AdapterUtils.postData(cardConfig.adapterURL.sendOTPForResetPIN[0], queryParam, true).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        floatingMenuService.getTermsAndCondition = function(callback) {
                  var q = $q.defer();
            AdapterUtils.getData(cardConfig.adapterURL.getTermsAndConditions[0], {}, true).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        floatingMenuService.validateOTP = function(payload) {
            var q = $q.defer();
            AdapterUtils.postData(cardConfig.adapterURL.validateOTPForResetPIN[0], payload, true).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        return floatingMenuService;

    }
]);
