(function() {

    'use strict';

    angularApp.controller('internationalUsageActivateController', ["$state",
        "$scope",
        "$stateParams",
        "$translate",
        "cardsService",
        "floatingMenuService",
        "$filter",
        "cardConfig",
        "linkCardService", "utilityService",
        "cardCompareService",
        function($state,
            $scope,
            $stateParams,
            $translate,
            cardsService,
            floatingMenuService,
            $filter,
            cardConfig,
            linkCardService, utilityService,
            cardCompareService) {

            //functions, variables that can be accessed from the HTML come here
            var internationalUsageActivateVm = this;
            //private methods section start
            function initPage() {

                internationalUsageActivateVm.currentStatus = '';

                var cards = cardsService.getCardList();

                internationalUsageActivateVm.card = cards[cardsService.getSelectedCard()];
                internationalUsageActivateVm.cardNumber = internationalUsageActivateVm.card.cardNumber;
                internationalUsageActivateVm.getInternationalUsage(internationalUsageActivateVm.cardNumber); 

            }

            // go to home
            internationalUsageActivateVm.goBackHome = function() {
                $state.go('menu.cardOverview');
            }

            //get internaltional usage and change button text and status
            internationalUsageActivateVm.getInternationalUsage = function(cardNumber) {


                internationalUsageActivateVm.currentStatus = internationalUsageActivateVm.card.internationalUsageStatus;
                if (internationalUsageActivateVm.currentStatus == 'Active') {
                    internationalUsageActivateVm.btnTxt = 'Deactivate';
                    internationalUsageActivateVm.activate = true;
                    internationalUsageActivateVm.deactivate = false;
                    internationalUsageActivateVm.currentStatus = 'Active';
                } else {
                    internationalUsageActivateVm.btnTxt = 'Activate';
                    internationalUsageActivateVm.deactivate = true;
                    internationalUsageActivateVm.activate = false;
                    internationalUsageActivateVm.currentStatus = 'Inactive';
                }
                internationalUsageActivateVm.translationData = {
                    currentStatus: internationalUsageActivateVm.currentStatus
                }


            }
                //change button into active and inactive vice versa
                internationalUsageActivateVm.changeInternationalUsage = function() {
                    var data = {
                        cardNumber: internationalUsageActivateVm.cardNumber,
                        tnc : true
                       // accountId : cardCompareService.accountId
                    };
                    if (internationalUsageActivateVm.currentStatus.toLowerCase() == 'active') {
                    // internationalUsageActivateVm.currentStatus = 'Inactive';
                    data.status = "1";
                    internationalUsageActivateVm.checkvalue = false;
                } else {
                    // internationalUsageActivateVm.currentStatus = 'Active';
                    data.status = "0";
                }


                var alertObj = {
                    cssClass: 'sbi-alert-popup',
                    buttons: [{
                        text: cardConfig.buttons.OK_LABEL,
                        type: 'button-positive',
                        onTap: function(e) {
                            refreshCardsDetail();
                           
                        }
                    }]

                }
                    //based on status show popup message

                    floatingMenuService.changeInternationalUsage(data).then(function(response) {
                       


                        cardsService.errorLogger(response);
                        var temp = response.data.srNumber;
                        var cardNumber = $filter('cardmask')(internationalUsageActivateVm.cardNumber, 'X', '4', '-');
                        if (internationalUsageActivateVm.currentStatus.toLowerCase() == 'inactive') {
                         var str = '<img class="fss-popup-activated-img" src="img/FSS/Approved.svg"><p class="roboto-regular fontSize-heading fss-m-b-30" translate="ACTIVATE_TXT"></p><div class="text-align-center font-content sbi-sub-label roboto-regular">';

                         if(temp == null || temp == undefined || temp == ""){
                             $translate('ACTIVATE_MSG', { cardNumber: cardNumber}).then(function(translation) {
                                alertObj.template = str + translation + '</div>';
                                if (response.data.responseCode == cardConfig.responseCode.dataSuccess) {
                                   // refreshCardsDetail();
                                internationalUsageActivateVm.currentStatus = 'Active';
                                internationalUsageActivateVm.btnTxt = 'Deactivate';
                                 internationalUsageActivateVm.activate = true;
                                 internationalUsageActivateVm.deactivate=false;

                                    internationalUsageActivateVm.translationData = {
                                        currentStatus: internationalUsageActivateVm.currentStatus
                                    }
                                    cardsService.alertModal(alertObj, function(res) {
                                    // $state.go('menu.cardOverview');

                                });

                                }
                            });
                         }else{
                            $translate('ACTIVATE_MSG_SR', {cardNumber: cardNumber,srNumber:temp}).then(function(translation) {
                                alertObj.template = str + translation + '</div>';
                                if (response.data.responseCode == cardConfig.responseCode.dataSuccess) {
                                    //refreshCardsDetail();
                                     internationalUsageActivateVm.currentStatus = 'Active';
                                    internationalUsageActivateVm.btnTxt = 'Deactivate';
                                    internationalUsageActivateVm.activate = true;
                                     internationalUsageActivateVm.deactivate=false;
                                    internationalUsageActivateVm.translationData = {
                                        currentStatus: internationalUsageActivateVm.currentStatus
                                    }
                                    cardsService.alertModal(alertObj, function(res) {
                                    // $state.go('menu.cardOverview');

                                });

                                }
                            });
                        }                       
                    } else {                     
                       var str = '<img class="fss-popup-activated-img" src="img/FSS/Approved.svg"><p class="roboto-regular fontSize-heading fss-m-b-30" translate="DEACTIVATE_TXT"></p><div class="text-align-center font-content sbi-sub-label roboto-regular">';

                       if(temp == null || temp == undefined || temp == ""){

                         $translate('DEACTIVATE_MSG', { cardNumber: cardNumber}).then(function(translation) {
                            alertObj.template = str + translation + '</div>';
                            if (response.data.responseCode == cardConfig.responseCode.dataSuccess) {
                                //refreshCardsDetail();
                                internationalUsageActivateVm.currentStatus = 'Inactive';
                                internationalUsageActivateVm.btnTxt = 'Activate';
                                 internationalUsageActivateVm.activate = false;
                                     internationalUsageActivateVm.deactivate=true;
                                internationalUsageActivateVm.translationData = {
                                    currentStatus: internationalUsageActivateVm.currentStatus
                                }
                                cardsService.alertModal(alertObj, function(res) {
                                    // $state.go('menu.cardOverview');

                                });

                            }
                        });
                     }else{

                        $translate('DEACTIVATE_MSG_SR', {cardNumber: cardNumber,srNumber:temp}).then(function(translation) {
                            alertObj.template = str + translation + '</div>';
                            if (response.data.responseCode == cardConfig.responseCode.dataSuccess) {
                               // refreshCardsDetail();
                               internationalUsageActivateVm.currentStatus = 'Inactive';
                                internationalUsageActivateVm.btnTxt = 'Activate';
                                internationalUsageActivateVm.activate = false;
                                     internationalUsageActivateVm.deactivate=true;
                                internationalUsageActivateVm.translationData = {
                                    currentStatus: internationalUsageActivateVm.currentStatus
                                }
                                cardsService.alertModal(alertObj, function(res) {
                                    // $state.go('menu.cardOverview');

                                });

                            }
                        });
                    }

                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

}

            //actions to done everytime the view is shown
            function refreshCardsDetail() {
                 utilityService.showSpinner(); 
                linkCardService.getLinkedCards({})
                .then(function(response) {
                    cardsService.errorLogger(response);
                    switch (response.responseCode) {
                        case cardConfig.responseCode["success"]:

                        /* on successful login - send OTP */
                        if (response) {
                            var cardList = (response.data.cards) ? response.data.cards : [];
                                    cardsService.setCardList(cardList); 
                                     utilityService.hideSpinner();
                                     $state.go('menu.cardOverview');

                                }
                                break;
                            }
                        }, function(error) {
                             utilityService.hideSpinner(); 
                            utilityService.showErrorMessage(error.responseMessage);
                        });
            }

            $scope.$on('$ionicView.beforeEnter', function(event, data) {
                initPage();
            });

        }
        ]);
})();
