
'use strict';

angularApp.controller('cardTransactionsController', ["$state",
    "$scope",
    "$stateParams",
    "cardsService",
    "floatingMenuService",
    "cardConfig", "utilityService",
    "cardCompareService",
    "$ionicPopup","$ionicHistory",
    function($state,
        $scope,
        $stateParams,
        cardsService,
        floatingMenuService,
        cardConfig, utilityService,
        cardCompareService,
        $ionicPopup,$ionicHistory) {

        //functions, variables that can be accessed from the HTML come here
        var cardTransactionsVm = this;
        var transactions = [];
        var cardIndexTransactions = 0;
      
        //private methods section start
        function initPage(stateParams) {
            $scope.shownGroup = null;
            cardTransactionsVm.selectedAcctype = null;
            cardTransactionsVm.lastVisibleIndex = [];
            cardTransactionsVm.cardList = [];
            cardTransactionsVm.selectedTransactionList = [];
            cardTransactionsVm.noMoreTransactions = [];
            cardTransactionsVm.card = cardsService.getSetCardDetail();
            cardTransactionsVm.card.cardRank = "Primary Card";
            cardTransactionsVm.card.sortOrder="descending";
            cardTransactionsVm.card.lastIndex = 10;

            cardTransactionsVm.cardList.push(cardTransactionsVm.card);
            var addonCards = cardsService.getParams().addOnCards;
         
                for (var i = 0; i < addonCards.length; i++) {
                    addonCards[i].cardRank = "Add on Card"
                    addonCards[i].lastIndex = 10;
                     addonCards[i].sortOrder="descending";
                    cardTransactionsVm.cardList.push(addonCards[i]);
                }
            
            cardTransactionsVm.counter = 0;
            for (var k = 0; k < cardTransactionsVm.cardList.length; k++) {
                if (cardTransactionsVm.cardList[k].isTransactionHistoryEnabled === true) {
                    cardTransactionsVm.counter = cardTransactionsVm.counter + 1;
                }
            }
            getAllTransaction();

            cardTransactionsVm.lastIndex = 10;
        }

        // go to home
        cardTransactionsVm.goBackHome = function() {
            //$state.go('menu.cardOverview');
			var backBtn = $ionicHistory.backView();
            var backState = backBtn.stateName;
            $state.go(backState);
        }



        $scope.scrollMainToTop = function() {
            var element = angular.element(document.querySelector('.has-subheader > .scroll'));
            element = element[0];
            element.style.webkitTransform = "";
            element.style.MozTransform = "";
            element.style.msTransform = "";
            element.style.OTransform = "";
            element.style.transform = "";

            var test = angular.element(document.querySelector('.scroll'));
            test.css("transform", "1");
        };




        $scope.toggleGroup = function(cardNumber, index) {
            // var pageNo;
            // var index=index||0;
            // cardTransactionsVm.selectedTransactionList[index]={};
            if ($scope.isGroupShown(cardNumber)) {
                $scope.shownGroup = null;
            } else {
                $scope.shownGroup = cardNumber;
            }
            // if(index==undefined){
            //     index=0;
            // }
            // else{

            // }
              
             
                cardTransactionsVm.cardList[index].lastIndex = index;
                for(var count = index; count < cardTransactionsVm.cardList[index].transactions.length; count ++){
                    if(count < 10){
                    cardTransactionsVm.cardList[index].transactions[count].visibilityFlag = true;
                   }else{
                     cardTransactionsVm.cardList[index].transactions[count].visibilityFlag = false;
                   }
                }

                cardTransactionsVm.lastVisibleIndex[index] =  0;
               // cardTransactionsVm.lastVisibleIndex[0].

            //      for (i = lastIndex;
            //     ((i < (lastIndex + 10)) && (i < cardTransactionsVm.cardList[cardIndex].transactions.length)); i++) {
            //     cardTransactionsVm.cardList[cardIndex].transactions[i].visibilityFlag = true;
            //     // cardTransactionsVm.lastVisibleIndex[cardIndex] += 1;
            //     cardTransactionsVm.lastVisibleIndex[cardIndex] = i + 1;
            // }

            
             
            
            



            fetchNextCoupleTransactions(index);


            // pageNo=cardTransactionsVm.selectedTransactionList[index].pageNo||0;
            // if(cardTransactionsVm.selectedTransactionList[index].pageNo ==undefined){
            //     pageNo=0;
            // }
            // else{
            //     pageNo=cardTransactionsVm.selectedTransactionList[index].pageNo;
            // }
            // if (cardTransactionsVm.cardList[index].loadedFlag == false) {
            //     cardTransactionsVm.cardList[index].loadedFlag = true;
            // if (cardTransactionsVm.cardList[index].loadedFlag==false) {
            //     fetchNextCoupleTransactions(index);
            // }
            // }
            $scope.scrollMainToTop();
        };

        $scope.isGroupShown = function(cardNumber) {
            return $scope.shownGroup === cardNumber;
        };


        //actions to done everytime the view is shown
        $scope.$on('$ionicView.loaded', function(event, data) {
            initPage(data.stateParams);
        });
        cardTransactionsVm.viewMore = function(index) {
            fetchNextCoupleTransactions(index);
            // cardTransactionsVm.getTransactions(cardTransactionsVm.cardList[index].cardNumber, cardTransactionsVm.cardList[index].pageNo + 1, cardTransactionsVm.cardList[index].id);
        };

        function getAllTransaction() {
            var payload = {
               // accountId: cardCompareService.accountId,
                cardNumber: cardTransactionsVm.card.cardNumber

            };
             utilityService.showSpinner(); 
            floatingMenuService.transaction(payload).then(function(response) {
                //     var transactions = response.transactions || [];
                 
                cardsService.errorLogger(response);
                transactions = response.data.transactions || [];
                transactions.sort(function(a, b) {
                    return new Date(b.date).getTime() - new Date(a.date).getTime()
                });


                var firstTenTransactions = [];

                for (var i = 0; i < cardTransactionsVm.cardList.length; i++) {
                    // cardTransactionsVm.cardList[i].pageNo = 0;
                    cardTransactionsVm.lastVisibleIndex[i] = 0;
                    cardTransactionsVm.cardList[i].id = i;
                    cardTransactionsVm.cardList[i].transactions = [];
                    if (cardTransactionsVm.cardList[i].cardRank === "Primary Card") {

                        cardTransactionsVm.cardList[i].transactions.push(transactions);

                        if (transactions.length < 10) {

                            cardTransactionsVm.cardList[i].noMoreTransactions = true;
                        } else {
                            cardTransactionsVm.cardList[i].noMoreTransactions = false;

                        }
                        cardTransactionsVm.cardList[i].transactions = cardTransactionsVm.cardList[i].transactions[0];


                    } else {
                        for (var j = 0; j < transactions.length; j++) {


                            if (cardTransactionsVm.cardList[i].cardNumber === transactions[j].cardNumber) {
                                //if (cardTransactionsVm.cardList[i].transactions.length <= 10) {
                                cardTransactionsVm.cardList[i].transactions.push(transactions[j]);


                                if (cardTransactionsVm.cardList[i].transactions < 10) {
                                    cardTransactionsVm.cardList[i].noMoreTransactions = true;
                                } else {
                                    cardTransactionsVm.cardList[i].noMoreTransactions = false;

                                }

                                //}
                            }
                        }
                    }

                }

                // fetchNextCoupleTransactions(cardTransactionsVm.cardList[0].id);
                for(var m=0; m<cardTransactionsVm.cardList.length; m++){

					if(cardTransactionsVm.cardList[m] && cardTransactionsVm.cardList[m].isTransactionHistoryEnabled == true){

                    cardIndexTransactions = m;
                        break;
                  }
                }
                $scope.toggleGroup(cardTransactionsVm.cardList[cardIndexTransactions].cardNumber, cardTransactionsVm.cardList[cardIndexTransactions].id);
                   utilityService.hideSpinner(); 
            }, function(error) {
                 utilityService.hideSpinner(); 

                utilityService.showErrorMessage(error.responseMessage);

            });
        }

        cardTransactionsVm.dateSort = function(card) {

            if (card.sortOrder == "descending") {
                 card.transactions.sort(function(a, b) {
                    return new Date(a.date).getTime() - new Date(b.date).getTime();
                });
                card.sortOrder = "ascending";
            } else {
                 card.transactions.sort(function(a, b) {
                    return new Date(b.date).getTime() - new Date(a.date).getTime();
                });
                   card.sortOrder = "descending";
            }

        }


          cardTransactionsVm.descSort = function(card) {

            if (card.sortOrder == "descending") {
                // transactions.sort(function(a, b) {
                //     return new Date(b.date).getTime() - new Date(a.date).getTime()
                // });

                 card.transactions.sort(function(a, b) {
                    return a.description - b.description;

                    
                });

                card.sortOrder = "ascending";

            } else {

                 card.transactions.sort(function(a, b) {
                          return b.description - a.description;
                  
                });

                   card.sortOrder = "descending";

               

            }

        }




          cardTransactionsVm.amountSort = function(card) {

            if (card.sortOrder == "descending") {
                // transactions.sort(function(a, b) {
                //     return new Date(b.date).getTime() - new Date(a.date).getTime()
                // });

                 card.transactions.sort(function(a, b) {
                    return  parseInt(a.amount) - parseInt(b.amount);

                    
                });

                card.sortOrder = "ascending";

            } else {

                 card.transactions.sort(function(a, b) {
                   // return new Date(b.date).getTime() - new Date(a.date).getTime()
                        return  parseInt(b.amount) - parseInt(a.amount);
                  
                });

                   card.sortOrder = "descending";

               

            }

        }

        function fetchNextCoupleTransactions(cardIndex) {
            var lastIndex = cardTransactionsVm.lastVisibleIndex[cardIndex],
                i = 0;
            
            if(lastIndex > cardTransactionsVm.cardList[cardIndex].transactions.length){
                for(var count = 0; count < cardTransactionsVm.cardList[cardIndex].transactions.length; count++){
                        cardTransactionsVm.cardList[cardIndex].transactions[count].visibilityFlag = true;
                }
            }else{
                for(var count = 0; count < lastIndex; count++){
                        cardTransactionsVm.cardList[cardIndex].transactions[count].visibilityFlag = true;
                }
            }

            for (i = lastIndex;
                ((i < (lastIndex + 10)) && (i < cardTransactionsVm.cardList[cardIndex].transactions.length)); i++) {
                cardTransactionsVm.cardList[cardIndex].transactions[i].visibilityFlag = true;
                // cardTransactionsVm.lastVisibleIndex[cardIndex] += 1;
                cardTransactionsVm.lastVisibleIndex[cardIndex] = i + 1;
            }
            if( cardTransactionsVm.cardList[cardIndex].lastIndex < cardTransactionsVm.cardList[cardIndex].transactions.length){
           cardTransactionsVm.cardList[cardIndex].lastIndex = cardTransactionsVm.cardList[cardIndex].lastIndex + 10;
        }



            if (cardTransactionsVm.cardList[cardIndex].lastIndex >= cardTransactionsVm.cardList[cardIndex].transactions.length) {
                cardTransactionsVm.cardList[cardIndex].noMoreTransactions = true;


            } else {
                cardTransactionsVm.cardList[cardIndex].noMoreTransactions = false;

            }
        }
    }
]);
