
'use strict';

angularApp.controller('newPinController', ["$state",
    "$scope",
    "$translate",
    "cardsService",
    "floatingMenuService",
    "$filter",
    "cardConfig", "utilityService",
    "cardCompareService",

    function($state,
        $scope,
        $translate,
        cardsService,
        floatingMenuService,
        $filter,
        cardConfig, utilityService,
        cardCompareService) {

        //functions, variables that can be accessed from the HTML come here
        var newPinVm = this;
        //Entry point
        function initPage() {

            newPinVm.newPin = '';
            newPinVm.confirmPin = '';
            newPinVm.pin1First = '';
            newPinVm.pin1Second = '';
            newPinVm.pin1Third = '';
            newPinVm.pin1Fourth = '';
            newPinVm.pin2First = '';
            newPinVm.pin2Second = '';
            newPinVm.pin2Third = '';
            newPinVm.pin2Fourth = '';
            newPinVm.noMatch = false;
            var params = floatingMenuService.getParams();
            newPinVm.cardNumber = params.cardNumber;
            newPinVm.total = 0;
            newPinVm.regMobile = params.regMobile;
            newPinVm.confirmDisable = true;
            newPinVm.disableButton = true;
        }
        // key up function on input field
        newPinVm.proceedSuccess = function(value) {
                newPinVm.noMatch = false;
                newPinVm.confirmDisable = true;
                newPinVm.newPin = newPinVm.pin1First + newPinVm.pin1Second + newPinVm.pin1Third + newPinVm.pin1Fourth;
                if (newPinVm.newPin.length == 4) {
                    newPinVm.confirmDisable = false;
                }
                newPinVm.newPin = newPinVm.pin1First + newPinVm.pin1Second + newPinVm.pin1Third + newPinVm.pin1Fourth;
                newPinVm.confirmPin = newPinVm.pin2First + newPinVm.pin2Second + newPinVm.pin2Third + newPinVm.pin2Fourth;
                if( newPinVm.newPin.length == 4 &&  newPinVm.confirmPin.length == 4 ){
                    newPinVm.disableButton = false;
                }

            }
            // validate function on submit 
        newPinVm.validate = function() {
                newPinVm.newPin = newPinVm.pin1First + newPinVm.pin1Second + newPinVm.pin1Third + newPinVm.pin1Fourth;
                newPinVm.confirmPin = newPinVm.pin2First + newPinVm.pin2Second + newPinVm.pin2Third + newPinVm.pin2Fourth;
                if (newPinVm.newPin == newPinVm.confirmPin) {
                    return true;
                } else {
                    newPinVm.noMatch = true;
                    newPinVm.newPin = '';
                    newPinVm.confirmPin = '';
                    newPinVm.pin1First = '';
                    newPinVm.pin1Second = '';
                    newPinVm.pin1Third = '';
                    newPinVm.pin1Fourth = '';
                    newPinVm.pin2First = '';
                    newPinVm.pin2Second = '';
                    newPinVm.pin2Third = '';
                    newPinVm.pin2Fourth = '';
                    return false;
                }

            }
            // reset function submit    
        newPinVm.resetPin = function() {
            if (!newPinVm.validate()) {
                return false;
            }
            var cardNumber = $filter('cardmask')(newPinVm.cardNumber, 'X', '4', '-');
            var data = {
                cardNumber: newPinVm.cardNumber,
                newPin: newPinVm.newPin
               // accountId: cardCompareService.accountId
            };

            var str = '<img class="fss-popup-activated-img" src="img/FSS/Approved.svg"><div class="text-align-center font-content sbi-sub-label roboto-regular">';

            var alertObj = {
                cssClass: 'sbi-alert-popup',
                buttons: [{
                    text: cardConfig.buttons.OK_LABEL,
                    type: 'button-positive',
                    onTap: function(e) {

                    }
                }]
            } 

            floatingMenuService.resetPin(data).then(function(response) {
              cardsService.errorLogger(response);
                if (response.data.responseCode == cardConfig.responseCode.dataSuccess) {
                        var temp = response.data.srNumber;
                          if(temp == null || temp == undefined || temp == ""){
                                $translate('RESET_PIN_SUCCESSFUL_1', { cardNumber: cardNumber}).then(function(translation) {
                                alertObj.template = str + translation + '</div>';
                                cardsService.alertModal(alertObj, function(res) {
                                $state.go('menu.cardOverview');
                            });
                         });

                     } else {
                         $translate('RESET_PIN_SUCCESSFUL_1_SR', { cardNumber: cardNumber, srNumber:response.data.srNumber}).then(function(translation) {
                         alertObj.template = str + translation + '</div>';
                        cardsService.alertModal(alertObj, function(res) {
                            $state.go('menu.cardOverview');
                        });
                    });
                 }
                } else {
                    alertObj.template = '<div class="text-align-center font-content sbi-sub-label roboto-regular">Something Goes wrong!</div>';
                    cardsService.alertModal(alertObj, null);
                }

            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }


        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function(event, data) {
            initPage();
        });

    }
]);
