

'use strict';

angularApp.controller('resendOTPPinController', ["$state",
"$scope",
"$translate",
"cardsService",
"floatingMenuService",
"applyNowService",
"$filter",
"cardConfig", "utilityService",
"$timeout",
"validateService",
"$ionicHistory","clickStreamService",
function resendOTPPinController(
    $state,
    $scope,
    $translate,
    cardsService,
    floatingMenuService,
    applyNowService,
    $filter,
    cardConfig, utilityService, $timeout, validateService,$ionicHistory,clickStreamService) {
    //functions, variables that can be accessed from the HTML come here
    var resendOTPPinVm = this;

    resendOTPPinVm.validateService = validateService;
    //Entry point
    function initPage() {
        var params = floatingMenuService.getParams();
        applyNowService.setParams({ "applyCardMobileVerify": false });
        resendOTPPinVm.getOTPNumber = '';
        resendOTPPinVm.cardNumber = params.cardNumber;

        resendOTPPinVm.mobileNumberForResend = params.mobileNumber;
        resendOTPPinVm.email = params.email;
       // resendOTPPinVm.accountId = params.accountId;

        resendOTPPinVm.showBack = false;
        resendOTPPinVm.showNext = true;
        resetPinOTP.noValidOTP = false;
        resendOTPPinVm.clickCount = 0;
        
        if(floatingMenuService.isResendExhaust){
             resendOTPPinVm.disableLink = true;
        }
       if(floatingMenuService.isTextExhaust){
             resendOTPPinVm.disableTextBox = true;
       } 
      /*  resendOTPPinVm.disableLink = false;
        resendOTPPinVm.disableTextBox = false;*/
        resendOTPPinVm.isFromEapply = applyNowService.getParams().eapplySentOTP;
        if (resendOTPPinVm.isFromEapply) {
            resendOTPPinVm.mobileNumber = $filter('cardmask')(applyNowService.getParams().eapplyMobileNumber, 'X', 4);
        } else {
            resendOTPPinVm.mobileNumber = $filter('cardmask')(params.mobileNumber, 'X', 4);

        }

        resendOTPPinVm.stateBeforeOTP = cardsService.getParams().stateBeforeOTP;
        resendOTPPinVm.isFromEapplyResend = false;
        resendOTPPinVm.isFromEapplysend = true;

        resendOTPPinVm.isFromManagePin = true;
        resendOTPPinVm.isFromManagepinResend = false;

    }

    $translate(['ENTER_OTP']).then(function(translations) {

        resendOTPPinVm.OTP = translations['ENTER_OTP'];
    });

    // Function to resend OTP
    resendOTPPinVm.resendOTP = function() {

        //  resendOTPPinVm.getOTPNumber = false;
        if (resendOTPPinVm.resetPinOTP != undefined) {
            resendOTPPinVm.resetPinOTP.getOTPNumber = false;

        }


        resendOTPPinVm.clickCount++;
        if (resendOTPPinVm.clickCount > 5) {
            resendOTPPinVm.disableLink = true;
            floatingMenuService.isResendExhaust=true;
            resendOTPPinVm.clickCount = 0;

        }
        var resendDisabled = {
            cssClass: 'sbi-alert-popup',
            template: '<div class="text-align-center font-content roboto-regular"> You have exhausted the number of times you can ask for the One Time Password(OTP) to be resent.</div>',
            buttons: [{
                text: cardConfig.buttons.OK_LABEL,
                type: 'button-positive'
            }]
        };
        var resendDisabledPin = {
            cssClass: 'sbi-alert-popup',
            template: '<div class="text-align-center font-content roboto-regular"> You have exhausted the number of times you can ask for the One Time Password(OTP) to be resent.Please re-start with your Change pin request by clicking on Manage Pin.</div>',
            buttons: [{
                text: cardConfig.buttons.OK_LABEL,
                type: 'button-positive'
            }]
        };

        floatingMenuService.setIsResend(true);
        var mobileNumber = applyNowService.getParams().eapplyMobileNumber;
        //resend otp for eapply
        if (resendOTPPinVm.isFromEapply && mobileNumber) {
            if (!resendOTPPinVm.disableLink) {
                applyNowService.sendEapplyOTP({
                    "mobileNumber": mobileNumber,
                    "isResend": "true"
                }).then(function(response) {
                        cardsService.errorLogger(response);
                        if (response.data.responseCode == cardConfig.responseCode.dataSuccess) {
                            // var successSendOTP = {
                            //     cssClass: 'sbi-alert-popup',
                            //     template: '<div class="text-align-center font-content roboto-regular"> OTP succesfully re-sent</div>',
                            //     buttons: [{
                            //         text: cardConfig.buttons.OK_LABEL,
                            //         type: 'button-positive'
                            //     }]
                            // };
                            //cardsService.alertModal(successSendOTP, null);
                            resendOTPPinVm.isFromEapplyResend = true;
                            resendOTPPinVm.isFromEapplysend = false;

                        }
                    },
                    function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
            } else {
                cardsService.alertModal(resendDisabled, null);
            }
        } else {
            //resend OTP for resetPin
            if (!resendOTPPinVm.disableLink) {
                //var sendOTPPayload = floatingMenuService.getParams();

                var sendOTPPayload = {
                    "cardNumber": resendOTPPinVm.cardNumber,
                    // "mobileNumber": resendOTPPinVm.mobileNumberForResend,
                    // "email": resendOTPPinVm.email,
                    "isResend": "true"
                    //"accountId": resendOTPPinVm.accountId

                };

                floatingMenuService.sendOTP(sendOTPPayload)
                    .then(function(response) {
                            cardsService.errorLogger(response);
                            switch (response.data.responseCode) {
                                case cardConfig.responseCode.dataSuccess:

                                    // var successSendOTP = {
                                    //     cssClass: 'sbi-alert-popup',
                                    //     template: '<div class="text-align-center font-content roboto-regular"> OTP succesfully re-sent</div>',
                                    //     buttons: [{
                                    //         text: cardConfig.buttons.OK_LABEL,
                                    //         type: 'button-positive'
                                    //     }]
                                    // };
                                    // / cardsService.alertModal(successSendOTP, null);
                                    resendOTPPinVm.isFromManagePin = false;
                                    resendOTPPinVm.isFromManagepinResend = true;
                                    break;
                            }
                        },
                        function(error) {

                        });
            } else {
                cardsService.alertModal(resendDisabledPin, null);
            }
        }

    }

    // function to validate OTP
    resendOTPPinVm.validateOTP = function() {
        var mobileNumber = applyNowService.getParams().eapplyMobileNumber;
        var randomNumber;
	var requestDate = new Date();
	requestDate = requestDate.getTime();
	randomNumber=Math.floor((Math.random()) + requestDate);
	randomNumber = (randomNumber * 10 + 1);
        if (resendOTPPinVm.isFromEapply && mobileNumber) {
            //we have to add the code for validate OTP we have to work with real services
            applyNowService.validateEapplyOTP({
                "cardNumber": "999999" + mobileNumber,
                "otp": resendOTPPinVm.getOTPNumber,
                "secKey":randomNumber
            }).then(function(response) {
                    cardsService.errorLogger(response);

                    if (response.data.responseCode == cardConfig.responseCode.dataSuccess) {

                           var newNumber=parseInt(response.data.secKey) ;

                            var generatedNumber=(newNumber/2)-1;
                              generatedNumber=generatedNumber/99;

                            if(randomNumber==generatedNumber)
                            {
                             applyNowService.setParams({ "applyCardMobileVerify": true });
                                //$state.go('menu.cardPersonalDetails2');
                                utilityService.showSpinner();
                                applyNowService.applyCard().then(function(responseNew) {
                                    cardsService.errorLogger(responseNew);
                                    switch (responseNew.responseCode) {
                                        case cardConfig.responseCode.success:
                                        utilityService.hideSpinner();
                                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("CRDS_CRDRQSTAPRV_CC_END_NXT_BTN"));
                                            $state.go('menu.cardRequestApprove');
                                            break;
                                        case cardConfig.responseCode.failed:
                                        utilityService.hideSpinner();
                                            break;
                                        default:
                                        utilityService.hideSpinner();
                                            break;
                                    }

                                },
                                function(error) {
                                    utilityService.hideSpinner();
                                    utilityService.showErrorMessage(error.responseMessage);
                                });
                               
                            }

                            else
                            {
                             
                             utilityService.showErrorMessage("Invalid OTP")

                            }
                        
                       
                    } else {
                        var errorValidateOTP = {
                            cssClass: 'sbi-alert-popup',
                            template: '<div class="text-align-center font-content roboto-regular">' + response.responseMessage + '</div>',
                            buttons: [{
                                text: cardConfig.buttons.OK_LABEL,
                                type: 'button-positive'
                            }]
                        };
                        cardsService.alertModal(errorValidateOTP, null);
                        resendOTPPinVm.getOTPNumber = "";


                    }
                },
                function(error) {
                    var otpFailed = $translate.instant('OTP_FAILED_ATTEMPT');
                    if (error.responseMessage == otpFailed) {
                        utilityService.showErrorMessage($translate.instant('OTP_FAILED_MESSAGE_APPLY'));
                        resendOTPPinVm.disableTextBox = true;
                        resendOTPPinVm.disableLink = true;
                        resendOTPPinVm.getOTPNumber = "";
                    } else {
                        utilityService.showErrorMessage(error.responseMessage);
                        resendOTPPinVm.getOTPNumber = "";
                       


                    }
                });

        } else {
            var data = {

                }
                /* linkCardService.sendOTP(data, function(response){                
                    switch(response.responseJSON.responseCode){
                        case '0000':  
                            $state.go('menu.enterCardOTP', responseData);
                            break;
                        case '1111': 
                            cardsService.alertModal(alertObj, function(res){
                                linkCardVm.userIdData = "";
                                linkCardVm.cardPasswordData = "";
                            });
                            break;
                            default:break;
                    }
                });*/


                 var randomNumber;
		 var requestDate = new Date();
		 requestDate = requestDate.getTime()
		 randomNumber=Math.floor((Math.random()) + requestDate);
		 randomNumber = (randomNumber * 10 + 1);
            floatingMenuService.validateOTP({
                "cardNumber": resendOTPPinVm.cardNumber,
                "otp": resendOTPPinVm.getOTPNumber,
                "secKey":randomNumber
            }).then(function(response) {
                    cardsService.errorLogger(response);
                    if (response.data.responseCode == cardConfig.responseCode.dataSuccess) {
                          var newNumber=parseInt(response.data.secKey) ;

                          var generatedNumber=(newNumber/2)-1;
                           generatedNumber=generatedNumber/99;

                        if(response.data.responseCode==cardConfig.responseCode.dataSuccess)
                        {
                            if(randomNumber==generatedNumber)
                            {
                            $state.go('menu.newPin');
                            }

                            else
                            {
                             
                             utilityService.showErrorMessage("Invalid OTP")

                            }
                        }

                        
                    } else {
                        var errorValidateOTP = {
                            cssClass: 'sbi-alert-popup',
                            template: '<div class="text-align-center font-content roboto-regular">' + response.responseMessage + '</div>',
                            buttons: [{
                                text: cardConfig.buttons.OK_LABEL,
                                type: 'button-positive'
                            }]
                        };
                        cardsService.alertModal(errorValidateOTP, null);
                        resendOTPPinVm.getOTPNumber = "";


                    }
                },
                function(error) {
                    var otpFailed = $translate.instant('OTP_FAILED_ATTEMPT');
                    if (error.responseMessage == otpFailed) {
                        utilityService.showErrorMessage($translate.instant('OTP_FAILED_MESSAGE_PIN'));
                        resendOTPPinVm.disableTextBox = true;
                        resendOTPPinVm.disableLink = true;
                        resendOTPPinVm.getOTPNumber = "";
                        floatingMenuService.isTextExhaust = true;
                      floatingMenuService.isResendExhaust = true;
                    } else {
                        utilityService.showErrorMessage(error.responseMessage);
                        resendOTPPinVm.getOTPNumber = "";


                    }

                });
            var responseData = {
                // otpRef: 1234,
                // otp: resendOTPPinVm.getOTPNumber,
                cardNumber: resendOTPPinVm.cardNumber
            }
            floatingMenuService.setParams(responseData);
        }


    }

    resendOTPPinVm.GoBack = function() {   
        $ionicHistory.goBack();
    }

    resendOTPPinVm.goBacktoPrevious = function() {   
        $ionicHistory.goBack();
    }

function generateNumber()
{



    return generatedNumber;
}
    function validateForm() {
        resendOTPPinVm.resetPinOTP = {};
        if (resendOTPPinVm.validateService.isValidOTPNumCards(resendOTPPinVm.getOTPNumber)) {
            resendOTPPinVm.resetPinOTP.getOTPNumber = resendOTPPinVm.validateService.isValidOTPNumCards(resendOTPPinVm.getOTPNumber);
        }
        return (angular.equals({}, resendOTPPinVm.resetPinOTP)) ? true : false;
    }

    $timeout(function() {
        document.getElementById("e56-e1bd-etj2-c43b").addEventListener("click", function() {

            floatingMenuService.getRedirectionMessage().then(function(response) {
                cardsService.errorLogger(response);
                if (response.data && response.data.message) {
                    cardsService.setParams({ "rewardsAgreeContent": response.data.message });
                    floatingMenuService.setParams({ "sourceRedirect": "managePin" });
                    $state.go('menu.rewardsAgree');
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

        });
    }, 50);

    resendOTPPinVm.toRewardsAgree = function() {
        floatingMenuService.getRedirectionMessage().then(function(response) {
            cardsService.errorLogger(response);
            if (response.data && response.data.message) {
                cardsService.setParams({ "rewardsAgreeContent": response.data.message });
                floatingMenuService.setParams({ "sourceRedirect": "managePin" });
                $state.go("menu.rewardsAgree");
            }


        }, function(error) {
            utilityService.showErrorMessage(error.responseMessage);
        });
    };



    //actions to done everytime the view is shown

    $scope.$on('$ionicView.beforeEnter', function(event, data) {
        initPage(data.stateParams);
    });

}
]);