/*
    Module Name  : Cards,
    File Name    : rewardsAgreeController.js,
    Description  : floating menu rewards agree page controller function
*/
'use strict';

angularApp.controller('rewardsAgreeController', rewardsAgreeController);

rewardsAgreeController.$inject = ["$scope", "$state", "floatingMenuService", "cardConfig", "linkCardService", "$cordovaInAppBrowser", "$rootScope", "$timeout", "cardsService", "utilityService", "getAccountDetailsService","payNowServices","applyNowService","homeScreenService","fTBeneficiaryService"]


function rewardsAgreeController($scope, $state, floatingMenuService, cardConfig, linkCardService, $cordovaInAppBrowser, $rootScope, $timeout, cardsService, utilityService, getAccountDetailsService,payNowServices,applyNowService,homeScreenService,fTBeneficiaryService) {
    var rewardsAgreeVm = this;
 
    
    
    function initPage() {
        rewardsAgreeVm.isBackCheck = homeScreenService.isBackCheck;
				homeScreenService.isBackCheck = false;
utilityService.showSpinner();

  payNowServices.getRedirectUrls().then(function(response) {
                              
                    payNowServices.links=JSON.parse(response.data.urls);
                     utilityService.hideSpinner();


                }, function(error) {
                    utilityService.hideSpinner();
                });


        getRedirectionMessage();

    }

    function getRedirectionMessage() {
        rewardsAgreeVm.parseContent = cardsService.getParams().rewardsAgreeContent;
        $timeout(function() {
            var getElem = document.getElementById("f0b86a1d-59b9-4463-8a40-bf620d529dfd");
            if (getElem) {

                getElem.addEventListener("click", function() {
                    floatingMenuService.getTermsAndCondition({})
                        .then(function(response) {
                            cardsService.errorLogger(response);
                            if (response.data && response.data.message) {
                                cardsService.setParams({ "termsAndCtonditionConent": response.data.message });
                                $state.go("menu.rewardsTermsCondition");
                            }

                        }, function(error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });

                });
            }
        }, 50);
    }

    rewardsAgreeVm.goBack = function() {
        homeScreenService.ishamburgerMenuRO = false;
        fTBeneficiaryService.isCreditCardFlag = true;
        getAccountDetailsService.setRewTab = true;
        getAccountDetailsService.tabIndex.tabIndex = 5;
        $state.go('menu.accountOverviewMyBalance');
    }

    // go to reward redemption page (sbi)
    rewardsAgreeVm.goBacktoNext = function() {
        linkCardService.LinkCreditCards({}).then(
            function(response) {
                cardsService.errorLogger(response);

              function openBrowser() {
                    var openBrowserUrl;
                             var links= payNowServices.links;

                            if(floatingMenuService.getParams().sourceRedirect == "linkCard"){
                                    rewardsAgreeVm.inAppBrowser("https://" + links.linkCard[0] + response.data.handShakeToken + links.linkCard[1]);
                                    
                            }else
                            {
                                switch (floatingMenuService.getParams().sourceRedirect) {
                        case 'blockCard':
                            openBrowserUrl = "https://" + links.blockCard[0] + response.data.handShakeToken + links.blockCard[1] + links.blockCard[2];
                          
                            break;

                             case 'managePin':
                            openBrowserUrl = "https://" + links.managePin[0] + response.data.handShakeToken + links.managePin[1] + links.managePin[2];
                            
                            break;
                          
                        default:
                            openBrowserUrl = "https://" + links.rewardRedemption[0] + response.data.handShakeToken + links.rewardRedemption[1] + links.rewardRedemption[2];
                           
                            break;

                    }
                    cardsService.inAppBrowser(openBrowserUrl);
                            }


                }


            openBrowser();


            },
            function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
    }
    rewardsAgreeVm.inAppBrowser = function(url){
        cordova.ThemeableBrowser.open(url, '_blank', {
            statusbar: {
                color: '#ffffffff'
            },
            toolbar: {
                height: 37,
                color: '#ffffffff',
                 image: 'share'
            },
            
             closeButton: {
                image: 'back',
                height: 37,
                width: 32,
                align: 'left',
                event: 'closePressed'
            },
         
         
            backButtonCanClose: true
        }).addEventListener('closePressed', function(e) {
             getAccountDetailsService.tabIndex.tabIndex = 5;
             $state.go('menu.accountOverviewMyBalance');
			 applyNowService.isCardFlag=true;
            
           
        })
    
    }



    //one time initialization to be done when the controller is loaded
    $scope.$on('$ionicView.loaded', function() {
        initPage();
    });


}
