/*
    Module Name  : Cards,
    File Name    : rewardsController.js,
    Description  : floating menu rewards controller function
*/
'use strict';

angularApp.controller('rewardsController', ["$state",
    "$scope",
    "$stateParams",
    "cardsService",
    "floatingMenuService",
    "cardConfig","utilityService","$ionicHistory",

    function($state,
        $scope,
        $stateParams,
        cardsService,
        floatingMenuService,
        cardConfig,utilityService,$ionicHistory) {

        //functions, variables that can be accessed from the HTML come here
        var rewardsVm = this;
        var cardDetails;
        //Entry point
        function initPage(stateParams) {
            rewardsVm.sbiLink = cardConfig.links.register;
            var cards = cardsService.getCardList();
            cardDetails = cards[cardsService.getSelectedCard()];
            rewardsVm.cardNumber = cardDetails.cardNumber;
            rewardsVm.getRewards();
            floatingMenuService.setParams({ "sourceRedirect": "" });
        }
        // go to home
        rewardsVm.goBackHome = function() {
			var backBtn = $ionicHistory.backView();
            var backState = backBtn.stateName;
            $state.go(backState);
			
		}
            // get rewards service call function
        rewardsVm.getRewards = function() {


            rewardsVm.rewards = cardDetails.rewardPointDetails || {};
            rewardsVm.translationData = {
                date: rewardsVm.rewards.toExpire.date
            };
        }

        rewardsVm.toRewardsAgree = function() {
            floatingMenuService.getRedirectionMessage().then(function(response) {
                cardsService.errorLogger(response);
                if (response.data && response.data.message) {
                    cardsService.setParams({ "rewardsAgreeContent": response.data.message });
                    floatingMenuService.setParams({ "sourceRedirect": "" });
                    $state.go("menu.rewardsAgree");
                }


            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        };


        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function(event, data) {
            initPage(data.stateParams);
        });


    }
]);
