

'use strict';

angularApp.controller('browseCardsController', ["$state", "$scope", "$translate", "newCardService", "cardsService", "$filter", "$ionicScrollDelegate", "$timeout", "cardConfig", "cardCompareService", "utilityService","homeScreenService","$ionicHistory","applyNowService","clickStreamService","$ionicPopup","linkCardService","loggedInUserService","leadGenerationService",
    function($state, $scope, $translate, newCardService, cardsService, $filter, $ionicScrollDelegate, $timeout, cardConfig, cardCompareService, utilityService,homeScreenService,$ionicHistory,applyNowService,clickStreamService,$ionicPopup,linkCardService,loggedInUserService,leadGenerationService) {

        var browseCardsVm = this;
        var tabList = ["All", "lifestyle", "reward", "shopping", "travel---fuel"];


        function initPage() {
            // browseCardsVm.isBackCheck = homeScreenService.isBackCheck;
				    // homeScreenService.isBackCheck = false;
            if(homeScreenService.ishamburgerMenuBrowseCards){
              browseCardsVm.isHamCheck = true;
              browseCardsVm.isBackCheck = true;
            }else {
              browseCardsVm.isBackCheck = false;
            }
            browseCardsVm.canAdd = true;
            browseCardsVm.getCardsList();
            browseCardsVm.compareList = [];
            browseCardsVm.compareCardList = [];
            browseCardsVm.closeCompare();
            browseCardsVm.ComparebtnShow = false;
        }

        browseCardsVm.CompareShow = function(){
            browseCardsVm.ComparebtnShow = true;
        }

        browseCardsVm.CompareHide = function(){
            browseCardsVm.ComparebtnShow = false;
            browseCardsVm.compareList = [];
			browseCardsVm.canAdd = true;
            angular.forEach(browseCardsVm.cardsList, function(value, key) {
                value.show = true;
                value.active = false;
            });
        }

        browseCardsVm.getCardsList = function() {
            browseCardsVm.cardsList = cardsService.getParams().browseAllCards;
            angular.forEach(browseCardsVm.cardsList, function(value, key) {
                value.show = true;
                value.active = false;


                value.pictureURL = value.pictureURL.replace(cardConfig.cardUrl.other_card, "https://www");
                value.pictureURL = value.pictureURL.replace(cardConfig.cardUrl.tata_card, "https://www.tatacard.com");
            });
            var list = $filter('unique')(browseCardsVm.cardsList, 'categoryName');
            browseCardsVm.headerList = [];
            var travelcard='';
            angular.forEach(list, function(value, key) {
                if (value.categoryName.toLowerCase() == 'lifestyle') {
                    browseCardsVm.headerList.unshift('lifestyle');
                } else if (tabList.indexOf(value.categoryName) > 0) {
                    if(value.categoryName.toLowerCase()=="travel---fuel"){
                       travelcard= value.categoryName.replace('---fuel','');
                       value.categoryName=travelcard;
                    }
                    browseCardsVm.headerList.push(value.categoryName);
                }

            });

            browseCardsVm.headerList.unshift('All');
            if(homeScreenService.ishamburgerMenuBrowseCards == true){
				browseCardsVm.showCategory = (cardsService.getParams().browseCardsTabSelected) ? (cardsService.getParams().browseCardsTabSelected) : browseCardsVm.headerList[0];
              //homeScreenService.ishamMenu == false;
            }
			else if(cardsService.getParams().browseCardsTabSelected){
				var index = tabList.indexOf(cardsService.getParams().browseCardsTabSelected);
				browseCardsVm.showCategory = browseCardsVm.headerList[index];
			}
            else{
				browseCardsVm.showCategory = (cardsService.getParams().browseCardsTabSelected) ? (cardsService.getParams().browseCardsTabSelected) : browseCardsVm.headerList[1];
            }
        }
        browseCardsVm.tabClicked = function() {
            $timeout(function() {
                $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop(true);
            }, 100)

        }

        // go to home
        browseCardsVm.goBackHome = function() {
            if(!loggedInUserService.isLoggedInDetails.isLoggedIn){               
                $state.go('menu.leadGenerationCreditCard');
            }else if(homeScreenService.ishamMenu===true){
                //$state.go("menu.homeScreen");
				$ionicHistory.goBack();
				homeScreenService.ishamMenu=false;
            }else{
                cardsService.setParams({ "browseCardsTabSelected": browseCardsVm.showCategory });
				//$state.go('menu.cardIntroduction');
                homeScreenService.isCreditCardFlag = true;//flag set in order to call cards api once we go back from here
				$state.go('menu.accountOverviewMyBalance');
            }
        }
        // add cards to compare function
        browseCardsVm.addToCompare = function() {
            var cardName = [];
            angular.forEach(browseCardsVm.cardsList, function(value, key) {
                if (!value.show) {
                    cardName[cardName.length] = value.cardName;
                }
            });


            var responseData = { "cardNames": cardName };

            cardCompareService.getCardComparison(responseData).then(function(response) {
                cardsService.errorLogger(response);
                if (response.data && response.data.comparisonResult.length > 0) {
                    cardsService.setParams({ "cardCompareData": response.data.comparisonResult });
                    $state.go('menu.cardComparison');
                } else {

                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        // go to selected card detail page
        browseCardsVm.goToCard = function(card) {

            cardsService.setParams({ "cardName": card.cardName });

            $state.go('menu.cardPlatinum');

        }



        browseCardsVm.getCompare = function(card) {
            if(card.active == false){
                card.active = false;
                card.show = true;
                browseCardsVm.compareList.pop();
                if (browseCardsVm.compareList.length < 2) {
                    browseCardsVm.canAdd = true;
                }
            }
            else{
                    cardsService.setParams({ "browseCardsTabSelected": browseCardsVm.showCategory });
                    browseCardsVm.compCards = [];
                    var str = '<img class="fss-popup-activated-img" src="img/FSS/Approved.svg"><div class="text-align-center font-content sbi-sub-label roboto-regular">';

                    var alertObj = {
                        cssClass: 'sbi-alert-popup',
                        buttons: [{
                            text: cardConfig.buttons.OK_LABEL,
                            type: 'button-positive',
                            onTap: function(e) {

                            }
                        }]
                    }

                    if (browseCardsVm.compareList.length == 2 && !browseCardsVm.canAdd) {
                        card.active = false;
                        $translate('MoreThanTwoCards').then(function(translation) {
                            alertObj.template = str + translation + '</div>';
                            cardsService.alertModal(alertObj, null);
                        });
                        return false;
                    }
                    if (browseCardsVm.compareList.length < 2) {
                        browseCardsVm.canAdd = true;
                        card.show = false;
                        browseCardsVm.compareList.push(browseCardsVm.compareList.length);
                    }
                    if (browseCardsVm.compareList.length == 2) {
                        card.show = false;
                        browseCardsVm.canAdd = false;
                    }
            }
        }


        // close compare floating div
        browseCardsVm.closeCompare = function() {
            browseCardsVm.compareList = [];
            browseCardsVm.canAdd = true;
            angular.forEach(browseCardsVm.cardsList, function(value, key) {
                value.show = true;
                value.active = false;
            });
        }
		browseCardsVm.goBack = function(card) {
			if(cardsService.isComingIntro){
				cardsService.isComingIntro = false;
				$state.go('menu.cardIntroduction');
			}else{
				$ionicHistory.goBack();
			}
		};
        // remove item from compare list
        browseCardsVm.removeItem = function(card) {

            card.active = false;
            card.show = true;
            browseCardsVm.compareList.pop();
            if (browseCardsVm.compareList.length < 2) {
                browseCardsVm.canAdd = true;
            }

        };
		
		browseCardsVm.applyNow = function(card) {
            if(!loggedInUserService.isLoggedInDetails.isLoggedIn){
                newCardService.setPreLoginSelectedMenu('cards');
                newCardService.setTermsAndConditionsOutboundAnalyticsData(card);
                loggedInUserService.productClicked = 'menu.termsAndConditionsOutboundAnalytics';
                $state.go('menu.userLogin');
            }else{
                utilityService.showSpinner();
                if(linkCardService.getAllowAppStatus() == ""){
                    linkCardService.getPendingApplicationStatus({})
                    .then(function(response) {
                            cardsService.errorLogger(response);
                            if (response.data) {
                                    if (response.data.allow == "false"){
                                        linkCardService.setAllowAppStatus(response.data);
                                        utilityService.hideSpinner();
                                        utilityService.enableShowErrorMessage(); 
                                        utilityService.showErrorMessage(response.data.allowMessage);   
                                        return false;       
                                    }
                                    else{
                                        linkCardService.setAllowAppStatus(response.data);
                                        allowApplication(card);
                                    }
                            }
                        },
                        function(error) {
                            utilityService.hideSpinner();
                            allowApplication(card);
                        });
                }
                else{
                    if(linkCardService.getAllowAppStatus().allow == "false"){
                        utilityService.hideSpinner();
                        utilityService.enableShowErrorMessage(); 
                        utilityService.showErrorMessage(linkCardService.getAllowAppStatus().allowMessage);   
                        return false;       
                    }
                    else{
                        utilityService.hideSpinner();
                        allowApplication(card);
                    }
                }  
            }
                      
        };

		function allowApplication(card) {
            applyNowService.resetApplyForm();
            newCardService.setParams({ "applyCardType": card.cardType });
            newCardService.setParams({ "applyCardName": card.cardName });
            newCardService.setParams({ "applyPictureURL": card.pictureURL });
            newCardService.setParams({ "applyCardCategory": card.categoryName });

            applyNowService.getCities().then(function(response) {
                cardsService.errorLogger(response);
                cardsService.setParams({ "city": response.data.cities });
                cardsService.setParams({ 'pendingApplication': false });
                //$state.go('menu.cardCitySelection');
                //$state.go('menu.cardPersonalDetails1');
                //Adding below code for centralised consent sprint 2 journey
                leadGenerationService.checkConsent().then(function(response){
                    
                    browseCardsVm.customerRecordExists = response.customerRecordExists;
                    if(browseCardsVm.customerRecordExists == "false"){
                        newCardService.setPreLoginSelectedMenu('cards');
                        loggedInUserService.productClicked = 'menu.termsAndConditionsOutboundAnalytics';
                        $state.go('menu.termsAndConditionsOutboundAnalytics');
                    }else{
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "CC_START_NXT_BTN"));
                        $state.go('menu.cardPersonalDetails1');    
                    }
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
                
                //}
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
		
        //actions to done everytime the view is shown

        $scope.$on('$ionicView.beforeEnter', function(event, data) {
            initPage();
        });
    }
]);
