
'use strict';

angularApp.controller('cardIntroductionController', ["$state", "$scope", "$ionicSlideBoxDelegate", "newCardService", "$timeout", "cardConfig", "linkCardService", "$cordovaInAppBrowser", "$rootScope", "cardsService", "utilityService","homeScreenService",
    function($state, $scope, $ionicSlideBoxDelegate, newCardService, $timeout, cardConfig, linkCardService, $cordovaInAppBrowser, $rootScope, cardsService, utilityService,homeScreenService) {

      
        var cardIntroVm = this;

        function initPage() {
            // cardIntroVm.isBackCheck = homeScreenService.isBackCheck;
				    // homeScreenService.isBackCheck = false;
            if(homeScreenService.ishamburgerMenuApplyNewCard){
              cardIntroVm.isHamCheck = true;
              cardIntroVm.isBackCheck = true;
            }else {
              cardIntroVm.isBackCheck = false;
            }
            cardIntroVm.firstslide = true;
            $scope.slideIndex = 0;
            cardIntroVm.getRecommendedCards();
        }

        

        cardIntroVm.goBackHome = function() {
            $state.go('menu.accountOverviewMyBalance');
        }

        cardIntroVm.getRecommendedCards = function() {
            var data = {};
            newCardService.getRecommendedCards(data).then(function(response) {
                cardsService.errorLogger(response);


                $timeout(function() {
                    cardIntroVm.getRecommendedCardList = response.data.recommendedCards || [];
                    angular.forEach(cardIntroVm.getRecommendedCardList, function(value, key) {
                        value.pictureURL = value.pictureURL.replace(cardConfig.cardUrl.other_card, "https://www");
                         value.pictureURL = value.pictureURL.replace(cardConfig.cardUrl.tata_card, "https://www.tatacard.com");

                    });

                    cardIntroVm.lastslide = (cardIntroVm.getRecommendedCardList.length == 1) ? false : true;
                    $ionicSlideBoxDelegate.update();
                    $ionicSlideBoxDelegate.loop(true);
                })

            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

      

        cardIntroVm.slideChanged = function(index) {
            $scope.slideIndex = index;
            if (index == 0) {
                cardIntroVm.firstslide = true;
            } else {
                cardIntroVm.firstslide = false;
            }

            if (index == (cardIntroVm.getRecommendedCards.length - 1)) {
                cardIntroVm.lastslide = true;
            } else {
                cardIntroVm.lastslide = false;
            }

        }

      

        cardIntroVm.goToCard = function(card) {
            cardsService.setParams({ "cardName": card.cardName });

            $state.go('menu.cardPlatinum');

        }

     
        cardIntroVm.previous = function() {
            $ionicSlideBoxDelegate.previous();
        }

     

        cardIntroVm.next = function() {
            $ionicSlideBoxDelegate.next();
        }

      
        cardIntroVm.browseCards = function() {
          homeScreenService.ishamburgerMenuBrowseCards = false;
          newCardService.browseCards();
            // newCardService.getCardsList().then(function(response) {
            //     cardsService.errorLogger(response);
            //     if (response.data && response.data.cards.length > 0) {
            //         cardsService.setParams({ "browseAllCards": response.data.cards });
            //         $state.go('menu.browseCards');
            //     }
            // }, function(error) {
            //     utilityService.showErrorMessage(error.responseMessage);
            // });

        }

        cardIntroVm.needAnalysis = function() {
          homeScreenService.ishamburgerMenuNeedAnalysis = false;
          newCardService.needAnalysis();
            // newCardService.getWelcomeMessages().then(function(response) {
            //     cardsService.errorLogger(response);
            //     if (response.data && response.data.message) {
            //         newCardService.resetParams();
            //         cardsService.setParams({ "needAnalysisWelcome": response.data.message });
            //         $state.go('menu.cardWelcome');
            //     }
            //
            //
            // }, function(error) {
            //     utilityService.showErrorMessage(error.responseMessage);
            // });

        };

     

        $scope.$on('$ionicView.beforeEnter', function(event, data) {
            initPage();
        });
    }
]);
