/*
    Module Name  : Cards,
    File Name    : cardIntroductionController.js,
    Description  : card Introduction page controller function
*/

'use strict';

angularApp.controller('cardAnnualIncomeController', ["$state", "$scope", "$translate", "newCardService", "cardsService","utilityService",
    function($state, $scope, $translate, newCardService, cardsService,utilityService) {

        //functions, variables that can be accessed from the HTML come here
        var incomeVm = this;

        //private methods section start
        function initPage() {
            incomeVm.showBack = true;
            incomeVm.showNext = true;
            incomeVm.annualIncome = '5';
            incomeVm.lookFor = {
                value: 100000,
                options: {
                    ceil: 3000000,
                    floor: 100000,
                    showSelectionBar: true,
                    onChange: incomeVm.setAnnualIncome,
                    translate: function(value) {
                        value = parseInt(value / 100000, 10);
                        if(value == '1'){
                        return '&#8377;' + value + ' Lakh';
                    }else{
                         return '&#8377;' + value + ' Lakhs';
                    }
                    }
                }
            };

            var annualIncomeValue = newCardService.getParams().annualIncome;
            if (annualIncomeValue) {
                incomeVm.lookFor.value = annualIncomeValue;
            }
        }

        incomeVm.setAnnualIncome = function() {

            newCardService.setParams({
                annualIncome: incomeVm.lookFor.value
            });

        }

        // close journey
        incomeVm.closeJourney = function() {
            $state.go('menu.cardIntroduction');
        }

        incomeVm.goToNextPage = function() {
            newCardService.getExpenseList().then(function(response) {
                cardsService.errorLogger(response);
                if (response.data && response.data.monthlyExpenses.length > 0) {
                    cardsService.setParams({ "expenseWCM": response.data.monthlyExpenses });
                    $state.go('menu.cardExpenses');
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

        }


    
   incomeVm.goBacktoPrevious = function() {
            $state.go('menu.cardPrivileges');
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });
    }
]);
