/*
    Module Name  : Cards,
    File Name    : cardPrivilegesController.js,
    Description  : card Privileges page controller function
*/

'use strict';

angularApp.controller('cardPrivilegesController', ["$state", "$scope", "$translate", "newCardService", "cardsService", "utilityService",
    function($state, $scope, $translate, newCardService, cardsService, utilityService) {

        //functions, variables that can be accessed from the HTML come here
        var privilegesVm = this;
        //Entry function
        function initPage() {
            privilegesVm.showBack = true;
            privilegesVm.showNext = true;
            privilegesVm.lookFor = {
                value: 50,
                minValue: 0,
                maxValue: 100,
                options: {
                    ceil: 100,
                    floor: 0,
                    onChange: privilegesVm.setLifeStyle,
                    translate: function(value) {
                        if (value >= 0 && value <= 40) {
                            return 'Value for money';
                        } else if (value > 40 && value <= 60) {
                            return 'Balanced';
                        } else if (value > 60 && value <= 100) {
                            return 'Best in Class';
                        }
                    }
                }
            };
            var sliderValue = newCardService.getParams().lifeStyle;
            if (sliderValue) {
                privilegesVm.lookFor.value = sliderValue;
            }
            privilegesVm.privilegeGroups();
            getPrivilegestext();

        }

        privilegesVm.setLifeStyle = function() {
                newCardService.setParams({
                    lifeStyle: privilegesVm.lookFor.value
                });
            }

            // close journey
        privilegesVm.closeJourney = function() {
            //$state.go('menu.cardIntroduction');
            $state.go('menu.accountOverviewMyBalance');
        }

           function getPrivilegestext() {
             newCardService.privilegeGroups().then(function(response) {
                    cardsService.errorLogger(response);
                    if (response.data) {
                       privilegesVm.needsLabel = response.data.type.needsLabel; 
                        privilegesVm.privilagesLabel = response.data.type.privilagesLabel;
                    }

                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });;
        }


        privilegesVm.privilegeGroups = function() {
                privilegesVm.categories = [];
                var existPrivilegesCategory = newCardService.getParams().privilegesCategory;
                if (existPrivilegesCategory) {
                    privilegesVm.categories = existPrivilegesCategory;
                } else {
                    var categories = cardsService.getParams().privillagesWCM;
                    angular.forEach(categories, function(value, key) {
                        value.toggle = false;
                    });
                    privilegesVm.categories = categories;
                }
            }

            // go to annual income page
        privilegesVm.goToNext = function() {

                $state.go('menu.cardAnnualIncome');
            }
            
            // go to selected category
        privilegesVm.goToCategory = function(category) {
            category.toggle = category.toggle ? category.toggle : false;
            if (category.toggle == false) {
                category.toggle = true;
            } else {
                category.toggle = false;
            }

            newCardService.setParams({
                privilegesCategory: privilegesVm.categories
            });
        };

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });
    }
]);
