
'use strict';

angularApp.controller('cardSuggestionController', cardSuggestionController);
cardSuggestionController.$inject = ["$state", "$scope", "$translate", "newCardService", "simplifierService", "cardsService", "cardConfig", "cardCompareService", "utilityService"];

function cardSuggestionController($state, $scope, $translate, newCardService, simplifierService, cardsService, cardConfig, cardCompareService, utilityService) {

    //functions, variables that can be accessed from the HTML come here
    var suggestionVm = this;

    //Entry point
    function initPage() {
        suggestionVm.selectedCardDetails = [];
        suggestionVm.canAdd = true;
        suggestionVm.compareList = [];
        suggestionVm.closeCompare();
        suggestionVm.getSuggestedCards();
    }

    // get list of suggested cards
    suggestionVm.getSuggestedCards = function() {
        suggestionVm.totalCards = [];
        suggestionVm.suggestedCards = [];
        suggestionVm.otherSuggestedCards = [];
        suggestionVm.suggestedCardList = cardsService.getParams().suggestedCards;
  if(suggestionVm.suggestedCardList['suggestedCard']!=null)
  {
        suggestionVm.suggestedCards.push(suggestionVm.suggestedCardList['suggestedCard']);
        suggestionVm.totalCards.push(suggestionVm.suggestedCardList['suggestedCard']);
    }
        suggestionVm.otherSuggestedCards = suggestionVm.suggestedCardList['otherCards'];
        angular.forEach(suggestionVm.otherSuggestedCards, function(value, key) {
            suggestionVm.totalCards.push(value);
        });
    }


    // add cards for comparison
    suggestionVm.addToCompare = function() {
            var cardName = [],
                i = 0;
            angular.forEach(suggestionVm.totalCards, function(value, key) {
                if (!value.show) {
                    cardName[i++] = value.cardName;
                }
            });
            var responseData = { "cardNames": cardName };

            cardCompareService.getCardComparison(responseData).then(function(response) {
                cardsService.errorLogger(response);
                if (response.data && response.data.comparisonResult.length > 0) {
                    cardsService.setParams({ "cardCompareData": response.data.comparisonResult });
                    $state.go('menu.cardComparison');
                } else {}
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        // compare two cards
    suggestionVm.getCompare = function(card) {
            var str = '<img class="fss-popup-activated-img" src="img/FSS/Approved.svg"><div class="text-align-center font-content sbi-sub-label roboto-regular">';

            var alertObj = {
                cssClass: 'sbi-alert-popup',
                buttons: [{
                    text: 'OK',
                    type: 'button-positive',
                    onTap: function(e) {

                    }
                }]
            }

            if (suggestionVm.compareList.length == 2 && !suggestionVm.canAdd) {
                card.active = false;
                $translate('MoreThanTwoCards').then(function(translation) {
                    alertObj.template = str + translation + '</div>';
                    cardsService.alertModal(alertObj, null);
                });
                return false;
            }

            if (suggestionVm.compareList.length < 2) {
                suggestionVm.canAdd = true;
                card.show = false;
                suggestionVm.compareList.push(suggestionVm.compareList.length);
            }
            if (suggestionVm.compareList.length == 2) {
                card.show = false;
                suggestionVm.canAdd = false;

            }
        }

        // close compare floating div
    suggestionVm.closeCompare = function() {
            suggestionVm.compareList = [];
            suggestionVm.canAdd = true;
            angular.forEach(suggestionVm.totalCards, function(value, key) {
                value.show = true;
                value.active = false;
            });
        }

        // remove conmpare item
    suggestionVm.removeItem = function(card) {
            card.active = false;
            card.show = true;
            suggestionVm.compareList.pop();
            if (suggestionVm.compareList.length < 2) {
                suggestionVm.canAdd = true;
            }

        }

        // go to selected card page
    // suggestionVm.goToCard = function(card) {
    //     var payload = {
    //         cardName: card.cardName
    //     };
    //     newCardService.getCard(payload).then(function(response) {
    //         cardsService.errorLogger(response);
    //         if (response.data && response.data.cardFeatures.length > 0) {
    //            cardsService.setParams({ "cardDetail": response.data });
    //             $state.go('menu.cardPlatinum');
    //         } else {
    //             var erroObj = {
    //                 cssClass: 'sbi-alert-popup',
    //                 template: '<div class="text-align-center font-content roboto-regular" translate="ResponseError"> </div>',
    //                 buttons: [{
    //                     text: cardConfig.buttons.OK_LABEL,
    //                     type: 'button-positive'
    //                 }]
    //             };
    //             cardsService.alertModal(erroObj, null);

    //         }
    //     }, function(error) {
    //         utilityService.showErrorMessage(error.responseMessage);
    //     });
    // }

   suggestionVm.goToCard = function(card) {
            cardsService.setParams({ "cardName": card.cardName });

            $state.go('menu.cardPlatinum');

        }

    suggestionVm.closeJourney = function() {
        $state.go('menu.cardIntroduction');
    }

    suggestionVm.startAgain = function() {
        newCardService.resetParams();
        $state.go('menu.cardPrivileges');
    }


    //one time initialization to be done when the controller is loaded
    $scope.$on('$ionicView.beforeEnter', function() {
        initPage();
    });

}
