/*
    Module Name  : Cards,
    File Name    : cardWelcomeController.js,
    Description  : card Welcome page controller function
*/

'use strict';

angularApp.controller('cardWelcomeController', ["$timeout", "$state", "$scope", "$translate", "newCardService", "cardConfig", "cardsService", "utilityService","homeScreenService","$ionicHistory",
    function($timeout, $state, $scope, $translate, newCardService, cardConfig, cardsService, utilityService,homeScreenService,$ionicHistory) {

        //functions, variables that can be accessed from the HTML come here
        var cardWelcomeVm = this;

        //private methods section start

        function initPage() {
          if(homeScreenService.ishamburgerMenuNeedAnalysis){
            cardWelcomeVm.isHamCheck = true;
            cardWelcomeVm.isBackCheck = true;
          }else {
            cardWelcomeVm.isBackCheck = false;
          }
            getWelcomeMessages();
        }

        function getWelcomeMessages() {
            cardWelcomeVm.parseContent = cardsService.getParams().needAnalysisWelcome;
        }

        cardWelcomeVm.goBackHome = function() {
          if(homeScreenService.ishamMenu===true){
            //$state.go("menu.homeScreen");
            $ionicHistory.goBack();
            homeScreenService.ishamMenu=false;
          }
          else{
           //$state.go('menu.cardIntroduction');
			$state.go('menu.accountOverviewMyBalance');
        }
      }

        // Begin need analysis journey
        cardWelcomeVm.begin = function() {
                newCardService.privilegeGroups().then(function(response) {
                    cardsService.errorLogger(response);
                    if (response.data && response.data.priviledges.length > 0) {
                        cardsService.setParams({ "privillagesWCM": response.data.priviledges });
                        $state.go('menu.cardPrivileges');
                    }

                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
            //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });
    }
]);
