/*
	Module Name  : Cards,
	File Name    : enterOTPController.js,
	Description	 : OTP page controller function
*/
//(function(){

'use strict';

angularApp.controller('enterOTPController', 
						["$state",
						 "$scope",
						 "$translate", 
						 "linkCardService",
						 "cardConfig",
						 "cardsService",
						 "$filter",
				 
function ($state,
		 $scope,
		 $translate,
		 linkCardService,
		 cardConfig,
		 cardsService,
		 $filter) {
	
	//functions, variables that can be accessed from the HTML come here
	var enterOTPVm = this;
	//private methods section start
	function initPage(){
		var params = linkCardService.getParams();
		enterOTPVm.showBack = false;
		enterOTPVm.showNext = true;	
		enterOTPVm.getOTPNumber = "";		
		enterOTPVm.mobileNumber = $filter('mask')(params.mobileNumber, 'X', 4);		
		enterOTPVm.userID = params.userID;
		enterOTPVm.password = params.password;
		enterOTPVm.otpRef = params.otpRef;
		enterOTPVm.sbiLink = cardConfig.links.register;
		enterOTPVm.showBtn = false;
		enterOTPVm.services = cardsService;
	}
		
	
	enterOTPVm.resendOTP = function(){
		var str = '<img class="fss-popup-activated-img" src="img/FSS/Approved.svg"><div class="text-align-center font-content  roboto-regular">';
		var data = {
				"userID": enterOTPVm.userID || null,
				"password": enterOTPVm.password || null
		}
		linkCardService.sendOTP(data, function(response){			
			var alertObj = { 
					template: str + response.responseJSON.responseMessage +'</div>',
					cssClass: 'sbi-alert-popup',
					buttons: [{
						text: cardConfig.buttons.OK_LABEL,
						type: 'button-positive',
						onTap: function(e) { 
							
						}
					}]
					
			} 
			switch(response.responseJSON.responseCode){
				case cardConfig.responseCode.success:  /* on successful login - send OTP */
					enterOTPVm.getOTPNumber = "";
					break;
				case cardConfig.responseCode.failed: /* on login failed - show popup message */
					cardsService.alertModal(alertObj, function(res){
						enterOTPVm.getOTPNumber = "";
						$state.go('menu.linkCard');
					});
					break;
				default:break;
			}
		});
	}
	
	enterOTPVm.linkCard = function(){
		var str = '<img class="fss-popup-activated-img" src="img/FSS/Approved.svg"><p class="roboto-regular fontSize-heading fss-m-b-30" translate="VERIFIED_TXT"></p><div class="text-align-center font-content  roboto-regular" translate="CARD_LINKED_MSG">';
		var data = {
			otpRef: enterOTPVm.otpRef || null,
			otp: enterOTPVm.getOTPNumber
		}
		
		linkCardService.linkCard(data, function(response){			
			var popTemplate = str + '</div>' 
								
			var alertObj = {
					template: popTemplate,
					cssClass: 'sbi-alert-popup',
					buttons: [{
						text: cardConfig.buttons.OK_LABEL,
						type: 'button-positive',
						onTap: function(e) { 
							
						}
					}]				
			} 
			
			switch(response.responseJSON.responseCode){
				case cardConfig.responseCode.success:  /* on successful otp validation - send OTP */
					cardsService.alertModal(alertObj, function(res){
						$state.go('menu.accountOverviewMyBalance', {cardsLinked: true});
					});					
					break;
				case cardConfig.responseCode.failed: /* on login failed - show popup message */
					cardsService.alertModal(alertObj, function(res){
						enterOTPVm.getOTPNumber = "";
					});
					break;
				default:break;
			}
		})
		
	}
	
	//actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function(event, data) {
		initPage();
	});
		 }]);	
//})();