/*
	Module Name  : Cards,
	File Name    : linkCardController.js,
	Description	 : link card page controller function
*/
//(function(){
'use strict';

angularApp.controller('linkCardController', 
						["$state",
						 "$scope",
						 "$translate", 
						 "linkCardService",
						 "cardConfig",
						 "cardsService",
						 "homeScreenService",
				 
function ($state,
		 $scope,
		 $translate,
		 linkCardService,
		 cardConfig,
		 cardsService,
	 	 homeScreenService) {
	
	//functions, variables that can be accessed from the HTML come here
	var linkCardVm = this;
	//private methods section start
	function initPage(){		
		linkCardVm.isBackCheck = homeScreenService.isBackCheck;
		homeScreenService.isBackCheck = false;
		linkCardVm.showBack = false;
		linkCardVm.showNext = true;
		linkCardVm.services = cardsService;
		linkCardVm.showBtn = false;
		linkCardVm.resetField = true;
		linkCardVm.userIdData = "" ;
		linkCardVm.cardPasswordData = "";		
	}
	
	$translate('USER_ID_REQ')
	.then(function (translatedValue) {
		linkCardVm.userId = translatedValue;
	});
	
	$translate('PASSWORD_REQ')
	.then(function (translatedValue) {
		linkCardVm.cardPassword = translatedValue;
	});
	
	linkCardVm.validate = function(){
		linkCardVm.resetField = false;
		if(linkCardVm.userIdData && linkCardVm.cardPasswordData){
			linkCardVm.showBtn = true;
		}else{
			linkCardVm.showBtn = false;
		}
	}
	
	linkCardVm.sendOTP = function(){
		var data = {
				"userID": linkCardVm.userIdData || null,
				"password": linkCardVm.cardPasswordData || null
		}
		linkCardService.sendOTP(data, function(response){
			var responseData = (response.responseJSON.data) ? angular.extend(response.responseJSON.data, data) : {}; 
			linkCardService.setParams(responseData);			
			var alertObj = {
					template: '<div class="text-center fss-card-small-font">'+ response.responseJSON.responseMessage +'</div>',
					cssClass: 'sbi-alert-popup',
					buttons: [{
						text: cardConfig.buttons.OK_LABEL,
						type: 'button-positive',
						onTap: function(e) { 
							
						}
					}]
					
			} 
			//if(response.responseJSON) response.responseJSON.responseCode = '1111';
			switch(response.responseJSON.responseCode){
				case cardConfig.responseCode.success:  /* on successful login - send OTP */
					$state.go('menu.enterCardOTP');
					break;
				case cardConfig.responseCode.failed: /* on login failed - show popup message */
					cardsService.alertModal(alertObj, function(res){
						linkCardVm.userIdData = "";
						linkCardVm.cardPasswordData = "";
					});
					break;
				default:break;
			}
		});
		
	}
	
	//actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function() {
		initPage();
	});
}]);
//})(); 