/*
    Module Name  : Cards,
    File Name    : linkCardService.js,
    Description  : contains link card page service functions
*/

'use strict';


angularApp.service('linkCardService', ['commonAPIService', 'cardConfig', '$q', 'AdapterUtils',
    function(commonAPIService, cardConfig, $q, AdapterUtils) {

        var linkCardServices = this;
        var params = {};
        var allowAppStatus = "";
       
        /*
            Function Name: sendOTP,
            Input: (callback function),
            Output: none,
            Description: Makes send OTP service call
        */

        linkCardServices.setAllowAppStatus = function(obj) {
            allowAppStatus = obj;
        }
            
        linkCardServices.getAllowAppStatus = function() {
            return allowAppStatus;
        }

        linkCardServices.sendOTP = function(requestParams, callback) {
            commonAPIService.invokeAdapter(cardConfig.adapterURL.sendOTP[0],
                cardConfig.adapterURL.sendOTP[1], requestParams, callback);

            /* var q = $q.defer();
             AdapterUtils.postData(cardConfig.adapterURL.sendOTP[0], requestParams, true).then(
                 function(response) {

                     q.resolve(response.data);
                 },
                 function(error) {
                     q.reject(error);
                 }
             );
             return q.promise;*/
        };
        /*
            Function Name: linkCard,
            Input: (callback function),
            Output: none,
            Description: Makes link card service call
        */

        // linkCardServices.linkCard = function(requestParams, callback) {
        //     commonAPIService.invokeAdapter(cardConfig.adapterURL.linkCard[0],
        //         cardConfig.adapterURL.linkCard[1], requestParams, callback);
        // };

        /*
            Function Name: getHandShakeToken,
            Input: (callback function),
            Output: none,
            Description: Makes link card service call
        */

        linkCardServices.LinkCreditCards = function(payload) {
            // commonAPIService.invokeAdapter(cardConfig.adapterURL.getHandShakeToken[0],
            //     cardConfig.adapterURL.getHandShakeToken[1], null, callback);
            var q = $q.defer();
            AdapterUtils.postData(cardConfig.adapterURL.getHandShakeToken[0], payload, true).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        /*
            Function Name: getLinkedCards,
            Input: (callback function),
            Output: none,
            Description: Makes linked cards get service call
        */
        linkCardServices.getLinkedCards = function(payload) {
            // commonAPIService.invokeAdapter(cardConfig.adapterURL.getLinkedCards[0],
            //     cardConfig.adapterURL.getLinkedCards[1], null, callback);
            var q = $q.defer();
            AdapterUtils.postDataWithTimeOut(cardConfig.adapterURL.getLinkedCards[0], payload, false,180000).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;

        };


        // var response = {
        //     "responseJSON": {
        //         "data": {
        //             "cards": [{
        //                 "nameOfCardHolder": "AMED TEST NAME-1:000011650",
        //                 "cardType": "667",
        //                 "cardNumber": "0114006676534358547",
        //                 "outstandingTotal": "0",
        //                 "lastStatementDate": "16/09/2016",
        //                 "dueDate": "06/10/2016",
        //                 "isBlocked": false,
        //                 "outStanding": {
        //                     "total": "0",
        //                     "unbilled": "0"
        //                 },
        //                 "lastPayment": {
        //                     "amount": "675.18",
        //                     "date": "05/09/2016"
        //                 },
        //                 "credit": {
        //                     "limit": "10000",
        //                     "available": "10000"
        //                 },
        //                 "cash": {
        //                     "limit": "1000",
        //                     "available": "1000"
        //                 },
        //                 "paymentDue": "0",
        //                 "minimumDue": "0",
        //                 "rewardPointDetails": {
        //                     "openingBalance": "917",
        //                     "pointsEarned": "0",
        //                     "pointsRedeemed": "0",
        //                     "closingBalance": "917",
        //                     "toExpire": {
        //                         "points": "110",
        //                         "date": "Current Month"
        //                     }
        //                 },
        //                 "internationalUsageStatus": "Active",
        //                 "policyWrapper": {
        //                     "cardStatement": "Approved",
        //                     "unbilledTransaction": "Approved",
        //                     "paymentHistory": "Approved",
        //                     "accountInformation": "Approved",
        //                     "rewardsRedemption": "Approved",
        //                     "atmPinReplacement": "Approved"
        //                 }
        //             }]
        //         },

        //         "responseMessage": "Success Response from IIB",
        //         "responseCode": "0000",
        //         "errorLog": null
        //     }
        // };
        // callback(response);
        
        /*
            Function Name: getPendingApplicationStatus,
            Input: (callback function),
            Output: none,
            Description: Get status of submitted application
        */
        linkCardServices.getPendingApplicationStatus = function(payload) {
            var q = $q.defer();
            AdapterUtils.postData(cardConfig.adapterURL.getPendingApplicationStatus[0], payload, false).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        /*
            Function Name: getPendingApplications,
            Input: (callback function),
            Output: none,
            Description: Makes pending application get service call
        */
        linkCardServices.getPendingApplications = function(payload) {
            // commonAPIService.invokeAdapter(cardConfig.adapterURL.getSavedApplication[0],
            //     cardConfig.adapterURL.getSavedApplication[1], null, callback);

            var q = $q.defer();
            AdapterUtils.postData(cardConfig.adapterURL.getSavedApplication[0], payload, false).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        /*
            Function Name: completeApplication,
            Input: (callback function),
            Output: none,
            Description: Makes incomplete applications get service call
        */
        linkCardServices.completeApplication = function(payload) {
            // commonAPIService.invokeAdapter(cardConfig.adapterURL.getSavedApplicationData[0],
            //     cardConfig.adapterURL.getSavedApplicationData[1], null, callback);

            var q = $q.defer();
            AdapterUtils.postData(cardConfig.adapterURL.getSavedApplicationData[0], payload, false).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        /*
            Function Name: deLink,
            Input: (callback function),
            Output: none,
            Description: Makes delink service call
        */
        linkCardServices.deLink = function(payload) {
            /* commonAPIService.invokeAdapter(cardConfig.adapterURL.deLink[0],
                 cardConfig.adapterURL.deLink[1], null, callback);*/
            var q = $q.defer();
            AdapterUtils.postData(cardConfig.adapterURL.deLink[0], payload, true).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;

        };

        /*
            Function Name: getApplicationStatus,
            Input: (callback function),
            Output: none,
            Description: get Application status those completed
        */
        linkCardServices.getApplicationStatus = function(data) {
            // commonAPIService.invokeAdapter(cardConfig.adapterURL.getApplicationStatus[0],
            //     cardConfig.adapterURL.getApplicationStatus[1], data, callback);
            var q = $q.defer();
            AdapterUtils.postData(cardConfig.adapterURL.getApplicationStatus[0], {}, true).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;

        };

          linkCardServices.removeSavedApplication = function() {
            var q = $q.defer();
            AdapterUtils.postData(cardConfig.adapterURL.removeSavedApplication[0], {}, true).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        /*
            Function Name: getSavedApplicationData,
            Input: (callback function),
            Output: none,
            Description: Makes delink service call
        */
        // linkCardServices.getSavedApplicationData = function(data,callback) {
        //     commonAPIService.invokeAdapter(cardConfig.adapterURL.getSavedApplicationData[0],
        //         cardConfig.adapterURL.getSavedApplicationData[1], data, callback);
        // };
        /*
            Function Name: setParams,
            Input: (callback function),
            Output: none,
            Description: Sets params obj
        */
        linkCardServices.setParams = function(obj) {
                var setParams = angular.extend(params, obj);
            }
            /*
                Function Name: getParams,
                Input: (callback function),
                Output: none,
                Description: Gets params obj
            */
        linkCardServices.getParams = function() {
                return params;
            }
            /*
                Function Name: resetParams,
                Input: (callback function),
                Output: none,
                Description: Reset params obj
            */
        linkCardServices.resetParams = function() {
            params = {};
        }
        return linkCardServices;
    }
]);
