/*
    Module Name  : Cards,
    File Name    : cardLinkAccountController.js,
    Description  : card link account controller function
*/

'use strict';

angularApp.controller('retrieveTrackApplicationController', ["$state",
    "$scope",
    "applyNowService",
    "$ionicHistory",
    "cardConfig",
    "cardsService", "utilityService", "linkCardService", "payNowServices", "newCardService","getAccountDetailsService","$ionicPopup",



    function($state,
        $scope,
        applyNowService,
        $ionicHistory,
        cardConfig,
        cardsService, utilityService, linkCardService, payNowServices, newCardService,getAccountDetailsService,$ionicPopup) {

        var retrieveTrackApplicationVm = this;

        //load all accounts on page loads
        function initPage() {
            //retrieveTrackApplicationVm.getUserAccounts();
            retrieveTrackApplicationVm.getPendingApplications();
            //trackApplication();
        }



        retrieveTrackApplicationVm.getPendingApplications = function() {
            // Track application

            utilityService.showSpinner();
         
            linkCardService.getPendingApplications({}).then(function(response) {
                //counter++;
              
                cardsService.errorLogger(response);

                retrieveTrackApplicationVm.savedApplications = [];
                retrieveTrackApplicationVm.savedApplications.push(response.data);
                switch (response.responseCode) {
                    case cardConfig.responseCode["success"]:

                    if( response.data.pictureURL)
                    {

                        

                        response.data.pictureURL = response.data.pictureURL.replace(cardConfig.cardUrl.other_card, "https://www");
                        response.data.pictureURL = response.data.pictureURL.replace(cardConfig.cardUrl.tata_card, "https://www.tatacard.com");

                      

                       
                        newCardService.setParams({ "applyPictureURL": response.data.pictureURL });
                    }
                         newCardService.setParams({ "applyCardName": response.data.cardName });


                        /* on successful login - send OTP */

                        retrieveTrackApplicationVm.ApplicationNumberforRetrview = response.data.applicationNumber;
                        retrieveTrackApplicationVm.LeadRefNumberforRetrview = response.data.leadReferNo;
                        retrieveTrackApplicationVm.savedDataCardType = response.data.cardType;
                        retrieveTrackApplicationVm.savedDataFname = response.data.fname;

                        if (response.data.applicationNumber != null && response.data.applicationNumber.toUpperCase() === 'DRAFT') {

                            response.data.applicationNumber = "Draft Application"
                            retrieveTrackApplicationVm.showIncompleteApplication = true; //to show retrieve
                        } else if (response.data.applicationNumber || response.data.leadReferNo) {

                            retrieveTrackApplicationVm.showPendingApplication = true; //to show track application
                        } else {
                            retrieveTrackApplicationVm.noApplications = true;
                        }

                        utilityService.hideSpinner();
                }

            }, function(error) {
                utilityService.hideSpinner();
         

                utilityService.showErrorMessage(error.responseMessage);
                //}

            });
            //utilityService.hideSpinner();
        }


 retrieveTrackApplicationVm.goback=function()
 {
       getAccountDetailsService.tabIndex.tabIndex = 5;
       $state.go('menu.accountOverviewMyBalance');

}

        retrieveTrackApplicationVm.trackApplication = function() {

            // var data = {
            //     "applicationNumber": retrieveTrackApplicationVm.ApplicationNumberforRetrview,
            //     "leadReferNo": retrieveTrackApplicationVm.LeadRefNumberforRetrview,
            //     "CardType": retrieveTrackApplicationVm.savedDataCardType,
            //     "fname": retrieveTrackApplicationVm.savedDataFname
            // }
            linkCardService.getApplicationStatus()
                .then(function(response) {
                        cardsService.errorLogger(response);

                        var successAlertObj = {
                            cssClass: 'sbi-alert-popup',
                            buttons: [{
                                text: 'OK',
                                type: 'button-positive'
                            }]
                        };


                        if (response.data.responseCode) {
                            if (response.data.responseMessage) {
                                successAlertObj.template = '<img class="fss-popup-activated-img" src="img/FSS/Approved.svg"><div class="text-align-center font-content sbi-sub-label roboto-regular">' + response.data.responseMessage + '</div>';
                                cardsService.alertModal(successAlertObj, function(res) {

                                });

                            }
                        }
                    },
                    function(error) {
                        utilityService.enableShowErrorMessage();
                        utilityService.showErrorMessage(error.responseMessage);
                        //cardsService.errorLogger(error);
                    });
            //utilityService.hideSpinner();
        }


        // function resetApplyForm() {
        //     applyNowService.resetParams();

        // }

        retrieveTrackApplicationVm.removeApplication = function() {
            var popTemplate = '<div class="text-align-center font-content sbi-sub-label roboto-regular" translate="REMOVE_MSG"></div>';
            var alertObj = {
                template: popTemplate,
                cssClass: 'sbi-alert-popup',
                buttons: [{
                    text: 'Cancel',
                    type: 'button-positive'
                }, {
                    text: 'Ok',
                    type: 'button-positive',
                    onTap: function(e) {
                        linkCardService.removeSavedApplication({}).then(
                            function(response) {


                                 var alertPop = $ionicPopup.alert({
                                title: "",
                                template: "Application has been removed Successfully"
                            });
                            alertPop.then(function(res) {

                                if (res) {
                                  
                                retrieveTrackApplicationVm.showIncompleteApplication = false;
                                retrieveTrackApplicationVm.noApplications = true;

                                }

                            });
                             
                             
                            },
                            function(error) {
                                utilityService.showErrorMessage(error.responseMessage);
                            });
                      
                    }
                }]
            }

            cardsService.alertModal(alertObj, function(res) {

            });
        }


        retrieveTrackApplicationVm.completeApplication = function() {

        utilityService.showSpinner();
            linkCardService.completeApplication({}).then(function(response) {
                cardsService.errorLogger(response);

                switch (response.responseCode) {

                    case cardConfig.responseCode["success"]:

                        newCardService.setParams({ "applyCardType": response.data.cardType });
                        applyNowService.setParams({ "accountNum": response.data.applicantDetails.payment.bankAccountNumber });
                        newCardService.setParams({ "applyCardCategory": response.data.categoryName });
                        //resetApplyForm();

                        if (response.data) {
                            applyNowService.currentState="Retrieve";
                            cardsService.setApplicationDetail(response.data);
                            var data = response.data;
                            cardsService.setParams({ 'pendingApplication': true });

                             applyNowService.setParams({ "personalDetails": response.data.applicantDetails.personalDetails });

                             cardsService.setParams({ "citySelected": response.data.applicantDetails.personalDetails.address.city });

                             
                            if (data.isMobileVerified == "true") {
                                applyNowService.setParams({ "applyCardMobileVerify": true });
                            } else {
                                applyNowService.setParams({ "applyCardMobileVerify": false });
                            }

                            if (data.pageNo == "2") {
                                //redirecting professional page-1

                                applyNowService.setPersonalData1(data.applicantDetails.personalDetails);
                                applyNowService.setPersonalData2(data.applicantDetails.personalDetails);

                                applyNowService.getDesignationList().then(function(response) {
                                    cardsService.errorLogger(response);
                                    // step3Vm.designation = response.data.designations;
                                    if (response.data && response.data.designations.length != 0) {
                                        cardsService.setParams({ "designationsMaster": response.data.designations });
                                        applyNowService.getPersonalDetails().then(function(response) {
                                            cardsService.errorLogger(response);
                                            if (response.responseCode == cardConfig.responseCode.success) {
                                                if (response.data && response.data.qualifications.length > 0 && response.data.occupations.length > 0 && response.data.annualIncomes.length > 0 && response.data.salutations.length > 0 && response.data.genders.length > 0) {
                                                    cardsService.setParams({ "masterData": response.data });
                                                    applyNowService.getDisclaimer17().then(function(response) {
                                                        cardsService.errorLogger(response);
                                                        if (response.data && response.data.message) {
                                                            cardsService.setParams({ "getDisclaimer17": response.data.message });
                                                            applyNowService.getCities().then(function(response) {
                                                                cardsService.errorLogger(response);
                                                                if (response.data.cities && response.data.cities.length != 0) {
                                                                    cardsService.setParams({ "city": response.data.cities });
                                                                     utilityService.hideSpinner();
                                                                    $state.go('menu.cardProfessional1');
                                                                }

                                                            }, function(error) {
                                                                utilityService.showErrorMessage(error.responseMessage);
                                                            });
                                                        }
                                                    }, function(error) {
                                                           utilityService.hideSpinner();
                                                        utilityService.showErrorMessage(error.responseMessage);
                                                    });


                                                }

                                            }


                                        }, function(error) {
                                             utilityService.hideSpinner();
                                            utilityService.showErrorMessage(error.responseMessage);
                                            // cardsService.errorLogger(error);
                                        });
                                    }

                                }, function(error) {
                                     utilityService.hideSpinner();
                                    utilityService.showErrorMessage(error.responseMessage);
                                });


                            }



                            // } 
                            else {
                                //personalDetails-1 page
                                applyNowService.getPersonalDetails().then(function(response) {
                                    cardsService.errorLogger(response);
                                    if (response.responseCode == cardConfig.responseCode.success) {
                                        if (response.data && response.data.qualifications.length > 0 && response.data.occupations.length > 0 && response.data.annualIncomes.length > 0 && response.data.salutations.length > 0 && response.data.genders.length > 0) {
                                            cardsService.setParams({ "masterData": response.data });
                                            applyNowService.getCities().then(function(response) {
                                                cardsService.errorLogger(response);
                                                if (response.data.cities && response.data.cities.length != 0) {
                                                    cardsService.setParams({ "city": response.data.cities });
                                                     utilityService.hideSpinner();
                                                    $state.go('menu.cardPersonalDetails1');
                                                }

                                            }, function(error) {
                                                 utilityService.hideSpinner();
                                                utilityService.showErrorMessage(error.responseMessage);
                                            });
                                        }

                                    }


                                }, function(error) {
                                     utilityService.hideSpinner();
                                    utilityService.showErrorMessage(error.responseMessage);
                                    // cardsService.errorLogger(error);
                                });
                            }


                        }
                        break;
                }
            }, function(error) {
                 utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
                //cardsService.errorLogger(error);
            });

        }


        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });
    }
]);
