
    'use strict';

    angularApp.controller('cardDetailsController', ["$timeout",
        "$state",
        "$scope",
        "$stateParams",
        "payNowServices",
        "cardsService",
        "$ionicBackdrop",
        "$ionicPopover",
        "$ionicScrollDelegate",
        "cardConfig",
        "floatingMenuService", "utilityService",
        "cardCompareService",

        function($timeout,
            $state,
            $scope,
            $stateParams,
            payNowServices,
            cardsService,
            $ionicBackdrop,
            $ionicPopover,
            $ionicScrollDelegate,
            cardConfig,
            floatingMenuService, utilityService,
            cardCompareService) {

        //functions, variables that can be accessed from the HTML come here
        var cardDetailsVm = this;
        var toggleAddon = false;
        //Entry point   
        function initPage(stateParams) {
            utilityService.showSpinner();
            payNowServices.getRedirectUrls().then(function(response) {
                              
                    payNowServices.links=JSON.parse(response.data.urls);
                     utilityService.hideSpinner();


                }, function(error) {
                    utilityService.hideSpinner();
                });
            cardDetailsVm.cardDetails = {};
            cardDetailsVm.hasAddonCards = false;
            cardDetailsVm.getLinkedCards = cardsService.getCardList();


            cardsService.setCardList(cardDetailsVm.getLinkedCards);
            cardDetailsVm.getLinkedCards = cardsService.getCardList();


            if (cardsService.getParams().hasOwnProperty('primaryCardSelected')) {
                cardDetailsVm.selectedIndex = cardDetailsVm.id = cardsService.getParams().primaryCardSelected || 0;
            } else {
                cardDetailsVm.selectedIndex = cardDetailsVm.id = cardsService.getSelectedCard() || 0;
            }

            cardDetailsVm.updateCardDetail(cardDetailsVm.id);

            cardDetailsVm.selectedCardNo = cardDetailsVm.getLinkedCards[cardDetailsVm.selectedIndex]['cardNumber'];
            cardDetailsVm.accountId = cardDetailsVm.getLinkedCards[cardDetailsVm.selectedIndex]['accountId'];
            cardCompareService.accountId = cardDetailsVm.accountId;
            cardDetailsVm.cardDetails = {};
            cardDetailsVm.cardDetails = cardDetailsVm.getLinkedCards[cardDetailsVm.selectedIndex];
            cardCompareService.policyWrapper = cardDetailsVm.cardDetails.policyWrapper;
            cardDetailsVm.policyWrapper = [];
            cardDetailsVm.policyWrapper = cardCompareService.policyWrapper;
            if (cardDetailsVm.policyWrapper.atmPinReplacement === "Approved") {
                cardDetailsVm.showManagePIN = true;
            } else {
                cardDetailsVm.showManagePIN = false;
            }

              if (cardDetailsVm.policyWrapper.cardHotlist === "Approved") {
                cardDetailsVm.showBlockCard = true;
            } else {
                cardDetailsVm.showBlockCard = false;
            }
            if (cardDetailsVm.policyWrapper.rewardCatalogue === "Approved" && cardDetailsVm.policyWrapper.rewardsRedemption === "Approved") {
                cardDetailsVm.showRewards = true;
            } else {
                cardDetailsVm.showRewards = false;
            }
            // if (cardDetailsVm.policyWrapper.activateInternationalUsage === "Approved") {
            //     cardDetailsVm.showInternationalusage = true;
            // } else {
            //     cardDetailsVm.showInternationalusage = false;
            // }
            if (cardDetailsVm.policyWrapper.reissueReplacementCheck === "Approved") {
                cardCompareService.disableBlock = false;
            } else {
                cardCompareService.disableBlock = true;
            }
            cardsService.setSelectedCard(cardDetailsVm.cardDetails.id);
            var creditUtilized = (parseInt(cardDetailsVm.cardDetails.credit.available, 10) / parseInt(cardDetailsVm.cardDetails.credit.limit, 10)) * 100;
            cardDetailsVm.creditUtilized = 100 - (creditUtilized || 0);
            //yono it - 1520
            if(cardDetailsVm.creditUtilized < 0)
            {
                 cardDetailsVm.creditUtilized = 0;
            }
            var cashUtilized = (parseInt(cardDetailsVm.cardDetails.cash.available, 10) / parseInt(cardDetailsVm.cardDetails.cash.limit, 10)) * 100;
            cardDetailsVm.cashUtilized = 100 - (cashUtilized || 0);
            if(cardDetailsVm.cashUtilized < 0)
            {
                 cardDetailsVm.cashUtilized = 0;
            }
            //end yono it - 1520

        }

        // update card details for selected card
        cardDetailsVm.updateCardDetail = function(cardNum, fromDropDown) {
            if (fromDropDown) {
                cardDetailsVm.selectedIndex = cardDetailsVm.id;
                cardNum = cardDetailsVm.getLinkedCards[cardDetailsVm.selectedIndex]['cardNumber'];
                cardDetailsVm.accountId = cardDetailsVm.getLinkedCards[cardDetailsVm.selectedIndex]['accountId'];
                cardCompareService.accountId = cardDetailsVm.accountId;
                cardDetailsVm.cardDetails = cardDetailsVm.getLinkedCards[cardDetailsVm.selectedIndex];
                cardCompareService.policyWrapper = cardDetailsVm.cardDetails.policyWrapper;
                cardDetailsVm.policyWrapper = [];
                cardDetailsVm.policyWrapper = cardCompareService.policyWrapper;
                if (cardDetailsVm.policyWrapper.atmPinReplacement === "Approved") {
                    cardDetailsVm.showManagePIN = true;
                } else {
                    cardDetailsVm.showManagePIN = false;
                }
                if (cardDetailsVm.policyWrapper.rewardCatalogue === "Approved" && cardDetailsVm.policyWrapper.rewardsRedemption === "Approved") {
                    cardDetailsVm.showRewards = true;
                } else {
                    cardDetailsVm.showRewards = false;
                }
                // if (cardDetailsVm.policyWrapper.activateInternationalUsage === "Approved") {
                //     cardDetailsVm.showInternationalusage = true;
                // } else {
                //     cardDetailsVm.showInternationalusage = false;
                // }
                if (cardDetailsVm.policyWrapper.reissueReplacementCheck === "Approved") {
                    cardCompareService.disableBlock = false;
                } else {
                    cardCompareService.disableBlock = true;
                }
                var creditUtilized = (parseInt(cardDetailsVm.cardDetails.credit.available, 10) / parseInt(cardDetailsVm.cardDetails.credit.limit, 10)) * 100;
                cardDetailsVm.creditUtilized = 100 - creditUtilized;
                var cashUtilized = (parseInt(cardDetailsVm.cardDetails.cash.available, 10) / parseInt(cardDetailsVm.cardDetails.cash.limit, 10)) * 100;
                cardDetailsVm.cashUtilized = 100 - cashUtilized;
                cardsService.setSelectedCard(cardDetailsVm.cardDetails.id);
                var responseData = {
                    primaryCardSelected: cardDetailsVm.selectedIndex
                }

                cardsService.setParams(responseData);
                var addOnCardPayload = {
                    "cardNumber": cardNum
                    //"accountId": cardCompareService.accountId
                };

                payNowServices.getAddOnCards(addOnCardPayload).then(function(response) {
                    cardsService.errorLogger(response);
                    // cardDetailsVm.cardDetails.addonCards = response.data.cards;

                    if (response.data && response.data.cards) {
                        cardsService.setParams({ "addOnCards": response.data.cards || [] });

                          cardDetailsVm.cardDetails.addonCards = cardsService.getParams().addOnCards;
                          payNowServices.setaddonCards(cardDetailsVm.cardDetails.addonCards);
                          cardDetailsVm.addonCards = cardDetailsVm.cardDetails.addonCards;

                          cardDetailsVm.counter =0 ;
                          for(var k=0; k< cardDetailsVm.addonCards.length;k++){
                            if(cardDetailsVm.addonCards[k].isAddOnCardDetailEnabled === true){
                            cardDetailsVm.counter = cardDetailsVm.counter + 1;
                          }
                     }
                         cardsService.getSetCardDetail(cardDetailsVm.cardDetails, cardDetailsVm.selectedIndex);
                    }

                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }

            else
            {
                       cardDetailsVm.cardDetails.addonCards = cardsService.getParams().addOnCards;
                        payNowServices.setaddonCards(cardDetailsVm.cardDetails.addonCards);
                        cardDetailsVm.addonCards = cardDetailsVm.cardDetails.addonCards;

                        cardDetailsVm.counter =0 ;
                        for(var k=0; k< cardDetailsVm.addonCards.length;k++){
                            if(cardDetailsVm.addonCards[k].isAddOnCardDetailEnabled === true){
                                cardDetailsVm.counter = cardDetailsVm.counter + 1;
                             }
                         }
                              cardsService.getSetCardDetail(cardDetailsVm.cardDetails, cardDetailsVm.selectedIndex);
            }

        }

        // go to home
        cardDetailsVm.goBackHome = function() {
            $state.go('menu.accountOverviewMyBalance');
        }

        // go to card payment page
        cardDetailsVm.goToCardPayment = function() {
             utilityService.showSpinner();
            payNowServices.getUserAccounts({}).then(function(response) {

                cardsService.errorLogger(response);
                if (response.data && response.data.beneficiaryList && response.data.beneficiaryList.ownAccounts) {
                    cardsService.setParams({ "paymentAccounts": response.data.beneficiaryList.ownAccounts });
                     utilityService.hideSpinner();
                    $state.go('menu.cardPayment');
                }
            }, function(error) {
                  utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });

        }

        // group visibility toggle function
        cardDetailsVm.isGroupShown = function() {

            return toggleAddon;
        }

        // group toggle function
        cardDetailsVm.toggleGroup = function() {
            if (toggleAddon) {
                toggleAddon = false;
                $timeout(function() {
                    $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop(true);
                }, 100)
            } else {
                toggleAddon = true;
                $timeout(function() {
                    $ionicScrollDelegate.$getByHandle('mainScroll').scrollBottom(true);
                }, 100)

            }
        }

        // floating menu open event handler
        $scope.$on('floating-menu:open', function(event) {
            var elem = document.querySelectorAll('#floating-backdrop');
            for (var j = 0; j < elem.length; j++) {
                elem[j].className = '';
                elem[j].className = 'backdrop visible active';
            }

        });

        // floating menu close event handler
        $scope.$on('floating-menu:close', function(event) {
            var elem = document.querySelectorAll('#floating-backdrop');
            for (var j = 0; j < elem.length; j++) {
                elem[j].className = '';
                elem[j].className = 'backdrop';
            }
        });

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.enter', function() {
            initPage();
        });


        cardDetailsVm.toResetPin = function() {
           floatingMenuService.isResendExhaust = false;
            floatingMenuService.isTextExhaust = false;
            floatingMenuService.setIsResend(true);
            if (cardDetailsVm.addonCards && cardDetailsVm.addonCards.length >= 1) {
                $state.go("menu.resetPin");
            } else {
              if(cardDetailsVm.cardDetails.isManagePinEnabled){
                  //send otp for reset pin
                  var sendOTPPayload = {
                    "cardNumber": cardDetailsVm.cardDetails['cardNumber'],
                    // "mobileNumber": cardDetailsVm.cardDetails['regMobileNumber'],
                    // "email": cardDetailsVm.cardDetails['regEmail'],
                    "accountId" :cardDetailsVm.cardDetails['accountId'],
                    "isResend" : "false"
                };

                floatingMenuService.setParams(sendOTPPayload);

                floatingMenuService.sendOTP(sendOTPPayload)
                .then(function(response) {
                    cardsService.errorLogger(response);
                    switch (response.data.responseCode) {
                        case cardConfig.responseCode.dataSuccess:
                        floatingMenuService.setParams({ cardNumber: sendOTPPayload.cardNumber });
                        $state.go("menu.resendOTPPin");
                        break;
                    }
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
            else {
                $state.go("menu.resetPin");
            }


        }
    };

}
]);
