/*
    Module Name  : Cards,
    File Name    : cardPayment.js,
    Description  : controller function for card payment page
*/

'use strict';

angularApp.controller('cardPaymentController', ["$timeout", "$state",
    "$scope",
    "$translate",
    "payNowServices",
    "cardsService",
    "cardConfig",
    "linkCardService", "utilityService", "getAccountDetailsService", "$ionicPopup",


    function($timeout,
        $state,
        $scope,
        $translate,
        payNowServices,
        cardsService,
        cardConfig,
        linkCardService, utilityService, getAccountDetailsService, $ionicPopup) {

        var cardPaymentVm = this;
        var cName, cNUmber;
        var alertObj = {
            cssClass: 'sbi-alert-popup',
            buttons: [{
                text: cardConfig.buttons.OK_LABEL,
                type: 'button-positive',
                onTap: function(e) {

                }
            }]
        };
        //Entry point
        function initPage() {

            if (ionic.Platform.isIOS()) {
                cardPaymentVm.cardOtherPay = "text";
            } else {
                cardPaymentVm.cardOtherPay = "tel";
            }

            var test = payNowServices.getaddonCards();
            var selectedCards = cardsService.getSetCardDetail();
            cName = selectedCards.cardName;
            cNUmber = selectedCards.cardNumber;
            cardPaymentVm.getUserAccounts();
            cardPaymentVm.otherAmtSelected = false;
            cardPaymentVm.cardDetails = selectedCards.cardDetails;
            cardPaymentVm.nameOfCardHolder = selectedCards.nameOfCardHolder;
            cardPaymentVm.cardNo = selectedCards.cardNumber;
            cardPaymentVm.cardName = selectedCards.cardName;
            cardPaymentVm.paymentDue = cardPaymentVm.payment = selectedCards.paymentDue;
            cardPaymentVm.minimumDue = selectedCards.minimumDue;
            var paymentDefault = parseFloat(cardPaymentVm.payment);

            if ((!cardPaymentVm.otherAmtSelected) && (paymentDefault <= 0)) {
                alertObj.template = '<div class="font-content sbi-sub-label roboto-regular" translate="CHOOSE_OTHER_AMOUNT"></div>'
                cardsService.alertModal(alertObj, function(res) {

                });
            }



        }

        // Get user account details
        cardPaymentVm.getUserAccounts = function() {
            cardPaymentVm.userAccounts = cardsService.getParams().paymentAccounts;
            cardPaymentVm.account = cardPaymentVm.userAccounts[0];
            cardPaymentVm.validate();
        };



        function paymentCall() {

            cardPaymentVm.maximumAmountLimit = { limitAmount: 100000 };

            if (!cardPaymentVm.account) {
                alertObj.template = '<div class="font-content sbi-sub-label roboto-regular" translate="CURRENTLY_NO_ACCOUNT"></div>';
                cardsService.alertModal(alertObj, function(res) {});
            } else if (parseFloat(cardPaymentVm.sumModAccountAmount) == 0) {
                alertObj.template = '<div class="font-content sbi-sub-label roboto-regular" translate="NO_BALANCE_AMOUNT"></div>';
                cardsService.alertModal(alertObj, function(res) {});
            } else if ((!cardPaymentVm.otherAmtSelected) && parseFloat(cardPaymentVm.payment) <= 0) {
                alertObj.template = '<div class="font-content sbi-sub-label roboto-regular" translate="CHOOSE_OTHER_AMOUNT"></div>'
                cardsService.alertModal(alertObj, function(res) {});
            } else if (parseFloat(cardPaymentVm.payment) > parseFloat(cardPaymentVm.sumModAccountAmount)) {
                alertObj.template = '<div class="font-content sbi-sub-label roboto-regular" translate="NO_BALANCE_DUE_AMOUT"></div>';
                cardsService.alertModal(alertObj, function(res) {});

            } else if (parseFloat(cardPaymentVm.payment) <= parseFloat(cardPaymentVm.sumModAccountAmount)) {
                if (cardPaymentVm.otherAmtSelected && !parseInt(cardPaymentVm.amtVal, 10)) {
                    alertObj.template = '<div class="font-content sbi-sub-label roboto-regular" translate="ENTER_VALID_AMOUNT"></div>';
                    cardsService.alertModal(alertObj, function(res) {});

                } else if (parseInt(cardPaymentVm.amtVal) > cardPaymentVm.maximumAmountLimit.limitAmount) {

                    //alertObj.template = '<div class="font-content sbi-sub-label roboto-regular" >{{"PAY_LIMIT_EXCESS"| translate: cardPaymentVm.maximumAmountLimit}}</div>';
                    alertObj.template = '<div class="font-content sbi-sub-label roboto-regular" translate="PAY_LIMIT_EXCESS"></div>';
                    cardsService.alertModal(alertObj, function(res) {});

                }


                    else {
                        var randomNumber;
			var requestDate = new Date();
			requestDate = requestDate.getTime()
			randomNumber=Math.floor((Math.random()) + requestDate);
			randomNumber = (randomNumber * 10 + 1);
                    var data = {
                        cardNumber: cardPaymentVm.cardNo,
                        amount: cardPaymentVm.payment,
                        accountNumber:cardPaymentVm.account.benAccntNo,
                        narration: "credit Card Payment",
                        "secKey":randomNumber
                     
                    }
                  utilityService.showSpinner();

                    payNowServices.payDues(data).then(function(response) {
                            cardsService.errorLogger(response);
                   if(response.data.isOTPRequired=="true")
                   {

                    if(response.data.secKey==randomNumber)
                    {
                     payNowServices.cardPaymentBankacc=cardPaymentVm.account.benAccntNo;
                     payNowServices.cardPaymentAmount=cardPaymentVm.payment;
                         utilityService.hideSpinner();
                      $state.go("menu.cardPaymentOtp");
                    }
                  }

                  else
                  {
                          switch (response.responseCode) {
                       
                                case cardConfig.responseCode.success:
                                    var responseData = {
                                        transactionRef: response.data.referenceNumber || null,
                                        cardName: cName,
                                        cardNumber: cNUmber,
                                        accountNumber: cardPaymentVm.account.benAccntNo,
                                        amount: cardPaymentVm.payment,
                                        success: true
                                    };
                                    payNowServices.setParams(responseData);
                                    linkCardService.getLinkedCards({})
                                        .then(function(response) {
                                            cardsService.errorLogger(response);
                                            switch (response.responseCode) {
                                                case cardConfig.responseCode["success"]:
                                                    if (response) {
                                                        var cardList = (response.data.cards) ? response.data.cards : [];
                                                        cardsService.setCardList(cardList);
                                                         utilityService.hideSpinner(); // setting card list
                                                        $state.go('menu.paymentSuccessful');
                                                    }
                                                    break;
                                            }
                                        }, function(error) {
                                             utilityService.hideSpinner();
                                            utilityService.showErrorMessage(error.responseMessage);
                                        });

                                    break;
                                    //}

                                case cardConfig.responseCode.failed:
                                    var responseData = {
                                        success: false
                                    }
                                    payNowServices.setParams(responseData);
                                     utilityService.hideSpinner(); 
                                    $state.go('menu.paymentSuccessful');
                                    break;
                            }



                  }

                        },

                        function(error) {
                      utilityService.hideSpinner(); 

                            var messageTitle = "";
                            if (error.responseCode == "8505" || error.responseCode == "CD0008" ) {
                                messageTitle = "Message!";
                            }
                            var alertPop = $ionicPopup.alert({
                                title: messageTitle,
                                template: error.responseMessage
                            });
                            alertPop.then(function(res) {

                                if (res) {
                                    // getAccountDetailsService.tabIndex.tabIndex = 5;
                                    //$state.go('menu.cardOverview');
                                    getAccountDetailsService.tabIndex.tabIndex = 5;
                                    $state.go('menu.accountOverviewMyBalance');

                                }

                            });

                        });
                }

            }
        }
            // Call paynow service and go to payment successful page
            cardPaymentVm.goTopaymentSuccessful = function() {


                var rupeeSymbol = String.fromCharCode(8377);

                var successAlertObj = {
                    cssClass: 'sbi-alert-popup',
                    buttons: [{
                        text: 'OK',
                        type: 'button-positive'
                    }]
                }
                var popTemplate = '<div class="text-align-center font-content sbi-sub-label roboto-regular">Are you sure you want to Proceed for payment of ' + rupeeSymbol + cardPaymentVm.payment + '? </div>'
    

                var alertObj1 = {
                    template: popTemplate,
                    cssClass: 'sbi-alert-popup',
                    buttons: [{
                        text: 'Cancel',
                        type: 'button-positive',
                        onTap: function(e) {

                            return true;

                        }
                    }, {
                        text: 'Proceed',
                        type: 'button-positive',
                        onTap: function(e) {
                            paymentCall();

                        }



                    }]
                }

                if(cardPaymentVm.otherAmtSelected) 
                {
                    if(!cardPaymentVm.amtVal) 
                    {
                       cardPaymentVm.amtVal="0";

                    } 



                     cardPaymentVm.payment = parseFloat(cardPaymentVm.amtVal).toString();
                } 

                if (parseInt(cardPaymentVm.payment) > 0) {

                cardsService.alertModal(alertObj1, function(res) {



               });
            } else {
                paymentCall();
            }


            }

        //Function to check for MOD and add balance
        cardPaymentVm.checkForMod = function(){
            if (getAccountDetailsService.accessRightsData.accounts != null || getAccountDetailsService.accessRightsData.accounts != "" || getAccountDetailsService.accessRightsData.accounts != undefined) {
                var isAccountTransactional = false;
                for (var i in getAccountDetailsService.accessRightsData.accounts) {
                        if (getAccountDetailsService.accessRightsData.accounts[i].accountNumber === cardPaymentVm.account.benAccntNo && parseInt(getAccountDetailsService.accessRightsData.accounts[i].accessResponse) != 0) {
                            isAccountTransactional = true;
                        }
                }
            }else {
                    cardPaymentVm.sumModAccountAmount = cardPaymentVm.account.balance;
            }
            if (isAccountTransactional) {
                if (getAccountDetailsService.accessRightsData.accounts) {
                    for (var i in getAccountDetailsService.accessRightsData.accounts) {
                        if (getAccountDetailsService.accessRightsData.accounts[i].accountNumber === cardPaymentVm.account.benAccntNo && getAccountDetailsService.accessRightsData.accounts[i].modBalance) {
                            cardPaymentVm.sumModAccountAmount = parseFloat(cardPaymentVm.account.balance) + parseFloat(getAccountDetailsService.accessRightsData.accounts[i].modBalance);
                            break;
                        }
                    }
                } else {
                    cardPaymentVm.sumModAccountAmount = cardPaymentVm.account.balance;
                }
            }
        }

        // validate on submit
        cardPaymentVm.validate = function(amtType) {
            cardPaymentVm.checkForMod();
            if (amtType == 'otherAmount') {
                cardPaymentVm.otherAmtSelected = true;
                if (cardPaymentVm.amtVal > 0) {
                    cardPaymentVm.payment = parseFloat(cardPaymentVm.amtVal).toString();
                }
                else if(cardPaymentVm.amtVal==".")
                {
                    cardPaymentVm.amtVal="0.";

                     cardPaymentVm.payment ="0.";
                     
                }
                $timeout(function() {
                    document.getElementById("card-other-amt").focus();
                }, 50);

            } else if (amtType == 'predefined') {
                cardPaymentVm.otherAmtSelected = false;
            }
        }
		cardPaymentVm.setPrimaryAccount = function(tabIndex) {
			if (cardPaymentVm.userAccounts) {
				var selItem = getAccountDetailsService.displayPrimaryAccountAsDefault(cardPaymentVm.userAccounts, getAccountDetailsService.accountOverviewData.customerInformation.accountNumber)
				cardPaymentVm.account = selItem;//.selIndex.toString();
				cardPaymentVm.validate();
			}
		};



        $scope.$on('$ionicView.loaded', function () {
           if (!getAccountDetailsService.accessRightsData.accounts) {
                getAccountDetailsService.getAccountsAccessRights('').then(function (data) {
                    getAccountDetailsService.accessRightsData = data;
                    cardPaymentVm.checkForMod();
                }, function (error) {
                    // Failure block
                });
            }
        });

        $scope.$on('$ionicView.beforeEnter', function(event, data) {
            initPage();
		 cardPaymentVm.setPrimaryAccount();
	
        });
    }
]);
