/*
    Module Name  : Cards,
    File Name    : resendOTPinController.js,
    Description  : floating menu PIN resend OTP controller function
*/

'use strict';

angularApp.controller('cardPaymentOtpController', ["$state",
"$scope",
"$translate",
"cardsService",
"floatingMenuService",
"applyNowService",
"$filter",
"cardConfig", "utilityService",
"$timeout",
"validateService",
"payNowServices",
"$ionicPopup",
"getAccountDetailsService",
"linkCardService",
"lifeInsuranceBasicApplicationService",
"customerInfoService",
"constantConfig",
function cardPaymentOtpController(
    $state,
    $scope,
    $translate,
    cardsService,
    floatingMenuService,
    applyNowService,
    $filter,
    cardConfig, utilityService, $timeout, validateService,payNowServices,$ionicPopup,getAccountDetailsService,linkCardService,lifeInsuranceBasicApplicationService,customerInfoService,constantConfig) {
    //functions, variables that can be accessed from the HTML come here
    var cardPaymentOtpVm = this;
     var cName, cNUmber;

    cardPaymentOtpVm.validateService = validateService;
    //Entry point
    function initPage() {
       cardPaymentOtpVm.isResendOTP=false;
        var params = floatingMenuService.getParams();
        cardPaymentOtpVm.getOTPNumber = '';
        cardPaymentOtpVm.cardNumber = params.cardNumber;
    cardPaymentOtpVm.isResendDisabled=false;
        cardPaymentOtpVm.mobileNumberForResend = customerInfoService.customer.mobile;
        cardPaymentOtpVm.email = params.email;


         var selectedCards = cardsService.getSetCardDetail();
           cName = selectedCards.cardName;
            cNUmber = selectedCards.cardNumber;
             var rupeeSymbol = String.fromCharCode(8377);
       // resendOTPPinVm.accountId = params.accountId;
        cardPaymentOtpVm.enterOTP='Please enter OTP to make Payment of ' + rupeeSymbol + payNowServices.cardPaymentAmount + '';

        cardPaymentOtpVm.showBack = false;
        cardPaymentOtpVm.showNext = true;
        cardPaymentOtpVm.noValidOTP = false;
        cardPaymentOtpVm.clickCount = 0;
        
        if(floatingMenuService.isResendExhaust){
             cardPaymentOtpVm.disableLink = true;
        }
       if(floatingMenuService.isTextExhaust){
             cardPaymentOtpVm.disableTextBox = true;
       } 
      /*  resendOTPPinVm.disableLink = false;
        resendOTPPinVm.disableTextBox = false;*/
      
            cardPaymentOtpVm.mobileNumber = $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4);

        

       

    }

    $translate(['ENTER_OTP']).then(function(translations) {

        cardPaymentOtpVm.OTP = translations['ENTER_OTP'];
    });

    // Function to resend OTP
    cardPaymentOtpVm.resendOTP = function() {
            cardPaymentOtpVm.getOTPNumber = "";
                utilityService.showSpinner();
             payNowServices.resendOTPForPayDues().then(function(response) {
                 utilityService.hideSpinner();
                cardPaymentOtpVm.clickCount++;
                cardPaymentOtpVm.isResendOTP=true;
                if(cardPaymentOtpVm.clickCount==2)
                {
                   cardPaymentOtpVm.isResendDisabled=true;
                }
                if(response.data.otpStatus!="0000")
                {
                     utilityService.showErrorMessage(response.responseMessage);
                }


                
            },
             function(error) {
                        utilityService.hideSpinner();

             utilityService.showErrorMessage(error.responseMessage);

           } );
}

	cardPaymentOtpVm.goToBack = function() {
		 $state.go('menu.cardOverview');
	}


    // function to validate OTP
    cardPaymentOtpVm.validateOTP = function() {
		 utilityService.showSpinner();
         var randomNumber;
	 var requestDate = new Date();
	 requestDate = requestDate.getTime()
	 randomNumber=Math.floor((Math.random()) + requestDate);
	 randomNumber = (randomNumber * 10 + 1);
        
            floatingMenuService.validateOTPForPayment({
             
                "otp": cardPaymentOtpVm.getOTPNumber,
                  "secKey":randomNumber
            }).then(function(response) {
                   

                      if (response.responseCode == cardConfig.responseCode.success) {

                           var newNumber=parseInt(response.data.secKey) ;

                            var generatedNumber=(newNumber/2)-1;
                              generatedNumber=generatedNumber/99;

                            if(randomNumber!=generatedNumber)
                            {
                                 utilityService.hideSpinner();
                                utilityService.showErrorMessage(response.responseMessage)
                            }

                        

                        else
                        {
                            if(response.data.otpStatus!="Success")
                    {
                         var errorValidateOTP = {
                            cssClass: 'sbi-alert-popup',
                            template: '<div class="text-align-center font-content roboto-regular">' + response.responseMessage + '</div>',
                            buttons: [{
                                text: cardConfig.buttons.OK_LABEL,
                                type: 'button-positive'
                            }]
                        };
                        utilityService.hideSpinner();
                        cardsService.alertModal(errorValidateOTP, null); 



                    }
                  else   {

                      var responseData = {
                                        transactionRef: response.data.referenceNumber || null,
                                        cardName: cName,
                                        cardNumber: cNUmber,
                                        accountNumber:  payNowServices.cardPaymentBankacc,
                                        amount: payNowServices.cardPaymentAmount,
                                        success: true
                                    };

                                    payNowServices.setParams(responseData);
                                    linkCardService.getLinkedCards({})
                                        .then(function(response) {
                                           
                                            switch (response.responseCode) {
                                                case cardConfig.responseCode["success"]:
                                                    if (response) {
                                                        var cardList = (response.data.cards) ? response.data.cards : [];
                                                        cardsService.setCardList(cardList); // setting card list
                                                        getAccountDetailsService.accountOverviewData="";
														                            utilityService.hideSpinner();
                                                        $state.go('menu.paymentSuccessful');
                                                    }
                                                    break;
                                                     default:
                                                     utilityService.hideSpinner();
                                                     break;
                                            }
                                        }, function(error) {
                                          getAccountDetailsService.accountOverviewData="";
										                      	utilityService.hideSpinner();
                                            utilityService.showErrorMessage(error.responseMessage);
                                        });

                                   
                                    }
                                }
                            }

                            else
                            {
                                 utilityService.hideSpinner();
                                 utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);

                               
                            }
                      
                  
                },
                function(error) {
					
				               	utilityService.hideSpinner();

                            var messageTitle = "";
                            if (error.responseCode == "8505" || error.responseCode == "0002" || error.responseCode == "0007" || error.responseCode == "CD0008") { 
                                messageTitle = "Message!";
								
            								 var alertPop = $ionicPopup.alert({
                                            title: messageTitle,
                                            template: error.responseMessage
            									});
								
								 alertPop.then(function(res) {

										if (res) {
									     getAccountDetailsService.accountOverviewData="";
										   getAccountDetailsService.tabIndex.tabIndex = 5;
											 $state.go('menu.accountOverviewMyBalance');

										}

									});
               }else{
								utilityService.showErrorMessage(error.responseMessage);
							}
                           
                           
                });

                        }
                        

        


    $scope.$on('$ionicView.beforeEnter', function(event, data) {
        initPage(data.stateParams);
    });

}
]);