/*
    Module Name  : Cards,
    File Name    : payNowServices.js,
    Description  : service functions for card payment
*/

'use strict';


angularApp.service('payNowServices', ['commonAPIService', 'cardConfig', '$q', 'AdapterUtils',
    function(commonAPIService, cardConfig, $q, AdapterUtils) {

        var payNowServices = this;
        var params = {};
        var test;
        var cardPaymentBankacc="";
        var cardPaymentAmount=0;
        var links="";

        /*
            Function Name: cardOverview,
            Input: (callback function),
            Output: none,
            Description: Makes card overview service call
        */
        payNowServices.cardOverview = function(queryParam, callback) {
            var path = cardConfig.adapterURL.cardOverview[0] + '?cardNumber=' + queryParam;
            commonAPIService.invokeAdapter(path, cardConfig.adapterURL.cardOverview[1], null, callback);
        };

        /*
            Function Name: getUserAccounts,
            Input: (callback function),
            Output: none,
            Description: Makes user accounts get service call
        */
        payNowServices.getUserAccounts = function(payload, callback) {
            var q = $q.defer();
            AdapterUtils.postData(cardConfig.adapterURL.getOwnAccounts[0], payload, false).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        payNowServices.getAccountsAccessRights = function(payload, callback) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/HomeAdapter/getAccountsAccessRights", {}, false).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };        

         payNowServices.resendOTPForPayDues = function() {
            var q = $q.defer();
            AdapterUtils.postData(cardConfig.adapterURL.resendOTPForPayDues[0], {}, false).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        


            payNowServices.getRedirectUrls = function() {
            var q = $q.defer();
            AdapterUtils.postData(cardConfig.adapterURL.getRedirectUrls[0], {}, false).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        

        /*
            Function Name: payNow,
            Input: (callback function),
            Output: none,
            Description: Makes pay now service call
        */
        payNowServices.payDues = function(requestParams, callback) {
            var q = $q.defer();
            AdapterUtils.postDataWithTimeOut(cardConfig.adapterURL.payDues[0], requestParams, false,130000).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        /*
            Function Name: setParams,
            Input: (callback function),
            Output: none,
            Description: Sets params obj
        */
        payNowServices.setParams = function(obj) {

                var setParams = angular.extend(params, obj);
            }
            /*
                Function Name: getParams,
                Input: (callback function),
                Output: none,
                Description: Gets params obj
            */
        payNowServices.getParams = function() {
            return params;
        }



        /*
            Function Name: setParams,
            Input: (callback function),
            Output: none,
            Description: Sets params obj
        */
        payNowServices.setaddonCards = function(obj) {
                test = obj;
            }
            /*
                Function Name: getParams,
                Input: (callback function),
                Output: none,
                Description: Gets params obj
            */
        payNowServices.getaddonCards = function() {
                //alert('get', test);
                return test;
            }
            /*
                Function Name: resetParams,
                Input: (callback function),
                Output: none,
                Description: Resets params obj
            */
        payNowServices.resetParams = function() {
            params = {};
        }

        payNowServices.getAddOnCards = function(payload, callback) {
            var q = $q.defer();
            AdapterUtils.postData(cardConfig.adapterURL.getAddOnCards[0], payload, false).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        return payNowServices;
    }
]);
