

'use strict';

angularApp.controller('shikharCardsController', ["$state", "$scope", "$translate", "newCardService", "cardsService", "$filter", "$ionicScrollDelegate", "$timeout",
    "cardConfig", "cardCompareService", "utilityService","getAccountDetailsService","$ionicHistory","homeScreenService","clickStreamService","applyNowService","$ionicPopup","linkCardService",
    function($state, $scope, $translate, newCardService, cardsService, $filter, $ionicScrollDelegate, $timeout, cardConfig, cardCompareService, utilityService,
        getAccountDetailsService, $ionicHistory, homeScreenService,clickStreamService,applyNowService, $ionicPopup,linkCardService) {

        var shikharCardsVm = this;

        function initPage() {
            shikharCardsVm.isBackCheck = homeScreenService.isBackCheck;
			homeScreenService.isBackCheck = false;
            shikharCardsVm.canAdd = true;
            shikharCardsVm.getCardsList();
            shikharCardsVm.compareList = [];
            shikharCardsVm.compareCardList = [];
            shikharCardsVm.closeCompare();
            shikharCardsVm.ComparebtnShow = false;
        }

        shikharCardsVm.getCardsList = function() {

            newCardService.getCardsList().then(function(response) {
                cardsService.errorLogger(response);
                if (response.data && response.data.cards.length > 0) {
                  shikharCardsVm.cardsList = response.data.cards;
                  angular.forEach(shikharCardsVm.cardsList, function(value, key) {
                  value.show = true;
                  value.active = false;

                   value.pictureURL = value.pictureURL.replace(cardConfig.cardUrl.other_card, "https://www");
                   value.pictureURL = value.pictureURL.replace(cardConfig.cardUrl.tata_card, "https://www.tatacard.com");
                });
               var list = $filter('unique')(shikharCardsVm.cardsList, 'categoryName');
            }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

        }

        // go to home
        shikharCardsVm.goBackHome = function() {
          if(homeScreenService.ishamMenu===true){
            $ionicHistory.goBack();
  					//$state.go("menu.homeScreen");
  					homeScreenService.ishamMenu=false;
  				}
  				else{
           //getAccountDetailsService.tabIndex.tabIndex = 5;
           $state.go('menu.accountOverviewMyBalance');
        }
      }

        // add cards to compare function
        shikharCardsVm.addToCompare = function() {
            var cardName = [];
            angular.forEach(shikharCardsVm.cardsList, function(value, key) {
                if (!value.show) {

                    cardName[cardName.length] = value.cardName;
                }
            });


            var responseData = { "cardNames": cardName };

            cardCompareService.getCardComparison(responseData).then(function(response) {
                cardsService.errorLogger(response);
                if (response.data && response.data.comparisonResult.length > 0) {
                    cardsService.setParams({ "cardCompareData": response.data.comparisonResult });
                    $state.go('menu.cardComparison');
                } else {

                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        // go to selected card detail page
        shikharCardsVm.goToCard = function(card) {

            cardsService.setParams({ "cardName": card.cardName });

            $state.go('menu.cardPlatinum');

        }

        shikharCardsVm.CompareShow = function(){
            shikharCardsVm.ComparebtnShow = true;
        }

        shikharCardsVm.CompareHide = function(){
            shikharCardsVm.ComparebtnShow = false;
            shikharCardsVm.compareList = [];
			shikharCardsVm.canAdd = true;
			angular.forEach(shikharCardsVm.cardsList, function(value, key) {
                value.show = true;
                value.active = false;
            });
        }

        shikharCardsVm.getCompare = function(card) {

            //toggle add remove card from compare list
            if(card.active == false){
                card.active = false;
                card.show = true;
                shikharCardsVm.compareList.pop();
                if (shikharCardsVm.compareList.length < 2) {
                    shikharCardsVm.canAdd = true;
                }
            }
            else{
                cardsService.setParams({ "browseCardsTabSelected": shikharCardsVm.showCategory });
                shikharCardsVm.compCards = [];
                var str = '<img class="fss-popup-activated-img" src="img/FSS/Approved.svg"><div class="text-align-center font-content sbi-sub-label roboto-regular">';

                var alertObj = {
                    cssClass: 'sbi-alert-popup',
                    buttons: [{
                        text: cardConfig.buttons.OK_LABEL,
                        type: 'button-positive',
                        onTap: function(e) {

                        }
                    }]
                }

                if (shikharCardsVm.compareList.length == 2 && !shikharCardsVm.canAdd) {
                    card.active = false;
                    $translate('MoreThanTwoCards').then(function(translation) {
                        alertObj.template = str + translation + '</div>';
                        cardsService.alertModal(alertObj, null);
                    });
                    return false;
                }
                if (shikharCardsVm.compareList.length < 2) {
                    shikharCardsVm.canAdd = true;
                    card.show = false;
                    shikharCardsVm.compareList.push(shikharCardsVm.compareList.length);
                }
                if (shikharCardsVm.compareList.length == 2) {
                    card.show = false;
                    shikharCardsVm.canAdd = false;
                }
            }
        }


        // close compare floating div
        shikharCardsVm.closeCompare = function() {
            shikharCardsVm.compareList = [];
            shikharCardsVm.canAdd = true;
            angular.forEach(shikharCardsVm.cardsList, function(value, key) {
                value.show = true;
                value.active = false;
            });
        }

        // remove item from compare list
        shikharCardsVm.removeItem = function(card) {

            card.active = false;
            card.show = true;
            shikharCardsVm.compareList.pop();
            if (shikharCardsVm.compareList.length < 2) {
                shikharCardsVm.canAdd = true;
            }

        }

        
		shikharCardsVm.applyNow = function(card) {
            utilityService.showSpinner();
             if(linkCardService.getAllowAppStatus() == ""){
                linkCardService.getPendingApplicationStatus({})
                .then(function(response) {
                        cardsService.errorLogger(response);
                        if (response.data) {
                                if (response.data.allow == "false"){
                                    linkCardService.setAllowAppStatus(response.data);
                                    utilityService.hideSpinner();
                                    utilityService.enableShowErrorMessage(); 
                                    utilityService.showErrorMessage(response.data.allowMessage);   
                                    return false;       
                                }
                                else{
                                    linkCardService.setAllowAppStatus(response.data);
                                    allowApplication(card);
                                }
                        }
                    },
                    function(error) {
                        utilityService.hideSpinner();
                        allowApplication(card);
                    });
            }
            else{
                if(linkCardService.getAllowAppStatus().allow == "false"){
                    utilityService.hideSpinner();
                    utilityService.enableShowErrorMessage(); 
                    utilityService.showErrorMessage(linkCardService.getAllowAppStatus().allowMessage);   
                    return false;       
                }
                else{
                    utilityService.hideSpinner();
                    allowApplication(card);
                }
            } 
        };

		function allowApplication(card) {
            applyNowService.resetApplyForm();
            newCardService.setParams({ "applyCardType": card.cardType });
            newCardService.setParams({ "applyCardName": card.cardName });
            newCardService.setParams({ "applyPictureURL": card.pictureURL });
            newCardService.setParams({ "applyCardCategory": card.categoryName });

            applyNowService.getCities().then(function(response) {
                cardsService.errorLogger(response);
                cardsService.setParams({ "city": response.data.cities });
                cardsService.setParams({ 'pendingApplication': false });
                //$state.go('menu.cardCitySelection');
                $state.go('menu.cardPersonalDetails1');
                //}
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
		//actions to done everytime the view is shown

        $scope.$on('$ionicView.beforeEnter', function(event, data) {
            initPage();
        });
    }
]);
