'use strict';
angularApp.controller('csatAckController', [
    "$state",
    "$scope",
    "mPinLoginService",
    "csatService",
    "clearServiceDataService",
    "AdapterUtils",
    "loggedInUserService",
    "$ionicPopup",
    "$filter",
    "utilityService",
    "$ionicSideMenuDelegate",
    "constantConfig",
    "quickPayService",
    function ($state,
        $scope,
        mPinLoginService,
        csatService,
        clearServiceDataService,
        AdapterUtils,
        loggedInUserService,
        $ionicPopup,
        $filter,
        utilityService,
        $ionicSideMenuDelegate,
        constantConfig,
        quickPayService
    ) {

        var csatAckVm = this;

        $scope.$on('$ionicView.loaded', function() {
            $ionicSideMenuDelegate.canDragContent(false);
        });
        
        $scope.$on('$ionicView.afterLeave', function() {
            $ionicSideMenuDelegate.canDragContent(false);
        });

        $scope.$on('$ionicView.beforeEnter', function () {
            $ionicSideMenuDelegate.canDragContent(false);
            csatAckVm.rating = csatService.rating;
            csatAckVm.type = csatService.csatScreenType;
            csatAckVm.CSAT_RATING_CHECK = constantConfig.CSAT.CSAT_RATING_CHECK;
        });

        csatAckVm.ok = function () {
            if (csatAckVm.type == "CSR") {
                var template = '<div class="align_center ">' +
                    '<img alt="" class="margin-bottom-10" src="img/landingPage/AppRating.svg"/>' +
                    '<div class="opinion"><span translate="APPRATE_OPINION"></span></div>' +
                    '<div class="font-14 margin-bottom-20 padding-hor-50"><span translate="APPRATE_EXPERIENCE_ANDROID"></span></div>' +
                    '</div>';
                var myPopup = $ionicPopup.show({
                    cssClass: 'dialog apprate-popup',
                    template: template,
                    scope: '',
                    buttons: [{
                        text: $filter('translate')('APPRATE_RATE_NOW'),
                        onTap: function (e) {
                            myPopup.close();
                            utilityService.upgradeApp();
                            csatAckVm.logoutCommon();

                        }
                    }, {
                        text: $filter('translate')('APPRATE_NO_THANKS'),
                        onTap: function (e) {
                            myPopup.close();
                            csatAckVm.logoutCommon();

                        }
                    }]
                });
            }
            else {
                csatAckVm.logoutCommon();
            }
        }

        csatAckVm.logoutCommon = function () {

            sessionStorage.setItem('getNRICounterFromLocalStorage', "0");
            clearServiceDataService.clearServiceData();
            csatAckVm.sessionLogout();

        };
        csatAckVm.sessionLogout = function () {
            mPinLoginService.isLoggedIn = false;
            AdapterUtils.sessionLogout().then(
                function (response) {
                    loggedInUserService.logoutUser(true);
                },
                function (error) {
                    loggedInUserService.logoutUser(true);
                }
            );
        }

        return this;
    }
]);


