/**
 *   @ngdoc config
 *   @name angularApp.config : CSAT Config
 *   @description
 *   configuration file for CSAT module
 *   @author : Hitesh Dadhich
 */

/*This function defines all the constants named  Adapters url for cards module*/
angularApp
    /*State defination with respective names, urls, controllers and templates */
    .config([
        '$stateProvider',
        function ($stateProvider) {
            //Cards start
            $stateProvider
                .state('menu.csatLanding', {
                    url: '/csatLanding',
                    data: {
                        pageId: 'CSATLANDING'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/csat/csatLanding.html',
                            controller: 'csatLandingController',
                            controllerAs: 'csatLandingVm'
                        }
                    }
                })
                .state('menu.csatAckowledgement', {
                    url: '/csatAckowledgement',
                    data: {
                        pageId: 'CSATACK'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/csat/csatAcknowledgement.html',
                            controller: 'csatAckController',
                            controllerAs: 'csatAckVm'
                        }
                    }
                })
        }
    ]);
