'use strict';
angularApp.controller('csatLandingController', [
  "$state",
  "$scope",
  "clearServiceDataService",
  "AdapterUtils",
  "loggedInUserService",
  "mPinLoginService",
  "csatService",
  "$ionicSideMenuDelegate",
  "quickPayService",
  "cryptoService",
  function ($state,
    $scope,
    clearServiceDataService,
    AdapterUtils,
    loggedInUserService,
    mPinLoginService,
    csatService,
    $ionicSideMenuDelegate,
    quickPayService,
    cryptoService
  ) {

    var csatLandingVm = this;

    $scope.$on('$ionicView.loaded', function () {
      $ionicSideMenuDelegate.canDragContent(false);
    });

    $scope.$on('$ionicView.afterLeave', function () {
      $ionicSideMenuDelegate.canDragContent(false);

    });

    $scope.$on('$ionicView.beforeEnter', function () {
      $ionicSideMenuDelegate.canDragContent(false);
      navigator.splashscreen.hide();
      csatLandingVm.type = csatService.csatScreenType;
      $scope.numbers = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10];
      $scope.rating = 0;
      $scope.npsrating = 0;
      $scope.npsratings = { current: 0, max: 10 };
      $scope.csatratings = [{
        current: 0,
        max: 5
      }];
    });
    $scope.getCsatSelectedRating = function (rating) {
      csatLandingVm.rating = rating;
      csatService.rating = rating;
    }
    $scope.getCsatNpsSelectedRating = function (npsrating) {
      csatLandingVm.npsrating = npsrating;
      csatService.npsrating = npsrating;
    }
    csatLandingVm.submit = function () {
      var params = {};
      //go to nps for testing
      if (csatLandingVm.type == "CSR") {
        if (!(csatLandingVm.rating == undefined || csatLandingVm.rating == null)) {
          var req1 = cryptoService.getSHA512EncryptedData(csatLandingVm.rating + "CSAT").toString();
          params = { "rateCount": csatLandingVm.rating, "isSkip": false, "reqValidate": req1};
          csatService.saveGoldenJourneyStatus(params).then(function (data) {
            $state.go('menu.csatAckowledgement');
          }, function (error) {
            //utilityService.showErrorMessage(error.responseMessage);
            csatLandingVm.logoutCommon();
          });
        }

      }
      else {
        if (!(csatLandingVm.npsrating == undefined || csatLandingVm.npsrating == null)) {
          var req2 = cryptoService.getSHA512EncryptedData(csatLandingVm.npsrating + "CSAT").toString();
          params = { "rateCount": csatLandingVm.npsrating, "isSkip": false, "reqValidate": req2 };
          csatService.saveGoldenJourneyStatus(params).then(function (data) {
            $state.go('menu.csatAckowledgement');
          }, function (error) {
            //utilityService.showErrorMessage(error.responseMessage);
            csatLandingVm.logoutCommon();
          });
        }

      }
    }
    csatLandingVm.logoutCommon = function () {
      
        sessionStorage.setItem('getNRICounterFromLocalStorage', "0");
        clearServiceDataService.clearServiceData();
        csatLandingVm.sessionLogout();
     
    };

    csatLandingVm.skip = function () {
      var req3 = cryptoService.getSHA512EncryptedData("" + "CSAT").toString();
      var params = { "rateCount": "", "isSkip": true, "reqValidate": req3 };
      csatService.saveGoldenJourneyStatus(params).then(function (data) {
        csatLandingVm.logoutCommon();
      }, function (error) {
        csatLandingVm.logoutCommon();

      });

    }


    csatLandingVm.sessionLogout = function () {
      mPinLoginService.isLoggedIn = false;
      AdapterUtils.sessionLogout().then(
        function (response) {
          loggedInUserService.logoutUser(true);
        },
        function (error) {
          loggedInUserService.logoutUser(true);
        }
      );
    }
    return this;
  }
]);


