'use strict';

angularApp.controller('directTaxLandingController', [
    "$state",
    "$q",
    "$scope",
    "$translate",
    "eTaxService",
    "utilityService",
    "ompMerchantsService",
    "$ionicPopup",
    "loggedInUserService",
    "$sce",
    function ($state,
        $q,
        $scope,
        $translate,
        eTaxService,
        utilityService,
        ompMerchantsService,
        $ionicPopup,
        loggedInUserService,
        $sce
        ) {

        var directTaxLandingVm = this;
        directTaxLandingVm.link = '';
        //directTaxLandingVm.directTaxTnC = $sce.trustAsHtml(eTaxService.directTaxTnC);
        
        function initPage() {
            $translate(['LOGOUT_CONFIRM','OK','CANCEL']).then(function (translations) {
                    directTaxLandingVm.logoutMsg = translations['LOGOUT_CONFIRM'];
                    directTaxLandingVm.textOk = translations['OK'];
                    directTaxLandingVm.textCancel = translations['CANCEL'];
                    
            });
                
        };
        directTaxLandingVm.goToBack = function () {
            $state.go('menu.eTax');
        };
        directTaxLandingVm.goToETax = function () {
            $state.go('menu.eTax');
        };
        directTaxLandingVm.goToPrevious = function () {
            $ionicHistory.goBack();
        };
        directTaxLandingVm.submit = function () {
            
            var imageType = 'img/FT/BhimUpi/alertSymbol.svg';
            var message = directTaxLandingVm.logoutMsg;
            $ionicPopup.show({
                    title: '',
                    template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src='+imageType+' /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'
                + message + '</span></div></div></div>',
                    scope: $scope,
                    cssClass: 'bhim-alert-popup bg-white-popup',
                    buttons: [{
                        text: directTaxLandingVm.textCancel,
                        type: 'button-negative',
                        onTap: function () {
                            
                        }
                    },{
                        text: directTaxLandingVm.textOk,
                        type: 'button-positive',
                        onTap: function () {
                           
                                loggedInUserService.logoutUser();
                                ompMerchantsService.inChromeBrowser(directTaxLandingVm.link);
                            
                            
                        }
                    }],
                });
        };
       
        directTaxLandingVm.getTermAndCondition = function(){
            
                    var obj = {
                        "type" : "directTaxes"
                    }
                    eTaxService.fetchTermConditionDirectTax(obj).then(function (data) {
                        console.log(data);
                        if (!utilityService.isUndefined(data)) {
                            var content = data.getDirectTaxes[0].body;
                            directTaxLandingVm.link = data.getDirectTaxes[0].link;
                            content = content.replace("FIELD_1}}", '&lt;button class=&quot;margin-bottom-25 button button-small btn-color bhim-btn-spec-dbl bqr-font-rob-med btn-cancel&quot; click-stream=&quot;click&quot; onclick=&quot;angular.element(this).scope().directTaxLandingVm.submit()&quot;&gt;Continue &lt;/button&gt;');
                            directTaxLandingVm.directTaxTnC = $sce.trustAsHtml(content);
                            
                        }
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
               

        }
        
        /*actions to done everytime the view is shown*/
        $scope.$on('$ionicView.beforeEnter', function () {
            directTaxLandingVm.getTermAndCondition();
        });

        $scope.$on('$ionicView.loaded', function () {
                initPage();
            });
        return this;
    }
]);
