/**
*   @ngdoc config
*   @name angularApp.config : eTaxConfig
*   @description
*	configuration file for e-Tax module
*/

'use strict';

/*State defination with respective names, urls, controllers and templates */
angularApp.config(['$stateProvider',
	function ($stateProvider) {
		//Fund Transfer start
		$stateProvider
			.state('menu.eTax', {
				url: '/eTax',
				data: {
                        pageId: 'ETAX_LANDING'
                    },
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/eTax/eTax.html',
						controller: 'eTaxController',
						controllerAs: 'eTaxVm',
					}
				}
			})
			.state('menu.directTaxLanding', {
				url: '/directTaxLanding',
				data: {
                        pageId: 'ETAX_DIRECTTAX'
                    },
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/eTax/directTaxLanding.html',
						controller: 'directTaxLandingController',
						controllerAs: 'directTaxLandingVm',
					}
				}
			})
			.state('menu.stateTaxLanding', {
				url: '/stateTaxLanding',
				data: {
                        pageId: 'ETAX_STATETAX'
                    },
				views: {
					'menuContent': {
						templateUrl: 'pages/eTax/stateTaxLanding.html',
						controller: 'stateTaxLandingController',
						controllerAs: 'stateTaxLandingVm',
					}
				}
			})
			.state('menu.stateTaxDetails', {
				url: '/stateTaxDetails',
				data: {
                        pageId: 'ETAX_STATETAXDETAILS'
                    },
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/eTax/stateTaxDetails.html',
						controller: 'stateTaxDetailsController',
						controllerAs: 'stateTaxDetailsVm',
					}
				}
			})

	}]);
