'use strict';

angularApp.controller('stateTaxDetailsController', [
    "$state",
    "$q",
    "$scope",
    "$translate",
    "eTaxService",
    "utilityService",
    "ompMerchantsService",
    "$ionicPopup",
    "loggedInUserService",
    "$compile",
    "$sce",
    function ($state,
        $q,
        $scope,
        $translate,
        eTaxService,
        utilityService,
        ompMerchantsService,
        $ionicPopup,
        loggedInUserService,
        $compile,
        $sce
        ) {

        var stateTaxDetailsVm = this;

        
        
        function initPage() {
            $translate(['LOGOUT_CONFIRM','OK','CANCEL']).then(function (translations) {
                    stateTaxDetailsVm.logoutMsg = translations['LOGOUT_CONFIRM'];
                    stateTaxDetailsVm.textOk = translations['OK'];
                    stateTaxDetailsVm.textCancel = translations['CANCEL'];
                    
            });
                
        };
        stateTaxDetailsVm.goToBack = function () {
            $state.go('menu.eTax');
        };
        stateTaxDetailsVm.goToETax = function () {
            $state.go('menu.eTax');
        };
        stateTaxDetailsVm.goToPrevious = function () {
            $state.go('menu.stateTaxLanding');
        };
        stateTaxDetailsVm.submit = function () {
            
            var imageType = 'img/FT/BhimUpi/alertSymbol.svg';
            var message = stateTaxDetailsVm.logoutMsg;
            $ionicPopup.show({
                    title: '',
                    template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src='+imageType+' /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'
                + message + '</span></div></div></div>',
                    scope: $scope,
                    cssClass: 'bhim-alert-popup bg-white-popup',
                    buttons: [{
                        text: stateTaxDetailsVm.textCancel,
                        type: 'button-negative',
                        onTap: function () {
                            
                        }
                    },{
                        text: stateTaxDetailsVm.textOk,
                        type: 'button-positive',
                        onTap: function () {
                            if(eTaxService.selectedState.foreignKey != ""){
                                loggedInUserService.logoutUser();
                                var url = eTaxService.selectedState.foreignKey;
                                ompMerchantsService.inChromeBrowser(url);
                            }
                            
                        }
                    }],
                });
        };
       
        stateTaxDetailsVm.getTermAndCondition = function(){
            
                    var obj = {
                        "type" : "b3StateGovTaxes"
                    }
                    eTaxService.fetchTermCondition(obj).then(function (data) {
                        console.log(data);
                        if (!utilityService.isUndefined(data)) {
                            
                            data = data.replace("FIELD_2}}", eTaxService.selectedState.key+" State Govt.");
                            data = data.replace("FIELD_1}}", '<button class="margin-bottom-25 button button-small btn-color bhim-btn-spec-dbl bqr-font-rob-med btn-cancel" click-stream="click" onclick="angular.element(this).scope().stateTaxDetailsVm.submit()">Continue</button>');
                            data = data.replace("FIELD_3}}", eTaxService.selectedState.key+" State Government");
                            data = data.replace("FIELD_4}}", eTaxService.selectedState.value);
                            console.log(data);
                            stateTaxDetailsVm.stateTaxTnC = $sce.trustAsHtml(data);
                            
                            
                        }
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                
        }
        
        /*actions to done everytime the view is shown*/
        $scope.$on('$ionicView.beforeEnter', function () {
            stateTaxDetailsVm.getTermAndCondition();
        });

        $scope.$on('$ionicView.loaded', function () {
                initPage();
            });
        return this;
    }
]);
