'use strict';

angularApp.controller('stateTaxLandingController', [
    "$state",
    "$q",
    "$scope",
    "$translate",
    "eTaxService",
    "utilityService",
    "ompMerchantsService",
    "$ionicPopup",
    "loggedInUserService",
    function ($state,
        $q,
        $scope,
        $translate,
        eTaxService,
        utilityService,
        ompMerchantsService,
        $ionicPopup,
        loggedInUserService
        ) {

        var stateTaxLandingVm = this;

        function initPage() {
            $translate(['LOGOUT_CONFIRM','OK','CANCEL']).then(function (translations) {
                    stateTaxLandingVm.logoutMsg = translations['LOGOUT_CONFIRM'];
                    stateTaxLandingVm.textOk = translations['OK'];
                    stateTaxLandingVm.textCancel = translations['CANCEL'];
                    
            });
                
        };
        stateTaxLandingVm.goToBack = function () {
            $state.go('menu.eTax');
        };
        stateTaxLandingVm.goToETax = function () {
            $state.go('menu.eTax');
        };
        stateTaxLandingVm.goToPrevious = function () {
            $ionicHistory.goBack();
        };
        stateTaxLandingVm.submit = function () {
            eTaxService.selectedState = stateTaxLandingVm.taxType;
            $state.go('menu.stateTaxDetails');
            
        };
       
        
        stateTaxLandingVm.getStateList = function(){
            var obj = {
                        "key" : "",
                        "action" : "b2B3StateList"
                    }
                    eTaxService.getStateOrTaxList(obj).then(function (data) {
                        console.log(data);
                        if (!utilityService.isUndefined(data)) {
                            stateTaxLandingVm.states = data.info;
                            
                        }
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
        }
        stateTaxLandingVm.getTaxList = function(){
            if(stateTaxLandingVm.state == ""){
                stateTaxLandingVm.taxTypes = [];
            }
            else{
                stateTaxLandingVm.taxType = "";
                stateTaxLandingVm.taxTypes = [];
            var obj = {
                        "key" : stateTaxLandingVm.state.key,
                        "action" : "b2B3TaxList"
                    }
                    eTaxService.getStateOrTaxList(obj).then(function (data) {
                        console.log(data);
                        if (!utilityService.isUndefined(data)) {
                            stateTaxLandingVm.taxTypes = data.info;
                            
                        }
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }
        }
        function isEmpty(obj) {
            for(var key in obj) {
                if(obj.hasOwnProperty(key))
                    return false;
            }
            return true;
        }
        /*actions to done everytime the view is shown*/
        $scope.$on('$ionicView.beforeEnter', function () {
            if(!isEmpty(eTaxService.selectedState))
            {
                stateTaxLandingVm.taxType = eTaxService.selectedState;
                stateTaxLandingVm.state = eTaxService.selectedState;
            }
            else{
                stateTaxLandingVm.taxType = "";
                stateTaxLandingVm.state = "";
                stateTaxLandingVm.taxTypes = [];
            }
            stateTaxLandingVm.getStateList();
        });

        $scope.$on('$ionicView.loaded', function () {
                initPage();
            });
        return this;
    }
]);
