/**
 *   @ngdoc config
 *   @name angularApp.config : fasTagConfig
 *   @description
 *  configuration file for FASTag module
 */

/*This function defines all the constants named  Adapters url for FASTag module*/

angularApp
    .value(
        'fasTagConfig', {
            "links": {
              "fasTagurl": "https://fastag.onlinesbi.com"
            }
        })

    /*State defination with respective names, urls, controllers and templates */
    .config([
        '$stateProvider',
        function ($stateProvider) {
            $stateProvider
			.state('menu.fasTagLanding', {
				url: '/fasTagLanding',
				cache: false,
				data: {
					pageId: 'FASTAG_LANDING'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/fasTag/fasTagLanding.html',
						controller: 'fasTagLandingController',
						controllerAs: 'fasTagLandingVm'
					}
				}
			})
		 .state('menu.fasTagSbiPortalRedirection', {
            url: '/fasTagSbiPortalRedirection',
            cache: false,
            data: {
                pageId: 'FASTAG_RECHARGE_SBI_PORTAL'
            },
            views: {
                'menuContent': {
                    templateUrl: 'pages/fasTag/fasTagSbiPortalRedirection.html',
                    controller: 'fasTagSbiPortalRedirectionController',
                    controllerAs: 'fasTagSbiPortalRedirectionVm'
                }
            }
		})
		.state('menu.fasTagRecharge_UPI', {
			url: '/fasTagRecharge_UPI',
			cache: false,
			data: {
				pageId: 'FASTAG_RECHARGE_UPI'
			},
			views: {
				'menuContent': {
					templateUrl: 'pages/fasTag/fasTagRecharge_UPI.html',
					controller: 'fasTagRecharge_UPIController',
					controllerAs: 'fasTagRecharge_UPIVm'
				}
			}
		})
		 .state('menu.fasTagRechargeVerify_UPI', {
		 	url: '/fasTagRechargeVerify_UPI',
		 	cache: false,
		 	data: {
		 		pageId: 'FASTAG_RECHARGE_VERIFY_UPI'
		 	},
		 	views: {
		 		'menuContent': {
		 			templateUrl: 'pages/fasTag/fasTagRechargeVerify_UPI.html',
		 			controller: 'fasTagRechargeVerify_UPIController',
		 			controllerAs: 'fasTagRechargeVerify_UPIVm'
		 		}
		 	}
         })
        }
    ]);
