'use strict';
angularApp.controller('fasTagLandingController', [
	"$state",
	"$scope",
	"ionicToast",
	"$rootScope",
	"bhimUpiService",
	"utilityService",
	"constantConfig",
	"mPinLoginService",
	"loggedInUserService",
	function ($state, $scope, ionicToast, $rootScope, bhimUpiService,utilityService,constantConfig,mPinLoginService,loggedInUserService) {

		var fasTagLandingVm = this;
		function initPage() {
		fasTagLandingVm.sbiLink = fasTagConfig.links.fasTagurl;

		};
		fasTagLandingVm.goBack = function(){
			if(mPinLoginService.isLoggedIn == true){

				$state.go('menu.fundsTransferLanding');
			}
			else{

				$state.go('menu.userLogin');
			}
		};
		fasTagLandingVm.goToSBIfasTagPortal = function(){
			$state.go('menu.fasTagSbiPortalRedirection');
		};
		fasTagLandingVm.goTofasTagThroughUPI = function(){
			utilityService.showSpinner();
			if (!localStorage.getItem("appGenId")) {
				bhimUpiService.getNativeData("generateAppGenId", {},"FasTag").then(function (data) {
					if (device.platform.toLowerCase() == 'android') {
						bhimUpiService.appGenId = data.appGenId;
					} else {
						bhimUpiService.appGenId = data;
					}
					fasTagLandingVm.redirectToBhimUpiFlow();
				}, function (msg) {
					utilityService.hideSpinner();
					utilityService.showBhimUpiAlert("error", msg);
				});
			} else {
				bhimUpiService.getNativeData("setAppGenId", localStorage.getItem("appGenId"),"FasTag").then(function (data) {
					fasTagLandingVm.redirectToBhimUpiFlow();
				}, function (msg) {
					utilityService.hideSpinner();
					utilityService.showBhimUpiAlert("error", msg);
				});
			}
            };
			fasTagLandingVm.redirectToBhimUpiFlow = function () {

				if (device.platform.toLowerCase() == 'android') {
					utilityService.showSpinner();
					var json = JSON.stringify({});
					bhimUpiService.getNativeData(constantConfig.upiConstant.getpermission, json,"FasTag").then(function (data) {
						if (data.permission === 'Allowed') {
							fasTagLandingVm.redirectToBhimUpiJourney();
						} else {
							utilityService.hideSpinner();
							utilityService.showBhimUpiAlert("error", "UPI registration requires permission to use camera, SMS and Phone calls. Please allow these permissions. If problem persists re-initiate UPI registration.");
						}
					}, function (msg) {
						utilityService.hideSpinner();
						fasTagLandingVm.showVpaErrorMessage(msg);
					});
				} else if (device.platform.toLowerCase() == 'windows') {
					ionicToast.show("The functionality is not available in windows currently.", 'bottom', false, 3000);
				} else {
					utilityService.showSpinner();
					var json = JSON.stringify({
						"pspId": constantConfig.upiConstant.pspId,
						"encryptionKey": loggedInUserService.upiPermissionKey.split("^")[2]
					});
					bhimUpiService.getNativeData("initializeIOSsdk", json,"FasTag").then(function (data) {
						if (data !== "S") {
							utilityService.hideSpinner();
							utilityService.showBhimUpiAlert("error", data);
							return false;
						}
						utilityService.showSpinner();
						var json = JSON.stringify({
							"addInfo": {
								"addInfo10": constantConfig.upiConstant.addInfo10,
								"addInfo9": constantConfig.upiConstant.addInfo9
							},
							"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
							"requestInfo": {
								"pspId": constantConfig.upiConstant.pspId,
								"pspRefNo": generateRandomString(27)
							},
							"updateFlag": constantConfig.upiConstant.updateFlag,
							"smsSent": "false"
						});
						bhimUpiService.getNativeData(constantConfig.upiConstant.checkDevice, json,"FasTag").then(function (data) {
							$rootScope.checkDeviceInfo = JSON.parse(data);
							utilityService.hideSpinner();
							if ($rootScope.checkDeviceInfo.status == 'S') {
								if ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNM') {
										$state.go('menu.fasTagRecharge_UPI');
								} else {
									utilityService.showBhimUpiAlert("alert", "<b>Looks like you do not have a UPI profile to make payments. Please register UPI for making further transactions</b>");
								}
							} else {
								utilityService.showBhimUpiAlert("error", $rootScope.checkDeviceInfo.statusDesc);
							}
						}, function (msg) {
							utilityService.hideSpinner();
							fasTagLandingVm.showVpaErrorMessage(msg);
						});
					}, function (msg) {
						utilityService.hideSpinner();
						fasTagLandingVm.showVpaErrorMessage(msg);
					});

				}
			}

			fasTagLandingVm.redirectToBhimUpiJourney = function () {
				utilityService.showSpinner();
				var json = JSON.stringify({
					"addInfo": {
						"addInfo10": constantConfig.upiConstant.addInfo10,
						"addInfo9": constantConfig.upiConstant.addInfo9
					},
					"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
					"requestInfo": {
						"pspId": constantConfig.upiConstant.pspId,
						"pspRefNo": generateRandomString(27)
					},
					"updateFlag": constantConfig.upiConstant.updateFlag,
					"smsSent": false
				});
				bhimUpiService.getNativeData(constantConfig.upiConstant.checkDevice, json,"FasTag").then(function (data) {

					$rootScope.checkDeviceInfo = JSON.parse(data);
					utilityService.hideSpinner();
					if ($rootScope.checkDeviceInfo.status == 'S') {
						if ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNM') {
							$state.go('menu.fasTagRecharge_UPI');
						} else {
							utilityService.showBhimUpiAlert("error", "<b>Looks like you do not have a UPI profile to make payments. Please register UPI for making further transactions</b>");
						}
					} else {
						utilityService.showBhimUpiAlert("error", $rootScope.checkDeviceInfo.statusDesc);
					}
				}, function (msg) {
					utilityService.hideSpinner();
					fasTagLandingVm.showVpaErrorMessage(msg);
				});
			}


			fasTagLandingVm.showVpaErrorMessage = function (errorCode) {
				switch (errorCode) {
					case -1: utilityService.showErrorMessage(constantConfig.upiConstant.minusOne);
						break;

					case -2: utilityService.showErrorMessage(constantConfig.upiConstant.minusTwo);
						break;

					case -3: utilityService.showErrorMessage(constantConfig.upiConstant.minusThree);
						break;

					case -4: utilityService.showErrorMessage(constantConfig.upiConstant.minusFour);
						break;

					case -5: utilityService.showErrorMessage(constantConfig.upiConstant.minusFive);
						break;

					case -6: utilityService.showErrorMessage(constantConfig.upiConstant.minusSix);
						break;

					case -7: utilityService.showErrorMessage(constantConfig.upiConstant.minusSeven);
						break;

					default: utilityService.showErrorMessage(constantConfig.upiConstant.someWentWrong);
				}
			};

			$scope.$on('$ionicView.beforeEnter', function () {
				if(mPinLoginService.isLoggedIn == true){
				fasTagLandingVm.userLoggedIn = true;
				}
				else{

				fasTagLandingVm.userLoggedIn = false;
				}
			});




    }

]);
