'use strict';

angularApp.controller('fasTagRechargeVerify_UPIController', ["$state",
	"$ionicPopup",
	"$scope",
	"customerInfoService",
	"utilityService",
	"constantConfig",
	"bhimUpiService",
	"fasTagService",
	"mPinLoginService",
	"loggedInUserService",
	function ($state,
		$ionicPopup,
		$scope,
		customerInfoService,
		utilityService,
		constantConfig,
		bhimUpiService,
		fasTagService,
		mPinLoginService,
	  loggedInUserService) {


		var fasTagRechargeVerify_UPIVm = this;

		fasTagRechargeVerify_UPIVm.goToBack = function () {
			if(mPinLoginService.isLoggedIn == true){

				$state.go('menu.fundsTransferLanding');
			}
			else{

				$state.go('menu.userLogin');
			}
		}


		fasTagRechargeVerify_UPIVm.payNewBeneficiary = function () {
			utilityService.showSpinner();
			fasTagRechargeVerify_UPIVm.verifyUpiIdStatus = '';
			var json = JSON.stringify({
				"addInfo": {
					"addInfo10": constantConfig.upiConstant.addInfo10,
					"addInfo9": constantConfig.upiConstant.addInfo9
				},
				"payeeType": {
					"virtualAddress": fasTagRechargeVerify_UPIVm.fasTagUPIId.toString()
				},
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"vAReqType": constantConfig.upiConstant.vAReqType_T
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.checkVirtualAddressAPI, json,"FasTag").then(function (data) {
				var checkVpaResponse = JSON.parse(data);
				if (checkVpaResponse.status == 'VE') {
					customerInfoService.payeeDetails = {
						payeeType: "VA",
						requestType: 'pay',
						accountNo: "",
						ifsc: "",
						name: checkVpaResponse.payeeType.name || "",
						vpa: checkVpaResponse.payeeType.virtualAddress || "",
						amount: "",
						remark: "",
						nickName: "",
						phoneNumber: "",
						savePayee: false
					}
					fasTagRechargeVerify_UPIVm.getProfile();
				} else {
					utilityService.hideSpinner();
					fasTagRechargeVerify_UPIVm.verifyUpiIdStatus = checkVpaResponse.statusDesc;
				}
			}, function (msg) {
				utilityService.hideSpinner();
				fasTagRechargeVerify_UPIVm.showVpaErrorMessage(msg);
			});
		}
		fasTagRechargeVerify_UPIVm.getProfile = function () {
			utilityService.showSpinner();
			var json = JSON.stringify({
				"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"updateFlag": constantConfig.upiConstant.updateFlag
			});
				bhimUpiService.getNativeData(constantConfig.upiConstant.getProfile, json,"FasTag").then(function (data) {
				utilityService.hideSpinner();
				var getProfileResponse = JSON.parse(data);
				if (getProfileResponse.status == "S") {
					customerInfoService.payerProfileDtls = getProfileResponse;
					if(mPinLoginService.isLoggedIn == true){
						$state.go('menu.payToVpa_PayeeDetails');
					}
					else{
						loggedInUserService.productClicked = 'menu.payToVpa_PayeeDetails';
						$state.go('menu.userLogin');
					}
				} else {
					utilityService.showBhimUpiAlert("error", getProfileResponse.statusDesc);
				}
			}, function (msg) {
				utilityService.hideSpinner();
				fasTagRechargeVerify_UPIVm.showVpaErrorMessage(msg);
			});
		}
		fasTagRechargeVerify_UPIVm.showVpaErrorMessage = function (errorCode) {
			switch (errorCode) {
				case -1: utilityService.showErrorMessage(constantConfig.upiConstant.minusOne);
					break;

				case -2: utilityService.showErrorMessage(constantConfig.upiConstant.minusTwo);
					break;

				case -3: utilityService.showErrorMessage(constantConfig.upiConstant.minusThree);
					break;

				case -4: utilityService.showErrorMessage(constantConfig.upiConstant.minusFour);
					break;

				case -5: utilityService.showErrorMessage(constantConfig.upiConstant.minusFive);
					break;

				case -6: utilityService.showErrorMessage(constantConfig.upiConstant.minusSix);
					break;

				case -7: utilityService.showErrorMessage(constantConfig.upiConstant.minusSeven);
					break;

				default: utilityService.showErrorMessage(constantConfig.upiConstant.someWentWrong);
			}
		};

		fasTagRechargeVerify_UPIVm.showInfoPopup = function () {
			fasTagRechargeVerify_UPIVm.oneTimePaymentPopup = $ionicPopup.show({
				template: '<p>One Time Payment.</p>',
				title: '',
				cssClass: 'dialog',
				scope: $scope,
				buttons: [{
					text: 'OK',
					type: 'button-positive',
					onTap: function (e) {
						fasTagRechargeVerify_UPIVm.oneTimePaymentPopup.close();
					}
				}]
			});
		}
		$scope.$on('$ionicView.beforeEnter', function () {
			fasTagRechargeVerify_UPIVm.fasTagUPIId = fasTagService.fasTagUPIId.toLowerCase();
			fasTagRechargeVerify_UPIVm.verifyUpiIdStatus = '';
			if(mPinLoginService.isLoggedIn == true){
				fasTagRechargeVerify_UPIVm.isLoggedIn='Yes';
			}else{
				fasTagRechargeVerify_UPIVm.isLoggedIn='No';
			}
		});

		return this;
	}

]);
