'use strict';

angularApp.controller('atMaturityController',
	["$timeout",
		"$state",
		"$scope",
		"$translate",
		"fixedDepositService",

		function ($timeout,
			$state,
			$scope,
			$translate,
			fixedDepositService) {

			var atMaturityVm = this;
			function initPage() {
				atMaturityVm.creditsavingData = "Credit to Savings Account";
				atMaturityVm.renewprincipalData = "Renew Principal and Repay Interest";
				atMaturityVm.autorenewData = "Auto Renewal";
				atMaturityVm.showBack = true;
				atMaturityVm.showNext = true;
				atMaturityVm.disablenext = true;
				$translate(['AUTORENEWAL', 'CREDITSAVINGS', 'RENEWPRINCIPAL', 'FIXED_DEPOSIT']).then(function (translations) {
					atMaturityVm.autorenew = translations['AUTORENEWAL'];
					atMaturityVm.creditsaving = translations['CREDITSAVINGS'];
					atMaturityVm.renewprincipal = translations['RENEWPRINCIPAL'];
					atMaturityVm.fdTitle = translations['FIXED_DEPOSIT'];
				});
			}

			atMaturityVm.setSelected = function (data) {
				atMaturityVm.idSelectedVote = data;
				atMaturityVm.maturityInstruction = data;
				atMaturityVm.disablenext = false;
				fixedDepositService.customer.maturityInstruction = atMaturityVm.maturityInstruction;
				if (atMaturityVm.maturityInstruction === "Auto Renewal") {
					fixedDepositService.customer.matInstService = "A";
					atMaturityVm.autorenewselected = true;
					atMaturityVm.creditsavingselected = false;
					atMaturityVm.renewPrincipalselected = false;
				}
				if (atMaturityVm.maturityInstruction === "Credit to Savings Account") {
					fixedDepositService.customer.matInstService = "C";
					atMaturityVm.autorenewselected = false;
					atMaturityVm.creditsavingselected = true;
					atMaturityVm.renewPrincipalselected = false;
				}
				if (atMaturityVm.maturityInstruction === "Renew Principal and Repay Interest") {
					fixedDepositService.customer.matInstService = "B";
					atMaturityVm.autorenewselected = false;
					atMaturityVm.creditsavingselected = false;
					atMaturityVm.renewPrincipalselected = true;
				}
			}

			atMaturityVm.goBacktoPrevious = function () {
				$state.go('menu.interestPayout');
			}

			atMaturityVm.goToNextPage = function () {
				$state.go('menu.reviewFD');//to do
			}

			atMaturityVm.goToAO = function () {
				$state.go("menu.accountOverviewMyBalance");
			}

			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				if (fixedDepositService.customer.maturityInstruction === "") {
					if (fixedDepositService.customer.interestPayout !== "At Maturity") {
						atMaturityVm.autorenewData = "Auto Renewal";
						atMaturityVm.disauto = true;
						atMaturityVm.discredit = false;
						atMaturityVm.disrenew = false;
					} else {
						atMaturityVm.autorenewData = "Auto Renewal";
						atMaturityVm.disauto = false;
						atMaturityVm.discredit = false;
						atMaturityVm.disrenew = false;
					}
					atMaturityVm.maturity = false;
					atMaturityVm.autorenewselected = false;
					atMaturityVm.creditsavingselected = false;
					atMaturityVm.renewPrincipalselected = false;
					atMaturityVm.showBack = true;
					atMaturityVm.showNext = true;
					atMaturityVm.disablenext = true;
					fixedDepositService.customer.intpaycheck = fixedDepositService.customer.interestPayout;
				} else {
					if (fixedDepositService.customer.clickback) {
						atMaturityVm.maturity = fixedDepositService.customer.maturityInstruction;
						fixedDepositService.customer.clickback = false;
						atMaturityVm.disablenext = false;
						if (fixedDepositService.customer.interestPayout !== "At Maturity") {
							atMaturityVm.disauto = true;
						} else {
							atMaturityVm.disauto = false;
						}
					} else {
						if (fixedDepositService.customer.intpaycheck !== fixedDepositService.customer.interestPayout) {
							if (fixedDepositService.customer.interestPayout !== "At Maturity") {
								atMaturityVm.disauto = true;
								atMaturityVm.autorenewselected = false;
								atMaturityVm.autorenewData = false;
								atMaturityVm.discredit = false;
								atMaturityVm.disrenew = false;
								atMaturityVm.maturity = true;
							} else {
								atMaturityVm.maturity = true;
								atMaturityVm.autorenewData = "Auto Renewal";
								atMaturityVm.disauto = false;
								atMaturityVm.discredit = false;
								atMaturityVm.disrenew = false;
							}
							fixedDepositService.customer.intpaycheck = fixedDepositService.customer.interestPayout;
						} else {
							atMaturityVm.maturity = fixedDepositService.customer.maturityInstruction;
							atMaturityVm.disablenext = false;
							if (fixedDepositService.customer.interestPayout !== "At Maturity") {
								atMaturityVm.disauto = true;
							} else {
								atMaturityVm.disauto = false;
							}
						}
					}
				}
				atMaturityVm.maturityInstruction = fixedDepositService.customer.maturityInstruction;
				atMaturityVm.diffDays = fixedDepositService.customer.diffDays;
				// Show only Credit to savind account for FD greater then 5 years
				if(atMaturityVm.diffDays > 1825){
					//atMaturityVm.disauto = false; /* Removed 5 years check */
					atMaturityVm.discredit = false;
					atMaturityVm.disrenew = false; /* Removed 5 years check */
				}
			});

			$scope.$on('$ionicView.afterLeave', function () {
				//any cleanup needs to be done here: executes everytime when page is left
			});
			return this;
		}]);