'use strict';

angularApp.controller('changeMaturityDetailsController',
	["$timeout",
		"$state",
		"$scope",
		"$translate",
		"$ionicPopup",
		"fixedDepositService",
		"fixedDepositClosureService",
		"$ionicPopover",
		"utilityService",
		"getAccountDetailsService",
		"closePopupService",
		"personalLoanService",
		"clickStreamService",
		"reviewFDService",
		"openUrlInAppbroswerService",
		"customerInfoService",
		"interestrateService",
		"changeMaturityService",
		"$ionicHistory",
		function ($timeout,
			$state,
			$scope,
			$translate,
			$ionicPopup,
			fixedDepositService,
			fixedDepositClosureService,
			$ionicPopover,
			utilityService,
			getAccountDetailsService,
			closePopupService,
			personalLoanService,
			clickStreamService,
			reviewFDService,
			openUrlInAppbroswerService,
			customerInfoService,
			interestrateService,
			changeMaturityService,
			$ionicHistory
		) {

			var changeMaturityDetailsVm = this;
			

			function initPage() {
				changeMaturityDetailsVm.showSelect = true;
				changeMaturityDetailsVm.marginError = "";
				changeMaturityDetailsVm.showBack = true;
				changeMaturityDetailsVm.showNext = true;
				changeMaturityDetailsVm.disablenext = true;
				changeMaturityDetailsVm.disablenextMaturity = true;
				changeMaturityDetailsVm.disableback = false;
				changeMaturityDetailsVm.showTenure = true
				$translate(['AUTORENEWAL', 'CREDIT_TO_ACC', 'RENEWPRINCIPAL', 'FIXED_DEPOSIT', 'INTEREST_RATES', 'FIXED_YEARS', 'FIXED_MONTHS', 'FIXED_DAYS', 'NEW_TENURE', 'TENURE_LIMIT', 'CREDIT_TO_SAVING', 'RENEW_INT', 'AUTO_RENEW']).then(function (translations) {
					changeMaturityDetailsVm.autorenew = translations['AUTORENEWAL'];
					changeMaturityDetailsVm.creditsaving = translations['CREDIT_TO_ACC'];
					changeMaturityDetailsVm.renewprincipal = translations['RENEWPRINCIPAL'];
					changeMaturityDetailsVm.fdTitle = translations['FIXED_DEPOSIT'];
					changeMaturityDetailsVm.interest =translations['INTEREST_RATES'];
					changeMaturityDetailsVm.years =translations['FIXED_YEARS'];
					changeMaturityDetailsVm.months=translations['FIXED_MONTHS'];
					changeMaturityDetailsVm.days=translations['FIXED_DAYS'];
					changeMaturityDetailsVm.newTenure=translations['NEW_TENURE'];
					changeMaturityDetailsVm.tenureLimit =translations['TENURE_LIMIT'];
					changeMaturityDetailsVm.creditsavingData = translations['CREDIT_TO_ACC'];
					changeMaturityDetailsVm.renewprincipalData = translations['RENEW_INT'];
					changeMaturityDetailsVm.autorenewData = translations['AUTO_RENEW'];

				});
			}

			changeMaturityDetailsVm.setSelected = function (data) {

				changeMaturityDetailsVm.idSelectedVote = data;
				changeMaturityDetailsVm.maturityInstruction = data;

				changeMaturityDetailsVm.disablenextMaturity = false;
				changeMaturityDetailsVm.disablenext = false;
				fixedDepositService.customer.maturityInstruction = changeMaturityDetailsVm.maturityInstruction;
				if (changeMaturityDetailsVm.maturityInstruction === "Auto Renewal") {
					fixedDepositService.customer.matInstService = "A";
					changeMaturityDetailsVm.autorenewselected = true;
					changeMaturityDetailsVm.creditsavingselected = false;
					changeMaturityDetailsVm.renewPrincipalselected = false;
					changeMaturityDetailsVm.showTenure = true;
					if((changeMaturityDetailsVm.yearsData == '' && changeMaturityDetailsVm.monthsData == '' && changeMaturityDetailsVm.daysData == '') || (changeMaturityDetailsVm.accountNumber == '' || changeMaturityDetailsVm.accountNumber == undefined))
					{
						changeMaturityDetailsVm.disablenext = true;
					}
				}
				if (changeMaturityDetailsVm.maturityInstruction === "Credit to Account") {
					fixedDepositService.customer.matInstService = "C";
					changeMaturityDetailsVm.autorenewselected = false;
					changeMaturityDetailsVm.creditsavingselected = true;
					changeMaturityDetailsVm.renewPrincipalselected = false;
					changeMaturityDetailsVm.showTenure = false;

					changeMaturityDetailsVm.yearsData ="";
					fixedDepositService.customer.years = changeMaturityDetailsVm.yearsData;
					changeMaturityDetailsVm.monthsData ="";
					fixedDepositService.customer.months = changeMaturityDetailsVm.monthsData;
					changeMaturityDetailsVm.daysData ="";
					fixedDepositService.customer.days = changeMaturityDetailsVm.daysData;
					if(changeMaturityDetailsVm.accountNumber == '' || changeMaturityDetailsVm.accountNumber == undefined){
						changeMaturityDetailsVm.disablenext = true;
					}
				}
				if (changeMaturityDetailsVm.maturityInstruction === "Renew Principal and Repay Interest") {
					fixedDepositService.customer.matInstService = "B";
					changeMaturityDetailsVm.autorenewselected = false;
					changeMaturityDetailsVm.creditsavingselected = false;
					changeMaturityDetailsVm.renewPrincipalselected = true;
					changeMaturityDetailsVm.showTenure = true;
					if((changeMaturityDetailsVm.yearsData == '' && changeMaturityDetailsVm.monthsData == '' && changeMaturityDetailsVm.daysData == '') || (changeMaturityDetailsVm.accountNumber==''))
					{
						changeMaturityDetailsVm.disablenext = true;
					}
					if(changeMaturityDetailsVm.accountNumber == '' || changeMaturityDetailsVm.accountNumber == undefined){
						changeMaturityDetailsVm.showTenure = false;
					}
				}
			}

			function getMaturityDate(fixedDepositService,changeMaturityDetailsVm,interestrateService) {
			 	if((!changeMaturityDetailsVm.yearsData) && (!changeMaturityDetailsVm.monthsData) && (!changeMaturityDetailsVm.daysData)){
			 		changeMaturityDetailsVm.isvalidDays = false;
			 		fixedDepositService.customer.isvalidDays = changeMaturityDetailsVm.isvalidDays;
			 		changeMaturityDetailsVm.disablenext = true;
			 		changeMaturityDetailsVm.newDates ='';
			 	} else {
			 		changeMaturityDetailsVm.isvalidDays = true;
			 		fixedDepositService.customer.isvalidDays = changeMaturityDetailsVm.isvalidDays;
			 		//changeMaturityDetailsVm.newDates = new Date(); 

			 		changeMaturityDetailsVm.newDates = new Date(changeMaturityDetailsVm.initialMaturityDate);

			 		var millis = Date.parse(changeMaturityDetailsVm.newDates);
			 		var daysvalue = fixedDepositService.customer.days;
			 		if(daysvalue){
			 			changeMaturityDetailsVm.newDates.setTime(millis  + daysvalue *24*60*60*1000);
			 		}
			 		if(fixedDepositService.customer.months){
			 			changeMaturityDetailsVm.newDates.setMonth(changeMaturityDetailsVm.newDates.getMonth() + fixedDepositService.customer.months);
			 		}
			 		if(fixedDepositService.customer.years){
			 			changeMaturityDetailsVm.newDates.setFullYear(changeMaturityDetailsVm.newDates.getFullYear() + fixedDepositService.customer.years);
			 		}
			 	}
			 	
			 	
		var max_date = new Date(changeMaturityDetailsVm.initialMaturityDate); 
		max_date.setFullYear(max_date.getFullYear() + 10); 
		max_date.setTime(max_date.getTime() + (1*60*60*1000));
		changeMaturityDetailsVm.maxdate = max_date;
		var mindate = new Date(changeMaturityDetailsVm.initialMaturityDate);
		var millis = Date.parse(mindate);
		var daysvalue=7;
		mindate.setTime(millis  + daysvalue *24*60*60*1000);
		changeMaturityDetailsVm.mindate = mindate;
			 	//if(!changeMaturityDetailsVm.isTaxable && !changeMaturityDetailsVm.isMod){
			 		if(!changeMaturityDetailsVm.newDates){
						changeMaturityDetailsVm.isTenureInvalid = true;
						changeMaturityDetailsVm.invalidTenureMessage = changeMaturityDetailsVm.tenureLimit;
			 			changeMaturityDetailsVm.disablenext = true;
			 			changeMaturityDetailsVm.maturityDate ="" ;
			 			changeMaturityDetailsVm.interestrate = "";
			 			changeMaturityDetailsVm.maturityDateFull = "";
			 			changeMaturityDetailsVm.isvalidDays = false;
			 			fixedDepositService.customer.isvalidDays = changeMaturityDetailsVm.isvalidDays;
			 			fixedDepositService.customer.maturityDate = angular.copy(changeMaturityDetailsVm.initialMaturityDate);
			 			fixedDepositService.customer.interestRate = changeMaturityDetailsVm.interestrate;
			 			fixedDepositService.customer.maturityDateFull = changeMaturityDetailsVm.maturityDateFull;
			 		} else if (changeMaturityDetailsVm.newDates > changeMaturityDetailsVm.maxdate || changeMaturityDetailsVm.newDates < changeMaturityDetailsVm.mindate){
			 			if(changeMaturityDetailsVm.isvalidDays){
							changeMaturityDetailsVm.isTenureInvalid = true;
							changeMaturityDetailsVm.invalidTenureMessage = changeMaturityDetailsVm.tenureLimit;
			 				changeMaturityDetailsVm.disablenext = true;
						 }
			 			changeMaturityDetailsVm.maturityDate ="" ;
			 			changeMaturityDetailsVm.interestrate = "";
			 			changeMaturityDetailsVm.maturityDateFull = "";
			 			changeMaturityDetailsVm.isvalidDays = false;
			 			fixedDepositService.customer.isvalidDays = changeMaturityDetailsVm.isvalidDays;
			 			fixedDepositService.customer.maturityDate = angular.copy(changeMaturityDetailsVm.initialMaturityDate);
			 			fixedDepositService.customer.interestRate = changeMaturityDetailsVm.interestrate;
			 			fixedDepositService.customer.maturityDateFull = changeMaturityDetailsVm.maturityDateFull;
			 		} else {
			 			var month = ["JAN", "FEB", "MAR", "APR", "MAY", "JUN","JUL", "AUG", "SEP", "OCT", "NOV", "DEC"];
			 			changeMaturityDetailsVm.newmaturityDate = changeMaturityDetailsVm.newDates;
			 			changeMaturityDetailsVm.maturityDateFull = changeMaturityDetailsVm.newmaturityDate;
			 			fixedDepositService.customer.maturityDateFull = changeMaturityDetailsVm.maturityDateFull;
						// changeMaturityDetailsVm.newDates=new Date(changeMaturityDetailsVm.newDates.getTime() - (24*60*60*1000));
						changeMaturityDetailsVm.newDates=new Date(changeMaturityDetailsVm.newDates.getTime());
			 			changeMaturityDetailsVm.maturityDate = "" + changeMaturityDetailsVm.newDates.getDate() + " " + month[(changeMaturityDetailsVm.newDates.getMonth())] +" "+changeMaturityDetailsVm.newDates.getFullYear();
			 			//fixedDepositService.customer.maturityDate = changeMaturityDetailsVm.maturityDate;
			 			var year, month,days;
			 			year = changeMaturityDetailsVm.newDates.getFullYear();
			 			month = changeMaturityDetailsVm.newDates.getMonth()+1;
			 			days = changeMaturityDetailsVm.newDates.getDate();
			 			if(month <= 9){
			 				month = "0" + month;
			 			}
			 			if(days <= 9){
			 				days = "0" + days;
			 			}
			 			changeMaturityDetailsVm.maturitydateRequest = ""+days+month+year;
			 			fixedDepositService.customer.maturitydateRequest = changeMaturityDetailsVm.maturitydateRequest;
			 			
			 			changeMaturityDetailsVm.disablenext = false;
			 			
						
						changeMaturityDetailsVm.isTenureInvalid = false;
			 			getInterestRateValue(fixedDepositService,changeMaturityDetailsVm,interestrateService);
			 		}
			 	
				
			 }

 			changeMaturityDetailsVm.getInterestRate = function(){
 				
				$state.go('menu.cminterestrate')
			}

			changeMaturityDetailsVm.goBack = function () {
				
					$state.go("menu.fixedDepositDetails");
				
			};
			
			changeMaturityDetailsVm.goToAO = function () {
				
				$state.go("menu.accountOverviewMyBalance");
			};

			changeMaturityDetailsVm.goToNextPage = function () {
				fixedDepositService.customer.maturityDate = changeMaturityDetailsVm.maturityDate;
				console.log('fdservice customer on change maturity',fixedDepositService.customer);
				if(fixedDepositService.customer.matInstService == 'C'){
					//show pop-up
					changeMaturityDetailsVm.confirmPopup();
				}
				else{
					$state.go("menu.FDReviewChangeMaturity");
				}
				
			};

			changeMaturityDetailsVm.confirmPopup = function(){
				
			var message = 'Are you sure to credit your ' + changeMaturityDetailsVm.accType + ' ' + changeMaturityDetailsVm.accountNumber + '?';
			var sub_msg = 'This process cannot be reversed.';
				var btn_array = [
					{
						text: "Cancel",
						type: 'button-negative',
						onTap: function () {
							
						}
					},
					{
						text: "Confirm",
						type: 'button-positive',
						onTap: function () {
							var obj = {
								  "branchCode": fixedDepositService.customer.branchCode,
								  "accountNumber": fixedDepositService.customer.fdAccountNumber,
								  "maturityInstruction": fixedDepositService.customer.matInstService,
								  "termMonths": (fixedDepositService.customer.months == '') ? 0 : fixedDepositService.customer.months,
								  "transferAccountNumber": fixedDepositService.customer.debitAccountNumber,
								  "termDays": (fixedDepositService.customer.days == '') ? 0 : fixedDepositService.customer.days,
								  "termYears": (fixedDepositService.customer.years == '') ? 0 : fixedDepositService.customer.years
							}
							changeMaturityService.updateChangeMaturity(obj).then(function (data) {
								console.log(data);
								$state.go('menu.changeMaturitySuccess');
								
							}, function (error) {
								
								utilityService.showErrorMessage(error.responseMessage);
							});
						}
					}
				];
			
			
			var changeMaturityAlertPopup = $ionicPopup.alert({
				template: '<div class="font-dark-grey"><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter color545454 roboto-medium"><span>'
				+ message + '</span></div><div class="roboto-regualr color747474 font-size-14">' + sub_msg + '</div></div></div>', //template,
				scope: $scope,
				cssClass: 'bhim-alert-popup',
				buttons: btn_array,
			});
			changeMaturityAlertPopup.then(function (res) {
			});
			}

			changeMaturityDetailsVm.getYears = function(){
				if(changeMaturityDetailsVm.yearsData){
					changeMaturityDetailsVm.yearsData = parseInt(changeMaturityDetailsVm.yearsData);
				} else {
					changeMaturityDetailsVm.yearsData ="";
				}
				fixedDepositService.customer.years = changeMaturityDetailsVm.yearsData;
				getMaturityDate(fixedDepositService,changeMaturityDetailsVm,interestrateService);
			}

			changeMaturityDetailsVm.validateFields = function(){
				if(fixedDepositService.customer.matInstService == 'A' || fixedDepositService.customer.matInstService == 'B'){
					if(changeMaturityDetailsVm.accountNumber && changeMaturityDetailsVm.accountNumber != '' && fixedDepositService.customer.matInstService == 'B'){
						changeMaturityDetailsVm.showTenure = true;
					}
					if((changeMaturityDetailsVm.yearsData == '' && changeMaturityDetailsVm.monthsData == '' && changeMaturityDetailsVm.daysData == '') || (changeMaturityDetailsVm.accountNumber==''))
					{
						changeMaturityDetailsVm.disablenext = true;
					}
					else{
						changeMaturityDetailsVm.disablenext = false;
					}
				}

			}

			changeMaturityDetailsVm.getMonths = function(){
				if(changeMaturityDetailsVm.monthsData){
					changeMaturityDetailsVm.monthsData = parseInt(changeMaturityDetailsVm.monthsData);
				} else {
					changeMaturityDetailsVm.monthsData ="";
				}
				fixedDepositService.customer.months = changeMaturityDetailsVm.monthsData;
				getMaturityDate(fixedDepositService,changeMaturityDetailsVm,interestrateService);
			}

			changeMaturityDetailsVm.getDays = function(){
				if(changeMaturityDetailsVm.daysData){
					changeMaturityDetailsVm.daysData = parseInt(changeMaturityDetailsVm.daysData);
				} else {
					changeMaturityDetailsVm.daysData ="";
				}
				fixedDepositService.customer.days = changeMaturityDetailsVm.daysData;
				getMaturityDate(fixedDepositService,changeMaturityDetailsVm,interestrateService);
			}

			function getInterestRateValue(fixedDepositService,fixedDurationVm,interestrateService) {
			 	var currentDate = new Date(changeMaturityDetailsVm.initialMaturityDate); 
			 	var maturityDateFull = changeMaturityDetailsVm.maturityDateFull;
			 	var timeDiff = Math.abs(maturityDateFull.getTime() - currentDate.getTime());
			 	changeMaturityDetailsVm.diffDays = Math.ceil(timeDiff / (1000 * 3600 * 24)); 
			 	interestrateService.fetchInterestRate(changeMaturityDetailsVm).then(function(data){
			 		//console.log(data);
			 		if(data){
			 			changeMaturityDetailsVm.durationRate=[];
			 			for (var i=0;i <data.fdInterestDetails.length;i++){
			 				changeMaturityDetailsVm.durationRate.push(data.fdInterestDetails[i]);
			 			}
			 			for(var j=0;j<changeMaturityDetailsVm.durationRate.length;j++){
			 				if(changeMaturityDetailsVm.diffDays >= parseInt(Math.ceil(changeMaturityDetailsVm.durationRate[j].minTenure)) && changeMaturityDetailsVm.diffDays <= parseInt(Math.ceil(changeMaturityDetailsVm.durationRate[j].maxTenure))){
			 					changeMaturityDetailsVm.interestrate = changeMaturityDetailsVm.durationRate[j].interestRate;
			 					fixedDepositService.customer.interestRate = changeMaturityDetailsVm.interestrate;
			 				}
			 			}
			 		}
			 	}, function(error){
					utilityService.showErrorMessage(error.responseMessage);
			 	});
			 	fixedDepositService.customer.interestRate = changeMaturityDetailsVm.interestrate;
			 	fixedDepositService.customer.diffDays = changeMaturityDetailsVm.diffDays;
			 	// fixedDepositService.customer.taxdiffDays = fixedDurationVm.taxdiffDays;

			}
			changeMaturityDetailsVm.showPop = function(){
				if(changeMaturityDetailsVm.accountDetails.length > 0)
				{
					changeMaturityDetailsVm.popUp = $ionicPopup.show({
						title: '',
						cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
						templateUrl: 'pages/fixedDeposit/changeMaturity/dropdownModal.html',
						scope: $scope
					});
				}
			}
			
			changeMaturityDetailsVm.close = function(index){
				changeMaturityDetailsVm.marginError = "";
				changeMaturityDetailsVm.popUp.close();
				changeMaturityDetailsVm.balance = changeMaturityDetailsVm.accountDetails[index].accountBalance;
				changeMaturityDetailsVm.accType = changeMaturityDetailsVm.accountDetails[index].accountType;
				changeMaturityDetailsVm.accountNumber = changeMaturityDetailsVm.accountDetails[index].accountNumber;
				fixedDepositService.customer.debitAccountNumber = changeMaturityDetailsVm.accountNumber;
				fixedDepositService.customer.debitAccountType = changeMaturityDetailsVm.accType;
				fixedDepositService.customer.debitAccountBalance = changeMaturityDetailsVm.balance;
				changeMaturityDetailsVm.selectedAccount = changeMaturityDetailsVm.accountDetails[index];
				changeMaturityDetailsVm.showSelect = false;
				changeMaturityDetailsVm.disablenext = false;
				changeMaturityDetailsVm.validateFields();
				
			}


			changeMaturityDetailsVm.getAccountDetails = function() {	
				if(changeMaturityService.accList.length <= 0){
					changeMaturityService.getAccountList().then(function(data) {
						console.log(data);
						var account_list = data.accList;
						

						console.log(account_list);
						//NCMCService.accountDetails = account_list;
						changeMaturityDetailsVm.accountDetails = account_list;
						changeMaturityService.accList = changeMaturityDetailsVm.accountDetails;
						if(changeMaturityDetailsVm.accountDetails.length == 0){
							changeMaturityDetailsVm.marginError = "No account available.";
						}
	                },function(error) {
						utilityService.showErrorMessage(error.responseMessage);
						changeMaturityDetailsVm.marginError = "No account available.";
					});
				}
				else{
					changeMaturityDetailsVm.accountDetails = changeMaturityService.accList;
						if(changeMaturityDetailsVm.accountDetails.length == 0){
							changeMaturityDetailsVm.marginError = "No account available.";
						}
				}
			};

			$scope.$on('$ionicView.loaded', function () {
				initPage();
				
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				changeMaturityDetailsVm.marginError = "";
				fixedDepositService.isChangeMaturity = true;
				changeMaturityDetailsVm.accountDetails = [];
				changeMaturityDetailsVm.yearsData = fixedDepositService.customer.years;
				changeMaturityDetailsVm.monthsData = fixedDepositService.customer.months;
				changeMaturityDetailsVm.daysData = fixedDepositService.customer.days;
				changeMaturityDetailsVm.maturityDate = angular.copy(changeMaturityService.maturityDate);
				changeMaturityDetailsVm.initialMaturityDate = angular.copy(changeMaturityService.maturityDate);
				changeMaturityDetailsVm.interestrate = fixedDepositService.customer.interestRate;
				changeMaturityDetailsVm.maturityDateTime = angular.copy(fixedDepositService.customer.maturityDateTime);
				changeMaturityDetailsVm.isvalidDays = fixedDepositService.customer.isvalidDays;
				
				changeMaturityDetailsVm.getAccountDetails();
				getMaturityDate(fixedDepositService,changeMaturityDetailsVm,interestrateService);
				
			});

			$scope.$on('$ionicView.afterLeave', function () {
				//any cleanup needs to be done here: executes everytime when page is left
			});
			return this;
		}]);