'use strict';

angularApp.controller('cminterestrateController', 
	["$timeout",
	"$state",
	"$scope",
	"$translate",
	"fixedDepositService",
	"interestrateService",
	"utilityService",
	"customerInfoService",

	function ($timeout,
		$state,
		$scope,
		$translate,
		fixedDepositService,
		interestrateService,
		utilityService,
		customerInfoService) {
	var cminterestrateVm = this;
	function initPage(){		
		cminterestrateVm.showBack = false;
		cminterestrateVm.showNext = false;
		$translate(['DURATION','INTEREST_RATEH','INTEREST_RATEFD']).then(function (translations) {
			cminterestrateVm.durationH=translations['DURATION'];
			cminterestrateVm.interestrateH=translations['INTEREST_RATEH'];
			cminterestrateVm.fdTitle=translations['INTEREST_RATEFD'];
		}); 
	}

	cminterestrateVm.setSelected = function(duration,rate){
		cminterestrateVm.durationselect = duration;
		cminterestrateVm.rateselect = rate;
		cminterestrateVm.idSelectedVote = duration;
		fixedDepositService.customer.years = "";
		fixedDepositService.customer.months = "";
		fixedDepositService.customer.days = "";
		cminterestrateVm.isSelect = true;
		fixedDepositService.customer.isvalidDays = true;
		fixedDepositService.customer.viewInterest = true;
		if(cminterestrateVm.isSelect){
			getMDateIrate(fixedDepositService,cminterestrateVm);
		}
		$state.go("menu.FDChangeMaturity");
	}

/**
 * function to calculate maturity date and interest rate
 * @param {angualr service object} fixedDepositService 
 * @param {controller object} cminterestrateVm
 */
 function getMDateIrate (fixedDepositService,cminterestrateVm){
 	cminterestrateVm.minDate = cminterestrateVm.durationselect;
 	cminterestrateVm.mindates = cminterestrateVm.minDate.split(" ");
 	if(cminterestrateVm.mindates[1] === "days" ){
 		fixedDepositService.customer.days = parseInt(cminterestrateVm.mindates [0]);
 		fixedDepositService.customer.interestRate = cminterestrateVm.rateselect;
 		var newDate = new Date();
 		var millis = Date.parse(newDate);
 		var daysvalue = fixedDepositService.customer.days;
 		newDate.setTime(millis  + daysvalue *24*60*60*1000);
 		cminterestrateVm.maturityDateFull = newDate;
 		var month = ["JAN", "FEB", "MAR", "APR", "MAY", "JUN","JUL", "AUG", "SEP", "OCT", "NOV", "DEC"];
 		newDate = new Date(newDate.getTime() - (24*60*60*1000));
 		//fixedDepositService.customer.maturityDate = "" + newDate.getDate() + " " + month[(newDate.getMonth())] +" "+newDate.getFullYear();
 		var year, month,days;
 		year = newDate.getFullYear();
 		month = newDate.getMonth()+1;
 		days = newDate.getDate();
 		if(month <= 9){
 			month = "0" + month;
 		}
 		if(days <= 9){
 			days = "0" + days;
 		}
 		cminterestrateVm.maturitydateRequest = ""+days+month+year;
 		fixedDepositService.customer.maturitydateRequest = cminterestrateVm.maturitydateRequest;	
 	}
 	if(cminterestrateVm.mindates[1] !== "days"){
 		fixedDepositService.customer.years = parseInt(cminterestrateVm.mindates [0]);
 		fixedDepositService.customer.interestRate = cminterestrateVm.rateselect;
 		var newDate = new Date(); 
 		newDate.setFullYear(newDate.getFullYear() + fixedDepositService.customer.years); 
 		cminterestrateVm.maturityDateFull = newDate;
 		var month = ["JAN", "FEB", "MAR", "APR", "MAY", "JUN","JUL", "AUG", "SEP", "OCT", "NOV", "DEC"];
 		newDate = new Date(newDate.getTime() - (24*60*60*1000));
 		//fixedDepositService.customer.maturityDate = "" + newDate.getDate() + " " + month[(newDate.getMonth())] +" "+newDate.getFullYear();
 		var year, month,days;
 		year = newDate.getFullYear();
 		month = newDate.getMonth()+1;
 		days = newDate.getDate();
 		if(month <= 9){
 			month = "0" + month;
 		}
 		if(days <= 9){
 			days = "0" + days;
 		}
 		cminterestrateVm.maturitydateRequest = ""+days+month+year;
 		fixedDepositService.customer.maturitydateRequest = cminterestrateVm.maturitydateRequest;
 	}

 	var currentDate = new Date(); 
 	var maturityDateFull = cminterestrateVm.maturityDateFull;
 	var timeDiff = Math.abs(maturityDateFull.getTime() - currentDate.getTime());
 	cminterestrateVm.diffDays = Math.ceil(timeDiff / (1000 * 3600 * 24)); 
 	fixedDepositService.customer.diffDays = cminterestrateVm.diffDays + 1;
 }
	
	cminterestrateVm.goBack = function(){
	$state.go("menu.FDChangeMaturity");
	};

	cminterestrateVm.goToAO = function(){
		
			$state.go("menu.FDChangeMaturity");
		
		
	};

	cminterestrateVm.goToNextPage = function(){
		if(cminterestrateVm.isSelect){
			getMDateIrate(fixedDepositService,cminterestrateVm);
		}
		$state.go('menu.fixedDuration');
	};
	
	$scope.$on('$ionicView.loaded', function() {
		initPage();
	});
	
	$scope.$on('$ionicView.beforeEnter', function() {
		cminterestrateVm.isChangeMaturity = fixedDepositService.isChangeMaturity;
		if(fixedDepositService.customer.viewInterest === false){
			cminterestrateVm.idSelectedVote =  false;
		}
		cminterestrateVm.isStaffFlag = customerInfoService.customer.isStaffFlag;
		cminterestrateVm.amount = fixedDepositService.customer.amountData;
		cminterestrateVm.years = fixedDepositService.customer.years;
		cminterestrateVm.months = fixedDepositService.customer.months;
		cminterestrateVm.days = fixedDepositService.customer.days;
		cminterestrateVm.isTaxable = fixedDepositService.customer.isTaxable;
		cminterestrateVm.isScitizen = fixedDepositService.customer.isSenior;
		if(cminterestrateVm.isStaffFlag === 'Y'){
			if(fixedDepositService.customer.isSenior === true){
			cminterestrateVm.custype = "staff_senior_citizen";
			fixedDepositService.customer.custype = "staff_senior_citizen";
			} else {
				cminterestrateVm.custype = "staff_customer";
				fixedDepositService.customer.custype = "staff_customer";
			}
		}
		if(cminterestrateVm.isStaffFlag === 'N'){
			if(fixedDepositService.customer.isSenior === true){
			cminterestrateVm.custype = "senior_citizen";
			fixedDepositService.customer.custype = "senior_citizen";
			} else {
				cminterestrateVm.custype = "normal_customer";
				fixedDepositService.customer.custype = "normal_customer";
			}
		}
		interestrateService.fetchInterestRate(cminterestrateVm).then(function(data){
			if(!utilityService.isUndefined(data.fdInterestDetails)){
				cminterestrateVm.durationRate=[];
				for (var i=0;i <data.fdInterestDetails.length;i++){
		// code changes for MOD start
					if (fixedDepositService.customer.isMod === true) {
							if(data.fdInterestDetails[i].minTenure >= 365 && data.fdInterestDetails[i].maxTenure <= 1826.07449){
								cminterestrateVm.durationRate.push(data.fdInterestDetails[i]);
							}
					} else {
								cminterestrateVm.durationRate.push(data.fdInterestDetails[i]);
					}
		// code changes for MOD start
				}

			}
		}, function(error){
			utilityService.showErrorMessage(error.responseMessage);
		});
	});
	
	$scope.$on('$ionicView.afterLeave', function() {		
		//any cleanup needs to be done here: executes everytime when page is left
	});
	return this;
}]);