'use strict';

angularApp.controller('reviewFDChangeMaturityController', ["$timeout",
	"$state",
	"$scope",
	"$translate",
	"fixedDepositService",
	"reviewFDService",
	"customerInfoService",
	"$ionicPopup",
	"utilityService",
	"getAccountDetailsService",
	"accountOverviewService",
	"openUrlInAppbroswerService",
	"changeMaturityService",
	function ($timeout,
		$state,
		$scope,
		$translate,
		fixedDepositService,
		reviewFDService,
		customerInfoService,
		$ionicPopup,
		utilityService,
		getAccountDetailsService,
		accountOverviewService,
		openUrlInAppbroswerService,
		changeMaturityService) {

		//functions, variables that can be accessed from the HTML come here
		var reviewFDChangeMaturityDetailsVm = this;
		reviewFDChangeMaturityDetailsVm.nightMode = false;
		
		//private methods section start
		function initPage() {
			reviewFDChangeMaturityDetailsVm.showCancel = true;
			reviewFDChangeMaturityDetailsVm.showConfirm = true;
			reviewFDChangeMaturityDetailsVm.disableconfirm = true;
			$translate(['NAME', 'PAMOUNT', 'DBT_AC_NO', 'MDATE', 'MAMOUNT', 'RATE_OF_INT', 'IPAYOUT', 'MINSTRUCTION', 'NOMINEE_DETAILS', 'READTERMS', 'CONGRATS', 'FIXED_DEPOSIT', 'REGISTERED', 'NOMINEELINK', 'NO_NOMINEE']).then(function (translations) {
				reviewFDChangeMaturityDetailsVm.name = translations['NAME'];
				reviewFDChangeMaturityDetailsVm.pAmount = translations['PAMOUNT'];
				reviewFDChangeMaturityDetailsVm.account = translations['DBT_AC_NO'];
				reviewFDChangeMaturityDetailsVm.mDate = translations['MDATE'];
				reviewFDChangeMaturityDetailsVm.mAmount = translations['MAMOUNT'];
				reviewFDChangeMaturityDetailsVm.iRate = translations['RATE_OF_INT'];
				reviewFDChangeMaturityDetailsVm.iPayout = translations['IPAYOUT'];
				reviewFDChangeMaturityDetailsVm.mInstruction = translations['MINSTRUCTION'];
				reviewFDChangeMaturityDetailsVm.Nominee = translations['NOMINEE_DETAILS'];
				reviewFDChangeMaturityDetailsVm.termscondition = translations['READTERMS'];
				reviewFDChangeMaturityDetailsVm.congrats = translations['CONGRATS'];
				reviewFDChangeMaturityDetailsVm.fdTitle = translations['FIXED_DEPOSIT'];
				reviewFDChangeMaturityDetailsVm.register = translations['REGISTERED'];
				reviewFDChangeMaturityDetailsVm.nomineeLink = translations['NOMINEELINK'];
				reviewFDChangeMaturityDetailsVm.nonominee = translations['NO_NOMINEE'];
			});
		}
		
		reviewFDChangeMaturityDetailsVm.eyesOnFun = function(accNo){
			
			var obj = {
						  "keyType": "cmiKeyTypeAccount",
						  "debitAccount": accNo
						};
					changeMaturityService.getUnmaskData(obj).then(function (data) {
						reviewFDChangeMaturityDetailsVm.isAccountMasked = false;
						reviewFDChangeMaturityDetailsVm.custAccount = data;
					}, function (error) {
						utilityService.showErrorMessage(error.responseMessage);
					});


			
		}

		reviewFDChangeMaturityDetailsVm.eyesOffFun = function(accNo){
			reviewFDChangeMaturityDetailsVm.isAccountMasked = true;
			//reviewFDChangeMaturityDetailsVm.oFDValue = accNo;
			//reviewFDChangeMaturityDetailsVm.maskedCustAccount = angular.copy(reviewFDChangeMaturityDetailsVm.custAccount);
		}

		reviewFDChangeMaturityDetailsVm.eyesOnFunTrans = function(accNo){
			
			
					
						reviewFDChangeMaturityDetailsVm.isAccountMasked = false;
						reviewFDChangeMaturityDetailsVm.custAccount = changeMaturityService.transferAccountNumber;
					


			
		}

		reviewFDChangeMaturityDetailsVm.eyesOffFunTrans = function(accNo){
			reviewFDChangeMaturityDetailsVm.isAccountMasked = true;
			
		}
		

		reviewFDChangeMaturityDetailsVm.termconditionPopUp = function (TnCDetails) {
			var title = "";
                var buttontext = "OK";
                var detail = TnCDetails;
                

			reviewFDChangeMaturityDetailsVm.closeTnC = changeMaturityService.showTnCAlertModal(title, detail, buttontext,function(){});
		}

		//public functions end
		reviewFDChangeMaturityDetailsVm.termcondition = function () {
				if(reviewFDService.normalFDTnC == "") {
					var obj = {"type" : "changeMaturityTnC"};
					changeMaturityService.fetchRtermcondition(obj).then(function (data) {
						if (!utilityService.isUndefined(data)) {
							changeMaturityService.normalFDTnC = data;
							reviewFDChangeMaturityDetailsVm.termconditionPopUp(changeMaturityService.normalFDTnC);
						}
					}, function (error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				} else {
					reviewFDChangeMaturityDetailsVm.termconditionPopUp(changeMaturityService.normalFDTnC);
				}
			
		}
		reviewFDChangeMaturityDetailsVm.closePopup = function () {
			reviewFDChangeMaturityDetailsVm.closeTnC.close();
			utilityService.hideSpinner();
		}

		
		reviewFDChangeMaturityDetailsVm.getCBValue = function (isChecked) {
			if (isChecked === true) {
				reviewFDChangeMaturityDetailsVm.disableconfirm = false;
				reviewFDChangeMaturityDetailsVm.checkTnC = true;
			}
			else {
				reviewFDChangeMaturityDetailsVm.disableconfirm = true;
				reviewFDChangeMaturityDetailsVm.checkTnC = false;
			}
		}
		
		reviewFDChangeMaturityDetailsVm.goToCancel = function () {
			fixedDepositService.customer.clickback = true;
			$state.go('menu.FDChangeMaturity');
		}
		reviewFDChangeMaturityDetailsVm.goToAO = function () {
			reviewFDService.clearFDData();
			fixedDepositService.customer = {};
			$state.go("menu.accountOverviewMyBalance");
		}

		reviewFDChangeMaturityDetailsVm.goToConfirm = function () {
			reviewFDChangeMaturityDetailsVm.disableconfirm = true;
			reviewFDChangeMaturityDetailsVm.isStaffFlag = customerInfoService.customer.isStaffFlag;
			var trans_ac_number = "";
			if(fixedDepositService.customer.matInstService == 'A'){
				trans_ac_number = changeMaturityService.transferAccountNumber;
			}
			else{
				trans_ac_number = fixedDepositService.customer.debitAccountNumber;
			}
			var obj = {
				  "branchCode": fixedDepositService.customer.branchCode,
				  "accountNumber": fixedDepositService.customer.fdAccountNumber,
				  "maturityInstruction": fixedDepositService.customer.matInstService,
				  "termMonths": (fixedDepositService.customer.months == '') ? 0 : fixedDepositService.customer.months,
				  "transferAccountNumber": trans_ac_number,
				  "termDays": (fixedDepositService.customer.days == '') ? 0 : fixedDepositService.customer.days,
				  "termYears": (fixedDepositService.customer.years == '') ? 0 : fixedDepositService.customer.years
			}
			changeMaturityService.updateChangeMaturity(obj).then(function (data) {
				console.log(data);
				$state.go('menu.changeMaturitySuccess');
				
			}, function (error) {
				reviewFDChangeMaturityDetailsVm.isChecked = false;
				utilityService.showErrorMessage(error.responseMessage);
			});
		}

		
		

		$scope.$on('$ionicView.loaded', function () {
			initPage();
			reviewFDChangeMaturityDetailsVm.moduleName = "FixedDeposit";
			reviewFDChangeMaturityDetailsVm.actionName = "NomineeDetails";
			
		});

		$scope.$on('$ionicView.beforeEnter', function () {
			if (!utilityService.isUndefined(fixedDepositService.customer.dob)) {
				reviewFDChangeMaturityDetailsVm.dob = fixedDepositService.customer.dob;
			}

			reviewFDChangeMaturityDetailsVm.days = fixedDepositService.customer.days;
			if (!reviewFDChangeMaturityDetailsVm.days) {
				reviewFDChangeMaturityDetailsVm.days = 0;
			}
			reviewFDChangeMaturityDetailsVm.months = fixedDepositService.customer.months;
			if (!reviewFDChangeMaturityDetailsVm.months) {
				reviewFDChangeMaturityDetailsVm.months = 0;
			}
			reviewFDChangeMaturityDetailsVm.years = fixedDepositService.customer.years;
			if (!reviewFDChangeMaturityDetailsVm.years) {
				reviewFDChangeMaturityDetailsVm.years = 0;
			}
			reviewFDChangeMaturityDetailsVm.customerName = customerInfoService.customer.name;
			reviewFDChangeMaturityDetailsVm.emailID = customerInfoService.customer.emailID;
			reviewFDChangeMaturityDetailsVm.mobile = customerInfoService.customer.mobile;
			reviewFDChangeMaturityDetailsVm.title = customerInfoService.customer.title;
			reviewFDChangeMaturityDetailsVm.isChecked = false;
			reviewFDChangeMaturityDetailsVm.showCancel = true;
			reviewFDChangeMaturityDetailsVm.showConfirm = true;
			reviewFDChangeMaturityDetailsVm.disableconfirm = true;
			if(fixedDepositService.customer.matInstService == 'A'){
				reviewFDChangeMaturityDetailsVm.maskedCustAccount = utilityService.maskData(changeMaturityService.transferAccountNumber, "front", 4);
			}
			else{
				reviewFDChangeMaturityDetailsVm.maskedCustAccount = fixedDepositService.customer.debitAccountNumber;
			}
			
			reviewFDChangeMaturityDetailsVm.custName = fixedDepositService.customer.custName;
			reviewFDChangeMaturityDetailsVm.pAmountdata = fixedDepositService.customer.principalAmount;
			reviewFDChangeMaturityDetailsVm.maturityDate = fixedDepositService.customer.maturityDate;
			reviewFDChangeMaturityDetailsVm.maturitydateRequest = fixedDepositService.customer.maturitydateFDRequest;
			reviewFDChangeMaturityDetailsVm.maturityAmount = fixedDepositService.customer.maturityAmount;
			reviewFDChangeMaturityDetailsVm.interestRate = fixedDepositService.customer.interestRate.replace('%','');
			reviewFDChangeMaturityDetailsVm.interestPayout = fixedDepositService.customer.interestPayout;
			reviewFDChangeMaturityDetailsVm.intpayoutservice = fixedDepositService.customer.intpayoutservice;
			reviewFDChangeMaturityDetailsVm.maturityInstruction = fixedDepositService.customer.maturityInstruction;
			reviewFDChangeMaturityDetailsVm.matInstService = fixedDepositService.customer.matInstService;
			reviewFDChangeMaturityDetailsVm.isTaxable = fixedDepositService.customer.isTaxable;
			reviewFDChangeMaturityDetailsVm.isMod = fixedDepositService.customer.isMod;

			reviewFDChangeMaturityDetailsVm.modeOfOperation = fixedDepositService.customer.modeOfOperation;
			reviewFDChangeMaturityDetailsVm.isAccountMasked = true;
			
		});

		$scope.$on('$ionicView.afterLeave', function () {
			//any cleanup needs to be done here: executes everytime when page is left
		});
		return this;
	}]);