'use strict';

angularApp.controller('fixedDepositController',
	["$timeout",
		"$state",
		"$scope",
		"$translate",
		"fixedDepositService",
		"closePopupService",
		"$ionicPopup",
		"customerInfoService",
		"$ionicPopover",
		"accountOverviewService",
		"utilityService",
		"getAccountDetailsService",
		"homeScreenService",
		"$ionicHistory",

		function ($timeout,
			$state,
			$scope,
			$translate,
			fixedDepositService,
			closePopupService,
			$ionicPopup,
			customerInfoService,
			$ionicPopover,
			accountOverviewService,
			utilityService,
			getAccountDetailsService,
			homeScreenService,
			$ionicHistory) {

			//functions, variables that can be accessed from the HTML come here
			var fixedDepositVm = this;
			fixedDepositVm.indexId = 1;


			 function calculateAge(born)
							{
								var now= new Date();
								var bornDate = new Date(born);
								var birthday = new Date(now.getFullYear(), bornDate.getMonth(), bornDate.getDate());
								if (now >= birthday) 
								return now.getFullYear() - bornDate.getFullYear();
								else
								return now.getFullYear() - bornDate.getFullYear() - 1;
							}

			/* page initialization */
			function initPage() {
				// fixedDepositVm.isBackCheck = homeScreenService.isBackCheck;
				// homeScreenService.isBackCheck = false;
				if(homeScreenService.ishamburgerMenuFD){
				  fixedDepositVm.isHamCheck = true;
				  fixedDepositVm.isBackCheck = true;
				}else {
				  fixedDepositVm.isBackCheck = false;
					// fixedDepositVm.isHamCheck = false;
				}
				fixedDepositVm.showBack = false;
				fixedDepositVm.showNext = true;
				fixedDepositVm.disablenext = true;
				fixedDepositVm.isValidError = false;
				fixedDepositVm.validErrorMessage = "";
				fixedDepositVm.isValidAccount = false;
				fixedDepositVm.validAccountMessage = "";

				$translate(['SAVING_INFO', 'AMOUNT', 'DEPOSIT_FROM', 'TAX_SAVER', 'FIXED_DEPOSIT', 'AMOUNT_COMPARE', 'SENIOR_CITIZEN', 'SELECT_ACCOUNT', 'FDINFOMSG', 'FDINFOMSG_NEXT', 'FDINFOMSG_DOWN', 'AMOUNT_LIMIT', 'SENIOR_AMOUNT_LIMIT', 'TAX_AMOUNT', 'SENIOR_TAX_AMOUNT', 'INACTIVE_ACCOUNT', 'NO_TRANS_RIGHTS','ACC_TRANS_RIGHTS','FETCH_TRANS_RGTS']).then(function (translations) {
					fixedDepositVm.fixedDeposit = translations['SAVING_INFO'];
					fixedDepositVm.amount = translations['AMOUNT'];
					fixedDepositVm.depositFrom = translations['DEPOSIT_FROM'];
					fixedDepositVm.taxSaver = translations['TAX_SAVER'];
					fixedDepositVm.fdTitle = translations['FIXED_DEPOSIT'];
					fixedDepositVm.amtCmperror = translations['AMOUNT_COMPARE'];
					fixedDepositVm.seniorCitizen = translations['SENIOR_CITIZEN'];
					fixedDepositVm.selectedAccount = translations['SELECT_ACCOUNT'];
					fixedDepositVm.amountinfofd = translations['FDINFOMSG'];
					fixedDepositVm.amountinfotsfd = translations['FDINFOMSG_NEXT'];
					fixedDepositVm.taxsaverinfo = translations['FDINFOMSG_DOWN'];
					fixedDepositVm.normalAmountLimit = translations['AMOUNT_LIMIT'];
					fixedDepositVm.senioramountLimit = translations['SENIOR_AMOUNT_LIMIT'];
					fixedDepositVm.taxAmounLimit = translations['TAX_AMOUNT'];
					fixedDepositVm.seniorTaxAmounLimit = translations['SENIOR_TAX_AMOUNT'];
					fixedDepositVm.activeAccount = translations['INACTIVE_ACCOUNT'];
					fixedDepositVm.transactionRights = translations['NO_TRANS_RIGHTS'];
					fixedDepositVm.accTransRights = translations['ACC_TRANS_RIGHTS'];
					fixedDepositVm.fetchTransRights = translations['FETCH_TRANS_RGTS'];
				});
			};
			fixedDepositVm.getInfomessage = function (fixedDepositVm) {
				fixedDepositService.fetchInfoMessage(fixedDepositVm).then(function (data) {
					if (data.message) {
						fixedDepositVm.amountInfoMeesage = data.message;
					}
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			fixedDepositVm.infoPopup = function ($event) {
				$ionicPopover.fromTemplateUrl('pages/fixedDeposit/fixedDeposit/popover.html', {
					scope: $scope
				}).then(function (popover) {
					if (fixedDepositVm.isTaxable) {
						fixedDepositVm.action = "amountToSaveFd";
					} else {
						fixedDepositVm.action = "amountToSaveTsfd"
					}
					fixedDepositVm.getInfomessage(fixedDepositVm);
					$scope.popover = popover;
					$scope.popover.show($event);
				});
			};

			fixedDepositVm.closePopover = function () {
				$scope.popover.hide();
			};

			fixedDepositVm.getInfomessageTax = function (fixedDepositVm) {
				fixedDepositService.fetchInfoMessage(fixedDepositVm).then(function (data) {
					if (data.message) {
						fixedDepositVm.taxInfoMeesage = data.message;
					}
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			fixedDepositVm.infoPopupFD = function ($event) {
				$ionicPopover.fromTemplateUrl('pages/fixedDeposit/fixedDeposit/popoverFD.html', {
					scope: $scope
				}).then(function (popover) {
					fixedDepositVm.action = "FDToBeAtaxSaverFd";
					fixedDepositVm.getInfomessageTax(fixedDepositVm);
					$scope.popover = popover;
					$scope.popover.show($event);
				});
			};

			fixedDepositVm.infoPopupFDSC = function ($event) {
				$ionicPopover.fromTemplateUrl('pages/fixedDeposit/fixedDeposit/popoverFDSC.html', {
					scope: $scope
				}).then(function (popover) {
					$scope.popover = popover;
					$scope.popover.show($event);
				});
			};

			fixedDepositVm.selectedAccountFun = function () {
				var data = fixedDepositVm.selectedValue.split(",");
				var e = [];
				e.accountType = data[0];
				e.accountNumber = data[1];
				e.accountBalance = data[2];
				e.isActive = data[3];
				e.isTransactional = data[4];
				e.branchCode = data[5];
				e.branchName = data[6];
				e.intCategory = data[7];
				e.accountTypeCode = data[8];
				e.indexId = data[9];
				fixedDepositVm.indexId = e.indexId;
				fixedDepositService.customer.indexId = fixedDepositVm.indexId;
				fixedDepositVm.isActive = e.isActive;
				fixedDepositVm.selectedAccountisActive = fixedDepositVm.isActive;
				fixedDepositVm.isTransactional = e.isTransactional;
				fixedDepositVm.selectedAccountisTransactional = fixedDepositVm.isTransactional;
				fixedDepositVm.selectedAccountType = e.accountType;
				fixedDepositVm.selectedAccountNumber = e.accountNumber;
				fixedDepositVm.selectedAccountAmount = e.accountBalance;
				fixedDepositService.customer.selectedItem = e.accountNumber;
				fixedDepositService.selectedDetails.accountID = e.accountID;
				fixedDepositService.selectedDetails.accountType = e.accountType;
				fixedDepositService.selectedDetails.accountNumber = e.accountNumber;
				fixedDepositService.selectedDetails.accountBalance = e.accountBalance;
				fixedDepositService.selectedDetails.isActive = e.isActive;
				fixedDepositService.selectedDetails.isTransactional = e.isTransactional;
				fixedDepositService.selectedDetails.branchCode = e.branchCode;
				fixedDepositService.selectedDetails.branchName = e.branchName;
				fixedDepositService.customer.branchCode = e.branchCode;
				fixedDepositService.customer.branchName = e.branchName;
				fixedDepositService.selectedDetails.intCategory = e.intCategory;
				fixedDepositService.selectedDetails.accountTypeCode = e.accountTypeCode;
				fixedDepositService.customer.intCategory = e.intCategory;
				fixedDepositService.customer.accountTypeCode = e.accountTypeCode;
				fixedDepositService.customer.modeOfOperation = fixedDepositVm.accDetails[fixedDepositVm.indexId].operational;
				fixedDepositService.customer.nominee = "";
				fixedDepositVm.changeAmount();
			};

			/* validation for amount field */
			fixedDepositVm.getCBValue = function (isChecked) {
				if (isChecked === true) {
					fixedDepositVm.isTaxable = true;
					if (fixedDepositService.customer.isPanAvailable === "" || fixedDepositService.customer.isPanAvailable === undefined || fixedDepositService.customer.isPanAvailable === null) {
						var title = '';
						var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="PAN4" "></div><div class="FDpopup-margin fontSize-subHeading roboto-light font-dark-grey" translate="PAN1"></div><div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="PAN2"></div><div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="PAN3"></div>';
						var onTap = 'menu.fixedDeposit';
						fixedDepositService.showAlertModal(title, template, onTap, $scope, $state);
						fixedDepositVm.isTaxable = false;
					}
				} else {
					fixedDepositVm.isTaxable = false;
				}
				fixedDepositService.customer.isTaxable = fixedDepositVm.isTaxable;
				fixedDepositVm.changeAmount();
			};

			/* change event for senior citizen check box */
			fixedDepositVm.getSCValue = function (isChecked) {
				if (isChecked === true) {
					fixedDepositVm.isSenior = true;
				} else {
					fixedDepositVm.isSenior = false;
				}
				fixedDepositService.customer.isSenior = fixedDepositVm.isSenior;
				fixedDepositVm.changeAmount();
			};

			/*event for changing the amount field */
			fixedDepositVm.changeAmount = function () {
				if(getAccountDetailsService.accessRightsData.accounts) {
					for (var i in getAccountDetailsService.accessRightsData.accounts) {
						if (getAccountDetailsService.accessRightsData.accounts[i].accountNumber === fixedDepositService.selectedDetails.accountNumber && getAccountDetailsService.accessRightsData.accounts[i].modBalance) {
							fixedDepositVm.sumModAccountAmount = parseFloat(fixedDepositVm.selectedAccountAmount) + parseFloat(getAccountDetailsService.accessRightsData.accounts[i].modBalance);
							break;
						}
					}
				} else {
					fixedDepositVm.sumModAccountAmount = parseFloat(fixedDepositVm.selectedAccountAmount);
				}
				
				fixedDepositVm.checkdisable = false;
				if (fixedDepositVm.amountData !== undefined && fixedDepositVm.amountData !== "") {
					fixedDepositVm.amountData = parseFloat(fixedDepositVm.amountData);
				} else {
					fixedDepositVm.amountData = "";
				}

				fixedDepositService.customer.amountData = fixedDepositVm.amountData;
				var title = '';
				var onTap = 'menu.fixedDeposit';
				fixedDepositVm.isValidAccount = false;
				fixedDepositVm.validAccountMessage = "";
				fixedDepositVm.isValidError = false;
				fixedDepositVm.validErrorMessage = "";
				if (fixedDepositVm.sumModAccountAmount < fixedDepositVm.amountData) {
					fixedDepositVm.disablenext = true;
					fixedDepositVm.showBack = false;
					fixedDepositVm.isValidError = true;
					fixedDepositVm.validErrorMessage = fixedDepositVm.amtCmperror;
				} else if (fixedDepositVm.selectedAccountisActive == false) {
					fixedDepositVm.showBack = false;
					fixedDepositVm.disablenext = true;
					fixedDepositVm.isValidAccount = true;
					fixedDepositVm.validAccountMessage = fixedDepositVm.activeAccount;
				} else if (fixedDepositVm.selectedAccountisTransactional == false) {
					fixedDepositVm.showBack = false;
					fixedDepositVm.disablenext = true;
					fixedDepositVm.isValidAccount = true;
					fixedDepositVm.validAccountMessage = fixedDepositVm.transactionRights;
				} else if (fixedDepositVm.selectedAccountisActive == undefined ||  fixedDepositVm.selectedAccountisActive == null || fixedDepositVm.selectedAccountisActive == "") {
					fixedDepositVm.showBack = false;
					fixedDepositVm.disablenext = true;
					fixedDepositVm.isValidAccount = true;
					fixedDepositVm.validAccountMessage = "";
				} else if (fixedDepositVm.selectedAccountisTransactional == undefined ||  fixedDepositVm.selectedAccountisTransactional == null || fixedDepositVm.selectedAccountisTransactional == "") {
					fixedDepositVm.showBack = false;
					fixedDepositVm.disablenext = true;
					fixedDepositVm.isValidAccount = true;
					fixedDepositVm.validAccountMessage = "";
				} else {
					if (fixedDepositVm.isTaxable === false) {
						if (fixedDepositVm.isSenior !== true) {
							if (fixedDepositVm.amountData > 9999999 || fixedDepositVm.amountData < 1000 || fixedDepositVm.amountData === "" || fixedDepositVm.amountData === null || fixedDepositVm.amountData === undefined) {
								fixedDepositVm.isValidError = true;
								fixedDepositVm.validErrorMessage = fixedDepositVm.normalAmountLimit;
								fixedDepositVm.disablenext = true;
								fixedDepositVm.showBack = false;
							} else {
								fixedDepositVm.isValidError = false;
								fixedDepositVm.checkdisable = true;
								fixedDepositVm.disablenext = false;
								fixedDepositVm.showBack = true;
							}
						} else {
							if (fixedDepositVm.amountData > 9999999 || fixedDepositVm.amountData < 10000 || fixedDepositVm.amountData === "" || fixedDepositVm.amountData === null || fixedDepositVm.amountData === undefined) {
								fixedDepositVm.isValidError = true;
								fixedDepositVm.validErrorMessage = fixedDepositVm.senioramountLimit;
								fixedDepositVm.disablenext = true;
								fixedDepositVm.showBack = false;
							} else {
								fixedDepositVm.dobCUST = "" + fixedDepositVm.getDay + " " + fixedDepositVm.getMonth.toUpperCase() + " " + fixedDepositVm.getYear;
								var title = '';
								var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="SENIOR_POPUP" "></div><div class="amt_limit fontSize-subHeading roboto-light font-dark-grey">{{fixedDepositVm.dobCUST}}</div><div class="FDpopup-margin fontSize-subHeading roboto-light font-dark-grey" translate="SENIOR_BANK"></div>';
								var onTap = 'menu.fixedDeposit';
								fixedDepositService.showAlertModal(title, template, onTap, $scope, $state);
								fixedDepositVm.isValidError = false;
								fixedDepositVm.checkdisable = true;
								fixedDepositVm.disablenext = false;
								fixedDepositVm.showBack = true;
							}
						}
					}

					if (fixedDepositVm.isTaxable === true) {
						if (fixedDepositVm.isSenior !== true) {
							if (fixedDepositVm.amountData > 150000 || fixedDepositVm.amountData < 1000 || fixedDepositVm.amountData === "" || fixedDepositVm.amountData === null || fixedDepositVm.amountData === undefined) {
								fixedDepositVm.isValidError = true;
								fixedDepositVm.validErrorMessage = fixedDepositVm.taxAmounLimit;
								fixedDepositVm.disablenext = true;
								fixedDepositVm.showBack = false;
							} else {
								fixedDepositVm.isValidError = false;
								fixedDepositVm.checkdisable = true;
								fixedDepositVm.disablenext = false;
								fixedDepositVm.showBack = true;
							}
						} else {
							if (fixedDepositVm.amountData > 150000 || fixedDepositVm.amountData < 10000 || fixedDepositVm.amountData === "" || fixedDepositVm.amountData === null || fixedDepositVm.amountData === undefined) {
								fixedDepositVm.isValidError = true;
								fixedDepositVm.validErrorMessage = fixedDepositVm.seniorTaxAmounLimit;
								fixedDepositVm.disablenext = true;
								fixedDepositVm.showBack = false;
							} else {
								fixedDepositVm.dobCUST = "" + fixedDepositVm.getDay + " " + fixedDepositVm.getMonth.toUpperCase() + " " + fixedDepositVm.getYear;
								var title = '';
								var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="SENIOR_POPUP" "></div><div class="amt_limit fontSize-subHeading roboto-light font-dark-grey">{{fixedDepositVm.dobCUST}}</div><div class="FDpopup-margin fontSize-subHeading roboto-light font-dark-grey" translate="SENIOR_BANK"></div>';
								var onTap = 'menu.fixedDeposit';
								fixedDepositService.showAlertModal(title, template, onTap, $scope, $state);
								fixedDepositVm.isValidError = false;
								fixedDepositVm.checkdisable = true;
								fixedDepositVm.disablenext = false;
								fixedDepositVm.showBack = true;
							}
						}
					}
				}
			};

			/* function to go to account overview page */
			fixedDepositVm.goToAO = function () {
				if(homeScreenService.ishamMenu===true){
					$ionicHistory.goBack();
					homeScreenService.ishamMenu=false;
				}
				else{
				$state.go("menu.accountOverviewMyBalance");
			}
		}

			fixedDepositVm.goBacktoPrevious = function () {
				$state.go("menu.accountOverviewMyBalance");
			}
			fixedDepositVm.getTSFDMessage = function () {
				fixedDepositService.fetchTSFDMessage().then(function (data) {
					if (data) {
						fixedDepositVm.tsfdMessage = data;
					}
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}
			fixedDepositVm.goToNextPage = function () {
				if(getAccountDetailsService.accessRightsData.accounts == null || getAccountDetailsService.accessRightsData.accounts == "") {
					fixedDepositVm.disablenext = true;
					fixedDepositVm.isValidAccount = true;
					fixedDepositVm.validAccountMessage = fixedDepositVm.fetchTransRights;
				} else { 
					var isAccountTransactional = false;
					for (var i in getAccountDetailsService.accessRightsData.accounts) {
						if (getAccountDetailsService.accessRightsData.accounts[i].accountNumber === fixedDepositService.selectedDetails.accountNumber && parseInt(getAccountDetailsService.accessRightsData.accounts[i].accessResponse) != 0) {
							isAccountTransactional = true;
						}
					}
					if(isAccountTransactional) {
						// fixedDepositVm.changeAmount();
						if(fixedDepositVm.isTaxable==true){
						fixedDepositVm.getTSFDMessage();
						if(fixedDepositVm.tsfdMessage){
						fixedDepositVm.cancelPopupName = $ionicPopup.show({
							title: "",
							cssClass: 'removePopup-head popupWidth90 popupMargin ftpopup-body popupBackgroundWhite ss-medical-page inb-popUp-sub-btn',
							template: '<div class=""></div><div class="inb-alert-msg popupTextBottomPadding fontSize-subHeading inb-p20 fss-common-ul-list" style="padding-bottom:0!important; text-align:justify!important;padding-top:20px;">' +
							fixedDepositVm.tsfdMessage + '</div></div>',
							scope: $scope,
							buttons: [
								{
									text: 'Cancel',
									type: 'button-assertive',
									onTap: function () {
										fixedDepositVm.cancelPopupName.close();
										//fixedDepositService.customer.checkPage = true;
									}
								},
								{
									text: 'OK',
									type: 'button-assertive',
									onTap: function () {
											$state.go('menu.fixedDuration');
									}
								}
							],
						});
					}
					}
					else
						$state.go("menu.fixedDuration");
					} else {
						fixedDepositVm.disablenext = true;
						fixedDepositVm.isValidAccount = true;
						fixedDepositVm.validAccountMessage = fixedDepositVm.accTransRights;
					}
				}
			}

			$scope.$on('$ionicView.loaded', function () {
				initPage();
				if(getAccountDetailsService.accessRightsData.accounts == null || getAccountDetailsService.accessRightsData.accounts == "") {
					getAccountDetailsService.getAccountsAccessRights('').then( function(data) {
                    getAccountDetailsService.accessRightsData = data;
					}, function(error) {
						// Failure block
					});
				}
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				homeScreenService.dummymenuCheck=true;
				fixedDepositVm.todayDate = new Date();
				if (customerInfoService.customer.DOB !== "" && customerInfoService.customer.DOB !== undefined && customerInfoService.customer.DOB !== null) {
					fixedDepositVm.custDate = customerInfoService.customer.DOB;
					fixedDepositService.customer.custDOB = customerInfoService.customer.DOB;
					fixedDepositVm.getDay = fixedDepositVm.custDate.substring(0, 2);
					fixedDepositVm.getMonth = fixedDepositVm.custDate.substring(3, 6);
					fixedDepositVm.getYear = fixedDepositVm.custDate.substring(7, 11);
					fixedDepositVm.DOBcustomer = new Date(fixedDepositVm.getMonth + fixedDepositVm.getDay + "," + fixedDepositVm.getYear);
					fixedDepositVm.custAge =calculateAge (fixedDepositService.customer.custDOB);
					//fixedDepositVm.custAge = (fixedDepositVm.todayDate - fixedDepositVm.DOBcustomer) / (1000 * 60 * 60 * 24 * 365);
					fixedDepositVm.custAge = parseInt(fixedDepositVm.custAge);
					if (fixedDepositVm.custAge === 60 || fixedDepositVm.custAge > 60) {
						fixedDepositVm.inSeniorCitizen = true;
					} else {
						fixedDepositVm.inSeniorCitizen = false;
					}
				} else {
					fixedDepositVm.inSeniorCitizen = false;
				}
				fixedDepositService.customer.isPanAvailable = customerInfoService.customer.isPanAvailable;
				fixedDepositVm.isTaxable = fixedDepositService.customer.isTaxable;
				fixedDepositVm.isSenior = fixedDepositService.customer.isSenior;
				fixedDepositVm.amountData = fixedDepositService.customer.amountData;
				fixedDepositVm.accDetails = [];
				fixedDepositVm.accDetailsNew = [];
				fixedDepositVm.accDetailsNew = fixedDepositService.accDetails;
				for (var i in fixedDepositVm.accDetailsNew) {
					if (fixedDepositVm.accDetailsNew[i].accountType === "Savings Account") {
						fixedDepositVm.accDetailsNew[i].accountType = "Savings A/c";
					} else if (fixedDepositVm.accDetailsNew[i].accountType === "Current Account") {
						fixedDepositVm.accDetailsNew[i].accountType = "Current A/c";
					} else if (fixedDepositVm.accDetailsNew[i].accountType === "Overdraft Account") {
						fixedDepositVm.accDetailsNew[i].accountType = "Overdraft A/c";
					}
					fixedDepositVm.accDetailsNew[i].accountBalance = parseInt(fixedDepositVm.accDetailsNew[i].accountBalance);
				}
				fixedDepositVm.accDetails = fixedDepositVm.accDetailsNew;
				if (fixedDepositService.selectedDetails.accountType === '') {
					fixedDepositVm.selectedValue = fixedDepositVm.accDetails[0].accountType + "," + fixedDepositVm.accDetails[0].accountNumber + "," + fixedDepositVm.accDetails[0].accountBalance + "," + fixedDepositVm.accDetails[0].isActive + "," + fixedDepositVm.accDetails[0].isTransactional + "," + fixedDepositVm.accDetails[0].branchCode + "," + fixedDepositVm.accDetails[0].branchName + "," + fixedDepositVm.accDetails[0].intCategory + "," + fixedDepositVm.accDetails[0].accountTypeCode + ",0";
					fixedDepositVm.showBack = false;
					fixedDepositVm.showNext = true;
					fixedDepositVm.disablenext = true;
					fixedDepositVm.indexId = 0;
					fixedDepositVm.isActive = fixedDepositVm.accDetails[0].isActive;
					fixedDepositVm.selectedAccountisActive = fixedDepositVm.isActive;
					fixedDepositService.selectedDetails.isActive = fixedDepositVm.isActive;
					fixedDepositVm.isTransactional = fixedDepositVm.accDetails[0].isTransactional;
					fixedDepositVm.selectedAccountisTransactional = fixedDepositVm.isTransactional;
					fixedDepositService.selectedDetails.isTransactional = fixedDepositVm.isTransactional;
					fixedDepositService.customer.selectedItem = fixedDepositVm.accDetails[0].accountNumber;
					fixedDepositVm.selectedAccountType = fixedDepositVm.accDetails[0].accountType;
					fixedDepositVm.selectedAccountNumber = fixedDepositVm.accDetails[0].accountNumber;
					fixedDepositVm.selectedAccountAmount = fixedDepositVm.accDetails[0].accountBalance;
					fixedDepositService.selectedDetails.accountType = fixedDepositVm.selectedAccountType;
					fixedDepositService.selectedDetails.accountNumber = fixedDepositVm.selectedAccountNumber;
					fixedDepositService.selectedDetails.accountBalance = fixedDepositVm.selectedAccountAmount;
					fixedDepositVm.selectedbranchCode = fixedDepositVm.accDetails[0].branchCode;
					fixedDepositVm.selectedbranchName = fixedDepositVm.accDetails[0].branchName;
					fixedDepositService.selectedDetails.branchCode = fixedDepositVm.selectedbranchCode;
					fixedDepositService.selectedDetails.branchName = fixedDepositVm.selectedbranchName;
					fixedDepositService.customer.branchCode = fixedDepositVm.selectedbranchCode;
					fixedDepositService.customer.branchName = fixedDepositVm.selectedbranchName;
					fixedDepositService.selectedDetails.intCategory = fixedDepositVm.accDetails[0].intCategory;
					fixedDepositService.selectedDetails.accountTypeCode = fixedDepositVm.accDetails[0].accountTypeCode;
					fixedDepositService.customer.intCategory = fixedDepositVm.accDetails[0].intCategory;
					fixedDepositService.customer.accountTypeCode = fixedDepositVm.accDetails[0].accountTypeCode;
					fixedDepositService.customer.modeOfOperation = fixedDepositVm.accDetails[0].operational;
				} else {
					fixedDepositVm.indexId = fixedDepositService.customer.indexId;
					fixedDepositVm.selectedAccountType = fixedDepositService.selectedDetails.accountType;
					fixedDepositVm.selectedAccountNumber = fixedDepositService.selectedDetails.accountNumber;
					fixedDepositVm.selectedAccountAmount = fixedDepositService.selectedDetails.accountBalance;
					fixedDepositVm.selectedAccountisActive = fixedDepositService.selectedDetails.isActive;
					fixedDepositVm.selectedAccountisTransactional = fixedDepositService.selectedDetails.isTransactional;
					fixedDepositVm.selectedbranchCode = fixedDepositService.selectedDetails.branchCode;
					fixedDepositVm.selectedbranchName = fixedDepositService.selectedDetails.branchName;
					fixedDepositService.customer.branchCode = fixedDepositVm.selectedbranchCode;
					fixedDepositService.customer.branchName = fixedDepositVm.selectedbranchName;
					fixedDepositVm.intCategory = fixedDepositService.selectedDetails.intCategory;
					fixedDepositVm.accountTypeCode = fixedDepositService.selectedDetails.accountTypeCode;
					fixedDepositService.customer.intCategory = fixedDepositVm.intCategory;
					fixedDepositService.customer.accountTypeCode = fixedDepositVm.accountTypeCode;
					fixedDepositVm.selectedValue = fixedDepositVm.selectedAccountType + "," + fixedDepositVm.selectedAccountNumber + "," + fixedDepositVm.selectedAccountAmount + "," + fixedDepositVm.selectedAccountisActive + "," + fixedDepositVm.selectedAccountisTransactional + "," + fixedDepositVm.selectedbranchCode + "," + fixedDepositVm.selectedbranchName + "," + fixedDepositVm.intCategory + "," + fixedDepositVm.accountTypeCode + "," + fixedDepositVm.indexId;
					fixedDepositService.customer.modeOfOperation = fixedDepositVm.accDetails[fixedDepositVm.indexId].operational;
				}
				fixedDepositVm.changeAmount();
			});

			$scope.$on('$ionicView.afterLeave', function () {
				//any cleanup needs to be done here: executes everytime when page is left
			});
			return this;
		}]);