angularApp.service('fixedDepositClosureService',
	function ($q, utilityService, AdapterUtils, secKeyValidationServices,constantConfig) {
		var FDservice = this;
		FDservice.sendFDClosure = function (data) {
			var q = $q.defer();
			var obj = {
				"fdAccountNumber": data.account,
				"transferAccountNumber": data.creditAc,
				"accountBalance": data.amountCredited,
				"branchCode": data.branchCode
			};
			AdapterUtils.postData("adapters/FixedDepositAdapter/sendFDClosure", obj, true).then(
				function (response) {
					q.resolve(response.data);
				}, function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		FDservice.fetchFDAccountDetails = function (data) {
			var q = $q.defer();
			var obj = {
				"fdAccountNumber": data.account,
				"lien": data.lien,
				"operational": data.operational,
				"branchCode": data.branchCode
			};
			AdapterUtils.postData("adapters/FixedDepositAdapter/fetchFDAccountDetails", obj, false).then(
				function (response) {
					q.resolve(response.data);
				}, function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		FDservice.FDprematureClosure = function (data, dates) {
			var q = $q.defer();
			var obj = {
				"fdAccountNumber": data.account,
				"closureDate": dates.closefdDate,
				"branchCode": data.branchCode
			};
			AdapterUtils.postData("adapters/FixedDepositAdapter/prematureClosureEnq", obj, true).then(
				function (response) {
					q.resolve(response.data);
				}, function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		FDservice.getRelationship = function () {
			var q = $q.defer();
			var obj = {
				"id": "MasterDataTry1",
				"fields": ["Relationship"]
			};
			AdapterUtils.postData("adapters/FixedDepositAdapter/getRelationship", obj, true).then(
				function (response) {
					q.resolve(response.data);
				}, function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		FDservice.fetchFdReceipt = function (data) {
			var q = $q.defer();
			var requestSecKey = secKeyValidationServices.generatesRandomNums();
			var obj = {
				"amount": data.amount,
				"name": data.name,
				"email": data.email,
				"fdAccountNumber": data.fdAccountNumber,
				"taxSaverFlag": data.taxSaverFlag,
				"tenureDuration": data.tenureDuration,
				"maturityDate": data.maturityDate,
				"maturityAmount": data.maturityAmount,
				"maturityInstruction": data.maturityInstruction,
				"interestRate": data.interestRate,
				"interestPayout": data.interestPayout,
				"startDate": data.startDate,
				"endDate": data.endDate,
				"branchCode": data.branchCode,
				"branchName": data.branchName,
				"debitAccountNumber": data.debitAccountNumber,
				"isDownload": data.isDownload,
				"modeOfOperation": data.modeOfOperation,
				"scheme": data.scheme,
				"mobile": data.mobile,
				"dob": data.dob,
				"cif": data.cif,
				"nomineeName": data.nomineeName,
				"secKey":requestSecKey,
				"isNewBuild":"true"
			};
			AdapterUtils.postData("adapters/FixedDepositAdapter/fetchFdReceipt", obj, false).then(
				function (response) {
					var finalcalculatedKey = secKeyValidationServices.verifySecKey(parseInt(response.secKey));
					if(requestSecKey === finalcalculatedKey){
						q.resolve(response.data);
					}else{
						q.reject({responseMessage:constantConfig.secKeyErrors.technicalError});
					}
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		FDservice.fdClosureCheckBranch = function (fdNumber) {
			var q = $q.defer();
			var reqParams = {"accountNumber" : fdNumber};
			AdapterUtils.postData("adapters/FixedDepositAdapter/fdClosureDetails", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				}, function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};		
		return FDservice;
	});  
