'use strict';

angularApp.controller('fixedDepositDetailsController',
	["$timeout",
		"$state",
		"$scope",
		"$translate",
		"$ionicPopup",
		"fixedDepositService",
		"fixedDepositClosureService",
		"$ionicPopover",
		"utilityService",
		"getAccountDetailsService",
		"closePopupService",
		"personalLoanService",
		"clickStreamService",
		"reviewFDService",
		"openUrlInAppbroswerService",
		"$ionicHistory",
		"changeMaturityService",
		"constantConfig",
		"$rootScope",
		"pwdProtectedPdfDownloadService",
		function ($timeout,
			$state,
			$scope,
			$translate,
			$ionicPopup,
			fixedDepositService,
			fixedDepositClosureService,
			$ionicPopover,
			utilityService,
			getAccountDetailsService,
			closePopupService,
			personalLoanService,
			clickStreamService,
			reviewFDService,
			openUrlInAppbroswerService,
			$ionicHistory,
			changeMaturityService,
			constantConfig,
			$rootScope,
			pwdProtectedPdfDownloadService
		) {

			var fixedDepositDetailsVm = this;
			fixedDepositDetailsVm.isTaxable = false;
			fixedDepositDetailsVm.mailLoader = false;
			fixedDepositDetailsVm.downloadLoader = false;
			fixedDepositDetailsVm.isFDDetailsAvailable = false;
			fixedDepositDetailsVm.closeDetails = {};
			fixedDepositDetailsVm.nightMode = false;
			fixedDepositDetailsVm.showLA = false;
			fixedDepositDetailsVm.disableAvailODBtn = true;
			fixedDepositDetailsVm.disableCloseFDBtn = true;
			fixedDepositDetailsVm.isModOrPmryFD = false;
			fixedDepositDetailsVm.isValidAccount = false;
			fixedDepositDetailsVm.validAccountMessage = "";
			fixedDepositDetailsVm.isAccountMasked = false;
			fixedDepositDetailsVm.closeFDNotAllowedPopUp = false;
			fixedDepositDetailsVm.personalDetails = {
				fdNumber: "",
				name: "",
				debitAccountNumber: "",
				principalAmount: 0,
				tenureDuration: "",
				maturityDate: "",
				maturityAmount: 0,
				interestRate: 0,
				interestPayout: "",
				maturityInstruction: "",
				maturityInstructionText: "",
				taxSaverFlag: false,
				creditAc: "",
				amountCredited: 0,
				startDate: "",
				effectiveIE: 0,
				isSeniorCitizen: false,
				odLimit: 0,
				odInterestRate: "",
				odExpiryDate: "",
				isAvailOD: false,
				isCloseFD: false,
				product: "",
				scheme: "",
				lienAmount: ""
			};

			function initPage() {
				$translate(['FDN', 'NAME', 'PRINCIPAL_AMT', 'TENURE', 'DEPOST_DATE', 'MATURITY_DATE', 'MATURITY_AMT', 'RATE_OF_INT',
					'EFFCTIVE_IE', 'AMNT_CREDITED', 'INTRST_PAYOUT', 'MATURITY_INST', 'CREDIT_AC', 'NOMINEE', 'START_DATE', 'CLOSEFD', 'REGISTERED', 'NOMINEELINK', 'SELECT_ACCOUNT', 'LIEN_AMOUNT', 'NOT_AVAILABLE', 'NO_NOMINEE', 'MODCLOSEFD', 'MODAVAILOD', 'ACC_TRANS_RIGHTS', 'FETCH_TRANS_RGTS', 'EDIT_MATURITY']).then(function (translations) {
						fixedDepositDetailsVm.fdNumber = translations['FDN'];
						fixedDepositDetailsVm.name = translations['NAME'];
						fixedDepositDetailsVm.principalAmount = translations['PRINCIPAL_AMT'];
						fixedDepositDetailsVm.tenure = translations['TENURE'];
						fixedDepositDetailsVm.depositDate = translations['DEPOST_DATE'];
						fixedDepositDetailsVm.maturityDate = translations['MATURITY_DATE'];
						fixedDepositDetailsVm.maturityAmount = translations['MATURITY_AMT'];
						fixedDepositDetailsVm.rateOfInterest = translations['RATE_OF_INT'];
						fixedDepositDetailsVm.effectiveIE = translations['EFFCTIVE_IE'];
						fixedDepositDetailsVm.amountCredited = translations['AMNT_CREDITED'];
						fixedDepositDetailsVm.interestPayout = translations['INTRST_PAYOUT'];
						fixedDepositDetailsVm.maturityInst = translations['MATURITY_INST'];
						fixedDepositDetailsVm.creditAc = translations['CREDIT_AC'];
						fixedDepositDetailsVm.nominee = translations['NOMINEE'];
						fixedDepositDetailsVm.startDate = translations['START_DATE'];
						fixedDepositDetailsVm.closefd = translations['CLOSEFD'];
						fixedDepositDetailsVm.register = translations['REGISTERED'];
						fixedDepositDetailsVm.nomineeLink = translations['NOMINEELINK'];
						fixedDepositDetailsVm.editMaturityLink = translations['EDIT_MATURITY'];
						fixedDepositDetailsVm.selectedAccount = translations['SELECT_ACCOUNT'];
						fixedDepositDetailsVm.lienAmount = translations['LIEN_AMOUNT'];
						fixedDepositDetailsVm.notAvailable = translations['NOT_AVAILABLE'];
						fixedDepositDetailsVm.nonominee = translations['NO_NOMINEE'];
						fixedDepositDetailsVm.modCloseFD = translations['MODCLOSEFD'];
						fixedDepositDetailsVm.modAvailOD = translations['MODAVAILOD'];
						fixedDepositDetailsVm.accTransRights = translations['ACC_TRANS_RIGHTS'];
						fixedDepositDetailsVm.fetchTransRights = translations['FETCH_TRANS_RGTS'];
					});
				fixedDepositService.customer.nomineeClick = '';
				fixedDepositService.customer.AODclick = '';
			}

			fixedDepositDetailsVm.eyesOnFun = function(accNo){
				fixedDepositDetailsVm.isAccountMasked = false;
				fixedDepositDetailsVm.personalDetails.fdNumber = fixedDepositDetailsVm.oFDValue;
			}

			fixedDepositDetailsVm.eyesOffFun = function(accNo){
				fixedDepositDetailsVm.isAccountMasked = true;
				fixedDepositDetailsVm.oFDValue = accNo;
				fixedDepositDetailsVm.personalDetails.maskedFdNumber = utilityService.maskData(accNo, "front", 4);
			}

			fixedDepositDetailsVm.selectedAccountFun = function () {
				var data = fixedDepositDetailsVm.selectedValue.split(",");
				var e = [];
				e.accountType = data[0];
				e.accountNumber = data[1];
				e.accountBalance = data[2];
				e.isActive = data[3];
				e.isTransactional = data[4];
				e.indexId = data[5];
				fixedDepositDetailsVm.indexId = e.indexId;
				fixedDepositService.customer.indexId = fixedDepositDetailsVm.indexId;
				fixedDepositDetailsVm.isActive = e.isActive;
				fixedDepositDetailsVm.isTransactional = e.isTransactional;
				var title = '';
				var onTap = '';
				if (fixedDepositDetailsVm.isActive === "true" && fixedDepositDetailsVm.isTransactional === "true") {
					fixedDepositDetailsVm.selectedAccountType = e.accountType;
					fixedDepositDetailsVm.selectedAccountNumber = e.accountNumber;
					fixedDepositDetailsVm.selectedAccountAmount = e.accountBalance;
					fixedDepositService.customer.selectedItem = e.accountNumber;
					fixedDepositService.selectedDetails.accountID = e.accountID;
					fixedDepositService.selectedDetails.accountType = e.accountType;
					fixedDepositService.selectedDetails.accountNumber = e.accountNumber;
					fixedDepositService.selectedDetails.accountBalance = e.accountBalance;
					fixedDepositService.selectedDetails.isActive = e.isActive;
					fixedDepositService.selectedDetails.isTransactional = e.isTransactional;
					fixedDepositDetailsVm.confirmclose = false;
				} else {
					if (fixedDepositDetailsVm.isActive === "false") {
						fixedDepositDetailsVm.confirmclose = true;
						var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="SELECT_ACTIVE_ACC"></div><div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="ACTIVE_OR"></div><div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="CONTACT_NEAREST"></div>';
						fixedDepositService.showAlertModal(title, template, onTap, $scope, $state);
					}

					if (fixedDepositDetailsVm.isTransactional === "false") {
						fixedDepositDetailsVm.confirmclose = true;
						var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="USE_TRANS_RIGHTS"></div>';
						fixedDepositService.showAlertModal(title, template, onTap, $scope, $state);
					}
				}
				fixedDepositDetailsVm.confirmclose = false;
				fixedDepositDetailsVm.isValidAccount = false;
			};

			fixedDepositDetailsVm.getInfomessageerate = function (fixedDepositDetailsVm, $event) {
				fixedDepositDetailsVm.fdcloseinfomessage = "";
				if (!fixedDepositService.fdcloseinfomessage) {
					utilityService.showSpinner();
					fixedDepositService.fetchInfoMessage(fixedDepositDetailsVm).then(function (data) {
						if (data.message) {
							fixedDepositDetailsVm.fdcloseinfomessage = data.message;
							fixedDepositService.fdcloseinfomessage = data.message;
							$scope.popover.show($event);
							//angular.element(document.querySelector("#overlayPopup")).removeClass("tooltiptextFDClosureAmt");
							//angular.element(document.querySelector("#overlayPopup")).addClass("tooltiptextFDClosure");
						}
						utilityService.hideSpinner();
					}, function (error) {
						utilityService.hideSpinner();
						utilityService.showErrorMessage(error.responseMessage);
					});
				} else {
					fixedDepositDetailsVm.fdcloseinfomessage = fixedDepositService.fdcloseinfomessage;
					$scope.popover.show($event);
				}
			}

			fixedDepositDetailsVm.getInfomessageerateAmt = function (fixedDepositDetailsVm, $event) {
				fixedDepositDetailsVm.fdcloseinfomessage = "";
				if (!fixedDepositService.fdcloseinfomessageAmt) {
					utilityService.showSpinner();
					fixedDepositService.fetchInfoMessage(fixedDepositDetailsVm).then(function (data) {
						if (data.message) {
							fixedDepositDetailsVm.fdcloseinfomessage = data.message;
							fixedDepositDetailsVm.fdcloseinfomessageIsAmt = true;
							fixedDepositService.fdcloseinfomessageAmt = data.message;
							$scope.popover.show($event);
							//angular.element(document.querySelector("#overlayPopup")).removeClass("tooltiptextFDClosure");
							//angular.element(document.querySelector("#overlayPopup")).addClass("tooltiptextFDClosureAmt");
						}
						utilityService.hideSpinner();
					}, function (error) {
						//angular.element(document.querySelector("#overlayPopup")).removeClass("tooltiptextFDClosure");
						//angular.element(document.querySelector("#overlayPopup")).addClass("tooltiptextFDClosureAmt");
						utilityService.hideSpinner();
						utilityService.showErrorMessage(error.responseMessage);
					});
				} else {
					fixedDepositDetailsVm.fdcloseinfomessage = fixedDepositService.fdcloseinfomessageAmt;
					$scope.popover.show($event);
				}
			}
			$ionicPopover.fromTemplateUrl('pages/fixedDeposit/fixedDepositDetails/popover.html', {
				scope: $scope
			}).then(function (popover) {
				$scope.popover = popover;
			});

			fixedDepositDetailsVm.infoPopup = function ($event) {
				if (!fixedDepositDetailsVm.isTaxable) {
					fixedDepositDetailsVm.action = "effectiveInterestRatefd";
				} else {
					fixedDepositDetailsVm.action = "effectiveInterestRateTsfd"
				}
				fixedDepositDetailsVm.getInfomessageerate(fixedDepositDetailsVm, $event);

			};

			fixedDepositDetailsVm.infoPopupAmt = function ($event) {
				if (!fixedDepositDetailsVm.isTaxable) {
					fixedDepositDetailsVm.action = "amountToSavefd";
				} else {
					fixedDepositDetailsVm.action = "amountToSaveTsfd"
				}
				fixedDepositDetailsVm.getInfomessageerateAmt(fixedDepositDetailsVm, $event);

			};

			fixedDepositDetailsVm.closePopover = function () {
				$scope.popover.hide();
			};

			fixedDepositDetailsVm.createFDReceiptPayload = function (isDownload) {
				return {
					"amount": fixedDepositDetailsVm.personalDetails.principalAmount,
					"name": fixedDepositDetailsVm.personalDetails.name,
					"email": "",
					"fdAccountNumber": fixedDepositDetailsVm.personalDetails.fdNumber,
					"taxSaverFlag": fixedDepositDetailsVm.personalDetails.taxSaverFlag,
					"tenureDuration": fixedDepositDetailsVm.personalDetails.tenureDuration == null ? "" : fixedDepositDetailsVm.personalDetails.tenureDuration,
					"maturityDate": fixedDepositDetailsVm.personalDetails.maturityDate,
					"maturityAmount": fixedDepositDetailsVm.personalDetails.maturityAmount,
					"maturityInstruction": fixedDepositDetailsVm.personalDetails.maturityInstruction == null ? "" : fixedDepositDetailsVm.personalDetails.maturityInstruction,
					"interestRate": fixedDepositDetailsVm.personalDetails.interestRate,
					"interestPayout": fixedDepositDetailsVm.personalDetails.interestPayout.trim(),
					"startDate": fixedDepositService.customer.startDate,
					"endDate": fixedDepositDetailsVm.personalDetails.maturityDate,
					"branchCode": fixedDepositService.customer.branchCode,
					"branchName": fixedDepositService.customer.branchName == null ? "" : fixedDepositService.customer.branchName,
					"debitAccountNumber": "",
					"isDownload": isDownload.toString(),
					"modeOfOperation": fixedDepositService.customer.modeOfOperation,
					"scheme": fixedDepositService.customer.scheme,
					"mobile": "",
					"dob": "",
					"cif": "",
					"nomineeName": fixedDepositService.customer.nominee
				};
			}

			fixedDepositDetailsVm.receiptDownload = function () {
				fixedDepositDetailsVm.downloadLoader = true;
				var requestParams = fixedDepositDetailsVm.createFDReceiptPayload(true);
				fixedDepositClosureService.fetchFdReceipt(requestParams).then(function (data) {
					fixedDepositDetailsVm.downloadLoader = false;
					var content = data.documentData;
					var fileName = data.documentTitle + '.pdf';
					pwdProtectedPdfDownloadService.savePDF(fileName, content, "").then(function(response){
						pwdProtectedPdfDownloadService.pwdCommonTemplate();	
					},function error(e){
						utilityService.showErrorMessage(e);
					});
				}, function (error) {
					fixedDepositDetailsVm.downloadLoader = false;
					var msg = '<div class="font-size-16 roboto-medium">'+error.responseMessage+'</div>'
					utilityService.showBhimUpiAlert("info", msg, "", "OK", $scope);
				});
			};

			fixedDepositDetailsVm.receiptEmail = function () {
				fixedDepositDetailsVm.mailLoader = true;
				var requestParams = fixedDepositDetailsVm.createFDReceiptPayload(false);
				fixedDepositClosureService.fetchFdReceipt(requestParams).then(function (data) {
					var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="">Mail has been sent to your registered email id.</div>';
					fixedDepositDetailsVm.emailPopup = $ionicPopup.show({
						title: '',
						template: template,
						cssClass: 'my-custom-popup',
						buttons: [{
							text: 'OK',
							type: 'button-assertive',
							onTap: function () {
								fixedDepositDetailsVm.emailPopup.close();
							}
						}],
					});
					fixedDepositDetailsVm.mailLoader = false;
				}, function (error) {
					fixedDepositDetailsVm.mailLoader = false;
					var msg = '<div class="font-size-16 roboto-medium">'+error.responseMessage+'</div>'
					utilityService.showBhimUpiAlert("info", msg, "", "OK", $scope);
					
				});
			};

			fixedDepositDetailsVm.nomineeInfo = function () {
				var title = '';
				var onTap = 'menu.fixedDepositDetails';
				var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey">{{fixedDepositDetailsVm.nonominee}}</div>';
				fixedDepositService.showAlertModal(title, template, onTap, $scope, $state);
			}

			fixedDepositDetailsVm.goTOAvailOD = function () {

				//Errors added as per the new BRS - DM2021129686

				if(fixedDepositDetailsVm.isTaxable !== "" && fixedDepositDetailsVm.isTaxable !== "undefined" && fixedDepositDetailsVm.isTaxable !== "null" && 
				fixedDepositDetailsVm.isMod !== "" && fixedDepositDetailsVm.isMod !== "undefined" && fixedDepositDetailsVm.isMod !== "null" && 
				fixedDepositService.customer.modeOfOperation !== "" && fixedDepositService.customer.modeOfOperation  !== "undefined" && fixedDepositService.customer.modeOfOperation !== "null" &&
				fixedDepositDetailsVm.showLA !== "" && fixedDepositDetailsVm.showLA  !== "undefined" && fixedDepositDetailsVm.showLA !== "null" && 
				fixedDepositDetailsVm.personalDetails.principalAmount !== "" && fixedDepositDetailsVm.personalDetails.principalAmount !== "undefined" && fixedDepositDetailsVm.personalDetails.principalAmount !== "null" 
				&& fixedDepositDetailsVm.personalDetails.fdClosureLimit !== "" && fixedDepositDetailsVm.personalDetails.fdClosureLimit !== "undefined" 
				&& fixedDepositDetailsVm.personalDetails.fdClosureLimit !== "null")
				{

					fixedDepositDetailsVm.totalErrorCountOD = 0;
					if(fixedDepositDetailsVm.isTaxable || fixedDepositService.customer.modeOfOperation !== "OWN" || fixedDepositDetailsVm.showLA || fixedDepositDetailsVm.isMod){
					

						if(fixedDepositDetailsVm.isTaxable){
							fixedDepositDetailsVm.totalErrorCountOD++;
						}
						if(fixedDepositService.customer.modeOfOperation !== "OWN"){
							fixedDepositDetailsVm.totalErrorCountOD++;
							fixedDepositDetailsVm.modoperationNotJoin = true;
						}
						
						if(fixedDepositDetailsVm.showLA){
							fixedDepositDetailsVm.totalErrorCountOD++;
						}
								
						if(fixedDepositDetailsVm.isMod){
							fixedDepositDetailsVm.totalErrorCountOD++;
						}
						
						
					}

					var prinAmount = parseInt(fixedDepositDetailsVm.personalDetails.principalAmount);
					var fdclosureLimitval = parseInt(fixedDepositDetailsVm.personalDetails.fdClosureLimit);

					if(prinAmount <  fdclosureLimitval){
						fixedDepositDetailsVm.totalErrorCountOD++;
						fixedDepositDetailsVm.failDueToFDClosure = true;
						
						
					}

					if(fixedDepositDetailsVm.totalErrorCountOD !== "" && fixedDepositDetailsVm.totalErrorCountOD !== "undefined" && fixedDepositDetailsVm.totalErrorCountOD !== "null"){
					
						if(fixedDepositDetailsVm.totalErrorCountOD == 0)
						{
							fixedDepositDetailsVm.availODNotAllowedPopUp = false;
							fixedDepositService.selectedDetails = {
								accountType: '',
								accountNumber: '',
								accountBalance: '',
								isActive: '',
								isTransactional: '',
								branchCode: '',
								branchName: '',
								intCategory: '',
								accountTypeCode: ''
							};
							fixedDepositService.customer.indexId = 0;
							fixedDepositService.customer.AODclick = "detailsfd";
							if (fixedDepositDetailsVm.cancelPopupName) {
								fixedDepositDetailsVm.cancelPopupName.close();
							}
							if(!fixedDepositDetailsVm.isAvailOD) //avail od change if condition
							{ 
							utilityService.showErrorMessage(fixedDepositDetailsVm.availODMessage);
							}
							else
							{
								$state.go('menu.overdraft');
							}

						}
						if(fixedDepositDetailsVm.totalErrorCountOD == 1)
						{
							fixedDepositDetailsVm.ODErrorCSS = 'app-footer app-footer-loginbanner bar bar-footer border-radius-top-left-right heightCountOne';
							fixedDepositDetailsVm.availODNotAllowedPopUp = true;
							$scope.showDrawer();

						}
						if(fixedDepositDetailsVm.totalErrorCountOD == 2)
						{
							fixedDepositDetailsVm.ODErrorCSS = 'app-footer app-footer-loginbanner bar bar-footer border-radius-top-left-right heightCountTwo';
							fixedDepositDetailsVm.availODNotAllowedPopUp = true;
							$scope.showDrawer();
						}
						if(fixedDepositDetailsVm.totalErrorCountOD == 3)
						{
							fixedDepositDetailsVm.ODErrorCSS = 'app-footer app-footer-loginbanner bar bar-footer border-radius-top-left-right heightCountThree';
							fixedDepositDetailsVm.availODNotAllowedPopUp = true;
							$scope.showDrawer();
						}
						if(fixedDepositDetailsVm.totalErrorCountOD == 4)
						{
							fixedDepositDetailsVm.ODErrorCSS = 'app-footer app-footer-loginbanner bar bar-footer border-radius-top-left-right heightCountFour';
							fixedDepositDetailsVm.availODNotAllowedPopUp = true;
							$scope.showDrawer();
						}
						if(fixedDepositDetailsVm.totalErrorCountOD == 5)
						{
							fixedDepositDetailsVm.ODErrorCSS = 'app-footer app-footer-loginbanner bar bar-footer border-radius-top-left-right heightCountFive';
							fixedDepositDetailsVm.availODNotAllowedPopUp = true;
							$scope.showDrawer();
						}

						
					}

				}

			}

			fixedDepositDetailsVm.editnominee = function () {
				fixedDepositService.customer.nomineeClick = "detailsfd";
				//night mode implementation for nominee details
				fixedDepositDetailsVm.reviewFD = {
					"account": fixedDepositDetailsVm.account,
					"branchCode": fixedDepositService.customer.branchCode
				};
				if (!fixedDepositDetailsVm.nightMode) {
					if (fixedDepositService.customer.nominee.trim() == "") {
						utilityService.showSpinner();
						reviewFDService.getNomineeDetails(fixedDepositDetailsVm.reviewFD).then(function (response) {
							fixedDepositService.customer.showNominee = utilityService.getValue(response.hideNominee);
							fixedDepositService.customer.age = utilityService.getValue(response.ageofGuardian);
							fixedDepositService.customer.dob = utilityService.getValue(response.dob);
							fixedDepositService.customer.relation = utilityService.getValue(response.relation);
							fixedDepositService.customer.guardian = utilityService.getValue(response.nomineeGuardian);
							fixedDepositService.customer.address1 = utilityService.getValue(response.address1);
							fixedDepositService.customer.address2 = utilityService.getValue(response.address2);
							fixedDepositService.customer.nominee = utilityService.getValue(response.name);
							utilityService.hideSpinner();
							$state.go('menu.nominee');
						}, function (error) {
							utilityService.hideSpinner();
							utilityService.showErrorMessage(error.responseMessage);
						});
					} else {
						$state.go('menu.nominee');
					}
				}
			}

			fixedDepositDetailsVm.editnomineeclose = function () {
				fixedDepositService.customer.nomineeClick = "closefd";
				$state.go('menu.nominee');
			};

			fixedDepositDetailsVm.goBack = function () {
				fixedDepositService.customer.checkPage = false;
				$state.go("menu.accountOverviewMyBalance");
			};

			fixedDepositDetailsVm.goToAO = function () {
				fixedDepositService.customer.checkPage = false;
				$state.go("menu.accountOverviewMyBalance");
			};

			//Errors added as per the new BRS - DM2021129686
			fixedDepositDetailsVm.closeFD = function(){
				if(fixedDepositDetailsVm.isTaxable !== "" && fixedDepositDetailsVm.isTaxable !== "undefined" && fixedDepositDetailsVm.isTaxable !== "null" && 
				fixedDepositDetailsVm.isMod !== "" && fixedDepositDetailsVm.isMod !== "undefined" && fixedDepositDetailsVm.isMod !== "null" && 
				fixedDepositService.customer.modeOfOperation !== "" && fixedDepositService.customer.modeOfOperation  !== "undefined" && fixedDepositService.customer.modeOfOperation !== "null" &&
				fixedDepositDetailsVm.showLA !== "" && fixedDepositDetailsVm.showLA  !== "undefined" && fixedDepositDetailsVm.showLA !== "null")
				{

					fixedDepositDetailsVm.totalErrorCountFD = 0;
					

					if(fixedDepositDetailsVm.isTaxable || fixedDepositDetailsVm.isMod || fixedDepositService.customer.modeOfOperation !== "OWN" || fixedDepositDetailsVm.showLA){

							if(fixedDepositDetailsVm.isTaxable){
								fixedDepositDetailsVm.totalErrorCountFD++;
								
							}
							if(fixedDepositDetailsVm.isMod){
								fixedDepositDetailsVm.totalErrorCountFD++;
								
							}
							if(fixedDepositService.customer.modeOfOperation !== "OWN"){
								fixedDepositDetailsVm.totalErrorCountFD++;
								fixedDepositDetailsVm.modoperationNotJoin = true;
							}
							if(fixedDepositDetailsVm.showLA){
								fixedDepositDetailsVm.totalErrorCountFD++;
								
							}
					}
					
					if(fixedDepositDetailsVm.totalErrorCountFD !== "" && fixedDepositDetailsVm.totalErrorCountFD !== "undefined" && fixedDepositDetailsVm.totalErrorCountFD !== "null"){
						if(	fixedDepositDetailsVm.totalErrorCountFD == 0){
							fixedDepositDetailsVm.closeFDNotAllowedPopUp = false;
							
								var fdNumber = fixedDepositDetailsVm.personalDetails.fdNumber;
								fixedDepositClosureService.fdClosureCheckBranch(fdNumber).then(function (data) {

									
									fixedDepositDetailsVm.closeFDSubmit();
								},
								function(error){
									
									utilityService.showErrorMessage(error.responseMessage);
								});
						

						}
						if(fixedDepositDetailsVm.totalErrorCountFD == 1)
						{
							fixedDepositDetailsVm.FDErrorCSS = 'app-footer app-footer-loginbanner bar bar-footer border-radius-top-left-right heightCountOne';
							fixedDepositDetailsVm.closeFDNotAllowedPopUp = true;
							$scope.showDrawer();
						}
						if(fixedDepositDetailsVm.totalErrorCountFD == 2)
						{
							fixedDepositDetailsVm.FDErrorCSS = 'app-footer app-footer-loginbanner bar bar-footer border-radius-top-left-right heightCountTwo';
							fixedDepositDetailsVm.closeFDNotAllowedPopUp = true;
							$scope.showDrawer();
						}
						if(fixedDepositDetailsVm.totalErrorCountFD == 3)
						{
							fixedDepositDetailsVm.FDErrorCSS = 'app-footer app-footer-loginbanner bar bar-footer border-radius-top-left-right heightCountThree';
							fixedDepositDetailsVm.closeFDNotAllowedPopUp = true;
							$scope.showDrawer();
						}
						if(fixedDepositDetailsVm.totalErrorCountFD == 4)
						{
							fixedDepositDetailsVm.FDErrorCSS = 'app-footer app-footer-loginbanner bar bar-footer border-radius-top-left-right heightCountFour';
							fixedDepositDetailsVm.closeFDNotAllowedPopUp = true;
							$scope.showDrawer();
						}
						
					}


				}
			}
			
			

			$scope.showDrawer=function(){
				$scope.slideDownTrue=false;
				$scope.slideUpTrue=true;
			}


			fixedDepositDetailsVm.OKCloseClosureMsgPopUp = function(){

				if(fixedDepositDetailsVm.closeFDNotAllowedPopUp){
				fixedDepositDetailsVm.closeFDNotAllowedPopUp = false;
				}
				else if(fixedDepositDetailsVm.availODNotAllowedPopUp){
				fixedDepositDetailsVm.availODNotAllowedPopUp = false;
				}
				$scope.hideDrawer();
			}


			$scope.hideDrawer=function(){
			  $scope.slideUpTrue=false;
			  $scope.slideDownTrue=true;
			}


			fixedDepositDetailsVm.closeFDSubmit = function () {
				fixedDepositDetailsVm.moduleName = "FixedDeposit";
				fixedDepositDetailsVm.actionName = "FDPREMATURECLOSUREENQ";
				fixedDepositService.fetchNightModeStatus(fixedDepositDetailsVm, true).then(function (data) {
					if (!(data.nightMode == "Y" ? true : false)) {
						fixedDepositDetailsVm.closefdDate = fixedDepositDetailsVm.personalDetails.maturityDate;
						fixedDepositDetailsVm.closefdDate = new Date();
						var year, month, days;
						year = fixedDepositDetailsVm.closefdDate.getFullYear();
						month = fixedDepositDetailsVm.closefdDate.getMonth() + 1;
						days = fixedDepositDetailsVm.closefdDate.getDate();
						if (month <= 9) {
							month = "0" + month;
						}
						if (days <= 9) {
							days = "0" + days;
						}
						fixedDepositDetailsVm.closefdDate = "" + days + month + year;
						fixedDepositDetailsVm.reviewFD = {
							"account": fixedDepositDetailsVm.account,
							"branchCode": fixedDepositService.customer.branchCode
						};
						fixedDepositClosureService.FDprematureClosure(fixedDepositDetailsVm.reviewFD, fixedDepositDetailsVm).then(function (data) {
							if (!utilityService.isUndefined(data)) {
								fixedDepositService.customer.amountCredited = data.amountCredited;
								fixedDepositService.customer.effectiveInterestRates = data.effectiveInterestRates;
								fixedDepositDetailsVm.withloan = '<div class="button_fund fontSize-subHeading roboto-light font-dark-grey">{{fixedDepositDetailsVm.closefd}}</div><div class="FDpopup-styling fontSize-subHeading roboto-light font-dark-grey"><a id="APLY_PL_ANC" click-stream="click" class="noUnderline font-link-blue" href="javascript:void(0)" translate="CONFIRMCLOSE" ng-click="fixedDepositDetailsVm.applyPL()"></div>';
								fixedDepositDetailsVm.withoutloan = '<div class="button_fund fontSize-subHeading roboto-light font-dark-grey">{{fixedDepositDetailsVm.closefd}}</div>';
								fixedDepositDetailsVm.withODlink = '<div class="button_fund fontSize-subHeading roboto-light font-dark-grey">{{fixedDepositDetailsVm.closefd}}</div><div class="FDpopup-styling fontSize-subHeading roboto-light font-dark-grey"><a id="APLY_OD_ANC" click-stream="click" class="noUnderline font-link-blue" href="javascript:void(0)" translate="APPLYOD" ng-click="fixedDepositDetailsVm.goTOAvailOD()"></div>';
								fixedDepositService.customer.fdCloseClick = utilityService.getRandomNumber();
								clickStreamService.clickStreamData = fixedDepositService.customer.fdCloseClick;
								if (fixedDepositDetailsVm.disableAvailODBtn) {
									if (fixedDepositService.customer.preApprovedLoanAmount !== undefined && fixedDepositService.customer.preApprovedLoanAmount !== null && fixedDepositService.customer.preApprovedLoanAmount !== "") {
										fixedDepositDetailsVm.preApprovedLoanAmount = parseInt(fixedDepositService.customer.preApprovedLoanAmount);
										if (fixedDepositDetailsVm.preApprovedLoanAmount > 0) {
											fixedDepositDetailsVm.closemessage = fixedDepositDetailsVm.withloan;
										} else {
											fixedDepositDetailsVm.closemessage = fixedDepositDetailsVm.withoutloan;
										}
									} else {
										fixedDepositDetailsVm.closemessage = fixedDepositDetailsVm.withoutloan;
									}
								} else {
									fixedDepositDetailsVm.closemessage = fixedDepositDetailsVm.withODlink;
								}

								fixedDepositDetailsVm.cancelPopupName = $ionicPopup.show({
									title: "",
									cssClass: 'my-custom-popup',
									template: fixedDepositDetailsVm.closemessage,
									scope: $scope,
									buttons: [
										{
											text: 'OK',
											type: 'button-assertive',
											onTap: function () {
												fixedDepositDetailsVm.cancelPopupName.close();
												fixedDepositService.customer.checkPage = true;
												$state.go('menu.fixedDepositClosure');
											}
										},
										{
											text: 'Cancel',
											type: 'button-assertive',
											onTap: function () {
												fixedDepositDetailsVm.cancelPopupName.close();
											}
										}
									],
								});
							}
						}, function (error) {
							utilityService.showErrorMessage(error.responseMessage);
						});
					} else {
						fixedDepositDetailsVm.cancelPopupName = $ionicPopup.show({
							title: "",
							cssClass: 'my-custom-popup',
							template: '<div class="button_fund fontSize-subHeading roboto-light font-dark-grey">{{fixedDepositDetailsVm.closefd}}</div>',
							scope: $scope,
							buttons: [
								{
									text: 'OK',
									type: 'button-assertive',
									onTap: function () {
										fixedDepositDetailsVm.cancelPopupName.close();
										fixedDepositService.customer.checkPage = true;
										$state.go('menu.fixedDepositClosure');
									}
								},
								{
									text: 'Cancel',
									type: 'button-assertive',
									onTap: function () {
										fixedDepositDetailsVm.cancelPopupName.close();
									}
								}
							],
						});
					}

				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}


			fixedDepositDetailsVm.applyPL = function () {
				personalLoanService.clearAll();
				personalLoanService.getLoanDetails().then(function (data) {

					personalLoanService.personalLoanData = data;
					personalLoanService.minDuration = data.minTenure;
					personalLoanService.maxDuration = data.maxTenure;
					personalLoanService.interestRate = data.interestRate;
					personalLoanService.product = data.productCode;
					personalLoanService.maxEmiLimit = data.maxPermissibleEMI;
					personalLoanService.processingFee = data.processingFee;
					personalLoanService.minBestOffer = data.minPalAmount;
					personalLoanService.activityCode = data.activityCode;
					personalLoanService.schemeCode = data.schemeCode;
					if (fixedDepositDetailsVm.cancelPopupName) {
						fixedDepositDetailsVm.cancelPopupName.close();
					}
					$state.go('menu.personalLoan');

				}, function (error) {
					if (fixedDepositDetailsVm.cancelPopupName) {
						fixedDepositDetailsVm.cancelPopupName.close();
					}
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			fixedDepositDetailsVm.confirmClosureFD = function () {
				if ( ($state.current.url != "/fixedDepositClosure") && 
				    (getAccountDetailsService.accessRightsData.accounts == null || 
				    	getAccountDetailsService.accessRightsData.accounts == "")) {
					fixedDepositDetailsVm.confirmclose = true;
					fixedDepositDetailsVm.isValidAccount = true;
					fixedDepositDetailsVm.validAccountMessage = fixedDepositDetailsVm.fetchTransRights;
				} else {
					var isAccountTransactional = false;
					for (var i in getAccountDetailsService.accessRightsData.accounts) {
						if (getAccountDetailsService.accessRightsData.accounts[i].accountNumber === fixedDepositService.selectedDetails.accountNumber && parseInt(getAccountDetailsService.accessRightsData.accounts[i].accessResponse) != 0) {
							isAccountTransactional = true;
						}
					}
					if (isAccountTransactional || ($state.current.url == "/fixedDepositClosure") ) {
						fixedDepositService.customer.checkPage = false;
						fixedDepositDetailsVm.reviewFD = {
							account: fixedDepositDetailsVm.account,
							creditAc: fixedDepositDetailsVm.selectedAccountNumber,
							amountCredited: fixedDepositService.customer.amountCredited,
							branchCode: fixedDepositService.customer.branchCode
						};
						var fdParams = {
							isMod : fixedDepositDetailsVm.isMod,
							fdNumber: fixedDepositDetailsVm.personalDetails.fdNumber,
							selectedAccountNumber: fixedDepositDetailsVm.selectedAccountNumber,
							amountCredited: fixedDepositDetailsVm.closeDetails.amountCredited
						};
						$state.go('menu.closeDepositOTP',{depositObject: {depositType: 'fdClosure',closureParams: fixedDepositDetailsVm.reviewFD,fdParams:fdParams}});						
					} else {
						fixedDepositDetailsVm.confirmclose = true;
						fixedDepositDetailsVm.isValidAccount = true;
						fixedDepositDetailsVm.validAccountMessage = fixedDepositDetailsVm.accTransRights;
					}
				}
			}

			fixedDepositDetailsVm.cancelClosureFD = function () {
				$state.go('menu.fixedDepositDetails');
			}

			fixedDepositDetailsVm.fetchNomineeDetails = function () {
				fixedDepositDetailsVm.reviewFD = {
					"account": fixedDepositDetailsVm.account,
					"branchCode": fixedDepositService.customer.branchCode
				};
				if (!fixedDepositDetailsVm.nightMode) {
					reviewFDService.getNomineeDetails(fixedDepositDetailsVm.reviewFD).then(function (response) {
						fixedDepositService.customer.showNominee = utilityService.getValue(response.hideNominee);
						fixedDepositService.customer.age = utilityService.getValue(response.ageofGuardian);
						fixedDepositService.customer.dob = utilityService.getValue(response.dob);
						fixedDepositService.customer.relation = utilityService.getValue(response.relation);
						fixedDepositService.customer.guardian = utilityService.getValue(response.nomineeGuardian);
						fixedDepositService.customer.address1 = utilityService.getValue(response.address1);
						fixedDepositService.customer.address2 = utilityService.getValue(response.address2);
						fixedDepositService.customer.nominee = utilityService.getValue(response.name);
					}, function (error) {
					});
				}
			}

			fixedDepositDetailsVm.fetchFDAccountDetails = function () {
				fixedDepositDetailsVm.reviewFD = {
					"account": fixedDepositDetailsVm.account,
					"lien": fixedDepositService.customer.lienAmount != "0" ? "true" : "false",
					"operational": fixedDepositService.customer.modeOfOperation,
					"branchCode": fixedDepositService.customer.branchCode
				};
				fixedDepositClosureService.fetchFDAccountDetails(fixedDepositDetailsVm.reviewFD).then(function (response) {
					fixedDepositDetailsVm.isFDDetailsAvailable = true;
					fixedDepositDetailsVm.personalDetails = response;
					fixedDepositDetailsVm.personalDetails.currency = getAccountDetailsService.currency ;
					//fixedDepositDetailsVm.canEditMaturityInstruction = response.matFlag;
					fixedDepositDetailsVm.eyesOffFun(fixedDepositDetailsVm.personalDetails.fdNumber);
					if(fixedDepositDetailsVm.personalDetails.maturityInstruction == null){
						fixedDepositDetailsVm.personalDetails.maturityInstructionText = "";
					}
					if(fixedDepositDetailsVm.personalDetails.maturityInstruction == "A"){
						fixedDepositDetailsVm.personalDetails.maturityInstructionText = "Auto Renewal";
					}
					if(fixedDepositDetailsVm.personalDetails.maturityInstruction == "B"){
						fixedDepositDetailsVm.personalDetails.maturityInstructionText = "Renew Principal and Repay Interest";
					}
					if(fixedDepositDetailsVm.personalDetails.maturityInstruction == "C"){
						fixedDepositDetailsVm.personalDetails.maturityInstructionText = "Credit to Account";
					}
					if(fixedDepositDetailsVm.personalDetails.maturityInstruction == "D"){
						fixedDepositDetailsVm.personalDetails.maturityInstructionText = "Default";
					}
					fixedDepositDetailsVm.isTaxable = response.taxSaverFlag;
					fixedDepositDetailsVm.isAvailOD = fixedDepositDetailsVm.personalDetails.isAvailOD;
					fixedDepositDetailsVm.isCloseFD = fixedDepositDetailsVm.personalDetails.isCloseFD;
					if (fixedDepositDetailsVm.personalDetails.isModPmryEligible) {
						fixedDepositDetailsVm.isModOrPmryFD = fixedDepositDetailsVm.personalDetails.isModPmryEligible.toLowerCase() == "true" ? true : false;
					} else {
						fixedDepositDetailsVm.isModOrPmryFD = false;
					}
					fixedDepositService.customer.fdnumber = fixedDepositDetailsVm.personalDetails.fdNumber;
					fixedDepositService.customer.product = fixedDepositDetailsVm.personalDetails.product;
					fixedDepositService.customer.principalAmount = fixedDepositDetailsVm.personalDetails.principalAmount;
					fixedDepositService.customer.maturityAmount = fixedDepositDetailsVm.personalDetails.maturityAmount;
					fixedDepositService.customer.ODLimit = fixedDepositDetailsVm.personalDetails.odLimit;
					fixedDepositService.customer.ODIntRate = fixedDepositDetailsVm.personalDetails.odInterestRate;
					fixedDepositService.customer.ODExyDate = fixedDepositDetailsVm.personalDetails.odExpiryDate;
					fixedDepositDetailsVm.personalDetails.lienAmount = fixedDepositService.customer.lienAmount;
					


					fixedDepositService.customer.debitAccountNumber = fixedDepositDetailsVm.personalDetails.debitAccountNumber;
					changeMaturityService.transferAccountNumber = fixedDepositDetailsVm.personalDetails.debitAccountNumber;
					fixedDepositService.customer.isAvailOD = fixedDepositDetailsVm.personalDetails.isAvailOD;
					fixedDepositService.customer.isCloseFD = fixedDepositDetailsVm.personalDetails.isCloseFD;
					fixedDepositService.customer.effectiveIE = fixedDepositDetailsVm.personalDetails.effectiveIE;
					fixedDepositService.customer.custName = fixedDepositDetailsVm.personalDetails.name;
					fixedDepositService.customer.interestPayout = fixedDepositDetailsVm.personalDetails.interestPayout;
					fixedDepositService.customer.maturityDate = fixedDepositDetailsVm.personalDetails.maturityDate;
					changeMaturityService.maturityDate = fixedDepositDetailsVm.personalDetails.maturityDate;
					if (fixedDepositDetailsVm.personalDetails.lienAmount !== undefined && fixedDepositDetailsVm.personalDetails.lienAmount !== "" && fixedDepositDetailsVm.personalDetails.lienAmount !== null) {
						fixedDepositDetailsVm.LM = parseInt(fixedDepositDetailsVm.personalDetails.lienAmount);
						if (fixedDepositDetailsVm.LM > 0) {
							fixedDepositDetailsVm.showLA = true;
						} else {
							fixedDepositDetailsVm.showLA = false;
						}
					} else {
						fixedDepositDetailsVm.showLA = false;
					}
					if (!fixedDepositDetailsVm.isModOrPmryFD) {
						if (fixedDepositDetailsVm.isTaxable) {
							var newCustDate = fixedDepositDetailsVm.startDatePrint.split(" ");
							var todayDate = new Date();
							var getYear = parseInt(newCustDate[2]);
							var getMonth = newCustDate[1];
							var month = ["JAN", "FEB", "MAR", "APR", "MAY", "JUN", "JUL", "AUG", "SEP", "OCT", "NOV", "DEC"];
							for (var i = 1; i <= month.length; i++) {
								if (month[i] === getMonth) {
									var getNewMonth = i;
								}
							}
							var getDay = parseInt(newCustDate[0]);
							newCustDate = new Date(getYear, getNewMonth, getDay, 0, 0, 0);
							var newAge = (todayDate - newCustDate) / (1000 * 60 * 60 * 24 * 365);
							newAge = parseInt(newAge);
							if (newAge < 5) {
								fixedDepositDetailsVm.disableCloseFDBtn = true;
							} else {
								fixedDepositDetailsVm.disableCloseFDBtn = false;
							}
						} else {
							if (fixedDepositDetailsVm.isCloseFD && !fixedDepositDetailsVm.showLA) {
								fixedDepositDetailsVm.disableCloseFDBtn = false;
								fixedDepositDetailsVm.disableDueToLien = false;
							} else {
								fixedDepositDetailsVm.disableCloseFDBtn = true;
								fixedDepositDetailsVm.disableDueToLien = true;
							}
						}
						if (fixedDepositDetailsVm.isAvailOD && !fixedDepositDetailsVm.isTaxable && !fixedDepositDetailsVm.showLA) {
							fixedDepositDetailsVm.disableAvailODBtn = false;
						} else {
							fixedDepositDetailsVm.disableAvailODBtn = true;
						}
					} else {
						fixedDepositDetailsVm.disableAvailODBtn = false;
						fixedDepositDetailsVm.disableCloseFDBtn = false;
					}
					fixedDepositDetailsVm.fetchNomineeDetails();
					utilityService.hideSpinner();
				}, function (error) {
					fixedDepositDetailsVm.isFDDetailsAvailable = false;
					fixedDepositDetailsVm.disableCloseFDBtn = true;
					fixedDepositDetailsVm.disableAvailODBtn = true;
					fixedDepositDetailsVm.nightMode = true;
					utilityService.hideSpinner();
					utilityService.showErrorMessage(error.responseMessage);
				});
			}
			fixedDepositDetailsVm.changeMaturity = function () {
				$ionicHistory.clearCache().then(function(){
					fixedDepositService.customer.years = "";
					fixedDepositService.customer.months = "";
					fixedDepositService.customer.days = "";
					$state.go('menu.FDChangeMaturity');
				});
				
			};
			fixedDepositDetailsVm.editMaturity = function(){
				var obj = {
	  						//"cif": "string",
		  					// "fdAccountNumber": fixedDepositDetailsVm.account,
		  					// "branchCode": fixedDepositService.customer.branchCode,
		  					// "lien": fixedDepositService.customer.lienAmount != "0" ? "true" : "false",
		  					// "operational": fixedDepositService.customer.modeOfOperation,
		  					//"accountTypeCode": "string",
	  						//"intCategory": "string"
					}
					changeMaturityService.getMaturityInstDetail(obj).then(function (data) {
					fixedDepositDetailsVm.maturityInstLoaded = true;
					fixedDepositDetailsVm.canEditMaturityInstruction = data.matFlag;
					fixedDepositDetailsVm.personalDetails.maturityInstruction = data.maturityInstruction;
					if(fixedDepositDetailsVm.personalDetails.maturityInstruction == null){
						fixedDepositDetailsVm.personalDetails.maturityInstructionText = "";
					}
					if(fixedDepositDetailsVm.personalDetails.maturityInstruction == "A"){
						fixedDepositDetailsVm.personalDetails.maturityInstructionText = "Auto Renewal";
					}
					if(fixedDepositDetailsVm.personalDetails.maturityInstruction == "B"){
						fixedDepositDetailsVm.personalDetails.maturityInstructionText = "Renew Principal and Repay Interest";
					}
					if(fixedDepositDetailsVm.personalDetails.maturityInstruction == "C"){
						fixedDepositDetailsVm.personalDetails.maturityInstructionText = "Credit to Account";
					}
					if(fixedDepositDetailsVm.personalDetails.maturityInstruction == "D"){
						fixedDepositDetailsVm.personalDetails.maturityInstructionText = "Default";
					}
				}, function (error) {
					fixedDepositDetailsVm.maturityInstLoaded = false;
					fixedDepositDetailsVm.canEditMaturityInstruction = false;
					utilityService.showErrorMessage(error.responseMessage);
				});
			};

			$scope.$on('$ionicView.loaded', function () {
				initPage();
				fixedDepositDetailsVm.account = fixedDepositService.customer.fdAccountNumber;
				fixedDepositDetailsVm.moduleName = "FixedDeposit";
				fixedDepositDetailsVm.actionName = ($state.current.url == "/fixedDepositClosure") ? "FDPREMATURECLOSUREENQ" : "NomineeDetails";
				utilityService.showSpinner();
				fixedDepositService.fetchNightModeStatus(fixedDepositDetailsVm, false).then(function (data) {
					fixedDepositDetailsVm.nightMode = data.nightMode == "Y" ? true : false;
					fixedDepositDetailsVm.fetchFDAccountDetails();
				}, function (error) {
					utilityService.hideSpinner();
					utilityService.showErrorMessage(error.responseMessage);
				});
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				$scope.slideUpTrue=false; 
				$scope.slideDownTrue=true; 
				fixedDepositDetailsVm.canEditMaturityInstruction = "false";
				fixedDepositDetailsVm.maturityInstLoaded = false;
				if(!fixedDepositDetailsVm.startDatePrint){
					fixedDepositDetailsVm.startDatePrint = "";
				}
				if (fixedDepositService.customer.checkPage) {
					fixedDepositDetailsVm.closeDetails.amountCredited = utilityService.getValue(fixedDepositService.customer.amountCredited);
					fixedDepositDetailsVm.closeDetails.effectiveInterestRates = utilityService.getValue(fixedDepositService.customer.effectiveInterestRates);
					fixedDepositDetailsVm.startDatePrint = fixedDepositService.customer.startDate;
					fixedDepositDetailsVm.accDetails = fixedDepositService.accDetails;
					fixedDepositDetailsVm.accDetails.forEach(function (accDetail) {
						if (accDetail.accountType === "Savings Account") {
							accDetail.accountType = "Savings A/c";
						} else if (accDetail.accountType === "Current Account") {
							accDetail.accountType = "Current A/c";
						}
						else if (accDetail.accountType === "Overdraft Account") {
							accDetail.accountType = "Overdraft A/c";
						}
					});
					if (fixedDepositService.selectedDetails.accountType === '') {
						fixedDepositDetailsVm.selectedValue = fixedDepositDetailsVm.accDetails[0].accountType + "," + fixedDepositDetailsVm.accDetails[0].accountNumber + "," + fixedDepositDetailsVm.accDetails[0].accountBalance + "," + fixedDepositDetailsVm.accDetails[0].isActive + "," + fixedDepositDetailsVm.accDetails[0].isTransactional + ",0";
						fixedDepositDetailsVm.indexId = 0;
						fixedDepositDetailsVm.isActive = fixedDepositDetailsVm.accDetails[0].isActive;
						fixedDepositDetailsVm.isTransactional = fixedDepositDetailsVm.accDetails[0].isTransactional;
						fixedDepositService.customer.selectedItem = fixedDepositDetailsVm.accDetails[0].accountNumber;
						fixedDepositDetailsVm.selectedAccountType = fixedDepositDetailsVm.accDetails[0].accountType;
						fixedDepositDetailsVm.selectedAccountNumber = fixedDepositDetailsVm.accDetails[0].accountNumber;
						fixedDepositService.selectedDetails.accountType = fixedDepositDetailsVm.selectedAccountType;
						fixedDepositService.selectedDetails.accountNumber = fixedDepositDetailsVm.selectedAccountNumber;
						var title = '';
						var onTap = '';
						if (fixedDepositDetailsVm.isActive === false) {
							fixedDepositDetailsVm.confirmclose = true;
							var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="SELECT_ACTIVE_ACC"></div><div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="ACTIVE_OR"></div><div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="CONTACT_NEAREST"></div>';
							fixedDepositService.showAlertModal(title, template, onTap, $scope, $state);
						}

						if (fixedDepositDetailsVm.isTransactional === false) {
							fixedDepositDetailsVm.confirmclose = true;
							var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="USE_TRANS_RIGHTS"></div>';
							fixedDepositService.showAlertModal(title, template, onTap, $scope, $state);
						}

						if (fixedDepositDetailsVm.isActive && fixedDepositDetailsVm.isTransactional) {
							fixedDepositDetailsVm.confirmclose = false;
						}
					} else {
						fixedDepositDetailsVm.indexId = fixedDepositService.customer.indexId;
						fixedDepositDetailsVm.selectedAccountType = fixedDepositService.selectedDetails.accountType;
						fixedDepositDetailsVm.selectedAccountNumber = fixedDepositService.selectedDetails.accountNumber;
						fixedDepositDetailsVm.selectedAccountAmount = fixedDepositService.selectedDetails.accountBalance;
						fixedDepositDetailsVm.selectedAccountisActive = fixedDepositService.selectedDetails.isActive;
						fixedDepositDetailsVm.selectedAccountisTransactional = fixedDepositService.selectedDetails.isTransactional;
						fixedDepositDetailsVm.selectedValue = fixedDepositDetailsVm.selectedAccountType + "," + fixedDepositDetailsVm.selectedAccountNumber + "," + fixedDepositDetailsVm.selectedAccountAmount + "," + fixedDepositDetailsVm.selectedAccountisActive + "," + fixedDepositDetailsVm.selectedAccountisTransactional + "," + fixedDepositDetailsVm.indexId;
						if (fixedDepositDetailsVm.selectedAccountisActive === "true" && fixedDepositDetailsVm.selectedAccountisTransactional === "true") {
							fixedDepositDetailsVm.confirmclose = false;
						}
					}
				}
			});

			$scope.$on('$ionicView.afterLeave', function () {
				//any cleanup needs to be done here: executes everytime when page is left
			});
			return this;
		}]);
