'use strict';

angularApp.controller('fixedDurationController', 
	["$timeout",
	"$state",
	"$scope",
	"$translate",
	"fixedDepositService",
	"interestrateService",
	"utilityService",
	"customerInfoService",
	function ($timeout,
		$state,
		$scope,
		$translate,
		fixedDepositService,
		interestrateService,
		utilityService,
		customerInfoService) {
	var fixedDurationVm = this;
	function initPage(){
		fixedDurationVm.showBack = true;
		fixedDurationVm.showNext = true;
		fixedDurationVm.disablenext = true;
		fixedDurationVm.isTenureInvalid = false;
		fixedDurationVm.invalidTenureMessage = "";
		$translate(['FIXED_DURATION','FIXED_TENURE','FIXED_YEARS','FIXED_MONTHS','FIXED_DAYS','INTEREST_RATES','FIXED_DEPOSIT','TENURE_LIMIT','TAXTENURE_LIMIT']).then(function (translations) {
			fixedDurationVm.fixedDuration=translations['FIXED_DURATION'];
			fixedDurationVm.fixedTenure=translations['FIXED_TENURE'];
			fixedDurationVm.years  =translations['FIXED_YEARS'];
			fixedDurationVm.months=translations['FIXED_MONTHS'];
			fixedDurationVm.days=translations['FIXED_DAYS'];
			fixedDurationVm.interest =translations['INTEREST_RATES'];
			fixedDurationVm.fdTitle =translations['FIXED_DEPOSIT'];
			fixedDurationVm.tenureLimit =translations['TENURE_LIMIT'];
			fixedDurationVm.taxTenureLimit =translations['TAXTENURE_LIMIT'];
		});
	}
/**
 * calcualte the interest based of no of days (period)
 * @param {angualr service object} fixedDepositService 
 * @param {controller object} fixedDurationVm
 */	
 function getInterestRateValue(fixedDepositService,fixedDurationVm,interestrateService) {
 	var currentDate = new Date(); 
 	var maturityDateFull = fixedDurationVm.maturityDateFull;
 	var timeDiff = Math.abs(maturityDateFull.getTime() - currentDate.getTime());
 	fixedDurationVm.diffDays = Math.ceil(timeDiff / (1000 * 3600 * 24)); 
 	interestrateService.fetchInterestRate(fixedDurationVm).then(function(data){
 		if(data){
 			fixedDurationVm.durationRate=[];
 			for (var i=0;i <data.fdInterestDetails.length;i++){
 				fixedDurationVm.durationRate.push(data.fdInterestDetails[i]);
 			}
 			for(var j=0;j<fixedDurationVm.durationRate.length;j++){
 				if(fixedDurationVm.diffDays >= parseInt(fixedDurationVm.durationRate[j].minTenure) && fixedDurationVm.diffDays <= parseInt(fixedDurationVm.durationRate[j].maxTenure)){
 					fixedDurationVm.interestrate = fixedDurationVm.durationRate[j].interestRate;
 				}
 			}
 		}
 	}, function(error){
		utilityService.showErrorMessage(error.responseMessage);
 	});
 	fixedDepositService.customer.interestRate = fixedDurationVm.interestrate;
 	fixedDepositService.customer.diffDays = fixedDurationVm.diffDays;
 	// fixedDepositService.customer.taxdiffDays = fixedDurationVm.taxdiffDays;

 }

/**
 * calcualte the maturity date based on days,months, years entered
 * @param {angualr service object} fixedDepositService 
 * @param {controller object} fixedDurationVm
 */
 function getMaturityDate(fixedDepositService,fixedDurationVm,interestrateService) {
 	if((!fixedDurationVm.yearsData) && (!fixedDurationVm.monthsData) && (!fixedDurationVm.daysData)){
 		fixedDurationVm.isvalidDays = false;
 		fixedDepositService.customer.isvalidDays = fixedDurationVm.isvalidDays;
 		fixedDurationVm.disablenext = true;
 		fixedDurationVm.newDates ='';
 	} else {
 		fixedDurationVm.isvalidDays = true;
 		fixedDepositService.customer.isvalidDays = fixedDurationVm.isvalidDays;
 		fixedDurationVm.newDates = new Date(); 
 		var millis = Date.parse(fixedDurationVm.newDates);
 		var daysvalue = fixedDepositService.customer.days;
		 if(fixedDepositService.customer.years){
			fixedDurationVm.newDates.setFullYear(fixedDurationVm.newDates.getFullYear() + fixedDepositService.customer.years);
		}
 		if(fixedDepositService.customer.months){
 			fixedDurationVm.newDates.setMonth(fixedDurationVm.newDates.getMonth() + fixedDepositService.customer.months);
 		}
 		if(daysvalue){
			//fixedDurationVm.newDates.setTime(millis  + daysvalue *24*60*60*1000);
			fixedDurationVm.newDates.setDate(fixedDurationVm.newDates.getDate() + daysvalue);
	   }
 	}
 	
 	
 	if(!fixedDurationVm.isTaxable){
 		if(!fixedDurationVm.newDates){
			fixedDurationVm.isTenureInvalid = true;
			fixedDurationVm.invalidTenureMessage = fixedDurationVm.tenureLimit;
 			fixedDurationVm.disablenext = true;
 			fixedDurationVm.maturityDate ="" ;
 			fixedDurationVm.interestrate = "";
 			fixedDurationVm.maturityDateFull = "";
 			fixedDurationVm.isvalidDays = false;
 			fixedDepositService.customer.isvalidDays = fixedDurationVm.isvalidDays;
 			fixedDepositService.customer.maturityDate = fixedDurationVm.maturityDate;
 			fixedDepositService.customer.interestRate = fixedDurationVm.interestrate;
 			fixedDepositService.customer.maturityDateFull = fixedDurationVm.maturityDateFull;
 		} else if (fixedDurationVm.newDates > fixedDurationVm.maxdate || fixedDurationVm.newDates < fixedDurationVm.mindate){
 			if(fixedDurationVm.isvalidDays){
				fixedDurationVm.isTenureInvalid = true;
				fixedDurationVm.invalidTenureMessage = fixedDurationVm.tenureLimit;
 				fixedDurationVm.disablenext = true;
			 }
 			fixedDurationVm.maturityDate ="" ;
 			fixedDurationVm.interestrate = "";
 			fixedDurationVm.maturityDateFull = "";
 			fixedDurationVm.isvalidDays = false;
 			fixedDepositService.customer.isvalidDays = fixedDurationVm.isvalidDays;
 			fixedDepositService.customer.maturityDate = fixedDurationVm.maturityDate;
 			fixedDepositService.customer.interestRate = fixedDurationVm.interestrate;
 			fixedDepositService.customer.maturityDateFull = fixedDurationVm.maturityDateFull;
 		} else {
 			var month = ["JAN", "FEB", "MAR", "APR", "MAY", "JUN","JUL", "AUG", "SEP", "OCT", "NOV", "DEC"];
 			fixedDurationVm.newmaturityDate = fixedDurationVm.newDates;
 			fixedDurationVm.maturityDateFull = fixedDurationVm.newmaturityDate;
 			fixedDepositService.customer.maturityDateFull = fixedDurationVm.maturityDateFull;
			// fixedDurationVm.newDates=new Date(fixedDurationVm.newDates.getTime() - (24*60*60*1000));
			fixedDurationVm.newDates=new Date(fixedDurationVm.newDates.getTime());
 			fixedDurationVm.maturityDate = "" + fixedDurationVm.newDates.getDate() + " " + month[(fixedDurationVm.newDates.getMonth())] +" "+fixedDurationVm.newDates.getFullYear();
 			fixedDepositService.customer.maturityDate = fixedDurationVm.maturityDate;
 			var year, month,days;
 			year = fixedDurationVm.newDates.getFullYear();
 			month = fixedDurationVm.newDates.getMonth()+1;
 			days = fixedDurationVm.newDates.getDate();
 			if(month <= 9){
 				month = "0" + month;
 			}
 			if(days <= 9){
 				days = "0" + days;
 			}
 			fixedDurationVm.maturitydateRequest = ""+days+month+year;
 			fixedDepositService.customer.maturitydateRequest = fixedDurationVm.maturitydateRequest;
			fixedDurationVm.disablenext = false;
			fixedDurationVm.isTenureInvalid = false;
 			getInterestRateValue(fixedDepositService,fixedDurationVm,interestrateService);
 		}
 	}
 	if(fixedDurationVm.isTaxable){
 		if(!fixedDurationVm.newDates){
			fixedDurationVm.isTenureInvalid = true;
			fixedDurationVm.invalidTenureMessage = fixedDurationVm.taxTenureLimit;
 			fixedDurationVm.disablenext = true;
 			fixedDurationVm.maturityDate ="" ;
 			fixedDurationVm.interestrate = "";
 			fixedDurationVm.maturityDateFull = "";
 			fixedDurationVm.isvalidDays = false;
 			fixedDepositService.customer.isvalidDays = fixedDurationVm.isvalidDays;
 			fixedDepositService.customer.maturityDate = fixedDurationVm.maturityDate;
 			fixedDepositService.customer.interestRate = fixedDurationVm.interestrate;
 			fixedDepositService.customer.maturityDateFull = fixedDurationVm.maturityDateFull;
 		} else if (fixedDurationVm.newDates > fixedDurationVm.maxdate || fixedDurationVm.newDates < fixedDurationVm.maxtaxdate){
 			
 			if(fixedDurationVm.isvalidDays){
				fixedDurationVm.isTenureInvalid = true;
				fixedDurationVm.invalidTenureMessage = fixedDurationVm.taxTenureLimit;
 				fixedDurationVm.disablenext = true;
 			}
 			fixedDurationVm.maturityDate ="" ;
 			fixedDurationVm.interestrate = "";
 			fixedDurationVm.maturityDateFull = "";
 			fixedDurationVm.isvalidDays = false;
 			fixedDepositService.customer.isvalidDays = fixedDurationVm.isvalidDays;
 			fixedDepositService.customer.maturityDate = fixedDurationVm.maturityDate;
 			fixedDepositService.customer.interestRate = fixedDurationVm.interestrate;
 			fixedDepositService.customer.maturityDateFull = fixedDurationVm.maturityDateFull;
 		} else {
 			var month = ["JAN", "FEB", "MAR", "APR", "MAY", "JUN","JUL", "AUG", "SEP", "OCT", "NOV", "DEC"];
 			fixedDurationVm.newmaturityDate = fixedDurationVm.newDates;
 			fixedDurationVm.maturityDateFull = fixedDurationVm.newmaturityDate;
 			fixedDepositService.customer.maturityDateFull = fixedDurationVm.maturityDateFull;
			// fixedDurationVm.newDates=new Date(fixedDurationVm.newDates.getTime() - (24*60*60*1000));
			fixedDurationVm.newDates=new Date(fixedDurationVm.newDates.getTime());
 			fixedDurationVm.maturityDate = "" + fixedDurationVm.newDates.getDate() + " " + month[(fixedDurationVm.newDates.getMonth())] +" "+fixedDurationVm.newDates.getFullYear();
 			fixedDepositService.customer.maturityDate = fixedDurationVm.maturityDate;
 			var year, month,days;
 			year = fixedDurationVm.newDates.getFullYear();
 			month = fixedDurationVm.newDates.getMonth()+1;
 			days = fixedDurationVm.newDates.getDate();
 			if(month <= 9){
 				month = "0" + month;
 			}
 			if(days <= 9){
 				days = "0" + days;
 			}
 			fixedDurationVm.maturitydateRequest = ""+days+month+year;
 			fixedDepositService.customer.maturitydateRequest = fixedDurationVm.maturitydateRequest;
 			fixedDurationVm.disablenext = false;
			fixedDurationVm.isTenureInvalid = false;
 			getInterestRateValue(fixedDepositService,fixedDurationVm,interestrateService);
 		}
 	}

 }
	//public functions end
	fixedDurationVm.getYears = function(){
		if(fixedDurationVm.yearsData){
			fixedDurationVm.yearsData = parseInt(fixedDurationVm.yearsData);
		} else {
			fixedDurationVm.yearsData ="";
		}
		fixedDepositService.customer.years = fixedDurationVm.yearsData;
		getMaturityDate(fixedDepositService,fixedDurationVm,interestrateService);
	}

	fixedDurationVm.getMonths = function(){
		if(fixedDurationVm.monthsData){
			fixedDurationVm.monthsData = parseInt(fixedDurationVm.monthsData);
		} else {
			fixedDurationVm.monthsData ="";
		}
		fixedDepositService.customer.months = fixedDurationVm.monthsData;
		getMaturityDate(fixedDepositService,fixedDurationVm,interestrateService);
	}

	fixedDurationVm.getDays = function(){
		if(fixedDurationVm.daysData){
			fixedDurationVm.daysData = parseInt(fixedDurationVm.daysData);
		} else {
			fixedDurationVm.daysData ="";
		}
		fixedDepositService.customer.days = fixedDurationVm.daysData;
		getMaturityDate(fixedDepositService,fixedDurationVm,interestrateService);
	}
	
	fixedDurationVm.goToAO = function(){
		$state.go("menu.accountOverviewMyBalance");
	}
	fixedDurationVm.goBacktoPrevious = function(){
		$state.go('menu.fixedDeposit')
	}

	fixedDurationVm.goToNextPage = function(){
		if(fixedDurationVm.yearsData){
			fixedDurationVm.yearsData = parseInt(fixedDurationVm.yearsData);
		} else {
			fixedDurationVm.yearsData ="";
		}
		fixedDepositService.customer.years = fixedDurationVm.yearsData;
		if(fixedDurationVm.monthsData){
			fixedDurationVm.monthsData = parseInt(fixedDurationVm.monthsData);
		} else {
			fixedDurationVm.monthsData ="";
		}
		fixedDepositService.customer.months = fixedDurationVm.monthsData;
		if(fixedDurationVm.daysData){
			fixedDurationVm.daysData = parseInt(fixedDurationVm.daysData);
		} else {
			fixedDurationVm.daysData ="";
		}
		fixedDepositService.customer.days = fixedDurationVm.daysData;
		getMaturityDate(fixedDepositService,fixedDurationVm,interestrateService);
		$state.go('menu.interestPayout');
		
	}

	fixedDurationVm.getInterestRate = function(){
		$state.go('menu.interestrate')
	}

	$scope.$on('$ionicView.loaded', function() {
		initPage();
	});
	
	$scope.$on('$ionicView.beforeEnter', function() {
		var newDates = new Date(); 
		fixedDurationVm.currentDate = "" + newDates.getDate()  + "/" +(newDates.getMonth()+1) + "/" + newDates.getFullYear();
		newDates.setFullYear(newDates.getFullYear() + 10); 
		newDates.setTime(newDates.getTime() + (1*60*60*1000));
		fixedDurationVm.maxdate = newDates;
		var mindate = new Date();
		var millis = Date.parse(mindate);
		var daysvalue=7;
		mindate.setTime(millis  + daysvalue *24*60*60*1000);
		fixedDurationVm.mindate = mindate;
		fixedDurationVm.isvalidDays = false;
		fixedDurationVm.isTaxablecheck = fixedDepositService.customer.isTaxable;
		var taxDate = new Date(); 
		fixedDurationVm.currenttaxDate = "" + taxDate.getDate()  + "/" +(taxDate.getMonth()+1) + "/" + taxDate.getFullYear();
		taxDate.setFullYear(taxDate.getFullYear() + 5); 
		fixedDurationVm.maxtaxdate = taxDate;
		if(!fixedDepositService.customer.maturityDate){
			fixedDurationVm.showBack = true;
			fixedDurationVm.showNext = true;
			fixedDurationVm.disablenext = true;
		}
		fixedDurationVm.yearsData = fixedDepositService.customer.years;
		fixedDurationVm.monthsData = fixedDepositService.customer.months;
		fixedDurationVm.daysData = fixedDepositService.customer.days;
		fixedDurationVm.maturityDate = fixedDepositService.customer.maturityDate;
		fixedDurationVm.interestrate = fixedDepositService.customer.interestRate;
		fixedDurationVm.maturityDateTime = fixedDepositService.customer.maturityDateTime;
		fixedDurationVm.isvalidDays = fixedDepositService.customer.isvalidDays;
		fixedDurationVm.isTaxable = fixedDepositService.customer.isTaxable;
		fixedDurationVm.isScitizen = fixedDepositService.customer.isSenior;
		fixedDurationVm.isStaffFlag = customerInfoService.customer.isStaffFlag;
		if(fixedDurationVm.isStaffFlag === 'Y'){
			if(fixedDepositService.customer.isSenior === true){
				fixedDurationVm.custype = "staff_senior_citizen";
				fixedDepositService.customer.custype = "staff_senior_citizen";
			} else {
				fixedDurationVm.custype = "staff_customer";
				fixedDepositService.customer.custype = "staff_customer";
			}
		}
		if(fixedDurationVm.isStaffFlag === 'N'){
			if(fixedDepositService.customer.isSenior === true){
				fixedDurationVm.custype = "senior_citizen";
				fixedDepositService.customer.custype = "senior_citizen";
			} else {
				fixedDurationVm.custype = "normal_customer";
				fixedDepositService.customer.custype = "normal_customer";
			}
		}
		if(fixedDurationVm.newDates){
			fixedDurationVm.disablenext = true;
		}
		if(fixedDepositService.customer.maturityDate){
			fixedDurationVm.disablenext = false;
		}
		if((fixedDurationVm.yearsData) || (fixedDurationVm.monthsData) || (fixedDurationVm.daysData)){
			if(fixedDurationVm.yearsData){
				fixedDurationVm.yearsData = parseInt(fixedDurationVm.yearsData);
			} else {
				fixedDurationVm.yearsData ="";
			}
			fixedDepositService.customer.years = fixedDurationVm.yearsData;
			if(fixedDurationVm.monthsData ){
				fixedDurationVm.monthsData = parseInt(fixedDurationVm.monthsData);
			} else {
				fixedDurationVm.monthsData ="";
			}
			fixedDepositService.customer.months = fixedDurationVm.monthsData;
			if(fixedDurationVm.daysData ){
				fixedDurationVm.daysData = parseInt(fixedDurationVm.daysData);
			} else {
				fixedDurationVm.daysData ="";
			} 
			fixedDepositService.customer.days = fixedDurationVm.daysData;
			getMaturityDate(fixedDepositService,fixedDurationVm,interestrateService);
		}
	});

	$scope.$on('$ionicView.afterLeave', function() {
		//any cleanup needs to be done here: executes everytime when page is left
	});
	return this;
}]);