'use strict';

angularApp.controller('interestPayoutController',
	["$timeout",
		"$state",
		"$scope",
		"$translate",
		"fixedDepositService",
		"interestPayoutService",
		"utilityService",
		"customerInfoService",

		function ($timeout,
			$state,
			$scope,
			$translate,
			fixedDepositService,
			interestPayoutService,
			utilityService,
			customerInfoService) {

			var interestPayoutVm = this;
			function initPage() {
				interestPayoutVm.monthlyData = "Monthly";
				interestPayoutVm.quarterlyData = "Quarterly";
				interestPayoutVm.halfyearlyData = "Half Yearly";
				interestPayoutVm.atmaturityData = "At Maturity";
				interestPayoutVm.showBack = true;
				interestPayoutVm.showNext = true;
				interestPayoutVm.disablenext = true;
				$translate(['MONTHLY', 'QUARTERLY', 'HALF_YEARLY', 'AT_MATURITY', 'FIXED_DEPOSIT']).then(function (translations) {
					interestPayoutVm.monthly = translations['MONTHLY'];
					interestPayoutVm.quarterly = translations['QUARTERLY'];
					interestPayoutVm.halfyearly = translations['HALF_YEARLY'];
					interestPayoutVm.atmaturity = translations['AT_MATURITY'];
					interestPayoutVm.fdTitle = translations['FIXED_DEPOSIT'];
				});
				interestPayoutVm.isvalidPayout = false;
			}

			/**
			 * function to calcualte interest payout amount
			 * @param {angualr service object} fixedDepositService 
			 * @param {controller object} interestPayoutVm
			 */
			function getInterestPayout(fixedDepositService, interestPayoutVm) {
				interestPayoutVm.isStaffFlag = customerInfoService.customer.isStaffFlag;
				interestPayoutVm.intCategory = fixedDepositService.customer.intCategory;
				interestPayoutVm.accountTypeCode = fixedDepositService.customer.accountTypeCode;
				interestPayoutVm.branchCode = fixedDepositService.customer.branchCode;
				interestPayoutService.getMaturityDetails(interestPayoutVm).then(function (data) {
					if (!utilityService.isUndefined(data.fdGetMaturityDetails)) {
						interestPayoutVm.disablenext = false;
						interestPayoutVm.intAmountnewValue = utilityService.getValue(data.fdGetMaturityDetails.payoutAmount);
						fixedDepositService.customer.maturityAmount = utilityService.getValue(data.fdGetMaturityDetails.maturityAmount);
						fixedDepositService.customer.interestRate = utilityService.getValue(data.fdGetMaturityDetails.rate);
						fixedDepositService.customer.maturitydateFD = utilityService.getValue(data.fdGetMaturityDetails.maturityDate);
						var month = ["JAN", "FEB", "MAR", "APR", "MAY", "JUN", "JUL", "AUG", "SEP", "OCT", "NOV", "DEC"];
						var newCustDate = fixedDepositService.customer.maturitydateFD.split(" ");
						var getYear = parseInt(newCustDate[2]);
						var getMonth = newCustDate[1];
						var getDay = parseInt(newCustDate[0]);
						for (var i = 0; i < month.length; i++) {
							if (month[i] === getMonth) {
								var getNewMonth = i;
							}
						}
						getNewMonth = getNewMonth + 1;
						if (getNewMonth <= 9) {
							getNewMonth = "0" + getNewMonth;
						}
						if (getDay <= 9) {
							getDay = "0" + getDay;
						}
						fixedDepositService.customer.maturitydateFDRequest = "" + getDay + getNewMonth + getYear;

						if (interestPayoutVm.interestPayout === "At Maturity") {
							interestPayoutVm.intAmount = fixedDepositService.customer.maturityAmount - interestPayoutVm.amount;
						} else {
							interestPayoutVm.intAmount = interestPayoutVm.intAmountnewValue;
						}
						fixedDepositService.customer.intpayamount = interestPayoutVm.intAmount;
						fixedDepositService.customer.intpaystring = interestPayoutVm.interestPayoutData;
					}
				}, function (error) {
					interestPayoutVm.disablenext = true;
					utilityService.showErrorMessage(error.responseMessage);
				});

			}

			interestPayoutVm.setSelected = function (data) {
				interestPayoutVm.idSelectedVote = data;
				interestPayoutVm.interestPayout = data;
				interestPayoutVm.isvalidPayout = true;
				if (interestPayoutVm.interestPayout === "Monthly") {
					interestPayoutVm.interestPayoutData = "monthly";
					interestPayoutVm.intpayoutservice = "1A";
					interestPayoutVm.monthselected = true;
					interestPayoutVm.quarterselected = false;
					interestPayoutVm.halfyearselected = false;
					interestPayoutVm.maturityselected = false;
				}
				if (interestPayoutVm.interestPayout === "Quarterly") {
					interestPayoutVm.interestPayoutData = "quarterly";
					interestPayoutVm.intpayoutservice = "3A";
					interestPayoutVm.monthselected = false;
					interestPayoutVm.quarterselected = true;
					interestPayoutVm.halfyearselected = false;
					interestPayoutVm.maturityselected = false;
				}
				if (interestPayoutVm.interestPayout === "Half Yearly") {
					interestPayoutVm.interestPayoutData = "half yearly";
					interestPayoutVm.intpayoutservice = "6A";
					interestPayoutVm.monthselected = false;
					interestPayoutVm.quarterselected = false;
					interestPayoutVm.halfyearselected = true;
					interestPayoutVm.maturityselected = false;
				}
				if (interestPayoutVm.interestPayout === "At Maturity") {
					interestPayoutVm.interestPayoutData = "at maturity";
					interestPayoutVm.intpayoutservice = "M";
					interestPayoutVm.monthselected = false;
					interestPayoutVm.quarterselected = false;
					interestPayoutVm.halfyearselected = false;
					interestPayoutVm.maturityselected = true;
				}
				getInterestPayout(fixedDepositService, interestPayoutVm);
				fixedDepositService.customer.interestPayout = interestPayoutVm.interestPayout;
				fixedDepositService.customer.intpayoutservice = interestPayoutVm.intpayoutservice;
			}
			interestPayoutVm.goBacktoPrevious = function () {
				$state.go('menu.fixedDuration');//To do
			}

			interestPayoutVm.goToNextPage = function () {
				if (interestPayoutVm.isTaxable === false) {
					$state.go('menu.atMaturity');
				}
				if (interestPayoutVm.isTaxable === true) {
					$state.go('menu.reviewFD');
					fixedDepositService.customer.matInstService = "C";
				}
			}

			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			interestPayoutVm.goToAO = function () {
				$state.go("menu.accountOverviewMyBalance");
			};

			$scope.$on('$ionicView.beforeEnter', function () {
				interestPayoutVm.isTaxable = fixedDepositService.customer.isTaxable;
				interestPayoutVm.diffDays = fixedDepositService.customer.diffDays;
				interestPayoutVm.interestrate = fixedDepositService.customer.interestRate;
				interestPayoutVm.amount = fixedDepositService.customer.amountData;
				interestPayoutVm.days = fixedDepositService.customer.days;
				if (!interestPayoutVm.days) {
					interestPayoutVm.days = 0;
				}
				interestPayoutVm.months = fixedDepositService.customer.months;
				if (!interestPayoutVm.months) {
					interestPayoutVm.months = 0;
				}
				interestPayoutVm.years = fixedDepositService.customer.years;
				if (!interestPayoutVm.years) {
					interestPayoutVm.years = 0;
				}
				interestPayoutVm.isSenior = fixedDepositService.customer.isSenior;
				interestPayoutVm.maturitydateRequest = fixedDepositService.customer.maturitydateRequest;
				interestPayoutVm.maturityInstruction = "A";
				var newDate = new Date();
				var year, month, days;
				year = newDate.getFullYear();
				month = newDate.getMonth() + 1;
				days = newDate.getDate();
				if (month <= 9) {
					month = "0" + month;
				}
				if (days <= 9) {
					days = "0" + days;
				}
				interestPayoutVm.startDate = "" + days + month + year;

				if (interestPayoutVm.diffDays <= 180) {
					interestPayoutVm.disquart = true;
					interestPayoutVm.dishyear = true;
					interestPayoutVm.dismonth = true;
				}
				if (interestPayoutVm.diffDays >= 181 && interestPayoutVm.diffDays <= 365) {
					interestPayoutVm.disquart = false;
					interestPayoutVm.dishyear = true;
					interestPayoutVm.dismonth = true;
				}

				if (interestPayoutVm.diffDays > 365) {
					interestPayoutVm.dishyear = false;
					interestPayoutVm.dismonth = false;
					interestPayoutVm.disquart = false;
				}

				// if (interestPayoutVm.diffDays > 1825) {
				// 	interestPayoutVm.dishyear = true;
				// 	interestPayoutVm.dismonth = true;
				// 	interestPayoutVm.disquart = true;
				// }

				interestPayoutVm.dismature = false;

				if (fixedDepositService.customer.interestPayout === "") {
					interestPayoutVm.isvalidPayout = false;
					interestPayoutVm.intPayout = false;
					interestPayoutVm.monthselected = false;
					interestPayoutVm.quarterselected = false;
					interestPayoutVm.halfyearselected = false;
					interestPayoutVm.maturityselected = false;
					interestPayoutVm.showBack = true;
					interestPayoutVm.showNext = true;
					interestPayoutVm.disablenext = true;
					fixedDepositService.customer.intpayoutMD = fixedDepositService.customer.maturityDate;
					fixedDepositService.customer.intpayoutAMT = fixedDepositService.customer.amountData;
					fixedDepositService.customer.intpayoutACCT = fixedDepositService.customer.selectedItem;
				} else {
					if (fixedDepositService.customer.intpayoutMD !== fixedDepositService.customer.maturityDate || fixedDepositService.customer.intpayoutAMT !== fixedDepositService.customer.amountData || fixedDepositService.customer.intpayoutACCT !== fixedDepositService.customer.selectedItem) {
						fixedDepositService.customer.intpayoutMD = fixedDepositService.customer.maturityDate;
						fixedDepositService.customer.intpayoutAMT = fixedDepositService.customer.amountData;
						fixedDepositService.customer.intpayoutACCT = fixedDepositService.customer.selectedItem;
						interestPayoutVm.intPayout = false;
						interestPayoutVm.monthselected = false;
						interestPayoutVm.quarterselected = false;
						interestPayoutVm.halfyearselected = false;
						interestPayoutVm.maturityselected = false;
						interestPayoutVm.isvalidPayout = false;
						interestPayoutVm.showBack = true;
						interestPayoutVm.showNext = true;
						interestPayoutVm.disablenext = true;
						fixedDepositService.customer.interestPayout = false;
					} else {
						interestPayoutVm.intPayout = fixedDepositService.customer.interestPayout;
						if (interestPayoutVm.intPayout) {
							interestPayoutVm.disablenext = false;
							interestPayoutVm.isvalidPayout = true;
							interestPayoutVm.intAmount = fixedDepositService.customer.intpayamount;
							interestPayoutVm.interestPayoutData = fixedDepositService.customer.intpaystring;
						} else {
							interestPayoutVm.monthselected = false;
							interestPayoutVm.quarterselected = false;
							interestPayoutVm.halfyearselected = false;
							interestPayoutVm.maturityselected = false;
							interestPayoutVm.isvalidPayout = false;
							interestPayoutVm.showBack = true;
							interestPayoutVm.showNext = true;
							interestPayoutVm.disablenext = true;
						}
					}
				}
				interestPayoutVm.interestPayout = fixedDepositService.customer.interestPayout;
			});

			$scope.$on('$ionicView.afterLeave', function () {
				//any cleanup needs to be done here: executes everytime when page is left
			});
			return this;
		}]);