'use strict';

angularApp.controller('interestrateController', 
	["$timeout",
	"$state",
	"$scope",
	"$translate",
	"fixedDepositService",
	"interestrateService",
	"utilityService",
	"customerInfoService",

	function ($timeout,
		$state,
		$scope,
		$translate,
		fixedDepositService,
		interestrateService,
		utilityService,
		customerInfoService) {
	var interestrateVm = this;
	function initPage(){		
		interestrateVm.showBack = false;
		interestrateVm.showNext = false;
		$translate(['DURATION','INTEREST_RATEH','INTEREST_RATEFD']).then(function (translations) {
			interestrateVm.durationH=translations['DURATION'];
			interestrateVm.interestrateH=translations['INTEREST_RATEH'];
			interestrateVm.fdTitle=translations['INTEREST_RATEFD'];
		}); 
	}

	interestrateVm.setSelected = function(duration,rate){
		interestrateVm.durationselect = duration;
		interestrateVm.rateselect = rate;
		interestrateVm.idSelectedVote = duration;
		fixedDepositService.customer.years = "";
		fixedDepositService.customer.months = "";
		fixedDepositService.customer.days = "";
		interestrateVm.isSelect = true;
		fixedDepositService.customer.isvalidDays = true;
		fixedDepositService.customer.viewInterest = true;
		if(interestrateVm.isSelect){
			getMDateIrate(fixedDepositService,interestrateVm);
		}
		$state.go('menu.fixedDuration');
	}

/**
 * function to calculate maturity date and interest rate
 * @param {angualr service object} fixedDepositService 
 * @param {controller object} interestrateVm
 */
 function getMDateIrate (fixedDepositService,interestrateVm){
 	interestrateVm.minDate = interestrateVm.durationselect;
 	interestrateVm.mindates = interestrateVm.minDate.split(" ");
 	if(interestrateVm.mindates[1] === "days" ){
 		fixedDepositService.customer.days = parseInt(interestrateVm.mindates [0]);
 		fixedDepositService.customer.interestRate = interestrateVm.rateselect;
 		var newDate = new Date();
 		var millis = Date.parse(newDate);
 		var daysvalue = fixedDepositService.customer.days;
 		newDate.setTime(millis  + daysvalue *24*60*60*1000);
 		interestrateVm.maturityDateFull = newDate;
 		var month = ["JAN", "FEB", "MAR", "APR", "MAY", "JUN","JUL", "AUG", "SEP", "OCT", "NOV", "DEC"];
 		newDate = new Date(newDate.getTime() - (24*60*60*1000));
 		fixedDepositService.customer.maturityDate = "" + newDate.getDate() + " " + month[(newDate.getMonth())] +" "+newDate.getFullYear();
 		var year, month,days;
 		year = newDate.getFullYear();
 		month = newDate.getMonth()+1;
 		days = newDate.getDate();
 		if(month <= 9){
 			month = "0" + month;
 		}
 		if(days <= 9){
 			days = "0" + days;
 		}
 		interestrateVm.maturitydateRequest = ""+days+month+year;
 		fixedDepositService.customer.maturitydateRequest = interestrateVm.maturitydateRequest;	
 	}
 	if(interestrateVm.mindates[1] !== "days"){
 		fixedDepositService.customer.years = parseInt(interestrateVm.mindates [0]);
 		fixedDepositService.customer.interestRate = interestrateVm.rateselect;
 		var newDate = new Date(); 
 		newDate.setFullYear(newDate.getFullYear() + fixedDepositService.customer.years); 
 		interestrateVm.maturityDateFull = newDate;
 		var month = ["JAN", "FEB", "MAR", "APR", "MAY", "JUN","JUL", "AUG", "SEP", "OCT", "NOV", "DEC"];
 		newDate = new Date(newDate.getTime() - (24*60*60*1000));
 		fixedDepositService.customer.maturityDate = "" + newDate.getDate() + " " + month[(newDate.getMonth())] +" "+newDate.getFullYear();
 		var year, month,days;
 		year = newDate.getFullYear();
 		month = newDate.getMonth()+1;
 		days = newDate.getDate();
 		if(month <= 9){
 			month = "0" + month;
 		}
 		if(days <= 9){
 			days = "0" + days;
 		}
 		interestrateVm.maturitydateRequest = ""+days+month+year;
 		fixedDepositService.customer.maturitydateRequest = interestrateVm.maturitydateRequest;
 	}

 	var currentDate = new Date(); 
 	var maturityDateFull = interestrateVm.maturityDateFull;
 	var timeDiff = Math.abs(maturityDateFull.getTime() - currentDate.getTime());
 	interestrateVm.diffDays = Math.ceil(timeDiff / (1000 * 3600 * 24)); 
 	fixedDepositService.customer.diffDays = interestrateVm.diffDays + 1;
 }
	
	interestrateVm.goBacktoPrevious = function(){
	
	};

	interestrateVm.goToAO = function(){
		$state.go("menu.fixedDuration");
	};

	interestrateVm.goToNextPage = function(){
		if(interestrateVm.isSelect){
			getMDateIrate(fixedDepositService,interestrateVm);
		}
		$state.go('menu.fixedDuration');
	};
	
	$scope.$on('$ionicView.loaded', function() {
		initPage();
	});
	
	$scope.$on('$ionicView.beforeEnter', function() {
		if(fixedDepositService.customer.viewInterest === false){
			interestrateVm.idSelectedVote =  false;
		}
		interestrateVm.isStaffFlag = customerInfoService.customer.isStaffFlag;
		interestrateVm.amount = fixedDepositService.customer.amountData;
		interestrateVm.years = fixedDepositService.customer.years;
		interestrateVm.months = fixedDepositService.customer.months;
		interestrateVm.days = fixedDepositService.customer.days;
		interestrateVm.isTaxable = fixedDepositService.customer.isTaxable;
		interestrateVm.isScitizen = fixedDepositService.customer.isSenior;
		if(interestrateVm.isStaffFlag === 'Y'){
			if(fixedDepositService.customer.isSenior === true){
			interestrateVm.custype = "staff_senior_citizen";
			fixedDepositService.customer.custype = "staff_senior_citizen";
			} else {
				interestrateVm.custype = "staff_customer";
				fixedDepositService.customer.custype = "staff_customer";
			}
		}
		if(interestrateVm.isStaffFlag === 'N'){
			if(fixedDepositService.customer.isSenior === true){
			interestrateVm.custype = "senior_citizen";
			fixedDepositService.customer.custype = "senior_citizen";
			} else {
				interestrateVm.custype = "normal_customer";
				fixedDepositService.customer.custype = "normal_customer";
			}
		}
		interestrateService.fetchInterestRate(interestrateVm).then(function(data){
			if(!utilityService.isUndefined(data.fdInterestDetails)){
				interestrateVm.durationRate=[];
				for (var i=0;i <data.fdInterestDetails.length;i++){
					interestrateVm.durationRate.push(data.fdInterestDetails[i]);
				}

			}
		}, function(error){
			utilityService.showErrorMessage(error.responseMessage);
		});
	});
	
	$scope.$on('$ionicView.afterLeave', function() {		
		//any cleanup needs to be done here: executes everytime when page is left
	});
	return this;
}]);