'use strict';

angularApp.controller('nomineeController', ["$timeout",
	"$state",
	"$scope",
	"$translate",
	"fixedDepositService",
	"nomineeService",
	"closePopupService",
	"$ionicPopup",
	"ionicDatePicker",
	"validationService",
	"utilityService",
	"$filter",
	"fixedDepositClosureService",
	function ($timeout,
		$state,
		$scope,
		$translate,
		fixedDepositService,
		nomineeService,
		closePopupService,
		$ionicPopup,
		ionicDatePicker,
		validationService,
		utilityService,
		$filter,
		fixedDepositClosureService) {

		var nomineeVm = this;
		function initPage() {
			nomineeVm.showBack = true;
			nomineeVm.showNext = true;
			nomineeVm.showNameError = false;
			nomineeVm.showGNameError = false;
			nomineeVm.showAgeError = false;
			nomineeVm.showAddressError = false;
			nomineeVm.showAddress2Error = false;
			nomineeVm.Relations = [];
			$translate(['NOMINEE_INFO', 'NOMINEE_NAME', 'NOMINEE_AGE', 'SELECT_RELATION', 'RELATION_TITLE', 'NOMINEE_FADDRESS', 'NOMINEE_SADDRESS', 'NOMINEE_GUARD', 'FIXED_DEPOSIT', 'NOMINEE_HIDE', 'DATE_OF_BIRTH', 'EDITT']).then(function (translations) {
				nomineeVm.nominee = translations['NOMINEE_INFO'];
				nomineeVm.nomineeName = translations['NOMINEE_NAME'];
				nomineeVm.nomineeAge = translations['NOMINEE_AGE'];
				nomineeVm.relationSelect = translations['SELECT_RELATION'];
				nomineeVm.relationTitle = translations['RELATION_TITLE'];
				nomineeVm.nomineefAddress = translations['NOMINEE_FADDRESS'];
				nomineeVm.nomineesAddress = translations['NOMINEE_SADDRESS'];
				nomineeVm.nomineeGuard = translations['NOMINEE_GUARD'];
				nomineeVm.fdTitle = translations['FIXED_DEPOSIT'];
				nomineeVm.nomineeHide = translations['NOMINEE_HIDE'];
				nomineeVm.dateofbirth = translations['DATE_OF_BIRTH'];
				nomineeVm.edit = translations['EDITT']
			});
		}
		nomineeVm.ipObj1 = {
			callback: function (val) {
				nomineeVm.DOBCust = new Date(val);
				if (parseInt(getCalculatedAge(nomineeVm.DOBCust)) < 18) {
					nomineeVm.minorFlag = true;
					nomineeVm.guardNData = true;
					nomineeVm.guardiaAge = true;
					if (nomineeVm.age === undefined || nomineeVm.age === "" || nomineeVm.age === null || nomineeVm.age < 18 || nomineeVm.age > 99) {
						nomineeVm.showAgeError = true;
					} else {
						nomineeVm.showAgeError = false;
					}
					if (nomineeVm.guardian === undefined || nomineeVm.guardian === "" || nomineeVm.guardian === null) {
						nomineeVm.showGNameError = true;
					} else {
						nomineeVm.showGNameError = false;
					}
				} else {
					nomineeVm.minorFlag = false;
					nomineeVm.guardNData = false;
					nomineeVm.guardiaAge = false;
					nomineeVm.showGNameError = false;
					nomineeVm.showAgeError = false;
					nomineeVm.age = "";
					nomineeVm.guardian = "";
				}
				nomineeVm.setSubmitButton();
			},
			inputDate: new Date(),
			to: new Date(),
			mondayFirst: true,
			closeOnSelect: false,
			templateType: 'popup',
		};

		function getCalculatedAge(born) {
			var now = new Date();
			var birthday = new Date(now.getFullYear(), born.getMonth(), born.getDate());
			if(now >= birthday)
				return now.getFullYear() - born.getFullYear();
			else
				return (now.getFullYear() - born.getFullYear()) - 1;
		}

		nomineeVm.openDatePicker = function () {
			ionicDatePicker.openDatePicker(nomineeVm.ipObj1);
		};

		nomineeVm.selectedAccountFun = function () {
			var data = nomineeVm.selectedValue.split(",");
			var e = [];
			e.relationname = data[0];
			e.indexId = data[1];
			nomineeVm.indexId = e.indexId;
			nomineeVm.customer.nomIndexid = nomineeVm.indexId;
			nomineeVm.relationType = e.relationname;
			nomineeVm.customer.relation = nomineeVm.relationType;
			nomineeVm.setSubmitButton();
		}

		nomineeVm.getNomineeValue = function (isChecked) {
			if (isChecked === true) {
				nomineeVm.nameToBePrintedFlag = "N";
				nomineeVm.showNominee = true;
			} else {
				nomineeVm.nameToBePrintedFlag = "Y";
				nomineeVm.showNominee = false;
			}
			nomineeVm.customer.showNominee = nomineeVm.showNominee;
			nomineeVm.customer.nameToBePrintedFlag = nomineeVm.nameToBePrintedFlag;
		}

		nomineeVm.getNomineeName = function () {
			var regexp = new RegExp("^([a-zA-Z ]{0,40})$");
			if (regexp.test(nomineeVm.nameData)) {
				nomineeVm.nameDataValid = true;
			} else {
				nomineeVm.nameDataValid = false;
			}

			if (nomineeVm.nameData === "" || nomineeVm.nameData === undefined || nomineeVm.nameData === null || nomineeVm.nameDataValid === false) {
				nomineeVm.showNameError = true;
			} else {
				nomineeVm.showNameError = false;
				nomineeVm.customer.nominee = nomineeVm.nameData;
			}
			nomineeVm.setSubmitButton();
		}

		nomineeVm.getNomineeAge = function () {
			if (nomineeVm.age !== undefined && nomineeVm.age !== "" && nomineeVm.age !== null) {
				nomineeVm.age = parseInt(nomineeVm.age);
			} else {
				nomineeVm.age = "";
			}

			if (nomineeVm.age >= 18 && nomineeVm.age <= 99) {
				nomineeVm.customer.age = nomineeVm.age;
				nomineeVm.showAgeError = false;
			} else {
				nomineeVm.showAgeError = true;
			}
			nomineeVm.setSubmitButton();
		}

		nomineeVm.getNomineeGuardian = function () {
			var regexp = new RegExp("^([a-zA-Z ]{0,30})$");
			if (regexp.test(nomineeVm.guardian)) {
				nomineeVm.guardianValid = true;
			} else {
				nomineeVm.guardianValid = false;
			}

			if (nomineeVm.guardian === "" || nomineeVm.guardian === undefined || nomineeVm.guardian === null || nomineeVm.guardianValid === false) {
				nomineeVm.showGNameError = true;
			} else {
				nomineeVm.showGNameError = false;
				nomineeVm.customer.guardian = nomineeVm.guardian;
			}
			nomineeVm.setSubmitButton();
		}

		nomineeVm.getNomineeAddress1 = function () {
			var regexp = new RegExp("^.{1,30}$");
			if (regexp.test(nomineeVm.address1)) {
				nomineeVm.address1Valid = true;
			} else {
				nomineeVm.address1Valid = false;
			}

			if (nomineeVm.address1 === "" || nomineeVm.address1 === undefined || nomineeVm.address1 === null || nomineeVm.address1Valid === false) {
				nomineeVm.showAddressError = true;
			} else {
				nomineeVm.showAddressError = false;
				nomineeVm.customer.address1 = nomineeVm.address1;
			}
			nomineeVm.setSubmitButton();
		}

		nomineeVm.getNomineeAddress2 = function () {
			var regexp = new RegExp("^.{1,30}$");
			if (regexp.test(nomineeVm.address2)) {
				nomineeVm.address2Valid = true;
			} else {
				nomineeVm.address2Valid = false;
			}

			if (nomineeVm.address2 === "" || nomineeVm.address2 === undefined || nomineeVm.address2 === null || nomineeVm.address2Valid === false) {
				nomineeVm.showAddress2Error = true;
			} else {
				nomineeVm.showAddress2Error = false;
				nomineeVm.customer.address2 = nomineeVm.address2;
			}
			nomineeVm.setSubmitButton();
		}

		nomineeVm.setSubmitButton = function () {
			if(!nomineeVm.showNameError &&
				(nomineeVm.relationType != "" && nomineeVm.indexId > 0) &&
				nomineeVm.DOBCust != "Date of Birth" && 
				nomineeVm.address1 != "" && !nomineeVm.showAddressError && 
				nomineeVm.address2 != "" && !nomineeVm.showAddress2Error) {
					if(nomineeVm.guardNData && nomineeVm.guardiaAge) {
						if(nomineeVm.guardian != "" && !nomineeVm.showGNameError && nomineeVm.age != "" && !nomineeVm.showAgeError) {
							nomineeVm.disablesubmit = false;
						} else {
							nomineeVm.disablesubmit = true;
						}
					} else {
						nomineeVm.disablesubmit = false;
					}
				} else {
					nomineeVm.disablesubmit = true;
				}
		}

		nomineeVm.editnominee = function () {
			nomineeVm.showaddress2 = true;
			nomineeVm.guardiaAge = false;
			nomineeVm.guardNData = false;
			nomineeVm.disablesubmit = true;
			nomineeVm.hideDOB = true;
			nomineeVm.disNomName = false;
			nomineeVm.disNomSelect = false;
			nomineeVm.disNomDOB = false;
			nomineeVm.disNomGuardName = false;
			nomineeVm.disNomAddress1 = false;
			nomineeVm.disNomcheckbox = false;
			nomineeVm.showNameError = false;
			nomineeVm.showGNameError = false;
			nomineeVm.showAgeError = false;
			nomineeVm.showAddressError = false;
			nomineeVm.showAddress2Error = false;
			nomineeVm.customer = [];
			nomineeVm.guardian = "";
			nomineeVm.address1 = "";
			nomineeVm.address2 = "";
			nomineeVm.nameData = "";
			nomineeVm.DOBCust = "Date of Birth";
			nomineeVm.selectedValue = nomineeVm.Relations[0].relationname + ",0";
			nomineeVm.indexId = 0;
			nomineeVm.showNominee = false;
			nomineeVm.age = "";
		}

		nomineeVm.goToAO = function () {
			if (fixedDepositService.customer.nomineeClick === 'detailsfd') {
				$state.go('menu.fixedDepositDetails');
			}
			if (fixedDepositService.customer.nomineeClick === 'closefd') {
				$state.go('menu.fixedDepositClosure');
			}
			if (fixedDepositService.customer.nomineeClick === 'reviewfd') {
				$state.go('menu.reviewFD');
			}
		}

		nomineeVm.goBacktoPrevious = function () {
			if (fixedDepositService.customer.nomineeClick === 'detailsfd') {
				$state.go('menu.fixedDepositDetails');
			}
			if (fixedDepositService.customer.nomineeClick === 'closefd') {
				$state.go('menu.fixedDepositClosure');
			}
			if (fixedDepositService.customer.nomineeClick === 'reviewfd') {
				$state.go('menu.reviewFD');
			}
		}

		nomineeVm.goToNextPage = function () {
			fixedDepositService.customer.age = nomineeVm.age;
			fixedDepositService.customer.dob = nomineeVm.DOBCust;
			fixedDepositService.customer.relation = nomineeVm.relationType;
			fixedDepositService.customer.guardian = nomineeVm.guardian;
			fixedDepositService.customer.address1 = nomineeVm.address1;
			fixedDepositService.customer.address2 = nomineeVm.address2;
			fixedDepositService.customer.nominee = nomineeVm.nameData;
			fixedDepositService.customer.showNominee = nomineeVm.showNominee;
			fixedDepositService.customer.minorFlag = nomineeVm.minorFlag;
			fixedDepositService.customer.nameToBePrintedFlag = nomineeVm.nameToBePrintedFlag;
			nomineeVm.nomineeDOB = $filter('date')(nomineeVm.DOBCust, "ddMMyyyy");
			if (fixedDepositService.customer.nomineeClick === 'detailsfd') {
				nomineeService.updateNominee(nomineeVm).then(function (data) {
					//Success block
					nomineeVm.sucessPopUP = $ionicPopup.show({
						title : "",
						cssClass : 'my-custom-popup',
						template : '<div class="button_fund fontSize-subHeading roboto-light font-dark-grey" translate="UPDT_NOM_SUCESS" translate-values="{fdAccountNumber:nomineeVm.fdAccountNumber}"></div>',
						scope : $scope,
						buttons: [
							{
								text:'OK',
								type: 'button-assertive',
								onTap: function() {
									nomineeVm.sucessPopUP.close();
									$state.go('menu.fixedDepositDetails');
								}
							}
						],
					});
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}
			if (fixedDepositService.customer.nomineeClick === 'closefd') {
				$state.go('menu.fixedDepositClosure');
			}
			if (fixedDepositService.customer.nomineeClick === 'reviewfd') {
				$state.go('menu.reviewFD');
			}
		}

		nomineeVm.setRelationship = function () {
			if (fixedDepositService.customer.relation === "" || fixedDepositService.customer.relation === null || fixedDepositService.customer.relation === undefined) {
				nomineeVm.indexId = 0;
				nomineeVm.selectedValue = nomineeVm.Relations[0].relationname + ",0";
			}
			else {
				for (var i = 0; i < nomineeVm.Relations.length; i++) {
					if (nomineeVm.Relations[i].relationname === fixedDepositService.customer.relation) {
						nomineeVm.indexId = nomineeVm.Relations[i].id;
					}
				}
				nomineeVm.selectedValue = fixedDepositService.customer.relation + "," + nomineeVm.indexId;
			}
		}

		$scope.$on('$ionicView.loaded', function () {
			initPage();
			if(!fixedDepositService.Relations.length){
				fixedDepositClosureService.getRelationship().then(function(data){
					if(!utilityService.isUndefined(data)){
						fixedDepositService.Relations = data.relations;
						nomineeVm.Relations = fixedDepositService.Relations;
					}
					nomineeVm.setRelationship();
				}, function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});
			} else {
				nomineeVm.Relations = fixedDepositService.Relations;
				nomineeVm.setRelationship();
			}
		});

		$scope.$on('$ionicView.beforeEnter', function () {
			nomineeVm.disablesubmit = true;
			nomineeVm.showNameError = false;
			nomineeVm.showGNameError = false;
			nomineeVm.showAgeError = false;
			nomineeVm.showAddressError = false;
			nomineeVm.showAddress2Error = false;
			nomineeVm.showaddress2 = false;
			nomineeVm.guardiaAge = false;
			nomineeVm.disNomName = true;
			nomineeVm.disNomSelect = true;
			nomineeVm.disNomDOB = true;
			nomineeVm.disNomGuardName = true;
			nomineeVm.disNomAddress1 = true;
			nomineeVm.disNomcheckbox = true;

			if (fixedDepositService.customer.guardian !== "" && fixedDepositService.customer.guardian !== null && fixedDepositService.customer.guardian !== undefined) {
				nomineeVm.guardNData = true;
				nomineeVm.minorFlag = true;
			} else {
				nomineeVm.guardNData = false;
				nomineeVm.minorFlag = false;
			}

			if (fixedDepositService.customer.dob === "" || fixedDepositService.customer.dob === undefined || fixedDepositService.customer.dob === "") {
				nomineeVm.hideDOB = false;
			} else {
				nomineeVm.hideDOB = true;
				if (fixedDepositService.customer.dob.toString().length > 8) 
				{
                   nomineeVm.DOBCust = fixedDepositService.customer.dob;
				}
				else
				{
                 var existingNomDate = fixedDepositService.customer.dob.substring (2,4) +'/'+  fixedDepositService.customer.dob.substring(0, 2) + '/'+fixedDepositService.customer.dob.substring(4,8);
				 nomineeVm.DOBCust =new Date(existingNomDate);			
				}
			}
			nomineeVm.age = fixedDepositService.customer.age;
			nomineeVm.guardian = fixedDepositService.customer.guardian;
			nomineeVm.address1 = fixedDepositService.customer.address1;
			nomineeVm.address2 = fixedDepositService.customer.address2;
			nomineeVm.nameData = fixedDepositService.customer.nominee;
			nomineeVm.showNominee = fixedDepositService.customer.showNominee;
			nomineeVm.fdAccountNumber = fixedDepositService.customer.fdnumber;
			nomineeVm.nameToBePrintedFlag = "N";
			nomineeVm.branchCode = fixedDepositService.customer.branchCode;
		});

		$scope.$on('$ionicView.afterLeave', function () {
			//any cleanup needs to be done here: executes everytime when page is left
		});
		return this;
	}]);