'use strict';

angularApp.controller('overdraftController', 
	["$timeout",
	"$state",
	"$scope",
	"$translate",
	"fixedDepositService",
	"fdODDetailService",
	"$ionicPopover",
	"$ionicPopup",
	"utilityService",
	"accountOverviewService",
	"customerInfoService",
	"getAccountDetailsService",
	"clickStreamService",

	function ($timeout,
		$state,
		$scope,
		$translate,
		fixedDepositService,
		fdODDetailService,
		$ionicPopover,
		$ionicPopup,
		utilityService,
		accountOverviewService,
		customerInfoService,
		getAccountDetailsService,
		clickStreamService) {

	var overdraftVm = this;
	function initPage(){	
		overdraftVm.showBack = true;
		overdraftVm.disableconfirm = true;
		overdraftVm.isValidAccount = false;
		overdraftVm.validAccountMessage = "";
		$translate(['OVER_DRAFT','OLIMIT','OIRATE','OEDATE','READTERMS','CONGRATULATIONS','AGREETERMS','OD_ACCOUNTNUMBER','ACC_TRANS_RIGHTS','FETCH_TRANS_RGTS']).then(function (translations) {
			overdraftVm.olimit=translations['OLIMIT'];
			overdraftVm.oirate=translations['OIRATE'];
			overdraftVm.oedate=translations['OEDATE'];
			overdraftVm.readtermscondition=translations['READTERMS'];
			overdraftVm.agreetermscondition=translations['AGREETERMS'];
			overdraftVm.congratulations=translations['CONGRATULATIONS'];
			overdraftVm.odTitle=translations['OVER_DRAFT'];
			overdraftVm.accountNumberLabel=translations['OD_ACCOUNTNUMBER'];
			overdraftVm.accTransRights = translations['ACC_TRANS_RIGHTS'];
			overdraftVm.fetchTransRights = translations['FETCH_TRANS_RGTS'];
		});
	}
	 
	overdraftVm.getInfoodlimit = function (overdraftVm){
		fixedDepositService.fetchInfoMessage(overdraftVm).then(function(data){
			if(data.message){
				overdraftVm.limitinfomessage = data.message;
			}
		}, function(error){
			utilityService.showErrorMessage(error.responseMessage);
		});
	}

	overdraftVm.infoPopup = function($event) {
		$ionicPopover.fromTemplateUrl('pages/fixedDeposit/overdraft/popoverod.html', {
			scope: $scope
		}).then(function(popover) {
			overdraftVm.action = "ODLimit";
			overdraftVm.getInfoodlimit(overdraftVm);
			$scope.popover = popover;
			$scope.popover.show($event);
		});
	};

	overdraftVm.closePopover = function() {
		$scope.popover.hide();
	};

	overdraftVm.getInfoodrate = function (overdraftVm){
		fixedDepositService.fetchInfoMessage(overdraftVm).then(function(data){
			if(data.message){
				overdraftVm.rateinfomessage = data.message;
			}
		}, function(error){
			utilityService.showErrorMessage(error.responseMessage);
		});
	}
	overdraftVm.infoodPopupFD = function($event) {
		$ionicPopover.fromTemplateUrl('pages/fixedDeposit/overdraft/popoverodFD.html', {
			scope: $scope
		}).then(function(popover) {
			overdraftVm.action = "ODInterestRate";
			overdraftVm.getInfoodrate(overdraftVm);
			$scope.popover = popover;
			$scope.popover.show($event);
		});
	};

	overdraftVm.getCBValue = function(isChecked){
		if(isChecked === true && overdraftVm.checkdisable === false){
			overdraftVm.disableconfirm = false;
			overdraftVm.checkTnC = true;
		} else {
			overdraftVm.disableconfirm = true;
			overdraftVm.checkTnC = false;
		}
	} 
	overdraftVm.termcondition = function(){
		var title ='Terms & Conditions';
		var templateUrl;
		var cssClass = "ODtncPopup";
		var onTap = '';
		fdODDetailService.fetchtermcondition().then(function(data){
			if(!utilityService.isUndefined(data.termsConditions)){
				var tc = data.termsConditions;
				templateUrl = '<div class="font-content roboto-light" ng-click="overdraftVm.closePopup()">'+tc+'</div>'; 
				overdraftVm.closeTnC = fixedDepositService.showTnCAlertModal(title,templateUrl,onTap,cssClass,$scope,$state);
			}
		}, function(error){
			utilityService.showErrorMessage(error.responseMessage);
		});
	}

	overdraftVm.closePopup = function() {
		overdraftVm.closeTnC.close();
	}

	overdraftVm.goToBack = function(){
		if(fixedDepositService.customer.AODclick === 'detailsfd'){
			$state.go('menu.fixedDepositDetails');
		}
		if(fixedDepositService.customer.AODclick === 'reviewfd'){
			getAccountDetailsService.accountOverviewData = "";
			$state.go('menu.accountOverviewMyBalance');
		}
	}

	overdraftVm.goToAO = function(){
		if(fixedDepositService.customer.AODclick === 'detailsfd'){
			$state.go('menu.fixedDepositDetails');
		}
		if(fixedDepositService.customer.AODclick === 'reviewfd'){
			getAccountDetailsService.accountOverviewData = "";
			$state.go('menu.accountOverviewMyBalance');
		}
	}

	overdraftVm.selectedAccountFun =function (){
		var data=overdraftVm.selectedValue.split(",");
		var e =[];
		e.accountType=data[0];
		e.accountNumber=data[1];
		e.accountBalance=data[2];
		e.isActive=data[3];
		e.isTransactional=data[4];
		e.intCategory = data[5];
		e.accountTypeCode = data[6];
		e.indexId = data[7];
		overdraftVm.indexId = e.indexId;
		fixedDepositService.customer.indexId = overdraftVm.indexId;
		overdraftVm.isActive = e.isActive;
		overdraftVm.isTransactional = e.isTransactional;
		var title = '';
		var onTap = '';
		overdraftVm.isValidAccount = false;
		overdraftVm.validAccountMessage = "";
		if(overdraftVm.isActive === "true" && overdraftVm.isTransactional === "true"){
			overdraftVm.selectedAccountType=e.accountType;
			overdraftVm.selectedAccountNumber=e.accountNumber;
			overdraftVm.selectedAccountAmount=e.accountBalance;
			fixedDepositService.customer.selectedItem=e.accountNumber;
			fixedDepositService.selectedDetails.accountID = e.accountID;
			fixedDepositService.selectedDetails.accountType = e.accountType;
			fixedDepositService.selectedDetails.accountNumber = e.accountNumber;
			fixedDepositService.selectedDetails.accountBalance = e.accountBalance;
			fixedDepositService.selectedDetails.isActive = e.isActive;
			fixedDepositService.selectedDetails.isTransactional = e.isTransactional;
			fixedDepositService.selectedDetails.intCategory = e.intCategory;
			fixedDepositService.selectedDetails.accountTypeCode = e.accountTypeCode;
			fixedDepositService.selectedDetails.branchCode = e.branchCode;
			overdraftVm.disableconfirm = false;
			overdraftVm.checkdisable = false;
		} else {
			if(overdraftVm.isActive === "false"){
				overdraftVm.disableconfirm = true;
				overdraftVm.checkdisable = true;
				var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="SELECT_ACTIVE_ACC"></div><div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="ACTIVE_OR"></div><div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="CONTACT_NEAREST"></div>';
				fixedDepositService.showAlertModal(title,template,onTap,$scope,$state);
			} 
			
			if(overdraftVm.isTransactional === "false"){
				overdraftVm.disableconfirm = true;
				overdraftVm.checkdisable = true;
				var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="USE_TRANS_RIGHTS"></div>';
				fixedDepositService.showAlertModal(title,template,onTap,$scope,$state);
			} 
		}
		if(overdraftVm.isChecked === true && overdraftVm.checkdisable === false){
			overdraftVm.disableconfirm = false;
		} else {
			overdraftVm.disableconfirm = true;
		}
	};

	
	overdraftVm.getOdAgainstFD = function(){
		overdraftVm.disableconfirm = true;
		overdraftVm.fdnumber = fixedDepositService.customer.fdnumber;
		overdraftVm.isStaffFlag = customerInfoService.customer.isStaffFlag;
		if(overdraftVm.isStaffFlag === 'Y'){
			overdraftVm.pfId = true;
		}
		if(overdraftVm.isStaffFlag === 'N'){
			overdraftVm.pfId = false;
		}
		overdraftVm.modeOfOperation = fixedDepositService.customer.modeOfOperation;
		overdraftVm.principalAmount = fixedDepositService.customer.principalAmount;
		overdraftVm.product = fixedDepositService.customer.product;
		overdraftVm.maturityAmount = fixedDepositService.customer.maturityAmount;
		overdraftVm.transactionId = fixedDepositService.customer.fdCloseClick;
		overdraftVm.intCategory = fixedDepositService.customer.intCategory;
		overdraftVm.accountTypeCode = fixedDepositService.customer.accountTypeCode;
		overdraftVm.branchCode = fixedDepositService.customer.branchCode;
		overdraftVm.scheme = fixedDepositService.customer.scheme;
		$state.go('menu.closeDepositOTP',{depositObject: {depositType: 'odAgainstFD',overdraftVm:overdraftVm}});
	}

	overdraftVm.goToConfirm = function(){
		if(getAccountDetailsService.accessRightsData.accounts == null || getAccountDetailsService.accessRightsData.accounts == "") {
			overdraftVm.disableconfirm = true;
			overdraftVm.isValidAccount = true;
			overdraftVm.validAccountMessage = overdraftVm.fetchTransRights;
		} else { 
			var isAccountTransactional = false;
			for (var i in getAccountDetailsService.accessRightsData.accounts) {
				if (getAccountDetailsService.accessRightsData.accounts[i].accountNumber === fixedDepositService.selectedDetails.accountNumber && parseInt(getAccountDetailsService.accessRightsData.accounts[i].accessResponse) != 0) {
					isAccountTransactional = true;
				}
			}
			if(isAccountTransactional) {
				overdraftVm.getOdAgainstFD();
			} else {
				overdraftVm.disableconfirm = true;
				overdraftVm.isValidAccount = true;
				overdraftVm.validAccountMessage = overdraftVm.accTransRights;
			}
		}
	}
	
	$scope.$on('$ionicView.loaded', function() {
		initPage();
		if(getAccountDetailsService.accessRightsData.accounts == null || getAccountDetailsService.accessRightsData.accounts == "") {
			getAccountDetailsService.getAccountsAccessRights('').then( function(data) {
			getAccountDetailsService.accessRightsData = data;
			}, function(error) {
				// Failure block
			});
		}
	});
	
	$scope.$on('$ionicView.beforeEnter', function() {
		overdraftVm.overdraft = [];
		overdraftVm.overdraft  ={
			oirate : fixedDepositService.customer.ODIntRate,
			oedate : fixedDepositService.customer.ODExyDate,
			olimvalue : fixedDepositService.customer.ODLimit
		};
		var month = ["JAN", "FEB", "MAR", "APR", "MAY", "JUN","JUL", "AUG", "SEP", "OCT", "NOV", "DEC"];
		var newCustDate = fixedDepositService.customer.ODExyDate.split(" ");
		var getYear =  parseInt(newCustDate[2]);
		var getMonth = newCustDate[1];
		var getDay =  parseInt(newCustDate[0]);
		for(var i=0; i<month.length ;i++){
			if(month[i]===getMonth){
				var getNewMonth = i;
			}
		}
		getNewMonth = getNewMonth +1;
		if(getNewMonth <= 9){
			getNewMonth = "0" + getNewMonth;
		}
		if(getDay <= 9){
			getDay = "0" + getDay;
		}
		overdraftVm.ODExyDate = ""+getDay+getNewMonth+getYear;
		overdraftVm.accDetails = [];
		overdraftVm.accDetailsNew = [];
		overdraftVm.accDetailsNew = fixedDepositService.accDetails;
		for (var i in overdraftVm.accDetailsNew){
			if(overdraftVm.accDetailsNew[i].accountType === "Savings Account"){
				overdraftVm.accDetailsNew[i].accountType = "Savings A/c";
			} else if (overdraftVm.accDetailsNew[i].accountType === "Current Account"){
				overdraftVm.accDetailsNew[i].accountType = "Current A/c";
			} else if (overdraftVm.accDetailsNew[i].accountType === "Overdraft Account"){
				overdraftVm.accDetailsNew[i].accountType = "Overdraft A/c";
			}
		}
		overdraftVm.accDetails = overdraftVm.accDetailsNew;
		if(fixedDepositService.selectedDetails.accountType === ''){
			overdraftVm.selectedValue = overdraftVm.accDetails[0].accountType+","+overdraftVm.accDetails[0].accountNumber+","+overdraftVm.accDetails[0].accountBalance+","+overdraftVm.accDetails[0].isActive+","+overdraftVm.accDetails[0].isTransactional+","+overdraftVm.accDetails[0].intCategory+","+overdraftVm.accDetails[0].accountTypeCode+",0";
			overdraftVm.indexId = 0;
			overdraftVm.isActive = overdraftVm.accDetails[0].isActive;
			overdraftVm.isTransactional = overdraftVm.accDetails[0].isTransactional;
			fixedDepositService.customer.selectedItem=overdraftVm.accDetails[0].accountNumber;
			overdraftVm.selectedAccountType=overdraftVm.accDetails[0].accountType;
			overdraftVm.selectedAccountNumber=overdraftVm.accDetails[0].accountNumber;
			overdraftVm.selectedIntCategory=overdraftVm.accDetails[0].intCategory;
			overdraftVm.selectedAccountTypeCode=overdraftVm.accDetails[0].accountTypeCode;
			fixedDepositService.selectedDetails.accountType = overdraftVm.selectedAccountType;
			fixedDepositService.selectedDetails.accountNumber = overdraftVm.selectedAccountNumber;
			fixedDepositService.selectedDetails.intCategory = overdraftVm.selectedIntCategory;
			fixedDepositService.selectedDetails.accountTypeCode = overdraftVm.selectedAccountTypeCode;
			var title = '';
			var onTap = '';
			if(overdraftVm.isActive === false){
				overdraftVm.disableconfirm = true;
				overdraftVm.checkdisable = true;
				var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="SELECT_ACTIVE_ACC"></div><div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="ACTIVE_OR"></div><div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="CONTACT_NEAREST"></div>';
				fixedDepositService.showAlertModal(title,template,onTap,$scope,$state);
			} 
			
			if(overdraftVm.isTransactional === false){
				overdraftVm.disableconfirm = true;
				overdraftVm.checkdisable = true;
				var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="USE_TRANS_RIGHTS"></div>';
				fixedDepositService.showAlertModal(title,template,onTap,$scope,$state);
			} 

			if(overdraftVm.isActive && overdraftVm.isTransactional){
				overdraftVm.disableconfirm = false;
				overdraftVm.checkdisable = false;
			}
		}
		else{
			overdraftVm.indexId = fixedDepositService.customer.indexId;
			overdraftVm.selectedAccountType=fixedDepositService.selectedDetails.accountType;
			overdraftVm.selectedAccountNumber=fixedDepositService.selectedDetails.accountNumber;
			overdraftVm.selectedAccountAmount=fixedDepositService.selectedDetails.accountBalance;
			overdraftVm.selectedAccountisActive=fixedDepositService.selectedDetails.isActive;
			overdraftVm.selectedAccountisTransactional=fixedDepositService.selectedDetails.isTransactional;
			overdraftVm.selectedIntCategory=fixedDepositService.selectedDetails.intCategory;
			overdraftVm.selectedAccountTypeCode=fixedDepositService.selectedDetails.accountTypeCode;
			overdraftVm.selectedValue = overdraftVm.selectedAccountType +","+overdraftVm.selectedAccountNumber+","+overdraftVm.selectedAccountAmount+","+overdraftVm.selectedAccountisActive+","+overdraftVm.selectedAccountisTransactional+","+overdraftVm.selectedIntCategory+","+overdraftVm.selectedAccountTypeCode+","+overdraftVm.indexId;
			if(overdraftVm.selectedAccountisActive === "true" && overdraftVm.selectedAccountisTransactional === "true"){
				overdraftVm.disableconfirm = false;
				overdraftVm.checkdisable = false;
			}
		}
		fixedDepositService.selectedDetails.branchCode = overdraftVm.accDetails[overdraftVm.indexId].branchCode;
		if(overdraftVm.isChecked === true && overdraftVm.checkdisable === false){
			overdraftVm.disableconfirm = false;	
		} else {
			overdraftVm.disableconfirm = true;
		}
	});
	
	$scope.$on('$ionicView.afterLeave', function() {
		//any cleanup needs to be done here: executes everytime when page is left
	});
	return this;
}]);
