'use strict';

angularApp.controller('reviewFDController', ["$timeout",
	"$state",
	"$scope",
	"$translate",
	"fixedDepositService",
	"reviewFDService",
	"customerInfoService",
	"$ionicPopup",
	"utilityService",
	"getAccountDetailsService",
	"accountOverviewService",
	"openUrlInAppbroswerService",
	"myDreamsService",
	"$filter",
	"constantConfig",
	function ($timeout,
		$state,
		$scope,
		$translate,
		fixedDepositService,
		reviewFDService,
		customerInfoService,
		$ionicPopup,
		utilityService,
		getAccountDetailsService,
		accountOverviewService,
		openUrlInAppbroswerService,
		myDreamsService,
		$filter,
		constantConfig) {

		//functions, variables that can be accessed from the HTML come here
		var reviewFDVm = this;
		reviewFDVm.nightMode = false;
		reviewFDVm.isAccountMasked = false;
		//private methods section start
		function initPage() {
			reviewFDVm.showCancel = true;
			reviewFDVm.showConfirm = true;
			reviewFDVm.disableconfirm = true;
			$translate(['NAME', 'PAMOUNT', 'DBT_AC_NO', 'MDATE', 'MAMOUNT', 'RATE_OF_INT', 'IPAYOUT', 'MINSTRUCTION', 'NOMINEE_DETAILS', 'READTERMS', 'CONGRATS', 'FIXED_DEPOSIT', 'REGISTERED', 'NOMINEELINK', 'NO_NOMINEE']).then(function (translations) {
				reviewFDVm.name = translations['NAME'];
				reviewFDVm.pAmount = translations['PAMOUNT'];
				reviewFDVm.account = translations['DBT_AC_NO'];
				reviewFDVm.mDate = translations['MDATE'];
				reviewFDVm.mAmount = translations['MAMOUNT'];
				reviewFDVm.iRate = translations['RATE_OF_INT'];
				reviewFDVm.iPayout = translations['IPAYOUT'];
				reviewFDVm.mInstruction = translations['MINSTRUCTION'];
				reviewFDVm.Nominee = translations['NOMINEE_DETAILS'];
				reviewFDVm.termscondition = translations['READTERMS'];
				reviewFDVm.congrats = translations['CONGRATS'];
				reviewFDVm.fdTitle = translations['FIXED_DEPOSIT'];
				reviewFDVm.register = translations['REGISTERED'];
				reviewFDVm.nomineeLink = translations['NOMINEELINK'];
				reviewFDVm.nonominee = translations['NO_NOMINEE'];
			});
		}
		//private methods section end

		reviewFDVm.eyesOnFun = function(accNo){
			reviewFDVm.isAccountMasked = false;
			reviewFDVm.custAccount = reviewFDVm.oFDValue;
		}

		reviewFDVm.eyesOffFun = function(accNo){
			reviewFDVm.isAccountMasked = true;
			reviewFDVm.oFDValue = accNo;
			reviewFDVm.maskedCustAccount = utilityService.maskData(accNo, "front", 4);
		}

		//public functions start

		reviewFDVm.termconditionPopUp = function (TnCDetails) {
			var title = 'Terms & Conditions';
			var templateUrl;
			var cssClass = "ODtncPopup";
			var onTap = '';
			templateUrl = '<div class="fontSize-subHeading font-content roboto-light" ng-click="reviewFDVm.closePopup()">' + TnCDetails + '</div>';
			reviewFDVm.closeTnC = fixedDepositService.showTnCAlertModal(title, templateUrl, onTap, cssClass, $scope, $state);
		}

		//public functions end
		reviewFDVm.termcondition = function () {
			if (!reviewFDVm.isTaxable) {
				if(reviewFDService.normalFDTnC == "") {
					reviewFDService.fetchRtermcondition().then(function (data) {
						if (!utilityService.isUndefined(data.termsConditions)) {
							reviewFDService.normalFDTnC = data.termsConditions;
							reviewFDVm.termconditionPopUp(reviewFDService.normalFDTnC);
						}
					}, function (error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				} else {
					reviewFDVm.termconditionPopUp(reviewFDService.normalFDTnC);
				}
			} else {
				if(reviewFDService.taxSaverFDTnC == "") {
					reviewFDService.fetchRtaxtermcondition().then(function (data) {
						if (!utilityService.isUndefined(data.termsConditions)) {
							reviewFDService.taxSaverFDTnC = data.termsConditions;
							reviewFDVm.termconditionPopUp(data.termsConditions);
						}
					}, function (error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				} else {
					reviewFDVm.termconditionPopUp(reviewFDService.taxSaverFDTnC);
				}
			}
		}
		reviewFDVm.closePopup = function () {
			reviewFDVm.closeTnC.close();
			utilityService.hideSpinner();
		}

		reviewFDVm.nomineeInfo = function () {
			var title = '';
			var onTap = 'menu.reviewFD';
			var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey">{{reviewFDVm.nonominee}}</div>';
			fixedDepositService.showAlertModal(title, template, onTap, $scope, $state);
		}
		reviewFDVm.getCBValue = function (isChecked) {
			if (isChecked === true) {
				reviewFDVm.disableconfirm = false;
				reviewFDVm.checkTnC = true;
			}
			else {
				reviewFDVm.disableconfirm = true;
				reviewFDVm.checkTnC = false;
			}
		}
		reviewFDVm.editnominee = function () {
			// fixedDepositService.customer.checkNominee = false;
			fixedDepositService.customer.nomineeClick = "reviewfd";
			if (!reviewFDService.nightMode) {
				$state.go('menu.nominee');
			}
		}		
		reviewFDVm.goToCancel = function () {
			fixedDepositService.customer.clickback = true;
			if (reviewFDVm.isTaxable === false) {
				$state.go('menu.atMaturity');
			}
			if (reviewFDVm.isTaxable === true) {
				$state.go('menu.interestPayout');
			}
			
		}		
		reviewFDVm.goToAO = function () {
			reviewFDService.clearFDData();
			fixedDepositService.customer = {};
			$state.go("menu.accountOverviewMyBalance");
		}

		reviewFDVm.goToConfirm = function () {
			reviewFDVm.shortDisableNext = "Y";
			reviewFDVm.disableconfirm = true;
			reviewFDVm.isStaffFlag = customerInfoService.customer.isStaffFlag;
			reviewFDService.createFixedDeposit(fixedDepositService.customer, reviewFDVm).then(function (data) {
				reviewFDVm.shortDisableNext = "";
				var title = null;
				var template = '';
				if (!(data.nightMode == "Y" ? true : false)) {
					if (!utilityService.isUndefined(data)) {
						fixedDepositService.customer.fdAccountNumber = utilityService.getValue(data.fdAccountNumber);
						fixedDepositService.customer.fdnumber = fixedDepositService.customer.fdAccountNumber;
						fixedDepositService.customer.loanEligibility = utilityService.getValue(data.loanEligibility);
						fixedDepositService.customer.receiptLink = utilityService.getValue(data.receiptLink);
						fixedDepositService.customer.product = utilityService.getValue(data.product);
						fixedDepositService.customer.principalAmount = fixedDepositService.customer.amountData;
						reviewFDVm.FDnumber = fixedDepositService.customer.fdAccountNumber;
						reviewFDVm.isAvailOD = utilityService.getValue(data.isAvailOD);
						reviewFDVm.odLimit = utilityService.getValue(data.odLimit);
						reviewFDVm.odInterestRate = utilityService.getValue(data.odInterestRate);
						reviewFDVm.odExpiryDate = utilityService.getValue(data.odExpiryDate);
						reviewFDVm.docId = utilityService.getValue(data.docId);
						fixedDepositService.customer.startDate = utilityService.getValue(data.startDate);
						fixedDepositService.customer.scheme = utilityService.getValue(data.scheme);
						reviewFDVm.maskedAccNumber = utilityService.maskData(reviewFDVm.FDnumber, "front", 4);

						if(data.linkStatus && data.linkStatus.toLowerCase() == "success"){
							getAccountDetailsService.accountOverviewData = "";
							reviewFDService.clearFDData();
							fixedDepositService.customer = {};
							// utilityService.showBhimUpiAlert("success", "Your FD is created and linked successfully", "menu.accountOverviewMyBalance");
							// return true;
							template = '<div class ="congratsOD"><img src="img/happyface.svg" height="45" width="45" class="happyFaceOD"></div><div class="button_fund_closure RFDpopup fontSize-heading roboto-regular font-dark-grey" translate="CONGRATSNEW"></div><div class="FDpopup-margin fontSize-subHeading roboto-light font-dark-grey" translate="FD_CREATE" translate-values="{FDnumber:reviewFDVm.maskedAccNumber}"></div><div class="FDpopup-styling fontSize-subHeading roboto-light font-dark-grey">Your advice has been sent to your registered email id</div><div class="FDpopup-styling fontSize-subHeading roboto-light font-dark-grey"><a class="font-link-blue" href="javascript:void(0)" translate="DOWNLOAD" ng-click="reviewFDVm.download()"></div>';
							
						}
						if(data.linkStatus && data.linkStatus.toLowerCase() !== "success"){
							getAccountDetailsService.accountOverviewData = "";
							reviewFDService.clearFDData();
							fixedDepositService.customer = {};
							utilityService.showBhimUpiAlert("alert", "We are unable to link the FD to the Dream " + myDreamsService.selectedDreamDetails.dreamName + " due to some technical reasons. Please link to your investment through linking process", "menu.accountOverviewMyBalance");
							return true;
						}

						if (reviewFDVm.emailID) {
							if (reviewFDVm.isTaxable === false) {
								if (reviewFDVm.isAvailOD === "true") {
									template = '<div class ="congratsOD"><img src="img/happyface.svg" height="45" width="45" class="happyFaceOD"></div><div class="button_fund_closure RFDpopup fontSize-heading roboto-regular font-dark-grey" translate="CONGRATSNEW"></div><div class="button_fund_closure fontSize-subHeading roboto-light font-dark-grey" translate="FD_CREATE" translate-values="{FDnumber:reviewFDVm.maskedAccNumber}"></div><div class="FDpopup-margin fontSize-subHeading roboto-light font-dark-grey" translate="SENT_MAIL"></div><div class="FDpopup-styling fontSize-subHeading roboto-light font-dark-grey"><a class="noUnderline font-link-blue" href="javascript:void(0)" translate="DOWNLOAD" ng-click="reviewFDVm.download()"></div><div class="FDpopup-styling FDpopup-margin fontSize-subHeading roboto-light font-dark-grey" translate="ELIGIBLE_LOAN"></div><div class="FDpopup-styling fontSize-subHeading roboto-light font-dark-grey"><a class="noUnderline font-link-blue" href="javascript:void(0)" translate="APPLY_NOW" ng-click="reviewFDVm.applyOD()"></div>';
								}
								else {
									template = '<div class ="congratsOD"><img src="img/happyface.svg" height="45" width="45" class="happyFaceOD"></div><div class="button_fund_closure RFDpopup fontSize-heading roboto-regular font-dark-grey" translate="CONGRATSNEW"></div><div class="button_fund_closure fontSize-subHeading roboto-light font-dark-grey" translate="FD_CREATE" translate-values="{FDnumber:reviewFDVm.maskedAccNumber}"></div><div class="FDpopup-margin fontSize-subHeading roboto-light font-dark-grey" translate="SENT_MAIL"></div><div class="FDpopup-styling fontSize-subHeading roboto-light font-dark-grey"><a class="noUnderline font-link-blue" href="javascript:void(0)" translate="DOWNLOAD" ng-click="reviewFDVm.download()"></div>';
								}
							}
							else {
								template = '<div class ="congratsOD"><img src="img/happyface.svg" height="45" width="45" class="happyFaceOD"></div><div class="button_fund_closure RFDpopup fontSize-heading roboto-regular font-dark-grey" translate="CONGRATSNEW"></div><div class="button_fund_closure fontSize-subHeading roboto-light font-dark-grey" translate="FD_TAXCREATE" translate-values="{FDnumber:reviewFDVm.maskedAccNumber}"></div><div class="FDpopup-margin fontSize-subHeading roboto-light font-dark-grey" translate="SENT_MAIL"></div><div class="FDpopup-styling fontSize-subHeading roboto-light font-dark-grey"><a class="noUnderline font-link-blue" href="javascript:void(0)" translate="DOWNLOAD" ng-click="reviewFDVm.download()"></div>';
							}
						}
						else {
							if (reviewFDVm.isTaxable === false) {
								if (reviewFDVm.isAvailOD === "true") {
									template = '<div class ="congratsOD"><img src="img/happyface.svg" height="45" width="45" class="happyFaceOD"></div><div class="button_fund_closure RFDpopup fontSize-heading roboto-regular font-dark-grey" translate="CONGRATSNEW"></div><div class="button_fund_closure fontSize-subHeading roboto-light font-dark-grey" translate="FD_CREATE" translate-values="{FDnumber:reviewFDVm.maskedAccNumber}"></div><div class="FDpopup-styling fontSize-subHeading roboto-light font-dark-grey"><a class="noUnderline font-link-blue" href="javascript:void(0)" translate="DOWNLOAD" ng-click="reviewFDVm.download()"></div><div class="FDpopup-styling FDpopup-margin fontSize-subHeading roboto-light font-dark-grey" translate="ELIGIBLE_LOAN"></div><div class="FDpopup-styling fontSize-subHeading roboto-light font-dark-grey"><a class="noUnderline font-link-blue" href="javascript:void(0)" translate="APPLY_NOW" ng-click="reviewFDVm.applyOD()"></div>';
								}
								else {
									template = '<div class ="congratsOD"><img src="img/happyface.svg" height="45" width="45" class="happyFaceOD"></div><div class="button_fund_closure RFDpopup fontSize-heading roboto-regular font-dark-grey" translate="CONGRATSNEW"></div><div class="button_fund_closure fontSize-subHeading roboto-light font-dark-grey" translate="FD_CREATE" translate-values="{FDnumber:reviewFDVm.maskedAccNumber}"></div><div class="FDpopup-styling fontSize-subHeading roboto-light font-dark-grey"><a class="noUnderline font-link-blue" href="javascript:void(0)" translate="DOWNLOAD" ng-click="reviewFDVm.download()"></div>';
								}
							}
							else {
								template = '<div class ="congratsOD"><img src="img/happyface.svg" height="45" width="45" class="happyFaceOD"></div><div class="button_fund_closure RFDpopup fontSize-heading roboto-regular font-dark-grey" translate="CONGRATSNEW"></div><div class="button_fund_closure fontSize-subHeading roboto-light font-dark-grey" translate="FD_TAXCREATE" translate-values="{FDnumber:reviewFDVm.maskedAccNumber}"></div><div class="FDpopup-styling fontSize-subHeading roboto-light font-dark-grey"><a class="noUnderline font-link-blue" href="javascript:void(0)" translate="DOWNLOAD" ng-click="reviewFDVm.download()"></div>';
							}
						}
					
						reviewFDVm.successPopup = $ionicPopup.show({
							title: title,
							template: template,
							scope: $scope,
							cssClass: 'my-custom-popup',
							buttons: [{
								text: 'OK',
								type: 'button-assertive',
								onTap: function () {
									getAccountDetailsService.accountOverviewData = "";
									reviewFDService.clearFDData();
									fixedDepositService.customer = {};
									reviewFDVm.successPopup.close();
									$state.go('menu.accountOverviewMyBalance');
								}
							}],
						});
					}
				}
				else {
					reviewFDVm.storeRefNumber = utilityService.getValue(data.storeRefNumber);
					template = '<div class ="congratsOD"><img src="img/happyface.svg" height="45" width="45" class="happyFaceOD"></div><div class="button_fund_closure RFDpopup fontSize-heading roboto-regular font-dark-grey" translate="CONGRATSNEW"></div><div class="button_fund_closure fontSize-subHeading roboto-light font-dark-grey" translate="NM_FDCREQUEST" translate-values="{requestNumber:reviewFDVm.storeRefNumber}"></div><div class="FDpopup-margin fontSize-subHeading roboto-light font-dark-grey" translate="FDNM_INFO"></div>';
					reviewFDVm.successPopup = $ionicPopup.show({
						title: title,
						template: template,
						scope: $scope,
						cssClass: 'my-custom-popup',
						buttons: [{
							text: 'OK',
							type: 'button-assertive',
							onTap: function () {
								getAccountDetailsService.accountOverviewData = "";
								reviewFDService.clearFDData();
								fixedDepositService.customer = {};
								reviewFDVm.successPopup.close();
								$state.go('menu.accountOverviewMyBalance');
							}
						}],
					});
				}
			}, function (error) {
				//YONOIT-1540 starts
				//reviewFDVm.shortDisableNext = "";
				reviewFDVm.isChecked = false;
				//utilityService.showErrorMessage(error.responseMessage);

				var template = '<div class="popup-padding font-dark-grey"><div><center><img class="approvedIconPosition" src="img/FT/BhimUpi/errorSymbol.svg"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><span class="popUp-msg-color">' + error.responseMessage + '</span></div></div></div>';
				reviewFDVm.successPopup = $ionicPopup.show({
					title: '',
					template: template,
					scope: $scope,
					cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup',
					buttons: [{
						text: 'OK',
						type: 'button-assertive',
						onTap: function () {
							getAccountDetailsService.accountOverviewData = "";
							reviewFDService.clearFDData();
							fixedDepositService.customer = {};
							$state.go('menu.accountOverviewMyBalance');
						}
					}],
				}); //YONOIT-1540 ends
			});
		}

		function b64toBlob(b64Data, contentType, sliceSize) {
			contentType = contentType || '';
			sliceSize = sliceSize || 512;

			var byteCharacters = atob(b64Data);
			var byteArrays = [];

			for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
				var slice = byteCharacters.slice(offset, offset + sliceSize);

				var byteNumbers = [];
				for (var i = 0; i < slice.length; i++) {
					byteNumbers[i] = slice.charCodeAt(i);
				}

				var byteArray = new Uint8Array(byteNumbers);

				byteArrays.push(byteArray);
			}

			var blob = new Blob(byteArrays, { type: contentType });
			return blob;
		}

		function savebase64AsPDF(folderpath, filename, content, contentType) {
			var contentStr = atob(content);
            var contentLen = contentStr.length;

            if (contentLen >= constantConfig.accOverview.pdfSize) {                           
                utilityService.showErrorMessage(constantConfig.accOverview.sizeLimitMessage);
                return;
            }
			// Convert the base64 string in a Blob
			var DataBlob = b64toBlob(content, contentType);
			filename = filename + ".pdf";
			window.resolveLocalFileSystemURL(folderpath, function (dir) {
				dir.getFile(filename, { create: true }, function (file) {
					file.createWriter(function (fileWriter) {
						fileWriter.write(DataBlob);

					}, function () {

					});
				});
			});
		}

		reviewFDVm.download = function () {
			reviewFDService.fetchDownloadReceiptURL(fixedDepositService.customer, reviewFDVm).then(function (data) {
				var content = data.content;
				var filename = data.fileName;
				var contentType = "application/pdf";
				if (utilityService.isAndroidPlatform()) {
					reviewFDVm.folderpath = cordova.file.externalRootDirectory;
				}
				if (utilityService.isIOSPlatform()) {
					reviewFDVm.folderpath = cordova.file.documentsDirectory;
				}
				savebase64AsPDF(reviewFDVm.folderpath, filename, content, contentType);
				if (utilityService.isIOSPlatform()) {
					filename = filename + ".pdf";
					var finalObject = { "folderpath": reviewFDVm.folderpath, "filename": filename };
					openUrlInAppbroswerService.openUrl("data:application/pdf;base64," + content + "","");
					getAccountDetailsService.accountOverviewData = "";
					if(reviewFDVm.successPopup) {
						reviewFDVm.successPopup.close();
					}
					reviewFDService.clearFDData();
					fixedDepositService.customer = {};
					$state.go('menu.accountOverviewMyBalance');
				}
				/* to show information popup for downlaod receipt, which will tell user format of passowrd for android and ios */
				if (utilityService.isAndroidPlatform()) {
					var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="DOWNLOADFDRECEIPT" translate-values="{folderpath:reviewFDVm.folderpath}"></div>';
					//var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="PASSWORD_INFO1"></div><div class="FDpopup-styling FDpopup-margin fontSize-subHeading roboto-light font-dark-grey" translate="PASSWORD_INFO2"></div>';
					reviewFDVm.downloadPopup = $ionicPopup.show({
						title: '',
						template: template,
						scope: $scope,
						cssClass: 'my-custom-popup',
						buttons: [{
							text: 'OK',
							type: 'button-assertive',
							onTap: function () {
								getAccountDetailsService.accountOverviewData = "";
								reviewFDVm.downloadPopup.close();
								if(reviewFDVm.successPopup) {
									reviewFDVm.successPopup.close();
								}
								reviewFDService.clearFDData();
								fixedDepositService.customer = {};
								$state.go('menu.accountOverviewMyBalance');
							}
						}],
					});
				}
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		}


		reviewFDVm.applyOD = function () {
			fixedDepositService.selectedDetails = {
				accountType: '',
				accountNumber: '',
				accountBalance: '',
				isActive: '',
				isTransactional: '',
				branchCode: '',
				branchName: '',
				intCategory: '',
				accountTypeCode: ''
			};
			fixedDepositService.customer.indexId = 0;
			fixedDepositService.customer.fdnumber = reviewFDVm.FDnumber;
			fixedDepositService.customer.ODIntRate = reviewFDVm.odInterestRate;
			fixedDepositService.customer.ODLimit = reviewFDVm.odLimit;
			fixedDepositService.customer.ODExyDate = reviewFDVm.odExpiryDate;
			fixedDepositService.customer.AODclick = "reviewfd";
			if(reviewFDVm.successPopup) {
				reviewFDVm.successPopup.close();
			}
			$state.go('menu.overdraft');
		}

		reviewFDVm.getNomineeDetails = function () {
			if(!reviewFDService.isNomineeAvailable){
				reviewFDVm.reviewFD = {
					account: fixedDepositService.customer.selectedItem,
					branchCode: fixedDepositService.customer.branchCode
				};
				reviewFDService.getNomineeDetails(reviewFDVm.reviewFD).then(function (data) {
					fixedDepositService.customer.showNominee = utilityService.getValue(data.hideNominee);
					fixedDepositService.customer.age = utilityService.getValue(data.ageofGuardian);
					fixedDepositService.customer.dob = utilityService.getValue(data.dob);
					fixedDepositService.customer.relation = utilityService.getValue(data.relation);
					fixedDepositService.customer.guardian = utilityService.getValue(data.nomineeGuardian);
					fixedDepositService.customer.address1 = utilityService.getValue(data.address1);
					fixedDepositService.customer.address2 = utilityService.getValue(data.address2);
					fixedDepositService.customer.nominee = utilityService.getValue(data.name);
					reviewFDService.isNomineeAvailable = true;
					if (fixedDepositService.customer.dob !== "" && fixedDepositService.customer.dob !== undefined && fixedDepositService.customer.dob !== null) {
						fixedDepositService.customer.minorFlag = true;
						if (fixedDepositService.customer.dob.length > 8) {
							var month = ["JAN", "FEB", "MAR", "APR", "MAY", "JUN", "JUL", "AUG", "SEP", "OCT", "NOV", "DEC"];
							var newCustDate = fixedDepositService.customer.dob.split(" ");
							var getYear = parseInt(newCustDate[2]);
							var getMonth = newCustDate[1];
							var getDay = parseInt(newCustDate[0]);
							for (var i = 0; i < month.length; i++) {
								if (month[i] === getMonth) {
									var getNewMonth = i;
								}
							}
							getNewMonth = getNewMonth + 1;
							if (getNewMonth <= 9) {
								getNewMonth = "0" + getNewMonth;
							}
							if (getDay <= 9) {
								getDay = "0" + getDay;
							}
							reviewFDVm.dob = "" + getDay + getNewMonth + getYear;
						} else {
							reviewFDVm.dob = fixedDepositService.customer.dob;
						}
					} else {
						fixedDepositService.customer.minorFlag = false;
						reviewFDVm.dob = "";
					}
					if (fixedDepositService.customer.showNominee === true) {
						fixedDepositService.customer.nameToBePrintedFlag = "N";
					} else {
						fixedDepositService.customer.nameToBePrintedFlag = "Y";
					}
				}, function (error) {
					reviewFDService.isNomineeAvailable = false;
					utilityService.showErrorMessage(error.responseMessage);
				});
			}
		}

		$scope.$on('$ionicView.loaded', function () {
			initPage();
			reviewFDVm.moduleName = "FixedDeposit";
			reviewFDVm.actionName = "NomineeDetails";
			if(!reviewFDService.nightModeFlag) {
				fixedDepositService.fetchNightModeStatus(reviewFDVm, true).then(function (data) {
					reviewFDService.nightModeFlag = true;
					reviewFDService.nightMode = data.nightMode === "Y" ? true : false;
					reviewFDVm.nightMode = reviewFDService.nightMode;
					if (!reviewFDService.nightMode && utilityService.isUndefined(fixedDepositService.customer.nominee)) {
						reviewFDService.isNomineeAvailable = false;
						reviewFDVm.getNomineeDetails();
					}
				}, function (error) {
					reviewFDService.nightModeFlag = false;
					utilityService.showErrorMessage(error.responseMessage);
				});
			} else {
				reviewFDVm.nightMode = reviewFDService.nightMode;
				if (!reviewFDService.nightMode && utilityService.isUndefined(fixedDepositService.customer.nominee)) {
					reviewFDService.isNomineeAvailable = false;
					reviewFDVm.getNomineeDetails();
				}
			}
		});

		$scope.$on('$ionicView.beforeEnter', function () {
			if (!utilityService.isUndefined(fixedDepositService.customer.dob)) {
				reviewFDVm.dob = $filter('date')(fixedDepositService.customer.dob, "ddMMyyyy")
			}

			reviewFDVm.days = fixedDepositService.customer.days;
			if (!reviewFDVm.days) {
				reviewFDVm.days = 0;
			}
			reviewFDVm.months = fixedDepositService.customer.months;
			if (!reviewFDVm.months) {
				reviewFDVm.months = 0;
			}
			reviewFDVm.years = fixedDepositService.customer.years;
			if (!reviewFDVm.years) {
				reviewFDVm.years = 0;
			}
			reviewFDVm.customerName = customerInfoService.customer.name;
			reviewFDVm.emailID = customerInfoService.customer.emailID;
			reviewFDVm.mobile = customerInfoService.customer.mobile;
			reviewFDVm.title = customerInfoService.customer.title;
			reviewFDVm.isChecked = false;
			reviewFDVm.showCancel = true;
			reviewFDVm.showConfirm = true;
			reviewFDVm.disableconfirm = true;
			fixedDepositService.customer.custName = customerInfoService.customer.name;
			reviewFDVm.custAccount = fixedDepositService.customer.selectedItem;
			reviewFDVm.custName = fixedDepositService.customer.custName;
			reviewFDVm.pAmountdata = fixedDepositService.customer.amountData;
			reviewFDVm.maturityDate = fixedDepositService.customer.maturitydateFD;
			reviewFDVm.maturitydateRequest = fixedDepositService.customer.maturitydateFDRequest;
			reviewFDVm.maturityAmount = fixedDepositService.customer.maturityAmount;
			reviewFDVm.interestRate = fixedDepositService.customer.interestRate;
			reviewFDVm.interestPayout = fixedDepositService.customer.interestPayout;
			reviewFDVm.intpayoutservice = fixedDepositService.customer.intpayoutservice;
			reviewFDVm.maturityInstruction = fixedDepositService.customer.maturityInstruction;
			reviewFDVm.matInstService = fixedDepositService.customer.matInstService;
			reviewFDVm.isTaxable = fixedDepositService.customer.isTaxable;
			fixedDepositService.customer.nomineeClick = '';
			fixedDepositService.customer.AODclick = '';
			reviewFDVm.modeOfOperation = fixedDepositService.customer.modeOfOperation;
			if(reviewFDVm.modeOfOperation === "OWN"){
				reviewFDVm.modeOfOperation = "Single";
			}
			else{
				reviewFDVm.modeOfOperation = reviewFDVm.modeOfOperation;
			}

			if(!reviewFDVm.maturityDate || !reviewFDVm.maturityAmount || !reviewFDVm.interestRate) {
				reviewFDVm.noDataAvailable = true;
			} else {
				reviewFDVm.noDataAvailable = false;
			}
			
			reviewFDVm.eyesOffFun(reviewFDVm.custAccount);
		});

		$scope.$on('$ionicView.afterLeave', function () {
			//any cleanup needs to be done here: executes everytime when page is left
		});
		return this;
	}]);