angularApp.service('reviewFDService',
	function ($q, AdapterUtils,fixedDepositService, myDreamsService) {
		var FDservice = this;
		FDservice.taxSaverFDTnC = "";
		FDservice.normalFDTnC = "";
		FDservice.nightMode = false;
		FDservice.nightModeFlag = false;
		FDservice.isNomineeAvailable = false;
		
		FDservice.clearFDData= function () {
			FDservice.taxSaverFDTnC = "";
			FDservice.normalFDTnC = "";
			FDservice.nightMode = false;
			FDservice.nightModeFlag = false;
			FDservice.isNomineeAvailable = false;
		}

		FDservice.getNomineeDetails = function (data) {
			var q = $q.defer();
			var obj = {
				"fdAccountNumber": data.account,
				"branchCode": data.branchCode
			};
			AdapterUtils.postData("adapters/FixedDepositAdapter/fetchNomineeDetails", obj, false).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		FDservice.createFixedDeposit = function (data, rVM) {
			var q = $q.defer();
			var obj = {
				"amount": data.amountData.toString().split(',').join(""),
				"debitAccountNumber": data.selectedItem,
				"tenureDuration": {
					"days": rVM.days,
					"months": rVM.months,
					"years": rVM.years
				},
				"maturityDate": data.maturitydateFDRequest,
				"interestRate": data.interestRate,
				"nominee": {
					"name": data.nominee,
					"relation": data.relation,
					"ageofGuardian": data.age,
					"nomineeGuardian": data.guardian,
					"address1": data.address1,
					"address2": data.address2,
					"dob": rVM.dob,
					"hideNominee": data.showNominee
				},
				"interestPayout": data.intpayoutservice,
				"maturityInstruction": data.matInstService,
				"taxSaver": data.isTaxable,				
				"isSeniorCitizen": data.isSenior,
				"nameToBePrintedFlag": data.nameToBePrintedFlag,
				"minorFlag": data.minorFlag,
				"isStaffFlag": rVM.isStaffFlag,
				"name": rVM.customerName,
				"emailID": rVM.emailID,
				"maturityAmount": data.maturityAmount,
				"modeOfOperation": rVM.modeOfOperation,
				"mobile": rVM.mobile,
				"title": rVM.title,
				"branchCode": data.branchCode,
				"branchName": data.branchName,
				"termsNcondition": rVM.checkTnC,
				"intCategory": data.intCategory,
				"accountTypeCode": data.accountTypeCode
			};

			if(myDreamsService.selectedDreamDetails && myDreamsService.selectedDreamDetails.dreamId){
				obj["dreamID"] = myDreamsService.selectedDreamDetails.dreamId;
			}

			AdapterUtils.postData("adapters/FixedDepositAdapter/createFixedDeposit", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		FDservice.fetchDownloadReceiptURL = function (data, fdVM) {
			var q = $q.defer();
			var obj = {
				"fdAccountNumber": data.fdAccountNumber,
				"docId": fdVM.docId
			};
			AdapterUtils.postData("adapters/FixedDepositAdapter/fetchDownloadReceiptURL", obj, true).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		FDservice.fetchRtaxtermcondition = function () {
			var q = $q.defer();
			AdapterUtils.getData("adapters/FixedDepositAdapter/fetchTaxSaverTermsandConditions", true).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		FDservice.fetchRtermcondition = function () {
			var q = $q.defer();
			AdapterUtils.getData("adapters/FixedDepositAdapter/fetchTermsandConditions", true).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		return FDservice;
	});  