'use strict';

angularApp.controller('ftPaymentController', [
	"$state",
	"$scope",
	"$ionicPopup",
	"utilityService",
	"$rootScope",
	"constantConfig",
	"bQRService",
	"ionicToast",
	"bhimUpiService",
	"customerInfoService",

	function ($state,
		$scope,
		$ionicPopup,
		utilityService,
		$rootScope,
		constantConfig,
		bQRService,
		ionicToast,
		bhimUpiService,
		customerInfoService) {

		var ftPaymentVm = this;

		ftPaymentVm.cancelPayment = function () {
			if (customerInfoService.scanQrEntrypoint && customerInfoService.scanQrEntrypoint !== 'FTLANDING') {
				$state.go('menu.fundtrans');
			} else {
				$state.go('menu.fundsTransferLanding');
			}
		}

		function initPage() {
			ftPaymentVm.merchantImage = "img/bharatQR/QR_Code.png";
			ftPaymentVm.cardImage = "img/bharatQR/MasterCard.png";

			ftPaymentVm.disablesubmit = true;
			ftPaymentVm.cardHideShow = false;
			ftPaymentVm.vpaHideShow = false;
			ftPaymentVm.checkBalanceFlag = false;
			ftPaymentVm.availBalanceFlag = false;
			ftPaymentVm.accountSelectFlag = false;
			ftPaymentVm.checkbalance = false
			ftPaymentVm.AvailFlag = false;

			if (bQRService.selectedVpaDetails.cardSelectedType) {
				if (bQRService.selectedVpaDetails.cardSelectedType == "card") {
					ftPaymentVm.valChecked = "card";
					ftPaymentVm.cardHideShow = true;
					ftPaymentVm.vpaHideShow = false;
				} else {
					ftPaymentVm.valChecked = "vpa";
					ftPaymentVm.cardHideShow = false;
					ftPaymentVm.vpaHideShow = true;
				}
			}

			if (bQRService.accountUserSelected) {
				ftPaymentVm.accountArray = bQRService.accountUserSelected;
			}

			if (bQRService.accountUserSelectedMain) {
				ftPaymentVm.accountSelectedArray = bQRService.accountUserSelectedMain;
			}

			ftPaymentVm.remark = bQRService.selectedVpaDetails.remarks;
			ftPaymentVm.Vpa = bQRService.selectedVpaDetails.selectedVPAAccount;
			ftPaymentVm.selectedValueVpa = bQRService.selectedVpaDetails.selectedVPAAccountDetails;

			if (ftPaymentVm.Vpa && ftPaymentVm.selectedValueVpa) {
				ftPaymentVm.disablesubmit = false;
			}
		};

		ftPaymentVm.getCheckedbalance = function () {
			ftPaymentVm.checkbalance = false;
			ftPaymentVm.accountSelectFlag = true;
		}

		ftPaymentVm.selectAccount = function () {
			if (ftPaymentVm.selectedValueCard) {
				var data = ftPaymentVm.selectedValueCard.split(",");
				var a = [];
				a.accountNumber = data[0];
				a.accountBalance = data[1];
				a.accountType = data[2];
				a.indexPos = data[3];
				ftPaymentVm.indexPos = a.indexPos;
				ftPaymentVm.selectedAccountNumber = a.accountNumber;
				ftPaymentVm.availCardBalance = a.accountBalance;
				bQRService.payByCard.accountDetails = ftPaymentVm.selectedValueCard;
				bQRService.payByCard.availBalance = ftPaymentVm.availCardBalance;
				bQRService.viewDebitCards(ftPaymentVm.selectedAccountNumber).then(function (response) {
					console.log(response);
					ftPaymentVm.disablesubmit = false;
					ftPaymentVm.accountSelectFlag = true;
					ftPaymentVm.cardList = response.cardList;
				}, function (error) {
					ftPaymentVm.disablesubmit = true;
					utilityService.showBhimUpiAlert("error", error.responseMessage);
				});
			}
		};

		ftPaymentVm.getCheckedValue = function (value) {
			bQRService.selectedVpaDetails.cardSelectedType = value;
			ftPaymentVm.valChecked = value;
			bQRService.selectedVpaDetails.selectedValue = value;
			if (value == "card") {
				ionicToast.show("Coming soon", 'bottom', false, 2000);
				// ftPaymentVm.cardHideShow = true;
				// ftPaymentVm.vpaHideShow = false;
				// ftPaymentVm.disablesubmit = false;
				// ftPaymentVm.accountFilterRequest();
			} else {
				ftPaymentVm.cardHideShow = false;
				ftPaymentVm.vpaHideShow = true;
				ftPaymentVm.disablesubmit = false;
				ftPaymentVm.selectVpaAccount();
			}
		}

		ftPaymentVm.selectVpaAccount = function () {
			// bQRService.accountDetailsSelected = [];
			if ($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNN') {
				utilityService.showBhimUpiAlert("alert", "You are not registered for UPI. Please register through BHIM UPI to make the payments.");
			} else if (($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNN') || ($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNM')) {
				utilityService.showBhimUpiAlert("alert", "It looks that you have changed Device/Sim. Please re-register through BHIM UPI to make the payments.");
			} else {
				ftPaymentVm.getVpaListByAcc();
			}
		}

		ftPaymentVm.getVpaListByAcc = function () {
			ftPaymentVm.disablesubmit = true;
			if (ftPaymentVm.Vpa) {
				bQRService.selectedVpaDetails.selectedVPAAccount = ftPaymentVm.Vpa;
				var indexValue = ftPaymentVm.Vpa.split(',');
				var selectedVpa = indexValue[0];
				var indexValueData = indexValue[1];
				ftPaymentVm.selectedValueVpa = '';

				for (var i = 0; i < bQRService.accountDetailsSelected.length; i++) {
					if (bQRService.accountDetailsSelected[i].virtualAddress == selectedVpa) {
						ftPaymentVm.accountSelectedArray = [];
						ftPaymentVm.accountSelectedArray = bQRService.accountDetailsSelected[i].accountInfo;
						bQRService.accountUserSelectedMain = ftPaymentVm.accountSelectedArray;
					}
				}

			} else {
				ftPaymentVm.selectedValueVpa = '';
				ftPaymentVm.disablesubmit = true;


				ftPaymentVm.accountArray = [];
				utilityService.showSpinner();
				var json = JSON.stringify({
					"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
					"requestInfo": {
						"pspId": constantConfig.upiConstant.pspId,
						"pspRefNo": generateRandomString(27)
					},
					"updateFlag": constantConfig.upiConstant.updateFlag
				});
				bhimUpiService.getNativeData(constantConfig.upiConstant.getProfile, json).then(function (data) {
					if (JSON.parse(data).status === "S") {
						var profileObject = JSON.parse(data);
						ftPaymentVm.selectedAccDetails = profileObject.vpaAccountDetails;
						bQRService.accountDetailsSelected = profileObject.vpaAccountDetails;
						for (var i = 0; i < profileObject.vpaAccountDetails.length; i++) {
							ftPaymentVm.accountArray.push(profileObject.vpaAccountDetails[i].virtualAddress);
						}
						bQRService.accountUserSelected = ftPaymentVm.accountArray;
						if (ftPaymentVm.Vpa) {
							ftPaymentVm.accountSelectedArray = [];
							ftPaymentVm.accountSelectedArray = profileObject.vpaAccountDetails[indexValueData].accountInfo;
							bQRService.accountUserSelectedMain = ftPaymentVm.accountSelectedArray;
						}
						utilityService.hideSpinner();
					} else {
						utilityService.hideSpinner();
						utilityService.showBhimUpiAlert("error", JSON.parse(data).statusDesc);
					}
				}, function (msg) {
					utilityService.hideSpinner();
					utilityService.showBhimUpiAlert("error", msg);
				});
			}
		}

		ftPaymentVm.selectVpaAccountList = function () {
			ftPaymentVm.AvailFlag = false;
			if (!ftPaymentVm.selectedValueVpa)
				ftPaymentVm.disablesubmit = true;
			else
				ftPaymentVm.disablesubmit = false;
			bQRService.selectedVpaDetails.selectedVPAAccountDetails = ftPaymentVm.selectedValueVpa;
		}

		ftPaymentVm.goToNextPage = function () {
			if (ftPaymentVm.valChecked == "vpa" && ftPaymentVm.amountVal > 100000) {
				utilityService.showBhimUpiAlert("error", "Transaction amount should not be more than ₹1,00,000");
				return false;
			}
			bQRService.selectedVpaDetails.remarks = ftPaymentVm.remark;
			bQRService.selectedVpaDetails.selectedVPAAccount = ftPaymentVm.Vpa;
			var indexValue = ftPaymentVm.Vpa.split(',');
			var indexValueData = indexValue[0];
			bQRService.selectedVpaDetails.vpaName = indexValueData;
			bQRService.selectedVpaDetails.selectedVPAAccountDetails = ftPaymentVm.selectedValueVpa;
			if (ftPaymentVm.selectedValueVpa) {
				var selectedObject = JSON.parse(ftPaymentVm.selectedValueVpa);
				bQRService.selectedVpaDetails.accountSelected = selectedObject.maskedAccountNumber;
				bQRService.selectedVpaDetails.accountIdSelected = selectedObject.accId;
				bQRService.selectedVpaDetails.bankCode = selectedObject.bankCode;
			}
			bQRService.payByCard.payByCardObj = ftPaymentVm.viewCardNumer;

			bQRService.payByCard.cardList = ftPaymentVm.cardList;
			bQRService.payByCard.accountList = ftPaymentVm.accountDetails;
			$state.go("menu.reviewPayment");
		}

		ftPaymentVm.balanceEnquiry = function () {
			utilityService.showSpinner();
			var selectedObject = JSON.parse(ftPaymentVm.selectedValueVpa);
			var indexValue = ftPaymentVm.Vpa.split(',');
			var indexValueData = indexValue[0];
			var json = JSON.stringify({
				"accountId": selectedObject.accId,
				"addInfo": {
					"addInfo10": constantConfig.upiConstant.addInfo10,
					"addInfo9": constantConfig.upiConstant.addInfo9
				},
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"virtualAddress": indexValueData
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.onBalanceEnquiry, json).then(function (data) {
				var checkBalRes = JSON.parse(data).apiResp;
				utilityService.hideSpinner();
				if (checkBalRes.status === 'S') {
					ftPaymentVm.AvailFlag = true;
					console.log(checkBalRes);
					ftPaymentVm.availBalance = checkBalRes.accountInfo.accountBalance;
					bQRService.selectedVpaDetails.availBalance = ftPaymentVm.availBalance;
				} else {
					utilityService.hideSpinner();
					utilityService.showBhimUpiAlert("error", JSON.parse(data).statusDesc);
				}
			}, function (msg) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		}

		$scope.$on('$ionicView.beforeEnter', function () {
			ftPaymentVm.merchantDetails = bQRService.merchantDetails;
			ftPaymentVm.transactionAmount = Number.parseFloat(bQRService.transactionAmount) + Number.parseFloat(bQRService.convenienceFee);
			utilityService.hideSpinner();
		});

		ftPaymentVm.goBacktoPrevious = function () {
			$state.go("menu.scanPay");
		}

		ftPaymentVm.accountFilterRequest = function () {
			if (!bQRService.accountDetails.length) {
				bQRService.accountFilter().then(function (data) {
					console.log(data)
					ftPaymentVm.accountDetails = data.accList;
					bQRService.accountDetails = ftPaymentVm.accountDetails;
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			} else {
				ftPaymentVm.accountDetails = bQRService.accountDetails;
				bQRService.accountDetails = ftPaymentVm.accountDetails;
			}
		}

		$scope.$on('$ionicView.loaded', function () {
			initPage();
		});

		$scope.goToHome = function () {
			$state.go('menu.fundsTransfer');
		}

		return this;
	}]);