'use strict';

angularApp.controller('reviewPaymentController', [
	"$state",
	"$scope",
	"$ionicPopup",
	"utilityService",
	"$rootScope",
	"constantConfig",
	"fTReviewDetails_VPAService",
	"bhimUpiService",
	"bQRService",
	"customerInfoService",
	function ($state,
		$scope,
		$ionicPopup,
		utilityService,
		$rootScope,
		constantConfig,
		fTReviewDetails_VPAService,
		bhimUpiService,
		bQRService,
		customerInfoService) {

		var reviewPaymentVm = this;

		reviewPaymentVm.cancelPayment = function () {
			if (customerInfoService.scanQrEntrypoint && customerInfoService.scanQrEntrypoint !== 'FTLANDING') {
				$state.go('menu.fundtrans');
			} else {
				$state.go('menu.fundsTransferLanding');
			}
		}

		function initPage() {
			reviewPaymentVm.merchantImage = "img/bharatQR/QR_Code.png";
			reviewPaymentVm.cardSelected = false;
			reviewPaymentVm.vpaSelected = false;
			reviewPaymentVm.disablesubmit = true;
			reviewPaymentVm.merchantNameVal = bQRService.merchantDetails.merchantName;
			reviewPaymentVm.cardImage = "img/bharatQR/MasterCard.png";
			reviewPaymentVm.amountVal = Number.parseFloat(bQRService.transactionAmount) + Number.parseFloat(bQRService.convenienceFee);

			reviewPaymentVm.accountType = bQRService.merchantDetails.accountType;
			reviewPaymentVm.remarks = bQRService.selectedVpaDetails.remarks;
			if (bQRService.selectedVpaDetails.selectedValue == "card") {
				var accountData = bQRService.payByCard.accountDetails.split(',');
				var cardData = JSON.parse(bQRService.payByCard.payByCardObj);
				reviewPaymentVm.accountNumber = accountData[0];
				reviewPaymentVm.selectedCard = cardData.cardNo;
				reviewPaymentVm.cardSelected = true;
			} else {
				reviewPaymentVm.vpaSelected = true;
				reviewPaymentVm.vpa = bQRService.selectedVpaDetails.vpaName;
				reviewPaymentVm.accountNumber = bQRService.selectedVpaDetails.accountSelected;
				reviewPaymentVm.bankLogo = bQRService.selectedVpaDetails.bankCode;
			}
		}

		reviewPaymentVm.closePopup = function () {
			reviewPaymentVm.closeTnC.close();
			utilityService.hideSpinner();
		}

		reviewPaymentVm.termconditionPopUp = function (TnCDetails) {
			var title = 'Terms & Conditions';
			var templateUrl;
			var cssClass = "ODtncPopup";
			var onTap = '';
			templateUrl = '<div class="fontSize-subHeading font-content roboto-light" ng-click="reviewPaymentVm.closePopup()">' + TnCDetails + '</div>';
			reviewPaymentVm.closeTnC = bQRService.showTnCAlertModal(title, templateUrl, onTap, cssClass, "OK", $state);
		}

		//public functions end
		reviewPaymentVm.termcondition = function () {
			if (bQRService.normalBharatTnC == "") {
				var obj = {
					"type": "bharatQrTnC"
				}
				bQRService.fetchRtermcondition(obj).then(function (data) {
					if (!utilityService.isUndefined(data)) {
						bQRService.normalBharatTnC = data;
						reviewPaymentVm.termconditionPopUp(bQRService.normalBharatTnC);
					}
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			} else {
				reviewPaymentVm.termconditionPopUp(bQRService.normalBharatTnC);
			}
		}

		reviewPaymentVm.getCBValue = function (isChecked) {
			if (isChecked === true) {
				reviewPaymentVm.disablesubmit = false;
			} else {
				reviewPaymentVm.disablesubmit = true;
			}
		}

		reviewPaymentVm.goBacktoPrevious = function () {
			$state.go('menu.ftPayment');
		}

		$scope.goToHome = function () {
			$state.go('menu.fundsTransfer');
		}

		reviewPaymentVm.goToNextPage = function () {
			reviewPaymentVm.payment();
		}

		reviewPaymentVm.payment = function () {
			utilityService.showSpinner();
			if (bQRService.selectedVpaDetails.selectedValue == "vpa") {
				var json = JSON.stringify({
					"addInfo": {
						"addInfo10": constantConfig.upiConstant.addInfo10,
						"addInfo9": constantConfig.upiConstant.addInfo9
					},
					"amount": reviewPaymentVm.amountVal,
					"expiryTime": 0,
					"payeeType": {
						"name": reviewPaymentVm.merchantNameVal,
						"virtualAddress": bQRService.merchantDetails.virtualPaymentAddress,
						"vpaType": constantConfig.upiConstant.vpaType
					},
					"payerType": {
						"accountId": bQRService.selectedVpaDetails.accountIdSelected,
						"virtualAddress": reviewPaymentVm.vpa
					},
					"requestInfo": {
						"pspId": constantConfig.upiConstant.pspId,
						"pspRefNo": generateRandomString(27)
					},
					"transactionNote": reviewPaymentVm.remarks || "",
					"upiTransRefNo": 0
				});
				bhimUpiService.getNativeData(constantConfig.upiConstant.onPayInitiation, json).then(function (data) {
					reviewPaymentVm.paymentResponse = data;
					reviewPaymentVm.displayPaymentResp(reviewPaymentVm.paymentResponse);
				}, function (msg) {
					utilityService.hideSpinner();
					if (msg != -101)
						utilityService.showBhimUpiAlert("error", msg);
				});
			} else {
				bQRService.processPayment().then(function (data) {
					console.log("processPayment", data)
					reviewPaymentVm.successPopup = $ionicPopup.show({
						title: '',
						template: '<div class="text-center">Transaction Successful!</div><div class="button_fund_closure RFDpopup fontSize-heading roboto-regular font-dark-grey">You have paid ' + reviewPaymentVm.amountVal + ' successfully to ' + reviewPaymentVm.merchantNameVal + '.</div><div class="FDpopup-margin fontSize-subHeading roboto-light font-dark-grey">Remaining Balance in A/c ' + reviewPaymentVm.accountNumber + ' is ' + bQRService.payByCard.availBalance + '.</div>',
						scope: $scope,
						cssClass: 'my-custom-popup',
						buttons: [{
							text: 'OK',
							type: 'button-assertive',
							onTap: function () {
								reviewPaymentVm.successPopup.close();
								bQRService.initialValueStage();
								$state.go('menu.fundsTransferLanding');
							}
						}],
					});
				}, function (msg) {
					utilityService.hideSpinner();
					utilityService.showBhimUpiAlert("error", msg);
				});
			}
		}

		reviewPaymentVm.displayPaymentResp = function (data) {
			utilityService.hideSpinner();
			if (JSON.parse(data).apiResp.status == 'S') {
				utilityService.setCsatJournies("fundTransfer");
				$state.go('menu.bharatQrSuccess');
			} else if (JSON.parse(data).apiResp.status == 'F') {
				if (JSON.parse(data).apiResp.responseMsg) {
					utilityService.showBhimUpiAlert("error", JSON.parse(data).apiResp.responseMsg, "menu.fundsTransferLanding");
				} else {
					utilityService.showBhimUpiAlert("error", JSON.parse(data).apiResp.statusDesc, "menu.fundsTransferLanding");
				}
			} else {
				utilityService.showBhimUpiAlert("error", JSON.parse(data).apiResp.statusDesc, "menu.fundsTransferLanding");
			}
		};

		$scope.$on('$ionicView.loaded', function () {
			initPage();
		});

		return this;

	}]);