'use strict';

angularApp.controller('generateQrController', ["$state",
	"$ionicPopup",
	"$scope",
	"customerInfoService",
	"utilityService",
	"constantConfig",
	"$rootScope",
	"$timeout",

	function ($state,
		$ionicPopup,
		$scope,
		customerInfoService,
		utilityService,
		constantConfig,
		$rootScope,
		$timeout) {

		var generateQrVm = this;

		generateQrVm.shareQrCode = function (share) {
			if (device.platform.toLowerCase() == 'ios') {
				var myBaseString = generateQrVm.vpaImage;
				var block = myBaseString.split(";");
				var dataType = block[0].split(":")[1];
				var myBase64 = block[1].split(",")[1];

				var successCallback = function (data) {
					
				}
				var failureCallback = function (error) {
					
				}
				cordova.exec(successCallback, failureCallback, "HyperTrackWrapper", "shareImage", [myBase64]);
			} else {
				if (generateQrVm.vpaImage) {
					var params = {
						data: generateQrVm.vpaImage,
						format: 'JPG',
						quality: 80,
						mediaScanner: true
					};

					var myBaseString = generateQrVm.vpaImage;
					var block = myBaseString.split(";");
					var dataType = block[0].split(":")[1];
					var myBase64 = block[1].split(",")[1];
					var displayTime = function () {
						var str = "";

						var currentTime = new Date();
						var hours = currentTime.getHours();
						var minutes = currentTime.getMinutes();
						var seconds = currentTime.getSeconds();

						if (minutes < 10) {
							minutes = "0" + minutes;
						}
						if (seconds < 10) {
							seconds = "0" + seconds;
						}
						str += hours + ":" + minutes + " ";
						if (hours > 11) {
							str += "PM";
						} else {
							str += "AM";
						}
						return str;
					};
					var contentType = "image/png";
					var folderpath = cordova.file.externalRootDirectory;
					var filename = "UPI ID - " + generateQrVm.payeeVpa + ".png";
					generateQrVm.savebase64AsImageFile(folderpath, filename, myBase64, contentType, share);
				} else {
					utilityService.showBhimUpiAlert("error", "Kindly select the UPI ID");
				}
			}
		}

		generateQrVm.savebase64AsImageFile = function (folderpath, filename, content, contentType, share) {
			var DataBlob = generateQrVm.b64toBlob(content, contentType);
			if (device.version == 10) {
				folderpath = cordova.file.externalDataDirectory;
				window.resolveLocalFileSystemURL(folderpath, function (dir) {
					generateQrVm.popupFolderpath = dir.nativeURL + filename;
					dir.getFile(filename, { create: true }, function (file) {
						file.createWriter(function (fileWriter) {
							fileWriter.write(DataBlob);
							generateQrVm.downloadOrShare(share);
						}, function () {
							utilityService.showBhimUpiAlert("error", 'Unable to save file in path ' + folderpath);
						});
					});
				});
			}
			else {
				window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fileSystem) {
					fileSystem.root.getDirectory("Download", { create: true, exclusive: false }, function (dir) {
						generateQrVm.popupFolderpath = dir.nativeURL + filename;
						dir.getFile(filename, { create: true }, function (file) {
							file.createWriter(function (fileWriter) {
								fileWriter.write(DataBlob);
								generateQrVm.downloadOrShare(share);
							}, function () {
								utilityService.showBhimUpiAlert("error", 'Unable to save file in path ' + folderpath);
							});
						});
					});
				});
			}
		}
		generateQrVm.downloadOrShare = function (share) {
			if (share) {
				var options = {
						message: 'QR code - ', // not supported on some apps (i.e. Facebook, Instagram)
						subject: 'YONO QR Code : ' + generateQrVm.payeeVpa, // Subject. for email
						files: [generateQrVm.popupFolderpath], // an array of filenames either locally or remotely
						url: generateQrVm.payeeVpa,
						chooserTitle: 'Share YONO QR code' // Android only, you can override the default share sheet title
					};

				var onSuccess = function (result) {

				};
				var onError = function (msg) {

				}
				window.plugins.socialsharing.shareWithOptions(options, onSuccess, onError);
			} else if (!share) {
				var fileStoredAlert = $ionicPopup.show({
					template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src="img/FT/BhimUpi/successSymbol.svg" /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>QR Code downloaded successfully</span></div></div></div>',
					title: '',
					cssClass: 'bhim-alert-popup',
					scope: $scope,
					buttons: [{
						text: 'OK',
						type: 'button-positive',
						onTap: function (e) { }
					}]
				});
			}
		}
		generateQrVm.b64toBlob = function (b64Data, contentType, sliceSize) {
			contentType = contentType || '';
			sliceSize = sliceSize || 512;
			var byteCharacters = atob(b64Data);
			var byteArrays = [];
			//Check PDF SIZE
            if (byteCharacters.length >= constantConfig.accOverview.pdfSize) {
                utilityService.showErrorMessage(constantConfig.accOverview.sizeLimitMessage);
                return;
            }
			for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
				var slice = byteCharacters.slice(offset, offset + sliceSize);
				var byteNumbers = new Array(slice.length);
				for (var i = 0; i < slice.length; i++) {
					byteNumbers[i] = slice.charCodeAt(i);
				}
				var byteArray = new Uint8Array(byteNumbers);
				byteArrays.push(byteArray);
			}
			var blob = new Blob(byteArrays, { type: contentType });
			return blob;
		};

		generateQrVm.generateQrImage = function () {
			var userName = customerInfoService.customer.name ? customerInfoService.customer.name : "";
			var amount = generateQrVm.amount ? generateQrVm.amount : "";
			var transactionNote = customerInfoService.collectRequest.remark ? customerInfoService.collectRequest.remark : "";
			var qrCodeGenerate = new QRious({
				element: document.getElementById('qrCanvas1'),
				value: "upi://pay?pa=" + generateQrVm.payeeVpa + "&pn=" + userName + "&am=" + amount + "&tn=" + transactionNote,
				mime: 'image/png',
				size: 160
			});
			generateQrVm.vpaImage = qrCodeGenerate.toDataURL('[mime type]');
		}

		$scope.$on('$ionicView.beforeEnter', function () {
			generateQrVm.payeeVpa = customerInfoService.collectRequest.payeeVpa.trim();
			generateQrVm.amount = customerInfoService.collectRequest.amount || "";
			$timeout(function () {
				generateQrVm.generateQrImage();
			}, 300);
		});

		return this;
	}

]);
