'use strict';

angularApp.controller('sendCollectRequestController', ["$state",
	"$ionicPopup",
	"$scope",
	"customerInfoService",
	"utilityService",
	"constantConfig",
	"$rootScope",
	"$stateParams",
	"ionicDatePicker",
	"bhimUpiService",

	function ($state,
		$ionicPopup,
		$scope,
		customerInfoService,
		utilityService,
		constantConfig,
		$rootScope,
		$stateParams,
		ionicDatePicker,
		bhimUpiService) {

		var sendCollectRequestVm = this;

		sendCollectRequestVm.close = function () {
			$state.go('menu.fundtrans');
		}

		sendCollectRequestVm.changeVpa = function (vpa) {
			if (vpa.trim()) {
				for (var i = 0; i < sendCollectRequestVm.profileDetails.length; i++) {
					if (vpa.trim() == sendCollectRequestVm.profileDetails[i].virtualAddress) {
						sendCollectRequestVm.accountsArr = sendCollectRequestVm.profileDetails[i].accountInfo;
						for (var j = 0; j < sendCollectRequestVm.profileDetails[i].accountInfo.length; j++) {
							if (sendCollectRequestVm.profileDetails[i].accountInfo[j].preferredFlag == 'T') {
								sendCollectRequestVm.collectRequest.payeeAccount = sendCollectRequestVm.profileDetails[i].accountInfo[j];
							}
						}
					}
				}
			} else {
				sendCollectRequestVm.accountsArr = [];
				sendCollectRequestVm.collectRequest.payeeAccount = "";
			}
		}

		sendCollectRequestVm.clearFormFields = function (action) {
			sendCollectRequestVm.custRegisteredName = "";
			sendCollectRequestVm.verifyUpiError = "";
			if (action !== 'verify')
				sendCollectRequestVm.collectRequest.payerVpa = "";
			sendCollectRequestVm.collectRequest.payerName = "";
			sendCollectRequestVm.collectRequest.amount = "";
			sendCollectRequestVm.collectRequest.remark = "";
			sendCollectRequestVm.collectRequest.expiry = "";
		}

		sendCollectRequestVm.validateFormFields = function () {
			if (sendCollectRequestVm.collectRequest.collectType == 'VA') {
				if (!sendCollectRequestVm.collectRequest.payerVpa) {
					utilityService.showBhimUpiAlert("alert", "Please Enter Valid UPI Id");
					return false;
				}
				if (!sendCollectRequestVm.collectRequest.amount || sendCollectRequestVm.collectRequest.amount < 1 || sendCollectRequestVm.collectRequest.amount > 100000) {
					utilityService.showBhimUpiAlert("alert", "Please Enter Valid Amount Between ₹1 - ₹1,00,000 to be collect");
					return false;
				}
			} else {
				if (sendCollectRequestVm.collectRequest.amount && (sendCollectRequestVm.collectRequest.amount < 1 || sendCollectRequestVm.collectRequest.amount > 100000)) {
					utilityService.showBhimUpiAlert("alert", "Please Enter Valid Amount Between ₹1 - ₹1,00,000 to be collect");
					return false;
				}
			}
			if (!sendCollectRequestVm.collectRequest.payeeVpa || !sendCollectRequestVm.collectRequest.payeeAccount) {
				utilityService.showBhimUpiAlert("alert", "Please Select your Account Details");
				return false;
			}
			return true;
		}

		sendCollectRequestVm.goToCollectReview = function () {
			if (sendCollectRequestVm.validateFormFields()) {
				customerInfoService.collectRequest = {
					collectType: sendCollectRequestVm.collectRequest.collectType || "",
					payerVpa: sendCollectRequestVm.collectRequest.payerVpa || "",
					payerName: sendCollectRequestVm.collectRequest.payerName || "",
					amount: sendCollectRequestVm.collectRequest.amount || "",
					remark: sendCollectRequestVm.collectRequest.remark || "",
					payeeVpa: sendCollectRequestVm.collectRequest.payeeVpa || "",
					payeeAccount: sendCollectRequestVm.collectRequest.payeeAccount || "",
					expiry: sendCollectRequestVm.collectRequest.expiry || ""
				}
				if (sendCollectRequestVm.collectRequest.collectType == 'QR') {
					$state.go('menu.generateQr');
				} else {
					$state.go('menu.sendCollectRequestReview');
					// utilityService.showSpinner();
					// var json = JSON.stringify({
					// 	"addInfo": {
					// 		"addInfo10": constantConfig.upiConstant.addInfo10,
					// 		"addInfo9": constantConfig.upiConstant.addInfo9
					// 	},
					// 	"payeeType": {
					// 		"virtualAddress": sendCollectRequestVm.collectRequest.payerVpa !== "" ? sendCollectRequestVm.collectRequest.payerVpa.toString() : ""
					// 	},
					// 	"requestInfo": {
					// 		"pspId": constantConfig.upiConstant.pspId,
					// 		"pspRefNo": generateRandomString(27)
					// 	},
					// 	"vAReqType": constantConfig.upiConstant.vAReqType_T
					// });
					// bhimUpiService.getNativeData(constantConfig.upiConstant.checkVirtualAddressAPI, json).then(function (data) {
					// 	var checkVpaResponse = JSON.parse(data);
					// 	utilityService.hideSpinner();
					// 	if (checkVpaResponse.status == 'VE') {
					// 		customerInfoService.collectRequest.payerName = checkVpaResponse.payeeType.name;
					// 		$state.go('menu.sendCollectRequestReview');
					// 	} else {
					// 		utilityService.showBhimUpiAlert("error", checkVpaResponse.statusDesc);
					// 	}
					// }, function (msg) {
					// 	utilityService.hideSpinner();
					// 	utilityService.showBhimUpiAlert("error", msg);
					// });
				}
			}
		}

		sendCollectRequestVm.verifyUpiId = function () {
			if (!sendCollectRequestVm.collectRequest.payerVpa) {
				sendCollectRequestVm.verifyUpiError = "Please enter UPI ID";
				return false;
			}
			utilityService.showSpinner();
			var json = JSON.stringify({
				"addInfo": {
					"addInfo10": constantConfig.upiConstant.addInfo10,
					"addInfo9": constantConfig.upiConstant.addInfo9
				},
				"payeeType": {
					"virtualAddress": sendCollectRequestVm.collectRequest.payerVpa !== "" ? sendCollectRequestVm.collectRequest.payerVpa.toString() : ""
				},
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"vAReqType": constantConfig.upiConstant.vAReqType_T
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.checkVirtualAddressAPI, json).then(function (data) {
				utilityService.hideSpinner();
				var checkVpaResponse = JSON.parse(data);
				if (checkVpaResponse.status == 'VE') {
					sendCollectRequestVm.custRegisteredName = checkVpaResponse.payeeType.name;
				} else {
					sendCollectRequestVm.verifyUpiError = checkVpaResponse.statusDesc;
				}
			}, function (msg) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		}

		sendCollectRequestVm.openDatePicker = function () {
			var monList = ["JAN", "FEB", "MAR", "APR", "MAY", "JUN", "JUL", "AUG", "SEP", "OCT", "NOV", "DEC"];
			var newDate = new Date();
			newDate.setFullYear(newDate.getFullYear() - 100);
			var toDate = new Date();
			toDate.setFullYear(toDate.getFullYear() - 18);
			sendCollectRequestVm.dateObj = {
				callback: function (val) {
					var expiry = new Date(val);
					customerInfoService.collectExpiryDate = expiry;
					sendCollectRequestVm.expiry = expiry.getDate() + " " + monList[expiry.getMonth()] + " " + expiry.getFullYear();
				},
				inputDate: toDate,
				monthsList: monList,
				from: newDate,
				to: toDate,
				mondayFirst: true,
				closeOnSelect: false,
				templateType: 'popup',
				dateFormat: 'dd MMM yyyy'
			};
			ionicDatePicker.openDatePicker(sendCollectRequestVm.dateObj);
		}

		$scope.$on('$ionicView.beforeEnter', function () {
			if (customerInfoService.collectAction == 'GENERATEQR') {
				customerInfoService.collectRequest.collectType = 'QR';
				sendCollectRequestVm.classForUpiIdOpt = 'tab-item tabs-style div-bottom';
				sendCollectRequestVm.classForQrCodeOpt = 'tab-item tabs-style div-bottom bor-bot-active';
			} else {
				customerInfoService.collectRequest.collectType = 'VA';
				sendCollectRequestVm.classForUpiIdOpt = 'tab-item tabs-style div-bottom bor-bot-active';
				sendCollectRequestVm.classForQrCodeOpt = 'tab-item tabs-style div-bottom';
			}

			sendCollectRequestVm.profileDetails = customerInfoService.profileDetails.vpaAccountDetails;
			sendCollectRequestVm.collectRequest = {
				collectType: customerInfoService.collectRequest.collectType || "VA",
				payerVpa: customerInfoService.collectRequest.payerVpa || "",
				payerName: customerInfoService.collectRequest.payerName || "",
				amount: customerInfoService.collectRequest.amount || "",
				remark: customerInfoService.collectRequest.remark || "",
				payeeVpa: customerInfoService.collectRequest.payeeVpa || "",
				payeeAccount: customerInfoService.collectRequest.payeeAccount || "",
				expiry: customerInfoService.collectRequest.expiry || ""
			}
			if (!customerInfoService.reviewScreen) {
				customerInfoService.reviewScreen = false;
				sendCollectRequestVm.clearFormFields();
			}


			if (!sendCollectRequestVm.collectRequest.payeeVpa && !sendCollectRequestVm.collectRequest.payeeAccount) {
				for (var i = 0; i < sendCollectRequestVm.profileDetails.length; i++) {
					if (sendCollectRequestVm.profileDetails[i].defVPAStatus) {
						sendCollectRequestVm.collectRequest.payeeVpa = customerInfoService.collectRequest.payeeVpa ? customerInfoService.collectRequest.payeeVpa : sendCollectRequestVm.profileDetails[i].virtualAddress;
						sendCollectRequestVm.accountsArr = sendCollectRequestVm.profileDetails[i].accountInfo;
						for (var j = 0; j < sendCollectRequestVm.profileDetails[i].accountInfo.length; j++) {
							if (sendCollectRequestVm.profileDetails[i].accountInfo[j].preferredFlag == 'T') {
								sendCollectRequestVm.collectRequest.payeeAccount = customerInfoService.collectRequest.payeeAccount ? customerInfoService.collectRequest.payeeAccount : sendCollectRequestVm.profileDetails[i].accountInfo[j];
							}
						}
					}
				}
			}

		});

		sendCollectRequestVm.openDatePicker = function () {
			var monList = ["JAN", "FEB", "MAR", "APR", "MAY", "JUN", "JUL", "AUG", "SEP", "OCT", "NOV", "DEC"];
			var newDate = new Date();
			var toDate = new Date();
			toDate.setDate(toDate.getDate() + 44);
			sendCollectRequestVm.dateObj = {
				callback: function (val) {
					var dateOfExpiry = new Date(val);
					customerInfoService.collectExpiryDate = dateOfExpiry;
					sendCollectRequestVm.collectRequest.expiry = dateOfExpiry.getDate() + " " + monList[dateOfExpiry.getMonth()] + " " + dateOfExpiry.getFullYear();
				},
				inputDate: newDate,
				monthsList: monList,
				from: newDate,
				to: toDate,
				mondayFirst: true,
				closeOnSelect: false,
				templateType: 'popup',
				dateFormat: 'dd MMM yyyy'
			};
			ionicDatePicker.openDatePicker(sendCollectRequestVm.dateObj);
		}

		sendCollectRequestVm.toggleCollectOptions = function (collectOption) {
			sendCollectRequestVm.clearFormFields();
			if (collectOption == 'UPI') {
				sendCollectRequestVm.collectRequest.collectType = 'VA';
				sendCollectRequestVm.classForUpiIdOpt = 'tab-item tabs-style div-bottom bor-bot-active';
				sendCollectRequestVm.classForQrCodeOpt = 'tab-item tabs-style div-bottom';
			}
			if (collectOption == 'QR') {
				sendCollectRequestVm.collectRequest.collectType = 'QR';
				sendCollectRequestVm.classForUpiIdOpt = 'tab-item tabs-style div-bottom';
				sendCollectRequestVm.classForQrCodeOpt = 'tab-item tabs-style div-bottom bor-bot-active';
			}
		};

		return this;
	}
]);
