'use strict';

angularApp.controller('sendCollectRequestReviewController', ["$state",
	"$ionicPopup",
	"$scope",
	"customerInfoService",
	"utilityService",
	"constantConfig",
	"$rootScope",
	"bhimUpiService",

	function ($state,
		$ionicPopup,
		$scope,
		customerInfoService,
		utilityService,
		constantConfig,
		$rootScope,
		bhimUpiService) {

		var sendCollectRequestReviewVm = this;

		// sendCollectRequestReviewVm.getMinutesBetweenDates = function (endDate) {
		// 	var startDate = new Date();
		// 	var diff = endDate.getTime() - startDate.getTime();
		// 	return (diff / 60000);
		// }

		sendCollectRequestReviewVm.collectMoney = function () {
			var expiryTime = '';
			if (customerInfoService.collectExpiryDate) {
				var start = new Date();
				var currentTime = start.getTime();
				start.setHours(0, 0, 0, 0);
				var end = new Date(customerInfoService.collectExpiryDate);
				end.setHours(23, 55, 59, 0);
				var diff1 = end - start;
				var diff = diff1 - (currentTime - start);
				var expiryTime = (diff / 60000);
				expiryTime = Math.round(expiryTime);
			}else{
				var start = new Date();
				var currentTime = start.getTime();
				start.setHours(0, 0, 0, 0);
				var end = new Date();
				end.setHours(23, 55, 59, 0);
				var diff1 = end - start;
				var diff = diff1 - (currentTime - start);
				var expiryTime = (diff / 60000);
				expiryTime = Math.round(expiryTime);
			}
			utilityService.showSpinner();
			var json = JSON.stringify({
				"addInfo": {
					"addInfo10": constantConfig.upiConstant.addInfo10,
					"addInfo9": constantConfig.upiConstant.addInfo9
				},
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"amount": sendCollectRequestReviewVm.collectRequest.amount,
				"expiryTime": expiryTime,
				"payeeType": {
					"accountId": sendCollectRequestReviewVm.collectRequest.payeeAccount.accId,
					"virtualAddress": sendCollectRequestReviewVm.collectRequest.payeeVpa.trim(),
					"vpaType": "VA"
				},
				"payerType": {
					"name": sendCollectRequestReviewVm.collectRequest.payerName,
					"virtualAddress": sendCollectRequestReviewVm.collectRequest.payerVpa
				},
				"transactionNote": sendCollectRequestReviewVm.collectRequest.remark,
				"upiTransRefNo": 0
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.onCollectInitiation, json).then(function (data) {
				var collectResponse = JSON.parse(data).apiResp;
				utilityService.hideSpinner();
				if (collectResponse.status == 'S') {
					$state.go('menu.collectRequestSuccess');
				} else {
					utilityService.showBhimUpiAlert("error", collectResponse.responseMsg || collectResponse.statusDesc);
				}
			}, function (msg) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		}

		sendCollectRequestReviewVm.close = function () {
			$state.go('menu.fundtrans');
		}

		sendCollectRequestReviewVm.goToBack = function () {
			$state.go('menu.sendCollectRequest');
		}

		$scope.$on('$ionicView.beforeEnter', function () {
			customerInfoService.reviewScreen = true;
			sendCollectRequestReviewVm.collectRequest = {
				collectType: customerInfoService.collectRequest.collectType || "VA",
				payerVpa: customerInfoService.collectRequest.payerVpa || "",
				payerName: customerInfoService.collectRequest.payerName || "",
				amount: customerInfoService.collectRequest.amount || "",
				remark: customerInfoService.collectRequest.remark || "NA",
				payeeVpa: customerInfoService.collectRequest.payeeVpa || "",
				payeeAccount: customerInfoService.collectRequest.payeeAccount || "",
				expiry: customerInfoService.collectRequest.expiry || ""
			}
		});

		return this;
	}
]);

