'use strict';

angularApp.controller('addAccountController', ["$state",
    "$ionicPopup",
    "$scope",
    "customerInfoService",
    "utilityService",
    "constantConfig",
    "$rootScope",
    "ionicToast",
    "$stateParams",
    "bhimUpiService",

    function ($state,
        $ionicPopup,
        $scope,
        customerInfoService,
        utilityService,
        constantConfig,
        $rootScope,
        ionicToast,
        $stateParams,
        bhimUpiService) {

        var addAccountVm = this;

        $scope.$on('$ionicView.beforeEnter', function () {
            addAccountVm.accountsLoaded = false;
            addAccountVm.bankList = customerInfoService.bankList;
            addAccountVm.selectedVirtualAddress = customerInfoService.addAccountVpa;
        });

        addAccountVm.clearSearchText = function () {
            addAccountVm.searchText = '';
        }

        addAccountVm.selectBank = function (bank) {
            addAccountVm.accountsLoaded = false;
            addAccountVm.accountList = [];
            utilityService.showSpinner();
            var json = JSON.stringify({
                "addInfo": {
                    "addInfo10": constantConfig.upiConstant.addInfo10,
                    "addInfo9": constantConfig.upiConstant.addInfo9
                },
                "bankCode": bank.bankCode,
                "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "requestType": customerInfoService.action == 'ADDACC' ? constantConfig.upiConstant.requestType_A : constantConfig.upiConstant.requestType_E, //Added request type as per the action taken after getAccountList
                "updateFlag": constantConfig.upiConstant.updateFlag,
                "userInfo": {
                    "defVPAStatus": constantConfig.upiConstant.defVPAStatus,
                    "isMerchant": constantConfig.upiConstant.isMerchant,
                    "name": "",//Sudhir Bhujbal", //Here need to add logged in user name
                    "showMerchant": constantConfig.upiConstant.showMerchant,
                    "accountId": 0,
                    "virtualAddress": addAccountVm.selectedVirtualAddress//By default send mob no.--- $rootScope.checkDeviceInfo.deviceInfo.mobileNo
                }
            });
            bhimUpiService.getNativeData(constantConfig.upiConstant.getaccountListAPI, json).then(function (data) {
                var accObj = JSON.parse(data);
                utilityService.hideSpinner();
                if (accObj.status == 'S') {
                    addAccountVm.accountsLoaded = true;
                    addAccountVm.accountList = accObj.accountList;
                    addAccountVm.pspRespRefNo = accObj.requestInfo.pspRespRefNo;
                    customerInfoService.accountsDetails = {
                        "pspRespRefNo": addAccountVm.pspRespRefNo,
                        "accountList": addAccountVm.accountList,
                        "bank": bank,
                        "accountObj": accObj
                    }
                    if (customerInfoService.action == 'ADDACC') {
                        $state.go('menu.viewBankAccounts');
                    } else {
                        $state.go('menu.createNewUpiId');
                    }
                } else {
                    utilityService.showBhimUpiAlert("alert", accObj.statusDesc);
                }
            }, function (msg) {
                utilityService.hideSpinner();
                utilityService.showBhimUpiAlert("error", msg);
            });
        }

        return this;
    }
]);
