'use strict';

angularApp.controller('createNewUpiIdController', ["$state",
    "$ionicPopup",
    "$scope",
    "customerInfoService",
    "utilityService",
    "constantConfig",
    "$rootScope",
    "$stateParams",
    "validationService",
    "bhimUpiService",

    function ($state,
        $ionicPopup,
        $scope,
        customerInfoService,
        utilityService,
        constantConfig,
        $rootScope,
        $stateParams,
        validationService,
        bhimUpiService) {

        var createNewUpiIdVm = this;
        createNewUpiIdVm.sbi="@sbi";

        createNewUpiIdVm.backToBhimUpi = function(){
            $state.go('menu.fundtrans');
        }

        createNewUpiIdVm.goToRelationshipOverview = function(){
            $state.go('menu.accountOverviewMyBalance');
        }

        createNewUpiIdVm.createNewUpiId = function () {
            if(!createNewUpiIdVm.enteredVpa){
                utilityService.showBhimUpiAlert("alert", "Please Enter the UPI ID which you want to create");
                return false;
            }
            if(!createNewUpiIdVm.selectedBankAccount){
                utilityService.showBhimUpiAlert("alert", "Please select the primary account, which will be used for future transactions with the created UPI ID");
                return false;
            }
            if (createNewUpiIdVm.enteredVpa.indexOf("@") == -1) {
                if (!validationService.isValidVPA(createNewUpiIdVm.enteredVpa.split("@")[0].toLowerCase() + "@sbi")) {
                    utilityService.showBhimUpiAlert("alert", "Kindly check the UPI ID.");
                    return false;
                }
            } else {
                if (!validationService.isValidVPA(createNewUpiIdVm.enteredVpa)) {
                    utilityService.showBhimUpiAlert("alert", "Kindly check the UPI ID.");
                    return false;
                }
            }

            createNewUpiIdVm.selectedBankAccFromDD = [];
            for (var i = 0; i < customerInfoService.payerProfileDtls.vpaAccountDetails.length; i++) {
                for (var j = 0; j < customerInfoService.payerProfileDtls.vpaAccountDetails[i].accountInfo.length; j++) {
                    if (customerInfoService.payerProfileDtls.vpaAccountDetails[i].accountInfo[j].accId == JSON.parse(createNewUpiIdVm.selectedBankAccount).accId) {
                        createNewUpiIdVm.selectedBankAccFromDD.push(customerInfoService.payerProfileDtls.vpaAccountDetails[i].accountInfo[j]);
                    }
                }
            }

            utilityService.showSpinner();
            createNewUpiIdVm.selectedBankAccFromDD[0].preferredFlag = 'T';
            createNewUpiIdVm.selectedBankAccFromDD[0].checkedAccount = true;//As discussed with Swapnil on 05-12-2018 this flag should be true everytime when we create new VPA
            var json = JSON.stringify({
                "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "accountList": [createNewUpiIdVm.selectedBankAccFromDD[0]],
                "updateFlag": constantConfig.upiConstant.updateFlag,
                "userInfo": {
                    "defVPAStatus": constantConfig.upiConstant.defVPAStatus,
                    "isMerchant": constantConfig.upiConstant.isMerchant,
                    "showMerchant": constantConfig.upiConstant.showMerchant,
                    "accountId": JSON.parse(createNewUpiIdVm.selectedBankAccount).accId,
                    "virtualAddress": createNewUpiIdVm.enteredVpa.split("@")[0].toLowerCase() + "@sbi"
                }
            });
            bhimUpiService.getNativeData(constantConfig.upiConstant.onCreateNewVPA, json).then(function (data) {
                utilityService.hideSpinner();
                if (JSON.parse(data).status === "S") {
                    createNewUpiIdVm.isVpaCreatedSuccess = true;
                } else {
                    utilityService.showBhimUpiAlert("error", JSON.parse(data).statusDesc);
                }
            }, function (msg) {
                utilityService.hideSpinner();
                utilityService.showBhimUpiAlert("error", msg);
            });
        }

        createNewUpiIdVm.checkVpaAvailability = function () {
            if (createNewUpiIdVm.enteredVpa.indexOf("@") == -1) {
                if (!validationService.isValidVPA(createNewUpiIdVm.enteredVpa.split("@")[0].toLowerCase() + "@sbi")) {
                    utilityService.showBhimUpiAlert("alert", "Kindly check the UPI ID.");
                    return false;
                }
            } else {
                if (!validationService.isValidVPA(createNewUpiIdVm.enteredVpa)) {
                    utilityService.showBhimUpiAlert("alert", "Kindly check the UPI ID.");
                    return false;
                }
            }

            if (createNewUpiIdVm.enteredVpa) {
                utilityService.showSpinner();
                var json = JSON.stringify({
                    "addInfo": {
                        "addInfo10": constantConfig.upiConstant.addInfo10,
                        "addInfo9": constantConfig.upiConstant.addInfo9
                    },
                    "payeeType": {
                        "virtualAddress": createNewUpiIdVm.enteredVpa.split("@")[0].toLowerCase() + "@sbi"
                    },
                    "requestInfo": {
                        "pspId": constantConfig.upiConstant.pspId,
                        "pspRefNo": generateRandomString(27)
                    },
                    "vAReqType": "R"
                });
                bhimUpiService.getNativeData(constantConfig.upiConstant.checkVirtualAddressAPI, json).then(function (data) {
                    utilityService.hideSpinner();
                    if (JSON.parse(data).status === 'VN') {
                        createNewUpiIdVm.isEnteredIdAvailable = true;
                    } else if (JSON.parse(data).status === 'VE') {
                        createNewUpiIdVm.isEnteredIdAvailable = false;
                    } else {
                        utilityService.showBhimUpiAlert("alert", "Kindly check the UPI ID.");
                    }
                }, function (msg) {
                    utilityService.hideSpinner();
                    utilityService.showBhimUpiAlert("error", msg);
                });
            }
        }

        createNewUpiIdVm.selectSuggestedVpa = function (sugesstedVpa) {
            createNewUpiIdVm.enteredVpa = sugesstedVpa.split("@")[0];
            createNewUpiIdVm.isEnteredIdAvailable = "donotshowError";
            // createNewUpiIdVm.enteredVpa = sugesstedVpa;
        }

        createNewUpiIdVm.goBack = function () {
            $state.go('menu.accounts');
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            createNewUpiIdVm.isVpaCreatedSuccess = false;
            createNewUpiIdVm.enteredVpa = '';
            createNewUpiIdVm.selectedBankAccount = '';
            createNewUpiIdVm.isEnteredIdAvailable = "donotshowError";
            createNewUpiIdVm.vpaSuggestionList = customerInfoService.accountsDetails.accountObj.vpaSuggestionList;
            createNewUpiIdVm.accountList = customerInfoService.accountsDetails.accountList
        });

        return this;
    }
]);
