'use strict';

angularApp.controller('setUpiPinController', ["$state",
	"$ionicPopup",
	"$scope",
	"customerInfoService",
	"utilityService",
	"constantConfig",
	"$rootScope",
	"ionicDatePicker",
	"bhimUpiService",

	function ($state,
		$ionicPopup,
		$scope,
		customerInfoService,
		utilityService,
		constantConfig,
		$rootScope,
		ionicDatePicker,
		bhimUpiService) {

		var setUpiPinVm = this;

		setUpiPinVm.close = function () {
			$state.go('menu.accounts');
		}

		setUpiPinVm.setUpiPin = function () {
			if (!setUpiPinVm.debitCardNum) {
				utilityService.showBhimUpiAlert("error", "Please enter last six digit of debit card");
				return false;
			}
			utilityService.showSpinner();
			var json = {};
			if (setUpiPinVm.cardType == 'M') {
				json = JSON.stringify({
					"accountId": setUpiPinVm.accountDetails.accId,
					"addInfo": {
						"addInfo10": constantConfig.upiConstant.addInfo10,
						"addInfo9": constantConfig.upiConstant.addInfo9
					},
					"cardType": setUpiPinVm.cardType,
					"lastSixDigitDebitCardno": setUpiPinVm.debitCardNum,
					"re_verify": "N",
					"requestInfo": {
						"pspId": constantConfig.upiConstant.pspId,
						"pspRefNo": generateRandomString(27)
					},
					"virtualAddress": customerInfoService.vpaForSetPin
				});
			} else {
				if (!setUpiPinVm.expiryMonthAndYear || setUpiPinVm.expiryMonthAndYear.length != 4) {
					utilityService.hideSpinner();
					utilityService.showBhimUpiAlert("error", "Please enter valid expiry month & year combination");
					return false;
				}
				json = JSON.stringify({
					"accountId": setUpiPinVm.accountDetails.accId,
					"addInfo": {
						"addInfo10": constantConfig.upiConstant.addInfo10,
						"addInfo9": constantConfig.upiConstant.addInfo9
					},
					"cardType": setUpiPinVm.cardType,
					"expiryDate": setUpiPinVm.expiryMonthAndYear,
					"lastSixDigitDebitCardno": setUpiPinVm.debitCardNum,
					"re_verify": "N",
					"requestInfo": {
						"pspId": constantConfig.upiConstant.pspId,
						"pspRefNo": generateRandomString(27)
					},
					"virtualAddress": customerInfoService.vpaForSetPin
				});
			}
			bhimUpiService.getNativeData(constantConfig.upiConstant.onSetMpin, json).then(function (data) {
				utilityService.hideSpinner();
				if (JSON.parse(data).apiResp.status == 'S') {
					setUpiPinVm.confirmPopup = $ionicPopup.confirm({
						cssClass: 'dialog',
						template: '<div class="button_fund fontSize-subHeading roboto-light font-dark-grey" translate="">You have successfully set UPI pin.</div>',
						buttons: [{
							text: '<span>OK</span>',
							onTap: function (e) {
								setUpiPinVm.confirmPopup.close();
								setUpiPinVm.redirectToAccounts();
							}
						}]
					});
				} else {
					utilityService.showBhimUpiAlert("error", JSON.parse(data).apiResp.statusDesc);
				}
			}, function (msg) {
				utilityService.hideSpinner();
				if (msg != -101)
					utilityService.showBhimUpiAlert("error", msg);
			});
		}

		setUpiPinVm.redirectToAccounts = function () {
			utilityService.showSpinner();
			var json = JSON.stringify({
				"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"updateFlag": constantConfig.upiConstant.updateFlag
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.getProfile, json).then(function (data) {
				utilityService.hideSpinner();
				var getProfileResponse = JSON.parse(data);
				if (getProfileResponse.status == "S") {
					customerInfoService.payerProfileDtls = getProfileResponse;
					$state.go('menu.accounts');
				} else {
					utilityService.showBhimUpiAlert("error", getProfileResponse.statusDesc);
				}
			}, function (msg) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		}

		setUpiPinVm.clearExpiryDetails = function () {
			setUpiPinVm.expiryMonthAndYear = "";
		}

		$scope.$on('$ionicView.beforeEnter', function () {
			setUpiPinVm.accountDetails = customerInfoService.selectedAccountDtls;
			customerInfoService.selectedAccountDtls = '';
			setUpiPinVm.cardType = 'O';
		});

		setUpiPinVm.goBack = function () {
			$state.go('menu.accounts');
		}

		return this;
	}

]);
