'use strict';

angularApp.controller('viewAllUpiIdsController', ["$state",
    "$ionicPopup",
    "$scope",
    "customerInfoService",
    "utilityService",
    "constantConfig",
    "$rootScope",
    "$timeout",
    "bhimUpiService",

    function ($state,
        $ionicPopup,
        $scope,
        customerInfoService,
        utilityService,
        constantConfig,
        $rootScope,
        $timeout,
        bhimUpiService) {

        var viewAllUpiIdsVm = this;

        viewAllUpiIdsVm.goBack = function () {
            $state.go('menu.accounts');
        }

        viewAllUpiIdsVm.setPrimaryVpa = function (vpaDetails, indexVal) {
            utilityService.showSpinner();
            var json = JSON.stringify({
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "requestType": constantConfig.upiConstant.requestType_P, //fixed for Primary
                "userInfo": {
                    "defVPAStatus": constantConfig.upiConstant.defVPAStatus,
                    "isMerchant": constantConfig.upiConstant.isMerchant,
                    "showMerchant": constantConfig.upiConstant.showMerchant,
                    "accountId": vpaDetails.accountInfo[0].accId,
                    "virtualAddress": vpaDetails.virtualAddress
                }
            });
            bhimUpiService.getNativeData(constantConfig.upiConstant.onRemoveVPA, json).then(function (data) {
                utilityService.hideSpinner();
                if (JSON.parse(data).status == "S") {
                    var setPrimaryVpa = $ionicPopup.alert({
                        template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src="img/FT/BhimUpi/successSymbol.svg" /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>Your Primary UPI ID is updated successfully.</span></div></div></div>',
                        title: '',
                        cssClass: 'bhim-alert-popup',
                        scope: $scope,
                        buttons: [{
                            text: 'OK',
                            type: 'button-positive',
                            onTap: function (e) {
                                console.log(viewAllUpiIdsVm.profileDetails.vpaAccountDetails[indexVal]);
                                for (var i = 0; i < viewAllUpiIdsVm.profileDetails.vpaAccountDetails.length; i++) {
                                    if (i == indexVal) {
                                        viewAllUpiIdsVm.profileDetails.vpaAccountDetails[i].defVPAStatus = true;
                                    } else {
                                        viewAllUpiIdsVm.profileDetails.vpaAccountDetails[i].defVPAStatus = false;
                                    }
                                }
                                customerInfoService.payerProfileDtls = viewAllUpiIdsVm.profileDetails;
                            }
                        }]
                    });
                } else {
                    utilityService.showBhimUpiAlert("error", JSON.parse(data).statusDesc);
                }
            }, function (msg) {
                utilityService.hideSpinner();
                utilityService.showBhimUpiAlert("error", msg);
            });
        }

        viewAllUpiIdsVm.deleteVpa = function (vpaDetails, indexVal) {
            var confirmPopup = $ionicPopup.confirm({
                title: '',
                template: '<div style="text-align: left !important;" class="button_fund fontSize-subHeading font-dark-grey">Are you sure you want to delete your UPI ID ' + vpaDetails.virtualAddress + '?</div><br><div style="text-align: left !important;" class="button_fund fontSize-subHeading roboto-regular font-dark-grey">Post Deletion,</div><div style="text-align: left !important;" class="button_fund fontSize-subHeading roboto-regular font-dark-grey"><ul class="bhim-ul-disc"><li><div class="pay-pos roboto-light font-size pad-0 bhim-upi-li bhim-pad-right15">Fund transfer through ' + vpaDetails.virtualAddress + ' will not be available</div></li><li><div class="pay-pos roboto-light font-size pad-0 mar-top10 bhim-upi-li bhim-pad-right15">Same UPI ID(s) will not be available for 2 years.</div></li></ul></div>',
                cssClass: 'dialog',
                buttons: [{
                    text: 'Cancel'
                }, {
                    text: 'Confirm',
                    onTap: function (e) {
                        viewAllUpiIdsVm.deleteVpaConfirm(vpaDetails, indexVal);
                    }
                }]
            });
        }

        viewAllUpiIdsVm.deleteVpaConfirm = function (vpaDetails, indexVal) {
            utilityService.showSpinner();
            var json = JSON.stringify({
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "requestType": constantConfig.upiConstant.requestType_D, //fixed for Delete
                "userInfo": {
                    "defVPAStatus": constantConfig.upiConstant.defVPAStatus,
                    "isMerchant": constantConfig.upiConstant.isMerchant,
                    "showMerchant": constantConfig.upiConstant.showMerchant,
                    "accountId": vpaDetails.accountInfo[0].accId,
                    "virtualAddress": vpaDetails.virtualAddress
                }
            });
            bhimUpiService.getNativeData(constantConfig.upiConstant.onRemoveVPA, json).then(function (data) {
                utilityService.hideSpinner();
                if (JSON.parse(data).status == "S") {
                    viewAllUpiIdsVm.profileDetails.vpaAccountDetails.splice(indexVal, 1);
                } else {
                    utilityService.showBhimUpiAlert("error", JSON.parse(data).statusDesc);
                }
            }, function (msg) {
                utilityService.hideSpinner();
                utilityService.showBhimUpiAlert("error", msg);
            });
        }

        viewAllUpiIdsVm.deregisterUpiProfile = function () {
            viewAllUpiIdsVm.confirmPopup = $ionicPopup.confirm({
                cssClass: 'dialog',
                template: '<div style="text-align: left !important;" class="button_fund fontSize-subHeading font-dark-grey" translate="">Are you sure you want to deregister your UPI profile?</div><br><div style="text-align: left !important;" class="button_fund fontSize-subHeading roboto-regular font-dark-grey">Post Deregistration,</div></div><div style="text-align: left !important;" class="button_fund fontSize-subHeading roboto-regular font-dark-grey"><ul class="bhim-ul-disc"><li><div class="pay-pos roboto-light font-size pad-0 bhim-upi-li bhim-pad-right15">Fund transfer through UPI will not be available</div></li><li><div class="pay-pos roboto-light font-size pad-0 mar-top10 bhim-upi-li bhim-pad-right15">Same UPI ID(s) will not be available for 2 years.</div></li></ul></div>',
                buttons: [{
                    text: '<span>Cancel</span>',
                    onTap: function (e) {
                        viewAllUpiIdsVm.confirmPopup.close();
                    }
                }, {
                    text: 'Confirm',
                    type: 'button-positive',
                    onTap: function (e) {
                        viewAllUpiIdsVm.confirmPopup.close();
                        viewAllUpiIdsVm.deregisterConfirm();
                    }
                }]
            });
        }

        viewAllUpiIdsVm.deregisterConfirm = function () {
            utilityService.showSpinner();
            var json = JSON.stringify({
                "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "updateFlag": constantConfig.upiConstant.updateFlag,
                "userInfo": {
                    "defVPAStatus": false,
                    "isMerchant": false,
                    "secretDetails": {
                        "secretAnswer": constantConfig.upiConstant.secretAnswer,
                        "quesId": constantConfig.upiConstant.secretQuestionId,
                        "quesName": constantConfig.upiConstant.secretQuestionName
                    },
                    "showMerchant": false,
                    "accountId": 0
                }
            })
            bhimUpiService.getNativeData(constantConfig.upiConstant.deRegisterAccount, json).then(function (data) {
                utilityService.hideSpinner();
                viewAllUpiIdsVm.deRegisterData = JSON.parse(data);
                if (viewAllUpiIdsVm.deRegisterData.status == 'S') {
                    $state.go('menu.deRegisterSuccess');
                } else {
                    utilityService.showBhimUpiAlert("error", viewAllUpiIdsVm.deRegisterData.statusDesc);
                }
            }, function (msg) {
                utilityService.hideSpinner();
                utilityService.showBhimUpiAlert("error", msg);
            });
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            viewAllUpiIdsVm.profileDetails = customerInfoService.payerProfileDtls;
        });

        return this;
    }
]);
