'use strict';

angularApp.controller('viewBankAccountsController', ["$state",
    "$ionicPopup",
    "$scope",
    "customerInfoService",
    "utilityService",
    "constantConfig",
    "$rootScope",
    "$stateParams",
    "bhimUpiService",

    function ($state,
        $ionicPopup,
        $scope,
        customerInfoService,
        utilityService,
        constantConfig,
        $rootScope,
        $stateParams,
        bhimUpiService) {

        var viewBankAccountsVm = this;

        viewBankAccountsVm.addAccount = function () {
            utilityService.showSpinner();
            var json = JSON.stringify({
                "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27),
                    "pspRespRefNo": viewBankAccountsVm.accountsDetails.pspRespRefNo
                },
                "updateFlag": constantConfig.upiConstant.updateFlag,
                "userInfo": {
                    "defVPAStatus": constantConfig.upiConstant.defVPAStatus,
                    "isMerchant": constantConfig.upiConstant.isMerchant,
                    "showMerchant": constantConfig.upiConstant.showMerchant,
                    "accountId": viewBankAccountsVm.bankAcc ? viewBankAccountsVm.bankAcc : "-1",
                    "virtualAddress": viewBankAccountsVm.addAccountVpa
                }
            });
            bhimUpiService.getNativeData(constantConfig.upiConstant.onSubmitNewAccount, json).then(function (data) {
                var accObj = JSON.parse(data);
                utilityService.hideSpinner();
                if (accObj.status == 'S') {
                    viewBankAccountsVm.confirmPopup = $ionicPopup.confirm({
                        cssClass : 'bhim-alert-popup',
                        template : '<div class="font-dark-grey"><div><img class="approvedIconPosition" src="img/FT/BhimUpi/successSymbol.svg" /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>Your account has been successfully added to <b>'+viewBankAccountsVm.addAccountVpa+'</b></span></div></div></div>',
                        buttons: [{
                            text: '<span>OK</span>',
                            type: 'button-positive',
                            onTap: function (e) {
                                viewBankAccountsVm.confirmPopup.close();
                                viewBankAccountsVm.redirectToAccounts();
                            }
                        }]
                    });
                } else {
                    utilityService.showBhimUpiAlert("error", accObj.statusDesc);
                }
            }, function (msg) {
                utilityService.hideSpinner();
                utilityService.showBhimUpiAlert("error", msg);
            });
        }

        viewBankAccountsVm.redirectToAccounts = function () {
            utilityService.showSpinner();
            var json = JSON.stringify({
                "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "updateFlag": constantConfig.upiConstant.updateFlag
            });
            bhimUpiService.getNativeData(constantConfig.upiConstant.getProfile, json).then(function (data) {
                utilityService.hideSpinner();
                var getProfileResponse = JSON.parse(data);
                if (getProfileResponse.status == "S") {
                    customerInfoService.payerProfileDtls = getProfileResponse;
                    $state.go('menu.accounts');
                } else {
                    utilityService.showBhimUpiAlert("error", getProfileResponse.statusDesc);
                }
            }, function (msg) {
                utilityService.hideSpinner();
                utilityService.showBhimUpiAlert("error", msg);
            });
        }

        viewBankAccountsVm.goBack = function () {
            $state.go('menu.addAccount');
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            viewBankAccountsVm.bankAcc = '';
            viewBankAccountsVm.accountsDetails = customerInfoService.accountsDetails;
            viewBankAccountsVm.addAccountVpa = customerInfoService.addAccountVpa;
        });

        return this;
    }
]);
