'use strict';

angularApp.controller('deRegisterController', ["$state",
	"$ionicPopup",
	"$scope",
	"customerInfoService",
	"utilityService",
	"constantConfig",
	"$rootScope",
	"fTReviewDetails_VPAService",
	"bhimUpiService",

	function ($state,
		$ionicPopup,
		$scope,
		customerInfoService,
		utilityService,
		constantConfig,
		$rootScope,
		fTReviewDetails_VPAService,
		bhimUpiService) {

		var deRegisterVm = this;

		deRegisterVm.forgotSecretQnA = function () {
			var comingsoonPopup = $ionicPopup.alert({
				template: '<div class="CSPadding font-dark-grey "><div class="parentCS"><img class="imgwidthCS" src="img/Coming_Soon_Illustration.svg"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="childCS">'
				+ "This facility is coming soon in future versions. Please keep YONO updated" + '</div></div></div></div></div></div>',
				cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter custButtonCS button0pd',
				buttons: [
					{
						text: 'OK',
						type: 'button-positive',
						onTap: function (e) {
							comingsoonPopup.close();
						}
					}
				]
			});
		}

		deRegisterVm.goBack = function () {
			$state.go('menu.viewAllUpiIds');
		}

		deRegisterVm.deregister = function () {
			if (deRegisterVm.selectedSecQue && deRegisterVm.secretAnswer) {
				deRegisterVm.confirmPopup = $ionicPopup.confirm({
					cssClass: 'dialog',
					template: '<div style="text-align: left !important;" class="button_fund fontSize-subHeading font-dark-grey" translate="">Are you sure you want to deregister your UPI profile?</div><br><div style="text-align: left !important;" class="button_fund fontSize-subHeading roboto-regular font-dark-grey">Post Deregistration,</div></div><div style="text-align: left !important;" class="button_fund fontSize-subHeading roboto-regular font-dark-grey"><ul class="bhim-ul-disc"><li><div class="pay-pos roboto-light font-size pad-0 bhim-upi-li bhim-pad-right15">Fund transfer through UPI will not be available</div></li><li><div class="pay-pos roboto-light font-size pad-0 mar-top10 bhim-upi-li bhim-pad-right15">Same UPI ID(s) will not be available for 2 years.</div></li></ul></div>',
					buttons: [{
						text: '<span>Cancel</span>',
						onTap: function (e) {
							deRegisterVm.confirmPopup.close();
						}
					}, {
						text: 'Confirm',
						type: 'button-positive',
						onTap: function (e) {
							deRegisterVm.confirmPopup.close();
							deRegisterVm.deregisterConfirm();
						}
					}]
				});
			} else {
				utilityService.showBhimUpiAlert("alert", "Secret Question and Answer is mandatory for de-register your UPI profile");
			}
		}

		deRegisterVm.deregisterConfirm = function () {
			utilityService.showSpinner();
			var json = JSON.stringify({
				"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"updateFlag": constantConfig.upiConstant.updateFlag,
				"userInfo": {
					"defVPAStatus": false,
					"isMerchant": false,
					"secretDetails": {
						"secretAnswer": deRegisterVm.secretAnswer,
						"quesId": deRegisterVm.selectedSecQue.split('#')[0],
						"quesName": deRegisterVm.selectedSecQue.split('#')[1]
					},
					"showMerchant": false,
					"accountId": 0
				}
			})
			bhimUpiService.getNativeData(constantConfig.upiConstant.deRegisterAccount, json).then(function (data) {
				utilityService.hideSpinner();
				deRegisterVm.deRegisterData = JSON.parse(data);
				if (deRegisterVm.deRegisterData.status == 'S') {
					$state.go('menu.deRegisterSuccess');
				} else {
					utilityService.showBhimUpiAlert("error", deRegisterVm.deRegisterData.statusDesc);
				}
			}, function (msg) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		}

		deRegisterVm.toggleSecretAns = function () {
			deRegisterVm.isTextReadable == true ? deRegisterVm.isTextReadable = false : deRegisterVm.isTextReadable = true;
		};

		$scope.$on('$ionicView.beforeEnter', function () {
			deRegisterVm.secQuestions = customerInfoService.secQuestions;
			deRegisterVm.isTextReadable = false;
			deRegisterVm.secretAnswer = '';
		});

		return this;
	}



]);
