'use strict';

angularApp.controller('deRegisterSuccessController', ["$state",
    "$ionicPopup",
    "$scope",
    "customerInfoService",
    "utilityService",
    "constantConfig",
    "$rootScope",
    "bhimUpiService",
    "loggedInUserService",

    function ($state,
        $ionicPopup,
        $scope,
        customerInfoService,
        utilityService,
        constantConfig,
        $rootScope,
        bhimUpiService,
        loggedInUserService) {

        var deRegisterSuccessVm = this;

        deRegisterSuccessVm.goToUpiRegistration = function () {
            if (device.platform.toLowerCase() == 'android') {
                /*Sim card Info fetching - Start*/
                var simInfosuccessCallback = function(result) {
                    if (result !== undefined && result != null && result != '') {
                        if (result.cards && result.cards.length > 0) {
                            customerInfoService.simCardInfo = result;
                            utilityService.showSpinner();
                            var json = JSON.stringify({
                                "addInfo": {
                                    "addInfo10": constantConfig.upiConstant.addInfo10,
                                    "addInfo9": constantConfig.upiConstant.addInfo9
                                },
                                "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                                "requestInfo": {
                                    "pspId": constantConfig.upiConstant.pspId,
                                    "pspRefNo": generateRandomString(27)
                                },
                                "updateFlag": constantConfig.upiConstant.updateFlag,
                                "smsSent": device.platform.toLowerCase() == 'android' ? false : "false"
                            });
                            bhimUpiService.getNativeData(constantConfig.upiConstant.checkDevice, json).then(function (data) {
                                $rootScope.checkDeviceInfo = JSON.parse(data);
                                utilityService.hideSpinner();
                                if ($rootScope.checkDeviceInfo.status == 'S') {
                                    if ($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNN') {
                                        $state.go('menu.createNewVpa');
                                    } else if ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNM') {
                                        $state.go('menu.fundtrans');
                                    } else if (($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNM') || ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNN')) {
                                        $state.go('menu.vpaOptions');
                                    }
                                } else {
                                    utilityService.showBhimUpiAlert("error", $rootScope.checkDeviceInfo.statusDesc);
                                }
                            }, function (msg) {
                                utilityService.hideSpinner();
                                utilityService.showBhimUpiAlert("error", msg);
                            });
                        } else {
                            utilityService.showBhimUpiAlert("alert", "Please insert simcard to proceed further");
                        }
                    } else {
                        utilityService.showBhimUpiAlert("alert", "Please insert simcard to proceed further");
                    }
                }

                var HasPerminionSuccessCallback = function(result) {
                    if (result) {
                        window.plugins.sim.getSimInfo(simInfosuccessCallback, errorCallback);
                    } else {
                        requestReadPermission();
                    }
                }

                var errorCallback = function(error) {
                    var elementSimInfo = document.getElementById('ErrorInfo');
                    elementSimInfo.innerHTML = error;
                }

                var requestSuccessCallback = function(result) {
                    if (result) {
                        hasReadPermission();
                    }
                }

                // Android only: check permission
                var hasReadPermission = function() {
                    window.plugins.sim.hasReadPermission(HasPerminionSuccessCallback, errorCallback);
                }

                // Android only: request permission
                var requestReadPermission = function() {
                    window.plugins.sim.requestReadPermission(requestSuccessCallback, errorCallback);
                }

                hasReadPermission();
                /*Sim card Info fetching - End*/
            } else {
                utilityService.showSpinner();
                var json = JSON.stringify({
                    "pspId": constantConfig.upiConstant.pspId,
                    "encryptionKey": loggedInUserService.upiPermissionKey.split("^")[2]
                });
                bhimUpiService.getNativeData("initializeIOSsdk", json).then(function (data) {
                    utilityService.showSpinner();
                    var json = JSON.stringify({
                        "addInfo": {
                            "addInfo10": constantConfig.upiConstant.addInfo10,
                            "addInfo9": constantConfig.upiConstant.addInfo9
                        },
                        "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                        "requestInfo": {
                            "pspId": constantConfig.upiConstant.pspId,
                            "pspRefNo": generateRandomString(27)
                        },
                        "updateFlag": constantConfig.upiConstant.updateFlag,
                        "smsSent": device.platform.toLowerCase() == 'android' ? false : "false"
                    });
                    bhimUpiService.getNativeData(constantConfig.upiConstant.checkDevice, json).then(function (data) {
                        $rootScope.checkDeviceInfo = JSON.parse(data); 
                        utilityService.hideSpinner();
                        if($rootScope.checkDeviceInfo.status == 'S'){
                            if ($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNN') {
                                $state.go('menu.createNewVpa');
                            } else if($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNM'){
                                $state.go('menu.fundtrans');
                            }else if(($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNM') || ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNN')){
                                $state.go('menu.vpaOptions');
                            }
                        }else{
                            utilityService.showBhimUpiAlert("error", $rootScope.checkDeviceInfo.statusDesc);
                        }
                    }, function (msg) {
                        utilityService.hideSpinner();
                        utilityService.showBhimUpiAlert("error", msg);
                    });
                }, function (msg) {
                    utilityService.hideSpinner();
                    utilityService.showBhimUpiAlert("error", msg);
                });
            }
        };

        deRegisterSuccessVm.goBack = function () {
            $state.go('menu.fundsTransferLanding');
        }

        deRegisterSuccessVm.goToFundsTransfer = function () {
            $state.go('menu.fundsTransferLanding');
        }

        deRegisterSuccessVm.goToRelationshipOverview = function () {
            $state.go('menu.accountOverviewMyBalance');
        }

        return this;
    }

]);
