'use strict';

angularApp.controller('enableDisableUpiController', ["$state",
    "$ionicPopup",
    "$scope",
    "customerInfoService",
    "utilityService",
    "constantConfig",
    "$rootScope",
    "fTReviewDetails_VPAService",
    "bhimUpiService",
    "serviceRequestService",
    function ($state,
        $ionicPopup,
        $scope,
        customerInfoService,
        utilityService,
        constantConfig,
        $rootScope,
        fTReviewDetails_VPAService,
        bhimUpiService,
        serviceRequestService) {

        var enableDisableUpiVm = this;

        enableDisableUpiVm.goBack = function () {
            if(bhimUpiService.entryForEnableDisable == 'Account'){
                serviceRequestService.innerpageHeader = "Account";
                serviceRequestService.imageIcon = 'img/serviceRequest/Account.svg';
                serviceRequestService.innerLinks = serviceRequestService.getAccountOptions();
                $state.go('menu.innerPage');
            }
            else{
                $state.go(bhimUpiService.entryForEnableDisable);
            }
            
        }

        enableDisableUpiVm.getAccountStatus = function (account, index) {
            var reqParams = {};
            if(account.type == "sdk"){
                reqParams = {
                    "accountNo": account.unmaskedAccountNumber,
                    "accountType" : account.accounttype,
                    "branchCode" : account.branchCode
                    
                }
            }
            else{
                reqParams = {
                    "accountNo": account.accountNumber,
                    "accountType" : account.accounttype,
                    "branchCode" : account.branchCode
                }
            }
            
            bhimUpiService.getAccountStatus(reqParams).then(function (data) {
                enableDisableUpiVm.status = data.upiStatus;
                for (var i = 0; i < enableDisableUpiVm.accountList.length; i++) {
                    if (i == index) {
                        enableDisableUpiVm.accountList[index].selectedAccount = true;
                    } else {
                        enableDisableUpiVm.accountList[i].selectedAccount = false;
                    }
                }
            }, function (error) {
                //to remove radio button selection
                enableDisableUpiVm.acc = "";
                utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        enableDisableUpiVm.closeCancelPopup = function () {
            enableDisableUpiVm.myPopup.close();
        }

        enableDisableUpiVm.changeStatus = function (index, statusToDo, account, $event) {
            enableDisableUpiVm.selectedAccIndex = index;
            enableDisableUpiVm.statusToDo = statusToDo;
            enableDisableUpiVm.statusRequired = statusToDo == 'DS' ? 'disable' : 'enable';
            if(account.type === "sdk"){
                enableDisableUpiVm.selectedAccountNumber = account.unmaskedAccountNumber;
                enableDisableUpiVm.maskSelectedAccountNumber = account.accountNumber;
            }
            else{
                enableDisableUpiVm.selectedAccountNumber = account.accountNumber;
                enableDisableUpiVm.maskSelectedAccountNumber = account.accountNumber;
            }
            
            enableDisableUpiVm.selectedAccount = account;
            enableDisableUpiVm.myPopup = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
                templateUrl: 'pages/fundTransfer/bhimUpi/Manage/UPI/Enable-Disable/enableDisableUpiConfirmPopup.html',
                scope: $scope
            })
            $event.stopPropagation();
        }

        enableDisableUpiVm.changeStatusConfirm = function () {
            enableDisableUpiVm.myPopup.close();
            if (enableDisableUpiVm.statusToDo.toLowerCase() == 'en') {
                if(enableDisableUpiVm.selectedAccount.type === "sdk"){
                        bhimUpiService.enableReqParam = {
                        "requestId": generateRandomString(17),
                        "accountNo": enableDisableUpiVm.selectedAccountNumber,
                        "mobileNo": $rootScope.checkDeviceInfo.deviceInfo.mobileNo,
                        "name": $rootScope.checkDeviceInfo.userInfo.name,
                        "branchCode": enableDisableUpiVm.selectedAccount.branchCode,
                        "requestType": enableDisableUpiVm.statusToDo

                        };
                    }
                    else{
                        bhimUpiService.enableReqParam = {
                        "requestId": generateRandomString(17),
                        "accountNo": enableDisableUpiVm.selectedAccountNumber,
                        "mobileNo": "",
                        "name": "",
                        "branchCode": enableDisableUpiVm.selectedAccount.branchCode,
                        "requestType": enableDisableUpiVm.statusToDo
                        };
                    }
                
                $state.go('menu.enableUPIAuthentication');
            } else {
                var reqParams = {};
                if(enableDisableUpiVm.selectedAccount.type === "sdk"){
                    reqParams = {
                    "requestId": generateRandomString(17),
                    "accountNo": enableDisableUpiVm.selectedAccountNumber,
                    "mobileNo": $rootScope.checkDeviceInfo.deviceInfo.mobileNo,
                    "name": $rootScope.checkDeviceInfo.userInfo.name,
                    "branchCode": enableDisableUpiVm.selectedAccount.branchCode,
                    "requestType": enableDisableUpiVm.statusToDo
                    };
                }
                else{
                    reqParams = {
                    "requestId": generateRandomString(17),
                    "accountNo": enableDisableUpiVm.selectedAccountNumber,
                    "mobileNo": "",
                    "name": "",
                    "branchCode": enableDisableUpiVm.selectedAccount.branchCode,
                    "requestType": enableDisableUpiVm.statusToDo
                    };
                }
                bhimUpiService.enableDisableAcc(reqParams).then(function (data) {
                    enableDisableUpiVm.status = enableDisableUpiVm.statusToDo;
                    for (var i = 0; i < enableDisableUpiVm.accountList.length; i++) {
                        if (i == enableDisableUpiVm.selectedAccIndex) {
                            enableDisableUpiVm.accountList[enableDisableUpiVm.selectedAccIndex].selectedAccount = true;
                        } else {
                            enableDisableUpiVm.accountList[i].selectedAccount = false;
                        }
                    }
                }, function (error) {
                    utilityService.hideSpinner();
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            enableDisableUpiVm.acc = '';
            
            for (var i = 0; i < bhimUpiService.accountList.length; i++) {
                bhimUpiService.accountList[i]["selectedAccount"] = false;
            }
            enableDisableUpiVm.accountList = bhimUpiService.accountList;

            if(bhimUpiService.isEnabledSuccess){
                bhimUpiService.isEnabledSuccess = false;
                //check if account exist bhimUpiService.enableReqParam  and get the key index
                var isAccountExists = -1;
        enableDisableUpiVm.accountList.some(function (obj, i) {
            if(obj.type == 'sdk')
            return obj.unmaskedAccountNumber == bhimUpiService.enableReqParam.accountNo ? isAccountExists = i : false;
            else
          return obj.accountNumber == bhimUpiService.enableReqParam.accountNo ? isAccountExists = i : false;
        });
        if (isAccountExists !== -1) {

                enableDisableUpiVm.acc = isAccountExists;
                bhimUpiService.accountList[isAccountExists]["selectedAccount"] = true;
                enableDisableUpiVm.accountList = bhimUpiService.accountList;
                enableDisableUpiVm.getAccountStatus(enableDisableUpiVm.accountList[isAccountExists],isAccountExists);
        }
            }

            bhimUpiService.enableReqParam = {};
        });

        return this;
    }
]);
