'use strict';

angularApp.controller('payToVpaController', ["$state",
	"$ionicPopup",
	"$scope",
	"customerInfoService",
	"utilityService",
	"$rootScope",
	"constantConfig",
	"ionicToast",
	"bhimUpiService",
	"fTBeneficiaryService",

	function ($state,
		$ionicPopup,
		$scope,
		customerInfoService,
		utilityService,
		$rootScope,
		constantConfig,
		ionicToast,
		bhimUpiService,
		fTBeneficiaryService) {

		var payToVpaVm = this;

		payToVpaVm.checkVpaAvailability = function () {
			if (!payToVpaVm.payeeDetails.vpa) {
				utilityService.showBhimUpiAlert("alert", "Please Enter beneficiary UPI ID");
				return false;
			}
			payToVpaVm.verifyUpiIdStatus = '';
			utilityService.showSpinner();
			var json = JSON.stringify({
				"addInfo": {
					"addInfo10": constantConfig.upiConstant.addInfo10,
					"addInfo9": constantConfig.upiConstant.addInfo9
				},
				"payeeType": {
					"virtualAddress": payToVpaVm.payeeDetails.vpa.toString()
				},
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"vAReqType": constantConfig.upiConstant.vAReqType_T
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.checkVirtualAddressAPI, json).then(function (data) {
				var checkVpaResponse = JSON.parse(data);
				if (checkVpaResponse.status == 'VE') {
					customerInfoService.payeeDetails = {
						payeeType: "VA",
						requestType: 'pay',
						accountNo: payToVpaVm.payeeDetails.accountNo || "",
						ifsc: payToVpaVm.payeeDetails.ifsc || "",
						name: checkVpaResponse.payeeType.name || "",
						vpa: checkVpaResponse.payeeType.virtualAddress || "",
						amount: payToVpaVm.payeeDetails.amount || "",
						remark: payToVpaVm.payeeDetails.remark || "",
						nickName: payToVpaVm.payeeDetails.nickName || "",
						phoneNumber: payToVpaVm.payeeDetails.phoneNumber || "",
						savePayee: payToVpaVm.payeeDetails.savePayee || false
					}
					payToVpaVm.getProfile();
				} else {
					utilityService.hideSpinner();
					payToVpaVm.verifyUpiIdStatus = checkVpaResponse.statusDesc;
				}
			}, function (msg) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		}

		payToVpaVm.getProfile = function () {
			utilityService.showSpinner();
			var json = JSON.stringify({
				"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"updateFlag": constantConfig.upiConstant.updateFlag
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.getProfile, json).then(function (data) {
				utilityService.hideSpinner();
				var getProfileResponse = JSON.parse(data);
				if (getProfileResponse.status == "S") {
					customerInfoService.payerProfileDtls = getProfileResponse;
					$state.go('menu.payToVpa_PayeeDetails');
				} else {
					utilityService.showBhimUpiAlert("alert", getProfileResponse.statusDesc);
				}
			}, function (msg) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		};

		payToVpaVm.showInfoPopup = function () {
			payToVpaVm.oneTimePaymentPopup = $ionicPopup.show({
				template: '<p>One Time Payment.</p>',
				title: '',
				cssClass: 'dialog',
				scope: $scope,
				buttons: [{
					text: 'OK',
					type: 'button-positive',
					onTap: function (e) {
						payToVpaVm.oneTimePaymentPopup.close();
					}
				}]
			});
		}

		payToVpaVm.goToBack = function () {
			if(fTBeneficiaryService.tabIndexVal){
				$state.go('menu.upiPayments');
			}else{
				$state.go('menu.fundtrans');
			}
		}

		$scope.$on('$ionicView.beforeEnter', function () {
			payToVpaVm.verifyUpiIdStatus = '';
			payToVpaVm.payeeDetails = {
				payeeType: customerInfoService.payeeDetails.payeeType,
				accountNo: customerInfoService.payeeDetails.accountNo,
				ifsc: customerInfoService.payeeDetails.ifsc,
				name: customerInfoService.payeeDetails.name,
				vpa: customerInfoService.payeeDetails.vpa,
				amount: customerInfoService.payeeDetails.amount,
				remark: customerInfoService.payeeDetails.remark,
				nickName: customerInfoService.payeeDetails.nickName,
				phoneNumber: customerInfoService.payeeDetails.phoneNumber,
				savePayee: customerInfoService.payeeDetails.savePayee || false
			}
		});

		return this;
	}



]);
