'use strict';

angularApp.controller('payToVpa_ReviewController', ["$state",
	"$scope",
	"customerInfoService",
	"utilityService",
	"constantConfig",
	"$rootScope",
	"bhimUpiService",

	function ($state,
		$scope,
		customerInfoService,
		utilityService,
		constantConfig,
		$rootScope,
		bhimUpiService) {

		var payToVpa_ReviewVm = this;

		payToVpa_ReviewVm.upiPayment = function () {
			utilityService.showSpinner();
			var json = {};
			if (payToVpa_ReviewVm.payeeDetails.payeeType == 'VA') {
				json = {
					"addInfo": {
						"addInfo10": constantConfig.upiConstant.addInfo10,
						"addInfo9": constantConfig.upiConstant.addInfo9
					},
					"amount": payToVpa_ReviewVm.payeeDetails.amount,
					"expiryTime": 0,
					"payeeType": {
						"name": payToVpa_ReviewVm.payeeDetails.name,
						"virtualAddress": payToVpa_ReviewVm.payeeDetails.vpa,
						"vpaType": payToVpa_ReviewVm.payeeDetails.payeeType
					},
					"payerType": {
						"accountId": payToVpa_ReviewVm.payerDetails.account.accId,
						"virtualAddress": payToVpa_ReviewVm.payerDetails.vpa
					},
					"requestInfo": {
						"pspId": constantConfig.upiConstant.pspId,
						"pspRefNo": generateRandomString(27)
					},
					"transactionNote": payToVpa_ReviewVm.payeeDetails.remark || "",
					"upiTransRefNo": 0
				};
				
				payToVpa_ReviewVm.payeeDetails.currencyCode ? json["currencyCode"] = payToVpa_ReviewVm.payeeDetails.currencyCode : "";
				payToVpa_ReviewVm.payeeDetails.ref_id ? json["ref_id"] = payToVpa_ReviewVm.payeeDetails.ref_id : "";
				payToVpa_ReviewVm.payeeDetails.merchantCatCode ? json["merchantCatCode"] = payToVpa_ReviewVm.payeeDetails.merchantCatCode : "";
				payToVpa_ReviewVm.payeeDetails.minAmount ? json["minAmount"] = payToVpa_ReviewVm.payeeDetails.minAmount : "";
				payToVpa_ReviewVm.payeeDetails.ref_url ? json["ref_url"] = payToVpa_ReviewVm.payeeDetails.ref_url : "";
				payToVpa_ReviewVm.payeeDetails.tid ? json["tid"] = payToVpa_ReviewVm.payeeDetails.tid : "";

				json = JSON.stringify(json);

			} else if (payToVpa_ReviewVm.payeeDetails.payeeType == 'AC') {
				json = JSON.stringify({
					"addInfo": {
						"addInfo10": constantConfig.upiConstant.addInfo10,
						"addInfo9": constantConfig.upiConstant.addInfo9
					},
					"amount": payToVpa_ReviewVm.payeeDetails.amount,
					"expiryTime": 0,
					"payeeType": {
						"name": payToVpa_ReviewVm.payeeDetails.name,
						"accountNo": payToVpa_ReviewVm.payeeDetails.accountNo,
						"ifsc": payToVpa_ReviewVm.payeeDetails.ifsc,
						"vpaType": payToVpa_ReviewVm.payeeDetails.payeeType
					},
					"payerType": {
						"accountId": payToVpa_ReviewVm.payerDetails.account.accId,
						"virtualAddress": payToVpa_ReviewVm.payerDetails.vpa
					},
					"requestInfo": {
						"pspId": constantConfig.upiConstant.pspId,
						"pspRefNo": generateRandomString(27)
					},
					"transactionNote": payToVpa_ReviewVm.payeeDetails.remark || "",
					"upiTransRefNo": 0
				});
			}
			bhimUpiService.getNativeData(constantConfig.upiConstant.onPayInitiation, json).then(function (data) {
				payToVpa_ReviewVm.paymentResponse = data;
				payToVpa_ReviewVm.displayPaymentResp(payToVpa_ReviewVm.paymentResponse);
			}, function (msg) {
				utilityService.hideSpinner();
				if(msg != -101)
					utilityService.showBhimUpiAlert("error", msg);
			});
		}

		payToVpa_ReviewVm.displayPaymentResp = function (data) {
			utilityService.hideSpinner();
			if (JSON.parse(data).apiResp.status == 'S') {
				utilityService.setCsatJournies("fundTransfer");
				customerInfoService.payeeDetails["upiTransRefNo"] = JSON.parse(data).apiResp.custRefNo;
				$state.go('menu.payToVpa_Success');
			} else {
				if (JSON.parse(data).apiResp.responseMsg) {
					utilityService.showBhimUpiAlert("error", JSON.parse(data).apiResp.responseMsg, "menu.upiPayments");
				} else {
					utilityService.showBhimUpiAlert("error", JSON.parse(data).apiResp.statusDesc, "menu.upiPayments");
				}
			}
		};

		payToVpa_ReviewVm.close = function () {
			if (customerInfoService.payeeDetails.requestType == 'collect')
				$state.go('menu.transactionHistory');
			else
				$state.go('menu.fundtrans');
		}

		payToVpa_ReviewVm.goToBack = function () {
			$state.go('menu.payToVpa_PayeeDetails');
		}

		$scope.$on('$ionicView.beforeEnter', function () {
			payToVpa_ReviewVm.payeeDetails = {};
			customerInfoService.payeeDetails.payeeType == 'QR' ? payToVpa_ReviewVm.payeeDetails['payeeType'] = 'VA' : payToVpa_ReviewVm.payeeDetails['payeeType'] = customerInfoService.payeeDetails.payeeType;

			payToVpa_ReviewVm.payeeDetails = {
				payeeType: payToVpa_ReviewVm.payeeDetails.payeeType,
				accountNo: customerInfoService.payeeDetails.accountNo,
				ifsc: customerInfoService.payeeDetails.ifsc,
				bankName : customerInfoService.payeeDetails.bankName,
				name: customerInfoService.payeeDetails.name,
				vpa: customerInfoService.payeeDetails.vpa,
				amount: customerInfoService.payeeDetails.amount,
				remark: customerInfoService.payeeDetails.remark,
				nickName: customerInfoService.payeeDetails.nickName,
				phoneNumber: customerInfoService.payeeDetails.phoneNumber,
				savePayee: customerInfoService.payeeDetails.savePayee,

				currencyCode : customerInfoService.payeeDetails.currencyCode || "",
				ref_id : customerInfoService.payeeDetails.ref_id || "",
				merchantCatCode : customerInfoService.payeeDetails.merchantCatCode || "",
				minAmount : customerInfoService.payeeDetails.minAmount || "",
				ref_url : customerInfoService.payeeDetails.ref_url || "",
				tid : customerInfoService.payeeDetails.tid || ""
			}
			payToVpa_ReviewVm.payerDetails = {
				vpa: customerInfoService.payerDetails.vpa,
				account: customerInfoService.payerDetails.accountObj
			}

			if (customerInfoService.payeeDetails.payeeType == "QR")
				payToVpa_ReviewVm.paymentType = "QR CODE";
			else if (customerInfoService.payeeDetails.payeeType == "AC")
				payToVpa_ReviewVm.paymentType = "BANK ACCOUNT";
			else
				payToVpa_ReviewVm.paymentType = "UPI";
		});

		return this;
	}
]);

