'use strict';

angularApp.controller('pendingRequestsController', ["$state",
	"customerInfoService",
	"utilityService",
	"constantConfig",
	"ionicToast",
	"$scope",
	"$ionicPopup",
	"bhimUpiService",

	function ($state,
		customerInfoService,
		utilityService,
		constantConfig,
		ionicToast,
		$scope,
		$ionicPopup,
		bhimUpiService) {

		var pendingRequestsVm = this;

		pendingRequestsVm.goBack = function(){
			$state.go('menu.fundtrans');
		}

		pendingRequestsVm.rejectRequest = function(collectRequest, indexVal){
			customerInfoService.upiCollectRequest = collectRequest;
			utilityService.showSpinner();
			var json = JSON.stringify({
				"addInfo": {
					"addInfo10": constantConfig.upiConstant.addInfo10,
					"addInfo9": constantConfig.upiConstant.addInfo9
				},
				"approvalStatus":"R",
				"expiryTime":0,
				"npciTranId": customerInfoService.upiCollectRequest.txnId,
				"payerType":{
					"accountId": "1234",
					"virtualAddress" : "sbi"
				},
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"upiTransRefNo": customerInfoService.upiCollectRequest.upiTrnRefNo
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.onCollectApprove, json).then(function(data){
				var collectApproveResp = JSON.parse(data).apiResp;
                utilityService.hideSpinner();
				if(collectApproveResp.status == 'R'){
					pendingRequestsVm.approveCollectPopup = $ionicPopup.confirm({
                        cssClass: 'dialog',
                        template: '<div class="button_fund fontSize-subHeading roboto-light font-dark-grey">'+collectApproveResp.statusDesc+'</div>',
                        buttons: [{
                            text: '<span>Ok</span>',
                            onTap: function (e) {
                                pendingRequestsVm.approveCollectPopup.close();
								pendingRequestsVm.collectRequestsList.splice(indexVal, 1);
                            }
                        }]
                    });
				}else{
					utilityService.showBhimUpiAlert("error", collectApproveResp.statusDesc);
				}
			}, function(msg){
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		}
		
		pendingRequestsVm.blockRequest = function(collectRequest, indexVal){
			customerInfoService.upiCollectRequest = collectRequest;
			utilityService.showSpinner();
			var json = JSON.stringify({
				"addInfo": {
					"addInfo10": constantConfig.upiConstant.addInfo10,
					"addInfo9": constantConfig.upiConstant.addInfo9
				},
				"approvalStatus":"S",
				"expiryTime":0,
				"npciTranId": customerInfoService.upiCollectRequest.txnId,
				"payerType":{
					"accountId": "1234",
					"virtualAddress" : "sbi"
				},
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"upiTransRefNo": customerInfoService.upiCollectRequest.upiTrnRefNo
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.onCollectApprove, json).then(function(data){
				var collectApproveResp = JSON.parse(data).apiResp;
                utilityService.hideSpinner();
				if(collectApproveResp.status == 'R'){
					pendingRequestsVm.approveCollectPopup = $ionicPopup.confirm({
                        cssClass: 'dialog',
                        template: '<div class="button_fund fontSize-subHeading roboto-light font-dark-grey">'+collectApproveResp.statusDesc+'</div>',
                        buttons: [{
                            text: '<span>Ok</span>',
                            onTap: function (e) {
                                pendingRequestsVm.approveCollectPopup.close();
								pendingRequestsVm.collectRequestsList.splice(indexVal, 1);
                            }
                        }]
                    });
				}else{
					utilityService.showBhimUpiAlert("error", collectApproveResp.statusDesc);
				}
			}, function(msg){
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		}

		pendingRequestsVm.approveRequest = function(collectRequest){
			customerInfoService.upiCollectRequest = collectRequest;
			customerInfoService.payeeDetails = {
				payeeType: "VA",
				requestType : 'collectFromLanding',
				accountNo: collectRequest.accountNo || "",
				ifsc: collectRequest.ifsc || "",
				name : collectRequest.payeeName || "",
				vpa : collectRequest.payeeVa || "",
				amount : collectRequest.txnAmount || "",
				remark : collectRequest.txnNote || "",
				nickName : collectRequest.nickName || "",
				phoneNumber : collectRequest.phoneNumber || "",
				savePayee : collectRequest.savePayee || false
			}
			utilityService.showSpinner();
            var json = JSON.stringify({
                "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "updateFlag": constantConfig.upiConstant.updateFlag
            });
            bhimUpiService.getNativeData(constantConfig.upiConstant.getProfile, json).then(function(data) {
				utilityService.hideSpinner();
				var getProfileResponse = JSON.parse(data);
                if (getProfileResponse.status == "S") {
                    customerInfoService.payerProfileDtls = getProfileResponse;
					$state.go('menu.payToVpa_PayeeDetails');
                } else {
					utilityService.showBhimUpiAlert("error", getProfileResponse.statusDesc);
                }
            }, function(msg) {
                utilityService.hideSpinner();
                utilityService.showBhimUpiAlert("error", msg);
            });
		}

		$scope.$on('$ionicView.beforeEnter', function () {
			pendingRequestsVm.collectRequestsList = customerInfoService.collectRequestsList;
		});
		
		return this;
	}

]);
