'use strict';

angularApp.controller('payToQRController', [
    "$state",
    "$scope",
    "$ionicPopup",
    "cameraService",
    "utilityService",
    "fTBeneficiaryService",
    "$rootScope",
    "cryptoService",
    "constantConfig",
    "customerInfoService",
    "ionicToast",
    "bhimUpiService",
    "bQRService",

    function ($state,
        $scope,
        $ionicPopup,
        cameraService,
        utilityService,
        fTBeneficiaryService,
        $rootScope,
        cryptoService,
        constantConfig,
        customerInfoService,
        ionicToast,
        bhimUpiService,
        bQRService) {

        var payToQRVm = this;
        payToQRVm.scannedImage = "img/FT/qrScanTap.svg";

        //Get query parameter from URL
        payToQRVm.getParameterByName = function (name, url) {
            if (!url) url = window.location.href;
            name = name.replace(/[\[\]]/g, "\\$&");
            var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)"),
                results = regex.exec(url);
            if (!results) return null;
            if (!results[2]) return '';
            if(name=='am'){
				if(results[2].search("E")!==-1 || results[2].search("e")!==-1){
                return results[2];
			}
		}
            return decodeURIComponent(results[2].replace(/\+/g, " "));
        }

        //Scan the QR Code
        payToQRVm.scanQrCode = function () {
            if (device.platform.toLowerCase() == 'android') {
                bhimUpiService.getNativeData("scanqrcode", {}).then(function (data) {
                    var barcodeData = data.scanResult;
                    if (barcodeData.indexOf("upi://pay?") !== 0) {
                        bhimUpiService.getQRCode(barcodeData).then(function (data) {
                            if (data.validStatus == 0) {
                                if (data.isQRValid == true) {
                                    bQRService.merchantDetails = data;
                                    bQRService.merchantDetails.redirectType = "fundsTransfer";
                                    $state.go("menu.scanPay");
                                } else {
                                    utilityService.showBhimUpiAlert("error", "Invalid QR");
                                }
                            } else {
                                payToQRVm.goToBhimUpiPayment(barcodeData);
                            }
                        }, function (error) {
                            utilityService.showBhimUpiAlert("error", error.responseMessage);
                        });
                    } else {
                        payToQRVm.goToBhimUpiPayment(barcodeData);
                    }
                }, function (error) {
                    utilityService.showBhimUpiAlert("error", error);
                });
            } else {
                bhimUpiService.getNativeData("scanqrcode", {}).then(function (data) {
                    var barcodeData = data;

                    if (barcodeData.indexOf("upi://pay?") !== 0) {
                        bhimUpiService.getQRCode(barcodeData).then(function (data) {
                            if (data.validStatus == 0) {
                                if (data.isQRValid == true) {
                                    bQRService.merchantDetails = data;
                                    bQRService.merchantDetails.redirectType = "fundsTransfer";
                                    $state.go("menu.scanPay");
                                } else {
                                    utilityService.showBhimUpiAlert("error", "Invalid QR");
                                }
                            } else {
                                payToQRVm.goToBhimUpiPayment(barcodeData);
                            }
                        }, function (error) {
                            utilityService.showBhimUpiAlert("error", error.responseMessage);
                        });
                    } else {
                        payToQRVm.goToBhimUpiPayment(barcodeData);
                    }

                }, function (error) {
                    utilityService.showBhimUpiAlert("error", error);
                });
            }
        };

        payToQRVm.goToBhimUpiPayment = function (barcodeData) {
            try {
                payToQRVm.isBarcodeScanned = !utilityService.isEmpty(barcodeData);
                if (payToQRVm.isBarcodeScanned) {
                    payToQRVm.payeeVpa = payToQRVm.getParameterByName('pa', barcodeData);
                    payToQRVm.scannedImage = "img/FT/qrScanTap.svg";
                    if (payToQRVm.getParameterByName('am', barcodeData))
                        payToQRVm.amount = Number(payToQRVm.getParameterByName('am', barcodeData));
                    if (payToQRVm.getParameterByName('tn', barcodeData))
                        payToQRVm.remark = payToQRVm.getParameterByName('tn', barcodeData);
                    if (payToQRVm.getParameterByName('cu', barcodeData))
                        payToQRVm.currencyCode = payToQRVm.getParameterByName('cu', barcodeData);
                    if (payToQRVm.getParameterByName('tr', barcodeData))
                        payToQRVm.ref_id = payToQRVm.getParameterByName('tr', barcodeData);
                    if (payToQRVm.getParameterByName('mc', barcodeData))
                        payToQRVm.merchantCatCode = payToQRVm.getParameterByName('mc', barcodeData);
                    if (payToQRVm.getParameterByName('mam', barcodeData))
                        payToQRVm.minAmount = payToQRVm.getParameterByName('mam', barcodeData);
                    if (payToQRVm.getParameterByName('url', barcodeData))
                        payToQRVm.ref_url = payToQRVm.getParameterByName('url', barcodeData);
                    if (payToQRVm.getParameterByName('tid', barcodeData))
                        payToQRVm.tid = payToQRVm.getParameterByName('tid', barcodeData);

                    payToQRVm.checkVpaAvailability();
                } else {
                    payToQRVm.scannedImage = "img/FT/qrScanTap.svg";
                }
            } catch (e) { }
        }

        //Select the QR Code from gallery
        payToQRVm.selectImagefromGallery = function () {
            cameraService.getImageFromGallery().then(function (imageData) {
                try {
                    payToQRVm.scannedImage = imageData;
                    qrcode.decode(imageData);
                    qrcode.callback = function (decodedData) {
                        payToQRVm.isBarcodeScanned = !utilityService.isEmpty(decodedData);
                        if (payToQRVm.isBarcodeScanned) {
                            bhimUpiService.getQRCode(decodedData).then(function (data) {
                                if (data.validStatus == 0) {
                                    if (data.isQRValid == true) {
                                        bQRService.merchantDetails = data;
                                        bQRService.merchantDetails.redirectType = "scan";
                                        $state.go("menu.scanPay");
                                    } else {
                                        utilityService.showBhimUpiAlert("error", "Invalid QR");
                                    }
                                } else {
                                    payToQRVm.payeeVpa = payToQRVm.getParameterByName('pa', decodedData);
                                    if (payToQRVm.getParameterByName('am', decodedData))
                                        payToQRVm.amount = Number(payToQRVm.getParameterByName('am', decodedData));
                                    if (payToQRVm.getParameterByName('tn', decodedData))
                                        payToQRVm.remark = payToQRVm.getParameterByName('tn', decodedData);
                                    if (payToQRVm.getParameterByName('cu', decodedData))
                                        payToQRVm.currencyCode = payToQRVm.getParameterByName('cu', decodedData);
                                    if (payToQRVm.getParameterByName('tr', decodedData))
                                        payToQRVm.ref_id = payToQRVm.getParameterByName('tr', decodedData);
                                    if (payToQRVm.getParameterByName('mc', decodedData))
                                        payToQRVm.merchantCatCode = payToQRVm.getParameterByName('mc', decodedData);
                                    if (payToQRVm.getParameterByName('mam', decodedData))
                                        payToQRVm.minAmount = payToQRVm.getParameterByName('mam', decodedData);
                                    if (payToQRVm.getParameterByName('url', decodedData))
                                        payToQRVm.ref_url = payToQRVm.getParameterByName('url', decodedData);
                                    if (payToQRVm.getParameterByName('tid', decodedData))
                                        payToQRVm.tid = payToQRVm.getParameterByName('tid', decodedData);

                                    payToQRVm.checkVpaAvailability();
                                }
                            }, function (error) {
                                console.log("barCodeerror", error)
                                utilityService.showBhimUpiAlert("error", error.responseMessage);
                            });
                        }
                    }
                }
                catch (e) { }
            }, function (error) {
                if (error != 'error')
                    utilityService.showBhimUpiAlert("error", error);
            });
        };

        payToQRVm.checkVpaAvailability = function () {
            if (!payToQRVm.payeeVpa) {
                utilityService.showBhimUpiAlert("alert", "Invalid QR");
                return false;
            }
            utilityService.showSpinner();
            var json = JSON.stringify({
                "addInfo": {
                    "addInfo10": constantConfig.upiConstant.addInfo10,
                    "addInfo9": constantConfig.upiConstant.addInfo9
                },
                "payeeType": {
                    "virtualAddress": payToQRVm.payeeVpa.toString()
                },
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "vAReqType": constantConfig.upiConstant.vAReqType_T
            });
            bhimUpiService.getNativeData(constantConfig.upiConstant.checkVirtualAddressAPI, json).then(function (data) {
                var checkVpaResponse = JSON.parse(data);
                if (checkVpaResponse.status == 'VN') {
                    utilityService.hideSpinner();
                    utilityService.showBhimUpiAlert("alert", "This QR code data doesn't exist. Kindly check the image.");
                } else if (checkVpaResponse.status == 'VE') {
                    customerInfoService.payeeDetails = {
                        payeeType: "QR",
                        requestType: 'qr_pay',
                        accountNo: payToQRVm.payeeDetails.accountNo || "",
                        ifsc: payToQRVm.payeeDetails.ifsc || "",
                        name: checkVpaResponse.payeeType.name || "",
                        vpa: checkVpaResponse.payeeType.virtualAddress || "",
                        amount: payToQRVm.amount || "",
                        remark: payToQRVm.remark || "",
                        nickName: payToQRVm.payeeDetails.nickName || "",
                        phoneNumber: payToQRVm.payeeDetails.phoneNumber || "",
                        savePayee: payToQRVm.payeeDetails.savePayee || false,
                        currencyCode : payToQRVm.currencyCode || "",
                        ref_id : payToQRVm.ref_id || "",
                        merchantCatCode : payToQRVm.merchantCatCode || "",
                        minAmount : payToQRVm.minAmount || "",
                        ref_url : payToQRVm.ref_url || "",
                        tid : payToQRVm.tid || ""
                    }
                    payToQRVm.getProfile();
                } else {
                    utilityService.hideSpinner();
                    utilityService.showBhimUpiAlert("error", "Invalid QR");
                }
            }, function (msg) {
                utilityService.hideSpinner();
                utilityService.showBhimUpiAlert("error", msg);
            });
        }

        payToQRVm.getProfile = function () {
            utilityService.showSpinner();
            var json = JSON.stringify({
                "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "updateFlag": constantConfig.upiConstant.updateFlag
            });
            bhimUpiService.getNativeData(constantConfig.upiConstant.getProfile, json).then(function (data) {
                utilityService.hideSpinner();
                var getProfileResponse = JSON.parse(data);
                if (getProfileResponse.status == "S") {
                    customerInfoService.payerProfileDtls = getProfileResponse;
                    $state.go('menu.payToVpa_PayeeDetails');
                } else {
                    ionicToast.show(getProfileResponse.statusDesc, 'bottom', false, 3000);
                }
            }, function (msg) {
                utilityService.hideSpinner();
                utilityService.showBhimUpiAlert("error", msg);
            });
        };

        payToQRVm.goToBack = function () {
            if (customerInfoService.scanQrEntrypoint == 'FTLANDING') {
                $state.go('menu.fundsTransferLanding');
            } else {
                $state.go('menu.fundtrans');
            }
        }

        payToQRVm.close = function () {
            if (customerInfoService.scanQrEntrypoint == 'FTLANDING') {
                $state.go('menu.fundsTransferLanding');
            } else {
                $state.go('menu.fundtrans');
            }
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            bQRService.convenienceFee = "";
            bQRService.transactionAmount = "";
            bQRService.purpose = "";
            bQRService.billNumber = "";
            bQRService.loyaltyNumber = "";
            bQRService.merchantDetails = {};
            payToQRVm.scannedImage = "img/FT/qrScanTap.svg";
            payToQRVm.amount = '';
            payToQRVm.payeeDetails = {
                payeeType: customerInfoService.payeeDetails.payeeType,
                accountNo: customerInfoService.payeeDetails.accountNo,
                ifsc: customerInfoService.payeeDetails.ifsc,
                name: customerInfoService.payeeDetails.name,
                vpa: customerInfoService.payeeDetails.vpa,
                amount: customerInfoService.payeeDetails.amount,
                remark: customerInfoService.payeeDetails.remark,
                nickName: customerInfoService.payeeDetails.nickName,
                phoneNumber: customerInfoService.payeeDetails.phoneNumber,
                savePayee: customerInfoService.payeeDetails.savePayee || false
            }
        });

        return this;
    }]);