'use strict';

angularApp.controller('createNewVpaController', ["$state",
	"$rootScope",
	"utilityService",
	"constantConfig",
	"customerInfoService",
	"ionicToast",
	"bhimUpiService",
	"$ionicPlatform",
	"$scope",
	"$interval",

	function ($state,
		$rootScope,
		utilityService,
		constantConfig,
		customerInfoService,
		ionicToast,
		bhimUpiService,
		$ionicPlatform,
		$scope,
		$interval) {

		var createNewVpaVm = this;

		createNewVpaVm.goBack = function () {
			if (createNewVpaVm.spinner)
				$interval.cancel(createNewVpaVm.spinner);
			$state.go('menu.fundsTransferLanding');
		}

		createNewVpaVm.showTimerForReVerification = function () {
			var timeLeft = 10;
			createNewVpaVm.spinner = $interval(function () {
				if (timeLeft == 0) {
					createNewVpaVm.showWaitSpinner = false;
					createNewVpaVm.checkDeviceAfterSMS();
				} else {
					createNewVpaVm.showWaitSpinner = true;
					createNewVpaVm.timeRemaining = timeLeft;
					timeLeft--;
				}
			}, 1000)
		}

		createNewVpaVm.goToSelectNumber = function () {
			$rootScope.previousPage = 'createNewVpa';
			if (device.platform.toLowerCase() == 'android') {
				$state.go('menu.selectNumber');
			} else {
				if ($rootScope.checkDeviceInfo.smsStatus == 'SS') {
					createNewVpaVm.getBankList();
				} else {
					utilityService.showSpinner();
					var json = JSON.stringify({
						"smsGateWayContent": $rootScope.checkDeviceInfo.smsGateWayContent,
						"smsGateWayKey": $rootScope.checkDeviceInfo.smsGateWayKey,
						"smsGateWayNo": $rootScope.checkDeviceInfo.smsGateWayNo,
						"appGenId": bhimUpiService.appGenId
					});
					bhimUpiService.getNativeData(constantConfig.upiConstant.sendsms, json).then(function (data) {
						utilityService.hideSpinner();
						createNewVpaVm.showTimerForReVerification();
					}, function (msg) {
						utilityService.hideSpinner();
						utilityService.showBhimUpiAlert("error", msg);
					});
				}
			}
		};

		createNewVpaVm.checkDeviceAfterSMS = function () {
			$interval.cancel(createNewVpaVm.spinner);
			utilityService.showSpinner();
			var json = JSON.stringify({
				"addInfo": {
					"addInfo10": constantConfig.upiConstant.addInfo10,
					"addInfo9": constantConfig.upiConstant.addInfo9
				},
				"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"updateFlag": constantConfig.upiConstant.updateFlag,
				"smsSent": "true"
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.checkDevice, json).then(function (data) {
				$rootScope.checkDeviceInfo = JSON.parse(data);
				if ($rootScope.checkDeviceInfo.status == 'S') {
					if ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNM' &&
						$rootScope.checkDeviceInfo.re_verify && $rootScope.checkDeviceInfo.re_verify == 'Y') {
						utilityService.hideSpinner();
						$state.go('menu.reVerifyDevice');
					} else {
						if ($rootScope.checkDeviceInfo.smsStatus == 'SS') {
							createNewVpaVm.getBankList();
						} else {
							utilityService.hideSpinner();
							utilityService.showBhimUpiAlert("error", "Currently system is facing the issues with SMS gateway. Please try after sometime.");
						}
					}
				} else {
					utilityService.hideSpinner();
					utilityService.showBhimUpiAlert("error", $rootScope.checkDeviceInfo.statusDesc);
				}
			}, function (msg) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		}

		createNewVpaVm.getBankList = function () {
			var json = JSON.stringify({
				"addInfo": {
					"addInfo10": constantConfig.upiConstant.addInfo10,
					"addInfo9": constantConfig.upiConstant.addInfo9
				},
				"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"updateFlag": constantConfig.upiConstant.updateFlag
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.getbankListAPI, json).then(function (data) {
				utilityService.hideSpinner();
				createNewVpaVm.banklistResponse = JSON.parse(data);
				if (createNewVpaVm.banklistResponse.status == 'S') {
					customerInfoService.bankList = createNewVpaVm.banklistResponse.bankMasterList;
					customerInfoService.accountDtlAgainstBank = [];
					$state.go('menu.selectBank');
				} else {
					utilityService.showBhimUpiAlert("error", "Unable to fetch bank list. Please try after sometime.");
				}
			}, function (msg) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		};

		$scope.$on('$ionicView.beforeEnter', function () {
			bhimUpiService.isUpiRegistration = true;
			createNewVpaVm.showWaitSpinner = false;
		});

		$ionicPlatform.on("resume", function (event) {
			////*******This code is commented upto iOS release */
			// if (bhimUpiService.isUpiRegistration) {
			// 	bhimUpiService.isUpiRegistration = false;
			// 	utilityService.showBhimUpiAlert("alert", "UPI registration process has been interrupted. Due to security purpose Application toggle/minimize is not allowed. Please try to register again.", "menu.fundsTransferLanding");
			// }
		});

		return this;
	}

]);

