'use strict';

angularApp.controller('createUPIPinController', ["$state",
	"$ionicPopup",
	"$scope",
	"customerInfoService",
	"utilityService",
	"constantConfig",
	"$rootScope",
	"ionicDatePicker",
	"bhimUpiService",

	function ($state,
		$ionicPopup,
		$scope,
		customerInfoService,
		utilityService,
		constantConfig,
		$rootScope,
		ionicDatePicker,
		bhimUpiService) {

		var createUPIPinVm = this;

		createUPIPinVm.goBack = function () {
			$state.go('menu.reVerifyDevice');
		}

		createUPIPinVm.close = function () {
			$state.go('menu.fundsTransferLanding');
		}
		
		createUPIPinVm.clearExpiryDetails = function(){
			createUPIPinVm.expiryMonthAndYear = '';
		}

		createUPIPinVm.setUpiPin = function () {
			if (!createUPIPinVm.debitCardNum) {
				utilityService.showBhimUpiAlert("error", "Please enter last six digits of debit card");
				return false;
			}
			utilityService.showSpinner();
			var json = {};
			if (createUPIPinVm.cardType == 'M') {
				json = JSON.stringify({
					"accountId": createUPIPinVm.accountDetails.accId,
					"addInfo": {
						"addInfo10": constantConfig.upiConstant.addInfo10,
						"addInfo9": constantConfig.upiConstant.addInfo9
					},
					"cardType": createUPIPinVm.cardType,
					"re_verify": "Y",
					"lastSixDigitDebitCardno": createUPIPinVm.debitCardNum,
					"requestInfo": {
						"pspId": constantConfig.upiConstant.pspId,
						"pspRefNo": generateRandomString(27)
					},
					"virtualAddress": $rootScope.checkDeviceInfo.userInfo.virtualAddress
				});
			} else {
				if (!createUPIPinVm.expiryMonthAndYear || createUPIPinVm.expiryMonthAndYear.length != 4) {
					utilityService.hideSpinner();
					utilityService.showBhimUpiAlert("error", "Please enter valid expiry month & year combination");
					return false;
				}
				json = JSON.stringify({
					"accountId": createUPIPinVm.accountDetails.accId,
					"addInfo": {
						"addInfo10": constantConfig.upiConstant.addInfo10,
						"addInfo9": constantConfig.upiConstant.addInfo9
					},
					"cardType": createUPIPinVm.cardType,
					"expiryDate": createUPIPinVm.expiryMonthAndYear,
					"lastSixDigitDebitCardno": createUPIPinVm.debitCardNum,
					"re_verify": "Y",
					"requestInfo": {
						"pspId": constantConfig.upiConstant.pspId,
						"pspRefNo": generateRandomString(27)
					},
					"virtualAddress": $rootScope.checkDeviceInfo.userInfo.virtualAddress
				});
			}
			bhimUpiService.isUpiRegistration = false;
			bhimUpiService.getNativeData(constantConfig.upiConstant.onSetMpin, json).then(function (data) {
				bhimUpiService.isUpiRegistration = true;
				utilityService.hideSpinner();
				if (JSON.parse(data).apiResp.status == 'S') {
					localStorage.setItem('appGenId', JSON.parse(data).apiResp.servGenId);
					bhimUpiService.isUpiRegistration = false;
					var onSetMpin = $ionicPopup.alert({
						template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src="img/FT/BhimUpi/successSymbol.svg" /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>You have successfully set UPI pin.</span></div></div></div>',
						title: '',
						cssClass: 'bhim-alert-popup',
						scope: $scope,
						buttons: [{
							text: 'OK',
							type: 'button-positive',
							onTap: function (e) {
								onSetMpin.close();
								utilityService.showSpinner();
								bhimUpiService.getNativeData("setAppGenId", localStorage.getItem("appGenId")).then(function (data) {
									var json = JSON.stringify({
										"addInfo": {
											"addInfo10": constantConfig.upiConstant.addInfo10,
											"addInfo9": constantConfig.upiConstant.addInfo9
										},
										"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
										"requestInfo": {
											"pspId": constantConfig.upiConstant.pspId,
											"pspRefNo": generateRandomString(27)
										},
										"updateFlag": constantConfig.upiConstant.updateFlag,
										"smsSent": false
									});
									bhimUpiService.getNativeData(constantConfig.upiConstant.checkDevice, json).then(function (data) {
										$rootScope.checkDeviceInfo = JSON.parse(data);
										utilityService.hideSpinner();
										if ($rootScope.checkDeviceInfo.status == 'S') {
											$state.go('menu.fundtrans');//Redirect UPI Dashboard
										} else {
											$state.go('menu.fundsTransferLanding');//Redirect FT main Dashboard
										}
									}, function (msg) {
										utilityService.hideSpinner();
										$state.go('menu.fundsTransferLanding');//Redirect FT main Dashboard
									});
								}, function (msg) {
									utilityService.hideSpinner();
									utilityService.showBhimUpiAlert("error", msg);
								});
							}
						}]
					});
				} else {
					utilityService.showBhimUpiAlert("error", JSON.parse(data).apiResp.statusDesc);
				}
			}, function (msg) {
				bhimUpiService.isUpiRegistration = true;
				utilityService.hideSpinner();
				if (msg != -101)
					utilityService.showBhimUpiAlert("error", msg);
			});
		}


		$scope.$on('$ionicView.beforeEnter', function () {
			createUPIPinVm.debitCardNum = "";
			createUPIPinVm.expiryMonthAndYear = "";
			createUPIPinVm.accountDetails = customerInfoService.verifyAccountObj;
			createUPIPinVm.cardType = 'O';
		});

		return this;
	}

]);
