'use strict';

angularApp.controller('fetchMyVpaController', ["$state",
	"$ionicPopup",
	"$scope",
	"customerInfoService",
	"utilityService",
	"constantConfig",
	"$rootScope",
	"bhimUpiService",

	function ($state,
		$ionicPopup,
		$scope,
		customerInfoService,
		utilityService,
		constantConfig,
		$rootScope,
		bhimUpiService) {

		var fetchMyVpaVm = this;

		fetchMyVpaVm.goBack = function () {
			$state.go('menu.vpaOptions');
		}

		fetchMyVpaVm.updateDevice = function () {
			if (!fetchMyVpaVm.secretAnswer) {
				utilityService.showBhimUpiAlert("alert", "Please Enter Secret Answer");
				return false;
			}

			$rootScope.previousPage = 'fetchMyVpa';
			customerInfoService.upi_SecretQue = fetchMyVpaVm.selectedSecQue;
			customerInfoService.upi_SecretAns = fetchMyVpaVm.secretAnswer;
			$state.go('menu.selectNumber');


			// if ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNN') {
			// 	$rootScope.previousPage = 'fetchMyVpa';
			// 	customerInfoService.upi_SecretQue = fetchMyVpaVm.selectedSecQue;
			// 	customerInfoService.upi_SecretAns = fetchMyVpaVm.secretAnswer;
			// 	$state.go('menu.selectNumber');
			// } else if ($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNM') {
			// 	utilityService.showSpinner();
			// 	var json = JSON.stringify({
			// 		"deviceInfo": {
			// 			"oldMobileNo": $rootScope.checkDeviceInfo.deviceInfo.oldMobileNo
			// 		},
			// 		"requestInfo": {
			// 			"pspId": constantConfig.upiConstant.pspId,
			// 			"pspRefNo": generateRandomString(27)
			// 		},
			// 		"requestType": constantConfig.upiConstant.requestType_D,
			// 		"updateFlag": constantConfig.upiConstant.updateFlag,
			// 		"userInfo": {
			// 			"secretDetails": {
			// 				"secretAnswer": fetchMyVpaVm.secretAnswer.toString(),
			// 				"quesId": fetchMyVpaVm.selectedSecQue
			// 			}
			// 		}
			// 	});
			// 	bhimUpiService.getNativeData(constantConfig.upiConstant.updateDevice, json).then(function (data) {
			// 		utilityService.hideSpinner();
			// 		if (JSON.parse(data).status === 'S') {
			// 			var fetchVpaPopup = $ionicPopup.alert({
			// 				template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src="img/FT/BhimUpi/successSymbol.svg" /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>Your profile has been fetched successfully</span></div></div></div>',
			// 				title: '',
			// 				cssClass: 'bhim-alert-popup',
			// 				scope: $scope,
			// 				buttons: [{
			// 					text: 'OK',
			// 					type: 'button-positive',
			// 					onTap: function (e) {
			// 						fetchMyVpaVm.checkDevice();
			// 					}
			// 				}]
			// 			});
			// 		} else {
			// 			utilityService.showBhimUpiAlert("error", JSON.parse(data).statusDesc);
			// 		}
			// 	}, function (msg) {
			// 		utilityService.hideSpinner();
			// 		utilityService.showBhimUpiAlert("error", msg);
			// 	});
			// }
		};

		fetchMyVpaVm.checkDevice = function () {
			utilityService.showSpinner();
			var json = JSON.stringify({
				"addInfo": {
					"addInfo10": constantConfig.upiConstant.addInfo10,
					"addInfo9": constantConfig.upiConstant.addInfo9
				},
				"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"updateFlag": constantConfig.upiConstant.updateFlag,
                "smsSent": device.platform.toLowerCase() == 'android' ? false : "false"
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.checkDevice, json).then(function (data) {
				$rootScope.checkDeviceInfo = JSON.parse(data);
				utilityService.hideSpinner();
				if ($rootScope.checkDeviceInfo.status == 'S') {
					if ($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNN') {
						$state.go('menu.createNewVpa');
					} else if ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNM') {
						$state.go('menu.fundtrans');
					} else if (($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNM') || ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNN')) {
						$state.go('menu.vpaOptions');
					}
				} else {
					utilityService.showBhimUpiAlert("error", $rootScope.checkDeviceInfo.statusDesc);
				}
			}, function (msg) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		};

		fetchMyVpaVm.deRegisterProfile = function(){
			fetchMyVpaVm.confirmPopup = $ionicPopup.confirm({
                cssClass: 'dialog',
                template: '<div style="text-align: left !important;" class="button_fund fontSize-subHeading font-dark-grey" translate="">Are you sure you want to deregister your UPI profile?</div><br><div style="text-align: left !important;" class="button_fund fontSize-subHeading roboto-regular font-dark-grey">Post Deregistration,</div></div><div style="text-align: left !important;" class="button_fund fontSize-subHeading roboto-regular font-dark-grey"><ul class="bhim-ul-disc"><li><div class="pay-pos roboto-light font-size pad-0 bhim-upi-li bhim-pad-right15">Fund transfer through UPI will not be available</div></li><li><div class="pay-pos roboto-light font-size pad-0 mar-top10 bhim-upi-li bhim-pad-right15">Same UPI ID(s) will not be available for 2 years.</div></li></ul></div>',
                buttons: [{
                    text: '<span>Cancel</span>',
                    onTap: function (e) {
                        fetchMyVpaVm.confirmPopup.close();
                    }
                }, {
                    text: 'Confirm',
                    type: 'button-positive',
                    onTap: function (e) {
                        fetchMyVpaVm.confirmPopup.close();
                        fetchMyVpaVm.deregisterConfirm();
                    }
                }]
            });
		}

		fetchMyVpaVm.deregisterConfirm = function () {
            utilityService.showSpinner();
            var json = JSON.stringify({
                "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "updateFlag": constantConfig.upiConstant.updateFlag,
                "userInfo": {
                    "defVPAStatus": false,
                    "isMerchant": false,
                    "secretDetails": {
                        "secretAnswer": constantConfig.upiConstant.secretAnswer,
                        "quesId": constantConfig.upiConstant.secretQuestionId,
                        "quesName": constantConfig.upiConstant.secretQuestionName
                    },
                    "showMerchant": false,
                    "accountId": 0
                }
            })
            bhimUpiService.getNativeData(constantConfig.upiConstant.deRegisterAccount, json).then(function (data) {
                utilityService.hideSpinner();
                fetchMyVpaVm.deRegisterData = JSON.parse(data);
                if (fetchMyVpaVm.deRegisterData.status == 'S') {
                    $state.go('menu.fundsTransferLanding');
                } else {
                    utilityService.showBhimUpiAlert("error", fetchMyVpaVm.deRegisterData.statusDesc);
                }
            }, function (msg) {
                utilityService.hideSpinner();
                utilityService.showBhimUpiAlert("error", msg);
            });
        }

		fetchMyVpaVm.toggleSecretAns = function () {
			fetchMyVpaVm.isTextReadable == true ? fetchMyVpaVm.isTextReadable = false : fetchMyVpaVm.isTextReadable = true;
		};

		$scope.$on('$ionicView.beforeEnter', function () {
			fetchMyVpaVm.secQuestions = customerInfoService.secQuestions;
			customerInfoService.secQuestions = '';
			fetchMyVpaVm.isTextReadable = false;
			fetchMyVpaVm.secretDetails = $rootScope.checkDeviceInfo.userInfo.secretDetails;
			fetchMyVpaVm.selectedSecQue = fetchMyVpaVm.secretDetails.quesId;
			fetchMyVpaVm.secretAnswer = '';
		});

		return this;
	}

]);
