'use strict';

angularApp.controller('reVerifyDeviceController', ["$state",
	"$rootScope",
	"utilityService",
	"constantConfig",
	"customerInfoService",
	"ionicToast",
	"bhimUpiService",
	"$scope",
	"$ionicPopup",

	function ($state,
		$rootScope,
		utilityService,
		constantConfig,
		customerInfoService,
		ionicToast,
		bhimUpiService,
		$scope,
		$ionicPopup) {

		var reVerifyDeviceVm = this;

		reVerifyDeviceVm.goBack = function () {
			bhimUpiService.isForgotUpiPin = "";
			$state.go('menu.fundsTransferLanding');
		}

		reVerifyDeviceVm.resetUpiPin = function () {
			if (!reVerifyDeviceVm.selectedAccount) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("alert", "Please select account number to proceed.");
				return false;
			}
			customerInfoService.verifyAccountObj = JSON.parse(reVerifyDeviceVm.selectedAccount);
			if (customerInfoService.verifyAccountObj.mpinFlag == 'Y') {
				$state.go('menu.createUPIPin');
			} else {
				utilityService.showBhimUpiAlert("alert", "You haven't set UPI pin for selected account. Click OK to proceed.", "menu.createUPIPin");
			}
		}

		reVerifyDeviceVm.androidReVerification = function(){
			utilityService.showSpinner();
			var json = JSON.stringify({
				"accountInfo": reVerifyDeviceVm.selectedAccountObj,
				"payerType": {
					"accountId": reVerifyDeviceVm.selectedAccountObj.accId,
					"accountNo": reVerifyDeviceVm.selectedAccountObj.maskedAccountNumber
				},
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"transactionNote": ""
			})
			bhimUpiService.isUpiRegistration = false;
			bhimUpiService.getNativeData("onVerifyUPIPin", json).then(function (data) {
				bhimUpiService.isUpiRegistration = true;
				utilityService.hideSpinner();
				if (JSON.parse(data).status == 'S') {
					console.log(JSON.parse(data));
					localStorage.setItem('appGenId', JSON.parse(data).deviceInfo.servGenId);
					bhimUpiService.isUpiRegistration = false;
					var onVerifyUPIPin = $ionicPopup.alert({
						template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src="img/FT/BhimUpi/successSymbol.svg" /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>You have successfully verified UPI pin.</span></div></div></div>',
						title: '',
						cssClass: 'bhim-alert-popup',
						scope: $scope,
						buttons: [{
							text: 'OK',
							type: 'button-positive',
							onTap: function (e) {
								onVerifyUPIPin.close();
								utilityService.showSpinner();
								bhimUpiService.getNativeData("setAppGenId", localStorage.getItem("appGenId")).then(function (data) {
									var json = JSON.stringify({
										"addInfo": {
											"addInfo10": constantConfig.upiConstant.addInfo10,
											"addInfo9": constantConfig.upiConstant.addInfo9
										},
										"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
										"requestInfo": {
											"pspId": constantConfig.upiConstant.pspId,
											"pspRefNo": generateRandomString(27)
										},
										"updateFlag": constantConfig.upiConstant.updateFlag,
										"smsSent": false
									});
									bhimUpiService.getNativeData(constantConfig.upiConstant.checkDevice, json).then(function (data) {
										$rootScope.checkDeviceInfo = JSON.parse(data);
										utilityService.hideSpinner();
										if ($rootScope.checkDeviceInfo.status == 'S') {
											$state.go('menu.fundtrans');//Redirect UPI Dashboard
										} else {
											$state.go('menu.fundsTransferLanding');//Redirect FT main Dashboard
										}
									}, function (msg) {
										utilityService.hideSpinner();
										$state.go('menu.fundsTransferLanding');//Redirect FT main Dashboard
									});
								}, function (msg) {
									utilityService.hideSpinner();
									utilityService.showBhimUpiAlert("error", msg);
								});
							}
						}]
					});
				} else {
					utilityService.showBhimUpiAlert("error", JSON.parse(data).statusDesc);
				}
			}, function (msg) {
				bhimUpiService.isUpiRegistration = true;
				reVerifyDeviceVm.isForgotUpiPin = true;
				bhimUpiService.isForgotUpiPin = reVerifyDeviceVm.isForgotUpiPin;
				utilityService.hideSpinner();
				if (msg != -101)
					utilityService.showBhimUpiAlert("error", msg);
			});
		}

		reVerifyDeviceVm.iosReVerification = function(){
			utilityService.showSpinner();
			var json = JSON.stringify({
				"passwordLength" : reVerifyDeviceVm.selectedAccountObj.uPinLength.toString(),
				"uPinFType" : reVerifyDeviceVm.selectedAccountObj.uPinFType,
				"bankName" : reVerifyDeviceVm.selectedAccountObj.bankName,
				"mobileNo" : $rootScope.checkDeviceInfo.deviceInfo.mobileNo ? $rootScope.checkDeviceInfo.deviceInfo.mobileNo.toString() : "",
				"payerVPA" : $rootScope.checkDeviceInfo.userInfo.virtualAddress,
				"accountNo" : reVerifyDeviceVm.selectedAccountObj.maskedAccountNumber.toString(),
				"accID" : reVerifyDeviceVm.selectedAccountObj.accId.toString()
			})
			bhimUpiService.isUpiRegistration = false;
			bhimUpiService.getNativeData("onVerifyUPIPin", json).then(function (data) {
				bhimUpiService.isUpiRegistration = true;
				utilityService.hideSpinner();
				if (JSON.parse(data).status == 'S') {
					console.log(JSON.parse(data));
					localStorage.setItem('appGenId', JSON.parse(data).deviceInfo.servGenId);
					var onVerifyUPIPin = $ionicPopup.alert({
						template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src="img/FT/BhimUpi/successSymbol.svg" /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>You have successfully verified UPI pin.</span></div></div></div>',
						title: '',
						cssClass: 'bhim-alert-popup',
						scope: $scope,
						buttons: [{
							text: 'OK',
							type: 'button-positive',
							onTap: function (e) {
								onVerifyUPIPin.close();
								utilityService.showSpinner();
								bhimUpiService.getNativeData("setAppGenId", localStorage.getItem("appGenId")).then(function (data) {
									var json = JSON.stringify({
										"addInfo": {
											"addInfo10": constantConfig.upiConstant.addInfo10,
											"addInfo9": constantConfig.upiConstant.addInfo9
										},
										"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
										"requestInfo": {
											"pspId": constantConfig.upiConstant.pspId,
											"pspRefNo": generateRandomString(27)
										},
										"updateFlag": constantConfig.upiConstant.updateFlag,
										"smsSent": "false"
									});
									bhimUpiService.getNativeData(constantConfig.upiConstant.checkDevice, json).then(function (data) {
										$rootScope.checkDeviceInfo = JSON.parse(data);
										utilityService.hideSpinner();
										if ($rootScope.checkDeviceInfo.status == 'S') {
											$state.go('menu.fundtrans');//Redirect UPI Dashboard
										} else {
											$state.go('menu.fundsTransferLanding');//Redirect FT main Dashboard
										}
									}, function (msg) {
										utilityService.hideSpinner();
										$state.go('menu.fundsTransferLanding');//Redirect FT main Dashboard
									});
								}, function (msg) {
									utilityService.hideSpinner();
									utilityService.showBhimUpiAlert("error", msg);
								});
							}
						}]
					});
				} else {
					utilityService.showBhimUpiAlert("error", JSON.parse(data).statusDesc);
				}
			}, function (msg) {
				bhimUpiService.isUpiRegistration = true;
				reVerifyDeviceVm.isForgotUpiPin = true;
				bhimUpiService.isForgotUpiPin = reVerifyDeviceVm.isForgotUpiPin;
				utilityService.hideSpinner();
				if (msg != -101)
					utilityService.showBhimUpiAlert("error", msg);
			});
		}

		reVerifyDeviceVm.reVerifyDevice = function () {
			if (!reVerifyDeviceVm.selectedAccount) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("alert", "Please select account number for completing verification.");
				return false;
			}
			reVerifyDeviceVm.selectedAccountObj = JSON.parse(reVerifyDeviceVm.selectedAccount);
			customerInfoService.verifyAccountObj = reVerifyDeviceVm.selectedAccountObj;
			if (reVerifyDeviceVm.selectedAccountObj.mpinFlag == 'Y') {
				if (device.platform.toLowerCase() == 'android'){
					reVerifyDeviceVm.androidReVerification();
				}else{
					reVerifyDeviceVm.iosReVerification();
				}
			} else {
				$state.go('menu.createUPIPin');
			}
		}

		$scope.$on('$ionicView.beforeEnter', function () {
			reVerifyDeviceVm.isForgotUpiPin = bhimUpiService.isForgotUpiPin;
			reVerifyDeviceVm.selectedAccount = "";
			reVerifyDeviceVm.checkDeviceData = $rootScope.checkDeviceInfo;
			reVerifyDeviceVm.accountList = $rootScope.checkDeviceInfo.accountList;
		});

		return this;
	}

]);

