'use strict';

angularApp.controller('selectNumberController', ["$state",
	"$ionicPopup",
	"$scope",
	"customerInfoService",
	"utilityService",
	"constantConfig",
	"$rootScope",
	"ionicToast",
	"bhimUpiService",
	"$interval",

	function ($state,
		$ionicPopup,
		$scope,
		customerInfoService,
		utilityService,
		constantConfig,
		$rootScope,
		ionicToast,
		bhimUpiService,
		$interval) {

		var selectNumberVm = this;

		$scope.$on('$ionicView.beforeEnter', function () {
			selectNumberVm.showWaitSpinner = false;
			selectNumberVm.simcards = customerInfoService.simCardInfo.cards;
		});

		selectNumberVm.showTimerForReVerification = function () {
			var timeLeft = 10;
			selectNumberVm.spinner = $interval(function () {
				if (timeLeft == 0) {
					selectNumberVm.showWaitSpinner = false;
					selectNumberVm.checkDeviceAfterSMS();
				} else {
					selectNumberVm.showWaitSpinner = true;
					selectNumberVm.timeRemaining = timeLeft;
					timeLeft--;
				}
			}, 1000)
		}

		selectNumberVm.sendSms = function (sim) {
			if (sim.carrierName.indexOf('No service') == -1) {
				utilityService.showSpinner();
				var json = JSON.stringify({
					"smsContent": $rootScope.checkDeviceInfo.smsGateWayContent,
					"smsEncKey": $rootScope.checkDeviceInfo.smsGateWayKey,
					"smsGateWayNo": $rootScope.checkDeviceInfo.smsGateWayNo,
					"slot": sim.simSlotIndex.toString()
				});
				bhimUpiService.isUpiRegistration = false;
				bhimUpiService.getNativeData(constantConfig.upiConstant.sendsms, json).then(function (data) {
					bhimUpiService.isUpiRegistration = true;
					if (data.smsStatus === 'S') {
						if ($rootScope.previousPage == 'fetchMyVpa') {
							utilityService.hideSpinner();
							selectNumberVm.showTimerForReVerification();
						} else {
							utilityService.hideSpinner();
							selectNumberVm.showTimerForReVerification();
						}
					} else if (data.smsStatus === 'A') {
						utilityService.hideSpinner();
						utilityService.showBhimUpiAlert("alert", "Your phone is in flight mode. Please retry.");
					} else if (data.smsStatus === 'SN') {
						utilityService.hideSpinner();
						utilityService.showBhimUpiAlert("alert", "Please check whether active sim card available in your device.");
					} else {
						utilityService.hideSpinner();
						utilityService.showBhimUpiAlert("alert", "System is not able to send SMS from the selected sim. Please retry.");
					}
				}, function (msg) {
					utilityService.hideSpinner();
					utilityService.showBhimUpiAlert("error", msg);
				});
			} else {
				utilityService.showBhimUpiAlert("alert", "Kindly check your network settings for the selected sim card.");
			}
		};

		selectNumberVm.checkDeviceAfterSMS = function () {
			$interval.cancel(selectNumberVm.spinner);
			utilityService.showSpinner();
			var json = JSON.stringify({
				"addInfo": {
					"addInfo10": constantConfig.upiConstant.addInfo10,
					"addInfo9": constantConfig.upiConstant.addInfo9
				},
				"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"updateFlag": constantConfig.upiConstant.updateFlag,
				"smsSent": true
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.checkDevice, json).then(function (data) {
				$rootScope.checkDeviceInfo = JSON.parse(data);
				if ($rootScope.checkDeviceInfo.status == 'S') {
					if ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNM' &&
						$rootScope.checkDeviceInfo.re_verify && $rootScope.checkDeviceInfo.re_verify == 'Y') {
						utilityService.hideSpinner();
						$state.go('menu.reVerifyDevice');
					} else {
						if ($rootScope.checkDeviceInfo.smsStatus == 'SS') {
							selectNumberVm.getBankList();
						} else {
							utilityService.hideSpinner();
							utilityService.showBhimUpiAlert("error", "Currently system is facing the issues with SMS gateway. Please try after sometime.");
						}
					}
				} else {
					utilityService.hideSpinner();
					utilityService.showBhimUpiAlert("error", $rootScope.checkDeviceInfo.statusDesc);
				}
			}, function (msg) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		}

		selectNumberVm.getBankList = function () {
			var json = JSON.stringify({
				"addInfo": {
					"addInfo10": constantConfig.upiConstant.addInfo10,
					"addInfo9": constantConfig.upiConstant.addInfo9
				},
				"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"updateFlag": constantConfig.upiConstant.updateFlag
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.getbankListAPI, json).then(function (data) {
				utilityService.hideSpinner();
				selectNumberVm.banklistResponse = JSON.parse(data);
				if (selectNumberVm.banklistResponse.status == 'S') {
					customerInfoService.bankList = selectNumberVm.banklistResponse.bankMasterList;
					customerInfoService.accountDtlAgainstBank = [];
					$state.go('menu.selectBank');
				} else {
					utilityService.showBhimUpiAlert("error", "Currently system is facing some technical challanges for fetching the bank list. Please try after sometime.");
				}
			}, function (msg) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		};

		selectNumberVm.goBack = function () {
			if ($rootScope.previousPage == 'fetchMyVpa') {
				$state.go('menu.fetchMyVpa');
			} else {
				$interval.cancel(selectNumberVm.spinner);
				$state.go('menu.createNewVpa');
			}
		};

		return this;
	}

]);
