'use strict';

angularApp.controller('upiRegistrationSuccessController', ["$state",
	"$scope",
	"customerInfoService",
	"utilityService",
	"constantConfig",
	"$rootScope",
	"bhimUpiService",

	function ($state,
		$scope,
		customerInfoService,
		utilityService,
		constantConfig,
		$rootScope,
		bhimUpiService) {

		var upiRegistrationSuccessVm = this;

		upiRegistrationSuccessVm.close = function () {
			$state.go('menu.fundsTransferLanding');
		}

		upiRegistrationSuccessVm.checkDevice = function () {
			utilityService.showSpinner();
			bhimUpiService.getNativeData("setAppGenId", localStorage.getItem("appGenId")).then(function (data) {
				var json = JSON.stringify({
					"addInfo": {
						"addInfo10": constantConfig.upiConstant.addInfo10,
						"addInfo9": constantConfig.upiConstant.addInfo9
					},
					"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
					"requestInfo": {
						"pspId": constantConfig.upiConstant.pspId,
						"pspRefNo": generateRandomString(27)
					},
					"updateFlag": constantConfig.upiConstant.updateFlag,
					"smsSent": device.platform.toLowerCase() == 'android' ? false : "false"
				});
				bhimUpiService.getNativeData(constantConfig.upiConstant.checkDevice, json).then(function (data) {
					$rootScope.checkDeviceInfo = JSON.parse(data);
					utilityService.hideSpinner();
					if ($rootScope.checkDeviceInfo.status == 'S') {
						$state.go('menu.fundtrans');//Redirect UPI Dashboard
					} else {
						$state.go('menu.fundsTransferLanding');//Redirect FT main Dashboard
					}
				}, function (msg) {
					utilityService.hideSpinner();
					$state.go('menu.fundsTransferLanding');//Redirect FT main Dashboard
				});
			}, function (msg) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		}

		$scope.$on('$ionicView.beforeEnter', function () {
			bhimUpiService.isUpiRegistration = false;
			upiRegistrationSuccessVm.registeredUpiId = customerInfoService.registeredUpiId;
		});

		return this;
	}



]);
