'use strict';

angularApp.controller('vpaOptionsController', ["$state",
	"$ionicPopup",
	"$scope",
	"customerInfoService",
	"utilityService",
	"constantConfig",
	"$rootScope",
	"ionicToast",
	"bhimUpiService",

	function ($state,
		$ionicPopup,
		$scope,
		customerInfoService,
		utilityService,
		constantConfig,
		$rootScope,
		ionicToast,
		bhimUpiService) {

		var vpaOptionsVm = this;

		vpaOptionsVm.goBack = function(){
			$state.go('menu.fundsTransferLanding');
		}

		vpaOptionsVm.fetchMyVpa = function(){
			utilityService.showSpinner();
			var json = JSON.stringify({
				"addInfo": {
					"addInfo10": constantConfig.upiConstant.addInfo10,
					"addInfo9": constantConfig.upiConstant.addInfo9
				},
				"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"updateFlag": constantConfig.upiConstant.updateFlag
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.getSecurityQuestionsList, json).then(function (data) {
				var secQueObj = JSON.parse(data);
				utilityService.hideSpinner();
				if (secQueObj.status == 'S') {
					customerInfoService.secQuestions = secQueObj.secQuesList;
					$state.go('menu.fetchMyVpa');
				}else{
					utilityService.showBhimUpiAlert("error", "Sorry, we are unable to fetch your profile. Try again.");
				}
			}, function (msg) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		};

		vpaOptionsVm.createVpa = function(){
			$state.go('menu.createNewVpa');
		};
		
		return this;
	}



]);
