'use strict';

angularApp.controller('raiseDisputeController', ["$state",
	"$ionicPopup",
	"$scope",
	"customerInfoService",
	"utilityService",
	"constantConfig",
	"$rootScope",
	"$stateParams",
	"ionicToast",
	"bhimUpiService",

	function ($state,
		$ionicPopup,
		$scope,
		customerInfoService,
		utilityService,
		constantConfig,
		$rootScope,
		$stateParams,
		ionicToast,
		bhimUpiService) {

		var raiseDisputeVm = this;

        raiseDisputeVm.raiseDispute = function(){
			if(!raiseDisputeVm.disputeType){
				utilityService.showBhimUpiAlert("alert", "Please select dispute type");
				return false;
			}
            utilityService.showSpinner();
			var json = JSON.stringify({
                "custRefNo" : raiseDisputeVm.transactionDetail.custRefNo,
                "disputeRemark" : raiseDisputeVm.remark || "Raise Dispute",
                "disputeType" : raiseDisputeVm.disputeType.split("#")[0],
                "expiryTime" : 0,
                "requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
                "upiTranRefNo" : raiseDisputeVm.transactionDetail.trnRefNo,
                "upiTransRefNo" : 0
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.onRaiseDispute, json).then(function(data){
				var raiseDisputeResp = JSON.parse(data);
                utilityService.hideSpinner();
                if(raiseDisputeResp.status == 'S'){
					customerInfoService.disputeDetails = {
						"disputeRemark" : raiseDisputeVm.remark || "Raise Dispute",
						"disputeType" : raiseDisputeVm.disputeType.split("#")[1],
						"ticketNo" : raiseDisputeResp.ticketNo,
						"transactionDetails" : customerInfoService.transaction
					}
					$state.go('menu.raiseDisputeSuccess');
					//utilityService.showBhimUpiAlert("success", raiseDisputeResp.statusDesc, "menu.transactionHistory");
                }else{
					utilityService.showBhimUpiAlert("error", raiseDisputeResp.statusDesc);
                }
			}, function(msg){
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
        }

		raiseDisputeVm.close = function () {
			$state.go('menu.transactionHistory');
        }

        $scope.$on('$ionicView.beforeEnter', function () {
			 raiseDisputeVm.remark = '';
			 raiseDisputeVm.disputeType = '';
             raiseDisputeVm.transactionDetail = customerInfoService.transaction;
             raiseDisputeVm.disputesTypes = customerInfoService.disputeTypes;
        });
		
		return this;
	}

]);
