'use strict';

angularApp.controller('transactionHistoryController', ["$state",
	"customerInfoService",
	"utilityService",
	"constantConfig",
	"$scope",
	"$ionicPopup",
	"bhimUpiService",

	function ($state,
		customerInfoService,
		utilityService,
		constantConfig,
		$scope,
		$ionicPopup,
		bhimUpiService) {

		var transactionHistoryVm = this;
		
		transactionHistoryVm.showTransactionDetails = function(transaction){
			customerInfoService.transaction = transaction;
			$state.go('menu.transactionReceipt');
		}

		transactionHistoryVm.showDisputeReceipt = function(dispute){
			customerInfoService.dispute = dispute;
			$state.go('menu.disputeReceipt');
		}

		transactionHistoryVm.grtBlockedVpaList = function(){
			transactionHistoryVm.spamList = [];
			utilityService.showSpinner();
			transactionHistoryVm.blockedVpaAvail = true;
			var json = JSON.stringify({
				"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"updateFlag": constantConfig.upiConstant.updateFlag
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.getSpamVPAList, json).then(function (data) {
				var spamVpaListResp = JSON.parse(data);
				utilityService.hideSpinner();
				if(spamVpaListResp.status == 'S'){
					if(spamVpaListResp.vpaDetails && spamVpaListResp.vpaDetails.length > 0){
						transactionHistoryVm.spamList = spamVpaListResp.vpaDetails;
					}else{
						transactionHistoryVm.blockedVpaAvail = false;
					}
				}else{
					utilityService.showBhimUpiAlert("error", spamVpaListResp.statusDesc);
				}
				
			}, function (msg) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		}

		transactionHistoryVm.getDisputedRequests = function(){
			transactionHistoryVm.disputeListAvail = true;
			utilityService.showSpinner();
			var json = JSON.stringify({
				"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"updateFlag": constantConfig.upiConstant.updateFlag,
				"requestType" : "A"
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.getDisputeList, json).then(function (data) {
				var disputedRequestsResp = JSON.parse(data);
				utilityService.hideSpinner();
				if(disputedRequestsResp.status == 'S'){
					if(disputedRequestsResp.listofCustDispute && disputedRequestsResp.listofCustDispute.length > 0){
						transactionHistoryVm.disputeList = disputedRequestsResp.listofCustDispute;
					}else{
						transactionHistoryVm.disputeListAvail = false;
					}
				}else{
					utilityService.showBhimUpiAlert("error", disputedRequestsResp.statusDesc);
				}
			}, function (msg) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		}

		transactionHistoryVm.collectRequests = function(){
			utilityService.showSpinner();
			transactionHistoryVm.collectRequestAvl = true;
			var json = JSON.stringify({
                "addInfo": {
					"addInfo10": constantConfig.upiConstant.addInfo10,
					"addInfo9": constantConfig.upiConstant.addInfo9
				},
				"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"updateFlag": constantConfig.upiConstant.updateFlag
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.getcollectList, json).then(function (data) {
				var collectRequestsResp = JSON.parse(data);
				transactionHistoryVm.pendingRequestsList = [];
				if(transactionHistoryVm.transactionHistory && transactionHistoryVm.transactionHistory.length > 0){
					for(var i = 0; i < transactionHistoryVm.transactionHistory.length; i++){
						if((transactionHistoryVm.transactionHistory[i].txnStatus && transactionHistoryVm.transactionHistory[i].txnStatus.toLowerCase() == 'pending') && 
						(transactionHistoryVm.transactionHistory[i].txnType && transactionHistoryVm.transactionHistory[i].txnType.toLowerCase() == 'collect') && 
						(transactionHistoryVm.transactionHistory[i].drCrFlag && transactionHistoryVm.transactionHistory[i].drCrFlag.toLowerCase() == 'c')){
							transactionHistoryVm.pendingRequestsList.push(transactionHistoryVm.transactionHistory[i]);
						}
					}
				}
				utilityService.hideSpinner();
				if (collectRequestsResp.status == 'S') {
					if(collectRequestsResp.collectList && collectRequestsResp.collectList.length > 0){
						transactionHistoryVm.collectRequestsList = collectRequestsResp.collectList;
					} else{
						transactionHistoryVm.collectRequestAvl = false;
					}
				}else{
					utilityService.showBhimUpiAlert("error", collectRequestsResp.statusDesc);
				}
			}, function (msg) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		}
		
		transactionHistoryVm.rejectRequest = function(collectRequest, indexVal){
			customerInfoService.upiCollectRequest = collectRequest;
			utilityService.showSpinner();
			var json = JSON.stringify({
				"addInfo": {
					"addInfo10": constantConfig.upiConstant.addInfo10,
					"addInfo9": constantConfig.upiConstant.addInfo9
				},
				"approvalStatus":"R",
				"expiryTime":0,
				"npciTranId": customerInfoService.upiCollectRequest.txnId,
				"payerType":{
					"accountId": "1234",
					"virtualAddress" : "sbi"
				},
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"upiTransRefNo": customerInfoService.upiCollectRequest.upiTrnRefNo
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.onCollectApprove, json).then(function(data){
				var collectApproveResp = JSON.parse(data).apiResp;
                utilityService.hideSpinner();
				if(collectApproveResp.status == 'R'){
					transactionHistoryVm.approveCollectPopup = $ionicPopup.confirm({
                        cssClass: 'bhim-alert-popup',
                        template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src="img/FT/BhimUpi/successSymbol.svg" /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'+collectApproveResp.statusDesc+'</span></div></div></div>',
                        buttons: [{
                            text: 'OK',
							type: 'button-positive',
                            onTap: function (e) {
                                transactionHistoryVm.approveCollectPopup.close();
								transactionHistoryVm.collectRequestsList.splice(indexVal, 1);
                                if(transactionHistoryVm.collectRequestsList.length == 0)
									transactionHistoryVm.collectRequestAvl = false;
                            }
                        }]
                    });
				}else{
					utilityService.showBhimUpiAlert("error", collectApproveResp.statusDesc);
				}
			}, function(msg){
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		}
		
		transactionHistoryVm.blockRequest = function(collectRequest, indexVal){
			customerInfoService.upiCollectRequest = collectRequest;
			utilityService.showSpinner();
			var json = JSON.stringify({
				"addInfo": {
					"addInfo10": constantConfig.upiConstant.addInfo10,
					"addInfo9": constantConfig.upiConstant.addInfo9
				},
				"approvalStatus":"S",
				"expiryTime":0,
				"npciTranId": customerInfoService.upiCollectRequest.txnId,
				"payerType":{
					"accountId": "1234",
					"virtualAddress" : "sbi"
				},
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"upiTransRefNo": customerInfoService.upiCollectRequest.upiTrnRefNo
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.onCollectApprove, json).then(function(data){
				var collectApproveResp = JSON.parse(data).apiResp;
                utilityService.hideSpinner();
				if(collectApproveResp.status == 'R'){
					transactionHistoryVm.approveCollectPopup = $ionicPopup.confirm({
                        cssClass: 'bhim-alert-popup',
                        template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src="img/FT/BhimUpi/successSymbol.svg" /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'+collectApproveResp.statusDesc+'</span></div></div></div>',
                        buttons: [{
                            text: 'OK',
							type: 'button-positive',
                            onTap: function (e) {
                                transactionHistoryVm.approveCollectPopup.close();
								transactionHistoryVm.collectRequestsList.splice(indexVal, 1);
                                if(transactionHistoryVm.collectRequestsList.length == 0)
									transactionHistoryVm.collectRequestAvl = false;
                            }
                        }]
                    });
				}else{
					utilityService.showBhimUpiAlert("error", collectApproveResp.statusDesc);
				}
			}, function(msg){
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		}

		transactionHistoryVm.approveRequest = function(collectRequest){
			customerInfoService.upiCollectRequest = collectRequest;
			customerInfoService.payeeDetails = {
				payeeType: "VA",
				requestType : 'collect',
				accountNo: collectRequest.accountNo || "",
				ifsc: collectRequest.ifsc || "",
				name : collectRequest.payeeName || "",
				vpa : collectRequest.payeeVa || "",
				amount : collectRequest.txnAmount || "",
				remark : collectRequest.txnNote || "",
				nickName : collectRequest.nickName || "",
				phoneNumber : collectRequest.phoneNumber || "",
				savePayee : collectRequest.savePayee || false
			}
			utilityService.showSpinner();
            var json = JSON.stringify({
                "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "updateFlag": constantConfig.upiConstant.updateFlag
            });
            bhimUpiService.getNativeData(constantConfig.upiConstant.getProfile, json).then(function(data) {
				utilityService.hideSpinner();
				var getProfileResponse = JSON.parse(data);
                if (getProfileResponse.status == "S") {
                    customerInfoService.payerProfileDtls = getProfileResponse;
					$state.go('menu.payToVpa_PayeeDetails');
                } else {
					utilityService.showBhimUpiAlert("error", getProfileResponse.statusDesc);
                }
            }, function(msg) {
                utilityService.hideSpinner();
                utilityService.showBhimUpiAlert("error", msg);
            });
		}

		transactionHistoryVm.raiseDispute = function (transaction) {
			customerInfoService.disputeDetails = {};
			utilityService.showSpinner();
			var json = JSON.stringify({
				"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"updateFlag": constantConfig.upiConstant.updateFlag
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.getDisputeTypeList, json).then(function (data) {
				var disputeTypesResp = JSON.parse(data);
				utilityService.hideSpinner();
				if (disputeTypesResp.status == 'S') {
					customerInfoService.disputeDetails = {
						transaction: transaction,
						disputeTypes: disputeTypesResp.disputeList
					}
					$state.go('menu.raiseDispute');
				} else {
					utilityService.showBhimUpiAlert("error", disputeTypesResp.statusDesc);
				}
			}, function (msg) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		}

		transactionHistoryVm.close = function () {
			$state.go('menu.fundtrans');
		}

		transactionHistoryVm.goback = function () {
			$state.go('menu.fundtrans');
		}
		
		transactionHistoryVm.selTab = function (selectedTabIndex) {
			transactionHistoryVm.tab = selectedTabIndex;
			if(selectedTabIndex == 2){
				transactionHistoryVm.collectRequests();
			}
			if(selectedTabIndex == 3){
				transactionHistoryVm.getDisputedRequests();
			}
			if(selectedTabIndex == 4){
				transactionHistoryVm.grtBlockedVpaList();
			}
		}

		$scope.isGroupShown = function (accountType) {
			return ($scope.shownGroup === accountType);
		};

		$scope.toggleGroup = function (accountType) {
			if ($scope.isGroupShown(accountType)) {
				$scope.shownGroup = null;
			} else {
				$scope.shownGroup = accountType;
			}
		};

		transactionHistoryVm.unblockUpiId = function (spamObj, indexVal) {
			utilityService.showSpinner();
			var json = JSON.stringify({
				"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"updateFlag": constantConfig.upiConstant.updateFlag,
				"spamRefNo" : spamObj.spamRefNo
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.onUnBlockVPA, json).then(function (data) {
				var unBlockVPAResp = JSON.parse(data);
				utilityService.hideSpinner();
				if (unBlockVPAResp.status == 'S') {
					 var unblockVpaPopup = $ionicPopup.show({
						cssClass: 'bhim-alert-popup',
                        template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src="img/FT/BhimUpi/successSymbol.svg" /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'+unBlockVPAResp.statusDesc+'</span></div></div></div>',
                        title: '',
                        scope: $scope,
                        buttons: [{
                            text: 'OK',
                            type: 'button-positive',
                            onTap: function (e) {
								transactionHistoryVm.spamList.splice(indexVal, 1);
								if(transactionHistoryVm.spamList.length == 0)
									transactionHistoryVm.blockedVpaAvail = false;
								unblockVpaPopup.close();
                            }
                        }]
                    });
				} else {
					utilityService.showBhimUpiAlert("error", unBlockVPAResp.statusDesc);
				}
			}, function (msg) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		}

		$scope.$on('$ionicView.beforeEnter', function () {
			transactionHistoryVm.tab = 1;
			transactionHistoryVm.pendingRequestsList = [];
			transactionHistoryVm.collectRequestsList = '';
			transactionHistoryVm.transactionHistoryBlank = false;
			transactionHistoryVm.transactionHistory = customerInfoService.transactionHistory;
			if(!transactionHistoryVm.transactionHistory || (transactionHistoryVm.transactionHistory && transactionHistoryVm.transactionHistory.length == 0)){
				transactionHistoryVm.transactionHistoryBlank = true;
			}
		});

		return this;
	}

]);
