'use strict';

angularApp.controller('transactionReceiptController', ["$state",
	"$ionicPopup",
	"$scope",
	"customerInfoService",
	"utilityService",
	"constantConfig",
	"$rootScope",
	"ionicToast",
	"bhimUpiService",

	function ($state,
		$ionicPopup,
		$scope,
		customerInfoService,
		utilityService,
		constantConfig,
		$rootScope,
		ionicToast,
		bhimUpiService) {

		var transactionReceiptVm = this;

		transactionReceiptVm.repeatTransaction = function(){
			customerInfoService.payeeDetails = {
				payeeType: customerInfoService.transaction.addressType ? customerInfoService.transaction.addressType.trim() : "VA",
				requestType : 'pay',
				accountNo: customerInfoService.transaction.payeeAccountNo || "",
				ifsc: customerInfoService.transaction.payeeIfsc || "",
				name : transactionReceiptVm.transaction.payeeName || "",
				vpa : transactionReceiptVm.transaction.payeeVirtualAddress || "",
				amount : transactionReceiptVm.transaction.txnAmount || "",
				remark : transactionReceiptVm.transaction.txnNote || "",
				nickName : "",
				phoneNumber : "",
				savePayee : false
			}
			utilityService.showSpinner();
            var json = JSON.stringify({
                "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "updateFlag": constantConfig.upiConstant.updateFlag
            });
            bhimUpiService.getNativeData(constantConfig.upiConstant.getProfile, json).then(function(data) {
				utilityService.hideSpinner();
				var getProfileResponse = JSON.parse(data);
                if (getProfileResponse.status == "S") {
                    customerInfoService.payerProfileDtls = getProfileResponse;
					$state.go('menu.payToVpa_PayeeDetails');
                } else {
					utilityService.showBhimUpiAlert("error", getProfileResponse.statusDesc);
                }
            }, function(msg) {
                utilityService.hideSpinner();
                utilityService.showBhimUpiAlert("error", msg);
            });
		}

		transactionReceiptVm.raiseDispute = function () {
			utilityService.showSpinner();
			var json = JSON.stringify({
				"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"updateFlag": constantConfig.upiConstant.updateFlag,
				"payType" : transactionReceiptVm.transaction.payType
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.getDisputeTypeList, json).then(function (data) {
				utilityService.hideSpinner();
				if(JSON.parse(data).status == 'S'){
					customerInfoService.disputeTypes = JSON.parse(data).disputeList;
					$state.go('menu.raiseDispute');
				}else{
					utilityService.showBhimUpiAlert("error", JSON.parse(data).statusDesc);
				}
			}, function (msg) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		}

		transactionReceiptVm.goToBack = function () {
			$state.go('menu.transactionHistory');
		}

		$scope.$on('$ionicView.beforeEnter', function () {
			transactionReceiptVm.transaction = customerInfoService.transaction;
			transactionReceiptVm.transactionType = transactionReceiptVm.transaction.drCrFlag;
		});

		return this;
	}
]);
