'use strict';

angularApp.controller('fundtransController', ["$state",
	"$ionicPopup",
	"$scope",
	"customerInfoService",
	"utilityService",
	"constantConfig",
	"$rootScope",
	"fTBeneficiaryService",
	"$q",
	"bhimUpiService",
	"ionicToast",
	"bQRService",

	function ($state,
		$ionicPopup,
		$scope,
		customerInfoService,
		utilityService,
		constantConfig,
		$rootScope,
		fTBeneficiaryService,
		$q,
		bhimUpiService,
		ionicToast,
		bQRService) {

		var fundtransVm = this;

		fundtransVm.upiPayments = function (val) {
			fTBeneficiaryService.tabIndexVal = "";
			if (device.platform.toLowerCase() == 'android') {
				bhimUpiService.getNativeData("getcontactpermission", {}).then(function (data) {
					if (data.contactpermission === 'Allowed') {
						bhimUpiService.getNativeData("openContacts", {}).then(function (data) {
							var contact = data;

							if (contact && contact.number) {
								var x = contact.number.replace(/\s/g, '');
								if (x.length >= 10) {
									fundtransVm.vpa = x.substr(x.length - 10) + "@sbi";
								} else {
									return false;
									utilityService.showBhimUpiAlert("alert", 'Please select valid mobile number');
								}
							} else {
								return false;
								utilityService.showBhimUpiAlert("alert", 'Please select valid mobile number');
							}

							customerInfoService.payeeDetails = {
								payeeType: "VA",
								requestType: 'pay',
								accountNo: "",
								ifsc: "",
								name: "",
								vpa: fundtransVm.vpa || "",
								amount: "",
								remark: "",
								nickName: "",
								phoneNumber: "",
								savePayee: false
							}
							$state.go('menu.payToVpa');
						}, function (msg) {
							utilityService.hideSpinner();
							utilityService.showBhimUpiAlert("error", msg);
						});
					} else {
						utilityService.hideSpinner();
						ionicToast.show("Contact permission denied. Please allow to proceed", 'bottom', false, 3000);
					}
				}, function (msg) {
					utilityService.hideSpinner();
					utilityService.showBhimUpiAlert("error", msg);
				});
			} else {
				bhimUpiService.getNativeData("openContacts", {}).then(function (data) {
					var contact = data;

					if (contact) {
						var x = contact.replace(/\s/g, '');
						if (x.length >= 10) {
							fundtransVm.vpa = x.substr(x.length - 10) + "@sbi";
						} else {
							return false;
							utilityService.showBhimUpiAlert("alert", 'Please select valid mobile number');
						}
					} else {
						return false;
						utilityService.showBhimUpiAlert("alert", 'Please select valid mobile number');
					}

					customerInfoService.payeeDetails = {
						payeeType: "VA",
						requestType: 'pay',
						accountNo: "",
						ifsc: "",
						name: "",
						vpa: fundtransVm.vpa || "",
						amount: "",
						remark: "",
						nickName: "",
						phoneNumber: "",
						savePayee: false
					}
					$state.go('menu.payToVpa');
				}, function (msg) {
					utilityService.hideSpinner();
					utilityService.showBhimUpiAlert("error", msg);
				});
			}
		}

		fundtransVm.sendCollectRequest = function (action) {
			customerInfoService.collectAction = action;
			utilityService.showSpinner();
			var json = JSON.stringify({
				"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"updateFlag": constantConfig.upiConstant.updateFlag
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.getProfile, json).then(function (data) {
				utilityService.hideSpinner();
				var getProfileResponse = JSON.parse(data);
				if (getProfileResponse.status == "S") {
					customerInfoService.collectRequest = {};
					customerInfoService.profileDetails = getProfileResponse;
					$state.go('menu.sendCollectRequest');
				} else {
					utilityService.showBhimUpiAlert("error", getProfileResponse.statusDesc);
				}
			}, function (msg) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		}

		fundtransVm.payToVpa = function (val) {
			fTBeneficiaryService.tabIndexVal = val;
			customerInfoService.payerDetails = {};
			customerInfoService.payeeDetails = {};
			utilityService.showSpinner();
			var json = JSON.stringify({
				"appVersionCode": 0,
				"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"requestType": "VA",
				"updateFlag": constantConfig.upiConstant.updateFlag
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.getBeneficiaryList, json).then(function (data) {
				utilityService.hideSpinner();
				var getBeneficiaryListResponse = JSON.parse(data);
				if (getBeneficiaryListResponse.status == 'S') {
					if (getBeneficiaryListResponse.beneficiaryList && getBeneficiaryListResponse.beneficiaryList.length > 0) {
						customerInfoService.upiBeneficiaries = getBeneficiaryListResponse.beneficiaryList;
					} else {
						customerInfoService.upiBeneficiaries = [];
					}
					$state.go('menu.upiPayments');
				} else {
					utilityService.showBhimUpiAlert("error", getBeneficiaryListResponse.statusDesc);
				}
			}, function (msg) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		}

		fundtransVm.payToQR = function () {
			customerInfoService.scanQrEntrypoint = 'BHIMLANDING';
			customerInfoService.payerDetails = {};
			customerInfoService.payeeDetails = {};
			//$state.go('menu.payToQR');
			fundtransVm.scanQrCode();
		}

		fundtransVm.payToAccount = function (val) {
			fTBeneficiaryService.tabIndexVal = val;
			customerInfoService.payerDetails = {};
			customerInfoService.payeeDetails = {};

			utilityService.showSpinner();
			var json = JSON.stringify({
				"appVersionCode": 0,
				"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"requestType": "AC",
				"updateFlag": constantConfig.upiConstant.updateFlag
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.getBeneficiaryList, json).then(function (data) {
				utilityService.hideSpinner();
				var getBeneficiaryListResponse = JSON.parse(data);
				if (getBeneficiaryListResponse.status == 'S') {
					if (getBeneficiaryListResponse.beneficiaryList && getBeneficiaryListResponse.beneficiaryList.length > 0) {
						customerInfoService.upiAccBeneficiaries = getBeneficiaryListResponse.beneficiaryList;
					} else {
						customerInfoService.upiAccBeneficiaries = [];
					}
					$state.go('menu.upiPayments');
				} else {
					utilityService.showBhimUpiAlert("error", getBeneficiaryListResponse.statusDesc);
				}
			}, function (msg) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		}

		fundtransVm.transactionHistory = function () {
			utilityService.showSpinner();
			var json = JSON.stringify({
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				}
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.getTransactionHistoryList, json).then(function (data) {
				var transHistory = JSON.parse(data);
				utilityService.hideSpinner();
				if (transHistory.status == 'S') {
					customerInfoService.transactionHistory = transHistory.transDetails;
					$state.go('menu.transactionHistory');
				} else {
					utilityService.showBhimUpiAlert("error", transHistory.statusDesc);
				}
			}, function (msg) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		}

		fundtransVm.collectRequests = function () {
			utilityService.showSpinner();
			var json = JSON.stringify({
				"addInfo": {
					"addInfo10": constantConfig.upiConstant.addInfo10,
					"addInfo9": constantConfig.upiConstant.addInfo9
				},
				"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"updateFlag": constantConfig.upiConstant.updateFlag
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.getcollectList, json).then(function (data) {
				var collectRequestsResp = JSON.parse(data);
				utilityService.hideSpinner();
				if (collectRequestsResp.status == 'S') {
					customerInfoService.collectRequestsList = collectRequestsResp.collectList;
					$state.go('menu.pendingRequests');
				} else {
					utilityService.showBhimUpiAlert("error", collectRequestsResp.statusDesc);
				}
			}, function (msg) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		}

		fundtransVm.close = function () {
			$state.go('menu.fundsTransferLanding');
		}

		fundtransVm.manageAccounts = function () {
			if ($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNN') {
				$state.go('menu.createNewVpa');
			} else if ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNM') {
				utilityService.showSpinner();
				var json = JSON.stringify({
					"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
					"requestInfo": {
						"pspId": constantConfig.upiConstant.pspId,
						"pspRefNo": generateRandomString(27)
					},
					"updateFlag": constantConfig.upiConstant.updateFlag
				});
				bhimUpiService.getNativeData(constantConfig.upiConstant.getProfile, json).then(function (data) {
					utilityService.hideSpinner();
					var getProfileResponse = JSON.parse(data);
					if (getProfileResponse.status == "S") {
						customerInfoService.payerProfileDtls = getProfileResponse;
						$state.go('menu.accounts');
					} else {
						utilityService.showBhimUpiAlert("error", getProfileResponse.statusDesc);
					}
				}, function (msg) {
					utilityService.hideSpinner();
					utilityService.showBhimUpiAlert("error", msg);
				});
			} else if (($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNM') || ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNN')) {
				$state.go('menu.vpaOptions');
			}
		}

		fundtransVm.viewMyQrCode = function () {
			utilityService.showSpinner();
			var json = JSON.stringify({
				"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"updateFlag": constantConfig.upiConstant.updateFlag
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.getProfile, json).then(function (data) {
				utilityService.hideSpinner();
				var getProfileResponse = JSON.parse(data);
				if (getProfileResponse.status == "S") {
					customerInfoService.payerProfileDtls = getProfileResponse;
					$state.go('menu.viewMyQrCode');
				} else {
					utilityService.showBhimUpiAlert("error", getProfileResponse.statusDesc);
				}
			}, function (msg) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		}

		//Get query parameter from URL
		fundtransVm.getParameterByName = function (name, url) {
			if (!url) url = window.location.href;
			name = name.replace(/[\[\]]/g, "\\$&");
			var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)"),
				results = regex.exec(url);
			if (!results) return null;
			if (!results[2]) return '';
			if(name=='am'){
				if(results[2].search("E")!==-1 || results[2].search("e")!==-1){
                return results[2];
			}
		}
			return decodeURIComponent(results[2].replace(/\+/g, " "));
		}

		//Scan the QR Code
		fundtransVm.scanQrCode = function () {
			if (device.platform.toLowerCase() == 'android') {
				bhimUpiService.getNativeData("scanqrcode", {}).then(function (data) {
					var barcodeData = data.scanResult;
					bhimUpiService.getQRCode(barcodeData).then(function (data) {
						if (data.validStatus == 0) {
							if (data.isQRValid == true) {
								bQRService.merchantDetails = data;
								bQRService.merchantDetails.redirectType = "fundsTransfer";
								$state.go("menu.scanPay");
							} else {
								utilityService.showBhimUpiAlert("error", "Invalid QR");
							}
						} else {
							fundtransVm.goToBhimUpiPayment(barcodeData);
						}
					}, function (error) {
						utilityService.showBhimUpiAlert("error", error.responseMessage);
					});
				}, function (error) {
					utilityService.showBhimUpiAlert("error", error);
				});
			} else {
				bhimUpiService.getNativeData("scanqrcode", {}).then(function (data) {
                    var barcodeData = data;

                    if (barcodeData.indexOf("upi://pay?") !== 0) {
                        bhimUpiService.getQRCode(barcodeData).then(function (data) {
                            if (data.validStatus == 0) {
                                if (data.isQRValid == true) {
                                    bQRService.merchantDetails = data;
                                    bQRService.merchantDetails.redirectType = "fundsTransfer";
                                    $state.go("menu.scanPay");
                                } else {
                                    utilityService.showBhimUpiAlert("error", "Invalid QR");
                                }
                            } else {
                                fundtransVm.goToBhimUpiPayment(barcodeData);
                            }
                        }, function (error) {
                            utilityService.showBhimUpiAlert("error", error.responseMessage);
                        });
                     } else {
                         fundtransVm.goToBhimUpiPayment(barcodeData);
                     }

                }, function (error) {
                    utilityService.showBhimUpiAlert("error", error);
                });
			}
		};

		fundtransVm.goToBhimUpiPayment = function (barcodeData) {
			try {
				fundtransVm.isBarcodeScanned = !utilityService.isEmpty(barcodeData);
				if (fundtransVm.isBarcodeScanned) {
					fundtransVm.amount = "";
					fundtransVm.remark = "";
					fundtransVm.currencyCode = "";
					fundtransVm.ref_id = "";
					fundtransVm.merchantCatCode = "";
					fundtransVm.minAmount = "";
					fundtransVm.ref_url = "";
					fundtransVm.tid = "";

					fundtransVm.payeeVpa = fundtransVm.getParameterByName('pa', barcodeData);
					fundtransVm.scannedImage = "img/FT/PayQRCode.svg";
					if (fundtransVm.getParameterByName('am', barcodeData))
						fundtransVm.amount = Number(fundtransVm.getParameterByName('am', barcodeData));
					if (fundtransVm.getParameterByName('tn', barcodeData))
						fundtransVm.remark = fundtransVm.getParameterByName('tn', barcodeData);
					if (fundtransVm.getParameterByName('cu', barcodeData))
                        fundtransVm.currencyCode = fundtransVm.getParameterByName('cu', barcodeData);
                    if (fundtransVm.getParameterByName('tr', barcodeData))
                        fundtransVm.ref_id = fundtransVm.getParameterByName('tr', barcodeData);
                    if (fundtransVm.getParameterByName('mc', barcodeData))
                        fundtransVm.merchantCatCode = fundtransVm.getParameterByName('mc', barcodeData);
                    if (fundtransVm.getParameterByName('mam', barcodeData))
                        fundtransVm.minAmount = fundtransVm.getParameterByName('mam', barcodeData);
                    if (fundtransVm.getParameterByName('url', barcodeData))
                        fundtransVm.ref_url = fundtransVm.getParameterByName('url', barcodeData);
                    if (fundtransVm.getParameterByName('tid', barcodeData))
                        fundtransVm.tid = fundtransVm.getParameterByName('tid', barcodeData);


					fundtransVm.checkVpaAvailability();
				} else {
					fundtransVm.scannedImage = "img/FT/PayQRCode.svg";
				}
			} catch (e) { }
		}

		fundtransVm.checkVpaAvailability = function () {
			if (!fundtransVm.payeeVpa) {
				utilityService.showBhimUpiAlert("alert", "Invalid QR");
				return false;
			}
			utilityService.showSpinner();
			var json = JSON.stringify({
				"addInfo": {
					"addInfo10": constantConfig.upiConstant.addInfo10,
					"addInfo9": constantConfig.upiConstant.addInfo9
				},
				"payeeType": {
					"virtualAddress": fundtransVm.payeeVpa.toString()
				},
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"vAReqType": constantConfig.upiConstant.vAReqType_T
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.checkVirtualAddressAPI, json).then(function (data) {
				var checkVpaResponse = JSON.parse(data);
				if (checkVpaResponse.status == 'VN') {
					utilityService.hideSpinner();
					utilityService.showBhimUpiAlert("alert", "This QR code data doesn't exist. Kindly check the image.");
				} else if (checkVpaResponse.status == 'VE') {
					customerInfoService.payeeDetails = {
						payeeType: "QR",
						requestType: 'qr_pay',
						accountNo: "",
						ifsc: "",
						name: checkVpaResponse.payeeType.name || "",
						vpa: checkVpaResponse.payeeType.virtualAddress || "",
						amount: fundtransVm.amount || "",
						remark: fundtransVm.remark || "",
						nickName: "",
						phoneNumber: "",
						savePayee: false,
						currencyCode : fundtransVm.currencyCode || "",
                        ref_id : fundtransVm.ref_id || "",
                        merchantCatCode : fundtransVm.merchantCatCode || "",
                        minAmount : fundtransVm.minAmount || "",
                        ref_url : fundtransVm.ref_url || "",
                        tid : fundtransVm.tid || ""
					}
					fundtransVm.getProfile();
				} else {
					utilityService.hideSpinner();
					utilityService.showBhimUpiAlert("error", "Invalid QR");
				}
			}, function (msg) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		}

		fundtransVm.getProfile = function () {
			utilityService.showSpinner();
			var json = JSON.stringify({
				"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"updateFlag": constantConfig.upiConstant.updateFlag
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.getProfile, json).then(function (data) {
				utilityService.hideSpinner();
				var getProfileResponse = JSON.parse(data);
				if (getProfileResponse.status == "S") {
					customerInfoService.payerProfileDtls = getProfileResponse;
					$state.go('menu.payToVpa_PayeeDetails');
				} else {
					ionicToast.show(getProfileResponse.statusDesc, 'bottom', false, 3000);
				}
			}, function (msg) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		};

		$scope.$on('$ionicView.beforeEnter', function () {
			bhimUpiService.isUpiRegistration = false;
			customerInfoService.reviewScreen = false;
			bQRService.convenienceFee = '';
			bQRService.transactionAmount = '';
		});

		return this;
	}

]);
