'use strict';

angularApp.controller('fTEditBeneficiaryController', [
	"$state",
	"$scope",
	"cameraService",
	"fTBeneficiaryService",
	"utilityService",
	"constantConfig",
	"validationService",
	"$ionicPopup",
	"fTSetOTPService",
	"loggedInUserService",
	"$rootScope",
	"fTReviewService",
	"cryptoService",

	function ( 
		$state,
		$scope,
		cameraService,
		fTBeneficiaryService,
		utilityService,
		constantConfig,
		validationService,
		$ionicPopup, fTSetOTPService, loggedInUserService, $rootScope, fTReviewService, cryptoService) {
			
		var fTEditBeneficiaryVm = this;
		
		//var loggedInUserDetails = loggedInUserService.getUserProfileDetails();
		fTEditBeneficiaryVm.userMobileNo = $rootScope.mobileNo;
		fTEditBeneficiaryVm.isOtpFieldEmpty = false;
		
		/* Page navigates back to Funds Transfer */
		fTEditBeneficiaryVm.goBack = function() {
			$state.go('menu.fundsTransfer');
		};
		
		/* Selecting an image from gallery */
		fTEditBeneficiaryVm.editImage = function() {
			cameraService.getImageFromGallery().then(function(data) {
				fTEditBeneficiaryVm.updateImage(data);
				fTEditBeneficiaryVm.setImage(data);
			}, function(error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		};
		
		/* Mapping the image to the page */
		fTEditBeneficiaryVm.setImage = function(img) {
			fTEditBeneficiaryVm.benImage = img;
			fTBeneficiaryService.customer.imgData = fTEditBeneficiaryVm.benImage;
		};
		
		/* update image */
		fTEditBeneficiaryVm.updateImage = function(imgData){
			if(fTEditBeneficiaryVm.beneficiary.picId !==""){
			var picId = fTEditBeneficiaryVm.beneficiary.benPicDocId ? fTEditBeneficiaryVm.beneficiary.benPicDocId.slice(1,-1) : '';
			var updatePicData = {
			  "id": fTEditBeneficiaryVm.beneficiary.picId,
			  "mimeType": "image/jpg",
			  "documentTitle": "Beneficiary Image",
			  "documentData": imgData.split(',')[1],
			  "nickname": fTEditBeneficiaryVm.beneficiary.nickname
			};				
			//service call to upload image
			fTBeneficiaryService.updateBeneficiaryPicture(updatePicData).then(function(response) {
				fTEditBeneficiaryVm.picDocId = response.id;
				fTEditBeneficiaryVm.picDocId=fTEditBeneficiaryVm.picDocId.replace('{','').replace('}','');
				fTBeneficiaryService.customer.picDocId = fTEditBeneficiaryVm.picDocId;
				
			}, function(error) {
				utilityService.showErrorMessage(error.responseMessage);
			});	
			}else{
				
			var updatePic= {
			  "mimeType": "image/jpg",
			  "documentTitle": "Beneficiary Image",
			  "documentData": imgData.split(',')[1],
			  "nickname": fTEditBeneficiaryVm.beneficiary.nickname
			};
			
			//service call to upload image
			fTBeneficiaryService.uploadBeneficiaryPicture(updatePic).then(function(response) {
				fTEditBeneficiaryVm.picDocId = response.id;
				fTEditBeneficiaryVm.picDocId=fTEditBeneficiaryVm.picDocId.replace('{','').replace('}','');
				fTBeneficiaryService.customer.picDocId = fTEditBeneficiaryVm.picDocId;
			}, function(error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
			}		
		};
		/* Updating the fields and navigating to funds transfer page */
		fTEditBeneficiaryVm.updateAccount = function() {
			var updateData = {
			  "inbUserId":"",
			  "benName": fTEditBeneficiaryVm.beneficiary.name,
			  "benOldNickName": fTEditBeneficiaryVm.beneficiary.nickname,
			  "benNewNickName": fTEditBeneficiaryVm.beneficiary.newNickName,
			  "benAccntNo":fTEditBeneficiaryVm.beneficiary.accountno,
			  "intraBankFlag":fTEditBeneficiaryVm.beneficiary.intraBankFlag,
			  "benType" : fTEditBeneficiaryVm.beneficiary.benType,
			  "oldTransferLimit":fTEditBeneficiaryVm.beneficiary.maxLimit,
			  "newTransferLimit": fTEditBeneficiaryVm.beneficiary.newMaxLimit,
			  "benMMID":fTEditBeneficiaryVm.beneficiary.mmid,
			  "benPicDocId":fTEditBeneficiaryVm.picDocId

			  
			};
			fTBeneficiaryService.updateData = updateData;
			$state.go('menu.ftEditBeneficiaryOtp');


		};


		fTEditBeneficiaryVm.validateMobile = function () {
			if (fTEditBeneficiaryVm.beneficiary.mobileno)
				fTEditBeneficiaryVm.showMobileError = !validationService.isValidMobile(fTEditBeneficiaryVm.beneficiary.mobileno);
			else fTEditBeneficiaryVm.showMobileError = false;
			fTEditBeneficiaryVm.nextEnable();
		};
		
		/* Enabling next button after the validations */
		fTEditBeneficiaryVm.nextEnable = function () {			
			if (!fTEditBeneficiaryVm.showMobileError && !utilityService.isUndefined(fTEditBeneficiaryVm.beneficiary.newNickName) && !fTEditBeneficiaryVm.showSpecialCharacterNicknameError) { //1601
				fTEditBeneficiaryVm.disableNext = false;
			} else {
				fTEditBeneficiaryVm.disableNext = true;
			}
		};
		
		/* Updating the mobile number input field */
		fTEditBeneficiaryVm.updateMobNo = function() {
			fTEditBeneficiaryVm.validateMobile();
			fTBeneficiaryService.customer.mobileNo = fTEditBeneficiaryVm.beneficiary.mobileno;
		};
		
		/* Updating the nick name input field */
		fTEditBeneficiaryVm.updateNickname = function() {
			fTEditBeneficiaryVm.showNickNameEmpty = !utilityService.isUndefined(fTEditBeneficiaryVm.beneficiary.newNickName);
			if(fTEditBeneficiaryVm.showNickNameEmpty){
				fTEditBeneficiaryVm.showNickNameEmpty = false;
				fTBeneficiaryService.customer.nickName = fTEditBeneficiaryVm.beneficiary.newNickName;
				
					var excludeSpecialChar =  /^[a-zA-Z0-9\s]+$/;
					if (excludeSpecialChar.test(fTEditBeneficiaryVm.beneficiary.newNickName)) {
						fTEditBeneficiaryVm.showSpecialCharacterNicknameError = false;
					} else {
						fTEditBeneficiaryVm.showSpecialCharacterNicknameError = true;
					}
				
			}
			else{
				fTEditBeneficiaryVm.showNickNameEmpty = true;
				fTEditBeneficiaryVm.showSpecialCharacterNicknameError = false;
			}
			fTEditBeneficiaryVm.nextEnable();
			
		};
		
		/* Updating the maximum limit field */
		fTEditBeneficiaryVm.updateMaxLimit = function() {
			fTEditBeneficiaryVm.showMaxLimitEmpty = !utilityService.isUndefined(fTEditBeneficiaryVm.beneficiary.newMaxLimit);
			if(fTEditBeneficiaryVm.showMaxLimitEmpty){
				if(fTEditBeneficiaryVm.beneficiary.newMaxLimit >= 1){
					fTBeneficiaryService.customer.maxLimit = fTEditBeneficiaryVm.beneficiary.newMaxLimit;
					fTEditBeneficiaryVm.showMaxLimitEmpty = false;
					fTEditBeneficiaryVm.showMaxLimitError = false;
					fTEditBeneficiaryVm.nextEnable();
				}
				else {
					fTEditBeneficiaryVm.showMaxLimitEmpty = false;
					fTEditBeneficiaryVm.showMaxLimitError = true;
					fTEditBeneficiaryVm.disableNext = true;
				}
			}
			else{
				fTEditBeneficiaryVm.showMaxLimitEmpty = true;
				fTEditBeneficiaryVm.showMaxLimitError = false;
				fTEditBeneficiaryVm.disableNext = true;
			}
		};
		
		fTEditBeneficiaryVm.validateProfilePwd = function(){
			var loggedInUserDetails = loggedInUserService.getUserProfileDetails();
			if (fTEditBeneficiaryVm.newProfilePassword) {
				fTReviewService.getProfilePassAndSerKey().then(function (response) {
					var options = {
						inbUserName:loggedInUserDetails.inbUsername,
						strPass:fTEditBeneficiaryVm.newProfilePassword,
						keyId:response.keyId,
						serviceId:response.serviceId,
						osName:device.platform
					};
					var reqParams = utilityService.commonRequestForValidateProfilePass(options);
					fTReviewService.getProfilePassAuth(reqParams).then(function (data) {
						$state.go('menu.fTEditBeneficiary');
					}, function(error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
					
				}, function(error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}else{
				utilityService.showErrorMessage('Please enter your Internet Banking Profile Password.')
			}
		};
		
		/* Navigating to Funds Transfer Home page */
		$scope.goToHome = function() {
			$state.go('menu.fundsTransfer');
		};
		
		$scope.$on('$ionicView.beforeEnter', function() {
			fTEditBeneficiaryVm.ifscValue = fTBeneficiaryService.customer.ifsc;
			fTEditBeneficiaryVm.bank = fTBeneficiaryService.customer.selectedBank;
			fTEditBeneficiaryVm.beneficiary = {
				name : fTBeneficiaryService.customer.nameData,
				nickname : fTBeneficiaryService.customer.nickName,
				accountno : fTBeneficiaryService.customer.accountNoData,
				ifsc : fTBeneficiaryService.customer.ifsc,
				mmid : fTBeneficiaryService.customer.mmid,
				imgData : fTBeneficiaryService.customer.imgData,
				benType : fTBeneficiaryService.customer.benType,
				intraBankFlag : fTBeneficiaryService.customer.intraBankFlag,
				maxLimit : fTBeneficiaryService.customer.maxLimit,
				mobileno : fTBeneficiaryService.customer.mobileNo,
				picId : fTBeneficiaryService.customer.conImg
			};
			fTEditBeneficiaryVm.setImage(fTBeneficiaryService.customer.imgData);
			fTEditBeneficiaryVm.beneficiary.newMaxLimit = fTBeneficiaryService.customer.maxLimit || '';
			fTEditBeneficiaryVm.disableNext = true;
			fTEditBeneficiaryVm.showNickNameEmpty = false;
			fTEditBeneficiaryVm.showMobileError = false;
			fTEditBeneficiaryVm.showMaxLimitError = false;
			fTEditBeneficiaryVm.showMaxLimitEmpty = false;
			fTEditBeneficiaryVm.showSpecialCharacterNicknameError = false; //1966
			fTEditBeneficiaryVm.beneficiary.newNickName = fTBeneficiaryService.customer.nickName;
			
		});
		return this;
	}
]);
