'use strict';

angularApp.controller('fTEditBeneficiaryOtpController', [
	"$state",
	"$scope",
	"fTBeneficiaryService",
	"utilityService",
	"constantConfig",
	"$ionicPopup",
	"fTSetOTPService",
	"$rootScope",
	"cryptoService",
	"autoOtpReadService",

	function (
		$state,
		$scope,
		fTBeneficiaryService,
		utilityService,
		constantConfig,
		$ionicPopup, fTSetOTPService, $rootScope, cryptoService, autoOtpReadService) {

		var fTEditBeneficiaryOtpVm = this;

		fTEditBeneficiaryOtpVm.userMobileNo = $rootScope.mobileNo;
		fTEditBeneficiaryOtpVm.isOtpFieldEmpty = false;
		fTEditBeneficiaryOtpVm.disableResend = 0;
		/* Page navigates back to Funds Transfer */
		fTEditBeneficiaryOtpVm.goBack = function () {
			$state.go('menu.fundsTransfer');
		};

		fTEditBeneficiaryOtpVm.changeOtp = function () {
			fTEditBeneficiaryOtpVm.isOtpFieldEmpty = false;
		};

		fTEditBeneficiaryOtpVm.validateOtp = function () {
			if (!fTEditBeneficiaryOtpVm.otp) {
				fTEditBeneficiaryOtpVm.isOtpFieldEmpty = true;
			} else {
				var reqParams = {};
				reqParams["otp"] = fTEditBeneficiaryOtpVm.otp;
				reqParams["mobile"] = $rootScope.mobileNo;
				fTSetOTPService.validateOTP(reqParams).then(function (resOtp) {
					if (resOtp.status.toLowerCase() == 'success') {
						var updateData = fTBeneficiaryService.updateData;
						fTBeneficiaryService.updateBeneficiary(updateData).then(function (response) {
							fTBeneficiaryService.imagesLoaded = false;
							fTEditBeneficiaryOtpVm.successPopup = $ionicPopup.show({
								title: '',
								cssClass: 'popupWidth90 popupMargin ftpopup-body popupBackgroundWhite removePopup-head textAlignCenter',
								template: '<div class="popupBodyPadding font-dark-grey"><div><img class="approvedIconPosition" src="img/FT/approved.svg"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'
									+ response.result + '</span></div></div></div>',
								scope: $scope,
								buttons: [{
									text: 'OK',
									type: 'button-assertive',
									onTap: function () {
										fTBeneficiaryService.schTransItems = "";
										fTBeneficiaryService.beneficiaries = undefined;
										$state.go('menu.fundsTransfer');
									}
								}],
							});
							fTBeneficiaryService.beneficiaries = undefined;
						}, function (error) {
							utilityService.showErrorMessage(error.responseMessage);
						});
					} else {
						utilityService.showErrorMessage(response.status);
					}
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}
		};

		fTEditBeneficiaryOtpVm.resendOtp = function () {
			fTEditBeneficiaryOtpVm.disableResend++;
			fTEditBeneficiaryOtpVm.otp = "";
			fTEditBeneficiaryOtpVm.isOtpFieldEmpty = false;
			var reqData = {};
			reqData["id"] = $rootScope.mobileNo;
			reqData.otpCode = constantConfig.keysForOTP.ftEditBenificary;
			reqData.ocHash = cryptoService.getSHA512EncryptedData(constantConfig.keysForOTP.ftEditBenificary).toString();
			fTSetOTPService.generateOTP(reqData).then(function (data) {
				// if (utilityService.isAndroidPlatform()) {
				// 	autoOtpReadService.startOtpReading().then(function (result) {
				// 		fTEditBeneficiaryOtpVm.otp = result;
				// 	}, function (error) {
				// 		console.log(error);
				// 	});
				// }
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		};

		/* Navigating to Funds Transfer Home page */
		$scope.goToHome = function () {
			$state.go('menu.fundsTransfer');
		};

		$scope.$on('$ionicView.beforeEnter', function () {
			fTEditBeneficiaryOtpVm.disableResend = 0;
			fTEditBeneficiaryOtpVm.resendOtp();
		});
		return this;
	}
]);
