'use strict';

angularApp.controller('fTEditScheduleDetailsController', [
	"$state",
	"$scope",
	"fTReviewService",
	"ionicDatePicker",
	"utilityService",
	"validationService",
	"fTBeneficiaryService",
	"$filter",
	"constantConfig",

	function ($state,
		$scope,
		fTReviewService,
		ionicDatePicker,
		utilityService,
		validationService,
		fTBeneficiaryService,
		$filter,
		constantConfig) {

			var fTEditScheduleDetailsVm = this;
			
			fTEditScheduleDetailsVm.disablePayBtn = function() {
				fTEditScheduleDetailsVm.disablePay = !(!fTEditScheduleDetailsVm.showAmountError && utilityService.isEmpty(fTEditScheduleDetailsVm.transAmount) && utilityService.isUndefined(fTEditScheduleDetailsVm.remarks));
			};
			
			/* Navigates to the previous page */
			fTEditScheduleDetailsVm.goToBack = function() {
				$state.go('menu.fundsTransfer');
			};
			
			/* Enabling next button after entering remarks */
			fTEditScheduleDetailsVm.getRemark = function(isValid) {
				fTEditScheduleDetailsVm.disablePay = !(isValid);
				return fTEditScheduleDetailsVm.disablePay;
			};
			/* Navigating to Funds Transfer Home page */
			$scope.goToHome = function() {
				$state.go('menu.fundsTransfer');
			};
			$scope.$on('$ionicView.beforeEnter', function() {
				
				fTEditScheduleDetailsVm.showAmountMandatory = false;
				fTEditScheduleDetailsVm.showAmountError = false;
				fTEditScheduleDetailsVm.showRemarkError = false;
				fTEditScheduleDetailsVm.disablePay = true;
				
				fTEditScheduleDetailsVm.payingTo = {
					img : fTBeneficiaryService.customer.conImg,
					name : fTBeneficiaryService.customer.nameData,
					nickName : fTBeneficiaryService.customer.nickName,
					benType : fTBeneficiaryService.customer.benType,
					bank : fTBeneficiaryService.customer.bankData,
					accountNo : fTBeneficiaryService.customer.accountNoData,
					ifsc : fTBeneficiaryService.customer.ifsc,
					intraBankFlag : fTBeneficiaryService.customer.intraBankFlag
				};


				fTEditScheduleDetailsVm.charges = fTBeneficiaryService.customer.transFee;
				
				//set from account amount and account type and name
				for(var ac in fTBeneficiaryService.customer.ownAccItems){
					if(fTBeneficiaryService.customer.ownAccItems[ac]["accountNo"] == fTBeneficiaryService.customer.fromAccNumber){
						fTEditScheduleDetailsVm.selectedAccountAmount = fTBeneficiaryService.customer.ownAccItems[ac]["balance"];
						fTEditScheduleDetailsVm.selectedAccountType = fTBeneficiaryService.customer.ownAccItems[ac]["benType"];
						fTEditScheduleDetailsVm.accountNickName = fTBeneficiaryService.customer.ownAccItems[ac]["nickName"];
					}
				}
				
				fTEditScheduleDetailsVm.payingFrom = {
					img : constantConfig.SBILogo,
					name : fTEditScheduleDetailsVm.accountNickName,
					accountNo : fTBeneficiaryService.customer.fromAccNumber,
					accountType : fTEditScheduleDetailsVm.selectedAccountType
				};
				
				fTEditScheduleDetailsVm.remarks = fTBeneficiaryService.customer.remarks;
				fTEditScheduleDetailsVm.transAmount = fTBeneficiaryService.customer.scheduledTransferAmount;
				fTEditScheduleDetailsVm.date = new Date(fTBeneficiaryService.customer.scheduleDate);
			});
			return this;
		}
]);
