'use strict';

angularApp.controller('fTHowToPayTheBeneficiaryController', [
	"$state",
	"$scope",
	"$ionicPopup",
	"fTNewBeneficiaryService",
	"fTBeneficiaryService",
	"constantConfig",
	"utilityService",
	"$rootScope",
	"$stateParams",
	"$filter",
	"$ionicHistory",
	"ionicToast",
	"$ionicViewSwitcher",
	function ($state,
		$scope,
		$ionicPopup,
		fTNewBeneficiaryService,
		fTBeneficiaryService,
		constantConfig,utilityService, $rootScope, $stateParams, $filter,$ionicHistory, ionicToast,$ionicViewSwitcher) {

		var fTHowToPayTheBeneficiaryVm = this;

		fTHowToPayTheBeneficiaryVm.accountArray = [];
		fTHowToPayTheBeneficiaryVm.months = ["01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12"];
		fTHowToPayTheBeneficiaryVm.years = ["17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31", "32", "33", "34", "35", "36", "37", "38", "39", "40", "41", "42", "43", "44", "45", "46", "47", "48", "49", "50"];

		fTHowToPayTheBeneficiaryVm.goToSetUpiPin = function(){
			$state.go("menu.fTSetUpiPin");
		};

		fTHowToPayTheBeneficiaryVm.setPinChkDevice = function(){
			utilityService.showSpinner();
			var json = JSON.stringify({
				"addInfo":{
					"addInfo10":constantConfig.upiConstant.addInfo10,
					"addInfo9":constantConfig.upiConstant.addInfo9
				},
				"recoveryOptionFlag":constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo":{
					"pspId":constantConfig.upiConstant.pspId,
					"pspRefNo":generateRandomString(27)
				},
				"updateFlag":constantConfig.upiConstant.updateFlag
			});
			getNativeData(constantConfig.upiConstant.checkDevice, function(data){
				$rootScope.checkDeviceInfo = JSON.parse(data);
				if(JSON.parse(data).status == 'S'){
					fTHowToPayTheBeneficiaryVm.getUserProfile();
				}else{
					utilityService.hideSpinner();
					utilityService.showErrorMessage(JSON.parse(data).statusDesc);
				}
			}, function(msg){
				utilityService.hideSpinner();
				fTHowToPayTheBeneficiaryVm.showVpaErrorMessage(msg);
			},json);
		};

		fTHowToPayTheBeneficiaryVm.getUserProfile = function(){
			var json = JSON.stringify({
				"recoveryOptionFlag":constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo":{
					"pspId":constantConfig.upiConstant.pspId,
					"pspRefNo":generateRandomString(27)
				},
				"updateFlag":constantConfig.upiConstant.updateFlag
			});
			getNativeData(constantConfig.upiConstant.getProfile, function(data){
				utilityService.hideSpinner();
				var profileObj = JSON.parse(data);
				fTHowToPayTheBeneficiaryVm.accountsListArr = [];
				for(var i = 0; i < profileObj.vpaAccountDetails.length; i++){
					for(var j = 0; j < profileObj.vpaAccountDetails[i].accountInfo.length; j++){
						profileObj.vpaAccountDetails[i].accountInfo[j]["virtualAddress"] = profileObj.vpaAccountDetails[i].virtualAddress;
						fTHowToPayTheBeneficiaryVm.accountsListArr.push(profileObj.vpaAccountDetails[i].accountInfo[j]);
					}
				}
				fTHowToPayTheBeneficiaryVm.selectedAcc = fTBeneficiaryService.selectedAcc.maskedAccNo;
				fTHowToPayTheBeneficiaryVm.accountArray = fTHowToPayTheBeneficiaryVm.accountsListArr;
			}, function(msg){
				utilityService.hideSpinner();
				fTHowToPayTheBeneficiaryVm.showVpaErrorMessage(msg);
			},json);
		};

		fTHowToPayTheBeneficiaryVm.setUpiPin = function(){
			utilityService.showSpinner();
			var json = {};
			if(fTHowToPayTheBeneficiaryVm.cardType == 'M'){
				json = JSON.stringify({
					"accountId":fTBeneficiaryService.selectedAcc.accId,
					"addInfo":{
						"addInfo10":constantConfig.upiConstant.addInfo10,
						"addInfo9":constantConfig.upiConstant.addInfo9
					},
					"cardType":fTHowToPayTheBeneficiaryVm.cardType,
					"lastSixDigitDebitCardno":fTHowToPayTheBeneficiaryVm.dcNumber,
					"requestInfo":{
						"pspId":constantConfig.upiConstant.pspId,
						"pspRefNo":generateRandomString(27)
					},
					"virtualAddress":fTBeneficiaryService.selectedAcc.virtualAddress
				});
			}else{
				json = JSON.stringify({
					"accountId":fTBeneficiaryService.selectedAcc.accId,
					"addInfo":{
						"addInfo10":constantConfig.upiConstant.addInfo10,
						"addInfo9":constantConfig.upiConstant.addInfo9
					},
					"cardType":fTHowToPayTheBeneficiaryVm.cardType,
					"expiryDate":fTHowToPayTheBeneficiaryVm.month + fTHowToPayTheBeneficiaryVm.year,
					"lastSixDigitDebitCardno":fTHowToPayTheBeneficiaryVm.dcNumber,
					"requestInfo":{
						"pspId":constantConfig.upiConstant.pspId,
						"pspRefNo":generateRandomString(27)
					},
					"virtualAddress":fTBeneficiaryService.selectedAcc.virtualAddress
				});
			}
			getNativeData(constantConfig.upiConstant.onSetMpin, function(data){
				utilityService.hideSpinner();
				if(JSON.parse(data).apiResp.status === 'S'){
					$state.go('menu.fTReviewDetails_VPA');
				} else{
					utilityService.showErrorMessage(JSON.parse(data).apiResp.statusDesc);
				}
			}, function(msg){
				utilityService.hideSpinner();
				fTHowToPayTheBeneficiaryVm.showVpaErrorMessage(msg);
			},json);
		}


		/* Selecting a payment option */
		fTHowToPayTheBeneficiaryVm.selectedOption = function(option) {
			if (option === 'acc')
				fTHowToPayTheBeneficiaryVm.option = "account";
				//GOC HYD start ----------------------------------
			else if (option === 'OA')
			fTHowToPayTheBeneficiaryVm.option = "otherBankAccount";
				//GOC HYD End ----------------------------------
			else if (option === 'mob')
				fTHowToPayTheBeneficiaryVm.option = "mobile";
			else
				fTHowToPayTheBeneficiaryVm.option = "vpa";
			fTHowToPayTheBeneficiaryVm.enableNext = true;
		};

		/* Open VPA Popup */
		fTHowToPayTheBeneficiaryVm.VPAPopup = function() {
			fTHowToPayTheBeneficiaryVm.myPopup = $ionicPopup.show({
				title : '',
				cssClass : 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
				templateUrl : 'pages/fundTransfer/fTHowToPayTheBeneficiary/fTVPAPopup.html',
				scope : $scope
			});
		};

		/* Navigates to previous page from the popup */
		fTHowToPayTheBeneficiaryVm.goToBack = function() {
			fTHowToPayTheBeneficiaryVm.myPopup.close();
			$state.go("menu.fTHowToPayTheBeneficiary")
		};

		/* Navigates page to new beneficiary account */
		fTHowToPayTheBeneficiaryVm.goToNewBeneficiary = function() {
			fTBeneficiaryService.customer.nameData = "";
			fTBeneficiaryService.customer.ifsc = "";
			fTBeneficiaryService.customer.nickName = "";
			fTBeneficiaryService.customer.accountNoData = "";
			fTBeneficiaryService.customer.mobileNo = "";
			fTBeneficiaryService.customer.remarks = "";
			fTNewBeneficiaryService.selectedDiv = "SBIAccnt";
			$state.go("menu.fTNewBeneficiary")
		};
	//GOC HYD start -----------------------------------------
	fTHowToPayTheBeneficiaryVm.goToNewBeneficiary_otherBankAccount = function() {
	fTBeneficiaryService.customer.nameData = "";
	fTBeneficiaryService.customer.ifsc = "";
	fTBeneficiaryService.customer.nickName = "";
	fTBeneficiaryService.customer.accountNoData = "";
	fTBeneficiaryService.customer.mobileNo = "";
	fTBeneficiaryService.customer.remarks = "";
	fTNewBeneficiaryService.selectedDiv = "OBAccnt";
	$state.go("menu.fTNewBeneficiary")
	};
// GOC HYD End -----------------------------------------
		/* Navigates page to new beneficiary mobile */
		fTHowToPayTheBeneficiaryVm.goToNewBeneficiary_Mobile = function() {
			fTBeneficiaryService.customer.nameData = "";
			fTBeneficiaryService.customer.mmid = "";
			fTBeneficiaryService.customer.nickName = "";
			fTBeneficiaryService.customer.mobileNo = "";
			fTBeneficiaryService.customer.remarks = "";
			$state.go("menu.fTNewBeneficiary_Mobile")
		};

		/* Navigates page to new beneficiary VPA */
		fTHowToPayTheBeneficiaryVm.goToNewBeneficiary_VPA = function() {
			fTHowToPayTheBeneficiaryVm.myPopup.close();
			fTBeneficiaryService.customer.nameData = "";
			fTBeneficiaryService.customer.vpa = "";
			fTBeneficiaryService.customer.nickName = "";
			fTBeneficiaryService.customer.mobileNo = "";
			fTBeneficiaryService.customer.remarks = "";
			$state.go("menu.settings")
		};

		/* Navigates to previous page */
		fTHowToPayTheBeneficiaryVm.goBack = function() {
			$ionicViewSwitcher.nextDirection('back');
			$state.go("menu.fundsTransferLanding")
			//$ionicHistory.goBack(-2);
		};

		/* Navigates to next page depending upon the selected option */
		fTHowToPayTheBeneficiaryVm.goNext = function() {
			fTBeneficiaryService.savedImg = "";
			fTBeneficiaryService.customer.imgData = constantConfig.ft.defaultEditBenImg;
			if (fTHowToPayTheBeneficiaryVm.option === "account")
				fTHowToPayTheBeneficiaryVm.goToNewBeneficiary();
				//GOC HYD Start-----------------------------------
				else if (fTHowToPayTheBeneficiaryVm.option === "otherBankAccount")
				fTHowToPayTheBeneficiaryVm.goToNewBeneficiary_otherBankAccount();
				//GOC HYD End --------------------------------------
			else if (fTHowToPayTheBeneficiaryVm.option === "mobile")
				fTHowToPayTheBeneficiaryVm.goToNewBeneficiary_Mobile();
		};
		//GOC HYD Start-----------------------------------
		fTHowToPayTheBeneficiaryVm.wrap = function(option){
			fTHowToPayTheBeneficiaryVm.selectedOption(option);
			fTHowToPayTheBeneficiaryVm.goNext();
		};
		//GOC HYD End --------------------------------------
		fTHowToPayTheBeneficiaryVm.isMaestroCard = false;
		fTHowToPayTheBeneficiaryVm.changeCardType = function(cardType){
			if(cardType == 'M'){
				fTHowToPayTheBeneficiaryVm.isMaestroCard = true;
			}else{
				fTHowToPayTheBeneficiaryVm.isMaestroCard = false;
			}
		};

		fTHowToPayTheBeneficiaryVm.showVpaErrorMessage = function(errorCode){
			switch(errorCode){
				case -1 : utilityService.showErrorMessage(constantConfig.upiConstant.minusOne);
				break;

				case -2 : utilityService.showErrorMessage(constantConfig.upiConstant.minusTwo);
				break;

				case -3 : utilityService.showErrorMessage(constantConfig.upiConstant.minusThree);
				break;

				case -4 : utilityService.showErrorMessage(constantConfig.upiConstant.minusFour);
				break;

				case -5 : utilityService.showErrorMessage(constantConfig.upiConstant.minusFive);
				break;

				case -6 : utilityService.showErrorMessage(constantConfig.upiConstant.minusSix);
				break;

				case -7 : utilityService.showErrorMessage(constantConfig.upiConstant.minusSeven);
				break;

				default : utilityService.showErrorMessage(constantConfig.upiConstant.someWentWrong);
			}
		};

		/* Navigating to Funds Transfer Home page */
		$scope.goToHome = function() {
			$ionicViewSwitcher.nextDirection('back');
			$state.go("menu.fundsTransferLanding")
			//$ionicHistory.goBack(-2);
		};

		$scope.$on('$ionicView.beforeEnter', function() {
			fTHowToPayTheBeneficiaryVm.option = "";
			fTHowToPayTheBeneficiaryVm.enableNext = false;
		});

		return this;
	}
]);
