'use strict';

angularApp.controller('fTNewBeneficiaryController', [
             	"$state",
             	"$scope",
             	"$ionicPopup",
             	"cameraService",
             	"$cordovaContacts",
             	"fTNewBeneficiaryService",
             	"ftIFSCSearchService",
             	"utilityService",
             	"validationService",
             	"fTBeneficiaryService",
             	"constantConfig","$timeout",
 	
 	function (	$state,
         		$scope,
         		$ionicPopup,
         		cameraService,
         		$cordovaContacts,
         		fTNewBeneficiaryService,
         		ftIFSCSearchService,
         		utilityService,
         		validationService,
         		fTBeneficiaryService,
         		constantConfig,$timeout) {
			                 		
			var fTNewBeneficiaryVm = this;
			
			var getNativeData = function(type, successCallback, failureCallback, data) {
				
				if (data === undefined) {
					data = '';
				}
				cordova.exec(successCallback, failureCallback, "Upisdk", type, [data]);
			};
			
			/* Error Flags */
			fTNewBeneficiaryVm.showSBIAccountNumberError = false;
			fTNewBeneficiaryVm.showOtherAccountNumberError = false;
			fTNewBeneficiaryVm.showNameError = false;
			fTNewBeneficiaryVm.showIFSCError = false;
			fTNewBeneficiaryVm.showNickNameError = false;
			
			 fTNewBeneficiaryVm.showSpecialCharacterNicknameError = false; //changed  1966
                         fTNewBeneficiaryVm.showSpecialCharacterNameError = false; //changed  1966
			
			/* Page Initialization */
			function initPage() {
				fTNewBeneficiaryVm.showBack = true;
				fTNewBeneficiaryVm.showNext = true;
				fTNewBeneficiaryVm.disableNext = true;
				fTNewBeneficiaryVm.ifscInput = "";
				fTNewBeneficiaryVm.selectedIfsc = 'f';
				$scope.showDiv = fTNewBeneficiaryService.selectedDiv;
			};

		/* Validation for SBI Account Number */
		fTNewBeneficiaryVm.validateSBIAccountNumber = function () {
			fTNewBeneficiaryVm.showSBIAccountNumberError = !validationService.isValidSBIAccountNumber(fTNewBeneficiaryVm.accNo);
			fTNewBeneficiaryVm.nextEnable();
		};
		fTNewBeneficiaryVm.validateSBIUnMaskedAccountNumber = function () {
			fTNewBeneficiaryVm.showSBIAccountDontMatchError = false;
			fTNewBeneficiaryVm.showSBIUnMaskedAccountNumberError = !validationService.isValidSBIAccountNumber(fTNewBeneficiaryVm.unmaskedAccNo);
		};
		fTNewBeneficiaryVm.matchSBIAccountNumber = function () {
			if(fTNewBeneficiaryVm.accNo && fTNewBeneficiaryVm.unmaskedAccNo) {
				if (fTNewBeneficiaryVm.accNo.toString() !== fTNewBeneficiaryVm.unmaskedAccNo.toString()) {
					fTNewBeneficiaryVm.disableNext = true;
					fTNewBeneficiaryVm.showSBIAccountDontMatchError = true;
				}
				else fTNewBeneficiaryVm.showSBIAccountDontMatchError = false;
			}
			fTNewBeneficiaryVm.nextEnable();
		};
		/* Validation for Other Account Number */
		fTNewBeneficiaryVm.validateOtherAccountNumber = function () {
			fTNewBeneficiaryVm.nextEnable();
		};
		fTNewBeneficiaryVm.validateOtherUnmaskedAccountNumber = function () {
			fTNewBeneficiaryVm.showOBAccountDontMatchError = false;
		};
		fTNewBeneficiaryVm.matchOBAccountNumber = function () {
			if(fTNewBeneficiaryVm.accNo && fTNewBeneficiaryVm.unmaskedOBAccNo) {
				if (fTNewBeneficiaryVm.accNo.toString() !== fTNewBeneficiaryVm.unmaskedOBAccNo.toString()) {
					fTNewBeneficiaryVm.showOBAccountDontMatchError = true;
				}
				else fTNewBeneficiaryVm.showOBAccountDontMatchError = false;
			}
			fTNewBeneficiaryVm.nextEnable();
		};
			
			/* Validation for Name */
			fTNewBeneficiaryVm.validateName = function() {
				//fTNewBeneficiaryVm.showNameError = !validationService.isValidName(fTNewBeneficiaryVm.name);
				fTNewBeneficiaryVm.showNameError = utilityService.isEmpty(fTNewBeneficiaryVm.name); //change 1601
                //below changed 1601
                if(fTNewBeneficiaryVm.name)
                {
                var excludeSpecialChar = /^[a-zA-Z\s]+$/;
                if (excludeSpecialChar.test(fTNewBeneficiaryVm.name)) {
                    fTNewBeneficiaryVm.showSpecialCharacterNameError = false;
                 } else {
                    fTNewBeneficiaryVm.showSpecialCharacterNameError = true;
                }
              }
			  else{
				   fTNewBeneficiaryVm.showSpecialCharacterNameError = false;
			  }
             //end change
				fTNewBeneficiaryVm.nextEnable();
			};

			/*Validation for Nick Name */
			fTNewBeneficiaryVm.validateNickName = function() {
				fTNewBeneficiaryVm.showNickNameError = utilityService.isEmpty(fTNewBeneficiaryVm.nickName);
				 //below changed  1601
				if(fTNewBeneficiaryVm.nickName)
				{
					 var excludeSpecialChar = /^[a-zA-Z0-9\s]+$/;
					 if (excludeSpecialChar.test(fTNewBeneficiaryVm.nickName)) {
						 fTNewBeneficiaryVm.showSpecialCharacterNicknameError = false;
					 } else {
						 fTNewBeneficiaryVm.showSpecialCharacterNicknameError = true;
					 }
				}
				else{
					 fTNewBeneficiaryVm.showSpecialCharacterNicknameError = false;
				}
				fTNewBeneficiaryVm.nextEnable();
			};
			
			/* Validation for IFSC */
			fTNewBeneficiaryVm.validateIFSC = function() {
				if(!utilityService.isEmpty(fTNewBeneficiaryVm.ifsc)){
					fTNewBeneficiaryVm.showIFSCError = !validationService.isValidIFSC(fTNewBeneficiaryVm.ifsc);
					fTNewBeneficiaryVm.ifscEmptyError = false;
				}
				else{
					fTNewBeneficiaryVm.ifscEmptyError = true;
					fTNewBeneficiaryVm.showIFSCError = false;
				}
				fTNewBeneficiaryVm.nextEnable();
			};
			
			/* Picking a mobile number from contacts */
			fTNewBeneficiaryVm.getContacts = function() {
				utilityService.showSpinner();

				var json = JSON.stringify({});
				
				getNativeData('getcontactpermission', function(data){
					utilityService.hideSpinner();
					
					if(data.contactpermission === 'Allowed'){
						$cordovaContacts.pickContact().then(function(contactPicked) {
							var num = contactPicked.phoneNumbers[0].value.replace(/ /g, "");
							fTNewBeneficiaryVm.mobNo = num.substring(num.length - constantConfig.ft.mobileNoLen, num.length);
						});
					} else {
						utilityService.hideSpinner();
						utilityService.showErrorMessage("UPI registration requires permission to use camera, SMS and Phone calls. Please allow these permissions. If problem persists re-initiate UPI registration.");
					}
				}, function(msg){
					
					utilityService.hideSpinner();
					utilityService.showErrorMessage("Can not process now, Please try after sometime.");
				},json);
			};
			
			/* Navigates to previous page */
			fTNewBeneficiaryVm.goBacktoPrevious = function() {
				$state.go('menu.fTHowToPayTheBeneficiary');
			};
			
			/* Enabling next button after the validations */
			fTNewBeneficiaryVm.nextEnable = function() {
				if (!utilityService.isEmpty(fTNewBeneficiaryVm.name) && !utilityService.isUndefined(fTNewBeneficiaryVm.accNo) && !fTNewBeneficiaryVm.showMobileError && !utilityService.isEmpty(fTNewBeneficiaryVm.nickName) && !utilityService.isUndefined(fTNewBeneficiaryVm.newMaxLimit) && !fTNewBeneficiaryVm.showMaxLimitError && !fTNewBeneficiaryVm.showMaxRemError && !fTNewBeneficiaryVm.showTenLakhAboveError && !fTNewBeneficiaryVm.showSpecialCharacterNicknameError && !fTNewBeneficiaryVm.showSpecialCharacterNameError  && !fTNewBeneficiaryVm.showMultipleFiveError) { //1601
					if ($scope.showDiv !== 'SBIAccnt') {
						fTNewBeneficiaryVm.disableNext = fTNewBeneficiaryVm.accNo.toString() !== fTNewBeneficiaryVm.unmaskedOBAccNo.toString()
							|| !(validationService.isValidIFSC(fTNewBeneficiaryVm.ifsc));
					} else {
						fTNewBeneficiaryVm.disableNext = fTNewBeneficiaryVm.accNo.toString() !== fTNewBeneficiaryVm.unmaskedAccNo.toString()
							|| !(validationService.isValidSBIAccountNumber(fTNewBeneficiaryVm.accNo));
					}
				} else {
					fTNewBeneficiaryVm.disableNext = true;
				}
			};
			
			/* Navigates to next page */
			fTNewBeneficiaryVm.goToNextPage = function() {
				fTNewBeneficiaryVm.showNameError = (utilityService.isEmpty(fTNewBeneficiaryVm.name) || utilityService.isUndefined(fTNewBeneficiaryVm.name));
				if ($scope.showDiv !== 'SBIAccnt') {
					fTNewBeneficiaryVm.showIFSCError = (utilityService.isEmpty(fTNewBeneficiaryVm.ifsc) || utilityService.isUndefined(fTNewBeneficiaryVm.ifsc));
					fTNewBeneficiaryVm.showOtherAccountNumberError = (utilityService.isEmpty(fTNewBeneficiaryVm.accNo) || utilityService.isUndefined(fTNewBeneficiaryVm.accNo));
				} else {
					fTNewBeneficiaryVm.showSBIAccountNumberError = !validationService.isValidSBIAccountNumber(fTNewBeneficiaryVm.accNo);
				}
				if (!fTNewBeneficiaryVm.showNameError) {
					if ($scope.showDiv !== 'SBIAccnt') {
						if (!fTNewBeneficiaryVm.showIFSCError && !fTNewBeneficiaryVm.showOtherAccountNumberError)
							fTNewBeneficiaryVm.callNextPage();
					} else {
						if (!fTNewBeneficiaryVm.showSBIAccountNumberError)
							fTNewBeneficiaryVm.callNextPage();
					}
				}
			};
			
			/* Navigates to next page */
			fTNewBeneficiaryVm.callNextPage = function() {				
				fTBeneficiaryService.savedImg = (fTNewBeneficiaryVm.benImage === constantConfig.ft.defaultEditBenImg) ? constantConfig.ft.defaultBenImg : fTNewBeneficiaryVm.benImage;
				fTBeneficiaryService.customer.transAmount = fTBeneficiaryService.minAmount;
				fTBeneficiaryService.customer.nameData = fTNewBeneficiaryVm.name;
				fTBeneficiaryService.customer.ifsc = fTNewBeneficiaryVm.ifsc;
				fTBeneficiaryService.customer.nickName = fTNewBeneficiaryVm.nickName;
				fTBeneficiaryService.customer.accountNoData = fTNewBeneficiaryVm.accNo;
				fTBeneficiaryService.customer.mobileNo = fTNewBeneficiaryVm.mobNo;
				fTBeneficiaryService.customer.accountTypeData = constantConfig.ft.SavingAcc;
				fTBeneficiaryService.customer.maxLimit = fTNewBeneficiaryVm.newMaxLimit;
				/* GOC HYD Code Start */
				fTBeneficiaryService.stateIFSC='';
				/* GOC HYD Code End */

				if ($scope.showDiv === 'SBIAccnt') {
					fTBeneficiaryService.customer.bankData = constantConfig.ft.SBI;
					fTBeneficiaryService.customer.intraBankFlag = "Y";
				} else {
					fTBeneficiaryService.customer.bankData = fTNewBeneficiaryVm.ifsc.substring( 0, 4 );
					fTBeneficiaryService.customer.intraBankFlag = "N";
				}
				
				$state.go('menu.fTPaymentDetails_Account');
			};
			
			fTNewBeneficiaryVm.validateMobile = function() {
				if(fTNewBeneficiaryVm.mobNo)
					fTNewBeneficiaryVm.showMobileError = !validationService.isValidMobile(fTNewBeneficiaryVm.mobNo);
				else fTNewBeneficiaryVm.showMobileError = false;
				fTNewBeneficiaryVm.nextEnable();
			};
			
			
			fTNewBeneficiaryVm.validateMaxLength = function() {
				
				fTNewBeneficiaryVm.showMaxLimitEmpty = !utilityService.isUndefined(fTNewBeneficiaryVm.newMaxLimit);
				if(fTNewBeneficiaryVm.showMaxLimitEmpty){
					var maxRem = (fTNewBeneficiaryVm.newMaxLimit % 5);
					if(fTNewBeneficiaryVm.newMaxLimit >= 5){
						if(maxRem == 0){
							fTNewBeneficiaryVm.showMaxRemError = false;
						}
						else {
							fTNewBeneficiaryVm.showMaxRemError = true;
						}
						fTNewBeneficiaryVm.showMaxLimitEmpty = false;
						fTNewBeneficiaryVm.showMaxLimitError = false;
					}
					else {
						fTNewBeneficiaryVm.showMaxLimitEmpty = false;
						fTNewBeneficiaryVm.showMaxLimitError = true;
						fTNewBeneficiaryVm.showMaxRemError = false;
					}
				}
				else{
					fTNewBeneficiaryVm.showMaxLimitEmpty = true;
					fTNewBeneficiaryVm.showMaxLimitError = false;
					fTNewBeneficiaryVm.showMaxRemError = false;
				}
				fTNewBeneficiaryVm.nextEnable();
			}; 
			
			/* Saves the selected ifsc */
			fTNewBeneficiaryVm.saveIFSC = function(ifsc) {
				fTNewBeneficiaryVm.selectedIfsc = ifsc;
				fTNewBeneficiaryVm.ifsccode = ifsc;
				fTNewBeneficiaryVm.ifsc = ifsc;
				fTBeneficiaryService.customer.ifsc = fTNewBeneficiaryVm.ifsc;
				/* GOC Code Start */
				fTNewBeneficiaryVm.IsVisible = false;
				/* GOC Code End */
			};
			
			/* Navigates back to new beneficiary page after selecting the ifsc */
			fTNewBeneficiaryVm.goToMainPage = function() {
				fTNewBeneficiaryVm.confirmPopup.close();
				fTNewBeneficiaryVm.validateIFSC();
				$state.go('menu.fTNewBeneficiary');
			};
			
			/* Selecting an image from the gallery */
			fTNewBeneficiaryVm.editImage = function() {
				cameraService.getImageFromGallery().then(function(data) {
					fTNewBeneficiaryVm.setImage(data);
					$timeout(function(){
					fTNewBeneficiaryVm.uploadImage(data);
					},1000);
				}, function(error) {
				});
			};
			
			/* upload image */
			fTNewBeneficiaryVm.uploadImage = function(img){
				var updatePicData = {
				  "mimeType": "image/jpg",
				  "documentTitle": "Beneficiary Image",
				  "documentData": img.split(',')[1],
				  "nickname": fTNewBeneficiaryVm.nickName || ''
				}
				
				//service call to upload image
				fTBeneficiaryService.uploadBeneficiaryPicture(updatePicData).then(function(response) {
					fTNewBeneficiaryVm.picDocId = response.id;
					fTBeneficiaryService.customer.picDocId = fTNewBeneficiaryVm.picDocId;
				}, function(error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}
			
			/* Save the selected image */
			fTNewBeneficiaryVm.setImage = function(img) {
				fTNewBeneficiaryVm.benImage = img;
				fTBeneficiaryService.savedImg = fTNewBeneficiaryVm.benImage;
			};
			
			/* Passing bank name depending upon the selected tab */
			fTNewBeneficiaryVm.clickedTab = function($event, clicked) {
				$scope.showDiv = clicked;
				fTNewBeneficiaryService.selectedDiv = clicked;
				fTNewBeneficiaryVm.showSpecialCharacterNicknameError = false; //changed  1601
                fTNewBeneficiaryVm.showSpecialCharacterNameError = false; //changed  1601
				if (clicked === 'SBIAccnt') {
					fTNewBeneficiaryVm.name = "";
					fTNewBeneficiaryVm.accNo = "";
					fTNewBeneficiaryVm.unmaskedAccNo = "";
					fTNewBeneficiaryVm.unmaskedOBAccNo = "";
					fTNewBeneficiaryVm.showSBIAccountNumberError = false;
					fTNewBeneficiaryVm.mobNo = "";
					fTNewBeneficiaryVm.nickName = "";
					fTNewBeneficiaryVm.benImage = fTBeneficiaryService.customer.imgData;
					fTBeneficiaryService.customer.bankData = constantConfig.ft.SBI;;
				} else {
					fTNewBeneficiaryVm.name = "";
					fTNewBeneficiaryVm.accNo = "";
					fTNewBeneficiaryVm.unmaskedAccNo = "";
					fTNewBeneficiaryVm.unmaskedOBAccNo = "";
					fTNewBeneficiaryVm.mobNo = "";
					fTNewBeneficiaryVm.nickName = "";
					fTNewBeneficiaryVm.benImage = fTBeneficiaryService.customer.imgData;
					fTBeneficiaryService.customer.bankData = fTNewBeneficiaryVm.ifsc.substring( 0, 4 );
				}
			};
			
			/* Open ifsc popup */
			var showPopup = function(responseIFSCList, searchInput) {
				fTNewBeneficiaryVm.ifscList = responseIFSCList;
				$scope.ifscInput = searchInput;
				fTNewBeneficiaryVm.confirmPopup = $ionicPopup.show({
					templateUrl : 'pages/fundTransfer/fTNewBeneficiary/fTNBSearchIFSC.html',
					cssClass : 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head',
					scope : $scope
				});
			};
			
			/* Search ifsc */
			fTNewBeneficiaryVm.searchIFSC = function(value) {
				if (fTNewBeneficiaryVm.ifsc !== "" && fTNewBeneficiaryVm.ifsc.length > 2) {
					fTNewBeneficiaryVm.ifscEmptyError = false;
					utilityService.showSpinner();
					ftIFSCSearchService.searchIFSCCodes(value).then(function(responseIFSCList) {
						utilityService.hideSpinner();
						showPopup(responseIFSCList, value);
					}, function(error) {
						utilityService.hideSpinner();
						utilityService.showErrorMessage(error.responseMessage);
					});
				}
				else{
					fTNewBeneficiaryVm.ifscEmptyError = true;
					fTNewBeneficiaryVm.showIFSCError = false;
				}
			};
			
			/* update IFSC list */
			fTNewBeneficiaryVm.updateIfscList = function(value){
				if (value !== "" && value.length > 2) {
					fTNewBeneficiaryVm.showifserror = false;
					fTNewBeneficiaryVm.ifscList='';
					ftIFSCSearchService.searchIFSCCodes(value).then(function(responseIFSCList) {
						fTNewBeneficiaryVm.showifserror = false;
						fTNewBeneficiaryVm.ifscList = responseIFSCList;
					}, function(error) {
						fTNewBeneficiaryVm.showifserror = true;
						fTNewBeneficiaryVm.ifserror = error.responseMessage;
					});
				}
			}
			
			/* Navigating to Funds Transfer Home page */
			$scope.goToHome = function() {
				$state.go('menu.fundsTransfer');
			}
			fTNewBeneficiaryVm.validateMaxLimit = function(model){
				if(model < 5){
					fTNewBeneficiaryVm.disableNext = true;
					fTNewBeneficiaryVm.showMaxLimitError = true;
				}else{
					fTNewBeneficiaryVm.showMaxLimitError = false;
					fTNewBeneficiaryVm.nextEnable();
				}
				if(model>5 && model<1000000 && model%5 != 0){
                    fTNewBeneficiaryVm.disableNext = true;
                    fTNewBeneficiaryVm.showMultipleFiveError = true;
                }else{
                    fTNewBeneficiaryVm.showMultipleFiveError = false;
                    fTNewBeneficiaryVm.nextEnable();
                }
				if(model > 1000000){
					fTNewBeneficiaryVm.disableNext = true;
					fTNewBeneficiaryVm.showTenLakhAboveError = true;
				}else{
					fTNewBeneficiaryVm.showTenLakhAboveError = false;
					fTNewBeneficiaryVm.nextEnable();
				}
				
			};
			$scope.$on('$ionicView.beforeEnter', function() {
				initPage();
				fTNewBeneficiaryVm.benImage = ( (fTBeneficiaryService.savedImg === constantConfig.ft.defaultBenImg) || utilityService.isUndefined(fTBeneficiaryService.savedImg))?fTBeneficiaryService.customer.imgData:fTBeneficiaryService.savedImg;
				fTNewBeneficiaryVm.name = fTBeneficiaryService.customer.nameData;
				fTNewBeneficiaryVm.ifsc = fTBeneficiaryService.customer.ifsc;
				fTNewBeneficiaryVm.nickName = fTBeneficiaryService.customer.nickName;
				fTNewBeneficiaryVm.accNo = fTBeneficiaryService.customer.accountNoData;
				fTNewBeneficiaryVm.mobNo = fTBeneficiaryService.customer.mobileNo;
				fTNewBeneficiaryVm.bank = fTBeneficiaryService.customer.bankData;
				/* GOC START */
				if(fTBeneficiaryService.stateIFSC =="searchIFSC"){
					fTNewBeneficiaryVm.unmaskedOBAccNo =fTBeneficiaryService.customer.unmaskedOBAccNo;
					fTNewBeneficiaryVm.newMaxLimit=fTBeneficiaryService.customer.newMaxLimit;
				}
				
				/* GOC END */
				fTNewBeneficiaryVm.validateName();
				if ($scope.showDiv === 'SBIAccnt') {
					fTNewBeneficiaryVm.validateSBIAccountNumber();
				} else {
					fTNewBeneficiaryVm.validateIFSC();
				}
				fTNewBeneficiaryVm.showMobileError = false;
				fTNewBeneficiaryVm.ifscEmptyError = false;
				fTNewBeneficiaryVm.showSBIAccountNumberError = false;
				fTNewBeneficiaryVm.showOtherAccountNumberError = false;
				fTNewBeneficiaryVm.showNameError = false;
				fTNewBeneficiaryVm.showIFSCError = false;
				fTNewBeneficiaryVm.showNickNameError = false;
				fTNewBeneficiaryVm.showMaxLimitError = false;
				fTNewBeneficiaryVm.showMaxLimitEmpty = false;
				fTNewBeneficiaryVm.showMaxRemError = false;
				fTNewBeneficiaryVm.showSpecialCharacterNicknameError = false; // 1966
				fTNewBeneficiaryVm.showSpecialCharacterNameError = false; // 1966
			});
			/*   GOC-CR-IFSC Search Code Start */
		fTNewBeneficiaryVm.IsVisible = false;
		fTNewBeneficiaryVm.bankName = "";
		fTNewBeneficiaryVm.branchName = "";
		fTNewBeneficiaryVm.typeMinimumCharacterBank = false;
		fTNewBeneficiaryVm.typeMinimumCharacterBranch = false;
		//fTNewBeneficiaryVm.stateIFSC="";







		fTNewBeneficiaryVm.searchIFSCbyBank = function (bankName, branchName) {
			var disable = fTNewBeneficiaryVm.disableSearch();
			if (!disable) {
				utilityService.showSpinner();
				ftIFSCSearchService.searchIFSCCodesbyBank(bankName, branchName).then(function (responseIFSCList) {
					utilityService.hideSpinner();
					fTNewBeneficiaryVm.ifscList = '';

					if (responseIFSCList.length) {
						fTNewBeneficiaryVm.IsVisible = true;
						fTNewBeneficiaryVm.ifscList = responseIFSCList;

					}
					else {

						fTNewBeneficiaryVm.IsVisible = false;
						var listCDKPopUp = $ionicPopup.show({
							template: "<p>No records to display</p>",
							title: '',
							cssClass: 'dialog',
							scope: $scope,
							buttons: [{
								text: 'OK',
								type: 'button-positive'
							}]
						});
					}

				}, function (error) {

					fTNewBeneficiaryVm.IsVisible = false;
					utilityService.hideSpinner();
					utilityService.showErrorMessage(error.responseMessage);

				});
			}
			else {
				fTNewBeneficiaryVm.IsVisible = false;

			}
		};

		fTNewBeneficiaryVm.goIFSCsearchPage = function () {
			fTBeneficiaryService.savedImg = (fTNewBeneficiaryVm.benImage === constantConfig.ft.defaultEditBenImg) ? constantConfig.ft.defaultBenImg : fTNewBeneficiaryVm.benImage;
			fTBeneficiaryService.customer.transAmount = fTBeneficiaryService.minAmount;
			fTBeneficiaryService.customer.nameData = fTNewBeneficiaryVm.name;
			fTBeneficiaryService.customer.ifsc = fTNewBeneficiaryVm.ifsc;
			fTBeneficiaryService.customer.nickName = fTNewBeneficiaryVm.nickName;
			fTBeneficiaryService.customer.accountNoData = fTNewBeneficiaryVm.accNo;
			fTBeneficiaryService.customer.mobileNo = fTNewBeneficiaryVm.mobNo;
			fTBeneficiaryService.customer.accountTypeData = constantConfig.ft.SavingAcc;
			fTBeneficiaryService.customer.maxLimit = fTNewBeneficiaryVm.newMaxLimit;
			fTBeneficiaryService.customer.unmaskedOBAccNo=fTNewBeneficiaryVm.unmaskedOBAccNo;
			fTBeneficiaryService.customer.newMaxLimit = fTNewBeneficiaryVm.newMaxLimit;
			
      fTBeneficiaryService.stateIFSC = 'searchIFSC';
			$state.go('menu.fTNBSearchIFSCbybankAndBranch');
			
		};
		fTNewBeneficiaryVm.saveIFSCbyBank = function (ifsc) {

			fTNewBeneficiaryVm.selectedIfsc = ifsc;
			fTNewBeneficiaryVm.ifsccode = ifsc;
			fTNewBeneficiaryVm.ifsc = ifsc;
			fTBeneficiaryService.customer.ifsc = fTNewBeneficiaryVm.ifsc;
			fTNewBeneficiaryVm.IsVisible = false;
			$state.go('menu.fTNewBeneficiary');
			fTNewBeneficiaryVm.validateIFSC();

		}

		fTNewBeneficiaryVm.goToMainPage = function () {
			fTNewBeneficiaryVm.validateIFSC();
			$state.go('menu.fTNewBeneficiary');
		};
		fTNewBeneficiaryVm.disableSearch = function () {
			var disable = true;
			if ((fTNewBeneficiaryVm.bankName !== "" && fTNewBeneficiaryVm.bankName.length > 3) && (fTNewBeneficiaryVm.branchName !== "" && fTNewBeneficiaryVm.branchName.length > 3)) {
				disable = false;
			}
			else {

				disable = true;

			}

			return disable;
		}

		fTNewBeneficiaryVm.ValidatebankName = function () {
			var disable = fTNewBeneficiaryVm.disableSearch();
			if (disable) {
				fTNewBeneficiaryVm.IsVisible = false;
			}

		}
		fTNewBeneficiaryVm.ValidatebranchName = function () {
			var disable = fTNewBeneficiaryVm.disableSearch();
			if (disable) {
				fTNewBeneficiaryVm.IsVisible = false;
			}
		}
		fTNewBeneficiaryVm.searchIFSC = function (value) {
			var ifscString = value;
			var ifscStringArray= ifscString.split('');
			if (ifscStringArray.length > 2) {
				
				fTNewBeneficiaryVm.ifscEmptyError = false;
				fTNewBeneficiaryVm.ifserror =false;
				fTNewBeneficiaryVm.IsVisible = false;
				utilityService.showSpinner();
				ftIFSCSearchService.searchIFSCCodes(value).then(function (responseIFSCList) {
					utilityService.hideSpinner();
					fTNewBeneficiaryVm.ifscList = responseIFSCList;
					fTNewBeneficiaryVm.IsVisible = true;

				}, function (error) {
					utilityService.hideSpinner();
					fTNewBeneficiaryVm.ifserror =true;
					fTNewBeneficiaryVm.IsVisible = false;
					
					fTNewBeneficiaryVm.ifserror = error.responseMessage;
				});
			} else{
				fTNewBeneficiaryVm.ifscEmptyError = true;
				
				fTNewBeneficiaryVm.IsVisible = false;
				fTNewBeneficiaryVm.ifserror =false;


			}

		};
		/* GOC-CR-IFSC Search Code End */
			return this;
		}
]);
