'use strict';

angularApp.controller('fTNewBeneficiary_MobileController', [
	"$timeout",
	"$state",
	"$scope",
	"$ionicPopup",
	"cameraService",
	"$q",
	"$cordovaContacts",
	"fTNewBeneficiary_MobileService",
	"$translate",
	"utilityService",
	"validationService",
	"$ionicPopover",
	"fTBeneficiaryService",
	"constantConfig",
	
	function ($timeout,
		$state,
		$scope,
		$ionicPopup,
		cameraService,
		$q,
		$cordovaContacts,
		fTNewBeneficiary_MobileService,
		$translate,
		utilityService,
		validationService,
		$ionicPopover,
		fTBeneficiaryService,
		constantConfig){
			// functions, variables that can be accessed from the HTML come here
			var fTNewBeneficiary_MobileVm = this;
			
			var getNativeData = function(type, successCallback, failureCallback, data) {
				
				if (data === undefined) {
					data = '';
				}
				cordova.exec(successCallback, failureCallback, "Upisdk", type, [data]);
			};
			/* Error Flages */
			fTNewBeneficiary_MobileVm.showMobileError = false;
			fTNewBeneficiary_MobileVm.showNameError = false;
			fTNewBeneficiary_MobileVm.showMMIDError = false;
			fTNewBeneficiary_MobileVm.showNickNameError = false;
			
			function initPage() {
				$translate('FUNDSTRANSFER').then(function(translatedvalue) {
					fTNewBeneficiary_MobileVm.fTtitle = translatedvalue;
				});
				fTNewBeneficiary_MobileVm.disableNext = true;
				
				fTBeneficiaryService.remarkPurpose="";
				fTBeneficiaryService.remarkOther="";
				
			};
			
			fTNewBeneficiary_MobileVm.validateNickName = function() {
				fTNewBeneficiary_MobileVm.showNickNameError = utilityService.isEmpty(fTNewBeneficiary_MobileVm.nickName);
				fTNewBeneficiary_MobileVm.nextEnable();
			};
			
			fTNewBeneficiary_MobileVm.validateName = function() {
				fTNewBeneficiary_MobileVm.showNameError = !validationService.isValidName(fTNewBeneficiary_MobileVm.name);
				fTNewBeneficiary_MobileVm.nextEnable();
			};
			
			fTNewBeneficiary_MobileVm.validateMaxLength = function() {
				
				fTNewBeneficiary_MobileVm.showMaxLimitEmpty = !utilityService.isUndefined(fTNewBeneficiary_MobileVm.newMaxLimit);
				if(fTNewBeneficiary_MobileVm.showMaxLimitEmpty){
					if(fTNewBeneficiary_MobileVm.newMaxLimit >= 1){
						fTNewBeneficiary_MobileVm.showMaxLimitEmpty = false;
						fTNewBeneficiary_MobileVm.showMaxLimitError = false;
					}
					else {
						fTNewBeneficiary_MobileVm.showMaxLimitEmpty = false;
						fTNewBeneficiary_MobileVm.showMaxLimitError = true;
					}
				}
				else{
					fTNewBeneficiary_MobileVm.showMaxLimitEmpty = true;
					fTNewBeneficiary_MobileVm.showMaxLimitError = false;
				}
				fTNewBeneficiary_MobileVm.nextEnable();
			}; 
			
			fTNewBeneficiary_MobileVm.validateMMID = function() {
				fTNewBeneficiary_MobileVm.showMMIDError = !validationService.isValidMMID(fTNewBeneficiary_MobileVm.mmid);
				fTNewBeneficiary_MobileVm.nextEnable();
			};
			
			fTNewBeneficiary_MobileVm.validateMobile = function() {
				fTNewBeneficiary_MobileVm.showMobileError = !validationService.isValidMobile(fTNewBeneficiary_MobileVm.mobNo);
				fTNewBeneficiary_MobileVm.nextEnable();
			};
			
			fTNewBeneficiary_MobileVm.getContacts = function() {
				utilityService.showSpinner();
				
				var json = JSON.stringify({});
				
				getNativeData('getcontactpermission', function(data){
					utilityService.hideSpinner();
					
					if(data.contactpermission === 'Allowed'){
						$cordovaContacts.pickContact().then(function(contactPicked) {
							var num = contactPicked.phoneNumbers[0].value.replace(/ /g, "");
							fTNewBeneficiary_MobileVm.mobNo = num.substring(num.length - constantConfig.ft.mobileNoLen, num.length);
						});
					} else {
						utilityService.hideSpinner();
						utilityService.showErrorMessage("UPI registration requires permission to use camera, SMS and Phone calls. Please allow these permissions. If problem persists re-initiate UPI registration.");
					}
				}, function(msg){
					
					utilityService.hideSpinner();
					utilityService.showErrorMessage("Can not process now, Please try after sometime.");
				},json);
				
			};
			
			fTNewBeneficiary_MobileVm.infoPopup = function($event) {
				$ionicPopover.fromTemplateUrl('pages/fundTransfer/fTNewBeneficiary_Mobile/mmidInfo.html', {
					scope : $scope
				}).then(function(popover) {
					$scope.popover = popover;
					$scope.popover.show($event);
				});
			};
			
			
			fTNewBeneficiary_MobileVm.goBack = function() {
				$state.go('menu.fTHowToPayTheBeneficiary');
			};
			
			fTNewBeneficiary_MobileVm.nextEnable = function() {
				fTNewBeneficiary_MobileVm.disableNext = !(!utilityService.isEmpty(fTNewBeneficiary_MobileVm.name) && !utilityService.isEmpty(fTNewBeneficiary_MobileVm.mmid) 
				&& !utilityService.isEmpty(fTNewBeneficiary_MobileVm.mobNo)&& !utilityService.isEmpty(fTNewBeneficiary_MobileVm.nickName)
				&& !utilityService.isEmpty(fTNewBeneficiary_MobileVm.newMaxLimit) && !fTNewBeneficiary_MobileVm.showMaxLimitError);
			};
			
			
			fTNewBeneficiary_MobileVm.goNext = function() {
				fTNewBeneficiary_MobileVm.showNameError = !validationService.isValidName(fTNewBeneficiary_MobileVm.name);
				fTNewBeneficiary_MobileVm.showMMIDError = !validationService.isValidMMID(fTNewBeneficiary_MobileVm.mmid);
				fTNewBeneficiary_MobileVm.showMobileError = !validationService.isValidMobile(fTNewBeneficiary_MobileVm.mobNo);
				fTNewBeneficiary_MobileVm.showNickNameError = utilityService.isEmpty(fTNewBeneficiary_MobileVm.nickName);
				
				if (!fTNewBeneficiary_MobileVm.showMMIDError && !fTNewBeneficiary_MobileVm.showNameError && !fTNewBeneficiary_MobileVm.showMobileError) {
					fTBeneficiaryService.savedImg = (fTNewBeneficiary_MobileVm.benImage === constantConfig.ft.defaultEditBenImg) ? constantConfig.ft.defaultBenImg : fTNewBeneficiary_MobileVm.benImage;
					fTBeneficiaryService.customer.transAmount = fTBeneficiaryService.minAmount;
					fTBeneficiaryService.customer.nameData = fTNewBeneficiary_MobileVm.name;
					fTBeneficiaryService.customer.mmid = fTNewBeneficiary_MobileVm.mmid;
					fTBeneficiaryService.customer.nickName = fTNewBeneficiary_MobileVm.nickName;
					fTBeneficiaryService.customer.mobileNo = fTNewBeneficiary_MobileVm.mobNo;
					fTBeneficiaryService.customer.maxLimit = fTNewBeneficiary_MobileVm.newMaxLimit;		
					fTBeneficiaryService.customer.intraBankFlag = "N";
					fTBeneficiaryService.customer.bankData="";
					fTBeneficiaryService.customer.accountNoData = "";
					
					$state.go('menu.fTPaymentDetails_Mobile');
					
				}
			};
			
			fTNewBeneficiary_MobileVm.editImage = function() {
				cameraService.getImageFromGallery().then(function(data) {
					fTNewBeneficiary_MobileVm.setImage(data);
					fTNewBeneficiary_MobileVm.uploadImage(data);
				}, function(error) {
				});
			};
			
			fTNewBeneficiary_MobileVm.setImage = function(img) {
				fTNewBeneficiary_MobileVm.benImage = img;
				fTBeneficiaryService.savedImg = fTNewBeneficiary_MobileVm.benImage;
			};
			
			/* upload image */
			fTNewBeneficiary_MobileVm.uploadImage = function(img){
				var updatePicData = {
				  "mimeType": "image/jpg",
				  "documentTitle": "Beneficiary Image",
				  "documentData": img.split(',')[1],
				  "nickname": fTNewBeneficiary_MobileVm.nickName
				}
				
				//service call to upload image
				fTBeneficiaryService.uploadBeneficiaryPicture(updatePicData).then(function(response) {
					fTNewBeneficiary_MobileVm.picDocId = response.id;
					fTBeneficiaryService.customer.picDocId = fTNewBeneficiary_MobileVm.picDocId;
				}, function(error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}
			
			$scope.goToHome = function() {
				$state.go('menu.fundsTransfer');
			};
			
			// one time initialization to be done when the controller is loaded
			$scope.$on('$ionicView.loaded', function() {
				initPage();
			});
			
			// actions to done every time the view is shown
			$scope.$on('$ionicView.beforeEnter', function() {
				fTNewBeneficiary_MobileVm.benImage = ((fTBeneficiaryService.savedImg === constantConfig.ft.defaultBenImg) || utilityService.isUndefined(fTBeneficiaryService.savedImg))?constantConfig.ft.defaultEditBenImg:fTBeneficiaryService.savedImg;
				fTNewBeneficiary_MobileVm.name = fTBeneficiaryService.customer.nameData;
				fTNewBeneficiary_MobileVm.mmid = fTBeneficiaryService.customer.mmid;
				fTNewBeneficiary_MobileVm.nickName = fTBeneficiaryService.customer.nickName;
				fTNewBeneficiary_MobileVm.mobNo = fTBeneficiaryService.customer.mobileNo;
				fTNewBeneficiary_MobileVm.validateMobile();
				fTNewBeneficiary_MobileVm.validateMMID();
				fTNewBeneficiary_MobileVm.validateName();
				fTNewBeneficiary_MobileVm.showMobileError = false;
				fTNewBeneficiary_MobileVm.showNameError = false;
				fTNewBeneficiary_MobileVm.showMMIDError = false;
				fTNewBeneficiary_MobileVm.showMaxLimitError = false;
				fTNewBeneficiary_MobileVm.showMaxLimitEmpty = false;
			});
			return this;
		}
]);
