'use strict';

angularApp.controller('fTNewBeneficiary_VPAController', [
	"$timeout",
	"$state",
	"$scope",
	"$ionicPopup",
	"cameraService",
	"$cordovaContacts",
	"fTNewBeneficiary_VPAService",
	"$translate",
	"utilityService",
	"validationService",
	"$ionicPopover",
	"fTBeneficiaryService",
	"constantConfig",

	function ($timeout,
		$state,
		$scope,
		$ionicPopup,
		cameraService,
		$cordovaContacts,
		fTNewBeneficiary_VPAService,
		$translate,
		utilityService,
		validationService,
		$ionicPopover,
		fTBeneficiaryService,
		constantConfig) {
			
		var fTNewBeneficiary_VPAVm = this;
		fTNewBeneficiary_VPAVm.showNameError = false;
		fTNewBeneficiary_VPAVm.showVPAError = false;
		fTNewBeneficiary_VPAVm.nickName = "";
		fTNewBeneficiary_VPAVm.mobNo = "";
		
		function initPage() {
			$translate('FUNDSTRANSFER').then(function(translatedvalue) {
				fTNewBeneficiary_VPAVm.fTtitle = translatedvalue;
			});
			fTNewBeneficiary_VPAVm.disableNext = true;
		};
		
		fTNewBeneficiary_VPAVm.validateName = function() {
			fTNewBeneficiary_VPAVm.showNameError = !validationService.isValidName(fTNewBeneficiary_VPAVm.name);
			fTNewBeneficiary_VPAVm.nextEnable();
		};
		
		fTNewBeneficiary_VPAVm.validateVPA = function() {
			fTNewBeneficiary_VPAVm.showVPAError = !validationService.isValidVPA(fTNewBeneficiary_VPAVm.vpa);
			fTNewBeneficiary_VPAVm.nextEnable();
		};
		
		fTNewBeneficiary_VPAVm.getContacts = function() {
			utilityService.showSpinner();
			var json = JSON.stringify({});
			getNativeData(constantConfig.upiConstant.getcontactpermission, function(data){
				utilityService.hideSpinner();
				if(data.contactpermission === 'Allowed'){
					$cordovaContacts.pickContact().then(function(contactPicked) {
						var num = contactPicked.phoneNumbers[0].value.replace(/ /g, "");
						fTNewBeneficiary_VPAVm.mobNo = num.substring(num.length - constantConfig.ft.mobileNoLen, num.length);
					});
				} else {
					utilityService.hideSpinner();
					utilityService.showErrorMessage("UPI registration requires permission to use camera, SMS and Phone calls. Please allow these permissions. If problem persists re-initiate UPI registration.");
				}
			}, function(msg){
				utilityService.hideSpinner();
				fTNewBeneficiary_VPAVm.showVpaErrorMessage(msg);
			},json);
		};
		
		fTNewBeneficiary_VPAVm.infoPopup = function($event) {
			$ionicPopover.fromTemplateUrl('pages/fundTransfer/fTNewBeneficiary_VPA/vpaInfo.html', {
				scope : $scope
			}).then(function(popover) {
				$scope.popover = popover;
				$scope.popover.show($event);
			});
		};
		
		fTNewBeneficiary_VPAVm.goBack = function() {
			$state.go('menu.upiPay');
		};
		
		fTNewBeneficiary_VPAVm.nextEnable = function() {
			fTNewBeneficiary_VPAVm.disableNext = !(!utilityService.isEmpty(fTNewBeneficiary_VPAVm.name) && !utilityService.isEmpty(fTNewBeneficiary_VPAVm.vpa));
		};
		
		fTNewBeneficiary_VPAVm.vpaValidation = function() {
			fTNewBeneficiary_VPAVm.isVPAValid = !(utilityService.isEmpty(fTNewBeneficiary_VPAVm.vpa) || utilityService.isUndefined(fTNewBeneficiary_VPAVm.vpa));
		};
		
		fTNewBeneficiary_VPAVm.nameValidation = function() {
			fTNewBeneficiary_VPAVm.isNameValid = !(utilityService.isEmpty(fTNewBeneficiary_VPAVm.name) || utilityService.isUndefined(fTNewBeneficiary_VPAVm.name));
		};
		
		fTNewBeneficiary_VPAVm.goNext = function() {
			fTBeneficiaryService.savedImg = (fTNewBeneficiary_VPAVm.benImage === constantConfig.ft.defaultEditBenImg) ? constantConfig.ft.defaultBenImg : fTNewBeneficiary_VPAVm.benImage;
			fTBeneficiaryService.qrflag = false;
			fTBeneficiaryService.customer.transAmount = fTBeneficiaryService.minAmount;
			fTNewBeneficiary_VPAVm.showNameError = !validationService.isValidName(fTNewBeneficiary_VPAVm.name);
			fTNewBeneficiary_VPAVm.showVPAError = !validationService.isValidVPA(fTNewBeneficiary_VPAVm.vpa);

			if (!fTNewBeneficiary_VPAVm.showNameError && !fTNewBeneficiary_VPAVm.showVPAError) {
				fTBeneficiaryService.customer.nameData = fTNewBeneficiary_VPAVm.name;
				fTBeneficiaryService.customer.vpa = fTNewBeneficiary_VPAVm.vpa;
				fTBeneficiaryService.customer.nickName = fTNewBeneficiary_VPAVm.nickName;
				fTBeneficiaryService.customer.mobileNo = fTNewBeneficiary_VPAVm.mobNo;
				
				utilityService.showSpinner();
				var json = JSON.stringify({
					"addInfo":{
						"addInfo10":constantConfig.upiConstant.addInfo10,
						"addInfo9":constantConfig.upiConstant.addInfo9
						},
						"payeeType":{
							"virtualAddress": fTNewBeneficiary_VPAVm.vpa.toString()
							},
						"requestInfo":{
							"pspId":constantConfig.upiConstant.pspId,
							"pspRefNo": generateRandomString(27)
							},
						"vAReqType":constantConfig.upiConstant.vAReqType_T
					});
				getNativeData(constantConfig.upiConstant.checkVirtualAddressAPI, function(data){
					utilityService.hideSpinner();
					if(JSON.parse(data).status === 'VN'){
						utilityService.showErrorMessage("This Virtual Payment Address (VPA) is not available. Please select any other VPA.");
					} else if(JSON.parse(data).status === 'VE'){
						$state.go('menu.fTPaymentDetails_VPA');
					} else {
						utilityService.showErrorMessage("Please register to YONO SBI application");
					}
				}, function(msg){
					utilityService.hideSpinner();
					fTNewBeneficiary_VPAVm.showVpaErrorMessage(msg);
				},json);
			}
		};
		
		//Display error message if something wrong happened at server side.
		fTNewBeneficiary_VPAVm.showVpaErrorMessage = function(errorCode){
			switch(errorCode){
				case -1 : utilityService.showErrorMessage(constantConfig.upiConstant.minusOne);
				break;
				
				case -2 : utilityService.showErrorMessage(constantConfig.upiConstant.minusTwo);
				break;
				
				case -3 : utilityService.showErrorMessage(constantConfig.upiConstant.minusThree);
				break;
				
				case -4 : utilityService.showErrorMessage(constantConfig.upiConstant.minusFour);
				break;
				
				case -5 : utilityService.showErrorMessage(constantConfig.upiConstant.minusFive);
				break;
				
				case -6 : utilityService.showErrorMessage(constantConfig.upiConstant.minusSix);
				break;
				
				case -7 : utilityService.showErrorMessage(constantConfig.upiConstant.minusSeven);
				break;
				
				default : utilityService.showErrorMessage(constantConfig.upiConstant.someWentWrong);
			}
		};
					
		fTNewBeneficiary_VPAVm.editImage = function() {
			cameraService.getImageFromGallery().then(function(data) {
				fTNewBeneficiary_VPAVm.setImage(data);
				//fTNewBeneficiary_VPAVm.uploadImage(data);
			}, function(error) {
			});
		};
		
		fTNewBeneficiary_VPAVm.setImage = function(img) {
			fTNewBeneficiary_VPAVm.benImage = img;
			fTBeneficiaryService.savedImg = fTNewBeneficiary_VPAVm.benImage;
		};
		
		/* upload image */
		fTNewBeneficiary_VPAVm.uploadImage = function(img){
			var updatePicData = {
			  "mimeType": "image/jpg",
			  "documentTitle": "Beneficiary Image",
			  "documentData": img.split(',')[1],
			  "nickname": fTNewBeneficiary_VPAVm.nickName || ''
			}
			
			//service call to upload image
			fTBeneficiaryService.uploadBeneficiaryPicture(updatePicData).then(function(response) {
				fTNewBeneficiary_VPAVm.picDocId = response.id;
				fTBeneficiaryService.customer.picDocId = fTNewBeneficiary_VPAVm.picDocId;
			}, function(error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		};
		
		$scope.goToHome = function() {
			$state.go('menu.fundsTransfer');
		};
		
		// one time initialization to be done when the controller is loaded
		$scope.$on('$ionicView.loaded', function() {
			initPage();
		});
		
		// actions to done every time the view is shown
		$scope.$on('$ionicView.beforeEnter', function() {
			fTNewBeneficiary_VPAVm.benImage = ((fTBeneficiaryService.savedImg === constantConfig.ft.defaultBenImg) || utilityService.isUndefined(fTBeneficiaryService.savedImg))?constantConfig.ft.defaultEditBenImg:fTBeneficiaryService.savedImg;
			fTNewBeneficiary_VPAVm.name = fTBeneficiaryService.customer.nameData;
			fTNewBeneficiary_VPAVm.vpa = fTBeneficiaryService.customer.vpa;
			fTNewBeneficiary_VPAVm.nickName = fTBeneficiaryService.customer.nickName;
			fTNewBeneficiary_VPAVm.mobNo = fTBeneficiaryService.customer.mobileNo;
			fTNewBeneficiary_VPAVm.validateVPA();
			fTNewBeneficiary_VPAVm.validateName();
			fTNewBeneficiary_VPAVm.showNameError = false;
			fTNewBeneficiary_VPAVm.showVPAError = false;
		});
		
		return this;
		
	}
]);
