'use strict';
angularApp.controller('fTPaymentDetailsController', [
	"$state",
	"$scope",
	"fTBeneficiaryService",
	"$ionicPopup",
	"closePopupService",
	"fTReviewService",
	"ionicDatePicker",
	"utilityService",
	"validationService",
	"$filter",
	"constantConfig",
	"getAccountDetailsService",
	"$translate",
	"customerInfoService",
	"homeScreenService",
	function(
			$state, 
			$scope, 
			fTBeneficiaryService, 
			$ionicPopup,
			closePopupService, 
			fTReviewService, 
			ionicDatePicker, 
			utilityService,
			validationService,
			$filter,
			constantConfig,
			getAccountDetailsService,
			$translate,
			customerInfoService,
			homeScreenService) {
			
			var fTPaymentDetailsVm = this;
			fTPaymentDetailsVm.showAmountError = false;
			fTPaymentDetailsVm.showRemarkError = false;
			fTPaymentDetailsVm.isValidAccount = false;
			fTPaymentDetailsVm.validAccountMessage = "";
			fTPaymentDetailsVm.isAccountMasked = false;
			fTPaymentDetailsVm.multiple_fifty_flag = false;
		

		/* Page Initialization */
		function initPage() {
			$translate(['ACC_TRANS_RIGHTS', 'FETCH_TRANS_RGTS', 'ACC_LIMITED_TRANS_RIGHTS', 'ACC_VIEWONLY_TRANS_RIGHTS', 'ACC_INB_TRANS_RIGHTS']).then(function (translations) {
				fTPaymentDetailsVm.accTransRights = translations['ACC_TRANS_RIGHTS'];
				fTPaymentDetailsVm.fetchTransRights = translations['FETCH_TRANS_RGTS'];
				fTPaymentDetailsVm.accLimitedTransRights = translations['ACC_LIMITED_TRANS_RIGHTS'];
				fTPaymentDetailsVm.accViewOnlyTransRights = translations["ACC_VIEWONLY_TRANS_RIGHTS"];
				fTPaymentDetailsVm.accINBOnlyTransRights = translations["ACC_INB_TRANS_RIGHTS"];
			});
			fTPaymentDetailsVm.isAccountTransactional = true;
			fTPaymentDetailsVm.payingFrom = fTBeneficiaryService.payingFrom;
			fTPaymentDetailsVm.showAmountMandatory = false;
			fTPaymentDetailsVm.accExceptSelected = [];
			//remove own account from account list if own to own fund transfer is there
			if (fTBeneficiaryService.customer.accountTypeData === constantConfig.ft.ownAccText) {
				for (var acc in fTPaymentDetailsVm.payingFrom) {
					if (fTPaymentDetailsVm.payingFrom[acc]["accountNo"] === fTBeneficiaryService.customer.accountNoData) {
						fTPaymentDetailsVm.accExceptSelected.splice(acc, 1);
					} else {
						fTPaymentDetailsVm.accExceptSelected.push(fTPaymentDetailsVm.payingFrom[acc]);
					}
				}
				fTPaymentDetailsVm.payingFrom = fTPaymentDetailsVm.accExceptSelected;
			}

			fTPaymentDetailsVm.isChecked = fTBeneficiaryService.checkBox || "N";
			fTPaymentDetailsVm.scheduleDate = fTBeneficiaryService.customer.scheduleDate;

			fTPaymentDetailsVm.newMaxLimit = fTBeneficiaryService.customer.maxLimit || '';
			fTPaymentDetailsVm.disablePayBtn();


			/* Paying from account list */
			fTPaymentDetailsVm.accDetails = [];
			fTPaymentDetailsVm.accDetails = fTPaymentDetailsVm.payingFrom;

			for (var i in fTPaymentDetailsVm.accDetails) {
				var selAccount = fTPaymentDetailsVm.accDetails[i]["accountType"].toLowerCase();
				if(selAccount.indexOf("savings") != -1){
					fTPaymentDetailsVm.accDetails[i]["accountType"]="SB";
				}else if(selAccount.indexOf("current") != -1){
					fTPaymentDetailsVm.accDetails[i]["accountType"]="CA";
					
				}else if(selAccount.indexOf("overdraft") != -1){
					fTPaymentDetailsVm.accDetails[i]["accountType"]="OD";
					
				}
				}
				if(fTBeneficiaryService.selectedDetails.accountType === ''){
					fTPaymentDetailsVm.indexId = 0;
					fTPaymentDetailsVm.availableBalance=fTPaymentDetailsVm.accDetails[0].balance;
					fTPaymentDetailsVm.selectedValue = fTPaymentDetailsVm.accDetails[0].accountType+","+fTPaymentDetailsVm.accDetails[0].accountNo+","+fTPaymentDetailsVm.accDetails[0].balance+",0";
					fTBeneficiaryService.customer.selectedItem=fTPaymentDetailsVm.selectedValue;
					fTPaymentDetailsVm.selectedAccountType=fTPaymentDetailsVm.accDetails[0].accountType;
					fTPaymentDetailsVm.selectedAccountNumber=fTPaymentDetailsVm.accDetails[0].accountNo;
					fTPaymentDetailsVm.selectedAccountAmount=fTPaymentDetailsVm.accDetails[0].balance;
					
					fTBeneficiaryService.selectedDetails.accountType = fTPaymentDetailsVm.selectedAccountType;
					fTBeneficiaryService.selectedDetails.accountNo = fTPaymentDetailsVm.selectedAccountNumber;
					fTBeneficiaryService.selectedDetails.balance = fTPaymentDetailsVm.selectedAccountAmount;
					fTBeneficiaryService.selectedDetails.img = fTPaymentDetailsVm.accDetails[0].img;
				}
				else{
					fTPaymentDetailsVm.indexId = fTBeneficiaryService.customer.indexId;
					if(fTPaymentDetailsVm.accDetails[fTPaymentDetailsVm.indexId]){
						fTPaymentDetailsVm.selectedValue = fTPaymentDetailsVm.accDetails[fTPaymentDetailsVm.indexId].accountType+","+fTPaymentDetailsVm.accDetails[fTPaymentDetailsVm.indexId].accountNo+","+fTPaymentDetailsVm.accDetails[fTPaymentDetailsVm.indexId].balance+","+fTPaymentDetailsVm.indexId;
					}else{
						fTPaymentDetailsVm.selectedValue = fTPaymentDetailsVm.accDetails[0].accountType+","+fTPaymentDetailsVm.accDetails[0].accountNo+","+fTPaymentDetailsVm.accDetails[0].balance+",0";
					}
					
					fTPaymentDetailsVm.selectedAccountType = fTPaymentDetailsVm.selectedValue.split(',')[0];
					fTPaymentDetailsVm.selectedAccountNumber=fTPaymentDetailsVm.selectedValue.split(',')[1];
					fTPaymentDetailsVm.selectedAccountAmount=fTPaymentDetailsVm.selectedValue.split(',')[2];
					if(fTPaymentDetailsVm.accDetails[fTPaymentDetailsVm.indexId]){
						fTPaymentDetailsVm.img = fTPaymentDetailsVm.accDetails[fTPaymentDetailsVm.indexId].img;
					}else{
						fTPaymentDetailsVm.img = fTPaymentDetailsVm.accDetails[0].img;	
					}
					fTPaymentDetailsVm.availableBalance = fTPaymentDetailsVm.selectedValue.split(',')[2];
					
					fTBeneficiaryService.selectedDetails.accountType = fTPaymentDetailsVm.selectedAccountType;
					fTBeneficiaryService.selectedDetails.accountNo = fTPaymentDetailsVm.selectedAccountNumber;
					fTBeneficiaryService.selectedDetails.balance = fTPaymentDetailsVm.selectedAccountAmount;
					fTBeneficiaryService.selectedDetails.img = fTPaymentDetailsVm.img;
					
				}
				
				if(fTPaymentDetailsVm.selectedAccountAmount < 1){
					var title = '';
					var onTap = '';
					fTPaymentDetailsVm.disablenext = true;
					fTPaymentDetailsVm.disablePay = true;
					var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="NO_SUFF_BAL"></div>';
					fTBeneficiaryService.showAlertModal(title,template,onTap,$scope,$state);
				}
				fTPaymentDetailsVm.setPrimaryAccount();
			};
			
			
			
			var nextDate = new Date().setDate(new Date().getDate()+1);
			 var toDate = new Date().setDate(new Date().getDate() + 365);
			fTPaymentDetailsVm.ipObj1 = {
				callback : function(val) {
					var date = new Date(val);
					fTPaymentDetailsVm.scheduleDate = date;
					fTPaymentDetailsVm.disablePayBtn();
				},
				inputDate : new Date(nextDate),
				from : nextDate,
				to: toDate,
				mondayFirst : true,
				closeOnSelect : false,
				templateType : 'popup',
			};
			
			fTPaymentDetailsVm.setPrimaryAccount = function () {
			if (fTReviewService.isComingFromFTHomePage) {
				var arr = fTPaymentDetailsVm.accDetails;
				for (var i = 0, j = arr.length; i < j; i++) {
					if (arr[i].accountNo == getAccountDetailsService.accountOverviewData.customerInformation.accountNumber) {
						fTPaymentDetailsVm.selectedValue = fTPaymentDetailsVm.accDetails[i].accountType + "," + fTPaymentDetailsVm.accDetails[i].accountNo + "," + fTPaymentDetailsVm.accDetails[i].balance + "," + i;
						fTPaymentDetailsVm.availableBalance = fTPaymentDetailsVm.accDetails[i].balance;
						fTPaymentDetailsVm.selectedAccountFun();
					}
				};
			}
			fTReviewService.isComingFromFTHomePage = false;
		};
			
			/* Open the date picker popup */
			fTPaymentDetailsVm.openDatePicker = function() {
				ionicDatePicker.openDatePicker(fTPaymentDetailsVm.ipObj1);
			};
			
			/* Show error message for Remark */
			fTPaymentDetailsVm.validateRemark = function() {
				if (!utilityService.isEmpty(fTPaymentDetailsVm.remark)) {
					fTPaymentDetailsVm.showRemarkError = false;
					fTPaymentDetailsVm.disablePayBtn();
				} else {
					fTPaymentDetailsVm.showRemarkError = true;
					fTPaymentDetailsVm.disablePayBtn();
				}
			};
			
			/* Show error message for Amount */
			fTPaymentDetailsVm.validateAmount = function() {
				/* MOD changes start */
				if(getAccountDetailsService.accessRightsData.accounts) {
					for (var i in getAccountDetailsService.accessRightsData.accounts) {
						if (getAccountDetailsService.accessRightsData.accounts[i].accountNumber === fTBeneficiaryService.selectedDetails.accountNo && getAccountDetailsService.accessRightsData.accounts[i].modBalance) {
							fTPaymentDetailsVm.sumModAccountAmount = parseFloat(getAccountDetailsService.accessRightsData.accounts[i].modBalance) + parseFloat(fTPaymentDetailsVm.selectedAccountAmount);
							break;
						}
					}
				} else {
					fTPaymentDetailsVm.sumModAccountAmount = parseFloat(fTPaymentDetailsVm.selectedAccountAmount);
				}
				/* MOD changes end */

				if(fTPaymentDetailsVm.isChecked === "N"){
					if(fTPaymentDetailsVm.transAmount ){
						if(parseFloat(fTPaymentDetailsVm.transAmount) >= 1){
							switch (validationService.isValidAmount(fTPaymentDetailsVm.sumModAccountAmount, fTPaymentDetailsVm.transAmount, fTPaymentDetailsVm.newMaxLimit)) {
							case 0 :
								fTPaymentDetailsVm.showAmountError = false;
								fTPaymentDetailsVm.showAmountMandatory = false;
								fTPaymentDetailsVm.showAmountErrorMsg = "";
								fTPaymentDetailsVm.disablePayBtn();
								break;
							case 1 :
								fTPaymentDetailsVm.showAmountError = true;
								fTPaymentDetailsVm.showAmountMandatory = false;
								if(!fTPaymentDetailsVm.sumModAccountAmount) //changed for AMS-1002 
                                {
                                    fTPaymentDetailsVm.showAmountErrorMsg = constantConfig.ft.modeBalancetxt;
                                }
                                else
                                {
                                    fTPaymentDetailsVm.showAmountErrorMsg = constantConfig.ft.validAmtTxt;
                                }
								fTPaymentDetailsVm.disablePayBtn();
								break;
							case 3 :
								fTPaymentDetailsVm.showAmountError = true;
								fTPaymentDetailsVm.showAmountMandatory = false;
								fTPaymentDetailsVm.showAmountErrorMsg = constantConfig.ft.validMaxAmtTxt;
								fTPaymentDetailsVm.disablePayBtn();
								break;
							default :
								fTPaymentDetailsVm.showAmountError = true;
								fTPaymentDetailsVm.showAmountMandatory = false;
								fTPaymentDetailsVm.showAmountErrorMsg = constantConfig.ft.inSuffAmt;
								fTPaymentDetailsVm.disablePayBtn();
								break;
							}
						}
						else{
							fTPaymentDetailsVm.showAmountError = true;
							fTPaymentDetailsVm.showAmountMandatory = false;
							fTPaymentDetailsVm.showAmountErrorMsg = constantConfig.ft.amtGrtThanZero;
							fTPaymentDetailsVm.disablePayBtn();
						}
					}
					else {
						fTPaymentDetailsVm.showAmountError = false;
						fTPaymentDetailsVm.showAmountMandatory = true;
						fTPaymentDetailsVm.disablePay = true;
					}
				} else {
					if(parseFloat(fTPaymentDetailsVm.transAmount) > parseFloat(fTPaymentDetailsVm.newMaxLimit)){
						fTPaymentDetailsVm.showAmountError = true;
						fTPaymentDetailsVm.showAmountErrorMsg = constantConfig.ft.excMaxAmt;
						fTPaymentDetailsVm.disablePayBtn();
					} else{
						if(fTPaymentDetailsVm.transAmount){
							if(parseFloat(fTPaymentDetailsVm.transAmount) >= 1){
								switch (validationService.isValidAmount(fTPaymentDetailsVm.sumModAccountAmount, parseFloat(fTPaymentDetailsVm.transAmount), fTPaymentDetailsVm.newMaxLimit)) {
								case 0 :
									fTPaymentDetailsVm.showAmountError = false;
									fTPaymentDetailsVm.showAmountMandatory = false;
									fTPaymentDetailsVm.showAmountErrorMsg = "";
									fTPaymentDetailsVm.disablePayBtn();
									break;
								case 1 :
									fTPaymentDetailsVm.showAmountError = true;
									fTPaymentDetailsVm.showAmountMandatory = false;
							if(!fTPaymentDetailsVm.sumModAccountAmount) //changed for AMS-1002 
							{
								fTPaymentDetailsVm.showAmountErrorMsg = constantConfig.ft.modeBalancetxt;
							}
							else
							{
								fTPaymentDetailsVm.showAmountErrorMsg = constantConfig.ft.validAmtTxt;
							}
									fTPaymentDetailsVm.disablePayBtn();
									break;
								case 3 :
									fTPaymentDetailsVm.showAmountError = true;
									fTPaymentDetailsVm.showAmountMandatory = false;
									fTPaymentDetailsVm.showAmountErrorMsg = constantConfig.ft.validMaxAmtTxt;
									fTPaymentDetailsVm.disablePayBtn();
									break;
								default :
									if(fTPaymentDetailsVm.isChecked === "N"){
										fTPaymentDetailsVm.showAmountError = true;
										fTPaymentDetailsVm.showAmountMandatory = false;
										fTPaymentDetailsVm.showAmountErrorMsg = constantConfig.ft.inSuffAmt;
										fTPaymentDetailsVm.disablePayBtn();
										break;
									}
								}
							}
							else{
								fTPaymentDetailsVm.showAmountError = true;
								fTPaymentDetailsVm.showAmountMandatory = false;
								fTPaymentDetailsVm.showAmountErrorMsg = constantConfig.ft.amtGrtThanZero;
								fTPaymentDetailsVm.disablePayBtn();
							}
						} else {
							fTPaymentDetailsVm.showAmountError = false;
							fTPaymentDetailsVm.showAmountMandatory = true;
							fTPaymentDetailsVm.disablePay = true;
						}
					}
				}
			/* PPF Amount Field Validation code begins */
			if (fTPaymentDetailsVm.credAcType=='Other Deposits A/c')
			{
	
			if (fTPaymentDetailsVm.transAmount != "" && fTPaymentDetailsVm.transAmount != undefined && fTPaymentDetailsVm.selectedValue) {
			
				var amountCheck = fTPaymentDetailsVm.selectedValue.split(','); 
				var  multipleCheck = fTPaymentDetailsVm.transAmount % 50;
				if (multipleCheck != 0 || fTPaymentDetailsVm.transAmount < 500 || fTPaymentDetailsVm.transAmount >150000 )
				 {
					fTPaymentDetailsVm.multiple_fifty_flag = true;
					fTPaymentDetailsVm.showAmountError = true;
					fTPaymentDetailsVm.showAmountMandatory = false;
					fTPaymentDetailsVm.showAmountErrorMsg = constantConfig.ft.validPpfAmtTxt;
				}
				else if(fTPaymentDetailsVm.selectedValue && parseInt(amountCheck[2]) < parseInt(fTPaymentDetailsVm.transAmount))
				{
					fTPaymentDetailsVm.multiple_fifty_flag = false;
					fTPaymentDetailsVm.showAmountError = true;
					fTPaymentDetailsVm.showAmountMandatory = false;
					fTPaymentDetailsVm.showAmountErrorMsg = constantConfig.ft.inSuffAmt;
				} 
				else {
					fTPaymentDetailsVm.multiple_fifty_flag = false;
					fTBeneficiaryService.customer.transAmount = fTPaymentDetailsVm.transAmount;
					fTPaymentDetailsVm.showAmountError = false;
					fTPaymentDetailsVm.showAmountMandatory = false;
					fTPaymentDetailsVm.showAmountErrorMsg = "";
			
				}


			} else {
				fTPaymentDetailsVm.disablenext = false;
				fTPaymentDetailsVm.disablePay =false;



			}
			}
			/* PPF Amount Field Validation code ends */
			};
			
			//validate maximum limit
			fTPaymentDetailsVm.validateMaxLength = function() {
				
				fTPaymentDetailsVm.showMaxLimitEmpty = !utilityService.isUndefined(fTPaymentDetailsVm.newMaxLimit);
				if(fTPaymentDetailsVm.showMaxLimitEmpty){
					if(fTPaymentDetailsVm.newMaxLimit >= 1){
						fTPaymentDetailsVm.showMaxLimitEmpty = false;
						fTPaymentDetailsVm.showMaxLimitError = false;
					}
					else {
						fTPaymentDetailsVm.showMaxLimitEmpty = false;
						fTPaymentDetailsVm.showMaxLimitError = true;
					}
				}
				else{
					fTPaymentDetailsVm.showMaxLimitEmpty = true;
					fTPaymentDetailsVm.showMaxLimitError = false;
				}
				fTPaymentDetailsVm.disablePayBtn();
			}; 
			
			/* Disable Pay button */
			fTPaymentDetailsVm.disablePayBtn = function() {
				if (!fTPaymentDetailsVm.showAmountError && !fTPaymentDetailsVm.showAmountMandatory && !utilityService.isUndefined(fTPaymentDetailsVm.remark)) {
					if (fTPaymentDetailsVm.isChecked === 'S') {
						if (!utilityService.isUndefined(fTPaymentDetailsVm.scheduleDate))
							fTPaymentDetailsVm.disablePay = false;
						else
							fTPaymentDetailsVm.disablePay = true;
					} else {
						fTPaymentDetailsVm.disablePay = false;
					}
				} else {
					fTPaymentDetailsVm.disablePay = true;
				}

				if(fTPaymentDetailsVm.disablePay && fTPaymentDetailsVm.transAmount &&  fTPaymentDetailsVm.showAmountErrorMsg.length >=1){
					var maxLength = 0; 
					var ftTransAmount = document.getElementById("ftTransAmount");
					if(!fTPaymentDetailsVm.newMaxLimit){
						maxLength = $filter('INR')(fTPaymentDetailsVm.sumModAccountAmount,'',2);
						ftTransAmount ? ftTransAmount.setAttribute("maxlength",maxLength.length):'';
					}
					else{
						maxLength = $filter('INR')(parseFloat(fTPaymentDetailsVm.newMaxLimit),'',2);
						ftTransAmount ? ftTransAmount.setAttribute("maxlength",maxLength.length): '';
					}
				}
			};
			
			/* change event for selecting account*/
			fTPaymentDetailsVm.selectedAccountFun =function (){
				var data=fTPaymentDetailsVm.selectedValue.split(",");
				var imgData = fTPaymentDetailsVm.accDetails[data[3]].img;
				var e =[];
				e.accountType=data[0];
				e.accountNo=data[1];
				e.balance=data[2];
				e.indexId = data[3];
				e.img = imgData;
				fTPaymentDetailsVm.availableBalance=e.balance;
				fTPaymentDetailsVm.indexId = e.indexId;
				fTBeneficiaryService.customer.indexId = fTPaymentDetailsVm.indexId;
				
				var title = '';
				var onTap = '';
				
				fTPaymentDetailsVm.selectedAccountAmount=e.balance;
				
				fTBeneficiaryService.selectedDetails.accountType = e.accountType;
				fTBeneficiaryService.selectedDetails.accountNo = e.accountNo;
				fTBeneficiaryService.selectedDetails.balance = e.balance;
				fTBeneficiaryService.selectedDetails.img = e.img;
				
				fTPaymentDetailsVm.isValidAccount = false;
				fTPaymentDetailsVm.validAccountMessage = "";

				if(fTPaymentDetailsVm.selectedAccountAmount > 0){
					if(fTPaymentDetailsVm.transAmount){
						if(fTPaymentDetailsVm.isChecked === "N"){
							fTPaymentDetailsVm.validateAmount(); //validate amount on account change
						}
					}
				}
				else if(fTPaymentDetailsVm.selectedAccountAmount < 1){
					fTPaymentDetailsVm.disablenext = true;
					fTPaymentDetailsVm.disablePay = true;
					var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="NO_SUFF_BAL"></div>';
					fTBeneficiaryService.showAlertModal(title,template,onTap,$scope,$state);
				}
			};
			
			/* Navigates to previous page */
			fTPaymentDetailsVm.goToBack = function() {
				$state.go('menu.fundsTransfer');
			};
			
			fTPaymentDetailsVm.validateFromAcc = function() {
				var arr = fTBeneficiaryService.payingFrom;
				for (var i=0; i < arr.length; i++) {
				  if(arr[i].accountNo == fTBeneficiaryService.selectedDetails.accountNo){
				  	if(((arr[i].isActive != true) || (arr[i].isTransactional != true)) ){
				  		    $translate('INACTIVE_ACCOUNT').then(function(transValue) {
								utilityService.showErrorMessage( "Selected account "+arr[i].accountNo+" is " +transValue);
							});	
							return true;
							//alert('Nor active');
					}
				  };
				};
				return false;
			};
			fTPaymentDetailsVm.validateSimilarAcc = function() {
				try{
					if(parseInt(fTPaymentDetailsVm.payingTo.accountNo)
					 === parseInt(fTBeneficiaryService.selectedDetails.accountNo)){
						return true;
					}
				}catch(err){}	
				return false;
			};

			/* New Access Right changes start */
			fTPaymentDetailsVm.checkRightsAndPay = function () {
				fTPaymentDetailsVm.isValidAccount = false;
				if (homeScreenService.isAccessRightsAvail) {
					var pleaseWaitPopUp = $ionicPopup.show({
						title: null,
						cssClass: 'my-custom-popup',
						template: '<div class="button_fund fontSize-subHeading roboto-light font-dark-grey" translate="PLEASE_WAIT_ACCESSRIGHTS"></div>',
						buttons: [{
							text: 'OK',
							type: 'button-assertive'
						}]
					});
				} else {
					if (getAccountDetailsService.accessRightsData.accounts == null || getAccountDetailsService.accessRightsData.accounts == "") {
						getAccountDetailsService.getAccountsAccessRights('').then(function (data) {
							getAccountDetailsService.accessRightsData = data;

							for (var i in getAccountDetailsService.accessRightsData.accounts) {
								if (getAccountDetailsService.accessRightsData.accounts[i].accountNumber === fTBeneficiaryService.selectedDetails.accountNo) {
									if (parseInt(getAccountDetailsService.accessRightsData.accounts[i].accessResponse) == 0) {
										fTPaymentDetailsVm.isValidAccount = true;
										fTPaymentDetailsVm.validAccountMessage = fTPaymentDetailsVm.accTransRights;
										return false;
									}
									if (parseInt(getAccountDetailsService.accessRightsData.accounts[i].accessResponse) == 2) {
										if (fTBeneficiaryService.customer.accountType && fTBeneficiaryService.customer.accountType.toLocaleLowerCase().indexOf('own') == -1) {
											fTPaymentDetailsVm.isValidAccount = true;
											fTPaymentDetailsVm.validAccountMessage = fTPaymentDetailsVm.accTransRights;
											return false;
										}
									}
								}
							}

							fTPaymentDetailsVm.goToPay();
						}, function (error) {
							fTPaymentDetailsVm.disablenext = true;
							fTPaymentDetailsVm.isValidAccount = true;
							fTPaymentDetailsVm.validAccountMessage = fTPaymentDetailsVm.fetchTransRights;
							return false;
						})
					} else {
						for (var i in getAccountDetailsService.accessRightsData.accounts) {
							if (getAccountDetailsService.accessRightsData.accounts[i].accountNumber === fTBeneficiaryService.selectedDetails.accountNo) {
								if (parseInt(getAccountDetailsService.accessRightsData.accounts[i].accessResponse) == 0) {
									fTPaymentDetailsVm.isValidAccount = true;
									fTPaymentDetailsVm.validAccountMessage = fTPaymentDetailsVm.accTransRights;
									return false;
								}
								if (parseInt(getAccountDetailsService.accessRightsData.accounts[i].accessResponse) == 2) {
									if (fTBeneficiaryService.customer.accountType && fTBeneficiaryService.customer.accountType.toLocaleLowerCase().indexOf('own') == -1) {
										fTPaymentDetailsVm.isValidAccount = true;
										fTPaymentDetailsVm.validAccountMessage = fTPaymentDetailsVm.accTransRights;
										return false;
									}
								}
							}
						}
						fTPaymentDetailsVm.goToPay();
					}
				}

			}
		/* End of New Access Right changes start */
			
			/* Navigates to next page */
			fTPaymentDetailsVm.goToPay = function() {
				/* Access Right changes start */
				// fTPaymentDetailsVm.isValidAccount = false;
				// if(getAccountDetailsService.accessRightsData.accounts == null || getAccountDetailsService.accessRightsData.accounts == "") {
				// 	fTPaymentDetailsVm.disablenext = true;
				// 	fTPaymentDetailsVm.isValidAccount =  true;
				// 	fTPaymentDetailsVm.validAccountMessage = fTPaymentDetailsVm.fetchTransRights;
				// 	return false;
				// } else {
				// 	for (var i in getAccountDetailsService.accessRightsData.accounts) {
				// 		if (getAccountDetailsService.accessRightsData.accounts[i].accountNumber === fTBeneficiaryService.selectedDetails.accountNo) {
				// 			if(parseInt(getAccountDetailsService.accessRightsData.accounts[i].accessResponse) == 0){
				// 				fTPaymentDetailsVm.isValidAccount =  true;
				// 				fTPaymentDetailsVm.validAccountMessage = fTPaymentDetailsVm.accTransRights;
				// 				return false;
				// 			}
				// 			if(parseInt(getAccountDetailsService.accessRightsData.accounts[i].accessResponse) == 2){
				// 				if(fTBeneficiaryService.customer.accountType && fTBeneficiaryService.customer.accountType.toLocaleLowerCase().indexOf('own') == -1){
				// 					fTPaymentDetailsVm.isValidAccount =  true;
				// 					fTPaymentDetailsVm.validAccountMessage = fTPaymentDetailsVm.accTransRights;
				// 					return false;
				// 				}
				// 			}
				// 		}
				// 	}
				// }
				/* Access Right changes end */

				if(((!fTPaymentDetailsVm.payingTo.accountNo) || (!fTBeneficiaryService.selectedDetails.accountNo))
					&& (!fTPaymentDetailsVm.payingTo.mmid)){
					utilityService.showErrorMessage("Please select valid TO and FROM account");
					return true;
				}
				var validateSimilarAcc = fTPaymentDetailsVm.validateSimilarAcc();
				if(validateSimilarAcc){
					utilityService.showErrorMessage("Please select different TO and FROM account");
					return true;
				}	
				var isValidFromAccount = fTPaymentDetailsVm.validateFromAcc();
				if(isValidFromAccount){
					return true;
				}	
				fTPaymentDetailsVm.setSelectedBranchCodeForFromAcc();
				if (fTPaymentDetailsVm.isChecked === "S") {
					$scope.getDate();
				}
			  if (fTBeneficiaryService.customer.accountType === "Frequent Transfer") {
				fTBeneficiaryService.customer.frequentAmount = parseFloat(fTPaymentDetailsVm.transAmount.replace(/,/g,''));
			   }
   
			   else{
				fTBeneficiaryService.customer.transAmount= parseFloat(fTPaymentDetailsVm.transAmount.replace(/,/g,''));
   
			   }
				fTBeneficiaryService.customer.remarks = fTPaymentDetailsVm.remark;
				
				fTBeneficiaryService.checkBox = fTPaymentDetailsVm.isChecked;
				
					// Fix for defect AMS-704
			if (fTPaymentDetailsVm.transAmount) {
				fTPaymentDetailsVm.transAmount = parseFloat(fTPaymentDetailsVm.transAmount.replace(/,/g,''));
                                 fTPaymentDetailsVm.transAmount = fTPaymentDetailsVm.transAmount.toString();
			}
			// End of Fix for defect
				if(fTBeneficiaryService.customer.intraBankFlag == "Y"){
					if(fTBeneficiaryService.customer.ownAccount)
						fTBeneficiaryService.customer.isOwnAccntFlag='Y';
					else fTBeneficiaryService.customer.isOwnAccntFlag='N';
					var reqParams = {
						"benName": fTPaymentDetailsVm.payingTo.name ? fTPaymentDetailsVm.payingTo.name: "",
						"benMMID": fTPaymentDetailsVm.payingTo.mmid ? fTPaymentDetailsVm.payingTo.mmid : "",
						"benNickName": fTPaymentDetailsVm.payingTo.nickName ? fTPaymentDetailsVm.payingTo.nickName : "",
						"benType": 'account',
						"benIFSCCode": fTPaymentDetailsVm.payingTo.ifsc ? fTPaymentDetailsVm.payingTo.ifsc: "" ,
						"amount": fTPaymentDetailsVm.transAmount ? fTPaymentDetailsVm.transAmount : "",
						"intraBankFlag" : "Y",
						"intCategory" : fTBeneficiaryService.selectedDetails.intCategory ? fTBeneficiaryService.selectedDetails.intCategory : "",
						"accountTypeCode" : fTBeneficiaryService.selectedDetails.accountTypeCode ? fTBeneficiaryService.selectedDetails.accountTypeCode : "",
						"customerType": customerInfoService.customer.type ? customerInfoService.customer.type :"",
					        "DOB" : "",//customerInfoService.customer.DOB ? customerInfoService.customer.DOB : ""
						"benAccntNo": fTPaymentDetailsVm.payingTo.accountNo ? fTPaymentDetailsVm.payingTo.accountNo : "",
						"debitNriflag": fTBeneficiaryService.selectedDetails.debitNriflag ? fTBeneficiaryService.selectedDetails.debitNriflag : "",
						"creditTypeCode": fTPaymentDetailsVm.payingTo.creditTypeCode ? fTPaymentDetailsVm.payingTo.creditTypeCode : "",
						"creditIntCategory": fTPaymentDetailsVm.payingTo.creditIntCategory ? fTPaymentDetailsVm.payingTo.creditIntCategory : "",
						"remAccntNo": fTBeneficiaryService.selectedDetails.accountNo ? fTBeneficiaryService.selectedDetails.accountNo : "",
						"branchCode": fTBeneficiaryService.selectedDetails.branchCode ? fTBeneficiaryService.selectedDetails.branchCode : "",
						"isOwnAccntFlag": fTBeneficiaryService.customer.isOwnAccntFlag ? fTBeneficiaryService.customer.isOwnAccntFlag : "",
						"remark": fTBeneficiaryService.customer.remarks ? fTBeneficiaryService.customer.remarks : ""
					};
					reqParams.amount.replace("," , "");
					fTReviewService.getTransactionFee(reqParams).then(function(response) {

					if (response.messageCode == "01") {

						fTPaymentDetailsVm.cancelPopupName = $ionicPopup.show({
							title: "",
							cssClass: 'my-custom-popup',
							template: response.message,
							scope: $scope,
							buttons: [
								{
									text: 'OK',
									type: 'button-assertive',
									onTap: function () {
										fTPaymentDetailsVm.cancelPopupName.close();

										// call after NRI check

										try {
											fTReviewService.transactionFee = response.commisonAmt;
											fTReviewService.tncChannel = response.channel;
											fTReviewService.benBranchCode = response.benBranchCode;
											fTReviewService.benBranchName = response.benBranchName;
											fTReviewService.benAccntCat = response.benAccntCat;
											$state.go('menu.review');
										} catch (e) { }

										// call after NRI check END

									}
								},
								{
									text: 'Cancel',
									type: 'button-assertive',
									onTap: function () {
										fTPaymentDetailsVm.cancelPopupName.close();
									}
								}
							],
						});

					}
					else if (response.messageCode == "02" || response.messageCode == "03") {
						utilityService.showErrorMessage(response.message);
					}
					else {

						// call after NRI check

						try {
							fTReviewService.transactionFee = response.commisonAmt;
							fTReviewService.tncChannel = response.channel;
							fTReviewService.benBranchCode = response.benBranchCode;
							fTReviewService.benBranchName = response.benBranchName;
							fTReviewService.benAccntCat = response.benAccntCat;
							$state.go('menu.review');
						} catch (e) { }

						// call after NRI check END

					}
					}, function(error) {
						utilityService.showErrorMessage(error.responseMessage);
					});				
				}else{
					
				fTBeneficiaryService.customer.isOwnAccntFlag='N';
					
				var reqParams = {
					"benName": fTPaymentDetailsVm.payingTo.name ? fTPaymentDetailsVm.payingTo.name : "",
					"benMMID": fTPaymentDetailsVm.payingTo.mmid  ? fTPaymentDetailsVm.payingTo.mmid : "",
					"benNickName": fTPaymentDetailsVm.payingTo.nickName ? fTPaymentDetailsVm.payingTo.nickName: "",
					"benType": fTPaymentDetailsVm.payingTo.benType ? fTPaymentDetailsVm.payingTo.benType: "",
					"benIFSCCode": fTPaymentDetailsVm.payingTo.ifsc ? fTPaymentDetailsVm.payingTo.ifsc : "",
					"amount": fTPaymentDetailsVm.transAmount ? fTPaymentDetailsVm.transAmount :"",
					"intraBankFlag" : "N",
					"intCategory" : fTBeneficiaryService.selectedDetails.intCategory ? fTBeneficiaryService.selectedDetails.intCategory : "",
					"accountTypeCode" : fTBeneficiaryService.selectedDetails.accountTypeCode ? fTBeneficiaryService.selectedDetails.accountTypeCode : "",
					"customerType": customerInfoService.customer.type ? customerInfoService.customer.type :"",
					"DOB" : "",//customerInfoService.customer.DOB ? customerInfoService.customer.DOB : ""
					"benAccntNo": fTPaymentDetailsVm.payingTo.accountNo ? fTPaymentDetailsVm.payingTo.accountNo : "",
					"debitNriflag": fTBeneficiaryService.selectedDetails.debitNriflag ? fTBeneficiaryService.selectedDetails.debitNriflag : "",
					"creditTypeCode": fTPaymentDetailsVm.payingTo.creditTypeCode ? fTPaymentDetailsVm.payingTo.creditTypeCode : "",
					"creditIntCategory": fTPaymentDetailsVm.payingTo.creditIntCategory ? fTPaymentDetailsVm.payingTo.creditIntCategory : "",
					"remAccntNo": fTBeneficiaryService.selectedDetails.accountNo ? fTBeneficiaryService.selectedDetails.accountNo : "",
					"branchCode": fTBeneficiaryService.selectedDetails.branchCode ? fTBeneficiaryService.selectedDetails.branchCode : "",
					"isOwnAccntFlag": fTBeneficiaryService.customer.isOwnAccntFlag ? fTBeneficiaryService.customer.isOwnAccntFlag : "",
					"remark": fTBeneficiaryService.customer.remarks ? fTBeneficiaryService.customer.remarks : ""
				};
				reqParams.amount.replace("," , "");
				fTReviewService.getTransactionFee(reqParams).then(function(response) {

					if (response.messageCode == "01") {

						fTPaymentDetailsVm.cancelPopupName = $ionicPopup.show({
							title: "",
							cssClass: 'my-custom-popup',
							template: response.message,
							scope: $scope,
							buttons: [
								{
									text: 'OK',
									type: 'button-assertive',
									onTap: function () {
										fTPaymentDetailsVm.cancelPopupName.close();

										// call after NRI check

										try {
											fTReviewService.transactionFee = response.commisonAmt;
											fTReviewService.tncChannel = response.channel;
											fTReviewService.benBranchCode = response.benBranchCode;
											fTReviewService.benBranchName = response.benBranchName;
											fTReviewService.benAccntCat = response.benAccntCat;
											$state.go('menu.review');
										} catch (e) { }

										// call after NRI check END

									}
								},
								{
									text: 'Cancel',
									type: 'button-assertive',
									onTap: function () {
										fTPaymentDetailsVm.cancelPopupName.close();
									}
								}
							],
						});

					}
					else if (response.messageCode == "02" || response.messageCode == "03") {
						utilityService.showErrorMessage(response.message);
					}
					else {

						// call after NRI check

						try {
							fTReviewService.transactionFee = response.commisonAmt;
							fTReviewService.tncChannel = response.channel;
							fTReviewService.benBranchCode = response.benBranchCode;
							fTReviewService.benBranchName = response.benBranchName;
							fTReviewService.benAccntCat = response.benAccntCat;
							$state.go('menu.review');
						} catch (e) { }

						// call after NRI check END

					}
				}, function(error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
				}
			};
			
			/* Navigating to Funds Transfer Home page */
			$scope.goToHome = function() {
				$state.go('menu.fundsTransfer');
			};
			
		
			
			
			fTPaymentDetailsVm.scheduled = function() {
				if (fTPaymentDetailsVm.isChecked === "N") {
					fTPaymentDetailsVm.isChecked = "S";
					if(parseFloat(fTPaymentDetailsVm.transAmount) <= parseFloat(fTPaymentDetailsVm.newMaxLimit)){
						fTPaymentDetailsVm.showAmountError = false;
					} else if(fTPaymentDetailsVm.newMaxLimit == undefined){
						fTPaymentDetailsVm.showAmountError = false;
					} else {
						fTPaymentDetailsVm.validateAmount();
					}
				} else {
					fTPaymentDetailsVm.isChecked = "N";
					fTPaymentDetailsVm.scheduleDate = "";
					fTBeneficiaryService.customer.scheduleDate = "";
					fTPaymentDetailsVm.validateAmount();
				}
				fTPaymentDetailsVm.disablePayBtn();
			};
			
			$scope.getDate = function() {
				var newDate = fTPaymentDetailsVm.scheduleDate;
				var monthName = ["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"];
				fTPaymentDetailsVm.scheduleDateFormat = "" + newDate.getDate() + " " + monthName[newDate.getMonth()] + " " + newDate.getFullYear();
				fTBeneficiaryService.customer.scheduleDate = fTPaymentDetailsVm.scheduleDateFormat;
			};
			fTPaymentDetailsVm.setSelectedBranchCodeForFromAcc= function() {
				var arrLen = fTBeneficiaryService.payingFrom.length;
				for (var i = 0; i < arrLen; i++) {
					if(fTBeneficiaryService.payingFrom[i].accountNo == fTBeneficiaryService.selectedDetails.accountNo){
						fTBeneficiaryService.selectedDetails.branchCode = fTBeneficiaryService.payingFrom[i].branchCode;
						fTBeneficiaryService.selectedDetails.accountTypeCode = fTBeneficiaryService.payingFrom[i].accountTypeCode ?  fTBeneficiaryService.payingFrom[i].accountTypeCode : "";
						fTBeneficiaryService.selectedDetails.intCategory = fTBeneficiaryService.payingFrom[i].intCategory ? fTBeneficiaryService.payingFrom[i].intCategory : "";
						fTBeneficiaryService.selectedDetails.debitNriflag = fTBeneficiaryService.payingFrom[i].debitNriflag ? fTBeneficiaryService.payingFrom[i].debitNriflag : "";
					}
				}
			},
			$scope.$on('$ionicView.beforeEnter', function() {
				fTPaymentDetailsVm.scheduleDate = "";
				fTBeneficiaryService.customer.scheduleDate = "";
				
				fTPaymentDetailsVm.remark = fTBeneficiaryService.customer.remarks;
					
					fTPaymentDetailsVm.remarkPurposes=fTPaymentDetailsVm.getFTPurposes();
				
					fTPaymentDetailsVm.remarkPurpose = fTBeneficiaryService.remarkPurpose;
					if(fTPaymentDetailsVm.remarkPurpose =="Others"){
						fTPaymentDetailsVm.remarkOther=fTPaymentDetailsVm.remark;
						}
					
					else{
						fTPaymentDetailsVm.remarkPurpose = fTBeneficiaryService.customer.remarks;
					}
					
				
					
				
				if(fTBeneficiaryService.customer.accountType === constantConfig.ft.ftText){
					fTPaymentDetailsVm.transAmount = $filter('INR')(fTBeneficiaryService.customer.frequentAmount);
				}else{
					fTPaymentDetailsVm.transAmount = $filter('INR')(fTBeneficiaryService.customer.transAmount);
				}
				if(fTPaymentDetailsVm.transAmount)
					fTPaymentDetailsVm.validateAmount();
				fTPaymentDetailsVm.validateRemark();
				fTPaymentDetailsVm.showAmountError = false;
				fTPaymentDetailsVm.showRemarkError = false;
				fTPaymentDetailsVm.showMaxLimitError = false;
				fTPaymentDetailsVm.showMaxLimitEmpty = false;
				fTPaymentDetailsVm.accountNoData = fTBeneficiaryService.customer.accountNoData;
				fTPaymentDetailsVm.imgData = fTBeneficiaryService.customer.conImg;
				fTPaymentDetailsVm.nameData = fTBeneficiaryService.customer.nameData;
				fTPaymentDetailsVm.bankData = fTBeneficiaryService.customer.bankData;
				fTPaymentDetailsVm.nickNameData = fTBeneficiaryService.customer.nickName;
				fTPaymentDetailsVm.benTypeData = fTBeneficiaryService.customer.benType;
				fTPaymentDetailsVm.benIfscData = fTBeneficiaryService.customer.ifsc;
				fTPaymentDetailsVm.intraBankFlagData = fTBeneficiaryService.customer.intraBankFlag;
				fTPaymentDetailsVm.ownAccount = fTBeneficiaryService.customer.ownAccount;
				fTPaymentDetailsVm.newMaxLimit = fTBeneficiaryService.customer.maxLimit;
				fTPaymentDetailsVm.mmid = fTBeneficiaryService.customer.mmid;
				fTPaymentDetailsVm.creditTypeCode = fTBeneficiaryService.customer.creditTypeCode;// added for ppf validation
				fTPaymentDetailsVm.creditIntCategory = fTBeneficiaryService.customer.creditIntCategory;// added for ppf validation
				fTPaymentDetailsVm.credAcType=fTBeneficiaryService.customer.credAcType; // added for ppf validation


				fTPaymentDetailsVm.payingTo = {
					img: fTPaymentDetailsVm.imgData,
					name: fTPaymentDetailsVm.nameData,
					nickName: fTPaymentDetailsVm.nickNameData,
					benType: fTPaymentDetailsVm.benTypeData,
					ifsc: fTPaymentDetailsVm.benIfscData,
					bank: fTPaymentDetailsVm.bankData,
					accountNo: fTPaymentDetailsVm.accountNoData,
					intraBankFlag: fTPaymentDetailsVm.intraBankFlagData,
					mmid: fTPaymentDetailsVm.mmid,
					mobileNo: fTBeneficiaryService.customer.mobileNo,
					creditTypeCode: fTPaymentDetailsVm.creditTypeCode,
					creditIntCategory: fTPaymentDetailsVm.creditIntCategory
				};
				fTPaymentDetailsVm.eyesOffFun(fTPaymentDetailsVm.payingTo.accountNo);
				initPage();
			});

		fTPaymentDetailsVm.eyesOnFun = function(accNo){
			fTPaymentDetailsVm.isAccountMasked = false;
			fTPaymentDetailsVm.payingTo.accountNo = fTPaymentDetailsVm.oFDValue;
		}

		fTPaymentDetailsVm.eyesOffFun = function(accNo){
			fTPaymentDetailsVm.isAccountMasked = true;
			fTPaymentDetailsVm.oFDValue = accNo;
			fTPaymentDetailsVm.payingTo.maskedFdNumber = utilityService.maskData(accNo, "front", 4);
		}

			$scope.$on('$ionicView.loaded', function () {
				// if(!getAccountDetailsService.accessRightsData.accounts) {
				// 	getAccountDetailsService.getAccountsAccessRights('').then( function(data) {
				// 		getAccountDetailsService.accessRightsData = data;
				// 	}, function(error) {
				// 		// Failure block
				// 	});
				// }
			});


		fTPaymentDetailsVm.updateRemark =function(){
			fTPaymentDetailsVm.remark=fTPaymentDetailsVm.remarkOther;
			fTBeneficiaryService.remarkOther = fTPaymentDetailsVm.remarkOther;
			fTBeneficiaryService.remarkPurpose = fTPaymentDetailsVm.remarkPurpose;
			fTPaymentDetailsVm.validateRemark();
		} 
		fTPaymentDetailsVm.updatePurpose = function(){			
			if(fTPaymentDetailsVm.remarkPurpose=="Others"){					
			fTPaymentDetailsVm.remark="";
			fTPaymentDetailsVm.validateRemark();
					
		}
		else{
			fTPaymentDetailsVm.remarkOther="";
			fTPaymentDetailsVm.remark=fTPaymentDetailsVm.remarkPurpose;
			fTBeneficiaryService.remarkOther = "";
			fTBeneficiaryService.remarkPurpose = "";
			fTPaymentDetailsVm.validateRemark();
		}
	
		

			}
			fTPaymentDetailsVm.getFTPurposes = function(){
		
			
				fTBeneficiaryService.getFTPurposes().then(function(data){
				fTPaymentDetailsVm.remarkPurposes=data.remarkPurposes;
				},function (error) {
				utilityService.showErrorMessage(error.responseMessage);
				}
				); 
			
			}



			return this;
		}

]);
