'use strict';

angularApp.controller('fTPaymentDetails_AccountController', [
	"$state",
	"$scope",
	"fTBeneficiaryService",
	"$ionicPopup",
	"closePopupService",
	"fTReviewService",
	"validationService",
	"utilityService",
	"$filter",
	"constantConfig",
	"$rootScope",
	"cryptoService",
	"customerInfoService",
	"$translate",
	"getAccountDetailsService",
	"requestYCService",
	function ($state,
		$scope,
		fTBeneficiaryService,
		$ionicPopup,
		closePopupService,
		fTReviewService,
		validationService,
		utilityService,
		$filter,
		constantConfig,
		$rootScope, 
		cryptoService,
		customerInfoService,
		$translate,
		getAccountDetailsService,
		requestYCService) {
			
	var fTPaymentDetails_AccountVm = this;
	fTPaymentDetails_AccountVm.isValidAccount = false;
	fTPaymentDetails_AccountVm.validAccountMessage = "";
		fTPaymentDetails_AccountVm.isAccountMasked = false;
	
	function initPage() {
		$translate(['ACC_TRANS_RIGHTS','FETCH_TRANS_RGTS']).then(function (translations) {
			fTPaymentDetails_AccountVm.accTransRights = translations['ACC_TRANS_RIGHTS'];
			fTPaymentDetails_AccountVm.fetchTransRights = translations['FETCH_TRANS_RGTS'];
		});
		fTPaymentDetails_AccountVm.showAmountError = false;
		fTPaymentDetails_AccountVm.showRemarkError = false;
		fTPaymentDetails_AccountVm.disablePay = true;
		
		fTPaymentDetails_AccountVm.payingFrom = fTBeneficiaryService.payingFrom;
		fTPaymentDetails_AccountVm.accountTypeData =fTBeneficiaryService.selectedDetails.accountType;
		
		fTPaymentDetails_AccountVm.showAmountMandatory = false;
		
		/* Paying from account list */
		fTPaymentDetails_AccountVm.accDetails = [];
		fTPaymentDetails_AccountVm.accDetails = fTPaymentDetails_AccountVm.payingFrom;
		for(var i in fTPaymentDetails_AccountVm.accDetails){
			var selAccount = fTPaymentDetails_AccountVm.accDetails[i]["accountType"].toLowerCase();
		if(selAccount.indexOf("savings") != -1){
			fTPaymentDetails_AccountVm.accDetails[i]["accountType"]="SB";
		}else if(selAccount.indexOf("current") != -1){
			fTPaymentDetails_AccountVm.accDetails[i]["accountType"]="CA";
			
		}else if(selAccount.indexOf("overdraft") != -1){
			fTPaymentDetails_AccountVm.accDetails[i]["accountType"]="OD";
			
		}
		}
		if(fTBeneficiaryService.selectedDetails.accountType === ''){
			fTPaymentDetails_AccountVm.availableBalance=fTPaymentDetails_AccountVm.accDetails[0].balance;
			fTPaymentDetails_AccountVm.selectedValue = fTPaymentDetails_AccountVm.accDetails[0].accountType+","+fTPaymentDetails_AccountVm.accDetails[0].accountNo+","+fTPaymentDetails_AccountVm.accDetails[0].balance+",0";
			fTPaymentDetails_AccountVm.indexId = 0;
			
			fTBeneficiaryService.customer.selectedItem=fTPaymentDetails_AccountVm.selectedValue;
			fTPaymentDetails_AccountVm.selectedAccountType=fTPaymentDetails_AccountVm.accDetails[0].accountType;
			fTPaymentDetails_AccountVm.selectedAccountNumber=fTPaymentDetails_AccountVm.accDetails[0].accountNo;
			fTPaymentDetails_AccountVm.selectedAccountAmount=fTPaymentDetails_AccountVm.accDetails[0].balance;
			
			fTBeneficiaryService.selectedDetails.accountType = fTPaymentDetails_AccountVm.selectedAccountType;
			fTBeneficiaryService.selectedDetails.accountNo = fTPaymentDetails_AccountVm.selectedAccountNumber;
			fTBeneficiaryService.selectedDetails.balance = fTPaymentDetails_AccountVm.selectedAccountAmount;
			fTBeneficiaryService.selectedDetails.img = fTPaymentDetails_AccountVm.accDetails[0].img;
		}
		else{
			fTPaymentDetails_AccountVm.indexId = fTBeneficiaryService.customer.indexId;
			if(fTPaymentDetails_AccountVm.accDetails[fTPaymentDetails_AccountVm.indexId]){
				fTPaymentDetails_AccountVm.selectedValue = fTPaymentDetails_AccountVm.accDetails[fTPaymentDetails_AccountVm.indexId].accountType+","+fTPaymentDetails_AccountVm.accDetails[fTPaymentDetails_AccountVm.indexId].accountNo+","+fTPaymentDetails_AccountVm.accDetails[fTPaymentDetails_AccountVm.indexId].balance+","+fTPaymentDetails_AccountVm.indexId;
			} else {
				fTPaymentDetails_AccountVm.selectedValue = fTPaymentDetails_AccountVm.accDetails[0].accountType+","+fTPaymentDetails_AccountVm.accDetails[0].accountNo+","+fTPaymentDetails_AccountVm.accDetails[0].balance+",0";
			}
					
			fTPaymentDetails_AccountVm.selectedAccountType = fTPaymentDetails_AccountVm.selectedValue.split(',')[0];
			
			fTPaymentDetails_AccountVm.selectedAccountNumber = fTPaymentDetails_AccountVm.selectedValue.split(',')[1];
			fTPaymentDetails_AccountVm.selectedAccountAmount = fTPaymentDetails_AccountVm.selectedValue.split(',')[2];
			if(fTPaymentDetails_AccountVm.accDetails[fTPaymentDetails_AccountVm.indexId]){
				fTPaymentDetails_AccountVm.img = fTPaymentDetails_AccountVm.accDetails[fTPaymentDetails_AccountVm.indexId].img;
			}else{
				fTPaymentDetails_AccountVm.img = fTPaymentDetails_AccountVm.accDetails[0].img;
			}
			fTPaymentDetails_AccountVm.availableBalance = fTPaymentDetails_AccountVm.selectedValue.split(',')[2];
					/* fTPaymentDetails_AccountVm.selectedAccountType=fTBeneficiaryService.selectedDetails.accountType;
					fTPaymentDetails_AccountVm.selectedAccountNumber=fTBeneficiaryService.selectedDetails.accountNo;
					fTPaymentDetails_AccountVm.selectedAccountAmount=fTBeneficiaryService.selectedDetails.balance;
					fTPaymentDetails_AccountVm.img = fTPaymentDetails_AccountVm.accDetails[0].img;
					fTPaymentDetails_AccountVm.availableBalance=fTPaymentDetails_AccountVm.accDetails[fTPaymentDetails_AccountVm.indexId].balance; */
		}
				
				if(fTPaymentDetails_AccountVm.selectedAccountAmount < 1){
					var title = '';
					var onTap = '';
					fTPaymentDetails_AccountVm.disablenext = true;
					fTPaymentDetails_AccountVm.disablePay = true;
					var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="NO_SUFF_BAL"></div>';
					fTBeneficiaryService.showAlertModal(title,template,onTap,$scope,$state);
				}
			};
			
			fTPaymentDetails_AccountVm.validateRemark = function() {
				if (!utilityService.isEmpty(fTPaymentDetails_AccountVm.remark)) {
					fTPaymentDetails_AccountVm.showRemarkError = false;
					fTPaymentDetails_AccountVm.disablePayBtn();
				} else {
					fTPaymentDetails_AccountVm.showRemarkError = true;
					fTPaymentDetails_AccountVm.disablePayBtn();
				}
			};
			fTPaymentDetails_AccountVm.validateAmount = function() {
				/* MOD changes start */
				if(getAccountDetailsService.accessRightsData.accounts) {
					for (var i in getAccountDetailsService.accessRightsData.accounts) {
						if (getAccountDetailsService.accessRightsData.accounts[i].accountNumber === fTBeneficiaryService.selectedDetails.accountNo && getAccountDetailsService.accessRightsData.accounts[i].modBalance) {
							fTPaymentDetails_AccountVm.sumModAccountAmount = parseFloat(getAccountDetailsService.accessRightsData.accounts[i].modBalance) + parseFloat(fTPaymentDetails_AccountVm.selectedAccountAmount);
							break;
						}
					}
				} else {
					fTPaymentDetails_AccountVm.sumModAccountAmount = parseFloat(fTPaymentDetails_AccountVm.selectedAccountAmount);
				}
				/* MOD changes end */

				if(fTPaymentDetails_AccountVm.transAmount){
					if(fTPaymentDetails_AccountVm.transAmount >= 1){
						switch (validationService.isValidAmount(fTPaymentDetails_AccountVm.sumModAccountAmount, fTPaymentDetails_AccountVm.transAmount,fTPaymentDetails_AccountVm.maxLimit)) {
						case 0 :
							fTPaymentDetails_AccountVm.showAmountError = false;
							fTPaymentDetails_AccountVm.showAmountMandatory = false;
							fTPaymentDetails_AccountVm.showAmountErrorMsg = "";
							fTPaymentDetails_AccountVm.disablePayBtn();
							break;
						case 1 :
							fTPaymentDetails_AccountVm.showAmountError = true;
							fTPaymentDetails_AccountVm.showAmountMandatory = false;
							
							if(!fTPaymentDetails_AccountVm.sumModAccountAmount) //changed for AMS-1002 
                            {
                                fTPaymentDetails_AccountVm.showAmountErrorMsg = constantConfig.ft.modeBalancetxt;
                            }
                            else{
                                fTPaymentDetails_AccountVm.showAmountErrorMsg = constantConfig.ft.validAmtTxt;
                            }
							fTPaymentDetails_AccountVm.disablePayBtn();
							break;
						case 3 :
							fTPaymentDetails_AccountVm.showAmountError = true;
							fTPaymentDetails_AccountVm.showAmountMandatory = false;
							fTPaymentDetails_AccountVm.showAmountErrorMsg = constantConfig.ft.validMaxAmtTxt;
							fTPaymentDetails_AccountVm.disablePayBtn();
							break;
						default :
							fTPaymentDetails_AccountVm.showAmountError = true;
							fTPaymentDetails_AccountVm.showAmountMandatory = false;
							fTPaymentDetails_AccountVm.showAmountErrorMsg = constantConfig.ft.inSuffAmt;
							fTPaymentDetails_AccountVm.disablePayBtn();
							break;
						}
					}
					else{
						fTPaymentDetails_AccountVm.showAmountError = true;
						fTPaymentDetails_AccountVm.showAmountMandatory = false;
						fTPaymentDetails_AccountVm.showAmountErrorMsg = constantConfig.ft.amtGrtThanZero;
						fTPaymentDetails_AccountVm.disablePayBtn();
					}
				}
				else {
					fTPaymentDetails_AccountVm.showAmountError = false;
					fTPaymentDetails_AccountVm.showAmountMandatory = true;
					fTPaymentDetails_AccountVm.disablePay = true;
				}
			};
			fTPaymentDetails_AccountVm.disablePayBtn = function() {
				if (!fTPaymentDetails_AccountVm.showAmountError && !fTPaymentDetails_AccountVm.showAmountMandatory && !utilityService.isEmpty(fTPaymentDetails_AccountVm.transAmount) && !utilityService.isUndefined(fTPaymentDetails_AccountVm.remark)) {
					fTPaymentDetails_AccountVm.disablePay = false;
				} else {
					fTPaymentDetails_AccountVm.disablePay = true;
				}
				if(fTPaymentDetails_AccountVm.disablePay && fTPaymentDetails_AccountVm.transAmount &&  fTPaymentDetails_AccountVm.showAmountErrorMsg.length >=1){
					var maxLength = 0; 
					var ftTransAmount = document.getElementById("ftTransAmount");
					if(!fTPaymentDetails_AccountVm.maxLimit){
						maxLength = $filter('INR')(fTPaymentDetails_AccountVm.sumModAccountAmount,'',2);
						ftTransAmount ? ftTransAmount.setAttribute("maxlength",maxLength.length):'';
					}
					else{
						maxLength = $filter('INR')(parseFloat(fTPaymentDetails_AccountVm.maxLimit),'',2);
						ftTransAmount ? ftTransAmount.setAttribute("maxlength",maxLength.length): '';
					}
				}
			};
			
			/* change event for selecting account*/
			fTPaymentDetails_AccountVm.selectedAccountFun =function (){
				fTPaymentDetails_AccountVm.isValidAccount = false;
				fTPaymentDetails_AccountVm.validAccountMessage = "";

				var data=fTPaymentDetails_AccountVm.selectedValue.split(",");
				var imgData = fTPaymentDetails_AccountVm.accDetails[data[3]].img;
				var e =[];
				e.accountType=data[0];
				e.accountNo=data[1];
				e.balance=data[2];
				e.indexId = data[3];
				e.img = imgData;
				
				fTPaymentDetails_AccountVm.availableBalance=e.balance;
				
				fTPaymentDetails_AccountVm.indexId = e.indexId;
				fTBeneficiaryService.customer.indexId = fTPaymentDetails_AccountVm.indexId;
				
				fTPaymentDetails_AccountVm.selectedAccountAmount=e.balance;
				
				fTBeneficiaryService.selectedDetails.accountType = e.accountType;
				fTBeneficiaryService.selectedDetails.accountNo = e.accountNo;
				fTBeneficiaryService.selectedDetails.balance = e.balance;
				fTBeneficiaryService.selectedDetails.img = e.img;
					
				if(fTPaymentDetails_AccountVm.selectedAccountAmount > 0){
					if(fTPaymentDetails_AccountVm.transAmount)
						fTPaymentDetails_AccountVm.validateAmount(); //validate amount on account change
				}
				else if(fTPaymentDetails_AccountVm.selectedAccountAmount < 1){
					var title = '';
					var onTap = '';
					fTPaymentDetails_AccountVm.disablenext = true;
					fTPaymentDetails_AccountVm.disablePay = true;
					var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="NO_SUFF_BAL"></div>';
					fTBeneficiaryService.showAlertModal(title,template,onTap,$scope,$state);
				}
			};
			
			fTPaymentDetails_AccountVm.goToBack = function() {
				$state.go('menu.fTNewBeneficiary');
			};

			fTPaymentDetails_AccountVm.goToPay = function() {
				/* Access Right changes start */
				fTPaymentDetails_AccountVm.isValidAccount = false;
				if(getAccountDetailsService.accessRightsData.accounts == null || getAccountDetailsService.accessRightsData.accounts == "") {
					fTPaymentDetails_AccountVm.isValidAccount =  true;
					fTPaymentDetails_AccountVm.validAccountMessage = fTPaymentDetails_AccountVm.fetchTransRights;
					return false;
				} else {
					for (var i in getAccountDetailsService.accessRightsData.accounts) {
						if (getAccountDetailsService.accessRightsData.accounts[i].accountNumber === fTBeneficiaryService.selectedDetails.accountNo) {
							if(parseInt(getAccountDetailsService.accessRightsData.accounts[i].accessResponse) == 0 || parseInt(getAccountDetailsService.accessRightsData.accounts[i].accessResponse) == 2){
								fTPaymentDetails_AccountVm.isValidAccount =  true;
								fTPaymentDetails_AccountVm.validAccountMessage = fTPaymentDetails_AccountVm.accTransRights;
								return false;
							}
						}
					}
				}
				/* Access Right changes End */

				if(fTBeneficiaryService.customer && parseInt(fTBeneficiaryService.customer.accountNoData) !== parseInt(fTPaymentDetails_AccountVm.selectedValue.split(',')[1])){
					if(!fTPaymentDetails_AccountVm.isRepeatedBeneficiaryAdded()){
						fTPaymentDetails_AccountVm.setSelectedBranchCodeForFromAcc();
						fTBeneficiaryService.customer.transAmount = parseFloat(fTPaymentDetails_AccountVm.transAmount.replace(",", ""));
						fTBeneficiaryService.customer.remarks = fTPaymentDetails_AccountVm.remark;
						fTBeneficiaryService.customer.imgData = fTPaymentDetails_AccountVm.imgData;
                                               // Fix for defect AMS-704
				         	if (fTPaymentDetails_AccountVm.transAmount) {
						fTPaymentDetails_AccountVm.transAmount = parseFloat(fTPaymentDetails_AccountVm.transAmount);
						fTPaymentDetails_AccountVm.transAmount = fTPaymentDetails_AccountVm.transAmount.toString();
					        }
					// End of Fix for defect
						if(fTPaymentDetails_AccountVm.payingTo.intraBankFlag == "Y"){	
							var reqParams = {
								"benName": fTPaymentDetails_AccountVm.payingTo.name,
								"benNickName": fTPaymentDetails_AccountVm.payingTo.nickName,
								"benType": "account",
								"benIFSCCode": fTPaymentDetails_AccountVm.payingTo.ifsc,
								"amount": fTPaymentDetails_AccountVm.transAmount,
								"intraBankFlag" : "Y",
								"intCategory" : fTBeneficiaryService.selectedDetails.intCategory ? fTBeneficiaryService.selectedDetails.intCategory : "",
								"accountTypeCode" : fTBeneficiaryService.selectedDetails.accountTypeCode ? fTBeneficiaryService.selectedDetails.accountTypeCode : "",
								"customerType": customerInfoService.customer.type ? customerInfoService.customer.type :"",
								"DOB" : "",
								"benAccntNo": fTPaymentDetails_AccountVm.payingTo.accountNo ? fTPaymentDetails_AccountVm.payingTo.accountNo : "",
								"debitNriflag": fTBeneficiaryService.selectedDetails.debitNriflag ? fTBeneficiaryService.selectedDetails.debitNriflag : "",
								"creditTypeCode": fTPaymentDetails_AccountVm.payingTo.creditTypeCode ? fTPaymentDetails_AccountVm.payingTo.creditTypeCode : "",
								"creditIntCategory": fTPaymentDetails_AccountVm.payingTo.creditIntCategory ? fTPaymentDetails_AccountVm.payingTo.creditIntCategory : "",
								"remAccntNo": fTBeneficiaryService.selectedDetails.accountNo ? fTBeneficiaryService.selectedDetails.accountNo : "",
								"branchCode": fTBeneficiaryService.selectedDetails.branchCode ? fTBeneficiaryService.selectedDetails.branchCode : "",
								"isOwnAccntFlag": fTBeneficiaryService.customer.isOwnAccntFlag ? fTBeneficiaryService.customer.isOwnAccntFlag : "",
								"remark": fTBeneficiaryService.customer.remarks ? fTBeneficiaryService.customer.remarks : ""
							};
							
							fTReviewService.getTransactionFee(reqParams).then(function(response) {
								if (response.messageCode == "01") {

								fTPaymentDetails_AccountVm.cancelPopupName = $ionicPopup.show({
									title: "",
									cssClass: 'my-custom-popup',
									template: response.message,
									scope: $scope,
									buttons: [
										{
											text: 'OK',
											type: 'button-assertive',
											onTap: function () {
												fTPaymentDetails_AccountVm.cancelPopupName.close();

												// call after NRI check

												try {
													fTReviewService.transactionFee = response.commisonAmt;
													fTReviewService.tncChannel = response.channel;
													fTReviewService.benBranchCode = response.benBranchCode;
													fTReviewService.benBranchName = response.benBranchName;
													fTReviewService.benAccntCat = response.benAccntCat;
													$state.go('menu.fTReviewDetails_Account');
												} catch (e) { }

												// call after NRI check END

											}
										},
										{
											text: 'Cancel',
											type: 'button-assertive',
											onTap: function () {
												fTPaymentDetails_AccountVm.cancelPopupName.close();
											}
										}
									],
								});

							}
							else if (response.messageCode == "02" || response.messageCode == "03") {
								utilityService.showErrorMessage(response.message);
							}
							else {

								// call after NRI check

								try {
									fTReviewService.transactionFee = response.commisonAmt;
									fTReviewService.tncChannel = response.channel;
									fTReviewService.benBranchCode = response.benBranchCode;
									fTReviewService.benBranchName = response.benBranchName;
									fTReviewService.benAccntCat = response.benAccntCat;
									$state.go('menu.fTReviewDetails_Account');
								} catch (e) { }

								// call after NRI check END

							}
							}, function(error) {
								utilityService.showErrorMessage(error.responseMessage);
							});
						}else{
							var reqParams = {
								"benName": fTPaymentDetails_AccountVm.payingTo.name,
								"benNickName": fTPaymentDetails_AccountVm.payingTo.nickName,
								"benType": "account",
								"benIFSCCode": fTPaymentDetails_AccountVm.payingTo.ifsc,
								"amount": fTPaymentDetails_AccountVm.transAmount,
								"intraBankFlag" : "N",
								"intCategory" : fTBeneficiaryService.selectedDetails.intCategory ? fTBeneficiaryService.selectedDetails.intCategory : "",
								"accountTypeCode" : fTBeneficiaryService.selectedDetails.accountTypeCode ? fTBeneficiaryService.selectedDetails.accountTypeCode : "",
								"customerType": customerInfoService.customer.type ? customerInfoService.customer.type :"",
								"DOB": "",
								"benAccntNo": fTPaymentDetails_AccountVm.payingTo.accountNo ? fTPaymentDetails_AccountVm.payingTo.accountNo : "",
								"debitNriflag": fTBeneficiaryService.selectedDetails.debitNriflag ? fTBeneficiaryService.selectedDetails.debitNriflag : "",
								"creditTypeCode": fTPaymentDetails_AccountVm.payingTo.creditTypeCode ? fTPaymentDetails_AccountVm.payingTo.creditTypeCode : "",
								"creditIntCategory": fTPaymentDetails_AccountVm.payingTo.creditIntCategory ? fTPaymentDetails_AccountVm.payingTo.creditIntCategory : "",
								"remAccntNo": fTBeneficiaryService.selectedDetails.accountNo ? fTBeneficiaryService.selectedDetails.accountNo : "",
								"branchCode": fTBeneficiaryService.selectedDetails.branchCode ? fTBeneficiaryService.selectedDetails.branchCode : "",
								"isOwnAccntFlag": fTBeneficiaryService.customer.isOwnAccntFlag ? fTBeneficiaryService.customer.isOwnAccntFlag : "",
								"remark": fTBeneficiaryService.customer.remarks ? fTBeneficiaryService.customer.remarks : ""
							};
							fTReviewService.getTransactionFee(reqParams).then(function(response) {
							if (response.messageCode == "01") {

								fTPaymentDetails_AccountVm.cancelPopupName = $ionicPopup.show({
									title: "",
									cssClass: 'my-custom-popup',
									template: response.message,
									scope: $scope,
									buttons: [
										{
											text: 'OK',
											type: 'button-assertive',
											onTap: function () {
												fTPaymentDetails_AccountVm.cancelPopupName.close();

												// call after NRI check

												try {
													fTReviewService.transactionFee = response.commisonAmt;
													fTReviewService.tncChannel = response.channel;
													fTReviewService.benBranchCode = response.benBranchCode;
													fTReviewService.benBranchName = response.benBranchName;
													fTReviewService.benAccntCat = response.benAccntCat;
													$state.go('menu.fTReviewDetails_Account');
												} catch (e) { }

												// call after NRI check END

											}
										},
										{
											text: 'Cancel',
											type: 'button-assertive',
											onTap: function () {
												fTPaymentDetails_AccountVm.cancelPopupName.close();
											}
										}
									],
								});

							}
							else if (response.messageCode == "02" || response.messageCode == "03") {
								utilityService.showErrorMessage(response.message);
							}
							else {

								// call after NRI check

								try {
									fTReviewService.transactionFee = response.commisonAmt;
									fTReviewService.tncChannel = response.channel;
									fTReviewService.benBranchCode = response.benBranchCode;
									fTReviewService.benBranchName = response.benBranchName;
									fTReviewService.benAccntCat = response.benAccntCat;
									$state.go('menu.fTReviewDetails_Account');
								} catch (e) { }

								// call after NRI check END

							}							}, function(error) {
								utilityService.showErrorMessage(error.responseMessage);
							});
						}
					}else{
						utilityService.showErrorMessage(fTPaymentDetails_AccountVm.repeatedParameter+' you entered is already exist in your beneficiary list.');
					}
				}else{
					utilityService.showErrorMessage('Remitter account number and beneficiary account number should not be same.');
				}
			};
			
			fTPaymentDetails_AccountVm.isRepeatedBeneficiaryAdded = function(){
				for(var i = 0; i < fTBeneficiaryService.beneficiaries.otherAccItems.length; i++){
					if(parseInt(fTBeneficiaryService.customer.accountNoData) == parseInt(fTBeneficiaryService.beneficiaries.otherAccItems[i].accountNo)){
						fTPaymentDetails_AccountVm.repeatedParameter = 'Beneficiary account number';
						return true;
					}
					if(fTBeneficiaryService.customer.nickName.toLowerCase() == fTBeneficiaryService.beneficiaries.otherAccItems[i].nickName.toLowerCase()){
						fTPaymentDetails_AccountVm.repeatedParameter = 'Beneficiary nick name';
						return true;
					}
				}
				return false;
			};
			
			$scope.goToHome = function() {
				$state.go('menu.fundsTransfer');
			};
			fTPaymentDetails_AccountVm.setSelectedBranchCodeForFromAcc = function() {
				var arrLen = fTBeneficiaryService.payingFrom.length;
				for (var i = 0; i < arrLen; i++) {
					if(fTBeneficiaryService.payingFrom[i].accountNo == fTBeneficiaryService.selectedDetails.accountNo){
						fTBeneficiaryService.selectedDetails.branchCode = fTBeneficiaryService.payingFrom[i].branchCode;
						fTBeneficiaryService.selectedDetails.accountTypeCode = fTBeneficiaryService.payingFrom[i].accountTypeCode ?  fTBeneficiaryService.payingFrom[i].accountTypeCode : "";
						fTBeneficiaryService.selectedDetails.intCategory = fTBeneficiaryService.payingFrom[i].intCategory ? fTBeneficiaryService.payingFrom[i].intCategory : "";
						fTBeneficiaryService.selectedDetails.debitNriflag = fTBeneficiaryService.payingFrom[i].debitNriflag ? fTBeneficiaryService.payingFrom[i].debitNriflag : "";
					}
				}
			},
			$scope.$on('$ionicView.beforeEnter', function() {
				initPage();
				fTPaymentDetails_AccountVm.transAmount = $filter('INR')(fTBeneficiaryService.customer.transAmount);
				
	fTPaymentDetails_AccountVm.remark = fTBeneficiaryService.customer.remarks;
	
	fTPaymentDetails_AccountVm.remarkPurposes=fTPaymentDetails_AccountVm.getFTPurposes();	

	fTPaymentDetails_AccountVm.remarkPurpose = fTBeneficiaryService.remarkPurpose;
	if(fTPaymentDetails_AccountVm.remarkPurpose =="Others"){
	fTPaymentDetails_AccountVm.remarkOther= fTPaymentDetails_AccountVm.remark;
	}




				if(fTPaymentDetails_AccountVm.transAmount)
					fTPaymentDetails_AccountVm.validateAmount();
				fTPaymentDetails_AccountVm.validateRemark();
				fTPaymentDetails_AccountVm.showAmountError = false;
				fTPaymentDetails_AccountVm.showRemarkError = false;
				
				if (fTBeneficiaryService.savedImg === "" || fTBeneficiaryService.savedImg === undefined)
					fTPaymentDetails_AccountVm.imgData = fTBeneficiaryService.customer.conImg;
				else
					fTPaymentDetails_AccountVm.imgData = fTBeneficiaryService.savedImg;
				
				fTPaymentDetails_AccountVm.accountNoData = fTBeneficiaryService.customer.accountNoData;
				fTPaymentDetails_AccountVm.nameData = fTBeneficiaryService.customer.nameData;
				fTPaymentDetails_AccountVm.bankData = fTBeneficiaryService.customer.bankData;
				fTPaymentDetails_AccountVm.nickNameData = fTBeneficiaryService.customer.nickName;
				fTPaymentDetails_AccountVm.benTypeData = fTBeneficiaryService.customer.benType;
				fTPaymentDetails_AccountVm.benIfscData = fTBeneficiaryService.customer.ifsc;
				fTPaymentDetails_AccountVm.intraBankFlagData = fTBeneficiaryService.customer.intraBankFlag;
				fTPaymentDetails_AccountVm.maxLimit = fTBeneficiaryService.customer.maxLimit;
				fTPaymentDetails_AccountVm.creditTypeCode = fTBeneficiaryService.customer.creditTypeCode;
				fTPaymentDetails_AccountVm.creditIntCategory = fTBeneficiaryService.customer.creditIntCategory;
				
				fTPaymentDetails_AccountVm.payingTo = {
					img : fTPaymentDetails_AccountVm.imgData,
					name : fTPaymentDetails_AccountVm.nameData,
					nickName : fTPaymentDetails_AccountVm.nickNameData,
					benType : fTPaymentDetails_AccountVm.benTypeData,
					ifsc : fTPaymentDetails_AccountVm.benIfscData,
					bank : fTPaymentDetails_AccountVm.bankData,
					accountNo : fTPaymentDetails_AccountVm.accountNoData,
					intraBankFlag : fTPaymentDetails_AccountVm.intraBankFlagData,
					creditTypeCode: fTPaymentDetails_AccountVm.creditTypeCode,
					creditIntCategory: fTPaymentDetails_AccountVm.creditIntCategory
				};
				fTPaymentDetails_AccountVm.eyesOffFun(fTPaymentDetails_AccountVm.payingTo.accountNo);
				if(!fTBeneficiaryService.config.quickTransferLimit) {
					requestYCService.getWelcomeMessages().then(function (response) {
						fTBeneficiaryService.config.quickTransferLimit = response.fundsTransfer.benAmountLimit;
						fTPaymentDetails_AccountVm.transferLimit = response.fundsTransfer.benAmountLimit;
					});
				}
				else fTPaymentDetails_AccountVm.transferLimit = fTBeneficiaryService.config.quickTransferLimit;
			});

		fTPaymentDetails_AccountVm.eyesOnFun = function(accNo){
			fTPaymentDetails_AccountVm.isAccountMasked = false;
			fTPaymentDetails_AccountVm.payingTo.accountNo = fTPaymentDetails_AccountVm.oFDValue;
		}

		fTPaymentDetails_AccountVm.eyesOffFun = function(accNo){
			fTPaymentDetails_AccountVm.isAccountMasked = true;
			fTPaymentDetails_AccountVm.oFDValue = accNo;
			fTPaymentDetails_AccountVm.payingTo.maskedFdNumber = utilityService.maskData(accNo, "front", 4);
		}


			$scope.$on('$ionicView.loaded', function () {
				if(!getAccountDetailsService.accessRightsData.accounts) {
					getAccountDetailsService.getAccountsAccessRights('').then( function(data) {
						getAccountDetailsService.accessRightsData = data;
					}, function(error) {
						// Failure block
					});
				}
			});
		

fTPaymentDetails_AccountVm.updateRemark =function(){
	fTPaymentDetails_AccountVm.remark=fTPaymentDetails_AccountVm.remarkOther;
	fTBeneficiaryService.remarkOther = fTPaymentDetails_AccountVm.remarkOther;
	fTBeneficiaryService.remarkPurpose = fTPaymentDetails_AccountVm.remarkPurpose;
	fTPaymentDetails_AccountVm.validateRemark();
} 
fTPaymentDetails_AccountVm.updatePurpose = function(){
	if(fTPaymentDetails_AccountVm.remarkPurpose=="Others"){					
		fTPaymentDetails_AccountVm.remark="";				
		fTPaymentDetails_AccountVm.validateRemark();						
	}
	else{
		fTPaymentDetails_AccountVm.remarkOther="";
		fTPaymentDetails_AccountVm.remark=fTPaymentDetails_AccountVm.remarkPurpose;
		fTBeneficiaryService.remarkOther = "";
		fTBeneficiaryService.remarkPurpose = fTPaymentDetails_AccountVm.remarkPurpose;
		fTPaymentDetails_AccountVm.validateRemark();
	}
	}
	fTPaymentDetails_AccountVm.getFTPurposes = function(){
	
   
		fTBeneficiaryService.getFTPurposes().then(function(data){
			fTPaymentDetails_AccountVm.remarkPurposes=data.remarkPurposes;
	   },function (error) {
	   utilityService.showErrorMessage(error.responseMessage);
	   }
	   ); 
	
   }


			

			return this;
		}
]);
