'use strict';

angularApp.controller('fTPaymentDetails_MobileController', [
	"$state",
	"$scope",
	"$rootScope",
	"$ionicPopup",
	"fTBeneficiaryService",
	"closePopupService",
	"fTReviewService",
	"validationService",
	"utilityService",
	"$filter",
	"constantConfig",
	"cryptoService",
	"loggedInUserService",
	"customerInfoService",
	"getAccountDetailsService",
	"$translate",
	"requestYCService",

	function ($state,
		$scope,
		$rootScope,
		$ionicPopup,
		fTBeneficiaryService,
		closePopupService,
		fTReviewService,
		validationService,
		utilityService,
		$filter,
		constantConfig,
		cryptoService,
		loggedInUserService,
		customerInfoService,
		getAccountDetailsService,
		$translate,
		requestYCService) {

			var fTPaymentDetails_MobileVm = this;
			fTPaymentDetails_MobileVm.disablePay = false;
			fTPaymentDetails_MobileVm.showAmountError = false;
			fTPaymentDetails_MobileVm.showRemarkError = false;

			fTPaymentDetails_MobileVm.isValidAccount = false;
			fTPaymentDetails_MobileVm.validAccountMessage = "";

			function initPage() {
				$translate(['ACC_TRANS_RIGHTS','FETCH_TRANS_RGTS']).then(function (translations) {
					fTPaymentDetails_MobileVm.accTransRights = translations['ACC_TRANS_RIGHTS'];
					fTPaymentDetails_MobileVm.fetchTransRights = translations['FETCH_TRANS_RGTS'];
				});
				fTPaymentDetails_MobileVm.payingFrom = fTBeneficiaryService.payingFrom;
				fTPaymentDetails_MobileVm.accountTypeData = fTBeneficiaryService.selectedDetails.accountType;
				
				fTPaymentDetails_MobileVm.showAmountMandatory = false;
				
				fTPaymentDetails_MobileVm.accDetails = [];
				fTPaymentDetails_MobileVm.accDetails = fTPaymentDetails_MobileVm.payingFrom;
				
				for(var i in fTPaymentDetails_MobileVm.accDetails){
				var selAccount = fTPaymentDetails_MobileVm.accDetails[i]["accountType"].toLowerCase();	
				if(selAccount.indexOf("savings") != -1){
					fTPaymentDetails_MobileVm.accDetails[i]["accountType"]="SB";
				}else if(selAccount.indexOf("current") != -1){
					fTPaymentDetails_MobileVm.accDetails[i]["accountType"]="CA";
					
				}else if(selAccount.indexOf("overdraft") != -1){
					fTPaymentDetails_MobileVm.accDetails[i]["accountType"]="OD";
					
				}
				}
				if(fTBeneficiaryService.selectedDetails.accountType === ''){
					fTPaymentDetails_MobileVm.availableBalance=fTPaymentDetails_MobileVm.accDetails[0].balance;
					fTPaymentDetails_MobileVm.selectedValue = fTPaymentDetails_MobileVm.accDetails[0].accountType+","+fTPaymentDetails_MobileVm.accDetails[0].accountNo+","+fTPaymentDetails_MobileVm.accDetails[0].balance+",0";
					fTPaymentDetails_MobileVm.indexId = 0;
					
					fTBeneficiaryService.customer.selectedItem=fTPaymentDetails_MobileVm.selectedValue;
					fTPaymentDetails_MobileVm.selectedAccountType=fTPaymentDetails_MobileVm.accDetails[0].accountType;
					fTPaymentDetails_MobileVm.selectedAccountNumber=fTPaymentDetails_MobileVm.accDetails[0].accountNo;
					fTPaymentDetails_MobileVm.selectedAccountAmount=fTPaymentDetails_MobileVm.accDetails[0].balance;
					
					fTBeneficiaryService.selectedDetails.accountType = fTPaymentDetails_MobileVm.selectedAccountType;
					fTBeneficiaryService.selectedDetails.accountNo = fTPaymentDetails_MobileVm.selectedAccountNumber;
					fTBeneficiaryService.selectedDetails.balance = fTPaymentDetails_MobileVm.selectedAccountAmount;
					fTBeneficiaryService.selectedDetails.img = fTPaymentDetails_MobileVm.accDetails[0].img;
				}
				else{
					fTPaymentDetails_MobileVm.indexId = fTBeneficiaryService.customer.indexId;
					if(fTPaymentDetails_MobileVm.accDetails[fTPaymentDetails_MobileVm.indexId]){
						fTPaymentDetails_MobileVm.selectedValue = fTPaymentDetails_MobileVm.accDetails[fTPaymentDetails_MobileVm.indexId].accountType+","+fTPaymentDetails_MobileVm.accDetails[fTPaymentDetails_MobileVm.indexId].accountNo+","+fTPaymentDetails_MobileVm.accDetails[fTPaymentDetails_MobileVm.indexId].balance+","+fTPaymentDetails_MobileVm.indexId;
					} else {
						fTPaymentDetails_MobileVm.selectedValue = fTPaymentDetails_MobileVm.accDetails[0].accountType+","+fTPaymentDetails_MobileVm.accDetails[0].accountNo+","+fTPaymentDetails_MobileVm.accDetails[0].balance+",0";
					}
					
		fTPaymentDetails_MobileVm.selectedAccountType = fTPaymentDetails_MobileVm.selectedValue.split(',')[0];
		fTPaymentDetails_MobileVm.selectedAccountNumber = fTPaymentDetails_MobileVm.selectedValue.split(',')[1];
		fTPaymentDetails_MobileVm.selectedAccountAmount = fTPaymentDetails_MobileVm.selectedValue.split(',')[2];
		if(fTPaymentDetails_MobileVm.accDetails[fTPaymentDetails_MobileVm.indexId]){
			fTPaymentDetails_MobileVm.img = fTPaymentDetails_MobileVm.accDetails[fTPaymentDetails_MobileVm.indexId].img;
		} else {
			fTPaymentDetails_MobileVm.img = fTPaymentDetails_MobileVm.accDetails[0].img;
		}
		
		fTPaymentDetails_MobileVm.availableBalance = fTPaymentDetails_MobileVm.selectedValue.split(',')[2];
				}
				
				if(fTPaymentDetails_MobileVm.selectedAccountAmount < 1){
					var title = '';
					var onTap = '';
					fTPaymentDetails_MobileVm.disablenext = true;
					fTPaymentDetails_MobileVm.disablePay = true;
					var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="NO_SUFF_BAL"></div>';
					fTBeneficiaryService.showAlertModal(title,template,onTap,$scope,$state);
				}
			}
			fTPaymentDetails_MobileVm.validateRemark = function() {
				if (!utilityService.isEmpty(fTPaymentDetails_MobileVm.remark)) {
					fTPaymentDetails_MobileVm.showRemarkError = false;
					fTPaymentDetails_MobileVm.disablePayBtn();
				} else {
					fTPaymentDetails_MobileVm.showRemarkError = true;
					fTPaymentDetails_MobileVm.disablePayBtn();
				}
			};
			fTPaymentDetails_MobileVm.validateAmount = function() {
				/* MOD changes start */
				if(getAccountDetailsService.accessRightsData.accounts) {
					for (var i in getAccountDetailsService.accessRightsData.accounts) {
						if (getAccountDetailsService.accessRightsData.accounts[i].accountNumber === fTBeneficiaryService.selectedDetails.accountNo && getAccountDetailsService.accessRightsData.accounts[i].modBalance) {
							fTPaymentDetails_MobileVm.sumModAccountAmount = parseFloat(getAccountDetailsService.accessRightsData.accounts[i].modBalance) + parseFloat(fTPaymentDetails_MobileVm.selectedAccountAmount);
							break;
						}
					}
				} else {
					fTPaymentDetails_MobileVm.sumModAccountAmount = parseFloat(fTPaymentDetails_MobileVm.selectedAccountAmount);
				}
				/* MOD changes end */

				if(fTPaymentDetails_MobileVm.transAmount){
					if(fTPaymentDetails_MobileVm.transAmount >= 1){
						switch (validationService.isValidAmount(fTPaymentDetails_MobileVm.sumModAccountAmount, fTPaymentDetails_MobileVm.transAmount,fTPaymentDetails_MobileVm.maxLimit)) {
						case 0 :
							fTPaymentDetails_MobileVm.showAmountError = false;
							fTPaymentDetails_MobileVm.showAmountMandatory = false;
							fTPaymentDetails_MobileVm.showAmountErrorMsg = "";
							fTPaymentDetails_MobileVm.disablePayBtn();
							break;
						case 1 :
							fTPaymentDetails_MobileVm.showAmountError = true;
							fTPaymentDetails_MobileVm.showAmountMandatory = false;
							if(!fTPaymentDetails_MobileVm.sumModAccountAmount) //changed for AMS-1002 
                            {
                                fTPaymentDetails_MobileVm.showAmountErrorMsg = constantConfig.ft.modeBalancetxt;
                            }
                            else{
                                fTPaymentDetails_MobileVm.showAmountErrorMsg = constantConfig.ft.validAmtTxt;
                            }
							fTPaymentDetails_MobileVm.disablePayBtn();
							break;
						case 3 :
							fTPaymentDetails_MobileVm.showAmountError = true;
							fTPaymentDetails_MobileVm.showAmountMandatory = false;
							fTPaymentDetails_MobileVm.showAmountErrorMsg = constantConfig.ft.validMaxAmtTxt;
							fTPaymentDetails_MobileVm.disablePayBtn();
							break;
						default :
							fTPaymentDetails_MobileVm.showAmountError = true;
							fTPaymentDetails_MobileVm.showAmountMandatory = false;
							fTPaymentDetails_MobileVm.showAmountErrorMsg = constantConfig.ft.inSuffAmt;
							fTPaymentDetails_MobileVm.disablePayBtn();
							break;
						}
					}
					else{
						fTPaymentDetails_MobileVm.showAmountError = true;
						fTPaymentDetails_MobileVm.showAmountMandatory = false;
						fTPaymentDetails_MobileVm.showAmountErrorMsg = constantConfig.ft.amtGrtThanZero;
						fTPaymentDetails_MobileVm.disablePayBtn();
					}
				}
				else {
					fTPaymentDetails_MobileVm.showAmountError = false;
					fTPaymentDetails_MobileVm.showAmountMandatory = true;
					fTPaymentDetails_MobileVm.disablePay = true;
				}
			};
			fTPaymentDetails_MobileVm.disablePayBtn = function() {
				if (!fTPaymentDetails_MobileVm.showAmountError && !fTPaymentDetails_MobileVm.showAmountMandatory && !utilityService.isEmpty(fTPaymentDetails_MobileVm.transAmount) && !utilityService.isUndefined(fTPaymentDetails_MobileVm.remark)) {
					fTPaymentDetails_MobileVm.disablePay = false;
				} else {
					fTPaymentDetails_MobileVm.disablePay = true;
				}
				if(fTPaymentDetails_MobileVm.disablePay && fTPaymentDetails_MobileVm.transAmount &&  fTPaymentDetails_MobileVm.showAmountErrorMsg.length >=1){
					var maxLength = 0; 
					var ftTransAmount = document.getElementById("ftTransAmount");
					if(!fTPaymentDetails_MobileVm.maxLimit){
						maxLength = $filter('INR')(fTPaymentDetails_MobileVm.sumModAccountAmount,'',2);
						ftTransAmount ? ftTransAmount.setAttribute("maxlength",maxLength.length):'';
					}
					else{
						maxLength = $filter('INR')(parseFloat(fTPaymentDetails_MobileVm.maxLimit),'',2);
						ftTransAmount ? ftTransAmount.setAttribute("maxlength",maxLength.length): '';
					}
				}
			}
			
			/* change event for selecting account*/
			fTPaymentDetails_MobileVm.selectedAccountFun =function (){
				fTPaymentDetails_MobileVm.isValidAccount = false;
				fTPaymentDetails_MobileVm.validAccountMessage = "";

				var data=fTPaymentDetails_MobileVm.selectedValue.split(",");
				var imgData = fTPaymentDetails_MobileVm.accDetails[data[3]].img;
				var e =[];
				e.accountType=data[0];
				e.accountNo=data[1];
				e.balance=data[2];
				e.indexId = data[3];
				e.img = imgData;
				
				fTPaymentDetails_MobileVm.availableBalance=e.balance;
				fTPaymentDetails_MobileVm.indexId = e.indexId;
				fTBeneficiaryService.customer.indexId = fTPaymentDetails_MobileVm.indexId;
				
				fTPaymentDetails_MobileVm.selectedAccountAmount=e.balance;
				
				fTBeneficiaryService.selectedDetails.accountType = e.accountType;
				fTBeneficiaryService.selectedDetails.accountNo = e.accountNo;
				fTBeneficiaryService.selectedDetails.balance = e.balance;
				fTBeneficiaryService.selectedDetails.img = e.img;
				
				if(fTPaymentDetails_MobileVm.selectedAccountAmount > 0){
					if(fTPaymentDetails_MobileVm.transAmount)
						fTPaymentDetails_MobileVm.validateAmount(); //validate amount on account change
				}
				
				else if(fTPaymentDetails_MobileVm.selectedAccountAmount < 1){
					var title = '';
					var onTap = '';
					fTPaymentDetails_MobileVm.disablenext = true;
					fTPaymentDetails_MobileVm.disablePay = true;
					var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="NO_SUFF_BAL"></div>';
					fTBeneficiaryService.showAlertModal(title,template,onTap,$scope,$state);
				}
			};
			
			fTPaymentDetails_MobileVm.goToBack = function() {
				fTBeneficiaryService.savedFlag = true;
				$state.go('menu.fTNewBeneficiary_Mobile');
			}

			fTPaymentDetails_MobileVm.goToPay = function() {
				/* Access Right changes start */
				if(getAccountDetailsService.accessRightsData.accounts == null || getAccountDetailsService.accessRightsData.accounts == "") {
					fTPaymentDetails_MobileVm.isValidAccount =  true;
					fTPaymentDetails_MobileVm.validAccountMessage = fTPaymentDetails_MobileVm.fetchTransRights;
					return false;
				} else {
					for (var i in getAccountDetailsService.accessRightsData.accounts) {
						if (getAccountDetailsService.accessRightsData.accounts[i].accountNumber === fTBeneficiaryService.selectedDetails.accountNo) {
							if(parseInt(getAccountDetailsService.accessRightsData.accounts[i].accessResponse) == 0 || parseInt(getAccountDetailsService.accessRightsData.accounts[i].accessResponse) == 2){
								fTPaymentDetails_MobileVm.isValidAccount =  true;
								fTPaymentDetails_MobileVm.validAccountMessage = fTPaymentDetails_MobileVm.accTransRights;
								return false;
							}
						}
					}
				}
				/* Access Right changes End */

				if(!fTPaymentDetails_MobileVm.isRepeatedBeneficiaryAdded()){
					fTPaymentDetails_MobileVm.setSelectedBranchCodeForFromAcc();
					fTBeneficiaryService.customer.transAmount = parseFloat(fTPaymentDetails_MobileVm.transAmount.replace(",", ""));
					fTBeneficiaryService.customer.remarks = fTPaymentDetails_MobileVm.remark;
					fTBeneficiaryService.customer.imgData = fTPaymentDetails_MobileVm.imgData;
					
					var reqParams = {
						"benName": fTPaymentDetails_MobileVm.payingTo.name,
						"benNickName": fTPaymentDetails_MobileVm.payingTo.nickName,
						"benType": "mobile",
						"benMMID": fTPaymentDetails_MobileVm.payingTo.mmid,
						"amount": fTPaymentDetails_MobileVm.transAmount,
						"intraBankFlag" : "N",
						 "intCategory" : fTBeneficiaryService.selectedDetails.intCategory ? fTBeneficiaryService.selectedDetails.intCategory : "",
						 "accountTypeCode" : fTBeneficiaryService.selectedDetails.accountTypeCode ? fTBeneficiaryService.selectedDetails.accountTypeCode : "",
						 "customerType": customerInfoService.customer.type ? customerInfoService.customer.type :"",
						"DOB": "",
						"benAccntNo": fTPaymentDetails_MobileVm.payingTo.accountNo ? fTPaymentDetails_MobileVm.payingTo.accountNo : "",
						"debitNriflag": fTBeneficiaryService.selectedDetails.debitNriflag ? fTBeneficiaryService.selectedDetails.debitNriflag : "",
						"creditTypeCode": fTPaymentDetails_MobileVm.payingTo.creditTypeCode ? fTPaymentDetails_MobileVm.payingTo.creditTypeCode : "",
						"creditIntCategory": fTPaymentDetails_MobileVm.payingTo.creditIntCategory ? fTPaymentDetails_MobileVm.payingTo.creditIntCategory : "",
						"remAccntNo": fTBeneficiaryService.selectedDetails.accountNo ? fTBeneficiaryService.selectedDetails.accountNo : "",
						"branchCode": fTBeneficiaryService.selectedDetails.branchCode ? fTBeneficiaryService.selectedDetails.branchCode : "",
						"isOwnAccntFlag": fTBeneficiaryService.customer.isOwnAccntFlag ? fTBeneficiaryService.customer.isOwnAccntFlag : "",
						"remark": fTBeneficiaryService.customer.remarks ? fTBeneficiaryService.customer.remarks : ""
					};
					
					fTReviewService.getTransactionFee(reqParams).then(function(response) {
					if (response.messageCode == "01") {

						fTPaymentDetails_MobileVm.cancelPopupName = $ionicPopup.show({
							title: "",
							cssClass: 'my-custom-popup',
							template: response.message,
							scope: $scope,
							buttons: [
								{
									text: 'OK',
									type: 'button-assertive',
									onTap: function () {
										fTPaymentDetails_MobileVm.cancelPopupName.close();

										// call after NRI check

										try {
											fTReviewService.transactionFee = response.commisonAmt;
											fTReviewService.tncChannel = response.channel;
											fTReviewService.benBranchCode = response.benBranchCode;
											fTReviewService.benBranchName = response.benBranchName;
											fTReviewService.benAccntCat = response.benAccntCat;
											$state.go('menu.fTReviewDetails_Mobile');
										} catch (e) { }

										// call after NRI check END

									}
								},
								{
									text: 'Cancel',
									type: 'button-assertive',
									onTap: function () {
										fTPaymentDetails_MobileVm.cancelPopupName.close();
									}
								}
							],
						});

					}
					else if (response.messageCode == "02" || response.messageCode == "03") {
						utilityService.showErrorMessage(response.message);
					}
					else {

						// call after NRI check

						try {
							fTReviewService.transactionFee = response.commisonAmt;
							fTReviewService.tncChannel = response.channel;
							fTReviewService.benBranchCode = response.benBranchCode;
							fTReviewService.benBranchName = response.benBranchName;
							fTReviewService.benAccntCat = response.benAccntCat;
							$state.go('menu.fTReviewDetails_Mobile');
						} catch (e) { }

						// call after NRI check END

					}
					}, function(error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				}else{
					utilityService.showErrorMessage(fTPaymentDetails_MobileVm.repeatedParameter+' you entered is already exist in your beneficiary list.');
				}
			};
			
			fTPaymentDetails_MobileVm.isRepeatedBeneficiaryAdded = function(){
				for(var i = 0; i < fTBeneficiaryService.beneficiaries.otherAccItems.length; i++){
					if((parseInt(fTBeneficiaryService.customer.mmid) == parseInt(fTBeneficiaryService.beneficiaries.otherAccItems[i].mmid) && parseInt(fTBeneficiaryService.customer.mobileNo) == parseInt(fTBeneficiaryService.beneficiaries.otherAccItems[i].mobileNumber))){
						fTPaymentDetails_MobileVm.repeatedParameter = 'Beneficiary MMID';
						return true;
					}
					if(fTBeneficiaryService.customer.nickName.toLowerCase() == fTBeneficiaryService.beneficiaries.otherAccItems[i].nickName.toLowerCase()){
						fTPaymentDetails_MobileVm.repeatedParameter = 'Beneficiary nick name';
						return true;
					}
				}
				return false;
			};
			
			$scope.goToHome = function() {
				$state.go('menu.fundsTransfer');
			};
		
			fTPaymentDetails_MobileVm.setSelectedBranchCodeForFromAcc = function() {
				var arrLen = fTBeneficiaryService.payingFrom.length;
				for (var i = 0; i < arrLen; i++) {
					if(fTBeneficiaryService.payingFrom[i].accountNo == fTBeneficiaryService.selectedDetails.accountNo){
						fTBeneficiaryService.selectedDetails.branchCode = fTBeneficiaryService.payingFrom[i].branchCode;
						fTBeneficiaryService.selectedDetails.accountTypeCode = fTBeneficiaryService.payingFrom[i].accountTypeCode ?  fTBeneficiaryService.payingFrom[i].accountTypeCode : "";
						fTBeneficiaryService.selectedDetails.intCategory = fTBeneficiaryService.payingFrom[i].intCategory ? fTBeneficiaryService.payingFrom[i].intCategory : "";
						fTBeneficiaryService.selectedDetails.debitNriflag = fTBeneficiaryService.payingFrom[i].debitNriflag ? fTBeneficiaryService.payingFrom[i].debitNriflag : "";
					}
				}
			};
			$scope.$on('$ionicView.beforeEnter', function() {
				initPage();
				fTPaymentDetails_MobileVm.remark = fTBeneficiaryService.customer.remarks;
			
			
			fTPaymentDetails_MobileVm.remarkPurposes=fTPaymentDetails_MobileVm.getFTPurposes();	
			
			fTPaymentDetails_MobileVm.remarkPurpose = fTBeneficiaryService.remarkPurpose;
			if(fTPaymentDetails_MobileVm.remarkPurpose =="Others"){
				fTPaymentDetails_MobileVm.remarkOther= fTPaymentDetails_MobileVm.remark;
			}	
			
			
			
				fTPaymentDetails_MobileVm.transAmount = $filter('INR')(fTBeneficiaryService.customer.transAmount);
				if(fTPaymentDetails_MobileVm.transAmount)
					fTPaymentDetails_MobileVm.validateAmount();
				fTPaymentDetails_MobileVm.validateRemark();
				fTPaymentDetails_MobileVm.showAmountError = false;
				fTPaymentDetails_MobileVm.showRemarkError = false;
				if (fTBeneficiaryService.savedImg === "" || fTBeneficiaryService.savedImg === undefined)
					fTPaymentDetails_MobileVm.imgData = fTBeneficiaryService.customer.conImg;
				else
					fTPaymentDetails_MobileVm.imgData = fTBeneficiaryService.savedImg;
				fTPaymentDetails_MobileVm.nameData = fTBeneficiaryService.customer.nameData;
				fTPaymentDetails_MobileVm.mmid = fTBeneficiaryService.customer.mmid;
				fTPaymentDetails_MobileVm.mobileNo = fTBeneficiaryService.customer.mobileNo;
				
				fTPaymentDetails_MobileVm.accountNoData = fTBeneficiaryService.customer.accountNoData;
				fTPaymentDetails_MobileVm.bankData = fTBeneficiaryService.customer.bankData;
				fTPaymentDetails_MobileVm.nickNameData = fTBeneficiaryService.customer.nickName;
				fTPaymentDetails_MobileVm.benTypeData = fTBeneficiaryService.customer.benType;
				fTPaymentDetails_MobileVm.maxLimit = fTBeneficiaryService.customer.maxLimit;
				fTPaymentDetails_MobileVm.creditTypeCode = fTBeneficiaryService.customer.creditTypeCode;
				fTPaymentDetails_MobileVm.creditIntCategory = fTBeneficiaryService.customer.creditIntCategory;
				
				fTPaymentDetails_MobileVm.payingTo = {
					img : fTPaymentDetails_MobileVm.imgData,
					name : fTPaymentDetails_MobileVm.nameData,
					mmid : fTPaymentDetails_MobileVm.mmid,
					mobile : fTPaymentDetails_MobileVm.mobileNo,
					
					nickName : fTPaymentDetails_MobileVm.nickNameData,
					benType : fTPaymentDetails_MobileVm.benTypeData,
					bank : fTPaymentDetails_MobileVm.bankData,
					accountNo : fTPaymentDetails_MobileVm.accountNoData,
					creditTypeCode: fTPaymentDetails_MobileVm.creditTypeCode,
					creditIntCategory: fTPaymentDetails_MobileVm.creditIntCategory
				};

				if(!fTBeneficiaryService.config.quickTransferLimit) {
					requestYCService.getWelcomeMessages().then(function (response) {
						fTBeneficiaryService.config.quickTransferLimit = response.fundsTransfer.benAmountLimit;
						fTPaymentDetails_MobileVm.transferLimit = response.fundsTransfer.benAmountLimit;
					});
				}
				else fTPaymentDetails_MobileVm.transferLimit = fTBeneficiaryService.config.quickTransferLimit;
			});
			
			$scope.$on('$ionicView.loaded', function () {
				if(!getAccountDetailsService.accessRightsData.accounts) {
					getAccountDetailsService.getAccountsAccessRights('').then( function(data) {
						getAccountDetailsService.accessRightsData = data;
					}, function(error) {
						// Failure block
					});
				}
			});
		

		fTPaymentDetails_MobileVm.updateRemark =function(){
			fTPaymentDetails_MobileVm.remark=fTPaymentDetails_MobileVm.remarkOther;
			fTBeneficiaryService.remarkOther = fTPaymentDetails_MobileVm.remarkOther;
			fTBeneficiaryService.remarkPurpose = fTPaymentDetails_MobileVm.remarkPurpose;
			fTPaymentDetails_MobileVm.validateRemark();
		} 
			fTPaymentDetails_MobileVm.updatePurpose = function(){
				if(fTPaymentDetails_MobileVm.remarkPurpose=="Others"){					
					fTPaymentDetails_MobileVm.remark="";			
					fTPaymentDetails_MobileVm.validateRemark();
											
									
				}
				else{
					fTPaymentDetails_MobileVm.remarkOther="";
					fTPaymentDetails_MobileVm.remark=fTPaymentDetails_MobileVm.remarkPurpose;
					fTBeneficiaryService.remarkOther = "";
					fTBeneficiaryService.remarkPurpose = fTPaymentDetails_MobileVm.remarkPurpose;
					fTPaymentDetails_MobileVm.validateRemark();
				}
			}
			fTPaymentDetails_MobileVm.getFTPurposes = function(){
			
		
		
		
				fTBeneficiaryService.getFTPurposes().then(function(data){
			fTPaymentDetails_MobileVm.remarkPurposes=data.remarkPurposes;
			},function (error) {
			utilityService.showErrorMessage(error.responseMessage);
			}
			); 
			
		}


			
			return this;
		}
]);
