'use strict';

angularApp.controller('fTPaymentDetails_QRCodeController', [
	"$state",
	"$scope",
	"$ionicPopup",
	"fTBeneficiaryService",
	"closePopupService",
	"qrCodeService",

	function ($state,
		$scope,
		$ionicPopup,
		fTBeneficiaryService,
		closePopupService,
		qrCodeService) {

	var fTPaymentDetails_QRCodeVm = this;

	function initPage(){
		fTPaymentDetails_QRCodeVm.payingFrom = fTBeneficiaryService.payingFrom;
		fTBeneficiaryService.selectedItem = fTPaymentDetails_QRCodeVm.payingFrom[0];
		fTPaymentDetails_QRCodeVm.selectedAccountType = fTPaymentDetails_QRCodeVm.payingFrom[0].accountType;
		fTPaymentDetails_QRCodeVm.selectedAccountNumber = fTPaymentDetails_QRCodeVm.payingFrom[0].accountNo;
		fTPaymentDetails_QRCodeVm.selectedAccountAmount = fTPaymentDetails_QRCodeVm.payingFrom[0].balance;
		fTPaymentDetails_QRCodeVm.transAmount = fTBeneficiaryService.minAmount;
		fTPaymentDetails_QRCodeVm.disablePay = true;
	};

	fTPaymentDetails_QRCodeVm.accountPopup	= function(){
		$scope.data = {}
		fTPaymentDetails_QRCodeVm.myPopup = $ionicPopup.show({
			title:'Select Account',
			cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite textAlignCenter',
			template : '<div  ng-repeat="acc in fTPaymentDetails_QRCodeVm.payingFrom">'+
							'<div class="row" ng-click="fTPaymentDetails_QRCodeVm.selectedAccount(acc)" >'+
								'<div class = "  col-40">{{acc.accountType}}</div>'+
								'<div class = " col-40">{{acc.accountNo}}</div>'+
								'<div class = " col-20">&#8377;&nbsp;{{acc.balance | INR}}</div>'+
							'</div>'+
						'</div>',							
			scope: $scope
		});
		closePopupService.register(fTPaymentDetails_QRCodeVm.myPopup);
	};

	fTPaymentDetails_QRCodeVm.selectedAccount = function (e){
		fTPaymentDetails_QRCodeVm.myPopup.close();
		fTPaymentDetails_QRCodeVm.selectedAccountType = e.accountType;
		fTPaymentDetails_QRCodeVm.selectedAccountNumber = e.accountNo;
		fTPaymentDetails_QRCodeVm.selectedAccountAmount = e.balance;
		fTBeneficiaryService.selectedItem = e;
	};

	$scope.getRemark = function(){
		fTBeneficiaryService.customer.remarks = fTPaymentDetails_QRCodeVm.remark;
	};

	fTPaymentDetails_QRCodeVm.QrPopup = function() {
		var accNo = "";
		var vpa = fTPaymentDetails_QRCodeVm.payingTo.vpa;
		var amount = fTPaymentDetails_QRCodeVm.transAmount;
		var remark = fTPaymentDetails_QRCodeVm.remark;
		qrCodeService.resolveQRCode(accNo,vpa,amount,remark).then(function(data){
			try{
				fTPaymentDetails_QRCodeVm.balance = data.responseJSON.data.remainingBalance;
				fTPaymentDetails_QRCodeVm.successPopup = $ionicPopup.show({
					cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite textAlignCenter',
					templateUrl : 'pages/fundTransfer/fTPaymentDetails_QRCode/fTQrPopup.html',
					scope : $scope
				});
			}catch(e){}
		}, function(error){

		});	
	}; 

	fTPaymentDetails_QRCodeVm.goToSuccessPopup = function(){
		fTPaymentDetails_QRCodeVm.successPopup.close();
		$state.go('menu.fundsTransfer');
	};
	
	fTPaymentDetails_QRCodeVm.goToBack = function(){
		$state.go('menu.fTQRCode');
	};


	fTPaymentDetails_QRCodeVm.getRemark = function(isValid){
		fTPaymentDetails_QRCodeVm.disablePay = !(isValid);
		return fTPaymentDetails_QRCodeVm.disablePay;
	};

	$scope.goToHome = function(){
    	$state.go('menu.fundsTransfer');
    };

	$scope.$on('$ionicView.beforeEnter', function() {
		fTPaymentDetails_QRCodeVm.remark="";
		fTPaymentDetails_QRCodeVm.imgData = "img/FT/contacts.svg";
		fTPaymentDetails_QRCodeVm.nameData = fTBeneficiaryService.customer.nameData;
		fTPaymentDetails_QRCodeVm.vpa = fTBeneficiaryService.customer.vpa;
		fTPaymentDetails_QRCodeVm.payingTo=
		{name: "Apna Bazar", vpa: "apnabazar@icici"};
		initPage();
	});

	return this;
}]);