'use strict';
angularApp.controller('fTPaymentDetails_VPAController', [
	"$state",
	"$scope",
	"$ionicPopup",
	"fTBeneficiaryService",
	"closePopupService",
	"fTReviewService",
	"validationService",
	"utilityService",
	"$filter",
	"constantConfig",

	function($state,
		$scope, 
		$ionicPopup, 
		fTBeneficiaryService, 
		closePopupService, 
		fTReviewService, 
		validationService,
		utilityService,
		$filter,
		constantConfig) {

		var fTPaymentDetails_VPAVm = this;

		fTPaymentDetails_VPAVm.showAmountError = false;
		fTPaymentDetails_VPAVm.showRemarkError = false;
		fTPaymentDetails_VPAVm.showAmountMandatory = false;
		function initPage() {
			fTPaymentDetails_VPAVm.getUserProfile();
			fTPaymentDetails_VPAVm.selectedVpa = "";
			/* fTPaymentDetails_VPAVm.payingFrom = fTBeneficiaryService.payingFromVPA;
			fTBeneficiaryService.selectedItem = fTPaymentDetails_VPAVm.payingFrom[0];
			fTPaymentDetails_VPAVm.selectedAccountType = fTPaymentDetails_VPAVm.payingFrom[0].accountType;
			fTPaymentDetails_VPAVm.selectedAccountNumber = fTPaymentDetails_VPAVm.payingFrom[0].accountNo;
			fTPaymentDetails_VPAVm.selectedAccountAmount = fTPaymentDetails_VPAVm.payingFrom[0].balance; */
			//fTPaymentDetails_VPAVm.selectedAccountAmount = 0;
		};
		
		fTPaymentDetails_VPAVm.accountArray = [];
		fTPaymentDetails_VPAVm.getUserProfile = function(){
			fTPaymentDetails_VPAVm.accountArray = [];
			utilityService.showSpinner();
			var json = JSON.stringify({
				"recoveryOptionFlag":constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo":{
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"updateFlag":constantConfig.upiConstant.updateFlag
			});
			getNativeData(constantConfig.upiConstant.getProfile, function(data){
				utilityService.hideSpinner();
				var profileObj = JSON.parse(data);
				fTPaymentDetails_VPAVm.accountsListArr = [];
				for(var i = 0; i < profileObj.vpaAccountDetails.length; i++){
					for(var j = 0; j < profileObj.vpaAccountDetails[i].accountInfo.length; j++){
						profileObj.vpaAccountDetails[i].accountInfo[j]["virtualAddress"] = profileObj.vpaAccountDetails[i].virtualAddress;
						fTPaymentDetails_VPAVm.accountsListArr.push(profileObj.vpaAccountDetails[i].accountInfo[j]);
					}
				}
				fTPaymentDetails_VPAVm.accountArray = fTPaymentDetails_VPAVm.accountsListArr;
			}, function(msg){
				utilityService.hideSpinner();
				fTPaymentDetails_VPAVm.showVpaErrorMessage(msg);
			},json);
		};
		
		//Display error message if something wrong happened at server side.
		fTPaymentDetails_VPAVm.showVpaErrorMessage = function(errorCode){
			switch(errorCode){
				case -1 : utilityService.showErrorMessage(constantConfig.upiConstant.minusOne);
				break;
				
				case -2 : utilityService.showErrorMessage(constantConfig.upiConstant.minusTwo);
				break;
				
				case -3 : utilityService.showErrorMessage(constantConfig.upiConstant.minusThree);
				break;
				
				case -4 : utilityService.showErrorMessage(constantConfig.upiConstant.minusFour);
				break;
				
				case -5 : utilityService.showErrorMessage(constantConfig.upiConstant.minusFive);
				break;
				
				case -6 : utilityService.showErrorMessage(constantConfig.upiConstant.minusSix);
				break;
				
				case -7 : utilityService.showErrorMessage(constantConfig.upiConstant.minusSeven);
				break;
				
				default : utilityService.showErrorMessage(constantConfig.upiConstant.someWentWrong);
			}
		};
		
		fTPaymentDetails_VPAVm.getSelectedAccountFun = function(selectedAccDetails){
			if(selectedAccDetails !== ""){
				if(!utilityService.isEmpty(fTPaymentDetails_VPAVm.remark) && 
				fTPaymentDetails_VPAVm.transAmount){
					fTPaymentDetails_VPAVm.disablePay = false;
					fTBeneficiaryService.selectedAcc =  {
						accId : selectedAccDetails.split(',')[0],
						maskedAccNo : selectedAccDetails.split(',')[1], 
						virtualAddress : selectedAccDetails.split(',')[2],
						mpinFlag : selectedAccDetails.split(',')[3]
					}
				} else {
					fTPaymentDetails_VPAVm.disablePay = true;
				}
			} else {
				fTPaymentDetails_VPAVm.disablePay = true;
			}
		};

		fTPaymentDetails_VPAVm.validateRemark = function() {
			if (!utilityService.isEmpty(fTPaymentDetails_VPAVm.remark)) {
				fTPaymentDetails_VPAVm.showRemarkError = false;
				fTPaymentDetails_VPAVm.disablePayBtn();
				fTPaymentDetails_VPAVm.getSelectedAccountFun(fTPaymentDetails_VPAVm.selectedVpa);
			} else {
				fTPaymentDetails_VPAVm.showRemarkError = true;
				fTPaymentDetails_VPAVm.disablePayBtn();		
			}
		};
		
		fTPaymentDetails_VPAVm.validateAmount = function() {
			if(fTPaymentDetails_VPAVm.transAmount){
				if(fTPaymentDetails_VPAVm.transAmount >= 1){
					//switch(validationService.isValidAmount(fTPaymentDetails_VPAVm.selectedAccountAmount, fTPaymentDetails_VPAVm.transAmount,fTBeneficiaryService.maxAmountTansfer)){
					switch(validationService.isValidAmount(fTPaymentDetails_VPAVm.transAmount, fTPaymentDetails_VPAVm.transAmount,fTBeneficiaryService.maxAmountTansfer)){
					case 0 :
							fTPaymentDetails_VPAVm.showAmountError = false;
							fTPaymentDetails_VPAVm.showAmountMandatory = false;
							fTPaymentDetails_VPAVm.showAmountErrorMsg = "";
							fTPaymentDetails_VPAVm.disablePayBtn();
							break;
					case 1 :
							fTPaymentDetails_VPAVm.showAmountError = true;
							fTPaymentDetails_VPAVm.showAmountMandatory = false;
							fTPaymentDetails_VPAVm.showAmountErrorMsg = constantConfig.ft.validAmtTxt;
							fTPaymentDetails_VPAVm.disablePayBtn();
							break;
					case 2 :
							fTPaymentDetails_VPAVm.showAmountError = true;
							fTPaymentDetails_VPAVm.showAmountMandatory = false;
							fTPaymentDetails_VPAVm.showAmountErrorMsg = constantConfig.ft.inSuffAmt;
							fTPaymentDetails_VPAVm.disablePayBtn();
							break;
					default :
							fTPaymentDetails_VPAVm.showAmountError = true;
							fTPaymentDetails_VPAVm.showAmountMandatory = false;
							fTPaymentDetails_VPAVm.showAmountErrorMsg = constantConfig.ft.excMaxAmt;
							fTPaymentDetails_VPAVm.disablePayBtn();
							break;
					}
				} else {
					fTPaymentDetails_VPAVm.showAmountError = true;
					fTPaymentDetails_VPAVm.showAmountMandatory = false;
					fTPaymentDetails_VPAVm.showAmountErrorMsg = constantConfig.ft.amtGrtThanZero;
					fTPaymentDetails_VPAVm.disablePayBtn();
					fTPaymentDetails_VPAVm.getSelectedAccountFun(fTPaymentDetails_VPAVm.selectedVpa);
				}
			}
			else {
				fTPaymentDetails_VPAVm.showAmountError = false;
				fTPaymentDetails_VPAVm.showAmountMandatory = true;
				fTPaymentDetails_VPAVm.disablePay = true;
			}
		}; 
		
		fTPaymentDetails_VPAVm.disablePayBtn = function() {
			if (!fTPaymentDetails_VPAVm.showAmountError &&  !fTPaymentDetails_VPAVm.showAmountMandatory && 
			!utilityService.isEmpty(fTPaymentDetails_VPAVm.remark) && 
			fTPaymentDetails_VPAVm.selectedVpa !== "") {
				fTPaymentDetails_VPAVm.disablePay = false;
			} else {
				fTPaymentDetails_VPAVm.disablePay = true;
			}

			if(fTPaymentDetails_VPAVm.disablePay && fTPaymentDetails_VPAVm.transAmount &&  fTPaymentDetails_VPAVm.showAmountErrorMsg.length >=1){
				var maxLength = 0; 
				var ftTransAmount = document.getElementById("ftTransAmount");
				maxLength = $filter('INR')(fTPaymentDetails_VPAVm.maxAmountTansfer,'',2);
				ftTransAmount ? ftTransAmount.setAttribute("maxlength",maxLength.length):'';
			}
		};
		
		fTPaymentDetails_VPAVm.accountPopup = function() {
			$scope.data = {};
			fTPaymentDetails_VPAVm.myPopup = $ionicPopup.show({
				cssClass : 'ftpopup-body popupWidth90 popupMargin font-dark-grey roboto-light font-content popupBackgroundWhite removePopup-head',
				template : '<div > <div class="row popupList removeRowPadding textAlignCenter roboto-regular bg-color-grey" ><div class = "col removeColPadding" translate="SELECT_ACCOUNT"></div></div>'+ 
				 				'<div ng-repeat="acc in fTPaymentDetails_VPAVm.payingFrom" class="popupList-borderBottom" >' + 
									'<div class="row popupList popupList-padding" style="width:100%;" ng-click="fTPaymentDetails_VPAVm.selectedAccount(acc)" >'+
					 		           '<div class = "col-33 removeColPadding">{{acc.accountType}}</div>' + 
										'<div class = "col-33 removeColPadding">{{acc.accountNo}}</div>' + 
										'<div class = "col-33 removeColPadding">&#8377;{{acc.balance | INR}}</div>' + 
									'</div>' + 
								'</div>' + 
							'</div>',
				scope : $scope
			});
			closePopupService.register(fTPaymentDetails_VPAVm.myPopup);
		};
		
		/* fTPaymentDetails_VPAVm.selectedAccount = function(e) {
			fTPaymentDetails_VPAVm.myPopup.close();
			fTPaymentDetails_VPAVm.selectedAccountType = e.accountType;
			fTPaymentDetails_VPAVm.selectedAccountNumber = e.accountNo;
			fTPaymentDetails_VPAVm.selectedAccountAmount = e.balance;
			fTBeneficiaryService.selectedItem = e;
			fTPaymentDetails_VPAVm.validateAmount();
		}; */
		
		$scope.goToHome = function() {
			$state.go('menu.fundsTransfer');
		};
		
		fTPaymentDetails_VPAVm.goToBack = function() {
			if (fTBeneficiaryService.qrflag)
				$state.go('menu.fTQRCode')
			else{
				fTBeneficiaryService.savedFlag = true;
				$state.go('menu.fTNewBeneficiary_VPA');
			}
		};
		
		fTPaymentDetails_VPAVm.goToPay = function() {
			fTBeneficiaryService.customer.nameData = fTPaymentDetails_VPAVm.payingTo.name;
			fTBeneficiaryService.customer.transAmount = parseFloat(fTPaymentDetails_VPAVm.transAmount.replace(",",""));
			fTBeneficiaryService.customer.accountTypeData = fTPaymentDetails_VPAVm.payingTo.accType;
			fTBeneficiaryService.customer.vpa = fTPaymentDetails_VPAVm.payingTo.vpa;
			fTBeneficiaryService.customer.remarks = fTPaymentDetails_VPAVm.remark;
			fTBeneficiaryService.customer.imgData = fTPaymentDetails_VPAVm.imgData;
			
			if(fTBeneficiaryService.selectedAcc.mpinFlag == 'Y'){
				$state.go('menu.fTReviewDetails_VPA');
			} else {
				$state.go('menu.fTSetUpiPin');
			}
		};

		$scope.$on('$ionicView.beforeEnter', function() {
			fTPaymentDetails_VPAVm.remark = fTBeneficiaryService.customer.remarks;
			fTPaymentDetails_VPAVm.transAmount = $filter('INR')(fTBeneficiaryService.customer.transAmount);
			if(fTPaymentDetails_VPAVm.transAmount)
				fTPaymentDetails_VPAVm.validateAmount();
			//fTPaymentDetails_VPAVm.validateRemark();
			fTPaymentDetails_VPAVm.showAmountError = false;
			fTPaymentDetails_VPAVm.showRemarkError = false;
			if(!fTBeneficiaryService.savedImg)
				fTPaymentDetails_VPAVm.imgData = fTBeneficiaryService.customer.conImg;
			else
				fTPaymentDetails_VPAVm.imgData = fTBeneficiaryService.savedImg;
			
			if (fTBeneficiaryService.customer.nameData)
				fTPaymentDetails_VPAVm.nameData = fTBeneficiaryService.customer.nameData;
			else
				fTPaymentDetails_VPAVm.nameData = "";
			
			if (fTBeneficiaryService.customer.vpa)
				fTPaymentDetails_VPAVm.vpa = fTBeneficiaryService.customer.vpa; 
			else
				fTPaymentDetails_VPAVm.vpa = "";
			fTPaymentDetails_VPAVm.accType = "VPA";
			fTPaymentDetails_VPAVm.payingTo = {
				img : fTPaymentDetails_VPAVm.imgData,
				name : fTPaymentDetails_VPAVm.nameData,
				accType : fTPaymentDetails_VPAVm.accType,
				vpa : fTPaymentDetails_VPAVm.vpa
			};
			initPage();
		});

		return this;
	}
]);
