'use strict';

angularApp.controller('fTReviewDetails_AccountController', [
	"$state",
	"$scope",
	"$rootScope",
	"$ionicPopup",
	"fTNewBeneficiaryService",
	"fTReviewService",
	"fTBeneficiaryService",
	"utilityService",
	"fTSetOTPService","customerInfoService","getAccountDetailsService","constantConfig","cryptoService", "autoOtpReadService",

	function ($state,
		$scope,
		$rootScope,
		$ionicPopup,
		fTNewBeneficiaryService,
		fTReviewService,
		fTBeneficiaryService,
		utilityService,
		fTSetOTPService,customerInfoService,getAccountDetailsService,constantConfig,cryptoService, autoOtpReadService) {

		var fTReviewDetails_AccountVm = this;
		//fTReviewDetails_AccountVm.checkTnC = true;

		$scope.isOTP = false;
		fTReviewDetails_AccountVm.clearFlag = false;
		fTReviewDetails_AccountVm.isValidOtp = true;
		fTReviewDetails_AccountVm.otp = '';
        fTReviewDetails_AccountVm.disableNext = false;
		//call OTP screen
		fTReviewDetails_AccountVm.sendOTP = function () {
			fTReviewDetails_AccountVm.otp = "";
			fTReviewDetails_AccountVm.generateOTP();
		};

		//Validate OTP
		fTReviewDetails_AccountVm.validateOTP = function () {
			fTReviewDetails_AccountVm.disableNext = true;
			var reqParams = {};
			reqParams["otp"] = fTReviewDetails_AccountVm.otp;
			reqParams["mobile"] = customerInfoService.customer.mobile;
				
			fTSetOTPService.validateOTP(reqParams).then(function (data) {
					
				if (data.status.toLowerCase() === 'success') {
					var timeStamp = Math.floor(Date.now() / 1000);
					fTReviewDetails_AccountVm.SuccessPopup(timeStamp);
				}
				else {
					fTReviewDetails_AccountVm.otp = '';
					fTReviewDetails_AccountVm.clearFlag = true;
					fTReviewDetails_AccountVm.isValidOtp = false;
					fTReviewDetails_AccountVm.disableNext = false;
					utilityService.showErrorMessage(data.status);
				}
			}, function (error) {
				fTReviewDetails_AccountVm.disableNext = false;
				utilityService.showErrorMessage(error.responseMessage);
			});
		};

		//Reset OTP text field
		fTReviewDetails_AccountVm.resetOtpField = function () {

		};

		fTReviewDetails_AccountVm.generateOTPOnce = function () {

			fTReviewDetails_AccountVm.isDisabledOTP++;
			fTReviewDetails_AccountVm.generateOTP();
		};

		//Generate OTP
		fTReviewDetails_AccountVm.generateOTP = function () {
			var reqParams = {};
			reqParams["id"] = customerInfoService.customer.mobile;
			reqParams.otpCode = constantConfig.keysForOTP.ftNormalFundTransfer;
			reqParams.ocHash = cryptoService.getSHA512EncryptedData(constantConfig.keysForOTP.ftNormalFundTransfer).toString();
			$scope.isOTP = true;
			fTSetOTPService.generateOTP(reqParams).then(function (data) {
				// if (utilityService.isAndroidPlatform()) {
				// 	autoOtpReadService.startOtpReading().then(function (result) {
				// 		fTReviewDetails_AccountVm.otp = result;
				// 	}, function (error) {
				// 		console.log(error);
				// 	});
				// }
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		};

		//close OTP screen
		fTReviewDetails_AccountVm.closeViewOTP = function () {
			$scope.isOTP = false;
		};

		fTReviewDetails_AccountVm.SuccessPopup = function (timeStamp) {
			var remName = customerInfoService.customer.name ? customerInfoService.customer.name : "";
			var remAdd1 = customerInfoService.customer.address ? customerInfoService.customer.address : "";
		
			var branchCodeFromAcc = fTBeneficiaryService.selectedDetails.branchCode ? fTBeneficiaryService.selectedDetails.branchCode : "";
			fTNewBeneficiaryService.addBeneficiary(fTBeneficiaryService.customer, fTReviewDetails_AccountVm.payingFrom.accountNo, fTReviewDetails_AccountVm.payingTo.name,
				fTReviewDetails_AccountVm.amount, fTReviewDetails_AccountVm.charges, fTReviewDetails_AccountVm.remarks,
				timeStamp, fTReviewDetails_AccountVm.checkTnC, branchCodeFromAcc, remName, remAdd1, fTReviewDetails_AccountVm.benBranchCode, fTReviewDetails_AccountVm.benBranchName, fTReviewDetails_AccountVm.benAccntCat).then(function (data) {
					try {
						if (data.responseCode == "00") {
							fTReviewDetails_AccountVm.balance = utilityService.getValue(data.balance);
							fTReviewDetails_AccountVm.successPopup = $ionicPopup.show({
								title: '',
								cssClass: 'popupWidth90 popupMargin ftpopup-body popupBackgroundWhite removePopup-head textAlignCenter',
								templateUrl: 'pages/fundTransfer/fTReviewDetails_Account/fTSuccessPopup.html',
								scope: $scope
							});
							fTBeneficiaryService.beneficiaries = undefined;
						} else {
							var error = data.errorLog || 'Error';
							fTBeneficiaryService.showErrorModal('', null, 'menu.fundsTransfer', $scope, $state, error);
						}
					}
					catch (e) {
					}
				}, function (error) {
					fTBeneficiaryService.showErrorModal('', null, 'menu.fundsTransfer', $scope, $state, error.responseMessage);
				});
		};

		fTReviewDetails_AccountVm.goToBack = function () {
			$state.go('menu.fTPaymentDetails_Account');
		};

		fTReviewDetails_AccountVm.goToSuccessPopup = function () {
			getAccountDetailsService.accountOverviewData = "";
			fTReviewDetails_AccountVm.successPopup.close();
			fTBeneficiaryService.schTransItems = "";
			fTBeneficiaryService.beneficiaries = undefined;
			getAccountDetailsService.accountOverviewData = '';
			
			fTBeneficiaryService.remarkPurpose="";
			fTBeneficiaryService.remarkOther="";


				$state.go("menu.fundsTransfer")
			};
		fTReviewDetails_AccountVm.maskEmail = function (str) {
		 return str[0] + "X".repeat(str.length - 2) + str.slice(-1);
		}
		fTReviewDetails_AccountVm.maskEmail2 = function (str) {
	 	return str[0] + "X".repeat(str.length - 1) ;
		}
		fTReviewDetails_AccountVm.maskcustEmail=function(email){
			 var arr = email.split("@");
			 //var arr2=arr[1].split(".");
			var firstDotIndex = arr[1].indexOf('.');
 			var emailFirstPart = arr[1].substring(0, firstDotIndex);
 			var emailSecondPart = arr[1].substring(firstDotIndex + 1);
			 fTReviewDetails_AccountVm.maskedEmailID=fTReviewDetails_AccountVm.maskEmail2(arr[0]) + "@" + fTReviewDetails_AccountVm.maskEmail(emailFirstPart)+"."+emailSecondPart;
		 }

		//this function is define to call terms and conditions service
		$scope.openTC = function (type) {
			var reqParams = {
				"type": type
			}
			fTBeneficiaryService.getTermsCondition(reqParams).then(
				function (data) {
					$scope.termsConditions = data;
					$state.go('menu.ftTerms', { obj: $scope.termsConditions });
				},
				function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				}
			);
		};

		$scope.goToHome = function () {
			$state.go('menu.fundsTransfer');
		};

		$scope.$on('$ionicView.beforeEnter', function () {
			fTReviewDetails_AccountVm.imgData = fTBeneficiaryService.customer.imgData;
			fTReviewDetails_AccountVm.payingTo = {
				img: fTReviewDetails_AccountVm.imgData,
				name: fTBeneficiaryService.customer.nameData,
				nickName: fTBeneficiaryService.customer.nickName,
				bank: fTBeneficiaryService.customer.bankData,
				accountNo: fTBeneficiaryService.customer.accountNoData,
				intraBankFlag: fTBeneficiaryService.customer.intraBankFlag
			};
			if (fTReviewService.tncChannel == 'INTRABANK') {
				fTReviewDetails_AccountVm.tncType = 'GRPT';
			} else {
				fTReviewDetails_AccountVm.tncType = fTReviewService.tncChannel.slice(0, 4)
			}
			fTReviewDetails_AccountVm.payingFrom = fTBeneficiaryService.selectedDetails;
			fTReviewDetails_AccountVm.charges = fTReviewService.transactionFee;
			fTReviewDetails_AccountVm.benBranchCode = fTReviewService.benBranchCode;
			fTReviewDetails_AccountVm.benBranchName = fTReviewService.benBranchName;
			fTReviewDetails_AccountVm.benAccntCat = fTReviewService.benAccntCat;
			fTReviewDetails_AccountVm.amount = fTBeneficiaryService.customer.transAmount.toString();
			fTReviewDetails_AccountVm.displayAmount = fTBeneficiaryService.customer.transAmount.toFixed(2);
			fTReviewDetails_AccountVm.remarks = fTBeneficiaryService.customer.remarks;
			fTReviewDetails_AccountVm.loggedInUserMobNo = $rootScope.mobileNo;  //fTBeneficiaryService.customer.mobileNo;
			fTReviewDetails_AccountVm.emailID = $rootScope.customerInfoForProfile.emailID;
					 if(fTReviewDetails_AccountVm.emailID!="" &&fTReviewDetails_AccountVm.emailID!=undefined){
					 fTReviewDetails_AccountVm.maskcustEmail(fTReviewDetails_AccountVm.emailID);
			}
			fTReviewDetails_AccountVm.isDisabledOTP = 0;

			if (fTReviewDetails_AccountVm.payingTo.intraBankFlag) {
				if (fTReviewDetails_AccountVm.payingTo.intraBankFlag.toUpperCase() == 'N') {
					fTReviewDetails_AccountVm.showTnC = true;
					fTReviewDetails_AccountVm.checkTnC = false;
				} else {
					fTReviewDetails_AccountVm.showTnC = false;
					fTReviewDetails_AccountVm.checkTnC = true;
				}
			} else {
				fTReviewDetails_AccountVm.showTnC = true;
				fTReviewDetails_AccountVm.checkTnC = false;
			}
			});
			fTReviewDetails_AccountVm.goToSchedulePopup =function(){
				fTReviewDetails_AccountVm.txnMessage = "";
				fTReviewDetails_AccountVm.schedulePopup.close(); 
	
				fTBeneficiaryService.remarkPurpose="";
				fTBeneficiaryService.remarkOther="";
	
			   $state.go('menu.fundsTransfer');
			}
			return this;
		}
]);
