'use strict';

angularApp.controller('fTReviewDetails_MobileController', [
	"$state",
	"$scope",
	"$rootScope",
	"$ionicPopup",
	"fTNewBeneficiary_MobileService",
	"fTReviewService",
	"fTBeneficiaryService",
	"utilityService",
	"fTSetOTPService","customerInfoService","getAccountDetailsService","cryptoService","constantConfig", "autoOtpReadService",

	function ($state,
		$scope,
		$rootScope,
		$ionicPopup,
		fTNewBeneficiary_MobileService,
		fTReviewService,
		fTBeneficiaryService,
		utilityService,
		fTSetOTPService,customerInfoService,getAccountDetailsService,cryptoService,constantConfig, autoOtpReadService) {

		var fTReviewDetails_MobileVm = this;
		fTReviewDetails_MobileVm.clearFlag = false;
		fTReviewDetails_MobileVm.isValidOtp = true;
		fTReviewDetails_MobileVm.otp = '';
		//fTReviewDetails_MobileVm.checkTnC = true;
		$scope.isOTP = false;
		fTReviewDetails_MobileVm.disableNext = false;

		//call OTP screen
		fTReviewDetails_MobileVm.sendOTP = function () {
			fTReviewDetails_MobileVm.otp = "";
			fTReviewDetails_MobileVm.generateOTP();
		}

		//Validate OTP
		fTReviewDetails_MobileVm.validateOTP = function () {
			fTReviewDetails_MobileVm.disableNext = true;
			var reqParams = {};
			reqParams["otp"] = fTReviewDetails_MobileVm.otp;
			reqParams["mobile"] = customerInfoService.customer.mobile;
			fTSetOTPService.validateOTP(reqParams).then(function (data) {
				if (data.status.toLowerCase() === 'success') {
					var timeStamp = Math.floor(Date.now() / 1000);
					fTReviewDetails_MobileVm.SuccessPopup(timeStamp);
				} else {
					fTReviewDetails_MobileVm.otp = '';
					fTReviewDetails_MobileVm.clearFlag = true;
					fTReviewDetails_MobileVm.isValidOtp = false;
					fTReviewDetails_MobileVm.disableNext = false;
					utilityService.showErrorMessage(data.status);
				}
			}, function (error) {
				fTReviewDetails_MobileVm.disableNext = false;
				utilityService.showErrorMessage(error.responseMessage);
			});
		}

		//Reset OTP text field
			fTReviewDetails_MobileVm.resetOtpField = function(){}

		fTReviewDetails_MobileVm.generateOTPOnce = function () {
			fTReviewDetails_MobileVm.isDisabledOTP++;
			fTReviewDetails_MobileVm.generateOTP();
		};

		//Generate OTP
		fTReviewDetails_MobileVm.generateOTP = function () {
			var reqParams = {};
			reqParams["id"] = customerInfoService.customer.mobile;
			reqParams.otpCode = constantConfig.keysForOTP.ftScheduleFundTransfer;
			reqParams.ocHash = cryptoService.getSHA512EncryptedData(constantConfig.keysForOTP.ftScheduleFundTransfer).toString();
			$scope.isOTP = true;
			fTSetOTPService.generateOTP(reqParams).then(function (data) {
				// if (utilityService.isAndroidPlatform()) {
				// 	autoOtpReadService.startOtpReading().then(function (result) {
				// 		fTReviewDetails_MobileVm.otp = result;
				// 	}, function (error) {
				// 		console.log(error);
				// 	});
				// }
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		}

		//close OTP screen
		fTReviewDetails_MobileVm.closeViewOTP = function () {
			$scope.isOTP = false;
		}

		fTReviewDetails_MobileVm.SuccessPopup = function (timeStamp) {
			var branchCodeFromAcc = fTBeneficiaryService.selectedDetails.branchCode ? fTBeneficiaryService.selectedDetails.branchCode : "";
			var remName = customerInfoService.customer.name ? customerInfoService.customer.name : "";
			var remAdd1 = customerInfoService.customer.address ? customerInfoService.customer.address : "";

			fTNewBeneficiary_MobileService.addBeneficiary(fTBeneficiaryService.customer,
				fTReviewDetails_MobileVm.payingFrom.accountNo, fTReviewDetails_MobileVm.payingTo.name, fTReviewDetails_MobileVm.amount, fTReviewDetails_MobileVm.charges,
				fTReviewDetails_MobileVm.remarks, timeStamp, fTBeneficiaryService.customer.remMMID,
				fTReviewDetails_MobileVm.checkTnC, branchCodeFromAcc, remName, remAdd1, fTReviewDetails_MobileVm.benBranchCode, fTReviewDetails_MobileVm.benBranchName, fTReviewDetails_MobileVm.benAccntCat).then(function (data) {
					try {
						if (data.data.responseCode == "00") {
							fTReviewDetails_MobileVm.balance = data.data.balance;
							fTReviewDetails_MobileVm.successPopup = $ionicPopup.show({
								title: '',
								cssClass: 'popupWidth90 popupMargin ftpopup-body popupBackgroundWhite removePopup-head textAlignCenter',
								templateUrl: 'pages/fundTransfer/fTReviewDetails_Mobile/fTSuccessPopup.html',
								scope: $scope
							});
							fTBeneficiaryService.beneficiaries = undefined;
						} else {
							var error = data.data.errorLog || 'Error';
							fTBeneficiaryService.showErrorModal('', null, 'menu.fundsTransfer', $scope, $state, error);
						}
					} catch (e) { }
				}, function (error) {
					fTBeneficiaryService.showErrorModal('', null, 'menu.fundsTransfer', $scope, $state, error.responseMessage);
				});
		};
			fTReviewDetails_MobileVm.goToBack = function() {
				$state.go('menu.fTPaymentDetails_Mobile');
			}
			fTReviewDetails_MobileVm.goToSuccessPopup = function() {
				getAccountDetailsService.accountOverviewData="";
				fTReviewDetails_MobileVm.successPopup.close();
				fTBeneficiaryService.schTransItems = "";
				fTBeneficiaryService.beneficiaries = undefined;
				getAccountDetailsService.accountOverviewData = '';
				
				fTBeneficiaryService.remarkPurpose="";
				fTBeneficiaryService.remarkOther="";
				
			   
				$state.go("menu.fundsTransfer")
			}

			//this function is define to call terms and conditions service
			$scope.openTC = function(type){
				var reqParams = {
				  "type": type
				}
				fTBeneficiaryService.getTermsCondition(reqParams).then(
					function(data) {
						$scope.termsConditions = data;
						$state.go('menu.ftTerms',{obj:$scope.termsConditions});
					},
					function(error) {
						utilityService.showErrorMessage(error.responseMessage);
					}
				);
			}
			
			$scope.goToHome = function() {
				$state.go('menu.fundsTransfer');
			};
		fTReviewDetails_MobileVm.maskEmail = function (str) {
		 return str[0] + "X".repeat(str.length - 2) + str.slice(-1);
		}
		fTReviewDetails_MobileVm.maskEmail2 = function (str) {
		return str[0] + "X".repeat(str.length - 1) ;
		}
		fTReviewDetails_MobileVm.maskcustEmail=function(email){
			 var arr = email.split("@");
			//var arr2=arr[1].split(".");
			var firstDotIndex = arr[1].indexOf('.');
			var emailFirstPart = arr[1].substring(0, firstDotIndex);
			var emailSecondPart = arr[1].substring(firstDotIndex + 1);
			fTReviewDetails_MobileVm.maskedEmailID=fTReviewDetails_MobileVm.maskEmail2(arr[0]) + "@" + fTReviewDetails_MobileVm.maskEmail(emailFirstPart)+"."+emailSecondPart;
		}

		$scope.$on('$ionicView.beforeEnter', function () {
			if (fTReviewService.tncChannel == 'INTRABANK') {
				fTReviewDetails_MobileVm.tncType = 'GRPT';
			} else {
				fTReviewDetails_MobileVm.tncType = fTReviewService.tncChannel.slice(0, 4)
			}
			fTReviewDetails_MobileVm.imgData = fTBeneficiaryService.customer.imgData;
			fTReviewDetails_MobileVm.payingTo = {
				img: fTReviewDetails_MobileVm.imgData,
				name: fTBeneficiaryService.customer.nameData,
				nickName: fTBeneficiaryService.customer.nickName,
				mmid: fTBeneficiaryService.customer.mmid,
				mobile: fTBeneficiaryService.customer.mobileNo,
				accountNo: fTBeneficiaryService.customer.accountNoData,
				intraBankFlag: fTBeneficiaryService.customer.intraBankFlag
			};
			fTReviewDetails_MobileVm.charges = fTReviewService.transactionFee;
			fTReviewDetails_MobileVm.benBranchCode = fTReviewService.benBranchCode;
			fTReviewDetails_MobileVm.benBranchName = fTReviewService.benBranchName;
			fTReviewDetails_MobileVm.benAccntCat = fTReviewService.benAccntCat;
			fTReviewDetails_MobileVm.payingFrom = fTBeneficiaryService.selectedDetails;
			fTReviewDetails_MobileVm.amount = fTBeneficiaryService.customer.transAmount.toFixed(2);
			fTReviewDetails_MobileVm.remarks = fTBeneficiaryService.customer.remarks;
			fTReviewDetails_MobileVm.remMMID = fTBeneficiaryService.customer.remMMID;
			fTReviewDetails_MobileVm.loggedInUserMobNo = $rootScope.mobileNo; //fTBeneficiaryService.customer.mobileNo;
			fTReviewDetails_MobileVm.isDisabledOTP = 0;
			fTReviewDetails_MobileVm.emailID = $rootScope.customerInfoForProfile.emailID;
					 if(fTReviewDetails_MobileVm.emailID!="" &&fTReviewDetails_MobileVm.emailID!=undefined){
					 fTReviewDetails_MobileVm.maskcustEmail(fTReviewDetails_MobileVm.emailID);
			}
			if (fTReviewDetails_MobileVm.payingTo.intraBankFlag) {
				if (fTReviewDetails_MobileVm.payingTo.intraBankFlag.toUpperCase() == 'N') {
					fTReviewDetails_MobileVm.showTnC = true;
					fTReviewDetails_MobileVm.checkTnC = false;
				} else {
					fTReviewDetails_MobileVm.showTnC = false;
					fTReviewDetails_MobileVm.checkTnC = true;
				}
			} else {
				fTReviewDetails_MobileVm.showTnC = true;
				fTReviewDetails_MobileVm.checkTnC = false;
			}
			});
			fTReviewDetails_MobileVm.goToSchedulePopup = function(){
				fTReviewDetails_MobileVm.txnMessage = "";
				fTReviewDetails_MobileVm.schedulePopup.close();
			 
			 fTBeneficiaryService.remarkPurpose="";
			 fTBeneficiaryService.remarkOther="";
		  
			$state.go('menu.fundsTransfer');
			}
			return this;
		}
]);
