'use strict';

angularApp.controller('fTReviewDetails_VPAController', [
	"$state",
	"$scope",
	"$ionicPopup",
	"fTNewBeneficiary_VPAService",
	"fTBeneficiaryService",
	"fTReviewService",
	"utilityService",
	"fTSetOTPService",
	"loggedInUserService",
	"customerInfoService", 
	"$rootScope",
	"constantConfig",
	"fTReviewDetails_VPAService",
	"getAccountDetailsService",

	function ($state,
		$scope,
		$ionicPopup,
		fTNewBeneficiary_VPAService,
		fTBeneficiaryService,
		fTReviewService,
		utilityService,
		fTSetOTPService,
		loggedInUserService,
		customerInfoService, 
		$rootScope, 
		constantConfig,
		fTReviewDetails_VPAService,
		getAccountDetailsService) {

		var fTReviewDetails_VPAVm = this;
		//fTReviewDetails_VPAVm.checkTnC = true;
		
		fTReviewDetails_VPAVm.SuccessPopup = function() {
			utilityService.showSpinner();
			var json = JSON.stringify({  
			   "addInfo":{  
				  "addInfo10":constantConfig.upiConstant.addInfo10,
				  "addInfo9":constantConfig.upiConstant.addInfo9
			   },
			   "amount":fTReviewDetails_VPAVm.amount,
			   "expiryTime":0,
			   "payeeType":{  
				  "name":fTReviewDetails_VPAVm.payingTo.name,
				  "virtualAddress":fTReviewDetails_VPAVm.payingTo.vpa,
				  "vpaType":constantConfig.upiConstant.vpaType
			   },
			   "payerType":{  
				  "accountId":fTBeneficiaryService.selectedAcc.accId,
				  "virtualAddress":fTBeneficiaryService.selectedAcc.virtualAddress
			   },
			   "requestInfo":{  
				  "pspId":constantConfig.upiConstant.pspId,
				  "pspRefNo":generateRandomString(27)
			   },
			   "transactionNote":fTReviewDetails_VPAVm.remarks || "",
			   "upiTransRefNo":0
			});
			getNativeData(constantConfig.upiConstant.onPayInitiation, function(data){
				fTReviewDetails_VPAVm.paymentResponse = data;
				var auditDataInput = JSON.parse(fTReviewDetails_VPAVm.paymentResponse).apiResp
				var jsonObj = {
					service : "FundsTransfer",
					amount : auditDataInput.amount,
					payeeVPA : auditDataInput.payeeVPA,
					payerVPA : auditDataInput.payerVPA,
					transactionRefNo : auditDataInput.custRefNo,
					npciTransId : auditDataInput.npciTransId,
					status : auditDataInput.status
				};
				var reqParams = {};
				reqParams["auditData"] = JSON.stringify(jsonObj);
				fTReviewDetails_VPAService.getAuditLogs(reqParams).then(function(data){
						fTReviewDetails_VPAVm.displayPaymentResp(fTReviewDetails_VPAVm.paymentResponse);
					}, function(error){
						fTReviewDetails_VPAVm.displayPaymentResp(fTReviewDetails_VPAVm.paymentResponse);
				});
			}, function(msg){
				utilityService.hideSpinner();
				fTReviewDetails_VPAVm.showVpaErrorMessage(msg);
			},json);		
		};
		
		fTReviewDetails_VPAVm.displayPaymentResp = function(data){
			utilityService.hideSpinner();
			fTReviewDetails_VPAVm.balance = utilityService.getValue(data.balance);
			if(JSON.parse(data).apiResp.status === 'S'){
				utilityService.setCsatJournies("fundTransfer");
				fTReviewDetails_VPAVm.successPopup = $ionicPopup.show({
					title : '',
					cssClass : 'popupWidth90 popupMargin ftpopup-body popupBackgroundWhite removePopup-head textAlignCenter',
					templateUrl : 'pages/fundTransfer/fTReviewDetails_VPA/fTSuccessPopup.html',
					scope : $scope
				});
				fTBeneficiaryService.beneficiaries = undefined;
			} else if(JSON.parse(data).apiResp.status === 'F'){
				if(JSON.parse(data).apiResp.responseCode){
					fTReviewDetails_VPAVm.showPaymentFailureMessage(JSON.parse(data).apiResp.responseCode);
				}else {
					utilityService.showErrorMessage(JSON.parse(data).apiResp.statusDesc);
				}
			} else {
				utilityService.showErrorMessage(JSON.parse(data).apiResp.statusDesc);
			}
		};
		
		fTReviewDetails_VPAVm.goToBack = function() {
			$state.go('menu.fTPaymentDetails_VPA');
		};
		
		fTReviewDetails_VPAVm.goToSuccessPopup = function() {
			fTReviewDetails_VPAVm.successPopup.close();
			fTBeneficiaryService.schTransItems = "";
			fTBeneficiaryService.beneficiaries = undefined;
			getAccountDetailsService.accountOverviewData = '';
			$state.go('menu.fundsTransfer');
		};

		//this function is define to call terms and conditions service
		$scope.openTC = function(type){
			var reqParams = {
			  "type": type
			}
			fTBeneficiaryService.getTermsCondition(reqParams).then(
				function(data) {
					$scope.termsConditions = data;
					$state.go('menu.ftTerms',{obj:$scope.termsConditions});
				},
				function(error) {
					utilityService.showErrorMessage(error.responseMessage);
				}
			);
		};
		
		//Display error message if something wrong happened at server side.
		fTReviewDetails_VPAVm.showVpaErrorMessage = function(errorCode){
			switch(errorCode){
				case -1 : utilityService.showErrorMessage(constantConfig.upiConstant.minusOne);
				break;
				
				case -2 : utilityService.showErrorMessage(constantConfig.upiConstant.minusTwo);
				break;
				
				case -3 : utilityService.showErrorMessage(constantConfig.upiConstant.minusThree);
				break;
				
				case -4 : utilityService.showErrorMessage(constantConfig.upiConstant.minusFour);
				break;
				
				case -5 : utilityService.showErrorMessage(constantConfig.upiConstant.minusFive);
				break;
				
				case -6 : utilityService.showErrorMessage(constantConfig.upiConstant.minusSix);
				break;
				
				case -7 : utilityService.showErrorMessage(constantConfig.upiConstant.minusSeven);
				break;
				
				default : utilityService.showErrorMessage(constantConfig.upiConstant.someWentWrong);
			}
		}
		
		fTReviewDetails_VPAVm.showPaymentFailureMessage = function(errorCode) {
			switch (errorCode) {
				case "ND":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ND);
				break;
				
				case "NC":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_NC);
				break;
				
				case "Z0":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_Z0);
					break;
					
				case "AM":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_AM);
					break;
				
				case "ZG":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZG);
					break;
				
				case "ZI":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZI);
					break;

				case "ZJ":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZJ);
					break;
		
				case "ZK":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZK);
					break;

				case "ZL":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZL);
					break;
					
				case "ZU":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZU);
					break;

				case "ZN":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZN);
					break;
					
				case "ZO":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZO);
					break;

				case "ZP":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZP);
					break;
					
				case "ZQ":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZQ);
					break;

				case "ZX":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZX);
					break;

				case "ZY":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZY);
					break;
				
				case "XB":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XB);
					break;
				
				case "XC":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XC);
					break;
				
				case "XD":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XD);
					break;
				
				case "XE":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XE);
					break;
				
				case "XF":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XF);
					break;
				
				case "XG":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XG);
					break;
				
				case "XH":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XH);
					break;
				
				case "XI":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XI);
					break;
				
				case "XJ":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XJ);
					break;
				
				case "XK":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XK);
					break;
				
				case "XP":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XP);
					break;
					
				
				case "XQ":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XQ);
					break;
				
				case "XT":utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XT);
					break;
				
				case "XU":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XU);
					break;
				
				case "XV":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XV);
					break;
				
				case "XW":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XW);
					break;
				
				case "XX":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XX);
					break;
				
				case "XY":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XY);
					break;
							
				
				case "XZ":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_XZ);
					break;
				
				case "YC":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_YC);
					break;
				
				case "YD":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_YD);
					break;
				
				case "YE":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_YE);
					break;
				
				case "YF":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_YF);
					break;
				
				case "YG":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_YG);
					break;
				
				case "YH":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_YH);
					break;
								
				
				case "YI":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_YI);
					break;
				
				case "U08":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_U08);
					break;
				
				case "U31":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_U31);
					break;
							
				
				case "U30":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_U30);
					break;
				
				case "U67":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_U67);
					break;
				
				case "U68":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_U68);
					break;
							
				
				case "U69":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_U69);
					break;
				
				case "U70":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_U70);
					break;
				
				case "ZA":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZA);
					break;
							
				case "ZB":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZB);
					break;
					
				case "Z9":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_Z9);
					break;
					
				case "K1":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_K1);
					break;
					
				case "Z8":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_Z8);
					break;
					
				case "Z7":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_Z7);
					break;
					
				case "Z6":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_Z6);
					break;
					
				case "ZC":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZC);
					break;
					
				case "UA":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_UA);
					break;
					
				case "UP":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_UP);
					break;
					
				case "UT":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_UT);
					break;
					
				case "ZM":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZM);
					break;
					
				case "ZD":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZD);
					break;
					
				case "ZE":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZE);
					break;
					
				case "ZF":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_ZF);
					break;
					
				case "U66":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_U66);
					break;
					
				case "Z5":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_Z5);
					break;
					
				case "32":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_32);
					break;
					
				case "21":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_21);
					break;
					
				case "00":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_00);
					break;
					
				case "14":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_14);
					break;
					
				case "15":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_15);
					break;
					
				case "17":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_17);
					break;
					
				case "63":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_63);
					break;
					
				case "68":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_68);
					break;
					
				case "94":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_94);
					break;
					
				case "96":
					utilityService.showErrorMessage(constantConfig.upiConstant.paymentFail_96);
					break;
					
				default:
					utilityService.showErrorMessage(constantConfig.upiConstant.someWentWrong);
			}
		};

		$scope.goToHome = function() {
			$state.go('menu.fundsTransfer');
		};
		
		$scope.$on('$ionicView.beforeEnter', function() {
			fTReviewDetails_VPAVm.imgData = fTBeneficiaryService.customer.imgData;
			fTReviewDetails_VPAVm.payingTo = {
				img : fTReviewDetails_VPAVm.imgData,
				name : fTBeneficiaryService.customer.nameData,
				accType : fTBeneficiaryService.customer.accountTypeData,
				vpa : fTBeneficiaryService.customer.vpa
			};
			fTReviewDetails_VPAVm.charges = "0.00";//fTReviewService.transactionFee;
			fTReviewDetails_VPAVm.payingFromAcc = fTBeneficiaryService.selectedItem;
			fTReviewDetails_VPAVm.payingFrom = fTBeneficiaryService.selectedAcc;
			fTReviewDetails_VPAVm.amount = fTBeneficiaryService.customer.transAmount;
			fTReviewDetails_VPAVm.remarks = fTBeneficiaryService.customer.remarks;
			fTReviewDetails_VPAVm.isDisabledOTP = false;
		});
		
		return this;
	}
]);
