'use strict';

angularApp.controller('fTScheduleReviewController', [
	"$state",
	"$scope",
	"$ionicPopup",
	"fTReviewService",
	"fTScheduleReviewService",
	"fTBeneficiaryService",
	"utilityService",
	"constantConfig",

	function ($state,
			$scope,
			$ionicPopup,
			fTReviewService,
			fTScheduleReviewService,
			fTBeneficiaryService,
			utilityService,
			constantConfig) {

			var fTScheduleReviewVm = this;
			var showPopup = function() {
				fTScheduleReviewVm.fTSchedulePopup = $ionicPopup.show({
					title : '',
					cssClass : 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
					templateUrl : 'pages/fundTransfer/fTScheduleReview/fTSchedulePopup.html',
					scope : $scope
				});
			};
			
			fTScheduleReviewVm.SuccessPopup = function() {
				fTScheduleReviewService.updateSchedulePayment(fTBeneficiaryService.customer).then(function(response) {
					try{
					showPopup();
						}
						catch(e){
						}
				}, function(error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			};
			
			fTScheduleReviewVm.goToBack = function() {
				$state.go('menu.fTEditScheduleDetails');
			}
			
			fTScheduleReviewVm.goToNext = function() {
				fTScheduleReviewVm.fTSchedulePopup.close();
				fTBeneficiaryService.customer.scheduleDate = "";
				$state.go("menu.fundsTransfer")
			}
			
			$scope.goToHome = function() {
				$state.go('menu.fundsTransfer');
			}
			
			$scope.$on('$ionicView.beforeEnter', function() {
				fTScheduleReviewVm.imgData = fTBeneficiaryService.customer.conImg;
				fTScheduleReviewVm.payingTo = {
					img : fTScheduleReviewVm.imgData,
					name : fTBeneficiaryService.customer.nameData,
					bank : fTBeneficiaryService.customer.bankData,
					accountNo : fTBeneficiaryService.customer.accountNoData
				};
				fTScheduleReviewVm.payingFrom = {
					img : fTBeneficiaryService.customer.sbiLogo,
					name : fTBeneficiaryService.customer.sAccountType,
					accountNo : fTBeneficiaryService.customer.sAccountNo
				};
				fTScheduleReviewVm.amount = fTBeneficiaryService.customer.transAmount.toFixed(2);
				fTScheduleReviewVm.date = fTBeneficiaryService.customer.scheduleDate;
				fTScheduleReviewVm.remarks = fTBeneficiaryService.customer.remarks;
				fTScheduleReviewVm.charges = fTReviewService.transactionFee;
			});
			
			return this;
		}
]);
