/**
*   @ngdoc config
*   @name angularApp.config : ftConfig
*   @description
*	configuration file for funds transfer module
*/

'use strict';

/*State defination with respective names, urls, controllers and templates */
angularApp.config(['$stateProvider',
	function ($stateProvider) {
		//Fund Transfer start
		$stateProvider
			.state('menu.fundsTransferLanding', {
				url: '/fundsTransfer',
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/fundTransfer/fundsTransfer/fundsTransferLanding.html',
						controller: 'fundsTransferLandingController',
						controllerAs: 'fundsTransferLandingVm',
					}
				}
			})
			.state('menu.fundsTransfer', {
				url: '/fundsTransfer',
				data: {
					pageId: 'FT_HOM'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/fundTransfer/fundsTransfer/fundsTransfer.html',
						controller: 'fundsTransferController',
						controllerAs: 'fundsTransferVm',
					}
				}
			})
			.state('menu.ftProfilePassword', {
				url: '/ftProfilePassword',
				data: {
					pageId: 'FT_PRFPWD'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/fundTransfer/fundsTransfer/ftProfilePassword.html',
						controller: 'fundsTransferController',
						controllerAs: 'fundsTransferVm',
					}
				}
			})
			.state('menu.fTPaymentDetails', {
				url: '/fTPaymentDetails',
				data: {
					pageId: 'FT_PYMTDETL'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/fundTransfer/fTPaymentDetails/fTPaymentDetails.html',
						controller: 'fTPaymentDetailsController',
						controllerAs: 'fTPaymentDetailsVm',
					}
				}
			})
			.state('menu.review', {
				url: '/review',
				data: {
					pageId: 'FT_RVW'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/fundTransfer/review/review.html',
						controller: 'reviewController',
						controllerAs: 'reviewVm',
					}
				}
			})
			.state('menu.ftEditBeneficiaryOtp', {
				url: '/ftEditBeneficiaryOtp',
				data: {
					pageId: 'FT_EDITBNFYOTP'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/fundTransfer/fTEditBeneficiary/ftEditBeneficiaryOtp.html',
						controller: 'fTEditBeneficiaryOtpController',
						controllerAs: 'fTEditBeneficiaryOtpVm',
					}
				}
			})
			.state('menu.fTHowToPayTheBeneficiary', {
				url: '/fTHowToPayTheBeneficiary',
				data: {
					pageId: 'FT_HWPAYBNFY'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/fundTransfer/fTHowToPayTheBeneficiary/fTHowToPayTheBeneficiary.html',
						controller: 'fTHowToPayTheBeneficiaryController',
						controllerAs: 'fTHowToPayTheBeneficiaryVm',
					}
				}
			})
			.state('menu.fTSetUpiPin', {
				url: '/fTSetUpiPin',
				data: {
					pageId: 'FT_SETUPIPIN'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/fundTransfer/fTHowToPayTheBeneficiary/fTSetUpiPin.html',
						controller: 'fTHowToPayTheBeneficiaryController',
						controllerAs: 'fTHowToPayTheBeneficiaryVm',
					}
				}
			})
			.state('menu.fTNewBeneficiary', {
				url: '/fTNewBeneficiary',
				data: {
					pageId: 'FT_NEWBNFY'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/fundTransfer/fTNewBeneficiary/fTNewBeneficiary.html',
						controller: 'fTNewBeneficiaryController',
						controllerAs: 'fTNewBeneficiaryVm',
					}
				}
			})
			.state('menu.fTPaymentDetails_Account', {
				url: '/fTPaymentDetails_Account',
				data: {
					pageId: 'FT_PYMTDETLACCT'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/fundTransfer/fTPaymentDetails_Account/fTPaymentDetails_Account.html',
						controller: 'fTPaymentDetails_AccountController',
						controllerAs: 'fTPaymentDetails_AccountVm',
					}
				}
			})
			.state('menu.fTReviewDetails_Account', {
				url: '/fTReviewDetails_Account',
				data: {
					pageId: 'FT_RVWDETLACCT'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/fundTransfer/fTReviewDetails_Account/fTReviewDetails_Account.html',
						controller: 'fTReviewDetails_AccountController',
						controllerAs: 'fTReviewDetails_AccountVm',
					}
				}
			})
			.state('menu.fTNewBeneficiary_Mobile', {
				url: '/fTNewBeneficiary_Mobile',
				data: {
					pageId: 'FT_NEWBNFYMOB'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/fundTransfer/fTNewBeneficiary_Mobile/fTNewBeneficiary_Mobile.html',
						controller: 'fTNewBeneficiary_MobileController',
						controllerAs: 'fTNewBeneficiary_MobileVm',
					}
				}
			})
			.state('menu.fTPaymentDetails_Mobile', {
				url: '/fTPaymentDetails_Mobile',
				data: {
					pageId: 'FT_PYMTDETLMOB'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/fundTransfer/fTPaymentDetails_Mobile/fTPaymentDetails_Mobile.html',
						controller: 'fTPaymentDetails_MobileController',
						controllerAs: 'fTPaymentDetails_MobileVm',
					}
				}
			})
			.state('menu.fTReviewDetails_Mobile', {
				url: '/fTReviewDetails_Mobile',
				data: {
					pageId: 'FT_RVWDETLMOB'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/fundTransfer/fTReviewDetails_Mobile/fTReviewDetails_Mobile.html',
						controller: 'fTReviewDetails_MobileController',
						controllerAs: 'fTReviewDetails_MobileVm',
					}
				}
			})
			.state('menu.fTNewBeneficiary_VPA', {
				url: '/fTNewBeneficiary_VPA',
				data: {
					pageId: 'FT_NEWBNFYVPA'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/fundTransfer/fTNewBeneficiary_VPA/fTNewBeneficiary_VPA.html',
						controller: 'fTNewBeneficiary_VPAController',
						controllerAs: 'fTNewBeneficiary_VPAVm',
					}
				}
			})
			.state('menu.fTPaymentDetails_VPA', {
				url: '/fTPaymentDetails_VPA',
				data: {
					pageId: 'FT_PYMTDETLVPA'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/fundTransfer/fTPaymentDetails_VPA/fTPaymentDetails_VPA.html',
						controller: 'fTPaymentDetails_VPAController',
						controllerAs: 'fTPaymentDetails_VPAVm',
					}
				}
			})
			.state('menu.fTReviewDetails_VPA', {
				url: '/fTReviewDetails_VPA',
				data: {
					pageId: 'FT_RVWDETLVPA'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/fundTransfer/fTReviewDetails_VPA/fTReviewDetails_VPA.html',
						controller: 'fTReviewDetails_VPAController',
						controllerAs: 'fTReviewDetails_VPAVm',
					}
				}
			})
			.state('menu.fTQRCode', {
				url: '/fTQRCode',
				data: {
					pageId: 'FT_QRCOD'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/fundTransfer/fTQRCode/fTQRCode.html',
						controller: 'fTQRCodeController',
						controllerAs: 'fTQRCodeVm',
					}
				}
			})
			.state('menu.fTEditScheduleDetails', {
				url: '/fTEditScheduleDetails',
				data: {
					pageId: 'FT_EDTSCHDETL'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/fundTransfer/fTEditScheduleDetails/fTEditScheduleDetails.html',
						controller: 'fTEditScheduleDetailsController',
						controllerAs: 'fTEditScheduleDetailsVm',
					}
				}
			})
			.state('menu.fTEditBeneficiary', {
				url: '/fTEditBeneficiary',
				data: {
					pageId: 'FT_EDTBNFY'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/fundTransfer/fTEditBeneficiary/fTEditBeneficiary.html',
						controller: 'fTEditBeneficiaryController',
						controllerAs: 'fTEditBeneficiaryVm',
					}
				}
			})
			.state('menu.ftEditProfilePassword', {
				url: '/ftEditProfilePassword',
				data: {
					pageId: 'FT_EDTBNFYPROPWD'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/fundTransfer/fTEditBeneficiary/ftEditProfilePassword.html',
						controller: 'fTEditBeneficiaryController',
						controllerAs: 'fTEditBeneficiaryVm',
					}
				}
			})
			.state('menu.fTScheduleReview', {
				url: '/fTScheduleReview',
				data: {
					pageId: 'FT_SCHRVW'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/fundTransfer/fTScheduleReview/fTScheduleReview.html',
						controller: 'fTScheduleReviewController',
						controllerAs: 'fTScheduleReviewVm',
					}
				}
			})
			.state('menu.ftTerms', {
				url: '/ftTerms',
				cache: false,
				data: {
					pageId: 'FT_TERMS'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/fundTransfer/termsConditions/terms.html',
						controller: 'ftTermsController',
						controllerAs: 'ftTermsVm',
					}
				},
				params: { 'obj': null }
			})
			.state('menu.upiPay', {
				url: '/upiPay',
				data: {
					pageId: 'FT_UPIPAY'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/fundTransfer/ftUpiPay/upiPay.html',
						controller: 'upiPayController',
						controllerAs: 'upiPayVm'
					}
				}
			})
			.state('menu.vpaPopup', {
				url: '/vpaPopup',
				data: {
					pageId: 'FT_UPIVPAUNAVLPOPUP'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/fundTransfer/fTHowToPayTheBeneficiary/fTVPAPopup.html',
						controller: 'upiPayController',
						controllerAs: 'upiPayVm'
					}
				}
			})
			/* Goc HYD Code for Search IFSC by bank and branch start */
			.state('menu.fTNBSearchIFSCbybankAndBranch', {
				url: '/fTNBSearchIFSCbybankAndBranch',
				data: {
					pageId: 'FT_NEWBNFY_IFSC_SEARCH_BY_BANK'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/fundTransfer/fTNewBeneficiary/fTNBSearchIFSCbybankAndBranch.html',
						controller: 'fTNewBeneficiaryController',
						controllerAs: 'fTNewBeneficiaryVm',
					}
				}
			})
			/* Goc HYD Code for Search IFSC by bank and branch ENd*/
	}]);