'use strict';

angularApp.controller('upiPayController', [
    "$state",
    "$scope",
    "$ionicPopup",
    "$ionicHistory",
    "constantConfig",
    "utilityService",
    "$rootScope",
    "$stateParams",
    "fTBeneficiaryService",

    function($state,
        $scope,
        $ionicPopup,$ionicHistory, constantConfig, utilityService, $rootScope, $stateParams, fTBeneficiaryService) {

        var upiPayVm = this;

        /* Selecting a payment option */
        upiPayVm.selectedOption = function(option) {
            if (option === 'vpa')
                upiPayVm.option = "vpa";
            else if (option === 'qrcode')
                upiPayVm.option = "qrcode";
            else
                upiPayVm.option = "bqr";
            upiPayVm.enableNext = true;
        };

        upiPayVm.goToNext = function() {
            if (upiPayVm.option == "qrcode") {
                $state.go('menu.fTQRCode');
            }
            if (upiPayVm.option == "vpa") {
                utilityService.showSpinner();
                var jsonForPermission = JSON.stringify({});
                getNativeData(constantConfig.upiConstant.getpermission, function(data) {
                    utilityService.hideSpinner();
                    if (data.permission === 'Allowed') {
                        utilityService.showSpinner();
                        var json = JSON.stringify({
                            "addInfo": {
                                "addInfo10": constantConfig.upiConstant.addInfo10,
                                "addInfo9": constantConfig.upiConstant.addInfo9
                            },
                            "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                            "requestInfo": {
                                "pspId": constantConfig.upiConstant.pspId,
                                "pspRefNo": generateRandomString(27)
                            },
                            "updateFlag": constantConfig.upiConstant.updateFlag
                        });
                        getNativeData(constantConfig.upiConstant.checkDevice, function(data) {
                            $rootScope.checkDeviceInfo = JSON.parse(data);
                            utilityService.hideSpinner();
                            if (JSON.parse(data).userInfo) {
                                fTBeneficiaryService.customer.nameData = "";
                                fTBeneficiaryService.customer.vpa = "";
                                fTBeneficiaryService.customer.nickName = "";
                                fTBeneficiaryService.customer.mobileNo = "";
                                fTBeneficiaryService.customer.remarks = "";
                                $state.go("menu.fTNewBeneficiary_VPA");
                            } else {
                                upiPayVm.VPAPopup();
                            }
                        }, function(msg) {
                            utilityService.hideSpinner();
                            upiPayVm.showVpaErrorMessage(msg);
                        }, json);

                    } else {
                        utilityService.hideSpinner();
                        utilityService.showErrorMessage("UPI registration requires permission to use camera, SMS and Phone calls. Please allow these permissions. If problem persists re-initiate UPI registration.");
                    }
                }, function(msg) {
                    utilityService.hideSpinner();
                    upiPayVm.showVpaErrorMessage(msg);
                }, jsonForPermission);
            }
        };

        /* Open VPA Popup */
		upiPayVm.VPAPopup = function() {
			upiPayVm.myPopup = $ionicPopup.show({
				title : '',
				cssClass : 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
				templateUrl : 'pages/fundTransfer/fTHowToPayTheBeneficiary/fTVPAPopup.html',
				scope : $scope
			});
        };
        
        upiPayVm.goToNewBeneficiary_VPA = function(){
            upiPayVm.myPopup.close();
            $state.go("menu.settings");
        };

        upiPayVm.goToBack = function(){
            upiPayVm.myPopup.close();
        };

        $scope.goToHome = function() {
            //$state.go('menu.fundsTransfer');
            $ionicHistory.goBack();
        };

        upiPayVm.showVpaErrorMessage = function(errorCode) {
            switch (errorCode) {
                case -1:
                    utilityService.showErrorMessage(constantConfig.upiConstant.minusOne);
                    break;

                case -2:
                    utilityService.showErrorMessage(constantConfig.upiConstant.minusTwo);
                    break;

                case -3:
                    utilityService.showErrorMessage(constantConfig.upiConstant.minusThree);
                    break;

                case -4:
                    utilityService.showErrorMessage(constantConfig.upiConstant.minusFour);
                    break;

                case -5:
                    utilityService.showErrorMessage(constantConfig.upiConstant.minusFive);
                    break;

                case -6:
                    utilityService.showErrorMessage(constantConfig.upiConstant.minusSix);
                    break;

                case -7:
                    utilityService.showErrorMessage(constantConfig.upiConstant.minusSeven);
                    break;

                default:
                    utilityService.showErrorMessage(constantConfig.upiConstant.someWentWrong);
            }
        };

        $scope.$on('$ionicView.beforeEnter', function() {
            upiPayVm.option = "";
            upiPayVm.enableNext = false;
        });

        return this;
    }
]);
