'use strict';

angularApp.controller('fundsTransferLandingController', [
    "$state",
    "$q",
    "$scope",
    "$translate",
    "fTBeneficiaryService",
    "cancelScheduledPaymentService",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService",
    "constantConfig",
    "AdapterUtils",
    "$ionicScrollDelegate",
    "fTReviewService",
    "ionicToast",
    "loggedInUserService",
    "cryptoService",
    "getAccountDetailsService",
    "customerInfoService",
    "homeScreenService",
    "$rootScope",
    "billDeskService",
    "applyNowService",
    "personalLoanService",
    "sampoornSurakshaService",
    "bhimUpiService",
    "cardsService",
    "lifeInsuranceBasicApplicationService",
    "requestYCService",
    "$ionicSideMenuDelegate",
    "$filter",

    function ($state,
        $q,
        $scope,
        $translate,
        fTBeneficiaryService,
        cancelScheduledPaymentService,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        constantConfig,
        AdapterUtils,
        $ionicScrollDelegate,
        fTReviewService, ionicToast,
        loggedInUserService, cryptoService,
        getAccountDetailsService,
        customerInfoService,
        homeScreenService,
        $rootScope,
        billDeskService,
        applyNowService,	
        personalLoanService,
        sampoornSurakshaService,
        bhimUpiService,
        cardsService,
        lifeInsuranceBasicApplicationService,
        requestYCService,
        $ionicSideMenuDelegate,
        $filter) {

        var fundsTransferLandingVm = this;
        fundsTransferLandingVm.isTextReadable = false;
        fundsTransferLandingVm.isTextReadablereEnter = false;
        fundsTransferLandingVm.offersData = [];
        fundsTransferLandingVm.fastTagflag=loggedInUserService.fastTagFlag;

        /**
         * toggle Selected Transfer Type
         */
        $scope.toggleGroup = function (accountType, account) {
            if (account) {
                if ((account.ownAccount == 'Y') && ((account.isActive === false || account.isTransactional === false ||
                    (account.status == "")))) {
                    return true;
                }
            }
            if ($scope.isGroupShown(accountType)) {
                $scope.shownGroup = null;
            } else {
                $scope.shownGroup = accountType;
            }
            if ($scope.shownGroup === constantConfig.ft.ftText) {
                var listType = fundsTransferLandingVm.freqTransItems;
                fundsTransferLandingVm.selectedAcctype = fundsTransferLandingVm.freqTransItems;

            } else if ($scope.shownGroup === constantConfig.ft.otherAccText) {
                fundsTransferLandingVm.selectedAcctype = fundsTransferLandingVm.otherAccItems;

            } else if ($scope.shownGroup === constantConfig.ft.scheduledTracsfText) {
                fundsTransferLandingVm.selectedAcctype = fundsTransferLandingVm.schTransItems;

            } else if ($scope.shownGroup === constantConfig.ft.ownAccText) {
                fundsTransferLandingVm.selectedAcctype = fundsTransferLandingVm.ownAccItems;
            } else {
                fundsTransferLandingVm.selectedAcctype = null;
            }
        };

        /**
         * show the Select transfer type
         */
        $scope.isGroupShown = function (accountType) {
            return ($scope.shownGroup === accountType);
        };


        //Function for close view
        fundsTransferLandingVm.closeView = function () {
            $state.go('menu.homeScreen');
        }

        fundsTransferLandingVm.closeProfilePwdView = function () {
            $state.go('menu.fundsTransfer');
        }

        fundsTransferLandingVm.goToBack = function () {
            fundsTransferLandingVm.cancelPopupName.close();
            $state.go('menu.fundsTransfer');
        };
        fundsTransferLandingVm.goToPrevious = function () {
            //$ionicHistory.goBack();
            $state.go('menu.homeScreen');
        };
        fundsTransferLandingVm.goTofasTag = function () {
            
            $state.go('menu.fasTagLanding');
        };
        fundsTransferLandingVm.goToHome = function () {
            if (homeScreenService.ishamMenu === true) {
                //$state.go("menu.homeScreen");
                $ionicHistory.goBack();
                homeScreenService.ishamMenu = false;
            } else {
                $state.go('menu.fundsTransferLanding');
            }
        }

        /* Navigate to QRCode Page */
        fundsTransferLandingVm.goToUpiPay = function () {
            if (device.platform.toLowerCase() == 'android') {
                $state.go('menu.upiPay');
            } else if (device.platform.toLowerCase() == 'windows') {
                ionicToast.show("The functionality is not available in windows currently.", 'bottom', false, 3000);
            } else {
                //ionicToast.show("The functionality is not available in iOS currently.", 'bottom', false, 3000);
                var comingsoonPopup = $ionicPopup.alert({
                    template: '<div class="CSPadding font-dark-grey "><div class="parentCS"><img class="imgwidthCS" src="img/Coming_Soon_Illustration.svg"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="childCS">'
                    + "Coming Soon" + '</div></div></div></div></div></div>',
                    cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter custButtonCS button0pd',
                    buttons: [
                        {
                            text: 'OK',
                            type: 'button-positive',
                            onTap: function (e) {
                                comingsoonPopup.close();
                                $state.go("menu.fundsTransferLanding");
                            }
                        }
                    ]
                });
            }
        };

        /* Navigate to New Beneficiary Page */
        fundsTransferLandingVm.goToNewBeneficiary = function () {
            // var accOverviewData = getAccountDetailsService.accountOverviewData;
            //     var profPassObj = {
            //     prevPage: "menu.fundsTransferLanding",
            //     nextPage: "menu.ftProfilePassword",
            //     goto: "menu.setProfilePassword",
            //     ionicPopup: $ionicPopup,
            //     accOverviewData: accOverviewData
            // };
            //     getAccountDetailsService.commonfunForProfilePassCheck(profPassObj);
            //$state.go('menu.ftProfilePassword');
            if (getAccountDetailsService.accountOverviewData) {
                $state.go('menu.quickTransferLanding');
             }
            else {
                var errorData = "Something went wrong. Please try again after sometime.";
                utilityService.showNfsAlertModal("", errorData, "menu.homeScreen", $scope, $state, "OK");
            }
        };
        fundsTransferLandingVm.goToBankAccount = function () {
            homeScreenService.ishamburgerMenuFT = false;
            if (homeScreenService.isCustCalled == true) {
                var pleaseWaitPopUp = $ionicPopup.show({
                    title: null,
                    cssClass: 'my-custom-popup',
                    template: '<div class="button_fund fontSize-subHeading roboto-light font-dark-grey" translate="PLEASE_WAIT"></div>',
                    buttons: [{
                        text: 'OK',
                        type: 'button-assertive'
                    }]
                });
            } else {
                $state.go('menu.fundsTransfer');
            }
        }
        fundsTransferLandingVm.goToQRScan = function () {
            if (device.platform.toLowerCase() == 'android') {
                $state.go('menu.fTQRCode');
            } else if (device.platform.toLowerCase() == 'windows') {
                ionicToast.show("The functionality is not available in windows currently.", 'bottom', false, 3000);
            } else {
                var comingsoonPopup = $ionicPopup.alert({
                    template: '<div class="CSPadding font-dark-grey "><div class="parentCS"><img class="imgwidthCS" src="img/Coming_Soon_Illustration.svg"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="childCS">'
                    + "Coming Soon" + '</div></div></div></div></div></div>',
                    cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter custButtonCS button0pd',
                    buttons: [
                        {
                            text: 'OK',
                            type: 'button-positive',
                            onTap: function (e) {
                                comingsoonPopup.close();
                                $state.go("menu.fundsTransferLanding");
                            }
                        }
                    ]
                });
            }
        };

        fundsTransferLandingVm.goToCreditCardPay = function () {
            fTBeneficiaryService.isCreditCardFlag = true;
            getAccountDetailsService.tabIndex.tabIndex = 5;
            $state.go('menu.accountOverviewMyBalance');
        };
        fundsTransferLandingVm.goToBillPay = function () {
            billDeskService.billDeskToken();
        };

        fundsTransferLandingVm.goToComingSoon = function () {

            var comingsoonPopup = $ionicPopup.alert({
                template: '<div class="CSPadding font-dark-grey "><div class="parentCS"><img class="imgwidthCS" src="img/Coming_Soon_Illustration.svg"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="childCS">'
                + "Coming Soon" + '</div></div></div></div></div></div>',
                cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter custButtonCS button0pd',
                buttons: [
                    {
                        text: 'OK',
                        type: 'button-positive',
                        onTap: function (e) {
                            comingsoonPopup.close();
                            $state.go("menu.fundsTransferLanding");
                        }
                    }
                ]
            });
            // utilityService.showErrorMessage(selectedObj.message);
        };

        fundsTransferLandingVm.validateProfilePwd = function () {
            var loggedInUserDetails = loggedInUserService.getUserProfileDetails();
            if (fundsTransferLandingVm.newProfilePassword) {
                fTReviewService.getProfilePassAndSerKey().then(function (response) {
                    var options = {
                        inbUserName: loggedInUserDetails.inbUsername,
                        strPass: fundsTransferLandingVm.newProfilePassword,
                        keyId: response.keyId,
                        serviceId: response.serviceId,
                        osName: device.platform
                    };
                    var reqParams = utilityService.commonRequestForValidateProfilePass(options);
                    fTReviewService.getProfilePassAuth(reqParams).then(function (data) {
                        $state.go('menu.fTHowToPayTheBeneficiary');
                    }, function (error) {
                        //utilityService.showErrorMessage(error.responseMessage);
                        if (error.responseCode == "INB.AUTH.016") {
                            fundsTransferLandingVm.myPopup = $ionicPopup.show({
                                title: '',
                                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
                                templateUrl: 'pages/fundTransfer/fundsTransfer/profilePassUnblockPopUp.html',
                                scope: $scope
                            })
                        } else {
                            utilityService.showErrorMessage(error.responseMessage);
                        }
                    });
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else {
                utilityService.showErrorMessage('Please enter your Internet Banking Profile Password.')
            }
        };

        fundsTransferLandingVm.redirectToBharatQr = function (payType) {
            utilityService.showSpinner();
            if (!localStorage.getItem("appGenId")) {
                bhimUpiService.getNativeData("generateAppGenId", {}).then(function (data) {
                    if (device.platform.toLowerCase() == 'android') {
                        bhimUpiService.appGenId = data.appGenId;
                    } else {
                        bhimUpiService.appGenId = data;
                    }
                    fundsTransferLandingVm.redirectToBharatQrFlow(payType);
                }, function (msg) {
                    utilityService.hideSpinner();
                    utilityService.showBhimUpiAlert("error", msg);
                });
            } else {
                bhimUpiService.getNativeData("setAppGenId", localStorage.getItem("appGenId")).then(function (data) {
                    fundsTransferLandingVm.redirectToBharatQrFlow(payType);
                }, function (msg) {
                    utilityService.hideSpinner();
                    utilityService.showBhimUpiAlert("error", msg);
                });
            }
            // } else {
            //     var comingsoonPopup = $ionicPopup.alert({
            //         template: '<div class="CSPadding font-dark-grey "><div class="parentCS"><img class="imgwidthCS" src="img/Coming_Soon_Illustration.svg"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="childCS">'
            //         + 'Coming Soon</div></div></div></div></div></div>',
            //         cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter custButtonCS button0pd',
            //         buttons: [
            //             {
            //                 text: 'OK',
            //                 type: 'button-positive',
            //                 onTap: function (e) {
            //                     comingsoonPopup.close();
            //                 }
            //             }
            //         ]
            //     });
            // }
        }

        fundsTransferLandingVm.redirectToBharatQrFlow = function (payType) {
            if (device.platform.toLowerCase() == 'android') {
                utilityService.showSpinner();
                var json = JSON.stringify({});
                bhimUpiService.getNativeData(constantConfig.upiConstant.getpermission, json).then(function (data) {
                    if (data.permission === 'Allowed') {
                        fundsTransferLandingVm.redirectToBharatQRJourney(payType);
                    } else {
                        utilityService.hideSpinner();
                        utilityService.showBhimUpiAlert("alert", "UPI registration requires permission to use camera, SMS and Phone calls. Please allow these permissions. If problem persists re-initiate UPI registration.");
                    }
                }, function (msg) {
                    utilityService.hideSpinner();
                    utilityService.showBhimUpiAlert("error", msg);
                });
            } else if (device.platform.toLowerCase() == 'windows') {
                ionicToast.show("The functionality is not available in windows currently.", 'bottom', false, 3000);
            } else {
                utilityService.showSpinner();
                var json = JSON.stringify({
                    "pspId": constantConfig.upiConstant.pspId,
                    "encryptionKey": loggedInUserService.upiPermissionKey.split("^")[2]
                });
                bhimUpiService.getNativeData("initializeIOSsdk", json).then(function (data) {
                    if (data !== "S") {
                        utilityService.hideSpinner();
                        utilityService.showBhimUpiAlert("error", data);
                        return false;
                    }
                    utilityService.showSpinner();
                    var json = JSON.stringify({
                        "addInfo": {
                            "addInfo10": constantConfig.upiConstant.addInfo10,
                            "addInfo9": constantConfig.upiConstant.addInfo9
                        },
                        "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                        "requestInfo": {
                            "pspId": constantConfig.upiConstant.pspId,
                            "pspRefNo": generateRandomString(27)
                        },
                        "updateFlag": constantConfig.upiConstant.updateFlag,
                        "smsSent": "false"
                    });
                    bhimUpiService.getNativeData(constantConfig.upiConstant.checkDevice, json).then(function (data) {
                        $rootScope.checkDeviceInfo = JSON.parse(data);
                        utilityService.hideSpinner();
                        if ($rootScope.checkDeviceInfo.status == 'S') {
                            if ($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNN') {
                                utilityService.showBhimUpiAlert("alert", "Looks like you do not have a UPI profile to make payments. Please register UPI for making further transactions", "menu.createNewVpa");
                            } else if ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNM') {
                                if (payType) {
                                    bhimUpiService.getNativeData("openContacts", {}).then(function (data) {
                                        var contact = data;

                                        if (contact) {
                                            var x = contact.replace(/\s/g, '');
                                            if (x.length >= 10) {
                                                fundsTransferLandingVm.vpa = x.substr(x.length - 10) + "@sbi";
                                            } else {
                                                return false;
                                                utilityService.showBhimUpiAlert("alert", 'Please select valid mobile number');
                                            }
                                        } else {
                                            return false;
                                            utilityService.showBhimUpiAlert("alert", 'Please select valid mobile number');
                                        }

                                        customerInfoService.payeeDetails = {
                                            payeeType: "VA",
                                            requestType: 'pay',
                                            accountNo: "",
                                            ifsc: "",
                                            name: "",
                                            vpa: fundsTransferLandingVm.vpa || "",
                                            amount: "",
                                            remark: "",
                                            nickName: "",
                                            phoneNumber: "",
                                            savePayee: false
                                        }
                                        $state.go('menu.payToVpa');
                                    }, function (msg) {
                                        utilityService.hideSpinner();
                                        utilityService.showBhimUpiAlert("error", msg);
                                    });
                                } else {
                                    customerInfoService.scanQrEntrypoint = 'FTLANDING';
                                    customerInfoService.payerDetails = {};
                                    customerInfoService.payeeDetails = {};
                                    $state.go('menu.payToQR');
                                }
                            } else if (($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNM') || ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNN')) {
                                utilityService.showBhimUpiAlert("alert", "Looks like you have changed Device/Sim. Please register UPI for making further transactions", "menu.vpaOptions");
                            }
                        } else {
                            utilityService.showBhimUpiAlert("error", $rootScope.checkDeviceInfo.statusDesc);
                        }
                    }, function (msg) {
                        utilityService.hideSpinner();
                        utilityService.showBhimUpiAlert("error", msg);
                    });
                }, function (msg) {
                    utilityService.hideSpinner();
                    utilityService.showBhimUpiAlert("error", msg);
                });
            }
        }

        fundsTransferLandingVm.redirectToBharatQRJourney = function (payType) {
            /*Sim card Info fetching - Start*/
            var simInfosuccessCallback = function (result) {
                if (result !== undefined && result != null && result != '') {
                    if (result.cards && result.cards.length > 0) {
                        customerInfoService.simCardInfo = result;
                        utilityService.showSpinner();
                        var json = JSON.stringify({
                            "addInfo": {
                                "addInfo10": constantConfig.upiConstant.addInfo10,
                                "addInfo9": constantConfig.upiConstant.addInfo9
                            },
                            "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                            "requestInfo": {
                                "pspId": constantConfig.upiConstant.pspId,
                                "pspRefNo": generateRandomString(27)
                            },
                            "updateFlag": constantConfig.upiConstant.updateFlag,
                            "smsSent": false
                        });
                        bhimUpiService.getNativeData(constantConfig.upiConstant.checkDevice, json).then(function (data) {
                            $rootScope.checkDeviceInfo = JSON.parse(data);
                            if ($rootScope.checkDeviceInfo.status == 'S') {
                                if ($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNN') {
                                    bhimUpiService.getNativeData("generateAppGenId", {}).then(function (data) {
                                        utilityService.hideSpinner();
                                        bhimUpiService.appGenId = data;
                                        utilityService.showBhimUpiAlert("alert", "Looks like you do not have a UPI profile to make payments. Please register UPI for making further transactions", "menu.createNewVpa");
                                    }, function (msg) {
                                        utilityService.hideSpinner();
                                        utilityService.showBhimUpiAlert("error", msg);
                                    });
                                } else if ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNM') {
                                    utilityService.hideSpinner();
                                    if ($rootScope.checkDeviceInfo.re_verify && $rootScope.checkDeviceInfo.re_verify == 'Y') {
                                        utilityService.showBhimUpiAlert("alert", $rootScope.checkDeviceInfo.statusDesc);
                                    } else {
                                        if (payType) {
                                            bhimUpiService.getNativeData("getcontactpermission", {}).then(function (data) {
                                                if (data.contactpermission === 'Allowed') {
                                                    bhimUpiService.getNativeData("openContacts", {}).then(function (data) {
                                                        var contact = data;

                                                        if (contact && contact.number) {
                                                            var x = contact.number.replace(/\s/g, '');
                                                            if (x.length >= 10) {
                                                                fundsTransferLandingVm.vpa = x.substr(x.length - 10) + "@sbi";
                                                            } else {
                                                                return false;
                                                                utilityService.showBhimUpiAlert("alert", 'Please select valid mobile number');
                                                            }
                                                        } else {
                                                            return false;
                                                            utilityService.showBhimUpiAlert("alert", 'Please select valid mobile number');
                                                        }

                                                        customerInfoService.payeeDetails = {
                                                            payeeType: "VA",
                                                            requestType: 'pay',
                                                            accountNo: "",
                                                            ifsc: "",
                                                            name: "",
                                                            vpa: fundsTransferLandingVm.vpa || "",
                                                            amount: "",
                                                            remark: "",
                                                            nickName: "",
                                                            phoneNumber: "",
                                                            savePayee: false
                                                        }
                                                        $state.go('menu.payToVpa');
                                                    }, function (msg) {
                                                        utilityService.hideSpinner();
                                                        utilityService.showBhimUpiAlert("error", msg);
                                                    });
                                                } else {
                                                    utilityService.hideSpinner();
                                                    ionicToast.show("Contact permission denied. Please allow to proceed", 'bottom', false, 3000);
                                                }
                                            }, function (msg) {
                                                utilityService.hideSpinner();
                                                utilityService.showBhimUpiAlert("error", msg);
                                            });
                                        } else {
                                            customerInfoService.scanQrEntrypoint = 'FTLANDING';
                                            customerInfoService.payerDetails = {};
                                            customerInfoService.payeeDetails = {};
                                            $state.go('menu.payToQR');
                                        }
                                    }
                                } else if (($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNM') || ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNN')) {
                                    bhimUpiService.getNativeData("generateAppGenId", {}).then(function (data) {
                                        utilityService.hideSpinner();
                                        bhimUpiService.appGenId = data.appGenId;
                                        utilityService.showBhimUpiAlert("alert", "Looks like you have changed Device/Sim. Please register UPI for making further transactions", "menu.vpaOptions");
                                    }, function (msg) {
                                        utilityService.hideSpinner();
                                        utilityService.showBhimUpiAlert("error", msg);
                                    });
                                }
                            } else {
                                utilityService.hideSpinner();
                                utilityService.showBhimUpiAlert("error", $rootScope.checkDeviceInfo.statusDesc);
                            }
                        }, function (msg) {
                            utilityService.hideSpinner();
                            utilityService.showBhimUpiAlert("error", msg);
                        });
                    } else {
                        utilityService.hideSpinner();
                        utilityService.showBhimUpiAlert("alert", "Please insert simcard to proceed further");
                    }
                } else {
                    utilityService.hideSpinner();
                    utilityService.showBhimUpiAlert("alert", "Please insert simcard to proceed further");
                }
            }

            var HasPerminionSuccessCallback = function (result) {
                if (result) {
                    window.plugins.sim.getSimInfo(simInfosuccessCallback, errorCallback);
                } else {
                    requestReadPermission();
                }
            }

            var errorCallback = function (error) {
                var elementSimInfo = document.getElementById('ErrorInfo');
                elementSimInfo.innerHTML = error;
            }

            var requestSuccessCallback = function (result) {
                if (result) {
                    hasReadPermission();
                }
            }

            // Android only: check permission
            function hasReadPermission() {
                window.plugins.sim.hasReadPermission(HasPerminionSuccessCallback, errorCallback);
            }

            // Android only: request permission
            function requestReadPermission() {
                window.plugins.sim.requestReadPermission(requestSuccessCallback, errorCallback);
            }

            hasReadPermission();
            /*Sim card Info fetching - End*/
        };

        fundsTransferLandingVm.redirectToBhimUpi = function () {
            utilityService.showSpinner();
            if (!localStorage.getItem("appGenId")) {
                bhimUpiService.getNativeData("generateAppGenId", {}).then(function (data) {
                    if (device.platform.toLowerCase() == 'android') {
                        bhimUpiService.appGenId = data.appGenId;
                    } else {
                        bhimUpiService.appGenId = data;
                    }
                    fundsTransferLandingVm.redirectToBhimUpiFlow();
                }, function (msg) {
                    utilityService.hideSpinner();
                    utilityService.showBhimUpiAlert("error", msg);
                });
            } else {
                bhimUpiService.getNativeData("setAppGenId", localStorage.getItem("appGenId")).then(function (data) {
                    fundsTransferLandingVm.redirectToBhimUpiFlow();
                }, function (msg) {
                    utilityService.hideSpinner();
                    utilityService.showBhimUpiAlert("error", msg);
                });
            }
            // } else {
            //     var comingsoonPopup = $ionicPopup.alert({
            //         template: '<div class="CSPadding font-dark-grey "><div class="parentCS"><img class="imgwidthCS" src="img/Coming_Soon_Illustration.svg"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="childCS">'
            //         + 'Coming Soon</div></div></div></div></div></div>',
            //         cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter custButtonCS button0pd',
            //         buttons: [
            //             {
            //                 text: 'OK',
            //                 type: 'button-positive',
            //                 onTap: function (e) {
            //                     comingsoonPopup.close();
            //                 }
            //             }
            //         ]
            //     });
            // }
        }

        fundsTransferLandingVm.redirectToBhimUpiFlow = function () {
            if (device.platform.toLowerCase() == 'android') {
                utilityService.showSpinner();
                var json = JSON.stringify({});
                bhimUpiService.getNativeData(constantConfig.upiConstant.getpermission, json).then(function (data) {
                    if (data.permission === 'Allowed') {
                        fundsTransferLandingVm.redirectToBhimUpiJourney();
                    } else {
                        utilityService.hideSpinner();
                        utilityService.showBhimUpiAlert("alert", "UPI registration requires permission to use camera, SMS and Phone calls. Please allow these permissions. If problem persists re-initiate UPI registration.");
                    }
                }, function (msg) {
                    utilityService.hideSpinner();
                    utilityService.showBhimUpiAlert("error", msg);
                });
            } else if (device.platform.toLowerCase() == 'windows') {
                ionicToast.show("The functionality is not available in windows currently.", 'bottom', false, 3000);
            } else {
                utilityService.showSpinner();
                var json = JSON.stringify({
                    "pspId": constantConfig.upiConstant.pspId,
                    "encryptionKey": loggedInUserService.upiPermissionKey.split("^")[2]
                });
                bhimUpiService.getNativeData("initializeIOSsdk", json).then(function (data) {
                    if (data !== "S") {
                        utilityService.hideSpinner();
                        utilityService.showBhimUpiAlert("error", data);
                        return false;
                    }
                    utilityService.showSpinner();
                    var json = JSON.stringify({
                        "addInfo": {
                            "addInfo10": constantConfig.upiConstant.addInfo10,
                            "addInfo9": constantConfig.upiConstant.addInfo9
                        },
                        "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                        "requestInfo": {
                            "pspId": constantConfig.upiConstant.pspId,
                            "pspRefNo": generateRandomString(27)
                        },
                        "updateFlag": constantConfig.upiConstant.updateFlag,
                        "smsSent": "false"
                    });
                    bhimUpiService.getNativeData(constantConfig.upiConstant.checkDevice, json).then(function (data) {
                        $rootScope.checkDeviceInfo = JSON.parse(data);
                        if ($rootScope.checkDeviceInfo.status == 'S') {
                            if ($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNN') {
                                bhimUpiService.getNativeData("generateAppGenId", {}).then(function (data) {
                                    utilityService.hideSpinner();
                                    bhimUpiService.appGenId = data;
                                    $state.go('menu.createNewVpa');
                                }, function (msg) {
                                    utilityService.hideSpinner();
                                    utilityService.showBhimUpiAlert("error", msg);
                                });
                            } else if ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNM') {
                                utilityService.hideSpinner();
                                if ($rootScope.checkDeviceInfo.re_verify && $rootScope.checkDeviceInfo.re_verify == 'Y') {
                                    utilityService.showBhimUpiAlert("alert", $rootScope.checkDeviceInfo.statusDesc);
                                } else {
                                    $state.go('menu.fundtrans');
                                }
                            } else if (($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNM') || ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNN')) {
                                bhimUpiService.getNativeData("generateAppGenId", {}).then(function (data) {
                                    utilityService.hideSpinner();
                                    bhimUpiService.appGenId = data;
                                    $state.go('menu.vpaOptions');
                                }, function (msg) {
                                    utilityService.hideSpinner();
                                    utilityService.showBhimUpiAlert("error", msg);
                                });
                            }
                        } else {
                            utilityService.hideSpinner();
                            utilityService.showBhimUpiAlert("error", $rootScope.checkDeviceInfo.statusDesc);
                        }
                    }, function (msg) {
                        utilityService.hideSpinner();
                        utilityService.showBhimUpiAlert("error", msg);
                    });
                }, function (msg) {
                    utilityService.hideSpinner();
                    utilityService.showBhimUpiAlert("error", msg);
                });
            }
        }

        fundsTransferLandingVm.redirectToBhimUpiJourney = function () {
            /*Sim card Info fetching - Start*/
            function simInfosuccessCallback(result) {
                if (result !== undefined && result != null && result != '') {
                    if (result.cards && result.cards.length > 0) {
                        customerInfoService.simCardInfo = result;
                        utilityService.showSpinner();
                        var json = JSON.stringify({
                            "addInfo": {
                                "addInfo10": constantConfig.upiConstant.addInfo10,
                                "addInfo9": constantConfig.upiConstant.addInfo9
                            },
                            "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                            "requestInfo": {
                                "pspId": constantConfig.upiConstant.pspId,
                                "pspRefNo": generateRandomString(27)
                            },
                            "updateFlag": constantConfig.upiConstant.updateFlag,
                            "smsSent": false
                        });
                        bhimUpiService.getNativeData(constantConfig.upiConstant.checkDevice, json).then(function (data) {
                            $rootScope.checkDeviceInfo = JSON.parse(data);
                            if ($rootScope.checkDeviceInfo.status == 'S') {
                                if ($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNN') {
                                    bhimUpiService.getNativeData("generateAppGenId", {}).then(function (data) {
                                        utilityService.hideSpinner();
                                        bhimUpiService.appGenId = data.appGenId;
                                        $state.go('menu.createNewVpa');
                                    }, function (msg) {
                                        utilityService.hideSpinner();
                                        utilityService.showBhimUpiAlert("error", msg);
                                    });
                                } else if ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNM') {
                                    utilityService.hideSpinner();
                                    if ($rootScope.checkDeviceInfo.re_verify && $rootScope.checkDeviceInfo.re_verify == 'Y') {
                                        utilityService.showBhimUpiAlert("alert", $rootScope.checkDeviceInfo.statusDesc);
                                    } else {
                                        $state.go('menu.fundtrans');
                                    }
                                } else if (($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNM') || ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNN')) {
                                    bhimUpiService.getNativeData("generateAppGenId", {}).then(function (data) {
                                        utilityService.hideSpinner();
                                        bhimUpiService.appGenId = data.appGenId;
                                        $state.go('menu.vpaOptions');
                                    }, function (msg) {
                                        utilityService.hideSpinner();
                                        utilityService.showBhimUpiAlert("error", msg);
                                    });
                                }
                            } else {
                                utilityService.hideSpinner();
                                utilityService.showBhimUpiAlert("error", $rootScope.checkDeviceInfo.statusDesc);
                            }
                        }, function (msg) {
                            utilityService.hideSpinner();
                            utilityService.showBhimUpiAlert("error", msg);
                        });
                    } else {
                        utilityService.hideSpinner();
                        utilityService.showBhimUpiAlert("alert", "Please insert simcard to proceed further");
                    }
                } else {
                    utilityService.hideSpinner();
                    utilityService.showBhimUpiAlert("alert", "Please insert simcard to proceed further");
                }
            }

            function HasPerminionSuccessCallback(result) {
                if (result) {
                    window.plugins.sim.getSimInfo(simInfosuccessCallback, errorCallback);
                } else {
                    requestReadPermission();
                }
            }

            function errorCallback(error) {
                var elementSimInfo = document.getElementById('ErrorInfo');
                elementSimInfo.innerHTML = error;
            }

            function requestSuccessCallback(result) {
                if (result) {
                    hasReadPermission();
                }
            }

            // Android only: check permission
            function hasReadPermission() {
                window.plugins.sim.hasReadPermission(HasPerminionSuccessCallback, errorCallback);
            }

            // Android only: request permission
            function requestReadPermission() {
                window.plugins.sim.requestReadPermission(requestSuccessCallback, errorCallback);
            }

            hasReadPermission();
            /*Sim card Info fetching - End*/
        };

        /*actions to done everytime the view is shown*/
        $scope.$on('$ionicView.beforeEnter', function () {
            bhimUpiService.isUpiRegistration = false;
            if (homeScreenService.ishamburgerMenuFTL) {
                fundsTransferLandingVm.isHamCheck = true;
                fundsTransferLandingVm.isBackCheck = true;
            } else {
                fundsTransferLandingVm.isBackCheck = false;
            }
            //console.log($ionicHistory.backView().stateName);
            // fundsTransferLandingVm.isBackCheck = homeScreenService.isBackCheck;
            // homeScreenService.isBackCheck = false;
            fundsTransferLandingVm.getnotificationOffer();
            fTBeneficiaryService.savedImg = "";
            //Check for the default account

            if(!fTBeneficiaryService.config.quickTransferLimit) {
                requestYCService.getWelcomeMessages().then(function (response) {
                    fTBeneficiaryService.config.quickTransferLimit = response.fundsTransfer.benAmountLimit;
                    fundsTransferLandingVm.transferLimit = response.fundsTransfer.benAmountLimit;
                });
            }
            else fundsTransferLandingVm.transferLimit = fTBeneficiaryService.config.quickTransferLimit;
        });
        fundsTransferLandingVm.forgotPass = function () {
            $state.go('menu.forgotProfilePwd');
        }

        fundsTransferLandingVm.forgotpassPopup = function () {
            var havingMPINPrblmPopUp = $ionicPopup.show({
                template: "<p> If you have forgotton your profile password, you can reset the same yourself. You need to  authenticate yourself either with the hint question and answer that you had set for the Profile password or ATM Card details & PIN. You can approach branch in case you don't remember Hint Question/answer or ATM card details & PIN </p>",
                title: '',
                cssClass: 'dialog',
                scope: $scope,
                buttons: [{
                    text: 'OK',
                    type: 'button-positive'
                }]
            });
        };

        fundsTransferLandingVm.unblockProfilePassword = function () {
            fundsTransferLandingVm.myPopup.close();
            $state.go('menu.forgotProfilePwd');
        }

        fundsTransferLandingVm.cancel = function () {
            fundsTransferLandingVm.myPopup.close();
            $state.go('menu.homeScreen');
        }

        fundsTransferLandingVm.toggleSecretAns = function () {
            fundsTransferLandingVm.isTextReadable == true ? fundsTransferLandingVm.isTextReadable = false : fundsTransferLandingVm.isTextReadable = true;
        };
        fundsTransferLandingVm.toggleReEnter = function () {
            fundsTransferLandingVm.isTextReadablereEnter == true ? fundsTransferLandingVm.isTextReadablereEnter = false : fundsTransferLandingVm.isTextReadablereEnter = true;
        };
        fundsTransferLandingVm.openPal = function () {

            personalLoanService.clearAll();
            personalLoanService.getLoanDetails().then(function (data) {

                personalLoanService.personalLoanData = data;
                personalLoanService.minDuration = data.minTenure;
                personalLoanService.maxDuration = data.maxTenure;
                personalLoanService.interestRate = data.interestRate;
                personalLoanService.product = data.productCode;
                personalLoanService.maxEmiLimit = data.maxPermissibleEMI;
                personalLoanService.processingFee = data.processingFee;
                personalLoanService.minBestOffer = data.minPalAmount;
                personalLoanService.activityCode = data.activityCode;
                personalLoanService.schemeCode = data.schemeCode;
                $state.go('menu.personalLoan');

            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        };
        fundsTransferLandingVm.bannerWidth = function () {
            if (homeScreenService.offersData && homeScreenService.offersData.length > 1) {
                fundsTransferLandingVm.homeWidth = window.innerWidth - (window.innerWidth * 0.15) + "px";
            } else {
                fundsTransferLandingVm.homeWidth = "100%";
            }
        }
        fundsTransferLandingVm.getnotificationOffer = function () {
            if (!homeScreenService.isNotificationDataAvail) {
                fundsTransferLandingVm.palSpinner = true;
                homeScreenService.getnotificationOffer().then(function (data) {
                    homeScreenService.isNotificationDataAvail = true;
                    fundsTransferLandingVm.palSpinner = false;
                    if (data.suggestedData.offers && data.suggestedData.alerts) {
                        homeScreenService.alertsData = data.suggestedData.alerts;
                        homeScreenService.offersData = data.suggestedData.offers;
                        fundsTransferLandingVm.offersData = homeScreenService.offersData;
                        fundsTransferLandingVm.alertsData = homeScreenService.alertsData;
                        fundsTransferLandingVm.bannerWidth();
                        $rootScope.bellNotificationCnt = homeScreenService.getBellNotificationCount();
                        for (var i = 0; i < data.suggestedData.offers.length; i++) {
                            if (data.suggestedData.offers[i].category == "SS") {
                                lifeInsuranceBasicApplicationService.getFSSBannerImages().then(function (response) {
                                    for (var i = 0; i < data.suggestedData.offers.length; i++) {
                                        if (data.suggestedData.offers[i].category == "SS") {
                                            if (response.subCategory.length > 0) {
                                                for (var j = 0; j < response.subCategory.length; j++) {
                                                    if (response.subCategory[j].subCode == "sampoorna") {
                                                        var eligibleSumAssured = String.fromCharCode(8377) + $filter('INR')(parseInt(data.suggestedData.offers[i].amount));
                                                        data.suggestedData.offers[i].messageDescription = response.subCategory[j].message;
                                                        data.suggestedData.offers[i].messageDescription = data.suggestedData.offers[i].messageDescription ? data.suggestedData.offers[i].messageDescription.replace("FIELD_1}}", eligibleSumAssured).replace("Rs. ", String.fromCharCode(8377)) : eligibleSumAssured;
                                                        data.suggestedData.offers[i].image = response.subCategory[j].offerImgMobile;
                                                    }
                                                }
                                            }
                                            homeScreenService.alertsData = data.suggestedData.alerts;
                                            homeScreenService.offersData = data.suggestedData.offers;
                                        }
                                        if (data.suggestedData.offers[i].category == "PAPL") {
                                            var eligibleSumAssured = String.fromCharCode(8377) + $filter('INR')(parseInt(data.suggestedData.offers[i].palAmount));
                                            data.suggestedData.offers[i].messageDescription = data.suggestedData.offers[i].messageDescription ? data.suggestedData.offers[i].messageDescription.replace(data.suggestedData.offers[i].palAmount, eligibleSumAssured).replace("Rs. ", String.fromCharCode(8377)) : eligibleSumAssured;
                                        }
                                    }
                                }, function (error) {
                                });
                            }
                        }
                    }
                }, function (error) {
                    homeScreenService.isNotificationDataAvail = false;
                    fundsTransferLandingVm.palSpinner = false;
                });
            } else {
                if (homeScreenService.offersData && homeScreenService.alertsData) {
                    fundsTransferLandingVm.offersData = homeScreenService.offersData;
                    fundsTransferLandingVm.alertsData = homeScreenService.alertsData;
                    fundsTransferLandingVm.bannerWidth();
                    $rootScope.bellNotificationCnt = homeScreenService.getBellNotificationCount();
                }
            }
        };
        fundsTransferLandingVm.navigateEmiAlerts = function (offerData) {
            switch (offerData.category) {
                case 'LI':
                    generalInsurenceHomeService.setGIProductsID(offerData.category);
                    $state.go('menu.sbiLifeIntro');
                    break;
                case 'DEMAT':
                    openAccountService.setStatusOfOpenAccount(0);
                    $state.go('menu.openSecurityAccount');
                    break;
                case 'CC':
                    cardsService.setParams({
                        "cardName": offerData.name
                    });
                    $state.go('menu.cardIntroduction');
                    break;
                case 'PAPL':
                    fundsTransferLandingVm.openPal();
                    break;
                case 'OMP':
                    $state.go(offerData.stateGo);
                    break;
                case 'GI':
                    generalInsurenceHomeService.setGIProductsID(offerData.category);
                    $state.go('menu.declaimer');
                    break;
                case 'SS':
                    // sampoornSurakshaService.getPremiumAndNomineeInfo().then(function(data) {
                    // 	sampoornSurakshaService.setPremiumDetails(data);
                    // 	$state.go('menu.ssPremiumCalculation');
                    // }, function(error) {
                    // 	utilityService.showErrorMessage(error.responseMessage);
                    // });
                    break;
                case 'MF':
                    $state.go('menu.introMutualFunds');
                    break;//Here MF developer need to confirm redirection
                default:
            }
        };

        fundsTransferLandingVm.buyoffer = function (offer) {
            if (offer.category == "SS") {
                sampoornSurakshaService.getPremiumAndNomineeInfo().then(function (data) {
                    sampoornSurakshaService.clearAll();
                    sampoornSurakshaService.setPremiumDetails(data);
                    $state.go('menu.ssPremiumCalculation');
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        };

        fundsTransferLandingVm.knowMoreOffer = function (offer) {
            if (offer.category == "SS") {
                sampoornSurakshaService.getPolicyFeatures().then(function (data) {
                    sampoornSurakshaService.setPolicyDetails(data);
                    sampoornSurakshaService.setBuyNow(true);
                    $state.go('menu.ssPolicyFeatures');
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        };

        fundsTransferLandingVm.yonocash = function () {
            $state.go('menu.yonoCash');
            //   requestYCService.isUserWhiteListed().then(function(response) {
            //             if (response.isUserWhiteListed == true) {
            //                $state.go('menu.yonoCash');
            //             }else{
            // 				var comingsoonPopup = $ionicPopup.alert({
            //                 template: '<div class="CSPadding font-dark-grey "><div class="parentCS"><img class="imgwidthCS" src="img/Coming_Soon_Illustration.svg"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="childCS">'
            //                 + "Coming Soon" + '</div></div></div></div></div></div>',
            //                 cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter custButtonCS button0pd',
            //                 buttons: [
            //                     {
            //                         text: 'OK',
            //                         type: 'button-positive',
            //                         onTap: function (e) {
            //                             comingsoonPopup.close();
            //                         }
            //                     }
            //                 ]
            //             });
            // 			}
            //         }, function(error) {
            // 			var comingsoonPopup = $ionicPopup.alert({
            //                 template: '<div class="CSPadding font-dark-grey "><div class="parentCS"><img class="imgwidthCS" src="img/Coming_Soon_Illustration.svg"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="childCS">'
            //                 + "Coming Soon" + '</div></div></div></div></div></div>',
            //                 cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter custButtonCS button0pd',
            //                 buttons: [
            //                     {
            //                         text: 'OK',
            //                         type: 'button-positive',
            //                         onTap: function (e) {
            //                             comingsoonPopup.close();
            //                         }
            //                     }
            //                 ]
            //             });
            //              //utilityService.showErrorMessage(error.responseMessage);
            //         });
        };

        /* start donation code remove from iOS */
        fundsTransferLandingVm.gotoDonation = function(){
            $state.go('menu.donation');
        }
        /* end donation code remove from iOS */

        return this;
    }
]);
