'use strict';
angularApp.controller('quickTransferAddBeneController', [
		"$state",
		"$scope",		
		"utilityService",
		"quickTransferService",
		"$translate",
		"getAccountDetailsService",
		"$ionicPopup",
		"validationService",
		"ftIFSCSearchService",
		"cameraService",
		"$ionicViewSwitcher",
		"fTBeneficiaryService",
		"$timeout",
		"constantConfig",
		function($state, 
		$scope,
		utilityService,
		quickTransferService,
		$translate,
		getAccountDetailsService,
		$ionicPopup,
		validationService,
		ftIFSCSearchService,
		cameraService,
		$ionicViewSwitcher,
		fTBeneficiaryService,
		$timeout,
		constantConfig) {
			
			var quickTransferAddBeneVm = this;
			quickTransferAddBeneVm.defaultImage = "img/quickpay/Pic.svg";
			var plusImg = "img/quickpay/add.svg";
			var minusImg = "img/quickpay/Del.svg"
			quickTransferAddBeneVm.defaultPlusImage = plusImg;
			quickTransferAddBeneVm.isNextDisabled = true;
			quickTransferAddBeneVm.isMaxLengthEmpty = false;
			quickTransferAddBeneVm.isNickNameEmpty = false;
			quickTransferAddBeneVm.submitted = false;
			quickTransferAddBeneVm.multipleOfFive = false;
			quickTransferAddBeneVm.isErrorMessage = false;

			var isDefaultPic = true;

			function initPage(){
				var pay_type = "";
				quickTransferAddBeneVm.pay_type = quickTransferService.paymentType ? quickTransferService.paymentType : "sbi";

				if(quickTransferService.paymentType == 'sbi'){
					pay_type = 'SBI A/C';
				}
				else if(quickTransferService.paymentType == 'other'){
					pay_type = 'OTHER BANK A/C';
				}
				else if(quickTransferService.paymentType == 'mobile'){
					pay_type = 'MOBILE NUMBER';
				}
				$translate(['QT_HEADER'], {type: pay_type }).then(function (translations) {
                    quickTransferAddBeneVm.header_txt = translations['QT_HEADER'];
                });
				$translate(['YQP_ERR_MSG_MAX_LMT_LESS_THAN_ONE','YQP_ERR_MSG_MAX_LMT_10_LAKHS','YQP_ERR_MSG_MAX_REQUIRED','QT_ERR_MSG_MAX_LIM_MUL_5']).then(function (translations) {
                    quickTransferAddBeneVm.lessThanOne = translations['YQP_ERR_MSG_MAX_LMT_LESS_THAN_ONE'];
					quickTransferAddBeneVm.maxTenLakh = translations['YQP_ERR_MSG_MAX_LMT_10_LAKHS'];
					quickTransferAddBeneVm.requiredMaxLim = translations['YQP_ERR_MSG_MAX_REQUIRED'];
					quickTransferAddBeneVm.multipleOfFive = translations['QT_ERR_MSG_MAX_LIM_MUL_5'];
                });
                

				quickTransferAddBeneVm.name = quickTransferService.paymentData["beneName"];
				quickTransferAddBeneVm.accountNumber = quickTransferService.paymentData["beneAccNo"];
				quickTransferAddBeneVm.ifsc = quickTransferService.paymentData["ifsc"];
				quickTransferAddBeneVm.beneMMID = quickTransferService.paymentData["mmid"];
				quickTransferAddBeneVm.beneMobileNo = quickTransferService.paymentData["beneMobileNo"];
			}

			quickTransferAddBeneVm.editPic = function(){
				utilityService.showSpinner();
				cameraService.getImageFromGalleryWithoutCompress().then(function(data) {
					utilityService.hideSpinner();
					var base64Img = data.split(',')[1];
					quickTransferAddBeneVm.imageSizeValidation(base64Img,data);
					
				}, function(error) {
					utilityService.hideSpinner();
				});
			}

			quickTransferAddBeneVm.imageSizeValidation = function(base64Img,data){
				quickTransferAddBeneVm.b64toBlob = function (b64Data, contentType, sliceSize) {
					contentType = contentType || '';
					sliceSize = sliceSize || 512;

					var byteCharacters = atob(b64Data);
					var byteArrays = [];

					for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
						var slice = byteCharacters.slice(offset, offset + sliceSize);

						var byteNumbers = new Array(slice.length);
						for (var i = 0; i < slice.length; i++) {
							byteNumbers[i] = slice.charCodeAt(i);
						}

						var byteArray = new Uint8Array(byteNumbers);

						byteArrays.push(byteArray);
					}

					var blob = new Blob(byteArrays, { type: contentType });
					return blob;
				}
				var blobData = quickTransferAddBeneVm.b64toBlob(base64Img,"image/jpg",512);
				if(blobData.size > constantConfig.quickTransferAdapterURL.imgSize){
					utilityService.showErrorMessage(constantConfig.quickTransferAdapterURL.imageSizeMessage);
					return;
				}else{
					quickTransferAddBeneVm.setImage(data);
					$timeout(function(){
						quickTransferAddBeneVm.uploadImage(data);
					},1000);
				}
			}

			quickTransferAddBeneVm.setImage = function(img) {
				isDefaultPic = false;
				!isDefaultPic ? quickTransferAddBeneVm.defaultPlusImage = minusImg : quickTransferAddBeneVm.defaultPlusImage = plusImg;
				quickTransferAddBeneVm.defaultImage = img;
			};

			/* upload image */
			quickTransferAddBeneVm.uploadImage = function(img){
				var updatePicData = {
				  "mimeType": "image/jpg",
				  "documentTitle": "Beneficiary Image",
				  "documentData": img.split(',')[1],
				  "nickname": quickTransferAddBeneVm.nickName || ''
				}
				
				//service call to upload image
				fTBeneficiaryService.uploadBeneficiaryPicture(updatePicData).then(function(response) {
					utilityService.hideSpinner();
					quickTransferAddBeneVm.picDocId = response.id;
					quickTransferService.paymentData["picDocId"] = response.id;
					//fTBeneficiaryService.customer.picDocId = fTNewBeneficiaryVm.picDocId;
				}, function(error) {
					utilityService.hideSpinner();
					utilityService.showErrorMessage(error.responseMessage);
				});
			}
   
			$scope.$on('$ionicView.beforeEnter', function() {
				initPage();
			});
			$scope.$on('$ionicView.loaded', function () {
			
			});

			quickTransferAddBeneVm.gotoNext = function(){
				var isValidate = quickTransferAddBeneVm.isValidAllFields();
				if(isValidate){
					quickTransferService.paymentData["beneNickName"] = quickTransferAddBeneVm.nickName;
					quickTransferService.paymentData["maxLimit"] = quickTransferAddBeneVm.maxLimit;
					quickTransferService.paymentData["defaultImage"] = quickTransferAddBeneVm.defaultImage;
					$state.go("menu.quickTransferReviewBeneView");
				}
			}

			quickTransferAddBeneVm.gotoHome = function(){
				$ionicViewSwitcher.nextDirection('back');
            	$state.go("menu.quickTransferLanding");
			}

			quickTransferAddBeneVm.validateMaxLen = function(maxLmt){
				if(!maxLmt){
					quickTransferAddBeneVm.isErrorMessage = true;
					quickTransferAddBeneVm.errorMessage = quickTransferAddBeneVm.requiredMaxLim;
					return false;
				}
				else{
					var maxRem = (maxLmt % 5);
					if(maxLmt < 1){
						quickTransferAddBeneVm.isErrorMessage = true;
						quickTransferAddBeneVm.errorMessage = quickTransferAddBeneVm.lessThanOne;
						return false;
					}else if(maxLmt > 1000000){
						quickTransferAddBeneVm.isErrorMessage = true;
						quickTransferAddBeneVm.errorMessage = quickTransferAddBeneVm.maxTenLakh;
						return false;
					}else if(maxLmt >= 1){
						if(maxRem === 0){
							quickTransferAddBeneVm.isErrorMessage = false;
							return true;
						}
						else{
							quickTransferAddBeneVm.isErrorMessage = true;
							quickTransferAddBeneVm.errorMessage = quickTransferAddBeneVm.multipleOfFive;
							return false;
						}
					}
				}
			}

			quickTransferAddBeneVm.nickNameChanged = function(){
				if(!quickTransferAddBeneVm.nickName){
					quickTransferAddBeneVm.isNickNameEmpty = true;
					quickTransferAddBeneVm.isValidAllFields();
				}else{
					quickTransferAddBeneVm.isNickNameEmpty = false;
					quickTransferAddBeneVm.isValidAllFields();
				}
			}

			quickTransferAddBeneVm.isValidAllFields = function(){
				quickTransferAddBeneVm.submitted = true;
				if(quickTransferAddBeneVm.validateMaxLen(quickTransferAddBeneVm.maxLimit) && !quickTransferAddBeneVm.isNickNameEmpty){
					return true;
				}else{
					return false;
				}
			}

			return this;
		}

		
]);


