/**
 *   @ngdoc config
 *   @name angularApp.config : quickTransferConfig
 *   @description
 *   configuration file for Quick Transfer module
 *   @author : Hitesh Dadhich
 */

/*This function defines all the constants named  Adapters url for cards module*/
angularApp
    /*State defination with respective names, urls, controllers and templates */
    .config([
        '$stateProvider',
        function ($stateProvider) {
            //Cards start
            $stateProvider
                .state('menu.quickTransferLanding', {
                    url: '/quickTransferLanding',
                    data: {
                        pageId: 'QUICKTRANSLANDING'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/fundTransfer/quickTransfer/quickTransferLanding.html',
                            controller: 'quickTransferLandingController',
                            controllerAs: 'quickTransferLandingVm'
                        }
                    }
                })
                .state('menu.quickTransferPayment', {
                    url: '/quickTransferPayment',
                    data: {
                        pageId: 'QUICKTRANSPAYMENT'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/fundTransfer/quickTransfer/quickTransferPayment.html',
                            controller: 'quickTransferPaymentController',
                            controllerAs: 'quickTransferPaymentVm'
                        }
                    }
                })
                .state('menu.quickTransferPaymentReview', {
                    url: '/quickTransferPaymentReview',
                    data: {
                        pageId: 'QUICKTRANSPAYMENTREVIEW'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/fundTransfer/quickTransfer/quickTransferPaymentReview.html',
                            controller: 'quickTransferPaymentReviewController',
                            controllerAs: 'quickTransferPaymentReviewVm'
                        }
                    }
                })
                .state('menu.quickTransferOTPView', {
                    url: '/quickTransferOTPView',
                    data: {
                        pageId: 'QUICKTRANSOTP'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/fundTransfer/quickTransfer/quickTransferOTP.html',
                            controller: 'quickTransferOTPController',
                            controllerAs: 'quickTransferOTPVm'
                        }
                    }
                })
                .state('menu.quickTransferSuccessView', {
                    url: '/quickTransferSuccessView',
                    data: {
                        pageId: 'QUICKTRANSSUCCESS'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/fundTransfer/quickTransfer/quickTransferSuccess.html',
                            controller: 'quickTransferSuccessController',
                            controllerAs: 'quickTransferSuccessVm'
                        }
                    }
                })
                .state('menu.quickTransferAddBeneView', {
                    url: '/quickTransferAddBeneView',
                    data: {
                        pageId: 'QUICKTRANSADDBENE'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/fundTransfer/quickTransfer/quickTransferAddBene.html',
                            controller: 'quickTransferAddBeneController',
                            controllerAs: 'quickTransferAddBeneVm'
                        }
                    }
                })
                .state('menu.quickTransferReviewBeneView', {
                    url: '/quickTransferReviewBeneView',
                    data: {
                        pageId: 'QUICKTRANSREVIEWBENE'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/fundTransfer/quickTransfer/quickTransferReviewBene.html',
                            controller: 'quickTransferReviewBeneController',
                            controllerAs: 'quickTransferReviewBeneVm'
                        }
                    }
                })
                .state('menu.quickTransferProfilePasswordView', {
                    url: '/quickTransferProfilePasswordView',
                    data: {
                        pageId: 'QUICKTRANSPROFILEPASSWORD'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/fundTransfer/quickTransfer/quickTransferProfilePassword.html',
                            controller: 'quickTransferProfilePasswordController',
                            controllerAs: 'quickTransferProfilePasswordVm'
                        }
                    }
                })
        }
    ]);
