'use strict';

angularApp.controller('quickTransferOTPController',
    ["$state",
    "$scope",		
    "utilityService",
    "quickTransferService",
    "$translate",
    "getAccountDetailsService",
    "$ionicPopup",
    "validationService",
    "ftIFSCSearchService",
    "customerInfoService",
    "fTSetOTPService",
    "$ionicViewSwitcher",
    "constantConfig",
    "cryptoService",
    "autoOtpReadService",
    function (
        $state, 
		$scope,
		utilityService,
		quickTransferService,
		$translate,
		getAccountDetailsService,
		$ionicPopup,
		validationService,
		ftIFSCSearchService,
        customerInfoService,
        fTSetOTPService,
        $ionicViewSwitcher,
        constantConfig,
        cryptoService,
        autoOtpReadService) {

       var quickTransferOTPVm = this;
       var otpCount = 0;
       quickTransferOTPVm.isDisabledOTPbtn = false;
       quickTransferOTPVm.isOTPRequired = false;
       quickTransferOTPVm.txnType = '';

       function initPage(){
            var pay_type = "";

            quickTransferOTPVm.pay_type = quickTransferService.paymentType ? quickTransferService.paymentType : "sbi";

            if(quickTransferService.paymentType == 'sbi'){
                pay_type = 'SBI A/C';
                quickTransferOTPVm.txnType = "SBIBank";
            }
            else if(quickTransferService.paymentType == 'other'){
                pay_type = 'OTHER BANK A/C';
                quickTransferOTPVm.txnType = "otherBank";
            }
            else if(quickTransferService.paymentType == 'mobile'){
                pay_type = 'MOBILE NUMBER';
                quickTransferOTPVm.txnType = "mobileNumber";
            }
            $translate(['QT_HEADER'], {type: pay_type }).then(function (translations) {
                quickTransferOTPVm.header_txt = translations['QT_HEADER'];
            });
            quickTransferOTPVm.resendOTP();
            quickTransferOTPVm.mobileNo = customerInfoService.customer.mobile;
       }

            quickTransferOTPVm.resendOTP = function(){
                if(!quickTransferOTPVm.isDisabledOTPbtn){
                    var reqParams = {};
                    reqParams["id"] = customerInfoService.customer.mobile;
                    reqParams.otpCode = constantConfig.keysForOTP.ftNormalFundTransfer;
                    reqParams.ocHash = cryptoService.getSHA512EncryptedData(constantConfig.keysForOTP.ftNormalFundTransfer).toString();
                    quickTransferService.generateOTP(reqParams).then(function(data){
                        // Disabling below code to hide autoreadotp popup
                        // if (utilityService.isAndroidPlatform()) {
                        //     autoOtpReadService.startOtpReading().then(function (result) {
                        //         quickTransferOTPVm.otp = result;
                        //     }, function (error) {
                        //         console.log(error);
                        //     });
                        // }
                        if(otpCount != 2){
                            otpCount = otpCount+1;
                        }else{
                            quickTransferOTPVm.isDisabledOTPbtn = true;
                        }
                    }, function(error){
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }
            }

       quickTransferOTPVm.otpValidate = function(qtOTPForm){
            if(qtOTPForm.$valid && quickTransferOTPVm.otp){
                quickTransferOTPVm.isOTPRequired = false;
                var reqParams = {};
                reqParams["otp"] = quickTransferOTPVm.otp;
                reqParams["mobile"] = customerInfoService.customer.mobile;
                quickTransferService.validateOTP(reqParams).then(function(data){
                    //Call Transfer Fund API
                    quickTransferOTPVm.transferFund();
                    
                }, function(error){
                    utilityService.showErrorMessage(error.responseMessage);
                });	
            }
            else{
                quickTransferOTPVm.isOTPRequired = true;
            }
       }

       quickTransferOTPVm.transferFund = function(){
            var timeStamp = Math.floor(Date.now() / 1000);
            var reqParams = {};

            // {"benMobileNo":"","remarks":"TestThree","isOwnAccntFlag":"N","txnType":"other","otpTimeStamp":"1593069013","termsNcondition":true,"benCountryCode":"91","amtsh":"4199550a1cc6ab07488238b033914ec5cca2cd866c4493f8c386753cb55156b4f17a2a8501c2c458ef0bff3c512be26403f66bf494c608edc2d12c526a9fc6fc","accountCategory":"","benBranchCode":"","benBranchName":"","skipOtp":false,"isTestTransaction":false}
            //reqParams["benName"] = quickTransferService.paymentData["beneName"];
            //reqParams["benType"] = quickTransferService.paymentType !== "mobile" ? "account" : "mobile";
            reqParams["benMobileNo"] = quickTransferService.paymentData["beneMobileNo"];
            //reqParams["benAccntNo"] = quickTransferService.paymentData["beneAccNo"];
            //reqParams["remAccntNo"] = quickTransferService.paymentData["senderAccNo"];
            //reqParams["amount"] = quickTransferService.paymentData["transAmount"];
            //reqParams["transactionFee"] = quickTransferService.paymentData["commisonAmt"];
            reqParams["remarks"] = quickTransferService.paymentData["remark"];
            //reqParams["benMMID"] = quickTransferService.paymentData["mmid"] ? quickTransferService.paymentData["mmid"] : "";
            //reqParams["intraBankFlag"] = quickTransferOTPVm.pay_type === "sbi" ? "Y" : "N";
            reqParams["isOwnAccntFlag"] = quickTransferService.paymentData["isOwnAccount"] ? "Y" : "N";
            reqParams["txnType"] = quickTransferOTPVm.txnType;
            reqParams["otpTimeStamp"] = timeStamp;
            reqParams["termsNcondition"] = true;
            //reqParams["remBranchCode"] = quickTransferService.paymentData["selectedAcc"]["branchCode"] ? quickTransferService.paymentData["selectedAcc"]["branchCode"] :"";
            //reqParams["benIfscCode"] = quickTransferService.paymentData["ifsc"];
            //reqParams["remName"] = customerInfoService.customer["name"] ? customerInfoService.customer["name"] : "";
            //reqParams["remAdd1"] = customerInfoService.customer["address"] ? customerInfoService.customer["address"] : "";
            reqParams["benCountryCode"] = "91";
            //reqParams["remMobileNo"] = customerInfoService.customer["mobile"] ? customerInfoService.customer["mobile"] : "";
            //reqParams["remEmail"] = customerInfoService.customer["emailID"] ? customerInfoService.customer["emailID"] : "";
            reqParams["benBranchCode"] = "";
            reqParams["benBranchName"] = (quickTransferOTPVm.pay_type == 'other' && quickTransferService.paymentData["SelectedIFSCDetails"]) ? quickTransferService.paymentData["SelectedIFSCDetails"]["branch"] : "";
            reqParams["isTestTransaction"] = quickTransferService.paymentData["isTestTransaction"];
            reqParams["amtsh"] = "";//(cryptoService.getSHA512EncryptedData(quickTransferService.paymentData["transAmount"] + quickTransferService.paymentData["beneAccNo"] + quickTransferService.paymentData["mmid"] + quickTransferService.paymentData["senderAccNo"])).toString();
            
			quickTransferService.transferFunds(reqParams).then(function(data){
                quickTransferService.paymentData["remBalance"] = data["balance"];
                $state.go("menu.quickTransferSuccessView");
                
            }, function(error){
                $ionicViewSwitcher.nextDirection('back');
                utilityService.showBhimUpiAlert('error',error.responseMessage,'menu.quickTransferLanding');
            });	
       }

       quickTransferOTPVm.gotoHome = function(){
            $ionicViewSwitcher.nextDirection('back');
            $state.go("menu.quickTransferLanding");
       }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });
}]);