'use strict';
angularApp.controller('quickTransferPaymentController', [
		"$state",
		"$scope",		
		"utilityService",
		"quickTransferService",
		"$translate",
		"getAccountDetailsService",
		"$ionicPopup",
		"validationService",
		"ftIFSCSearchService",
		"$ionicPopover",
		"constantConfig",
		"customerInfoService",
		"$rootScope",
		"$ionicScrollDelegate",
		"$ionicPlatform",
		function($state, 
		$scope,
		utilityService,
		quickTransferService,
		$translate,
		getAccountDetailsService,
		$ionicPopup,
		validationService,
		ftIFSCSearchService,
		$ionicPopover,
		constantConfig,
		customerInfoService,
		$rootScope,
		$ionicScrollDelegate,
		$ionicPlatform) {
			
			var quickTransferPaymentVm = this;
			
			quickTransferPaymentVm.isNextEnable = false;
			quickTransferPaymentVm.showSBIAccountNumberError = false;
			quickTransferPaymentVm.showReEnterSBIAccountNumberError = false;
			quickTransferPaymentVm.showOtherAccountNumberError = false;
			quickTransferPaymentVm.showReEnterOtherAccountNumberError = false;
			quickTransferPaymentVm.isValidAccount = false;
			quickTransferPaymentVm.isShowLastTransBanner = false;
			quickTransferPaymentVm.isDisabled = true;
			quickTransferPaymentVm.isTestPayChecked = false;
			quickTransferPaymentVm.isAmountError = false;
			quickTransferPaymentVm.isInvalidMMID = false;
			quickTransferPaymentVm.isInvalidMobile = false;
			quickTransferPaymentVm.isDuplicateAccNu = false;
			quickTransferPaymentVm.isOwnAccount = false;
			quickTransferPaymentVm.submitted = false;
			quickTransferPaymentVm.isPayAgainClicked = false;
			quickTransferPaymentVm.deregisterBackButton = "";
            quickTransferPaymentVm.spinnerPopup = "";

			var transArr = ['ACC_TRANS_RIGHTS','FETCH_TRANS_RGTS','NO_SUFF_BAL','QT_ERR_MSG_VALID_AMOUNT','QT_ERR_MSG_LESS_THN_ZERO','QT_ERR_MSG_INN_BAL','QT_ERR_MSG_VALID_MAX_AMT'];
			quickTransferPaymentVm.showSelect = true;
			
			function initPage(){
				var pay_type = "";
				//quickTransferService.paymentType = "other";
				quickTransferPaymentVm.pay_type = quickTransferService.paymentType ? quickTransferService.paymentType : "other";

				if(quickTransferService.paymentType == 'sbi'){
					pay_type = 'SBI A/C';
					quickTransferPaymentVm.maxLength = 11;
				}
				else if(quickTransferService.paymentType == 'other'){
					pay_type = 'OTHER BANK A/C';
					quickTransferPaymentVm.maxLength = 30;
				}
				else if(quickTransferService.paymentType == 'mobile'){
					pay_type = 'MOBILE NUMBER';
				}
				$translate(['QT_HEADER'], {type: pay_type }).then(function (translations) {
                    quickTransferPaymentVm.header_txt = translations['QT_HEADER'];
                });
				$translate(transArr).then(function (translations) {
					quickTransferPaymentVm.accTransRights = translations['ACC_TRANS_RIGHTS'];
					quickTransferPaymentVm.fetchTransRights = translations['FETCH_TRANS_RGTS'];
					quickTransferPaymentVm.suffBalance = translations['NO_SUFF_BAL'];
					quickTransferPaymentVm.validAmount = translations['QT_ERR_MSG_VALID_AMOUNT'];
					quickTransferPaymentVm.lessThanZero = translations['QT_ERR_MSG_LESS_THN_ZERO'];
					quickTransferPaymentVm.innsuffBal = translations['QT_ERR_MSG_INN_BAL'];
					quickTransferPaymentVm.invalidMaxAmt = translations['QT_ERR_MSG_VALID_MAX_AMT'];
					
					quickTransferPaymentVm.accLists = getAccountDetailsService.accountOverviewData.accounts;
				});
				
				
			}
			

			quickTransferPaymentVm.isValidAllFields = function(){
				//common field condition 
				//quickTransferPaymentVm.submitted = true;
				if((quickTransferPaymentVm.isValidAccount) || (!quickTransferPaymentVm.name) || (quickTransferPaymentVm.isAmountError) || (!quickTransferPaymentVm.amount) || (!quickTransferPaymentVm.remark)){
					return false;
				}else{
					//validation on type wise fields
					if((quickTransferService.paymentType == "sbi") && ((quickTransferPaymentVm.showSBIAccountNumberError) || (quickTransferPaymentVm.isDuplicateAccNu) ||
					(quickTransferPaymentVm.account_number !== quickTransferPaymentVm.re_account_number) || (quickTransferPaymentVm.showReEnterSBIAccountNumberError))){
						return false;
					}
					else if((quickTransferService.paymentType == "other") && ((quickTransferPaymentVm.account_number !== quickTransferPaymentVm.re_account_number) || (quickTransferPaymentVm.isDuplicateAccNu)
					|| (quickTransferPaymentVm.showIFSCError) || (quickTransferPaymentVm.ifscEmptyError))){
						return false;
					}
					else if((quickTransferService.paymentType == "mobile") && ((!quickTransferPaymentVm.mmid) || (quickTransferPaymentVm.isInvalidMMID) || (!quickTransferPaymentVm.mobileNo) || (quickTransferPaymentVm.isInvalidMobile))){
						return false;
					}
					else{
						return true;
					}
				}
				
			}

			quickTransferPaymentVm.mChanged = function(type){
				if(type === "mmid"){
					if(quickTransferPaymentVm.mmid && quickTransferPaymentVm.mmid.length < 7){
						quickTransferPaymentVm.isInvalidMMID = true;
						quickTransferPaymentVm.isValidAllFields();
					}else{
						quickTransferPaymentVm.isInvalidMMID = false;
						quickTransferPaymentVm.isValidAllFields();
					}
				}else{
					if(quickTransferPaymentVm.mobileNo && quickTransferPaymentVm.mobileNo.length < 10){
						quickTransferPaymentVm.isInvalidMobile = true;
						quickTransferPaymentVm.isValidAllFields();
					}else{
						quickTransferPaymentVm.isInvalidMobile = false;
						quickTransferPaymentVm.isValidAllFields();
					}
				}
			}

			//Validate SBI Account Number - Should be 11 digits
			quickTransferPaymentVm.validateSBIAccountNumber = function(accNo){
				quickTransferPaymentVm.isDuplicateAccNu = false;
				quickTransferPaymentVm.showSBIAccountNumberError = !validationService.isValidSBIAccountNumber(accNo);
				quickTransferPaymentVm.commonFunForOwnAccAndDuplicate();
			}
			// quickTransferPaymentVm.validateAccNumber = function(){
			// 	quickTransferPaymentVm.commonFunctionalityForTocheckDuplicate();
			// 	quickTransferPaymentVm.commonFunctionalityForTocheckOwnAccount(quickTransferPaymentVm.account_number);
			// }

			quickTransferPaymentVm.commonFunForOwnAccAndDuplicate = function(){
				if(quickTransferPaymentVm.account_number && (quickTransferPaymentVm["selectedAccount"] && quickTransferPaymentVm["selectedAccount"]["accountNumber"])){
					if(quickTransferPaymentVm.account_number === quickTransferPaymentVm["selectedAccount"]["accountNumber"]){
						quickTransferPaymentVm.isDuplicateAccNu = true;
					}else{
						quickTransferPaymentVm.isDuplicateAccNu = false;
					}
				}
				quickTransferPaymentVm.isValidAllFields();

				for(var i=0;i < quickTransferPaymentVm.accLists.length;i++){
					if(quickTransferPaymentVm.accLists[i]["accountNumber"] === quickTransferPaymentVm.account_number){
						quickTransferPaymentVm.isOwnAccount = true;
						break;
					}else{
						quickTransferPaymentVm.isOwnAccount = false;
					}
				}
			}

			

			quickTransferPaymentVm.validateReEnterAccountNumber = function(accNo){
				quickTransferPaymentVm.showReEnterSBIAccountNumberError = !validationService.isValidSBIAccountNumber(accNo);
				quickTransferPaymentVm.isValidAllFields();
			}

			
			// quickTransferPaymentVm.validateOtherAccountNumber = function(accNo){
			// 	for(var i=0;i < quickTransferPaymentVm.accLists.length;i++){
			// 		if(quickTransferPaymentVm.accLists[i]["accountNumber"] === accNo){
			// 			quickTransferPaymentVm.isDuplicateAccNu = true;
			// 			break;
			// 		}
			// 		else{
			// 			quickTransferPaymentVm.isDuplicateAccNu = false;
			// 		}
			// 	}
			// 	quickTransferPaymentVm.isValidAllFields();
			// }

			// quickTransferPaymentVm.validateReEnterOtherAccountNumber = function(accNo){
			// 	quickTransferPaymentVm.showReEnterOtherAccountNumberError = !validationService.isValidOtherAccountNumber(accNo);
			// }

			//validate IFSC 
			quickTransferPaymentVm.validateIFSC = function(ifsc){
				if(!utilityService.isEmpty(ifsc)){
					quickTransferPaymentVm.showIFSCError = !validationService.isValidIFSC(ifsc);
					quickTransferPaymentVm.ifscEmptyError = false;
					quickTransferPaymentVm.isValidAllFields();
				}
				else{
					quickTransferPaymentVm.ifscEmptyError = true;
					quickTransferPaymentVm.showIFSCError = false;
					quickTransferPaymentVm.isValidAllFields();
				}
			}
			
			quickTransferPaymentVm.showPop = function(){
				if(quickTransferPaymentVm.accLists.length > 0)
				{
					quickTransferPaymentVm.popUp = $ionicPopup.show({
						title: '',
						cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
						templateUrl: 'pages/fundTransfer/quickTransfer/dropdownModal.html',
						scope: $scope
					});
				}
			}

			quickTransferPaymentVm.goToReview = function(type,qtForm){
				quickTransferPaymentVm.submitted = true;
				var isValidate = quickTransferPaymentVm.isValidAllFields();
				if(isValidate){
					if(qtForm.$valid){
						utilityService.showSpinner();
						try{
							
							var request = {
								"benName": quickTransferPaymentVm.name,
								//"benNickName": "",
								"benType": type !== "mobile" ? "account" : "mobile",
								"benIFSCCode": type === "other" ? quickTransferPaymentVm.ifsc : "",
								"amount": parseFloat(quickTransferPaymentVm.amount).toFixed(2),
								"intraBankFlag" : type === "sbi" ? "Y" : "N",
								"intCategory" : quickTransferPaymentVm.intCategory ? quickTransferPaymentVm.intCategory : "",
								"accountTypeCode" : quickTransferPaymentVm.accountTypeCode ? quickTransferPaymentVm.accountTypeCode : "",
								"customerType": customerInfoService.customer.type ? customerInfoService.customer.type :"",
								//"DOB" : "",
								"benAccntNo":quickTransferPaymentVm.account_number,							
								"remAccntNo":quickTransferPaymentVm.selectedAccount["accountNumber"],
								"branchCode":quickTransferPaymentVm.selectedAccount["branchCode"] ? quickTransferPaymentVm.selectedAccount["branchCode"] :"",
								//NRI
								"debitNriflag":quickTransferPaymentVm.selectedAccount["nriFlag"] ? quickTransferPaymentVm.selectedAccount["nriFlag"] :"",
								"creditTypeCode":quickTransferPaymentVm.accountTypeCode ? quickTransferPaymentVm.accountTypeCode : "",
								"creditIntCategory":quickTransferPaymentVm.intCategory ? quickTransferPaymentVm.intCategory : ""
							};
							if(type === "mobile"){
								request["benMMID"] = quickTransferPaymentVm.mmid;
							}
							//Set Values in common object 
							quickTransferService.paymentData = {
								senderAccNo:quickTransferPaymentVm.accountNumber,
								beneAccNo:quickTransferPaymentVm.account_number,
								beneName:quickTransferPaymentVm.name,
								ifsc:type === "other" ? quickTransferPaymentVm.ifsc : "",
								transAmount:quickTransferPaymentVm.amount,
								mmid:type === "mobile" ? quickTransferPaymentVm.mmid : "",
								beneMobileNo:type === "mobile" ? quickTransferPaymentVm.mobileNo : "",
								remark:quickTransferPaymentVm.remark,
								commisonAmt:'',
								channel:'',
								selectedAcc : quickTransferPaymentVm.selectedAccount,
								isTestTransaction: quickTransferPaymentVm.isTestPayChecked ? true : false,
								isOwnAccount : quickTransferPaymentVm.isOwnAccount ? true : false
							};
							quickTransferService.getTransactionFee(request).then(function(response) {
								utilityService.hideSpinner();
								quickTransferService.paymentData["commisonAmt"] = response.commisonAmt;
								quickTransferService.paymentData["channel"] = response.channel;
								$state.go('menu.quickTransferPaymentReview');
							}, function(error) {
								utilityService.hideSpinner();
								utilityService.showErrorMessage(error.responseMessage);
							});
						}
						catch(e){
							utilityService.hideSpinner();
							utilityService.showErrorMessage(e);
						}
					}
				}
				// else{
				// 	utilityService.showErrorMessage("Something went wrong. Please try after sometime.");
				// }
			
			}

			quickTransferPaymentVm.validateAmount = function(amt){
				var maxLimit = constantConfig.ft.qtDefaultMaxLimit;
				/* MOD changes start */
				if (getAccountDetailsService.accessRightsData.accounts) {
					for (var i in getAccountDetailsService.accessRightsData.accounts) {
						if (getAccountDetailsService.accessRightsData.accounts[i].accountNumber === quickTransferPaymentVm.accountNumber && getAccountDetailsService.accessRightsData.accounts[i].modBalance) {
							quickTransferPaymentVm.sumModAccountAmount = parseFloat(getAccountDetailsService.accessRightsData.accounts[i].modBalance) + parseFloat(quickTransferPaymentVm.balance);
							break;
						}
					}
				} else {
					quickTransferPaymentVm.sumModAccountAmount = parseFloat(quickTransferPaymentVm.balance);
				}
				/* MOD changes end */

				if(!quickTransferPaymentVm.isTestPayChecked){
					if(amt && amt >= 1){
						switch (validationService.isValidAmount(quickTransferPaymentVm.sumModAccountAmount, amt, maxLimit)) {
							case 0:
								quickTransferPaymentVm.isAmountError = false;
								quickTransferPaymentVm.amtErrMsg = "";
								quickTransferPaymentVm.isValidAllFields();
								break;
							case 1:
								quickTransferPaymentVm.isAmountError = true;
								quickTransferPaymentVm.amtErrMsg = quickTransferPaymentVm.validAmount;
								quickTransferPaymentVm.isValidAllFields();
								break;
							case 3:
								quickTransferPaymentVm.isAmountError = true;
								quickTransferPaymentVm.amtErrMsg = quickTransferPaymentVm.invalidMaxAmt;
								quickTransferPaymentVm.isValidAllFields();
								break;
							default:
								quickTransferPaymentVm.isAmountError = true;
								quickTransferPaymentVm.amtErrMsg = quickTransferPaymentVm.innsuffBal;
								quickTransferPaymentVm.isValidAllFields();
								break;
						}

					}else{
						quickTransferPaymentVm.isAmountError = true;
						quickTransferPaymentVm.amtErrMsg = quickTransferPaymentVm.lessThanZero;
						quickTransferPaymentVm.isValidAllFields();
					}
				}else{
					quickTransferPaymentVm.isAmountError = false;
					quickTransferPaymentVm.amtErrMsg = "";
					quickTransferPaymentVm.isValidAllFields();
				}
			}

			quickTransferPaymentVm.primaryAccount = function(){
				if(!quickTransferPaymentVm.isPayAgainClicked){
					//Primary account to be the default selected value of the account field. If primary account is not there, the account with highest available balance to be the default selected.
					var priAccount = $rootScope.customerAccNo;
					if(priAccount){
						for(var i=0; i<quickTransferPaymentVm.accLists.length;i++){
							if(priAccount == quickTransferPaymentVm.accLists[i]["accountNumber"]){
								quickTransferPaymentVm.close(quickTransferPaymentVm.accLists[i]);
								break;
							}
						}
					}
					else{
						var tmp = quickTransferPaymentVm.accLists.map(function(o) {return o["accountBalance"];});
						var maxValue = Math.max.apply(Math, tmp);
						//find the index using the tmp array, need to convert maxValue to a string since value is of type string
						var index = tmp.indexOf(parseFloat(maxValue).toFixed(2));
						for(var i=0; i<quickTransferPaymentVm.accLists.length;i++){
							if(index == i){
								quickTransferPaymentVm.close(quickTransferPaymentVm.accLists[i]);
								break;
							}
						}
					}
				}
				
			}

			quickTransferPaymentVm.close = function(acc){
				quickTransferPaymentVm.popUp ? quickTransferPaymentVm.popUp.close() : "";
				for(var i=0; i < quickTransferPaymentVm.accLists.length; i++){
					if(quickTransferPaymentVm.accLists[i]["accountNumber"] === acc["accountNumber"]){
						quickTransferPaymentVm.balance = quickTransferPaymentVm.accLists[i].accountBalance;
						quickTransferPaymentVm.accType = quickTransferPaymentVm.accLists[i].accountType;
						quickTransferPaymentVm.accountNumber = quickTransferPaymentVm.accLists[i].accountNumber;
						quickTransferPaymentVm.selectedAccount = quickTransferPaymentVm.accLists[i];
						quickTransferPaymentVm.intCategory = quickTransferPaymentVm.accLists[i].intCategory;
						quickTransferPaymentVm.accountTypeCode = quickTransferPaymentVm.accLists[i].accountTypeCode;
						quickTransferPaymentVm.commonFunForOwnAccAndDuplicate();
						//quickTransferPaymentVm.commonFunctionalityForTocheckOwnAccount(acc["accountNumber"]);
						break;
					}
				}
				
				quickTransferPaymentVm.validationOnAccountSelection(quickTransferPaymentVm.accountNumber);
				quickTransferPaymentVm.isValidAllFields();
			}

			quickTransferPaymentVm.validationOnAccountSelection = function(accNo){
				quickTransferPaymentVm.isValidAccount = false;
				quickTransferPaymentVm.showSelect = false;
				quickTransferPaymentVm.validAccountMessage = "";

				if(parseFloat(quickTransferPaymentVm.balance) < 0){
					quickTransferPaymentVm.isValidAccount = true;
					quickTransferPaymentVm.validAccountMessage = quickTransferPaymentVm.suffBalance;
					quickTransferPaymentVm.isValidAllFields();
				}
				else{
					/* Access Right changes start */
					if (!getAccountDetailsService.accessRightsData.accounts) {
						quickTransferPaymentVm.isValidAccount = true;
						quickTransferPaymentVm.validAccountMessage = quickTransferPaymentVm.fetchTransRights;
						quickTransferPaymentVm.isValidAllFields();
						return false;
					} else {
						for (var i in getAccountDetailsService.accessRightsData.accounts) {
							if (getAccountDetailsService.accessRightsData.accounts[i].accountNumber === accNo) {
								//Access rights check 
								//Account with “Limited” or “Full” Transaction rights (For Own account transfer - Limited rights, for other accounts - both within SBI or other banks - Full transaction rights)
								if (parseInt(getAccountDetailsService.accessRightsData.accounts[i].accessResponse) == 0) {
									quickTransferPaymentVm.isValidAccount = true;
									quickTransferPaymentVm.validAccountMessage = quickTransferPaymentVm.accTransRights;
									quickTransferPaymentVm.isValidAllFields();
									return false;
								}
								else{
									if (parseInt(getAccountDetailsService.accessRightsData.accounts[i].accessResponse) == 2) {
										if(!quickTransferPaymentVm.isOwnAccount){
											quickTransferPaymentVm.isValidAccount = true;
											quickTransferPaymentVm.validAccountMessage = quickTransferPaymentVm.accTransRights;
											quickTransferPaymentVm.isValidAllFields();
											return false;
										}
									}
										
								}
							}
						}
					}
				}
			}

			quickTransferPaymentVm.getSelectedAccount = function(accList){
				
				quickTransferPaymentVm.balance = accLists.accountBalance;
				quickTransferPaymentVm.accType = accLists.accountType;
				quickTransferPaymentVm.accountNumber = accLists.accountNumber;
				quickTransferPaymentVm.showSelect = false;
			}
			quickTransferPaymentVm.goBacktoPrevious = function(){
				quickTransferPaymentVm.submitted = false;
				//quickTransferPaymentVm.validateIFSC(quickTransferPaymentVm.ifsc);
				$state.go('menu.quickTransferLanding');
			}
			
   
			$scope.$on('$ionicView.beforeEnter', function() {
				quickTransferPaymentVm.remarkPurposes= quickTransferPaymentVm.getFTPurposes();
			
				quickTransferPaymentVm.getTransactionAPI();
			});
			$scope.$on('$ionicView.loaded', function () {
			initPage();
			});

			quickTransferPaymentVm.showSpinner = function () {
				if (utilityService.isAndroidPlatform()) {
					quickTransferPaymentVm.deregisterBackButton = $ionicPlatform.registerBackButtonAction(function (e) { }, 401);
				}
				quickTransferPaymentVm.spinnerPopup = $ionicPopup.show({
					cssClass: 'removePopupHeader removePopupBodyPading spinnerPopup',
					templateUrl: 'common/directives/templates/spinner.html'
				});
			}

			quickTransferPaymentVm.hideSpinner = function () {
				if (utilityService.isAndroidPlatform()) {
					quickTransferPaymentVm.deregisterBackButton();
				}
				quickTransferPaymentVm.spinnerPopup.close();
				setTimeout(function () {
					$scope.$apply(function () {
						quickTransferPaymentVm.primaryAccount();
					})
				});
			}

			quickTransferPaymentVm.getAccessRights = function(){
				quickTransferPaymentVm.showSpinner();
				if (!getAccountDetailsService.accessRightsData.accounts) {
					getAccountDetailsService.getAccountsAccessRights('').then(function (data) {
						getAccountDetailsService.accessRightsData = data;
						quickTransferPaymentVm.hideSpinner();
					}, function (error) {
						quickTransferPaymentVm.hideSpinner();
					});
				}else{
					quickTransferPaymentVm.hideSpinner();
				}
			}

			quickTransferPaymentVm.getTransactionAPI = function(){

				quickTransferService.getTransactions().then(function(response) {

					quickTransferPaymentVm.isShowLastTransBanner = true;
					if(response["transactionType"] === "SBIBank" || response["transactionType"] === "sbi"){
						response["transactionType"] = "sbi";
					}else if(response["transactionType"] === "otherBank" || response["transactionType"] === "other"){
						response["transactionType"] = "other";
					}else if(response["transactionType"] === "mobileNumber" || response["transactionType"] === "other"){
						response["transactionType"] = "mobile";
					}
					quickTransferPaymentVm.lastTransDetails = response;
					quickTransferPaymentVm.lastTransName = response["beneficiaryName"] ? response["beneficiaryName"] : "";
					quickTransferPaymentVm.lastTransAccNo = response["beneficiaryAccountNumber"] ? response["beneficiaryAccountNumber"] : "";
					quickTransferPaymentVm.getAccessRights();
				}, function(error) {
					//utilityService.showErrorMessage(error.responseMessage);
					quickTransferPaymentVm.getAccessRights();
				});
			}

			quickTransferPaymentVm.payAgainClick = function(){
				quickTransferPaymentVm.isPayAgainClicked = true;
				var details = quickTransferPaymentVm.lastTransDetails;
				if(Object.keys(details).length !== 0){
					quickTransferPaymentVm.name = details["beneficiaryName"] ? details["beneficiaryName"] : "";
					quickTransferPaymentVm.account_number = details["beneficiaryAccountNumber"] ? details["beneficiaryAccountNumber"] :"";
					quickTransferPaymentVm.re_account_number = details["beneficiaryAccountNumber"] ? details["beneficiaryAccountNumber"] : "";
					quickTransferPaymentVm.ifsc = details["ifscCode"] ? details["ifscCode"] : "";
					quickTransferPaymentVm.mmid = details["mmid"] ? details["mmid"] : "";
					quickTransferPaymentVm.mobileNo = details["mobileNo"] ? details["mobileNo"] : "";
					//quickTransferPaymentVm.isTestPayChecked = true;
					quickTransferService.paymentType = details["transactionType"];
					for(var i=0; i < quickTransferPaymentVm.accLists.length; i++){
						if(quickTransferPaymentVm.accLists[i]["accountNumber"] === details["senderAccountNumber"]){
							details["accountNumber"] = details["senderAccountNumber"];
							quickTransferPaymentVm.close(details);
							break;
						}
					}
					
					initPage();
				}
				
			}

			quickTransferPaymentVm.updateIfscList = function(ifsc){
				if (ifsc && ifsc.length > 2) {
					ftIFSCSearchService.searchIFSCCodes(ifsc).then(function(responseIFSCList) {
						quickTransferPaymentVm.ifscList = responseIFSCList;
					}, function(error) {
						//utilityService.showErrorMessage(error.responseMessage);
					});
				}
			}

			quickTransferPaymentVm.searchIFSC = function(value) {
				if (value && value.length > 2) {
					quickTransferPaymentVm.ifscEmptyError = false;
					utilityService.showSpinner();
					ftIFSCSearchService.searchIFSCCodes(value).then(function(responseIFSCList) {
						utilityService.hideSpinner();
						showPopup(responseIFSCList, value);
					}, function(error) {
						utilityService.hideSpinner();
						utilityService.showErrorMessage(error.responseMessage);
					});
				}
				else{
					quickTransferPaymentVm.ifscEmptyError = true;
					quickTransferPaymentVm.showIFSCError = false;
				}
			};

			/* Open ifsc popup */
			var showPopup = function(responseIFSCList, searchInput) {
				quickTransferPaymentVm.ifscList = responseIFSCList;
				$scope.ifscInput = searchInput;
				quickTransferPaymentVm.confirmPopup = $ionicPopup.show({
					templateUrl : 'pages/fundTransfer/quickTransfer/quickFTIFSCSearch.html',
					cssClass : 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head ',
					scope : $scope
				});
			};

			/* Navigates back to new beneficiary page after selecting the ifsc */
			quickTransferPaymentVm.goToMainPage = function() {
				quickTransferPaymentVm.confirmPopup.close();
				quickTransferPaymentVm.validateIFSC(quickTransferPaymentVm.ifsc);
			};

			quickTransferPaymentVm.saveIFSC = function(selectedItem,ifsc) {
				quickTransferService.paymentData["SelectedIFSCDetails"] = selectedItem;
				quickTransferPaymentVm.selectedIfsc = ifsc;
				quickTransferPaymentVm.ifsccode = ifsc;
				quickTransferPaymentVm.ifsc = ifsc;
			};


			var templateForMMID = '<ion-popover-view class="loginnewarrow qt_mmid_popover">' + 
															'<div class="qt_mmid_popover_upnew"></div>' +
															'<ion-content class="qt_mmid_ionicContent">' +
															'<div translate="YQP_LBL_MMID_HEADER_INFO" class="qt_mmid_header"></div>'+
															'<div class="roboto-light font-sixe-12 color3f3f3f" translate="YQP_LBL_MMID_INFO" style="padding-top: 13px;"></div> </ion-content>' + '</ion-popover-view>';
			quickTransferPaymentVm.mmidInfo = function($event){
				$scope.popover_hint = $ionicPopover.fromTemplate(templateForMMID, {
					scope : $scope
				});
				$scope.popover_hint.show($event);
			}

			quickTransferPaymentVm.setTestPayMethod = function(isChecked){
				if(isChecked){
					quickTransferPaymentVm.amount = "1.00";
				}
				else{
					quickTransferPaymentVm.amount = "";
				}
				quickTransferPaymentVm.validateAmount(quickTransferPaymentVm.amount);
				//quickTransferPaymentVm.isValidAllFields();
			}
			

			quickTransferPaymentVm.updateRemark =function(){
				quickTransferPaymentVm.remark=quickTransferPaymentVm.remarkOther;		
			} 
			quickTransferPaymentVm.updatePurpose = function(){
				if(quickTransferPaymentVm.remarkPurpose=="Others"){					

						quickTransferPaymentVm.remark="";
						$ionicScrollDelegate.scrollBottom();
											
									
				}
				else{
					quickTransferPaymentVm.remarkOther="";
					quickTransferPaymentVm.remark=quickTransferPaymentVm.remarkPurpose;
					
				}
				
				}
				quickTransferPaymentVm.getFTPurposes = function(){
				
					quickTransferService.getFTPurposes().then(function(data){
					quickTransferPaymentVm.remarkPurposes=data.remarkPurposes;
				},function (error) {
				utilityService.showErrorMessage(error.responseMessage);
				}
				); 
				
			}
			
			



			return this;
		}

		
]);


