'use strict';
angularApp.controller('quickTransferPaymentReviewController', [
		"$state",
		"$scope",		
		"utilityService",
		"quickTransferService",
		"$translate",
		"getAccountDetailsService",
		"$ionicPopup",
		"$ionicViewSwitcher",
		"customerInfoService",
		"constantConfig",
		"fTSetOTPService",
		"cryptoService",
		function($state, 
		$scope,
		utilityService,
		quickTransferService,
		$translate,
		getAccountDetailsService,
		$ionicPopup,
		$ionicViewSwitcher,
		customerInfoService,
		constantConfig,
		fTSetOTPService,
		cryptoService) {
			
			var quickTransferPaymentReviewVm = this;

			function initPage(){
				var pay_type = "";
				
				quickTransferPaymentReviewVm.pay_type = quickTransferService.paymentType ? quickTransferService.paymentType : "sbi";

				if(quickTransferService.paymentType == 'sbi'){
					pay_type = 'SBI A/C';
				}
				else if(quickTransferService.paymentType == 'other'){
					pay_type = 'OTHER BANK A/C';
				}
				else if(quickTransferService.paymentType == 'mobile'){
					pay_type = 'MOBILE NUMBER';
				}
				$translate(['QT_HEADER'], {type: pay_type }).then(function (translations) {
                    quickTransferPaymentReviewVm.header_txt = translations['QT_HEADER'];
                });
			
				quickTransferPaymentReviewVm.showSelect = true;
				quickTransferPaymentReviewVm.accLists = getAccountDetailsService.accountOverviewData.accounts;

				//quickTransferService.paymentData;
                quickTransferPaymentReviewVm.payingFrom = quickTransferService.paymentData["senderAccNo"];
				quickTransferPaymentReviewVm.beneAccNo = quickTransferService.paymentData["beneAccNo"];
				quickTransferPaymentReviewVm.beneName = quickTransferService.paymentData["beneName"];
				quickTransferPaymentReviewVm.mmid = quickTransferService.paymentData["mmid"];
				quickTransferPaymentReviewVm.beneMobileNo = quickTransferService.paymentData["beneMobileNo"];
				quickTransferPaymentReviewVm.remark = quickTransferService.paymentData["remark"];
				quickTransferPaymentReviewVm.transAmount = quickTransferService.paymentData["transAmount"];
				quickTransferPaymentReviewVm.commisonAmt = quickTransferService.paymentData["commisonAmt"];
			}
   
			$scope.$on('$ionicView.beforeEnter', function() {
				initPage();
				
			});
			$scope.$on('$ionicView.loaded', function () {
			
			});

			quickTransferPaymentReviewVm.gotoHome = function(){
				$ionicViewSwitcher.nextDirection('back');
				$state.go("menu.quickTransferLanding");
			}
			quickTransferPaymentReviewVm.goNext = function(){
				$state.go("menu.quickTransferOTPView");
				//Generate OTP
			}
			quickTransferPaymentReviewVm.goBack = function(){
				$ionicViewSwitcher.nextDirection('back');
				$state.go("menu.quickTransferPayment");
			}

			return this;
		}

		
]);


