'use strict';

angularApp.controller('quickTransferProfilePasswordController',
    ["$state",
    "$scope",		
    "utilityService",
    "quickTransferService",
    "$translate",
    "getAccountDetailsService",
    "$ionicPopup",
    "validationService",
    "ftIFSCSearchService",
    "$ionicViewSwitcher",
    "loggedInUserService",
    "fTReviewService",
    "customerInfoService",
    function (
        $state, 
		$scope,
		utilityService,
		quickTransferService,
		$translate,
		getAccountDetailsService,
		$ionicPopup,
		validationService,
		ftIFSCSearchService,
        $ionicViewSwitcher,
        loggedInUserService,
        fTReviewService,
        customerInfoService) {

        var quickTransferProfilePasswordVm = this;
        quickTransferProfilePasswordVm.isTextReadable = false;
        quickTransferProfilePasswordVm.isTextReadablereEnter = false;
        quickTransferProfilePasswordVm.isPrfPwdError = false;

       function initPage(){
            var pay_type = "";
            
            quickTransferProfilePasswordVm.pay_type = quickTransferService.paymentType ? quickTransferService.paymentType : "sbi";

            if(quickTransferService.paymentType == 'sbi'){
                pay_type = 'SBI A/C';
            }
            else if(quickTransferService.paymentType == 'other'){
                pay_type = 'OTHER BANK A/C';
            }
            else if(quickTransferService.paymentType == 'mobile'){
                pay_type = 'MOBILE NUMBER';
            }
            $translate(['QT_HEADER'], {type: pay_type }).then(function (translations) {
                quickTransferProfilePasswordVm.header_txt = translations['QT_HEADER'];
            });
       }

       quickTransferProfilePasswordVm.gotoHome = function(){
            $ionicViewSwitcher.nextDirection('back');
            $state.go("menu.quickTransferLanding");
       }

       quickTransferProfilePasswordVm.gotoRelationship = function(){
           //quickTransferService.isAddBeneficiaryBtnClcked = false;
           $state.go("menu.accountOverviewMyBalance");
       }

       quickTransferProfilePasswordVm.toggleSecretAns = function () {
            quickTransferProfilePasswordVm.isTextReadable == true ? quickTransferProfilePasswordVm.isTextReadable = false : quickTransferProfilePasswordVm.isTextReadable = true;
        };
        quickTransferProfilePasswordVm.toggleReEnter = function () {
            quickTransferProfilePasswordVm.isTextReadablereEnter == true ? quickTransferProfilePasswordVm.isTextReadablereEnter = false : quickTransferProfilePasswordVm.isTextReadablereEnter = true;
        };
        quickTransferProfilePasswordVm.forgotpassPopup = function () {
            var havingMPINPrblmPopUp = $ionicPopup.show({
                template: "<p> If you have forgotton your profile password, you can reset the same yourself. You need to  authenticate yourself either with the hint question and answer that you had set for the Profile password or ATM Card details & PIN. You can approach branch in case you don't remember Hint Question/answer or ATM card details & PIN </p>",
                title: '',
                cssClass: 'dialog',
                scope: $scope,
                buttons: [{
                    text: 'OK',
                    type: 'button-positive'
                }]
            });
        };

        quickTransferProfilePasswordVm.forgotPass = function () {
            $state.go('menu.forgotProfilePwd');
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        quickTransferProfilePasswordVm.validateProfilePwd = function () {
            var loggedInUserDetails = loggedInUserService.getUserProfileDetails();
            if (quickTransferProfilePasswordVm.newProfilePassword) {
                quickTransferProfilePasswordVm.isPrfPwdError = false;
                fTReviewService.getProfilePassAndSerKey().then(function (response) {
                     var options = {
						inbUserName:loggedInUserDetails.inbUsername,
						strPass:quickTransferProfilePasswordVm.newProfilePassword,
						keyId:response.keyId,
						serviceId:response.serviceId,
						osName:device.platform
					};
					var reqParams = utilityService.commonRequestForValidateProfilePass(options);
                    fTReviewService.getProfilePassAuth(reqParams).then(function (data) {
                        //Call add Beneficiary service
                        quickTransferProfilePasswordVm.addBeneficiary();
                    }, function (error) {
                        if (error.responseCode == "INB.AUTH.016") {
                            // quickTransferProfilePasswordVm.myPopup = $ionicPopup.show({
                            //     title: '',
                            //     cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
                            //     templateUrl: 'pages/fundTransfer/fundsTransfer/profilePassUnblockPopUp.html',
                            //     scope: $scope
                            // })
                            utilityService.showErrorMessage(error.responseMessage);
                        } else {
                            utilityService.showErrorMessage(error.responseMessage);
                        }
                    });
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else {
                quickTransferProfilePasswordVm.isPrfPwdError = true;
            }
        };

        quickTransferProfilePasswordVm.addBeneficiary = function(){
            quickTransferService.paymentData["isAddBeneficiary"] = true;
             var loggedInUserDetails = loggedInUserService.getUserProfileDetails();
             var type = '';
             if(quickTransferService.paymentType==='sbi'){
                type = "intra";
             }
             else if(quickTransferService.paymentType==='other'){
                type = "inter";
             }
             else{
                type = "mobile";
             }
            var reqParams = {
                cif: "",
                inbUserId: loggedInUserDetails.inbUsername,
                benNickName: quickTransferService.paymentData["beneNickName"],
                benIfscCode: quickTransferService.paymentData["ifsc"],
                benType: quickTransferService.paymentType,
                benAccntNo: quickTransferService.paymentData["beneAccNo"],
                remName: (customerInfoService.customer && customerInfoService.customer.name) ? customerInfoService.customer.name : "",
                benBranchName: quickTransferService.paymentData["SelectedIFSCDetails"] ? quickTransferService.paymentData["SelectedIFSCDetails"]["branch"] : "",
                remMobileNo: (customerInfoService.customer && customerInfoService.customer.mobile) ? customerInfoService.customer.mobile : "",
                benMobileNo: quickTransferService.paymentData["beneMobileNo"],
                benMMID: quickTransferService.paymentData["mmid"],
                remBranchCode: quickTransferService.paymentData["selectedAcc"]["branchCode"],
                transferLimit: quickTransferService.paymentData["maxLimit"],
                type: type
            };
            quickTransferService.addBeneficiary(reqParams).then(function(response){
                $state.go("menu.quickTransferSuccessView");
            }, function (error) {
                $ionicViewSwitcher.nextDirection('back');
                utilityService.showBhimUpiAlert('error',error.responseMessage,'menu.quickTransferLanding');
            });
        }
}]);