angularApp.service('quickTransferService',
	function ($q, utilityService, AdapterUtils, $state, $ionicPopup,constantConfig) {
		var quickTransferService = this;
		quickTransferService.paymentType = "";
		quickTransferService.isAddBeneficiaryBtnClcked = false;
		quickTransferService.paymentData = {};
		quickTransferService.getFTPurposes = function () {
			console.log("Service: getRemarkPurposes");        
			  var q = $q.defer();
			  AdapterUtils.postData("adapters/FundsTransferAdapter/getRemarkPurposes", {}, false).then(
					  function (response) {
							  q.resolve(response.data);
					  },
					  function (error) {
							  q.reject(error);
					  }
			  );
			  return q.promise;
		  };
		quickTransferService.clearVars = function(){
			quickTransferService.paymentType = "";
			quickTransferService.paymentData = {};
		}
		quickTransferService.payToContact = function (params) {
			var q = $q.defer();
			AdapterUtils.postData(constantConfig.quickTransferAdapterURL.payToContact, params, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		quickTransferService.getTransactions = function (params) {
			var q = $q.defer();
			AdapterUtils.postData(constantConfig.quickTransferAdapterURL.getTransaction, {}, false).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		quickTransferService.getTransactionFee = function (params) {
			var q = $q.defer();
			AdapterUtils.postData(constantConfig.quickTransferAdapterURL.getTransactionFeeQuickTransfer, params, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		quickTransferService.transferFunds = function(params) {
			var q = $q.defer();
			AdapterUtils.postData(constantConfig.quickTransferAdapterURL.transferFundsQuickTransfer, params, true).then(
				function(response) {
					q.resolve(response.data);
				},
				function(error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		quickTransferService.generateOTP = function(requestData) {
			var q = $q.defer();	
			AdapterUtils.postData(constantConfig.quickTransferAdapterURL.getOTPTokenSecure,requestData,true).then(function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}); 
			return q.promise;
		};
		
		//Validate OTP
		quickTransferService.validateOTP = function(requestData) {
			var q = $q.defer();	
			AdapterUtils.postData(constantConfig.quickTransferAdapterURL.validateOTP,requestData,true).then(function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}); 
			return q.promise;
		};

		//Add Beneficary
		quickTransferService.addBeneficiary = function(requestData) {
			var q = $q.defer();	
			AdapterUtils.postData(constantConfig.quickTransferAdapterURL.addBeneficiary,requestData,true).then(function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}); 
			return q.promise;
		};

		
		return quickTransferService;
	});  
