'use strict';

angularApp.controller('quickTransferSuccessController',
    ["$state",
    "$scope",		
    "utilityService",
    "quickTransferService",
    "$translate",
    "getAccountDetailsService",
    "$ionicPopup",
    "validationService",
    "ftIFSCSearchService",
    "$ionicViewSwitcher",
    function (
        $state, 
		$scope,
		utilityService,
		quickTransferService,
		$translate,
		getAccountDetailsService,
		$ionicPopup,
		validationService,
		ftIFSCSearchService,
        $ionicViewSwitcher) {

       var quickTransferSuccessVm = this;

       function initPage(){
            var pay_type = "";
            quickTransferSuccessVm.isAddBeneficiary = quickTransferService.paymentData["isAddBeneficiary"] ? quickTransferService.paymentData["isAddBeneficiary"] : false;
            if(quickTransferSuccessVm.isAddBeneficiary){
                quickTransferSuccessVm.nickName = quickTransferService.paymentData["beneNickName"];
            }else{
                quickTransferSuccessVm.paidToName = quickTransferService.paymentData["beneName"];
                quickTransferSuccessVm.paidAmount = quickTransferService.paymentData["transAmount"];
                quickTransferSuccessVm.inAcc = quickTransferService.paymentData["senderAccNo"];
                quickTransferSuccessVm.remBalance = quickTransferService.paymentData["remBalance"];
            }

            quickTransferSuccessVm.pay_type = quickTransferService.paymentType ? quickTransferService.paymentType : "sbi";

            if(quickTransferService.paymentType == 'sbi'){
                pay_type = 'SBI A/C';
            }
            else if(quickTransferService.paymentType == 'other'){
                pay_type = 'OTHER BANK A/C';
            }
            else if(quickTransferService.paymentType == 'mobile'){
                pay_type = 'MOBILE NUMBER';
            }
            $translate(['QT_HEADER'], {type: pay_type }).then(function (translations) {
                quickTransferSuccessVm.header_txt = translations['QT_HEADER'];
            });

            if(getAccountDetailsService.accountOverviewData){
                quickTransferPaymentVm.accLists = getAccountDetailsService.accountOverviewData.accounts;
                quickTransferPaymentVm.primaryAccount();
            }
            else{
                utilityService.showSpinner();
                getAccountDetailsService.getAccountDetails().then(function (data) {
                    utilityService.hideSpinner();
                    getAccountDetailsService.accountOverviewData = data;
                }, function(error) {
                    utilityService.hideSpinner();
                });
            }
       }

       quickTransferSuccessVm.gotoHome = function(){
            $ionicViewSwitcher.nextDirection('back');
            $state.go("menu.quickTransferLanding");
       }

       quickTransferSuccessVm.gotoRelationship = function(){
            quickTransferService.isAddBeneficiaryBtnClcked = false;
            $state.go("menu.accountOverviewMyBalance");
       }

       quickTransferSuccessVm.addBeneficiary = function(){
           quickTransferService.isAddBeneficiaryBtnClcked = true;
           $state.go("menu.quickTransferAddBeneView");
       }

        $scope.$on('$ionicView.beforeEnter', function() {
            getAccountDetailsService.accountOverviewData = "";
            initPage();
        });
}]);