angularApp.service('fTReviewDetailsService', function($q, AdapterUtils, constantConfig, cryptoService) {

    var ReviewService = this;

    ReviewService.transferFunds = function(fromAccountNo, beneficiary, charge, timeStamp, checkTnC,
        branchCodeFromAcc, remName, remAdd1) {
        var q = $q.defer();
		beneficiary.nickName = beneficiary.nickName ? beneficiary.nickName.toString() : "";
		beneficiary.mmid = beneficiary.mmid ? beneficiary.mmid.toString() : "";
		beneficiary.transAmount = beneficiary.transAmount ? beneficiary.transAmount.toString() : "";
		beneficiary.accountNoData = beneficiary.accountNoData ? beneficiary.accountNoData.toString() : "";
        var funds = {
            "benName": beneficiary.nameData,
            "benNickName": beneficiary.nickName,
            "benType": beneficiary.benType,
            "accountCategory": beneficiary.accountCategory,
            "benMobileNo": beneficiary.mobileNo,
            "benAccntNo": beneficiary.accountNoData,
            "remAccntNo": fromAccountNo,
            "amount": beneficiary.transAmount,
            "transactionFee": charge,
            "remarks": beneficiary.remarks,
            "remMMID": "",
            "benMMID": beneficiary.mmid ? beneficiary.mmid : "",
            "intraBankFlag": beneficiary.intraBankFlag,
            "isOwnAccntFlag": beneficiary.isOwnAccntFlag,
            "txnType": "",
            "otpTimeStamp": timeStamp,
            "termsNcondition": checkTnC,
            "remBranchCode": branchCodeFromAcc,
            "benIFSCCode": beneficiary.ifsc ? beneficiary.ifsc : "",
            "benStatus": beneficiary.benStatus ? beneficiary.benStatus : "",
            "remName": remName ? remName : "",
            "benCountryCode": "91",
            "amtsh": (cryptoService.getSHA512EncryptedData(beneficiary.transAmount + beneficiary.nickName + beneficiary.accountNoData + beneficiary.mmid + fromAccountNo.toString())).toString()
        };

        AdapterUtils.postData(constantConfig.ftAdapterUrl.transferFunds, funds, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };
    ReviewService.schedulePayment = function(fromAccountNo, beneficiary, charge, timeStamp, checkTnC, branchCodeFromAcc, remName, remAdd1) {
        var q = $q.defer();
        var scheduleFunds = {
            "benName": beneficiary.nameData,
            "benNickName": beneficiary.nickName,
            "benType": beneficiary.benType,
			"accountCategory": beneficiary.accountCategory,
            "benAccntNo": beneficiary.accountNoData,
            "benMMID": beneficiary.mmid,
            "remMMID": beneficiary.remMMID,
            "benMobileNo": beneficiary.mobileNo,
            "remAccntNo": fromAccountNo,
            "amount": beneficiary.transAmount,
            "transactionFee": charge,
            "remarks": beneficiary.remarks,
            "siFrequency": beneficiary.siFrequency,
            "siCount": beneficiary.siCount,
            "siDate": beneficiary.scheduleDate,
            "intraBankFlag": beneficiary.intraBankFlag,
            "otpTimeStamp": timeStamp,
            "isOwnAccntFlag": beneficiary.isOwnAccntFlag,
            "termsNcondition": checkTnC,
            "benIFSCCode": beneficiary.ifsc ? beneficiary.ifsc : "",
            "benStatus": beneficiary.benStatus ? beneficiary.benStatus : "",
            "remName": remName ? remName : "",
            "remAdd1": remAdd1 ? remAdd1 : "",
            "remAdd2": "",
            "remAdd3": "",
            "benCountryCode": "91",
            "remBranchCode": branchCodeFromAcc,
            "remMobileNo": "",
            "remEmail": ""
        };

        AdapterUtils.postData(constantConfig.ftAdapterUrl.schedulePayment, scheduleFunds, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            });
        return q.promise;
    };

    return ReviewService;

});
