'use strict';

angularApp.controller('reviewController', [
    "$state",
    "$scope",
    "$rootScope",
    "$ionicPopup",
    "fTReviewService",
    "fTReviewDetailsService",
    "fTBeneficiaryService",
    "fTScheduleReviewService",
    "utilityService",
    "fTSetOTPService", "customerInfoService", "getAccountDetailsService","cryptoService","constantConfig", "autoOtpReadService","$filter",

    function($state,
        $scope,
        $rootScope,
        $ionicPopup,
        fTReviewService,
        fTReviewDetailsService,
        fTBeneficiaryService,
        fTScheduleReviewService,
        utilityService,
        fTSetOTPService, customerInfoService, getAccountDetailsService,cryptoService,constantConfig, autoOtpReadService,$filter) {

        var reviewVm = this;
        $scope.isOTP = false;
        reviewVm.clearFlag = false;
        reviewVm.isValidOtp = true;
        reviewVm.otp = '';
        reviewVm.loggedInUserMobNo = $rootScope.mobileNo;
        //reviewVm.checkTnC = true;
        reviewVm.disableNext = false;
        reviewVm.sendOTP = function () {
            reviewVm.otp="";
            reviewVm.generateOTP();
        }

        //Validate OTP
        reviewVm.validateOTP = function () {
            reviewVm.disableNext = true;
            var reqParams = {};
            reqParams["otp"] = reviewVm.otp;
            reqParams["mobile"] = customerInfoService.customer.mobile;

            fTSetOTPService.validateOTP(reqParams).then(function (data) {
                if (data.status.toLowerCase() === 'success') {
                    var timeStamp = Math.floor(Date.now() / 1000);
                    if (reviewVm.date != '')
                        reviewVm.SchedulePopup(timeStamp);
                    else reviewVm.SuccessPopup(timeStamp);
                } else {
                    utilityService.showErrorMessage(data.status);
                    reviewVm.otp = '';
                    reviewVm.clearFlag = true;
                    reviewVm.isValidOtp = false;
                    reviewVm.disableNext = false;
                }
            }, function (error) {
                reviewVm.disableNext = false;
                utilityService.showErrorMessage(error.responseMessage);
            });
        };

        reviewVm.generateOTPOnce = function () {

            $scope.isDisableOTP++;
            reviewVm.generateOTP();

        };

        //Generate OTP
        reviewVm.generateOTP = function () {
            if (fTBeneficiaryService.customer.isOwnAccntFlag.toLowerCase() == 'n') {
                var reqParams = {};
                reqParams["id"] = customerInfoService.customer.mobile;
                if (reviewVm.date != '') {
                    reqParams.otpCode = constantConfig.keysForOTP.ftScheduleFundTransfer;
                    reqParams.ocHash = cryptoService.getSHA512EncryptedData(constantConfig.keysForOTP.ftScheduleFundTransfer).toString();

                } else {
                    reqParams.otpCode = constantConfig.keysForOTP.ftNormalFundTransfer;
                    reqParams.ocHash = cryptoService.getSHA512EncryptedData(constantConfig.keysForOTP.ftNormalFundTransfer).toString();
                }

                $scope.isOTP = true;
                fTSetOTPService.generateOTP(reqParams).then(function (data) {
                    // Disabling below code to hide autoreadotp popup
                    // if (utilityService.isAndroidPlatform()) {
                    //     autoOtpReadService.startOtpReading().then(function (result) {
                    //         reviewVm.otp = result;
                    //     }, function (error) {
                    //         console.log(error);
                    //     });
                    // }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
			}else if(fTBeneficiaryService.customer.isOwnAccntFlag.toLowerCase() == 'y'){
				var timeStamp = Math.floor(Date.now() / 1000);
				if (reviewVm.date != '')
					reviewVm.SchedulePopup(timeStamp);
				else reviewVm.SuccessPopup(timeStamp);
			}
        }

        //close OTP screen
        reviewVm.closeViewOTP = function() {
            $scope.isOTP = false;
        };

        //show success popup
        reviewVm.SuccessPopup = function(timeStamp) {
            var remName = customerInfoService.customer.name ? customerInfoService.customer.name : "";
            var remAdd1 = customerInfoService.customer.address ? customerInfoService.customer.address : "";
            reviewVm.nameData = fTBeneficiaryService.customer.nickName;
            reviewVm.accountNoData = fTBeneficiaryService.selectedDetails;
            if (fTBeneficiaryService.customer.frequentAmount > 0) {
                fTBeneficiaryService.customer.transAmount = fTBeneficiaryService.customer.frequentAmount;
            }
            fTBeneficiaryService.customer.benStatus = "";
            if (fTBeneficiaryService.customer.isActive == 'Y') {
                fTBeneficiaryService.customer.benStatus = "ACTIVATED";
            }
            var branchCodeFromAcc = fTBeneficiaryService.selectedDetails.branchCode ? fTBeneficiaryService.selectedDetails.branchCode : "";
            var benBranchCode = fTReviewService.benBranchCode ? fTReviewService.benBranchCode : "";
            var benBranchName = fTReviewService.benBranchName ? fTReviewService.benBranchName : "";
            var benAccntCat = fTReviewService.benAccntCat ? fTReviewService.benAccntCat : "";
            fTReviewDetailsService.transferFunds(reviewVm.payingFrom.accountNo, fTBeneficiaryService.customer, reviewVm.charges, timeStamp, reviewVm.checkTnC,
                branchCodeFromAcc, remName, remAdd1, benBranchCode, benBranchName, benAccntCat).then(function (data) {
                    try {
                        fTBeneficiaryService.imagesLoaded = false;
                        if (data.responseCode == "00") {
                            if (data.storeRefNumber) {
                                var nightModePopup = $ionicPopup.show({
                                    template: '<p>The Transaction window has elapsed for today.Your Transaction is scheduled for next working day. </p>',
                                    title: '',
                                    cssClass: 'dialog',
                                    scope: $scope,
                                    buttons: [{
                                        text: 'OK',
                                        type: 'button-positive',
                                        onTap: function (e) {
                                            fTBeneficiaryService.schTransItems = "";
                                            fTBeneficiaryService.beneficiaries = "";
                                            getAccountDetailsService.accountOverviewData = '';
                                            $state.go('menu.fundsTransfer');
                                        }
                                    }]
                                });
                            } else {
                                var balanceData = data.balance;
                                //reviewVm.balance = parseFloat(balanceData).toFixed(2);
                                if(balanceData !="" && balanceData!=undefined) //added by lalita YONOIT - 1522
                               {
                                   reviewVm.balance = parseFloat(balanceData).toFixed(2);
                               }
                               else
                               {
                               reviewVm.balance ="";
                               }
                                reviewVm.successPopupData = $ionicPopup.show({
                                    title: '',
                                    cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
                                    templateUrl: 'pages/fundTransfer/review/fTSuccessPopup.html',
                                    scope: $scope
                                });
                            }
                        } else {
                            if (data.storeRefNumber) {
                                var nightModePopup = $ionicPopup.show({
                                    template: '<p>The Transaction window has elapsed for today.Your Transaction is scheduled for next working day. </p>',
                                    title: '',
                                    cssClass: 'dialog',
                                    scope: $scope,
                                    buttons: [{
                                        text: 'OK',
                                        type: 'button-positive',
                                        onTap: function (e) {
                                            fTBeneficiaryService.schTransItems = "";
                                            fTBeneficiaryService.beneficiaries = "";
                                            getAccountDetailsService.accountOverviewData = '';
                                            $state.go('menu.fundsTransfer');
                                        }
                                    }]
                                });
                            } else {
                                var error = data.errorLog || 'Error';
                                fTBeneficiaryService.showErrorModal('', null, 'menu.fundsTransfer', $scope, $state, error);
                            }
                        }
                    } catch (e) { }
                }, function (error) {
                    fTBeneficiaryService.showErrorModal('', null, 'menu.fundsTransfer', $scope, $state, error.responseMessage);
                });
        };

        reviewVm.SchedulePopup = function (timeStamp) {
            var branchCodeFromAcc = fTBeneficiaryService.selectedDetails.branchCode ? fTBeneficiaryService.selectedDetails.branchCode : "";
            var remName = customerInfoService.customer.name ? customerInfoService.customer.name : "";
            var remAdd1 = customerInfoService.customer.address ? customerInfoService.customer.address : "";
            if (fTBeneficiaryService.customer.frequentAmount > 0) {
                fTBeneficiaryService.customer.transAmount = fTBeneficiaryService.customer.frequentAmount;
            }
            fTBeneficiaryService.customer.benStatus = "";
            if (fTBeneficiaryService.customer.isActive == 'Y') {
                fTBeneficiaryService.customer.benStatus = "ACTIVATED";
            };
            fTReviewDetailsService.schedulePayment(reviewVm.payingFrom.accountNo, fTBeneficiaryService.customer, reviewVm.charges, timeStamp, reviewVm.checkTnC,
                branchCodeFromAcc, remName, remAdd1).then(function (data) {

                try {
                    reviewVm.schedulePopup = $ionicPopup.show({
                        title: '',
                        cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
                        templateUrl: 'pages/fundTransfer/review/fTSchedulePopup.html',
                        scope: $scope
                    });
                } catch (e) {}
            }, function(error) {
				fTBeneficiaryService.showErrorModal('', null, 'menu.fundsTransfer', $scope, $state, error.responseMessage);
            });
        };

        reviewVm.goToBack = function() {
            $state.go('menu.fTPaymentDetails');
        }

        reviewVm.goToSuccessPopup = function() {
            reviewVm.successPopupData.close();
            getAccountDetailsService.accountOverviewData = "";
            fTBeneficiaryService.customer.scheduleDate = "";
            fTBeneficiaryService.customer.remarks = "";
            fTBeneficiaryService.schTransItems = "";
            fTBeneficiaryService.beneficiaries = "";
            getAccountDetailsService.accountOverviewData = '';
                        
            fTBeneficiaryService.remarkPurpose="";
            fTBeneficiaryService.remarkOther="";

                         
                       
            $state.go("menu.fundsTransfer")
        }

        reviewVm.goToSchedulePopup = function() {
            reviewVm.schedulePopup.close();
            getAccountDetailsService.accountOverviewData = "";
            fTBeneficiaryService.customer.scheduleDate = "";
            fTBeneficiaryService.customer.remarks = "";
            fTBeneficiaryService.schTransItems = "";
            fTBeneficiaryService.beneficiaries = "";
            getAccountDetailsService.accountOverviewData = '';
            
            fTBeneficiaryService.remarkPurpose="";
            fTBeneficiaryService.remarkOther="";
            
            
            $state.go("menu.fundsTransfer")
        }

        $scope.goToHome = function() {
            $state.go('menu.fundsTransfer');
        }

        //this function is define to call terms and conditions service
        $scope.openTC = function(type) {
            var reqParams = {
                "type": type
            }
            fTBeneficiaryService.getTermsCondition(reqParams).then(
                function(data) {
                    $scope.termsConditions = data;
                    $state.go('menu.ftTerms', {
                        obj: $scope.termsConditions
                    });
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                }
            );
        };

        reviewVm.maskEmail = function (str) {
         return str[0] + "X".repeat(str.length - 2) + str.slice(-1);
        }
        reviewVm.maskEmail2 = function (str) {
        return str[0] + "X".repeat(str.length - 1) ;
        }
        reviewVm.maskcustEmail=function(email){
           var arr = email.split("@");
           //var arr2=arr[1].split(".",1);
          var firstDotIndex = arr[1].indexOf('.');
          var emailFirstPart = arr[1].substring(0, firstDotIndex);
          var emailSecondPart = arr[1].substring(firstDotIndex + 1);
          reviewVm.maskedEmailID=reviewVm.maskEmail2(arr[0]) + "@" + reviewVm.maskEmail(emailFirstPart)+"."+emailSecondPart;
        }
        $scope.$on('$ionicView.beforeEnter', function() {
            $scope.isOTP = false;
            reviewVm.clearFlag = false;
            reviewVm.isValidOtp = true;
            reviewVm.otp = '';
            reviewVm.mmid = fTBeneficiaryService.customer.mmid;
            reviewVm.imgData = fTBeneficiaryService.customer.conImg;
            reviewVm.payingTo = {
                img: reviewVm.imgData,
                name: fTBeneficiaryService.customer.nameData,
                bank: fTBeneficiaryService.customer.bankData,
                accountNo: fTBeneficiaryService.customer.accountNoData,
                nickName: fTBeneficiaryService.customer.nickName,
                benType: fTBeneficiaryService.customer.benType,
                ifsc: fTBeneficiaryService.customer.ifsc,
                intraBankFlag: fTBeneficiaryService.customer.intraBankFlag
            };
            reviewVm.payingFrom = fTBeneficiaryService.selectedDetails;
            if (fTBeneficiaryService.customer.accountType === "Frequent Transfer") {
                reviewVm.amount = fTBeneficiaryService.customer.frequentAmount.toFixed(2);
            } else {
                reviewVm.amount = fTBeneficiaryService.customer.transAmount.toFixed(2);
            }
            if (fTReviewService.tncChannel == 'INTRABANK') {
                reviewVm.tncType = 'GRPT';
            } else {
                reviewVm.tncType = fTReviewService.tncChannel.slice(0, 4)
            }
            reviewVm.date = fTBeneficiaryService.customer.scheduleDate || '';
            reviewVm.remarks = fTBeneficiaryService.customer.remarks;
            reviewVm.charges = fTReviewService.transactionFee;
            reviewVm.mobileNo = fTBeneficiaryService.customer.mobileNo;
            $scope.isDisableOTP = 0;
            // AMS-646
            if($rootScope.customerInfoForProfile!="" &&  $rootScope.customerInfoForProfile!=undefined){
                reviewVm.emailID = $rootScope.customerInfoForProfile.emailID;
                if(reviewVm.emailID!="" &&reviewVm.emailID!=undefined){
                //reviewVm.loggedInUserEmailId = reviewVm.emailID;
                      reviewVm.maskcustEmail(reviewVm.emailID);
              }
            }
            if (reviewVm.payingTo.intraBankFlag) {
                if (reviewVm.payingTo.intraBankFlag.toUpperCase() == 'N') {
                    reviewVm.showTnC = true
                    reviewVm.checkTnC = false
                } else {
                    reviewVm.showTnC = false;
                    reviewVm.checkTnC = true;
                }
            } else {
                reviewVm.showTnC = true
                reviewVm.checkTnC = false
            }
        });
        return this;
    }
]);
