angularApp.controller('declaimerController', [
    "$scope",
    "$state",
    "generalInsurenceHomeService", "utilityService","carLoanService","$ionicHistory","homeScreenService","clickStreamService","leadGenerationService",


    function($scope,
        $state,
        generalInsurenceHomeService, utilityService,carLoanService,$ionicHistory,homeScreenService,clickStreamService,leadGenerationService) {

        var declaimerVm = this;
        var productId;
        function initPage() {
            declaimerVm.isChecked = false;
            declaimerVm.showBack = true;
            declaimerVm.showNext = true;
            productId = generalInsurenceHomeService.getGIProductsID();
            if (!generalInsurenceHomeService.getDesclamaierAPI()) {
                generalInsurenceHomeService.getDisclaimer().then(function(data) {
                    generalInsurenceHomeService.setDesclamaierAPI(data.msg);
                    declaimerVm.consentText = data.msg;
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else {
               declaimerVm.consentText = generalInsurenceHomeService.getDesclamaierAPI();
            }
        }

        declaimerVm.goBacktoPrevious = function() {
            var backNavigationState = generalInsurenceHomeService.getBackNavigationState();
            if(backNavigationState) {
                generalInsurenceHomeService.setBackNavigationState("");
                $state.go(backNavigationState);
            } 
            else if(carLoanService.checkSource =="car")
            {
              carLoanService.checkSource ="";
               $state.go("menu.loans");


            }else if(homeScreenService.ishamMenu===true){
              $ionicHistory.goBack();
        			homeScreenService.ishamMenu=false;
            }
            else
            {
              $state.go("menu.generalInsurance",{backInsurance : true});
             }
        }

        declaimerVm.goToNextPage = function() {
            utilityService.showSpinner();
            productId = generalInsurenceHomeService.getGIProductsID();
          leadGenerationService.insertConsent().then(function(data){
            switch (productId) {
                case 'personal-accident-insurance':
                    generalInsurenceHomeService.setBackNavigationState("");
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "GIH_START_NXT_BTN"));
                             utilityService.hideSpinner();
                    $state.go('menu.personalaccidentdetail');
                    break;
                case 'health-insurance':
                    generalInsurenceHomeService.setBackNavigationState("");
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "GIH_HI_START_NXT_BTN"));
                             utilityService.hideSpinner();
                    $state.go('menu.healthInsurance');
                    break;
                case 'motor-insurance':
                    generalInsurenceHomeService.setBackNavigationState("");
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "GIM_MP_START_NXT_BTN"));
                            utilityService.hideSpinner();
                    $state.go('menu.motorInsuranceDetail');
                    break;
                case 'travel-insurance':
                    generalInsurenceHomeService.setBackNavigationState("");
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "GIH_START_NXT_BTN"));
                            utilityService.hideSpinner();
                    $state.go('menu.travelInsuranceDetail');
                    break;
                case 'home-insurance':
                    generalInsurenceHomeService.setBackNavigationState("");
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "GI_LTH_START_NXT_BTN"));
                            utilityService.hideSpinner();
                    $state.go('menu.homeInsuranceDetail');
                    break;
                case 'personal-accident-insurance-buy':
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "GIH_START_NXT_BTN"));
                    getPlanDetails("personal-accident-insurance", "44", { "path": 'menu.accidentQuoteMemberInfo', "landingPage": "buy"});
                    break;
                case 'personal-accident-insurance-details':
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "GIH_START_NXT_BTN"));
                    generalInsurenceHomeService.setGIProductsID('personal-accident-insurance');
                    generalInsurenceHomeService.setProductID('personal-accident-insurance');
                    generalInsurenceHomeService.setLandingPage("details");
                            utilityService.hideSpinner();
                    $state.go('menu.personalaccidentdetail');
                    break;
            }              
          }, function(error) {
                    utilityService.hideSpinner();
            utilityService.showErrorMessage(error.responseMessage);
            });
        }

        function getPlanDetails(productId, uin, options) {
            utilityService.showSpinner();
            generalInsurenceHomeService.getAllPlans().then(function(response) {
                utilityService.hideSpinner();
                generalInsurenceHomeService.setAllProductListDetailsAPI(response);
                generalInsurenceHomeService.getProductFeatures({'uin': uin}).then(function(data) {
                    generalInsurenceHomeService.setPlanDetail(data);
                    generalInsurenceHomeService.setProductDetail(data);
                    generalInsurenceHomeService.setGIProductsID(productId);
                    generalInsurenceHomeService.setLandingPage(options.landingPage);
                    generalInsurenceHomeService.setProductID(productId);
                    $state.go(options.path);
                }, function(error) {
                     utilityService.hideSpinner();
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }, function(error) {
                 utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
        
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
