angularApp.controller('eInsuranceController', [
    "$state",
    "$scope",
    "$translate", "$ionicPopup", "$filter", "generalInsurenceHomeService", "utilityService", "generalInsurenceHealthService", "validateService","generalInsurenceTravelService","generalInsurenceHomeDetailService","generalInsurenceMotorService","GIconstant",


    function(
        $state,
        $scope,
        $translate, $ionicPopup, $filter, generalInsurenceHomeService, utilityService, generalInsurenceHealthService, validateService,generalInsurenceTravelService,generalInsurenceHomeDetailService,generalInsurenceMotorService,GIconstant) {

        var eInsuranceVm = this;

        eInsuranceVm.openNewAccount = "";
        eInsuranceVm.existingAccount = "";
        eInsuranceVm.formValidation = {};
        eInsuranceVm.validateService = validateService;
        eInsuranceVm.wcmContent = "";
        eInsuranceVm.planUin = "";
        eInsuranceVm.newAccount = [];

        function initPage() {
            eInsuranceVm.content = "existing"; 
            generalInsurenceHomeService.eInsuranceAccount().then(function(detail) {
                eInsuranceVm.wcmContent = detail.msg;
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
            eInsuranceVm.planUin = generalInsurenceHomeService.getPlanDetail().uin;
            eInsuranceVm.renewalDetail = generalInsurenceHomeService.getRenewDetail();

            if(eInsuranceVm.planUin == GIconstant.common.TravelInsurance){
                eInsuranceVm.newAccount = generalInsurenceTravelService.getTravelMasterDetail().einsurance;
            }else if(eInsuranceVm.planUin == GIconstant.common.longTermHome){
                eInsuranceVm.newAccount =  generalInsurenceHomeDetailService.getMasterDetail().einsurance;
            }else if(eInsuranceVm.planUin == GIconstant.common.motorFour || eInsuranceVm.planUin == GIconstant.common.motorTwo){
                eInsuranceVm.newAccount =  generalInsurenceMotorService.getMIcommonMaster().einsurance;
            }else if(eInsuranceVm.planUin == GIconstant.common.arogysPremier){
                eInsuranceVm.newAccount =  generalInsurenceHealthService.getArogyaMasterList().einsurance;
            }else if(eInsuranceVm.planUin == GIconstant.common.criticalIllness){
                eInsuranceVm.newAccount =  generalInsurenceHealthService.getCriticalMasterList().einsurance;
            }else if(eInsuranceVm.planUin == GIconstant.common.hospitaldailycash){
                eInsuranceVm.newAccount =  generalInsurenceHealthService.getHDCMasterList().einsurance;
            }

        }

        function validateForm() {
            eInsuranceVm.formValidation = {};
           if(eInsuranceVm.content == "existing"){
                if (eInsuranceVm.validateService.isValidEInsurance(eInsuranceVm.accountNumber)) {
                    eInsuranceVm.formValidation.accountNumber = eInsuranceVm.validateService.isValidEInsurance(eInsuranceVm.accountNumber);
                }
           }else{
                    eInsuranceVm.accountNumber = "";
                if (eInsuranceVm.validateService.isValidAccountNum(eInsuranceVm.insuranceRepository)) {
                    eInsuranceVm.formValidation.insuranceRepository = eInsuranceVm.validateService.isValidAccountNum(eInsuranceVm.insuranceRepository);
                }
           }
            return (angular.equals({}, eInsuranceVm.formValidation)) ? true : false;
        }

        eInsuranceVm.clicked = function(){            
        }

        eInsuranceVm.goBack = function() {
           $state.go("menu.healthPaymentSuccess");
        }

        eInsuranceVm.submit = function(){
            eInsuranceVm.formSubmitted = true;
            if (validateForm()) {
                getJsonForSubmitRequest();
                
            }
            
        }
        eInsuranceVm.showListOfDocument = function(){
            generalInsurenceHomeService.getDocumentList().then(function(data) {
                if(data.msg){
                        var title =  $translate.instant('Document List');
                        var buttontext = "OK";
                        var blankdata = null;
                        var detail =  $translate.instant(data.msg);
                        utilityService.showAlertModal(title, detail, blankdata, blankdata, $state, buttontext)

                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        eInsuranceVm.clearField = function(index){
            if(index == "existing"){
                eInsuranceVm.formValidation.insuranceRepository = "";
            }else{
                eInsuranceVm.formValidation.accountNumber = "";
            }
        }

        function getJsonForSubmitRequest(){
            var productDetails = generalInsurenceHomeService.getLinkedpolicyDetailDetails();
             if(eInsuranceVm.planUin == GIconstant.common.TravelInsurance){
                if(eInsuranceVm.renewalDetail && eInsuranceVm.renewalDetail.isRenewal){
                    var partyDetails = eInsuranceVm.renewalDetail.quoteDetails;
                }else{
                    var partyDetails = generalInsurenceTravelService.getProposerContactDetail();
                    var partyResponseDetails =  generalInsurenceTravelService.getTravelCreateParty().partyCreate;
                }
                var submitReuest ={
                    "productCode": productDetails.productCode ? productDetails.productCode : "", 
                    "productSubCode": productDetails.productSubCode ? productDetails.productSubCode :"", 
                    "repositoryName": eInsuranceVm.insuranceRepository ? eInsuranceVm.insuranceRepository.key : "",
                    "customerType": "individual", 
                    "accountType": "individual", 
                    "policynumber": productDetails.policyNo ? productDetails.policyNo :"", 
                    "partyID": eInsuranceVm.renewalDetail ? (partyDetails.partyId ? partyDetails.partyId : "") :  (partyResponseDetails.partyID ? partyResponseDetails.partyID : ""), 
                    "dateOfPartyCreation": eInsuranceVm.renewalDetail ?  (partyDetails.policyTerms ? partyDetails.policyTerms.effectDate : "") : (partyResponseDetails.partyCreationDate ? partyResponseDetails.partyCreationDate : ""), 
                    "partyFname": eInsuranceVm.renewalDetail ? (partyDetails.partyName ? partyDetails.partyName : "") : (partyDetails.firstName ? partyDetails.firstName : ""),
                    "partyMname": eInsuranceVm.renewalDetail ? (partyDetails.partyName ? partyDetails.partyName : "") : (partyDetails.middleName ? partyDetails.middleName : ""),
                    "partyLname": eInsuranceVm.renewalDetail ? (partyDetails.partyName ? partyDetails.partyName : "") : (partyDetails.lastName ? partyDetails.lastName :""),
                    "genderParty": eInsuranceVm.renewalDetail ? (partyDetails.gender ? partyDetails.gender : "") : (partyDetails.gender ? partyDetails.gender.ikey : ""),
                    "dobParty": eInsuranceVm.renewalDetail ? (partyDetails.partydob ? partyDetails.partydob : "") : (partyDetails.birthdate ? $filter('startDateWithTimezone')(partyDetails.birthdate) : ""),
                    "panNo": "",
                    "aadharCardNo": "",
                    "partyMobileNo": eInsuranceVm.renewalDetail ? (partyDetails.mobile ? partyDetails.mobile : "") : (partyDetails.mobileNo ? partyDetails.mobileNo : ""),
                    "partyEmail": eInsuranceVm.renewalDetail ? (partyDetails.email ? partyDetails.email : ""  ) : (partyDetails.email ? partyDetails.email : ""),
                    "eaccountnumber": eInsuranceVm.accountNumber ? eInsuranceVm.accountNumber : ""
                }
            }else if(eInsuranceVm.planUin == GIconstant.common.longTermHome){
                 if(eInsuranceVm.renewalDetail && eInsuranceVm.renewalDetail.isRenewal){
                    var partyDetails = eInsuranceVm.renewalDetail.quoteDetails;
                }else{
                    var partyDetails =  generalInsurenceHomeDetailService.getPartyDetails().partyCreate;
                    var partyResponseDetails = generalInsurenceHomeDetailService.getPartyResponse().partyCreate;
                } 
                var submitReuest ={
                    "productCode": productDetails.productCode ? productDetails.productCode : "", 
                    "productSubCode": productDetails.productSubCode ? productDetails.productSubCode :"", 
                    "repositoryName": eInsuranceVm.insuranceRepository ? eInsuranceVm.insuranceRepository.key : "",
                    "customerType": "individual", 
                    "accountType": "individual", 
                    "policynumber": productDetails.policyNo ? productDetails.policyNo :"", 
                    "partyID": eInsuranceVm.renewalDetail ? (partyDetails.partyId ? partyDetails.partyId : "") :  (partyResponseDetails.partyID ? partyResponseDetails.partyID : ""), 
                    "dateOfPartyCreation": eInsuranceVm.renewalDetail ?  (partyDetails.policyTerms ? partyDetails.policyTerms.effectDate : "") : (partyResponseDetails.partyCreationDate ? partyResponseDetails.partyCreationDate : ""), 
                    "partyFname": eInsuranceVm.renewalDetail ? (partyDetails.partyName ? partyDetails.partyName : "") : (partyDetails.firstName ? partyDetails.firstName : ""),
                    "partyMname": eInsuranceVm.renewalDetail ? (partyDetails.partyName ? partyDetails.partyName : "") : (partyDetails.middleName ? partyDetails.middleName : ""),
                    "partyLname": eInsuranceVm.renewalDetail ? (partyDetails.partyName ? partyDetails.partyName : "") : (partyDetails.lastName ? partyDetails.lastName :""),
                    "genderParty": eInsuranceVm.renewalDetail ? (partyDetails.gender ? partyDetails.gender : "") : (partyDetails.gender ? partyDetails.gender.ikey : ""),
                    "dobParty": eInsuranceVm.renewalDetail ? (partyDetails.partydob ? partyDetails.partydob : "") : (partyDetails.dob ? $filter('startDateWithTimezone')(partyDetails.dob) : ""),
                    "panNo": "",
                    "aadharCardNo": "",
                    "partyMobileNo": eInsuranceVm.renewalDetail ? (partyDetails.mobile ? partyDetails.mobile : "") : (partyDetails.mobile ? partyDetails.mobile : ""),
                    "partyEmail": eInsuranceVm.renewalDetail ? (partyDetails.email ? partyDetails.email : ""  ) : (partyDetails.emailID ? partyDetails.emailID : ""),
                    "eaccountnumber": eInsuranceVm.accountNumber ? eInsuranceVm.accountNumber : ""
                }
            }else if(eInsuranceVm.planUin == GIconstant.common.motorFour || eInsuranceVm.planUin == GIconstant.common.motorTwo){
                if(eInsuranceVm.renewalDetail && eInsuranceVm.renewalDetail.isRenewal){
                    var partyDetails = eInsuranceVm.renewalDetail.quoteDetails;
                }else{
                    var partyDetails = generalInsurenceMotorService.getPartyDetails().partyCreate;
                    var partyResponseDetails =  generalInsurenceHomeService.getCreatePartyCI().partyCreate;
                }
                var submitReuest ={
                    "productCode": productDetails.productCode ? productDetails.productCode : "", 
                    "productSubCode": productDetails.productSubCode ? productDetails.productSubCode :"", 
                    "repositoryName": eInsuranceVm.insuranceRepository ? eInsuranceVm.insuranceRepository.key : "",
                    "customerType": "individual", 
                    "accountType": "individual", 
                    "policynumber": productDetails.policyNo ? productDetails.policyNo :"", 
                    "partyID": eInsuranceVm.renewalDetail ? (partyDetails.partyId ? partyDetails.partyId : "") :  (partyResponseDetails.partyID ? partyResponseDetails.partyID : ""),
                    "dateOfPartyCreation": eInsuranceVm.renewalDetail ?  (partyDetails.policyTerms ? partyDetails.policyTerms.effectDate : "") : (partyResponseDetails.partyCreationDate ? partyResponseDetails.partyCreationDate : ""),
                    "partyFname": eInsuranceVm.renewalDetail ? (partyDetails.partyName ? partyDetails.partyName : "") : (partyDetails.firstName ? partyDetails.firstName : ""),
                    "partyMname": eInsuranceVm.renewalDetail ? (partyDetails.partyName ? partyDetails.partyName : "") : (partyDetails.middleName ? partyDetails.middleName : ""),
                    "partyLname": eInsuranceVm.renewalDetail ? (partyDetails.partyName ? partyDetails.partyName : "") : (partyDetails.lastName ? partyDetails.lastName :""),
                    "genderParty": eInsuranceVm.renewalDetail ? (partyDetails.gender ? partyDetails.gender : "") : (partyDetails.gender ? partyDetails.gender.ikey : ""),
                    "dobParty": eInsuranceVm.renewalDetail ? (partyDetails.partydob ? partyDetails.partydob : "") : (partyDetails.dob ? $filter('startDateWithTimezone')(partyDetails.dob) : ""),
                    "panNo": "",
                    "aadharCardNo": "",
                    "partyMobileNo": eInsuranceVm.renewalDetail ? (partyDetails.mobile ? partyDetails.mobile : "") : (partyDetails.mobile ? partyDetails.mobile : ""),
                    "partyEmail": eInsuranceVm.renewalDetail ? (partyDetails.email ? partyDetails.email : ""  ) : (partyDetails.emailID ? partyDetails.emailID : ""),
                    "eaccountnumber": eInsuranceVm.accountNumber ? eInsuranceVm.accountNumber : ""
                }
            }
            else if(eInsuranceVm.planUin == GIconstant.common.arogysPremier || eInsuranceVm.planUin == GIconstant.common.criticalIllness || eInsuranceVm.planUin == GIconstant.common.hospitaldailycash){
                if(eInsuranceVm.renewalDetail && eInsuranceVm.renewalDetail.isRenewal){
                    var partyDetails = eInsuranceVm.renewalDetail.quoteDetails;
                }else{
                    var partyDetails = generalInsurenceHealthService.getHealthApplicationPersonalDetails();
                    var partyResponseDetails =  generalInsurenceHealthService.getCreatePartyCI().partyCreate;
                }  
                var submitReuest ={
                    "productCode": productDetails.productCode ? productDetails.productCode : "", 
                    "productSubCode": productDetails.productSubCode ? productDetails.productSubCode :"", 
                    "repositoryName": eInsuranceVm.insuranceRepository ? eInsuranceVm.insuranceRepository.key : "",
                    "customerType": "individual", 
                    "accountType": "individual", 
                    "policynumber": productDetails.policyNo ? productDetails.policyNo :"", 
                    "partyID": eInsuranceVm.renewalDetail ? (partyDetails.partyId ? partyDetails.partyId : "") :  (partyResponseDetails.partyID ? partyResponseDetails.partyID : ""),
                    "dateOfPartyCreation": eInsuranceVm.renewalDetail ?  (partyDetails.policyTerms ? partyDetails.policyTerms.effectDate : "") : (partyResponseDetails.partyCreationDate ? partyResponseDetails.partyCreationDate : ""),
                    "partyFname": eInsuranceVm.renewalDetail ? (partyDetails.partyName ? partyDetails.partyName : "") : (partyDetails.firstName ? partyDetails.firstName : ""),
                    "partyMname": eInsuranceVm.renewalDetail ? (partyDetails.partyName ? partyDetails.partyName : "") : (partyDetails.middleName ? partyDetails.middleName : ""),
                    "partyLname": eInsuranceVm.renewalDetail ? (partyDetails.partyName ? partyDetails.partyName : "") : (partyDetails.LastName ? partyDetails.LastName :""),
                    "genderParty": eInsuranceVm.renewalDetail ? (partyDetails.gender ? partyDetails.gender : "") : (partyDetails.gender ? partyDetails.gender : ""),
                    "dobParty": eInsuranceVm.renewalDetail ? (partyDetails.partydob ? partyDetails.partydob : "") : (partyDetails.birthdate ? $filter('startDateWithTimezone')(partyDetails.birthdate) : ""),
                    "panNo": "",
                    "aadharCardNo": "",
                    "partyMobileNo": eInsuranceVm.renewalDetail ? (partyDetails.mobile ? partyDetails.mobile : "") : (partyDetails.mobile ? partyDetails.mobile : ""),
                    "partyEmail": eInsuranceVm.renewalDetail ? (partyDetails.email ? partyDetails.email : ""  ) : (partyDetails.email ? partyDetails.email : ""),
                    "eaccountnumber": eInsuranceVm.accountNumber ? eInsuranceVm.accountNumber : ""
                }
            }
           
            generalInsurenceHomeService.getEInsuranceData(submitReuest).then(function(data) {
                var accNumber = generalInsurenceHomeService.getPlanDetail();
                accNumber.accNumber = eInsuranceVm.accountNumber;
                generalInsurenceHomeService.setPlanDetail(accNumber);
                $state.go("menu.requestSubmit");
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
