angularApp.controller('generalInsurenceHomeController', ["$state", "$stateParams", "$scope", "generalInsurenceHomeService", "$ionicScrollDelegate", "utilityService","clickStreamService",

    function ($state, $stateParams, $scope, generalInsurenceHomeService, $ionicScrollDelegate, utilityService,clickStreamService) {

        var healthInsuranceVm = this;
        var TabsSelected;

        function initPage() {
            
            healthInsuranceVm.showContect = 0;
            loadInsurenceData();
            callAllProducts();
        }

        $scope.loadTabContent = function(tabId) {
            healthInsuranceVm.showContect = tabId;
            var tabsList = ['health-insurance', 'motor-insurance', 'travel-insurance', 'home-insurance', 'personal-accident-insurance', 'recomended-insurance'];
            TabsSelected = tabsList[tabId];
            saveDetail();
        }

        function loadInsurenceData() {     
            switch ($stateParams.page) {
                case 'motor-insurance':
                    
                    healthInsuranceVm.showContect = 1;
                    healthInsuranceVm.insurencesList = healthInsuranceVm.insurencesList
                    $ionicScrollDelegate.scrollTo(100, 0, 1);
                    break;
                case 'home-insurance':
                    
                    healthInsuranceVm.showContect = 3;
                    $ionicScrollDelegate.scrollTo(400, 0, 1);
                    break;
                case 'travel-insurance':
                    healthInsuranceVm.showContect = 2;
                    $ionicScrollDelegate.scrollTo(300, 0, 1);
                    break;
                case 'personal-accident-insurance':
                    healthInsuranceVm.showContect = 4;
                    break;
                default:
                    healthInsuranceVm.showContect = 0;
                    break;
            }

        }

        function saveDetail() {
            var selected;
            if (TabsSelected) {
                selected = TabsSelected;
            } else {
                selected = $stateParams.page;
            }
            if (healthInsuranceVm.insurencesList) {
                for (var count = 0; count < healthInsuranceVm.insurencesList.length; count++) {
                    if (selected == healthInsuranceVm.insurencesList[count].productId) {
                        healthInsuranceVm.insurencesPerticularProductList = healthInsuranceVm.insurencesList[count].policies;
                    }
                }
            }


        }

        function callAllProducts (){
            generalInsurenceHomeService.getAllPlans().then(function(response) {
                generalInsurenceHomeService.setAllProductListDetailsAPI(response);
                var recomendedArray = [];
                healthInsuranceVm.insurencesList = response;
                var allPlansData = response;
                generalInsurenceHomeService.getRecommend().then(function(responseRecomended) {
                    var responsevalue = responseRecomended.suggestedData;
                    if (responsevalue) {
                        for (var i = 0; i < responsevalue.length; i++) {
                            for (var j = 0; j < allPlansData.length; j++) {
                                for (var k = 0; k < allPlansData[j].policies.length; k++)
                                    if (responsevalue[i].name == allPlansData[j].policies[k].productCode) {
                                        recomendedArray.push(allPlansData[j].policies[k]);
                                    }
                            }
                        }
                    }
                    if(recomendedArray.length > 0){
                        var recomendobj = {};
                        recomendobj.productId = 'recomended-insurance';
                        recomendobj.policies = recomendedArray;
                        healthInsuranceVm.insurencesList.push(recomendobj);
                        saveDetail();
                    }

                }, function(error) {
                });
                saveDetail();
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
    



        healthInsuranceVm.goBack = function() {
            $state.go('menu.declaimer');
        };


        healthInsuranceVm.showProductFeatures = function(data) {
            var productUid = data.uin;
            var productId;
            if (productUid == "11" || productUid == "12" || productUid == "13" || productUid == "14") {
                productId = "health-insurance";

            } else if (productUid == "22") {
                productId = "home-insurance";
            } else if (productUid == "31" || productUid == "32") {
                productId = "motor-insurance";
            } else if (productUid == "44") {
                productId = "personal-accident-insurance";
            } else if (productUid == "55") {
                productId = "travel-insurance";
            }
            generalInsurenceHomeService.setProductID(productId);
            generalInsurenceHomeService.setProductDetail(data);
            var tabsURLList = ['recommendedPolicyDetails', 'motorRecommendedPolicyFeatures', 'travelRecommendedPolicyFeatures', 'homeRecommendedPolicyFeatures', 'accidentRecommendedPolicyFeatures','recommendedPolicyDetails'];
            $state.go('menu.' + tabsURLList[healthInsuranceVm.showContect]);

        }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
