//'use strict';

angularApp.controller('renewpaymentController', [
    "$state",
    "$scope", "$filter", "validateService", "generalInsurenceTravelService", "generalInsurenceHealthService", "generalInsurenceAccidentService", "generalInsurenceHomeService", "utilityService", "$ionicPopup","$translate","lifeInsuranceCommonService","$stateParams","GIconstant",


    function(
        $state,
        $scope, $filter, validateService, generalInsurenceTravelService, generalInsurenceHealthService, generalInsurenceAccidentService, generalInsurenceHomeService, utilityService, $ionicPopup,$translate,lifeInsuranceCommonService,$stateParams,GIconstant) {

        var renewpaymentVm = this;
        var productUid, quoteCalculationDetail, productSiCodeDetail;
        var paymentDetailAfterPayment;
        var paiPaymentDetail, renewDetail, allLinkedPolicy, productspecificDetail, planDetail;

        function initPage() {
            renewpaymentVm.accountList = "";
            renewpaymentVm.balance = "";
            renewpaymentVm.paymentForm = {};
            allLinkedPolicy = generalInsurenceHomeService.getLinkedpolicyDetailDetailsNew();
            quoteCalculationDetail = generalInsurenceHomeService.getLinkedpolicyDetailDetails();
            renewDetail = generalInsurenceHomeService.getRenewDetail();
            renewpaymentVm.ProductIds = quoteCalculationDetail.uin;
            if(renewpaymentVm.ProductIds == '44'){
                renewpaymentVm.premiumAmount = renewDetail.renewalService.premium;
                renewpaymentVm.sumAssured=renewDetail.renewalService.sumInsured;
            }else{
                 renewpaymentVm.sumAssured = generalInsurenceHomeService.getpolicySumInsured();
                renewpaymentVm.premiumAmount = renewDetail.quoteDetails.totalPremium;
            }
            
           
            var account = {};
            generalInsurenceHomeService.getSBIBankAccounts(account).then(function(data) {
                renewpaymentVm.accDetails = data.beneficiaryList.ownAccounts;
               getproductDetail();
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

            
            if(quoteCalculationDetail.uin == '44'){
                 renewpaymentVm.showQuote = true;
            }else{
                 renewpaymentVm.showQuote = false;
            }
            renewpaymentVm.quoteNUmber = renewDetail.quoteDetails ? renewDetail.quoteDetails.quoteNumber : "";


            switch (quoteCalculationDetail.uin) {
                case '12':
                    renewpaymentVm.policyTitle = $translate.instant("CI_PURCHASE_SUIMMARY"); 
                    renewpaymentVm.productName = $translate.instant("CI_PRODUCT"); 
                    break;
                case '11':
                    renewpaymentVm.policyTitle = $translate.instant("AP_PURCHASE_SUIMMARY"); 
                    renewpaymentVm.productName = $translate.instant("AP_PRODUCT"); 
                    break;
                case '14':
                    renewpaymentVm.policyTitle = $translate.instant("SH_PURCHASE_SUIMMARY"); 
                    renewpaymentVm.productName = $translate.instant("SH_PRODUCT"); 
                    break;
                case '13':
                    renewpaymentVm.policyTitle = $translate.instant("HDC_PURCHASE_SUIMMARY"); 
                    renewpaymentVm.productName = $translate.instant("HDC_PRODUCT"); 
                    break;
                 case '22':
                    renewpaymentVm.policyTitle = $translate.instant("LTH_PURCHASE_SUIMMARY"); 
                    renewpaymentVm.productName = $translate.instant("LTH_PRODUCT"); 
                    break;
                case '31':
                    renewpaymentVm.policyTitle = $translate.instant("M4W_PURCHASE_SUIMMARY"); 
                    renewpaymentVm.productName = $translate.instant("M4W_PRODUCT"); 
                    break;
                case '32':
                    renewpaymentVm.policyTitle = $translate.instant("M2W_PURCHASE_SUIMMARY"); 
                    renewpaymentVm.productName = $translate.instant("M2W_PRODUCT"); 
                    break;
                case '44':
                    renewpaymentVm.policyTitle = $translate.instant("PAI_PURCHASE_SUIMMARY"); 
                    renewpaymentVm.productName = $translate.instant("PAI_PRODUCT"); 
                    break;
                case '55':
                    renewpaymentVm.policyTitle = $translate.instant("TI_PURCHASE_SUIMMARY"); 
                    renewpaymentVm.productName = $translate.instant("TI_PRODUCT"); 
                    break;

            }

        }

        function getproductDetail() {
            var productUin = {
                "uin": renewpaymentVm.ProductIds
            }
            generalInsurenceHomeService.getProductFeatures(productUin).then(function(data) {
                 generalInsurenceHomeService.setPlanDetail(data)
                 generalInsurenceHomeService.setProductDetail(data);
               planDetail = data;
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

        }

        function showRetry(title, template, funName) {
            var alertPopup = $ionicPopup.alert({
                title: title,
                template: template,
                scope: $scope,
                cssClass: 'sbi-alert-popup',
                buttons: [{
                    text: 'OK',
                    type: 'button-positive',
                    onTap: function(e) {
                        return true;
                    }
                }]
               
            });
            alertPopup.then(function(res) {
                $state.go('menu.generalInsurance');
            });

        }


        function isValidSecKey(secKey,requestKey) {
            var calculatedKey = lifeInsuranceCommonService.verifySeckey(parseInt(secKey));
                if(requestKey == calculatedKey){
                    return true;
                }                           
            return false;           
        }

        renewpaymentVm.paymentForm = {};
        renewpaymentVm.validateService = validateService;

        function validateForm() {
            renewpaymentVm.paymentForm = {};
            if (renewpaymentVm.validateService.isValidAccountNum(renewpaymentVm.accountList)) {
                renewpaymentVm.paymentForm.accountList = renewpaymentVm.validateService
                    .isValidAccountNum(renewpaymentVm.accountList);
            }

            return (angular.equals({}, renewpaymentVm.paymentForm)) ? true : false;
        }


        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });


        renewpaymentVm.changeAccount = function(account) {
            renewpaymentVm.balance = account.balance;
            if (renewpaymentVm.balance < renewpaymentVm.premiumAmount) {
                renewpaymentVm.paymentForm.accountList = "your balance is too low";
            }


        }

        renewpaymentVm.displayBalance = function(balance) {
            if (balance) {
                return $filter('rupeeSymbol')(balance);
            }

        }

        renewpaymentVm.goBacktoPrevious = function() {
            $state.go("menu.basicInformation");
        }

         function getPayment() {
			var renewalDetail = generalInsurenceHomeService.getRenewDetail();
			renewalDetail.isRenewal = true;
			generalInsurenceHomeService.setRenewDetail(renewalDetail);
            var secKey = generalInsurenceHomeService.generateSecKey();
			if(renewpaymentVm.ProductIds == "44"){
				var certificateNumber = generalInsurenceHomeService.getLinkedpolicyDetailDetails() ? generalInsurenceHomeService.getLinkedpolicyDetailDetails().policyNo : "";
				var paymentDetail = {
					"secKey" : secKey,					
					"debitAccount": renewpaymentVm.accountList.benAccntNo,
					"amount" : renewDetail.renewalService.premium,
					"policyNo" : certificateNumber
				}
				generalInsurenceHealthService.payForPAIRenew(paymentDetail).then(function(data) {
					if(data.isOTPRequired == "true"){
						$state.go("menu.paymentOtp");																
					}else if(data.isOTPRequired == "false"){
						if(!isValidSecKey(data.secKey,secKey)){
							//renewalDetail.isRenewal = false;
							generalInsurenceHomeService.setRenewDetail(renewalDetail);
							utilityService.showErrorMessage(GIconstant.errorMessage);
						}else{
							generalInsurenceHomeService.setLinkedpolicyDetailDetails(data.policy);
							data.policy.onlinePolicy = {};
							data.policy.onlinePolicy.policyNumber = data.policy.policyNo;
							generalInsurenceHomeService.setOnlinePolicy(data.payment);
							$state.go('menu.healthPaymentSuccess');
							utilityService.setCsatJournies('generalInsurance');
						} 
					}
				}, function(error) {
					//renewalDetail.isRenewal = false;
					generalInsurenceHomeService.setRenewDetail(renewalDetail);
					utilityService.showAlertModal("", $translate.instant("PAYMENT_FAILURE_MSG"), "menu.generalInsurance", $scope, $state, "OK");
				});
			}else{
				var paymentDetail = {
					"secKey" : secKey,
					"generalOtherPoliciesInsPayment": {
						"quoteNo": renewDetail.quoteDetails.quoteNumber,
						"debitAccount": renewpaymentVm.accountList.benAccntNo
					   
					}
				}

				generalInsurenceHealthService.payForOtherPurchase(paymentDetail).then(function(data) {
					if(data.isOTPRequired == "true"){
					  switch (renewpaymentVm.ProductIds) {
						  case "31":
						  $state.go("menu.paymentOtp");
						  break;
						  case "55":
						  $state.go("menu.paymentOtp");
						  break;
						  case "11":
						  $state.go("menu.paymentOtp");
						  break;
						  case "44":
						  $state.go("menu.paymentOtp");
						  break;
						  case "22":
						  $state.go("menu.paymentOtp");
						  break;
						  case "12":
						  $state.go("menu.paymentOtp");
						  break;
						  case "13":
						  $state.go("menu.paymentOtp");
						  break;
						  case "32":
						  $state.go("menu.paymentOtp");
						  break;
                           case "14":
                          $state.go("menu.paymentOtp");
						  break;
                           case "55":
                          $state.go("menu.paymentOtp");
						  break;
					  }                                                                  
					}else if(data.isOTPRequired == "false"){
						if(!isValidSecKey(data.secKey,secKey)){
							renewalDetail.isRenewal = false;
							generalInsurenceHomeService.setRenewDetail(renewalDetail);
							utilityService.showErrorMessage(GIconstant.errorMessage)
						}else{
							generalInsurenceHomeService.setLinkedpolicyDetailDetails(data.data.policy);
							data.data.policy.onlinePolicy.policyNumber = data.data.policy.policyNo;
							generalInsurenceHomeService.setOnlinePolicy(data.data.policy);
							$state.go('menu.healthPaymentSuccess');
							utilityService.setCsatJournies('generalInsurance');
						} 
					}
				}, function(error) {
					renewalDetail.isRenewal = false;
					generalInsurenceHomeService.setRenewDetail(renewalDetail);
					utilityService.showAlertModal("", $translate.instant("PAYMENT_FAILURE_MSG"), "menu.generalInsurance", $scope, $state, "OK");
				});
			}
            
        }






        /*function getAgentRecipt(paymentDetail) {
            var currentDate = generalInsurenceHomeService.getCurrentDate();
            var getAgentReceipt = {
                "agentReceiptDetailsRequest": {
                    "instumentTotal": renewDetail.quoteDetails.totalPremium,
                    "payor": renewDetail.quoteDetails.policyTerms.customerCode,
                    "payorCustCodeArr": renewDetail.quoteDetails.policyTerms.customerCode,
                    "payorType": "individual",
                    "quoteNo": renewDetail.quoteDetails.quoteNumber,
                    "receiveAmountArr": renewDetail.quoteDetails.totalPremium,
                    "totalPremium": renewDetail.quoteDetails.totalPremium,
                    "transationID": paymentDetail.payment.paymentRefNumber,
                    "receiptDate": $filter('newdateFormat')(currentDate),
                    "con": paymentDetail.payment.lotusRefNumber,
                    "productCode": planDetail.productCode,
                    "productSubCode": planDetail.productSubCode
                }
            }
            generalInsurenceHealthService.getAgentReceipt(getAgentReceipt).then(function(data) {
                getOnlinepolicy();
                generalInsurenceHomeService.setAgentRecipt(data);
            }, function(error) {
                showRetry("Payment Received", $translate.instant("POLICY_ISSUE_FAILURE"), "agent");
            });
        }

        function getOnlinepolicy() {
            var getOnlinePolicy = {
                "onlinePolicy": {
                    "transactionType": "3",
                    "quoteNumber": renewDetail.quoteDetails.quoteNumber,
                    "productCode": planDetail.productCode,
                    "productSubCode": planDetail.productSubCode
                }
            }

            generalInsurenceHealthService.getOnlinePolicy(getOnlinePolicy).then(function(data) {
                generalInsurenceHomeService.setOnlinePolicy(data);
                policyCreate();
            }, function(error) {
                showRetry("Payment Received", $translate.instant("POLICY_ISSUE_FAILURE"), "online");
            });
        }

        function policyCreate() {
            var policyNo = generalInsurenceHomeService.getOnlinePolicy();
            var uinDetail = {
                "uin": quoteCalculationDetail.uin,
            }
            generalInsurenceHomeService.setProductDetail(uinDetail);


            var quote = {
                    "quoteCreation" : {
                        "actualPremiumPayable" : renewDetail.quoteDetails.totalPremium
                    }
            }
            generalInsurenceHealthService.setQuotecalculation(quote);

            var policyDetail = {
                "customerName" : quoteCalculationDetail.customerName
            }
            generalInsurenceHomeService.setpolicySumInsured(renewDetail.quoteDetails.sumInsured);
            generalInsurenceHomeService.setLinkedpolicyDetailDetails(policyDetail);

            
            var createPolicy = {
                "portfolio": {
                    "generalInsurance": {
                        "products": [{
                                "productId": allLinkedPolicy.productId,
                                "policies": [{
                                        "policyName": quoteCalculationDetail.policyName,
                                        "uin": quoteCalculationDetail.uin,
                                        "productCode": planDetail.productCode,
                                        "productSubCode": planDetail.productSubCode,
                                        "dob": new Date(quoteCalculationDetail.dob),
                                        "planName": quoteCalculationDetail.planName,
                                        "imageUrl": quoteCalculationDetail.imageUrl,
                                        "customerName": quoteCalculationDetail.customerName,
                                        "policyNo": policyNo.onlinePolicy.policyNumber,
                                        "annualPremium": renewDetail.quoteDetails.totalPremium,
                                        "sumInsured": quoteCalculationDetail.uin == '31' ||quoteCalculationDetail.uin =='32' ? renewDetail.quoteDetails.idv :  renewDetail.quoteDetails.sumInsured,
                                        "renewalDate": new Date(renewDetail.quoteDetails.policyTerms.expiryDate),
                                        "policyTerm": quoteCalculationDetail.policyTerm,
                                        "premiumPaid": renewDetail.quoteDetails.totalPremium,
                                        "status": "Active",
                                        "policyValidUntil": new Date(renewDetail.quoteDetails.policyTerms.expiryDate),
                                        "vehicleIdv": quoteCalculationDetail.vehicleIdv,
                                        "vehicleMake": quoteCalculationDetail.vehicleMake,
                                        "vehicleModel": quoteCalculationDetail.vehicleModel,
                                        "registrationNo": quoteCalculationDetail.registrationNo,
                                        "ownerAccountNumber": renewpaymentVm.accountList.benAccntNo,
                                        "emailId": quoteCalculationDetail.emailId,
                                        "mobileNo" : quoteCalculationDetail.mobileNo,
                                        "nomineeName":  quoteCalculationDetail.nomineeName,
                                        "nomineeRelationship": quoteCalculationDetail.nomineeRelationship,
                                        "address1": quoteCalculationDetail.address1,
                                        "address2": quoteCalculationDetail.address2,
                                        "address3": quoteCalculationDetail.address3,
                                        "address4": quoteCalculationDetail.address4,
                                        "autoRenew": renewpaymentVm.renewal ? true : false,
                                        "policyStartDate" : new Date(renewDetail.quoteDetails.policyTerms.effectDate),

                                    }

                                ]
                            }

                        ]
                    }
                }
            }

            generalInsurenceHomeService.setLinkedpolicyDetailDetails(createPolicy.portfolio.generalInsurance.products[0].policies[0]);
            generalInsurenceHomeService.setLinkedpolicyDetailDetailsNew(createPolicy.portfolio.generalInsurance.products[0]);
            var test = JSON.stringify(createPolicy);

            generalInsurenceHealthService.getPolicyCreate(createPolicy).then(function(data) {
                generalInsurenceHomeService.setPolicyCreateDetail(data);
                $state.go('menu.healthPaymentSuccess');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });


        }*/

        renewpaymentVm.goToNextPage = function() {
            if (validateForm()) {
               var alertPopup = $ionicPopup.alert({
                    title: "Confirm",
                    template: "Are you sure you want to proceed with a payment of " + $filter('rupeeSymbol')(renewpaymentVm.premiumAmount) + "?",
                    scope: $scope,
                    cssClass: 'sbi-alert-popup',
                    buttons: [{
                        text: 'Cancel',
                        type: 'button-negative',
                        onTap: function(e) {
                            return false;
                        }
                    },{
                        text: 'Proceed',
                        type: 'button-positive',
                        onTap: function(e) {
                            return true;
                        }
                    }]
               
                });

                alertPopup.then(function(res) {
                    if (res) {
                        getPayment();    
                    }
                });

                
            }
        }


    }
]);
