
angularApp.controller('sbiGeneralInsuranceController', ["$state", "$scope", "generalInsurenceHomeService", "utilityService", "generalInsurenceHomeDetailService", 
"generalInsurenceHealthService", "generalInsurenceMotorService", "generalInsurenceAccidentService", "generalInsurenceTravelService","sampoornSurakshaService",
"carLoanService","rrService","$location","$ionicSlideBoxDelegate","$stateParams","newCardService","clickStreamService","leadGenerationService","loggedInUserService",
    function($state, $scope, generalInsurenceHomeService, utilityService, generalInsurenceHomeDetailService, generalInsurenceHealthService, generalInsurenceMotorService,
     generalInsurenceAccidentService, generalInsurenceTravelService,sampoornSurakshaService,carLoanService,rrService,$location,$ionicSlideBoxDelegate,$stateParams,newCardService,clickStreamService,leadGenerationService,loggedInUserService) {
        var sbiGeneralInsuranceVm = this;
        $scope.navInsurance = "life";
         $scope.options1 = "";
         $scope.options2 = "";
         $scope.bannerData = "";
        
        function initPage() {
            //Check whether user is coming back from insurance page 
            sbiGeneralInsuranceVm.backInsurance = $stateParams.backInsurance;
            if(!sbiGeneralInsuranceVm.backInsurance){
                clearAllData();
            }
            
            //API hit for banner data
            if(!$scope.bannerData){
                generalInsurenceHomeService.getInsuranceBannerPage().then(function(data){
                    $scope.bannerData = data; 
                    var delegate = $ionicSlideBoxDelegate.$getByHandle('banner');
                    delegate.start();
                }, function(error) {
                    $scope.bannerData = '';
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }

            // get all redesign plans
            generalInsurenceHomeService.getAllRedesignPlans().then(function(data){
                $scope.allPlans = data; 
               
            }, function(error) {
                $scope.allPlans = '';
                utilityService.showErrorMessage(error.responseMessage);
            });

            $scope.options1 = {
                slidesPerView: 1.2,
                spaceBetween: 2,
                loop:true,
                breakpoints: {
                    // when window width is <= 720px
                    720: {
                        slidesPerView: 1.2,
                        spaceBetween: 4
                    },
                    // when window width is <= 640px
                    640: {
                        slidesPerView: 1.2,
                        spaceBetween: 4
                    },
                    // when window width is <= 480px
                    480: {
                        slidesPerView: 1.2,
                        spaceBetween: 4
                    },
                    // when window width is <= 320px
                    320: {
                        slidesPerView: 1.2,
                        spaceBetween: 2
                    }
                },
                pager: true
            };

            $scope.options2 = {
                slidesPerView: 1,
                loop:false,
                pagination: false,
                spaceBetween: 2
            };

            // Set the active tab
            if(sampoornSurakshaService.getActiveCategory()){
                 $scope.navInsurance = sampoornSurakshaService.getActiveCategory();
             }
             else{
                 $scope.navInsurance = "life";  
             }
            if($scope.navInsurance == "health"){
                sbiGeneralInsuranceVm.tab = 2;
            }else if($scope.navInsurance == "personal-accident"){
                sbiGeneralInsuranceVm.tab = 3;
            }else if($scope.navInsurance == "long-term-home"){
                sbiGeneralInsuranceVm.tab = 4;
            }else if($scope.navInsurance == "travel"){
                sbiGeneralInsuranceVm.tab = 5;
            }else if($scope.navInsurance == "motor"){
                sbiGeneralInsuranceVm.tab = 6;
            }else if($scope.navInsurance == "life"){
                sbiGeneralInsuranceVm.tab = 1;   
            }
           
        }

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        $scope.$on('$ionicView.beforeLeave', function () {
            var headerElem = document.querySelector('body');
            if (headerElem) {
                headerElem.classList.remove('hiddenExtraButton');
            }
        });
        $scope.$on('$ionicView.afterEnter', function () {
            var headerElem = document.querySelector('body');
            if (headerElem) {
                headerElem.classList.add('hiddenExtraButton');
            }
        });

        sbiGeneralInsuranceVm.goBackToPreviousPage = function () {
            $state.go('menu.homeScreen');
        }

        // Redirect to life insurance after clicking on banner
        $scope.redirectToLifeInsurance = function(value){ 
            if(value.bannerTitle.indexOf("Sampoorn Suraksha")!=-1){
                sampoornSurakshaService.getPremiumAndNomineeInfo().then(function(data) {
                    sampoornSurakshaService.clearAll();
                    sampoornSurakshaService.setPremiumDetails(data);
                    $state.go('menu.ssPremiumCalculation', {lifeGeneInsure : true});  
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }else if(value.bannerTitle.indexOf("Rinn Raksha")!=-1){
                rrService.addRetrive(false);
                $state.go('menu.rinnRaksha');
            }else if(value.bannerTitle.indexOf("Group Health Insurance")!=-1){
                generalInsurenceHomeService.setGIProductsID('health-insurance');
                $state.go('menu.declaimer');
            }else if(value.bannerTitle.indexOf("Personal Accident Insurance")!=-1){
                generalInsurenceHomeService.setGIProductsID('personal-accident-insurance');
                $state.go('menu.declaimer');
            }
        }

        
        // Redirect to respective insurance page after clicking on Buy Now from categories
        sbiGeneralInsuranceVm.goToLifeInsuranceProd = function(uinId){
            sampoornSurakshaService.setActiveCategory($scope.navInsurance);
            var uin = document.getElementById(uinId).getElementsByClassName('fss-insurance-number')[0].innerHTML;
            if(uin == '111N040V04'){
                sampoornSurakshaService.getPremiumAndNomineeInfo().then(function(data) {
                    sampoornSurakshaService.clearAll();
                    sampoornSurakshaService.setPremiumDetails(data);
                    $state.go('menu.ssPremiumCalculation', {lifeGeneInsure : true});  
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
                
            }else if(uin == '111N078V03'){
                rrService.addRetrive(false);
                // code added for centralized consent Check
                    leadGenerationService.checkConsent().then(function(data){
                        utilityService.hideSpinner();
                        console.log(data);
                        if(data.customerRecordExists == "false"){
                            newCardService.setPostLoginSelectedMenu('goRinnRakshaGLI');
                            loggedInUserService.productClicked = 'menu.termsAndConditionsOutboundAnalytics';
                            $state.go('menu.termsAndConditionsOutboundAnalytics');
                        }else{
                            clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "LI_START_NXT_BTN")); 
                            $state.go('menu.rinnRaksha', {lifeGeneInsure : true});
                        }
                    },function(error){
                            utilityService.hideSpinner();	
                            utilityService.showErrorMessage(error.responseMessage);
                    });	
        
            }
            else if($scope.navInsurance == 'life' && (uin != '111N078V03' || uin != '111N040V04')){
                $state.go('menu.sbiLifeIntro');
            }
            else{
                switch(sbiGeneralInsuranceVm.tab){
                    case 2:
                        generalInsurenceHomeService.setGIProductsID('health-insurance');
                        break;
                     case 3:
                        generalInsurenceHomeService.setGIProductsID('personal-accident-insurance');
                        break;
                     case 4:
                        generalInsurenceHomeService.setGIProductsID('home-insurance');
                        break;
                     case 5:
                        generalInsurenceHomeService.setGIProductsID('travel-insurance');
                        break;
                    case 6:
                        generalInsurenceHomeService.setGIProductsID('motor-insurance');
                        break;
                    default:
                        break;
                }
                newCardService.setPostLoginSelectedMenu('insure');
                $state.go('menu.declaimer');
            }
        }
        
        // Link policy
        $scope.linkPolicyInsure = function(){
            $state.go('menu.linkingLIPolicy');
        }

        // Set active tab after navigating from one tab to another
        sbiGeneralInsuranceVm.insuranceTab = function (index, category) {
            sbiGeneralInsuranceVm.tab = index;
            $scope.navInsurance = category;
        }
        
        // Reset data
        function clearAllData() {
            generalInsurenceHealthService.clearAllData();
            generalInsurenceHomeService.clearAll();
            generalInsurenceHomeDetailService.clearAll();
            generalInsurenceMotorService.clearAll();
            generalInsurenceAccidentService.clearAll();
            generalInsurenceTravelService.clearAll();
            sampoornSurakshaService.clearAll();
            $scope.allPlans = '';
        }
    }
]);



