angularApp.controller('arsaEinsuranceController', [
    "$state", "$scope", "$filter",
    "validateService", "generalInsurenceHealthService",
    "generalInsurenceHomeService", "GIconstant", "utilityService",
    "$translate", "arogyaSanjeevaniService", "$ionicScrollDelegate",


    function ($state, $scope, $filter, validateService,
        generalInsurenceHealthService, generalInsurenceHomeService,
        GIconstant, utilityService, $translate, arogyaSanjeevaniService, $ionicScrollDelegate) {

        var arsaEinsuranceVm = this;
        arsaEinsuranceVm.validateService = validateService;
        arsaEinsuranceVm.data = {};
        arsaEinsuranceVm.detailsPage = {};

        /* Function to display the necessary information
         & put validation on Page load*/
        arsaEinsuranceVm.initPage = function () {
            arsaEinsuranceVm.panImage = "img/Visibility_off.svg";
            arsaEinsuranceVm.premium = arogyaSanjeevaniService.getPremiumData() ? arogyaSanjeevaniService.getPremiumData().estPremium : "";
            arsaEinsuranceVm.repositories = generalInsurenceHealthService.getArogyaMasterList() ? generalInsurenceHealthService.getArogyaMasterList().arogyaSanjeevaniRepository : [{ 'key': '1', 'value': '1' }];
            arsaEinsuranceVm.showInfo = $translate.instant("EINSURANCE_ACCOUNT_STARTS_LBL");
            arsaEinsuranceVm.detailsPage = {};
            if (arogyaSanjeevaniService.getEinsurance()) {
                arsaEinsuranceVm.data = arogyaSanjeevaniService.getEinsurance();
            } else {
                arsaEinsuranceVm.data.isRepo = false;
                arsaEinsuranceVm.data.eAccount = '3';
                arsaEinsuranceVm.data.isPanDisabled = arogyaSanjeevaniService.getHealthApplicationPersonalDetails().isPanDisabled;
                arsaEinsuranceVm.data.ckyc = "";
            }
            arsaEinsuranceVm.data.pan = $filter('cardmask')(arogyaSanjeevaniService.getPan(), 'X', 4);
        }

        /*go to previous page */
        arsaEinsuranceVm.goBacktoPrevious = function () {
            $state.go("menu.arsaNomineeDetails");
        }

        /*Function to change Repo*/
        arsaEinsuranceVm.changeRepo = function (repo) {
            repo == 'yes' ? arsaEinsuranceVm.data.isRepo = true : arsaEinsuranceVm.data.isRepo = false;
        }

        /*Function to change E Account */
        arsaEinsuranceVm.changeEaccount = function (ans) {
            ans == 'yes' ? arsaEinsuranceVm.data.eAccount = '1' : arsaEinsuranceVm.data.eAccount = '2';
            if(arsaEinsuranceVm.data.eAccount === '2') {arsaEinsuranceVm.data.pan = $filter('cardmask')(arogyaSanjeevaniService.getPan(), 'X', 4)}
        }

        /*Function to validate the fields */
        arsaEinsuranceVm.validateForm = function () {
            arsaEinsuranceVm.detailsPage = {};
            if (arsaEinsuranceVm.data.isRepo && arsaEinsuranceVm.data.eAccount == "3") {
                arogyaSanjeevaniService.showError($translate.instant("PLEASE_SELECT_ANSWER_MSSG"));
                return;
            }
            if (arsaEinsuranceVm.data.isRepo && arsaEinsuranceVm.data.eAccount == "1") {
                if (arsaEinsuranceVm.validateService.isValidEAccount(arsaEinsuranceVm.data.eaccountNumber)) {
                    arsaEinsuranceVm.detailsPage.eaccountNumber = arsaEinsuranceVm.validateService.isValidEAccount(arsaEinsuranceVm.data.eaccountNumber);
                }
            }
            if (arsaEinsuranceVm.data.isRepo && arsaEinsuranceVm.data.eAccount == "2") {
                if (arsaEinsuranceVm.validateService.isValidPanNumber(arogyaSanjeevaniService.getPan())) {
                    arsaEinsuranceVm.detailsPage.pan = arsaEinsuranceVm.validateService.isValidPanNumber(arogyaSanjeevaniService.getPan());
                }
                if (arsaEinsuranceVm.validateService.isValidRepo(arsaEinsuranceVm.data.repository)) {
                    arsaEinsuranceVm.detailsPage.repository = arsaEinsuranceVm.validateService.isValidRepo(arsaEinsuranceVm.data.repository);
                }
            }
            if (arsaEinsuranceVm.data.ckyc && arsaEinsuranceVm.validateService.isValidCKYC(arsaEinsuranceVm.data.ckyc)) {
                arsaEinsuranceVm.detailsPage.ckyc = arsaEinsuranceVm.validateService.isValidCKYC(arsaEinsuranceVm.data.ckyc);
            }
            return (angular.equals({}, arsaEinsuranceVm.detailsPage)) ? true : false;
        }

        /*Function to Mask/UnMask of PAN input */
        arsaEinsuranceVm.switchPan = function () {
            if (arsaEinsuranceVm.data.pan.length > 4) {
                if (arsaEinsuranceVm.panImage.includes("On")) {
                    arsaEinsuranceVm.panImage = "img/Visibility_off.svg";
                    arsaEinsuranceVm.data.pan = $filter('cardmask')( arogyaSanjeevaniService.getPan(), 'X', 4);
                } else {
                    arsaEinsuranceVm.data.pan =  arogyaSanjeevaniService.getPan();
                    arsaEinsuranceVm.panImage = "img/Visibility_OnPurple.svg";
                }
            }
        }

        /*Function to on Blur of PAN input */
        arsaEinsuranceVm.panBlur = function () {
            arogyaSanjeevaniService.setPan(arsaEinsuranceVm.data.pan);
            if (arsaEinsuranceVm.data.pan.length > 4) {
                arsaEinsuranceVm.data.pan = $filter('cardmask')(arsaEinsuranceVm.data.pan, 'X', 4);
            }
            arsaEinsuranceVm.panImage = "img/Visibility_off.svg";
        }

        /*Function to on Focus of PAN input */
        arsaEinsuranceVm.panFocus = function () {
            arsaEinsuranceVm.data.pan =  arogyaSanjeevaniService.getPan();
        }

        /* go to Next Page */ 
        arsaEinsuranceVm.goToNextPage = function () {
            if (arsaEinsuranceVm.validateForm()) {
                if (arsaEinsuranceVm.data.isRepo && arsaEinsuranceVm.data.eAccount == "1" && (arsaEinsuranceVm.data.eaccountNumber.charAt(0) != '1' &&
                    arsaEinsuranceVm.data.eaccountNumber.charAt(0) != '2' && arsaEinsuranceVm.data.eaccountNumber.charAt(0) != '3' && arsaEinsuranceVm.data.eaccountNumber.charAt(0) != '4')) {
                    arogyaSanjeevaniService.showErrorCaution($translate.instant("UNABLE_TO_CREDIT_EINSURANCE"),
                        "menu.arsaPayment", "OK", function () {
                            arsaEinsuranceVm.getQuoteNumber();
                        });
                } else {
                    arsaEinsuranceVm.getQuoteNumber();
                }

            }
        }

        /*Function to get the Quote Number */ 
        arsaEinsuranceVm.getQuoteNumber = function () {
            var proposer = arogyaSanjeevaniService.getHealthApplicationPersonalDetails();
            var nomineeDetails = arogyaSanjeevaniService.getNomineeDetail();
            var insuredDetails = arogyaSanjeevaniService.getHealthAdditionalDetails();
            var basicDetails = arogyaSanjeevaniService.getbasicHealthDetail();
            var einsurance = arogyaSanjeevaniService.getArogyaQuestion();
            var insureDetArrary = [];
            var medicalQuestions = [];
            var adult = 0;
            var child = 0;
            var ffCat = "";
            for (var i = 0; i < basicDetails.familySize; i++) {
                insureDetArrary[i] = {};
                insureDetArrary[i].title = insuredDetails.title[i].key;
                insureDetArrary[i].firstName = insuredDetails.name[i];
                insureDetArrary[i].lastName = insuredDetails.lastName[i];
                insureDetArrary[i].dob = $filter('dateFormat')(insuredDetails.birthDay[i]);
                insureDetArrary[i].gender = (insuredDetails.Gender[i] === "M" || insuredDetails.Gender[i] === 'Male') ? 'M' : 'F';
                insureDetArrary[i].maritalStatus = insuredDetails.maritalStatus[i].key;
                insureDetArrary[i].relationshipToProposer = insuredDetails.relationship[i].key;
                insureDetArrary[i].occupation = insuredDetails.isOccupation[i] ? insuredDetails.occupation[i].key : '904';
                medicalQuestions[i] = {};
                medicalQuestions[i].selectedSmoke =  einsurance.insuredQuestions[i].selectedSmoke ? 'true' : 'false';
                medicalQuestions[i].selectedTobaco =  einsurance.insuredQuestions[i].selectedTobaco ? 'true' : 'false';
                medicalQuestions[i].selectedAlcohol =  einsurance.insuredQuestions[i].selectedAlcohol ? 'true' : 'false'; 
                if(insuredDetails.relationship[i].ikey == "C"){
                    child++
                }else{
                    adult++
                }
            }
            child == 0 ? ffCat = adult + "A" : ffCat = adult + "A+" + child + "C";
            var sanjeevaniFFCategory = generalInsurenceHealthService.getArogyaMasterList().arogyaSanjeevaniFamilyFloaterRelation.find(function (ff) {
                return ff.ikey == ffCat
            })

            var request = {
                "createQuoteRequest": {
                    "quoteDetails": {
                        "arogyaPolicyType": basicDetails.productTypes.key,
                        "effectiveDate":  $filter('dateFormat')(basicDetails.startDate),
                        "sanjeevaniFFCategory": sanjeevaniFFCategory.key,
                        "sumInsured": basicDetails.sumInsured.key,
                        "autorenewal": nomineeDetails.autoRenew ? "true" : "false",
                        "productCode" : arogyaSanjeevaniService.getProductCode() ? arogyaSanjeevaniService.getProductCode() : ""
                    },
                    "personalDetails": {
                        "title": proposer.title.key,
                        "firstName": proposer.firstName,
                        "lastName": proposer.LastName,
                        "name": proposer.firstName + " " + proposer.LastName,
                        "dob": $filter('dateFormat')(proposer.birthdate),
                        "plotNo": proposer.plotNo,
                        "buildingName": proposer.address,
                        "streetName": proposer.streetName,
                        "postCode": proposer.pincode,
                        "locality": proposer.location.pinId,
                        "city": proposer.city,
                        "state": proposer.stateKey,
                        "countryCode": "",
                        "gender": (proposer.gender === "M" || proposer.gender === "Male") ? "M" : "F",
                        "emailId": proposer.email,
                        "mobileNumber": proposer.mobile,
                        "occupationCode": proposer.occupation.key,
                        "pan": arogyaSanjeevaniService.getPan() ? arogyaSanjeevaniService.getPan() : ""
                    },
                    "kycDetails": {
                        "kycEFormat": arsaEinsuranceVm.data.isRepo ? '1' : '0',
                        "kycRepository": (arsaEinsuranceVm.data.isRepo && arsaEinsuranceVm.data.eAccount == '2') ? arsaEinsuranceVm.data.repository.key : "",
                        "kycEInsuranceAccountNo": (arsaEinsuranceVm.data.isRepo && arsaEinsuranceVm.data.eAccount == '1') ? arsaEinsuranceVm.data.eaccountNumber : "",
                        "kycCkycNo": arsaEinsuranceVm.data.ckyc ? arsaEinsuranceVm.data.ckyc : ""
                    },
                    "insuredDetails": insureDetArrary,
                    "existingIllness": einsurance.existingIllness ? 'true' : 'false',
                    "deniedInsurance": einsurance.deniedInsurance ? 'true' : 'false',
                    "insuredQuestions": medicalQuestions,
                    "nomineeDetails": {
                        "name": nomineeDetails.nomineeName + " " + nomineeDetails.nomineeLastName,
                        "relationship": nomineeDetails.nomineeRelationWithInsured.key,
                        "dob":  $filter('dateFormat')(nomineeDetails.birthdate),
                        "gender": nomineeDetails.nomineeTitle.gender
                    },
                    "appointeeDetails": {
                        "name": nomineeDetails.AppointeeName ? nomineeDetails.AppointeeName + " " + nomineeDetails.appointeeLastName : "",
                        "appointeeRelationship": nomineeDetails.relationWithNominee ? nomineeDetails.relationWithNominee.key : ""
                    }
                }
            };
            arogyaSanjeevaniService.fullQuote(request).then(function (data) {
                var premiumData = arogyaSanjeevaniService.getPremiumData();
                premiumData.estPremium = data.arogyaSanjeevani.duePremium;
                arogyaSanjeevaniService.setPremiumData(premiumData);
                arogyaSanjeevaniService.setQuote(data.arogyaSanjeevani.quotationNo);
                arsaEinsuranceVm.saveApplicationArogya();
            }, function (error) {
                arogyaSanjeevaniService.showError(error.responseMessage);
            });
        }

        /* save application for Arogya Sanjeevani  */
        arsaEinsuranceVm.saveApplicationArogya = function () {
            var stringifyStructure1 = arogyaSanjeevaniService.getSaveApplicationArogyaStructure();
            var structure = stringifyStructure1;
            if (typeof (structure.quoteData) == 'string') {
                structure.quoteData = JSON.parse(structure.quoteData);
            }
            var firstPageDetail = arogyaSanjeevaniService.getSaveQuoteRequestForArogya();
            var applicationNo = arogyaSanjeevaniService.getSaveApplicationArogyaResponse();
            firstPageDetail.quoteData = structure.quoteData;
            firstPageDetail.quoteData.premiumCalculation.request.einsurance = {};
            firstPageDetail.quoteData.premiumCalculation.request.einsurance = arsaEinsuranceVm.data;
            structure.applicationNumber = applicationNo.applicationNumber;
            structure.sumInsured = arogyaSanjeevaniService.getpolicySumInsured() ? arogyaSanjeevaniService.getpolicySumInsured() : "";
            structure.policyStartDate = arogyaSanjeevaniService.getpolicyStartdate() ? arogyaSanjeevaniService.getpolicyStartdate() : "";
            structure.quoteData = firstPageDetail.quoteData;
            structure.applicationData = GIconstant.OmniChannel.ArogyaSanjeevani.AP_EINSURNACE;
            var stringified = structure;
            if (typeof (stringified.quoteData) == 'object') {
                stringified.quoteData = JSON.stringify(stringified.quoteData);
            }
            arogyaSanjeevaniService.setSaveApplicationArogyaStructure(structure);
            generalInsurenceHomeService.saveApplication(stringified, GIconstant.OmniChannel.Arogya.AP_EINSURNACE).then(function (data) {
                 arogyaSanjeevaniService.setEinsurance(arsaEinsuranceVm.data);
                 $state.go("menu.arsaPayment");
            }, function (error) {
                arogyaSanjeevaniService.showError(error.responseMessage);
            });
        }

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            arsaEinsuranceVm.initPage();
        });



    }
]);
