angularApp.controller('arsaNomineeDetailsController', 
["$state", "$scope", "$filter",
    "validateService", "generalInsurenceHealthService",
    "generalInsurenceHomeService", "GIconstant", "utilityService",
    "$translate", "arogyaSanjeevaniService", "$ionicScrollDelegate",


    function ($state, $scope, $filter, validateService,
        generalInsurenceHealthService, generalInsurenceHomeService,
        GIconstant, utilityService, $translate,  arogyaSanjeevaniService, 
        $ionicScrollDelegate) {

        var arsaNomineeDetailsVm = this;

        /* Function to display the necessary information
         & put validation on Page load*/
        arsaNomineeDetailsVm.initPage = function () {
            arsaNomineeDetailsVm.terms = false;
            arsaNomineeDetailsVm.validateService = validateService;
            arsaNomineeDetailsVm.showBack = true;
            arsaNomineeDetailsVm.showNext = true;
            arsaNomineeDetailsVm.nomineeReadonly = false;
            arsaNomineeDetailsVm.apointeeReadonly = false;
            arsaNomineeDetailsVm.RemoveSelf = true;
            arsaNomineeDetailsVm.travelNomineeDetailsInfoForm = {};
            arsaNomineeDetailsVm.data = {};
            arsaNomineeDetailsVm.data.autoRenew =  false;
            arsaNomineeDetailsVm.data.terms =  false;
            arsaNomineeDetailsVm.premium = arogyaSanjeevaniService.getPremiumData() ? arogyaSanjeevaniService.getPremiumData().estPremium : "";            
            arsaNomineeDetailsVm.titles = generalInsurenceHealthService.getArogyaMasterList().title;
            arsaNomineeDetailsVm.nomineeRelationsWithInsured = generalInsurenceHealthService.getArogyaMasterList().nomineeRealtion;
            arsaNomineeDetailsVm.relationsWithNominee = generalInsurenceHealthService.getArogyaMasterList().appointeeRelation;
            var currentDate = generalInsurenceHomeService.getCurrentDate();
            arsaNomineeDetailsVm.birthdateStartLimit = currentDate;
            if (arogyaSanjeevaniService.getNomineeDetail()) {
                arsaNomineeDetailsVm.data = arogyaSanjeevaniService.getNomineeDetail();
            } else {
                var curentDate = generalInsurenceHomeService.getCurrentDate();
                arsaNomineeDetailsVm.data.minDOB = generalInsurenceHomeService.getFutureYear(curentDate, -110);
                arsaNomineeDetailsVm.data.maxDOB = generalInsurenceHomeService.getFutureYear(curentDate, -18);
                arsaNomineeDetailsVm.data.maxDOB = generalInsurenceHomeService.getFutureDate(arsaNomineeDetailsVm.data.maxDOB, 1);
            }
            if(arsaNomineeDetailsVm.data.terms) {
                arsaNomineeDetailsVm.data.nomineeDetailsTCTime = arogyaSanjeevaniService.getNomineeDetail().nomineeDetailsTCTime ? arogyaSanjeevaniService.getNomineeDetail().nomineeDetailsTCTime : "";
            } else {
                arsaNomineeDetailsVm.data.nomineeDetailsTCTime = "";
            }
        }

        /* Function to validate all the required fields */
        arsaNomineeDetailsVm.validateForm = function () {
            arsaNomineeDetailsVm.travelNomineeDetailsInfoForm = {};
            if (arsaNomineeDetailsVm.validateService.isValidFirstName(arsaNomineeDetailsVm.data.nomineeName)) {
                arsaNomineeDetailsVm.travelNomineeDetailsInfoForm.nomineeName = arsaNomineeDetailsVm.validateService.isValidFirstName(arsaNomineeDetailsVm.data.nomineeName);
            }
            if (arsaNomineeDetailsVm.validateService.isValidTitle(arsaNomineeDetailsVm.data.nomineeTitle)) {
                arsaNomineeDetailsVm.travelNomineeDetailsInfoForm.nomineeTitle = arsaNomineeDetailsVm.validateService.isValidTitle(arsaNomineeDetailsVm.data.nomineeTitle);
            }
            if (arsaNomineeDetailsVm.validateService.isValidLastNameGI(arsaNomineeDetailsVm.data.nomineeLastName,false)) {
                arsaNomineeDetailsVm.travelNomineeDetailsInfoForm.nomineeLastName = arsaNomineeDetailsVm.validateService.isValidLastNameGI(arsaNomineeDetailsVm.data.nomineeLastName,false);
            }
            if (arsaNomineeDetailsVm.validateService.isValidNomineeRelationWithInsured(arsaNomineeDetailsVm.data.nomineeRelationWithInsured)) {
                arsaNomineeDetailsVm.travelNomineeDetailsInfoForm.nomineeRelationWithInsured = arsaNomineeDetailsVm.validateService.isValidNomineeRelationWithInsured(arsaNomineeDetailsVm.data.nomineeRelationWithInsured);
            }
            if (arsaNomineeDetailsVm.validateService.isValidbirthDate(arsaNomineeDetailsVm.data.birthdate)) {
                arsaNomineeDetailsVm.travelNomineeDetailsInfoForm.birthdate = arsaNomineeDetailsVm.validateService.isValidbirthDate(arsaNomineeDetailsVm.data.birthdate);
            }

            if (arsaNomineeDetailsVm.validateService.isValidDateGI(arsaNomineeDetailsVm.data.birthdate, '01 Jan 1900', arsaNomineeDetailsVm.birthdateStartLimit)) {
                arsaNomineeDetailsVm.travelNomineeDetailsInfoForm.birthdate = arsaNomineeDetailsVm.validateService.isValidDateGI(arsaNomineeDetailsVm.data.birthdate, '01 Jan 1900', arsaNomineeDetailsVm.birthdateStartLimit);
            }

            if (arsaNomineeDetailsVm.data.minorNominee) {
                if (arsaNomineeDetailsVm.validateService.isValidTitle(arsaNomineeDetailsVm.data.appointeeTitle)) {
                    arsaNomineeDetailsVm.travelNomineeDetailsInfoForm.appointeeTitle = arsaNomineeDetailsVm.validateService.isValidTitle(arsaNomineeDetailsVm.data.appointeeTitle);
                }
                if (arsaNomineeDetailsVm.validateService.isValidLastNameGI(arsaNomineeDetailsVm.data.appointeeLastName,false)) {
                    arsaNomineeDetailsVm.travelNomineeDetailsInfoForm.appointeeLastName = arsaNomineeDetailsVm.validateService.isValidLastNameGI(arsaNomineeDetailsVm.data.appointeeLastName,false);
                }
                if (arsaNomineeDetailsVm.validateService.isValidAppointeeRelationshipwithNominee(arsaNomineeDetailsVm.data.relationWithNominee)) {
                    arsaNomineeDetailsVm.travelNomineeDetailsInfoForm.relationWithNominee = arsaNomineeDetailsVm.validateService.isValidAppointeeRelationshipwithNominee(arsaNomineeDetailsVm.data.relationWithNominee);
                }
                if (arsaNomineeDetailsVm.validateService.isValidName(arsaNomineeDetailsVm.data.AppointeeName)) {
                    arsaNomineeDetailsVm.travelNomineeDetailsInfoForm.AppointeeName = arsaNomineeDetailsVm.validateService.isValidName(arsaNomineeDetailsVm.data.AppointeeName);
                }
                if (arsaNomineeDetailsVm.validateService.isValidbirthDate(arsaNomineeDetailsVm.data.proposerBirthday)) {
                    arsaNomineeDetailsVm.travelNomineeDetailsInfoForm.proposerBirthday = arsaNomineeDetailsVm.validateService.isValidbirthDate(arsaNomineeDetailsVm.data.proposerBirthday);
                }
                if (arsaNomineeDetailsVm.validateService.isValidDateGI(arsaNomineeDetailsVm.data.proposerBirthday, arsaNomineeDetailsVm.data.minDOB, arsaNomineeDetailsVm.data.maxDOB)) {
                    arsaNomineeDetailsVm.travelNomineeDetailsInfoForm.proposerBirthday = arsaNomineeDetailsVm.validateService.isValidDateGI(arsaNomineeDetailsVm.data.proposerBirthday, arsaNomineeDetailsVm.data.minDOB, arsaNomineeDetailsVm.data.maxDOB);
                }
            }
            return (angular.equals({}, arsaNomineeDetailsVm.travelNomineeDetailsInfoForm)) ? true : false;
        }

        /* go to previous page */
        arsaNomineeDetailsVm.goBacktoPrevious = function () {
            $state.go('menu.arsaMedicalQuestion');
        }

        /* fuction to save time on T&C Click  */
        arsaNomineeDetailsVm.onTnCondClick = function(isChecked) {
            if(isChecked) {
                var presentDate = new Date();
                var timeInMilliSec = presentDate.getTime();
                arsaNomineeDetailsVm.data.nomineeDetailsTCTime = timeInMilliSec;
            }
        }

        /* save application for Arogya Sanjeevani  */
        arsaNomineeDetailsVm.saveApplicationArogya = function () {
            var stringifyStructure1 = arogyaSanjeevaniService.getSaveApplicationArogyaStructure();
            var structure = stringifyStructure1;
            if (typeof (structure.quoteData) == 'string') {
                structure.quoteData = JSON.parse(structure.quoteData);
            }
            var firstPageDetail = arogyaSanjeevaniService.getSaveQuoteRequestForArogya();
            var applicationNo = arogyaSanjeevaniService.getSaveApplicationArogyaResponse();
            firstPageDetail.quoteData = structure.quoteData;
            firstPageDetail.quoteData.premiumCalculation.request.nomineeDetails = {};
            firstPageDetail.quoteData.premiumCalculation.request.nomineeDetails = arsaNomineeDetailsVm.data;
            structure.applicationNumber = applicationNo.applicationNumber;
            structure.sumInsured = arogyaSanjeevaniService.getpolicySumInsured() ? arogyaSanjeevaniService.getpolicySumInsured() : "";
            structure.policyStartDate = arogyaSanjeevaniService.getpolicyStartdate() ? arogyaSanjeevaniService.getpolicyStartdate() : "";
            structure.quoteData = firstPageDetail.quoteData;
            structure.applicationData = GIconstant.OmniChannel.ArogyaSanjeevani.AP_NOMINEE_DETAILS;
            var stringified = structure;
            if (typeof (stringified.quoteData) == 'object') {
                stringified.quoteData = JSON.stringify(stringified.quoteData);
            }
            arogyaSanjeevaniService.setSaveApplicationArogyaStructure(structure);
            generalInsurenceHomeService.saveApplication(stringified, GIconstant.OmniChannel.Arogya.AP_NOMINEE_DETAILS).then(function (data) {
                arogyaSanjeevaniService.setNomineeDetail(arsaNomineeDetailsVm.data);
                $state.go("menu.arsaEinsurance");
            }, function (error) {
                arogyaSanjeevaniService.showError(error.responseMessage);
            });
        }


        /* if valid go to next page */
        arsaNomineeDetailsVm.goToNextPage = function () {
            if (arsaNomineeDetailsVm.validateForm()) {
                arsaNomineeDetailsVm.saveApplicationArogya();
            }
        }

        /* Function to check if the user is minor */
        arsaNomineeDetailsVm.isMinor = function () {
            if (arsaNomineeDetailsVm.data.birthdate) {
                var isMinorbirthdate = arsaNomineeDetailsVm.data.birthdate;
                var currentDate = generalInsurenceHomeService.getCurrentDate();
                var minorlimit = generalInsurenceHomeService.getFutureYear(currentDate, -18);
                minorlimit = generalInsurenceHomeService.getFutureDate(minorlimit, 2);
                var diffVal = $filter('dateDifferenceInDays')(minorlimit, isMinorbirthdate);
                if (diffVal > 0) {
                    arsaNomineeDetailsVm.data.checkForMinor = true;
                    arsaNomineeDetailsVm.data.minorNominee = true;
                } else {
                    arsaNomineeDetailsVm.data.checkForMinor = false;
                    arsaNomineeDetailsVm.data.minorNominee = false;
                }
            }

        }

        /* Function to show declartion popup */
        arsaNomineeDetailsVm.clickDeclaration = function () {
            generalInsurenceHomeService.getDiclaration().then(function (data) {

            }, function (error) {
                arogyaSanjeevaniService.showError(error.responseMessage);
            });
        };

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            arsaNomineeDetailsVm.initPage();
        });

        return this;

    }
]);
