'use strict';

angularApp.controller('arsaOTPPaymentController', ["$state",
    "$scope",
    "$translate",
    "getAccountDetailsService",
    "utilityService",
    "homeScreenService",
    "$ionicPopup","$filter","customerInfoService","arogyaSanjeevaniService",

    function ($state,
        $scope,
        $translate,
        getAccountDetailsService,
        utilityService,
        homeScreenService,
        $ionicPopup, $filter,customerInfoService,arogyaSanjeevaniService
    ) {

        var OTPPaymentControllerVm = this;      
        OTPPaymentControllerVm.showSubmit =true;
        OTPPaymentControllerVm.showBack = true;
        var count = 0;

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            OTPPaymentControllerVm.initPage();           
        });

        /* Function to display the necessary information
         & put validation on Page load*/
        OTPPaymentControllerVm.initPage = function()  {
            OTPPaymentControllerVm.mobileNumber =  $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4);
            OTPPaymentControllerVm.otp = "";
            OTPPaymentControllerVm.clickCount = 0;
            OTPPaymentControllerVm.otpValid = false;
            OTPPaymentControllerVm.disableLink = false;
            OTPPaymentControllerVm.otpError = "";
        }

        /* Function to send OTP on click of Resend OTP button*/
        OTPPaymentControllerVm.resendOtp = function(){    
            	count += 1;
                OTPPaymentControllerVm.otp = '';
		        if (count > 2) {
                    var mssgTxt = $translate.instant('ARSA_MAX_OTP_GENERATION');
                    arogyaSanjeevaniService.showError(mssgTxt);
                    OTPPaymentControllerVm.disableLink = true;
                }else {
                    OTPPaymentControllerVm.disableLink = false;
                    arogyaSanjeevaniService.resendOTPArsaPayment().then(function(data) {
                        var successMssg = $translate.instant('ASRA_SUCCESS_OTP_RESENT_MSSG');
                        var title = '';
                        var onTap = '';
                        var buttontext = 'OK';
                        arogyaSanjeevaniService.showAlertModal(title, successMssg, onTap, $scope, $state, buttontext);
                    },function(error){
                        count = count - 1;
                        arogyaSanjeevaniService.showError(error.responseMessage);   
                    })
                }

           
        }

        /* Function is called on change of OTP input */
        OTPPaymentControllerVm.changeOtp =  function(){
             if(OTPPaymentControllerVm.otp == '' || ! OTPPaymentControllerVm.otp){
                OTPPaymentControllerVm.otpValid = true;
                OTPPaymentControllerVm.otpError = $translate.instant('INVALID_OTP_ERR');
             }else if(OTPPaymentControllerVm.otp.length < 6){
                OTPPaymentControllerVm.otpValid = true;
                OTPPaymentControllerVm.otpError = $translate.instant('ARSA_INVALID_OTP');
             }else{
                 OTPPaymentControllerVm.otpValid = false;
                 OTPPaymentControllerVm.otpError = "";
             }
        }
    
        /* Function is validate the entered OTP */
         OTPPaymentControllerVm.validateOTPForPayNew = function(){

             if(OTPPaymentControllerVm.otp == '' || !OTPPaymentControllerVm.otp){
                OTPPaymentControllerVm.otpValid = true;
                OTPPaymentControllerVm.otpError = $translate.instant('INVALID_OTP_ERR');
             }else if(OTPPaymentControllerVm.otp.length != 6){
				OTPPaymentControllerVm.otpValid = true;
                OTPPaymentControllerVm.otpError = $translate.instant('ARSA_INVALID_OTP');
			 }else{
                OTPPaymentControllerVm.otpValid = false;
                OTPPaymentControllerVm.otpError = "";
                var reqParams = {};
                reqParams["otp"] = OTPPaymentControllerVm.otp;
                arogyaSanjeevaniService.valiateOTPArsaPayment(reqParams).then(function(data) {
                        data.statusCode = "0000";
                        arogyaSanjeevaniService.setLinkedpolicyDetails(data);
                        $state.go('menu.arsaPaymentSuceess');
                },function(error){
                    if(error.responseCode == "1401" || error.responseCode == "1402"||error.responseCode == "1403"||error.responseCode == "1404"){
                        var data = {};
                        data.statusCode = error.responseCode;
                        arogyaSanjeevaniService.setLinkedpolicyDetails(data);
                        $state.go('menu.arsaPaymentSuceess');
                    }else{
                        OTPPaymentControllerVm.otp ='';   
                        arogyaSanjeevaniService.showError(error.responseMessage);   
                    }
                })

             }
            
        }
       

        return this;
    }
]);