angularApp.controller('arsaPaymentController', 
    ["$state", "$scope", "$ionicPopup", "$filter",
    "validateService","generalInsurenceHomeService", "GIconstant", "utilityService",
    "$translate", "arogyaSanjeevaniService","$ionicPopover","getAccountDetailsService",


    function ($state, $scope,
        $ionicPopup, $filter, validateService, generalInsurenceHomeService,
        GIconstant, utilityService, $translate, arogyaSanjeevaniService, $ionicPopover,
        getAccountDetailsService) {

        var arsaPaymentVm = this;
        arsaPaymentVm.validateService = validateService;
        arsaPaymentVm.data = {};
        arsaPaymentVm.detailsPage = {};
        
        /* Function to display the necessary information
         & put validation on Page load*/
        arsaPaymentVm.initPage = function (){
            arsaPaymentVm.premium =  arogyaSanjeevaniService.getPremiumData() ?  arogyaSanjeevaniService.getPremiumData().estPremium : "";
            arsaPaymentVm.productName = "Arogya Sanjeevani";
            arsaPaymentVm.quoteNumber = arogyaSanjeevaniService.getQuote() ? arogyaSanjeevaniService.getQuote() :"";
            arsaPaymentVm.sumInsured = arogyaSanjeevaniService.getbasicHealthDetail() ? arogyaSanjeevaniService.getbasicHealthDetail().sumInsured.value : "";
            arsaPaymentVm.quoteSummaryTCTime = arogyaSanjeevaniService.getPremiumData() ? arogyaSanjeevaniService.getPremiumData().quoteSummaryTCTime.toString() : ""; 
            arsaPaymentVm.nomineeDetailsTCTime = arogyaSanjeevaniService.getNomineeDetail() ? arogyaSanjeevaniService.getNomineeDetail().nomineeDetailsTCTime.toString() : ""; 
            arsaPaymentVm.data.showSelect = true;
            arsaPaymentVm.detailsPage = {};
            arogyaSanjeevaniService.getSBIBankAccounts({}).then(function(data) {
                arsaPaymentVm.data.accList = data.beneficiaryList.ownAccounts;
                arogyaSanjeevaniService.accList = arsaPaymentVm.data.accList;
                var primaryAccount = getAccountDetailsService.accountOverviewData ? getAccountDetailsService.accountOverviewData.customerInformation.accountNumber : "";
                var objPriAcc = getAccountDetailsService.displayPrimaryAccountAsDefault(arsaPaymentVm.data.accList,primaryAccount);
                var index = arsaPaymentVm.data.accList.findIndex(function(acc){
                    return acc.benAccntNo == objPriAcc.benAccntNo
                })
                arsaPaymentVm.close(index);
            }, function(error) {
                arogyaSanjeevaniService.showError(error.responseMessage);
            });
            
        }

        /* Function to show PopOver on click of info icon*/
        arsaPaymentVm.displayInfo = function($event){
			arsaPaymentVm.leftStyle = "left : " + ($event.clientX - 35) + "px";
			
			arsaPaymentVm.template = '<ion-popover-view class="loginnewarrow hmbr-info arsa-popover arsa-referwidth" id="runtimeHeight">' + '<div class="edu-arrow-downnew" style="{{arsaPaymentVm.leftStyle}}"></div>' + 
			'<a class="iconsubtext closeinfobutton float-right" id="CALL_ANC" click-stream="click" ng-click="arsaPaymentVm.closePopover()">' + '<i class="ico-close ver-align-middle"></i>' + '</a>' + '<ion-content class="col-90" has-bouncing="false">' +
			'<div id="renderHeight" class="text-left padding-left-10 padding-right-10 font-size-12">'+
			'<div>A referral code is a unique number assigned to an SBI employee, which can be filled whenever the employee assist any customer in the journey in SBI General.</div>' + 
			'</div>' + '</ion-content>' + '</ion-popover-view>';
			$scope.popover = $ionicPopover.fromTemplate(arsaPaymentVm.template, {
				scope: $scope
			});
			$scope.popover.show($event);
		}

        /* Function to close PopOver*/
        arsaPaymentVm.closePopover = function(){
			$scope.popover.hide();
		}

        /* Function to show PopUp of Account List*/
         arsaPaymentVm.showPop = function(){
            if(arsaPaymentVm.data.accList && arsaPaymentVm.data.accList.length > 0){
                arsaPaymentVm.popUpTemplate = arogyaSanjeevaniService.formPopUpTemplate("arsaPaymentVm.data.accList","arsaPaymentVm");
                arsaPaymentVm.popUp = $ionicPopup.show({
                    title: '',
                    cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
                    template: arsaPaymentVm.popUpTemplate,
                    scope: $scope
                });
            }
        }

        /* Function to close PopUp of Account List*/
         arsaPaymentVm.close = function(index){
            if(arsaPaymentVm.popUp) {arsaPaymentVm.popUp.close()}
            arsaPaymentVm.data.balance = arsaPaymentVm.data.accList[index].balance;
            arsaPaymentVm.data.benAccntType = arsaPaymentVm.data.accList[index].benAccntType;
            arsaPaymentVm.data.benAccntNo = arsaPaymentVm.data.accList[index].benAccntNo;
            arsaPaymentVm.data.selectedAccount = arsaPaymentVm.data.accList[index];
            arsaPaymentVm.data.showSelect = false;
        }

        arsaPaymentVm.goBack = function () {
            $state.go("menu.arsaEinsurance");
        }

        arsaPaymentVm.goToNextPage = function () {
            arsaPaymentVm.detailsPage = {};
            if(arsaPaymentVm.data.referralCode && arsaPaymentVm.data.referralCode.length != 10){
                arsaPaymentVm.detailsPage.referralCode = $translate.instant("REFERENCECODE_MESSAGE");
                return;
            }else if(parseInt(arsaPaymentVm.data.balance) < parseInt(arsaPaymentVm.premium)){
                arogyaSanjeevaniService.showError($translate.instant('ARSA_LOW_BALANCE_MSSG'));
            }else{
                var request = {};
                request.accNo = arsaPaymentVm.data.benAccntNo ? arsaPaymentVm.data.benAccntNo : "";
                /**KYC check */
                arogyaSanjeevaniService.checkKyc(request).then(function(data) {
                    if(data && parseInt(data.kycPoints) >= 110){
                        var requestObj = {};
                        requestObj = {
                            "applicationNumber": arogyaSanjeevaniService.getSaveApplicationArogyaResponse() ? arogyaSanjeevaniService.getSaveApplicationArogyaResponse().applicationNumber : "",
                            "quoteNo": arsaPaymentVm.quoteNumber ? arsaPaymentVm.quoteNumber : "" ,
                            "premium": arsaPaymentVm.premium ? arsaPaymentVm.premium : "",
                            "accountNumber": arsaPaymentVm.data.benAccntNo ? arsaPaymentVm.data.benAccntNo : "",
                            "referralCode": arsaPaymentVm.data.referralCode ? arsaPaymentVm.data.referralCode : "",
                            "quoteSummaryTnC": "true",
                            "quoteSummaryTimestamp": arsaPaymentVm.quoteSummaryTCTime,
                            "nomineeTnC": "true",
                            "nomineeTnCTimestamp": arsaPaymentVm.nomineeDetailsTCTime
                        } 
                        /* Issue Policy Call   */      
                        arogyaSanjeevaniService.payARSAPolicy(requestObj).then(function() {
                            $state.go("menu.arsaOTPPayment");                
                        },function(error){
                            arogyaSanjeevaniService.showError(error.responseMessage);   
                        }); 
                    }else{
                        arogyaSanjeevaniService.showError($translate.instant('ARSA_KYC_NON_COMPLIANT_MSSG')); 
                    }             
                },function(error){
                    arogyaSanjeevaniService.showError(error.responseMessage);   
                }); 
                  
            }
        }

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            arsaPaymentVm.initPage();
        });

       

    }
]);
