'use strict';

angularApp.controller('arsaPaymentSuceessController', ["$state",
    "$scope", "$filter",    
    "$translate","arogyaSanjeevaniService", "utilityService","getAccountDetailsService",
    "openUrlInAppbroswerService","irctcService","$ionicPopup","generalInsurenceHomeDetailService",
    "homeScreenService","GIconstant","$ionicModal","clickStreamService",

    function ($state,
        $scope, $filter,          
        $translate, arogyaSanjeevaniService,    
        utilityService,getAccountDetailsService,openUrlInAppbroswerService,irctcService,$ionicPopup,
        generalInsurenceHomeDetailService,homeScreenService,GIconstant,$ionicModal,clickStreamService
    ) {

        var paymentSuccessVm = this;       
        paymentSuccessVm.showBack = true;
        paymentSuccessVm.showNext = true;
        
        $scope.$on('$ionicView.beforeEnter', function () {
            paymentSuccessVm.initPage();
        });

        /* Function to display the necessary information
         & put validation on Page load*/
        paymentSuccessVm.initPage = function() { 
            clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("GI_HLTHPYMTSUC" + "_" + "GIH_HI_END_NXT_BTN"));
            paymentSuccessVm.policyDetails = {};
            paymentSuccessVm.constant = GIconstant;
            paymentSuccessVm.imageSrc = '';
            paymentSuccessVm.errorMssg = '';
            paymentSuccessVm.height = '295px';
            var arsaProductData = arogyaSanjeevaniService.getbasicHealthDetail();
            paymentSuccessVm.sumInsured  = arsaProductData.sumInsured.value; 
            paymentSuccessVm.premiumAmt = arogyaSanjeevaniService.getPremiumData() ?  arogyaSanjeevaniService.getPremiumData().estPremium : "";
            paymentSuccessVm.policyDetails = arogyaSanjeevaniService.getLinkedpolicyDetails();
            var status = paymentSuccessVm.policyDetails.statusCode;
            if(status == "0000"){
                paymentSuccessVm.imageSrc = 'img/YCGroup5.svg';
                paymentSuccessVm.errorMssg = '';
                paymentSuccessVm.height = '295px';
            }else if(status == "1401"){
                paymentSuccessVm.imageSrc = 'img/FT/BhimUpi/errorSymbol.svg';
                paymentSuccessVm.errorMssg = $translate.instant('TRY_AFTER_SOMETIME_MSSG');
                paymentSuccessVm.height = '260px';
            }else if(status == "1402"){
                paymentSuccessVm.imageSrc = 'img/yc_Group.svg';
                paymentSuccessVm.errorMssg = $translate.instant('TIMED_OUT_MSSG'); 
                paymentSuccessVm.height = '220px';
            }else if (status == "1403" || status == "1404"){
                paymentSuccessVm.imageSrc = 'img/YCGroup5.svg';
                paymentSuccessVm.errorMssg = $translate.instant('POLICY_EMAILED_MSSG');
                paymentSuccessVm.height = '280px';
            }

            if(status == "0000" || status == "1404" || status == "1403"){
                var req = {};
                req.applicationNumber = arogyaSanjeevaniService.getSaveApplicationArogyaResponse().applicationNumber;
                generalInsurenceHomeDetailService.deleteApplication(req).then(function(giData) {
                }, function(error) {
                });
            }
            paymentSuccessVm.helpLineText = paymentSuccessVm.policyDetails.arogyaSanjeevani.helpLineText ? paymentSuccessVm.policyDetails.arogyaSanjeevani.helpLineText : "";
        }

        /* Function to View/Download Payment Slip*/
        paymentSuccessVm.getPaymentAcknowledgeSlip=function(isEmail){
            paymentSuccessVm.isFromEmail = isEmail;
            var data = {
                "policyNumber" : (paymentSuccessVm.policyDetails.arogyaSanjeevani && paymentSuccessVm.policyDetails.arogyaSanjeevani.policyNo) ? paymentSuccessVm.policyDetails.arogyaSanjeevani.policyNo : "",
                "isEmail" : isEmail
            };
            arogyaSanjeevaniService.getPaymentAcknowledgeSlip(data).then(function(res){
              if(paymentSuccessVm.isFromEmail){
                paymentSuccessVm.showMailAlert();
              }else{
                pdfGenration(res.arogyaSanjeevani.base64Pdf,res.arogyaSanjeevani.name);
              } 
            },function(error){
                arogyaSanjeevaniService.showError(error.responseMessage);             
            })
        }

        /* Function to convert base64 string to blob*/    
         function b64toBlob(b64Data, contentType, sliceSize) {
                contentType = contentType || '';
                sliceSize = sliceSize || 512;
                var byteCharacters = atob(b64Data);
                var byteArrays = [];
                for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
                    var slice = byteCharacters.slice(offset, offset + sliceSize);
                    var byteNumbers = [];
                    for (var i = 0; i < slice.length; i++) {
                        byteNumbers[i] = slice.charCodeAt(i);
                    }
                    var byteArray = new Uint8Array(byteNumbers);
                    byteArrays.push(byteArray);
                }
                var blob = new Blob(byteArrays, { type: contentType });
                return blob;
            }

        /* Function to save base64 data*/
            function savebase64AsPDF(folderpath, filename, content, contentType) {
                // Convert the base64 string in a Blob
                var DataBlob = b64toBlob(content, contentType);
                var errorInvalidSize = "Invalid File Size";
                window.resolveLocalFileSystemURL(folderpath, function(dir) {
                    dir.getFile(filename, { create: true }, function(file) {
                        file.createWriter(function(fileWriter) {
                            if (DataBlob.size >= paymentSuccessVm.constant.ArogyaSanjeevani.MIN_FILE_LENGTH && DataBlob.size <= paymentSuccessVm.constant.ArogyaSanjeevani.MAX_FILE_LENGTH) {
                                fileWriter.write(DataBlob);
                            } else {
                                arogyaSanjeevaniService.displayPopUp("", "padBtm25 top-padding26", errorInvalidSize, "OK",
                                    function () { }
                                );
                            }
                        }, function() {

                        });
                    });
                });
            }

        /* Function to generate PDF on device*/
            function pdfGenration(content, filename) {
                var contentType = "application/pdf";
                var isandroid;

                if (utilityService.isAndroidPlatform()) {
                    isandroid = true;
                    paymentSuccessVm.folderpath = cordova.file.externalRootDirectory;   
                    savebase64AsPDF(paymentSuccessVm.folderpath, filename, content, contentType);
                }

                if (utilityService.isIOSPlatform()) {
                    paymentSuccessVm.folderpath = cordova.file.applicationDirectory;
                }
                
                if (utilityService.isIOSPlatform()) {
                    irctcService.savebase64AsPDF(paymentSuccessVm.folderpath,filename,content,contentType);
                    if(utilityService.isIOSPlatform()){
                      openUrlInAppbroswerService.openUrl("data:application/pdf;base64,"+content+"","");
                    }
                }

                if (isandroid) {
                    var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="DOWNLOADFDRECEIPT" translate-values="{folderpath:paymentSuccessVm.folderpath}"></div>';
                    paymentSuccessVm.downloadPopup = $ionicPopup.show({
                        title: '',
                        template: template,
                        scope: $scope,
                        cssClass: 'arsa-alert-popup',
                        buttons: [{
                            text: 'OK',
                            type: 'button-assertive',
                            onTap: function() {
                                paymentSuccessVm.downloadPopup.close();
                            }
                        }],
                    });
                }
            }      

        /* Function to navigate to Account Overview Page*/
        paymentSuccessVm.goToHome = function () {         
          getAccountDetailsService.tabIndex.tabIndex=4;  
          homeScreenService.isInsuranceFlag=true;        
          $state.go('menu.accountOverviewMyBalance');
        }
        
        /* Function to show Email Alert*/
        paymentSuccessVm.showMailAlert = function () { 
            var mssg = $translate.instant('EMAIL_SENT_SUCCESSFULLY_ARSA');
                arogyaSanjeevaniService.displayPopUp("", "padBtm25 top-padding26", mssg, "OK", function () {
            });
        }

        /* Function to show modal on click of info icon*/
        paymentSuccessVm.displayInfo = function($event) {
            $ionicModal.fromTemplateUrl('pages/generalInsurance/arsaPasswordHintModal.html' ,{
                scope: $scope,
                animation: 'slide-in-up',
                backdropClickToClose : true
            }).then(function(modal) {
                $scope.modal = modal;
                $scope.modal.show();
            }); 
		}

        //actions to done everytime the view is hidden
        $scope.$on('$ionicView.afterLeave', function () {
            $scope.modal.hide();
            $scope.modal.remove();
        });
		
        return this;
    }
]);
