angularApp.controller('arsaProposerDetailsController', ["$timeout",
    "$state", "$scope", "$filter",
    "validateService", "generalInsurenceHealthService",
    "generalInsurenceHomeService", "GIconstant", "utilityService",
    "$translate", "arogyaSanjeevaniService", "$ionicScrollDelegate",


    function ($timeout, $state, $scope, $filter, validateService,
        generalInsurenceHealthService, generalInsurenceHomeService,
        GIconstant, utilityService, $translate, arogyaSanjeevaniService, $ionicScrollDelegate) {

        var arsaProposerDetailsVm = this;
        arsaProposerDetailsVm.showBack = true;
        arsaProposerDetailsVm.showNext = true;
        arsaProposerDetailsVm.data = {};
        arsaProposerDetailsVm.detailsPage = {};
        arsaProposerDetailsVm.validateService = validateService;
        var cbsDataDetail;

        /* Function to display the necessary information
         & put validation on Page load*/
        arsaProposerDetailsVm.initPage = function () {
            arsaProposerDetailsVm.panImage = "img/Visibility_off.svg";
            arsaProposerDetailsVm.readonly = true;
            arsaProposerDetailsVm.premium = arogyaSanjeevaniService.getPremiumData() ? arogyaSanjeevaniService.getPremiumData().estPremium : "";
            arsaProposerDetailsVm.showPan = false;
            arsaProposerDetailsVm.detailsPage = {};
            if (parseInt(arsaProposerDetailsVm.premium) > 100000) {
                var msg = $translate.instant('ARSA_PREM_AMT_GREATER_ONE_LAKH');
                arogyaSanjeevaniService.showError(msg, "menu.arsaQuoteCalculation", "OK", function () {
                    $state.go("menu.arsaQuoteCalculation");
                });
                return;
            }
            arsaProposerDetailsVm.titles = generalInsurenceHealthService.getArogyaMasterList().title;
            arsaProposerDetailsVm.occupations = generalInsurenceHealthService.getArogyaMasterList().arogyaSanjeevaniOccupation;
            if (arogyaSanjeevaniService.getHealthApplicationPersonalDetails()) {
                arsaProposerDetailsVm.data = arogyaSanjeevaniService.getHealthApplicationPersonalDetails();
                cbsDataDetail = arogyaSanjeevaniService.getHealthApplicationPersonalDetails().gender;
                if(generalInsurenceHomeService.getIIBaccountDetail()){
                    arsaProposerDetailsVm.populateTitle(generalInsurenceHomeService.getIIBaccountDetail());
                }else{
                    var data = {};
                    data.cbsData = {};
                    data.cbsData.genderCode = arsaProposerDetailsVm.data.gender;
                    arsaProposerDetailsVm.populateTitle(data);
                }
                arsaProposerDetailsVm.data.pan = $filter('cardmask')(arogyaSanjeevaniService.getPan(), 'X', 4);
                arsaProposerDetailsVm.detailsPage = {};
            } else {
                var account = {};
                generalInsurenceHomeService.getSBIBankAccounts(account).then(function (accDetails) {
                    var requestAccount = {
                        "bankAccountNo": accDetails.beneficiaryList.ownAccounts[0].benAccntNo
                    }
                    arsaProposerDetailsVm.prefilCBSData(requestAccount);
                }, function (error) {
                    arogyaSanjeevaniService.showError(error.responseMessage);
                });
            }
        }

        /* Function to fetech user's Information */
        arsaProposerDetailsVm.prefilCBSData = function (account) {
            generalInsurenceHomeService.getSBIBankAccoutDetails(account).then(function (data) {
                if (data) {
                    if (data.cbsData.pinCode.length == 6) {
                        var detail = {
                            "pinCode": data.cbsData.pinCode
                        }
                        arsaProposerDetailsVm.locationDetail(detail);
                    }
                    
                    cbsDataDetail = data.cbsData.genderCode;
                    arsaProposerDetailsVm.data.firstName = data.cbsData.firstName;
                    arsaProposerDetailsVm.data.gender = data.cbsData.genderCode;
                    arsaProposerDetailsVm.data.LastName = data.cbsData.lastName;
                    arsaProposerDetailsVm.data.birthdate = $filter('formatCbsDate')(data.cbsData.dateOfBirth);
                    arsaProposerDetailsVm.data.plotNo = data.cbsData.addressLine1;
                    arsaProposerDetailsVm.data.plotNo = arsaProposerDetailsVm.data.plotNo ? arsaProposerDetailsVm.data.plotNo.replace(/[^A-Za-z0-9./,-\s]/g, '') : '';
                    arsaProposerDetailsVm.data.address = data.cbsData.addressLine2;
                    arsaProposerDetailsVm.data.streetName = data.cbsData.addressLine3;
                    arsaProposerDetailsVm.data.pincode = data.cbsData.pinCode;
                    arsaProposerDetailsVm.data.email = data.cbsData.email1;
                    arsaProposerDetailsVm.data.mobile = data.cbsData.mobileNumber;
                    var panNumber = data.cbsData.panNumber ? data.cbsData.panNumber : "";
                    arsaProposerDetailsVm.data.isPanDisabled = data.cbsData.panNumber ? true : false;
                    arogyaSanjeevaniService.setPan(panNumber);
                    arsaProposerDetailsVm.data.pan = data.cbsData.panNumber ? $filter('cardmask')(data.cbsData.panNumber, 'X', 4) : "";
                    generalInsurenceHomeService.setIIBaccountDetail(data);
                    arsaProposerDetailsVm.detail = data.cbsData;
                    arsaProposerDetailsVm.populateTitle(data);
                }
            }, function (error) {
                arogyaSanjeevaniService.showError(error.responseMessage);
            });
        }

        /* Function to populate Title*/
        arsaProposerDetailsVm.populateTitle = function (data) {
            arsaProposerDetailsVm.data.isGenderReadOnly = false;
            arsaProposerDetailsVm.populate(data.cbsData.genderCode);
        }

        /* Function to enable/disable Title field*/
        arsaProposerDetailsVm.populate = function (code) {
            if (code == "F") {
                arsaProposerDetailsVm.data.gender = "Female";
                arsaProposerDetailsVm.titles = arsaProposerDetailsVm.titles.filter(function (title) {
                    return title.key != "9000000001";
                })
            }  else if (code == "M") {
                arsaProposerDetailsVm.data.gender = "Male";
                var maleTitle = arsaProposerDetailsVm.titles.filter(function (title) {
                    return title.key == "9000000001";
                })
                arsaProposerDetailsVm.data.title = maleTitle[0];
                arsaProposerDetailsVm.data.isGenderReadOnly = true;
            } else {
                arsaProposerDetailsVm.data.gender = "";
                arsaProposerDetailsVm.data.isGenderReadOnly = true;
            }
        }

        /* Function to Mask/UnMask PAN Number*/
        arsaProposerDetailsVm.switchPan = function () {
            if (arsaProposerDetailsVm.data.pan.length > 4) {
                if (arsaProposerDetailsVm.panImage.includes("On")) {
                    arsaProposerDetailsVm.panImage = "img/Visibility_off.svg";
                    arsaProposerDetailsVm.data.pan = $filter('cardmask')( arogyaSanjeevaniService.getPan(), 'X', 4);
                } else {
                    arsaProposerDetailsVm.data.pan =  arogyaSanjeevaniService.getPan();
                    arsaProposerDetailsVm.panImage = "img/Visibility_OnPurple.svg";
                }
            }
        }

        /* Function is called on Blur of PAN No input*/
        arsaProposerDetailsVm.panBlur = function () {
             arogyaSanjeevaniService.setPan(arsaProposerDetailsVm.data.pan);
            if (arsaProposerDetailsVm.data.pan.length > 4) {
                arsaProposerDetailsVm.data.pan = $filter('cardmask')(arsaProposerDetailsVm.data.pan, 'X', 4);
            }
            arsaProposerDetailsVm.panImage = "img/Visibility_off.svg";
            $timeout(function () {
                $ionicScrollDelegate.$getByHandle('mainScroll').resize();
            }, 50);
        }

        /* Function is called on Focus of PAN No input*/
        arsaProposerDetailsVm.panFocus = function () {
            arsaProposerDetailsVm.data.pan =  arogyaSanjeevaniService.getPan();
        }

        /* Function to get Location Array, State & City fields*/
        arsaProposerDetailsVm.locationDetail = function (detail) {
            generalInsurenceHomeService.getLocation(detail).then(function (dataDetail) {
                generalInsurenceHomeService.setLocationDetails(dataDetail);
                if (dataDetail) {
                    arsaProposerDetailsVm.data.city = dataDetail.city.cityName;
                    arsaProposerDetailsVm.data.locations = dataDetail.location;
                    arsaProposerDetailsVm.data.state = dataDetail.state.value;
                    arsaProposerDetailsVm.data.stateKey = dataDetail.state.code;
                }
            }, function (error) {
                arogyaSanjeevaniService.showError(error.responseMessage);
            });
        }

        /* Function to validate all the required fields*/
        arsaProposerDetailsVm.validateForm = function () {
            arsaProposerDetailsVm.detailsPage = {};
            if (arsaProposerDetailsVm.validateService.isValidTitle(arsaProposerDetailsVm.data.title)) {
                arsaProposerDetailsVm.detailsPage.title = arsaProposerDetailsVm.validateService.isValidTitle(arsaProposerDetailsVm.data.title);
            }
            if (arsaProposerDetailsVm.validateService.isValidFirstName(arsaProposerDetailsVm.data.firstName)) {
                arsaProposerDetailsVm.detailsPage.firstName = arsaProposerDetailsVm.validateService.isValidFirstName(arsaProposerDetailsVm.data.firstName);
            }
            if (arsaProposerDetailsVm.validateService.isValidLastNameGI(arsaProposerDetailsVm.data.LastName, true)) {
                arsaProposerDetailsVm.detailsPage.LastName = arsaProposerDetailsVm.validateService.isValidLastNameGI(arsaProposerDetailsVm.data.LastName, true);
            }
            if (arsaProposerDetailsVm.validateService.isValidGender(arsaProposerDetailsVm.data.gender)) {
                arsaProposerDetailsVm.detailsPage.gender = arsaProposerDetailsVm.validateService.isValidGender(arsaProposerDetailsVm.data.gender);
            }
            if (arsaProposerDetailsVm.validateService.isValidbirthDate(arsaProposerDetailsVm.data.birthdate)) {
                arsaProposerDetailsVm.detailsPage.birthdate = arsaProposerDetailsVm.validateService.isValidbirthDate(arsaProposerDetailsVm.data.birthdate);
            }
            if (arsaProposerDetailsVm.validateService.isValidOccupationArsa(arsaProposerDetailsVm.data.occupation)) {
                arsaProposerDetailsVm.detailsPage.occupation = arsaProposerDetailsVm.validateService.isValidOccupationArsa(arsaProposerDetailsVm.data.occupation);
            }
            if (arsaProposerDetailsVm.validateService.isValidplotNO(arsaProposerDetailsVm.data.plotNo)) {
                arsaProposerDetailsVm.detailsPage.plotNo = arsaProposerDetailsVm.validateService.isValidplotNO(arsaProposerDetailsVm.data.plotNo);
            }
            if (arsaProposerDetailsVm.validateService.isValidBuildingName(arsaProposerDetailsVm.data.address)) {
                arsaProposerDetailsVm.detailsPage.address = arsaProposerDetailsVm.validateService.isValidBuildingName(arsaProposerDetailsVm.data.address);
            }
            if (arsaProposerDetailsVm.validateService.isValidStreetName(arsaProposerDetailsVm.data.streetName)) {
                arsaProposerDetailsVm.detailsPage.streetName = arsaProposerDetailsVm.validateService.isValidStreetName(arsaProposerDetailsVm.data.streetName);
            }
            if (arsaProposerDetailsVm.validateService.isValidCity(arsaProposerDetailsVm.data.city)) {
                arsaProposerDetailsVm.detailsPage.city = arsaProposerDetailsVm.validateService.isValidCity(arsaProposerDetailsVm.data.city);
            }
            if (arsaProposerDetailsVm.validateService.isValidState(arsaProposerDetailsVm.data.state)) {
                arsaProposerDetailsVm.detailsPage.state = arsaProposerDetailsVm.validateService.isValidState(arsaProposerDetailsVm.data.state);
            }
            if (arsaProposerDetailsVm.validateService.isValidPincode(arsaProposerDetailsVm.data.pincode)) {
                arsaProposerDetailsVm.detailsPage.pincode = arsaProposerDetailsVm.validateService.isValidPincode(arsaProposerDetailsVm.data.pincode);
            }
            if (arsaProposerDetailsVm.validateService.isValidLocatiom(arsaProposerDetailsVm.data.location)) {
                arsaProposerDetailsVm.detailsPage.location = arsaProposerDetailsVm.validateService.isValidLocatiom(arsaProposerDetailsVm.data.location);
            }
            if (arsaProposerDetailsVm.validateService.isValidPhoneNo(arsaProposerDetailsVm.data.mobile)) {
                arsaProposerDetailsVm.detailsPage.mobile = arsaProposerDetailsVm.validateService.isValidPhoneNo(arsaProposerDetailsVm.data.mobile);
            }
            if (arsaProposerDetailsVm.validateService.isValidEmail(arsaProposerDetailsVm.data.email)) {
                arsaProposerDetailsVm.detailsPage.email = arsaProposerDetailsVm.validateService.isValidEmail(arsaProposerDetailsVm.data.email);
            }
            if (arsaProposerDetailsVm.validateService.isValidPanNumber(arogyaSanjeevaniService.getPan())) {
                arsaProposerDetailsVm.detailsPage.pan = arsaProposerDetailsVm.validateService.isValidPanNumber( arogyaSanjeevaniService.getPan());
            }

            return (angular.equals({}, arsaProposerDetailsVm.detailsPage)) ? true : false;
        }

        /* Function called on Back Button Click, to Navigate 
        Previous Page */
        arsaProposerDetailsVm.goBacktoPrevious = function () {
            $state.go("menu.arsaQuoteSummary");
        }

        /* Function called on Next Button Click, to Navigate to 
        Next Page */
        arsaProposerDetailsVm.goToNextPage = function () {
            if (arsaProposerDetailsVm.validateForm()) {
                arsaProposerDetailsVm.saveApplicationArogya();
            }
        }

        /* Save application for Arogya Sanjeevani */
        arsaProposerDetailsVm.saveApplicationArogya = function() {
            var stringifyStructure1 = arogyaSanjeevaniService.getSaveApplicationArogyaStructure();
            var structure = stringifyStructure1;
            if(typeof(structure.quoteData)=='string'){
                structure.quoteData = JSON.parse(structure.quoteData);
            }
            var firstPageDetail = arogyaSanjeevaniService.getSaveQuoteRequestForArogya();
            var premiumDetail = arogyaSanjeevaniService.getPremiumcalculationForArogyaPremium();
            var applicationNo = arogyaSanjeevaniService.getSaveApplicationArogyaResponse();
            firstPageDetail.quoteData = structure.quoteData;
            firstPageDetail.quoteData.premiumCalculation.request.personalDetails = {};
            firstPageDetail.quoteData.premiumCalculation.request.personalDetails = angular.copy(arsaProposerDetailsVm.data);
            firstPageDetail.quoteData.premiumCalculation.request.personalDetails.gender = cbsDataDetail;
            firstPageDetail.quoteData.premiumCalculation.request.personalDetails.pan =  arogyaSanjeevaniService.getPan();
            firstPageDetail.quoteData.premiumCalculation.response = premiumDetail;
            structure.applicationNumber = applicationNo.applicationNumber;
            structure.sumInsured =  arogyaSanjeevaniService.getpolicySumInsured() ?  arogyaSanjeevaniService.getpolicySumInsured() : "";   
            structure.policyStartDate =   arogyaSanjeevaniService.getpolicyStartdate() ?   arogyaSanjeevaniService.getpolicyStartdate() : "";
            structure.quoteData = firstPageDetail.quoteData;
            structure.applicationData = GIconstant.OmniChannel.ArogyaSanjeevani.AP_PROPOSER_DETAILS;
            var stringified = structure;
            if(typeof(stringified.quoteData)=='object'){
                stringified.quoteData = JSON.stringify(stringified.quoteData);
            }
            arogyaSanjeevaniService.setSaveApplicationArogyaStructure(structure);
            generalInsurenceHomeService.saveApplication(stringified,GIconstant.OmniChannel.Arogya.AP_PROPOSER_DETAILS).then(function(data) {
                arsaProposerDetailsVm.data.gender = cbsDataDetail;
                arogyaSanjeevaniService.setHealthApplicationPersonalDetails(arsaProposerDetailsVm.data);
                $state.go("menu.arsaPolicyHolder");
            }, function(error) {
                arogyaSanjeevaniService.showError(error.responseMessage);
            });
        }

        /* Function is called on change of PAN No,
        to fetch the location */
        arsaProposerDetailsVm.chkforpincode = function () {
            if (arsaProposerDetailsVm.data.pincode && arsaProposerDetailsVm.data.pincode.length == 6) {
                var detail = {
                    "pinCode": arsaProposerDetailsVm.data.pincode
                }
                arsaProposerDetailsVm.locationDetail(detail);
            } else {
                arsaProposerDetailsVm.data.city = '';
                arsaProposerDetailsVm.data.state = '';
            }
        }

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            arsaProposerDetailsVm.initPage();
        });

    }
]);
