angularApp.controller('sanjeevaniQuoteCalculationController', ["$timeout",
    "$state","$scope", "$filter", 
    "validateService", "generalInsurenceHealthService", 
    "generalInsurenceHomeService", "GIconstant", "utilityService", 
    "$translate","arogyaSanjeevaniService",


    function($timeout, $state, $scope,  $filter, validateService, 
        generalInsurenceHealthService, generalInsurenceHomeService, 
        GIconstant, utilityService, $translate,arogyaSanjeevaniService) {

        var quoteCalculationControllerVm = this;
        quoteCalculationControllerVm.constant = GIconstant;
        quoteCalculationControllerVm.healthInformation = {};
        quoteCalculationControllerVm.insuranceList = [];
        quoteCalculationControllerVm.showBack = true;
        quoteCalculationControllerVm.showNext = true;
        quoteCalculationControllerVm.isIncrEnabled = true;
        quoteCalculationControllerVm.isDecrEnabled = false;
        quoteCalculationControllerVm.product = {};
        quoteCalculationControllerVm.healthQuoteCalculation = {};
        quoteCalculationControllerVm.validateService = validateService;
        var productType;

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            quoteCalculationControllerVm.initPage();
        });

        /* Function to display the necessary information
         & put validation on Page load*/
        quoteCalculationControllerVm.initPage = function() {
            quoteCalculationControllerVm.product = {};
            var curentDate = generalInsurenceHomeService.getCurrentDate();
            quoteCalculationControllerVm.product.defaultvalue = curentDate;
            quoteCalculationControllerVm.product.minstartDate = $filter('chosenDate')(curentDate);
            quoteCalculationControllerVm.product.startDate = $filter('chosenDate')(curentDate);
            quoteCalculationControllerVm.product.maxEndDate = generalInsurenceHomeService.getFutureDate(curentDate, quoteCalculationControllerVm.constant.Health.policyEndDate);     
            var masterData = generalInsurenceHealthService.getArogyaMasterList();
            quoteCalculationControllerVm.product.familySize = quoteCalculationControllerVm.constant.Health.familySize1;
            quoteCalculationControllerVm.healthQuoteCalculation = {};
                if(arogyaSanjeevaniService.getbasicHealthDetail()) {
                    quoteCalculationControllerVm.product.productTypes = arogyaSanjeevaniService.getbasicHealthDetail().productTypes;
                    quoteCalculationControllerVm.product.sumInsured = arogyaSanjeevaniService.getbasicHealthDetail().sumInsured;
                    quoteCalculationControllerVm.product.startDate = arogyaSanjeevaniService.getbasicHealthDetail().startDate;
                    quoteCalculationControllerVm.product.familySize = arogyaSanjeevaniService.getbasicHealthDetail().familySize;
                    
                    quoteCalculationControllerVm.productType = masterData.arogyaSanjeevaniProductType ? masterData.arogyaSanjeevaniProductType : masterData.productType;
                    quoteCalculationControllerVm.sumInsured =  masterData.arogyaSanjeevaniSumInsured ? masterData.arogyaSanjeevaniSumInsured : masterData.variantSumInsured;
                } else {    
                    /* get Arogya masters */
                    if(generalInsurenceHealthService.getArogyaMasterList()) {
                        quoteCalculationControllerVm.productType = masterData.arogyaSanjeevaniProductType ? masterData.arogyaSanjeevaniProductType : masterData.productType;
                            quoteCalculationControllerVm.sumInsured =  masterData.arogyaSanjeevaniSumInsured ? masterData.arogyaSanjeevaniSumInsured : masterData.variantSumInsured;
                            quoteCalculationControllerVm.product.productTypes = quoteCalculationControllerVm.productType[0];
                            
                            quoteCalculationControllerVm.initialSumInsured = quoteCalculationControllerVm.sumInsured.filter(function (sum) {
                                return sum.value == '300000';
                            })

                        quoteCalculationControllerVm.product.sumInsured = quoteCalculationControllerVm.initialSumInsured[0];
                    } else {   
                        generalInsurenceHealthService.getArogyaMaster().then(function(response) {
                            quoteCalculationControllerVm.productType = response.arogyaSanjeevaniProductType ? response.arogyaSanjeevaniProductType : response.productType;
                            quoteCalculationControllerVm.sumInsured =  response.arogyaSanjeevaniSumInsured ? response.arogyaSanjeevaniSumInsured : response.variantSumInsured;
                            quoteCalculationControllerVm.product.productTypes = quoteCalculationControllerVm.productType[0];
                            
                            quoteCalculationControllerVm.initialSumInsured = quoteCalculationControllerVm.sumInsured.filter(function (sum) {
                                return sum.value == '300000';
                            })

                        quoteCalculationControllerVm.product.sumInsured = quoteCalculationControllerVm.initialSumInsured[0];
                        generalInsurenceHealthService.setArogyaMasterList(response);
                        }, function(error) {
                            arogyaSanjeevaniService.showError(error.responseMessage);
                        });
                    }  
                }  
            
            /* To Calculate the date range of Policy */
            quoteCalculationControllerVm.calculatePolicyEndDate = function() {
                if (quoteCalculationControllerVm.healthType == quoteCalculationControllerVm.constant.Health.simple) {
                    quoteCalculationControllerVm.product.policyEndDate = generalInsurenceHomeService.getFutureYear(quoteCalculationControllerVm.product.startDate, quoteCalculationControllerVm.constant.Health.policyEndYear);
                }
            }
        }

        /* based on product type display family size when page loaded  */
        quoteCalculationControllerVm.validateproductType = function(prodType) {
            if(prodType == quoteCalculationControllerVm.constant.ArogyaSanjeevani.ProductType.individual) {
                quoteCalculationControllerVm.product.familySize = quoteCalculationControllerVm.constant.Health.familySize1;
            }  else {
                quoteCalculationControllerVm.product.familySize = quoteCalculationControllerVm.constant.Health.familySize2;
            }
        }

        /* Function called on Back Button Click, to Navigate 
        Previous Page */
        quoteCalculationControllerVm.goBacktoPrevious = function() {
            $state.go('menu.recommendedPolicyDetails'); 
        }

        /* save application for Arogya Sanjeevani  */
        quoteCalculationControllerVm.saveApplicationArogya = function() {
            arogyaSanjeevaniService.setpolicyStartdate(quoteCalculationControllerVm.product.startDate);
            arogyaSanjeevaniService.setpolicySumInsured(quoteCalculationControllerVm.product.sumInsured.value);
            var structure = arogyaSanjeevaniService.getSaveApplicationSimpleHealth();
            var firstPageDetail = arogyaSanjeevaniService.getSaveQuoteRequestForArogya();
            firstPageDetail.quoteData.premiumCalculation.request.quoteDetails.productType = quoteCalculationControllerVm.product.productTypes;
            firstPageDetail.quoteData.premiumCalculation.request.quoteDetails.familysize = quoteCalculationControllerVm.product.familySize.toString();
            firstPageDetail.quoteData.premiumCalculation.request.quoteDetails.effectiveDate = new Date(quoteCalculationControllerVm.product.startDate);
            firstPageDetail.quoteData.premiumCalculation.request.quoteDetails.sumInsured = quoteCalculationControllerVm.product.sumInsured;

            var planDetail = generalInsurenceHomeService.getPlanDetail();
            
            structure.applicationNumber =  arogyaSanjeevaniService.getSaveApplicationArogyaResponse() ? arogyaSanjeevaniService.getSaveApplicationArogyaResponse().applicationNumber : '';
            structure.productCode = planDetail.productCode;
            structure.uin = GIconstant.common.arogyaSanjeevani;
            structure.planName = planDetail.planName;
            structure.mobileNumber = '';
            structure.quoteData = firstPageDetail.quoteData;
            structure.applicationData = GIconstant.OmniChannel.ArogyaSanjeevani.AP_PREMIUM_1;
            structure.sumInsured =  arogyaSanjeevaniService.getpolicySumInsured() ?  arogyaSanjeevaniService.getpolicySumInsured() : '';   
            structure.policyStartDate =   arogyaSanjeevaniService.getpolicyStartdate() ?   arogyaSanjeevaniService.getpolicyStartdate() : '';
           
            var stringified = structure;
            if(typeof(structure.applicationData)=='object'){
                   stringified.applicationData = JSON.stringify(stringified.applicationData);
            }
             if(typeof(structure.quoteData)=='object'){
                    stringified.quoteData = JSON.stringify(stringified.quoteData);
            }
            arogyaSanjeevaniService.setSaveApplicationArogyaStructure(structure);
            arogyaSanjeevaniService.setProductCode(planDetail.productCode);
            generalInsurenceHomeService.saveApplication(stringified,GIconstant.OmniChannel.ArogyaSanjeevani.AP_PREMIUM_1).then(function(data) {
                arogyaSanjeevaniService.setSaveApplicationArogyaResponse(data);
                $state.go('menu.arsaMembersDetails');
            }, function(error) {
                arogyaSanjeevaniService.showError(error.responseMessage);
            });
        }

         /* go to next page */
        quoteCalculationControllerVm.goToNextPage = function() {
            if (validateForm()) {
                quoteCalculationControllerVm.product.UIN = productType;
                quoteCalculationControllerVm.product.uin = productType;
                arogyaSanjeevaniService.setbasicHealthDetail(quoteCalculationControllerVm.product);
                quoteCalculationControllerVm.saveApplicationArogya();
            }
        }

        /* Function to decrease the count of insured members  */
        quoteCalculationControllerVm.decrementInsurers = function(count) {
            if(count == 2) {
                quoteCalculationControllerVm.isDecrEnabled = false;
            } else {
                quoteCalculationControllerVm.isDecrEnabled = true;
                quoteCalculationControllerVm.product.familySize--;
            }
        }

        /* Function to increase the count of insured members  */
        quoteCalculationControllerVm.incrementInsurers = function(count) {
            if(count >= 7) {
                quoteCalculationControllerVm.isIncrEnabled = false;
            } else {
                quoteCalculationControllerVm.isIncrEnabled = true;
                quoteCalculationControllerVm.product.familySize++;
            }
        }

        /* Form Validation   */
        function validateForm() {
            if (quoteCalculationControllerVm.validateService.isValidProductType(quoteCalculationControllerVm.product.productTypes)) {
                quoteCalculationControllerVm.healthQuoteCalculation.productTypes = quoteCalculationControllerVm.validateService.isValidProductType(quoteCalculationControllerVm.product.productTypes);
            }
            if (quoteCalculationControllerVm.validateService.isValidPolicyStartDate(quoteCalculationControllerVm.product.startDate)) {
                quoteCalculationControllerVm.healthQuoteCalculation.startDate = quoteCalculationControllerVm.validateService.isValidPolicyStartDate(quoteCalculationControllerVm.product.startDate);
            }
            if (quoteCalculationControllerVm.validateService.isValidSumInsured(quoteCalculationControllerVm.product.sumInsured)) {
                quoteCalculationControllerVm.healthQuoteCalculation.sumInsured = quoteCalculationControllerVm.validateService.isValidSumInsured(quoteCalculationControllerVm.product.sumInsured);
            }
            return (angular.equals({}, quoteCalculationControllerVm.healthQuoteCalculation)) ? true : false;
        }

    }
]);
