angularApp.controller('healthPremiumSummaryController', [
    "$state",
    "$scope",
    "$translate", "generalInsurenceHealthService", "generalInsurenceHomeService","clickStreamService",


    function(
        $state,
        $scope,
        $translate, generalInsurenceHealthService, generalInsurenceHomeService,clickStreamService) {

        var healthPremiumSummaryVm = this;
        var productType, premiumDetail;

        function initPage() {
            productType = generalInsurenceHomeService.getProductDetail().uin;
            var previousDetails =  generalInsurenceHealthService.getHealthInsureDetails();

            healthPremiumSummaryVm.showNext = true;
            healthPremiumSummaryVm.showBack = true;
            if (productType == '14') {
                healthPremiumSummaryVm.insuranceType = $translate.instant('simpleHealth');
                premiumDetail = generalInsurenceHealthService.getPremiumcalculationForSimpleHealth();
            } else if (productType == '13') {
                healthPremiumSummaryVm.insuranceType = $translate.instant('HOSPITAL_DAILY_CASH');
                premiumDetail = generalInsurenceHealthService.getPremiumDetailsForHDC();
            }

            generalInsurenceHomeService.setpolicySumInsured(previousDetails.totalSumInsured.value);

                        
            healthPremiumSummaryVm.data = {
                sumAssured: premiumDetail.premiumCalculation.sumInsured,
                quoteNumber: premiumDetail.premiumCalculation.quoteNumber,
                premiumAmount: premiumDetail.premiumCalculation.actualPremiumPayable,
                totalSumInsured : previousDetails.totalSumInsured.value
            };

            
        }

        healthPremiumSummaryVm.goToNextPage = function() {
            clickStreamService.clickStreamData = generalInsurenceHomeService.getProductDetail().policyName;
            if (productType == '14') {
                //$state.go('menu.quoteIRDAIOtp');
                $state.go("menu.healthApplicationPersonalDetails");
            } else if (productType == '13') {
                $state.go('menu.quoteIRDAIOtp');
            }


        }
        healthPremiumSummaryVm.goBackToPreviousPage = function() {
            if (productType == '14') {
                $state.go('menu.healthInsureDetail');
            } else if (productType == '13') {
                $state.go('menu.hospitalDailyCashPremiumCalculation');
            }

        }
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });


    }
]);
