angularApp.controller('simpleHealthPremiumCalulationController', ["$filter","$state", "$scope", "validateService", "generalInsurenceHealthService", "generalInsurenceHomeService", "GIconstant", "utilityService","clickStreamService",
    function($filter,$state, $scope, validateService, generalInsurenceHealthService, generalInsurenceHomeService, GIconstant, utilityService,clickStreamService) {

        //functions, variables that can be accessed from the HTML come here
        var simpleHealthPremiumCalulationVm = this;
        simpleHealthPremiumCalulationVm.constant = GIconstant;
        simpleHealthPremiumCalulationVm.product = {};
        simpleHealthPremiumCalulationVm.showBack = true;
        simpleHealthPremiumCalulationVm.showNext = true;
        var healthType;
        var productType;

        //private methods section start
        function initPage() {
            simpleHealthPremiumCalulationVm.product = {};
            
            /* get product uin id*/
            productType = generalInsurenceHomeService.getProductDetail().uin;
            if (productType == simpleHealthPremiumCalulationVm.constant.Health.arogya) {
                simpleHealthPremiumCalulationVm.productName = simpleHealthPremiumCalulationVm.constant.Health.arogyaPremium;
            } else if (productType == simpleHealthPremiumCalulationVm.constant.Health.hdc) {
                simpleHealthPremiumCalulationVm.productName = simpleHealthPremiumCalulationVm.constant.Health.hospitaldailycash;
            } else if (productType == simpleHealthPremiumCalulationVm.constant.Health.simple) {
                simpleHealthPremiumCalulationVm.productName = simpleHealthPremiumCalulationVm.constant.Health.simpleHealth;

            }
            // setTimeout(function() {
                simpleHealthPremiumCalulationVm.healthType = productType;
                simpleHealthPremiumCalulationVm.product.uin = productType;
            // }, 10);


            if (productType == simpleHealthPremiumCalulationVm.constant.Health.arogya) {
                /* get Arogya masters */
                generalInsurenceHealthService.getArogyaMaster().then(function(response) {
                    simpleHealthPremiumCalulationVm.productType = response.productType;
                    // simpleHealthPremiumCalulationVm.product.productTypes = simpleHealthPremiumCalulationVm.productType[0];
                    // simpleHealthPremiumCalulationVm.product.familySize = simpleHealthPremiumCalulationVm.constant.Health.familySize1;
                    generalInsurenceHealthService.setArogyaMasterList(response);

                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    //alert(error.responseMessage);
                });
            }

            /* get product type */
            else if (productType == simpleHealthPremiumCalulationVm.constant.Health.simple) {
              
                generalInsurenceHealthService.getSimpleMaster().then(function(response) {
                    simpleHealthPremiumCalulationVm.productType = response.productType;
                    // simpleHealthPremiumCalulationVm.product.productTypes = simpleHealthPremiumCalulationVm.productType[0];
                    // simpleHealthPremiumCalulationVm.product.familySize = simpleHealthPremiumCalulationVm.constant.Health.familySize1;
                    generalInsurenceHealthService.setSimpleMasterList(response);

                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    //alert(error.responseMessage);
                });
            }

            /* back button handle */
            setTimeout(function() {
                var previouspageData = generalInsurenceHealthService.getbasicHealthDetail();
                if (previouspageData) {
                    if (previouspageData.uin == productType) {
                        simpleHealthPremiumCalulationVm.product = previouspageData;
                    } else {
                        simpleHealthPremiumCalulationVm.product = {};
                        // simpleHealthPremiumCalulationVm.product.productTypes = simpleHealthPremiumCalulationVm.productType[0];
                        simpleHealthPremiumCalulationVm.product.familySize = simpleHealthPremiumCalulationVm.constant.Health.familySize1;
                        simpleHealthPremiumCalulationVm.product.startDate = $filter('chosenDate')(generalInsurenceHomeService.getCurrentDate());
                    }
                }
                else{
                     simpleHealthPremiumCalulationVm.product.familySize = simpleHealthPremiumCalulationVm.constant.Health.familySize1;
                     simpleHealthPremiumCalulationVm.product.startDate = $filter('chosenDate')(generalInsurenceHomeService.getCurrentDate());
                }
                 if(productType == simpleHealthPremiumCalulationVm.constant.Health.simple){
                    simpleHealthPremiumCalulationVm.product.policyEndDate = generalInsurenceHomeService.getFutureYear(simpleHealthPremiumCalulationVm.product.startDate, 1);
                 }
                  

                /* policy start date validation */
                var curentDate = generalInsurenceHomeService.getCurrentDate();
                simpleHealthPremiumCalulationVm.product.defaultvalue = curentDate;
                simpleHealthPremiumCalulationVm.product.minstartDate = $filter('chosenDate')(curentDate);
                simpleHealthPremiumCalulationVm.product.maxEndDate = generalInsurenceHomeService.getFutureDate(curentDate, simpleHealthPremiumCalulationVm.constant.Health.policyEndDate);

            }, 10);
            simpleHealthPremiumCalulationVm.calculatePolicyEndDate = function() {
                if (simpleHealthPremiumCalulationVm.healthType == simpleHealthPremiumCalulationVm.constant.Health.simple) {
                    simpleHealthPremiumCalulationVm.product.policyEndDate = generalInsurenceHomeService.getFutureYear(simpleHealthPremiumCalulationVm.product.startDate, simpleHealthPremiumCalulationVm.constant.Health.policyEndYear);
                }
            }
        }

        simpleHealthPremiumCalulationVm.validateService = validateService;
        simpleHealthPremiumCalulationVm.product = {};

        /* Form Validation   */
        function validateForm() {
            simpleHealthPremiumCalulationVm.healthQuoteCalculation = {};
            if (simpleHealthPremiumCalulationVm.validateService.isValidProductType(simpleHealthPremiumCalulationVm.product.productTypes)) {
                simpleHealthPremiumCalulationVm.healthQuoteCalculation.productTypes = simpleHealthPremiumCalulationVm.validateService.isValidProductType(simpleHealthPremiumCalulationVm.product.productTypes);
            }
            if (simpleHealthPremiumCalulationVm.validateService.isValidPolicyStartDate(simpleHealthPremiumCalulationVm.product.startDate)) {
                simpleHealthPremiumCalulationVm.healthQuoteCalculation.startDate = simpleHealthPremiumCalulationVm.validateService.isValidPolicyStartDate(simpleHealthPremiumCalulationVm.product.startDate);
            }

            if (simpleHealthPremiumCalulationVm.validateService.isValidDateGI(simpleHealthPremiumCalulationVm.product.startDate,simpleHealthPremiumCalulationVm.product.minstartDate,simpleHealthPremiumCalulationVm.product.maxEndDate)) {
                simpleHealthPremiumCalulationVm.healthQuoteCalculation.startDate = simpleHealthPremiumCalulationVm.validateService.isValidDateGI(simpleHealthPremiumCalulationVm.product.startDate,simpleHealthPremiumCalulationVm.product.minstartDate,simpleHealthPremiumCalulationVm.product.maxEndDate);
            }

            return (angular.equals({}, simpleHealthPremiumCalulationVm.healthQuoteCalculation)) ? true : false;
        }

        /* remove insured members  */
        simpleHealthPremiumCalulationVm.decrementInsurers = function() {
            if (simpleHealthPremiumCalulationVm.product.productTypes.key != simpleHealthPremiumCalulationVm.constant.Health.productTypeIndividual) {
                if (simpleHealthPremiumCalulationVm.product.familySize > simpleHealthPremiumCalulationVm.constant.Health.familySize2) {
                    simpleHealthPremiumCalulationVm.product.familySize--;
                } else {
                    return;
                }
            }
        }

        /* Add Insured Members  */
        simpleHealthPremiumCalulationVm.incrementInsurers = function() {
            if (simpleHealthPremiumCalulationVm.product.productTypes.key != simpleHealthPremiumCalulationVm.constant.Health.productTypeIndividual) {
                if (productType == simpleHealthPremiumCalulationVm.constant.Health.simple) {
                    if (simpleHealthPremiumCalulationVm.product.familySize < simpleHealthPremiumCalulationVm.constant.Health.familySize4) {
                        simpleHealthPremiumCalulationVm.product.familySize++;
                    }
                } else {
                    if (simpleHealthPremiumCalulationVm.product.productTypes.key == simpleHealthPremiumCalulationVm.constant.Health.productTypeFamilyFloater) {

                        if (simpleHealthPremiumCalulationVm.product.familySize < simpleHealthPremiumCalulationVm.constant.Health.familySize4) {
                            simpleHealthPremiumCalulationVm.product.familySize++;
                        }
                    } else {
                        if (simpleHealthPremiumCalulationVm.product.familySize < simpleHealthPremiumCalulationVm.constant.Health.familySize6) {
                            simpleHealthPremiumCalulationVm.product.familySize++;
                        }
                    }
                }
            }
        }

        /* based on product type display family size when page loaded  */
        simpleHealthPremiumCalulationVm.validateproductType = function() {
            if (simpleHealthPremiumCalulationVm.product.productTypes) {
                if (simpleHealthPremiumCalulationVm.product.productTypes.key == simpleHealthPremiumCalulationVm.constant.Health.productTypeIndividual) {
                    simpleHealthPremiumCalulationVm.product.familySize = simpleHealthPremiumCalulationVm.constant.Health.familySize1;
                } else {
                    simpleHealthPremiumCalulationVm.product.familySize = simpleHealthPremiumCalulationVm.constant.Health.familySize2;
                }
            }
        }

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        simpleHealthPremiumCalulationVm.goBacktoPrevious = function() {
            //To do
            switch (productType) {
                case simpleHealthPremiumCalulationVm.constant.Health.arogya:
                    $state.go("menu.recommendedPolicyDetails");
                    break;
                case simpleHealthPremiumCalulationVm.constant.Health.simple:
                    $state.go("menu.recommendedPolicyDetails");
                    break;
            }
        }


        /* save application for simple health  */
        function saveApplicationSH() {
             generalInsurenceHomeService.setpolicyStartdate(simpleHealthPremiumCalulationVm.product.startDate);
            var structure = generalInsurenceHomeService.getSaveApplicationSimpleHealth();
            var firstPageDetail = generalInsurenceHealthService.getSaveQuoteRequestForSimpleHealth();
            firstPageDetail.quoteData.premiumCalculation.request.quoteDetails.productType = simpleHealthPremiumCalulationVm.product.productTypes;
            firstPageDetail.quoteData.premiumCalculation.request.quoteDetails.familysize = simpleHealthPremiumCalulationVm.product.familySize.toString();
            firstPageDetail.quoteData.premiumCalculation.request.quoteDetails.effectiveDate = new Date(simpleHealthPremiumCalulationVm.product.startDate);
            firstPageDetail.quoteData.premiumCalculation.request.quoteDetails.expiryDate = new Date(simpleHealthPremiumCalulationVm.product.policyEndDate);
            firstPageDetail.quoteData.premiumCalculation.request.quoteDetails.planDuration = "1";
            var planDetail = generalInsurenceHomeService.getPlanDetail();
            // var stringifyDetail = JSON.stringify(firstPageDetail);
            //generalInsurenceHomeService.getSaveApplicationHealthStructure();
            structure.applicationNumber = generalInsurenceHomeService.getSaveApplicationHealthStructure() ? generalInsurenceHomeService.getSaveApplicationHealthStructure().applicationNumber : "";
            structure.productCode = planDetail.productCode;
            structure.uin = productType;
            structure.planName = planDetail.planName;
            structure.mobileNumber = "";
            structure.quoteData = firstPageDetail.quoteData;
            structure.applicationData = "";
            structure.sumInsured =  generalInsurenceHomeService.getpolicySumInsured() ?  generalInsurenceHomeService.getpolicySumInsured() : "";   
            structure.policyStartDate =   generalInsurenceHomeService.getpolicyStartdate() ?   generalInsurenceHomeService.getpolicyStartdate() : "";

            var stringified = structure;

            if(typeof(structure.applicationData)=='object'){
                    stringified.applicationData = JSON.stringify(stringified.applicationData);
            }
            if(typeof(structure.quoteData)=='object'){
                    stringified.quoteData = JSON.stringify(stringified.quoteData);
            }
            generalInsurenceHomeService.setSaveApplicationHealthStructure(structure);
            if(structure.applicationNumber==''){
            generalInsurenceHomeService.saveApplication(stringified,GIconstant.OmniChannel.SimpleHealth.SH_PREMIUM_1).then(function(data) {
                structure.applicationNumber = data.applicationNumber;
                 generalInsurenceHomeService.setSaveApplicationHealthStructure(structure);
                $state.go("menu.healthInsureDetail");
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
         }else{
             $state.go("menu.healthInsureDetail");
         }
        }




        /* save application for Arogya Premium  */
        function saveApplicationArogya() {
            generalInsurenceHomeService.setpolicyStartdate(simpleHealthPremiumCalulationVm.product.startDate);
            var structure = generalInsurenceHomeService.getSaveApplicationSimpleHealth();
            var firstPageDetail = generalInsurenceHealthService.getSaveQuoteRequestForArogya();
            firstPageDetail.quoteData.premiumCalculation.request.quoteDetails.productType = simpleHealthPremiumCalulationVm.product.productTypes;
            firstPageDetail.quoteData.premiumCalculation.request.quoteDetails.familysize = simpleHealthPremiumCalulationVm.product.familySize.toString();
            firstPageDetail.quoteData.premiumCalculation.request.quoteDetails.effectiveDate = new Date(simpleHealthPremiumCalulationVm.product.startDate);

            var planDetail = generalInsurenceHomeService.getPlanDetail();
            // var stringifyDetail = JSON.stringify(firstPageDetail);
            structure.applicationNumber =  generalInsurenceHealthService.getSaveApplicationArogyaResponse() ? generalInsurenceHealthService.getSaveApplicationArogyaResponse().applicationNumber : "";
            structure.productCode = planDetail.productCode;
            structure.uin = productType;
            structure.planName = planDetail.planName;
            structure.mobileNumber = "";
            structure.quoteData = firstPageDetail.quoteData;
            structure.applicationData = "";
            structure.sumInsured =  generalInsurenceHomeService.getpolicySumInsured() ?  generalInsurenceHomeService.getpolicySumInsured() : "";   
            structure.policyStartDate =   generalInsurenceHomeService.getpolicyStartdate() ?   generalInsurenceHomeService.getpolicyStartdate() : "";

            var stringified = structure;
            if(typeof(structure.applicationData)=='object'){
                   stringified.applicationData = JSON.stringify(stringified.applicationData);
            }
             if(typeof(structure.quoteData)=='object'){
                    stringified.quoteData = JSON.stringify(stringified.quoteData);
            }
            generalInsurenceHomeService.setSaveApplicationArogyaStructure(structure);

            generalInsurenceHomeService.saveApplication(stringified,GIconstant.OmniChannel.Arogya.AP_PREMIUM_1).then(function(data) {
                generalInsurenceHealthService.setSaveApplicationArogyaResponse(data);
                $state.go("menu.healthInsureDetail");
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }




        /*  go to next page */
        simpleHealthPremiumCalulationVm.goToNextPage = function() {
            if (validateForm()) {
                clickStreamService.clickStreamData = generalInsurenceHomeService.getProductDetail().policyName;
                var basicDetail = generalInsurenceHealthService.getbasicHealthDetail();

                if (basicDetail) {
                    if (basicDetail.UIN == productType) {
                        if (simpleHealthPremiumCalulationVm.product.productTypes.key == basicDetail.productTypes.key) {

                        } else {
                            var data = null;
                            generalInsurenceHomeService.setQuoteListDetails(data);
                            generalInsurenceHealthService.setPremiumcalculationForArogyaPremium(data);
                            generalInsurenceHealthService.setPremiumcalculationForSimpleHealth(data);
                        }

                    }

                }
                simpleHealthPremiumCalulationVm.product.UIN = productType;
                simpleHealthPremiumCalulationVm.product.uin = productType;
                generalInsurenceHealthService.setbasicHealthDetail(simpleHealthPremiumCalulationVm.product);
                if (productType == simpleHealthPremiumCalulationVm.constant.Health.arogya) {
                    saveApplicationArogya();

                } else if (productType == simpleHealthPremiumCalulationVm.constant.Health.simple) {
                    saveApplicationSH();

                }
            }
        }
    }
]);
// })();
