angularApp.service('generalInsurenceAccidentService', [ "$q", "AdapterUtils", "genralInsurenceConfig","$filter","generalInsurenceHomeService","generalInsurenceTravelService",
    function($q, AdapterUtils, genralInsurenceConfig,$filter,generalInsurenceHomeService,generalInsurenceTravelService) {


        var generalInsurenceAccident = this;
        var sumInsuredDetail, PolicyDateInformation, InsuredDetails, policyNumber, masterDetail, savedData;

        generalInsurenceAccident.clearAll = function(){
            sumInsuredDetail  = null; PolicyDateInformation = null; InsuredDetails = null; policyNumber = null; masterDetail = null; savedData = null;
        }
        generalInsurenceAccident.setsumInsuredDetail = function(data) {
                sumInsuredDetail = data;
        }
        generalInsurenceAccident.getsumInsuredDetail = function() {
                return sumInsuredDetail
        }
        generalInsurenceAccident.setPolicyDateInfo = function(data) {
            PolicyDateInformation = data;
        }
        generalInsurenceAccident.getPolicyDateInfo = function() {
            return PolicyDateInformation
        }
        generalInsurenceAccident.setInsuredDetails = function(data) {
            InsuredDetails = data;
        }
        generalInsurenceAccident.getInsuredDetails = function() {
            return InsuredDetails
        }
        generalInsurenceAccident.setMasterData = function(data) {
            masterDetail = data;
        }
        generalInsurenceAccident.getMasterData = function() {
            return masterDetail
        }
        generalInsurenceAccident.setSavedData = function(data) {
            savedData = data;
        }
        generalInsurenceAccident.getSavedData = function() {
            return savedData
        }
        generalInsurenceAccident.setPolicyNumber = function(data) {
            policyNumber = data;
        }
        generalInsurenceAccident.getPolicyNumber = function(data) {
            return policyNumber
        }

        generalInsurenceAccident.postPAIPremium = function(paiPremium) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.postPAIPremium[0], paiPremium, true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        generalInsurenceAccident.getPersonalAccidentMasters = function(paiPremium) {
            var q = $q.defer();
            AdapterUtils.getData(genralInsurenceConfig.adapterURL.getPersonalAccidentMasters[0], true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        

         generalInsurenceAccident.getInfoContentForGI = function(payment) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.getTooltipContent[0], payment, true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        generalInsurenceAccident.payForPAIPurchase = function(payment) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.payForPAIPurchase[0], payment, true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        //Function to validate OTP for PAI purchase
         generalInsurenceAccident.validateOTPForPAIPayment = function(otpRequest) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.validateOTPForPAIPayment[0], otpRequest, true).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        //Function to resend OTP for PAI purchase
         generalInsurenceAccident.resendOTPForPAIPayment = function() {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.resendOTPForPAI[0], true).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        //Function to resend OTP for PAI purchase
         generalInsurenceAccident.resendOTPForPAIRenewalPayment = function() {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.resendOTPForPAIRenewal[0], true).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        //Function to validate PAI policy
         generalInsurenceAccident.paiValidatePolicyPurchase = function() {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.paiValidatePolicyPurchase[0], true).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        generalInsurenceAccident.assignvalueForPAI = function() {
            var pagelength = 3;
            var savedApplication = {}
            var services = ["applicationData", "personal", "nominee"];
            for (var serCount = 0; serCount < pagelength; serCount++) {
                var SavePageDetail = services[serCount];
                if (SavePageDetail == "applicationData") {
                    if (savedData && savedData.quoteData && savedData.quoteData.policyStartDate ) {
                       sumInsuredDetail = {};
                       sumInsuredDetail.SumInsuredValue = savedData.quoteData.sumInsured;
                       sumInsuredDetail.finalPremiumAmount = savedData.quoteData.premiumAmount;
                       sumInsuredDetail.startDate = $filter('chosenDate')(savedData.quoteData.policyStartDate);
                       sumInsuredDetail.endDate = $filter('chosenDate')(savedData.quoteData.policyEndDate);
                    } else {
                        sumInsuredDetail = {};
                    }
                } else if (SavePageDetail == "personal") {

                   if (savedData && savedData.applicationData && savedData.applicationData.createquoterequest && savedData.applicationData.createquoterequest.personalDetails) {
                       InsuredDetails = {};
                       InsuredDetails.abbrName = savedData.applicationData.createquoterequest.personalDetails.abbrName;
                       InsuredDetails.firstName = savedData.applicationData.createquoterequest.personalDetails.firstName;
                       InsuredDetails.lastName = savedData.applicationData.createquoterequest.personalDetails.lastName;
                       InsuredDetails.dob = $filter('chosenDate')(savedData.applicationData.createquoterequest.personalDetails.dob);
                       InsuredDetails.gender = savedData.applicationData.createquoterequest.personalDetails.gender=='M'?'Male': 'Female';
                       InsuredDetails.emailId = savedData.applicationData.createquoterequest.personalDetails.emailId;
                       InsuredDetails.mobileNumber = savedData.applicationData.createquoterequest.personalDetails.mobileNumber;
                       InsuredDetails.pincode = savedData.applicationData.createquoterequest.personalDetails.pincode;
                       InsuredDetails.plotNo = savedData.applicationData.createquoterequest.personalDetails.plotNo;
                       InsuredDetails.buildingName = savedData.applicationData.createquoterequest.personalDetails.buildingName;
                       InsuredDetails.streetName = savedData.applicationData.createquoterequest.personalDetails.streetName;
                       InsuredDetails.location = savedData.applicationData.createquoterequest.personalDetails.location;
                       generalInsurenceHomeService.setLocationDetail(savedData.applicationData.createquoterequest.personalDetails.locationSource);
                    } else {
                        InsuredDetails = {};
                    }

                } else  if(SavePageDetail == "nominee"){


                     if (savedData && savedData.applicationData && savedData.applicationData.createquoterequest && savedData.applicationData.createquoterequest.nomineeDetails) {

                        var nomineeDetail = {};
                        nomineeDetail.uin  = savedData.uin;
                        nomineeDetail.nomineeTitle = savedData.applicationData.createquoterequest.nomineeDetails.name.salutation;
                        nomineeDetail.name1 = savedData.applicationData.createquoterequest.nomineeDetails.name.firstName;
                        nomineeDetail.nomineeLastName = savedData.applicationData.createquoterequest.nomineeDetails.name.lastName;
                        nomineeDetail.relationship = $filter('selectBoxFilter')(masterDetail.nomineeRelation,savedData.applicationData.createquoterequest.nomineeDetails.relationship); 
                        nomineeDetail.birthDate =  $filter('chosenDate')(savedData.applicationData.createquoterequest.nomineeDetails.dob);
                       if(savedData.applicationData.createquoterequest.appointeeDetails){
                        nomineeDetail.appointeeTitle =  savedData.applicationData.createquoterequest.appointeeDetails.appointeeTitle;
                        nomineeDetail.name = savedData.applicationData.createquoterequest.appointeeDetails.name;
                        nomineeDetail.appointeeLastName =  savedData.applicationData.createquoterequest.appointeeDetails.lastName;
                        nomineeDetail.relationshipWithNominee = $filter('selectBoxFilter')(masterDetail.appointeeRelation,savedData.applicationData.createquoterequest.appointeeDetails.appointeeRelationship);
                        nomineeDetail.proposerBirthday =  $filter('chosenDate')(savedData.applicationData.createquoterequest.appointeeDetails.dob);
                       }
                    generalInsurenceTravelService.setTravelNomineeDetail(nomineeDetail);
                        

                     }
                }
                
            }
        }


        return generalInsurenceAccident;

    }
]);

