angularApp.controller('cancelDetailsController', [
    "$state",
    "$scope",
    "validateService",
    "utilityService",
    "$translate",
    "$ionicPopup",
    "$ionicHistory",
    "generalInsurenceHomeService",
    "pailinkingRenwalService",
    "$ionicPopover",
    function ($state,
        $scope,
        validateService,
        utilityService,
        $translate,
        $ionicPopup,
        $ionicHistory,
        generalInsurenceHomeService,
        pailinkingRenwalService,
        $ionicPopover) {

        var cancelDetailsVm = this;

        cancelDetailsVm.initPage = function () {
            cancelDetailsVm.accountDetail = generalInsurenceHomeService.getLinkedpolicyDetailDetails();
            cancelDetailsVm.reasonList = pailinkingRenwalService.cancelStructure ? pailinkingRenwalService.cancelStructure.cancellnReasons : [];
            cancelDetailsVm.structure = pailinkingRenwalService.cancelStructure ? pailinkingRenwalService.cancelStructure.data : [];
            cancelDetailsVm.structureLength = cancelDetailsVm.structure.length - 2;
            cancelDetailsVm.reason = (pailinkingRenwalService.cancelStructure && pailinkingRenwalService.cancelStructure.cancellnReasons) ? pailinkingRenwalService.cancelStructure.cancellnReasons[0] : {};
        }

        cancelDetailsVm.displayInfo = function ($event, msg, no) {
            if (no == 1) {
                cancelDetailsVm.leftStyle = "left : " + ($event.pageX - 52) + "px";
                cancelDetailsVm.leftAlign = "left : " + 112 + "px !important";
            } else {
                cancelDetailsVm.leftStyle = "left : " + ($event.pageX - 235) + "px";
                cancelDetailsVm.leftAlign = "left : " + 112 + "px !important";
            }
			
			cancelDetailsVm.template = '<ion-popover-view class="loginnewarrow hmbr-info pce-popover pce-referwidth" id="runtimeHeight" style=>' + '<div class="pce-popover-upArrow" style="{{cancelDetailsVm.leftStyle}}"></div>' + 
			'<ion-content class="col-100" has-bouncing="false">' +
			'<div class="pce-popContent-txt"><div>'+ msg +'</div>' + 
			'</div>' + '</ion-content>' + '</ion-popover-view>';
			$scope.popover = $ionicPopover.fromTemplate(cancelDetailsVm.template, {
				scope: $scope
			});
			$scope.popover.show($event);
        }

        /* Function to close PopOver*/
        cancelDetailsVm.closePopover = function () {
            $scope.popover.hide();
        }

        cancelDetailsVm.goBack = function () {
            $ionicHistory.goBack();
        }

        cancelDetailsVm.cancelPolicy = function () {
            if (!cancelDetailsVm.accountDetail.cancellationRefNo) {
                if (cancelDetailsVm.accountDetail.uin == "44") {
                    cancelDetailsVm.callPAIValidate();
                } else if (cancelDetailsVm.accountDetail.uin == "15") {
                    cancelDetailsVm.validateAS();
                }
            } else {
                var currentDate = new Date();
                var newCancellationDate = cancelDetailsVm.accountDetail.cancellationDate.split(" ")[0];
                var cancelDate = new Date(newCancellationDate);
                var Difference_In_Time = currentDate.getTime() - cancelDate.getTime();
                var Difference_In_Days = Difference_In_Time / (1000 * 3600 * 24);
                if (Difference_In_Days <= 7) {
                    var errorMssgLine1 = $translate.instant('PCE_CANCEL_ERROR');
                    var errorMssgLine2 = $translate.instant('PCE_CANC_REQ_LODGED');
                    pailinkingRenwalService.errorPopUp(errorMssgLine1, errorMssgLine2, 'menu.myPolicies', '', function () { });
                } else {
                    if (cancelDetailsVm.accountDetail.uin == "44") {
                        cancelDetailsVm.callPAIValidate();
                    } else if (cancelDetailsVm.accountDetail.uin == "15") {
                        cancelDetailsVm.validateAS();
                    }
                }
            }
        }

        cancelDetailsVm.validateAS = function () {
            var request = {
                "journeyRequest": "Cancellation",
                "policyNumber": cancelDetailsVm.accountDetail.policyNo,
                "productCode": cancelDetailsVm.accountDetail.productCode ? cancelDetailsVm.accountDetail.productCode : "ASAN001"
            }
            pailinkingRenwalService.getSearchPolicyAS(request).then(function (res) {
                var statusCode = res.policyDetails[0].code.toUpperCase();
                var errorMssgLine2;
                pailinkingRenwalService.cancelDetails = res.policyDetails[0];
                pailinkingRenwalService.cancelDetails.reason = cancelDetailsVm.reason;
                if (statusCode == "SC003") {
                    pailinkingRenwalService.sendOTPForASCancellation().then(function (result) {
                        pailinkingRenwalService.isFromCancellation = true;
                        $state.go('menu.consentPage');
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }
                else {
                    var errorMssgLine1 = $translate.instant('PCE_CANCEL_ERROR');
                    switch (statusCode) {
                        case "EC001":
                            errorMssgLine2 = $translate.instant('PCE_ERROR_001');
                            break;
                        case "EC002":
                            errorMssgLine2 = $translate.instant('PCE_ERROR_002');
                            break;
                        case "EC004":
                            errorMssgLine2 = $translate.instant('PCE_ERROR_004_OR_008');
                            break;
                        case "EC005":
                            errorMssgLine2 = $translate.instant('PCE_ERROR_005');
                            break;
                        default:
                            errorMssgLine2 = "";
                    }
                    pailinkingRenwalService.errorPopUp(errorMssgLine1, errorMssgLine2, 'menu.myPolicies', '', function () { });
                }
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });


        }

        cancelDetailsVm.callPAIValidate = function () {
            var request = {
                "flow": "C"
            }
            pailinkingRenwalService.getPaiValidatePolicy(request).then(function (res) {
                var statusCode = res.message.toUpperCase();
                var errorMssgLine2;
                pailinkingRenwalService.cancelDetails = res;
                pailinkingRenwalService.cancelDetails.reason = cancelDetailsVm.reason;
                var currentDate = new Date();
                if (res.renewedPolicyinfo && res.renewedPolicyinfo.journalNo == cancelDetailsVm.accountDetail.policyNo) {
                    var getDateValue = res.renewedPolicyinfo.startDate.split(" ")[0];
                    var futurePolicyDate = getDateObj(getDateValue);
                    if(futurePolicyDate && futurePolicyDate.getTime() >= currentDate.getTime()) {
                        pailinkingRenwalService.navigateToConsent();
                    } else { 
                        pailinkingRenwalService.errorPopUp($translate.instant('PCE_CANCEL_ERROR'), '', '', '');
                    }
                }
                else if (res.journalNo == cancelDetailsVm.accountDetail.policyNo) {
                    if (statusCode == "SC003") {
                        pailinkingRenwalService.navigateToConsent();
                    } else {
                        var errorMssgLine1 = $translate.instant('PCE_CANCEL_ERROR');
                        switch (statusCode) {
                            case "EC001":
                                errorMssgLine2 = $translate.instant('PCE_ERROR_001');
                                break;
                            case "EC002":
                                errorMssgLine2 = $translate.instant('PCE_ERROR_002');
                                break;
                            case "EC004":
                                errorMssgLine2 = $translate.instant('PCE_ERROR_004_OR_008');
                                break;
                            case "EC005":
                                errorMssgLine2 = $translate.instant('PCE_ERROR_005');
                                break;
                            case "EC008":
                                errorMssgLine2 = $translate.instant('PCE_ERROR_004_OR_008');
                                break;
                            default:
                                errorMssgLine2 = "";
                        }
                        pailinkingRenwalService.errorPopUp(errorMssgLine1, errorMssgLine2, 'menu.myPolicies', '', function () { });
                    }
                } else {
                    pailinkingRenwalService.showError($translate.instant('PCE_TECHICAL_ERROR'));
                }

            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        pailinkingRenwalService.navigateToConsent = function() {
            pailinkingRenwalService.getOtp().then(function (result) {
                pailinkingRenwalService.isFromCancellation = true;
                $state.go('menu.consentPage');
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
        //funtion to format the date
        function getDateObj(dateStr) {
            if(!dateStr || dateStr.length != 8) {
                return null;
            }

            var day = dateStr.substring(0,2);
            var month = dateStr.substring(2,4);
            var year = dateStr.substring(4);

            return new Date(year, month - 1, day);
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            cancelDetailsVm.initPage();
        });

    }
]);
