angularApp.controller('consentPageController', [
    "$state", 
    "$scope", 
    "validateService", 
    "utilityService",
    "$translate",
    "$ionicPopup",
    "$ionicHistory",
    "generalInsurenceHomeService",
    "customerInfoService",
    "$filter",
    "pailinkingRenwalService",
    function($state, 
        $scope, 
        validateService, 
        utilityService,
        $translate,
        $ionicPopup,
        $ionicHistory,
        generalInsurenceHomeService,
        customerInfoService,
        $filter,
        pailinkingRenwalService) {

        var consentPageVm = this;

        consentPageVm.initPage = function () {
            consentPageVm.mobileNumber =   $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4);
            consentPageVm.resetPinOTP = "";
            consentPageVm.otpNumber = "";
			consentPageVm.otpCount = 0;
			consentPageVm.clickCount = 0;
			consentPageVm.isResendDisabled = false;
            consentPageVm.accountDetail = generalInsurenceHomeService.getLinkedpolicyDetailDetails();
        }
        
        consentPageVm.goBack = function() {
            $ionicHistory.goBack();
        }

        consentPageVm.goNext = function() {
            consentPageVm.resetPinOTP = "";
			if(!consentPageVm.otpNumber || consentPageVm.otpNumber.length != 6){
				consentPageVm.resetPinOTP = "Please enter valid OTP";
			}else{
                var request = {
					"otp" : consentPageVm.otpNumber,
                    "journeyName": "PAI_AS_CAN"
				}
				pailinkingRenwalService.validateOtp(request).then(function(data) {
                    if(consentPageVm.accountDetail.uin == "44"){
                        if(pailinkingRenwalService.isFromCancellation){
                            var cancelRequest = {
                                "product" : "PAI",
                                "refundReason": pailinkingRenwalService.cancelDetails && pailinkingRenwalService.cancelDetails.reason ? pailinkingRenwalService.cancelDetails.reason.value : "",
                                "policyNumber" : consentPageVm.accountDetail.policyNo
                            }
                            pailinkingRenwalService.cancelPolicy(cancelRequest).then(function(paiCancelData) {
                                pailinkingRenwalService.srNumber = paiCancelData.srNo;
                                $state.go("menu.paiCancelSucces");
                            },function(error){
                                utilityService.showErrorMessage(error.responseMessage);
                            })
                        }else{
                            var endorseRequest = {
                                "endorsements" : pailinkingRenwalService.getPaiUpdatePolicyDeatils()
                            }
                            pailinkingRenwalService.endorsePAI(endorseRequest).then(function(paiEndorseData) {
                                pailinkingRenwalService.srNumber = paiEndorseData.srNo;
                                $state.go("menu.paiCancelSucces");
                            },function(error){
                                utilityService.showErrorMessage(error.responseMessage);
                            })
                        }
                    }else if(consentPageVm.accountDetail.uin == "15"){
                        if(pailinkingRenwalService.isFromCancellation){
                            var cancelRequestAS = {
                                "product" : "AS",
                                "refundReason": pailinkingRenwalService.cancelDetails && pailinkingRenwalService.cancelDetails.reason ? pailinkingRenwalService.cancelDetails.reason.value : ""
                            }
                            pailinkingRenwalService.cancelPolicy(cancelRequestAS).then(function(asCancelData) {
                                pailinkingRenwalService.srNumber = asCancelData.srNo;
                                $state.go("menu.paiCancelSucces");
                            },function(error){
                                utilityService.showErrorMessage(error.responseMessage);
                            })
                        }
                    }
				},function(error){
					consentPageVm.otpNumber = "";
					consentPageVm.otpCount++;
					if(consentPageVm.otpCount >= 3){
                        pailinkingRenwalService.showErrorCaution("img/FT/BhimUpi/errorSymbol.svg",error.responseMessage,'menu.homeScreen','',function () { 
                            $state.go('menu.homeScreen');
                        });
					}else{
						utilityService.showErrorMessage(error.responseMessage);
					}
				})
            }
            
        }

        consentPageVm.resendOTP = function(){
			pailinkingRenwalService.getOtp().then(function(data) {
				consentPageVm.otpNumber = "";
				consentPageVm.resetPinOTP = "";
				consentPageVm.clickCount++;
				if(consentPageVm.clickCount >= 2){
					consentPageVm.isResendDisabled = true;
				}
				var template = "<p> "+ "Successfully resent OTP." +" </p>";
				var onTap = '';
				var buttontext = "<b>OK</b>";
				utilityService.showAlertModal('', template, onTap, $scope, $state, buttontext);
			},function(error){
				utilityService.showErrorMessage(error.responseMessage);
			});
		}			

        $scope.$on('$ionicView.beforeEnter', function() {
            consentPageVm.initPage();
        });

    }
]);
