angularApp.controller('paiCancelSucccessController', [
    "$state", 
    "$scope",
    "$translate",
    "utilityService",
    "$ionicPopup",
    "getAccountDetailsService",
    "homeScreenService",
    "pailinkingRenwalService",
    "GIconstant","irctcService",
    "arogyaSanjeevaniService",
    "generalInsurenceHomeService",
    "openUrlInAppbroswerService",
    function($state, 
        $scope,
        $translate,
        utilityService,
        $ionicPopup,
        getAccountDetailsService,
        homeScreenService,
        pailinkingRenwalService,
        GIconstant,irctcService,
        arogyaSanjeevaniService,
        generalInsurenceHomeService,
        openUrlInAppbroswerService) {

        var paiCancelSucccessVm = this;

        paiCancelSucccessVm.initPage = function () {
            paiCancelSucccessVm.constant = GIconstant;
            paiCancelSucccessVm.helpLine = "For any further assistance please call us on 1800-102-1111 or write to us at customer.care@sbigeneral.in or visit the nearest branch.";
            paiCancelSucccessVm.requestNumber = pailinkingRenwalService.srNumber;
            paiCancelSucccessVm.accountDetail = generalInsurenceHomeService.getLinkedpolicyDetailDetails();
            if(pailinkingRenwalService.isFromCancellation) {
                paiCancelSucccessVm.mssgToShow = $translate.instant('PCE_CANCELLATION_TEXT');
            } else {
                paiCancelSucccessVm.mssgToShow = $translate.instant('PCE_ENDORSEMENT_TEXT');
            }
        }
        
        paiCancelSucccessVm.viewDetails = function() {
            homeScreenService.isInsuranceFlag = true;
            getAccountDetailsService.tabIndex.tabIndex = 4;         
            $state.go('menu.accountOverviewMyBalance');
        }

        paiCancelSucccessVm.downloadPolicy = function(){
            var request = {};
            if(paiCancelSucccessVm.accountDetail.uin == "44"){
                if(pailinkingRenwalService.isFromCancellation) {  
                    request = {
                        "pdfType": "PAI"
                    }
                } else {
                    request = {
                        "pdfType": "PAI_END"
                    }
                }
            }else if(paiCancelSucccessVm.accountDetail.uin == "15"){
                request = {
                    "pdfType": "AS"
                }
            }
            pailinkingRenwalService.getCancelAcknowledgeSlip(request).then(function(data){
                pdfGenration(data.base64, data.fileName);
            },function(error){
                utilityService.showErrorMessage(error.responseMessage);
                //pailinkingRenwalService.showError(error.responseMessage); 
            })
        }

        function pdfGenration(content, filename) {
            var contentType = "application/pdf";

            if (utilityService.isAndroidPlatform()) {
                paiCancelSucccessVm.folderpath = cordova.file.externalDataDirectory;  
                savebase64AsPDF(paiCancelSucccessVm.folderpath, filename, content, contentType);
            }
            
            if (utilityService.isIOSPlatform()) {
                paiCancelSucccessVm.folderpath = cordova.file.applicationDirectory;
                irctcService.savebase64AsPDF(paiCancelSucccessVm.folderpath,filename,content,contentType);
                openUrlInAppbroswerService.openUrl("data:application/pdf;base64,"+content+"","");
                
            }
        }

        function savebase64AsPDF(folderpath, filename, content, contentType) {
            // Convert the base64 string in a Blob
            var DataBlob = b64toBlob(content, contentType);
            var errorInvalidSize = "Invalid File Size";
            if(utilityService.isAndroidPlatform()) {
                if(device.version==10){
                    paiCancelSucccessVm.popupFolderpath = folderpath.replace(cordova.file.externalRootDirectory,"") + filename;
                    window.resolveLocalFileSystemURL(folderpath, function(dir) {
                        dir.getFile(filename, { create: true }, function(file) {
                            file.createWriter(function(fileWriter) {
                                if (DataBlob.size >= paiCancelSucccessVm.constant.ArogyaSanjeevani.MIN_FILE_LENGTH && DataBlob.size <= paiCancelSucccessVm.constant.ArogyaSanjeevani.MAX_FILE_LENGTH) {
                                    fileWriter.write(DataBlob);
                                    paiCancelSucccessVm.showDownloadPopUp();
                                } else {
                                    arogyaSanjeevaniService.displayPopUp("", "padBtm25 top-padding26", errorInvalidSize, "OK",
                                        function () { }
                                    );
                                }
                            }, function() {});
                        });
                    });
                }
                else{
                    //for Android below 10 and Android 11 not for 10
                    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem){
                        fileSystem.root.getDirectory("Download", {create: true, exclusive: false},function(dir) {
                            paiCancelSucccessVm.popupFolderpath = dir.fullPath + filename;
                            dir.getFile(filename, { create: true, exclusive: false }, function(file) {
                                file.createWriter(function(fileWriter) {
                                    if (DataBlob.size >= paiCancelSucccessVm.constant.ArogyaSanjeevani.MIN_FILE_LENGTH && DataBlob.size <= paiCancelSucccessVm.constant.ArogyaSanjeevani.MAX_FILE_LENGTH) {
                                        fileWriter.write(DataBlob);
                                        paiCancelSucccessVm.showDownloadPopUp();
                                    } else {
                                        arogyaSanjeevaniService.displayPopUp("", "padBtm25 top-padding26", errorInvalidSize, "OK",
                                            function () { }
                                        );
                                    }
                                }, function() {});
                            });
                        });
                    });
                }

                
            }
        

        paiCancelSucccessVm.showDownloadPopUp = function() {
            //Show popup 
                var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="PAI_DOWNLOAD_RECEIPT" translate-values="{filePath:paiCancelSucccessVm.popupFolderpath}"></div>';
                paiCancelSucccessVm.downloadPopup = $ionicPopup.show({
                    title: '',
                    template: template,
                    scope: $scope,
                    cssClass: 'my-custom-popup',
                    buttons: [{
                        text:'OK',
                        type: 'button-assertive',
                        onTap: function() { 
                            paiCancelSucccessVm.downloadPopup.close();

                        }
                    }],
                });
            }
        }

        function b64toBlob(b64Data, contentType, sliceSize) {
            contentType = contentType || '';
            sliceSize = sliceSize || 512;
            var byteCharacters = atob(b64Data);
            var byteArrays = [];
            for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
                var slice = byteCharacters.slice(offset, offset + sliceSize);
                var byteNumbers = [];
                for (var i = 0; i < slice.length; i++) {
                    byteNumbers[i] = slice.charCodeAt(i);
                }
                var byteArray = new Uint8Array(byteNumbers);
                byteArrays.push(byteArray);
            }
            var blob = new Blob(byteArrays, { type: contentType });
            return blob;
        }

        paiCancelSucccessVm.displayInfo = function () {
            pailinkingRenwalService.showPassHintPopUp();
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            paiCancelSucccessVm.initPage();
        });

    }
]);
