angularApp.controller('quoteIRDAIOtpController', [
    "$state",
    "$scope",
    "$ionicPopup", "generalInsurenceHomeService", "GIconstant", "utilityService",

    function(
        $state,
        $scope,
        $ionicPopup, generalInsurenceHomeService, GIconstant, utilityService) {

        //functions, variables that can be accessed from the HTML come here
        var quoteIRDAIOtpVm = this;
        quoteIRDAIOtpVm.constant = GIconstant;

        //private methods section start
        function initPage() {
            quoteIRDAIOtpVm.showBack = true;
            quoteIRDAIOtpVm.showNext = true;
            quoteIRDAIOtpVm.featuresJson = [{ feature: "As per IRDAI regulations, you need to call one of our specified person to proceed further." },
                { feature: "The specified person will help explain features and address any queries This call will be toll free from your mobile number registered in India." },
            ];
            quoteIRDAIOtpVm.productType = generalInsurenceHomeService.getProductDetail().uin;

            switch (quoteIRDAIOtpVm.productType) {
                case '13':
                    quoteIRDAIOtpVm.productName = quoteIRDAIOtpVm.constant.common.hospitaldailycash;
                    break;
                case '11':
                    quoteIRDAIOtpVm.productName = quoteIRDAIOtpVm.constant.common.arogysPremier;
                    break;
                case '12':
                    quoteIRDAIOtpVm.productName = quoteIRDAIOtpVm.constant.common.criticalIllness;
                    break;
                case '31':
                    quoteIRDAIOtpVm.productName = quoteIRDAIOtpVm.constant.common.motorFour;
                    break;
                case '32':
                    quoteIRDAIOtpVm.productName = quoteIRDAIOtpVm.constant.common.motorTwo;
                    break;
                case '55':
                    quoteIRDAIOtpVm.productName = quoteIRDAIOtpVm.constant.common.TravelInsurance;
                    break;
                case '22':
                    quoteIRDAIOtpVm.productName = quoteIRDAIOtpVm.constant.common.longTermHome;
                    break;
                case '44':
                    quoteIRDAIOtpVm.productName = quoteIRDAIOtpVm.constant.common.PAI;
                    break;
                case '14':
                    quoteIRDAIOtpVm.productName = quoteIRDAIOtpVm.constant.common.simpleHealth;
                    break;
            }

        }
        //private methods section end
        function getAccDetails() {
            var accountn = {};
            generalInsurenceHomeService.getSBIBankAccounts(account).then(function(data) {

                generalInsurenceHomeService.setaccountDetail(data.beneficiaryList.ownAccounts);
                $state.go("menu.healthApplicationPersonalDetails", { page: "simple health" });
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }


        quoteIRDAIOtpVm.goToNextPage = function() {
            // to do
            var alertPopup = $ionicPopup.alert({
                title: '',
                cssClass: 'iradpopupheader',
                templateUrl: 'pages/generalInsurance/quotes/IRDAIVerificationPopup.html'
            });

            alertPopup.then(function(res) {
                switch (quoteIRDAIOtpVm.productType) {
                    case '13':
                        $state.go("menu.paymentAccountDetails", { page: "Health" });
                        break;
                    case '11':
                        $state.go("menu.paymentAccountDetails", { page: "Health" });
                        break;
                    case '12':
                        $state.go("menu.paymentAccountDetails", { page: "Health" });
                        break;
                    case '14':
                        // getAccDetails();
                        $state.go("menu.healthApplicationPersonalDetails", { page: "simple health" });
                        break;
                    case '31':
                        $state.go("menu.paymentAccountDetailsMotor");
                        break;
                    case '32':
                        $state.go("menu.paymentAccountDetailsMotor");
                        break;
                    case '55':
                        $state.go("menu.paymentAccountDetailsTravel");
                        break;
                    case '22':
                        $state.go("menu.paymentAccountDetailsHome");
                        break;

                }
            });
        }

        quoteIRDAIOtpVm.goBacktoPrevious = function() {
            // to do

            switch (quoteIRDAIOtpVm.productType) {
                case '13':
                    $state.go("menu.quotesList");
                    break;
                case '11':
                    $state.go("menu.quotesList");
                    break;
                case '12':
                    $state.go("menu.quotesList");
                    break;
                case '14':
                    $state.go("menu.healthPremiumSummary");
                    break;
                case '31':
                    $state.go("menu.motorPremiumCalculation");
                    break;
                case '32':
                    $state.go("menu.motorPremiumCalculation");
                    break;
                case '55':
                    $state.go("menu.travelPremiumSummary");
                    break;
                case '22':
                    $state.go("menu.homeQuoteSummary");
                    break;

            }
        }
        quoteIRDAIOtpVm.selectedPolicy = function() {
                // to do
            }
            //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {


        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {

            initPage();
        });

        //actions to done everytime the view is hidden
        $scope.$on('$ionicView.afterLeave', function() {

            //any cleanup needs to be done here: executes everytime when page is left
        });
        return this;
    }
]);
// })();
