angularApp.controller('travelQuotePersonalInfoController', ["$timeout",
    "$state",
    "$scope", "generalInsurenceTravelService", "validateService","utilityService",

    function($timeout,
        $state,
        $scope, generalInsurenceTravelService, validateService,utilityService) {

        //functions, variables that can be accessed from the HTML come here
        var travelQuotePersonalInfoVm = this;
        //private methods section start
        function initPage() {
            travelQuotePersonalInfoVm.showBack = true;
            travelQuotePersonalInfoVm.showNext = true;



            /*  handle back button function */
            $timeout(function() {
                if (generalInsurenceTravelService.getTravellerPersonalDetails()) {
                    travelQuotePersonalInfoVm.name = generalInsurenceTravelService.getTravellerPersonalDetails().name;
                    travelQuotePersonalInfoVm.email = generalInsurenceTravelService.getTravellerPersonalDetails().emailID;
                    travelQuotePersonalInfoVm.mobile = generalInsurenceTravelService.getTravellerPersonalDetails().mobileNo;
                    $scope.$apply();
                }
            }, 10);
        }

        //private methods section end

        //validation function starts
        travelQuotePersonalInfoVm.travelPersonalInfo = {};

        //onkeyup validate fields if required
        travelQuotePersonalInfoVm.validateService = validateService;

        /* field validation  */
        function validateForm() {
            travelQuotePersonalInfoVm.travelPersonalInfo = {};

            if (travelQuotePersonalInfoVm.validateService.isValidName(travelQuotePersonalInfoVm.name)) {
                travelQuotePersonalInfoVm.travelPersonalInfo.name = travelQuotePersonalInfoVm.validateService.isValidName(travelQuotePersonalInfoVm.name);
            }
            if (travelQuotePersonalInfoVm.validateService.isValidEmail(travelQuotePersonalInfoVm.email)) {
                travelQuotePersonalInfoVm.travelPersonalInfo.email = travelQuotePersonalInfoVm.validateService.isValidEmail(travelQuotePersonalInfoVm.email);
            }
            if (travelQuotePersonalInfoVm.validateService.isValidPhoneNo(travelQuotePersonalInfoVm.mobile)) {
                travelQuotePersonalInfoVm.travelPersonalInfo.mobile = travelQuotePersonalInfoVm.validateService.isValidPhoneNo(travelQuotePersonalInfoVm.mobile);
            }
            return (angular.equals({}, travelQuotePersonalInfoVm.travelPersonalInfo)) ? true : false;
        }



        travelQuotePersonalInfoVm.goToPreviousPage = function() {
            // to do
        }

        /* show Terms and condition Popus */
        travelQuotePersonalInfoVm.showTermsAndConditions = function() {
            // to do
            if (validateForm()) {
                var TravellerPersonalDetails = {
                    name: travelQuotePersonalInfoVm.name,
                    emailID: travelQuotePersonalInfoVm.email,
                    mobileNo: travelQuotePersonalInfoVm.mobile,
                }
                generalInsurenceTravelService.setTravellerPersonalDetails(TravellerPersonalDetails);

                var postDetail = {
                    "productDetails": {
                        "prodyctType": generalInsurenceTravelService.getTravellerPolicyDetails().policyType.value,
                        "policyOption": generalInsurenceTravelService.getTravellerPolicyDetails().policyOption.value,
                        "travelToUSCanada": generalInsurenceTravelService.getTravellerPolicyDetails().travellingToUSCanada,
                        "travelStartDate": generalInsurenceTravelService.getTravellerPolicyDetails().startDate,
                        "travelEndDate": generalInsurenceTravelService.getTravellerPolicyDetails().endDate,
                        "purposeOfTravel": generalInsurenceTravelService.getTravellerPolicyDetails().travelPurpose.value,
                    },
                    "travellerDetails": {
                        "dob": generalInsurenceTravelService.getTravellerDetail().birthDate1,
                        "sumInsured": generalInsurenceTravelService.getTravellerDetail().sumInsured.value,
                        "proposerRelation": generalInsurenceTravelService.getTravellerDetail().relationshipWithProposer.value,
                    },
                    "personalDetails": {
                        "name": travelQuotePersonalInfoVm.name,
                        "emailId": travelQuotePersonalInfoVm.email,
                        "mobileNumber": travelQuotePersonalInfoVm.mobile,
                    }
                }

                generalInsurenceTravelService.postTravelPremium(postDetail).then(function(data) {
                    generalInsurenceTravelService.setTravellerPremiumResponse(data);
                    $state.go("menu.travelPremiumSummary");
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });

            }

        }


        travelQuotePersonalInfoVm.goBacktoPrevious = function() {
            $state.go("menu.travelQuoteTravellerInfo");
        }


        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {


        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        //actions to done everytime the view is hidden
        $scope.$on('$ionicView.afterLeave', function() {

            //any cleanup needs to be done here: executes everytime when page is left
        });
        return this;
    }
]);
// })();
