/**
 *   @ngdoc config
 *   @name angularApp.config : governmentSchemeConfig
 *   @description
 *  configuration file for governmentScheme module
 */

/*This function defines all the constants named  Adapters url for governmentScheme module*/

    angularApp.value(
            'governmentSchemeConfig', {
                "links": {
                    "governmentSchemeTagurl": "https://www.sbi.co.in/web/agri-rural/rural/financial-inclusion",
                    "governmentSchemeOnlineSbiurl": "https://www.onlinesbi.com/",
                    "governmentSchemeSSYurl": "https://www.sbi.co.in/web/personal-banking/investments-deposits/govt-schemes/sukanya-samriddhi-yojana"
                }
            })
    /*State defination with respective names, urls, controllers and templates */
    .config([
        '$stateProvider',
        function ($stateProvider) { 
                //governmentScheme journey starts here
            $stateProvider
			.state('menu.governmentSchemesLanding', {
                url: '/governmentSchemesLanding',
                cache: false,
                data: {
                    pageId: 'GOV_SCH_LANDING'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/governmentSchemes/governmentSchemesLandingWCM.html',
                        controller: 'governmentSchemesLandingWCMController',
                        controllerAs: 'governmentSchemesLandingWCMVm'
                    }
                }
            })
         .state('menu.governmentSchemeDetails', {
      				url: '/governmentSchemeDetails',
      				data: {
      					pageId: 'GOV_SCH_DETAILS'
      				},
      				cache: false,
      				views: {
      					'menuContent': {
      						templateUrl: 'pages/governmentSchemes/governmentSchemeDetails.html',
      						controller: 'governmentSchemeDetailsController',
      						controllerAs: 'governmentSchemeDetailsVm'
      					}
      				},
      				params: { schemeDetails: null }
        })


         
         	//governmentScheme journey ends here


        }
    ]);
