'use strict';

angularApp.controller('userTourController', ["$state",
    "$scope",
    "customerInfoService",
    "getAccountDetailsService",
    "utilityService",
    "$filter",
	"$ionicSlideBoxDelegate",
	"requestYCService",
	"fTBeneficiaryService",
	"loggedInUserService",
	function ($state,
		$scope,
		customerInfoService,
		getAccountDetailsService,
		utilityService,
		$filter,
		$ionicSlideBoxDelegate,
        requestYCService,
        fTBeneficiaryService,
        loggedInUserService) {

        var userTourVm = this;
        userTourVm.muted = true;
        userTourVm.muteButtonTouched = false;
        userTourVm.lockSlide = function(){
            $ionicSlideBoxDelegate.enableSlide( false );
        }
		userTourVm.nextTourSlide = function(audioUrl) {
            if(userTourVm.muteButtonTouched && userTourVm.muted) userTourVm.muted = true;
            else userTourVm.muted = false;
            $ionicSlideBoxDelegate.next();
            playAudio(audioUrl);
        };
		function playAudio(audioUrl){
		    if(userTourVm.audio) { stopAudio();}

            userTourVm.audio = new Audio(userTourVm.audioClips[audioUrl]);
            userTourVm.audio.play();
            if(userTourVm.muted)
                userTourVm.audio.muted = true;
        }
        function stopAudio(){
            /*userTourVm.audio.pause();
            userTourVm.audio.currentTime = 0;*/
            userTourVm.audio.src = "";
        }
        userTourVm.muteAudio = function(){
		    userTourVm.muteButtonTouched = true;
            userTourVm.muted = !userTourVm.muted;
            userTourVm.audio.muted = userTourVm.muted;
        };
        /*function manageAudioPause() {
            if(userTourVm.audio) userTourVm.audio.pause();
        }
        function manageAudioResume() {
            if(userTourVm.audio) userTourVm.audio.play();
        }*/
        /*userTourVm.previous = function() {
            $ionicSlideBoxDelegate.previous();
        };*/
        userTourVm.finishTour = function() {
            stopAudio();
            $state.go("menu.homeScreen");
        };
		$scope.$on('$ionicView.afterEnter', function() {
			initPage();
		});
        function initPage() {
            document.addEventListener("pause", function() {
                if(userTourVm.audio && userTourVm.audio.src.includes('userTour')) userTourVm.audio.pause();
            });
            document.addEventListener("resume", function() {
                if(userTourVm.audio && userTourVm.audio.src.includes('userTour') && !userTourVm.audio.ended) userTourVm.audio.play();
            });
            loggedInUserService.manageLocalData('"isFirstLogin":true',"YONOLocalStorageData.json",true,'write').then(function(res){
                loggedInUserService.isFirstLogin = true;
            },function(e){});
            userTourVm.audioClips = {
                "yono_pay": "audio/userTour/YONOPay.mp3",
                "yono_cash": "audio/userTour/YONOCash.mp3",
                "search": "audio/userTour/Search.mp3",
                "investments": "audio/userTour/Investments.mp3",
                "loans": "audio/userTour/Loans.mp3",
                "shop_order": "audio/userTour/ShopOrder.mp3",
                "offers": "audio/userTour/Offers.mp3",
                "yono_agri": "audio/userTour/YONOKrishi.mp3",
                "service_request": "audio/userTour/ServiceRequest.mp3",
                "yono_wearables": "audio/userTour/YONOWearable.mp3",
                "sbi_rewards": "audio/userTour/SBIRewards.mp3",
            }
            playAudio('yono_pay');
        }
		return this;
	}
]);
