angularApp.service('rdClosureService',
	function ($q, utilityService, AdapterUtils) {
		var RDservice = this;
		RDservice.sendRDClosure = function (acc_number) {
			var q = $q.defer();
			var obj = {
				"accountNumber": acc_number
			};
			AdapterUtils.postData("adapters/RecurringDepositAdapter/closureOfRD", obj, true).then(
				function (response) {
					q.resolve(response.data);
				}, function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		RDservice.fetchFDAccountDetails = function (data) {
			var q = $q.defer();
			var obj = {
				"fdAccountNumber": data.account,
				"lien": data.lien,
				"operational": data.operational,
				"branchCode": data.branchCode
			};
			AdapterUtils.postData("adapters/RecurringDepositAdapter/fetchFDAccountDetails", obj, false).then(
				function (response) {
					q.resolve(response.data);
				}, function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		RDservice.transactionDetails = function (acc_number) {
			var q = $q.defer();
			var obj = {
				"accountNumber": acc_number
			};
			AdapterUtils.postData("adapters/RecurringDepositAdapter/transactionDetails", obj, false).then(
				function (response) {
					q.resolve(response.data);
				}, function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		RDservice.RDprematureClosure = function (acc_number) {
			var q = $q.defer();
			var obj = {
				"accountNumber": acc_number
			};
			AdapterUtils.postData("adapters/RecurringDepositAdapter/preClosure", obj, true).then(
				function (response) {
					q.resolve(response.data);
				}, function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		RDservice.getRelationship = function () {
			var q = $q.defer();
			var obj = {
				"id": "MasterDataTry1",
				"fields": ["Relationship"]
			};
			AdapterUtils.postData("adapters/FixedDepositAdapter/getRelationship", obj, true).then(
				function (response) {
					q.resolve(response.data);
				}, function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		RDservice.fetchFdReceipt = function (data) {
			var q = $q.defer();
			var obj = {
				"amount": data.amount,
				"name": data.name,
				"email": data.email,
				"fdAccountNumber": data.fdAccountNumber,
				"taxSaverFlag": data.taxSaverFlag,
				"tenureDuration": data.tenureDuration,
				"maturityDate": data.maturityDate,
				"maturityAmount": data.maturityAmount,
				"maturityInstruction": data.maturityInstruction,
				"interestRate": data.interestRate,
				"interestPayout": data.interestPayout,
				"startDate": data.startDate,
				"endDate": data.endDate,
				"branchCode": data.branchCode,
				"branchName": data.branchName,
				"debitAccountNumber": data.debitAccountNumber,
				"isDownload": data.isDownload,
				"modeOfOperation": data.modeOfOperation,
				"scheme": data.scheme,
				"mobile": data.mobile,
				"dob": data.dob,
				"cif": data.cif,
				"nominee": data.nominee
			};
			AdapterUtils.postData("adapters/RecurringDepositAdapter/fetchFdReceipt", obj, false).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		return RDservice;
	});  