'use strict';
angularApp.controller('instaClosureDetailsController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"instaHomeService",
		"customerInfoService","$filter",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, instaHomeService, customerInfoService,$filter) {
			
			var instaClosureDetailsVm = this;
			
			function initPage() {
				instaClosureDetailsVm.disablesubmit = true;

				instaClosureDetailsVm.availod = true;
				instaClosureDetailsVm.closeDetails = [];
				instaClosureDetailsVm.nightMode = false;
				instaClosureDetailsVm.showDateDiv = true;
				instaClosureDetailsVm.indexId = 0;

				instaClosureDetailsVm.isMaskAccount = true;
				instaClosureDetailsVm.isMaskDebitPan = true;

				instaClosureDetailsVm.closureAmountVal = parseInt(instaHomeService.viewInstaData.totalClosureAmount) + "";
				instaClosureDetailsVm.interestAccruedVal = parseInt(instaHomeService.viewInstaData.interestAccrued) + "";
				instaClosureDetailsVm.totalClosureAmount = parseInt(instaHomeService.viewInstaData.totalOutstandingAmount) + "";
				instaClosureDetailsVm.debitAccount = $filter('cardmask')(instaHomeService.viewInstaData.displayAccountNumberFormat, 'X', 4);
				instaClosureDetailsVm.accountNo = instaHomeService.viewInstaData.accountNumber;
				
			};

			instaClosureDetailsVm.goToAO = function () {
				$state.go('menu.accountOverviewMyBalance');
			}

			instaClosureDetailsVm.backFunc = function () {
				$state.go('menu.instaClosureEnquiry');
			}

			instaClosureDetailsVm.unmaskData = function(idType) {
	            var request = {
	                "type": idType,
	                "keyType": "instaViewAccountNumber",
	                "loanType": "IHL"
	            }
	            if (idType == 'accountno') {
	                instaHomeService.getUnmaskData(request).then(function(data) {
	                    if (idType == 'accountno') {
	                        instaClosureDetailsVm.isMaskAccount = false;
	                        instaClosureDetailsVm.accountNo = data;
	                    }
	                }, function(error) {
	                    utilityService.showErrorMessage(error.responseMessage);
	                });
	            }else {
	                if (idType == 'naccountno') {
	                    instaClosureDetailsVm.isMaskAccount = true;
	                    instaClosureDetailsVm.accountNo = instaHomeService.viewInstaData.accountNumber;
	                }
	            }
	        }

	        instaClosureDetailsVm.termconditionPopUp = function (TnCDetails) {
				var title = "Terms & Conditions";
                var buttontext = "OK";
                var detail = TnCDetails;
                instaHomeService.showTnCAlertModal(title, detail, buttontext,function(){});
			}

	        instaClosureDetailsVm.termcondition = function () {
				if(instaHomeService.normalClosureTnC == "") {
					var obj = {
						"type" : "instaClosureTnC"
					}
					instaHomeService.fetchRtermcondition(obj).then(function (data) {
						
						if (!utilityService.isUndefined(data)) {
							instaHomeService.normalClosureTnC = data;
							instaClosureDetailsVm.termconditionPopUp(instaHomeService.normalClosureTnC);
						}
					}, function (error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				} else {
					instaClosureDetailsVm.termconditionPopUp(instaHomeService.normalClosureTnC);
				}
			}

	        instaClosureDetailsVm.unmaskDebitData = function(idType) {
	            var request = {
	                "type": idType,
	                "keyType": "instaViewDebitCreditAccount",
	                "loanType": "IHL",
	                "toAccount": instaClosureDetailsVm.debitAccount
	            }
	            if (idType == 'accountno') {
	                instaHomeService.getUnmaskData(request).then(function(data) {
	                    if (idType == 'accountno') {
	                        instaClosureDetailsVm.isMaskDebitPan = false;
	                        instaClosureDetailsVm.debitAccount = data;
	                    }
	                }, function(error) {
	                    utilityService.showErrorMessage(error.responseMessage);
	                });
					// instaClosureDetailsVm.isMaskDebitPan = false;
					// instaClosureDetailsVm.debitAccount = instaHomeService.viewInstaData.displayAccountNumberFormat;
	            } else {
	                if (idType == 'naccountno') {
	                    instaClosureDetailsVm.isMaskDebitPan = true;
	                    instaClosureDetailsVm.debitAccount = instaHomeService.viewInstaData.displayAccountNumberFormat;
	                }
					// instaClosureDetailsVm.isMaskDebitPan = true;
					// instaClosureDetailsVm.debitAccount = $filter('cardmask')(instaHomeService.viewInstaData.displayAccountNumberFormat, 'X', 4);
	            }
	        }

	        instaClosureDetailsVm.unmaskDebitDataUI = function(idType) {
	           
	            if (idType == 'accountno') {
	                instaClosureDetailsVm.isMaskDebitPan = false;
					instaClosureDetailsVm.debitAccount = instaHomeService.viewInstaData.displayAccountNumberFormat;
	            } else {
	                if (idType == 'naccountno') {
	                    instaClosureDetailsVm.isMaskDebitPan = true;
						instaClosureDetailsVm.debitAccount = $filter('cardmask')(instaHomeService.viewInstaData.displayAccountNumberFormat, 'X', 4);
	                }
					
	            }
	        }

			instaClosureDetailsVm.Confirm = function () {
				instaHomeService.customer.otpClick == "instaclosure";
				var obj = {
					 "id": customerInfoService.customer.mobile,
					 "emailId": customerInfoService.customer.emailID
				}
				instaHomeService.requestOtp(obj).then(function (data) {
					$state.go('menu.instaOtp');   
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			instaClosureDetailsVm.getCBValue = function (isChecked) {
				if (isChecked === true) {
					instaClosureDetailsVm.disablesubmit = false;
				} else {
					instaClosureDetailsVm.disablesubmit = true;
				}
			}

			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				instaClosureDetailsVm.status = instaHomeService.viewInstaData.status;
			});

			return this;
		}
]);


