'use strict';
angularApp.controller('instaClosureEnquiryController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"instaHomeService",
		"getAccountDetailsService",
		"customerInfoService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, instaHomeService, getAccountDetailsService,customerInfoService) {
			
			var instaClosureEnquiryVm = this;
			
			function initPage() {
				instaClosureEnquiryVm.disablesubmit = true;
				instaClosureEnquiryVm.availod = true;
				instaClosureEnquiryVm.closeDetails = [];
				instaClosureEnquiryVm.nightMode = false;
				instaClosureEnquiryVm.showDateDiv = true;
				instaClosureEnquiryVm.indexId = 0;

				instaClosureEnquiryVm.isMaskPan = true;

				
			};

			instaClosureEnquiryVm.goToAO = function () {
				$state.go('menu.accountOverviewMyBalance');
			}

			instaClosureEnquiryVm.backFunc = function () {
				instaHomeService.accountDetailsCloser = [];
				$state.go('menu.instaClosure');
			}

			instaClosureEnquiryVm.nextFunc = function () {
				if(instaClosureEnquiryVm.status == "N"){
					var account_bal = JSON.parse(instaClosureEnquiryVm.creditToAccount);
					
					if(parseInt(instaClosureEnquiryVm.totalClosureVal) > parseInt(account_bal.accountBalance))
					{
						var template =  '<div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter" translate="INSUFFICIENTBALANCE"></div></div>';
						$ionicPopup.show({
							title: '',
							template: template,
							scope: $scope,
							cssClass: 'my-custom-popup',
							buttons: [{
								text: 'OK',
								type: 'button-assertive',
								onTap: function () {
									//$state.go('menu.instaCreate');
								}
							}],
						});
					}
					else{
						$state.go('menu.instaClosureDetails');
					}
				}
				else{
					$state.go('menu.instaClosureDetails');
				}
				
			}

			instaClosureEnquiryVm.getCBValue = function (isChecked) {
				if (isChecked === true) {
					instaClosureEnquiryVm.disablesubmit = false;
				} else {
					instaClosureEnquiryVm.disablesubmit = true;
				}
			}

			instaClosureEnquiryVm.interestAcc = function () {
				var template =  '<div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter">Accrued interest till date.</div></div>';
				$ionicPopup.show({
					title: '',
					template: template,
					scope: $scope,
					cssClass: 'my-custom-popup',
					buttons: [{
						text: 'OK',
						type: 'button-assertive',
						onTap: function () {
							//$state.go('menu.instaCreate');
						}
					}],
				});
			}

			instaClosureEnquiryVm.unmaskData = function(idType) {
	            var request = {
	                "type": idType,
	                "keyType": "instaViewAccountNumber",
	                "loanType": "IHL"
	            }
	            if (idType == 'accountno') {
	                instaHomeService.getUnmaskData(request).then(function(data) {
	                    if (idType == 'accountno') {
	                        instaClosureEnquiryVm.isMaskPan = false;
	                        instaClosureEnquiryVm.accountNo = data;
	                    }
	                }, function(error) {
	                    utilityService.showErrorMessage(error.responseMessage);
	                });
	            } else {
	                if (idType == 'naccountno') {
	                    instaClosureEnquiryVm.isMaskPan = true;
	                    instaClosureEnquiryVm.accountNo = instaHomeService.viewInstaData.accountNumber;
	                }
	            }
	        }

			instaClosureEnquiryVm.selectedAccountFun = function () {

				if (instaClosureEnquiryVm.creditToAccount) {
					instaHomeService.viewInstaData.accountSelectedDetails = instaClosureEnquiryVm.creditToAccount;
					var data = JSON.parse(instaClosureEnquiryVm.creditToAccount);
					// 	var e = [];
					// 	e.accountNumber = data[0];
					// 	e.accountType = data[1];
					// 	e.indexId = data[2];
					// 	e.accountBalance = data[3];
					// 	instaClosureEnquiryVm.indexId = e.indexId;

					// 	instaClosureEnquiryVm.selectedAccountType = e.accountType;

					// 	instaClosureEnquiryVm.selectedAccountNumber = e.accountNumber;

					// 	instaClosureEnquiryVm.selectedAccountAmount = e.accountBalance;
					// 	instaHomeService.customer.selectedItem = e.accountNumber;

					instaHomeService.viewInstaData.payingFromAccount = data.accountNumber;
					instaHomeService.viewInstaData.displayAccountFormat = data.accountType + " " + data.accountNumber;
					instaHomeService.viewInstaData.displayAccountNumberFormat = data.accountNumber;
					instaHomeService.viewInstaData.accountBalance = data.accountBalance;

					instaClosureEnquiryVm.disablesubmit = false;
				} else {
					instaClosureEnquiryVm.disablesubmit = true;
				}
			};

			instaClosureEnquiryVm.accountDetails = function() {	

				
				if (!instaHomeService.accountDetailsCloser.length) {
					if(instaClosureEnquiryVm.status == 'P'){
						if (!getAccountDetailsService.accountOverviewData) {
						instaHomeService.getAccountDetails().then(function(data) {
						getAccountDetailsService.accountOverviewData = data;
						instaHomeService.accountDetailsCloser = data.accounts;
						
						var customer_info = getAccountDetailsService.accountOverviewData.customerInformation;
						var primary_account_number = customer_info.accountNumber;
						instaHomeService.accountDetailsCloser.sort(function(a, b){
    						return b.accountBalance - a.accountBalance;
						});
						var isAccountExists = -1;
						if(primary_account_number != ''){
							instaHomeService.accountDetailsCloser.some(function(obj, i) {
  								return obj.accountNumber == primary_account_number ? isAccountExists = i : false;
							});

						}
	                    instaClosureEnquiryVm.accountDetails = instaHomeService.accountDetailsCloser;
	                    if(isAccountExists !== -1) {
  							instaClosureEnquiryVm.creditToAccount = angular.toJson(instaClosureEnquiryVm.accountDetails[isAccountExists]);
  							instaClosureEnquiryVm.disablesubmit = false;
							instaClosureEnquiryVm.selectedAccountFun();	
						}
						else{
							instaClosureEnquiryVm.getSelectedAccount();
						}
					},function(error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
					}
					else{
						instaHomeService.accountDetailsCloser = getAccountDetailsService.accountOverviewData.accounts;
						
						var customer_info = getAccountDetailsService.accountOverviewData.customerInformation;
						var primary_account_number = customer_info.accountNumber;
						instaHomeService.accountDetailsCloser.sort(function(a, b){
    						return b.accountBalance - a.accountBalance;
						});
						var isAccountExists = -1;
						if(primary_account_number != ''){
							instaHomeService.accountDetailsCloser.some(function(obj, i) {
  								return obj.accountNumber == primary_account_number ? isAccountExists = i : false;
							});

						}
	                    instaClosureEnquiryVm.accountDetails = instaHomeService.accountDetailsCloser;
	                    if(isAccountExists !== -1) {
  							instaClosureEnquiryVm.creditToAccount = angular.toJson(instaClosureEnquiryVm.accountDetails[isAccountExists]);
  							instaClosureEnquiryVm.disablesubmit = false;
							instaClosureEnquiryVm.selectedAccountFun();	
						}
						else{
							instaClosureEnquiryVm.getSelectedAccount();
						}
					}
					}
					else{
						instaHomeService.getAccountList().then(function(data) {
						
						instaHomeService.accountDetailsCloser = data.accList;
						
						var customer_info = getAccountDetailsService.accountOverviewData.customerInformation;
						var primary_account_number = customer_info.accountNumber;
						instaHomeService.accountDetailsCloser.sort(function(a, b){
    						return b.accountBalance - a.accountBalance;
						});
						var isAccountExists = -1;
						if(primary_account_number != ''){
							instaHomeService.accountDetailsCloser.some(function(obj, i) {
  								return obj.accountNumber == primary_account_number ? isAccountExists = i : false;
							});

						}
	                    instaClosureEnquiryVm.accountDetails = instaHomeService.accountDetailsCloser;
	                    if(isAccountExists !== -1) {
  							instaClosureEnquiryVm.creditToAccount = angular.toJson(instaClosureEnquiryVm.accountDetails[isAccountExists]);
  							instaClosureEnquiryVm.disablesubmit = false;
							instaClosureEnquiryVm.selectedAccountFun();	
						}
						else{
							instaClosureEnquiryVm.getSelectedAccount();
						}
					},function(error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
					}
					

					
				} else {
					instaHomeService.accountDetailsCloser.sort(function(a, b){
    					return b.accountBalance - a.accountBalance
					});
	                instaClosureEnquiryVm.accountDetails = instaHomeService.accountDetailsCloser; 
	                //instaClosureEnquiryVm.getSelectedAccount();
				}
			}
			instaClosureEnquiryVm.getSelectedAccount = function() {
				if(instaHomeService.accountDetailsCloser.length > 0){
					instaClosureEnquiryVm.creditToAccount = angular.toJson(instaClosureEnquiryVm.accountDetails[0]);
					instaClosureEnquiryVm.disablesubmit = false;
					instaClosureEnquiryVm.selectedAccountFun();
				}

			}
			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				instaClosureEnquiryVm.status = instaHomeService.viewInstaData.status;
				instaClosureEnquiryVm.accountDetails();

				if (instaHomeService.viewInstaData.accountSelectedDetails) {
					instaClosureEnquiryVm.creditToAccount = instaHomeService.viewInstaData.accountSelectedDetails;
					instaClosureEnquiryVm.disablesubmit = false;
				} else {
					instaClosureEnquiryVm.disablesubmit = true;
				}

				

				instaClosureEnquiryVm.closureAmountVal = parseInt(instaHomeService.viewInstaData.totalClosureAmount) + "";
				instaClosureEnquiryVm.interestAccruedVal = parseInt(instaHomeService.viewInstaData.interestAccrued) + "";
				instaClosureEnquiryVm.totalClosureVal = parseInt(instaHomeService.viewInstaData.totalOutstandingAmount) + "";
				instaClosureEnquiryVm.accountNo = instaHomeService.viewInstaData.accountNumber;

			});

			return this;
		}
]);


