/**
 *   @ngdoc config
 *   @name angularApp.config : cardConfig
 *   @description
 *  configuration file for cards module
 */

/*This function defines all the constants named  Adapters url for cards module*/
angularApp
   

/*State defination with respective names, urls, controllers and templates */

.config([
    '$stateProvider',
    function($stateProvider) {

        //Cards start
        $stateProvider
            .state('menu.instaClosure', {
                url: '/instaClosure',
                data: {
                    pageId: 'INSTA_CLOSURE'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/insta/instaClosure/instaClosure.html',
                        controller: 'instaClosureController',
                        controllerAs: 'instaClosureVm'
                    }
                }
            })
            .state('menu.instaClosureEnquiry', {
                url: '/instaClosureEnquiry',
                data: {
                    pageId: 'INSTA_CLOSURE_ENQUIRY'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/insta/instaClosureEnquiry/instaClosureEnquiry.html',
                        controller: 'instaClosureEnquiryController',
                        controllerAs: 'instaClosureEnquiryVm'
                    }
                }
            })
            .state('menu.instaClosureDetails', {
                url: '/instaClosureDetails',
                data: {
                    pageId: 'INSTA_CLOSURE_DETAILS'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/insta/instaClosureDetails/instaClosureDetails.html',
                        controller: 'instaClosureDetailsController',
                        controllerAs: 'instaClosureDetailsVm'
                    }
                }
            })
            .state('menu.instaCreate', {
                url: '/instaCreate',
                data: {
                    pageId: 'INSTA_CREATE'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/insta/instaCreate/instaCreate.html',
                        controller: 'instaCreateController',
                        controllerAs: 'instaCreateVm'
                    }
                }
            })
            .state('menu.instaDeposit', {
                url: '/instaDeposit',
                data: {
                    pageId: 'INSTA_DEPOSIT'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/insta/instaDeposit/instaDeposit.html',
                        controller: 'instaDepositController',
                        controllerAs: 'instaDepositVm'
                    }
                }
            })
            .state('menu.instaReview', {
                url: '/instaReview',
                data: {
                    pageId: 'INSTA_REVIEW'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/insta/instaReview/instaReview.html',
                        controller: 'instaReviewController',
                        controllerAs: 'instaReviewVm'
                    }
                }
            })
            .state('menu.instaOtp', {
                url: '/instaOtp',
                data: {
                    pageId: 'INSTA_OTP'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/insta/instaOtp/instaOtp.html',
                        controller: 'instaOtpController',
                        controllerAs: 'instaOtpVm'
                    }
                }
            })

    }
]);
