'use strict';
angularApp.controller('instaCreateController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"instaHomeService",
		"customerInfoService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, instaHomeService, customerInfoService) {
			
			var instaCreateVm = this;
			
			function initPage() {
				instaCreateVm.disableconfirm = true;
				instaCreateVm.availod = true;
				instaCreateVm.closeDetails = [];
				instaCreateVm.nightMode = false;
				instaCreateVm.showDateDiv = true;
				instaCreateVm.indexId = 0;

				var bestOfferAmount = parseInt(instaHomeService.customer.bestofferamount);
				instaCreateVm.minLoanAmount = parseInt(instaHomeService.customer.minLoanAmount);
				instaCreateVm.steppingAmount = parseInt(instaHomeService.customer.steppingAmount);

				if (!instaCreateVm.emiAmountVal) {
					var exponent = instaHomeService.customer.loanduration;
						var rateOfInterest = instaHomeService.customer.interestrate;
						var r = ((rateOfInterest/100.0)/12.0);
						var exponentValue = Math.pow(1+r, exponent);
						instaCreateVm.emiAmountVal = Math.round((instaHomeService.customer.selectedamount *(r*exponentValue)/(exponentValue-1)).toFixed(2));
						instaHomeService.customer.emiamount = instaCreateVm.emiAmountVal;
					}
					instaHomeService.customer.selectedamount = instaHomeService.customer.selectedamount;
					instaCreateVm.selectAmount = instaHomeService.customer.selectedamount;
                	instaCreateVm.amountData = instaHomeService.customer.selectedamount;

				if (bestOfferAmount > instaCreateVm.minLoanAmount) {
					instaCreateVm.lookFor = {
		                value: instaHomeService.customer.selectedamount,
		                options: {
		                    ceil: instaHomeService.customer.bestofferamount,
		                    floor: instaCreateVm.minLoanAmount,
		                    showSelectionBar: true,
		                    step: instaCreateVm.steppingAmount,
		                    onChange: instaCreateVm.onChangeRangeAmount,
		                    translate: function(value) {
		                    	if (!instaCreateVm.emiAmountVal) {
		                    		var exponent = instaCreateVm.durationVal;
									var rateOfInterest = instaCreateVm.interestRateVal;
									var r = ((rateOfInterest/100.0)/12.0);
									var exponentValue = Math.pow(1+r, exponent);

									instaCreateVm.emiAmountVal = Math.round((instaHomeService.customer.selectedamount *(r*exponentValue)/(exponentValue-1)).toFixed(2));
									instaHomeService.customer.emiamount = instaCreateVm.emiAmountVal;
		                    	}
								instaHomeService.customer.selectedamount = value;
								instaCreateVm.selectAmount = instaHomeService.customer.selectedamount;
		                    	instaCreateVm.amountData = instaHomeService.customer.selectedamount;
		                        
			                    return '&#8377;' + value;
							}
		                }
		            };
		        } else {
		        	if (!instaCreateVm.emiAmountVal) {
                		var exponent = instaHomeService.customer.loanduration;
						var rateOfInterest = instaHomeService.customer.interestrate;
						var r = ((rateOfInterest/100.0)/12.0);
						var exponentValue = Math.pow(1+r, exponent);
						instaCreateVm.emiAmountVal = Math.round((instaHomeService.customer.selectedamount *(r*exponentValue)/(exponentValue-1)).toFixed(2));
						instaHomeService.customer.emiamount = instaCreateVm.emiAmountVal;
                	}
					instaHomeService.customer.selectedamount = instaHomeService.customer.selectedamount;
					instaCreateVm.selectAmount = instaHomeService.customer.selectedamount;
                	instaCreateVm.amountData = instaHomeService.customer.selectedamount;
		        }
			};

			instaCreateVm.next = function () {
				$state.go('menu.instaDeposit');
			}

			instaCreateVm.goToAO = function () {
				$state.go('menu.accountOverviewMyBalance');
			}
			instaCreateVm.goToHome = function () {
				$state.go('menu.homeScreen');
			}

			instaCreateVm.loanLimitFunc = function () {
				var template =  '<div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter">For Residual Maturity of underlying Home Loan (Above 60 months but upto 120 months) : Tenure of Insta Home Topup Loan is 60 months.<br>For Residual Maturity of underlying Home Loan (Above 120 months) : Tenure of Insta Home Topup Loan is 120 months.</div></div>';
				$ionicPopup.show({
					title: '',
					template: template,
					scope: $scope,
					cssClass: 'my-custom-popup',
					buttons: [{
						text: 'OK',
						type: 'button-assertive',
						onTap: function () {
							$state.go('menu.instaCreate');
						}
					}],
				});
			}

			instaCreateVm.interestRateFunc = function () {
				var template = 'The present effective rate of interest is ' + instaCreateVm.interestRateVal + ' p. a calculated on daily balance of the loan amount at monthly rests, subject to the interest rate reset on the 1st day of every calendar quarter, on the basis of the prevailing RBI Repo Rate.';
				$ionicPopup.show({
					title: '',
					template: template,
					scope: $scope,
					cssClass: 'my-custom-popup',
					buttons: [{
						text: 'OK',
						type: 'button-assertive',
						onTap: function () {
							$state.go('menu.instaCreate');
						}
					}],
				});
			}

			instaCreateVm.topUpLoanFunc = function () {
				var template =  '<div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter">Insta Home Top-up Loan is available to our pre-selected Home Loan customers over YONO platform. Under this scheme processing of the loan request, disbursement of loan and setting of S.I in the Saving Account for repayment of EMIs will be done by the system with no manual intervantion.</div></div>';
				$ionicPopup.show({
					title: '',
					template: template,
					scope: $scope,
					cssClass: 'my-custom-popup',
					buttons: [{
						text: 'OK',
						type: 'button-assertive',
						onTap: function () {
							$state.go('menu.instaCreate');
						}
					}],
				});
			}

			instaCreateVm.amountSelectFunc = function () {
				var template =  '5% of the Home Loan Limit, subject to Minimum of Rs.'+ instaCreateVm.minLoanAmount +'/- and Maximum of Rs.'+ instaHomeService.customer.bestofferamount +'/-';
				$ionicPopup.show({
					title: '',
					template: template,
					scope: $scope,
					cssClass: 'my-custom-popup',
					buttons: [{
						text: 'OK',
						type: 'button-assertive',
						onTap: function () {
							$state.go('menu.instaCreate');
						}
					}],
				});
			}

			instaCreateVm.getCBValue = function (isChecked) {
				if (instaCreateVm.isStaff) {
					if (isChecked === true) {
						instaCreateVm.disableconfirm = false;
					} else {
						instaCreateVm.disableconfirm = true;
					}
				}
			}

			instaCreateVm.onChangeRangeAmount = function () {
				var exponent = instaCreateVm.durationVal;
				var rateOfInterest = instaCreateVm.interestRateVal;
				var r = ((rateOfInterest/100.0)/12.0);
				var exponentValue = Math.pow(1+r, exponent);

				instaCreateVm.emiAmountVal =  Math.round((instaHomeService.customer.selectedamount *(r*exponentValue)/(exponentValue-1)).toFixed(2));
				instaHomeService.customer.emiamount = instaCreateVm.emiAmountVal;
			}

			instaCreateVm.validation = function () {				
				if (instaCreateVm.isStaff ==  false) {
					instaCreateVm.disableconfirm = false;
				}
			}

			instaCreateVm.getPreFilledData = function () {				
				if (customerInfoService.customer.isStaffFlag == "Y") {
					instaCreateVm.isStaff = true;
				} else {
					instaCreateVm.isStaff = false;
				}

                instaCreateVm.durationVal = instaHomeService.customer.loanduration;
				instaCreateVm.emiAmountVal = Math.round(instaHomeService.customer.emiamount) + "";
				instaCreateVm.interestRateVal = instaHomeService.customer.interestrate;

				instaCreateVm.minAmount = parseInt(instaHomeService.customer.minLoanAmount);
				instaCreateVm.maxAmount = instaHomeService.customer.bestofferamount;
				instaCreateVm.bestofferamount = parseInt(instaHomeService.customer.bestofferamount) + "";
				
				instaCreateVm.selectAmount = instaHomeService.customer.selectedamount;
				instaCreateVm.amountData = parseInt(instaHomeService.customer.selectedamount);				
			}

			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				instaCreateVm.getPreFilledData();
				instaCreateVm.validation();
			});
			return this;
		}
]);