'use strict';
angularApp.controller('instaDepositController', [
	"$state",
	"$scope",
	"$ionicPopup",
	"$translate",
	"$ionicHistory",
	"utilityService",
	"ionicDatePicker",
	"$ionicSideMenuDelegate",
	"instaHomeService",
	function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, instaHomeService) {
		
		var instaDepositVm = this;
		var today = new Date();
		$scope.selectedDate = today.getDate();
		$scope.currentDate = today.getDate();
		var current_month = today.getMonth();
		var next_month = today.getMonth() + 1;
  		$scope.selectedYear = today.getFullYear();
		if(current_month == '11')
		{
			next_month = 0;
			$scope.selectedYear = today.getFullYear() + 1;
		}
		var month = new Array();
  month[0] = "January";
  month[1] = "February";
  month[2] = "March";
  month[3] = "April";
  month[4] = "May";
  month[5] = "June";
  month[6] = "July";
  month[7] = "August";
  month[8] = "September";
  month[9] = "October";
  month[10] = "November";
  month[11] = "December";

  
  $scope.selectedMonth = month[next_month];
		if($scope.selectedDate > 28){
			$scope.selectedDate = '';
		}
		function initPage() {
			instaDepositVm.availod = true;
			instaDepositVm.closeDetails = [];
			instaDepositVm.nightMode = false;
			instaDepositVm.showDateDiv = true;
			instaDepositVm.indexId = 0;
			instaDepositVm.disablenext = true;

			instaDepositVm.isMaskPan = true;
		};

		instaDepositVm.goToAO = function () {
			$state.go('menu.accountOverviewMyBalance');
		}
		instaDepositVm.goToHome = function () {
				$state.go('menu.homeScreen');
		}
		instaDepositVm.nextFunc = function () {
			$state.go('menu.instaReview');
		}

		instaDepositVm.backFunc = function () {
			instaHomeService.customer.emipaymentday = "";
			$state.go('menu.instaCreate');
		}

		$scope.getSelectedDate = function (date) {
			if(date>$scope.currentDate)
			{
				return;
			}
			else{
				instaDepositVm.scheduleDate = date;
				$scope.selectedDate = date;
			}
		}

		instaDepositVm.unmaskData = function(idType) {
            var request = {
                "type": idType,
                "keyType": "instaCreateAccountNumber",
                "loanType": "IHL"
            }
            if (idType == 'accountno') {
                instaHomeService.getUnmaskData(request).then(function(data) {
                    if (idType == 'accountno') {
                        instaDepositVm.isMaskPan = false;
                        instaDepositVm.accountNumber = data;
                    }
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else {
                if (idType == 'naccountno') {
                    instaDepositVm.isMaskPan = true;
                    instaDepositVm.accountNumber = instaHomeService.customer.creditToAccount;
                }
            }
        }
        Date.prototype.addDays = function(days){
       			this.setDate(this.getDate() + parseInt(days));
       			return this;
       		};

		instaDepositVm.openDatePopup = function () {
			
			

				var newDate = new Date();
				var to_date = new Date();
							
				
				var from_date = '';
				
				from_date = newDate.addDays(3);
				to_date = angular.copy(from_date);
				var selected_date = '';
				
				var disable_date = [];
				var dateFromAPI =  to_date.setMonth(to_date.getMonth()+1);
				dateFromAPI = to_date.addDays(-1);
				
				if (instaHomeService.customer.emipaymentday) {
					selected_date = new Date(instaDepositVm.scheduleDate);
				}
				else{
					selected_date = from_date;
				}
				instaDepositVm.dateObj = {
					callback: function (val) {
						    instaDepositVm.scheduleDate = val;
		                    var emi_date = new Date(val);
		                    instaHomeService.customer.fullemipaymentday = emi_date;
		                    var emi_day = emi_date.getDate();
		                    instaHomeService.customer.emipaymentday = emi_day;
		                    if (instaDepositVm.scheduleDate != "") {
								instaDepositVm.disablenext = false;
							} else {
								instaDepositVm.disablenext = true;
							}
						},
						inputDate: selected_date,
						monthsList:["JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC"],
						from: from_date,
						to: dateFromAPI,
						mondayFirst: true,
						closeOnSelect: false,
						templateType: 'popup',
						dateFormat: 'dd MMM yyyy'
						//disabledDates: disable_dates

				};

				ionicDatePicker.openDatePicker(instaDepositVm.dateObj);


		}

		instaDepositVm.getPreFilledData = function () {
			// var todayDate = new Date().getDate().toString();
			// if (todayDate == "29" || todayDate == "30" || todayDate == "31") {
			// 	instaDepositVm.scheduleDate = ""
			// 	$scope.selectedDate = "";
			// } else {
			// 	instaDepositVm.scheduleDate = new Date().getDate().toString();
			// 	$scope.selectedDate = instaDepositVm.scheduleDate;
			// }


            instaDepositVm.accountNumber = instaHomeService.customer.creditToAccount;
            if (instaHomeService.customer.emipaymentday) {
            	instaDepositVm.scheduleDate = instaHomeService.customer.fullemipaymentday; //changed due to datepicker applied
            	$scope.selectedDate = instaHomeService.customer.fullemipaymentday;
            } else {
				instaHomeService.customer.emipaymentday = instaDepositVm.scheduleDate;
            }
            
			if (instaDepositVm.scheduleDate) {
				instaDepositVm.disablenext = false;
			} else {
				instaDepositVm.disablenext = true;
			}
		}

		$scope.$on('$ionicView.loaded', function () {
			initPage();
		});

		$scope.$on('$ionicView.beforeEnter', function () {
			instaDepositVm.getPreFilledData();
		});

		return this;
	}
]);


