'use strict';
angularApp.controller('instaOtpController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"instaHomeService",
		"customerInfoService",
		"getAccountDetailsService",
		"$filter","$timeout",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, instaHomeService, customerInfoService, getAccountDetailsService, $filter, $timeout) {
			
			var instaOtpVm = this;
			// var count = 0;
			
			function initPage() {
				instaOtpVm.availod = true;
				instaOtpVm.closeDetails = [];
				instaOtpVm.nightMode = false;
				instaOtpVm.isNextEnabled = true;
				instaOtpVm.isDisabledOTP = false;
				instaOtpVm.showDateDiv = true;
				instaOtpVm.indexId = 0;
				instaOtpVm.clickCount = 0;
				instaOtpVm.otpCount = 0;
				instaOtpVm.mobileNumber = $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4);
			};

			instaOtpVm.goToAO = function () {
				if(instaOtpVm.isSubmitDisabled){
					//to call customer info again
					getAccountDetailsService.accountOverviewData = "";
				}
				if (instaHomeService.customer.otpClick == "instacreate") {
					$state.go('menu.homeScreen');
				}
				else{
					$state.go('menu.accountOverviewMyBalance');
				}
				
			}

			instaOtpVm.otpFinal = function () {
				instaOtpVm.isSubmitDisabled = true;
				if (instaOtpVm.otp.length < 6) {
					instaOtpVm.changeOtp();
				} else {
					if (instaHomeService.customer.otpClick == "instacreate") {
						var requestParams = {
							"otp": instaOtpVm.otp,
							"mobile": customerInfoService.customer.mobile
						}
						
						instaHomeService.validateOtp(requestParams).then(function (data) {
							
								var obj = {
									"disbursedAmount": instaHomeService.customer.selectedamount,
									"siStartDate": instaHomeService.customer.emipaymentday
								}
								
								instaHomeService.createInstaHomeLoan(obj).then(function (data) {
									
									var template;
									var referenceNumber = (data.referenceNumber == undefined || data.referenceNumber == null || data.referenceNumber == "") ? data.storeRefNumber : data.referenceNumber;
									if (data.inAppStatus == "1") {
										template =  '<div class="popupTextBottomPadding fontSize-subHeading"><div class ="congratsOD"><img src="img/Gift.svg" height="45" width="45" class="happyFaceOD"></div><div class="textAlignCenter">Thanks for applying Insta Home Top-up Loan <b>Reference Number</b> '+referenceNumber+'</div></br><div class="button_fund_closure RFDpopup roboto-regular font-dark-grey">We will process the application.<br>You will be notified on your registered mobile and email shortly.</div></div>';
									} else {
										template =  "<div class='popupTextBottomPadding fontSize-subHeading'><div class ='congratsOD'><img src='img/Gift.svg' height='45' width='45' class='happyFaceOD'></div><div class='textAlignCenter'>We have received the request for Insta Home Loan Topup on your home loan A/c "+instaHomeService.customer.accountno+". We have sent a request for consent to your secondary account holder.</div></br><div class='button_fund_closure RFDpopup roboto-regular font-dark-grey'>We will process the request as soon as we receive the consent. Please obtain co-applicant's consent within 24 hours. Loan will be disbursed only after co-applicant's consent.</div></div>";
									}
									//to call customer info again
									getAccountDetailsService.accountOverviewData = "";

									$ionicPopup.show({
										title: '',
										template: template,
										scope: $scope,
										cssClass: 'my-custom-popup',
										buttons: [{
											text: 'OK',
											type: 'button-assertive',
											onTap: function () {
												//getAccountDetailsService.accountOverviewData = "";
												utilityService.setCsatJournies('instaHomeLoanTopup');
												$state.go('menu.accountOverviewMyBalance');
											}
										}],
									});
								}, function (error) {
									instaOtpVm.isSubmitDisabled = false;
									utilityService.showErrorMessage(error.responseMessage);
								});
							
						}, function (error) {
							instaOtpVm.isSubmitDisabled = false;
							instaOtpVm.otpCount++;
							if(instaOtpVm.otpCount >= 3){
								utilityService.showErrorMessage("You have reached maximum attempts to send OTP, please try after 3 minutes.");
							}else{
								utilityService.showErrorMessage(error.responseMessage);
							}
						});
					} else {
						var requestParams = {
							"otp": instaOtpVm.otp,
							"mobile": customerInfoService.customer.mobile
						}
						
						instaHomeService.validateOtp(requestParams).then(function (data) {
							var obj = {
								"fromAccount": instaHomeService.viewInstaData.accountNumber,
								"toAccount": instaHomeService.viewInstaData.payingFromAccount,
								"amount": instaHomeService.viewInstaData.accountBalance
							}
							instaHomeService.sendInstaClosure(obj).then(function(response) {
								instaOtpVm.storeRefNumber = response.storeRefNumber;
								if(response) {
									var title = '';
									var template='';
									var onTap ='';
									getAccountDetailsService.accountOverviewData="";

									if(instaOtpVm.storeRefNumber != "" && instaOtpVm.storeRefNumber){
										template = '<div class ="congratsOD"><img src="img/check.png" height="45" width="45" class="happyFaceOD"></div><div class="button_fund_closure RFDpopup fontSize-heading roboto-regular font-dark-grey">Your request number '+instaOtpVm.storeRefNumber+' for closing Insta Home Top-up Loan has been received.</div><div class="FDpopup-margin fontSize-subHeading roboto-light font-dark-grey">You will be notified once the request is processed.</div><div class="FDpopup-styling fontSize-subHeading roboto-light font-dark-grey">You can check the status of the request from the menu under service request.</div>';
									}
									else{
										template =  '<div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter">Congratulations ! Your Insta Home Top up loan with account number '+instaHomeService.viewInstaData.accountNumber+' has been closed</div></div>';
									}
									// if (response.nightMode) {
									// 	if (response.nightMode == "Y") {
									// 		template = '<div class ="congratsOD"><img src="img/check.png" height="45" width="45" class="happyFaceOD"></div><div class="button_fund_closure RFDpopup fontSize-heading roboto-regular font-dark-grey">Your request number '+instaOtpVm.storeRefNumber+' for closing Recurring Deposit has been received.</div><div class="FDpopup-margin fontSize-subHeading roboto-light font-dark-grey">You will be notified once the request is processed.</div><div class="FDpopup-styling fontSize-subHeading roboto-light font-dark-grey">You can check the status of the request from the menu under service request.</div>';
									// 	} else {
									// 		template =  '<div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter">Congratulations ! Your Insta Home Top up loan with account number '+instaHomeService.viewInstaData.accountNumber+' has been closed</div></div>';
									// 	}
									// } else {
										template =  '<div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter">Congratulations ! Your Insta Home Top up loan with account number '+instaHomeService.viewInstaData.accountNumber+' has been closed</div></div>';
									//}
									onTap = 'menu.accountOverviewMyBalance';
									utilityService.setCsatJournies('instaHomeLoanTopup');
									instaHomeService.showAlertModal(title,template,onTap,$scope,$state);
								}
							}, function(error) {
								instaOtpVm.isSubmitDisabled = false;
								utilityService.showErrorMessage(error.responseMessage);
							});	
						}, function (error) {
							instaOtpVm.isSubmitDisabled = false;
							instaOtpVm.otpCount++;
							if(instaOtpVm.otpCount >= 3){
								utilityService.showErrorMessage("You have reached maximum attempts to send OTP, please try after 3 minutes.");
							}else{
								utilityService.showErrorMessage(error.responseMessage);
							}
						});
					}
				}
			}

			instaOtpVm.changeOtp = function () {
				if (instaOtpVm.otp) {
					instaOtpVm.showNameError = instaOtpVm.otp.length;
					if (instaOtpVm.otp.length == 6) {
						instaOtpVm.isNextEnabled = false;
					} else {
						instaOtpVm.isNextEnabled = true;
					}
				} else {
					instaOtpVm.isNextEnabled = true;
				}
			}

			instaOtpVm.resendOtp = function (clickCount) {
				instaOtpVm.otp = "";
				var reqData = {
					"id": customerInfoService.customer.mobile,
					"emailId": customerInfoService.customer.emailID
				}
				instaHomeService.requestOtp(reqData).then(function (data) {
					instaOtpVm.otpCount = 0;
					if (clickCount == 2) {
						instaOtpVm.isNextEnabled = true;
						instaOtpVm.isDisabledOTP = true;
					}else{
						//instaOtpVm.isNextEnabled = true;
						instaOtpVm.isDisabledOTP = true;
						$timeout(function () {
							instaOtpVm.isDisabledOTP = false;
						}, 180000);
					}
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				instaOtpVm.isSubmitDisabled = false;
				if (instaHomeService.customer.accountno) {
					instaOtpVm.accountNumber = instaHomeService.customer.accountno;
				} else {
					instaOtpVm.accountNumber = instaHomeService.viewInstaData.accountNumber;
				}
			});

			return this;
		}
]);


