'use strict';
angularApp.controller('instaReviewController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"instaHomeService",
		"customerInfoService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, instaHomeService, customerInfoService) {
			
			var instaReviewVm = this;
			
			function initPage() {
				instaReviewVm.disableconfirm = true;
				instaReviewVm.availod = true;
				instaReviewVm.closeDetails = [];
				instaReviewVm.nightMode = false;
				instaReviewVm.showDateDiv = true;
				instaReviewVm.indexId = 0;

				instaReviewVm.isMaskPan = true;
			};

			instaReviewVm.goToAO = function () {
				$state.go('menu.accountOverviewMyBalance');
			}
			instaReviewVm.goToHome = function () {
				$state.go('menu.homeScreen');
			}

			instaReviewVm.interestRateFunc = function () {
				var template =  '<div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter">1% above 1 year MCLR, current effective rate '+instaReviewVm.interestRateVal+'% p.a. Interest rate, subject to interest rate reset at the end of every year from the date of first disbursement on the basis of prevailing 1 year MCLR as on the date of reset.</div></div>';
				$ionicPopup.show({
					title: '',
					template: template,
					scope: $scope,
					cssClass: 'my-custom-popup',
					buttons: [{
						text: 'OK',
						type: 'button-assertive',
						onTap: function () {
							$state.go('menu.instaReview');
						}
					}],
				});
			}

			instaReviewVm.loanLimitFunc = function () {
				if(instaReviewVm.feesVal > 0){
				var template =  '<div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter">A flat Processing Fee of '+instaReviewVm.reviewFeesVal+' will be levied under the product. Processing fee will be deducted from the loan amount before disbursement.</div></div>';
				}else{
				var template =  '<div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter">A flat Processing Fee of '+instaReviewVm.reviewFeesVal+' will be levied under the product. Processing fee will be deducted from the loan amount before disbursement.</div></div>';
				}
				$ionicPopup.show({
					title: '',
					template: template,
					scope: $scope,
					cssClass: 'my-custom-popup',
					buttons: [{
						text: 'OK',
						type: 'button-assertive',
						onTap: function () {
							$state.go('menu.instaReview');
						}
					}],
				});
			}

			instaReviewVm.closePopup = function () {
				instaReviewVm.closeTnC.close();
				utilityService.hideSpinner();
			}

			instaReviewVm.termconditionPopUp = function (TnCDetails) {
				var title = "Terms & Conditions";
                var buttontext = "OK";
                var detail = TnCDetails;
                instaHomeService.showTnCAlertModal(title, detail, buttontext,function(){});
			}

			instaReviewVm.unmaskData = function(idType) {
	            var request = {
	                "type": idType,
	                "keyType": "instaCreateAccountNumber",
	                "loanType": "IHL"
	            }
	            if (idType == 'accountno') {
	                instaHomeService.getUnmaskData(request).then(function(data) {
	                    if (idType == 'accountno') {
	                        instaReviewVm.isMaskPan = false;
	                        instaReviewVm.accountNumber = data;
	                    }
	                }, function(error) {
	                    utilityService.showErrorMessage(error.responseMessage);
	                });
	            } else {
	                if (idType == 'naccountno') {
	                    instaReviewVm.isMaskPan = true;
	                    instaReviewVm.accountNumber = instaHomeService.customer.creditToAccount;
	                }
	            }
	        }

			//public functions end
			instaReviewVm.termcondition = function () {				
					var obj = {
						"type" : "instaTC"
					}
					instaHomeService.fetchRtermcondition(obj).then(function (data) {						
						if (!utilityService.isUndefined(data)) {
							data = data.replace("FIELD_1}}", 'Rs.' + instaReviewVm.installmentVal);
							data = data.replace("FIELD_2}}", instaReviewVm.emiDateVal);
							if(instaReviewVm.feesVal > 0) {
								data = data.replace("FIELD_3}}", instaReviewVm.reviewFeesVal);
							}else{
								data = data.replace("FIELD_3}}", 0);
							}
							
							data = data.replace("FIELD_4}}", instaReviewVm.mclr + '%');
							data = data.replace("FIELD_5}}", instaReviewVm.interestRateVal + '%');
							data = data.replace("FIELD_6}}", 'Rs.' + instaReviewVm.loanAmountVal);
							data = data.replace("FIELD_7}}", instaReviewVm.customerName);
							data = data.replace("FIELD_8}}", instaReviewVm.durationVal);
							data = data.replace("FIELD_1}}", 'Rs.' + instaReviewVm.installmentVal);
							data = data.replace("FIELD_5}}", instaReviewVm.interestRateVal + '%');
							instaHomeService.normalFDTnC = data;
							instaReviewVm.termconditionPopUp(instaHomeService.normalFDTnC);
						}
					}, function (error) {
						utilityService.showErrorMessage(error.responseMessage);
					});				
			}

			instaReviewVm.nextFunc = function () {
				instaHomeService.customer.otpClick = "instacreate";
				var obj = {
					 "id": customerInfoService.customer.mobile,
					 "emailId": customerInfoService.customer.emailID
				}
				
				instaHomeService.requestOtp(obj).then(function (data) {
					$state.go('menu.instaOtp');   
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			instaReviewVm.backFunc = function () {
				$state.go('menu.instaDeposit');
			}

			instaReviewVm.getCBValue = function (isChecked) {
				if (isChecked === true) {
					instaReviewVm.disableconfirm = false;
				}else{
					instaReviewVm.disableconfirm = true;
				}
			}

			instaReviewVm.getPreFilledData = function () {
				instaReviewVm.loanAmountVal = parseInt(instaHomeService.customer.selectedamount)+"";
				instaReviewVm.durationVal = instaHomeService.customer.loanduration;
				instaReviewVm.installmentVal = parseInt(instaHomeService.customer.emiamount)+"";
				instaReviewVm.accountNumber = instaHomeService.customer.creditToAccount;
				instaReviewVm.emiDateVal = instaHomeService.customer.emipaymentday;
				instaReviewVm.interestRateVal = instaHomeService.customer.interestrate;
				instaReviewVm.feesVal = instaHomeService.customer.processingfees;
				instaReviewVm.reviewFeesVal = instaHomeService.customer.reviewProcessingFee;
				instaReviewVm.mclr = instaHomeService.customer.mclr;
				instaReviewVm.customerName = instaHomeService.customer.customerName;
			}

			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				instaReviewVm.getPreFilledData();
			});

			return this;
		}
]);


