'use strict';

angularApp.service('instaaadhaarManualAddressService',
    function($q, AdapterUtils, constantConfig) {
        var instaaadhaarManualAddressService = this;

        //Get City and Country based on Pincode input parameter
        instaaadhaarManualAddressService.getAreaDetailForPincode = function(inputparams) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.getAreaDetailForPincode , inputparams, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        //Update Correspondence address when aadhaar address is not matching with the user's current address
        instaaadhaarManualAddressService.updateCorrespondenceAddress = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.updateCorrespondenceAddress, requestData, true).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        //Update user aadhaar details
        instaaadhaarManualAddressService.updateAadhaarDetails = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.adharcard, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        //Load Title List
        instaaadhaarManualAddressService.getTitleList = function(requestData) {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.loadMasterData + requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        //Load gender
        instaaadhaarManualAddressService.getGenderList = function(requestData) {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.loadMasterData + requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        return instaaadhaarManualAddressService;
    });
