'use strict';

angularApp.controller('instaaadhaarManualEntryAddressController', ["$state",
    "$scope",
    "$ionicHistory",
    "instaService",
    "instaaadhaarManualAddressService",
    "utilityService",
    "$translate",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        $ionicHistory,
        instaService,
        instaaadhaarManualAddressService,
        utilityService,
        $translate,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instaaadhaarManualAddressVm = this;

        function initPage() {
            instaaadhaarManualAddressVm.showBack = true;
            instaaadhaarManualAddressVm.showNext = true;
            instaaadhaarManualAddressVm.disableNext = true;
            instaaadhaarManualAddressVm.aofooter = true;
            instaaadhaarManualAddressVm.disableCity = true;
            instaaadhaarManualAddressVm.disableState = true;
            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                instaaadhaarManualAddressVm.okBtntext = translatedvalue;
            });
        }

        instaaadhaarManualAddressVm.goBacktoPrevious = function() {
            instaService.isCustManualCorresChkBox = false;
            $state.go("menu.instaKit_aDCityCountry");
        }

        /* Functionality : Watch the form for validation
           Conditions : If(In resume journey, all data comes populated in the fields[Form is valid] and therefore "Next" button will be enabled)
           Else(If the form is invalid, disable "Next" button)
        */
        $scope.$watch("instaaadhaarManualAddressVm.aadharManualEntryAddressForm.$valid", function(value) {
            if(value === true){
                instaaadhaarManualAddressVm.disableNext = false;
            } else {
                instaaadhaarManualAddressVm.disableNext = true;
            }
        });

        /* Functionality : Set the request parameters and post the data on click of "next" button */
        instaaadhaarManualAddressVm.goToNextPage = function() {
            instaService.aadhaarManualPermanentAddress.address1 = instaaadhaarManualAddressVm.addressAboveData;
            instaService.aadhaarManualPermanentAddress.address2 = instaaadhaarManualAddressVm.addressBelowData;
            instaService.aadhaarManualPermanentAddress.pincode = instaaadhaarManualAddressVm.pincodeData;
            instaService.aadhaarManualPermanentAddress.city = instaaadhaarManualAddressVm.cityData;
            instaService.aadhaarManualPermanentAddress.state = instaaadhaarManualAddressVm.stateData;
            instaService.aadhaarManualPermanentAddress.locality = instaaadhaarManualAddressVm.localityData;

            var requestParams = {
                "id": instaService.customer.mobileNo,
                "data": {
                    "personalDetails": {
                        "uid": instaService.customerManualEntryDetails.aadharNumber,
                        "name": instaService.customerManualEntryDetails.fullName,
                        "firstName": instaService.customerManualEntryDetails.firstName,
                        "middleName": instaService.customerManualEntryDetails.middleName,
                        "lastName": instaService.customerManualEntryDetails.lastName,
                        "title": instaService.customerManualEntryDetails.title,
                        "gender": instaService.customerManualEntryDetails.gender,
                        "dob": instaService.customerManualEntryDetails.dob,
                        "isAadhaarScanned": false,
                        "additionalDetails":{
                            "cityOfBirth": instaService.customerAdditionalDetails.cityOfBirth,
                            "countryOfBirth": instaService.customerAdditionalDetails.countryOfBirth
                        },
                        "address": [{
                            "type": "aadhaar",
                            "addressLine1": instaService.aadhaarManualPermanentAddress.address1,
                            "addressLine2": instaService.aadhaarManualPermanentAddress.address2,
                            "pincode": instaService.aadhaarManualPermanentAddress.pincode,
                            "city": instaService.aadhaarManualPermanentAddress.city,
                            "cityCode":"",
                            "state": instaService.aadhaarManualPermanentAddress.state,
                            "stateCode":"",
                            "locality": instaService.aadhaarManualPermanentAddress.locality
                        }]
                    },
                    "commonId": $state.$current.data.commonId
                }
            }
            instaaadhaarManualAddressService.updateAadhaarDetails(requestParams).then(function(response) {
                if (response.responseCode === constantConfig.successCode) {
                    $state.go('menu.instaKit_panDetails');
                }
            }, function(error) {
               utilityService.showErrorMessage(error.responseMessage);
            });
        }

        /* Event : Click on cross icon in the page (Close account opening module) */
        $scope.goToHome = function() {
            instaService.homeNav();
        }

        /* Functionality : Enable or disable next button on change of every field in the form to check for validation
           Event : On Change of the form field
           Parameter : param - Form validity whether it is valid or not
           Returns : param - true / false
        */
        instaaadhaarManualAddressVm.changefn = function(param) {
            instaaadhaarManualAddressVm.disableNext = !param;
        }

        /* Functionality : Enable or disable next button on change of every field in the form to check for validation
           Parameter : param - Form validity whether it is valid or not
           Returns : param - true / false
        */
        instaaadhaarManualAddressVm.updatedvalue = function(param) {
            (param) ? instaaadhaarManualAddressVm.disableNext = false: instaaadhaarManualAddressVm.disableNext = true;
            return instaaadhaarManualAddressVm.disableNext;
        }

        /* Functionality : Service to return city and state based on the pincode entered
           Event : On change of pincode
        */
        instaaadhaarManualAddressVm.updatearea = function(param) {
            var inputparams = {
                "pinCode": instaaadhaarManualAddressVm.pincodeData
            }
            if (instaaadhaarManualAddressVm.aadharManualEntryAddressForm.pincode.$valid === true && !utilityService.isUndefined(instaaadhaarManualAddressVm.pincodeData)) {
                instaaadhaarManualAddressService.getAreaDetailForPincode(inputparams).then(function(data) {
                    if (utilityService.isUndefined(data)) {
                        var title = '';
                        var template = '{{"PINCODE_MATCH" | translate}}';
                        var onTap = '';
                        var buttontext = '<b>' + instaaadhaarManualAddressVm.okBtntext + '</b>';
                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                        instaaadhaarManualAddressVm.disableState = false;
                        instaaadhaarManualAddressVm.disableCity = false;
                    } else{
                        instaService.customer.city = utilityService.getValue(data.cityName);
                        instaService.customer.state = utilityService.getValue(data.stateName);
                        instaaadhaarManualAddressVm.cityData = instaService.customer.city;
                        instaaadhaarManualAddressVm.stateData = instaService.customer.state;
                        instaaadhaarManualAddressVm.disableCity = true;
                        instaaadhaarManualAddressVm.disableState = true;

                    }
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else if (instaaadhaarManualAddressVm.pincodeData === "" || (!utilityService.isUndefined(instaaadhaarManualAddressVm.pincodeData)).length != 6) {
                instaaadhaarManualAddressVm.cityData = "";
                instaaadhaarManualAddressVm.stateData = "";
            }

        }

        /* Functionality : Check for city and state validation
           Event : On Blur
        */
        instaaadhaarManualAddressVm.checkUpdatedCityStateValid = function(param) {
            instaaadhaarManualAddressVm.updatedvalue(param);
        }

        /* Functionality : Auto populate the data
           Event : On load
        */
        instaaadhaarManualAddressVm.populateResumeData = function() {
            instaaadhaarManualAddressVm.addressAboveData = instaService.aadhaarManualPermanentAddress.address1;
            instaaadhaarManualAddressVm.addressBelowData = instaService.aadhaarManualPermanentAddress.address2;
            instaaadhaarManualAddressVm.pincodeData = instaService.aadhaarManualPermanentAddress.pincode;
            instaaadhaarManualAddressVm.cityData = instaService.aadhaarManualPermanentAddress.city;
            instaaadhaarManualAddressVm.stateData = instaService.aadhaarManualPermanentAddress.state;
            instaaadhaarManualAddressVm.localityData = instaService.aadhaarManualPermanentAddress.locality;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            if(instaService.isResumeJourney == true)
            instaaadhaarManualAddressVm.populateResumeData();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
