'use strict';

angularApp.controller('instaAadhaarManualEntryCAddressController', ["$state",
    "$scope",
    "$ionicHistory",
    "instaService",
    "instaaadhaarManualAddressService",
    "utilityService",
    "$translate",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        $ionicHistory,
        instaService,
        instaaadhaarManualAddressService,
        utilityService,
        $translate,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instaaadhaarManualCaddressVm = this;

        function initPage() {
            instaaadhaarManualCaddressVm.showBack = true;
            instaaadhaarManualCaddressVm.showNext = true;
            instaaadhaarManualCaddressVm.disableNext = true;
            instaaadhaarManualCaddressVm.aofooter = true;
            instaaadhaarManualCaddressVm.disableCity = true;
            instaaadhaarManualCaddressVm.disableState = true;
            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                instaaadhaarManualCaddressVm.okBtntext = translatedvalue;
            });
        }

        instaaadhaarManualCaddressVm.goBacktoPrevious = function() {
            instaService.isCustManualCorresChkBox = true;
            $state.go("menu.instaKit_aDCityCountry");
        }

        /* Functionality : Watch the form for validation
           Conditions : If(In resume journey, all data comes populated in the fields[Form is valid] and therefore "Next" button will be enabled)
           Else(If the form is invalid, disable "Next" button)
        */
        $scope.$watch("instaaadhaarManualCaddressVm.aadharManualEntryCAddressForm.$valid", function(value) {
            if (value === true) {
                instaaadhaarManualCaddressVm.disableNext = false;
            } else {
                instaaadhaarManualCaddressVm.disableNext = true;
            }
        });

        /* Functionality : Set the request parameters and post the data on click of "next" button */
        instaaadhaarManualCaddressVm.goToNextPage = function() {
            instaService.aadhaarManualCorrespondenceAddress.address1 = instaaadhaarManualCaddressVm.addressAboveData;
            instaService.aadhaarManualCorrespondenceAddress.address2 = instaaadhaarManualCaddressVm.addressBelowData;
            instaService.aadhaarManualCorrespondenceAddress.pincode = instaaadhaarManualCaddressVm.pincodeData;
            instaService.aadhaarManualCorrespondenceAddress.city = instaaadhaarManualCaddressVm.cityData;
            instaService.aadhaarManualCorrespondenceAddress.state = instaaadhaarManualCaddressVm.stateData;
            instaService.aadhaarManualCorrespondenceAddress.locality = instaaadhaarManualCaddressVm.localityData;

            var requestParams = {
                "id": instaService.customer.mobileNo,
                "data": {
                    "personalDetails": {
                        "uid": instaService.customerManualEntryDetails.aadharNumber,
                        "name": instaService.customerManualEntryDetails.fullName,
                        "firstName": instaService.customerManualEntryDetails.firstName,
                        "middleName": instaService.customerManualEntryDetails.middleName,
                        "lastName": instaService.customerManualEntryDetails.lastName,
                        "title": instaService.customerManualEntryDetails.title,
                        "titleCode":instaService.customerManualEntryDetails.titleCode,
                        "gender": instaService.customerManualEntryDetails.gender,
                        "genderCode":instaService.customerManualEntryDetails.genderCode,
                        "dob": instaService.customerManualEntryDetails.dob,
                        "isAadhaarScanned": false,
                        "scannedCorrespondenceAddFlag": instaService.isCustManualCorresChkBox,
                        "address": [{
                            "type": "CORRESPONDENCE",
                            "addressLine1": instaService.aadhaarManualCorrespondenceAddress.address1,
                            "addressLine2": instaService.aadhaarManualCorrespondenceAddress.address2,
                            "pincode": instaService.aadhaarManualCorrespondenceAddress.pincode,
                            "city": instaService.aadhaarManualCorrespondenceAddress.city,
                            "cityCode":instaService.aadhaarManualCorrespondenceAddress.cityCode,
                            "state": instaService.aadhaarManualCorrespondenceAddress.state,
                            "stateCode":instaService.aadhaarManualCorrespondenceAddress.stateCode,
                            "locality": instaService.aadhaarManualCorrespondenceAddress.locality
                        }]
                    },
                    "additionalDetails":{
                        "cityOfBirth": instaService.customerAdditionalDetails.cityOfBirth,
                        "countryOfBirth": instaService.customerAdditionalDetails.countryOfBirth
                    },
                    "commonId": $state.$current.data.commonId
                }
            }
            instaaadhaarManualAddressService.updateAadhaarDetails(requestParams).then(function(response) {
                if (response.responseCode === constantConfig.successCode) {
                    $state.go('menu.instaKit_panDetails');
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        /* Event : Click on cross icon in the page (Close account opening module) */
        $scope.goToHome = function() {
            instaService.homeNav();
        }

        /* Functionality : Enable or disable next button on change of the field in the form to check for validation
           Event : On Change of the form field
           Parameter : param - Form validity whether it is valid or not
           Returns : param - true / false
        */
        instaaadhaarManualCaddressVm.changefn = function(param) {
            instaaadhaarManualCaddressVm.disableNext = !param;
        }

        /* Functionality : Enable or disable next button on change of the field in the form to check for validation
           Parameter : param - Form validity whether it is valid or not
           Returns : param - true / false
        */
        instaaadhaarManualCaddressVm.updatedvalue = function(param) {
            (param) ? instaaadhaarManualCaddressVm.disableNext = false: instaaadhaarManualCaddressVm.disableNext = true;
            return instaaadhaarManualCaddressVm.disableNext;
        }

        /* Functionality : Service to return city and state based on the pincode entered
           Event : On change of pincode
        */
        instaaadhaarManualCaddressVm.updatearea = function(param) {
            var inputparams = {
                "pinCode": instaaadhaarManualCaddressVm.pincodeData
            }
            if (instaaadhaarManualCaddressVm.aadharManualEntryCAddressForm.pincode.$valid === true && !utilityService.isUndefined(instaaadhaarManualCaddressVm.pincodeData)) {
                instaaadhaarManualAddressService.getAreaDetailForPincode(inputparams).then(function(data) {
                    if (utilityService.isUndefined(data)) {
                        var title = '';
                        var template = '{{"PINCODE_MATCH" | translate}}';
                        var onTap = '';
                        var buttontext = '<b>' + instaaadhaarManualCaddressVm.okBtntext + '</b>';
                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                        instaaadhaarManualCaddressVm.disableState = false;
                        instaaadhaarManualCaddressVm.disableCity = false;
                    } else{
                        instaService.customer.city = utilityService.getValue(data.cityName);
                        instaService.customer.state = utilityService.getValue(data.stateName);
                        instaService.aadhaarManualCorrespondenceAddress.cityCode = utilityService.getValue(data.cityCode);
                        instaService.aadhaarManualCorrespondenceAddress.stateCode = utilityService.getValue(data.stateCode);
                        instaaadhaarManualCaddressVm.cityData = instaService.customer.city;
                        instaaadhaarManualCaddressVm.stateData = instaService.customer.state;
                        instaaadhaarManualCaddressVm.disableCity = true;
                        instaaadhaarManualCaddressVm.disableState = true;

                    }
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else if (instaaadhaarManualCaddressVm.pincodeData === "" || (!utilityService.isUndefined(instaaadhaarManualCaddressVm.pincodeData)).length != 6) {
                instaaadhaarManualCaddressVm.cityData = "";
                instaaadhaarManualCaddressVm.stateData = "";
            }

        }

        /* Functionality : Check if city and state is valid
           Event : On blur of city and state fields
        */
        instaaadhaarManualCaddressVm.checkUpdatedCityStateValid = function(param) {
            instaaadhaarManualCaddressVm.updatedvalue(param);
        }

        /* Functionality : Auto populate data
           Event : On load
        */
        instaaadhaarManualCaddressVm.populateResumeData = function() {
            instaaadhaarManualCaddressVm.addressAboveData = instaService.aadhaarManualCorrespondenceAddress.address1;
            instaaadhaarManualCaddressVm.addressBelowData = instaService.aadhaarManualCorrespondenceAddress.address2;
            instaaadhaarManualCaddressVm.pincodeData = instaService.aadhaarManualCorrespondenceAddress.pincode;
            instaaadhaarManualCaddressVm.cityData = instaService.aadhaarManualCorrespondenceAddress.city;
            instaaadhaarManualCaddressVm.stateData = instaService.aadhaarManualCorrespondenceAddress.state;
            instaaadhaarManualCaddressVm.localityData = instaService.aadhaarManualCorrespondenceAddress.locality;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
                instaaadhaarManualCaddressVm.populateResumeData();
                $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);

        });

        return this;
    }
]);
