'use strict';

angularApp.controller('instaAadhaarManualEntryController', ["$state",
    "$scope",
    "instaService",
    "utilityService",
    "$translate",
    "instaaadhaarManualAddressService",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        instaService,
        utilityService,
        $translate,
        instaaadhaarManualAddressService,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instaAadhaarManualEntryVm = this;

        function initPage() {
            instaAadhaarManualEntryVm.showBack = true;
            instaAadhaarManualEntryVm.showNext = true;
            instaAadhaarManualEntryVm.aofooter = true;
            instaAadhaarManualEntryVm.invalid = false;
            instaAadhaarManualEntryVm.properDate = false;
            instaAadhaarManualEntryVm.disableNext = true;
            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                instaAadhaarManualEntryVm.okBtntext = translatedvalue;
            });
        }

        /* Functionality : Load titles (Master data)
           Event : On load
        */
        instaAadhaarManualEntryVm.loadTitles = function(){
            var requestData = "TitleLotus";
            instaaadhaarManualAddressService.getTitleList(requestData).then(function(response) {
                instaAadhaarManualEntryVm.selectTitles = response.data;
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        /* Functionality : Load gender (Master data)
           Event : On load
        */
        instaAadhaarManualEntryVm.loadGenderList = function(){
            var requestParam = "Gender";
	    utilityService.showSpinner();
	    instaAadhaarManualEntryVm.isErorr  = false;
            instaaadhaarManualAddressService.getGenderList(requestParam).then(function(response) {
	    instaAadhaarManualEntryVm.isErorr = false;
	    utilityService.hideSpinner();
                instaAadhaarManualEntryVm.genderList = response.data;
            }, function(error) {
	        utilityService.hideSpinner();
		instaAadhaarManualEntryVm.isErorr = true;
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        /* Functionality :  Set the model values to common service for using it in other controller
           Event : on click of "next" button 
        */
        instaAadhaarManualEntryVm.goToNextPage = function() {
            instaAadhaarManualEntryVm.ageCheck = instaAadhaarManualEntryVm.checkAge();
            if (instaAadhaarManualEntryVm.aadhaarnumber != instaService.nomineeAadhaarCardDetails.uid) {
                if (instaAadhaarManualEntryVm.ageCheck > 0) {
                    instaService.isCustManualCorresChkBox = instaAadhaarManualEntryVm.isChecked;
                     if(instaService.isCustManualCorresChkBox == false){
                        instaService.aadhaarManualCorrespondenceAddress.address1 = "";
                        instaService.aadhaarManualCorrespondenceAddress.address2 = "";
                        instaService.aadhaarManualCorrespondenceAddress.pincode = "";
                        instaService.aadhaarManualCorrespondenceAddress.city = "";
                        instaService.aadhaarManualCorrespondenceAddress.state = "";
                        instaService.aadhaarManualCorrespondenceAddress.locality = "";                        
                    }
                    $state.go('menu.instaKit_aDCityCountry');
                } else {
                    var title = '';
                    var template = '{{"AGE_CHECK" | translate}}';
                    var onTap = 'menu.instaKit_aadhaarManualEntry';
                    var buttontext = '<b>' + instaAadhaarManualEntryVm.okBtntext + '</b>';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                }
                instaService.customerManualEntryDetails.aadharNumber = instaAadhaarManualEntryVm.aadhaarnumber;
                instaService.customerManualEntryDetails.firstName = instaAadhaarManualEntryVm.fatherFname;
                instaService.customerManualEntryDetails.lastName = instaAadhaarManualEntryVm.fatherLname;
                instaService.customerManualEntryDetails.middleName = instaAadhaarManualEntryVm.fatherMname;
                instaService.customerManualEntryDetails.fullName = instaAadhaarManualEntryVm.fatherFname + ' ' + instaAadhaarManualEntryVm.fatherMname + ' ' + instaAadhaarManualEntryVm.fatherLname;
                instaService.customerManualEntryDetails.genderCode = instaAadhaarManualEntryVm.selectedGender;
                instaService.customerManualEntryDetails.titleCode = instaAadhaarManualEntryVm.selectedTitle;
                instaService.customerManualEntryDetails.title = instaService.getValueById(instaAadhaarManualEntryVm.selectTitles,instaAadhaarManualEntryVm.selectedTitle);
                instaService.customerManualEntryDetails.gender = instaService.getValueById(instaAadhaarManualEntryVm.genderList,instaAadhaarManualEntryVm.selectedGender);               
                instaService.customerManualEntryDetails.dob = instaAadhaarManualEntryVm.date + '/' + instaAadhaarManualEntryVm.month + '/' + instaAadhaarManualEntryVm.year;
            } else {
                var title = '';
                var template = "{{'AADHAAR_BOTH_SAME'| translate}}";
                var onTap = '';
                var buttontext = "<b>" + instaAadhaarManualEntryVm.okBtntext + "</b>";
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            }

        }

        instaAadhaarManualEntryVm.goBacktoPrevious = function() {
            $state.go('menu.instaKit_personalDetails');
        }

        //Auto populate the data in resume journey
        instaAadhaarManualEntryVm.populateResumeData = function() {
                instaAadhaarManualEntryVm.aadhaarnumber = instaService.customerManualEntryDetails.aadharNumber;
                instaAadhaarManualEntryVm.fatherFname = instaService.customerManualEntryDetails.firstName;
                instaAadhaarManualEntryVm.fatherMname = instaService.customerManualEntryDetails.middleName;
                instaAadhaarManualEntryVm.fatherLname = instaService.customerManualEntryDetails.lastName;
                instaAadhaarManualEntryVm.selectedGender = instaService.customerManualEntryDetails.genderCode;
                instaAadhaarManualEntryVm.selectedTitle = instaService.customerManualEntryDetails.titleCode;
                instaAadhaarManualEntryVm.isChecked = instaService.isCustManualCorresChkBox;
        }

        $scope.$watch("instaAadhaarManualEntryVm.personalDetailsForm.$valid", function(value) {
            if (value === true && instaAadhaarManualEntryVm.invalid == false) {
                instaAadhaarManualEntryVm.disableNext = false;
            } else {
                instaAadhaarManualEntryVm.disableNext = true;
            }
        });

        // On page load - populate aadhaar dob
        instaAadhaarManualEntryVm.populateDobAadhaar = function() {
            if (!utilityService.isUndefined(instaService.customerManualEntryDetails.dob)) {
                instaService.customerManualEntryDetails.dob = moment(instaService.customerManualEntryDetails.dob, ["DD/MM/YYYY", "MM/DD/YYYY", "DD-MM-YYYY", "MM-DD-YYYY", "YYYY-MM-DD", "YYYY-DD-MM","YYYY/MM/DD", "YYYY/DD/MM"]);
                var dateFormat = new Date(instaService.customerManualEntryDetails.dob);
                var day = dateFormat.getDate();
                var month = dateFormat.getMonth() + 1;
                var year = dateFormat.getFullYear();
                var formattedDate = day.toString();
                if (formattedDate.length == 1) {
                    formattedDate = "0" + formattedDate;
                    instaAadhaarManualEntryVm.date = formattedDate;
                } else {
                    instaAadhaarManualEntryVm.date = parseInt(day);
                }
                var formattedMonth = month.toString();
                if (formattedMonth.length == 1) {
                    formattedMonth = "0" + formattedMonth;
                    instaAadhaarManualEntryVm.month = formattedMonth;
                } else {
                    instaAadhaarManualEntryVm.month = parseInt(month);
                }
                instaAadhaarManualEntryVm.year = parseInt(year);
            } else if (!utilityService.isUndefined(instaService.customerManualEntryDetails.yob) && utilityService.isUndefined(instaService.customerManualEntryDetails.dob)) {
                instaAadhaarManualEntryVm.date = "";
                instaAadhaarManualEntryVm.month = "";
                instaAadhaarManualEntryVm.year = parseInt(instaService.customerManualEntryDetails.yob);
            }
        }
        $scope.goToHome = function() {
            instaService.homeNav();
        }

        instaAadhaarManualEntryVm.validateForm = function(isValid) {
            instaAadhaarManualEntryVm.disableNext = !isValid;
        }

        /* Based on the title change, populate the gender dropdown */
        instaAadhaarManualEntryVm.genderUpdate = function(value) {
            if (utilityService.isUndefined(value)) {
                instaAadhaarManualEntryVm.selectedGender = constantConfig.acOp.gender;
            } else if (value === "01") {
                instaAadhaarManualEntryVm.selectedGender = "M";
            } else {
                instaAadhaarManualEntryVm.selectedGender = "F";
            }
        }

        /* Based on gender change, populate title dropdown */
        instaAadhaarManualEntryVm.titleUpdate = function(value) {
            if (utilityService.isUndefined(value)) {
                instaAadhaarManualEntryVm.selectedTitle = constantConfig.acOp.title;
            } else if (value.toLowerCase() === constantConfig.acOp.male || value.toLowerCase() === "m") {
                instaAadhaarManualEntryVm.selectedTitle = "01";
            } else {
                instaAadhaarManualEntryVm.selectedTitle = "02";
            }
        }

        // Validate date
        instaAadhaarManualEntryVm.validDateFormat = function(isValid) {
            var fullDate = instaAadhaarManualEntryVm.month + '/' + instaAadhaarManualEntryVm.date + '/' + instaAadhaarManualEntryVm.year;
            var dobMonth = instaAadhaarManualEntryVm.month;
            var dobDay = instaAadhaarManualEntryVm.date;
            var dobYr = instaAadhaarManualEntryVm.year;
            var fullDateInMilliSeconds = Date.parse(fullDate);
            var formattedDate = new Date();
            var formattedDateYr = formattedDate.getFullYear();
            var currDate = new Date();
            var curYear = currDate.getFullYear();
            var curDateInMilliSeconds = new Date().getTime();
            formattedDate.setFullYear(dobYr, dobMonth - 1, dobDay);
            var months30 = ['04', '06', '09', '11', "4", "6", "9"];
            var monthIndex = months30.indexOf(dobMonth);

            // If entered date is greater than the current date
            if (fullDateInMilliSeconds > curDateInMilliSeconds) {
                instaAadhaarManualEntryVm.disableNext = true;
                instaAadhaarManualEntryVm.invalid = true;
                instaAadhaarManualEntryVm.properDate = false;
            }
            // Leap year validation
            else if (dobYr % 4 == 0 && (dobYr % 100 != 0 || dobYr % 400 == 0)) {
                if (dobMonth == 2 && dobDay > 29) {
                    instaAadhaarManualEntryVm.disableNext = true;
                    instaAadhaarManualEntryVm.invalid = true;
                    instaAadhaarManualEntryVm.properDate = false;
                } else if (monthIndex != -1 && dobDay == 31) {
                    instaAadhaarManualEntryVm.disableNext = true;
                    instaAadhaarManualEntryVm.invalid = true;
                    instaAadhaarManualEntryVm.properDate = false;
                } else {
                    instaAadhaarManualEntryVm.disableNext = !isValid;
                    instaAadhaarManualEntryVm.invalid = false;
                    instaAadhaarManualEntryVm.properDate = true;
                }
            } else if (dobMonth == 2 && dobDay >= 29) {
                instaAadhaarManualEntryVm.disableNext = true;
                instaAadhaarManualEntryVm.invalid = true;
                instaAadhaarManualEntryVm.properDate = false;
            }
            // If the month has only 30 days
            else if (monthIndex != -1 && dobDay == 31) {
                instaAadhaarManualEntryVm.disableNext = true;
                instaAadhaarManualEntryVm.invalid = true;
                instaAadhaarManualEntryVm.properDate = false;
            } else {
                instaAadhaarManualEntryVm.disableNext = !isValid;
                instaAadhaarManualEntryVm.invalid = false;
                instaAadhaarManualEntryVm.properDate = true;
            }
            return instaAadhaarManualEntryVm.properDate;
        }

        //Method to calculate customer age
        instaAadhaarManualEntryVm.checkAge = function() {
                instaAadhaarManualEntryVm.validDate = instaAadhaarManualEntryVm.validDateFormat();
                if (instaAadhaarManualEntryVm.validDate == true) {
                    var fullDate = instaAadhaarManualEntryVm.month + '/' + instaAadhaarManualEntryVm.date + '/' + instaAadhaarManualEntryVm.year;

                    var formattedDate = new Date();
                    formattedDate.setFullYear(instaAadhaarManualEntryVm.year, instaAadhaarManualEntryVm.month - 1, instaAadhaarManualEntryVm.date);
                    var todayDate = new Date();
                    var currentYear = todayDate.getFullYear();
                    var validYear = todayDate.setFullYear(currentYear - 18);
                    instaAadhaarManualEntryVm.customerAge = validYear - formattedDate;
                    instaAadhaarManualEntryVm.dob = fullDate;
                    instaAadhaarManualEntryVm.disableNext = false;
                } else if (instaAadhaarManualEntryVm.validDate == false) {
                    instaAadhaarManualEntryVm.disableNext = true;
                }
                return instaAadhaarManualEntryVm.customerAge;
            }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            instaAadhaarManualEntryVm.loadTitles();
            instaAadhaarManualEntryVm.loadGenderList();
            instaAadhaarManualEntryVm.populateResumeData();
            instaAadhaarManualEntryVm.populateDobAadhaar();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
