'use strict';

angularApp.controller('instaAadhaarOTPController', ["$state",
    "$scope",
    "instagetOTPService",
    "instaService",
    "utilityService",
    "resumeJourneyService",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "cryptoService",
    "encryptionService",
    "$translate",
    "loggedInUserService",
    "AdapterUtils",
    "instaAadhaarValService",
    function ($state,
        $scope,
        instagetOTPService,
        instaService,
        utilityService,
        resumeJourneyService,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService,
        cryptoService,
        encryptionService,
        $translate,
        loggedInUserService,
        AdapterUtils,
        instaAadhaarValService
    ) {

        var instaAadhaarOTPAoVm = this;

        function initPage() {
            instaAadhaarOTPAoVm.showBack = true;
            instaAadhaarOTPAoVm.showNext = true;
            instaAadhaarOTPAoVm.resendOtpLink = true;
            instaAadhaarOTPAoVm.otpSentMsg = true;
            instaAadhaarOTPAoVm.aofooter = true;
            instaAadhaarOTPAoVm.disableFields = false;
            instaAadhaarOTPAoVm.isEnableOTPOnce = true;
            instaAadhaarOTPAoVm.disableNext = true;
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                instaAadhaarOTPAoVm.okBtntext = translatedvalue;

            });


        }

        instaAadhaarOTPAoVm.goBacktoPrevious = function () {
            $state.go('menu.instaKit_aadhaarValidation');
        }

        $scope.goToHome = function () {
            instaService.homeNav();
        }

        instaAadhaarOTPAoVm.validateOTP = function(isValid) {
            instaAadhaarOTPAoVm.disableNext = !isValid;
        }

        instaAadhaarOTPAoVm.getAadharOTP = function(isResendClicked){
			if (!isResendClicked) {
				instaAadhaarOTPAoVm.isSubmitNotTapped = false;
			}
			instaAadhaarValService.aadhrOTPattempt = instaAadhaarValService.aadhrOTPattempt + 1;
			if (instaAadhaarValService.aadhrOTPattempt > 5 && isResendClicked) {
				return true;
			}
			
            instaAadhaarOTPAoVm.getOTPNumber = "";
            instaAadhaarOTPAoVm.disableNext = true;
			var requestParams = {
				"vidNumber" : instaService.customerAadhaarCardDetails.vid ? instaService.customerAadhaarCardDetails.vid : "",
				"aadharNumber" : instaService.customerAadhaarCardDetails.uid ? instaService.customerAadhaarCardDetails.uid : ""
			};
	
			instaAadhaarValService.generateAadharOtp(requestParams).then(function(response) {
								if (response.data.status == "0") {
									var title = '';
									var template = '{{"OTP_SUCCESS" | translate}}';
									var onTap = '';
									var buttontext = '<b>' + instaAadhaarOTPAoVm.okBtntext + '</b>';
									utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
									instaAadhaarOTPAoVm.otpNumberInput = false;
								} else if (response.data.status == "-1" || response.data.status == "-2") {
									var title1 = '';
									var template1 = response.data.details;
									var onTap1 = '';
									var buttontext1 = '<b>' + instaAadhaarOTPAoVm.okBtntext + '</b>';
									utilityService.showAlertModal(title1, template1, onTap1, $scope, $state, buttontext1);
								} else {
									var title2 = '';
									var template2 = '{{"SERVICE_ERR_MSG" | translate}}';
									var onTap2 = '';
									var buttontext2 = '<b>' + instaAadhaarOTPAoVm.okBtntext + '</b>';
									utilityService.showAlertModal(title2, template2, onTap2, $scope, $state, buttontext2);
								}
								
							}, function(error) {
								utilityService.showErrorMessage(error.responseMessage);
							});
		};

        instaAadhaarOTPAoVm.getAadharDetails = function() {
        	var uidType = "0";
        	if(instaService.isVID){
        		uidType = "2";
        	}
            var requestParams = {
                "aadharNumber": instaService.customerAadhaarCardDetails.uid,
                "vidNumber": instaService.customerAadhaarCardDetails.vid,
                "otp": instaAadhaarOTPAoVm.getOTPNumber,
                "uidType" : uidType
            }
            instaAadhaarValService.getEKycOTPSecure(requestParams).then(function(response) {
                var aadharDetails = response.data;
                if(!utilityService.isUndefined(response.data)){
                        instaService.customerAadhaarCardDetails.uid = aadharDetails.kycResponse.uidData.aadharNumber;
                        instaService.customerAadhaarCardDetails.name = aadharDetails.kycResponse.uidData.poi.name;
                        instaService.customerAadhaarCardDetails.gender = aadharDetails.kycResponse.uidData.poi.gender;
                        instaService.customerAadhaarCardDetails.house = aadharDetails.kycResponse.uidData.poa.house;
                        instaService.customerAadhaarCardDetails.street = aadharDetails.kycResponse.uidData.poa.street;
                        instaService.customerAadhaarCardDetails.loc = aadharDetails.kycResponse.uidData.poa.locality;
                        instaService.customerAadhaarCardDetails.dist = aadharDetails.kycResponse.uidData.poa.city;
                        instaService.customerAadhaarCardDetails.state = aadharDetails.kycResponse.uidData.poa.state;
                        instaService.customerAadhaarCardDetails.stateCode = aadharDetails.kycResponse.uidData.poa.stateCode;
                        instaService.customerAadhaarCardDetails.cityCode = aadharDetails.kycResponse.uidData.poa.cityCode;
                        instaService.customerAadhaarCardDetails.pc = aadharDetails.kycResponse.uidData.poa.pinCode;
                        instaService.customerAadhaarCardDetails.dob = aadharDetails.kycResponse.uidData.poi.dob;
                        instaService.customer.photo = aadharDetails.kycResponse.uidData.photo;
                        instaService.customerAadhaarCardDetails.aadharNewEntry = true;  
                        instaService.customerAadhaarCardDetails.district = aadharDetails.kycResponse.uidData.poa.district;
                        instaService.customerAadhaarCardDetails.districtCode = aadharDetails.kycResponse.uidData.poa.districtCode;
                        instaService.picId = "";
                        instaService.pincodeReset = true;
                        instaService.customerAadhaarCardDetails.distCode = "";
                        instaService.customerAadhaarCardDetails.subdistCode = "";
                        instaService.customerAadhaarCardDetails.villageCode = "";
                        $state.go('menu.instaKit_pdetailsAN');
                }
                else{
                    var title3 = '';
                    var template3 = '{{"INVALID_OTP" | translate}}';
                    var onTap3 = '';
                    var buttontext3 = '<b>' + instaAadhaarOTPAoVm.okBtntext + '</b>';
                    utilityService.showAlertModal(title3, template3, onTap3, $scope, $state, buttontext3);
                }              
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage); 
            });
        };


        //On click of Resend OTP link
        instaAadhaarOTPAoVm.resendOTPService = function () {
            instaAadhaarOTPAoVm.getAadharOTP();
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            instaAadhaarOTPAoVm.getAadharOTP();


        });

        $scope.$on('$ionicView.beforeLeave', function () {

        });

        return this;
    }
]);
