'use strict';

angularApp.controller('instaaccountOpeningController', ["$state",
    "$scope",
    "instaaccountOpeningService",
    "instaService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "constantConfig",
    "newToSbiService",
    "employerDetailsService",

    function($state,
        $scope,
        instaaccountOpeningService,
        instaService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        constantConfig,
        newToSbiService,
        employerDetailsService) {

        var instaaccountOpeningVm = this;
        //instaaccountOpeningVm.literateFlag = false;
        instaaccountOpeningVm.isChecked = false;
        instaaccountOpeningVm.isChecked = instaService.literateFlag;
        instaaccountOpeningVm.disableNext = true;
        
        function initPage() {
            instaaccountOpeningVm.aofooter = true;

            instaaccountOpeningVm.journeyType = instaService.journeyType;
            instaaccountOpeningVm.constantJourneyTypeVKYC = constantConfig.acOpeningAdapterOVDConstant.vkycInsta;
            instaaccountOpeningVm.constantJourneyTypeSalaryAcc = constantConfig.acOpeningAdapterOVDConstant.salaryAcc;
            instaaccountOpeningVm.getInstaPlusDetail = angular.copy(newToSbiService.getInstaPlusDetail);

            if(instaaccountOpeningVm.journeyType == instaaccountOpeningVm.constantJourneyTypeSalaryAcc){
                    instaaccountOpeningVm.featuresJson = instaaccountOpeningVm.getInstaPlusDetail.productInformationSalaryVkyc;
                    //instaaccountOpeningVm.disableNext = false;
                    instaaccountOpeningVm.showSalaryTitles = true;
            }else{
                if(instaaccountOpeningVm.journeyType != instaaccountOpeningVm.constantJourneyTypeVKYC){
                    instaaccountOpeningVm.loadProductFeatures();
                    //instaaccountOpeningVm.disableNext = true;
                }else{
                    instaaccountOpeningVm.featuresJson = instaaccountOpeningVm.getInstaPlusDetail.productInformationInstaPlus;
                    //instaaccountOpeningVm.disableNext = false;
                }
            }
          
            instaaccountOpeningVm.showBack = false;
            instaaccountOpeningVm.showNext = true;

            instaService.setFeature(instaaccountOpeningVm.getInstaPlusDetail.policyWording);
            
        }

        /* Functionality : WCM service to load product features
           Event : On load
        */
        instaaccountOpeningVm.loadProductFeatures = function() {
            instaaccountOpeningService.getProductFeatures().then(function(data) {
                instaaccountOpeningVm.featuresJson = data;
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        instaaccountOpeningVm.authoriseUser = function(){
            if(instaaccountOpeningVm.isChecked){
                instaaccountOpeningVm.isChecked = true;
                instaaccountOpeningVm.disableNext = false;
            }
            else{
                instaaccountOpeningVm.isChecked = false;
                instaaccountOpeningVm.disableNext = true;
            }
        }

        instaaccountOpeningVm.goToNextPage = function() {
            instaaccountOpeningVm.journeyType = instaService.journeyType;
             //instaaccountOpeningVm.disableNext = false;
               instaService.literateFlag = instaaccountOpeningVm.isChecked;
                 $state.go('menu.accountOpeningProcessAtglance');
            
          }
	
        instaaccountOpeningVm.knowmoreLink = function(){
            $state.go('menu.instaKit_knowMore');
        }

        instaaccountOpeningVm.goBacktoPrevious = function() {
            $state.go('menu.instaKit_applyNewOrResume');
        }

        $scope.goToHome = function(){
            instaService.homeNav();
        }
        
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            instaaccountOpeningVm.journeyType = instaService.journeyType;
            if(instaaccountOpeningVm.journeyType == constantConfig.acOpeningAdapterOVDConstant.salaryAcc){
                instaaccountOpeningVm.showSalaryTitles = true;
            }else{
                instaaccountOpeningVm.showSalaryTitles = false;
                instaaccountOpeningVm.constantJourneyTypeVKYC = constantConfig.acOpeningAdapterOVDConstant.vkycInsta;
            }
           
            instaaccountOpeningVm.getInstaPlusDetail = angular.copy(newToSbiService.getInstaPlusDetail);

        });
        
        return this;
    }
]);
