'use strict';

angularApp.controller('instaaccountOpeningGetPictureController', ["$state",
    "$scope",
    "$translate",
    "cameraService",
    "utilityService",
    "instaService",
    "$ionicPopover",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        $translate,
        cameraService,
        utilityService,
        instaService,
        $ionicPopover,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instaaOGetPictureVm = this;

        instaaOGetPictureVm.showBack = true;
        instaaOGetPictureVm.showNext = false;
        instaaOGetPictureVm.aofooter = true;

        function initPage() {
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                instaaOGetPictureVm.okBtntext = translatedvalue;  
            });
        }

        instaaOGetPictureVm.goBacktoPrevious = function() {
            $state.go("menu.instaKit_panAuthorise");
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        instaaOGetPictureVm.takeSelfie = function() {
            $state.go('menu.instaKit_aOTakeSelfie');
        }

        /* Fetch image from gallery */
        instaaOGetPictureVm.imageFromGallery = function() {
            cameraService.getImageFromGallery().then(function(data) {
                instaService.customer.photo = data;
                $state.go('menu.instaKit_aOLooksGreat');
            }, function(error) {
                var title = '';
                var template = '{{"SERVICE_ERR_MSG" | translate}}';
                var onTap = '';
                var buttontext = '<b>' + instaaOGetPictureVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            });
        }

        /* Info Popup */
        var template = '<ion-popover-view class="ao-tooltip ao-popupInfo roboto-regular ao-twoLinesHt">' + '<ion-content>' +
                        '<div class="" translate="CLEAR_PICTURE"></div>' + '</ion-content>' + '</ion-popover-view>';

        $scope.popover = $ionicPopover.fromTemplate(template, {
            scope: $scope
        });

        instaaOGetPictureVm.infoPopup = function($event) {
            $scope.popover.show($event);
        };

        instaaOGetPictureVm.closePopover = function() {
            $scope.popover.hide();
        };
       /* Info Popup */
        
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });
        
        return this;
    }
]);
