'use strict';

angularApp.controller('instaaccountOpeningLooksGreatController', ["$state",
    "$scope",
    "instaaccountOpeningLooksGreatService",
    "instaService",
    "utilityService",
    "$translate",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        instaaccountOpeningLooksGreatService,
        instaService,
        utilityService,
        $translate,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instaaOLooksGreatVm = this;

        function initPage() {
            instaaOLooksGreatVm.aofooter = true;
            instaaOLooksGreatVm.showBack = true;
            instaaOLooksGreatVm.showNext = true;
            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                instaaOLooksGreatVm.okBtntext = translatedvalue;
            });
        }

        instaaOLooksGreatVm.goBacktoPrevious = function() {
            if(instaService.cifNumber == "0000"){
            $state.go('menu.instaKit_panDetails');
            }else{
                $state.go('menu.instaKit_kindlyNote');
            }
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        instaaOLooksGreatVm.goToNextPage = function() {
           instaaOLooksGreatVm.handleApply();        
        }

        /* Functionality : Service to upload the customer photo
           Event : On click of "tick" image
        */
        instaaOLooksGreatVm.handleApply = function() {
            var newImg = instaService.customer.photo;
            var param = {
                /*"documentClass": "LT_AO_INSTA",
                "mimeType": "image/jpg",
                "documentTitle": "CustomerPhoto",
                "documentData": newImg,
                "documentType": "Photograph",
                "documentID": instaService.customer.mobileNo,*/
                "commonId": $state.$current.data.commonId
            }
            instaaccountOpeningLooksGreatService.uploadPhoto(param).then(function(response) {
                $state.go('menu.instaKit_additionalDetails');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        /* Functionality : Service to upload the customer photo
           Event : On click of "tick" image
        */
        instaaOLooksGreatVm.retrievePhotoCall = function() {
            var param = instaService.picId;
            param = param.split("{").join("");
            param = param.split("}").join("")
            instaaccountOpeningLooksGreatService.retrievePhoto(param).then(function(response) {
                instaaOLooksGreatVm.croppedImage = "data:image/jpeg;base64," + response.data.documentData;
                instaService.customer.photo = instaaOLooksGreatVm.croppedImage;
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
             $translate('AO_OK_LABEL').then(function(translatedvalue) {
                instaaOLooksGreatVm.okBtntext = translatedvalue;
            });
           // if(!instaService.customer.photo){
            if (instaService.isResumeJourney == true && !utilityService.isUndefined(instaService.picId)) {
                instaaOLooksGreatVm.retrievePhotoCall();
            }
            else{
                instaaOLooksGreatVm.croppedImage = "data:image/jpeg;base64," +instaService.customer.photo;
            }
        $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
