'use strict';

angularApp.service('instaaccountOpeningService',
    function($q, AdapterUtils, constantConfig) {
        var instaaccountOpeningService = this;
        instaaccountOpeningService.literateFlag = true;

        instaaccountOpeningService.getProductFeatures = function() {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.getProductFeatures, true).then(

                function(response) {
                    q.resolve(response.data.productFeatures);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        instaaccountOpeningService.getInstaPlusDetail = function() {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.getInstaPlusDetail, true).then(

                function(response) {
                    q.resolve(response.data.getINSTAPlusDeatail);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        instaaccountOpeningService.getVideoDemo = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/InstaAccountOpeningAdapter/getVideoDemo", {}, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        instaaccountOpeningService.getFAQList = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/InstaAccountOpeningAdapter/getFAQList", {}, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        return instaaccountOpeningService;
    });
