'use strict';

angularApp.controller('instaaccountOpeningTakeSelfieController', ["$state",
    "$scope",
    "$translate",
    "cameraService",
    "instaService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        $translate,
        cameraService,
        instaService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instaaOTakeSelfieVm = this;

        function initPage() {
            instaaOTakeSelfieVm.showBack = true;
            instaaOTakeSelfieVm.aofooter = true;
        
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                instaaOTakeSelfieVm.okBtntext = translatedvalue;  
            });
        }

        instaaOTakeSelfieVm.goBacktoPrevious = function() {
            $state.go('menu.instaKit_aOGetPicture');
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        /* Opens Mobile Camera */
        instaaOTakeSelfieVm.openCamera = function() {
            cameraService.getnewImage().then(function(data) {
                instaaOTakeSelfieVm.setImage(data);
                $state.go('menu.instaKit_aOLooksGreat');
            }, function(error) {
                var title = '';
                var template = '{{"SERVICE_ERR_MSG" | translate}}';
                var onTap = '';
                var buttontext = '<b>' + instaaOTakeSelfieVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            });
        }

        /* Set the image captured in camera */
        instaaOTakeSelfieVm.setImage = function(img) {
            instaaOTakeSelfieVm.selfieImage = img;
            instaService.customer.photo = instaaOTakeSelfieVm.selfieImage;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            instaaOTakeSelfieVm.selfieImage = "img/client-img.png";
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });
        
        return this;
    }
]);
