'use strict';

angularApp.controller('instaknowMoreController', ["$state",
    "$scope",
    "instaknowMoreService",
    "instaService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "constantConfig",
    "newToSbiService",

    function($state,
        $scope,
        instaknowMoreService,
        instaService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        constantConfig,
        newToSbiService) {

        var instaknowMoreVm = this;

        instaknowMoreVm.showBack = true;
        instaknowMoreVm.showNext = false;

        function initPage() {
            instaknowMoreVm.aofooter = true;
            instaknowMoreVm.journeyType = instaService.journeyType;
            instaknowMoreVm.constantJourneyTypeVKYC = constantConfig.acOpeningAdapterOVDConstant.vkycInsta;
            instaknowMoreVm.getInstaPlusDetail = angular.copy(newToSbiService.getInstaPlusDetail);
            if(instaknowMoreVm.journeyType == constantConfig.acOpeningAdapterOVDConstant.salaryAcc){
                instaknowMoreVm.featuresJson = instaknowMoreVm.getInstaPlusDetail.productInformationKnowmoreSalaryVkyc;
                instaknowMoreVm.showSalaryTitles = true;
                $scope.$apply();
            }else{
            if(instaknowMoreVm.journeyType != instaknowMoreVm.constantJourneyTypeVKYC){
                instaknowMoreVm.loadProductFeatures();
            }else{
                instaknowMoreVm.featuresJson = instaknowMoreVm.getInstaPlusDetail.productInformationKnowmoreInstaPlus;
            }
            }     
            
        }

        instaknowMoreVm.loadProductFeatures = function() {
            instaknowMoreService.productKnowMore().then(function(data) {
                instaknowMoreVm.featuresJson = data;
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        instaknowMoreVm.goBacktoPrevious = function() {
            $state.go('menu.instaKit_accountOpening');
        }

        $scope.goToHome = function(){
            instaService.homeNav();
        }
        
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            instaknowMoreVm.journeyType = instaService.journeyType;
            instaknowMoreVm.constantJourneyTypeVKYC = constantConfig.acOpeningAdapterOVDConstant.vkycInsta;
            instaknowMoreVm.getInstaPlusDetail = angular.copy(newToSbiService.getInstaPlusDetail);
        });
        
        return this;
    }
]);
