'use strict';

angularApp.controller('instaaDAnnualIncomeController', ["$state",
    "$scope",
    "instaService",
    "instaadDetailsCommonService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        instaService,
        instaadDetailsCommonService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instaaDAnnualIncomeVm = this;

        function initPage() {
            instaaDAnnualIncomeVm.showBack = true;
            instaaDAnnualIncomeVm.showNext = false;
            instaaDAnnualIncomeVm.aofooter = true;
            instaaDAnnualIncomeVm.loadAnnualIncome();
        }

        instaaDAnnualIncomeVm.getOccupation = function() {
            $state.go("menu.instaKit_aDOccupation");
        }

        instaaDAnnualIncomeVm.loadAnnualIncome = function(){
        	utilityService.showSpinner();
            instaaDAnnualIncomeVm.isErorr = false;
            var requestParam = "IncomeLotus";
            instaadDetailsCommonService.getAnnualIncome(requestParam).then(function(data) {
            	instaaDAnnualIncomeVm.isErorr = false;
            	utilityService.hideSpinner();
                instaaDAnnualIncomeVm.subAnnualIncome = data;
            }, function(error) {
            	instaaDAnnualIncomeVm.isErorr = true;
            	utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        instaaDAnnualIncomeVm.goBacktoPrevious = function() {
            $state.go("menu.instaKit_aDFamilyDetails");
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        instaaDAnnualIncomeVm.populateResumeData = function(){
            if(instaService.isResumeJourney == true){
                instaaDAnnualIncomeVm.activeStatus = instaService.getIdByValue(instaaDAnnualIncomeVm.subAnnualIncome, instaService.customerAdditionalDetails.annualIncome);
            }
        }

        instaaDAnnualIncomeVm.goToNextPage = function(param) {
            instaService.activeAdditionalDetails.income = param.value;
            instaService.customerAdditionalDetails.annualIncome = param.description;
            $state.go("menu.instaKit_aDOccupation");
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            instaaDAnnualIncomeVm.activeStatus = instaService.activeAdditionalDetails.income;
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            //instaaDAnnualIncomeVm.populateResumeData();
        });

        return this;
    }
]);
