'use strict';

angularApp.controller('instaaDFamilyDetailsController', ["$state",
    "$scope",
    "instaService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "instaadDetailsCommonService",
    "utilityService",
    "constantConfig",
    function($state,
        $scope,
        instaService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        instaadDetailsCommonService,
        utilityService,
        constantConfig) {

        var instaaDFamilyDetailsVm = this;

        function initPage() {
            instaaDFamilyDetailsVm.showBack = true;
            instaaDFamilyDetailsVm.showNext = true;
            instaaDFamilyDetailsVm.disableNext = true;
            instaaDFamilyDetailsVm.aofooter = true;
        }

        instaaDFamilyDetailsVm.goBacktoPrevious = function() {
            $state.go("menu.instaKit_aDMaritalStatus"); 
        }

        instaaDFamilyDetailsVm.goToNextPage = function() {
            instaService.customerAdditionalDetails.maidenName = instaaDFamilyDetailsVm.maidenName;
            instaService.customerAdditionalDetails.motherMaidenName = instaaDFamilyDetailsVm.motherMname;
            instaService.customerAdditionalDetails.spouseName = instaaDFamilyDetailsVm.spouseName;
            instaService.customerAdditionalDetails.fatherFirstName = instaaDFamilyDetailsVm.fatherFname;
            instaService.customerAdditionalDetails.fatherMiddleName = instaaDFamilyDetailsVm.fatherMname;
            instaService.customerAdditionalDetails.fatherLastName = instaaDFamilyDetailsVm.fatherLname;
            instaService.customerAdditionalDetails.fatherName = instaaDFamilyDetailsVm.fatherFname + '' + instaaDFamilyDetailsVm.fatherLname;
            instaService.customerAdditionalDetails.motherFirstname = instaaDFamilyDetailsVm.motherFname;
            instaService.customerAdditionalDetails.motherMiddlename = instaaDFamilyDetailsVm.motherMname;
            instaService.customerAdditionalDetails.motherLastname = instaaDFamilyDetailsVm.motherLname;
            instaService.customerAdditionalDetails.cityOfBirth = instaaDFamilyDetailsVm.city;
            instaService.customerAdditionalDetails.citizenshipDeclarationFlag = instaaDFamilyDetailsVm.citizenshipConsent;
                
                $state.go("menu.instaKit_aDOccupation");

        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        instaaDFamilyDetailsVm.changeFn = function(isValid) {
            instaaDFamilyDetailsVm.disableNext = !isValid;
        }

        instaaDFamilyDetailsVm.fatherTitleSelection = function(value){
            instaService.customerAdditionalDetails.fatherTitleCode = value;
            instaService.customerAdditionalDetails.fatherTitle = instaService.getValueById(instaaDFamilyDetailsVm.selectTitles, instaService.customerAdditionalDetails.fatherTitleCode);
        }

        instaaDFamilyDetailsVm.motherTitleSelection = function(value){
            instaService.customerAdditionalDetails.motherTitleCode = value;
            instaService.customerAdditionalDetails.motherTitle = instaService.getValueById(instaaDFamilyDetailsVm.selectTitles, instaService.customerAdditionalDetails.motherTitleCode);
        }

        //Load Title Dropdown
        instaaDFamilyDetailsVm.loadTitles = function(){
            var requestData = "TitleLotus";
            utilityService.showSpinner();
            instaaDFamilyDetailsVm.isErorr = false;
            instaadDetailsCommonService.loadTitle(requestData).then(function(response) {
            	utilityService.hideSpinner();
            	instaaDFamilyDetailsVm.isErorr = false;
                instaaDFamilyDetailsVm.selectTitles = response.data;
                instaaDFamilyDetailsVm.selectTitlesFather = angular.copy(response.data);
                instaaDFamilyDetailsVm.selectTitlesFather ? instaaDFamilyDetailsVm.selectTitlesFather.pop() : ''; 
                instaaDFamilyDetailsVm.selectTitlesFather ? instaaDFamilyDetailsVm.selectTitlesFather.pop() : ''; 
                instaaDFamilyDetailsVm.selectTitlesMother = angular.copy(response.data);
                instaaDFamilyDetailsVm.selectTitlesMother ? instaaDFamilyDetailsVm.selectTitlesMother.shift() : '';  
                instaaDFamilyDetailsVm.fatherTitleSelection(instaService.customerAdditionalDetails.fatherTitleCode);
                instaaDFamilyDetailsVm.motherTitleSelection(instaService.customerAdditionalDetails.motherTitleCode);             
            }, function(error) {
            	instaaDFamilyDetailsVm.isErorr = true;
            	utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        //Required check for Spouse name based on marital status
        instaaDFamilyDetailsVm.enterSpouseName = function(isValid) {
            var required = false;
            if (instaService.activeAdditionalDetails.marital === "M") {
                required = true;
            } else {
                instaaDFamilyDetailsVm.spouseName = "";
                required = false;
            }
            instaaDFamilyDetailsVm.disableNext = !isValid;
            return required;
        }

        //Enable/disable Spouse name based on marital status
        instaaDFamilyDetailsVm.disableSpouse = function() {
            var disable = true;
            if (instaService.activeAdditionalDetails.marital === "M") {
                disable = false;
            } else {
                instaaDFamilyDetailsVm.spouseName = "";
                disable = true;
            }
            return disable;
        }

        // If married and female - Maiden name is required 
        // Else Maiden name not required
        instaaDFamilyDetailsVm.maidenFn = function(){
            var disable = true;
            var titleAadhaar = instaService.customerAadhaarCardDetails.title.toLowerCase();
            var titleManual = instaService.customerManualEntryDetails.title.toLowerCase();
            if (titleAadhaar == "mrs" || titleManual == "mrs") {
                disable = false;
            } else {
                instaaDFamilyDetailsVm.maidenName = "";
                disable = true;
            }
            return disable;
        }
	   
        //Populate data in resume / Omnichannel
	    instaaDFamilyDetailsVm.populateResumeData = function(){
            instaaDFamilyDetailsVm.maidenName = instaService.customerAdditionalDetails.maidenName;
            instaaDFamilyDetailsVm.motherMname = instaService.customerAdditionalDetails.motherMaidenName;
            instaaDFamilyDetailsVm.spouseName = instaService.customerAdditionalDetails.spouseName;
            instaaDFamilyDetailsVm.fatherFname = instaService.customerAdditionalDetails.fatherFirstName;
            instaaDFamilyDetailsVm.fatherMname = instaService.customerAdditionalDetails.fatherMiddleName;
            instaaDFamilyDetailsVm.fatherLname = instaService.customerAdditionalDetails.fatherLastName;
            instaaDFamilyDetailsVm.motherFname = instaService.customerAdditionalDetails.motherFirstname;
            instaaDFamilyDetailsVm.motherMname = instaService.customerAdditionalDetails.motherMiddlename;
            instaaDFamilyDetailsVm.motherLname = instaService.customerAdditionalDetails.motherLastname;  
            instaaDFamilyDetailsVm.motherTitle = instaService.customerAdditionalDetails.motherTitleCode;
            instaaDFamilyDetailsVm.fatherTitle = instaService.customerAdditionalDetails.fatherTitleCode;
            instaaDFamilyDetailsVm.city = instaService.customerAdditionalDetails.cityOfBirth;
            instaaDFamilyDetailsVm.citizenshipConsent = instaService.customerAdditionalDetails.citizenshipDeclarationFlag;          
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            instaaDFamilyDetailsVm.journeyType = instaService.journeyType;
            instaaDFamilyDetailsVm.constantJourneyTypeVKYC = constantConfig.acOpeningAdapterOVDConstant.vkycInsta;
            instaaDFamilyDetailsVm.populateResumeData();
            instaaDFamilyDetailsVm.enterSpouseName();
            instaaDFamilyDetailsVm.disableSpouse();
            instaaDFamilyDetailsVm.loadTitles();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
