'use strict';

angularApp.controller('instaaDMaritalStatusController', ["$state",
    "$scope",
    "instaService",
    "instaadDetailsCommonService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        instaService,
        instaadDetailsCommonService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instaaDMaritalStatusVm = this;

        function initPage() {
            instaaDMaritalStatusVm.showBack = true;
            instaaDMaritalStatusVm.showNext = false;
            instaaDMaritalStatusVm.aofooter = true;
            instaaDMaritalStatusVm.loadMaritalStatus();
        }

        instaaDMaritalStatusVm.getFamilyInfo = function() {
            $state.go("menu.instaKit_aDFamilyDetails");
        }

        instaaDMaritalStatusVm.populateResumeData = function(){
            if(instaService.isResumeJourney == true){
                instaaDMaritalStatusVm.activeStatus = instaService.getIdByValue(instaService.maritalStatusList, instaService.customerAdditionalDetails.maritalStatus);
            }
        }

        instaaDMaritalStatusVm.loadMaritalStatus = function(){
            var requestParam = "MaritalLotus";
            instaaDMaritalStatusVm.isErorr = false;
            utilityService.showSpinner();
            instaadDetailsCommonService.getMaritalStatus(requestParam).then(function(data) {          
                instaaDMaritalStatusVm.isErorr = false;
                utilityService.hideSpinner();
                instaService.maritalStatusList = data;
                instaaDMaritalStatusVm.maritalStatusList = instaService.maritalStatusList;
            }, function(error) {
            	utilityService.hideSpinner();
            	instaaDMaritalStatusVm.isErorr = true;
                utilityService.showErrorMessage(error.responseMessage);
            });
        };

        instaaDMaritalStatusVm.goBacktoPrevious = function() {
            $state.go("menu.instaKit_additionalDetails");
        }

        instaaDMaritalStatusVm.goToNextPage = function(param) {
            instaService.activeAdditionalDetails.marital = param.value;
            instaService.customerAdditionalDetails.maritalStatus = param.description;
            $state.go("menu.instaKit_aDFamilyDetails"); 
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            instaaDMaritalStatusVm.activeStatus = instaService.activeAdditionalDetails.marital;
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            //instaaDMaritalStatusVm.populateResumeData();
        });

        return this;
    }
]);
