'use strict';

angularApp.controller('instaaDReligionController', ["$state",
    "$scope",
    "instaService",
    "instaadDetailsCommonService",
    "utilityService",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        instaService,
        instaadDetailsCommonService,
        utilityService,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instaaDReligionVm = this;

        function initPage() {
            instaaDReligionVm.showBack = true;
            instaaDReligionVm.showNext = false;
            instaaDReligionVm.aofooter = true;
            instaaDReligionVm.religionList = [{ "value": "H", "description": "Hindu" },
                { "value": "C", "description": "Christian" },
                { "value": "M", "description": "Muslim" },
                { "value": "S", "description": "Sikh" },
                { "value": "O", "description": "Others" }
            ];
            instaaDReligionVm.loadCategory();
        }

        instaaDReligionVm.loadCategory = function(){
			instaaDReligionVm.isErorr = false;
			utilityService.showSpinner();
            var requestParam = "Category";
            instaadDetailsCommonService.getOccupation(requestParam).then(function(data) {                
                instaaDReligionVm.isErorr = false;
				utilityService.hideSpinner();
				instaaDReligionVm.categoryList = data;
               
                instaaDReligionVm.activeStatusCat = instaService.getIdByValue(instaaDReligionVm.categoryList, instaService.customerAdditionalDetails.category);
            }, function(error) {
				utilityService.hideSpinner();
				instaaDReligionVm.isErorr = true;
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        instaaDReligionVm.goBacktoPrevious = function() {
            instaService.customerAdditionalDetails.showNext = true;
            if(!utilityService.isUndefined(instaService.customerAdditionalDetails.subOccupation)){
                $state.go("menu.instakit_annualIncomeNew"); 
            }
            else{
                 $state.go("menu.instaKit_aDOccupation");
            }
        }


        instaaDReligionVm.goToNextPage = function() {
            instaaDReligionVm.updateAdditionalDetailsCall();
        }

        instaaDReligionVm.goBacktoPreviousReligion = function(){
            $state.go('menu.instaKit_aDReligion');
        }
        //If Religion is selected, get religion data and navigate
        instaaDReligionVm.goToNextPageReligion = function(param) {
            instaService.activeAdditionalDetails.religion = param.value;
            instaService.customerAdditionalDetails.religion = param.description;
            $state.go('menu.instaKit_aDCategory');
            //instaaDReligionVm.updateAdditionalDetailsCall();
        }

         //If Category is selected, get category data and navigate
         instaaDReligionVm.goToNextPageCategory = function(param) {
            instaService.activeAdditionalDetails.category = param.value;
            instaService.customerAdditionalDetails.category = param.description;
            instaaDReligionVm.updateAdditionalDetailsCall();
        }

        instaaDReligionVm.populateResumeData = function(){
            
                instaaDReligionVm.activeStatus = instaService.getIdByValue(instaaDReligionVm.religionList, instaService.customerAdditionalDetails.religion);
               
            
        }

        //Service to update additional detail
        instaaDReligionVm.updateAdditionalDetailsCall = function() {
            var requestParams = {
                "id": instaService.customer.mobileNo,
                "data":{
                    "additionalDetails":{
                        "maidenName": instaService.customerAdditionalDetails.maidenName,
                        "fatherName": instaService.customerAdditionalDetails.fatherName,
                        "fatherFirstName": instaService.customerAdditionalDetails.fatherFirstName,
                        "fatherMiddleName":instaService.customerAdditionalDetails.fatherMiddleName,
                        "fatherLastName":instaService.customerAdditionalDetails.fatherLastName,
                        "spouseName": instaService.customerAdditionalDetails.spouseName,
                        "motherMaidenName": instaService.customerAdditionalDetails.motherMaidenName,
                        "maritalStatus": instaService.customerAdditionalDetails.maritalStatus,
                        "maritalStatusCode":instaService.activeAdditionalDetails.marital,
                        "annualIncome": instaService.customerAdditionalDetails.annualIncome,
                        "annualIncomeCode":instaService.activeAdditionalDetails.income,
                        "religion": instaService.customerAdditionalDetails.religion,
                        "religionCode":instaService.activeAdditionalDetails.religion,
                        "annualIncomeValue":instaService.customerAdditionalDetails.annualIncomeValue,
                        "education": instaService.customerAdditionalDetails.education,
                        "educationCode":instaService.activeAdditionalDetails.education,
                        "occupation": instaService.customerAdditionalDetails.occupation,
                        "occupationCode":instaService.activeAdditionalDetails.occupation,
                        "subOccupation": instaService.customerAdditionalDetails.subOccupation,
                        "subOccupationCode":instaService.activeAdditionalDetails.suboccupation,
                        "thresoldLimitAmount" : '3500000',
                        "currentCountry" : 'IN',
                        "motherFirstName":instaService.customerAdditionalDetails.motherFirstname,
                        "motherMiddleName":instaService.customerAdditionalDetails.motherMiddlename,
                        "motherLastName":instaService.customerAdditionalDetails.motherLastname,
                        "motherTitle":instaService.customerAdditionalDetails.motherTitle,
                        "motherTitleCode":instaService.customerAdditionalDetails.motherTitleCode, 
                        "fatherTitle":instaService.customerAdditionalDetails.fatherTitle,
                        "fatherTitleCode":instaService.customerAdditionalDetails.fatherTitleCode,
                        "cityOfBirth": instaService.customerAdditionalDetails.cityOfBirth,
                        "category":instaService.customerAdditionalDetails.category,
                        "categoryCode":instaService.activeAdditionalDetails.category
                    },
                "vkyc": {
                        "citizenshipDeclarationFlag": instaService.customerAdditionalDetails.citizenshipDeclarationFlag
                    },
                    "commonId":$state.$current.data.commonId
                }             
            }
            instaadDetailsCommonService.updateAdditionalDetails(requestParams).then(function(response) {
                var responseCode = response.responseCode;
                if (responseCode === constantConfig.successCode) {
                    // $state.go("menu.instaKit_nomineeDetails");
                    
                    $state.go('menu.instaKit_nominationRelated');
                }
                
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            //instaaDReligionVm.activeStatus = instaService.activeAdditionalDetails.religion;
            instaaDReligionVm.journeyType = instaService.journeyType;
            instaaDReligionVm.constantJourneyTypeVKYC = constantConfig.acOpeningAdapterOVDConstant.vkycInsta;
            instaaDReligionVm.populateResumeData();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            instaaDReligionVm.loadCategory();
        });


        return this;
    }
]);
