'use strict';

angularApp.controller('instaaDSubOccupationController', ["$state",
    "$scope",
    "instaService",
    "instaadDetailsCommonService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        instaService,
        instaadDetailsCommonService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instaaDSubOccupationVm = this;

        function initPage() {
            instaaDSubOccupationVm.showBackService = true;
            instaaDSubOccupationVm.showNextService = false;
            instaaDSubOccupationVm.showBackOthers = true;
            instaaDSubOccupationVm.showNextOthers = false;
            instaaDSubOccupationVm.aofooter = true;
            instaaDSubOccupationVm.loadSubOccupationService();
            instaaDSubOccupationVm.loadSubOccupationOthers();
            instaaDSubOccupationVm.loadSubOccupationBusiness();
            instaaDSubOccupationVm.mainOccupationLabel = instaService.customerAdditionalDetails.occupation;
        }

        instaaDSubOccupationVm.goBacktoPrevious = function() {
            $state.go("menu.instaKit_aDOccupation");
        }

        instaaDSubOccupationVm.goToNextPage = function(param) {
            instaService.activeAdditionalDetails.suboccupation = param.value;
            instaService.customerAdditionalDetails.subOccupation = param.description;
            //$state.go("menu.instaKit_aDReligion");
            instaService.customerAdditionalDetails.showNext = true;
            $state.go("menu.instakit_annualIncomeNew");
        }

        instaaDSubOccupationVm.populateResumeData = function(){
            if(instaService.isResumeJourney == true){
                if(instaService.activeAdditionalDetails.occupation == "0001"){
                    instaaDSubOccupationVm.activeStatus = instaService.getIdByValue(instaaDSubOccupationVm.serviceOccupationList, instaService.customerAdditionalDetails.subOccupation);
                }
                else{
                    instaaDSubOccupationVm.activeStatus = instaService.getIdByValue(instaaDSubOccupationVm.othersOccupationList, instaService.customerAdditionalDetails.subOccupation);
                }
                
            }
        }

        instaaDSubOccupationVm.loadSubOccupationService = function(){
			instaaDSubOccupationVm.isErorr = false;
			utilityService.showSpinner();
            var requestParam = "OccupationLotusService";
            instaadDetailsCommonService.getOccupation(requestParam).then(function(data) {
				instaaDSubOccupationVm.isErorr = false;
				utilityService.hideSpinner();		
                instaaDSubOccupationVm.serviceOccupationList = data;
            }, function(error) {
				instaaDSubOccupationVm.isErorr = true;
				utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        instaaDSubOccupationVm.loadSubOccupationOthers = function(){
			instaaDSubOccupationVm.isErorr = false;
			utilityService.showSpinner();
            var requestParam = "OccupationLotusOthers";
            instaadDetailsCommonService.getOccupation(requestParam).then(function(data) { 
				instaaDSubOccupationVm.isErorr = false;
				utilityService.hideSpinner();		
                instaaDSubOccupationVm.othersOccupationList = data;
            }, function(error) {
				instaaDSubOccupationVm.isErorr = true;
				utilityService.hideSpinner();	
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        instaaDSubOccupationVm.loadSubOccupationBusiness = function(){
			instaaDSubOccupationVm.isErorr = false;
			utilityService.showSpinner();
            var requestParam = "OccupationLotusBusiness";
            instaadDetailsCommonService.getOccupation(requestParam).then(function(data) { 
				instaaDSubOccupationVm.isErorr = false;
				utilityService.hideSpinner();		
                instaaDSubOccupationVm.businessOccupationList = data;
            }, function(error) {
				instaaDSubOccupationVm.isErorr = true;
				utilityService.hideSpinner();	
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            if(instaService.activeAdditionalDetails.occupation == "0001"){
                instaaDSubOccupationVm.activeStatusService = instaService.activeAdditionalDetails.suboccupation;
            }
            else if(instaService.activeAdditionalDetails.occupation == "0002"){
                instaaDSubOccupationVm.activeStatusOthers = instaService.activeAdditionalDetails.suboccupation;
            }
            else if(instaService.activeAdditionalDetails.occupation == "0303"){
                instaaDSubOccupationVm.activeStatusBusiness = instaService.activeAdditionalDetails.suboccupation;
            }
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            //instaaDSubOccupationVm.populateResumeData();
        });

        return this;
    }
]);
