'use strict';

angularApp.service('instaadDetailsCommonService',
    function($q, AdapterUtils, constantConfig) {
        var instaadDetailsCommonService = this;
        instaadDetailsCommonService.updateAdditionalDetails = function(requestData) {
            var q = $q.defer();

            //Service to update all the additional details of the customer
            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.updateAdditionalDetail, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };

        instaadDetailsCommonService.getAnnualIncome = function(param) {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.loadMasterData + param, true).then(

                function(response) {
                    q.resolve(response.data);                    
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        
        instaadDetailsCommonService.getQualification = function(param) {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.loadMasterData + param, true).then(

                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        instaadDetailsCommonService.getMaritalStatus = function(param) {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.loadMasterData + param, true).then(

                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        instaadDetailsCommonService.getOccupation = function(param) {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.loadMasterData + param, true).then(

                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        instaadDetailsCommonService.loadTitle = function(param) {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.loadMasterData + param, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };



        return instaadDetailsCommonService;
    });
