'use strict';

angularApp.controller('instaKit_optionalAdditionalDetailsController', ["$state",
    "$scope",
    "$translate",
    "instaService",
    "utilityService",
    "instaaDCityCountryService",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "$ionicPopover",
    "instaadDetailsCommonService",

    function($state,
        $scope,
        $translate,
        instaService,
        utilityService,
        instaaDCityCountryService,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService,
        $ionicPopover,
        instaadDetailsCommonService) {

        var optionalAdditionalDetailsVm = this;

        function initPage() {
            optionalAdditionalDetailsVm.showBack = true;
            optionalAdditionalDetailsVm.showNext = true;
            optionalAdditionalDetailsVm.disableNext = true;
            optionalAdditionalDetailsVm.aofooter = true;

            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                optionalAdditionalDetailsVm.okBtntext = translatedvalue;
            });
        }


        optionalAdditionalDetailsVm.goBacktoPrevious = function() {
            $state.go("menu.instaKit_aDReligion");
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        optionalAdditionalDetailsVm.selectedCategory = function () {

            optionalAdditionalDetailsVm.categoryText = utilityService.getTextFromDropdown("categoryCode", optionalAdditionalDetailsVm.category, optionalAdditionalDetailsVm.categoryList, "categoryName");

        }

        optionalAdditionalDetailsVm.selectedPwd = function () {

            optionalAdditionalDetailsVm.instaPwdText = utilityService.getTextFromDropdown("pwdCode", optionalAdditionalDetailsVm.instaPwd, optionalAdditionalDetailsVm.pwdList, "pwdName");

        }

        optionalAdditionalDetailsVm.goToNextPage = function() {
            // $state.go('menu.instaKit_nominationRelated');
            instaService.optionalAdditionalDetails = {};
            instaService.optionalAdditionalDetails.categoryText = optionalAdditionalDetailsVm.categoryText;
            instaService.optionalAdditionalDetails.categoryCode = optionalAdditionalDetailsVm.categoryCode;
            instaService.optionalAdditionalDetails.numberOfDependents = optionalAdditionalDetailsVm.nod;
            instaService.optionalAdditionalDetails.netWorth = optionalAdditionalDetailsVm.netWorth;
            instaService.optionalAdditionalDetails.organisationName = optionalAdditionalDetailsVm.organisationName;
            instaService.optionalAdditionalDetails.designation = optionalAdditionalDetailsVm.designation;
            instaService.optionalAdditionalDetails.natureOfBuisness = optionalAdditionalDetailsVm.nob;
            instaService.optionalAdditionalDetails.personalDisability = optionalAdditionalDetailsVm.instaPwdText;
            instaService.optionalAdditionalDetails.perosonalDisabiltyCode = optionalAdditionalDetailsVm.instaPwd;
            instaService.optionalAdditionalDetails.alternateMobileNo = optionalAdditionalDetailsVm.alternateMob;
            instaService.optionalAdditionalDetails.residentialTelePhone = optionalAdditionalDetailsVm.telNo;
            instaService.optionalAdditionalDetails.officeTelePhone = optionalAdditionalDetailsVm.telNoOfc;


            var requestParams =  {
                "id": instaService.customer.mobileNo,
                "data": {
                  "vkyc": {
                    "category": optionalAdditionalDetailsVm.categoryText,
                    "categoryCode": optionalAdditionalDetailsVm.category,
                    "numberOfDependents": optionalAdditionalDetailsVm.nod,
                    "netWorth": optionalAdditionalDetailsVm.netWorth,
                    "organisationName": optionalAdditionalDetailsVm.organisationName,
                    "designation": optionalAdditionalDetailsVm.designation,
                    "natureOfBuisness": optionalAdditionalDetailsVm.nob,
                    "personalDisability": optionalAdditionalDetailsVm.instaPwdText,
                    "perosonalDisabiltyCode": optionalAdditionalDetailsVm.instaPwd,
                    "alternateMobileNo": optionalAdditionalDetailsVm.alternateMob,
                    "residentialTelePhone": optionalAdditionalDetailsVm.telNo,
                    "officeTelePhone": optionalAdditionalDetailsVm.telNoOfc
                  },
                  "commonId": $state.$current.data.commonId
                }
              }
              instaadDetailsCommonService.updateAdditionalDetails(requestParams).then(function(response) {
                if (response.responseCode === constantConfig.successCode) {
                    $state.go('menu.instaKit_nominationRelated');
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

        }


        optionalAdditionalDetailsVm.validateForm = function(isValid) {
            if (isValid === true && optionalAdditionalDetailsVm.citizenshipConsent) {
                optionalAdditionalDetailsVm.disableNext = false;
            } else {
                optionalAdditionalDetailsVm.disableNext = true;
            }
        }



        optionalAdditionalDetailsVm.populateResumeData = function() {
            if (instaService.isResumeJourney == true) {
                optionalAdditionalDetailsVm.categoryText = instaService.optionalAdditionalDetails.categoryText;
                optionalAdditionalDetailsVm.category = instaService.optionalAdditionalDetails.categoryCode;
                optionalAdditionalDetailsVm.nod = instaService.optionalAdditionalDetails.numberOfDependents;
                optionalAdditionalDetailsVm.netWorth = instaService.optionalAdditionalDetails.netWorth;
                optionalAdditionalDetailsVm.organisationName = instaService.optionalAdditionalDetails.organisationName;
                optionalAdditionalDetailsVm.designation = instaService.optionalAdditionalDetails.designation;
                optionalAdditionalDetailsVm.nob = instaService.optionalAdditionalDetails.natureOfBuisness;
                optionalAdditionalDetailsVm.instaPwdText = instaService.optionalAdditionalDetails.personalDisability;
                optionalAdditionalDetailsVm.instaPwd = instaService.optionalAdditionalDetails.perosonalDisabiltyCode;
                optionalAdditionalDetailsVm.alternateMob = instaService.optionalAdditionalDetails.alternateMobileNo;
                optionalAdditionalDetailsVm.telNo = instaService.optionalAdditionalDetails.residentialTelePhone;
                optionalAdditionalDetailsVm.telNoOfc = instaService.optionalAdditionalDetails.officeTelePhone;       
            }
        }



        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {

            optionalAdditionalDetailsVm.categoryList = [{"categoryCode":"1","categoryName":"abc"},{"categoryCode":"2","categoryName":"xyz"},{"categoryCode":"3","categoryName":"wxy"}];

            optionalAdditionalDetailsVm.pwdList = [{"pwdCode":"1","pwdName":"abc"},{"pwdCode":"2","pwdName":"xyz"},{"pwdCode":"3","pwdName":"wxy"}];

            optionalAdditionalDetailsVm.populateResumeData();

            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
