'use strict';

angularApp.controller('aoLandingController', ["$state",
    "$scope",
    "instaService",
    "$timeout",
    "$ionicScrollDelegate",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "aolandingService",
    "utilityService",
	"appPasswordService",
	"encryptionService",
	"aoService",
	"$translate",
    function($state,
        $scope,
        instaService,
        $timeout,
        $ionicScrollDelegate,
        $ionicSideMenuDelegate,
        mPinLoginService,
        aolandingService,
        utilityService,
        appPasswordService,
        encryptionService,
		aoService,
		$translate) { 

        var aoLandingVm = this;

        function initPage() {
            aoLandingVm.showBack = false;
            aoLandingVm.showNext = true;
            aoLandingVm.disableNext = true;
            aoLandingVm.aofooter = true;

             aoLandingVm.scrolllist = [
                { "title": "Digital Savings Account", "description": "Digital" },
                { "title": "Insta Account", "description": "Insta" }
            ];
            aoLandingVm.featuresJson = [{feature:"Personalized debit platinum card"},
                                                {feature:"Paperless account opening."},
                                                {feature:"No minimum balance requirement."},
                                                {feature:"Personalised Platinum Debit Card."},
                                                {feature:"Free personal accident insurance cover."}];
           aoLandingVm.loadDigitalFeature();
           aoLandingVm.loadInstaFeature();
           if(aoService.isJThirtyStarted){
           		aoLandingVm.isJThirty= true;	
           }else{
           		aoLandingVm.isJThirty = false
           }
           
        }      

        $scope.goToHome = function() {
            instaService.homeNav(aoLandingVm.isJThirty);
        }

         aoLandingVm.openAccount = function(type){
			if(aoService.isJThirtyStarted){
				 $state.go("menu.panAuthorise");
				 if(type=="Insta"){
				 	   aoService.isJThirtyData.upgradeAccType = "regular";
						}if(type=="Digital"){
			           		aoService.isJThirtyData.upgradeAccType  = "digital";
						}
				 return true;
			}
			if(type=="Insta"){
            	$state.go('menu.instaKit_applyNewOrResume');
			}else if(type=="Digital"){
                   // $state.go("menu.applyNewOrResume");
                   $state.go("menu.homePageAO");
			}
        }
	        
		aoLandingVm.loadDigitalFeature = function() {
	
			if (!aoService.isJThirtyStarted) {
				aolandingService.getFeatureComparison().then(function(data) {
					aoLandingVm.digitalfeaturesJson = data.digital;
					instaService.setFeature(data.policyWording);
				}, function(error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			} else {
				aolandingService.getFeatureComparisonJThirty().then(function(data) {
					aoLandingVm.digitalfeaturesJson = data;
				}, function(error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}
		}

        aoLandingVm.loadInstaFeature = function(){
        	if (!aoService.isJThirtyStarted) {
            aolandingService.getFeatureComparisonInsta().then(function(data) {
                aoLandingVm.instafeaturesJson = data;
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
            }else{
            	aolandingService.getFeatureComparisonInstaJThirty().then(function(data) {
                aoLandingVm.instafeaturesJson = data;
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
            }
        }
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            
            appPasswordService.loadSecurityQuestions().then(function(response) {
                instaService.setSecurityQuestion  = response.data.masterDetails;
            }, function(error) {
				
            });
             if (sessionStorage) {
			        sessionStorage.setItem('passphrase', encryptionService.passphrase);	
			    }
				aoService.isPreJTSixStarted = false;  
				aoService.preJTSixdata.maxCIFEntered = 0;  
        });

        return this;
    }
]);
