'use strict';

angularApp.service('aolandingService',
    function($q, AdapterUtils, constantConfig) {
        var aolandingService = this;
		
		aolandingService.getFeatureComparison = function() {
			var q = $q.defer();
			AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.getFeatureComparison, true).then(function(response) {
				q.resolve(response.data);
			}, function(error) {
				q.reject(error);
			});
			return q.promise;
		};
	
		aolandingService.getFeatureComparisonJThirty = function() {
			var q = $q.defer();
			AdapterUtils.postData(constantConfig.jTSixOpeningAdapterUrl.getFeatureComparisonJThirty, {}, true).then(function(response) {
				q.resolve(response.data.digitalSavingsAccountContent);
			}, function(error) {
				q.reject(error);
			});
			return q.promise;
		};
		aolandingService.getFeatureComparisonInsta = function(isJThirty) {
			var q = $q.defer();
	
			AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.getFeatureComparisonInsta, true).then(function(response) {
				q.resolve(response.data.insta);
			}, function(error) {
				q.reject(error);
			});
			return q.promise;
	
		};
		aolandingService.getFeatureComparisonInstaJThirty = function(isJThirty) {
			var q = $q.defer();
				
			AdapterUtils.postData(constantConfig.jTSixOpeningAdapterUrl.getRegularSavingsAccountFeaturesJThirty, {}, true).then(function(response) {
				q.resolve(response.data.regularSavingsAccountContent);
			}, function(error) {
				q.reject(error);
			});
			return q.promise;
	
		};


        return aolandingService;
    });
