'use strict';

angularApp.controller('instaappPasswordController', ["$state",
    "$scope",
    "instaService",
    "utilityService",
    "instaappPasswordService",
    "$ionicPopover",
    "$cordovaDevice",
    "cryptoService",
    "encryptionService",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "$ionicPopup",

    function($state,
        $scope,
        instaService,
        utilityService,
        instaappPasswordService,
        $ionicPopover,
        $cordovaDevice,
        cryptoService,
        encryptionService,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService,
        $ionicPopup) {

        var instaappPasswordVm = this;

        function initPage() {
            instaappPasswordVm.showBack = false;
            instaappPasswordVm.showNext = true;
            instaappPasswordVm.reAppPasswordCheck = false;
            instaappPasswordVm.disableNext = true;
            instaappPasswordVm.aofooter = true;
            //To get the device Operating system
            var deviceOs = $cordovaDevice.getPlatform();
            var deviceUid = $cordovaDevice.getUUID();
            instaService.customer.deviceOS = deviceOs;
            instaService.customer.deviceUid = deviceUid;
            instaappPasswordVm.encoded = '';
            instaappPasswordVm.securityQuestions = [];
            instaappPasswordVm.loadSecurityQuestion();
        }

        /* Info Popup */
        var template = '<ion-popover-view class="ao-tooltip ao-popupInfo roboto-regular ao-passwordHt">' + '<ion-content>' +
                        '<div class="" translate="APP_NOTIFICATION"></div>' + '</ion-content>' + '</ion-popover-view>';

        $scope.popover = $ionicPopover.fromTemplate(template, {
            scope: $scope
        });

        instaappPasswordVm.infoPopup = function($event) {
            $scope.popover.show($event);
        };

        instaappPasswordVm.closePopover = function() {
            $scope.popover.hide();
        };
       /* Info Popup */

        instaappPasswordVm.goBacktoPrevious = function() {
            $state.go('menu.instaKit_getOTP');
        }

        instaappPasswordVm.goToNextPage = function() {
            //var hashedAppPassword = cryptoService.getSHA512EncryptedData(instaappPasswordVm.appPasswordData);
            //instaappPasswordVm.encoded = encryptionService.getAES256EncryptedData(hashedAppPassword);
            instaappPasswordVm.encoded = instaappPasswordVm.appPasswordData;
            instaService.appPassword = instaappPasswordVm.encoded;
            instaappPasswordVm.literateFlag =  instaService.literateFlag;
            instaappPasswordVm.employerNotListed = instaService.employerNotListed;
            var requestParams = {
                "id": instaService.customer.mobileNo,
		"commonId":$state.$current.data.commonId,
                "type":"AO_INSTA",
                "data": {
                    "secQ":instaappPasswordVm.selectedSecQuestion,
                    "secA":instaappPasswordVm.secAnswer,
                    "literateFlag": instaappPasswordVm.literateFlag,
                    "employerNotListed": instaappPasswordVm.employerNotListed,
                    "auth" : {
                        "password" :instaappPasswordVm.encoded
                    },
                    "journeyType": instaService.journeyType,
                    "deviceInfo": {
                        "deviceIMEI" : instaService.customer.deviceUid,
                        "deviceOS" : instaService.customer.deviceOS
                    },
                    "personalDetails": {
                        "emailId" : instaService.customer.emailId,
                        "mobileNumber" : instaService.customer.mobileNo
                    }
                }
            }
            instaappPasswordService.registerCustomer(requestParams).then(function(response) {
                instaService.customer.lotusId = utilityService.getValue(response.data.lotusId);
                var responseCode = response.responseCode;
                if (responseCode === constantConfig.successCode) {

                    var alertParams = {
                        icon : false,
                        message : "{{'APP_COMPLETE_ALERT'| translate}}",
                        buttonText : "",
                        redirectUrl : "menu.instaKit_tax"
                    } 
                    utilityService.customAlertPopup(alertParams);

                    
                }

            }, function(error) {
               utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        instaappPasswordVm.changePassword = function() {
            if (instaappPasswordVm.reAppPasswordData !== instaappPasswordVm.appPasswordData) {
                instaappPasswordVm.reAppPasswordData = "";
                instaappPasswordVm.reAppPasswordCheck = true; 
                instaappPasswordVm.disableNext = true;
                return true;
            }
            instaappPasswordVm.reAppPasswordCheck = false;
            return true;
        }

        instaappPasswordVm.loadSecurityQuestion = function(){
        	if(instaService.setSecurityQuestion.length == 0){
        	utilityService.showSpinner();
        	instaappPasswordVm.isErorr = false;
            instaappPasswordService.loadSecurityQuestions().then(function(response) {
            	utilityService.hideSpinner();
               instaappPasswordVm.isErorr = false;
                instaappPasswordVm.securityQuestions = response.data.masterDetails;
                
            }, function(error) { 
            	utilityService.hideSpinner();
               instaappPasswordVm.isErorr = true;
               utilityService.showErrorMessage(error.responseMessage);
            });
            }else{
            	instaappPasswordVm.securityQuestions = instaService.setSecurityQuestion;
            }
        };

        instaappPasswordVm.changeCPassword = function() {
            if (instaappPasswordVm.reAppPasswordData !== instaappPasswordVm.appPasswordData) {
                instaappPasswordVm.reAppPasswordCheck = false;
            }
            return true;
        }

        instaappPasswordVm.proceedSuccess = function(isValid) {
            isValid ? instaappPasswordVm.disableNext = false : instaappPasswordVm.disableNext = true;
            return instaappPasswordVm.disableNext;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
