'use strict';

angularApp.controller('instabranchDetailsController', ["$state",
    "$scope",
    "instabranchDetailsService",
    "instaService",
    "$translate",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        instabranchDetailsService,
        instaService,
        $translate,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instabranchDetailsVm = this;

        function initPage() {
            instabranchDetailsVm.showBack = true;
            //instabranchDetailsVm.loadInTouchBranchDetails();
            instabranchDetailsVm.showLink = true;
            instabranchDetailsVm.showRadioBtn = false;
            instabranchDetailsVm.aofooter = true;
            instabranchDetailsVm.selectBranches = [];
            instabranchDetailsVm.loadInTouchCities();
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                instabranchDetailsVm.okBtntext = translatedvalue;  
            });   
        }

        instabranchDetailsVm.goBacktoPrevious = function() {
            $state.go('menu.instaKit_debitCardDetails');
        }

        instabranchDetailsVm.goToNextPage = function(param) {
            instaService.direction.latitude = param.latitude;
            instaService.direction.longitude = param.longitude;
            instaService.direction.branchname = param.branchName;
            instaService.direction.address = param.address +"<br/>"+ param.city +'-' + param.pincode +"<br/>"+ param.state;
           // $state.go('menu.direction');      
            var geocoords = instaService.direction.latitude + ',' + instaService.direction.longitude;
            if(utilityService.isUndefined(instaService.direction.latitude) || utilityService.isUndefined(instaService.direction.longitude)){
                var title = '';
                var template = '{{"NO_DIR" | translate}}';
                var onTap = 'menu.instaKit_branchDetails';
                var buttontext = '<b>' + instabranchDetailsVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            }
            else{
                if (utilityService.isIOSPlatform()) {
                  window.open('maps://?q=' + geocoords, '_system');
                }
                else {
                  var label = encodeURI('Your Destination'); // encode the label!
                  window.open('geo:0,0?q=' + geocoords + '(' + label + ')', '_system');
                }  
            }
                              
        }
	
        $scope.goToHome = function() {
            instaService.homeNav();
        }
	
        instabranchDetailsVm.loadInTouchBranchDetails = function() {
            //Service to get InTouch branch by city
            var params = {
                "city": instabranchDetailsVm.selectedName
            }
            instabranchDetailsService.loadBranchDetails(params).then(function(response) {
                instabranchDetailsVm.bankList = response.data.branches;
            }, function(error) {
              utilityService.showErrorMessage(error.responseMessage);
            });
        }

        instabranchDetailsVm.loadInTouchCities = function() {
            instabranchDetailsService.getCities().then(function(body) {
                if(!utilityService.isUndefined(body)){
                    for (var i = 0; i < body.length; i++) {
                        instabranchDetailsVm.selectBranches.push(body[i]);
                        instabranchDetailsVm.selectBranches.sort();
                    }
                }                
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
