'use strict';

angularApp.controller('instadebitCardDetailsController', ["$state",
    "$scope",
    "instaService",
    "utilityService",
    "instadebitCardDetailsService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "$translate",
    "instaenterOTPReferenceCodeService",
    "constantConfig",

    function ($state,
        $scope,
        instaService,
        utilityService,
        instadebitCardDetailsService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        $translate,
        instaenterOTPReferenceCodeService,
        constantConfig) {

        var instadebitCardDetailsVm = this;

        function initPage() {
            instadebitCardDetailsVm.showBack = true;
            instadebitCardDetailsVm.showNext = true;
            instadebitCardDetailsVm.disableNext = true;
            instadebitCardDetailsVm.aofooter = true;
            instadebitCardDetailsVm.selectedMethod = "";
            instadebitCardDetailsVm.getcardInfoContent();
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                instadebitCardDetailsVm.okBtntext = translatedvalue;
            });
        };

        instadebitCardDetailsVm.goBacktoPrevious = function () {
            $state.go('menu.instaKit_termsAndConditions');
        }

        instadebitCardDetailsVm.goToNextPage = function () {
            instaService.debitCardDetails.firstName = instadebitCardDetailsVm.fatherFname;
            instaService.debitCardDetails.lastName = "";
            instadebitCardDetailsVm.receiveDebitCardDetails();
        }

        $scope.goToHome = function () {
            instaService.homeNav();
        }

        instadebitCardDetailsVm.validateForm = function (isValid) {
            instadebitCardDetailsVm.disableNext = !isValid;
        }

        instadebitCardDetailsVm.openInstaAcc = function () {
            var requestParams = {
                "mobileNumber": instaService.customer.mobileNo,
                "commonId": $state.$current.data.commonId
            }
            instadebitCardDetailsService.openInstaAccount(requestParams).then(function (response) {

                if (!utilityService.isUndefined(response.data)) {
                    if (!utilityService.isUndefined(response.data.nightMode)) {
                        instaenterOTPReferenceCodeService.setNightmodeFlag(true);
                        $state.go('menu.instaKit_enterOTPReferenceCode');
                    }
                    else {
                        instaenterOTPReferenceCodeService.setNightmodeFlag(false);
                        $state.go('menu.instaKit_enterOTPReferenceCode');
                    }
                }
                else {
                    var title = '';
                    var template = response.responseMessage;
                    var onTap = 'menu.instaKit_debitCardDetails';
                    var buttontext = '<b>' + instadebitCardDetailsVm.okBtntext + '</b>';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                }
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        instadebitCardDetailsVm.generateVKYCToken = function () {
            var requestParams = {
                "mobileNumber": instaService.customer.mobileNo,
                "commonId": $state.$current.data.commonId
            }
            instadebitCardDetailsService.generateVKYCToken(requestParams).then(function (response) {

                if (!utilityService.isUndefined(response.data)) {
                    instaService.tokenNumber = response.data.refNo;
                        $state.go('menu.instaKit_enterOTPReferenceCode');
                }
                else {
                    var title = '';
                    var template = response.responseMessage;
                    var onTap = 'menu.instaKit_debitCardDetails';
                    var buttontext = '<b>' + instadebitCardDetailsVm.okBtntext + '</b>';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                }
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        instadebitCardDetailsVm.receiveDebitCardDetails = function () {
            var requestParams = {
                "id": instaService.customer.mobileNo,
                "data": {
                    "cardReadyForCollection": "",
                    "debitCardFirstName": instadebitCardDetailsVm.fatherFname,
                    "debitCardLastName": ""
                }
            }
            instadebitCardDetailsService.receiveDebitCard(requestParams).then(function (response) {
                if (instadebitCardDetailsVm.journeyType != instadebitCardDetailsVm.constantJourneyTypeVKYC) {
                    instadebitCardDetailsVm.openInstaAcc();
                } else {
                    instadebitCardDetailsVm.generateVKYCToken();
                }
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        instadebitCardDetailsVm.getcardInfoContent = function () {
            instadebitCardDetailsService.getInfoCardDelivery().then(function (data) {
                instadebitCardDetailsVm.cardInfo = data;
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        instadebitCardDetailsVm.generateEKYC = function () {
            instadebitCardDetailsService.genterateEkyc().then(function () {
            }, function (error) {

            });
        }

        instadebitCardDetailsVm.updateName = function () {
            if (instaService.isResumeJourney == false) {
                if (!utilityService.isUndefined(instaService.customerManualEntryDetails.firstName)) {
                    instadebitCardDetailsVm.fatherFname = instaService.customerManualEntryDetails.firstName + " " + instaService.customerManualEntryDetails.lastName;

                } else if (!utilityService.isUndefined(instaService.customerAadhaarCardDetails.name)) {
                    instadebitCardDetailsVm.splitDebitName(instaService.customerAadhaarCardDetails.name);
                }
            } else if (instaService.isResumeJourney == true) {
                if (!utilityService.isUndefined(instaService.customerManualEntryDetails.firstName)) {
                    instadebitCardDetailsVm.fatherFname = instaService.customerManualEntryDetails.firstName + " " + instaService.customerManualEntryDetails.lastName;
                } else if (!utilityService.isUndefined(instaService.customerAadhaarCardDetails.name)) {
                    instadebitCardDetailsVm.splitDebitName(instaService.customerAadhaarCardDetails.name);
                }
                instadebitCardDetailsVm.selectedMethod = instaService.cardReadyForCollection;
            }
        }

        instadebitCardDetailsVm.splitDebitName = function (names) {
            var cname = names;
            var res = cname.split(" ");
            var firstname = "";
            var lastname = res[res.length - 1];
            for (var i = 0; i < res.length - 1; i++) {
                firstname += res[i] + " ";
            }
            instadebitCardDetailsVm.fatherFname = firstname.trim() + " " + lastname.trim();
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
            instadebitCardDetailsVm.updateName();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            instadebitCardDetailsVm.journeyType = instaService.journeyType;
            instadebitCardDetailsVm.constantJourneyTypeVKYC = constantConfig.acOpeningAdapterOVDConstant.vkycInsta;
        });

        return this;
    }
]);
