'use strict';

angularApp.service('instadebitCardDetailsService',
    function($q, AdapterUtils, constantConfig) {
        var instadebitCardDetailsService = this;
        instadebitCardDetailsService.setDebitCardDetails = function(requestParams) {
            var q = $q.defer(); 

            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.setDebitCardNameDetails,requestParams, true).then(
                function(response){ 
                    q.resolve(response);
                },
                function(error){    
                    q.reject(error);
                }
            );
            return q.promise;
        };

        instadebitCardDetailsService.receiveDebitCard = function(requestParams) {

            var q = $q.defer();
            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.receiveDebitCard, requestParams, true).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        instadebitCardDetailsService.getInfoCardDelivery = function() {
            var q = $q.defer();
            
            AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.getInfoCardDelivery, true).then(

                function(response) {
                    q.resolve(response.data.informationOnCardDelivery);    
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };

        instadebitCardDetailsService.openInstaAccount = function(requestParams) {

            var q = $q.defer();
            AdapterUtils.postDataWithTimeOut(constantConfig.InstaAcOpeningAdapterUrl.openInstaAccount, requestParams, true, 120000).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        instadebitCardDetailsService.generateVKYCToken = function(requestParams) {

            var q = $q.defer();
            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.generateVKYCToken, requestParams, true).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        instadebitCardDetailsService.genterateEkyc = function() {

            var q = $q.defer();
            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.getEkycCertificate, true).then(
                function(response) {
                    q.resolve(response); 
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };
        
        return instadebitCardDetailsService;
}); 