'use strict';

angularApp.controller('instadetailsExistController', ["$state",
    "$scope",
    "instadetailsExistService",
    "instaService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        instadetailsExistService,
        instaService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instadetailsExistVm = this;

        function initPage() {
            instadetailsExistVm.showBack = false;
            instadetailsExistVm.showNext = false;
            instadetailsExistVm.loadLocateBranchContent();
        }

        $scope.goToHome = function() {
           instaService.homeNav();
        }

        instadetailsExistVm.displaymap = function() {
            $state.go('menu.instaKit_locateNearestBranch');
        }

        instadetailsExistVm.loadLocateBranchContent = function() {
            instadetailsExistService.getDetailsExistContent().then(function(data) {
                instadetailsExistVm.detailsExistMsg = data;
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }


        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });
        
        return this;
    }
]);
