'use strict';

angularApp.controller('instaenterOTPAoController', ["$state",
    "$scope",
    "$translate",
    "instaenterOTPService",
    "utilityService",
    "instaService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "constantConfig",
    "instadebitCardDetailsService",
    function($state,
        $scope,
        $translate,
        instaenterOTPService,
        utilityService,
        instaService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        constantConfig,
        instadebitCardDetailsService
        ) {

        var instaenterOTPAoVm = this;

        function initPage() {
            instaenterOTPAoVm.showBack = true;
            instaenterOTPAoVm.showNext = true;
            instaenterOTPAoVm.showOtpView = true;
            instaenterOTPAoVm.otpvalue = "";
            instaenterOTPAoVm.disableNext = true;
            instaenterOTPAoVm.aofooter = true;
            instaenterOTPAoVm.requestOtpCall();
            instaenterOTPAoVm.isDisabledOTP = false;
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                instaenterOTPAoVm.okBtntext = translatedvalue;  
            });
        }

        instaenterOTPAoVm.goBacktoPrevious = function() {
            //$state.go("menu.instaKit_productOffering");
            $state.go('menu.instaKit_termsAndConditions');
        }

        instaenterOTPAoVm.goToNextPage = function() {
            /* Send the OTP */
            instaService.tncOtpValue = instaenterOTPAoVm.otpvalue;
            var requestParams = {
                "mobile":instaService.customer.mobileNo,
                "otp": instaenterOTPAoVm.otpvalue,
                 "journeyName":instaService.journeyType
            }
            instaenterOTPService.OTPValidation(requestParams).then(function(response) {
                if (response.data.status.toLowerCase() == "success") {
                    setTimeout(function() {
                        instaenterOTPAoVm.updateCommonId();
                    }, 500);
                } 
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        instaenterOTPAoVm.updateCommonId = function() {
            var requestParams = {
                "id": instaService.customer.mobileNo,
                "data": {
                    "commonId": $state.$current.data.commonId
                }
            }
            instaenterOTPService.sendCommonId(requestParams).then(function(response) {
                instaenterOTPAoVm.journeyType = instaService.journeyType;
            if (response.responseCode == "0000") {
                if(instaenterOTPAoVm.journeyType == "VKYC-CSP"){
                    //instaenterOTPAoVm.generateVKYCToken();
                     $state.go('menu.salaryUploadDoc');
                }else{
                    $state.go('menu.instaKit_debitCardDetails');
                } 
            }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
		
		instaenterOTPAoVm.requestOtpCallOnce = function() {
			// if(instaenterOTPAoVm.isDisabledOTP){return true}
			instaenterOTPAoVm.requestOtpCall();
			// instaenterOTPAoVm.isDisabledOTP = true;
		};	

        /* Request for OTP on page load to the registered mobile number */
		
			instaenterOTPAoVm.requestOtpCall = function() {
				var requestParams = {
					"id" : instaService.customer.mobileNo,
					"recipientMailId" : instaService.customer.emailId
				}
				
				instaenterOTPService.requestOtp(requestParams).then(function(response) {

                    var title = '';
                    var template = '{{"OTP_SENT_SUCCESS" | translate}}';
                    var onTap = '';
                    var buttontext = '<b>' + instaenterOTPAoVm.okBtntext + '</b>';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);

                    // if (utilityService.isAndroidPlatform()) {
                    //     autoOtpReadService.startOtpReading().then(function(result) {
                    //         instaenterOTPAoVm.otpvalue = result;
                    //         instaenterOTPAoVm.disableNext = false;
                    //     }, function(error) {
            
                    //     }, function(watchStatus) {
                    //     });
                    // }


				}, function(error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        instaenterOTPAoVm.validateOTP = function(isValid) {
            instaenterOTPAoVm.disableNext = !isValid;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
