'use strict';

angularApp.service('instaenterOTPService',
    function($q, AdapterUtils, constantConfig) {
        var instaenterOTPService = this;
        
        /* Send the OTP and ID to complete the registration */
        instaenterOTPService.OTPValidation = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.instaValidateOTP, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        /* Request for OTP on page load to the registered mobile number */
        instaenterOTPService.requestOtp = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.getOTP, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };

        /* Request for OTP on page load to the registered mobile number */
        instaenterOTPService.sendCommonId = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.completeRegistration, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };
        return instaenterOTPService;
    });
