'use strict';

angularApp.controller('instaenterOTPReferenceCodeController', ["$state",
    "$scope",
    "instaService",
    "instaenterOTPReferenceCodeService",
    "$timeout",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "$translate",
    "constantConfig",
    "newToSbiService",
    "$ionicPopup",
    "employerDetailsService",
    function ($state,
        $scope,
        instaService,
        instaenterOTPReferenceCodeService,
        $timeout,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        $translate,
        constantConfig,
        newToSbiService,
        $ionicPopup,
        employerDetailsService) {

        var instaenterOTPReferenceCodeVm = this;

        function initPage() {
            instaenterOTPReferenceCodeVm.showBack = false;
            instaenterOTPReferenceCodeVm.showNext = true;
            instaenterOTPReferenceCodeVm.showOtpView = true;
            instaenterOTPReferenceCodeVm.otpFooterView = true;
            instaenterOTPReferenceCodeVm.disableNext = true;
            instaenterOTPReferenceCodeVm.disableResendOtp = true;
            instaenterOTPReferenceCodeVm.isChecked = false;
            instaenterOTPReferenceCodeVm.salryAccntCheck = true;
            instaenterOTPReferenceCodeVm.isChecked = instaService.vkycProcessConsent;
            //instaenterOTPReferenceCodeVm.salryAccntCheck = instaService.vkycProcessConsent;
            instaenterOTPReferenceCodeVm.journeyType = instaService.journeyType;
            instaenterOTPReferenceCodeVm.constantJourneyTypeVKYC = constantConfig.acOpeningAdapterOVDConstant.vkycInsta;
            instaenterOTPReferenceCodeVm.constantJourneyTypeSalary = constantConfig.acOpeningAdapterOVDConstant.salaryAcc;
            instaenterOTPReferenceCodeVm.getInstaPlusDetail = angular.copy(newToSbiService.getInstaPlusDetail);

            instaenterOTPReferenceCodeVm.vkycStatus = instaService.vkycStatus ? instaService.vkycStatus : "";

            if (instaenterOTPReferenceCodeVm.journeyType != instaenterOTPReferenceCodeVm.constantJourneyTypeVKYC && instaenterOTPReferenceCodeVm.journeyType != instaenterOTPReferenceCodeVm.constantJourneyTypeSalary) {

                if (instaenterOTPReferenceCodeService.getNightmodeFlag()) {
                    $translate('NIGHT_MODE').then(function (translatedvalue) {
                        instaenterOTPReferenceCodeVm.otpReferenceText = translatedvalue;
                    });
                } else {
                    instaenterOTPReferenceCodeVm.getAccContent();
                }
            } else {
                if (instaenterOTPReferenceCodeVm.vkycStatus.toUpperCase() == 'COMPLETED' || instaenterOTPReferenceCodeVm.vkycStatus.toUpperCase() == 'APPROVED') {
                    instaenterOTPReferenceCodeVm.applicationUnderProcess = instaenterOTPReferenceCodeVm.getInstaPlusDetail.pendingAccountContent;
                    instaenterOTPReferenceCodeVm.otpReferenceText = instaenterOTPReferenceCodeVm.getInstaPlusDetail.instaPlusAccOpenCotent;
                    instaenterOTPReferenceCodeVm.otpReferenceText = instaenterOTPReferenceCodeVm.otpReferenceText.replace("FIELD_1}}", instaService.acctNo);
                    instaenterOTPReferenceCodeVm.otpReferenceText = instaenterOTPReferenceCodeVm.otpReferenceText.replace("FIELD_2}}", instaService.cifNumber);
                    instaenterOTPReferenceCodeVm.otpReferenceText = instaenterOTPReferenceCodeVm.otpReferenceText.replace("FIELD_3}}", instaService.homeBranchLocalityId);
                } else {
                    instaenterOTPReferenceCodeVm.applicationUnderProcess = instaenterOTPReferenceCodeVm.getInstaPlusDetail.pendingAccountContent;
                    instaenterOTPReferenceCodeVm.otpReferenceText = instaenterOTPReferenceCodeVm.getInstaPlusDetail.tokenNumberDetails;
                    instaenterOTPReferenceCodeVm.otpReferenceText = instaenterOTPReferenceCodeVm.otpReferenceText.replace("FIELD_1}}", instaService.tokenNumber);
                }
            }
        }

        instaenterOTPReferenceCodeVm.goToNextPage = function () {
            instaenterOTPReferenceCodeVm.showOtpView = false;
            instaenterOTPReferenceCodeVm.otpFooterView = false;
        }

        $scope.goToHome = function () {
            instaService.homeNav();
        }

        instaenterOTPReferenceCodeVm.doneFn = function () {
            $state.go('menu.selectSim');
        }

        instaenterOTPReferenceCodeVm.getAccountDetails = function () {
            var requestParams = {
                "mobileNumber": instaService.customer.mobileNo,
                "commonId": $state.$current.data.commonId
            }
            instaenterOTPReferenceCodeService.openInstaPlusAccount(requestParams).then(function (response) {
                    instaService.acctNo = response.data.accountNumber ? response.data.accountNumber : "";
                    instaService.cifNumber = response.data.cifNumber ? response.data.cifNumber : "";
                    instaService.homeBranchLocalityId = response.data.branchCode ? response.data.branchCode : "";
                    instaService.vkycBranchCode = response.data.vkycBranchCode ? response.data.vkycBranchCode : "";
                    instaService.vkycStatus = response.data.status;
                    instaenterOTPReferenceCodeVm.vkycStatus = instaService.vkycStatus;
                    instaenterOTPReferenceCodeVm.otpReferenceText = instaenterOTPReferenceCodeVm.getInstaPlusDetail.instaPlusAccOpenCotent;
                    instaenterOTPReferenceCodeVm.otpReferenceText = instaenterOTPReferenceCodeVm.otpReferenceText.replace("FIELD_1}}", instaService.acctNo);
                    instaenterOTPReferenceCodeVm.otpReferenceText = instaenterOTPReferenceCodeVm.otpReferenceText.replace("FIELD_2}}", instaService.cifNumber);
                    instaenterOTPReferenceCodeVm.otpReferenceText = instaenterOTPReferenceCodeVm.otpReferenceText.replace("FIELD_3}}", instaService.homeBranchLocalityId);
            }, function (error) {
                //utilityService.showAlertPopUp(error.responseMessage);
                employerDetailsService.showAlertPopup("alert", error.responseMessage, error.responseMessage,
						"", "OK", "", "", "");
            });
        }

        instaenterOTPReferenceCodeVm.authoriseUser = function(){
            if(instaenterOTPReferenceCodeVm.isChecked){
                instaenterOTPReferenceCodeVm.salryAccntCheck = false;
                instaenterOTPReferenceCodeVm.isChecked = true;
            }else{
                instaenterOTPReferenceCodeVm.salryAccntCheck = true;
                 instaenterOTPReferenceCodeVm.isChecked = false;
            }
        }

        instaenterOTPReferenceCodeVm.populateResumeNames = function() {
            if (instaService.isResumeJourney == true){
                instaenterOTPReferenceCodeVm.isChecked = instaService.vkycProcessConsent;
                 instaenterOTPReferenceCodeVm.authoriseUser();
            }else{
                instaService.vkycProcessConsent = instaenterOTPReferenceCodeVm.isChecked;
            }
        }


        instaenterOTPReferenceCodeVm.nextFn = function () {
            instaService.vkycProcessConsent = instaenterOTPReferenceCodeVm.isChecked;
            instaService.salryAccntCheck = instaenterOTPReferenceCodeVm.salryAccntCheck;
            var param = {
                    "data": {
                        "vkycProcessConsent": instaService.vkycProcessConsent
                        }
                    }
                instaenterOTPReferenceCodeService.saveVkycConsent(param).then(function(response) {
                    $state.go('menu.instaKit_startVkyc');         
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }

        instaenterOTPReferenceCodeVm.validateOTP = function (isValid) {
            instaenterOTPReferenceCodeVm.disableNext = !isValid;
            instaenterOTPReferenceCodeVm.disableResendOtp = false;
        }

        instaenterOTPReferenceCodeVm.getAccContent = function () {
            instaenterOTPReferenceCodeService.getAccountOpenCont().then(function (response) {
                instaenterOTPReferenceCodeVm.otpReferenceText = response.data.accOpenContent;
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }



        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            initPage();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            instaenterOTPReferenceCodeVm.populateResumeNames();
        });

        return this;
    }
]);
