'use strict';

angularApp.controller('instaforeignController', ["$state",
    "$scope",
    "instaforeignService",
    "instaService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        instaforeignService,
        instaService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instaforeignVm = this;

        function initPage() {
            instaforeignVm.showBack = true;
            instaforeignVm.showNext = false;
            instaforeignVm.getFatcaInfoDetails();
        }

        instaforeignVm.goBacktoPrevious = function() {
            $state.go('menu.instaKit_tax'); 
        }

         //Get Tax info details on click of "i" icon
        instaforeignVm.getFatcaInfoDetails = function(){
            instaforeignService.getFatcaInfoDetails().then(function(data) {
                instaforeignVm.fatcaInfo = data;
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
