'use strict';

angularApp.controller('instaKit_emailOTPController', ["$state",
    "$scope",
    "$translate",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "customerInfoService",
    "instagetOTPService",
    "instaService",
    "loggedInUserService",
    "cryptoService",
    "encryptionService",
	"AdapterUtils",
	"accountOpeningHomeService",
    function($state,
        $scope,
        $translate,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        customerInfoService,
        instagetOTPService,
        instaService,
        loggedInUserService,
        cryptoService,
        encryptionService,
		AdapterUtils,
		accountOpeningHomeService) {

        var instaKit_emailOTPVm = this;

  		instaKit_emailOTPVm.isChallenged = false;
        instaKit_emailOTPVm.securityCheckName = "AOSecurityCheck";
        instaKit_emailOTPVm.aoAuthChallengeHandler = WL.Client.createSecurityCheckChallengeHandler(instaKit_emailOTPVm.securityCheckName);
        instaKit_emailOTPVm.aoAuthChallengeHandler.securityCheckName = instaKit_emailOTPVm.securityCheckName;


        function initPage() {
            instaKit_emailOTPVm.showBack = true;
            instaKit_emailOTPVm.showNext = true;
            instaKit_emailOTPVm.showOtpView = true;
            instaKit_emailOTPVm.otpvalue = "";
            instaKit_emailOTPVm.disableNext = true;
            instaKit_emailOTPVm.aofooter = true;
            //instaKit_emailOTPVm.requestOtpCall();
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                instaKit_emailOTPVm.okBtntext = translatedvalue;  
            });
            
        }

        instaKit_emailOTPVm.goBacktoPrevious = function() {
        	$state.go('menu.instaKit_mobileEntryPage');
        }

        $scope.goToHome = function() {
			accountOpeningHomeService.homeNav();
            
        }

        instaKit_emailOTPVm.validateOTP = function(isValid) {
            instaKit_emailOTPVm.disableNext = !isValid;
        }

		instaKit_emailOTPVm.invokeGetOTPService = function () {
		            var requestParams = {
		                "id": instaService.customer.mobileNo,
						"recipientMailId":  instaService.customer.emailId ? instaService.customer.emailId : "",
						"sendOTPFlg": "both" 
		            }
		            instagetOTPService.getOtp(requestParams).then(function (response) {
		             
		                //customer.otpNo = utilityService.getValue(response.data.otp);
		                var title = '';
		                var template = '{{"OTP_SENT_SUCCESS_MOBILE_AND_EMAIL" | translate}}';
		                var onTap = '';
		                var buttontext = '<b>' + instaKit_emailOTPVm.okBtntext + '</b>';
		                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
		            }, function (error) {
		                utilityService.showErrorMessage(error.responseMessage);
		            });
				}
				
				/* resend OTP */
				
				instaKit_emailOTPVm.requestOtpCallOnce = function() {
					instaKit_emailOTPVm.resendOtp();
				};

				instaKit_emailOTPVm.resendOtp = function () {
		            var requestParams = {
		                "id": instaService.customer.mobileNo,
						"recipientMailId":  instaService.customer.emailId ? instaService.customer.emailId : "",
						"sendOTPFlg": "mobileOnly" 
		            }
		            instagetOTPService.getOtp(requestParams).then(function (response) {
		             
		                //.customer.otpNo = utilityService.getValue(response.data.otp);
		                var title = '';
		                var template = '{{"OTP_SENT_SUCCESS" | translate}}';
		                var onTap = '';
		                var buttontext = '<b>' + instaKit_emailOTPVm.okBtntext + '</b>';
		                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
		
		                //instaKit_emailOTPVm.getOtpFromEmail(mobilenumber);
		            }, function (error) {
		                utilityService.showErrorMessage(error.responseMessage);
		            });
				}


				instaKit_emailOTPVm.requestOtpEmail = function() {
					instaKit_emailOTPVm.resendOtpEmail();
				};

				instaKit_emailOTPVm.resendOtpEmail = function () {
		            var requestParams = {
		                "id": instaService.customer.mobileNo,
						"recipientMailId":  instaService.customer.emailId ? instaService.customer.emailId : "",
						"sendOTPFlg": "emailOnly" 
		            }
		            instagetOTPService.getOtp(requestParams).then(function (response) {
		             
		                //.customer.otpNo = utilityService.getValue(response.data.otp);
		                var title = '';
		                var template = '{{"OTP_SENT_SUCCESS_EMAIL" | translate}}';
		                var onTap = '';
		                var buttontext = '<b>' + instaKit_emailOTPVm.okBtntext + '</b>';
		                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
		                // if (utilityService.isAndroidPlatform()) {
						// 		autoOtpReadService.startOtpReading().then(function(result) {
						// 			instaKit_emailOTPVm.getOTPNumber = result;
						// 			instaKit_emailOTPVm.disableNext = false;
						// 		}, function(error) {
						// 		}, function(watchStatus) {
						// 		});
						// 	}
		
		                //instaKit_emailOTPVm.getOtpFromEmail(mobilenumber);
		            }, function (error) {
		                utilityService.showErrorMessage(error.responseMessage);
		            });
				}


				/* resend OTP END */


	      instaKit_emailOTPVm.goToNextPage = function () {
	            utilityService.showSpinner();
	            instaKit_emailOTPVm.aoAuthChallengeHandler.handleChallenge = function (challenge) {
	                instaKit_emailOTPVm.isChallenged = true;
	                utilityService.hideSpinner();
	                if (challenge.errorMsg !== null) {
	                    utilityService.showErrorMessage(utilityService.getServerExceptionMessage(challenge));
	                } else {
	                    utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
	                }
	            };
	
	            instaKit_emailOTPVm.aoAuthChallengeHandler.handleSuccess = function (data) {
	                utilityService.hideSpinner();
	                instaKit_emailOTPVm.isChallenged = false;
	                if (data.user) {
	                    loggedInUserService.keyId = AdapterUtils.secretData == "" ? data.user.attributes.keyId : encryptionService.getAES256DecryptedData(data.user.attributes.keyId);
	                    loggedInUserService.tokenLotus = AdapterUtils.secretData == "" ? data.user.attributes.lotusToken : encryptionService.getAES256DecryptedData(data.user.attributes.lotusToken);
	                }
	            };
	
	            instaKit_emailOTPVm.aoAuthChallengeHandler.handleFailure = function (error) {
	                instaKit_emailOTPVm.aoAuthChallengeHandler.cancel();
	                instaKit_emailOTPVm.isChallenged = false;
	                utilityService.hideSpinner();
	                if (error.failure) {
	                    utilityService.showErrorMessage(error.failure);
	                } else {
	                    utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
	                }
	            }
	
	            var payload = {};
	            var requestParams = {
	                "mobileOTPKey": instaService.customer.mobileNo,
	                "passOTPKey": instaKit_emailOTPVm.otpvalue,
					"mfDeviceId": loggedInUserService.deviceIdForMpin,
					"deviceId": device.uuid,
					"emailOTPKey":  instaService.customer.emailId ? instaService.customer.emailId : "",
					"passEmailOTPKey": instaKit_emailOTPVm.emailOtpvalue,
				    "reqTimeStamp" : (new Date()).toString()
	            }
	            var src = cryptoService.encryptRSAWithPublicKey(encryptionService.iv + "^" + encryptionService.passphrase + "^" + encryptionService.salt, cryptoService.rsaPublicKey);
	            payload = {
	                "data": AdapterUtils.secretData + encryptionService.getAES256EncryptedData(JSON.stringify(requestParams)),
	                "src": src
	            }
	
	            payload = AdapterUtils.secretData == "" ? requestParams : payload;
	
	            if (instaKit_emailOTPVm.isChallenged) {
	                instaKit_emailOTPVm.aoAuthChallengeHandler.submitChallengeAnswer(payload);
	            } else {
	                WLAuthorizationManager.login(instaKit_emailOTPVm.aoAuthChallengeHandler.securityCheckName, payload).then(
	                    function (data) {
	                        utilityService.accessRestricted = utilityService.AOAuthRequired;
	                        utilityService.hideSpinner();
	                        //alert('Success');
							$state.go('menu.instaKit_appPassword');
	                    },
	                    function (error) {
	                        utilityService.accessRestricted = "";
	                        utilityService.hideSpinner();
	                        if (error.errorCode == 'CHALLENGE_HANDLING_CANCELED' || error.errorCode == 'APPLICATION_DISABLED') {
	                            return;
	                        }
	                        if (error.errorCode == "LOGIN_ALREADY_IN_PROCESS") {
	                            instaKit_emailOTPVm.aoAuthChallengeHandler.cancel();
	                        }
	                        utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
	                    });
	            }
	
	        }


        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            instaKit_emailOTPVm.invokeGetOTPService();
            instaKit_emailOTPVm.otpvalue = "";
			instaKit_emailOTPVm.emailOtpvalue = "";
        });

        return this;
    }
]);
