'use strict';

angularApp.controller('instagetOTPController', ["$state",
    "$scope",
    "instagetOTPService",
    "instaService",
    "utilityService",
    "resumeJourneyService",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "cryptoService",
    "encryptionService",
    "$translate",
    "loggedInUserService",
    "AdapterUtils",
    // "autoOtpReadService",
    function ($state,
        $scope,
        instagetOTPService,
        instaService,
        utilityService,
        resumeJourneyService,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService,
        cryptoService,
        encryptionService,
        $translate,
        loggedInUserService,
        AdapterUtils
        // autoOtpReadService
    ) {

        var instagetOTPVm = this;

        instagetOTPVm.isChallenged = false;
        instagetOTPVm.securityCheckName = "AOSecurityCheck";
        instagetOTPVm.aoAuthChallengeHandler = WL.Client.createSecurityCheckChallengeHandler(instagetOTPVm.securityCheckName);
        instagetOTPVm.aoAuthChallengeHandler.securityCheckName = instagetOTPVm.securityCheckName;

        function initPage() {
            instagetOTPVm.showBack = true;
            instagetOTPVm.showNext = true;
            //instagetOTPVm.otpSentMsg = false;
            instagetOTPVm.resendOtpLink = true;
            //instagetOTPVm.otpNumberInput = true;
            instagetOTPVm.otpSentMsg = true;
            instagetOTPVm.aofooter = true;
            instagetOTPVm.disableFields = false;
            instagetOTPVm.isEnableOTPOnce = true;
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                instagetOTPVm.okBtntext = translatedvalue;


                // var title = '';
                // var template = '{{"OTP_SENT_SUCCESS" | translate}}';
                // var onTap = '';
                // var buttontext = '<b>' + instagetOTPVm.okBtntext + '</b>';
                // utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);

            });


        }

        instagetOTPVm.goBacktoPrevious = function () {
            $state.go('menu.instaKit_mobileEntryPage');
        }

        $scope.goToHome = function () {
            instaService.homeNav();
        }

        instagetOTPVm.invokeGetOTPService = function () {
            var requestParams = {
                "id": instaService.customer.mobileNo,
                "recipientMailId": instaService.customer.emailId,
                "sendOTPFlg": "mobileOnly"
            }
            instagetOTPService.getOtp(requestParams).then(function (response) {
                //Success - Data
                //instagetOTPVm.resendOtpLink = false;
                //instagetOTPVm.otpNumberInput = false;
                //instagetOTPVm.getOTPNumber = utilityService.getValue(response.data.otp);
                instaService.customer.otpNo = utilityService.getValue(response.data.otp);
                var title = '';
                var template = '{{"OTP_SENT_SUCCESS" | translate}}';
                var onTap = '';
                var buttontext = '<b>' + instagetOTPVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                //  if (utilityService.isAndroidPlatform()) {
                // 		autoOtpReadService.startOtpReading().then(function(result) {
                // 			instagetOTPVm.getOTPNumber = result;
                // 			instagetOTPVm.disableNext = false;			
                // 		}, function(error) {
                // 		}, function(watchStatus) {
                // 		});
                // }
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        var timeoutHandle;

        function countdown(minutes) {
            var seconds = 60;
            var mins = minutes;

            function tick() {
                var counter = document.getElementById("timer");
                var current_minutes = mins - 1;
                seconds--;
                counter.innerHTML = current_minutes.toString() + ":" + (seconds < 10 ? "0" : "") + String(seconds);
                if (seconds > 0) {
                    timeoutHandle = setTimeout(tick, 1000);
                } else {
                    if (mins > 1) {
                        // countdown(mins-1);   never reach �00? issue solved:Contributed by Victor Streithorst
                        setTimeout(function () { countdown(mins - 1); }, 1000);
                    }
                }
            }
            tick();
        }



        //On click of Resend OTP link
        instagetOTPVm.resendOTPService = function () {
            // if (instagetOTPVm.isEnableOTPOnce == false) { return true }
            instagetOTPVm.invokeGetOTPService();
            // instagetOTPVm.isEnableOTPOnce = false;
        }

        // Validate OTP service call and redirect to next page
        instagetOTPVm.validateOtpCall = function () {
            instagetOTPVm.loginWithOTP();
        }

        //Challenge Handler
        instagetOTPVm.loginWithOTP = function () {
            utilityService.showSpinner();
            instagetOTPVm.aoAuthChallengeHandler.handleChallenge = function (challenge) {
                instagetOTPVm.isChallenged = true;
                utilityService.hideSpinner();
                if (challenge.errorMsg !== null) {
                    utilityService.showErrorMessage(utilityService.getServerExceptionMessage(challenge));
                } else {
                    utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
                }
            };

            instagetOTPVm.aoAuthChallengeHandler.handleSuccess = function (data) {
                instagetOTPVm.isChallenged = false;
                utilityService.hideSpinner();
                if (data.user) {
                    loggedInUserService.keyId = AdapterUtils.secretData == "" ? data.user.attributes.keyId : encryptionService.getAES256DecryptedData(data.user.attributes.keyId);
                    loggedInUserService.tokenLotus = AdapterUtils.secretData == "" ? data.user.attributes.lotusToken : encryptionService.getAES256DecryptedData(data.user.attributes.lotusToken);
                }
            };

            instagetOTPVm.aoAuthChallengeHandler.handleFailure = function (error) {
                instagetOTPVm.aoAuthChallengeHandler.cancel();
                instagetOTPVm.isChallenged = false;
                utilityService.hideSpinner();
                if (error.failure) {
                    utilityService.showErrorMessage(error.failure);
                } else {
                    utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
                }
            }

            var payload = {};
            var requestParams = {
                "mobileOTPKey": instaService.customer.mobileNo,
                "passOTPKey": instagetOTPVm.getOTPNumber,
                "mfDeviceId": loggedInUserService.deviceIdForMpin,
                "deviceId": device.uuid,
                "journeyName":instaService.journeyType
            }

            //TODO below line use for encrypted build(uncomment following)
            var passphraseSession;
            if (sessionStorage) {
                passphraseSession = sessionStorage.getItem('passphrase');
            }
            var passphrase = passphraseSession ? passphraseSession : encryptionService.passphrase;
            var src = cryptoService.encryptRSAWithPublicKey(encryptionService.iv + "^" + passphrase + "^" + encryptionService.salt, cryptoService.rsaPublicKey);
            payload = {
                "data": AdapterUtils.secretData + encryptionService.getAES256EncryptedData(JSON.stringify(requestParams)),
                "src": src
            }

            payload = AdapterUtils.secretData == "" ? requestParams : payload;

            if (instagetOTPVm.isChallenged) {
                instagetOTPVm.aoAuthChallengeHandler.submitChallengeAnswer(payload);
            } else {
                WLAuthorizationManager.login(instagetOTPVm.aoAuthChallengeHandler.securityCheckName, payload).then(
                    function (data) {
                        utilityService.accessRestricted = utilityService.AOAuthRequired;
                        utilityService.hideSpinner();
                        $state.go('menu.instaKit_appPassword');
                    },
                    function (error) {
                        utilityService.accessRestricted = "";
                        utilityService.hideSpinner();
                        if (error.errorCode == 'CHALLENGE_HANDLING_CANCELED' || error.errorCode == 'APPLICATION_DISABLED') {
                            return;
                        }
                        if (error.errorCode == "LOGIN_ALREADY_IN_PROCESS") {
                            instagetOTPVm.aoAuthChallengeHandler.cancel();
                        }
                        utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
                    });
            }
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            instagetOTPVm.invokeGetOTPService();
            // if (utilityService.isAndroidPlatform()) {
            // 	autoOtpReadService.startOtpReading().then(function(result) {
            // 		instagetOTPVm.getOTPNumber = result;
            // 		instagetOTPVm.disableNext = false;
            // 	}, function(error) {
            // 	}, function(watchStatus) {
            // 	});
            // }



        });

        $scope.$on('$ionicView.beforeLeave', function () {

        });

        return this;
    }
]);
