'use strict';

angularApp.service('instagetOTPService',
    function($q, AdapterUtils, constantConfig) {
        var instagetOTPService = this;
        instagetOTPService.getOtp = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.getOTP, requestData, true).then(
                
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };

        instagetOTPService.setReferralMobNo = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.setReferralCode, requestData, true).then(
                
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };

        instagetOTPService.validateOtp = function(requestParams) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.validateOTP, requestParams, true).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };

        instagetOTPService.emailServiceOtp = function(requestParams){
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.emailServiceForOtp, requestParams, true).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        }

        instagetOTPService.getCustomerDetails = function(requestData) {
            
            var q = $q.defer();
           
           AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.customerDocumentDetails, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        return instagetOTPService;
    });
