/**
*   @ngdoc config
*   @name angularApp.config : aoConfig
*   @description
*	configuration file for account opening module
*/

'use strict';

/*State definition with respective names, urls, controllers and templates */
angularApp.config(['$stateProvider',
	function ($stateProvider) {
		//Account Opening start
		$stateProvider
			.state('menu.instaKit_applyNewOrResume', {
				url: '/applyNewOrResume',
				data: {
					pageId: 'IAO_NWORRSM',
					sectionId: 'applyNewOrResumeSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/applyNewOrResume/instaKit_applyNewOrResume.html',
						controller: 'instaapplyNewOrResumeController',
						controllerAs: 'instaapplyNewOrResumeVm',
					}
				}
			})
			.state('menu.instaKit_accountOpening', {
				url: '/accountOpening',
				data: {
					pageId: 'IAO_HOM',
					sectionId: 'accountOpeningSection'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/accountOpening/instaKit_accountOpening.html',
						controller: 'instaaccountOpeningController',
						controllerAs: 'instaaccountOpeningVm',
					}
				}
			})
			.state('menu.instaKit_passwordRecovery', {
				url: '/passwordRecovery',
				data: {
					pageId: 'IAO_PWDRCVRY',
					sectionId: 'accountOpeningSection'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/passwordRecovery/instaKit_passwordRecovery.html',
						controller: 'instapasswordRecoveryController',
						controllerAs: 'instapasswordRecoveryVm',
					}
				}
			})
			.state('menu.instaKit_passwordOTP', {
				url: '/passwordOTP',
				data: {
					pageId: 'IAO_PWDOTP',
					sectionId: 'accountOpeningSection'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/passwordOTP/instaKit_passwordOTP.html',
						controller: 'instapasswordOTPController',
						controllerAs: 'instapasswordOTPVm',
					}
				}
			})
			.state('menu.instaKit_knowMore', {
				url: '/knowMore',
				data: {
					pageId: 'IAO_KNOWMORE',
					sectionId: 'accountOpeningSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/accountOpening/instaKit_knowMore.html',
						controller: 'instaknowMoreController',
						controllerAs: 'instaknowMoreVm',
					}
				}
			})
			.state('menu.instaKit_aOLooksGreat', {
				url: '/aOLooksGreat',
				data: {
					pageId: 'IAO_AOLOKGRT',
					sectionId: 'sub.aoCustomerImage',
					commonId: 'insta_aadhaarPhoto'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/accountOpening/instaKit_accountOpeningLooksGreat.html',
						controller: 'instaaccountOpeningLooksGreatController',
						controllerAs: 'instaaOLooksGreatVm',
					}
				}
			})
			.state('menu.instaKit_getOTP', {
				url: '/getOTP',
				data: {
					pageId: 'IAO_GETOTP',
					sectionId: 'getOTPSection'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/getOTP/instaKit_getOTP.html',
						controller: 'instagetOTPController',
						controllerAs: 'instagetOTPVm',
					}
				}
			})
			.state('menu.instaKit_emailOTP', {
				url: '/emailOTP',
				data: {
					pageId: 'IAO_EMAILOTP',
					sectionId: 'getEmailOTPSection'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/getOTP/instaKit_emailOTP.html',
						controller: 'instaKit_emailOTPController',
						controllerAs: 'instaKit_emailOTPVm',
					}
				}
			})
			.state('menu.instaKit_mobileEntryPage', {
				url: '/mobileEntryPage',
				data: {
					pageId: 'IAO_ENTERMOBNO',
					sectionId: 'getOTPSection'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/mobileEntryPage/instaKit_mobileEntryPage.html',
						controller: 'instamobileEntryPageController',
						controllerAs: 'instamobileEntryPageVm',
					}
				}
			})
			.state('menu.instaKit_appPassword', {
				url: '/appPassword',
				data: {
					pageId: 'IAO_APPPWD',
					sectionId: 'aoPasswordSection',
					commonId: 'insta_appPassword'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/appPassword/instaKit_appPassword.html',
						controller: 'instaappPasswordController',
						controllerAs: 'instaappPasswordVm',
					}
				}
			})
			.state('menu.instaKit_regenerateAppPassword', {
				url: '/regenerateAppPassword',
				data: {
					pageId: 'IAO_REGAPPPWD',
					sectionId: 'aoPasswordSection'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/regenerateAppPassword/instaKit_regenerateAppPassword.html',
						controller: 'instaregenerateAppPasswordController',
						controllerAs: 'instaregenerateAppPasswordVm',
					}
				}
			})
			.state('menu.instaKit_tax', {
				url: '/tax',
				data: {
					pageId: 'IAO_TAX',
					sectionId: 'sub.customeraoFatcaCrsDeclare',
					commonId: 'insta_fatca'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/tax/instaKit_tax.html',
						controller: 'instataxController',
						controllerAs: 'instataxVm',
					}
				}
			})
			.state('menu.instaKit_pdetailsAN', {
				url: '/pdetailsAN',
				data: {
					pageId: 'IAO_PRSLDETLAN',
					sectionId: 'sub.customeraoAadharDetails'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/personalDetails/instaKit_personalDetailsAN.html',
						controller: 'instapersonalDetailsANController',
						controllerAs: 'instapdetailsANVm',
					}
				}
			})
			.state('menu.instaKit_pdetailsAddress', {
				url: '/pdetailsAddress',
				data: {
					pageId: 'IAO_PRSLDETLADR',
					sectionId: 'aoPersonalDetailsSection',
					commonId: 'insta_customerAddress'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/personalDetails/instaKit_personalDetailsAddress.html',
						controller: 'instapersonalDetailsAddressController',
						controllerAs: 'instapdetailsAddressVm',
					}
				}
			})
			.state('menu.instaKit_pdetailsCAddress', {
				url: '/pdetailsCAddress',
				data: {
					pageId: 'IAO_PRSLDETLCADR',
					sectionId: 'sub.aoCustomerAddresss',
					commonId: 'insta_correspondAddress'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/personalDetails/instaKit_personalDetailsCAddress.html',
						controller: 'instapersonalDetailsCAddressController',
						controllerAs: 'instapdetailsCAddressVm',
					}
				}
			})
			.state('menu.instaKit_panDetails', {
				url: '/panDetails',
				data: {
					pageId: 'IAO_PANDETL',
					sectionId: 'sub.aoEnterPAN',
					commonId: 'insta_panNumber'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/panDetails/instaKit_panDetails.html',
						controller: 'instapanDetailsController',
						controllerAs: 'instapanDetailsVm',
					}
				}
			})
			.state('menu.instaKit_kindlyNote', {
				url: '/kindlyNote',
				data: {
					pageId: 'IAO_KINDNOTE',
					sectionId: 'sub.aoKindNote',
					commonId: 'insta_kindnote'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/panDetails/instaKit_kindlyNote.html',
						controller: 'instakindlyNoteController',
						controllerAs: 'instakindNoteVm',
					}
				}
			})
			.state('menu.instaKit_panAuthorise', {
				url: '/panAuthorise',
				data: {
					pageId: 'IAO_PANAUTH',
					sectionId: 'sub.customerAOagreeTerms',
					commonId: 'insta_aadhaarConsent'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/panAuthorise/instaKit_panAuthorise.html',
						controller: 'instapanAuthoriseController',
						controllerAs: 'instapanAuthoriseVm',
					}
				}
			})
			.state('menu.instaKit_foreign', {
				url: '/foreign',
				data: {
					pageId: 'IAO_FRGN',
					sectionId: 'aoTaxSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/foreign/instaKit_foreign.html',
						controller: 'instaforeignController',
						controllerAs: 'instaforeignVm',
					}
				}
			})
			.state('menu.instaKit_personalDetails', {
				url: '/personalDetails',
				data: {
					pageId: 'IAO_PRSLDETL',
					sectionId: 'aoPersonalDetailsSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/personalDetails/instaKit_personalDetails.html',
						controller: 'instapersonalDetailsController',
						controllerAs: 'instapersonalDetailsVm',
					}
				}
			})
			.state('menu.instaKit_aadhar', {
				url: '/aadhar',
				data: {
					pageId: 'IAO_ADHRSCN',
					sectionId: 'aoPersonalDetailsSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/personalDetails/instaKit_aadharscan.html',
						controller: 'instaaadharscanController',
						controllerAs: 'instaaadharvm',
					}
				}
			})
			.state('menu.instaKit_additionalDetails', {
				url: '/additionalDetails',
				data: {
					pageId: 'IAO_ADNLDETL',
					sectionId: 'sub.customeraoAdditionalDetailsMore'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/additionalDetails/instaKit_additionalDetails.html',
						controller: 'instaadditionalDetailsController',
						controllerAs: 'instaadditionalDetailsVm',
					}
				}
			})
			.state('menu.instaKit_optionalAdditionalDetails', {
				url: '/optionalAdditionalDetails',
				data: {
					pageId: 'IAO_OP_ADNLDETL',
					sectionId: 'optionalAdditionalDetails'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/additionalDetails/instaKit_optionalAdditionalDetails.html',
						controller: 'instaKit_optionalAdditionalDetailsController',
						controllerAs: 'optionalAdditionalDetailsVm',
					}
				}
			})
			.state('menu.instaKit_aDMaritalStatus', {
				url: '/aDMaritalStatus',
				data: {
					pageId: 'IAO_MRTLSTUS',
					sectionId: 'sub.customeraoAdditionalDetails'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/additionalDetails/instaKit_aDMaritalStatus.html',
						controller: 'instaaDMaritalStatusController',
						controllerAs: 'instaaDMaritalStatusVm',
					}
				}
			})
			.state('menu.instaKit_aDFamilyDetails', {
				url: '/aDFamilyDetails',
				data: {
					pageId: 'IAO_FMLYDETL',
					sectionId: 'sub.customeraoAdditionalDetails'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/additionalDetails/instaKit_aDFamilyDetails.html',
						controller: 'instaaDFamilyDetailsController',
						controllerAs: 'instaaDFamilyDetailsVm',
					}
				}
			})
			.state('menu.instaKit_aDAnnualIncome', {
				url: '/aDAnnualIncome',
				data: {
					pageId: 'IAO_ANULINCM',
					sectionId: 'sub.customeraoAdditionalDetailsMore'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/additionalDetails/instaKit_aDAnnualIncome.html',
						controller: 'instaaDAnnualIncomeController',
						controllerAs: 'instaaDAnnualIncomeVm',
					}
				}
			})
			.state('menu.instaKit_aDOccupation', {
				url: '/aDOccupation',
				data: {
					pageId: 'IAO_OCPTN',
					sectionId: 'sub.customeraoAdditionalDetails'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/additionalDetails/instaKit_aDOccupation.html',
						controller: 'instaaDOccupationController',
						controllerAs: 'instaaDOccupationVm',
					}
				}
			})
			.state('menu.instakit_annualIncomeNew', {
				url: '/aDOccupation',
				data: {
					pageId: 'IAO_OCPTN',
					sectionId: 'sub.customeraoAdditionalDetails',
					commonId: 'insta_additionalDetails'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/additionalDetails/instakit_annualIncomeNew.html',
						controller: 'instaaDOccupationController',
						controllerAs: 'instaaDOccupationVm',
					}
				}
			})
			.state('menu.instaKit_aDCategory', {
				url: '/aDOccupation',
				data: {
					pageId: 'IAO_OCPTN',
					sectionId: 'sub.customeraoAdditionalDetails',
					commonId: 'insta_additionalDetails'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/additionalDetails/instaKit_aDCategory.html',
						controller: 'instaaDReligionController',
						controllerAs: 'instaaDReligionVm',
					}
				}
			})
			
			.state('menu.instaKit_aDSubOccupationService', {
				url: '/aDSubOccupationService',
				data: {
					pageId: 'IAO_SUBOCPTN',
					sectionId: 'aoAdditionalDetailsSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/additionalDetails/instaKit_aDSubOccupationService.html',
						controller: 'instaaDSubOccupationController',
						controllerAs: 'instaaDSubOccupationVm',
					}
				}
			})
			.state('menu.instaKit_aDSubOccupationOthers', {
				url: '/aDSubOccupationOthers',
				data: {
					pageId: 'IAO_SUBOCPTNOTHR',
					sectionId: 'aoAdditionalDetailsSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/additionalDetails/instaKit_aDSubOccupationOthers.html',
						controller: 'instaaDSubOccupationController',
						controllerAs: 'instaaDSubOccupationVm',
					}
				}
			})
			.state('menu.instaKit_aDSubOccupationBusiness', {
				url: '/aDSubOccupationBusiness',
				data: {
					pageId: 'IAO_SUBOCPTNOTHR',
					sectionId: 'aoAdditionalDetailsSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/additionalDetails/instaKit_aDSubOccupationBusiness.html',
						controller: 'instaaDSubOccupationController',
						controllerAs: 'instaaDSubOccupationVm',
					}
				}
			})
			.state('menu.instaKit_aDReligion', {
				url: '/aDReligion',
				data: {
					pageId: 'IAO_RLGN',
					sectionId: 'sub.customeraoAdditionalDetailsMore',
					commonId: 'insta_additionalDetails'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/additionalDetails/instaKit_aDReligion.html',
						controller: 'instaaDReligionController',
						controllerAs: 'instaaDReligionVm',
					}
				}
			})
			.state('menu.instaKit_aDCityCountry', {
				url: '/aDCityCountry',
				data: {
					pageId: 'IAO_CTYCNTY',
					sectionId: 'aoPersonalDetailsSection',
					commonId: 'AadharManual'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/birthCityCountry/instaKit_aDCityCountry.html',
						controller: 'instaaDCityCountryController',
						controllerAs: 'instaaDCityCountryVm',
					}
				}
			})
			.state('menu.instaKit_termsAndConditions', {
				url: '/termsAndConditions',
				data: {
					pageId: 'IAO_TNC',
					sectionId: 'sub.customerTandC',
					commonId: 'insta_termsConditions'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/termsAndConditions/instaKit_termsAndConditions.html',
						controller: 'instatermsAndConditionsController',
						controllerAs: 'instatermsAndConditionsVm',
					}
				}
			})
			.state('menu.instaKit_productOffering', {
				url: '/productOffering',
				data: {
					pageId: 'IAO_PRDTOFRG',
					sectionId: 'sub.customerproductoffer',
					commonId: 'insta_productOffer'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/productOffering/instaKit_productOffering.html',
						controller: 'instaproductOfferingController',
						controllerAs: 'instaproductOfferingVm',
					}
				}
			})
			.state('menu.instaKit_enterOTP', {
				url: '/enterOTP',
				data: {
					pageId: 'IAO_ENTROTP',
					sectionId: 'aoTermsConditionSection',
					commonId: 'insta_tcOtp'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/enterOTP/instaKit_enterOTP.html',
						controller: 'instaenterOTPAoController',
						controllerAs: 'instaenterOTPAoVm',
					}
				}
			})
			.state('menu.instaKit_tempLogin', {
				url: '/tempLogin',
				data: {
					pageId: 'IAO_TMPLGN',
					sectionId: 'aoTempLoginSection'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/tempLogin/instaKit_tempLogin.html',
						controller: 'instatempLoginController',
						controllerAs: 'instatempLoginVm',
					}
				}
			})
			.state('menu.instaKit_accountOpeningDetails', {
				url: '/accountOpeningDetails',
				data: {
					pageId: 'IAO_AODETL',
					sectionId: 'aoAccountopeningDetailSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/accountOpeningDetails/instaKit_accountOpeningDetails.html',
						controller: 'instaaccountOpeningDetailsController',
						controllerAs: 'instaaccountOpeningDetailsVm',
					}
				}
			})
			.state('menu.instaKit_map', {
				url: '/map',
				data: {
					pageId: 'IAO_MAP',
					sectionId: 'aoMapSection'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/map/instaKit_map.html',
						controller: 'instamapController',
						controllerAs: 'instamapVm',
					}
				}
			})
			.state('menu.instaKit_nomineeDetails', {
				url: '/nomineeDetails',
				data: {
					pageId: 'IAO_NOMDETL',
					sectionId: 'aoNomineeDetailsSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/nomineeDetails/instaKit_nomineeDetails.html',
						controller: 'instanomineeDetailsController',
						controllerAs: 'instanomineeDetailsVm',
					}
				}
			})
			.state('menu.instaKit_nominationRelated', {
				url: '/nominationRelated',
				data: {
					pageId: 'IAO_NOMDETLRLTDFRST',
					sectionId: 'sub.customeraoNomineeDetails'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/nomineeDetails/instaKit_nomineeDetailsRelatedFirst.html',
						controller: 'instanomineeDetailsRelatedController',
						controllerAs: 'instanomineeDetailsRelatedVm',
					}
				}
			})
			.state('menu.instaKit_nomineeDetailsNext', {
				url: '/nomineeDetailsNext',
				data: {
					pageId: 'IAO_NOMDETLRLTD',
					sectionId: 'sub.customeraoNomineeDetails',
					commonId: 'insta_nomineeDetails'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/nomineeDetails/instaKit_nomineeDetailsRelated.html',
						controller: 'instanomineeDetailsRelatedController',
						controllerAs: 'instanomineeDetailsRelatedVm',
					}
				}
			})
			.state('menu.instaKit_nomineeDetailsAddressOption', {
				url: '/nomineeDetailsAddressOption',
				data: {
					pageId: 'IAO_NOMDETLADDOPTN',
					sectionId: 'sub.customeraoNomineeDetailsMore'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/nomineeDetails/instaKit_nomineeDetailsAddressOption.html',
						controller: 'instanomineeDetailsAddressOptionController',
						controllerAs: 'instanomineeDetailsAddressOptionVm',
					}
				}
			})
			.state('menu.instaKit_nomineeEnteredAddress', {
				url: '/nomineeEnteredAddress',
				data: {
					pageId: 'IAO_NOMENTDADD',
					sectionId: 'sub.customeraoNomineeDetailsMore',
					commonId: 'insta_guardian'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/nomineeDetails/instaKit_nomineeEnteredAddress.html',
						controller: 'instanomineeEnteredAddressController',
						controllerAs: 'instanomineeEnteredAddressVm',
					}
				}
			})
			.state('menu.instaKit_nomineeAddress', {
				url: '/nomineeAddress',
				data: {
					pageId: 'IAO_NOMADD',
					sectionId: 'sub.customeraoNomineeDetailsMore',
					commonId: 'insta_guardian'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/nomineeDetails/instaKit_nomineeAddress.html',
						controller: 'instanomineeAddressController',
						controllerAs: 'instanomineeAddressVm',
					}
				}
			})
			.state('menu.instaKit_nomineeCAddress', {
				url: '/nomineeCAddress',
				data: {
					pageId: 'IAO_NOMCADD',
					sectionId: 'sub.customeraoNomineeDetailsMore',
					commonId: 'insta_guardian'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/nomineeDetails/instaKit_nomineeCAddress.html',
						controller: 'instanomineeCAddressController',
						controllerAs: 'instanomineeCAddressVm',
					}
				}
			})
			.state('menu.instaKit_selectBranchOption', {
				url: '/selectBranchOption',
				data: {
					pageId: 'IAO_SELBRCHOPTN',
					sectionId: 'sub.customerAOhomeBranchGPS'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/selectBranch/instaKit_selectBranchOption.html',
						controller: 'instaselectBranchOptionController',
						controllerAs: 'instaselectBranchOptionVm',
					}
				}
			})
			.state('menu.instaKit_selectBranchListGps', {
				url: '/selectBranchListGps',
				data: {
					pageId: 'IAO_SELBRCHLSTGPS',
					sectionId: 'sub.customerlocationByGPS',
					commonId: 'insta_homeBranch'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/selectBranch/instaKit_selectBranchListGps.html',
						controller: 'instaselectBranchListGpsController',
						controllerAs: 'instaselectBranchListGpsVm',
					}
				}
			})
			.state('menu.instaKit_selectBranchListLocality', {
				url: '/selectBranchListLocality',
				data: {
					pageId: 'IAO_SELBRCHLSTLCTY',
					sectionId: 'sub.customerByLocality',
					commonId: 'insta_homeBranch'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/selectBranch/instaKit_selectBranchListLocality.html',
						controller: 'instaselectBranchListLocController',
						controllerAs: 'instaselectBranchListLocVm',
					}
				}
			})
			.state('menu.instaKit_selectBListLocalityByPincode', {
				url: '/selectBListLocalityByPincode',
				data: {
					pageId: 'IAO_SELBRCHLSTBYPINCODE',
					sectionId: 'sub.customerByPincode',
					commonId: 'insta_homeBranchPin'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/selectBranch/instaKit_selectBranchListLocalityByPincode.html',
						controller: 'instaselectBranchListByPinController',
						controllerAs: 'instaselectBranchListPinVm',
					}
				}
			})
			.state('menu.instaKit_reviewSelectedBranch', {
				url: '/reviewSelectedBranch',
				data: {
					pageId: 'IAO_REVIEWSELECTEDBRANCH',
					sectionId: 'sub.selectedBranch',
					commonId: 'insta_homeBranch'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/selectBranch/instaKit_reviewSelectedBranch.html',
						controller: 'instaReviewSelectedBranchController',
						controllerAs: 'instaReviewSelectedBranchVm',
					}
				}
			})
			.state('menu.instaKit_searchBranchByOption', {
				url: '/searchBranchByOption',
				data: {
					pageId: 'IAO_SEARCHBROPTN',
					sectionId: 'sub.searchBranchOption'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/selectBranch/instaKit_searchBranchByOption.html',
						controller: 'instaSearchBranchByOptionController',
						controllerAs: 'instaSearchBranchByOptionVm',
					}
				}
			})
			.state('menu.instaKit_searchBranch', {
				url: '/instaSearchBranch',
				data: {
					pageId: 'IAO_SEARCHBRANCH',
					sectionId: 'sub.searchBranch'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/selectBranch/instaKit_searchBranch.html',
						controller: 'instaSearchBranchController',
						controllerAs: 'instaSearchBranchVm',
					}
				}
			})
			.state('menu.instaKit_locateBranch', {
				url: '/locateBranch',
				data: {
					pageId: 'IAO_LCTBRCH',
					sectionId: 'aoTaxSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/locateBranch/instaKit_locateBranch.html',
						controller: 'instalocateBranchController',
						controllerAs: 'instalocateBranchVm',
					}
				}
			})
			.state('menu.instaKit_updateAadhaar', {
				url: '/updateAadhaar',
				data: {
					pageId: 'IAO_UPDADHR',
					sectionId: 'updateAadhaarSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/updateAadhaar/instaKit_updateAadhaar.html',
						controller: 'instaupdateAadhaarController',
						controllerAs: 'instaupdateAadhaarVm',
					}
				}
			})
			.state('menu.instaKit_multipleCustomer', {
				url: '/multipleCustomer',
				data: {
					pageId: 'IAO_MULCUST',
					commonId: 'AaDharPANDeclaration'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/multipleCustomer/instaKit_multipleCustomer.html',
						controller: 'instamultipleCustomerController',
						controllerAs: 'instamultipleCustomerVm',
					}
				}
			})
			.state('menu.instaKit_passbookDetails', {
				url: '/passbookDetails',
				data: {
					pageId: 'IAO_PASSBOOKDETL',
					commonId: 'AaDharPANDeclaration'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/passbookDetails/instaKit_passbookDetails.html',
						controller: 'instapassbookDetailsController',
						controllerAs: 'instapassbookDetailsVm',
					}
				}
			})
			.state('menu.instaKit_debitCardDetails', {
				url: '/debitCardDetails',
				data: {
					pageId: 'IAO_DBTCRDDETL',
					sectionId: 'sub.customerDebitdetails',
					commonId: 'insta_debitCardDetails'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/debitCardDetails/instaKit_debitCardDetails.html',
						controller: 'instadebitCardDetailsController',
						controllerAs: 'instadebitCardDetailsVm',
					}
				}
			})
			.state('menu.instaKit_branchDetails', {
				url: '/branchDetails',
				data: {
					pageId: 'IAO_BRCHDETL',
					sectionId: 'aoDebitCardDetailSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/branchDetails/instaKit_branchDetails.html',
						controller: 'instabranchDetailsController',
						controllerAs: 'instabranchDetailsVm',
					}
				}
			})
			.state('menu.instaKit_enterOTPReferenceCode', {
				url: '/enterOTPReferenceCode',
				data: {
					pageId: 'IAO_ENTROTPREFCOD',
					sectionId: 'aoReferenceCodeSection',
					commonId: 'insta_debitCardDetails'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/enterOTPReferenceCode/instaKit_enterOTPReferenceCode.html',
						controller: 'instaenterOTPReferenceCodeController',
						controllerAs: 'instaenterOTPReferenceCodeVm',
					}
				}
			})
			.state('menu.instaKit_startVkyc', {
				url: '/startVkyc',
				data: {
					pageId: 'IAO_STARTVKYC',
					sectionId: 'aoStartVkycSection'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/startVkyc/instaKit_startVkyc.html',
						controller: 'instaStartVkycController',
						controllerAs: 'instaStartVkycVm',
					}
				}
			})
			.state('menu.instaKit_getReady', {
				url: '/getReady',
				data: {
					pageId: 'IAO_GETREADY',
					sectionId: 'aoGetReady'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/startVkyc/instaKit_getReady.html',
						controller: 'instaGetReadyController',
						controllerAs: 'instaGedReadyVm',
					}
				}
			})

			.state('menu.instaKit_getReadyKnowMore', {
				url: '/getReadyKnowMore',
				data: {
					pageId: 'IAO_GETREADYKNOWMORE',
					sectionId: 'aoGetReadyKnowMore'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/startVkyc/instaKit_getReadyKnowMore.html',
						controller: 'instaGetReadyKnowMoreController',
						controllerAs: 'instaGedReadyKnowMoreVm',
					}
				}
			})
			.state('menu.instaKit_locateNearestBranch', {
				url: '/locateNearestBranch',
				data: {
					pageId: 'IAO_LOCNEARBRCH',
					sectionId: 'aoLocateNearestBranchSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/locateNearestBranch/instaKit_locateNearestBranch.html',
						controller: 'instalocateNearestBranchController',
						controllerAs: 'instalocateNearestBranchVm',
					}
				}
			})
			.state('menu.instaKit_locateBranchByLocality', {
				url: '/locateBranchByLocality',
				data: {
					pageId: 'IAO_LOCNEARBRCH',
					sectionId: 'aoLocateNearestBranchSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/locateNearestBranch/instaKit_locateBranchByLocality.html',
						controller: 'instalocateBranchByLocalityController',
						controllerAs: 'instalocateBranchLocVm',
					}
				}
			})
			.state('menu.instaKit_sbiInTouchRegisterOptions', {
				url: '/sbiInTouchRegisterOptions',
				data: {
					pageId: 'IAO_SBIINTCHREGOPTN',
					sectionId: 'aoSbiIntouchRegisterSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/sbiInTouch/instaKit_sbiInTouchRegisterOptions.html',
						controller: 'instasbiInTouchRegisterOptionsController',
						controllerAs: 'instasbiInTouchRegisterOptionsVm',
					}
				}
			})
			.state('menu.instaKit_homePage', {
				url: '/homePage',
				data: {
					pageId: 'IAO_HOMPG',
					sectionId: 'aoHomePageSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/homePage/instaKit_homePage.html',
						controller: 'instahomePageController',
						controllerAs: 'instahomePageVm',
					}
				}
			})
			.state('menu.instaKit_addFundsToYourAccount', {
				url: '/addFundsToYourAccount',
				data: {
					pageId: 'IAO_ADDFNDTOACCT',
					sectionId: 'aoAddFundSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/addFundsToYourAccount/instaKit_addFundsToYourAccount.html',
						controller: 'instaaddFundsToYourAccountController',
						controllerAs: 'instaaddFundsToYourAccountVm',
					}
				}
			})
			.state('menu.instaKit_detailsExist', {
				url: '/detailsExist',
				data: {
					pageId: 'IAO_DETLEXST',
					sectionId: 'aodetailsExistSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/detailsExist/instaKit_detailsExist.html',
						controller: 'instadinstaetailsExistController',
						controllerAs: 'instadetailsExistVm',
					}
				}
			})
			.state('menu.instaKit_resumeJourney', {
				url: '/resumeJourney',
				data: {
					pageId: 'IAO_RESMJRNY',
					sectionId: 'aoResumeSection'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/resumeJourney/instaKit_resumeJourney.html',
						controller: 'instaresumeJourneyController',
						controllerAs: 'instaresumeJourneyVm',
					}
				}
			})
			.state('menu.ao_landing', {
				url: '/aoLanding',
				data: {
					pageId: 'AO_LNDG'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/aoLanding/ao_landing.html',
						controller: 'aoLandingController',
						controllerAs: 'aoLandingVm',
					}
				}
			})
			.state('menu.instaKit_aadhaarValidation', {
				url: '/aadhaarValidation',
				data: {
					pageId: 'IAO_ADHRVLDTN',
					sectionId: 'aoAadhaarValidation',
					commonId: 'insta_aadhaarConsent'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/aadhaarValidation/instaKit_aadhaarValidation.html',
						controller: 'instaAadhaarValidationController',
						controllerAs: 'instaaadhaarValidVm',
					}
				}
			})
			.state('menu.instaKit_aoAadhaarOtp', {
				url: '/aadhaarOTP',
				data: {
					pageId: 'IAO_ADHROTP',
					sectionId: 'aoAadhaarOtp',
					commonId: 'insta_aadhaarOtp'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/aadhaarOTP/instaKit_aadhaarOTP.html',
						controller: 'instaAadhaarOTPController',
						controllerAs: 'instaAadhaarOTPAoVm',
					}
				}
			})
			.state('menu.instaKit_locateBranchByGps', {
				url: '/locateNearestBranch',
				data: {
					pageId: 'IAO_LOCATEBRCH',
					sectionId: 'locateNearestBranch'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/locateNearestBranch/instaKit_locateBranchByGps.html',
						controller: 'instalocateBranchByGpsController',
						controllerAs: 'instalocateBranchGpsVm',
					}
				}
			})

		  .state('menu.companyDetails', {
				url: '/companyDetails',
				data: {
					pageId: 'SAL_EMPDETAILS',
					sectionId: 'empDetails'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/companyDetails/companyDetails.html',
						controller: 'companyDetailsController',
						controllerAs: 'companyDetailsVm',
					}
				}
			})


			.state('menu.salaryUploadDoc', {
				url: '/salaryUploadDoc',
				data: {
					pageId: 'SAL_UPLOADDOC',
					sectionId: 'uplaodDocuments',
					commonId: 'insta_debitCardDetails'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/salaryUploadDoc/salaryUploadDoc.html',
						controller: 'salaryUploadDocController',
						controllerAs: 'salaryUploadDocVm',
					}
				}
			})


			.state('menu.accountOpeningProcessAtglance', {
				url: '/accountOpeningProcessAtglance',
				data: {
					pageId: 'AO_PROCESSGLANCE',
					sectionId: 'processGlanceAOSection'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/accountOpening/instaKit_accountOpeningProcessAtglance.html',
						controller: 'instaaccountOpeningProcessGlanceController',
						controllerAs: 'instaaccountOpeningProcessGlanceVm',
					}
				}
			})
			
			.state('menu.accountOpeningProcessGlanceFAQ', {
				url: '/accountOpeningProcessGlanceFAQ',
				data: {
					pageId: 'AO_PROCESSGLANCEFAQ',
					sectionId: 'processGlanceAOSectionFAQ'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/instaKit/accountOpening/instaKit_accountOpeningProcessGlanceFAQ.html',
						controller: 'instaaccountOpeningProcessGlanceFAQController',
						controllerAs: 'instaaccountOpeningProcessGlanceFAQVm',
					}
				}
			})
				

	}]);
