'use strict';

angularApp.controller('instalocateBranchController', ["$state",
    "$scope",
    "instalocateBranchService",
    "instaService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        instalocateBranchService,
        instaService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instalocateBranchVm = this;

        function initPage() {
            instalocateBranchVm.showBack = true;
            instalocateBranchVm.showNext = false;
            instalocateBranchVm.loadLocateBranchContent();
            instalocateBranchVm.aofooter = true;
        }

        $scope.goToHome = function() {
           instaService.homeNav();
        }

        instalocateBranchVm.goBacktoPrevious = function() {
            $state.go("menu.instaKit_tax");
        }

        instalocateBranchVm.displaymap = function() {
            $state.go('menu.instaKit_locateNearestBranch');
        }

        instalocateBranchVm.loadLocateBranchContent = function() {
            instalocateBranchService.getLocateBranchContent().then(function(data) {
                instalocateBranchVm.locateBranchMsg = data;
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });
        
        return this;
    }
]);
