'use strict';

angularApp.controller('instalocateBranchByGpsController', ["$state",
    "$scope",
    "instalocateNearestBranchService",
    "instaService",
    "utilityService",
    "currentLocationService",
    "$timeout",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        instalocateNearestBranchService,
        instaService,
        utilityService,
        currentLocationService,
        $timeout,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instalocateBranchGpsVm = this;

        function initPage() {
            instalocateBranchGpsVm.showBack = true;
            //instalocateBranchGpsVm.showNext = true;
            //instalocateBranchGpsVm.disableNext = true;
            instalocateBranchGpsVm.showRadioBtn = true;
            instalocateBranchGpsVm.showLink = true;
            instalocateBranchGpsVm.aofooter = true;
            instalocateBranchGpsVm.gpsLink = true;
        }

        instalocateBranchGpsVm.goBacktoPrevious = function() {
            $state.go('menu.instaKit_locateNearestBranch');
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        instalocateBranchGpsVm.validateForm = function(isValid) {
            if (isValid) {
                instalocateBranchGpsVm.disableNext = false;
            }
        }

        instalocateBranchGpsVm.navigatePage = function(param){
           var geocoords = param.latitude + ',' + param.longitude;
           if(utilityService.isUndefined(param.latitude) || utilityService.isUndefined(param.longitude)){
                var title = '';
                var template = '{{"NO_DIR" | translate}}';
                var onTap = 'menu.locateBranchByLocality';
                var buttontext = '<b>' + instalocateBranchGpsVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            }
            else{
                if (utilityService.isIOSPlatform()) {
                  window.open('maps://?q=' + geocoords, '_system');
                }
                else {
                  var label = encodeURI('Your Destination'); // encode the label!
                  window.open('geo:0,0?q=' + geocoords + '(' + label + ')', '_system');
                }  
            }
        }

        //Service for displaying branch list for latitude and longitude
        instalocateBranchGpsVm.loadBranchesGps = function() {            
            instalocateBranchGpsVm.bankListGps = instaService.locateByGPS;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        $scope.$on('$ionicView.beforeEnter', function() {
            instalocateBranchGpsVm.loadBranchesGps(); 
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn); 
        });

        return this;
    }
]);
