'use strict';

angularApp.controller('instalocateBranchByLocalityController', ["$state",
    "$scope",
    "instalocateNearestBranchService",
    "instaService",
    "utilityService",
    "$ionicHistory",
    "$translate",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        instalocateNearestBranchService,
        instaService,
        utilityService,
        $ionicHistory,
        $translate,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instalocateBranchLocVm = this;

        function initPage() {
            instalocateBranchLocVm.showBack = true;
            instalocateBranchLocVm.showNext = false;
            instalocateBranchLocVm.disableNext = true;
            instalocateBranchLocVm.bankListLocality = [];
            instalocateBranchLocVm.aofooter = true;
            instalocateBranchLocVm.showRadioBtn = false;
            instalocateBranchLocVm.showLink = true;
            instalocateBranchLocVm.localityname="";


            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                instalocateBranchLocVm.okBtntext = translatedvalue;
            });
        }

        instalocateBranchLocVm.goBacktoPrevious = function() {
            //$ionicHistory.goBack();
            $state.go('menu.instaKit_locateNearestBranch');
        }

        instalocateBranchLocVm.navigatePage = function(param){
           var geocoords = param.latitude + ',' + param.longitude;
           if(utilityService.isUndefined(param.latitude) || utilityService.isUndefined(param.longitude)){
                var title = '';
                var template = '{{"NO_DIR" | translate}}';
                var onTap = 'menu.instaKit_locateBranchByLocality';
                var buttontext = '<b>' + instalocateBranchLocVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            }
            else{
                if (utilityService.isIOSPlatform()) {
                  window.open('maps://?q=' + geocoords, '_system');
                }
                else {
                  var label = encodeURI('Your Destination'); // encode the label!
                  window.open('geo:0,0?q=' + geocoords + '(' + label + ')', '_system');
                }  
            }
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        //Make the radio button checked if the respective div is clicked
        instalocateBranchLocVm.checkDiv = function(param) {
            instalocateBranchLocVm.branchList = param.id;
            instalocateBranchLocVm.disableNext = false;
            instaService.homeBranchLocalityId = param.id;
            instaService.homeBranchLocalityCity = param.city;
        }

        instalocateBranchLocVm.onclickValidation = function(isValid) {
            instalocateBranchLocVm.hideOptions = true;
            for(var i=0;i<instalocateBranchLocVm.displayCities.length;i++){
                if(!utilityService.isUndefined(instalocateBranchLocVm.localityname)){
                    if(instalocateBranchLocVm.displayCities[i].toLowerCase() == instalocateBranchLocVm.localityname.toLowerCase()){
                        instalocateBranchLocVm.loadBranchesLocality();
                    }
                }
                else {
                    instalocateBranchLocVm.bankListLocality = [];
                    instalocateBranchLocVm.disableNext = true;
                }
                
            }
        }

        instalocateBranchLocVm.onChangeFn = function(value) {
            if (!utilityService.isUndefined(value)) {
                if (value.length == 3) {
                    instalocateBranchLocVm.loadBranchesLocality();
                }
            } else {
                instalocateBranchLocVm.bankListLocality = [];
                instalocateBranchLocVm.disableNext = true;
            }

        }

        instalocateBranchLocVm.showHideFilterDropDown = function(city) {
            if (!utilityService.isUndefined(city)) {
                instalocateBranchLocVm.localityname = city;
                instalocateBranchLocVm.loadBranchesLocality();
            } else {
                instalocateBranchLocVm.hideOptions = false;
            }
        }

        instalocateBranchLocVm.getCountriesList = function() {
            instalocateNearestBranchService.getAllCities().then(function(body) {
                if(!utilityService.isUndefined(body)){
                    for (var i = 0; i < body.length; i++) {                    
                        instalocateBranchLocVm.displayCities.push(body[i]);
                        instalocateBranchLocVm.displayCities.sort();
                    }
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }


        instalocateBranchLocVm.validateForm = function(isValid) {
            if (isValid) {
                instalocateBranchLocVm.disableNext = false;
            }
        }

        instalocateBranchLocVm.selectedBranch = function(param) {
            instaService.branchname = param.branchName;
            instaService.branchaddress = param.address;
            instaService.homeBranchLocalityId = param.id;
            instaService.homeBranchLocalityCity = param.city;
        }

        //Service for displaying branch list for locality
        instalocateBranchLocVm.loadBranchesLocality = function() {
            instalocateBranchLocVm.hideOptions = false;
            instalocateBranchLocVm.bankListLocality.length = 0;
            var params = {
                "locality": instalocateBranchLocVm.localityname
            }
            instalocateNearestBranchService.getBranchesForLocality(params).then(function(data) {
                if (utilityService.isUndefined(data.branches) || data.branches.length === 0) {
                    var title = '';
                    var template = '{{"BRANCH_UNAVLBL" | translate}}';
                    var onTap = 'menu.instaKit_locateBranchByLocality';
                    var buttontext = '<b>' + instalocateBranchLocVm.okBtntext + '</b>';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                } else {
                    for (var i = 0; i < data.branches.length; i++) {
                        instalocateBranchLocVm.bankListLocality.push(data.branches[i]);
                    }
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            instalocateBranchLocVm.displayCities = [];
            //instalocateBranchLocVm.getCountriesList();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });   

        return this;
    }
]);
