'use strict';

angularApp.controller('instalocateNearestBranchController', ["$state",
    "$scope",
    "instaService",
    "$ionicHistory",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "currentLocationService",
    "utilityService",
    "instalocateNearestBranchService",
	"$translate",

    function($state,
        $scope,
        instaService,
        $ionicHistory,
        $ionicSideMenuDelegate,
        mPinLoginService,
        currentLocationService,
        utilityService,
        instalocateNearestBranchService,
		$translate) {

        var instalocateNearestBranchVm = this;

        function initPage() {
            instalocateNearestBranchVm.showBack = true;
            instalocateNearestBranchVm.showNext = true;
            instalocateNearestBranchVm.disableNext = true;
            instalocateNearestBranchVm.byLocalityInput = true;
            instalocateNearestBranchVm.aofooter = true;
        }

        instalocateNearestBranchVm.goBacktoPrevious = function() {
            $ionicHistory.goBack();
        }

        instalocateNearestBranchVm.goToNextPage = function() {
            instalocateNearestBranchVm.redirectState();
        }
        
        $scope.goToHome = function() {
            instaService.homeNav();
        }

        instalocateNearestBranchVm.redirectState = function() {
            if (instalocateNearestBranchVm.isGpsClicked === true) {
                $state.go('menu.instaKit_locateBranchByGps');
            } else {
                $state.go('menu.instaKit_locateBranchByLocality');
            }  
        }

        instalocateNearestBranchVm.bylocality = function() {
            instalocateNearestBranchVm.isGpsClicked = false;
            instalocateNearestBranchVm.disableNext = false;
            instalocateNearestBranchVm.byLocalityInput = false;
        }

        instalocateNearestBranchVm.bygps = function() {
            CheckGPS.check(function(){
                currentLocationService.getCurrentPosition().then(
                function(position) {
                    var latitude = position.coords.latitude;
                    var longitude = position.coords.longitude;
                    instaService.locateByGPS.length = 0; 
                    var params = {
                        "latitude": latitude,
                        "longitude":longitude
                    }
                    if(utilityService.isUndefined(instaService.locateByGPS) || instaService.locateByGPS.length === 0){
                        instalocateNearestBranchService.getBranchesForGeo(params).then(function(data) {
                            if(!utilityService.isUndefined(data)){
                                for (var i = 0; i < data.branches.length; i++) {
                                    instaService.locateByGPS.push(data.branches[i]);
                                    setTimeout(function() { 
                                    if(instaService.locateByGPS.length == 0){
                                        var title = '';
                                        var template = '{{"UNABLE_TO_GET_BRANCH" | translate}}';
                                        var onTap = 'menu.instaKit_locateNearestBranch';
                                        var buttontext = 'OK';
                                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                                    }
                                }, 300);
                                }
                            }                            
                        }, function(error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    }
                    else{
                        
                    }
                },
                function(err) {
                  $translate([
						'ON_GPS'
				]).then(function(translations) {
				var title = '';
                var template = translations['ON_GPS'];
                var onTap = '';
                var buttontext = 'OK';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
				});
					
					
                }
            );   
            },
            function(){
				$translate([
						'ENABLE_GPS'
				]).then(function(translations) {
				var title = '';
                var template = translations['ENABLE_GPS'];
                var onTap = '';
                var buttontext = 'OK';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
				});
								
				
				
                
            });   
            instalocateNearestBranchVm.isGpsClicked = true;
            instalocateNearestBranchVm.disableNext = false;
            instalocateNearestBranchVm.byLocalityInput = true;
        }

        instalocateNearestBranchVm.validateform = function(isValid) {
            instalocateNearestBranchVm.disableNext = false;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            instaService.localityNav = "locateBranch";
            instaService.localityNextDisable="locateBranchList";
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
