'use strict';

angularApp.service('instalocateNearestBranchService',
    function($q, AdapterUtils, constantConfig) {

        var instalocateNearestBranchService = this;

        instalocateNearestBranchService.getBranchesForLocality = function(params) {
           
             var q = $q.defer(); 
             AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.getBranchesForLocality, params, true).then(
                function(response){ 
                    q.resolve(response.data);
                },
                function(error){    
                    q.reject(error);
                }
            );
            return q.promise;

        };

        instalocateNearestBranchService.getAllCities = function() {
           
             var q = $q.defer(); 
             AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.getAllCities, true).then(
                function(response){ 
                    q.resolve(response.body);
                },
                function(error){    
                    q.reject(error);
                }
            );
            return q.promise;


        };

         instalocateNearestBranchService.getBranchesForGeo = function(params) {

            var q = $q.defer(); 
            AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.getBranchesForGeo + params.longitude + "&latitude=" + params.latitude + "&branchLocator=" + params.branchLocator, false).then(

                function(response){ 
                    q.resolve(response.data);
                },
                function(error){    
                    q.reject(error);
                }
            );
            return q.promise;
        };


        return instalocateNearestBranchService;
    });
