'use strict';

angularApp.controller('instamobileEntryPageController', ["$state",
    "$scope",
    "instamobileEntryPageService",
    "instaService",
    "utilityService",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "$ionicPopup",
    "$ionicPopover",

    function ($state,
        $scope,
        instamobileEntryPageService,
        instaService,
        utilityService,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService,
        $ionicPopup,
        $ionicPopover) {

        var instamobileEntryPageVm = this;

        function initPage() {
            instamobileEntryPageVm.showBack = true;
            instamobileEntryPageVm.showNext = true;
            instamobileEntryPageVm.disableNext = true;
            instamobileEntryPageVm.aofooter = true;
            instamobileEntryPageVm.checkReferralField = false;
            instamobileEntryPageVm.referralMobNo = '';
            instamobileEntryPageVm.policyWording = instaService.getFeature() ? instaService.getFeature() : "";
        }

        instamobileEntryPageVm.goBacktoPrevious = function () {
            $state.go('menu.accountOpeningProcessAtglance');
        }

        instamobileEntryPageVm.goToNextPage = function (isValid, mobNo) {
            instamobileEntryPageVm.submitForm(isValid, mobNo);
        }

        $scope.goToHome = function () {
            instaService.homeNav();
        }

        instamobileEntryPageVm.checkFormValid = function (isValid) {
            if (instamobileEntryPageVm.newMail ? (isValid == true && instamobileEntryPageVm.restrictedDomainNames == false) : isValid) {
                // if(isValid){ ------ Enable this line in case of removal of email service and comment above line
                instamobileEntryPageVm.disableNext = false;
            }
            else {
                instamobileEntryPageVm.disableNext = true;
            }
        }

        //Get OTP Service call
        instamobileEntryPageVm.submitForm = function (isValid, mobNo) {
            if (isValid) {
                instamobileEntryPageVm.checkIfDetailsExists(mobNo);
                //this.invokeGetOTPService(mobNo);
                if (!utilityService.isUndefined(instamobileEntryPageVm.referralMobNo)) {
                    instamobileEntryPageVm.setReferralMobNo(mobNo, instamobileEntryPageVm.referralMobNo)
                }
            }
        }

        instamobileEntryPageVm.checkReferralCode = function () {
            if (utilityService.isUndefined(instamobileEntryPageVm.referralMobNo)) {
                instamobileEntryPageVm.checkReferralField = false;
            }
            else {
                instamobileEntryPageVm.checkReferralField = true;
            }
        }

        instamobileEntryPageVm.invokeGetOTPService = function (mobilenumber) {
            // var requestParams = {
            //     "id": mobilenumber,
            //     "recipientMailId": instamobileEntryPageVm.newMail
            // }
            // instamobileEntryPageService.getOtp(requestParams).then(function(response) {
            //Success - Data
            // instaService.customer.otpNo = utilityService.getValue(response.data.otp);
            instaService.customer.emailId = instamobileEntryPageVm.newMail;
            instaService.customer.mobileNo = instamobileEntryPageVm.newMobile;
            if (instamobileEntryPageVm.newMail) {
                $state.go("menu.instaKit_emailOTP");
            } else {
                $state.go("menu.instaKit_getOTP");
            }

            //instamobileEntryPageVm.getOtpFromEmail(mobilenumber);
            // }, function(error) {
            //     utilityService.showErrorMessage(error.responseMessage); 
            // });
        }

        instamobileEntryPageVm.setReferralMobNo = function (user_mob_no, ref_mob_no) {
            var requestParams = {
                "mobileNo": user_mob_no,
                "referralMobNo": ref_mob_no,
                "journeyName": "AO_INSTA",
                "status": "Inprogress"
            }
            instamobileEntryPageService.setReferralMobNo(requestParams).then(function (response) {
            }, function (error) {
                // utilityService.showErrorMessage(error.responseMessage); 
            });
        }

        instamobileEntryPageVm.restrictEmailDomains = function () {
            if (instamobileEntryPageVm.getOtpForm.emailId.$valid == true) {
                if (!instamobileEntryPageVm.newMail) {
                    instamobileEntryPageVm.restrictedDomainNames = false;
                }
                else {
                    var newmail = instamobileEntryPageVm.newMail;
                    var newmailCase = newmail.toLowerCase();
                    var mailSplit = newmailCase.split("@")[0];
                    var postMailSplit = newmailCase.split("@")[1];

                    if (mailSplit.indexOf("sbi") != -1 && (/\d/g.test(mailSplit)) === true) {
                        instamobileEntryPageVm.restrictedDomainNames = true;
                    }
                    else if (postMailSplit.indexOf("gmail") != -1 && postMailSplit.indexOf(".com") === -1) {
                        instamobileEntryPageVm.restrictedDomainNames = true;
                    }
                    else if (postMailSplit.indexOf("yahoo") != -1) {
                        var yahooExtensions = [".com", ".co.in", ".in"];
                        var count = 0;
                        for (var i = 0; i < yahooExtensions.length; i++) {
                            if (postMailSplit.indexOf(yahooExtensions[i]) != -1) {
                                count++;
                            }
                        }
                        if (count > 0) {
                            instamobileEntryPageVm.restrictedDomainNames = false;
                        }
                        else {
                            instamobileEntryPageVm.restrictedDomainNames = true;
                        }
                    }
                    else if (postMailSplit.indexOf("rediffmail") != -1 && postMailSplit.indexOf(".com") === -1) {
                        instamobileEntryPageVm.restrictedDomainNames = true;
                    }
                    else {
                        instamobileEntryPageVm.restrictedDomainNames = false;
                    }
                }
            }
        }
        var mobNoExists = "";
        instamobileEntryPageVm.checkIfDetailsExists = function (mobileNumber) {
            var requestParams = {
                "id": mobileNumber,
                "journeyType": instamobileEntryPageVm.journeyType
            }
            instamobileEntryPageService.getCustomerDetails(requestParams).then(function (response) {
                //var customerDetails = response.data;
                if (response.data == null && response.responseCode == constantConfig.successCode) {
                    //instamobileEntryPageVm.invokeGetOTPService(mobileNumber);
                    mobNoExists = response.responseCode;
                    var title = '';
                    var registeredTemplate = 'Mobile number is already registered. Kindly resume';
                    var onTap = 'menu.instaKit_resumeJourney';
                    var buttontext = '<b>' + 'OK' + '</b>';
                    utilityService.showAlertModal(title, registeredTemplate, onTap, $scope, $state, buttontext);

                }
            }, function (error) {
                mobNoExists = error.responseCode;
                if (!utilityService.isUndefined(error.data)) {
                    if (error.data.type.toLowerCase() == "ao") {
                        var title = '';
                        var noInstaTemplate = '{{"NOT_INSTA_ACC" | translate}}';
                        var onTap = 'menu.resumeAccountPageAO';
                        var buttontext = '<b>' + 'OK' + '</b>';
                        utilityService.showAlertModal(title, noInstaTemplate, onTap, $scope, $state, buttontext);
                    }
                } else if (error.responseCode == "0001" || error.responseCode == "0008") {
                    utilityService.showErrorMessage(error.responseMessage);
                }
                else {
                    instamobileEntryPageVm.invokeGetOTPService(mobileNumber);
                }
            });
        }

          /* Info Popup */
          var template = '<ion-popover-view class="tooltiptext ao-long-popupInfo roboto-regular">' + '<ion-content>' +
          '<div class="" ng-bind="instamobileEntryPageVm.getInfoMsg"></div>' + '</ion-content>' + '</ion-popover-view>';
 
      $scope.popover = $ionicPopover.fromTemplate(template, {
          scope: $scope
      });

        instamobileEntryPageVm.infoPopup = function($event) {
            instamobileEntryPageVm.getInfoMsg = "Separate OTP would be sent on E-mail and Mobile Number.";
            $scope.popover.show($event); 
                
       };

        instamobileEntryPageVm.openReferralInfoPopup = function () {
            var userInfoPopUp = $ionicPopup.show({
                template: '<p>Please enter Mobile Number of the person who recommended YONO here.</p>',
                title: '',
                cssClass: 'dialog',
                scope: $scope,
                buttons: [{
                    text: 'OK',
                    type: 'button-positive'
                }]
            });
        };

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            instamobileEntryPageVm.journeyType = instaService.journeyType;
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
