'use strict';

angularApp.controller('instanetBankingRegisterController', ["$state",
    "$scope",
    "instanetBankingRegisterService",
    "instaService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        instanetBankingRegisterService,
        instaService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instanetBankingRegisterVm = this;

        function initPage() {
            instanetBankingRegisterVm.showBack = true;
            instanetBankingRegisterVm.showNext = true;
            instanetBankingRegisterVm.reAppPasswordCheck = false;
            instanetBankingRegisterVm.disableNext = true;
            instanetBankingRegisterVm.aofooter = true;
        }

        instanetBankingRegisterVm.goBacktoPrevious = function() {
            $state.go('menu.instaKit_accountOpeningDetails');
        }

        instanetBankingRegisterVm.goToNextPage = function() {
            var requestParams = {
                "lotusId" : instaService.customer.lotusId,
                "tempUsername": instanetBankingRegisterVm.tempUsername,
                "internetBankingUsername": instanetBankingRegisterVm.ibUsername,
                "password": instanetBankingRegisterVm.password
            }
            instanetBankingRegisterService.registerInternetBanking(requestParams).then(function(response) {
               $state.go('menu.instaKit_aoMpin');
            }, function(error) {
              utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        instanetBankingRegisterVm.changePassword = function() {
            if (instanetBankingRegisterVm.cpassword != instanetBankingRegisterVm.password) {
                instanetBankingRegisterVm.cpassword = "";
                instanetBankingRegisterVm.reAppPasswordCheck = true;
                instanetBankingRegisterVm.disableNext = true;
                return true;
            }
            instanetBankingRegisterVm.reAppPasswordCheck = false;
            return true;
        }

        instanetBankingRegisterVm.changeCPassword = function() {
            if (instanetBankingRegisterVm.cpassword != instanetBankingRegisterVm.password) {
                instanetBankingRegisterVm.reAppPasswordCheck = false;
            }
            return true;
        }

        instanetBankingRegisterVm.proceedSuccess = function(isValid) {
            isValid ? instanetBankingRegisterVm.disableNext = false : instanetBankingRegisterVm.disableNext = true;
            return instanetBankingRegisterVm.disableNext;
        }
        
        instanetBankingRegisterVm.validateForm = function(isValid) {
            instanetBankingRegisterVm.disableNext = !isValid;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
