'use strict';

angularApp.controller('instanomineeAddressController', ["$state",
    "$scope",
    "instaService",
    "instanomineeDetailsRelatedService",
    "utilityService",
    "$timeout",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "constantConfig",

    function($state,
        $scope,
        instaService,
        instanomineeDetailsRelatedService,
        utilityService,
        $timeout,
        $ionicSideMenuDelegate,
        mPinLoginService,
        constantConfig) {

        var instanomineeAddressVm = this;

        function initPage() {
            instanomineeAddressVm.personalDetails = {};
            instanomineeAddressVm.showBack = true;
            instanomineeAddressVm.showNext = true;
            instanomineeAddressVm.aofooter = true;
            instanomineeAddressVm.disableNext = true;
        }

        instanomineeAddressVm.goBacktoPrevious = function() {
            $state.go("menu.instaKit_nomineeDetailsAddressOption");
        }

        instanomineeAddressVm.setGuardianDetails = function() {
            var guardianDetails = {};
            if (instaService.isNomineeScanned === true) {
                guardianDetails.nomineeName = instaService.nomineeAadhaarCardDetails.name;
                guardianDetails.guardianName = instaService.nomineeAadhaarCardDetails.guardianName;
            } else {
                guardianDetails.nomineeName = instaService.nominee.name;
                guardianDetails.guardianName = instaService.nominee.guardianName;
            }
            return guardianDetails;
        }

        /*$scope.$watch("instanomineeAddressVm.guardian-appoint.$valid", function(value) {
            if (value === true) {
                instanomineeAddressVm.disableNext = false;
            } else {
                instanomineeAddressVm.disableNext = true;
            }
        });*/

        instanomineeAddressVm.changefn = function() {
            //instanomineeAddressVm.disableNext = !isValid;
            if (instanomineeAddressVm.isChecked) {
                instanomineeAddressVm.disableNext = false;
            } else {
                instanomineeAddressVm.disableNext = true;
            }
        }

        instanomineeAddressVm.goToNextPage = function() {
            //Service to update guardian details
            var guardianDetailParams = instanomineeAddressVm.setGuardianDetails();
            instaService.nomineeGuardianDetails.guardianConsent = instanomineeAddressVm.isChecked;
            if(utilityService.isUndefined(guardianDetailParams.guardianName)){
              var title = '';
              var template = '{{"IF_GUARDIAN_NAME_EMPTY" | translate}}';
              var onTap = 'menu.instaKit_nominationRelated';
              var buttontext = 'OK';
              utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            }
            else{
            var params = {
                "id": instaService.customer.mobileNo,
                "data": {
                    "nominees": [{
                        "guardian": {
                            "address": {
                                "addressLine1": instanomineeAddressVm.personalDetails.addressLine1,
                                "addressLine2": instanomineeAddressVm.personalDetails.addressLine2,
                                "pincode": instanomineeAddressVm.personalDetails.pincode,
                                "city": instanomineeAddressVm.personalDetails.city,
                                "cityCode":"",
                                "state": instanomineeAddressVm.personalDetails.state,
                                "stateCode":"",
                                "locality": ""
                            },
                            "name": guardianDetailParams.guardianName,
                            "guardianAddressFlag": instaService.nominee.guardianAddressFlag,
                            "guardianConsent" : instaService.nomineeGuardianDetails.guardianConsent
                        },
                        "name": guardianDetailParams.nomineeName
                    }],
                    "commonId": $state.$current.data.commonId
                }
            }
            instanomineeDetailsRelatedService.updateGuardian(params).then(function(response) {
                // $state.go("menu.instaKit_selectBranchListLocality");
                if (instaService.isResumeJourney && instaService.homeBranchLocalityId) {
                    $state.go("menu.instaKit_reviewSelectedBranch");
                } else {
                    $state.go("menu.instaKit_selectBListLocalityByPincode");
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
          }
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        instanomineeAddressVm.displayGuardianAddress = function() {
            instanomineeAddressVm.isChecked = instaService.nomineeGuardianDetails.guardianConsent;
            if (instaService.isAadharManualEntry === false) {
                if (instaService.isResumeJourney === false && instaService.correspondenceCheckStatus == false) {
                    instanomineeAddressVm.personalDetails.addressLine1 = instaService.nullCheck(instaService.customerAadhaarCardDetails.house) + instaService.nullCheck(instaService.customerAadhaarCardDetails.street);
                    instanomineeAddressVm.personalDetails.addressLine2 = instaService.nullCheck(instaService.customerAadhaarCardDetails.lm) + instaService.nullCheck(instaService.customerAadhaarCardDetails.loc) + instaService.nullCheck(instaService.customerAadhaarCardDetails.vtc) + instaService.nullCheck(instaService.customerAadhaarCardDetails.po);
                    instanomineeAddressVm.personalDetails.address = instaService.nullCheck(instaService.customerAadhaarCardDetails.house) + instaService.nullCheck(instaService.customerAadhaarCardDetails.street) + instaService.nullCheck(instaService.customerAadhaarCardDetails.lm) + instaService.nullCheck(instaService.customerAadhaarCardDetails.loc) + instaService.nullCheck(instaService.customerAadhaarCardDetails.vtc) + instaService.nullCheck(instaService.customerAadhaarCardDetails.po) + instaService.nullCheck(instaService.customerAadhaarCardDetails.dist) + instaService.nullCheck(instaService.customerAadhaarCardDetails.state);
                    instanomineeAddressVm.personalDetails.pincode = instaService.customerAadhaarCardDetails.pc;
                    instanomineeAddressVm.personalDetails.city = instaService.customerAadhaarCardDetails.dist;
                    instanomineeAddressVm.personalDetails.state = instaService.customerAadhaarCardDetails.state;
                } else if (instaService.correspondenceCheckStatus == true) {
                    instanomineeAddressVm.personalDetails.addressLine1 = instaService.nullCheck(instaService.customerCorrespondenceAddress.address1);
                    instanomineeAddressVm.personalDetails.addressLine2 = instaService.nullCheck(instaService.customerCorrespondenceAddress.address2);
                    instanomineeAddressVm.personalDetails.address = instaService.nullCheck(instaService.customerCorrespondenceAddress.address1) + instaService.nullCheck(instaService.customerCorrespondenceAddress.address2);
                    instanomineeAddressVm.personalDetails.pincode = instaService.customerCorrespondenceAddress.pincode;
                    instanomineeAddressVm.personalDetails.city = instaService.customerCorrespondenceAddress.city;
                    instanomineeAddressVm.personalDetails.state = instaService.customerCorrespondenceAddress.state;
                } else {
                    instanomineeAddressVm.personalDetails.addressLine1 = instaService.nullCheck(instaService.customerAadhaarCardDetails.house);
                    instanomineeAddressVm.personalDetails.addressLine2 = instaService.nullCheck(instaService.customerAadhaarCardDetails.street);
                    instanomineeAddressVm.personalDetails.address = instaService.nullCheck(instaService.customerAadhaarCardDetails.house) + instaService.nullCheck(instaService.customerAadhaarCardDetails.street);
                    instanomineeAddressVm.personalDetails.pincode = instaService.customerAadhaarCardDetails.pc;
                    instanomineeAddressVm.personalDetails.city = instaService.customerAadhaarCardDetails.dist;
                    instanomineeAddressVm.personalDetails.state = instaService.customerAadhaarCardDetails.state;
                }
            } else if (instaService.isAadharManualEntry === true) {

                if (instaService.isCustManualCorresChkBox == true) {
                    instanomineeAddressVm.personalDetails.addressLine1 = instaService.nullCheck(instaService.aadhaarManualCorrespondenceAddress.address1);
                    instanomineeAddressVm.personalDetails.addressLine2 = instaService.nullCheck(instaService.aadhaarManualCorrespondenceAddress.address2);
                    instanomineeAddressVm.personalDetails.address = instaService.nullCheck(instaService.aadhaarManualCorrespondenceAddress.address1) + instaService.nullCheck(instaService.aadhaarManualCorrespondenceAddress.address2);
                    instanomineeAddressVm.personalDetails.pincode = instaService.aadhaarManualCorrespondenceAddress.pincode;
                    instanomineeAddressVm.personalDetails.city = instaService.aadhaarManualCorrespondenceAddress.city;
                    instanomineeAddressVm.personalDetails.state = instaService.aadhaarManualCorrespondenceAddress.state;
                }else if (instaService.correspondenceCheckStatus == false) {
                    instanomineeAddressVm.personalDetails.addressLine1 = instaService.nullCheck(instaService.customerAadhaarCardDetails.house) + instaService.nullCheck(instaService.customerAadhaarCardDetails.street);
                    instanomineeAddressVm.personalDetails.addressLine2 = instaService.nullCheck(instaService.customerAadhaarCardDetails.lm) + instaService.nullCheck(instaService.customerAadhaarCardDetails.loc) + instaService.nullCheck(instaService.customerAadhaarCardDetails.vtc) + instaService.nullCheck(instaService.customerAadhaarCardDetails.po);
                    instanomineeAddressVm.personalDetails.address = instaService.nullCheck(instaService.customerAadhaarCardDetails.house) + instaService.nullCheck(instaService.customerAadhaarCardDetails.street) + instaService.nullCheck(instaService.customerAadhaarCardDetails.lm) + instaService.nullCheck(instaService.customerAadhaarCardDetails.loc) + instaService.nullCheck(instaService.customerAadhaarCardDetails.vtc) + instaService.nullCheck(instaService.customerAadhaarCardDetails.po) + instaService.nullCheck(instaService.customerAadhaarCardDetails.dist) + instaService.nullCheck(instaService.customerAadhaarCardDetails.state);
                    instanomineeAddressVm.personalDetails.pincode = instaService.customerAadhaarCardDetails.pc;
                    instanomineeAddressVm.personalDetails.city = instaService.customerAadhaarCardDetails.dist;
                    instanomineeAddressVm.personalDetails.state = instaService.customerAadhaarCardDetails.state;
                } else if (instaService.correspondenceCheckStatus == true) {
                    instanomineeAddressVm.personalDetails.addressLine1 = instaService.nullCheck(instaService.customerCorrespondenceAddress.address1);
                    instanomineeAddressVm.personalDetails.addressLine2 = instaService.nullCheck(instaService.customerCorrespondenceAddress.address2);
                    instanomineeAddressVm.personalDetails.address = instaService.nullCheck(instaService.customerCorrespondenceAddress.address1) + instaService.nullCheck(instaService.customerCorrespondenceAddress.address2);
                    instanomineeAddressVm.personalDetails.pincode = instaService.customerCorrespondenceAddress.pincode;
                    instanomineeAddressVm.personalDetails.city = instaService.customerCorrespondenceAddress.city;
                    instanomineeAddressVm.personalDetails.state = instaService.customerCorrespondenceAddress.state;
                } else {
                    var title = '';
                    var template = '{{"APPLICANT_ADDRESS_IF_EMPTY" | translate}}';
                    var onTap = 'menu.instaKit_nomineeDetailsAddressOption';
                    var buttontext = 'OK';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                }
            }
            if (!utilityService.isUndefined(instanomineeAddressVm.personalDetails.addressLine1)) {
                var index = instanomineeAddressVm.personalDetails.addressLine1.lastIndexOf(",");
                instanomineeAddressVm.personalDetails.addressLine1 = instanomineeAddressVm.personalDetails.addressLine1.substring(0, index) + instanomineeAddressVm.personalDetails.addressLine1.substring(index + 1);
            }
            if (!utilityService.isUndefined(instanomineeAddressVm.personalDetails.addressLine2)) {
                var index = instanomineeAddressVm.personalDetails.addressLine2.lastIndexOf(",");
                instanomineeAddressVm.personalDetails.addressLine2 = instanomineeAddressVm.personalDetails.addressLine2.substring(0, index) + instanomineeAddressVm.personalDetails.addressLine2.substring(index + 1);
            }
            if (!utilityService.isUndefined(instanomineeAddressVm.personalDetails.address)) {
                var index = instanomineeAddressVm.personalDetails.address.lastIndexOf(",");
                instanomineeAddressVm.personalDetails.address = instanomineeAddressVm.personalDetails.address.substring(0, index) + instanomineeAddressVm.personalDetails.address.substring(index + 1);
            }
        }

        instanomineeAddressVm.guardianDetails = function(){
          if(instaService.isNomineeScanned === true){
                instanomineeAddressVm.guardianConName = instaService.nomineeAadhaarCardDetails.guardianName;
                instanomineeAddressVm.guardianConAge = instaService.nomineeAadhaarCardDetails.guardianAge;
            }
            else{
                instanomineeAddressVm.guardianConName = instaService.nominee.guardianName;
                instanomineeAddressVm.guardianConAge = instaService.nominee.guardianAge;
            }
      }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            instanomineeAddressVm.journeyType = instaService.journeyType;
            instanomineeAddressVm.constantJourneyTypeVKYC = constantConfig.acOpeningAdapterOVDConstant.vkycInsta;
            instanomineeAddressVm.displayGuardianAddress();
            if(instanomineeAddressVm.isChecked == true){
                instanomineeAddressVm.disableNext = false;
            }
            else{
                instanomineeAddressVm.disableNext = true;
            }
	    instanomineeAddressVm.guardianDetails();
        $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            
        });

        return this;
    }
]);
