'use strict';

angularApp.controller('instanomineeCAddressController', ["$state",
    "$scope",
    "instaService",
    "instanomineeDetailsRelatedService",
    "utilityService",
    "$translate",
    "$timeout",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "constantConfig",

    function($state,
        $scope,
        instaService,
        instanomineeDetailsRelatedService,
        utilityService,
        $translate,
        $timeout,
        $ionicSideMenuDelegate,
        mPinLoginService,
        constantConfig) {

        var instanomineeCAddressVm = this;

        function initPage() {
            instanomineeCAddressVm.showBack = true;
            instanomineeCAddressVm.showNext = true;
            instanomineeCAddressVm.disableNext = true;
            instanomineeCAddressVm.aofooter = true;
            instanomineeCAddressVm.disableState = true;
            instanomineeCAddressVm.disableCity = true;
            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                instanomineeCAddressVm.okBtntext = translatedvalue;
            });
        }

        instanomineeCAddressVm.goBacktoPrevious = function() {
            $state.go("menu.instaKit_nomineeDetailsAddressOption");
        }

        $scope.$watch("instanomineeCAddressVm.guardianNewAddrForm.$valid", function(value) {
            if (value) {
                instanomineeCAddressVm.disableNext = false;
            } else {
                instanomineeCAddressVm.disableNext = true;
            }
        });

        

         

        instanomineeCAddressVm.setGuardianDetails = function() {
            var guardianDetails = {};
            if (instaService.isNomineeScanned === true) {
                guardianDetails.nomineeName = instaService.nomineeAadhaarCardDetails.name;
                guardianDetails.guardianName = instaService.nomineeAadhaarCardDetails.guardianName;
            } else {
                guardianDetails.nomineeName = instaService.nominee.name;
                guardianDetails.guardianName = instaService.nominee.guardianName;
            }
            return guardianDetails;
        }

        instanomineeCAddressVm.goToNextPage = function() {
            instaService.nomineeGuardianDetails.address1 = instanomineeCAddressVm.addressAboveData;
            instaService.nomineeGuardianDetails.address2 = instanomineeCAddressVm.addressBelowData;
            instaService.nomineeGuardianDetails.pincode = instanomineeCAddressVm.pincodeData;
            instaService.nomineeGuardianDetails.city = instanomineeCAddressVm.cityData;
            instaService.nomineeGuardianDetails.state = instanomineeCAddressVm.stateData;
            instaService.nomineeGuardianDetails.locality = instanomineeCAddressVm.localityData;
            instaService.nomineeGuardianDetails.guardianConsent = instanomineeCAddressVm.isChecked;
            var guardianDetailParams = instanomineeCAddressVm.setGuardianDetails();
            if(utilityService.isUndefined(guardianDetailParams.guardianName)){
              var title = '';
              var template = '{{"IF_GUARDIAN_NAME_EMPTY" | translate}}';
              var onTap = 'menu.instaKit_nominationRelated';
              var buttontext = 'OK';
              utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            }
            else{
            //Service to update guardian details
            var params = {
                "id": instaService.customer.mobileNo,
                "data": {
                    "nominees": [{
                        "guardian": {
                            "address": {
                                "addressLine1": instaService.nomineeGuardianDetails.address1,
                                "addressLine2": instaService.nomineeGuardianDetails.address2,
                                "pincode": instaService.nomineeGuardianDetails.pincode,
                                "city": instaService.nomineeGuardianDetails.city,
                                "cityCode": instaService.nomineeGuardianDetails.cityCode,
                                "state": instaService.nomineeGuardianDetails.state,
                                "stateCode": instaService.nomineeGuardianDetails.stateCode,
                                "locality": instaService.nomineeGuardianDetails.locality
                            },
                            "name": guardianDetailParams.guardianName,
                            "guardianAddressFlag": instaService.nominee.guardianAddressFlag,
                            "guardianConsent" : instaService.nomineeGuardianDetails.guardianConsent
                        },
                        "name": guardianDetailParams.nomineeName
                    }],
                    "commonId": $state.$current.data.commonId
                }
            }
            instanomineeDetailsRelatedService.updateGuardian(params).then(function(response) {
                
                if (instaService.isResumeJourney && instaService.homeBranchLocalityId) {
                    $state.go("menu.instaKit_reviewSelectedBranch");
                } else {
                    $state.go("menu.instaKit_selectBListLocalityByPincode");
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
          }
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        instanomineeCAddressVm.changefn = function(param) {
             if (param) {
                if(instanomineeCAddressVm.isChecked){
                    instanomineeCAddressVm.disableNext = false;
                } 
                else{
                    instanomineeCAddressVm.disableNext = true;
                }               
            } else {
                instanomineeCAddressVm.disableNext = true;
            }
        }

        instanomineeCAddressVm.clickCheck = function(isValid){
            if (instanomineeCAddressVm.isChecked) {
                if(isValid){
                    instanomineeCAddressVm.disableNext = false;
                } 
                else{
                    instanomineeCAddressVm.disableNext = true;
                }               
            } else {
                instanomineeCAddressVm.disableNext = true;
            }
        }

        instanomineeCAddressVm.updatedvalue = function(param) {
             if (param) {
                if(instanomineeCAddressVm.isChecked){
                    instanomineeCAddressVm.disableNext = false;
                } 
                else{
                    instanomineeCAddressVm.disableNext = true;
                }               
            } else {
                instanomineeCAddressVm.disableNext = true;
            }
            return instanomineeCAddressVm.disableNext;
        }

        instanomineeCAddressVm.updatearea = function(param) {
            //Service to return city and state based on the pincode entered
            var inputparams = {
                "pinCode": instanomineeCAddressVm.pincodeData
            }
            if (!utilityService.isUndefined(instanomineeCAddressVm.pincodeData) && instanomineeCAddressVm.pincodeData.length == 6 && /^[0-9]{1,6}$/.test(instanomineeCAddressVm.pincodeData) == true) {
                instanomineeDetailsRelatedService.getAreaDetailForPincode(inputparams).then(function(data) {

                    if (utilityService.isUndefined(data)) {
                        var title = '';
                        var template = '{{"PINCODE_MATCH" | translate}}';
                        var onTap = '';
                        var buttontext = '<b>' + instanomineeCAddressVm.okBtntext + '</b>';
                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                        instanomineeCAddressVm.disableState = false;
                        instanomineeCAddressVm.disableCity = false;
                        instanomineeCAddressVm.stateList = "";
                    } else {
                        instanomineeCAddressVm.stateList = data;
                        if (instanomineeCAddressVm.stateList.length == 1) {
                        instaService.customer.city = utilityService.getValue(data[0].cityName);
                        instaService.customer.state = utilityService.getValue(data[0].stateName);
                        instaService.nomineeGuardianDetails.cityCode = utilityService.getValue(data[0].cityCode);
                        instaService.nomineeGuardianDetails.stateCode = utilityService.getValue(data[0].stateCode);
                        instanomineeCAddressVm.cityData = instaService.customer.city;
                        instanomineeCAddressVm.stateData = instaService.customer.state;

                        instanomineeCAddressVm.stateitemData = instaService.nomineeGuardianDetails.stateCode;
                        }
                        instanomineeCAddressVm.disableCity = true;
                        instanomineeCAddressVm.disableState = true;
                    }

                }, function(error) {
                	instanomineeCAddressVm.stateList = "";
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        }

        instanomineeCAddressVm.pincodeChange = function() {
            if (instanomineeCAddressVm.pincodeData === "" || (!utilityService.isUndefined(instanomineeCAddressVm.pincodeData)).length != 6) {
                instanomineeCAddressVm.cityData = "";
                instanomineeCAddressVm.stateData = "";
            }
        }

        instanomineeCAddressVm.checkUpdatedCityStateValid = function(param) {
            instanomineeCAddressVm.updatedvalue(param);
        }

        instanomineeCAddressVm.populateResumeData = function() {
            instanomineeCAddressVm.addressAboveData = utilityService.getValue(instaService.nomineeGuardianDetails.address1);
            instanomineeCAddressVm.addressBelowData = utilityService.getValue(instaService.nomineeGuardianDetails.address2);
            instanomineeCAddressVm.pincodeData = utilityService.getValue(instaService.nomineeGuardianDetails.pincode);
            instanomineeCAddressVm.cityData = utilityService.getValue(instaService.nomineeGuardianDetails.city);
            instanomineeCAddressVm.stateData = utilityService.getValue(instaService.nomineeGuardianDetails.state);
            instanomineeCAddressVm.localityData = utilityService.getValue(instaService.nomineeGuardianDetails.locality);
            instanomineeCAddressVm.isChecked = instaService.nomineeGuardianDetails.guardianConsent;
        }

         instanomineeCAddressVm.guardianDetails = function(){
          if(instaService.isNomineeScanned === true){
                instanomineeCAddressVm.guardianConName = instaService.nomineeAadhaarCardDetails.guardianName;
                instanomineeCAddressVm.guardianConAge = instaService.nomineeAadhaarCardDetails.guardianAge;
            }
            else{
                instanomineeCAddressVm.guardianConName = instaService.nominee.guardianName;
                instanomineeCAddressVm.guardianConAge = instaService.nominee.guardianAge;
            }
      };
      
      instanomineeCAddressVm.loadStateList = function(data) {
				 var inputparams = {
	                "pinCode": instaService.nomineeGuardianDetails.pincode
	           };
	           if(!instanomineeCAddressVm.stateList){
				instanomineeDetailsRelatedService.getAreaDetailForPincode(inputparams).then(function(data) {
	                    if (!utilityService.isUndefined(data)) {
	                        instanomineeCAddressVm.stateList = data;
                            instanomineeCAddressVm.stateCode = instanomineeCAddressVm.stateList[0].stateCode;
	                        instaService.nomineeGuardianDetails.stateCode =  instanomineeCAddressVm.stateCode; 
                            instanomineeCAddressVm.stateitemData = instaService.nomineeGuardianDetails.stateCode;
                            if (instaService.isResumeJourney){
                                if(instanomineeCAddressVm.isChecked){
                                instanomineeCAddressVm.disableNext = false;
                                }else{
                                    instanomineeCAddressVm.disableNext = true;
                                }
                            }
	                    }
	                }, function(error) {
	                });
                }
                else{
                    instanomineeCAddressVm.stateitemData = instaService.nomineeGuardianDetails.stateCode;
                }    
		};	  
		
		instanomineeCAddressVm.setstate = function(data) {
		          if(data){
		            var arr = instanomineeCAddressVm.stateList;
					 var arrLength = arr.length;	
		            for (var i = 0; i < arrLength; i++) {
		                if (arr[i].stateCode == data) {
		                    var tempData = arr[i];
		                    instaService.customer.city = utilityService.getValue(tempData.cityName);
		                            instaService.customer.state = utilityService.getValue(tempData.stateName);
		                            instaService.nomineeGuardianDetails.cityCode = utilityService.getValue(tempData.cityCode);
		                            instaService.nomineeGuardianDetails.stateCode = utilityService.getValue(tempData.stateCode);
		                            instanomineeCAddressVm.cityData = instaService.customer.city;
		                            instanomineeCAddressVm.stateData = instaService.customer.state;
		                            instanomineeCAddressVm.disableCity = true;
		                            instanomineeCAddressVm.disableState = true;
		                }
		            };
		          }
		};
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            instanomineeCAddressVm.journeyType = instaService.journeyType;
            instanomineeCAddressVm.constantJourneyTypeVKYC = constantConfig.acOpeningAdapterOVDConstant.vkycInsta;
            instanomineeCAddressVm.populateResumeData();
            instanomineeCAddressVm.guardianDetails();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            instanomineeCAddressVm.loadStateList();
            instanomineeCAddressVm.isChecked = instaService.nomineeGuardianDetails.guardianConsent;

       
           
        });

        return this;
    }
]);
