'use strict';

angularApp.controller('instanomineeDetailsAddressOptionController', ["$state",
    "$scope",
    "instaService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        instaService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instanomineeDetailsAddressOptionVm = this;

        function initPage() {
            instanomineeDetailsAddressOptionVm.showBack = true;
            instanomineeDetailsAddressOptionVm.showNext = false;
            instanomineeDetailsAddressOptionVm.btnWhite = true;
            instanomineeDetailsAddressOptionVm.aofooter = true;
            instaService.nomineeNav = "nomineeoption";

            instanomineeDetailsAddressOptionVm.addressOptions = [{ "value": "AO_SAMEASNOM_BTN", "description": "nomineeAddress" },
                { "value": "AO_SAMEASAPP_BTN", "description": "applicantAddress" },
                { "value": "AO_NEWADDR_BTN", "description": "newAddress" }
            ];
        }

        instanomineeDetailsAddressOptionVm.goBacktoPrevious = function() {
            $state.go('menu.instaKit_nomineeDetailsNext');
        }

        instanomineeDetailsAddressOptionVm.goToNextPage = function(param) {
            instaService.nominee.guardianAddressFlag = param.description;
            if (param.value === "AO_SAMEASNOM_BTN") {
                $state.go("menu.instaKit_nomineeEnteredAddress");
            } else if (param.value === "AO_SAMEASAPP_BTN") {
                $state.go("menu.instaKit_nomineeAddress");
            } else if (param.value === "AO_NEWADDR_BTN") {
                $state.go("menu.instaKit_nomineeCAddress");
            }
        }

        instanomineeDetailsAddressOptionVm.populateResumeData = function() {
            instanomineeDetailsAddressOptionVm.activeStatus = instaService.getIdByValue(instanomineeDetailsAddressOptionVm.addressOptions, instaService.nominee.guardianAddressFlag);
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            instanomineeDetailsAddressOptionVm.populateResumeData();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
