'use strict';

angularApp.controller('instanomineeDetailsController', ["$state",
    "$scope",
    "instaService",
    "utilityService",
    "$translate",
    "$ionicPopover",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "bhimUpiService",
    function($state,
        $scope,
        instaService,
        utilityService,
        $translate,
        $ionicPopover,
        $ionicSideMenuDelegate,
        mPinLoginService,
        bhimUpiService) {

        var instanomineeDetailsVm = this;
        var alphabets = /^([ \.]?[a-zA-Z]+)+$/;
        var numbers = /^[0-9]*$/;
        var addressRegex = /^[A-z().,-/0-9 #']*$/;

        function initPage() {
            instanomineeDetailsVm.showBack = true;
            instanomineeDetailsVm.showNext = false;
            instanomineeDetailsVm.aofooter = true;
            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                instanomineeDetailsVm.okBtntext = translatedvalue;
            });
        }

        instanomineeDetailsVm.clearNomineeAadhaarDetails = function(){
             instaService.nomineeAadhaarCardDetails = {
                    uid: "",
                    name: "",
                    gender: "",
                    yob: "",
                    co: "",
                    house: "",
                    street: "",
                    lm: "",
                    loc: "",
                    vtc: "",
                    po: "",
                    dist: "",
                    subdist: "",
                    state: "",
                    pc: "",
                    dob: "",
                    relationship: "",
                    guardian: ""
                }
        }

        /* Info Popup */
        var template = '<ion-popover-view class="tooltiptext ao-popupInfo roboto-regular ao-aadhaarInfoHt">' + '<ion-content>' +
                        '<div class="" translate="SCAN_AADHAAR_QRCODE"></div>' + '</ion-content>' + '</ion-popover-view>';

        $scope.popover = $ionicPopover.fromTemplate(template, {
            scope: $scope
        });

        instanomineeDetailsVm.infoPopup = function($event) {
            $scope.popover.show($event);
        };

        instanomineeDetailsVm.closePopover = function() {
            $scope.popover.hide();
        };
       /* Info Popup */

        //QR code scanner code
        instanomineeDetailsVm.goToQRCodeDetails = function() {
            bhimUpiService.getNativeData("scanqrcode", {}).then(function (data) {
                //if(!utilityService.isUndefined(barcodeData.text)){

                    if (device.platform.toLowerCase() == 'android') {
                        var barcodeData = data.scanResult;
                        }else{
                        var barcodeData = data;
                        }

                var xmlText = barcodeData;
                var formattedXml = xmlText.replace("/?xml","?xml");
                formattedXml = formattedXml.replace("xml?","?xml");
                var x2js = new X2JS();
                var jsonObj = x2js.xml_str2json(formattedXml);
                if(utilityService.isUndefined(jsonObj)){
                    var title = '';
                    var template = "{{'AADHAAR_POPUP'| translate}}";
                    var onTap = '';
                    var buttontext = "<b>" +instanomineeDetailsVm.okBtntext+ "</b>";
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext); 
                }
                else{                    
                var jsonStr = JSON.stringify(jsonObj);
                instanomineeDetailsVm.clearNomineeAadhaarDetails();
                instaService.nominee = {
                    uid:'',
                    name: '',
                    firstName:'',
                    middleName:'',
                    lastName:'',
                    relationship: '',
                    guardianName:'',
                    age: '',
                    address1: '',
                    address2: '',
                    pincode: '',
                    dob: '',
                    city: '',
                    state: ''
                }
                var securedScannedData = {
                    _co:instaService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._uid),
                    _dist:instaService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._dist),
                    _dob:instaService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._dob),
                    _gender:instaService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._gender),
                    _house:instaService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._house),
                    _name:instaService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._name),
                    _pc:instaService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._pc),
                    _po:instaService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._po),
                    _state:instaService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._state),
                    _street:instaService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._street),
                    _subdist:instaService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._subdist),
                    _uid:instaService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._uid),
                    _vtc:instaService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._vtc),
                    _yob:instaService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._yob),
                    _loc:instaService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._loc),
                    _lm:instaService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._lm)
                }
				securedScannedData._dob =  instaService.setDateFormatDDMMYYY(securedScannedData._dob);
				
                    if(instaService.checkSecuredData(numbers, securedScannedData._uid) === (instaService.customerAadhaarCardDetails.uid || instaService.customerManualEntryDetails.aadharNumber)){
                        var title = '';
                        var template = "{{'AADHAAR_BOTH_SAME'| translate}}";
                        var onTap = '';
                        var buttontext = "<b>" +instanomineeDetailsVm.okBtntext+ "</b>";
                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext); 
                    }
                    else{
                        setTimeout(function() { 
                            instaService.nomineeAadhaarCardDetails.uid = instaService.checkSecuredData(numbers, securedScannedData._uid);
                            instaService.nomineeAadhaarCardDetails.name = instaService.checkSecuredData(alphabets, securedScannedData._name);
                            instaService.nomineeAadhaarCardDetails.gender = instaService.checkSecuredData(alphabets, securedScannedData._gender);
                            instaService.nomineeAadhaarCardDetails.yob = instaService.checkSecuredData(numbers, securedScannedData._yob);
                            instaService.nomineeAadhaarCardDetails.house = instaService.checkSecuredData(addressRegex, securedScannedData._house);
                            instaService.nomineeAadhaarCardDetails.street = instaService.checkSecuredData(addressRegex, securedScannedData._street);
                            instaService.nomineeAadhaarCardDetails.lm = instaService.checkSecuredData(addressRegex, securedScannedData._lm);
                            instaService.nomineeAadhaarCardDetails.loc = instaService.checkSecuredData(addressRegex, securedScannedData._loc);
                            instaService.nomineeAadhaarCardDetails.vtc = instaService.checkSecuredData(addressRegex, securedScannedData._vtc);
                            instaService.nomineeAadhaarCardDetails.po = instaService.checkSecuredData(addressRegex, securedScannedData._po);
                            instaService.nomineeAadhaarCardDetails.dist = instaService.checkSecuredData(addressRegex, securedScannedData._dist);
                            instaService.nomineeAadhaarCardDetails.subdist = instaService.checkSecuredData(addressRegex, securedScannedData._subdist);
                            instaService.nomineeAadhaarCardDetails.state = instaService.checkSecuredData(addressRegex, securedScannedData._state);
                            instaService.nomineeAadhaarCardDetails.pc = instaService.checkSecuredData(numbers, securedScannedData._pc);
                            instaService.nomineeAadhaarCardDetails.dob = securedScannedData._dob;
                            instaService.isNomineeScanned = true;
                            $state.go('menu.instaKit_nominationRelated'); 
                        }, 500);
                    }
            }
            //}
            }, 
			function(error) {
                utilityService.showErrorMessage(error);
            });
        }

        instanomineeDetailsVm.goBacktoPrevious = function() {
            $state.go("menu.instaKit_aDReligion");
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }
        
        instanomineeDetailsVm.getNominationRelated = function() {
            instaService.isNomineeScanned = false;
            instanomineeDetailsVm.clearNomineeAadhaarDetails();
            $state.go('menu.instaKit_nominationRelated');
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
