'use strict';

angularApp.controller('instanomineeDetailsRelatedController', ["$state",
    "$scope",
    "utilityService",
    "instanomineeDetailsRelatedService",
    "instaService",
    "$translate",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function ($state,
        $scope,
        utilityService,
        instanomineeDetailsRelatedService,
        instaService,
        $translate,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instanomineeDetailsRelatedVm = this;

        function initPage() {
            instanomineeDetailsRelatedVm.showBack = true;
            instanomineeDetailsRelatedVm.showNext = true;
            instanomineeDetailsRelatedVm.nomineeAge = null;
            instanomineeDetailsRelatedVm.dob = "";
            instanomineeDetailsRelatedVm.nomineeGuardianName = "";
            instanomineeDetailsRelatedVm.guardianAge = "";
            instanomineeDetailsRelatedVm.aofooter = true;
            instanomineeDetailsRelatedVm.invalid = false;
            instanomineeDetailsRelatedVm.properDate = false;
            instaService.nomineeNav = "nomineedetails";
            instanomineeDetailsRelatedVm.validCityState = false;
            instanomineeDetailsRelatedVm.isAddress1Modified = false;
            instanomineeDetailsRelatedVm.isAddress2Modified = false;
            instanomineeDetailsRelatedVm.isCityModified = false;
            instanomineeDetailsRelatedVm.isStateModified = false;
            instanomineeDetailsRelatedVm.isPincodeModified = false;
            instanomineeDetailsRelatedVm.disableAddress1 = false;
            instanomineeDetailsRelatedVm.disableAddress2 = false;
            instanomineeDetailsRelatedVm.disableCity = true;
            instanomineeDetailsRelatedVm.disablePincode = false;
            instanomineeDetailsRelatedVm.disableState = true;
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                instanomineeDetailsRelatedVm.okBtntext = translatedvalue;
            });

        }

        instanomineeDetailsRelatedVm.goBacktoPrevious = function () {
            if (instaService.isNomineeScanned == true) {
                instaService.nomineeAadhaarCardDetails.address1 = instanomineeDetailsRelatedVm.addressAboveData;
                instaService.nomineeAadhaarCardDetails.address2 = instanomineeDetailsRelatedVm.addressBelowData;
                instaService.nomineeAadhaarCardDetails.pc = instanomineeDetailsRelatedVm.pincodeData;
                instaService.nomineeAadhaarCardDetails.dist = instanomineeDetailsRelatedVm.cityData;
                instaService.nomineeAadhaarCardDetails.state = instanomineeDetailsRelatedVm.stateData;
                instaService.nomineeAadhaarCardDetails.sameAsApplicantAddress = instanomineeDetailsRelatedVm.applicantChecked;
            } else {
                instaService.nominee.address1 = instanomineeDetailsRelatedVm.addressAboveData;
                instaService.nominee.address2 = instanomineeDetailsRelatedVm.addressBelowData;
                instaService.nominee.pincode = instanomineeDetailsRelatedVm.pincodeData;
                instaService.nominee.city = instanomineeDetailsRelatedVm.cityData;
                instaService.nominee.state = instanomineeDetailsRelatedVm.stateData;
                instaService.nominee.sameAsApplicantAddress = instanomineeDetailsRelatedVm.applicantChecked;
            }

            $state.go('menu.instaKit_nominationRelated');
        }

        instanomineeDetailsRelatedVm.setRequestParams = function () {
            var params = {};
            if (instanomineeDetailsRelatedVm.isNomineeScanned === true) {
                params = {
                    "id": instaService.customer.mobileNo,
                    "data": {
                        "nominees": [{
                            "uid": instaService.nomineeAadhaarCardDetails.uid,
                            "name": instaService.nomineeAadhaarCardDetails.name,
                            "relationship": instaService.nomineeAadhaarCardDetails.relationship,
                            "age": instanomineeDetailsRelatedVm.calculateAge(),
                            "guardianName": instaService.nomineeAadhaarCardDetails.guardianName,
                            "guardianAge": instaService.nomineeAadhaarCardDetails.guardianAge,
                            "dob": instaService.nomineeAadhaarCardDetails.dob,
                            "isNomineeAadhaarScanned": instanomineeDetailsRelatedVm.isNomineeScanned,
                            "sameAsApplicantAddress": instanomineeDetailsRelatedVm.applicantChecked,
                            "type": "",
                            "address": {
                                "addressLine1": instaService.nomineeAadhaarCardDetails.address1,
                                "addressLine2": instaService.nomineeAadhaarCardDetails.address2,
                                "pincode": instaService.nomineeAadhaarCardDetails.pc,
                                "city": instaService.nomineeAadhaarCardDetails.dist,
                                "state": instaService.nomineeAadhaarCardDetails.state
                            },
                            "guardian": {
                                "name": instaService.nomineeAadhaarCardDetails.guardianName,
                                "guardianAge": instaService.nomineeAadhaarCardDetails.guardianAge
                            }

                        }],
                        "commonId": $state.$current.data.commonId
                    }
                }
            } else {
                params = {
                    "id": instaService.customer.mobileNo,
                    "data": {
                        "nominees": [{
                            "uid": instaService.nominee.uid,
                            "name": instaService.nominee.name,
                            "relationship": instaService.nominee.relationship,
                            "age": instanomineeDetailsRelatedVm.calculateAge(),
                            "guardianName": instaService.nominee.guardianName,
                            "dob": instaService.nominee.dob,
                            "isNomineeAadhaarScanned": instanomineeDetailsRelatedVm.isNomineeScanned,
                            "sameAsApplicantAddress": instanomineeDetailsRelatedVm.applicantChecked,
                            "address": {
                                "addressLine1": instaService.nominee.address1,
                                "addressLine2": instaService.nominee.address2,
                                "pincode": instaService.nominee.pincode,
                                "city": instaService.nominee.city,
                                "cityCode": instaService.nominee.cityCode,
                                "state": instaService.nominee.state,
                                "stateCode": instaService.nominee.stateCode
                            },
                            "guardian": {
                                "name": instaService.nominee.guardianName,
                                "guardianAge": instaService.nominee.guardianAge
                            }

                        }],
                        "commonId": $state.$current.data.commonId
                    }
                }
            }
            return params;
        }
        instanomineeDetailsRelatedVm.goToNextPage = function () {
            var addressLength;
            var stateData = document.getElementById("state");
            var stateSelValue = stateData.options[stateData.selectedIndex].text;
            if (instaService.isNomineeScanned == true) {
                instaService.nomineeAadhaarCardDetails.address1 = instanomineeDetailsRelatedVm.addressAboveData;
                instaService.nomineeAadhaarCardDetails.address2 = instanomineeDetailsRelatedVm.addressBelowData;
                instaService.nomineeAadhaarCardDetails.pc = instanomineeDetailsRelatedVm.pincodeData;
                instaService.nomineeAadhaarCardDetails.dist = instanomineeDetailsRelatedVm.cityData;
                instaService.nomineeAadhaarCardDetails.state = instanomineeDetailsRelatedVm.stateData ? instanomineeDetailsRelatedVm.stateData : stateSelValue;
                instaService.nomineeAadhaarCardDetails.sameAsApplicantAddress = instanomineeDetailsRelatedVm.applicantChecked;
                addressLength = instaService.nomineeAadhaarCardDetails.address1.length + instaService.nomineeAadhaarCardDetails.address2.length;
            } else if (instaService.isNomineeScanned == false) {
                instaService.nominee.address1 = instanomineeDetailsRelatedVm.addressAboveData;
                instaService.nominee.address2 = instanomineeDetailsRelatedVm.addressBelowData;
                instaService.nominee.pincode = instanomineeDetailsRelatedVm.pincodeData;
                instaService.nominee.city = instanomineeDetailsRelatedVm.cityData;
                instaService.nominee.state = instanomineeDetailsRelatedVm.stateData ? instanomineeDetailsRelatedVm.stateData : stateSelValue;

                instaService.nominee.sameAsApplicantAddress = instanomineeDetailsRelatedVm.applicantChecked;
                addressLength = instaService.nominee.address1.length + instaService.nominee.address2.length;
            }

            /* If nominee address length is greater than 60 */
            if (addressLength > 60) {
                var title = '';
                var template = '{{"MAX_CHAR" | translate}}';
                var onTap = '';
                var buttontext = '<b>' + instanomineeDetailsRelatedVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            } else {
                //Service to update nominee details
                var requestParams = instanomineeDetailsRelatedVm.setRequestParams();
                instanomineeDetailsRelatedService.createNominee(requestParams).then(function (response) {
                    if (!utilityService.isUndefined(instanomineeDetailsRelatedVm.nomineeGuardianName) || instanomineeDetailsRelatedVm.nomineeAge < constantConfig.acOp.nomineeAge) {
                        $state.go("menu.instaKit_nomineeDetailsAddressOption");
                    } else {
                       
                        // $state.go("menu.instaKit_selectBranchListLocality");
                        if ((instaService.isResumeJourney && instaService.homeBranchLocalityId) || (!instaService.isResumeJourney && instaService.homeBranchLocalityId)  ) {
                            $state.go("menu.instaKit_reviewSelectedBranch");
                        } else {
                            $state.go("menu.instaKit_selectBListLocalityByPincode");
                        }
                    }

                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        }

        $scope.goToHome = function () {
            instaService.homeNav();
        }

        instanomineeDetailsRelatedVm.goBack = function () {
            instanomineeDetailsRelatedVm.nomineeName = "";
            instanomineeDetailsRelatedVm.nomineeDetailsFirstForm.$setPristine();
            instanomineeDetailsRelatedVm.nomineeRelationship = "";
            instanomineeDetailsRelatedVm.nomineeAge = null;
            instanomineeDetailsRelatedVm.dob = "";
            instanomineeDetailsRelatedVm.nomineeGuardianName = "";
            instanomineeDetailsRelatedVm.guardianAge = "";
            instanomineeDetailsRelatedVm.addressAboveData = "";
            instanomineeDetailsRelatedVm.addressBelowData = "";
            instanomineeDetailsRelatedVm.pincodeData = null;
            instanomineeDetailsRelatedVm.cityData = "";
            instanomineeDetailsRelatedVm.stateData = "";
            instanomineeDetailsRelatedVm.nomineeDobDay = null;
            instanomineeDetailsRelatedVm.nomineeDobMonth = null;
            instanomineeDetailsRelatedVm.nomineeDobYear = null;
            instaService.isNomineeAddress1Changed = false;
            instaService.isNomineeAddress2Changed = false;
            // $state.go('menu.instaKit_nomineeDetails');
            $state.go("menu.instaKit_aDCategory");
        }

        instanomineeDetailsRelatedVm.goNext = function () {
            if (instaService.isNomineeScanned == true) {
                instaService.nomineeAadhaarCardDetails.name = instanomineeDetailsRelatedVm.nomineeName;
                instaService.nomineeAadhaarCardDetails.relationship = instanomineeDetailsRelatedVm.nomineeRelationship;
                instaService.nomineeAadhaarCardDetails.age = instanomineeDetailsRelatedVm.nomineeAge;
                instaService.nomineeAadhaarCardDetails.dob = instanomineeDetailsRelatedVm.nomineeDobDay + '-' + instanomineeDetailsRelatedVm.nomineeDobMonth + '-' + instanomineeDetailsRelatedVm.nomineeDobYear;
                instaService.nomineeAadhaarCardDetails.guardianName = instanomineeDetailsRelatedVm.nomineeGuardianName;
                instaService.nomineeAadhaarCardDetails.guardianAge = instanomineeDetailsRelatedVm.guardianAge;
            } else if (instaService.isNomineeScanned == false) {
                instaService.nominee.name = instanomineeDetailsRelatedVm.nomineeName;
                instaService.nominee.relationship = instanomineeDetailsRelatedVm.nomineeRelationship;
                instaService.nominee.age = instanomineeDetailsRelatedVm.nomineeAge;
                instaService.nominee.dob = instanomineeDetailsRelatedVm.dob;
                instaService.nominee.guardianName = instanomineeDetailsRelatedVm.nomineeGuardianName;
                instaService.nominee.guardianAge = instanomineeDetailsRelatedVm.guardianAge;
            }
            $state.go('menu.instaKit_nomineeDetailsNext');
        }
        //On page load - Split the aadhaar card holder's name and display accordingly
        instanomineeDetailsRelatedVm.displayNames = function (value) {
            var fullName = value;
            var splittedName = value.split(" ");
            var splitLen = value.split(" ").length;
            var i;
            var middleName = [];

            if (splitLen === 2) {
                instanomineeDetailsRelatedVm.firstName = splittedName[0];
                instanomineeDetailsRelatedVm.lastName = splittedName[1];
                instanomineeDetailsRelatedVm.isMName = false;
            } else {
                instanomineeDetailsRelatedVm.isMName = true;
                instanomineeDetailsRelatedVm.firstName = splittedName[0];
                for (i = 1; i < splitLen - 1; i++) {
                    middleName[i] = splittedName[i];
                }
                instanomineeDetailsRelatedVm.middleName = middleName.join(' ');
                instanomineeDetailsRelatedVm.lastName = splittedName[splitLen - 1];
            }
        }

        /* Display Nominee details after scan or manual entry */
        instanomineeDetailsRelatedVm.displayNomineeAdharDetails = function () {
            if (instaService.isNomineeScanned == true) {
                instanomineeDetailsRelatedVm.nomineeName = instaService.nomineeAadhaarCardDetails.name;
                instanomineeDetailsRelatedVm.nomineeGuardianName = instaService.nomineeAadhaarCardDetails.guardianName;
                instanomineeDetailsRelatedVm.guardianAge = instaService.nomineeAadhaarCardDetails.guardianAge;
                instanomineeDetailsRelatedVm.nomineeRelationship = instaService.nomineeAadhaarCardDetails.relationship;
                instanomineeDetailsRelatedVm.dob = instaService.nomineeAadhaarCardDetails.dob;
                instanomineeDetailsRelatedVm.addressAboveData = instanomineeDetailsRelatedVm.concatAadharAddress1();
                instanomineeDetailsRelatedVm.addressBelowData = instanomineeDetailsRelatedVm.concatAadharAddress2();
                instanomineeDetailsRelatedVm.applicantChecked = instaService.nomineeAadhaarCardDetails.sameAsApplicantAddress;
                if (!utilityService.isUndefined(instaService.nomineeAadhaarCardDetails.pc))
                    instanomineeDetailsRelatedVm.pincodeData = parseInt(instaService.nomineeAadhaarCardDetails.pc);
                instanomineeDetailsRelatedVm.cityData = instaService.nomineeAadhaarCardDetails.dist;
                instanomineeDetailsRelatedVm.stateData = instaService.nomineeAadhaarCardDetails.state;
            } else {
                instanomineeDetailsRelatedVm.nomineeName = instaService.nominee.name;
                instanomineeDetailsRelatedVm.nomineeGuardianName = instaService.nominee.guardianName;
                instanomineeDetailsRelatedVm.guardianAge = instaService.nominee.guardianAge;
                instanomineeDetailsRelatedVm.nomineeRelationship = instaService.nominee.relationship;
                instanomineeDetailsRelatedVm.dob = instaService.nominee.dob;
                instanomineeDetailsRelatedVm.addressAboveData = instaService.nominee.address1;
                instanomineeDetailsRelatedVm.addressBelowData = instaService.nominee.address2;
                instanomineeDetailsRelatedVm.applicantChecked = instaService.nominee.sameAsApplicantAddress;
                if (!utilityService.isUndefined(instaService.nominee.pincode))
                    instanomineeDetailsRelatedVm.pincodeData = parseInt(instaService.nominee.pincode);
                instanomineeDetailsRelatedVm.cityData = instaService.nominee.city;
                instanomineeDetailsRelatedVm.stateData = instaService.nominee.state;
            }
            instanomineeDetailsRelatedVm.fetchStateListData();
        }
        instanomineeDetailsRelatedVm.fetchStateListData = function () {
            if (instanomineeDetailsRelatedVm.pincodeData && (!instanomineeDetailsRelatedVm.selectStateList)) {
                var inputparams = {
                    "pinCode": instanomineeDetailsRelatedVm.pincodeData
                }
                instanomineeDetailsRelatedService.getAreaDetailForPincode(inputparams).then(function (data) {
                    instanomineeDetailsRelatedVm.selectStateList = data;
                    instanomineeDetailsRelatedVm.selectdState = instaService.nominee.stateCode;
                }, function (error) {
                });
            }
        }
        /* Method to calculate age */
        instanomineeDetailsRelatedVm.calculateAge = function () {
            var todayDateAge = new Date();
            var bornNewDate = new Date(instanomineeDetailsRelatedVm.nomineeDobYear, instanomineeDetailsRelatedVm.nomineeDobMonth - 1, instanomineeDetailsRelatedVm.nomineeDobDay);
            var age = Math.floor((todayDateAge.getTime() - bornNewDate.getTime()) / (365.25 * 24 * 60 * 60 * 1000));

            return age;
        }

        /* Populate Date of birth from aadhaar / resume journey  -
        If (From aadhaar, dob format is different and therefore formatting it)
        Else(From aadhaar, yob alone received, then keep date and month fields empty to make the user to enter)
        */
        instanomineeDetailsRelatedVm.populateDobAadhaar = function (dateValue) {
            if (utilityService.isUndefined(instanomineeDetailsRelatedVm.nomineeDobYear) || utilityService.isUndefined(instanomineeDetailsRelatedVm.nomineeDobMonth) || utilityService.isUndefined(instanomineeDetailsRelatedVm.nomineeDobDay)) {
                if (!utilityService.isUndefined(dateValue)) {
                    dateValue = moment(dateValue, ["DD/MM/YYYY", "MM/DD/YYYY", "DD-MM-YYYY", "MM-DD-YYYY", "YYYY-MM-DD", "YYYY-DD-MM", "YYYY/MM/DD", "YYYY/DD/MM"]);
                    var dateFormat = new Date(dateValue);
                    var day = dateFormat.getDate();
                    var month = dateFormat.getMonth() + 1;
                    var year = dateFormat.getFullYear();
                    var formattedDate = day.toString();
                    if (formattedDate.length == 1) {
                        formattedDate = "0" + formattedDate;
                        instanomineeDetailsRelatedVm.nomineeDobDay = formattedDate;
                    } else {
                        instanomineeDetailsRelatedVm.nomineeDobDay = parseInt(day);
                    }
                    var formattedMonth = month.toString();
                    if (formattedMonth.length == 1) {
                        formattedMonth = "0" + formattedMonth;
                        instanomineeDetailsRelatedVm.nomineeDobMonth = formattedMonth;
                    } else {
                        instanomineeDetailsRelatedVm.nomineeDobMonth = parseInt(month);
                    }
                    instanomineeDetailsRelatedVm.nomineeDobYear = parseInt(year);
                    var fullDate = instanomineeDetailsRelatedVm.nomineeDobMonth + '-' + instanomineeDetailsRelatedVm.nomineeDobDay + '-' + instanomineeDetailsRelatedVm.nomineeDobYear;

                    var formattedNewDate = new Date();
                    formattedNewDate.setFullYear(instanomineeDetailsRelatedVm.nomineeDobYear, instanomineeDetailsRelatedVm.nomineeDobMonth - 1, instanomineeDetailsRelatedVm.nomineeDobDay);

                    var todayDate = new Date();
                    var currentYear = todayDate.getFullYear();
                    var validYear = todayDate.setFullYear(currentYear - constantConfig.acOp.nomineeAge);
                    instanomineeDetailsRelatedVm.nomineeAge = instanomineeDetailsRelatedVm.calculateAge();


                } else if (!utilityService.isUndefined(instaService.nomineeAadhaarCardDetails.yob) && utilityService.isUndefined(instaService.nomineeAadhaarCardDetails.dob)) {
                    instanomineeDetailsRelatedVm.nomineeDobDay = "";
                    instanomineeDetailsRelatedVm.nomineeDobMonth = "";
                    instanomineeDetailsRelatedVm.nomineeDobYear = parseInt(instaService.nomineeAadhaarCardDetails.yob);
                }
            }
        }

        /* From aadhaar, address comes splitted and therefore clubbing the fields which are required for address line 1 */
        instanomineeDetailsRelatedVm.concatAadharAddress1 = function () {
            var fullAddr = "";
            if (utilityService.isUndefined(instaService.nomineeAadhaarCardDetails.address1)) {
                fullAddr = instaService.nullCheck(instaService.nomineeAadhaarCardDetails.house) + instaService.nullCheck(instaService.nomineeAadhaarCardDetails.street);
                var index = fullAddr.lastIndexOf(",");
                fullAddr = fullAddr.substring(0, index) + fullAddr.substring(index + 1);
            } else {
                fullAddr = instaService.nomineeAadhaarCardDetails.address1;
            }
            return fullAddr;
        }

        /* From aadhaar, address comes splitted and therefore clubbing the fields which are required for address line 2 */
        instanomineeDetailsRelatedVm.concatAadharAddress2 = function () {
            var fullAddr = "";
            if (utilityService.isUndefined(instaService.nomineeAadhaarCardDetails.address2)) {
                fullAddr = instaService.nullCheck(instaService.nomineeAadhaarCardDetails.loc) + instaService.nullCheck(instaService.nomineeAadhaarCardDetails.vtc) + instaService.nullCheck(instaService.nomineeAadhaarCardDetails.po) + instaService.nullCheck(instaService.nomineeAadhaarCardDetails.subdist);
                var index = fullAddr.lastIndexOf(",");
                fullAddr = fullAddr.substring(0, index) + fullAddr.substring(index + 1);
            } else {
                fullAddr = instaService.nomineeAadhaarCardDetails.address2;
            }
            return fullAddr;
        }

        instanomineeDetailsRelatedVm.validateInputs = function (isValid) {
            if (instanomineeDetailsRelatedVm.validDate === true && isValid === true) {
                instanomineeDetailsRelatedVm.disableNext = !isValid;
            } else if (instanomineeDetailsRelatedVm.validDate === true && isValid === false) {
                instanomineeDetailsRelatedVm.disableNext = true;
            } else if (instanomineeDetailsRelatedVm.validDate === false && isValid === false) {
                instanomineeDetailsRelatedVm.disableNext = true;
            }
            return instanomineeDetailsRelatedVm.disableNext;
        }

        /* Date Validation */
        instanomineeDetailsRelatedVm.dateValidation = function (isValid) {
            var fullDate = instanomineeDetailsRelatedVm.nomineeDobMonth + '-' + instanomineeDetailsRelatedVm.nomineeDobDay + '-' + instanomineeDetailsRelatedVm.nomineeDobYear;
            var dobMonth = instanomineeDetailsRelatedVm.nomineeDobMonth;
            var dobDay = instanomineeDetailsRelatedVm.nomineeDobDay;
            var dobYr = instanomineeDetailsRelatedVm.nomineeDobYear;
            var fullDateInMilliSeconds = Date.parse(fullDate);
            var formattedDate = new Date();
            var formattedDateYr = formattedDate.getFullYear();
            var currDate = new Date();
            var curYear = currDate.getFullYear();
            var curDateInMilliSeconds = new Date().getTime();
            formattedDate.setFullYear(dobYr, dobMonth - 1, dobDay);
            var months30 = ["04", "06", "09", "11", "4", "6", "9"];
            var monthIndex = months30.indexOf(dobMonth);

            if (fullDateInMilliSeconds > curDateInMilliSeconds) {
                instanomineeDetailsRelatedVm.disableNext = true;
                instanomineeDetailsRelatedVm.invalid = true;
                instanomineeDetailsRelatedVm.properDate = false;
            } else if (dobYr % 4 == 0 && (dobYr % 100 != 0 || dobYr % 400 == 0)) {
                if (dobMonth == 2 && dobDay > 29) {
                    instanomineeDetailsRelatedVm.disableNext = true;
                    instanomineeDetailsRelatedVm.invalid = true;
                    instanomineeDetailsRelatedVm.properDate = false;
                } else if (monthIndex != -1 && dobDay == 31) {
                    instanomineeDetailsRelatedVm.disableNext = true;
                    instanomineeDetailsRelatedVm.invalid = true;
                    instanomineeDetailsRelatedVm.properDate = false;
                } else {
                    instanomineeDetailsRelatedVm.disableNext = !isValid;
                    instanomineeDetailsRelatedVm.invalid = false;
                    instanomineeDetailsRelatedVm.properDate = true;
                }

            } else if (dobMonth == 2 && dobDay >= 29) {
                instanomineeDetailsRelatedVm.disableNext = true;
                instanomineeDetailsRelatedVm.invalid = true;
                instanomineeDetailsRelatedVm.properDate = false;
            } else if (monthIndex != -1 && dobDay == 31) {
                instanomineeDetailsRelatedVm.disableNext = true;
                instanomineeDetailsRelatedVm.invalid = true;
                instanomineeDetailsRelatedVm.properDate = false;

            } else {
                instanomineeDetailsRelatedVm.disableNext = !isValid;
                instanomineeDetailsRelatedVm.invalid = false;
                instanomineeDetailsRelatedVm.properDate = true;

            }
            return instanomineeDetailsRelatedVm.properDate;
        }

        /* Date Validation */
        instanomineeDetailsRelatedVm.checkValidDate = function (isValid) {

            instanomineeDetailsRelatedVm.validDateFormat = instanomineeDetailsRelatedVm.dateValidation();

            if (instanomineeDetailsRelatedVm.validDateFormat == true) {
                var fullDate = instanomineeDetailsRelatedVm.nomineeDobMonth + '/' + instanomineeDetailsRelatedVm.nomineeDobDay + '/' + instanomineeDetailsRelatedVm.nomineeDobYear;
                var dateDMY = instanomineeDetailsRelatedVm.nomineeDobDay + '-' + instanomineeDetailsRelatedVm.nomineeDobMonth + '-' + instanomineeDetailsRelatedVm.nomineeDobYear;
                var formattedDate = new Date();
                formattedDate.setFullYear(instanomineeDetailsRelatedVm.nomineeDobYear, instanomineeDetailsRelatedVm.nomineeDobMonth - 1, instanomineeDetailsRelatedVm.nomineeDobDay);
                var todayDate = new Date();
                var currentYear = todayDate.getFullYear();
                var validYear = todayDate.setFullYear(currentYear - constantConfig.acOp.nomineeAge);
                instanomineeDetailsRelatedVm.nomineeAge = instanomineeDetailsRelatedVm.calculateAge();

                instanomineeDetailsRelatedVm.dob = dateDMY;
                if (isNaN(instanomineeDetailsRelatedVm.nomineeAge) === false && instanomineeDetailsRelatedVm.nomineeAge >= constantConfig.acOp.nomineeAge || instanomineeDetailsRelatedVm.nomineeAge < constantConfig.acOp.nomineeAge) {
                    instanomineeDetailsRelatedVm.validDate = true;
                } else if (isNaN(instanomineeDetailsRelatedVm.nomineeAge) === true) {
                    instanomineeDetailsRelatedVm.validDate = false;
                }
                if (instanomineeDetailsRelatedVm.validDate === true && isValid === true) {
                    instanomineeDetailsRelatedVm.disableNext = false;
                } else if (instanomineeDetailsRelatedVm.validDate === false && isValid === false) {
                    instanomineeDetailsRelatedVm.disableNext = true;
                } else if (instanomineeDetailsRelatedVm.validDate === true && isValid === false) {
                    instanomineeDetailsRelatedVm.disableNext = true;
                }

            } else if (instanomineeDetailsRelatedVm.validDateFormat === false) {
                instanomineeDetailsRelatedVm.disableNext = true;
            }
            return instanomineeDetailsRelatedVm.disableNext;
        }

        instanomineeDetailsRelatedVm.checkGuardian = function () {
            var required = false;

            if (isNaN(instanomineeDetailsRelatedVm.nomineeAge) === false && !utilityService.isUndefined(instanomineeDetailsRelatedVm.nomineeAge)) {
                if (instanomineeDetailsRelatedVm.nomineeAge >= constantConfig.acOp.nomineeAge) {
                    required = false;
                } else {
                    required = true;
                }
            }
            return required;
        }

        instanomineeDetailsRelatedVm.disableGuardian = function () {
            var disable = true;
            if (isNaN(instanomineeDetailsRelatedVm.nomineeAge) === false && !utilityService.isUndefined(instanomineeDetailsRelatedVm.nomineeAge)) {
                if (instanomineeDetailsRelatedVm.nomineeAge >= constantConfig.acOp.nomineeAge) {
                    disable = true;
                    instanomineeDetailsRelatedVm.nomineeGuardianName = "";
                    instanomineeDetailsRelatedVm.guardianAge = "";
                } else {
                    disable = false;
                }
            }
            return disable;
        }

        $scope.ageAbove18Pattern = (function () {
            var regexp = /^(1[89]|[2-9][0-9])$/;
            return {
                test: function (value) {
                    if (instanomineeDetailsRelatedVm.checkGuardian() === false) {
                        return true;
                    }
                    return regexp.test(value);
                }
            };
        })();

        $scope.namePattern = (function () {
            var regexp = /^([ \.]?[a-zA-Z]+)+$/;
            return {
                test: function (value) {
                    if (instanomineeDetailsRelatedVm.checkGuardian() === false) {
                        return true;
                    }
                    return regexp.test(value);
                }
            };
        })();

        instanomineeDetailsRelatedVm.concatCustomerAddressline1 = function () {
            var fullAddr = "";
            if (instaService.isResumeJourney === false) {
                fullAddr = instaService.nullCheck(instaService.customerAadhaarCardDetails.house) + instaService.nullCheck(instaService.customerAadhaarCardDetails.street);
                var index = fullAddr.lastIndexOf(",");
                fullAddr = fullAddr.substring(0, index) + fullAddr.substring(index + 1);
            } else {
                fullAddr = instaService.customerAadhaarCardDetails.addressLine1;
            }
            return fullAddr;
        }

        instanomineeDetailsRelatedVm.concatCustomerAddressline2 = function () {
            var fullAddr = "";
            if (instaService.isResumeJourney === false) {
                fullAddr = instaService.nullCheck(instaService.customerAadhaarCardDetails.loc) + instaService.nullCheck(instaService.customerAadhaarCardDetails.vtc) + instaService.nullCheck(instaService.customerAadhaarCardDetails.po) + instaService.nullCheck(instaService.customerAadhaarCardDetails.subdist);
                var index = fullAddr.lastIndexOf(",");
                fullAddr = fullAddr.substring(0, index) + fullAddr.substring(index + 1);
            } else {
                fullAddr = instaService.customerAadhaarCardDetails.addressLine2;
            }

            return fullAddr;
        }

        instanomineeDetailsRelatedVm.validateNomineeAddrInputs = function (isValid) {
            instanomineeDetailsRelatedVm.disableNomineeAddrNext = !isValid;
        }

        /* Based on Pincode, auto-populate city and state fields*/
        instanomineeDetailsRelatedVm.updateCityState = function (isValid) {
            instanomineeDetailsRelatedVm.npincode = instanomineeDetailsRelatedVm.pincodeData;
            if (!utilityService.isUndefined(instanomineeDetailsRelatedVm.npincode)) {
                instanomineeDetailsRelatedVm.isPincodeModified = true;
            }
            if (instanomineeDetailsRelatedVm.nomineeAddressForm.pincode.$valid === true) {
                var inputparams = {
                    "pinCode": instanomineeDetailsRelatedVm.pincodeData
                }
                instanomineeDetailsRelatedService.getAreaDetailForPincode(inputparams).then(function (data) {
                    //Success - Data
                    if (utilityService.isUndefined(data)) {
                        var title = '';
                        var template = '{{"PINCODE_MATCH" | translate}}';
                        var onTap = '';
                        var buttontext = '<b>' + instanomineeDetailsRelatedVm.okBtntext + '</b>';
                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                        instanomineeDetailsRelatedVm.disableState = false;
                        instanomineeDetailsRelatedVm.disableCity = false;
                        instanomineeDetailsRelatedVm.selectStateList = "";
                    } else {
                        instanomineeDetailsRelatedVm.selectStateList = data;
                        if (instanomineeDetailsRelatedVm.selectStateList.length == 1) {
                            instaService.customer.city = utilityService.getValue(data[0].cityName);
                            instaService.customer.state = utilityService.getValue(data[0].stateName);
                            instaService.nominee.cityCode = utilityService.getValue(data[0].cityCode);
                            instaService.nominee.stateCode = utilityService.getValue(data[0].stateCode);
                            instanomineeDetailsRelatedVm.cityData = instaService.customer.city;
                            instanomineeDetailsRelatedVm.stateData = instaService.customer.state;
                            instanomineeDetailsRelatedVm.ncity = instanomineeDetailsRelatedVm.cityData;
                            instanomineeDetailsRelatedVm.nstate = instanomineeDetailsRelatedVm.stateData;

                            instanomineeDetailsRelatedVm.selectdState = instaService.nominee.stateCode;
                        }

                        if (!utilityService.isUndefined(instanomineeDetailsRelatedVm.ncity)) {
                            instanomineeDetailsRelatedVm.isCityModified = true;
                        }
                        if (!utilityService.isUndefined(instanomineeDetailsRelatedVm.nstate)) {
                            instanomineeDetailsRelatedVm.isStateModified = true;
                        }

                    }
                }, function (error) {
                    instanomineeDetailsRelatedVm.selectStateList = "";
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else if (instanomineeDetailsRelatedVm.pincodeData === "" || (!utilityService.isUndefined(instanomineeDetailsRelatedVm.pincodeData)).length != 6) {
                instanomineeDetailsRelatedVm.cityData = "";
                instanomineeDetailsRelatedVm.stateData = "";
            }
        }

        /* If city and state fields are valid, enable/disable Next button */
        instanomineeDetailsRelatedVm.updatedValue = function (isValid) {

            instanomineeDetailsRelatedVm.disableNomineeAddrNext = !(isValid);
            instanomineeDetailsRelatedVm.ncity = instanomineeDetailsRelatedVm.cityData;
            instanomineeDetailsRelatedVm.nstate = instanomineeDetailsRelatedVm.stateData;
            if (!utilityService.isUndefined(instanomineeDetailsRelatedVm.ncity)) {
                instanomineeDetailsRelatedVm.isCityModified = true;
            }
            if (!utilityService.isUndefined(instanomineeDetailsRelatedVm.nstate)) {
                instanomineeDetailsRelatedVm.isStateModified = true;
            }
            return instanomineeDetailsRelatedVm.disableNext;
        }

        /* Disable nominee address page fields */
        instanomineeDetailsRelatedVm.disableAddressFields = function () {
            instanomineeDetailsRelatedVm.disableAddress1 = true;
            instanomineeDetailsRelatedVm.disableAddress2 = true;
            instanomineeDetailsRelatedVm.disablePincode = true;
            instanomineeDetailsRelatedVm.disableCity = true;
            instanomineeDetailsRelatedVm.disableState = true;
        }

        instanomineeDetailsRelatedVm.assignAddress = function () {
            if (instaService.isNomineeScanned == true) {
                instaService.nomineeAadhaarCardDetails.address1 = instanomineeDetailsRelatedVm.addressAboveData;
                instaService.nomineeAadhaarCardDetails.address2 = instanomineeDetailsRelatedVm.addressBelowData;
                instaService.nomineeAadhaarCardDetails.pc = instanomineeDetailsRelatedVm.pincodeData;
                instaService.nomineeAadhaarCardDetails.dist = instanomineeDetailsRelatedVm.cityData;
                instaService.nomineeAadhaarCardDetails.state = instanomineeDetailsRelatedVm.stateData;
            } else if (instaService.isNomineeScanned == false) {
                instaService.nominee.address1 = instanomineeDetailsRelatedVm.addressAboveData;
                instaService.nominee.address2 = instanomineeDetailsRelatedVm.addressBelowData;
                instaService.nominee.pincode = instanomineeDetailsRelatedVm.pincodeData;
                instaService.nominee.city = instanomineeDetailsRelatedVm.cityData;
                instaService.nominee.state = instanomineeDetailsRelatedVm.stateData;
            }
        }

        /* Based on "Same as Applicant Address" checkbox, reload the address fields  */
        instanomineeDetailsRelatedVm.checkboxValidation = function () {
            if (instanomineeDetailsRelatedVm.applicantChecked) {
                if (instaService.correspondenceCheckStatus === true) {
                    instanomineeDetailsRelatedVm.loadStateList(instaService.customerCorrespondenceAddress.pincode, instaService.customerCorrespondenceAddress.stateCode);
                    instanomineeDetailsRelatedVm.addressAboveData = instaService.customerCorrespondenceAddress.address1;
                    instanomineeDetailsRelatedVm.addressBelowData = instaService.customerCorrespondenceAddress.address2;
                    instanomineeDetailsRelatedVm.pincodeData = parseInt(instaService.customerCorrespondenceAddress.pincode);
                    instanomineeDetailsRelatedVm.cityData = instaService.customerCorrespondenceAddress.city;
                    instanomineeDetailsRelatedVm.stateData = instaService.customerCorrespondenceAddress.state;
                    instanomineeDetailsRelatedVm.disableAddressFields();
                } else {
                    instanomineeDetailsRelatedVm.loadStateList(instaService.customerAadhaarCardDetails.pc, instaService.customerAadhaarCardDetails.stateCode);
                    instanomineeDetailsRelatedVm.addressAboveData = instaService.customerAadhaarCardDetails.house;
                    instanomineeDetailsRelatedVm.addressBelowData = instaService.customerAadhaarCardDetails.street;
                    instanomineeDetailsRelatedVm.pincodeData = parseInt(instaService.customerAadhaarCardDetails.pc);
                    instanomineeDetailsRelatedVm.cityData = instaService.customerAadhaarCardDetails.dist;
                    instanomineeDetailsRelatedVm.stateData = instaService.customerAadhaarCardDetails.state;
                    instanomineeDetailsRelatedVm.disableAddressFields();
                }
            } else if (!instanomineeDetailsRelatedVm.applicantChecked) {
                instanomineeDetailsRelatedVm.disableAddress1 = false;
                instanomineeDetailsRelatedVm.disableAddress2 = false;
                instanomineeDetailsRelatedVm.disablePincode = false;
                instanomineeDetailsRelatedVm.disableCity = true;
                instanomineeDetailsRelatedVm.disableState = true;

                instanomineeDetailsRelatedVm.addressAboveData = '';
                instanomineeDetailsRelatedVm.addressBelowData = '';
                instanomineeDetailsRelatedVm.pincodeData = '';
                instanomineeDetailsRelatedVm.cityData = '';
                instanomineeDetailsRelatedVm.stateData = '';
                instaService.nomineeAadhaarCardDetails.house = '';
                instaService.nomineeAadhaarCardDetails.street = '';
                instaService.nomineeAadhaarCardDetails.loc = '';
                instaService.nomineeAadhaarCardDetails.vtc = '';
                instaService.nomineeAadhaarCardDetails.po = '';
                instaService.nomineeAadhaarCardDetails.subdist = '';
                instanomineeDetailsRelatedVm.selectStateList = '';
                instanomineeDetailsRelatedVm.nomineeAddressForm.$setPristine();
            }
        };


        instanomineeDetailsRelatedVm.loadStateList = function (data, stateCodeData) {
            var inputparams = {
                "pinCode": data
            }
            //if (!instanomineeDetailsRelatedVm.selectStateList) {
            instanomineeDetailsRelatedService.getAreaDetailForPincode(inputparams).then(function (data) {
                if (!utilityService.isUndefined(data)) {
                    instanomineeDetailsRelatedVm.selectStateList = data;
                    instaService.customer.city = utilityService.getValue(data.cityName);
                    instaService.customer.state = utilityService.getValue(data.stateName);
                    instaService.nominee.cityCode = utilityService.getValue(data.cityCode);
                    instaService.nominee.stateCode = utilityService.getValue(data.stateCode);
                    instanomineeDetailsRelatedVm.cityData = instaService.customer.city;
                    instanomineeDetailsRelatedVm.stateData = instaService.customer.state;
                    instanomineeDetailsRelatedVm.ncity = instanomineeDetailsRelatedVm.cityData;
                    instanomineeDetailsRelatedVm.nstate = instanomineeDetailsRelatedVm.stateData;
                    if (!utilityService.isUndefined(instanomineeDetailsRelatedVm.ncity)) {
                        instanomineeDetailsRelatedVm.isCityModified = true;
                    }
                    if (!utilityService.isUndefined(instanomineeDetailsRelatedVm.nstate)) {
                        instanomineeDetailsRelatedVm.isStateModified = true;
                    }
                    instanomineeDetailsRelatedVm.selectdState = stateCodeData;
                }
            }, function (error) {
                instanomineeDetailsRelatedVm.selectStateList = "";
            });
            // }else{
            // instanomineeDetailsRelatedVm.selectdState = stateCodeData;
            // }
        };

        instanomineeDetailsRelatedVm.stateListChange = function (data) {
            var arr = instanomineeDetailsRelatedVm.selectStateList;
            var arrLength = arr.length;
            for (var i = 0; i < arrLength; i++) {
                if (arr[i].stateCode == data) {
                    var tempData = arr[i];
                    instaService.customer.city = utilityService.getValue(tempData.cityName);
                    instaService.customer.state = utilityService.getValue(tempData.stateName);
                    instaService.nominee.cityCode = utilityService.getValue(tempData.cityCode);
                    instaService.nominee.stateCode = utilityService.getValue(tempData.stateCode);
                    instanomineeDetailsRelatedVm.cityData = instaService.customer.city;
                    instanomineeDetailsRelatedVm.stateData = instaService.customer.state;
                    instanomineeDetailsRelatedVm.ncity = instanomineeDetailsRelatedVm.cityData;
                    instanomineeDetailsRelatedVm.nstate = instanomineeDetailsRelatedVm.stateData;
                    if (!utilityService.isUndefined(instanomineeDetailsRelatedVm.ncity)) {
                        instanomineeDetailsRelatedVm.isCityModified = true;
                    }
                    if (!utilityService.isUndefined(instanomineeDetailsRelatedVm.nstate)) {
                        instanomineeDetailsRelatedVm.isStateModified = true;
                    }
                }
            };

        };

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            instanomineeDetailsRelatedVm.showBack = true;
            instanomineeDetailsRelatedVm.showNext = true;
            instanomineeDetailsRelatedVm.isAddress1 = false;
            instanomineeDetailsRelatedVm.isAddress2 = false;
            instanomineeDetailsRelatedVm.validDateFormat = false;
            instanomineeDetailsRelatedVm.isMName = false;
            instanomineeDetailsRelatedVm.isNomineeScanned = instaService.isNomineeScanned;
            instanomineeDetailsRelatedVm.journeyType = instaService.journeyType;
            instanomineeDetailsRelatedVm.constantJourneyTypeVKYC = constantConfig.acOpeningAdapterOVDConstant.vkycInsta;

            instanomineeDetailsRelatedVm.displayNomineeAdharDetails();

            if (instanomineeDetailsRelatedVm.isNomineeScanned === true) {
                instanomineeDetailsRelatedVm.nomineeAge = instaService.nomineeAadhaarCardDetails.age;
                instanomineeDetailsRelatedVm.displayNames(instaService.nomineeAadhaarCardDetails.name);
                instanomineeDetailsRelatedVm.populateDobAadhaar(instaService.nomineeAadhaarCardDetails.dob);
            } else {
                instanomineeDetailsRelatedVm.nomineeAge = instaService.nominee.age;
                instanomineeDetailsRelatedVm.populateDobAadhaar(instaService.nominee.dob);
            }
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
