'use strict';

angularApp.service('instanomineeDetailsRelatedService',
    function($q, AdapterUtils, constantConfig) {
        var instanomineeDetailsRelatedService = this;

        instanomineeDetailsRelatedService.createNominee = function(data) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.createNominee, data, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        instanomineeDetailsRelatedService.getAreaDetailForPincode = function(inputparams) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.getPostalDetailByPinCode , inputparams, true).then(

                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        instanomineeDetailsRelatedService.updateGuardian = function(data) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.updateGuardianDetails, data, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        instanomineeDetailsRelatedService.guardianCheck = function(data) {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.guardianAddress, data, true).then(

                function(response) {
                    q.resolve(response.data.guardianAddress);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        return instanomineeDetailsRelatedService;
    });
