'use strict';

angularApp.controller('instanomineeEnteredAddressController', ["$state",
    "$scope",
    "instaService",
    "instanomineeDetailsRelatedService",
    "utilityService",
    "$timeout",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "constantConfig",

    function ($state,
        $scope,
        instaService,
        instanomineeDetailsRelatedService,
        utilityService,
        $timeout,
        $ionicSideMenuDelegate,
        mPinLoginService,
        constantConfig) {

        var instanomineeEnteredAddressVm = this;

        function initPage() {

            instanomineeEnteredAddressVm.showBack = true;
            instanomineeEnteredAddressVm.showNext = true;
            instanomineeEnteredAddressVm.aofooter = true;
            instanomineeEnteredAddressVm.disableNext = true;
        }

        instanomineeEnteredAddressVm.goBacktoPrevious = function () {
            $state.go("menu.instaKit_nomineeDetailsAddressOption");
        }

        instanomineeEnteredAddressVm.changefn = function () {
            if (instanomineeEnteredAddressVm.isChecked) {
                instanomineeEnteredAddressVm.disableNext = false;
            } else {
                instanomineeEnteredAddressVm.disableNext = true;
            }
        }

        /*$scope.$watch("instanomineeEnteredAddressVm.guardian-appoint.$valid", function(value) {
            
            if (value == true) {
                instanomineeEnteredAddressVm.disableNext = false;
            } else {
                instanomineeEnteredAddressVm.disableNext = true;
            }
        });*/


        instanomineeEnteredAddressVm.setGuardianDetails = function () {
            var guardianDetails = {};
            if (instaService.isNomineeScanned === true) {
                guardianDetails.nomineeName = instaService.nomineeAadhaarCardDetails.name;
                guardianDetails.guardianName = instaService.nomineeAadhaarCardDetails.guardianName;
            }
            else {
                guardianDetails.nomineeName = instaService.nominee.name;
                guardianDetails.guardianName = instaService.nominee.guardianName;
            }
            return guardianDetails;
        }

        instanomineeEnteredAddressVm.goToNextPage = function () {
            var guardianDetailParams = instanomineeEnteredAddressVm.setGuardianDetails();
            instaService.nomineeGuardianDetails.guardianConsent = instanomineeEnteredAddressVm.isChecked;
            if (utilityService.isUndefined(guardianDetailParams.guardianName)) {
                var title = '';
                var template = '{{"IF_GUARDIAN_NAME_EMPTY" | translate}}';
                var onTap = 'menu.instaKit_nominationRelated';
                var buttontext = 'OK';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            }
            else {
                //Service to update guardian details
                var params = {
                    "id": instaService.customer.mobileNo,
                    "data": {
                        "nominees": [{
                            "guardian": {
                                "address": {
                                    "addressLine1": instanomineeEnteredAddressVm.personalDetails.addressLine1,
                                    "addressLine2": instanomineeEnteredAddressVm.personalDetails.addressLine2,
                                    "pincode": instanomineeEnteredAddressVm.personalDetails.pincode,
                                    "city": instanomineeEnteredAddressVm.personalDetails.city,
                                    "state": instanomineeEnteredAddressVm.personalDetails.state,
                                    "locality": ""
                                },
                                "name": guardianDetailParams.guardianName,
                                "guardianAddressFlag": instaService.nominee.guardianAddressFlag,
                                "guardianConsent": instaService.nomineeGuardianDetails.guardianConsent
                            },
                            "name": guardianDetailParams.nomineeName
                        }],
                        "commonId": $state.$current.data.commonId
                    }
                }
                instanomineeDetailsRelatedService.updateGuardian(params).then(function (response) {
                    // $state.go("menu.instaKit_selectBranchListLocality");
                    if (instaService.isResumeJourney && instaService.homeBranchLocalityId) {
                        $state.go("menu.instaKit_reviewSelectedBranch");
                    } else {
                        $state.go("menu.instaKit_selectBListLocalityByPincode");
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        }

        $scope.goToHome = function () {
            instaService.homeNav();
        }

        instanomineeEnteredAddressVm.fullAddress = function () {
            var address = "";
            instanomineeEnteredAddressVm.isChecked = instaService.nomineeGuardianDetails.guardianConsent;
            if (instaService.isNomineeScanned === true) {
                instanomineeEnteredAddressVm.personalDetails.addressLine1 = instaService.nullCheck(instaService.nomineeAadhaarCardDetails.address1);
                instanomineeEnteredAddressVm.personalDetails.addressLine2 = instaService.nullCheck(instaService.nomineeAadhaarCardDetails.address2);
                instanomineeEnteredAddressVm.personalDetails.address = instaService.nullCheck(instaService.nomineeAadhaarCardDetails.address1) + instaService.nullCheck(instaService.nomineeAadhaarCardDetails.address2);
                instanomineeEnteredAddressVm.personalDetails.pincode = instaService.nomineeAadhaarCardDetails.pc;
                instanomineeEnteredAddressVm.personalDetails.city = instaService.nomineeAadhaarCardDetails.dist;
                instanomineeEnteredAddressVm.personalDetails.state = instaService.nomineeAadhaarCardDetails.state;
            } else {
                instanomineeEnteredAddressVm.personalDetails.addressLine1 = instaService.nullCheck(instaService.nominee.address1);
                instanomineeEnteredAddressVm.personalDetails.addressLine2 = instaService.nullCheck(instaService.nominee.address2);
                instanomineeEnteredAddressVm.personalDetails.address = instaService.nullCheck(instaService.nominee.address1) + instaService.nullCheck(instaService.nominee.address2);
                instanomineeEnteredAddressVm.personalDetails.pincode = instaService.nominee.pincode;
                instanomineeEnteredAddressVm.personalDetails.city = instaService.nominee.city;
                instanomineeEnteredAddressVm.personalDetails.state = instaService.nominee.state;
            }
            if (!utilityService.isUndefined(instanomineeEnteredAddressVm.personalDetails.addressLine1)) {
                var index = instanomineeEnteredAddressVm.personalDetails.addressLine1.lastIndexOf(",");
                instanomineeEnteredAddressVm.personalDetails.addressLine1 = instanomineeEnteredAddressVm.personalDetails.addressLine1.substring(0, index) + instanomineeEnteredAddressVm.personalDetails.addressLine1.substring(index + 1);
            }
            if (!utilityService.isUndefined(instanomineeEnteredAddressVm.personalDetails.addressLine2)) {
                var index = instanomineeEnteredAddressVm.personalDetails.addressLine2.lastIndexOf(",");
                instanomineeEnteredAddressVm.personalDetails.addressLine2 = instanomineeEnteredAddressVm.personalDetails.addressLine2.substring(0, index) + instanomineeEnteredAddressVm.personalDetails.addressLine2.substring(index + 1);
            }
            if (!utilityService.isUndefined(instanomineeEnteredAddressVm.personalDetails.address)) {
                var index = instanomineeEnteredAddressVm.personalDetails.address.lastIndexOf(",");
                instanomineeEnteredAddressVm.personalDetails.address = instanomineeEnteredAddressVm.personalDetails.address.substring(0, index) + instanomineeEnteredAddressVm.personalDetails.address.substring(index + 1);
            }
        }

        instanomineeEnteredAddressVm.guardianDetails = function () {
            if (instaService.isNomineeScanned === true) {
                instanomineeEnteredAddressVm.guardianConName = instaService.nomineeAadhaarCardDetails.guardianName;
                instanomineeEnteredAddressVm.guardianConAge = instaService.nomineeAadhaarCardDetails.guardianAge;
            }
            else {
                instanomineeEnteredAddressVm.guardianConName = instaService.nominee.guardianName;
                instanomineeEnteredAddressVm.guardianConAge = instaService.nominee.guardianAge;
            }
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            instanomineeEnteredAddressVm.journeyType = instaService.journeyType;
            instanomineeEnteredAddressVm.constantJourneyTypeVKYC = constantConfig.acOpeningAdapterOVDConstant.vkycInsta;
            instanomineeEnteredAddressVm.personalDetails = {};
            instanomineeEnteredAddressVm.fullAddress();
            if (instanomineeEnteredAddressVm.isChecked == true) {
                instanomineeEnteredAddressVm.disableNext = false;
            }
            else {
                instanomineeEnteredAddressVm.disableNext = true;
            }
            instanomineeEnteredAddressVm.guardianDetails();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
