'use strict';

angularApp.controller('instapanAuthoriseController', ["$state",
    "$scope",
    "instapanAuthoriseService",
    "instaService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        instapanAuthoriseService,
        instaService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instapanAuthoriseVm = this;

        function initPage() {
            instapanAuthoriseVm.showBack = true;
            instapanAuthoriseVm.showNext = true;
            instapanAuthoriseVm.isChecked = '';
            instapanAuthoriseVm.disableNext = true;
            instapanAuthoriseVm.aofooter = true;
            instapanAuthoriseVm.loadAuthorizeDetails();
            $scope.isiPhone = utilityService.isIOSPlatform();
            instapanAuthoriseVm.isChecked = instaService.aadhaarAuthorizeFlag;
            instapanAuthoriseVm.agreeToAuthorize();
        }

        instapanAuthoriseVm.goBacktoPrevious = function() {
             $state.go('menu.instaKit_tax');
        }

        instapanAuthoriseVm.goToNextPage = function() {
            instapanAuthoriseVm.postAuthorizeDetails();
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        instapanAuthoriseVm.agreeToAuthorize = function() {
            if (instapanAuthoriseVm.isChecked) {
                instapanAuthoriseVm.disableNext = false;
            } else {
                instapanAuthoriseVm.disableNext = true;
            }
        }

        instapanAuthoriseVm.loadAuthorizeDetails = function() {
            instapanAuthoriseService.getAuthorizationDetails().then(function(data) {
                instapanAuthoriseVm.authorisationDetails = data;
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        instapanAuthoriseVm.postAuthorizeDetails = function() {
            instaService.aadhaarAuthorizeFlag = instapanAuthoriseVm.isChecked;
            var requestParams = {
                "id": instaService.customer.mobileNo,
                "data": {
                    "aadhaarAuthorizeFlag": instapanAuthoriseVm.isChecked,
                    "commonId": $state.$current.data.commonId
                }
            }

            instapanAuthoriseService.setPanAuthorizeFlag(requestParams).then(function(data) {
                $state.go('menu.instaKit_personalDetails');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }


        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
