'use strict';

angularApp.controller('instapanDetailsController', ["$state",
    "$scope",
    "$translate",
    "$ionicHistory",
    "utilityService",
    "instapanDetailsService",
    "instaService",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "newToSbiService",
    "$ionicPopup",

    function($state,
        $scope,
        $translate,
        $ionicHistory,
        utilityService,
        instapanDetailsService,
        instaService,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService,
        newToSbiService,$ionicPopup) {

        var instapanDetailsVm = this;

        function initPage() {
            instapanDetailsVm.showBack = true;
            instapanDetailsVm.showNext = true;
            instapanDetailsVm.aofooter = true;
            instapanDetailsVm.disableNext = true;

            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                instapanDetailsVm.okBtntext = translatedvalue;
            });
        }

        instapanDetailsVm.goBacktoPrevious = function() {
            if (instaService.correspondenceCheckStatus == false) {
                $state.go("menu.instaKit_pdetailsAddress");
            } else {
                $state.go("menu.instaKit_pdetailsCAddress");
            } 
        }

        instapanDetailsVm.goToNextPage = function(isValid) {
            var panCheck = instapanDetailsVm.pannumber;
            var validPan = panCheck.toUpperCase();
            if (isValid && validPan.substring(3, 4) == "P") {
                instaService.customer.panNumber = validPan;
                var params = {
                    "panNumber":instaService.customer.panNumber.toLowerCase()
                }
                //Service to update the pan number
                instapanDetailsService.panValidation(params).then(function(response) {
                   // instapanDetailsVm.updateCifStatus();
                   if(!utilityService.isUndefined(response.data)) {
                    instapanDetailsVm.panName = response.data.firstName + (response.data.middleName == " " ? "" : (" " + response.data.middleName)) + " " + response.data.lastName;
                      if (response.data.cif == "1001" || response.data.cif == "0002") {
		                         	utilityService.showErrorMessage(response.data.details);
		                         	return true;
		                         }
           if(!utilityService.isUndefined(response.data.firstName) ||!utilityService.isUndefined(response.data.lastName || response.data.cif == "0000")){                           
                            instapanDetailsVm.validatePan();
                            //instapanDetailsVm.updateCifStatus();
                           // $state.go('menu.instaKit_aOLooksGreat');
                       }
                   }
                   else{
                    var title = '';
                    var template = '{{"INVALID_PAN_INFO" | translate}}';
                    var onTap = 'menu.instaKit_panDetails';
                    var buttontext = '<b>' + instapanDetailsVm.okBtntext + '</b>';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                   }
                   
                }, function(error) {
                    instapanDetailsVm.errorMsg = error.responseMessage;
                    if (error.responseCode == "0012" || error.responseCode == "0011") {
                        instapanDetailsService.showAlertPopup("error", instapanDetailsVm.errorMsg, "", "menu.instaKit_mobileEntryPage", "OK", "", "", "");
                    } else if (error.responseCode == "0013") {
                        instapanDetailsService.showAlertPopup("error", instapanDetailsVm.errorMsg, "", "", "Retry", "", "", "");
                    } else if (!error.responseCode) {
                        instapanDetailsVm.showPopup2 = $ionicPopup.show({
                            template: '<p>Aadhar is not linked, Please link & try in 15 days.</p>',
                            title: '',
                            cssClass: 'dialog',
                            scope: $scope,
                            buttons: [{
                                text: 'Ok',
                                type: 'button-assertive',
                                onTap: function (e) {
                                    $state.go("menu.instaKit_mobileEntryPage");
                                }
                            }]
                        });

                    } else {
                        utilityService.showErrorMessage(error.responseMessage);
                    }
                });
            } else {
                var title1 = '';
                var template1 = '{{"INCORRECT_PAN_MSG" | translate}}';
                var onTap1 = 'menu.instaKit_panDetails';
                var buttontextN = '<b>' + instapanDetailsVm.okBtntext + '</b>';
                utilityService.showAlertModal(title1, template1, onTap1, $scope, $state, buttontextN);
                 
            }
        } 

        instapanDetailsVm.validatePan = function(){
            
            
            var params = {
                    "pan": instaService.customer.panNumber.toLowerCase()                            
                   
                }
        instapanDetailsService.validatePanNumber(params).then(function(response) {
            if (!utilityService.isUndefined(response.data.cif)) {
                instaService.cifNumber = response.data.cif;
              
                if (response.data.cif == "0000") {     
                    $state.go('menu.instaKit_aOLooksGreat');
                }
                 else {
                    $state.go('menu.instaKit_multipleCustomer');
                    //$state.go('menu.passbookDetails');
                }
                instapanDetailsVm.updateCifStatus();
            }
        }, function(error) {
            if(error.responseCode == "0004"){
                    instaService.panName = instapanDetailsVm.panName;
                    $state.go("menu.instaKit_kindlyNote");
                }else{
                    utilityService.showErrorMessage(error.responseMessage);
                }
            
            
        });
        }

        instapanDetailsVm.updateCifStatus = function() {
            var params = {
                "id": instaService.customer.mobileNo,
                "data": {
                    "personalDetails": {
                        "pan": instaService.customer.panNumber.toLowerCase(),
                        "panName": instapanDetailsVm.panName,
                        "cifStatus": instaService.cifNumber
                    },
                        "commonId":$state.$current.data.commonId
                    }
                }
            
            instapanDetailsService.updateCif(params).then(function(response) {
               
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }      

        instapanDetailsVm.populateResumeData = function() {
            /*if (instaService.isResumeJourney == true) {*/
            instapanDetailsVm.pannumber = instaService.customer.panNumber;
            /*}*/
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        instapanDetailsVm.enableNext = function() {
            if (!utilityService.isUndefined(instapanDetailsVm.pannumber)) {
                if (instapanDetailsVm.pannumber.length == constantConfig.acOp.panLength && (instapanDetailsVm.panDetailForm.panNumber.$invalid == true || instapanDetailsVm.panDetailForm.panNumber.$valid == true)) {
                    instapanDetailsVm.panDetailForm.$valid = true;
                } else {
                    instapanDetailsVm.panDetailForm.$valid = false;
                }
            }
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            instapanDetailsVm.populateResumeData();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            instapanDetailsVm.getInstaPlusDetail = angular.copy(newToSbiService.getInstaPlusDetail);
        });

        return this;
    }
]);
