'use strict';

angularApp.service('instapanDetailsService',
    function($q, AdapterUtils, constantConfig, $ionicPopup, $state) {
        var instapanDetailsService = this;

        instapanDetailsService.updatePanNumber = function(data) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.updatePANNumber, data, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
                );
            return q.promise;

        };

        instapanDetailsService.updateCif = function(data) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.updateCif, data, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
                );
            return q.promise;

        };

        instapanDetailsService.validatePanNumber = function(data) {
            var q = $q.defer();
            AdapterUtils.postDataWithTimeOut(constantConfig.InstaAcOpeningAdapterUrl.validatePanNumber, data, true, 90000).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
                );
            return q.promise;

        };

         instapanDetailsService.panValidation = function(data) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.panValidation, data, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
                );
            return q.promise;

        };

        instapanDetailsService.showAlertPopup = function (imageType, message1, message2, onTapgo, buttontext1, buttontext2, $scope, obj) {
            var btn_array = [];
            if (buttontext1 != "" && buttontext2 != "") {
                btn_array = [
                    {
                        text: buttontext2 || "Cancel",
                        type: 'button-negative',
                        onTap: function () {

                        }
                    },
                    {
                        text: buttontext1 || "OK",
                        type: 'button-positive',
                        onTap: function () {
                            if (onTapgo) {
                                $state.go(onTapgo);
                            }
                        }
                    }
                ];
            }
            else {
                btn_array = [
                    {
                        text: buttontext1 || "OK",
                        type: 'button-positive',
                        onTap: function () {
                            if (onTapgo) {
                                $state.go(onTapgo);
                            }
                        }
                    }
                ];
            }

            if (imageType && imageType.toLowerCase() == 'error') {
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/errorSymbol.svg"/></div>';
            } else if (imageType && imageType.toLowerCase() == 'success') {
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/successSymbol.svg"/></div>';
            } else if (imageType && imageType.toLowerCase() == 'alert') {
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/alertSymbol.svg"/></div>';
            } else {
                imageType = "";
            }
            var bhimErrorPopup = $ionicPopup.alert({
                template: '<div class="font-dark-grey">' + imageType + '<div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter roboto-medium font-size-16 color-darkgrey"><span>'
                + message1 + '</span><div ng-if="message2" class="textAlignCenter roboto-regular font-size-14 color-darkgrey padTop10">' + message2 + '</div></div></div></div>', //template,
                scope: $scope,
                cssClass: 'bhim-alert-popup',
                buttons: btn_array,
            });
            bhimErrorPopup.then(function (res) {
            });
        };

        
        return instapanDetailsService;

    });




