'use strict';

angularApp.controller('instapasswordOTPController', ["$state",
    "$scope",
    "$translate",
    "instapasswordOTPService",
    "utilityService",
    "instaService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        $translate,
        instapasswordOTPService,
        utilityService,
        instaService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instapasswordOTPVm = this;

        function initPage() {
            instapasswordOTPVm.showBack = false;
            instapasswordOTPVm.showNext = true;
            instapasswordOTPVm.showOtpView = true;
            instapasswordOTPVm.otpvalue = "";
            instapasswordOTPVm.disableNext = true;
            instapasswordOTPVm.aofooter = true;
            instapasswordOTPVm.requestOtpCall();
			pwdOtpForm.isDisabledOTP = false;
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                instapasswordOTPVm.okBtntext = translatedvalue;  
            });

        }

        instapasswordOTPVm.goBacktoPrevious = function() {
            //$state.go("menu.instaKit_productOffering");
            $state.go('menu.instaKit_termsAndConditions');
        }

        instapasswordOTPVm.goToNextPage = function() {
            /* Send the OTP */
            instaService.tncOtpValue = instapasswordOTPVm.otpvalue;
            var requestParams = {
                "mobile":instaService.customer.mobileNo,
                "otp": instapasswordOTPVm.otpvalue
            }
            instapasswordOTPService.OTPValidation(requestParams).then(function(response) {
                if (response.data.status.toLowerCase() == "success") {
                    $state.go("menu.instaKit_regenerateAppPassword");
                } else {
                    var message = "Please enter valid OTP";
                    utilityService.showErrorMessage(message);
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

		 instapasswordOTPVm.requestOtpCallOnce = function() {
		 	// if(pwdOtpForm.isDisabledOTP){return true}
		 	instapasswordOTPVm.requestOtpCall();
		 	    // pwdOtpForm.isDisabledOTP = true;
		 };	
         
        /* Request for OTP on page load to the registered mobile number */
        instapasswordOTPVm.requestOtpCall = function() {
            var requestParams = {
                "id": instaService.customer.mobileNo,
                "recipientMailId": instaService.customer.emailId
            }
            instapasswordOTPService.requestOtp(requestParams).then(function(response) {

                var title = '';
                var template = '{{"OTP_SENT_SUCCESS" | translate}}';
                var onTap = '';
                var buttontext = '<b>' +  instapasswordOTPVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
               
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        instapasswordOTPVm.validateOTP = function(isValid) {
            instapasswordOTPVm.disableNext = !isValid;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
