'use strict';

angularApp.controller('instapasswordRecoveryController', ["$state",
    "$scope",
    "$translate",
    "instaService",
    "utilityService",
    "instapasswordRecoveryService",
    "constantConfig",
    "instaappPasswordService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
	"ConnectivityMonitorUtils",
    function($state,
        $scope,
        $translate,
        instaService,
        utilityService,
        instapasswordRecoveryService,
        constantConfig,
        instaappPasswordService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        ConnectivityMonitorUtils) {

        var instapasswordRecoveryVm = this;

        function initPage() {
            instapasswordRecoveryVm.showBack = false;
            instapasswordRecoveryVm.showNext = true;
            instapasswordRecoveryVm.disableNext = true;
            instapasswordRecoveryVm.aofooter = true;
            instapasswordRecoveryVm.securityQuestions = [];
            instapasswordRecoveryVm.loadSecurityQuestion();
            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                instapasswordRecoveryVm.okBtntext = translatedvalue;
            });
        }

        instapasswordRecoveryVm.goToNextPage = function() {
           if (ConnectivityMonitorUtils.isOffline()) {
				   utilityService.showErrorMessage( "Unable to connect to Internet. Please check your connectivity." );
				   return true;
			    }
			    
            var requestParams = {
                "mobileNumber": instapasswordRecoveryVm.newMobile,
                "securityQues": instapasswordRecoveryVm.selectedSecQuestion,
                "securityAns": instapasswordRecoveryVm.secAnswer
            }
            instapasswordRecoveryService.checkUser(requestParams).then(function(response) {
            	
                if(response.data.status.toLowerCase() == 'success'){
                    instaService.customer.mobileNo = instapasswordRecoveryVm.newMobile;
                    $state.go("menu.instaKit_passwordOTP");
                }
                else{
                    var title = '';
                    var template = '{{"DETAIL_NO_MATCH_WITH_MOB" | translate}}';
                    var onTap = 'menu.instaKit_applyNewOrResume';
                    var buttontext = '<b>' + instapasswordRecoveryVm.okBtntext + '</b>';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                }
            }, function(error) {
                if(!utilityService.isUndefined(error.data)){
                    if(error.data.status.toLowerCase() == "ao"){
                        var title = '';
                        var template = '{{"NOT_INSTA_ACC" | translate}}';
                        var onTap = 'menu.resumeJourney';
                        var buttontext = '<b>' + instapasswordRecoveryVm.okBtntext + '</b>';
                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                    }
                }
                else{
                    var title = '';
                    var template = '{{"DETAIL_NO_MATCH" | translate}}';
                    var onTap = 'menu.instaKit_applyNewOrResume';
                    var buttontext = '<b>' + instapasswordRecoveryVm.okBtntext + '</b>';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                }               
            });
        };

        $scope.goToHome = function() {
            instaService.homeNav();
        }

         instapasswordRecoveryVm.loadSecurityQuestion = function(){
			utilityService.showSpinner();
        	if(!instapasswordRecoveryVm.isErorr){
 		       	instapasswordRecoveryVm.isErorr = false;	
        	}
            instaappPasswordService.loadSecurityQuestions().then(function(response) {
				utilityService.hideSpinner();
            	instapasswordRecoveryVm.isErorr = false;
                instapasswordRecoveryVm.securityQuestions = response.data.masterDetails;
            }, function(error) {
				utilityService.hideSpinner();
            	instapasswordRecoveryVm.isErorr = true;
                utilityService.showErrorMessage(error.responseMessage);
            });
        };

        instapasswordRecoveryVm.proceedSuccess = function(isValid) {
            isValid ? instapasswordRecoveryVm.disableNext = false : instapasswordRecoveryVm.disableNext = true;
            return instapasswordRecoveryVm.disableNext;
        }

        instapasswordRecoveryVm.forgotSecurityQA = function(){
            var title = '';
            var template = '{{"FORGOT_QA_MSG" | translate}}';
            var onTap = 'menu.instaKit_passwordRecovery';
            var buttontext = '<b>' + instapasswordRecoveryVm.okBtntext + '</b>';
            utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
