'use strict';

angularApp.controller('instaaadharscanController', ["$state",
    "$scope",
    "$cordovaBarcodeScanner",
    "instaService",
    "utilityService",
    "$translate",
    "$ionicSideMenuDelegate",
    "mPinLoginService",


    function($state,
        $scope,
        $cordovaBarcodeScanner,
        instaService,
        utilityService,
        $translate,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instaaadharvm = this;
        var alphabets = /^([ \.]?[a-zA-Z]+)+$/;
        var numbers = /^[0-9]*$/;
        var addressRegex = /^[A-z().,-/0-9 #']*$/;

        function initPage() {
            instaaadharvm.showBack = true;
            instaaadharvm.showNext = false;
            instaaadharvm.aofooter = true;
            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                instaaadharvm.okBtntext = translatedvalue;
            });
        }

        instaaadharvm.goBacktoPrevious = function() {
            $state.go('menu.instaKit_personalDetails');
        }

        instaaadharvm.goToNextPage = function() {
            $state.go('menu.instaKit_pdetailsAN');
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        //QR code scanner code
        instaaadharvm.goToQRCodeDetails = function() {
            $cordovaBarcodeScanner.scan().then(function(barcodeData) {
                if (!utilityService.isUndefined(barcodeData.text)) {
                    var xmlText = barcodeData.text;
                    var formattedXml = xmlText.replace("/?xml", "?xml");
                    formattedXml = formattedXml.replace("xml?", "?xml");
                    var x2js = new X2JS();
                    var jsonObj = x2js.xml_str2json(formattedXml);
                    if (utilityService.isUndefined(jsonObj)) {
                        var title = '';
                        var template = "{{'AADHAAR_POPUP'| translate}}";
                        var onTap = '';
                        var buttontext = "<b>" + instaaadharvm.okBtntext + "</b>";
                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                    } else {
                        instaService.isResumeJourney = false;
                        var jsonStr = JSON.stringify(jsonObj);
                        instaService.customerManualEntryDetails = {
                            aadharNumber: "",
                            firstName: "",
                            lastName: "",
                            middleName: "",
                            fullName: "",
                            gender: "",
                            title: "",
                            dob: "",
                            address1: "",
                            address2: "",
                            city: "",
                            state: "",
                            pincode: "",
                            isAadharScanned: false,
                            locality: "",
                            addressLine1: "",
                            addressLine2: ""

                        }

                        instaService.customerAadhaarCardDetails = {
                            uid: ""
                        }
                       
                        if (instaService.nomineeAadhaarCardDetails.uid === instaService.checkSecuredData(numbers, securedScannedData._uid)) {
                            var title = '';
                            var template = "{{'AADHAAR_BOTH_SAME'| translate}}";
                            var onTap = '';
                            var buttontext = "<b>" + instaaadharvm.okBtntext + "</b>";
                            utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                        } else {
                            setTimeout(function() {
                                instaService.customerAadhaarCardDetails.uid = instaService.checkSecuredData(numbers, securedScannedData._uid);
                                instaaadharvm.isScanned = true;
                                $state.go('menu.instaKit_pdetailsAN');
                            }, 500);
                        }
                    }
                }

            }, function(error) {
                var title = '';
                var template = "{{'ACCESS_APP'| translate}}";
                var onTap = '';
                var buttontext = "<b>" + instaaadharvm.okBtntext + "</b>";
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            });
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
