'use strict';

angularApp.controller('instapersonalDetailsANController', ["$state",
    "$scope",
    "$translate",
    "utilityService",
    "instaService",
    "instapersonalDataService",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        $translate,
        utilityService,
        instaService,
        instapersonalDataService,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instapdetailsANVm = this;

        function initPage() {
            instapdetailsANVm.showBack = true;
            instapdetailsANVm.showNext = true;
            instapdetailsANVm.invalid = false;
            instapdetailsANVm.aofooter = true;
            instapdetailsANVm.properDate = false;

            //  $translate(['AO_OK_LABEL','ADHAR_MSG_AO']).then(function(translatedvalue) {
            //     var title = '';
            //     instapdetailsANVm.okBtntext = translatedvalue.AO_OK_LABEL;
            //     var template = translatedvalue.ADHAR_MSG_AO;
            //     var onTap = '';
            //     var buttontext = '<b>' + instapdetailsANVm.okBtntext + '</b>';
            //     utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
          
            // });  
        }

        instapdetailsANVm.loadTitles = function(){
            var requestData = "TitleLotus";
            instapdetailsANVm.isErorr = false;
            utilityService.showSpinner();
            instapersonalDataService.loadTitleDropdown(requestData).then(function(response) {
                instapdetailsANVm.isErorr = false;
                utilityService.hideSpinner();
                instapdetailsANVm.selectTitles = response.data;
                instapdetailsANVm.personalDetails.title = instapdetailsANVm.populateTitle(instaService.customerAadhaarCardDetails.gender);
                if(instapdetailsANVm.personalDetails.gender.toLowerCase() == "male"){
                    instapdetailsANVm.disableSelectedTitle = true;
                }else{
                    instapdetailsANVm.disableSelectedTitle = false;
                    instapdetailsANVm.selectTitles ? instapdetailsANVm.selectTitles.shift() : '';
                }
                
            }, function(error) {
            	utilityService.hideSpinner();
            	instapdetailsANVm.isErorr = true;
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        instapdetailsANVm.goBacktoPrevious = function() {
            instapdetailsANVm.personalDetailsDate = null;
            instapdetailsANVm.personalDetailsMonth = null;
            $state.go('menu.instaKit_aadhaarValidation');
        }

        instapdetailsANVm.goToNextPage = function() {
            instapdetailsANVm.ageCheck = instapdetailsANVm.checkAge();
            if (instapdetailsANVm.ageCheck > 0) {
                $state.go('menu.instaKit_pdetailsAddress');
            } else {
                var title = '';
                var template = '{{"AGE_CHECK" | translate}}';
                var onTap = 'menu.instaKit_pdetailsAN';
                var buttontext = '<b>' + instapdetailsANVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            }
            $state.go('menu.instaKit_pdetailsAddress');
            instaService.customerAadhaarCardDetails.dob = instapdetailsANVm.personalDetailsDate + "/" + instapdetailsANVm.personalDetailsMonth + "/" + instapdetailsANVm.personalDetails.yob;
            instaService.customerAadhaarCardDetails.firstName = instapdetailsANVm.firstName;
            instaService.customerAadhaarCardDetails.middleName = instapdetailsANVm.middleName;
            instaService.customerAadhaarCardDetails.lastName = instapdetailsANVm.lastName;
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        // Form validation
        instapdetailsANVm.validateForm = function(isValid) {
            instapdetailsANVm.disableNext = !(isValid);
        }

        instapdetailsANVm.disableNextIfEmpty = function() {
            if (utilityService.isUndefined(instaService.customerAadhaarCardDetails.uid) || utilityService.isUndefined(instaService.customerAadhaarCardDetails.name)) {
                var title = '';
                var template = '{{"AADHAAR_DETAILS_IF_EMPTY" | translate}}';
                var onTap = 'menu.instaKit_locateNearestBranch';
                var buttontext = 'Locate Nearest Branch';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                instapdetailsANVm.showNext = false;
            }
        }

        // On page load - populate aadhaar dob
        instapdetailsANVm.populateDobAadhaar = function() {
            if (!utilityService.isUndefined(instaService.customerAadhaarCardDetails.dob)) {
                var customerDate = instaService.customerAadhaarCardDetails.dob;
                var splitDate = customerDate.split(/[/-]/);
                instapdetailsANVm.personalDetailsDate = splitDate[0];
                instapdetailsANVm.personalDetailsMonth = splitDate[1];
                instapdetailsANVm.personalDetails.yob = splitDate[2];
            } else if (!utilityService.isUndefined(instaService.customerAadhaarCardDetails.yob) && utilityService.isUndefined(instaService.customerAadhaarCardDetails.dob)) {
                instapdetailsANVm.personalDetailsDate = "";
                instapdetailsANVm.personalDetailsMonth = "";
                instapdetailsANVm.personalDetailsDateForm.personalDetailsDate.$setPristine();
                instapdetailsANVm.personalDetailsDateForm.personalDetailsMonth.$setPristine();
                instapdetailsANVm.personalDetails.yob = parseInt(instaService.customerAadhaarCardDetails.yob);
            }
        }

        // On change - Gender will be changed on title selection
        instapdetailsANVm.titleSelection = function() {
            if (instapdetailsANVm.personalDetails.title == "01") {
                instapdetailsANVm.personalDetails.gender = "Male";
            } else {
                instapdetailsANVm.personalDetails.gender = "Female";
            }
            instaService.customerAadhaarCardDetails.titleCode = instapdetailsANVm.personalDetails.title;
            instaService.customerAadhaarCardDetails.title = instaService.getValueById(instapdetailsANVm.selectTitles, instaService.customerAadhaarCardDetails.titleCode);
            instaService.customerAadhaarCardDetails.gender = instapdetailsANVm.personalDetails.gender;
        }

        // On page load - If date/month is undefined, trigger the popup
        instapdetailsANVm.showHidePopup = function() {
            if (utilityService.isUndefined(instapdetailsANVm.personalDetailsDate) || utilityService.isUndefined(instapdetailsANVm.personalDetailsMonth)) {
                var title = '';
                var template = '{{"VALID_AGE_PROOF" | translate}}';
                var onTap = 'menu.instaKit_pdetailsAN';
                var buttontext = 'OK';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            }
        }

        //On page load - if gender is "M" / "F" - Change to full text
        instapdetailsANVm.displayGender = function(value) {
            var genderLabel;
            var genderValue = value.toLowerCase();
            if (genderValue == "m" || genderValue == constantConfig.acOp.maleGender) {
                genderLabel = "Male";
            } else {
                genderLabel = "Female";
            }
            return genderLabel;
        }

        //On page load - change title dropdown based on the gender
        instapdetailsANVm.populateTitle = function(value) {
            var title;
            var genderValue = value.toLowerCase();
            if (genderValue == "m" || genderValue == constantConfig.acOp.maleGender) {
                title = "01";
            } else {
                title = "02";
            }
            instaService.customerAadhaarCardDetails.titleCode = title;
            instaService.customerAadhaarCardDetails.title = instaService.getValueById(instapdetailsANVm.selectTitles, instaService.customerAadhaarCardDetails.titleCode);
            instaService.customerAadhaarCardDetails.gender = genderValue;
            return title;
        }

        //On page load - Split the aadhaar card holder's name and display accordingly
        instapdetailsANVm.displayNames = function(value) {
            var fullName = value;
            var splittedName = value.split(" ");
            var splitLen = value.split(" ").length;
            var i;
            var middleName = [];
            if (splitLen === 1) {
                instapdetailsANVm.firstName = splittedName[0];
                instapdetailsANVm.isMName = false;
                instapdetailsANVm.isLName = false;
            } else if (splitLen === 2) {
                instapdetailsANVm.isLName = true;
                instapdetailsANVm.firstName = splittedName[0];
                instapdetailsANVm.lastName = splittedName[1];
                instapdetailsANVm.isMName = false;
            } else {
                instapdetailsANVm.isLName = true;
                instapdetailsANVm.isMName = true;
                instapdetailsANVm.firstName = splittedName[0];
                for (i = 1; i < splitLen - 1; i++) {
                    middleName[i] = splittedName[i];
                }
                instapdetailsANVm.middleName = middleName.join(' ');
                instapdetailsANVm.lastName = splittedName[splitLen - 1];
            }
        }

        instapdetailsANVm.validDateFormat = function(isValid) {
            var fullDate = instapdetailsANVm.personalDetailsDate + '-' + instapdetailsANVm.personalDetailsMonth + '-' + instapdetailsANVm.personalDetails.yob;
            var dobMonth = instapdetailsANVm.personalDetailsMonth;
            var dobDay = instapdetailsANVm.personalDetailsDate;
            var dobYr = instapdetailsANVm.personalDetails.yob;
            var fullDateInMilliSeconds = Date.parse(fullDate);
            var formattedDate = new Date();
            var formattedDateYr = formattedDate.getFullYear();
            var currDate = new Date();
            var curYear = currDate.getFullYear();
            var curDateInMilliSeconds = new Date().getTime();
            formattedDate.setFullYear(dobYr, dobMonth - 1, dobDay);
            var months30 = ["04", "06", "09", "11", "4", "6", "9"];
            var monthIndex = months30.indexOf(dobMonth);

            if (fullDateInMilliSeconds > curDateInMilliSeconds) {
                instapdetailsANVm.disableNext = true;
                instapdetailsANVm.properDate = false;
                instapdetailsANVm.invalid = true;
            } else if (dobYr % 4 == 0 && (dobYr % 100 != 0 || dobYr % 400 == 0)) {
                if (dobMonth == 2 && dobDay > 29) {
                    instapdetailsANVm.disableNext = true;
                    instapdetailsANVm.invalid = true;
                    instapdetailsANVm.properDate = false;
                } else if (monthIndex != -1 && dobDay == 31) {
                    instapdetailsANVm.disableNext = true;
                    instapdetailsANVm.invalid = true;
                    instapdetailsANVm.properDate = false;
                } else {
                    instapdetailsANVm.disableNext = !isValid;
                    instapdetailsANVm.invalid = false;
                    instapdetailsANVm.properDate = true;
                }
            } else if (dobMonth == 2 && dobDay >= 29) {
                instapdetailsANVm.disableNext = true;
                instapdetailsANVm.invalid = true;
                instapdetailsANVm.properDate = false;
            } else if (monthIndex != -1 && dobDay == 31) {
                instapdetailsANVm.disableNext = true;
                instapdetailsANVm.invalid = true;
                instapdetailsANVm.properDate = false;
            } else {
                instapdetailsANVm.disableNext = !isValid;
                instapdetailsANVm.invalid = false;
                instapdetailsANVm.properDate = true;
            }
            
            if(instapdetailsANVm.personalDetailsDate  < 10  && instapdetailsANVm.personalDetailsDate.length == 1 ){
            	instapdetailsANVm.disableNext = true;
                instapdetailsANVm.invalid = true;
                instapdetailsANVm.properDate = false;
            }
            if(instapdetailsANVm.personalDetailsMonth < 10 && instapdetailsANVm.personalDetailsMonth.length == 1 ){
            	instapdetailsANVm.disableNext = true;
                instapdetailsANVm.invalid = true;
                instapdetailsANVm.properDate = false;
            }
            return instapdetailsANVm.properDate;
        }

        instapdetailsANVm.checkAge = function() {
            instapdetailsANVm.validDate = instapdetailsANVm.validDateFormat();

            if (instapdetailsANVm.validDate == true) {
                var fullDate = instapdetailsANVm.personalDetailsDate + '/' + instapdetailsANVm.personalDetailsMonth + '/' + instapdetailsANVm.personalDetails.yob;
                var formattedDate = new Date();
                formattedDate.setFullYear(instapdetailsANVm.personalDetails.yob, instapdetailsANVm.personalDetailsMonth - 1, instapdetailsANVm.personalDetailsDate);
                var todayDate = new Date();
                var currentYear = todayDate.getFullYear();
                var validYear = todayDate.setFullYear(currentYear - 18);
                instapdetailsANVm.customerAge = validYear - formattedDate;
                instapdetailsANVm.dob = fullDate;
                instapdetailsANVm.disableNext = false;
            } else if (instapdetailsANVm.validDate == false) {
                instapdetailsANVm.disableNext = true;
            }
            return instapdetailsANVm.customerAge;
        }

        instapdetailsANVm.populateResumeNames = function() {
            if (!utilityService.isUndefined(instaService.customerAadhaarCardDetails.firstName)) {
                instapdetailsANVm.firstName = instaService.customerAadhaarCardDetails.firstName;
            }
            if (!utilityService.isUndefined(instaService.customerAadhaarCardDetails.middleName)) {
                instapdetailsANVm.isMName = true;
                instapdetailsANVm.middleName = instaService.customerAadhaarCardDetails.middleName;
            }
            if (!utilityService.isUndefined(instaService.customerAadhaarCardDetails.lastName)) {
                instapdetailsANVm.isLName = true;
                instapdetailsANVm.lastName = instaService.customerAadhaarCardDetails.lastName;
            }
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            instapdetailsANVm.personalDetails = {};
            instapdetailsANVm.personalDetails.uid = instaService.customerAadhaarCardDetails.uid;
            instapdetailsANVm.personalDetails.name = instaService.customerAadhaarCardDetails.name;
            instapdetailsANVm.personalDetails.yob = instaService.customerAadhaarCardDetails.yob;
            instapdetailsANVm.personalDetails.gender = instapdetailsANVm.displayGender(instaService.customerAadhaarCardDetails.gender);
            instapdetailsANVm.selectTitles = [];
            instapdetailsANVm.loadTitles();
            instapdetailsANVm.isLName = false;
            instapdetailsANVm.isMName = false;
            if (instaService.isResumeJourney == false || instaService.customerAadhaarCardDetails.aadharNewEntry == true) {
                //if(utilityService.isUndefined(instaService.customerAadhaarCardDetails.firstName)){
                    instapdetailsANVm.displayNames(instaService.customerAadhaarCardDetails.name);
                    instapdetailsANVm.disableNextIfEmpty();
                //}                
            }
             else {
                instapdetailsANVm.populateResumeNames();
            }

            instapdetailsANVm.populateDobAadhaar();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);

        });

        return this;
    }
]);
