'use strict';

angularApp.controller('instapersonalDetailsAddressController', ["$state",
    "$scope",
    "instaService",
    "utilityService",
    "instapersonalDetailsService",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "$translate",
    "instanomineeDetailsRelatedService",
    function ($state,
        $scope,
        instaService,
        utilityService,
        instapersonalDetailsService,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService,
        $translate,
        instanomineeDetailsRelatedService) {

        var instapdetailsAddressVm = this;
        var isAddressEmpty = false;

        function initPage() {
            instapdetailsAddressVm.showBack = true;
            instapdetailsAddressVm.showNext = true;
            if (instaService.isResumeJourney == false)
                instapdetailsAddressVm.isChecked = false;
            instapdetailsAddressVm.aofooter = true;
            instapdetailsAddressVm.distList = [];
                    
            instapdetailsAddressVm.disableDist = true;
            instapdetailsAddressVm.disableSubdist = true;
            instapdetailsAddressVm.disableVillage = true;
            
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                instapdetailsAddressVm.okBtntext = translatedvalue;
            });
        }

        instapdetailsAddressVm.goBacktoPrevious = function () {
            $state.go("menu.instaKit_pdetailsAN");
        }

        instapdetailsAddressVm.goToNextPage = function () {
            if (instapdetailsAddressVm.isChecked) {
                instaService.correspondenceCheckStatus = true;
                instapdetailsAddressVm.updateAadharDetailsCall('menu.instaKit_pdetailsCAddress');
            } else {
                instaService.correspondenceCheckStatus = false;
                instaService.customerCorrespondenceAddress.address1 = "";
                instaService.customerCorrespondenceAddress.address2 = "";
                instaService.customerCorrespondenceAddress.pincode = "";
                instaService.customerCorrespondenceAddress.city = "";
                instaService.customerCorrespondenceAddress.state = "";
                instaService.customerCorrespondenceAddress.locality = "";
                instaService.customerCorrespondenceAddress.district = "";
                instapdetailsAddressVm.updateAadharDetailsCall('menu.instaKit_panDetails');
            }
        }

        instapdetailsAddressVm.setGender = function () {
            var genderDetails = {};
            if (instaService.customerAadhaarCardDetails.gender.toLowerCase() == "m" || instaService.customerAadhaarCardDetails.gender.toLowerCase() == constantConfig.acOp.maleGender) {
                genderDetails.genderValue = "Male";
                genderDetails.genderCode = "M";
            }
            else if (instaService.customerAadhaarCardDetails.gender.toLowerCase() == "f" || instaService.customerAadhaarCardDetails.gender.toLowerCase() == constantConfig.acOp.femaleGender) {
                genderDetails.genderValue = "Female";
                genderDetails.genderCode = "F";
            }
            else if (instaService.customerAadhaarCardDetails.gender.toLowerCase() == constantConfig.acOp.transGender) {
                genderDetails.genderValue = "Transgender";
                genderDetails.genderCode = "T";
            }
            return genderDetails;
        }

        instapdetailsAddressVm.updateAadharDetailsCall = function (navigationPage) {
            var genderDetails = instapdetailsAddressVm.setGender();
            var addressOneLength = instaService.customerAadhaarCardDetails.house.length;
            var addressTwoLength = instaService.customerAadhaarCardDetails.street.length;
            /* If customer address length is greater than 40 */
            if (addressOneLength > 40 || addressTwoLength > 40) {
                var title = '';
                var template = '{{"MAX_CHAR_AADHAAR" | translate}}';
                var onTap = '';
                var buttontext = '<b>' + instapdetailsAddressVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            } else {
                var requestParams = {
                    "id": instaService.customer.mobileNo,
                    "data": {
                        "personalDetails": {
                           
                            "title": instaService.customerAadhaarCardDetails.title,
                            "titleCode": instaService.customerAadhaarCardDetails.titleCode,
                            "gender": genderDetails.genderValue,
                           
                            "dob": instaService.customerAadhaarCardDetails.dob,
                            "scannedCorrespondenceAddFlag": instaService.correspondenceCheckStatus,
                            "isAadhaarScanned": true,
                            "nationality": instaService.customerAdditionalDetails.nationality,
                            "nationalityCode": instaService.customerAdditionalDetails.nationalityID,
                            "citizenship": instaService.customerAdditionalDetails.citizenship,
                            "citizenshipCode": instaService.customerAdditionalDetails.citizenshipID,

                            "address": [{
                                "type": "PERMANENT",
                               
                                "district": instaService.customerAadhaarCardDetails.district,
                                "districtCode": instaService.customerAadhaarCardDetails.distCode,
                                "subDist": instaService.customerAadhaarCardDetails.subdist,
                                "subDistrictCode": instaService.customerAadhaarCardDetails.subdistCode,
                                "village": instaService.customerAadhaarCardDetails.village,
                                "villageCode": instaService.customerAadhaarCardDetails.villageCode
                            }]
                        },
                        "additionalDetails": {
                            "countryOfBirth": instaService.customerAdditionalDetails.countryOfBirth
                        },
                        "commonId": $state.$current.data.commonId
                    }
                }
                instapersonalDetailsService.updateAadhaarDetails(requestParams).then(function (response) {
                    $state.go(navigationPage);
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }

        }

        $scope.goToHome = function () {
            instaService.homeNav();
        }

        instapdetailsAddressVm.updateAadhaarLink = function () {
            $state.go('menu.instaKit_updateAadhaar');
        }

        instapdetailsAddressVm.checkFormValid = function (isValid) {
            if (isValid) {
                instapdetailsAddressVm.disableNext = false;
            }
            else {
                instapdetailsAddressVm.disableNext = true;
            }
        }

      

        instapdetailsAddressVm.concatAadharAddress = function () {
            var fullAddr = "";
            fullAddr = instaService.nullCheck(instaService.customerAadhaarCardDetails.house) + instaService.nullCheck(instaService.customerAadhaarCardDetails.street) + instaService.nullCheck(instaService.customerAadhaarCardDetails.loc);
            
            var index = fullAddr.lastIndexOf(",");
            fullAddr = fullAddr.substring(0, index) + fullAddr.substring(index + 1);
            return fullAddr;
        }

        instapdetailsAddressVm.checkForDistrict = function () {
            if (!utilityService.isUndefined(instaService.customerAadhaarCardDetails.stateCode)) {
                instapdetailsAddressVm.distList = [];
                var inputparams = {
                    "stateCode": instaService.customerAadhaarCardDetails.stateCode
                }
                instapersonalDetailsService.fetchDistrict(inputparams).then(function (data) {
                    for (var i = 0; i < data.length; i++) {
                        instapdetailsAddressVm.distList.push(data[i]);
                        instapdetailsAddressVm.distList.sort();
                    }
                    instapdetailsAddressVm.disableDist = false;
                    instapdetailsAddressVm.checkFormValid(instapdetailsAddressVm.addressDetailsForm.$valid);
                    instapdetailsAddressVm.checkForSubDistrict(instaService.customerAadhaarCardDetails.districtCode);
                },
                    function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
            }
        }


        //Load subdistricts based on district code
        instapdetailsAddressVm.checkForSubDistrict = function (value) {
            if (utilityService.isUndefined(value)) {
                instapdetailsAddressVm.subdistList = [];
                var subDistCode = instaService.customerAadhaarCardDetails.districtCode ? instaService.customerAadhaarCardDetails.districtCode : instaService.customerAadhaarCardDetails.distCode;
                var inputparams = {
                    "distCode": instaService.customerAadhaarCardDetails.stateCode + subDistCode
                }
                instapersonalDetailsService.fetchSubDistrict(inputparams).then(function (data) {
                    for (var i = 0; i < data.length; i++) {
                        instapdetailsAddressVm.subdistList.push(data[i]);
                        instapdetailsAddressVm.subdistList.sort();
                    }
                    instapdetailsAddressVm.disableSubdist = false;
                    instapdetailsAddressVm.district = instaService.customerAadhaarCardDetails.distCode;
                    instapdetailsAddressVm.checkFormValid(instapdetailsAddressVm.addressDetailsForm.$valid);
                    if (!utilityService.isUndefined(instapdetailsAddressVm.subdistrict)) {
                        instapdetailsAddressVm.checkForVillage(instapdetailsAddressVm.subdistrict);
                    }
                },
                    function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
            }
            else if (!utilityService.isUndefined(value)) {
                instapdetailsAddressVm.subdistList = [];
                var districtCode = instaService.customerAadhaarCardDetails.districtCode ? instaService.customerAadhaarCardDetails.districtCode : instaService.customerAadhaarCardDetails.distCode;
                var inputparams = {
                    "distCode": instaService.customerAadhaarCardDetails.stateCode + districtCode
                }
                instapersonalDetailsService.fetchSubDistrict(inputparams).then(function (data) {
                    for (var i = 0; i < data.length; i++) {
                        instapdetailsAddressVm.subdistList.push(data[i]);
                        instapdetailsAddressVm.subdistList.sort();
                    }
                    instapdetailsAddressVm.disableSubdist = false;
                    instaService.customerAadhaarCardDetails.distCode = value;
                    instapdetailsAddressVm.checkFormValid(instapdetailsAddressVm.addressDetailsForm.$valid);
                    if (!utilityService.isUndefined(instapdetailsAddressVm.subdistrict)) {
                        instapdetailsAddressVm.checkForVillage(instapdetailsAddressVm.subdistrict);
                    }
                },
                    function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
            }
            instapdetailsAddressVm.updateDistName(value);
        }

        //Load subdistricts based on district code
        instapdetailsAddressVm.checkForVillage = function (value) {
            if (utilityService.isUndefined(value)) {
                instapdetailsAddressVm.villagesList = [];
                var districtCode = instaService.customerAadhaarCardDetails.districtCode ? instaService.customerAadhaarCardDetails.districtCode : instaService.customerAadhaarCardDetails.distCode;
                var inputparams = {
                    "subDistCode": instaService.customerAadhaarCardDetails.stateCode + districtCode + instaService.customerAadhaarCardDetails.subdistCode

                }
                instapersonalDetailsService.fetchVillage(inputparams).then(function (data) {
                    for (var i = 0; i < data.length; i++) {
                        instapdetailsAddressVm.villagesList.push(data[i]);
                        instapdetailsAddressVm.villagesList.sort();
                    }
                    instapdetailsAddressVm.disableVillage = false;
                    instapdetailsAddressVm.subdistrict = instaService.customerAadhaarCardDetails.subdistCode;
                    instapdetailsAddressVm.checkFormValid(instapdetailsAddressVm.addressDetailsForm.$valid);
                },
                    function (error) {
                        console.log("error");
                    });
            }
            else if (!utilityService.isUndefined(value)) {
                instapdetailsAddressVm.villagesList = [];
                var districtCode = instaService.customerAadhaarCardDetails.districtCode ? instaService.customerAadhaarCardDetails.districtCode : instaService.customerAadhaarCardDetails.distCode;
                var inputparams = {
                    "subDistCode": instaService.customerAadhaarCardDetails.stateCode + districtCode + value
                }
                instapersonalDetailsService.fetchVillage(inputparams).then(function (data) {
                    for (var i = 0; i < data.length; i++) {
                        instapdetailsAddressVm.villagesList.push(data[i]);
                        instapdetailsAddressVm.villagesList.sort();
                    }
                    instapdetailsAddressVm.disableVillage = false;
                    instaService.customerAadhaarCardDetails.subdistCode = value;
                    instapdetailsAddressVm.checkFormValid(instapdetailsAddressVm.addressDetailsForm.$valid);
                },
                    function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
            }
            instapdetailsAddressVm.updateSubdistName(value);
        }

        //Update Village details in common 
        instapdetailsAddressVm.updateVillageDetails = function (value) {
            if (utilityService.isUndefined(value)) {
                instapdetailsAddressVm.village = instaService.customerAadhaarCardDetails.villageCode;
            }
            else if (!utilityService.isUndefined(value)) {
                instaService.customerAadhaarCardDetails.villageCode = value;
            }
            instapdetailsAddressVm.updateVillageName(value);
        }

        instapdetailsAddressVm.updateDistName = function (value) {
            for (var i = 0; i < instapdetailsAddressVm.distList.length; i++) {
                if (instapdetailsAddressVm.distList[i].distCode == value) {
                    instaService.customerAadhaarCardDetails.district = instapdetailsAddressVm.distList[i].description;

                }
            }
        }

        instapdetailsAddressVm.updateSubdistName = function (value) {
            for (var i = 0; i < instapdetailsAddressVm.subdistList.length; i++) {
                if (instapdetailsAddressVm.subdistList[i].subDistCode == value) {
                    instaService.customerAadhaarCardDetails.subdist = instapdetailsAddressVm.subdistList[i].description;

                }
            }
        }

        instapdetailsAddressVm.updateVillageName = function (value) {
            for (var i = 0; i < instapdetailsAddressVm.villagesList.length; i++) {
                if (instapdetailsAddressVm.villagesList[i].villageCode == value) {
                    instaService.customerAadhaarCardDetails.village = instapdetailsAddressVm.villagesList[i].description;
                }
            }
        }

        instapdetailsAddressVm.stateListChange = function (data) {
            var arr = instapdetailsAddressVm.selectStateList;
            if (data) {
                var arrLength = arr.length;
                for (var i = 0; i < arrLength; i++) {
                    if (arr[i].stateCode == data) {
                        var tempData = arr[i];
                        instapdetailsAddressVm.villagesList = [];
                        instapdetailsAddressVm.subdistList = []
                        instaService.customerAadhaarCardDetails.stateCode = tempData.stateCode;
                        instapdetailsAddressVm.checkForDistrict();
                        instaService.customerAadhaarCardDetails.districtCode = tempData.districtCode;
                        instapdetailsAddressVm.personalDetails.district = tempData.districtName;
                        instaService.customerAadhaarCardDetails.districtCode = tempData.districtCode;
                        instaService.customerAadhaarCardDetails.district = tempData.districtName;
                        instapdetailsAddressVm.subdistrict = "";
                        instapdetailsAddressVm.checkForSubDistrict(tempData.districtCode);
                    }
                };
            } else {
                instapdetailsAddressVm.villagesList = [];
                instapdetailsAddressVm.subdistList = [];
                instapdetailsAddressVm.personalDetails.district = "";
                instaService.customerAadhaarCardDetails.distCode = "";
                instapdetailsAddressVm.personalDetails.subdistCode = "";
                instaService.customerAadhaarCardDetails.subdistrict = "";
                instapdetailsAddressVm.disableNext = true;
                instaService.customerAadhaarCardDetails.stateCode = "";
            }
        };


        instapdetailsAddressVm.populateResumeData = function () {
           
            instapdetailsAddressVm.selectdState = instaService.customerAadhaarCardDetails.stateCode;
            instapdetailsAddressVm.district = instaService.customerAadhaarCardDetails.distCode;
            instapdetailsAddressVm.subdistrict = instaService.customerAadhaarCardDetails.subdistCode;
            instapdetailsAddressVm.village = instaService.customerAadhaarCardDetails.villageCode;
                            
                        
                        
        }

        instapdetailsAddressVm.loadState = function () {
            var inputparams = {
                "pinCode": instaService.customerAadhaarCardDetails.pc
            }
            if (!instapdetailsAddressVm.selectStateList || instaService.pincodeReset) {
                instanomineeDetailsRelatedService.getAreaDetailForPincode(inputparams).then(function (data) {
                    if (!utilityService.isUndefined(data)) {
                        instapdetailsAddressVm.selectStateList = data;
                        instaService.pincodeReset = false;

                        instapdetailsAddressVm.checkForDistrict();
                    }
                    instapdetailsAddressVm.checkFormValid(instapdetailsAddressVm.addressDetailsForm.$valid);
                }, function (error) {
                });
            }
        };


        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            instapdetailsAddressVm.journeyType = instaService.journeyType;
            instapdetailsAddressVm.constantJourneyTypeVKYC = constantConfig.acOpeningAdapterOVDConstant.vkycInsta;
            instapdetailsAddressVm.showAadhaarCheckbox = true;
            
            instapdetailsAddressVm.personalDetails = {
                address: instapdetailsAddressVm.concatAadharAddress(),
                pincode: instaService.customerAadhaarCardDetails.pc,
                city: instaService.customerAadhaarCardDetails.dist,
                state: instaService.customerAadhaarCardDetails.state,
                districtCode: instaService.customerAadhaarCardDetails.districtCode,
                district: instaService.customerAadhaarCardDetails.district
            };
              
                      
            instapdetailsAddressVm.isChecked = instaService.correspondenceCheckStatus;
            if (instaService.isResumeJourney == true ) {
                instapdetailsAddressVm.selectdState = instaService.customerAadhaarCardDetails.stateCode;
                instapdetailsAddressVm.district = instaService.customerAadhaarCardDetails.distCode;
                instapdetailsAddressVm.subdistrict = instaService.customerAadhaarCardDetails.subdistCode;
                instapdetailsAddressVm.village = instaService.customerAadhaarCardDetails.villageCode;
            }
            instapdetailsAddressVm.populateResumeData();
            instapdetailsAddressVm.loadState();

             

            if (!utilityService.isUndefined(instapdetailsAddressVm.village)) {
                instapdetailsAddressVm.updateVillageDetails(instapdetailsAddressVm.village);
            }

            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);


        });

        return this;
    }
]);
