'use strict';

angularApp.controller('instapersonalDetailsController', ["$state",
    "$scope",
    "$ionicPopover",
    "utilityService",
    "instaService",
    "$translate",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "instaaDCityCountryService",
    "bhimUpiService",
    "constantConfig",
    function($state,
        $scope,
        $ionicPopover,
        utilityService,
        instaService,
        $translate,
        $ionicSideMenuDelegate,
        mPinLoginService,
        instaaDCityCountryService,
        bhimUpiService,
        constantConfig) {

        var instapersonalDetailsVm = this;
        var alphabets = /^([ \.]?[a-zA-Z]+)+$/;
        var numbers = /^[0-9]*$/;
        var addressRegex = /^[A-z().,-/0-9 #']*$/;

        function initPage() {
            instapersonalDetailsVm.showBack = true;
            instapersonalDetailsVm.showNext = false;
            instapersonalDetailsVm.aofooter = true;
            instapersonalDetailsVm.showAadhaarDetails = false;
            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                instapersonalDetailsVm.okBtntext = translatedvalue;
            });
        }

        instapersonalDetailsVm.updateAadhaarLink = function() {
            $state.go('menu.instaKit_updateAadhaar');
        }

        instapersonalDetailsVm.goToScanAADHAR = function(isVID) {
            instaService.isAadharManualEntry = false;
            instaService.isVID = isVID;
                bhimUpiService.getNativeData("scanqrcode", {}).then(function (data) {

                    if (device.platform.toLowerCase() == 'android') {
                        var barcodeData = data.scanResult;
                        }else{
                        var barcodeData = data;
                        }

                    var xmlText = barcodeData;
                    var formattedXml = xmlText.replace("/?xml", "?xml");
                    formattedXml = formattedXml.replace("xml?", "?xml");
                    var x2js = new X2JS();
                    var jsonObj = x2js.xml_str2json(formattedXml);
                    if (utilityService.isUndefined(jsonObj)) {
                        var title = '';
                        var template = "{{'AADHAAR_POPUP'| translate}}";
                        var onTap = '';
                        var buttontext = "<b>" + instapersonalDetailsVm.okBtntext + "</b>";
                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                    } else {
                        instaService.isResumeJourney = false;
                        var jsonStr = JSON.stringify(jsonObj);

                        instaService.customerAadhaarCardDetails = {
                            uid: "",
                            isAadharScanned: false
                        }
                        
                        var securedScannedData = {
                            _uid: instaService.checkHtmlTags(jsonObj.PrintLetterBarcodeData._uid)
                        }
                       
                        if (instaService.nomineeAadhaarCardDetails.uid === instaService.checkSecuredData(numbers, securedScannedData._uid)) {
                            var title = '';
                            var template = "{{'AADHAAR_BOTH_SAME'| translate}}";
                            var onTap = '';
                            var buttontext = "<b>" + instapersonalDetailsVm.okBtntext + "</b>";
                            utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                        } else {
                            setTimeout(function() {
                                instaService.customerAadhaarCardDetails.uid = instaService.checkSecuredData(numbers, securedScannedData._uid);
                                instapersonalDetailsVm.isScanned = true;
                                $state.go('menu.instaKit_aadhaarValidation');
                            }, 500);
                        }
                    }

            }, function(error) {
                var title = '';
                var template = "{{'ACCESS_APP'| translate}}";
                var onTap = '';
                var buttontext = "<b>" + instapersonalDetailsVm.okBtntext + "</b>";
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            });
        }

        instapersonalDetailsVm.goToEnterAadhaar = function(isVID) {
            instaService.isAadharManualEntry = true;
            
            instaService.customerAadhaarCardDetails = {
                uid: "",
                isAadharScanned: false
            }
			instaService.isVID = isVID; 
            $state.go('menu.instaKit_aadhaarValidation');
        }

        instapersonalDetailsVm.goBacktoPrevious = function() {
            $state.go('menu.instaKit_panAuthorise');
        }

        instapersonalDetailsVm.showAadhaarInfo = function(){
            instapersonalDetailsVm.showAadhaarDetails = instapersonalDetailsVm.showAadhaarDetails ? false : true;
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        /* Info Popup */
     
	instapersonalDetailsVm.infoPopup = function($event, isVID) {
		var template;

		if (isVID) {

			if (!instapersonalDetailsVm.vidContent) {
				instaaDCityCountryService.getInfoList().then(function(body) {
					instapersonalDetailsVm.vidContent = body.infoList.vidContent;
					template = '<ion-popover-view class="tooltiptext ao-popupInfo roboto-regular ao-aadhaarInfoHt">' + '<ion-content>' + '<div class="" >' + body.infoList.vidContent + '</div>' + '</ion-content>' + '</ion-popover-view>';
					$scope.popover = $ionicPopover.fromTemplate(template, {
						scope : $scope
					});
					$scope.popover.show($event);
				}, function(error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			} else {
				template = '<ion-popover-view class="tooltiptext ao-popupInfo roboto-regular ao-aadhaarInfoHt">' + '<ion-content>' + '<div class="" >' + instapersonalDetailsVm.vidContent + '</div>' + '</ion-content>' + '</ion-popover-view>';
				$scope.popover = $ionicPopover.fromTemplate(template, {
					scope : $scope
				});
				$scope.popover.show($event);
			}
			
		} else {
			template = '<ion-popover-view class="tooltiptext ao-popupInfo roboto-regular ao-aadhaarInfoHt">' + '<ion-content>' + '<div class="" translate="MANUAL_INPUT_AADHAAR"></div>' + '</ion-content>' + '</ion-popover-view>';
			$scope.popover = $ionicPopover.fromTemplate(template, {
				scope : $scope
			});
			$scope.popover.show($event);	
		}

		
	}; 


       instapersonalDetailsVm.closePopover = function() {
            $scope.popover.hide();
       };
       /* Info Popup */

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {

            instapersonalDetailsVm.journeyType = instaService.journeyType;
            instapersonalDetailsVm.constantJourneyTypeVKYC = constantConfig.acOpeningAdapterOVDConstant.vkycInsta;

            if(instaService.journeyType == constantConfig.acOpeningAdapterOVDConstant.salaryAcc){
                instapersonalDetailsVm.showAadhaarForSalary = false;
            }else {
                if(instapersonalDetailsVm.journeyType != instapersonalDetailsVm.constantJourneyTypeVKYC){
                    instapersonalDetailsVm.showAadhaarForSalary = false;
                }else{
                    instapersonalDetailsVm.showAadhaarForSalary = true;
                }
            }
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
