'use strict';

angularApp.controller('instaproductOfferingController', ["$state",
    "$scope",
    "instaproductOfferingService",
    "instaService",
    "utilityService",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        instaproductOfferingService,
        instaService,
        utilityService,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instaproductOfferingVm = this;

        function initPage() {
            instaproductOfferingVm.showBack = true;
            instaproductOfferingVm.showNext = true;
            instaproductOfferingVm.aofooter = true;
          //  if(instaService.isResumeJourney == false)
           // instaproductOfferingVm.isChecked = true;
            instaproductOfferingVm.loadOtherProductOffers();
        }

        instaproductOfferingVm.goBacktoPrevious = function(){
            $state.go('menu.instaKit_termsAndConditions');
        }
        
        instaproductOfferingVm.goToNextPage = function() {
            instaproductOfferingVm.postPODetails();
        }

        instaproductOfferingVm.loadOtherProductOffers = function(){
            instaproductOfferingService.getOtherProductOfferings().then(function(data) {
                instaproductOfferingVm.productOfferingContent = data;
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        instaproductOfferingVm.postPODetails = function(){
            instaService.productOfferingFlag = instaproductOfferingVm.isChecked;
            var requestParams = {
                "id" : instaService.customer.mobileNo,                
                "data":{
                    "commonId":$state.$current.data.commonId,
                    "productOfferingFlag" : instaproductOfferingVm.isChecked,
                    "idIssueAt" : "",       
                    "secondIDType" : "", 
                    "secondIDNumber" : "",       
                    "firstIDType" : '49',        
                    "firstIDNumber" : instaService.customerAadhaarCardDetails.uid,
                    "idIssueDate" : '00000000',      
                    "customerRisk" : '00',
                    "services" : {
                        "atmRequest" : 'N',
                        "requestForINB" : 'Y'
                    }
                }
            }
            instaproductOfferingService.postProdOffers(requestParams).then(function(response) {
                if(response.responseCode == constantConfig.successCode){
                    /*if(!utilityService.isUndefined(instaService.tncOtpValue)){
                        $state.go('menu.debitCardDetails');
                    }
                    else{*/
                        $state.go('menu.instaKit_enterOTP');
                    /*}*/
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        instaproductOfferingVm.populateResumeData = function(){
            //instaproductOfferingVm.isChecked = instaService.productOfferingFlag;
        }
        
        $scope.goToHome = function() {
            instaService.homeNav();
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            if(instaService.isResumeJourney == true){
                instaproductOfferingVm.populateResumeData();
            }
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
