'use strict';

angularApp.controller('instareceiveDebitCardController', ["$state",
    "$scope",
    "instareceiveDebitCardService",
    "instaService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        instareceiveDebitCardService,
        instaService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instareceiveDebitCardVm = this;

        function initPage() {
            instareceiveDebitCardVm.showBack = true;
            instareceiveDebitCardVm.showNext = true;
            instareceiveDebitCardVm.disableNext = true;
            instareceiveDebitCardVm.aofooter = true;
            instareceiveDebitCardVm.selectedMethod = "";
        }

        instareceiveDebitCardVm.goBacktoPrevious = function() {
            $state.go('menu.instaKit_debitCardDetails');
        }

        instareceiveDebitCardVm.goToNextPage = function() {
           instareceiveDebitCardVm.getReferenceNumber();
        }

        instareceiveDebitCardVm.receiveDebitCardDetails = function(){
             var requestParams = {
                "id" : instaService.customer.mobileNo,                
                "data":{
                    "cardReadyForCollection":instareceiveDebitCardVm.selectedMethod,
                    "debitCardFirstName" : instaService.debitCardDetails.firstName,
                    "debitCardLastName" : instaService.debitCardDetails.lastName,
                    "commonId":$state.$current.data.commonId
                }
            }
            instareceiveDebitCardService.receiveDebitCard(requestParams).then(function(response) {
                
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        instareceiveDebitCardVm.getReferenceNumber = function(){
            var requestParams = {
                "id" : instaService.customer.mobileNo,                
                "data":{
                    "commonId":$state.$current.data.commonId
                }
            }
            instareceiveDebitCardService.getReferenceNo(requestParams).then(function(response) {
                instareceiveDebitCardVm.receiveDebitCardDetails();
                instaService.customer.referenceCode = utilityService.getValue(response.data.referenceCode);
                $state.go('menu.instaKit_enterOTPReferenceCode');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        instareceiveDebitCardVm.atSBI = function() {
            instareceiveDebitCardVm.isSBIClicked = true;
            instareceiveDebitCardVm.disableNext = false;
            instareceiveDebitCardVm.selectedMethod = "Intouch";
        }

        instareceiveDebitCardVm.atCorrespondence = function() {
            instareceiveDebitCardVm.isSBIClicked = false;
            instareceiveDebitCardVm.disableNext = false;
            instareceiveDebitCardVm.selectedMethod = "correspondance";
        }

        instareceiveDebitCardVm.populateResumeData = function(){
            instareceiveDebitCardVm.selectedMethod = instaService.cardReadyForCollection;
            if(instareceiveDebitCardVm.selectedMethod == "Intouch"){
                instareceiveDebitCardVm.isSBIClicked = true;
            }
            else if(instareceiveDebitCardVm.selectedMethod == "correspondance"){
                instareceiveDebitCardVm.isSBIClicked = false;
            }
            instareceiveDebitCardVm.disableNext = false;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            if(instaService.isResumeJourney == true){
                instareceiveDebitCardVm.populateResumeData();
            }
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            
        });

        return this;
    }
]);
