'use strict';

angularApp.controller('instaregenerateAppPasswordController', ["$state",
    "$scope",
    "instaService",
    "utilityService",
    "instaregenerateAppPasswordService",
    "$ionicPopover",
    "$cordovaDevice",
    "cryptoService",
    "encryptionService",
    "constantConfig",
    "$translate",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        instaService,
        utilityService,
        instaregenerateAppPasswordService,
        $ionicPopover,
        $cordovaDevice,
        cryptoService,
        encryptionService,
        constantConfig,
        $translate,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instaregenerateAppPasswordVm = this;

        function initPage() {
            instaregenerateAppPasswordVm.showBack = false;
            instaregenerateAppPasswordVm.showNext = true;
            instaregenerateAppPasswordVm.reAppPasswordCheck = false;
            instaregenerateAppPasswordVm.disableNext = true;
            instaregenerateAppPasswordVm.aofooter = true;
            //To get the device Operating system
            var deviceOs = $cordovaDevice.getPlatform();
            var deviceUid = $cordovaDevice.getUUID();
            instaService.customer.deviceOS = deviceOs;
            instaService.customer.deviceUid = deviceUid;
            instaregenerateAppPasswordVm.encoded = '';
             $translate('AO_OK_LABEL').then(function(translatedvalue) {
                instaregenerateAppPasswordVm.okBtntext = translatedvalue;
            });
        }

        /* Info Popup */
        var template = '<ion-popover-view class="ao-tooltip ao-popupInfo roboto-regular ao-passwordHt">' + '<ion-content>' +
                        '<div class="" translate="APP_NOTIFICATION"></div>' + '</ion-content>' + '</ion-popover-view>';

        $scope.popover = $ionicPopover.fromTemplate(template, {
            scope: $scope
        });

        instaregenerateAppPasswordVm.infoPopup = function($event) {
            $scope.popover.show($event);
        };

        instaregenerateAppPasswordVm.closePopover = function() {
            $scope.popover.hide();
        };
       /* Info Popup */

        instaregenerateAppPasswordVm.goToNextPage = function() {
            //var hashedAppPassword = cryptoService.getSHA512EncryptedData(instaregenerateAppPasswordVm.appPasswordData);
            //instaregenerateAppPasswordVm.encoded = encryptionService.getAES256EncryptedData(instaregenerateAppPasswordVm.appPasswordData);
            instaregenerateAppPasswordVm.encoded = instaregenerateAppPasswordVm.appPasswordData;
            instaService.appPassword = instaregenerateAppPasswordVm.encoded;
            var requestParams = {
                "id": instaService.customer.mobileNo,
                "type":"AO_INSTA",
                "data": {                    
                    "auth" : {
                        "password" :instaregenerateAppPasswordVm.encoded
                    }
                }
            }
            instaregenerateAppPasswordService.registerCustomer(requestParams).then(function(response) {
                instaService.customer.lotusId = utilityService.getValue(response.data.lotusId);
                var responseCode = response.responseCode;
                if (responseCode === constantConfig.successCode) {
                    var title = '';
                    var template = 'Your password is changed successfully. Please login again.';
                    var onTap = 'menu.instaKit_applyNewOrResume';
                    var buttontext = '<b>' + instaregenerateAppPasswordVm.okBtntext + '</b>';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                }

            }, function(error) {
               utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        instaregenerateAppPasswordVm.changePassword = function() {
            if (instaregenerateAppPasswordVm.reAppPasswordData !== instaregenerateAppPasswordVm.appPasswordData) {
                instaregenerateAppPasswordVm.reAppPasswordData = "";
                instaregenerateAppPasswordVm.reAppPasswordCheck = true;
                instaregenerateAppPasswordVm.disableNext = true;
                return true;
            }
            instaregenerateAppPasswordVm.reAppPasswordCheck = false;
            return true;
        }


        instaregenerateAppPasswordVm.changeCPassword = function() {
            if (instaregenerateAppPasswordVm.reAppPasswordData !== instaregenerateAppPasswordVm.appPasswordData) {
                instaregenerateAppPasswordVm.reAppPasswordCheck = false;
            }
            return true;
        }

        instaregenerateAppPasswordVm.proceedSuccess = function(isValid) {
            isValid ? instaregenerateAppPasswordVm.disableNext = false : instaregenerateAppPasswordVm.disableNext = true;
            return instaregenerateAppPasswordVm.disableNext;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
