'use strict';

angularApp.controller('instaresumeJourneyController', ["$state",
    "$scope",
    "instaService",
    "utilityService",
    "instaresumeJourneyService",
    "encryptionService",
    "cryptoService",
    "$translate",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "loggedInUserService",
    "AdapterUtils",
    "constantConfig",
    "ConnectivityMonitorUtils",
    "instaenterOTPReferenceCodeService",
    "instapanDetailsService",
    function ($state,
        $scope,
        instaService,
        utilityService,
        instaresumeJourneyService,
        encryptionService,
        cryptoService,
        $translate,
        $ionicSideMenuDelegate,
        mPinLoginService,
        loggedInUserService,
        AdapterUtils,
        constantConfig,
        ConnectivityMonitorUtils,
        instaenterOTPReferenceCodeService,
        instapanDetailsService) {

        var instaresumeJourneyVm = this;

        instaresumeJourneyVm.isChallenged = false;
        instaresumeJourneyVm.securityCheckName = "AOSecurityCheck";
        instaresumeJourneyVm.aoAuthChallengeHandler = WL.Client.createSecurityCheckChallengeHandler(instaresumeJourneyVm.securityCheckName);
        instaresumeJourneyVm.aoAuthChallengeHandler.securityCheckName = instaresumeJourneyVm.securityCheckName;

        function initPage() {
            instaresumeJourneyVm.showBack = true;
            instaresumeJourneyVm.showNext = false;
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                instaresumeJourneyVm.okBtntext = translatedvalue;
            });
        }

        instaresumeJourneyVm.goBacktoPrevious = function () {
            $state.go('menu.instaKit_applyNewOrResume');
        }

        $scope.goToHome = function () {
            instaService.homeNav();
        }

        instaresumeJourneyVm.resumeJourneyCall = function () {
            if (ConnectivityMonitorUtils.isOffline()) {
                utilityService.showErrorMessage("Unable to connect to Internet. Please check your connectivity.");
                return true;
            }
            instaresumeJourneyVm.loginWithResume();
        }

        instaresumeJourneyVm.forgotPassword = function () {
            $state.go("menu.instaKit_passwordRecovery");
        }

        instaresumeJourneyVm.getPageDetails = function (proFlag) {
            var requestParams = instaresumeJourneyVm.resumeMobile;
            instaresumeJourneyService.getPageDetails(instaresumeJourneyVm.resumeMobile).then(function (response) {
                var splitUrls = [];
                var splittedUrl1, splittedUrl2;
                if (response.payLoad.commonId == "insta_additionalDetails") {

                    $state.go('menu.instaKit_nominationRelated');

                } else if (response.payLoad.commonId == "insta_fatca") {
                    if (instaService.fatcaFlag == false) {
                        $state.go("menu.instaKit_locateBranch");
                    }
                    else {
                        $state.go(response.payLoad.mobileURL);
                    }
                } else if (response.payLoad.commonId == "insta_customerAddress") {
                    splitUrls = response.payLoad.mobileURL.split("/");
                    splittedUrl1 = splitUrls[0];
                    splittedUrl2 = splitUrls[1];
                    if (instaService.correspondenceCheckStatus == true) {
                        $state.go(splittedUrl1);
                    } else {
                        $state.go(splittedUrl2);
                    }

                } else if (response.payLoad.commonId == "insta_nomineeDetails") {
                    splitUrls = response.payLoad.mobileURL.split("/");
                    splittedUrl1 = splitUrls[0];
                    splittedUrl2 = splitUrls[1];
                    if (parseInt(instaService.nomineeAadhaarCardDetails.age) < 18 || parseInt(instaService.nominee.age) < 18) {
                        if (instaService.nominee.guardianAddressFlag == "nomineeAddress") {
                            $state.go("menu.instaKit_nomineeEnteredAddress");
                        }
                        else if (instaService.nominee.guardianAddressFlag == "applicantAddress") {
                            $state.go("menu.instaKit_nomineeAddress");
                        }
                        else if (instaService.nominee.guardianAddressFlag == "newAddress") {
                            $state.go("menu.instaKit_nomineeCAddress");
                        }
                        else {
                            $state.go(splittedUrl1);
                        }
                    } else {
                        // $state.go("menu.instaKit_selectBranchListLocality");
                        $state.go("menu.instaKit_selectBListLocalityByPincode");
                    }
                }
                else if (response.payLoad.commonId == "insta_panNumber") {
                    if (instaService.cifNumber == '0000') {
                        $state.go(response.payLoad.mobileURL);
                    }
                    else if (instaService.cifNumber == "0001") {
                        $state.go("menu.instaKit_multipleCustomer");
                    }
                    else {
                        $state.go("menu.instaKit_multipleCustomer");
                    }

                }


                else if (response.payLoad.commonId == "insta_homeBranch") {
                    $state.go("menu.instaKit_reviewSelectedBranch");
                }
                else if (response.payLoad.commonId == "insta_guardian") {
                    // $state.go("menu.instaKit_selectBranchListLocality");
                    $state.go("menu.instaKit_selectBListLocalityByPincode");

                }

                else if (response.payLoad.commonId == "insta_tcOtp") {
                    if(instaresumeJourneyVm.journeyType != instaresumeJourneyVm.constantJourneyTypeVKYC){
                         $state.go("menu.salaryUploadDoc");
                    }else{
                        $state.go('menu.instaKit_debitCardDetails');
                    }
                    
                }

                else if (response.payLoad.commonId == "insta_debitCardDetails") {
                    if (instaresumeJourneyVm.ststusData.toLowerCase() == "nightmode") {
                        instaenterOTPReferenceCodeService.setNightmodeFlag(true);
                        $state.go('menu.instaKit_enterOTPReferenceCode');
                    } else if (instaresumeJourneyVm.ststusData.toLowerCase() == "success" || instaresumeJourneyVm.ststusData.toLowerCase() == "approved" || instaresumeJourneyVm.ststusData.toLowerCase() == "open" || instaresumeJourneyVm.ststusData.toUpperCase() == "VKYCCOMPLETED") {
                        instaenterOTPReferenceCodeService.setNightmodeFlag(false);
                        $state.go('menu.instaKit_enterOTPReferenceCode');
                    }
                    else if ((instaresumeJourneyVm.ststusData.toLowerCase() == "failed") && (instaresumeJourneyVm.journeyType == instaresumeJourneyVm.constantJourneyTypeVKYC || instaresumeJourneyVm.journeyType == instaresumeJourneyVm.constantJourneyTypeSalary)) {
                        $state.go("menu.instaKit_enterOTPReferenceCode");
                    }else if ((instaresumeJourneyVm.ststusData.toLowerCase() == "failed") && (instaresumeJourneyVm.journeyType != instaresumeJourneyVm.constantJourneyTypeVKYC && instaresumeJourneyVm.journeyType != instaresumeJourneyVm.constantJourneyTypeSalary)) {
                        $state.go('menu.instaKit_debitCardDetails');
                    } 
                }

                // else if ((instaresumeJourneyVm.ststusData.toLowerCase() == "failed") && (instaresumeJourneyVm.journeyType != instaresumeJourneyVm.constantJourneyTypeVKYC)) {
                //     $state.go("menu.salaryUploadDoc");
                //  else if ((instaresumeJourneyVm.ststusData.toLowerCase() == "failed") && (instaresumeJourneyVm.journeyType == instaresumeJourneyVm.constantJourneyTypeVKYC)) {
                //     $state.go('menu.instaKit_debitCardDetails');
                // } 
                else {
                    $state.go(response.payLoad.mobileURL);
                }
                instaresumeJourneyVm.getCommonId(response.payLoad.commonId, proFlag);

            }, function (error) {
                var title = '';
                var template = error.responseMessage;
                var onTap = '';
                var buttontext = '<b>' + instaresumeJourneyVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            });
        }



        instaresumeJourneyVm.getCommonId = function (commonId) {
            instaService.getCommonId(commonId);
        }

        instaresumeJourneyVm.getCustomerDetails = function () {
            var pwdHashed = cryptoService.getSHA512EncryptedData(instaresumeJourneyVm.resumePassword);
            instaresumeJourneyVm.encoded = pwdHashed.toString();
            var requestParams = {
                "id": instaresumeJourneyVm.resumeMobile,
                "password": instaresumeJourneyVm.encoded,
                "journeyType": instaresumeJourneyVm.journeyType
            }

            instaresumeJourneyService.getCustomerDetails(requestParams).then(function (response) {
                var customerDetails = response.data;
                instaService.getResumeDocument(response.data);
                instaresumeJourneyVm.getPageDetails(response.data.productOfferingFlag);
                instaresumeJourneyVm.ststusData = response.data.status;
            }, function (error) {
                if (!utilityService.isUndefined(error.data)) {
                    if (error.data.type.toLowerCase() == "ao") {
                        var title = '';
                        var template = '{{"NOT_INSTA_ACC" | translate}}';
                        var onTap = 'menu.resumeJourney';
                        var buttontext = '<b>' + instaresumeJourneyVm.okBtntext + '</b>';
                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                    }
                } else if (error.responseCode == "0008") {

                    utilityService.showErrorMessage(error.responseMessage);
                }
                else {
                    var title = '';
                    var template = 'Details do not match.';
                    var onTap = '';
                    var buttontext = '<b>' + instaresumeJourneyVm.okBtntext + '</b>';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                }

            });
        }

        //Challenge Handler
        instaresumeJourneyVm.loginWithResume = function () {
            utilityService.showSpinner();
            instaresumeJourneyVm.aoAuthChallengeHandler.handleChallenge = function (challenge) {
                instaresumeJourneyVm.isChallenged = true;
                utilityService.hideSpinner();
                if (challenge.errorCode &&  challenge.errorCode == "3039") {
                    instapanDetailsService.showAlertPopup("error", challenge.errorMsg, "", "menu.newToSbiLanding", "OK", "", "", "");
                } else if (challenge.errorMsg !== null) {
                    utilityService.showErrorMessage(utilityService.getServerExceptionMessage(challenge));
                } else {
                    utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
                }
            };

            instaresumeJourneyVm.aoAuthChallengeHandler.handleSuccess = function (data) {
                instaresumeJourneyVm.isChallenged = false;
                utilityService.hideSpinner();
                if (data.user) {
                    loggedInUserService.keyId = AdapterUtils.secretData == "" ? data.user.attributes.keyId : encryptionService.getAES256DecryptedData(data.user.attributes.keyId);
                    loggedInUserService.tokenLotus = AdapterUtils.secretData == "" ? data.user.attributes.lotusToken : encryptionService.getAES256DecryptedData(data.user.attributes.lotusToken);
                }
            };

            instaresumeJourneyVm.aoAuthChallengeHandler.handleFailure = function (error) {
                instaresumeJourneyVm.aoAuthChallengeHandler.cancel();
                instaresumeJourneyVm.isChallenged = false;
                utilityService.hideSpinner();
                if (error.failure) {
                    utilityService.showErrorMessage(error.failure);
                } else {
                    utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
                }
            }

            var payload = {};

            var newKey = loggedInUserService.keyId;
            var passKey1Hashed = cryptoService.getSHA512EncryptedData(instaresumeJourneyVm.resumePassword);
            var passKeyHashed = cryptoService.getSHA512EncryptedData(passKey1Hashed + newKey);
            instaresumeJourneyVm.encoded = passKeyHashed.toString();
            var requestParams = {
                "mobileKey": instaresumeJourneyVm.resumeMobile,
                "passKey": instaresumeJourneyVm.encoded,
                "mfDeviceId": loggedInUserService.deviceIdForMpin,
                "deviceId": device.uuid
            }

            var passphraseSession;
            if (sessionStorage) {
                passphraseSession = sessionStorage.getItem('passphrase');
            }
            var passphrase = passphraseSession ? passphraseSession : encryptionService.passphrase;
            var src = cryptoService.encryptRSAWithPublicKey(encryptionService.iv + "^" + passphrase + "^" + encryptionService.salt, cryptoService.rsaPublicKey);
            payload = {
                "data": AdapterUtils.secretData + encryptionService.getAES256EncryptedData(JSON.stringify(requestParams)),
                "src": src
            }

            payload = AdapterUtils.secretData == "" ? requestParams : payload;

            if (instaresumeJourneyVm.isChallenged) {
                instaresumeJourneyVm.aoAuthChallengeHandler.submitChallengeAnswer(payload);
            } else {
                WLAuthorizationManager.login(instaresumeJourneyVm.aoAuthChallengeHandler.securityCheckName, payload).then(
                    function (data) {
                        utilityService.accessRestricted = utilityService.AOAuthRequired;
                        utilityService.hideSpinner();
                        instaresumeJourneyVm.getCustomerDetails();
                    },
                    function (error) {
                        utilityService.accessRestricted = "";
                        utilityService.hideSpinner();
                        if (error.errorCode == 'CHALLENGE_HANDLING_CANCELED' || error.errorCode == 'APPLICATION_DISABLED') {
                            return;
                        }
                        if (error.errorCode == "LOGIN_ALREADY_IN_PROCESS") {
                            instaresumeJourneyVm.aoAuthChallengeHandler.cancel();
                        }
                        utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
                    });
            }
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            instaresumeJourneyVm.journeyType = instaService.journeyType;
            instaresumeJourneyVm.constantJourneyTypeVKYC = constantConfig.acOpeningAdapterOVDConstant.vkycInsta;
            instaresumeJourneyVm.constantJourneyTypeSalary = constantConfig.acOpeningAdapterOVDConstant.salaryAcc;
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        $scope.$on('$ionicView.beforeLeave', function () {
            
        });

        return this;
    }
]);
