'use strict';

angularApp.controller('salaryUploadDocController', ["$state",
    "$scope",
    "instaService",
    "utilityService",
    "instapersonalDetailsService",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "$translate",
    "$ionicPopup",
    "instanomineeDetailsRelatedService",
    "salaryUploadService",
    "cameraService",
    "homeLoanService",
    "openUrlInAppbroswerService",
    "instaaccountOpeningLooksGreatService",
    "instadebitCardDetailsService",
    function ($state,
        $scope,
        instaService,
        utilityService,
        instapersonalDetailsService,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService,
        $translate,
        $ionicPopup,
        instanomineeDetailsRelatedService, 
        salaryUploadService, 
        instaaccountOpeningLooksGreatService, 
        cameraService,
        homeLoanService, 
        openUrlInAppbroswerService,
        instadebitCardDetailsService) {

        var salaryUploadDocVm = this;

        function initPage() {
            salaryUploadDocVm.showNext = true;
            salaryUploadDocVm.showBack = true;
        }

        salaryUploadDocVm.goBacktoPrevious = function () {
            
           
            $state.go("menu.instaKit_termsAndConditions");
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
           
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            salaryUploadDocVm.journeyType = instaService.journeyType;
            salaryUploadDocVm.constantJourneyTypeVKYC = constantConfig.acOpeningAdapterOVDConstant.vkycInsta;
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
             if(instaService.salaryDocId){
                salaryUploadDocVm.retrievePhoto();
            }
        });


        salaryUploadDocVm.retrievePhoto = function() {
            var param = instaService.salaryDocId;
            salaryUploadService.retrievePhoto(param).then(function(response) {
               if(response.data.mimeType == 'image/png'){
                   salaryUploadDocVm.profileImageUrl = "data:image/png;base64," + response.data.documentData;
                   if(salaryUploadDocVm.profileImageUrl){
                        salaryUploadDocVm.filename = "Image.png";
                        salaryUploadDocVm.contentType = "image/png";
                    }
               } else if(response.data.mimeType == 'image/jpg'){
                    salaryUploadDocVm.profileImageUrl = "data:image/jpeg;base64," + response.data.documentData;
                    if(salaryUploadDocVm.profileImageUrl){
                        salaryUploadDocVm.filename = "Image.jpg";
                        salaryUploadDocVm.contentType = "image/jpg";
                    }
               } 
                
                
                
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }


        //function for token generate 
        salaryUploadDocVm.generateVKYCToken = function () {
            var requestParams = {
                "mobileNumber": instaService.customer.mobileNo,
                "commonId": $state.$current.data.commonId
            }
            instadebitCardDetailsService.generateVKYCToken(requestParams).then(function (response) {

                if (!utilityService.isUndefined(response.data)) {
                    instaService.tokenNumber = response.data.refNo;
                        $state.go('menu.instaKit_enterOTPReferenceCode');
                    }
                
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }


        salaryUploadDocVm.goToNextPage = function () {
            if (salaryUploadDocVm.filename) {
               
               salaryUploadDocVm.generateVKYCToken();
            }
        }


        salaryUploadDocVm.uploadPicture = function () {

            if (!salaryUploadDocVm.filename) {
                var titlePopup = "Document";
                var subTitle = "Document size should be less than 500 KB and more than 2 KB."
                salaryUploadDocVm.picturePopup = $ionicPopup.show({
                    cssClass: 'uploadSalary-alert-popup',
                    title: titlePopup,
                    subTitle: subTitle,
                    template: '<div class="row">' +
                        '<p class="roboto-medium font-size-16" translate="">Document</p>' +
                        '</div>' +
                        '<div class="row">' +
                        '<p class="roboto-light mar-t-2 font-size-10" translate="">Only PNG, JPEG, PDF less than 500 KB and more than 2 KB</p>' +
                        '</div>' +
                        '<div class="row homeLoan textCenter margin-top-10 margin-bottom-5">' +
                        '<div class="col-50 flex-center">' +
                        '<div class="circle-outer"><img  alt="" src="img/AO/salary/addFile.svg" ng-click="salaryUploadDocVm.uploadFile()"></div>' +
                        '<p class="roboto-light font-size-12" translate="">Select File</p>' +
                        '</div>' +
                        '<div class="col-50 flex-center">' +
                        '<div class="circle-outer"><img  alt="" src="img/AO/salary/Camera.svg" ng-click="salaryUploadDocVm.clickselfie()"></div>' +
                        '<p class="roboto-light font-size-12" translate="">Open Camera</p>' +
                        '</div>' +
                        '</div>',
                    scope: $scope,
                    buttons: []
                });
            }

        }

        salaryUploadDocVm.commanAddFile = function (blob, data, typecheck, sizeOfImage) {
            var sizeInMB = sizeOfImage;
            var size = 0;
            var block = data.split(";");
            var contentType = block[0].split(":")[1];
            var typecheckFile = typecheck;
            salaryUploadDocVm.typeCheck = typecheckFile;
            if (sizeInMB < 666200) {
                size = (blob.size / 1024).toFixed(2);
                salaryUploadDocVm.profileImageUrl = data;

                salaryUploadDocVm.upDateProfile(salaryUploadDocVm.profileImageUrl, salaryUploadDocVm.filename, typecheckFile, contentType, size);
            } else {
                salaryUploadDocVm.setFilename = "";
                var msg = "Document size should be less than 500 KB and more than 2 KB."
                $ionicPopup.show({
                    title: '',
                    template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src="img/FT/BhimUpi/alertSymbol.svg" /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'
					+ msg + '</span></div></div></div>',
                    scope: $scope,
                    cssClass: 'my-custom-popup bhim-alert-popup ao-popupMain',
                    buttons: [{
                        text: 'OK',
                        type: 'button-assertive',
                        onTap: function () {

                        }
                    }],
                });
            }
        }

        salaryUploadDocVm.upDateProfile = function (imgProfile, filename, type, contentType, size) {
            var reqParams = {};
            reqParams["docType"] = type;
            reqParams["documentFormat"] = contentType;
            reqParams["docName"] = filename;
            reqParams["docSize"] = size;
            reqParams["base64"] = imgProfile.split(',')[1];
            reqParams["cifno"] = "";
            if (type == "png" || type == "jpg" || type == "jpeg" || type == "JPEG" || type == "JPG" || type == "PNG") {
                salaryUploadDocVm.filename = "Image." + type;
            } else if (type == "pdf") {
                salaryUploadDocVm.filename = "Document." + type;
            }
            console.log("reqParamsreqParams" + reqParams);
        }


      

        salaryUploadDocVm.uploadFile = function () {
            salaryUploadDocVm.picturePopup.close();
            if (utilityService.isAndroidPlatform()) {
                salaryUploadService.getFileForAndroid().then(function (response) {
                    
                    var data = response.data;
                   
                    console.log("data" + data);
                    var blob = new Blob([data], { type: 'image/jpeg' });
                    var typecheck = data.substring(data.indexOf('/') + 1, data.indexOf(';base64'));
                    var size = data.length;
                    salaryUploadDocVm.contentType = typecheck;
                    if (typecheck == "png" || typecheck == "jpg" || typecheck == "jpeg" || typecheck == "JPEG" || typecheck == "JPG" || typecheck == "PNG" || typecheck == "pdf") {
                        salaryUploadDocVm.commanAddFile(blob, data, typecheck, size);
                    } else {
                        var msgFormat = "Document should be in PNG, JPEG, PDF format."
                        $ionicPopup.show({
                            title: '',
                            template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src="img/FT/BhimUpi/alertSymbol.svg" /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'+ msgFormat + '</span></div></div></div>',
                            scope: $scope,
                            cssClass: 'my-custom-popup bhim-alert-popup ao-popupMain',
                            buttons: [{
                                text: 'OK',
                                type: 'button-assertive',
                                onTap: function () {
                                }
                            }],
                        });
                    }

                }, function (error) {

                });
            } else {
                salaryUploadService.getFileForiOS().then(function (response) {
                    var sizeInMB = response.size;
                    var data = response.imagedata;
                   
                    var blob = new Blob([data], { type: 'image/jpeg' });
                    var typecheck = data.substring(data.indexOf('/') + 1, data.indexOf(';base64'));
                    salaryUploadDocVm.contentType = typecheck;

                    if(sizeInMB >= 3077 && sizeInMB < 499680){
                        if (typecheck == "png" || typecheck == "jpg" || typecheck == "jpeg" || typecheck == "JPEG" || typecheck == "JPG" || typecheck == "PNG" || typecheck == "pdf") {
                            salaryUploadDocVm.commanAddFile(blob, data, typecheck, sizeInMB);
                        } else {
                            salaryUploadDocVm.clearPic();
                            var msgGetFile = "Document should be in PNG, JPEG, PDF format."
                            $ionicPopup.show({
                                title: '',
                                template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src="img/FT/BhimUpi/alertSymbol.svg" /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'+ msgGetFile + '</span></div></div></div>',
                                scope: $scope,
                                cssClass: 'my-custom-popup bhim-alert-popup',
                                buttons: [{
                                    text: 'OK',
                                    type: 'button-assertive',
                                    onTap: function () {
                                    }
                                }],
                            });
                        } 
                    }else{
                    
                         salaryUploadDocVm.setFilename = "";
                        var msg = "Document size should be less than 500 KB and more than 2 KB."
                        salaryUploadDocVm.checkIosFile = $ionicPopup.show({
                            title: '',
                            template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src="img/FT/BhimUpi/alertSymbol.svg" /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'
                            + msg + '</span></div></div></div>',
                            scope: $scope,
                            cssClass: 'my-custom-popup bhim-alert-popup ao-popupMain',
                            buttons: [{
                                text: 'OK',
                                type: 'button-assertive',
                                onTap: function () {
                                    salaryUploadDocVm.checkIosFile.close();
                                }
                            }],
                        });
                    }
             
                }, function (error) { });
            }
        }


        salaryUploadDocVm.clickselfie = function () { 
           
            salaryUploadDocVm.picturePopup.close();
            salaryUploadService.clickSelfie().then(function (data) {
                var selSize = data.length;
                

                salaryUploadDocVm.picturePopup.close();
               
                    if (selSize >= 3077 && selSize < 499680) {
                        salaryUploadDocVm.filename = "Selfie.png";
                        salaryUploadDocVm.profileImageUrl = data;
                        console.log('data' + JSON.stringify(data));
                        
                    }else {
                       
                        var msg1 = "Document size should be less than 500 KB and more than 2 KB."
                        salaryUploadDocVm.clickSelfiPop = $ionicPopup.show({
                        title: '',
                        template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src="img/FT/BhimUpi/alertSymbol.svg" /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'
                        + msg1 + '</span></div></div></div>',
                        scope: $scope,
                        cssClass: 'my-custom-popup bhim-alert-popup ao-popupMain',
                        buttons: [{
                            text: 'OK',
                            type: 'button-assertive',
                            onTap: function () {
                                salaryUploadDocVm.clickSelfiPop.close();
                            }
                        }],
                    });
                }
                
            }, function (error) {
                if (error != "error") {
                    var title = '';
                    var template = error;
                    var onTap = '';
                    var buttontext = '<strong>' + 'OK' + '</strong>';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                } else {
                    var title1 = '';
                    var template1 = '{{"SERVICE_ERR_MSG" | translate}}';
                    var onTap1 = '';
                    var buttontext1 = '<strong>' + 'OK' + '</strong>';
                    utilityService.showAlertModal(title1, template1, onTap1, $scope, $state, buttontext1);
                }
            });
        }

        salaryUploadDocVm.clearPic = function () {

            salaryUploadDocVm.filename = "";
            salaryUploadDocVm.profileImageUrl = "";
            salaryUploadDocVm.size = "";
            salaryUploadDocVm.contentType = "";
            salaryUploadDocVm.category = "";
        }

        salaryUploadDocVm.uploadPhotograph = function () {
            var contentType = "";
            var myBase64 = salaryUploadDocVm.profileImageUrl.split(',')[1];
            if(salaryUploadDocVm.contentType && salaryUploadDocVm.contentType.toLowerCase() == "pdf"){
                contentType = "application/pdf";
            } else{
                 contentType = "image/jpg";
            }
           

            var requestParams = {
                "eyeCheckStatus":"VKYC-CSP",
                "documentClass": "LT_AO_INSTA",
                "mimeType": contentType, // pdf or image/jpg
                "documentTitle": "Employment Proof", //anything
                "documentData": myBase64,
                "documentType":"Employment Proof",
                "documentID": instaService.customer.mobileNo,  //mobile number
                "channel": "Mobile",
                //"commonId": $state.$current.commonId,
                "accountNo": "string"
            }

            
           salaryUploadService.uploadPhotograph(requestParams).then(function (response) {
                instaService.salaryDocId = response.data.docRef;
                console.log("response >>" +JSON.stringify(response));
                salaryUploadDocVm.goToNextPage();
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        salaryUploadDocVm.showDocument = function () {
            if (salaryUploadDocVm.typeCheck == 'pdf') {
                var myBase64 = salaryUploadDocVm.profileImageUrl.split(',')[1];
                var contentType = "application/pdf";
                var folderpath = cordova.file.externalRootDirectory;
                var filename = salaryUploadDocVm.filename;
                savebase64AsPDF(folderpath, filename, myBase64, contentType);
            }
            else {
                salaryUploadDocVm.viewPopup = $ionicPopup.show({
                    scope: $scope,
                    cssClass: 'my-custom-popup bhim-alert-popup',
                    template: '<div class="row homeLoan textCenter justify-center margin-top-10 margin-bottom-5">' +
                        '<img class="viewImageSize" src="{{salaryUploadDocVm.profileImageUrl}}"/>' +
                        '</div>',
                    buttons: [{
                        text: 'OK',
                        type: 'button-assertive',
                        onTap: function () {
                        }
                    }]
                });
            }
        }
        



    salaryUploadDocVm.b64toBlob = function (b64Data, contentType, sliceSize) {
            contentType = contentType || '';
            sliceSize = sliceSize || 512;
            var byteCharacters = atob(b64Data);
            var byteArrays = [];
            for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
                var slice = byteCharacters.slice(offset, offset + sliceSize);
                var byteNumbers = new Array(slice.length);
                for (var i = 0; i < slice.length; i++) {
                    byteNumbers[i] = slice.charCodeAt(i);
                }
                var byteArray = new Uint8Array(byteNumbers);
                byteArrays.push(byteArray);
            }
            var blob = new Blob(byteArrays, { type: contentType });
            return blob;
        }

    function savebase64AsPDF (folderpath, filename, content, contentType) {
            // Convert the base64 string in a Blob
            var DataBlob = salaryUploadDocVm.b64toBlob(content, contentType);

            console.log("Starting to write the file :3");

            window.resolveLocalFileSystemURL(folderpath, function (dir) {
                console.log("Access to the directory granted succesfully");
                dir.getFile(filename, { create: true }, function (file) {
                    console.log("File created succesfully.");
                    file.createWriter(function (fileWriter) {
                        console.log("Writing content to file");
                        fileWriter.write(DataBlob);
                        console.log("Folder Path" + folderpath + filename);
                        var finalPath = folderpath + filename;
                        console.log("finalPath" +finalPath);

                // pdf viewer plugin call start //
                    cordova.plugins.fileOpener2.open(
                            finalPath, // You can also use a Cordova-style file uri: cdvfile://localhost/persistent/Downloads/starwars.pdf
                            'application/pdf', {
                            error: function (e) {
                                console.log('Error status: ' + e.status + ' - Error message: ' + e.message);
                            },
                            success: function () {
                                console.log('file opened successfully');
                            }
                        }
                        );
                    }, function () {
                        alert('Unable to save file in path ' + folderpath);
                    });
                // pdf viewer plugin call end //

                });
            });
        }

        return this;
    }
]);
