'use strict';

angularApp.service('salaryUploadService',
    function($q, AdapterUtils, utilityService, constantConfig, $ionicPopup, $state, $ionicScrollDelegate,$cordovaCamera) {

        var salaryUploadService = this;

	
		salaryUploadService.getFileForAndroid = function(){
            var q = $q.defer();
            
            fileChooser.open(function(imageURI){
                window.resolveLocalFileSystemURL(imageURI, function(fileEntry){
                    var base64 = "";
                    
                    console.log("got image file entry 1: " +  fileEntry.fullPath); 
                    fileEntry.file( function(file) {
                        console.log("file", file);
                        console.log("file.size", file.size);
                        if (file.size >= 3077 && file.size < 499680 ) {
                        var reader = new FileReader();
                        reader.onloadend = function(evt) {
                            console.log("Read complete!");
                            console.log("got image file entry 2: " +  fileEntry.fullPath);
                           
                            base64 = evt.target.result;
                           
                            var fileData = {
                                "data":base64,
                                "filePath":fileEntry.fullPath
                            }
                          
                            q.resolve(fileData);
                           
                        };
                        reader.readAsDataURL(file);
                        } else {
                            var msg = "Document size should be less than 500 KB and more than 2 KB."
                            $ionicPopup.show({
                                title: '',
                                template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src="img/FT/BhimUpi/alertSymbol.svg" /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'
                                + msg + '</span></div></div></div>',
                                scope: '',
                                cssClass: 'my-custom-popup bhim-alert-popup ao-popupMain',
                                buttons: [{
                                    text: 'OK',
                                    type: 'button-assertive',
                                    onTap: function () {
                                    }
                                }],
                            });
                        }
                    }, function (error) {
                        q.reject(error);
                    });
                }, failSystem);
            }, failureCallback);
            return q.promise;
        }

        salaryUploadService.getFileForiOS = function () {
            var q = $q.defer();

            DocumentPicker.getFile(['image', 'pdf'], function (url) {
                window.resolveLocalFileSystemURL(url, function (fileEntry) {
                    var base64 = "";
                    fileEntry.file(function (file) {
                    if (file.size >= 3077 && file.size < 499680 ) {
                        var reader = new FileReader();
                        reader.onloadend = function(evt) {
                            base64 = evt.target.result;
                            console.log("got image file entry 2: " +  fileEntry.fullPath);
                            var obj = {
                                size : file.size,
                                imagedata : base64,
                                path:fileEntry.fullPath
                            };
                    q.resolve(obj);
                        };
                        reader.readAsDataURL(file);
                        } else {
                            var msg = "Document size should be less than 500 KB and more than 2 KB."
                            $ionicPopup.show({
                                title: '',
                                template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src="img/FT/BhimUpi/alertSymbol.svg" /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'
                                + msg + '</span></div></div></div>',
                                scope: '',
                                cssClass: 'my-custom-popup bhim-alert-popup ao-popupMain',
                                buttons: [{
                                    text: 'OK',
                                    type: 'button-assertive',
                                    onTap: function () {
                                    }
                                }],
                            });
                        }
                    }, function (error) {
                        q.reject(error);
                    });
                }, failSystem);
                
            }, function(err) {
                q.reject("error");
            });
            return q.promise;
        }
    
		
        salaryUploadService.uploadPhotograph = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.salaryUploadDocVkyc, requestData, true).then(
                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        salaryUploadService.retrievePhoto = function(requestData) {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.retrieveDocument + requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
 
        
        salaryUploadService.clickSelfie = function(){
            var options = {
                quality: 70,
                destinationType: Camera.DestinationType.FILE_URI,
                sourceType: Camera.PictureSourceType.CAMERA,
                allowEdit: false,
                encodingType: Camera.EncodingType.JPEG,
                cameraDirection: Camera.Direction.FRONT,
                popoverOptions: CameraPopoverOptions,
                saveToPhotoAlbum: false,
                correctOrientation:true,
                targetHeight:0,
                targetWidth:0
            };

            console.log("options",options);
            
              var q =  $q.defer();
                       $cordovaCamera.getPicture(options).then(function(imageData) {
                           
                           q.resolve( "data:image/jpeg;base64," + imageData)
                       }, function(err) {
                           if(err == "No Image Selected" || err == "no image selected"){
                                   q.reject("No Image Captured")
                           }else if(err == "20"){
                                   q.reject("Permission Denied");
                           }else{
                               q.reject("error");
                           }
                       });
               return q.promise;
}

        salaryUploadService.showAlertPopup = function (imageType, message1, message2, onTapgo, buttontext1, buttontext2, $scope, obj) {
            var btn_array = [];
            if(buttontext1 != "" && buttontext2 != ""){
                btn_array = [
                    {
                        text: buttontext2 || "Cancel",
                        type: 'button-negative',
                        onTap: function () {

                        }
                    },
                    {
                        text: buttontext1 || "OK",
                        type: 'button-positive',
                        onTap: function () {                            
                            if (onTapgo) {
                                $state.go(onTapgo);
                            }                                              
                        }
                    }
                ];
            }
            else{
                btn_array = [
                    {
                        text: buttontext1 || "OK",
                        type: 'button-positive',
                        onTap: function () {
                            if (onTapgo) {
                                $state.go(onTapgo);
                            }
                        }
                    }
                ];
            }

            if(imageType && imageType.toLowerCase() == 'error'){
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/errorSymbol.svg"/></div>';
            } else if(imageType && imageType.toLowerCase() == 'success'){
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/successSymbol.svg"/></div>';
            }else if(imageType && imageType.toLowerCase() == 'alert'){
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/alertSymbol.svg"/></div>';
            }else{
                imageType = "";
            }
            var bhimErrorPopup = $ionicPopup.alert({
                template: '<div class="font-dark-grey">'+imageType+'<div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter roboto-medium font-size-16 color-darkgrey"><span>'
                + message1 + '</span><div ng-if="message2" class="textAlignCenter roboto-regular font-size-14 color-darkgrey padTop10">'+message2+'</div></div></div></div>', //template,
                scope: $scope,
                cssClass: 'bhim-alert-popup',
                buttons: btn_array,
            });
            bhimErrorPopup.then(function (res) {
            });
        };


        salaryUploadService.showAlertPopupWithCallback = function (imageType, message1, message2, message3, buttontext1, buttontext2, $scope, button1,button2) {
            if(imageType && imageType.toLowerCase() == 'error'){
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/errorSymbol.svg"/></div>';
            } else if(imageType && imageType.toLowerCase() == 'success'){
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/successSymbol.svg"/></div>';
            }else if(imageType && imageType.toLowerCase() == 'alert'){
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/alertSymbol.svg"/></div>';
            }else{
                imageType = "";
            }
            var rtxcPopUp = $ionicPopup.alert({
                template: '<div class="font-dark-grey">'+imageType+'<div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter roboto-medium font-size-16 color-darkgrey"><span>'
                + message1 + '</span><div  class="textAlignCenter roboto-regular font-size-14 color-darkgrey padTop10">'+message2+'</div><div  class="textAlignCenter roboto-bold font-size-14 color-darkgrey padTop10">'+message3+'</div></div></div></div>', //template,
                scope: $scope,
                cssClass: 'bhim-alert-popup',
                buttons: [
                    {
                        text: buttontext2 || "Cancel",
                        type: 'button-negative',
                        onTap: function () {
                            button1()
                        }
                    },
                    {
                        text: buttontext1 || "OK",
                        type: 'button-positive',
                        onTap: function () {
                            button2()
                        }
                    }
                ]
            });
            rtxcPopUp.then(function (res) {
            });
        };


        salaryUploadService.showTncAlertPopup = function (content) {
            var test = '<div>'
                        +content+        
                '<div class="rtxcTnC"> <button class="rxtcTnC_button" ng-click = "closePopup()" >OK</button></div></div>';
            var bhimErrorPopup = $ionicPopup.show({
                template: test,
                title: 'Terms & Conditions',
                cssClass: 'bhim-alert-popup hlTermnCondition',
            });
            bhimErrorPopup.then(function (res) {
                console.log("hii tabbed" ,res)
               
            });
            
        };

        function failureCallback (msg) {
                console.log(msg);
                utilityService.hideSpinner();
                //do something
        }
    
        function failSystem(err){
            console.log("got image file entry err: " +  err);
            utilityService.hideSpinner();
        }

        
     return salaryUploadService;

    });
