'use strict';

angularApp.controller('instaReviewSelectedBranchController', ["$state",
    "$scope",
    "$ionicScrollDelegate",
    "instaselectBranchListService",
    "instaService",
    "utilityService",
    "$ionicHistory",
    "$translate",
    "$ionicSideMenuDelegate",
    "mPinLoginService",


    function ($state,
        $scope,
        $ionicScrollDelegate,
        instaselectBranchListService,
        instaService,
        utilityService,
        $ionicHistory,
        $translate,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instaReviewSelectedBranchVm = this;

        function initPage() {
            instaReviewSelectedBranchVm.showBack = true;
            instaReviewSelectedBranchVm.showNext = true;
            instaReviewSelectedBranchVm.disableNext = false;
            instaReviewSelectedBranchVm.bankListLocality = [];
            instaReviewSelectedBranchVm.aofooter = true;
            instaReviewSelectedBranchVm.showRadioBtn = true;
            instaReviewSelectedBranchVm.showLink = false;
            instaReviewSelectedBranchVm.pincode = "";
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                instaReviewSelectedBranchVm.okBtntext = translatedvalue;
            });
        }

        instaReviewSelectedBranchVm.goBacktoPrevious = function () {
            if (instaService.isResumeJourney || !instaService.isResumeJourney ) {
                if(parseInt(instaService.nomineeAadhaarCardDetails.age) < 18 || parseInt(instaService.nominee.age) < 18){
                    if(instaService.nominee.guardianAddressFlag == "nomineeAddress"){
                        $state.go("menu.instaKit_nomineeEnteredAddress");
                    }
                    else if(instaService.nominee.guardianAddressFlag == "applicantAddress"){
                        $state.go("menu.instaKit_nomineeAddress");
                    }
                    else if(instaService.nominee.guardianAddressFlag == "newAddress"){
                        $state.go("menu.instaKit_nomineeCAddress");
                    }
                    else{
                        $state.go("menu.instaKit_nomineeDetailsAddressOption");
                    }
                }
                else{
                    $state.go("menu.instaKit_nomineeDetailsNext");
                }
            } 
           
        }

        instaReviewSelectedBranchVm.goToNextPage = function () {
            //if (instaService.localityNav === "selectBranch") {

            var requestParams = {
                "id": instaService.customer.mobileNo,
                "data": {
                    "homeBranch": {
                        "city": instaService.homeBranchLocalityCity,
                        "branchId": instaService.homeBranchLocalityId,
                        "branchType": instaService.homeBranchLocalityBranchName + "," + instaService.homeBranchLocalityAddress + "," + instaService.homeBranchLocalityCityName + "," + instaService.homeBranchLocalityPincode
                    },
                    "vkyc": {
                        "vkycBranchCode": instaService.vkycBranchCode
                      },
                    "commonId": $state.$current.data.commonId
                }
            }
            instaselectBranchListService.setSelectedBranch(requestParams).then(function (response) {
                $state.go('menu.instaKit_termsAndConditions');
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

        }

        instaReviewSelectedBranchVm.editBranch = function () {
            $state.go("menu.instaKit_selectBListLocalityByPincode");
        }

        $scope.goToHome = function () {
            instaService.homeNav();
        }

        //Service for displaying branch list for locality
        instaReviewSelectedBranchVm.loadBranchesLocality = function () {
            instaReviewSelectedBranchVm.hideOptions = false;
            instaReviewSelectedBranchVm.bankListLocality.length = 0;
            var params = {
                "locality": instaReviewSelectedBranchVm.searchValue,
                "localityType": "BRANCHNAME"
            }
            // instaService.homeBranchLocalityCity = instaReviewSelectedBranchVm.searchValue;
            instaselectBranchListService.getBranchesForLocality(params).then(function (data) {
                if (utilityService.isUndefined(data)) {
                    var title = '';
                    var template = '{{"NO_BRANCH_AVLBL" | translate}}';
                    var onTap = 'menu.instaKit_reviewSelectedBranch';
                    var buttontext = '<b>' + instaReviewSelectedBranchVm.okBtntext + '</b>';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                } else {
                    if (data.branches.length == 0) {
                        var title1 = '';
                        var template1 = '{{"NO_BRANCH_AVLBL" | translate}}';
                        var onTap1 = 'menu.instaKit_reviewSelectedBranch';
                        var buttontext1 = '<b>' + instaReviewSelectedBranchVm.okBtntext + '</b>';
                        utilityService.showAlertModal(title1, template1, onTap1, $scope, $state, buttontext1);
                    }
                    else {
                        for (var i = 0; i < data.branches.length; i++) {
                            instaReviewSelectedBranchVm.bankListLocality.push(data.branches[i]);
                            if (instaReviewSelectedBranchVm.bankListLocality[i].id == instaService.homeBranchLocalityId) {
                                // instaReviewSelectedBranchVm.branchList = instaReviewSelectedBranchVm.bankListLocality[i].id;
                                instaService.homeBranchLocalityBranchName = instaReviewSelectedBranchVm.bankListLocality[i].branchName;
                                instaService.homeBranchLocalityAddress = instaReviewSelectedBranchVm.bankListLocality[i].address;
                                instaService.homeBranchLocalityCityName = instaReviewSelectedBranchVm.bankListLocality[i].city;
                                instaService.homeBranchLocalityPincode = instaReviewSelectedBranchVm.bankListLocality[i].pincode;
                                instaService.vkycBranchCode = instaReviewSelectedBranchVm.bankListLocality[i].vkycBranchCode;
                                instaReviewSelectedBranchVm.branchName = instaService.homeBranchLocalityBranchName;
                                instaReviewSelectedBranchVm.address = instaService.homeBranchLocalityAddress;
                                instaReviewSelectedBranchVm.city = instaService.homeBranchLocalityCityName;
                                instaReviewSelectedBranchVm.pincode = instaService.homeBranchLocalityPincode;
                                // instaReviewSelectedBranchVm.disableNext = false;
                            }
                        }
                    }
                }
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            instaReviewSelectedBranchVm.searchValue = instaService.homeBranchLocalityId;
            if (instaService.isResumeJourney && instaReviewSelectedBranchVm.searchValue && !instaService.homeBranchLocalityBranchName) {
                instaReviewSelectedBranchVm.loadBranchesLocality();
            }else{
                instaReviewSelectedBranchVm.branchName = instaService.homeBranchLocalityBranchName;
                instaReviewSelectedBranchVm.address = instaService.homeBranchLocalityAddress;
                instaReviewSelectedBranchVm.city = instaService.homeBranchLocalityCityName;
                instaReviewSelectedBranchVm.pincode = instaService.homeBranchLocalityPincode;
            }

            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });
        return this;
    }
]);
