'use strict';

angularApp.controller('instaSearchBranchController', ["$state",
    "$scope",
    "$ionicScrollDelegate",
    "instaselectBranchListService",
    "instaService",
    "utilityService",
    "$ionicHistory",
    "$translate",
    "$ionicSideMenuDelegate",
    "mPinLoginService",


    function ($state,
        $scope,
        $ionicScrollDelegate,
        instaselectBranchListService,
        instaService,
        utilityService,
        $ionicHistory,
        $translate,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instaSearchBranchVm = this;

        function initPage() {
            instaSearchBranchVm.showBack = true;
            instaSearchBranchVm.showNext = true;
            instaSearchBranchVm.disableNext = true;
            instaSearchBranchVm.bankListLocality = [];
            instaSearchBranchVm.aofooter = true;
            instaSearchBranchVm.showRadioBtn = true;
            instaSearchBranchVm.showLink = false;
            instaSearchBranchVm.searchValue = "";
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                instaSearchBranchVm.okBtntext = translatedvalue;
            });
        }

        instaSearchBranchVm.goBacktoPrevious = function () {
            $state.go("menu.instaKit_searchBranchByOption");
        }

        instaSearchBranchVm.goToNextPage = function () {
            instaService.homeBranchLocalityId = instaSearchBranchVm.homeBranchLocalityId;
            instaService.homeBranchLocalityBranchName = instaSearchBranchVm.homeBranchLocalityBranchName;
            instaService.homeBranchLocalityAddress = instaSearchBranchVm.homeBranchLocalityAddress;
            instaService.homeBranchLocalityCityName = instaSearchBranchVm.homeBranchLocalityCityName;
            instaService.homeBranchLocalityPincode = instaSearchBranchVm.homeBranchLocalityPincode;
            instaService.vkycBranchCode = instaSearchBranchVm.vkycBranchCode;
            $state.go("menu.instaKit_reviewSelectedBranch");
        }

        instaSearchBranchVm.onChangeFn = function (value) {
            if (!utilityService.isUndefined(value)) {
                if (value.length == 3 && instaSearchBranchVm.searchBranchBy == "name") {
                    instaSearchBranchVm.loadBranchesLocality('BRANCHNAME');
                    $ionicScrollDelegate.scrollTop();
                } else if(value.length == 5 && instaSearchBranchVm.searchBranchBy == "code"){
                    instaSearchBranchVm.loadBranchesLocality('BRANCHCODE');
                    $ionicScrollDelegate.scrollTop();
                }
            } else {
                instaSearchBranchVm.bankListLocality = [];
                instaSearchBranchVm.disableNext = true;
            }

        }

        $scope.goToHome = function () {
            instaService.homeNav();
        }

        //Make the radio button checked if the respective div is clicked
        instaSearchBranchVm.checkDiv = function (param) {
            instaSearchBranchVm.branchList = param.id;
            instaSearchBranchVm.disableNext = false;
            // instaService.homeBranchLocalityId = param.id;
            // instaService.homeBranchLocalityBranchName = param.branchName;
            // instaService.homeBranchLocalityAddress = param.address;
            // instaService.homeBranchLocalityCityName = param.city;
            // instaService.homeBranchLocalityPincode = param.pincode;
            // instaService.vkycBranchCode = param.vkycBranchCode;
            instaSearchBranchVm.homeBranchLocalityId = param.id;
            instaSearchBranchVm.homeBranchLocalityBranchName = param.branchName;
            instaSearchBranchVm.homeBranchLocalityAddress = param.address;
            instaSearchBranchVm.homeBranchLocalityCityName = param.city;
            instaSearchBranchVm.homeBranchLocalityPincode = param.pincode;
            instaSearchBranchVm.vkycBranchCode = param.vkycBranchCode;
        }

        instaSearchBranchVm.validateForm = function (isValid) {
            if (isValid) {
                instaSearchBranchVm.disableNext = false;
            }
            else {
                instaSearchBranchVm.disableNext = true;
            }
        }

        instaSearchBranchVm.selectedBranch = function (param) {
            instaService.branchname = param.branchName;
            instaService.branchaddress = param.address;
            // instaService.homeBranchLocalityId = param.id;
            // instaService.homeBranchLocalityBranchName = param.branchName;
            // instaService.homeBranchLocalityAddress = param.address;
            // instaService.homeBranchLocalityCityName = param.city;
            // instaService.homeBranchLocalityPincode = param.pincode;
            // instaService.vkycBranchCode = param.vkycBranchCode;
            instaSearchBranchVm.homeBranchLocalityId = param.id;
            instaSearchBranchVm.homeBranchLocalityBranchName = param.branchName;
            instaSearchBranchVm.homeBranchLocalityAddress = param.address;
            instaSearchBranchVm.homeBranchLocalityCityName = param.city;
            instaSearchBranchVm.homeBranchLocalityPincode = param.pincode;
            instaSearchBranchVm.vkycBranchCode = param.vkycBranchCode;
        }

        //Service for displaying branch list for locality
        instaSearchBranchVm.loadBranchesLocality = function (localityType) {
            instaSearchBranchVm.hideOptions = false;
            instaSearchBranchVm.bankListLocality.length = 0;
            var params = {
                "locality": instaSearchBranchVm.searchValue,
                "localityType": localityType
            }
            instaService.homeBranchLocalityCity = instaSearchBranchVm.searchValue;
            instaselectBranchListService.getBranchesForLocality(params).then(function (data) {
                if (utilityService.isUndefined(data)) {
                    var title = '';
                    var template = '{{"NO_BRANCH_AVLBL" | translate}}';
                    var onTap = 'menu.instaKit_searchBranch';
                    var buttontext = '<b>' + instaSearchBranchVm.okBtntext + '</b>';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                } else {
                    if (data.branches.length == 0) {
                        var title1 = '';
                        var template1 = '{{"NO_BRANCH_AVLBL" | translate}}';
                        var onTap1 = 'menu.instaKit_searchBranch';
                        var buttontext1 = '<b>' + instaSearchBranchVm.okBtntext + '</b>';
                        utilityService.showAlertModal(title1, template1, onTap1, $scope, $state, buttontext1);
                    }
                    else {
                        for (var i = 0; i < data.branches.length; i++) {
                            instaSearchBranchVm.bankListLocality.push(data.branches[i]);
                            if (instaSearchBranchVm.bankListLocality[i].id == instaService.homeBranchLocalityId) {
                                instaSearchBranchVm.branchList = instaSearchBranchVm.bankListLocality[i].id;
                                // instaService.homeBranchLocalityBranchName = instaSearchBranchVm.bankListLocality[i].branchName;
                                // instaService.homeBranchLocalityAddress = instaSearchBranchVm.bankListLocality[i].address;
                                // instaService.homeBranchLocalityCityName = instaSearchBranchVm.bankListLocality[i].city;
                                // instaService.homeBranchLocalityPincode = instaSearchBranchVm.bankListLocality[i].pincode;
                                // instaService.vkycBranchCode = instaSearchBranchVm.bankListLocality[i].vkycBranchCode;
                                instaSearchBranchVm.homeBranchLocalityBranchName = instaSearchBranchVm.bankListLocality[i].branchName;
                                instaSearchBranchVm.homeBranchLocalityAddress = instaSearchBranchVm.bankListLocality[i].address;
                                instaSearchBranchVm.homeBranchLocalityCityName = instaSearchBranchVm.bankListLocality[i].city;
                                instaSearchBranchVm.homeBranchLocalityPincode = instaSearchBranchVm.bankListLocality[i].pincode;
                                instaSearchBranchVm.vkycBranchCode = instaSearchBranchVm.bankListLocality[i].vkycBranchCode;
                                instaSearchBranchVm.disableNext = false;
                            }
                        }
                    }
                }
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            if (instaService.clearSearchBrData) {
                instaSearchBranchVm.searchValue = ""
                instaSearchBranchVm.bankListLocality = []
                instaSearchBranchVm.branchList = ""
                instaSearchBranchVm.disableNext = true;
            }
            instaSearchBranchVm.searchBranchBy = instaService.searchBranchBy;            
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });
        return this;
    }
]);
