'use strict';

angularApp.controller('instaselectBranchListGpsController', ["$state",
    "$scope",
    "instaselectBranchListService",
    "instaService",
    "utilityService",
    "currentLocationService",
    "$timeout",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        instaselectBranchListService,
        instaService,
        utilityService,
        currentLocationService,
        $timeout,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instaselectBranchListGpsVm = this;

        function initPage() {
            instaselectBranchListGpsVm.showBack = true;
            instaselectBranchListGpsVm.showNext = true;
            instaselectBranchListGpsVm.disableNext = true;
            instaselectBranchListGpsVm.showRadioBtn = true;
            instaselectBranchListGpsVm.showLink = false;
            instaselectBranchListGpsVm.aofooter = true;
            instaselectBranchListGpsVm.gpsLink = true;
        }

        instaselectBranchListGpsVm.goBacktoPrevious = function() {
            $state.go('menu.instaKit_selectBranchOption');
        }

        instaselectBranchListGpsVm.goToNextPage = function() {
            var requestParams = {
                "id": instaService.customer.mobileNo,
                "data": {
                    "homeBranch": {
                        "city": "",
                        "branchId": instaService.homeBranchGpsId
                    },
                    "commonId": $state.$current.data.commonId
                }
            }
            instaselectBranchListService.setSelectedBranch(requestParams).then(function(response) {
                $state.go('menu.instaKit_termsAndConditions');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        instaselectBranchListGpsVm.validateForm = function(isValid) {
            if (isValid) {
                instaselectBranchListGpsVm.disableNext = false;
            }
        }

        instaselectBranchListGpsVm.selectedBranch = function(param) {
            instaService.branchname = param.branchName;
            instaService.branchaddress = param.address;
            instaService.homeBranchGpsId = param.id;
        }

        //Make the radio button checked if the respective div is clicked
        instaselectBranchListGpsVm.checkDiv = function(param) {
            instaselectBranchListGpsVm.branchList = param.id;
            instaselectBranchListGpsVm.disableNext = false;
            instaService.homeBranchGpsId = param.id;
        }

        //Service for displaying branch list for latitude and longitude
        instaselectBranchListGpsVm.loadBranchesGps = function() {            
            instaselectBranchListGpsVm.bankListGps = instaService.selectByGPS;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        $scope.$on('$ionicView.beforeEnter', function() {
            instaselectBranchListGpsVm.loadBranchesGps();  
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
