'use strict';

angularApp.controller('instaselectBranchListLocController', ["$state",
    "$scope",
    "$ionicScrollDelegate",
    "instaselectBranchListService",
    "instaService",
    "utilityService",
    "$ionicHistory",
    "$translate",
    "$ionicSideMenuDelegate",
    "mPinLoginService",


    function ($state,
        $scope,
        $ionicScrollDelegate,
        instaselectBranchListService,
        instaService,
        utilityService,
        $ionicHistory,
        $translate,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instaselectBranchListLocVm = this;

        function initPage() {
            instaselectBranchListLocVm.showBack = true;
            instaselectBranchListLocVm.showNext = true;
            instaselectBranchListLocVm.disableNext = true;
            instaselectBranchListLocVm.bankListLocality = [];
            instaselectBranchListLocVm.aofooter = true;
            instaselectBranchListLocVm.showRadioBtn = true;
            instaselectBranchListLocVm.showLink = false;
            instaselectBranchListLocVm.localityname = "";
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                instaselectBranchListLocVm.okBtntext = translatedvalue;
            });
        }

        instaselectBranchListLocVm.goBacktoPrevious = function () {
            //$ionicHistory.goBack();
            // $state.go("menu.instaKit_selectBranchOption");
            if(parseInt(instaService.nomineeAadhaarCardDetails.age) < 18 || parseInt(instaService.nominee.age) < 18){
                if(instaService.nominee.guardianAddressFlag == "nomineeAddress"){
                    $state.go("menu.instaKit_nomineeEnteredAddress");
                }
                else if(instaService.nominee.guardianAddressFlag == "applicantAddress"){
                    $state.go("menu.instaKit_nomineeAddress");
                }
                else if(instaService.nominee.guardianAddressFlag == "newAddress"){
                    $state.go("menu.instaKit_nomineeCAddress");
                }
                else{
                    $state.go("menu.instaKit_nomineeDetailsAddressOption");
                }
            }
            else{
                $state.go("menu.instaKit_nomineeDetailsNext");
            }
        }

        instaselectBranchListLocVm.goToNextPage = function () {
            //if (instaService.localityNav === "selectBranch") {
            var requestParams = {
                "id": instaService.customer.mobileNo,
                "data": {
                    "homeBranch": {
                        "city": instaService.homeBranchLocalityCity,
                        "branchId": instaService.homeBranchLocalityId,
                        "branchType": instaService.homeBranchLocalityBranchName + "," + instaService.homeBranchLocalityAddress + "," + instaService.homeBranchLocalityCityName + "," + instaService.homeBranchLocalityPincode
                    },
                    "vkyc": {
                        "vkycBranchCode": instaService.vkycBranchCode
                      },
                    "commonId": $state.$current.data.commonId
                }
            }
            instaselectBranchListService.setSelectedBranch(requestParams).then(function (response) {
                $state.go('menu.instaKit_termsAndConditions');
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

        }

        instaselectBranchListLocVm.getCountriesList = function () {
            instaselectBranchListService.getAllCities().then(function (body) {
                if (!utilityService.isUndefined(body)) {
                    for (var i = 0; i < body.length; i++) {
                        instaselectBranchListLocVm.displayCities.push(body[i]);
                        instaselectBranchListLocVm.displayCities.sort();
                    }
                }
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        instaselectBranchListLocVm.onChangeFn = function (value) {
            if (!utilityService.isUndefined(value)) {
                if (value.length == 3) {
                    instaselectBranchListLocVm.loadBranchesLocality();
                    $ionicScrollDelegate.scrollTop();
                }
            } else {
                instaselectBranchListLocVm.bankListLocality = [];
                instaselectBranchListLocVm.disableNext = true;
            }

        }

        instaselectBranchListLocVm.showHideFilterDropDown = function (city) {
            if (!utilityService.isUndefined(city)) {
                instaselectBranchListLocVm.localityname = city;
                instaselectBranchListLocVm.loadBranchesLocality();
            } else {
                instaselectBranchListLocVm.hideOptions = false;
            }
        }

        $scope.goToHome = function () {
            instaService.homeNav();
        }

        //Make the radio button checked if the respective div is clicked
        instaselectBranchListLocVm.checkDiv = function (param) {
            instaselectBranchListLocVm.branchList = param.id;
            instaselectBranchListLocVm.disableNext = false;
            instaService.homeBranchLocalityId = param.id;
            instaService.homeBranchLocalityBranchName = param.branchName;
            instaService.homeBranchLocalityAddress = param.address;
            instaService.homeBranchLocalityCityName = param.city;
            instaService.homeBranchLocalityPincode = param.pincode;
            instaService.vkycBranchCode = param.vkycBranchCode;
        }

        instaselectBranchListLocVm.changeLoc = function (locModel, isValid) {
            if (utilityService.isUndefined(locModel)) {
                instaselectBranchListLocVm.bankListLocality = [];
                instaselectBranchListLocVm.disableNext = true;
                instaService.homeBranchLocalityId = '';
                instaService.homeBranchLocalityCity = '';
                instaService.homeBranchLocalityBranchName = '';
                instaService.homeBranchLocalityAddress = '';
                instaService.homeBranchLocalityCityName = '';
                instaService.homeBranchLocalityPincode = '';
                instaService.vkycBranchCode = '';
            }
        }

        instaselectBranchListLocVm.onclickValidation = function (isValid) {
            instaselectBranchListLocVm.hideOptions = true;
            for (var i = 0; i < instaselectBranchListLocVm.displayCities.length; i++) {
                if (!utilityService.isUndefined(instaselectBranchListLocVm.localityname)) {
                    if (instaselectBranchListLocVm.displayCities[i].toLowerCase() == instaselectBranchListLocVm.localityname.toLowerCase()) {
                        instaselectBranchListLocVm.loadBranchesLocality();
                    }
                }
                else {
                    instaselectBranchListLocVm.bankListLocality = [];
                    instaselectBranchListLocVm.disableNext = true;
                }

            }
        }

        instaselectBranchListLocVm.validateForm = function (isValid) {
            if (isValid) {
                instaselectBranchListLocVm.disableNext = false;
            }
            else {
                instaselectBranchListLocVm.disableNext = true;
            }
        }

        instaselectBranchListLocVm.selectedBranch = function (param) {
            instaService.branchname = param.branchName;
            instaService.branchaddress = param.address;
            instaService.homeBranchLocalityId = param.id;
            instaService.homeBranchLocalityBranchName = param.branchName;
            instaService.homeBranchLocalityAddress = param.address;
            instaService.homeBranchLocalityCityName = param.city;
            instaService.homeBranchLocalityPincode = param.pincode;
            instaService.vkycBranchCode = param.vkycBranchCode;
        }

        //Service for displaying branch list for locality
        instaselectBranchListLocVm.loadBranchesLocality = function () {
            instaselectBranchListLocVm.hideOptions = false;
            instaselectBranchListLocVm.bankListLocality.length = 0;
            var params = {
                "locality": instaselectBranchListLocVm.localityname
            }
            instaService.homeBranchLocalityCity = instaselectBranchListLocVm.localityname;
            instaselectBranchListService.getBranchesForLocality(params).then(function (data) {
                if (utilityService.isUndefined(data)) {
                    var title = '';
                    var template = '{{"BRANCH_UNAVLBL" | translate}}';
                    var onTap = 'menu.instaKit_selectBranchListLocality';
                    var buttontext = '<b>' + instaselectBranchListLocVm.okBtntext + '</b>';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                } else {
                    if (data.branches.length == 0) {
                        var title = '';
                        var template = '{{"BRANCH_UNAVLBL" | translate}}';
                        var onTap = 'menu.instaKit_selectBranchListLocality';
                        var buttontext = '<b>' + instaselectBranchListLocVm.okBtntext + '</b>';
                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                    }
                    else {
                        for (var i = 0; i < data.branches.length; i++) {
                            instaselectBranchListLocVm.bankListLocality.push(data.branches[i]);
                            if (instaselectBranchListLocVm.bankListLocality[i].id == instaService.homeBranchLocalityId) {
                                instaselectBranchListLocVm.branchList = instaselectBranchListLocVm.bankListLocality[i].id;
                                instaService.homeBranchLocalityBranchName = instaselectBranchListLocVm.bankListLocality[i].branchName;
                                instaService.homeBranchLocalityAddress = instaselectBranchListLocVm.bankListLocality[i].address;
                                instaService.homeBranchLocalityCityName = instaselectBranchListLocVm.bankListLocality[i].city;
                                instaService.homeBranchLocalityPincode = instaselectBranchListLocVm.bankListLocality[i].pincode;
                                instaService.vkycBranchCode = instaselectBranchListLocVm.bankListLocality[i].vkycBranchCode;
                                instaselectBranchListLocVm.disableNext = false;
                            }
                        }
                    }
                }
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            instaselectBranchListLocVm.displayCities = [];
            //instaselectBranchListLocVm.getCountriesList();
            instaselectBranchListLocVm.localityname = instaService.homeBranchLocalityCity;
            if (!utilityService.isUndefined(instaselectBranchListLocVm.localityname)) {
                instaselectBranchListLocVm.loadBranchesLocality();
            }
            else if (utilityService.isUndefined(instaselectBranchListLocVm.localityname)) {
                instaselectBranchListLocVm.bankListLocality = [];
                instaselectBranchListLocVm.disableNext = true;
                instaService.homeBranchLocalityId = '';
                instaService.homeBranchLocalityCity = '';
                instaService.homeBranchLocalityBranchName = '';
                instaService.homeBranchLocalityAddress = '';
                instaService.homeBranchLocalityCityName = '';
                instaService.homeBranchLocalityPincode = '';
                instaService.vkycBranchCode = '';

            }
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });
        return this;
    }
]);
