'use strict';

angularApp.service('instaselectBranchListService',
    function($q, AdapterUtils, constantConfig) {

        var instaselectBranchListService = this;

        instaselectBranchListService.getBranchesForGeo = function(params) {

            var q = $q.defer(); 
            AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.getBranchesForGeo + params.longitude + "&latitude=" + params.latitude + "&branchLocator=" + params.branchLocator, false).then(

                function(response){ 
                    q.resolve(response.data);
                },
                function(error){    
                    q.reject(error);
                }
            );
            return q.promise;
        };

        instaselectBranchListService.getBranchesForLocality = function(params) {
           
             var q = $q.defer(); 
             AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.getBranchesForLocality, params, true).then(
                function(response){ 
                    q.resolve(response.data);
                },
                function(error){    
                    q.reject(error);
                }
            );
            return q.promise;

        };

         instaselectBranchListService.setSelectedBranch = function(requestParams) {
           
             var q = $q.defer(); 
            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.setSelectedBranch, requestParams, true).then(
                function(response){ 
                    q.resolve(response);
                },
                function(error){    
                    q.reject(error);
                }
            );
            return q.promise;

        };

        instaselectBranchListService.getAllCities = function() {
           
             var q = $q.defer(); 
             AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.getAllCities, true).then(
                function(response){ 
                    q.resolve(response.body);
                },
                function(error){    
                    q.reject(error);
                }
            );
            return q.promise;


        };

         instaselectBranchListService.fetchLocationByPinCode = function (payload) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/InstaAccountOpeningAdapter/fetchLocationByPinCode", payload, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

        return instaselectBranchListService;
    });
