'use strict';

angularApp.controller('instaselectBranchOptionController', ["$state",
    "$scope",
    "instaService",
    "$ionicHistory",
    "$translate",
    "currentLocationService",
    "utilityService",
    "instaselectBranchListService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        instaService,
        $ionicHistory,
        $translate,
        currentLocationService,
        utilityService,
        instaselectBranchListService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instaselectBranchOptionVm = this;

        function initPage() {
            instaselectBranchOptionVm.showBack = true;
            instaselectBranchOptionVm.showNext = true;
            instaselectBranchOptionVm.disableNext = true;
            instaselectBranchOptionVm.aofooter = true;
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                instaselectBranchOptionVm.okBtntext = translatedvalue;  
            });
        }

        instaselectBranchOptionVm.goBacktoPrevious = function() {
                if(parseInt(instaService.nomineeAadhaarCardDetails.age) < 18 || parseInt(instaService.nominee.age) < 18){
                    if(instaService.nominee.guardianAddressFlag == "nomineeAddress"){
                        $state.go("menu.instaKit_nomineeEnteredAddress");
                    }
                    else if(instaService.nominee.guardianAddressFlag == "applicantAddress"){
                        $state.go("menu.instaKit_nomineeAddress");
                    }
                    else if(instaService.nominee.guardianAddressFlag == "newAddress"){
                        $state.go("menu.instaKit_nomineeCAddress");
                    }
                    else{
                        $state.go("menu.instaKit_nomineeDetailsAddressOption");
                    }
                }
                else{
                    $state.go("menu.instaKit_nomineeDetailsNext");
                }
          
        }

        instaselectBranchOptionVm.goToNextPage = function() {            
            if (instaselectBranchOptionVm.isGpsClicked === true) {
                $state.go('menu.instaKit_selectBranchListGps');
            } else {
                $state.go('menu.instaKit_selectBranchListLocality');
            }
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        instaselectBranchOptionVm.bylocality = function() {
            instaselectBranchOptionVm.isGpsClicked = false;
            instaService.isGpsClicked = false;
            instaselectBranchOptionVm.disableNext = false;
        }

        instaselectBranchOptionVm.bygps = function() {  
             CheckGPS.check(function(){
                currentLocationService.getCurrentPosition().then(
                function(position) {
                    var latitude = position.coords.latitude;
                    var longitude = position.coords.longitude;
                    /*var latNew = latitude.toFixed(1);
                    var lonNew = longitude.toFixed(1);*/
                    instaService.customer.latitude = latitude;
                    instaService.customer.longitude = longitude;
                    instaService.selectByGPS.length = 0; 
                    var params = {
                        "latitude": instaService.customer.latitude,
                        "longitude": instaService.customer.longitude
                    }
                    if(utilityService.isUndefined(instaService.selectByGPS) || instaService.selectByGPS.length === 0){
                        instaselectBranchListService.getBranchesForGeo(params).then(function(data) {
                            for (var i = 0; i < data.branches.length; i++) {
                                instaService.selectByGPS.push(data.branches[i]);
                                setTimeout(function() { 
                                if(instaService.selectByGPS.length == 0){
                                    var title = '';
                                    var template = '{{"UNABLE_TO_GET_BRANCH" | translate}}';
                                    var onTap = 'menu.instaKit_selectBranchOption';
                                    var buttontext = 'OK';
                                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                                }
                            }, 300);
                            }
                        }, function(error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    }
                    else{
                        
                    }
                },
                function(err) {
                    var title = '';
                    var template = 'Please turn on GPS in your mobile to select branch by GPS';
                    var onTap = '';
                    var buttontext = '<b>' + instaselectBranchOptionVm.okBtntext + '</b>';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                }
            );   
            },
            function(){
                var title = '';
                var template = '{{"ENABLE_GPS" | translate}}';
                var onTap = '';
                var buttontext = 'OK';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            });                    
            instaselectBranchOptionVm.isGpsClicked = true;
            instaService.isGpsClicked = true;
            instaselectBranchOptionVm.disableNext = false;
        }

        instaselectBranchOptionVm.validateform = function(isValid) {
            instaselectBranchOptionVm.disableNext = false;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            instaService.localityNav = "selectBranch";
            instaService.localityNextDisable="selectBranchList";
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
