'use strict';

angularApp.controller('instataxController', ["$state",
    "$scope",
    "instaService",
    "instataxService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "$timeout",

    function($state,
        $scope,
        instaService,
        instataxService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        $timeout) {

        var instataxVm = this;

        function initPage() {
            instataxVm.showBack = false;
            instataxVm.showNext = true;
            instataxVm.disableNext = true;
            instataxVm.aofooter = true;  
            instataxVm.showBack = false;
        }

        //Go to Personal details page if user has clicked "No"
        instataxVm.goToNextPage = function(value){
            value = "yes";
            if(value == "yes"){
                instataxVm.isYesBtnClicked = true;
            }
            else{
                instataxVm.isYesBtnClicked = false;
            }
          var requestParams = {
                "id" : instaService.customer.mobileNo,
                "data":{
                    "fatcaFlag": instataxVm.isYesBtnClicked,
                    "commonId":$state.$current.data.commonId
                }
            }
            instataxService.setFactaFlag(requestParams).then(function(response) {
                if(value=="yes"){
                    $state.go('menu.instaKit_panAuthorise');
                }
                else{
                    $state.go('menu.instaKit_locateBranch');
                } 
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });  
        }

        instataxVm.getFatcaDeclarationDetail = function(){
            instataxService.getFatcaDeclaration().then(function(data) {
                instataxVm.fatcaQuestion = data;
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        //Show Info page on click of "i" icon
        instataxVm.showTaxInfo = function() {
            $state.go('menu.instaKit_foreign');
        }

        instataxVm.populateResumeData = function(){
			if(instaService.fatcaResumeStatus === true){
            instataxVm.isYesBtnClicked = instaService.fatcaFlag;
			}
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
            if(instaService.isResumeJourney == true){
                instataxVm.populateResumeData();
            }
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            $timeout(function() {
                instataxVm.getFatcaDeclarationDetail();
            });            
        });

        return this;
    }
]);
