'use strict';

angularApp.controller('instatermsAndConditionsController', ["$state",
    "$scope",
    "$translate",
    "$ionicScrollDelegate",
    "utilityService",
    "instatermsAndConditionsService",
    "instaService",
    "$timeout",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        $translate,
        $ionicScrollDelegate,
        utilityService,
        instatermsAndConditionsService,
        instaService,
        $timeout,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instatermsAndConditionsVm = this;

        function initPage() {
            instatermsAndConditionsVm.showBack = true;
            instatermsAndConditionsVm.showNext = true;
            instatermsAndConditionsVm.disableNext = true;
            instatermsAndConditionsVm.aofooter = true;
            instatermsAndConditionsVm.ConditionsJson = [];
            instatermsAndConditionsVm.conditionsList();
            var title = 'Terms & Conditions';
            var template = '{{"TERMS_CONDITIONS_POPUP" | translate}}';
            var onTap = 'menu.instaKit_termsAndConditions';
            var buttontext = 'Read T&C';
            utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            instatermsAndConditionsVm.disableCheckbox = true;
        }

        instatermsAndConditionsVm.goBacktoPrevious = function() {

            // $state.go("menu.instaKit_selectBranchListLocality");
            $state.go("menu.instaKit_reviewSelectedBranch");
            
        }

        instatermsAndConditionsVm.goToNextPage = function() {
            instatermsAndConditionsVm.postTAndCDetails();
        }

        instatermsAndConditionsVm.checkScrollOnLoad = function(){
            var tc = document.getElementById("tcId").offsetHeight;
            var tcContent = document.getElementById("tcContent").offsetHeight;
            if(tcContent <= tc){
                instatermsAndConditionsVm.disableCheckbox = false;
                var childNodes = document.getElementById('TERMCOND_CHK').children[0].children[0].removeAttribute("disabled");
            }
        }

        instatermsAndConditionsVm.checkScroll = function() {
            var currentTop = $ionicScrollDelegate.$getByHandle('scroller').getScrollPosition().top;
            var maxTop = $ionicScrollDelegate.$getByHandle('scroller').getScrollView().__maxScrollTop;
            if (currentTop >= maxTop) {
                instatermsAndConditionsVm.disableCheckbox = false;
                var childNodes = document.getElementById('TERMCOND_CHK').children[0].children[0].removeAttribute("disabled");
            }
        }

        //Service call to get terms and conditions data
        instatermsAndConditionsVm.conditionsList = function() {
            instatermsAndConditionsService.getTermsAndConditions().then(function(data) {
                instatermsAndConditionsVm.ConditionsJson = data;
                $timeout(function() {
                    instatermsAndConditionsVm.checkScrollOnLoad();
                });
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        // Service to send the terms and conditions checkbox flag
        instatermsAndConditionsVm.postTAndCDetails = function() {
             var requestParams = {
                "id" : instaService.customer.mobileNo,                
                "data":{
                    "commonId":$state.$current.data.commonId,
                    "termsAndConditionsFlag" : instatermsAndConditionsVm.isChecked
                }
            }
            instatermsAndConditionsService.postTAndC(requestParams).then(function(data) {
                if(data.responseCode == constantConfig.successCode){
                    //$state.go('menu.instaKit_productOffering');
                    $state.go('menu.instaKit_enterOTP');
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        instatermsAndConditionsVm.populateResumeData = function(){
            //instatermsAndConditionsVm.isChecked = instaService.termsAndConditionsFlag;
        }

        instatermsAndConditionsVm.agreeChkBox = function() {
            if (instatermsAndConditionsVm.isChecked) {
                instatermsAndConditionsVm.disableNext = false;
            } else {
                instatermsAndConditionsVm.disableNext = true;
            }
        }

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            instatermsAndConditionsVm.journeyType = instaService.journeyType;
            instatermsAndConditionsVm.constantJourneyTypeVKYC = constantConfig.acOpeningAdapterOVDConstant.vkycInsta;
            initPage();
            if(instaService.isResumeJourney == true){
                instatermsAndConditionsVm.populateResumeData();
            }
            instatermsAndConditionsVm.agreeChkBox();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
