'use strict';
angularApp.controller('linkDelinkUserController', [
    "$state",
    "$scope",
    "$ionicPopup",
    "$translate",
    "$ionicHistory",
    "utilityService",
    "ionicDatePicker",
    "$ionicSideMenuDelegate",
    "irctcService",
    function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, irctcService) {
        var linkDelinkUserVm = this;


        linkDelinkUserVm.goBack = function() {
            $ionicHistory.goBack(-1);
        };

        linkDelinkUserVm.forgotIRCTCUser = function() {
            cordova.ThemeableBrowser.open(irctcService.createIRCTCURL, '_system');
        };

        linkDelinkUserVm.proceed = function() {
            var uName = linkDelinkUserVm.userName;

            if (linkDelinkUserVm.isUserIDLinked) {
                irctcService.authenticateUser(uName).then(function(data) {
                    irctcService.userLinkedStatus = true;
                    irctcService.username = uName;
                    $ionicHistory.goBack(-1);
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else {

                //   var n = uName.localeCompare(irctcService.username);

                if (uName === irctcService.username) {
                    var myPopup = $ionicPopup.show({
                        templateUrl: 'pages/irctc/authenticateUser/delinkConfirmation.html',
                        cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter ftpopup-body',
                        title: '',

                        buttons: [{
                                text: 'Cancel',
                                type: 'button-assertive',
                                onTap: function(e) {
                                    return;
                                }
                            },
                            {
                                text: 'YES',
                                type: 'button-energized',
                                onTap: function(e) {
                                    irctcService.deAuthenticateUser().then(function(data) {
                                        irctcService.userLinkedStatus = false;
                                        irctcService.username = '';
                                        var alertPopup = $ionicPopup.alert({
                                            template: "<p style='text-align:center;font-weight:bold;font-size:16px'>IRCTC ID Delinked Successfully.</p>",
                                            buttons: [

                                                {
                                                    text: '<b>Ok</b>',
                                                    type: 'button-positive',
                                                    onTap: function(e) {
                                                        alertPopup.close();
                                                        $ionicHistory.goBack(-1);
                                                    }
                                                }
                                            ]
                                        });
                                       

                                    }, function(error) {
                                        utilityService.showErrorMessage(error.responseMessage);
                                    });
                                }
                            }
                        ]
                    });

                } else {
                    utilityService.showErrorMessage("Please enter valid user ID ");
                }
            }

        };

        linkDelinkUserVm.toggleMenu = function() {

            linkDelinkUserVm.menu = !linkDelinkUserVm.menu;
        }
        linkDelinkUserVm.createIRCTCAccount = function() {
            cordova.ThemeableBrowser.open(irctcService.createIRCTCURL, '_system');
        };

        $scope.$on('$ionicView.beforeLeave', function() {

        });

        $scope.$on('$ionicView.afterEnter', function() {

        });

        $scope.$on('$ionicView.beforeEnter', function() {
            linkDelinkUserVm.isUserIDLinked = !irctcService.userLinkedStatus;

            if (irctcService.username) {
                irctcService.userLinkedStatus = true;
                linkDelinkUserVm.username = irctcService.username;

                linkDelinkUserVm.userName = irctcService.username;

            } else {
                linkDelinkUserVm.username = "Menu";
                linkDelinkUserVm.userLinkedStatus = false;
                linkDelinkUserVm.userName = "";
            }
            linkDelinkUserVm.showManageInfo = irctcService.userLinkedStatus;

        });

        return this;
    }
]);
