'use strict';
angularApp.controller('bookTicketSearchController', [
	"$state",
	"$scope",
	"$ionicPopup",
	"$translate",
	"$ionicHistory",
	"utilityService",
	"ionicDatePicker",
	"$ionicSideMenuDelegate",
	"irctcService",
	"homeScreenService",
	"clickStreamService",
	function ($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, irctcService, homeScreenService, clickStreamService) {
		var bookTicketSearchdVm = this;
		bookTicketSearchdVm.callBannerFunction =  function() {
			irctcService.getIRCTCBannerdata('trainSearch').then(function (data) {
				bookTicketSearchdVm.bannerData = data.trainSearchBanner;
			});
		};
		bookTicketSearchdVm.trainQuota = [];


		bookTicketSearchdVm.GoBack = function () {
			// 	$ionicGoBack();
			$state.go('menu.homeScreen');
		};

			bookTicketSearchdVm.toggleMenu = function(){	
				bookTicketSearchdVm.menu = !bookTicketSearchdVm.menu;
			}

			bookTicketSearchdVm.hideMenu=function(){
				if(bookTicketSearchdVm.menu){
				bookTicketSearchdVm.menu=false;
			     }
			}

			bookTicketSearchdVm.autoSuggest = function(recState){
				if (recState == 'from') {
					bookTicketSearchdVm.hideListSource = false;
					bookTicketSearchdVm.filteredStationList = [];
				    angular.forEach(bookTicketSearchdVm.searchStations, function(stationObj) {
				      var index = stationObj.lastIndexOf(bookTicketSearchdVm.enterSourseStation.toUpperCase());
				      if(index != -1){
				        var filteredStationObj = {
				          "index" : stationObj.length - index,
				          "station" : stationObj
				        };
				        if(stationObj.indexOf(bookTicketSearchdVm.enterSourseStation.toUpperCase()) == 0){
				        	filteredStationObj = {
					          "index" : 0,
					          "station" : stationObj
					        };
				        }
				        bookTicketSearchdVm.filteredStationList.push(filteredStationObj);
				      }
				    });			
				} else if (recState == 'to'){
					  bookTicketSearchdVm.hideListDestination = false;
					  bookTicketSearchdVm.filteredStationListTo = [];
					    angular.forEach(bookTicketSearchdVm.searchStations, function(stationObj) {
					      var index = stationObj.lastIndexOf(bookTicketSearchdVm.enterDestinationStation.toUpperCase());
					      if(index != -1){
					        var filteredStationObj = {
					          "index" : stationObj.length - index,
					          "station" : stationObj
					        };
					        if(stationObj.indexOf(bookTicketSearchdVm.enterDestinationStation.toUpperCase()) == 0){
					        	filteredStationObj = {
						          "index" : 0,
						          "station" : stationObj
						        };
					        }
					        bookTicketSearchdVm.filteredStationListTo.push(filteredStationObj);
					      }
					    });
				}

			};

			bookTicketSearchdVm.gotoStationSearchResult = function (selectedStation,recState){
				if (recState == 'from') {
					bookTicketSearchdVm.hideListSource = true;
					bookTicketSearchdVm.enterSourseStation = selectedStation.station;
				} else if (recState == 'to'){
					bookTicketSearchdVm.enterDestinationStation = selectedStation.station;
					bookTicketSearchdVm.hideListDestination = true;
				}
			};
            
		bookTicketSearchdVm.goToBanner = function (store) {
			clickStreamService.clickStreamData = "websiteId," + store.mobileCategoryCode;
			if (store.mobileContent != "") {
				var bannerPopMsg = store.mobileContent;
				var bannerPopup = $ionicPopup.show({
					title: 'TERMS & CONDITIONS',
					cssClass: 'irctc-custom-popup roboto-regular font-size-14 color-darkgrey text-center',
					template: bannerPopMsg,
					buttons: [{
						text: 'OK',
						type: 'button-assertive',
						onTap: function () {
							bannerPopup.close();
						}
					}],
				});
			}
		}
		bookTicketSearchdVm.loadIRCTCMasters = function () {
			irctcService.getStationMaster().then(function (data) {
				irctcService.masterData = data;
				bookTicketSearchdVm.trainClass = data.trainClass;
				bookTicketSearchdVm.quotaList = data.trainQuota;
				bookTicketSearchdVm.selectedQuota = bookTicketSearchdVm.quotaList[0].key;
				bookTicketSearchdVm.selectedClass = bookTicketSearchdVm.trainClass[0].key;
				bookTicketSearchdVm.searchStations = data.trainStation;
				$scope.previousSelectedQuota= bookTicketSearchdVm.quotaList[0].key;
				if (data.username) {
					irctcService.userLinkedStatus = true;
					irctcService.username = data.username;
					bookTicketSearchdVm.username = data.username;
				} else {
					bookTicketSearchdVm.username = "Menu";
					irctcService.userLinkedStatus = false;
				}
				bookTicketSearchdVm.showManageInfo = irctcService.userLinkedStatus;

			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		};
		bookTicketSearchdVm.backCheck = function () {
			if (homeScreenService.ishamburgerMenuIRCTC) {
				bookTicketSearchdVm.isHamCheck = true;
				bookTicketSearchdVm.isBackCheck = true;
			} else {
				bookTicketSearchdVm.isBackCheck = false;
				bookTicketSearchdVm.isHamCheck = false;
			}
		};

		$scope.$on('$ionicView.beforeEnter', function () {
			bookTicketSearchdVm.backCheck();
			bookTicketSearchdVm.callBannerFunction()
			irctcService.genderMaster = [{
				"key": "M",
				"value": "Male"
			}, {
				"key": "F",
				"value": "Female"
			}, {
				"key": "T",
				"value": "Transgender"
			}];
			//Load IRCTC Masters & Station List
			bookTicketSearchdVm.hideListSource = true;
			bookTicketSearchdVm.hideListDestination = true;
			if (irctcService.searchTrainObj) {
				bookTicketSearchdVm.searchStations = irctcService.masterData.trainStation;
				bookTicketSearchdVm.enterSourseStation = irctcService.searchTrainObj.fromStation;
				bookTicketSearchdVm.enterDestinationStation = irctcService.searchTrainObj.toStation;
				bookTicketSearchdVm.scheduleDate = irctcService.displayDate;
				bookTicketSearchdVm.quotaList = irctcService.masterData.trainQuota;
				bookTicketSearchdVm.trainClass = irctcService.masterData.trainClass;
				bookTicketSearchdVm.selectedClass = irctcService.searchTrainObj.journeyClass;
				bookTicketSearchdVm.selectedQuota = irctcService.searchTrainObj.quota;
				bookTicketSearchdVm.selectedQuota = bookTicketSearchdVm.quotaList[0].key;
				bookTicketSearchdVm.selectedClass = bookTicketSearchdVm.trainClass[0].key;
				if (irctcService.username) {
					irctcService.userLinkedStatus = true;
					bookTicketSearchdVm.username = irctcService.username;
				} else {
					bookTicketSearchdVm.username = "Menu";
					irctcService.userLinkedStatus = false;
				}
				bookTicketSearchdVm.showManageInfo = irctcService.userLinkedStatus;
			} else {
				if(irctcService.pushNotificationData){
					bookTicketSearchdVm.enterSourseStation = irctcService.pushNotificationData.fromStn;
					bookTicketSearchdVm.enterDestinationStation = irctcService.pushNotificationData.toStn;
					bookTicketSearchdVm.scheduleDate = irctcService.pushNotificationData.journeyDate;
					irctcService.searchDate = new Date(irctcService.pushNotificationData.journeyDate);

				}
				bookTicketSearchdVm.loadIRCTCMasters()
			}
		});

       		
       		bookTicketSearchdVm.exchangeStations = function(){
       			var temp = bookTicketSearchdVm.enterSourseStation;
       			var fromStation = bookTicketSearchdVm.enterDestinationStation;
	            bookTicketSearchdVm.enterDestinationStation = temp;
	            bookTicketSearchdVm.enterSourseStation = fromStation;
       		};

       		Date.prototype.addDays = function(days){
       			this.setDate(this.getDate() + parseInt(days));
       			return this;
       		};

			bookTicketSearchdVm.openDatePicker = function(){
				var newDate = new Date();
				var dateLimit = irctcService.masterData.timeLimit;
				var dateFromAPI = newDate.addDays(dateLimit);
				bookTicketSearchdVm.dateObj = {
					callback: function (val) {
		                    var tomorrow = new Date(val);
		                    tomorrow.setDate(tomorrow.getDate() + 1);
		                    irctcService.searchDate = val;
		                    bookTicketSearchdVm.scheduleDate = new Date(tomorrow).toISOString().slice(0,10);
						},
						inputDate: new Date(),
						monthsList:["JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC"],
						from: new Date(),
						to: dateFromAPI,
						mondayFirst: true,
						closeOnSelect: false,
						templateType: 'popup',
						dateFormat: 'dd MMM yyyy'
				};
				ionicDatePicker.openDatePicker(bookTicketSearchdVm.dateObj);
			};
            
		bookTicketSearchdVm.searchTrains = function () {
			var fromStation = bookTicketSearchdVm.enterSourseStation;
			var toStation = bookTicketSearchdVm.enterDestinationStation;
			var jClass = bookTicketSearchdVm.selectedClass;
			var jQuota = bookTicketSearchdVm.selectedQuota;
			var dateString = bookTicketSearchdVm.scheduleDate;
			var jDate = dateString.replace(/-/g, "");
			fromStation = fromStation.toUpperCase();
			toStation = toStation.toUpperCase();
			irctcService.sourceStation = fromStation;
			irctcService.destStation = toStation;
			irctcService.searchQuota = jQuota;
			irctcService.timeinterval = undefined;
			var searchTrainObj = {
				"fromStation": fromStation,
				"toStation": toStation,
				"journeyDate": jDate,
				"journeyClass": jClass,
				"quota": jQuota
			};
			irctcService.searchTrainObj = searchTrainObj;
			irctcService.displayDate = bookTicketSearchdVm.scheduleDate;
			bookTicketSearchdVm.callSearchTranApi(searchTrainObj);
			
			
		};

        //Search Train Service
        bookTicketSearchdVm.onQuotaListChangeEvent= function(){
			var jQuota = bookTicketSearchdVm.selectedQuota;
			if (jQuota === 'SS') {
				var msg=irctcService.masterData.messageSSQuota ? irctcService.masterData.messageSSQuota : '';
				var ssQuotaPopup = $ionicPopup.show({
					title: null,
					cssClass: 'my-custom-popup roboto-regular font-size-14 color-darkgrey text-center ssQuota',
					template: msg,
					buttons: [{
						text: 'No',
						type: 'button-assertive',
						onTap: function () {
							bookTicketSearchdVm.selectedQuota = $scope.previousSelectedQuota;
							ssQuotaPopup.close();
						}
					},
					{
						text: 'Yes',
						type: 'button-positive',
						onTap: function () {
							$scope.previousSelectedQuota = bookTicketSearchdVm.selectedQuota;
							ssQuotaPopup.close();
							
						}
					}],
				});
			}else{
				$scope.previousSelectedQuota = bookTicketSearchdVm.selectedQuota;
			}
		}

		bookTicketSearchdVm.callSearchTranApi = function(searchTrainObj){
			irctcService.getTrainList(searchTrainObj).then(function (data) {
				irctcService.trainListData = data.trainBtwnStnsList;
				$state.go('menu.irctcBookTicketSearchResult');
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		}
 
		bookTicketSearchdVm.createIRCTCAccount = function () {
			cordova.ThemeableBrowser.open(irctcService.createIRCTCURL, '_system');
		};

		bookTicketSearchdVm.bookingHistory = function () {
			irctcService.selTab = "Y";
			$state.go('menu.bookingHistory');
		};
		bookTicketSearchdVm.bookingInvoiceList = function () {
			$state.go('menu.taxInvoiceList');
		};
		return this;
	}
]);
