'use strict';
angularApp.controller('bookTicketSearchModifyController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
        "irctcService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker,$ionicSideMenuDelegate,irctcService) {
			var bookTicketSearchModifyVm = this;
			bookTicketSearchModifyVm.trainQuota = [];
			bookTicketSearchModifyVm.switchAfternoon = function(){
				bookTicketSearchModifyVm.afternoon = !bookTicketSearchModifyVm.afternoon;
			}

			bookTicketSearchModifyVm.switchMorning = function(){
				bookTicketSearchModifyVm.morning = !bookTicketSearchModifyVm.morning;
			}

			bookTicketSearchModifyVm.switchEvening = function(){
				bookTicketSearchModifyVm.evening = !bookTicketSearchModifyVm.evening;
			}

			bookTicketSearchModifyVm.switchNight = function(){
				bookTicketSearchModifyVm.night = !bookTicketSearchModifyVm.night;
			}
			
			
			bookTicketSearchModifyVm.GoBack = function() {
					$ionicHistory.goBack(-1);
			};

			bookTicketSearchModifyVm.toggleMenu = function(){	
				bookTicketSearchModifyVm.menu = !bookTicketSearchModifyVm.menu;
			}

			bookTicketSearchModifyVm.autoSuggest = function(recState){
				if (recState == 'from') {
						bookTicketSearchModifyVm.hideListSource = false;
						bookTicketSearchModifyVm.filteredStationList = [];
					    angular.forEach(bookTicketSearchModifyVm.searchStations, function(stationObj) {
					      var index = stationObj.lastIndexOf(bookTicketSearchModifyVm.enterSourseStation.toUpperCase());
					      if(index != -1){
					        var filteredStationObj = {
					          "index" : stationObj.length - index,
					          "station" : stationObj
					        };
					        if(stationObj.indexOf(bookTicketSearchModifyVm.enterSourseStation.toUpperCase()) == 0){
					        	filteredStationObj = {
						          "index" : 0,
						          "station" : stationObj
						        };
					        }
					        bookTicketSearchModifyVm.filteredStationList.push(filteredStationObj);
					      }
					    });
				} else if (recState == 'to'){
					  bookTicketSearchModifyVm.hideListDestination = false;
					  bookTicketSearchModifyVm.filteredStationListTo = [];
					    angular.forEach(bookTicketSearchModifyVm.searchStations, function(stationObj) {
					      var index = stationObj.lastIndexOf(bookTicketSearchModifyVm.enterDestinationStation.toUpperCase());
					      if(index != -1){
					        var filteredStationObj = {
					          "index" : stationObj.length - index,
					          "station" : stationObj
					        };
					        if(stationObj.indexOf(bookTicketSearchModifyVm.enterDestinationStation.toUpperCase()) == 0){
					        	filteredStationObj = {
						          "index" : 0,
						          "station" : stationObj
						        };
					        }
					        bookTicketSearchModifyVm.filteredStationListTo.push(filteredStationObj);
					      }
					    });
				}

			};

			bookTicketSearchModifyVm.clearData=function(){
				bookTicketSearchModifyVm.afternoon=false;
				bookTicketSearchModifyVm.evening=false;
				bookTicketSearchModifyVm.morning = false;
				bookTicketSearchModifyVm.night = false;
				bookTicketSearchModifyVm.arrival = 'departureTime';
			}

			function filterdData(data){
                   var filterTrainList=[];
                   var sortFlag = bookTicketSearchModifyVm.arrival;
                   for(var i=0;i<data.length;i++){ 
                   	
                   	switch (sortFlag) {
                                case 'arrivalTime':
                                  if(bookTicketSearchModifyVm.morning){
			                   			if(data[i].arrivalTime > "00:00" && data[i].arrivalTime < "05:59"){
			                                filterTrainList.push(data[i]);
			                   			}
			                   		}
			                   		if(bookTicketSearchModifyVm.afternoon){
			                   			if(data[i].arrivalTime > "06:00" && data[i].arrivalTime < "11:59"){
			                                filterTrainList.push(data[i]);
			                   			}
			                   		}
			                   		if(bookTicketSearchModifyVm.evening){
			                   			if(data[i].arrivalTime > "12:00" && data[i].arrivalTime < "17:59"){
			                                filterTrainList.push(data[i]);
			                   			}
			                   		}
			                   		if(bookTicketSearchModifyVm.night){
			                   			if(data[i].arrivalTime > "18:00" && data[i].arrivalTime < "23:59"){
			                                filterTrainList.push(data[i]);
			                   			}
			                   		}
                                    break;
                                case 'departureTime':
                                  if(bookTicketSearchModifyVm.morning){
			                   			if(data[i].departureTime > "00:00" && data[i].departureTime < "05:59"){
			                                filterTrainList.push(data[i]);
			                   			}
			                   		}
			                   		if(bookTicketSearchModifyVm.afternoon){
			                   			if(data[i].departureTime > "06:00" && data[i].departureTime < "11:59"){
			                                filterTrainList.push(data[i]);
			                   			}
			                   		}
			                   		if(bookTicketSearchModifyVm.evening){
			                   			if(data[i].departureTime > "12:00" && data[i].departureTime < "17:59"){
			                                filterTrainList.push(data[i]);
			                   			}
			                   		}
			                   		if(bookTicketSearchModifyVm.night){
			                   			if(data[i].departureTime > "18:00" && data[i].departureTime < "23:59"){
			                                filterTrainList.push(data[i]);
			                   			}
			                   		}
                                    break;
                                default: break;
                            }
                   }
                 return filterTrainList;
			}

			bookTicketSearchModifyVm.gotoStationSearchResult = function (selectedStation,recState){
				if (recState == 'from') {
						bookTicketSearchModifyVm.hideListSource = true;
						bookTicketSearchModifyVm.enterSourseStation = selectedStation.station;
				} else if (recState == 'to'){
					bookTicketSearchModifyVm.enterDestinationStation = selectedStation.station;
					  bookTicketSearchModifyVm.hideListDestination = true;
				}
			};
            
            bookTicketSearchModifyVm.loadIRCTCMasters = function(){
                irctcService.getStationMaster().then(function (data) {
                    irctcService.masterData=data;
                    bookTicketSearchModifyVm.trainClass = data.trainClass;
                    bookTicketSearchModifyVm.quotaList = data.trainQuota;
                    bookTicketSearchModifyVm.selectedQuota = bookTicketSearchModifyVm.quotaList[0].key;
                    bookTicketSearchModifyVm.selectedClass = bookTicketSearchModifyVm.trainClass[0].key;
                    bookTicketSearchModifyVm.searchStations = data.trainStation;
                    if(data.username){
                    	irctcService.userLinkedStatus = true;
                    	irctcService.username=data.username;
                    	bookTicketSearchModifyVm.username = data.username;
                    }else{
                    	bookTicketSearchModifyVm.username = "Menu";
                    	irctcService.userLinkedStatus = false;
                    }
                    bookTicketSearchModifyVm.showManageInfo = irctcService.userLinkedStatus;
                    
                },function(error){
                	utilityService.showErrorMessage(error.responseMessage);
                });
            }
                                                     
			$scope.$on('$ionicView.beforeEnter', function () {
	        	//Load IRCTC Masters & Station List
	          bookTicketSearchModifyVm.hideListSource=true;
	          bookTicketSearchModifyVm.hideListDestination=true;
	          if(!irctcService.filterTime){
	          	bookTicketSearchModifyVm.arrival = 'departureTime';
	          }else{
	          	bookTicketSearchModifyVm.arrival = irctcService.filterTime;
	          }
	            if(irctcService.afternoonFlag){
					bookTicketSearchModifyVm.afternoon=true;
				}
				if(irctcService.eveningFlag){
					bookTicketSearchModifyVm.evening=true;
				}
				if(irctcService.morningFlag){
					bookTicketSearchModifyVm.morning=true;
				}
				if(irctcService.nightFlag){
					bookTicketSearchModifyVm.night=true;
				}
	           if(irctcService.username){
                    	irctcService.userLinkedStatus = true;
                    	bookTicketSearchModifyVm.username = irctcService.username;
                    }else{
                    	bookTicketSearchModifyVm.username = "Menu";
                    	irctcService.userLinkedStatus = false;
                    }
	           if(irctcService.searchTrainObj){
		          bookTicketSearchModifyVm.searchStations = irctcService.masterData.trainStation;
	              bookTicketSearchModifyVm.enterSourseStation=  irctcService.searchTrainObj.fromStation;
	              bookTicketSearchModifyVm.enterDestinationStation=irctcService.searchTrainObj.toStation;
	              bookTicketSearchModifyVm.scheduleDate= irctcService.displayDate;
	              bookTicketSearchModifyVm.quotaList=irctcService.masterData.trainQuota;
	              bookTicketSearchModifyVm.trainClass=irctcService.masterData.trainClass;
	              bookTicketSearchModifyVm.selectedClass= irctcService.searchTrainObj.journeyClass;
	              bookTicketSearchModifyVm.selectedQuota= irctcService.searchTrainObj.quota;
				$scope.previousSelectedQuota = irctcService.searchTrainObj.quota;

			} 

		});

       		
       		bookTicketSearchModifyVm.exchangeStations = function(){
       			var temp = bookTicketSearchModifyVm.enterSourseStation;
       			var fromStation = bookTicketSearchModifyVm.enterDestinationStation;
	            bookTicketSearchModifyVm.enterDestinationStation = temp;
	            bookTicketSearchModifyVm.enterSourseStation = fromStation;
       		};

       		Date.prototype.addDays = function(days){
       			this.setDate(this.getDate() + parseInt(days));
       			return this;
       		};

			bookTicketSearchModifyVm.openDatePicker = function(){
				var newDate = new Date();
				var dateLimit = irctcService.masterData.timeLimit;
				var dateFromAPI = newDate.addDays(dateLimit);
				bookTicketSearchModifyVm.dateObj = {
					callback: function (val) {
		                    var tomorrow = new Date(val);
		                    tomorrow.setDate(tomorrow.getDate() + 1);
		                    irctcService.searchDate = val;
		                    bookTicketSearchModifyVm.scheduleDate = new Date(tomorrow).toISOString().slice(0,10);
						},
						inputDate: new Date(),
						from: new Date(),
						to: dateFromAPI,
						mondayFirst: true,
						closeOnSelect: false,
						templateType: 'popup',
						dateFormat: 'dd MMM yyyy'

				};

				ionicDatePicker.openDatePicker(bookTicketSearchModifyVm.dateObj);
			}
            
		bookTicketSearchModifyVm.apply = function () {
			var fromStation = bookTicketSearchModifyVm.enterSourseStation;
			var toStation = bookTicketSearchModifyVm.enterDestinationStation;
			var jClass = bookTicketSearchModifyVm.selectedClass;
			var jQuota = bookTicketSearchModifyVm.selectedQuota;
			var dateString = bookTicketSearchModifyVm.scheduleDate;
			var jDate = dateString.replace(/-/g, "");
			irctcService.sourceStation = fromStation;
			irctcService.destStation = toStation;
			irctcService.searchQuota = jQuota;

			var searchTrainObj = {
				"fromStation": fromStation,
				"toStation": toStation,
				"journeyDate": jDate,
				"journeyClass": jClass,
				"quota": jQuota
			};
			irctcService.searchTrainObj = searchTrainObj;
			irctcService.displayDate = bookTicketSearchModifyVm.scheduleDate;
			bookTicketSearchModifyVm.callSearchTranApi(searchTrainObj);
			
		}

        //Serach Train Service
		bookTicketSearchModifyVm.onQuotaListChangeEvent= function(){
			var jQuota = bookTicketSearchModifyVm.selectedQuota;
			if (jQuota === 'SS') {
				var msg=irctcService.masterData.messageSSQuota ? irctcService.masterData.messageSSQuota : '';
				var ssQuotaPopup = $ionicPopup.show({
					title: null,
					cssClass: 'my-custom-popup roboto-regular font-size-14 color-darkgrey text-center ssQuota',
					template: msg,
					buttons: [{
						text: 'No',
						type: 'button-assertive',
						onTap: function () {
							bookTicketSearchModifyVm.selectedQuota = $scope.previousSelectedQuota;
							ssQuotaPopup.close();
						}
					},
					{
						text: 'Yes',
						type: 'button-assertive',
						onTap: function () {
							$scope.previousSelectedQuota=bookTicketSearchModifyVm.selectedQuota ;
							ssQuotaPopup.close();
							
						}
					}],
				});
			}else{
				$scope.previousSelectedQuota=bookTicketSearchModifyVm.selectedQuota ;
			}
		}
		bookTicketSearchModifyVm.callSearchTranApi = function (searchTrainObj) {
			irctcService.getTrainList(searchTrainObj).then(function (data) {
				irctcService.trainListData = data.trainBtwnStnsList;
				irctcService.trainListData = filterdData(irctcService.trainListData);
				if (irctcService.trainListData.length == 0) {
					irctcService.trainListData = data.trainBtwnStnsList;
				}
				$state.go('menu.irctcBookTicketSearchResult');
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
			irctcService.afternoonFlag = bookTicketSearchModifyVm.afternoon;
			irctcService.eveningFlag = bookTicketSearchModifyVm.evening;
			irctcService.morningFlag = bookTicketSearchModifyVm.morning;
			irctcService.nightFlag = bookTicketSearchModifyVm.night;
			irctcService.filterTime = bookTicketSearchModifyVm.arrival;
		}

		return this;
	}
]);
