'use strict';
angularApp.controller('bookTicketSearchResultController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"$timeout",
		"$ionicSideMenuDelegate",
        "$window","irctcService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, $timeout,$ionicSideMenuDelegate,$window,irctcService) {
			var bookTicketSearchdResultVm = this;
			 bookTicketSearchdResultVm.showCollapse = true;
			 bookTicketSearchdResultVm.testFlag = true;
            bookTicketSearchdResultVm.arrivalTimeSort="asc";
             bookTicketSearchdResultVm.departureTimeSort="asc";
              bookTicketSearchdResultVm.durationSort="asc";
			
			bookTicketSearchdResultVm.submitClass = function (selectedClass,selTrain) {
				var searchTrainObj = {
				    "trainNo":selTrain.trainNumber,
                   "fromStation":selTrain.fromStnCode,
                   "toStation":selTrain.toStnCode,
                   "journeyDate":irctcService.searchTrainObj.journeyDate,
                   "journeyClass":selectedClass,
                   "quota":irctcService.searchTrainObj.quota
                   };

				irctcService.getTrainFare(searchTrainObj).then(function (data) {
                   for(var i=0;i<bookTicketSearchdResultVm.trainBtwnStnsList.length;i++){
                   	if(bookTicketSearchdResultVm.trainBtwnStnsList[i].trainNumber==selTrain.trainNumber){
                   		bookTicketSearchdResultVm.trainBtwnStnsList[i].avlFareEnq=data;
                   		break;
                   	}
                   }
                    },function(error){
                        utilityService.showErrorMessage(error.responseMessage);
                 });
			};
             
            bookTicketSearchdResultVm.GoBack = function() {
                 $ionicHistory.goBack(-1);
            };

            bookTicketSearchdResultVm.modifySearch = function() {
                 $state.go('menu.irctcBookTicketSearchModify');
            };

			bookTicketSearchdResultVm.toggleGroup = function(index) {	
				bookTicketSearchdResultVm.trainBtwnStnsList[index].showNextDayAvailibility=!bookTicketSearchdResultVm.trainBtwnStnsList[index].showNextDayAvailibility;
			};


			bookTicketSearchdResultVm.filterList = function(selectedFilter){
				if(selectedFilter == 1){
					bookTicketSearchdResultVm.testFlag = 1;
				if(bookTicketSearchdResultVm.arrivalTimeSort=="asc"){
					 bookTicketSearchdResultVm.filterFlag = '-departureTime';
					 bookTicketSearchdResultVm.arrivalTimeSort="desc";
				}
				else{
					 bookTicketSearchdResultVm.filterFlag = 'departureTime';
					  bookTicketSearchdResultVm.arrivalTimeSort="asc";
				}  
			}
			else if(selectedFilter == 2){
					bookTicketSearchdResultVm.testFlag = 2;
				if(bookTicketSearchdResultVm.departureTimeSort=="asc"){
					 bookTicketSearchdResultVm.filterFlag = '-arrivalTime';
					 bookTicketSearchdResultVm.departureTimeSort="desc";
				}
				else{
					 bookTicketSearchdResultVm.filterFlag = 'arrivalTime';
					 bookTicketSearchdResultVm.departureTimeSort="asc";
				}
			}
			else if(selectedFilter == 3){
					bookTicketSearchdResultVm.testFlag = 3;
			    if(bookTicketSearchdResultVm.durationSort=="asc"){
					 bookTicketSearchdResultVm.filterFlag = '-sequence';
					 bookTicketSearchdResultVm.durationSort="desc";
				}
				else{
					 bookTicketSearchdResultVm.filterFlag = 'sequence';
					 bookTicketSearchdResultVm.durationSort="asc";
				} 
				}
			};

            bookTicketSearchdResultVm.viewTrainRoute = function(trainNo,selTrain){
                irctcService.selectedTrainData = selTrain;
                irctcService.getTrainRoute(trainNo).then(function (data) {
                    irctcService.viewRouteData = data;
                    $state.go('menu.irctcViewRoute');
                    },function(error){
                        utilityService.showErrorMessage(error.responseMessage);
                 });
            };

           bookTicketSearchdResultVm.cancel=function(){
           	bookTicketSearchdResultVm.popUP.close();
           };

           bookTicketSearchdResultVm.continue=function(){
           	bookTicketSearchdResultVm.popUP.close();
           		if(irctcService.username){
                  $state.go('menu.travellerMyList');
				}else{		
			      $state.go('menu.authenticateIRCTCUser');
                }   
           };

            bookTicketSearchdResultVm.toggleMenu = function(){
				bookTicketSearchdResultVm.menu = !bookTicketSearchdResultVm.menu;
			};

            bookTicketSearchdResultVm.bookNow = function(selTrain,date,index){
			var srcStnSearch = '';
			var destStnSearch = '';
			if (irctcService.searchTrainObj.fromStation.indexOf('(') != -1)
				srcStnSearch = irctcService.searchTrainObj.fromStation.split('(')[1].split(')')[0];
			else
				srcStnSearch = irctcService.searchTrainObj.fromStation;
			if (irctcService.searchTrainObj.toStation.indexOf('(') != -1)
				destStnSearch = irctcService.searchTrainObj.toStation.split('(')[1].split(')')[0];
			else
				destStnSearch = irctcService.searchTrainObj.toStation;
				
            	var srcStn = selTrain.fromStnCode;
            	var destStn = selTrain.toStnCode;

            	if(irctcService.searchTrainObj.quota == 'PT' || irctcService.searchTrainObj.quota == 'TQ'){
            		irctcService.maxPassCount = 4;
            	}else{
            		irctcService.maxPassCount = 6;
            	}
            	
            	if(srcStnSearch == srcStn && destStnSearch == destStn){
            		bookTicketSearchdResultVm.confirmBookNow(selTrain,date,index);
            	}else{
            		 var confirmMsg = '<p>You have searched trains for </p><p class="roboto-medium">'+ irctcService.searchTrainObj.fromStation + ' to '+ irctcService.searchTrainObj.toStation + '.</p><p>But you are booking in a train between </p><p class="roboto-medium">'+ srcStn +' and '+ destStn +'.</p><br/>Do you want to countinue?</p>';

      				var backPopup = $ionicPopup.show({
						title: null,
						cssClass: 'my-custom-popup roboto-regular font-size-14 color-darkgrey text-center',
						template: confirmMsg,
						buttons: [{
							text: 'No',
							type: 'button-assertive',
							onTap: function () {
								backPopup.close();
							}
						},
						{
							text: 'Yes',
							type: 'button-assertive',
							onTap: function () {
								bookTicketSearchdResultVm.confirmBookNow(selTrain,date,index);
							}
						}],
					});
            	}
            };

            bookTicketSearchdResultVm.confirmBookNow = function(selTrain,date,index){
            	if(index!=0){
	            	irctcService.myList = "";
	            	irctcService.totalTravellers="";
	            	irctcService.stationCodeArray = "";
	            	irctcService.stationNameArray = "";
	            	irctcService.infantArray=[];
	            	irctcService.passArray=[];
	            	 irctcService.selectedTrainData={};
	            	 irctcService.boardingStations="";
					irctcService.destinationAddress=""; // Destination address 
	            	var currentQuota = irctcService.searchQuota;
	            	irctcService.searchQuotaVal = irctcService.getArrayElement(currentQuota,irctcService.masterData.trainQuota,'myValue');
	            	
	            	if(!index){
	                   index=0;
	            	}
	            	if(date){
	            		irctcService.searchDate=date;
	            	}
					irctcService.selectedTrainData = selTrain;

				   if(irctcService.selectedTrainData.avlFareEnq.bkgCfg.seniorCitizenApplicable=="false"){
				      irctcService.showSeniorFlag=true;
				   }
					irctcService.selectedTrainData.boardingPoint="";
					var trainType = selTrain.trainTypes;
					var availablityType=selTrain.avlFareEnq.avlDayList[index].reasonType;
					var availabilityStatus=selTrain.avlFareEnq.avlDayList[index].availablityStatus;
					var availabilityStatusType=selTrain.avlFareEnq.avlDayList[index].availablityType;
	                   irctcService.availabilityStatus=availabilityStatus;
	                   irctcService.availabilityStatusType = availabilityStatusType;
					  if(availablityType.toLowerCase()=="w"){
	                        utilityService.showErrorMessage("Booking not allowed for this train");
					  }
					  else{
					  	for (var i =0;i<trainType.length;i++) {
					  		if (trainType[i] == 'R' || trainType[i] == 'D'){ 
								bookTicketSearchdResultVm.popUP = $ionicPopup.show({
									title: '',
									cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter ftpopup-body',
									templateUrl: 'pages/irctc/bookTicketResult/dynamicPricePopup.html',
									scope: $scope
								});
								return;
							}
							else{
								if(irctcService.username){
				                  $state.go('menu.travellerMyList');
								}else{		
							      $state.go('menu.authenticateIRCTCUser');
				                }
							}
					  	}
					}
				}
            };                                      
                                                           
			$scope.$on('$ionicView.afterEnter', function() {
				 if(irctcService.username){
                    	irctcService.userLinkedStatus = true;
                    	bookTicketSearchdResultVm.username = irctcService.username;
                    }else{
                    	bookTicketSearchdResultVm.username = "Menu";
                    	irctcService.userLinkedStatus = false;
                    }
                       bookTicketSearchdResultVm.showManageInfo = irctcService.userLinkedStatus;
				        bookTicketSearchdResultVm.trainBtwnStnsList = irctcService.trainListData;
				        for(var i=0;i<bookTicketSearchdResultVm.trainBtwnStnsList;i++){
				        	bookTicketSearchdResultVm.trainBtwnStnsList[i].showNextDayAvailibility=false;
				        }
						bookTicketSearchdResultVm.sourceStation = irctcService.sourceStation;
						bookTicketSearchdResultVm.destnStation = irctcService.destStation;
						var totalTrainFound = bookTicketSearchdResultVm.trainBtwnStnsList.length;
                        bookTicketSearchdResultVm.journeyDate = irctcService.searchDate;
						bookTicketSearchdResultVm.totalTrains =  " ("+totalTrainFound + " Trains found)";
			});

			$scope.$on('$ionicView.beforeEnter', function() {
                       bookTicketSearchdResultVm.testFlag = 3;
                       bookTicketSearchdResultVm.filterFlag = 'sequence';
			});
			return this;
		}
]);
