'use strict';
angularApp.controller('bookingFlowController', [
    "$state",
    "$scope",
    "$ionicPopup",
    "$translate",
    "$ionicHistory",
    "utilityService",
    "ionicDatePicker",
    "$ionicSideMenuDelegate",
    "irctcService",
    function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, irctcService) {
        var bookingFlowVm = this;
        bookingFlowVm.goBacktoPrevious = function() {
            $ionicHistory.goBack(-1);
        }
        bookingFlowVm.goToNextPage = function() {
            irctcService.settimerData('');
        if(irctcService.preBookingObj && Object.keys(irctcService.preBookingObj).length > 0){
            irctcService.preBooking(irctcService.preBookingObj).then(function (data) {
                irctcService.reviewDetails = data;
                irctcService.accList = data.accounts;
                irctcService.availabilityStatus = data.avlDayList[0].availablityStatus;
                $state.go('menu.ticketReview');
                
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
            
            //$state.go('menu.travellerContactDetails');
        }
        /** Function to reset mobile number starts **/
        $scope.openForgotPasswordPopup = function() {
            var elem = document.querySelector(".popup-open");
            if (elem) {
                return false;
            }
            $scope.resetMobileNo="";
            $scope.resetPwdSuccessMsg="";
            $scope.invalidMobileMsg="";
            $scope.resetSuccessDiv=false;

            bookingFlowVm.resetPasswordPopup = $ionicPopup.show({
                templateUrl: "pages/irctc/bookingFlow/resetPasswordPopup.html",
                scope: $scope,
                cssClass: 'reset-password-popup'
            });               
        }
        $scope.closePopup = function () {
            bookingFlowVm.resetPasswordPopup.close();
        }
        $scope.validateMobileNumber = function (mobileNo) {
            $scope.resetMobileNo=mobileNo;
            $scope.resetPwdSuccessMsg="";
            $scope.invalidMobileMsg="";
            $scope.resetSuccessDiv=false;
            var errMsg = irctcService.isValidMobileNo($scope.resetMobileNo);
            if(!errMsg){
                var requestParam=  {
                    "mobile": $scope.resetMobileNo,  
                    "paymentType":"PRE",
                    "returnBooking":"N" 
                  }
                  irctcService.resetPassword(requestParam).then(function (response) {
                  
                   if(response.responseCode=='0000'){
                        bookingFlowVm.resetPasswordPopup.close();
                        $scope.resetSuccessDiv=true;
                        $scope.resetPwdSuccessMsg= response.responseMessage ? response.responseMessage : '';
                   }
                  
                }, function (error) {
                    $scope.invalidMobileMsg= error.responseMessage ? error.responseMessage : '';
                   
                });
            }else{
                $scope.invalidMobileMsg=$scope.mobileError1;
              
            }
            
        }
        
        /** Function to reset mobile number ends **/

        bookingFlowVm.forgotPassword = function() {
            cordova.ThemeableBrowser.open(irctcService.forgotPasswordURL, '_system');               
        }
        bookingFlowVm.toggleMenu = function() {
            bookingFlowVm.menu = !bookingFlowVm.menu;
        }
        
        $scope.$on('$ionicView.beforeEnter', function() {
            bookingFlowVm.disableback = false;
            bookingFlowVm.disablenext = false;
            bookingFlowVm.showBack = true;
            bookingFlowVm.showNext = true;
            $scope.resetSuccessDiv=false;
            bookingFlowVm.isUserIDLinked = !irctcService.userLinkedStatus;
            if (irctcService.username) {
                irctcService.userLinkedStatus = true;
                bookingFlowVm.username = irctcService.username;
                bookingFlowVm.userName = irctcService.username;
            } else {
                bookingFlowVm.username = "Menu";
                bookingFlowVm.userLinkedStatus = false;
                bookingFlowVm.userName = "";
            }
            bookingFlowVm.showManageInfo = irctcService.userLinkedStatus;

            $translate(['IRCTC_RESET_MOBILE_ERROR1','IRCTC_RESET_MOBILE_ERROR2']).then(function (translations) {
                $scope.mobileError1 = translations['IRCTC_RESET_MOBILE_ERROR1'];
                $scope.mobileError2 =  translations['IRCTC_RESET_MOBILE_ERROR2'];
            });
            
        });

        return this;
    }
]);
