'use strict';
angularApp.controller('bookingCancelController', [
	"$state",
	"$scope",
	"$ionicPopup",
	"$translate",
	"$ionicHistory",
	"utilityService",
	"ionicDatePicker",
	"$ionicSideMenuDelegate",
	"irctcService",
	function ($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, irctcService) {
		var bookingCancelVm = this;


		bookingCancelVm.goBack = function () {
			$ionicHistory.goBack(-1);
		}

		bookingCancelVm.toggleMenu = function () {

			bookingCancelVm.menu = !bookingCancelVm.menu;
		}

		bookingCancelVm.goToNextPage = function () {

			bookingCancelVm.popUP = $ionicPopup.show({
				title: '',
				cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter ftpopup-body',
				templateUrl: 'pages/irctc/bookingHistory/CancelConfirmPopup.html',
				scope: $scope
			});

		}



		bookingCancelVm.continue = function () {
			bookingCancelVm.popUP.close();
			bookingCancelVm.cancellationList = [];
			bookingCancelVm.historyDetails.bookingResponseList.cancelledPsgn = [];
			for (var i = 0; i < bookingCancelVm.passengerList.length; i++) {

				if (bookingCancelVm.passengerList[i].checked) {
					bookingCancelVm.cancellationList.push(bookingCancelVm.passengerList[i].passengerSerialNumber);
					bookingCancelVm.historyDetails.bookingResponseList.cancelledPsgn.push(bookingCancelVm.passengerList[i]);
				}

			}
			irctcService.bookHistoryDetail = bookingCancelVm.historyDetails;
			var psgnCancelArray = bookingCancelVm.cancellationList;
			var psgnTokenString = '';
			for (var i = 0; i < psgnCancelArray.length; i++) {
				psgnTokenString = psgnTokenString + psgnCancelArray[i];
			}


			var cancelObj = {
				"transactionId": irctcService.bookHistoryDetail.transID,
				"psgnToken": psgnTokenString,
				"reservationId": irctcService.bookHistoryDetail.resvID,
				"icrctUserId": irctcService.bookHistoryDetail.icrctUserId
			}


			//call cancel service
			irctcService.cancelTicket1(cancelObj).then(function (data) {
				irctcService.cancelTicket = data;
				$state.go('menu.bookingCancelStatus');
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});

		}

		bookingCancelVm.cancel = function () {
			bookingCancelVm.popUP.close();

		}

		bookingCancelVm.checkCancelStatus = function (index) {
			for (var i = 0; i < bookingCancelVm.passengerList.length; i++) {
				if (bookingCancelVm.passengerList[i].checked) {
					
					if(index==i)
				{
					bookingCancelVm.noOfChecked++;
				}



				} else {
					
					
						if(index==i)
				{
					bookingCancelVm.noOfChecked--;
				}

				}
			}

			if(bookingCancelVm.noOfChecked==bookingCancelVm.passengerList.length)
			{
             bookingCancelVm.selectAllData=true;
			}

			else
			{
				bookingCancelVm.selectAllData=false;

			}
			if(bookingCancelVm.noOfChecked>0)
			{
				bookingCancelVm.isNextEnabled = false;
			}
			else
			{
				bookingCancelVm.isNextEnabled = true;
			}
		}


		$scope.$on('$ionicView.beforeLeave', function () {

		});

		$scope.$on('$ionicView.afterEnter', function () {

		});

		bookingCancelVm.selectAll = function () {
			if (bookingCancelVm.selectAllData) {
				for (var i = 0; i < bookingCancelVm.passengerList.length; i++) {
					bookingCancelVm.passengerList[i].checked = true;
                  
				}
				 bookingCancelVm.noOfChecked=bookingCancelVm.passengerList.length;
				bookingCancelVm.isNextEnabled = false;

			} else {
				for (var i = 0; i < bookingCancelVm.passengerList.length; i++) {
					bookingCancelVm.passengerList[i].checked = false;
				

				}
				bookingCancelVm.noOfChecked=0;
				bookingCancelVm.isNextEnabled = true;
			}

		}

		$scope.$on('$ionicView.beforeEnter', function () {
			bookingCancelVm.isNextEnabled = true;
			bookingCancelVm.historyDetails = irctcService.bookHistoryDetail;
			bookingCancelVm.noOfChecked=0;

			bookingCancelVm.fromSTN = irctcService.bookHistoryDetail.fromStn;
			bookingCancelVm.toSTN = irctcService.bookHistoryDetail.toStn;

			bookingCancelVm.duration = irctcService.bookHistoryDetail.duration

			bookingCancelVm.passengerList1 = bookingCancelVm.historyDetails.bookingResponseList.psgnDtlList;
			//bookingCancelVm.historyDetails.bookingResponseList.psgnDtlList[0].checked = false;
            bookingCancelVm.passengerList=[];

			//passenger.checked
			for (var i = 0; i < bookingCancelVm.passengerList1.length; i++) {
			  bookingCancelVm.passengerList1[i].checked = false;
               if(bookingCancelVm.passengerList1[i].currentStatus !='CAN')
               {
				 bookingCancelVm.passengerList.push( bookingCancelVm.passengerList1[i]);
               }
				
			}

			if (irctcService.username) {
				irctcService.userLinkedStatus = true;
				bookingCancelVm.username = irctcService.username;
			} else {
				bookingCancelVm.username = "Menu";
				bookingCancelVm.userLinkedStatus = false;
			}
			bookingCancelVm.showManageInfo = irctcService.userLinkedStatus;

		});

		return this;
	}
]);
