'use strict';
angularApp.controller('bookingHistoryController', [
	"$state",
	"$scope",
	"$ionicPopup",
	"$translate",
	"$ionicHistory",
	"utilityService",
	"ionicDatePicker",
	"$ionicSideMenuDelegate",
	"irctcService",
	function ($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, irctcService) {
		var bookingHistoryVm = this;

		bookingHistoryVm.goBack = function () {
			irctcService.searchTrainObj = "";
			irctcService.myList = "";
			irctcService.masterData = "";
			irctcService.selectedTrainData = "";
			irctcService.myListFullData = "";
			irctcService.pushNotificationData = {};
			$state.go('menu.irctcBookTicketSearch');
		};

		bookingHistoryVm.goToDetail = function (history, transId, resvId, mobileNo, tdrNo, isPNR, fStation, tStation, totalTime, isBoardingChanged) {
			irctcService.bookHistoryDetail = [];
			history.inprogressMsg=irctcService.bookHistory.inprogressMsg;
			irctcService.bookHistoryDetail.history = history;
			irctcService.bookHistoryDetail.resvID = resvId;
			irctcService.bookHistoryDetail.transID = transId;
			irctcService.bookHistoryDetail.mobileNumber = mobileNo;
			irctcService.bookHistoryDetail.tdrNumber = tdrNo;
			irctcService.bookHistoryDetail.fromStn = fStation;
			irctcService.bookHistoryDetail.toStn = tStation;
			irctcService.bookHistoryDetail.duration = history.totalTime;
			irctcService.bookHistoryDetail.isBoardingChanged = history.boardingChanged;
			irctcService.bookHistoryDetail.icrctUserId = history.icrctUserId;
			if (history.upcoming != 'A' && history.upcoming != 'I') {
				irctcService.getBookingHistoryDetail(transId).then(function (data) {
					irctcService.bookHistoryDetail.bookingResponseList = data.bookingResponseList;
					if (isPNR == 'PNR') {
						irctcService.bookHistoryDetail.pnrPageInfo = true;
					} else {
						irctcService.bookHistoryDetail.pnrPageInfo = false;
					}
					$state.go('menu.bookingHistoryDetail');
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			} else {
				$state.go('menu.bookingHistoryDetail');
			}
		};

		bookingHistoryVm.selType = function (bookingCategory) {
			bookingHistoryVm.selTab = bookingCategory;
			irctcService.selTab = bookingHistoryVm.selTab;
		};

		bookingHistoryVm.toggleMenu = function () {
			bookingHistoryVm.menu = !bookingHistoryVm.menu;
		};

		$scope.$on('$ionicView.beforeEnter', function () {

			bookingHistoryVm.selTab = 'Y';
			if (irctcService.username) {
				irctcService.userLinkedStatus = true;
				bookingHistoryVm.username = irctcService.username;
			} else {
				bookingHistoryVm.username = "Menu";
				bookingHistoryVm.userLinkedStatus = false;
			}
			bookingHistoryVm.showManageInfo = irctcService.userLinkedStatus;
			bookingHistoryVm.isUserIDLinked = irctcService.userLinkedStatus;

			if (irctcService.userLinkedStatus) {
				bookingHistoryVm.callBookingHistoryFnc();
			}
		});

		bookingHistoryVm.callBookingHistoryFnc = function () {
			irctcService.getBookingHistory().then(function (response) {
				var data=response.data;
				irctcService.bookHistory =data;
				irctcService.bookHistory.inprogressMsg= response.inprogressMsg ? response.inprogressMsg : '' ;

				if (data) {
					bookingHistoryVm.historyData = irctcService.bookHistory;
					bookingHistoryVm.accTab = 1;
					bookingHistoryVm.selTab = 'Y';
					if (irctcService.selTab) {
						bookingHistoryVm.selTab = irctcService.selTab;
					}

					bookingHistoryVm.upcomingCount = [];
					bookingHistoryVm.completedCount = [];
					bookingHistoryVm.cancelledCount = [];
					bookingHistoryVm.inProgressCount = [];
					bookingHistoryVm.discontinuedCount = [];
					angular.forEach(bookingHistoryVm.historyData, function (value, key) {
						if (value.upcoming == "Y") {
							bookingHistoryVm.upcomingCount.push(value);
						} else if (value.upcoming == "N") {
							bookingHistoryVm.completedCount.push(value);
						} else if (value.upcoming == "C") {
							bookingHistoryVm.cancelledCount.push(value);
						}else if (value.upcoming == "A" || value.upcoming == "I" || value.upcoming == "F" ) {
							if (value.booking.departureDate) {
								var d = value.booking.departureDate;
								var deptDate = d.substring(0, 4) + '/' + d.substring(4, 6) + '/' + d.substring(6, 8)
								value.booking.departureDate = new Date(deptDate);
								value.booking.bookingDate = new Date(value.booking.bookingDate);
							}
							if (value.upcoming == "I"){
								value.fromStName= value.booking.fromStn ? value.booking.fromStn : '';
								value.destStName=value.booking.destStn ? value.booking.destStn : '';
								bookingHistoryVm.inProgressCount.push(value);

							}else if (value.upcoming == "A" || value.upcoming == "F"){
								if (value.upcoming == 'F') {
									value.upcoming = 'A';
									value.originalUpcoming = 'F'
								} else {
									value.originalUpcoming = 'A';
								}
								bookingHistoryVm.discontinuedCount.push(value);
							}
							
						}
					})
					
				}

				for (var i = 0; i < bookingHistoryVm.upcomingCount.length; i++) {
					bookingHistoryVm.upcomingCount[i].indice = i + 1;
				}


				for (var k = 0; k < bookingHistoryVm.completedCount.length; k++) {
					bookingHistoryVm.completedCount[k].indice = k + 1;
				}


				for (var l = 0; l < bookingHistoryVm.cancelledCount.length; l++) {
					bookingHistoryVm.cancelledCount[l].indice = l + 1;
				}
				for (var n = 0; n < bookingHistoryVm.inProgressCount.length; n++) {
					bookingHistoryVm.inProgressCount[n].indice = n + 1;
				}
				
				for (var j = 0; j < bookingHistoryVm.discontinuedCount.length; j++) {
					bookingHistoryVm.discontinuedCount[j].indice = j + 1;
				}
				console.log('bookingHistoryVm 2--->', bookingHistoryVm);
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		}

		return this;
	}
]);
