'use strict';
angularApp.controller('bookingHistoryDetailController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
        "irctcService",
        "customerInfoService",
        "cardsService",
        "openUrlInAppbroswerService","ompMerchantsService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker,$ionicSideMenuDelegate,irctcService,customerInfoService,cardsService,openUrlInAppbroswerService,ompMerchantsService) {
			var bookingHistoryDetailVm = this;
			
			bookingHistoryDetailVm.goBack = function(){
				$ionicHistory.goBack(-1);
			};

			bookingHistoryDetailVm.cancelTicket = function(){
				$state.go('menu.bookingCancel');
			};

			bookingHistoryDetailVm.toggleMenu = function(){
		       bookingHistoryDetailVm.menu = !bookingHistoryDetailVm .menu;
		    };

		    bookingHistoryDetailVm.showInfoPopup = function () {
		      var havingMPINPrblmPopUp = $ionicPopup.show({
		        template: '<p translate="IRCTC_BRD_INFO"></p>',
		        title: '',
		        cssClass: 'dialog',
		        scope: $scope,
		        buttons: [{
		          text: 'OK',
		          type: 'button-positive'
		        }]
		      });
		    };

		    bookingHistoryDetailVm.boardingStationList = function (fromSTN,toSTN,jrnyDate,jrnyClass,trainNo,boardPoint) {
		    	irctcService.getBoardingPoint(fromSTN,toSTN,jrnyDate,jrnyClass,trainNo).then(function (data) {
		              	bookingHistoryDetailVm.boardingStations = data.boardingStationList;
		              	var selectedBoardingPoint ;
		              	for(var i = 0;i< bookingHistoryDetailVm.boardingStations.length;i++){
		              		var test = bookingHistoryDetailVm.boardingStations[i].stnNameCode;
		              		var splitStation = test.split("(");
		              		var codeSplit = splitStation[1].split(")");
		              		var code=codeSplit[0]
		              		if(code == boardPoint){
		              			selectedBoardingPoint = i;
		              			break;
		              		}
		              	}	              	
		                bookingHistoryDetailVm.boardingStation = bookingHistoryDetailVm.boardingStations[selectedBoardingPoint].stnNameCode;
			        },function(error){
			            utilityService.showErrorMessage(error.responseMessage);
		        });
		    };

		    bookingHistoryDetailVm.changeBoardingPoint = function(){
         		var updatedBoardingPoint = bookingHistoryDetailVm.boardingStation;
		        var pnr = bookingHistoryDetailVm.historyDetails.bookingResponseList.pnrNumber;
				var obj ={
				  "pnrNumber": pnr,
				  "boardingPointId": updatedBoardingPoint,
				  "resvId": irctcService.bookHistoryDetail.transID
				};

				var backPopup = $ionicPopup.show({
					title: null,
					cssClass: 'my-custom-popup',
					template: '<div class="button_fund fontSize-subHeading roboto-medium font-dark-grey" translate="IRCTC_BOARD_ALERT"></div>',
					buttons: [{
						text: 'No',
						type: 'button-assertive',
						onTap: function () {
							backPopup.close();
						}
					},
					{
						text: 'Yes',
						type: 'button-assertive',
						onTap: function () {
							irctcService.updateBoardingPoint(obj).then(function (data) {
				              	bookingHistoryDetailVm.boardingStation = updatedBoardingPoint;
				              	bookingHistoryDetailVm.isBoardingChanged = updatedBoardingPoint;
						        },function(error){
						            utilityService.showErrorMessage(error.responseMessage);
				        	});
							
						}
					}
				],
				});
		    };

		    bookingHistoryDetailVm.downloadTicket = function(isEmail,type){
				var recieptType="";
				bookingHistoryDetailVm.selTab=irctcService.selTab;
				if(type){
					recieptType=type;
				}else{
					if(irctcService.selTab=='C'){
	                  	recieptType="refund";
					}else{
						recieptType="ticket";
					}
			    }

				var obj = {
					"transactionId":irctcService.bookHistoryDetail.transID,
					"isEmail":isEmail,
					"type":recieptType
				};
				irctcService.getPDFTicket(obj).then(function (data) {
					if(!isEmail){
                        var filename =  data.fileName+'.pdf';
		            var content =  data.pdf;
					var contentType = "application/pdf";
					if(utilityService.isAndroidPlatform()){
						bookingHistoryDetailVm.android = true;
						bookingHistoryDetailVm.folderpath = cordova.file.externalRootDirectory;
					}
					if(utilityService.isIOSPlatform()){
						bookingHistoryDetailVm.folderpath = cordova.file.applicationDirectory;
					}
					irctcService.savebase64AsPDFNew(bookingHistoryDetailVm.folderpath,filename,content,contentType);
					if(utilityService.isIOSPlatform()){
					openUrlInAppbroswerService.openUrl("data:application/pdf;base64,"+content+"","");
					}
					if(bookingHistoryDetailVm.android) {
						if (device.version == 10) {
							bookingHistoryDetailVm.folderpath = cordova.file.externalDataDirectory;
						}
						var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="DOWNLOADFDRECEIPT" translate-values="{folderpath:bookingHistoryDetailVm.folderpath}"></div>';
			    			bookingHistoryDetailVm.downloadPopup = $ionicPopup.show({
			    				title: '',
			    				template: template,
			    				scope: $scope,
			    				cssClass: 'my-custom-popup',
			    				buttons: [{
			    					text:'OK',
			    					type: 'button-assertive',
			    					onTap: function() { 
			    						bookingHistoryDetailVm.downloadPopup.close();

			    					}
			    				}],
			    			});
					
					}
					bookingHistoryDetailVm.successPopup.close();
				} else {
                        	var alertPopup = $ionicPopup.alert({
								template: "<p style='text-align:center;font-weight:bold;font-size:16px'>Email and SMS has been sent successfully</p>"
							});
                        }
                    },function(error){
                        utilityService.showErrorMessage(error.responseMessage);
                });
			};	

			bookingHistoryDetailVm.emailSMSTicket = function(){
				var custMobileNumber = irctcService.bookHistoryDetail.mobileNumber;
				//show popup
				var popTemplate = '<div class="text-align-center font14 irctc-fromTo-txt roboto-medium" translate="IRCTC_EMAIL_TEXT"></div> \n\
						<hr class="irctc-fromTo-txt">\n\
                		<div class="text-align-center font14 irctc-fromTo-txt roboto-medium"><span translate="IRCTC_MOBILE_NO"></span><br><span>'+custMobileNumber+'</span></div>';
			            var alertObj = {
			                template: popTemplate,
			                cssClass: 'sbi-alert-popup',
			                buttons: [{
			                    text: 'Cancel',
			                    type: 'button-positive'
			                }, {
			                    text: 'Confirm',
			                    type: 'button-positive',
			                    onTap: function(e) {
			                        // Make service call for sending SMS via IRCTC
			                       bookingHistoryDetailVm.downloadTicket(true);
			                    }
			            }]
			          };
			cardsService.alertModal(alertObj, function (res) {});
			};

			bookingHistoryDetailVm.openTAndC=function(){
				ompMerchantsService.inAppBrowser("http://contents.irctc.co.in/en/term.html#Q3");
			};

			bookingHistoryDetailVm.optVikalp=function(){
				var popTemplate = '<div class="text-align-center font18 roboto-medium" translate="VIKALP_TNC"></div> \n\
                		<div class="text-align-center font16 roboto-regular" translate="VIKALP_PNR"></div> \n\ <br/> <div class="text-align-center font16 roboto-regular" ><a href="http://contents.irctc.co.in/en/vikalpTerms.html" style="color:#0095da;text-decoration:none;">Click here for more information</a></div> ' ;
			            var alertObj = {
			                template: popTemplate,
			                cssClass: 'sbi-alert-popup',
			                buttons: [{
			                    text: 'Decline',
			                    type: 'button-positive'
			                }, {
			                    text: 'Accept',
			                    type: 'button-positive',
			                    onTap: function(e) {
			                       	var obj = {
					"resvId":irctcService.bookHistoryDetail.transID
				}
				//opt vikalp
				irctcService.getVikalpTrainList(obj).then(function (data) {
					irctcService.vikalpTrainList=data;
					$state.go("menu.optVikalpTrainList");
                    },function(error){
                        utilityService.showErrorMessage(error.responseMessage);
                });
			}   
		}]
	}
			cardsService.alertModal(alertObj, function (res) {});
};

			bookingHistoryDetailVm.fileTDR = function(){
					$state.go("menu.tdrPassList");
			};

			bookingHistoryDetailVm.loadTDRTnC = function(){
				var reqParams = {};
	              reqParams.type = "tdrTnC";
	              irctcService.getTnC(reqParams).then(function(data) {
	              	irctcService.tdrTncData = data;
	              	$state.go("menu.tdrTnc");
	              }, function(error) {
	                  utilityService.showErrorMessage(error.responseMessage);
	              });
			};

		bookingHistoryDetailVm.paymentReceipt = function (type) {
			bookingHistoryDetailVm.downloadTicket(false, type)
		};

		bookingHistoryDetailVm.generateQrCode  = function (qrImage) {
			if(qrImage) {
				var alertPopup = $ionicPopup.alert({
					template: "<img class='qrCodeImg' src='data:image/png;base64, "+ qrImage +"' alt='QR CODE' />",
					cssClass: 'scan-qr-popup removePopup-head popupWidth90 popupMargin popupBackgroundWhite ss-popup irctc-exception',
						buttons: [{
							text: 'OK',
							type: 'button-positive',
							onTap: function (e) {
								var element = angular.element(document.querySelector(".backdrop"));
								if(element){
									element.removeClass('qrcode-scanner-backdrop');
								}
								alertPopup.close();
							}
						}]
				});
				var elem = angular.element(document.querySelector(".backdrop"));
				if(elem){
					elem.addClass('qrcode-scanner-backdrop');
				}
			}
		};

		$scope.$on('$ionicView.beforeEnter', function () {
			bookingHistoryDetailVm.historyDetails = irctcService.bookHistoryDetail;
			console.log('bookingHistoryDetailVm.historyDetails', bookingHistoryDetailVm.historyDetails);
			if (bookingHistoryDetailVm.historyDetails.bookingResponseList) {
				bookingHistoryDetailVm.passengerList = bookingHistoryDetailVm.historyDetails.bookingResponseList.psgnDtlList;
				if(bookingHistoryDetailVm.passengerList){
					if(bookingHistoryDetailVm.passengerList[0].currentStatus == 'CNF'){
						bookingHistoryDetailVm.isTicketCOnfirmed = false;
					}else{
						bookingHistoryDetailVm.isTicketCOnfirmed = true;
					}
				}
			}

			bookingHistoryDetailVm.selTab = irctcService.selTab;
			bookingHistoryDetailVm.fromSTN = irctcService.bookHistoryDetail.fromStn;
			bookingHistoryDetailVm.toSTN = irctcService.bookHistoryDetail.toStn;
			if (bookingHistoryDetailVm.historyDetails.bookingResponseList) {
				var fromSTN = bookingHistoryDetailVm.historyDetails.bookingResponseList.fromStn;
				var toSTN = bookingHistoryDetailVm.historyDetails.bookingResponseList.destStn;
				var jrnyClass = bookingHistoryDetailVm.historyDetails.bookingResponseList.journeyClass;
				var trainNo = bookingHistoryDetailVm.historyDetails.bookingResponseList.trainNumber;
				var boardPoint = bookingHistoryDetailVm.historyDetails.bookingResponseList.boardingStn;
				var jDate = bookingHistoryDetailVm.historyDetails.bookingResponseList.journeyDate.split("T");
				var jrnyDate = jDate[0].replace(/-/g, "");
			}
			bookingHistoryDetailVm.duration = irctcService.bookHistoryDetail.duration;
			bookingHistoryDetailVm.isBoardingChanged = irctcService.bookHistoryDetail.isBoardingChanged;

			var tdrCheck = irctcService.bookHistoryDetail.tdrNumber;
			if (!tdrCheck) {
				bookingHistoryDetailVm.tdrFiled = false;
			} else {
				bookingHistoryDetailVm.tdrFiled = true;
			}

			bookingHistoryDetailVm.selectedTab = irctcService.selTab;
			if (bookingHistoryDetailVm.selectedTab == 'Y') {
				bookingHistoryDetailVm.boardingStationList(fromSTN, toSTN, jrnyDate, jrnyClass, trainNo, boardPoint);
			}

			if (irctcService.username) {
				irctcService.userLinkedStatus = true;
				bookingHistoryDetailVm.username = irctcService.username;
			} else {
				bookingHistoryDetailVm.username = "Menu";
				bookingHistoryDetailVm.userLinkedStatus = false;
			}
			bookingHistoryDetailVm.showManageInfo = irctcService.userLinkedStatus;
			bookingHistoryDetailVm.transactionID = irctcService.bookHistoryDetail.transID;
			bookingHistoryDetailVm.isPNRPage = irctcService.bookHistoryDetail.pnrPageInfo;
			if (bookingHistoryDetailVm.historyDetails.bookingResponseList) {
				bookingHistoryDetailVm.chartStatus = bookingHistoryDetailVm.historyDetails.bookingResponseList.trainChartStatus;
				bookingHistoryDetailVm.userPNR = bookingHistoryDetailVm.historyDetails.bookingResponseList.pnrNumber;
			}

			});

		return this;
	}
]);
