'use strict';
angularApp.controller('irctcFileTDRController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
        "irctcService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker,$ionicSideMenuDelegate,irctcService) {
			var irctcFileTDRVm = this;
			
			irctcFileTDRVm.goBack = function(){
				$ionicHistory.goBack(-1);
			}

			irctcFileTDRVm.toggleMenu = function(){
		       irctcFileTDRVm.menu = !irctcFileTDRVm.menu;
		    }

		    irctcFileTDRVm.submitTDR = function () {

		    	var obj = {
				  "resvId": irctcService.bookHistoryDetail.transID,
				  "reason": irctcFileTDRVm.tdrReason,
				  "psgnTokens":irctcService.tdrFiledPsgn
				};

				irctcFileTDRVm.pnrNumber = irctcService.bookHistoryDetail.bookingResponseList.pnrNumber;
				var trdStr = "Your request for TDR refund against PNR number "+irctcFileTDRVm.pnrNumber + " has been received.";
		    	irctcService.submitTDR(obj).then(function (data) {
                    //Show popup
                    var showPopup = $ionicPopup.show({
						template: '<div class="popupBodyPadding font-dark-grey"><div align="center"><img class="fss-popup-activated-img" src="img/FSS/Approved.svg"></div><div class="fss-cards-payment-success roboto-light font-content font-dark-grey ">  <p class="text-align-center font-content roboto-regular" translate="IRCTC_SUCCESSFUL_MSG"></p><p class="text-align-center font-content roboto-regular">'+trdStr+'</p></div></div>',
						cssClass: 'dialog',
						buttons: [{
							text: 'Ok',
							type: 'button-positive',
							onTap: function(e) {
								showPopup.close();  
								$state.go('menu.irctcBookTicketSearch');
							}
						}]
					});
				},function(error){
                    utilityService.showErrorMessage(error.responseMessage);
                });
		    }

			$scope.$on('$ionicView.beforeLeave', function(){

			});

			$scope.$on('$ionicView.afterEnter', function() {

			});
	      
			$scope.$on('$ionicView.beforeEnter', function() {

				if(irctcService.username){
	              irctcService.userLinkedStatus = true;
	              irctcFileTDRVm.username = irctcService.username;
	            }else{
	              irctcFileTDRVm.username = "Menu";
	              irctcFileTDRVm.userLinkedStatus = false;
	            }
	            irctcFileTDRVm.showManageInfo = irctcService.userLinkedStatus;
	           	irctcFileTDRVm.tdrReasons = irctcService.fileTDR.reason;
	           	irctcFileTDRVm.tdrTnc = irctcService.fileTDR.tnc;
	           	irctcFileTDRVm.tdrReason = irctcFileTDRVm.tdrReasons[0].key;

			});

		return this;
	}
]);
