'use strict';
angularApp.controller('forgotPasswordController', [
  "$state",
  "$scope",
  "$ionicPopup",
  "$translate",
  "utilityService",
  "loggedInUserService",
  "irctcService",
  "homeScreenService",
  "clickStreamService",
  "validateService",
  function ($state, $scope, $ionicPopup, $translate, utilityService, loggedInUserService, irctcService, homeScreenService, clickStreamService, validateService) {
    var forgotPageVm = this;
    forgotPageVm.regiterNumberErrMsg = '';
    forgotPageVm.validateService = validateService;
    forgotPageVm.showErrorMsg = false;
    forgotPageVm.mobileNumberObject = {};
    forgotPageVm.mobileNumber = '';
    var refInAppBrowser = "";
    forgotPageVm.startorStopTimer = true;
    forgotPageVm.timerTimer = 10;
    forgotPageVm.listPage = false;
    forgotPageVm.dynamicVar = 'forgotPass';
    $scope.$on('$ionicView.beforeEnter', function () {
      if (irctcService.username) {
        irctcService.userLinkedStatus = true;
        forgotPageVm.username = irctcService.username;
      } else {
        forgotPageVm.username = "Menu";
        forgotPageVm.userLinkedStatus = false;
      }
      forgotPageVm.showManageInfo = irctcService.userLinkedStatus;
      forgotPageVm.disableNext = true;
    });

    forgotPageVm.toggleMenu = function () {
      forgotPageVm.menu = !forgotPageVm.menu;
    };

    forgotPageVm.nextInput = function(e) {
      if (e.keyCode === 8) {
        var $prevElement = e.srcElement.previousElementSibling;
        if ($prevElement && (e.srcElement.maxLength != e.srcElement.value.length)) {
          $prevElement.focus();

        }
      } else {
        if (e.srcElement.maxLength === e.srcElement.value.length) {
          var $nextElement = e.srcElement.nextElementSibling;
          if ($nextElement && ($nextElement.maxLength != $nextElement.value.length)) {
            $nextElement.focus();
          }
        }
      }
    }

    forgotPageVm.goNext = function (array) {
      var reqParams = {};
      if (array != 'back') {
        var registerNumber = array;
        // var registerNumber = Object.keys(array).reduce(function (arr, key) {
        //   return arr.concat(array[key]);
        // }, []).join('');
        if (forgotPageVm.validateService.isValidIrctcMobileNo(registerNumber)) {
          forgotPageVm.regiterNumberErrMsg = forgotPageVm.validateService.isValidIrctcMobileNo(registerNumber);
          forgotPageVm.showErrorMsg = (forgotPageVm.regiterNumberErrMsg === "") ? true : false;
          return forgotPageVm.showErrorMsg;
        }
        reqParams["mobile"] = registerNumber;
        reqParams["paymentType"]="POST";
        reqParams["returnBooking"] = 'N';
      } else {
        reqParams["paymentType"]="POST";
        reqParams["mobile"] = '';
        reqParams["returnBooking"] = 'Y';
      }
      forgotPageVm.showErrorMsg = true;
      irctcService.resetPassword(reqParams).then(function (data) {
        forgotPageVm.regiterNumberErrMsg='';
        var response=data.data;
        $scope.resetPwdSuccessMsg= data.responseMessage ? data.responseMessage : '';
        if (reqParams["returnBooking"] === 'Y') {
          forgotPageVm.showSuccessOrErrorMessage('back', '', response);
        } else {
          var status = "success";
          var heading = '<h2 class="irctc-popup-heading">Password Reset Successful</h2>';
          var imageURL = status == "success" ? 'img/irctc/irctc-success.svg' : status == "failed" ? "img/irctc/irctc-pending.svg" : "img/irctc/irctc-unsuccessful.svg";
          var alertMsg = '<div class="popup-padding font-dark-grey"><div><center><img class="approvedIconPosition" src="' + imageURL + '"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20">' + heading + '<span class="popUp-msg-color">' + $scope.resetPwdSuccessMsg + '</span></div></div></div>';
          forgotPageVm.showSuccessOrErrorMessage(status, alertMsg, response);
        }
      }, function (error) {
          forgotPageVm.showErrorMsg =false;
          forgotPageVm.regiterNumberErrMsg=error.responseMessage;
      });
    };
    $scope.clearMobileFields=function(){
      forgotPageVm.mobileNumberObject.part1='';
      forgotPageVm.mobileNumberObject.part2='';
      forgotPageVm.mobileNumberObject.part3='';
      forgotPageVm.mobileNumberObject.part4='';
      forgotPageVm.mobileNumberObject.part5='';
      forgotPageVm.mobileNumberObject.part6='';
      forgotPageVm.mobileNumberObject.part7='';
      forgotPageVm.mobileNumberObject.part8='';
      forgotPageVm.mobileNumberObject.part9='';
      forgotPageVm.mobileNumberObject.part10='';
    }
    forgotPageVm.showSuccessOrErrorMessage = function (status, alertMsg, response) {
      $scope.clearMobileFields();
      forgotPageVm.formData = response.htmlForm;
      forgotPageVm.formURL = response.url;
      var pageContentUrl = 'data:text/html;base64,' + btoa(forgotPageVm.formData);
      if(status === 'back') {
        forgotPageVm.openCordovaBrowser(pageContentUrl);
      } else {
        var popupAlert = $ionicPopup.show({
          title: null,
          template: alertMsg,
          cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup irctc-exception',
          buttons: [{
            text: 'OK',
            type: 'button-assertive',
            onTap: function (e) {
              clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "ACC_REDIRECT_IRCTC"));
              popupAlert.close();
              if (status === 'success') {
                forgotPageVm.openCordovaBrowser(pageContentUrl);
              } else if (status === 'unsuccessful') {
                irctcService.searchTrainObj = "";
                irctcService.myList = "";
                irctcService.masterData = "";
                irctcService.selectedTrainData = "";
                irctcService.myListFullData = "";
                irctcService.infantArray = [];
                irctcService.passArray = [];
                $state.go('menu.irctcBookTicketSearch');
              }
            }
          }],
        });
      }
    }

    forgotPageVm.openCordovaBrowser = function(pageContentUrl) {
      refInAppBrowser = cordova.ThemeableBrowser.open(pageContentUrl, '_blank', {
        statusbar: {
          color: '#ffffffff'
        },
        toolbar: {
          height: 37,
          color: '#ffffffff',
          image: 'share'
        },
        closeButton: {
          image: 'back',
          height: 37,
          width: 32,
          align: 'left',
          event: 'closePressed'
        },
        backButtonCanClose: true
      });
      refInAppBrowser.addEventListener('loadstop', loadStartCallBackonForgot);
      refInAppBrowser.addEventListener('exit', exitCallBack);
      refInAppBrowser.addEventListener('closePressed', closePressedcallback);
    }

    function loadStartCallBackonForgot(event) {
      var checkFlag = irctcService.getUrlParameter("CancelButton", event.url);
      if (checkFlag === "Y") {
        refInAppBrowser.close();
        var bookingFlagCode = "C";
        forgotPageVm.getTicketBookingStatus(bookingFlagCode);
      } else if (checkFlag === "F") {
        refInAppBrowser.close();
        $state.go('menu.forgotPassword');
      } else if (event.url.indexOf(forgotPageVm.formURL) > -1) {
        refInAppBrowser.close();
        var bookingCode = '';
        forgotPageVm.getTicketBookingStatus(bookingCode);
      }
    }

    forgotPageVm.getTicketBookingStatus = function (bookingFlagCode) {
      irctcService.getBookingStatus().then(function (data) {
        irctcService.bookingStatus = data;
        if (data.status) {
          irctcService.bookingCompleted = true;
        } else {
          irctcService.bookingCompleted = false;
          if (data.bookingFlag === "BA") {
            irctcService.showPopOnError({
              bookingFlag: data.bookingFlag,
              bookingMessage: data.bookingMessage
            });
          } else {
            if(bookingFlagCode === 'C') {
              irctcService.showPopOnError({
                bookingFlag: bookingFlagCode,
                bookingMessage: ""
              });
            }
          }
        }
        // After Success User navigate to ticket confirmation Page.
        $state.go('menu.ticketConfirmation');
      }, function (error) {
        utilityService.showErrorMessage(error.responseMessage);
      });
    };

  }
]);
