/**
 *   @ngdoc config
 *   @name angularApp.config : cardConfig
 *   @description
 *  configuration file for cards module
 */

/*This function defines all the constants named  Adapters url for cards module*/
angularApp
    /*State defination with respective names, urls, controllers and templates */
    .config([
        '$stateProvider',
        function ($stateProvider) {
            //Cards start
            $stateProvider
                .state('menu.irctcBookTicketSearch', {
                    url: '/irctcBookTicketSearch',
                    data: {
                        pageId: 'OS_IRCTC_SRCHTCKT'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/irctc/bookTicket/bookTicketSearch.html',
                            controller: 'bookTicketSearchController',
                            controllerAs: 'bookTicketSearchdVm'
                        }
                    }
                })
                .state('menu.irctcBookTicketSearchModify', {
                    url: '/irctcBookTicketSearchModify',
                    data: {
                        pageId: 'OS_IRCTC_MDFSRCHTCKT'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/irctc/bookTicket/bookTicketSearchModify.html',
                            controller: 'bookTicketSearchModifyController',
                            controllerAs: 'bookTicketSearchModifyVm'
                        }
                    }
                })
                .state('menu.irctcBookTicketSearchResult', {
                    url: '/irctcBookTicketSearchResult',
                    data: {
                        pageId: 'OS_IRCTC_SRCHTCKTRSLT'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/irctc/bookTicketResult/bookTicketSearchResult.html',
                            controller: 'bookTicketSearchResultController',
                            controllerAs: 'bookTicketSearchdResultVm'
                        }
                    }
                })
                .state('menu.irctcViewRoute', {
                    url: '/irctcViewRoute',
                    data: {
                        pageId: 'OS_IRCTC_VIWRUTE'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/irctc/viewRoute/viewRoute.html',
                            controller: 'viewRouteController',
                            controllerAs: 'viewRouteVm'
                        }
                    }
                })
                .state('menu.authenticateIRCTCUser', {
                    url: '/authenticateIRCTCUser',
                    data: {
                        pageId: 'OS_IRCTC_AUTHUSR'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/irctc/authenticateUser/authenticateUser.html',
                            controller: 'authenticateUserController',
                            controllerAs: 'authenticateUserVm'
                        }
                    }
                })
                .state('menu.travellerList', {
                    url: '/travellerList',
                    data: {
                        pageId: 'OS_IRCTC_TRVLRLST'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/irctc/travellerList/travellerList.html',
                            controller: 'travellerListController',
                            controllerAs: 'travellerListVm'
                        }
                    }
                })
                .state('menu.travellerMyList', {
                    url: '/travellerMyList',
                    data: {
                        pageId: 'OS_IRCTC_TRVLRMYLST'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/irctc/travellerMyList/travellerMyList.html',
                            controller: 'travellerMyListController',
                            controllerAs: 'travellerMyListVm'
                        }
                    }
                })
                .state('menu.bookingFlow', {
                    url: '/bookingFlow',
                    data: {
                        pageId: 'OS_IRCTC_BOOKINGFLOW'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/irctc/bookingFlow/bookingFlow.html',
                            controller: 'bookingFlowController',
                            controllerAs: 'bookingFlowVm'
                        }
                    }
                })
                .state('menu.travellerContactDetails', {
                    url: '/travellerContactDetails',
                    data: {
                        pageId: 'OS_IRCTC_TRVLRCNTDTLS'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/irctc/travellerContactDetails/travellerContactDetails.html',
                            controller: 'travellerContactDetailsController',
                            controllerAs: 'travellerContactDetailsVm'
                        }
                    }
                })
                .state('menu.ticketReview', {
                    url: '/ticketReview',
                    data: {
                        pageId: 'OS_IRCTC_TCKTRVW'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/irctc/ticketReview/ticketReview.html',
                            controller: 'ticketReviewController',
                            controllerAs: 'ticketReviewVm'
                        }
                    }
                })
                .state('menu.irctcPayNow', {
                    url: '/irctcPayNow',
                    data: {
                        pageId: 'OS_IRCTC_PAYNOW'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/irctc/irctcPayNow/irctcPayNow.html',
                            controller: 'irctcPayNowController',
                            controllerAs: 'irctcPayNowVm'
                        }
                    }
                })
                .state('menu.irctcOTP', {
                    url: '/irctcOTP',
                    data: {
                        pageId: 'OS_IRCTC_OTP'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/irctc/irctcPayNow/irctcOTP.html',
                            controller: 'irctcOTPController',
                            controllerAs: 'irctcOTPVm'
                        }
                    }
                })
                .state('menu.ticketConfirmation', {
                    url: '/ticketConfirmation',
                    data: {
                        pageId: 'OS_IRCTC_TCKTCNFM'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/irctc/ticketConfirmation/ticketConfirmation.html',
                            controller: 'ticketConfirmationController',
                            controllerAs: 'ticketConfirmationVm'
                        }
                    }
                })
                .state('menu.bookingHistory', {
                    url: '/bookingHistory',
                    data: {
                        pageId: 'OS_IRCTC_BOKHSTRY'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/irctc/bookingHistory/bookingHistory.html',
                            controller: 'bookingHistoryController',
                            controllerAs: 'bookingHistoryVm'
                        }
                    }
                })
                .state('menu.tdrTnc', {
                    url: '/tdrTnc',
                    data: {
                        pageId: 'OS_IRCTC_TDRTNC'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/irctc/bookingHistory/tdrTnc.html',
                            controller: 'tdrTncController',
                            controllerAs: 'tdrTncVm'
                        }
                    }
                })
                .state('menu.bookingHistoryDetail', {
                    url: '/bookingHistoryDetail',
                    data: {
                        pageId: 'OS_IRCTC_BOKHSTRYDETL'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/irctc/bookingHistory/bookingHistoryDetail.html',
                            controller: 'bookingHistoryDetailController',
                            controllerAs: 'bookingHistoryDetailVm'
                        }
                    }
                })
                .state('menu.bookingCancel', {
                    url: '/bookingCancel',
                    data: {
                        pageId: 'OS_IRCTC_BKNGCNCL'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/irctc/bookingHistory/bookingCancel.html',
                            controller: 'bookingCancelController',
                            controllerAs: 'bookingCancelVm'
                        }
                    }
                })
                .state('menu.bookingCancelReview', {
                    url: '/bookingCancelReview',
                    data: {
                        pageId: 'OS_IRCTC_BKNGCNCLRVW'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/irctc/bookingHistory/bookingCancelReview.html',
                            controller: 'bookingCancelReviewController',
                            controllerAs: 'bookingCancelReviewVm'
                        }
                    }
                })
                .state('menu.bookingCancelConfirm', {
                    url: '/bookingCancelConfirm',
                    data: {
                        pageId: 'OS_IRCTC_BKNGCNCLCNFM'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/irctc/bookingHistory/bookingCancelConfirm.html',
                            controller: 'bookingCancelConfirmController',
                            controllerAs: 'bookingCancelConfirmVm'
                        }
                    }
                })
                .state('menu.bookingCancelStatus', {
                    url: '/bookingCancelStatus',
                    data: {
                        pageId: 'OS_IRCTC_BKNGCNCLSTUS'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/irctc/bookingHistory/bookingCancelStatus.html',
                            controller: 'bookingCancelStatusController',
                            controllerAs: 'bookingCancelStatusVm'
                        }
                    }
                })
                
                .state('menu.myList', {
                url: '/myList',
                data: {
                    pageId: 'OS_IRCTC_MYLST'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/irctc/travellerMyList/irctcMyList.html',
                        controller: 'irctcMyListController',
                        controllerAs: 'irctcMyListVm'
                    }
                }
            })
              .state('menu.myListEdit', {
                url: '/myListEdit',
                data: {
                    pageId: 'OS_IRCTC_MYLSTEDT'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/irctc/travellerMyList/travellerMyListEdit.html',
                        controller: 'travellerMyListEditController',
                        controllerAs: 'travellerMyListEditVm'
                    }
                }
            })
                .state('menu.linkDelinkUser', {
                    url: '/linkDelinkUser',
                    data: {
                        pageId: 'OS_IRCTC_LNKDLNK'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/irctc/authenticateUser/linkDelinkUser.html',
                            controller: 'linkDelinkUserController',
                            controllerAs: 'linkDelinkUserVm'
                        }
                    }
                })

                .state('menu.optVikalpTrainList', {
                    url: '/optVikalpTrainList',
                    data: {
                        pageId: 'OS_IRCTC_OPTVKLPTRNLST'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/irctc/vikalp/optVikalpTrainList.html',
                            controller: 'optVikalpTrainListController',
                            controllerAs: 'optVikalpTrainListVm'
                        }
                    }
                })

                .state('menu.irctcFeedback', {
                    url: '/irctcFeedback',
                    data: {
                        pageId: 'OS_IRCTC_FEEDBACK'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/irctc/irctcSupport/irctcFeedback.html',
                            controller: 'irctcFeedbackController',
                            controllerAs: 'irctcFeedbackVm'
                        }
                    }
                })

                .state('menu.irctcFAQ', {
                    url: '/irctcFAQ',
                    data: {
                        pageId: 'OS_IRCTC_FAQ'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/irctc/irctcSupport/irctcFAQ.html',
                            controller: 'irctcFAQController',
                            controllerAs: 'irctcFAQVm'
                        }
                    }
                })

                .state('menu.irctcBookingPolicy', {
                    url: '/irctcBookingPolicy',
                    data: {
                        pageId: 'OS_IRCTC_BOOKPLCY'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/irctc/irctcSupport/irctcBookingPolicy.html',
                            controller: 'irctcBookingPolicyController',
                            controllerAs: 'irctcBookingPolicyVm'
                        }
                    }
                })

                
                .state('menu.tdrPassList', {
                    url: '/tdrPassList',
                    data: {
                        pageId: 'OS_IRCTC_FILETDR_PASS'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/irctc/bookingHistory/tdrPassList.html',
                            controller: 'tdrPassListController',
                            controllerAs: 'tdrPassListVm'
                        }
                    }
                })

                .state('menu.irctcFileTDR', {
                    url: '/irctcFileTDR',
                    data: {
                        pageId: 'OS_IRCTC_FILETDR'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/irctc/bookingHistory/irctcFileTDR.html',
                            controller: 'irctcFileTDRController',
                            controllerAs: 'irctcFileTDRVm'
                        }
                    }
                })

                .state('menu.forgotPassword', {
                    url: '/forgotPassword',
                    data: {
                        pageId: 'OS_IRCTC_FORPASS'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/irctc/forgotPassword/forgotPass.html',
                            controller: 'forgotPasswordController',
                            controllerAs: 'forgotPageVm'
                        }
                    }
                })

                .state('menu.taxInvoiceList', {
                    url: '/taxInvoiceList',
                    data: {
                        pageId: 'OS_IRCTC_TAXINVOICE'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/irctc/taxInvoice/taxInvoice.html',
                            controller: 'taxInvoiceListController',
                            controllerAs: 'taxInvoiceListVm'
                        }
                    }
                })
        }
    ]);
