'use strict';
angularApp.controller('irctcOTPController', [
  "$state",
  "$scope",
  "$ionicPopup",
  "$translate",
  "$ionicHistory",
  "utilityService",
  "ionicDatePicker",
  "$ionicSideMenuDelegate",
  "irctcService", "customerInfoService", "fTSetOTPService", "$filter", "constantConfig", "cryptoService", "clickStreamService",
  function ($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, irctcService, customerInfoService, fTSetOTPService, $filter, constantConfig, cryptoService, clickStreamService) {
    var irctcOTPVm = this;
    var refInAppBrowser = "";
    irctcOTPVm.startorStopTimer = true;
    irctcOTPVm.timerTimer = 10;
    irctcOTPVm.listPage = false;
    irctcOTPVm.dynamicVar = 'irctcOtp';

    irctcOTPVm.goBack = function () {
      $ionicHistory.goBack(-1);
    };

     irctcOTPVm.enableNext=function(){
       if(irctcOTPVm.getOTPNumber.length==6){
         irctcOTPVm.disableNext=false;
       }
       else{
        irctcOTPVm.disableNext=true;
       }
     }

      irctcOTPVm.goNext = function(){
        var reqParams = {};
				reqParams["otp"] = irctcOTPVm.getOTPNumber;
				reqParams["mobile"] =customerInfoService.customer.mobile;
				fTSetOTPService.validateOTP(reqParams).then(function(response){
			  if(response.status.toLowerCase() == 'success'){
				    var accountNumber = irctcService.accountNumber;
            irctcService.payFromAccount(accountNumber).then(function (data) {
              irctcOTPVm.formData = data.htmlForm;
              irctcOTPVm.formURL = data.url;
              var pageContentUrl = 'data:text/html;base64,' + btoa(irctcOTPVm.formData);
                  irctcOTPVm.popUP = $ionicPopup.show({
                        title: '',
                         buttons: [{ 
                         text: 'OK',
                          onTap: function(e) {
                            clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "ACC_REDIRECT_IRCTC"));
                           irctcOTPVm.popUP.close();
                      irctcService.isServiceCalled = false;   
                      refInAppBrowser = cordova.ThemeableBrowser.open(pageContentUrl, '_blank', {
                        statusbar: {
                          color: '#ffffffff'
                        },
                        toolbar: {
                          height: 37,
                          color: '#ffffffff',
                          image: 'share'
                        },
                        closeButton: {
                          image: 'back',
                          height: 37,
                          width: 32,
                          align: 'left',
                          event: 'closePressed'
                        },
                        backButtonCanClose: true
                      });
                      refInAppBrowser.addEventListener('loadstop', loadStartCallBack);
                      refInAppBrowser.addEventListener('exit', exitCallBack);
                      refInAppBrowser.addEventListener('closePressed', closePressedcallback);
                    }
                    }],
                        cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter ftpopup-body',
                        templateUrl: 'pages/irctc/irctcPayNow/paymentPopUp.html',
                        scope: $scope
                      });
      }, function (err) {
       utilityService.showErrorMessage(err.responseMessage);
    });
			} else {
					utilityService.showErrorMessage(response.status);
					}
      }, function(error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
      };
	   function exitCallBack(event) {
		   
		   setTimeout(function(){ 
		   if(irctcService.isServiceCalled === false){
			   // irctcOTPVm.getTicketBookingStatus();
		   }
		    }, 90);
	   }

	   function closePressedcallback(event) {
		  
	   }
    function loadStartCallBack(event) {
      var checkFlag = irctcService.getUrlParameter("CancelButton", event.url);
      if (checkFlag === "Y") {
        refInAppBrowser.close();
        var bookingFlagCode = "C";
        irctcOTPVm.getTicketBookingStatus(bookingFlagCode);
      } else if (checkFlag === "F") {
        refInAppBrowser.close();
        $state.go('menu.forgotPassword');
      } else if (event.url.indexOf(irctcOTPVm.formURL) > -1) {
        refInAppBrowser.close();
        var bookingCode = '';
        irctcOTPVm.getTicketBookingStatus(bookingCode);
      }
    }

    irctcOTPVm.getUrlParameter = function (name, url) {
      name = name.replace(/[\[]/, '\\[').replace(/[\]]/, '\\]');
      var regex = new RegExp('[\\?&]' + name + '=([^&#]*)');
      var results = regex.exec(url);
      return results === null ? '' : decodeURIComponent(results[1].replace(/\+/g, ' '));
    };

    irctcOTPVm.getTicketBookingStatus = function (bookingFlagCode) {
    irctcService.isServiceCalled = true;
      irctcService.getBookingStatus().then(function (data) {
        irctcService.bookingStatus = data;
        if (data.status) {
          irctcService.bookingCompleted = true;
        } else {
          irctcService.bookingCompleted = false;
          if (data.bookingFlag === "BA") {
            irctcService.showPopOnError({
              bookingFlag: data.bookingFlag,
              bookingMessage: data.bookingMessage
            });
          }else {
            if(bookingFlagCode === 'C') {
              irctcService.showPopOnError({
                bookingFlag: bookingFlagCode,
                bookingMessage: ""
              });
            }
          }
        }
        // After Success User navigate to ticket confirmation Page.
        $state.go('menu.ticketConfirmation');
      }, function (error) {
        utilityService.showErrorMessage(error.responseMessage);
      });
    }

        irctcOTPVm.resendOTP=function(){
            irctcOTPVm.getOTPNumber="";
            irctcOTPVm.isResendOTP=true;
            var reqData = {};
            reqData.otpCode = constantConfig.keysForOTP.IRCTCOTP;
             reqData.ocHash = cryptoService.getSHA512EncryptedData(constantConfig.keysForOTP.IRCTCOTP).toString();
             fTSetOTPService.generateOTP(reqData).then(function(response){
                 irctcOTPVm.isResendDisabled=true;
             }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
             });
          };

		$scope.$on('$ionicView.beforeEnter', function() {
      irctcOTPVm.isResendOTP=false;
			irctcOTPVm.userMobile = $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4);
      irctcOTPVm.isResendDisabled=false;
      irctcOTPVm.clickCount=0;
      irctcOTPVm.disableNext=true;
		});

		return this;
	}
]);
