angularApp.service('irctcService',
    function ($q, AdapterUtils, utilityService, constantConfig, $ionicPopup, $state) {

        var irctcService = this;
        this.trainListData = [];
        this.stationListData = [];
        this.sourceStation = '';
        this.destStation = '';
        this.searchDate = '';
        this.searchQuota = '';
        this.viewRouteData = '';
        this.selectedTrainData = '';
        this.totalTravellers = '';
        this.myList = '';
        this.travelDate = '';
        this.accList = '';
        this.accountNumber = "";
        this.bookingStatus = "";
        this.from = "";
        this.fromData = "";
        this.bookHistory = "";
        this.bookHistoryDetail = [];
        this.ticketCancelledResp = "";
        this.userLinkedStatus = false;
        this.username = "";
        this.displayDate = "";
        this.masterData = "";
        this.myListFullData = "";
        this.vikalpTrainList = "";
        this.forgotPasswordURL = "https://www.irctc.co.in/eticketing/forgotPassword.jsf";
        this.createIRCTCURL = "https://www.irctc.co.in/eticketing/userSignUp.jsf";
        this.selTab = "";
        this.stationCodeArray = [];
        this.stationNameArray = [];
        this.tdrFiledPsgn = [];
        this.passArray = [];
        this.infantArray = [];
        this.boardingStations = "";
        this.bookingCompleted = "";
        this.foodAvailable = "";
        this.showSeniorFlag = false;

        irctcService.getStationMaster = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/OMPAdapter/getStationMaster", {}, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        irctcService.getPincodeData = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/ExistingCustomerAccountOpeningAdapter/fetchLocationByPinCode", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


    irctcService.isValidMobileNo = function(phoneNo) {
        var regexp = new RegExp("^[6789][0-9]{9}$");
        if (!phoneNo) {
            return "Required Field";
        }
        if (!regexp.test(phoneNo)) {
            return "Enter a valid Mobile number";
        }
        return false;
    };
                   
      irctcService.getStationList = function() {
            var q = $q.defer();
            AdapterUtils.postData("adapters/OMPAdapter/getStationList",{},true).then(
                function(response){
                   q.resolve(response.data);
                },
                function(error){
                    q.reject(error);
                });
            return q.promise;
        };
                   
       irctcService.getTrainList = function(trainObj) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/OMPAdapter/getTrainList",trainObj,true).then(
                function(response){
                   q.resolve(response.data);
                 },
                 function(error){
                   q.reject(error);
                 });
            return q.promise;
        };

        irctcService.getTrainFare = function(trainObj) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/OMPAdapter/getTrainFare",trainObj,true).then(
                function(response){
                   q.resolve(response.data);
                 },
                 function(error){
                   q.reject(error);
                 });
            return q.promise;
        };

        
        irctcService.getTrainRoute = function(trainNo) {
                var q = $q.defer();
                var obj = {
                   "trainNumber":trainNo
                };
            AdapterUtils.postData("adapters/OMPAdapter/getTrainRoute",obj,true).then(
                    function(response){
                        q.resolve(response.data);
                    },
                    function(error){
                        q.reject(error);
                });
            return q.promise;
        };

        irctcService.authenticateUser = function(username) {
                var q = $q.defer();
                var obj = {
                   "userId":username
                };
            AdapterUtils.postData("adapters/OMPAdapter/getUserStatus",obj,true).then(
                function(response){
                    q.resolve(response.data);
                },
                function(error){
                    q.reject(error);
            });
            return q.promise;
        };

        irctcService.deAuthenticateUser = function() {
                var q = $q.defer();
                var obj = {};
            AdapterUtils.postData("adapters/OMPAdapter/delinkIrctcUser",obj,true).then(
                function(response){
                    q.resolve(response.data);
                },
                function(error){
                    q.reject(error);
            });
            return q.promise;
        };

        irctcService.fetchMyList = function() {
                var q = $q.defer();
                
            AdapterUtils.postData("adapters/OMPAdapter/getMyList",{},true).then(
                function(response){
                    q.resolve(response.data);
                },
                function(error){
                    q.reject(error);
            });
            return q.promise;
        };

        irctcService.preBooking = function(preBookObj) {
                var q = $q.defer();
            preBookObj.tnc = true;
            AdapterUtils.postData("adapters/OMPAdapter/preBooking",preBookObj,true).then(
                function(response){
                    q.resolve(response.data);
                },
                function(error){
                    q.reject(error);
            });
            return q.promise;
        };

        irctcService.getBoardingPoint = function(fromSTN,toSTN,jrnyDate,jrnyClass,trainNo) {
                var q = $q.defer();
                var obj = {
                   "fromStation":fromSTN,
                   "toStation":toSTN,
                   "journeyDate":jrnyDate,
                   "journeyClass":jrnyClass,
                   "trainNumber":trainNo
                };

            AdapterUtils.postData("adapters/OMPAdapter/getBoardingPoint",obj,true).then(
                function(response){
                    q.resolve(response.data);
                },
                function(error){
                    q.reject(error);
            });
            return q.promise;
        };

        irctcService.updateBoardingPoint = function(obj) {
                var q = $q.defer();
                
            AdapterUtils.postData("adapters/OMPAdapter/updateBoardingPoint",obj,true).then(
                function(response){
                    q.resolve(response.data);
                },
                function(error){
                    q.reject(error);
            });
            return q.promise;
        };

        irctcService.payFromAccount = function(accNumber) {
                var q = $q.defer();
            var obj = {
              "accountNo":accNumber
            };
            AdapterUtils.postData("adapters/OMPAdapter/getPayment",obj,true).then(
                function(response){
                    q.resolve(response.data);
                },
                function(error){
                    q.reject(error);
            });
            return q.promise;
        };

        irctcService.loadPGDetails = function() {
            var q = $q.defer();
            var obj = {};
            AdapterUtils.postData("adapters/OMPAdapter/getPgDetail",obj,true).then(
                function(response){
                    q.resolve(response.data);
                },
                function(error){
                    q.reject(error);
            });
            return q.promise;
        };

        irctcService.confirmPGDetails = function() {
            var q = $q.defer();
            var obj = {};
            AdapterUtils.postData("adapters/OMPAdapter/getPgConfirm",obj,true).then(
                function(response){
                    q.resolve(response.data);
                },
                function(error){
                    q.reject(error);
            });
            return q.promise;
        };

        irctcService.getBookingStatus = function() {
                var q = $q.defer();
                var obj = {};
            AdapterUtils.postData("adapters/OMPAdapter/getBookingStatus",obj,true).then(
                function(response){
                    q.resolve(response.data);
                },
                function(error){
                    q.reject(error);
            });
            return q.promise;
        };

        irctcService.getBookingHistory = function() {
                var q = $q.defer();
            
            AdapterUtils.postData("adapters/OMPAdapter/getBookingHistory",{},true).then(
                function(response){
                    q.resolve(response);
                },
                function(error){
                    q.reject(error);
            });
            return q.promise;
        };

        irctcService.getBookingHistoryDetail = function(tripID) {
                var q = $q.defer();
            var obj = {
                "transactionId":tripID
            }
            AdapterUtils.postData("adapters/OMPAdapter/getBookingHistoryDetail",obj,true).then(
                function(response){
                    q.resolve(response.data);
                },
                function(error){
                    q.reject(error);
            });
            return q.promise;
        };

        irctcService.deleteMyList = function(reqParams) {
                var q = $q.defer();
          
            AdapterUtils.postData("adapters/OMPAdapter/deleteMyList",reqParams,true).then(
                function(response){
                    q.resolve(response.data);
                },
                function(error){
                    q.reject(error);
            });
            return q.promise;
        };      

        
        irctcService.updateMyList = function(reqParams) {
                var q = $q.defer();
          
            AdapterUtils.postData("adapters/OMPAdapter/updateMyList",reqParams,true).then(
                function(response){
                    q.resolve(response.data);
                },
                function(error){
                    q.reject(error);
            });
            return q.promise;
        };

         irctcService.savebase64AsPDF=function(folderpath,filename,content,contentType){

                var contentStr = atob(content);
                var contentLen = contentStr.length;
                if (contentLen >= constantConfig.accOverview.pdfSize) {
                   
                    utilityService.showErrorMessage(constantConfig.accOverview.sizeLimitMessage);
                    return;
                }
            // Convert the base64 string in a Blob
            var DataBlob = irctcService.b64toBlob(content,contentType);


            
            window.resolveLocalFileSystemURL(folderpath, function(dir) {
                dir.getFile(filename, {create:true}, function(file) {
                    file.createWriter(function(fileWriter) {
                        fileWriter.write(DataBlob);
                        
                    }, function(){
                        
                    });
                });
            });
        }

        /*Adding Below function in order to resolve android 11 PDF issue
        This function is used in Sampoorna suraksha journey as well
        Also above function savebase64AsPDF is modified after creation of this function 
        and its at UAT stage, irctc developer to check before committing */
        irctcService.savebase64AsPDFNew = function (folderpath, filename, content, contentType, scope) {

            var contentStr = atob(content);
            var contentLen = contentStr.length;
            if (contentLen >= constantConfig.accOverview.pdfSize) {

                utilityService.showErrorMessage(constantConfig.accOverview.sizeLimitMessage);
                return;
            }
            // Convert the base64 string in a Blob
            var DataBlob = irctcService.b64toBlob(content, contentType);

            // fix for android 10 file save issue
            if (utilityService.isAndroidPlatform()) {
                if (device.version == 10) {
                    folderpath = cordova.file.externalDataDirectory;
                    irctcService.popupFolderpath = folderpath.replace(cordova.file.externalRootDirectory, "") + filename;
                    window.resolveLocalFileSystemURL(folderpath, function (dir) {
                        dir.getFile(filename, { create: true }, function (file) {
                            file.createWriter(function (fileWriter) {
                                fileWriter.write(DataBlob);
                            }, function (error) {
                                console.log('File writer error: ' + error);
                            });
                        }, function (error) {
                            console.log('Error in dir.getFile: ' + error);
                        });
                    }, function (error) {
                        // failed to resolve file path
                    });
                }
                else {
                    //for Android below 10 and Android 11 not for 10
                    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fileSystem) {
                        fileSystem.root.getDirectory("Download", { create: true, exclusive: false}, function (dir) {
                            irctcService.popupFolderpath = dir.fullPath + filename;
                            dir.getFile(filename, { create: true, exclusive: false }, function (file) {
                                file.createWriter(function (fileWriter) {
                                    fileWriter.write(DataBlob);
                                }, function (error) {
                                });
                            },function (error) {
                                });
                        },function (error) {
                                });
                    });
                }
            }
            if (utilityService.isIOSPlatform()) {
                const finalPath = folderpath + filename;
                window.resolveLocalFileSystemURL(folderpath, function (dir) {
                    dir.getFile(filename, { create: true }, function (file) {
                        file.createWriter(function (fileWriter) {
                            fileWriter.write(DataBlob);
                        }, function () { });
                    });
                });
                cordova.plugins.fileOpener2.open(
                    finalPath,
                    'application/pdf', {
                        error: function (e) {
                            console.log('Error status: ' + e.status + ' - Error message: ' + e.message);
                        },
                        success: function () {
                            console.log('file opened successfully');
                        }
                    }
                );
            }
        }
        /* savebase64AsPDFNew ends */
        
        irctcService.getCountry=function(obj)
        {
            obj={};
            var q = $q.defer();
            
            AdapterUtils.postData("adapters/OMPAdapter/getCountry",obj,true).then(
                function(response){
                    q.resolve(response.data);
                },
                function(error){
                    q.reject(error);
            });
            return q.promise;
        }

        irctcService.cancelTicket1 = function(obj) {
            var q = $q.defer();
            
            AdapterUtils.postData("adapters/OMPAdapter/cancelTicket",obj,true).then(
                function(response){
                    q.resolve(response.data);
                },
                function(error){
                    q.reject(error);
            });
            return q.promise;
        };

        irctcService.getPDFTicket = function(obj) {
            var q = $q.defer();
            
            AdapterUtils.postData("adapters/OMPAdapter/eTicket",obj,true).then(
                function(response){
                    q.resolve(response.data);
                },
                function(error){
                    q.reject(error);
            });
            return q.promise;
        };

        irctcService.getVikalpTrainList = function(obj) {
            var q = $q.defer();
            
            AdapterUtils.postData("adapters/OMPAdapter/getVikapTrainList",obj,true).then(
                function(response){
                    q.resolve(response.data);
                },
                function(error){
                    q.reject(error);
            });
            return q.promise;
        };

        irctcService.optVikalp = function(obj) {
            var q = $q.defer();
            
            AdapterUtils.postData("adapters/OMPAdapter/optVikalp",obj,true).then(
                function(response){
                    q.resolve(response.data);
                },
                function(error){
                    q.reject(error);
            });
            return q.promise;
        };

        irctcService.getTnC = function(obj) {
            var q = $q.defer();
            
            AdapterUtils.postData("adapters/OMPAdapter/getTnC",obj,true).then(
                function(response){
                    q.resolve(response.data);
                },
                function(error){
                    q.reject(error);
            });
            return q.promise;
        };

        irctcService.getFAQ = function(obj) {
            var q = $q.defer();
            
            AdapterUtils.postData("adapters/OMPAdapter/getFaq",obj,true).then(
                function(response){
                    q.resolve(response.data);
                },
                function(error){
                    q.reject(error);
            });
            return q.promise;
        };

        irctcService.getTDR = function(obj) {
            var q = $q.defer();
            
            AdapterUtils.postData("adapters/OMPAdapter/getTdr",obj,true).then(
                function(response){
                    q.resolve(response.data);
                },
                function(error){
                    q.reject(error);
            });
            return q.promise;
        };

        irctcService.submitTDR = function(obj) {
            var q = $q.defer();
            
            AdapterUtils.postData("adapters/OMPAdapter/submitTdr",obj,true).then(
                function(response){
                    q.resolve(response.data);
                },
                function(error){
                    q.reject(error);
            });
            return q.promise;
        };

        irctcService.b64toBlob = function(b64Data, contentType, sliceSize) {
            contentType = contentType || '';
            sliceSize = sliceSize || 512;

            var byteCharacters = atob(b64Data);
            var byteArrays = [];

            for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
                var slice = byteCharacters.slice(offset, offset + sliceSize);

                //var byteNumbers = new Array(slice.length);
                //SonarQube fix to be tested
                var byteNumbers =[];
                for (var i = 0; i < slice.length; i++) {
                    byteNumbers[i] = slice.charCodeAt(i);
                }

                var byteArray = new Uint8Array(byteNumbers);

                byteArrays.push(byteArray);
            }

            var blob = new Blob(byteArrays, {type: contentType});
            return blob;
        }

        irctcService.getStationNameCode = function(stCode,codeArray,nameArray) {

            for(var i =0;i<codeArray.length;i++){
                if (stCode == codeArray[i]) {
                    var combinedName = nameArray[i] + '('+codeArray[i] + ')';
                    return combinedName
                }
            }

            return stCode;
        };

        irctcService.getFullStation = function(fullStationName){
            var splitStation = fullStationName.split("-");
            var code = splitStation[1].trim();
            return code;
        };

        irctcService.getArrayElement = function (key,array,returnType) {
            var val;


            for(var i =0;i<array.length;i++){
                if(returnType == 'myValue'){
                    if(array[i].key == key){
                        val = array[i].value;
                    }
                }else{
                    if(array[i].value == key){
                       val = array[i].key;
                    }   
                }
                    
            }
            
            return val;
        }

        irctcService.fetchDestCityState= function(requestParam) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/OMPAdapter/getCity",requestParam,true).then(
                function(response){
                    q.resolve(response.data);
                },
                function(error){
                    q.reject(error);
            });
            return q.promise;
        };

        irctcService.fetchDestPO= function(requestParam) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/OMPAdapter/getPostOffice",requestParam,true).then(
                function(response){
                    q.resolve(response.data);
                },
                function(error){
                    q.reject(error);
            });
            return q.promise;
        };

        irctcService.getIRCTCBannerdata = function (bannerParams) {
            var url = bannerParams === 'trainSearch' ? "adapters/OMPAdapter/get_train_search_banner" : "adapters/OMPAdapter/get_booking_success_banner";
            var q = $q.defer();
            AdapterUtils.postData(url, {}, true).then(
                function (response) {
                    if(response.data) {
                        q.resolve(response.data);
                    }
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        }
        irctcService.forgotPageOTP = function (reqPara) {
            var url = 'adapters/OMPAdapter/forgotPassword';
            var q = $q.defer();
            AdapterUtils.postData(url, reqPara, true).then(
                function (response) {
                    if(response.data) {
                        q.resolve(response.data);
                    }
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        }
        //Reset Password starts
        irctcService.resetPassword = function (reqParam) {
            var url = "adapters/OMPAdapter/reset_irctc_pass";
            var q = $q.defer();
            AdapterUtils.postData(url, reqParam, true).then(
                function (response) {
                    if (response.data) {
                        q.resolve(response);
                    }
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        }
        // Reset Password ends
        irctcService.showPopOnError = function (data) {
            if (data) {
                var imageURL = "img/irctc/irctc-unsuccessful.svg";
                var messageInfo = (data.bookingFlag === "C") ? '<p class="text-align-center font-content roboto-regular"  translate="IRCTC_REDIRECT_CANCEL_MSG" ></p>' : data.bookingMessage;
                var heading = (data.bookingFlag === "inValidURL") ? '' : '<h2 class="irctc-popup-heading">Booking Failed</h2>';
                var alertMsg = '<div class="popup-padding font-dark-grey"><div><center><img class="approvedIconPosition" src="' + imageURL + '"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20">' + heading + '<span class="popUp-msg-color">' + messageInfo + '</span></div></div></div>';
                var popUPNew = $ionicPopup.show({
                    template: alertMsg,
                    cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup irctc-exception',
                    buttons: [{
                        text: 'OK',
                        type: 'button-positive',
                        onTap: function (e) {
                            popUPNew.close();
                            if (data.bookingFlag != "inValidURL") {
                                irctcService.searchTrainObj = "";
                                irctcService.myList = "";
                                irctcService.masterData = "";
                                irctcService.selectedTrainData = "";
                                irctcService.myListFullData = "";
                                irctcService.infantArray = [];
                                irctcService.passArray = [];
                                $state.go('menu.irctcBookTicketSearch');
                            }
                        }
                    }]
                });
            } else {
                return false;
            }
        }

        irctcService.getUrlParameter = function (name, url) {
            if (name && url) {
                name = name.replace(/[\[]/, '\\[').replace(/[\]]/, '\\]');
                var regex = new RegExp('[\\?&]' + name + '=([^&#]*)');
                var results = regex.exec(url);
                return results === null ? '' : decodeURIComponent(results[1].replace(/\+/g, ' '));
            }
        };

        irctcService.allGstInvoices = function () {
            var url = "adapters/OMPAdapter/allGstInvoices"
            var q = $q.defer();
            AdapterUtils.postData(url, {}, true).then(
                function (response) {
                    if(response.data) {
                        q.resolve(response.data);
                    }
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        }

        irctcService.gstInvoiceDownload = function (tripId) {
            var url = "adapters/OMPAdapter/gstInvoice"
            var q = $q.defer();
            var obj = {transactionId : tripId, "isEmail":"false", "type":"gstInvoice"}
            AdapterUtils.postData(url, obj, true).then(
                function (response) {
                    if(response.data) {
                        q.resolve(response.data);
                    }
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        }
        irctcService.settimerData = function (currentTimer) {
            irctcService.currentTimerValue = currentTimer;

        }
        irctcService.getTimerData = function () {
            return irctcService.currentTimerValue;

        }

        return irctcService;

});
