'use strict';
angularApp.controller('taxInvoiceListController', [
	"$state",
	"$scope",
	"$ionicPopup",
	"$translate",
	"$ionicHistory",
	"utilityService",
	"ionicDatePicker",
	"$ionicSideMenuDelegate",
	"irctcService",
	"openUrlInAppbroswerService",
	function ($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, irctcService, openUrlInAppbroswerService) {
		var taxInvoiceListVm = this;
		taxInvoiceListVm.goBack = function () {
			$ionicHistory.goBack(-1);
		};

		taxInvoiceListVm.toggleMenu = function () {
			taxInvoiceListVm.menu = !taxInvoiceListVm.menu;
		};

		taxInvoiceListVm.taxInvoiceHandler = function() {
			taxInvoiceListVm.taxInvoiceListResult = []
			irctcService.allGstInvoices().then(function (data) {
				console.log('taxInvoiceHandler' , data);
				taxInvoiceListVm.taxInvoiceListResult = data;
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		};

		taxInvoiceListVm.downloadTaxInvoice =  function(tripId) {
			irctcService.gstInvoiceDownload(tripId).then(function(data) {
				console.log('data', data)
				var filename =  data.fileName+'.pdf';
		            var content =  data.pdf;
					var contentType = "application/pdf";
					if(utilityService.isAndroidPlatform()){
						taxInvoiceListVm.android = true;
						taxInvoiceListVm.folderpath = cordova.file.externalRootDirectory;
					}
					if(utilityService.isIOSPlatform()){
						taxInvoiceListVm.folderpath = cordova.file.applicationDirectory;
					}
					irctcService.savebase64AsPDFNew(taxInvoiceListVm.folderpath,filename,content,contentType);
					if (utilityService.isIOSPlatform()) {
						var finalObject = {
							"folderpath": taxInvoiceListVm.folderpath,
							"filename": filename
						};
						console.log(finalObject);
						openUrlInAppbroswerService.openUrl("data:application/pdf;base64," + content + "", "");
					}
					if(taxInvoiceListVm.android) {
						if (device.version == 10) {
							taxInvoiceListVm.folderpath = cordova.file.externalDataDirectory;
						}
						var imageURL = "img/irctc/irctc-success.svg";
                		var heading ='<h2 class="irctc-popup-heading">Successfully Downloaded Tax Invoice</h2>';
                		var alertMsg = '<div class="popup-padding font-dark-grey"><div><center><img class="approvedIconPosition" src="' + imageURL + '"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20">' + heading + '<span class="popUp-msg-color"></span></div></div><div class="popupTextBottomPadding"><div class="textAlignCenter">' + taxInvoiceListVm.folderpath + '<span class="popUp-msg-color"></span></div></div></div>';
			    		var taxInvoicepopUP = $ionicPopup.show({
							template: alertMsg,
							cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup irctc-exception',
							buttons: [{
								text: 'OK',
								type: 'button-positive',
								onTap: function (e) {
									taxInvoicepopUP.close();
								}
							}]
						});
					}
					
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		}

		$scope.$on('$ionicView.beforeEnter', function () {
			if (irctcService.username) {
				irctcService.userLinkedStatus = true;
				taxInvoiceListVm.username = irctcService.username;
			} else {
				taxInvoiceListVm.username = "Menu";
				taxInvoiceListVm.userLinkedStatus = false;
			}
			taxInvoiceListVm.showManageInfo = irctcService.userLinkedStatus;
			taxInvoiceListVm.isUserIDLinked = irctcService.userLinkedStatus;
			taxInvoiceListVm.taxInvoiceHandler();
		});

		return this;
	}
]);
