'use strict';
angularApp.controller('ticketConfirmationController', [
	"$state",
	"$scope",
	"$ionicPopup",
	"$translate",
	"$ionicHistory",
	"utilityService",
	"ionicDatePicker",
	"$ionicSideMenuDelegate",
	"irctcService",
	"customerInfoService",
	"openUrlInAppbroswerService",
	"clickStreamService",
	"homeScreenService",
	function ($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, irctcService, customerInfoService, openUrlInAppbroswerService, clickStreamService, homeScreenService) {
		var ticketConfirmationVm = this;
		ticketConfirmationVm.callBannerFunction = function () {
			irctcService.getIRCTCBannerdata('bookingConf').then(function (data) {
				ticketConfirmationVm.bannerData = data.completeTrainBooking
				console.log('banner Data ---->', data.completeTrainBooking);
			});
		};
		ticketConfirmationVm.goBack = function () {
			ticketConfirmationVm.bookAnotherTicket();
		};

		ticketConfirmationVm.paymentReceipt = function(){
           ticketConfirmationVm.downloadTicket(false,"payment");
		};

		ticketConfirmationVm.bookReturnTicket = function(){
				var searchTrainObj= {
	               "fromStation":irctcService.searchTrainObj.toStation,
	               "toStation":irctcService.searchTrainObj.fromStation,
	               "journeyDate":"",
	               "journeyClass":"",
	               "quota":""
               	};
               irctcService.searchTrainObj=searchTrainObj;
               irctcService.myList="";
               irctcService.selectedTrainData="";
               irctcService.myListFullData="";
			   $state.go('menu.irctcBookTicketSearch');
		};

		ticketConfirmationVm.bookAnotherTicket = function(){
			    irctcService.searchTrainObj="";
                irctcService.myList="";
                irctcService.masterData="";
                irctcService.selectedTrainData="";
                irctcService.myListFullData="";
			$state.go('menu.irctcBookTicketSearch');
		};

		 ticketConfirmationVm.toggleMenu = function(){
				ticketConfirmationVm.menu = !ticketConfirmationVm.menu;
			};

		ticketConfirmationVm.emailTicket = function () {
			ticketConfirmationVm.downloadTicket(true, "ticket");
		};

		ticketConfirmationVm.goToBanner = function (store) {
			clickStreamService.clickStreamData = "websiteId," + store.mobileCategoryCode;
			if (store.mobileContent != "") {
				var bannerPopMsg = store.mobileContent;
				var bannerPopup = $ionicPopup.show({
					title: 'TERMS & CONDITIONS',
					cssClass: 'irctc-custom-popup roboto-regular font-size-14 color-darkgrey text-center',
					template: bannerPopMsg,
					buttons: [{
						text: 'OK',
						type: 'button-assertive',
						onTap: function () {
							bannerPopup.close();
						}
					}],
				});
			} else {
				if (store.mobileCategoryCode.includes('OMP')) {
					homeScreenService.storeSelected = store.mobileBannerSubject;
					homeScreenService.categoryCode = store.mobileCategoryCode;
					$state.go('menu.merchantList');
				} else {
					try {
						$state.go(store.mobileRedirectionURL);
					} catch (err) {
						if(err) {
							irctcService.showPopOnError({
								bookingFlag: 'inValidURL',
								bookingMessage: "Something went wrong. Please try again after sometime."
							  });
						}
					}
				}
			}
		}

		ticketConfirmationVm.downloadTicket = function (isEmail, type) {
			var custEmailID = customerInfoService.customer.emailID;
			var txID = ticketConfirmationVm.bookedStatus.transactionId
				var obj = {
					"transactionId":txID,
					"isEmail":isEmail,
					"type":type
				};

				irctcService.getPDFTicket(obj).then(function (data) {


                  if(!isEmail){
		            var filename =  data.fileName+'.pdf';
		            var content =  data.pdf;
					var contentType = "application/pdf";
					if(utilityService.isAndroidPlatform()){
						ticketConfirmationVm.android = true;

						ticketConfirmationVm.folderpath = cordova.file.externalRootDirectory;
					}
					if(utilityService.isIOSPlatform()){
						ticketConfirmationVm.folderpath = cordova.file.applicationDirectory;
					}
					irctcService.savebase64AsPDFNew(ticketConfirmationVm.folderpath, filename, content, contentType);
					if (utilityService.isIOSPlatform()) {
						openUrlInAppbroswerService.openUrl("data:application/pdf;base64," + content + "", "");
					}
					if(ticketConfirmationVm.android) {
						if (device.version == 10) {
							ticketConfirmationVm.folderpath = cordova.file.externalDataDirectory;
						}
						var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="DOWNLOADFDRECEIPT" translate-values="{folderpath:ticketConfirmationVm.folderpath}"></div>';
			    			ticketConfirmationVm.downloadPopup = $ionicPopup.show({
			    				title: '',
			    				template: template,
			    				scope: $scope,
			    				cssClass: 'my-custom-popup',
			    				buttons: [{
			    					text:'OK',
			    					type: 'button-assertive',
			    					onTap: function() { 
			    						ticketConfirmationVm.downloadPopup.close();

			    					}
			    				}],
			    			});
					
					}
					ticketConfirmationVm.successPopup.close();
				} else {
					var alertPopup = $ionicPopup.alert({
						template: "<p style='text-align:center;font-weight:bold;font-size:16px'>Email and SMS has been sent successfully</p>"
					});
				}
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		};

		ticketConfirmationVm.generateQrCode  = function (qrImage) {
			if(qrImage) {
				var alertPopup = $ionicPopup.alert({
					template: "<img class='qrCodeImg' src='data:image/png;base64, "+ qrImage +"' alt='QR CODE' />",
					cssClass: 'scan-qr-popup removePopup-head popupWidth90 popupMargin popupBackgroundWhite ss-popup irctc-exception',
						buttons: [{
							text: 'OK',
							type: 'button-positive',
							onTap: function (e) {
								var element = angular.element(document.querySelector(".backdrop"));
								if(element){
									element.removeClass('qrcode-scanner-backdrop');
								}
								alertPopup.close();
							}
						}]
				});
				var elem = angular.element(document.querySelector(".backdrop"));
				if(elem){
					elem.addClass('qrcode-scanner-backdrop');
				}
			}
		};

		$scope.$on('$ionicView.beforeEnter', function () {
			ticketConfirmationVm.bookingCompleted = irctcService.bookingCompleted;
			ticketConfirmationVm.callBannerFunction();
			if (irctcService.username) {
				irctcService.userLinkedStatus = true;
				ticketConfirmationVm.username = irctcService.username;
			} else {
				ticketConfirmationVm.username = "Menu";
				ticketConfirmationVm.userLinkedStatus = false;
			}
			ticketConfirmationVm.showManageInfo = irctcService.userLinkedStatus;
			ticketConfirmationVm.bookedStatus = irctcService.bookingStatus;
			ticketConfirmationVm.bookedStatus.totalFare = irctcService.totalCollectableAmount;
			ticketConfirmationVm.bookedStatus.journeyQuota = irctcService.getArrayElement(ticketConfirmationVm.bookedStatus.journeyQuota, irctcService.masterData.trainQuota, 'myValue');
			if (ticketConfirmationVm.bookingCompleted) {
				ticketConfirmationVm.passengerList = ticketConfirmationVm.bookedStatus.psgnDtlList;
			} else {
				ticketConfirmationVm.passengerList = irctcService.passToBeDisplayed;
			}
			ticketConfirmationVm.trainData = irctcService.selectedTrainData;
			ticketConfirmationVm.classQuota = ticketConfirmationVm.trainData.avlFareEnq.enqClass + ', ' + irctcService.searchQuotaVal;
			ticketConfirmationVm.trainData = irctcService.selectedTrainData;
			ticketConfirmationVm.sourceTime = ticketConfirmationVm.trainData.departureTime;
			ticketConfirmationVm.destTime = ticketConfirmationVm.trainData.arrivalTime;
			ticketConfirmationVm.trainDuration = ticketConfirmationVm.trainData.duration;
	        ticketConfirmationVm.trainNumber = ticketConfirmationVm.trainData.trainNumber;
	        ticketConfirmationVm.trainName = ticketConfirmationVm.trainData.trainName;
	        ticketConfirmationVm.trainDate=irctcService.searchDate;
	        ticketConfirmationVm.stationTo = irctcService.getStationNameCode(ticketConfirmationVm.trainData.toStnCode,irctcService.stationCodeArray,irctcService.stationNameArray);
	        ticketConfirmationVm.stationFrom = irctcService.getStationNameCode(ticketConfirmationVm.trainData.fromStnCode,irctcService.stationCodeArray,irctcService.stationNameArray);
	        ticketConfirmationVm.mobileNumber = irctcService.selectedTrainData.mobileNo;
		});

		return this;
	}
]);
