'use strict';
angularApp.controller('travellerContactDetailsController', [
    "$state",
    "$scope",
    "$ionicPopup",
    "$translate",
    "$ionicHistory",
    "utilityService",
    "ionicDatePicker",
    "$ionicSideMenuDelegate",
    "$ionicScrollDelegate",
    "irctcService",
    "validateService",
    "customerInfoService",
    function ($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, $ionicScrollDelegate, irctcService, validateService, customerInfoService) {
        var travellerContactDetailsVm = this;

        travellerContactDetailsVm.goBack = function () {
            irctcService.selectedTrainData.boardingPoint = travellerContactDetailsVm.boardingStation;
            $ionicHistory.goBack(-1);
        };

        travellerContactDetailsVm.showInfoPopup = function () {
            var havingMPINPrblmPopUp = $ionicPopup.show({
                template: '<p translate="IRCTC_BRD_INFO"></p>',
                title: '',
                cssClass: 'dialog',
                scope: $scope,
                buttons: [{
                    text: 'OK',
                    type: 'button-positive'
                }]
            });
        };

        travellerContactDetailsVm.showGSTDetails = function () {
            $ionicScrollDelegate.resize();
        };

        travellerContactDetailsVm.goToNextPage = function () {
            var errMsg = irctcService.isValidMobileNo(travellerContactDetailsVm.mobile);
            if (errMsg) {
                utilityService.showErrorMessage(errMsg);
            } else {
                irctcService.selectedTrainData.isAutoUpgrade = travellerContactDetailsVm.optAutoUpgrade;
                irctcService.selectedTrainData.mobileNo = travellerContactDetailsVm.mobile;
                irctcService.selectedTrainData.boardingPoint = travellerContactDetailsVm.boardingStation;
                var stName = travellerContactDetailsVm.boardingStation.split('-');
                irctcService.selectedTrainData.boardingPointCode = stName[1];

                if (travellerContactDetailsVm.optGST) {
                    var validGST = validateService.isValidGSTNumber(travellerContactDetailsVm.trainData.avlFareEnq.bkgCfg.gstinPattern, travellerContactDetailsVm.gstNumber);
                    if (!validGST) {
                        utilityService.showErrorMessage("Please enter valid GST number");
                        return;
                    }
                    else if (!travellerContactDetailsVm.flat) {
                        utilityService.showErrorMessage("Please enter valid Flat");
                        return;
                    }
                    else if (!travellerContactDetailsVm.city) {
                        utilityService.showErrorMessage("Please enter valid City");
                        return;
                    }
                    else if (!travellerContactDetailsVm.state) {
                        utilityService.showErrorMessage("Please enter valid State");
                        return;
                    }
                } else if ($scope.destinationAddressFlag) {
                    $scope.destinationAddress1EmptyErrorFlag=false;
                    $scope.destinationAddress1ErrorFlag = false;
                    $scope.destinationAddress2ErrorFlag = false;
                    $scope.destinationAddress3ErrorFlag = false;
                    $scope.destinationPincodeEmptyErrorFlag = false;
                    $scope.destinationPincodeLengthErrorFlag = false;
                    $scope.destinationPOErrorFlag = false;
                    $scope.destinationCityErrorFlag = false;
                   
                    var validAddress2 = true;
                    var validAddress3 = true;
                    var validAddress1 = validateService.isValidDestAddress(travellerContactDetailsVm.destinationAddress1);
                    var validPIN = validateService.isValidDestPinCode(travellerContactDetailsVm.destinationPincode);

                    if (travellerContactDetailsVm.destinationAddress2) {
                        validAddress2 = validateService.isValidDestAddress(travellerContactDetailsVm.destinationAddress2);
                    }
                    if (travellerContactDetailsVm.destinationAddress3) {
                        validAddress3 = validateService.isValidDestAddress(travellerContactDetailsVm.destinationAddress3);
                    }


                    if (!travellerContactDetailsVm.destinationAddress1) {
                        $scope.destinationAddress1EmptyErrorFlag = true;
                      
                    }else if (!validAddress1) {
                        $scope.destinationAddress1ErrorFlag = true;
                       
                    }
                     if (travellerContactDetailsVm.destinationAddress2 && !validAddress2) {
                        $scope.destinationAddress2ErrorFlag = true;
                       
                    }
                     if (travellerContactDetailsVm.destinationAddress3 && !validAddress3) {
                        $scope.destinationAddress3ErrorFlag = true;
                        
                    }  if (!travellerContactDetailsVm.destinationPincode) {
                        $scope.destinationPincodeEmptyErrorFlag = true;
                        
                    }
                     else if (!validPIN) {
                        $scope.destinationPincodeLengthErrorFlag = true;
                        
                    } if (!travellerContactDetailsVm.destinationCity) {
                        $scope.destinationCityErrorFlag = true;
                       
                    }
                    if (!travellerContactDetailsVm.destinationPostOffice) {
                        $scope.destinationPOErrorFlag = true;
                       
                    }
                    if( $scope.destinationAddress1EmptyErrorFlag==true || 
                        $scope.destinationAddress1ErrorFlag == true ||
                        $scope.destinationAddress2ErrorFlag == true ||
                        $scope.destinationAddress3ErrorFlag == true ||
                        $scope.destinationPincodeEmptyErrorFlag == true ||
                        $scope.destinationPincodeLengthErrorFlag == true ||
                        $scope.destinationPOErrorFlag == true || 
                        $scope.destinationCityErrorFlag == true){
                            return false;

                    }

                }
                travellerContactDetailsVm.checkBooking();
            }
        };

        travellerContactDetailsVm.checkBooking = function () {
            var passObj = [];
            var passengers = travellerContactDetailsVm.passengerList;
            for (var i = 0; i < passengers.length; i++) {
                var passSerial = i + 1;
                var concessionCheck = "";
                if ((passengers[i].age > 59 && passengers[i].gender == 'M') || (passengers[i].age > 57 && passengers[i].gender == 'F') || (passengers[i].age > 59 && passengers[i].gender == 'T')) {
                    concessionCheck = passengers[i].concession;
                } else {
                    concessionCheck = "";
                }
                var idCardFlag = false;
                if (passengers[i].idCardNumber) {
                    idCardFlag = true;
                }
                var pObj = {
                    "concessionOpted": concessionCheck,
                    "passengerBerthChoice": passengers[i].berthPref,
                    "passengerAge": passengers[i].age,
                    "passengerBedrollChoice": passengers[i].bedRoll,
                    "childBerthFlag": passengers[i].childBerthFlag,
                    "passengerGender": passengers[i].gender,
                    "passengerName": passengers[i].fullName,
                    "passengerSerialNumber": passSerial,
                    "passengerNationality": passengers[i].nationality,
                    "passengerFoodChoice": passengers[i].mealPref,
                    "addToList": passengers[i].addToList,
                    "isInfant": passengers[i].isInfant,
                    "passengerIcardFlag": idCardFlag,
                    "passengerCardNumber": passengers[i].idCardNumber,
                    "passengerCardType": passengers[i].idCardType,
                    "sequenceNo": passengers[i].sequenceNo
                };
                passObj.push(pObj)
            }

            var gstDetail;
            if (travellerContactDetailsVm.optGST) {
                gstDetail = {
                    "gstIn": travellerContactDetailsVm.gstNumber,
                    "nameOnGst": travellerContactDetailsVm.gstCompany,
                    "flat": travellerContactDetailsVm.flat,
                    "street": travellerContactDetailsVm.street,
                    "pin": travellerContactDetailsVm.gstPin,
                    "state": travellerContactDetailsVm.state,
                    "stateCode": travellerContactDetailsVm.stateCode ? travellerContactDetailsVm.stateCode : "",
                    "city": travellerContactDetailsVm.city,
                    "area": travellerContactDetailsVm.area
                };

            } else {
                gstDetail = null;
            }

            //Boarding Point Train Service
            var obj = {
                "trainNo": travellerContactDetailsVm.trainData.trainNumber,
                "trainName": travellerContactDetailsVm.trainName,
                "journeyDate": travellerContactDetailsVm.jDate,
                "frmStn": travellerContactDetailsVm.stationFrom,
                "toStn": travellerContactDetailsVm.stationTo,
                "journeyClass": travellerContactDetailsVm.trainData.avlFareEnq.enqClass,
                "journeyQuota": irctcService.searchQuota,
                "autoUpgardationSelected": irctcService.selectedTrainData.isAutoUpgrade,
                "ignoreChoiceIfWl": "true",
                "mobileNumber": irctcService.selectedTrainData.mobileNo,
                "reservationChoice": travellerContactDetailsVm.selectedBerthAllotment,
                "boardingPoint": travellerContactDetailsVm.boardingStation,
                "coachId": travellerContactDetailsVm.coachID,
                "wsUserLogin": "",
                "clientTransactionId": "",
                "travelInsuranceOpted": travellerContactDetailsVm.optTravelInsurance,
                "passengerList": passObj, // array of passenger
                "agentDeviceId": "",
                "cache": "true",
                "mainJourneyTxnId": "",
                "atasOpted": "",
                "gstDetails": gstDetail,
                "gstDeatailInputFlag": travellerContactDetailsVm.optGST ? true : false,
                "duration": travellerContactDetailsVm.trainDuration
            };
            /** Destination address obj**/
            if($scope.destinationAddressFlag){
                obj.tktAddress= {
                "address": travellerContactDetailsVm.destinationAddress1,
                "street":  travellerContactDetailsVm.destinationAddress2 ?  travellerContactDetailsVm.destinationAddress2 : "",
                "colony":travellerContactDetailsVm.destinationAddress3 ?  travellerContactDetailsVm.destinationAddress3 : "",
                "pinCode":  travellerContactDetailsVm.destinationPincode,
                "stateName":  $scope.destinationState,
                "stateCode": travellerContactDetailsVm.stateCode ? travellerContactDetailsVm.stateCode : "",
                "city":  travellerContactDetailsVm.destinationCity,
                "postOffice": travellerContactDetailsVm.destinationPostOffice
                };
                irctcService.destinationAddress=obj.tktAddress;
                irctcService.destinationAddress.destinationCityList=$scope.destinationCityList;
                irctcService.destinationAddress.destinationPOList=$scope.destinationPOList;

            }else{
                irctcService.destinationAddress="";
            }
           
            irctcService.preBookingObj=obj;
            $state.go('menu.bookingFlow');
           /* irctcService.preBooking(obj).then(function (data) {
                irctcService.reviewDetails = data;
                irctcService.accList = data.accounts;
                irctcService.availabilityStatus = data.avlDayList[0].availablityStatus;
              
                $state.go('menu.ticketReview');
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });*/
        };

        travellerContactDetailsVm.bookingPolicy = function () {
            callTnC("eTicketPolicy");
        };

        travellerContactDetailsVm.insurancePolicy = function () {
            callTnC("travelInsurance");
        };

        travellerContactDetailsVm.boardingStationList = function (fromSTN, toSTN, jrnyDate, jrnyClass, trainNo) {
            //Boarding Point Train Service
            irctcService.getBoardingPoint(fromSTN, toSTN, jrnyDate, jrnyClass, trainNo).then(function (data) {
                travellerContactDetailsVm.boardingStations = data.boardingStationList;
                irctcService.boardingStations = travellerContactDetailsVm.boardingStations;
                travellerContactDetailsVm.boardingStation = travellerContactDetailsVm.boardingStations[0].stnNameCode;
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        };

        travellerContactDetailsVm.toggleMenu = function () {
            travellerContactDetailsVm.menu = !travellerContactDetailsVm.menu;
        };

        $scope.$on('$ionicView.afterEnter', function () {
            travellerContactDetailsVm.disablenext = false;
        });

        travellerContactDetailsVm.validateMobileNumber = function () {
            if (travellerContactDetailsVm.optBookingPolicy && travellerContactDetailsVm.mobile) {
                if (travellerContactDetailsVm.mobile.length == 10) {
                    travellerContactDetailsVm.disablenext = false;
                } else {
                    travellerContactDetailsVm.disablenext = true;
                }
            } else {
                travellerContactDetailsVm.disablenext = true;
            }
        };

        travellerContactDetailsVm.checkTerms = function () {
            if (travellerContactDetailsVm.optBookingPolicy && travellerContactDetailsVm.mobile) {
                if (travellerContactDetailsVm.mobile.length == 10) {
                    travellerContactDetailsVm.disablenext = false;
                } else {
                    travellerContactDetailsVm.disablenext = true;
                }
            } else {
                travellerContactDetailsVm.disablenext = true;
            }
        };

        travellerContactDetailsVm.loadCityState = function () {
            if (travellerContactDetailsVm.gstPin.length == 6) {
                var obj = {
                    "pinCode": travellerContactDetailsVm.gstPin
                };
                irctcService.getPincodeData(obj).then(function (data) {
                    travellerContactDetailsVm.city = data.districtName;
                    travellerContactDetailsVm.state = data.stateName;
                    travellerContactDetailsVm.stateCode = data.stateCode;
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        };

        function callTnC(key) {
            var reqParams = {};
            reqParams.type = key;
            irctcService.getTnC(reqParams).then(function (data) {
                travellerContactDetailsVm.terms = $ionicPopup.show({
                    title: "",
                    cssClass: 'ftandcpopup-body popupBackgroundWhite popupWidth90  popupBackgroundDark',
                    template: data,
                    scope: $scope,
                    buttons: [
                        {
                            text: '<b>Ok</b>',
                            type: 'button-positive',
                            onTap: function (e) {
                                travellerContactDetailsVm.terms.close();
                            }
                        }
                    ]
                });

            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        /** Destination address code starts here **/
        /** Fetch Pincode service starts **/
        $scope.fetchDestinationCityState = function (destinationPincode) {
            if(validateService.isValidDestPinCode(destinationPincode)){
                 var requestParam = {
                    "pincode": destinationPincode
                 };
        
                irctcService.fetchDestCityState(requestParam).then(function (response) {
                    $scope.destinationCityList=response.cityList;
                    $scope.destinationPOList= response.postofficeList ? response.postofficeList : [];
                    $scope.destinationState=response.state;
                    travellerContactDetailsVm.destinationCity="";
                    travellerContactDetailsVm.destinationPostOffice="";
                    if($scope.destinationCityList.length==1){
                        travellerContactDetailsVm.destinationCity=$scope.destinationCityList[0];
                    }
                    if($scope.destinationPOList.length==1){
                        travellerContactDetailsVm.destinationPostOffice=$scope.destinationPOList[0];
                    }
               
                }, function (error) {
                    $scope.destinationCityList=[];
                    $scope.destinationPOList= [];
                    $scope.destinationState="";
                    travellerContactDetailsVm.destinationCity="";
                    travellerContactDetailsVm.destinationPostOffice="";
                    travellerContactDetailsVm.destinationPincode="";
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        }
        /** Fetch Pincode service ends **/

        /** Fetch POST Office through pincode and city service starts **/
        $scope.fetchDestinationPO = function (destinationPincode,destinationCity) {
            var requestParam = {
                "pincode": destinationPincode,
                "city": destinationCity
            };
            irctcService.fetchDestPO(requestParam).then(function (response) {
                $scope.destinationPOList= response.postofficeList;
                travellerContactDetailsVm.destinationPostOffice="";
                if($scope.destinationPOList.length==1){
                    travellerContactDetailsVm.destinationPostOffice=$scope.destinationPOList[0];
                }

            }, function (error) {
                $scope.destinationPOList= [];
                travellerContactDetailsVm.destinationPostOffice="";
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
        /** Fetch POST Office through pincode and city service ends **/
        /** Reset city and State starts**/
        $scope.clearCityState = function () {
                $scope.destinationCityList=[];
                $scope.destinationPOList= [];
                $scope.destinationState="";
                travellerContactDetailsVm.destinationCity="";
                travellerContactDetailsVm.destinationPostOffice="";
        }
        /** Reset city and State ends**/
         /** Destination address code starts here **/


        $scope.$on('$ionicView.beforeEnter', function () {
            irctcService.preBookingObj={};
            travellerContactDetailsVm.resChoice = irctcService.masterData.reservationChoice;
            travellerContactDetailsVm.optBookingPolicy = true;
            if (irctcService.username) {
                irctcService.userLinkedStatus = true;
                travellerContactDetailsVm.username = irctcService.username;
            } else {
                travellerContactDetailsVm.username = "Menu";
                travellerContactDetailsVm.userLinkedStatus = false;
            }
            travellerContactDetailsVm.showManageInfo = irctcService.userLinkedStatus;
            if (travellerContactDetailsVm.optBookingPolicy && travellerContactDetailsVm.mobile) {
                if (travellerContactDetailsVm.mobile.length == 10) {
                    travellerContactDetailsVm.disablenext = false;
                } else {
                    travellerContactDetailsVm.disablenext = true;
                }
            } else {
                travellerContactDetailsVm.disablenext = true;
            }
            travellerContactDetailsVm.availibilityStatus = irctcService.availabilityStatus;
            if (parseInt(irctcService.availabilityStatusType) == 1 || parseInt(irctcService.availabilityStatusType) == 2) {
                travellerContactDetailsVm.isTravelInsuranceEnabled = true;
                travellerContactDetailsVm.optTravelInsurance = true;
                travellerContactDetailsVm.optTravelInsurance = "true";
            } else {
                travellerContactDetailsVm.isTravelInsuranceEnabled = false;
                travellerContactDetailsVm.optTravelInsurance = "false";
            }
            travellerContactDetailsVm.mobile = customerInfoService.customer.mobile;
            if (irctcService.selectedTrainData.mobileNo) {
                travellerContactDetailsVm.mobile = irctcService.selectedTrainData.mobileNo;
            }
            travellerContactDetailsVm.disableback = false;
            travellerContactDetailsVm.showBack = true;
            travellerContactDetailsVm.showNext = true;
            travellerContactDetailsVm.optGST = false;
            travellerContactDetailsVm.totalPassengers = irctcService.totalTravellers;
            travellerContactDetailsVm.trainData = irctcService.selectedTrainData;
            travellerContactDetailsVm.sourceTime = travellerContactDetailsVm.trainData.departureTime;
            travellerContactDetailsVm.destTime = travellerContactDetailsVm.trainData.arrivalTime;
            travellerContactDetailsVm.trainDuration = travellerContactDetailsVm.trainData.duration;
            travellerContactDetailsVm.trainNumber = travellerContactDetailsVm.trainData.trainNumber;
            travellerContactDetailsVm.trainName = travellerContactDetailsVm.trainData.trainName;
            travellerContactDetailsVm.stationTo = irctcService.getStationNameCode(travellerContactDetailsVm.trainData.toStnCode, irctcService.stationCodeArray, irctcService.stationNameArray);
            travellerContactDetailsVm.stationFrom = irctcService.getStationNameCode(travellerContactDetailsVm.trainData.fromStnCode, irctcService.stationCodeArray, irctcService.stationNameArray);
            travellerContactDetailsVm.trainDate = irctcService.searchDate;
            travellerContactDetailsVm.passengerList = irctcService.myList;
            var tomorrow = new Date(irctcService.searchDate);
            tomorrow.setDate(tomorrow.getDate() + 1);
            var dateString = new Date(tomorrow).toISOString().slice(0, 10);
            travellerContactDetailsVm.jDate = dateString.replace(/-/g, "");
            travellerContactDetailsVm.insuranceLabel = travellerContactDetailsVm.trainData.avlFareEnq.bkgCfg.travelInsuranceFareMsg
            travellerContactDetailsVm.selectedBerthAllotment = travellerContactDetailsVm.resChoice[0].key;
            travellerContactDetailsVm.totalTravellers = travellerContactDetailsVm.totalPassengers + ' Traveller(s) ';
            travellerContactDetailsVm.classQuota = travellerContactDetailsVm.trainData.avlFareEnq.enqClass + ', ' + irctcService.searchQuotaVal;
            if (irctcService.boardingStations) {
                travellerContactDetailsVm.boardingStations = irctcService.boardingStations;
                travellerContactDetailsVm.boardingStation = irctcService.selectedTrainData.boardingPoint;
            }
            else {
                travellerContactDetailsVm.boardingStationList(travellerContactDetailsVm.stationFrom, travellerContactDetailsVm.stationTo, travellerContactDetailsVm.jDate, travellerContactDetailsVm.trainData.avlFareEnq.enqClass, travellerContactDetailsVm.trainNumber)
            }

            /** Flag to set whether to show destination address or not and set default value**/
            $scope.destinationCityList = [];
            $scope.destinationPOList = [];
            travellerContactDetailsVm.destinationCity="";
            travellerContactDetailsVm.destinationPostOffice="";
            $scope.destinationAddressFlag=false;
            var destinationAddressFlagCheck = travellerContactDetailsVm.trainData.avlFareEnq.bkgCfg.captureAddress;
            if(destinationAddressFlagCheck=="1"){
                $scope.destinationAddressFlag=true;
            }
            if(irctcService.destinationAddress){
                var destAddress=irctcService.destinationAddress;
                travellerContactDetailsVm.destinationAddress1= destAddress.address;
                travellerContactDetailsVm.destinationAddress2= destAddress.street;
                travellerContactDetailsVm.destinationAddress3= destAddress.colony;
                travellerContactDetailsVm.destinationPincode= destAddress.pinCode;
                $scope.destinationState= destAddress.stateName;
                $scope.destinationCityList= irctcService.destinationAddress.destinationCityList;
                $scope.destinationPOList= irctcService.destinationAddress.destinationPOList;
                travellerContactDetailsVm.destinationCity= destAddress.city;
                travellerContactDetailsVm.destinationPostOffice= destAddress.postOffice;


            }
           
            /** Flag to set whether to show destination address or not**/

        });

        return this;
    }
]);
