'use strict';
angularApp.controller('travellerMyListController', [
    "$state",
    "$scope",
    "$ionicPopup",
    "$translate",
    "$ionicHistory",
    "utilityService",
    "ionicDatePicker",
    "$ionicSideMenuDelegate",
    "irctcService",
    function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, irctcService) {
        var travellerMyListVm = this;
        travellerMyListVm.editExistingUserId = false;

        travellerMyListVm.goBack = function() {
           $state.go('menu.irctcBookTicketSearchResult');
        }

        travellerMyListVm.goBacktoPrevious = function() {
            $state.go('menu.irctcBookTicketSearchResult');
        }

        travellerMyListVm.editUserId = function(){
            travellerMyListVm.editExistingUserId == false ? travellerMyListVm.editExistingUserId = true : travellerMyListVm.editExistingUserId = false;
        }

        travellerMyListVm.changeIrctcUser = function(){
            var uName = travellerMyListVm.irctcNewUser;
            irctcService.authenticateUser(uName).then(function(data) {
                irctcService.userLinkedStatus = true;
                irctcService.username = uName;
                travellerMyListVm.username = irctcService.username;
                travellerMyListVm.editUserId();
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        travellerMyListVm.showList = function(index) {
           travellerMyListVm.passArray[index].showTraveller = true;

        }

        travellerMyListVm.showPopUP=function(isChild)
        {
            if(isChild)
            {

            var alertPopup = $ionicPopup.alert({
                                template: "<p style='text-align:center;font-weight:bold;font-size:16px'>Full fare will be charged if seat/berth is opted for child.</p>",
                                    buttons: [
                            
                            {
                              text: '<b>Ok</b>',
                              type: 'button-positive',
                              onTap: function(e) {
                               alertPopup.close();
                             
                              }
                            }
                          ]
                            });
            }

        }

        travellerMyListVm.getCountry = function() {
            irctcService.getCountry().then(function(data) {
                travellerMyListVm.nationCategory = data;
                if (travellerMyListVm.passArray.length == 0) {
                    travellerMyListVm.addTraveller();
                }

            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

        }

        travellerMyListVm.updateAge = function(index) {
            if (travellerMyListVm.passArray[index].gender == "M") {
                if (travellerMyListVm.passArray[index].age >= 60 && travellerMyListVm.passArray[index].age <= 125) {
                    travellerMyListVm.passArray[index].concession = "true";
                } else {
                    travellerMyListVm.passArray[index].concession = "";
                }
            }
            if (travellerMyListVm.passArray[index].gender == "F") {
                if (travellerMyListVm.passArray[index].age >= 58 && travellerMyListVm.passArray[index].age <= 125) {
                   travellerMyListVm.passArray[index].concession = "true";
                } else {
                    travellerMyListVm.passArray[index].concession = "";
                }
            }
              if(travellerMyListVm.passArray[index].age>=5 && travellerMyListVm.passArray[index].age<=11)
             {   
            if(travellerMyListVm.childBerthMandatory=="true")
            {
             travellerMyListVm.passArray[index].childBerthFlag=true;
            }
        }
         else{
            travellerMyListVm.passArray[index].childBerthFlag=false;
         }
        }

        travellerMyListVm.isValidPassportNo = function(passportNo) {
            var passportPattern = /^[A-PR-WY][1-9]\d\s?\d{4}[1-9]$/ig;
            if (!passportNo) {
                return " Passport no.";
            }
            passportNo = passportNo.toUpperCase();
            if (!passportPattern.test(passportNo)) {
                return " valid Passport no.";
            }
            return false;
        };

        function validateData() {
            var errormsg = "";
            var ageAndNameMsg = "";
            for (var i = 0; i < travellerMyListVm.passArray.length; i++) {
                var index = i + 1;
                if (!travellerMyListVm.passArray[i].fullName) {
                    errormsg = "Name of Traveller " + index;
                    break;
                }

                if (!travellerMyListVm.passArray[i].age) {
                    errormsg = "Age of Traveller " + index;
                    break;
                }
                if (travellerMyListVm.passArray[i].fullName.length < 3) {
                    ageAndNameMsg = "Name of Traveller " + index + " cannot be less than 3 characters";
                    break;
                }

                if (travellerMyListVm.passArray[i].age) {
                    if (travellerMyListVm.passArray[i].isInfant) {
                        if (travellerMyListVm.passArray[i].age >= 5) {
                            ageAndNameMsg = "Age of Traveller " + index + " cannot be greater than 4 years";
                            break;
                        }

                        if(travellerMyListVm.passArray[i].age==0){
                             ageAndNameMsg = "Age of Traveller " + index + " cannot be 0";
                             break;
                        }
                    } else {
                        if (travellerMyListVm.passArray[i].age < 5) {
                            ageAndNameMsg = ageAndNameMsg + "Age of Traveller " + index + " cannot be less than 5 years";
                            break;
                        }

                        if (travellerMyListVm.passArray[i].age > parseInt(travellerMyListVm.maxAge)) {
                            ageAndNameMsg = "Age of Traveller " + index + " should be less than " + travellerMyListVm.maxAge;
                            break;
                        }

                        if (travellerMyListVm.passArray[i].nationality != 'IN') {
                            var isValidPass = travellerMyListVm.isValidPassportNo(travellerMyListVm.passArray[i].idCardNumber);
                            if (isValidPass) {
                                errormsg = isValidPass + " of Traveller " + index;
                            }
                        }
                    }
                }

                if(irctcService.searchTrainObj.quota == 'LD'){
                    if(travellerMyListVm.passArray[i].gender != 'F'){
                        ageAndNameMsg = "Passenger "+index+" cannot be Male/Transgender for selected Quota.";
                    }
                }
            }

                for (var i = 0; i < travellerMyListVm.infantArray.length; i++) {
                var index = i + 1;
                if (!travellerMyListVm.infantArray[i].fullName) {
                    errormsg = "Name of Infant " + index;
                    break;
                }
                if (!travellerMyListVm.infantArray[i].age) {
                    errormsg = "Age of Infant " + index;
                    break;
                }
                if (travellerMyListVm.infantArray[i].fullName.length < 3) {
                    ageAndNameMsg = "Name of Infant " + index + " cannot be less than 3 characters";
                    break;
                }
                if (travellerMyListVm.infantArray[i].age) {
                    if (travellerMyListVm.infantArray[i].isInfant) {
                        if (travellerMyListVm.infantArray[i].age >= 5) {
                            ageAndNameMsg = "Age of Infant " + index + " cannot be greater than 4 years";
                            break;
                        }
                        if(travellerMyListVm.infantArray[i].age==0){
                             ageAndNameMsg = "Age of Infant " + index + " cannot be 0";
                             break;
                        }
                    } else {
                        if (travellerMyListVm.infantArray[i].age < 5) {
                            ageAndNameMsg = ageAndNameMsg + "Age of Infant " + index + " cannot be less than 5 years";
                            break;
                        }
                        if (travellerMyListVm.infantArray[i].age > parseInt(travellerMyListVm.maxAge)) {
                            ageAndNameMsg = "Age of Infant " + index + " should be less than " + travellerMyListVm.maxAge;
                            break;
                        }
                        if (travellerMyListVm.infantArray[i].nationality != 'IN') {
                            var isValidPass = travellerMyListVm.isValidPassportNo(travellerMyListVm.infantArray[i].idCardNumber);
                            if (isValidPass) {
                                errormsg = isValidPass + " of Infant " + index;
                            }
                        }
                    }
                }
            }
            if (errormsg) {
                errormsg = "Please Enter " + errormsg;
            }
            if (ageAndNameMsg) {
                errormsg = ageAndNameMsg;
            }
            return errormsg;
        }

        travellerMyListVm.goToNextPage = function() {
            var messageToDisplay = validateData();
            if (messageToDisplay) {
                utilityService.showErrorMessage(messageToDisplay);
            } else {
                if(travellerMyListVm.passArray.length > 0 ){
                    irctcService.totalTravellers = travellerMyListVm.passArray.length;
                    irctcService.infantArray=travellerMyListVm.infantArray;
                    irctcService.passArray=travellerMyListVm.passArray;
                    travellerMyListVm.myList=travellerMyListVm.passArray.concat(travellerMyListVm.infantArray);
                     irctcService.myList = travellerMyListVm.myList;
                }
                $state.go('menu.travellerContactDetails');
                //$state.go('menu.bookingFlow');
            }
        }

        travellerMyListVm.changeIdCardType = function(index) {
            if (travellerMyListVm.passArray[index].nationality == "IN") {
                travellerMyListVm.idCardTypes = travellerMyListVm.trainData.avlFareEnq.bkgCfg.validIdCardTypes;;
                travellerMyListVm.passArray[index].idCardType = travellerMyListVm.idCardTypes[0];
                travellerMyListVm.passArray[index].idCardNumber = "";
                travellerMyListVm.isIDRequired = true;
            } else {
                var types = ["PASSPORT"];
                travellerMyListVm.idCardTypes = types;
                travellerMyListVm.passArray[index].idCardType = travellerMyListVm.idCardTypes[0];
                travellerMyListVm.passArray[index].idCardNumber = "";
                travellerMyListVm.passArray[index].concession = "false";
                travellerMyListVm.isIDRequired = false;
                travellerMyListVm.passArray[index].concession = "false";
            }

        }

        travellerMyListVm.deletePassenger = function(index,isInfant) {

            if(isInfant==true)
            {
                 travellerMyListVm.infantArray.splice(index, 1);
            }
            else
            {
            travellerMyListVm.passArray.splice(index, 1);
            }
             travellerMyListVm.myList=travellerMyListVm.passArray.concat(travellerMyListVm.infantArray); 
            travellerMyListVm.totalPassengers = travellerMyListVm.passArray.length;
        }

        travellerMyListVm.toggleMenu = function() {
            travellerMyListVm.menu = !travellerMyListVm.menu;
        }

        travellerMyListVm.updateTravellerData = function(name, index,isInfant) {
            travellerMyListVm.passArray[index].showTraveller=false;
		 if(isInfant==false)
            {
			for (var i = 0; i < irctcService.myListFullData.length; i++) {
                if (irctcService.myListFullData[i].fullName == name) {
                    travellerMyListVm.passArray[index] = angular.copy(irctcService.myListFullData[i]);
                    if (travellerMyListVm.trainData.avlFareEnq.bkgCfg.foodChoiceEnabled == "true") {
                        if (! travellerMyListVm.passArray[index].mealPref) {
                             travellerMyListVm.passArray[index].mealPref = "V";
                        }
                    } else {
                        travellerMyListVm.passArray[index].mealPref = "";
                    }

                    if (travellerMyListVm.passArray[index].gender == "M") {
                        if ( travellerMyListVm.passArray[index].age >= 60 && travellerMyListVm.passArray[index].age <= 125) {
                             travellerMyListVm.passArray[index].concession = "true";
                        } 
                    }

                    if (travellerMyListVm.passArray[index].gender == "F") {
                        if ( travellerMyListVm.passArray[index].age >= 58 &&  travellerMyListVm.passArray[index].age <= 125) {
                            travellerMyListVm.passArray[index].concession = "true";
                        } 
                    }

                    if (travellerMyListVm.passArray[index].gender == "T") {
                        if ( travellerMyListVm.passArray[index].age >= 60 && travellerMyListVm.passArray[index].age <= 125) {
                             travellerMyListVm.passArray[index].concession = "true";
                        } 
                    }
                    if (isInfant==true) {
                         travellerMyListVm.passArray[index].isInfant = true;
                    }

                    var isBirthAvailable = travellerMyListVm.checkBerth(travellerMyListVm.passArray[index].berthPref);
                    if (!isBirthAvailable) {
                       travellerMyListVm.passArray[index].berthPref = travellerMyListVm.berthCategory[0].key;
                    }
                    if(!travellerMyListVm.passArray[index].nationality){
                        travellerMyListVm.passArray[index].nationality ='IN';
                    }
                    travellerMyListVm.passArray[index].isExpand = true;
                    break;
                }
            }
        }
        else{
                for (var i = 0; i < irctcService.myListFullData.length; i++) {
                if (irctcService.myListFullData[i].fullName == name) {
                    travellerMyListVm.infantArray[index] = irctcService.myListFullData[i];
                    if (travellerMyListVm.trainData.avlFareEnq.bkgCfg.foodChoiceEnabled == "true") {
                        if (!travellerMyListVm.infantArray[index].mealPref) {
                            travellerMyListVm.infantArray[index].mealPref = "V";
                        }
                    } else {
                        travellerMyListVm.infantArray[index].mealPref = "";
                    }

                    if (travellerMyListVm.infantArray[index].gender == "M") {
                        if (travellerMyListVm.infantArray[index].age >= 60 && travellerMyListVm.infantArray[index].age <= 125) {
                            travellerMyListVm.infantArray[index].concession = "true";
                        } 
                    }
                    if (travellerMyListVm.infantArray[index].gender == "F") {
                        if (travellerMyListVm.infantArray[index].age >= 58 && travellerMyListVm.infantArray[index].age <= 125) {
                            travellerMyListVm.infantArray[index].concession = "true";
                        } 
                    }
                    if (travellerMyListVm.infantArray[index].gender == "T") {
                        if (travellerMyListVm.infantArray[index].age >= 60 && travellerMyListVm.infantArray[index].age <= 125) {
                            travellerMyListVm.infantArray[index].concession = "true";
                        } 
                    }
                    if (isInfant==true) {
                        travellerMyListVm.infantArray[index].isInfant = true;
                    }
                    var isBirthAvailable = travellerMyListVm.checkBerth(travellerMyListVm.infantArray[index].berthPref);
                    if (!isBirthAvailable) {
                        travellerMyListVm.infantArray[index].berthPref = travellerMyListVm.berthCategory[0].key;
                    }
                    travellerMyListVm.infantArray[index].isExpand = true;
                    break;
                }
            }
        }
         travellerMyListVm.showMyListTraveller = false;
          travellerMyListVm.passArray[index].showTraveller=false;
		 

        }

        travellerMyListVm.checkBerth = function(recBerth) {
            var list = travellerMyListVm.trainData.avlFareEnq.bkgCfg.applicableBerthTypes;
            for (var i = 0; i < list.length; i++) {
                if (list[i] == recBerth) {
                    return true;
                }
            }
            return false;
        }

        function CreateNameArray(data) {

            travellerMyListVm.FullNameData = [];
            for (var i = 0; i < data.length; i++) {
                travellerMyListVm.FullNameData.push(data[i].fullName);
            }
        }

        travellerMyListVm.hidePassenger = function(index,isInfant) {

            if(isInfant==false)
            {
                if(travellerMyListVm.passArray[index].isExpand)
                {
                    travellerMyListVm.passArray[index].isExpand=false;
                }
                else{
                     travellerMyListVm.passArray[index].isExpand=true;
                }
            }
            else{
                 if(travellerMyListVm.infantArray[index].isExpand){
                    travellerMyListVm.infantArray[index].isExpand=false;
                }
                else{
                     travellerMyListVm.infantArray[index].isExpand=true;
                }
            }
        }

           travellerMyListVm.changeConsession=function(index){
                    if (travellerMyListVm.passArray[index].gender == "M") {
                        if (travellerMyListVm.passArray[index].age >= 60 && travellerMyListVm.passArray[index].age <= 125) {
                           travellerMyListVm.passArray[index].concession = "true";
                        } 
                    }
                    if (travellerMyListVm.passArray[index].gender == "T") {
                        if (travellerMyListVm.passArray[index].age >= 60 && travellerMyListVm.passArray[index].age <= 125) {
                            travellerMyListVm.passArray[index].concession = "true";
                         } 
                    }
                    if (travellerMyListVm.passArray[index].gender == "F") {
                        if (travellerMyListVm.passArray[index].age >= 58 &&travellerMyListVm.passArray[index].age <= 125) {
                           travellerMyListVm.passArray[index].concession = "true";
                        } 
                    }

           }

        travellerMyListVm.addTraveller = function(isInfant) {
            var foodEnabled = travellerMyListVm.trainData.avlFareEnq.bkgCfg.foodChoiceEnabled;
            travellerMyListVm.passengerObj = {
                "fullName": "",
                "age": "",
                "gender": "M",
                "berthPref": travellerMyListVm.berthCategory[0].key,
                "mealPref": "",
                "status": "",
                "bedRoll": false,
                "childBerthFlag":false,
                "concession": false,
                "nationality": travellerMyListVm.nationCategory[0].code || "IN",
                "sequenceNo": "",
                "addToList": false,
                "isExpand": true,
                "isInfant": isInfant,
                "idCardType": travellerMyListVm.idCardTypes[0],
                "idCardNumber": "",
                "showTraveller":false
            };

            if (foodEnabled == 'true') {
                travellerMyListVm.passengerObj.mealPref = "V";
            }
            if (isInfant==true) {

                if (travellerMyListVm.infantArray.length < 2) {
                    travellerMyListVm.infantArray.push(travellerMyListVm.passengerObj);
                } else {
                    utilityService.showErrorMessage("Cannot Add more than 2 Infants");
                }
            } else {
                if (travellerMyListVm.passArray.length < 6) {
                    travellerMyListVm.passArray.push(travellerMyListVm.passengerObj);
                } else {
                    utilityService.showErrorMessage("Cannot Add more than 6 travellers");
                }
            }

            travellerMyListVm.totalPassengers = travellerMyListVm.passArray.length;
            if (travellerMyListVm.passArray.length >= 1) {
                travellerMyListVm.disablenext = false;
            }
            if(irctcService.showSeniorFlag){
                 var alertPopup1 = $ionicPopup.alert({
                                template: "<p style='text-align:center;font-weight:bold;font-size:16px'>No concessional tickets allowed for this Train/Quota/Class.</p>",
                                    buttons: [{
                              text: '<b>Ok</b>',
                              type: 'button-positive',
                              onTap: function(e) {
                               alertPopup1.close();
                              }
                            }
                          ]
                            });
                irctcService.showSeniorFlag=false;
            }
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            travellerMyListVm.maxPassCount = irctcService.maxPassCount;
            travellerMyListVm.infantArray = [];
            travellerMyListVm.passArray = [];
            irctcService.getTrainRoute(irctcService.selectedTrainData.trainNumber).then(function(data) {
                var list = data.stationList;
                var stationCodeArray = [];
                var stationNameArray = [];
                for (var i = 0; i < list.length; i++) {
                    stationCodeArray.push(list[i].stationCode);
                    stationNameArray.push(list[i].stationName);
                }
                irctcService.stationCodeArray = stationCodeArray;
                irctcService.stationNameArray = stationNameArray;
                travellerMyListVm.stationTo = irctcService.getStationNameCode(travellerMyListVm.trainData.toStnCode, irctcService.stationCodeArray, irctcService.stationNameArray);
                travellerMyListVm.stationFrom = irctcService.getStationNameCode(travellerMyListVm.trainData.fromStnCode, irctcService.stationCodeArray, irctcService.stationNameArray);
            }, function(error) {
            });

            if (irctcService.username) {
                irctcService.userLinkedStatus = true;
                travellerMyListVm.username = irctcService.username;
                travellerMyListVm.irctcNewUser = travellerMyListVm.username;
            } else {
                travellerMyListVm.username = "Menu";
                travellerMyListVm.userLinkedStatus = false;
            }
            travellerMyListVm.showManageInfo = irctcService.userLinkedStatus;
            if (irctcService.myList) {
                travellerMyListVm.myList = irctcService.myList;
                if(irctcService.infantArray){
                    travellerMyListVm.infantArray=irctcService.infantArray;
                }
                else{
                    travellerMyListVm.infantArray=[];
                }
                  if(irctcService.passArray){
                    travellerMyListVm.passArray=irctcService.passArray;
                }
                else{
                    travellerMyListVm.passArray=[];
                }
            } 
            else{
                travellerMyListVm.myList = [];
            }
            travellerMyListVm.totalPassengers = irctcService.totalTravellers;

            for (var i = 0; i < travellerMyListVm.totalPassengers; i++) {
            }
            travellerMyListVm.trainData = irctcService.selectedTrainData;
            travellerMyListVm.sourceTime = travellerMyListVm.trainData.departureTime;
            travellerMyListVm.destTime = travellerMyListVm.trainData.arrivalTime;
            travellerMyListVm.trainDuration = travellerMyListVm.trainData.duration;
            travellerMyListVm.trainNumber = travellerMyListVm.trainData.trainNumber;
            travellerMyListVm.trainName = travellerMyListVm.trainData.trainName;
            travellerMyListVm.stationTo = travellerMyListVm.trainData.toStnCode;
            travellerMyListVm.stationFrom = travellerMyListVm.trainData.fromStnCode;
            travellerMyListVm.availibilityStatus=irctcService.availabilityStatus;
            travellerMyListVm.trainDate = irctcService.searchDate;
            travellerMyListVm.berthCategory = [];
            travellerMyListVm.isIDRequired = travellerMyListVm.trainData.avlFareEnq.bkgCfg.idRequired;
            var listOfBerth = travellerMyListVm.trainData.avlFareEnq.bkgCfg.applicableBerthTypes;
            travellerMyListVm.idCardTypes = travellerMyListVm.trainData.avlFareEnq.bkgCfg.validIdCardTypes;
            for (var i = 0; i < listOfBerth.length; i++) {
                var currentBerth = irctcService.getArrayElement(listOfBerth[i], irctcService.masterData.berthTypes, 'myValue');
                var obj = {
                    "key": listOfBerth[i],
                    "value": currentBerth
                }
                travellerMyListVm.berthCategory.push(obj);
            }
            travellerMyListVm.isFoodAvail = travellerMyListVm.trainData.avlFareEnq.bkgCfg.foodChoiceEnabled;
            travellerMyListVm.isBedRoll = travellerMyListVm.trainData.avlFareEnq.bkgCfg.bedRollFlagEnabled;
           travellerMyListVm.childBerthMandatory=travellerMyListVm.trainData.avlFareEnq.bkgCfg.childBerthMandatory;
            travellerMyListVm.maxAge = travellerMyListVm.trainData.avlFareEnq.bkgCfg.maxPassengerAge;
             var rupeeSymbol = String.fromCharCode(8377);
            irctcService.masterData.bedroll=irctcService.masterData.bedroll.replace( 'â�¹',rupeeSymbol);
            irctcService.masterData.bedroll=irctcService.masterData.bedroll.replace('â¹',rupeeSymbol);
            travellerMyListVm.bedRollCharge=irctcService.masterData.bedroll;
            if (travellerMyListVm.passArray.length >= 1) {
                travellerMyListVm.disablenext = false;
            } else {
                travellerMyListVm.disablenext = true;
            }
            travellerMyListVm.showMyListTraveller = false;
            travellerMyListVm.disableback = false;
            travellerMyListVm.showBack = true;
            travellerMyListVm.showNext = true;
            travellerMyListVm.totalTravellers = travellerMyListVm.totalPassengers + ' Traveller(s) ';
            travellerMyListVm.classQuota = travellerMyListVm.trainData.avlFareEnq.enqClass + ', ' + irctcService.searchQuotaVal;
            travellerMyListVm.srCitizen = [ { "key": "true", "value": "Opt concession" },{ "key": "false", "value": "Forgo concession" }];
            irctcService.genderMaster = [{ "key": "M", "value": "Male" }, { "key": "F", "value": "Female" }, { "key": "T", "value": "Transgender" }];

            if(travellerMyListVm.trainData.avlFareEnq.bkgCfg.foodDetails){
                var foodArray =[];
                for(var i = 0;i<travellerMyListVm.trainData.avlFareEnq.bkgCfg.foodDetails.length;i++){
                    var obj = {};
                    if(travellerMyListVm.trainData.avlFareEnq.bkgCfg.foodDetails[i] == 'V'){
                        obj.key = travellerMyListVm.trainData.avlFareEnq.bkgCfg.foodDetails[i];
                        obj.value = "Veg";
                    }else if(travellerMyListVm.trainData.avlFareEnq.bkgCfg.foodDetails[i] == 'N'){
                        obj.key = travellerMyListVm.trainData.avlFareEnq.bkgCfg.foodDetails[i];
                        obj.value = "Non Veg";
                    }else if(travellerMyListVm.trainData.avlFareEnq.bkgCfg.foodDetails[i] == 'D'){
                        obj.key = travellerMyListVm.trainData.avlFareEnq.bkgCfg.foodDetails[i];
                        obj.value = "No Meal";
                    }
                    foodArray.push(obj);
                }
                irctcService.foodCategory = foodArray;
            }else{
                irctcService.foodCategory = [{ "key": "V", "value": "Veg" }, { "key": "N", "value": "Non Veg" }, { "key": "D", "value": "No Meal" }];
            }
            travellerMyListVm.foodCategory = irctcService.foodCategory;
            travellerMyListVm.genderCategory = irctcService.genderMaster;
            travellerMyListVm.getCountry();
            travellerMyListVm.optConcession = true;
            //Fetch Traveller List 
            irctcService.fetchMyList().then(function(data) {
                irctcService.myListFullData = data;
                if (data){ 
                    CreateNameArray(data); 
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        });

        return this;
    }
]);
