'use strict';
angularApp.controller('travellerMyListEditController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
        "irctcService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker,$ionicSideMenuDelegate,irctcService) {
			var travellerMyListEditVm = this;

		travellerMyListEditVm.goBack = function(){
			$ionicHistory.goBack(-1);
		}

       function ValidateData()
       {
       	var ageAndNameMsg="";
       	if(travellerMyListEditVm.PassengerList.age>125  || travellerMyListEditVm.PassengerList.age < 5 )
       	{
          ageAndNameMsg = "Age of Passenger must be between 5 & 125 ";
       	}
       	if(travellerMyListEditVm.PassengerList.fullName.length<3)
       	{
              ageAndNameMsg ="Name of Passenger cannot be less than 3 characters";
       	}

       	if(travellerMyListEditVm.PassengerList.age==0)
       	{
       		ageAndNameMsg="Age cannot be 0"
       	}
           
          return   ageAndNameMsg
       }
		travellerMyListEditVm.getCountry=function()
        {
           irctcService.getCountry().then(function (data) {
                  travellerMyListEditVm.nationCategory =data;
                   if(irctcService.from!="Edit")
                   {
                   travellerMyListEditVm.PassengerList.nationality=travellerMyListEditVm.nationCategory[0].code;
                   }
                    
                    },function(error){
                        utilityService.showErrorMessage(error.responseMessage);
                 });

        }
		travellerMyListEditVm.updateTraveller = function(){

			var err=ValidateData();

			if(err)
			{ utilityService.showErrorMessage(err);
             
			}

			else
			{

			var reqParams={};
			reqParams.updates=[{
				      "fullName": travellerMyListEditVm.PassengerList.fullName,
				      "age": travellerMyListEditVm.PassengerList.age,
				      "gender": travellerMyListEditVm.PassengerList.gender,
				      "berthPref": travellerMyListEditVm.PassengerList.berthPref,
				      "mealPref": travellerMyListEditVm.PassengerList.mealPref,
				      
				      "concession": "null",
				      "nationality": travellerMyListEditVm.PassengerList.nationality,
				      "sequenceNo": irctcService.fromData.sequenceNo
				     
				    }]

			irctcService.updateMyList(reqParams).then(function (data) {
                  
                   		var alertPopup = $ionicPopup.alert({
								template: "<p style='text-align:center;font-weight:bold;font-size:16px'>Data updated successfully.</p>",
								buttons: [
                            
                            {
                              text: '<b>Ok</b>',
                              type: 'button-positive',
                              onTap: function(e) {
                               alertPopup.close();
                               $state.go("menu.myList");
                              }
                            }
                          ]
							});
                    
                    
                    
                    },function(error){
                        utilityService.showErrorMessage(error.responseMessage);
                 });
		}
			
		}
       travellerMyListEditVm.toggleMenu = function(){
      
        travellerMyListEditVm.menu = !travellerMyListEditVm.menu;
      }
       
       travellerMyListEditVm.addTraveller = function(){

       	var err=ValidateData();

			if(err)
			{ utilityService.showErrorMessage(err);
             
			}
		else
		{
       	var reqParams={};
			reqParams.updates=[{
				      "fullName": travellerMyListEditVm.PassengerList.fullName,
				      "age": travellerMyListEditVm.PassengerList.age,
				      "gender": travellerMyListEditVm.PassengerList.gender,
				      "berthPref": travellerMyListEditVm.PassengerList.berthPref,
				      "mealPref": travellerMyListEditVm.PassengerList.mealPref,
				      "concession": "null",
				      "nationality": travellerMyListEditVm.PassengerList.nationality
				    
				     
				    }]

			irctcService.updateMyList(reqParams).then(function (data) {
                  
                   var alertPopup = $ionicPopup.alert({
								template: "<p style='text-align:center;font-weight:bold;font-size:16px'>Data added successfully.</p>",
									buttons: [
                            
                            {
                              text: '<b>Ok</b>',
                              type: 'button-positive',
                              onTap: function(e) {
                               alertPopup.close();
                               $state.go("menu.myList");
                              }
                            }
                          ]
							});
                    
                    
                    
                    },function(error){
                        utilityService.showErrorMessage(error.responseMessage);
                 });
		}
			
		}
       

      	$scope.$on('$ionicView.beforeLeave', function(){

		});

		$scope.$on('$ionicView.afterEnter', function() {
			
		});
      
		$scope.$on('$ionicView.beforeEnter', function() {
           travellerMyListEditVm.PassengerList={};
		  if(irctcService.username){
                      irctcService.userLinkedStatus = true;
                      travellerMyListEditVm.username = irctcService.username;
                    }else{
                      travellerMyListEditVm.username = "Menu";
                      travellerMyListEditVm.userLinkedStatus = false;
                    }
         travellerMyListEditVm.showManageInfo = irctcService.userLinkedStatus;
			

		travellerMyListEditVm.genderCategory = irctcService.genderMaster;
		travellerMyListEditVm.berthCategory = irctcService.masterData.berthTypes;
		travellerMyListEditVm.foodCategory = [{ "key": "V", "value": "Veg" }, { "key": "N", "value": "Non Veg" }, { "key": "D", "value": "No Meal" }];
		// travellerMyListEditVm.berthCategory = [];
  //        	var listOfBerth = irctcService.masterData.berthTypes;
  //        	for(var i =0;i<listOfBerth.length;i++){
  //        		var currentBerth = irctcService.getArrayElement(listOfBerth[i].key,irctcService.masterData.berthTypes,'myValue');
  //        		travellerMyListEditVm.berthCategory.push(currentBerth);
  //        	}

		//travellerMyListEditVm.berthCategory = [{"key":"LB","value":"Lower Berth"},{"key":"MB","value":"Middle Berth"},{"key":"UB","value":"Upper Berth"},{"key":"SL","value":"Side Lower"},{"key":"SU","value":"Side Upper"}];
		//travellerMyListEditVm.nationCategory = [{"key":"IN","value":"Indian"},{"key":"O","value":"Other"}];
		travellerMyListEditVm.getCountry();
		travellerMyListEditVm.PassengerList.berthPref=travellerMyListEditVm.berthCategory[0].key;
		travellerMyListEditVm.PassengerList.gender=travellerMyListEditVm.genderCategory[0].key;
	    
	     travellerMyListEditVm.PassengerList.mealPref="V";


        if(irctcService.from=="Edit")
        {
        	travellerMyListEditVm.fromEdit=true;
              
		 travellerMyListEditVm.PassengerList=irctcService.fromData;
		 if(!travellerMyListEditVm.PassengerList.mealPref)
		 {
		 	 travellerMyListEditVm.PassengerList.mealPref="V";
		 }

		}
		
	     });

		return this;
	
	}
]);
