'use strict';

angularApp.controller('landingController', ["$state",
	"$scope",
	"utilityService",
	"ConnectivityMonitorUtils",
	"internetBankingService",
	"loggedInUserService",
	"constantConfig",
	"cryptoService",
	"encryptionService",
	"currentLocationService",
	"clickStreamService",
	"AdapterUtils",
	"$ionicSideMenuDelegate",
	"ompOffersService",
	"keyGuardService",
	"$translate",
    "$ionicPopup",
	"quickPayService","ompMerchantsService",
	"registerWithSimService",
	function ($state,
		$scope,
		utilityService,
		ConnectivityMonitorUtils,
		internetBankingService,
		loggedInUserService,
		constantConfig,
		cryptoService,
		encryptionService,
		currentLocationService,
		clickStreamService,
		AdapterUtils,
		$ionicSideMenuDelegate,
		ompOffersService,
		keyGuardService,
		$translate,
        $ionicPopup,
		quickPayService,ompMerchantsService,
		registerWithSimService) {

		var landingVM = this;
		landingVM.keystoreValue = "";
		landingVM.imageRatio = 0;
		landingVM.deviceDetectedVal = "";
		landingVM.appVersion='';
		landingVM.isDeviceRegistered = false;
		$scope.$on('$ionicView.beforeEnter', function () {
			$translate(['VERSION_NO']).then(function (translations) {
				landingVM.appVersion = translations['VERSION_NO'] ? translations['VERSION_NO'] : '';
				});
			if (ionic.Platform.isIPad()) {
				document.getElementById('metaTag').setAttribute('content', 'user-scalable=no, initial-scale=0.75, maximum-scale=0.75, minimum-scale=0.75, width=device-width')
			}
			document.addEventListener('deviceready', onDeviceReadyEvent, false);
		});
		function onDeviceReadyEvent() {
			document.addEventListener("resume", onResumeEvent, false);
		}
		function onResumeEvent() {
			checkRogueApps(true);
		}
		$scope.$on('$ionicView.loaded', function () {
			$ionicSideMenuDelegate.canDragContent(false);
			$scope.initAppData();
		});

		$scope.initAppData = function () {
			ompMerchantsService.ompSearchHistory="";
			$scope.isOffline = false;
			$scope.retryBtn = false;
			$scope.keyGuardMsg = false;
			if (ConnectivityMonitorUtils.isOffline()) {
				$scope.retryBtn = true;
				$scope.isOffline = true;
			}
			encryptionService.generateAES256Key();
			//currentLocation();
			if (utilityService.isAndroidPlatform()) {
				var successCallback = function (data) {
					processCroppedImage(data);
				}
				var failureCallback = function () {
					$scope.retryBtn = false;
					$scope.isOffline = false;
					$scope.err = "Unauthorized apk";
					hideSplashScreen();
					return;
				}
				var requestDate = new Date();
				requestDate = requestDate.getMilliseconds();
				landingVM.imageRatio = Math.random() + requestDate;
				landingVM.imageRatio = Math.floor(landingVM.imageRatio * 10000 + 1);
				var options = ["file:///android_asset/www/img/sbi_custom.png", 100, 100, landingVM.imageRatio];
				cordova.exec(successCallback, failureCallback, "Utils", "cropImage", options);
			} else {
				isRootedAndKeyGuardEnabled();
			}
		};

		function hideSplashScreen() {
			if (navigator && navigator.splashscreen) {
				setTimeout(function () {
					navigator.splashscreen.hide();
				}, 10);
			}
		};

		function processCroppedImage(ratioValue) {
			ratioValue = ratioValue.split("#");
			landingVM.deviceDetectedVal = ratioValue[0];
			landingVM.imageRatio * 3 === parseInt(ratioValue[0]) ? isRootedAndKeyGuardEnabled() : sendDsecDetalis();
			landingVM.imageRatio = "";
		}

		function sendDsecDetalis() {
			var payload = {
				"acr": landingVM.deviceDetectedVal != "" ? cryptoService.encryptRSAWithPublicKey(landingVM.deviceDetectedVal, cryptoService.rsaPublicKey) : ""
			};
			var resourceRequest = new WLResourceRequest("adapters/CustomSessionAdapter/dsec", WLResourceRequest.POST);
			resourceRequest.send(payload).then(function (response) {
				landingVM.deviceDetectedVal = "";
				ionic.Platform.exitApp();
			}, function (error) {
				landingVM.deviceDetectedVal = "";
				ionic.Platform.exitApp();
			});
		}

		var keystoreCheck = function () {
			if (utilityService.isAndroidPlatform()) {
				var successCallback = function (data) {
					landingVM.keystoreValue = utilityService.isAndroidPlatform() ? data : "";
					loggedInUserService.keystoreValue = landingVM.keystoreValue;
					if (ConnectivityMonitorUtils.isOffline()) {
						$scope.retryBtn = true;
						$scope.isOffline = true;
						hideSplashScreen();
						return;
					} else {
						/*login flow improvement*/
						checkDeviceRegistration();
						//CheckDevicePrint();
					}
				}
				var failureCallback = function () {
					$scope.retryBtn = false;
					$scope.isOffline = false;
					$scope.err = "Unauthorized apk";
					return;
				}
				cordova.exec(successCallback, failureCallback, "security", "certificateCheck", []);
			} else {
				if (ConnectivityMonitorUtils.isOffline()) {
					$scope.retryBtn = true;
					$scope.isOffline = true;
					hideSplashScreen();
					return;
				} else {
					/*login flow improvement*/
					checkDeviceRegistration();
					//CheckDevicePrint();
				}
			}
		};

		function connectServer() {
			try {
				loggedInUserService.rogueAppsData = {};
				var payload = {
					"data": cryptoService.encryptRSAWithPublicKey(encryptionService.iv + "^" + encryptionService.passphrase + "^" + encryptionService.salt, cryptoService.rsaPublicKey),
					"src": landingVM.keystoreValue != "" ? cryptoService.encryptRSAWithPublicKey(landingVM.keystoreValue, cryptoService.rsaPublicKey) : ""
				    
				};
				if(landingVM.appVersion){
					payload.appCode = landingVM.appVersion; //Build number
				}
				payload.irf = landingVM.isDeviceRegistered ? 'true' : 'false';
				payload.irv =  cryptoService.getSHA512EncryptedData(payload.irf).toString();
				var resourceRequest = new WLResourceRequest("adapters/CustomSessionAdapter/saveCustomInformation", WLResourceRequest.POST, { timeout: 10000 });
				resourceRequest.send(payload).then(function (response) {
					utilityService.lastTimeStamp = new Date();
					response.responseText = utilityService.isJSON(response.responseText) ? JSON.parse(response.responseText) : JSON.parse(encryptionService.getAES256DecryptedData(response.responseText));
					if (response.responseText.responseCode == '0000') {
						AdapterUtils.secretData = response.responseText.data.key;
						loggedInUserService.keyId = response.responseText.data.keyId;
						loggedInUserService.deviceIdForMpin = response.responseText.data.deviceId;
						loggedInUserService.upiPermissionKey = response.responseText.data.upiPermissionVal;
						loggedInUserService.billDeskUrl = response.responseText.data.billDeskUrl;
						loggedInUserService.sbiCollectUrl = response.responseText.data.sbiCollectUrl;
						quickPayService.yqpVpaLimit =response.responseText.data.yqpVpaLimit;
                        
						quickPayService.yqpRaiseRequestLimit = response.responseText.data.yqpRaiseRequestLimit;
                        			quickPayService.yqpBeneficiaryLimit = response.responseText.data.yqpBeneficiaryLimit;
						registerWithSimService.simVMNValidate = response.responseText.data.reqValidate;
						registerWithSimService.respValidate = response.responseText.data.respValidate;
						registerWithSimService.simBindingVirtualMobile = response.responseText.data.simVirtualMobNo;
						registerWithSimService.isSimLogin = response.responseText.data.isSimLogin;
						registerWithSimService.isSimRegistration = response.responseText.data.isSimRegistration;
						registerWithSimService.velocityMaxCount  = response.responseText.data.velocityMaxCount;
						registerWithSimService.velocityErrorMessage   = response.responseText.data.velocityErrorMessage ;
						registerWithSimService.maxVelValidate = response.responseText.data.maxVelValidate;
                        loggedInUserService.isUserTour = response.responseText.data.isUserTour;
						loggedInUserService.bkvFundDonationUrl = response.responseText.data.bkvFundDonationUrl;
							loggedInUserService.appOutdateFlag = response.responseText.data.appOutdateFlag === "true" ? true : false;
							loggedInUserService.appOutdateMessage = response.responseText.data.appOutdateMessage;					
							if(response.responseText.data.latestAndroidAppVersion){		
								loggedInUserService.latestAndroidAppVersion = "";
								loggedInUserService.latestAndroidAppVersion = response.responseText.data.latestAndroidAppVersion;
							}

						if(registerWithSimService.isSimRegistration || !landingVM.isDeviceRegistered){
							var checkVMNHash = cryptoService.getSHA512EncryptedData(registerWithSimService.simBindingVirtualMobile + "SIM_BINDING");
							if (checkVMNHash.toString() !== registerWithSimService.simVMNValidate) {
								hideSplashScreen();
								utilityService.showExitAlertPopup("Technical Error");return;
							}
						}
						var checkVelocityCountHash = cryptoService.getSHA512EncryptedData(registerWithSimService.velocityMaxCount + "SIM_BINDING");
						if (checkVelocityCountHash.toString() !== registerWithSimService.maxVelValidate) {
							hideSplashScreen();
							utilityService.showExitAlertPopup("Technical Error");return;
						}
						var checkFlagHash = cryptoService.getSHA512EncryptedData(registerWithSimService.isSimRegistration +""+ registerWithSimService.isSimLogin + "SIM_BINDING");
						if (checkFlagHash.toString() !== registerWithSimService.respValidate) {
							hideSplashScreen();
							utilityService.showExitAlertPopup("Technical Error");return;
						}
						
						if(response.responseText.data.latestIOSAppVersion){
						loggedInUserService.latestIOSAppVersion = "";
						loggedInUserService.latestIOSAppVersion = response.responseText.data.latestIOSAppVersion;
						}
						utilityService.getUPIPermissions(loggedInUserService.upiPermissionKey);

						loggedInUserService.isServerConnected = true;
						CheckDevicePrint();
					} else {
                        msgWithRetry(response);
                    }
				}, function (error) {
					loggedInUserService.isServerConnected = false;
					$scope.$apply(function () {
						$scope.err = utilityService.getServerExceptionMessage(error);
						$scope.retryBtn = true;
					});
					/**
					 * Yono lite redirection
					 */
					if (error.errorCode == 'MAINTENANCE_PAGE') {
						$scope.maintenanceMessage = error.errorMsg;
						$scope.appInstalled = false;
						var template = '<div class="yono-maintenance row row-wrap text-center"><span class="col col-80 col-offset-10 maintenance-logo"></span><strong class="col col-90">YONO app is under maintenance.</strong><span class="col col-90">Do you want to  <span ng-if="appInstalled">continue with</span><span ng-if="!appInstalled">download</span> our other application Yono Lite?</span><span class="col col-80 col-offset-10" style="line-height: 1.3em;"></span><button class="col col-80 col-offset-10 button button-block button-positive btn-primary-button" ng-click="redirectYonoLite()" ng-if="appInstalled">Go to Yono Lite</button><span class="col col-90"  ng-if="appInstalled">On clicking \'<strong>Go to Yono Lite</strong>\' you will be redirected to the Yono Lite applicaiton.</span><button class="col col-80 col-offset-10 button button-block button-positive btn-primary-button" ng-click="redirectAppStore()" ng-if="!appInstalled">Download Yono Lite</button><span class="col col-90" ng-if="!appInstalled">On clicking \'<strong>Download Yono Lite</strong>\' you will be redirected to the app store/play store in your mobile.</span><span class="col col-80 col-offset-10" style="line-height: 1.3em;"></span><strong class="col col-100" style="color: #673390;" ng-click="retry()">Retry</strong><span class="col col-80 col-offset-10">{{maintenanceMessage}}</span></div>';
						var myPopup;
						if (utilityService.isAndroidPlatform()) {
							window.plugins.launcher.canLaunch({ packageName: constantConfig.yonoLiteRedirectionURL.yonoLiteAppPackageName }, function (succes) {
								$scope.appInstalled = true;
								myPopup = $ionicPopup.show({
									cssClass: 'maintenance-popup', // String, The custom CSS class name
									template: template, // String (optional). The html template to place in the popup body.
									scope: $scope // Scope (optional). A scope to link to the popup content.
								});
							}, function (responseerror) {
								$scope.appInstalled = false;
								myPopup = $ionicPopup.show({
									cssClass: 'maintenance-popup', // String, The custom CSS class name
									template: template, // String (optional). The html template to place in the popup body.
									scope: $scope // Scope (optional). A scope to link to the popup content.
								});
							});
						} else {
							appAvailability.check( constantConfig.yonoLiteRedirectionURL.iOSPackSchema , function () {
								$scope.appInstalled = true;
								myPopup = $ionicPopup.show({
									cssClass: 'maintenance-popup', // String, The custom CSS class name
									template: template, // String (optional). The html template to place in the popup body.
									scope: $scope // Scope (optional). A scope to link to the popup content.
								});
							}, function () {
								$scope.appInstalled = false;
								myPopup = $ionicPopup.show({
									cssClass: 'maintenance-popup', // String, The custom CSS class name
									template: template, // String (optional). The html template to place in the popup body.
									scope: $scope // Scope (optional). A scope to link to the popup content.
								});
							});
						}
						$scope.redirectAppStore = function () {
							var url = '';
							if (utilityService.isAndroidPlatform()) {
								url = constantConfig.yonoLiteRedirectionURL.androidPlayStore;
							} else {
								url = constantConfig.yonoLiteRedirectionURL.iOSAppleStore;
							}
							ompMerchantsService.inChromeBrowser(url);
							myPopup.close();
						};
						$scope.redirectYonoLite = function () {
							var url = constantConfig.yonoLiteRedirectionURL.androidPackSchema;
							if (!utilityService.isAndroidPlatform()) {
								url = constantConfig.yonoLiteRedirectionURL.iOSPackSchema;
								ompMerchantsService.inChromeBrowser(url);
							} else {
								window.plugins.launcher.canLaunch({ packageName: constantConfig.yonoLiteRedirectionURL.yonoLiteAppPackageName }, function (succes) {
									window.plugins.launcher.launch({ packageName: constantConfig.yonoLiteRedirectionURL.yonoLiteAppPackageName }, function (success) { }, function (responseerror1) {
									});
								}, function (responseerror2) {
								});
							}
							myPopup.close();
						};
						/**
						 * Yono lite redirection ENDS
						 */
					}
					hideSplashScreen();
				});
			} catch (err) {
				loggedInUserService.isServerConnected = false;
                $scope.$apply(function(){
                $scope.err = constantConfig.adapter.SOMETHING_WENT_WRONG;
                $scope.retryBtn = true;
                });
                hideSplashScreen();
			}
		}

		function msgWithRetry(serverresponse) {
            loggedInUserService.isServerConnected = false;
            $scope.$apply(function(){
            if(serverresponse.responseText.responseCode == '0001' || serverresponse.responseText.responseCode == '0002'){
            $scope.err = serverresponse.responseText.responseCode + " : " + constantConfig.adapter.CANNOT_PROCESS_NOW;
			$scope.retryBtn = true;
            }           
            else if(serverresponse.responseText.responseCode == '0003' || serverresponse.responseText.responseCode == '0004') {
            $scope.err = serverresponse.responseText.responseCode + " : " + serverresponse.responseText.responseMessage;
            }
            });
            hideSplashScreen();
        }

		function isRootedAndKeyGuardEnabled() {
			$scope.err = '';
			if (utilityService.isAndroidPlatform()) {
				keyGuardService.checkKeyguard(function (checkKeyguardValue) {
					internetBankingService.checkKeyguardValue = checkKeyguardValue;
					keystoreCheck();
				});
			} else if (utilityService.isIOSPlatform()) {
				//code - jailbreak plugin
				var successCallbackIos = function (result) {			
					if (result) {
						hideSplashScreen();
						$state.go("menu.rootedDevice");
					} else {
						keyGuardService.checkKeyguard(function (checkKeyguardValue) {
							internetBankingService.checkKeyguardValue = checkKeyguardValue;
							keystoreCheck();
						});
					}
				};
				var errorCallbackIos = function (error) {		
					hideSplashScreen();
					utilityService.showErrorMessage(error);
				}
				return cordova.exec(successCallbackIos, errorCallbackIos, "JailbreakDetection", "isJailbroken", []);
			} else {
				$state.go('menu.landingWithOptions');
			}
		}

		//Function for retry Button click.
		$scope.retry = function () {
			$scope.isOffline = false;
			$scope.retryBtn = false;
			$scope.err = '';
			if (ConnectivityMonitorUtils.isOffline()) {
				$scope.retryBtn = true;
				$scope.isOffline = true;
			}
			else {
				connectServer();
				//CheckDevicePrint();
			}
		};

		function checkDataAvailability() {
			//Check if data is available in file else call service
							if (Object.keys(landingVM.fileStorageResult).length !== 0) {
								var result = landingVM.fileStorageResult;
								result.mpinConsent == true ? loggedInUserService.mpinConsent = true : loggedInUserService.mpinConsent = false;
								if (utilityService.isAndroidPlatform()) {
									if(result.simSubscriptionId){
										registerWithSimService.simSubscriptionId = result.simSubscriptionId;
									}
									else{
										registerWithSimService.simSubscriptionId = "";
										registerWithSimService.userWithoutSimReg =  true;
									}
								}
								else{
									registerWithSimService.simSubscriptionId = "";
								}
								if (loggedInUserService.rogueAppsDetected) {
									$state.go('menu.vurnableApps');
								}
								else {
										if(ompOffersService.notificationRecieved === true)
										{
											ompOffersService.notificationRecieved=false;
											$state.go('menu.ompOffers');
										}
										else{
											result.isDeviceRegistered == true ? $state.go('menu.userLanding') : $state.go('menu.landingWithOptions');
										}
									}
							}
							else {
								CheckDeviceRegisteredFromAdapter();
							}
		}
		
		function CheckDevicePrint() {
			loggedInUserService.deviceInfo = device.uuid;
			checkRogueApps();
		};
		function checkDeviceRegistration() {
			var fileDirectory = "";
			landingVM.fileStorageResult = {};
			if (utilityService.isAndroidPlatform()) {
				fileDirectory = cordova.file.applicationStorageDirectory;
			} else {
				fileDirectory = cordova.file.dataDirectory;
			}
			window.resolveLocalFileSystemURL(fileDirectory, function (fs) {
				fs.getFile("YONOLocalStorageFile.json", { create: true }, function (fileEntry) {
					fileEntry.file(function (file) {
						var reader = new FileReader();
						reader.onloadend = function () {
							//Check if data is available in file else call service
							if (this.result) {
								landingVM.fileStorageResult = JSON.parse(this.result);
								landingVM.isDeviceRegistered = landingVM.fileStorageResult.isDeviceRegistered;
								connectServer();
							}
							else{
								connectServer();
							}
						};
						reader.readAsText(file);
					}, function (e) {
						connectServer();
					});
				}, function (e) {
					connectServer();
				});
			}, function (e) {
				connectServer();
			});
		}
		function checkRogueApps(isAppLaunch) {
			loggedInUserService.rogueAppsDetected = false;
			loggedInUserService.rogueAppsDetectedList = [];
			if (constantConfig.rogueAppsData && constantConfig.rogueAppsData.rogueApps.length > 0) {
				for (var i = 0; i < constantConfig.rogueAppsData.rogueApps.length; i++) {
					if (utilityService.isAndroidPlatform()) {
						if (constantConfig.rogueAppsData.rogueApps[i].appBundleName !== "") {
							landingVM.checkAppusingAppAvailibilty(i, isAppLaunch);
						}
						else {
							continue;
						}
					} else {
						if (constantConfig.rogueAppsData.rogueApps[i].appSchemaName !== "") {
							landingVM.checkAppusingAppAvailibilty(i, isAppLaunch);
						}
						else {
							continue;
						}

					}

				}
			}
			else {
				CheckDeviceRegistered();
			}

		}

		function CheckDeviceRegistered(){
			checkDataAvailability();
		}

		landingVM.checkAppusingAppAvailibilty = function (i, isAppLaunch) {
			var appBSName = '';
			if (utilityService.isAndroidPlatform()) {
				appBSName = constantConfig.rogueAppsData.rogueApps[i].appBundleName;
			} else {
				appBSName = constantConfig.rogueAppsData.rogueApps[i].appSchemaName + "://";
			}
			appAvailability.check(appBSName,
				function () {
					loggedInUserService.rogueAppsDetected = true;
					var rogueappsObj = {
						'appName': constantConfig.rogueAppsData.rogueApps[i].appName,
						'appIcon': constantConfig.rogueAppsData.rogueApps[i].appIcon
					};
					loggedInUserService.rogueAppsDetectedList.push(rogueappsObj);

					if (i == (constantConfig.rogueAppsData.rogueApps.length - 1)) {
						if (!isAppLaunch)
							CheckDeviceRegistered();
						else if (isAppLaunch && loggedInUserService.rogueAppsDetected) {
							$state.go('menu.vurnableApps');
						}

					}
				},
				function () {
					if (i == (constantConfig.rogueAppsData.rogueApps.length - 1)) {
						if (!isAppLaunch)
							CheckDeviceRegistered();
						else if (isAppLaunch && loggedInUserService.rogueAppsDetected) {
							$state.go('menu.vurnableApps');
						}

					}
				});
		}


		function CheckDeviceRegisteredFromAdapter(){
			if (loggedInUserService.rogueAppsDetected) {
				$state.go('menu.vurnableApps');
			}else{
				if(ompOffersService.notificationRecieved === true)
				{
					ompOffersService.notificationRecieved=false;
					$state.go('menu.ompOffers');
				}
				else{
						$state.go('menu.landingWithOptions');
				}
			}
		}
		
		return this;
	}
]);
