'use strict';

angularApp.controller('landingWithOptionsController',
	["$state",
		"$scope",
		"utilityService",
		"loggedInUserService",
		"currentLocationService",
		"clickStreamService",
		"ompMerchantsService", 
		"$ionicPopup",
		"registerWithSimService",
		"$filter",
		function ($state,
			$scope,
			utilityService,
			loggedInUserService,
			currentLocationService,
			clickStreamService,
			ompMerchantsService, 
			$ionicPopup,
			registerWithSimService,
			$filter
		) {

			var landingWOVM = this;
			landingWOVM.selection = "";

			landingWOVM.next = function () {
				if(landingWOVM.selection === "E"){
					$state.go('menu.selectSim')
					//registerWithSimService.isSimRegistration ? $state.go('menu.selectSim') : $state.go('menu.existingCustomer',{previousPage : "preHomeLoginPage"});
				}else{
					$state.go("menu.newToSbiLanding");
				}
			}

			landingWOVM.infoOpen = function(custType){
				if(custType === "E"){
					landingWOVM.info = [
						"Customers already having Internet Banking credentials - register Yono by using the internet banking details.",
						"Customers don't have internet banking credentials may register for both INB and Yono by using Debit card (without visiting the branch).",
						"Customers don't have either INB or Debit card, may create a request by using Yono and visit a branch for activation."
					];
				}else{
					landingWOVM.info = [
						"Open a New Video KYC Savings Bank Account",
						"Open a New Digital Savings Bank Account",
						"Resume your account opening application",
						"Apply for Loan"
					];
				}
                landingWOVM.popup = $ionicPopup.show({
                    templateUrl: 'pages/landing/infoPopup.html',
                    cssClass: 'bhim-alert-popup',
					scope:$scope,
                    buttons: [],
                });
			}

			landingWOVM.okBtnClicked = function(){
				landingWOVM.popup.close();
			}

			function currentLocation() {
                currentLocationService.getCurrentPosition().then(
                    function (position) {
                        ompMerchantsService.merchantsLocationData = position.coords ? position.coords : "";
                        clickStreamService.currentLocation = position.coords.latitude + " " + position.coords.longitude;
                    },
                    function (err) {
                        clickStreamService.currentLocation = "";
                    }
                );
            }

			$scope.$on('$ionicView.beforeEnter', function () {
				currentLocation();
			});

			//one time initialization to be done when the controller is loaded
            $scope.$on('$ionicView.loaded', function () {
                navigator.splashscreen.hide();
            });

			$scope.$on('$ionicView.afterEnter', function () {
                if (loggedInUserService.appOutdateFlag) {
                    var message = $filter('limitTo')(loggedInUserService.appOutdateMessage, 180);
                    var exitAppButton = utilityService.isAndroidPlatform() ? '<button class="btn exitBtn" ng-click="landingWOVM.exitForUpdateApp()">Exit</button>' : '';
                    landingWOVM.appUpdatePopup = $ionicPopup.show({
                        template: '<div class="popup-body"><div class="appUpdateContainer"><img class="appUpdateLogo" src="img/OMP/appUpdate.svg" alt="App update Logo"/></div><div class="appUpdateHeading">App Update Available</div><div class="appUpdateInfo">' + message + '</div><button class="btn updateAppBtn marginBottom4" ng-click="landingWOVM.updateToStore()">Update</button>' + exitAppButton + '</div></p>',
                        title: '',
                        scope: $scope,
                        cssClass: 'app-update-popup'
                    });
                    var elem = angular.element(document.querySelector(".backdrop"));
                    if (elem) {
                        elem.addClass('app-update-backdrop');
                    }
                }
            });

			landingWOVM.updateToStore = function () {
                utilityService.upgradeApp();
            };

            landingWOVM.exitForUpdateApp = function () {
                ionic.Platform.exitApp();
                navigator.app.exitApp();
            };


			return this;
		}
	]);
