angularApp.controller('lifeInsuranceApplicationInfoCFController', [
    "$state",
    "$scope",
    "validateService",
    "lifeInsuranceApplicationService",
    "lifeInsuranceCommonService",
    "LiConstant",


    function(
        $state,
        $scope,
        validateService, 
        lifeInsuranceApplicationService,
        lifeInsuranceCommonService,
        LiConstant) {

        var lifeInsuranceApplicationInfoCFVm = this;
        lifeInsuranceApplicationInfoCFVm.showBack = true;
        lifeInsuranceApplicationInfoCFVm.showNext = true;
        lifeInsuranceApplicationInfoCFVm.disableBack = false;
        lifeInsuranceApplicationInfoCFVm.disableNext = false;
        var date = validateService.getCurrentDate();
        var currentYear = parseInt(date.getFullYear());
        lifeInsuranceApplicationInfoCFVm.data = {};
        

        function initPage() {

            lifeInsuranceApplicationInfoCFVm.data.childEducationNeeds = [];
            lifeInsuranceApplicationInfoCFVm.data.childMarriageNeeds = [];

            lifeInsuranceApplicationInfoCFVm.data.numberOfChildren = lifeInsuranceApplicationService.getPersonalDetails().numberOfChildren;
            
            if (lifeInsuranceApplicationService.getneedAnalysisChildMarriage()) {
                lifeInsuranceApplicationInfoCFVm.data.childMarriageNeeds = lifeInsuranceApplicationService.getneedAnalysisChildMarriage();
            }

            if (lifeInsuranceApplicationService.getNeedAnalysisChildEducation()) {
                lifeInsuranceApplicationInfoCFVm.data.childEducationNeeds = lifeInsuranceApplicationService.getNeedAnalysisChildEducation();
            }else{
                initializeDetails();
            }

            if(lifeInsuranceApplicationInfoCFVm.data.childEducationNeeds.length != lifeInsuranceApplicationInfoCFVm.data.numberOfChildren){
                initializeDetails();
            }
            getMasterChildneeds();
        }

        function initializeDetails() {
            lifeInsuranceApplicationInfoCFVm.data.childEducationNeeds = [];
            lifeInsuranceApplicationInfoCFVm.data.childMarriageNeeds = [];
            for (var count = 0; count < lifeInsuranceApplicationInfoCFVm.data.numberOfChildren; count++) {
                var education = {};
                education.childAge = '';
                education.fundRequiredAge = '';
                education.savedAmount = '';
                education.currentCost = '';
                lifeInsuranceApplicationInfoCFVm.data.childEducationNeeds.push(education);

                var marriage = {};
                marriage.currentCost = '';
                marriage.fundRequiredAge = '';
                marriage.savedAmount = '';
                lifeInsuranceApplicationInfoCFVm.data.childMarriageNeeds.push(marriage);

            }
        };

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });


        lifeInsuranceApplicationInfoCFVm.closeJourney = function() {
             lifeInsuranceCommonService.closePopUp().then(function(result) {
                if(result) {
                   $state.go("menu.generalInsurance"); 
                }
            });
        };

        
        lifeInsuranceApplicationInfoCFVm.goBacktoPrevious = function() {
            $state.go("menu.lifeInsuranceApplicationInfoOG");
        }

        //validation starts 
        lifeInsuranceApplicationInfoCFVm.lifeInsuranceApplicationCFForm = {};
        lifeInsuranceApplicationInfoCFVm.validateService = validateService;

        //onclick of next button
        lifeInsuranceApplicationInfoCFVm.goToNextPage = function() {
            if (validateForm()) {
                lifeInsuranceApplicationService.setNeedAnalysisChildEducation(lifeInsuranceApplicationInfoCFVm.data.childEducationNeeds);
                lifeInsuranceApplicationService.setneedAnalysisChildMarriage(lifeInsuranceApplicationInfoCFVm.data.childMarriageNeeds);
                lifeInsuranceApplicationService.saveNA(LiConstant.journeyCommonId.NA_CHILD_FUTURE).then(function(){
                    submit();
                });
            }
        }

        function submit(){
            lifeInsuranceApplicationService.submitNeedAnalysisData().then(function(data) {
                lifeInsuranceApplicationService.setNeedAnalysisResult(data);
                $state.go("menu.financialGoalsCharts");
            });
        };

        function getMasterChildneeds() {
            var list = lifeInsuranceApplicationService.getNeedAnalysisMastersList();
            lifeInsuranceApplicationInfoCFVm.childAges = list.childAges;
            lifeInsuranceApplicationInfoCFVm.childEducationFundAt = list.childEducationFundAt;
            lifeInsuranceApplicationInfoCFVm.childMarriageFundAt = list.childMarriageFundAt;
        }


        function validateForm() {
            lifeInsuranceApplicationInfoCFVm.lifeInsuranceApplicationCFForm = {};
            lifeInsuranceApplicationInfoCFVm.lifeInsuranceApplicationCFForm.eduAge = {};
            lifeInsuranceApplicationInfoCFVm.lifeInsuranceApplicationCFForm.age = {};
            lifeInsuranceApplicationInfoCFVm.lifeInsuranceApplicationCFForm.saving = {};
            lifeInsuranceApplicationInfoCFVm.lifeInsuranceApplicationCFForm.currentCost = {};
            lifeInsuranceApplicationInfoCFVm.lifeInsuranceApplicationCFForm.marriageAge = {};
            lifeInsuranceApplicationInfoCFVm.lifeInsuranceApplicationCFForm.marriageSaving = {};
            lifeInsuranceApplicationInfoCFVm.lifeInsuranceApplicationCFForm.marriageCurrentCost = {};
            var isValid = true;

            for (var count = 0; count < lifeInsuranceApplicationInfoCFVm.data.numberOfChildren; count++) {
                if (lifeInsuranceApplicationInfoCFVm.validateService.isValidChildEduFund(lifeInsuranceApplicationInfoCFVm.data.childEducationNeeds[count].childAge)) {
                    lifeInsuranceApplicationInfoCFVm.lifeInsuranceApplicationCFForm.eduAge[count] = lifeInsuranceApplicationInfoCFVm.validateService.isValidChildEduFund(lifeInsuranceApplicationInfoCFVm.data.childEducationNeeds[count].childAge);
                    isValid = false;
                }

                if (lifeInsuranceApplicationInfoCFVm.validateService.isValidChildAge(lifeInsuranceApplicationInfoCFVm.data.childEducationNeeds[count].fundRequiredAge)) {
                    lifeInsuranceApplicationInfoCFVm.lifeInsuranceApplicationCFForm.age[count] = lifeInsuranceApplicationInfoCFVm.validateService.isValidChildAge(lifeInsuranceApplicationInfoCFVm.data.childEducationNeeds[count].fundRequiredAge);
                    isValid = false;
                }

                if (lifeInsuranceApplicationInfoCFVm.validateService.isValidSavings(lifeInsuranceApplicationInfoCFVm.data.childEducationNeeds[count].savedAmount)) {
                    lifeInsuranceApplicationInfoCFVm.lifeInsuranceApplicationCFForm.saving[count] = lifeInsuranceApplicationInfoCFVm.validateService.isValidSavings(lifeInsuranceApplicationInfoCFVm.data.childEducationNeeds[count].savedAmount);
                    isValid = false;
                }

                if (lifeInsuranceApplicationInfoCFVm.validateService.isValidCurrentCost(lifeInsuranceApplicationInfoCFVm.data.childEducationNeeds[count].currentCost, lifeInsuranceApplicationInfoCFVm.data.childEducationNeeds[count].savedAmount)) {
                    lifeInsuranceApplicationInfoCFVm.lifeInsuranceApplicationCFForm.currentCost[count] = lifeInsuranceApplicationInfoCFVm.validateService.isValidCurrentCost(lifeInsuranceApplicationInfoCFVm.data.childEducationNeeds[count].currentCost, lifeInsuranceApplicationInfoCFVm.data.childEducationNeeds[count].savedAmount);
                    isValid = false;
                }

                if (lifeInsuranceApplicationInfoCFVm.validateService.isValidMarriageEduFund(lifeInsuranceApplicationInfoCFVm.data.childMarriageNeeds[count].fundRequiredAge)) {
                    lifeInsuranceApplicationInfoCFVm.lifeInsuranceApplicationCFForm.marriageAge[count] = lifeInsuranceApplicationInfoCFVm.validateService.isValidMarriageEduFund(lifeInsuranceApplicationInfoCFVm.data.childMarriageNeeds[count].fundRequiredAge);
                    isValid = false;
                }

                if (lifeInsuranceApplicationInfoCFVm.validateService.isValidSavingsMarr(lifeInsuranceApplicationInfoCFVm.data.childMarriageNeeds[count].savedAmount)) {
                    lifeInsuranceApplicationInfoCFVm.lifeInsuranceApplicationCFForm.marriageSaving[count] = lifeInsuranceApplicationInfoCFVm.validateService.isValidSavingsMarr(lifeInsuranceApplicationInfoCFVm.data.childMarriageNeeds[count].savedAmount);
                    isValid = false;
                }

                if (lifeInsuranceApplicationInfoCFVm.validateService.isValidCurrentCostMarr(lifeInsuranceApplicationInfoCFVm.data.childMarriageNeeds[count].currentCost, lifeInsuranceApplicationInfoCFVm.data.childMarriageNeeds[count].savedAmount)) {
                    lifeInsuranceApplicationInfoCFVm.lifeInsuranceApplicationCFForm.marriageCurrentCost[count] = lifeInsuranceApplicationInfoCFVm.validateService.isValidCurrentCostMarr(lifeInsuranceApplicationInfoCFVm.data.childMarriageNeeds[count].currentCost, lifeInsuranceApplicationInfoCFVm.data.childMarriageNeeds[count].savedAmount);
                    isValid = false;
                }
            }
            return isValid;
        }


    }
]);
