angularApp.controller('lifeInsuranceApplicationInfoFDController', [
    "$state",
    "$scope",
    "validateService",
    "lifeInsuranceApplicationService",
    "lifeInsuranceCommonService",
    "LiConstant",
    "$ionicScrollDelegate",


    function(
        $state,
        $scope,
        validateService, 
        lifeInsuranceApplicationService,
        lifeInsuranceCommonService,
        LiConstant,
        $ionicScrollDelegate) {

        var lifeInsuranceApplicationInfoFDVm = this;
        lifeInsuranceApplicationInfoFDVm.validateService = validateService;
        lifeInsuranceApplicationInfoFDVm.showBack = true;
        lifeInsuranceApplicationInfoFDVm.showNext = true;
        lifeInsuranceApplicationInfoFDVm.disableBack = false;
        lifeInsuranceApplicationInfoFDVm.disableNext = false;
       
        function initPage() {
            lifeInsuranceApplicationInfoFDVm.data = {};
            if(lifeInsuranceApplicationService.getFinancialDetails()) {
                lifeInsuranceApplicationInfoFDVm.data = lifeInsuranceApplicationService.getFinancialDetails();
            }
        }

    
        lifeInsuranceApplicationInfoFDVm.goBacktoPrevious = function() {
            $state.go("menu.lifeInsuranceApplicationInfoPD");
        }

        lifeInsuranceApplicationInfoFDVm.closeJourney = function() {
             lifeInsuranceCommonService.closePopUp().then(function(result) {
                if(result) {
                   $state.go("menu.generalInsurance"); 
                }
            });
        };

        lifeInsuranceApplicationInfoFDVm.resize = function() {
            $ionicScrollDelegate.$getByHandle('mainScroll').resize();
        };
       
        lifeInsuranceApplicationInfoFDVm.goToNextPage = function() {
            if (validateForm()) {

                if(!lifeInsuranceApplicationInfoFDVm.data.haveLIPolicy) {
                    lifeInsuranceApplicationInfoFDVm.data.haveLIPolicy = false;
                    lifeInsuranceApplicationInfoFDVm.data.currentLifeSumAssured = "0";
                }

                if(!lifeInsuranceApplicationInfoFDVm.data.haveLoan) {
                    lifeInsuranceApplicationInfoFDVm.data.haveLoan = false;
                    lifeInsuranceApplicationInfoFDVm.data.outstandingHomeLoan = "0";
                    lifeInsuranceApplicationInfoFDVm.data.outstandingOtherLoan = "0";
                }

                lifeInsuranceApplicationService.setFinancialDetails(lifeInsuranceApplicationInfoFDVm.data);
                lifeInsuranceApplicationService.saveNA(LiConstant.journeyCommonId.NA_FINANCIAL).then(function() {
                    $state.go("menu.lifeInsuranceApplicationInfoOD");
                });
            }
        }

    
        function validateForm() {
            lifeInsuranceApplicationInfoFDVm.lifeInsuranceApplicationFDForm = {};

            if (lifeInsuranceApplicationInfoFDVm.validateService.isValidMonthlyIncome(lifeInsuranceApplicationInfoFDVm.data.monthlyIncome)) {
                lifeInsuranceApplicationInfoFDVm.lifeInsuranceApplicationFDForm.monthlyIncome = lifeInsuranceApplicationInfoFDVm.validateService.isValidMonthlyIncome(lifeInsuranceApplicationInfoFDVm.data.monthlyIncome);
            }

            if (lifeInsuranceApplicationInfoFDVm.validateService.isValidMonthlyExpense(lifeInsuranceApplicationInfoFDVm.data.monthlyExpenses)) {
                lifeInsuranceApplicationInfoFDVm.lifeInsuranceApplicationFDForm.monthlyExpenses = lifeInsuranceApplicationInfoFDVm.validateService.isValidMonthlyExpense(lifeInsuranceApplicationInfoFDVm.data.monthlyExpenses);
            }

            if (lifeInsuranceApplicationInfoFDVm.data.haveLIPolicy) {
                if (lifeInsuranceApplicationInfoFDVm.validateService.isValidExistingPolicyDetails(lifeInsuranceApplicationInfoFDVm.data.currentLifeSumAssured)) {
                    lifeInsuranceApplicationInfoFDVm.lifeInsuranceApplicationFDForm.currentLifeSumAssured = lifeInsuranceApplicationInfoFDVm.validateService.isValidExistingPolicyDetails(lifeInsuranceApplicationInfoFDVm.data.currentLifeSumAssured);
                }
            }
            if (lifeInsuranceApplicationInfoFDVm.data.haveLoan) {
                if (lifeInsuranceApplicationInfoFDVm.validateService.isValidOutstandingHomeLoan(lifeInsuranceApplicationInfoFDVm.data.outstandingHomeLoan)) {
                    lifeInsuranceApplicationInfoFDVm.lifeInsuranceApplicationFDForm.outstandingHomeLoan = lifeInsuranceApplicationInfoFDVm.validateService.isValidOutstandingHomeLoan(lifeInsuranceApplicationInfoFDVm.data.outstandingHomeLoan);
                }
                if (lifeInsuranceApplicationInfoFDVm.validateService.isValidOutstandingOtherLoan(lifeInsuranceApplicationInfoFDVm.data.outstandingOtherLoan)) {
                    lifeInsuranceApplicationInfoFDVm.lifeInsuranceApplicationFDForm.outstandingOtherLoan = lifeInsuranceApplicationInfoFDVm.validateService.isValidOutstandingOtherLoan(lifeInsuranceApplicationInfoFDVm.data.outstandingOtherLoan);
                }
            }
            return (angular.equals({}, lifeInsuranceApplicationInfoFDVm.lifeInsuranceApplicationFDForm)) ? true : false;
        }


        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
