angularApp.controller('lifeInsuranceApplicationInfoODController', [
    "$state",
    "$scope",
    "validateService",
    "lifeInsuranceApplicationService",
    "utilityService",
    "lifeInsuranceCommonService",
    "LiConstant",
    "$translate",


    function(
        $state,
        $scope,
        validateService,
        lifeInsuranceApplicationService,
        utilityService,
        lifeInsuranceCommonService,
        LiConstant,
        $translate) {

        var lifeInsuranceApplicationInfoODVm = this;
        lifeInsuranceApplicationInfoODVm.validateService = validateService;

        lifeInsuranceApplicationInfoODVm.showBack = true;
        lifeInsuranceApplicationInfoODVm.showNext = true;
        lifeInsuranceApplicationInfoODVm.disableBack = false;
        lifeInsuranceApplicationInfoODVm.disableNext = false;

        lifeInsuranceApplicationInfoODVm.data = {};

        function initPage() {
            var list = lifeInsuranceApplicationService.getNeedAnalysisMastersList();
            lifeInsuranceApplicationInfoODVm.assumedInflations = list.assumedInflations;
            lifeInsuranceApplicationInfoODVm.riskAppetites = list.riskAppetites;
            if (lifeInsuranceApplicationService.getOtherDetails()) {
                lifeInsuranceApplicationInfoODVm.data = lifeInsuranceApplicationService.getOtherDetails();
            } else {
                lifeInsuranceApplicationInfoODVm.data.assumedInflation = lifeInsuranceApplicationInfoODVm.assumedInflations[2];
            }

        }


        //onclick of back button
        lifeInsuranceApplicationInfoODVm.goBacktoPrevious = function() {
            $state.go("menu.lifeInsuranceApplicationInfoFD");
        }


        lifeInsuranceApplicationInfoODVm.closeJourney = function() {
             lifeInsuranceCommonService.closePopUp().then(function(result) {
                if(result) {
                   $state.go("menu.generalInsurance"); 
                }
            });
        };

        //onclick of next button
        lifeInsuranceApplicationInfoODVm.goToNextPage = function() {
            if (validateForm()) {
                lifeInsuranceApplicationService.setOtherDetails(lifeInsuranceApplicationInfoODVm.data);
                lifeInsuranceApplicationService.saveNA(LiConstant.journeyCommonId.NA_OTHER).then(function() {
                    $state.go("menu.lifeInsuranceApplicationInfoRP");
                });
            }
        }

        lifeInsuranceApplicationInfoODVm.showRiskInfo = function() {
            var message = $translate.instant('OD_RISK_INFO');
            var title = '';
            var template = "<p class='roboto-regular font-content text-left'>"+message+"</p> ";
            var onTap = '';
            var buttontext = "<b>OK</b>";
            utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
        }

        lifeInsuranceApplicationInfoODVm.showInflationRates = function() {
            var message = $translate.instant('OD_INFLATION_INFO');
            var title = '';
            var template = "<p class='roboto-regular font-content'>"+message+"</p>";
            var onTap = '';
            var buttontext = "<b>OK</b>";
            utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
        }

        //common validation function
        function validateForm() {
            lifeInsuranceApplicationInfoODVm.lifeInsuranceApplicationODForm = {};
            if (lifeInsuranceApplicationInfoODVm.validateService.isValidInflation(lifeInsuranceApplicationInfoODVm.data.assumedInflation)) {
                lifeInsuranceApplicationInfoODVm.lifeInsuranceApplicationODForm.assumedInflation = lifeInsuranceApplicationInfoODVm.validateService.isValidInflation(lifeInsuranceApplicationInfoODVm.data.assumedInflation);
            }
            if (lifeInsuranceApplicationInfoODVm.validateService.isValidRisk(lifeInsuranceApplicationInfoODVm.data.riskAppetite)) {
                lifeInsuranceApplicationInfoODVm.lifeInsuranceApplicationODForm.riskAppetite = lifeInsuranceApplicationInfoODVm.validateService.isValidRisk(lifeInsuranceApplicationInfoODVm.data.riskAppetite);
            }
            return (angular.equals({}, lifeInsuranceApplicationInfoODVm.lifeInsuranceApplicationODForm)) ? true : false;
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
