angularApp.controller('lifeInsuranceApplicationInfoOGController', [
    "$state",
    "$scope",
    "validateService",
    "lifeInsuranceApplicationService",
    "lifeInsuranceCommonService",
    "LiConstant",
    "$ionicScrollDelegate",


    function(
        $state,
        $scope,
        validateService,
        lifeInsuranceApplicationService,
        lifeInsuranceCommonService,
        LiConstant,
        $ionicScrollDelegate) {

        var lifeInsuranceApplicationInfoOGVm = this;
        lifeInsuranceApplicationInfoOGVm.validateService = validateService;
        var date = validateService.getCurrentDate();
        var currentYear = parseInt(date.getFullYear());

        lifeInsuranceApplicationInfoOGVm.showBack = true;
        lifeInsuranceApplicationInfoOGVm.showNext = true;
        lifeInsuranceApplicationInfoOGVm.disableBack = false;
        lifeInsuranceApplicationInfoOGVm.disableNext = false;
        var firPageDetail;

        lifeInsuranceApplicationInfoOGVm.data = {};


        function initPage() {
            getMasterOthergoals();
            firPageDetail = lifeInsuranceApplicationService.getPersonalDetails();
            if (lifeInsuranceApplicationService.getOtherGoals()) {
                lifeInsuranceApplicationInfoOGVm.data = lifeInsuranceApplicationService.getOtherGoals();
            }
        }

        function getMasterOthergoals() {
            lifeInsuranceApplicationInfoOGVm.otherGoalsAt = lifeInsuranceApplicationService.getNeedAnalysisMastersList().otherGoalsAt;
        }

        lifeInsuranceApplicationInfoOGVm.updateAchieveBy = function() {
            if (lifeInsuranceApplicationInfoOGVm.data.achiveByYear.key == 0) {
                lifeInsuranceApplicationInfoOGVm.data.savedAmount = '0';
                lifeInsuranceApplicationInfoOGVm.data.currentCost = '0';
            } else {
                lifeInsuranceApplicationInfoOGVm.data.savedAmount = '';
                lifeInsuranceApplicationInfoOGVm.data.currentCost = '';
            }
        }


        lifeInsuranceApplicationInfoOGVm.closeJourney = function() {
             lifeInsuranceCommonService.closePopUp().then(function(result) {
                if(result) {
                   $state.go("menu.generalInsurance"); 
                }
            });
        };

        //onclick of previous button
        lifeInsuranceApplicationInfoOGVm.goBacktoPrevious = function() {
            $state.go("menu.lifeInsuranceApplicationInfoBuyHome");
        };


        lifeInsuranceApplicationInfoOGVm.resize = function() {
            $ionicScrollDelegate.$getByHandle('mainScroll').resize();
        };
        
        //onclick of next button
        lifeInsuranceApplicationInfoOGVm.goToNextPage = function() {
            if (validateForm()) {
                
                if(lifeInsuranceApplicationInfoOGVm.data.achiveByYear.key == 0) {
                    lifeInsuranceApplicationInfoOGVm.data.savedAmount = '0';
                    lifeInsuranceApplicationInfoOGVm.data.currentCost = '0';
                    lifeInsuranceApplicationService.setNoOtherGoals(true);
                } else {
                    lifeInsuranceApplicationService.setNoOtherGoals(false);
                }

                lifeInsuranceApplicationService.setNeedAnalysisOtherGoalDetails(lifeInsuranceApplicationInfoOGVm.data);
                lifeInsuranceApplicationService.saveNA(LiConstant.journeyCommonId.NA_OTHER_GOALS).then(function(){
                     if (firPageDetail.numberOfChildren == 0) {
                        gotoFinancialGoalsCharts();
                    } else {
                        $state.go("menu.lifeInsuranceApplicationInfoCF");
                    }
                });
            }
        }


        function gotoFinancialGoalsCharts() {
            var req = [];
            lifeInsuranceApplicationService.setNeedAnalysisChildEducation(req);
            lifeInsuranceApplicationService.setneedAnalysisChildMarriage(req);
               
            lifeInsuranceApplicationService.submitNeedAnalysisData().then(function(data) {
                lifeInsuranceApplicationService.setNeedAnalysisResult(data);
                 $state.go("menu.financialGoalsCharts");
            });
        }


        // validation function
        function validateForm() {
            lifeInsuranceApplicationInfoOGVm.lifeInsuranceApplicationOGForm = {};

            if (lifeInsuranceApplicationInfoOGVm.validateService.isValidAchieveBy(lifeInsuranceApplicationInfoOGVm.data.achiveByYear)) {
                lifeInsuranceApplicationInfoOGVm.lifeInsuranceApplicationOGForm.achiveByYear = lifeInsuranceApplicationInfoOGVm.validateService.isValidAchieveBy(lifeInsuranceApplicationInfoOGVm.data.achiveByYear);
            }

            if(lifeInsuranceApplicationInfoOGVm.data.achiveByYear && (lifeInsuranceApplicationInfoOGVm.data.achiveByYear.key != 0)) {
                if (lifeInsuranceApplicationInfoOGVm.validateService.isValidSavings(lifeInsuranceApplicationInfoOGVm.data.savedAmount)) {
                lifeInsuranceApplicationInfoOGVm.lifeInsuranceApplicationOGForm.savedAmount = lifeInsuranceApplicationInfoOGVm.validateService.isValidSavings(lifeInsuranceApplicationInfoOGVm.data.savedAmount);
                }

                if (lifeInsuranceApplicationInfoOGVm.validateService.isValidCurrentCost(lifeInsuranceApplicationInfoOGVm.data.currentCost, lifeInsuranceApplicationInfoOGVm.data.savedAmount)) {
                    lifeInsuranceApplicationInfoOGVm.lifeInsuranceApplicationOGForm.currentCost = lifeInsuranceApplicationInfoOGVm.validateService.isValidCurrentCost(lifeInsuranceApplicationInfoOGVm.data.currentCost, lifeInsuranceApplicationInfoOGVm.data.savedAmount);
                }
            }
            
            return (angular.equals({}, lifeInsuranceApplicationInfoOGVm.lifeInsuranceApplicationOGForm)) ? true : false;
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
