angularApp.controller('lifeInsuranceApplicationInfoPDController', [
    "$state",
    "$scope",
    "validateService",
    "lifeInsuranceApplicationService",
    "$filter",
    "$stateParams",
    "lifeInsuranceCommonService",
    "LiConstant",
    "$timeout",
    function(
        $state,
        $scope,
        validateService,
        lifeInsuranceApplicationService,
        $filter,
        $stateParams,
        lifeInsuranceCommonService,
        LiConstant,
        $timeout) {

        var lifeInsuranceApplicationInfoPDVm = this;
        lifeInsuranceApplicationInfoPDVm.validateService = validateService;

        lifeInsuranceApplicationInfoPDVm.showBack = true;
        lifeInsuranceApplicationInfoPDVm.showNext = true;
        lifeInsuranceApplicationInfoPDVm.disableBack = false;
        lifeInsuranceApplicationInfoPDVm.disableNext = false;

        lifeInsuranceApplicationInfoPDVm.agree = $stateParams.agree;

        var currentDate = validateService.getCurrentDate();
        lifeInsuranceApplicationInfoPDVm.defaultDate = new Date(1980, 0, 1, 0, 0, 0, 0); // default calender year 1980
        lifeInsuranceApplicationInfoPDVm.minEndDate = $filter('chosenDate')(validateService.getFutureDate(currentDate, -36500));
        lifeInsuranceApplicationInfoPDVm.maxEndDate = $filter('chosenDate')(validateService.getFutureYear(currentDate, -18));

        //initialize the UI
        function initPage() {
            lifeInsuranceApplicationInfoPDVm.data = {};
            lifeInsuranceApplicationInfoPDVm.data.name = {};
            lifeInsuranceApplicationInfoPDVm.data.numberOfChildren = 0;

            var data = lifeInsuranceApplicationService.getAccoutDetails();
            if (data) {
                $timeout(function() { //to render the values only after view is completly visible
                    lifeInsuranceApplicationInfoPDVm.data.name.first = data.cbsData.firstName;
                    lifeInsuranceApplicationInfoPDVm.data.name.middle = data.cbsData.middleName;
                    lifeInsuranceApplicationInfoPDVm.data.name.last = data.cbsData.lastName;
                    lifeInsuranceApplicationInfoPDVm.data.dob = $filter('formatCbsDate')(data.cbsData.dateOfBirth);
                    lifeInsuranceApplicationInfoPDVm.genderCode = data.cbsData.genderCode;
                    getMasterData();
                }, 10);
            }
            
            if (lifeInsuranceApplicationService.getPersonalDetails()) {
                lifeInsuranceApplicationInfoPDVm.data = lifeInsuranceApplicationService.getPersonalDetails();
            }
        }


        //populate the gender based on the title selected
        lifeInsuranceApplicationInfoPDVm.populateGender = function() {
            if (lifeInsuranceApplicationInfoPDVm.data.salutation == lifeInsuranceApplicationInfoPDVm.salutations[0]) {
                lifeInsuranceApplicationInfoPDVm.data.gender = lifeInsuranceApplicationInfoPDVm.genders[0];
            } else {
                lifeInsuranceApplicationInfoPDVm.data.gender = lifeInsuranceApplicationInfoPDVm.genders[1];
            }

        }

        lifeInsuranceApplicationInfoPDVm.closeJourney = function() {
            lifeInsuranceCommonService.closePopUp().then(function(result) {
                if (result) {
                    $state.go("menu.generalInsurance");
                }
            });

        };

        //get the master data
        function getMasterData() {
            var data = lifeInsuranceApplicationService.getNeedAnalysisMastersList();
            lifeInsuranceApplicationInfoPDVm.genders = data.genders;
            if ($stateParams.agree && lifeInsuranceApplicationInfoPDVm.genderCode == "M") {
                lifeInsuranceApplicationInfoPDVm.data.gender = lifeInsuranceApplicationInfoPDVm.genders[0];
                lifeInsuranceApplicationInfoPDVm.data.salutation = data.salutations[0];
            } else if ($stateParams.agree && lifeInsuranceApplicationInfoPDVm.genderCode == "F") {
                lifeInsuranceApplicationInfoPDVm.data.gender = lifeInsuranceApplicationInfoPDVm.genders[1];
                lifeInsuranceApplicationInfoPDVm.data.salutation = data.salutations[2];
            }

            lifeInsuranceApplicationInfoPDVm.maritalStatusLists = data.maritalStatusLists;
            lifeInsuranceApplicationInfoPDVm.salutations = data.salutations;

        }


        // decrement logic for children
        lifeInsuranceApplicationInfoPDVm.decrementInsurers = function() {
            if (lifeInsuranceApplicationInfoPDVm.data.numberOfChildren > 0) {
                lifeInsuranceApplicationInfoPDVm.data.numberOfChildren--;
            }
        }

        // increment logic for children
        lifeInsuranceApplicationInfoPDVm.incrementInsurers = function() {
            if (lifeInsuranceApplicationInfoPDVm.data.numberOfChildren < 4) {
                lifeInsuranceApplicationInfoPDVm.data.numberOfChildren++;
            }
        }


        //onclick of back button
        lifeInsuranceApplicationInfoPDVm.goBacktoPrevious = function() {
            if (lifeInsuranceCommonService.isFromRetrieveApplication()) {
                $state.go("menu.retreiveApplication");
            } else {
                $state.go("menu.lifeInsurancePaymentAccountDetails");
            }
        }


        //onclick of submit button
        lifeInsuranceApplicationInfoPDVm.goToNextPage = function() {
            if (validateForm()) {
                lifeInsuranceApplicationInfoPDVm.data.age = validateService.calcAge(lifeInsuranceApplicationInfoPDVm.data.dob);
                if (lifeInsuranceApplicationInfoPDVm.data.numberOfChildren == 0) {
                    lifeInsuranceApplicationService.setNoChildPlans(true);
                } else {
                    lifeInsuranceApplicationService.setNoChildPlans(false);
                }
                lifeInsuranceApplicationInfoPDVm.data.numberOfChildren = lifeInsuranceApplicationInfoPDVm.data.numberOfChildren.toString();
                lifeInsuranceApplicationService.setPersonalDetails(lifeInsuranceApplicationInfoPDVm.data);
                lifeInsuranceApplicationService.saveNA(LiConstant.journeyCommonId.NA_PERSONAL).then(function() {
                    $state.go("menu.lifeInsuranceApplicationInfoFD");
                });
            }
        }

        //common validation function
        function validateForm() {
            lifeInsuranceApplicationInfoPDVm.lifeInsuranceApplicationPDForm = {};
            if (lifeInsuranceApplicationInfoPDVm.validateService.isValidName(lifeInsuranceApplicationInfoPDVm.data.name.first)) {
                lifeInsuranceApplicationInfoPDVm.lifeInsuranceApplicationPDForm.first = lifeInsuranceApplicationInfoPDVm.validateService.isValidName(lifeInsuranceApplicationInfoPDVm.data.name.first);
            }
            if (lifeInsuranceApplicationInfoPDVm.validateService.isValidName(lifeInsuranceApplicationInfoPDVm.data.name.last)) {
                lifeInsuranceApplicationInfoPDVm.lifeInsuranceApplicationPDForm.last = lifeInsuranceApplicationInfoPDVm.validateService.isValidName(lifeInsuranceApplicationInfoPDVm.data.name.last);
            }
            if(lifeInsuranceApplicationInfoPDVm.data.name.middle != "" && lifeInsuranceApplicationInfoPDVm.data.name.middle){
             if (lifeInsuranceApplicationInfoPDVm.validateService.isValidName(lifeInsuranceApplicationInfoPDVm.data.name.middle)) {
                 lifeInsuranceApplicationInfoPDVm.lifeInsuranceApplicationPDForm.middle = lifeInsuranceApplicationInfoPDVm.validateService.isValidName(lifeInsuranceApplicationInfoPDVm.data.name.middle);
             }   
            }
            if (lifeInsuranceApplicationInfoPDVm.validateService.isValidAdult(lifeInsuranceApplicationInfoPDVm.data.dob)) {
                lifeInsuranceApplicationInfoPDVm.lifeInsuranceApplicationPDForm.dob = lifeInsuranceApplicationInfoPDVm.validateService.isValidAdult(lifeInsuranceApplicationInfoPDVm.data.dob);
            }

            if (lifeInsuranceApplicationInfoPDVm.validateService.isValidMstatus(lifeInsuranceApplicationInfoPDVm.data.maritalStatus)) {
                lifeInsuranceApplicationInfoPDVm.lifeInsuranceApplicationPDForm.maritalStatus = lifeInsuranceApplicationInfoPDVm.validateService.isValidMstatus(lifeInsuranceApplicationInfoPDVm.data.maritalStatus);
            }
            if (lifeInsuranceApplicationInfoPDVm.validateService.isValidTitle(lifeInsuranceApplicationInfoPDVm.data.salutation)) {
                lifeInsuranceApplicationInfoPDVm.lifeInsuranceApplicationPDForm.salutation = lifeInsuranceApplicationInfoPDVm.validateService.isValidTitle(lifeInsuranceApplicationInfoPDVm.data.salutation);
            }
            return (angular.equals({}, lifeInsuranceApplicationInfoPDVm.lifeInsuranceApplicationPDForm)) ? true : false;
        }


        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });
    }
]);
