angularApp.controller('lifeInsuranceApplicationInfoRPController', [
    "$state",
    "$scope",
    "validateService",
    "lifeInsuranceApplicationService",
    "utilityService",
    "lifeInsuranceCommonService",
    "LiConstant",
    "$translate",

    function(
        $state,
        $scope,
        validateService,
        lifeInsuranceApplicationService,
        utilityService,
        lifeInsuranceCommonService,
        LiConstant,
        $translate) {

        var lifeInsuranceApplicationInfoRPVm = this;
        lifeInsuranceApplicationInfoRPVm.showBack = true;
        lifeInsuranceApplicationInfoRPVm.showNext = true;
        lifeInsuranceApplicationInfoRPVm.disableBack = false;
        lifeInsuranceApplicationInfoRPVm.disableNext = false;

        lifeInsuranceApplicationInfoRPVm.data = {};
        lifeInsuranceApplicationInfoRPVm.data.retirementAge = "";
        lifeInsuranceApplicationInfoRPVm.data.savedAmount = "";
        lifeInsuranceApplicationInfoRPVm.data.postRetirementLifeStyle = "";


        function initPage() {
            lifeInsuranceApplicationInfoRPVm.currentAge = lifeInsuranceApplicationService.getPersonalDetails().age;

            var list = lifeInsuranceApplicationService.getNeedAnalysisMastersList();
            lifeInsuranceApplicationInfoRPVm.postRetirementLifecycles = list.postRetirementLifecycles;
            lifeInsuranceApplicationInfoRPVm.retireAt = list.retireAt;

            if (lifeInsuranceApplicationService.getRetirementPlanning()) {
                lifeInsuranceApplicationInfoRPVm.data = lifeInsuranceApplicationService.getRetirementPlanning();
            }
        }


        //onclick of Back button
        lifeInsuranceApplicationInfoRPVm.goBacktoPrevious = function() {
            $state.go("menu.lifeInsuranceApplicationInfoOD");
        }


        lifeInsuranceApplicationInfoRPVm.closeJourney = function() {
            lifeInsuranceCommonService.closePopUp().then(function(result) {
                if(result) {
                   $state.go("menu.generalInsurance"); 
                }
            });
        };

        lifeInsuranceApplicationInfoRPVm.showRetirementInfo = function() {
            var message = $translate.instant('RETIRE_INFO');
            var title = '';
            var template = "<p class='roboto-regular font-content text-left'>"+message+"</p> ";
            var onTap = '';
            var buttontext = "<b>OK</b>";
            utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
        }

        //validation starts 
        lifeInsuranceApplicationInfoRPVm.lifeInsuranceApplicationRPForm = {};
        lifeInsuranceApplicationInfoRPVm.validateService = validateService;

        //onclick of next button
        lifeInsuranceApplicationInfoRPVm.goToNextPage = function() {
            if (validateForm()) {
                lifeInsuranceApplicationService.setRetirementPlanning(lifeInsuranceApplicationInfoRPVm.data);
                lifeInsuranceApplicationService.saveNA(LiConstant.journeyCommonId.NA_RETIREMENT).then(function() {
                    $state.go("menu.lifeInsuranceApplicationInfoBuyHome");
                });
            }
        }



        function validateForm() {

            lifeInsuranceApplicationInfoRPVm.lifeInsuranceApplicationRPForm = {};
            if (lifeInsuranceApplicationInfoRPVm.validateService.isValidRetire(lifeInsuranceApplicationInfoRPVm.data.retirementAge)) {
                lifeInsuranceApplicationInfoRPVm.lifeInsuranceApplicationRPForm.retirementAge = lifeInsuranceApplicationInfoRPVm.validateService.isValidRetire(lifeInsuranceApplicationInfoRPVm.data.retirementAge);
            }


            if (lifeInsuranceApplicationInfoRPVm.validateService.isValidSavings(lifeInsuranceApplicationInfoRPVm.data.savedAmount)) {
                lifeInsuranceApplicationInfoRPVm.lifeInsuranceApplicationRPForm.savedAmount = lifeInsuranceApplicationInfoRPVm.validateService.isValidSavings(lifeInsuranceApplicationInfoRPVm.data.savedAmount);
            }

            if (lifeInsuranceApplicationInfoRPVm.validateService.isValidPostretire(lifeInsuranceApplicationInfoRPVm.data.postRetirementLifeStyle)) {
                lifeInsuranceApplicationInfoRPVm.lifeInsuranceApplicationRPForm.postRetirementLifeStyle = lifeInsuranceApplicationInfoRPVm.validateService.isValidPostretire(lifeInsuranceApplicationInfoRPVm.data.postRetirementLifeStyle);
            }

            return (angular.equals({}, lifeInsuranceApplicationInfoRPVm.lifeInsuranceApplicationRPForm)) ? true : false;
        }


        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });
    }
]);
