angularApp.controller('liForm_DiseaseDetailsController', [
    "$state",
    "$scope",
    "lifeInsuranceBasicApplicationService",
    "validateService",
    "lifeInsuranceApplicationService",
    "lifeInsuranceCommonService",
    "suggestedPlansDetailsService",
    "LiConstant",
    "$ionicScrollDelegate",
    "clickStreamService",

    function(
        $state,
        $scope,
        lifeInsuranceBasicApplicationService,
        validateService,
        lifeInsuranceApplicationService,
        lifeInsuranceCommonService,
        suggestedPlansDetailsService,
        LiConstant,
        $ionicScrollDelegate,clickStreamService) {

        var liForm_DiseaseDetailsVm = this;


        function initPage() {
            liForm_DiseaseDetailsVm.showBack = true;
            liForm_DiseaseDetailsVm.showNext = true;
            liForm_DiseaseDetailsVm.disableBack = false;
            liForm_DiseaseDetailsVm.disableNext = false;
            liForm_DiseaseDetailsVm.liFormDiseaseDetails = {};

            liForm_DiseaseDetailsVm.uin = suggestedPlansDetailsService.getCurrentSugestedProduct().uin;
            liForm_DiseaseDetailsVm.selectedProduct = suggestedPlansDetailsService.getCurrentSugestedProduct().planName;
            liForm_DiseaseDetailsVm.data = {};
            liForm_DiseaseDetailsVm.data.disease = [];
            liForm_DiseaseDetailsVm.diseaseCount = 1;
            liForm_DiseaseDetailsVm.maxDate = Date();
            liForm_DiseaseDetailsVm.validateService = validateService;
            liForm_DiseaseDetailsVm.gender = lifeInsuranceApplicationService.getPersonalDetails().gender;

            var disease = {};
            disease.natureOfDisease = "";
            disease.dateOfDiagnosis = "";
            disease.hospitalAddress = "";
            disease.treatmentDetails = "";
            liForm_DiseaseDetailsVm.data.disease.push(disease);
            liForm_DiseaseDetailsVm.hasDisease = false;


            var medicalQuestionAns = lifeInsuranceBasicApplicationService.getMedicalHistory().questions;
            var comQuesLength = lifeInsuranceBasicApplicationService.getcommonQuestionLength();
            if (liForm_DiseaseDetailsVm.gender.key == 'F') {
                var femQuesLength = lifeInsuranceBasicApplicationService.getfemaleQuestionLength();
                var arrLength = comQuesLength + femQuesLength;
            } else {
                var arrLength = comQuesLength;
            }

            for (var i = 0; i < arrLength; i++) {
                if (medicalQuestionAns[i].ans && medicalQuestionAns[i].ans.toString() == "true" && medicalQuestionAns[i].qid !== "hm_visible_ID_mark_detail" && medicalQuestionAns[i].qid !== 'HD_HUSBAND_ANNUAL_INCOME' && medicalQuestionAns[i].qid !== 'hd_preg_last_delivery_date') {
                    liForm_DiseaseDetailsVm.hasDisease = true;
                    break;
                }
            }
            if (lifeInsuranceBasicApplicationService.getDiseaseDetails() && lifeInsuranceBasicApplicationService.getDiseaseDetails().length != 0) {
                liForm_DiseaseDetailsVm.data.disease = lifeInsuranceBasicApplicationService.getDiseaseDetails();
                for (var index = 0; index < liForm_DiseaseDetailsVm.data.disease.length; index++) {
                    if (liForm_DiseaseDetailsVm.data.disease[index].isFullyRecovered == 'true' || liForm_DiseaseDetailsVm.data.disease[index].isFullyRecovered == true) {
                        liForm_DiseaseDetailsVm.data.disease[index].isFullyRecovered = true;
                    } else {
                        liForm_DiseaseDetailsVm.data.disease[index].isFullyRecovered = false;
                    }
                }

            }
        }


        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });


        liForm_DiseaseDetailsVm.closeJourney = function() {
            lifeInsuranceCommonService.closePopUp().then(function(result) {
                if (result) {
                    $state.go("menu.generalInsurance");
                }
            });
        };

        $scope.addDisease = function() {
            if (liForm_DiseaseDetailsVm.diseaseCount < 4) {
                var disease = {};
                disease.natureOfDisease = "";
                disease.dateOfDiagnosis = "";
                disease.hospitalAddress = "";
                disease.treatmentDetails = "";
                liForm_DiseaseDetailsVm.data.disease.push(disease);
            }
            liForm_DiseaseDetailsVm.diseaseCount++;
            $ionicScrollDelegate.$getByHandle('mainScroll').resize();
        }

        $scope.deleteDisease = function(count) {
            liForm_DiseaseDetailsVm.data.disease.splice(count, 1);
            liForm_DiseaseDetailsVm.diseaseCount--;
            $ionicScrollDelegate.$getByHandle('mainScroll').resize();
        }

        // On click of Back button
        liForm_DiseaseDetailsVm.goBacktoPrevious = function() {

            var newStart = parseInt(lifeInsuranceBasicApplicationService.getStart());
            if (!newStart) {
                var medical = lifeInsuranceBasicApplicationService.getMedicalQuestions();
                newStart = medical.commonQues.length;
                if (liForm_DiseaseDetailsVm.gender.key == 'F') {
                    newStart += medical.femaleAdditionalQues.length;
                }
                newStart = parseInt(newStart / 10) * 10;
            }


            if (liForm_DiseaseDetailsVm.gender.key == 'M') {
                $state.go("menu.retireSmartMedicalHistory", { start: newStart });
            } else {
                $state.go("menu.retireSmartMedicalHistory4");
            }

        }

        function validateForm() {
            liForm_DiseaseDetailsVm.liFormDiseaseDetails = {};
            liForm_DiseaseDetailsVm.liFormDiseaseDetails.natureOfDisease = [];
            liForm_DiseaseDetailsVm.liFormDiseaseDetails.dateOfDiagnosis = [];
            liForm_DiseaseDetailsVm.liFormDiseaseDetails.hospitalAddress = [];
            liForm_DiseaseDetailsVm.liFormDiseaseDetails.treatmentDetails = [];


            var isValid = true;

            for (var count = 0; count < liForm_DiseaseDetailsVm.diseaseCount; count++) {

                if (liForm_DiseaseDetailsVm.validateService.isValidNatureDisease(liForm_DiseaseDetailsVm.data.disease[count].natureOfDisease, liForm_DiseaseDetailsVm.hasDisease)) {
                    liForm_DiseaseDetailsVm.liFormDiseaseDetails.natureOfDisease[count] =
                        liForm_DiseaseDetailsVm.validateService.isValidNatureDisease(liForm_DiseaseDetailsVm.data.disease[count].natureOfDisease, liForm_DiseaseDetailsVm.hasDisease);
                    isValid = false;
                }

                if (liForm_DiseaseDetailsVm.validateService.isValidDiagnosisDate(liForm_DiseaseDetailsVm.data.disease[count].dateOfDiagnosis, liForm_DiseaseDetailsVm.hasDisease) && liForm_DiseaseDetailsVm.hasDisease) {
                    liForm_DiseaseDetailsVm.liFormDiseaseDetails.dateOfDiagnosis[count] =
                        liForm_DiseaseDetailsVm.validateService.isValidDiagnosisDate(liForm_DiseaseDetailsVm.data.disease[count].dateOfDiagnosis, liForm_DiseaseDetailsVm.hasDisease);
                    isValid = false;
                }

                if (liForm_DiseaseDetailsVm.data.disease[count].isFullyRecovered && liForm_DiseaseDetailsVm.validateService.isValidInfoDoctorHospital(liForm_DiseaseDetailsVm.data.disease[count].hospitalAddress, liForm_DiseaseDetailsVm.hasDisease) && liForm_DiseaseDetailsVm.hasDisease) {
                    liForm_DiseaseDetailsVm.liFormDiseaseDetails.hospitalAddress[count] =
                        liForm_DiseaseDetailsVm.validateService.isValidInfoDoctorHospital(liForm_DiseaseDetailsVm.data.disease[count].hospitalAddress, liForm_DiseaseDetailsVm.hasDisease);
                    isValid = false;
                }
                if (!liForm_DiseaseDetailsVm.data.disease[count].isFullyRecovered && liForm_DiseaseDetailsVm.validateService.isValidTreatmentDetail(liForm_DiseaseDetailsVm.data.disease[count].treatmentDetails, liForm_DiseaseDetailsVm.hasDisease) && liForm_DiseaseDetailsVm.hasDisease) {
                    liForm_DiseaseDetailsVm.liFormDiseaseDetails.treatmentDetails[count] =
                        liForm_DiseaseDetailsVm.validateService.isValidTreatmentDetail(liForm_DiseaseDetailsVm.data.disease[count].treatmentDetails, liForm_DiseaseDetailsVm.hasDisease);
                    isValid = false;
                }

            }
            return isValid;
        }

        // On click of Next button
        liForm_DiseaseDetailsVm.goToNextPage = function() {
            if (validateForm()) {
                clickStreamService.clickStreamData = liForm_DiseaseDetailsVm.selectedProduct;
                var medicalHistory = lifeInsuranceBasicApplicationService.getMedicalHistoryIb(); 
        
                medicalHistory.diseases = [];

                for (var count = 0; count < liForm_DiseaseDetailsVm.diseaseCount; count++) {
                    var disease = {};
                    if (!liForm_DiseaseDetailsVm.data.disease[count].natureOfDisease) {
                        disease.natureOfDisease = "";
                    } else {
                        disease.natureOfDisease = liForm_DiseaseDetailsVm.data.disease[count].natureOfDisease;
                    }
                    if (!liForm_DiseaseDetailsVm.data.disease[count].dateOfDiagnosis) {
                        disease.dateOfDiagnosis = "";
                    } else {
                        disease.dateOfDiagnosis = liForm_DiseaseDetailsVm.data.disease[count].dateOfDiagnosis;
                    }


                    if (liForm_DiseaseDetailsVm.data.disease[count].isFullyRecovered) {
                        disease.isFullyRecovered = liForm_DiseaseDetailsVm.data.disease[count].isFullyRecovered.toString();
                    } else {
                        disease.isFullyRecovered = "false";
                    }
                    if (!liForm_DiseaseDetailsVm.data.disease[count].hospitalAddress) {
                        disease.hospitalAddress = "";
                    } else {
                        disease.hospitalAddress = liForm_DiseaseDetailsVm.data.disease[count].hospitalAddress;
                    }
                    if (liForm_DiseaseDetailsVm.data.disease[count].treatmentDetails) {
                        disease.treatmentDetails = liForm_DiseaseDetailsVm.data.disease[count].treatmentDetails;
                    } else {
                        disease.treatmentDetails = "";
                    }
                    medicalHistory.diseases.push(disease);
                }
                lifeInsuranceBasicApplicationService.setDiseaseDetails(medicalHistory.diseases, liForm_DiseaseDetailsVm.data);
                lifeInsuranceBasicApplicationService.saveApplication(LiConstant.journeyCommonId.APP_DISEASE).then(function() {
                    if (lifeInsuranceBasicApplicationService.getMedicalQuestions().additionalQues.length > 0) {
                        $state.go("menu.liForm_AdditionalDetails");
                    } else {
                        $state.go("menu.liForm_FamilyHistory");
                    }
                });
            }
        }
    }
]);
