angularApp.controller('liForm_FamilyHistoryController', [
    "$state",
    "$scope",
    "lifeInsuranceBasicApplicationService",
    "validateService",
    "lifeInsuranceCommonService",
    "suggestedPlansDetailsService",
    "LiConstant",
    "$ionicScrollDelegate",
    "clickStreamService",
    function(
        $state,
        $scope,
        lifeInsuranceBasicApplicationService,
        validateService,
        lifeInsuranceCommonService,
        suggestedPlansDetailsService,
        LiConstant,
        $ionicScrollDelegate,clickStreamService) {

        var liForm_FamilyHistoryVm = this;
        liForm_FamilyHistoryVm.validateService = validateService;
        liForm_FamilyHistoryVm.showBack = true;
        liForm_FamilyHistoryVm.showNext = true;
        liForm_FamilyHistoryVm.disableBack = false;
        liForm_FamilyHistoryVm.disableNext = false;

        liForm_FamilyHistoryVm.data = {};
        liForm_FamilyHistoryVm.data.father = {};
        liForm_FamilyHistoryVm.data.mother = {};
        liForm_FamilyHistoryVm.data.spouse = {};
        liForm_FamilyHistoryVm.formValidate = {};
        liForm_FamilyHistoryVm.formValidate.fatherDetails = {};
        liForm_FamilyHistoryVm.formValidate.spouseDetails = {};
        liForm_FamilyHistoryVm.formValidate.motherDetails = {};
        liForm_FamilyHistoryVm.formValidate.childrenDetails = {};
        liForm_FamilyHistoryVm.formValidate.childrenDetails.healthStatus = {};
        liForm_FamilyHistoryVm.formValidate.childrenDetails.age = {};
        liForm_FamilyHistoryVm.formValidate.childrenDetails.presentHealthStatus = {};
        liForm_FamilyHistoryVm.formValidate.childrenDetails.ifDeadCauseOfDeath = {};
        liForm_FamilyHistoryVm.formValidate.childrenDetails.specificNatureOfIllness = {};
        liForm_FamilyHistoryVm.formValidate.childrenDetails.relationship = {};
        liForm_FamilyHistoryVm.data.familyMembers = [];

        liForm_FamilyHistoryVm.data.memberCount = 0;

        var canAddSpouse = true;

        function initPage() {
            lifeInsuranceBasicApplicationService.getApplicationMasterList(function(response) {
                liForm_FamilyHistoryVm.HealthStatus = response.healthStatus;
                liForm_FamilyHistoryVm.PresentHealthState = response.presentHealthStatus;
                liForm_FamilyHistoryVm.CauseOfDeath = response.deathCauses;
                liForm_FamilyHistoryVm.childList = response.familyMembers;
            });

            liForm_FamilyHistoryVm.uin = suggestedPlansDetailsService.getCurrentSugestedProduct().uin;
            liForm_FamilyHistoryVm.selectedProduct = suggestedPlansDetailsService.getCurrentSugestedProduct().planName;
            if (lifeInsuranceBasicApplicationService.getFamilyHistory()) {
                liForm_FamilyHistoryVm.data = lifeInsuranceBasicApplicationService.getFamilyHistory();
                if (liForm_FamilyHistoryVm.data.spouse.healthStatus) {
                    canAddSpouse = false;
                }
                liForm_FamilyHistoryVm.data.memberCount = liForm_FamilyHistoryVm.data.familyMembers.length;
            }
        };

        liForm_FamilyHistoryVm.closeJourney = function() {
            lifeInsuranceCommonService.closePopUp().then(function(result) {
                if (result) {
                    $state.go("menu.generalInsurance");
                }
            });
        };

        $scope.addChild = function() {
            if (liForm_FamilyHistoryVm.data.memberCount < 4) {
                var child = {};
                child.healthStatus = {};
                child.age = "";
                child.presentHealthStatus = {};
                child.ifDeadCauseOfDeath = {};
                child.specificNatureOfIllness = "";
                child.relationship = "";
                liForm_FamilyHistoryVm.data.familyMembers.push(child);
            }
            liForm_FamilyHistoryVm.data.memberCount++;
            $ionicScrollDelegate.$getByHandle('mainScroll').resize();
        }


        $scope.deleteChild = function(count) {
            liForm_FamilyHistoryVm.data.familyMembers.splice(count, 1);
            liForm_FamilyHistoryVm.data.memberCount--;
            $ionicScrollDelegate.$getByHandle('mainScroll').resize();
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        liForm_FamilyHistoryVm.goBacktoPrevious = function() {
            if (lifeInsuranceBasicApplicationService.getMedicalQuestions().additionalQues.length > 0) {
                var commonQuestionLength = lifeInsuranceBasicApplicationService.getMedicalQuestions().commonQues.length;
                lifeInsuranceBasicApplicationService.setCommonQuestionLength(commonQuestionLength);
                liForm_FamilyHistoryVm.proposerGender = lifeInsuranceBasicApplicationService.getPersonalDetails1().gender.key;
                var totalLength;
                if (liForm_FamilyHistoryVm.proposerGender == 'F') {
                    var femaleQuestionLength = lifeInsuranceBasicApplicationService.getMedicalQuestions().femaleAdditionalQues.length;
                    lifeInsuranceBasicApplicationService.setFemaleQuestionLength(femaleQuestionLength);
                    totalLength = commonQuestionLength + femaleQuestionLength;
                } else {
                    totalLength = commonQuestionLength;
                };
                lifeInsuranceBasicApplicationService.setTotalLength(totalLength);
                $state.go("menu.liForm_AdditionalDetails");
            } else {
                $state.go("menu.liForm_DiseaseDetails");
            }
        }

        liForm_FamilyHistoryVm.goToNextPage = function() {
            if (validateForm()) {
                clickStreamService.clickStreamData = liForm_FamilyHistoryVm.selectedProduct;
                var familyMedicalDetails = {};
                familyMedicalDetails.father = {};
                familyMedicalDetails.mother = {};
                familyMedicalDetails.spouse = {};
                familyMedicalDetails.familyMembers = [];

                familyMedicalDetails.father.healthStatus = liForm_FamilyHistoryVm.data.father.healthStatus;
                familyMedicalDetails.father.age = liForm_FamilyHistoryVm.data.father.age;
                familyMedicalDetails.father.presentHealthStatus = liForm_FamilyHistoryVm.data.father.presentHealthStatus;
                familyMedicalDetails.father.ifDeadCauseOfDeath = liForm_FamilyHistoryVm.data.father.ifDeadCauseOfDeath;
                if (liForm_FamilyHistoryVm.data.father.specificNatureOfIllness) {
                    familyMedicalDetails.father.specificNatureOfIllness = liForm_FamilyHistoryVm.data.father.specificNatureOfIllness;
                } else {
                    familyMedicalDetails.father.specificNatureOfIllness = "";
                    liForm_FamilyHistoryVm.data.father.specificNatureOfIllness = "";
                }

                familyMedicalDetails.mother.healthStatus = liForm_FamilyHistoryVm.data.mother.healthStatus;
                familyMedicalDetails.mother.age = liForm_FamilyHistoryVm.data.mother.age;
                familyMedicalDetails.mother.presentHealthStatus = liForm_FamilyHistoryVm.data.mother.presentHealthStatus;
                familyMedicalDetails.mother.ifDeadCauseOfDeath = liForm_FamilyHistoryVm.data.mother.ifDeadCauseOfDeath;
                if (liForm_FamilyHistoryVm.data.mother.specificNatureOfIllness) {
                    familyMedicalDetails.mother.specificNatureOfIllness = liForm_FamilyHistoryVm.data.mother.specificNatureOfIllness;
                } else {
                    liForm_FamilyHistoryVm.data.mother.specificNatureOfIllness = "";
                    familyMedicalDetails.mother.specificNatureOfIllness = "";
                }

                if (angular.equals({}, liForm_FamilyHistoryVm.data.spouse)) {
                    familyMedicalDetails.spouse = {};
                    liForm_FamilyHistoryVm.data.spouse = {};
                } else {
                    familyMedicalDetails.spouse.healthStatus = liForm_FamilyHistoryVm.data.spouse.healthStatus;
                    familyMedicalDetails.spouse.age = liForm_FamilyHistoryVm.data.spouse.age;
                    familyMedicalDetails.spouse.presentHealthStatus = liForm_FamilyHistoryVm.data.spouse.presentHealthStatus;
                    familyMedicalDetails.spouse.ifDeadCauseOfDeath = liForm_FamilyHistoryVm.data.spouse.ifDeadCauseOfDeath;
                    if (liForm_FamilyHistoryVm.data.spouse.specificNatureOfIllness) {
                        familyMedicalDetails.spouse.specificNatureOfIllness = liForm_FamilyHistoryVm.data.spouse.specificNatureOfIllness;
                    } else {
                        liForm_FamilyHistoryVm.data.spouse.specificNatureOfIllness = "";
                        familyMedicalDetails.spouse.specificNatureOfIllness = "";
                    }
                }

                if (liForm_FamilyHistoryVm.data.memberCount == 0) {
                    familyMedicalDetails.familyMembers = [];
                } else {
                    for (var count = 0; count < liForm_FamilyHistoryVm.data.memberCount; count++) {
                        var child = {};
                        child.healthStatus = liForm_FamilyHistoryVm.data.familyMembers[count].healthStatus;
                        child.age = liForm_FamilyHistoryVm.data.familyMembers[count].age;
                        child.presentHealthStatus = liForm_FamilyHistoryVm.data.familyMembers[count].presentHealthStatus;
                        child.ifDeadCauseOfDeath = liForm_FamilyHistoryVm.data.familyMembers[count].ifDeadCauseOfDeath;
                        if (liForm_FamilyHistoryVm.data.familyMembers[count].specificNatureOfIllness) {
                            child.specificNatureOfIllness = liForm_FamilyHistoryVm.data.familyMembers[count].specificNatureOfIllness;
                        } else {
                            liForm_FamilyHistoryVm.data.familyMembers[count].specificNatureOfIllness = "";
                            child.specificNatureOfIllness = "";
                        }
                        child.relationship = liForm_FamilyHistoryVm.data.familyMembers[count].relationship;
                        familyMedicalDetails.familyMembers.push(child);
                    }
                }

                lifeInsuranceBasicApplicationService.setFamilyHistory(familyMedicalDetails, liForm_FamilyHistoryVm.data);
                lifeInsuranceBasicApplicationService.saveApplication(LiConstant.journeyCommonId.APP_FAMILY_HISTORY).then(function() {
                    $state.go("menu.liForm_eInsurance");
                });
            }
        }

        $scope.isSpouseShown = function() {
            if (canAddSpouse == true) {
                return true;
            } else {
                return false;
            }
        }

        $scope.resize = function() {

        }

        $scope.toggleSpouse = function() {
            if (canAddSpouse) {
                canAddSpouse = false;
            } else {
                canAddSpouse = true;
                liForm_FamilyHistoryVm.data.spouse = {};
            }
            $ionicScrollDelegate.$getByHandle('mainScroll').resize();
        }

        liForm_FamilyHistoryVm.onPresentHealthStateChanged = function(healthState) {
            /* Switch Case to show Error on health change drop down */
            switch (healthState) {
                case 'mother':
                    if (liForm_FamilyHistoryVm.data.mother.presentHealthStatus.key != liForm_FamilyHistoryVm.PresentHealthState[0].key) {
                        liForm_FamilyHistoryVm.formValidate.motherDetails.specificNatureOfIllness = liForm_FamilyHistoryVm.validateService.isValidNatureofIll(liForm_FamilyHistoryVm.data.mother.specificNatureOfIllness);
                    } else {
                        liForm_FamilyHistoryVm.formValidate.motherDetails.specificNatureOfIllness = "";
                    }
                    break;
                case 'father':
                    if (liForm_FamilyHistoryVm.data.father.presentHealthStatus.key != liForm_FamilyHistoryVm.PresentHealthState[0].key) {
                        liForm_FamilyHistoryVm.formValidate.fatherDetails.specificNatureOfIllness = liForm_FamilyHistoryVm.validateService.isValidNatureofIll(liForm_FamilyHistoryVm.data.father.specificNatureOfIllness);
                    } else {
                        liForm_FamilyHistoryVm.formValidate.fatherDetails.specificNatureOfIllness = "";
                    }
                    break;
                case 'spouse':
                    if (liForm_FamilyHistoryVm.data.spouse.presentHealthStatus.key != liForm_FamilyHistoryVm.PresentHealthState[0].key) {
                        liForm_FamilyHistoryVm.formValidate.spouseDetails.specificNatureOfIllness = liForm_FamilyHistoryVm.validateService.isValidNatureofIll(liForm_FamilyHistoryVm.data.spouse.specificNatureOfIllness);
                    } else {
                        liForm_FamilyHistoryVm.formValidate.spouseDetails.specificNatureOfIllness = "";
                    }
                    break;
                case 'child':
                    for (var count = 0; count < liForm_FamilyHistoryVm.data.memberCount; count++) {
                        if (liForm_FamilyHistoryVm.data.familyMembers[count].presentHealthStatus.key != liForm_FamilyHistoryVm.PresentHealthState[0].key) {
                            liForm_FamilyHistoryVm.formValidate.childrenDetails.specificNatureOfIllness[count] = liForm_FamilyHistoryVm.validateService.isValidNatureofIll(liForm_FamilyHistoryVm.data.familyMembers[count].specificNatureOfIllness);
                        } else {
                            liForm_FamilyHistoryVm.formValidate.childrenDetails.specificNatureOfIllness[count] = "";
                        }
                    }
                    break;
                default: break;

            }
        }

        liForm_FamilyHistoryVm.onDeathCauseChanged = function(deathCause) {
            /* Switch Case to show Error on death cause drop down */
            switch (deathCause) {
                case 'father':
                    if (liForm_FamilyHistoryVm.data.father.ifDeadCauseOfDeath.key != liForm_FamilyHistoryVm.CauseOfDeath[0].key) {
                        liForm_FamilyHistoryVm.formValidate.fatherDetails.specificNatureOfIllness = liForm_FamilyHistoryVm.validateService.isValidNatureofIll(liForm_FamilyHistoryVm.data.father.specificNatureOfIllness);
                    } else {
                        liForm_FamilyHistoryVm.formValidate.fatherDetails.specificNatureOfIllness = "";
                    }
                    break;
                case 'mother':
                    if (liForm_FamilyHistoryVm.data.mother.ifDeadCauseOfDeath.key != liForm_FamilyHistoryVm.CauseOfDeath[0].key) {
                        liForm_FamilyHistoryVm.formValidate.motherDetails.specificNatureOfIllness = liForm_FamilyHistoryVm.validateService.isValidNatureofIll(liForm_FamilyHistoryVm.data.mother.specificNatureOfIllness);
                    } else {
                        liForm_FamilyHistoryVm.formValidate.motherDetails.specificNatureOfIllness = "";
                    }
                    break;
                case 'spouse':
                    if (liForm_FamilyHistoryVm.data.spouse.ifDeadCauseOfDeath.key != liForm_FamilyHistoryVm.CauseOfDeath[0].key) {
                        liForm_FamilyHistoryVm.formValidate.spouseDetails.specificNatureOfIllness = liForm_FamilyHistoryVm.validateService.isValidNatureofIll(liForm_FamilyHistoryVm.data.spouse.specificNatureOfIllness);
                    } else {
                        liForm_FamilyHistoryVm.formValidate.spouseDetails.specificNatureOfIllness = "";
                    }
                    break;
                case 'child':
                    for (var count = 0; count < liForm_FamilyHistoryVm.data.memberCount; count++) {
                        if (liForm_FamilyHistoryVm.data.familyMembers[count].ifDeadCauseOfDeath.key != liForm_FamilyHistoryVm.CauseOfDeath[0].key) {
                            liForm_FamilyHistoryVm.formValidate.childrenDetails.specificNatureOfIllness[count] = liForm_FamilyHistoryVm.validateService.isValidNatureofIll(liForm_FamilyHistoryVm.data.familyMembers[count].specificNatureOfIllness);
                        } else {
                            liForm_FamilyHistoryVm.formValidate.childrenDetails.specificNatureOfIllness[count] = "";
                        }
                    }
                    break;

            }

        }

        liForm_FamilyHistoryVm.onFatherStatusChanged = function() {

            if (liForm_FamilyHistoryVm.data.father.healthStatus.key != (liForm_FamilyHistoryVm.HealthStatus[0].key)) {
                liForm_FamilyHistoryVm.data.father.presentHealthStatus = {};
                liForm_FamilyHistoryVm.formValidate.fatherDetails.ifDeadCauseOfDeath = liForm_FamilyHistoryVm.validateService.isValidifDeadCauseOfDeath(liForm_FamilyHistoryVm.data.father.ifDeadCauseOfDeath);
            } else if (liForm_FamilyHistoryVm.data.father.healthStatus.key != (liForm_FamilyHistoryVm.HealthStatus[1].key)) {
                liForm_FamilyHistoryVm.data.father.ifDeadCauseOfDeath = {};
                liForm_FamilyHistoryVm.formValidate.fatherDetails.presentHealthStatus = liForm_FamilyHistoryVm.validateService.isValidPresentHealthState(liForm_FamilyHistoryVm.data.father.presentHealthStatus);

            }

        }

        liForm_FamilyHistoryVm.onMotherStatusChanged = function() {
            if (liForm_FamilyHistoryVm.data.mother.healthStatus.key != (liForm_FamilyHistoryVm.HealthStatus[0].key)) {
                liForm_FamilyHistoryVm.data.mother.presentHealthStatus = {};
                liForm_FamilyHistoryVm.formValidate.motherDetails.ifDeadCauseOfDeath = liForm_FamilyHistoryVm.validateService.isValidifDeadCauseOfDeath(liForm_FamilyHistoryVm.data.mother.ifDeadCauseOfDeath);
            } else if (liForm_FamilyHistoryVm.data.mother.healthStatus.key != (liForm_FamilyHistoryVm.HealthStatus[1].key)) {
                liForm_FamilyHistoryVm.data.mother.ifDeadCauseOfDeath = {};
                liForm_FamilyHistoryVm.formValidate.motherDetails.presentHealthStatus = liForm_FamilyHistoryVm.validateService.isValidPresentHealthState(liForm_FamilyHistoryVm.data.mother.presentHealthStatus);
            }
        }

        liForm_FamilyHistoryVm.onSpouseStatusChanged = function() {
            if (liForm_FamilyHistoryVm.data.spouse.healthStatus.key != (liForm_FamilyHistoryVm.HealthStatus[0].key)) {
                liForm_FamilyHistoryVm.data.spouse.presentHealthStatus = {};
                liForm_FamilyHistoryVm.formValidate.spouseDetails.ifDeadCauseOfDeath = liForm_FamilyHistoryVm.validateService.isValidifDeadCauseOfDeath(liForm_FamilyHistoryVm.data.spouse.ifDeadCauseOfDeath);
            } else if (liForm_FamilyHistoryVm.data.spouse.healthStatus.key != (liForm_FamilyHistoryVm.HealthStatus[1].key)) {
                liForm_FamilyHistoryVm.data.spouse.ifDeadCauseOfDeath = {};
                liForm_FamilyHistoryVm.formValidate.spouseDetails.presentHealthStatus = liForm_FamilyHistoryVm.validateService.isValidPresentHealthState(liForm_FamilyHistoryVm.data.spouse.presentHealthStatus);
            }
        }

        liForm_FamilyHistoryVm.onChildrenStatusChanged = function(index) {
            if (liForm_FamilyHistoryVm.data.familyMembers[index].healthStatus.key != (liForm_FamilyHistoryVm.HealthStatus[0].key)) {
                liForm_FamilyHistoryVm.data.familyMembers[index].presentHealthStatus = {};
                for (var count = 0; count < liForm_FamilyHistoryVm.data.memberCount; count++) {
                    liForm_FamilyHistoryVm.formValidate.childrenDetails.ifDeadCauseOfDeath[count] = liForm_FamilyHistoryVm.validateService.isValidifDeadCauseOfDeath(liForm_FamilyHistoryVm.data.familyMembers[count].ifDeadCauseOfDeath);
                }

            } else if (liForm_FamilyHistoryVm.data.familyMembers[index].healthStatus.key != (liForm_FamilyHistoryVm.HealthStatus[1].key)) {
                liForm_FamilyHistoryVm.data.familyMembers[index].ifDeadCauseOfDeath = {};
                for (var count = 0; count < liForm_FamilyHistoryVm.data.memberCount; count++) {
                    liForm_FamilyHistoryVm.formValidate.childrenDetails.presentHealthStatus[count] = liForm_FamilyHistoryVm.validateService.isValidPresentHealthState(liForm_FamilyHistoryVm.data.familyMembers[count].presentHealthStatus);
                }
            }
        }

        function validateForm() {

            var isValid = true;

            //Father details
            if (liForm_FamilyHistoryVm.validateService.isValidhealthStatus(liForm_FamilyHistoryVm.data.father.healthStatus)) {
                liForm_FamilyHistoryVm.formValidate.fatherDetails.healthStatus = liForm_FamilyHistoryVm.validateService.isValidhealthStatus(liForm_FamilyHistoryVm.data.father.healthStatus);
                isValid = false;
            }
            

            if (JSON.stringify(liForm_FamilyHistoryVm.data.father.healthStatus) === JSON.stringify(liForm_FamilyHistoryVm.HealthStatus[0])) {
                if (liForm_FamilyHistoryVm.validateService.isValidAge(liForm_FamilyHistoryVm.data.father.age)) {
                liForm_FamilyHistoryVm.formValidate.fatherDetails.age = liForm_FamilyHistoryVm.validateService.isValidAge(liForm_FamilyHistoryVm.data.father.age);
                isValid = false;
                }
                if (liForm_FamilyHistoryVm.validateService.isValidPresentHealthState(liForm_FamilyHistoryVm.data.father.presentHealthStatus)) {
                    liForm_FamilyHistoryVm.formValidate.fatherDetails.presentHealthStatus = liForm_FamilyHistoryVm.validateService.isValidPresentHealthState(liForm_FamilyHistoryVm.data.father.presentHealthStatus);
                    isValid = false;
                }
                if (JSON.stringify(liForm_FamilyHistoryVm.data.father.presentHealthStatus) == JSON.stringify(liForm_FamilyHistoryVm.PresentHealthState[1]) || JSON.stringify(liForm_FamilyHistoryVm.data.father.presentHealthStatus) == JSON.stringify(liForm_FamilyHistoryVm.PresentHealthState[2])) {
                    if (liForm_FamilyHistoryVm.validateService.isValidNatureofIll(liForm_FamilyHistoryVm.data.father.specificNatureOfIllness)) {
                        liForm_FamilyHistoryVm.formValidate.fatherDetails.specificNatureOfIllness = liForm_FamilyHistoryVm.validateService.isValidNatureofIll(liForm_FamilyHistoryVm.data.father.specificNatureOfIllness);
                        isValid = false;
                    }
                }
            } else if (JSON.stringify(liForm_FamilyHistoryVm.data.father.healthStatus) === JSON.stringify(liForm_FamilyHistoryVm.HealthStatus[1])) {
                //To check for age if dead
                if (liForm_FamilyHistoryVm.validateService.isValidDeathAge(liForm_FamilyHistoryVm.data.father.age)) {
                liForm_FamilyHistoryVm.formValidate.fatherDetails.age = liForm_FamilyHistoryVm.validateService.isValidDeathAge(liForm_FamilyHistoryVm.data.father.age);
                isValid = false;
                }
                if (liForm_FamilyHistoryVm.validateService.isValidifDeadCauseOfDeath(liForm_FamilyHistoryVm.data.father.ifDeadCauseOfDeath)) {
                    liForm_FamilyHistoryVm.formValidate.fatherDetails.ifDeadCauseOfDeath = liForm_FamilyHistoryVm.validateService.isValidifDeadCauseOfDeath(liForm_FamilyHistoryVm.data.father.ifDeadCauseOfDeath);
                    isValid = false;
                }
                if (JSON.stringify(liForm_FamilyHistoryVm.data.father.ifDeadCauseOfDeath) == JSON.stringify(liForm_FamilyHistoryVm.CauseOfDeath[1]) || JSON.stringify(liForm_FamilyHistoryVm.data.father.ifDeadCauseOfDeath) == JSON.stringify(liForm_FamilyHistoryVm.CauseOfDeath[2]) || JSON.stringify(liForm_FamilyHistoryVm.data.father.ifDeadCauseOfDeath) == JSON.stringify(liForm_FamilyHistoryVm.CauseOfDeath[3])) {
                    if (liForm_FamilyHistoryVm.validateService.isValidNatureofIll(liForm_FamilyHistoryVm.data.father.specificNatureOfIllness)) {
                        liForm_FamilyHistoryVm.formValidate.fatherDetails.specificNatureOfIllness = liForm_FamilyHistoryVm.validateService.isValidNatureofIll(liForm_FamilyHistoryVm.data.father.specificNatureOfIllness);
                        isValid = false;
                    }
                }
            }


            //motherDetails
            if (liForm_FamilyHistoryVm.validateService.isValidhealthStatus(liForm_FamilyHistoryVm.data.mother.healthStatus)) {
                liForm_FamilyHistoryVm.formValidate.motherDetails.healthStatus = liForm_FamilyHistoryVm.validateService.isValidhealthStatus(liForm_FamilyHistoryVm.data.mother.healthStatus);
                isValid = false;
            }

            if (JSON.stringify(liForm_FamilyHistoryVm.data.mother.healthStatus) === JSON.stringify(liForm_FamilyHistoryVm.HealthStatus[0])) {
               //check for valid age
               if (liForm_FamilyHistoryVm.validateService.isValidAge(liForm_FamilyHistoryVm.data.mother.age)) {
                 liForm_FamilyHistoryVm.formValidate.motherDetails.age = liForm_FamilyHistoryVm.validateService.isValidAge(liForm_FamilyHistoryVm.data.mother.age);
                 isValid = false;
                }
                if (liForm_FamilyHistoryVm.validateService.isValidPresentHealthState(liForm_FamilyHistoryVm.data.mother.presentHealthStatus)) {
                    liForm_FamilyHistoryVm.formValidate.motherDetails.presentHealthStatus = liForm_FamilyHistoryVm.validateService.isValidPresentHealthState(liForm_FamilyHistoryVm.data.mother.presentHealthStatus);
                    isValid = false;
                }
                if (JSON.stringify(liForm_FamilyHistoryVm.data.mother.presentHealthStatus) == JSON.stringify(liForm_FamilyHistoryVm.PresentHealthState[1]) || JSON.stringify(liForm_FamilyHistoryVm.data.mother.presentHealthStatus) == JSON.stringify(liForm_FamilyHistoryVm.PresentHealthState[2])) {
                    if (liForm_FamilyHistoryVm.validateService.isValidNatureofIll(liForm_FamilyHistoryVm.data.mother.specificNatureOfIllness)) {
                        liForm_FamilyHistoryVm.formValidate.motherDetails.specificNatureOfIllness = liForm_FamilyHistoryVm.validateService.isValidNatureofIll(liForm_FamilyHistoryVm.data.father.specificNatureOfIllness);
                        isValid = false;
                    }
                }
            } else if (JSON.stringify(liForm_FamilyHistoryVm.data.mother.healthStatus) === JSON.stringify(liForm_FamilyHistoryVm.HealthStatus[1])) {
               //check for valid age at death
               if (liForm_FamilyHistoryVm.validateService.isValidDeathAge(liForm_FamilyHistoryVm.data.mother.age)) {
                 liForm_FamilyHistoryVm.formValidate.motherDetails.age = liForm_FamilyHistoryVm.validateService.isValidDeathAge(liForm_FamilyHistoryVm.data.mother.age);
                 isValid = false;
                }
                if (liForm_FamilyHistoryVm.validateService.isValidifDeadCauseOfDeath(liForm_FamilyHistoryVm.data.mother.ifDeadCauseOfDeath)) {
                    liForm_FamilyHistoryVm.formValidate.motherDetails.ifDeadCauseOfDeath = liForm_FamilyHistoryVm.validateService.isValidifDeadCauseOfDeath(liForm_FamilyHistoryVm.data.mother.ifDeadCauseOfDeath);
                    isValid = false;
                }
                if (JSON.stringify(liForm_FamilyHistoryVm.data.mother.ifDeadCauseOfDeath) == JSON.stringify(liForm_FamilyHistoryVm.CauseOfDeath[1]) || JSON.stringify(liForm_FamilyHistoryVm.data.mother.ifDeadCauseOfDeath) == JSON.stringify(liForm_FamilyHistoryVm.CauseOfDeath[2]) || JSON.stringify(liForm_FamilyHistoryVm.data.mother.ifDeadCauseOfDeath) == JSON.stringify(liForm_FamilyHistoryVm.CauseOfDeath[3])) {
                    if (liForm_FamilyHistoryVm.validateService.isValidNatureofIll(liForm_FamilyHistoryVm.data.mother.specificNatureOfIllness)) {
                        liForm_FamilyHistoryVm.formValidate.motherDetails.specificNatureOfIllness = liForm_FamilyHistoryVm.validateService.isValidNatureofIll(liForm_FamilyHistoryVm.data.mother.specificNatureOfIllness);
                        isValid = false;
                    }
                }
            }

            //spouseDetails
            if (!canAddSpouse) {
                if (liForm_FamilyHistoryVm.validateService.isValidhealthStatus(liForm_FamilyHistoryVm.data.spouse.healthStatus)) {
                    liForm_FamilyHistoryVm.formValidate.spouseDetails.healthStatus = liForm_FamilyHistoryVm.validateService.isValidhealthStatus(liForm_FamilyHistoryVm.data.spouse.healthStatus);
                    isValid = false;
                }
                
                if (JSON.stringify(liForm_FamilyHistoryVm.data.spouse.healthStatus) === JSON.stringify(liForm_FamilyHistoryVm.HealthStatus[0])) {
                    if (liForm_FamilyHistoryVm.validateService.isValidAge(liForm_FamilyHistoryVm.data.spouse.age)) {
                     liForm_FamilyHistoryVm.formValidate.spouseDetails.age = liForm_FamilyHistoryVm.validateService.isValidAge(liForm_FamilyHistoryVm.data.spouse.age);
                     isValid = false;
                    }
                    if (liForm_FamilyHistoryVm.validateService.isValidPresentHealthState(liForm_FamilyHistoryVm.data.spouse.presentHealthStatus)) {
                        liForm_FamilyHistoryVm.formValidate.spouseDetails.presentHealthStatus = liForm_FamilyHistoryVm.validateService.isValidPresentHealthState(liForm_FamilyHistoryVm.data.spouse.presentHealthStatus);
                        isValid = false;
                    }
                    if (JSON.stringify(liForm_FamilyHistoryVm.data.spouse.presentHealthStatus) == JSON.stringify(liForm_FamilyHistoryVm.PresentHealthState[1]) || JSON.stringify(liForm_FamilyHistoryVm.data.spouse.presentHealthStatus) == JSON.stringify(liForm_FamilyHistoryVm.PresentHealthState[2])) {
                        if (liForm_FamilyHistoryVm.validateService.isValidNatureofIll(liForm_FamilyHistoryVm.data.spouse.specificNatureOfIllness)) {
                            liForm_FamilyHistoryVm.formValidate.spouseDetails.specificNatureOfIllness = liForm_FamilyHistoryVm.validateService.isValidNatureofIll(liForm_FamilyHistoryVm.data.spouse.specificNatureOfIllness);
                            isValid = false;
                        }
                    }
                } else if (JSON.stringify(liForm_FamilyHistoryVm.data.spouse.healthStatus) === JSON.stringify(liForm_FamilyHistoryVm.HealthStatus[1])) {

                    if (liForm_FamilyHistoryVm.validateService.isValidDeathAge(liForm_FamilyHistoryVm.data.spouse.age)) {
                     liForm_FamilyHistoryVm.formValidate.spouseDetails.age = liForm_FamilyHistoryVm.validateService.isValidDeathAge(liForm_FamilyHistoryVm.data.spouse.age);
                     isValid = false;
                    }
                    if (liForm_FamilyHistoryVm.validateService.isValidifDeadCauseOfDeath(liForm_FamilyHistoryVm.data.spouse.ifDeadCauseOfDeath)) {
                        liForm_FamilyHistoryVm.formValidate.spouseDetails.ifDeadCauseOfDeath = liForm_FamilyHistoryVm.validateService.isValidifDeadCauseOfDeath(liForm_FamilyHistoryVm.data.spouse.ifDeadCauseOfDeath);
                        isValid = false;
                    }
                    if (JSON.stringify(liForm_FamilyHistoryVm.data.spouse.ifDeadCauseOfDeath) == JSON.stringify(liForm_FamilyHistoryVm.CauseOfDeath[1]) || JSON.stringify(liForm_FamilyHistoryVm.data.spouse.ifDeadCauseOfDeath) == JSON.stringify(liForm_FamilyHistoryVm.CauseOfDeath[2]) || JSON.stringify(liForm_FamilyHistoryVm.data.spouse.ifDeadCauseOfDeath) == JSON.stringify(liForm_FamilyHistoryVm.CauseOfDeath[3])) {
                        if (liForm_FamilyHistoryVm.validateService.isValidNatureofIll(liForm_FamilyHistoryVm.data.spouse.specificNatureOfIllness)) {
                            liForm_FamilyHistoryVm.formValidate.spouseDetails.specificNatureOfIllness = liForm_FamilyHistoryVm.validateService.isValidNatureofIll(liForm_FamilyHistoryVm.data.spouse.specificNatureOfIllness);
                            isValid = false;
                        }
                    }
                }
            }

            //children validation
            for (var count = 0; count < liForm_FamilyHistoryVm.data.memberCount; count++) {
                if (liForm_FamilyHistoryVm.validateService.isValidhealthStatus(liForm_FamilyHistoryVm.data.familyMembers[count].healthStatus.key)) {
                    liForm_FamilyHistoryVm.formValidate.childrenDetails.healthStatus[count] = liForm_FamilyHistoryVm.validateService.isValidhealthStatus(liForm_FamilyHistoryVm.data.familyMembers[count].healthStatus.key);
                    isValid = false;
                }
                
                if (JSON.stringify(liForm_FamilyHistoryVm.data.familyMembers[count].healthStatus) === JSON.stringify(liForm_FamilyHistoryVm.HealthStatus[0])) {
                    if (liForm_FamilyHistoryVm.validateService.isValidAge(liForm_FamilyHistoryVm.data.familyMembers[count].age)) {
                     liForm_FamilyHistoryVm.formValidate.childrenDetails.age[count] = liForm_FamilyHistoryVm.validateService.isValidAge(liForm_FamilyHistoryVm.data.familyMembers[count].age);
                     isValid = false;
                    }
                    if (liForm_FamilyHistoryVm.validateService.isValidPresentHealthState(liForm_FamilyHistoryVm.data.familyMembers[count].presentHealthStatus)) {
                        liForm_FamilyHistoryVm.formValidate.childrenDetails.presentHealthStatus[count] = liForm_FamilyHistoryVm.validateService.isValidPresentHealthState(liForm_FamilyHistoryVm.data.familyMembers[count].presentHealthStatus);
                        isValid = false;
                    }
                    if (JSON.stringify(liForm_FamilyHistoryVm.data.familyMembers[count].presentHealthStatus) == JSON.stringify(liForm_FamilyHistoryVm.PresentHealthState[1]) || JSON.stringify(liForm_FamilyHistoryVm.data.familyMembers[count].presentHealthStatus) == JSON.stringify(liForm_FamilyHistoryVm.PresentHealthState[2])) {
                        if (liForm_FamilyHistoryVm.validateService.isValidNatureofIll(liForm_FamilyHistoryVm.data.familyMembers[count].specificNatureOfIllness)) {
                            liForm_FamilyHistoryVm.formValidate.childrenDetails.specificNatureOfIllness[count] = liForm_FamilyHistoryVm.validateService.isValidNatureofIll(liForm_FamilyHistoryVm.data.familyMembers[count].specificNatureOfIllness);
                            isValid = false;
                        }
                    }
                } else if (JSON.stringify(liForm_FamilyHistoryVm.data.familyMembers[count].healthStatus) === JSON.stringify(liForm_FamilyHistoryVm.HealthStatus[1])) {
                    if (liForm_FamilyHistoryVm.validateService.isValidDeathAge(liForm_FamilyHistoryVm.data.familyMembers[count].age)) {
                     liForm_FamilyHistoryVm.formValidate.childrenDetails.age[count] = liForm_FamilyHistoryVm.validateService.isValidDeathAge(liForm_FamilyHistoryVm.data.familyMembers[count].age);
                     isValid = false;
                    }
                    if (liForm_FamilyHistoryVm.validateService.isValidifDeadCauseOfDeath(liForm_FamilyHistoryVm.data.familyMembers[count].ifDeadCauseOfDeath)) {
                        liForm_FamilyHistoryVm.formValidate.childrenDetails.ifDeadCauseOfDeath[count] = liForm_FamilyHistoryVm.validateService.isValidifDeadCauseOfDeath(liForm_FamilyHistoryVm.data.familyMembers[count].ifDeadCauseOfDeath);
                        isValid = false;
                    }
                    if (JSON.stringify(liForm_FamilyHistoryVm.data.familyMembers[count].ifDeadCauseOfDeath) == JSON.stringify(liForm_FamilyHistoryVm.CauseOfDeath[1]) || JSON.stringify(liForm_FamilyHistoryVm.data.familyMembers[count].ifDeadCauseOfDeath) == JSON.stringify(liForm_FamilyHistoryVm.CauseOfDeath[1]) || JSON.stringify(liForm_FamilyHistoryVm.data.familyMembers[count].ifDeadCauseOfDeath) == JSON.stringify(liForm_FamilyHistoryVm.CauseOfDeath[2])) {
                        if (liForm_FamilyHistoryVm.validateService.isValidNatureofIll(liForm_FamilyHistoryVm.data.familyMembers[count].specificNatureOfIllness)) {
                            liForm_FamilyHistoryVm.formValidate.childrenDetails.specificNatureOfIllness[count] = liForm_FamilyHistoryVm.validateService.isValidNatureofIll(liForm_FamilyHistoryVm.data.familyMembers[count].specificNatureOfIllness);
                            isValid = false;
                        }
                    }
                }

                if (liForm_FamilyHistoryVm.validateService.isValidRelationship(liForm_FamilyHistoryVm.data.familyMembers[count].relationship)) {
                    liForm_FamilyHistoryVm.formValidate.childrenDetails.relationship[count] = liForm_FamilyHistoryVm.validateService.isValidRelationship(liForm_FamilyHistoryVm.data.familyMembers[count].relationship);
                    isValid = false;
                }

            }
            return isValid;
        }

        return this;
    }
]);
