(function() {

    'use strict';

    angularApp.controller('liForm_MailingInfoController', [
        "$state",
        "$scope",
        "validateService",
        "lifeInsuranceBasicApplicationService",
        "premiumCalculationService",
        "lifeInsuranceCommonService",
        "suggestedPlansDetailsService",
        "LiConstant","lifeInsuranceApplicationService",
        "clickStreamService",

        function(
            $state,
            $scope,
            validateService,
            lifeInsuranceBasicApplicationService,
            premiumCalculationService,
            lifeInsuranceCommonService,
            suggestedPlansDetailsService,
            LiConstant,lifeInsuranceApplicationService,clickStreamService) {

            var liForm_MailingInfoVm = this;
            liForm_MailingInfoVm.stateData = "";
            liForm_MailingInfoVm.data = {};
            liForm_MailingInfoVm.data.permanent = {};
            liForm_MailingInfoVm.data.current = {};


            function initPage() {
                liForm_MailingInfoVm.showBack = true;
                liForm_MailingInfoVm.showNext = true;
                liForm_MailingInfoVm.disableBack = false;
                liForm_MailingInfoVm.disableNext = false;
                var data = lifeInsuranceApplicationService.getAccoutDetails();
                if(data){
                    liForm_MailingInfoVm.data.permanent.address1 = data.cbsData.addressLine1;
                    liForm_MailingInfoVm.data.permanent.address2 = data.cbsData.addressLine2;
                    liForm_MailingInfoVm.data.permanent.address3 = data.cbsData.addressLine3;
                }
                loadMasterData();

                liForm_MailingInfoVm.uin = suggestedPlansDetailsService.getCurrentSugestedProduct().uin;
                liForm_MailingInfoVm.selectedProduct = suggestedPlansDetailsService.getCurrentSugestedProduct().planName;
                if (lifeInsuranceBasicApplicationService.getMailingInformation1()) {
                    liForm_MailingInfoVm.data = lifeInsuranceBasicApplicationService.getMailingInformation1();
                    if (liForm_MailingInfoVm.data.isCurrentSameAsPermenent == 'true' || liForm_MailingInfoVm.data.isCurrentSameAsPermenent == true) {
                        liForm_MailingInfoVm.data.isCurrentSameAsPermenent = true;
                    } else {
                        liForm_MailingInfoVm.data.isCurrentSameAsPermenent = false;
                    }
                    var reqObj1 = {
                        "stID": liForm_MailingInfoVm.data.permanent.state.key
                    };
                    var reqObj2 = {
                        "stID": liForm_MailingInfoVm.data.current.state.key
                    };
                    lifeInsuranceBasicApplicationService.getCityList(reqObj1).then(function(data) {
                        liForm_MailingInfoVm.cities = data.cities;
                        lifeInsuranceBasicApplicationService.getCityList(reqObj2).then(function(data) {
                            liForm_MailingInfoVm.cities1 = data.cities;
                        }, function(error) {});
                    }, function(error) {});
                }
            }

            $scope.$on('$ionicView.beforeEnter', function() {
                initPage();
            });


            liForm_MailingInfoVm.closeJourney = function() {
                lifeInsuranceCommonService.closePopUp().then(function(result) {
                    if (result) {
                        $state.go("menu.generalInsurance");
                    }
                });
            };

            function loadMasterData() {
                liForm_MailingInfoVm.isJammuKashmirResident = premiumCalculationService.getJammuKashmir();

                lifeInsuranceBasicApplicationService.getStateList().then(function(data) {
                    liForm_MailingInfoVm.stateData = data.states;

                    if (liForm_MailingInfoVm.isJammuKashmirResident) {
                        liForm_MailingInfoVm.data.permanent.state = data.states[11];
                        var state = {
                            "stID": data.states[11].key
                        };
                        lifeInsuranceBasicApplicationService.getCityList(state).then(function(data) {
                            liForm_MailingInfoVm.cities = data.cities;
                        }, function(error) {});

                    } else {
                        liForm_MailingInfoVm.states = data.states;
                        liForm_MailingInfoVm.states1 = data.states;
                    }
                }, function(error) {});
            };


            liForm_MailingInfoVm.fetchCityList = function(value) {
                if (value == 0) {
                    var state = {
                        "stID": liForm_MailingInfoVm.data.permanent.state.key
                    };
                    liForm_MailingInfoVm.data.permanent.city = null;
                    lifeInsuranceBasicApplicationService.getCityList(state).then(function(data) {
                        liForm_MailingInfoVm.cities = data.cities;
                    }, function(error) {});
                } else {
                    var state = {
                        "stID": liForm_MailingInfoVm.data.current.state.key
                    };
                    liForm_MailingInfoVm.data.current.city = null;
                    lifeInsuranceBasicApplicationService.getCityList(state).then(function(data) {
                        liForm_MailingInfoVm.cities1 = data.cities;
                    }, function(error) {});
                }
            };


            liForm_MailingInfoVm.updateCity1 = function() {
                if (liForm_MailingInfoVm.data.isCurrentSameAsPermenent) {
                    liForm_MailingInfoVm.cities1 = liForm_MailingInfoVm.cities;
                    liForm_MailingInfoVm.data.current.city = liForm_MailingInfoVm.data.permanent.city;
                }
                if (liForm_MailingInfoVm.data.isCurrentSameAsPermenent && liForm_MailingInfoVm.isJammuKashmirResident) {
                    liForm_MailingInfoVm.data.current.state = liForm_MailingInfoVm.data.permanent.state;
                } else {
                    liForm_MailingInfoVm.data.current.state = "";
                    liForm_MailingInfoVm.states1 = liForm_MailingInfoVm.stateData;
                }
                if (!liForm_MailingInfoVm.data.isCurrentSameAsPermenent) {
                    liForm_MailingInfoVm.data.current = {};
                }
            }


            //validation starts 
            liForm_MailingInfoVm.liForm_MailingInfoForm = {};
            liForm_MailingInfoVm.validateService = validateService;

            //onclick of next button
            liForm_MailingInfoVm.goToNextPage = function() {
                if (validateForm()) {
                    clickStreamService.clickStreamData = liForm_MailingInfoVm.selectedProduct;
                    var mailingInformation = {}; 
                    mailingInformation.permanent = {};
                    mailingInformation.permanent.address1 = liForm_MailingInfoVm.data.permanent.address1;
                    if (!liForm_MailingInfoVm.data.permanent.address2) {
                        mailingInformation.permanent.address2 = "";
                    } else {
                        mailingInformation.permanent.address2 = liForm_MailingInfoVm.data.permanent.address2;
                    }

                    if (!liForm_MailingInfoVm.data.permanent.address3) {
                        mailingInformation.permanent.address3 = "";
                    } else {
                        mailingInformation.permanent.address3 = liForm_MailingInfoVm.data.permanent.address3;
                    }
                    mailingInformation.permanent.city = liForm_MailingInfoVm.data.permanent.city;
                    mailingInformation.permanent.state = liForm_MailingInfoVm.data.permanent.state;
                    mailingInformation.permanent.pincode = liForm_MailingInfoVm.data.permanent.pincode;

                    mailingInformation.current = {};
                    if (liForm_MailingInfoVm.data.isCurrentSameAsPermenent) {
                        mailingInformation.isCurrentSameAsPermenent = liForm_MailingInfoVm.data.isCurrentSameAsPermenent.toString();
                    } else {
                        mailingInformation.isCurrentSameAsPermenent = "false";
                        liForm_MailingInfoVm.data.isCurrentSameAsPermenent = false;
                    }

                    mailingInformation.current.address1 = liForm_MailingInfoVm.data.current.address1;

                    if (!liForm_MailingInfoVm.data.current.address2) {
                        mailingInformation.current.address2 = "";
                    } else {
                        mailingInformation.current.address2 = liForm_MailingInfoVm.data.current.address2;
                    }

                    if (!liForm_MailingInfoVm.data.current.address3) {
                        mailingInformation.current.address3 = "";
                    } else {
                        mailingInformation.current.address3 = liForm_MailingInfoVm.data.current.address3;
                    }

                    mailingInformation.current.city = liForm_MailingInfoVm.data.current.city;
                    mailingInformation.current.state = liForm_MailingInfoVm.data.current.state;
                    mailingInformation.current.pincode = liForm_MailingInfoVm.data.current.pincode;

                    lifeInsuranceBasicApplicationService.setMailingInformation(mailingInformation);
                    lifeInsuranceBasicApplicationService.saveApplication(LiConstant.journeyCommonId.APP_MAILING_INFO).then(function() {
                        $state.go("menu.liForm_MailingInfoAadhaarScan");
                    });
                }
            }

            // On click of Back button
            liForm_MailingInfoVm.goBacktoPrevious = function() {
                $state.go("menu.lifeInsuranceBasicInformation4");
            }

            // validation function
            function validateForm() {
                liForm_MailingInfoVm.liForm_MailingInfoForm = {};

                if (liForm_MailingInfoVm.validateService.isValidAddress(liForm_MailingInfoVm.data.permanent.address1)) {
                    liForm_MailingInfoVm.liForm_MailingInfoForm.Address = liForm_MailingInfoVm.validateService.isValidAddress(liForm_MailingInfoVm.data.permanent.address1);
                }
                if (liForm_MailingInfoVm.validateService.isValidAddress(liForm_MailingInfoVm.data.current.address1)) {
                    liForm_MailingInfoVm.liForm_MailingInfoForm.Address1 = liForm_MailingInfoVm.validateService.isValidAddress(liForm_MailingInfoVm.data.current.address1);
                }
                if (liForm_MailingInfoVm.validateService.isValidCity(liForm_MailingInfoVm.data.permanent.city)) {
                    liForm_MailingInfoVm.liForm_MailingInfoForm.city = liForm_MailingInfoVm.validateService.isValidCity(liForm_MailingInfoVm.data.permanent.city);
                }
                if (liForm_MailingInfoVm.validateService.isValidCity(liForm_MailingInfoVm.data.current.city)) {
                    liForm_MailingInfoVm.liForm_MailingInfoForm.city1 = liForm_MailingInfoVm.validateService.isValidCity(liForm_MailingInfoVm.data.current.city);
                }

                if (!liForm_MailingInfoVm.isJammuKashmirResident) {
                    if (liForm_MailingInfoVm.validateService.isValidState(liForm_MailingInfoVm.data.permanent.state)) {
                        liForm_MailingInfoVm.liForm_MailingInfoForm.state = liForm_MailingInfoVm.validateService.isValidState(liForm_MailingInfoVm.data.permanent.state);
                    }
                }

                if (!(liForm_MailingInfoVm.isJammuKashmirResident && liForm_MailingInfoVm.data.isCurrentSameAsPermenent)) {
                    if (liForm_MailingInfoVm.validateService.isValidState(liForm_MailingInfoVm.data.current.state)) {
                        liForm_MailingInfoVm.liForm_MailingInfoForm.state1 = liForm_MailingInfoVm.validateService.isValidState(liForm_MailingInfoVm.data.current.state);
                    }
                }

                if (liForm_MailingInfoVm.validateService.isValidPincode(liForm_MailingInfoVm.data.permanent.pincode)) {
                    liForm_MailingInfoVm.liForm_MailingInfoForm.pincode = liForm_MailingInfoVm.validateService.isValidPincode(liForm_MailingInfoVm.data.permanent.pincode);
                }
                if (liForm_MailingInfoVm.validateService.isValidPincode(liForm_MailingInfoVm.data.current.pincode)) {
                    liForm_MailingInfoVm.liForm_MailingInfoForm.pincode1 = liForm_MailingInfoVm.validateService.isValidPincode(liForm_MailingInfoVm.data.current.pincode);
                }

                return (angular.equals({}, liForm_MailingInfoVm.liForm_MailingInfoForm)) ? true : false;
            }
        }
    ]);
})();
