angularApp.controller('liForm_MailingInfoEnterDetailsController', [
    "$state",
    "$scope",
    "lifeInsuranceBasicApplicationService",
    "lifeInsuranceApplicationService",
    "validateService",
    "$filter",
    "suggestedPlansDetailsService",
    "premiumCalculationService",
    "lifeInsuranceCommonService",
    "LiConstant","clickStreamService",


    function(
        $state,
        $scope,
        lifeInsuranceBasicApplicationService,
        lifeInsuranceApplicationService,
        validateService,
        $filter,
        suggestedPlansDetailsService,
        premiumCalculationService,
        lifeInsuranceCommonService,
        LiConstant,clickStreamService) {

        var liForm_MailingInfoEnterDetailsVm = this;
        liForm_MailingInfoEnterDetailsVm.validateService = validateService;



        liForm_MailingInfoEnterDetailsVm.update = function(dob) {
            var age = liForm_MailingInfoEnterDetailsVm.validateService.calcAge(dob);
            if (Number(age) < 18) {
                liForm_MailingInfoEnterDetailsVm.data.isNomineeMinor = true;
            } else { liForm_MailingInfoEnterDetailsVm.data.isNomineeMinor = false; }

        }

        liForm_MailingInfoEnterDetailsVm.closeJourney = function() {
            lifeInsuranceCommonService.closePopUp().then(function(result) {
                if (result) {
                    $state.go("menu.generalInsurance");
                }
            });
        };


        function initPage() {
            liForm_MailingInfoEnterDetailsVm.showBack = true;
            liForm_MailingInfoEnterDetailsVm.showNext = true;
            liForm_MailingInfoEnterDetailsVm.disableBack = false;
            liForm_MailingInfoEnterDetailsVm.disableNext = false;

            liForm_MailingInfoEnterDetailsVm.mailingInfoDetail = {};

            liForm_MailingInfoEnterDetailsVm.data = {};
            liForm_MailingInfoEnterDetailsVm.data.name = {};
            liForm_MailingInfoEnterDetailsVm.data.address = {};
            var curSug = suggestedPlansDetailsService.getCurrentSugestedProduct().productCode;
            liForm_MailingInfoEnterDetailsVm.selectedProduct = suggestedPlansDetailsService.getCurrentSugestedProduct().planName;
            liForm_MailingInfoEnterDetailsVm.product = curSug;
            var currentDate = validateService.getCurrentDate();
            if (curSug !== LiConstant.productCode.SMART_CHAMP_INSURANCE) {
                liForm_MailingInfoEnterDetailsVm.defaultDate = new Date(1980, 0, 1, 0, 0, 0, 0);
                liForm_MailingInfoEnterDetailsVm.maxEndDate = $filter('chosenDate')(validateService.getFutureDate(currentDate, 0));
                liForm_MailingInfoEnterDetailsVm.minEndDate = $filter('chosenDate')(validateService.getFutureDate(currentDate, -36500));
            } else {
                var premData = premiumCalculationService.getPremiumCalculationSC();
                var today =validateService.getCurrentDate();
                var age = premData.childage;
                var newYear = Number(today.getFullYear() - Number(age) - 1);
                today.setFullYear(newYear);
                today.setDate(today.getDate() + 1);
                liForm_MailingInfoEnterDetailsVm.minEndDate = today;
                var last = new Date(today);
                last.setDate(last.getDate() - 1);
                last.setFullYear(last.getFullYear() + 1);
                liForm_MailingInfoEnterDetailsVm.maxEndDate = last;
                liForm_MailingInfoEnterDetailsVm.defaultDate = last;


                liForm_MailingInfoEnterDetailsVm.data.name.first = premData.child.first;
                liForm_MailingInfoEnterDetailsVm.data.name.middle = premData.child.middle;
                liForm_MailingInfoEnterDetailsVm.data.name.last = premData.child.last;


                liForm_MailingInfoEnterDetailsVm.beneficiary = {};
            }


            lifeInsuranceBasicApplicationService.getApplicationMasterList(function(response) {
                liForm_MailingInfoEnterDetailsVm.Relationship = response.relationships;
                liForm_MailingInfoEnterDetailsVm.Gender = response.gender;
            });

            lifeInsuranceBasicApplicationService.getStateList().then(function(data) {
                liForm_MailingInfoEnterDetailsVm.states = data.states;
            }, function(error) {});

            if (lifeInsuranceBasicApplicationService.isAadharScanned()) {
                autoPopulateAadhar();
            } else if (lifeInsuranceBasicApplicationService.getNomineeInformation()) {
                liForm_MailingInfoEnterDetailsVm.data = lifeInsuranceBasicApplicationService.getNomineeInformation();

                if (liForm_MailingInfoEnterDetailsVm.data.isSameApplicantAddress == 'true' || liForm_MailingInfoEnterDetailsVm.data.isSameApplicantAddress == true) {
                    liForm_MailingInfoEnterDetailsVm.data.isSameApplicantAddress = true;
                    liForm_MailingInfoEnterDetailsVm.autoPopulateAddress();
                } else {
                    liForm_MailingInfoEnterDetailsVm.data.isSameApplicantAddress = false;
                }

                if (liForm_MailingInfoEnterDetailsVm.data.isNomineeMinor == 'true' || liForm_MailingInfoEnterDetailsVm.data.isNomineeMinor == true) {
                    liForm_MailingInfoEnterDetailsVm.data.isNomineeMinor = true;
                } else {
                    liForm_MailingInfoEnterDetailsVm.data.isNomineeMinor = false;
                }

                liForm_MailingInfoEnterDetailsVm.fetchCityList();
            }
            
        }


        function autoPopulateAadhar() {
            var dataAadhar = lifeInsuranceBasicApplicationService.getNomineeAadhar();
            var stringDat = dataAadhar.name;
            stringDat = stringDat.split(" ");
            var stringArr = [];

            for (var v = 0; v < stringDat.length; v++) {
                stringArr.push(stringDat[v]);
            }
            if (stringArr.length == 2) {
                liForm_MailingInfoEnterDetailsVm.data.name.first = stringArr[0];
                liForm_MailingInfoEnterDetailsVm.data.name.last = stringArr[1];
            }

            if (stringArr.length == 3) {
                liForm_MailingInfoEnterDetailsVm.data.name.first = stringArr[0];
                liForm_MailingInfoEnterDetailsVm.data.name.last = stringArr[2];
                liForm_MailingInfoEnterDetailsVm.data.name.middle = stringArr[1];
            }
            if (stringArr.length == 1) {
                liForm_MailingInfoEnterDetailsVm.data.name.first = stringArr[0];

            }
            if (stringArr.length > 3) {
                liForm_MailingInfoEnterDetailsVm.data.name.first = stringArr[0];
                liForm_MailingInfoEnterDetailsVm.data.name.last = stringArr[2];
                liForm_MailingInfoEnterDetailsVm.data.name.middle = stringArr[1];
            }

            if (dataAadhar.gender == 'M') {
                liForm_MailingInfoEnterDetailsVm.data.gender = liForm_MailingInfoEnterDetailsVm.Gender[0];
            } else {
                liForm_MailingInfoEnterDetailsVm.data.gender = liForm_MailingInfoEnterDetailsVm.Gender[1];
            }

            if (dataAadhar.dob) {
                liForm_MailingInfoEnterDetailsVm.data.dob = $filter('formatAadharDate')(dataAadhar.dob);
                liForm_MailingInfoEnterDetailsVm.update(liForm_MailingInfoEnterDetailsVm.data.dob);
            }
            liForm_MailingInfoEnterDetailsVm.data.address.address1 = "";
            if (dataAadhar.house) {
                liForm_MailingInfoEnterDetailsVm.data.address.address1 = dataAadhar.house;
            }
            if (dataAadhar.street) {
                liForm_MailingInfoEnterDetailsVm.data.address.address1 += " " + dataAadhar.street;
            }
            liForm_MailingInfoEnterDetailsVm.data.address.address2 = "";
            if (dataAadhar.lm) {
                liForm_MailingInfoEnterDetailsVm.data.address.address2 = dataAadhar.lm;
            }
            if (dataAadhar.loc) {
                liForm_MailingInfoEnterDetailsVm.data.address.address2 += " " + dataAadhar.loc;
            }
            if (dataAadhar.vtc) {
                liForm_MailingInfoEnterDetailsVm.data.address.address2 += " " + dataAadhar.vtc;
            }
            liForm_MailingInfoEnterDetailsVm.data.address.address3 = '';
            if (dataAadhar.po) {
                liForm_MailingInfoEnterDetailsVm.data.address.address3 = dataAadhar.po;
            }
            if (dataAadhar.subdist) {
                liForm_MailingInfoEnterDetailsVm.data.address.address3 += " " + dataAadhar.subdist;
            }
            if (dataAadhar.pc) {
                liForm_MailingInfoEnterDetailsVm.data.address.pincode = dataAadhar.pc;
            }
        }


        liForm_MailingInfoEnterDetailsVm.autoPopulateAddress = function() {
            if (liForm_MailingInfoEnterDetailsVm.data.isSameApplicantAddress) {
                var details = lifeInsuranceBasicApplicationService.getMailingInformation();
                angular.copy(details.permanent, liForm_MailingInfoEnterDetailsVm.data.address);
            } else {
                liForm_MailingInfoEnterDetailsVm.data.address.address1 = "";
                liForm_MailingInfoEnterDetailsVm.data.address.address2 = "";
                liForm_MailingInfoEnterDetailsVm.data.address.address3 = "";
                liForm_MailingInfoEnterDetailsVm.data.address.state = "";
                liForm_MailingInfoEnterDetailsVm.data.address.city = "";
                liForm_MailingInfoEnterDetailsVm.data.address.pincode = "";
            }
        }

        liForm_MailingInfoEnterDetailsVm.fetchCityList = function(value) {
            var state = {
                "stID": liForm_MailingInfoEnterDetailsVm.data.address.state.key
            };

            liForm_MailingInfoEnterDetailsVm.city = null;
            lifeInsuranceBasicApplicationService.getCityList(state).then(function(data) {
                liForm_MailingInfoEnterDetailsVm.cities = data.cities;
            }, function(error) {});

        };


        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });


        // On click of Back button
        liForm_MailingInfoEnterDetailsVm.goBacktoPrevious = function() {
            $state.go("menu.liForm_MailingInfoAadhaarScan");
        }

        // On click of Next button
        liForm_MailingInfoEnterDetailsVm.goToNextPage = function() {
            if (validationForm()) {
                clickStreamService.clickStreamData = liForm_MailingInfoEnterDetailsVm.selectedProduct;
                var nomineeInformation = {}; 

                if (liForm_MailingInfoEnterDetailsVm.data.isSameApplicantAddress) {
                    nomineeInformation.isSameApplicantAddress = liForm_MailingInfoEnterDetailsVm.data.isSameApplicantAddress.toString();
                } else {
                    nomineeInformation.isSameApplicantAddress = "false";
                    liForm_MailingInfoEnterDetailsVm.data.isSameApplicantAddress = false;
                }
                nomineeInformation.name = {};
                nomineeInformation.name.first = liForm_MailingInfoEnterDetailsVm.data.name.first;
                nomineeInformation.name.middle = liForm_MailingInfoEnterDetailsVm.data.name.middle ? liForm_MailingInfoEnterDetailsVm.data.name.middle : '';
                nomineeInformation.name.last = liForm_MailingInfoEnterDetailsVm.data.name.last ? liForm_MailingInfoEnterDetailsVm.data.name.last : '';

                nomineeInformation.dob = liForm_MailingInfoEnterDetailsVm.data.dob;
                liForm_MailingInfoEnterDetailsVm.data.age = validateService.calcAge(liForm_MailingInfoEnterDetailsVm.data.dob);
                nomineeInformation.age = liForm_MailingInfoEnterDetailsVm.data.age;
                nomineeInformation.gender = liForm_MailingInfoEnterDetailsVm.data.gender;
                nomineeInformation.relationship = liForm_MailingInfoEnterDetailsVm.data.relationship;
                nomineeInformation.mobileNo = liForm_MailingInfoEnterDetailsVm.data.mobileNo;

                nomineeInformation.address = {};
                nomineeInformation.address.address1 = liForm_MailingInfoEnterDetailsVm.data.address.address1;
                if (liForm_MailingInfoEnterDetailsVm.data.address.address2) {
                    nomineeInformation.address.address2 = liForm_MailingInfoEnterDetailsVm.data.address.address2;
                } else {
                    nomineeInformation.address.address2 = "";
                    liForm_MailingInfoEnterDetailsVm.data.address.address2 = "";
                }

                if (liForm_MailingInfoEnterDetailsVm.data.address.address3) {
                    nomineeInformation.address.address3 = liForm_MailingInfoEnterDetailsVm.data.address.address3;
                } else {
                    nomineeInformation.address.address3 = "";
                    liForm_MailingInfoEnterDetailsVm.data.address.address3 = "";
                }
                nomineeInformation.address.city = liForm_MailingInfoEnterDetailsVm.data.address.city;
                nomineeInformation.address.state = liForm_MailingInfoEnterDetailsVm.data.address.state;
                nomineeInformation.address.pincode = liForm_MailingInfoEnterDetailsVm.data.address.pincode;

                if (liForm_MailingInfoEnterDetailsVm.data.isNomineeMinor) {
                    nomineeInformation.isNomineeMinor = liForm_MailingInfoEnterDetailsVm.data.isNomineeMinor.toString();
                } else {
                    nomineeInformation.isNomineeMinor = "false";
                    liForm_MailingInfoEnterDetailsVm.data.isNomineeMinor = false;
                }

                lifeInsuranceBasicApplicationService.setNomineeInformation(nomineeInformation);

                lifeInsuranceBasicApplicationService.saveApplication(LiConstant.journeyCommonId.APP_NOMINEE).then(function() {
                    if (liForm_MailingInfoEnterDetailsVm.data.isNomineeMinor) {
                        $state.go("menu.liForm_AppointeeInfoAadhaarScan");
                    } else {
                        $state.go("menu.liForm_ProposersFATCA_CRS");
                    }
                });
            }
        }

        function validationForm() {

            liForm_MailingInfoEnterDetailsVm.mailingInfoDetail = {};
            if (liForm_MailingInfoEnterDetailsVm.validateService.isValidName(liForm_MailingInfoEnterDetailsVm.data.name.first)) {
                liForm_MailingInfoEnterDetailsVm.mailingInfoDetail.Name = liForm_MailingInfoEnterDetailsVm.validateService.isValidName(liForm_MailingInfoEnterDetailsVm.data.name.first);
            }

            if (liForm_MailingInfoEnterDetailsVm.validateService.isValidMiddleLastName(liForm_MailingInfoEnterDetailsVm.data.name.middle)) {
                liForm_MailingInfoEnterDetailsVm.mailingInfoDetail.middleName = liForm_MailingInfoEnterDetailsVm.validateService.isValidMiddleLastName(liForm_MailingInfoEnterDetailsVm.data.name.middle);
            }

            if (liForm_MailingInfoEnterDetailsVm.validateService.isValidNomineeLastName(liForm_MailingInfoEnterDetailsVm.data.name.last)) {
                liForm_MailingInfoEnterDetailsVm.mailingInfoDetail.lastName = liForm_MailingInfoEnterDetailsVm.validateService.isValidNomineeLastName(liForm_MailingInfoEnterDetailsVm.data.name.last);
            }

            if (liForm_MailingInfoEnterDetailsVm.validateService.isValidbirthDate(liForm_MailingInfoEnterDetailsVm.data.dob)) {
                liForm_MailingInfoEnterDetailsVm.mailingInfoDetail.birthDate = liForm_MailingInfoEnterDetailsVm.validateService.isValidbirthDate(liForm_MailingInfoEnterDetailsVm.data.dob);
            }

            if (liForm_MailingInfoEnterDetailsVm.validateService.isValidGender(liForm_MailingInfoEnterDetailsVm.data.gender)) {
                liForm_MailingInfoEnterDetailsVm.mailingInfoDetail.gender = liForm_MailingInfoEnterDetailsVm.validateService.isValidGender(liForm_MailingInfoEnterDetailsVm.data.gender);
            }


            if (liForm_MailingInfoEnterDetailsVm.validateService.isValidPolicyStatus(liForm_MailingInfoEnterDetailsVm.data.relationship)) {
                liForm_MailingInfoEnterDetailsVm.mailingInfoDetail.RStatus = liForm_MailingInfoEnterDetailsVm.validateService.isValidPolicyStatus(liForm_MailingInfoEnterDetailsVm.data.relationship);
            }

            if (liForm_MailingInfoEnterDetailsVm.validateService.isValidPhoneNo(liForm_MailingInfoEnterDetailsVm.data.mobileNo)) {
                liForm_MailingInfoEnterDetailsVm.mailingInfoDetail.mobileno = liForm_MailingInfoEnterDetailsVm.validateService.isValidPhoneNo(liForm_MailingInfoEnterDetailsVm.data.mobileNo);
            }

            if (liForm_MailingInfoEnterDetailsVm.validateService.isValidAddress(liForm_MailingInfoEnterDetailsVm.data.address.address1)) {
                liForm_MailingInfoEnterDetailsVm.mailingInfoDetail.Address = liForm_MailingInfoEnterDetailsVm.validateService.isValidAddress(liForm_MailingInfoEnterDetailsVm.data.address.address1);
            }

            if (liForm_MailingInfoEnterDetailsVm.validateService.isValidState(liForm_MailingInfoEnterDetailsVm.data.address.state)) {
                liForm_MailingInfoEnterDetailsVm.mailingInfoDetail.state = liForm_MailingInfoEnterDetailsVm.validateService.isValidState(liForm_MailingInfoEnterDetailsVm.data.address.state);
            }

            if (liForm_MailingInfoEnterDetailsVm.validateService.isValidCity(liForm_MailingInfoEnterDetailsVm.data.address.city)) {
                liForm_MailingInfoEnterDetailsVm.mailingInfoDetail.city = liForm_MailingInfoEnterDetailsVm.validateService.isValidCity(liForm_MailingInfoEnterDetailsVm.data.address.city);
            }

            if (liForm_MailingInfoEnterDetailsVm.validateService.isValidPincode(liForm_MailingInfoEnterDetailsVm.data.address.pincode)) {
                liForm_MailingInfoEnterDetailsVm.mailingInfoDetail.pincode = liForm_MailingInfoEnterDetailsVm.validateService.isValidPincode(liForm_MailingInfoEnterDetailsVm.data.address.pincode);
            }

            return (angular.equals({}, liForm_MailingInfoEnterDetailsVm.mailingInfoDetail)) ? true : false;

        }

    }
]);
