angularApp.controller('liForm_appointeeInformationController', [
    "$state",
    "$scope",
    "validateService",
    "lifeInsuranceApplicationService",
    "lifeInsuranceBasicApplicationService",
    "$filter",
    "lifeInsuranceCommonService",
    "suggestedPlansDetailsService",
    "premiumCalculationService",
    "LiConstant",
    "clickStreamService",
    function(
        $state,
        $scope,
        validateService,
        lifeInsuranceApplicationService,
        lifeInsuranceBasicApplicationService,
        $filter,
        lifeInsuranceCommonService,
        suggestedPlansDetailsService,
        premiumCalculationService,
        LiConstant,clickStreamService) {

        var liForm_appointeeInformationVm = this;
        liForm_appointeeInformationVm.validateService = validateService;

        liForm_appointeeInformationVm.data = {};
        liForm_appointeeInformationVm.data.name = {};
        liForm_appointeeInformationVm.data.address = {};
        liForm_appointeeInformationVm.data.isSameApplicantAddress = false;
        liForm_appointeeInformationVm.showBack = true;
        liForm_appointeeInformationVm.showNext = true;
        liForm_appointeeInformationVm.disableBack = false;
        liForm_appointeeInformationVm.disableNext = false;


        function initPage() {
            var currentDate = validateService.getCurrentDate();
            liForm_appointeeInformationVm.uin = suggestedPlansDetailsService.getCurrentSugestedProduct().uin;
            liForm_appointeeInformationVm.selectedProduct = suggestedPlansDetailsService.getCurrentSugestedProduct().planName;
            liForm_appointeeInformationVm.applicationNumber = lifeInsuranceApplicationService.getApplicationNumber();

            liForm_appointeeInformationVm.maxEndDate = $filter('chosenDate')(validateService.getFutureYear(currentDate, -18)); //must be 18 years

            lifeInsuranceBasicApplicationService.getApplicationMasterList(function(response) {
                liForm_appointeeInformationVm.RelationshipwithAssured = response.relationships;
                liForm_appointeeInformationVm.RelationshipwithNominee = response.relationships;
                liForm_appointeeInformationVm.Gender = response.gender;
            });

            lifeInsuranceBasicApplicationService.getStateList().then(function(data) {
                liForm_appointeeInformationVm.states = data.states;
            }, function(error) {});


            if (lifeInsuranceBasicApplicationService.isAadharScanned()) {
                autoPopulateAadhar();
            } else if (lifeInsuranceBasicApplicationService.getAppointeeDetails()) {
                liForm_appointeeInformationVm.data = lifeInsuranceBasicApplicationService.getAppointeeDetails();
                if (liForm_appointeeInformationVm.data.isSameApplicantAddress == 'true' || liForm_appointeeInformationVm.data.isSameApplicantAddress == true) {
                    liForm_appointeeInformationVm.data.isSameApplicantAddress = true;
                    liForm_appointeeInformationVm.copyProposerToAppointee();
                } else {
                    liForm_appointeeInformationVm.data.isSameApplicantAddress = false;
                }
                getCityList();
            }
        }

        function getCityList() {
            var reqObj1 = {
                "stID": liForm_appointeeInformationVm.data.address.state.key
            };
            lifeInsuranceBasicApplicationService.getCityList(reqObj1).then(function(data) {
                liForm_appointeeInformationVm.cities = data.cities;
            }, function(error) {

            });
        }

        liForm_appointeeInformationVm.closeJourney = function() {
            lifeInsuranceCommonService.closePopUp().then(function(result) {
                if (result) {
                    $state.go("menu.generalInsurance");
                }
            });
        };

        liForm_appointeeInformationVm.copyProposerToAppointee = function() {
            if (liForm_appointeeInformationVm.data.isSameApplicantAddress) {
                liForm_appointeeInformationVm.data.address = {};
                var address = lifeInsuranceBasicApplicationService.getMailingInformation();
                angular.copy(address.permanent, liForm_appointeeInformationVm.data.address);
                getCityList();
            } else {
                liForm_appointeeInformationVm.data.address = {};
            }
        };

        function autoPopulateAadhar() {
            var dataAadhar = lifeInsuranceBasicApplicationService.getAppointeeAadhar();
            var stringDat = dataAadhar.name;
            stringDat = stringDat.split(" ");
            var stringArr = [];

            for (var v = 0; v < stringDat.length; v++) {
                stringArr.push(stringDat[v]);
            }
            if (stringArr.length == 2) {
                liForm_appointeeInformationVm.data.name.first = stringArr[0];
                liForm_appointeeInformationVm.data.name.last = stringArr[1];
            }

            if (stringArr.length == 3) {
                liForm_appointeeInformationVm.data.name.first = stringArr[0];
                liForm_appointeeInformationVm.data.name.last = stringArr[2];
                liForm_appointeeInformationVm.data.name.middle = stringArr[1];
            }
            if (stringArr.length == 1) {
                liForm_appointeeInformationVm.data.name.first = stringArr[0];

            }
            if (stringArr.length > 3) {
                liForm_appointeeInformationVm.data.name.first = stringArr[0];
                liForm_appointeeInformationVm.data.name.last = stringArr[2];
                liForm_appointeeInformationVm.data.name.middle = stringArr[1];
            }

            if (dataAadhar.gender == 'M') {
                liForm_appointeeInformationVm.data.gender = liForm_appointeeInformationVm.Gender[0];
            } else {
                liForm_appointeeInformationVm.data.gender = liForm_appointeeInformationVm.Gender[1];
            }

            if (dataAadhar.dob) {
                liForm_appointeeInformationVm.data.dob = $filter('formatAadharDate')(dataAadhar.dob);
            }
            liForm_appointeeInformationVm.data.address.address1 = '';
            if (dataAadhar.house) {
                liForm_appointeeInformationVm.data.address.address1 = dataAadhar.house;
            }
            if (dataAadhar.street) {
                liForm_appointeeInformationVm.data.address.address1 += " " + dataAadhar.street;
            }
            liForm_appointeeInformationVm.data.address.address2 = '';
            if (dataAadhar.lm) {
                liForm_appointeeInformationVm.data.address.address2 = dataAadhar.lm;
            }
            if (dataAadhar.loc) {
                liForm_appointeeInformationVm.data.address.address2 += " " + dataAadhar.loc;
            }
            if (dataAadhar.vtc) {
                liForm_appointeeInformationVm.data.address.address2 += " " + dataAadhar.vtc;
            }
            liForm_appointeeInformationVm.data.address.address3 = '';
            if (dataAadhar.po) {
                liForm_appointeeInformationVm.data.address.address3 = dataAadhar.po;
            }
            if (dataAadhar.subdist) {
                liForm_appointeeInformationVm.data.address.address3 += " " + dataAadhar.subdist;
            }
            if (dataAadhar.pc) {
                liForm_appointeeInformationVm.data.address.pincode = dataAadhar.pc;
            }
        };


        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        $scope.$on('$ionicView.enter', function() {
            if (lifeInsuranceBasicApplicationService.getAppointeeSign()) {
                lifeInsuranceBasicApplicationService.getAppointeeSign();
                liForm_appointeeInformationVm.canShowPreview = true;
                var sign = lifeInsuranceBasicApplicationService.getAppointeeSign();
                document.getElementById('preview').src = sign;
                liForm_appointeeInformationVm.data.signatureBase64 = sign.replace('data:image/png;base64,', '');
            } else if (liForm_appointeeInformationVm.data.signatureBase64) {
                liForm_appointeeInformationVm.canShowPreview = false;
            }
        });

        liForm_appointeeInformationVm.fetchCityList = function(value) {
            var state = {
                "stID": liForm_appointeeInformationVm.data.address.state.key
            };

            liForm_appointeeInformationVm.city = null;
            lifeInsuranceBasicApplicationService.getCityList(state).then(function(data) {
                liForm_appointeeInformationVm.cities = data.cities;
            }, function(error) {});
        };


        // On click of Back button
        liForm_appointeeInformationVm.goBacktoPrevious = function() {
            $state.go("menu.liForm_AppointeeInfoAadhaarScan");
        }

        liForm_appointeeInformationVm.getAppointeeSignature = function() {
           $state.go("menu.lifeInsuranceESignature");
        };

        //onclick of submit button
        liForm_appointeeInformationVm.goToNextPage = function() {
            if (validateForm()) {
                clickStreamService.clickStreamData = liForm_appointeeInformationVm.selectedProduct
                var appointeeDetails = {}; 

                appointeeDetails.isSameApplicantAddress = liForm_appointeeInformationVm.data.isSameApplicantAddress + '';
                appointeeDetails.name = {};
                appointeeDetails.name.first = liForm_appointeeInformationVm.data.name.first;
                if (liForm_appointeeInformationVm.data.name.middle) {
                    appointeeDetails.name.middle = liForm_appointeeInformationVm.data.name.middle;
                } else { appointeeDetails.name.middle = ""; };
                if (liForm_appointeeInformationVm.data.name.last) {
                    appointeeDetails.name.last = liForm_appointeeInformationVm.data.name.last;
                } else {
                    appointeeDetails.name.last = "";
                    liForm_appointeeInformationVm.data.name.last = "";
                };

                appointeeDetails.gender = liForm_appointeeInformationVm.data.gender;
                appointeeDetails.dob = liForm_appointeeInformationVm.data.dob;
                liForm_appointeeInformationVm.data.age = validateService.calcAge(liForm_appointeeInformationVm.data.dob);
                appointeeDetails.age = liForm_appointeeInformationVm.data.age.toString();
                appointeeDetails.address = {};
                appointeeDetails.address.address1 = liForm_appointeeInformationVm.data.address.address1;
                if (liForm_appointeeInformationVm.data.address.address2) {
                    appointeeDetails.address.address2 = liForm_appointeeInformationVm.data.address.address2;
                } else {
                    appointeeDetails.address.address2 = "";
                    liForm_appointeeInformationVm.data.address.address2 = "";
                }
                if (liForm_appointeeInformationVm.data.address.address3) {
                    appointeeDetails.address.address3 = liForm_appointeeInformationVm.data.address.address3;
                } else {
                    appointeeDetails.address.address3 = "";
                    liForm_appointeeInformationVm.data.address.address3 = "";
                }

                appointeeDetails.address.city = liForm_appointeeInformationVm.data.address.city;
                appointeeDetails.address.state = liForm_appointeeInformationVm.data.address.state;
                appointeeDetails.address.pincode = liForm_appointeeInformationVm.data.address.pincode;

                appointeeDetails.relationshipWithAssured = liForm_appointeeInformationVm.data.relationshipWithAssured;
                appointeeDetails.relationshipWithNominee = liForm_appointeeInformationVm.data.relationshipWithNominee;

                var request = {
                    "data": liForm_appointeeInformationVm.data.signatureBase64,
                    "filename": liForm_appointeeInformationVm.applicationNumber + "_APPOINTEE_SIGN_LT",
                    "quoteNo": premiumCalculationService.getQuoteNumber(),
                    "applicationNumber": liForm_appointeeInformationVm.applicationNumber
                }
                lifeInsuranceBasicApplicationService.sendDocs(request).then(function() {
                    appointeeDetails.signatureBase64 = 'Uploaded Successfully';
                    lifeInsuranceBasicApplicationService.setAppointeeDetails(appointeeDetails);
                    lifeInsuranceBasicApplicationService.saveApplication(LiConstant.journeyCommonId.APP_APPOINTEE).then(function() {
                        $state.go("menu.liForm_ProposersFATCA_CRS");
                    });
                }, function(error) {});
            }
        }

        //common validation function
        function validateForm() {
            liForm_appointeeInformationVm.liForm_appointeeInformationForm = {};

            if (liForm_appointeeInformationVm.validateService.isValidName(liForm_appointeeInformationVm.data.name.first)) {
                liForm_appointeeInformationVm.liForm_appointeeInformationForm.name = liForm_appointeeInformationVm.validateService.isValidName(liForm_appointeeInformationVm.data.name.first);
            }

            if (liForm_appointeeInformationVm.validateService.isValidMiddleLastName(liForm_appointeeInformationVm.data.name.middle)) {
                liForm_appointeeInformationVm.liForm_appointeeInformationForm.middle = liForm_appointeeInformationVm.validateService.isValidMiddleLastName(liForm_appointeeInformationVm.data.name.middle);
            }

            if (liForm_appointeeInformationVm.validateService.isValidNomineeLastName(liForm_appointeeInformationVm.data.name.last)) {
                liForm_appointeeInformationVm.liForm_appointeeInformationForm.last = liForm_appointeeInformationVm.validateService.isValidNomineeLastName(liForm_appointeeInformationVm.data.name.last);
            }

            if (liForm_appointeeInformationVm.validateService.isValidbirthDate(liForm_appointeeInformationVm.data.dob)) {
                liForm_appointeeInformationVm.liForm_appointeeInformationForm.birthDate = liForm_appointeeInformationVm.validateService.isValidbirthDate(liForm_appointeeInformationVm.data.dob);
            }
            if (liForm_appointeeInformationVm.validateService.isValidAddress(liForm_appointeeInformationVm.data.address.address1)) {
                liForm_appointeeInformationVm.liForm_appointeeInformationForm.Address = liForm_appointeeInformationVm.validateService.isValidAddress(liForm_appointeeInformationVm.data.address.address1);
            }
            if (liForm_appointeeInformationVm.validateService.isValidAssuredrel(liForm_appointeeInformationVm.data.relationshipWithAssured)) {
                liForm_appointeeInformationVm.liForm_appointeeInformationForm.AssuredRelation = liForm_appointeeInformationVm.validateService.isValidAssuredrel(liForm_appointeeInformationVm.data.relationshipWithAssured);
            }
            if (liForm_appointeeInformationVm.validateService.isValidNomineerel(liForm_appointeeInformationVm.data.relationshipWithNominee)) {
                liForm_appointeeInformationVm.liForm_appointeeInformationForm.NomineeRelation = liForm_appointeeInformationVm.validateService.isValidNomineerel(liForm_appointeeInformationVm.data.relationshipWithNominee);
            }

            if (liForm_appointeeInformationVm.validateService.isValidGender(liForm_appointeeInformationVm.data.gender)) {
                liForm_appointeeInformationVm.liForm_appointeeInformationForm.gender = liForm_appointeeInformationVm.validateService.isValidGender(liForm_appointeeInformationVm.data.gender);
            }

            if (liForm_appointeeInformationVm.validateService.isValidState(liForm_appointeeInformationVm.data.address.state)) {
                liForm_appointeeInformationVm.liForm_appointeeInformationForm.state = liForm_appointeeInformationVm.validateService.isValidState(liForm_appointeeInformationVm.data.address.state);
            }

            if (liForm_appointeeInformationVm.validateService.isValidCity(liForm_appointeeInformationVm.data.address.city)) {
                liForm_appointeeInformationVm.liForm_appointeeInformationForm.city = liForm_appointeeInformationVm.validateService.isValidCity(liForm_appointeeInformationVm.data.address.city);
            }

            if (liForm_appointeeInformationVm.validateService.isValidPincode(liForm_appointeeInformationVm.data.address.pincode)) {
                liForm_appointeeInformationVm.liForm_appointeeInformationForm.pincode = liForm_appointeeInformationVm.validateService.isValidPincode(liForm_appointeeInformationVm.data.address.pincode);
            }

            if (liForm_appointeeInformationVm.validateService.isValidSign(liForm_appointeeInformationVm.data.signatureBase64)) {
                liForm_appointeeInformationVm.liForm_appointeeInformationForm.sign = liForm_appointeeInformationVm.validateService.isValidSign(liForm_appointeeInformationVm.data.signatureBase64);
            }
            return (angular.equals({}, liForm_appointeeInformationVm.liForm_appointeeInformationForm)) ? true : false;
        }
    }
]);
