angularApp.controller('liForm_eInsuranceController', [
    "$state",
    "$scope",
    "validateService",
    "lifeInsuranceBasicApplicationService",
    "lifeInsuranceCommonService",
    "suggestedPlansDetailsService",
    "LiConstant",
    "utilityService","clickStreamService",

    function(
        $state,
        $scope,
        validateService,
        lifeInsuranceBasicApplicationService,
        lifeInsuranceCommonService,
        suggestedPlansDetailsService,
        LiConstant,utilityService,clickStreamService) {

        var liForm_eInsuranceVm = this;
        liForm_eInsuranceVm.validateService = validateService;
        liForm_eInsuranceVm.data = {};
        liForm_eInsuranceVm.placeOfFormFill = '';

        function initPage() {

            liForm_eInsuranceVm.showBack = true;
            liForm_eInsuranceVm.showNext = true;
            liForm_eInsuranceVm.disableBack = false;
            liForm_eInsuranceVm.disableNext = false;
            liForm_eInsuranceVm.data.isThroughRepository = true;
            lifeInsuranceBasicApplicationService.getApplicationMasterList(function(response) {
                liForm_eInsuranceVm.depositoryNames = response.repositoryNames;
            });

            liForm_eInsuranceVm.uin = suggestedPlansDetailsService.getCurrentSugestedProduct().uin;
            liForm_eInsuranceVm.selectedProduct = suggestedPlansDetailsService.getCurrentSugestedProduct().planName;
            if (lifeInsuranceBasicApplicationService.getEinsurance()) {
                liForm_eInsuranceVm.data = lifeInsuranceBasicApplicationService.getEinsurance();
                if(liForm_eInsuranceVm.data.isThroughRepository == 'true' || liForm_eInsuranceVm.data.isThroughRepository  == true) {
                    liForm_eInsuranceVm.data.isThroughRepository = true;
                } else{
                    liForm_eInsuranceVm.data.isThroughRepository = false;
                }
                if(liForm_eInsuranceVm.data.haveInsuranceAccount == 'true' || liForm_eInsuranceVm.data.haveInsuranceAccount  == true) {
                    liForm_eInsuranceVm.data.haveInsuranceAccount = true;
                } else{
                    liForm_eInsuranceVm.data.haveInsuranceAccount = false;
                }
            }
            if(lifeInsuranceBasicApplicationService.getPlace()){
                liForm_eInsuranceVm.placeOfFormFill = lifeInsuranceBasicApplicationService.getPlace();
            }
        }

        liForm_eInsuranceVm.goBacktoPrevious = function() {
            $state.go("menu.liForm_FamilyHistory");
        }

        liForm_eInsuranceVm.updateInfo = function() {
            if (liForm_eInsuranceVm.data.isThroughRepository) {
                liForm_eInsuranceVm.data.haveInsuranceAccount = false;
                liForm_eInsuranceVm.data.insuranceAccountNumber = "";
                liForm_eInsuranceVm.data.repositoryName = {};
            }
        }

        liForm_eInsuranceVm.closeJourney = function() {
             lifeInsuranceCommonService.closePopUp().then(function(result) {
                if(result) {
                   $state.go("menu.generalInsurance"); 
                }
            });
        };
        liForm_eInsuranceVm.showInfoDetails = function() {           
            var title = '';
            var template = "<p class='roboto-regular font-content text-left'>*SBI Life will contact you to facilitate the opening of an e-Insurance account.</p>";
            var onTap = '';
            var buttontext = "<b>OK</b>";
            utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
        };
      
        liForm_eInsuranceVm.updateRepository = function() {
            var startDigit = liForm_eInsuranceVm.data.insuranceAccountNumber.toString().charAt(0);
            if (startDigit == 1) {
                liForm_eInsuranceVm.data.repositoryName = liForm_eInsuranceVm.depositoryNames[0];
            } else if (startDigit == 2) {
                liForm_eInsuranceVm.data.repositoryName = liForm_eInsuranceVm.depositoryNames[1];
            } else if (startDigit == 4) {
                liForm_eInsuranceVm.data.repositoryName = liForm_eInsuranceVm.depositoryNames[2];
            } else if (startDigit == 5) {
                liForm_eInsuranceVm.data.repositoryName = liForm_eInsuranceVm.depositoryNames[3];
            }
        }

        // On click of Next button
        liForm_eInsuranceVm.goToNextPage = function() {
            if (validateForm()) {
                clickStreamService.clickStreamData = liForm_eInsuranceVm.selectedProduct;
                var einsurances = {};
                if (liForm_eInsuranceVm.data.isThroughRepository) {
                    einsurances.isThroughRepository = liForm_eInsuranceVm.data.isThroughRepository.toString();
                } else {
                    einsurances.isThroughRepository = "false";
                    liForm_eInsuranceVm.data.isThroughRepository = false;
                }
                if (liForm_eInsuranceVm.data.haveInsuranceAccount) {
                    einsurances.haveInsuranceAccount = liForm_eInsuranceVm.data.haveInsuranceAccount.toString();
                    einsurances.insuranceAccountNumber = liForm_eInsuranceVm.data.insuranceAccountNumber;
                    einsurances.repositoryName = liForm_eInsuranceVm.data.repositoryName;
                } else {
                    einsurances.haveInsuranceAccount = "false";
                    liForm_eInsuranceVm.data.haveInsuranceAccount = false;
                    einsurances.insuranceAccountNumber = "";
                    liForm_eInsuranceVm.data.insuranceAccountNumber = "";
                    einsurances.repositoryName = {};
                    liForm_eInsuranceVm.data.repositoryName = {};
                }
                var place = liForm_eInsuranceVm.placeOfFormFill;
                lifeInsuranceBasicApplicationService.setPlace(place);
                lifeInsuranceBasicApplicationService.setEinsurance(einsurances);
                lifeInsuranceBasicApplicationService.saveApplication(LiConstant.journeyCommonId.APP_EINSURANCE).then(function() {
                    $state.go("menu.liForm_Preview");
                });
                
            }
        }


        //frm e-insurance validation function
        function validateForm() {
            liForm_eInsuranceVm.frmEIinsurance = {};
            if (liForm_eInsuranceVm.validateService.isValidInsuranceAccountNumber(liForm_eInsuranceVm.data.insuranceAccountNumber) && liForm_eInsuranceVm.data.haveInsuranceAccount) {
                liForm_eInsuranceVm.frmEIinsurance.eInsuranceAccNum = liForm_eInsuranceVm.validateService.isValidInsuranceAccountNumber(liForm_eInsuranceVm.data.insuranceAccountNumber);
            }
            if (liForm_eInsuranceVm.validateService.isValidPlaceName(liForm_eInsuranceVm.placeOfFormFill)) {
                  liForm_eInsuranceVm.frmEIinsurance.place = liForm_eInsuranceVm.validateService.isValidPlaceName(liForm_eInsuranceVm.placeOfFormFill);
              }
            return (angular.equals({}, liForm_eInsuranceVm.frmEIinsurance)) ? true : false;
        }


        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
