angularApp.controller('lifeInsuranceBasicInformationController', [
    "$state",
    "$scope",
    "validateService",
    "lifeInsuranceBasicApplicationService",
    "lifeInsuranceApplicationService",
    "lifeInsuranceCommonService",
    "suggestedPlansDetailsService",
    "LiConstant","clickStreamService",


    function(
        $state,
        $scope,
        validateService,
        lifeInsuranceBasicApplicationService,
        lifeInsuranceApplicationService,
        lifeInsuranceCommonService,
        suggestedPlansDetailsService,
        LiConstant,clickStreamService) {

        var lifeInsuranceBasicInformationVm = this;
        lifeInsuranceBasicInformationVm.validateService = validateService;

        lifeInsuranceBasicInformationVm.showBack = true;
        lifeInsuranceBasicInformationVm.showNext = true;
        lifeInsuranceBasicInformationVm.disableBack = false;
        lifeInsuranceBasicInformationVm.disableNext = false;

        function initPage() {
            lifeInsuranceBasicInformationVm.data = {};
            lifeInsuranceBasicInformationVm.data.name = {};

            getApplicationMasterData();
            lifeInsuranceBasicInformationVm.uin = suggestedPlansDetailsService.getCurrentSugestedProduct().uin;
            lifeInsuranceBasicInformationVm.selectedProduct = suggestedPlansDetailsService.getCurrentSugestedProduct().planName;
            if (lifeInsuranceBasicApplicationService.getPersonalDetails1()) {
                lifeInsuranceBasicInformationVm.data = lifeInsuranceBasicApplicationService.getPersonalDetails1();
                var details = lifeInsuranceApplicationService.getPersonalDetails(); //for only required field changes
                lifeInsuranceBasicInformationVm.data.name.first = details.name.first;
                lifeInsuranceBasicInformationVm.data.name.middle = details.name.middle;
                lifeInsuranceBasicInformationVm.data.name.last = details.name.last;
                lifeInsuranceBasicInformationVm.data.dob = details.dob;
                lifeInsuranceBasicInformationVm.data.gender = details.gender;
            } else {
                var details = lifeInsuranceApplicationService.getPersonalDetails();
                lifeInsuranceBasicInformationVm.data.name.first = details.name.first;
                lifeInsuranceBasicInformationVm.data.name.middle = details.name.middle;
                lifeInsuranceBasicInformationVm.data.name.last = details.name.last;
                lifeInsuranceBasicInformationVm.data.dob = details.dob;
                lifeInsuranceBasicInformationVm.data.maritalStatus = details.maritalStatus;
                lifeInsuranceBasicInformationVm.data.gender = details.gender;
            }

        }

        lifeInsuranceBasicInformationVm.closeJourney = function() {
            lifeInsuranceCommonService.closePopUp().then(function(result) {
                if (result) {
                    $state.go("menu.generalInsurance");
                }
            });
        };


        // get the application master data for the application journey
        function getApplicationMasterData() {
            lifeInsuranceBasicApplicationService.getApplicationMasterData().then(function(data) {
                lifeInsuranceBasicInformationVm.maritalStatusLists = data.maritalStatusLists;
                lifeInsuranceBasicInformationVm.educationalQualificationList = data.qualifications;
            }, function(error) {

            });
        };



        //onclick of Back button
        lifeInsuranceBasicInformationVm.goBacktoPrevious = function() {
            if (!lifeInsuranceApplicationService.getPremiumAcceptanceMessage()) {
                lifeInsuranceApplicationService.getAcceptanceMessage().then(function(data) {
                    lifeInsuranceApplicationService.setPremiumAcceptanceMessage(data.message);
                    $state.go('menu.declarationOfLI');
                }, function(error) {

                });
            } else {
                $state.go('menu.declarationOfLI');
            }

        };


        //onclick of submit button
        lifeInsuranceBasicInformationVm.goToNextPage = function() {
            
            if (validateForm()) {
                lifeInsuranceBasicInformationVm.data.age = validateService.calcAge(lifeInsuranceBasicInformationVm.data.dob).toString();
                clickStreamService.clickStreamData = lifeInsuranceBasicInformationVm.selectedProduct;
                var details = lifeInsuranceBasicApplicationService.getApplicationDetails();
                if (!details.personalDetails) {
                    details.personalDetails = {};
                }
                details.personalDetails.name = lifeInsuranceBasicInformationVm.data.name;
               
                details.personalDetails.dob = lifeInsuranceBasicInformationVm.data.dob;
                details.personalDetails.age = lifeInsuranceBasicInformationVm.data.age;
                details.personalDetails.gender = lifeInsuranceBasicInformationVm.data.gender;
                details.personalDetails.fathersName = lifeInsuranceBasicInformationVm.data.fathersName;
                details.personalDetails.maritalStatus = lifeInsuranceBasicInformationVm.data.maritalStatus;
                details.personalDetails.educationalQualification = lifeInsuranceBasicInformationVm.data.educationalQualification;
                if (lifeInsuranceBasicInformationVm.data.maidenName) {
                    details.personalDetails.maidenName = lifeInsuranceBasicInformationVm.data.maidenName;
                } else {
                    details.personalDetails.maidenName = "";
                    lifeInsuranceBasicInformationVm.data.maidenName = '';
                }

                lifeInsuranceBasicApplicationService.setBasicApplicationInformation1(details);
                lifeInsuranceBasicApplicationService.saveApplication(LiConstant.journeyCommonId.APP_PERSONAL).then(function() {
                    $state.go("menu.lifeInsuranceExistingPolicy");
                });
            }
        }

        //common validation function
        function validateForm() {
            lifeInsuranceBasicInformationVm.lifeInsuranceBasicInformationForm = {};
            
            if (lifeInsuranceBasicInformationVm.validateService.isValidFatherName(lifeInsuranceBasicInformationVm.data.fathersName)) {
                lifeInsuranceBasicInformationVm.lifeInsuranceBasicInformationForm.fatherName = lifeInsuranceBasicInformationVm.validateService.isValidFatherName(lifeInsuranceBasicInformationVm.data.fathersName);
            }

            if (lifeInsuranceBasicInformationVm.validateService.isValidMaidenName(lifeInsuranceBasicInformationVm.data.maidenName) && (lifeInsuranceBasicInformationVm.data.gender.key == 'F')) {
                lifeInsuranceBasicInformationVm.lifeInsuranceBasicInformationForm.maidenname = lifeInsuranceBasicInformationVm.validateService.isValidMaidenName(lifeInsuranceBasicInformationVm.data.maidenName);
            }
            if (lifeInsuranceBasicInformationVm.validateService.isValidMstatus(lifeInsuranceBasicInformationVm.data.maritalStatus)) {
                lifeInsuranceBasicInformationVm.lifeInsuranceBasicInformationForm.mstatus = lifeInsuranceBasicInformationVm.validateService.isValidMstatus(lifeInsuranceBasicInformationVm.data.maritalStatus);
            }

            if (lifeInsuranceBasicInformationVm.validateService.isValidQualification(lifeInsuranceBasicInformationVm.data.educationalQualification)) {
                lifeInsuranceBasicInformationVm.lifeInsuranceBasicInformationForm.educationalQualification = lifeInsuranceBasicInformationVm.validateService.isValidQualification(lifeInsuranceBasicInformationVm.data.educationalQualification);
            }

            return (angular.equals({}, lifeInsuranceBasicInformationVm.lifeInsuranceBasicInformationForm)) ? true : false;
        }


        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
