angularApp.controller('lifeInsuranceBasicInformationController2', [
    "$state",
    "$scope",
    "$translate",
    "validateService",
    "lifeInsuranceBasicApplicationService",
    "utilityService",
    "lifeInsuranceCommonService",
    "suggestedPlansDetailsService",
    "LiConstant",
    "$ionicScrollDelegate","clickStreamService",

    function(
        $state,
        $scope,
        $translate,
        validateService,
        lifeInsuranceBasicApplicationService,
        utilityService,
        lifeInsuranceCommonService,
        suggestedPlansDetailsService,
        LiConstant,
        $ionicScrollDelegate,clickStreamService) {

        var lifeInsuranceBasicInformation2Vm = this;
        lifeInsuranceBasicInformation2Vm.validateService = validateService;

        lifeInsuranceBasicInformation2Vm.showBack = true;
        lifeInsuranceBasicInformation2Vm.showNext = true;
        lifeInsuranceBasicInformation2Vm.disableBack = false;
        lifeInsuranceBasicInformation2Vm.disableNext = false;

        function initPage() {
            lifeInsuranceBasicInformation2Vm.data = {};
            lifeInsuranceBasicInformation2Vm.uin = suggestedPlansDetailsService.getCurrentSugestedProduct().uin;
            lifeInsuranceBasicInformation2Vm.selectedProduct = suggestedPlansDetailsService.getCurrentSugestedProduct().planName;
            if (lifeInsuranceBasicApplicationService.getPersonalDetails2().nationality) {
                lifeInsuranceBasicInformation2Vm.data = lifeInsuranceBasicApplicationService.getPersonalDetails2();
                if(lifeInsuranceBasicInformation2Vm.data.isPoliticallyExposed == 'true' || lifeInsuranceBasicInformation2Vm.data.isPoliticallyExposed  == true) {
                    lifeInsuranceBasicInformation2Vm.data.isPoliticallyExposed = true;
                } else{
                    lifeInsuranceBasicInformation2Vm.data.isPoliticallyExposed = false;
                }
                if(lifeInsuranceBasicInformation2Vm.data.isHazardExposed == 'true' || lifeInsuranceBasicInformation2Vm.data.isHazardExposed == true) {
                    lifeInsuranceBasicInformation2Vm.data.isHazardExposed = true;
                }else {
                    lifeInsuranceBasicInformation2Vm.data.isHazardExposed = false;
                }
                if(lifeInsuranceBasicInformation2Vm.data.isConvicted == 'true' || lifeInsuranceBasicInformation2Vm.data.isConvicted == true) {
                    lifeInsuranceBasicInformation2Vm.data.isConvicted = true;
                }else{
                    lifeInsuranceBasicInformation2Vm.data.isConvicted = false;
                }
            } else {
                lifeInsuranceBasicInformation2Vm.data.nationality = $translate.instant('INDIAN');
                lifeInsuranceBasicInformation2Vm.data.countryOfResidence = $translate.instant('INDIA');
                lifeInsuranceBasicInformation2Vm.data.isPoliticallyExposed = false;
                lifeInsuranceBasicInformation2Vm.data.isHazardExposed = false;
                lifeInsuranceBasicInformation2Vm.data.isConvicted = false;
            }
            getApplicationMasterList();
        }

        function getApplicationMasterList() {
            lifeInsuranceBasicApplicationService.getApplicationMasterList(function(response) {
                lifeInsuranceBasicInformation2Vm.occupationHazardOs = response.hazardousOccupations;
            });
        };

        lifeInsuranceBasicInformation2Vm.closeJourney = function() {
             lifeInsuranceCommonService.closePopUp().then(function(result) {
                if(result) {
                   $state.go("menu.generalInsurance"); 
                }
            });
        };

        lifeInsuranceBasicInformation2Vm.resize = function() {
            $ionicScrollDelegate.$getByHandle('mainScroll').resize();   
        };
       

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });


        lifeInsuranceBasicInformation2Vm.risk1Info = function() {
            var title = '';
            var template = "<p class='roboto-regular font-content'>PEPs are individuals who are or have been entrusted with prominent public functions, i.e. heads/ministers of central/state govt., senior politicians, senior govt, judicial or military officials, senior executives of govt. companies, important political party officials, immediate family member of above persons (would include spouse, parents, siblings, children, spouse's parents or siblings and close associates of PEPs.)</p>";
            var onTap = '';
            var buttontext = "<b>OK</b>";
            utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
        };

        lifeInsuranceBasicInformation2Vm.risk3Info = function() {
            var title = '';
            var template = "<p class='roboto-regular font-content'>e.g. working in mines, chemical factory, corrosive, hazrdous chemicals or gas etc. or working at height, in sea, underground, underwater, on oil rigs or handling explosives, fire arms or involving combative assignments-internal or external.</p>";
            var onTap = '';
            var buttontext = "<b>OK</b>";
            utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
        };

        //onclick of Back button
        lifeInsuranceBasicInformation2Vm.goBacktoPrevious = function() {
            $state.go("menu.lifeInsuranceExistingPolicy");
        }


        //onclick of submit button
        lifeInsuranceBasicInformation2Vm.goToNextPage = function() {
            if (validateForm()) {
                clickStreamService.clickStreamData = lifeInsuranceBasicInformation2Vm.selectedProduct;
                var personalDetails = lifeInsuranceBasicApplicationService.getApplicationDetails().personalDetails;
                personalDetails.nationality = lifeInsuranceBasicInformation2Vm.data.nationality;
                personalDetails.countryOfResidence = lifeInsuranceBasicInformation2Vm.data.countryOfResidence;
                if (lifeInsuranceBasicInformation2Vm.data.isPoliticallyExposed) {
                    personalDetails.isPoliticallyExposed = lifeInsuranceBasicInformation2Vm.data.isPoliticallyExposed.toString();
                    personalDetails.politicalExposure = lifeInsuranceBasicInformation2Vm.data.politicalExposure;
                } else {
                    personalDetails.isPoliticallyExposed = "false";
                    personalDetails.politicalExposure = "";
                }
                if (lifeInsuranceBasicInformation2Vm.data.isConvicted) {
                    personalDetails.isConvicted = lifeInsuranceBasicInformation2Vm.data.isConvicted.toString();
                    personalDetails.conviction = lifeInsuranceBasicInformation2Vm.data.conviction;
                } else {
                    personalDetails.isConvicted = "false";
                    personalDetails.conviction = "";
                }
                if (lifeInsuranceBasicInformation2Vm.data.isHazardExposed) {
                    personalDetails.isHazardExposed = lifeInsuranceBasicInformation2Vm.data.isHazardExposed.toString();
                    personalDetails.hazardExposure = lifeInsuranceBasicInformation2Vm.data.hazardExposure;
                } else {
                    personalDetails.isHazardExposed = "false";
                    personalDetails.hazardExposure = {};
                }

                lifeInsuranceBasicApplicationService.setBasicApplicationInformation2(personalDetails);
                lifeInsuranceBasicApplicationService.saveApplication(LiConstant.journeyCommonId.APP_OTHER_DETAIL).then(function() {
                    $state.go("menu.lifeInsuranceBasicInformation3");
                });
            }
        }

        //common validation function
        function validateForm() {
            lifeInsuranceBasicInformation2Vm.lifeInsuranceBasicInformation2Form = {};

            if (lifeInsuranceBasicInformation2Vm.data.isPoliticallyExposed == true && lifeInsuranceBasicInformation2Vm.validateService.isValidPoliticallyExposed(lifeInsuranceBasicInformation2Vm.data.politicalExposure)) {
                lifeInsuranceBasicInformation2Vm.lifeInsuranceBasicInformation2Form.politicalHistory = lifeInsuranceBasicInformation2Vm.validateService.isValidPoliticallyExposed(lifeInsuranceBasicInformation2Vm.data.politicalExposure);
            }


            if (lifeInsuranceBasicInformation2Vm.data.isConvicted == true && lifeInsuranceBasicInformation2Vm.validateService.isValidConvictionHistory(lifeInsuranceBasicInformation2Vm.data.conviction)) {
                lifeInsuranceBasicInformation2Vm.lifeInsuranceBasicInformation2Form.convictionHistory = lifeInsuranceBasicInformation2Vm.validateService.isValidConvictionHistory(lifeInsuranceBasicInformation2Vm.data.conviction);
            }

            if (lifeInsuranceBasicInformation2Vm.data.isHazardExposed == true && lifeInsuranceBasicInformation2Vm.validateService.isValidHazardOccup(lifeInsuranceBasicInformation2Vm.data.hazardExposure)) {
                lifeInsuranceBasicInformation2Vm.lifeInsuranceBasicInformation2Form.occupationHazardO = lifeInsuranceBasicInformation2Vm.validateService.isValidHazardOccup(lifeInsuranceBasicInformation2Vm.data.hazardExposure);
            }

            return (angular.equals({}, lifeInsuranceBasicInformation2Vm.lifeInsuranceBasicInformation2Form)) ? true : false;
        }
    }
]);
