angularApp.controller('lifeInsuranceBasicInformationController3', [
    "$state",
    "$scope",
    "validateService", 
    "lifeInsuranceBasicApplicationService",
    "lifeInsuranceCommonService",
    "suggestedPlansDetailsService",
    "LiConstant","clickStreamService",


    function(
        $state,
        $scope,
        validateService, 
        lifeInsuranceBasicApplicationService,
        lifeInsuranceCommonService,
        suggestedPlansDetailsService,
        LiConstant,clickStreamService) {

        var lifeInsuranceBasicInformation3Vm = this;
        lifeInsuranceBasicInformation3Vm.validateService = validateService;
        

        lifeInsuranceBasicInformation3Vm.showBack = true;
        lifeInsuranceBasicInformation3Vm.showNext = true;
        lifeInsuranceBasicInformation3Vm.disableBack = false;
        lifeInsuranceBasicInformation3Vm.disableNext = false;

        function initPage() {
            lifeInsuranceBasicInformation3Vm.data = {};

            lifeInsuranceBasicInformation3Vm.uin = suggestedPlansDetailsService.getCurrentSugestedProduct().uin;
            lifeInsuranceBasicInformation3Vm.selectedProduct = suggestedPlansDetailsService.getCurrentSugestedProduct().planName;
            getMasterData();

            if (lifeInsuranceBasicApplicationService.getExistingLI2()) {
                lifeInsuranceBasicInformation3Vm.data = lifeInsuranceBasicApplicationService.getExistingLI2();
                if(lifeInsuranceBasicInformation3Vm.data.isSBILifeCustomer == 'true' || lifeInsuranceBasicInformation3Vm.data.isSBILifeCustomer == true) {
                    lifeInsuranceBasicInformation3Vm.data.isSBILifeCustomer = true;
                }else {
                    lifeInsuranceBasicInformation3Vm.data.isSBILifeCustomer = false;
                }
            }
            
        }

        lifeInsuranceBasicInformation3Vm.closeJourney = function() {
             lifeInsuranceCommonService.closePopUp().then(function(result) {
                if(result) {
                   $state.go("menu.generalInsurance"); 
                }
            });
        };

        function getMasterData() {
            lifeInsuranceBasicApplicationService.getApplicationMasterList(function(response) {
                lifeInsuranceBasicInformation3Vm.objectives = response.objectiveTakinPolicy;
                lifeInsuranceBasicInformation3Vm.languages = response.preferredLanguages;
            });
           
        };


        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });


        lifeInsuranceBasicInformation3Vm.goBacktoPrevious = function() {
            $state.go("menu.lifeInsuranceBasicInformation2");
        }

        //onclick of next button
        lifeInsuranceBasicInformation3Vm.goToNextPage = function() {
            if (validateForm()) {
                clickStreamService.clickStreamData = lifeInsuranceBasicInformation3Vm.selectedProduct;
                var personalDetails = lifeInsuranceBasicApplicationService.getApplicationDetails().personalDetails;
                if (lifeInsuranceBasicInformation3Vm.data.isSBILifeCustomer) {
                    personalDetails.isSBILifeCustomer = lifeInsuranceBasicInformation3Vm.data.isSBILifeCustomer.toString();
                    personalDetails.sbiLifePolicyNumber = lifeInsuranceBasicInformation3Vm.data.sbiLifePolicyNumber;
                } else {
                    personalDetails.isSBILifeCustomer = "false";
                    personalDetails.sbiLifePolicyNumber = "";
                }
                personalDetails.policyObjective = lifeInsuranceBasicInformation3Vm.data.policyObjective;
                personalDetails.language = lifeInsuranceBasicInformation3Vm.data.language;

                lifeInsuranceBasicApplicationService.setExistingLI2(personalDetails);
                lifeInsuranceBasicApplicationService.saveApplication(LiConstant.journeyCommonId.APP_OTHER_DETAIL_2).then(function() {
                    $state.go("menu.lifeInsuranceBasicInformation4");
                });
            }
        }

        // validation function
        function validateForm() {
            lifeInsuranceBasicInformation3Vm.lifeInsuranceBasicInformation3Form = {};


            if (lifeInsuranceBasicInformation3Vm.validateService.isValidPolicyObjective(lifeInsuranceBasicInformation3Vm.data.policyObjective)) {
                lifeInsuranceBasicInformation3Vm.lifeInsuranceBasicInformation3Form.objective = lifeInsuranceBasicInformation3Vm.validateService.isValidPolicyObjective(lifeInsuranceBasicInformation3Vm.data.policyObjective);
            }

            if (lifeInsuranceBasicInformation3Vm.validateService.isValidLanguageOfCommu(lifeInsuranceBasicInformation3Vm.data.language)) {
                lifeInsuranceBasicInformation3Vm.lifeInsuranceBasicInformation3Form.language = lifeInsuranceBasicInformation3Vm.validateService.isValidLanguageOfCommu(lifeInsuranceBasicInformation3Vm.data.language);
            }

            if ((lifeInsuranceBasicInformation3Vm.data.isSBILifeCustomer) &&
                (lifeInsuranceBasicInformation3Vm.validateService.isValidPolicyNum(lifeInsuranceBasicInformation3Vm.data.sbiLifePolicyNumber))) {
                lifeInsuranceBasicInformation3Vm.lifeInsuranceBasicInformation3Form.existingSBILifeCustomer = lifeInsuranceBasicInformation3Vm.validateService.isValidPolicyNum(lifeInsuranceBasicInformation3Vm.data.sbiLifePolicyNumber);
            }
            return (angular.equals({}, lifeInsuranceBasicInformation3Vm.lifeInsuranceBasicInformation3Form)) ? true : false;
        }
    }
]);
