angularApp.controller('lifeInsuranceBasicInformationController4', [
    "$state",
    "$scope",
    "validateService",
    "lifeInsuranceBasicApplicationService",
    "premiumCalculationService",
    "lifeInsuranceCommonService",
    "suggestedPlansDetailsService",
    "LiConstant",
    "$filter",
    "clickStreamService",

    function(
        $state,
        $scope,
        validateService,
        lifeInsuranceBasicApplicationService,
        premiumCalculationService,
        lifeInsuranceCommonService,
        suggestedPlansDetailsService,
        LiConstant,
        $filter,clickStreamService) {

        var lifeInsuranceBasicInformation4Vm = this;
        lifeInsuranceBasicInformation4Vm.data = {};

        lifeInsuranceBasicInformation4Vm.showBack = true;
        lifeInsuranceBasicInformation4Vm.showNext = true;
        lifeInsuranceBasicInformation4Vm.disableBack = false;
        lifeInsuranceBasicInformation4Vm.disableNext = false;

        function initPage() {
            lifeInsuranceBasicInformation4Vm.validateService = validateService;

            lifeInsuranceBasicInformation4Vm.uin = suggestedPlansDetailsService.getCurrentSugestedProduct().uin;
            lifeInsuranceBasicInformation4Vm.selectedProduct = suggestedPlansDetailsService.getCurrentSugestedProduct().planName;
            lifeInsuranceBasicApplicationService.getApplicationMasterList(function(response) {
                lifeInsuranceBasicInformation4Vm.occupations = response.occupations;
                lifeInsuranceBasicInformation4Vm.domicile = response.domiciles;
            });

            getProofDoc();
            if (lifeInsuranceBasicApplicationService.getBasicApplicationInformation4()) {
                lifeInsuranceBasicInformation4Vm.data = lifeInsuranceBasicApplicationService.getBasicApplicationInformation4();
                if (lifeInsuranceBasicInformation4Vm.data.occupation) {
                    lifeInsuranceBasicInformation4Vm.changeOccupation();
                }
            }
        }


        lifeInsuranceBasicInformation4Vm.closeJourney = function() {
            lifeInsuranceCommonService.closePopUp().then(function(result) {
                if (result) {
                    $state.go("menu.generalInsurance");
                }
            });
        };


        lifeInsuranceBasicInformation4Vm.changeOccupation = function() {
            if (lifeInsuranceBasicInformation4Vm.data.occupation.key == 'Retired' ||
                lifeInsuranceBasicInformation4Vm.data.occupation.key == 'Self Employed' ||
                lifeInsuranceBasicInformation4Vm.data.occupation.key == 'Housewife' ||
                lifeInsuranceBasicInformation4Vm.data.occupation.key == 'Agriculturist' ||
                lifeInsuranceBasicInformation4Vm.data.occupation.key == 'Student') {
                lifeInsuranceBasicInformation4Vm.data.occu = false;

            } else {
                lifeInsuranceBasicInformation4Vm.data.occu = true;
            }

        };

        lifeInsuranceBasicInformation4Vm.changeEmployerName = function() {
            if (lifeInsuranceBasicInformation4Vm.data.occupation.key == 'Professional' || lifeInsuranceBasicInformation4Vm.data.occupation.key == 'Business') {
                lifeInsuranceBasicInformation4Vm.data.employerReadonly = true;
                lifeInsuranceBasicInformation4Vm.data.employerName = "Self-Employed";
            } else {
                lifeInsuranceBasicInformation4Vm.data.employerReadonly = false;
                lifeInsuranceBasicInformation4Vm.data.employerName = "";
            }
        };



        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });


        lifeInsuranceBasicInformation4Vm.goBacktoPrevious = function() {
            $state.go("menu.lifeInsuranceBasicInformation3");
        }


        function getProofDoc() {
            lifeInsuranceBasicApplicationService.getProofDoc().then(function(data) {
                lifeInsuranceBasicInformation4Vm.docName = data.proofDocuments.identity;
                lifeInsuranceBasicInformation4Vm.docNameIncome = data.proofDocuments.income;
                lifeInsuranceBasicInformation4Vm.docNameAge = data.proofDocuments.age;
                lifeInsuranceBasicInformation4Vm.docNameAddress = data.proofDocuments.residential;

                lifeInsuranceBasicInformation4Vm.data.idProof = $filter('getObjectByValue')(lifeInsuranceBasicInformation4Vm.docName, 'key', '57'); //lifeInsuranceBasicInformation4Vm.docName[4]; //aadhar card non editable
                lifeInsuranceBasicInformation4Vm.premiumAmount = parseInt(premiumCalculationService.getAnnualPremiumAmount());

                if (parseInt(lifeInsuranceBasicInformation4Vm.premiumAmount) >= 50000) {
                    lifeInsuranceBasicInformation4Vm.data.ageProof = $filter('getObjectByValue')(lifeInsuranceBasicInformation4Vm.docName, 'key', '11'); //lifeInsuranceBasicInformation4Vm.docNameAge[6];
                }
            });
        }

        //onclick of next button
        lifeInsuranceBasicInformation4Vm.goToNextPage = function() {
            if (validateForm()) {
                clickStreamService.clickStreamData = lifeInsuranceBasicInformation4Vm.selectedProduct;
                var personalDetails = lifeInsuranceBasicApplicationService.getApplicationDetails().personalDetails;

                personalDetails.occupation = lifeInsuranceBasicInformation4Vm.data.occupation;
                if (lifeInsuranceBasicInformation4Vm.data.occu) {
                    personalDetails.employerName = lifeInsuranceBasicInformation4Vm.data.employerName;

                    personalDetails.natureOfDuty = lifeInsuranceBasicInformation4Vm.data.natureOfDuty;
                    personalDetails.annualIncome = lifeInsuranceBasicInformation4Vm.data.annualIncome;
                } else {
                    personalDetails.employerName = "";
                    personalDetails.natureOfDuty = "";
                    personalDetails.annualIncome = "";
                }
                if (personalDetails.occupation.isDefencePersonnel == 'true') {
                    personalDetails.forceNumber = lifeInsuranceBasicInformation4Vm.data.forceNumber;
                } else {
                    personalDetails.forceNumber = "";
                }

                if (lifeInsuranceBasicInformation4Vm.data.panNumber) {
                    personalDetails.panNumber = lifeInsuranceBasicInformation4Vm.data.panNumber;
                } else {
                    personalDetails.panNumber = "";
                }

                personalDetails.domicile = lifeInsuranceBasicInformation4Vm.data.domicile;
                personalDetails.idProof = lifeInsuranceBasicInformation4Vm.data.idProof;
                personalDetails.incomeProof = lifeInsuranceBasicInformation4Vm.data.incomeProof;
                personalDetails.ageProof = lifeInsuranceBasicInformation4Vm.data.ageProof;
                personalDetails.addressProof = lifeInsuranceBasicInformation4Vm.data.addressProof;

                lifeInsuranceBasicApplicationService.setBasicApplicationInformation4(personalDetails);
                lifeInsuranceBasicApplicationService.saveApplication(LiConstant.journeyCommonId.APP_PROFESSIONAL).then(function() {
                    $state.go("menu.liForm_MailingInfo");
                });
            }
        }


        // validation function
        function validateForm() {
            lifeInsuranceBasicInformation4Vm.lifeInsuranceBasicInformation4Form = {};

            if (lifeInsuranceBasicInformation4Vm.validateService.isValidOccupation(lifeInsuranceBasicInformation4Vm.data.occupation)) {
                lifeInsuranceBasicInformation4Vm.lifeInsuranceBasicInformation4Form.occupation = lifeInsuranceBasicInformation4Vm.validateService.isValidOccupation(lifeInsuranceBasicInformation4Vm.occupation);
            }

            if (lifeInsuranceBasicInformation4Vm.validateService.isValidEmployerName(lifeInsuranceBasicInformation4Vm.data.employerName) && lifeInsuranceBasicInformation4Vm.data.occu) {
                lifeInsuranceBasicInformation4Vm.lifeInsuranceBasicInformation4Form.nameofemployer = lifeInsuranceBasicInformation4Vm.validateService.isValidEmployerName(lifeInsuranceBasicInformation4Vm.data.employerName);
            }

            if (lifeInsuranceBasicInformation4Vm.data.occupation && lifeInsuranceBasicInformation4Vm.data.occupation.isDefencePersonnel == 'true') {
                if (lifeInsuranceBasicInformation4Vm.validateService.isValidForceNumber(lifeInsuranceBasicInformation4Vm.data.forceNumber) && lifeInsuranceBasicInformation4Vm.data.occu) {
                    lifeInsuranceBasicInformation4Vm.lifeInsuranceBasicInformation4Form.employeeForceNumber = lifeInsuranceBasicInformation4Vm.validateService.isValidForceNumber(lifeInsuranceBasicInformation4Vm.data.forceNumber);
                }
            }

            if (lifeInsuranceBasicInformation4Vm.validateService.isValidAnnualIncome(lifeInsuranceBasicInformation4Vm.data.annualIncome) && lifeInsuranceBasicInformation4Vm.data.occu) {
                lifeInsuranceBasicInformation4Vm.lifeInsuranceBasicInformation4Form.annualIncome = lifeInsuranceBasicInformation4Vm.validateService.isValidAnnualIncome(lifeInsuranceBasicInformation4Vm.data.annualIncome);
            }

            if (lifeInsuranceBasicInformation4Vm.validateService.isValidDomicile(lifeInsuranceBasicInformation4Vm.data.domicile)) {
                lifeInsuranceBasicInformation4Vm.lifeInsuranceBasicInformation4Form.domicile = lifeInsuranceBasicInformation4Vm.validateService.isValidDomicile(lifeInsuranceBasicInformation4Vm.data.domicile);
            }

            if (lifeInsuranceBasicInformation4Vm.validateService.isValidIdentityProof(lifeInsuranceBasicInformation4Vm.data.idProof)) {
                lifeInsuranceBasicInformation4Vm.lifeInsuranceBasicInformation4Form.identityProof = lifeInsuranceBasicInformation4Vm.validateService.isValidIdentityProof(lifeInsuranceBasicInformation4Vm.data.idProof);
            }

            if (lifeInsuranceBasicInformation4Vm.validateService.isValidIncomeProof(lifeInsuranceBasicInformation4Vm.data.incomeProof)) {
                lifeInsuranceBasicInformation4Vm.lifeInsuranceBasicInformation4Form.incomeProof = lifeInsuranceBasicInformation4Vm.validateService.isValidIncomeProof(lifeInsuranceBasicInformation4Vm.data.incomeProof);
            }

            if (lifeInsuranceBasicInformation4Vm.validateService.isValidAgeProof(lifeInsuranceBasicInformation4Vm.data.ageProof)) {
                lifeInsuranceBasicInformation4Vm.lifeInsuranceBasicInformation4Form.ageProof = lifeInsuranceBasicInformation4Vm.validateService.isValidAgeProof(lifeInsuranceBasicInformation4Vm.data.ageProof);
            }
            if (lifeInsuranceBasicInformation4Vm.validateService.isValidAddressProof(lifeInsuranceBasicInformation4Vm.data.addressProof)) {
                lifeInsuranceBasicInformation4Vm.lifeInsuranceBasicInformation4Form.addressProof = lifeInsuranceBasicInformation4Vm.validateService.isValidAddressProof(lifeInsuranceBasicInformation4Vm.data.addressProof);
            }

            if (lifeInsuranceBasicInformation4Vm.validateService.isValidActivityName(lifeInsuranceBasicInformation4Vm.data.natureOfDuty) && lifeInsuranceBasicInformation4Vm.data.occu) {
                lifeInsuranceBasicInformation4Vm.lifeInsuranceBasicInformation4Form.activityName = lifeInsuranceBasicInformation4Vm.validateService.isValidActivityName(lifeInsuranceBasicInformation4Vm.data.natureOfDuty);
            }

            if (lifeInsuranceBasicInformation4Vm.premiumAmount >= 50000 || lifeInsuranceBasicInformation4Vm.data.ageProof.key == '11') {
                if (lifeInsuranceBasicInformation4Vm.validateService.isValidPANNo(lifeInsuranceBasicInformation4Vm.data.panNumber)) {
                    lifeInsuranceBasicInformation4Vm.lifeInsuranceBasicInformation4Form.panNumber = lifeInsuranceBasicInformation4Vm.validateService.isValidPANNo(lifeInsuranceBasicInformation4Vm.data.panNumber);
                }
            }

            return (angular.equals({}, lifeInsuranceBasicInformation4Vm.lifeInsuranceBasicInformation4Form)) ? true : false;
        }


    }
]);


