(function() {
    'use strict';
    //lifeInsurance Application Services
    angularApp.service('lifeInsuranceBasicApplicationService', lifeInsuranceBasicApplicationService);

    lifeInsuranceBasicApplicationService.$inject = ['$filter',
        'commonAPIService',
        'lifeInsuranceConfig',
        '$q',
        'AdapterUtils',
        'financialGoalsChartsServices',
        'utilityService',
        'lifeInsuranceApplicationService'
    ];

    function lifeInsuranceBasicApplicationService($filter,
        commonAPIService,
        lifeInsuranceConfig,
        $q,
        AdapterUtils,
        financialGoalsChartsServices,
        utilityService,
        lifeInsuranceApplicationService) {

        var lifeInsuranceBasicApplication = this;

        var applicationData = {}; //  for sending to the server and cloudent
        applicationData.medicalHistory = {};
        applicationData.medicalHistory.questions = [];

        var basicApplicationData = {}; // for storing user entered data
        basicApplicationData.medicalHistory = {};
        basicApplicationData.medicalHistory.questions = [];

        var applicationMasterData = {};
        var medicalQuestions = {};
        var startIndex;
        var dataHgtWt = {};

        var commonQuestionLength;
        var femaleQuestionLength;
        var addQuestionLength;
        var totalLength;
        var submitApplicationResponse;
        var nomineeAadhar;
        var appointeeAadhar;
        var proposerAadhar;
        var AadharText;
        var signature;
        var isAadharScanned;
        var applicationD;
        var paymentRequest;
        var uploadAttempts;
        var paymentAccounts;


        lifeInsuranceBasicApplication.initializeApplication = function() {
            applicationData = {};
            applicationData.medicalHistory = {};
            applicationData.medicalHistory.questions = [];

            basicApplicationData = {};
            basicApplicationData.medicalHistory = {};
            basicApplicationData.medicalHistory.questions = [];

            medicalQuestions = {};
            dataHgtWt = {};
        };

        lifeInsuranceBasicApplication.setUploadImageCount = function(imgCount) {
            if(!uploadAttempts) {
                uploadAttempts  = {};//Array(10).fill(0);
            }
            if(!uploadAttempts[imgCount]) {
                uploadAttempts[imgCount] = 0;
            }
            uploadAttempts[imgCount]++;
            if(uploadAttempts[imgCount] > 3) {
                return true;
            } else {
                return false;
            }
           
        };

        lifeInsuranceBasicApplication.resetUploadImageCount = function() {
            uploadAttempts  = {};
        };

        lifeInsuranceBasicApplication.setIsAadharScanned = function(value) {
            isAadharScanned = value;
        };

        lifeInsuranceBasicApplication.isAadharScanned = function() {
            return isAadharScanned;
        };

        lifeInsuranceBasicApplication.setPayment = function(payment) {
            paymentRequest = payment;
        };

        lifeInsuranceBasicApplication.getPayment = function() {
            return paymentRequest;
        };

        lifeInsuranceBasicApplication.getApplicationMasterList = function(callback) {
            callback(applicationMasterData);
        };

        lifeInsuranceBasicApplication.getApplicationDetails = function() {
            return applicationData;
        };

        lifeInsuranceBasicApplication.setApplicationDetails = function(data) {
            applicationData = data;
        };

        lifeInsuranceBasicApplication.setBasicApplicationInformation1 = function(details) {
            applicationData = details;
        };

        lifeInsuranceBasicApplication.getPersonalDetails1 = function() {
            return applicationData.personalDetails;
        };

        lifeInsuranceBasicApplication.setBasicApplicationInformation2 = function(details) {
            applicationData.personalDetails = details;
        };

        lifeInsuranceBasicApplication.getPersonalDetails2 = function() {
            return applicationData.personalDetails;
        };


        lifeInsuranceBasicApplication.setExistingLI1 = function(details) {
            applicationData.existingLIPolicies = details;
        };

        lifeInsuranceBasicApplication.getExistingLI1 = function() {
            return applicationData.existingLIPolicies;
        };


        lifeInsuranceBasicApplication.setExistingLI2 = function(details) {
            applicationData.personalDetails = details;
        };

        lifeInsuranceBasicApplication.getExistingLI2 = function() {
            return applicationData.personalDetails;
        };

        lifeInsuranceBasicApplication.getBasicApplicationInformation4 = function() {
            return applicationData.personalDetails;
        };

        lifeInsuranceBasicApplication.setBasicApplicationInformation4 = function(details) {
            applicationData.personalDetails = details;
        };

        lifeInsuranceBasicApplication.setBasicApplicationInformation5 = function(previewDetails) {
            basicApplicationData.personalDetails4 = previewDetails;
        };

        lifeInsuranceBasicApplication.setBasicApplicationInformation6 = function(previewDetails) {
            basicApplicationData.personalDetails5 = previewDetails;
        };

        lifeInsuranceBasicApplication.getPersonalDetails5 = function() {
            return basicApplicationData.personalDetails4;
        };

        lifeInsuranceBasicApplication.getPersonalDetails6 = function() {
            return basicApplicationData.personalDetails5;
        };

        lifeInsuranceBasicApplication.getPersonalDetails3 = function() {
            return applicationData.personalDetails;
        };

        lifeInsuranceBasicApplication.getMailingInformation1 = function() {
            return applicationData.mailingInformation;
        };

        lifeInsuranceBasicApplication.setMailingInformation = function(details) {
            applicationData.mailingInformation = details;
        };

        lifeInsuranceBasicApplication.getMailingInformation = function() {
            return applicationData.mailingInformation;
        };

        lifeInsuranceBasicApplication.getcommonQuestionLength = function() {
            return commonQuestionLength;
        };

        lifeInsuranceBasicApplication.getfemaleQuestionLength = function() {
            return femaleQuestionLength;
        };

        lifeInsuranceBasicApplication.setCommonQuestionLength = function(value) {
            commonQuestionLength = value;
        };

        lifeInsuranceBasicApplication.setFemaleQuestionLength = function(value) {
            femaleQuestionLength = value;
        };

        lifeInsuranceBasicApplication.gettotalLength = function() {
            return totalLength;
        };

        lifeInsuranceBasicApplication.setTotalLength = function(data) {
            totalLength = data;
        };

        lifeInsuranceBasicApplication.getaddQuestionLength = function() {
            return addQuestionLength;
        };

        lifeInsuranceBasicApplication.setNomineeInformation = function(details) {
            applicationData.nomineeInformation = details;
        };

        lifeInsuranceBasicApplication.getNomineeInformation = function() {
            return applicationData.nomineeInformation;
        };


        lifeInsuranceBasicApplication.setAppointeeSign = function(sign) {
            signature = sign;
        };

        lifeInsuranceBasicApplication.getAppointeeSign = function() {
            return signature;
        };

        lifeInsuranceBasicApplication.setAppointeeDetails = function(details) {
            applicationData.appointeeDetails = details;
        };

        lifeInsuranceBasicApplication.getAppointeeDetails = function() {
            return applicationData.appointeeDetails;
        };

        lifeInsuranceBasicApplication.setFATCACRSinfo = function(details) {
            applicationData.fatcacrs = details;
        };

        lifeInsuranceBasicApplication.getFatcaDetails = function() {
            return applicationData.fatcacrs;
        };


        function getHeightInCM(height) {
            var regX = /['"]/g;
            var res = regX.test(height);
            if (res) {
                var newHeight = height.replace('"', '');
                var feet = newHeight.split("'");
                var centemeter = (feet[0] * 30.48) + (feet[1] * 2.54);
                return centemeter;
            } else {
                return height;
            }
        };

        lifeInsuranceBasicApplication.resetMedicalHistory = function() {
            applicationData.medicalHistory = {};
            applicationData.medicalHistory.questions = [];
            femaleQuestionLength = 0;
            totalLength = 0;
        }

        lifeInsuranceBasicApplication.retrieveMedicalHistory = function(data) {
            applicationData.medicalHistory = data;
            for (var index = 0; index < applicationData.medicalHistory.questions.length; index++) {
                if (applicationData.medicalHistory.questions[index].ans === "true" || applicationData.medicalHistory.questions[index].ans === true) {
                    applicationData.medicalHistory.questions[index].ans = true;
                } else if (applicationData.medicalHistory.questions[index].ans === "false" || applicationData.medicalHistory.questions[index].ans === false) {
                    applicationData.medicalHistory.questions[index].ans = false;
                }

                for (var subIndex = 0; subIndex < applicationData.medicalHistory.questions[index].subAns.length; subIndex++) {
                    if (applicationData.medicalHistory.questions[index].subAns[subIndex].ans === "true" || applicationData.medicalHistory.questions[index].subAns[subIndex].ans === true) {
                        applicationData.medicalHistory.questions[index].subAns[subIndex].ans = true;
                    } else if (applicationData.medicalHistory.questions[index].subAns[subIndex].ans === "false" || applicationData.medicalHistory.questions[index].subAns[subIndex].ans === false) {
                        applicationData.medicalHistory.questions[index].subAns[subIndex].ans = false;
                    }
                }
            }
        };


        lifeInsuranceBasicApplication.setMedicalHistory = function(data) {
            questions();
            if (data.height && data.weight) {
                applicationData.medicalHistory.height = getHeightInCM(data.height);
                basicApplicationData.medicalHistory.height = data.height;

                applicationData.medicalHistory.weight = data.weight;
                basicApplicationData.medicalHistory.weight = data.weight;
            }

            function questions() {
                var j = parseInt(data.start);
                basicApplicationData.medicalHistory.questions.length = data.question.length;
                commonQuestionLength = data.question.length;
                var k = 0;

                for (var i = j;
                    (i < (j + 10)) && (i < data.question.length); i++, k++) {
                    var question = {};
                    var subAns = {};
                    var arrL = [];

                    question.qid = data.question[i].id;
                    question.ans = data.answer[k];
                    question.subAns = [];

                    applicationData.medicalHistory.questions[i] = question;


                    //for preview page
                    var questionP = {};
                    var subAnsP = {};
                    questionP.qid = data.question[i].id;
                    questionP.ans = data.answer[k];
                    questionP.question = data.question[i].question;
                    questionP.quesType = data.question[i].quesType;
                    questionP.subAnsP = [];
                    basicApplicationData.medicalHistory.questions[i] = questionP;

                    if (data.sub) {
                        var dataSub = data.sub;
                        angular.forEach(dataSub, function(value, key) {
                            var keyS = parseInt(key) + parseInt(data.start);
                            var valueS = value;

                            var arr = 0;
                            if (keyS == i) {
                                angular.forEach(valueS.details, function(value, key) {
                                    arrL[arr] = { "a": value, "b": key, "c": keyS };

                                    arr = arr + 1;
                                });
                            }
                        });

                        if (data.question[i].subQues) {
                            for (var v = 0; v < data.question[i].subQues.length; v++) {
                                question.subAns[v] = {};
                                question.subAns[v].qid = data.question[i].subQues[v].id;

                                //for preview page
                                questionP.subAnsP[v] = {};
                                questionP.subAnsP[v].qid = data.question[i].subQues[v].id;
                                questionP.subAnsP[v].quesType = data.question[i].subQues[v].quesType;
                                questionP.subAnsP[v].question = data.question[i].subQues[v].question;

                                for (var d = 0; d < arrL.length; d++) {
                                    if (arrL[d].c == i) {
                                        if (arrL[d].b == v) {
                                            question.subAns[v].ans = arrL[d].a;

                                            //for preview page
                                            questionP.subAnsP[v].ans = arrL[d].a;

                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                return applicationData.medicalHistory.questions;
            };
        };

        lifeInsuranceBasicApplication.setMedicalHistoryAdd = function(data) {
            questionsAdd();

            function questionsAdd() {
                if (applicationData.personalDetails.gender.key == 'F') {
                    var j = commonQuestionLength + femaleQuestionLength;
                    totalLength = commonQuestionLength + femaleQuestionLength;
                } else {
                    var j = commonQuestionLength;
                    totalLength = commonQuestionLength;
                };

                addQuestionLength = data.addQuestion.length;
                var k = 0;
                for (var i = j;
                    (i < (j + addQuestionLength)); i++, k++) {

                    var question = {};
                    var subAns = {};
                    var arrL = [];
                    question.qid = data.addQuestion[k].id;
                    question.ans = data.addAnswer[k];
                    question.subAns = [];

                    applicationData.medicalHistory.questions[i] = question;

                    //for preview page
                    var questionP = {};
                    var subAnsP = {};
                    questionP.qid = data.addQuestion[k].id;
                    questionP.ans = data.addAnswer[k];
                    questionP.question = data.addQuestion[k].question;
                    questionP.quesType = data.addQuestion[k].quesType;
                    questionP.subAnsP = [];
                    basicApplicationData.medicalHistory.questions[i] = questionP;

                    if (data.sub) {
                        var dataSub = data.sub;
                        angular.forEach(dataSub, function(value, key) {
                            var keyS = parseInt(key) + j;
                            var valueS = value;
                            var skipIndex;
                            var arr = 0;
                            if (keyS == i) {
                                angular.forEach(valueS.details, function(value, key) {
                                    arrL[arr] = { "a": value, "b": key, "c": keyS };
                                    arr = arr + 1;
                                });
                            }
                        });

                        if (data.addQuestion[k].subQues) {
                            for (var v = 0; v < data.addQuestion[k].subQues.length; v++) {
                                question.subAns[v] = {};
                                question.subAns[v].qid = data.addQuestion[k].subQues[v].id;
                                //for preview page
                                questionP.subAnsP[v] = {};
                                questionP.subAnsP[v].qid = data.addQuestion[k].subQues[v].id;
                                questionP.subAnsP[v].quesType = data.addQuestion[k].subQues[v].quesType;
                                questionP.subAnsP[v].question = data.addQuestion[k].subQues[v].question;

                                for (var d = 0; d < arrL.length; d++) {
                                    if (arrL[d].c == i) {
                                        if (arrL[d].b == v) {
                                            question.subAns[v].ans = arrL[d].a;
                                            //for preview page
                                            questionP.subAnsP[v].ans = arrL[d].a;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                return applicationData.medicalHistory.questions;
            }
        };

        lifeInsuranceBasicApplication.getMedicalHistoryFemale = function() {
            return applicationData.medicalHistory.questions;
        }

        lifeInsuranceBasicApplication.getMedicalHistoryPreview = function() {
            return applicationData.medicalHistory.questions;
        }

        lifeInsuranceBasicApplication.setMedicalHistoryFemale = function(data) {
            questionsFem();

            function questionsFem() {
                var j = commonQuestionLength;
                femaleQuestionLength = data.Femquestion.length;
                var k = 0;
                for (var i = j;
                    (i < (j + femaleQuestionLength)); i++, k++) {

                    var question = {};
                    var subAns = {};
                    var arrL = [];

                    question.qid = data.Femquestion[k].id;

                    if (question.qid == 'HD_HUSBAND_ANNUAL_INCOME' && data.femAnswer[k]) {
                        question.ans = data.femAnswer[k];
                    } else if (question.qid == 'HD_HUSBAND_ANNUAL_INCOME' && !data.femAnswer[k]) {
                        question.ans = '';
                    } else if (question.qid !== 'HD_HUSBAND_ANNUAL_INCOME') {
                        question.ans = data.femAnswer[k];
                    }
                    question.subAns = [];
                    applicationData.medicalHistory.questions[i] = question;

                    //for preview page
                    var questionP = {};
                    var subAnsP = {};
                    questionP.qid = data.Femquestion[k].id;
                    questionP.ans = data.femAnswer[k];
                    questionP.question = data.Femquestion[k].question;
                    questionP.quesType = data.Femquestion[k].quesType;

                    questionP.subAnsP = [];
                    basicApplicationData.medicalHistory.questions[i] = questionP;

                    if (data.sub) {
                        var dataSub = data.sub;
                        angular.forEach(dataSub, function(value, key) {
                            var keyS = parseInt(key) + j;
                            var valueS = value;
                            var skipIndex;
                            var arr = 0;
                            if (keyS == i) {
                                angular.forEach(valueS.details, function(value, key) {
                                    arrL[arr] = { "a": value, "b": key, "c": keyS };
                                    arr = arr + 1;
                                });
                            }
                        });
                    }

                    if (data.Femquestion[k].subQues) {
                        for (var v = 0; v < data.Femquestion[k].subQues.length; v++) {
                            question.subAns[v] = {};
                            question.subAns[v].qid = data.Femquestion[k].subQues[v].id;

                            //for preview page
                            questionP.subAnsP[v] = {};
                            questionP.subAnsP[v].qid = data.Femquestion[k].subQues[v].id;
                            questionP.subAnsP[v].quesType = data.Femquestion[k].subQues[v].quesType;
                            questionP.subAnsP[v].question = data.Femquestion[k].subQues[v].question;

                            for (var d = 0; d < arrL.length; d++) {
                                if (arrL[d].c == i) {
                                    if (arrL[d].b == v) {

                                        //for preview page
                                        questionP.subAnsP[v].ans = arrL[d].a;
                                        if (question.subAns[v].qid == 'hd_husband_insu_yr_prem' || question.subAns[v].qid == 'HD_HUSBAND_INSU_SA') {
                                            question.subAns[v].ans = $filter('formatAmount')(arrL[d].a);
                                        } else {
                                            question.subAns[v].ans = arrL[d].a;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                // lifeInsuranceBasicApplication.saveApplication();
                return applicationData.medicalHistory.questions;
            }
        };


        lifeInsuranceBasicApplication.isJammuKashmirResident = function() {
            return false;
        };

        lifeInsuranceBasicApplication.setDiseaseDetails = function(details) {
            applicationData.medicalHistory.diseases = details;
        };

        lifeInsuranceBasicApplication.getDiseaseDetails = function() {
            return applicationData.medicalHistory.diseases;
        };

        lifeInsuranceBasicApplication.getDiseaseDetailsPreview = function() {
            return applicationData.medicalHistory.diseases;
        };


        lifeInsuranceBasicApplication.setFamilyHistory = function(details) {
            applicationData.familyMedicalDetails = details;
        };

        lifeInsuranceBasicApplication.getFamilyHistory = function() {
            return applicationData.familyMedicalDetails;
        };

        lifeInsuranceBasicApplication.setEinsurance = function(details) {
            applicationData.einsurances = details;
        };

        lifeInsuranceBasicApplication.getEinsurance = function() {
            return applicationData.einsurances;
        };

        lifeInsuranceBasicApplication.setPlace = function(place) {
            applicationData.place = place;
        };

        lifeInsuranceBasicApplication.getPlace = function() {
            return applicationData.place;
        };



        lifeInsuranceBasicApplication.getAdditionalDetails = function() {
            return basicApplicationData.additionalDetails;

        };

        lifeInsuranceBasicApplication.getBasicApplicationData = function() {
            return applicationData;
        };


        lifeInsuranceBasicApplication.getSubmitApplicationResponse = function() {
            return submitApplicationResponse;
        };

        lifeInsuranceBasicApplication.setSubmitApplicationResponse = function(response) {
            submitApplicationResponse = response;
        };

        lifeInsuranceBasicApplication.getapplicationData = function() {
            return applicationData;
        };

        lifeInsuranceBasicApplication.getApplicationInfo = function(callback) {
            callback(applicationData);
        };

        lifeInsuranceBasicApplication.setMedicalQuestions = function(data) {
            data.commonQues = data.commonQues || [];
            data.femaleAdditionalQues = data.femaleAdditionalQues || [];
            data.additionalQues = data.additionalQues || [];
            medicalQuestions = data;

            lifeInsuranceBasicApplication.setCommonQuestionLength(data.commonQues.length);
            lifeInsuranceBasicApplication.setFemaleQuestionLength(data.femaleAdditionalQues.length);
        };

        lifeInsuranceBasicApplication.setStart = function(data) {
            startIndex = parseInt(parseInt(data));
        };

        lifeInsuranceBasicApplication.getStart = function() {
            return startIndex;
        };

        lifeInsuranceBasicApplication.getMedicalQuestions = function() {
            return medicalQuestions;
        };

        lifeInsuranceBasicApplication.getMedicalHistory = function() {
            return applicationData.medicalHistory;
        };

        lifeInsuranceBasicApplication.getMedicalHistoryIb = function() {
            return applicationData.medicalHistory;
        };

        lifeInsuranceBasicApplication.setHgtWt = function(a, b) {
            dataHgtWt = {
                height: a,
                weight: b
            };
            return dataHgtWt;
        };

        lifeInsuranceBasicApplication.getHgtWt = function() {
            return dataHgtWt;
        };


        lifeInsuranceBasicApplication.payForPolicyPurchase = function(reqObj, callback) {
            commonAPIService.invokeAdapter(lifeInsuranceConfig.adapterURL.payForPolicyPurchase[0], lifeInsuranceConfig.adapterURL.payForPolicyPurchase[1], reqObj, callback);
        };

        lifeInsuranceBasicApplication.getStates = function(callback) {
            commonAPIService.invokeAdapter(lifeInsuranceConfig.adapterURL.getStateList[0], lifeInsuranceConfig.adapterURL.getStateList[1], null, callback);
        };

        lifeInsuranceBasicApplication.setNomineeAadhar = function(details) {
            nomineeAadhar = details;
        };

        lifeInsuranceBasicApplication.getNomineeAadhar = function() {
            return nomineeAadhar;
        };


        lifeInsuranceBasicApplication.setAppointeeAadhar = function(details) {
            appointeeAadhar = details;
        };

        lifeInsuranceBasicApplication.getAppointeeAadhar = function() {
            return appointeeAadhar;
        };

        lifeInsuranceBasicApplication.setProposerAadhar = function(details) {
            proposerAadhar = details;
        };

        lifeInsuranceBasicApplication.getProposerAadhar = function() {
            return proposerAadhar;
        };

        lifeInsuranceBasicApplication.setAadharText = function(data) {
            AadharText = data;
        };

        lifeInsuranceBasicApplication.getAadharText = function() {
            return AadharText;
        };

        lifeInsuranceBasicApplication.setPaymentAccount = function(ownAccounts) {
            paymentAccounts = ownAccounts;
        };

        lifeInsuranceBasicApplication.getPaymentAccount = function() {
            return paymentAccounts;
        };

        lifeInsuranceBasicApplication.getMasterDataHealth = function(uin) {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getHealthQuestions[0], uin, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };


        lifeInsuranceBasicApplication.getProofDoc = function(callback) {
            var q = $q.defer();
            AdapterUtils.getData(lifeInsuranceConfig.adapterURL.getProofDocumentList[0], true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        lifeInsuranceBasicApplication.getFatcaCrsContent = function() {
            var q = $q.defer();
            AdapterUtils.getData(lifeInsuranceConfig.adapterURL.getFatcaCRSContent[0], true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        lifeInsuranceBasicApplication.getDeclarationContent = function() {
            var q = $q.defer();
            AdapterUtils.getData(lifeInsuranceConfig.adapterURL.getHUFKartaContent[0], true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        lifeInsuranceBasicApplication.getCallCenterNumber = function() {
            var q = $q.defer();
            AdapterUtils.getData(lifeInsuranceConfig.adapterURL.getCallCenterNumber[0], true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        lifeInsuranceBasicApplication.getIRDAIText = function() {
            var q = $q.defer();
            AdapterUtils.getData(lifeInsuranceConfig.adapterURL.getIRDAIText[0], true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        lifeInsuranceBasicApplication.getStateList = function() {
            var q = $q.defer();
            AdapterUtils.getData(lifeInsuranceConfig.adapterURL.getStateList[0], true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }

            );
            return q.promise;
        };

        lifeInsuranceBasicApplication.getCityList = function(state) {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getCityList[0], state, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;

        };

        lifeInsuranceBasicApplication.getInsuranceActContent = function() {
            var q = $q.defer();
            AdapterUtils.getData(lifeInsuranceConfig.adapterURL.getInsuranceActContent[0], true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }

            );
            return q.promise;
        };

        lifeInsuranceBasicApplication.getAadharTextFromCloud = function() {
            var q = $q.defer();
            AdapterUtils.getData(lifeInsuranceConfig.adapterURL.getLIAadharText[0], true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        lifeInsuranceBasicApplication.getPaymentCompleteMessage = function() {
            var q = $q.defer();
            AdapterUtils.getData(lifeInsuranceConfig.adapterURL.getPaymentComplete[0], true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        lifeInsuranceBasicApplication.getOTPToken = function(reqParams) {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getLIOTPToken[0], reqParams, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };

        //function to call resendOTP for payNewPolicy 
        lifeInsuranceBasicApplication.getOTPTokenForPayNew = function() {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.resendOTPForPayNewPolicy[0], true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };

            //function to call resendOTP for payRenewPolicy 
        lifeInsuranceBasicApplication.getOTPTokenForPayRenew = function() {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.resendOTPForPayRenewPolicy[0], true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };

        lifeInsuranceBasicApplication.validateOTPToken = function(reqParams) {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.validateLIOTPToken[0], reqParams, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };
        //function to validate otp at payment page
        lifeInsuranceBasicApplication.validateOTPTokenForPayment = function(reqParams) {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.validateOTPForPayNew[0], reqParams, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };

        //function to validate otp at renew payment page
        lifeInsuranceBasicApplication.validateOTPTokenForRenewPayment = function(reqParams) {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.validateOTPForPayRenew[0], reqParams, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };
        lifeInsuranceBasicApplication.validateOTPForSbiLifeSmbRenew = function(reqParams) {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.validateOTPForSbiLifeSmbRenew[0], reqParams, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };
        lifeInsuranceBasicApplication.paymentAcknowledgeSlip = function(reqParams) {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getSmbLifeInsuranceRenewalPDF[0], reqParams, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };

        lifeInsuranceBasicApplication.payNewPolicy = function(reqParams) {
            var q = $q.defer();
            AdapterUtils.postDataWithTimeOut(lifeInsuranceConfig.adapterURL.payNewLIPolicy[0], reqParams, true, lifeInsuranceConfig.adapterURL.payNewLIPolicy[2]).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };

        lifeInsuranceBasicApplication.getInfoContentForLI = function() {
            var q = $q.defer();
            AdapterUtils.postDataWithTimeOut(lifeInsuranceConfig.adapterURL.getInfoContent[0], {}, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                   // utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };

        lifeInsuranceBasicApplication.sendDocs = function(requestObj) {
            var q = $q.defer();
            AdapterUtils.postDataWithTimeOut(lifeInsuranceConfig.adapterURL.uploadDoc[0], requestObj, true, lifeInsuranceConfig.adapterURL.uploadDoc[2]).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };

        lifeInsuranceBasicApplication.getApplicationMasterData = function() {
            var q = $q.defer();
            AdapterUtils.getData(lifeInsuranceConfig.adapterURL.getApplicationMasterData[0], true).then(
                function(response) {
                    applicationMasterData = response.data;
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        lifeInsuranceBasicApplication.getCuringDocumentList = function() {
            var q = $q.defer();
            AdapterUtils.getData(lifeInsuranceConfig.adapterURL.getLiFatcaContents[0], true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        lifeInsuranceBasicApplication.getCustomerInfo = function() {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getLiCustomerInfo[0], true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        lifeInsuranceBasicApplication.getFSSBannerImages = function() {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getCarouselImages[0],{},true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

      


        lifeInsuranceBasicApplication.getLoanLanding=function()
        {
            	var q = $q.defer();
		AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getLoanLanding[0], {}, true).then(
			function (response) {
				q.resolve(response.data);
			},
			function (error) {
				q.reject(error);
			}
		);
		return q.promise;
        }


           lifeInsuranceBasicApplication.getHomeLoanRedirection1 = function(id) {
            var q = $q.defer();
            var url="";
            if(id=="home")
            {
                url=lifeInsuranceConfig.adapterURL.getHomeLoanRedirection[0];

            }
            
            else if(id=="car")
            {
             url=lifeInsuranceConfig.adapterURL.getCaLoanRedirection[0];
            }

            else
            {
             url=lifeInsuranceConfig.adapterURL.getEducationLoanRedirection[0];
            }
            AdapterUtils.postData(url,{}, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        lifeInsuranceBasicApplication.saveApplication = function(commonId) {
            var save = {};
            save.applicationNumber = lifeInsuranceApplicationService.getApplicationNumber();
            save.application = {};
            save.application.req = applicationData;
            save.pageNo = commonId;
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.saveApplication[0], save, true).then(
                function(response) {
                    lifeInsuranceBasicApplication.saveJourney(commonId);
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };

        lifeInsuranceBasicApplication.saveJourney = function(commonId) {
            var journeyMaster = lifeInsuranceApplicationService.getJourneyMaster();
            var applicationNumber = lifeInsuranceApplicationService.getApplicationNumber();
            var object = $filter('getObjectByValue')(journeyMaster, 'commonId', commonId);
            var request = {
                "id": applicationNumber,
                "journey": [{
                    "journeyType": object.journeyType,
                    "portalURL": object.portalURL,
                    "commonId": object.commonId,
                    "mobileURL": object.mobileURL,
                    "lastModifiedTime": lifeInsuranceApplicationService.getDate().getTime() + '',
                    "lastModifiedBy": "mobile"
                }]
            };
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.saveLiJourney[0], request, false).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    //utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };
        lifeInsuranceBasicApplication.getSbiLifeSmbPolicyRenewalDetails = function() {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getSbiLifeSmbPolicyRenewalDetails[0], true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };

        lifeInsuranceBasicApplication.submitApplication = function(commonId) {

            applicationD = {
                "application": applicationData,
                "applicationNumber": lifeInsuranceApplicationService.getApplicationNumber()
            };
            if (!applicationD.application.familyMedicalDetails.spouse.healthStatus) {
                applicationD.application.familyMedicalDetails.spouse = {};
            }
            if (!applicationD.application.appointeeDetails) {
                applicationD.application.appointeeDetails = null;
            }
            var q = $q.defer();
            AdapterUtils.postDataWithTimeOut(lifeInsuranceConfig.adapterURL.submitApplication[0], applicationD, true, lifeInsuranceConfig.adapterURL.submitApplication[2]).then(
                function(response) {
                    submitApplicationResponse = response.data;
                    lifeInsuranceBasicApplication.saveJourney(commonId);
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                });
            return q.promise;
        };

        lifeInsuranceBasicApplication.getSBIBankAccounts = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FSSCommonAdapter/getOwnAccounts", {}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
    }

})();
