angularApp.controller('lifeInsuranceEnterOTPController', [
    "$state",
    "$scope",
    "validateService",
    "lifeInsuranceBasicApplicationService",
    "lifeInsuranceCommonService", 
    "premiumCalculationService",
    "lifeInsuranceApplicationService",
    "suggestedPlansDetailsService",
    "$ionicPopup","$timeout",


    function(
        $state,
        $scope,
        validateService,
        lifeInsuranceBasicApplicationService,
        lifeInsuranceCommonService, 
        premiumCalculationService,
        lifeInsuranceApplicationService,
        suggestedPlansDetailsService,
        $ionicPopup,$timeout
    ) {

        var lifeInsuranceEnterOTPVm = this;
        lifeInsuranceEnterOTPVm.validateService = validateService;

        function initPage() {
            lifeInsuranceEnterOTPVm.showBack = false;
            lifeInsuranceEnterOTPVm.showNext = true;
            lifeInsuranceEnterOTPVm.terms = false;
            lifeInsuranceEnterOTPVm.disableback = true;
            lifeInsuranceEnterOTPVm.name = "";
            lifeInsuranceEnterOTPVm.disableLink = false;
            lifeInsuranceEnterOTPVm.clickCount = 0;

            var personalDetail = lifeInsuranceApplicationService.getPersonalDetails();
            if (personalDetail) {
                lifeInsuranceEnterOTPVm.name = personalDetail.name.first;
                if (personalDetail.name.middle) {
                    lifeInsuranceEnterOTPVm.name = lifeInsuranceEnterOTPVm.name + " " + personalDetail.name.middle;
                }
                if (personalDetail.name.last) {
                    lifeInsuranceEnterOTPVm.name = lifeInsuranceEnterOTPVm.name + " " + personalDetail.name.last;
                }
            }

            lifeInsuranceEnterOTPVm.selectedProduct = suggestedPlansDetailsService.getCurrentSugestedProduct();

            lifeInsuranceApplicationService.getESignatureContent().then(function(data) {            
                    lifeInsuranceEnterOTPVm.disclaimerContent = data.message;
                    $timeout(function(){
                   document.getElementById('cusname').innerHTML = lifeInsuranceEnterOTPVm.name;
                    document.getElementById('policyname').innerHTML = lifeInsuranceEnterOTPVm.selectedProduct.planName;
                    document.getElementById('policyuin').innerHTML = lifeInsuranceEnterOTPVm.selectedProduct.uin;
                    });
                    
                }, function(error) {

                });
            
            lifeInsuranceEnterOTPVm.sendOTP();
        }

        lifeInsuranceEnterOTPVm.sendOTP = function() {
            lifeInsuranceEnterOTPVm.enterOTP = "";
            var reqParams = {};
            reqParams.id = "";
            reqParams.emailId = "";
            lifeInsuranceBasicApplicationService.getOTPToken(reqParams).then(function(data) {
                lifeInsuranceEnterOTPVm.lifeInsuranceEnterOTPForm = {};
            });
        };


        lifeInsuranceEnterOTPVm.resendOTP = function() {
            lifeInsuranceEnterOTPVm.enterOTP = "";
            var reqParams = {};
            reqParams.id = "";
            reqParams.emailId = "";
            lifeInsuranceBasicApplicationService.getOTPToken(reqParams).then(function(data) {
                lifeInsuranceEnterOTPVm.clickCount++;
                lifeInsuranceEnterOTPVm.lifeInsuranceEnterOTPForm = {};
                if(lifeInsuranceEnterOTPVm.clickCount == 2){
                   lifeInsuranceEnterOTPVm.disableLink = true;
                }
            });
        };


        lifeInsuranceEnterOTPVm.validateOTP = function() {
            var reqParams = {};
            reqParams.otp = lifeInsuranceEnterOTPVm.enterOTP;
            lifeInsuranceBasicApplicationService.validateOTPToken(reqParams).then(function(data) {
                if (data.status == 'Success' && data.ownAccounts && data.ownAccounts.length > 0) {
                    lifeInsuranceBasicApplicationService.setPaymentAccount(data.ownAccounts);
                    $state.go('menu.lifeInsurancePaynow');
                } else if (data.status != 'Success') {
                    lifeInsuranceEnterOTPVm.lifeInsuranceEnterOTPForm.enterOTP = data.status;
                    lifeInsuranceBasicApplicationService.setPaymentAccount(null);
                } else {
                    var alertPopup = $ionicPopup.alert({
                        title: '',
                        template: '<p class="roboto-regular font-content text-center">We are unable to process your request at this time. Please try later!</p>'
                    });
                    lifeInsuranceBasicApplicationService.setPaymentAccount(null);
                }
            });
        };

        //onclick of submit button
        lifeInsuranceEnterOTPVm.goToNextPage = function() {
            if (validateForm()) {
                lifeInsuranceEnterOTPVm.validateOTP();
            }
        };

        lifeInsuranceEnterOTPVm.closeJourney = function() {
            lifeInsuranceCommonService.closePopUp().then(function(result) {
                if (result) {
                    $state.go("menu.generalInsurance");
                }
            });
        };

        //conmmon validation function
        function validateForm() {
            lifeInsuranceEnterOTPVm.lifeInsuranceEnterOTPForm = {};
            if (lifeInsuranceEnterOTPVm.validateService.isValidOTPNum(lifeInsuranceEnterOTPVm.enterOTP)) {
                lifeInsuranceEnterOTPVm.lifeInsuranceEnterOTPForm.enterOTP = lifeInsuranceEnterOTPVm.validateService.isValidOTPNum(lifeInsuranceEnterOTPVm.enterOTP);
            }
            return (angular.equals({}, lifeInsuranceEnterOTPVm.lifeInsuranceEnterOTPForm)) ? true : false;
        };

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
