angularApp.controller('lifeInsuranceExistingPolicyController', [
    "$state",
    "$scope",
    "validateService",
    "lifeInsuranceBasicApplicationService",
    "lifeInsuranceCommonService",
    "suggestedPlansDetailsService",
    "LiConstant",
    "$ionicScrollDelegate","clickStreamService",


    function(
        $state,
        $scope,
        validateService,
        lifeInsuranceBasicApplicationService,
        lifeInsuranceCommonService,
        suggestedPlansDetailsService,
        LiConstant,
        $ionicScrollDelegate,clickStreamService) {

        var lifeInsuranceExistingPolicyVm = this;
        lifeInsuranceExistingPolicyVm.validateService = validateService;
        lifeInsuranceExistingPolicyVm.data = {};

        lifeInsuranceExistingPolicyVm.showBack = true;
        lifeInsuranceExistingPolicyVm.showNext = true;
        lifeInsuranceExistingPolicyVm.disableBack = false;
        lifeInsuranceExistingPolicyVm.disableNext = false;

        function initPage() {
            getApplicationMasterList();
           
            lifeInsuranceExistingPolicyVm.uin = suggestedPlansDetailsService.getCurrentSugestedProduct().uin;
            lifeInsuranceExistingPolicyVm.selectedProduct = suggestedPlansDetailsService.getCurrentSugestedProduct().planName;
            lifeInsuranceExistingPolicyVm.maxPolicy = 10;
            if(lifeInsuranceBasicApplicationService.getExistingLI1()){
                lifeInsuranceExistingPolicyVm.data.existingLIPolicy = lifeInsuranceBasicApplicationService.getExistingLI1();
                lifeInsuranceExistingPolicyVm.data.haveLIPolicy = (lifeInsuranceExistingPolicyVm.data.existingLIPolicy.length > 0);
            }else {
                lifeInsuranceExistingPolicyVm.data.haveLIPolicy = false;
                lifeInsuranceExistingPolicyVm.data.existingLIPolicy = [];
            }
        }


        function getApplicationMasterList() {
            lifeInsuranceBasicApplicationService.getApplicationMasterList(function(response) {
                lifeInsuranceExistingPolicyVm.premiumPaidForRss = response.premiumPaidFor;
                lifeInsuranceExistingPolicyVm.policyStatuss = response.policyStatus;
                lifeInsuranceExistingPolicyVm.undergoneMedicals = response.undergoneMedicals;
            });
        }

        lifeInsuranceExistingPolicyVm.closeJourney = function() {
             lifeInsuranceCommonService.closePopUp().then(function(result) {
                if(result) {
                   $state.go("menu.generalInsurance"); 
                }
            });
        };


        lifeInsuranceExistingPolicyVm.addPolicy = function() {
            if (lifeInsuranceExistingPolicyVm.data.haveLIPolicy &&
                (lifeInsuranceExistingPolicyVm.data.existingLIPolicy.length < lifeInsuranceExistingPolicyVm.maxPolicy)) {
                var policy = {};
                lifeInsuranceExistingPolicyVm.data.existingLIPolicy.push(policy);
            } else {
                lifeInsuranceExistingPolicyVm.data.existingLIPolicy = [];
            }
            $ionicScrollDelegate.$getByHandle('mainScroll').resize();
        };

        lifeInsuranceExistingPolicyVm.deletePolicy = function(index) {
            if (lifeInsuranceExistingPolicyVm.data.existingLIPolicy.length) {
                lifeInsuranceExistingPolicyVm.data.existingLIPolicy.splice(index, 1);
            }
            $ionicScrollDelegate.$getByHandle('mainScroll').resize();
        };


        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });


        // On click on back button
        lifeInsuranceExistingPolicyVm.goBacktoPrevious = function() {
            $state.go("menu.lifeInsuranceBasicInformation");
        }

        //onclick of next button
        lifeInsuranceExistingPolicyVm.goToNextPage = function() {
            if (validateForm()) {
                clickStreamService.clickStreamData = lifeInsuranceExistingPolicyVm.selectedProduct;
                var existingLIPolicy = [];
                if (lifeInsuranceExistingPolicyVm.data.haveLIPolicy) {
                    for (var count = 0; count < lifeInsuranceExistingPolicyVm.data.existingLIPolicy.length; count++) {
                        var policy = {};
                        policy.companyName = lifeInsuranceExistingPolicyVm.data.existingLIPolicy[count].companyName;
                        policy.policyNo = lifeInsuranceExistingPolicyVm.data.existingLIPolicy[count].policyNo;
                        policy.yearOfIssue = lifeInsuranceExistingPolicyVm.data.existingLIPolicy[count].yearOfIssue;
                        policy.planName = lifeInsuranceExistingPolicyVm.data.existingLIPolicy[count].planName;
                        policy.isUndergoneMedical = lifeInsuranceExistingPolicyVm.data.existingLIPolicy[count].isUndergoneMedical;
                        policy.yearlyPremium = lifeInsuranceExistingPolicyVm.data.existingLIPolicy[count].yearlyPremium;
                        policy.sumAssured = lifeInsuranceExistingPolicyVm.data.existingLIPolicy[count].sumAssured;
                        policy.premiumPaidFor = lifeInsuranceExistingPolicyVm.data.existingLIPolicy[count].premiumPaidFor;
                        policy.policyStatus = lifeInsuranceExistingPolicyVm.data.existingLIPolicy[count].policyStatus;
                        existingLIPolicy.push(policy);
                    } 
                }

                lifeInsuranceBasicApplicationService.setExistingLI1(existingLIPolicy);
                lifeInsuranceBasicApplicationService.saveApplication(LiConstant.journeyCommonId.APP_EXISTING_POLICY).then(function() {
                    $state.go("menu.lifeInsuranceBasicInformation2");
                });
            }
        }


        function validateForm() {

            lifeInsuranceExistingPolicyVm.lifeInsuranceExistingPolicyForm = {};
            lifeInsuranceExistingPolicyVm.lifeInsuranceExistingPolicyForm.insuranceCompany = {};
            lifeInsuranceExistingPolicyVm.lifeInsuranceExistingPolicyForm.policyNum = {};
            lifeInsuranceExistingPolicyVm.lifeInsuranceExistingPolicyForm.yearOfIssue = {};
            lifeInsuranceExistingPolicyVm.lifeInsuranceExistingPolicyForm.productName = {};
            lifeInsuranceExistingPolicyVm.lifeInsuranceExistingPolicyForm.undergoneMedical = {};
            lifeInsuranceExistingPolicyVm.lifeInsuranceExistingPolicyForm.yearlyPremiumRs = {};
            lifeInsuranceExistingPolicyVm.lifeInsuranceExistingPolicyForm.sumAssuredRs = {};
            lifeInsuranceExistingPolicyVm.lifeInsuranceExistingPolicyForm.premiumPaidForRs = {};
            lifeInsuranceExistingPolicyVm.lifeInsuranceExistingPolicyForm.policyStatus = {};

            if (lifeInsuranceExistingPolicyVm.data.haveLIPolicy) {

                for (var count = 0; count < lifeInsuranceExistingPolicyVm.data.existingLIPolicy.length; count++) {

                    if (lifeInsuranceExistingPolicyVm.validateService.isValidInsuranceCompany(lifeInsuranceExistingPolicyVm.data.existingLIPolicy[count].companyName)) {
                        lifeInsuranceExistingPolicyVm.lifeInsuranceExistingPolicyForm.insuranceCompany[count] = lifeInsuranceExistingPolicyVm.validateService.isValidInsuranceCompany(lifeInsuranceExistingPolicyVm.data.existingLIPolicy[count].companyName);
                    }
                    if (lifeInsuranceExistingPolicyVm.validateService.isValidExistingPolicy(lifeInsuranceExistingPolicyVm.data.existingLIPolicy[count].policyNo)) {
                        lifeInsuranceExistingPolicyVm.lifeInsuranceExistingPolicyForm.policyNum[count] = lifeInsuranceExistingPolicyVm.validateService.isValidExistingPolicy(lifeInsuranceExistingPolicyVm.data.existingLIPolicy[count].policyNo);
                    }
                    if (lifeInsuranceExistingPolicyVm.validateService.isValidYearOfIssue(lifeInsuranceExistingPolicyVm.data.existingLIPolicy[count].yearOfIssue)) {
                        lifeInsuranceExistingPolicyVm.lifeInsuranceExistingPolicyForm.yearOfIssue[count] = lifeInsuranceExistingPolicyVm.validateService.isValidYearOfIssue(lifeInsuranceExistingPolicyVm.data.existingLIPolicy[count].yearOfIssue);
                    }
                    if (lifeInsuranceExistingPolicyVm.validateService.isValidProductName(lifeInsuranceExistingPolicyVm.data.existingLIPolicy[count].planName)) {
                        lifeInsuranceExistingPolicyVm.lifeInsuranceExistingPolicyForm.productName[count] = lifeInsuranceExistingPolicyVm.validateService.isValidProductName(lifeInsuranceExistingPolicyVm.data.existingLIPolicy[count].planName);
                    }
                    if (lifeInsuranceExistingPolicyVm.validateService.isValidUndergoneMedical(lifeInsuranceExistingPolicyVm.data.existingLIPolicy[count].isUndergoneMedical)) {
                        lifeInsuranceExistingPolicyVm.lifeInsuranceExistingPolicyForm.undergoneMedical[count] = lifeInsuranceExistingPolicyVm.validateService.isValidUndergoneMedical(lifeInsuranceExistingPolicyVm.data.existingLIPolicy[count].isUndergoneMedical);
                    }
                    if (lifeInsuranceExistingPolicyVm.validateService.isValidYearlyPremiumRS(lifeInsuranceExistingPolicyVm.data.existingLIPolicy[count].yearlyPremium)) {
                        lifeInsuranceExistingPolicyVm.lifeInsuranceExistingPolicyForm.yearlyPremiumRs[count] = lifeInsuranceExistingPolicyVm.validateService.isValidYearlyPremiumRS(lifeInsuranceExistingPolicyVm.data.existingLIPolicy[count].yearlyPremium);
                    }
                    if (lifeInsuranceExistingPolicyVm.validateService.isValidSumAssuredRS(lifeInsuranceExistingPolicyVm.data.existingLIPolicy[count].sumAssured)) {
                        lifeInsuranceExistingPolicyVm.lifeInsuranceExistingPolicyForm.sumAssuredRs[count] = lifeInsuranceExistingPolicyVm.validateService.isValidSumAssuredRS(lifeInsuranceExistingPolicyVm.data.existingLIPolicy[count].sumAssured);
                    }
                    if (lifeInsuranceExistingPolicyVm.validateService.isValidPremiumPaidForRS(lifeInsuranceExistingPolicyVm.data.existingLIPolicy[count].premiumPaidFor)) {
                        lifeInsuranceExistingPolicyVm.lifeInsuranceExistingPolicyForm.premiumPaidForRs[count] = lifeInsuranceExistingPolicyVm.validateService.isValidPremiumPaidForRS(lifeInsuranceExistingPolicyVm.data.existingLIPolicy[count].premiumPaidFor);
                    }
                    if (lifeInsuranceExistingPolicyVm.validateService.isValidPolicyStatus(lifeInsuranceExistingPolicyVm.data.existingLIPolicy[count].policyStatus)) {
                        lifeInsuranceExistingPolicyVm.lifeInsuranceExistingPolicyForm.policyStatus[count] = lifeInsuranceExistingPolicyVm.validateService.isValidPolicyStatus(lifeInsuranceExistingPolicyVm.data.existingLIPolicy[count].policyStatus);
                    }

                }
            }

            return (((angular.equals({}, lifeInsuranceExistingPolicyVm.lifeInsuranceExistingPolicyForm.insuranceCompany)) ? true : false) &&
                ((angular.equals({}, lifeInsuranceExistingPolicyVm.lifeInsuranceExistingPolicyForm.policyNum)) ? true : false) &&
                ((angular.equals({}, lifeInsuranceExistingPolicyVm.lifeInsuranceExistingPolicyForm.yearOfIssue)) ? true : false) &&
                ((angular.equals({}, lifeInsuranceExistingPolicyVm.lifeInsuranceExistingPolicyForm.productName)) ? true : false) &&
                ((angular.equals({}, lifeInsuranceExistingPolicyVm.lifeInsuranceExistingPolicyForm.undergoneMedical)) ? true : false) &&
                ((angular.equals({}, lifeInsuranceExistingPolicyVm.lifeInsuranceExistingPolicyForm.yearlyPremiumRs)) ? true : false) &&
                ((angular.equals({}, lifeInsuranceExistingPolicyVm.lifeInsuranceExistingPolicyForm.sumAssuredRs)) ? true : false) &&
                ((angular.equals({}, lifeInsuranceExistingPolicyVm.lifeInsuranceExistingPolicyForm.premiumPaidForRs)) ? true : false) &&
                ((angular.equals({}, lifeInsuranceExistingPolicyVm.lifeInsuranceExistingPolicyForm.policyStatus)) ? true : false));

        }

    }
]);
