angularApp.controller('lifeInsuranceOTPforPaymentController', [
    "$state",
    "$scope",
    "validateService",
    "lifeInsuranceBasicApplicationService",
    "lifeInsuranceCommonService", 
    "premiumCalculationService",
    "lifeInsuranceApplicationService",
    "suggestedPlansDetailsService",
    "$ionicPopup","utilityService",
    "customerInfoService",

    function(
        $state,
        $scope,
        validateService,
        lifeInsuranceBasicApplicationService,
        lifeInsuranceCommonService, 
        premiumCalculationService,
        lifeInsuranceApplicationService,
        suggestedPlansDetailsService,
        $ionicPopup,utilityService,customerInfoService
    ) {

        var lifeInsuranceEnterOTPPaymentVm = this;
        lifeInsuranceEnterOTPPaymentVm.validateService = validateService;

        function initPage() {
            lifeInsuranceEnterOTPPaymentVm.showBack = false;
            lifeInsuranceEnterOTPPaymentVm.showNext = true;
            lifeInsuranceEnterOTPPaymentVm.terms = false;
            lifeInsuranceEnterOTPPaymentVm.disableback = true;
           
            lifeInsuranceEnterOTPPaymentVm.selectedProduct = suggestedPlansDetailsService.getCurrentSugestedProduct();
            lifeInsuranceEnterOTPPaymentVm.productName = lifeInsuranceEnterOTPPaymentVm.selectedProduct.planName;
            var rupeeSymbol = String.fromCharCode(8377);
            lifeInsuranceEnterOTPPaymentVm.premiumAmount = rupeeSymbol + lifeInsuranceBasicApplicationService.getPayment().premiumAmount;
            var data = lifeInsuranceApplicationService.getAccoutDetails();
            lifeInsuranceEnterOTPPaymentVm.mobileNum = $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4);
           
        }

        lifeInsuranceEnterOTPPaymentVm.resendOTP = function() {
            lifeInsuranceEnterOTPPaymentVm.enterOTP = "";
            var reqParams = {};
            reqParams.id = "";
            reqParams.emailId = "";
            lifeInsuranceBasicApplicationService.getOTPTokenForPayNew().then(function(data) {
                lifeInsuranceEnterOTPPaymentVm.lifeInsuranceEnterOTPForm = {};
            });
        };
        //call for validate OTP at payment page
        lifeInsuranceEnterOTPPaymentVm.validateOTP = function() {
            var reqParams = {};
            var requestSecKey;
	    var requestDate = new Date();
        requestDate = requestDate.getTime();
	    requestSecKey=Math.floor((Math.random()) + requestDate);
	    requestSecKey = (requestSecKey * 10 + 1);
            reqParams.otp = lifeInsuranceEnterOTPPaymentVm.enterOTP;
            reqParams.secKey = requestSecKey;
            lifeInsuranceBasicApplicationService.validateOTPTokenForPayment(reqParams).then(function(data) { 
                    if(data.otpStatus == "Success"){
                        var calculatedKey = lifeInsuranceCommonService.verifySeckey(parseInt(data.secKey));
                        if(requestSecKey == calculatedKey){
                           utilityService.setCsatJournies('lifeInsurance');
                           $state.go("menu.lifeInsurancePaymentSuccess");
                        }    
                    }else if(data.otpStatus != "Success"){
                      lifeInsuranceEnterOTPPaymentVm.lifeInsuranceEnterOTPForm.enterOTP = data.otpStatus;
                    }else {
                    var alertPopup = $ionicPopup.alert({
                        title: '',
                        template: '<p class="roboto-regular font-content text-center">We are unable to process your request. Please try again later!</p>'
                    });
                }
                    //$state.go('menu.lifeInsurancePaynow');
            },function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        };

        //onclick of submit button
        lifeInsuranceEnterOTPPaymentVm.goToNextPage = function() {
            if (validateForm()) {
                lifeInsuranceEnterOTPPaymentVm.validateOTP();
            }
        };

        lifeInsuranceEnterOTPPaymentVm.closeJourney = function() {
            lifeInsuranceCommonService.closePopUp().then(function(result) {
                if (result) {
                    $state.go("menu.generalInsurance");
                }
            });
        };

        //conmmon validation function
        function validateForm() {
            lifeInsuranceEnterOTPPaymentVm.lifeInsuranceEnterOTPForm = {};
            if (lifeInsuranceEnterOTPPaymentVm.validateService.isValidOTPNum(lifeInsuranceEnterOTPPaymentVm.enterOTP)) {
                lifeInsuranceEnterOTPPaymentVm.lifeInsuranceEnterOTPForm.enterOTP = lifeInsuranceEnterOTPPaymentVm.validateService.isValidOTPNum(lifeInsuranceEnterOTPPaymentVm.enterOTP);
            }
            return (angular.equals({}, lifeInsuranceEnterOTPPaymentVm.lifeInsuranceEnterOTPForm)) ? true : false;
        };

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
