angularApp.controller('lifeInsurancePaynowController', [
    "$state",
    "$scope",
    "$translate",
    "premiumCalculationService",
    "validateService",
    "$ionicPopup",
    "lifeInsuranceBasicApplicationService",
    "suggestedPlansDetailsService",
    "lifeInsuranceApplicationService",
    "utilityService",
    "LiConstant",
    "clickStreamService","lifeInsuranceCommonService","constantConfig",


    function(
        $state,
        $scope,
        $translate,
        premiumCalculationService,
        validateService,
        $ionicPopup,
        lifeInsuranceBasicApplicationService,
        suggestedPlansDetailsService,
        lifeInsuranceApplicationService,
        utilityService,
        LiConstant,
        clickStreamService,lifeInsuranceCommonService,constantConfig) {

        var lifeInsurancePaynowVm = this;
        var e = $translate.instant('SelectMonthlyPremium');
        var payInfo;

        function initPage() {
            lifeInsurancePaynowVm.getTooltipContentLI();
            lifeInsurancePaynowVm.validateService = validateService;

            var selectedProduct = suggestedPlansDetailsService.getCurrentSugestedProduct();
            var account = {};

            lifeInsurancePaynowVm.planName = selectedProduct.planName;
            lifeInsurancePaynowVm.uin = selectedProduct.uin;
            lifeInsurancePaynowVm.ckAutoPayInLI = false;

            if(lifeInsuranceBasicApplicationService.getPaymentAccount()) {
                lifeInsurancePaynowVm.accounts = lifeInsuranceBasicApplicationService.getPaymentAccount();
                if (lifeInsurancePaynowVm.accounts.length > 0) {
                    lifeInsurancePaynowVm.selectedAccNumber = lifeInsurancePaynowVm.accounts[0];
                }
            }
            
            if (lifeInsurancePaynowVm.uin == LiConstant.productUIN.SMART_WEALTH_BUILDER) {
                var premData = premiumCalculationService.getPremiumCalculationSW();
            }

            if (lifeInsurancePaynowVm.uin == LiConstant.productUIN.SMART_MONEY_BACK_GOLD) {
                var premData = premiumCalculationService.getPremiumCalculationFData();
            }

            if (lifeInsurancePaynowVm.uin == LiConstant.productUIN.SMART_CHAMP_INSURANCE) {
                var premData = premiumCalculationService.getPremiumCalculationSC();
            }

            if (lifeInsurancePaynowVm.uin == LiConstant.productUIN.SHUBH_NIVESH) {
                var premData = premiumCalculationService.getPremiumCalculationSN();
            }

            if (lifeInsurancePaynowVm.uin == LiConstant.productUIN.SARAL_SWADHAN_PLUS) {
                var premData = premiumCalculationService.getPremiumCalculationSS();
            }

            if (lifeInsurancePaynowVm.uin == LiConstant.productUIN.RETIRE_SMART) {
                var premData = premiumCalculationService.getPremiumCalculationRS();
            }

            lifeInsurancePaynowVm.SelectedLIPayYrTenure = premData.policyTerm;
            lifeInsurancePaynowVm.quoteNumber = premData.quoteNumber;
            lifeInsurancePaynowVm.premFreq = premData.premiumFreq || premData.premFreq;
            if (lifeInsurancePaynowVm.premFreq.key == 'Monthly') {
                if(premData.premiumAmount){
                lifeInsurancePaynowVm.premiumAmount = 3 * Number(premData.premiumAmount);
            } else {
                lifeInsurancePaynowVm.premiumAmount = 3 * Number(premData.premium);
            } 
                lifeInsurancePaynowVm.monthlyPremium = e;
            } else {
                lifeInsurancePaynowVm.premiumAmount = premData.premiumAmount || premData.premium;
            }
            lifeInsurancePaynowVm.sumAssured = premData.sumAssured;
        };

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        lifeInsurancePaynowVm.goToNextPage = function() {
            if (validateForm()) {
                 checkForBalance();
            }
        };

        lifeInsurancePaynowVm.goBack = function() {
            $state.go('menu.lifeInsuranceUploadDocuments');
        };

        function checkForBalance() {
            var balance = parseInt(lifeInsurancePaynowVm.selectedAccNumber.balance);
            if (balance < lifeInsurancePaynowVm.premiumAmount) {
                var message = $translate.instant('NO_BALANCE_AMOUNT');
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    template: '<p class = "roboto-regular font-content text-center">' + message + '</p>'
                });
                alertPopup.then(function(res) {});
            } else {
                var message = $translate.instant('PAYMENT_CONFIRM');
                 var rupeeSymbol = String.fromCharCode(8377);
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    template: '<p class = "roboto-regular font-content text-center">' + message + ' ' + rupeeSymbol + lifeInsurancePaynowVm.premiumAmount + ' ?' + '</p>',
                    cssClass: 'bi-table',
                    buttons: [{
                     text: 'No',
                     type: 'button-negative',
                     onTap: function(e) {
                         return false;
                     }
                    }, {
                     text: 'Yes',
                     type: 'button-positive',
                     onTap: function(e) {
                        return true;
                    }
                }]
                });
                alertPopup.then(function(res) {
                if(res){
                    doPayment();
                }
                });
            }
        };

        function doPayment() {
            var requestSecKey;
	   var requestDate = new Date();
        requestDate = requestDate.getTime();
	    requestSecKey=Math.floor((Math.random()) + requestDate);
	    requestSecKey = (requestSecKey * 10 + 1);
            var requestObj = {};
            clickStreamService.clickStreamData = lifeInsurancePaynowVm.uin;
            requestObj.applicationNumber = lifeInsuranceApplicationService.getApplicationNumber();
            requestObj.proposalNumber = lifeInsuranceBasicApplicationService.getSubmitApplicationResponse().proposalNo;
            requestObj.premiumAmount = lifeInsurancePaynowVm.premiumAmount.toString();
            requestObj.accountHolderName = lifeInsurancePaynowVm.selectedAccNumber.benName;
            requestObj.accountNumber = lifeInsurancePaynowVm.selectedAccNumber.benAccntNo;
            requestObj.ifscCode = '';
            requestObj.isAutoPay = lifeInsurancePaynowVm.ckAutoPayInLI.toString();
            requestObj.panNumber = lifeInsuranceBasicApplicationService.getApplicationDetails().personalDetails.panNumber;
            requestObj.branchCode = lifeInsurancePaynowVm.selectedAccNumber.branchCode;
            requestObj.productName = lifeInsurancePaynowVm.planName;
            requestObj.premiumFreq = lifeInsurancePaynowVm.premFreq.key ? lifeInsurancePaynowVm.premFreq.key : '';
            requestObj.secKey = requestSecKey;
             requestObj.referralCode = lifeInsurancePaynowVm.refCode;

            lifeInsuranceBasicApplicationService.setPayment(requestObj);
            lifeInsuranceBasicApplicationService.payNewPolicy(requestObj).then(function(data) {
                if(data.isOTPRequired == "true"){
                  $state.go("menu.lifeInsuranceOTPforPayment");     
                }else{
                    var calculatedKey = lifeInsuranceCommonService.verifySeckey(parseInt(data.secKey));
                        if(requestSecKey == calculatedKey){
                           utilityService.setCsatJournies('lifeInsurance');
                           $state.go("menu.lifeInsurancePaymentSuccess");
                        }        
                }
               // $state.go("menu.lifeInsurancePaymentSuccess");  
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
               
        };


         lifeInsurancePaynowVm.getTooltipContentLI=function(){
            utilityService.showSpinner();
                 lifeInsuranceBasicApplicationService.getInfoContentForLI().then(function(response) {  
                if(response.infoList[0].key=='452374ef-c96a-4860-930d-60853bc887f5'){
                    utilityService.hideSpinner();
                    lifeInsurancePaynowVm.refCodeContentMessage=response.infoList[0].value;
                }else{
                     utilityService.hideSpinner();
                    lifeInsurancePaynowVm.refCodeContentMessage=constantConfig.mfAndsecConst.riskInfoEmptyText;
                }                       
                }, function(error) {
                     utilityService.hideSpinner();
                    lifeInsurancePaynowVm.refCodeContentMessage=constantConfig.mfAndsecConst.riskInfoEmptyText;

                });
            }

        /***Function to show information POP UP***/
	        lifeInsurancePaynowVm.showInformationPopupRef= function() {
	        	var infoPopup = $ionicPopup.show({
					template: '<p>'+lifeInsurancePaynowVm.refCodeContentMessage+'</p>',
					title:'Information',
					scope: $scope,
					cssClass: 'dialog',		
					buttons: [
		            {
		               text: 'Ok'
		            }
					]
				});

	            
	        }
        function validateForm() {
            lifeInsurancePaynowVm.frmPaymentSummary = {};
            if (lifeInsurancePaynowVm.validateService.isValidAccountNum(lifeInsurancePaynowVm.selectedAccNumber)) {
                lifeInsurancePaynowVm.frmPaymentSummary.selectedAccNumberVMsg = lifeInsurancePaynowVm.validateService.isValidAccountNum(lifeInsurancePaynowVm.selectedAccNumber);
            }
            return (angular.equals({}, lifeInsurancePaynowVm.frmPaymentSummary)) ? true : false;
        };

    }
]);
