angularApp.controller('lifeInsuranceUploadDocumentsController', [
    "$state",
    "$scope",
    "cameraService",
    "lifeInsuranceApplicationService",
    "lifeInsuranceBasicApplicationService",
    "premiumCalculationService",
    "validateService",
    "suggestedPlansDetailsService",
    "utilityService",
	"$rootScope",
    "clickStreamService",

    function(
        $state,
        $scope,
        cameraService,
        lifeInsuranceApplicationService,
        lifeInsuranceBasicApplicationService,
        premiumCalculationService,
        validateService,
        suggestedPlansDetailsService,
        utilityService,
		$rootScope,
        clickStreamService
    ) {

        var lifeInsuranceUploadDocumentsVm = this;
        lifeInsuranceUploadDocumentsVm.cameraService = cameraService;
        lifeInsuranceUploadDocumentsVm.validateService = validateService;


        function initPage() {

            lifeInsuranceUploadDocumentsVm.showBack = false;
            lifeInsuranceUploadDocumentsVm.showNext = true;
            lifeInsuranceUploadDocumentsVm.emailDoc = false;
            lifeInsuranceUploadDocumentsVm.clickedNext = false;
            var docs = lifeInsuranceBasicApplicationService.getPersonalDetails3();
            lifeInsuranceUploadDocumentsVm.incomeProof = docs.incomeProof.value;
            lifeInsuranceUploadDocumentsVm.ageProof = docs.ageProof.value;
            lifeInsuranceUploadDocumentsVm.domicile = docs.addressProof.value;
            lifeInsuranceUploadDocumentsVm.idProof = docs.idProof.value;

            lifeInsuranceUploadDocumentsVm.uin = suggestedPlansDetailsService.getCurrentSugestedProduct().uin;
            lifeInsuranceUploadDocumentsVm.selectedProduct = suggestedPlansDetailsService.getCurrentSugestedProduct().planName;

            lifeInsuranceUploadDocumentsVm.submitResponse = lifeInsuranceBasicApplicationService.getSubmitApplicationResponse();
            lifeInsuranceUploadDocumentsVm.quoteNum = premiumCalculationService.getQuoteNumber();
            lifeInsuranceUploadDocumentsVm.applicationNumber = lifeInsuranceApplicationService.getApplicationNumber();
        }

        // On click on next button
        lifeInsuranceUploadDocumentsVm.goToNextPage = function() {
            lifeInsuranceUploadDocumentsVm.clickedNext = true;
            clickStreamService.clickStreamData = lifeInsuranceUploadDocumentsVm.selectedProduct;
            if (validateForm()) {
                $state.go('menu.lifeInsurancePayment');
            }
        };

        function validateForm() {
            return lifeInsuranceUploadDocumentsVm.successPhoto;
        };

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        function isValidFileSize(data) {
            var fileSize = (data.length * 3 / 4) / 1024;
            if (fileSize >= 1024) {
                var title = '';
                var template = "<p> File size should be less than 1MB </p>";
                var onTap = '';
                var buttontext = "<b>OK</b>";
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                return false;
            } else {
                return true;
            }
        }

        lifeInsuranceUploadDocumentsVm.upAge = function() {
            lifeInsuranceUploadDocumentsVm.cameraService.getnewImage().then(function(data) {
                if (!isValidFileSize(data)) {
                    return;
                }
                if (lifeInsuranceBasicApplicationService.setUploadImageCount(0)) {
                    logout();
                }
                lifeInsuranceUploadDocumentsVm.camAge = data.replace('data:image/jpeg;base64,', '');
                lifeInsuranceUploadDocumentsVm.proposalNum = lifeInsuranceUploadDocumentsVm.submitResponse.proposalNo;
                lifeInsuranceUploadDocumentsVm.ageCode = 'X01';
                lifeInsuranceUploadDocumentsVm.filename = lifeInsuranceUploadDocumentsVm.proposalNum + "_" + lifeInsuranceUploadDocumentsVm.ageCode;
                var docs = {};
                docs.data = lifeInsuranceUploadDocumentsVm.camAge;
                docs.filename = lifeInsuranceUploadDocumentsVm.filename;
                docs.quoteNo = lifeInsuranceUploadDocumentsVm.quoteNum;
                docs.docName = lifeInsuranceUploadDocumentsVm.ageProof;
                docs.applicationNumber = lifeInsuranceUploadDocumentsVm.applicationNumber;
                lifeInsuranceBasicApplicationService.sendDocs(docs).then(function() {
                    lifeInsuranceUploadDocumentsVm.successAgeProof = true;
                }, function(error) {});
            });
        }

        lifeInsuranceUploadDocumentsVm.upAgeG = function() {
            lifeInsuranceUploadDocumentsVm.cameraService.getImageFromGallery().then(function(data) {
                if (!isValidFileSize(data)) {
                    return;
                }
                if (lifeInsuranceBasicApplicationService.setUploadImageCount(1)) {
                    logout();
                }
                lifeInsuranceUploadDocumentsVm.camAge = data.replace('data:image/jpeg;base64,', '');
                lifeInsuranceUploadDocumentsVm.proposalNum = lifeInsuranceUploadDocumentsVm.submitResponse.proposalNo;
                lifeInsuranceUploadDocumentsVm.ageCode = 'X01';
                lifeInsuranceUploadDocumentsVm.filename = lifeInsuranceUploadDocumentsVm.proposalNum + "_" + lifeInsuranceUploadDocumentsVm.ageCode;
                var docs = {};
                docs.data = lifeInsuranceUploadDocumentsVm.camAge;
                docs.filename = lifeInsuranceUploadDocumentsVm.filename;
                docs.quoteNo = lifeInsuranceUploadDocumentsVm.quoteNum;
                docs.docName = lifeInsuranceUploadDocumentsVm.ageProof;
                docs.applicationNumber = lifeInsuranceUploadDocumentsVm.applicationNumber;
                lifeInsuranceBasicApplicationService.sendDocs(docs).then(function() {
                    lifeInsuranceUploadDocumentsVm.successAgeProof = true;
                }, function(error) {});
            });
        }

        lifeInsuranceUploadDocumentsVm.upInc = function() {
            lifeInsuranceUploadDocumentsVm.cameraService.getnewImage().then(function(data) {
                if (!isValidFileSize(data)) {
                    return;
                }
                if (lifeInsuranceBasicApplicationService.setUploadImageCount(2)) {
                    logout();
                }
                lifeInsuranceUploadDocumentsVm.camInc = data.replace('data:image/jpeg;base64,', '');
                lifeInsuranceUploadDocumentsVm.proposalNum = lifeInsuranceUploadDocumentsVm.submitResponse.proposalNo;
                lifeInsuranceUploadDocumentsVm.ageCode = 'X04';
                lifeInsuranceUploadDocumentsVm.filename = lifeInsuranceUploadDocumentsVm.proposalNum + "_" + lifeInsuranceUploadDocumentsVm.ageCode;
                var docs = {};
                docs.data = lifeInsuranceUploadDocumentsVm.camInc;
                docs.filename = lifeInsuranceUploadDocumentsVm.filename;
                docs.quoteNo = lifeInsuranceUploadDocumentsVm.quoteNum;
                docs.docName = lifeInsuranceUploadDocumentsVm.incomeProof;
                docs.applicationNumber = lifeInsuranceUploadDocumentsVm.applicationNumber;
                lifeInsuranceBasicApplicationService.sendDocs(docs).then(function() {
                    lifeInsuranceUploadDocumentsVm.successIncomeProof = true;
                }, function(error) {});
            });

        }

        lifeInsuranceUploadDocumentsVm.upIncG = function() {
            lifeInsuranceUploadDocumentsVm.cameraService.getImageFromGallery().then(function(data) {
                if (!isValidFileSize(data)) {
                    return;
                }
                if (lifeInsuranceBasicApplicationService.setUploadImageCount(3)) {
                    logout();
                }
                lifeInsuranceUploadDocumentsVm.camInc = data.replace('data:image/jpeg;base64,', '');
                lifeInsuranceUploadDocumentsVm.proposalNum = lifeInsuranceUploadDocumentsVm.submitResponse.proposalNo;
                lifeInsuranceUploadDocumentsVm.ageCode = 'X04';
                lifeInsuranceUploadDocumentsVm.filename = lifeInsuranceUploadDocumentsVm.proposalNum + "_" + lifeInsuranceUploadDocumentsVm.ageCode;
                var docs = {};
                docs.data = lifeInsuranceUploadDocumentsVm.camInc;
                docs.filename = lifeInsuranceUploadDocumentsVm.filename;
                docs.quoteNo = lifeInsuranceUploadDocumentsVm.quoteNum;
                docs.docName = lifeInsuranceUploadDocumentsVm.incomeProof;
                docs.applicationNumber = lifeInsuranceUploadDocumentsVm.applicationNumber;
                lifeInsuranceBasicApplicationService.sendDocs(docs).then(function() {
                    lifeInsuranceUploadDocumentsVm.successIncomeProof = true;
                }, function(error) {});
            });

        }

        lifeInsuranceUploadDocumentsVm.upId = function() {
            lifeInsuranceUploadDocumentsVm.cameraService.getnewImage().then(function(data) {
                if (!isValidFileSize(data)) {
                    return;
                }
                if (lifeInsuranceBasicApplicationService.setUploadImageCount(4)) {
                    logout();
                }
                lifeInsuranceUploadDocumentsVm.camId = data.replace('data:image/jpeg;base64,', '');
                lifeInsuranceUploadDocumentsVm.proposalNum = lifeInsuranceUploadDocumentsVm.submitResponse.proposalNo;
                lifeInsuranceUploadDocumentsVm.ageCode = 'X02';
                lifeInsuranceUploadDocumentsVm.filename = lifeInsuranceUploadDocumentsVm.proposalNum + "_" + lifeInsuranceUploadDocumentsVm.ageCode;
                var docs = {};
                docs.data = lifeInsuranceUploadDocumentsVm.camId;
                docs.filename = lifeInsuranceUploadDocumentsVm.filename;
                docs.quoteNo = lifeInsuranceUploadDocumentsVm.quoteNum;
                docs.docName = lifeInsuranceUploadDocumentsVm.idProof;
                docs.applicationNumber = lifeInsuranceUploadDocumentsVm.applicationNumber;
                lifeInsuranceBasicApplicationService.sendDocs(docs).then(function() {
                    lifeInsuranceUploadDocumentsVm.successIdProof = true;
                }, function(error) {});
            });
        }

        lifeInsuranceUploadDocumentsVm.upIdG = function() {
            lifeInsuranceUploadDocumentsVm.cameraService.getImageFromGallery().then(function(data) {
                if (!isValidFileSize(data)) {
                    return;
                }
                if (lifeInsuranceBasicApplicationService.setUploadImageCount(5)) {
                    logout();
                }
                lifeInsuranceUploadDocumentsVm.camId = data.replace('data:image/jpeg;base64,', '');
                lifeInsuranceUploadDocumentsVm.proposalNum = lifeInsuranceUploadDocumentsVm.submitResponse.proposalNo;
                lifeInsuranceUploadDocumentsVm.ageCode = 'X02';
                lifeInsuranceUploadDocumentsVm.filename = lifeInsuranceUploadDocumentsVm.proposalNum + "_" + lifeInsuranceUploadDocumentsVm.ageCode;
                var docs = {};
                docs.data = lifeInsuranceUploadDocumentsVm.camId;
                docs.filename = lifeInsuranceUploadDocumentsVm.filename;
                docs.quoteNo = lifeInsuranceUploadDocumentsVm.quoteNum;
                docs.docName = lifeInsuranceUploadDocumentsVm.idProof;
                docs.applicationNumber = lifeInsuranceUploadDocumentsVm.applicationNumber;
                lifeInsuranceBasicApplicationService.sendDocs(docs).then(function() {
                    lifeInsuranceUploadDocumentsVm.successIdProof = true;
                }, function(error) {});
            });
        }

        lifeInsuranceUploadDocumentsVm.upAdd = function() {
            lifeInsuranceUploadDocumentsVm.cameraService.getnewImage().then(function(data) {
                if (!isValidFileSize(data)) {
                    return;
                }
                if (lifeInsuranceBasicApplicationService.setUploadImageCount(6)) {
                    logout();
                }
                lifeInsuranceUploadDocumentsVm.camAdd = data.replace('data:image/jpeg;base64,', '');
                lifeInsuranceUploadDocumentsVm.proposalNum = lifeInsuranceUploadDocumentsVm.submitResponse.proposalNo;
                lifeInsuranceUploadDocumentsVm.ageCode = 'X03';
                lifeInsuranceUploadDocumentsVm.filename = lifeInsuranceUploadDocumentsVm.proposalNum + "_" + lifeInsuranceUploadDocumentsVm.ageCode;
                var docs = {};
                docs.data = lifeInsuranceUploadDocumentsVm.camAdd;
                docs.filename = lifeInsuranceUploadDocumentsVm.filename;
                docs.quoteNo = lifeInsuranceUploadDocumentsVm.quoteNum;
                docs.docName = lifeInsuranceUploadDocumentsVm.domicile;
                docs.applicationNumber = lifeInsuranceUploadDocumentsVm.applicationNumber;
                lifeInsuranceBasicApplicationService.sendDocs(docs).then(function() {
                    lifeInsuranceUploadDocumentsVm.successAddressProof = true;
                }, function(error) {});
            });
        }

        lifeInsuranceUploadDocumentsVm.upAddG = function() {
            lifeInsuranceUploadDocumentsVm.cameraService.getImageFromGallery().then(function(data) {
                if (!isValidFileSize(data)) {
                    return;
                }
                if (lifeInsuranceBasicApplicationService.setUploadImageCount(7)) {
                    logout();
                }
                lifeInsuranceUploadDocumentsVm.camAdd = data.replace('data:image/jpeg;base64,', '');
                lifeInsuranceUploadDocumentsVm.proposalNum = lifeInsuranceUploadDocumentsVm.submitResponse.proposalNo;
                lifeInsuranceUploadDocumentsVm.ageCode = 'X03';
                lifeInsuranceUploadDocumentsVm.filename = lifeInsuranceUploadDocumentsVm.proposalNum + "_" + lifeInsuranceUploadDocumentsVm.ageCode;
                var docs = {};
                docs.data = lifeInsuranceUploadDocumentsVm.camAdd;
                docs.filename = lifeInsuranceUploadDocumentsVm.filename;
                docs.quoteNo = lifeInsuranceUploadDocumentsVm.quoteNum;
                docs.docName = lifeInsuranceUploadDocumentsVm.domicile;
                docs.applicationNumber = lifeInsuranceUploadDocumentsVm.applicationNumber;
                lifeInsuranceBasicApplicationService.sendDocs(docs).then(function() {
                    lifeInsuranceUploadDocumentsVm.successAddressProof = true;
                }, function(error) {});
            });
        }

        lifeInsuranceUploadDocumentsVm.upPhoto = function() {

            lifeInsuranceUploadDocumentsVm.cameraService.getnewImage().then(function(data) {
                if (!isValidFileSize(data)) {
                    return;
                }
                if (lifeInsuranceBasicApplicationService.setUploadImageCount(8)) {
                    logout();
                }
                lifeInsuranceUploadDocumentsVm.camPhoto = data.replace('data:image/jpeg;base64,', '');
                lifeInsuranceUploadDocumentsVm.proposalNum = lifeInsuranceUploadDocumentsVm.submitResponse.proposalNo;
                lifeInsuranceUploadDocumentsVm.ageCode = 'PROPOSER_IMG_LT';
                lifeInsuranceUploadDocumentsVm.filename = lifeInsuranceUploadDocumentsVm.applicationNumber + "_" + lifeInsuranceUploadDocumentsVm.ageCode;
                var docs = {};
                docs.data = lifeInsuranceUploadDocumentsVm.camPhoto;
                docs.filename = lifeInsuranceUploadDocumentsVm.filename;
                docs.quoteNo = lifeInsuranceUploadDocumentsVm.quoteNum;
                docs.applicationNumber = lifeInsuranceUploadDocumentsVm.applicationNumber;
                lifeInsuranceBasicApplicationService.sendDocs(docs).then(function() {
                    lifeInsuranceUploadDocumentsVm.successPhoto = true;
                }, function(error) {});
            });
        }

        lifeInsuranceUploadDocumentsVm.upPhotoG = function() {
            lifeInsuranceUploadDocumentsVm.cameraService.getImageFromGallery().then(function(data) {
                if (!isValidFileSize(data)) {
                    return;
                }
                if (lifeInsuranceBasicApplicationService.setUploadImageCount(9)) {
                    logout();
                }
                lifeInsuranceUploadDocumentsVm.camPhoto = data.replace('data:image/jpeg;base64,', '');
                lifeInsuranceUploadDocumentsVm.proposalNum = lifeInsuranceUploadDocumentsVm.submitResponse.proposalNo;
                lifeInsuranceUploadDocumentsVm.ageCode = 'PROPOSER_IMG_LT';
                lifeInsuranceUploadDocumentsVm.filename = lifeInsuranceUploadDocumentsVm.applicationNumber + "_" + lifeInsuranceUploadDocumentsVm.ageCode;
                var docs = {};
                docs.data = lifeInsuranceUploadDocumentsVm.camPhoto;
                docs.filename = lifeInsuranceUploadDocumentsVm.filename;
                docs.quoteNo = lifeInsuranceUploadDocumentsVm.quoteNum;
                docs.applicationNumber = lifeInsuranceUploadDocumentsVm.applicationNumber;
                lifeInsuranceBasicApplicationService.sendDocs(docs).then(function() {
                    lifeInsuranceUploadDocumentsVm.successPhoto = true;
                }, function(error) {});
            });
        }

        function logout() {
            var title = '';
            var template = "<p>You have crossed Max Limit for Upload Documents. You will be Logged Out</p>";
            var onTap = '';
            var buttontext = "<b>OK</b>";
            utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            logoutChallangeHandler();
            //$state.go("menu.userLogin");
			window.location = $rootScope.initialLocation;
        }
    }
]);
