angularApp.controller('lifeInsurancePaymentAccountDetailsController', [
    "$state",
    "$scope",
    "lifeInsuranceApplicationService",
    "premiumCalculationService",
    "lifeInsuranceBasicApplicationService",
    "lifeInsuranceCommonService",


    function(
        $state,
        $scope,
        lifeInsuranceApplicationService,
        premiumCalculationService,
        lifeInsuranceBasicApplicationService,
        lifeInsuranceCommonService
    ) {

        var lifeInsurancePaymentAccountDetailsVm = this;

        //private methods section start
        function initPage() {
            lifeInsurancePaymentAccountDetailsVm.disable = true;
            var account = {};

            lifeInsuranceApplicationService.getSBIBankAccounts(account).then(function(data) {
                lifeInsurancePaymentAccountDetailsVm.accDetails = data.beneficiaryList.ownAccounts;
                if (lifeInsurancePaymentAccountDetailsVm.accDetails.length > 0) {
                    lifeInsurancePaymentAccountDetailsVm.accountDetail = lifeInsurancePaymentAccountDetailsVm.accDetails[0];
                    lifeInsurancePaymentAccountDetailsVm.disable = false;
                } else {
                    lifeInsurancePaymentAccountDetailsVm.disable = true;
                }

                if (!lifeInsurancePaymentAccountDetailsVm.letsMakeFasterText) {
                    lifeInsuranceApplicationService.getLetsMakeFasterText().then(function(data) {
                        lifeInsurancePaymentAccountDetailsVm.letsMakeFasterText = data.message;
                    });
                }
            });
        }


        //private methods section end
        lifeInsurancePaymentAccountDetailsVm.goToApplication = function(agree) {
            var accountNumber = {
                "bankAccountNo": lifeInsurancePaymentAccountDetailsVm.accountDetail.benAccntNo
            }

            var bank = {
                "accountNumber": lifeInsurancePaymentAccountDetailsVm.accountDetail.benAccntNo,
                "accountType": lifeInsurancePaymentAccountDetailsVm.accountDetail.benAccntType,
                "branchName": lifeInsurancePaymentAccountDetailsVm.accountDetail.branchName,
                "branchCode": lifeInsurancePaymentAccountDetailsVm.accountDetail.branchCode
            };

            lifeInsuranceApplicationService.setSelectedAccount(lifeInsurancePaymentAccountDetailsVm.accountDetail);

            lifeInsuranceApplicationService.getSBIBankAccoutDetails(accountNumber).then(function(data) {
                if(data.cbsData.middleName){
                   bank.accountHolderName = data.cbsData.firstName + " " + data.cbsData.middleName + " " + data.cbsData.lastName;
                }
                if(data.cbsData.firstName || data.cbsData.lastName){
                   bank.accountHolderName = data.cbsData.firstName + " " + data.cbsData.lastName;   
                }
                lifeInsuranceApplicationService.getMasterData().then(function(data) {
                    lifeInsuranceApplicationService.setApplicationNumber("");
                    lifeInsuranceCommonService.setIsFromRetrieveApplication(false);
                    lifeInsuranceApplicationService.initializeNeedAnalysis();
                    premiumCalculationService.initializeBI();
                    lifeInsuranceBasicApplicationService.initializeApplication();
                    lifeInsuranceApplicationService.setBankAccountDetails(bank);
                    //lifeInsuranceApplicationService.saveNA().then(function() {
                        $state.go("menu.lifeInsuranceApplicationInfoPD", { agree: agree });
                    //});
                });
            });
        }

        lifeInsurancePaymentAccountDetailsVm.goBack = function() {
            $state.go('menu.helpMeChoosePolicy');
        };

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });
    }
]);
