angularApp.controller('retireSmartMedicalHistoryController', [
    "$state",
    "$scope",
    "validateService",
    "lifeInsuranceBasicApplicationService",
    "suggestedPlansDetailsService",
    "$stateParams",
    "lifeInsuranceApplicationService",
    "lifeInsuranceCommonService",
    "LiConstant",
    
    function(
        $state,
        $scope,
        validateService,
        lifeInsuranceBasicApplicationService,
        suggestedPlansDetailsService,
        $stateParams,
        lifeInsuranceApplicationService,
        lifeInsuranceCommonService,
        LiConstant) {

        var retireSmartMedicalHistoryVm = this;
        var medicalQuestions;
        var commonQuestionLength;
        var commonQuestion;
        var femaleQuestionLength;
        var femaleQuestion;

        function initPage() {
            retireSmartMedicalHistoryVm.answer = [];
            retireSmartMedicalHistoryVm.details = [];
            retireSmartMedicalHistoryVm.sub = [];
            retireSmartMedicalHistoryVm.validateService = validateService;
            retireSmartMedicalHistoryVm.showBack = true;
            retireSmartMedicalHistoryVm.showNext = true;
            retireSmartMedicalHistoryVm.disableBack = false;
            retireSmartMedicalHistoryVm.disableNext = false;

            retireSmartMedicalHistoryVm.gender = lifeInsuranceApplicationService.getPersonalDetails().gender.key;

            retireSmartMedicalHistoryVm.uin = suggestedPlansDetailsService.getCurrentSugestedProduct().uin;

            getMasterDataHealthSW();
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        retireSmartMedicalHistoryVm.updateHgtWt = function() {
            lifeInsuranceBasicApplicationService.setHgtWt(retireSmartMedicalHistoryVm.height, retireSmartMedicalHistoryVm.weight);
        };

        retireSmartMedicalHistoryVm.closeJourney = function() {
            lifeInsuranceCommonService.closePopUp().then(function(result) {
                if (result) {
                    $state.go("menu.generalInsurance");
                }
            });
        };

        retireSmartMedicalHistoryVm.goBacktoPrevious = function() {
            var start = parseInt(retireSmartMedicalHistoryVm.start) - 10;
            if (start < 0) {
                $state.go("menu.liForm_ProposersFATCA_CRS");
            } else {
                retireSmartMedicalHistoryVm.start = parseInt(retireSmartMedicalHistoryVm.start) - 10;

                $state.go("menu.retireSmartMedicalHistory", { start: retireSmartMedicalHistoryVm.start });
            }
        }



        var firstpopulate = function() {
            var j = parseInt(retireSmartMedicalHistoryVm.start);
            var k = 0;
            var i;
            for (i = j;
                (i < (j + 10)) && (i < commonQuestionLength); i++, k++) {
                if (commonQuestion[i].quesType == '2') {
                    retireSmartMedicalHistoryVm.answer[k] = undefined;
                } else {
                    retireSmartMedicalHistoryVm.answer[k] = '';
                }

                if (commonQuestion[i].subQues) {
                    for (var l = 0; l < commonQuestion[i].subQues.length; l++) {
                        retireSmartMedicalHistoryVm.sub[k] = {};
                        retireSmartMedicalHistoryVm.sub[k].details = [];
                        if (commonQuestion[i].subQues[l].quesType == '2') {
                            retireSmartMedicalHistoryVm.sub[k].details[l] = undefined;
                        } else {
                            retireSmartMedicalHistoryVm.sub[k].details[l] = '';
                        }
                    }
                }
            }
            return retireSmartMedicalHistoryVm;
        }

        retireSmartMedicalHistoryVm.update = function() {
            lifeInsuranceBasicApplicationService.setMedicalHistory(retireSmartMedicalHistoryVm);
        }

        var nextpopulate = function() {
            var preMedical = lifeInsuranceBasicApplicationService.getMedicalHistory().questions;
            if (lifeInsuranceBasicApplicationService.getMedicalHistory().height) {
                retireSmartMedicalHistoryVm.height = lifeInsuranceBasicApplicationService.getMedicalHistory().height;
            }
            if (lifeInsuranceBasicApplicationService.getMedicalHistory().weight) {
                retireSmartMedicalHistoryVm.weight = lifeInsuranceBasicApplicationService.getMedicalHistory().weight;
            }
            var j = parseInt(retireSmartMedicalHistoryVm.start);
            if (!preMedical[j]) {
                firstpopulate();
            } else {
                var i;
                var k = 0;
                for (i = j;
                    ((i < (j + 10)) && (i < commonQuestionLength)); i++, k++) {

                    retireSmartMedicalHistoryVm.answer[k] = preMedical[i].ans;
                    retireSmartMedicalHistoryVm.sub[k] = {};
                    retireSmartMedicalHistoryVm.sub[k].details = [];

                    if (preMedical[i].subAns) {
                        for (var l = 0; l < preMedical[i].subAns.length; l++) {
                            if (preMedical[i].subAns[l]) {
                                retireSmartMedicalHistoryVm.sub[k].details[l] = preMedical[i].subAns[l].ans;
                            }
                        }
                    }
                }
            }
            return retireSmartMedicalHistoryVm;
        }


        function getMasterDataHealthSW() {
            var a = lifeInsuranceBasicApplicationService.getMedicalQuestions();
            retireSmartMedicalHistoryVm.start = $stateParams.start || 0;
            commonQuestionLength = a.commonQues.length;
            commonQuestion = a.commonQues;
            nextpopulate();
            retireSmartMedicalHistoryVm.question = a.commonQues;
        }



        retireSmartMedicalHistoryVm.goToNextPage = function() {

            if (validateForm()) {
                lifeInsuranceBasicApplicationService.setMedicalHistory(retireSmartMedicalHistoryVm);
                var end = parseInt(retireSmartMedicalHistoryVm.start) + 10;

                if (end < commonQuestionLength) {
                    retireSmartMedicalHistoryVm.start = parseInt(retireSmartMedicalHistoryVm.start) + 10;
                    $state.go("menu.retireSmartMedicalHistory", { start: retireSmartMedicalHistoryVm.start });
                } else {
                    lifeInsuranceBasicApplicationService.setStart(retireSmartMedicalHistoryVm.start);
                    lifeInsuranceBasicApplicationService.saveApplication(LiConstant.journeyCommonId.APP_MEDICAL).then(function() {
                        if (retireSmartMedicalHistoryVm.gender == 'M') {
                            $state.go("menu.liForm_DiseaseDetails");
                        } else {
                            $state.go("menu.retireSmartMedicalHistory4");
                        }
                    });
                }
            }
        }

        //common validation function
        function validateForm() {
            retireSmartMedicalHistoryVm.retireSmartMedicalHistoryForm = {};
            retireSmartMedicalHistoryVm.retireSmartMedicalHistoryForm.answer = [];
            retireSmartMedicalHistoryVm.retireSmartMedicalHistoryForm.subQuestion = [];

            var j = parseInt(retireSmartMedicalHistoryVm.start);
            var isValid = true;
            var k = 0;
            var i;

            if (retireSmartMedicalHistoryVm.validateService.isValidWeight(retireSmartMedicalHistoryVm.weight) && (retireSmartMedicalHistoryVm.start == 0)) {
                retireSmartMedicalHistoryVm.retireSmartMedicalHistoryForm.weight = retireSmartMedicalHistoryVm.validateService.isValidWeight(retireSmartMedicalHistoryVm.weight);
                isValid = false;
            }

            if (retireSmartMedicalHistoryVm.validateService.isValidHeight(retireSmartMedicalHistoryVm.height) && (retireSmartMedicalHistoryVm.start == 0)) {
                retireSmartMedicalHistoryVm.retireSmartMedicalHistoryForm.height = retireSmartMedicalHistoryVm.validateService.isValidHeight(retireSmartMedicalHistoryVm.height);
                isValid = false;
            }


            for (i = j;
                ((i < (j + 10)) && (i < commonQuestionLength)); i++, k++) {
                retireSmartMedicalHistoryVm.retireSmartMedicalHistoryForm.subQuestion[k] = {};
                retireSmartMedicalHistoryVm.retireSmartMedicalHistoryForm.subQuestion[k].details = [];


                if (retireSmartMedicalHistoryVm.answer[k] == undefined && retireSmartMedicalHistoryVm.question[i].quesType == '2') {
                    if (retireSmartMedicalHistoryVm.validateService.isValidYesNo(retireSmartMedicalHistoryVm.answer[k])) {
                        retireSmartMedicalHistoryVm.retireSmartMedicalHistoryForm.answer[k] = retireSmartMedicalHistoryVm.validateService.isValidYesNo(retireSmartMedicalHistoryVm.answer[k]);
                        isValid = false;
                    }
                }

                if (retireSmartMedicalHistoryVm.validateService.isValiddetails(retireSmartMedicalHistoryVm.answer[k]) && retireSmartMedicalHistoryVm.question[i].quesType == '1') {
                    retireSmartMedicalHistoryVm.retireSmartMedicalHistoryForm.answer[k] = retireSmartMedicalHistoryVm.validateService.isValiddetails(retireSmartMedicalHistoryVm.answer[k]);
                    isValid = false;
                }



                if (retireSmartMedicalHistoryVm.question[i].subQues) {
                    for (var l = 0; l < retireSmartMedicalHistoryVm.question[i].subQues.length; l++) {
                        if (retireSmartMedicalHistoryVm.question[i].subQues[l].quesType == '2' && retireSmartMedicalHistoryVm.sub[k].details[l] == undefined) {
                            if (retireSmartMedicalHistoryVm.validateService.isValidYesNo(retireSmartMedicalHistoryVm.sub[k].details[l]) && (retireSmartMedicalHistoryVm.answer[k])) {
                                retireSmartMedicalHistoryVm.retireSmartMedicalHistoryForm.subQuestion[k].details[l] = retireSmartMedicalHistoryVm.validateService.isValidYesNo(retireSmartMedicalHistoryVm.sub[k].details[l]);
                                isValid = false;
                            }
                        }

                        if (retireSmartMedicalHistoryVm.question[i].subQues[l].quesType == '1') {
                            if (retireSmartMedicalHistoryVm.validateService.isValiddetails(retireSmartMedicalHistoryVm.sub[k].details[l]) && (retireSmartMedicalHistoryVm.answer[k])) {
                                retireSmartMedicalHistoryVm.retireSmartMedicalHistoryForm.subQuestion[k].details[l] = retireSmartMedicalHistoryVm.validateService.isValiddetails(retireSmartMedicalHistoryVm.sub[k].details[l]);
                                isValid = false;
                            }
                        }

                        if (retireSmartMedicalHistoryVm.answer[k] && retireSmartMedicalHistoryVm.question[i].subQues[l].quesType == '1' && retireSmartMedicalHistoryVm.question[i].subQues[l].id == 'hm_visible_ID_mark_detail') {
                            if (retireSmartMedicalHistoryVm.validateService.isValidAlphabets(retireSmartMedicalHistoryVm.sub[k].details[l])) {
                                retireSmartMedicalHistoryVm.retireSmartMedicalHistoryForm.subQuestion[k].details[l] = retireSmartMedicalHistoryVm.validateService.isValidAlphabets(retireSmartMedicalHistoryVm.sub[k].details[l]);
                                isValid = false;
                            }
                        }
                    }
                }
            }
            return isValid;
        }
    }
]);
