angularApp.controller('retireSmartMedicalHistoryController4', [
    "$state",
    "$scope",
    "validateService",
    "lifeInsuranceBasicApplicationService",
    "lifeInsuranceApplicationService",
    "$filter",
    "lifeInsuranceCommonService",
    "suggestedPlansDetailsService",
    "LiConstant",


    function(
        $state,
        $scope,
        validateService,
        lifeInsuranceBasicApplicationService,
        lifeInsuranceApplicationService,
        $filter,
        lifeInsuranceCommonService,
        suggestedPlansDetailsService,
        LiConstant) {

        var retireSmartMedicalHistoryVm4 = this;
        var femaleQuestions;
        retireSmartMedicalHistoryVm4.validateService = validateService;
        var next;

        function initPage() {

            retireSmartMedicalHistoryVm4.showBack = true;
            retireSmartMedicalHistoryVm4.showNext = true;
            retireSmartMedicalHistoryVm4.disableBack = false;
            retireSmartMedicalHistoryVm4.disableNext = false;
            retireSmartMedicalHistoryVm4.femAnswer = [];
            retireSmartMedicalHistoryVm4.sub = [];
            retireSmartMedicalHistoryVm4.gender = lifeInsuranceBasicApplicationService.getPersonalDetails1().gender.key;
            retireSmartMedicalHistoryVm4.married = lifeInsuranceBasicApplicationService.getPersonalDetails1().maritalStatus;

            retireSmartMedicalHistoryVm4.uin = suggestedPlansDetailsService.getCurrentSugestedProduct().uin;

            var currentDate = validateService.getCurrentDate();

            retireSmartMedicalHistoryVm4.maxEndDate = $filter('chosenDate')(validateService.getFutureDate(currentDate, 0));
            retireSmartMedicalHistoryVm4.minEndDate = $filter('chosenDate')(validateService.getFutureDate(currentDate, -36500));

            getMasterDataFemques();

            if (lifeInsuranceBasicApplicationService.getfemaleQuestionLength()) {
                prepopulate();
            } else {
                firstpopulate();
            }

        }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        retireSmartMedicalHistoryVm4.closeJourney = function() {
            lifeInsuranceCommonService.closePopUp().then(function(result) {
                if (result) {
                    $state.go("menu.generalInsurance");
                }
            });
        };

        var prepopulate = function() {
            var preMedical = lifeInsuranceBasicApplicationService.getMedicalHistory().questions;
            var start = lifeInsuranceBasicApplicationService.getcommonQuestionLength();
            var total = parseInt(lifeInsuranceBasicApplicationService.getfemaleQuestionLength()) + start;

            var k = 0;
            var i;
            for (i = start; i < total; i++, k++) {
                retireSmartMedicalHistoryVm4.femAnswer[k] = preMedical[i].ans;
                retireSmartMedicalHistoryVm4.sub[k] = {};
                retireSmartMedicalHistoryVm4.sub[k].details = [];
                if (preMedical[i].subAns) {
                    for (var l = 0; l < preMedical[i].subAns.length; l++) {
                        if (preMedical[i].subAns[l].ans) {
                            retireSmartMedicalHistoryVm4.sub[k].details[l] = preMedical[i].subAns[l].ans;
                        }
                    }
                }
            }
            return retireSmartMedicalHistoryVm4;
        }

        var firstpopulate = function() {
            var start = lifeInsuranceBasicApplicationService.getcommonQuestionLength();
            femaleQuestions = lifeInsuranceBasicApplicationService.getMedicalQuestions().femaleAdditionalQues;
            var total = parseInt(femaleQuestions.length) + start;
            var k = 0;
            var i;
            for (i = start; i < total; i++, k++) {
                if (femaleQuestions[k].quesType == '1') {
                    retireSmartMedicalHistoryVm4.femAnswer[k] = '';
                } else {
                    retireSmartMedicalHistoryVm4.femAnswer[k] = undefined;

                }
                retireSmartMedicalHistoryVm4.sub[k] = {};
                retireSmartMedicalHistoryVm4.sub[k].details = [];

                if (femaleQuestions[k].subQues) {
                    for (var l = 0; l < femaleQuestions[k].subQues.length; l++) {
                        if (femaleQuestions[k].subQues[l].quesType == '2') {
                            retireSmartMedicalHistoryVm4.sub[k].details[l] = undefined;
                        } else {
                            retireSmartMedicalHistoryVm4.sub[k].details[l] = '';
                        }
                    }
                }
            }
            return retireSmartMedicalHistoryVm4;
        }



        retireSmartMedicalHistoryVm4.goBacktoPrevious = function() {
            var newStart = lifeInsuranceBasicApplicationService.getMedicalQuestions().commonQues.length;
            var newStart = parseInt(newStart / 10) * 10; //parseInt(lifeInsuranceBasicApplicationService.getStart());            
            $state.go("menu.retireSmartMedicalHistory", { start: newStart });
        }



        function getMasterDataFemques() {
            femaleQuestions = lifeInsuranceBasicApplicationService.getMedicalQuestions().femaleAdditionalQues;
            retireSmartMedicalHistoryVm4.Femquestion = femaleQuestions;
        };



        //onclick of submit button

        retireSmartMedicalHistoryVm4.goToNextPage = function() {
            if (validateForm()) {
                lifeInsuranceBasicApplicationService.setMedicalHistoryFemale(retireSmartMedicalHistoryVm4);
                lifeInsuranceBasicApplicationService.saveApplication(LiConstant.journeyCommonId.APP_MEDICAL_FEMALE).then(function() {
                    $state.go("menu.liForm_DiseaseDetails");
                });
            }
        }

        //common validation function
        function validateForm() {
            retireSmartMedicalHistoryVm4.retireSmartMedicalHistoryForm = {};
            retireSmartMedicalHistoryVm4.retireSmartMedicalHistoryForm.test = [];
            retireSmartMedicalHistoryVm4.retireSmartMedicalHistoryForm.sub = [];
            var isValid = true;

            for (var i = 0; i < retireSmartMedicalHistoryVm4.Femquestion.length; i++) {
                retireSmartMedicalHistoryVm4.retireSmartMedicalHistoryForm.sub[i] = {};
                retireSmartMedicalHistoryVm4.retireSmartMedicalHistoryForm.sub[i].details = [];

                if (retireSmartMedicalHistoryVm4.Femquestion[i].quesType == '1') {
                    if (retireSmartMedicalHistoryVm4.Femquestion[i].id == '71') {
                        if (retireSmartMedicalHistoryVm4.validateService.isValidinsdetails(retireSmartMedicalHistoryVm4.femAnswer[i])) {
                            retireSmartMedicalHistoryVm4.retireSmartMedicalHistoryForm.test[i] = retireSmartMedicalHistoryVm4.validateService.isValidinsdetails(retireSmartMedicalHistoryVm4.femAnswer[i]);
                            isValid = false;
                        }
                    } else if (retireSmartMedicalHistoryVm4.Femquestion[i].id == 'HD_HUSBAND_ANNUAL_INCOME' && retireSmartMedicalHistoryVm4.married == "Married") {
                        if (retireSmartMedicalHistoryVm4.validateService.isValidHusincome(retireSmartMedicalHistoryVm4.femAnswer[i])) {
                            retireSmartMedicalHistoryVm4.retireSmartMedicalHistoryForm.test[i] = retireSmartMedicalHistoryVm4.validateService.isValidHusincome(retireSmartMedicalHistoryVm4.femAnswer[i]);
                            isValid = false;
                        }
                        // } else if ((retireSmartMedicalHistoryVm4.Femquestion[i].id == '116') || (retireSmartMedicalHistoryVm4.Femquestion[i].id == 'hd_preg_last_delivery_date')) {
                        //     if (retireSmartMedicalHistoryVm4.validateService.isValidbirthDate(retireSmartMedicalHistoryVm4.femAnswer[i])) {
                        //         retireSmartMedicalHistoryVm4.retireSmartMedicalHistoryForm.test[i] = retireSmartMedicalHistoryVm4.validateService.isValidbirthDate(retireSmartMedicalHistoryVm4.femAnswer[i]);
                        //         isValid = false;
                        //     }
                    } else if (retireSmartMedicalHistoryVm4.validateService.isValiddetails(retireSmartMedicalHistoryVm4.femAnswer[i]) && (retireSmartMedicalHistoryVm4.Femquestion[i].id !== '116') && (retireSmartMedicalHistoryVm4.Femquestion[i].id !== 'hd_preg_last_delivery_date') && (retireSmartMedicalHistoryVm4.Femquestion[i].id !== 'HD_HUSBAND_ANNUAL_INCOME') && (retireSmartMedicalHistoryVm4.Femquestion[i].id !== '71')) {
                        retireSmartMedicalHistoryVm4.retireSmartMedicalHistoryForm.test[i] = retireSmartMedicalHistoryVm4.validateService.isValiddetails(retireSmartMedicalHistoryVm4.femAnswer[i]);
                        isValid = false;
                    }
                }

                if (retireSmartMedicalHistoryVm4.femAnswer[i] == undefined && retireSmartMedicalHistoryVm4.Femquestion[i].quesType == '2') {
                    if (retireSmartMedicalHistoryVm4.validateService.isValidYesNo(retireSmartMedicalHistoryVm4.femAnswer[i])) {
                        retireSmartMedicalHistoryVm4.retireSmartMedicalHistoryForm.test[i] = retireSmartMedicalHistoryVm4.validateService.isValidYesNo(retireSmartMedicalHistoryVm4.femAnswer[i]);
                        isValid = false;
                    }
                }

                // Sub Question Answer Validation
                if (retireSmartMedicalHistoryVm4.Femquestion[i].subQues) {
                    for (var l = 0; l < retireSmartMedicalHistoryVm4.Femquestion[i].subQues.length; l++) {
                        if ((retireSmartMedicalHistoryVm4.Femquestion[i].subQues[l].quesType == '2') && (retireSmartMedicalHistoryVm4.sub[i].details[l] == undefined) && (retireSmartMedicalHistoryVm4.femAnswer[i])) {
                            if (retireSmartMedicalHistoryVm4.validateService.isValidYesNo(retireSmartMedicalHistoryVm4.sub[i].details[l])) {
                                retireSmartMedicalHistoryVm4.retireSmartMedicalHistoryForm.sub[i].details[l] = retireSmartMedicalHistoryVm4.validateService.isValidYesNo(retireSmartMedicalHistoryVm4.sub[i].details[l]);
                                isValid = false;
                            }
                        }

                        if (retireSmartMedicalHistoryVm4.Femquestion[i].subQues[l].quesType == '1' && (retireSmartMedicalHistoryVm4.femAnswer[i])) {
                            if (retireSmartMedicalHistoryVm4.validateService.isValiddetails(retireSmartMedicalHistoryVm4.sub[i].details[l])) {
                                retireSmartMedicalHistoryVm4.retireSmartMedicalHistoryForm.sub[i].details[l] = retireSmartMedicalHistoryVm4.validateService.isValiddetails(retireSmartMedicalHistoryVm4.sub[i].details[l]);
                                isValid = false;
                            }
                        }
                        if (retireSmartMedicalHistoryVm4.Femquestion[i].subQues[l].quesType == '4' && (retireSmartMedicalHistoryVm4.femAnswer[i])) {
                            if (retireSmartMedicalHistoryVm4.validateService.isValidDate(retireSmartMedicalHistoryVm4.sub[i].details[l])) {
                                retireSmartMedicalHistoryVm4.retireSmartMedicalHistoryForm.sub[i].details[l] = retireSmartMedicalHistoryVm4.validateService.isValidDate(retireSmartMedicalHistoryVm4.sub[i].details[l]);
                                isValid = false;
                            }
                        }
                    }
                }
            }
            return isValid;
        }

    }
]);
