angularApp.controller('declarationOfLIController', [
    "$state",
    "$scope",
    "suggestedPlansDetailsService",
    "lifeInsuranceApplicationService",
    "lifeInsuranceBasicApplicationService","clickStreamService",
    function(
        $state,
        $scope,
        suggestedPlansDetailsService,
        lifeInsuranceApplicationService,
        lifeInsuranceBasicApplicationService,
        clickStreamService) {

        var declarationOfLIVm = this;
        //private methods section start
        function initPage() {

            declarationOfLIVm.showBack = true;
            declarationOfLIVm.showNext = true;
            declarationOfLIVm.disableBack = false;
            declarationOfLIVm.disableNext = false;

            var personalDetail = lifeInsuranceApplicationService.getPersonalDetails();
            if (personalDetail) {
                declarationOfLIVm.name = personalDetail.name.first;
                if (personalDetail.name.middle) {
                    declarationOfLIVm.name = declarationOfLIVm.name + " " + personalDetail.name.middle;
                }
                if (personalDetail.name.last) {
                    declarationOfLIVm.name = declarationOfLIVm.name + " " + personalDetail.name.last;
                }
            }

            declarationOfLIVm.selectedProduct = suggestedPlansDetailsService.getCurrentSugestedProduct();

            declarationOfLIVm.declaration = lifeInsuranceApplicationService.getPremiumAcceptanceMessage();
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });


        $scope.$on('$ionicView.enter', function() {
            if (declarationOfLIVm.declaration && declarationOfLIVm.selectedProduct) {
                var elements = document.querySelectorAll('[id="cusname"]');

                for (var i = 0; i < elements.length; i++) {
                    elements[i].innerHTML = declarationOfLIVm.name;
                }
                document.getElementById('policyname').innerHTML = declarationOfLIVm.selectedProduct.planName;
                document.getElementById('policyuin').innerHTML = declarationOfLIVm.selectedProduct.uin;
            }
        });

        // On click of Back button
        declarationOfLIVm.goBacktoPrevious = function() {
            $state.go("menu.premiumCalculation3");
        }

        // On click of Next button
        declarationOfLIVm.goToNextPage = function() {
            clickStreamService.clickStreamData = declarationOfLIVm.selectedProduct.planName; 
            lifeInsuranceBasicApplicationService.getApplicationMasterData().then(function() {
                $state.go('menu.lifeInsuranceBasicInformation');
            });
        }
    }
]);
