angularApp.controller('premiumCalculation2Controller', [
    "$state",
    "$scope",
    "premiumCalculationService",
    "validateService",
    "lifeInsuranceCommonService",
    "utilityService",
    "LiConstant",
    "$translate",

    function(
        $state,
        $scope,
        premiumCalculationService,
        validateService,
        lifeInsuranceCommonService,
        utilityService,
        LiConstant,
        $translate) {

        //functions, variables that can be accessed from the HTML come here
        var premiumCalculation2Vm = this;
        premiumCalculation2Vm.validateService = validateService;


        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });


        function initPage() {

            premiumCalculation2Vm.data = {};
            premiumCalculation2Vm.data.pta = {};
            premiumCalculation2Vm.data.adb = {};
            premiumCalculation2Vm.data.atp = {};
            premiumCalculation2Vm.data.cc13 = {};

            var dataPrev = premiumCalculationService.getPremiumCalculationFData();

            premiumCalculation2Vm.sumAssured = dataPrev.sumAssured;
            premiumCalculation2Vm.maxTerm = dataPrev.policyTerm;
            premiumCalculation2Vm.age = dataPrev.age;

            if (dataPrev.pta ||
                dataPrev.adb ||
                dataPrev.atp ||
                dataPrev.cc13) {
                premiumCalculation2Vm.data.isPTARider = dataPrev.isPTARider;
                premiumCalculation2Vm.data.isADBRider = dataPrev.isADBRider;
                premiumCalculation2Vm.data.isATPDBRider = dataPrev.isATPDBRider;
                premiumCalculation2Vm.data.isCC13Rider = dataPrev.isCC13Rider;
                premiumCalculation2Vm.data.adb = dataPrev.adb;
                premiumCalculation2Vm.data.pta = dataPrev.pta;
                premiumCalculation2Vm.data.atp = dataPrev.atp;
                premiumCalculation2Vm.data.cc13 = dataPrev.cc13;
            }

        };

        premiumCalculation2Vm.closeJourney = function() {
            lifeInsuranceCommonService.closePopUp().then(function(result) {
                if (result) {
                    $state.go("menu.generalInsurance");
                }
            });
        };

        premiumCalculation2Vm.goBacktoPrevious = function() {
            $state.go("menu.smartMoneyBackGoldPremiumCalculation");
        }

        premiumCalculation2Vm.showPTARider = function() {
            var message = $translate.instant('PTA_RIDER_INFO');
            var title = '';
            var template = "<p class='roboto-regular font-content text-left'>"+ message +"</p>";
            var onTap = '';
            var buttontext = "<b>OK</b>";
            utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
        }


        premiumCalculation2Vm.showADBRider = function() {
            var message = $translate.instant('ADB_RIDER_INFO');
            var title = '';
            var template = "<p class='roboto-regular font-content text-left'>"+ message +"</p> ";
            var onTap = '';
            var buttontext = "<b>OK</b>";
            utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
        }

        premiumCalculation2Vm.showATPDBRider = function() {
            var message = $translate.instant('ATPDB_RIDER_INFO');
            var title = '';
            var template = "<p class='roboto-regular font-content text-left'>"+ message +"</p> ";
            var onTap = '';
            var buttontext = "<b>OK</b>";
            utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
        }

        premiumCalculation2Vm.showCC13Rider = function() {
            var message = $translate.instant('CC13_RIDER_INFO');
            var title = '';
            var template = "<p class='roboto-regular font-content text-left'>"+ message +"</p> ";
            var onTap = '';
            var buttontext = "<b>OK</b>";
            utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
        }

        premiumCalculation2Vm.Calculate = function() {
            if (validateForm()) {
                var totalRiderPremium = (premiumCalculation2Vm.data.pta.sumAssured  ? Number(premiumCalculation2Vm.data.pta.sumAssured) : 0) + (premiumCalculation2Vm.data.adb.sumAssured ? Number(premiumCalculation2Vm.data.adb.sumAssured) :0 ) +  (premiumCalculation2Vm.data.atp.sumAssured ? Number(premiumCalculation2Vm.data.atp.sumAssured) : 0 ) + (premiumCalculation2Vm.data.cc13.sumAssured ? Number(premiumCalculation2Vm.data.cc13.sumAssured) : 0);
                var selectPremium;
               if(premiumCalculation2Vm.data.isPTARider ||premiumCalculation2Vm.data.isADBRider || premiumCalculation2Vm.data.isATPDBRider || premiumCalculation2Vm.data.isCC13Rider){
                    selectPremium =  false;
               }else{
                    selectPremium = true ; 
               }

                if (premiumCalculation2Vm.validateService.isValidRiderPremium(totalRiderPremium, premiumCalculation2Vm.sumAssured, 30) || selectPremium) {
                    var data = premiumCalculationService.getPremiumCalculationFData();

                    data.pta = {};

                    if (!premiumCalculation2Vm.data.isPTARider) {
                        data.isPTARider = false;
                    } else { data.isPTARider = premiumCalculation2Vm.data.isPTARider; }

                    if (!premiumCalculation2Vm.data.isADBRider) {
                        data.isADBRider = false;
                    } else { data.isADBRider = premiumCalculation2Vm.data.isADBRider; }

                    if (!premiumCalculation2Vm.data.isATPDBRider) {
                        data.isATPDBRider = false;
                    } else { data.isATPDBRider = premiumCalculation2Vm.data.isATPDBRider; }
                    if (!premiumCalculation2Vm.data.isCC13Rider) {
                        data.isCC13Rider = false;
                    } else { data.isCC13Rider = premiumCalculation2Vm.data.isCC13Rider; }
                    data.pta.term = premiumCalculation2Vm.data.pta.term;
                    premiumCalculation2Vm.newPTARiderSumAssuredPreferredTermAssuranceRider = premiumCalculation2Vm.data.pta.sumAssured;
                    data.pta.sumAssured = premiumCalculation2Vm.newPTARiderSumAssuredPreferredTermAssuranceRider;
                    data.adb = {};
                    data.adb.term = premiumCalculation2Vm.data.adb.term;
                    premiumCalculation2Vm.newADBRiderSumAssured = premiumCalculation2Vm.data.adb.sumAssured;
                    data.adb.sumAssured = premiumCalculation2Vm.newADBRiderSumAssured;
                    data.atp = {};
                    data.atp.term = premiumCalculation2Vm.data.atp.term;
                    premiumCalculation2Vm.newAPDBRiderSumAssured = premiumCalculation2Vm.data.atp.sumAssured;
                    data.atp.sumAssured = premiumCalculation2Vm.newAPDBRiderSumAssured;
                    data.cc13 = {};
                    data.cc13.term = premiumCalculation2Vm.data.cc13.term;
                    premiumCalculation2Vm.newCritiCareNonLinkedRiderAmt = premiumCalculation2Vm.data.cc13.sumAssured;
                    data.cc13.sumAssured = premiumCalculation2Vm.newCritiCareNonLinkedRiderAmt;
                    premiumCalculationService.setPremiumCalculationFData2(data);
                    premiumCalculationService.saveBI(LiConstant.journeyCommonId.PC_SMBG_2).then(function() {
                        premiumCalculationService.submitPremiumCalculationData().then(function(data) {
                            premiumCalculationService.setPremiumCalculationResponse(data);

                            $state.go("menu.premiumCalculation3");
                        });
                    });
                }else{
                         var title  = "";
                         var buttontext = "OK";
                         var blankdata = null;
                         var detail =  $translate.instant('RiderErrorMsg30');
                         utilityService.showAlertModal(title, detail, blankdata, blankdata, $state, buttontext)
                }

            }
        };

        premiumCalculation2Vm.upPTA1 = function() {
            if (!premiumCalculation2Vm.data.isPTARider) {
                premiumCalculation2Vm.data.pta.term = "";
                premiumCalculation2Vm.data.pta.sumAssured = '';
            }

        }
        premiumCalculation2Vm.upPTA2 = function() {
            if (!premiumCalculation2Vm.data.isADBRider) {
                premiumCalculation2Vm.data.adb.term = "";
                premiumCalculation2Vm.data.adb.sumAssured = '';
            }

        }
        premiumCalculation2Vm.upPTA3 = function() {
            if (!premiumCalculation2Vm.data.isATPDBRider) {
                premiumCalculation2Vm.data.atp.term = "";
                premiumCalculation2Vm.data.atp.sumAssured = '';
            }

        }
        premiumCalculation2Vm.upPTA4 = function() {
            if (!premiumCalculation2Vm.data.isCC13Rider) {
                premiumCalculation2Vm.data.cc13.term = "";
                premiumCalculation2Vm.data.cc13.sumAssured = '';
            }

        }

        //common validation function
        function validateForm() {

            premiumCalculation2Vm.frmPremiumCalculation2 = {};
            if (premiumCalculation2Vm.validateService.isPTARiderTerm(premiumCalculation2Vm.data.pta.term, premiumCalculation2Vm.data.isPTARider, premiumCalculation2Vm.maxTerm)) {
                premiumCalculation2Vm.frmPremiumCalculation2.PTARiderTermPreferredTermAssuranceRiderVMsg = premiumCalculation2Vm.validateService.isPTARiderTerm(premiumCalculation2Vm.data.pta.term, premiumCalculation2Vm.data.isPTARider, premiumCalculation2Vm.maxTerm);

            }
            if (premiumCalculation2Vm.validateService.isPTARiderSumAssuredADBRiderSM(premiumCalculation2Vm.data.pta.sumAssured, premiumCalculation2Vm.sumAssured, premiumCalculation2Vm.data.isPTARider, premiumCalculation2Vm.age)) {
                premiumCalculation2Vm.frmPremiumCalculation2.PTARiderSumAssuredPreferredTermAssuranceRiderVMsg = premiumCalculation2Vm.validateService.isPTARiderSumAssuredADBRiderSM(premiumCalculation2Vm.data.pta.sumAssured, premiumCalculation2Vm.sumAssured, premiumCalculation2Vm.data.isPTARider, premiumCalculation2Vm.age);

            }
            if (premiumCalculation2Vm.validateService.isPTARiderTermAD(premiumCalculation2Vm.data.adb.term, premiumCalculation2Vm.data.isADBRider, premiumCalculation2Vm.maxTerm)) {
                premiumCalculation2Vm.frmPremiumCalculation2.PTARiderTermPreferredTermAssuranceRiderADVMsg = premiumCalculation2Vm.validateService.isPTARiderTermAD(premiumCalculation2Vm.data.adb.term, premiumCalculation2Vm.data.isADBRider, premiumCalculation2Vm.maxTerm);

            }
            if (premiumCalculation2Vm.validateService.isPTARiderTermADis(premiumCalculation2Vm.data.atp.term, premiumCalculation2Vm.data.isATPDBRider, premiumCalculation2Vm.maxTerm)) {
                premiumCalculation2Vm.frmPremiumCalculation2.PTARiderTermPreferredTermAssuranceRiderADisVMsg = premiumCalculation2Vm.validateService.isPTARiderTermADis(premiumCalculation2Vm.data.atp.term, premiumCalculation2Vm.data.isATPDBRider, premiumCalculation2Vm.maxTerm);

            }
            if (premiumCalculation2Vm.validateService.isPTARiderSumAssuredADBRiderSM(premiumCalculation2Vm.data.adb.sumAssured, premiumCalculation2Vm.sumAssured, premiumCalculation2Vm.data.isADBRider, premiumCalculation2Vm.age)) {
                premiumCalculation2Vm.frmPremiumCalculation2.PTARiderSumAssuredADBRiderSumAssuredVMsg = premiumCalculation2Vm.validateService.isPTARiderSumAssuredADBRiderSM(premiumCalculation2Vm.data.adb.sumAssured, premiumCalculation2Vm.sumAssured, premiumCalculation2Vm.data.isADBRider, premiumCalculation2Vm.age);
            }
            if (premiumCalculation2Vm.validateService.isPTARiderSumAssuredADBRiderSM(premiumCalculation2Vm.data.atp.sumAssured, premiumCalculation2Vm.sumAssured, premiumCalculation2Vm.data.isATPDBRider, premiumCalculation2Vm.age)) {
                premiumCalculation2Vm.frmPremiumCalculation2.PTARiderSumAssuredAPDBRiderSumAssuredVMsg = premiumCalculation2Vm.validateService.isPTARiderSumAssuredADBRiderSM(premiumCalculation2Vm.data.atp.sumAssured, premiumCalculation2Vm.sumAssured, premiumCalculation2Vm.data.isATPDBRider, premiumCalculation2Vm.age);
            }
            if (premiumCalculation2Vm.validateService.isPTARiderTermADis(premiumCalculation2Vm.data.cc13.term, premiumCalculation2Vm.data.isCC13Rider, premiumCalculation2Vm.maxTerm)) {
                premiumCalculation2Vm.frmPremiumCalculation2.CritiCareNonLinkedRiderVMsg = premiumCalculation2Vm.validateService.isPTARiderTermADis(premiumCalculation2Vm.data.cc13.term, premiumCalculation2Vm.data.isCC13Rider, premiumCalculation2Vm.maxTerm);
            }
            if (premiumCalculation2Vm.validateService.isPTARiderSumAssuredCC(premiumCalculation2Vm.data.cc13.sumAssured, premiumCalculation2Vm.sumAssured, premiumCalculation2Vm.data.isCC13Rider, premiumCalculation2Vm.age, premiumCalculation2Vm.data.cc13.term)) {
                premiumCalculation2Vm.frmPremiumCalculation2.CritiCareNonLinkedRiderAmtVMsg = premiumCalculation2Vm.validateService.isPTARiderSumAssuredCC(premiumCalculation2Vm.data.cc13.sumAssured, premiumCalculation2Vm.sumAssured, premiumCalculation2Vm.data.isCC13Rider, premiumCalculation2Vm.age, premiumCalculation2Vm.data.cc13.term);
            }

            return (angular.equals({}, premiumCalculation2Vm.frmPremiumCalculation2)) ? true : false;
        }

    }
]);
