angularApp.controller('premiumCalculation3Controller', [
    "$state",
    "$scope",
    "$ionicPopup",
    "premiumCalculationService",
    "lifeInsuranceConfig",
    'suggestedPlansDetailsService',
    'utilityService',
    'lifeInsuranceCommonService',
    "lifeInsuranceApplicationService",
    "LiConstant", "$timeout", "clickStreamService",
    function(
        $state,
        $scope,
        $ionicPopup,
        premiumCalculationService,
        lifeInsuranceConfig,
        suggestedPlansDetailsService,
        utilityService,
        lifeInsuranceCommonService,
        lifeInsuranceApplicationService,
        LiConstant, $timeout, clickStreamService) {

        var premiumCalculation3Vm = this;
        premiumCalculation3Vm.showBack = true;
        premiumCalculation3Vm.showNext = true;
        premiumCalculation3Vm.disableBack = false;
        premiumCalculation3Vm.disableNext = false;
        var product;
        var uin, rows;

        function initPage() {
            var selectedProduct = suggestedPlansDetailsService.getCurrentSugestedProduct();
            premiumCalculation3Vm.data = {};

            premiumCalculation3Vm.productName = selectedProduct.planName;
            premiumCalculation3Vm.product = selectedProduct.productCode;
            product = premiumCalculation3Vm.product;
            premiumCalculation3Vm.uin = selectedProduct.uin;
            uin = premiumCalculation3Vm.uin;

            getPremiumCalculationData();

            if (!premiumCalculation3Vm.benifitIllustratorText) {
                premiumCalculationService.getBenefitIllustratorText().then(function(data) {
                    premiumCalculation3Vm.benifitIllustratorText = data.message;
                }, function() {});
            }

            clickStreamService.clickStreamData = premiumCalculation3Vm.uin;
        };


        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });


        premiumCalculation3Vm.closeJourney = function() {
            lifeInsuranceCommonService.closePopUp().then(function(result) {
                if (result) {
                    $state.go("menu.generalInsurance");
                }
            });
        };

        premiumCalculation3Vm.goBacktoPrevious = function() {
            if (premiumCalculation3Vm.product == LiConstant.productCode.SMART_WEALTH_BUILDER && premiumCalculation3Vm.uin == LiConstant.productUIN.SMART_WEALTH_BUILDER) {

                $state.go("menu.smartWealthBuilderPremiumCalculation2");
            }
            //"SBI Life - Smart Money Back Gold"
            if (premiumCalculation3Vm.product == LiConstant.productCode.SMART_MONEY_BACK_GOLD && premiumCalculation3Vm.uin == LiConstant.productUIN.SMART_MONEY_BACK_GOLD) {

                $state.go("menu.premiumCalculation2");
            }
            //Smart Champ Insurance
            if (premiumCalculation3Vm.product == LiConstant.productCode.SMART_CHAMP_INSURANCE && premiumCalculation3Vm.uin == LiConstant.productUIN.SMART_CHAMP_INSURANCE) {

                $state.go("menu.smartChampInsurancePremiumCalculation");
            }
            //"SBI Life - Shub Nivesh"
            if (premiumCalculation3Vm.product == LiConstant.productCode.SHUBH_NIVESH && premiumCalculation3Vm.uin == LiConstant.productUIN.SHUBH_NIVESH) {

                $state.go("menu.shubhNiveshRider");
            }
            //"SBI Life - Retire Smart"
            if (premiumCalculation3Vm.product == LiConstant.productCode.RETIRE_SMART && premiumCalculation3Vm.uin == LiConstant.productUIN.RETIRE_SMART) {

                $state.go("menu.retireSmartPremiumCalculation");
            }
            if (premiumCalculation3Vm.product == LiConstant.productCode.SARAL_SWADHAN_PLUS && premiumCalculation3Vm.uin == LiConstant.productUIN.SARAL_SWADHAN_PLUS) {

                $state.go("menu.saralSwadhanPremiumCalculation");
            }

        }

        function getPremiumCalculationData() {

            //"SBI Life - Smart Wealth Builder"
            if (premiumCalculation3Vm.product == LiConstant.productCode.SMART_WEALTH_BUILDER && premiumCalculation3Vm.uin == LiConstant.productUIN.SMART_WEALTH_BUILDER) {
                var data = premiumCalculationService.getPremiumCalculationResponse();
            }

            //"SBI Life - Smart Money Back Gold"
            if (premiumCalculation3Vm.product == LiConstant.productCode.SMART_MONEY_BACK_GOLD && premiumCalculation3Vm.uin == LiConstant.productUIN.SMART_MONEY_BACK_GOLD) {
                var data = premiumCalculationService.getPremiumCalculationResponse();
            }

            //Smart Champ Insurance
            if (premiumCalculation3Vm.product == LiConstant.productCode.SMART_CHAMP_INSURANCE && premiumCalculation3Vm.uin == LiConstant.productUIN.SMART_CHAMP_INSURANCE) {
                var data = premiumCalculationService.getPremiumCalculationResponse();
            }

            //"SBI Life - Shub Nivesh"
            if (premiumCalculation3Vm.product == LiConstant.productCode.SHUBH_NIVESH && premiumCalculation3Vm.uin == LiConstant.productUIN.SHUBH_NIVESH) {
                var data = premiumCalculationService.getPremiumCalculationResponse();
            }

            //"SBI Life - Retire Smart"
            if (premiumCalculation3Vm.product == LiConstant.productCode.RETIRE_SMART && premiumCalculation3Vm.uin == LiConstant.productUIN.RETIRE_SMART) {
                var data = premiumCalculationService.getPremiumCalculationResponse();
            }

            //"SBI Life - Saral Swadhan"
            if (premiumCalculation3Vm.product == LiConstant.productCode.SARAL_SWADHAN_PLUS && premiumCalculation3Vm.uin == LiConstant.productUIN.SARAL_SWADHAN_PLUS) {
                var data = premiumCalculationService.getPremiumCalculationResponse();
            }
            premiumCalculation3Vm.quoteDetails = data;
            premiumCalculation3Vm.data.proposerName = data.proposerName;
            premiumCalculation3Vm.data.quoteNumber = data.quoteNumber;
            premiumCalculation3Vm.data.premium = data.premium;
            premiumCalculation3Vm.data.annPremium = data.annPremium;
            premiumCalculation3Vm.data.sumAssured = data.sumAssured;
            premiumCalculation3Vm.tableData = data.premiumTableData.rowData;
            premiumCalculation3Vm.data.isStaff = data.isStaff;

        }

        premiumCalculation3Vm.goToNextPage = function() {
            premiumCalculationService.setPremiumAmount(premiumCalculation3Vm.data.premium);
            premiumCalculationService.setAnnualPremiumAmount(premiumCalculation3Vm.data.annPremium);
           clickStreamService.clickStreamData = premiumCalculation3Vm.productName;
            // to do
            if (premiumCalculation3Vm.product == LiConstant.productCode.SMART_WEALTH_BUILDER && premiumCalculation3Vm.uin == LiConstant.productUIN.SMART_WEALTH_BUILDER) {

                var data = premiumCalculationService.getPremiumCalculationSW();
                data.proposerName = premiumCalculation3Vm.data.proposerName;
                data.quoteNumber = premiumCalculation3Vm.data.quoteNumber;
                data.sumAssured = premiumCalculation3Vm.data.sumAssured;

                premiumCalculationService.setPremiumCalculationSW3(data);


            }
            //"SBI Life - Saral Swadhan"
            if (premiumCalculation3Vm.product == LiConstant.productCode.SARAL_SWADHAN_PLUS && premiumCalculation3Vm.uin == LiConstant.productUIN.SARAL_SWADHAN_PLUS) {
                var data = premiumCalculationService.getPremiumCalculationSS();
                data.proposerName = premiumCalculation3Vm.data.proposerName;
                data.quoteNumber = premiumCalculation3Vm.data.quoteNumber;
                data.sumAssured = premiumCalculation3Vm.data.sumAssured;

                premiumCalculationService.setPremiumCalculationSS2(data);

            }

            //"SBI Life - Smart Money Back Gold"
            if (premiumCalculation3Vm.product == LiConstant.productCode.SMART_MONEY_BACK_GOLD && premiumCalculation3Vm.uin == LiConstant.productUIN.SMART_MONEY_BACK_GOLD) {

                var data = premiumCalculationService.getPremiumCalculationFData();
                data.proposerName = premiumCalculation3Vm.data.proposerName;
                data.quoteNumber = premiumCalculation3Vm.data.quoteNumber;
                data.premium = premiumCalculation3Vm.data.premium;

                premiumCalculationService.submitPremiumCalculationFData3(data);

            }
            //Smart Champ Insurance
            if (premiumCalculation3Vm.product == LiConstant.productCode.SMART_CHAMP_INSURANCE && premiumCalculation3Vm.uin == LiConstant.productUIN.SMART_CHAMP_INSURANCE) {

                var data = premiumCalculationService.getPremiumCalculationSC();
                data.proposerName = premiumCalculation3Vm.data.proposerName;
                data.quoteNumber = premiumCalculation3Vm.data.quoteNumber;
                data.premium = premiumCalculation3Vm.quoteDetails.premium;

                premiumCalculationService.setPremiumCalculationSC2(data);

            }
            //"SBI Life - Shub Nivesh"
            if (premiumCalculation3Vm.product == LiConstant.productCode.SHUBH_NIVESH && premiumCalculation3Vm.uin == LiConstant.productUIN.SHUBH_NIVESH) {
                var data = premiumCalculationService.getPremiumCalculationSN();
                data.proposerName = premiumCalculation3Vm.data.proposerName;
                data.quoteNumber = premiumCalculation3Vm.data.quoteNumber;
                data.premium = premiumCalculation3Vm.quoteDetails.premium;
                premiumCalculationService.setPremiumCalculationSN3(data);
            }
            //"SBI Life - Retire Smart"
            if (premiumCalculation3Vm.product == LiConstant.productCode.RETIRE_SMART && premiumCalculation3Vm.uin == LiConstant.productUIN.RETIRE_SMART) {
                var data = premiumCalculationService.getPremiumCalculationRS();

                data.proposerName = premiumCalculation3Vm.data.proposerName;
                data.quoteNumber = premiumCalculation3Vm.data.quoteNumber;
                data.sumAssured = premiumCalculation3Vm.data.sumAssured;

                premiumCalculationService.setPremiumCalculationRS2(data);

            }

            premiumCalculation3Vm.popupLoad = function() {
                $timeout(function() {
                    var table = document.getElementById('fss-li-bi-table');
                    rows = table.getElementsByTagName("tr");
                }, 10);
            }


            var tableMatrix = [];

            premiumCalculation3Vm.exportCSV = function() {
                tableMatrix = [];
                var productId = premiumCalculation3Vm.product;
                var pageSize = "a1";
                if (productId == LiConstant.productCode.SMART_MONEY_BACK_GOLD || productId == LiConstant.productCode.SMART_CHAMP_INSURANCE || productId == LiConstant.productCode.SHUBH_NIVESH) {
                    pageSize = "a3";
                } else if (productId == LiConstant.productCode.SARAL_SWADHAN_PLUS) {
                    pageSize = 'a4';
                }
                var doc = new jsPDF('l', 'pt', pageSize);
                doc.cellInitialize();
                doc.setFontSize(16);
                var defaultCellWidth = 80;
                var defaultCellHeight = 16;
                var lineHeight = 14;
                var leftMargin = 50;
                var topMargin = 70;

                doc.text(premiumCalculation3Vm.productName + " (UIN: " + uin + ")", leftMargin, 50);

                doc.setFontSize(10);

                var rowMeta = [];
                var columnMeta = [];
                angular.forEach(rows, function(row, rowIndex) {
                    var dataColumns = row.getElementsByTagName("td");
                    var headerColumns = row.getElementsByTagName("th");
                    var columns = headerColumns.length ? headerColumns : dataColumns;
                    rowMeta[rowIndex] = 0;
                    angular.forEach(columns, function(column, columnIndex) {
                        var element = angular.element(column);
                        var txt = element.text().trim() || " ";
                        var colspan = element.attr("colspan");
                        var columnIndex = findColumnIndex(rowIndex);
                        colspan = colspan ? colspan * 1 : 0;
                        var rowspan = element.attr("rowspan");
                        rowspan = rowspan ? rowspan * 1 : 0;

                        var width = defaultCellWidth;
                        var height = defaultCellHeight;
                        if (rowspan && colspan) {
                            var activeRow = rowIndex;
                            width = defaultCellWidth * colspan;
                            height = 0;
                            for (var i = 1; i < rowspan; i++) {
                                var activeColumn = columnIndex;
                                for (var j = 1; j < colspan; j++) {
                                    setCellValue(activeRow + i, activeColumn + j, {
                                        span: true
                                    })
                                }
                            }

                        } else if (rowspan) {
                            txt = doc.splitTextToSize(txt, width);
                            if (txt.length > 1) {
                                height = lineHeight * txt.length;
                            }
                            height = 0;
                            var activeRow = rowIndex;
                            for (var i = 1; i < rowspan; i++) {
                                setCellValue(activeRow + i, columnIndex, {
                                    span: true
                                })
                            }
                        } else if (colspan) {
                            width = defaultCellWidth * colspan;
                            txt = doc.splitTextToSize(txt, width);
                            if (txt.length > 1) {
                                height = lineHeight * txt.length;
                            }
                            var activeColumn = columnIndex;
                            for (var i = 1; i < colspan; i++) {
                                setCellValue(rowIndex, activeColumn + i, {
                                    span: true
                                })
                            }
                        } else {
                            txt = doc.splitTextToSize(txt, width);
                            if (txt.length > 1) {
                                height = lineHeight * txt.length;
                            }
                        }
                        rowMeta[rowIndex] = height > rowMeta[rowIndex] ? height : rowMeta[rowIndex];
                        setCellValue(rowIndex, columnIndex, {
                            text: txt,
                            colspan: colspan,
                            rowspan: rowspan,
                            rowHeight: height,
                            width: width
                        })
                    })

                })

                // setting height, x abd y
                var x = 0;
                var y = 0;
                angular.forEach(tableMatrix, function(row, rowIndex) {
                    x = 0;
                    angular.forEach(row, function(column, columnIndex) {
                        if (column.span) {
                            x = x + defaultCellWidth;
                            return;
                        }
                        var cellHeight = rowMeta[rowIndex];
                        if (column.rowspan) {
                            for (var i = rowIndex + 1; i <= column.rowspan; i++) {
                                cellHeight = cellHeight + rowMeta[i];
                            }
                        }
                        column.height = cellHeight;
                        column.x = x;
                        column.y = y;
                        x = x + defaultCellWidth;
                    })
                    y = y + rowMeta[rowIndex];
                })

                angular.forEach(tableMatrix, function(row, rowIndex) {
                        angular.forEach(row, function(column, columnIndex) {
                            if (column.span) return;
                            doc.cell(column.x + leftMargin, column.y + topMargin, column.width, column.height, column.text);
                        })
                    })
                    //to do
                doc.save(premiumCalculation3Vm.productName + "-BI.pdf");
                var baseUrl = doc.output('datauristring');
                var Base64 = baseUrl.split(',');
                Base64 = Base64[1];
                pdfGenration(Base64, premiumCalculation3Vm.productName + ".pdf");
            }


            function b64toBlob(b64Data, contentType, sliceSize) {
                contentType = contentType || '';
                sliceSize = sliceSize || 512;
                var byteCharacters = atob(b64Data);
                var byteArrays = [];
                for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
                    var slice = byteCharacters.slice(offset, offset + sliceSize);
                    var byteNumbers = [];
                    for (var i = 0; i < slice.length; i++) {
                        byteNumbers[i] = slice.charCodeAt(i);
                    }
                    var byteArray = new Uint8Array(byteNumbers);
                    byteArrays.push(byteArray);
                }
                var blob = new Blob(byteArrays, { type: contentType });
                return blob;
            }

            function savebase64AsPDF(folderpath, filename, content, contentType) {
                // Convert the base64 string in a Blob
                var DataBlob = b64toBlob(content, contentType);

                window.resolveLocalFileSystemURL(folderpath, function(dir) {
                    dir.getFile(filename, { create: true }, function(file) {
                        file.createWriter(function(fileWriter) {
                            fileWriter.write(DataBlob);

                        }, function() {

                        });
                    });
                });
            }


            function pdfGenration(content, filename) {
                var contentType = "application/pdf";
                var isandroid, folderpath;

                if (utilityService.isAndroidPlatform()) {
                    isandroid = true;
                    premiumCalculation3Vm.folderpath = cordova.file.externalRootDirectory;
                }
                if (utilityService.isIOSPlatform()) {
                    premiumCalculation3Vm.folderpath = cordova.file.applicationDirectory;
                }
                savebase64AsPDF(premiumCalculation3Vm.folderpath, filename, content, contentType);
                if (utilityService.isIOSPlatform()) {
                    var finalObject = { "folderpath": premiumCalculation3Vm.folderpath, "filename": filename };
                    //cordova.exec(sayHelloSuccess, sayHelloFailure, "PdfViewer", "openPDF", [finalObject]);
                    window.open("data:application/pdf;base64," + content + "", "_blank", "location=no");
                }
                if (isandroid) {
                    var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="DOWNLOADFDRECEIPT" translate-values="{folderpath:premiumCalculation3Vm.folderpath}"></div>';
                    premiumCalculation3Vm.downloadPopup = $ionicPopup.show({
                        title: '',
                        template: template,
                        scope: $scope,
                        cssClass: 'my-custom-popup',
                        buttons: [{
                            text: 'OK',
                            type: 'button-assertive',
                            onTap: function() {
                                premiumCalculation3Vm.downloadPopup.close();
                            }
                        }],
                    });
                }
            }

            function findColumnIndex(rowIndex) {
                var row = tableMatrix[rowIndex];
                if (!row) return 0;
                for (var i = 0; i < row.length; i++) {
                    if (!row[i]) return i;
                }
                return row.length;
            }

            function setCellValue(rowIndex, columnIndex, data) {
                if (!tableMatrix[rowIndex]) tableMatrix[rowIndex] = [];
                tableMatrix[rowIndex][columnIndex] = data;
            }

            premiumCalculationService.saveBI(LiConstant.journeyCommonId.PC_BI).then(function() {
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    templateUrl: 'pages/lifeInsurance/buyPolicy/premiumCalculation/declarationTablePopup.html',
                    scope: $scope,
                    cssClass: 'bi-table',
                    buttons: [{
                        text: 'OK',
                        type: 'button-negative',
                        onTap: function(e) {
                            lifeInsuranceApplicationService.getAcceptanceMessage().then(function(data) {
                                lifeInsuranceApplicationService.setPremiumAcceptanceMessage(data.message);
                                $state.go("menu.declarationOfLI");
                            }, function(error) {

                            });
                            return false;
                        }

                    } 
                    //Commented this code to disable/remove export PDF button as of now for compliance issue(uncomment whnever asked to enable button)
                    //,
                    // {
                    //     text: 'Export PDF',
                    //     type: 'button-positive',
                    //     onTap: function(e) {
                    //         premiumCalculation3Vm.exportCSV();
                    //         return true;
                    //     }
                    // }
                    ]

                });
                alertPopup.then(function(res) {


                });
            });
        }
    }
]);
