(function() {
    'use strict';

    //lifeInsurance Application Services

    angularApp.service('premiumCalculationService', premiumCalculationService);

    premiumCalculationService.$inject = [
        'commonAPIService',
        'lifeInsuranceConfig',
        '$filter',
        '$q',
        'AdapterUtils',
        'utilityService',
        'lifeInsuranceApplicationService',
        'LiConstant'
    ];

    function premiumCalculationService(
        commonAPIService,
        lifeInsuranceConfig,
        $filter,
        $q,
        AdapterUtils,
        utilityService,
        lifeInsuranceApplicationService,
        LiConstant
    ) {

        var premiumCalculation = this;
        var premiumCalculationData = {};
        var premiumCalculationDataSW = {};
        var premiumCalculationDataSS = {};
        var premiumCalculationDataRS = {};
        var premiumCalculationDataSN = {};
        var premiumCalculationDataSC = {};

        var premiumAmount;
        var annualPremium;
        var quoteNumber;
        var assuredAmount;
        var termAssured;
        var jkResident;
        var premiumCalcRes;
        var premiumMasters;
        var childName;
        var mobileNumber;
        var saveBI = {};
        saveBI.bi = {};


        premiumCalculation.setJammuKashmir = function(data) {
            jkResident = data;
        };

        premiumCalculation.getJammuKashmir = function() {
            if (!jkResident || jkResident == "No") {
                return false;
            }
            return true;
        };


        //get the mobile number
        premiumCalculation.getMobileNumber = function() {
            return mobileNumber;
        };

        //set the mobile number
        premiumCalculation.setMobileNumber = function(number) {
            mobileNumber = number;
        };

        premiumCalculation.initializeBI = function() {
            premiumCalculationData = {};
            premiumCalculationDataSW = {};
            premiumCalculationDataSS = {};
            premiumCalculationDataRS = {};
            premiumCalculationDataSN = {};
            premiumCalculationDataSC = {};
            saveBI = {};
            saveBI.bi = {};
        };

        premiumCalculation.saveBI = function(commonId) {
            //Smart Wealth Builder 
            if (premiumCalculationDataSW.productCode == LiConstant.productCode.SMART_WEALTH_BUILDER) {
                saveBI.applicationNumber = premiumCalculationDataSW.applicationNumber;
                saveBI.productCode = premiumCalculationDataSW.productCode;
                saveBI.productName = premiumCalculationDataSW.productName;
                saveBI.uin = premiumCalculationDataSW.uin;
                saveBI.mobileNumber = premiumCalculationDataSW.mobileNumber;
                saveBI.bi.req = JSON.stringify(premiumCalculationDataSW);
                saveBI.bi.res = '';
            }

            //Smart Money Back Gold
            if (premiumCalculationData.productCode == LiConstant.productCode.SMART_MONEY_BACK_GOLD) {
                saveBI.applicationNumber = premiumCalculationData.applicationNumber;
                saveBI.productCode = premiumCalculationData.productCode;
                saveBI.productName = premiumCalculationData.productName;
                saveBI.uin = premiumCalculationData.uin;
                saveBI.mobileNumber = premiumCalculationData.mobileNumber;
                saveBI.bi.req = JSON.stringify(premiumCalculationData);
                saveBI.bi.res = '';
            }

            //Smart Champ Insurance
            if (premiumCalculationDataSC.productCode == LiConstant.productCode.SMART_CHAMP_INSURANCE) {
                saveBI.applicationNumber = premiumCalculationDataSC.applicationNumber;
                saveBI.productCode = premiumCalculationDataSC.productCode;
                saveBI.productName = premiumCalculationDataSC.productName;
                saveBI.uin = premiumCalculationDataSC.uin;
                saveBI.mobileNumber = premiumCalculationDataSC.mobileNumber;
                var premiumCalculationDataSCCC = premiumCalculationDataSC;
                premiumCalculationDataSCCC.child = childName;
                saveBI.bi.req = JSON.stringify(premiumCalculationDataSCCC);
                saveBI.bi.res = '';
            }

            //"SBI Life - Shub Nivesh"
            if (premiumCalculationDataSN.productCode == LiConstant.productCode.SHUBH_NIVESH) {
                saveBI.applicationNumber = premiumCalculationDataSN.applicationNumber;
                saveBI.productCode = premiumCalculationDataSN.productCode;
                saveBI.productName = premiumCalculationDataSN.productName;
                saveBI.uin = premiumCalculationDataSN.uin;
                saveBI.mobileNumber = premiumCalculationDataSN.mobileNumber;
                saveBI.bi.req = JSON.stringify(premiumCalculationDataSN);
                saveBI.bi.res = '';
            }

            //"SBI Life - Retire Smart"
            if (premiumCalculationDataRS.productCode == LiConstant.productCode.RETIRE_SMART) {
                saveBI.applicationNumber = premiumCalculationDataRS.applicationNumber;
                saveBI.productCode = premiumCalculationDataRS.productCode;
                saveBI.productName = premiumCalculationDataRS.productName;
                saveBI.uin = premiumCalculationDataRS.uin;
                saveBI.mobileNumber = premiumCalculationDataRS.mobileNumber;
                saveBI.bi.req = JSON.stringify(premiumCalculationDataRS);
                saveBI.bi.res = '';
            }

            //"SBI Life - Saral Swadhan +"
            if (premiumCalculationDataSS.productCode == LiConstant.productCode.SARAL_SWADHAN_PLUS) {
                saveBI.applicationNumber = premiumCalculationDataSS.applicationNumber;
                saveBI.productCode = premiumCalculationDataSS.productCode;
                saveBI.productName = premiumCalculationDataSS.productName;
                saveBI.uin = premiumCalculationDataSS.uin;
                saveBI.mobileNumber = premiumCalculationDataSS.mobileNumber;
                saveBI.bi.req = JSON.stringify(premiumCalculationDataSS);
                saveBI.bi.res = '';
            }

            saveBI.pageNo = commonId;
            premiumCalculation.setMobileNumber(saveBI.mobileNumber);

            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.saveBI[0], saveBI, true).then(
                function(response) {
                    premiumCalculation.saveJourney(commonId);
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };


        premiumCalculation.saveJourney = function(commonId) {
            var journeyMaster = lifeInsuranceApplicationService.getJourneyMaster();
            var applicationNumber = lifeInsuranceApplicationService.getApplicationNumber();
            var object = $filter('getObjectByValue')(journeyMaster, 'commonId', commonId);
            var request = {
                "id": applicationNumber,
                "journey": [{
                    "journeyType": object.journeyType,
                    "portalURL": object.portalURL,
                    "commonId": object.commonId,
                    "mobileURL": object.mobileURL,
                    "lastModifiedTime": lifeInsuranceApplicationService.getDate().getTime() + '',
                    "lastModifiedBy": "mobile"
                }]
            };
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.saveLiJourney[0], request, false).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    //utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };


        //Smart Wealth Builder
        premiumCalculation.setBiDataSW = function(data) {
            premiumCalculationDataSW = JSON.parse(data.req);
            if (data.res) {
                var dataRes = JSON.parse(data.res);
                premiumCalculation.setPremiumCalculationResponse(dataRes.data);
            }
        }

        premiumCalculation.setPremiumCalculationSW1 = function(data) {
            premiumCalculationDataSW = data;
        };

        premiumCalculation.setPremiumCalculationSW2 = function(data) {
            premiumCalculationDataSW = data;
        };

        premiumCalculation.setPremiumCalculationSW3 = function(data) {
            premiumCalculationDataSW = data;
            quoteNumber = data.quoteNumber;
        };

        premiumCalculation.getPremiumCalculationSW = function() {
            return premiumCalculationDataSW;
        };


        //Retire Smart 
        premiumCalculation.setBiDataRS = function(data) {
            premiumCalculationDataRS = JSON.parse(data.req);
            if (data.res) {
                var dataRes = JSON.parse(data.res);
                premiumCalculation.setPremiumCalculationResponse(dataRes.data);
            }
        }

        premiumCalculation.setPremiumCalculationRS1 = function(data) {
            premiumCalculationDataRS = data;
        };

        premiumCalculation.setPremiumCalculationRS2 = function(data) {
            premiumCalculationDataRS = data;
            quoteNumber = data.quoteNumber;
        };

        premiumCalculation.getPremiumCalculationRS = function() {
            return premiumCalculationDataRS;
        };


        //Saral Swadhan +
        premiumCalculation.setBiDataSS = function(data) {
            premiumCalculationDataSS = JSON.parse(data.req);
            if (data.res) {
                var dataRes = JSON.parse(data.res);
                premiumCalculation.setPremiumCalculationResponse(dataRes.data);
            }
        }

        premiumCalculation.setPremiumCalculationSS1 = function(data, cloud) {
            premiumCalculationDataSS = data;
        };

        premiumCalculation.setPremiumCalculationSS2 = function(data) {
            premiumCalculationDataSS = data;
            quoteNumber = data.quoteNumber;
        };

        premiumCalculation.getPremiumCalculationSS = function() {
            return premiumCalculationDataSS;
        };


        //Smart Money Back Gold  
        premiumCalculation.setBiDataSM = function(data) {
            premiumCalculationData = JSON.parse(data.req);
            if (data.res) {
                var dataRes = JSON.parse(data.res);
                premiumCalculation.setPremiumCalculationResponse(dataRes.data);
            }
        }

        premiumCalculation.setPremiumCalculationFData1 = function(data) {
            premiumCalculationData = data;

        };

        premiumCalculation.setPremiumCalculationFData2 = function(data) {
            premiumCalculationData = data;

        };

        premiumCalculation.submitPremiumCalculationFData3 = function(data) {
            premiumCalculationData = data;
            quoteNumber = data.quoteNumber;
        };

        premiumCalculation.getPremiumCalculationFData = function() {
            return premiumCalculationData;
        };



        //Smart Champ 

        premiumCalculation.setBiDataSC = function(data) {
            premiumCalculationDataSC = JSON.parse(data.req);
            childName = premiumCalculationDataSC.child;
            if (data.res) {
                var dataRes = JSON.parse(data.res);
                premiumCalculation.setPremiumCalculationResponse(dataRes.data);
            }
        }

        premiumCalculation.setChildName = function(data) {
            childName = data;
        };

        premiumCalculation.getChildName = function() {
            return childName;
        };

        premiumCalculation.setPremiumCalculationSC1 = function(data) {
            premiumCalculationDataSC = data;

        };

        premiumCalculation.setPremiumCalculationSC2 = function(data) {
            premiumCalculationDataSC = data;
            quoteNumber = data.quoteNumber;
        };

        premiumCalculation.getPremiumCalculationSC = function() {
            return premiumCalculationDataSC;
        };



        //Shubh Nivesh

        premiumCalculation.setBiDataSN = function(data) {
            premiumCalculationDataSN = JSON.parse(data.req);
            if (data.res) {
                var dataRes = JSON.parse(data.res);
                premiumCalculation.setPremiumCalculationResponse(dataRes.data);
            }
        }

        premiumCalculation.setPremiumCalculationSN1 = function(data) {
            premiumCalculationDataSN = data;
        };

        premiumCalculation.setPremiumCalculationSN2 = function(data) {
            premiumCalculationDataSN = data;

        };

        premiumCalculation.setPremiumCalculationSN3 = function(data) {
            premiumCalculationDataSN = data;
            quoteNumber = data.quoteNumber;
        };

        premiumCalculation.getPremiumCalculationSN = function() {
            return premiumCalculationDataSN;
        };
        //anuual premium getter setter
        premiumCalculation.getAnnualPremiumAmount = function() {
            return annualPremium;
        };

        premiumCalculation.setAnnualPremiumAmount = function(data) {
            if (data) {
                annualPremium = $filter('formatAmount')(data);
            } else {
                annualPremium = 0;
            }
            // return premiumAmount;
        };


        //Other Methods  
        premiumCalculation.getPremiumAmount = function() {
            return premiumAmount;
        };

        premiumCalculation.getQuoteNumber = function() {
            return quoteNumber;
        };

        premiumCalculation.setPremiumAmount = function(data) {
            if (data) {
                premiumAmount = $filter('formatAmount')(data);
            } else {
                premiumAmount = 0;
            }
            // return premiumAmount;
        };

        premiumCalculation.setPremiumCalculationResponse = function(data) {
            premiumCalcRes = data;
            premiumAmount = parseInt(data.premium);
            annualPremium = parseInt(data.annPremium);
        }

        premiumCalculation.getPremiumCalculationResponse = function() {
            return premiumCalcRes;
        }

        premiumCalculation.setAssuredAmount = function(amt) {
            assuredAmount = amt;
        };

        premiumCalculation.getAssuredAmount = function() {
            return assuredAmount;
        };

        premiumCalculation.setpolicyTerm = function(term) {
            termAssured = term;
        };
        premiumCalculation.getpolicyTerm = function() {
            return termAssured;
        };

        premiumCalculation.getPremiumCalculationInfo = function(callback) {
            callback(premiumCalculationData);
        };

        //Submit Premium Calculation 

        premiumCalculation.submitPremiumCalculationDataSW = function() {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getPremiumSmartWealthBuilder[0], premiumCalculationDataSW, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };


        premiumCalculation.submitPremiumCalculationDataSN = function() {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getPremiumShubhNivesh[0], premiumCalculationDataSN, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };

        premiumCalculation.submitPremiumCalculationDataRS = function() {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getPremiumRetireSmart[0], premiumCalculationDataRS, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };



        premiumCalculation.submitPremiumCalculationDataSC = function() {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getPremiumSmartChamp[0], premiumCalculationDataSC, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };


        premiumCalculation.submitPremiumCalculationDataSS = function() {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getPremiumSaralSwadhan[0], premiumCalculationDataSS, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };

        premiumCalculation.submitPremiumCalculationData = function() {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getPremiumMoneyBackGold[0], premiumCalculationData, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };

        // Premium Masters Data

        premiumCalculation.getMasterDataPlans = function() {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getPremiumCalMasters[0], {}, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };


        premiumCalculation.setMasterDataPlans = function(data) {
            premiumMasters = data;
        }

        premiumCalculation.getPremiumMasters = function() {
            return premiumMasters;
        }

        //     
        premiumCalculation.getBenefitIllustratorText = function() {
            var q = $q.defer();
            AdapterUtils.getData(lifeInsuranceConfig.adapterURL.getBenefitIllustratorText[0], true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        //To set mobile number and email on preview page 
        premiumCalculation.setMobileEmail = function(mob, eml) {

            //Smart Wealth Builder 
            if (premiumCalculationDataSW.productCode == LiConstant.productCode.SMART_WEALTH_BUILDER) {
                premiumCalculationDataSW.mobileNumber = mob;
                premiumCalculationDataSW.email = eml;
                saveBI.applicationNumber = premiumCalculationDataSW.applicationNumber;
                saveBI.productCode = premiumCalculationDataSW.productCode;
                saveBI.productName = premiumCalculationDataSW.productName;
                saveBI.uin = premiumCalculationDataSW.uin;
                saveBI.mobileNumber = premiumCalculationDataSW.mobileNumber;
                saveBI.bi.req = JSON.stringify(premiumCalculationDataSW);
                saveBI.bi.res = '';
            }

            //Smart Money Back Gold
            if (premiumCalculationData.productCode == LiConstant.productCode.SMART_MONEY_BACK_GOLD) {
                premiumCalculationData.mobileNumber = mob;
                premiumCalculationData.email = eml;
                saveBI.applicationNumber = premiumCalculationData.applicationNumber;
                saveBI.productCode = premiumCalculationData.productCode;
                saveBI.productName = premiumCalculationData.productName;
                saveBI.uin = premiumCalculationData.uin;
                saveBI.mobileNumber = premiumCalculationData.mobileNumber;
                saveBI.bi.req = JSON.stringify(premiumCalculationData);
                saveBI.bi.res = '';
            }

            //Smart Champ Insurance
            if (premiumCalculationDataSC.productCode == LiConstant.productCode.SMART_CHAMP_INSURANCE) {
                premiumCalculationDataSC.mobileNumber = mob;
                premiumCalculationDataSC.email = eml;
                saveBI.applicationNumber = premiumCalculationDataSC.applicationNumber;
                saveBI.productCode = premiumCalculationDataSC.productCode;
                saveBI.productName = premiumCalculationDataSC.productName;
                saveBI.uin = premiumCalculationDataSC.uin;
                saveBI.mobileNumber = premiumCalculationDataSC.mobileNumber;
                var premiumCalculationDataSCCC = premiumCalculationDataSC;
                premiumCalculationDataSCCC.child = childName;
                saveBI.bi.req = JSON.stringify(premiumCalculationDataSCCC);
                saveBI.bi.res = '';
            }

            //"SBI Life - Shub Nivesh"
            if (premiumCalculationDataSN.productCode == LiConstant.productCode.SHUBH_NIVESH) {
                premiumCalculationDataSN.mobileNumber = mob;
                premiumCalculationDataSN.email = eml;
                saveBI.applicationNumber = premiumCalculationDataSN.applicationNumber;
                saveBI.productCode = premiumCalculationDataSN.productCode;
                saveBI.productName = premiumCalculationDataSN.productName;
                saveBI.uin = premiumCalculationDataSN.uin;
                saveBI.mobileNumber = premiumCalculationDataSN.mobileNumber;
                saveBI.bi.req = JSON.stringify(premiumCalculationDataSN);
                saveBI.bi.res = '';
            }

            //"SBI Life - Retire Smart"
            if (premiumCalculationDataRS.productCode == LiConstant.productCode.RETIRE_SMART) {
                premiumCalculationDataRS.mobileNumber = mob;
                premiumCalculationDataRS.email = eml;
                saveBI.applicationNumber = premiumCalculationDataRS.applicationNumber;
                saveBI.productCode = premiumCalculationDataRS.productCode;
                saveBI.productName = premiumCalculationDataRS.productName;
                saveBI.uin = premiumCalculationDataRS.uin;
                saveBI.mobileNumber = premiumCalculationDataRS.mobileNumber;
                saveBI.bi.req = JSON.stringify(premiumCalculationDataRS);
                saveBI.bi.res = '';
            }

            //"SBI Life - Saral Swadhan +"
            if (premiumCalculationDataSS.productCode == LiConstant.productCode.SARAL_SWADHAN_PLUS) {
                premiumCalculationDataSS.mobileNumber = mob;
                premiumCalculationDataSS.email = eml;
                saveBI.applicationNumber = premiumCalculationDataSS.applicationNumber;
                saveBI.productCode = premiumCalculationDataSS.productCode;
                saveBI.productName = premiumCalculationDataSS.productName;
                saveBI.uin = premiumCalculationDataSS.uin;
                saveBI.mobileNumber = premiumCalculationDataSS.mobileNumber;
                saveBI.bi.req = JSON.stringify(premiumCalculationDataSS);
                saveBI.bi.res = '';
            }

            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.saveBI[0], saveBI, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;

        };
    }

})();
