angularApp.controller('retireSmartPCController', [
    "$state",
    "$scope",
    "$translate",
    "validateService",
    "premiumCalculationService",
    "suggestedPlansDetailsService",
    "lifeInsuranceApplicationService",
    "lifeInsuranceCommonService",
    "LiConstant",
    "$ionicScrollDelegate",


    function(
        $state,
        $scope,
        $translate,
        validateService,
        premiumCalculationService,
        suggestedPlansDetailsService,
        lifeInsuranceApplicationService,
        lifeInsuranceCommonService,
        LiConstant,
        $ionicScrollDelegate) {

        var retireSmartPCVm = this;
        retireSmartPCVm.validateService = validateService;

        var b = $translate.instant('SelectPlanOption');
        var c = $translate.instant('SelectMonthlyPremium');

        function initPage() {

            retireSmartPCVm.showBack = true;
            retireSmartPCVm.showNext = true;
            retireSmartPCVm.disableBack = false;
            retireSmartPCVm.disableNext = false;
            retireSmartPCVm.data = {};
            retireSmartPCVm.retireSmartPCForm = {};

            retireSmartPCVm.data.premiumFreq = {};
            retireSmartPCVm.data.payingOption = {};
            getMasterDataPlans();

            retireSmartPCVm.isFromRetrieveApplication = lifeInsuranceCommonService.isFromRetrieveApplication();

            if (premiumCalculationService.getPremiumCalculationRS().age) {
                retireSmartPCVm.data = premiumCalculationService.getPremiumCalculationRS();

                if (retireSmartPCVm.data.premiumFreq.key == 'Monthly') {
                    retireSmartPCVm.monthlyPremium = c;
                }
                retireSmartPCVm.updateByPlanOpt();

            } else {
                retireSmartPCVm.premiumPaymentTerms = [b];
            }

            if (!retireSmartPCVm.isFromRetrieveApplication) {
                var bankDet = lifeInsuranceApplicationService.getAccoutDetails();
                retireSmartPCVm.data.pfNumber = bankDet.cbsData.pfNumber;

                if (!retireSmartPCVm.data.pfNumber) {
                    retireSmartPCVm.data.pfNumber = '';
                }
                retireSmartPCVm.data.customerType = bankDet.cbsData.customerType;
            }

            var perDet = lifeInsuranceApplicationService.getPersonalDetails();
            var sugDet = suggestedPlansDetailsService.getCurrentSugestedProduct();

            retireSmartPCVm.data.dob = perDet.dob;

            if (perDet.name.middle && perDet.name.last) {
                retireSmartPCVm.data.proposerName = perDet.name.first + " " + perDet.name.middle + " " + perDet.name.last;
            }

            if (perDet.name.middle && !perDet.name.last) {
                retireSmartPCVm.data.proposerName = perDet.name.first + " " + perDet.name.middle;
            }

            if (!perDet.name.middle && perDet.name.last) {
                retireSmartPCVm.data.proposerName = perDet.name.first + " " + perDet.name.last;
            }

            if (!perDet.name.middle && !perDet.name.last) {
                retireSmartPCVm.data.proposerName = perDet.name.first;
            }

            retireSmartPCVm.data.productCode = sugDet.productCode;
            retireSmartPCVm.data.productName = sugDet.planName;
            retireSmartPCVm.data.uin = sugDet.uin;
            retireSmartPCVm.data.age = retireSmartPCVm.validateService.calcAge(retireSmartPCVm.data.dob);
            retireSmartPCVm.data.gender = perDet.gender;
            retireSmartPCVm.data.applicationNumber = lifeInsuranceApplicationService.getApplicationNumber();
        }

        retireSmartPCVm.closeJourney = function() {
            lifeInsuranceCommonService.closePopUp().then(function(result) {
                if (result) {
                    $state.go("menu.generalInsurance");
                }
            });
        };

        function getMasterDataPlans() {
            var response = premiumCalculationService.getPremiumMasters().retireSmart;
            retireSmartPCVm.policyTerms = response.policyTerms;
            retireSmartPCVm.premiumPaymentTermss = response.premiumPayingTerms;
            retireSmartPCVm.planOptions = response.planOptions;
            retireSmartPCVm.premiumFrequencys = response.premiumFrequencies;
        }

       
        retireSmartPCVm.updateByPlans = function() {
            retireSmartPCVm.data.payingTerm = '';
            retireSmartPCVm.data.policyTerm = '';
            retireSmartPCVm.data.premiumAmount = '';
        }
        retireSmartPCVm.updateAmt = function() {
            retireSmartPCVm.data.premiumAmount = '';
            if (retireSmartPCVm.data.premiumFreq.key == 'Monthly') {
                retireSmartPCVm.monthlyPremium = c;
            }
        }


        retireSmartPCVm.updateByPlanOpt = function() {
            retireSmartPCVm.data.noOfYrElapsed = retireSmartPCVm.data.policyTerm;
            if (retireSmartPCVm.validateService.isValidPolicyTermRS(retireSmartPCVm.data.policyTerm, retireSmartPCVm.data.age)) {
                retireSmartPCVm.retireSmartPCForm.policyTerm = retireSmartPCVm.validateService.isValidPolicyTermRS(retireSmartPCVm.data.policyTerm, retireSmartPCVm.data.age);
            } else {
                retireSmartPCVm.retireSmartPCForm = {};
            }
            if (retireSmartPCVm.data.payingOption.key == 'Regular') {
                retireSmartPCVm.premiumPaymentTerms = [retireSmartPCVm.data.policyTerm];
                retireSmartPCVm.data.payingTerm = retireSmartPCVm.premiumPaymentTerms[0];
            } else if (retireSmartPCVm.data.payingOption.key == 'LPPT') {
                if (retireSmartPCVm.data.policyTerm == 10) {
                    retireSmartPCVm.premiumPaymentTerms = retireSmartPCVm.premiumPaymentTermss.limited.ppt10;
                } else {
                    retireSmartPCVm.premiumPaymentTerms = retireSmartPCVm.premiumPaymentTermss.limited.ppt15;

                }
            }
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });


        retireSmartPCVm.scrollDelegate = function() {
            $ionicScrollDelegate.$getByHandle('mainScroll').resize();
        };

        retireSmartPCVm.goBacktoPrevious = function() {
            $state.go("menu.planDetails");
        };


        retireSmartPCVm.goBackToRetrieve = function() {
            if (retireSmartPCVm.isFromRetrieveApplication) {
                suggestedPlansDetailsService.getPlanDetails().then(function(data) {
                    suggestedPlansDetailsService.setPlanDetails(data);
                    $state.go("menu.planDetails");
                }, function(error) {

                });
            } else {
                retireSmartPCVm.goBacktoPrevious();
            }
        };

        //onclick of submit button
        retireSmartPCVm.goToNextPage = function() {
            if (validateForm()) {
                var data = {};
                data.proposerName = retireSmartPCVm.data.proposerName;
                data.gender = retireSmartPCVm.data.gender;
                data.productCode = retireSmartPCVm.data.productCode;
                data.productName = retireSmartPCVm.data.productName;

                data.uin = retireSmartPCVm.data.uin;

                data.applicationNumber = retireSmartPCVm.data.applicationNumber;
                data.pfNumber = retireSmartPCVm.data.pfNumber;
                data.customerType = retireSmartPCVm.data.customerType;

                data.age = retireSmartPCVm.data.age.toString();

                retireSmartPCVm.premiumAmountNew = retireSmartPCVm.data.premiumAmount;

                data.policyTerm = retireSmartPCVm.data.policyTerm;
                data.payingOption = retireSmartPCVm.data.payingOption;
                data.payingTerm = retireSmartPCVm.data.payingTerm;
                data.premiumFreq = retireSmartPCVm.data.premiumFreq;
                data.premiumAmount = retireSmartPCVm.premiumAmountNew;
                data.dob = retireSmartPCVm.data.dob;

                data.noOfYrElapsed = retireSmartPCVm.data.noOfYrElapsed;
                data.email = retireSmartPCVm.data.email;
                data.mobileNumber = retireSmartPCVm.data.mobileNumber;

                premiumCalculationService.setPremiumCalculationRS1(data);

                premiumCalculationService.saveBI(LiConstant.journeyCommonId.PC_RETIRE_SMART).then(function() {
                    premiumCalculationService.submitPremiumCalculationDataRS().then(function(data) {
                        premiumCalculationService.setJammuKashmir(false);
                        premiumCalculationService.setPremiumCalculationResponse(data);
                        $state.go("menu.premiumCalculation3");
                    });
                });

            }
        }

        //common validation function
        function validateForm() {

            retireSmartPCVm.retireSmartPCForm = {};

            if (retireSmartPCVm.validateService.isValidBDayRS(retireSmartPCVm.data.dob)) {
                retireSmartPCVm.retireSmartPCForm.birthDate = retireSmartPCVm.validateService.isValidBDayRS(retireSmartPCVm.data.dob);
            }


            if (retireSmartPCVm.validateService.isValidGender(retireSmartPCVm.data.gender)) {
                retireSmartPCVm.retireSmartPCForm.gender = retireSmartPCVm.validateService.isValidGender(retireSmartPCVm.data.gender);
            }

            if (retireSmartPCVm.validateService.isValidPolicyTermRS(retireSmartPCVm.data.policyTerm, retireSmartPCVm.data.age)) {
                retireSmartPCVm.retireSmartPCForm.policyTerm = retireSmartPCVm.validateService.isValidPolicyTermRS(retireSmartPCVm.data.policyTerm, retireSmartPCVm.data.age);
            }

            if (retireSmartPCVm.validateService.isValidPlanOption(retireSmartPCVm.data.payingOption.key)) {
                retireSmartPCVm.retireSmartPCForm.planOption = retireSmartPCVm.validateService.isValidPlanOption(retireSmartPCVm.data.payingOption.key);
            }


            if (retireSmartPCVm.validateService.isValidPremiumFrequency(retireSmartPCVm.data.premiumFreq.key)) {
                retireSmartPCVm.retireSmartPCForm.premiumFrequency = retireSmartPCVm.validateService.isValidPremiumFrequency(retireSmartPCVm.data.premiumFreq.key);
            }

            if (retireSmartPCVm.validateService.isValidEmail(retireSmartPCVm.data.email)) {
                retireSmartPCVm.retireSmartPCForm.email = retireSmartPCVm.validateService.isValidEmail(retireSmartPCVm.data.email);
            }

            if (retireSmartPCVm.validateService.isValidPhoneNo(retireSmartPCVm.data.mobileNumber)) {
                retireSmartPCVm.retireSmartPCForm.phoneNo = retireSmartPCVm.validateService.isValidPhoneNo(retireSmartPCVm.data.mobileNumber);
            }

            if (retireSmartPCVm.validateService.isValidPPT(retireSmartPCVm.data.payingTerm)) {
                retireSmartPCVm.retireSmartPCForm.premiumPaymentTerm = retireSmartPCVm.validateService.isValidPPT(retireSmartPCVm.data.payingTerm);
            }
            if (retireSmartPCVm.validateService.isValidPremiumAmountRS(retireSmartPCVm.data.premiumAmount, retireSmartPCVm.data.premiumFreq.key, retireSmartPCVm.data.payingOption.key)) {
                retireSmartPCVm.retireSmartPCForm.premiumAmount = retireSmartPCVm.validateService.isValidPremiumAmountRS(retireSmartPCVm.data.premiumAmount, retireSmartPCVm.data.premiumFreq.key, retireSmartPCVm.data.payingOption.key);
            }
            if (retireSmartPCVm.validateService.isValidnoOfYears(retireSmartPCVm.data.noOfYrElapsed)) {
                retireSmartPCVm.retireSmartPCForm.noOfYears = retireSmartPCVm.validateService.isValidnoOfYears(retireSmartPCVm.data.noOfYrElapsed);
            }

            return (angular.equals({}, retireSmartPCVm.retireSmartPCForm)) ? true : false;
        }
    }

]);
