angularApp.controller('saralSwadhanPCController', [
    "$state",
    "$scope",
    "validateService",
    "lifeInsuranceApplicationService",
    "premiumCalculationService",
    "suggestedPlansDetailsService",
    "lifeInsuranceCommonService",
    "LiConstant",

    function(
        $state,
        $scope,
        validateService,
        lifeInsuranceApplicationService,
        premiumCalculationService,
        suggestedPlansDetailsService,
        lifeInsuranceCommonService,
        LiConstant) {

        var saralSwadhanPCVm = this;

        function initPage() {

            saralSwadhanPCVm.data = {};
            saralSwadhanPCVm.saralSwadhanPCForm = {};
            saralSwadhanPCVm.validateService = validateService;
            saralSwadhanPCVm.showBack = true;
            saralSwadhanPCVm.showNext = true;
            saralSwadhanPCVm.disableBack = false;
            saralSwadhanPCVm.disableNext = false;

            saralSwadhanPCVm.data.premiumFreq = {};

            saralSwadhanPCVm.isFromRetrieveApplication = lifeInsuranceCommonService.isFromRetrieveApplication();

            getMasterDataPlans();

            if (premiumCalculationService.getPremiumCalculationSS().age) {

                saralSwadhanPCVm.data = premiumCalculationService.getPremiumCalculationSS();

            }

            if(!saralSwadhanPCVm.isFromRetrieveApplication) {

                var bankDet = lifeInsuranceApplicationService.getAccoutDetails();
                saralSwadhanPCVm.data.pfNumber = bankDet.cbsData.pfNumber;
                saralSwadhanPCVm.data.customerType = bankDet.cbsData.customerType;
            }   

                var details = lifeInsuranceApplicationService.getPersonalDetails();
                var curSug = suggestedPlansDetailsService.getCurrentSugestedProduct();

                saralSwadhanPCVm.data.dob = details.dob;

                saralSwadhanPCVm.data.age = saralSwadhanPCVm.validateService.calcAge(saralSwadhanPCVm.data.dob);
                if (details.name.middle && details.name.last) {
                    saralSwadhanPCVm.data.proposerName = details.name.first + " " + details.name.middle + " " + details.name.last;
                }

                if (details.name.middle && !details.name.last) {
                    saralSwadhanPCVm.data.proposerName = details.name.first + " " + details.name.middle;
                }

                if (!details.name.middle && details.name.last) {
                    saralSwadhanPCVm.data.proposerName = details.name.first + " " + details.name.last;
                }

                if (!details.name.middle && !details.name.last) {
                    saralSwadhanPCVm.data.proposerName = details.name.first;
                }
                saralSwadhanPCVm.data.gender = details.gender;
                saralSwadhanPCVm.data.uin = curSug.uin;
                saralSwadhanPCVm.data.productCode = curSug.productCode;
                saralSwadhanPCVm.data.productName = curSug.planName;
                saralSwadhanPCVm.data.applicationNumber = lifeInsuranceApplicationService.getApplicationNumber();

            }

        function getMasterDataPlans() {
            var response = premiumCalculationService.getPremiumMasters().saralSwadhanPlus;
            saralSwadhanPCVm.policyTerms = response.policyTerms;
            saralSwadhanPCVm.planOptions = response.planOptions;
            saralSwadhanPCVm.premiumFrequencys = response.premiumFrequencies;

            if (saralSwadhanPCVm.premiumFrequencys.length == 1) {
                saralSwadhanPCVm.data.premiumFreq = saralSwadhanPCVm.premiumFrequencys[0];
            }

        }

        $scope.$on('$ionicView.beforeEnter', function() {

            initPage();
        });

        saralSwadhanPCVm.closeJourney = function() {
            lifeInsuranceCommonService.closePopUp().then(function(result) {
                if (result) {
                    $state.go("menu.generalInsurance");
                }
            });
        };

        saralSwadhanPCVm.goBacktoPrevious = function() {
            if (saralSwadhanPCVm.isFromRetrieveApplication) {
                suggestedPlansDetailsService.getPlanDetails().then(function(data) {
                    suggestedPlansDetailsService.setPlanDetails(data);
                    $state.go("menu.planDetails");
                }, function(error) {
                });
            } else {
                $state.go("menu.planDetails");
            }
        };

        saralSwadhanPCVm.update = function() {
            if (saralSwadhanPCVm.validateService.isValidPolicyTermSS(saralSwadhanPCVm.data.policyTerm, saralSwadhanPCVm.data.age)) {
                saralSwadhanPCVm.saralSwadhanPCForm.policyTerm = saralSwadhanPCVm.validateService.isValidPolicyTermSS(saralSwadhanPCVm.data.policyTerm, saralSwadhanPCVm.data.age);

            }else{
                saralSwadhanPCVm.saralSwadhanPCForm = {};
            }
        }

        saralSwadhanPCVm.goToNextPage = function() {
            if (validateForm()) {

                saralSwadhanPCVm.premiumAmountNew = saralSwadhanPCVm.data.premiumAmount;

                var data = {};

                data.proposerName = saralSwadhanPCVm.data.proposerName;
                data.gender = saralSwadhanPCVm.data.gender;
                data.productCode = saralSwadhanPCVm.data.productCode;
                data.productName = saralSwadhanPCVm.data.productName;
                data.applicationNumber = saralSwadhanPCVm.data.applicationNumber;
                data.pfNumber = saralSwadhanPCVm.data.pfNumber;
                data.customerType = saralSwadhanPCVm.data.customerType;
                data.dob = saralSwadhanPCVm.data.dob;
                data.uin = saralSwadhanPCVm.data.uin;
                data.age = saralSwadhanPCVm.data.age.toString();
                data.premiumAmount = saralSwadhanPCVm.premiumAmountNew;
                data.policyTerm = saralSwadhanPCVm.data.policyTerm;
                data.premiumFreq = saralSwadhanPCVm.data.premiumFreq;
                data.email = saralSwadhanPCVm.data.email;
                data.mobileNumber = saralSwadhanPCVm.data.mobileNumber;

                premiumCalculationService.setPremiumCalculationSS1(data);

                premiumCalculationService.saveBI(LiConstant.journeyCommonId.PC_SARAL_SWADHAN).then(function(){
                premiumCalculationService.submitPremiumCalculationDataSS().then(function(data) {
                    premiumCalculationService.setJammuKashmir(false);
                    premiumCalculationService.setPremiumCalculationResponse(data);
                    $state.go("menu.premiumCalculation3");
                });

            });


            }}

            //common validation function
            function validateForm() {

                saralSwadhanPCVm.saralSwadhanPCForm = {};

                if (saralSwadhanPCVm.validateService.isValidBDaySS(saralSwadhanPCVm.data.dob)) {
                    saralSwadhanPCVm.saralSwadhanPCForm.birthDate = saralSwadhanPCVm.validateService.isValidBDaySS(saralSwadhanPCVm.data.dob);
                }

                if (saralSwadhanPCVm.validateService.isValidGender(saralSwadhanPCVm.data.gender)) {
                    saralSwadhanPCVm.saralSwadhanPCForm.gender = saralSwadhanPCVm.validateService.isValidGender(saralSwadhanPCVm.data.gender);
                }

                if (saralSwadhanPCVm.validateService.isValidSumAssuredSS(saralSwadhanPCVm.data.premiumAmount)) {
                    saralSwadhanPCVm.saralSwadhanPCForm.sumAssured = saralSwadhanPCVm.validateService.isValidSumAssuredSS(saralSwadhanPCVm.data.premiumAmount);
                }

                if (saralSwadhanPCVm.validateService.isValidPolicyTermSS(saralSwadhanPCVm.data.policyTerm, saralSwadhanPCVm.data.age)) {
                    saralSwadhanPCVm.saralSwadhanPCForm.policyTerm = saralSwadhanPCVm.validateService.isValidPolicyTermSS(saralSwadhanPCVm.data.policyTerm, saralSwadhanPCVm.data.age);
                }

                if (saralSwadhanPCVm.validateService.isValidPremiumFrequency(saralSwadhanPCVm.data.premiumFreq.key)) {
                    saralSwadhanPCVm.saralSwadhanPCForm.premiumFrequency = saralSwadhanPCVm.validateService.isValidPremiumFrequency(saralSwadhanPCVm.data.premiumFreq.key);
                }

                if (saralSwadhanPCVm.validateService.isValidEmail(saralSwadhanPCVm.data.email)) {
                    saralSwadhanPCVm.saralSwadhanPCForm.email = saralSwadhanPCVm.validateService.isValidEmail(saralSwadhanPCVm.data.email);
                }

                if (saralSwadhanPCVm.validateService.isValidPhoneNo(saralSwadhanPCVm.data.mobileNumber)) {
                    saralSwadhanPCVm.saralSwadhanPCForm.phoneNo = saralSwadhanPCVm.validateService.isValidPhoneNo(saralSwadhanPCVm.data.mobileNumber);
                }

                return (angular.equals({}, saralSwadhanPCVm.saralSwadhanPCForm)) ? true : false;
            }

        }


    
]);
