angularApp.controller('shubhNiveshPC2Controller', [
    "$state",
    "$scope",
    "$translate",
    "premiumCalculationService",
    "validateService",
    "utilityService",
    "lifeInsuranceCommonService",
    "LiConstant",
    "$ionicScrollDelegate",
    function(
        $state,
        $scope,
        $translate,
        premiumCalculationService,
        validateService,
        utilityService,
        lifeInsuranceCommonService,
        LiConstant,
        $ionicScrollDelegate) {


        var shubhNiveshPC2Vm = this;

        shubhNiveshPC2Vm.validateService = validateService;


        $scope.$on('$ionicView.beforeEnter', function() {

            initPage();
        });


        function initPage() {
            shubhNiveshPC2Vm.data = {};
            shubhNiveshPC2Vm.data.pta = {};
            shubhNiveshPC2Vm.data.atp = {};
            shubhNiveshPC2Vm.data.adb = {};

            var premiumDet = premiumCalculationService.getPremiumCalculationSN();

            shubhNiveshPC2Vm.sumAssured = premiumDet.sumAssured;
            shubhNiveshPC2Vm.maxTerm = premiumDet.policyTerm;

            if (premiumDet.pta ||
                premiumDet.adb ||
                premiumDet.atp) {
                shubhNiveshPC2Vm.data.isPTARider = premiumDet.isPTARider;
                shubhNiveshPC2Vm.data.isADBRider = premiumDet.isADBRider;
                shubhNiveshPC2Vm.data.isATPDBRider = premiumDet.isATPDBRider;
                shubhNiveshPC2Vm.data.adb = premiumDet.adb;
                shubhNiveshPC2Vm.data.pta = premiumDet.pta;
                shubhNiveshPC2Vm.data.atp = premiumDet.atp;
            }
        };

        shubhNiveshPC2Vm.closeJourney = function() {
            lifeInsuranceCommonService.closePopUp().then(function(result) {
                if (result) {
                    $state.go("menu.generalInsurance");
                }
            });
        };

        shubhNiveshPC2Vm.goBacktoPrevious = function() {
            $state.go("menu.shubhNiveshPremiumCalculation");
        }

        shubhNiveshPC2Vm.resize = function() {
            $ionicScrollDelegate.$getByHandle('mainScroll').resize();
        };


        shubhNiveshPC2Vm.Calculate = function() {

            if (validateForm()) {
                var totalRiderPremium = (shubhNiveshPC2Vm.data.pta.sumAssured ? Number(shubhNiveshPC2Vm.data.pta.sumAssured) : 0) + (shubhNiveshPC2Vm.data.adb.sumAssured ? Number(shubhNiveshPC2Vm.data.adb.sumAssured) : 0 ) +  (shubhNiveshPC2Vm.data.atp.sumAssured ? Number(shubhNiveshPC2Vm.data.atp.sumAssured) : 0);
                var selectPremium;
               if(shubhNiveshPC2Vm.data.isPTARider || shubhNiveshPC2Vm.data.isADBRider || shubhNiveshPC2Vm.data.isATPDBRider){
                    selectPremium =  false;
               }else{
                    selectPremium = true ; 
               }

                if (shubhNiveshPC2Vm.validateService.isValidRiderPremium(totalRiderPremium, shubhNiveshPC2Vm.sumAssured, 30) || selectPremium) {

                    shubhNiveshPC2Vm.newPTARiderSumAssuredPreferredTermAssuranceRider = shubhNiveshPC2Vm.data.pta.sumAssured;
                    shubhNiveshPC2Vm.newAPDBRiderSumAssured = shubhNiveshPC2Vm.data.atp.sumAssured;
                    shubhNiveshPC2Vm.newADBRiderSumAssured = shubhNiveshPC2Vm.data.adb.sumAssured;

                    var data = premiumCalculationService.getPremiumCalculationSN();

                    data.pta = {};

                    if (!shubhNiveshPC2Vm.data.isATPDBRider) {
                        data.isATPDBRider = false;
                    } else {
                        data.isATPDBRider = shubhNiveshPC2Vm.data.isATPDBRider;
                    }

                    if (!shubhNiveshPC2Vm.data.isADBRider) {
                        data.isADBRider = false;
                    } else {
                        data.isADBRider = shubhNiveshPC2Vm.data.isADBRider;
                    }

                    if (!shubhNiveshPC2Vm.data.isPTARider) {
                        data.isPTARider = false;
                    } else {
                        data.isPTARider = shubhNiveshPC2Vm.data.isPTARider;
                    }

                    data.pta.term = shubhNiveshPC2Vm.data.pta.term;
                    data.pta.sumAssured = shubhNiveshPC2Vm.newPTARiderSumAssuredPreferredTermAssuranceRider;
                    data.atp = {};
                    data.atp.term = shubhNiveshPC2Vm.data.atp.term;
                    data.atp.sumAssured = shubhNiveshPC2Vm.newAPDBRiderSumAssured;
                    data.adb = {};
                    data.adb.term = shubhNiveshPC2Vm.data.adb.term;
                    data.adb.sumAssured = shubhNiveshPC2Vm.newADBRiderSumAssured;

                    premiumCalculationService.setPremiumCalculationSN2(data);

                    premiumCalculationService.saveBI(LiConstant.journeyCommonId.PC_SHUBH_NIVESH_2).then(function() {
                        premiumCalculationService.submitPremiumCalculationDataSN().then(function(data) {
                            premiumCalculationService.setPremiumCalculationResponse(data);
                            $state.go("menu.premiumCalculation3");
                        });
                    });
                } else {
                    var title = '';
                    var buttontext = "OK";
                    var blankdata = null;
                    var detail = $translate.instant('RiderErrorMsg30');
                    utilityService.showAlertModal(title, detail, blankdata, blankdata, $state, buttontext);
                }
            }
        };

        shubhNiveshPC2Vm.ptrInfo = function() {
            var message = $translate.instant('SN_PTA_RIDER_INFO');
            var title = '';
            var template = "<p class='roboto-regular font-content'>"+message+"</p>";
            var onTap = '';
            var buttontext = "<b>OK</b>";
            utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
        };


        shubhNiveshPC2Vm.adbrInfo = function() {
            var message = $translate.instant('SN_ADBR_RIDER_INFO');
            var title = '';
            var template = "<p class='roboto-regular font-content'>"+message+"</p>";
            var onTap = '';
            var buttontext = "<b>OK</b>";
            utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
        };

        shubhNiveshPC2Vm.ptpdbInfo = function() {
            var message = $translate.instant('SN_PTPDB_RIDER_INFO');
            var title = '';
            var template = "<p class='roboto-regular font-content'>"+message+"</p>";
            var onTap = '';
            var buttontext = "<b>OK</b>";
            utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
        };



        //To Update PTA
        shubhNiveshPC2Vm.upPTA1 = function() {
            if (!shubhNiveshPC2Vm.data.isPTARider) {
                shubhNiveshPC2Vm.data.pta.term = "";
                shubhNiveshPC2Vm.data.pta.sumAssured = '';
            }
            shubhNiveshPC2Vm.resize();
        }

        shubhNiveshPC2Vm.upPTA2 = function() {
            if (!shubhNiveshPC2Vm.data.isADBRider) {
                shubhNiveshPC2Vm.data.adb.term = "";
                shubhNiveshPC2Vm.data.adb.sumAssured = '';
            }
            shubhNiveshPC2Vm.resize();

        }

        shubhNiveshPC2Vm.upPTA3 = function() {
            if (!shubhNiveshPC2Vm.data.isATPDBRider) {
                shubhNiveshPC2Vm.data.atp.term = "";
                shubhNiveshPC2Vm.data.atp.sumAssured = '';
            }
            shubhNiveshPC2Vm.resize();
        }

        //common validation function
        function validateForm() {

            shubhNiveshPC2Vm.frmPremiumCalculation2 = {};
            if (shubhNiveshPC2Vm.validateService.isPTARiderTerm(shubhNiveshPC2Vm.data.pta.term, shubhNiveshPC2Vm.data.isPTARider, shubhNiveshPC2Vm.maxTerm)) {
                shubhNiveshPC2Vm.frmPremiumCalculation2.PTARiderTermPreferredTermAssuranceRiderVMsg = shubhNiveshPC2Vm.validateService.isPTARiderTerm(shubhNiveshPC2Vm.data.pta.term, shubhNiveshPC2Vm.data.isPTARider, shubhNiveshPC2Vm.maxTerm);

            }
            if (shubhNiveshPC2Vm.validateService.isPTARiderSumAssuredADBRider(shubhNiveshPC2Vm.data.pta.sumAssured, shubhNiveshPC2Vm.sumAssured, shubhNiveshPC2Vm.data.isPTARider)) {
                shubhNiveshPC2Vm.frmPremiumCalculation2.PTARiderSumAssuredPreferredTermAssuranceRiderVMsg = shubhNiveshPC2Vm.validateService.isPTARiderSumAssuredADBRider(shubhNiveshPC2Vm.data.pta.sumAssured, shubhNiveshPC2Vm.sumAssured, shubhNiveshPC2Vm.data.isPTARider);

            }
            if (shubhNiveshPC2Vm.validateService.isPTARiderTermAD(shubhNiveshPC2Vm.data.adb.term, shubhNiveshPC2Vm.data.isADBRider, shubhNiveshPC2Vm.maxTerm)) {
                shubhNiveshPC2Vm.frmPremiumCalculation2.PTARiderTermPreferredTermAssuranceRiderADVMsg = shubhNiveshPC2Vm.validateService.isPTARiderTermAD(shubhNiveshPC2Vm.data.adb.term, shubhNiveshPC2Vm.data.isADBRider, shubhNiveshPC2Vm.maxTerm);

            }
            if (shubhNiveshPC2Vm.validateService.isPTARiderTermADis(shubhNiveshPC2Vm.data.atp.term, shubhNiveshPC2Vm.data.isATPDBRider, shubhNiveshPC2Vm.maxTerm)) {
                shubhNiveshPC2Vm.frmPremiumCalculation2.PTARiderTermPreferredTermAssuranceRiderADisVMsg = shubhNiveshPC2Vm.validateService.isPTARiderTermADis(shubhNiveshPC2Vm.data.atp.term, shubhNiveshPC2Vm.data.isATPDBRider, shubhNiveshPC2Vm.maxTerm);

            }
            if (shubhNiveshPC2Vm.validateService.isPTARiderSumAssuredADBRider(shubhNiveshPC2Vm.data.adb.sumAssured, shubhNiveshPC2Vm.sumAssured, shubhNiveshPC2Vm.data.isADBRider)) {
                shubhNiveshPC2Vm.frmPremiumCalculation2.PTARiderSumAssuredADBRiderSumAssuredVMsg = shubhNiveshPC2Vm.validateService.isPTARiderSumAssuredADBRider(shubhNiveshPC2Vm.data.adb.sumAssured, shubhNiveshPC2Vm.sumAssured, shubhNiveshPC2Vm.data.isADBRider);
            }
            if (shubhNiveshPC2Vm.validateService.isPTARiderSumAssuredADBRider(shubhNiveshPC2Vm.data.atp.sumAssured, shubhNiveshPC2Vm.sumAssured, shubhNiveshPC2Vm.data.isATPDBRider)) {
                shubhNiveshPC2Vm.frmPremiumCalculation2.PTARiderSumAssuredAPDBRiderSumAssuredVMsg = shubhNiveshPC2Vm.validateService.isPTARiderSumAssuredADBRider(shubhNiveshPC2Vm.data.atp.sumAssured, shubhNiveshPC2Vm.sumAssured, shubhNiveshPC2Vm.data.isATPDBRider);
            }


            return (angular.equals({}, shubhNiveshPC2Vm.frmPremiumCalculation2)) ? true : false;
        }

    }
]);
