angularApp.controller('shubhNiveshPCController', [
    "$state",
    "$scope",
    "$translate",
    "validateService",
    "premiumCalculationService",
    "suggestedPlansDetailsService",
    "lifeInsuranceApplicationService",
    "lifeInsuranceCommonService",
    "LiConstant",


    function(
        $state,
        $scope,
        $translate,
        validateService,
        premiumCalculationService,
        suggestedPlansDetailsService,
        lifeInsuranceApplicationService,
        lifeInsuranceCommonService,
        LiConstant) {

        var shubhNiveshPCVm = this;
        var b = $translate.instant('SelectPlanOption');
        var c = $translate.instant('SelectFreq');
        var d = $translate.instant('SelectFreqPlan');
        var e = $translate.instant('SelectMonthlyPremium');


        function initPage() {

            shubhNiveshPCVm.showBack = true;
            shubhNiveshPCVm.showNext = true;
            shubhNiveshPCVm.disableBack = false;
            shubhNiveshPCVm.disableNext = false;
            shubhNiveshPCVm.data = {};
            shubhNiveshPCVm.shubhNiveshPCForm = {};
            shubhNiveshPCVm.data.premiumFreq = {};
            shubhNiveshPCVm.data.planName = {};
            shubhNiveshPCVm.validateService = validateService;

            shubhNiveshPCVm.isFromRetrieveApplication = lifeInsuranceCommonService.isFromRetrieveApplication();


            shubhNiveshPCVm.jkResidents = [
                'No', 'Yes'
            ];
            getMasterDataPlans();

            if (premiumCalculationService.getPremiumCalculationSN().age) {
                shubhNiveshPCVm.data = premiumCalculationService.getPremiumCalculationSN();
                shubhNiveshPCVm.updateByPlanOpt();
                shubhNiveshPCVm.updateByFreq();
            } else {
                shubhNiveshPCVm.policyTerms = [d];
            }

            if (!shubhNiveshPCVm.isFromRetrieveApplication) {
                var bankDet = lifeInsuranceApplicationService.getAccoutDetails();
                shubhNiveshPCVm.data.pfNumber = bankDet.cbsData.pfNumber;
                shubhNiveshPCVm.data.customerType = bankDet.cbsData.customerType;
            }


            var details = lifeInsuranceApplicationService.getPersonalDetails();

            var curSug = suggestedPlansDetailsService.getCurrentSugestedProduct();

            shubhNiveshPCVm.data.dob = details.dob;

            shubhNiveshPCVm.data.age = shubhNiveshPCVm.validateService.calcAge(shubhNiveshPCVm.data.dob);
            if (details.name.middle && details.name.last) {
                shubhNiveshPCVm.data.proposerName = details.name.first + " " + details.name.middle + " " + details.name.last;
            }

            if (details.name.middle && !details.name.last) {
                shubhNiveshPCVm.data.proposerName = details.name.first + " " + details.name.middle;
            }

            if (!details.name.middle && details.name.last) {
                shubhNiveshPCVm.data.proposerName = details.name.first + " " + details.name.last;
            }

            if (!details.name.middle && !details.name.last) {
                shubhNiveshPCVm.data.proposerName = details.name.first;
            }
            shubhNiveshPCVm.data.gender = details.gender;
            shubhNiveshPCVm.data.productCode = curSug.productCode;
            shubhNiveshPCVm.data.productName = curSug.planName;

            shubhNiveshPCVm.data.uin = curSug.uin;
            shubhNiveshPCVm.data.applicationNumber = lifeInsuranceApplicationService.getApplicationNumber();

        }


        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });


        shubhNiveshPCVm.closeJourney = function() {
            lifeInsuranceCommonService.closePopUp().then(function(result) {
                if (result) {
                    $state.go("menu.generalInsurance");
                }
            });
        };

        function getMasterDataPlans() {

            var response = premiumCalculationService.getPremiumMasters().shubhNivesh;
            shubhNiveshPCVm.policyTermss = response.policyTerms;
            shubhNiveshPCVm.planOptions = response.planOptions;
            shubhNiveshPCVm.premiumFrequencys = response.premiumFrequencies;

            if (shubhNiveshPCVm.premiumFrequencys.length == 1) {
                shubhNiveshPCVm.data.premiumFreq = shubhNiveshPCVm.premiumFrequencys[0];
            }
        }

        shubhNiveshPCVm.updateErr = function() {
            if (shubhNiveshPCVm.validateService.isValidPolicyTermSN(shubhNiveshPCVm.data.policyTerm, shubhNiveshPCVm.data.age, shubhNiveshPCVm.data.planName.key)) {
                shubhNiveshPCVm.shubhNiveshPCForm.policyTerm = shubhNiveshPCVm.validateService.isValidPolicyTermSN(shubhNiveshPCVm.data.policyTerm, shubhNiveshPCVm.data.age, shubhNiveshPCVm.data.planName.key);
            } else {
                shubhNiveshPCVm.shubhNiveshPCForm = {};
            }
        }


        shubhNiveshPCVm.updateByPlanOpt = function() {
            if (shubhNiveshPCVm.data.premiumFreq.key == undefined) {
                shubhNiveshPCVm.policyTerms = [c];
            } else if (shubhNiveshPCVm.data.premiumFreq.key !== 'Single') {
                if (shubhNiveshPCVm.data.planName.key == 'Endowment Option') {
                    shubhNiveshPCVm.policyTerms = shubhNiveshPCVm.policyTermss.endowment7;
                }
                if (shubhNiveshPCVm.data.planName.key == 'Endowment with Whole Life Option') {
                    shubhNiveshPCVm.policyTerms = shubhNiveshPCVm.policyTermss.endowmentWholeLife;
                }
            } else {

                if (shubhNiveshPCVm.data.planName.key == 'Endowment Option') {
                    shubhNiveshPCVm.policyTerms = shubhNiveshPCVm.policyTermss.endowment5;
                }
                if (shubhNiveshPCVm.data.planName.key == 'Endowment with Whole Life Option') {
                    shubhNiveshPCVm.policyTerms = shubhNiveshPCVm.policyTermss.endowmentWholeLife;
                }
            }
        }

        shubhNiveshPCVm.updateByFreq = function() {
            if (shubhNiveshPCVm.data.premiumFreq.key == 'Monthly') {
                shubhNiveshPCVm.monthlyPremium = e;
            }

            if (shubhNiveshPCVm.data.planName.key == undefined) {
                shubhNiveshPCVm.policyTerms = [b];
            } else if (shubhNiveshPCVm.data.planName.key == 'Endowment Option') {
                if (shubhNiveshPCVm.data.premiumFreq.key !== 'Single') {
                    shubhNiveshPCVm.policyTerms = shubhNiveshPCVm.policyTermss.endowment7;
                }
                if (shubhNiveshPCVm.data.premiumFreq.key == 'Single') {
                    shubhNiveshPCVm.policyTerms = shubhNiveshPCVm.policyTermss.endowment5;
                }
            } else if (shubhNiveshPCVm.data.planName.key == 'Endowment with Whole Life Option') {
                shubhNiveshPCVm.policyTerms = shubhNiveshPCVm.policyTermss.endowmentWholeLife;

            }

        }

        shubhNiveshPCVm.goBacktoPrevious = function() {
            if (shubhNiveshPCVm.isFromRetrieveApplication) {
                suggestedPlansDetailsService.getPlanDetails().then(function(data) {
                    suggestedPlansDetailsService.setPlanDetails(data);
                    $state.go("menu.planDetails");
                }, function(error) {

                });
            } else {
                $state.go("menu.planDetails");
            }
        }

        //onclick of submit button
        shubhNiveshPCVm.goToNextPage = function() {
            if (validateForm()) {

                shubhNiveshPCVm.sumAssuredNew = shubhNiveshPCVm.data.sumAssured;

                var data = premiumCalculationService.getPremiumCalculationSN() || {};

                data.proposerName = shubhNiveshPCVm.data.proposerName;
                data.age = shubhNiveshPCVm.data.age.toString();
                data.uin = shubhNiveshPCVm.data.uin;
                data.productCode = shubhNiveshPCVm.data.productCode;
                data.productName = shubhNiveshPCVm.data.productName;
                data.applicationNumber = shubhNiveshPCVm.data.applicationNumber;
                data.pfNumber = shubhNiveshPCVm.data.pfNumber;
                data.customerType = shubhNiveshPCVm.data.customerType;
                data.dob = shubhNiveshPCVm.data.dob;
                data.gender = shubhNiveshPCVm.data.gender;
                data.sumAssured = shubhNiveshPCVm.sumAssuredNew;
                data.policyTerm = shubhNiveshPCVm.data.policyTerm;
                data.planName = shubhNiveshPCVm.data.planName;
                data.premiumFreq = shubhNiveshPCVm.data.premiumFreq;
                data.email = shubhNiveshPCVm.data.email;
                data.mobileNumber = shubhNiveshPCVm.data.mobileNumber;
                data.isJkResident = shubhNiveshPCVm.jkResident;

                premiumCalculationService.setPremiumCalculationSN1(data);
                premiumCalculationService.saveBI(LiConstant.journeyCommonId.PC_SHUBH_NIVESH).then(function() {
                    premiumCalculationService.setJammuKashmir(shubhNiveshPCVm.jkResident);
                    $state.go("menu.shubhNiveshRider");
                })
            }
        }

        //common validation function
        function validateForm() {

            shubhNiveshPCVm.shubhNiveshPCForm = {};
            if (shubhNiveshPCVm.validateService.isValidBDaySN(shubhNiveshPCVm.data.dob, shubhNiveshPCVm.data.planName.key, shubhNiveshPCVm.data.premiumFreq.key)) {
                shubhNiveshPCVm.shubhNiveshPCForm.birthDate = shubhNiveshPCVm.validateService.isValidBDaySN(shubhNiveshPCVm.data.dob, shubhNiveshPCVm.data.planName.key, shubhNiveshPCVm.data.premiumFreq.key);
            }

            if (shubhNiveshPCVm.validateService.isValidGender(shubhNiveshPCVm.data.gender)) {
                shubhNiveshPCVm.shubhNiveshPCForm.gender = shubhNiveshPCVm.validateService.isValidGender(shubhNiveshPCVm.data.gender);
            }

            if (shubhNiveshPCVm.validateService.isValidSumAssuredSN(shubhNiveshPCVm.data.sumAssured)) {
                shubhNiveshPCVm.shubhNiveshPCForm.sumAssured = shubhNiveshPCVm.validateService.isValidSumAssuredSN(shubhNiveshPCVm.data.sumAssured);
            }

            if (shubhNiveshPCVm.validateService.isValidPolicyTermSN(shubhNiveshPCVm.data.policyTerm, shubhNiveshPCVm.data.age, shubhNiveshPCVm.data.planName.key)) {
                shubhNiveshPCVm.shubhNiveshPCForm.policyTerm = shubhNiveshPCVm.validateService.isValidPolicyTermSN(shubhNiveshPCVm.data.policyTerm, shubhNiveshPCVm.data.age, shubhNiveshPCVm.data.planName.key);
            }

            if (shubhNiveshPCVm.validateService.isValidPlanOption(shubhNiveshPCVm.data.planName.key)) {
                shubhNiveshPCVm.shubhNiveshPCForm.planOption = shubhNiveshPCVm.validateService.isValidPlanOption(shubhNiveshPCVm.data.planName.key);
            }

            if (shubhNiveshPCVm.validateService.isValidPremiumFrequency(shubhNiveshPCVm.data.premiumFreq.key)) {
                shubhNiveshPCVm.shubhNiveshPCForm.premiumFrequency = shubhNiveshPCVm.validateService.isValidPremiumFrequency(shubhNiveshPCVm.data.premiumFreq.key);
            }

            if (shubhNiveshPCVm.validateService.isValidEmail(shubhNiveshPCVm.data.email)) {
                shubhNiveshPCVm.shubhNiveshPCForm.email = shubhNiveshPCVm.validateService.isValidEmail(shubhNiveshPCVm.data.email);
            }

            if (shubhNiveshPCVm.validateService.isValidPhoneNo(shubhNiveshPCVm.data.mobileNumber)) {
                shubhNiveshPCVm.shubhNiveshPCForm.phoneNo = shubhNiveshPCVm.validateService.isValidPhoneNo(shubhNiveshPCVm.data.mobileNumber);
            }

            if (shubhNiveshPCVm.validateService.isValidJkResident(shubhNiveshPCVm.jkResident)) {
                shubhNiveshPCVm.shubhNiveshPCForm.jkResident = shubhNiveshPCVm.validateService.isValidJkResident(shubhNiveshPCVm.jkResident);
            }

            return (angular.equals({}, shubhNiveshPCVm.shubhNiveshPCForm)) ? true : false;
        }
    }
]);
