angularApp.controller('smartChampInsurancePCController', [
    "$state",
    "$scope",
    "$translate",
    "validateService",
    "lifeInsuranceApplicationService",
    "suggestedPlansDetailsService",
    "premiumCalculationService",
    "lifeInsuranceCommonService",
    "LiConstant",


    function(
        $state,
        $scope,
        $translate,
        validateService,
        lifeInsuranceApplicationService,
        suggestedPlansDetailsService,
        premiumCalculationService,
        lifeInsuranceCommonService,
        LiConstant) {

        var smartChampInsurancePCVm = this;
        var e = $translate.instant('SelectMonthlyPremium');
        smartChampInsurancePCVm.smartChampInsurancePCForm = {};
        smartChampInsurancePCVm.validateService = validateService;


        function getMasterDataPlans() {
            var response = premiumCalculationService.getPremiumMasters().smartChamp;
            smartChampInsurancePCVm.childAges = response.ageOfChild;
            smartChampInsurancePCVm.premiumFrequencys = response.premiumFrequencies;
        }

        function initPage() {

            smartChampInsurancePCVm.data = {};
            smartChampInsurancePCVm.data.child = {};
            smartChampInsurancePCVm.data.premiumFreq = {};

            smartChampInsurancePCVm.isFromRetrieveApplication = lifeInsuranceCommonService.isFromRetrieveApplication();

            smartChampInsurancePCVm.jkResidents = [
                'No', 'Yes'
            ];

            smartChampInsurancePCVm.showBack = true;
            smartChampInsurancePCVm.showNext = true;
            smartChampInsurancePCVm.disableBack = false;
            smartChampInsurancePCVm.disableNext = false;

            getMasterDataPlans();

            if (premiumCalculationService.getPremiumCalculationSC().lifeassuredAge) {
                smartChampInsurancePCVm.data = premiumCalculationService.getPremiumCalculationSC();
                if (premiumCalculationService.getChildName()) {
                    smartChampInsurancePCVm.data.child = premiumCalculationService.getChildName();
                }
                smartChampInsurancePCVm.updateByFreq();
                smartChampInsurancePCVm.update(smartChampInsurancePCVm.data.premFreq.key, smartChampInsurancePCVm.data.childage);
            }

            if (!smartChampInsurancePCVm.isFromRetrieveApplication) {
                var bankDet = lifeInsuranceApplicationService.getAccoutDetails();
                smartChampInsurancePCVm.data.pfNumber = bankDet.cbsData.pfNumber;
                smartChampInsurancePCVm.data.customerType = bankDet.cbsData.customerType;

            }


            var details = lifeInsuranceApplicationService.getPersonalDetails();
            var curSug = suggestedPlansDetailsService.getCurrentSugestedProduct();

            smartChampInsurancePCVm.data.dob = details.dob;


            if (details.name.middle && details.name.last) {
                smartChampInsurancePCVm.data.proposerName = details.name.first + " " + details.name.middle + " " + details.name.last;
            }

            if (details.name.middle && !details.name.last) {
                smartChampInsurancePCVm.data.proposerName = details.name.first + " " + details.name.middle;
            }

            if (!details.name.middle && details.name.last) {
                smartChampInsurancePCVm.data.proposerName = details.name.first + " " + details.name.last;
            }

            if (!details.name.middle && !details.name.last) {
                smartChampInsurancePCVm.data.proposerName = details.name.first;
            }


            smartChampInsurancePCVm.data.gender = details.gender;
            smartChampInsurancePCVm.data.productCode = curSug.productCode;
            smartChampInsurancePCVm.data.productName = curSug.planName;
            smartChampInsurancePCVm.data.uin = curSug.uin;
            smartChampInsurancePCVm.data.applicationNumber = lifeInsuranceApplicationService.getApplicationNumber();
            smartChampInsurancePCVm.data.lifeassuredAge = smartChampInsurancePCVm.validateService.calcAge(smartChampInsurancePCVm.data.dob);
        }



        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });


        smartChampInsurancePCVm.closeJourney = function() {
            lifeInsuranceCommonService.closePopUp().then(function(result) {
                if (result) {
                    $state.go("menu.generalInsurance");
                }
            });
        };

        smartChampInsurancePCVm.update = function(freq, age) {

            if (freq !== 'Single') {
                smartChampInsurancePCVm.premiumPaymentTerm = Number(18 - age);
            }
            smartChampInsurancePCVm.data.policyTerm = Number(21 - age);
        };

        smartChampInsurancePCVm.updateByFreq = function() {
            if (smartChampInsurancePCVm.data.premFreq.key == 'Monthly') {
                smartChampInsurancePCVm.monthlyPremium = e;
            }
        };

        smartChampInsurancePCVm.goBacktoPrevious = function() {
            if (smartChampInsurancePCVm.isFromRetrieveApplication) {
                suggestedPlansDetailsService.getPlanDetails().then(function(data) {
                    suggestedPlansDetailsService.setPlanDetails(data);
                    $state.go("menu.planDetails");
                }, function(error) {

                });
            } else {
                $state.go("menu.planDetails");
            }
        };

        smartChampInsurancePCVm.goToNextPage = function() {
            if (validateForm()) {
                var data = {};

                data.lifeassuredAge = smartChampInsurancePCVm.data.lifeassuredAge.toString();
                data.childage = smartChampInsurancePCVm.data.childage.toString();
                data.childName = smartChampInsurancePCVm.data.child.first + " " + smartChampInsurancePCVm.data.child.middle + " " + smartChampInsurancePCVm.data.child.last;
                data.uin = smartChampInsurancePCVm.data.uin;
                data.productCode = smartChampInsurancePCVm.data.productCode;
                data.productName = smartChampInsurancePCVm.data.productName;
                data.dob = smartChampInsurancePCVm.data.dob;


                data.applicationNumber = smartChampInsurancePCVm.data.applicationNumber;
                data.pfNumber = smartChampInsurancePCVm.data.pfNumber;
                data.customerType = smartChampInsurancePCVm.data.customerType;

                data.proposerName = smartChampInsurancePCVm.data.proposerName;
                data.gender = smartChampInsurancePCVm.data.gender;
                smartChampInsurancePCVm.sumAssuredNew = smartChampInsurancePCVm.data.sumAssured;
                data.sumAssured = smartChampInsurancePCVm.sumAssuredNew;
                data.policyTerm = smartChampInsurancePCVm.data.policyTerm;
                data.premFreq = smartChampInsurancePCVm.data.premFreq;
                data.email = smartChampInsurancePCVm.data.email;
                data.mobileNumber = smartChampInsurancePCVm.data.mobileNumber;
                data.isJkResident = smartChampInsurancePCVm.data.isJkResident;

                premiumCalculationService.setChildName(smartChampInsurancePCVm.data.child);

                premiumCalculationService.setPremiumCalculationSC1(data);

                premiumCalculationService.setJammuKashmir(smartChampInsurancePCVm.data.isJkResident);

                premiumCalculationService.saveBI(LiConstant.journeyCommonId.PC_SMART_CHAMP).then(function() {
                    premiumCalculationService.submitPremiumCalculationDataSC().then(function(data) {
                        premiumCalculationService.setPremiumCalculationResponse(data);
                        $state.go("menu.premiumCalculation3");
                    });
                });
            }
        }

        //common validation function
        function validateForm() {
            smartChampInsurancePCVm.smartChampInsurancePCForm = {};

            if (smartChampInsurancePCVm.validateService.isValidBDaySC(smartChampInsurancePCVm.data.dob)) {
                smartChampInsurancePCVm.smartChampInsurancePCForm.birthDate = smartChampInsurancePCVm.validateService.isValidBDaySC(smartChampInsurancePCVm.data.dob);
            }

            if (smartChampInsurancePCVm.validateService.isValidGender(smartChampInsurancePCVm.data.gender)) {
                smartChampInsurancePCVm.smartChampInsurancePCForm.gender = smartChampInsurancePCVm.validateService.isValidGender(smartChampInsurancePCVm.data.gender);
            }

            if (smartChampInsurancePCVm.validateService.isValidSumAssuredSC(smartChampInsurancePCVm.data.sumAssured)) {
                smartChampInsurancePCVm.smartChampInsurancePCForm.sumAssured = smartChampInsurancePCVm.validateService.isValidSumAssuredSC(smartChampInsurancePCVm.data.sumAssured);
            }

            if (smartChampInsurancePCVm.validateService.isValidName(smartChampInsurancePCVm.data.child.first)) {
                smartChampInsurancePCVm.smartChampInsurancePCForm.childName = smartChampInsurancePCVm.validateService.isValidName(smartChampInsurancePCVm.data.child.first);
            }

            if (smartChampInsurancePCVm.validateService.isValidNomineeLastName(smartChampInsurancePCVm.data.child.last)) {
                smartChampInsurancePCVm.smartChampInsurancePCForm.childLastName = smartChampInsurancePCVm.validateService.isValidNomineeLastName(smartChampInsurancePCVm.data.child.last);
            }

            if (smartChampInsurancePCVm.validateService.isValidMiddleLastName(smartChampInsurancePCVm.data.child.middle)) {
                smartChampInsurancePCVm.smartChampInsurancePCForm.childMiddleName = smartChampInsurancePCVm.validateService.isValidMiddleLastName(smartChampInsurancePCVm.data.child.middle);
            }

            if (smartChampInsurancePCVm.validateService.isValidchildAge(smartChampInsurancePCVm.data.childage)) {
                smartChampInsurancePCVm.smartChampInsurancePCForm.childAge = smartChampInsurancePCVm.validateService.isValidchildAge(smartChampInsurancePCVm.data.childage);
            }

            if (smartChampInsurancePCVm.validateService.isValidMaturitySC(smartChampInsurancePCVm.data.lifeassuredAge, smartChampInsurancePCVm.data.policyTerm)) {
                smartChampInsurancePCVm.smartChampInsurancePCForm.childAge = smartChampInsurancePCVm.validateService.isValidMaturitySC(smartChampInsurancePCVm.data.lifeassuredAge, smartChampInsurancePCVm.data.policyTerm);
            }

            if (smartChampInsurancePCVm.validateService.isValidEmail(smartChampInsurancePCVm.data.email)) {
                smartChampInsurancePCVm.smartChampInsurancePCForm.email = smartChampInsurancePCVm.validateService.isValidEmail(smartChampInsurancePCVm.data.email);
            }

            if (smartChampInsurancePCVm.validateService.isValidPhoneNo(smartChampInsurancePCVm.data.mobileNumber)) {
                smartChampInsurancePCVm.smartChampInsurancePCForm.phoneNo = smartChampInsurancePCVm.validateService.isValidPhoneNo(smartChampInsurancePCVm.data.mobileNumber);
            }

            if (smartChampInsurancePCVm.validateService.isValidJkResident(smartChampInsurancePCVm.data.isJkResident)) {
                smartChampInsurancePCVm.smartChampInsurancePCForm.jkResident = smartChampInsurancePCVm.validateService.isValidJkResident(smartChampInsurancePCVm.data.isJkResident);
            }
            return (angular.equals({}, smartChampInsurancePCVm.smartChampInsurancePCForm)) ? true : false;
        }
    }

]);
