angularApp.controller('smartMoneyBackGoldPCController', [
    "$state",
    "$scope",
    "$translate",
    "validateService",
    "premiumCalculationService",
    "lifeInsuranceApplicationService",
    "suggestedPlansDetailsService",
    "lifeInsuranceCommonService",
    "LiConstant",

    function(
        $state,
        $scope,
        $translate,
        validateService,
        premiumCalculationService,
        lifeInsuranceApplicationService,
        suggestedPlansDetailsService,
        lifeInsuranceCommonService,
        LiConstant) {

        var smartMoneyBackGoldPCVm = this;
        var noValue = $translate.instant("PleaseSelectPlanOption");
        var currentDate = validateService.getCurrentDate();
        var e = $translate.instant('SelectMonthlyPremium');

        smartMoneyBackGoldPCVm.validateService = validateService;


        function getMasterDataPlans() {

            var response = premiumCalculationService.getPremiumMasters().smartBackMoneyGold;

            smartMoneyBackGoldPCVm.policyTermss = response.policyTerms;
            smartMoneyBackGoldPCVm.planOptions = response.planOptions;
            smartMoneyBackGoldPCVm.premiumFrequencys = response.premiumFrequencies;

        }


        function initPage() {

            smartMoneyBackGoldPCVm.data = {};
            smartMoneyBackGoldPCVm.smartMoneyBackGoldPCForm = {};
            smartMoneyBackGoldPCVm.data.premiumFreq = {};
            smartMoneyBackGoldPCVm.data.planName = {};
            smartMoneyBackGoldPCVm.showBack = true;
            smartMoneyBackGoldPCVm.showNext = true;
            smartMoneyBackGoldPCVm.disableBack = false;
            smartMoneyBackGoldPCVm.disableNext = false;

            smartMoneyBackGoldPCVm.jkResidents = [
                'No', 'Yes'
            ];

            getMasterDataPlans();

            smartMoneyBackGoldPCVm.isFromRetrieveApplication = lifeInsuranceCommonService.isFromRetrieveApplication();

            if (premiumCalculationService.getPremiumCalculationFData().age) {
                smartMoneyBackGoldPCVm.data = premiumCalculationService.getPremiumCalculationFData();
                smartMoneyBackGoldPCVm.changeByPlan();
                smartMoneyBackGoldPCVm.updateByFreq();
            } else {

                smartMoneyBackGoldPCVm.policyTerms = [noValue];
            }

            if (!smartMoneyBackGoldPCVm.isFromRetrieveApplication) {
                var bankDet = lifeInsuranceApplicationService.getAccoutDetails();
                smartMoneyBackGoldPCVm.data.pfNumber = bankDet.cbsData.pfNumber;
                smartMoneyBackGoldPCVm.data.customerType = bankDet.cbsData.customerType;
            }


            var details = lifeInsuranceApplicationService.getPersonalDetails();
            var curSug = suggestedPlansDetailsService.getCurrentSugestedProduct();


            smartMoneyBackGoldPCVm.data.dob = details.dob;


            if (details.name.middle && details.name.last) {
                smartMoneyBackGoldPCVm.data.proposerName = details.name.first + " " + details.name.middle + " " + details.name.last;
            }

            if (details.name.middle && !details.name.last) {
                smartMoneyBackGoldPCVm.data.proposerName = details.name.first + " " + details.name.middle;
            }

            if (!details.name.middle && details.name.last) {
                smartMoneyBackGoldPCVm.data.proposerName = details.name.first + " " + details.name.last;
            }

            if (!details.name.middle && !details.name.last) {
                smartMoneyBackGoldPCVm.data.proposerName = details.name.first;
            }

            smartMoneyBackGoldPCVm.data.productCode = curSug.productCode;
            smartMoneyBackGoldPCVm.data.productName = curSug.planName;

            smartMoneyBackGoldPCVm.data.uin = curSug.uin;
            smartMoneyBackGoldPCVm.data.gender = details.gender;
            smartMoneyBackGoldPCVm.data.age = smartMoneyBackGoldPCVm.validateService.calcAge(smartMoneyBackGoldPCVm.data.dob);

            smartMoneyBackGoldPCVm.data.applicationNumber = lifeInsuranceApplicationService.getApplicationNumber();
        }




        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });



        smartMoneyBackGoldPCVm.goBacktoPrevious = function() {
            if (smartMoneyBackGoldPCVm.isFromRetrieveApplication) {
                suggestedPlansDetailsService.getPlanDetails().then(function(data) {
                    suggestedPlansDetailsService.setPlanDetails(data);
                    $state.go("menu.planDetails");
                }, function(error) {

                });
            } else {
                $state.go("menu.planDetails");
            }
        }

        smartMoneyBackGoldPCVm.updateErr = function() {
            if (smartMoneyBackGoldPCVm.validateService.isValidPolicyTermSM(smartMoneyBackGoldPCVm.data.policyTerm, smartMoneyBackGoldPCVm.data.age)) {
                smartMoneyBackGoldPCVm.smartMoneyBackGoldPCForm.policyTerm = smartMoneyBackGoldPCVm.validateService.isValidPolicyTermSM(smartMoneyBackGoldPCVm.data.policyTerm, smartMoneyBackGoldPCVm.data.age);
            } else {
                smartMoneyBackGoldPCVm.smartMoneyBackGoldPCForm = {};
            }
        };



        //onclick of submit button
        smartMoneyBackGoldPCVm.goToNextPage = function() {
            if (validateForm()) {
                var data = premiumCalculationService.getPremiumCalculationFData() || {};
                data.proposerName = smartMoneyBackGoldPCVm.data.proposerName;
                data.dob = smartMoneyBackGoldPCVm.data.dob;
                data.age = smartMoneyBackGoldPCVm.data.age.toString();
                data.productCode = smartMoneyBackGoldPCVm.data.productCode;
                data.productName = smartMoneyBackGoldPCVm.data.productName;
                data.uin = smartMoneyBackGoldPCVm.data.uin;
                data.gender = smartMoneyBackGoldPCVm.data.gender;

                smartMoneyBackGoldPCVm.data.sumAssuredNew = smartMoneyBackGoldPCVm.data.sumAssured;

                data.sumAssured = smartMoneyBackGoldPCVm.data.sumAssuredNew;
                data.policyTerm = smartMoneyBackGoldPCVm.data.policyTerm;
                data.planName = smartMoneyBackGoldPCVm.data.planName;
                data.premiumFreq = smartMoneyBackGoldPCVm.data.premiumFreq;
                data.email = smartMoneyBackGoldPCVm.data.email;
                data.mobileNumber = smartMoneyBackGoldPCVm.data.mobileNumber;
                data.isJkResident = smartMoneyBackGoldPCVm.data.isJkResident;

                data.applicationNumber = smartMoneyBackGoldPCVm.data.applicationNumber;
                data.pfNumber = smartMoneyBackGoldPCVm.data.pfNumber;
                data.customerType = smartMoneyBackGoldPCVm.data.customerType;

                premiumCalculationService.setPremiumCalculationFData1(data);
                premiumCalculationService.saveBI(LiConstant.journeyCommonId.PC_SMBG).then(function() {
                    premiumCalculationService.setAssuredAmount(smartMoneyBackGoldPCVm.data.sumAssured);
                    premiumCalculationService.setpolicyTerm(smartMoneyBackGoldPCVm.data.policyTerm);
                    premiumCalculationService.setJammuKashmir(smartMoneyBackGoldPCVm.data.isJkResident);
                    $state.go("menu.premiumCalculation2");

                });
            }
        }

        smartMoneyBackGoldPCVm.changeByPlan = function() {
            if (smartMoneyBackGoldPCVm.data.planName.key == "Option 1") {
                smartMoneyBackGoldPCVm.policyTerms = smartMoneyBackGoldPCVm.policyTermss.option1;
                smartMoneyBackGoldPCVm.data.policyTerm = smartMoneyBackGoldPCVm.policyTerms[0];
            } else if (smartMoneyBackGoldPCVm.data.planName.key == "Option 2") {
                smartMoneyBackGoldPCVm.policyTerms = smartMoneyBackGoldPCVm.policyTermss.option2;
                smartMoneyBackGoldPCVm.data.policyTerm = smartMoneyBackGoldPCVm.policyTerms[0];
            } else if (smartMoneyBackGoldPCVm.data.planName.key == "Option 3") {
                smartMoneyBackGoldPCVm.policyTerms = smartMoneyBackGoldPCVm.policyTermss.option3;
                smartMoneyBackGoldPCVm.data.policyTerm = smartMoneyBackGoldPCVm.policyTerms[0];
            } else if (smartMoneyBackGoldPCVm.data.planName.key == "Option 4") {
                smartMoneyBackGoldPCVm.policyTerms = smartMoneyBackGoldPCVm.policyTermss.option4;
                smartMoneyBackGoldPCVm.data.policyTerm = smartMoneyBackGoldPCVm.policyTerms[0];
            }
        }

        smartMoneyBackGoldPCVm.updateByFreq = function() {
            if (smartMoneyBackGoldPCVm.data.premiumFreq.key == 'Monthly') {
                smartMoneyBackGoldPCVm.monthlyPremium = e;
            }
        }

        smartMoneyBackGoldPCVm.closeJourney = function() {
            lifeInsuranceCommonService.closePopUp().then(function(result) {
                if (result) {
                    $state.go("menu.generalInsurance");
                }
            });
        };

        //common validation function
        function validateForm() {

            smartMoneyBackGoldPCVm.smartMoneyBackGoldPCForm = {};

            if (smartMoneyBackGoldPCVm.validateService.isValidBirthDateForPolicy(smartMoneyBackGoldPCVm.data.dob, smartMoneyBackGoldPCVm.data.policyTerm)) {
                smartMoneyBackGoldPCVm.smartMoneyBackGoldPCForm.birthDate = smartMoneyBackGoldPCVm.validateService.isValidBirthDateForPolicy(smartMoneyBackGoldPCVm.data.dob, smartMoneyBackGoldPCVm.data.policyTerm);
            }

            if (smartMoneyBackGoldPCVm.validateService.isValidGender(smartMoneyBackGoldPCVm.data.gender)) {
                smartMoneyBackGoldPCVm.smartMoneyBackGoldPCForm.gender = smartMoneyBackGoldPCVm.validateService.isValidGender(smartMoneyBackGoldPCVm.data.gender);
            }

            if (smartMoneyBackGoldPCVm.validateService.isValidPlanOption(smartMoneyBackGoldPCVm.data.planName.key)) {
                smartMoneyBackGoldPCVm.smartMoneyBackGoldPCForm.planOption = smartMoneyBackGoldPCVm.validateService.isValidPlanOption(smartMoneyBackGoldPCVm.data.planName.key);
            }

            if (smartMoneyBackGoldPCVm.validateService.isValidSumAssured(smartMoneyBackGoldPCVm.data.sumAssured)) {
                smartMoneyBackGoldPCVm.smartMoneyBackGoldPCForm.sumAssured = smartMoneyBackGoldPCVm.validateService.isValidSumAssured(smartMoneyBackGoldPCVm.data.sumAssured);
            }

            if (smartMoneyBackGoldPCVm.validateService.isValidPolicyTermSM(smartMoneyBackGoldPCVm.data.policyTerm, smartMoneyBackGoldPCVm.data.age)) {
                smartMoneyBackGoldPCVm.smartMoneyBackGoldPCForm.policyTerm = smartMoneyBackGoldPCVm.validateService.isValidPolicyTermSM(smartMoneyBackGoldPCVm.data.policyTerm, smartMoneyBackGoldPCVm.data.age);
            }

            if (smartMoneyBackGoldPCVm.validateService.isValidPremiumFrequency(smartMoneyBackGoldPCVm.data.premiumFreq.key)) {
                smartMoneyBackGoldPCVm.smartMoneyBackGoldPCForm.premiumFrequency = smartMoneyBackGoldPCVm.validateService.isValidPremiumFrequency(smartMoneyBackGoldPCVm.data.premiumFreq.key);
            }

            if (smartMoneyBackGoldPCVm.validateService.isValidEmail(smartMoneyBackGoldPCVm.data.email)) {
                smartMoneyBackGoldPCVm.smartMoneyBackGoldPCForm.email = smartMoneyBackGoldPCVm.validateService.isValidEmail(smartMoneyBackGoldPCVm.data.email);
            }

            if (smartMoneyBackGoldPCVm.validateService.isValidPhoneNo(smartMoneyBackGoldPCVm.data.mobileNumber)) {
                smartMoneyBackGoldPCVm.smartMoneyBackGoldPCForm.phoneNo = smartMoneyBackGoldPCVm.validateService.isValidPhoneNo(smartMoneyBackGoldPCVm.data.mobileNumber);
            }

            if (smartMoneyBackGoldPCVm.validateService.isValidJkResident(smartMoneyBackGoldPCVm.data.isJkResident)) {
                smartMoneyBackGoldPCVm.smartMoneyBackGoldPCForm.jkResident = smartMoneyBackGoldPCVm.validateService.isValidJkResident(smartMoneyBackGoldPCVm.data.isJkResident);
            }
            return (angular.equals({}, smartMoneyBackGoldPCVm.smartMoneyBackGoldPCForm)) ? true : false;
        }

    }
]);
