angularApp.controller('smartWealthBuilderPCController', [
    "$state",
    "$scope",
    "validateService",
    "premiumCalculationService",
    "lifeInsuranceApplicationService",
    "suggestedPlansDetailsService",
    "lifeInsuranceCommonService",
    "LiConstant",

    function(
        $state,
        $scope,
        validateService,
        premiumCalculationService,
        lifeInsuranceApplicationService,
        suggestedPlansDetailsService,
        lifeInsuranceCommonService,
        LiConstant) {

        var smartWealthBuilderPCVm = this;
        smartWealthBuilderPCVm.validateService = validateService;
        var planDetails;
        var premiumPayingTerms;


        var ageAdult = function(date) {

            var ageA = validateService.calcAge(date);
            if ((ageA < 18)) {
                return true;
            }
            return false;
        }

        function initPage() {

            smartWealthBuilderPCVm.data = {};
            smartWealthBuilderPCVm.smartWealthBuilderPCForm = {};
            smartWealthBuilderPCVm.data.premiumFreq = {};
            smartWealthBuilderPCVm.data.planName = {};

            smartWealthBuilderPCVm.isFromRetrieveApplication = lifeInsuranceCommonService.isFromRetrieveApplication();
            getMasterDataPlans();

            smartWealthBuilderPCVm.showBack = true;
            smartWealthBuilderPCVm.showNext = true;
            smartWealthBuilderPCVm.disableBack = false;
            smartWealthBuilderPCVm.disableNext = false;

            if (premiumCalculationService.getPremiumCalculationSW().age) {

                smartWealthBuilderPCVm.data = premiumCalculationService.getPremiumCalculationSW();
                if (smartWealthBuilderPCVm.data.planName.key == 'Single') {
                    smartWealthBuilderPCVm.policyTerms = planDetails.single;
                    smartWealthBuilderPCVm.data.premPayingTerm = smartWealthBuilderPCVm.data.policyTerm;

                } else if (smartWealthBuilderPCVm.data.planName.key == 'Regular') {
                    smartWealthBuilderPCVm.policyTerms = planDetails.regular;
                } else {
                    smartWealthBuilderPCVm.policyTerms = planDetails.limited;
                }

                smartWealthBuilderPCVm.updateByPlanOpt();


            }

            if (!smartWealthBuilderPCVm.isFromRetrieveApplication) {
                var bankDet = lifeInsuranceApplicationService.getAccoutDetails();
                smartWealthBuilderPCVm.data.pfNumber = bankDet.cbsData.pfNumber;
                smartWealthBuilderPCVm.data.customerType = bankDet.cbsData.customerType;

            }

            var details = lifeInsuranceApplicationService.getPersonalDetails();
            var curSug = suggestedPlansDetailsService.getCurrentSugestedProduct();

            smartWealthBuilderPCVm.data.dob = details.dob;

            if (details.name.middle && details.name.last) {
                smartWealthBuilderPCVm.data.proposerName = details.name.first + " " + details.name.middle + " " + details.name.last;
            }

            if (details.name.middle && !details.name.last) {
                smartWealthBuilderPCVm.data.proposerName = details.name.first + " " + details.name.middle;
            }

            if (!details.name.middle && details.name.last) {
                smartWealthBuilderPCVm.data.proposerName = details.name.first + " " + details.name.last;
            }

            if (!details.name.middle && !details.name.last) {
                smartWealthBuilderPCVm.data.proposerName = details.name.first;
            }
            smartWealthBuilderPCVm.data.productCode = curSug.productCode;
            smartWealthBuilderPCVm.data.productName = curSug.planName;
            smartWealthBuilderPCVm.data.uin = curSug.uin;
            smartWealthBuilderPCVm.data.age = smartWealthBuilderPCVm.validateService.calcAge(smartWealthBuilderPCVm.data.dob);
            smartWealthBuilderPCVm.data.gender = details.gender;
            smartWealthBuilderPCVm.data.applicationNumber = lifeInsuranceApplicationService.getApplicationNumber();

            smartWealthBuilderPCVm.adult = ageAdult(smartWealthBuilderPCVm.data.dob);

        }

        smartWealthBuilderPCVm.updateByPlans = function() {
            if (smartWealthBuilderPCVm.data.planName.key == 'Single') {
                smartWealthBuilderPCVm.policyTerms = planDetails.single;
                smartWealthBuilderPCVm.data.premPayingTerm = smartWealthBuilderPCVm.data.policyTerm;
                smartWealthBuilderPCVm.data.premiumFreq = {};

            } else if (smartWealthBuilderPCVm.data.planName.key == 'Regular') {
                smartWealthBuilderPCVm.policyTerms = planDetails.regular;
                smartWealthBuilderPCVm.data.premPayingTerm = '';
            } else {
                smartWealthBuilderPCVm.policyTerms = planDetails.limited;
                smartWealthBuilderPCVm.data.premPayingTerm = '';
            }
        }

        smartWealthBuilderPCVm.closeJourney = function() {
            lifeInsuranceCommonService.closePopUp().then(function(result) {
                if (result) {
                    $state.go("menu.generalInsurance");
                }
            });
        };

        smartWealthBuilderPCVm.updateByPlanOpt = function() {
            if (smartWealthBuilderPCVm.validateService.isValidPolicyTermSW(smartWealthBuilderPCVm.data.policyTerm, smartWealthBuilderPCVm.data.age)) {

                smartWealthBuilderPCVm.smartWealthBuilderPCForm.policyTerm = smartWealthBuilderPCVm.validateService.isValidPolicyTermSW(smartWealthBuilderPCVm.data.policyTerm, smartWealthBuilderPCVm.data.age);
            } else {
                smartWealthBuilderPCVm.smartWealthBuilderPCForm = {};
            }
            if (smartWealthBuilderPCVm.data.planName.key == 'Regular') {

                smartWealthBuilderPCVm.premiumPaymentTerms = [smartWealthBuilderPCVm.data.policyTerm];
                smartWealthBuilderPCVm.data.premPayingTerm = smartWealthBuilderPCVm.data.policyTerm;
            } else if (smartWealthBuilderPCVm.data.policyTerm == '10') {
                smartWealthBuilderPCVm.premiumPaymentTerms = premiumPayingTerms.limited.ppt10;
            } else {
                smartWealthBuilderPCVm.premiumPaymentTerms = premiumPayingTerms.limited.ppt15;
            }
        }


        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });



        smartWealthBuilderPCVm.goBacktoPrevious = function() {
            if (smartWealthBuilderPCVm.isFromRetrieveApplication) {
                suggestedPlansDetailsService.getPlanDetails().then(function(data) {
                    suggestedPlansDetailsService.setPlanDetails(data);
                    $state.go("menu.planDetails");
                }, function(error) {

                });
            } else {
                $state.go("menu.planDetails");
            }
        };


        function getMasterDataPlans() {

            var response = premiumCalculationService.getPremiumMasters().smartWealthBuilder;

            planDetails = response.policyTerms;
            premiumPayingTerms = response.premiumPayingTerms;
            smartWealthBuilderPCVm.planOptions = response.planOptions;

            smartWealthBuilderPCVm.ageOfProposer = response.ageOfProposer;
            smartWealthBuilderPCVm.premiumFrequency = response.premiumFrequencies;

        }


        //onclick of submit button
        smartWealthBuilderPCVm.goToNextPage = function() {
            if (validateForm()) {

                var data = premiumCalculationService.getPremiumCalculationSW() || {};
                data.dob = smartWealthBuilderPCVm.data.dob;
                data.proposerName = smartWealthBuilderPCVm.data.proposerName;
                data.gender = smartWealthBuilderPCVm.data.gender;
                data.productName = smartWealthBuilderPCVm.data.productName;
                data.productCode = smartWealthBuilderPCVm.data.productCode;
                data.uin = smartWealthBuilderPCVm.data.uin;
                data.age = smartWealthBuilderPCVm.data.age.toString();
                data.proposerAge = smartWealthBuilderPCVm.data.proposerAge;
                smartWealthBuilderPCVm.premiumAmountNew = smartWealthBuilderPCVm.data.premiumAmount;
                data.premiumAmount = smartWealthBuilderPCVm.premiumAmountNew;
                data.policyTerm = smartWealthBuilderPCVm.data.policyTerm;
                data.planName = smartWealthBuilderPCVm.data.planName;
                data.premPayingTerm = smartWealthBuilderPCVm.data.premPayingTerm;
                data.premiumFreq = smartWealthBuilderPCVm.data.premiumFreq;
                data.email = smartWealthBuilderPCVm.data.email;
                data.mobileNumber = smartWealthBuilderPCVm.data.mobileNumber;
                data.applicationNumber = smartWealthBuilderPCVm.data.applicationNumber;
                data.pfNumber = smartWealthBuilderPCVm.data.pfNumber;
                data.customerType = smartWealthBuilderPCVm.data.customerType;

                premiumCalculationService.setPremiumCalculationSW1(data);
                premiumCalculationService.saveBI(LiConstant.journeyCommonId.PC_SWB).then(function() {
                    premiumCalculationService.setJammuKashmir(false);
                    $state.go("menu.smartWealthBuilderPremiumCalculation2");
                });
            }
        }



        //common validation function
        function validateForm() {

            smartWealthBuilderPCVm.smartWealthBuilderPCForm = {};

            if (smartWealthBuilderPCVm.validateService.isValidBirthDateForPlanPolicy(smartWealthBuilderPCVm.data.dob, smartWealthBuilderPCVm.data.planName.key)) {
                smartWealthBuilderPCVm.smartWealthBuilderPCForm.birthDate = smartWealthBuilderPCVm.validateService.isValidBirthDateForPlanPolicy(smartWealthBuilderPCVm.data.dob, smartWealthBuilderPCVm.data.planName.key);
            }


            if (smartWealthBuilderPCVm.validateService.isValidGender(smartWealthBuilderPCVm.data.gender)) {
                smartWealthBuilderPCVm.smartWealthBuilderPCForm.gender = smartWealthBuilderPCVm.validateService.isValidGender(smartWealthBuilderPCVm.data.gender);
            }


            if (smartWealthBuilderPCVm.validateService.isValidPlanOption(smartWealthBuilderPCVm.data.planName.key)) {
                smartWealthBuilderPCVm.smartWealthBuilderPCForm.planOption = smartWealthBuilderPCVm.validateService.isValidPlanOption(smartWealthBuilderPCVm.data.planName.key);
            }

            if (smartWealthBuilderPCVm.validateService.isValidPremiumAmount(smartWealthBuilderPCVm.data.premiumAmount, smartWealthBuilderPCVm.data.premiumFreq.key, smartWealthBuilderPCVm.data.planName.key)) {
                smartWealthBuilderPCVm.smartWealthBuilderPCForm.premiumAmount = smartWealthBuilderPCVm.validateService.isValidPremiumAmount(smartWealthBuilderPCVm.data.premiumAmount, smartWealthBuilderPCVm.data.premiumFreq.key, smartWealthBuilderPCVm.data.planName.key);
            }

            if (smartWealthBuilderPCVm.validateService.isValidPolicyTermSW(smartWealthBuilderPCVm.data.policyTerm, smartWealthBuilderPCVm.data.age)) {
                smartWealthBuilderPCVm.smartWealthBuilderPCForm.policyTerm = smartWealthBuilderPCVm.validateService.isValidPolicyTermSW(smartWealthBuilderPCVm.data.policyTerm, smartWealthBuilderPCVm.data.age);
            }

            if (smartWealthBuilderPCVm.validateService.isValidPremiumFrequency(smartWealthBuilderPCVm.data.premiumFreq.key) && smartWealthBuilderPCVm.data.planName.key != 'Single') {
                smartWealthBuilderPCVm.smartWealthBuilderPCForm.premiumFrequency = smartWealthBuilderPCVm.validateService.isValidPremiumFrequency(smartWealthBuilderPCVm.data.premiumFreq.key);
            }

            if (smartWealthBuilderPCVm.validateService.isValidEmail(smartWealthBuilderPCVm.data.email)) {
                smartWealthBuilderPCVm.smartWealthBuilderPCForm.email = smartWealthBuilderPCVm.validateService.isValidEmail(smartWealthBuilderPCVm.data.email);
            }

            if (smartWealthBuilderPCVm.validateService.isValidPhoneNo(smartWealthBuilderPCVm.data.mobileNumber)) {
                smartWealthBuilderPCVm.smartWealthBuilderPCForm.phoneNo = smartWealthBuilderPCVm.validateService.isValidPhoneNo(smartWealthBuilderPCVm.data.mobileNumber);
            }

            if (smartWealthBuilderPCVm.validateService.isValidAgeProposer(smartWealthBuilderPCVm.data.proposerAge) && smartWealthBuilderPCVm.adult) {
                smartWealthBuilderPCVm.smartWealthBuilderPCForm.ageProposer = smartWealthBuilderPCVm.validateService.isValidAgeProposer(smartWealthBuilderPCVm.data.proposerAge);
            }
            if (smartWealthBuilderPCVm.validateService.isValidPPT(smartWealthBuilderPCVm.data.premPayingTerm) && smartWealthBuilderPCVm.data.planName.key == 'Limited') {
                smartWealthBuilderPCVm.smartWealthBuilderPCForm.premiumPaymentTerm = smartWealthBuilderPCVm.validateService.isValidPPT(smartWealthBuilderPCVm.data.premPayingTerm);
            }

            return (angular.equals({}, smartWealthBuilderPCVm.smartWealthBuilderPCForm)) ? true : false;
        }

    }



]);
