angularApp.controller('smartWealthBuilderPCController2', [
    "$state", 
    "$scope", 
    "$translate", 
    "premiumCalculationService", 
    "validateService", 
    "$ionicPopup",
    "lifeInsuranceCommonService",
    "LiConstant",
    "utilityService",
    
    function(
        $state, 
        $scope, 
        $translate, 
        premiumCalculationService, 
        validateService, 
        $ionicPopup,
        lifeInsuranceCommonService,
        LiConstant,utilityService) {

        var smartWealthBuilderPC2Vm = this;

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });


        function initPage() {
            smartWealthBuilderPC2Vm.data = {};
            smartWealthBuilderPC2Vm.validateService = validateService;
            smartWealthBuilderPC2Vm.totalFund = 0;

            var dataPrev = premiumCalculationService.getPremiumCalculationSW();

            smartWealthBuilderPC2Vm.premiumAmount = dataPrev.premiumAmount;
            smartWealthBuilderPC2Vm.maxTerm = dataPrev.policyTerm;
            smartWealthBuilderPC2Vm.data.noOfYrElapsed = smartWealthBuilderPC2Vm.maxTerm;
            smartWealthBuilderPC2Vm.dob = dataPrev.dob;
            smartWealthBuilderPC2Vm.planName = dataPrev.planName;
            smartWealthBuilderPC2Vm.policyTerm = dataPrev.policyTerm;
            
            if (smartWealthBuilderPC2Vm.planName.key == 'Single') {
             smartWealthBuilderPC2Vm.samfPlaceHolder = "Sum Assured Multiple Factor (e.g : 1.25 times)";
            }else if(smartWealthBuilderPC2Vm.planName.key == 'Regular'){
              smartWealthBuilderPC2Vm.samfPlaceHolder = "Sum Assured Multiple Factor (e.g : 10 times)";
            }else if(smartWealthBuilderPC2Vm.planName.key == 'Limited'){
              smartWealthBuilderPC2Vm.samfPlaceHolder = "Sum Assured Multiple Factor (e.g : 10 times)";
            }else{
              smartWealthBuilderPC2Vm.samfPlaceHolder = "Sum Assured Multiple Factor (e.g : 10 times)";
            }

            if (premiumCalculationService.getPremiumCalculationSW().samf) {
                smartWealthBuilderPC2Vm.data = premiumCalculationService.getPremiumCalculationSW();
            }
        };

        smartWealthBuilderPC2Vm.closeJourney = function() {
            lifeInsuranceCommonService.closePopUp().then(function(result) {
                if(result) {
                   $state.go("menu.generalInsurance"); 
                }
            });
        };

        smartWealthBuilderPC2Vm.goBacktoPrevious = function() {
            $state.go("menu.smartWealthBuilderPremiumCalculation");
        }

        smartWealthBuilderPC2Vm.maxvalueLimit = function() {
            var alertPopup = $ionicPopup.alert({
                title: '',
                template: $translate.instant('Percentage cannot greater than 100%')
            });
        }

        smartWealthBuilderPC2Vm.minvalueLimit = function() {
            var alertPopup = $ionicPopup.alert({
                title: '',
                template: $translate.instant('Percentage cannot be less than 100%')
            });
        }
       
        smartWealthBuilderPC2Vm.showInfo = function() {
            var title = '';
            var template = "<p class='roboto-regular font-content text-left'>Choose your sum assured as a multiple of your premium.</p><p class='roboto-regular font-content text-left'>Part of your premium will be charged towards this cover and rest will be invested in funds chosen by you. </p> ";
            var onTap = '';
            var buttontext = "<b>OK</b>";
            utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
        }


        function getTotalFund() {
            smartWealthBuilderPC2Vm.totalFund = 0;
            if (smartWealthBuilderPC2Vm.data.perInvEquityFund) {
                smartWealthBuilderPC2Vm.totalFund += Number(smartWealthBuilderPC2Vm.data.perInvEquityFund);
            } else {
                smartWealthBuilderPC2Vm.data.perInvEquityFund = 0;
            }
            if (smartWealthBuilderPC2Vm.data.perInvEquityOptimiserFund) {
                smartWealthBuilderPC2Vm.totalFund += Number(smartWealthBuilderPC2Vm.data.perInvEquityOptimiserFund);
            } else {
                smartWealthBuilderPC2Vm.data.perInvEquityOptimiserFund = 0;
            }
            if (smartWealthBuilderPC2Vm.data.perInvgrowthFund) {
                smartWealthBuilderPC2Vm.totalFund += Number(smartWealthBuilderPC2Vm.data.perInvgrowthFund);
            } else {
                smartWealthBuilderPC2Vm.data.perInvgrowthFund = 0;
            }
            if (smartWealthBuilderPC2Vm.data.perInvBalancedFund) {
                smartWealthBuilderPC2Vm.totalFund += Number(smartWealthBuilderPC2Vm.data.perInvBalancedFund);
            } else {
                smartWealthBuilderPC2Vm.data.perInvBalancedFund = 0;
            }
            if (smartWealthBuilderPC2Vm.data.perInvBondFund) {
                smartWealthBuilderPC2Vm.totalFund += Number(smartWealthBuilderPC2Vm.data.perInvBondFund);
            } else {
                smartWealthBuilderPC2Vm.data.perInvBondFund = 0;
            }
            if (smartWealthBuilderPC2Vm.data.perInvMoneyMarketFund) {
                smartWealthBuilderPC2Vm.totalFund += Number(smartWealthBuilderPC2Vm.data.perInvMoneyMarketFund);
            } else {
                smartWealthBuilderPC2Vm.data.perInvMoneyMarketFund = 0;
            }
            if (smartWealthBuilderPC2Vm.data.perInvTop300Fund) {
                smartWealthBuilderPC2Vm.totalFund += Number(smartWealthBuilderPC2Vm.data.perInvTop300Fund);
            } else {
                smartWealthBuilderPC2Vm.data.perInvTop300Fund = 0;
            }
        }

        smartWealthBuilderPC2Vm.Calculate = function() {

            if (validateForm()) {

                getTotalFund();
                if (smartWealthBuilderPC2Vm.totalFund > 100) {
                    smartWealthBuilderPC2Vm.maxvalueLimit();

                } else if (smartWealthBuilderPC2Vm.totalFund < 100) {
                    smartWealthBuilderPC2Vm.minvalueLimit();

                } else {
                    var data = premiumCalculationService.getPremiumCalculationSW();

                    data.samf = smartWealthBuilderPC2Vm.data.samf;
                    data.perInvEquityFund = smartWealthBuilderPC2Vm.data.perInvEquityFund;
                    data.perInvEquityOptimiserFund = smartWealthBuilderPC2Vm.data.perInvEquityOptimiserFund;
                    data.perInvgrowthFund = smartWealthBuilderPC2Vm.data.perInvgrowthFund;
                    data.perInvBalancedFund = smartWealthBuilderPC2Vm.data.perInvBalancedFund;
                    data.perInvBondFund = smartWealthBuilderPC2Vm.data.perInvBondFund;
                    data.perInvMoneyMarketFund = smartWealthBuilderPC2Vm.data.perInvMoneyMarketFund;
                    data.perInvTop300Fund = smartWealthBuilderPC2Vm.data.perInvTop300Fund;
                    data.noOfYrElapsed = smartWealthBuilderPC2Vm.data.noOfYrElapsed;

                    premiumCalculationService.setPremiumCalculationSW2(data);

                    premiumCalculationService.saveBI(LiConstant.journeyCommonId.PC_SWB_2).then(function(){
                        premiumCalculationService.submitPremiumCalculationDataSW().then(function(data) {
                        premiumCalculationService.setPremiumCalculationResponse(data);                        
                        $state.go('menu.premiumCalculation3');
                    });
                 });           

                }
            }
        };


        //common validation function
        function validateForm() {

            smartWealthBuilderPC2Vm.frmPremiumCalculation2 = {};
            if (smartWealthBuilderPC2Vm.validateService.isValidSamf(smartWealthBuilderPC2Vm.dob, smartWealthBuilderPC2Vm.planName, smartWealthBuilderPC2Vm.policyTerm, smartWealthBuilderPC2Vm.premiumAmount, smartWealthBuilderPC2Vm.data.samf)) {
                smartWealthBuilderPC2Vm.frmPremiumCalculation2.Samf = smartWealthBuilderPC2Vm.validateService.isValidSamf(smartWealthBuilderPC2Vm.dob, smartWealthBuilderPC2Vm.planName, smartWealthBuilderPC2Vm.policyTerm, smartWealthBuilderPC2Vm.premiumAmount, smartWealthBuilderPC2Vm.data.samf);

            }
            if (smartWealthBuilderPC2Vm.validateService.isValidnoOfYears(smartWealthBuilderPC2Vm.data.noOfYrElapsed)) {
                smartWealthBuilderPC2Vm.frmPremiumCalculation2.noOfYears = smartWealthBuilderPC2Vm.validateService.isValidnoOfYears(smartWealthBuilderPC2Vm.data.noOfYrElapsed);
            }

            return (angular.equals({}, smartWealthBuilderPC2Vm.frmPremiumCalculation2)) ? true : false;
        }
        return this;
    }
]);
