angularApp.controller('financialGoalsChartsController', [
    "$state",
    "$scope",
    "financialGoalsChartsServices",
    "lifeInsuranceApplicationService",
    "lifeInsuranceConfig",
    "suggestedPlansDetailsService",

    function(
        $state,
        $scope,
        financialGoalsChartsServices,
        lifeInsuranceApplicationService,
        lifeInsuranceConfig,
        suggestedPlansDetailsService) {

        var financialGoalsChartsVm = this;

        function initPage() {
            financialGoalsChartsVm.hasPlans = lifeInsuranceApplicationService.getNoPlans();

        }

        function drawChartsAndAnalysis(data) {
            financialGoalsChartsServices.setGoalSuggestedPlans(data);
            financialGoalsChartsVm.getSavingChartsView(data.analysisResult.retirement.savedAmount, data.analysisResult.retirement.gapAmount);
            financialGoalsChartsVm.getBuyingHomeSaveData(data.analysisResult.home.savedAmount, data.analysisResult.home.gapAmount);
            financialGoalsChartsVm.getOtherGoalsData(data.analysisResult.otherGoals.savedAmount, data.analysisResult.otherGoals.gapAmount);
            financialGoalsChartsVm.getProtectedData(data.analysisResult.lifeProtCor.savedAmount, data.analysisResult.lifeProtCor.gapAmount);

            financialGoalsChartsVm.chldMarriageGoalsData(data.analysisResult.childMarriage.savedAmount, data.analysisResult.childMarriage.gapAmount);
            financialGoalsChartsVm.chldEducationGoalsData(data.analysisResult.childEducation.savedAmount, data.analysisResult.childEducation.gapAmount);
            financialGoalsChartsVm.savings = data.analysisResult;
        };

        financialGoalsChartsVm.getNeedAnalysisData = function() {
            var needAnalysisResult = lifeInsuranceApplicationService.getNeedAnalysisResult();
            drawChartsAndAnalysis(needAnalysisResult);
        };

        financialGoalsChartsVm.getSavingChartsView = function(saved, yetToSave) {
            var Saving = document.getElementById('savingChart').getContext('2d');
            var mysavingData = new Chart(Saving, financialGoalsChartsServices.getSavingChartsData(saved, yetToSave));
        };

        financialGoalsChartsVm.getBuyingHomeSaveData = function(saved, yetToSave) {
            if (!financialGoalsChartsVm.hasPlans.homeDetails) {
                var buyingHomeSave = document.getElementById('buyingHomeSaveChart').getContext('2d');
                var buyingHomeSaveData = new Chart(buyingHomeSave, financialGoalsChartsServices.getSavingChartsData(saved, yetToSave));
            }
        };

        financialGoalsChartsVm.getOtherGoalsData = function(saved, yetToSave) {
            if (!financialGoalsChartsVm.hasPlans.otherGoals) {
                var otherGoals = document.getElementById('otherGoalsChart').getContext('2d');
                var otherGoalsData = new Chart(otherGoals, financialGoalsChartsServices.getSavingChartsData(saved, yetToSave));
            }
        };

        financialGoalsChartsVm.getProtectedData = function(saved, yetToSave) {
            var otherGoals = document.getElementById('protectionChart').getContext('2d');
            var otherGoalsData = new Chart(otherGoals, financialGoalsChartsServices.getSavingChartsData(saved, yetToSave));
        };

        financialGoalsChartsVm.chldMarriageGoalsData = function(saved, yetToSave) {
            if (!financialGoalsChartsVm.hasPlans.child) {
                var chldMarriageGoals = document.getElementById('chldMarriageGoalsChart').getContext('2d');
                var chldMarriageGoalData = new Chart(chldMarriageGoals, financialGoalsChartsServices.getSavingChartsData(saved, yetToSave));
            }
        };

        financialGoalsChartsVm.chldEducationGoalsData = function(saved, yetToSave) {
            if (!financialGoalsChartsVm.hasPlans.child) {
                var chldEducationGoals = document.getElementById('chldEducationGoalsChart').getContext('2d');
                var chldEducationGoalData = new Chart(chldEducationGoals, financialGoalsChartsServices.getSavingChartsData(saved, yetToSave));
            }
        };

        financialGoalsChartsVm.goViewAllSuggestedPlans = function(value) {
            suggestedPlansDetailsService.setSelectedCategory(value);
            $state.go("menu.suggestedPlans");
        };
        financialGoalsChartsVm.goToHomeInsurance = function() {
            $state.go('menu.sbiHomeRecommendations');
        };

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        $scope.$on('$ionicView.enter', function() {
            financialGoalsChartsVm.getNeedAnalysisData();
        });

    }
]);
