angularApp.service('financialGoalsChartsServices', financialGoalsChartsServices);

financialGoalsChartsServices.$inject = [];

function financialGoalsChartsServices() {

    this.goalSuggestedPlans = {};

    this.getSavingChartsData = function(saved, yetToSave) {
        var savingDataConfig = {
            type: 'doughnut',
            data: {
                labels: ["Saved", "Yet to save"],
                datasets: [{
                    data: [saved, yetToSave],



                    backgroundColor: ["#e8a5a5", "#AB3C3C"],
                    hoverBackgroundColor: ["#e8a5a5", "#AB3C3C"]
                }]
            },
            options: {
                cutoutPercentage: 55,
                responsive: true,
                showAllTooltips: true,
                legend: {
                    position: 'bottom',
                     display: false
                },
                tooltipTemplate: "<%= value %>",
                onAnimationComplete: function() {
                    this.showTooltip(this.segments, true);
                },
                tooltipEvents: [],
                elements: {
                    center: {
                        // the longest text that could appear in the center
                        maxText: '100%',
                        text: 'Saving',
                        fontColor: '#000',
                        fontFamily: "'Helvetica Neue', 'Helvetica', 'Arial', sans-serif",
                        fontStyle: 'normal',
                        fontSize: 14,
                        minFontSize: 1,
                        maxFontSize: 256,
                    }
                }

            }

        };
        Chart.pluginService.register({
            afterUpdate: function(chart) {
                if (chart.config.options.elements.center) {
                    var helpers = Chart.helpers;
                    var centerConfig = chart.config.options.elements.center;
                    var globalConfig = Chart.defaults.global;
                    var ctx = chart.chart.ctx;

                    var fontStyle = helpers.getValueOrDefault(centerConfig.fontStyle, globalConfig.defaultFontStyle);
                    var fontFamily = helpers.getValueOrDefault(centerConfig.fontFamily, globalConfig.defaultFontFamily);

                    if (centerConfig.fontSize)
                        var fontSize = centerConfig.fontSize;
                    // figure out the best font size, if one is not specified
                    else {
                        ctx.save();
                        var fontSize = helpers.getValueOrDefault(centerConfig.minFontSize, 1);
                        var maxFontSize = helpers.getValueOrDefault(centerConfig.maxFontSize, 256);
                        var maxText = helpers.getValueOrDefault(centerConfig.maxText, centerConfig.text);

                        do {
                            ctx.font = helpers.fontString(fontSize, fontStyle, fontFamily);
                            var textWidth = ctx.measureText(maxText).width;

                            // check if it fits, is within configured limits and that we are not simply toggling back and forth
                            if (textWidth < chart.innerRadius * 2 && fontSize < maxFontSize)
                                fontSize += 1;
                            else {
                                // reverse last step
                                fontSize -= 1;
                                break;
                            }
                        } while (true)
                        ctx.restore();
                    }

                    // save properties
                    chart.center = {
                        font: helpers.fontString(fontSize, fontStyle, fontFamily),
                        fillStyle: helpers.getValueOrDefault(centerConfig.fontColor, globalConfig.defaultFontColor)
                    };
                }
            },
            afterDraw: function(chart) {
                if (chart.center) {
                    var centerConfig = chart.config.options.elements.center;
                    var ctx = chart.chart.ctx;

                    ctx.save();
                    ctx.font = chart.center.font;
                    ctx.fillStyle = chart.center.fillStyle;
                    ctx.textAlign = 'center';
                    ctx.textBaseline = 'middle';
                    var centerX = (chart.chartArea.left + chart.chartArea.right) / 2;
                    var centerY = (chart.chartArea.top + chart.chartArea.bottom) / 2;
                    ctx.fillText(centerConfig.text, centerX, centerY);
                    ctx.restore();
                }
            },
        })
        return savingDataConfig;
    }



    this.setGoalSuggestedPlans = function(data) {
        this.goalSuggestedPlans = data;
    }


    this.getGoalSuggestedPlans = function() {
        return this.goalSuggestedPlans;
    }

    return this;
}
