angularApp.controller('otherProductListController', [
    "$state",
    "$scope",
    "$translate",
    "$ionicPopup",
    "suggestedPlansDetailsService",
    "lifeInsuranceBasicApplicationService",
    "LiConstant",
    "$ionicScrollDelegate",

    function(
        $state,
        $scope,
        $translate,
        $ionicPopup,
        suggestedPlansDetailsService,
        lifeInsuranceBasicApplicationService,
        LiConstant,
        $ionicScrollDelegate) {

        var otherProductListVm = this;

        function initPage() {
            if (!otherProductListVm.topContent) {
                suggestedPlansDetailsService.getOtherProductsListContent1().then(function(data) {
                    otherProductListVm.topContent = data.message;
                });
            }

            if (!otherProductListVm.bottomContent) {
                suggestedPlansDetailsService.getOtherProductsListContent2().then(function(data) {
                    otherProductListVm.bottomContent = data.message;
                });
            }
            getOtherAllProductsListFn();
        }

        otherProductListVm.goToShowPolicyDetailsPage = function(currentProduct) {

            if (!otherProductListVm.product || !otherProductListVm.terms) {
                var message = !otherProductListVm.product ? $translate.instant('PLEASE_AGREE_PROCEED') : $translate.instant('PLS_AGR_BLW_PRCD');
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    template: "<p class='text-align-center'> "+ message +"</p>",
                    scope: $scope,
                });
                alertPopup.then(function(res) {
                    if (res) {}
                });
            } else {
                if (suggestedPlansDetailsService.getCurrentSugestedProduct()) {
                    var prevProduct = suggestedPlansDetailsService.getCurrentSugestedProduct().productCode;
                }
                suggestedPlansDetailsService.setCurrentSugestedProduct(currentProduct);
                var newProduct = suggestedPlansDetailsService.getCurrentSugestedProduct().productCode;

                if (prevProduct !== newProduct) {
                    lifeInsuranceBasicApplicationService.resetMedicalHistory();
                }
                getPlanDetailsForSellingProduct(currentProduct);
            }

        }


        function getPlanDetailsForSellingProduct(currentProduct) {
            var request = {
                "uin": currentProduct.uin
            };

            switch (currentProduct.uin) {
                case LiConstant.productUIN.SMART_CHAMP_INSURANCE:
                    gotoDetailPage(request);
                    break;
                case LiConstant.productUIN.SMART_MONEY_BACK_GOLD:
                    gotoDetailPage(request);
                    break;
                case LiConstant.productUIN.SHUBH_NIVESH:
                    gotoDetailPage(request);
                    break;
                case LiConstant.productUIN.SARAL_SWADHAN_PLUS:
                    gotoDetailPage(request);
                    break;
                case LiConstant.productUIN.RETIRE_SMART:
                    gotoDetailPage(request);
                    break;
                case LiConstant.productUIN.SMART_WEALTH_BUILDER:
                    gotoDetailPage(request);
                    break;
                default:
                    $state.go('menu.productNotSaleOnApp');
                    break;
            }

        };


        function gotoDetailPage(request) {
            suggestedPlansDetailsService.getPlanDetails(request).then(function(data) {
                suggestedPlansDetailsService.setPlanDetails(data);
                suggestedPlansDetailsService.setPlanListStateUrl("menu.otherProductList");
                $state.go("menu.planDetails");
            });
        };


        //getting suggested Plans List
        function getOtherAllProductsListFn() {
            if (!otherProductListVm.productList) {
                suggestedPlansDetailsService.getOtherAllProductsList().then(function(data) {
                    otherProductListVm.productList = data.plans;
                    $ionicScrollDelegate.$getByHandle('mainScroll').resize();
                });
            }
        };

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
