angularApp.controller('planDetailsController', [
    "$state",
    "$scope",
    "suggestedPlansDetailsService",
    "$ionicScrollDelegate",
    "premiumCalculationService",
    "lifeInsuranceCommonService",
    "$ionicHistory",
    "LiConstant",
    "clickStreamService",
    "lifeInsuranceBasicApplicationService",

    function(
        $state,
        $scope,
        suggestedPlansDetailsService,
        $ionicScrollDelegate,
        premiumCalculationService,
        lifeInsuranceCommonService,
        $ionicHistory,
        LiConstant,
        clickStreamService,
        lifeInsuranceBasicApplicationService) {


        var planDetailsVm = this;

        //private methods section start
        function initPage() {
            planDetailsVm.showBack = false;
            planDetailsVm.showNext = true;
            planDetailsVm.showContect = 0;
            planDetailsVm.productDetails = suggestedPlansDetailsService.getPlanDetailsList();  
            if (!planDetailsVm.disclaimer) {
                  planDetailsVm.disclaimer = planDetailsVm.productDetails.productFooter;
            }
        }


        // Click on next buttton it will go as per selected product 
        planDetailsVm.buyNow = function() {

            premiumCalculationService.getMasterDataPlans().then(function(data) {
                premiumCalculationService.setMasterDataPlans(data);
                lifeInsuranceBasicApplicationService.resetUploadImageCount();
                clickStreamService.clickStreamData = planDetailsVm.productDetails.uin;

                switch (planDetailsVm.productDetails.uin) {
                    case LiConstant.productUIN.SMART_CHAMP_INSURANCE:
                        $state.go('menu.smartChampInsurancePremiumCalculation');
                        break;
                    case LiConstant.productUIN.SMART_MONEY_BACK_GOLD:
                        $state.go('menu.smartMoneyBackGoldPremiumCalculation');
                        break;
                    case LiConstant.productUIN.SHUBH_NIVESH:
                        $state.go('menu.shubhNiveshPremiumCalculation');
                        break;
                    case LiConstant.productUIN.SARAL_SWADHAN_PLUS:
                        $state.go('menu.saralSwadhanPremiumCalculation');
                        break;
                    case LiConstant.productUIN.RETIRE_SMART:
                        $state.go('menu.retireSmartPremiumCalculation');
                        break;
                    case LiConstant.productUIN.SMART_WEALTH_BUILDER:
                        $state.go('menu.smartWealthBuilderPremiumCalculation');
                        break;
                    default:
                        $state.go('menu.productNotSaleOnApp');
                        break;
                }
            });
        };

        planDetailsVm.goBack = function() {
            if (lifeInsuranceCommonService.isFromRetrieveApplication()) {
                $state.go("menu.retreiveApplication");
            } else {
                $state.go(suggestedPlansDetailsService.getPlanListStateUrl());
            }
        };

        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicScrollDelegate.scrollTop();
            initPage();
        });

    }
]);
