angularApp.controller('suggestedPlansController', [
    "$state",
    "$scope",
    "$translate",
    "$ionicPopup",
    "suggestedPlansDetailsService",
    "lifeInsuranceBasicApplicationService",
    "LiConstant",


    function(
        $state,
        $scope,
        $translate,
        $ionicPopup,
        suggestedPlansDetailsService,
        lifeInsuranceBasicApplicationService,
        LiConstant) {

        var suggestedPlansVm = this;
        /*suggestedPlansVm.traditional;
        suggestedPlansVm.unit;*/

        function initPage() {
            suggestedPlansVm.suggestedPlans = [];
            if (!suggestedPlansVm.noteSuggestionText) {
                suggestedPlansDetailsService.getNoteSuggestionText().then(function(data) {
                    suggestedPlansVm.noteSuggestionText = data.message;
                });
            }
            fetchCategory();
            getSuggestedProductsListFn();
        }


        function fetchCategory() {
            var type = suggestedPlansDetailsService.getSelectedCategory();
            switch (type) {
                case '0':
                    suggestedPlansVm.traditional = 'ProdLstLifeProtTrad';
                    suggestedPlansVm.unit = 'prodLstLifeprotUnit';
                    break;
                case '1':
                    suggestedPlansVm.traditional = 'ProdLstRetTrad';
                    suggestedPlansVm.unit = 'ProdLstRetUnit';
                    break;
                case '2':
                    suggestedPlansVm.traditional = 'ProdLstWealthCreTrad';
                    suggestedPlansVm.unit = 'ProdLstWealthCreUnit';
                    break;
                case '3':
                    suggestedPlansVm.traditional = 'ProdLstChTrad';
                    suggestedPlansVm.unit = 'ProdLstChUnit';
                    break;
                case '4':
                    suggestedPlansVm.traditional = 'ProdLstWealthCreTrad';
                    suggestedPlansVm.unit = 'ProdLstWealthCreUnit';
                    break;
                case '99':
                    suggestedPlansVm.traditional = false;
                    suggestedPlansVm.unit = false;
                    break;
                default:
                    suggestedPlansVm.traditional = false;
                    suggestedPlansVm.unit = false;
                    break;
            }

        };

        suggestedPlansVm.parseSuggestedProducts = function() {
            if (!suggestedPlansVm.traditional && !suggestedPlansVm.unit) {
                suggestedPlansVm.suggestedPlans = suggestedPlansVm.responcePolicyListData;
                fetchImages();
                return;
            }

            for (var count = 0; count < suggestedPlansVm.responcePolicyListData.length; count++) {
                if ((suggestedPlansVm.responcePolicyListData[count].category == suggestedPlansVm.traditional) ||
                    (suggestedPlansVm.responcePolicyListData[count].category == suggestedPlansVm.unit)) {
                    suggestedPlansVm.suggestedPlans.push(suggestedPlansVm.responcePolicyListData[count]);
                }
            }
            fetchImages();
        };


        function fetchImages() {
            if (!suggestedPlansDetailsService.allPlans) {
                suggestedPlansDetailsService.getOtherAllProductsList().then(function(data) {
                    suggestedPlansDetailsService.allPlans = data.plans;
                    bindImage();
                });
            }else {
                bindImage();
            }
        };

        function bindImage() {
            var allPlans = suggestedPlansDetailsService.allPlans;
            if (allPlans) {
                for (var count = 0; count < suggestedPlansVm.suggestedPlans.length; count++) {
                    for (var allPlanIndex = 0; allPlanIndex < allPlans.length; allPlanIndex++) {
                        if (suggestedPlansVm.suggestedPlans[count].uin == allPlans[allPlanIndex].uin) {
                            suggestedPlansVm.suggestedPlans[count].imgUrl = allPlans[allPlanIndex].imageUrl;
                        }
                    }
                }
            }
        };


        suggestedPlansVm.showSuggested = function(product) {
            if (product.category == suggestedPlansVm.traditional) {
                return true;
            }
        };

        //getting suggested Plans List
        function getSuggestedProductsListFn() {
            suggestedPlansDetailsService.getSuggestedProductsList(function(data) {
                suggestedPlansVm.responcePolicyListData = data.suggestedPlans.plans;
                suggestedPlansVm.parseSuggestedProducts();
            });
        }

        //click on next for show product details
        suggestedPlansVm.goToShowPolicyDetailsPage = function(currentProduct) {
            if (!suggestedPlansVm.terms) {
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    template: '<p class="text-align-center" translate="PLEASE_AGREE_PROCEED"></p>',
                    scope: $scope,
                });
                alertPopup.then(function(res) {
                    if (res) {}
                });
            } else {
                if (suggestedPlansDetailsService.getCurrentSugestedProduct()) {
                    var prevProduct = suggestedPlansDetailsService.getCurrentSugestedProduct().productCode;
                }
                suggestedPlansDetailsService.setCurrentSugestedProduct(currentProduct);
                var newProduct = suggestedPlansDetailsService.getCurrentSugestedProduct().productCode;
                if (prevProduct !== newProduct) {
                    lifeInsuranceBasicApplicationService.resetMedicalHistory();
                }
                getPlanDetailsForSellingProduct(currentProduct);
            }
        };

        function getPlanDetailsForSellingProduct(currentProduct) {
            var request = {
                "uin": currentProduct.uin
            };

            switch (currentProduct.uin) {
                case LiConstant.productUIN.SMART_CHAMP_INSURANCE:
                    gotoDetailPage(request);
                    break;
                case LiConstant.productUIN.SMART_MONEY_BACK_GOLD:
                    gotoDetailPage(request);
                    break;
                case LiConstant.productUIN.SHUBH_NIVESH:
                    gotoDetailPage(request);
                    break;
                case LiConstant.productUIN.SARAL_SWADHAN_PLUS:
                    gotoDetailPage(request);
                    break;
                case LiConstant.productUIN.RETIRE_SMART:
                    gotoDetailPage(request);
                    break;
                case LiConstant.productUIN.SMART_WEALTH_BUILDER:
                    gotoDetailPage(request);
                    break;
                default:
                    $state.go('menu.productNotSaleOnApp');
                    break;
            }

        };

        function gotoDetailPage(request) {
            suggestedPlansDetailsService.getPlanDetails(request).then(function(data) {
                suggestedPlansDetailsService.setPlanDetails(data);
                suggestedPlansDetailsService.setPlanListStateUrl("menu.suggestedPlans");
                $state.go("menu.planDetails");
            }, function(error) {
                $state.go("menu.productNotSaleOnApp");
            });
        };

        //click on button to show other priduct product page
        suggestedPlansVm.goToShowOtherProductsPage = function() {
            $state.go("menu.otherProductList");
        };

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
