angularApp.service('suggestedPlansDetailsService', ["$filter",
    "financialGoalsChartsServices",
    "commonAPIService",
    "lifeInsuranceConfig",
    "$q",
    "AdapterUtils",
    "utilityService",


    function($filter,
        financialGoalsChartsServices,
        commonAPIService,
        lifeInsuranceConfig,
        $q,
        AdapterUtils,
        utilityService) {

        var suggestedPlansDetails = this;
        var selectedCategory;
        var selectedProduct;
        var planDetails;
        var planListStateUrl;



        suggestedPlansDetails.setSelectedCategory = function(category) {
            selectedCategory = category;
        };

        suggestedPlansDetails.getSelectedCategory = function() {
            return selectedCategory;
        };

        suggestedPlansDetails.setPlanListStateUrl = function(path) {
            planListStateUrl = path;
        };

        suggestedPlansDetails.getPlanListStateUrl = function() {
            return planListStateUrl;
        };

        suggestedPlansDetails.getPlanDetails = function() {
            var requestJson = {
                "uin": selectedProduct.uin
            };
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getPlanDetails[0], requestJson, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };


        suggestedPlansDetails.getOtherProductsListContent1 = function() {
            var q = $q.defer();
            AdapterUtils.getData(lifeInsuranceConfig.adapterURL.getNoteViewTop[0], true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };


        suggestedPlansDetails.getOtherProductsListContent2 = function() {
            var q = $q.defer();
            AdapterUtils.getData(lifeInsuranceConfig.adapterURL.getNoteViewBottom[0], true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };

        suggestedPlansDetails.getNoteSuggestionText = function() {
            var q = $q.defer();
            AdapterUtils.getData(lifeInsuranceConfig.adapterURL.getNoteSuggesionText[0], true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };

        suggestedPlansDetails.getProductDisclaimer = function() {
            var q = $q.defer();
            AdapterUtils.getData(lifeInsuranceConfig.adapterURL.getProductDisclaimer[0], true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };

        suggestedPlansDetails.getProductNotSold = function() {
            var q = $q.defer();
            AdapterUtils.getData(lifeInsuranceConfig.adapterURL.getProductNotSold[0], true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };

        suggestedPlansDetails.setPlanDetails = function(details) {
            planDetails = details;
        }

        suggestedPlansDetails.getPlanDetailsList = function() {
            return planDetails;
        }


        suggestedPlansDetails.setCurrentSugestedProduct = function(productInfo) {
            selectedProduct = productInfo;
        }


        suggestedPlansDetails.getCurrentSugestedProduct = function() {
            return selectedProduct;
        }

        suggestedPlansDetails.getSuggestedProductsList = function(callback) {
            var response = financialGoalsChartsServices.getGoalSuggestedPlans();
            callback(response);
        }


        //getting suggested and other products List
        suggestedPlansDetails.getOtherAllProductsList = function() {
            var q = $q.defer();
            AdapterUtils.getData(lifeInsuranceConfig.adapterURL.getAllPlans[0], true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        }


        suggestedPlansDetails.getSuggestedProductDetails = function(reqobj, callback) {
            commonAPIService.invokeAdapter(lifeInsuranceConfig.adapterURL.getPlanDetails[0], lifeInsuranceConfig.adapterURL.getPlanDetails[1], reqobj, callback);
        }

        return suggestedPlansDetails;

    }
]);


