angularApp.controller('lifeInsuranceEstatementController', [
    "$state",
    "$scope",
    "validateService",
    "liPolicyPaymentService",
    "lifeInsuranceConfig",
    "linkingLIPolicyService",
    "utilityService",
    "$ionicPopup",


    function(
        $state,
        $scope,
        validateService,
        liPolicyPaymentService,
        lifeInsuranceConfig,
        linkingLIPolicyService,
        utilityService,
        $ionicPopup) {

        var lifeInsuranceEstatementVm = this;
        lifeInsuranceEstatementVm.validateService = validateService;

        function initPage() {

            lifeInsuranceEstatementVm.showBack = true;
            lifeInsuranceEstatementVm.showNext = true;
            lifeInsuranceEstatementVm.disableBack = false;
            lifeInsuranceEstatementVm.disableNext = false;

            var details = linkingLIPolicyService.getMyPolicyDetails();
            if (details.policyDetails.policyNumber) {
                lifeInsuranceEstatementVm.policyNumber = details.policyDetails.policyNumber;
            }
            getFinancialYear();

        };


        function getFinancialYear() {
            lifeInsuranceEstatementVm.years = [];
            var year = lifeInsuranceEstatementVm.validateService.getCurrentDate().getFullYear();
            var month = lifeInsuranceEstatementVm.validateService.getCurrentDate().getMonth();
            if(month>2) year = year +1;
            for (var count = 0; count < 4; count++) {
                var finYear = {};
                var fromYear = year - 1;
                finYear.years = fromYear + '-' + year;
                lifeInsuranceEstatementVm.years.push(finYear);
                year--;
            }
        };

     

        //onClick download Estatement
        lifeInsuranceEstatementVm.onClickDownloadEStatement = function() {
            if (validateForm()) {
                requestViewDownloadEStatement();
            }
        }


        function validateForm() {
            lifeInsuranceEstatementVm.frmDownloadEStatement = {};

            if (lifeInsuranceEstatementVm.validateService.isValidFinancialyear(lifeInsuranceEstatementVm.financialyear)) {
                lifeInsuranceEstatementVm.frmDownloadEStatement.financialyearVMsg = lifeInsuranceEstatementVm.validateService.isValidFinancialyear(lifeInsuranceEstatementVm.financialyear);
            }
            return (angular.equals({}, lifeInsuranceEstatementVm.frmDownloadEStatement)) ? true : false;
        }


        function requestViewDownloadEStatement() {
            /*var downloadViewEstatmentJson = {
                "policyNumber": '51001920406',
                "financialYear": '2015-2016'
            };*/

            var downloadViewEstatmentJson = {
                "policyNumber" : lifeInsuranceEstatementVm.policyNumber,
                "financialYear" : lifeInsuranceEstatementVm.financialyear.years
            }

            liPolicyPaymentService.downloadViewPolicy(downloadViewEstatmentJson).then(function(data) {
                var content = data.base64;
                var filename = "e_statement_" + downloadViewEstatmentJson.policyNumber + '_'+ downloadViewEstatmentJson.financialYear + '.pdf';
                var contentType = "application/pdf";
                if (utilityService.isAndroidPlatform()) {
                    lifeInsuranceEstatementVm.android = true;

                    lifeInsuranceEstatementVm.folderpath = cordova.file.externalRootDirectory;
                }
                if (utilityService.isIOSPlatform()) {
                    lifeInsuranceEstatementVm.folderpath = cordova.file.applicationDirectory;
                }
                savebase64AsPDF(lifeInsuranceEstatementVm.folderpath, filename, content, contentType);
                if (utilityService.isIOSPlatform()) {
                    var finalObject = { "folderpath": lifeInsuranceEstatementVm.folderpath, "filename": filename };
                    //cordova.exec(sayHelloSuccess, sayHelloFailure, "PdfViewer", "openPDF", [finalObject]);
                    window.open("data:application/pdf;base64,"+content+"","_blank","location=no");

                }
                if (lifeInsuranceEstatementVm.android) {
                    var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="DOWNLOADFDRECEIPT" translate-values="{folderpath:lifeInsuranceEstatementVm.folderpath}"></div>';
                    lifeInsuranceEstatementVm.downloadPopup = $ionicPopup.show({
                        title: '',
                        template: template,
                        scope: $scope,
                        cssClass: 'my-custom-popup',
                        buttons: [{
                            text: 'OK',
                            type: 'button-assertive',
                            onTap: function() {
                                lifeInsuranceEstatementVm.downloadPopup.close();
                            }
                        }],
                    });
                }
            });
        }

        function b64toBlob(b64Data, contentType, sliceSize) {
            contentType = contentType || '';
            sliceSize = sliceSize || 512;

            var byteCharacters = atob(b64Data);
            var byteArrays = [];

            for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
                var slice = byteCharacters.slice(offset, offset + sliceSize);

                var byteNumbers = [];
                for (var i = 0; i < slice.length; i++) {
                    byteNumbers[i] = slice.charCodeAt(i);
                }

                var byteArray = new Uint8Array(byteNumbers);

                byteArrays.push(byteArray);
            }

            var blob = new Blob(byteArrays, { type: contentType });
            return blob;
        }




        function savebase64AsPDF(folderpath, filename, content, contentType) {
            // Convert the base64 string in a Blob
            var DataBlob = b64toBlob(content, contentType);

            window.resolveLocalFileSystemURL(folderpath, function(dir) {
                dir.getFile(filename, { create: true }, function(file) {
                    file.createWriter(function(fileWriter) {
                        fileWriter.write(DataBlob);

                    }, function() {

                    });
                });
            });
        }

        lifeInsuranceEstatementVm.goBack = function() {
            $state.go("menu.myPolicyDetails");
        };

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
