angularApp.service('fundSwitchRedirectService', [
    "$filter",
    'commonAPIService',
    'lifeInsuranceConfig',
    '$q',
    'AdapterUtils',
    'utilityService',


    function($filter,
        commonAPIService,
        lifeInsuranceConfig,
        $q,
        AdapterUtils,
        utilityService
    ) {

        var fundSwitchRedirect = this;
        var fundSwitch;
        var fundRedirect;
        var fundswhRequestNum;
        var fundRedRequestNum;


        //function to set fund switch from details page
        fundSwitchRedirect.setFundSwitch = function(data) {
            fundSwitch = data;
        }

        //get the fund switch data
        fundSwitchRedirect.getFundSwitch = function() {
            return fundSwitch;
        };

        //function to set the fund redirect from details page
        fundSwitchRedirect.setFundRedirect = function(data) {
            fundRedirect = data;
        };

        //get the fund redirect
        fundSwitchRedirect.getFundRedirect = function() {
            return fundRedirect;
        };


        // set and get Fund switch Request Num to service for reuse
        fundSwitchRedirect.setFundswhRequestStatusNum = function(data) {
            fundswhRequestNum = data;
        }
        fundSwitchRedirect.getFundswhRequestStatusNum = function() {
            return fundswhRequestNum;
        }

        // set and get Fund redirect Request Num to service for reuse
        fundSwitchRedirect.setFundRedRequestStatusNum = function(data) {
            fundRedRequestNum = data;
        }
        fundSwitchRedirect.getFundRedRequestStatusNum = function() {
            return fundRedRequestNum;
        }

        fundSwitchRedirect.getFundAllocationForSwitching = function(requestObject) {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getFundAllocationForSwitching[0], requestObject, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };

        fundSwitchRedirect.getFundSwitchTable = function(requestObject) {
            var q = $q.defer();
            AdapterUtils.getData(lifeInsuranceConfig.adapterURL.getFundSwitchTable[0], true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };

        fundSwitchRedirect.getFundRedirectTable = function(requestObject) {
            var q = $q.defer();
            AdapterUtils.getData(lifeInsuranceConfig.adapterURL.getFundRedirectTable[0], true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };

        fundSwitchRedirect.validateFundSwitch = function(requestObject) {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.validateFundSwitch[0], requestObject, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };


        fundSwitchRedirect.switchFund = function(requestObject) {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.switchFund[0], requestObject, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };


        fundSwitchRedirect.getFundAllocationForRedirect = function(requestObject) {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getFundAllocationForRedirect[0], requestObject, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        }


        fundSwitchRedirect.validateFundRedirect = function(requestObject) {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.validateFundRedirect[0], requestObject, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };


        fundSwitchRedirect.redirectFund = function(requestObject) {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.redirectFund[0], requestObject, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };

        fundSwitchRedirect.getFundRedirectText = function() {
            var q = $q.defer();
            AdapterUtils.getData(lifeInsuranceConfig.adapterURL.getFundRedirectText[0], true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        fundSwitchRedirect.getFundSwitchText = function() {
            var q = $q.defer();
            AdapterUtils.getData(lifeInsuranceConfig.adapterURL.getFundSwitchText[0], true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        fundSwitchRedirect.getPaymentComplete = function() {
            var q = $q.defer();
            AdapterUtils.getData(lifeInsuranceConfig.adapterURL.getPaymentComplete[0], true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };

        return fundSwitchRedirect;
    }
]);
