angularApp.controller('lifeInsuranceFundRedirectController', ["$timeout",
    "$state",
    "$scope",
    "$translate",
    "fundSwitchRedirectService",
    "lifeInsuranceConfig",
    "linkingLIPolicyService",
    "$ionicPopup",
    "$ionicScrollDelegate",
    "utilityService",

    function($timeout,
        $state,
        $scope,
        $translate,
        fundSwitchRedirectService,
        lifeInsuranceConfig,
        linkingLIPolicyService,
        $ionicPopup,
        $ionicScrollDelegate,
        utilityService) {

        var lifeInsuranceFundRedirectVm = this;

        function initPage() {
            lifeInsuranceFundRedirectVm.showBack = false;
            lifeInsuranceFundRedirectVm.showNext = true;
            lifeInsuranceFundRedirectVm.ckExceds100Val = false;
            lifeInsuranceFundRedirectVm.newAllocation = [];
            lifeInsuranceFundRedirectVm.TotalNewAllocation = 0;
            lifeInsuranceFundRedirectVm.canShow = [];
            lifeInsuranceFundRedirectVm.isConfirm = false;

            changeNextName();

            fundSwitchRedirectService.getFundRedirectText().then(function(data) {
                lifeInsuranceFundRedirectVm.note = data.message;
            });

            var details = linkingLIPolicyService.getMyPolicyDetails();
            if (details) {
                lifeInsuranceFundRedirectVm.productName = details.policyDetails.productName;
                lifeInsuranceFundRedirectVm.policyNumber = details.policyDetails.policyNumber;
            }
            getCurrentFundAllocationDetails();
        }

        function changeNextName() {
            if (!lifeInsuranceFundRedirectVm.isConfirm) {
                lifeInsuranceFundRedirectVm.nextButtonName = $translate.instant('CONFIRM_LBL');
            } else {
                lifeInsuranceFundRedirectVm.nextButtonName = $translate.instant('SUBMIT_LBL');
            }
        };

        function getCurrentFundAllocationDetails() {
            if (fundSwitchRedirectService.getFundRedirect()) {
                lifeInsuranceFundRedirectVm.FundData = fundSwitchRedirectService.getFundRedirect().fundAllocation;
                for (var count = 0; count < lifeInsuranceFundRedirectVm.FundData.length; count++) {
                    lifeInsuranceFundRedirectVm.newAllocation[count] = "";
                }
            }
        }

        lifeInsuranceFundRedirectVm.resize = function() {
            $ionicScrollDelegate.$getByHandle('mainScroll').resize();
        };

        function showFundAmountTable() {
            var alertPopup = $ionicPopup.alert({
                title: '',
                template: '<p class="roboto-regular font-content fund-table" ng-bind-html="lifeInsuranceFundRedirectVm.fundAmountTable"></p>',
                scope: $scope,
                cssClass: 'bi-table'
            });
            alertPopup.then(function(res) {});
        };

        lifeInsuranceFundRedirectVm.getFundAmountTable = function() {
            if (!lifeInsuranceFundRedirectVm.fundAmountTable) {
                fundSwitchRedirectService.getFundSwitchTable().then(function(data) {
                    lifeInsuranceFundRedirectVm.fundAmountTable = data.message;
                    showFundAmountTable();
                });
            } else {
                showFundAmountTable();
            }
        };

        lifeInsuranceFundRedirectVm.toggleSelect = function(index) {
            if (lifeInsuranceFundRedirectVm.canShow[index] == true) {
                lifeInsuranceFundRedirectVm.canShow[index] = false;
            } else {
                lifeInsuranceFundRedirectVm.canShow[index] = true;
            }
        };


        lifeInsuranceFundRedirectVm.updateNewAllocation = function() {
            lifeInsuranceFundRedirectVm.TotalNewAllocation = 0;
            for (var count = 0; count < lifeInsuranceFundRedirectVm.FundData.length; count++) {
                if (lifeInsuranceFundRedirectVm.newAllocation[count] != "") {
                    lifeInsuranceFundRedirectVm.TotalNewAllocation =
                        lifeInsuranceFundRedirectVm.TotalNewAllocation + parseFloat(lifeInsuranceFundRedirectVm.newAllocation[count]);
                }
            }

            if (lifeInsuranceFundRedirectVm.TotalNewAllocation > 100) {
                lifeInsuranceFundRedirectVm.ckExceds100Val = true;
            } else {
                lifeInsuranceFundRedirectVm.ckExceds100Val = false;
            }
        }


        lifeInsuranceFundRedirectVm.goToNextPage = function() {
            if (lifeInsuranceFundRedirectVm.TotalNewAllocation == 100) {
                fundRedirect();
            } else {
                lifeInsuranceFundRedirectVm.ckExceds100Val = true;
            }
        }

        lifeInsuranceFundRedirectVm.goNext = function() {
            if (!lifeInsuranceFundRedirectVm.isConfirm) {
                lifeInsuranceFundRedirectVm.goToNextPage();

            } else {
                lifeInsuranceFundRedirectVm.submitFundRedirect();
            }
        };

        lifeInsuranceFundRedirectVm.goBacktoPrevious = function() {
            if (lifeInsuranceFundRedirectVm.isConfirm) {
                lifeInsuranceFundRedirectVm.isConfirm = false;
            } else {
                $state.go("menu.myPolicyDetails");
            }
        };

        function fundRedirect() {

            var alertPopup = $ionicPopup.alert({
                title: 'Terms and Condition',
                template: '<p class="text-align-center" ng-bind-html="lifeInsuranceFundRedirectVm.note | ngBindHtmlFilter"></p>',
                scope: $scope,
                cssClass: 'bi-table',
                buttons: [{
                    text: 'Cancel',
                    type: 'button-negative',
                    onTap: function(e) {
                        return false;
                    }

                }, {
                    text: 'Agree',
                    type: 'button-positive',
                    onTap: function(e) {
                        return true;
                    }
                }]
            });
            alertPopup.then(function(res) {
                if (res) {
                    confirmFundRedirect();
                }
            });
        }



        function confirmFundRedirect() {
            lifeInsuranceFundRedirectVm.newFundAllocationJson = {};
            lifeInsuranceFundRedirectVm.newFundAllocationJson.policyNumber = lifeInsuranceFundRedirectVm.policyNumber;
            lifeInsuranceFundRedirectVm.newFundAllocationJson.fundAllocations = [];
            for (var count = 0; count < lifeInsuranceFundRedirectVm.FundData.length; count++) {
                var object = {};
                object.key = lifeInsuranceFundRedirectVm.FundData[count].key;
                object.value = {};
                object.value.oldValue = lifeInsuranceFundRedirectVm.FundData[count].value;
                if (lifeInsuranceFundRedirectVm.newAllocation[count] != "") {
                    object.value.newValue = parseFloat(lifeInsuranceFundRedirectVm.newAllocation[count]);
                } else {
                    // object.value.new = 0;
                }
                object.value.currentValue = lifeInsuranceFundRedirectVm.FundData[count].currentValue;
                lifeInsuranceFundRedirectVm.newFundAllocationJson.fundAllocations.push(object);
            }

            fundSwitchRedirectService.validateFundRedirect(lifeInsuranceFundRedirectVm.newFundAllocationJson).then(function(data) {
                $ionicScrollDelegate.scrollTop();
                lifeInsuranceFundRedirectVm.isConfirm = true;
                lifeInsuranceFundRedirectVm.canShow = [];
                changeNextName();
            }, function(error) {
               
            });
        };


        lifeInsuranceFundRedirectVm.submitFundRedirect = function() {
            fundSwitchRedirectService.redirectFund(lifeInsuranceFundRedirectVm.newFundAllocationJson).then(function(data) {
                fundSwitchRedirectService.setFundRedRequestStatusNum(data.requestNumber);
                $state.go("menu.lifeInsuranceRequestReceived2");
            }, function(error) {

            });
        };

        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicScrollDelegate.scrollTop();
            initPage();
        });

    }
]);
