angularApp.controller('lifeInsuranceFundSwitchController', [
    "$state",
    "$scope",
    "$translate",
    "fundSwitchRedirectService",
    "linkingLIPolicyService",
    "$ionicPopup",
    "$ionicScrollDelegate",
    "utilityService",
    "$filter",
    "validateService",

    function(
        $state,
        $scope,
        $translate,
        fundSwitchRedirectService,
        linkingLIPolicyService,
        $ionicPopup,
        $ionicScrollDelegate,
        utilityService,
        $filter,
        validateService) {

        var lifeInsuranceFundSwitchVm = this;


        function initPage() {
            lifeInsuranceFundSwitchVm.showBack = true;
            lifeInsuranceFundSwitchVm.showNext = true;
            lifeInsuranceFundSwitchVm.ckExceds100Val = false;
            lifeInsuranceFundSwitchVm.newAllocation = [];
            lifeInsuranceFundSwitchVm.oldAllocation = [];
            lifeInsuranceFundSwitchVm.TotalNewAllocation = 0;
            lifeInsuranceFundSwitchVm.canShow = [];
            lifeInsuranceFundSwitchVm.isConfirm = false;
            lifeInsuranceFundSwitchVm.fundAsOn = $filter('chosenDate')(validateService.getCurrentDate());

            changeNextName();

            fundSwitchRedirectService.getFundSwitchText().then(function(data) {
                lifeInsuranceFundSwitchVm.note = data.message;
            });

            var details = linkingLIPolicyService.getMyPolicyDetails();
            if (details) {
                lifeInsuranceFundSwitchVm.productName = details.policyDetails.productName;
                lifeInsuranceFundSwitchVm.policyNumber = details.policyDetails.policyNumber;
            }
            getCurrentFundAllocationDetails();
        }


        function changeNextName() {
            if (!lifeInsuranceFundSwitchVm.isConfirm) {
                lifeInsuranceFundSwitchVm.nextButtonName = $translate.instant('CONFIRM_LBL');
            } else {
                lifeInsuranceFundSwitchVm.nextButtonName = $translate.instant('SUBMIT_LBL');
            }
        };

        lifeInsuranceFundSwitchVm.resize = function() {
            $ionicScrollDelegate.$getByHandle('mainScroll').resize();
        };


        function getCurrentFundAllocationDetails() {
            if (fundSwitchRedirectService.getFundSwitch()) {
                lifeInsuranceFundSwitchVm.FundData = fundSwitchRedirectService.getFundSwitch().fundAllocation;
                for (var count = 0; count < lifeInsuranceFundSwitchVm.FundData.length; count++) {
                    lifeInsuranceFundSwitchVm.newAllocation[count] = "";
                    lifeInsuranceFundSwitchVm.oldAllocation[count] = "";
                }
            }
        }

        lifeInsuranceFundSwitchVm.toggleSelect = function(index) {
            if (lifeInsuranceFundSwitchVm.canShow[index] == true) {
                lifeInsuranceFundSwitchVm.canShow[index] = false;
            } else {
                lifeInsuranceFundSwitchVm.canShow[index] = true;
            }
            lifeInsuranceFundSwitchVm.resize();
        };

        lifeInsuranceFundSwitchVm.updateNewAllocation = function() {
            lifeInsuranceFundSwitchVm.TotalNewAllocation = 0;
            for (var count = 0; count < lifeInsuranceFundSwitchVm.FundData.length; count++) {
                if (lifeInsuranceFundSwitchVm.newAllocation[count] != "") {
                    lifeInsuranceFundSwitchVm.TotalNewAllocation =
                        lifeInsuranceFundSwitchVm.TotalNewAllocation + parseFloat(lifeInsuranceFundSwitchVm.newAllocation[count]);
                }
            }
            if (lifeInsuranceFundSwitchVm.TotalNewAllocation > 100) {
                lifeInsuranceFundSwitchVm.ckExceds100Val = true;
            } else {
                lifeInsuranceFundSwitchVm.ckExceds100Val = false;
            }
        };

        function showFundAmountTable() {
            var alertPopup = $ionicPopup.alert({
                title: '',
                template: '<p class="roboto-regular font-content fund-table" ng-bind-html="lifeInsuranceFundSwitchVm.fundAmountTable"></p>',
                scope: $scope,
                cssClass: 'bi-table'
            });
            alertPopup.then(function(res) {});
        };

        lifeInsuranceFundSwitchVm.getFundAmountTable = function() {
            if (!lifeInsuranceFundSwitchVm.fundAmountTable) {
                fundSwitchRedirectService.getFundSwitchTable().then(function(data) {
                    lifeInsuranceFundSwitchVm.fundAmountTable = data.message;
                    showFundAmountTable();
                });
            } else {
                showFundAmountTable();
            }
        };

        lifeInsuranceFundSwitchVm.requestReceived = function() {
            if (lifeInsuranceFundSwitchVm.TotalNewAllocation == 100) {
                fundSwitch();
            } else {
                lifeInsuranceFundSwitchVm.ckExceds100Val = true;
            }
        };

        lifeInsuranceFundSwitchVm.goBacktoPrevious = function() {
            if (lifeInsuranceFundSwitchVm.isConfirm) {
                lifeInsuranceFundSwitchVm.isConfirm = false;
            } else {
                $state.go("menu.myPolicyDetails");
            }
        };

        lifeInsuranceFundSwitchVm.goNext = function() {
            if (!lifeInsuranceFundSwitchVm.isConfirm) {
                lifeInsuranceFundSwitchVm.requestReceived();
            } else {
                lifeInsuranceFundSwitchVm.submitFundSwitch();
            }
        };

        function fundSwitch() {
            var alertPopup = $ionicPopup.alert({
                title: 'Terms and Condition',
                template: '<p class="text-align-center" ng-bind-html="lifeInsuranceFundSwitchVm.note | ngBindHtmlFilter"></p>',
                scope: $scope,
                cssClass: 'bi-table',
                buttons: [{
                    text: 'Cancel',
                    type: 'button-negative',
                    onTap: function(e) {
                        return false;
                    }
                }, {
                    text: 'Agree',
                    type: 'button-positive',
                    onTap: function(e) {
                        return true;
                    }
                }]
            });
            alertPopup.then(function(res) {
                if (res) {
                    confirmFundSwitch();
                }
            });
        };

        function confirmFundSwitch() {
            lifeInsuranceFundSwitchVm.newFundAllocationJson = {};
            lifeInsuranceFundSwitchVm.newFundAllocationJson.policyNumber = lifeInsuranceFundSwitchVm.policyNumber;
            lifeInsuranceFundSwitchVm.newFundAllocationJson.fundAllocations = [];
            for (var count = 0; count < lifeInsuranceFundSwitchVm.FundData.length; count++) {
                var object = {};
                object.key = lifeInsuranceFundSwitchVm.FundData[count].key;
                object.value = {};
                //object.value.old = lifeInsuranceFundSwitchVm.FundData[count].value;

                if (lifeInsuranceFundSwitchVm.oldAllocation[count] != "") {
                    object.value.oldValue = parseFloat(lifeInsuranceFundSwitchVm.oldAllocation[count]);
                } else {
                    // object.value.old = 0;
                }


                if (lifeInsuranceFundSwitchVm.newAllocation[count] != "") {
                    object.value.newValue = parseFloat(lifeInsuranceFundSwitchVm.newAllocation[count]);
                } else {
                    //  object.value.new = 0;
                }

                object.value.currentValue = lifeInsuranceFundSwitchVm.FundData[count].currentValue;
                lifeInsuranceFundSwitchVm.newFundAllocationJson.fundAllocations.push(object);
            }

            fundSwitchRedirectService.validateFundSwitch(lifeInsuranceFundSwitchVm.newFundAllocationJson).then(function(data) {
                $ionicScrollDelegate.scrollTop();
                lifeInsuranceFundSwitchVm.isConfirm = true;
                lifeInsuranceFundSwitchVm.canShow = [];
                changeNextName();
            }, function(error) {

            });
        };


        lifeInsuranceFundSwitchVm.submitFundSwitch = function() {
            fundSwitchRedirectService.switchFund(lifeInsuranceFundSwitchVm.newFundAllocationJson).then(function(data) {
                fundSwitchRedirectService.setFundswhRequestStatusNum(data.requestNumber);
                $state.go("menu.lifeInsuranceRequestReceived");
            }, function(error) {

            });
        };


        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicScrollDelegate.scrollTop();
            initPage();
        });

    }
]);
