angularApp.controller('lifeInsuranceAadharScanController', [
    "$state",
    "$scope",
    "validateService",
    "commonAPIService",
    "lifeInsuranceBasicApplicationService",
    "suggestedPlansDetailsService",

    function(
        $state,
        $scope,
        validateService,
        commonAPIService,
        lifeInsuranceBasicApplicationService,
        suggestedPlansDetailsService) {

        //functions, variables that can be accessed from the HTML come here
        var lifeInsuranceAadharScanVm = this;
        lifeInsuranceAadharScanVm.commonAPIService = commonAPIService;
        lifeInsuranceAadharScanVm.validateService = validateService;

        //private methods section start
        function initPage() {
            lifeInsuranceAadharScanVm.showBack = true;
            lifeInsuranceAadharScanVm.showNext = true;
            lifeInsuranceAadharScanVm.agree = false;
            lifeInsuranceAadharScanVm.isAadharEntered = false;

            lifeInsuranceAadharScanVm.aadharText = lifeInsuranceBasicApplicationService.getAadharText();
        }

        lifeInsuranceAadharScanVm.scanAdhar = function() {
            lifeInsuranceAadharScanVm.commonAPIService.QRcodescanner(function(dataAdhar) {
                lifeInsuranceAadharScanVm.AadharCardNumber = dataAdhar.uid;
                lifeInsuranceAadharScanVm.isAadharEntered = true;
            });
        };

        lifeInsuranceAadharScanVm.showAadhar = function() {

        };


        lifeInsuranceAadharScanVm.canShowAadhar = function() {
            if (lifeInsuranceAadharScanVm.AadharCardNumber.length == 12) {
                lifeInsuranceAadharScanVm.isAadharEntered = true;
                lifeInsuranceAadharScanVm.showAadhar();
            } else {
                lifeInsuranceAadharScanVm.isAadharEntered = false;
            }
        };

        lifeInsuranceAadharScanVm.goToNextPage = function() {
            if (validateForm()) {
                var reqObj = {
                    "AadharCardNumber": "lifeInsuranceAadharScanVm.AadharCardNumber"
                };
                $state.go('menu.lifeInsurancePayment');
            }
        }

        function fillAadharText() {
            var applicationData = lifeInsuranceBasicApplicationService.getapplicationData();
            var product = suggestedPlansDetailsService.getCurrentSugestedProduct();
            var name = applicationData.personalDetails.name.first;
            if (applicationData.personalDetails.name.middle) {
                name = name + " " + applicationData.personalDetails.name.middle;
            }
            if (applicationData.personalDetails.name.last) {
                name = name + " " + applicationData.personalDetails.name.last;
            }

            document.getElementById('cusname').innerHTML = name;
            document.getElementById('policyname').innerHTML = product.planName;
            document.getElementById('aadharnumber').innerHTML = applicationData.fatcacrs.idProofNumber;
            document.getElementById('policyuin').innerHTML = product.uin;
        };

        //conmmon validation function
        function validateForm() {
            lifeInsuranceAadharScanVm.frmLiAadharScan = {};

            if (lifeInsuranceAadharScanVm.validateService.isValidAadharCardNum(lifeInsuranceAadharScanVm.AadharCardNumber)) {
                lifeInsuranceAadharScanVm.frmLiAadharScan.AadharCardNumber = lifeInsuranceAadharScanVm.validateService.isValidAadharCardNum(lifeInsuranceAadharScanVm.AadharCardNumber);
            }

            if (lifeInsuranceAadharScanVm.validateService.isAgree(lifeInsuranceAadharScanVm.agree)) {
                lifeInsuranceAadharScanVm.frmLiAadharScan.agree = lifeInsuranceAadharScanVm.validateService.isAgree(lifeInsuranceAadharScanVm.agree);
            }
            return (angular.equals({}, lifeInsuranceAadharScanVm.frmLiAadharScan)) ? true : false;
        }


        lifeInsuranceAadharScanVm.goBacktoPrevious = function() {
            $state.go('menu.liForm_Preview');
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        $scope.$on('$ionicView.enter', function() {
            fillAadharText();
        });
    }
]);
