(function() {
    'use strict';

    angularApp.service('lifeInsuranceCommonService', lifeInsuranceCommonService);

    lifeInsuranceCommonService.$inject = ['AdapterUtils',
        '$q',
        'utilityService',
        'lifeInsuranceBasicApplicationService',
        'premiumCalculationService',
        'lifeInsuranceApplicationService',
        '$ionicPopup',
        'suggestedPlansDetailsService',
        'lifeInsuranceConfig',
        '$state',
        'LiConstant'
    ];

    function lifeInsuranceCommonService(AdapterUtils,
        $q,
        utilityService,
        lifeInsuranceBasicApplicationService,
        premiumCalculationService,
        lifeInsuranceApplicationService,
        $ionicPopup,
        suggestedPlansDetailsService,
        lifeInsuranceConfig,
        $state,LiConstant) {

        var lifeInsuranceCommon = this;
        var isFromRetrieveApplication;
        var calculatedKey;
        var naDataReq = {};
        var naDataRes = {};

        var biDataReq = {};
        var biDataRes = {};
        var biProduct = {};

        var appDataReq = {};
        var appDataRes = {};
        var serviceLength;
        var selectedUIN;
         var renewalData='';

        lifeInsuranceCommon.renewalDataAdd = function (renewal) {
            renewalData = renewal;
        };
        lifeInsuranceCommon.getRenewalData = function () {
            return renewalData;
        };
        lifeInsuranceCommon.isFromRetrieveApplication = function() {
            return isFromRetrieveApplication;
        };
        // Function to verify secKey from the response
        lifeInsuranceCommon.verifySeckey = function(secKey){
            return calculatedKey=((secKey/2)-1)/99;
        };

        lifeInsuranceCommon.setIsFromRetrieveApplication = function(value) {
            isFromRetrieveApplication = value;
        };

        lifeInsuranceCommon.getSavedApplication = function(quote) {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getNBAData[0], quote, true).then(
                function(response) {
                    q.resolve(response.data);
                    var pageNo = response.data.na.pageNo;
                    lifeInsuranceBasicApplicationService.resetUploadImageCount();
                    //NA data
                    if (response.data.na) {
                        naDataReq = response.data.na.na.req;
                        naDataRes = response.data.na.na.res;
                        lifeInsuranceApplicationService.setNeedAnalysis(response.data.na.na.req);
                        lifeInsuranceApplicationService.getMasterData().then(function(data) {
                            if (response.data.na && !response.data.bi && !response.data.app) {
                                lifeInsuranceApplicationService.getJourneyMasterFromCloud().then(function(data) {
                                   lifeInsuranceCommon.getSavedJourney().then(function(data) {
                                        $state.go(data.mobileURL);
                                   }, function(error) {
                                        $state.go('menu.lifeInsuranceApplicationInfoPD');
                                   });
                                });
                            }
                        });
                    }

                    //BI data
                    if (response.data.bi) {
                        var biData = response.data.bi.bi;
                        biDataReq = JSON.parse(response.data.bi.bi.req);

                        if(response.data.bi.bi.res) {
                            biDataRes = JSON.parse(response.data.bi.bi.res);
                        }
                        
                        selectedUIN = biDataReq.uin;
                        if (biDataReq.productCode == LiConstant.productCode.SARAL_SWADHAN_PLUS) {
                            var productDet = {};
                            productDet.productCode = biDataReq.productCode;
                            productDet.planName = biDataReq.productName;
                            productDet.uin = biDataReq.uin;
                            suggestedPlansDetailsService.setCurrentSugestedProduct(productDet);
                            premiumCalculationService.setBiDataSS(biData);
                        }

                        //"SBI Life - Smart Money Back Gold"        
                        if (biDataReq.productCode == LiConstant.productCode.SMART_MONEY_BACK_GOLD) {
                            var productDet = {};
                            productDet.productCode = biDataReq.productCode;
                            productDet.planName = biDataReq.productName;
                            productDet.uin = biDataReq.uin;
                            suggestedPlansDetailsService.setCurrentSugestedProduct(productDet);
                            premiumCalculationService.setBiDataSM(biData);
                        }
                        //Smart Wealth Builder    
                        if (biDataReq.productCode == LiConstant.productCode.SMART_WEALTH_BUILDER) {
                            var productDet = {};
                            productDet.productCode = biDataReq.productCode;
                            productDet.planName = biDataReq.productName;
                            productDet.uin = biDataReq.uin;
                            suggestedPlansDetailsService.setCurrentSugestedProduct(productDet);
                            premiumCalculationService.setBiDataSW(biData);
                        }

                        //Smart Champ Insurance
                        if (biDataReq.productCode == LiConstant.productCode.SMART_CHAMP_INSURANCE) {
                            var productDet = {};
                            productDet.productCode = biDataReq.productCode;
                            productDet.planName = biDataReq.productName;
                            productDet.uin = biDataReq.uin;
                            suggestedPlansDetailsService.setCurrentSugestedProduct(productDet);
                            premiumCalculationService.setBiDataSC(biData);
                        }

                        //"SBI Life - Shub Nivesh"    
                        if (biDataReq.productCode == LiConstant.productCode.SHUBH_NIVESH) {
                            var productDet = {};
                            productDet.productCode = biDataReq.productCode;
                            productDet.planName = biDataReq.productName;
                            productDet.uin = biDataReq.uin;
                            suggestedPlansDetailsService.setCurrentSugestedProduct(productDet);
                            premiumCalculationService.setBiDataSN(biData);
                        }

                        //"SBI Life - Retire Smart"    
                        if (biDataReq.productCode == LiConstant.productCode.RETIRE_SMART) {
                            var productDet = {};
                            productDet.productCode = biDataReq.productCode;
                            productDet.planName = biDataReq.productName;
                            productDet.uin = biDataReq.uin;
                            suggestedPlansDetailsService.setCurrentSugestedProduct(productDet);
                            premiumCalculationService.setBiDataRS(biData);
                        }
                        premiumCalculationService.getMasterDataPlans().then(function(data) {
                            premiumCalculationService.setMasterDataPlans(data);
                            if (response.data.na && response.data.bi && !response.data.app) {
                                suggestedPlansDetailsService.getPlanDetails().then(function(data) {
                                    suggestedPlansDetailsService.setPlanDetails(data);
                                    lifeInsuranceApplicationService.getJourneyMasterFromCloud().then(function(data) {
                                        lifeInsuranceCommon.getSavedJourney().then(function(data) {
                                            $state.go(data.mobileURL);
                                        }, function(error) {
                                            $state.go('menu.planDetails');
                                        });
                                    });
                                }, function(error) {});
                            }
                        })
                    }

                    if (response.data.app) {
                        var req = response.data.app.application.req;
                        if (response.data.app.application.res) {
                            lifeInsuranceBasicApplicationService.setSubmitApplicationResponse(response.data.app.application.res);
                        }
                        lifeInsuranceBasicApplicationService.setApplicationDetails(req);
                        if(req.medicalHistory) {
                            lifeInsuranceBasicApplicationService.retrieveMedicalHistory(req.medicalHistory);
                        } else {
                            lifeInsuranceBasicApplicationService.resetMedicalHistory();
                        }
                        var reqObj = {};
                        reqObj.uin = selectedUIN;

                        lifeInsuranceBasicApplicationService.getApplicationMasterData().then(function(data) {
                            lifeInsuranceBasicApplicationService.getMasterDataHealth(reqObj).then(function(data) {
                                lifeInsuranceBasicApplicationService.setMedicalQuestions(data);
                                if (response.data.na && response.data.bi && response.data.app) {
                                    suggestedPlansDetailsService.getPlanDetails().then(function(data) {
                                        suggestedPlansDetailsService.setPlanDetails(data);
                                        lifeInsuranceApplicationService.getJourneyMasterFromCloud().then(function(data) {
                                            lifeInsuranceCommon.getSavedJourney().then(function(data) {
                                                $state.go(data.mobileURL);
                                            }, function(error) {
                                                $state.go('menu.lifeInsuranceBasicInformation');
                                            });
                                        });
                                    }, function(error) {});
                                }
                            });
                        });
                    }
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        lifeInsuranceCommon.getSavedJourney = function() {
            var q = $q.defer();
            var request = {
                "id": lifeInsuranceApplicationService.getApplicationNumber(),
                "journeyType": "LI"
            }
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getLiSavedJourney[0], request, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        lifeInsuranceCommon.closePopUp = function() {
            var alertPopup = $ionicPopup.alert({
                template: '<div class="roboto-regular font-content text-center" translate="JOURNEY_CLOSE"></div>',
                buttons: [{
                    text: 'Cancel',
                    type: 'button-negative',
                    onTap: function(e) {
                        return false;
                    }

                }, {
                    text: 'Agree',
                    type: 'button-positive',
                    onTap: function(e) {
                        return true;
                    }
                }]
            });
            return alertPopup;
        };

        lifeInsuranceCommon.retreiveLIPendingApplications = function() {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.retreiveLIApplications[0], {}, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        lifeInsuranceCommon.checkProposalStatus = function(requestObj) {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.checkLIProposalStatus[0], requestObj, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        lifeInsuranceCommon.removeSavedApplication = function(requestObj) {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.removeLiSavedApplication[0], requestObj, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        //Function to get a random 4 digit number
        lifeInsuranceCommon.getSecretDigit = function() {
            return Math.floor((Math.random() * 8999) + 1000).toString();
        };

        //To validate the secret key
        lifeInsuranceCommon.validateSecretKey = function(original, received) {
            var newKey = ((Number(received) / 2) - 1) / 99;

            if(Number(original) == Number(newKey)) {
                return true;
            } else {
                return false;
            }
        };

    }
})();
