/**
 *   @ngdoc config
 *   @name angularApp.config : lifeInsuranceConfig
 *   @description
 *  configuration file for life insurance module
 */

/*This function defines all the constants named  Adapters url for Life Insurance module*/
angularApp
    .value(
        'lifeInsuranceConfig', {
            "errorMessage": {
                'enterValidOTP': 'Please enter valid OTP.'
            },
            "adapterURL": {

                "browseAllGIPlans": ['adapter/browseAllGIPlans', 'get'],
                "getFundAllocationForSwitching": ['adapters/LifeInsuranceAdapterv2/getFundAllocationForSwitching', 'post'],
                "getFundAllocationForRedirect": ['adapters/LifeInsuranceAdapterv2/getFundAllocationForRedirect', 'post'],
                "validateFundSwitch": ['adapters/LifeInsuranceAdapterv2/validateFundSwitch', 'post'],
                "validateFundRedirect": ['adapters/LifeInsuranceAdapterv2/validateFundRedirect', 'post'],
                "switchFund": ['adapters/LifeInsuranceAdapterv2/switchFund', 'post'],
                "redirectFund": ['adapters/LifeInsuranceAdapterv2/redirectFund', 'post'],
                "performNeedAnalysis": ['adapters/LifeInsuranceAdapterv2/performNeedAnalysis', 'post'],
                "getPlanDetails": ['adapters/LifeInsuranceAdapterv2/getPlanDetails', 'post'],
                "getPremiumSmartWealthBuilder": ['adapters/LifeInsuranceAdapterv2/getPremiumSmartWealthBuilder', 'post'],
                "submitApplication": ['adapters/LifeInsuranceAdapterv2/submitApplication', 'post', '120000'],
                "payForPolicyPurchase": ['adapters/LifeInsuranceAdapterv2/payForPolicyPurchase', 'post'],
                "linkPolicy": ['adapters/LifeInsuranceAdapterv2/linkPolicy', 'post'],
                "getOTPForLinkPolicy": ['adapters/LifeInsuranceAdapterv2/sendOTP', 'post'],
                "getPolicyDetails": ['adapters/LifeInsuranceAdapterv2/getPolicyDetails', 'post'],
                "downloadStatement": ['adapters/LifeInsuranceAdapterv2/getEStatementPDF', 'post', '120000'],
                "getStateList": ['adapters/LifeInsuranceAdapterv2/getStateList', 'get'],
                "getCityList": ['adapters/LifeInsuranceAdapterv2/getCityList', 'post'],
                "getDidYouKnowList": ['adapters/LifeInsuranceAdapterv2/getDidYouKnowList', 'get'],
                "getNeedAnalysisMasters": ['adapters/LifeInsuranceAdapterv2/getNeedAnalysisMasters', 'get'],
                "getProofDocumentList": ['adapters/LifeInsuranceAdapterv2/getProofDocumentList', 'get'],
                "getPremiumCalMasters": ['adapters/LifeInsuranceAdapterv2/getPremiumCalMasters', 'post'],
                "getLISBIBankAccounts": ['adapters/FSSCommonAdapter/getOwnAccounts'],
                "getLISBIBankAccountDetails": ['adapters/FSSCommonAdapter/getBankAccountHolderDetails'],
                "getHealthQuestions": ['adapters/LifeInsuranceAdapterv2/getHealthQuestions', 'post'],
                "consentText": ['adapters/LifeInsuranceAdapterv2/getConsentProceedText', 'get'],
                "didYouKnowList": ['adapters/LifeInsuranceAdapterv2/getDidYouKnowList', 'get'],
                "getAllPlans": ['adapters/LifeInsuranceAdapterv2/getAllPlans', 'get'],
                "getPremiumSaralSwadhan": ['adapters/LifeInsuranceAdapterv2/getPremiumSaralSwadhan', 'post'],
                "getPremiumRetireSmart": ['adapters/LifeInsuranceAdapterv2/getPremiumRetireSmart', 'post'],
                "getPremiumSmartChamp": ['adapters/LifeInsuranceAdapterv2/getPremiumSmartChamp', 'post'],
                "getPremiumMoneyBackGold": ['adapters/LifeInsuranceAdapterv2/getPremiumMoneyBackGold', 'post'],
                "getFatcaCRSContent": ['adapters/LifeInsuranceAdapterv2/getFatcaCRSContent', 'get'],
                "getHUFKartaContent": ['adapters/LifeInsuranceAdapterv2/getHUFKartaContent', 'get'],
                "getPremiumShubhNivesh": ['adapters/LifeInsuranceAdapterv2/getPremiumShubhNivesh', 'post'],
                "getApplicationMasterData": ['adapters/LifeInsuranceAdapterv2/getApplicationPartMasters', 'get'],
                "getCallCenterNumber": ['adapters/LifeInsuranceAdapterv2/getCallCenterNumber', 'get'],
                "getLILinkedPolicies": ['adapters/LifeInsuranceAdapterv2/getLinkedPolicies', 'post'],
                "saveApplication": ['adapters/LifeInsuranceAdapterv2/saveApplication', 'post'],
                "uploadDoc": ['adapters/LifeInsuranceAdapterv2/uploadDoc', 'post', '120000'],
                "getNBAData": ['adapters/LifeInsuranceAdapterv2/getNBAData', 'post'],
                "getInsuranceActContent": ['adapters/LifeInsuranceAdapterv2/getInsuranceActContent', 'get'],
                "getNoteViewTop": ['adapters/LifeInsuranceAdapterv2/getNoteViewTop', 'get'],
                "getNoteViewBottom": ['adapters/LifeInsuranceAdapterv2/getNoteViewBottom', 'get'],
                "getNoteSuggesionText": ['adapters/LifeInsuranceAdapterv2/getNoteSuggesionText', 'get'],
                "getLetsMakeFasterText": ['adapters/LifeInsuranceAdapterv2/getLetsMakeFasterText', 'get'],
                "getProductDisclaimer": ['adapters/LifeInsuranceAdapterv2/getProductDisclaimer', 'get'],
                "getProductNotSold": ['adapters/LifeInsuranceAdapterv2/getProductNotSold', 'get'],
                "getFundRedirectText": ['adapters/LifeInsuranceAdapterv2/getFundRedirect', 'get'],
                "getFundSwitchText": ['adapters/LifeInsuranceAdapterv2/getFundSwitch', 'get'],
                "getPaymentComplete": ['adapters/LifeInsuranceAdapterv2/getPaymentComplete', 'get'],
                "getConsentProceedAddressText": ['adapters/LifeInsuranceAdapterv2/getConsentProceedAddressText', 'get'],
                "getWelcomeText": ['adapters/LifeInsuranceAdapterv2/getWelcomeText', 'get'],
                "getBenefitIllustratorText": ['adapters/LifeInsuranceAdapterv2/getBenefitIllustratorText', 'get'],
                "getIRDAIText": ['adapters/LifeInsuranceAdapterv2/getIRDAItext', 'get'],
                "getLIAadharText": ['adapters/LifeInsuranceAdapterv2/getAadharText', 'get'],
                "saveNA": ['adapters/LifeInsuranceAdapterv2/saveNA', 'post'],
                "getLIOTPToken": ['adapters/OTPAdapter/getOTPTokenSecure', 'post'],
                "validateLIOTPToken": ['adapters/LifeInsuranceAdapterv2/validateOTP', 'post'],
                "validateOTPForPayNew": ['adapters/LifeInsuranceAdapterv2/validateOTPForPayNew', 'post'],
                "validateOTPForPayRenew": ['adapters/LifeInsuranceAdapterv2/validateOTPForPayRenew', 'post'],
                "validateOTPForSbiLifeSmbRenew": ['adapters/LifeInsuranceAdapterv2/validateOTPForSbiLifeSmbRenew', 'post'],
                "saveBI": ['adapters/LifeInsuranceAdapterv2/saveBI', 'post'],
                "payNewLIPolicy": ['adapters/LifeInsuranceAdapterv2/payNewPolicy', 'post', '120000'],
                "payRenewLIPolicy": ['adapters/LifeInsuranceAdapterv2/payRenewPolicy', 'post', '120000'],
                "payRenewSbiLifeSmbPolicy": ['adapters/LifeInsuranceAdapterv2/payRenewSbiLifeSmbPolicy', 'post', '120000'],
                "resendPayRenewSbiLifeSmbPolicy": ['adapters/LifeInsuranceAdapterv2/resendPayRenewSbiLifeSmbPolicy', 'post', '120000'],
                "retreiveLIApplications": ['adapters/LifeInsuranceAdapterv2/getApplications', 'post'],
                "getAcceptanceMessage": ['adapters/LifeInsuranceAdapterv2/getAcceptanceMessage', 'get'],
                "getESignatureContent": ['adapters/LifeInsuranceAdapterv2/getESignatureContent', 'post'],
                "checkLIProposalStatus": ['adapters/LifeInsuranceAdapterv2/getProposalStatus', 'post'],
                "removeLiSavedApplication": ['adapters/LifeInsuranceAdapterv2/removeApplication', 'post'],
                "getLiFatcaContents": ['adapters/LifeInsuranceAdapterv2/getFatcaContents', 'post'],
                "getPolicyRenewalDetails": ['adapters/LifeInsuranceAdapterv2/getPolicyRenewalDetails', 'post'],
                "getFundSwitchTable": ['adapters/LifeInsuranceAdapterv2/getFundSwitchAmountTable', 'get'],
                "getFundRedirectTable": ['adapters/LifeInsuranceAdapterv2/getFundRedirectAmountTable', 'get'],
                "getLiJourneyMaster": ['adapters/FSSCommonAdapter/getJourneyMaster', 'post'],
                "getLiSavedJourney": ['adapters/FSSCommonAdapter/getSavedJourney', 'post'],
                "saveLiJourney": ['adapters/FSSCommonAdapter/saveJourney', 'post'],
                "getCarouselImages": ['adapters/FSSCommonAdapter/getCarouselImages', 'get'],
                /* "getLiCustomerInfo": ['adapters/HomeAdapter/customerInfo', 'post'], */
                "getLiCustomerInfo": ['adapters/HomeAdapter/customerAndAccountInfo', 'post'],
                "resendOTPForPayNewPolicy": ['adapters/LifeInsuranceAdapterv2/resendOTPForPayNewPolicy', 'post'],
                "resendOTPForPayRenewPolicy": ['adapters/LifeInsuranceAdapterv2/resendOTPForPayRenewPolicy', 'post'],
                "getHomeLoanRedirection":['adapters/PreApprovedLoanAdapter/Home/getRedirection','post'],
                "getCaLoanRedirection":['adapters/PreApprovedLoanAdapter/Car/getRedirection','post'],
                "getEducationLoanRedirection":['adapters/PreApprovedLoanAdapter/Education/getRedirection','post'],
                "getLoanLanding": ['adapters/PreApprovedLoanAdapter/Home/getLoanLanding'],
                "checkCustomerStatus": ['adapters/LifeInsuranceAdapterv2/checkCustomerStatus'],
                "getPremiumAndNomineeInfo": ['adapters/LifeInsuranceAdapterv2/getPremiumAndNomineeInfo'],
                "getPolicyFeatures": ['adapters/LifeInsuranceAdapterv2/getPolicyFeatures'],
                "getCustomerDeclaration" : ['adapters/LifeInsuranceAdapterv2/getCustomerDeclaration'],
                "getMedicalDiagnosis" : ['adapters/LifeInsuranceAdapterv2/getMedicalDiagnosis'],
                "getTermsAndConditions" : ['adapters/LifeInsuranceAdapterv2/getTermsAndConditions'],
                "getAutoRenewal" : ['adapters/LifeInsuranceAdapterv2/getAutoRenewal'],
                "getOTPDeclaration" : ['adapters/LifeInsuranceAdapterv2/getOTPDeclaration'],
                "ssValidateOTP" : ['adapters/LifeInsuranceAdapterv2/validateOTPTokenSecure'],
                "createPolicy" : ['adapters/LifeInsuranceAdapterv2/createPolicy'],
                "getDocument" : ['adapters/LifeInsuranceAdapterv2/getDocument'],
                "getCurrentPolicyDocument" : ['adapters/LifeInsuranceAdapterv2/getCurrentPolicyDocument'],
                "getSsPolicyDetails": ['adapters/LifeInsuranceAdapterv2/getSsPolicyDetails'],
                "getAllInsuranceProducts": ['adapters/LifeInsuranceAdapterv2/getAllInsuranceProducts'],
                "getSchemeDetails": ['adapters/LifeInsuranceAdapterv2/getSchemeDetails'],
                "getInfoContent": ['adapters/LifeInsuranceAdapterv2/getInfoContent'],
                "getFundTransferAccounts" : ['adapters/LifeInsuranceAdapterv2/getFundTransferAccounts'],
                "getBaseEmail" : ['adapters/LifeInsuranceAdapterv2/getBaseEmail'],
                "getSwarnaGangaUrl": ['adapters/LifeInsuranceAdapterv2/getSwarnaGangaUrl'],                
                "getOTPTokenSS" : ['adapters/LifeInsuranceAdapterv2/getOTPTokenSecure'],
                "getSwarnaGangaWCMContent": ['adapters/LifeInsuranceAdapterv2/getSwarnaGangaDisclaimer'],
                "scheduleRenewalPayment": ['adapters/LifeInsuranceAdapterv2/ssPolicySchedulePyament'],
                "renewalPremium" : ['adapters/LifeInsuranceAdapterv2/ssPolicySchedulePyament'],
                "generateSSRenewOTP" : ['adapters/LifeInsuranceAdapterv2/generateSSRenewOTP'],
                "validateOTPForRenew" : ['adapters/LifeInsuranceAdapterv2/validateOTPForRenew'],
                "getSbiLifeSmbPolicyRenewalDetails" : ['adapters/LifeInsuranceAdapterv2/getSbiLifeSmbPolicyRenewalDetails'],
                "getSmbLifeInsuranceRenewalPDF" : ['adapters/LifeInsuranceAdapterv2/getSmbLifeInsuranceRenewalPDF'],
                "getCovidHistoryWcmContent" : ['adapters/LifeInsuranceAdapterv2/getCovidHistoryWcmContent']
            },
            "validStatusCodes": ["0000", "0001"]
        });
// definition of routes
angularApp.config(['$stateProvider',
    '$urlRouterProvider',
    '$controllerProvider',
    '$translateProvider',
    '$ionicConfigProvider',

    function ($stateProvider,
        $urlRouterProvider,
        $controllerProvider,
        $translateProvider,
        $ionicConfigProvider) {

        //Life Insurance start

        $stateProvider
            .state('menu.sbiLifeIntro', {
                url: '/sbiLifeIntroduction',
                data: {
                    pageId: 'LI_SBILYFINTRO'
                },
                params: { page: 'life' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/needAnalysis/lifeInsuranceIntro.html',
                        controller: 'lifeInsuranceIntroController',
                        controllerAs: 'lifeInsuranceIntroVm',
                    }
                }
            })
            .state('menu.helpMeChoosePolicy', {
                url: '/helpMeChoosePolicy',
                data: {
                    pageId: 'LI_HLPCHSPOLY'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/needAnalysis/helpMeChoosePolicy.html',
                        controller: 'helpMeChoosePolicyController',
                        controllerAs: 'helpMeChoosePolicyControllerVm',
                    }
                }
            })
            .state('menu.lifeInsuranceDidYouKnow', {
                url: '/lifeInsuranceDidYouKnow',
                data: {
                    pageId: 'LI_LYFINSDYK'
                },
                params: { page: 'life' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/needAnalysis/lifeInsuranceDidYouKnow.html',
                        controller: 'lifeInsuranceDidYouKnowController',
                        controllerAs: 'lifeInsuranceDidYouKnowVm',
                    }
                }
            })
            .state('menu.lifeInsuranceApplicationInfoPD', {
                url: '/lifeInsuranceBasic',
                data: {
                    pageId: 'LI_LYFINSBSC'
                },
                params: { agree: false },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/needAnalysis/lifeInsuranceApplicationInfoPD.html',
                        controller: 'lifeInsuranceApplicationInfoPDController',
                        controllerAs: 'lifeInsuranceApplicationInfoPDVm',
                    }
                }
            })
            .state('menu.lifeInsuranceApplicationInfoFD', {
                url: '/lifeInsuranceApplicationInfoFinancialDetails',
                data: {
                    pageId: 'LI_LYFINSAPPINFOFNCLDETL'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/needAnalysis/lifeInsuranceApplicationInfoFD.html',
                        controller: 'lifeInsuranceApplicationInfoFDController',
                        controllerAs: 'lifeInsuranceApplicationInfoFDVm',
                    }
                }
            })
            .state('menu.lifeInsuranceApplicationInfoOD', {
                url: '/lifeInsuranceApplicationInfoOtherDetails',
                data: {
                    pageId: 'LI_LYFINSAPPINFOOTHRDETL'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/needAnalysis/lifeInsuranceApplicationInfoOD.html',
                        controller: 'lifeInsuranceApplicationInfoODController',
                        controllerAs: 'lifeInsuranceApplicationInfoODVm',
                    }
                }
            })
            .state('menu.lifeInsuranceApplicationInfoRP', {
                url: '/lifeInsuranceApplicationInfoRetirementPlanning',
                data: {
                    pageId: 'LI_LYFINSAPPINFORTMTPLNG'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/needAnalysis/lifeInsuranceApplicationInfoRP.html',
                        controller: 'lifeInsuranceApplicationInfoRPController',
                        controllerAs: 'lifeInsuranceApplicationInfoRPVm',
                    }
                }
            })
            .state('menu.lifeInsuranceApplicationInfoBuyHome', {
                url: '/lifeInsuranceApplicationInfoBuyHome',
                data: {
                    pageId: 'LI_LYFINSAPPINFOBUYHOM'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/needAnalysis/lifeInsuranceApplicationInfoBuyHome.html',
                        controller: 'lifeInsuranceApplicationInfoBuyHomeController',
                        controllerAs: 'lifeInsuranceApplicationInfoBuyHomeVm',
                    }
                }
            })
            .state('menu.lifeInsuranceApplicationInfoOG', {
                url: '/lifeInsuranceApplicationInfoOtherGoals',
                data: {
                    pageId: 'LI_LYFINSAPPINFOOTHRGOAL'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/needAnalysis/lifeInsuranceApplicationInfoOG.html',
                        controller: 'lifeInsuranceApplicationInfoOGController',
                        controllerAs: 'lifeInsuranceApplicationInfoOGVm',
                    }
                }
            })
            .state('menu.lifeInsuranceApplicationInfoCF', {
                url: '/lifeInsuranceApplicationInfoChildrensFuture',
                data: {
                    pageId: 'LI_LYFINSAPPINFOCLDNFUTU'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/needAnalysis/lifeInsuranceApplicationInfoCF.html',
                        controller: 'lifeInsuranceApplicationInfoCFController',
                        controllerAs: 'lifeInsuranceApplicationInfoCFVm',
                    }
                }
            })
            .state('menu.financialGoalsCharts', {
                url: '/financialGoalsCharts',
                data: {
                    pageId: 'LI_FNCLGOALCHRT'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/suggestedPlans/financialGoalsCharts.html',
                        controller: 'financialGoalsChartsController',
                        controllerAs: 'financialGoalsChartsVm',
                    }
                }
            })
            .state('menu.suggestedPlans', {
                url: '/suggestedPlans',
                data: {
                    pageId: 'LI_SUGDPLNS'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/suggestedPlans/suggestedPlans.html',
                        controller: 'suggestedPlansController',
                        controllerAs: 'suggestedPlansVm',
                    }
                }
            })
            .state('menu.productNotSaleOnApp', {
                url: '/productNotSaleOnApp',
                data: {
                    pageId: 'LI_PRDTNOTSALEONAPP'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/suggestedPlans/productNotSaleOnApp.html',
                        controller: 'productNotSaleOnAppController',
                        controllerAs: 'productNotSaleOnAppVm',
                    }
                }
            })
            .state('menu.otherProductList', {
                url: '/otherProductList',
                data: {
                    pageId: 'LI_OTHRPRDTLST'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/suggestedPlans/otherProductList.html',
                        controller: 'otherProductListController',
                        controllerAs: 'otherProductListVm',
                    }
                }
            })
            .state('menu.planDetails', {
                url: '/planDetails',
                data: {
                    pageId: 'LI_PLNDETL'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/suggestedPlans/planDetails.html',
                        controller: 'planDetailsController',
                        controllerAs: 'planDetailsVm',
                    }
                }
            })

            // Product - 1
            .state('menu.retireSmartPremiumCalculation', {
                url: '/retireSmartPremiumCalculation',
                data: {
                    pageId: 'LI_RTRSMRTPRMCALC'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/premiumCalculation/retireSmart/retireSmartPC.html',
                        controller: 'retireSmartPCController',
                        controllerAs: 'retireSmartPCVm',
                    }
                }
            })
            // Product - 2
            .state('menu.saralSwadhanPremiumCalculation', {
                url: '/saralSwadhanPremiumCalculation',
                data: {
                    pageId: 'LI_SARLSWDNPREMCALC'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/premiumCalculation/saralSwadhan/saralSwadhanPC.html',
                        controller: 'saralSwadhanPCController',
                        controllerAs: 'saralSwadhanPCVm',
                    }
                }
            })
            // Product - 3
            .state('menu.shubhNiveshPremiumCalculation', {
                url: '/shubhNiveshPremiumCalculation',
                data: {
                    pageId: 'LI_SHUBNVSHPRMCALC'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/premiumCalculation/shubhNivesh/shubhNiveshPC.html',
                        controller: 'shubhNiveshPCController',
                        controllerAs: 'shubhNiveshPCVm',
                    }
                }
            })
            // Product - 4
            .state('menu.smartMoneyBackGoldPremiumCalculation', {
                url: '/smartMoneyBackGoldPremiumCalculation',
                data: {
                    pageId: 'LI_SMRTMONYGOLDPRMCALC'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/premiumCalculation/smartMoneyBackGold/smartMoneyBackGoldPC.html',
                        controller: 'smartMoneyBackGoldPCController',
                        controllerAs: 'smartMoneyBackGoldPCVm',
                    }
                }
            })
            // Product - 5
            .state('menu.smartChampInsurancePremiumCalculation', {
                url: '/smartChampInsurancePremiumCalculation',
                data: {
                    pageId: 'LI_SMRTCHMPINSPRMCALC'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/premiumCalculation/smartChampInsurance/smartChampInsurancePC.html',
                        controller: 'smartChampInsurancePCController',
                        controllerAs: 'smartChampInsurancePCVm',
                    }
                }
            })
            // Product - 6
            .state('menu.smartWealthBuilderPremiumCalculation', {
                url: '/smartWealthBuilderPremiumCalculation',
                data: {
                    pageId: 'LI_SMRTWLTHBLDRPRMCALC'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/premiumCalculation/smartWealthBuilder/smartWealthBuilderPC.html',
                        controller: 'smartWealthBuilderPCController',
                        controllerAs: 'smartWealthBuilderPCVm',
                    }
                }
            })
            .state('menu.premiumCalculation2', {
                url: '/premiumCalculation2',
                data: {
                    pageId: 'LI_PRMCALC2'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/premiumCalculation/premiumCalculation2.html',
                        controller: 'premiumCalculation2Controller',
                        controllerAs: 'premiumCalculation2Vm',
                    }
                }
            })
            .state('menu.smartWealthBuilderPremiumCalculation2', {
                url: '/smartWealthBuilderPremiumCalculation2',
                data: {
                    pageId: 'LI_SMRTWLTHBLDRPRMCALC2'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/premiumCalculation/smartWealthBuilder/smartWealthBuilderPC2.html',
                        controller: 'smartWealthBuilderPCController2',
                        controllerAs: 'smartWealthBuilderPC2Vm',
                    }
                }
            })
            .state('menu.shubhNiveshRider', {
                url: '/shubhNiveshRider',
                data: {
                    pageId: 'LI_SHUBNVSHRIDR'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/premiumCalculation/shubhNivesh/shubhNiveshPC2.html',
                        controller: 'shubhNiveshPC2Controller',
                        controllerAs: 'shubhNiveshPC2Vm',
                    }
                }
            })
            .state('menu.premiumCalculation3', {
                url: '/premiumCalculation3',
                data: {
                    pageId: 'LI_PRMCALC3'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/premiumCalculation/premiumCalculation3.html',
                        controller: 'premiumCalculation3Controller',
                        controllerAs: 'premiumCalculation3Vm',
                    }
                }
            })
            .state('menu.declarationOfLI', {
                url: '/declarationOfLI',
                data: {
                    pageId: 'LI_DECTNLI'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/premiumCalculation/declarationOfLI.html',
                        controller: 'declarationOfLIController',
                        controllerAs: 'declarationOfLIVm',
                    }
                }
            })
            .state('menu.lifeInsuranceBasicInformation', {
                url: '/lifeInsuranceBasicInformation',
                data: {
                    pageId: 'LI_LYFINSBSCINFO'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/payment/lifeInsuranceBasicInformation.html',
                        controller: 'lifeInsuranceBasicInformationController',
                        controllerAs: 'lifeInsuranceBasicInformationVm',
                    }
                }
            })
            .state('menu.lifeInsuranceBasicInformation2', {
                url: '/lifeInsuranceBasicInformation2',
                data: {
                    pageId: 'LI_LYFINSBSCINFO2'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/payment/lifeInsuranceBasicInformation2.html',
                        controller: 'lifeInsuranceBasicInformationController2',
                        controllerAs: 'lifeInsuranceBasicInformation2Vm',
                    }
                }
            })
            .state('menu.lifeInsurancePaymentAccountDetails', {
                url: '/lifeInsurancePaymentAccountDetails',
                data: {
                    pageId: 'LI_LYFINSPYMTACCTDETL'
                },
                params: { page: "Life" },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/payment/lifeInsurancepaymentAccountDetails.html',
                        controller: 'lifeInsurancePaymentAccountDetailsController',
                        controllerAs: 'lifeInsurancePaymentAccountDetailsVm',
                    }
                }
            })
            .state('menu.lifeInsuranceExistingPolicy', {
                url: '/lifeInsuranceExistingPolicy',
                data: {
                    pageId: 'LI_LYFINSEXTGPOLY'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/payment/lifeInsuranceExistingPolicy.html',
                        controller: 'lifeInsuranceExistingPolicyController',
                        controllerAs: 'lifeInsuranceExistingPolicyVm',
                    }
                }
            })
            .state('menu.lifeInsuranceBasicInformation3', {
                url: '/lifeInsuranceBasicInformation3',
                data: {
                    pageId: 'LI_LYFINSBSCINFO3'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/payment/lifeInsuranceBasicInformation3.html',
                        controller: 'lifeInsuranceBasicInformationController3',
                        controllerAs: 'lifeInsuranceBasicInformation3Vm',
                    }
                }
            })
            .state('menu.lifeInsuranceBasicInformation4', {
                url: '/lifeInsuranceBasicInformation4',
                data: {
                    pageId: 'LI_LYFINSBSCINFO4'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/payment/lifeInsuranceBasicInformation4.html',
                        controller: 'lifeInsuranceBasicInformationController4',
                        controllerAs: 'lifeInsuranceBasicInformation4Vm',
                    }
                }
            })
            .state('menu.lifeInsuranceAccountOverview', {
                url: '/lifeInsuranceAccountOverview',
                data: {
                    pageId: 'LI_LYFINSACCTOVRVIW'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/lifeInsuranceAccountOverview.html',
                        controller: 'lifeInsuranceAccountOverviewController',
                        controllerAs: 'lifeInsuranceAccountOverviewVm',
                    }
                }
            })
            .state('menu.liForm_appointeeInformation', {
                url: '/liForm_appointeeInformation',
                data: {
                    pageId: 'LI_APTEINFO'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/payment/liForm_appointeeInformation.html',
                        controller: 'liForm_appointeeInformationController',
                        controllerAs: 'liForm_appointeeInformationVm',
                    }
                }
            })
            .state('menu.liForm_ProposersFATCA_CRS', {
                url: '/liForm_ProposersFATCA_CRS',
                data: {
                    pageId: 'LI_PRSRFATCACRS'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/payment/liForm_ProposersFATCA_CRS.html',
                        controller: 'liForm_ProposersFATCA_CRSController',
                        controllerAs: 'liForm_ProposersFATCA_CRSVm',
                    }
                }
            })
            // common page
            .state('menu.retireSmartMedicalHistory', {
                url: '/retireSmartMedicalHistory/:start',
                data: {
                    pageId: 'LI_RTRSMRTMDCLHSTY'
                },

                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/payment/retireSmart/retireSmartMedicalHistory.html',
                        controller: 'retireSmartMedicalHistoryController',
                        controllerAs: 'retireSmartMedicalHistoryVm',
                    }
                }
            })
            // For female questions
            .state('menu.retireSmartMedicalHistory4', {
                url: '/retireSmartMedicalHistory4',
                data: {
                    pageId: 'LI_RTRSMRTMDCLHSTY4'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/payment/retireSmart/retireSmartMedicalHistory4.html',
                        controller: 'retireSmartMedicalHistoryController4',
                        controllerAs: 'retireSmartMedicalHistoryVm4',
                    }
                }
            })
            .state('menu.liForm_DiseaseDetails', {
                url: '/liForm_DiseaseDetails',
                data: {
                    pageId: 'LI_DISEDETL'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/payment/liForm_DiseaseDetails.html',
                        controller: 'liForm_DiseaseDetailsController',
                        controllerAs: 'liForm_DiseaseDetailsVm',
                    }
                }
            })
            .state('menu.liForm_FamilyHistory', {
                url: '/liForm_FamilyHistory',
                data: {
                    pageId: 'LI_FMLYHSTY'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/payment/liForm_FamilyHistory.html',
                        controller: 'liForm_FamilyHistoryController',
                        controllerAs: 'liForm_FamilyHistoryVm',
                    }
                }
            })

            .state('menu.liForm_AdditionalDetails', {
                url: '/liForm_AdditionalDetails',
                data: {
                    pageId: 'LI_ADDTL'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/payment/liForm_AdditionalDetails.html',
                        controller: 'liForm_AdditionalDetailsController',
                        controllerAs: 'liForm_AdditionalDetailsVm',
                    }
                }
            })
            .state('menu.liForm_eInsurance', {
                url: '/liForm_eInsurance',
                data: {
                    pageId: 'LI_EINS'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/payment/liForm_eInsurance.html',
                        controller: 'liForm_eInsuranceController',
                        controllerAs: 'liForm_eInsuranceVm',
                    }
                }
            })
            .state('menu.liForm_Preview', {
                url: '/liForm_Preview',
                data: {
                    pageId: 'LI_PRVW'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/payment/liForm_Preview.html',
                        controller: 'liForm_PreviewController',
                        controllerAs: 'liForm_PreviewVm',
                    }
                }
            })
            .state('menu.liForm_MailingInfo', {
                url: '/liForm_MailingInfo',
                data: {
                    pageId: 'LI_MLNGINFO'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/payment/liForm_MailingInfo.html',
                        controller: 'liForm_MailingInfoController',
                        controllerAs: 'liForm_MailingInfoVm',
                    }
                }
            })
            .state('menu.liForm_MailingInfoAadhaarScan', {
                url: '/liForm_MailingInfoAadhaarScan',
                data: {
                    pageId: 'LI_MLNGINFOADHRSCN'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/payment/liForm_MailingInfoAadhaarScan.html',
                        controller: 'liForm_MailingInfoAadhaarScanController',
                        controllerAs: 'liForm_MailingInfoAadhaarScanVm',
                    }
                }
            })
            .state('menu.liForm_MailingInfoEnterDetails', {
                url: '/liForm_MailingInfoEnterDetails',
                data: {
                    pageId: 'LI_MLNGINFOEBTRDETL'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/payment/liForm_MailingInfoEnterDetails.html',
                        controller: 'liForm_MailingInfoEnterDetailsController',
                        controllerAs: 'liForm_MailingInfoEnterDetailsVm',
                    }
                }
            })
            .state('menu.liForm_AppointeeInfoAadhaarScan', {
                url: '/liForm_AppointeeInfoAadhaarScan',
                data: {
                    pageId: 'LI_APTEINFOADHRSCN'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/payment/liForm_AppointeeInfoAadhaarScan.html',
                        controller: 'liForm_AppointeeInfoAadhaarScanController',
                        controllerAs: 'liForm_AppointeeInfoAadhaarScanVm',
                    }
                }
            })
            .state('menu.lifeInsuranceAadharScan', {
                url: '/lifeInsuranceAadharScan',
                data: {
                    pageId: 'LI_LYFINSADHRSCN'
                },
                params: { page: 'life' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/lifeInsuranceAadharScan.html',
                        controller: 'lifeInsuranceAadharScanController',
                        controllerAs: 'lifeInsuranceAadharScanVm',
                    }
                }
            })
            .state('menu.lifeInsuranceUploadDocuments', {
                url: '/lifeInsuranceUploadDocuments',
                data: {
                    pageId: 'LI_LYFINSUPLDDOC'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/payment/lifeInsuranceUploadDocuments.html',
                        controller: 'lifeInsuranceUploadDocumentsController',
                        controllerAs: 'lifeInsuranceUploadDocumentsVm',
                    }
                }
            })
            .state('menu.lifeInsuranceDocumentsReceived', {
                url: '/lifeInsuranceDocumentsReceived',
                data: {
                    pageId: 'LI_LYFINSDOCRCVD'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/payment/lifeInsuranceDocumentsReceived.html',
                        controller: 'lifeInsuranceDocumentsReceivedController',
                        controllerAs: 'lifeInsuranceDocumentsReceivedVm',
                    }
                }
            })
            .state('menu.linkingLIPolicy', {
                url: '/linkingLIPolicy',
                data: {
                    pageId: 'LI_LNKGLIPOLY'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/linkPolicy/linkingLIPolicy.html',
                        controller: 'linkingLIPolicyController',
                        controllerAs: 'linkingLIPolicyVm',
                    }
                }
            })
            .state('menu.enterOTPLinking', {
                url: '/enterOTPLinking',
                data: {
                    pageId: 'LI_ENTROTPLNKG'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/linkPolicy/enterOTPLinking.html',
                        controller: 'enterOTPLinkingController',
                        controllerAs: 'enterOTPLinkingVm',
                    }
                }
            })
            .state('menu.myPolicyDetails', {
                url: '/myPolicyDetails',
                data: {
                    pageId: 'LI_MYPOLYDETL'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/linkPolicy/myPolicyDetails.html',
                        controller: 'myPolicyDetailsController',
                        controllerAs: 'myPolicyDetailsVm',
                    }
                }
            })
            //for pay renewal
            .state('menu.paymentSummary', {
                url: '/paymentSummary',
                data: {
                    pageId: 'LI_PYMTSUMY'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/payRenewal/paymentSummary.html',
                        controller: 'paymentSummaryController',
                        controllerAs: 'paymentSummaryVm',
                    }
                }
            })
            //for pay renewal
            .state('menu.paymentComplete', {
                url: '/paymentComplete',
                data: {
                    pageId: 'LI_PYMTCMPT'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/payRenewal/paymentComplete.html',
                        controller: 'paymentCompleteController',
                        controllerAs: 'paymentCompleteVm',
                    }
                }
            })
            .state('menu.lifeInsuranceFundSwitch', {
                url: '/lifeInsuranceFundSwitch',
                data: {
                    pageId: 'LI_LYFINSFNDSWCH'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/fundSwitchRedirect/lifeInsuranceFundSwitch.html',
                        controller: 'lifeInsuranceFundSwitchController',
                        controllerAs: 'lifeInsuranceFundSwitchVm',
                    }
                }
            })
            .state('menu.lifeInsuranceFundRedirect', {
                url: '/lifeInsuranceFundRedirect',
                data: {
                    pageId: 'LI_LYFINSFNDRDRT'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/fundSwitchRedirect/lifeInsuranceFundRedirect.html',
                        controller: 'lifeInsuranceFundRedirectController',
                        controllerAs: 'lifeInsuranceFundRedirectVm',
                    }
                }
            })
            .state('menu.lifeInsuranceEstatement', {
                url: '/lifeInsuranceEstatement',
                data: {
                    pageId: 'LI_LYFINSESTMT'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/estatement/lifeInsuranceEstatement.html',
                        controller: 'lifeInsuranceEstatementController',
                        controllerAs: 'lifeInsuranceEstatementVm',
                    }
                }
            })
            .state('menu.lifeInsuranceRequestReceived', {
                url: '/lifeInsuranceRequestReceived',
                data: {
                    pageId: 'LI_LYFINSRQSTRCVD'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/fundSwitchRedirect/lifeInsuranceRequestReceived.html',
                        controller: 'lifeInsuranceRequestReceivedController',
                        controllerAs: 'lifeInsuranceRequestReceivedVm',
                    }
                }
            })
            .state('menu.lifeInsuranceRequestReceived2', {
                url: '/lifeInsuranceRequestReceived2',
                data: {
                    pageId: 'LI_LYFINSRQSTRCVD2'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/fundSwitchRedirect/lifeInsuranceRequestReceived2.html',
                        controller: 'lifeInsuranceRequestReceivedController2',
                        controllerAs: 'lifeInsuranceRequestReceived2Vm',
                    }
                }
            })
            .state('menu.lifeInsurancePayment', {
                url: '/lifeInsurancePayment',
                data: {
                    pageId: 'LI_LYFINSPYMT'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/payment/lifeInsuranceEnterOTP.html',
                        controller: 'lifeInsuranceEnterOTPController',
                        controllerAs: 'lifeInsuranceEnterOTPVm',
                    }
                }
            })
            //otp for payment
            .state('menu.lifeInsuranceOTPforPayment', {
                url: '/lifeInsuranceOTPforPayment',
                data: {
                    pageId: 'LI_LYFINSPYMTOTP'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/payment/lifeInsuranceOTPforPayment.html',
                        controller: 'lifeInsuranceOTPforPaymentController',
                        controllerAs: 'lifeInsuranceEnterOTPPaymentVm',
                    }
                }
            })
            //otp for Renew payment
            .state('menu.lifeInsuranceOTPforRenewPayment', {
                url: '/lifeInsuranceOTPforRenewPayment',
                data: {
                    pageId: 'LI_LYFINSRNWPYMTOTP'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/payRenewal/lifeInsuranceOTPforRenewPayment.html',
                        controller: 'lifeInsuranceOTPforRenewPaymentController',
                        controllerAs: 'lifeInsuranceEnterOTPRenewPaymentVm',
                    }
                }
            })
            //after application submit
            .state('menu.lifeInsurancePaynow', {
                url: '/lifeInsurancePaynow',
                data: {
                    pageId: 'LI_LYFINSPYNW'
                },
                params: { page: 'life' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/payment/lifeInsurancePaynow.html',
                        controller: 'lifeInsurancePaynowController',
                        controllerAs: 'lifeInsurancePaynowVm',
                    }
                }
            })
            //after application submit
            .state('menu.lifeInsurancePaymentSuccess', {
                url: '/lifeInsurancePaymentSuccess',
                data: {
                    pageId: 'LI_LYFINSPYMTSUC'
                },
                params: { page: 'life' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/buyPolicy/payment/lifeInsurancePaymentSuccess.html',
                        controller: 'lifeInsurancePaymentSuccessController',
                        controllerAs: 'lifeInsurancePaymentSuccessVm',
                    }
                }
            })

            .state('menu.lifeInsuranceESignature', {
                url: '/lifeInsuranceESignature',
                data: {
                    pageId: 'LI_LYFINSESIGNTR'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/lifeInsuranceESignature.html',
                        controller: 'lifeInsuranceESignatureController',
                        controllerAs: 'lifeInsuranceESignatureVm',
                    }
                }
            })

            .state('menu.retreiveApplication', {
                url: '/retreiveApplication',
                data: {
                    pageId: 'LI_LYFINSRTRVAPPCTN'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/retreiveApplication/retreiveApplication.html',
                        controller: 'retreiveApplicationController',
                        controllerAs: 'retreiveApplicationVm',
                    }
                }
            })

            .state('menu.ssPremiumCalculation', {
                url: '/ssPremiumCalculation',
                data: {
                    pageId: 'LI_SSPRECAL'
                },
                params: { page: 'life', lifeGeneInsure:null },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/sampoornSuraksha/ssPremiumCalculation.html',
                        controller: 'ssPremiumCalculationController',
                        controllerAs: 'ssPremiumCalculationVm',
                    }
                }
            })

            .state('menu.ssPolicyFeatures', {
                url: '/ssPolicyFeatures',
                data: {
                    pageId: 'LI_SSPOYFET'
                },
                params: { page: 'life' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/sampoornSuraksha/ssPolicyFeatures.html',
                        controller: 'ssPolicyFeaturesController',
                        controllerAs: 'ssPolicyFeaturesVm',
                    }
                }
            })

            .state('menu.ssMedicalInformation', {
                url: '/ssMedicalInformation',
                data: {
                    pageId: 'LI_SSMEDINFO'
                },
                cache : false,
                params: { page: 'life' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/sampoornSuraksha/ssMedicalInformation.html',
                        controller: 'ssMedicalInformationController',
                        controllerAs: 'ssMedicalInformationVm',
                    }
                }
            })

            .state('menu.ssPayment', {
                url: '/ssPayment',
                data: {
                    pageId: 'LI_SSPAY'
                },
                cache : false,
                params: { page: 'life' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/sampoornSuraksha/ssPayment.html',
                        controller: 'ssPaymentController',
                        controllerAs: 'ssPaymentVm',
                    }
                }
            })

             .state('menu.ssPaymentOtp', {
                url: '/ssPaymentOtp',
                data: {
                    pageId: 'LI_SSOTPPAY'
                },
                params: { page: 'life' },
                cache : false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/sampoornSuraksha/ssPaymentOtp.html',
                        controller: 'ssPaymentOtpController',
                        controllerAs: 'ssPaymentOtpVm',
                    }
                }
            })

            .state('menu.ssPaymentSuccess', {
                url: '/ssPaymentSuccess',
                data: {
                    pageId: 'LI_SSPAYSUC'
                },
                params: { page: 'life' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/sampoornSuraksha/ssPaymentSuccess.html',
                        controller: 'ssPaymentSuccessController',
                        controllerAs: 'ssPaymentSuccessVm',
                    }
                }
            })

            .state('menu.ssPolicySummary', {
                url: '/ssPolicySummary',
                data: {
                    pageId: 'LI_SSPOL'
                },
                params: { page: 'life' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/sampoornSuraksha/ssPolicySummary.html',
                        controller: 'ssPolicySummaryController',
                        controllerAs: 'ssPolicySummaryVm',
                    }
                }
            })

            .state('menu.ssRenewal', {
                url: '/ssRenewal',
                data: {
                    pageId: 'LI_SSREN'
                },
                cache : false,
                params: { page: 'life' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/sampoornSuraksha/ssRenewal.html',
                        controller: 'ssRenewalController',
                        controllerAs: 'ssRenewalVm',
                    }
                }
            })
            .state('menu.ssRenewalRequest', {
                url: '/ssRenewalRequest',
                data: {
                    pageId: 'LI_SSREQ'
                },
                cache : false,
                params: { page: 'life' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/sampoornSuraksha/ssRenewalRequest.html',
                        controller: 'ssRenewalRequestController',
                        controllerAs: 'ssRenewalRequestVm',
                    }
                }
            })

             .state('menu.ssRenewalOtp', {
                url: '/ssRenewalOtp',
                data: {
                    pageId: 'LI_SSOTP'
                },
                cache : false,
                params: { page: 'life' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/sampoornSuraksha/ssRenewalOtp.html',
                        controller: 'ssRenewalOtpController',
                        controllerAs: 'ssRenewalOtpVm',
                    }
                }
            })

            .state('menu.ssRenewalSuccess', {
                url: '/ssRenewalSuccess',
                data: {
                    pageId: 'LI_SSRENW_SUC'
                },
                cache : false,
                params: { page: 'life' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/sampoornSuraksha/ssPaymentRenewalSuccess.html',
                        controller: 'ssPaymentRenewalSuccessController',
                        controllerAs: 'ssPaymentRenewalSuccessVm',
                    }
                }
            })
            .state('menu.newRenewalHome', {
                url: '/newRenewalHome',
                data: {
                    pageId: 'LI_NEWRENW_SUC'
                },
                cache : false,
                params: { page: 'life' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/newRenewal/newRenewalHome.html',
                        controller: 'newRenewalHomeController',
                        controllerAs: 'newRenewalHomeVm',
                    }
                }
            })
            .state('menu.newRenewalOTP', {
                url: '/newRenewalOTP',
                data: {
                    pageId: 'LI_NEWRENW_OTP'
                },
                cache : false,
                params: { page: 'life' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/newRenewal/newRenewalOTP.html',
                        controller: 'newRenewalOTPController',
                        controllerAs: 'newRenewalOTPVm',
                    }
                }
            })
            .state('menu.newRenewalSuccess', {
                url: '/newRenewalSuccess',
                data: {
                    pageId: 'LI_NEWRENW_SUCCESS'
                },
                cache : false,
                params: { page: 'life' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/lifeInsurance/newRenewal/newRenewalSuccess.html',
                        controller: 'newRenewalSuccessController',
                        controllerAs: 'newRenewalSuccessVm',
                    }
                }
            })
    }
]);
