angularApp.controller('lifeInsuranceESignatureController', [
    "$state",
    "$scope",
    "$translate",
    "lifeInsuranceBasicApplicationService",

    function(
        $state,
        $scope,
        $translate,
        lifeInsuranceBasicApplicationService) {

        var lifeInsuranceESignatureVm = this;
        lifeInsuranceESignatureVm.signaturePad;

        function initPage() {
            lifeInsuranceESignatureVm.warning = '';
            var canvas = document.getElementById("signature");

            var w = window.innerWidth;
            var h = window.innerHeight;

            canvas.width = w;
            canvas.height = h / 2.5;

            lifeInsuranceESignatureVm.signaturePad = new SignaturePad(canvas, {
                dotSize: 0.2
            });

            lifeInsuranceESignatureVm.signaturePad.on();
        };

        lifeInsuranceESignatureVm.save = function() {
            lifeInsuranceESignatureVm.imageURI = lifeInsuranceESignatureVm.signaturePad.toDataURL();

            lifeInsuranceESignatureVm.validate();
        };

        lifeInsuranceESignatureVm.clear = function() {
            lifeInsuranceESignatureVm.signaturePad.clear();
            lifeInsuranceESignatureVm.warning = '';
        };

        lifeInsuranceESignatureVm.validate = function() {
            if (lifeInsuranceESignatureVm.signaturePad.isEmpty()) {
                lifeInsuranceESignatureVm.warning = $translate.instant('LI_SIGN_WARN');
            } else {
                lifeInsuranceESignatureVm.warning = '';
                lifeInsuranceBasicApplicationService.setAppointeeSign(lifeInsuranceESignatureVm.imageURI);
                lifeInsuranceESignatureVm.signaturePad.off();
                $state.go("menu.liForm_appointeeInformation");

            }
        };

        $scope.$on('$ionicView.enter', function() {
            initPage();
        });
    }
]);
