angularApp.controller('enterOTPLinkingController', ["$state",
    "$scope",
    "$ionicPopup",
    "validateService",
    "linkingLIPolicyService",
    "utilityService",
    "lifeInsuranceCommonService",

    function(
        $state,
        $scope,
        $ionicPopup,
        validateService,
        linkingLIPolicyService,
        utilityService,
        lifeInsuranceCommonService) {

        var enterOTPLinkingVm = this;
        enterOTPLinkingVm.validateService = validateService;

        function initPage() {
            enterOTPLinkingVm.enterOTP = "";
            enterOTPLinkingVm.mobileNumber = linkingLIPolicyService.getOTPSentNumber();
        };

        enterOTPLinkingVm.linkPolicy = function() {
            if (validateForm()) {
                var secKey = lifeInsuranceCommonService.getSecretDigit();
                linkingLIPolicyService.linkPolicy(enterOTPLinkingVm.enterOTP, secKey).then(function(data) {
                    if (data.secKey) {
                        if (lifeInsuranceCommonService.validateSecretKey(secKey, data.secKey)) {
                            showVerifed();
                        } else {
                            var alertPopup = $ionicPopup.alert({
                                title: '',
                                template: '<p class="roboto-regular font-content text-center">Unable to link a policy</p>'
                            });
                        }
                    }
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        };

        enterOTPLinkingVm.resendOTP = function() {
            linkingLIPolicyService.getOtp().then(function(data) {
                enterOTPLinkingVm.otpResendMsg = true;
                enterOTPLinkingVm.enterOTP = "";
            }, function(error) {
                enterOTPLinkingVm.otpResendMsg = true;
                enterOTPLinkingVm.enterOTP = "";
            });
        };

        enterOTPLinkingVm.goBack = function() {
            $state.go("menu.linkingLIPolicy");
        };

        function showVerifed() {
            var alertPopup = $ionicPopup.alert({
                title: '',
                templateUrl: 'pages/lifeInsurance/linkPolicy/verifyLinkedOTPPopup.html'
            });
            alertPopup.then(function(res) {
                $state.go("menu.accountOverviewMyBalance");
            });
        };

        //conmmon validation function
        function validateForm() {
            enterOTPLinkingVm.frmEnterOTPLink = {};

            if (enterOTPLinkingVm.validateService.isValidOTPNum(enterOTPLinkingVm.enterOTP)) {
                enterOTPLinkingVm.frmEnterOTPLink.enterOTP = enterOTPLinkingVm.validateService.isValidOTPNum(enterOTPLinkingVm.enterOTP);
            }
            return (angular.equals({}, enterOTPLinkingVm.frmEnterOTPLink)) ? true : false;
        };

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
