angularApp.controller('linkingLIPolicyController', [
    "$state", 
    "$scope", 
    "validateService", 
    "linkingLIPolicyService",
    "utilityService",
    "getAccountDetailsService",
    "homeScreenService",
    "customerInfoService",
    "$translate",
    "$ionicPopup",
    "pailinkingRenwalService",
    "generalInsurenceHomeService",
    "GIconstant",
    function($state, 
        $scope, 
        validateService, 
        linkingLIPolicyService,
        utilityService,
        getAccountDetailsService,
        homeScreenService,
        customerInfoService,
        $translate,
        $ionicPopup,
        pailinkingRenwalService,
        generalInsurenceHomeService,
        GIconstant) {

        var linkingLIPolicyVm = this;
        linkingLIPolicyVm.validateService = validateService;

        //private methods section start
        function initPage() {
            linkingLIPolicyVm.constant = GIconstant;
            linkingLIPolicyVm.defaultDate = new Date(1980,0,1,0,0,0,0); // default calender year 1980
            linkingLIPolicyVm.PolicyNum = "";
            linkingLIPolicyVm.birthDate = "";
            linkingLIPolicyVm.isLifeInsTabSelected = true;
            linkingLIPolicyVm.isAutoRenewEnabled = false;
            linkingLIPolicyVm.paiPolicyLists = [];
            linkingLIPolicyVm.isPaiPolicyAvailable = true;
            var paiPolicy = generalInsurenceHomeService.getGIProductList().filter(function(policy){
                return policy.productId = 'personal-accident-insurance'
            })
            if(paiPolicy.length > 0 ){
                var paiPolicyArray = paiPolicy[0].policies.filter(function(policy){
                    return (policy.realTimeStatus.toLowerCase() ==  "active" || policy.realTimeStatus.toLowerCase() ==  "grace")
                }) 
                linkingLIPolicyVm.accountDetail = paiPolicyArray[0];
            }else{
                linkingLIPolicyVm.accountDetail = {};
            }
        }


        //onclick of submit button
        linkingLIPolicyVm.lifeInsPolicyLink = function() {
            if (validateForm()) {       
                sendOTPForLinkPolicy();
            }
        }

        // Fund form Data will post to server
        function sendOTPForLinkPolicy() {
            var reqObj = {
                "policyNumber": linkingLIPolicyVm.PolicyNum,
                "dob": linkingLIPolicyVm.birthDate
            };

            linkingLIPolicyService.setOTPRequestObject(reqObj);

            linkingLIPolicyService.getOtp().then(function(data) {
                if (data.mobileNumber) {
                   linkingLIPolicyService.setOTPSentNumber(data.mobileNumber);
                    $state.go("menu.enterOTPLinking");
                } 
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }


        linkingLIPolicyVm.goBackLinkedPolicies = function() {
            homeScreenService.isInsuranceFlag = true;
            getAccountDetailsService.tabIndex.tabIndex = 4;
            $state.go("menu.accountOverviewMyBalance");
        };


        function validateForm() {

            linkingLIPolicyVm.frmLinkingPolicySendOTP = {};
            if (linkingLIPolicyVm.validateService.isValidPolicyNum(linkingLIPolicyVm.PolicyNum)) {
                linkingLIPolicyVm.frmLinkingPolicySendOTP.PolicyNum = linkingLIPolicyVm.validateService.isValidPolicyNum(linkingLIPolicyVm.PolicyNum);
            }
            if (linkingLIPolicyVm.validateService.isValidbirthDate(linkingLIPolicyVm.birthDate)) {
                linkingLIPolicyVm.frmLinkingPolicySendOTP.birthDate = linkingLIPolicyVm.validateService.isValidbirthDate(linkingLIPolicyVm.birthDate);
            }
            return (angular.equals({}, linkingLIPolicyVm.frmLinkingPolicySendOTP)) ? true : false;
        }

        /* On Tab Click */
        linkingLIPolicyVm.onTabClick = function(val) {
            if(val === 'LI') { 
                linkingLIPolicyVm.isLifeInsTabSelected = true;
            } else {
                if(!angular.equals({}, getAccountDetailsService.accountOverviewData.customerInformation)) {
                    if(getAccountDetailsService.accountOverviewData.customerInformation.residentialStatus != '1'){
					    pailinkingRenwalService.showErrorCaution("img/yc_Group.svg",$translate.instant('GI_NRI_USER_LBL'),'menu.accountOverviewMyBalance','',function () { 
                            homeScreenService.isInsuranceFlag = true;
                            getAccountDetailsService.tabIndex.tabIndex = 4;
                            $state.go('menu.accountOverviewMyBalance');
                        });
				    } else {
                        //linkingLIPolicyVm.isLifeInsTabSelected = false;
                        linkingLIPolicyVm.getPaiLinkingDetails();
                    }
                } else {
                    utilityService.showErrorMessage('Technical error, please try later.');
                }
            }
        }

        /* Method to get PAI Policy List */
        linkingLIPolicyVm.getPaiLinkingDetails = function() {
            if(linkingLIPolicyVm.paiPolicyLists.length <= 0) {
                pailinkingRenwalService.getPaiPolicyByCif().then(function(result) {
                    if(linkingLIPolicyVm.accountDetail && linkingLIPolicyVm.accountDetail.realTimeStatus) { 
                        linkingLIPolicyVm.isPaiPolicyAvailable = false;
                        linkingLIPolicyVm.isLifeInsTabSelected = false;
                    } else {
                        if(result.data.docStatus && result.data.docStatus.toLowerCase() == "deleted") {
                            linkingLIPolicyVm.callPAI();
                        } else { 
                            if(result.data.policyNo != "") {
                                linkingLIPolicyVm.isLifeInsTabSelected = false;
                                linkingLIPolicyVm.isPaiPolicyAvailable = false;
                            } else {
                                linkingLIPolicyVm.isPaiPolicyAvailable = true;
                            }
                        }
                    }
                }, function(error) {
                    if(error.responseCode == "2001") {   
                        linkingLIPolicyVm.callPAI();
                    } else { 
                        utilityService.showErrorMessage(error.responseMessage);
                        linkingLIPolicyVm.isLifeInsTabSelected = true;
                    }
                });
            } else {
                linkingLIPolicyVm.isLifeInsTabSelected = false;
            }
        }

        linkingLIPolicyVm.callPAI = function(){
            var param = {
                "flow" : "L"
            }
            pailinkingRenwalService.getPaiValidatePolicy(param).then(function(res) {
                var statusCode = res.message.toUpperCase();
                linkingLIPolicyVm.paiPolicyLists = [];
                linkingLIPolicyVm.isLifeInsTabSelected = false;
                if(statusCode =="SL004" || statusCode =="SL005") {
                    linkingLIPolicyVm.paiPolicyLists.push(res);
                    linkingLIPolicyVm.isPaiPolicyAvailable = true;
                    if(linkingLIPolicyVm.paiPolicyLists[0].noOfDaysRemaining < 0){
                        linkingLIPolicyVm.paiPolicyLists[0].noOfDaysToExpire = 30 - Math.abs(linkingLIPolicyVm.paiPolicyLists[0].noOfDaysRemaining);
                    }
                } else {
                    linkingLIPolicyVm.isPaiPolicyAvailable = false;
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
                linkingLIPolicyVm.isLifeInsTabSelected = true;
            });   
        }

        /* On Link Policy Click under General Insurance Tab, Navigate to Successful Page*/
        linkingLIPolicyVm.generalInsPolicyLink = function() {
            pailinkingRenwalService.linkPaiPolicy().then(function(res) {
                pailinkingRenwalService.helpLine = res.helpline;
                $state.go('menu.paiLinkingSuccess');
            }, function(error) {
                 pailinkingRenwalService.showErrorCaution("img/yc_Group.svg",$translate.instant('GI_POLICY_NOT_LINKED_MSSG'),'menu.accountOverviewMyBalance','',function () { 
                    homeScreenService.isInsuranceFlag = true;
                    getAccountDetailsService.tabIndex.tabIndex = 4;
                    $state.go('menu.accountOverviewMyBalance');
                });
            });
        }

        /* Navigate to FAQ Page*/
        linkingLIPolicyVm.goToFAQ = function() {
            pailinkingRenwalService.getLinkingFaq().then(function(res) {
                pailinkingRenwalService.faqQuestions = res.getFAQLists;
                $state.go('menu.paiLinkingFAQ');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        /* Navigate to Account Overview Page*/
        linkingLIPolicyVm.goToRelationship = function() {
            homeScreenService.isInsuranceFlag = true;
            getAccountDetailsService.tabIndex.tabIndex = 4;         
            $state.go('menu.accountOverviewMyBalance');
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
