angularApp.service('linkingLIPolicyService', [
    "$filter",
    "commonAPIService",
    "lifeInsuranceConfig",
    "$q",
    "AdapterUtils",
    "utilityService",

    function($filter,
        commonAPIService,
        lifeInsuranceConfig,
        $q,
        AdapterUtils,
        utilityService) {

        var linkingLIPolicy = this;
        var otpRequestObj = {};
        var selectedPolicy;
        var selectedPolicyDetails;
        var myPolicyDetails;
        var mobileNumber;

        //function to set the otp sent number after send otp is clicked
        linkingLIPolicy.setOTPSentNumber = function(number) {
            mobileNumber = number;
        };


        //function to get the otp sent number
        linkingLIPolicy.getOTPSentNumber = function() {
            return mobileNumber;
        };


        //send OTP request object
        linkingLIPolicy.setOTPRequestObject = function(reqObj) {
            otpRequestObj = reqObj;
        };

        //get OTP request object for link a policy
        linkingLIPolicy.getOTPRequestObject = function() {
            return otpRequestObj;
        };

        //function to request otp 
        linkingLIPolicy.getOtp = function() {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getOTPForLinkPolicy[0], otpRequestObj, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        linkingLIPolicy.setSelectedPolicyDetails = function(data) {
            selectedPolicyDetails = data;
        };

        linkingLIPolicy.getSelectedPolicyDetails = function() {
            return selectedPolicyDetails;
        };

        //for linking the existing policy after the otp is verified
        linkingLIPolicy.linkPolicy = function(otp, secKey) {
            otpRequestObj.otp = otp;
            otpRequestObj.secKey = secKey;
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.linkPolicy[0], otpRequestObj, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                     //lifeInsuranceCommonService.errorLogger(error);
                    q.reject(error);
                }
            );
            return q.promise;
        };


        //function to get all the linked policies
        linkingLIPolicy.getLinkedPolicies = function(data) {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getLILinkedPolicies[0], {}, false).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                   //  lifeInsuranceCommonService.errorLogger(error);
                    q.reject(error);
                }
            );
            return q.promise;
        };


        //function to set the selected policy
        linkingLIPolicy.setSelectedPolicy = function(policy) {
            selectedPolicy = policy;
        };

        //function to get the selected polies
        linkingLIPolicy.getSelectedPolicy = function() {
            return selectedPolicy;
        };

        //function to get the policy details
        linkingLIPolicy.getPolicyDetails = function(policyNo) {
            var reqobj = { "policyNumber": policyNo };
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getPolicyDetails[0], reqobj, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    //lifeInsuranceCommonService.errorLogger(error);
                    q.reject(error);
                }
            );
            return q.promise;
        };

        //function to get the image of selected policy
        linkingLIPolicy.getPolicyDetailImage = function(uinNumber) {
            var requestJson = {
                "uin": uinNumber
            };
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getPlanDetails[0], requestJson, true).then(
                function(response) {
                    q.resolve(response.data.imgUrlMobile);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        //function to set my policy details
        linkingLIPolicy.setMyPolicyDetails = function(data) {
            myPolicyDetails = data;
        };

        //function to get policy details
        linkingLIPolicy.getMyPolicyDetails = function() {
            return myPolicyDetails;
        };

    }
]);
