angularApp.controller('myPolicyDetailsController', [
    "$state",
    "$scope",
    "linkingLIPolicyService",
    "fundSwitchRedirectService",
    "liPolicyPaymentService","getAccountDetailsService","utilityService",

    function(
        $state,
        $scope,
        linkingLIPolicyService,
        fundSwitchRedirectService,
        liPolicyPaymentService,getAccountDetailsService,utilityService) {

        var myPolicyDetailsVm = this;


        function initPage() {
            myPolicyDetailsVm.data = {};
            getPolicyDetailsFn();
        }

        function getPolicyDetailsFn() {
            getAccountDetailsService.accountOverviewData.isPolicyRenewal=false;
            if (linkingLIPolicyService.getSelectedPolicy()) {
                var policy = linkingLIPolicyService.getSelectedPolicy();
                myPolicyDetailsVm.data.policyDetails = linkingLIPolicyService.getSelectedPolicyDetails();
                myPolicyDetailsVm.data.policyDetails.policyNumber = policy.policyNumber;
                myPolicyDetailsVm.data.policyDetails.policyImage = policy.imageUrl;
                myPolicyDetailsVm.data.policyDetails.policyType = policy.policyType;
                canShowUlip();
                linkingLIPolicyService.setMyPolicyDetails(myPolicyDetailsVm.data);
            }
        }

        function canShowUlip() {
            if (myPolicyDetailsVm.data.policyDetails.policyType == "ULIP") {
                myPolicyDetailsVm.canShowFsFr = true;
            } else {
                myPolicyDetailsVm.canShowFsFr = false;
            }
        };

        myPolicyDetailsVm.goBackLinkedPolicies = function() {
            $state.go("menu.accountOverviewMyBalance");
        };

        myPolicyDetailsVm.gotoPayRenewal = function() {
            var reqobj = {
                "policyNumber": myPolicyDetailsVm.data.policyDetails.policyNumber
            };
            liPolicyPaymentService.getLiPolicyRenewalDetails(reqobj).then(function(data) {
               
                getAccountDetailsService.accountOverviewData.isPolicyRenewal=true;
                liPolicyPaymentService.setPolicyRenewalDetails(data);
                $state.go("menu.paymentSummary");
            });
        };

        myPolicyDetailsVm.gotoEstatement = function() {
            $state.go("menu.lifeInsuranceEstatement");
        };

        myPolicyDetailsVm.gotoFundSwitch = function() {
            var reqobj = { "policyNumber": myPolicyDetailsVm.data.policyDetails.policyNumber };
            fundSwitchRedirectService.getFundAllocationForSwitching(reqobj).then(function(data) {
                fundSwitchRedirectService.setFundSwitch(data);
                $state.go("menu.lifeInsuranceFundSwitch");
            });
        };

        myPolicyDetailsVm.gotoFundRedirect = function() {
            var reqobj = { "policyNumber": myPolicyDetailsVm.data.policyDetails.policyNumber };
            fundSwitchRedirectService.getFundAllocationForRedirect(reqobj).then(function(data) {
                fundSwitchRedirectService.setFundRedirect(data);
                $state.go("menu.lifeInsuranceFundRedirect");
            });
        };


        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });


         $scope.$on('floating-menu:open', function(event) {
            var elem = document.querySelectorAll('#floating-backdrop');
            for (var j = 0; j < elem.length; j++) {
                elem[j].className = '';
                elem[j].className = 'backdrop visible active';
            }

        });

        // floating menu close event handler
        $scope.$on('floating-menu:close', function(event) {
            var elem = document.querySelectorAll('#floating-backdrop');
            for (var j = 0; j < elem.length; j++) {
                elem[j].className = '';
                elem[j].className = 'backdrop';
            }
        });


    }

]);
