'use strict';

angularApp.controller('newRenewalOTPController', ["$state",
    "$scope",
    "$translate",
    "getAccountDetailsService",
    "utilityService",
    "homeScreenService",
    "$ionicPopup",
    "$rootScope",
    "$filter","customerInfoService","lifeInsuranceBasicApplicationService","lifeInsuranceCommonService","liPolicyPaymentService",
    "pailinkingRenwalService",

    function ($state,
        $scope,
        $translate,
        getAccountDetailsService,
        utilityService,
        homeScreenService,
        $ionicPopup,
        $rootScope,
        $filter,customerInfoService,lifeInsuranceBasicApplicationService,lifeInsuranceCommonService,liPolicyPaymentService,
        pailinkingRenwalService
    ) {

        var newRenewalOTPVm = this;      
        newRenewalOTPVm.showSubmit =true;
        newRenewalOTPVm.showBack = true;
        var count = 0;


        function initPage() {
            newRenewalOTPVm.mobileNumber =  $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4);
             newRenewalOTPVm.clickCount = 0;
             newRenewalOTPVm.otpValid = false;
             newRenewalOTPVm.disableLink = false;
        }


        //Function for close view
        newRenewalOTPVm.closeView = function () {
          homeScreenService.ishamburgerMenuRO=false;
          homeScreenService.isInsuranceFlag = true;
          getAccountDetailsService.tabIndex.tabIndex=4;          
          $state.go('menu.accountOverviewMyBalance');
        }

        newRenewalOTPVm.onKeyUp = function(){
            $scope.isINR = true;
        }

        //onclick of Back button
        newRenewalOTPVm.goBacktoPrevious = function () {
            $state.go('menu.newRenewalHome');
        };

        newRenewalOTPVm.resendOtp = function(){    
            	count += 1;
                newRenewalOTPVm.otp == '';
		        if (count > 2) {
                    var mssgTxt = $translate.instant('MAX_OTP_GENERATION');
                    pailinkingRenwalService.showError(mssgTxt);
                }else{
                    var successMssg = $translate.instant('SUCCESS_OTP_RESENT_MSSG');
                    var title = '';
                    var onTap = '';
                    var buttontext = 'OK';
                    if(pailinkingRenwalService.isPaiRenewClicked){
                        var renewalSMSObj = {};
                        renewalSMSObj["selectedAccountNumber"] = pailinkingRenwalService.getPaiInsertObject().selectedAccnt;
                        pailinkingRenwalService.getPaiRenewalSMS(renewalSMSObj).then(function(data) {
                            newRenewalOTPVm.clickCount++;
                            newRenewalOTPVm.newRenewalOTPForm = {};
                            utilityService.showAlertModal(title, successMssg, onTap, $scope, $state, buttontext);
                        },function(error){
                            count = count - 1;
                            openAccountService.showError(error.responseMessage,'menu.accountOverviewMyBalance','', function () { 
                                homeScreenService.isInsuranceFlag = true;
                                getAccountDetailsService.tabIndex.tabIndex = 4;
                                $state.go('menu.accountOverviewMyBalance');
                            } );
                        })
                    } else {
                        liPolicyPaymentService.renewPayRenewSbiLifeSmbPolicy().then(function(data) {
                            newRenewalOTPVm.clickCount++;
                            newRenewalOTPVm.newRenewalOTPForm = {};
                            utilityService.showAlertModal(title, successMssg, onTap, $scope, $state, buttontext);
                        },function(error){
                            count = count - 1;
                            openAccountService.showError(error.responseMessage,'menu.accountOverviewMyBalance','', function () { 
                                homeScreenService.isInsuranceFlag = true;
                                getAccountDetailsService.tabIndex.tabIndex = 4;
                                $state.go('menu.accountOverviewMyBalance');
                            } );
                        })
                    }
                }

           
        }

        newRenewalOTPVm.changeOtp =  function(){
             if(newRenewalOTPVm.otp == '' || !newRenewalOTPVm.otp){
                newRenewalOTPVm.otpValid = true;
             }else if(newRenewalOTPVm.otp.length < 6){
                newRenewalOTPVm.otpValid = true;
             }else{
                 newRenewalOTPVm.otpValid = false;
             }
        }
    
         newRenewalOTPVm.validateOTPForPayNew = function(){

             if(newRenewalOTPVm.otp == '' || !newRenewalOTPVm.otp){
                newRenewalOTPVm.otpValid = true;
             }else{     
                newRenewalOTPVm.otpValid = false;
                 if(pailinkingRenwalService.isPaiRenewClicked) {
                    var paiOTPParams = {};
                    paiOTPParams["otp"] = newRenewalOTPVm.otp;
                    paiOTPParams["journeyName"] = "PAILR";
                    pailinkingRenwalService.validateOtp(paiOTPParams).then(function(res) {
                        var paiInsertParams = {};
                        paiInsertParams["autoRenewFlag"] = pailinkingRenwalService.getPaiInsertObject().autoRenewFlag;
                        paiInsertParams["selectedAccount"] = pailinkingRenwalService.getPaiInsertObject().selectedAccnt;
                        //Call Insert PAI API & On Success, Navigate to Success Page
                        pailinkingRenwalService.paiInsertPolicy(paiInsertParams).then(function(data) {
                            pailinkingRenwalService.isPaiRenewClicked = true;
                            data.statusCode = "0000";
                            for( var i = 0; i < pailinkingRenwalService.paiLiPolicyList.length; i++){ 
                                if ( pailinkingRenwalService.paiLiPolicyList[i].journalNo === pailinkingRenwalService.policyNo) { 
                                    pailinkingRenwalService.paiLiPolicyList.splice(i, 1); 
                                }
                            }
                            pailinkingRenwalService.setPaiPolicyDetails(data);
                            pailinkingRenwalService.cloudantPai = "";
                            $state.go("menu.newRenewalSuccess");
                        }, function(error) {
                            if(error.responseCode == "3150" || error.responseCode == "1410"|| error.responseCode == "1301" || error.responseCode == "8468"){
                                var data = {};
                                data.statusCode = error.responseCode;
                                pailinkingRenwalService.setPaiPolicyDetails(data);
                                $state.go("menu.newRenewalSuccess");
                            }else{
                                newRenewalOTPVm.otp ='';   
                                utilityService.showErrorMessage(error.responseMessage);   
                            }
                        });
                    }, function(error) {
                        newRenewalOTPVm.otp =''; 
                        utilityService.showErrorMessage(error.responseMessage);
                    }); 
                 } else {
                    var reqParams = {};
                    var requestSecKey = '';
                    var requestDate = new Date();
                    requestDate = requestDate.getTime();
                    requestSecKey=Math.floor((Math.random()) + requestDate);
                    requestSecKey = (requestSecKey * 10 + 1);
                    reqParams["otp"] = newRenewalOTPVm.otp;
                    reqParams["secKey"] = requestSecKey;
                    lifeInsuranceBasicApplicationService.validateOTPForSbiLifeSmbRenew(reqParams).then(function(data) { 
                        if(data.otpStatus == "Success"){
                                var calculatedKey = lifeInsuranceCommonService.verifySeckey(parseInt(data.secKey));
                                if(requestSecKey == calculatedKey){  
                                $rootScope.renewalRefNo = data.lotusRefNumber;                         
                                    lifeInsuranceBasicApplicationService.getSbiLifeSmbPolicyRenewalDetails().then(function(data) {
                                        getAccountDetailsService.accountOverviewData.newRenewalPolicy=data.record;                                
                                        homeScreenService.getnotificationOffer().then(function (data) {
                                            homeScreenService.offersData=data.suggestedData.offers;
                                            utilityService.setCsatJournies('lifeInsurance');
                                            for( var i = 0; i < pailinkingRenwalService.paiLiPolicyList.length; i++){ 
                                                if ( pailinkingRenwalService.paiLiPolicyList[i].policyNumber === pailinkingRenwalService.policyNo) { 
                                                    pailinkingRenwalService.paiLiPolicyList.splice(i, 1); 
                                                }
                                            }
                                            $state.go("menu.newRenewalSuccess");
                                        });
                                    });
                                
                                }    
                            }else if(data.otpStatus != "Success"){
                                newRenewalOTPVm.enterOTP="";
                                newRenewalOTPVm.otp = "";
                                newRenewalOTPVm.lifeInsuranceEnterOTPForm.enterOTP = data.status;
                                utilityService.showErrorMessage(data.responseMessage);
                            }else {
                            var alertPopup = $ionicPopup.alert({
                                title: '',
                                template: '<p class="roboto-regular font-content text-center">' + 'We are unable to process your request due to ' + data.status + '</p>'
                            });
                        }
                    },function(error){
                        newRenewalOTPVm.otp ='';                    
                })
                 }
             }
            
        }
       
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {           
          
        });
        
        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            initPage();           
        });

        $scope.$on('$ionicView.beforeLeave', function () {

        });

        return this;
    }
]);
