
'use strict';

angularApp.controller('newRenewalSuccessController', ["$state",
    "$scope",    
    "$ionicSideMenuDelegate",    
    "$translate", "$ionicPopover",  
    "utilityService","getAccountDetailsService","lifeInsuranceCommonService","mPinLoginService",
    "lifeInsuranceBasicApplicationService","openUrlInAppbroswerService","irctcService","$ionicPopup",
    "pailinkingRenwalService","generalInsurenceHomeService","homeScreenService","arogyaSanjeevaniService",
    "GIconstant",

    function ($state,
        $scope,        
        $ionicSideMenuDelegate,       
        $translate,  $ionicPopover,      
        utilityService,getAccountDetailsService,lifeInsuranceCommonService,mPinLoginService,lifeInsuranceBasicApplicationService,
        openUrlInAppbroswerService,irctcService,$ionicPopup,pailinkingRenwalService,generalInsurenceHomeService,homeScreenService,
        arogyaSanjeevaniService,GIconstant
    ) {

        var newRenewalSuccessVm = this;       
        newRenewalSuccessVm.showBack = true;
        newRenewalSuccessVm.showNext = true;

        function initPage() { 
            newRenewalSuccessVm.constant = GIconstant;      
            newRenewalSuccessVm.paiLiPolicyList = pailinkingRenwalService.paiLiPolicyList;    
            newRenewalSuccessVm.policyDetails = lifeInsuranceCommonService.getRenewalData();
            newRenewalSuccessVm.policyList = getAccountDetailsService.accountOverviewData.newRenewalPolicy;
            newRenewalSuccessVm.isPaiRenewedClicked = pailinkingRenwalService.isPaiRenewClicked;
            var status = '';
            if(newRenewalSuccessVm.isPaiRenewedClicked){
                newRenewalSuccessVm.paiPolicyDetails = pailinkingRenwalService.getPaiPolicyDetails();
                newRenewalSuccessVm.PaiRenewPolicyDetails = pailinkingRenwalService.getPaiRenewPolicyDetails();
                status = newRenewalSuccessVm.paiPolicyDetails.statusCode;
                if(status == "0000"){
                    newRenewalSuccessVm.imageSrc = 'img/YCGroup5.svg';
                    newRenewalSuccessVm.errorMssg = '';
                    newRenewalSuccessVm.height = '295px';
                }else if(status == "1410" || status == "1301"){
                    newRenewalSuccessVm.imageSrc = 'img/FT/BhimUpi/errorSymbol.svg';
                    newRenewalSuccessVm.errorMssg = $translate.instant('TRY_AFTER_SOMETIME_MSSG');
                    newRenewalSuccessVm.height = '260px';
                }else if(status == "3150" || status == "8468"){
                    newRenewalSuccessVm.imageSrc = 'img/yc_Group.svg';
                    newRenewalSuccessVm.errorMssg = $translate.instant('TIMED_OUT_MSSG'); 
                    newRenewalSuccessVm.height = '220px';
                }else if (status == "1403" || status == "1404"){
                    newRenewalSuccessVm.imageSrc = 'img/YCGroup5.svg';
                    newRenewalSuccessVm.errorMssg = $translate.instant('POLICY_EMAILED_MSSG');
                    newRenewalSuccessVm.height = '280px';
                }
            }
        }


        newRenewalSuccessVm.getPaymentAcknowledgeSlip=function(){
            lifeInsuranceBasicApplicationService.paymentAcknowledgeSlip().then(function(data){
                pdfGenration(data.base64,"paymentAcknowledgeSlip_" + newRenewalSuccessVm.policyDetails.policyNumber + '.pdf');
            },function(error){
                              
            })
        }
               
         function b64toBlob(b64Data, contentType, sliceSize) {
                contentType = contentType || '';
                sliceSize = sliceSize || 512;
                var byteCharacters = atob(b64Data);
                var byteArrays = [];
                for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
                    var slice = byteCharacters.slice(offset, offset + sliceSize);
                    var byteNumbers = [];
                    for (var i = 0; i < slice.length; i++) {
                        byteNumbers[i] = slice.charCodeAt(i);
                    }
                    var byteArray = new Uint8Array(byteNumbers);
                    byteArrays.push(byteArray);
                }
                var blob = new Blob(byteArrays, { type: contentType });
                return blob;
            }

            function savebase64AsPDF(folderpath, filename, content, contentType) {
                // Convert the base64 string in a Blob
                var DataBlob = b64toBlob(content, contentType);
                var errorInvalidSize = "Invalid File Size";
                if(utilityService.isAndroidPlatform()) {
                    if(device.version==10){
                        newRenewalSuccessVm.popupFolderpath = folderpath.replace(cordova.file.externalRootDirectory,"") + filename;
                        window.resolveLocalFileSystemURL(folderpath, function(dir) {
                            dir.getFile(filename, { create: true }, function(file) {
                                file.createWriter(function(fileWriter) {
                                    if (DataBlob.size >= newRenewalSuccessVm.constant.ArogyaSanjeevani.MIN_FILE_LENGTH && DataBlob.size <= newRenewalSuccessVm.constant.ArogyaSanjeevani.MAX_FILE_LENGTH) {
                                        fileWriter.write(DataBlob);
                                        newRenewalSuccessVm.showDownloadPopUp();
                                    } else {
                                        arogyaSanjeevaniService.displayPopUp("", "padBtm25 top-padding26", errorInvalidSize, "OK",
                                            function () { }
                                        );
                                    }
                                }, function() {});
                            });
                        });
                    }
                    else{
                        //for Android below 10 and Android 11 not for 10
                        window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem){
                            fileSystem.root.getDirectory("Download", {create: true, exclusive: false},function(dir) {
                                newRenewalSuccessVm.popupFolderpath = dir.fullPath + filename;
                                dir.getFile(filename, { create: true, exclusive: false }, function(file) {
                                    file.createWriter(function(fileWriter) {
                                        if (DataBlob.size >= newRenewalSuccessVm.constant.ArogyaSanjeevani.MIN_FILE_LENGTH && DataBlob.size <= newRenewalSuccessVm.constant.ArogyaSanjeevani.MAX_FILE_LENGTH) {
                                            fileWriter.write(DataBlob);
                                            newRenewalSuccessVm.showDownloadPopUp();
                                        } else {
                                            arogyaSanjeevaniService.displayPopUp("", "padBtm25 top-padding26", errorInvalidSize, "OK",
                                                function () { }
                                            );
                                        }
                                    }, function() {});
                                });
                            });
                        });
                    }

                    
                }

            }


            function pdfGenration(content, filename) {
                var contentType = "application/pdf";

                if (utilityService.isAndroidPlatform()) {
                    newRenewalSuccessVm.folderpath = cordova.file.externalDataDirectory;   
                    savebase64AsPDF(newRenewalSuccessVm.folderpath, filename, content, contentType);
                }
                
                if (utilityService.isIOSPlatform()) {
                    newRenewalSuccessVm.folderpath = cordova.file.applicationDirectory;
                    irctcService.savebase64AsPDF(newRenewalSuccessVm.folderpath,filename,content,contentType);
                    if(utilityService.isIOSPlatform()){
                    var finalObject = { "folderpath": newRenewalSuccessVm.folderpath, "filename": filename };
                        openUrlInAppbroswerService.openUrl("data:application/pdf;base64,"+content+"","");
                    }
                }
            }

        newRenewalSuccessVm.showDownloadPopUp = function() {
           //Show popup 
            var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="PAI_DOWNLOAD_RECEIPT" translate-values="{filePath:newRenewalSuccessVm.popupFolderpath}"></div>';
            newRenewalSuccessVm.downloadPopup = $ionicPopup.show({
                title: '',
                template: template,
                scope: $scope,
                cssClass: 'my-custom-popup',
                buttons: [{
                    text:'OK',
                    type: 'button-assertive',
                    onTap: function() { 
                        newRenewalSuccessVm.downloadPopup.close();

                    }
                }],
            });
        }      

        //onclick of home button
        newRenewalSuccessVm.goToHome = function () {         
          getAccountDetailsService.tabIndex.tabIndex=4; 
          homeScreenService.isInsuranceFlag = true;        
          $state.go('menu.accountOverviewMyBalance');
        }
        newRenewalSuccessVm.renewAnotherPolicy = function () { 
            pailinkingRenwalService.paiPolicyData = [];   
            $state.go('menu.newRenewalHome');
        }
        
        newRenewalSuccessVm.goToLinking = function () {               
          $state.go('menu.linkingLIPolicy');
        }

        /* Function to View/Download Payment Slip*/
        newRenewalSuccessVm.getPaymentAcknowledgeSlipPiRenew=function(){
           var paiPdfRequest = {
                "policyNo": newRenewalSuccessVm.paiPolicyDetails.payment.journalNo,
                "productId": "personal-accident-insurance"
            }				
            generalInsurenceHomeService.getPlan(paiPdfRequest).then(function(detail) {
                pdfGenration(detail.base64, "PersonalAccidentInsurance.pdf");
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

       /* Function to show PopOver on click of info icon*/
        newRenewalSuccessVm.displayInfo = function($event){
			newRenewalSuccessVm.leftStyle = "left : " + ($event.clientX - 35) + "px";
            newRenewalSuccessVm.template = '<ion-popover-view class="quickpay loginnewarrow hmbr-info pai-lr-info-icon" id="runtimeHeight">' + '<div class="username-hint-arrow-upnew" style="{{newRenewalSuccessVm.leftStyle}}"></div>' +
            '<ion-content class="nfs-popover pai-lr-popover" style="margin: 0px !important;">' +
            '<div id="renderHeight" class="padding-right-10 font-size-12" style="padding-left: 14px !important;">' +
            '<div class="row no-padding"><div class="col col-100"><label class="arsa-policyDocLbl" translate="ARSA_POLICY_DOCUMENT_LBL"></label> </div></div>' +
            '<hr class="arsa_border_style_popover">'+
            '<div class="row no-padding"><div class="col col-30"><label class="arsa_datePDF_lbl_bold arsa_txt_underline">05Mar</label>'+
            '<span><label class="arsa_datePDF_lbl_light"> ch </label></span></div>'+
            '<div class="col col-10 arsa_align_Item_Center"><label class="arsa_datePDF_lbl_light">+</label></div>'+
            '<div class="col col-20 arsa_align_Item_Center"><label class="arsa_datePDF_lbl_bold arsa_txt_underline">!</label> </div>' +
            '<div class="col col-10 arsa_align_Item_Center"><label class="arsa_datePDF_lbl_light">+</label></div>'+
            '<div class="col col-30 pai-align-ItemRight"><label class="arsa_datePDF_lbl_light">9xxxxx </label><span><label class="arsa_datePDF_lbl_bold arsa_txt_underline">8899</label></span></div></div>'+
            '<div class="row no-padding"><div class="col col-40"> <p class="arsa_datePDF_lbl_light arsa_whiteSpace_Normal arsa_fontfamily_regular arsa-lineHeight15" translate="PCE_PASSWORD_BIRTHDATE_LABEL"></p></div>'+
            '<div class="col col-30"><p class="arsa_datePDF_lbl_light arsa_whiteSpace_Normal arsa_fontfamily_regular arsa-lineHeight15">Mandatory "!" sign</p></div>'+
            '<div class="col col-30 arsa-paddingRight-0 arsa-popover-lineheight"><p class="arsa_datePDF_lbl_light arsa_whiteSpace_Normal arsa_fontfamily_regular arsa-lineHeight15" translate="PCE_PASSWORD_MOBNO" ></p></div></div>' + 
            '<hr class="arsa_border_style_Succes_popover_dotted">'+
            '<div class="row"><div class="col col-100 pai-align-ItemLeft"><label class="arsa-passwordEg-Lbl">Password eg. - 05Mar!8899</label></div></div>'+
			'</div>' + '</ion-content>' + '</ion-popover-view>';
			$scope.popover = $ionicPopover.fromTemplate(newRenewalSuccessVm.template, {
				scope: $scope
			});
			$scope.popover.show($event);
		}

      
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        $scope.$on('$ionicView.beforeLeave', function () {

        });

        return this;
    }
]);
