angularApp.service('liPolicyPaymentService', [
    "lifeInsuranceConfig",
    '$q',
    'AdapterUtils',
    'utilityService',

    function(
        lifeInsuranceConfig,
        $q,
        AdapterUtils,
        utilityService) {

        var liPolicyPayment = this;
        var payRenewalResponse;
        var policyRenewaldetails;
     

        liPolicyPayment.setpayRenewalResponse = function(data) {
            payRenewalResponse = data;
        };

        liPolicyPayment.getpayRenewalResponse = function() {
            return payRenewalResponse;
        };

        liPolicyPayment.setPolicyRenewalDetails = function(data) {
            policyRenewaldetails = data;
        };

        liPolicyPayment.getPolicyRenewalDetails = function() {
            return policyRenewaldetails;
        };


        liPolicyPayment.getSBIBankAccounts = function() {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getLISBIBankAccounts[0], {}, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };


        liPolicyPayment.getPayRenewalMessage = function() {
            var q = $q.defer();
            AdapterUtils.getData(lifeInsuranceConfig.adapterURL.getPaymentComplete[0], true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };

        // Download Policy E-Statement from server  
        liPolicyPayment.downloadViewPolicy = function(downloadViewEstatmentJson) {
            var q = $q.defer();
            AdapterUtils.postDataWithTimeOut(lifeInsuranceConfig.adapterURL.downloadStatement[0], downloadViewEstatmentJson, true, lifeInsuranceConfig.adapterURL.downloadStatement[2]).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };


        // Policy Payment Data will post to server and get response  
        liPolicyPayment.payRenewPolicy = function(policyPayNowDetailsJson) {
            var q = $q.defer();
            AdapterUtils.postDataWithTimeOut(lifeInsuranceConfig.adapterURL.payRenewLIPolicy[0], policyPayNowDetailsJson, true, lifeInsuranceConfig.adapterURL.payRenewLIPolicy[2]).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };
         liPolicyPayment.payRenewSbiLifeSmbPolicy = function(policyPayNowDetailsJson) {
            var q = $q.defer();
            AdapterUtils.postDataWithTimeOut(lifeInsuranceConfig.adapterURL.payRenewSbiLifeSmbPolicy[0], policyPayNowDetailsJson, true, lifeInsuranceConfig.adapterURL.payRenewLIPolicy[2]).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };

        liPolicyPayment.renewPayRenewSbiLifeSmbPolicy = function() {
            var q = $q.defer();
            AdapterUtils.postDataWithTimeOut(lifeInsuranceConfig.adapterURL.resendPayRenewSbiLifeSmbPolicy[0], {}, true, lifeInsuranceConfig.adapterURL.resendPayRenewSbiLifeSmbPolicy[2]).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };

         liPolicyPayment.getInfoContentForLI = function() {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getInfoContent[0], {}, true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        liPolicyPayment.getLiPolicyRenewalDetails = function(request) {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getPolicyRenewalDetails[0], request, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    q.reject(error);
                }
            );
            return q.promise;
        };
    }
]);
