angularApp.controller('lifeInsuranceOTPforRenewPaymentController', [
    "$state",
    "$scope",
    "validateService",
    "lifeInsuranceBasicApplicationService",
    "lifeInsuranceCommonService", 
    "premiumCalculationService",
    "lifeInsuranceApplicationService",
    "suggestedPlansDetailsService",
    "$ionicPopup","utilityService",
    "customerInfoService","liPolicyPaymentService","getAccountDetailsService",


    function(
        $state,
        $scope,
        validateService,
        lifeInsuranceBasicApplicationService,
        lifeInsuranceCommonService, 
        premiumCalculationService,
        lifeInsuranceApplicationService,
        suggestedPlansDetailsService,
        $ionicPopup,utilityService,
        customerInfoService,liPolicyPaymentService, getAccountDetailsService
    ) {

        var lifeInsuranceEnterOTPRenewPaymentVm = this;
        lifeInsuranceEnterOTPRenewPaymentVm.validateService = validateService;

        function initPage() {
            lifeInsuranceEnterOTPRenewPaymentVm.showBack = false;
            lifeInsuranceEnterOTPRenewPaymentVm.showNext = true;
            lifeInsuranceEnterOTPRenewPaymentVm.terms = false;
            lifeInsuranceEnterOTPRenewPaymentVm.disableback = true;
           lifeInsuranceEnterOTPRenewPaymentVm.enterOTP = "";
           lifeInsuranceEnterOTPRenewPaymentVm.lifeInsuranceEnterOTPForm.enterOTP="";
            var rupeeSymbol = String.fromCharCode(8377);
            lifeInsuranceEnterOTPRenewPaymentVm.premiumAmount = rupeeSymbol + liPolicyPaymentService.getPolicyRenewalDetails().grossAmount;
            lifeInsuranceEnterOTPRenewPaymentVm.mobileNum = $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4);
           
        }

        lifeInsuranceEnterOTPRenewPaymentVm.resendOTP = function() {
            lifeInsuranceEnterOTPRenewPaymentVm.enterOTP = "";
            var reqParams = {};
            reqParams.id = "";
            reqParams.emailId = "";
            lifeInsuranceBasicApplicationService.getOTPTokenForPayRenew().then(function(data) {
                lifeInsuranceEnterOTPRenewPaymentVm.lifeInsuranceEnterOTPForm = {};
            });
        };
        //call for validate OTP at renew payment page
        lifeInsuranceEnterOTPRenewPaymentVm.validateOTP = function() {
            var reqParams = {};
            var requestSecKey;
	    var requestDate = new Date();
	   requestDate = requestDate.getTime();
	    requestSecKey=Math.floor((Math.random()) + requestDate);
	    requestSecKey = (requestSecKey * 10 + 1);
            reqParams.otp = lifeInsuranceEnterOTPRenewPaymentVm.enterOTP;
            reqParams.secKey = requestSecKey;
            lifeInsuranceBasicApplicationService.validateOTPTokenForRenewPayment(reqParams).then(function(data) { 
                    if(data.otpStatus == "Success"){
                        var calculatedKey = lifeInsuranceCommonService.verifySeckey(parseInt(data.secKey));
                        if(requestSecKey == calculatedKey){                            
                            liPolicyPaymentService.setpayRenewalResponse(data);
                            getAccountDetailsService.accountOverviewData="";
                           utilityService.setCsatJournies('lifeInsurance');
                           $state.go("menu.paymentComplete");
                        }    
                    }else if(data.otpStatus != "Success"){
                        lifeInsuranceEnterOTPRenewPaymentVm.enterOTP="";
                        lifeInsuranceEnterOTPRenewPaymentVm.lifeInsuranceEnterOTPForm.enterOTP = data.status;
                    }else {
                    var alertPopup = $ionicPopup.alert({
                        title: '',
                        template: '<p class="roboto-regular font-content text-center">' + 'We are unable to process your request due to ' + data.status + '</p>'
                    });
                }
                    //$state.go('menu.lifeInsurancePaynow');
            },function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        };

        //onclick of submit button
        lifeInsuranceEnterOTPRenewPaymentVm.goToNextPage = function() {
            if (validateForm()) {
                lifeInsuranceEnterOTPRenewPaymentVm.validateOTP();
            }
        };

        lifeInsuranceEnterOTPRenewPaymentVm.closeJourney = function() {
            lifeInsuranceCommonService.closePopUp().then(function(result) {
                if (result) {
                    $state.go("menu.generalInsurance");
                }
            });
        };

        //conmmon validation function
        function validateForm() {
            lifeInsuranceEnterOTPRenewPaymentVm.lifeInsuranceEnterOTPForm = {};
            if (lifeInsuranceEnterOTPRenewPaymentVm.validateService.isValidOTPNum(lifeInsuranceEnterOTPRenewPaymentVm.enterOTP)) {
                lifeInsuranceEnterOTPRenewPaymentVm.lifeInsuranceEnterOTPForm.enterOTP = lifeInsuranceEnterOTPRenewPaymentVm.validateService.isValidOTPNum(lifeInsuranceEnterOTPRenewPaymentVm.enterOTP);
            }
            return (angular.equals({}, lifeInsuranceEnterOTPRenewPaymentVm.lifeInsuranceEnterOTPForm)) ? true : false;
        };

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
