angularApp.controller('paymentSummaryController', [
    "$state",
    "$scope",
    "$ionicPopup",
    "validateService",
    "liPolicyPaymentService",
    "linkingLIPolicyService",
    "lifeInsuranceApplicationService",
    "$translate","lifeInsuranceCommonService","constantConfig","getAccountDetailsService",

    function(
        $state,
        $scope,
        $ionicPopup,
        validateService,
        liPolicyPaymentService,
        linkingLIPolicyService,
        lifeInsuranceApplicationService,
        $translate,lifeInsuranceCommonService,constantConfig,getAccountDetailsService) {

        var paymentSummaryVm = this;

        function initPage() {
            if(getAccountDetailsService.accountOverviewData.isPolicyRenewal!=true){
                paymentSummaryVm.refCodeHide=false;
                paymentSummaryVm.getTooltipContentLI();
            }else{
                paymentSummaryVm.refCodeHide=getAccountDetailsService.accountOverviewData.isPolicyRenewal;
            }
            
            paymentSummaryVm.showBack = true;
            paymentSummaryVm.showNext = true;
            paymentSummaryVm.disableBack = false;
            paymentSummaryVm.disableNext = false;

            var policy = linkingLIPolicyService.getMyPolicyDetails();
            var renewalDetails = liPolicyPaymentService.getPolicyRenewalDetails();
            if (policy && renewalDetails) {
                paymentSummaryVm.policyTitle = policy.policyDetails.productName;
                paymentSummaryVm.policyNumber = policy.policyDetails.policyNumber;
                paymentSummaryVm.premiumAmount = renewalDetails.grossAmount;
                paymentSummaryVm.sumAssured = policy.policyDetails.sumInsured;
                paymentSummaryVm.SelectedLIPayYrTenure = policy.policyDetails.policyTerm;
            }
            selectAccNumAndGetBalance();
        };


        //  getting Current balance
        function selectAccNumAndGetBalance() {
            liPolicyPaymentService.getSBIBankAccounts().then(function(data) {
                paymentSummaryVm.accounts = data.beneficiaryList.ownAccounts;
                if(paymentSummaryVm.accounts.length > 0) {
                    if(paymentSummaryVm.selectedAccNumber=='' || paymentSummaryVm.selectedAccNumber==null){
                        paymentSummaryVm.selectedAccNumber = paymentSummaryVm.accounts[0];
                    }else{
                        for(var i=0;i<paymentSummaryVm.accounts.length;i++ ){
                            if(paymentSummaryVm.selectedAccNumber.benAccntNo==paymentSummaryVm.accounts[i].benAccntNo){
                                paymentSummaryVm.selectedAccNumber='';
                                 paymentSummaryVm.selectedAccNumber = paymentSummaryVm.accounts[i];
                            }
                        }
                    }
                }
            });
        };


        //onkeyup validate fields if required
        paymentSummaryVm.validateService = validateService;

        // clicked on pay now button
        paymentSummaryVm.payNow = function() {
            if (validateForm()) {
                checkForBalance();
            }
        }

        function checkForBalance() {
            var balance = parseInt(paymentSummaryVm.selectedAccNumber.balance);
            if (balance < paymentSummaryVm.premiumAmount) {
                var message = $translate.instant('NO_BALANCE_AMOUNT');
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    template: '<p class = "roboto-regular font-content text-center">' + message + '</p>'
                });
                alertPopup.then(function(res) {});
            } else {
                var accountNumber = {
                    "bankAccountNo": paymentSummaryVm.selectedAccNumber.benAccntNo
                }
                lifeInsuranceApplicationService.getSBIBankAccoutDetails(accountNumber).then(function(data) {
                    paymentSummaryVm.accountDetails = data;
                   // doPayment();
                },function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
                 var message = $translate.instant('PAYMENT_CONFIRM');
                 var rupeeSymbol = String.fromCharCode(8377);
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    template: '<p class = "roboto-regular font-content text-center">' + message + ' ' + rupeeSymbol + paymentSummaryVm.premiumAmount + ' ?' + '</p>',
                    cssClass: 'bi-table',
                    buttons: [{
                     text: 'No',
                     type: 'button-negative',
                     onTap: function(e) {
                         return false;
                     }
                    }, {
                     text: 'Yes',
                     type: 'button-positive',
                     onTap: function(e) {
                        return true;
                    }
                }]
                });
                alertPopup.then(function(res) {
                if(res){
                    doPayment();
                }
                });
                
            }
        };


        function doPayment() {
            var requestSecKey;
	    var requestDate = new Date();
        requestDate = requestDate.getTime();
	    requestSecKey=Math.floor((Math.random()) + requestDate);
	    requestSecKey = (requestSecKey * 10 + 1);
            var requestObj = {};
            requestObj.proposalNumber = '';//lifeInsuranceBasicApplicationService.getSubmitApplicationResponse().proposalNo;
            requestObj.policyNumber = paymentSummaryVm.policyNumber;
            requestObj.premiumAmount = paymentSummaryVm.premiumAmount.toString();
            requestObj.accountHolderName = paymentSummaryVm.selectedAccNumber.benName;
            requestObj.accountNumber = paymentSummaryVm.selectedAccNumber.benAccntNo;
            requestObj.ifscCode = '';
            requestObj.isAutoPay = paymentSummaryVm.ckAutoPayInLI ? paymentSummaryVm.ckAutoPayInLI.toString() : 'false';
            requestObj.panNumber = paymentSummaryVm.accountDetails.panNumber;
            requestObj.branchCode = paymentSummaryVm.selectedAccNumber.branchCode;
            requestObj.secKey = requestSecKey;
             requestObj.referralCode = paymentSummaryVm.refCode;
            liPolicyPaymentService.payRenewPolicy(requestObj).then(function(data) {
                 if(data.isOTPRequired == "true"){
                  $state.go("menu.lifeInsuranceOTPforRenewPayment");     
                }else{
                    var calculatedKey = lifeInsuranceCommonService.verifySeckey(parseInt(data.secKey));
                        if(requestSecKey == calculatedKey){
                            liPolicyPaymentService.setpayRenewalResponse(data);
                           utilityService.setCsatJournies('lifeInsurance');
                           $state.go("menu.paymentComplete");
                        }        
                }
               // $state.go("menu.paymentComplete");
            });
        };


         paymentSummaryVm.getTooltipContentLI=function(){
            //utilityService.showSpinner();
                 liPolicyPaymentService.getInfoContentForLI().then(function(response) {  
                if(response.infoList[0].key=='452374ef-c96a-4860-930d-60853bc887f5'){
                   // utilityService.hideSpinner();
                    paymentSummaryVm.refCodeContentMessage=response.infoList[0].value;
                }else{
                    // utilityService.hideSpinner();
                    paymentSummaryVm.refCodeContentMessage=constantConfig.mfAndsecConst.riskInfoEmptyText;
                }                       
                }, function(error) {
                    // utilityService.hideSpinner();
                     paymentSummaryVm.refCodeContentMessage=constantConfig.mfAndsecConst.riskInfoEmptyText;

                });
            }

         /***Function to show information POP UP***/
	        paymentSummaryVm.showInformationPopupRef= function() {
	        	var infoPopup = $ionicPopup.show({
					template: '<p>'+paymentSummaryVm.refCodeContentMessage+'</p>',
					title:'Information',
					scope: $scope,
					cssClass: 'dialog',		
					buttons: [
		            {
		               text: 'Ok'
		            }
					]
				});

	            
	        }
        paymentSummaryVm.goBack = function() {
            $state.go("menu.myPolicyDetails");
        };

        //frm Payment Summary validation function
        function validateForm() {
            paymentSummaryVm.frmPaymentSummary = {};
            if (paymentSummaryVm.validateService.isValidAccountNum(paymentSummaryVm.selectedAccNumber)) {
                paymentSummaryVm.frmPaymentSummary.selectedAccNumberVMsg = paymentSummaryVm.validateService.isValidAccountNum(paymentSummaryVm.selectedAccNumber);
            }
            return (angular.equals({}, paymentSummaryVm.frmPaymentSummary)) ? true : false;
        }
        

        //one time initialization to be done when the controller is entered
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
