angularApp.controller('retreiveApplicationController', [
    "$state",
    "$scope",
    "utilityService",
    "generalInsurenceHomeDetailService",
    "generalInsurenceHomeService",
    "lifeInsuranceCommonService",
    "suggestedPlansDetailsService",
    "lifeInsuranceApplicationService",
    "GIconstant",
    "generalInsurenceMotorService",
    "generalInsurenceTravelService",
    "generalInsurenceHealthService",
    "$ionicPopup",
    "generalInsurenceAccidentService",
    "$timeout",
    "$filter",
    "$ionicScrollDelegate","rrService",
    "arogyaSanjeevaniService",
    "$translate",
    function(
        $state,
        $scope,
        utilityService,
        generalInsurenceHomeDetailService,
        generalInsurenceHomeService,
        lifeInsuranceCommonService,
        suggestedPlansDetailsService,
        lifeInsuranceApplicationService,
        GIconstant,
        generalInsurenceMotorService,
        generalInsurenceTravelService,
        generalInsurenceHealthService,
        $ionicPopup,
        generalInsurenceAccidentService,
        $timeout,
        $filter,
        $ionicScrollDelegate,rrService,
        arogyaSanjeevaniService,
        $translate) {

        var retreiveApplicationVm = this;
        $scope.paiErrorTitle = '';
        $scope.paiErrorDescription = '';
        $scope.paiErrorFooter = '';

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
            $ionicScrollDelegate.scrollTop();
        });
        var savedApplication;
        //Control initialization
        function initPage() {
            retreiveApplicationVm.LIApplications = [];
            retreiveApplicationVm.GIApplications = [];
             retreiveApplicationVm.RINApplications = [];
			retreiveApplicationVm.applications = [];
            retreiveApplicationVm.tempapplications = [];
            retreiveApplicationVm.hasLiApplication = true;
            retreiveApplicationVm.hasGiApplication = true;
            retreiveApplicationVm.hasRinApplication = true;
            retreiveLIPendingApplications();
        };

        //Function to retreive pending applications of Life Insurance
        function retreiveLIPendingApplications() {
            lifeInsuranceCommonService.setIsFromRetrieveApplication(true);
            lifeInsuranceCommonService.retreiveLIPendingApplications().then(function(data) {
				utilityService.showSpinner();
                retreiveApplicationVm.LIApplications = data.applications;
                if (retreiveApplicationVm.LIApplications.length > 0) {
                    retreiveApplicationVm.hasLiApplication = true;
                }
                getImagesFromWCM();
				retreiveApplicationVm.applications = retreiveApplicationVm.LIApplications;
                retreiveGIPendingApplications();
            }, function(error) {
                retreiveApplicationVm.hasLiApplication = false;
                retreiveGIPendingApplications();
            });
        };


        function retreiveGIPendingApplications() {
            generalInsurenceHomeDetailService.getSavedApplications().then(function(giData) {
				utilityService.hideSpinner();
                retreiveApplicationVm.GIApplications = giData.applications;
                if (retreiveApplicationVm.GIApplications.length > 0) {
                    retreiveApplicationVm.hasGiApplication = true;
                }
                getGIImagesFromWCM();
                retreiveRinRakshaPendingApplications();
            }, function(error) {
				utilityService.hideSpinner();
				retreiveApplicationVm.applications = retreiveApplicationVm.LIApplications;
                retreiveApplicationVm.hasGiApplication = false;
                retreiveRinRakshaPendingApplications();
            });
        }
        //RinRaksha Retrive Pending Application
         function  retreiveRinRakshaPendingApplications(){
            rrService.getApplications().then(function(res){
                utilityService.hideSpinner();
                retreiveApplicationVm.RINApplications = res;
                if (retreiveApplicationVm.RINApplications != null) {
                    retreiveApplicationVm.hasRinApplication = true;
                }
                getRINImagesFromWCM();
            },function(error){
                utilityService.hideSpinner();
                 retreiveApplicationVm.hasRinApplication = false;
                 retreiveApplicationVm.applications = retreiveApplicationVm.LIApplications;
            });
        }

        //Function to get applications from WCM
        function getGIImagesFromWCM() {
            if (!retreiveApplicationVm.wcmGIProducts) {
                generalInsurenceHomeService.getAllPlans().then(function(data) {
                    retreiveApplicationVm.wcmGIProducts = data;
                    bindWcmGIImagesToRetreiveApplication();
                }, function(error) {});
            } else {
                bindWcmGIImagesToRetreiveApplication();
            }
        };
         //Function to get applications from WCM of Rinraksha
        function getRINImagesFromWCM() {
            if (!retreiveApplicationVm.wcmRINProducts) {
                suggestedPlansDetailsService.getOtherAllProductsList().then(function(data) {
                    retreiveApplicationVm.wcmRINProducts = data;
                    bindWcmRINImagesToRetreiveApplication();
                }, function(error) {});
            } else {
                bindWcmRINImagesToRetreiveApplication();
            }
        };

        retreiveApplicationVm.restrictDate = function(createdDate){
           var todaysDate =  generalInsurenceHomeService.getCurrentDate();
           var backDate  = generalInsurenceHomeService.getFutureDate(todaysDate,-30);
           createdDate = $filter('timeStampToDate')(createdDate);
            if(new Date(createdDate).getTime() <= new Date(backDate).getTime()){
                return false;
            }else{
                return true;
            }
        }

        //Function to get applications from WCM
        function getImagesFromWCM() {
            if (!retreiveApplicationVm.wcmProducts) {
                suggestedPlansDetailsService.getOtherAllProductsList().then(function(data) {
                    retreiveApplicationVm.wcmProducts = data.plans;
                    bindWcmImagesToRetreiveApplication();
                });
            } else {
                bindWcmImagesToRetreiveApplication();
            }
        };

        //Functions to map WCM images with Retreived application
        function bindWcmGIImagesToRetreiveApplication() {
            for (var index = 0; index < retreiveApplicationVm.GIApplications.length; index++) {
				retreiveApplicationVm.GIApplications[index].moduleName = "GI";
                for (var subIndex = 0; subIndex < retreiveApplicationVm.wcmGIProducts.length; subIndex++) {
                    if (retreiveApplicationVm.GIApplications[index].uin) {
                        for (var j = 0; j < retreiveApplicationVm.wcmGIProducts[subIndex].policies.length; j++) {
                            if (retreiveApplicationVm.GIApplications[index].uin == retreiveApplicationVm.wcmGIProducts[subIndex].policies[j].uin) {
                                retreiveApplicationVm.GIApplications[index].imageUrl = retreiveApplicationVm.wcmGIProducts[subIndex].policies[j].logoImgUrlMobile;
                            }
                        }
                    }
                }
            }
			retreiveApplicationVm.applications = retreiveApplicationVm.LIApplications.concat(retreiveApplicationVm.GIApplications);
        };

        //Functions to map WCM images with Retreived application
        function bindWcmImagesToRetreiveApplication() {
            for (var index = 0; index < retreiveApplicationVm.LIApplications.length; index++) {
				retreiveApplicationVm.LIApplications[index].moduleName = "LI";
                for (var subIndex = 0; subIndex < retreiveApplicationVm.wcmProducts.length; subIndex++) {
                    if (retreiveApplicationVm.LIApplications[index].uin && retreiveApplicationVm.LIApplications[index].uin == retreiveApplicationVm.wcmProducts[subIndex].uin) {
                        retreiveApplicationVm.LIApplications[index].imageUrl = retreiveApplicationVm.wcmProducts[subIndex].imageUrl;
                        break;
                    }
                }
            }
        };

        //Functions to map WCM images with Retreived application for RinRaksha
        function bindWcmRINImagesToRetreiveApplication() {
            for (var index = 0; index < retreiveApplicationVm.RINApplications.length; index++) {
                retreiveApplicationVm.RINApplications[index].moduleName = "RIN";
                retreiveApplicationVm.RINApplications[index].date = new Date(retreiveApplicationVm.RINApplications[index].date);
                for (var subIndex = 0; subIndex < retreiveApplicationVm.wcmRINProducts.plans.length; subIndex++) {
                    if (retreiveApplicationVm.RINApplications[index].uin && retreiveApplicationVm.RINApplications[index].uin == retreiveApplicationVm.wcmRINProducts.plans[subIndex].uin) {
                        retreiveApplicationVm.RINApplications[index].imageUrl = retreiveApplicationVm.wcmRINProducts.plans[subIndex].imageUrl;
                        break;
                    }
                }
            }
           //retreiveApplicationVm.applications = retreiveApplicationVm.LIApplications.concat(retreiveApplicationVm.RINApplications);
           
           if(!retreiveApplicationVm.hasLiApplication){
            retreiveApplicationVm.tempapplications = retreiveApplicationVm.LIApplications.concat(retreiveApplicationVm.RINApplications);
            retreiveApplicationVm.applications = retreiveApplicationVm.applications.concat(retreiveApplicationVm.tempapplications);
           }else{
               retreiveApplicationVm.applications = retreiveApplicationVm.applications.concat(retreiveApplicationVm.RINApplications);
           }
        };
        //Function to retreive or track application
        retreiveApplicationVm.retreiveLiApplication = function(application) {
            if (application.proposalNumber && application.paymentStatus) {
                checkProposalStatus(application.proposalNumber);
            } else {
                retreiveApplication(application.applicationNumber);
            }
        };



        function omniChannelRedirection(details) {
            var contentDetail = {
                "id": details,
                "journeyType": "GI"
            }
            generalInsurenceHomeService.redirectForOmni(contentDetail).then(function(detail) {}, function(error) {
                // $state.go('menu.simpleHealthQuestionarie');
                 utilityService.showErrorMessage(error.responseMessage);
            });
        }

         function CheckStartDateRange(applicationNumber,startDate, pageUrl) {
            
            var todaysDate =  generalInsurenceHomeService.getCurrentDate();
            startDate = $filter('startDateWithTimezone')(startDate);
            todaysDate = $filter('startDateWithTimezone')(todaysDate);
            if(new Date(startDate).getTime() >= new Date(todaysDate).getTime()){
                omniChannelRedirection(applicationNumber);
            }else{
                $state.go(pageUrl);
            }
            
        }

        function CheckStartDateRangeArsa(applicationNumber,startDate, pageUrl,savedApplicationArogya) {     
            var todaysDate =  generalInsurenceHomeService.getCurrentDate();
            startDate = $filter('startDateWithTimezone')(startDate);
            todaysDate = $filter('startDateWithTimezone')(todaysDate);
            if(new Date(startDate).getTime() > new Date(todaysDate).getTime()){
                $state.go(pageUrl);
            }else{
               //TO DO Redirect to specific page 
               if(GIconstant.OmniChannel.ArogyaSanjeevani.AP_PREMIUM_1 == savedApplicationArogya.applicationData){
                    $state.go('menu.arsaQuoteCalculation');
               }else if(GIconstant.OmniChannel.ArogyaSanjeevani.AP_PREMIUM_2 == savedApplicationArogya.applicationData){
                    $state.go("menu.arsaMembersDetails");
               }else if(GIconstant.OmniChannel.ArogyaSanjeevani.AP_PREMIUM_RESULT == savedApplicationArogya.applicationData){
                    $state.go("menu.arsaQuoteSummary"); 
               }else if(GIconstant.OmniChannel.ArogyaSanjeevani.AP_PROPOSER_DETAILS == savedApplicationArogya.applicationData){
                    $state.go("menu.arsaProposerDetails"); 
               }else if(GIconstant.OmniChannel.ArogyaSanjeevani.AP_INSURER_DETAILS == savedApplicationArogya.applicationData){
                    $state.go("menu.arsaPolicyHolder"); 
               }else if(GIconstant.OmniChannel.ArogyaSanjeevani.AP_HEALTH_QA == savedApplicationArogya.applicationData){
                    $state.go("menu.arsaMedicalQuestion"); 
               }else if(GIconstant.OmniChannel.ArogyaSanjeevani.AP_NOMINEE_DETAILS == savedApplicationArogya.applicationData){
                    $state.go("menu.arsaNomineeDetails"); 
               }else if(GIconstant.OmniChannel.ArogyaSanjeevani.AP_EINSURNACE == savedApplicationArogya.applicationData){
                    $state.go("menu.arsaEinsurance"); 
               }else{
                   $state.go('menu.arsaQuoteCalculation');
               }
               
            }
        }

        generalInsurenceHomeService.getJourneyMaster().then(function() {

        });

        retreiveApplicationVm.retreiveRINApplication = function(data,trackValue) {
            if(trackValue==1){
                 rrService.termsObj = data;
                 $state.go('menu.rrPenApplication');
            }else{
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    template: "<p class='roboto-regular font-content text-center'>Your application will resume from where you left it.</p>",
                    scope: $scope,
                    buttons: [{
                        text: 'Cancel',
                        type: 'button-negative',
                        onTap: function(e) {
                            return false;
                        }

                    }, {
                        text: 'OK',
                        type: 'button-positive',
                        onTap: function(e) {
                            return true;
                        }
                    }]
                });

            alertPopup.then(function(res) {
                if (res) {
                    retreiveRINApplicationWithSuccess(data);
                }
            });
          }
        }
         function retreiveRINApplicationWithSuccess(data) {
             utilityService.showSpinner();
             var reqParams = {
                "appNo": data.appNo
            }            
             rrService.getApplicationsData(reqParams).then(function (data) {
                        utilityService.hideSpinner();                                                    
                        rrService.saveData= data; 
                        rrService.addRetrive(true);
                        rrService.premiumDetails.totPremAmt = rrService.saveData.application.app.totPremAmt;
                        rrService.premiumDetails.basePremAmt = rrService.saveData.application.app.basePremAmt;
                        rrService.premiumDetails.quoteNo = rrService.saveData.application.app.quoteNo;
                        rrService.premiumDetails.taxAmt = rrService.saveData.application.app.taxAmt;
                        rrService.loanTypeInfo = data.application.app.loanAcType;
                        switch(data.application.app.pageNo) {
                            case "1":
                                $state.go('menu.rrPersonalDetails');
                                break;
                            case "2":
                                 $state.go('menu.rrNomioneeDetails');
                                break;
                            case "3":
                                $state.go('menu.rinQuestionsAns');
                                break;
                            case "4":
                               $state.go('menu.rrReviewDetails');
                                break;
                            case "5":
                                 $state.go('menu.rrPaymantDetails');
                                break;
                               
                        }                                    
                        //$state.go('menu.rrNomioneeDetails');
                    }, function (error) {
                        utilityService.hideSpinner();
                        utilityService.showErrorMessage(error.responseMessage);
                        //$state.go('menu.rrPersonalDetails');
                    });

         }
        retreiveApplicationVm.retreiveGIApplication = function(data) {
            var alertPopup = $ionicPopup.alert({
                title: '',
                template: "<p class='roboto-regular font-content text-center'>Your application will resume from where you left</p>",
                scope: $scope,
                buttons: [{
                    text: 'Cancel',
                    type: 'button-negative',
                    onTap: function(e) {
                        return false;
                    }

                }, {
                    text: 'OK',
                    type: 'button-positive',
                    onTap: function(e) {
                        return true;
                    }
                }]
            });
            alertPopup.then(function(res) {
                if (res) {
                    // Validate Policy Purchase API
                    if(data.uin == '44'){
                        generalInsurenceAccidentService.paiValidatePolicyPurchase().then(function(response) {
                            if(response.data.isAllowed){
                                retreiveGIApplicationWithSucess(data);
                            }
                            else{
                                $scope.paiErrorTitle = response.data.errorTitle;
                                $scope.paiErrorFooter = response.data.errorFooter;
                                $scope.paiErrorDescription = response.data.errorDescription;
                                retreiveApplicationVm.popUp = $ionicPopup.show({
                                    title: '',
                                    cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll yonoWeableBackdrop',
                                    templateUrl: 'pages/generalInsurance/common/paiErrorMessagePopup.html',
                                    scope: $scope
                                });
                            }
                        },function(error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    }
                    else{
                        retreiveGIApplicationWithSucess(data);
                    }
                }
            });
        }


        function retreiveGIApplicationWithSucess(data) {
            var createdDate;
            if(data.timeStamp){
                   createdDate = $filter('timeStampToDate')(data.timeStamp);
                   createdDate = $filter('startDateWithTimezone')(createdDate);
            }
            generalInsurenceHomeService.setpolicyCreatedDate(createdDate);
            var applicationNumber;
            if (data) {
                applicationNumber = data.applicationNumber;

                generalInsurenceHealthService.setSaveApplicationCriticalResponse(data);
                generalInsurenceHealthService.setSaveApplicationArogyaResponse(data);
                var detail = {
                    "applicationNumber": data.applicationNumber,
                    "uin" : data.uin
                }
                generalInsurenceHomeService.setQuoteNumber(data.quoteNumber);
                generalInsurenceHomeService.setapplicationNumber(data.applicationNumber);
                generalInsurenceHomeService.getSavedApplicationForAPI(detail).then(function(response) {
                    if (response) {
                        if (response.sumInsured) {
                            generalInsurenceHomeService.setpolicySumInsured(response.sumInsured);
                        }
                        if (response.policyStartDate) {
                            generalInsurenceHomeService.setpolicyStartdate(response.policyStartDate);
                        }

                        if (generalInsurenceHomeService.isJson(response.quoteData)) {
                            response.quoteData = JSON.parse(response.quoteData);
                        }
                        if (generalInsurenceHomeService.isJson(response.applicationData)) {
                            response.applicationData = JSON.parse(response.applicationData);
                        }

                        savedApplication = response;
                        var detailForProduct = {
                            uin: response.uin
                        }
                        var planDetail = {
                            productCode: response.productCode,
                            planName: response.planName
                        }
                        generalInsurenceHomeService.setPlanDetail(planDetail);


                        generalInsurenceHomeService.setProductDetail(detailForProduct);


                        switch (response.uin) {

                            case GIconstant.common.longTermHome:
                                generalInsurenceHomeDetailService.getLongTermMasters().then(function(master) {
                                    if (master) {
                                        generalInsurenceHomeDetailService.setMasterDetail(master);
                                        generalInsurenceHomeDetailService.setSavedData(savedApplication);
                                        generalInsurenceHomeDetailService.assignvalueForHome();
                                        if (data.applicationNumber) {

                                            if(response.policyStartDate){
                                                CheckStartDateRange(data.applicationNumber,response.policyStartDate,'menu.homeQuotePolicyInfo')
                                            }else{
                                                $state.go('menu.homeQuotePolicyInfo');
                                            }
                                            //omniChannelRedirection(data.applicationNumber, GIconstant.common.longTermHome);
                                            //$state.go('menu.homeQuotePolicyInfo');
                                        } else {
                                            //$state.go('menu.homeQuotePolicyInfo');
                                        }

                                    }
                                }, function(error) {
                                    utilityService.showErrorMessage(error.responseMessage);
                                });
                                break;

                            case GIconstant.common.motorTwo:
                                generalInsurenceMotorService.getMICommonMasters().then(function(master) {
                                    if (master) {

                                        generalInsurenceMotorService.setMIcommonMaster(master);
                                        generalInsurenceMotorService.setSavedData(savedApplication);
                                        generalInsurenceMotorService.assignvalueForMotor();

                                        if (data.applicationNumber) {

                                            var motorType  = generalInsurenceMotorService.getMotorTypeDetail();
                                            var redirectUrl;
                                            if(motorType == 'new'){
                                                 redirectUrl = "menu.motorNewCarGetCarInfo";
                                            }else{
                                                redirectUrl = "menu.motorCarInsuredWithOtherCompany";
                                            }
                                            if(response.policyStartDate){
                                                CheckStartDateRange(data.applicationNumber,response.policyStartDate,redirectUrl)
                                            }else{
                                                $state.go(redirectUrl);
                                            }
                                            //CheckStartDateRange(data.applicationNumber,response.policyStartDate,'menu.homeQuotePolicyInfo')
                                           // omniChannelRedirection(data.applicationNumber);
                                            // omniChannelRedirection(response.applicationData);
                                            //$state.go('menu.motorCarInsuredWithOtherCompany');
                                        } else {
                                            //$state.go('menu.motorCarInsuredWithOtherCompany');
                                        }
                                    }
                                }, function(error) {
                                    utilityService.showErrorMessage(error.responseMessage);
                                });
                                break;
                            case GIconstant.common.motorFour:
                                generalInsurenceMotorService.getMICommonMasters().then(function(master) {
                                    if (master) {

                                        generalInsurenceMotorService.setMIcommonMaster(master);
                                        generalInsurenceMotorService.setSavedData(savedApplication);
                                        generalInsurenceMotorService.assignvalueForMotor();

                                        if (data.applicationNumber) {
                                            var motorType  = generalInsurenceMotorService.getMotorTypeDetail();
                                            var redirectUrl;
                                            if(motorType == 'new'){
                                                 redirectUrl = "menu.motorNewCarGetCarInfo";
                                            }else{
                                                redirectUrl = "menu.motorCarInsuredWithOtherCompany";
                                            }
                                            if(response.policyStartDate){
                                                CheckStartDateRange(data.applicationNumber,response.policyStartDate,redirectUrl)
                                            }else{
                                                $state.go(redirectUrl);
                                            }
                                            //omniChannelRedirection(data.applicationNumber);
                                            // omniChannelRedirection(response.applicationData);
                                            //$state.go('menu.motorCarInsuredWithOtherCompany');
                                        } else {
                                            $state.go('menu.motorCarInsuredWithOtherCompany');
                                        }
                                    }
                                }, function(error) {
                                    utilityService.showErrorMessage(error.responseMessage);
                                });
                                break;
                            case GIconstant.common.TravelInsurance:
                                generalInsurenceTravelService.getTravelMaster().then(function(master) {
                                    if (master) {
                                        generalInsurenceTravelService.setTravelMasterDetail(master);
                                        generalInsurenceTravelService.setSavedData(savedApplication);
                                        generalInsurenceTravelService.assignvalueForTravel();
                                        if (data.applicationNumber) {
                                            if(response.policyStartDate){
                                                CheckStartDateRange(data.applicationNumber,response.policyStartDate,'menu.travelQuotePolicyInfo')
                                            }else{
                                                $state.go('menu.travelQuotePolicyInfo');
                                            }
                                            //omniChannelRedirection(data.applicationNumber, GIconstant.common.TravelInsurance);
                                            //$state.go('menu.travelQuotePolicyInfo');
                                        } else {
                                            $state.go('menu.travelQuotePolicyInfo');
                                        }
                                    }
                                }, function(error) {
                                    utilityService.showErrorMessage(error.responseMessage);
                                });
                                break;

                            case GIconstant.common.simpleHealth:
                                generalInsurenceHealthService.getSimpleMaster().then(function(master) {

                                generalInsurenceHealthService.setSimpleMasterList(master);
                                savedApplication.applicationNumber = data.applicationNumber;
                                generalInsurenceHomeService.setSaveApplicationHealthStructure(savedApplication);
                                generalInsurenceHealthService.assignvalueForSimple();
                                if (data.applicationNumber) {

                                    if(response.policyStartDate){
                                                CheckStartDateRange(data.applicationNumber,response.policyStartDate,'menu.simpleHealthPremiumCalulation')
                                    }else{
                                                $state.go('menu.simpleHealthPremiumCalulation');
                                    }

                                    //omniChannelRedirection(data.applicationNumber, GIconstant.common.arogysPremier);
                                    //$state.go('menu.accidentQuoteMemberInfo');
                                }
                                 }, function(error) {
                                        utilityService.showErrorMessage(error.responseMessage);
                                });
                                break;

                            case GIconstant.common.arogyaSanjeevani:
                                 generalInsurenceHealthService.getArogyaMaster().then(function(master) {
                                    generalInsurenceHealthService.setArogyaMasterList(master);
                                    savedApplication.applicationNumber = data.applicationNumber;
                                    arogyaSanjeevaniService.setSaveApplicationArogyaStructure(savedApplication);
                                    arogyaSanjeevaniService.setSaveApplicationArogyaResponse(savedApplication);
                                    arogyaSanjeevaniService.assignvalueForArogyaSanjeevani();
                                    if (data.applicationNumber) {
                                        if(response.policyStartDate){
                                            CheckStartDateRangeArsa(data.applicationNumber,response.policyStartDate,'menu.arsaQuoteCalculation',savedApplication);
                                        }else{
                                            $state.go('menu.arsaQuoteCalculation');
                                        }
                                    }
                                }, function(error) {
                                        utilityService.showErrorMessage(error.responseMessage);
                                });
                                break;

                            case GIconstant.common.arogysPremier:
                              generalInsurenceHealthService.getArogyaMaster().then(function(master) {
                                generalInsurenceHealthService.setArogyaMasterList(master);
                                savedApplication.applicationNumber = data.applicationNumber;
                                generalInsurenceHomeService.setSaveApplicationArogyaStructure(savedApplication);
                                generalInsurenceHealthService.setSaveApplicationArogyaResponse(savedApplication);
                                generalInsurenceHealthService.assignvalueForArogya();
                                if (data.applicationNumber) {

                                    if(response.policyStartDate){
                                                CheckStartDateRange(data.applicationNumber,response.policyStartDate,'menu.simpleHealthPremiumCalulation')
                                    }else{
                                                $state.go('menu.simpleHealthPremiumCalulation');
                                    }
                                    //omniChannelRedirection(data.applicationNumber, GIconstant.common.arogysPremier);
                                    //$state.go('menu.accidentQuoteMemberInfo');
                                }
                                }, function(error) {
                                        utilityService.showErrorMessage(error.responseMessage);
                                });
                                break;

                            case GIconstant.common.criticalIllness:
                             generalInsurenceHealthService.getCriticalMaster().then(function(master) {
                                generalInsurenceHealthService.setCriticalMasterList(master);
                                savedApplication.applicationNumber = data.applicationNumber;
                                generalInsurenceHomeService.setSaveApplicationCriticalStructure(savedApplication);
                                generalInsurenceHealthService.setSaveApplicationCriticalResponse(savedApplication);
                                generalInsurenceHealthService.assignvalueForCritical();
                                if (data.applicationNumber) {
                                    if(response.policyStartDate){
                                                CheckStartDateRange(data.applicationNumber,response.policyStartDate,'menu.criticalIlnessPremiumCalulation')
                                    }else{
                                                $state.go('menu.criticalIlnessPremiumCalulation');
                                    }
                                    //omniChannelRedirection(data.applicationNumber, GIconstant.common.arogysPremier);
                                    //$state.go('menu.accidentQuoteMemberInfo');
                                }
                                }, function(error) {
                                        utilityService.showErrorMessage(error.responseMessage);
                                }); 
                                break;

                            case GIconstant.common.hospitaldailycash:
                             generalInsurenceHealthService.getHDCMaster().then(function(master) {
                                generalInsurenceHealthService.setHDCMasterList(master);
                                savedApplication.applicationNumber = data.applicationNumber;
                                generalInsurenceHomeService.setSaveApplicationHDCStructure(savedApplication);
                                generalInsurenceHealthService.setSaveApplicationHDCResponse(savedApplication);
                                generalInsurenceHealthService.assignvalueForHDC();
                                if (data.applicationNumber) {
                                    if(response.policyStartDate){
                                                CheckStartDateRange(data.applicationNumber,response.policyStartDate,'menu.hospitalDailyCashPremiumCalculation')
                                    }else{
                                                $state.go('menu.hospitalDailyCashPremiumCalculation');
                                    }
                                    //omniChannelRedirection(data.applicationNumber, GIconstant.common.arogysPremier);
                                    //$state.go('menu.accidentQuoteMemberInfo');
                                }
                                }, function(error) {
                                        utilityService.showErrorMessage(error.responseMessage);
                                });
                                break;
                            case GIconstant.common.PAI:
                                generalInsurenceAccidentService.getPersonalAccidentMasters().then(function(master) {
                                    if (master) {
                                        generalInsurenceAccidentService.setMasterData(master);
                                        generalInsurenceAccidentService.setSavedData(savedApplication);
                                        generalInsurenceAccidentService.assignvalueForPAI();
                                        if (data.applicationNumber) {
                                            if(response.policyStartDate){
                                                CheckStartDateRange(data.applicationNumber,response.policyStartDate,'menu.accidentQuoteMemberInfo')
                                            }else{
                                                        $state.go('menu.accidentQuoteMemberInfo');
                                            }
                                                    //omniChannelRedirection(data.applicationNumber, GIconstant.common.PAI);
                                            //$state.go('menu.accidentQuoteMemberInfo');
                                        } else {
                                            $state.go('menu.accidentQuoteMemberInfo');
                                        }
                                    }
                                }, function(error) {
                                    utilityService.showErrorMessage(error.responseMessage);
                                });
                                break;


                        }








                    }
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        };




        //Function to Check proposal status
        function checkProposalStatus(number) {
            var req = {
                "proposalNo": number
            };
            lifeInsuranceCommonService.checkProposalStatus(req).then(function(data) {
                showProposalStatus(data.status);
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        };

        //Function to show proposal status
        function showProposalStatus(status) {
            var title = '';
            var template = '<p class="roboto-regular font-content">' + status + '</p>';
            var onTap = '';
            var buttontext = "<b>OK</b>";
            utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
        };

        //Funcction to retreive the application
        function retreiveApplication(application) {
            var req = {};
            req.applicationNumber = application;
            lifeInsuranceApplicationService.setApplicationNumber(req.applicationNumber);
            lifeInsuranceCommonService.setIsFromRetrieveApplication(true);
            lifeInsuranceCommonService.getSavedApplication(req).then(function(data) {}, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        };

        //Function to remove application from local
        retreiveApplicationVm.removeLiApplication = function(application) {
            var alertPopup = $ionicPopup.alert({
                title: '',
                template: "<p class='roboto-regular font-content text-center'>Are you sure want to remove the pending application ?</p>",
                scope: $scope,
                buttons: [{
                    text: 'Cancel',
                    type: 'button-negative',
                    onTap: function(e) {
                        return false;
                    }

                }, {
                    text: 'Remove',
                    type: 'button-positive',
                    onTap: function(e) {
                        return true;
                    }
                }]
            });
            alertPopup.then(function(res) {
                if (res) {
                    var req = {};
                    req.applicationNumber = application.applicationNumber;
                    lifeInsuranceCommonService.removeSavedApplication(req).then(function(data) {
                        var index = retreiveApplicationVm.applications.indexOf(application);
                        retreiveApplicationVm.applications.splice(index, 1);
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }
            });
        };

        //Function to remove application from local
        retreiveApplicationVm.removeGiApplication = function(application) {


            var alertPopup = $ionicPopup.alert({
                title: '',
                template: "<p class='roboto-regular font-content text-center'>Are you sure want to remove the pending application ?</p>",
                scope: $scope,
                buttons: [{
                    text: 'Cancel',
                    type: 'button-negative',
                    onTap: function(e) {
                        return false;
                    }

                }, {
                    text: 'Remove',
                    type: 'button-positive',
                    onTap: function(e) {
                        return true;
                    }
                }]
            });
            alertPopup.then(function(res) {
                if (res) {
                   var req = {};
                    req.applicationNumber = application.applicationNumber;
                    generalInsurenceHomeDetailService.deleteApplication(req,true).then(function(giData) {
                        var index = retreiveApplicationVm.applications.indexOf(application);
                        retreiveApplicationVm.applications.splice(index, 1);
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }
            });

            
            
        };

        //Function to remove application from local RinRaksha
        retreiveApplicationVm.removeRinApplication = function(application) {
            var alertPopup = $ionicPopup.alert({
                title: '',
                template: "<p class='roboto-regular font-content text-center'>Are you sure want to remove the pending application ?</p>",
                scope: $scope,
                buttons: [{
                    text: 'Cancel',
                    type: 'button-negative',
                    onTap: function(e) {
                        return false;
                    }

                }, {
                    text: 'Remove',
                    type: 'button-positive',
                    onTap: function(e) {
                        return true;
                    }
                }]
            });
            alertPopup.then(function(res) {
                if (res) {
                   var req = {};                                         
                    req.appNo = application.appNo;
                    rrService.deleteRinApplication(req,true).then(function(rinData) {
                        var index = retreiveApplicationVm.applications.indexOf(application);
                        retreiveApplicationVm.applications.splice(index, 1);
                        rrService.saveData = {};
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }
            });

            
            
        };

    }
]);
