angularApp.service('sampoornSurakshaService',["$q","AdapterUtils","$filter","$ionicPopup","lifeInsuranceConfig",
	function($q,AdapterUtils,$filter,$ionicPopup,lifeInsuranceConfig){
    
    var sampoornSurakshaService = this;

    var policyDetails,premiumDetails,buttonVisible,formDetails,successResponse,questions,ssPolicyDetails,medicalInfo,renewalDetails,isRenewalSuccess,activeCategory;

    sampoornSurakshaService.renewalRequest = {};
    sampoornSurakshaService.isFromPapl = false;

    sampoornSurakshaService.clearAll = function(){
        medicalInfo = null,premiumDetails = null, formDetails = null,renewalDetails = null,isRenewalSuccess = null,activeCategory = null;
        sampoornSurakshaService.renewalRequest = {};
    }

    
    sampoornSurakshaService.genericError = "<div class='ss-error-header font-reg'>Oops!</div>"+
                                            "<div class='ss-p-t-48 font-reg font-size-16 ss-placholer-color fss-col-verify fontWeight600'>"+
                                                "<div>We are unable to provide you this cover.</div>"+
                                                "<div> Let us help you explore our other plans which are better suited to you.</div>"+
                                            "</div>";
                                            
    sampoornSurakshaService.displayPopUp = function(heading,message,buttonText,callBack){
        var alertPopup = $ionicPopup.alert({
            title: heading,
            template: '<div class="popupTextBottomPadding ss-p-r-f-8 ss-popup-list font-size-12 font-light ss-text-color">'
            + message + '</div></div>',
            cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite ss-popup',
            buttons: [
                {
                    text: buttonText,
                    onTap: function(e) {
                        callBack();
                    }
                }
            ],
        });
    };

    sampoornSurakshaService.findObject = function(key,list) {
		var obj = {};
		for (var count = 0; count < list.length; count++) {
			if (list[count]["key"].toLowerCase() == key.toLowerCase()) {
				return list[count];
			}
		}
		return obj;
	}

    sampoornSurakshaService.displayErrorPopUp = function(heading,message,buttonText,button1,button2){
        var alertPopup = $ionicPopup.alert({
            title: heading,
            template: '<div class="padTop20 font-dark-grey"></div><div class="popupTextBottomPadding fontSize-subHeading p-20 fss-common-ul-list">'
            + message + '</div></div>',
            cssClass: 'removePopup-head popupWidth90 popupMargin ftpopup-body popupBackgroundWhite ss-medical-page',
            buttons: [
                {
                    text: buttonText[0],
                    onTap: function(e) {
                        button1();
                    }
                },
                {
                    text: buttonText[1],
                    onTap: function(e) {
                        button2();
                    }
                }
            ],
        });
    };

    sampoornSurakshaService.setMedicalInfo = function(info) {
	    medicalInfo = info;
	};

    sampoornSurakshaService.getMedicalInfo = function() {
        return medicalInfo;
    };

    sampoornSurakshaService.setSSPolicyDetails = function(details) {
	    ssPolicyDetails = details;
	};

    sampoornSurakshaService.getSSPolicyDetails = function() {
        return ssPolicyDetails;
    };

    sampoornSurakshaService.setQuestions = function(ques) {
	    questions = ques;
	};

    sampoornSurakshaService.getQuestions = function() {
        return questions;
    };

    sampoornSurakshaService.setFinalResponse = function(res) {
	    successResponse = res;
	};

    
    sampoornSurakshaService.getRenewalDetails = function() {
        return renewalDetails;
    };

    sampoornSurakshaService.setRenewalDetails = function(res) {
	    renewalDetails = res;
	};

    sampoornSurakshaService.getFinalResponse = function() {
        return successResponse;
    };

    sampoornSurakshaService.setPolicyDetails = function(policy) {
	    policyDetails = policy;
	};

    sampoornSurakshaService.getPolicyDetails = function() {
        return policyDetails;
    };

    sampoornSurakshaService.setFormDetails = function(form) {
	    formDetails = form;
	};

    sampoornSurakshaService.getFormDetails = function() {
        return formDetails;
    };

    sampoornSurakshaService.setBuyNow = function(buyNow) {
	    buttonVisible = buyNow;
	};

    sampoornSurakshaService.getBuyNow = function() {
        return buttonVisible;
    };

    sampoornSurakshaService.setActiveCategory = function(category) {
	    activeCategory = category;
	};

    sampoornSurakshaService.getActiveCategory = function() {
        return activeCategory;
    };
    sampoornSurakshaService.setPremiumDetails = function(premium) {
	    premiumDetails = premium;
	};

    sampoornSurakshaService.getPremiumDetails = function() {
        return premiumDetails;
    };
    //Added following service to get covid popup content : Part of Medical Questionarie
    sampoornSurakshaService.getCovidPopupContent = function() {
        var q = $q.defer();
        AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getCovidHistoryWcmContent[0], {}, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    sampoornSurakshaService.getMedicalDiagnosis = function() {
        var q = $q.defer();
        AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getMedicalDiagnosis[0], {}, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    sampoornSurakshaService.getAutoRenewal = function() {
        var q = $q.defer();
        AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getAutoRenewal[0], {}, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    sampoornSurakshaService.checkCustomerStatus = function() {
        var q = $q.defer();
        AdapterUtils.postData(lifeInsuranceConfig.adapterURL.checkCustomerStatus[0], {}, false).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    sampoornSurakshaService.checkCustomerStatusPAPL = function(request) {
        var q = $q.defer();
        AdapterUtils.postData(lifeInsuranceConfig.adapterURL.checkCustomerStatus[0], request, false).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };
    
    sampoornSurakshaService.getPremiumAndNomineeInfo = function() {
        var q = $q.defer();
        AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getPremiumAndNomineeInfo[0], {}, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    sampoornSurakshaService.getPolicyFeatures = function() {
        var q = $q.defer();
        AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getPolicyFeatures[0], {}, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    sampoornSurakshaService.getCustomerDeclaration = function() {
        var q = $q.defer();
        AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getCustomerDeclaration[0], {}, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    sampoornSurakshaService.getDocument = function(payLoad) {
        var q = $q.defer();
        AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getDocument[0], payLoad, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    sampoornSurakshaService.getCurrentPolicyDocument = function(payLoad) {
        var q = $q.defer();
        AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getCurrentPolicyDocument[0], payLoad, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    sampoornSurakshaService.getTermsAndConditions = function() {
        var q = $q.defer();
        AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getTermsAndConditions[0], {}, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    }; 

    sampoornSurakshaService.getOTPDeclaration = function() {
        var q = $q.defer();
        AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getOTPDeclaration[0], {}, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    sampoornSurakshaService.ssValidateOTP = function(payLoad) {
        var q = $q.defer();
        AdapterUtils.postData(lifeInsuranceConfig.adapterURL.ssValidateOTP[0], payLoad, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    sampoornSurakshaService.createPolicy = function(payLoad) {
        var q = $q.defer();
        AdapterUtils.postData(lifeInsuranceConfig.adapterURL.createPolicy[0], payLoad, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    sampoornSurakshaService.getSsPolicyDetails = function() {
        var q = $q.defer();
        AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getSsPolicyDetails[0], {}, false).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

     sampoornSurakshaService.getAllInsuranceProducts = function() {
        var q = $q.defer();
        AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getAllInsuranceProducts[0], {}, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    sampoornSurakshaService.getSchemeDetails = function() {
        var q = $q.defer();
        AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getSchemeDetails[0], {}, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    sampoornSurakshaService.getFundTransferAccounts = function(payload) {
        var q = $q.defer();
        AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getFundTransferAccounts[0], payload, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    sampoornSurakshaService.getBaseEmail = function() {
        var q = $q.defer();
        AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getBaseEmail[0], {}, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

   sampoornSurakshaService.getOTPToken = function() {
        var q = $q.defer();
        AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getOTPTokenSS[0], {}, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };
        
     sampoornSurakshaService.getSwarnaGangaUrl = function() {
        var q = $q.defer();
        AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getSwarnaGangaUrl[0], {}, false).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };
     sampoornSurakshaService.loadSwarnaGangaWCMContent = function() {
        var q = $q.defer();
        AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getSwarnaGangaWCMContent[0], {}, false).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    sampoornSurakshaService.scheduleRenewalPayment = function(payload) {
        var q = $q.defer();
        AdapterUtils.postData(lifeInsuranceConfig.adapterURL.scheduleRenewalPayment[0], payload, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    sampoornSurakshaService.generateSSRenewOTP = function(payLoad) {
        var q = $q.defer();
        AdapterUtils.postData(lifeInsuranceConfig.adapterURL.generateSSRenewOTP[0], payLoad, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    sampoornSurakshaService.validateOTPForRenew = function(payLoad) {
        var q = $q.defer();
        AdapterUtils.postData(lifeInsuranceConfig.adapterURL.validateOTPForRenew[0], payLoad, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    sampoornSurakshaService.formPopUpTemplate = function(array,controllerName){
        var template = '<div class="font-dark-grey irctc">'+
                '<div ng-repeat="acc in '+ array + ' track by $index">'+
                    '<div class="row  borderbtm" ng-click="'+controllerName + '.close($index)">'+
                    '<div class="col padtop10 font-size-20 roboto-regular color545454">&#8377; {{acc.accountBalance |INR}}</div>'+
                    '<div class="col padTopBTM30 font-size-12 roboto-medium color545454">{{acc.accountType}}<br><span class="font-size-14 roboto-medium color545454">{{acc.accountNumber}}</span></div>'+
                    '</div></div></div>';
        return template;
    }
	return sampoornSurakshaService;

}]);
    
