angularApp.controller('ssMedicalInformationController', [
    "$state", 
    "$scope", 
    "validateService",
    "utilityService",
    "sampoornSurakshaService",
    "$filter","clickStreamService",
    function($state, 
        $scope, 
        validateService,
        utilityService,
        sampoornSurakshaService,
        $filter,clickStreamService) {


        var ssMedicalInformationVm = this;

        function initPage() {
            ssMedicalInformationVm.validateService = validateService;
            ssMedicalInformationVm.ssQuestion = sampoornSurakshaService.getQuestions() ? sampoornSurakshaService.getQuestions() : [];
            ssMedicalInformationVm.toggleAnswerMed = [];
            ssMedicalInformationVm.toggleAnswerApp = [];
            ssMedicalInformationVm.ssMedicalQuestion = [];
            ssMedicalInformationVm.ssAppQuestion = [];
            for(var i=0 ; i < ssMedicalInformationVm.ssQuestion.length ; i++){
                if(ssMedicalInformationVm.ssQuestion[i].qtype == "medical"){
                    ssMedicalInformationVm.ssMedicalQuestion.push(ssMedicalInformationVm.ssQuestion[i]);
                    ssMedicalInformationVm.toggleAnswerMed.push(null);
                }else if(ssMedicalInformationVm.ssQuestion[i].qtype == "application"){
                    ssMedicalInformationVm.ssAppQuestion.push(ssMedicalInformationVm.ssQuestion[i]);
                    ssMedicalInformationVm.toggleAnswerApp.push(null);
                }
            }

            if(sampoornSurakshaService.getMedicalInfo()){
                ssMedicalInformationVm.kgs = sampoornSurakshaService.getMedicalInfo().kgs;
                ssMedicalInformationVm.feet = sampoornSurakshaService.getMedicalInfo().feet;
                ssMedicalInformationVm.inch = sampoornSurakshaService.getMedicalInfo().inch;
                for(var i= 0 ; i<ssMedicalInformationVm.toggleAnswerMed.length ; i++){
                    ssMedicalInformationVm.toggleAnswerMed[i] = false; 
                }
                for(var i= 0 ; i<ssMedicalInformationVm.toggleAnswerApp.length ; i++){
                    ssMedicalInformationVm.toggleAnswerApp[i] = false;       
                }
            }

        }

        
        ssMedicalInformationVm.clearErrObj = function(){
            ssMedicalInformationVm.errObj = {};
        }
        //Added this function to show covid history popup
        ssMedicalInformationVm.onToggleChange = function(index){
            if(index==3 && ssMedicalInformationVm.toggleAnswerMed[index] == false){
                 sampoornSurakshaService.getCovidPopupContent().then(function(data) {
                 var title = "Covid History <br/> <span class='covidPopup'>I hereby confirm that</span>";
                var buttontext = "I Agree";
                var detail = data;
                sampoornSurakshaService.displayPopUp(title, detail, buttontext,function(){});
            },function(error){
                utilityService.showErrorMessage(error.responseMessage);
            });
            }
        }

        ssMedicalInformationVm.validatePage = function(){
            ssMedicalInformationVm.errObj = {};
            ssMedicalInformationVm.errObj.toggleAnswerMed =[];
            ssMedicalInformationVm.errObj.toggleAnswerApp =[];
            if(validateService.isValidHeight(ssMedicalInformationVm.feet)){
                ssMedicalInformationVm.errObj.error = validateService.isValidHeight(ssMedicalInformationVm.feet);
                return false;
            }

            if(ssMedicalInformationVm.inch == "" || ssMedicalInformationVm.inch == undefined){
                ssMedicalInformationVm.errObj.error = "Please enter inches";
                return false;
            }
            if(ssMedicalInformationVm.heightErrorMsg){
                return false;
            }

            if(validateService.isValidWeight(ssMedicalInformationVm.kgs)){
                ssMedicalInformationVm.errObj.error = validateService.isValidWeight(ssMedicalInformationVm.kgs);
                return false;
            }

            for(var i= 0 ; i<ssMedicalInformationVm.toggleAnswerMed.length ; i++){
                if(ssMedicalInformationVm.toggleAnswerMed[i] == null || ssMedicalInformationVm.toggleAnswerMed[i] == undefined){
                    ssMedicalInformationVm.errObj.toggleAnswerMed[i] = "Click yes or no";
                    return false;
                }
                
            }

           for(var i= 0 ; i<ssMedicalInformationVm.toggleAnswerApp.length ; i++){
                if(ssMedicalInformationVm.toggleAnswerApp[i] == null || ssMedicalInformationVm.toggleAnswerApp[i] == undefined){
                    ssMedicalInformationVm.errObj.toggleAnswerApp[i] = "Click yes or no";
                    return false;
                }
                
            }

            
            for(var i= 0 ; i<ssMedicalInformationVm.toggleAnswerApp.length ; i++){
                if(ssMedicalInformationVm.toggleAnswerApp[i]){
                    sampoornSurakshaService.displayErrorPopUp("",sampoornSurakshaService.genericError,["Back","Proceed"],function(){
                    },function(){
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "PROCEED_BTN"));
                        $state.go('menu.generalInsurance');
                    });
                    return false;
                }
            }

            for(var i= 0 ; i<ssMedicalInformationVm.toggleAnswerMed.length ; i++){
                if(ssMedicalInformationVm.toggleAnswerMed[i]){
                    sampoornSurakshaService.displayErrorPopUp("",sampoornSurakshaService.genericError,["Back","Proceed"],function(){
                    },function(){
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "PROCEED_BTN"));
                        $state.go('menu.generalInsurance');
                    });
                    return false;
                }
            }
            
            return true
        }


        ssMedicalInformationVm.setMaxInch = function(){
            if(ssMedicalInformationVm.inch == "00"){
                ssMedicalInformationVm.inch = "0";
            }
        }

        ssMedicalInformationVm.viewDetails = function(){
            sampoornSurakshaService.getMedicalDiagnosis().then(function(data) {
                 var title = "Medical Diagnosis";
                var buttontext = "OK";
                var detail = data;
                sampoornSurakshaService.displayPopUp(title, detail, buttontext,function(){});
            },function(error){
                utilityService.showErrorMessage(error.responseMessage);
            });
          
        }


        ssMedicalInformationVm.calculateBmi = function(){
            ssMedicalInformationVm.totalFeet = parseInt(ssMedicalInformationVm.feet) + (parseFloat(ssMedicalInformationVm.inch*0.083333));
            ssMedicalInformationVm.heightInMeters = ssMedicalInformationVm.totalFeet/3.2808;
            ssMedicalInformationVm.bmi = ssMedicalInformationVm.kgs / (ssMedicalInformationVm.heightInMeters*ssMedicalInformationVm.heightInMeters);
            if(ssMedicalInformationVm.bmi < sampoornSurakshaService.getPremiumDetails().minBmi || ssMedicalInformationVm.bmi > sampoornSurakshaService.getPremiumDetails().maxBmi){
                sampoornSurakshaService.displayErrorPopUp("",sampoornSurakshaService.genericError,["Back","Proceed"],function(){

                },function(){
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "PROCEED_BTN"));
                    $state.go('menu.generalInsurance');
                });
                return false;
            }
            return true;
        }

        ssMedicalInformationVm.goBack = function(){
            $state.go('menu.ssPremiumCalculation');
        }

        ssMedicalInformationVm.goToNextPage = function(){
            if(ssMedicalInformationVm.validatePage()){
                if(ssMedicalInformationVm.calculateBmi()){
                    var request = {
                        "amount" : sampoornSurakshaService.getFormDetails().sumAssured
                    }
                    sampoornSurakshaService.getFundTransferAccounts(request).then(function(data) {
                        var formDetails = sampoornSurakshaService.getFormDetails();
                        formDetails.height = ssMedicalInformationVm.heightInMeters * 100;
                        formDetails.weight = ssMedicalInformationVm.kgs;
                        var pageDetails = sampoornSurakshaService.getPremiumDetails();
                        pageDetails.basePremium = data.basePremium;
                        pageDetails.grossPremiumForPayment = data.grossPremium;
                        pageDetails.gst = data.gst;
                        pageDetails.accList = data.accList;
                        sampoornSurakshaService.setPremiumDetails(pageDetails);
                        var medicalPageDetails = {};
                        medicalPageDetails.kgs = ssMedicalInformationVm.kgs;
                        medicalPageDetails.feet = ssMedicalInformationVm.feet;
                        medicalPageDetails.inch = ssMedicalInformationVm.inch;
                        sampoornSurakshaService.setMedicalInfo(medicalPageDetails);
                        sampoornSurakshaService.setFormDetails(formDetails);
                        $state.go('menu.ssPayment');
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }
            }

             
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
