angularApp.controller('ssPaymentController', [
    "$state", 
    "$scope", 
    "validateService",
    "utilityService",
    "sampoornSurakshaService",
    "$filter","getAccountDetailsService",
    "lifeInsuranceBasicApplicationService","customerInfoService",
    function($state, 
        $scope, 
        validateService,
        utilityService,
        sampoornSurakshaService,
        $filter,getAccountDetailsService,lifeInsuranceBasicApplicationService,customerInfoService) {


        var ssPaymentVm = this;
        ssPaymentVm.validateService = validateService;

        function initPage() {
           ssPaymentVm.autoRenew = true;
           ssPaymentVm.accList = sampoornSurakshaService.getPremiumDetails().accList ? sampoornSurakshaService.getPremiumDetails().accList : [];
           ssPaymentVm.lifeCover = sampoornSurakshaService.getFormDetails().sumAssured;
           ssPaymentVm.quotient = Math.floor(sampoornSurakshaService.getFormDetails().sumAssured/100000);
           ssPaymentVm.basicPremium = sampoornSurakshaService.getPremiumDetails().basePremium;
           ssPaymentVm.gst = sampoornSurakshaService.getPremiumDetails().gst;
           ssPaymentVm.totalPremium = sampoornSurakshaService.getPremiumDetails().grossPremiumForPayment;
        }

        ssPaymentVm.goBack = function(){ 
            $state.go('menu.ssMedicalInformation');
        }

        ssPaymentVm.validate = function(){
            ssPaymentVm.errObj = {}
            if (validateService.isValidAccountNum(ssPaymentVm.selectedAccount)) {
                ssPaymentVm.errObj.accountNumber = validateService.isValidAccountNum(ssPaymentVm.selectedAccount);
            }
            if(ssPaymentVm.referralCodeisValid){
                return false;
            }
            return (angular.equals({}, ssPaymentVm.errObj)) ? true : false;
            
        }

        ssPaymentVm.goToNextPage = function(){
            if(ssPaymentVm.validate()){
                sampoornSurakshaService.getOTPToken().then(function(data) {
                    var formDetails = sampoornSurakshaService.getFormDetails();
                    formDetails.fromAccount = JSON.parse(ssPaymentVm.selectedAccount).accountNumber;
                    formDetails.autoRenewal = ssPaymentVm.autoRenew == true ? 'Y' : 'N';
                    formDetails.branchCode = JSON.parse(ssPaymentVm.selectedAccount).branchCode;
                    formDetails.referralCode = ssPaymentVm.referralCode;
                    sampoornSurakshaService.setFormDetails(formDetails);
                    $state.go('menu.ssPaymentOtp');
                },function(error){
                    utilityService.showErrorMessage(error.responseMessage);
                }); 
            }
        }

        ssPaymentVm.getAutoRenewalTnC = function(){
            sampoornSurakshaService.getAutoRenewal().then(function(data) {
                var title = "Auto Renewal Declaration";
                var buttontext = "OK";
                var detail = data;
                sampoornSurakshaService.displayPopUp(title, detail, buttontext,function(){});
            },function(error){
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        ssPaymentVm.enablePay = function(){
            if(ssPaymentVm.selectedAccount){
                var amount = JSON.parse(ssPaymentVm.selectedAccount);
                if(parseFloat(amount.accountBalance) < parseFloat(ssPaymentVm.totalPremium)){
                    ssPaymentVm.payEnable = false;
                }else{
                    ssPaymentVm.payEnable = true;
                }
            }
        }

        ssPaymentVm.getDeclaration = function(){
            sampoornSurakshaService.getCustomerDeclaration().then(function(data) {
                var title = "Customer Declaration";
                var buttontext = "OK";
                var htmlObject = document.createElement('div');
                htmlObject.innerHTML = data;
                var fragment = document.createDocumentFragment(); 
                fragment.appendChild(htmlObject);
                fragment.getElementById('cusname').innerText = customerInfoService.customer ? customerInfoService.customer.name : "";
                fragment.getElementById('cusmobilenumber').innerText = customerInfoService.customer ? $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4) : "";
                var detail = fragment.firstChild.innerHTML;
                sampoornSurakshaService.displayPopUp(title, detail, buttontext,function(){});
            },function(error){
                utilityService.showErrorMessage(error.responseMessage);
            });            
        }

        ssPaymentVm.getTNC = function(){
            sampoornSurakshaService.getTermsAndConditions().then(function(data) {
                var title = "Terms and Conditions";
                var buttontext = "OK";
                var detail = data;
                sampoornSurakshaService.displayPopUp(title, detail, buttontext,function(){});
            },function(error){
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
        

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
