angularApp.controller('ssPaymentOtpController', [
    "$state", 
    "$scope", 
    "validateService",
    "utilityService","$filter","customerInfoService","sampoornSurakshaService","lifeInsuranceBasicApplicationService","homeScreenService","getAccountDetailsService","generalInsurenceHomeService",
    function($state, 
        $scope, 
        validateService,
        utilityService,$filter,customerInfoService,sampoornSurakshaService,lifeInsuranceBasicApplicationService,homeScreenService,getAccountDetailsService,generalInsurenceHomeService) {


        var ssPaymentOtpVm = this;

        function initPage() {
           ssPaymentOtpVm.mobileNumber = $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4);
           ssPaymentOtpVm.clickCount = 0; 
           ssPaymentOtpVm.isResendOTP = false; 
           ssPaymentOtpVm.isResendDisabled=false; 
           ssPaymentOtpVm.otpCount = 0;  
           ssPaymentOtpVm.isOtpDisabled = false;   
        }

        ssPaymentOtpVm.otpDeclaration = function(){
            sampoornSurakshaService.getOTPDeclaration().then(function(data) {
                var title = "OTP Declaration";
                var buttontext = "OK";
                var detail = $filter('ngBindHtmlFilter')(data);
                sampoornSurakshaService.displayPopUp(title, detail, buttontext,function(){});
            },function(error){
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        ssPaymentOtpVm.validateOTP = function(){
            ssPaymentOtpVm.resetPinOTP = "";
            if(!ssPaymentOtpVm.getOTPNumber){
                ssPaymentOtpVm.resetPinOTP = "Please Enter the OTP";
            }else if(ssPaymentOtpVm.getOTPNumber.length != 6){
                ssPaymentOtpVm.resetPinOTP = "Please enter 6 digits OTP";
            }else{
                ssPaymentOtpVm.isOtpDisabled = true;
                var request = {};
                request.otp = ssPaymentOtpVm.getOTPNumber;
                sampoornSurakshaService.ssValidateOTP(request).then(function(data) {
                    var finalRequest = {
                        "basePremium": sampoornSurakshaService.getPremiumDetails().basePremium,
                        "gst": sampoornSurakshaService.getPremiumDetails().gst,
                        "grossPremium": sampoornSurakshaService.getPremiumDetails().grossPremium,
                        "referralCode" : sampoornSurakshaService.getFormDetails().referralCode ? sampoornSurakshaService.getFormDetails().referralCode : "",
                        "emailId": sampoornSurakshaService.getFormDetails().isEmailMasked == false ? sampoornSurakshaService.getFormDetails().primaryEmailId : "",
                        "height": sampoornSurakshaService.getFormDetails().height,
                        "weight": sampoornSurakshaService.getFormDetails().weight,
                        "medicalIllness": "N",
                        "smokeGreaterThanTen": "N",
                        "proposalDecline": "N",
                        "autoRenewal": sampoornSurakshaService.getFormDetails().autoRenewal,
                        "branchCode": sampoornSurakshaService.getFormDetails().branchCode,
                        "sumAssured": sampoornSurakshaService.getFormDetails().sumAssured,
                        "nomineeName": sampoornSurakshaService.getFormDetails().nomineeName,
                        "nomineeDOB": $filter('ssDateFormat')(sampoornSurakshaService.getFormDetails().nomineeDOB),
                        "relationship": sampoornSurakshaService.getFormDetails().relationship,
                        "amount": sampoornSurakshaService.getFormDetails().amount,
                        "fromAccount": sampoornSurakshaService.getFormDetails().fromAccount,
                        "hospitalizedSevenMoreDays": "N",
                        "covidTestPostiveThreeMonth": "N",
                        "travelledOverseasLastTwoMonth": "N",
                        "covidHistoryConfirmFlag": "Y"
                    }
                    sampoornSurakshaService.createPolicy(finalRequest).then(function(data) {
                        sampoornSurakshaService.setFinalResponse(data);
                        utilityService.setCsatJournies('sampoornSuraksha');
                        if (homeScreenService.offersData && homeScreenService.alertsData) {
                            for(var i = 0;i<homeScreenService.offersData.length; i++){ 
                                if (homeScreenService.offersData[i].category == "SS") {
                                    homeScreenService.offersData.splice(i, 1); 
                                }
                            }
                        }
                        generalInsurenceHomeService.setGIProducts('');
                        getAccountDetailsService.accountOverviewData = '';
                        $state.go('menu.ssPaymentSuccess');
                    },function(error){
                        //utilityService.showErrorMessage(error.responseMessage);
                        if (homeScreenService.offersData && homeScreenService.alertsData) {
                            for(var i = 0;i<homeScreenService.offersData.length; i++){ 
                                if (homeScreenService.offersData[i].category == "SS") {
                                    homeScreenService.offersData.splice(i, 1); 
                                }
                            }
                        }
                        generalInsurenceHomeService.setGIProducts('');
                        getAccountDetailsService.accountOverviewData = '';
                        var title = '';
                        var template = "<p> "+error.responseMessage +" </p>";
                        var onTap = 'menu.homeScreen';
                        var buttontext = "<b>OK</b>";
                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                    }); 
                },function(error){
                    ssPaymentOtpVm.otpCount++;
                    ssPaymentOtpVm.isOtpDisabled = false;
                    if(ssPaymentOtpVm.otpCount >= 3){
                        ssPaymentOtpVm.isOtpDisabled = true;
                        var title = '';
                        var template = "<p> "+error.responseMessage +" </p>";
                        var onTap = 'menu.homeScreen';
                        var buttontext = "<b>OK</b>";
                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                    }else{
                        utilityService.showErrorMessage(error.responseMessage);
                    }
                    
                });
            } 
        }

        ssPaymentOtpVm.resendOTP = function(){
            sampoornSurakshaService.getOTPToken().then(function(data) {
                ssPaymentOtpVm.otpCount = 0;
                ssPaymentOtpVm.isOtpDisabled = false;
            },function(error){
                utilityService.showErrorMessage(error.responseMessage);
            }); 
            ssPaymentOtpVm.clickCount++;
            ssPaymentOtpVm.isResendOTP = true;
            if(ssPaymentOtpVm.clickCount >= 2){
                ssPaymentOtpVm.isResendDisabled = true;
            }
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
