angularApp.controller('ssPaymentRenewalSuccessController', [
    "$state", 
    "$scope", 
    "validateService",
    "utilityService","$filter","customerInfoService","sampoornSurakshaService","irctcService","$ionicPopup","openUrlInAppbroswerService","getAccountDetailsService","constantConfig",
    function($state, 
        $scope, 
        validateService,
        utilityService,$filter,customerInfoService,sampoornSurakshaService,irctcService,$ionicPopup,openUrlInAppbroswerService,getAccountDetailsService,constantConfig) {


        var ssPaymentRenewalSuccessVm = this;

        ssPaymentRenewalSuccessVm.initPage = function() {
           ssPaymentRenewalSuccessVm.emailId = sampoornSurakshaService.getFinalResponse().emailId;
           ssPaymentRenewalSuccessVm.formNumber = sampoornSurakshaService.getFinalResponse().coiNumber;
		   if(getAccountDetailsService.accountOverviewData.sampoornaSurakshaPolicy){
			    for (var i=0; i < getAccountDetailsService.accountOverviewData.sampoornaSurakshaPolicy.length; i++) {
					if (getAccountDetailsService.accountOverviewData.sampoornaSurakshaPolicy[i].coiNumber === sampoornSurakshaService.getRenewalDetails().policyDetails.coiNumber) {
						getAccountDetailsService.accountOverviewData.sampoornaSurakshaPolicy[i].policyPaymentFlag = "";
					}
				}
		   }
        }

        ssPaymentRenewalSuccessVm.redirect = function(){
        	getAccountDetailsService.tabIndex.tabIndex = 4;
			 $state.go('menu.accountOverviewMyBalance');
        }

		ssPaymentRenewalSuccessVm.savebase64AsPDF = function(folderpath, filename, content, contentType) {
			var contentStr = atob(content);
                        var contentLen = contentStr.length;
                        if (contentLen >= constantConfig.accOverview.pdfSize) {
                           
                            utilityService.showErrorMessage(constantConfig.accOverview.sizeLimitMessage);
                            return;
                        }
            // Convert the base64 string in a Blob
            var DataBlob = b64toBlob(content, contentType);
            filename = filename + ".pdf";
            window.resolveLocalFileSystemURL(folderpath, function(dir) {
                dir.getFile(filename, { create: true }, function(file) {
                    file.createWriter(function(fileWriter) {
                        fileWriter.write(DataBlob);
                    }, function() {});
                });
            });
        }

        ssPaymentRenewalSuccessVm.downloadLetter = function(isEmail){
            var request = {
                "isEmail": isEmail,
				"coiNumber" : ssPaymentRenewalSuccessVm.formNumber,
                "type": "sampoornSuraksha1"
            }

			sampoornSurakshaService.getDocument(request).then(function(data) {
				if(!isEmail){
			            var filename =  data.fileName+'.pdf';
						var content =  data.pdf;
						var contentType = "application/pdf";
						if(utilityService.isAndroidPlatform()){
							ssPaymentRenewalSuccessVm.android = true;
							ssPaymentRenewalSuccessVm.folderpath = cordova.file.externalRootDirectory;
						}
						if(utilityService.isIOSPlatform()){
							ssPaymentRenewalSuccessVm.folderpath = cordova.file.applicationDirectory;
						}
						irctcService.savebase64AsPDFNew(ssPaymentRenewalSuccessVm.folderpath,filename,content,contentType);
						if(utilityService.isIOSPlatform()){
						var finalObject = {"folderpath":ssPaymentRenewalSuccessVm.folderpath,"filename":filename};
						openUrlInAppbroswerService.openUrl("data:application/pdf;base64,"+content+"","");
						}
						if(ssPaymentRenewalSuccessVm.android) {
							var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="DOWNLOADFDRECEIPT" translate-values="{folderpath:ssPaymentRenewalSuccessVm.folderpath}"></div>';
								ssPaymentRenewalSuccessVm.downloadPopup = $ionicPopup.show({
									title: '',
									template: template,
									scope: $scope,
									cssClass: 'my-custom-popup',
									buttons: [{
										text:'OK',
										type: 'button-assertive',
										onTap: function() { 
											ssPaymentRenewalSuccessVm.downloadPopup.close();

										}
									}],
								});
						
						}
					}else{
						var alertPopup = $ionicPopup.alert({
							template: "<p class='fontWeight600 fss-col-verify font-size-16'>Email has been sent successfully</p>"
						});
                    }
                },function(error){
                    utilityService.showErrorMessage(error.responseMessage);
                }); 	
        	}

        $scope.$on('$ionicView.beforeEnter', function() {
            ssPaymentRenewalSuccessVm.initPage();
        });

    }
]);
