angularApp.controller('ssPolicySummaryController', [
    "$state", 
    "$scope", 
    "validateService",
    "utilityService","$filter","sampoornSurakshaService","irctcService","$ionicPopup","openUrlInAppbroswerService","$ionicHistory",
    function($state, 
        $scope, 
        validateService,
        utilityService,$filter,sampoornSurakshaService,irctcService,$ionicPopup,openUrlInAppbroswerService,$ionicHistory) {


        var ssPolicySummaryVm = this;

        function initPage() {  
          ssPolicySummaryVm.name = sampoornSurakshaService.getSSPolicyDetails() ? sampoornSurakshaService.getSSPolicyDetails().name : "";
          ssPolicySummaryVm.coverStartDate = sampoornSurakshaService.getSSPolicyDetails() ? sampoornSurakshaService.getSSPolicyDetails().startDate : "";
          ssPolicySummaryVm.coverEndDate = sampoornSurakshaService.getSSPolicyDetails() ? sampoornSurakshaService.getSSPolicyDetails().endDate : "";
          ssPolicySummaryVm.memberNo = sampoornSurakshaService.getSSPolicyDetails() ? sampoornSurakshaService.getSSPolicyDetails().coiNumber : "";
          ssPolicySummaryVm.sumAssured = sampoornSurakshaService.getSSPolicyDetails() ? sampoornSurakshaService.getSSPolicyDetails().sumAssured : "";
          ssPolicySummaryVm.premium = sampoornSurakshaService.getSSPolicyDetails() ? sampoornSurakshaService.getSSPolicyDetails().premium : "";
          ssPolicySummaryVm.status = sampoornSurakshaService.getSSPolicyDetails() ? sampoornSurakshaService.getSSPolicyDetails().status : "";
          ssPolicySummaryVm.autoRenewal = sampoornSurakshaService.getSSPolicyDetails() ? sampoornSurakshaService.getSSPolicyDetails().autoRenewal : "";
        }


        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        ssPolicySummaryVm.downloadLetter = function(isEmail){
            var request = {
                "isEmail": isEmail,
                "coiNumber" : ssPolicySummaryVm.memberNo,
                "type": "sampoornSuraksha1"
            }
            sampoornSurakshaService.getCurrentPolicyDocument(request).then(function(data) {
                 if(!isEmail){
                     ssPolicySummaryVm.downLoadPdf(data);  
                 }else{
                    var alertPopup = $ionicPopup.alert({
                        template: "<p class='fontWeight600 fss-col-verify font-size-16'>Email has been sent successfully</p>"
                    });
                 }
            },function(error){
                utilityService.showErrorMessage(error.responseMessage);
            }); 
        }

        ssPolicySummaryVm.downloadSchemeDetails = function(){      
            sampoornSurakshaService.getSchemeDetails().then(function(data) {
                ssPolicySummaryVm.downLoadPdf(data);  
            },function(error){
                utilityService.showErrorMessage(error.responseMessage);
            }); 
        }

        ssPolicySummaryVm.goBack = function(){
            $ionicHistory.goBack(-1);
        }

        ssPolicySummaryVm.downLoadPdf = function(data){
            var d = new Date();
            var currentDate = d.getDate()+""+(d.getMonth()+1)+""+d.getFullYear()+""+d.getHours()+""+d.getMinutes();
            var filename =  data.fileName+currentDate+'.pdf';
            var content =  data.pdf;
            var contentType = "application/pdf";
            if(utilityService.isAndroidPlatform()){
                ssPolicySummaryVm.android = true;
                ssPolicySummaryVm.folderpath = cordova.file.externalRootDirectory;
            }
            if(utilityService.isIOSPlatform()){
                ssPolicySummaryVm.folderpath = cordova.file.applicationDirectory;
            }
            irctcService.savebase64AsPDFNew(ssPolicySummaryVm.folderpath,filename,content,contentType);
            if(utilityService.isIOSPlatform()){
            var finalObject = {"folderpath":ssPolicySummaryVm.folderpath,"filename":filename};
            openUrlInAppbroswerService.openUrl("data:application/pdf;base64,"+content+"","");
            }
            if(ssPolicySummaryVm.android) {
                var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="DOWNLOADFDRECEIPT" translate-values="{folderpath:ssPolicySummaryVm.folderpath}"></div>';
                    ssPolicySummaryVm.downloadPopup = $ionicPopup.show({
                        title: '',
                        template: template,
                        scope: $scope,
                        cssClass: 'my-custom-popup',
                        buttons: [{
                            text:'OK',
                            type: 'button-assertive',
                            onTap: function() { 
                                ssPolicySummaryVm.downloadPopup.close();

                            }
                        }],
                    });
            }
            ssPolicySummaryVm.successPopup.close();
        }

    }
]);
