angularApp.controller('ssPremiumCalculationController', [
    "$state", 
    "$scope", 
    "validateService",
    "utilityService",
    "ionicDatePicker",
    "$ionicScrollDelegate",
    "customerInfoService",
    "$filter",
    "sampoornSurakshaService",
    "lifeInsuranceBasicApplicationService","homeLoanService","$ionicHistory",
    "$timeout",
    "$stateParams",
    function($state, 
        $scope, 
        validateService,
        utilityService,
        ionicDatePicker,$ionicScrollDelegate,customerInfoService,$filter,sampoornSurakshaService,lifeInsuranceBasicApplicationService,homeLoanService,$ionicHistory,
        $timeout,$stateParams) {


        var ssPremiumCalculationVm = this;
        ssPremiumCalculationVm.lifeGeneInsure = $stateParams.lifeGeneInsure;
        ssPremiumCalculationVm.validateFileds = function(){
            ssPremiumCalculationVm.errObj = {};
            ssPremiumCalculationVm.isError = false;
            if (validateService.isValidName(ssPremiumCalculationVm.name)) {
                ssPremiumCalculationVm.errObj.name = validateService.isValidName(ssPremiumCalculationVm.name);
            }
            if(validateService.isValidEmailHL(ssPremiumCalculationVm.email)){
                ssPremiumCalculationVm.errObj.email = validateService.isValidEmailHL(ssPremiumCalculationVm.email);
            }
            if(validateService.isValidDateOfBirth(ssPremiumCalculationVm.nomineeDob)){
                ssPremiumCalculationVm.errObj.dob = validateService.isValidDateOfBirth(ssPremiumCalculationVm.nomineeDob);
            }
            if (validateService.isValidRelationship(ssPremiumCalculationVm.relationship)) {
                ssPremiumCalculationVm.errObj.relationship = validateService.isValidRelationship(ssPremiumCalculationVm.relationship);
                ssPremiumCalculationVm.isError = true;
            }
            return (angular.equals({}, ssPremiumCalculationVm.errObj)) ? true : false;
        }

        ssPremiumCalculationVm.refreshSlider = function(){
            $timeout(function(){
                $scope.$broadcast('rzSliderForceRender');
            });
    
        };

        function initPage() {
            ssPremiumCalculationVm.errObj = {};
            ssPremiumCalculationVm.isMaskDob = true;
            ssPremiumCalculationVm.premiumDetails = sampoornSurakshaService.getPremiumDetails();
            ssPremiumCalculationVm.tnc = sampoornSurakshaService.getPremiumDetails().tnc ? true : false;
            ssPremiumCalculationVm.isError = false;
            ssPremiumCalculationVm.email = ssPremiumCalculationVm.premiumDetails.emailId; 
            ssPremiumCalculationVm.dob = ssPremiumCalculationVm.premiumDetails.primaryDob;
            if(!ssPremiumCalculationVm.premiumDetails.emailId){
                document.getElementById('email').removeAttribute('readonly');
                ssPremiumCalculationVm.isEditEmail = false;
            }else{
                ssPremiumCalculationVm.isEditEmail = true;
                document.getElementById("email").readOnly = true;
            }
            if(ssPremiumCalculationVm.dob){
                var str = ssPremiumCalculationVm.dob.split(' ');
                var year = str[2];
                var Mask = year.replace(year,'XXXX');
                ssPremiumCalculationVm.dob = str[0] + ' ' + str[1] + ' '+ Mask;
            }
            var mobile = customerInfoService.customer.mobile;
            var rupeeSymbol = String.fromCharCode(8377);
            ssPremiumCalculationVm.sumInsured = parseInt(ssPremiumCalculationVm.premiumDetails.eligibleSumAssured);
            ssPremiumCalculationVm.isSlider = false;
            ssPremiumCalculationVm.isCheckBox = false;
            ssPremiumCalculationVm.isThree = false;
            if(ssPremiumCalculationVm.sumInsured > 400000){
                ssPremiumCalculationVm.amountSlider = {
                    value: ssPremiumCalculationVm.premiumDetails.amount.initial,
                    options: {
                        showSelectionBar: true,
                        floor : ssPremiumCalculationVm.premiumDetails.amount.min,
                        ceil : ssPremiumCalculationVm.premiumDetails.amount.max,
                        step : ssPremiumCalculationVm.premiumDetails.amount.step,
                        onChange : function(id,model){
                            ssPremiumCalculationVm.amount = ssPremiumCalculationVm.amountSlider.value;
                            ssPremiumCalculationVm.calculatePremium();
                        },
                        translate : function(value){
                            return rupeeSymbol + $filter('INR')(value);
                        }
                    }
                 };
                 ssPremiumCalculationVm.isSlider = true;
                 ssPremiumCalculationVm.refreshSlider();
            }else if(ssPremiumCalculationVm.sumInsured == 300000 || ssPremiumCalculationVm.sumInsured == 400000){
                if(ssPremiumCalculationVm.sumInsured == 300000){
                    ssPremiumCalculationVm.isThree = true;
                }
                ssPremiumCalculationVm.isCheckBox = true;
            }
           ssPremiumCalculationVm.amount = ssPremiumCalculationVm.premiumDetails.amount.initial;
           ssPremiumCalculationVm.calculatePremium();
           if(ssPremiumCalculationVm.premiumDetails.policyValidUntil){
                ssPremiumCalculationVm.validTill = $filter('homeDateFormat')(ssPremiumCalculationVm.premiumDetails.policyValidUntil);
           }
           ssPremiumCalculationVm.sumInsured = ssPremiumCalculationVm.premiumDetails.eligibleSumAssured;
           if(ssPremiumCalculationVm.premiumDetails.nomineeDOB){
                ssPremiumCalculationVm.nomineeDob = $filter('homeDateFormat')(ssPremiumCalculationVm.premiumDetails.nomineeDOB);
           }else{
               ssPremiumCalculationVm.nomineeDob = "";
           }

           if(!ssPremiumCalculationVm.premiumDetails.relationshipList ||  ssPremiumCalculationVm.premiumDetails.relationshipList.length == 0){
               ssPremiumCalculationVm.premiumDetails.relationshipList  = [];
                lifeInsuranceBasicApplicationService.getApplicationMasterData().then(function(data) {
                    ssPremiumCalculationVm.premiumDetails.relationshipList = data.relationships;
                    if(ssPremiumCalculationVm.premiumDetails.relationship){
                        ssPremiumCalculationVm.relationship = sampoornSurakshaService.findObject(ssPremiumCalculationVm.premiumDetails.relationship, ssPremiumCalculationVm.premiumDetails.relationshipList);
                    }
                    sampoornSurakshaService.setQuestions(data.ssQuestion);
                }, function(error) {
                
                });
           }else{
               if(ssPremiumCalculationVm.premiumDetails.relationship){
                    ssPremiumCalculationVm.relationship = sampoornSurakshaService.findObject(ssPremiumCalculationVm.premiumDetails.relationship, ssPremiumCalculationVm.premiumDetails.relationshipList);
                }
           }
           ssPremiumCalculationVm.name = ssPremiumCalculationVm.premiumDetails.nomineeName;
        }
         
        ssPremiumCalculationVm.goToNextPage = function(){
            if(ssPremiumCalculationVm.validateFileds()){
                var formDetails = {
                    "sumAssured" : ssPremiumCalculationVm.amount,
                    "nomineeName": ssPremiumCalculationVm.name,		
                    "nomineeDOB": ssPremiumCalculationVm.nomineeDob,	
                    "relationship": ssPremiumCalculationVm.relationship.key,
                    "primaryEmailId": ssPremiumCalculationVm.isEditEmail == false ? ssPremiumCalculationVm.email : ssPremiumCalculationVm.premiumDetails.emailId,
                    "amount" : ssPremiumCalculationVm.premium,
                    "isEmailMasked" : ssPremiumCalculationVm.isEditEmail
                }
                var pageDetails = sampoornSurakshaService.getPremiumDetails();
                pageDetails.nomineeName = ssPremiumCalculationVm.name;
                pageDetails.relationship = ssPremiumCalculationVm.relationship.key;
                pageDetails.nomineeDOB = $filter('ssDateFormat')(ssPremiumCalculationVm.nomineeDob);
                pageDetails.emailId = ssPremiumCalculationVm.premiumDetails.emailId;
                pageDetails.amount.initial = parseInt(ssPremiumCalculationVm.amount);
                pageDetails.relationship = ssPremiumCalculationVm.relationship.key;
                pageDetails.relationshipList = ssPremiumCalculationVm.premiumDetails.relationshipList; 
                pageDetails.tnc = true;
                sampoornSurakshaService.setPremiumDetails(pageDetails);
                sampoornSurakshaService.setFormDetails(formDetails);
                $state.go('menu.ssMedicalInformation');
            }
        }

        ssPremiumCalculationVm.openDatePicker = function(){
            var monList = ["JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC"];
            var newDate = new Date();
            newDate.setFullYear(newDate.getFullYear() - 100);
            var toDate = new Date();
            toDate.setFullYear(toDate.getFullYear() - 18);
            ssPremiumCalculationVm.dateObj = {
                    callback: function (val) {
                        var dateOfBirth = new Date(val);
                        var setDate;
                        if(dateOfBirth.getDate() < 10){
                            var setDate = "0" + dateOfBirth.getDate();
                        }else{
                            setDate = dateOfBirth.getDate();
                        }
                        ssPremiumCalculationVm.nomineeDob = setDate + " " + monList[dateOfBirth.getMonth()] + " " + dateOfBirth.getFullYear();
                    },
                    inputDate: toDate,
                    monthsList:monList,
                    from: newDate,
                    to: toDate,
                    mondayFirst: true,
                    closeOnSelect: false,
                    templateType: 'popup',
                    dateFormat: 'dd MMM yyyy'
            };

            ionicDatePicker.openDatePicker(ssPremiumCalculationVm.dateObj);
        }

        ssPremiumCalculationVm.calculatePremium = function(){
            ssPremiumCalculationVm.quotient = Math.floor(ssPremiumCalculationVm.amount/100000);
            ssPremiumCalculationVm.premium = parseFloat(ssPremiumCalculationVm.premiumDetails.grossPremium) * ssPremiumCalculationVm.quotient;
            ssPremiumCalculationVm.premium =ssPremiumCalculationVm.premium.toFixed(2);
        }

        ssPremiumCalculationVm.goBack = function(){
             if(ssPremiumCalculationVm.lifeGeneInsure){
                $state.go('menu.generalInsurance', {backInsurance : true});
            }
            else{
                ssPremiumCalculationVm.tnc = "";
                ssPremiumCalculationVm.errObj = {};
                $ionicHistory.goBack(-1);
            }
        }

        ssPremiumCalculationVm.unmaskDob = function(type){
            if(type == "dob"){
                ssPremiumCalculationVm.isMaskDob = false;
                ssPremiumCalculationVm.dob = ssPremiumCalculationVm.premiumDetails.primaryDob;
            }else if(type == "ndob"){
                ssPremiumCalculationVm.isMaskDob = true;
                var str = ssPremiumCalculationVm.dob.split(' ');
                var year = str[2];
                var Mask = year.replace(year,'XXXX');
                ssPremiumCalculationVm.dob = str[0] + ' ' + str[1] + ' '+ Mask;
            }else if(type == "email"){
                sampoornSurakshaService.getBaseEmail().then(function(data) {
                    ssPremiumCalculationVm.email = data.email;
                    ssPremiumCalculationVm.isEditEmail = false;
                    document.getElementById('email').removeAttribute('readonly');
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        }

        ssPremiumCalculationVm.knowMore = function(){
            var pageDetails = sampoornSurakshaService.getPremiumDetails();
            pageDetails.nomineeName = ssPremiumCalculationVm.name;
            pageDetails.relationship = ssPremiumCalculationVm.relationship ? ssPremiumCalculationVm.relationship.key : "";
            pageDetails.nomineeDOB = ssPremiumCalculationVm.nomineeDob ? $filter('ssDateFormat')(ssPremiumCalculationVm.nomineeDob) : "";
            pageDetails.emailId = ssPremiumCalculationVm.email;
            pageDetails.amount.initial = parseInt(ssPremiumCalculationVm.amount);
            pageDetails.relationshipList = ssPremiumCalculationVm.premiumDetails.relationshipList; 
            pageDetails.tnc = true;
            sampoornSurakshaService.setPremiumDetails(pageDetails);
            sampoornSurakshaService.getPolicyFeatures().then(function(data) {
                sampoornSurakshaService.setPolicyDetails(data);
                sampoornSurakshaService.setBuyNow(false);
                $state.go('menu.ssPolicyFeatures');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
