angularApp.controller('ssRenewalOtpController', [
    "$state", 
    "$scope",
    "sampoornSurakshaService",
    "$ionicPopup",
    "$ionicPopover",
    "utilityService",
    "$filter",
    "customerInfoService",
    "getAccountDetailsService",
    "clickStreamService",
    function($state, 
        $scope,
        sampoornSurakshaService,
        $ionicPopup,
        $ionicPopover,
        utilityService,
        $filter,
        customerInfoService,
        getAccountDetailsService,
        clickStreamService) {

        var ssRenewalOtpVm = this;

        ssRenewalOtpVm.initPage = function(){
            ssRenewalOtpVm.otpCount = 0;
            ssRenewalOtpVm.clickCount = 0;
            ssRenewalOtpVm.isResendDisabled = false;
            ssRenewalOtpVm.mobileNumber = customerInfoService.customer.mobile ? $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4) : "";
        }

        ssRenewalOtpVm.goToNextPage = function(){
           ssRenewalOtpVm.resetPinOTP = "";
            if(!ssRenewalOtpVm.otpNumber || ssRenewalOtpVm.otpNumber.length != 6){
                ssRenewalOtpVm.resetPinOTP = "Enter a valid otp";
            }else{
                var request = {
                    "otp" : ssRenewalOtpVm.otpNumber
                }
                sampoornSurakshaService.validateOTPForRenew(request).then(function(data) {
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "PAY_NOW"));
                    sampoornSurakshaService.setFinalResponse(data);
                    $state.go('menu.ssRenewalSuccess');
                },function(error){
                    ssRenewalOtpVm.otpNumber = "";
                    if(error.errorCode == "OTP12"){
                        ssRenewalOtpVm.otpCount++;
                        if(ssRenewalOtpVm.otpCount >= 3){
                            var title = '';
                            var template = "<p> "+error.responseMessage +" </p>";
                            var onTap = 'menu.homeScreen';
                            var buttontext = "<b>OK</b>";
                            utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                        }else{
                            utilityService.showErrorMessage(error.responseMessage);
                        }
                    }else{
                        utilityService.showErrorMessage(error.responseMessage);
                    }
                });
            }
        }

        ssRenewalOtpVm.resendOTP = function(){
            sampoornSurakshaService.generateSSRenewOTP(sampoornSurakshaService.renewalRequest).then(function(data) {
                ssRenewalOtpVm.otpNumber = "";
                ssRenewalOtpVm.resetPinOTP = "";
                ssRenewalOtpVm.clickCount++;
                if(ssRenewalOtpVm.clickCount >= 2){
                    ssRenewalOtpVm.isResendDisabled = true;
                }
                var template = "<p> "+ "OTP has been sent to your registered mobile number." +" </p>";
                var onTap = '';
                var buttontext = "<b>OK</b>";
                utilityService.showAlertModal('', template, onTap, $scope, $state, buttontext);
            },function(error){
                ssRenewalOtpVm.otpNumber = "";
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            ssRenewalOtpVm.initPage();
        });

    }
]);
