'use strict';

angularApp.controller('ntbEnterAccountAggregatorIDController', [
    "$state",
    "$scope",
    "$ionicPopup",
    "$ionicHistory",
    "clNTBCalculatorService",
    "$filter",
    "utilityService",
    "clickStreamService",
    "cryptoService",
    "$timeout",
    function (
        $state,
        $scope,
        $ionicPopup,
        $ionicHistory,
        clNTBCalculatorService,
        $filter,
        utilityService,
        clickStreamService,
        cryptoService,
        $timeout) {
            
        var ntbEnterAccountAggregatorIDVm = this;        
        var accountAggregatorPattern = /[A-Za-z0-9]{6,35}@[A-Za-z0-9]{1,33}/;
        var ref;
        $scope.showDisclaimerError = false;

        ntbEnterAccountAggregatorIDVm.initPage = function(){
            ntbEnterAccountAggregatorIDVm.errorObj = {
                aAId: { show: false, error: '' }
            }            

            ntbEnterAccountAggregatorIDVm.selectedAccountAggregators = "";
            ntbEnterAccountAggregatorIDVm.selectedAccAggr = clNTBCalculatorService.selectedAccAggr;

            $scope.disclaimerContentNTBAA = clNTBCalculatorService.disclaimerLine1;
            $scope.disclaimerContentNTBAA2 = clNTBCalculatorService.disclaimerLine2;
        }        
        
        ntbEnterAccountAggregatorIDVm.goBack = function () {
            $ionicHistory.goBack();
        }

        ntbEnterAccountAggregatorIDVm.checkPattern = function () {
            if (!accountAggregatorPattern.test(ntbEnterAccountAggregatorIDVm.vuaID) || ntbEnterAccountAggregatorIDVm.vuaID.length < 7 || ntbEnterAccountAggregatorIDVm.vuaID.length > 40) {
                ntbEnterAccountAggregatorIDVm.errorObj.aAId = {
                    show: true,
                    error: $filter('translate')('NTB_ENTER_AA_ID_ERROR')
                };
            } else {
                if ((ntbEnterAccountAggregatorIDVm.vuaID.match(new RegExp("@", "g")) || []).length > 1) {
                    ntbEnterAccountAggregatorIDVm.errorObj.aAId = {
                        show: true,
                        error: $filter('translate')('NTB_ENTER_AA_ID_ERROR')
                    };
                } else {
                    ntbEnterAccountAggregatorIDVm.errorObj.aAId = {
                        show: false,
                        error: ''
                    }
                }
            }
        }

        ntbEnterAccountAggregatorIDVm.openDisclaimer = function () {
            ntbEnterAccountAggregatorIDVm.agreeCheckBox = false;
            if (ntbEnterAccountAggregatorIDVm.vuaID == undefined || ntbEnterAccountAggregatorIDVm.vuaID == "" || ntbEnterAccountAggregatorIDVm.vuaID == null) {
                ntbEnterAccountAggregatorIDVm.errorObj.aAId = {
                    show: true,
                    error: $filter('translate')('NTB_ENTER_AA_ID_ERROR')
                }
            }
            if (!ntbEnterAccountAggregatorIDVm.errorObj.aAId.show) {
                clNTBCalculatorService.openDisclaimerPopup($scope);               
            }
        }      

        $scope.closeDisclaimer = function () {
            clNTBCalculatorService.closeDisclaimerPopup($scope);
        }

         $scope.agreeNTBAADisclaimer = function(disclaimerNTBAAChecked){
            if(disclaimerNTBAAChecked){
                ntbEnterAccountAggregatorIDVm.checkBoxChecked = true;
                $scope.showNTBAADisclaimerError = false;
            }else{
                ntbEnterAccountAggregatorIDVm.checkBoxChecked = false;
                $scope.showNTBAADisclaimerError = true;
            }
        }

        $scope.ntbAAContinue = function() {
            if(ntbEnterAccountAggregatorIDVm.checkBoxChecked){
                $scope.showNTBAADisclaimerError = false;
                var SHA512HashedVal = clNTBCalculatorService.productIDNTBCL + clNTBCalculatorService.getGenerateLeadData().mobile+clNTBCalculatorService.selectedAccAggr.aAname+ntbEnterAccountAggregatorIDVm.vuaID + clNTBCalculatorService.getReferenceStatusData().crmLeadID;
			    var value = cryptoService.getSHA512EncryptedData(SHA512HashedVal).toString();
                var payload= {
                    "productId": clNTBCalculatorService.productIDNTBCL,
                    "mobileNo": clNTBCalculatorService.getGenerateLeadData().mobile,
                    "aaId": clNTBCalculatorService.selectedAccAggr.aAname,
                    "vua": ntbEnterAccountAggregatorIDVm.vuaID,
                    "accountID":clNTBCalculatorService.getReferenceStatusData().crmLeadID,
                    "val": value
                }                
                clNTBCalculatorService.getAAUrl(payload).then(function (response) {
                    $scope.closeDisclaimer();
                    ntbEnterAccountAggregatorIDVm.inAppBrowser(response.webRedirectionUrl);
                    clNTBCalculatorService.ntbAARespURL = response.respUrl;
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }else{
                $scope.showNTBAADisclaimerError = true;
            }
        }

        ntbEnterAccountAggregatorIDVm.inAppBrowser = function (url) {
            $timeout(function () {
                clNTBCalculatorService.extendSession().then(function(response) {
                    console.log("session extended"+response);
                },function(error){ 
                    console.log("error"+error);
                });                
            }, 150000);
            
            ref = cordova.ThemeableBrowser.open(url, '_blank', {
                statusbar: {
                    color: '#ffffffff'
                },
                toolbar: {
                    height: 44,
                    color: '#ffffffff',
                    image: 'share'
                },
                backButton: {
                    wwwImage: 'img/inappback.png',
                    align: 'left',
                    event: 'backPressed'
                },                
                backButtonCanClose: true
            });

             ref.addEventListener('loadstart', function (event) {
                console.log("loadstart",event);
                var URL=event.url;
                if(URL.indexOf(clNTBCalculatorService.ntbAARespURL) > -1) {
                    ref.close();
                    clNTBCalculatorService.finalConsentCheck();
                }
             });

            ref.addEventListener('backPressed', function () {
                ref.close();
                clNTBCalculatorService.finalConsentCheck();                
            });
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            ntbEnterAccountAggregatorIDVm.initPage();
        });
        return this;
    }
])