'use strict';

angularApp.controller('pablChooseController', [
    "$state",
    "$scope",
    "$ionicHistory",
    "utilityService",
    "pablService",
    "$ionicPopup",
    function($state,
        $scope,
        $ionicHistory,
        utilityService,
        pablService,
        $ionicPopup) {

        var pablChooseVm = this;
        pablChooseVm.loanDetailsData = {};

        pablChooseVm.initPage = function () {
            pablChooseVm.loanDetailsData = pablService.getEligibilityDetailsData();
            pablChooseVm.intRate = pablChooseVm.loanDetailsData.roi;
            pablChooseVm.loanAmount = pablChooseVm.loanDetailsData.amount;
        }

        pablChooseVm.goback = function() {
            $ionicHistory.goBack(-1);
        };

        pablChooseVm.proceedToPABL = function() {
            pablChooseVm.redirectionPopup = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',
                template:'<div class="nominee-popup"><div class="nominee-padding font-dark-grey">'+
                        '<div class="text-center"><img class="approvedIconPosition" src="img/pacl/redirection_img.png" alt=""></div></div><div class="padding-15 text-center"><div class="sbod-fontWeight-700 nominee--msg font-bold" translate="PABL_REDIR_LBL"></div><br><div class="nominee--msg" translate="PABL_REDIR_MSG"></div></div><div class="padding-15 text-center">'+
                        '<button class="nominee-popup-btn" ng-click="pablChooseVm.redirectionCall()" translate="PABL_CONT_LBL"></button></div></div>',
                scope: $scope
            });
        }

        pablChooseVm.redirectionCall = function(){
            pablService.getPABLPageRedirectionURL().then(function (response) {
				pablService.setRedirectionalUrlData(response);
				pablChooseVm.submitPABLRedirectUrlData();
			}, function (error) {
                pablChooseVm.redirectionPopup.close();
				utilityService.showErrorMessage(error.responseMessage);
			});
        }

        pablChooseVm.submitPABLRedirectUrlData = function(){
            pablChooseVm.redirectUrlDetailsData = pablService.getRedirectionalUrlData();
            var actUrl = pablChooseVm.redirectUrlDetailsData.redirectURL;
            var data = pablChooseVm.redirectUrlDetailsData.data;
            var checksum = pablChooseVm.redirectUrlDetailsData.checksum;

            var pageContent = '<!DOCTYPE html><html><head><meta charset="ISO-8859-1"><title>Sample Test</title></head><body><form id="sampleForm" name="sampleForm" action="'+ actUrl+'" method="post" enctype="application/x-www-form-urlencoded">' +
            '<input type="text" id="data" name="data" value="'+ data+ '">' + 
            '<input type="text" id="checksum" name="checkSum" value="'+ checksum + '">' +
            '</form> <script type="text/javascript">document.getElementById("sampleForm").submit();'+
            '</script></body></html>';
            var pageContentUrl = 'data:text/html;base64,' + btoa(pageContent);                            
            var ref = cordova.ThemeableBrowser.open(pageContentUrl, '_blank', {
                statusbar:{
                    color: '#ffffffff',
                    align: 'left'
                },
                title: {
                    height: 44,
                    color: '#000000',
                    staticText : 'Explore PABL',
                    showPageTitle : true,
                    align : 'left'
                },
                closeButton: {
                    wwwImage: 'img/inappback.png',
                    align: 'left'
                },
                backButtonCanClose: true
            });

            ref.addEventListener('loadstart', function (event) {
                console.log("loadstart--> ",event);
            });

            ref.addEventListener("exit", function (event) {
                ref.close();
                $state.go('menu.pablChoose');
            });

            pablChooseVm.redirectionPopup.close();
        }

        pablChooseVm.skipPABL = function() {
            pablService.getPABLReasonList().then(function (response) {
				pablService.setReasonList(response);
				$state.go('menu.pablNotInterested');
			}, function (error) {			
				utilityService.showErrorMessage(error.responseMessage);
			});
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            pablChooseVm.initPage();
        });       
        return this;
    }
]);