'use strict';

angularApp.controller('pablNotInterestedController', [
    "$state",
    "$scope",
    "$translate",
    "utilityService",
    "$ionicHistory",
    "pablService",
    "patwlService",
    function($state,
        $scope,
        $translate,
        utilityService,
        $ionicHistory,
        pablService,
        patwlService) {

        var pablNotInterestedVm = this;
        pablNotInterestedVm.showOtherDetails = false;

        pablNotInterestedVm.initPage = function () {
            pablNotInterestedVm.loanDetailsData = pablService.getEligibilityDetailsData();
            pablNotInterestedVm.branch = pablNotInterestedVm.loanDetailsData.branchName;
            pablNotInterestedVm.branchCode = pablNotInterestedVm.loanDetailsData.branchCode;
            pablNotInterestedVm.reasonsList = pablService.getReasonList().notInterestedNowDropdownDataList;
            pablNotInterestedVm.userInputMaxLength = parseInt(pablNotInterestedVm.loanDetailsData.userInputMaxLength);
            pablNotInterestedVm.userInputMaxAmount = parseInt(pablNotInterestedVm.loanDetailsData.userInputMaxAmount);
            pablNotInterestedVm.reasons = "";
            pablNotInterestedVm.amountError = "";
        }

        pablNotInterestedVm.selectReason = function(reason){
            if(reason && reason.restcall == "Y"){
                pablNotInterestedVm.showOtherDetails = true;
            }else{
                pablNotInterestedVm.showOtherDetails = false;
            }
        }

        pablNotInterestedVm.validateLoanAmt = function(loanAmt) {
            if(parseInt(loanAmt) > pablNotInterestedVm.userInputMaxAmount){
                pablNotInterestedVm.amountError = "Please enter valid loan amount";
            }else{
                pablNotInterestedVm.amountError = patwlService.isValidField(loanAmt,"Loan Amount");
            }
            return (angular.equals("", pablNotInterestedVm.amountError)) ? true : false; 
        }

        pablNotInterestedVm.goback = function() {
            $ionicHistory.goBack(-1);
        }; 
        
        pablNotInterestedVm.goToNextPage = function() {            
            if(pablNotInterestedVm.showOtherDetails){
                pablNotInterestedVm.validateLoanAmt(pablNotInterestedVm.loanAmt);
                if(!pablNotInterestedVm.amountError){
                     pablNotInterestedVm.submitLead();
                }
            }else{
                pablNotInterestedVm.submitLead();
            }                       
        }

        pablNotInterestedVm.submitLead = function(){
            var request = {
                "userInput": pablNotInterestedVm.loanAmt ? pablNotInterestedVm.loanAmt : "",
                "notInterestedReason": pablNotInterestedVm.reasonData ? pablNotInterestedVm.reasonData : ""
            }
            pablService.submitPABLNotInterestedLead(request).then(function (response) {
                pablService.setSubmittedData(response);
                $state.go('menu.pablThankYou');
            }, function (error) {			
                utilityService.showErrorMessage(error.responseMessage);
            }); 
        }        

        $scope.$on('$ionicView.beforeEnter', function() {
            pablNotInterestedVm.initPage();
        });

        return this;
    }
]);