'use strict';

angularApp.service('pablService',
    function($q, AdapterUtils, utilityService, constantConfig, $ionicPopup, $state, $ionicScrollDelegate,$cordovaCamera) {

        var pablService = this;

        var loanDetails,savedUrlData,submittedData,dropDownData;

        this.tncReadInlineErrorMsg= "";

        // Setter/Getter
        pablService.setEligibilityDetailsData = function(data) {
            loanDetails = data;
        };

        pablService.getEligibilityDetailsData = function() {
            return loanDetails;
        };

        pablService.setRedirectionalUrlData = function(data) {
            savedUrlData = data;
        };

        pablService.getRedirectionalUrlData = function() {
            return savedUrlData;
        };

        pablService.setReasonList = function(data) {
            dropDownData = data;
        };

        pablService.getReasonList = function() {
            return dropDownData;
        };

        pablService.setSubmittedData = function(data) {
            submittedData = data;
        };

        pablService.getSubmittedData = function() {
            return submittedData;
        };          

        // API calls
        pablService.getPABLBasicEligibility= function() {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/pabl/basicEligibility", {}, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        pablService.getPABLPageRedirectionURL = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/pabl/getPageRedirectionURL", {}, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        pablService.submitPABLNotInterestedLead = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/pabl/notInterestedLead", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        }; 

        pablService.getPABLReasonList = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/pabl/reasonList", {}, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

         pablService.showAlertPopup = function (imageType, message1, message2, onTapgo, buttontext1, buttontext2, $scope, obj) {
            var btn_array = [];
            if (buttontext1 != "" && buttontext2 != "") {
                btn_array = [{
                    text: buttontext2 || "Cancel",
                    type: 'button-negative',
                    onTap: function () {
                        if (onTapgo) {
                            $state.go(onTapgo);
                        }
                    }
                },{
                    text: buttontext1 || "OK",
                    type: 'button-positive',
                    onTap: function () {
                        if (onTapgo) {
                            $state.go(onTapgo);
                        }
                    }
                }];
            } else {
                btn_array = [{
                    text: buttontext1 || "OK",
                    type: 'button-positive',
                    onTap: function () {
                        if (onTapgo) {
                            $state.go(onTapgo);
                        }
                    }
                }];
            }

            if (imageType && imageType.toLowerCase() == 'error') {
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/errorSymbol.svg"/></div>';
            } else if (imageType && imageType.toLowerCase() == 'success') {
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/successSymbol.svg"/></div>';
            } else if (imageType && imageType.toLowerCase() == 'alert') {
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/lifeInsurance/alert.svg"/></div>';
            } else {
                imageType = "";
            }
            $ionicPopup.alert({
                template: '<div class="font-dark-grey">'+ imageType +'</div><div class="popupTextBottomPadding padTop10 fontSize-subHeading"><div class="textAlignCenter color-darkgrey"><span class="font-wt-bold roboto-bold font-size-16">'+ message1 +'</span><div class="textAlignCenter roboto-regular font-size-14 color-darkgrey padTop10">'+ message2 +'</div></div></div></div>',
                scope: $scope,
                cssClass: 'bhim-alert-popup pabl_popup',
                buttons: btn_array,
            });
        };
        
     return pablService;
    });