'use strict';

angularApp.controller('paclCongratulationsController', [
    "$state",
    "$scope",
    "$translate",  
    "$ionicSideMenuDelegate",
    "$filter", "paclService", "$ionicPopover", "utilityService", "openUrlInAppbroswerService",
    "irctcService", "$ionicPopup", "goldLoanRLMSService",

    function($state,
        $scope,
        $translate,        
        $ionicSideMenuDelegate,
        $filter, paclService, $ionicPopover, utilityService, openUrlInAppbroswerService, 
        irctcService, $ionicPopup, goldLoanRLMSService) {

        var paclCongratulationsVm = this;       

        function initPage() {
            if(paclService.getSuccessPACLData()) {
                paclCongratulationsVm.refNo = paclService.getSuccessPACLData().yonoRef;
                paclCongratulationsVm.loanAmount = paclService.getSuccessPACLData().amount;
                if(paclService.getSuccessPACLData().email){
                    goldLoanRLMSService.showAlertPopup("alert",paclService.getSuccessPACLData().email,"","menu.paclCongratulations","OK","","","");
                }
            }            
        };

        paclCongratulationsVm.goBack = function() {
            $state.go('menu.homeScreen');  
        }
     

        paclCongratulationsVm.openPasswordInfo = function ($event) {
            paclCongratulationsVm.leftStyle = "left : " + ($event.clientX - 10) + "px";           
            paclCongratulationsVm.template = '<ion-popover-view class="loginnewarrow hmbr-info pswd-info-popnew passwordInfoPopup" id="runtimeHeight">'+ 
                '<div class="goldloan-arrow-upnew" style="{{paclCongratulationsVm.leftStyle}}"></div>'+'<div class="padBottom3"><span class="inb-lock-roboto-bold font-size-14">Password eg. - 05Mar!8899</span></div>'+
                '<a class="iconsubtext closeinfobutton float-right" id="CALL_ANC" click-stream="click" ng-click="paclCongratulationsVm.closePopover()"><img src="img/Close.png" class="glPwdClose"></a>'+
                '<div class="popupDivider"></div>'+'<ion-content class="nfs-popover">'+'<div class="row roboto-light font-size-12 padTop15">'+
                '<div class="col col-40"><div class="row"><div><span class="inb-lock-roboto-bold font-size-12 text-underline-gl">05Mar</span><span>ch</span></div><span class="padLeft50">+</span></div><div class="row fss-text-center">Birth date and first 3 letters of birth month with first letter capital</div></div>'+
                '<div class="col col-20"><div class="row"><span class="inb-lock-roboto-bold font-size-12 text-underline-gl padLeft25">!</span><span class="padLeft50">+</span></div><div class="row fss-text-center">Mandatory "!" sign</div></div>'+
                '<div class="col col-40"><div class="row"><span class="padLeft50">9XXXXX</span><span class="inb-lock-roboto-bold font-size-12 text-underline-gl">8899</span></div><div class="row fss-text-center padLeft25">Last 4 digits of the registered mobile number</div></div></div></ion-content></ion-popover-view>';
            $scope.popover = $ionicPopover.fromTemplate(paclCongratulationsVm.template, {
                scope: $scope
            });
            $scope.popover.show($event);               
        }
    
        paclCongratulationsVm.downloadLetter = function(isEmail){
            var payload = {};
            if(!isEmail){
                payload = {
                    "isEmail": false,
                    "type": "inprinciple"
                };
            }else{
                payload = {
                    "isEmail": true,
                    "type": "inprinciple"
                };
            }                 

            paclService.getDocument(payload).then(function(data) {
                if(!isEmail) {
                    var filename =  data.fileName+'.pdf';
                    var content =  data.pdf;
                    var contentType = "application/pdf";
                    if(utilityService.isAndroidPlatform()) {
                        paclCongratulationsVm.android = true;
                        paclCongratulationsVm.folderpath = cordova.file.externalRootDirectory;
                    }
                    if(utilityService.isIOSPlatform()) {
                        paclCongratulationsVm.folderpath = cordova.file.applicationDirectory;
                    }

                    irctcService.savebase64AsPDF(paclCongratulationsVm.folderpath,filename,content,contentType);

                    if(utilityService.isIOSPlatform()) {
                        var finalObject = {"folderpath":paclCongratulationsVm.folderpath,"filename":filename};
                        openUrlInAppbroswerService.openUrl("data:application/pdf;base64,"+content+"","");
                    }

                    if(paclCongratulationsVm.android) {
                        var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="DOWNLOADFDRECEIPT" translate-values="{folderpath:paclCongratulationsVm.folderpath}"></div>';
                        paclCongratulationsVm.downloadPopup = $ionicPopup.show({
                            title: '',
                            template: template,
                            scope: $scope,
                            cssClass: 'my-custom-popup',
                            buttons: [{
                                text:'OK',
                                type: 'button-assertive',
                                onTap: function() { 
                                    paclCongratulationsVm.downloadPopup.close();
                                }
                            }],
                        });                        
                    }
                    paclCongratulationsVm.successPopup.close();
                }else{
                    var alertPopup = $ionicPopup.alert({
                        template: "<p style='text-align:center;font-weight:bold;font-size:16px'>Email has been sent successfully</p>"
                    });
                }
            },function(error){
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
        
        paclCongratulationsVm.closePopover = function(){
            $scope.popover.hide();
        }

        paclCongratulationsVm.goToAccOverview = function() {
            $state.go('menu.accountOverviewMyBalance');
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        return this;
    }
]);