'use strict';

angularApp.service('paclService',
    function($q, AdapterUtils, utilityService, constantConfig, $ionicPopup, $state, $ionicScrollDelegate) {

        var paclService = this;

        var paclDetails,paclSuccess;

        paclService.clearAll = function(){
            paclDetails= null;paclSuccess=null;
        }
        
        // Setter/Getter
        paclService.setPACLData = function(data) {
            paclDetails = data;
        };

        paclService.getPACLData = function() {
            return paclDetails;
        };

        paclService.setSuccessPACLData = function(data) {
            paclSuccess = data;
        };

        paclService.getSuccessPACLData = function() {
            return paclSuccess;
        };


        // API call

        paclService.submitApplication = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/pacl/submitApplication", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };



        paclService.getDocument = function(payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/pacl/getDocument", payLoad, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        paclService.getLoanDetail = function() {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/pacl/getLoanDetail", {}, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        return paclService;

    });