'use strict';
angularApp.controller('patwlApplicantDetailsController', [
	"$state",
	"$scope",
	"$ionicPopup",
	"$translate",
	"$ionicHistory",
	"utilityService",
	"ionicDatePicker",
	"$ionicSideMenuDelegate",
	"$ionicScrollDelegate",
	"customerInfoService",
	"validateService",
	"$filter", "patwlService", "homeScreenService",
	function ($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate,
		$ionicScrollDelegate, customerInfoService, validateService, $filter, patwlService, homeScreenService) {

		var patwlApplicantDetailsVm = this;
		patwlApplicantDetailsVm.emailMaskUnmask = false;
		var pinRegex = /^[123456789]\d{5}$/;
		var mailformat = /^([\w\.\-]+)@([\w\-]+)((\.(\w){2,63}){1,2})$/;         //  /\S+@[a-zA-Z]+\.[a-zA-Z]+/;
		var phnReg = /^(?!0+$)[0-9]+$/                // /^(0+|[1-9]\d*)$/;

		patwlApplicantDetailsVm.initPage = function () {
			patwlApplicantDetailsVm.employementObj = {};
			patwlApplicantDetailsVm.personalDetails = {}
			patwlApplicantDetailsVm.currentAddressObj = {};
			patwlApplicantDetailsVm.errObj = {};
			patwlApplicantDetailsVm.isMaskmobile = true;
			patwlApplicantDetailsVm.isMaskDeductAcc = true;
			patwlApplicantDetailsVm.isMaskEmail = true;
			patwlApplicantDetailsVm.parsonalTab = true;
			patwlApplicantDetailsVm.personalDetails.isEmailID = false;
			patwlApplicantDetailsVm.professionList = [];
			if (patwlService.isFromLoanDetailBack) {
				patwlApplicantDetailsVm.professionList = patwlService.getCustomerData().professions;
				patwlApplicantDetailsVm.employementObj = patwlService.getApplicantPageData().work;
				patwlApplicantDetailsVm.personalDetails = patwlService.getApplicantPageData().parsonal;
				patwlApplicantDetailsVm.currentAddressObj = patwlService.getApplicantPageData().address;

				if (patwlApplicantDetailsVm.employementObj.empType == 'Salaried') {
					patwlApplicantDetailsVm.isSalaried = true;
				} else {
					patwlApplicantDetailsVm.isSalaried = false;
				}
				if (patwlApplicantDetailsVm.currentAddressObj.addressType == 'Permanent') {
					patwlApplicantDetailsVm.isPermanentAddress = true;
				} else {
					patwlApplicantDetailsVm.isPermanentAddress = false;
				}


			} else {
				patwlApplicantDetailsVm.customerDetails = patwlService.getCustomerData();
				patwlApplicantDetailsVm.personalDetails.personalDetailsCheck = false;
				patwlApplicantDetailsVm.professionList = patwlService.getCustomerData().professions;
				patwlApplicantDetailsVm.isPermanentAddress = true;
				patwlApplicantDetailsVm.currentAddressObj.addressType = 'Permanent';
				patwlApplicantDetailsVm.employementObj.empType = 'Salaried';
				patwlApplicantDetailsVm.isSalaried = true;
				patwlApplicantDetailsVm.personalDetails.name = patwlApplicantDetailsVm.customerDetails.name;
				patwlApplicantDetailsVm.personalDetails.dob = (patwlApplicantDetailsVm.customerDetails.dob).toUpperCase();
				patwlApplicantDetailsVm.personalDetails.email = patwlApplicantDetailsVm.customerDetails.email;
				patwlApplicantDetailsVm.personalDetails.mobile = patwlApplicantDetailsVm.customerDetails.mobileNumber;
				patwlApplicantDetailsVm.personalDetails.accNo = patwlApplicantDetailsVm.customerDetails.accountNo;
				patwlApplicantDetailsVm.personalDetails.address = patwlApplicantDetailsVm.customerDetails.permanentAddress;

				if (patwlApplicantDetailsVm.personalDetails.email) {
					patwlApplicantDetailsVm.personalDetails.isEmailID = true;
				}
			}

		}



		patwlApplicantDetailsVm.unMaskData = function (payload, type) {
			patwlService.getUnmaskedOutput(payload).then(function (response) {
				if (type == "mobile") {
					patwlApplicantDetailsVm.personalDetails.mobileUnMasked = response.unmaskedOutput;
				}
				if (type == "accountNo") {
					patwlApplicantDetailsVm.personalDetails.accNoUnMasked = response.unmaskedOutput;
				}
				if (type == "email") {
					patwlApplicantDetailsVm.personalDetails.emailUnMasked = response.unmaskedOutput;
				}
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			})
		}

		patwlApplicantDetailsVm.toggleMaskData = function (type) {
			if (type == "mobile") {
				if (patwlApplicantDetailsVm.isMaskmobile) {
					patwlApplicantDetailsVm.unMaskData({
						"maskedInput": patwlApplicantDetailsVm.personalDetails.mobile
						, "type": "mobileNumber"
					}, type);
				}
				patwlApplicantDetailsVm.isMaskmobile = !patwlApplicantDetailsVm.isMaskmobile;
			}
			if (type == "accountNo") {
				if (patwlApplicantDetailsVm.isMaskDeductAcc) {
					patwlApplicantDetailsVm.unMaskData({
						"maskedInput": patwlApplicantDetailsVm.personalDetails.accNo
						, "type": "accountNo"
					}, type);
				}
				patwlApplicantDetailsVm.isMaskDeductAcc = !patwlApplicantDetailsVm.isMaskDeductAcc;
			}
			if (type == "email") {
				if (patwlApplicantDetailsVm.isMaskEmail) {
					patwlApplicantDetailsVm.unMaskData({
						"maskedInput": patwlApplicantDetailsVm.personalDetails.email
						, "type": "email"
					}, type);
				}
				patwlApplicantDetailsVm.isMaskEmail = !patwlApplicantDetailsVm.isMaskEmail;
			}
		}

		patwlApplicantDetailsVm.toggleEye = function (type) {
			patwlApplicantDetailsVm.isTextReadable == true ? patwlApplicantDetailsVm.isTextReadable = false : patwlApplicantDetailsVm.isTextReadable = true;
			if (type === "email") {
				patwlApplicantDetailsVm.emailMaskUnmask = patwlApplicantDetailsVm.isTextReadable;
			}
		};

		patwlApplicantDetailsVm.checkEmailValue = function () {
			if (patwlService.isValidField(patwlApplicantDetailsVm.personalDetails.email, "Email ID")) {
				patwlApplicantDetailsVm.errObj.emailError = patwlService.isValidField(patwlApplicantDetailsVm.personalDetails.email, "Email ID");
			} else {
				if (!mailformat.test(patwlApplicantDetailsVm.personalDetails.email)) {
					patwlApplicantDetailsVm.errObj.emailError = "Please enter correct email id containing @ symbol followed by valid domain name.";
				} else {
					patwlApplicantDetailsVm.errObj.emailError = '';
				}
			}
		}

		patwlApplicantDetailsVm.checkAddress = function (val) {
			switch (val) {
				case 'Line1':
					if (patwlService.isValidField(patwlApplicantDetailsVm.currentAddressObj.addLine1, "Address Line 1")) {
						patwlApplicantDetailsVm.errObj.addLine1Error = patwlService.isValidField(patwlApplicantDetailsVm.personalDetails.addLine1, "Address Line 1");
					} else {
						patwlApplicantDetailsVm.errObj.addLine1Error = '';
					}
					break;
				case 'Line2':
					if (patwlService.isValidField(patwlApplicantDetailsVm.currentAddressObj.addLine2, "Address Line 2")) {
						patwlApplicantDetailsVm.errObj.addLine2Error = patwlService.isValidField(patwlApplicantDetailsVm.personalDetails.addLine2, "Address Line 2");
					} else {
						patwlApplicantDetailsVm.errObj.addLine2Error = '';
					}
					break;
				case 'Pincode':
					if (patwlService.isValidField(patwlApplicantDetailsVm.currentAddressObj.pincode, "pincode")) {
						patwlApplicantDetailsVm.errObj.pincodeError = patwlService.isValidField(patwlApplicantDetailsVm.personalDetails.pincode, "pincode");
					} else {
						if ((patwlApplicantDetailsVm.currentAddressObj.pincode.length != 6) || (!pinRegex.test(patwlApplicantDetailsVm.currentAddressObj.pincode))) {
							patwlApplicantDetailsVm.errObj.pincodeError = 'Pin code should be of six digits (0-9) and should not start with zero.”';
						} else {
							patwlApplicantDetailsVm.errObj.pincodeError = '';
						}
					}
					break;
				case 'City':
					if (patwlService.isValidField(patwlApplicantDetailsVm.currentAddressObj.city, "city")) {
						patwlApplicantDetailsVm.errObj.cityError = patwlService.isValidField(patwlApplicantDetailsVm.personalDetails.city, "city");
					} else {
						patwlApplicantDetailsVm.errObj.cityError = '';
					}
					break;
				case 'State':
					if (patwlService.isValidField(patwlApplicantDetailsVm.currentAddressObj.state, "state")) {
						patwlApplicantDetailsVm.errObj.stateError = patwlService.isValidField(patwlApplicantDetailsVm.personalDetails.state, "state");
					} else {
						patwlApplicantDetailsVm.errObj.stateError = '';
					}
					break;
				default:

			}
		}

		patwlApplicantDetailsVm.checkEmployerDetail = function (val) {
			switch (val) {
				case 'Name':
					if (patwlService.isValidField(patwlApplicantDetailsVm.employementObj.emplyerName, "employer name")) {
						patwlApplicantDetailsVm.errObj.employerNameError = patwlService.isValidField(patwlApplicantDetailsVm.employementObj.emplyerName, "employer name");
					} else {
						patwlApplicantDetailsVm.errObj.employerNameError = '';
					}
					break;
				case 'Contact':
					if (patwlService.isValidField(patwlApplicantDetailsVm.employementObj.contact, "employer contact number")) {
						patwlApplicantDetailsVm.errObj.employerContactError = patwlService.isValidField(patwlApplicantDetailsVm.employementObj.contact, "employer contact number");
					}
					else {
						if (patwlApplicantDetailsVm.employementObj.contact.length < 10) {
							patwlApplicantDetailsVm.errObj.employerContactError = 'Please enter valid employer contact number'
						}
						else if (!phnReg.test(patwlApplicantDetailsVm.employementObj.contact)) {
							patwlApplicantDetailsVm.errObj.employerContactError = 'Please enter valid employer contact number'
						} else {
							patwlApplicantDetailsVm.errObj.employerContactError = '';
						}
					}
					break;
				case 'Addr1':
					if (patwlService.isValidField(patwlApplicantDetailsVm.employementObj.addreLine1, "Address Line 1")) {
						patwlApplicantDetailsVm.errObj.emprAdd1Error = patwlService.isValidField(patwlApplicantDetailsVm.employementObj.addreLine1, "Address Line 1");
					} else {
						patwlApplicantDetailsVm.errObj.emprAdd1Error = '';
					}
					break;
				case 'Addr2':
					if (patwlService.isValidField(patwlApplicantDetailsVm.employementObj.addreLine2, "Address Line 2")) {
						patwlApplicantDetailsVm.errObj.emprAdd2Error = patwlService.isValidField(patwlApplicantDetailsVm.employementObj.addreLine2, "Address Line 2");
					} else {
						patwlApplicantDetailsVm.errObj.emprAdd2Error = '';
					}
					break;
				case 'Pincode':
					if (patwlService.isValidField(patwlApplicantDetailsVm.employementObj.pincode, "pincode")) {
						patwlApplicantDetailsVm.errObj.emprPincodeError = patwlService.isValidField(patwlApplicantDetailsVm.employementObj.pincode, "pincode");
					} else {
						if (patwlApplicantDetailsVm.employementObj.pincode.length < 6 || (!pinRegex.test(patwlApplicantDetailsVm.employementObj.pincode))) {
							patwlApplicantDetailsVm.errObj.emprPincodeError = 'please enter valid pincode'
						} else {
							patwlApplicantDetailsVm.errObj.emprPincodeError = '';
						}
					}
					break;
				case 'Profession':
					if (patwlService.isValidField(patwlApplicantDetailsVm.employementObj.professionType, "profession type")) {
						patwlApplicantDetailsVm.errObj.professionTypeError = patwlService.isValidField(patwlApplicantDetailsVm.employementObj.professionType, "profession type");
					} else {
						patwlApplicantDetailsVm.errObj.professionTypeError = '';
					}
					break;
				default:
			}
		}

		patwlApplicantDetailsVm.changeEmplyementType = function (emp) {
			patwlApplicantDetailsVm.employementObj = {};
			if (emp == 'Salaried') {
				patwlApplicantDetailsVm.isSalaried = true;
				patwlApplicantDetailsVm.employementObj.empType = emp;
			} else {
				patwlApplicantDetailsVm.isSalaried = false;
				patwlApplicantDetailsVm.employementObj.empType = emp;
			}
			patwlApplicantDetailsVm.clearEmplyomentError();
		}



		patwlApplicantDetailsVm.clearEmplyomentError = function () {
			patwlApplicantDetailsVm.errObj.employerNameError = '';
			patwlApplicantDetailsVm.errObj.employerContactError = '';
			patwlApplicantDetailsVm.errObj.emprAdd1Error = '';
			patwlApplicantDetailsVm.errObj.emprAdd2Error = '';
			patwlApplicantDetailsVm.errObj.emprPincodeError = '';
			patwlApplicantDetailsVm.errObj.professionTypeError = '';
		}

		patwlApplicantDetailsVm.selectAddressType = function (AddrType) {
			patwlApplicantDetailsVm.currentAddressObj = {};
			if (AddrType == 'Permanent') {
				patwlApplicantDetailsVm.isPermanentAddress = true;
				patwlApplicantDetailsVm.currentAddressObj.addressType = 'Permanent';
			} else {
				patwlApplicantDetailsVm.isPermanentAddress = false;
				patwlApplicantDetailsVm.currentAddressObj.addressType = 'Current';
			}

			patwlApplicantDetailsVm.clearAddressError();

		}

		patwlApplicantDetailsVm.clearAddressError = function () {
			patwlApplicantDetailsVm.errObj.addLine1Error = '';
			patwlApplicantDetailsVm.errObj.addLine2Error = '';
			patwlApplicantDetailsVm.errObj.pincodeError = '';
			patwlApplicantDetailsVm.errObj.cityError = '';
			patwlApplicantDetailsVm.errObj.stateError = '';
		}


		patwlApplicantDetailsVm.changeTab = function (type, val) {
			if (type == 'Personal') {
				patwlApplicantDetailsVm.parsonalTab = !patwlApplicantDetailsVm.parsonalTab;
				patwlApplicantDetailsVm.addressTab = false;
				patwlApplicantDetailsVm.workTab = false;
			} else if (type == 'Address') {
				patwlApplicantDetailsVm.addressTab = !patwlApplicantDetailsVm.addressTab;
				patwlApplicantDetailsVm.parsonalTab = false;
				patwlApplicantDetailsVm.workTab = false;
				patwlApplicantDetailsVm.errObj.AddressError = '';
			} else if (type == 'Work') {
				patwlApplicantDetailsVm.workTab = !patwlApplicantDetailsVm.workTab;
				patwlApplicantDetailsVm.parsonalTab = false;
				patwlApplicantDetailsVm.addressTab = false;
			}
		}


		patwlApplicantDetailsVm.goBack = function () {
			$ionicHistory.goBack(-1);
		}

		patwlApplicantDetailsVm.validatePersonalDetails = function () {
			var isValid = true;
			if (!patwlApplicantDetailsVm.email) {

				if (patwlApplicantDetailsVm.personalDetails.email == '' || patwlApplicantDetailsVm.personalDetails.email == null || patwlApplicantDetailsVm.personalDetails.email == undefined) {
					patwlApplicantDetailsVm.errObj.emailError = 'Please enter email Id.';
					isValid = false;
				} else {
					if (!mailformat.test(patwlApplicantDetailsVm.personalDetails.email)) {
						patwlApplicantDetailsVm.errObj.emailError = "Please enter correct email id containing @ symbol followed by valid domain name.";
						isValid = false;
					} else {
						patwlApplicantDetailsVm.errObj.emailError = '';
					}
				}
			}
			if (!patwlApplicantDetailsVm.personalDetails.personalDetailsCheck) {
				$ionicScrollDelegate.scrollBottom();
				patwlApplicantDetailsVm.errObj.confirmCheckError = "Please tick the above box to proceed";
				isValid = false;
			} else {
				patwlApplicantDetailsVm.errObj.confirmCheckError = "";
			}

			if (!patwlApplicantDetailsVm.parsonalTab && !isValid) {
				// patwlApplicantDetailsVm.changeTab('Personal','Open')
				$ionicScrollDelegate.scrollTop();
				patwlApplicantDetailsVm.errObj.personalDetailError = "Please enter missing detail.";
			} else {
				patwlApplicantDetailsVm.errObj.personalDetailError = '';
			}
			return isValid;
		}

		patwlApplicantDetailsVm.validateAddressDetails = function () {
			var isValid = true;
			if (patwlApplicantDetailsVm.currentAddressObj.addressType != 'Permanent') {
				if (patwlApplicantDetailsVm.currentAddressObj.addLine1 == '' || patwlApplicantDetailsVm.currentAddressObj.addLine1 == null || patwlApplicantDetailsVm.currentAddressObj.addLine1 == undefined) {
					patwlApplicantDetailsVm.errObj.addLine1Error = 'Please provide address 1.';
					isValid = false;
				} else {
					patwlApplicantDetailsVm.errObj.addLine1Error = '';
				}
				if (patwlApplicantDetailsVm.currentAddressObj.addLine2 == '' || patwlApplicantDetailsVm.currentAddressObj.addLine2 == null || patwlApplicantDetailsVm.currentAddressObj.addLine2 == undefined) {
					patwlApplicantDetailsVm.errObj.addLine2Error = 'Please provide address 2.';
					isValid = false;
				} else {
					patwlApplicantDetailsVm.errObj.addLine2Error = '';
				}
				if (patwlApplicantDetailsVm.currentAddressObj.pincode == '' || patwlApplicantDetailsVm.currentAddressObj.pincode == null || patwlApplicantDetailsVm.currentAddressObj.pincode == undefined) {
					patwlApplicantDetailsVm.errObj.pincodeError = 'Please provide pincode.';
					isValid = false;
				} else {
					if ((patwlApplicantDetailsVm.currentAddressObj.pincode.length != 6) || (!pinRegex.test(patwlApplicantDetailsVm.currentAddressObj.pincode))) {
						patwlApplicantDetailsVm.errObj.pincodeError = 'Pin code should be of six digits (0-9) and should not start with zero.”';
						isValid = false;
					} else {
						patwlApplicantDetailsVm.errObj.pincodeError = '';
					}

				}
				if (patwlApplicantDetailsVm.currentAddressObj.city == '' || patwlApplicantDetailsVm.currentAddressObj.city == null || patwlApplicantDetailsVm.currentAddressObj.city == undefined) {
					patwlApplicantDetailsVm.errObj.cityError = 'Please provide city.';
					isValid = false;
				} else {
					patwlApplicantDetailsVm.errObj.cityError = '';
				}
				if (patwlApplicantDetailsVm.currentAddressObj.state == '' || patwlApplicantDetailsVm.currentAddressObj.state == null || patwlApplicantDetailsVm.currentAddressObj.state == undefined) {
					patwlApplicantDetailsVm.errObj.stateError = 'Please provide state.';
					isValid = false;
				} else {
					patwlApplicantDetailsVm.errObj.stateError = '';
				}

				if (!patwlApplicantDetailsVm.addressTab && !isValid) {
					//patwlApplicantDetailsVm.changeTab('Address','Open')
					patwlApplicantDetailsVm.errObj.AddressError = 'Please enter missing details.';
				} else {
					patwlApplicantDetailsVm.errObj.AddressError = '';
				}
			}
			return isValid;
		}

		patwlApplicantDetailsVm.validateWorkDetails = function () {
			var isValid = true;
			if (patwlApplicantDetailsVm.employementObj.empType == 'NonSalaried') {
				if (patwlApplicantDetailsVm.employementObj.professionType == '' || patwlApplicantDetailsVm.employementObj.professionType == null || patwlApplicantDetailsVm.employementObj.professionType == undefined) {
					isValid = false;
					patwlApplicantDetailsVm.errObj.professionTypeError = 'Please enter profession type';
				} else {
					patwlApplicantDetailsVm.errObj.professionTypeError = '';
				}
			} else {
				if (patwlApplicantDetailsVm.employementObj.emplyerName == '' || patwlApplicantDetailsVm.employementObj.emplyerName == null || patwlApplicantDetailsVm.employementObj.emplyerName == undefined) {
					isValid = false;
					patwlApplicantDetailsVm.errObj.employerNameError = 'Please enter employer name';
				} else {
					patwlApplicantDetailsVm.errObj.employerNameError = '';
				}
				if (patwlApplicantDetailsVm.employementObj.contact == '' || patwlApplicantDetailsVm.employementObj.contact == null || patwlApplicantDetailsVm.employementObj.contact == undefined) {
					isValid = false;
					patwlApplicantDetailsVm.errObj.employerContactError = 'Please enter employer contact number';
				} else {
					if (patwlApplicantDetailsVm.employementObj.contact.length < 10) {
						patwlApplicantDetailsVm.errObj.employerContactError = 'Please enter valid employer contact number'
					}
					else if (!phnReg.test(patwlApplicantDetailsVm.employementObj.contact)) {
						patwlApplicantDetailsVm.errObj.employerContactError = 'Please enter valid employer contact number'
					} else {
						patwlApplicantDetailsVm.errObj.employerContactError = '';
					}

				}
				if (patwlApplicantDetailsVm.employementObj.addreLine1 == '' || patwlApplicantDetailsVm.employementObj.addreLine1 == null || patwlApplicantDetailsVm.employementObj.addreLine1 == undefined) {
					isValid = false;
					patwlApplicantDetailsVm.errObj.emprAdd1Error = 'Please enter Address Line 1';
				} else {
					patwlApplicantDetailsVm.errObj.emprAdd1Error = '';
				}
				if (patwlApplicantDetailsVm.employementObj.addreLine2 == '' || patwlApplicantDetailsVm.employementObj.addreLine2 == null || patwlApplicantDetailsVm.employementObj.addreLine2 == undefined) {
					isValid = false;
					patwlApplicantDetailsVm.errObj.emprAdd2Error = 'Please enter Address line 2';
				} else {
					patwlApplicantDetailsVm.errObj.emprAdd2Error = '';
				}
				if (patwlApplicantDetailsVm.employementObj.pincode == '' || patwlApplicantDetailsVm.employementObj.pincode == null || patwlApplicantDetailsVm.employementObj.pincode == undefined) {
					isValid = false;
					patwlApplicantDetailsVm.errObj.emprPincodeError = 'Please enter pincode';
				} else {
					if (patwlApplicantDetailsVm.employementObj.pincode.length < 6 || (!pinRegex.test(patwlApplicantDetailsVm.employementObj.pincode))) {
						patwlApplicantDetailsVm.errObj.emprPincodeError = 'please enter valid pincode'
						isValid = false;
					} else {
						patwlApplicantDetailsVm.errObj.emprPincodeError = '';
					}
				}
			}
			if (!patwlApplicantDetailsVm.workTab && !isValid) {
				//patwlApplicantDetailsVm.changeTab('Work','Open')
				patwlApplicantDetailsVm.errObj.workdetailsTypeError = 'Please enter details.';
			} else {
				patwlApplicantDetailsVm.errObj.workdetailsTypeError = '';
			}
			return isValid;
		}


		patwlApplicantDetailsVm.applyLoan = function () {
			if (!patwlApplicantDetailsVm.validatePersonalDetails()) {
				return;
			}
			else if (!patwlApplicantDetailsVm.validateAddressDetails()) {
				return;
			}
			else if (!patwlApplicantDetailsVm.validateWorkDetails()) {
				return;
			}
			else if (!patwlApplicantDetailsVm.finalConsentCheck) {
				patwlApplicantDetailsVm.errObj.finalConsentCheck = 'Please tick the above box to proceed';
				return;
			}
			else {
				patwlApplicantDetailsVm.errObj.finalConsentCheck = '';
				var dataObject = {};
				if (!patwlApplicantDetailsVm.personalDetails.isEmailID) {
					dataObject.email = patwlApplicantDetailsVm.personalDetails.email;
				}
				dataObject.permanentAddressConsent = patwlApplicantDetailsVm.personalDetails.personalDetailsCheck;
				dataObject.addressType = patwlApplicantDetailsVm.currentAddressObj.addressType;
				if (dataObject.addressType == 'Current') {
					dataObject.addressDetails = {};
					dataObject.addressDetails.addressLine1 = patwlApplicantDetailsVm.currentAddressObj.addLine1 ? patwlApplicantDetailsVm.currentAddressObj.addLine1: '';
					dataObject.addressDetails.addressLine2 = patwlApplicantDetailsVm.currentAddressObj.addLine2 ? patwlApplicantDetailsVm.currentAddressObj.addLine2: '';
					dataObject.addressDetails.addressLine3 = patwlApplicantDetailsVm.currentAddressObj.addLine3 ? patwlApplicantDetailsVm.currentAddressObj.addLine3: '';
					dataObject.addressDetails.pinCode = patwlApplicantDetailsVm.currentAddressObj.pincode ? patwlApplicantDetailsVm.currentAddressObj.pincode:'';
					dataObject.addressDetails.city = patwlApplicantDetailsVm.currentAddressObj.city ? patwlApplicantDetailsVm.currentAddressObj.city:'';
					dataObject.addressDetails.state = patwlApplicantDetailsVm.currentAddressObj.state ? patwlApplicantDetailsVm.currentAddressObj.state:'';
				}
				dataObject.workType = patwlApplicantDetailsVm.employementObj.empType ? patwlApplicantDetailsVm.employementObj.empType :'';
				if (dataObject.workType == 'Salaried') {
					dataObject.workDetails = {};
					dataObject.workDetails.employerName = patwlApplicantDetailsVm.employementObj.emplyerName ? patwlApplicantDetailsVm.employementObj.emplyerName:'';
					dataObject.workDetails.employerContactNo = patwlApplicantDetailsVm.employementObj.contact ? patwlApplicantDetailsVm.employementObj.contact:'';
					dataObject.workDetails.addressLine1 = patwlApplicantDetailsVm.employementObj.addreLine1 ? patwlApplicantDetailsVm.employementObj.addreLine1:'';
					dataObject.workDetails.addressLine2 = patwlApplicantDetailsVm.employementObj.addreLine2 ? patwlApplicantDetailsVm.employementObj.addreLine2:'';
					dataObject.workDetails.pinCode = patwlApplicantDetailsVm.employementObj.pincode ? patwlApplicantDetailsVm.employementObj.pincode: '';
				} else {
					dataObject.profession = patwlApplicantDetailsVm.employementObj.professionType ? patwlApplicantDetailsVm.employementObj.professionType: '';
				}
				dataObject.shareInformationConsent = patwlApplicantDetailsVm.finalConsentCheck;
				patwlService.getInterestRate(dataObject).then(function (response){
					patwlService.applicationDetailResponse = response;
					patwlService.setApplicantPageData({
						"parsonal": patwlApplicantDetailsVm.personalDetails,
						"address": patwlApplicantDetailsVm.currentAddressObj,
						"work": patwlApplicantDetailsVm.employementObj
					})
					patwlService.setLoanDetailData();
					patwlService.showAlertPopupForRTOAlert("", "Vehicle to be registered with RTO as per address selected.", "",
						"menu.patwlLoanDetails", "OK", "", "", "");
				}, function (error) {
					if (error.responseCode == "GI01") {
						if (homeScreenService.offersData.length > 0) {
							for (var i = 0; i < homeScreenService.offersData.length; i++) {
								if (homeScreenService.offersData[i].category == "PA2WL") {
									homeScreenService.offersData.splice(i, 1);
								}
							}
						}
						patwlService.showAlertPopup("error", error.responseMessage, "", "menu.homeScreen", "OK", "", "", "");
					} else {
						utilityService.showErrorMessage(error.responseMessage);
					}
				});
			}
		}

		$scope.$on('$ionicView.loaded', function () {

		});

		$scope.$on('$ionicView.beforeEnter', function () {
			patwlApplicantDetailsVm.initPage();
		});

		return this;
	}

]);


