'use strict';
angularApp.controller('patwlLandingPageController', [
	"$state",
	"$scope",
	"$ionicPopup",
	"$translate",
	"$ionicHistory",
	"utilityService",
	"ionicDatePicker",
	"$ionicSideMenuDelegate",
	"$ionicScrollDelegate",
	"customerInfoService",
	"validateService",
	"$filter", "patwlService",
	function ($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate,
		$ionicScrollDelegate, customerInfoService, validateService, $filter, patwlService) {

		var patwlLandingPageVm = this;
		patwlLandingPageVm.offerDetails = {};

		patwlLandingPageVm.initPage = function () {
			patwlLandingPageVm.offerDetails = patwlService.getInitailEligibilityData();
			patwlLandingPageVm.loanMaxAmount = patwlLandingPageVm.offerDetails.maxLoanAmt;
			patwlLandingPageVm.emiAmount = patwlLandingPageVm.offerDetails.maxPermissibleEmi;
			patwlLandingPageVm.maxTenure = patwlLandingPageVm.offerDetails.maxTenure / 12;
			patwlLandingPageVm.interestRate = patwlLandingPageVm.offerDetails.interestRate;
		}

		patwlLandingPageVm.goBack = function () {
			$ionicHistory.goBack(-1);
		}

		patwlLandingPageVm.applyLoan = function () {
			patwlService.clearAll();
			patwlLandingPageVm.getCustomerDetails();
		}

		patwlLandingPageVm.getCustomerDetails = function () {
			patwlService.getCustomerBasicDetails().then(function (response) {
				patwlService.setCustomerData(response);
				$state.go('menu.patwlApplicantDetails');
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		}

		$scope.$on('$ionicView.loaded', function () {

		});

		$scope.$on('$ionicView.beforeEnter', function () {
			patwlLandingPageVm.initPage();
		});

		return this;
	}

]);


