'use strict';

angularApp.controller('patwlLoanDetailsController', [
    "$state",
    "$scope",
    "$translate",
    "$ionicSideMenuDelegate",
    "$filter", "$ionicPopover", "$ionicPopup", "utilityService", "patwlService",

    function ($state,
        $scope,
        $translate,
        $ionicSideMenuDelegate,
        $filter, $ionicPopover, $ionicPopup, utilityService, patwlService) {

        var patwlLoanDetailsVm = this;

        patwlLoanDetailsVm.initPage = function () {
            patwlLoanDetailsVm.loanDetailData = {};
            var today = new Date();
            var defaultDate = new Date(today.getFullYear(), today.getMonth(), today.getDate() + 1);
            patwlLoanDetailsVm.tenureList = [];
            patwlLoanDetailsVm.vehicleMakeList = [];
            patwlLoanDetailsVm.cityList = [];
            patwlLoanDetailsVm.cityList = patwlService.applicationDetailResponse.cityList;
            patwlLoanDetailsVm.vehicleModelList = [];
            patwlLoanDetailsVm.vehicleVariantList = [];

            patwlLoanDetailsVm.dealerList = [];
            $scope.dateobj = {};
            $scope.dateobj.dt = defaultDate;
            patwlLoanDetailsVm.amount = {};
            patwlLoanDetailsVm.vehicleObj = {};
            patwlLoanDetailsVm.errVehicleObj = {};
            patwlLoanDetailsVm.processingFeeGST = patwlService.applicationDetailResponse.gst;
            patwlLoanDetailsVm.rateOfIntrest = patwlService.applicationDetailResponse.roi;
            patwlLoanDetailsVm.vehicleOnRoadPercent = parseFloat(patwlService.applicationDetailResponse.vehicleOnRoadPercent);
            patwlLoanDetailsVm.dealerOnRoadPercent = parseFloat(patwlService.applicationDetailResponse.dealerOnRoadPercent);
            patwlLoanDetailsVm.constantProcessingFee = parseFloat(patwlService.applicationDetailResponse.constantProcessingFee);
            patwlLoanDetailsVm.vehicleMakeList = patwlService.applicationDetailResponse.vehicleMakeList;

            patwlLoanDetailsVm.loanDetailData = patwlService.getInitailEligibilityData();
            patwlLoanDetailsVm.vehicleObj.vehicleOnRoadPrice = 0;
            patwlLoanDetailsVm.maxEligibleLoanAmnt = patwlLoanDetailsVm.loanDetailData.maxLoanAmt;

            // Processing Fee Calculation
            patwlLoanDetailsVm.processingFeePercent = patwlLoanDetailsVm.loanDetailData.processingFee;
            patwlLoanDetailsVm.calculateProcessingFee(patwlLoanDetailsVm.maxEligibleLoanAmnt, patwlLoanDetailsVm.processingFeePercent, patwlLoanDetailsVm.processingFeeGST);
            patwlLoanDetailsVm.amount.min = patwlLoanDetailsVm.loanDetailData.minLoanAmt;
            patwlLoanDetailsVm.amount.max = patwlLoanDetailsVm.maxEligibleLoanAmnt;
            patwlLoanDetailsVm.amount.step = patwlService.applicationDetailResponse.loanStepping;
            patwlLoanDetailsVm.amount.initial = patwlLoanDetailsVm.amount.max;
            patwlLoanDetailsVm.updateAmtSlider();
            patwlLoanDetailsVm.createTenureData(patwlService.applicationDetailResponse.tenureInMonths, patwlLoanDetailsVm.rateOfIntrest);
            if (patwlService.getLoanDetailData()) {
                patwlLoanDetailsVm.loanDetailData = patwlService.getLoanDetailData();
                patwlLoanDetailsVm.vehicleObj.make = patwlLoanDetailsVm.loanDetailData.vehicleMake;
                patwlLoanDetailsVm.getModelList(patwlLoanDetailsVm.vehicleObj.make.vehicleMfrId);
                patwlLoanDetailsVm.vehicleObj.model = patwlLoanDetailsVm.loanDetailData.vehicleModel;
                patwlLoanDetailsVm.getVariantList(patwlLoanDetailsVm.vehicleObj.model.vehicleModeId,patwlLoanDetailsVm.loanDetailData.city.twnCtyID);
                patwlLoanDetailsVm.vehicleObj.variant = patwlLoanDetailsVm.loanDetailData.vehicleVariant;
                patwlLoanDetailsVm.city = patwlLoanDetailsVm.loanDetailData.city;
                patwlLoanDetailsVm.selectCity(patwlLoanDetailsVm.city.twnCtyID);
                patwlLoanDetailsVm.vehicleObj.dealer = patwlLoanDetailsVm.loanDetailData.dealer;
                patwlLoanDetailsVm.getOtherDetail(patwlLoanDetailsVm.vehicleObj.dealer, patwlLoanDetailsVm.loanDetailData.vehicleVariant.vehicleId);
                patwlLoanDetailsVm.vehicleObj.vehicleOnRoadPrice = patwlLoanDetailsVm.loanDetailData.vehiclePrice.onRoadPrice;
                patwlLoanDetailsVm.vehicleObj.dealerQuoteOnRoadPrice = patwlLoanDetailsVm.loanDetailData.dealerQuotedPrice;
                patwlLoanDetailsVm.amountSlider.value = patwlLoanDetailsVm.loanDetailData.loanAmount;
                patwlLoanDetailsVm.amount.initial = patwlLoanDetailsVm.loanDetailData.loanAmount;
                patwlLoanDetailsVm.amount.max = patwlLoanDetailsVm.loanDetailData.max;
                patwlLoanDetailsVm.myContri = patwlLoanDetailsVm.loanDetailData.myContribution;
                patwlLoanDetailsVm.processingFee = patwlLoanDetailsVm.loanDetailData.processingFee;
                patwlLoanDetailsVm.repayStartDate = patwlLoanDetailsVm.loanDetailData.repaymentStartDate;
                patwlLoanDetailsVm.rateOfIntrest = patwlLoanDetailsVm.loanDetailData.interestRate;
                for (var i = 0; i < patwlLoanDetailsVm.tenureList.length; i++) {
                    if (patwlLoanDetailsVm.selectedTenureRadio == patwlLoanDetailsVm.tenureList[i].tenure) {
                        patwlLoanDetailsVm.selectedTenureRadio = patwlLoanDetailsVm.loanDetailData.tenure;
                        patwlLoanDetailsVm.tenure = patwlLoanDetailsVm.loanDetailData.tenure;
                        patwlLoanDetailsVm.estimatedEMI = patwlLoanDetailsVm.loanDetailData.emi;
                    }
                }
                patwlLoanDetailsVm.updateAmtSlider();
                patwlLoanDetailsVm.emiCalculation();
            } else {
                var tenureListLength = patwlLoanDetailsVm.tenureList.length - 1;
                patwlLoanDetailsVm.selectedTenureRadio = patwlLoanDetailsVm.tenureList[tenureListLength].tenure;
                patwlLoanDetailsVm.tenure = patwlLoanDetailsVm.tenureList[tenureListLength].tenure;
                patwlLoanDetailsVm.estimatedEMI = patwlLoanDetailsVm.tenureList[tenureListLength].estimatedEMI;
            }
        };


        patwlLoanDetailsVm.clearData = function (val) {
            switch (val) {
                case 'City':
                    patwlLoanDetailsVm.vehicleObj.make = '';
                    patwlLoanDetailsVm.vehicleModelList = [];
                    patwlLoanDetailsVm.vehicleObj.model = '';
                    patwlLoanDetailsVm.vehicleVariantList = [];
                    patwlLoanDetailsVm.vehicleObj.variant = '';
                    patwlLoanDetailsVm.dealerList = [];
                    patwlLoanDetailsVm.vehicleObj.dealer = '';
                    patwlLoanDetailsVm.vehicleObj.loanBranch = '';
                    patwlLoanDetailsVm.vehicleObj.vehicleOnRoadPrice = '';
                    patwlLoanDetailsVm.vehicleObj.dealerQuoteOnRoadPrice = '';
                    break;
                case 'Make':
                    patwlLoanDetailsVm.vehicleModelList = [];
                    patwlLoanDetailsVm.vehicleObj.model = '';
                    patwlLoanDetailsVm.vehicleVariantList = [];
                    patwlLoanDetailsVm.vehicleObj.variant = '';
                    patwlLoanDetailsVm.dealerList = [];
                    patwlLoanDetailsVm.vehicleObj.dealer = '';
                    patwlLoanDetailsVm.vehicleObj.loanBranch = '';
                    patwlLoanDetailsVm.vehicleObj.vehicleOnRoadPrice = '';
                    patwlLoanDetailsVm.vehicleObj.dealerQuoteOnRoadPrice = '';
                    break;
                case 'Model':
                    patwlLoanDetailsVm.vehicleVariantList = [];
                    patwlLoanDetailsVm.vehicleObj.variant = '';
                    patwlLoanDetailsVm.dealerList = [];
                    patwlLoanDetailsVm.vehicleObj.dealer = '';
                    patwlLoanDetailsVm.vehicleObj.loanBranch = '';
                    patwlLoanDetailsVm.vehicleObj.vehicleOnRoadPrice = '';
                    patwlLoanDetailsVm.vehicleObj.dealerQuoteOnRoadPrice = '';
                    break;
                case 'Variant':
                    patwlLoanDetailsVm.dealerList = [];
                    patwlLoanDetailsVm.vehicleObj.dealer = '';
                    patwlLoanDetailsVm.vehicleObj.loanBranch = '';
                    patwlLoanDetailsVm.vehicleObj.vehicleOnRoadPrice = '';
                    patwlLoanDetailsVm.vehicleObj.dealerQuoteOnRoadPrice = '';
                    break;
                case 'Dealer':
                    patwlLoanDetailsVm.vehicleObj.loanBranch = '';
                    patwlLoanDetailsVm.vehicleObj.vehicleOnRoadPrice = '';
                    patwlLoanDetailsVm.vehicleObj.dealerQuoteOnRoadPrice = '';
                    break;

            }
        }

        patwlLoanDetailsVm.calculateProcessingFee = function (amnt, feePercent, gst) {
            patwlLoanDetailsVm.processingFeeWithoutGST = parseFloat((feePercent / 100) * amnt);
            patwlLoanDetailsVm.processingFeeWithGST = parseFloat((gst / 100) * patwlLoanDetailsVm.processingFeeWithoutGST);
            patwlLoanDetailsVm.actualProcessingFee = parseFloat(patwlLoanDetailsVm.processingFeeWithoutGST + patwlLoanDetailsVm.processingFeeWithGST);

            patwlLoanDetailsVm.processingFeeMinWithoutGST = parseFloat((gst / 100) * patwlLoanDetailsVm.constantProcessingFee);
            patwlLoanDetailsVm.processingFeeMinWithGST = parseFloat(patwlLoanDetailsVm.processingFeeMinWithoutGST + patwlLoanDetailsVm.constantProcessingFee);

            if (patwlLoanDetailsVm.actualProcessingFee > patwlLoanDetailsVm.processingFeeMinWithGST) {
                patwlLoanDetailsVm.processingFee = patwlLoanDetailsVm.actualProcessingFee.toFixed(2);
            } else {
                patwlLoanDetailsVm.processingFee = patwlLoanDetailsVm.processingFeeMinWithGST.toFixed(2);
            }
        }

        patwlLoanDetailsVm.getModelList = function (key) {
            patwlLoanDetailsVm.clearData('Make');
            var payload = {
                "vehicleMfrId": key
            };
            patwlService.getVehicleModelList(payload).then(function (response) {
                patwlLoanDetailsVm.vehicleModelList = response.vehicleModelList;
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        patwlLoanDetailsVm.getVariantList = function (key,cityId) {
            patwlLoanDetailsVm.clearData('Model');
            var payload = {
                "vehicleModeId": key,
                "twnCtyID": cityId
            };
            patwlService.getVehicleVariantList(payload).then(function (response) {
                patwlLoanDetailsVm.vehicleVariantList = [];
                patwlLoanDetailsVm.vehicleVariantList = response.vehicleVariantList;
            }, function (error) {
                patwlLoanDetailsVm.vehicleObj.make = '';
                patwlLoanDetailsVm.vehicleModelList = [];
                patwlLoanDetailsVm.vehicleObj.model = '';
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        patwlLoanDetailsVm.selectCity = function (cityObj) {
            patwlLoanDetailsVm.clearData('Variant');
            var payload = {
                "twnCtyID": cityObj
            }
            patwlService.getDealerList(payload).then(function (response) {
                patwlLoanDetailsVm.dealerList = [];
                patwlLoanDetailsVm.dealerList = response.dealerList;
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        patwlLoanDetailsVm.getOtherDetail = function (dealer,key) {
            var payload = {
                "vehicleId": key
            }
            // patwlLoanDetailsVm.clearData('Dealer')
            patwlLoanDetailsVm.vehicleObj.loanBranch = dealer.autoHubBranchName;
            patwlService.getOtherDetails(payload).then(function (response) {
                patwlLoanDetailsVm.vehicleObj.vehicleOnRoadPrice = response.vehiclePriceList[0].onRoadPrice;
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }


        patwlLoanDetailsVm.createTenureData = function (tenures, roi) {
            for (var i = 0; i < tenures.length; i++) {
                var tempList = {};
                tempList.id = i;
                tempList.tenure = tenures[i];
                tempList.roi = roi;
                tempList.estimatedEMI = 0;
                patwlLoanDetailsVm.tenureList.push(tempList);
            }
            var arrayCount = patwlLoanDetailsVm.tenureList.length - 1;
            patwlLoanDetailsVm.selectedTenureRadio = patwlLoanDetailsVm.tenureList[arrayCount].tenure;
            patwlLoanDetailsVm.emiCalculation();
        }

        patwlLoanDetailsVm.calculateSliderMaxLoanAmount = function () {
            if (patwlService.isValidField(patwlLoanDetailsVm.vehicleObj.dealerQuoteOnRoadPrice, "Dealer Quoted On Road Price")) {
                patwlLoanDetailsVm.errVehicleObj.dealerQuoteOnRoadPriceError = patwlService.isValidField(patwlLoanDetailsVm.vehicleObj.dealerQuoteOnRoadPrice, "Dealer Quoted On Road Price");
            } else {
                var vehiclePricePercent = (patwlLoanDetailsVm.vehicleOnRoadPercent/100) * parseInt(patwlLoanDetailsVm.vehicleObj.vehicleOnRoadPrice);
                var priceCheckPlus = parseInt(patwlLoanDetailsVm.vehicleObj.vehicleOnRoadPrice) + parseInt(vehiclePricePercent);
                var priceCheckMinus = parseInt(patwlLoanDetailsVm.vehicleObj.vehicleOnRoadPrice) - parseInt(vehiclePricePercent);
                if ((parseInt(patwlLoanDetailsVm.vehicleObj.dealerQuoteOnRoadPrice) > priceCheckPlus) || (parseInt(patwlLoanDetailsVm.vehicleObj.dealerQuoteOnRoadPrice) < priceCheckMinus)) {
                    patwlService.showAlertPopupForAmountMismatch("alert", "The amount entered by you is not matching as per selected vehicle on road price.", "Please check with dealer and resume again.", "menu.patwlLoanDetails", "OK", "Go Back", "", "");
                    patwlLoanDetailsVm.vehicleObj.dealerQuoteOnRoadPrice = "";
                    patwlLoanDetailsVm.errVehicleObj.dealerQuoteOnRoadPriceError = "";
                } else {
                    patwlLoanDetailsVm.errVehicleObj.dealerQuoteOnRoadPriceError = "";
                    var LTVValue = 0;
                    LTVValue = (patwlLoanDetailsVm.dealerOnRoadPercent/100) * parseInt(patwlLoanDetailsVm.vehicleObj.dealerQuoteOnRoadPrice);
                    
                    if(LTVValue < patwlLoanDetailsVm.maxEligibleLoanAmnt){
                        LTVValue = LTVValue;
                    }else{
                        LTVValue = patwlLoanDetailsVm.maxEligibleLoanAmnt;
                    }                    

                    patwlLoanDetailsVm.amount.max = LTVValue;
                    patwlLoanDetailsVm.amount.initial = patwlLoanDetailsVm.amount.max;

                    if (patwlLoanDetailsVm.amount.max % patwlLoanDetailsVm.amount.step > 0) {
                        patwlLoanDetailsVm.amount.max -= (patwlLoanDetailsVm.amount.max % patwlLoanDetailsVm.amount.step);
                    }
                    
                    patwlLoanDetailsVm.updateAmtSlider();
                    patwlLoanDetailsVm.calculateLoanAmnt();
                }
            }
        }

        patwlLoanDetailsVm.updateAmtSlider = function () {
            var rupeeSymbol = String.fromCharCode(8377);
            patwlLoanDetailsVm.amountSlider = {
                value: patwlLoanDetailsVm.amount.initial,
                options: {
                    showSelectionBar: true,
                    floor: patwlLoanDetailsVm.amount.min,
                    ceil: patwlLoanDetailsVm.amount.max,
                    step: 1,
                    onChange: function (id, model) {
                        patwlLoanDetailsVm.calculateLoanAmnt();
                    },
                    translate: function (value) {
                        return rupeeSymbol + $filter('INR')(value);
                    }
                }
            };
        }

        patwlLoanDetailsVm.calculateMyContributionAmnt = function () {
            if (patwlLoanDetailsVm.vehicleObj.dealerQuoteOnRoadPrice) {
                patwlLoanDetailsVm.myContri = parseInt(patwlLoanDetailsVm.vehicleObj.dealerQuoteOnRoadPrice) - parseInt(patwlLoanDetailsVm.amountSlider.value);
            } else {
                patwlLoanDetailsVm.myContri = 0;
            }
        }

        patwlLoanDetailsVm.calculateLoanAmnt = function () {
            if (isNaN(patwlLoanDetailsVm.amountSlider.value)) {
                patwlLoanDetailsVm.amountSlider.value = patwlLoanDetailsVm.amount.min;
            } else {
                patwlLoanDetailsVm.amountSlider.value = patwlLoanDetailsVm.amountSlider.value < patwlLoanDetailsVm.amount.min ? patwlLoanDetailsVm.amount.min : patwlLoanDetailsVm.amountSlider.value;
                patwlLoanDetailsVm.amountSlider.value = patwlLoanDetailsVm.amountSlider.value > patwlLoanDetailsVm.amount.max ? patwlLoanDetailsVm.amount.max : patwlLoanDetailsVm.amountSlider.value;
            }

            if (patwlLoanDetailsVm.amountSlider.value % patwlLoanDetailsVm.amount.step > 0) {
                patwlLoanDetailsVm.amountSlider.value -= (patwlLoanDetailsVm.amountSlider.value % patwlLoanDetailsVm.amount.step);
            }
            patwlLoanDetailsVm.emiCalculation();
        }

        patwlLoanDetailsVm.emiCalculation = function () {
            for (var i = 0; i < patwlLoanDetailsVm.tenureList.length; i++) {
                patwlLoanDetailsVm.tenureList[i].estimatedEMI = patwlService.emiCalculation(patwlLoanDetailsVm.amountSlider.value, patwlLoanDetailsVm.tenureList[i].roi, patwlLoanDetailsVm.tenureList[i].tenure);
            }
            patwlLoanDetailsVm.calculateProcessingFee(patwlLoanDetailsVm.amountSlider.value, patwlLoanDetailsVm.processingFeePercent, patwlLoanDetailsVm.processingFeeGST);
            patwlLoanDetailsVm.calculateMyContributionAmnt();
        }

        patwlLoanDetailsVm.openDatePicker = function () {
            var todayInPicker = new Date();
            var maxDateInPicker = new Date(todayInPicker.getFullYear(), todayInPicker.getMonth(), todayInPicker.getDate() + 28);
            var minDateInPicker = new Date(todayInPicker.getFullYear(), todayInPicker.getMonth(), todayInPicker.getDate() + 1);
            $scope.dateOptions = {
                maxDate: maxDateInPicker,
                minDate: minDateInPicker,
                formatYear: 'yy',
                startingDay: 1
            }
            var datePickerPopup = $ionicPopup.alert({
                cssClass: 'rtxc-datepicker-popup',
                template: '<div class="datePickerBlock font-size-14">' +
                    '<input type="text" datepicker="dd MMM yyyy" ng-model="dateobj.dt" max-date="dateOptions.maxDate" min-date="dateOptions.minDate" format-day-title="dd MMM yyyy" is-open="true" show-weeks="false"/>' +
                    '</div>',
                scope: $scope,
                buttons: [{
                    text: 'Cancel',
                    type: 'button-negative',
                    onTap: function (res) {
                        datePickerPopup.close();
                    }
                }, {
                    text: 'OK',
                    type: 'button-positive',
                    onTap: function (res) {
                        patwlLoanDetailsVm.repayDateError = '';
                        var repayStartDate = $filter('date')($scope.dateobj.dt, "dd MMM yyyy");
                        patwlLoanDetailsVm.repayStartDate = repayStartDate.toUpperCase();
                    }
                }],
            });
        }

        patwlLoanDetailsVm.validateLoanDetailsForm = function () {
            patwlLoanDetailsVm.errVehicleObj = {};
            if (patwlService.isValidField(patwlLoanDetailsVm.vehicleObj.make, "Make")) {
                patwlLoanDetailsVm.errVehicleObj.vehicleMakeError = patwlService.isValidField(patwlLoanDetailsVm.vehicleObj.make, "Make");
            }
            if (patwlService.isValidField(patwlLoanDetailsVm.vehicleObj.model, "Model")) {
                patwlLoanDetailsVm.errVehicleObj.vehicleModelError = patwlService.isValidField(patwlLoanDetailsVm.vehicleObj.model, "Model");
            }
            if (patwlService.isValidField(patwlLoanDetailsVm.vehicleObj.variant, "Variant")) {
                patwlLoanDetailsVm.errVehicleObj.vehicleVariantError = patwlService.isValidField(patwlLoanDetailsVm.vehicleObj.variant, "Variant");
            }
            if (patwlService.isValidField(patwlLoanDetailsVm.vehicleObj.dealer, "Dealer")) {
                patwlLoanDetailsVm.errVehicleObj.dealerError = patwlService.isValidField(patwlLoanDetailsVm.vehicleObj.dealer, "Dealer");
            }
            if (patwlService.isValidField(patwlLoanDetailsVm.vehicleObj.dealerQuoteOnRoadPrice, "Dealer")) {
                patwlLoanDetailsVm.errVehicleObj.dealerQuoteOnRoadPriceError = patwlService.isValidField(patwlLoanDetailsVm.vehicleObj.dealerQuoteOnRoadPrice, "Dealer Quoted On Road Price");
            }
            if (patwlService.isValidField(patwlLoanDetailsVm.repayStartDate, "Loan Repayment Start Date")) {
                patwlLoanDetailsVm.errVehicleObj.repayDateError = patwlService.isValidField(patwlLoanDetailsVm.repayStartDate, "Loan Repayment Start Date");
            }

            return (angular.equals({}, patwlLoanDetailsVm.errVehicleObj)) ? true : false;
        }

        patwlLoanDetailsVm.selectTenure = function (val) {
            patwlLoanDetailsVm.selectedTenureRadio = val.tenure;
            patwlLoanDetailsVm.tenure = val.tenure;
            patwlLoanDetailsVm.estimatedEMI = val.estimatedEMI;
        }

        patwlLoanDetailsVm.goBack = function () {
            patwlService.isFromLoanDetailBack = true;
            $state.go('menu.patwlApplicantDetails');
        };

        patwlLoanDetailsVm.goToNextPage = function () {
            if (patwlLoanDetailsVm.validateLoanDetailsForm()) {
                patwlLoanDetailsVm.payableAmount = parseFloat(patwlLoanDetailsVm.myContri) + parseFloat(patwlLoanDetailsVm.processingFee);
                for (var i = 0; i < patwlLoanDetailsVm.tenureList.length; i++) {
                    if (patwlLoanDetailsVm.selectedTenureRadio == patwlLoanDetailsVm.tenureList[i].tenure) {
                        patwlLoanDetailsVm.selectedTenureRadio = patwlLoanDetailsVm.tenureList[i].tenure;
                        patwlLoanDetailsVm.tenure = patwlLoanDetailsVm.tenureList[i].tenure;
                        patwlLoanDetailsVm.estimatedEMI = patwlLoanDetailsVm.tenureList[i].estimatedEMI;
                        patwlLoanDetailsVm.rateOfIntrest = patwlLoanDetailsVm.tenureList[i].roi;
                    }
                }
				
				if (patwlLoanDetailsVm.estimatedEMI > patwlService.getInitailEligibilityData().maxPermissibleEmi ){
					patwlLoanDetailsVm.errVehicleObj.maxpermissibleEMIBreachError = "Either reduce the loan amount or select the higher tenure.";
				}else{
					patwlLoanDetailsVm.errVehicleObj.maxpermissibleEMIBreachError = "";
					 var payload = {
                        "city": patwlLoanDetailsVm.city ? patwlLoanDetailsVm.city : "",
                        "vehicleMake": patwlLoanDetailsVm.vehicleObj.make ? patwlLoanDetailsVm.vehicleObj.make : "",
                        "vehicleModel": patwlLoanDetailsVm.vehicleObj.model ? patwlLoanDetailsVm.vehicleObj.model : "",
                        "vehicleVariant": patwlLoanDetailsVm.vehicleObj.variant ? patwlLoanDetailsVm.vehicleObj.variant : "",
                        "dealer": patwlLoanDetailsVm.vehicleObj.dealer ? patwlLoanDetailsVm.vehicleObj.dealer : "",
                        "vehiclePrice": {
                            "onRoadPrice": patwlLoanDetailsVm.vehicleObj.vehicleOnRoadPrice ? patwlLoanDetailsVm.vehicleObj.vehicleOnRoadPrice : ""
                        },
                        "dealerQuotedPrice": patwlLoanDetailsVm.vehicleObj.dealerQuoteOnRoadPrice ? patwlLoanDetailsVm.vehicleObj.dealerQuoteOnRoadPrice : "",
                        "loanAmount": patwlLoanDetailsVm.amountSlider.value ? patwlLoanDetailsVm.amountSlider.value : "",
                        "myContribution": patwlLoanDetailsVm.myContri ? patwlLoanDetailsVm.myContri : "",
                        "processingFee": patwlLoanDetailsVm.processingFee ? patwlLoanDetailsVm.processingFee : "",
                        "payableAmount": patwlLoanDetailsVm.payableAmount ? patwlLoanDetailsVm.payableAmount : "",
                        "repaymentStartDate": patwlLoanDetailsVm.repayStartDate ? patwlLoanDetailsVm.repayStartDate : "",
                        "tenure": patwlLoanDetailsVm.tenure ? patwlLoanDetailsVm.tenure : "",
                        "interestRate": patwlLoanDetailsVm.rateOfIntrest ? patwlLoanDetailsVm.rateOfIntrest : "",
                        "emi": patwlLoanDetailsVm.estimatedEMI ? patwlLoanDetailsVm.estimatedEMI : ""
                    }
                    patwlService.saveLoanDetails(payload).then(function (response) {
                        payload.max = patwlLoanDetailsVm.amount.max;
                        if (patwlService.getLoanDetailData() && patwlLoanDetailsVm.isLoanDetailChanged(payload)) {
                            patwlService.isLoanDetailsChanged = true ;
                        }else{
                            patwlService.isLoanDetailsChanged = false ;
                        }
                        patwlService.setLoanDetailData(payload);
                        patwlService.setPhotographData();
                        $state.go('menu.patwlUploadPhotograph');
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
				}               
            }
        };

        patwlLoanDetailsVm.isLoanDetailChanged = function (payLoad) {
            var isChanged = false;
            if(payLoad.emi != patwlService.getLoanDetailData().emi) {
                isChanged = true;
            }
             if (payLoad.repaymentStartDate != patwlService.getLoanDetailData().repaymentStartDate) {
                isChanged = true;
            }
             if (payLoad.processingFee != patwlService.getLoanDetailData().processingFee) {
                isChanged = true;
            }
            return isChanged;
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            patwlLoanDetailsVm.initPage();
        });

        return this;
    }
]);