'use strict';

angularApp.controller('patwlOtpController', [
    "$state",
    "$scope",
    "$translate",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService",
    "$filter",
    "homeLoanService",
    "constantConfig", "cryptoService", "customerInfoService", "$interval", "patwlService", "$timeout", "homeScreenService",

    function ($state,
        $scope,
        $translate,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        $filter,
        homeLoanService,
        constantConfig, cryptoService, customerInfoService, $interval, patwlService, $timeout, homeScreenService) {

        var patwlOtpVm = this;
        var intervalCount = 0;
        patwlOtpVm.IsOTpScreen = true;

        patwlOtpVm.initPage = function () {
            $scope.resendOtpCounter = 0;
            $scope.invalidOtpCounter = 0;
            patwlOtpVm.mobileNo = customerInfoService.customer.mobile;
            patwlOtpVm.timeInSeconds = 90;
        }

        patwlOtpVm.goToHome = function () {
            $state.go('menu.homeScreen');
        };

        patwlOtpVm.submitOTP = function () {
            if (patwlService.isValidField(patwlOtpVm.otp, "OTP")) {
                patwlOtpVm.otpError = patwlService.isValidField(patwlOtpVm.otp, "OTP");
            } else {
                var reqParams = {
                    "otp": patwlOtpVm.otp
                }
                patwlService.validateOTP(reqParams).then(function (response) {
                    var request = {
                        "debitProcessingFeeConsent": true,
                        "agreeTncConsent": true
                    }
                    patwlService.submitApplication(request).then(function (data) {
                        homeScreenService.isNotificationDataAvail = false;
                        if (data.isNightMode.toUpperCase() == 'Y') {
                            patwlService.yonoRef = data.yonoRef;
                            patwlService.setNightModeData(data);
                            // if (homeScreenService.offersData.length > 0) {
                            //     for (var i = 0; i < homeScreenService.offersData.length; i++) {
                            //         if (homeScreenService.offersData[i].category == "PA2WL") {
                            //             homeScreenService.offersData.splice(i, 1);
                            //         }
                            //     }
                            // }
                            $state.go('menu.patwlCongratulations');
                        } else {                            
                            patwlOtpVm.IsOTpScreen = false;
                            patwlOtpVm.startTimer(patwlOtpVm.timeInSeconds);
                            patwlService.yonoRef = data.yonoRef;
                            patwlService.validityDate = data.validityDate;
                        }
                    }, function (error) {
                        patwlOtpVm.otp = '';
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }, function (error) {
                    patwlOtpVm.otp = null;
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }

        }


        patwlOtpVm.startTimer = function (timeIn) {
            patwlOtpVm.enquireAppStatus();
            $scope.countdown = timeIn;
            var div = 60;
            $scope.textContentSec = $scope.countdown % div;
            var rem = $scope.countdown - $scope.textContentSec;
            $scope.textContentMin = rem / div;
            var stopIntervalId = setInterval(function () {
                $scope.textContentSec = $scope.countdown % div;
                rem = $scope.countdown - $scope.textContentSec;
                $scope.textContentMin = rem / div;
                if ($scope.textContentMin == 0 && $scope.textContentSec == 0) {
                    clearInterval(stopIntervalId);
                } else {
                    $scope.countdown = --$scope.countdown;
                }
                if (!$scope.$$phase)
                    $scope.$apply();
            }, 1000);
            if (!$scope.$$phase)
                $scope.$apply();

        }

        patwlOtpVm.enquireAppStatus = function () {
            var request = {};
            patwlOtpVm.enquireInterval = $interval(function () {
                intervalCount++;
                if (intervalCount > 2) {
                    request.isLast = "Y";
                } else {
                    request.isLast = "N";
                }

                patwlService.fetchAppStatus(request).then(function (data) {
                    patwlService.setCloudAppData(data);
                    patwlOtpVm.statusData = data;
                    if (homeScreenService.offersData.length > 0) {
                        for (var j = 0; j < homeScreenService.offersData.length; j++) {
                            if (homeScreenService.offersData[j].category == "PA2WL") {
                                homeScreenService.offersData.splice(j, 1);
                            }
                        }
                    }
                    $state.go('menu.patwlCongratulations');
                }, function (error) {
                    if (error.responseCode == "FA01") {
                        $interval.cancel(patwlOtpVm.enquireInterval);
                        patwlService.showAlertPopup("error", error.responseMessage, "", "menu.homeScreen", "OK", "", "", "");
                    } else if (intervalCount > 2) {
                        $interval.cancel(patwlOtpVm.enquireInterval);
                        patwlService.statusEnquiry().then(function (data) {
                            patwlService.setStatusEnquiryData(data);
                            patwlOtpVm.statusData = data;
                            if (homeScreenService.offersData.length > 0) {
                                for (var k = 0; k < homeScreenService.offersData.length; k++) {
                                    if (homeScreenService.offersData[k].category == "PA2WL") {
                                        homeScreenService.offersData.splice(k, 1);
                                    }
                                }
                            }
                            $state.go('menu.patwlCongratulations');
                        }, function (err) {
                            patwlService.showAlertPopup("error", err.responseMessage, "", "menu.homeScreen", "OK", "", "", "");
                        });
                    }
                });
            }, 30000);

            // patwlOtpVm.timeOutInterval1 = $timeout(function() {
            //     console.log("enquiry cancelled");
            //     $interval.cancel(patwlOtpVm.enquireInterval);
            //     patwlService.statusEnquiry().then(function(data) {
            //         patwlOtpVm.statusData = data;
            //         $state.go('menu.patwlCongratulations');
            //     },function(error) {
            //         patwlService.showAlertPopup("error",error.responseMessage,"","menu.homeScreen","OK","","",""); 
            //     });
            // }, (patwlOtpVm.timeInSeconds*1000));                      
        }

        patwlOtpVm.resendOTP = function () {
            $scope.invalidOtpCounter = 0;
            if ($scope.isDisabledOTPbtn) {
                return true;
            }
            patwlOtpVm.otp = null;
            patwlOtpVm.isValidOtp = true;
            var reqParams = {};
            reqParams["id"] = patwlOtpVm.mobileNumber;
            reqParams.otpCode = constantConfig.keysForOTP.Register;
            reqParams.ocHash = cryptoService.getSHA512EncryptedData(constantConfig.keysForOTP.Register).toString();
            patwlService.generateOTP(reqParams).then(function (data) {
                patwlService.showAlertPopup("", "OTP resent Successfully", "", "", "OK", "", "", "");
                $scope.resendOtpCounter += 1;
                if ($scope.resendOtpCounter === 2) {
                    $scope.isDisabledOTPbtn = true;
                }
            }, function (error) {
                patwlOtpVm.otpError = '';
                utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });
        };

        $scope.$on('$ionicView.beforeEnter', function () {
            patwlOtpVm.initPage();
        });


        $scope.$on('$ionicView.afterLeave', function () {
            $interval.cancel(patwlOtpVm.enquireInterval);
            // $timeout.cancel(patwlOtpVm.timeOutInterval1);
        });

        return this;
    }
]);