'use strict';
angularApp.controller('patwlReviewController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",		
		"$ionicScrollDelegate",	
		"validateService",
		"$filter","constantConfig","patwlService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, $ionicScrollDelegate, 
			validateService, $filter, constantConfig, patwlService) {
			
			var patwlReviewVm = this;

			function initPage() {
				patwlReviewVm.isMaskmobile = true;
				patwlReviewVm.isMaskDeductAcc = true;
				patwlReviewVm.isMaskEmail = true;
				patwlReviewVm.letterDownloadedCounter = 0;
				if ((patwlService.letterDownloadedCounter > 0) && patwlService.isLoanDetailsChanged) {
					patwlService.letterDownloadedCounter = 0;
				}
				patwlReviewVm.persnalDetail = patwlService.getApplicantPageData().parsonal;
				patwlReviewVm.addressDetail = patwlService.getApplicantPageData().address;
				patwlReviewVm.workDetail = patwlService.getApplicantPageData().work;
				patwlReviewVm.loanDetails  = patwlService.getLoanDetailData();
				patwlReviewVm.name = patwlReviewVm.persnalDetail.name;
				var dob = patwlReviewVm.persnalDetail.dob;
				patwlReviewVm.dob = dob.toUpperCase();
				patwlReviewVm.mobile = patwlReviewVm.persnalDetail.mobile;
				patwlReviewVm.dedAccNo = patwlReviewVm.persnalDetail.accNo;
				patwlReviewVm.emailID = patwlReviewVm.persnalDetail.email;
				patwlReviewVm.perAddress = patwlReviewVm.persnalDetail.address
				patwlReviewVm.isEmail = patwlReviewVm.persnalDetail.isEmailID ;
				patwlReviewVm.empType = patwlReviewVm.workDetail.empType;
				if (patwlReviewVm.empType == 'Salaried') {
					patwlReviewVm.emplrName = patwlReviewVm.workDetail.emplyerName;
					patwlReviewVm.emplrContactNo = patwlReviewVm.workDetail.contact;
					patwlReviewVm.address = patwlReviewVm.workDetail.addreLine1 + " " + patwlReviewVm.workDetail.addreLine2 + " " + patwlReviewVm.workDetail.pincode;
				} else {
					patwlReviewVm.NonSalariedType = patwlReviewVm.workDetail.professionType.value;
				}
	
				patwlReviewVm.vehicleMake =patwlReviewVm.loanDetails.vehicleMake.vehicleMfrName;
				patwlReviewVm.vehicleModel = patwlReviewVm.loanDetails.vehicleModel.vehicleModelName;
				patwlReviewVm.vehicleVariant = patwlReviewVm.loanDetails.vehicleVariant.vehicleVrntName;
				patwlReviewVm.vehicleDealer = patwlReviewVm.loanDetails.dealer.dealerName;
	
				patwlReviewVm.branchLoan = patwlReviewVm.loanDetails.dealer.autoHubBranchName;
				patwlReviewVm.dealerQuoteAmt = patwlReviewVm.loanDetails.dealerQuotedPrice;
	
				patwlReviewVm.loanAmnt = patwlReviewVm.loanDetails.loanAmount;
				patwlReviewVm.contriAmnt = parseFloat(patwlReviewVm.loanDetails.myContribution);
				patwlReviewVm.loanTenure = patwlReviewVm.loanDetails.tenure;
				patwlReviewVm.loanIntRate = patwlReviewVm.loanDetails.interestRate;
				patwlReviewVm.processingFeeAmnt = parseFloat(patwlReviewVm.loanDetails.processingFee).toFixed(2);
				patwlReviewVm.loanEMI = patwlReviewVm.loanDetails.emi;
				patwlReviewVm.monthlyRepay = patwlReviewVm.loanDetails.repaymentStartDate;
				patwlReviewVm.payableAmnt = (patwlReviewVm.contriAmnt + parseFloat(patwlReviewVm.processingFeeAmnt)).toFixed(2);
				patwlReviewVm.balAmt = patwlReviewVm.payableAmnt;
			}
	
			patwlReviewVm.unMaskData = function (payload, type) {
				patwlService.getUnmaskedOutput(payload).then(function (response) {
					if (type == "mobile") {
						patwlReviewVm.mobileUnMasked = response.unmaskedOutput;
					}
					if (type == "accountNo") {
						patwlReviewVm.accNoUnMasked = response.unmaskedOutput;
					}
					if (type == "email") {
						patwlReviewVm.emailUnMasked = response.unmaskedOutput;
					}
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}
	
			patwlReviewVm.toggleMaskData = function (type) {
				if (type == "mobile") {
					if (patwlReviewVm.isMaskmobile) {
						patwlReviewVm.unMaskData({
							"maskedInput": patwlReviewVm.persnalDetail.mobile
							, "type": "mobileNumber"
						}, type);
					}
					patwlReviewVm.isMaskmobile = !patwlReviewVm.isMaskmobile;
				}
				if (type == "accountNo") {
					if (patwlReviewVm.isMaskDeductAcc) {
						patwlReviewVm.unMaskData({
							"maskedInput": patwlReviewVm.persnalDetail.accNo
							, "type": "accountNo"
						}, type);
					}
					patwlReviewVm.isMaskDeductAcc = !patwlReviewVm.isMaskDeductAcc;
				}
				if (type == "email") {
					if (patwlReviewVm.isMaskEmail && patwlReviewVm.isEmail) {
						patwlReviewVm.unMaskData({
							"maskedInput": patwlReviewVm.persnalDetail.email
							, "type": "email"
						}, type);
					}
					patwlReviewVm.isMaskEmail = !patwlReviewVm.isMaskEmail;
				}
			}

			patwlReviewVm.goBack = function () {
				$state.go('menu.patwlUploadPhotograph');
			}

			patwlReviewVm.authorizeConsent = function (val) {
				if (val) {
	                patwlReviewVm.authorizeConsentCheck = true;
	                patwlReviewVm.errorCheck = false;                     
	            } else {
	            	patwlReviewVm.authorizeConsentCheck = false; 
	                patwlReviewVm.errorCheck = true;
	            }
			}

			patwlReviewVm.showTnC = function () { 
				patwlService.getTnC().then(function (data) {
	                patwlReviewVm.ddeTnCContent = data;
	                patwlReviewVm.tncPopup(patwlReviewVm.ddeTnCContent);
	            }, function (error) {
	                utilityService.showErrorMessage(error.responseMessage);
	            });
			}

			patwlReviewVm.showTnCChecked = function () {
				if (patwlReviewVm.authorizeTnCCheck) {
					patwlReviewVm.downloadTnCErrorCheck = "";
					if (patwlService.letterDownloadedCounter < 1) {
	                	patwlReviewVm.showTnC();
	            	}					
				}
			}

			patwlReviewVm.tncPopup = function (data) {
	            var test = '<ion-content class="padding bottomZero rtxc_tnc_popup_list">'+ data +
	                '<div class="rtxcTnC"><button class="rxtcTnC_button" ng-click="closePopup()">I Agree and Accept</button></div></ion-content>';
	                $scope.bhimErrorPopup = $ionicPopup.show({
	                template: test,
	                title: 'Terms & Conditions',
	                scope: $scope,
	                cssClass: 'bhim-alert-popup hlTermnCondition',
		        });
	        }

	        $scope.closePopup =  function(){
	            $scope.bhimErrorPopup.close();
	            if (patwlService.letterDownloadedCounter > 0) {
	                patwlReviewVm.fileAlreadyDownloaded();
	            }else{
	                patwlReviewVm.downloadTnCLetter();
	            }           
	        }

	        patwlReviewVm.fileAlreadyDownloaded = function () {
	            patwlReviewVm.myPopup1 = $ionicPopup.show({
	                template: 'Your Terms and Condition is already downloaded',
	                title: '',
	                cssClass: 'dialog',
	                scope: $scope,
	                buttons: [{
	                    text: 'OK',
	                    type: 'button-positive'
	                }]
	            });
	        }

	        patwlReviewVm.downloadTnCLetter = function () {
	   			patwlService.downloadTnC().then(function (data) {
	                patwlReviewVm.letterDownloadedCounter = 1;
	                patwlService.letterDownloadedCounter = patwlReviewVm.letterDownloadedCounter;

	                patwlReviewVm.downloadTnCErrorCheck = "";
	                var content = data.base64Pdf;
	                var filename = "Terms & Conditions";
	                var contentType = "application/pdf";
	               
	                savebase64AsPDF(filename, content, contentType);

	            }, function (error) {
	                patwlReviewVm.letterDownloadedCounter = 0;
	                patwlReviewVm.downloadTnCErrorCheck = "Please download Terms and Conditions to proceed(mandatory).";
	                utilityService.showErrorMessage(error.responseMessage);
	            });
	        }

	        function savebase64AsPDF(filename, content, contentType) {
				patwlReviewVm.popupFolderpath = "";
	            var DataBlob = b64toBlob(content, contentType);
				if (utilityService.isAndroidPlatform()) {
					if(device.version==10){
						const folderpath = cordova.file.externalDataDirectory;
						patwlReviewVm.popupFolderpath = folderpath.replace(cordova.file.externalRootDirectory,"") + filename;
						window.resolveLocalFileSystemURL(folderpath, function(dir) {
							dir.getFile(filename, { create: true }, function(file) {
								file.createWriter(function(fileWriter) {
									fileWriter.write(DataBlob);
									//Show popup 
									var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="PATWL_DOWNLOAD_RECEIPT" translate-values="{filePath:patwlReviewVm.popupFolderpath}"></div>';
									patwlReviewVm.downloadPopup = $ionicPopup.show({
										title: '',
										template: template,
										scope: $scope,
										cssClass: 'my-custom-popup',
										buttons: [{
											text:'OK',
											type: 'button-assertive',
											onTap: function() { 
												patwlReviewVm.downloadPopup.close();
											}
										}],
									});
								}, function() {});
							});
						});
					}else{
						//for Android below 10 and Android 11 not for 10
						window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem){
							fileSystem.root.getDirectory("Download", {create: true, exclusive: false},function(dir) {
								patwlReviewVm.popupFolderpath = dir.fullPath + filename;
								dir.getFile(filename, { create: true }, function(file) {
									file.createWriter(function(fileWriter) {
										fileWriter.write(DataBlob);
										//Show popup 
										var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="PATWL_DOWNLOAD_RECEIPT" translate-values="{filePath:patwlReviewVm.popupFolderpath}"></div>';
										patwlReviewVm.downloadPopup = $ionicPopup.show({
											title: '',
											template: template,
											scope: $scope,
											cssClass: 'my-custom-popup',
											buttons: [{
												text:'OK',
												type: 'button-assertive',
												onTap: function() { 
													patwlReviewVm.downloadPopup.close();
												}
											}],
										});
									}, function() {});
								});
							});
						});
					}					
				}
				if (utilityService.isIOSPlatform()) {
					const folderpath = cordova.file.documentsDirectory;
					const finalPath = folderpath + filename;
					window.resolveLocalFileSystemURL(folderpath, function (dir) {
						dir.getFile(filename, { create: true }, function (file) {
							file.createWriter(function (fileWriter) {
								fileWriter.write(DataBlob);
							}, function () { });
						});
					});
					cordova.plugins.fileOpener2.open(
						finalPath,
						'application/pdf', {
							error: function (e) {
								console.log('Error status: ' + e.status + ' - Error message: ' + e.message);
							},
							success: function () {
								console.log('file opened successfully');
							}
						}
					);
				}
	        }

	        function b64toBlob(b64Data, contentType, sliceSize) {
	            contentType = contentType || '';
	            sliceSize = sliceSize || 512;
	            var byteCharacters = atob(b64Data);
	            var byteArrays = [];
	            for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
	                var slice = byteCharacters.slice(offset, offset + sliceSize);
	                var byteNumbers = [];
	                for (var i = 0; i < slice.length; i++) {
	                    byteNumbers[i] = slice.charCodeAt(i);
	                }
	                var byteArray = new Uint8Array(byteNumbers);
	                byteArrays.push(byteArray);
	            }
	            var blob = new Blob(byteArrays, { type: contentType });
	            return blob;
	        }

			patwlReviewVm.goToNextPage = function () {
				if(patwlReviewVm.authorizeConsentCheck && patwlReviewVm.authorizeTnCCheck && patwlService.letterDownloadedCounter > 0) {
					patwlService.checkAccountBalance().then(function(response) {
                        patwlService.generateOTP().then(function(data) {
	                        $state.go('menu.patwlOtp');
	                    },function(error){
	                        utilityService.showErrorMessage(error.responseMessage);
	                    });
                    },function(error){
                        patwlService.showAlertPopup("error", error.responseMessage, "", "menu.homeScreen", "OK", "", "", "");
                    });					
				}else{
					if (patwlReviewVm.authorizeConsentCheck) {
		                patwlReviewVm.authorizeConsentCheck = true;
		                patwlReviewVm.errorCheck = false;                     
		            } else {
		            	patwlReviewVm.authorizeConsentCheck = false; 
		                patwlReviewVm.errorCheck = true;
		            }

		            if (patwlReviewVm.authorizeTnCCheck) {
		            	patwlReviewVm.downloadTnCErrorCheck = "";
		            }else{		            	
                    	patwlReviewVm.downloadTnCErrorCheck = "Please check the above box to accept terms and conditions.";
		            }

		            if (patwlReviewVm.authorizeTnCCheck) {
		            	if (patwlService.letterDownloadedCounter > 0) {
			            	patwlReviewVm.downloadTnCErrorCheck = "";
			            }else{
			            	patwlReviewVm.downloadTnCErrorCheck = "Please download Terms and Conditions to proceed(mandatory).";
			            }
		            }	            
					
                    $ionicScrollDelegate.scrollBottom();
				}				  
			}			

			$scope.$on('$ionicView.loaded', function () {
				//initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				initPage();
			});

			return this;
		}

		
]);


