'use strict';

angularApp.service('patwlService',
    function ($q, AdapterUtils, utilityService, constantConfig, $ionicPopup, $state, $ionicScrollDelegate,$cordovaCamera) {

        var patwlService = this;

        var patwlDetails, patwlSuccess, photoData, statusEnquiryData, statusData, offerBannerData, initialEligibilityData , nightModeData;
        var customerDetails = {};
        this.isBannerAvaialable = true;
        this.isFromLoanDetailBack = false;
        this.applicationDetailResponse = {};
        this.letterDownloadedCounter = 0;
        this.isLoanDetailsChanged = false ;
        var applicantPageData = {};
        var loanDetailData = {};
        patwlService.clearAll = function () {
            patwlDetails = null; patwlSuccess = null; photoData = null; statusEnquiryData = null; statusData = null; loanDetailData = null; nightModeData = null ;
            customerDetails = null; this.isFromLoanDetailBack = false;this.isLoanDetailsChanged = false ;this.letterDownloadedCounter = 0;
        }

        // Setter/Getter

        patwlService.getImageFromGallery = function () {
            var options = {
                quality: 50,
                destinationType: Camera.DestinationType.DATA_URL,
                sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
                allowEdit: true,
                popoverOptions: CameraPopoverOptions,
                correctOrientation: true
            };
            if (utilityService.isAndroidPlatform()) {
                if(device.version==11){
                    options.allowEdit = false ;
                }
             }
            var q = $q.defer();
            $cordovaCamera.getPicture(options).then(function (imageData) {
                q.resolve("data:image/jpeg;base64," + imageData)
            }, function (err) {
                q.reject("error");
            });
            return q.promise;
        }

        patwlService.getnewImage = function () {
            var options = {
                quality: 50,
                destinationType: Camera.DestinationType.DATA_URL,
                sourceType: Camera.PictureSourceType.CAMERA,
                allowEdit: true,
                encodingType: Camera.EncodingType.JPEG,
                popoverOptions: CameraPopoverOptions,
                cameraDirection: Camera.Direction.FRONT,
                saveToPhotoAlbum: false,
                correctOrientation: true
            };
            if (utilityService.isAndroidPlatform()) {
                if(device.version==11){
                    options.allowEdit = false ;
                }
             }
            var q = $q.defer();
            $cordovaCamera.getPicture(options).then(function (imageData) {
                q.resolve("data:image/jpeg;base64," + imageData)
            }, function (err) {
                q.reject("error");
            });
            return q.promise;
        }

        patwlService.setNightModeData = function(val){
            nightModeData = val;
        }
        patwlService.getNightModeData = function(){
            return nightModeData ;
        }


        patwlService.setInitailEligibilityData = function (val) {
            initialEligibilityData = val;
        }
        patwlService.getInitailEligibilityData = function () {
            return initialEligibilityData;
        }

        patwlService.setLoanDetailData = function (val) {
            loanDetailData = val;
        }
        patwlService.getLoanDetailData = function () {
            return loanDetailData;
        }

        patwlService.setApplicantPageData = function (val) {
            applicantPageData = val;
        }
        patwlService.getApplicantPageData = function () {
            return applicantPageData
        }

        patwlService.setCustomerData = function (val) {
            customerDetails = val;
        }
        patwlService.getCustomerData = function () {
            return customerDetails;
        }

        patwlService.setOfferBannerData = function (val) {
            offerBannerData = val;
        }
        patwlService.getOfferBannerData = function () {
            return offerBannerData;
        }

        patwlService.setpatwlData = function (data) {
            patwlDetails = data;
        };
        patwlService.getpatwlData = function () {
            return patwlDetails;
        };

        patwlService.setSuccesspatwlData = function (data) {
            patwlSuccess = data;
        };
        patwlService.getSuccesspatwlData = function () {
            return patwlSuccess;
        };

        patwlService.setPhotographData = function (data) {
            photoData = data;
        }
        patwlService.getPhotographData = function () {
            return photoData;
        }

        patwlService.setCloudAppData = function (data) {
            statusData = data;
        }

        patwlService.getCloudAppData = function () {
            return statusData;
        }

        patwlService.setStatusEnquiryData = function (data) {
            statusEnquiryData = data;
        }

        patwlService.getStatusEnquiryData = function () {
            return statusEnquiryData;
        }

        patwlService.isValidField = function (obj, field) {
            if (!obj) {
                return 'Please provide ' + field;
            }
            return false;
        };

        patwlService.emiCalculation = function (p, i, t) {
            p = parseInt(p);
            i = parseFloat(i) / 1200;
            t = parseInt(t);
            var numerator = p * i * Math.pow((1 + i), t);
            var denominator = Math.pow((1 + i), t) - 1;
            var emiAmount = Math.ceil((numerator / denominator));
            return emiAmount;
        }




        patwlService.showAlertPopupForRTOAlert = function (imageType, message1, message2, onTapgo, buttontext1, buttontext2, $scope, obj) {
            var btn_array = [];
            if (buttontext1 != "" && buttontext2 != "") {
                btn_array = [
                    {
                        text: buttontext2 || "Cancel",
                        type: 'button-negative',
                        onTap: function () {

                        }
                    },
                    {
                        text: buttontext1 || "OK",
                        type: 'button-positive',
                        onTap: function () {
                            if (onTapgo) {
                                $state.go(onTapgo);
                            }
                        }
                    }
                ];
            } else {
                btn_array = [
                    {
                        text: buttontext1 || "OK",
                        type: 'button-positive patwl_popup_rto',
                        onTap: function () {
                            if (onTapgo) {
                                $state.go(onTapgo);
                            }
                        }
                    }
                ];
            }

            if (imageType && imageType.toLowerCase() == 'error') {
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/errorSymbol.svg"/></div>';
            } else if (imageType && imageType.toLowerCase() == 'success') {
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/successSymbol.svg"/></div>';
            } else if (imageType && imageType.toLowerCase() == 'alert') {
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/alertSymbol.svg"/></div>';
            } else {
                imageType = "Please Note!";
            }
            var bhimErrorPopup = $ionicPopup.alert({
                template: '<div class="patwl_rto_popup_alert">' + imageType + '<div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="patwl_rto_popup_alert_msg"><span>'
                    + message1 + '</span><div ng-if="message2" class="textAlignCenter roboto-regular font-size-14 color-darkgrey padTop10">' + message2 + '</div></div></div></div>',
                scope: $scope,
                cssClass: 'bhim-alert-popup patwl_popup_border',
                buttons: btn_array,
            });
            bhimErrorPopup.then(function (res) {

            });
        };

        patwlService.showAlertPopupForAmountMismatch = function (imageType, message1, message2, onTapgo, buttontext1, buttontext2, $scope, obj) {
            var btn_array = [];
            if (buttontext1 != "" && buttontext2 != "") {
                btn_array = [
                    {
                        text: buttontext2 || "Cancel",
                        type: 'button-negative',
                        onTap: function () {
                            $state.go('menu.homeScreen');
                        }
                    },
                    {
                        text: buttontext1 || "OK",
                        type: 'button-positive',
                        onTap: function () {
                            if (onTapgo) {
                                $state.go(onTapgo);
                            }
                        }
                    }
                ];
            } else {
                btn_array = [
                    {
                        text: buttontext1 || "OK",
                        type: 'button-positive',
                        onTap: function () {
                            if (onTapgo) {
                                $state.go(onTapgo);
                            }
                        }
                    }
                ];
            }

            if (imageType && imageType.toLowerCase() == 'error') {
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/errorSymbol.svg"/></div>';
            } else if (imageType && imageType.toLowerCase() == 'success') {
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/successSymbol.svg"/></div>';
            } else if (imageType && imageType.toLowerCase() == 'alert') {
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/alertSymbol.svg"/></div>';
            } else {
                imageType = "";
            }
            var bhimErrorPopup = $ionicPopup.alert({
                template: '<div class="font-dark-grey">' + imageType + '<div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter roboto-medium font-size-16 color-darkgrey"><span>'
                    + message1 + '</span><div  class="textAlignCenter roboto-regular font-size-14 color-darkgrey padTop10">' + message2 + '</div></div></div></div>', //template,
                scope: $scope,
                cssClass: 'bhim-alert-popup patwl_popup_border',
                buttons: btn_array,
            });
            bhimErrorPopup.then(function (res) {
            });
        };

        patwlService.showAlertPopup = function (imageType, message1, message2, onTapgo, buttontext1, buttontext2, $scope, obj) {
            var btn_array = [];
            if (buttontext1 != "" && buttontext2 != "") {
                btn_array = [
                    {
                        text: buttontext2 || "Cancel",
                        type: 'button-negative',
                        onTap: function () {

                        }
                    },
                    {
                        text: buttontext1 || "OK",
                        type: 'button-positive',
                        onTap: function () {
                            if (onTapgo) {
                                $state.go(onTapgo);
                            }
                        }
                    }
                ];
            } else {
                btn_array = [
                    {
                        text: buttontext1 || "OK",
                        type: 'button-positive',
                        onTap: function () {
                            if (onTapgo) {
                                $state.go(onTapgo);
                            }
                        }
                    }
                ];
            }

            if (imageType && imageType.toLowerCase() == 'error') {
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/errorSymbol.svg"/></div>';
            } else if (imageType && imageType.toLowerCase() == 'success') {
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/successSymbol.svg"/></div>';
            } else if (imageType && imageType.toLowerCase() == 'alert') {
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/alertSymbol.svg"/></div>';
            } else {
                imageType = "";
            }
            var bhimErrorPopup = $ionicPopup.alert({
                template: '<div class="font-dark-grey">' + imageType + '<div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter roboto-medium font-size-16 color-darkgrey"><span>'
                    + message1 + '</span><div ng-if="message2" class="textAlignCenter roboto-regular font-size-14 color-darkgrey padTop10">' + message2 + '</div></div></div></div>', //template,
                scope: $scope,
                cssClass: 'bhim-alert-popup patwl_popup_border',
                buttons: btn_array,
            });
            bhimErrorPopup.then(function (res) {
            });
        };


        // API call

        patwlService.getOtherDetails = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/pa2wl/getOtherDetails", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        patwlService.getDealerList = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/pa2wl/getDealerList", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        patwlService.saveLoanDetails = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/pa2wl/saveLoanDetails", payload, true).then(
                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        patwlService.getVehicleVariantList = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/pa2wl/getVehicleVariantList", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        patwlService.getVehicleModelList = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/pa2wl/getVehicleModelList", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        patwlService.getCustomerBasicDetails = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/pa2wl/getCustomerBasicDetails", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        patwlService.submitApplication = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/pa2wl/submitApplication", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        patwlService.getUnmaskedOutput = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/pa2wl/getUnmaskedOutput", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        patwlService.getTnC = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/pa2wl/getTnC", {}, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        patwlService.downloadTnC = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/pa2wl/downloadTnC", {}, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        patwlService.getInitialEligibility = function (payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/pa2wl/initialEligibility", {}, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        patwlService.uploadPhotograph = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/pa2wl/uploadPhotograph", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        patwlService.retrievePhotograph = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/pa2wl/retrievePhotograph", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        patwlService.getInterestRate = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/pa2wl/getInterestRate", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        patwlService.fetchAppStatus = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/pa2wl/fetchAppStatus", payload, false).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        patwlService.statusEnquiry = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/pa2wl/statusEnquiry", {}, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        patwlService.generateOTP = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/OTPAdapter/getOTPTokenSecure", {}, true).then(function (response) {
                q.resolve(response.data);
            },
                function (error) {
                    q.reject(error);
                });
            return q.promise;
        };

        //Validate OTP
        patwlService.validateOTP = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/OTPAdapter/validateOTPTokenSecure", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                });
            return q.promise;
        };

        patwlService.downloadAndEmailDocument = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/pa2wl/downloadAndEmailDocument", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                });
            return q.promise;
        };

        patwlService.getDocsForLoanAccountSummary = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/pa2wl/getDocsForLoanAccountSummary", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                });
            return q.promise;
        };

        patwlService.checkAccountBalance = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/pa2wl/checkAccountBalance", {}, false).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                });
            return q.promise;
        };

        return patwlService;

    });