'use strict';

angularApp.controller('patwlUploadPhotographController', [
    "$state",
    "$scope",
    "$translate",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService", 
    "$filter",
    "patwlService",
    "$ionicScrollDelegate",
    "homeLoanService","ionicDatePicker","cameraService",

    function($state,
        $scope,
        $translate,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        $filter,
        patwlService,
        $ionicScrollDelegate,
        homeLoanService,ionicDatePicker,cameraService) {

        var patwlUploadPhotographVm = this;

        patwlUploadPhotographVm.initPage = function () {
            patwlUploadPhotographVm.editIcon = true;
            if (patwlService.getPhotographData()) {
                patwlUploadPhotographVm.retrievePhotograph();
            }
        }

        patwlUploadPhotographVm.retrievePhotograph = function() {
            patwlService.retrievePhotograph().then(function(data) {
                patwlUploadPhotographVm.profileImageUrl = "data:image/jpeg;base64," + data.docList.base64;
                patwlUploadPhotographVm.filename = data.docList.docName;                    
                patwlUploadPhotographVm.contentType = data.docList.mimeType;
                patwlUploadPhotographVm.category = data.docList.category;
                patwlUploadPhotographVm.photoValidated = true;
                patwlUploadPhotographVm.editIcon = false;               
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        patwlUploadPhotographVm.deletePicture = function () {
            patwlUploadPhotographVm.profileImageUrl = "";
            patwlUploadPhotographVm.editIcon = true;
            patwlUploadPhotographVm.photoNotAdded = false;
        }

        patwlUploadPhotographVm.uploadPicture = function(){
            patwlUploadPhotographVm.picturePopup = $ionicPopup.show({
                cssClass: 'uploadPhoto-alert-popup',
                template: '<div style="text-align: right!important;"> <img alt="" class="patwl_close_ico" src="img/HomeLoan/Close.svg" ng-click="patwlUploadPhotographVm.goToHome()" /> </div>'+
                        '<div class="row homeLoan textCenter" style="padding:0px !important;"><div class="col-50">'+
                        '<img class="rxtc-photoPopUp" alt="" src="img/patwl/UploadPhoto.svg" ng-click="patwlUploadPhotographVm.uploadGalleryPicture()"/>'+
                        '<p class="roboto-medium font-size-12" translate="RTXC_GALLERY_LBL"></p></div>'+
                        '<div class="col-50"><img class="rxtc-photoPopUp" alt="" src="img/patwl/Selfie.svg" ng-click="patwlUploadPhotographVm.clickselfie()"/>'+
                        '<p class="roboto-medium font-size-12" translate="RTXC_SELFIE_LBL"></p></div></div>',
                scope: $scope, 
                buttons: []
            });
        }

        patwlUploadPhotographVm.goToHome = function(){
            patwlUploadPhotographVm.picturePopup.close();
            // $state.go('menu.homeScreen');
        }

        patwlUploadPhotographVm.clickselfie = function() {
            patwlUploadPhotographVm.picturePopup.close();
            patwlService.getnewImage().then(function(data) {
                var blob = new Blob([data], {type: 'image/jpeg'});
                var typecheck = data.substring(data.indexOf('/') + 1, data.indexOf(';base64'));
                var size = data.length;
                if (typecheck == "png" || typecheck == "jpg" || typecheck == "jpeg") {
                     patwlUploadPhotographVm.commanAddFile(blob, data, typecheck,size); 
                }else{
                    // utilityService.hideSpinner();
                    var template = "File should not exceed 3MB in size."
                    $ionicPopup.show({
                        title: '',
                        template: template,
                        scope: $scope,
                        cssClass: 'my-custom-popup',
                        buttons: [{
                            text: 'OK',
                            type: 'button-assertive',
                            onTap: function () {
                            }
                        }],
                    });
                }
            }, function(error) {
                var title = '';
                var template = '{{"SERVICE_ERR_MSG" | translate}}';
                var onTap = '';
                var buttontext = '<b>OK</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            });
        }

        patwlUploadPhotographVm.uploadGalleryPicture = function() {
            patwlUploadPhotographVm.picturePopup.close();
            patwlService.getImageFromGallery().then(function(data) {
                var blob = new Blob([data], {type: 'image/jpeg'});
                var typecheck = data.substring(data.indexOf('/') + 1, data.indexOf(';base64'));
                var size = data.length;
                if (typecheck == "png" || typecheck == "jpg" || typecheck == "jpeg") {
                     patwlUploadPhotographVm.commanAddFile(blob, data, typecheck,size); 
                }else{
                    // utilityService.hideSpinner();
                    var template = "File should not exceed 3MB in size."
                    $ionicPopup.show({
                        title: '',
                        template: template,
                        scope: $scope,
                        cssClass: 'my-custom-popup',
                        buttons: [{
                            text: 'OK',
                            type: 'button-assertive',
                            onTap: function () {
                            }
                        }],
                    });
                }
            }, function(error) {
                var title = '';
                var template = '{{"SERVICE_ERR_MSG" | translate}}';
                var onTap = '';
                var buttontext = '<b>OK</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            });
        }

         patwlUploadPhotographVm.commanAddFile = function(blob, data, typecheck, sizeOfImage){
                var imageName = "Photo.jpeg";
                var sizeInMB = sizeOfImage;
                var size = 0;
                var block = data.split(";");
                var contentType = block[0].split(":")[1];                

                if (sizeInMB < 3145728) {
                    // utilityService.hideSpinner();
                    patwlUploadPhotographVm.profileImageUrl = data;
                    patwlUploadPhotographVm.filename = imageName;                    
                    patwlUploadPhotographVm.size = size;
                    patwlUploadPhotographVm.contentType = contentType;
                    patwlUploadPhotographVm.category = imageName + typecheck;  
                    patwlUploadPhotographVm.uploadPhotograph(patwlUploadPhotographVm.profileImageUrl,patwlUploadPhotographVm.filename,patwlUploadPhotographVm.category,patwlUploadPhotographVm.contentType); 
                }else{
                    // utilityService.hideSpinner();
                    var template = "Uploaded photograph Exceeds the size limit. Maximum size limit-3 MB, please retry."
                    $ionicPopup.show({
                        title: '',
                        template: template,
                        scope: $scope,
                        cssClass: 'my-custom-popup',
                        buttons: [{
                            text: 'OK',
                            type: 'button-assertive',
                            onTap: function () {
                                
                            }
                        }],
                    });
                }
            }

         patwlUploadPhotographVm.uploadPhotograph = function(imgProfile, filename, category, contentType) {
            patwlUploadPhotographVm.editIcon = false;
            patwlUploadPhotographVm.photoNotAdded = false;
            var request = {
                "docList": {
                    "docName": filename ? filename : '',
                    "mimeType": contentType ? contentType : '',
                    "base64": imgProfile ? imgProfile.split(',')[1] : ''
                    }
                };
                 patwlService.uploadPhotograph(request).then(function(data) {
                patwlService.setPhotographData(data);
                patwlUploadPhotographVm.editIcon = false;
                patwlUploadPhotographVm.expandPhoto = false;
                patwlUploadPhotographVm.photoValidated = true;
                patwlUploadPhotographVm.photoNotAdded = false;
            }, function(error) {
                patwlUploadPhotographVm.profileImageUrl = "";
                patwlUploadPhotographVm.editIcon = true;
                patwlUploadPhotographVm.photoNotAdded = false;
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        patwlUploadPhotographVm.goBack = function() {
            $state.go('menu.patwlLoanDetails');
        };

        patwlUploadPhotographVm.goToNextPage = function() {
            if (patwlUploadPhotographVm.profileImageUrl) {
                $state.go('menu.patwlReview');
            }else{
                patwlUploadPhotographVm.photoNotAdded = true;
            }
        }  

        $scope.$on('$ionicView.beforeEnter', function() {            
            patwlUploadPhotographVm.initPage();          
        });

        return this;
    }
]);