'use strict';

angularApp.controller('clNTBEligibileAmountDetailsController', [
    "$state",
    "$scope",
    "$translate",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService",
    "$filter",
    "clNTBCalculatorService",
    "homeLoanService",
    "$morphCarousel",

    function ($state,
        $scope,
        $translate,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        $filter,
        clNTBCalculatorService,
        homeLoanService,
        $morphCarousel) {

        var clNTBEligibileAmountDetailsVm = this;
        var loanDetails;
        $scope.isNonEdited = true;
        var intRates = [];
        
        // initialize variable
        clNTBEligibileAmountDetailsVm.initPage = function () {
            var tenures = [];
            clNTBEligibileAmountDetailsVm.EligibilityData = clNTBCalculatorService.getCheckEligiblityRequest();
            clNTBEligibileAmountDetailsVm.clNTeligibilityEditScreen2Hide = false;
            clNTBEligibileAmountDetailsVm.occupationCode = clNTBCalculatorService.getApplicantOccupation();
            clNTBEligibileAmountDetailsVm.userGender = clNTBCalculatorService.getApplicantGender();
            clNTBEligibileAmountDetailsVm.rateOfInterestMasterDataLists = clNTBCalculatorService.getRateOfInterestMasterDataLists();
            clNTBEligibileAmountDetailsVm.emiNMIRatioMasterDataList = clNTBCalculatorService.getEmiNMIRatioMasterDataList();
            clNTBEligibileAmountDetailsVm.staticMasterData = clNTBCalculatorService.getStaticMasterData();
            loanDetails = clNTBCalculatorService.getGLLoanDetails();

            if (clNTBCalculatorService.isAmountBack) {
                var hlbackLoanDetail = clNTBCalculatorService.getEligibalAmountDetail()
                clNTBEligibileAmountDetailsVm.loanMaxAmount = hlbackLoanDetail.eligibleLoanAmount;
                clNTBEligibileAmountDetailsVm.selectedTenure = hlbackLoanDetail.loanTenure;
                clNTBEligibileAmountDetailsVm.emiAmount = hlbackLoanDetail.monthlyEMI;
                if (!$scope.$$phase) {
                    $scope.$apply();
                }

            } else {
                if (parseInt(loanDetails.loanAmount) > parseInt(clNTBEligibileAmountDetailsVm.staticMasterData.maxLoanAmount)) {
                    clNTBEligibileAmountDetailsVm.loanMaxAmount = clNTBEligibileAmountDetailsVm.staticMasterData.maxLoanAmount;
                }
                else {
                    clNTBEligibileAmountDetailsVm.loanMaxAmount = loanDetails.loanAmount;
                }
                clNTBEligibileAmountDetailsVm.emiAmount = loanDetails.monthlyEMI;
                if (!$scope.$$phase) {
                    $scope.$apply();
                }

            }

            clNTBEligibileAmountDetailsVm.interestRate = loanDetails.rateOfInterest;
            clNTBEligibileAmountDetailsVm.tenures = [];
            var maxTenure = parseInt(clNTBEligibileAmountDetailsVm.staticMasterData.maxTenure);    // 7 will be sent from adapter
            var minTenure = parseInt(clNTBEligibileAmountDetailsVm.staticMasterData.minTenure);
            var tenurecheck = 0;
            if ((maxTenure - minTenure) < 10) {
                while (tenurecheck < 5) {
                    for (var i = minTenure; i <= maxTenure; i++) {
                        tenures.push(i);
                    }
                    tenurecheck++;
                }
            } else {
                for (var j = minTenure; j <= maxTenure; j++) {
                    tenures.push(j);
                }
            }

            clNTBEligibileAmountDetailsVm.tenures = tenures;
            clNTBEligibileAmountDetailsVm.loanAmount = clNTBEligibileAmountDetailsVm.loanMaxAmount
            if (!clNTBCalculatorService.isAmountBack) {
                clNTBEligibileAmountDetailsVm.selectedTenure = loanDetails.loanTunure;
                clNTBEligibileAmountDetailsVm.tenure = loanDetails.loanTunure;
            }
            clNTBEligibileAmountDetailsVm.loanMinAmount = 100000;
            setTimeout(function () {
                $morphCarousel.update('cl-tenure-carousel');
            }, 100);

            clNTBEligibileAmountDetailsVm.disableMBtn = false;
            clNTBEligibileAmountDetailsVm.disablePBtn = false;

            //loan amount

            if (clNTBEligibileAmountDetailsVm.loanAmount <= clNTBEligibileAmountDetailsVm.loanMinAmount) {
                clNTBEligibileAmountDetailsVm.disableMBtn = true;
            }
            if (clNTBEligibileAmountDetailsVm.loanAmount >= clNTBEligibileAmountDetailsVm.loanMaxAmount) {
                clNTBEligibileAmountDetailsVm.disablePBtn = true;
            }

            // clNTBEligibileAmountDetailsVm.emiCalculation();
        }



        $scope.$watch(function () {
            return (clNTBEligibileAmountDetailsVm.selectedTenure);
        }, function (tenureValue) {
            if (tenureValue !== undefined) {
                clNTBEligibileAmountDetailsVm.selectedTenure = tenureValue;
                if (clNTBEligibileAmountDetailsVm.selectedTenure) {
                    clNTBEligibileAmountDetailsVm.tenure = clNTBEligibileAmountDetailsVm.selectedTenure;
                    clNTBEligibileAmountDetailsVm.interestRate = clNTBEligibileAmountDetailsVm.getInterestRate(clNTBEligibileAmountDetailsVm.tenure);
                    clNTBEligibileAmountDetailsVm.emiCalculation();
                }
            }
        });


        //loan amount check
        clNTBEligibileAmountDetailsVm.loanAmountCheck = function (loanValue) {
            var loanAmt = parseInt(loanValue);
            if ((loanAmt % 1000) > 0) {
                clNTBEligibileAmountDetailsVm.loanAmount -= (loanAmt % 1000);
            } else {
                clNTBEligibileAmountDetailsVm.loanAmount = loanAmt;
            }
            if (clNTBEligibileAmountDetailsVm.loanAmount <= clNTBEligibileAmountDetailsVm.loanMinAmount) {
                clNTBEligibileAmountDetailsVm.loanAmount = parseInt(clNTBEligibileAmountDetailsVm.loanMinAmount);
                clNTBEligibileAmountDetailsVm.disableMBtn = true;
            } else {
                clNTBEligibileAmountDetailsVm.disableMBtn = false;
            }
            if (clNTBEligibileAmountDetailsVm.loanAmount >= clNTBEligibileAmountDetailsVm.loanMaxAmount) {
                clNTBEligibileAmountDetailsVm.loanAmount = parseInt(clNTBEligibileAmountDetailsVm.loanMaxAmount)
                clNTBEligibileAmountDetailsVm.disablePBtn = true;
            } else {
                clNTBEligibileAmountDetailsVm.disablePBtn = false;
            }

            if (loanAmt < 100000 || isNaN(loanAmt)) {
                clNTBEligibileAmountDetailsVm.loanAmount = 100000;
            }

            // interestRate will only be affected by tenure.
            clNTBEligibileAmountDetailsVm.interestRate = clNTBEligibileAmountDetailsVm.getInterestRate(clNTBEligibileAmountDetailsVm.tenure);
            clNTBEligibileAmountDetailsVm.emiCalculation();
        }

        // EMI calculation
        clNTBEligibileAmountDetailsVm.emiCalculation = function () {
            if ($scope.isNonEdited) {
                return;
            } else {
                clNTBEligibileAmountDetailsVm.emiAmount = clNTBCalculatorService.emiCalculation(clNTBEligibileAmountDetailsVm.loanAmount, clNTBEligibileAmountDetailsVm.interestRate, clNTBEligibileAmountDetailsVm.tenure);
            }
        }


        // decrease amount for loan amount //
        clNTBEligibileAmountDetailsVm.decreaseAmount = function (loanValue) {
            var loanAmount = parseInt(loanValue);
            if (loanAmount) {
                clNTBEligibileAmountDetailsVm.disablePBtn = false;
                if (loanAmount <= clNTBEligibileAmountDetailsVm.loanMinAmount) {
                    clNTBEligibileAmountDetailsVm.disableMBtn = true;
                } else {
                    clNTBEligibileAmountDetailsVm.loanAmount = loanAmount - 1000;
                    if (clNTBEligibileAmountDetailsVm.loanAmount <= clNTBEligibileAmountDetailsVm.loanMinAmount) {
                        clNTBEligibileAmountDetailsVm.disableMBtn = true;
                    }
                }
                clNTBEligibileAmountDetailsVm.loanAmountCheck(clNTBEligibileAmountDetailsVm.loanAmount);
            }
        }


        // increase amount for loan amount //
        clNTBEligibileAmountDetailsVm.increaseAmount = function (loanValue) {
            var loanAmount = parseInt(loanValue);
            if (loanAmount) {
                clNTBEligibileAmountDetailsVm.disableMBtn = false;
                if (loanAmount >= clNTBEligibileAmountDetailsVm.loanMaxAmount) {
                    clNTBEligibileAmountDetailsVm.disablePBtn = true;
                } else {
                    clNTBEligibileAmountDetailsVm.loanAmount = loanAmount + 1000;
                    if (clNTBEligibileAmountDetailsVm.loanAmount >= clNTBEligibileAmountDetailsVm.loanMaxAmount) {
                        clNTBEligibileAmountDetailsVm.disablePBtn = true;
                    }
                }
                clNTBEligibileAmountDetailsVm.loanAmountCheck(clNTBEligibileAmountDetailsVm.loanAmount);
            }
        }


        // edit loan details //
        clNTBEligibileAmountDetailsVm.clNTEditButton = function () {
            $scope.isNonEdited = false;
            $morphCarousel.update('cl-tenure-carousel');
            clNTBEligibileAmountDetailsVm.clNTeligibilityEditScreen2Hide = true;
        }


        // interest button //
        clNTBEligibileAmountDetailsVm.interested = function () {
            if (clNTBEligibileAmountDetailsVm.emiAmount > loanDetails.monthlyEMI) {
                utilityService.showErrorMessage("The proportion of EMIs in net monthly income (NMI) is higher than eligible limit, please verify EMI and/or NMI details and revise");
            } else {
                var request = {
                    "loanamount": clNTBEligibileAmountDetailsVm.loanAmount ? clNTBEligibileAmountDetailsVm.loanAmount : '',
                    "eligibleLoanAmount": clNTBEligibileAmountDetailsVm.loanMaxAmount ? clNTBEligibileAmountDetailsVm.loanMaxAmount : '',
                    "monthlyEMI": clNTBEligibileAmountDetailsVm.emiAmount ? clNTBEligibileAmountDetailsVm.emiAmount : '',
                    "interestRate": clNTBEligibileAmountDetailsVm.interestRate ? clNTBEligibileAmountDetailsVm.interestRate : '',
                    "loanTenure": clNTBEligibileAmountDetailsVm.tenure ? clNTBEligibileAmountDetailsVm.tenure : '',
                };

                clNTBCalculatorService.setEligibalAmountDetail(request);
                clNTBCalculatorService.setIsCallBackRequset('false');
                $state.go('menu.clNTBSubmitDetails');
            }

        }


        // get interest rate //
        clNTBEligibileAmountDetailsVm.getInterestRate = function (clTenure) {         
            var interestRate;
            clTenure = parseInt(clTenure);
            intRates = clNTBEligibileAmountDetailsVm.rateOfInterestMasterDataLists;

            for(var i=0; i < intRates.length; i++){
                if((parseInt(clTenure) >= parseInt(intRates[i].minLoanTenure)) && (parseInt(clTenure) <= parseInt(intRates[i].maxLoanTenure))){
                    interestRate= intRates[i].interestRate;
                }
            }
            return interestRate;
        }


        // on  //
        $scope.$on('$ionicView.beforeEnter', function () {
            clNTBEligibileAmountDetailsVm.initPage();
        });


        // goback condition  //
        clNTBEligibileAmountDetailsVm.goBack = function () {
            clNTBCalculatorService.isCheckEligibilityBack = true;
            $state.go('menu.clNTBEligibilityCheckDetails');
        }


        // request callback  //
        clNTBEligibileAmountDetailsVm.requestCallBack = function () {
            clNTBCalculatorService.isSubmitDetailsBack = false;
            clNTBCalculatorService.setIsCallBackRequset('true')
            $state.go('menu.clNTBSubmitDetails');
        }

        return this;
    }
]);
