'use strict';

angularApp.controller('clNTBEligibilityCheckDetailsController', [
    "$state",
    "$scope",
    "$translate",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService",
    "$filter",
    "clNTBCalculatorService",
    "homeLoanService",

    function ($state,
        $scope,
        $translate,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        $filter,
        clNTBCalculatorService,
        homeLoanService) {

        var clNTBEligibilityCheckDetailsVm = this;

        /* init variables  */
        clNTBEligibilityCheckDetailsVm.initPage = function () {
            

            $scope.applicantDetail = {};
            clNTBEligibilityCheckDetailsVm.clStaticMasterData = clNTBCalculatorService.getStaticMasterData();
            $scope.applicantDetail.birthDate = new Date(clNTBEligibilityCheckDetailsVm.clStaticMasterData.defaultDobDate);
            clNTBEligibilityCheckDetailsVm.selectedBD = 1;
            $scope.endDate = new Date();
            if (clNTBCalculatorService.isCheckEligibilityBack) {
                $scope.applicantDetail = clNTBCalculatorService.applicantData;
                clNTBEligibilityCheckDetailsVm.selectedBD = 5;
                $scope.applicantDetail.activeTab = 5;
                setTimeout(function () {
                document.getElementById('bd-5').classList.add('hl_check_detail_breardcrum_selected');
            }, 500)
            } else {
                $scope.applicantDetail.gender = '';
                $scope.applicantDetail.incomeSource = '';
                $scope.applicantDetail.retirementAge = '';
                $scope.applicantDetail.netMonthlyIncome = '';
                $scope.applicantDetail.emiPaying = '';
                $scope.applicantDetail.emiAndnmiConstraint = false;
                $scope.applicantDetail.activeTab = 1;
                $scope.applicantDetail.nextToUpdate = 0
                $scope.applicantDetail.appDOBSelected = false;
                $scope.applicantDetail.incomeSourceText = '';
                setTimeout(function () {
                document.getElementById('bd-1').classList.add('hl_check_detail_breardcrum_selected');
            }, 500)
            }

            $scope.breadcrumbList = [{ id: 1 },
            { id: 2 }, { id: 3 }, { id: 4 }, { id: 5 }]

            clNTBEligibilityCheckDetailsVm.updatedigest();
            
            $scope.isApplicantScreen = true;
        }
        $scope.dateOptions = {
            maxDate: new Date(),
            minDate:clNTBCalculatorService.calculateAgeProvided(67),
            formatYear: 'yy',
            startingDay: 1
        }

        /* request call back */
        clNTBEligibilityCheckDetailsVm.requestCallBack = function () {
            clNTBCalculatorService.isSubmitDetailsBack = false ;
            clNTBCalculatorService.setIsCallBackRequset('true')
            clNTBCalculatorService.isAmountBack = false ;
            $state.go('menu.clNTBSubmitDetails');
        }


        /* request on  */
        $scope.$on('$ionicView.beforeEnter', function () {
            clNTBEligibilityCheckDetailsVm.initPage();
        });


        /* update digest  */
        clNTBEligibilityCheckDetailsVm.updatedigest = function () {
            if (!$scope.$$phase)
                $scope.$apply();
            return;
        }


        /* update breadcrumb  */
        clNTBEligibilityCheckDetailsVm.updateBreadCrumb = function (val) {
            if (val <= 6) {
                document.getElementById('bd-' + val).classList.add('hl_check_detail_breardcrum_selected');
                document.getElementById('bd-' + $scope.applicantDetail.activeTab).classList.remove('hl_check_detail_breardcrum_selected');
                $scope.applicantDetail.activeTab = val;
                $scope.applicantDetail.nextToUpdate = $scope.applicantDetail.activeTab + 1

                $scope.isApplicantScreen = true;
                clNTBEligibilityCheckDetailsVm.updatedigest();
            } 
        }


        /* go back  */
        clNTBEligibilityCheckDetailsVm.goBack = function () {
            clNTBCalculatorService.isHomeScreenBack = true;
            clNTBCalculatorService.isAmountBack = false
            $state.go('menu.clNTBExploreCarLoan');
        }


        /* goto screen  */
        clNTBEligibilityCheckDetailsVm.goToScreen = function (val) {
            switch (val) {
                case 1:
                    clNTBEligibilityCheckDetailsVm.updateBreadCrumb(val)
                    clNTBEligibilityCheckDetailsVm.selectedBD = val;
                    clNTBEligibilityCheckDetailsVm.selectedCO = val;

                    $scope.applicantDetail.activeTab = val;
                    break;
                case 2:
                    if ($scope.applicantDetail.appDOBSelected) {
                        clNTBEligibilityCheckDetailsVm.updateBreadCrumb(val)
                        clNTBEligibilityCheckDetailsVm.selectedBD = val;
                        clNTBEligibilityCheckDetailsVm.selectedCO = val;

                        $scope.applicantDetail.activeTab = val;
                        if ($scope.applicantDetail.gender != '') {
                            setTimeout(function () {
                                clNTBEligibilityCheckDetailsVm.genderSelected($scope.applicantDetail.gender)
                            }, 500)
                        }
                    } else {
                        return;
                    }
                    break;
                case 3:
                    if ($scope.applicantDetail.gender != '') {
                        clNTBEligibilityCheckDetailsVm.updateBreadCrumb(val)
                        clNTBEligibilityCheckDetailsVm.selectedBD = val;
                        clNTBEligibilityCheckDetailsVm.selectedCO = val;

                        $scope.applicantDetail.activeTab = val;
                        setTimeout(function () {
                            clNTBEligibilityCheckDetailsVm.incomeSourceSelected($scope.applicantDetail.incomeSource)
                        }, 1000)
                        clNTBEligibilityCheckDetailsVm.updatedigest();
                    } else {

                        return;
                    }
                    break;
                case 4:
                    if ($scope.applicantDetail.incomeSource != '') {
                        clNTBEligibilityCheckDetailsVm.updateBreadCrumb(val)
                        clNTBEligibilityCheckDetailsVm.selectedBD = val;
                        clNTBEligibilityCheckDetailsVm.selectedCO = val;

                        $scope.applicantDetail.activeTab = val;
                        $scope.applicantDetail.nmiError = false
                        clNTBEligibilityCheckDetailsVm.updatedigest();

                    } else {

                        return;
                    }
                    break;
                case 5:
                    if ($scope.applicantDetail.netMonthlyIncome != '') {
                        clNTBEligibilityCheckDetailsVm.updateBreadCrumb(val)
                        clNTBEligibilityCheckDetailsVm.selectedBD = val;
                        clNTBEligibilityCheckDetailsVm.selectedCO = val;

                        $scope.applicantDetail.activeTab = val;
                        $scope.applicantDetail.emiError = false;
                        clNTBEligibilityCheckDetailsVm.updatedigest();
                    } else {

                        return;
                    }
                    break;
                case 6:
                    if ($scope.applicantDetail.emiPaying != '') {
                        clNTBEligibilityCheckDetailsVm.updateBreadCrumb(val)
                        clNTBEligibilityCheckDetailsVm.selectedBD = val;
                        clNTBEligibilityCheckDetailsVm.selectedCO = val;

                        $scope.applicantDetail.activeTab = val;

                    } else {
                        return;
                    }
                    break;
                default:
                    val = 1;
                    clNTBEligibilityCheckDetailsVm.updateBreadCrumb(val)
                    clNTBEligibilityCheckDetailsVm.selectedBD = val;
                    clNTBEligibilityCheckDetailsVm.selectedCO = val;

                    $scope.applicantDetail.activeTab = val;
                    break;

                }
                clNTBEligibilityCheckDetailsVm.updatedigest();
            }


            /* goto on next button */
            clNTBEligibilityCheckDetailsVm.goToNext = function (val) {
            if (val == 2) {
                if ($scope.applicantDetail.birthDate == '' || $scope.applicantDetail.birthDate == null || $scope.applicantDetail.birthDate == undefined) {

                    if (clNTBCalculatorService.isValidField($scope.applicantDetail.birthDate, "applicant DOB")) {
                        $scope.applicantDetail.dobError = clNTBCalculatorService.isValidField($scope.applicantDetail.birthDate, "applicant DOB");
                    }

                } else {
                    if (clNTBCalculatorService.calculateAge($scope.applicantDetail.birthDate) < clNTBEligibilityCheckDetailsVm.clStaticMasterData.minAge || clNTBCalculatorService.calculateAge($scope.applicantDetail.birthDate) > clNTBEligibilityCheckDetailsVm.clStaticMasterData.maxAge) {
                        $scope.applicantDetail.dobError = "Applicant's age should be between " + clNTBEligibilityCheckDetailsVm.clStaticMasterData.minAge + " - " + clNTBEligibilityCheckDetailsVm.clStaticMasterData.maxAge + " years"
                        return;
                    } else {
                        clNTBEligibilityCheckDetailsVm.selectedBD = val;
                        $scope.applicantDetail.appDOBSelected = true;
                        $scope.applicantDetail.dobError = ''
                        clNTBEligibilityCheckDetailsVm.updateBreadCrumb(val);

                        if ($scope.applicantDetail.gender != '') {
                            setTimeout(function () {
                                clNTBEligibilityCheckDetailsVm.genderSelected($scope.applicantDetail.gender)
                            }, 500)
                        }
                    }
                }

            } else if (val == 3) {
                if (val == 3 && ($scope.applicantDetail.gender == '' || $scope.applicantDetail.gender == null || $scope.applicantDetail.gender == undefined)) {
                    if (clNTBCalculatorService.isValidField($scope.applicantDetail.gender, "applicant gender")) {
                        $scope.applicantDetail.genderError = clNTBCalculatorService.isValidField($scope.applicantDetail.gender, "applicant gender");
                    }
                } else {
                    clNTBEligibilityCheckDetailsVm.selectedBD = val;
                    clNTBEligibilityCheckDetailsVm.updateBreadCrumb(val);
                    if ($scope.applicantDetail.incomeSource != '') {
                        setTimeout(function () {
                            clNTBEligibilityCheckDetailsVm.incomeSourceSelected($scope.applicantDetail.incomeSource)
                        }, 500)
                    }
                }
            }
            else if (val == 4) {
                if ($scope.applicantDetail.incomeSource == '' || $scope.applicantDetail.incomeSource == null || $scope.applicantDetail.incomeSource == undefined) {
                    if (clNTBCalculatorService.isValidField($scope.applicantDetail.incomeSource, "applicant income source")) {
                        $scope.applicantDetail.incomeError = clNTBCalculatorService.isValidField($scope.applicantDetail.incomeSource, "applicant income source");
                        console.log($scope.applicantDetail.incomeError)
                        return;
                    }
                }
                else {

                    clNTBEligibilityCheckDetailsVm.selectedBD = val;
                    $scope.applicantDetail.incomeError = '';
                    clNTBEligibilityCheckDetailsVm.updateBreadCrumb(val);
                }

            } else if (val == 5) {
                if ($scope.applicantDetail.netMonthlyIncome == '' || $scope.applicantDetail.netMonthlyIncome == null || $scope.applicantDetail.netMonthlyIncome == undefined) {
                    if (clNTBCalculatorService.isValidField($scope.applicantDetail.netMonthlyIncome, "applicant net monthly income")) {
                        $scope.applicantDetail.nmiError = clNTBCalculatorService.isValidField($scope.applicantDetail.netMonthlyIncome, "applicant net monthly income");
                    }
                }
                else {
                    if ($scope.applicantDetail.netMonthlyIncome < parseInt(clNTBEligibilityCheckDetailsVm.clStaticMasterData.minNetMonthlyIncome)) {
                        $scope.applicantDetail.nmiError = 'Your minimum montly income should be greater than Rs. ' + parseInt(clNTBEligibilityCheckDetailsVm.clStaticMasterData.minNetMonthlyIncome) + ' for applying car loan on YONO.';
                        return;
                    } 
                    else {
                        clNTBEligibilityCheckDetailsVm.selectedBD = val;
                        $scope.applicantDetail.nmiError = '';
                        clNTBEligibilityCheckDetailsVm.updateBreadCrumb(val);
                    }
                }
            }
            else if (val == 6) {
                if ($scope.applicantDetail.emiPaying == '' || $scope.applicantDetail.emiPaying == null || $scope.applicantDetail.emiPaying == undefined) {
                    if (clNTBCalculatorService.isValidField($scope.applicantDetail.emiPaying, "applicant existing paying EMI")) {
                        $scope.applicantDetail.emiError = clNTBCalculatorService.isValidField($scope.applicantDetail.emiPaying, "applicant existing paying EMI");
                    }
                } else {
                    clNTBEligibilityCheckDetailsVm.selectedBD = val;
                    $scope.applicantDetail.emiError = '';
                    clNTBEligibilityCheckDetailsVm.updateBreadCrumb(val);
                 }
            }

                clNTBEligibilityCheckDetailsVm.updatedigest();
        }


        /* gender selection */
        clNTBEligibilityCheckDetailsVm.genderSelected = function (val) {

            if (val == 'M') {
                document.getElementById('NTB_HL_Male').classList.add("hlNTBDetailsBtn_after_click");
                document.getElementById('NTB_HL_Female').classList.remove("hlNTBDetailsBtn_after_click");
                document.getElementById('NTB_HL_Others').classList.remove("hlNTBDetailsBtn_after_click");
            } else if (val == 'F') {
                document.getElementById('NTB_HL_Female').classList.add("hlNTBDetailsBtn_after_click");
                document.getElementById('NTB_HL_Others').classList.remove("hlNTBDetailsBtn_after_click");
                document.getElementById('NTB_HL_Male').classList.remove("hlNTBDetailsBtn_after_click");
            } else {
                document.getElementById('NTB_HL_Others').classList.add("hlNTBDetailsBtn_after_click");
                document.getElementById('NTB_HL_Male').classList.remove("hlNTBDetailsBtn_after_click");
                document.getElementById('NTB_HL_Female').classList.remove("hlNTBDetailsBtn_after_click");
            }

            setTimeout(function () {
                clNTBEligibilityCheckDetailsVm.selectedBD = 3
                $scope.applicantDetail.gender = val
                clNTBEligibilityCheckDetailsVm.updateBreadCrumb(3);
                if ($scope.applicantDetail.incomeSource != '') {
                    setTimeout(function () {
                        clNTBEligibilityCheckDetailsVm.incomeSourceSelected($scope.applicantDetail.incomeSource)
                    }, 500)
                }
                clNTBEligibilityCheckDetailsVm.updatedigest();

            }, 500);
        }


        /* income selection */
        clNTBEligibilityCheckDetailsVm.incomeSourceSelected = function (val) {
            if (val == 'SL') {
                document.getElementById('NTB_HL_SALARY').classList.add("hlNTBDetailsBtn_after_click");
                document.getElementById('NTB_HL_SELF_EMP').classList.remove("hlNTBDetailsBtn_after_click");
                document.getElementById('NTB_HL_OTH').classList.remove("hlNTBDetailsBtn_after_click");
                $scope.applicantDetail.incomeSourceText = true ;
            } else if (val == 'SE') {
                document.getElementById('NTB_HL_SELF_EMP').classList.add("hlNTBDetailsBtn_after_click");
                document.getElementById('NTB_HL_OTH').classList.remove("hlNTBDetailsBtn_after_click");
                document.getElementById('NTB_HL_SALARY').classList.remove("hlNTBDetailsBtn_after_click");
                $scope.applicantDetail.incomeSourceText = false
            } else {
                document.getElementById('NTB_HL_OTH').classList.add("hlNTBDetailsBtn_after_click");
                document.getElementById('NTB_HL_SALARY').classList.remove("hlNTBDetailsBtn_after_click");
                document.getElementById('NTB_HL_SELF_EMP').classList.remove("hlNTBDetailsBtn_after_click");
                $scope.applicantDetail.incomeSourceText = false ;
            }

            setTimeout(function () {
                clNTBEligibilityCheckDetailsVm.selectedBD = 4
                $scope.applicantDetail.incomeSource = val
               clNTBEligibilityCheckDetailsVm.updateBreadCrumb(4);
                clNTBEligibilityCheckDetailsVm.updatedigest();
            }, 500);

            clNTBEligibilityCheckDetailsVm.updatedigest();
        }


        /* validate applicant details */
        clNTBEligibilityCheckDetailsVm.validateApplicantDetail = function () {
            var isVal = false;
            if ($scope.applicantDetail.birthDate == '' || $scope.applicantDetail.birthDate == null || $scope.applicantDetail.birthDate == undefined) {
                isVal = true;
            }
            if ($scope.applicantDetail.gender == '' || $scope.applicantDetail.gender == null || $scope.applicantDetail.gender == undefined) {
                isVal = true;
            }
            if ($scope.applicantDetail.incomeSource == '' || $scope.applicantDetail.incomeSource == null || $scope.applicantDetail.incomeSource == undefined) {
                isVal = true;
            } else {
                if($scope.applicantDetail.incomeSource == 'SL') {
                    isVal = true;
                }
            }
            if ($scope.applicantDetail.netMonthlyIncome < 10000 || $scope.applicantDetail.netMonthlyIncome == '' || $scope.applicantDetail.netMonthlyIncome == null || $scope.applicantDetail.netMonthlyIncome == undefined) {
                isVal = true;
            }
            if ($scope.applicantDetail.emiPaying == '' || $scope.applicantDetail.emiPaying == null || $scope.applicantDetail.emiPaying == undefined) {
                isVal = true;
            }
            if ($scope.applicantDetail.emiPaying > $scope.applicantDetail.netMonthlyIncome) {
                isVal = true;
            }
            if ($scope.applicantDetail.incomeSource == 'SL' && (clNTBCalculatorService.calculateAge($scope.applicantDetail.birthDate) <= clNTBEligibilityCheckDetailsVm.clStaticMasterData.maxAge)) {
                isVal = true;
            }
            return isVal;
        }

        /* coapplicant selection */
        clNTBEligibilityCheckDetailsVm.validateCoApplicantDetail = function () {
        }


        /* get Date format */
        clNTBEligibilityCheckDetailsVm.getDateInFormat = function (date) {
            var today = new Date(date);
            var dd = today.getDate();

            var mm = today.getMonth() + 1;
            var yyyy = today.getFullYear();
            if (dd < 10) {
                dd = '0' + dd;
            }

            if (mm < 10) {
                mm = '0' + mm;
            }

            today = dd + '/' + mm + '/' + yyyy;
            console.log(today);
            return today
        }


        /* get eligibility service call */
        clNTBEligibilityCheckDetailsVm.getEligibilityServiceCall = function () {
            var payload = {
                "applicantDetails": {
                }
            }

            payload.applicantDetails.dateOfBirth = clNTBEligibilityCheckDetailsVm.getDateInFormat($scope.applicantDetail.birthDate);

            // if ($scope.applicantDetail.gender == 'F') {
            //     payload.applicantDetails.gender = 'F';
            // } else if($scope.applicantDetail.gender == 'M') {
            //     payload.applicantDetails.gender = 'M';
            // } else{
            //     payload.applicantDetails.gender = 'M';
            // }
            payload.applicantDetails.gender = $scope.applicantDetail.gender ;
            if ($scope.applicantDetail.incomeSource == 'SL') {
                payload.applicantDetails.incomeSource = 'Salaried';
            } else {
                payload.applicantDetails.incomeSource = 'Others';
            }
            payload.applicantDetails.netMonthlyIncome = $scope.applicantDetail.netMonthlyIncome;
            payload.applicantDetails.emiOnExistingLoan = $scope.applicantDetail.emiPaying;
            clNTBCalculatorService.getEligiblityCheck(payload.applicantDetails).then(function (response) {
                clNTBCalculatorService.applicantData = $scope.applicantDetail;
                clNTBCalculatorService.setGLLoanDetails(response);
                clNTBCalculatorService.setCheckEligiblityRequest(payload);
                clNTBCalculatorService.setCheckEligiblityResponse(response);
                clNTBCalculatorService.isAmountBack = false ;
                $state.go('menu.clNTBEligibileAmountDetails');
            }, function (error) {
                if(error.isValidationFailedResponse){
                    $scope.applicantDetail.emiError = error.responseMessage ;
                }else{
                    utilityService.showErrorMessage(error.responseMessage);
                }
                
            });
        }


        /* check eligibility */
        clNTBEligibilityCheckDetailsVm.checkEligibility = function () {
            if($scope.applicantDetail.emiPaying == '' || $scope.applicantDetail.emiPaying == undefined || $scope.applicantDetail.emiPaying == null){
                $scope.applicantDetail.emiError = 'Please provide applicant existing paying EMI. '
            }else{
                $scope.applicantDetail.emiError = '';
                var temp = {
                    "dateOfBirth": "",
                    "gender": "",
                    "incomeSource": "",
                    "netMonthlyIncome": "",
                    "emiOnExistingLoan": ""
                };
                temp.dateOfBirth = clNTBEligibilityCheckDetailsVm.getDateInFormat($scope.applicantDetail.birthDate);
                temp.gender = $scope.applicantDetail.gender;
                temp.incomeSource = $scope.applicantDetail.incomeSource;
                temp.netMonthlyIncome = $scope.applicantDetail.netMonthlyIncome;
                temp.emiOnExistingLoan = $scope.applicantDetail.emiPaying;
                clNTBCalculatorService.setApplicantGender($scope.applicantDetail.gender);
                clNTBCalculatorService.setApplicantOccupation($scope.applicantDetail.incomeSource);
                clNTBEligibilityCheckDetailsVm.getEligibilityServiceCall();
            }
        }
       return this;
    }
]);
