'use strict';

angularApp.controller('clNTBExploreCarLoanController', [
    "$state",
    "$scope",
    "$translate",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService",
    "$filter",
    "closePopupService",
    "clNTBCalculatorService",
    "homeLoanService",
    "$ionicSlideBoxDelegate", "constantConfig", "cryptoService",
    function ($state,
        $scope,
        $translate,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        $filter,
        closePopupService,
        clNTBCalculatorService,
        homeLoanService,
        $ionicSlideBoxDelegate, constantConfig, cryptoService) {

        var clNTBExploreCarLoanVm = this;

        //initialize variable
        clNTBExploreCarLoanVm.initPage = function () {
            clNTBExploreCarLoanVm.bannerList = [];
            clNTBExploreCarLoanVm.getData = '';
            clNTBExploreCarLoanVm.isMaskDob = true;
            $scope.maskedNumber = '';
            clNTBExploreCarLoanVm.childBanner = '';
            clNTBExploreCarLoanVm.masterData = '';
            $scope.callService = 0;
            clNTBExploreCarLoanVm.getBanner();
            clNTBExploreCarLoanVm.getContent();
            clNTBExploreCarLoanVm.minAge = "";
            clNTBExploreCarLoanVm.maxAge = "";
            $scope.merchantData = [];
        }

        // track application
        clNTBExploreCarLoanVm.trackApplication = function () {
            $scope.refNo = {};
            var backPopup = $ionicPopup.show({
                cssClass: 'ntb-alert-popup hlExploreTrackPop',
                template: '<div class="">' +
                    '<div class="text-center">' +
                    '<div class="roboto-bold font-size-18" translate="NTB_HL_TRACK_APP_LBL"></div>' +
                    '<div class="roboto-medium font-size-14 padTop10" translate="NTB_HL_REF_NO_LBL"></div>' +
                    '<div class="roboto-light font-size-12 padTop10" translate="NTB_HL_TRACK_REF_STMT"></div></div>' +
                    '<div class="padTop10 hlInputTrack clNTBTrack"><label class="width100 fss-input-box item-floating-label form-field fss-select-box-div">' +
                    '<span class="input-label color-darkgrey font-size-12" ng-bind="\'NTB_HL_REF_NO\' | translate"></span>' +
                    '<input type="tel" numeric-only max-len="10" style="width: 100% !important;" placeholder="{{\'NTB_HL_REF_NO\' | translate}}" ' +
                    'class="roboto-regular font-size-16 color-darkgrey width90" ng-model="refNo.referenceNumber">' +
                    '</label><div class="inputErrorMsg" ng-show="refNo.refNoError" ng-bind="refNo.refNoError"></div></div></div>',
                scope: $scope,
                buttons: [
                    {
                        text: 'Submit',
                        type: 'button-positive clNTBrefere',
                        onTap: function () {

                            if (clNTBCalculatorService.isValidField($scope.refNo.referenceNumber, "Reference Number")) {
                                $scope.refNo.refNoError = clNTBCalculatorService.isValidField($scope.refNo.referenceNumber, "Reference Number");
                                backPopup.show();
                            } else if ((parseInt($scope.refNo.referenceNumber)) === 0) {
                                $scope.refNo.refNoError = "Reference number accepts minimum 1 and maximum 10 numeric values (0 to 9 only) and all zeros not allowed"
                                backPopup.show();
                            } else {
                                $scope.refNo.refNoError = "";
                                var request = {
                                    "leadId": $scope.refNo.referenceNumber ? $scope.refNo.referenceNumber : ''
                                };
                                clNTBCalculatorService.submitReferenceNumber(request).then(function (data) {
                                    $scope.refNo.referenceNumber = data.leadId;
                                    $scope.refNo.contactNo = data.mobile;
                                    clNTBExploreCarLoanVm.setMaskedNumber($scope.refNo.contactNo);
                                    var backPopup1 = $ionicPopup.alert({
                                        cssClass: 'ntb-alert-popup hlExploreTrackPop',
                                        template: '<div class=""><div class="text-center">' +
                                            '<div class="roboto-bold font-size-18" translate="NTB_HL_TRACK_APP_LBL"></div>' +
                                            '<div class="roboto-medium font-size-14 padTop10" translate="NTB_HL_REF_NO_LBL"></div>' +
                                            '<div class="roboto-light font-size-12 padTop10" translate="NTB_HL_TRACK_REF_STMT"></div></div>' +
                                            '<div class="padTop15">' +
                                            '<div class="roboto-regular font-size-12" translate="NTB_HL_REF_NO"></div>' +
                                            '<div class="roboto-regular font-size-16 padTop5"> {{ refNo.referenceNumber }}' +
                                            '<span><img src="img/HomeLoan/Sucess.svg" class="hlSuccess"/></span></div>' +
                                            '</div><div class="padTop20">' +
                                            '<div class="roboto-medium font-size-14" translate="NTB_HL_CONTACT_NUMBER_VERIFY_STMT"></div>' +
                                            '<div class="padTop20"><div class="row roboto-regular font-size-12 color3F" style="padding:0 0 5px 0" translate="NTB_HL_CONTACT"></div>' +
                                            '<div class="padtop10" ng-if="clNTBExploreCarLoanVm.isMaskDob">' +
                                            '<span class="clisMask roboto-regular">{{maskedNumber}}</span>' +
                                            '</div>' +
                                            '</div></div></div>',
                                        scope: $scope,
                                        buttons: [{
                                            text: 'Send OTP',
                                            type: 'button-positive hlReferButton clNTBrefere',
                                            onTap: function () {
                                                $scope.callService = $scope.callService + 1;
                                                utilityService.showSpinner();
                                                var reqParams = {};
                                                reqParams["id"] = $scope.refNo.contactNo ? $scope.refNo.contactNo : '';
                                                reqParams.otpCode = constantConfig.keysForOTP.Register;
                                                reqParams.ocHash = cryptoService.getSHA512EncryptedData(constantConfig.keysForOTP.Register).toString();
                                                if ($scope.callService == 1) {
                                                    clNTBCalculatorService.generateOTP(reqParams).then(function (response) {
                                                        clNTBCalculatorService.trackReferenceData = true;
                                                        clNTBCalculatorService.leadID = $scope.refNo.referenceNumber;
                                                        clNTBCalculatorService.leadMobile = $scope.refNo.contactNo;
                                                        $scope.callService = 0;
                                                        utilityService.hideSpinner();
                                                        $state.go('menu.clNTBOTPVerification');
                                                        clNTBExploreCarLoanVm.updatedigest();
                                                    }, function (error) {
                                                        $scope.callService = 0;
                                                        utilityService.hideSpinner();
                                                        utilityService.showErrorMessage(error.responseMessage);
                                                    });
                                                }
                                            }
                                        }],
                                    });
                                    closePopupService.register(backPopup1);
                                }, function (error) {
                                    utilityService.showErrorMessage(error.responseMessage);
                                });
                            }
                        }
                    }],
            });
            closePopupService.register(backPopup);
        }


        //update digest
        clNTBExploreCarLoanVm.updatedigest = function () {
            if (!$scope.$$phase)
                $scope.$apply();
            return;
        }

        //set Mask Number
        clNTBExploreCarLoanVm.setMaskedNumber = function (val) {
            $scope.maskedNumber = val.replace(/[0-9]{6}/, 'XXXXXX');
        }

        //get Banner
         clNTBExploreCarLoanVm.getBanner = function () {
            clNTBCalculatorService.getLeadGenerationBanner().then(function (response) {
                clNTBExploreCarLoanVm.bannerList = response;
                clNTBExploreCarLoanVm.getBannerTimeout();
            }).catch(function (error) {
            })
        }

        clNTBExploreCarLoanVm.getBannerTimeout = function(){
            setTimeout(function () {
                $ionicSlideBoxDelegate.update();
                $ionicSlideBoxDelegate.loop(true);
            }, 400);
        }

        //get Home Contnet
        clNTBExploreCarLoanVm.getContent = function () {
            clNTBCalculatorService.getHomeContent().then(function (response) {
                clNTBExploreCarLoanVm.getData = response.carLoanLeadGeneration;
            }).catch(function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        //get child banner
        clNTBExploreCarLoanVm.dataForIndividualMerchant = {};
        clNTBExploreCarLoanVm.getBannerExploreBanners = function () {
            clNTBExploreCarLoanVm.getBannerExplore();

        }

        clNTBExploreCarLoanVm.getBannerExplore = function () {
            var payload = {
                "categoryCode": clNTBExploreCarLoanVm.bannerList[0].categoryCode
            }
            clNTBCalculatorService.getBannerExplore(payload).then(function (response) {
                clNTBExploreCarLoanVm.childBanner = response;

                clNTBExploreCarLoanVm.dataForIndividualMerchant = clNTBExploreCarLoanVm.childBanner[0].merchant.mobileData;
                $scope.merchantData = response[0].merchant.mobileData[0].row// clNTBExploreCarLoanVm.dataForIndividualMerchant;
                clNTBCalculatorService.getBannerExploreDetails("", "To avail these offers, kindly register or login to YONO with valid credentials.", clNTBExploreCarLoanVm.childBanner,
                    "menu.clNTBExploreCarLoan", "", "", $scope, "");
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }


        // on condtn
        $scope.$on('$ionicView.beforeEnter', function () {
            clNTBExploreCarLoanVm.initPage();
        });


        // goBack button
        clNTBExploreCarLoanVm.goBack = function () {
            if (clNTBCalculatorService.isFromHamburger) {
                $state.go('menu.loansLanding');
            }
            if (clNTBCalculatorService.isFromNTB) {
                $state.go('menu.newToSbiLanding');
            }

        }


        // request call back
        clNTBExploreCarLoanVm.requestCallBack = function () {
            clNTBCalculatorService.isSubmitDetailsBack = false;
            clNTBCalculatorService.setIsCallBackRequset('true')
            $state.go('menu.clNTBSubmitDetails');
        }


        // get started
        clNTBExploreCarLoanVm.getStarted = function () {
            clNTBCalculatorService.isCheckEligibilityBack = false;
            clNTBCalculatorService.isSubmitDetailsBack = false;
            clNTBCalculatorService.submitLeadData = {};

            clNTBCalculatorService.getMasterData().then(function (response) {
                clNTBExploreCarLoanVm.masterData = response;
                clNTBCalculatorService.setStaticMasterData(clNTBExploreCarLoanVm.masterData.staticMasterData);
                clNTBCalculatorService.setRateOfInterestMasterDataLists(clNTBExploreCarLoanVm.masterData.rateOfInterestMasterDataLists);
                $state.go('menu.clNTBEligibilityCheckDetails');
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        return this;
    }
]);
