'use strict';

angularApp.controller('clNTBIncomeStmtController', [
    "$state",
    "$scope",
    "$translate",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService",
    "cryptoService",
    "clNTBCalculatorService",
    function ($state,
        $scope,
        $translate,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        cryptoService,
        clNTBCalculatorService) {

        var clNTBIncomeStmtVm = this;     

        clNTBIncomeStmtVm.initPage = function () {
            clNTBCalculatorService.getDisclaimerContent().then(function (response) {
                clNTBCalculatorService.disclaimerLine1 = response.disclaimerLine1;
                clNTBCalculatorService.disclaimerLine2 = response.disclaimerLine2;
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        clNTBIncomeStmtVm.goBack = function (){
            $ionicHistory.goBack();
        }

        clNTBIncomeStmtVm.proceedToAA = function() {
            if(clNTBCalculatorService.ntbConsentCounter === 1){
                clNTBCalculatorService.finalConsentCheck();
            }else{
                $state.go('menu.ntbAALandingPage');
            }
        }

        clNTBIncomeStmtVm.skipAA = function() {
             $state.go('menu.clNTBReferenceDetails');
        }
     
        $scope.$on('$ionicView.beforeEnter', function () {
            clNTBIncomeStmtVm.initPage();
        });

        return this;
    }
]);
