'use strict';

angularApp.controller('clNTBOTPVerificationController', [
    "$state",
    "$scope",
    "$translate",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService",
    "$filter",
    "clNTBCalculatorService",    
    "constantConfig",
    "cryptoService","goldLoanRLMSService",

    function ($state,
        $scope,
        $translate,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        $filter,
        clNTBCalculatorService,        
        constantConfig,
        cryptoService,goldLoanRLMSService) {

        var clNTBOTPVerificationVm = this;
        clNTBOTPVerificationVm.flowType = '';

        // initial variables
        clNTBOTPVerificationVm.initPage = function () {
            $scope.resendOtpCounter = 0;
            $scope.invalidOtpCounter = 0;

            if (clNTBCalculatorService.trackReferenceData) {
                clNTBOTPVerificationVm.mobileNumber = clNTBCalculatorService.leadMobile;
            } else {
                clNTBOTPVerificationVm.mobileNumber = clNTBCalculatorService.getContactNumber();
            }

            clNTBOTPVerificationVm.leadGeneratePayLoad = {};
            clNTBOTPVerificationVm.leadGeneratePayLoad = clNTBCalculatorService.getGenerateLeadData();
            setTimeout(function () {
                clNTBOTPVerificationVm.updateheader();
            }, 1000);
        }

        //resend OTP
        clNTBOTPVerificationVm.resendOTP = function () {
            utilityService.showSpinner();
            $scope.invalidOtpCounter = 0;
            if ($scope.isDisabledOTPbtn) {
                return true;
            }
            utilityService.showSpinner();
            clNTBOTPVerificationVm.otp = null;
            clNTBOTPVerificationVm.isValidOtp = true;
            var reqParams = {};
            if (clNTBCalculatorService.trackReferenceData) {
                reqParams["id"] = clNTBCalculatorService.leadMobile ? clNTBCalculatorService.leadMobile : '';
            } else {
                reqParams["id"] = clNTBOTPVerificationVm.mobileNumber;
            }
            reqParams.otpCode = constantConfig.keysForOTP.Register;
            reqParams.ocHash = cryptoService.getSHA512EncryptedData(constantConfig.keysForOTP.Register).toString();
            clNTBCalculatorService.generateOTP(reqParams).then(function (data) {
                utilityService.hideSpinner();
                clNTBCalculatorService.showAlertPopup("", "OTP resent Successfully", "", "", "OK", "", "", "");
                $scope.resendOtpCounter += 1;
                if ($scope.resendOtpCounter === 2) {
                    $scope.isDisabledOTPbtn = true;
                }
            }, function (error) {
                clNTBOTPVerificationVm.otpError = '';
                utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });
        };

        // update header according to flow
        clNTBOTPVerificationVm.updateheader = function () {
            if (clNTBCalculatorService.trackReferenceData) {
                clNTBOTPVerificationVm.flowType = 'T';
            } else if (clNTBCalculatorService.getIsCallBackRequset() == 'false') {
                clNTBOTPVerificationVm.flowType = 'N';
            } else {
                clNTBOTPVerificationVm.flowType = 'R';
            }
            if (!$scope.$$phase){
                $scope.$apply();
            }            
        }

        //submit OTP
        clNTBOTPVerificationVm.submitOTP = function () {
            utilityService.hideSpinner();
            if (clNTBCalculatorService.isValidField(clNTBOTPVerificationVm.otp, "OTP")) {
                clNTBOTPVerificationVm.otpError = clNTBCalculatorService.isValidField(clNTBOTPVerificationVm.otp, "OTP");
            } else {
                var reqParams = {};
                if (clNTBCalculatorService.trackReferenceData) {
                    reqParams["otp"] = clNTBOTPVerificationVm.otp ? clNTBOTPVerificationVm.otp : '';
                    reqParams["mobile"] = clNTBCalculatorService.leadMobile ? clNTBCalculatorService.leadMobile : '';
                } else {
                    reqParams["otp"] = clNTBOTPVerificationVm.otp;
                    reqParams["mobile"] = clNTBOTPVerificationVm.mobileNumber;
                }
                clNTBCalculatorService.validateOTP(reqParams).then(function (data) {
                    if (clNTBCalculatorService.trackReferenceData) {
                        var request = {
                            "leadId": clNTBCalculatorService.leadID ? clNTBCalculatorService.leadID : '',
                            "mobile": clNTBCalculatorService.leadMobile ? clNTBCalculatorService.leadMobile : ''
                        };
                        clNTBCalculatorService.getReferenceNumberStatus(request).then(function (response) {
                            clNTBCalculatorService.leadID = '';
                            clNTBCalculatorService.leadMobile = ''
                            clNTBCalculatorService.setReferenceStatusData(response);
                            $state.go('menu.clNTBReferenceDetails');
                        }, function (error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    } else {
                        clNTBCalculatorService.submitLeadDetails(clNTBCalculatorService.getGenerateLeadData()).then(function (res) {
                            clNTBCalculatorService.setReferenceStatusData(res);                            
                            $state.go('menu.clNTBIncomeStmt');
                        }, function (error) {
                            if (error.isValidationFailedResponse) {
                                goldLoanRLMSService.showAlertPopup("error", "", error.responseMessage,
                                    "menu.clNTBExploreCarLoan", "Go to Home Page", "", "", "");
                            } else {
                                utilityService.showErrorMessage(error.responseMessage);
                            }
                        });
                    }
                }, function (error) {
                    utilityService.hideSpinner();
                    clNTBOTPVerificationVm.otpError = '';
                    $scope.invalidOtpCounter += 1;
                    if ($scope.invalidOtpCounter === 3) {
                        $ionicPopup.show({
                            template: 'You have exceeded number of attempts. Please try after sometime.',
                            title: '',
                            cssClass: 'dialog',
                            scope: $scope,
                            buttons: [{
                                text: 'OK',
                                type: 'button-positive',
                                onTap: function () {
                                    clNTBOTPVerificationVm.invalidOtpCounter = true;
                                }
                            }]
                        });
                    } else {
                        utilityService.showErrorMessage(error.responseMessage);
                    }
                });
            }
        }

        //on condition   
        $scope.$on('$ionicView.beforeEnter', function () {
            clNTBOTPVerificationVm.initPage();
        });

        //go Back
        clNTBOTPVerificationVm.goBack = function () {
            clNTBCalculatorService.isSubmitDetailsBack = true;
            $ionicHistory.goBack(-1);
        }
        return this;
    }
]);