'use strict';

angularApp.controller('clNTBReferenceDetailsController', [
    "$state",
    "$scope",
    "$translate",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService",
    "$filter",
    "clNTBCalculatorService",
    "homeLoanService",
    "goldLoanRLMSService",
    function ($state,
        $scope,
        $translate,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        $filter,
        clNTBCalculatorService,
        homeLoanService,
        goldLoanRLMSService,
        $hlReferSliderFun) {

        var clNTBReferenceDetailsVm = this;
        clNTBReferenceDetailsVm.flowType = 'P';
        //initialize variable
        clNTBReferenceDetailsVm.initPage = function () {
            clNTBReferenceDetailsVm.consentReceived = clNTBCalculatorService.consentReceived;
            clNTBReferenceDetailsVm.userDetails = clNTBCalculatorService.getGenerateLeadData();
            clNTBReferenceDetailsVm.refNo = clNTBCalculatorService.getReferenceStatusData().crmLeadID;
            clNTBReferenceDetailsVm.name = clNTBReferenceDetailsVm.userDetails.firstname + " " + clNTBReferenceDetailsVm.userDetails.lastname;
            clNTBReferenceDetailsVm.bannerList = [];
            clNTBReferenceDetailsVm.getBanner();
            $scope.merchantData = [];
            if (clNTBCalculatorService.getReferenceStatusData()) {
                clNTBReferenceDetailsVm.applicationStatus = clNTBCalculatorService.getReferenceStatusData().statusCode;
            }
            setTimeout(function () {
                clNTBReferenceDetailsVm.updateheader();
            }, 1000);
        }

        //on condtn
        $scope.$on('$ionicView.beforeEnter', function () {
            clNTBReferenceDetailsVm.initPage();
        });

        //go to home button
        clNTBReferenceDetailsVm.goToHome = function () {
            var temp = {};
            clNTBCalculatorService.setCheckEligiblityRequest(temp);
            clNTBCalculatorService.setCheckEligiblityResponse(temp)
            clNTBCalculatorService.setEligibalAmountDetail(temp)
            clNTBCalculatorService.isSubmitDetailsBack = false;
            clNTBCalculatorService.trackReferenceData = false;
            clNTBCalculatorService.isJourneyCompleted = true;
            clNTBCalculatorService.trackReferenceData = false;
            $ionicHistory.clearHistory();
            $state.go('menu.clNTBExploreCarLoan');
        }
        //clear reference
        clNTBReferenceDetailsVm.clRefereNextSlide = function () {
            $hlReferSliderFun.next();
        }

        clNTBReferenceDetailsVm.updateheader = function () {
            if (clNTBCalculatorService.trackReferenceData) {
                clNTBReferenceDetailsVm.flowType = 'T'
            } else if (clNTBCalculatorService.getIsCallBackRequset() == 'false') {
                clNTBReferenceDetailsVm.flowType = 'N'
            } else {
                clNTBReferenceDetailsVm.flowType = 'R'
            }
            if (!$scope.$$phase)
                $scope.$apply();
        }
        // get banners 
        clNTBReferenceDetailsVm.getBanner = function () {
            clNTBCalculatorService.getLeadGenerationBanner().then(function (response) {
                clNTBReferenceDetailsVm.bannerList = response;
            }).catch(function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
        //get child banner
        clNTBReferenceDetailsVm.dataForIndividualMerchant = {};
        clNTBReferenceDetailsVm.getBannerExploreBanners = function () {
            clNTBReferenceDetailsVm.getBannerExplore();
        }

        clNTBReferenceDetailsVm.getBannerExplore = function () {
            var payload = {
                "categoryCode": clNTBReferenceDetailsVm.bannerList[0].categoryCode
            }
            clNTBCalculatorService.getBannerExplore(payload).then(function (response) {
                clNTBReferenceDetailsVm.childBanner = response;
                clNTBReferenceDetailsVm.dataForIndividualMerchant = clNTBReferenceDetailsVm.childBanner[0].merchant.mobileData;
                $scope.merchantData = response[0].merchant.mobileData[0].row       // clNTBReferenceDetailsVm.dataForIndividualMerchant;
                clNTBCalculatorService.getBannerExploreDetails("", "To avail these offers, kindly register or login to YONO with valid credentials.", clNTBReferenceDetailsVm.childBanner,
                    "menu.clNTBReferenceDetails", "", "", $scope, "");
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
        return this;
    }
]);
