'use strict';

angularApp.controller('clNTBSubmitDetailsController', [
    "$state",
    "$scope",
    "$translate",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService",
    "$filter",
    "clNTBCalculatorService",
    "homeLoanService",
    "$ionicScrollDelegate",
    "goldLoanRLMSService",
    "constantConfig",
    "cryptoService",
    function ($state,
        $scope,
        $translate,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        $filter,
        clNTBCalculatorService,
        homeLoanService,
        $ionicScrollDelegate,
        goldLoanRLMSService,
        constantConfig,
        cryptoService) {

        var clNTBSubmitDetailsVm = this;
        var isvalid = true;
        var regForName = /^[a-zA-Z]*$/;
        var phnReg = /^[123456789]\d{9}$/;
        var pinRegex = /^[0-9]{6}$/;
        var mailformat = /^([\w\.\-]+)@([\w\-]+)((\.(\w){2,63}){1,2})$/;
        clNTBSubmitDetailsVm.mobileMaskUnmask = false;
        clNTBSubmitDetailsVm.emailMaskUnmask = false;
        var tncVerified = false;

        clNTBSubmitDetailsVm.initPage = function () {
            clNTBSubmitDetailsVm.maskMobileData = true;
            clNTBSubmitDetailsVm.maskEmailData = true;
            clNTBSubmitDetailsVm.email = true;
            clNTBSubmitDetailsVm.mobile = true;
            clNTBSubmitDetailsVm.cityList = [];
            clNTBSubmitDetailsVm.branchList = [];
            clNTBSubmitDetailsVm.branchList = [];
			clNTBSubmitDetailsVm.genderList = [];
            clNTBSubmitDetailsVm.errObj = {};
            clNTBSubmitDetailsVm.loanPurposeList = [];
            clNTBSubmitDetailsVm.tNc = '';
            clNTBSubmitDetailsVm.Mask = '';
            clNTBSubmitDetailsVm.maskedMobile = '';
            clNTBSubmitDetailsVm.unMaskedMobile = '';
            clNTBSubmitDetailsVm.eligibilityData = {};
            clNTBSubmitDetailsVm.authorizeCheck = false;
            clNTBSubmitDetailsVm.authorizeTnCCheck = false;
            clNTBSubmitDetailsVm.eligibilityRequestData = clNTBCalculatorService.getCheckEligiblityRequest();
            clNTBSubmitDetailsVm.eligibilityResponseData = clNTBCalculatorService.getCheckEligiblityResponse();
            clNTBSubmitDetailsVm.eligibilityAmountDetail = clNTBCalculatorService.getEligibalAmountDetail();
            $scope.callService = 0;
            clNTBSubmitDetailsVm.masterData = {};
             if (clNTBCalculatorService.getIsCallBackRequset() == 'true'){
                clNTBSubmitDetailsVm.masterDetails();
                clNTBSubmitDetailsVm.isCallBack = true;
            }else{
                clNTBSubmitDetailsVm.isCallBack = false;
            }

            if (clNTBCalculatorService.isSubmitDetailsBack) {
                clNTBSubmitDetailsVm.populateSubmitDetails();
            }
            setTimeout(function () {
                clNTBSubmitDetailsVm.updateheader()
            }, 1000);
        }

        clNTBSubmitDetailsVm.toggleEye = function (type) {
            clNTBSubmitDetailsVm.isTextReadable == true ? clNTBSubmitDetailsVm.isTextReadable = false : clNTBSubmitDetailsVm.isTextReadable = true;
            if (type === "mobile") {
                clNTBSubmitDetailsVm.mobileMaskUnmask = clNTBSubmitDetailsVm.isTextReadable;
            }
            if (type === "email"){
                clNTBSubmitDetailsVm.emailMaskUnmask = clNTBSubmitDetailsVm.isTextReadable;
            }
        }

        // check first name 
        clNTBSubmitDetailsVm.checkFirstNameValue = function () {
            if (clNTBCalculatorService.isValidField(clNTBSubmitDetailsVm.fname, "First Name")) {
                clNTBSubmitDetailsVm.errObj.fNameError = clNTBCalculatorService.isValidField(clNTBSubmitDetailsVm.fname, "First Name");
                isvalid = false;
            } else {
                if (!regForName.test(clNTBSubmitDetailsVm.fname)) {
                    clNTBSubmitDetailsVm.errObj.fNameError = 'Please enter valid name';
                    isvalid = false;
                } else {
                    clNTBSubmitDetailsVm.errObj.fNameError = '';
                }
            }
        }

        // check last name 
        clNTBSubmitDetailsVm.checkLastNameValue = function () {
            if (clNTBCalculatorService.isValidField(clNTBSubmitDetailsVm.lname, "Last Name")) {
                clNTBSubmitDetailsVm.errObj.lNameError = clNTBCalculatorService.isValidField(clNTBSubmitDetailsVm.lname, "Last Name");
                isvalid = false;
            } else {
                if (!regForName.test(clNTBSubmitDetailsVm.lname)) {
                    clNTBSubmitDetailsVm.errObj.lNameError = 'Please enter valid name';
                    isvalid = false;
                } else {
                    clNTBSubmitDetailsVm.errObj.lNameError = '';
                }
            }
        }

        // checvk for PIN
        clNTBSubmitDetailsVm.checkPINValue =  function(){
            if (clNTBCalculatorService.isValidField(clNTBSubmitDetailsVm.pincode, "PIN Number")) {
                clNTBSubmitDetailsVm.errObj.pincodeError = clNTBCalculatorService.isValidField(clNTBSubmitDetailsVm.pincode, "PIN Number");
                isvalid = false;
            } else {
                if (!pinRegex.test(clNTBSubmitDetailsVm.pincode)) {
                    clNTBSubmitDetailsVm.errObj.pincodeError = 'Pin code should be of six digits (0-9) and should not start with zero.';
                    isvalid = false;
                } else {
                    clNTBSubmitDetailsVm.errObj.pincodeError = '';
                }
            }
        }

        // check mobile value 
        clNTBSubmitDetailsVm.checkMobileValue = function () {
            if (clNTBCalculatorService.isValidField(clNTBSubmitDetailsVm.mobileNumber, "Contact Number")) {
                clNTBSubmitDetailsVm.errObj.phNumberError = clNTBCalculatorService.isValidField(clNTBSubmitDetailsVm.mobileNumber, "Contact Number");
                isvalid = false;
            } else {
                if (!phnReg.test(clNTBSubmitDetailsVm.mobileNumber)) {
                    clNTBSubmitDetailsVm.errObj.phNumberError = 'Contact number should be of ten digits (0-9) and should not start with zero.';
                    isvalid = false;
                } else {
                    clNTBSubmitDetailsVm.errObj.phNumberError = '';
                }
            }
        }

        // check email value 
        clNTBSubmitDetailsVm.checkEmailValue = function () {
            if (clNTBCalculatorService.isValidField(clNTBSubmitDetailsVm.emailId, "Email ID")) {
                clNTBSubmitDetailsVm.errObj.emailError = clNTBCalculatorService.isValidField(clNTBSubmitDetailsVm.emailId, "Email ID");
                isvalid = false;
            } else {
                if (!mailformat.test(clNTBSubmitDetailsVm.emailId)) {
                    clNTBSubmitDetailsVm.errObj.emailError = "Please enter correct email id containing @ symbol followed by valid domain name.";
                    isvalid = false;
                } else {
                    clNTBSubmitDetailsVm.errObj.emailError = '';
                }
            }
        }

        //get update header
        clNTBSubmitDetailsVm.updateheader = function () {
            if (clNTBCalculatorService.getIsCallBackRequset() == 'false') {
                clNTBSubmitDetailsVm.isNormalFlow = 'N';
            } else {
                clNTBSubmitDetailsVm.isNormalFlow = 'R';
            }
            if (!$scope.$$phase)
                $scope.$apply();
        }


        // fetch city 
        clNTBSubmitDetailsVm.getCityList = function () {
            if (clNTBCalculatorService.isValidField(clNTBSubmitDetailsVm.pincode, "pincode")) {
                clNTBSubmitDetailsVm.errObj.pincodeError = clNTBCalculatorService.isValidField(clNTBSubmitDetailsVm.pincode, "pincode");
                clNTBSubmitDetailsVm.city = "";
                clNTBSubmitDetailsVm.branch = "";
                clNTBSubmitDetailsVm.cityList = [];
                clNTBSubmitDetailsVm.branchList = [];
            } else {
                if (clNTBSubmitDetailsVm.pincode.length != 6) {
                    clNTBSubmitDetailsVm.errObj.pincodeError = 'Please provide valid pincode'
                    clNTBSubmitDetailsVm.city = "";
                    clNTBSubmitDetailsVm.branch = "";
                    clNTBSubmitDetailsVm.cityList = [];
                    clNTBSubmitDetailsVm.branchList = [];
                } else {
                    clNTBSubmitDetailsVm.errObj.pincodeError = '';
                    var payload = {
                        "pinCode": clNTBSubmitDetailsVm.pincode
                    }
                    clNTBCalculatorService.getCityByPinCode(payload).then(function (response) {
                        clNTBSubmitDetailsVm.cityList = response;
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }
            }
        }

        // fetch branch list 
        clNTBSubmitDetailsVm.getBranchList = function () {
            if (clNTBCalculatorService.isValidField(clNTBSubmitDetailsVm.city, "pincode")) {
                clNTBSubmitDetailsVm.errObj.pincodeError = clNTBCalculatorService.isValidField(clNTBSubmitDetailsVm.pincode, "pincode");
            } else {
                var payload = {
                    "cityCode": clNTBSubmitDetailsVm.city
                }
                clNTBCalculatorService.getBranchListByCity(payload).then(function (response) {
                    clNTBSubmitDetailsVm.branchList = response.branchList;
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        }

        // fetch submit details 
        clNTBSubmitDetailsVm.populateSubmitDetails = function () {
            var retentionData = {};
            retentionData = clNTBCalculatorService.submitLeadData;
            clNTBSubmitDetailsVm.fname = retentionData.fname;
            clNTBSubmitDetailsVm.lname = retentionData.lname;
            clNTBSubmitDetailsVm.mobileNumber = retentionData.mobileNumber;
            clNTBSubmitDetailsVm.emailId = retentionData.emailId;
            clNTBSubmitDetailsVm.pincode = retentionData.pincode;
            clNTBSubmitDetailsVm.getCityList();
            setTimeout(function () {
                clNTBSubmitDetailsVm.city = retentionData.city
                clNTBSubmitDetailsVm.getBranchList(clNTBSubmitDetailsVm.city);
                if (!$scope.$$phase)
                    $scope.$apply();
                setTimeout(function () {
                    clNTBSubmitDetailsVm.branch = retentionData.branch;
                    clNTBSubmitDetailsVm.gender = retentionData.gender;
                    clNTBSubmitDetailsVm.authorizeCheck = retentionData.authorizeCheck;
                    clNTBSubmitDetailsVm.authorizeTnCCheck = true;
                    if (!$scope.$$phase)
                        $scope.$apply();
                }, 2000);
            }, 1000);
        }

        // get master data 
        clNTBSubmitDetailsVm.masterDetails = function () {
            clNTBCalculatorService.getMasterData().then(function (response) {
                clNTBSubmitDetailsVm.genderList = response.staticMasterData.gender ;
                clNTBCalculatorService.setStaticMasterData(response.staticMasterData);
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        //validate form
        clNTBSubmitDetailsVm.validateDetailsForm = function () {
            clNTBSubmitDetailsVm.errObj = {};
            isvalid = true;

            if (clNTBCalculatorService.isValidField(clNTBSubmitDetailsVm.fname, "First Name")) {
                clNTBSubmitDetailsVm.errObj.fNameError = clNTBCalculatorService.isValidField(clNTBSubmitDetailsVm.fname, "First Name");
                isvalid = false;
            } else {
                if (!regForName.test(clNTBSubmitDetailsVm.fname)) {
                    clNTBSubmitDetailsVm.errObj.fNameError = 'Please enter valid name';
                    isvalid = false;
                } else {
                    clNTBSubmitDetailsVm.errObj.fNameError = '';
                }
            }

            if (clNTBCalculatorService.isValidField(clNTBSubmitDetailsVm.lname, "Last Name")) {
                clNTBSubmitDetailsVm.errObj.lNameError = clNTBCalculatorService.isValidField(clNTBSubmitDetailsVm.lname, "Last Name");
                isvalid = false;
            } else {
                if (!regForName.test(clNTBSubmitDetailsVm.lname)) {
                    clNTBSubmitDetailsVm.errObj.lNameError = 'Please enter valid name';
                    isvalid = false;
                } else {
                    clNTBSubmitDetailsVm.errObj.lNameError = '';
                }
            }
			if(clNTBSubmitDetailsVm.isCallBack){
				if (clNTBCalculatorService.isValidField(clNTBSubmitDetailsVm.gender, "Gender")) {
                clNTBSubmitDetailsVm.errObj.genderError = clNTBCalculatorService.isValidField(clNTBSubmitDetailsVm.gender, "Gender");
                isvalid = false;
                } else {
                    if (!regForName.test(clNTBSubmitDetailsVm.gender)) {
                        clNTBSubmitDetailsVm.errObj.genderError = 'Please enter Gender';
                        isvalid = false;
                    } else {
                        clNTBSubmitDetailsVm.errObj.genderError = '';
                    }
                }
			}			

            if (clNTBCalculatorService.isValidField(clNTBSubmitDetailsVm.mobileNumber, "Contact Number")) {
                clNTBSubmitDetailsVm.errObj.phNumberError = clNTBCalculatorService.isValidField(clNTBSubmitDetailsVm.mobileNumber, "Contact Number");
                isvalid = false;
            } else {
                if (!phnReg.test(clNTBSubmitDetailsVm.mobileNumber)) {
                    clNTBSubmitDetailsVm.errObj.phNumberError = 'Contact number should be of ten digits (0-9) and should not start with zero.';
                    isvalid = false;
                } else {
                    clNTBSubmitDetailsVm.errObj.phNumberError = '';
                }
            }

            if (clNTBCalculatorService.isValidField(clNTBSubmitDetailsVm.emailId, "Email ID")) {
                clNTBSubmitDetailsVm.errObj.emailError = clNTBCalculatorService.isValidField(clNTBSubmitDetailsVm.emailId, "Email ID");
                isvalid = false;
            } else {
                if (!mailformat.test(clNTBSubmitDetailsVm.emailId)) {
                    clNTBSubmitDetailsVm.errObj.emailError = "Please enter correct email id containing @ symbol followed by valid domain name.";
                    isvalid = false;
                } else {
                    clNTBSubmitDetailsVm.errObj.emailError = '';
                }
            }

            if (clNTBCalculatorService.isValidField(clNTBSubmitDetailsVm.pincode, "PIN Code of Current Residential Address")) {
                clNTBSubmitDetailsVm.errObj.pincodeError = clNTBCalculatorService.isValidField(clNTBSubmitDetailsVm.pincode, "PIN Code of Current Residential Address");
                isvalid = false;
            } else {
                if (!pinRegex.test(clNTBSubmitDetailsVm.pincode)) {
                    clNTBSubmitDetailsVm.errObj.pincodeError = 'Pin code should be of six digits (0-9) and should not start with zero';
                    isvalid = false;
                } else {
                    clNTBSubmitDetailsVm.errObj.pincodeError = '';
                }
            }

            if (clNTBCalculatorService.isValidField(clNTBSubmitDetailsVm.city, "City")) {
                clNTBSubmitDetailsVm.errObj.cityError = clNTBCalculatorService.isValidField(clNTBSubmitDetailsVm.city, "City");
                isvalid = false;
            } else {
                clNTBSubmitDetailsVm.errObj.cityError = '';
            }

            if (clNTBCalculatorService.isValidField(clNTBSubmitDetailsVm.branch, "Your Preferred Branch")) {
                clNTBSubmitDetailsVm.errObj.branchError = clNTBCalculatorService.isValidField(clNTBSubmitDetailsVm.branch, "Your Preferred Branch");
                isvalid = false;
            } else {
                clNTBSubmitDetailsVm.errObj.branchError = '';
            }

            return isvalid;
        }

        // masking unmasking 
        clNTBSubmitDetailsVm.unmaskData = function (type, flag) {
            if (type === 'mobile') {
                if (flag === true) {
                    clNTBSubmitDetailsVm.maskMobileData = true;
                    document.getElementById('mob').classList.remove('unhide-input-txt-hl-ntb');
                } else {
                    clNTBSubmitDetailsVm.maskMobileData = false;
                    document.getElementById('mob').classList.add('unhide-input-txt-hl-ntb');
                }
            }

            if (type === 'email') {
                if (flag === true) {
                    document.getElementById('email').classList.remove('unhide-input-txt-hl-ntb');
                    clNTBSubmitDetailsVm.maskEmailData = true;
                } else {
                    document.getElementById('email').classList.add('unhide-input-txt-hl-ntb');
                    clNTBSubmitDetailsVm.maskEmailData = false;
                }
            }
            clNTBSubmitDetailsVm.updatedigest();
        }
        clNTBSubmitDetailsVm.setMaskedNumber = function (val) {
            $scope.maskedNumber = val.replace(/[0-9]{6}/, 'XXXXXX');
        }

        // submit details
        clNTBSubmitDetailsVm.submitDetails = function () {
            utilityService.showSpinner();
            if (clNTBSubmitDetailsVm.validateDetailsForm()) {
                if (clNTBSubmitDetailsVm.authorizeCheck && clNTBSubmitDetailsVm.authorizeTnCCheck) {
                    clNTBSubmitDetailsVm.getSubmitPayload();
                } else {
                    clNTBSubmitDetailsVm.errorCheck = true;
                    $ionicScrollDelegate.scrollBottom();
                    utilityService.hideSpinner();
                }
            } else {
                utilityService.hideSpinner();
                return;
            }
        }

        clNTBSubmitDetailsVm.verifyTnC = function(tncChecked){
            if(tncChecked && !tncVerified){
                clNTBSubmitDetailsVm.showTnC();
            }
        }

        clNTBSubmitDetailsVm.showTnC = function () {            
            clNTBCalculatorService.getNTBCarLoanTnC().then(function (data) {
                clNTBSubmitDetailsVm.ntbCLTnCContent = data;
                clNTBSubmitDetailsVm.tncPopup(clNTBSubmitDetailsVm.ntbCLTnCContent);
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        clNTBSubmitDetailsVm.tncPopup = function (data) {
            var test = '<ion-content class="padding bottomZero rtxc_tnc_popup_list">'+ data +
                '<div class="rtxcTnC"><button class="rxtcTnC_button" ng-click="closePopup()">Proceed</button></div></ion-content>';
                $scope.bhimErrorPopup = $ionicPopup.show({
                template: test,
                title: 'Terms & Conditions',
                scope: $scope,
                cssClass: 'bhim-alert-popup hlTermnCondition ',
            });
        }

        $scope.closePopup =  function(){
            tncVerified = true;
            $scope.bhimErrorPopup.close();                    
        }

        // on condn
        $scope.$on('$ionicView.beforeEnter', function () {
            clNTBSubmitDetailsVm.initPage();
        });

        // get submit payload
        clNTBSubmitDetailsVm.getSubmitPayload = function () {
            var payld = {
                "sourceId": "",
                "email": clNTBSubmitDetailsVm.emailId,
                "firstname": clNTBSubmitDetailsVm.fname,
                "lastname": clNTBSubmitDetailsVm.lname,
                "mobile": clNTBSubmitDetailsVm.mobileNumber,
                "branchcode": clNTBSubmitDetailsVm.branch,
                "city":  clNTBSubmitDetailsVm.cityList[0].cityName,
                "pincode": clNTBSubmitDetailsVm.pincode,
            };

            if (clNTBCalculatorService.getIsCallBackRequset() == "true") {
                payld.gender = clNTBSubmitDetailsVm.gender;
                payld.isCallbackRequest = 'Y';
            } else {
                payld.isCallbackRequest = 'N';
                payld.gender = clNTBSubmitDetailsVm.eligibilityRequestData.applicantDetails.gender;
                payld.loanamount = clNTBSubmitDetailsVm.eligibilityAmountDetail.loanamount;
                payld.dob = clNTBSubmitDetailsVm.eligibilityRequestData.applicantDetails.dateOfBirth;
                payld.incomeSource = clNTBSubmitDetailsVm.eligibilityRequestData.applicantDetails.incomeSource;
                payld.netMonthlyIncome = clNTBSubmitDetailsVm.eligibilityRequestData.applicantDetails.netMonthlyIncome;
                payld.existingEMI = clNTBSubmitDetailsVm.eligibilityRequestData.applicantDetails.emiOnExistingLoan;
                payld.monthlyEMI = clNTBSubmitDetailsVm.eligibilityAmountDetail.monthlyEMI;
                payld.interestRate = clNTBSubmitDetailsVm.eligibilityAmountDetail.interestRate;
                payld.loanTenure = clNTBSubmitDetailsVm.eligibilityAmountDetail.loanTenure;
            }         

            clNTBCalculatorService.setGenerateLeadData(payld);
            $scope.callService = $scope.callService + 1;
            if ($scope.callService == 1) {
                clNTBSubmitDetailsVm.generateOTP(clNTBSubmitDetailsVm.mobileNumber);
            } else {
                utilityService.hideSpinner();
                return;
            }
        }

        // generate otp
        clNTBSubmitDetailsVm.generateOTP = function (mobileNumber) {
            var reqParams = {};
            reqParams["id"] = mobileNumber;
            reqParams.otpCode = constantConfig.keysForOTP.Register;
            reqParams.ocHash = cryptoService.getSHA512EncryptedData(constantConfig.keysForOTP.Register).toString();
            clNTBCalculatorService.generateOTP(reqParams).then(function (data) {
                clNTBCalculatorService.submitLeadData = clNTBSubmitDetailsVm;
                clNTBCalculatorService.setContactNumber(clNTBSubmitDetailsVm.mobileNumber);
                $scope.callService = 0;
                utilityService.hideSpinner();
                $state.go('menu.clNTBOTPVerification');
                clNTBSubmitDetailsVm.updatedigest();
            }, function (error) {
                $scope.callService = 0;
                utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        // go back function
        clNTBSubmitDetailsVm.goBack = function () {
            if (clNTBCalculatorService.getIsCallBackRequset() == 'true') {
                $state.go('menu.clNTBExploreCarLoan');
            } else {
                clNTBCalculatorService.isAmountBack = true;
                $state.go('menu.clNTBEligibileAmountDetails');
            }
        }

        // life cycle digest
        clNTBSubmitDetailsVm.updatedigest = function () {
            if (!$scope.$$phase)
                $scope.$apply();
            return;
        }
        return this;
    }
]);