'use strict';
angularApp.controller('cLReferenceNumberController', [
    "$state",
    "$scope",
    "$ionicPopup",
    "$translate",
    "$ionicHistory",
    "utilityService",
    "ionicDatePicker",
    "$ionicSideMenuDelegate",
    "customerInfoService", "carLoanService","irctcService","openUrlInAppbroswerService","getAccountDetailsService",
    function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, customerInfoService, carLoanService,irctcService,openUrlInAppbroswerService,getAccountDetailsService) {

        var cLReferenceNumberVm = this;

        function initPage() {
            cLReferenceNumberVm.applicationRef = carLoanService.finalData.yonoRef;
            cLReferenceNumberVm.loanTenure = carLoanService.finalData.loanTenure;
            cLReferenceNumberVm.date = carLoanService.finalData.letterGenDate;
            cLReferenceNumberVm.loanAmount = carLoanService.finalData.loanAmount;
            cLReferenceNumberVm.emi = carLoanService.finalData.effectiveEmi;
            cLReferenceNumberVm.rate = carLoanService.finalData.effectiveRate;
            utilityService.setCsatJournies('carLoan');
        };

        cLReferenceNumberVm.emailLetter = function() {

        }

        cLReferenceNumberVm.downloadLetter = function(isEmail) {
            var payload = {};
            if (!isEmail) {
                payload = {
                    "isEmail": false,
                    "type": "inprinciple"
                };
            } else {
                payload = {
                    "isEmail": true,
                    "type": "inprinciple"
                };
            }


            carLoanService.getDocument(payload).then(function(data) {
                console.log(data);

                if (!isEmail) {
                    var filename = data.fileName + '.pdf';
                    var content = data.pdf;
                    var contentType = "application/pdf";
                    if (utilityService.isAndroidPlatform()) {
                        cLReferenceNumberVm.android = true;

                        cLReferenceNumberVm.folderpath = cordova.file.externalRootDirectory;
                    }
                    if (utilityService.isIOSPlatform()) {
                        cLReferenceNumberVm.folderpath = cordova.file.applicationDirectory;
                    }
                    irctcService.savebase64AsPDF(cLReferenceNumberVm.folderpath, filename, content, contentType);
                    if (utilityService.isIOSPlatform()) {
                        var finalObject = { "folderpath": cLReferenceNumberVm.folderpath, "filename": filename };
                        openUrlInAppbroswerService.openUrl("data:application/pdf;base64," + content + "", "");
                    }
                    if (cLReferenceNumberVm.android) {
                        var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" >File Downloaded to Internal Storage</div>';
                        cLReferenceNumberVm.downloadPopup = $ionicPopup.show({
                            title: '',
                            template: template,
                            scope: $scope,
                            cssClass: 'my-custom-popup',
                            buttons: [{
                                text: 'OK',
                                type: 'button-assertive',
                                onTap: function() {
                                    cLReferenceNumberVm.downloadPopup.close();

                                }
                            }],
                        });

                    }
                    cLReferenceNumberVm.successPopup.close();
                } else {
                    var alertPopup = $ionicPopup.alert({
                        template: "<p style='text-align:center;font-weight:bold;font-size:16px'>Email has been sent successfully</p>"
                    });
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

        }

        

        cLReferenceNumberVm.goToAccOverview = function() {
            $state.go('menu.homeScreen');
            //getAccountDetailsService.isCarLoan = true;
        }

        $scope.$on('$ionicView.loaded', function() {

        });

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        return this;
    }


]);