'use strict';
angularApp.controller('carAppStatusController', [
    "$state",
    "$scope",
    "$ionicPopup",
    "$translate",
    "$ionicHistory",
    "utilityService",
    "ionicDatePicker",
    "$ionicSideMenuDelegate",
    "$ionicScrollDelegate",
    "loanConfig",
    "homeLoanService", "carLoanService","$interval",
    function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, $ionicScrollDelegate, loanConfig, homeLoanService, carLoanService,$interval) {

        var carAppStatusVm = this;

        function initPage() {
            carAppStatusVm.showProgress = true;
            carAppStatusVm.showTimer();
        }

        carAppStatusVm.triggerBureau = function(group) {
            var request = carLoanService.saveObjCarDetails;
            carLoanService.finalEligibility(request).then(function(data) {
                if (data.cirResult == 'Y') {
                    homeLoanService.source = "car";
                    carLoanService.carData = carAppStatusVm.detail;
                    carLoanService.saveObj = request;
                    $state.go('menu.carLoanSelectBranch');
                    carLoanService.finalData = data;
                } else if (data.cirResult == "E") {
                    carAppStatusVm.showEStatus();
                   // utilityService.showErrorMessage("Application check failed due to technical error.");
                    //show popup

                } else if (data.cirResult == "P") {
                    utilityService.showErrorMessage("Application check still in progress.");
                } else if (data.cirResult == "N") {
                    carAppStatusVm.waitBureau = true;
                    carAppStatusVm.showProgress = false;
                }

            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

        }

        carAppStatusVm.showEStatus = function(){
            var backPopup = $ionicPopup.show({
                title: null,
                cssClass: 'my-custom-popup',
                template: '<div class="button_fund font-size-14 roboto-medium color-darkgrey" translate="HL_E_STATUS"></div>',
                buttons: [
                {
                    text: 'OK',
                    type: 'button-assertive',
                    onTap: function () {
                        //service call for reject
                        backPopup.close();
                        $ionicHistory.goBack(-1);
                    }
                }],
            });
        }


        carAppStatusVm.goBack = function() {
            $ionicHistory.goBack(-1);
        }

        carAppStatusVm.goToAO = function(){
           $state.go('menu.homeScreen');
        }


        carAppStatusVm.showTimer = function(){
            var timeLeft = 30;
            //utilityService.showSpinner();
            carAppStatusVm.showTimeRemaining = true;
            //var timerId = setInterval(countdown, 1000);
            $interval(function(){
                if (timeLeft == 0) {
                //clearTimeout(timerId);
                //doSomething();
                //carAppStatusVm.showProgress = false;
                carAppStatusVm.showTimeRemaining = false;
                //utilityService.hideSpinner();
              } else {
                carAppStatusVm.timeRemaining = timeLeft + ' seconds remaining';
                timeLeft--;
              }
            },1000)
            
        }

        $scope.$on('$ionicView.loaded', function() {

        });

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });



        return this;
    }


]);