'use strict';
angularApp.controller('carDetailsController', [
    "$state",
    "$scope",
    "$ionicPopup",
    "$translate",
    "$ionicHistory",
    "utilityService",
    "ionicDatePicker",
    "$ionicSideMenuDelegate",
    "$ionicScrollDelegate",
    "loanConfig",
    "homeLoanService", "carLoanService","$interval",
    function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, $ionicScrollDelegate, loanConfig, homeLoanService, carLoanService,$interval) {

        var carDetailsVm = this;

        function initPage() {

            carDetailsVm.showMake = false;
            carDetailsVm.showCity = false;
            carDetailsVm.showState = false;
            carDetailsVm.showDealer = false;


                

            carDetailsVm.detail = {};
            carDetailsVm.detail.onRoadPrice = 0;

            if (carLoanService.carData) {
                carDetailsVm.masterData = carLoanService.userMaster;
                carDetailsVm.detail = carLoanService.carData;
                carDetailsVm.model = carDetailsVm.masterData.master.models;
                carDetailsVm.variant = carDetailsVm.masterData.master.variants;
            } else if (carLoanService.resumeData) {

                carDetailsVm.masterData = carLoanService.resumeData;
                if (carDetailsVm.masterData.stateOfPurchase) {
                     var stateObj=JSON.parse(carDetailsVm.masterData.stateOfPurchaseValue);
                   
                    carDetailsVm.detail.state = stateObj;

                    var cityObj=JSON.parse(carDetailsVm.masterData.cityOfPurchaseValue);
                    carDetailsVm.city=[];
                    carDetailsVm.city.push(cityObj);
                    carDetailsVm.detail.city = cityObj;

                    var makeObj = JSON.parse(carDetailsVm.masterData.makeValue);
                 
                   
                    carDetailsVm.detail.make =makeObj;

                    var modelObj = JSON.parse(carDetailsVm.masterData.modelValue);
                    carDetailsVm.model=[];
                    carDetailsVm.model.push(modelObj);
                    carDetailsVm.detail.model = modelObj;

                    var variantObj = JSON.parse(carDetailsVm.masterData.variantValue);
                    carDetailsVm.variant=[];
                    carDetailsVm.variant.push(variantObj);
                    carDetailsVm.detail.variant = variantObj;
                    
                    if(carDetailsVm.masterData.dealerName)
                    {
                     var dealerObj =JSON.parse(carDetailsVm.masterData.dealerNameValue);
                     carDetailsVm.dealer=[];
                     carDetailsVm.dealer.push(dealerObj);
                     carDetailsVm.detail.dealer=dealerObj;
                     carDetailsVm.detail.dealerName = dealerObj;
                 }
                 else
                 {
                    carDetailsVm.dealer=[];
                     carDetailsVm.detail.dealer="";
                 }

                

                    carDetailsVm.detail.showroomprice = carDetailsVm.masterData.exshowRoomPrice;
                    carDetailsVm.detail.performa = carDetailsVm.masterData.proforma;
                    carDetailsVm.detail.extendedWarranty = carDetailsVm.masterData.warantty;
                    carDetailsVm.detail.registrationPrice = carDetailsVm.masterData.rto;;
                    carDetailsVm.detail.accessories = carDetailsVm.masterData.accessories;;
                    carDetailsVm.detail.others = carDetailsVm.masterData.others;;
                    //carDetailsVm.detail.dealerName = carDetailsVm.masterData.dealerNameValue;
                    //carDetailsVm.detail.dealerNameKey = carDetailsVm.masterData.dealerName;
                    carDetailsVm.detail.onRoadPrice = carDetailsVm.masterData.onRoadPrice;;
                    carDetailsVm.detail.insurance = carDetailsVm.masterData.insurance;;



                } else {
                    carDetailsVm.detail.performa = 'N';
                    carDetailsVm.masterData = carLoanService.userMaster;

                    carDetailsVm.dealer = carDetailsVm.masterData.master.dealers;
                }


            } else {
                carDetailsVm.detail.performa = 'N';
                carDetailsVm.masterData = carLoanService.userMaster;
              
            }

            carDetailsVm.stateData = carDetailsVm.masterData.master.states;
            //carDetailsVm.dealer = carDetailsVm.masterData.master.dealers;
            carDetailsVm.make   = carDetailsVm.masterData.master.manufacturers





        };

        carDetailsVm.applyknowmore = function(group) {

        }

        carDetailsVm.calculateOnRoadPrice = function() {
            if (carDetailsVm.detail.performa == 'Y') {
                carDetailsVm.detail.onRoadPrice = 0;
                if (!carDetailsVm.detail.registrationPrice) {
                    carDetailsVm.detail.registrationPrice = 0;
                }
                if (!carDetailsVm.detail.insurance) {
                    carDetailsVm.detail.insurance = 0;
                }
                if (!carDetailsVm.detail.extendedWarranty) {
                    carDetailsVm.detail.extendedWarranty = 0;
                }
                if (!carDetailsVm.detail.accessories) {
                    carDetailsVm.detail.accessories = 0;
                }
                if (!carDetailsVm.detail.others) {
                    carDetailsVm.detail.others = 0;
                }
                if (!carDetailsVm.detail.showroomprice) {
                    carDetailsVm.detail.showroomprice = 0;
                }

                carDetailsVm.detail.onRoadPrice = (parseInt(carDetailsVm.detail.showroomprice) + parseInt(carDetailsVm.detail.registrationPrice) + parseInt(carDetailsVm.detail.insurance) + parseInt(carDetailsVm.detail.accessories) + parseInt(carDetailsVm.detail.extendedWarranty) + parseInt(carDetailsVm.detail.others)).toString();



            } else {
                carDetailsVm.detail.onRoadPrice = carDetailsVm.detail.showroomprice;
            }


        }

        carDetailsVm.showList = function(key) {
            if (key == 'state') {

                if (carDetailsVm.detail.state.length == 0) {
                    carDetailsVm.detail.stateKey = "";
                    carDetailsVm.showState = false;



                } else if (carDetailsVm.detail.state.length >= 3) {
                    carDetailsVm.showState = true;
                } else {
                    carDetailsVm.showState = false;
                }

            } else if (key == 'city') {
                if (carDetailsVm.detail.city.length == 0) {
                    carDetailsVm.detail.cityKey = "";
                    carDetailsVm.showCity = false;
                } else if (carDetailsVm.detail.city.length >= 3) {
                    carDetailsVm.showCity = true;
                } else {
                    carDetailsVm.showCity = false;
                }

            } else if (key == 'make') {
                if (carDetailsVm.detail.make.length == 0) {
                    carDetailsVm.detail.makeKey = "";
                    carDetailsVm.showMake = false;
                } else if (carDetailsVm.detail.make.length >= 3) {
                    carDetailsVm.showMake = true;

                } else {
                    carDetailsVm.showMake = false;
                }

            } else if (key == 'dealer') {

                if (carDetailsVm.detail.dealerName.length == 0) {
                    carDetailsVm.detail.dealerNameKey = "";
                    carDetailsVm.showDealer = false;
                } else if (carDetailsVm.detail.dealerName.length >= 3) {
                    carDetailsVm.showDealer = true;

                } else {
                    carDetailsVm.showDealer = false;
                }
                 $ionicScrollDelegate.resize();

            }





        }

        carDetailsVm.updateState = function() {

            carDetailsVm.detail.stateValue =JSON.stringify(carDetailsVm.detail.state);
            carDetailsVm.detail.city = "";
            carDetailsVm.detail.cityValue = "";
            carDetailsVm.detail.dealerNameValue = "";
            carDetailsVm.detail.dealer="";
            carDetailsVm.detail.dealerName = "";
            carDetailsVm.dealer="";

            var request = {
                "masterId": "CL_CityOfPurchase",
                "key": carDetailsVm.detail.state.key
            };

            carLoanService.getSubData(request).then(function(data) {

                carDetailsVm.city = data.clCities;

            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        carDetailsVm.updateCity = function() {

            carDetailsVm.detail.cityValue = JSON.stringify(carDetailsVm.detail.city);
            carDetailsVm.detail.dealerNameValue = "";
            carDetailsVm.detail.dealer="";
            carDetailsVm.detail.dealerName = "";
            carDetailsVm.dealer="";

            if( carDetailsVm.detail.city && carDetailsVm.detail.make )
            {
                   var request = {
                    "cityCode": carDetailsVm.detail.city.key,
                    "makeCode": carDetailsVm.detail.make.key                
            }

            carLoanService.getDealerList(request).then(function(data) {

                carDetailsVm.model = data.modelList;
                carDetailsVm.dealer = data.dealerList;
                


            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

            }

           
        }

        carDetailsVm.updateDealer = function(item,itemKey) {
         carDetailsVm.detail.dealerNameValue = JSON.stringify(carDetailsVm.detail.dealerName);
        }


        carDetailsVm.updateMake = function(item) {
            carDetailsVm.detail.makeValue = JSON.stringify(carDetailsVm.detail.make)
            carDetailsVm.detail.variant = "";
            carDetailsVm.detail.variantValue = "";
            carDetailsVm.detail.model = "";
            carDetailsVm.detail.modelValue = "";

            carDetailsVm.detail.dealerNameValue = "";
            carDetailsVm.detail.dealer="";
            carDetailsVm.detail.dealerName = "";
            carDetailsVm.dealer="";

             if( carDetailsVm.detail.city && carDetailsVm.detail.make )
            {
                   var request = {
                    "cityCode": carDetailsVm.detail.city.key,
                    "makeCode": carDetailsVm.detail.make.key                
            }

            carLoanService.getDealerList(request).then(function(data) {

                carDetailsVm.model = data.modelList;
                carDetailsVm.dealer = data.dealerList;
                


            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

            }

         

        }


        carDetailsVm.updateModel = function(item) {

            carDetailsVm.detail.modelValue = JSON.stringify(carDetailsVm.detail.model);
            carDetailsVm.detail.variant = "";
            carDetailsVm.detail.variantValue = "";
            var request = {
                "masterId": "CL_Variant",
                "key": carDetailsVm.detail.model.key
            };

            carLoanService.getSubData(request).then(function(data) {
                carDetailsVm.variant = data.clVariants;

            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        carDetailsVm.updateVariant = function(item) {
            carDetailsVm.detail.variantValue = JSON.stringify(carDetailsVm.detail.variant);

        }

        carDetailsVm.changePerforma = function() {

            $ionicScrollDelegate.resize();

            if (carDetailsVm.detail.performa == 'N') {
                carDetailsVm.detail.registrationPrice = "";
                carDetailsVm.detail.insurance = "";
                carDetailsVm.detail.extendedWarranty = "";
                carDetailsVm.detail.accessories = "";
                carDetailsVm.detail.others = "";
                carDetailsVm.detail.onRoadPrice = carDetailsVm.detail.showroomprice;
            }

        }



        carDetailsVm.goBack = function() {
            $ionicHistory.goBack(-1);
        }




        carDetailsVm.validateForm = function() {
            carDetailsVm.errObj = {};

            if (!carDetailsVm.detail.state) {
                carDetailsVm.errObj.state = "Please select State";

            }

            if (!carDetailsVm.detail.city) {
                carDetailsVm.errObj.city = "Please select City";
            }

            if (!carDetailsVm.detail.make) {
                carDetailsVm.errObj.make = "Please select Make";
            }

            if (!carDetailsVm.detail.model) {
                carDetailsVm.errObj.model = "Please select Model";
            }

            if (!carDetailsVm.detail.variant) {
                carDetailsVm.errObj.variant = "Please select Variant";
            }

            if (!carDetailsVm.detail.showroomprice) {
                carDetailsVm.errObj.showroomprice = "Please enter Ex-showroom Price";

            }
            if (parseInt(carDetailsVm.detail.showroomprice)<100000) {
                carDetailsVm.errObj.showroomprice = "Please enter valid Ex-showroom Price";

            }
            if (carDetailsVm.detail.performa == "Y") {
                if (!carDetailsVm.detail.registrationPrice) {
                    carDetailsVm.errObj.registrationPrice = "Please enter Registration Price";
                }

                if (!carDetailsVm.detail.insurance) {
                    carDetailsVm.errObj.insurance = "Please enter Insurance Price";
                }
                if (!carDetailsVm.detail.extendedWarranty) {
                    carDetailsVm.errObj.extendedWarranty = "Please enter Extended Warranty";
                }
                if (!carDetailsVm.detail.accessories) {
                    carDetailsVm.errObj.accessories = "Please enter Accessories Price";
                }
                if (!carDetailsVm.detail.others) {
                    carDetailsVm.errObj.others = "Please enter Others Price";
                }

                var sum = parseInt(carDetailsVm.detail.accessories) + parseInt(carDetailsVm.detail.extendedWarranty);

                var CalculatedValue = parseInt(0.05 * carDetailsVm.detail.showroomprice);

                if (sum > CalculatedValue || sum > 50000) {
                    var alertPopup = $ionicPopup.alert({
                        template: "<p style='text-align:center;font-weight:bold;font-size:16px'>The maximum cost of accessories and extended warranty should not exceed 5% of the ex-showroom cost of the vehicle Variant or Rs. 50,000/ whichever is lower.Kindly update the same.</p>",
                        buttons: [

                            {
                                text: '<b>Ok</b>',
                                type: 'button-positive',
                                onTap: function(e) {
                                    alertPopup.close();


                                }
                            }
                        ]
                    });
                    return;

                }


            }


            return (angular.equals({}, carDetailsVm.errObj)) ? true : false;
        }

        carDetailsVm.checkForFinalEligibility = function(){
            

                

        }

        carDetailsVm.goToAO = function(){
            $state.go('menu.accountOverviewMyBalance');
        }

        carDetailsVm.goToNextPage = function() {

            if (carDetailsVm.validateForm()) {
                // carDetailsVm.waitBureau = true;
                // carDetailsVm.showTimeRemaining = true;
                //         carDetailsVm.showProgress = true;
                        
                //         carDetailsVm.showTimer();
                var request = carLoanService.saveObj;
                request.make = carDetailsVm.detail.make.key;
                request.makeValue = carDetailsVm.detail.makeValue;
                request.model = carDetailsVm.detail.model.key;
                request.modelValue = carDetailsVm.detail.modelValue
                request.variant = carDetailsVm.detail.variant.key;
                request.variantValue = carDetailsVm.detail.variantValue;
                request.exshowRoomPrice = carDetailsVm.detail.showroomprice;
                request.stateOfPurchase = carDetailsVm.detail.state.key;
                request.stateOfPurchaseValue = carDetailsVm.detail.stateValue;
                request.cityOfPurchase = carDetailsVm.detail.city.key;
                request.cityOfPurchaseValue = carDetailsVm.detail.cityValue;
                request.proforma = carDetailsVm.detail.performa;
                request.warantty = carDetailsVm.detail.extendedWarranty;
                request.rto = carDetailsVm.detail.registrationPrice;
                request.accessories = carDetailsVm.detail.accessories;;
                request.others = carDetailsVm.detail.others;
                request.dealerName = carDetailsVm.detail.dealerName ? carDetailsVm.detail.dealerName.key : "" ; 
                request.dealerNameValue = carDetailsVm.detail.dealerName ? carDetailsVm.detail.dealerNameValue : "" ; 
                request.onRoadPrice = carDetailsVm.detail.onRoadPrice;
                request.page = "carDetails";
                request.insurance = carDetailsVm.detail.insurance;

                carLoanService.saveObjCarDetails = request;
                

                $state.go('menu.carLoanAppStatus');
                //carDetailsVm.checkForFinalEligibility();
            }
        }

        carDetailsVm.showTimer = function(){
            var timeLeft = 30;
            //utilityService.showSpinner();

            //var timerId = setInterval(countdown, 1000);
            $interval(function(){
                if (timeLeft == 0) {
                //clearTimeout(timerId);
                //doSomething();
                carDetailsVm.showProgress = false;
                carDetailsVm.showTimeRemaining = false;
                carDetailsVm.checkForFinalEligibility();
                //utilityService.hideSpinner();
              } else {
                carDetailsVm.timeRemaining = timeLeft + ' seconds remaining';
                timeLeft--;
              }
            },1000)
            
        }

        $scope.$on('$ionicView.loaded', function() {

        });

        $scope.$on('$ionicView.beforeEnter', function() {
        if (utilityService.isIOSPlatform())
          {
           carDetailsVm.scroll=false;
          }

          else
          {
           carDetailsVm.scroll=true;
          }
            initPage();
         
        });



        return this;
    }


]);