'use strict';
angularApp.controller('carLoanKnowMoreController', [
    "$state",
    "$scope",
    "$ionicPopup",
    "$translate",
    "$ionicHistory",
    "utilityService",
    "ionicDatePicker",
    "$ionicSideMenuDelegate",
    "loanConfig",
    "homeLoanService", "carLoanService", "$filter", "lifeInsuranceBasicApplicationService", "ompMerchantsService","$timeout","generalInsurenceHomeService","sampoornSurakshaService",
    function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, loanConfig, homeLoanService, carLoanService, $filter, lifeInsuranceBasicApplicationService, ompMerchantsService,$timeout,generalInsurenceHomeService,sampoornSurakshaService) {

        var carLoanKnowMoreVm = this;

        function initPage() {
            carLoanKnowMoreVm.eligibity = carLoanService.loanDetails.getLoansDetails.eligibilty;
            carLoanKnowMoreVm.documentation = carLoanService.loanDetails.getLoansDetails.documentation;
            carLoanKnowMoreVm.interest = carLoanService.loanDetails.getLoansDetails.interest;
            carLoanKnowMoreVm.features = carLoanService.loanDetails.getLoansDetails.features;
            carLoanKnowMoreVm.tab = 1;
            carLoanKnowMoreVm.selectedTab = 'A';
            carLoanKnowMoreVm.buttonText = carLoanService.buttonText;

        


           sampoornSurakshaService.getAllInsuranceProducts().then(function(data) {
                      
                    var products = data.giProducts;
                    carLoanKnowMoreVm.insurencesList=[];
                for (var i=0;i<products.length;i++)
                {
                    if(products[i].productId =="motor-insurance")
                    {
                        carLoanKnowMoreVm.insurencesList.push(products[i]);


                    }

                     if(products[i].productId =="personal-accident-insurance")
                    {
                        carLoanKnowMoreVm.insurencesList.push(products[i]);


                    }

                }

                  },
                  function(error) {
                 utilityService.showErrorMessage(error.responseMessage);
             });



            var rupeeSymbol = String.fromCharCode(8377);
            carLoanKnowMoreVm.amountSlider = {
                value: parseInt(carLoanService.loanDetails.loanDetails[0].maxAnnualIncome),
                options: {
                    showSelectionBar: true,
                    floor: parseInt(carLoanService.loanDetails.loanDetails[0].minAnnualIncome),
                    ceil: parseInt(carLoanService.loanDetails.loanDetails[0].maxAnnualIncome),
                    step: 1,
                    onChange: function(id, model) {
                        //carLoanKnowMoreVm.interestValue = $filter('percent')(carLoanKnowMoreVm.interestSlider.value);
                        //carLoanKnowMoreVm.emiCalculation();
                        changeLoanMax();
                    },
                    translate: function(value) {
                        return rupeeSymbol + $filter('INR')(value);
                    }
                }
            };

            carLoanKnowMoreVm.amountSliderV = {
                value: parseInt(carLoanService.loanDetails.loanDetails[1].maxAnnualIncome),
                options: {
                    showSelectionBar: true,
                    floor: parseInt(carLoanService.loanDetails.loanDetails[1].minAnnualIncome),
                    ceil: parseInt(carLoanService.loanDetails.loanDetails[1].maxAnnualIncome),
                    step: 1,
                    onChange: function(id, model) {
                        //carLoanKnowMoreVm.interestValue = $filter('percent')(carLoanKnowMoreVm.interestSlider.value);
                        //carLoanKnowMoreVm.emiCalculation();
                        changeLoanMax();
                    },
                    translate: function(value) {
                        return rupeeSymbol + $filter('INR')(value);
                    }
                }
            };

            var maxLoanAmount = parseInt(carLoanService.loanDetails.loanDetails[0].maxAnnualIncome) * 4
            carLoanKnowMoreVm.loanSlider = {


                value: maxLoanAmount,
                options: {
                    showSelectionBar: true,
                    floor: parseInt(carLoanService.loanDetails.loanDetails[0].minLoanAmount),
                    ceil: maxLoanAmount,
                    step: 1,
                    onChange: function(id, model) {
                        //carLoanKnowMoreVm.interestValue = $filter('percent')(carLoanKnowMoreVm.interestSlider.value);
                        carLoanKnowMoreVm.emiCalculation();
                    },
                    translate: function(value) {
                        return rupeeSymbol + $filter('INR')(value);
                    }
                }

            }

            var maxLoanAmountV = Math.round(parseInt(carLoanService.loanDetails.loanDetails[1].maxAnnualIncome) * 0.85);

            carLoanKnowMoreVm.loanSliderV = {


                value: maxLoanAmountV,
                options: {
                    showSelectionBar: true,
                    floor: parseInt(carLoanService.loanDetails.loanDetails[1].minLoanAmount),
                    ceil: maxLoanAmountV,
                    step: 1,
                    onChange: function(id, model) {
                        //carLoanKnowMoreVm.interestValue = $filter('percent')(carLoanKnowMoreVm.interestSlider.value);
                        carLoanKnowMoreVm.emiCalculationV();
                    },
                    translate: function(value) {
                        return rupeeSymbol + $filter('INR')(value);
                    }
                }

            }

            carLoanKnowMoreVm.tenureSlider = {
                value: parseInt(carLoanService.loanDetails.loanDetails[0].maxTenure),
                options: {
                    showSelectionBar: true,
                    floor: parseInt(carLoanService.loanDetails.loanDetails[0].minTenure),
                    ceil: parseInt(carLoanService.loanDetails.loanDetails[0].maxTenure),
                    step: 1,
                    onChange: function(id, model) {
                        carLoanKnowMoreVm.emiCalculation();
                    },
                    translate: function(value) {
                        return value + " Months";
                    }
                }
            };

            carLoanKnowMoreVm.tenureSliderV = {
                value: parseInt(carLoanService.loanDetails.loanDetails[1].maxTenure),
                options: {
                    showSelectionBar: true,
                    floor: parseInt(carLoanService.loanDetails.loanDetails[1].minTenure),
                    ceil: parseInt(carLoanService.loanDetails.loanDetails[1].maxTenure),
                    step: 1,
                    onChange: function(id, model) {
                        carLoanKnowMoreVm.emiCalculationV();
                    },
                    translate: function(value) {
                        return value + " Months";
                    }
                }
            };
            carLoanKnowMoreVm.emiCalculation();
            carLoanKnowMoreVm.emiCalculationV();
        };

        carLoanKnowMoreVm.setMax = function(type){
            if(type == "tenure"){
                    value = carLoanService.loanDetails.loanDetails[0].maxAnnualIncome;
                    if(parseInt(loanCaculatorVm.tenureSlider.value) > parseInt(value)){
                        loanCaculatorVm.tenureSlider.value = value + "";
                    }
                }
                if(type == "loan"){
                    value = carLoanService.loanDetails.loanDetails[0].maxAnnualIncome;
                    if(parseInt(carLoanKnowMoreVm.amountSlider.value) > parseInt(value)){
                        carLoanKnowMoreVm.amountSlider.value = value + "";
                    }
                }
                loanCaculatorVm.emiCalculation();
        }

//         carLoanKnowMoreVm.applyknowmore = function(group) {

//         }

        carLoanKnowMoreVm.selTab = function(sel) {
            carLoanKnowMoreVm.tab = sel;
        }


        carLoanKnowMoreVm.selType = function(recFlag) {
            if (recFlag == 'B') {

                carLoanKnowMoreVm.selectedTab = 'B';
            } else {

                carLoanKnowMoreVm.selectedTab = 'A';
            }
        }


         carLoanKnowMoreVm.redirectToUrl=function(insurance)
             {

                carLoanService.checkSource ="car"
                 if(insurance.productId =="personal-accident-insurance")
                 {
                    generalInsurenceHomeService.setGIProductsID("personal-accident-insurance");

                    $state.go('menu.declaimer');

                }

                else
                 {
                   generalInsurenceHomeService.setGIProductsID("motor-insurance");
                  $state.go('menu.declaimer');
                 }

             }


         

        function changeLoanMax() {
            if (carLoanKnowMoreVm.selectedTab == 'A') {
                carLoanKnowMoreVm.loanSlider.options.ceil = carLoanKnowMoreVm.amountSlider.value * 4;
                carLoanKnowMoreVm.loanSlider.value = carLoanKnowMoreVm.amountSlider.value * 4;
            } else

            {
                carLoanKnowMoreVm.loanSliderV.options.ceil = Math.round(carLoanKnowMoreVm.amountSliderV.value * 0.85);
                carLoanKnowMoreVm.loanSliderV.value = Math.round(carLoanKnowMoreVm.amountSliderV.value * 0.85);
            }


        }

        carLoanKnowMoreVm.emiCalculation = function() {
            
            var p = carLoanKnowMoreVm.loanSlider.value;
           
            carLoanKnowMoreVm.interestRate = carLoanService.loanDetails.loanDetails[0].intRate;
            var i = (carLoanKnowMoreVm.interestRate / 1200);
            var t = carLoanKnowMoreVm.tenureSlider.value;
            var numerator = p * i * Math.pow((1 + i), t);
            var denominator = Math.pow((1 + i), t) - 1;
            carLoanKnowMoreVm.emiAmount = Math.ceil((numerator / denominator));


        }


        carLoanKnowMoreVm.emiCalculationV = function() {
          
            var p = carLoanKnowMoreVm.loanSliderV.value;
       
            carLoanKnowMoreVm.interestRateV = carLoanService.loanDetails.loanDetails[1].intRate;
            var i = (carLoanKnowMoreVm.interestRateV / 1200);
            var t = carLoanKnowMoreVm.tenureSliderV.value;
            var numerator = p * i * Math.pow((1 + i), t);
            var denominator = Math.pow((1 + i), t) - 1;
            carLoanKnowMoreVm.emiAmountV = Math.ceil((numerator / denominator));


        }

        carLoanKnowMoreVm.openUrl = function() {
            var id = "car";
            lifeInsuranceBasicApplicationService.getHomeLoanRedirection1(id).then(function(response) {
                ompMerchantsService.inAppBrowser(response.url);
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        carLoanKnowMoreVm.goback=function()
        {
            $ionicHistory.goBack(-1);
        }

        carLoanKnowMoreVm.gotoApplyNow = function() {




            if (carLoanService.YonodedupeData.status == '0') {
                var request = {
                    "loanType": "car"
                }
                carLoanService.getEligiblityCheck(request).then(function(data) {


                    carLoanService.userMaster = data;
                    if (data.status == "CL02") {
                        homeLoanService.dedupErrors = data.reasons;
                        homeLoanService.source='car';
                        $state.go('menu.homeLoanError');
                    } else if (data.status == "0000") {
                        $state.go('menu.carPersonaldetails');
                    } else if (data.status == "CL03") {
                    
                        $state.go('menu.cLExtinginLos');
                    }


                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else {
                $state.go('menu.clApplicationStatus');


            }


        }



        carLoanKnowMoreVm.goToAO = function() {
            $state.go('menu.accountOverviewMyBalance');
        }



        $scope.$on('$ionicView.loaded', function() {

        });

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });



        return this;
    }
]);