angularApp.service('carLoanService',
    function($q, AdapterUtils, utilityService, constantConfig) {

        var carLoanService = this;
        this.loanDetails = "";
        carLoanService.resumeData = "";


        carLoanService.getCarLoanDetails = function(payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Car/getCarLoanDetails", payload, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        carLoanService.getDistrictCity = function(payload){
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Car/getDistrictSubDistrict", payload, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        }

        carLoanService.getDealerList = function(payload){
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Car/getDealerList", payload, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        }
        
        carLoanService.getEligiblityCheck = function(payload) {


            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Car/executeBusinessEligibility", payload, true).then(
                function(response) {
                    carLoanService.clearAll();
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        carLoanService.pushLOSData = function(payload) {


            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Car/pushLOSData", payload, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        carLoanService.saveData = function(payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Car/saveData", payload, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        carLoanService.validateNMIEMI = function(payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Car/validateNMIEMI", payload, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        carLoanService.clearAll = function() {

            

            carLoanService.resumeData = "";
            carLoanService.saveObj = "";

            carLoanService.personalData = "";
            carLoanService.workData = "";
            carLoanService.carData = "";
            carLoanService.amountSlider = "";
            carLoanService.tenureSlider = "";

        }


        carLoanService.getYonoDedupe = function(payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Car/getYonoDedupe", payload, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        carLoanService.triggerCIR = function(payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Car/triggerCIR", payload, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        carLoanService.finalEligibility = function(payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Car/finalEligibiltyCheck", payload, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        carLoanService.getSubData = function(payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Car/fetchDependentMaster", payload, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        carLoanService.delete = function(payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Car/deleteExistingYonoApplication", payload, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        carLoanService.validateCSP = function(payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Car/validateCSP", payload, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        carLoanService.resumeApplication = function(payload) {

            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Car/resumeApplication", payload, true).then(
                function(response) {
                    carLoanService.clearAll();
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

          carLoanService.getDocument = function(payload) {

            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Car/getDocument", payload, true).then(
                function(response) {
                   
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };





        return carLoanService;

    });