'use strict';
angularApp.controller('clApplicationStatusController', [
    "$state",
    "$scope",
    "$ionicPopup",
    "$translate",
    "$ionicHistory",
    "utilityService",
    "ionicDatePicker",
    "$ionicSideMenuDelegate",
    "customerInfoService", "carLoanService",
    function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, customerInfoService, carLoanService) {

        var clApplicationStatusVm = this;

        function initPage() {
            clApplicationStatusVm.yonoRef = carLoanService.YonodedupeData.yonoRef;
            clApplicationStatusVm.startDate = carLoanService.YonodedupeData.startDate;
        };

        clApplicationStatusVm.applyNew = function() {


            var backPopup = $ionicPopup.show({
                title: null,
                cssClass: 'my-custom-popup',
                template: '<div class="button_fund font-size-14 roboto-medium color-darkgrey" translate="CL_DELETE_APP"></div>',
                buttons: [{
                        text: 'No',
                        type: 'button-assertive',
                        onTap: function() {
                            backPopup.close();
                        }
                    },
                    {
                        text: 'Yes',
                        type: 'button-assertive',
                        onTap: function() {
                            var request = {};
                            backPopup.close();
                            carLoanService.delete(request).then(function(data) {
                                   
                                    var alertPopup = $ionicPopup.alert({
                                        template: "<p style='text-align:center;font-weight:bold;font-size:16px'> Your pending applications have been deleted.</p>",
                                        buttons: [

                                            {
                                                text: '<b>Ok</b>',
                                                type: 'button-positive',
                                                onTap: function(e) {
                                                    alertPopup.close();
                                                    $state.go('menu.loans');
                                                 
                                                }
                                            }
                                        ]
                                    });


                                },
                                function(error) {
                                    utilityService.showErrorMessage(error.responseMessage);
                                });
                        }
                    }
                ]
            });
    
        }

        clApplicationStatusVm.resume = function() {
            var request = {};

            carLoanService.resumeApplication(request).then(function(data) {


                carLoanService.resumeData = data;
                carLoanService.homeBranch = data.applicants[0].homeBranch;
                $state.go('menu.carPersonaldetails');

            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        clApplicationStatusVm.goback=function()
        {
             $ionicHistory.goBack(-1);
        }



        clApplicationStatusVm.goToHome = function() {
            $state.go('menu.homeScreen')
        }

        $scope.$on('$ionicView.loaded', function() {

        });

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        return this;
    }


]);