'use strict';
angularApp.controller('clSelectBranchController', [
    "$state",
    "$scope",
    "$ionicPopup",
    "$translate",
    "$ionicHistory",
    "utilityService",
    "ionicDatePicker",
    "$ionicSideMenuDelegate",
    "customerInfoService",
    "homeLoanService",
    "getAccountDetailsService", "carLoanService",
    function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, customerInfoService, homeLoanService, getAccountDetailsService, carLoanService) {

        var clSelectBranchVm = this;



        function initPage() {
            clSelectBranchVm.homeBranchesAC = [];
            clSelectBranchVm.homeBranches = [];
            clSelectBranchVm.branchesByLocation = [];
            clSelectBranchVm.selTab = 'B';
            clSelectBranchVm.selectedIndex = 0;
            clSelectBranchVm.selectedIndexLocation = 0; //clSelectBranchVm.homeBranches
            clSelectBranchVm.loadState();

            // if (getAccountDetailsService.accountOverviewData) {
            //     var arr = getAccountDetailsService.accountOverviewData.accounts;
            //     for (var i = 0; i < arr.length; i++) {
            //         clSelectBranchVm.homeBranchesAC.push(arr[i].branchCode);
            //     }
            // }
            clSelectBranchVm.homeBranchesAC.push(carLoanService.homeBranch);
            clSelectBranchVm.homeBranchesAC = clSelectBranchVm.removeDuplicate(clSelectBranchVm.homeBranchesAC);

           

            for (var i = 0; i < clSelectBranchVm.homeBranchesAC.length; i++) {
                var request = {
                    "locality": clSelectBranchVm.homeBranchesAC[i]
                };

                homeLoanService.getBranchDetails(request).then(function(data) {
                    console.log(data);
                    clSelectBranchVm.homeBranches.push(data.branches[0]);

                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }





            clSelectBranchVm.selectedBranch = "Branch";
            clSelectBranchVm.alphabets = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";

            if (homeLoanService.source == "car") {
                clSelectBranchVm.isCar = true;
            } else {
                clSelectBranchVm.isCar = false;
            }
        };

        clSelectBranchVm.getHomeBranch = function(selIndex) {
            clSelectBranchVm.selectedIndex = selIndex;
        }

        clSelectBranchVm.getLocationBranch = function(selIndex) {
            clSelectBranchVm.selectedIndexLocation = selIndex;
        }



        clSelectBranchVm.removeDuplicate = function(arr) {
            var uniqArr = [];
            for (var i = 0; i < arr.length; i++) {
                if (uniqArr.indexOf(arr[i]) == -1) {
                    uniqArr.push(arr[i]);
                }
            }
            return uniqArr;
        }

        clSelectBranchVm.loadState = function() {
            var request = {
                "masterId": [
                    "HL_Branch"
                ]
            };
            homeLoanService.getStateForBranch(request).then(function(data) {
                clSelectBranchVm.locationStates = data.branch;

            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

        }

        clSelectBranchVm.loadDistrict = function() {
            //clSelectBranchVm.locationState
            var request = {
                "masterId": [
                    "HL_Branch"
                ],
                "stateCode": clSelectBranchVm.locationState.stateCode
            };
            homeLoanService.getDistrictForBranch(request).then(function(data) {
                clSelectBranchVm.locationDistricts = data.branch;

            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

        }

        clSelectBranchVm.loadCity = function() {
            var request = {
                "masterId": [
                    "HL_Branch"
                ],
                "districtName": clSelectBranchVm.locationDistrict.district
            };
            homeLoanService.getCityForBranch(request).then(function(data) {
                var cities = data.branch;
                for (var i = 0; i < cities.length; i++) {
                    if (cities[i].city == "") {
                        cities[i].city = "Others";
                    }
                }
                clSelectBranchVm.locationCities = cities;

            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

        }

        clSelectBranchVm.loadBranchByLocation = function() {
            clSelectBranchVm.expandLocationByBranch();
            clSelectBranchVm.branchesByLocation = [];
            var request = {
                "masterId": [
                    "HL_Branch"
                ],
                "districtName": clSelectBranchVm.locationDistrict.district,
                "cityName": clSelectBranchVm.locationCity.city
            };

            homeLoanService.getBranchForLocations(request).then(function(data) {
                clSelectBranchVm.branchesByLocation = data.branch;

            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

        }

        clSelectBranchVm.expandLocationByBranch = function() {
            clSelectBranchVm.isLocationByBranch = !clSelectBranchVm.isLocationByBranch;
        }



        clSelectBranchVm.selType = function(recFlag) {
            if (recFlag == 'B') {
                //By Branch
                clSelectBranchVm.selTab = 'B';
            } else {
                //By Pincode
                clSelectBranchVm.selTab = 'A';
            }
        }

        clSelectBranchVm.goToNextPage = function() {
            var branchCode = clSelectBranchVm.selTab == 'B' ? clSelectBranchVm.homeBranches[clSelectBranchVm.selectedIndex].id : clSelectBranchVm.branchesByLocation[clSelectBranchVm.selectedIndexLocation].branchCode;



            if (homeLoanService.source == "car") {

                var branchName = clSelectBranchVm.selTab == 'B' ? clSelectBranchVm.homeBranches[clSelectBranchVm.selectedIndex].branchName : clSelectBranchVm.branchesByLocation[clSelectBranchVm.selectedIndexLocation].branch;

                var request = {};
                request.branchCode = branchCode;
                request.branchName = branchName;

                carLoanService.pushLOSData(request).then(function(data) {

                    $state.go("menu.cLReferenceNumber");
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });


            } else {

                var confirmProduct = {
                    "loanType": homeLoanService.getGroupId(),
                    "productName": homeLoanService.getSelectedProduct().productName,
                    "productCode": homeLoanService.getSelectedProduct().productCode,
                    "branchCode": branchCode
                }
                homeLoanService.confirmProduct(confirmProduct).then(function(data) {
                    utilityService.setCsatJournies('homeloan');
                    homeLoanService.setConfirmProduct(data);
                    $state.go('menu.homeLoanRefNo');
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        }

        clSelectBranchVm.goBack = function() {
            $ionicHistory.goBack(-1);

        }

        $scope.$on('$ionicView.loaded', function() {

        });

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        return this;
    }


]);