'use strict';
angularApp.controller('eduOtpController', [
		"$state",
		"$scope",		
		"utilityService",
		"educationLoanService","customerInfoService","$filter",
		function($state, $scope,utilityService,educationLoanService,customerInfoService,$filter) {
			
			var eduOtpVm = this;

			function initPage(){
				eduOtpVm.otpCount = 0;
				eduOtpVm.clickCount = 0;
				eduOtpVm.isResendDisabled = false;
				eduOtpVm.mobileNumber = $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4);
			}

			eduOtpVm.goNext = function(){
				eduOtpVm.resetPinOTP = "";
				if(!eduOtpVm.otpNumber){
					eduOtpVm.resetPinOTP = "Please Enter the OTP";
				}else if(eduOtpVm.otpNumber.length != 6){
					eduOtpVm.resetPinOTP = "Please enter 6 digits OTP";
				}else{
					var request = {
						"otp" : eduOtpVm.otpNumber
					}
					educationLoanService.validateOtp(request).then(function(data) {
						var request = educationLoanService.getDataPush();
						educationLoanService.dataPush(request).then(function(data) {
							var losData = educationLoanService.getDataPush();
							losData.refNo = data.refNo;
							educationLoanService.setDataPush(losData);
							utilityService.setCsatJournies('educationLoan');
							educationLoanService.clearAll();
							$state.go('menu.eduSuccess');
						},function(error){
							eduOtpVm.otpNumber = "";
							utilityService.showErrorMessage(error.responseMessage);
						});
					},function(error){
						eduOtpVm.otpNumber = "";
						eduOtpVm.otpCount++;
						if(eduOtpVm.otpCount >= 3){
							var title = '';
							var template = "<p> "+error.responseMessage +" </p>";
							var onTap = 'menu.homeScreen';
							var buttontext = "<b>OK</b>";
							utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
						}else{
							utilityService.showErrorMessage(error.responseMessage);
						}
					});
				}
			}

			eduOtpVm.resendOTP = function(){
				educationLoanService.getOtp().then(function(data) {
					eduOtpVm.otpNumber = "";
					eduOtpVm.resetPinOTP = "";
					eduOtpVm.clickCount++;
					if(eduOtpVm.clickCount >= 2){
						eduOtpVm.isResendDisabled = true;
					}
					var template = "<p> "+ "OTP has been sent to your registered mobile number." +" </p>";
					var onTap = '';
					var buttontext = "<b>OK</b>";
					utilityService.showAlertModal('', template, onTap, $scope, $state, buttontext);
				},function(error){
					eduOtpVm.otpNumber = "";
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			eduOtpVm.goBack = function(){
				$state.go('menu.eduScan');
			}

			$scope.$on('$ionicView.beforeEnter', function() {
				initPage();
			});
			
			return this;
		}

		
]);


