'use strict';
angularApp.controller('eduRequestDisburseController', [
		"$state",
		"$scope",		
		"utilityService",
		"$filter",
		"educationLoanService","$ionicPopover","$translate","$ionicPopup",
		function($state, $scope,utilityService,$filter,educationLoanService,$ionicPopover,$translate,$ionicPopup) {
			
			var eduRequestDisburseVm = this;
			
			function initPage(){
				eduRequestDisburseVm.loanAmount = educationLoanService.getKnowMore().accountSummary.sanctionedAmount;
				eduRequestDisburseVm.marginList = educationLoanService.getKnowMore().marginList;
				if(educationLoanService.getCurrentDemand()){
					eduRequestDisburseVm.demand = educationLoanService.getCurrentDemand().currentDemand;
					eduRequestDisburseVm.margin = educationLoanService.getCurrentDemand().marginPay;
					eduRequestDisburseVm.balance = educationLoanService.getCurrentDemand().marginPay.key=='I authorise to debit from bank account' ? educationLoanService.getCurrentDemand().selectedAccount.accountBalance : "";
					eduRequestDisburseVm.accType = educationLoanService.getCurrentDemand().marginPay.key=='I authorise to debit from bank account' ? educationLoanService.getCurrentDemand().selectedAccount.accountType : "";
					eduRequestDisburseVm.accountNumber = educationLoanService.getCurrentDemand().marginPay.key=='I authorise to debit from bank account' ? educationLoanService.getCurrentDemand().selectedAccount.accountNumber : "";
					eduRequestDisburseVm.showSelect = educationLoanService.getCurrentDemand().marginPay.key=='I authorise to debit from bank account' ? false : true;
					eduRequestDisburseVm.accList = educationLoanService.getCurrentDemand().marginPay.key=='I authorise to debit from bank account' ? educationLoanService.getCurrentDemand().accList : "";
					eduRequestDisburseVm.selectedAccount = educationLoanService.getCurrentDemand().marginPay.key=='I authorise to debit from bank account' ? educationLoanService.getCurrentDemand().selectedAccount : "";
				}
				eduRequestDisburseVm.enablePay();
			}

			eduRequestDisburseVm.enablePay = function(){
				eduRequestDisburseVm.enableNext = false;
				if(!eduRequestDisburseVm.accList && eduRequestDisburseVm.margin && eduRequestDisburseVm.margin.key == "I authorise to debit from bank account"){
					eduRequestDisburseVm.showSelect = true;
					educationLoanService.accountFilter().then(function(data) {
						if(eduRequestDisburseVm.marginList && eduRequestDisburseVm.margin && eduRequestDisburseVm.marginList[0].key == eduRequestDisburseVm.margin.key){
							eduRequestDisburseVm.enableNext = true;
						}
						if(eduRequestDisburseVm.marginList && eduRequestDisburseVm.margin && eduRequestDisburseVm.marginList[1].key == eduRequestDisburseVm.margin.key && eduRequestDisburseVm.balance){
							eduRequestDisburseVm.enableNext = true;
						}
						eduRequestDisburseVm.accList = data.accList;
					}, function(error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				}else{
					if(eduRequestDisburseVm.marginList && eduRequestDisburseVm.margin && eduRequestDisburseVm.marginList[0].key == eduRequestDisburseVm.margin.key){
						eduRequestDisburseVm.enableNext = true;
					}
					if(eduRequestDisburseVm.marginList && eduRequestDisburseVm.margin && eduRequestDisburseVm.marginList[1].key == eduRequestDisburseVm.margin.key && eduRequestDisburseVm.balance){
						eduRequestDisburseVm.enableNext = true;
					}
				}
			}

			// var template = '<ion-popover-view class="edu-popover" id="runtimeHeight" >'+'<div class="edu-arrow-down-login edu-arrow-down"></div>' + '<a class="iconsubtext closeinfobutton float-right" id="CALL_ANC" click-stream="click" ng-click="eduRequestDisburseVm.closePopover()">' + '<i class="ico-close ver-align-middle"></i>' + '</a>' + '<ion-content class="col-90">' +
			// '<div id="renderHeight" class="text-left padding-left-10 padding-right-10 font-size-12" translate="EDU_MARGIN_TOOL"></div>' + '</ion-content>' + '</ion-popover-view>';

			var template = '<ion-popover-view class=" loginnewarrow edu-fraudemergencypopovernew" id="runtimeHeight" >' + '<div class="edu-arrow-upnew"></div>' + '<a class="iconsubtext closeinfobutton float-right" id="CALL_ANC" click-stream="click" ng-click="eduRequestDisburseVm.closePopover()">' + '<i class="ico-close ver-align-middle"></i>' + '</a>' + '<ion-content class="col-90">' +
			'<div id="renderHeight" class="text-left padding-left-10 padding-right-10 font-size-12" translate="EDU_MARGIN_TOOL"></div>' + '</ion-content>' + '</ion-popover-view>';

			$scope.popover = $ionicPopover.fromTemplate(template, {
				scope: $scope
			});

			eduRequestDisburseVm.openInfo = function($event){
				$scope.popover.show($event);
			}

			eduRequestDisburseVm.closePopover = function(){
				$scope.popover.hide();
			}

			eduRequestDisburseVm.validatePage = function(){
				eduRequestDisburseVm.demandError = "";
				if(!eduRequestDisburseVm.demand || eduRequestDisburseVm.demand == "0"){
					eduRequestDisburseVm.demandError = $translate.instant('EDU_DEMAND_ZERO_ERROR');
					return false;
				}
				if(parseInt(eduRequestDisburseVm.demand) > educationLoanService.getKnowMore().accountSummary.outstandingAmount){
					eduRequestDisburseVm.demandError = $translate.instant('EDU_DEMAND_ERROR');
					return false;
				}
				return true;
			} 

			eduRequestDisburseVm.goNext = function(){
				if(eduRequestDisburseVm.validatePage()){
					var losData = {
						"currentDemand" : eduRequestDisburseVm.demand,
						"marginPaymentMethod" : eduRequestDisburseVm.margin.key,
						"marginAccountNumber": eduRequestDisburseVm.margin.key=='I authorise to debit from bank account' ?  eduRequestDisburseVm.accountNumber : "",
						"marginPay" : eduRequestDisburseVm.margin,
						"selectedAccount" : eduRequestDisburseVm.selectedAccount,
						"accList" : eduRequestDisburseVm.accList
					}
					educationLoanService.setCurrentDemand(losData);
					educationLoanService.setDataPush(losData);
					$state.go('menu.eduScan');
				}
			}

			eduRequestDisburseVm.goBack = function(){
				$state.go('menu.eduSummary');
			}

			eduRequestDisburseVm.showPop = function(){
				if(eduRequestDisburseVm.accList && eduRequestDisburseVm.accList.length > 0){
					eduRequestDisburseVm.popUp = $ionicPopup.show({
						title: '',
						cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
						templateUrl: 'pages/loans/education/dropdownModal.html',
						scope: $scope
					});
				}
			}

			eduRequestDisburseVm.close = function(index){
				eduRequestDisburseVm.marginError = "";
				eduRequestDisburseVm.popUp.close();
				eduRequestDisburseVm.balance = eduRequestDisburseVm.accList[index].accountBalance;
				eduRequestDisburseVm.accType = eduRequestDisburseVm.accList[index].accountType;
				eduRequestDisburseVm.accountNumber = eduRequestDisburseVm.accList[index].accountNumber;
				eduRequestDisburseVm.selectedAccount = eduRequestDisburseVm.accList[index];
				eduRequestDisburseVm.showSelect = false;
				eduRequestDisburseVm.enablePay();
				if(parseFloat(eduRequestDisburseVm.balance) == 0){
					eduRequestDisburseVm.marginError = "Saving account does not have balance kindly ensure funds availability before branch proceesing.";
				}
			}
			
			$scope.$on('$ionicView.beforeEnter', function() {
				initPage();
			});
			
			return this;
		}

		
]);