'use strict';
angularApp.controller('eduScanController', [
		"$state",
		"$scope",		
		"utilityService",
		"educationLoanService","$filter","$ionicPopover","xpressCreditService","$ionicPopup","homeLoanService",
		function($state, $scope,utilityService,educationLoanService,$filter,$ionicPopover,xpressCreditService,$ionicPopup,homeLoanService) {
			
			var eduScanVm = this;

			function initPage(){
				eduScanVm.isMarksheet = true;
				if(educationLoanService.getScanDoc()){
					eduScanVm.demandLetterName = educationLoanService.getScanDoc().demandLetterName;
					eduScanVm.markSheetName = educationLoanService.getScanDoc().markSheetName;
					eduScanVm.otherMarkSheetName = educationLoanService.getScanDoc().otherMarkSheetName;
					eduScanVm.paymentReceiptName = educationLoanService.getScanDoc().paymentReceiptName;
					eduScanVm.otherPaymentReceiptName = educationLoanService.getScanDoc().otherPaymentReceiptName;
					eduScanVm.tnc = educationLoanService.getScanDoc().dontHaveMarksheetFlag;
					eduScanVm.reason = educationLoanService.getScanDoc().dontHaveMarksheetReason;
				}
			}

			eduScanVm.goNext = function(){
				eduScanVm.reasonError = "";
				if(eduScanVm.tnc && !eduScanVm.reason){
					eduScanVm.reasonError = "Please specify reason";
				}else{
					educationLoanService.getOtp().then(function(data) {
						var losData = educationLoanService.getDataPush();
						losData.dontHaveMarksheetFlag = eduScanVm.tnc ? "Y" : "N";
						losData.dontHaveMarksheetReason = eduScanVm.tnc ? eduScanVm.reason : "";
						var pageDetails = {
							"demandLetterName" : eduScanVm.demandLetterName,
							"markSheetName" : eduScanVm.markSheetName,
							"otherMarkSheetName" : eduScanVm.otherMarkSheetName,
							"paymentReceiptName" : eduScanVm.paymentReceiptName,
							"otherPaymentReceiptName" : eduScanVm.otherPaymentReceiptName,
							"dontHaveMarksheetFlag" : eduScanVm.tnc,
							"dontHaveMarksheetReason" : eduScanVm.tnc ? eduScanVm.reason : ""
						};
						educationLoanService.setScanDoc(pageDetails);
						educationLoanService.setDataPush(losData);
						$state.go('menu.eduOtp');
					},function(error){
						utilityService.showErrorMessage(error.responseMessage);
					});
				}
			}

			eduScanVm.removeDocument = function(type){
				if (type == "1") {
					eduScanVm.demandLetterName = "";
				}else if (type == "2") {
					eduScanVm.markSheetName = "";
					eduScanVm.tnc = false;
				}else if (type == "3") {
					eduScanVm.otherMarkSheetName = "";
				}else if (type == "4") {
					eduScanVm.paymentReceiptName = "";
				}else if (type == "5") {
					eduScanVm.otherPaymentReceiptName = "";
				}
			}

			eduScanVm.openInfo = function($event,id){
				if(id=='mark'){
					eduScanVm.isMarksheet = true;
					eduScanVm.template = '<ion-popover-view class="loginnewarrow edu-fraudemergencypopovernew" id="runtimeHeight" >' + '<div class="edu-arrow-upnew"></div>' + '<a class="iconsubtext closeinfobutton float-right" id="CALL_ANC" click-stream="click" ng-click="eduScanVm.closePopover()">' + '<i class="ico-close ver-align-middle"></i>' + '</a>' + '<ion-content class="col-90">' +
					'<div id="renderHeight" class="text-left padding-left-10 padding-right-10 font-size-12">Upload the latest/last Marksheet or pass certificate</div>' + '</ion-content>' + '</ion-popover-view>';
					$scope.popover = $ionicPopover.fromTemplate(eduScanVm.template, {
						scope: $scope
					});
				}else{
					eduScanVm.isMarksheet = false;
					eduScanVm.template = '<ion-popover-view class="loginnewarrow edu-scna-popnew" id="runtimeHeight" >' + '<div class="edu-arrow-downnew"></div>' + '<a class="iconsubtext closeinfobutton float-right" id="CALL_ANC" click-stream="click" ng-click="eduScanVm.closePopover()">' + '<i class="ico-close ver-align-middle"></i>' + '</a>' + '<ion-content class="col-90">' +
					'<div id="renderHeight" class="text-left padding-left-10 padding-right-10 font-size-12">'+
					'<div>Examination/Library/Laboratory fees</div><br>' +
					'<div>Purchase of Books /Equipment /Instruments /Uniforms /computers (maximum 20% of the total tution fees payable for completion of the course)</div><br>'+
					'<div>Caution Deposit/Building Fund/Refundable Deposit(maximum 10% of tution fees for the entire course)</div><br><div>Travel Expenses/Passage money for studies abroad Cost of a Two-wheeler upto Rs. 50,000/-</div><br>' +
					'<div>Any other expense required to complete the course like study tours, project work etc.</div>' + 
					'</div>' + '</ion-content>' + '</ion-popover-view>';
					$scope.popover = $ionicPopover.fromTemplate(eduScanVm.template, {
						scope: $scope
					});
				}
				$scope.popover.show($event);
			}

			eduScanVm.cameraClick = function(type){
				xpressCreditService.getnewImage().then(function(data) {
					var blob = new Blob([data], {type: 'image/jpeg'});
					var typecheck = data.substring(data.indexOf('/') + 1, data.indexOf(';base64'));
					var size = data.length;
					if (typecheck == "png" || typecheck == "jpg" || typecheck == "jpeg" || typecheck == "pdf") {
						eduScanVm.commanAddFile(blob, type, data, typecheck,size);
					}  else {
						var template = "Upload documents can be pdf, jpeg, png format only."
						$ionicPopup.show({
							title: '',
							template: template,
							scope: $scope,
							cssClass: 'my-custom-popup',
							buttons: [{
								text: 'OK',
								type: 'button-assertive',
								onTap: function () {
									$state.go('menu.xcDocupload');
								}
							}],
						});
					}	
				}, function(error) {});	
			}

			eduScanVm.uploadClick = function(type){
				if(utilityService.isAndroidPlatform()){
					homeLoanService.getFileForAndroid().then(function(data){
						var blob = new Blob([data], {type: 'image/jpeg'});
						var typecheck = data.substring(data.indexOf('/') + 1, data.indexOf(';base64'));
						var size = data.length;
						if (typecheck == "png" || typecheck == "jpg" || typecheck == "jpeg" || typecheck == "pdf") {
							eduScanVm.commanAddFile(blob, type, data, typecheck,size); 
						}else{
							var template = "Upload documents can be pdf, jpeg, png format only."
							$ionicPopup.show({
								title: '',
								template: template,
								scope: $scope,
								cssClass: 'my-custom-popup',
								buttons: [{
									text: 'OK',
									type: 'button-assertive',
									onTap: function () {
									}
								}],
							});
						}

					}, function(error) { 

					});
				}else{
					homeLoanService.getFileForiOS().then(function(response) {
						var sizeInMB = response.size;
                        var data = response.imagedata;
						var blob = new Blob([data], {type: 'image/jpeg'});
						var typecheck = data.substring(data.indexOf('/') + 1, data.indexOf(';base64'));
						if (typecheck == "png" || typecheck == "jpg" || typecheck == "jpeg" || typecheck == "pdf") {
							eduScanVm.commanAddFile(blob, type, data, typecheck,sizeInMB); 
						}else{
							var template = "Upload documents can be pdf, jpeg, png format only."
							$ionicPopup.show({
								title: '',
								template: template,
								scope: $scope,
								cssClass: 'my-custom-popup',
								buttons: [{
									text: 'OK',
									type: 'button-assertive',
									onTap: function () {
									}
								}],
							});
						}
					}, function(error) {});
				}
			}

			eduScanVm.commanAddFile = function(blob, type, data, typecheck,sizeOfImage){
				var imageName = "";
				var sizeInMB = sizeOfImage;
				var size = 0;
				var block = data.split(";");
				var contentType = block[0].split(":")[1];

				if (sizeInMB < 1048576) {
					if (type == "1") {
						imageName = "Demand_Letter" + '.' + typecheck;
						eduScanVm.demandLetterName = imageName;
						size = (blob.size/1024).toFixed(2);
					}else if (type == "2") {
						imageName = "Marksheet" + '.' + typecheck;
						eduScanVm.markSheetName = imageName;
						eduScanVm.tnc = false;
						size = (blob.size/1024).toFixed(2);
					}else if (type == "3") {
						imageName = "Marksheet" + '.' + typecheck;
						eduScanVm.otherMarkSheetName = imageName;
						size = (blob.size/1024).toFixed(2);
					}else if (type == "4") {
						imageName = "Payment_Receipt" + '.' + typecheck;
						eduScanVm.paymentReceiptName = imageName;
						size = (blob.size/1024).toFixed(2);
					}else if (type == "5") {
						imageName = "Other_Payment" + '.' + typecheck;
						eduScanVm.otherPaymentReceiptName = imageName;
						size = (blob.size/1024).toFixed(2);
					}
					eduScanVm.profileImageUrl = data;
					eduScanVm.filename = imageName;
					eduScanVm.upDateProfile(eduScanVm.profileImageUrl,eduScanVm.filename,type,typecheck,contentType); 
				}else{
					var template = "Please upload File with size less than 1MB."
					$ionicPopup.show({
						title: '',
						template: template,
						scope: $scope,
						cssClass: 'my-custom-popup',
						buttons: [{
							text: 'OK',
							type: 'button-assertive',
							onTap: function () {
								
							}
						}],
					});
				}
			}

			eduScanVm.upDateProfile = function(imgProfile, filename, type, typecheck, contentType) {
				var reqParams = {};
				reqParams["documentCategory"] = type;
				reqParams["documentFormat"] = contentType;
				reqParams["docName"] = filename; 
				reqParams["base64"] = imgProfile.split(',')[1];
				console.log("reqParamsreqParams",reqParams);
				educationLoanService.uploadDocument(reqParams).then(function(data) {
                    console.log("uploadDocService",data);
                },function(error) {
					if (type == "1") {
						eduScanVm.demandLetterName = "";
					}else if (type == "2") {	
						eduScanVm.markSheetName = "";
					}else if (type == "3") {
						eduScanVm.otherMarkSheetName = "";
					}else if (type == "4") {
						eduScanVm.paymentReceiptName = "";
					}else if (type == "5") {
						eduScanVm.otherPaymentReceiptName = "";
					}
                    utilityService.showErrorMessage(error.responseMessage);
                });
			}

			eduScanVm.closePopover = function(){
				$scope.popover.hide();
			}

			eduScanVm.goBack = function(){
				$state.go('menu.eduRequestDisburse');
			}
			
			$scope.$on('$ionicView.beforeEnter', function() {
				initPage();
			});
			
			return this;
		}

]);