'use strict';
angularApp.controller('eduSummaryController', [
		"$state",
		"$scope",		
		"utilityService",
		"educationLoanService","$filter","ompMerchantsService",
		function($state, $scope,utilityService,educationLoanService,$filter,ompMerchantsService) {
			
			var eduSummaryVm = this;

			function initPage(){
				eduSummaryVm.loanAccount = educationLoanService.getKnowMore().accountSummary.accountNumber;
				eduSummaryVm.disbursedAmount = parseInt(educationLoanService.getKnowMore().accountSummary.disbursedAmount);
				eduSummaryVm.sanctionedAmount = parseInt(educationLoanService.getKnowMore().accountSummary.sanctionedAmount);
				eduSummaryVm.outstandingAmount = parseInt(educationLoanService.getKnowMore().accountSummary.outstandingAmount);
				eduSummaryVm.interestRate = educationLoanService.getKnowMore().accountSummary.rateOfInterest;
				eduSummaryVm.emi = educationLoanService.getKnowMore().accountSummary.emi;
				eduSummaryVm.disburseDate = educationLoanService.getKnowMore().accountSummary.disbursementDate;

				if((eduSummaryVm.sanctionedAmount - eduSummaryVm.disbursedAmount) == 0){
					eduSummaryVm.isOutZero = true;
					eduSummaryVm.buttonText = "Apply New Loan";
				}else{
					eduSummaryVm.isOutZero = false;
					if(educationLoanService.getKnowMore().accountSummary.status == "1"){
						eduSummaryVm.buttonText = "Apply New Loan";
					}else if(educationLoanService.getKnowMore().accountSummary.status == "2"){
						eduSummaryVm.buttonText = "Request Disbursement";
					}else if(educationLoanService.getKnowMore().accountSummary.status == "3"){
						eduSummaryVm.buttonText = "Check Status";
					}
				}
			}

			eduSummaryVm.style = function(){
				var val = (eduSummaryVm.disbursedAmount/eduSummaryVm.sanctionedAmount)*100;
				if(val < 4){
					val = 4;
				}
				val = val + "%";
				return { 'width' :  val}
			}
			
			eduSummaryVm.margin = function(value){
				var val = (eduSummaryVm.disbursedAmount/eduSummaryVm.sanctionedAmount)*100;
				if(val < 85){
					if(value == "text"){
						val = (val-15) + "%";
					}else{
						val = (val-11) + "%";
					}
				}else{
					if(value == "text"){
						val = "70%";
					}else{
						val = "74%";
					}
				}
				return { 'padding-left' :  val}
			}
			
			eduSummaryVm.viewTrans = function(){
				educationLoanService.viewtransaction().then(function(data) {
					educationLoanService.setViewTransaction(data);
					$state.go('menu.eduTransaction');
				}, function(error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			eduSummaryVm.requestDisburse = function(){
				if(educationLoanService.getKnowMore().accountSummary.status == "1" || eduSummaryVm.isOutZero){
					educationLoanService.displayPopUp("You will be redirected to Vidya-Lakshmi portal now","Please keep your documents ready for application","",["Cancel","OK"],function(){
					},function(){
						educationLoanService.getRedirection().then(function(data) {
							if(utilityService.isAndroidPlatform()){
								ompMerchantsService.inChromeBrowser(data.url);
							}else{
								ompMerchantsService.inAppBrowser(data.url);
							}
						}, function(error) {
							utilityService.showErrorMessage(error.responseMessage);
						});
					});
				}else if(educationLoanService.getKnowMore().accountSummary.status == "2"){
					$state.go('menu.eduRequestDisburse');
				}else if(educationLoanService.getKnowMore().accountSummary.status == "3"){
					$state.go('menu.eduCheckStatus');
				}
			}

			$scope.$on('$ionicView.beforeEnter', function() {
				initPage();
			});
			
			return this;
		}

		
]);


