angularApp.service('educationLoanService',["$q","AdapterUtils","loanConfig","$filter","$ionicPopup",
	function($q,AdapterUtils,loanConfig,$filter,$ionicPopup){
    
    var educationLoanService = this;

    var knowmore,viewTransaction,viewSummary,dataPushData,currentDemand,scanDoc;

    educationLoanService.clearAll = function(){
        knowmore = null,viewTransaction = null,viewSummary = null,currentDemand = null,scanDoc = null;
    };

	educationLoanService.displayPopUp = function(heading,message,css,buttonText,button1,button2){
        var alertPopup = $ionicPopup.alert({
            title: '<div class="padTop20 font-dark-grey fontWeight600 edu-pop-title">' + heading + '</div>' ,
            template: '<div class="popupTextBottomPadding p-20 fss-common-ul-list edu-pop-up-msg">'
            + message + '</div></div>',
            cssClass: 'removePopup-head popupWidth90 popupMargin ftpopup-body popupBackgroundWhite ss-medical-page edu-pop-up' + css,
            buttons: [
                {
                    text: buttonText[0],
                    onTap: function(e) {
                        button1();
                    }
                },
                {
                    text: buttonText[1],
                    onTap: function(e) {
                        button2();
                    }
                }
            ],
        });
    };

    educationLoanService.knowMore = function() {
        var q = $q.defer();
        AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Education/getEducationLoanDetails", {}, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    educationLoanService.getRedirection = function() {
        var q = $q.defer();
        AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Education/getRedirection", {}, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    educationLoanService.getOtp = function() {
        var q = $q.defer();
        AdapterUtils.postData("adapters/OTPAdapter/getOTPTokenSecure", {}, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    educationLoanService.validateOtp = function(payLoad) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/OTPAdapter/validateOTPTokenSecure", payLoad, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    educationLoanService.viewtransaction = function() {
        var q = $q.defer();
        AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Education/viewEducationLoanTransactions", {}, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    educationLoanService.accountFilter = function() {
        var q = $q.defer();
        AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Education/getAccountFilter", {}, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    educationLoanService.dataPush = function(payLoad) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Education/pushLOSData", payLoad, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    educationLoanService.uploadDocument = function(payLoad) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Education/uploadDocument", payLoad, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    educationLoanService.getKnowMore = function(){
        return knowmore;
    }

    educationLoanService.setKnowMore = function(data){
        knowmore = data;
    }

    educationLoanService.getViewTransaction = function(){
        return viewTransaction;
    }

    educationLoanService.setViewTransaction = function(data){
        viewTransaction = data;
    }

    educationLoanService.getDataPush = function(){
        return dataPushData;
    }

    educationLoanService.setDataPush = function(data){
        dataPushData = data;
    }

    educationLoanService.getCurrentDemand = function(){
        return currentDemand;
    }

    educationLoanService.setCurrentDemand = function(data){
        currentDemand = data;
    }

    educationLoanService.getScanDoc = function(){
        return scanDoc;
    }

    educationLoanService.setScanDoc = function(data){
        scanDoc = data;
    }

	return educationLoanService;

}]);
