'use strict';
angularApp.controller('knowMoreController', [
		"$state",
		"$scope",
		"utilityService",
		"educationLoanService","sampoornSurakshaService","$filter","ompMerchantsService","homeScreenService","clickStreamService",
		function($state, $scope,utilityService,educationLoanService,sampoornSurakshaService,$filter,ompMerchantsService,homeScreenService,clickStreamService) {

			var knowMoreVm = this;

            function initPage(){
                knowMoreVm.poilcyFeatures = educationLoanService.getKnowMore();
                $scope.isiPhone = utilityService.isIOSPlatform();
                if(knowMoreVm.poilcyFeatures.accountSummary.accountflag == "true"){
                    knowMoreVm.isApplyNew = false;
                }else{
                    knowMoreVm.isApplyNew = true;
                }
                knowMoreVm.productType = knowMoreVm.poilcyFeatures.emiCalculator.emiCalcDetails[0];
                knowMoreVm.showCategory = knowMoreVm.poilcyFeatures.planFeatures[0];
                knowMoreVm.changeLoan();
                knowMoreVm.tenureSlider.value = knowMoreVm.maxTenure;
                knowMoreVm.emiCalculation();


            }

            knowMoreVm.setMax = function(field){
				if(field == "loan"){
					if(parseInt(knowMoreVm.amountSlider.value) > parseInt(knowMoreVm.maxLoan)){
						knowMoreVm.amountSlider.value = parseInt(knowMoreVm.maxLoan);
					}
                    if(parseInt(knowMoreVm.amountSlider.value) < parseInt(knowMoreVm.minLoan)){
						knowMoreVm.amountSlider.value = parseInt(knowMoreVm.minLoan);
					}
				}
                knowMoreVm.calculateInterestRate();
                knowMoreVm.emiCalculation();
            }

            knowMoreVm.setMin = function(field){
                if(field == "loan"){
                    if(parseInt(knowMoreVm.amountSlider.value) < parseInt(knowMoreVm.minLoan) || isNaN(parseInt(knowMoreVm.amountSlider.value)) || parseInt(knowMoreVm.amountSlider.value) == 0){
						knowMoreVm.amountSlider.value = parseInt(knowMoreVm.minLoan);
					}
                }
                knowMoreVm.emiCalculation();
            }

            knowMoreVm.goBacktoPrevious = function(){
                $state.go('menu.loans');
            }

            knowMoreVm.isGroupShown = function(group) {
                return knowMoreVm.shownGroup === group;
            };

            knowMoreVm.toggleGroup = function(group) {
                if (knowMoreVm.isGroupShown(group)) {
                    knowMoreVm.shownGroup = null;
                } else {
                    knowMoreVm.shownGroup = group;
                }
            };

            knowMoreVm.changeLoan = function(){
                for(var i=0 ; i < knowMoreVm.poilcyFeatures.emiCalculator.emiCalcDetails.length;i++){
                    if(knowMoreVm.productType.key == knowMoreVm.poilcyFeatures.emiCalculator.emiCalcDetails[i].key){
                        knowMoreVm.amountSlider = {
                            value: parseInt(knowMoreVm.poilcyFeatures.emiCalculator.emiCalcDetails[i].values[knowMoreVm.poilcyFeatures.emiCalculator.emiCalcDetails[i].values.length - 1].initialAmt),
                            options: {
                                showSelectionBar: true,
                                floor : parseInt(knowMoreVm.poilcyFeatures.emiCalculator.emiCalcDetails[i].values[0].minLoanAmt),
                                ceil : parseInt(knowMoreVm.poilcyFeatures.emiCalculator.emiCalcDetails[i].values[knowMoreVm.poilcyFeatures.emiCalculator.emiCalcDetails[i].values.length - 1].maxLoanAmt),
                                step : parseInt(knowMoreVm.poilcyFeatures.emiCalculator.loanAmountStep),
                                onChange : function(id,model){
                                    knowMoreVm.calculateInterestRate();
                                    knowMoreVm.emiCalculation();
                                },
                                translate : function(value){
                                    var rupeeSymbol = String.fromCharCode(8377);
                                    return rupeeSymbol + " " +$filter('INR')(value);
                                }
                            }
                        };

                        knowMoreVm.tenureSlider = {
                            value: parseInt(knowMoreVm.poilcyFeatures.emiCalculator.emiCalcDetails[i].values[knowMoreVm.poilcyFeatures.emiCalculator.emiCalcDetails[i].values.length - 1].minTenure),
                            options: {
                                showSelectionBar: true,
                                floor : parseInt(knowMoreVm.poilcyFeatures.emiCalculator.emiCalcDetails[i].values[0].minTenure),
                                ceil : parseInt(knowMoreVm.poilcyFeatures.emiCalculator.emiCalcDetails[i].values[knowMoreVm.poilcyFeatures.emiCalculator.emiCalcDetails[i].values.length - 1].maxTenure),
                                step : parseInt(knowMoreVm.poilcyFeatures.emiCalculator.loanTenureStep),
                                onChange : function(id,model){
                                    knowMoreVm.emiCalculation();
                                },
                                translate : function(value,id,label){
                                    if(label === 'ceil'){
                                        return  value + " yrs";
                                    }else if(label === 'floor'){
                                        return  value + " yr";
                                    }
                                }
                            }
                        };
                        knowMoreVm.interestRate = parseFloat(knowMoreVm.poilcyFeatures.emiCalculator.emiCalcDetails[i].values[knowMoreVm.poilcyFeatures.emiCalculator.emiCalcDetails[i].values.length - 1].intRate);
                        knowMoreVm.maxLoan = parseInt(knowMoreVm.poilcyFeatures.emiCalculator.emiCalcDetails[i].values[knowMoreVm.poilcyFeatures.emiCalculator.emiCalcDetails[i].values.length - 1].maxLoanAmt);
                        knowMoreVm.minLoan = parseInt(knowMoreVm.poilcyFeatures.emiCalculator.emiCalcDetails[i].values[0].minLoanAmt);
                        knowMoreVm.maxTenure = parseInt(knowMoreVm.poilcyFeatures.emiCalculator.emiCalcDetails[i].values[knowMoreVm.poilcyFeatures.emiCalculator.emiCalcDetails[i].values.length - 1].maxTenure);
                        knowMoreVm.minTenure = parseInt(knowMoreVm.poilcyFeatures.emiCalculator.emiCalcDetails[i].values[0].minTenure);
                        knowMoreVm.tenureSlider.value = knowMoreVm.maxTenure;
                        knowMoreVm.emiCalculation();
                    }
                }
            }


            knowMoreVm.redirectPopUp = function(){
				educationLoanService.displayPopUp("You will be redirected to Vidya-Lakshmi portal now","Please keep your documents ready for application","",["Cancel","OK"],function(){
                     clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "APPLY_NOW_CANCL_BTN"));
				},function(){
                    educationLoanService.getRedirection().then(function(data) {
                         clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "APPLY_NOW_OK_BTN"));
                         if(utilityService.isAndroidPlatform()){
                            ompMerchantsService.inChromeBrowser(data.url);
                        }else{
                            ompMerchantsService.inAppBrowser(data.url);
                        }
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
				});
			}

            knowMoreVm.viewSummary = function(){
                if(parseInt(knowMoreVm.poilcyFeatures.accountSummary.sanctionedAmount) == 0){
                     utilityService.showErrorMessage("Your education loan is not sanctioned");
                }else{
                    $state.go('menu.eduSummary');
                }
            }

            knowMoreVm.calculateInterestRate = function(){
                for(var i=0 ; i < knowMoreVm.poilcyFeatures.emiCalculator.emiCalcDetails.length;i++){
                    if(knowMoreVm.productType.key == knowMoreVm.poilcyFeatures.emiCalculator.emiCalcDetails[i].key){
                        for(var j=0 ; j<knowMoreVm.poilcyFeatures.emiCalculator.emiCalcDetails[i].values.length ; j++){
                            if(knowMoreVm.poilcyFeatures.emiCalculator.emiCalcDetails[i].values[j].minLoanAmt <= knowMoreVm.amountSlider.value  && knowMoreVm.poilcyFeatures.emiCalculator.emiCalcDetails[i].values[j].maxLoanAmt >= knowMoreVm.amountSlider.value){
                                knowMoreVm.interestRate = knowMoreVm.poilcyFeatures.emiCalculator.emiCalcDetails[i].values[j].intRate;
                                break;
                            }
                        }
                    }
                }
            }

            knowMoreVm.emiCalculation = function(){
                var p = knowMoreVm.amountSlider.value;
                var r = knowMoreVm.interestRate/(1200);
                var n = knowMoreVm.tenureSlider.value*12;
                var numerator = p * r * Math.pow((1+r),n);
				var denominator = Math.pow((1+r),n) - 1;
				knowMoreVm.emiAmount =  Math.ceil((numerator/denominator));
            };

			$scope.$on('$ionicView.beforeEnter', function() {
				// knowMoreVm.isBackCheck = homeScreenService.isBackCheck;
				// homeScreenService.isBackCheck	=false;
				initPage();
			});

			return this;
		}


]);
