'use strict';

angularApp.controller('flpcLandingController', ["$state", "$scope","$ionicPopup", "$translate", "$ionicHistory", "flpcLandingService","$ionicSideMenuDelegate","utilityService",
    function($state, $scope,$ionicPopup,$translate,$ionicHistory, flpcLandingService, $ionicSideMenuDelegate, utilityService) {

        var flpclandingVm = this;

        function initPage() {
            flpclandingVm.flpcProductData();
        }

        flpclandingVm.flpcProductData = function() {
            flpcLandingService.getFlpcData('').then(function(data) {
              
                flpclandingVm.featuresJson = data;
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        };

        flpclandingVm.goBacktoPrevious = function() {
            // $state.go('menu.loans');
            $ionicHistory.goBack(-1);
        };

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });
		
		//one time initialization to be done when the controller is loaded
		$scope.$on('$ionicView.loaded', function() {
			$ionicSideMenuDelegate.canDragContent(false)
		});
		
		//actions to done everytime the view is shown
		$scope.$on('$ionicView.beforeEnter', function() {
			$ionicSideMenuDelegate.canDragContent(false);
		});
		
		//any cleanup needs to be done here: executes everytime when page is left
		$scope.$on('$ionicView.afterLeave', function() {
			$ionicSideMenuDelegate.canDragContent(false)
		});
	
        return this;
    }
]);
