'use strict';

angularApp.controller('glAdditionalDetailsRLMSController', [
    "$state",
    "$scope",
    "$translate",  
    "$ionicSideMenuDelegate", "goldLoanRLMSService", "$ionicPopover", "$ionicPopup", "utilityService",
    "currentLocationService",

    function($state,
        $scope,
        $translate,        
        $ionicSideMenuDelegate, goldLoanRLMSService, $ionicPopover, $ionicPopup, utilityService,
        currentLocationService) {

        var glAdditionalDetailsVm = this;

        function initPage() {
            glAdditionalDetailsVm.totalEMIs = [];
            glAdditionalDetailsVm.totalEMICost = null;
            // glAdditionalDetailsVm.accountDetails = [{"accountBalance":"100000.00","accountCategory":"D","accountDescription":"CA-GEN-PUB IND-CSA REIMB-INR","accountNumber":"XXXXXXX6136","accountType":"Current","accountTypeCode":"5011","branchCode":"00437","branchName":"TREASURY BRANCH NASIK","currency":"INR","intCategory":"1511","modFlag":"false","nriFlag":"D","operational":"OWN","status":"OPEN","tenure":""},{"accountBalance":"100000.00","accountCategory":"D","accountDescription":"SBCHQ-GEN-PUB IND-NONRURAL-INR","accountNumber":"XXXXXXX6125","accountType":"Savings","accountTypeCode":"1011","branchCode":"00437","branchName":"TREASURY BRANCH NASIK","currency":"INR","intCategory":"1101","modFlag":"true","nriFlag":"D","operational":"OWN","status":"OPEN","tenure":""}];
            
            glAdditionalDetailsVm.accountDetails = goldLoanRLMSService.getAdditionDetailData().accountList;
            glAdditionalDetailsVm.sbiLoanEMI = parseInt(goldLoanRLMSService.getAdditionDetailData().totalSbiEmi);

            if(goldLoanRLMSService.resumeData) {
                glAdditionalDetailsVm.masterData = angular.copy(goldLoanRLMSService.resumeData);
                if(!glAdditionalDetailsVm.branchName) {
                    glAdditionalDetailsVm.branchName = glAdditionalDetailsVm.accountDetails[0].branchName;
                    glAdditionalDetailsVm.accountType = glAdditionalDetailsVm.accountDetails[0].accountType;
                    glAdditionalDetailsVm.accountNumber = glAdditionalDetailsVm.accountDetails[0].accountNumber;
                    glAdditionalDetailsVm.branchCode = glAdditionalDetailsVm.accountDetails[0].branchCode;
                }
            } else {
                glAdditionalDetailsVm.masterData = angular.copy(goldLoanRLMSService.userMaster);
                glAdditionalDetailsVm.branchName = glAdditionalDetailsVm.accountDetails[0].branchName;
                glAdditionalDetailsVm.accountType = glAdditionalDetailsVm.accountDetails[0].accountType;
                glAdditionalDetailsVm.accountNumber = glAdditionalDetailsVm.accountDetails[0].accountNumber;
                glAdditionalDetailsVm.branchCode = glAdditionalDetailsVm.accountDetails[0].branchCode;
            }

            // glAdditionalDetailsVm.loanPurposeList = glAdditionalDetailsVm.masterData.master.loanPurposes;
            // glAdditionalDetailsVm.eduQualifyList = glAdditionalDetailsVm.masterData.master.educations;
            // glAdditionalDetailsVm.residTypeList = glAdditionalDetailsVm.masterData.master.residentialTypes;
            // glAdditionalDetailsVm.maritalStatusList = glAdditionalDetailsVm.masterData.master.maritalStatuses;
            glAdditionalDetailsVm.emiTypes = glAdditionalDetailsVm.masterData.master.emiTypes;
            

            if(goldLoanRLMSService.getBasicDetailData().additionalDetail) {             
                glAdditionalDetailsVm.branchName = goldLoanRLMSService.getBasicDetailData().additionalDetail.selectAccountBranchName;
                glAdditionalDetailsVm.accountType = goldLoanRLMSService.getBasicDetailData().additionalDetail.selectedAccountType;
                glAdditionalDetailsVm.accountNumber = goldLoanRLMSService.getBasicDetailData().additionalDetail.selectedAccountNumber;
                glAdditionalDetailsVm.branchCode = goldLoanRLMSService.getBasicDetailData().additionalDetail.selectedAccountBranchCode;
                // glAdditionalDetailsVm.loanPurpose = JSON.parse(goldLoanRLMSService.getBasicDetailData().additionalDetail.loanPurposeValue);
                // glAdditionalDetailsVm.eduQualify = JSON.parse(goldLoanRLMSService.getBasicDetailData().additionalDetail.educationValue);
                // glAdditionalDetailsVm.residType = JSON.parse(goldLoanRLMSService.getBasicDetailData().additionalDetail.residentialTypeValue);
                // glAdditionalDetailsVm.maritalStatus = JSON.parse(goldLoanRLMSService.getBasicDetailData().additionalDetail.maritalStatusValue);
                // glAdditionalDetailsVm.monthlyIncome = goldLoanRLMSService.getBasicDetailData().additionalDetail.netMonthlyIncome;
                if(goldLoanRLMSService.getBasicDetailData().additionalDetail.existingEmi){
                    glAdditionalDetailsVm.totalEMIs = goldLoanRLMSService.getBasicDetailData().additionalDetail.existingEmi;
                }else{
                    glAdditionalDetailsVm.totalEMICost = glAdditionalDetailsVm.sbiLoanEMI;
                }
                
                if(glAdditionalDetailsVm.totalEMIs.length > 0) {
                    for(var i=0; i < glAdditionalDetailsVm.totalEMIs.length; i++) {
                        if(glAdditionalDetailsVm.totalEMIs[i].typeValue.value){                       
                            glAdditionalDetailsVm.totalEMIs[i].typeValue = glAdditionalDetailsVm.totalEMIs[i].typeValue;
                        }else{
                            glAdditionalDetailsVm.totalEMIs[i].typeValue = JSON.parse(glAdditionalDetailsVm.totalEMIs[i].typeValue);
                        } 
                    } 
                }
            }
            
            glAdditionalDetailsVm.calculateEMIs();
           
        };


        glAdditionalDetailsVm.addEMI = function(){
            glAdditionalDetailsVm.emi = {                    
                    "type" : "",
                    "typeValue" : "",
                    "amount" : ""
                };   
            glAdditionalDetailsVm.totalEMIs.push(glAdditionalDetailsVm.emi);           
        }

        glAdditionalDetailsVm.calculateEMIs = function(){
            glAdditionalDetailsVm.totalEMICost = 0;
            for(var i = 0; i< glAdditionalDetailsVm.totalEMIs.length;i++) {
                if(glAdditionalDetailsVm.totalEMIs[i].amount) {
                    glAdditionalDetailsVm.totalEMICost = parseInt(glAdditionalDetailsVm.totalEMICost) + parseInt(glAdditionalDetailsVm.totalEMIs[i].amount); 
                }
            }

            if(glAdditionalDetailsVm.sbiLoanEMI) {
               glAdditionalDetailsVm.totalEMICost = parseInt(glAdditionalDetailsVm.sbiLoanEMI) + parseInt(glAdditionalDetailsVm.totalEMICost);  
            }                
         }

        glAdditionalDetailsVm.deleteEMI = function(emiIndex){
            glAdditionalDetailsVm.totalEMIs.splice(emiIndex,1);
            glAdditionalDetailsVm.calculateEMIs();
        }

        glAdditionalDetailsVm.openInfo = function ($event) {
            glAdditionalDetailsVm.leftStyle = "left : " + ($event.clientX - 30) + "px";           
            glAdditionalDetailsVm.template = '<ion-popover-view class="loginnewarrow hmbr-info gl-info-popnew gl-emi-info nfs-popover-height" id="runtimeHeight" >' + '<div class="edu-arrow-downnew" style="{{glAdditionalDetailsVm.leftStyle}}"></div>' + 
            '<a class="iconsubtext closeinfobutton float-right" id="CALL_ANC" click-stream="click" ng-click="glAdditionalDetailsVm.closePopover()">' + '<i class="ico-close ver-align-middle"></i>' + '</a>' + '<ion-content class="col-90  nfs-popover" has-bouncing="false">' +
            '<div id="renderHeight" class="text-left padding-left-10 padding-right-10 font-size-12">'+
            '<div>For overdraft loans, EMI amount is calculated as notional interest amount on total sanctioned overdraft limit.</div>' + 
            '</div>' + '</ion-content>' + '</ion-popover-view>';
            $scope.popover = $ionicPopover.fromTemplate(glAdditionalDetailsVm.template, {
                scope: $scope
            });
            $scope.popover.show($event);
               
        }

        glAdditionalDetailsVm.closePopover = function(){
            $scope.popover.hide();
        }       

        glAdditionalDetailsVm.showPop = function () {
            if(glAdditionalDetailsVm.accountDetails.length > 0) {
            var templateUrl = '<div class="font-dark-grey irctc">'+'<div>'+
                '<div class="row borderbtm" ng-repeat="item in glAdditionalDetailsVm.accountDetails track by $index" ng-click="glAdditionalDetailsVm.close($index)">'+
                '<div class="col col-60 padTop15 font-size-12 roboto-regular color545454 ncmc-txt-left">{{item.branchName}} - {{item.branchCode}}</div>'+
                '<div class="col col-40"><div class="font-size-12 roboto-regular color545454 text-align-right" ng-bind="item.accountType"></div>'+
                '<div class="font-size-14 roboto-medium color545454" ng-bind="item.accountNumber"></div></div></div></div></div>';

                glAdditionalDetailsVm.popUp = $ionicPopup.show({
                    title: '',
                    cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
                    template : templateUrl,
                    scope: $scope
                  });
            }
        }


        glAdditionalDetailsVm.close = function(index){
            glAdditionalDetailsVm.popUp.close();
            glAdditionalDetailsVm.branchName = glAdditionalDetailsVm.accountDetails[index].branchName;
            glAdditionalDetailsVm.accountType = glAdditionalDetailsVm.accountDetails[index].accountType;
            glAdditionalDetailsVm.accountNumber = glAdditionalDetailsVm.accountDetails[index].accountNumber;
            glAdditionalDetailsVm.branchCode = glAdditionalDetailsVm.accountDetails[index].branchCode;
        }

        glAdditionalDetailsVm.validateForm = function(){
            glAdditionalDetailsVm.errObj = {};
           
            if(goldLoanRLMSService.schemeEMI){
                goldLoanRLMSService.schemeEMI = parseFloat(goldLoanRLMSService.schemeEMI);
            }else{
                goldLoanRLMSService.schemeEMI = 0;
            }
            if(glAdditionalDetailsVm.totalEMICost){
                glAdditionalDetailsVm.totalEMICost = parseFloat(glAdditionalDetailsVm.totalEMICost);
            }else{
                glAdditionalDetailsVm.totalEMICost = 0;
            }



            // if(parseFloat(goldLoanRLMSService.monthlyIncome) > 0) {
            //     if(parseFloat(goldLoanRLMSService.monthlyIncome) <= parseFloat(parseFloat(goldLoanRLMSService.schemeEMI) + parseFloat(glAdditionalDetailsVm.totalEMICost))) {
            //         if(glAdditionalDetailsVm.totalEMICost < 1){
            //             /*glAdditionalDetailsVm.errObj.monthlyIncomeError = "Total EMI cannot exceed ₹" + goldLoanRLMSService.monthlyIncome;*/
            //             glAdditionalDetailsVm.errObj.monthlyIncomeError ="Total EMI (including EMI for the current Gold Loan application) exceeds your Net Monthly Income."
                        
            //         }else{
            //             /*glAdditionalDetailsVm.errObj.nmiEMIError = "Total EMI cannot exceed ₹" + goldLoanRLMSService.monthlyIncome;*/
            //             glAdditionalDetailsVm.errObj.nmiEMIError = glAdditionalDetailsVm.errObj.monthlyIncomeError ="Total EMI (including EMI for the current Gold Loan application) exceeds your Net Monthly Income."
            //         }                    
            //     }
            // }

            if(parseFloat(goldLoanRLMSService.monthlyIncome) > 0) {
                if(goldLoanRLMSService.schemeEMI){
                    if(parseFloat(goldLoanRLMSService.monthlyIncome) <= parseFloat(parseFloat(goldLoanRLMSService.schemeEMI) + parseFloat(glAdditionalDetailsVm.totalEMICost))) {
                        glAdditionalDetailsVm.errObj.nmiEMIError ="Total EMI (including EMI for the current Gold Loan application) exceeds your Net Monthly Income.";
                    }                    
                }
            }

            if(glAdditionalDetailsVm.totalEMIs.length > 0) {
                for(var i = 0; i< glAdditionalDetailsVm.totalEMIs.length;i++) {                          
                    var obj = {};
                    obj.typeValue = glAdditionalDetailsVm.totalEMIs[i].typeValue.value;
                    // obj.typeValue = JSON.stringify(glAdditionalDetailsVm.totalEMIs[i].type);
                    obj.amount = glAdditionalDetailsVm.totalEMIs[i].amount;

                    if(goldLoanRLMSService.isValidField(obj.typeValue,"Loan Type")) {
                        glAdditionalDetailsVm.totalEMIs[i].loanTypeErr = goldLoanRLMSService.isValidFieldEMI(obj.typeValue,"loanType");
                        glAdditionalDetailsVm.errObj.loanTypeErr = glAdditionalDetailsVm.totalEMIs[i].loanTypeErr;
                    }else{
                        glAdditionalDetailsVm.totalEMIs[i].loanTypeErr = "";
                    }

                    if(goldLoanRLMSService.isValidField(obj.amount,"amount")) {
                        glAdditionalDetailsVm.totalEMIs[i].amountErr = goldLoanRLMSService.isValidFieldEMI(obj.amount,"amount");
                        glAdditionalDetailsVm.errObj.amountErr = glAdditionalDetailsVm.totalEMIs[i].amountErr;
                    }else if(obj.amount <= 0){
                        glAdditionalDetailsVm.totalEMIs[i].amountErr = "Please provide valid amount";
                        glAdditionalDetailsVm.errObj.amountErr = glAdditionalDetailsVm.totalEMIs[i].amountErr;
                    }else{
                        glAdditionalDetailsVm.totalEMIs[i].amountErr = "";
                    }
                }
            }

            return (angular.equals({}, glAdditionalDetailsVm.errObj)) ? true : false;
        }
      

        glAdditionalDetailsVm.findBranches = function() {
            var totalAddedEMIs = [];
            utilityService.showSpinner();
                currentLocationService.getCurrentPosition().then(
                    function (position) {
                        utilityService.hideSpinner();
                        goldLoanRLMSService.geocoords = position.coords.latitude + "," + position.coords.longitude;
                        var latitude = position.coords.latitude;
                        var longitude = position.coords.longitude;
                        goldLoanRLMSService.locateBranches.length = 0;

                        for(var i=0; i < glAdditionalDetailsVm.totalEMIs.length; i++) {
                            var addEMI = {
                                "type" :  glAdditionalDetailsVm.totalEMIs[i].typeValue ? glAdditionalDetailsVm.totalEMIs[i].typeValue.key : "",
                                "typeValue" : glAdditionalDetailsVm.totalEMIs[i].typeValue ? JSON.stringify(glAdditionalDetailsVm.totalEMIs[i].typeValue) : "",
                                "amount" : glAdditionalDetailsVm.totalEMIs[i].amount ? glAdditionalDetailsVm.totalEMIs[i].amount : ""
                            };

                            totalAddedEMIs.push(addEMI);
                        }

                         var saveRequest = {
                            "lat" : latitude.toString(),
                            "lng" : longitude.toString(),
                            "additionalDetail": {

                                "selectedAccountType" : glAdditionalDetailsVm.accountType ? glAdditionalDetailsVm.accountType : "",
                                "selectedAccountNumber" : glAdditionalDetailsVm.accountNumber ? glAdditionalDetailsVm.accountNumber : "",
                                "selectAccountBranchName" : glAdditionalDetailsVm.branchName ? glAdditionalDetailsVm.branchName : "",
                                "selectedAccountBranchCode" : glAdditionalDetailsVm.branchCode ? glAdditionalDetailsVm.branchCode : "",
                                "existingEmi" : totalAddedEMIs.length > 0  ? totalAddedEMIs : null
                            }
                        }

                 
                       if (utilityService.isUndefined(goldLoanRLMSService.locateBranches) || goldLoanRLMSService.locateBranches.length === 0) {
                            //service call
                            goldLoanRLMSService.getBranchDetail(saveRequest).then(function (data) {
                                goldLoanRLMSService.getBasicDetailData().additionalDetail = saveRequest.additionalDetail;
                                if (!utilityService.isUndefined(data)) {
                                    goldLoanRLMSService.locateBranches = [];
                                    for (var i = 0; i < data.branchLists.length; i++) {
                                        goldLoanRLMSService.locateBranches.push(data.branchLists[i]);                                        
                                    }
                                    $state.go('menu.glSelectBranchRLMS');
                                    goldLoanRLMSService.selectedBranch = "";
                                    
                                }
                            }, function (error) {
                                utilityService.showErrorMessage(error.responseMessage);                                    
                            });
                        } 
                        
                    },function (err) {
                        //Location permission off
                        utilityService.hideSpinner();
                        

                            for(var i=0; i < glAdditionalDetailsVm.totalEMIs.length; i++) {
                                var addEMI = {
                                    "type" :  glAdditionalDetailsVm.totalEMIs[i].typeValue ? glAdditionalDetailsVm.totalEMIs[i].typeValue.key : "",
                                    "typeValue" : glAdditionalDetailsVm.totalEMIs[i].typeValue ? JSON.stringify(glAdditionalDetailsVm.totalEMIs[i].typeValue) : "",
                                    "amount" : glAdditionalDetailsVm.totalEMIs[i].amount ? glAdditionalDetailsVm.totalEMIs[i].amount : ""
                                };

                                totalAddedEMIs.push(addEMI);
                            }

                        var saveRequest = {
                            "lat" : "",
                            "lng" : "",
                            "additionalDetail": {

                                "selectedAccountType" : glAdditionalDetailsVm.accountType ? glAdditionalDetailsVm.accountType : "",
                                "selectedAccountNumber" : glAdditionalDetailsVm.accountNumber ? glAdditionalDetailsVm.accountNumber : "",
                                "selectAccountBranchName" : glAdditionalDetailsVm.branchName ? glAdditionalDetailsVm.branchName : "",
                                "selectedAccountBranchCode" : glAdditionalDetailsVm.branchCode ? glAdditionalDetailsVm.branchCode : "",
                                "existingEmi" : totalAddedEMIs.length > 0  ? totalAddedEMIs : null
                            }
                        }                            //service call
                    goldLoanRLMSService.getBranchDetail(saveRequest).then(function (data) {
                        goldLoanRLMSService.getBasicDetailData().additionalDetail = saveRequest.additionalDetail;                  
                        goldLoanRLMSService.locateBranches = [];
                        goldLoanRLMSService.selectedBranch = "";
                        goldLoanRLMSService.onlyGoldBranches = true;
                        $state.go('menu.glGPSErrorRLMS'); 
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);                                    
                    });
                 
            });       
        }

        glAdditionalDetailsVm.goBack = function() {
            $state.go('menu.glLoanDetailsRLMS');
        };

        glAdditionalDetailsVm.goToNextPage = function() {
            if(glAdditionalDetailsVm.validateForm()) {
                goldLoanRLMSService.selectedAccount = {
                    "selectedAccountNumber" : glAdditionalDetailsVm.accountNumber ? glAdditionalDetailsVm.accountNumber : "",
                    "selectedAccountBranchName" : glAdditionalDetailsVm.branchName ? glAdditionalDetailsVm.branchName : "",
                    "selectedAccountBranchCode" : glAdditionalDetailsVm.branchCode ? glAdditionalDetailsVm.branchCode : "",
                };   
                glAdditionalDetailsVm.findBranches();               
            }           
        };

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        return this;
    }
]);