'use strict';

angularApp.controller('glApplicationStatusRLMSController', [
    "$state",
    "$scope",
    "$translate",  
    "$ionicSideMenuDelegate",
    "$filter", "goldLoanRLMSService", "$ionicPopup", "utilityService", "$ionicHistory",

    function($state,
        $scope,
        $translate,        
        $ionicSideMenuDelegate,
        $filter, goldLoanRLMSService, $ionicPopup, utilityService, $ionicHistory) {

        var glApplicationStatusVm = this;
       

        function initPage() {
            glApplicationStatusVm.currApplicationStatus = [];
            if(goldLoanRLMSService.getYonoDedupeData()){
                glApplicationStatusVm.refNo = goldLoanRLMSService.getYonoDedupeData().yonoRef;
            }

            if (goldLoanRLMSService.getYonoDedupeData().status == '1') {
                glApplicationStatusVm.isResumeApp = true;
            }else if (goldLoanRLMSService.getYonoDedupeData().status == '2') {
                // glApplicationStatusVm.statusCode = 3;
                // glApplicationStatusVm.rlmsStatusCode = 'PDOC';
                // glApplicationStatusVm.status = "Application Sanctioned";
                if(goldLoanRLMSService.retrieveData) {
                    glApplicationStatusVm.currApplicationStatus = goldLoanRLMSService.retrieveData.currApplicationStatus;
                    for(var i=0;i < glApplicationStatusVm.currApplicationStatus.length; i++) {
                        if(glApplicationStatusVm.currApplicationStatus[i].statusCode == '2') {
                            glApplicationStatusVm.statusCode = 2;
                            glApplicationStatusVm.status = glApplicationStatusVm.currApplicationStatus[i].statusDescription;
                            glApplicationStatusVm.rlmsStatusCode = glApplicationStatusVm.currApplicationStatus[i].rlmsStatusCode;
                        }else if(glApplicationStatusVm.currApplicationStatus[i].statusCode == '3') {
                            glApplicationStatusVm.statusCode = 3;
                            glApplicationStatusVm.status = glApplicationStatusVm.currApplicationStatus[i].statusDescription;
                            glApplicationStatusVm.rlmsStatusCode = glApplicationStatusVm.currApplicationStatus[i].rlmsStatusCode;
                        }
                    }
                }
            }          
        };

        glApplicationStatusVm.resumeApp = function() {
            $state.go('menu.glPersonalDetailsRLMS');
        }

        glApplicationStatusVm.goBack = function() {
            $ionicHistory.goBack(-1);
        }

        glApplicationStatusVm.goToLoans = function() {
            $state.go('menu.loans');
        }

        glApplicationStatusVm.applyNewloan = function() {
            $state.go('menu.loans');
        }

        glApplicationStatusVm.applyNew = function() {        
            var backPopup = $ionicPopup.alert({
                    cssClass: 'bhim-alert-popup',
                    template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src="img/FT/BhimUpi/alertSymbol.svg"/></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div>'+
                              '<div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter roboto-medium font-size-16 color-darkgrey"><span>Are you sure you want to apply for a new loan?</span><div class="textAlignCenter roboto-regular font-size-14 color-darkgrey">This will delete your current loan application.</div></div></div></div>',
                    buttons: [{
                        text: 'Cancel',
                        type: 'button-negative',
                        onTap: function () {
                            backPopup.close();
                        }
                    },
                    {
                        text: 'Proceed',
                        type: 'button-positive',
                        onTap: function () {
                            
                            //service call for reject
                            var request = {
                                "loanType" : goldLoanRLMSService.getGroupId()
                            };
                            goldLoanRLMSService.deleteApplication(request).then(function(data) {
                                goldLoanRLMSService.clearAll();
                                goldLoanRLMSService.resumeData = false;
                                goldLoanRLMSService.retrieveData = false;
                                goldLoanRLMSService.personalDetailCheck = false;
                                $state.go('menu.loans');
                                // var alertPopup = $ionicPopup.alert({
                                //     template: "<p style='text-align:center;font-weight:bold;font-size:16px'>All your pending applications have been deleted.</p>"
                                // });
                                goldLoanRLMSService.showAlertPopup("","All your pending applications have been deleted.","",
                                                "menu.loans","OK","","","");                             
                            },function(error){
                                utilityService.showErrorMessage(error.responseMessage);
                            });
                            
                            backPopup.close();
                            $state.go('menu.loans');
                        }
                    }],
                });
           
        }



        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        return this;
    }
]);