'use strict';

angularApp.controller('glBranchesNearRLMSController', [
    "$state",
    "$scope",
    "$translate",  
    "$ionicSideMenuDelegate",
    "$filter", "goldLoanRLMSService","$ionicPopover","$ionicPopup","utilityService",
    "$ionicScrollDelegate","currentLocationService",

    function($state,
        $scope,
        $translate,        
        $ionicSideMenuDelegate,
        $filter, goldLoanRLMSService, $ionicPopover, $ionicPopup,utilityService,
        $ionicScrollDelegate,currentLocationService) {

        var glBranchesNearVm = this;

        function initPage() {
            glBranchesNearVm.branches = [];
            glBranchesNearVm.enableGoldPoint = false;
            glBranchesNearVm.branchError = "";
            
            if(!goldLoanRLMSService.selectedBranch) {
                glBranchesNearVm.selectedIndexLocation = 100000;
            }

            glBranchesNearVm.branches = angular.copy(goldLoanRLMSService.locateByGPS);
            // glBranchesNearVm.branches = [{"branchName":"BELPAUR BHAVAN SEC 3 BELAPUR","address":"PB NO 11 BELAPUR BHAVAN,SECTOR 11 OFFICE NO 3,CBD BELAPUR, NAVIMUMBAI400614","pincode":"400614","phoneNumber":"27574506","city":"MUMBAI","state":"MAHARASHTRA","id":"40524","latitude":"19.0197419","longitude":"73.0420058","goldPoint":"N"},{"branchName":"VICHUMBE","address":"GROUND FLOOR GAT NO.173, AT+PO,VICHUMBE, TAL PANVEL,RAIGAD","pincode":"410206","phoneNumber":"205061 / 67","city":"MUMBAI","state":"MAHARASHTRA","id":"71073","latitude":"19.0186613","longitude":"73.0402563","goldPoint":"N"},{"branchName":"MONARCH PLAZA BR. BELAPUR","address":"SHOP NO. 12 & 13,MONARCH PLAZA,,PLOT NO. 56, SECTOR NO. 11, CBD BELAPUR,NAVI MUMBAI","pincode":"400614","phoneNumber":"27565673","city":"MUMBAI","state":"MAHARASHTRA","id":"32190","latitude":"19.014951","longitude":"73.0391501","goldPoint":"Y"},{"branchName":"KONKAN BHAVAN (NAVI MUMBAI)","address":"CIDCO BLDG.(SOUTH WING), CBD BELAPUR,NAVI MUMBAI,,DIST:THANE, MAHARASHTRA","pincode":"400614","phoneNumber":"27571030","city":"MUMBAI","state":"MAHARASHTRA","id":"06240","latitude":"19.0227936","longitude":"73.0389251","goldPoint":"N"},{"branchName":"CBD BELAPUR","address":"WARDEN HOUSE,PLOT NO 65 SECTOR-11,CBD BELAPUR NAVI MUMBAI","pincode":"400614","phoneNumber":"27578582","city":"MUMBAI","state":"MAHARASHTRA","id":"13551","latitude":"19.0144044","longitude":"73.0387685","goldPoint":"N"},{"branchName":"SECTOR -15 BELAPUR","address":"SHOP NO 15 LORDS , PLOT NO 35-35 A,SECTOR-15, BELAPUR,NAVI MUMBAI","pincode":"400614","phoneNumber":"27575332","city":"MUMBAI","state":"MAHARASHTRA","id":"16414","latitude":"19.0098613","longitude":"73.0304847","goldPoint":"Y"},{"branchName":"NMMC BRANCH BELAPUR","address":"NMMC HEAD QUARTER,PALM BEACH JUNCTION SECTOR 15A,CBD BELAPUR, NAVI MUMBAI","pincode":"400614","phoneNumber":"27571511","city":"MUMBAI","state":"MAHARASHTRA","id":"41078","latitude":"19.01054","longitude":"73.02781","goldPoint":"N"},{"branchName":"RUPEREL GARDENS SEC23 NERUL","address":"PLOT NO C-3, RUPAREL GARDENS,SECTOR 23, NERUL,NAVI MUMBAI","pincode":"400706","phoneNumber":"27702228","city":"MUMBAI","state":"MAHARASHTRA","id":"70692","latitude":"19.0253627","longitude":"73.0208083","goldPoint":"Y"},{"branchName":"SEAWOOD MUMBAI","address":"LAXMI CHS SHOP NO.8 TO 10,PLOT NO.7 SECTOR 42,SEAWOOD, OPP RLY STATION, NAVI MUMBAI","pincode":"400706","phoneNumber":"27724209","city":"MUMBAI","state":"MAHARASHTRA","id":"10725","latitude":"19.0210964","longitude":"73.0185717","goldPoint":"Y"},{"branchName":"NERUL EAST (NAVI MUMBAI)","address":"KRISHNA KAMAL CHS, UNIT-5/6&7,PLOT NO. 111 ,SECT0R-23,NERUL EAST,NAVI MUMBAI","pincode":"400706","phoneNumber":"27717040","city":"MUMBAI","state":"MAHARASHTRA","id":"11785","latitude":"19.0305454","longitude":"73.0186053","goldPoint":"N"},{"branchName":"PER. BKG. SECTOR 4 KHARGAR","address":"PLOT NO 28, SHOP NO 6 TO 9 ,BHOOMI TOWE,SECTOR 04, KHARGHAR,NAVI MUMBAI , DIST.RAIGARH","pincode":"410210","phoneNumber":"27742530","city":"MUMBAI","state":"MAHARASHTRA","id":"50878","latitude":"19.0344855","longitude":"73.0640462","goldPoint":"Y"},{"branchName":"KHARGHAR (SECTOR-8)","address":"SHOP NO. 1, 2, 3 &4, BHOOMI HEIGHTS,PLOT NO 5 & 6, SECTOR 8,KHARGHAR,NAVI MUMBAI","pincode":"410210","phoneNumber":"27746003","city":"MUMBAI","state":"MAHARASHTRA","id":"12841","latitude":"19.032213","longitude":"73.0670902","goldPoint":"Y"},{"branchName":"NERUL(WEST)","address":"MANGALMURTI, PLOT NO. A-29/30/31 AND 50,SECTOR-20, OPP NERUL RAILWAY STATION,NERUL (WEST), NAVI MUMBAI","pincode":"400706","phoneNumber":"27715749","city":"MUMBAI","state":"MAHARASHTRA","id":"05087","latitude":"19.0337389","longitude":"73.0170173","goldPoint":"Y"},{"branchName":"NRI SEAWOODS BRANCH (NAVI MUMBAI)","address":"SHOP NO 1&2 GROUND FLOOR,GAHLOT MAJESTY,PALM BEACH ROAD, SEAWOODS, PLOT NO 3A,SEC 46 A NERUL(W) NAVI MUMBAI DIST:THAN","pincode":"400706","phoneNumber":"27709083,84","city":"MUMBAI","state":"MAHARASHTRA","id":"16215","latitude":"19.010233","longitude":"73.0122347","goldPoint":"N"},{"branchName":"SECTOR 12 KHARGHAR","address":"SHOP NOS. 20 & 21, GROUND FLOOR AND 21,22 ON IST FLOOR, RAHUL APTMENT COOP HSG,STY, PLOT NO.E-125, KHARGHAR NAVI MUMBA","pincode":"410210","phoneNumber":"27744913","city":"MUMBAI","state":"MAHARASHTRA","id":"17265","latitude":"19.039065","longitude":"73.0667268","goldPoint":"N"},{"branchName":"CENT PARK RD SEC 12 KHARGHAR","address":"SHOP NO. 1-5, GYANESHWARI APT.,NEW SATARA CHSL,SECTOR 12, KHARGHAR, NAVI MUMBAI","pincode":"410210","phoneNumber":"27743459","city":"MUMBAI","state":"MAHARASHTRA","id":"70792","latitude":"19.0443637","longitude":"73.0642277","goldPoint":"N"},{"branchName":"KHARGHAR SECTOR 10","address":"SHOP NO 186 & 187, DHRUV HEIGHTS,,SECTOR - 10, KOPRA, KHARGHAR,,NAVI MUMBAI","pincode":"410210","phoneNumber":"7738161658","city":"MUMBAI","state":"MAHARASHTRA","id":"18648","latitude":"19.0333067","longitude":"73.0737236","goldPoint":"N"},{"branchName":"GAONDEVI MANDIR SEC20 NERUL","address":"KALASH SANKALP CHS,,PLOT C-3-4, SECTOR 20, NEAR GAON,DEVI MANDIR, NERUL, NAVI MUMBAI 400706","pincode":"400706","phoneNumber":"27722396","city":"MUMBAI","state":"MAHARASHTRA","id":"40585","latitude":"19.0370296","longitude":"73.0130971","goldPoint":"Y"},{"branchName":"PALM BEACH ROAD","address":"FF1 AND FF2,NEIGHBOURHOOD SHOPPING COMPLEX,SEC. 4, NERUL, NAVI MUMBAI","pincode":"400706","phoneNumber":"27713701","city":"MUMBAI","state":"MAHARASHTRA","id":"05088","latitude":"19.0440521","longitude":"73.0118256","goldPoint":"N"},{"branchName":"KHARGHAR NAVI MUMBAI","address":"CHATURBHUJ COOP HSG SOC LTD,PLOT NO 61&62, SECTOR-21 KHARGHAR,NAVI MUMBAI MAHARASHTRA","pincode":"410210","phoneNumber":"741406","city":"MUMBAI","state":"MAHARASHTRA","id":"11673","latitude":"19.0476646","longitude":"73.0696788","goldPoint":"N"}]; 
        };

        glBranchesNearVm.showGoldPointOnly = function () {
            glBranchesNearVm.enableGoldPoint != glBranchesNearVm.enableGoldPoint;

            if(glBranchesNearVm.enableGoldPoint == true) {
                for(var i = glBranchesNearVm.branches.length; i--;) {
                    if(glBranchesNearVm.branches[i].gPoint == 'N') {
                        glBranchesNearVm.branches.splice(i,1);
                    }                    
                }
            }else{
                glBranchesNearVm.branches = angular.copy(goldLoanRLMSService.locateByGPS);
            }
        }

        glBranchesNearVm.selectBranch = function(loc,index){
            glBranchesNearVm.selectedBranch = loc;
            goldLoanRLMSService.selectedBranch = glBranchesNearVm.selectedBranch;
            glBranchesNearVm.selectedIndexLocation = index;
            glBranchesNearVm.branchError = "";
        }

        glBranchesNearVm.openMaps = function(loc){
             var geocoords = loc.latitude + "," + loc.longitude;
             if (utilityService.isIOSPlatform()) {
                cordova.ThemeableBrowser.open('https://www.google.com/maps/search/?api=1&query=' + geocoords, '_blank',
                {
                    statusbar: {
                        color:'#ffffffff'
                    },
                    toolbar: {
                        height: 37,
                        color: '#ffffffff',
                        image: 'share'
                    },

                    closeButton: {
                        image:'back',
                        height: 37,
                        width: 32,
                        align: 'left',
                        event: 'closePressed'
                    },

                    backButtonCanClose: true
                });
            }else {
                var label = encodeURI('Your Destination'); // encode the label!
                window.open('geo:0,0?q=' + geocoords + '(' + label + ')', '_system');
            }
         }

        

        glBranchesNearVm.goBack = function() {
            $state.go('menu.glSelectBranchRLMS');
        };

        glBranchesNearVm.goToNextPage = function() {
            glBranchesNearVm.branchError = "";
            if(glBranchesNearVm.selectedBranch){
                var appRequest = {
                    "selectedBranch": {
                        "brCode" : glBranchesNearVm.selectedBranch.brCode ? glBranchesNearVm.selectedBranch.brCode : "",
                        "branchName" : glBranchesNearVm.selectedBranch.branchName ? glBranchesNearVm.selectedBranch.branchName : "",
                        "circle": glBranchesNearVm.selectedBranch.circle ? glBranchesNearVm.selectedBranch.circle : "",
                        "officeType": glBranchesNearVm.selectedBranch.officeType ? glBranchesNearVm.selectedBranch.officeType : "",
                        "add1": glBranchesNearVm.selectedBranch.add1 ? glBranchesNearVm.selectedBranch.add1 : "",
                        "add2": glBranchesNearVm.selectedBranch.add2 ? glBranchesNearVm.selectedBranch.add2 : "",
                        "add3": glBranchesNearVm.selectedBranch.add3 ? glBranchesNearVm.selectedBranch.add3 : "",
                        "pinCode": glBranchesNearVm.selectedBranch.pinCode ? glBranchesNearVm.selectedBranch.pinCode : "",
                        "phone": glBranchesNearVm.selectedBranch.phone ? glBranchesNearVm.selectedBranch.phone : "",
                        "mobNo": glBranchesNearVm.selectedBranch.mobNo ? glBranchesNearVm.selectedBranch.mobNo : "",
                        "bmCell": glBranchesNearVm.selectedBranch.bmCell ? glBranchesNearVm.selectedBranch.bmCell : "",
                        "email": glBranchesNearVm.selectedBranch.email ? glBranchesNearVm.selectedBranch.email : "",
                        "latitude": glBranchesNearVm.selectedBranch.latitude ? glBranchesNearVm.selectedBranch.latitude : "",
                        "longitude": glBranchesNearVm.selectedBranch.longitude ? glBranchesNearVm.selectedBranch.longitude : "",
                        "gPoint": glBranchesNearVm.selectedBranch.gPoint ? glBranchesNearVm.selectedBranch.gPoint : ""
                    }
                }

                goldLoanRLMSService.getLoanSummary(appRequest).then(function(data) {
                    goldLoanRLMSService.getBasicDetailData().selectedBranch = appRequest.selectedBranch;
                    console.log(data);
                    goldLoanRLMSService.setLoanSummaryData(data);                 
                    $state.go('menu.glLoanSummaryRLMS');
                },function(error){
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }else{
                glBranchesNearVm.branchError = true;
                $ionicScrollDelegate.scrollTop();
            }
        };

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        return this;
    }
]);