'use strict';

angularApp.controller('glGPSErrorRLMSController', [
    "$state",
    "$scope",
    "$translate",  
    "$ionicSideMenuDelegate",
    "$filter", "goldLoanRLMSService", "$ionicPopover", "$ionicPopup", "utilityService", "currentLocationService",

    function($state,
        $scope,
        $translate,        
        $ionicSideMenuDelegate,
        $filter, goldLoanRLMSService, $ionicPopover, $ionicPopup, utilityService, currentLocationService) {

        var glGPSErrorVm = this;

        function initPage() {
        };

        glGPSErrorVm.findGoldBranches = function() {
            utilityService.showSpinner();
            // CheckGPS.check(function () {
                currentLocationService.getCurrentPosition().then(
                    function (position) {
                        utilityService.hideSpinner();
                        goldLoanRLMSService.geocoords = position.coords.latitude + "," + position.coords.longitude;
                        var latitude = position.coords.latitude;
                        var longitude = position.coords.longitude;
                        goldLoanRLMSService.locateBranches.length = 0;
                        var params = {
                            "latitude": latitude.toString(),
                            "longitude": longitude.toString(),
                            "goldPoint": goldLoanRLMSService.onlyGoldBranches
                        }
                        
                        if (utilityService.isUndefined(goldLoanRLMSService.locateBranches) || goldLoanRLMSService.locateBranches.length === 0 
                            || utilityService.isUndefined(goldLoanRLMSService.locateByGPS) || goldLoanRLMSService.locateByGPS.length === 0) {
                            //service call
                            goldLoanRLMSService.getBranchListByGeo(params).then(function (data) {
                                if (!utilityService.isUndefined(data)) {
                                    if(goldLoanRLMSService.onlyGoldBranches == true) {
                                        goldLoanRLMSService.locateBranches = [];
                                        for (var i = 0; i < data.length; i++) {
                                            goldLoanRLMSService.locateBranches.push(data[i]);
                                            $state.go('menu.glSelectBranchRLMS');
                                            goldLoanRLMSService.selectedBranch = "";
                                        }     
                                    }else{
                                        goldLoanRLMSService.locateByGPS = [];
                                        for (var i = 0; i < data.length; i++) {
                                            goldLoanRLMSService.locateByGPS.push(data[i]);
                                            $state.go('menu.glBranchesNearRLMS');
                                            goldLoanRLMSService.selectedBranch = "";
                                        }
                                    }
                                                                   
                                }
                            }, function (error) {
                                 utilityService.showErrorMessage(error.responseMessage);                                    
                            });
                        } 
                    },function (err) {
                        //Location permission off
                        utilityService.hideSpinner();                        
                        //goldLoanRLMSService.gpsState = "off";
                        $state.go('menu.glSelectBranchRLMS');
                    }                    
                );
            // },function () {
            //     //GPS off
            //     utilityService.hideSpinner();
            //     if(goldLoanRLMSService.gpsState == "off" || $stateParams.gps == "off"){
            //         $state.go('menu.glSelectBranchRLMS');
            //         glGPSErrorVm.goldPointBranches = [];
            //         goldLoanRLMSService.gpsState = "";
            //     }else{
            //         $state.go('menu.glGPSErrorRLMS'); 
            //     }
                
            // });
        }

        glGPSErrorVm.goBack = function() {            
            glGPSErrorVm.findGoldBranches();                     
        };

      
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        return this;
    }
]);