'use strict';

angularApp.controller('glLoanDetailsRLMSController', [
    "$state",
    "$scope",
    "$translate",  
    "$ionicSideMenuDelegate",
    "$filter", "goldLoanRLMSService", "$ionicPopover", "utilityService",

    function($state,
        $scope,
        $translate,        
        $ionicSideMenuDelegate,
        $filter, goldLoanRLMSService, $ionicPopover, utilityService) {

        var glLoanDetailsVm = this;

        function initPage() {
            glLoanDetailsVm.loanSchemesList = [];
            glLoanDetailsVm.isExpand = false;            
            
            var rupeeSymbol = String.fromCharCode(8377);

            if(goldLoanRLMSService.resumeData){
                glLoanDetailsVm.loanSchemesList = goldLoanRLMSService.resumeData.master.productVariants;
            }else{
                glLoanDetailsVm.loanSchemesList = goldLoanRLMSService.userMaster.master.productVariants;
            }
            
            var getExistingSchemeDetails = goldLoanRLMSService.getSchemeDetailData().schemeDetails;



            if(goldLoanRLMSService.getBasicDetailData().loanDetail) {
                glLoanDetailsVm.schemeTypeCode = goldLoanRLMSService.getBasicDetailData().loanDetail.schemeCode; 
                for(var i=0; i < glLoanDetailsVm.loanSchemesList.length; i++) {
                   if(glLoanDetailsVm.schemeTypeCode == glLoanDetailsVm.loanSchemesList[i].key) {

                        glLoanDetailsVm.loanSchemesList[i].isExpand = true;
                        glLoanDetailsVm.schemeTypeRadio = goldLoanRLMSService.getBasicDetailData().loanDetail.schemeCode;                
                        glLoanDetailsVm.amountValue = parseInt(goldLoanRLMSService.getBasicDetailData().loanDetail.requestedLoanAmount);
                        glLoanDetailsVm.tenureValue = parseInt(goldLoanRLMSService.getBasicDetailData().loanDetail.requestedTenure);
                        glLoanDetailsVm.name = goldLoanRLMSService.getBasicDetailData().loanDetail.name;
                        glLoanDetailsVm.schemeTypeName = glLoanDetailsVm.loanSchemesList[i].schemeName;
                        glLoanDetailsVm.schemeTypeID = glLoanDetailsVm.loanSchemesList[i].schemeId;
                        glLoanDetailsVm.schemeCode = glLoanDetailsVm.loanSchemesList[i].key;
                        glLoanDetailsVm.schemeTypeDetails = glLoanDetailsVm.loanSchemesList[i].details;
                        glLoanDetailsVm.schemeDescription = glLoanDetailsVm.loanSchemesList[i].description;
                        glLoanDetailsVm.schemeMargin = glLoanDetailsVm.loanSchemesList[i].margin;
                        glLoanDetailsVm.interestRate = parseFloat(goldLoanRLMSService.getBasicDetailData().loanDetail.intRate);
                        glLoanDetailsVm.amountSlider.options.floor = parseInt(goldLoanRLMSService.getBasicDetailData().loanDetail.minLoanAmt);
                        glLoanDetailsVm.amountSlider.options.ceil = parseInt(goldLoanRLMSService.getBasicDetailData().loanDetail.eligibleAmount)
                        glLoanDetailsVm.amountSlider.value = parseInt(goldLoanRLMSService.getBasicDetailData().loanDetail.requestedLoanAmount);
                        glLoanDetailsVm.tenureSlider.options.floor = parseInt(goldLoanRLMSService.getBasicDetailData().loanDetail.minTenure);
                        glLoanDetailsVm.tenureSlider.options.ceil = parseInt(goldLoanRLMSService.getBasicDetailData().loanDetail.maxTenure);
                        glLoanDetailsVm.tenureSlider.value = parseInt(goldLoanRLMSService.getBasicDetailData().loanDetail.requestedTenure);
                        glLoanDetailsVm.emiAmount = goldLoanRLMSService.getBasicDetailData().loanDetail.emi;
                        glLoanDetailsVm.monthlyInterest = goldLoanRLMSService.getBasicDetailData().loanDetail.monthlyInterest;
                        if(glLoanDetailsVm.emiAmount) {
                            glLoanDetailsVm.emiAmount = goldLoanRLMSService.emiCalculation(glLoanDetailsVm.amountValue,glLoanDetailsVm.interestRate,glLoanDetailsVm.tenureValue);
                            goldLoanRLMSService.schemeEMI = glLoanDetailsVm.emiAmount;
                        }else{
                            goldLoanRLMSService.schemeEMI = 0;
                        }

                        if(glLoanDetailsVm.monthlyInterest) {
                            glLoanDetailsVm.monthlyInterest = goldLoanRLMSService.monthlyInterestCalculation(glLoanDetailsVm.amountValue,glLoanDetailsVm.interestRate,glLoanDetailsVm.tenureValue);
                            //goldLoanRLMSService.schemeEMI = glLoanDetailsVm.monthlyInterest;
                        }
                       // break;
                    }else{
                        glLoanDetailsVm.loanSchemesList[i].isExpand = false;
                        }
                }       
            } else { 
           for(var i=0; i < glLoanDetailsVm.loanSchemesList.length; i++) {
               if(getExistingSchemeDetails[0].schemeCode == glLoanDetailsVm.loanSchemesList[i].key){
                    glLoanDetailsVm.loanSchemesList[i].isExpand = true;
                    glLoanDetailsVm.name = getExistingSchemeDetails[0].name;
                    glLoanDetailsVm.schemeTypeName = getExistingSchemeDetails[0].schemeName;
                    glLoanDetailsVm.schemeTypeID = getExistingSchemeDetails[0].schemeId;
                    glLoanDetailsVm.schemeCode = getExistingSchemeDetails[0].schemeCode;
                    glLoanDetailsVm.schemeTypeDetails = getExistingSchemeDetails[0].details;
                    glLoanDetailsVm.schemeDescription = getExistingSchemeDetails[0].description;
                    glLoanDetailsVm.schemeMargin = getExistingSchemeDetails[0].margin;
                    glLoanDetailsVm.interestRate = parseFloat(getExistingSchemeDetails[0].intRate);
                    glLoanDetailsVm.amountSlider.options.floor = parseInt(getExistingSchemeDetails[0].minLoanAmt);
                    glLoanDetailsVm.amountSlider.options.ceil = parseInt(getExistingSchemeDetails[0].eligibleAmount);
                    glLoanDetailsVm.amountSlider.value = parseInt(getExistingSchemeDetails[0].eligibleAmount);
                    glLoanDetailsVm.tenureSlider.options.floor = parseInt(getExistingSchemeDetails[0].minTenure);
                    glLoanDetailsVm.tenureSlider.options.ceil = parseInt(getExistingSchemeDetails[0].maxTenure);
                    glLoanDetailsVm.tenureSlider.value = parseInt(getExistingSchemeDetails[0].maxTenure);
                    glLoanDetailsVm.emiAmount = parseFloat(getExistingSchemeDetails[0].emi);
                    glLoanDetailsVm.amountValue = parseInt(getExistingSchemeDetails[0].eligibleAmount);
                    glLoanDetailsVm.tenureValue = parseInt(getExistingSchemeDetails[0].maxTenure);
                    glLoanDetailsVm.monthlyInterest = getExistingSchemeDetails[0].monthlyInterest ?  getExistingSchemeDetails[0].monthlyInterest : "" ;
                    if(glLoanDetailsVm.emiAmount) {
                    glLoanDetailsVm.emiAmount = goldLoanRLMSService.emiCalculation(glLoanDetailsVm.amountValue,glLoanDetailsVm.interestRate,glLoanDetailsVm.tenureValue);
                    goldLoanRLMSService.schemeEMI = glLoanDetailsVm.emiAmount;
                    }else{
                        goldLoanRLMSService.schemeEMI = 0;
                    }

                    if(glLoanDetailsVm.monthlyInterest) {
                        glLoanDetailsVm.monthlyInterest = goldLoanRLMSService.monthlyInterestCalculation(glLoanDetailsVm.amountValue,glLoanDetailsVm.interestRate,glLoanDetailsVm.tenureValue);
                        //goldLoanRLMSService.schemeEMI = glLoanDetailsVm.monthlyInterest;
                    }   
                   
               }else{
                   glLoanDetailsVm.loanSchemesList[i].isExpand = false;
               }
           }
           }

                                
        }

                glLoanDetailsVm.amountSlider = {
                    value: glLoanDetailsVm.amountValue,
                    options: {
                        showSelectionBar: true,
                        floor : glLoanDetailsVm.minAmount,
                        ceil :  glLoanDetailsVm.maxAmount,
                        step :  1,
                        onChange : function(id,model){                             
                            if(glLoanDetailsVm.monthlyInterest) {       // "SBI_GOLD_LIQ"
                                glLoanDetailsVm.monthlyInterestCalculation(glLoanDetailsVm.monthlyInterest);
                            }else if(glLoanDetailsVm.emiAmount) {       //"SBI_GOLD_LOAN"
                                glLoanDetailsVm.emiCalculation(glLoanDetailsVm.emiAmount);
                            }                            
                        },
                        translate : function(value){
                            return  rupeeSymbol + $filter('INR')(value);
                        }   
                    }
                }; 

            glLoanDetailsVm.tenureSlider = {
                    value: glLoanDetailsVm.tenureValue,
                    options: {
                        showSelectionBar: true,
                        floor : glLoanDetailsVm.minTenure,
                        ceil :  glLoanDetailsVm.maxTenure,
                        step :  1,
                        onChange : function(id,model){
                            if(glLoanDetailsVm.monthlyInterest) {       // "SBI_GOLD_LIQ"
                                glLoanDetailsVm.monthlyInterestCalculation(glLoanDetailsVm.monthlyInterest);
                            }else if(glLoanDetailsVm.emiAmount) {       //"SBI_GOLD_LOAN"
                                glLoanDetailsVm.emiCalculation(glLoanDetailsVm.emiAmount);
                            }   
                        },
                        translate : function(value){
                            return  value + " months";
                        }   
                    }
                };

        glLoanDetailsVm.chooseScheme = function (index,scheme) {
            glLoanDetailsVm.loanSchemesList[index].isExpand = true;
            glLoanDetailsVm.updateSchemeDetail(scheme);
            for(var i= 0; i < glLoanDetailsVm.loanSchemesList.length ; i++){
                if(i != index){
                    glLoanDetailsVm.loanSchemesList[i].isExpand = false;
                }                
            }

            //New service call to retrieve data for schemes
        }

        glLoanDetailsVm.updateSchemeDetail = function(scheme){

            var saveRequest = { 	
                 "loanType":"string",
                 "schemeCode":scheme.key
                }

            goldLoanRLMSService.updateSchemeDetail(saveRequest).then(function(data) {
                
                    glLoanDetailsVm.errObj = {};
                    glLoanDetailsVm.name = data.schemeDetails[0].name;
                    glLoanDetailsVm.schemeTypeName = data.schemeDetails[0].schemeName;
                    glLoanDetailsVm.schemeTypeID = data.schemeDetails[0].schemeId;
                    glLoanDetailsVm.schemeCode = data.schemeDetails[0].schemeCode;
                    glLoanDetailsVm.schemeTypeDetails = data.schemeDetails[0].details;
                    glLoanDetailsVm.schemeDescription = data.schemeDetails[0].description;
                    glLoanDetailsVm.schemeMargin = data.schemeDetails[0].margin;
                    glLoanDetailsVm.interestRate = parseFloat(data.schemeDetails[0].intRate);
                    glLoanDetailsVm.amountSlider.options.floor = parseInt(data.schemeDetails[0].minLoanAmt);
                    glLoanDetailsVm.amountSlider.options.ceil = parseInt(data.schemeDetails[0].eligibleAmount);
                    glLoanDetailsVm.amountSlider.value = parseInt(data.schemeDetails[0].eligibleAmount);
                    glLoanDetailsVm.tenureSlider.options.floor = parseInt(data.schemeDetails[0].minTenure);
                    glLoanDetailsVm.tenureSlider.options.ceil = parseInt(data.schemeDetails[0].maxTenure);
                    glLoanDetailsVm.tenureSlider.value = parseInt(data.schemeDetails[0].maxTenure);
                    glLoanDetailsVm.emiAmount = parseFloat(data.schemeDetails[0].emi);
                    glLoanDetailsVm.amountValue = parseInt(data.schemeDetails[0].eligibleAmount);
                    glLoanDetailsVm.tenureValue = parseInt(data.schemeDetails[0].maxTenure);
                    glLoanDetailsVm.monthlyInterest = data.schemeDetails[0].monthlyInterest ?  data.schemeDetails[0].monthlyInterest : "" ;
                    if(glLoanDetailsVm.emiAmount) {
                    glLoanDetailsVm.emiAmount = goldLoanRLMSService.emiCalculation(glLoanDetailsVm.amountValue,glLoanDetailsVm.interestRate,glLoanDetailsVm.tenureValue);
                    goldLoanRLMSService.schemeEMI = glLoanDetailsVm.emiAmount;
                    }else{
                        goldLoanRLMSService.schemeEMI = 0;
                    }

                    if( glLoanDetailsVm.monthlyInterest) {
                        glLoanDetailsVm.monthlyInterest = goldLoanRLMSService.monthlyInterestCalculation(glLoanDetailsVm.amountValue,glLoanDetailsVm.interestRate,glLoanDetailsVm.tenureValue);
                        //goldLoanRLMSService.schemeEMI = glLoanDetailsVm.monthlyInterest;
                    }   
                                    
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
                   
				});	

        }



        glLoanDetailsVm.emiCalculation = function(emi) {
            if(emi) { 
                glLoanDetailsVm.emiAmount = goldLoanRLMSService.emiCalculation(glLoanDetailsVm.amountSlider.value,glLoanDetailsVm.interestRate,glLoanDetailsVm.tenureSlider.value);
                goldLoanRLMSService.schemeEMI = parseFloat(glLoanDetailsVm.emiAmount);
            }else{
                goldLoanRLMSService.schemeEMI = 0;
            }
        }

        glLoanDetailsVm.monthlyInterestCalculation = function(monthlyInterest) {
            if(monthlyInterest) { 
                glLoanDetailsVm.monthlyInterest = goldLoanRLMSService.monthlyInterestCalculation(glLoanDetailsVm.amountSlider.value,glLoanDetailsVm.interestRate,glLoanDetailsVm.tenureSlider.value);
                //goldLoanRLMSService.schemeEMI = parseFloat(glLoanDetailsVm.monthlyInterest);
            } 
        }

        glLoanDetailsVm.openInfo = function ($event) {
            glLoanDetailsVm.leftStyle = "left : " + ($event.clientX - 30) + "px";           
            glLoanDetailsVm.template = '<ion-popover-view class="loginnewarrow hmbr-info hmbr-info-popnew popOverGL" id="runtimeHeight" >' + '<div class="edu-arrow-downnew" style="{{glLoanDetailsVm.leftStyle}}"></div>' + 
            '<a class="iconsubtext closeinfobutton float-right" id="CALL_ANC" click-stream="click" ng-click="glLoanDetailsVm.closePopover()">' + '<i class="ico-close ver-align-middle"></i>' + '</a>' + '<ion-content class="col-90 nfs-popover" has-bouncing="false">' +
            '<div id="renderHeight" class="text-left padding-left-10 padding-right-10 font-size-12">'+
            '<div>Interest and Principal to be paid at the end of the loan term. Monthly payment is not mandatory.</div>' + 
            '</div>' + '</ion-content>' + '</ion-popover-view>';
            $scope.popover = $ionicPopover.fromTemplate(glLoanDetailsVm.template, {
                scope: $scope
            });
            $scope.popover.show($event);
               
        }

        glLoanDetailsVm.closePopover = function(){
            $scope.popover.hide();
        }

         glLoanDetailsVm.validateForm = function(){ 
            glLoanDetailsVm.errObj = {};

            if(glLoanDetailsVm.amountSlider.value > glLoanDetailsVm.amountSlider.options.ceil) {
                glLoanDetailsVm.errObj.loanAmt = "Enter an amount lesser than ₹" + glLoanDetailsVm.amountSlider.options.ceil;
            }else if(glLoanDetailsVm.amountSlider.value < glLoanDetailsVm.amountSlider.options.floor) {
                glLoanDetailsVm.errObj.loanAmt = "Enter an amount greater than ₹" + glLoanDetailsVm.amountSlider.options.floor;
            }

            if(glLoanDetailsVm.tenureSlider.value > glLoanDetailsVm.tenureSlider.options.ceil) {
                glLoanDetailsVm.errObj.loanTenure = "Enter a tenure lesser than " + glLoanDetailsVm.tenureSlider.options.ceil + " months";
            }else if(glLoanDetailsVm.tenureSlider.value < glLoanDetailsVm.tenureSlider.options.floor) {
                glLoanDetailsVm.errObj.loanTenure = "Enter a tenure greater than " + glLoanDetailsVm.tenureSlider.options.floor + " months";
            }       

            return (angular.equals({}, glLoanDetailsVm.errObj)) ? true : false;
        }

        glLoanDetailsVm.goBack = function() {
            $state.go('menu.goldOrnamentDetailsRLMS');
        };

        glLoanDetailsVm.goToNextPage = function() {
            if(glLoanDetailsVm.validateForm()){
                var saveRequest = {
                    "loanDetail":{
                        "requestedLoanAmount": glLoanDetailsVm.amountSlider.value ? glLoanDetailsVm.amountSlider.value : "",
                        "requestedTenure": glLoanDetailsVm.tenureSlider.value ? glLoanDetailsVm.tenureSlider.value : "",
                        "schemeName": glLoanDetailsVm.schemeTypeName ? glLoanDetailsVm.schemeTypeName :"",
                        "schemeCode": glLoanDetailsVm.schemeCode ? glLoanDetailsVm.schemeCode : "",
                        "schemeId": glLoanDetailsVm.schemeTypeID ? glLoanDetailsVm.schemeTypeID : "",
                        "minLoanAmt": glLoanDetailsVm.amountSlider.options.floor ? glLoanDetailsVm.amountSlider.options.floor : "",
                        "maxLoanAmt": glLoanDetailsVm.amountSlider.options.ceil ? glLoanDetailsVm.amountSlider.options.ceil : "",
                        "minTenure": glLoanDetailsVm.tenureSlider.options.floor ? glLoanDetailsVm.tenureSlider.options.floor : "",
                        "maxTenure": glLoanDetailsVm.tenureSlider.options.ceil ? glLoanDetailsVm.tenureSlider.options.ceil : "",
                        "intRate": glLoanDetailsVm.interestRate ? glLoanDetailsVm.interestRate : "",
                        "emi": glLoanDetailsVm.emiAmount ? glLoanDetailsVm.emiAmount :"",
                        "monthlyInterest": glLoanDetailsVm.monthlyInterest ? glLoanDetailsVm.monthlyInterest : "",
                        "name": glLoanDetailsVm.name ? glLoanDetailsVm.name : "",
                        "details": glLoanDetailsVm.schemeTypeDetails ? glLoanDetailsVm.schemeTypeDetails : "",
                        "description": glLoanDetailsVm.schemeDescription ? glLoanDetailsVm.schemeDescription : "",
                        "margin": glLoanDetailsVm.schemeMargin ? glLoanDetailsVm.schemeMargin : "",
                        "eligibleAmount" :glLoanDetailsVm.amountSlider.options.ceil ? glLoanDetailsVm.amountSlider.options.ceil : ""
                    }
                }

                goldLoanRLMSService.getAdditionalDetail(saveRequest).then(function(data) {
                    goldLoanRLMSService.getBasicDetailData().loanDetail = saveRequest.loanDetail;
                    console.log(data);
                    goldLoanRLMSService.setAdditionDetailData(data);                 
                    $state.go('menu.glAdditionalDetailsRLMS');
                },function(error){
                    utilityService.showErrorMessage(error.responseMessage);
                });                
            }
        };


        /*glLoanDetailsVm.showPop = function(){
          
                  glLoanDetailsVm.popUp = $ionicPopup.show({
                    title: '',
                    cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
                    templateUrl: 'pages/ncmc/loadNCMC/dropdownModal.html',
                    scope: $scope
                  });
            
        }*/

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

   
        return this;
    }
]);