'use strict';
angularApp.controller('glLoanSummaryRLMSController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",		
		"$ionicScrollDelegate",	
		"validateService",
		"$filter",
		"goldLoanRLMSService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService,
			$ionicScrollDelegate,validateService,$filter,goldLoanRLMSService) {
			
			var glLoanSummaryVm = this;

			function initPage() {
				glLoanSummaryVm.errorCheck = false;
				glLoanSummaryVm.loanSummaryCheck = false;
				glLoanSummaryVm.ornamentsSummary = [];
				// glLoanSummaryVm.ornamentsSummary = [{"ornType":"Ear Rings","qty":"2","carat":"22K","netWgt":"6.3g"},{"ornType":"Necklace","qty":"1","carat":"22K","netWgt":"8.3g"},{"ornType":"Braclet","qty":"2","carat":"24K","netWgt":"5.2g"},{"ornType":"Rings","qty":"2","carat":"22K","netWgt":"3g"}];
				
				if(goldLoanRLMSService.getLoanSummaryData()) {
					glLoanSummaryVm.ornamentsSummary = goldLoanRLMSService.getLoanSummaryData().ornamentList;

					glLoanSummaryVm.loanAmount = goldLoanRLMSService.getLoanSummaryData().loanDetail.requestedLoanAmount; 
					glLoanSummaryVm.schemeSelected = goldLoanRLMSService.getLoanSummaryData().loanDetail.name;
					var amountValue = parseFloat(goldLoanRLMSService.getLoanSummaryData().loanDetail.requestedLoanAmount);
					var interestRate = parseFloat(goldLoanRLMSService.getLoanSummaryData().loanDetail.intRate);
					var tenureValue = parseFloat(goldLoanRLMSService.getLoanSummaryData().loanDetail.requestedTenure);
					if(goldLoanRLMSService.getLoanSummaryData().loanDetail.emi) {
						//glLoanSummaryVm.emi = goldLoanRLMSService.getLoanSummaryData().loanDetail.emi;
						glLoanSummaryVm.emi = goldLoanRLMSService.emiCalculation(amountValue,interestRate,tenureValue);
					}
					if(goldLoanRLMSService.getLoanSummaryData().loanDetail.monthlyInterest) {
						//glLoanSummaryVm.monthlyInterest = goldLoanRLMSService.getLoanSummaryData().loanDetail.monthlyInterest;
						glLoanSummaryVm.monthlyInterest = goldLoanRLMSService.monthlyInterestCalculation(amountValue,interestRate,tenureValue);
					}
					
					glLoanSummaryVm.tenure = goldLoanRLMSService.getLoanSummaryData().loanDetail.requestedTenure;
					glLoanSummaryVm.interestRate = goldLoanRLMSService.getLoanSummaryData().loanDetail.intRate;
					glLoanSummaryVm.margin = goldLoanRLMSService.getLoanSummaryData().loanDetail.margin;
					glLoanSummaryVm.creditAccNumber = goldLoanRLMSService.getLoanSummaryData().additionalDetail.selectedAccountNumber;
					glLoanSummaryVm.creditAccBranch = goldLoanRLMSService.getLoanSummaryData().additionalDetail.selectAccountBranchName + ' - ' + goldLoanRLMSService.getLoanSummaryData().additionalDetail.selectedAccountBranchCode;
					glLoanSummaryVm.branchToBeVisited = goldLoanRLMSService.getLoanSummaryData().selectedBranch.branchName + ' ' + goldLoanRLMSService.getLoanSummaryData().selectedBranch.brCode;
				}

			}

			glLoanSummaryVm.parseData = function (data) {
				return JSON.parse(data).value;
			}

			glLoanSummaryVm.confirmLoanSummary = function () {
				glLoanSummaryVm.loanSummaryCheck = !glLoanSummaryVm.loanSummaryCheck;
			}

			glLoanSummaryVm.goBack = function () {
				$state.go('menu.glSelectBranchRLMS');
			}			

			glLoanSummaryVm.goToNextPage = function () {
				if(glLoanSummaryVm.loanSummaryCheck == true) {
					var appRequest = {
						"referralCode": glLoanSummaryVm.referralCode ? glLoanSummaryVm.referralCode : "",
  						"tnc": glLoanSummaryVm.loanSummaryCheck
					};
					goldLoanRLMSService.submitApplication(appRequest).then(function(data) {
                		console.log(data);
                		goldLoanRLMSService.setSubmittedApplicationData(data);                 
                		$state.go('menu.glCongratulationsRLMS');
            		},function(error){
                		utilityService.showErrorMessage(error.responseMessage);
                		glLoanSummaryVm.errorCheck = false;
            		}); 
				}else{
					glLoanSummaryVm.errorCheck = true;
					$ionicScrollDelegate.scrollBottom();
				}												  
			}			

			$scope.$on('$ionicView.loaded', function () {
				//initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				initPage();
			});

			return this;
		}

		
]);


