'use strict';
angularApp.controller('glPersonalDetailsRLMSController', [
		"$state",
		"$scope",
		"$translate",
		"utilityService",
		"$ionicScrollDelegate","$filter","goldLoanRLMSService",
		function($state, $scope, $translate, utilityService, $ionicScrollDelegate,$filter,goldLoanRLMSService) {
			
			var glPersonalDetailsVm = this;
			glPersonalDetailsVm.detail = {};
			
			function initPage() {
				glPersonalDetailsVm.errorCheck = false;
				glPersonalDetailsVm.personalDetailCheck = false;            	
				glPersonalDetailsVm.isMaskPan = true;
            	glPersonalDetailsVm.isMaskAd = true;
            	glPersonalDetailsVm.isMaskEmail = true;
            	glPersonalDetailsVm.isMaskMobile = true;
            	glPersonalDetailsVm.isMaskDob = true;

            	if(goldLoanRLMSService.resumeData) {
                	glPersonalDetailsVm.masterData = angular.copy(goldLoanRLMSService.resumeData);
                    glPersonalDetailsVm.personalDetailCheck = true;
            	} else {
                	glPersonalDetailsVm.masterData = angular.copy(goldLoanRLMSService.userMaster);
                    glPersonalDetailsVm.personalDetailCheck = goldLoanRLMSService.personalDetailCheck;
            	}

                glPersonalDetailsVm.residTypeList = glPersonalDetailsVm.masterData.master.residentialTypes;
                glPersonalDetailsVm.occupationTypeList = glPersonalDetailsVm.masterData.master.occupationTypes;

				glPersonalDetailsVm.detail.homeBranchName = glPersonalDetailsVm.masterData.homeBranchName;
				glPersonalDetailsVm.detail.homeBranchCode = glPersonalDetailsVm.masterData.homeBranchCode;
				glPersonalDetailsVm.detail.customerName = glPersonalDetailsVm.masterData.firstName + ' '+ glPersonalDetailsVm.masterData.lastName;
				glPersonalDetailsVm.detail.dob = $filter('homeDateFormat')(glPersonalDetailsVm.masterData.dob);
            	var str = glPersonalDetailsVm.detail.dob.split(' ');
            	var year = str[2];
            	var Mask = year.replace(year, 'XXXX');
            	glPersonalDetailsVm.detail.dobMask = str[0] + ' ' + str[1] + ' ' + Mask;
				glPersonalDetailsVm.detail.gender = glPersonalDetailsVm.masterData.genderValue;
				glPersonalDetailsVm.detail.pan = glPersonalDetailsVm.masterData.pan;
				glPersonalDetailsVm.detail.aadhaar = glPersonalDetailsVm.masterData.aadhaar;
				glPersonalDetailsVm.detail.mobile = glPersonalDetailsVm.masterData.mobile;
				glPersonalDetailsVm.detail.email = glPersonalDetailsVm.masterData.email;

				
                if (!glPersonalDetailsVm.masterData.address[0].addressLine1) {
                	glPersonalDetailsVm.detail.addressLine1 = "";
            	} else {
                	if (glPersonalDetailsVm.masterData.address[0].addressLine1.indexOf(',') == -1) {
                    	glPersonalDetailsVm.detail.addressLine1 = glPersonalDetailsVm.masterData.address[0].addressLine1 + ",";
                	} else {
                    	glPersonalDetailsVm.detail.addressLine1 = glPersonalDetailsVm.masterData.address[0].addressLine1;
                	}
            	}

            	if (!glPersonalDetailsVm.masterData.address[0].addressLine2) {
                	glPersonalDetailsVm.detail.addressLine2 = "";
            	} else {
                	if (glPersonalDetailsVm.masterData.address[0].addressLine2.indexOf(',') == -1) {
                    	glPersonalDetailsVm.detail.addressLine2 = glPersonalDetailsVm.masterData.address[0].addressLine2 + ",";
                	} else {
                    	glPersonalDetailsVm.detail.addressLine2 = glPersonalDetailsVm.masterData.address[0].addressLine2;
                	}
            	}


            	if (!glPersonalDetailsVm.masterData.address[0].addressLine3) {
                	glPersonalDetailsVm.detail.addressLine3 = "";
            	} else {                	
                   	glPersonalDetailsVm.detail.addressLine3 = glPersonalDetailsVm.masterData.address[0].addressLine3;                		
            	}

            
            	if (!glPersonalDetailsVm.masterData.address[0].pincode) {
                	glPersonalDetailsVm.detail.pincode = "";
            	} else {
                	if (glPersonalDetailsVm.masterData.address[0].pincode.indexOf('-') == -1) {
                    	glPersonalDetailsVm.detail.pincode = "-" + glPersonalDetailsVm.masterData.address[0].pincode;
                	} else {
                    	glPersonalDetailsVm.detail.pincode = glPersonalDetailsVm.masterData.address[0].pincode;
                	}
            	}

            glPersonalDetailsVm.detail.permanentAddress = glPersonalDetailsVm.detail.addressLine1 + glPersonalDetailsVm.detail.addressLine2 + glPersonalDetailsVm.detail.addressLine3 + glPersonalDetailsVm.detail.pincode;

			glPersonalDetailsVm.residType = glPersonalDetailsVm.masterData.houseOwnershipValue ? {"key":glPersonalDetailsVm.masterData.houseOwnership,"value":glPersonalDetailsVm.masterData.houseOwnershipValue} : "";"";
			glPersonalDetailsVm.occupationType = glPersonalDetailsVm.masterData.occupationTypeValue ? {"key":glPersonalDetailsVm.masterData.occupationType,"value":glPersonalDetailsVm.masterData.occupationTypeValue} : "";
			glPersonalDetailsVm.monthlyIncome = glPersonalDetailsVm.masterData.netMonthlyIncome ? glPersonalDetailsVm.masterData.netMonthlyIncome:"";
				
		}

		glPersonalDetailsVm.unmaskDob = function() {
            glPersonalDetailsVm.isMaskDob = !glPersonalDetailsVm.isMaskDob;
        }
		
		// glPersonalDetailsVm.confirmPersonalDetail = function() {
		// 	glPersonalDetailsVm.personalDetailCheck = !glPersonalDetailsVm.personalDetailCheck;
		// }

		glPersonalDetailsVm.unmaskData = function(idType) {
            var request = {
                "type": idType,
                "loanType": "gold"
            }
            if (idType == 'pan' || idType == 'aadhaar' || idType == 'mobile' || idType == 'email') {
                goldLoanRLMSService.getUnmaskData(request).then(function(data) {
                    if (idType == 'pan') {
                        glPersonalDetailsVm.isMaskPan = false;
                        glPersonalDetailsVm.detail.pan = data;
                    } else if (idType == 'aadhaar') {
                        glPersonalDetailsVm.isMaskAd = false;
                        glPersonalDetailsVm.detail.aadhaar = data;
                    } else if (idType == 'mobile') {
                        glPersonalDetailsVm.isMaskMobile = false;
                        glPersonalDetailsVm.detail.mobile = data;
                    } else if (idType == 'email') {
                        glPersonalDetailsVm.isMaskEmail = false;
                        glPersonalDetailsVm.detail.email = data;
                    }
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else {
                if (idType == 'npan') {
                    glPersonalDetailsVm.isMaskPan = true;
                    glPersonalDetailsVm.detail.pan = glPersonalDetailsVm.masterData.pan;
                } else if (idType == 'naadhaar') {
                    glPersonalDetailsVm.isMaskAd = true;
                    glPersonalDetailsVm.detail.aadhaar = glPersonalDetailsVm.masterData.aadhaar;
                } else if (idType == 'nmobile') {
                    glPersonalDetailsVm.isMaskMobile = true;
                    glPersonalDetailsVm.detail.mobile = glPersonalDetailsVm.masterData.mobile;
                } else if (idType == 'nemail') {
                    glPersonalDetailsVm.isMaskEmail = true;
                    glPersonalDetailsVm.detail.email = glPersonalDetailsVm.masterData.email;
                } 
            }

        }

        glPersonalDetailsVm.validateForm = function(){
            glPersonalDetailsVm.errObj = {};
             if(goldLoanRLMSService.isValidField(glPersonalDetailsVm.residType,"Residential Type")) {
                glPersonalDetailsVm.errObj.residTypeError = goldLoanRLMSService.isValidField(glPersonalDetailsVm.residType,"Residential Type");
            }
			if(goldLoanRLMSService.isValidField(glPersonalDetailsVm.occupationType,"Occupation Type")) {
                glPersonalDetailsVm.errObj.occupationTypeError = goldLoanRLMSService.isValidField(glPersonalDetailsVm.occupationType,"Occupation Type");
            }
             if(goldLoanRLMSService.isValidField(glPersonalDetailsVm.monthlyIncome,"Net Monthly Income (in INR)")) {
                glPersonalDetailsVm.errObj.monthlyIncomeError = goldLoanRLMSService.isValidField(glPersonalDetailsVm.monthlyIncome,"Net Monthly Income (in INR)");
            }

            if(parseFloat(glPersonalDetailsVm.monthlyIncome) <= 0) {
                glPersonalDetailsVm.errObj.monthlyIncomeError = "Please provide valid Net Monthly Income (in INR)";
            }
            $ionicScrollDelegate.scrollBottom();

            return (angular.equals({}, glPersonalDetailsVm.errObj)) ? true : false;
        }

		glPersonalDetailsVm.goBack = function () {
			$state.go('menu.loans');
		}
			

		glPersonalDetailsVm.goToNextPage = function () {

          if(glPersonalDetailsVm.validateForm()) { 
			if(glPersonalDetailsVm.personalDetailCheck == true){
                goldLoanRLMSService.monthlyIncome = glPersonalDetailsVm.monthlyIncome;
				if(goldLoanRLMSService.resumeData) {
                	goldLoanRLMSService.resumeData.houseOwnership = glPersonalDetailsVm.residType.key;
					goldLoanRLMSService.resumeData.houseOwnershipValue = glPersonalDetailsVm.residType.value;
					goldLoanRLMSService.resumeData.occupationType = glPersonalDetailsVm.occupationType.key;
					goldLoanRLMSService.resumeData.occupationTypeValue = glPersonalDetailsVm.occupationType.value;
					goldLoanRLMSService.resumeData.netMonthlyIncome = glPersonalDetailsVm.monthlyIncome;
            	} else {
                	goldLoanRLMSService.userMaster.houseOwnership = glPersonalDetailsVm.residType.key;
					goldLoanRLMSService.userMaster.houseOwnershipValue = glPersonalDetailsVm.residType.value;
					goldLoanRLMSService.userMaster.occupationType = glPersonalDetailsVm.occupationType.key;
					goldLoanRLMSService.userMaster.occupationTypeValue = glPersonalDetailsVm.occupationType.value;
					goldLoanRLMSService.userMaster.netMonthlyIncome = glPersonalDetailsVm.monthlyIncome;
            	}
				var saveRequest = 
				{ 	
					"personalDetail":{
					"houseOwnership":glPersonalDetailsVm.residType.key ? glPersonalDetailsVm.residType.key : "",
					"houseOwnershipValue":glPersonalDetailsVm.residType.value ?  glPersonalDetailsVm.residType.value : "",
					"occupationType":glPersonalDetailsVm.occupationType.key ? glPersonalDetailsVm.occupationType.key : "",
					"occupationTypeValue":glPersonalDetailsVm.occupationType.value ? glPersonalDetailsVm.occupationType.value : "",
					"netMonthlyIncome":glPersonalDetailsVm.monthlyIncome ? glPersonalDetailsVm.monthlyIncome : "", 
					},
					"tnc": glPersonalDetailsVm.personalDetailCheck
				}
				goldLoanRLMSService.saveBasicDetail(saveRequest).then(function(data) {
                    if (data.status == "PSGL02") {
                        goldLoanRLMSService.dedupErrors = data.reasons;
                        $state.go('menu.goldLoanErrorRLMS');
                    }else if(data.status == "0000") {
					
                        goldLoanRLMSService.personalDetailCheck = true;
                        goldLoanRLMSService.setBasicDetailData(data);                                           
						$state.go("menu.goldOrnamentDetailsRLMS");                       
                    }                    
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
                    glPersonalDetailsVm.errorCheck = false;
				});				
			}else{
				glPersonalDetailsVm.errorCheck = true;
				$ionicScrollDelegate.scrollBottom();
			}
          }			  
		}		

		$scope.$on('$ionicView.loaded', function () {
			//initPage();
		});

		$scope.$on('$ionicView.beforeEnter', function () {
			initPage();
		});

		return this;
	}
		
]);


