'use strict';

angularApp.controller('glSelectBranchRLMSController', ["$state",
    "$scope",
    "aoService",
    "$ionicHistory",
    "$translate",
    "currentLocationService",
    "utilityService",
    "selectBranchListService",
    "goldLoanRLMSService",
    "$ionicScrollDelegate",

    function($state,
        $scope,
        aoService,
        $ionicHistory,
        $translate,
        currentLocationService,
        utilityService,
        selectBranchListService,
        goldLoanRLMSService,
        $ionicScrollDelegate) {

        var glSelectBranchVm = this;   

        function initPage() {
            glSelectBranchVm.homeBranchDetails = {};
            glSelectBranchVm.noBranchSelected = false;
            glSelectBranchVm.branchSelected = "";
            glSelectBranchVm.previouslySelectedBranch = "";      
            glSelectBranchVm.goldPointBranches = goldLoanRLMSService.locateBranches;
            glSelectBranchVm.onlyGoldBranches = [];
          
            glSelectBranchVm.homeBranchDetails.branchName = goldLoanRLMSService.selectedAccount.selectedAccountBranchName;
            glSelectBranchVm.homeBranchDetails.brCode = goldLoanRLMSService.selectedAccount.selectedAccountBranchCode;
            
            glSelectBranchVm.homeBranch = glSelectBranchVm.homeBranchDetails.branchName + ' | ' + glSelectBranchVm.homeBranchDetails.brCode;
            // glSelectBranchVm.goldPointBranches = [{"branchName":"BELPAUR BHAVAN SEC 3 BELAPUR","address":"PB NO 11 BELAPUR BHAVAN,SECTOR 11 OFFICE NO 3,CBD BELAPUR, NAVIMUMBAI400614","pincode":"400614","phoneNumber":"27574506","city":"MUMBAI","state":"MAHARASHTRA","id":"40524","latitude":"19.0197419","longitude":"73.0420058","goldPoint":"Y"},{"branchName":"VICHUMBE","address":"GROUND FLOOR GAT NO.173, AT+PO,VICHUMBE, TAL PANVEL,RAIGAD","pincode":"410206","phoneNumber":"205061 / 67","city":"MUMBAI","state":"MAHARASHTRA","id":"71073","latitude":"19.0186613","longitude":"73.0402563","goldPoint":"N"},{"branchName":"MONARCH PLAZA BR. BELAPUR","address":"SHOP NO. 12 & 13,MONARCH PLAZA,,PLOT NO. 56, SECTOR NO. 11, CBD BELAPUR,NAVI MUMBAI","pincode":"400614","phoneNumber":"27565673","city":"MUMBAI","state":"MAHARASHTRA","id":"32190","latitude":"19.014951","longitude":"73.0391501","goldPoint":"Y"}];
            
            if(goldLoanRLMSService.getBasicDetailData().selectedBranch) {
                glSelectBranchVm.previouslySelectedBranch = goldLoanRLMSService.getBasicDetailData().selectedBranch;
                glSelectBranchVm.branchSelected = glSelectBranchVm.previouslySelectedBranch;
            }
        }

        glSelectBranchVm.selectBranch = function(loc,index){
            glSelectBranchVm.branchSelected = loc;           
            goldLoanRLMSService.selectedBranch = loc;
            glSelectBranchVm.selectedIndexLocation = index;
            glSelectBranchVm.branchError = "";
        }

        glSelectBranchVm.openMaps = function(loc){
             var geocoords = loc.latitude + "," + loc.longitude;
             if (utilityService.isIOSPlatform()) {
                cordova.ThemeableBrowser.open('https://www.google.com/maps/search/?api=1&query=' + geocoords, '_blank',
                {
                    statusbar: {
                        color:'#ffffffff'
                    },
                    toolbar: {
                        height: 37,
                        color: '#ffffffff',
                        image: 'share'
                    },

                    closeButton: {
                        image:'back',
                        height: 37,
                        width: 32,
                        align: 'left',
                        event: 'closePressed'
                    },

                    backButtonCanClose: true
                });
            }else {
                var label = encodeURI('Your Destination'); // encode the label!
                window.open('geo:0,0?q=' + geocoords + '(' + label + ')', '_system');
            }
        } 

        glSelectBranchVm.selectHomeBranch = function() {  
            glSelectBranchVm.goToSummary();
        }

        glSelectBranchVm.goToNextPage = function() {
            if(glSelectBranchVm.branchSelected) {
                glSelectBranchVm.homeBranchDetails.branchName = glSelectBranchVm.branchSelected.branchName;
                glSelectBranchVm.homeBranchDetails.brCode = glSelectBranchVm.branchSelected.brCode;
                glSelectBranchVm.homeBranchDetails.circle = glSelectBranchVm.branchSelected.circle;
                glSelectBranchVm.homeBranchDetails.officeType = glSelectBranchVm.branchSelected.officeType;
                glSelectBranchVm.homeBranchDetails.add1 = glSelectBranchVm.branchSelected.add1;
                glSelectBranchVm.homeBranchDetails.add2 = glSelectBranchVm.branchSelected.add2;
                glSelectBranchVm.homeBranchDetails.add3 = glSelectBranchVm.branchSelected.add3;
                glSelectBranchVm.homeBranchDetails.pinCode = glSelectBranchVm.branchSelected.pinCode;
                glSelectBranchVm.homeBranchDetails.phone = glSelectBranchVm.branchSelected.phone;
                glSelectBranchVm.homeBranchDetails.mobNo = glSelectBranchVm.branchSelected.mobNo;
                glSelectBranchVm.homeBranchDetails.bmCell = glSelectBranchVm.branchSelected.bmCell;
                glSelectBranchVm.homeBranchDetails.email = glSelectBranchVm.branchSelected.email;
                glSelectBranchVm.homeBranchDetails.latitude = glSelectBranchVm.branchSelected.latitude;
                glSelectBranchVm.homeBranchDetails.longitude = glSelectBranchVm.branchSelected.longitude;
                glSelectBranchVm.homeBranchDetails.gPoint = glSelectBranchVm.branchSelected.gPoint;
                glSelectBranchVm.goToSummary();
            }
            else if(!glSelectBranchVm.branchSelected || glSelectBranchVm.goldPointBranches.length == 0){
                glSelectBranchVm.noBranchSelected = true;
                $ionicScrollDelegate.scrollTop();
            }
        }

        glSelectBranchVm.goToSummary = function() {
           var appRequest = {
                    "selectedBranch": {
                    "brCode" : glSelectBranchVm.homeBranchDetails.brCode ? glSelectBranchVm.homeBranchDetails.brCode : "",
                    "branchName" : glSelectBranchVm.homeBranchDetails.branchName ? glSelectBranchVm.homeBranchDetails.branchName : "",
                    "circle": glSelectBranchVm.homeBranchDetails.circle ? glSelectBranchVm.homeBranchDetails.circle : "",
                    "officeType": glSelectBranchVm.homeBranchDetails.officeType ? glSelectBranchVm.homeBranchDetails.officeType : "",
                    "add1": glSelectBranchVm.homeBranchDetails.add1 ? glSelectBranchVm.homeBranchDetails.add1 : "",
                    "add2": glSelectBranchVm.homeBranchDetails.add2 ? glSelectBranchVm.homeBranchDetails.add2 : "",
                    "add3": glSelectBranchVm.homeBranchDetails.add3 ? glSelectBranchVm.homeBranchDetails.add3 : "",
                    "pinCode": glSelectBranchVm.homeBranchDetails.pinCode ? glSelectBranchVm.homeBranchDetails.pinCode : "",
                    "phone": glSelectBranchVm.homeBranchDetails.phone ? glSelectBranchVm.homeBranchDetails.phone : "",
                    "mobNo": glSelectBranchVm.homeBranchDetails.mobNo ? glSelectBranchVm.homeBranchDetails.mobNo : "",
                    "bmCell": glSelectBranchVm.homeBranchDetails.bmCell ? glSelectBranchVm.homeBranchDetails.bmCell : "",
                    "email": glSelectBranchVm.homeBranchDetails.email ? glSelectBranchVm.homeBranchDetails.email : "",
                    "latitude": glSelectBranchVm.homeBranchDetails.latitude ? glSelectBranchVm.homeBranchDetails.latitude : "",
                    "longitude": glSelectBranchVm.homeBranchDetails.longitude ? glSelectBranchVm.homeBranchDetails.longitude : "",
                    "gPoint": glSelectBranchVm.homeBranchDetails.gPoint ? glSelectBranchVm.homeBranchDetails.gPoint : ""
                }
            }

            goldLoanRLMSService.getLoanSummary(appRequest).then(function(data) {
                goldLoanRLMSService.getBasicDetailData().selectedBranch = appRequest.selectedBranch;
                console.log(data);
                goldLoanRLMSService.setLoanSummaryData(data);                 
                $state.go('menu.glLoanSummaryRLMS');
            },function(error){
                utilityService.showErrorMessage(error.responseMessage);
            });  
        }

        glSelectBranchVm.goBack = function() {
            $state.go('menu.glAdditionalDetailsRLMS');
        }


        glSelectBranchVm.selectByGPS = function() {
            // $state.go('menu.glBranchesNearRLMS');
            glSelectBranchVm.findBranchesByGPS();
        }

        glSelectBranchVm.findBranchesByGPS = function() {
            goldLoanRLMSService.onlyGoldBranches = false ;
            utilityService.showSpinner();
            // CheckGPS.check(function () {
                currentLocationService.getCurrentPosition().then(
                    function (position) {
                        utilityService.hideSpinner();
                        goldLoanRLMSService.geocoords = position.coords.latitude + "," + position.coords.longitude;
                        var latitude = position.coords.latitude;
                        var longitude = position.coords.longitude;
                        goldLoanRLMSService.locateByGPS.length = 0;
                        var params = {
                            "latitude": latitude.toString(),
                            "longitude": longitude.toString(),
                            "goldPoint": goldLoanRLMSService.onlyGoldBranches
                        }
                        
                        if (utilityService.isUndefined(goldLoanRLMSService.locateByGPS) || goldLoanRLMSService.locateByGPS.length === 0) {
                            //service call
                            goldLoanRLMSService.getBranchListByGeo(params).then(function (data) {
                                if (!utilityService.isUndefined(data)) {
                                    goldLoanRLMSService.locateByGPS = [];
                                    for (var i = 0; i < data.length; i++) {
                                        goldLoanRLMSService.locateByGPS.push(data[i]);                                                                               
                                        goldLoanRLMSService.selectedBranch = "";
                                    }
                                    glSelectBranchVm.onlyGoldBranches = angular.copy(goldLoanRLMSService.locateByGPS); 
                                    for(var i = glSelectBranchVm.onlyGoldBranches.length; i--;) {
                                        if(glSelectBranchVm.onlyGoldBranches[i].gPoint == 'N') {
                                            glSelectBranchVm.onlyGoldBranches.splice(i,1);
                                        }                    
                                    }
                                    if(glSelectBranchVm.onlyGoldBranches.length == 0 || goldLoanRLMSService.locateByGPS.length == 0){
                                        utilityService.hideSpinner();
                                        $state.go('menu.glBranchesNearRLMS');
                                        goldLoanRLMSService.showAlertPopup("","No YONO Gold Point branch available near you.","",
                                                    "menu.glBranchesNearRLMS","OK","","","");                                        
                                    }else{
                                        $state.go('menu.glBranchesNearRLMS');
                                    }

                                    //setTimeout(function () {                                      
                                     // }, 2000);
                                    }
                                }, function (error) {
                                    utilityService.showErrorMessage(error.responseMessage);                                    
                                });
                            } 
                    },function (err) {
                        //Location permission off
                        utilityService.hideSpinner();
                        
                        // if(goldLoanRLMSService.gpsState == "off"){
                        //     $state.go('menu.glSelectBranchRLMS');
                        //     goldLoanRLMSService.gpsState = "";
                        // }else{
                           goldLoanRLMSService.onlyGoldBranches = false;
                           $state.go('menu.glGPSErrorRLMS'); 
                        //}
                    }                    
                );
            // },function () {
            //     //GPS off
            //     utilityService.hideSpinner();
            //     if(goldLoanRLMSService.gpsState == "off" || $stateParams.gps == "off"){
            //         $state.go('menu.glSelectBranchRLMS');
            //         goldLoanRLMSService.gpsState = "";
            //     }else{
            //         $state.go('menu.glGPSErrorRLMS'); 
            //     }
                
            // });  

        }
       

        glSelectBranchVm.selectByLocationCode = function(){
            var appRequest = {};

            goldLoanRLMSService.getBranchState(appRequest).then(function(data) {
                console.log(data);
                goldLoanRLMSService.setBranchStateData(data);                 
                $state.go('menu.glSelectBranchLocCodeRLMS');
            },function(error){
                utilityService.showErrorMessage(error.responseMessage);
            }); 
        }

      

       
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            
        });

        return this;
    }
]);