'use strict';

angularApp.controller('glSelectBranchLocCodeListRLMSController', [
    "$state",
    "$scope",
    "$translate",  
    "$ionicSideMenuDelegate",
    "$filter", "goldLoanRLMSService", "$ionicPopover", "$ionicPopup", "$ionicScrollDelegate", "utilityService",

    function($state,
        $scope,
        $translate,        
        $ionicSideMenuDelegate,
        $filter, goldLoanRLMSService, $ionicPopover, $ionicPopup, $ionicScrollDelegate, utilityService) {

        var glSelectBranchLocCodeListVm = this;

        function initPage() {
            glSelectBranchLocCodeListVm.branchError = "";           

            if(!goldLoanRLMSService.selectedBranch){
                glSelectBranchLocCodeListVm.selectedIndexLocation = 10000;
            }

            if(goldLoanRLMSService.getBranchByLocationData()) {
                glSelectBranchLocCodeListVm.branchesByLoCode = goldLoanRLMSService.getBranchByLocationData().branch;
            }

            if(goldLoanRLMSService.getBranchByCodeData()) {
                glSelectBranchLocCodeListVm.branchesByLoCode = goldLoanRLMSService.getBranchByCodeData().branch;
            }

            // glSelectBranchLocCodeListVm.branchesByLoCode = goldLoanRLMSService.locCodeList;
        };

        glSelectBranchLocCodeListVm.selectBranch = function(loc,index){
            glSelectBranchLocCodeListVm.selectedBranch = loc;
            goldLoanRLMSService.selectedBranch = glSelectBranchLocCodeListVm.selectedBranch;
            glSelectBranchLocCodeListVm.selectedIndexLocation = index;
            glSelectBranchLocCodeListVm.branchError = "";
        }

        glSelectBranchLocCodeListVm.openMaps = function(loc){
             var geocoords = loc.latitude + "," + loc.longitude;
             if (utilityService.isIOSPlatform()) {
                cordova.ThemeableBrowser.open('https://www.google.com/maps/search/?api=1&query='+geocoords, '_blank',
                {
                    statusbar: {
                        color:'#ffffffff'
                    },
                    toolbar: {
                        height: 37,
                        color: '#ffffffff',
                        image: 'share'
                    },

                    closeButton: {
                        image:'back',
                        height: 37,
                        width: 32,
                        align: 'left',
                        event: 'closePressed'
                    },

                    backButtonCanClose: true
                });
            }else {
                var label = encodeURI('Your Destination'); // encode the label!
                window.open('geo:0,0?q=' + geocoords + '(' + label + ')', '_system');
            }
         }

        glSelectBranchLocCodeListVm.goBack = function() {
            $state.go('menu.glSelectBranchLocCodeRLMS');
        };

        glSelectBranchLocCodeListVm.goToNextPage = function() {
            glSelectBranchLocCodeListVm.branchError = "";

            if(glSelectBranchLocCodeListVm.branchesByLoCode.length > 0 && glSelectBranchLocCodeListVm.selectedBranch) {
                var appRequest = {
                    "selectedBranch": {
                        "brCode" : glSelectBranchLocCodeListVm.selectedBranch.brCode ? glSelectBranchLocCodeListVm.selectedBranch.brCode : "",
                        "branchName" : glSelectBranchLocCodeListVm.selectedBranch.branchName ? glSelectBranchLocCodeListVm.selectedBranch.branchName : "",
                        "circle": glSelectBranchLocCodeListVm.selectedBranch.circle ? glSelectBranchLocCodeListVm.selectedBranch.circle : "",
                        "officeType": glSelectBranchLocCodeListVm.selectedBranch.officeType ? glSelectBranchLocCodeListVm.selectedBranch.officeType : "",
                        "add1": glSelectBranchLocCodeListVm.selectedBranch.add1 ? glSelectBranchLocCodeListVm.selectedBranch.add1 : "",
                        "add2": glSelectBranchLocCodeListVm.selectedBranch.add2 ? glSelectBranchLocCodeListVm.selectedBranch.add2 : "",
                        "add3": glSelectBranchLocCodeListVm.selectedBranch.add3 ? glSelectBranchLocCodeListVm.selectedBranch.add3 : "",
                        "pinCode": glSelectBranchLocCodeListVm.selectedBranch.pinCode ? glSelectBranchLocCodeListVm.selectedBranch.pinCode : "",
                        "phone": glSelectBranchLocCodeListVm.selectedBranch.phone ? glSelectBranchLocCodeListVm.selectedBranch.phone : "",
                        "mobNo": glSelectBranchLocCodeListVm.selectedBranch.mobNo ? glSelectBranchLocCodeListVm.selectedBranch.mobNo : "",
                        "bmCell": glSelectBranchLocCodeListVm.selectedBranch.bmCell ? glSelectBranchLocCodeListVm.selectedBranch.bmCell : "",
                        "email": glSelectBranchLocCodeListVm.selectedBranch.email ? glSelectBranchLocCodeListVm.selectedBranch.email : "",
                        "latitude": glSelectBranchLocCodeListVm.selectedBranch.latitude ? glSelectBranchLocCodeListVm.selectedBranch.latitude : "",
                        "longitude": glSelectBranchLocCodeListVm.selectedBranch.longitude ? glSelectBranchLocCodeListVm.selectedBranch.longitude : "",
                        "gPoint": glSelectBranchLocCodeListVm.selectedBranch.gPoint ? glSelectBranchLocCodeListVm.selectedBranch.gPoint : ""
                    }
                }

            goldLoanRLMSService.getLoanSummary(appRequest).then(function(data) {
                goldLoanRLMSService.getBasicDetailData().selectedBranch = appRequest.selectedBranch;
                console.log(data);
                goldLoanRLMSService.setLoanSummaryData(data);                 
                $state.go('menu.glLoanSummaryRLMS');
            },function(error){
                utilityService.showErrorMessage(error.responseMessage);
            });                                    
                
            }else{
                glSelectBranchLocCodeListVm.branchError = true;
                $ionicScrollDelegate.scrollTop();
            }   
        };

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        return this;
    }
]);