'use strict';

angularApp.controller('goldKnowMoreRLMSController', [
    "$state",
    "$scope",
    "$translate",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService", 
    "$filter",
    "goldLoanRLMSService",

    function($state,
        $scope,
        $translate,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        $filter,
        goldLoanRLMSService) {

        var goldKnowMoreVm = this;

        goldKnowMoreVm.initPage = function () {
            goldKnowMoreVm.tab = 1;

            goldKnowMoreVm.glKnowMoreDetails = goldLoanRLMSService.getGLLoanDetails().getLoansDetails;

            goldKnowMoreVm.source = "img/goldLoan/PGL_Process.svg";              
            goldKnowMoreVm.features = goldKnowMoreVm.glKnowMoreDetails.features;
            goldKnowMoreVm.prerequisites = goldKnowMoreVm.glKnowMoreDetails.prerequisites;
            goldKnowMoreVm.interest = goldKnowMoreVm.glKnowMoreDetails.interest;
            if (goldLoanRLMSService.getYonoDedupeData().status == '0') {
                goldKnowMoreVm.buttonText = "Apply Now";
            }else if(goldLoanRLMSService.getYonoDedupeData().status == '1'){
                goldKnowMoreVm.buttonText = "Resume";
            }else if(goldLoanRLMSService.getYonoDedupeData().status == '2'){
                goldKnowMoreVm.buttonText = "Retrieve";
            }
        }

        goldKnowMoreVm.goback = function() {
            $ionicHistory.goBack(-1);
        };


        $scope.$on('$ionicView.beforeEnter', function() {
            goldKnowMoreVm.initPage();          
        });

        goldKnowMoreVm.selTab = function(sel) {
            goldKnowMoreVm.tab = sel;
        }

        goldKnowMoreVm.applyNewGoldLoan = function() {
            var request = {
                    "loanType": "gold"
                }
            if (goldLoanRLMSService.getYonoDedupeData().status == '0') {
                goldLoanRLMSService.getEligiblityCheck(request).then(function(data) {
                    goldLoanRLMSService.homeBranch=data.homeBranch;
                    goldLoanRLMSService.setGroupId("gold");
                    goldLoanRLMSService.userMaster = data;
                    if (data.status == "PSGL02") {
                        goldLoanRLMSService.dedupErrors = data.reasons;
                        $state.go('menu.goldLoanErrorRLMS');
                    }else if(data.status == "0000") {
                        $state.go('menu.glPersonalDetailsRLMS');                            
                    }
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }else if(goldLoanRLMSService.getYonoDedupeData().status == '1'){
                goldLoanRLMSService.getEligiblityCheck(request).then(function(data) {
                    goldLoanRLMSService.homeBranch = data.homeBranch;
                    goldLoanRLMSService.setGroupId("gold");
                    goldLoanRLMSService.resumeData = data;
                    if (data.status == "PSGL02") {
                        goldLoanRLMSService.dedupErrors = data.reasons;
                        $state.go('menu.goldLoanErrorRLMS');
                    }else if(data.status == "0000") {
                        $state.go('menu.glApplicationStatusRLMS');                       
                    }
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }else if(goldLoanRLMSService.getYonoDedupeData().status == '2'){
                goldLoanRLMSService.getApplicationStatus(request).then(function(data) {
                    goldLoanRLMSService.homeBranch = data.homeBranch;
                    goldLoanRLMSService.setGroupId("gold");
                    goldLoanRLMSService.retrieveData = data;
                    $state.go('menu.glApplicationStatusRLMS');
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } 
        }

        return this;
    }
]);