'use strict';

angularApp.service('goldLoanRLMSService',
    function($q, AdapterUtils, utilityService, constantConfig, $ionicPopup, $state, $ionicScrollDelegate) {

        var goldLoanRLMSService = this;

        var homePageDetails,loanDetails,yonoDedupeData,buttonText,groupId,basicDetailData,schemeDetailData,additionDetailData,branchDetailData,
        branchStateData,branchByLocationData,branchByCodeData,loanSummaryData,submittedApplicationData;

        this.geocoords = "";
        this.locateByGPS = [];
        this.locateBranches = [];
        this.selectedAccount = {};
        this.schemeEMI = 0;
        this.selectedBranch = "";
        this.selectedMethod = "";
        this.gpsState = "";
        this.totalOrnaments = "";
        this.locCodeList = "";
        this.resumeData = "";
        this.retrieveData = "";
        this.onlyGoldBranches = "";
        this.personalDetailCheck = false;
        this.monthlyIncome = 0;

        goldLoanRLMSService.clearAll = function(){
            homePageDetails= null;loanDetails= null;yonoDedupeData=null;buttonText=null;groupId=null;basicDetailData=null;schemeDetailData=null;
            additionDetailData=null;branchDetailData=null;branchStateData=null;branchByLocationData=null;branchByCodeData=null;loanSummaryData=null;
            submittedApplicationData=null;
        }

        goldLoanRLMSService.clearData = function(){
        }

        // Setter/Getter

        goldLoanRLMSService.setGLLoanDetails = function(data) {
            loanDetails = data;
        };

        goldLoanRLMSService.getGLLoanDetails = function() {
            return loanDetails;
        };

        goldLoanRLMSService.setYonoDedupeData = function(data) {
            yonoDedupeData = data;
        }

        goldLoanRLMSService.getYonoDedupeData = function(data) {
            return yonoDedupeData;
        }

        goldLoanRLMSService.setButtonText = function(text) {
            buttonText = text;
        };

        goldLoanRLMSService.getButtonText = function() {
            return buttonText;
        };

        goldLoanRLMSService.setGroupId = function(id) {
            groupId = id;
        }

        goldLoanRLMSService.getGroupId = function() {
            return groupId;
        }

        goldLoanRLMSService.setBasicDetailData = function(data) {
            basicDetailData = data;
        }

        goldLoanRLMSService.getBasicDetailData = function(data) {
            return basicDetailData;
        }

        goldLoanRLMSService.setSchemeDetailData = function(data) {
            schemeDetailData = data;
        }

        goldLoanRLMSService.getSchemeDetailData = function(data) {
            return schemeDetailData;
        }

        goldLoanRLMSService.setAdditionDetailData = function(data) {
            additionDetailData = data;
        }

        goldLoanRLMSService.getAdditionDetailData = function(data) {
            return additionDetailData;
        }

        goldLoanRLMSService.setBranchDetailData = function(data) {
            branchDetailData = data;
        }

        goldLoanRLMSService.setBranchDetailData = function(data) {
            return branchDetailData;
        }

        goldLoanRLMSService.setBranchStateData = function(data) {
            branchStateData = data;
        }

        goldLoanRLMSService.getBranchStateData = function(data) {
            return branchStateData;
        }

        goldLoanRLMSService.setBranchByLocationData = function(data) {
            branchByLocationData = data;
        }

        goldLoanRLMSService.getBranchByLocationData = function(data) {
            return branchByLocationData;
        }

        goldLoanRLMSService.setBranchByCodeData = function(data) {
            branchByCodeData = data;
        }

        goldLoanRLMSService.getBranchByCodeData = function(data) {
            return branchByCodeData;
        }

        goldLoanRLMSService.setLoanSummaryData = function(data) {
            loanSummaryData = data;
        }

        goldLoanRLMSService.getLoanSummaryData = function(data) {
            return loanSummaryData;
        }

        goldLoanRLMSService.setSubmittedApplicationData = function(data) {
            submittedApplicationData = data;
        }

        goldLoanRLMSService.getSubmittedApplicationData = function(data) {
            return submittedApplicationData;
        }


        // Validations

        goldLoanRLMSService.isValidField = function(ornament,field) {
            if (!ornament) {
                return 'Please provide ' +field;
            }
            return false;
        }; 

        goldLoanRLMSService.isValidFieldEMI = function(ornament,type) {
            if (!ornament) {
                if(type == 'loanType'){
                    return 'Enter EMI type';
                }
                if(type = 'amount'){
                    return 'Enter EMI (INR)';
                }
                
            }
            return false;
        }; 

        goldLoanRLMSService.emiCalculation = function(p,i,t){
            p = parseInt(p);
            i = parseFloat(i)/1200;
            t = parseInt(t);
            var numerator = p * i * Math.pow((1+i),t);
            var denominator = Math.pow((1+i),t) - 1;
            var emiAmount = Math.ceil((numerator/denominator));
            return emiAmount;
        }

        goldLoanRLMSService.monthlyInterestCalculation = function(p,r,t){
            var months = parseInt(t);
            p = parseInt(p);
            r = parseFloat(r)/100;
            t = parseFloat(t)/12;
            var interest = Math.ceil(p * r * t);
            var monthlyInterest = Math.ceil(interest/months);
            return monthlyInterest;
        }


        // API call

        goldLoanRLMSService.getYonoDedupe = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/psg/v2/getYonoDedup", {}, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        goldLoanRLMSService.getLoanDetail = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/psg/getLoanDetail", {}, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        goldLoanRLMSService.getEligiblityCheck = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/psg/v2/getEligiblityCheck", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        goldLoanRLMSService.getApplicationStatus = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/psg/applicationStatus", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        goldLoanRLMSService.getUnmaskData = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/psg/getUnmaskData", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        goldLoanRLMSService.saveBasicDetail = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/psg/v2/saveBasicDetail", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        goldLoanRLMSService.getSchemeDetail = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/psg/v2/getSchemeDetail", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        goldLoanRLMSService.getAdditionalDetail = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/psg/v2/getAdditionalDetail", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        goldLoanRLMSService.getBranchDetail = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/psg/v2/getBranchDetail", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        goldLoanRLMSService.getBranchState = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/psg/getBranchState", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        goldLoanRLMSService.getBranchCity = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/psg/getBranchCity", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        goldLoanRLMSService.getBranchArea = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/psg/getBranchArea", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        goldLoanRLMSService.getBranchByLocation = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/psg/getBranchByLocation", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        goldLoanRLMSService.getBranchByCode = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/psg/getBranchByCode", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        goldLoanRLMSService.getLoanSummary = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/psg/getLoanSummary", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        goldLoanRLMSService.submitApplication = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/psg/v2/submitApplication", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        goldLoanRLMSService.deleteApplication = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/psg/deleteApplication", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        goldLoanRLMSService.getBranchListByGeo = function(payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/psg/getBranchListByGeo", payLoad, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        goldLoanRLMSService.getDocument = function(payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/psg/getDocument", payLoad, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
      
       
  
        goldLoanRLMSService.showAlertPopup = function (imageType, message1, message2, onTapgo, buttontext1, buttontext2, $scope, obj, i) {
            var btn_array = [];
            if(buttontext1 != "" && buttontext2 != ""){
                btn_array = [
                    {
                        text: buttontext2 || "Cancel",
                        type: 'button-negative',
                        onTap: function () {
                            
                        }
                    },
                    {
                        text: buttontext1 || "OK",
                        type: 'button-positive',
                        onTap: function () {
                            if (onTapgo) {
                                if(i >= 0) {
                                    obj.items.splice(i,1);
                                    if(obj.items.length < 20) {
                                        obj.limitExceeded = false;
                                    }                                 
                                }
                                $state.go(onTapgo);
                                $ionicScrollDelegate.resize();                               
                            }
                        }
                    }
                ];
            }
            else{
                btn_array = [
                    {
                        text: buttontext1 || "OK",
                        type: 'button-positive',
                        onTap: function () {
                            if (onTapgo) {
                                $state.go(onTapgo);
                            }
                        }
                    }
                ];
            }

            if(imageType && imageType.toLowerCase() == 'error'){
                imageType = '<div><img class="approvedIconPosition" src="img/FT/BhimUpi/errorSymbol.svg"/></div>';
            } else if(imageType && imageType.toLowerCase() == 'success'){
                imageType = '<div><img class="approvedIconPosition" src="img/FT/BhimUpi/successSymbol.svg"/></div>';
            }else if(imageType && imageType.toLowerCase() == 'alert'){
                imageType = '<div><img class="approvedIconPosition" src="img/FT/BhimUpi/alertSymbol.svg"/></div>';
            }else{
                imageType = "";
            }
            var bhimErrorPopup = $ionicPopup.alert({
                template: '<div class="font-dark-grey">'+imageType+'<div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter roboto-medium font-size-16 color-darkgrey"><span>'
                + message1 + '</span><div class="textAlignCenter roboto-regular font-size-14 color-darkgrey padTop10">'+message2+'</div></div></div></div>', //template,
                scope: $scope,
                cssClass: 'bhim-alert-popup',
                buttons: btn_array,
            });
            bhimErrorPopup.then(function (res) {
            });
        };

        goldLoanRLMSService.updateSchemeDetail = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/psg/v2/updateSchemeDetail", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        return goldLoanRLMSService;

    });