'use strict';

angularApp.controller('goldOrnamentDetailsRLMSController', [
    "$state",
    "$scope",
    "$translate",  
    "$ionicSideMenuDelegate",
    "$filter", "goldLoanRLMSService", "$ionicPopover", "$ionicScrollDelegate", "utilityService",

    function($state,
        $scope,
        $translate,        
        $ionicSideMenuDelegate,
        $filter, goldLoanRLMSService, $ionicPopover, $ionicScrollDelegate, utilityService) {

        var goldOrnamentDetailsVm = this;
       

        function initPage() {
            goldOrnamentDetailsVm.errObj = {};
            goldOrnamentDetailsVm.totalCoinWeight = 0;
            goldOrnamentDetailsVm.items = [];
            goldOrnamentDetailsVm.isExpand = false;
            goldOrnamentDetailsVm.limitExceeded = false;
            goldOrnamentDetailsVm.ornamentDetailCheck = false;


            if(goldLoanRLMSService.getBasicDetailData().ornamentDetail) { 
                goldOrnamentDetailsVm.items = goldLoanRLMSService.getBasicDetailData().ornamentDetail;
                if(goldOrnamentDetailsVm.items.length > 0) {
                    goldOrnamentDetailsVm.ornamentDetailCheck = true;
                    for(var i=0; i < goldOrnamentDetailsVm.items.length; i++){
                        goldOrnamentDetailsVm.items[i].ornamentTypeValue = JSON.parse(goldOrnamentDetailsVm.items[i].ornamentTypeValue);
                        goldOrnamentDetailsVm.items[i].quantityValue = JSON.parse(goldOrnamentDetailsVm.items[i].quantityValue);
                        goldOrnamentDetailsVm.items[i].caratValue = JSON.parse(goldOrnamentDetailsVm.items[i].caratValue);
                    }
                }else{
                    goldOrnamentDetailsVm.addItem();
                }  
            }

            if (goldLoanRLMSService.resumeData || goldOrnamentDetailsVm.items.length > 0) {
                if(goldLoanRLMSService.resumeData){
                    goldOrnamentDetailsVm.masterData = angular.copy(goldLoanRLMSService.resumeData);
                }else{
                    goldOrnamentDetailsVm.masterData = angular.copy(goldLoanRLMSService.userMaster);
                } 
            } else {
                goldOrnamentDetailsVm.masterData = angular.copy(goldLoanRLMSService.userMaster);
                goldOrnamentDetailsVm.addItem();
            }

            goldOrnamentDetailsVm.ornamentTypeList = goldOrnamentDetailsVm.masterData.master.ornamentTypes;
            goldOrnamentDetailsVm.ornQtyList = goldOrnamentDetailsVm.masterData.master.quantities;
            goldOrnamentDetailsVm.ornamentCaratList = goldOrnamentDetailsVm.masterData.master.carats;

        };
        

        goldOrnamentDetailsVm.hideOrnaments = function(index) {
            $ionicScrollDelegate.resize();
            if(goldOrnamentDetailsVm.validateForm()){
                goldOrnamentDetailsVm.items[index].isExpand =!goldOrnamentDetailsVm.items[index].isExpand;
                for(var i= 0; i < goldOrnamentDetailsVm.items.length ; i++){
                    if(i != index){
                        goldOrnamentDetailsVm.items[i].isExpand = false;
                    }                
                }
            }
        }

        goldOrnamentDetailsVm.parseData = function (data) {
            console.log(data);
            return JSON.parse(data).value;
        }

        goldOrnamentDetailsVm.addItem = function() {

            goldOrnamentDetailsVm.ornament = {
                "ornamentTypeValue" : "",
                "subOrnamentType" : "",
                "quantityValue" : "",
                "caratValue" : "",
                "netWeight" : "",
                "isExpand" : true,
                "ornamentErrors" : {
                    "ornamentTypeErr" : "",
                    "otherOrnamentTypeErr" : "",
                    "ornamentQuantityErr" : "",
                    "ornamentCaratErr" : "",
                    "ornamentNetWeightErr" : "",
                    "ornamentNetWeightCoinErr" : ""
                }                
            };
           

            if(goldOrnamentDetailsVm.items.length < 5) { 
                if(goldOrnamentDetailsVm.validateForm()) {          
                    goldOrnamentDetailsVm.items.push(goldOrnamentDetailsVm.ornament);
                    var index = goldOrnamentDetailsVm.items.length - 1;
                    for(var i= 0; i < goldOrnamentDetailsVm.items.length ; i++){
                        if(i != index){
                            goldOrnamentDetailsVm.items[i].isExpand = false;
                        }                
                    }
                }
            }
            else{
                goldOrnamentDetailsVm.limitExceeded = true;
                $ionicScrollDelegate.scrollBottom();
            }            
     
        }


        goldOrnamentDetailsVm.deleteItem = function(i){
            goldLoanRLMSService.showAlertPopup("alert","Are you sure you want to delete this Ornament details?","This process cannot be reversed.",
                "menu.goldOrnamentDetailsRLMS","Yes, delete","Cancel",$scope,goldOrnamentDetailsVm,i);                      
        }

        // goldOrnamentDetailsVm.confirmOrnamentDetail = function(){
        //     goldOrnamentDetailsVm.ornamentDetailCheck = !goldOrnamentDetailsVm.ornamentDetailCheck;
        // }

        goldOrnamentDetailsVm.openGoldCoinInfo = function($event){
            goldOrnamentDetailsVm.leftStyle = "left : " + ($event.clientX - 30) + "px";           
            goldOrnamentDetailsVm.template = '<ion-popover-view class="loginnewarrow hmbr-info hmbr-info-popnew popOverGL" id="runtimeHeight" >' + '<div class="edu-arrow-downnew" style="{{goldOrnamentDetailsVm.leftStyle}}"></div>' + 
            '<a class="iconsubtext closeinfobutton float-right" id="CALL_ANC" click-stream="click" ng-click="goldOrnamentDetailsVm.closePopover()">' + '<i class="ico-close ver-align-middle"></i>' + '</a>' + '<ion-content class="col-90 nfs-popover" has-bouncing="false">' +
            '<div id="renderHeight" class="text-left padding-left-10 padding-right-10 font-size-12">'+
            '<div>Only specially minted gold coins sold by banks up to a weight of 50 grams are eligible.</div>' + 
            '</div>' + '</ion-content>' + '</ion-popover-view>';
            $scope.popover = $ionicPopover.fromTemplate(goldOrnamentDetailsVm.template, {
                scope: $scope
            });
            $scope.popover.show($event);
               
        }

        goldOrnamentDetailsVm.closePopover = function(){
            $scope.popover.hide();
        }

        goldOrnamentDetailsVm.goBack = function() {
            $state.go('menu.glPersonalDetailsRLMS');
        };

        goldOrnamentDetailsVm.validateForm = function(){
            goldOrnamentDetailsVm.errObj = {};
            goldOrnamentDetailsVm.totalCoinWeight = 0;

            for(var i=0; i < goldOrnamentDetailsVm.items.length; i++) {
                var ornament = goldOrnamentDetailsVm.items[i].ornamentTypeValue.value;
                if(goldLoanRLMSService.isValidField(ornament,"Ornament Type")){
                    goldOrnamentDetailsVm.items[i].ornamentErrors.ornamentTypeErr = goldLoanRLMSService.isValidField(ornament,"Ornament Type");
                    goldOrnamentDetailsVm.errObj.ornamentTypeErr = goldOrnamentDetailsVm.items[i].ornamentErrors.ornamentTypeErr;
                }
                else{                   
                    goldOrnamentDetailsVm.items[i].ornamentErrors={};                    
                }

                //for other type ornament
                if(goldOrnamentDetailsVm.items[i].ornamentTypeValue.key == '13') {
                    if(goldLoanRLMSService.isValidField(goldOrnamentDetailsVm.items[i].subOrnamentType,"Other Ornament Type")){
                        goldOrnamentDetailsVm.items[i].ornamentErrors.otherOrnamentTypeErr = goldLoanRLMSService.isValidField(goldOrnamentDetailsVm.items[i].subOrnamentType,"Other Ornament Type");
                        goldOrnamentDetailsVm.errObj.otherOrnamentTypeErr = goldOrnamentDetailsVm.items[i].ornamentErrors.otherOrnamentTypeErr;
                    }else{
                        goldOrnamentDetailsVm.items[i].ornamentErrors={};
                    }  
                }else{
                    goldOrnamentDetailsVm.items[i].subOrnamentType = "";
                }

                //for coin weight
                if(goldOrnamentDetailsVm.items[i].ornamentTypeValue.key == '12') { 
                    goldOrnamentDetailsVm.totalCoinWeight = parseFloat(goldOrnamentDetailsVm.totalCoinWeight) + parseFloat(goldOrnamentDetailsVm.items[i].netWeight);
                   
                    if(goldOrnamentDetailsVm.totalCoinWeight > 50) {
                        goldOrnamentDetailsVm.items[i].ornamentErrors.ornamentNetWeightCoinErr = "Please provide valid netweight for Gold coins (e.g. maximum 50 grams)";
                        goldOrnamentDetailsVm.errObj.ornamentNetWeightCoinErr = goldOrnamentDetailsVm.items[i].ornamentErrors.ornamentNetWeightCoinErr;
                    }else{
                        goldOrnamentDetailsVm.items[i].ornamentErrors={};
                    }
                }

                var quantity = goldOrnamentDetailsVm.items[i].quantityValue.value;
                if(goldLoanRLMSService.isValidField(quantity,"Quantity")) {
                    goldOrnamentDetailsVm.items[i].ornamentErrors.ornamentQuantityErr = goldLoanRLMSService.isValidField(quantity,"Quantity");
                    goldOrnamentDetailsVm.errObj.ornamentQuantityErr = goldOrnamentDetailsVm.items[i].ornamentErrors.ornamentQuantityErr;
                }else{
                    goldOrnamentDetailsVm.items[i].ornamentErrors={};
                }

                var carat = goldOrnamentDetailsVm.items[i].caratValue.value;
                if(goldLoanRLMSService.isValidField(carat,"Carat")) {
                    goldOrnamentDetailsVm.items[i].ornamentErrors.ornamentCaratError = goldLoanRLMSService.isValidField(carat,"Carat");
                    goldOrnamentDetailsVm.errObj.ornamentCaratError = goldOrnamentDetailsVm.items[i].ornamentErrors.ornamentCaratError;
                }else{
                    goldOrnamentDetailsVm.items[i].ornamentErrors={};
                }

                if(goldLoanRLMSService.isValidField(goldOrnamentDetailsVm.items[i].netWeight,"Net Weight")) {
                    goldOrnamentDetailsVm.items[i].ornamentErrors.ornamentNetWeightErr = goldLoanRLMSService.isValidField(goldOrnamentDetailsVm.items[i].netWeight,"Net Weight");
                    goldOrnamentDetailsVm.errObj.ornamentNetWeightErr = goldOrnamentDetailsVm.items[i].ornamentErrors.ornamentNetWeightErr;
                }else if(parseFloat(goldOrnamentDetailsVm.items[i].netWeight) == 0){
                    goldOrnamentDetailsVm.items[i].ornamentErrors.ornamentNetWeightErr = "Please provide valid Net Weight";
                    goldOrnamentDetailsVm.errObj.ornamentNetWeightErr = goldOrnamentDetailsVm.items[i].ornamentErrors.ornamentNetWeightErr;
                }else{
                    goldOrnamentDetailsVm.items[i].ornamentErrors={};
                }

                goldOrnamentDetailsVm.items[i].netWeight = parseFloat((goldOrnamentDetailsVm.items[i].netWeight).toString());            
            }

            return (angular.equals({}, goldOrnamentDetailsVm.errObj)) ? true : false;
        }

        

        goldOrnamentDetailsVm.goToNextPage = function() {
      
            if(goldOrnamentDetailsVm.validateForm()){
                if(goldOrnamentDetailsVm.ornamentDetailCheck == true){
                    var totalOrnaments = [];

                    console.log(goldOrnamentDetailsVm.items.length);

                    for(var i= 0; i < goldOrnamentDetailsVm.items.length ; i++){
                        var addOrnament = {
                            "ornamentType" : goldOrnamentDetailsVm.items[i].ornamentTypeValue.key,
                            "ornamentTypeValue" : goldOrnamentDetailsVm.items[i].ornamentTypeValue ? JSON.stringify(goldOrnamentDetailsVm.items[i].ornamentTypeValue) : "",
                            "subOrnamentType" : goldOrnamentDetailsVm.items[i].subOrnamentType ? goldOrnamentDetailsVm.items[i].subOrnamentType : "" ,
                            "quantity" : goldOrnamentDetailsVm.items[i].quantityValue ?  goldOrnamentDetailsVm.items[i].quantityValue.key : "",
                            "quantityValue" : goldOrnamentDetailsVm.items[i].quantityValue ?  JSON.stringify(goldOrnamentDetailsVm.items[i].quantityValue) : "",
                            "carat" : goldOrnamentDetailsVm.items[i].caratValue ? goldOrnamentDetailsVm.items[i].caratValue.key : "",
                            "caratValue" : goldOrnamentDetailsVm.items[i].caratValue ? JSON.stringify(goldOrnamentDetailsVm.items[i].caratValue) : "",
                            "netWeight" : goldOrnamentDetailsVm.items[i].netWeight ? goldOrnamentDetailsVm.items[i].netWeight : ""
                            // "bisHallmarked": goldOrnamentDetailsVm.items[i].bisHallmarked ? goldOrnamentDetailsVm.items[i].bisHallmarked : "",
                            // "grossWeight": goldOrnamentDetailsVm.items[i].ornamentNetWeight ? goldOrnamentDetailsVm.items[i].ornamentNetWeight : ""
                        };

                        totalOrnaments.push(addOrnament);
                    }
                

                var saveRequest = 
                    {
                        "ornamentDetail" : totalOrnaments ? totalOrnaments : null,
                        "tnc" : goldOrnamentDetailsVm.ornamentDetailCheck
                    }

                goldLoanRLMSService.getSchemeDetail(saveRequest).then(function(data) {
                    goldLoanRLMSService.getBasicDetailData().ornamentDetail = saveRequest.ornamentDetail;
                    /*console.log(data);*/
                    goldLoanRLMSService.setSchemeDetailData(data);                 
                    $state.go('menu.glLoanDetailsRLMS');
                },function(error){
                    utilityService.showErrorMessage(error.responseMessage);
                    goldOrnamentDetailsVm.errorCheck = false;
                });                    
                
            }else{
                goldOrnamentDetailsVm.errorCheck = true;
                $ionicScrollDelegate.scrollBottom();
            }
                
          }            
            
        };

        $scope.$on('$ionicView.beforeEnter', function() {
            if (utilityService.isIOSPlatform()) {
                goldOrnamentDetailsVm.scroll = false;
            } else {
                goldOrnamentDetailsVm.scroll = true;
            }
            initPage();            
        });

        goldOrnamentDetailsVm.openInfo = function ($event) {
            goldOrnamentDetailsVm.leftStyle = "left : " + ($event.clientX - 30) + "px";           
            goldOrnamentDetailsVm.template = '<ion-popover-view class="loginnewarrow hmbr-info gl-info-popnew-addGold gl-emi-info nfs-popover-height" id="runtimeHeight" >' + '<div class="edu-arrow-upnew" style="{{goldOrnamentDetailsVm.leftStyle}}"></div>' + 
            '<a class="iconsubtext closeinfobutton float-right" id="CALL_ANC" click-stream="click" ng-click="goldOrnamentDetailsVm.closePopover()">' + '<i class="ico-close ver-align-middle"></i>' + '</a>' + '<ion-content class="col-90  nfs-popover" has-bouncing="false">' +
            '<div id="renderHeight" class="text-left padding-left-10 padding-right-10 font-size-12">'+
            '<div>Enter details of maximum 5 ornament types.Ornaments of same caratage can be grouped together and added in ‘Other’ category.</div>' + 
            '</div>' + '</ion-content>' + '</ion-popover-view>';
            $scope.popover = $ionicPopover.fromTemplate(goldOrnamentDetailsVm.template, {
                scope: $scope
            });
            $scope.popover.show($event);
               
        }
        goldOrnamentDetailsVm.closePopover = function(){
            $scope.popover.hide();
        } 

        return this;
    }
]);