'use strict';

angularApp.controller('hlNTBEligibilityCheckDetailsController', [
    "$state",
    "$scope",
    "$translate",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService",
    "$filter",
    "hlNTBCalculatorService",
    "homeLoanService",

    function ($state,
        $scope,
        $translate,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        $filter,
        hlNTBCalculatorService,
        homeLoanService) {

        var hlNTBEligibilityCheckDetailsVm = this;

        hlNTBEligibilityCheckDetailsVm.initPage = function () {
            $scope.applicantDetail = {};
            $scope.coApplicantDetail = {};
            $scope.renderApplicatntOrCoApplicant = 'New';
            $scope.onceCoAppSelected = false;


            if (hlNTBCalculatorService.isCheckEligibilityBack) {
                if (hlNTBCalculatorService.coapplicantData.birthDate) {
                    $scope.applicantDetail = hlNTBCalculatorService.applicantData;
                    $scope.coApplicantDetail = hlNTBCalculatorService.coapplicantData;
                    $scope.renderApplicatntOrCoApplicant = 'CallBack';
                    hlNTBEligibilityCheckDetailsVm.selectedCO = 11;
                } else {
                    $scope.applicantDetail = hlNTBCalculatorService.applicantData;
                    hlNTBEligibilityCheckDetailsVm.selectedBD = 5;
                    setTimeout(function () {
                        hlNTBEligibilityCheckDetailsVm.updateBreadCrumb(5);

                    }, 1000);
                }
                setTimeout(function () {
                    hlNTBEligibilityCheckDetailsVm.isCoApplicantAdded($scope.applicantDetail.isCoApplicantAddedd);
                }, 1000);

            } else {
                $scope.applicantDetail.birthDate = new Date("01/01/2020");
                hlNTBEligibilityCheckDetailsVm.selectedBD = 1;
                hlNTBEligibilityCheckDetailsVm.selectedCO = 0;
                $scope.applicantDetail.gender = '';
                $scope.coApplicantDetail.gender = '';
                $scope.applicantDetail.incomeSource = '';
                $scope.coApplicantDetail.incomeSource = '';
                $scope.applicantDetail.retirementAge = '';
                $scope.coApplicantDetail.retirementAge = '';
                $scope.applicantDetail.netMonthlyIncome = '';
                $scope.coApplicantDetail.netMonthlyIncome = '';
                $scope.applicantDetail.emiPaying = '';
                $scope.coApplicantDetail.emiPaying = '';
                $scope.applicantDetail.isCoApplicantAddedd = '';
                $scope.applicantDetail.emiAndnmiConstraint = false;
                $scope.applicantDetail.activeTab = 1;
                $scope.applicantDetail.coActiveTab = 1
                $scope.applicantDetail.nextToUpdate = 0
                $scope.applicantDetail.coNextToUpdate = 0;
                $scope.applicantDetail.appDOBSelected = false;
                $scope.applicantDetail.incomeSourceText = '';
                $scope.coApplicantDetail.incomeSourceText = '';
            }

            $scope.breadcrumbList = [{ id: 1 },
            { id: 2 }, { id: 3 }, { id: 4 }, { id: 5 }, { id: 6 }]
            $scope.coBreadcrumbList = [{ id: 7 },
            { id: 8 }, { id: 9 }, { id: 10 }, { id: 11 }];
            hlNTBEligibilityCheckDetailsVm.updatedigest();
            setTimeout(function () {
                if (!hlNTBCalculatorService.isCheckEligibilityBack) {
                    document.getElementById('bd-1').classList.add('hl_check_detail_breardcrum_selected');
                }

            }, 500)
            $scope.isApplicantScreen = true;
        }

        $scope.dateOptions = {
            maxDate: new Date(),
            formatYear: 'yy',
            startingDay: 1
        }
        hlNTBEligibilityCheckDetailsVm.requestCallBack = function () {
            hlNTBCalculatorService.setIsCallBackRequset('true')
            $state.go('menu.hlNTBSubmitDetails');
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            hlNTBEligibilityCheckDetailsVm.initPage();
        });

        hlNTBEligibilityCheckDetailsVm.updatedigest = function () {
            if (!$scope.$$phase)
                $scope.$apply();
            return;
        }

        hlNTBEligibilityCheckDetailsVm.updateBreadCrumb = function (val) {
            if (val <= 6) {
                document.getElementById('bd-' + val).classList.add('hl_check_detail_breardcrum_selected');
                if ($scope.applicantDetail.activeTab != val)
                    document.getElementById('bd-' + $scope.applicantDetail.activeTab).classList.remove('hl_check_detail_breardcrum_selected');
                $scope.applicantDetail.activeTab = val;
                $scope.applicantDetail.nextToUpdate = $scope.applicantDetail.activeTab + 1
                if (hlNTBCalculatorService.isCheckEligibilityBack && $scope.applicantDetail.isCoApplicantAddedd == 'Y') {
                    document.getElementById('co-' + $scope.applicantDetail.coActiveTab).classList.remove('hl_check_detail_dot_selected');
                }
                if ($scope.applicantDetail.isCoApplicantAddedd == 'Y')
                    document.getElementById('co-' + $scope.applicantDetail.coActiveTab).classList.remove('hl_check_detail_dot_selected');
                // $scope.applicantDetail.coActiveTab = val
                $scope.isApplicantScreen = true;
                hlNTBEligibilityCheckDetailsVm.updatedigest();
            } else {
                $scope.isApplicantScreen = false;
                document.getElementById('co-' + val).classList.add('hl_check_detail_dot_selected');
                if ($scope.applicantDetail.coActiveTab != val)
                    document.getElementById('co-' + $scope.applicantDetail.coActiveTab).classList.remove('hl_check_detail_dot_selected');
                $scope.applicantDetail.coActiveTab = val;
                $scope.applicantDetail.coNextToUpdate = $scope.applicantDetail.coActiveTab + 1
            }
        }

        hlNTBEligibilityCheckDetailsVm.goBack = function () {
            hlNTBCalculatorService.isHomeScreenBack = true;
            $state.go('menu.hlNTBExploreHomeLoan');
        }

        hlNTBEligibilityCheckDetailsVm.goToScreen = function (val) {
            switch (val) {
                case 1:
                    hlNTBEligibilityCheckDetailsVm.updateBreadCrumb(val)
                    hlNTBEligibilityCheckDetailsVm.selectedBD = val;
                    hlNTBEligibilityCheckDetailsVm.selectedCO = val;
                    $scope.applicantDetail.activeTab = val;
                    break;
                case 2:
                    if ($scope.applicantDetail.appDOBSelected) {
                        hlNTBEligibilityCheckDetailsVm.updateBreadCrumb(val)
                        hlNTBEligibilityCheckDetailsVm.selectedBD = val;
                        hlNTBEligibilityCheckDetailsVm.selectedCO = val;
                        $scope.applicantDetail.activeTab = val;
                        if ($scope.applicantDetail.gender != '') {
                            setTimeout(function () {
                                hlNTBEligibilityCheckDetailsVm.genderSelected($scope.applicantDetail.gender)
                            }, 500);
                        }
                    } else {
                        return;
                    }
                    break;
                case 3:
                    if ($scope.applicantDetail.gender != '') {
                        hlNTBEligibilityCheckDetailsVm.updateBreadCrumb(val)
                        hlNTBEligibilityCheckDetailsVm.selectedBD = val;
                        hlNTBEligibilityCheckDetailsVm.selectedCO = val;
                        $scope.applicantDetail.activeTab = val;
                        setTimeout(function () {
                            hlNTBEligibilityCheckDetailsVm.incomeSourceSelected($scope.applicantDetail.incomeSource)
                        }, 1000);
                        hlNTBEligibilityCheckDetailsVm.updatedigest();
                    } else {
                        return;
                    }
                    break;
                case 4:
                    if ($scope.applicantDetail.incomeSource != '') {
                        hlNTBEligibilityCheckDetailsVm.updateBreadCrumb(val)
                        hlNTBEligibilityCheckDetailsVm.selectedBD = val;
                        hlNTBEligibilityCheckDetailsVm.selectedCO = val;
                        $scope.applicantDetail.activeTab = val;
                        $scope.applicantDetail.nmiError = false
                        hlNTBEligibilityCheckDetailsVm.updatedigest();

                    } else {
                        return;
                    }
                    break;
                case 5:
                    if ($scope.applicantDetail.netMonthlyIncome != '') {
                        hlNTBEligibilityCheckDetailsVm.updateBreadCrumb(val)
                        hlNTBEligibilityCheckDetailsVm.selectedBD = val;
                        hlNTBEligibilityCheckDetailsVm.selectedCO = val;
                        $scope.applicantDetail.activeTab = val;
                        $scope.applicantDetail.emiError = false;
                        hlNTBEligibilityCheckDetailsVm.updatedigest();
                    } else {
                        return;
                    }
                    break;
                case 6:
                    if ($scope.applicantDetail.emiPaying != '') {
                        hlNTBEligibilityCheckDetailsVm.updateBreadCrumb(val)
                        hlNTBEligibilityCheckDetailsVm.selectedBD = val;
                        hlNTBEligibilityCheckDetailsVm.selectedCO = val;
                        $scope.applicantDetail.activeTab = val;
                        setTimeout(function () {
                            hlNTBEligibilityCheckDetailsVm.isCoApplicantAdded($scope.applicantDetail.isCoApplicantAddedd);
                        }, 1000);
                    } else {
                        return;
                    }
                    break;
                case 7:
                    if ($scope.applicantDetail.isCoApplicantAddedd == 'Y') {
                        hlNTBEligibilityCheckDetailsVm.updateBreadCrumb(val)
                        $scope.isApplicantScreen = false;
                        hlNTBEligibilityCheckDetailsVm.selectedCO = val;
                        $scope.applicantDetail.coActiveTab = val;
                        hlNTBEligibilityCheckDetailsVm.updatedigest();
                    } else {
                        return;
                    }
                    break;
                case 8:
                    if ($scope.coApplicantDetail.appDOBSelected != '' && $scope.applicantDetail.isCoApplicantAddedd == 'Y') {
                        hlNTBEligibilityCheckDetailsVm.updateBreadCrumb(val)
                        $scope.isApplicantScreen = false;
                        hlNTBEligibilityCheckDetailsVm.selectedCO = val;
                        $scope.applicantDetail.coActiveTab = val;
                        setTimeout(function () {
                            hlNTBEligibilityCheckDetailsVm.genderSelected($scope.coApplicantDetail.gender)
                        }, 500);
                        hlNTBEligibilityCheckDetailsVm.updatedigest();
                    } else {
                        return;
                    }
                    break;
                case 9:
                    if ($scope.coApplicantDetail.gender != '' && $scope.applicantDetail.isCoApplicantAddedd == 'Y') {
                        hlNTBEligibilityCheckDetailsVm.updateBreadCrumb(val)
                        $scope.isApplicantScreen = false;
                        hlNTBEligibilityCheckDetailsVm.selectedCO = val;
                        $scope.applicantDetail.coActiveTab = val;
                        hlNTBEligibilityCheckDetailsVm.updatedigest();
                    } else {
                        return;
                    }
                    break;
                case 10:
                    if ($scope.coApplicantDetail.incomeSource != '' && $scope.applicantDetail.isCoApplicantAddedd == 'Y') {
                        hlNTBEligibilityCheckDetailsVm.updateBreadCrumb(val)
                        $scope.isApplicantScreen = false;
                        hlNTBEligibilityCheckDetailsVm.selectedCO = val;
                        $scope.applicantDetail.coActiveTab = val;
                        hlNTBEligibilityCheckDetailsVm.updatedigest();
                    } else {
                        return;
                    }
                    break;
                case 11:
                    if ($scope.coApplicantDetail.netMonthlyIncome != '' && $scope.applicantDetail.isCoApplicantAddedd == 'Y') {
                        hlNTBEligibilityCheckDetailsVm.updateBreadCrumb(val)
                        $scope.isApplicantScreen = false;
                        hlNTBEligibilityCheckDetailsVm.selectedCO = val;
                        $scope.applicantDetail.coActiveTab = val;
                        hlNTBEligibilityCheckDetailsVm.updatedigest();
                    } else {
                        return
                    }
                    break;
            }
            hlNTBEligibilityCheckDetailsVm.updatedigest();
        }

        hlNTBEligibilityCheckDetailsVm.goToNext = function (val) {
            if (val == 2) {
                if ($scope.applicantDetail.birthDate == '' || $scope.applicantDetail.birthDate == null || $scope.applicantDetail.birthDate == undefined) {

                    if (hlNTBCalculatorService.isValidField($scope.applicantDetail.birthDate, "applicant DOB")) {
                        $scope.applicantDetail.dobError = hlNTBCalculatorService.isValidField($scope.applicantDetail.birthDate, "applicant DOB");
                    }

                } else {
                    if (hlNTBCalculatorService.calculateAge($scope.applicantDetail.birthDate) < 18) {
                        $scope.applicantDetail.dobError = "Applicant age should be greater than 18 years"
                        return;
                    } else if (hlNTBCalculatorService.calculateAge($scope.applicantDetail.birthDate) > 75) {
                        $scope.applicantDetail.dobError = "Applicant age should not be greater than 75 years"
                        return;
                    } else {
                        hlNTBEligibilityCheckDetailsVm.selectedBD = val;
                        $scope.applicantDetail.appDOBSelected = true;
                        $scope.applicantDetail.dobError = '';
                        hlNTBEligibilityCheckDetailsVm.updateBreadCrumb(val);

                        if ($scope.applicantDetail.gender != '') {
                            setTimeout(function () {
                                hlNTBEligibilityCheckDetailsVm.genderSelected($scope.applicantDetail.gender);
                            }, 500);
                        }
                    }
                }

            } else if (val == 3) {
                if (val == 3 && ($scope.applicantDetail.gender == '' || $scope.applicantDetail.gender == null || $scope.applicantDetail.gender == undefined)) {
                    if (hlNTBCalculatorService.isValidField($scope.applicantDetail.gender, "applicant gender")) {
                        $scope.applicantDetail.genderError = hlNTBCalculatorService.isValidField($scope.applicantDetail.gender, "applicant gender");
                    }
                } else {
                    hlNTBEligibilityCheckDetailsVm.selectedBD = val;
                    hlNTBEligibilityCheckDetailsVm.updateBreadCrumb(val);
                    if ($scope.applicantDetail.incomeSource != '') {
                        setTimeout(function () {
                            hlNTBEligibilityCheckDetailsVm.incomeSourceSelected($scope.applicantDetail.incomeSource)
                        }, 500);
                    }
                }
            }
            else if (val == 4) {
                if ($scope.applicantDetail.incomeSource == '' || $scope.applicantDetail.incomeSource == null || $scope.applicantDetail.incomeSource == undefined) {
                    if (hlNTBCalculatorService.isValidField($scope.applicantDetail.incomeSource, "applicant income source")) {
                        $scope.applicantDetail.incomeError = hlNTBCalculatorService.isValidField($scope.applicantDetail.incomeSource, "applicant income source");

                        return;
                    }
                } else if ($scope.applicantDetail.incomeSource == 'SL' && ($scope.applicantDetail.retirementAge == '' || $scope.applicantDetail.retirementAge == null || $scope.applicantDetail.retirementAge == undefined)) {
                    if (hlNTBCalculatorService.isValidField($scope.applicantDetail.retirementAge, "applicant retirement age")) {
                        $scope.applicantDetail.retireAgeError = hlNTBCalculatorService.isValidField($scope.applicantDetail.retirementAge, "applicant retirement age");

                        return;
                    }
                }
                else {
                    if ($scope.applicantDetail.incomeSource == 'SL' && ($scope.applicantDetail.retirementAge < 19 || $scope.applicantDetail.retirementAge > 65)) {
                        $scope.applicantDetail.retireAgeError = 'Retirement age should be between 19 and 65 year';
                        return;
                    } else if ($scope.applicantDetail.incomeSource == 'SL' && ($scope.applicantDetail.retirementAge < hlNTBCalculatorService.calculateAge($scope.applicantDetail.birthDate))) {
                        $scope.applicantDetail.retireAgeError = 'Retirement age cannot be less than your present age or greater than 65 years';
                        return;
                    }

                    else {
                        hlNTBEligibilityCheckDetailsVm.selectedBD = val;
                        $scope.applicantDetail.incomeError = '';
                        $scope.applicantDetail.retireAgeError = '';
                        hlNTBEligibilityCheckDetailsVm.updateBreadCrumb(val);
                    }
                }

            } else if (val == 5) {
                if ($scope.applicantDetail.netMonthlyIncome == '' || $scope.applicantDetail.netMonthlyIncome == null || $scope.applicantDetail.netMonthlyIncome == undefined) {
                    if (hlNTBCalculatorService.isValidField($scope.applicantDetail.netMonthlyIncome, "applicant net monthly income")) {
                        $scope.applicantDetail.nmiError = hlNTBCalculatorService.isValidField($scope.applicantDetail.netMonthlyIncome, "applicant net monthly income");
                    }
                }
                else {
                    if ($scope.applicantDetail.netMonthlyIncome < 10000) {
                        $scope.applicantDetail.nmiError = 'Your minimum monthly income should be greater than Rs. 10,000 for applying for home loan on YONO.';
                        return;
                    } else if ($scope.applicantDetail.netMonthlyIncome <= 0) {
                        $scope.applicantDetail.nmiError = hlNTBCalculatorService.isValidField($scope.applicantDetail.netMonthlyIncome, "applicant net monthly income");
                    }
                    else {
                        hlNTBEligibilityCheckDetailsVm.selectedBD = val;
                        $scope.applicantDetail.nmiError = '';
                        hlNTBEligibilityCheckDetailsVm.updateBreadCrumb(val);
                    }
                }
            }
            else if (val == 6) {
                if ($scope.applicantDetail.emiPaying == '' || $scope.applicantDetail.emiPaying == null || $scope.applicantDetail.emiPaying == undefined) {
                    if (hlNTBCalculatorService.isValidField($scope.applicantDetail.emiPaying, "applicant existing paying EMI")) {
                        $scope.applicantDetail.emiError = hlNTBCalculatorService.isValidField($scope.applicantDetail.emiPaying, "applicant existing paying EMI");
                    }
                } else {
                    hlNTBEligibilityCheckDetailsVm.selectedBD = val;
                    $scope.applicantDetail.emiError = '';
                    hlNTBEligibilityCheckDetailsVm.updateBreadCrumb(val);
                    if ($scope.applicantDetail.isCoApplicantAddedd != '') {
                        setTimeout(function () {
                            if ($scope.applicantDetail.isCoApplicantAddedd != 'N')
                                document.getElementById('co-' + $scope.applicantDetail.coActiveTab).classList.remove('hl_check_detail_dot_selected');
                            hlNTBEligibilityCheckDetailsVm.isCoApplicantAdded($scope.applicantDetail.isCoApplicantAddedd);
                        }, 500);
                    }
                }
            } else if (val == 7) {
                hlNTBEligibilityCheckDetailsVm.selectedCO = val;
                $scope.applicantDetail.coApplicantError = ''

            } else if (val == 8) {
                if ($scope.coApplicantDetail.birthDate == '' || $scope.coApplicantDetail.birthDate == null || $scope.coApplicantDetail.birthDate == undefined) {
                    if (hlNTBCalculatorService.isValidField($scope.coApplicantDetail.birthDate, "co-applicant DOB")) {
                        $scope.coApplicantDetail.coAppDobError = hlNTBCalculatorService.isValidField($scope.coApplicantDetail.birthDate, "co-applicant DOB");
                    }
                } else {
                    if (hlNTBCalculatorService.calculateAge($scope.coApplicantDetail.birthDate) < 18) {
                        $scope.coApplicantDetail.coAppDobError = "Co-applicant age should be greater than 18 years"
                        return;
                    } else if ((hlNTBCalculatorService.calculateAge($scope.applicantDetail.birthDate) > 70) && (hlNTBCalculatorService.calculateAge($scope.coApplicantDetail.birthDate) > 50)) {
                        $scope.coApplicantDetail.coAppDobError = "Co-applicant should have age up to 50 years as your age is above 70 years."
                        return;
                    } else if (hlNTBCalculatorService.calculateAge($scope.coApplicantDetail.birthDate) > 70) {
                        $scope.coApplicantDetail.coAppDobError = 'Co-applicant’s age should not be more than 70 years.'
                    } else {
                        $scope.applicantDetail.coActiveTab = 7;
                        hlNTBEligibilityCheckDetailsVm.selectedCO = val;
                        $scope.coApplicantDetail.appDOBSelected = true;
                        $scope.coApplicantDetail.coAppDobError = ''
                        hlNTBEligibilityCheckDetailsVm.updateBreadCrumb(val);

                        if ($scope.coApplicantDetail.gender != '') {
                            setTimeout(function () {
                                hlNTBEligibilityCheckDetailsVm.genderSelected($scope.coApplicantDetail.gender)
                            }, 500);
                        }
                    }
                }
            } else if (val == 9) {
                hlNTBEligibilityCheckDetailsVm.selectedCO = val;
            } else if (val == 10) {
                if ($scope.coApplicantDetail.incomeSource == '' || $scope.coApplicantDetail.incomeSource == null || $scope.coApplicantDetail.incomeSource == undefined) {
                    if (hlNTBCalculatorService.isValidField($scope.coApplicantDetail.incomeSource, "co-applicant income source")) {
                        $scope.coApplicantDetail.incomeError = hlNTBCalculatorService.isValidField($scope.coApplicantDetail.incomeSource, "co-applicant income source");
                    }
                } else if ($scope.coApplicantDetail.incomeSource == 'SL' && ($scope.coApplicantDetail.retirementAge == '' || $scope.coApplicantDetail.retirementAge == null || $scope.coApplicantDetail.retirementAge == undefined)) {
                    if (hlNTBCalculatorService.isValidField($scope.coApplicantDetail.retirementAge, "co-applicant retirement age")) {
                        $scope.coApplicantDetail.retireAgeError = hlNTBCalculatorService.isValidField($scope.coApplicantDetail.retirementAge, "aco-pplicant retirement age");
                    }
                } else {
                    if ($scope.coApplicantDetail.incomeSource == 'SL' && ($scope.coApplicantDetail.retirementAge < 19 || $scope.coApplicantDetail.retirementAge > 65)) {
                        $scope.coApplicantDetail.retireAgeError = 'Retirement age should be between 19 and 65 year';
                        return;
                    } else if ($scope.coApplicantDetail.incomeSource == 'SL' && ($scope.coApplicantDetail.retirementAge < hlNTBCalculatorService.calculateAge($scope.coApplicantDetail.birthDate))) {
                        $scope.coApplicantDetail.retireAgeError = 'Retirement age cannot be less than your present age or greater than 65 years';
                        return;
                    } else {
                        hlNTBEligibilityCheckDetailsVm.selectedCO = val;
                        $scope.coApplicantDetail.incomeError = '';
                        $scope.coApplicantDetail.retireAgeError = '';
                        hlNTBEligibilityCheckDetailsVm.updateBreadCrumb(val);
                    }
                }
            } else if (val == 11) {
                if ($scope.coApplicantDetail.netMonthlyIncome == 0 || $scope.coApplicantDetail.netMonthlyIncome == '' || $scope.coApplicantDetail.netMonthlyIncome == null || $scope.coApplicantDetail.netMonthlyIncome == undefined) {
                    if (hlNTBCalculatorService.isValidField($scope.coApplicantDetail.netMonthlyIncome, "co-applicant net monthly income")) {
                        $scope.coApplicantDetail.nmiError = hlNTBCalculatorService.isValidField($scope.coApplicantDetail.netMonthlyIncome, "co-applicant net monthly income");
                    }
                } else {
                    if ($scope.coApplicantDetail.netMonthlyIncome < 10000) {
                        $scope.coApplicantDetail.nmiError = 'Your minimum monthly income should be greater than Rs. 10,000 for applying for home loan on YONO.';
                        return;
                    } else {
                        hlNTBEligibilityCheckDetailsVm.selectedCO = val;
                        $scope.coApplicantDetail.nmiError = '';
                        hlNTBEligibilityCheckDetailsVm.updateBreadCrumb(val);
                    }
                }
            }
            hlNTBEligibilityCheckDetailsVm.updatedigest();
        }

        hlNTBEligibilityCheckDetailsVm.genderSelected = function (val) {

            if (val == 'M') {
                document.getElementById('NTB_HL_MALE').classList.add("hlNTBDetailsBtn_after_click");
                document.getElementById('NTB_HL_FEMALE').classList.remove("hlNTBDetailsBtn_after_click");
                document.getElementById('NTB_HL_OTHER').classList.remove("hlNTBDetailsBtn_after_click");
            } else if (val == 'F') {
                document.getElementById('NTB_HL_FEMALE').classList.add("hlNTBDetailsBtn_after_click");
                document.getElementById('NTB_HL_OTHER').classList.remove("hlNTBDetailsBtn_after_click");
                document.getElementById('NTB_HL_MALE').classList.remove("hlNTBDetailsBtn_after_click");
            } else {
                document.getElementById('NTB_HL_OTHER').classList.add("hlNTBDetailsBtn_after_click");
                document.getElementById('NTB_HL_MALE').classList.remove("hlNTBDetailsBtn_after_click");
                document.getElementById('NTB_HL_FEMALE').classList.remove("hlNTBDetailsBtn_after_click");
            }

            setTimeout(function () {
                if ($scope.applicantDetail.isCoApplicantAddedd == 'Y' && !$scope.isApplicantScreen) {
                    hlNTBEligibilityCheckDetailsVm.selectedCO = 9
                    $scope.coApplicantDetail.gender = val
                    hlNTBEligibilityCheckDetailsVm.updateBreadCrumb(9);
                    if ($scope.coApplicantDetail.incomeSource != '') {
                        setTimeout(function () {
                            hlNTBEligibilityCheckDetailsVm.incomeSourceSelected($scope.coApplicantDetail.incomeSource)
                        }, 500);
                    }
                    hlNTBEligibilityCheckDetailsVm.updatedigest();
                } else {
                    hlNTBEligibilityCheckDetailsVm.selectedBD = 3
                    $scope.applicantDetail.gender = val
                    hlNTBEligibilityCheckDetailsVm.updateBreadCrumb(3);
                    if ($scope.applicantDetail.incomeSource != '') {
                        setTimeout(function () {
                            hlNTBEligibilityCheckDetailsVm.incomeSourceSelected($scope.applicantDetail.incomeSource)
                        }, 500);
                    }
                    hlNTBEligibilityCheckDetailsVm.updatedigest();
                }

            }, 500);
        }


        hlNTBEligibilityCheckDetailsVm.incomeSourceSelected = function (val) {
            if (val == 'SL') {
                document.getElementById('NTB_HL_SALARY').classList.add("hlNTBDetailsBtn_after_click");
                document.getElementById('NTB_HL_SELF_EMP').classList.remove("hlNTBDetailsBtn_after_click");
                document.getElementById('NTB_HL_OTH').classList.remove("hlNTBDetailsBtn_after_click");
                $scope.applicantDetail.incomeSourceText = true;
                $scope.coApplicantDetail.incomeSourceText = true;
            } else if (val == 'SE') {
                document.getElementById('NTB_HL_SELF_EMP').classList.add("hlNTBDetailsBtn_after_click");
                document.getElementById('NTB_HL_OTH').classList.remove("hlNTBDetailsBtn_after_click");
                document.getElementById('NTB_HL_SALARY').classList.remove("hlNTBDetailsBtn_after_click");
                $scope.applicantDetail.incomeSourceText = false;
                $scope.coApplicantDetail.incomeSourceText = false;
            } else {
                document.getElementById('NTB_HL_OTH').classList.add("hlNTBDetailsBtn_after_click");
                document.getElementById('NTB_HL_SALARY').classList.remove("hlNTBDetailsBtn_after_click");
                document.getElementById('NTB_HL_SELF_EMP').classList.remove("hlNTBDetailsBtn_after_click");
                $scope.applicantDetail.incomeSourceText = false;
                $scope.coApplicantDetail.incomeSourceText = false;
            }
            if (hlNTBEligibilityCheckDetailsVm.selectedCO == '9') {
                $scope.coApplicantDetail.incomeSource = val
            } else {
                $scope.applicantDetail.incomeSource = val
                $scope.applicantDetail.incomeError = ''
            }
            hlNTBEligibilityCheckDetailsVm.updatedigest();
        }

        hlNTBEligibilityCheckDetailsVm.isCoApplicantAdded = function (val) {
            if (val == 'Y') {

                if ($scope.onceCoAppSelected) {
                    $scope.applicantDetail.isCoApplicantAddedd = val;
                    hlNTBEligibilityCheckDetailsVm.selectedBD = 6;
                    hlNTBEligibilityCheckDetailsVm.selectedCO = 0;
                    $scope.isApplicantScreen = false;
                    $scope.renderApplicatntOrCoApplicant = 'New';
                    $scope.onceCoAppSelected = false;
                    hlNTBCalculatorService.isCheckEligibilityBack = true;
                    setTimeout(function () {
                        hlNTBEligibilityCheckDetailsVm.updateBreadCrumb(hlNTBEligibilityCheckDetailsVm.selectedBD);
                        document.getElementById('NTB_HL_YES').classList.add("hlNTBDetailsBtn_after_click");
                        document.getElementById('NTB_HL_NO').classList.remove("hlNTBDetailsBtn_after_click");
                        document.getElementById('co-' + $scope.applicantDetail.coActiveTab).classList.remove('hl_check_detail_dot_selected');
                        hlNTBEligibilityCheckDetailsVm.updatedigest();
                    }, 1000);
                }
                else if ($scope.renderApplicatntOrCoApplicant == 'New' && hlNTBCalculatorService.isCheckEligibilityBack) {
                    $scope.applicantDetail.isCoApplicantAddedd = val;
                    hlNTBEligibilityCheckDetailsVm.selectedCO = 7;
                    hlNTBEligibilityCheckDetailsVm.selectedBD = 6;
                    $scope.isApplicantScreen = false;
                    $scope.applicantDetail.coApplicantError = '';
                    document.getElementById('NTB_HL_YES').classList.add("hlNTBDetailsBtn_after_click");
                    document.getElementById('NTB_HL_NO').classList.remove("hlNTBDetailsBtn_after_click");
                    document.getElementById('co-' + $scope.applicantDetail.coActiveTab).classList.remove('hl_check_detail_dot_selected');
                    $scope.applicantDetail.coActiveTab = 7;
                    document.getElementById('co-' + $scope.applicantDetail.coActiveTab).classList.add('hl_check_detail_dot_selected');
                }
                else if ($scope.renderApplicatntOrCoApplicant == 'New') {
                    if (!hlNTBCalculatorService.isCheckEligibilityBack) {
                        $scope.applicantDetail.coActiveTab = 8;
                        $scope.coApplicantDetail.birthDate = new Date("01/01/2020");
                    }
                    $scope.applicantDetail.isCoApplicantAddedd = val;
                    hlNTBEligibilityCheckDetailsVm.selectedCO = 7;
                    hlNTBEligibilityCheckDetailsVm.selectedBD = 6;
                    $scope.isApplicantScreen = false;
                    $scope.renderApplicatntOrCoApplicant = ''
                    $scope.applicantDetail.coApplicantError = '';
                    document.getElementById('NTB_HL_YES').classList.add("hlNTBDetailsBtn_after_click");
                    document.getElementById('NTB_HL_NO').classList.remove("hlNTBDetailsBtn_after_click");
                    setTimeout(function () {
                        hlNTBEligibilityCheckDetailsVm.updateBreadCrumb(hlNTBEligibilityCheckDetailsVm.selectedCO);
                        $scope.onceCoAppSelected = true;
                    }, 1000);
                    hlNTBEligibilityCheckDetailsVm.updatedigest();
                }
                else if (hlNTBCalculatorService.isCheckEligibilityBack && $scope.renderApplicatntOrCoApplicant == 'CallBack') {
                    $scope.applicantDetail.isCoApplicantAddedd = val;
                    $scope.applicantDetail.coActiveTab = 8;
                    hlNTBEligibilityCheckDetailsVm.selectedCO = 11;
                    hlNTBEligibilityCheckDetailsVm.selectedBD = 6;
                    $scope.isApplicantScreen = false;
                    $scope.renderApplicatntOrCoApplicant = 'CallBackDone';
                    document.getElementById('bd-' + 6).classList.add('hl_check_detail_breardcrum_selected');
                    document.getElementById('bd-' + 1).classList.remove('hl_check_detail_breardcrum_selected');
                    setTimeout(function () {
                        hlNTBEligibilityCheckDetailsVm.updateBreadCrumb(hlNTBEligibilityCheckDetailsVm.selectedCO);
                    }, 1000);
                    hlNTBEligibilityCheckDetailsVm.updatedigest();
                } else if (hlNTBCalculatorService.isCheckEligibilityBack && $scope.renderApplicatntOrCoApplicant == 'CallBackDone') {
                    $scope.applicantDetail.isCoApplicantAddedd = val;
                    hlNTBEligibilityCheckDetailsVm.selectedBD = 6;
                    hlNTBEligibilityCheckDetailsVm.selectedCO = 0;
                    $scope.isApplicantScreen = false;
                    $scope.renderApplicatntOrCoApplicant = 'New';
                    $scope.onceCoAppSelected = false;
                    setTimeout(function () {
                        hlNTBEligibilityCheckDetailsVm.updateBreadCrumb(hlNTBEligibilityCheckDetailsVm.selectedBD);
                        document.getElementById('NTB_HL_YES').classList.add("hlNTBDetailsBtn_after_click");
                        document.getElementById('NTB_HL_NO').classList.remove("hlNTBDetailsBtn_after_click");
                        document.getElementById('co-' + $scope.applicantDetail.coActiveTab).classList.remove('hl_check_detail_dot_selected');
                        hlNTBEligibilityCheckDetailsVm.updatedigest();
                    }, 1000);
                }
            } else {
                if (hlNTBCalculatorService.calculateAge($scope.applicantDetail.birthDate) > 70) {
                    $scope.applicantDetail.coApplicantError = 'Adding a Co-applicant is mandatory since your age is more than 70 years. Co-applicant’s age should not be more than 50 years.'
                    $scope.applicantDetail.emiAndnmiConstraint = true;
                    return;
                } else {
                    $scope.applicantDetail.isCoApplicantAddedd = val;
                    hlNTBEligibilityCheckDetailsVm.selectedCO = 0;
                    $scope.applicantDetail.coActiveTab = 1;
                    $scope.applicantDetail.coApplicantError = '';
                    $scope.isApplicantScreen = true;
                    hlNTBEligibilityCheckDetailsVm.clearCoApplicant();
                    $scope.renderApplicatntOrCoApplicant = 'New'
                    hlNTBCalculatorService.isCheckEligibilityBack = false;
                    document.getElementById('NTB_HL_NO').classList.add("hlNTBDetailsBtn_after_click");
                    document.getElementById('NTB_HL_YES').classList.remove("hlNTBDetailsBtn_after_click");
                    hlNTBEligibilityCheckDetailsVm.updatedigest();
                }
            }
        }

        hlNTBEligibilityCheckDetailsVm.clearCoApplicant = function () {
            $scope.coApplicantDetail = {};
            $scope.coApplicantDetail.birthDate = '';
            $scope.coApplicantDetail.gender = '';
            $scope.coApplicantDetail.incomeSource = '';
            $scope.coApplicantDetail.retirementAge = '';
            $scope.coApplicantDetail.netMonthlyIncome = ''
            $scope.coApplicantDetail.emiPaying = '';
        }

        hlNTBEligibilityCheckDetailsVm.validateApplicantDetail = function () {
            var isVal = false;
            if ($scope.applicantDetail.birthDate == '' || $scope.applicantDetail.birthDate == null || $scope.applicantDetail.birthDate == undefined) {
                isVal = true;
            }
            if ($scope.applicantDetail.gender == '' || $scope.applicantDetail.gender == null || $scope.applicantDetail.gender == undefined) {
                isVal = true;
            }
            if ($scope.applicantDetail.incomeSource == '' || $scope.applicantDetail.incomeSource == null || $scope.applicantDetail.incomeSource == undefined) {
                isVal = true;
            } else {
                if ($scope.applicantDetail.incomeSource == 'SL' && ($scope.applicantDetail.retirementAge == '' || $scope.applicantDetail.retirementAge == null || $scope.applicantDetail.retirementAge == undefined)) {
                    isVal = true;
                }
            }
            if ($scope.applicantDetail.netMonthlyIncome < 10000 || $scope.applicantDetail.netMonthlyIncome == '' || $scope.applicantDetail.netMonthlyIncome == null || $scope.applicantDetail.netMonthlyIncome == undefined) {
                isVal = true;
            }
            if ($scope.applicantDetail.emiPaying == '' || $scope.applicantDetail.emiPaying == null || $scope.applicantDetail.emiPaying == undefined) {
                isVal = true;
            }
            if ($scope.applicantDetail.emiPaying > $scope.applicantDetail.netMonthlyIncome) {
                isVal = true;
            }
            if ($scope.applicantDetail.incomeSource == 'SL' && (hlNTBCalculatorService.calculateAge($scope.applicantDetail.birthDate) >= $scope.applicantDetail.retirementAge)) {
                isVal = true;
            }
            return isVal;
        }

        hlNTBEligibilityCheckDetailsVm.validateCoApplicantDetail = function () {
            var isVal = false;
            if ($scope.coApplicantDetail.birthDate == '' || $scope.coApplicantDetail.birthDate == null || $scope.coApplicantDetail.birthDate == undefined) {
                isVal = true;
            }
            if ($scope.coApplicantDetail.gender == '' || $scope.coApplicantDetail.gender == null || $scope.coApplicantDetail.gender == undefined) {
                isVal = true;
            }
            if ($scope.coApplicantDetail.incomeSource == '' || $scope.coApplicantDetail.incomeSource == null || $scope.coApplicantDetail.incomeSource == undefined) {
                isVal = true;
            } else {
                if ($scope.coApplicantDetail.incomeSource == 'SL' && ($scope.coApplicantDetail.retirementAge == '' || $scope.coApplicantDetail.retirementAge == null || $scope.coApplicantDetail.retirementAge == undefined)) {
                    isVal = true;
                }
            }
            if ($scope.coApplicantDetail.netMonthlyIncome < 10000 || $scope.coApplicantDetail.netMonthlyIncome == '' || $scope.coApplicantDetail.netMonthlyIncome == null || $scope.coApplicantDetail.netMonthlyIncome == undefined) {
                isVal = true;
            }
            if ($scope.coApplicantDetail.emiPaying == '' || $scope.coApplicantDetail.emiPaying == null || $scope.coApplicantDetail.emiPaying == undefined) {
                isVal = true;
            }
            if ($scope.coApplicantDetail.emiPaying > $scope.coApplicantDetail.netMonthlyIncome) {
                isVal = true;
            }
            if ($scope.coApplicantDetail.incomeSource == 'SL' && (hlNTBCalculatorService.calculateAge($scope.coApplicantDetail.birthDate) >= $scope.coApplicantDetail.retirementAge)) {
                isVal = true;
            }
            return isVal;
        }

        hlNTBEligibilityCheckDetailsVm.getDateInFormat = function (date) {
            var today = new Date(date);
            var dd = today.getDate();
            var mm = today.getMonth() + 1;
            var yyyy = today.getFullYear();
            if (dd < 10) {
                dd = '0' + dd;
            }
            if (mm < 10) {
                mm = '0' + mm;
            }
            today = dd + '/' + mm + '/' + yyyy;
            return today
        }


        hlNTBEligibilityCheckDetailsVm.masterDetails = function () {
            utilityService.showSpinner();
            var payload = {};

            if (!$scope.applicantDetail.coApplicantAdded) {
                hlNTBCalculatorService.setApplicantGender($scope.applicantDetail.gender);
                hlNTBCalculatorService.setApplicantIncomeSource($scope.applicantDetail.incomeSource);
                payload.gender = hlNTBCalculatorService.getApplicantGender();
                payload.employmentType = hlNTBCalculatorService.getApplicantIncomeSource();
            } else {
                if (hlNTBCalculatorService.calculateAge(new Date($scope.applicantDetail.dateOfBirth)) > hlNTBCalculatorService.calculateAge(new Date($scope.coApplicantDetail.dateOfBirth))) {
                    hlNTBCalculatorService.setCoApplicantGender($scope.coApplicantDetail.gender);
                    hlNTBCalculatorService.setCoApplicantIncomeSource($scope.coApplicantDetail.incomeSource);
                    payload.gender = hlNTBCalculatorService.getCoApplicantGender();
                    payload.employmentType = hlNTBCalculatorService.getCoApplicantIncomeSource();
                } else {
                    hlNTBCalculatorService.setApplicantGender($scope.applicantDetail.gender);
                    hlNTBCalculatorService.setApplicantIncomeSource($scope.applicantDetail.incomeSource);
                    payload.gender = hlNTBCalculatorService.getApplicantGender();
                    payload.employmentType = hlNTBCalculatorService.getApplicantIncomeSource();
                }
            }
            hlNTBCalculatorService.getMasterData(payload).then(function (response) {
                hlNTBCalculatorService.setMasterDataService(response);
                hlNTBCalculatorService.isSubmitDetailsBack = false ;
                utilityService.hideSpinner();
                $state.go('menu.hlNTBEligibileAmountDetails');
            }, function (error) {
                utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });
        }


        hlNTBEligibilityCheckDetailsVm.getEligibilityServiceCall = function () {
            $scope.applicantDetail.coApplicantError = '';
            var payload = {
                "applicantDetails": {
                }
            }
            payload.applicantDetails.dateOfBirth = hlNTBEligibilityCheckDetailsVm.getDateInFormat($scope.applicantDetail.birthDate);

            if ($scope.applicantDetail.gender == 'F') {
                payload.applicantDetails.gender = 'F';
            } else {
                payload.applicantDetails.gender = 'M';
            }
            if ($scope.applicantDetail.incomeSource == 'SL') {
                payload.applicantDetails.incomeSource = 'Salaried';
                payload.applicantDetails.retirementAge = $scope.applicantDetail.retirementAge;
            } else {
                payload.applicantDetails.incomeSource = 'Other';
                payload.applicantDetails.retirementAge = '';
            }
            payload.applicantDetails.netMonthlyIncome = $scope.applicantDetail.netMonthlyIncome;
            payload.applicantDetails.emiOnExistingLoan = $scope.applicantDetail.emiPaying;
            if ($scope.applicantDetail.isCoApplicantAddedd == 'Y') {
                payload.coApplicantAdded = true;
                payload.coApplicantDetails = {};

                payload.coApplicantDetails.dateOfBirth = hlNTBEligibilityCheckDetailsVm.getDateInFormat($scope.coApplicantDetail.birthDate);
                if ($scope.coApplicantDetail.gender == 'F') {
                    payload.coApplicantDetails.gender = 'F';
                } else {
                    payload.coApplicantDetails.gender = 'M';
                }

                if ($scope.coApplicantDetail.incomeSource == 'SL') {
                    payload.coApplicantDetails.incomeSource = 'Salaried';
                    payload.coApplicantDetails.retirementAge = $scope.coApplicantDetail.retirementAge;
                } else {
                    payload.coApplicantDetails.incomeSource = 'Other';
                    payload.coApplicantDetails.retirementAge = '';
                }
                payload.coApplicantDetails.netMonthlyIncome = $scope.coApplicantDetail.netMonthlyIncome;
                payload.coApplicantDetails.emiOnExistingLoan = $scope.coApplicantDetail.emiPaying;
            } else {
                payload.coApplicantAdded = false;
            }
            hlNTBCalculatorService.getEligiblityCheck(payload).then(function (response) {

                hlNTBCalculatorService.applicantData = $scope.applicantDetail;
                hlNTBCalculatorService.coapplicantData = $scope.coApplicantDetail;
                hlNTBCalculatorService.setCheckEligiblityRequest(payload);
                hlNTBCalculatorService.setCheckEligiblityResponse(response);
                $scope.coApplicantDetail.emiError = '';
                $scope.applicantDetail.coApplicantError = '';
                hlNTBEligibilityCheckDetailsVm.masterDetails();
            }, function (error) {
                if (error.isValidationFailedResponse) {
                    if ($scope.applicantDetail.isCoApplicantAddedd == 'Y') {
                        $scope.coApplicantDetail.emiError = error.responseMessage;
                    } else {
                        $scope.applicantDetail.coApplicantError = error.responseMessage;
                    }
                } else {
                    utilityService.showErrorMessage(error.responseMessage);
                }
            });
        }


        hlNTBEligibilityCheckDetailsVm.checkEligibility = function () {
            if ($scope.applicantDetail.isCoApplicantAddedd == '') {
                if (hlNTBCalculatorService.isValidField($scope.applicantDetail.isCoApplicantAddedd, "co-applicant detail")) {
                    $scope.applicantDetail.coApplicantError = hlNTBCalculatorService.isValidField($scope.applicantDetail.isCoApplicantAddedd, "co-applicant detail");
                }
            }
            else {
                if ($scope.applicantDetail.isCoApplicantAddedd == 'N') {
                    $scope.applicantDetail.coApplicantError = '';
                    hlNTBCalculatorService.setApplicantGender($scope.applicantDetail.gender);
                    hlNTBCalculatorService.setApplicantOccupation($scope.applicantDetail.incomeSource);
                    hlNTBCalculatorService.coapplicantData = "";
                    hlNTBEligibilityCheckDetailsVm.getEligibilityServiceCall();
                }
                else if ($scope.applicantDetail.isCoApplicantAddedd == 'Y') {
                    $scope.applicantDetail.coApplicantError = ''
                    if ($scope.coApplicantDetail.emiPaying == '' || $scope.coApplicantDetail.emiPaying == null || $scope.coApplicantDetail.emiPaying == undefined) {
                        if (hlNTBCalculatorService.isValidField($scope.coApplicantDetail.emiPaying, "co-applicant existing paying EMI")) {
                            $scope.coApplicantDetail.emiError = hlNTBCalculatorService.isValidField($scope.coApplicantDetail.emiPaying, "co-applicant existing paying EMI");
                            return;
                        }
                    } else {
                        if ((hlNTBCalculatorService.calculateAge($scope.applicantDetail.birthDate) > 70) && (hlNTBCalculatorService.calculateAge($scope.coApplicantDetail.birthDate) > 50)) {
                            $scope.coApplicantDetail.emitonmiError = 'Co-applicant’s age should not be more than 50 years.'
                            $scope.coApplicantDetail.emiAndnmiConstraint = true;
                            return;
                        } else if (hlNTBCalculatorService.calculateAge($scope.coApplicantDetail.birthDate) > 70) {
                            $scope.coApplicantDetail.emitonmiError = 'Co-applicant’s age should not be more than 70 years.'
                            $scope.coApplicantDetail.emiAndnmiConstraint = true;
                        }
                        else {

                            hlNTBCalculatorService.setApplicantGender($scope.applicantDetail.gender);
                            hlNTBCalculatorService.setCoApplicantGender($scope.coApplicantDetail.gender)
                            hlNTBCalculatorService.setApplicantOccupation($scope.applicantDetail.incomeSource);
                            hlNTBCalculatorService.setCoApplicantOccupation($scope.coApplicantDetail.incomeSource)
                            hlNTBEligibilityCheckDetailsVm.getEligibilityServiceCall();
                        }
                    }
                }
            }
        }

        hlNTBEligibilityCheckDetailsVm.getTenureOfApplicant = function () {
            var ageOfAppli = hlNTBCalculatorService.calculateAge($scope.applicantDetail.birthDate)
            if ($scope.applicantDetail.incomeSource == 'SL') {
                return $scope.applicantDetail.retirementAge - ageOfAppli;
            } else {
                return 75 - ageOfAppli;
            }
        }
        return this;
    }
]);