'use strict';

angularApp.controller('hlNTBExploreHomeLoanController', [
    "$state",
    "$scope",
    "$translate",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService", 
    "$filter",
    "hlNTBCalculatorService",
    "homeLoanService",
    "closePopupService",
    "$ionicSlideBoxDelegate","constantConfig", "cryptoService",
    function($state,
        $scope,
        $translate,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        $filter,
        hlNTBCalculatorService,
        homeLoanService,
        closePopupService,
	   $ionicSlideBoxDelegate,constantConfig,cryptoService) {

        var hlNTBExploreHomeLoanVm = this;

        hlNTBExploreHomeLoanVm.initPage = function () {
           hlNTBExploreHomeLoanVm.contactNo = "9800123457";
           hlNTBExploreHomeLoanVm.bannerList = [];
           hlNTBExploreHomeLoanVm.isMaskDob = true;
           $scope.maskedNumber = '';
            $scope.callService = 0 ;
           hlNTBExploreHomeLoanVm.getBanner();
        }

        hlNTBExploreHomeLoanVm.knowMore = function(obj){
            $scope.discText = '';
            hlNTBCalculatorService.getDisclaimerContent().then(function(response){
                    $scope.discText = response;
                    $ionicPopup.show({                 
                        cssClass: 'ntb-alert-popup hlTermnCondition',
                        title: 'Disclaimer',
                        template: $scope.discText,
                        scope: $scope, 
                        buttons: [
                                {
                                text: 'Cancel',
                                type: 'button-negative',
                                onTap: function (res) {}
                        },{
                            text: 'OK',
                            type: 'button-positive',
                            onTap: function (res) {
                                if (utilityService.isIOSPlatform()) {
                                    cordova.ThemeableBrowser.open(obj.redirectionURL, '_system', {});
                                }else{
                                     window.open(obj.redirectionURL); 
                                }                                                                                    
                            }
                        }],
                    });
                   
            }).catch(function(error){
                console.log(error);
            });
        }
      

        hlNTBExploreHomeLoanVm.trackApplication = function() {
            $scope.refNo = {};
            var backPopup = $ionicPopup.show({                 
                cssClass: 'ntb-alert-popup hlExploreTrackPop',
                template: '<div class="">'+ 
                    '<div class="text-center">'+
                    '<div class="roboto-bold font-size-18" translate="NTB_HL_TRACK_APP_LBL"></div>'+
                    '<div class="roboto-medium font-size-14 padTop10" translate="NTB_HL_REF_NO_LBL"></div>'+
                    '<div class="roboto-light font-size-12 padTop10" translate="NTB_HL_TRACK_REF_STMT"></div></div>'+
                    '<div class="padTop10 hlInputTrack"><label class="width100 fss-input-box item-floating-label form-field fss-select-box-div">'+
                    '<span class="input-label color-darkgrey font-size-12" ng-bind="\'NTB_HL_REF_NO\' | translate"></span>'+
                    '<input type="tel" numeric-only max-len="10" style="width: click-stream="click" id="REFERENCE_NUM" 100% !important;" placeholder="{{\'NTB_HL_REF_NO\' | translate}}" '+
                    'class="roboto-regular font-size-16 color-darkgrey width90" ng-model="refNo.referenceNumber">'+
                    '</label><div class="inputErrorMsg" ng-show="refNo.refNoError" ng-bind="refNo.refNoError"></div></div></div>',
                scope: $scope, 
                buttons: [
                        {
                        text: 'Submit',
                        type: 'button-positive',
                        onTap: function (e) {
                            if(hlNTBCalculatorService.isValidField($scope.refNo.referenceNumber,"Reference Number")) {
                                $scope.refNo.refNoError = hlNTBCalculatorService.isValidField($scope.refNo.referenceNumber,"Reference Number");
                                backPopup.show();
                            }else if((parseInt($scope.refNo.referenceNumber)) === 0){
                                $scope.refNo.refNoError = "Reference number accepts minimum 1 and maximum 10 numeric values (0 to 9 only) and all zeros not allowed"
                                backPopup.show();
                            }
                            else{
                                $scope.refNo.refNoError = "";
                                var request = {
                                    "leadId" : $scope.refNo.referenceNumber ? $scope.refNo.referenceNumber : ''
                                };
                                hlNTBCalculatorService.submitReferenceNumber(request).then(function (data){
                                    $scope.refNo.referenceNumber = data.leadId;
                                    $scope.refNo.contactNo = data.mobile;
                                    hlNTBExploreHomeLoanVm.setMaskedNumber( $scope.refNo.contactNo);
                                    var backPopup1 =   $ionicPopup.alert({
                                cssClass: 'ntb-alert-popup hlExploreTrackPop',
                                template: '<div class=""><div class="text-center">'+
                                        '<div class="roboto-bold font-size-18" translate="NTB_HL_TRACK_APP_LBL"></div>'+
                                        '<div class="roboto-medium font-size-14 padTop10" translate="NTB_HL_REF_NO_LBL"></div>'+
                                        '<div class="roboto-light font-size-12 padTop10" translate="NTB_HL_TRACK_REF_STMT"></div></div>'+
                                        '<div class="padTop15">'+
                                        '<div class="roboto-regular font-size-12" translate="NTB_HL_REF_NO"></div>'+
                                        '<div class="roboto-regular font-size-16 padTop5" click-stream="click" id="TRACK_GET_OTP"> {{ refNo.referenceNumber }}' +
                                        '<span><img src="img/HomeLoan/Sucess.svg" class="hlSuccess"/></span></div>'+
                                        '</div><div class="padTop20">'+
                                        '<div class="roboto-medium font-size-14" translate="NTB_HL_CONTACT_NUMBER_VERIFY_STMT"></div>'+
                                        '<div class="padTop20"><div class="row roboto-regular font-size-12 color3F" style="padding:0 0 5px 0" translate="NTB_HL_CONTACT"></div>'+
                                        // '<div ng-if="!hlNTBExploreHomeLoanVm.isMaskDob">'+
                                        // '<span>{{refNo.contactNo}}</span>' +
                                        // '<span class="eyeoffGL"  ng-click="hlNTBExploreHomeLoanVm.unmaskDob(true)" ng-if="!hlNTBExploreHomeLoanVm.isMaskDob">'+
                                        // '<img src="img/Visibility_on.svg" class="eyeMaskGL"/> </div>'+
                                        '<div class="padtop10" ng-if="hlNTBExploreHomeLoanVm.isMaskDob">'+
                                        '<span>{{maskedNumber}}</span>'+
                                        // '<span class="eyeoffGL"   ng-click="hlNTBExploreHomeLoanVm.unmaskDob(false)">'+
                                        // '<img src="img/Visibility_off.svg" class="eyeMaskGL"/ ></span>'+
                                        '</div>'+
                                        '</div></div></div>',
                                    scope: $scope, 
                                    buttons: [ {
                                    text: 'Send OTP',
                                    type: 'button-positive hlReferButton',
                                    onTap: function () {
                                        $scope.callService = $scope.callService + 1 ;
                                        utilityService.showSpinner(); 
                                        var reqParams = {};
                                        reqParams["id"] = $scope.refNo.contactNo ? $scope.refNo.contactNo : '';
                                        reqParams.otpCode = constantConfig.keysForOTP.Register;
                                        reqParams.ocHash = cryptoService.getSHA512EncryptedData(constantConfig.keysForOTP.Register).toString();
                                        if($scope.callService == 1){
                                        hlNTBCalculatorService.generateOTP(reqParams).then(function (response) {
                                            hlNTBCalculatorService.trackReferenceData = true;
                                            hlNTBCalculatorService.leadID = $scope.refNo.referenceNumber ;
                                            hlNTBCalculatorService.leadMobile = $scope.refNo.contactNo;
                                            $scope.callService = 0;
                                            utilityService.hideSpinner(); 
                                            $state.go('menu.hlNTBOTPVerification');
                                            hlNTBExploreHomeLoanVm.updatedigest();
                                        }, function (error) {
                                            $scope.callService = 0 ;
                                            utilityService.hideSpinner(); 
                                            utilityService.showErrorMessage(error.responseMessage);
                                        });  
                                    }                         
                                    }
                                }],
                            })
                            closePopupService.register(backPopup1);
                        }, function (error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    }                            
                    }
                }],
            })
              closePopupService.register(backPopup);
        }
        hlNTBExploreHomeLoanVm.updatedigest = function () {
            if (!$scope.$$phase)
                $scope.$apply();
            return;
        }

        hlNTBExploreHomeLoanVm.setMaskedNumber = function(val){
            $scope.maskedNumber = val.replace(/[0-9]{6}/,'XXXXXX');
        }


        hlNTBExploreHomeLoanVm.getBanner = function(){
            hlNTBCalculatorService.getLeadGenerationBanner().then(function(response){
               
                hlNTBExploreHomeLoanVm.bannerList = response;
                setTimeout(function () {
                    $ionicSlideBoxDelegate.update();
                    $ionicSlideBoxDelegate.loop(true);
                }, 400);
            },function(error){
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
       

        $scope.$on('$ionicView.beforeEnter', function() {
            hlNTBExploreHomeLoanVm.initPage();
        });

        hlNTBExploreHomeLoanVm.goBack = function(){
            if(hlNTBCalculatorService.isFromHamburger){
                $state.go('menu.loansLanding');
            }

            if(hlNTBCalculatorService.isFromNTB){
                $state.go('menu.newToSbiLanding');
            }           
        }

        hlNTBExploreHomeLoanVm.requestCallBack = function(){
            hlNTBCalculatorService.isSubmitDetailsBack =  false;
            hlNTBCalculatorService.setIsCallBackRequset('true');
            $state.go('menu.hlNTBSubmitDetails');
        }

        hlNTBExploreHomeLoanVm.getStarted = function(){
            hlNTBCalculatorService.isCheckEligibilityBack = false ;
            hlNTBCalculatorService.isSubmitDetailsBack = false ;
            hlNTBCalculatorService.submitLeadData = {};
           $state.go('menu.hlNTBEligibilityCheckDetails');
           
        }


        hlNTBExploreHomeLoanVm.unmaskDob = function (flag) {          
            if (flag === true) {
                hlNTBExploreHomeLoanVm.isMaskDob = true;
            }else{
                hlNTBExploreHomeLoanVm.isMaskDob = false;
            }
        }

        return this;
    }
]);