'use strict';

angularApp.controller('hlNTBOTPVerificationController', [
    "$state",
    "$scope",
    "$translate",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService",
    "$filter",
    "hlNTBCalculatorService","goldLoanRLMSService",
    "homeLoanService", "constantConfig", "cryptoService",

    function ($state,
        $scope,
        $translate,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        $filter,
        hlNTBCalculatorService,goldLoanRLMSService,
        homeLoanService, constantConfig, cryptoService) {

        var hlNTBOTPVerificationVm = this;

        hlNTBOTPVerificationVm.initPage = function () {
            $scope.resendOtpCounter = 0;
            $scope.invalidOtpCounter = 0;
            if (hlNTBCalculatorService.trackReferenceData) {
                hlNTBOTPVerificationVm.mobileNumber = hlNTBCalculatorService.leadMobile;
            } else {
                hlNTBOTPVerificationVm.mobileNumber = hlNTBCalculatorService.getContactNumber();
            }
            hlNTBOTPVerificationVm.leadGeneratePayLoad = {};
            hlNTBOTPVerificationVm.leadGeneratePayLoad = hlNTBCalculatorService.getGenerateLeadData();
        }

        hlNTBOTPVerificationVm.resendOTP = function () {
            $scope.invalidOtpCounter = 0;
            if ($scope.isDisabledOTPbtn) {
                return true;
            }
            hlNTBOTPVerificationVm.otp = null;
            hlNTBOTPVerificationVm.isValidOtp = true;
            var reqParams = {};
            if (hlNTBCalculatorService.trackReferenceData) {
                reqParams["id"] = hlNTBCalculatorService.leadMobile ? hlNTBCalculatorService.leadMobile : '';
            } else {
                reqParams["id"] = hlNTBOTPVerificationVm.mobileNumber;
            }
            reqParams.otpCode = constantConfig.keysForOTP.Register;
            reqParams.ocHash = cryptoService.getSHA512EncryptedData(constantConfig.keysForOTP.Register).toString();
            hlNTBCalculatorService.generateOTP(reqParams).then(function (data) {
                hlNTBCalculatorService.showAlertPopup("", "OTP resent Successfully", "", "", "OK", "", "", "");
                $scope.resendOtpCounter += 1;
                if ($scope.resendOtpCounter === 2) {
                    $scope.isDisabledOTPbtn = true;
                }
            }, function (error) {
                hlNTBOTPVerificationVm.otpError = '';
                utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });
        };

        hlNTBOTPVerificationVm.submitOTP = function () {
            utilityService.hideSpinner();
            if (hlNTBCalculatorService.isValidField(hlNTBOTPVerificationVm.otp, "OTP")) {
                hlNTBOTPVerificationVm.otpError = hlNTBCalculatorService.isValidField(hlNTBOTPVerificationVm.otp, "OTP");
            } else {
                var reqParams = {};
                if (hlNTBCalculatorService.trackReferenceData) {
                    reqParams["otp"] = hlNTBOTPVerificationVm.otp ? hlNTBOTPVerificationVm.otp : '';
                    reqParams["mobile"] = hlNTBCalculatorService.leadMobile ? hlNTBCalculatorService.leadMobile : '';
                } else {
                    reqParams["otp"] = hlNTBOTPVerificationVm.otp;
                    reqParams["mobile"] = hlNTBOTPVerificationVm.mobileNumber;
                }

                hlNTBCalculatorService.validateOTP(reqParams).then(function (data) {
                    if (hlNTBCalculatorService.trackReferenceData) {
                        var request = {
                            "leadId": hlNTBCalculatorService.leadID ? hlNTBCalculatorService.leadID : '',
                            "mobile": hlNTBCalculatorService.leadMobile ? hlNTBCalculatorService.leadMobile : ''
                        };
                        hlNTBCalculatorService.getReferenceNumberStatus(request).then(function (response) {
                            hlNTBCalculatorService.trackReferenceData = false;
                            hlNTBCalculatorService.leadID = '';
                            hlNTBCalculatorService.leadMobile = ''
                            hlNTBCalculatorService.setReferenceStatusData(response);
                            $state.go('menu.hlNTBReferenceDetails');
                        }, function (error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    } else {
                       // console.log("hlNTBCalculatorService.getGenerateLeadData()" + JSON.stringify(hlNTBCalculatorService.getGenerateLeadData()));
                        hlNTBCalculatorService.submitLeadDetails(hlNTBCalculatorService.getGenerateLeadData()).then(function (res) {
                            hlNTBCalculatorService.setReferenceStatusData(res);
                            $state.go('menu.hlNTBReferenceDetails');
                        }, function (error) {
                            if(error.isValidationFailedResponse){
                                goldLoanRLMSService.showAlertPopup("error","",error.responseMessage,
                                                "menu.hlNTBExploreHomeLoan","Go to Home Page","","","");
                            }else{
                               utilityService.showErrorMessage(error.responseMessage); 
                           }                            
                        });
                    }
                }, function (error) {
                    utilityService.hideSpinner();
                    hlNTBOTPVerificationVm.otpError = '';
                    $scope.invalidOtpCounter += 1;
                    if ($scope.invalidOtpCounter === 3) {
                        $ionicPopup.show({
                            template: 'You have exceeded number of attempts. Please try after sometime.',
                            title: '',
                            cssClass: 'dialog',
                            scope: $scope,
                            buttons: [{
                                text: 'OK',
                                type: 'button-positive',
                                onTap: function () {
                                    hlNTBOTPVerificationVm.invalidOtpCounter = true;
                                }
                            }]
                        });
                    }
                    else {
                        utilityService.showErrorMessage(error.responseMessage);
                    }
                });
            }
        }


        $scope.$on('$ionicView.beforeEnter', function () {
            hlNTBOTPVerificationVm.initPage();
        });

        hlNTBOTPVerificationVm.goBack = function () {
            hlNTBCalculatorService.isSubmitDetailsBack = true;
            $ionicHistory.goBack(-1);
            // if(hlNTBCalculatorService.trackReferenceData){
            //     $state.go('menu.hlNTBExploreHomeLoan');
            // }else{
            //     hlNTBCalculatorService.isSubmitDetailsBack = true;
            //     $state.go('menu.hlNTBSubmitDetails');
            // }
        }
        return this;
    }
]);