'use strict';

angularApp.controller('hlNTBReferenceDetailsController', [
    "$state",
    "$scope",
    "$translate",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService",
    "$filter",
    "hlNTBCalculatorService",
    "homeLoanService",
    "goldLoanRLMSService",


    function ($state,
        $scope,
        $translate,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        $filter,
        hlNTBCalculatorService,
        homeLoanService,
        goldLoanRLMSService,
        $hlReferSliderFun) {

        var hlNTBReferenceDetailsVm = this;

        hlNTBReferenceDetailsVm.initPage = function () {
            hlNTBReferenceDetailsVm.getBanner();
            hlNTBReferenceDetailsVm.userDetails = hlNTBCalculatorService.getGenerateLeadData();
            hlNTBReferenceDetailsVm.refNo = hlNTBCalculatorService.getReferenceStatusData().crmLeadID;
            hlNTBReferenceDetailsVm.name = hlNTBReferenceDetailsVm.userDetails.firstname + " " + hlNTBReferenceDetailsVm.userDetails.lastname;
            hlNTBReferenceDetailsVm.bannerList = [];

            if (hlNTBCalculatorService.getReferenceStatusData()) {
                hlNTBReferenceDetailsVm.applicationStatus = hlNTBCalculatorService.getReferenceStatusData().statusCode;
            }
        }


        $scope.$on('$ionicView.beforeEnter', function () {
            hlNTBReferenceDetailsVm.initPage();
        });

        hlNTBReferenceDetailsVm.goToHome = function () {
            var temp = {};
            hlNTBCalculatorService.setCheckEligiblityRequest(temp);
            hlNTBCalculatorService.setCheckEligiblityResponse(temp)
            hlNTBCalculatorService.setEligibalAmountDetail(temp)
            hlNTBCalculatorService.isSubmitDetailsBack = false;
            hlNTBCalculatorService.trackReferenceData = false;
            hlNTBCalculatorService.isFromRefer = true;
            $ionicHistory.clearHistory();
            $state.go('menu.hlNTBExploreHomeLoan');
        }

        hlNTBReferenceDetailsVm.requestCallBack = function () {
            $state.go('menu.hlNTBRequestCallBack');
        }

        hlNTBReferenceDetailsVm.hlRefereNextSlide = function () {
            $hlReferSliderFun.next();
        }

        hlNTBReferenceDetailsVm.getBanner = function () {
            hlNTBCalculatorService.getOtherBanner().then(function (response) {
                hlNTBReferenceDetailsVm.bannerList = response;
            }).catch(function (error) {
                console.log(error);
            });
        }

        hlNTBReferenceDetailsVm.knowMore = function (obj) {
            $scope.discText = '';
            hlNTBCalculatorService.getDisclaimerContent().then(function (response) {
                $scope.discText = response;
                $ionicPopup.show({
                    cssClass: 'ntb-alert-popup hlTermnCondition',
                    title: 'Disclaimer',
                    template: $scope.discText,
                    scope: $scope,
                    buttons: [
                        {
                            text: 'Cancel',
                            type: 'button-negative',
                            onTap: function (res) { }
                        }, {
                            text: 'OK',
                            type: 'button-positive',
                            onTap: function (res) {
                                if (utilityService.isIOSPlatform()) {
                                    cordova.ThemeableBrowser.open(obj.redirectionURL, '_blank', {});
                                } else {
                                     window.open(obj.redirectionURL);
                                }
                            }
                        }],
                });
            }).catch(function (error) {
                console.log(error);
            });
        }

        hlNTBReferenceDetailsVm.goBack = function () {
            $state.go('menu.hlNTBExploreHomeLoan');
        }

        return this;
    }
]);