'use strict';

angularApp.controller('hlNTBSubmitDetailsController', [
    "$state",
    "$scope",
    "$translate",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService",
    "$filter",
    "hlNTBCalculatorService",
    "homeLoanService",
    "$ionicScrollDelegate", "goldLoanRLMSService", "constantConfig", "cryptoService",

    function ($state,
        $scope,
        $translate,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        $filter,
        hlNTBCalculatorService,
        homeLoanService,
        $ionicScrollDelegate, goldLoanRLMSService, constantConfig, cryptoService) {

        var hlNTBSubmitDetailsVm = this;
        var isvalid = true;
        var regForName = /^[a-zA-Z]*$/;
        var phnReg = /^[123456789]\d{9}$/;
        var pinRegex = /^[123456789]\d{5}$/;
        // var mailformat = /\S+@[a-zA-Z]+\.[a-zA-Z]{2,6}$/;
        // var mailformat2 = /\S+@[a-zA-Z]+\.([a-zA-Z]{2,})+\.[a-zA-Z]{2,}$/;
        var mailformat = /^([\w\.\-]+)@([\w\-]+)((\.(\w){2,63}){1,2})$/;
       
        hlNTBSubmitDetailsVm.mobileMaskUnmask = false;
        hlNTBSubmitDetailsVm.emailMaskUnmask = false;
        hlNTBSubmitDetailsVm.initPage = function () {           
            hlNTBSubmitDetailsVm.maskMobileData = true;
            hlNTBSubmitDetailsVm.maskEmailData = true;
            hlNTBSubmitDetailsVm.email = true;
            hlNTBSubmitDetailsVm.mobile = true;
            hlNTBSubmitDetailsVm.cityList = [];
            hlNTBSubmitDetailsVm.branchList = [];
            hlNTBSubmitDetailsVm.branchList = [];
            hlNTBSubmitDetailsVm.errObj = {};
            hlNTBSubmitDetailsVm.loanPurposeList = [];
            hlNTBSubmitDetailsVm.tNc = '';
            hlNTBSubmitDetailsVm.Mask = '';
            hlNTBSubmitDetailsVm.eligibilityData = {};
            hlNTBSubmitDetailsVm.authorizeCheck = false;
            hlNTBSubmitDetailsVm.eligibilityRequestData = hlNTBCalculatorService.getCheckEligiblityRequest();
            hlNTBSubmitDetailsVm.eligibilityResponseData = hlNTBCalculatorService.getCheckEligiblityResponse()
            hlNTBSubmitDetailsVm.eligibilityAmountDetail = hlNTBCalculatorService.getEligibalAmountDetail()
            hlNTBSubmitDetailsVm.masterData = {};
            hlNTBSubmitDetailsVm.masterDetails();
            hlNTBSubmitDetailsVm.getTermsAndConditions();
            hlNTBSubmitDetailsVm.maskedMobile = '';
            hlNTBSubmitDetailsVm.unMaskedMobile = '';
            $scope.callService = 0 ;
            
           
            if (hlNTBCalculatorService.isSubmitDetailsBack) {
                hlNTBSubmitDetailsVm.populateSubmitDetails();
            }

            setTimeout(function () {
            hlNTBSubmitDetailsVm.updateheader()
           
            }, 1000);
            // hlNTBCalculatorService.updatedigest();

        }

        hlNTBSubmitDetailsVm.checkFirstNameValue = function() {
            if (hlNTBCalculatorService.isValidField(hlNTBSubmitDetailsVm.fname, "First Name")) {
                hlNTBSubmitDetailsVm.errObj.fNameError = hlNTBCalculatorService.isValidField(hlNTBSubmitDetailsVm.fname, "First Name");
                isvalid = false;
            } else {
                if (!regForName.test(hlNTBSubmitDetailsVm.fname)) {
                    hlNTBSubmitDetailsVm.errObj.fNameError = 'Please enter valid name';
                    isvalid = false;
                } else {
                    hlNTBSubmitDetailsVm.errObj.fNameError = '';
                }
            }
        }

        hlNTBSubmitDetailsVm.checkLastNameValue = function() {
            if (hlNTBCalculatorService.isValidField(hlNTBSubmitDetailsVm.lname, "Last Name")) {
                hlNTBSubmitDetailsVm.errObj.lNameError = hlNTBCalculatorService.isValidField(hlNTBSubmitDetailsVm.lname, "Last Name");
                isvalid = false;
            } else {
                if (!regForName.test(hlNTBSubmitDetailsVm.lname)) {
                    hlNTBSubmitDetailsVm.errObj.lNameError = 'Please enter valid name';
                    isvalid = false;
                } else {
                    hlNTBSubmitDetailsVm.errObj.lNameError = '';
                }
            }
        }

        hlNTBSubmitDetailsVm.checkMobileValue = function() {
            if (hlNTBCalculatorService.isValidField(hlNTBSubmitDetailsVm.mobileNumber, "Contact Number")) {
                hlNTBSubmitDetailsVm.errObj.phNumberError = hlNTBCalculatorService.isValidField(hlNTBSubmitDetailsVm.mobileNumber, "Contact Number");
                isvalid = false;
            } else {
                if (!phnReg.test(hlNTBSubmitDetailsVm.mobileNumber)) {
                    hlNTBSubmitDetailsVm.errObj.phNumberError = 'Contact number should be of ten digits (0-9) and should not start with zero.';
                    isvalid = false;
                } else {
                    hlNTBSubmitDetailsVm.errObj.phNumberError = '';
                }
            }
        }

        hlNTBSubmitDetailsVm.checkEmailValue = function() {
            if (hlNTBCalculatorService.isValidField(hlNTBSubmitDetailsVm.emailId, "Email ID")) {
                hlNTBSubmitDetailsVm.errObj.emailError = hlNTBCalculatorService.isValidField(hlNTBSubmitDetailsVm.emailId, "Email ID");
                isvalid = false;
            } else {                
                if (!mailformat.test(hlNTBSubmitDetailsVm.emailId)) {
                    hlNTBSubmitDetailsVm.errObj.emailError = "Please enter correct email id containing @ symbol followed by valid domain name.";
                    isvalid = false;
                } else {
                    hlNTBSubmitDetailsVm.errObj.emailError = '';
                }
            }
        }


        hlNTBSubmitDetailsVm.updateheader = function () {
            if (hlNTBCalculatorService.getIsCallBackRequset() == 'false') {
                hlNTBSubmitDetailsVm.isNormalFlow = 'N';
            } else {
                hlNTBSubmitDetailsVm.isNormalFlow = 'R';
            }
            if (!$scope.$$phase)
                $scope.$apply();

        }

        hlNTBSubmitDetailsVm.getCityList = function () {
            if (hlNTBCalculatorService.isValidField(hlNTBSubmitDetailsVm.pincode, "pincode")) {
                hlNTBSubmitDetailsVm.errObj.pincodeError = hlNTBCalculatorService.isValidField(hlNTBSubmitDetailsVm.pincode, "pincode");
                hlNTBSubmitDetailsVm.city = "";
                hlNTBSubmitDetailsVm.branch = "";
            } else if ((hlNTBSubmitDetailsVm.pincode.length != 6) || (!pinRegex.test(hlNTBSubmitDetailsVm.pincode))) {
                hlNTBSubmitDetailsVm.errObj.pincodeError = 'Pin code should be of six digits (0-9) and should not start with zero.”';
                hlNTBSubmitDetailsVm.city = "";
                hlNTBSubmitDetailsVm.branch = "";
            } else {
                hlNTBSubmitDetailsVm.errObj.pincodeError = '';
                var payload = {
                    "pinCode": hlNTBSubmitDetailsVm.pincode
                }
                hlNTBCalculatorService.getCityByPinCode(payload).then(function (response) {
                    hlNTBSubmitDetailsVm.cityList = response;
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        }

        hlNTBSubmitDetailsVm.getBranchList = function () {
            if (hlNTBCalculatorService.isValidField(hlNTBSubmitDetailsVm.city, "pincode")) {
                hlNTBSubmitDetailsVm.errObj.pincodeError = hlNTBCalculatorService.isValidField(hlNTBSubmitDetailsVm.pincode, "pincode");
                hlNTBSubmitDetailsVm.branch = "";
            } else {
                var payload = {
                    "cityCode": hlNTBSubmitDetailsVm.city
                }
                hlNTBCalculatorService.getBranchListByCity(payload).then(function (response) {
                    hlNTBSubmitDetailsVm.branchList = response.branchList;
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        }


        hlNTBSubmitDetailsVm.populateSubmitDetails = function () {
            var retentionData = {};
            retentionData = hlNTBCalculatorService.submitLeadData;
            hlNTBSubmitDetailsVm.fname = retentionData.fname;
            hlNTBSubmitDetailsVm.lname = retentionData.lname;
            hlNTBSubmitDetailsVm.mobileNumber = retentionData.mobileNumber;
            hlNTBSubmitDetailsVm.emailId = retentionData.emailId;
            hlNTBSubmitDetailsVm.pincode = retentionData.pincode;
            hlNTBSubmitDetailsVm.getCityList();
            setTimeout(function () {
                hlNTBSubmitDetailsVm.city = retentionData.city
                hlNTBSubmitDetailsVm.getBranchList(hlNTBSubmitDetailsVm.city);
                if (!$scope.$$phase)
                    $scope.$apply();
                setTimeout(function () {
                    hlNTBSubmitDetailsVm.branch = retentionData.branch;
                    hlNTBSubmitDetailsVm.loanpurpose = retentionData.loanpurpose;
                    hlNTBSubmitDetailsVm.authorizeCheck = retentionData.authorizeCheck;
                    if (!$scope.$$phase)
                        $scope.$apply();
                }, 2000);
            }, 1000);
        }

       hlNTBSubmitDetailsVm.masterDetails = function () {
            var payload = {};
            if (hlNTBSubmitDetailsVm.isNormalFlow == 'false') {
                var gen = '';
                var empType = '';
                if (!hlNTBSubmitDetailsVm.eligibilityRequestData.coApplicantAdded) {
                    gen = hlNTBSubmitDetailsVm.eligibilityRequestData.applicantDetails.gender;
                    empType = hlNTBSubmitDetailsVm.eligibilityRequestData.applicantDetails.incomeSource;
                } else {
                    if (hlNTBCalculatorService.calculateAge(new Date(hlNTBSubmitDetailsVm.eligibilityRequestData.applicantDetails.dateOfBirth)) > hlNTBCalculatorService.calculateAge(new Date(hlNTBSubmitDetailsVm.eligibilityRequestData.coApplicantDetails.dateOfBirth))) {
                        gen = hlNTBSubmitDetailsVm.eligibilityRequestData.coApplicantDetails.gender;
                        empType = hlNTBSubmitDetailsVm.eligibilityRequestData.coApplicantDetails.incomeSource;
                    } else {
                        gen = hlNTBSubmitDetailsVm.eligibilityRequestData.applicantDetails.gender;
                        empType = hlNTBSubmitDetailsVm.eligibilityRequestData.applicantDetails.incomeSource;

                    }
                }
                payload = {
                    "gender": gen,
                    "employmentType": empType,
                    "loanType": ""
                }
            } else {
                payload = {
                    "gender": 'F',
                    "employmentType": 'Salaried',
                    "loanType": ""
                }
            }


            hlNTBCalculatorService.getMasterData(payload).then(function (response) {

                hlNTBSubmitDetailsVm.masterData = response
                hlNTBSubmitDetailsVm.loanPurposeList = response.loanPurposeMasterDataList;
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
       

        hlNTBSubmitDetailsVm.validateDetailsForm = function () {
            hlNTBSubmitDetailsVm.errObj = {};
            isvalid = true;

            if (hlNTBCalculatorService.isValidField(hlNTBSubmitDetailsVm.fname, "First Name")) {
                hlNTBSubmitDetailsVm.errObj.fNameError = hlNTBCalculatorService.isValidField(hlNTBSubmitDetailsVm.fname, "First Name");
                isvalid = false;
            } else {
                if (!regForName.test(hlNTBSubmitDetailsVm.fname)) {
                    hlNTBSubmitDetailsVm.errObj.fNameError = 'Please enter valid name';
                    isvalid = false;
                } else {
                    hlNTBSubmitDetailsVm.errObj.fNameError = '';
                }
            }

            if (hlNTBCalculatorService.isValidField(hlNTBSubmitDetailsVm.lname, "Last Name")) {
                hlNTBSubmitDetailsVm.errObj.lNameError = hlNTBCalculatorService.isValidField(hlNTBSubmitDetailsVm.lname, "Last Name");
                isvalid = false;
            } else {
                if (!regForName.test(hlNTBSubmitDetailsVm.lname)) {
                    hlNTBSubmitDetailsVm.errObj.lNameError = 'Please enter valid name';
                    isvalid = false;
                } else {
                    hlNTBSubmitDetailsVm.errObj.lNameError = '';
                }
            }

            if (hlNTBCalculatorService.isValidField(hlNTBSubmitDetailsVm.mobileNumber, "Contact Number")) {
                hlNTBSubmitDetailsVm.errObj.phNumberError = hlNTBCalculatorService.isValidField(hlNTBSubmitDetailsVm.mobileNumber, "Contact Number");
                isvalid = false;
            } else {
                if (!phnReg.test(hlNTBSubmitDetailsVm.mobileNumber)) {
                    hlNTBSubmitDetailsVm.errObj.phNumberError = 'Contact number should be of ten digits (0-9) and should not start with zero.';
                    isvalid = false;
                } else {
                    hlNTBSubmitDetailsVm.errObj.phNumberError = '';
                }
            }

            if (hlNTBCalculatorService.isValidField(hlNTBSubmitDetailsVm.emailId, "Email ID")) {
                hlNTBSubmitDetailsVm.errObj.emailError = hlNTBCalculatorService.isValidField(hlNTBSubmitDetailsVm.emailId, "Email ID");
                isvalid = false;
            } else {
                if (!mailformat.test(hlNTBSubmitDetailsVm.emailId)) {
                    hlNTBSubmitDetailsVm.errObj.emailError = "Please enter correct email id containing @ symbol followed by valid domain name.";
                    isvalid = false;
                } else {
                    hlNTBSubmitDetailsVm.errObj.emailError = '';
                }
            }

            if (hlNTBCalculatorService.isValidField(hlNTBSubmitDetailsVm.pincode, "PIN Code of Current Residential Address")) {
                hlNTBSubmitDetailsVm.errObj.pincodeError = hlNTBCalculatorService.isValidField(hlNTBSubmitDetailsVm.pincode, "PIN Code of Current Residential Address");
                isvalid = false;
            } else {
                if (!pinRegex.test(hlNTBSubmitDetailsVm.pincode)) {
                    hlNTBSubmitDetailsVm.errObj.pincodeError = 'Pin code should be of six digits (0-9) and should not start with zero.';
                    isvalid = false;
                } else {
                    hlNTBSubmitDetailsVm.errObj.pincodeError = '';
                }
            }

            if (hlNTBCalculatorService.isValidField(hlNTBSubmitDetailsVm.city, "City")) {
                hlNTBSubmitDetailsVm.errObj.cityError = hlNTBCalculatorService.isValidField(hlNTBSubmitDetailsVm.city, "City");
                isvalid = false;
            } else {
                hlNTBSubmitDetailsVm.errObj.cityError = '';
            }

            if (hlNTBCalculatorService.isValidField(hlNTBSubmitDetailsVm.branch, "Your Preferred Branch")) {
                hlNTBSubmitDetailsVm.errObj.branchError = hlNTBCalculatorService.isValidField(hlNTBSubmitDetailsVm.branch, "Your Preferred Branch");
                isvalid = false;
            } else {
                hlNTBSubmitDetailsVm.errObj.branchError = '';
            }

            if (hlNTBCalculatorService.isValidField(hlNTBSubmitDetailsVm.loanpurpose, "Loan Purpose")) {
                hlNTBSubmitDetailsVm.errObj.loanpurposeError = hlNTBCalculatorService.isValidField(hlNTBSubmitDetailsVm.loanpurpose, "Loan Purpose");
                isvalid = false;
            } else {
                hlNTBSubmitDetailsVm.errObj.loanpurposeError = '';
            }

            return isvalid;
        }

        hlNTBSubmitDetailsVm.getTermsConditions = function () {
            // hlNTBSubmitDetailsVm.termsNconditions = "I/We certify that the information provided by me/us in this application form is true and correct in all respects and State Bank of India is entitled to verify this directly or through any third party agent. I/We confirm that the attached copies of financials/Bank Statements/Title/Legal documents etc. are submitted by me/us against my/our loan application and certify that these are true copies. I/We further acknowledge the Bank's right to seek any information from any other source in this regard. I/We understand that all of the above-mentioned information shall form the basis of any facility that the Bank may decide to grant to me/us at its sole discretion.";
            hlNTBCalculatorService.showTncAlertPopup("", "Terms & Conditions", hlNTBSubmitDetailsVm.tNc,
                "menu.hlNTBSubmitDetails", "OK", "", "", "");
        }

        hlNTBSubmitDetailsVm.getTermsAndConditions = function () {
            hlNTBCalculatorService.getTermsAndConditions().then(function (response) {
                hlNTBSubmitDetailsVm.tNc = response;
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        hlNTBSubmitDetailsVm.goBack = function () {
            if (hlNTBCalculatorService.getIsCallBackRequset() == 'true') {
                hlNTBCalculatorService.isSubmitDetailsBack = false ;
                $state.go('menu.hlNTBExploreHomeLoan');
            } else {
                hlNTBCalculatorService.isAmountBack = true;
                $state.go('menu.hlNTBEligibileAmountDetails');
            }
        }

        hlNTBSubmitDetailsVm.unmaskData = function (type, flag) {
            if (type === 'mobile') {
                if (flag === true) {
                   hlNTBSubmitDetailsVm.maskMobileData = true;
                   document.getElementById('mob').classList.remove('unhide-input-txt-hl-ntb')

                } else {
                   hlNTBSubmitDetailsVm.maskMobileData = false;
                   document.getElementById('mob').classList.add('unhide-input-txt-hl-ntb');
                   
                }
            }

            if (type === 'email') {
                if (flag === true) {
                    document.getElementById('email').classList.remove('unhide-input-txt-hl-ntb')
                    hlNTBSubmitDetailsVm.maskEmailData = true;
                   
                } else {
                    document.getElementById('email').classList.add('unhide-input-txt-hl-ntb');
                   
                    hlNTBSubmitDetailsVm.maskEmailData = false;
                   
                }
            }
            hlNTBSubmitDetailsVm.updatedigest();
        }
        
        hlNTBSubmitDetailsVm.toggleEye = function (type) {
            hlNTBSubmitDetailsVm.isTextReadable == true ? hlNTBSubmitDetailsVm.isTextReadable = false : hlNTBSubmitDetailsVm.isTextReadable = true;
            if (type === "mobile") {
                hlNTBSubmitDetailsVm.mobileMaskUnmask = hlNTBSubmitDetailsVm.isTextReadable;
            }
            if (type === "email"){
                hlNTBSubmitDetailsVm.emailMaskUnmask = hlNTBSubmitDetailsVm.isTextReadable;
            }
        };

        hlNTBSubmitDetailsVm.setMaskedNumber = function(val){
            $scope.maskedNumber = val.replace(/[0-9]{6}/,'XXXXXX');
        }

        hlNTBSubmitDetailsVm.submitDetails = function () {
            utilityService.showSpinner();  
            if (hlNTBSubmitDetailsVm.validateDetailsForm()) {
                if (hlNTBSubmitDetailsVm.authorizeCheck) {
                    hlNTBSubmitDetailsVm.getSubmitPayload();
                } else {
                    hlNTBSubmitDetailsVm.errorCheck = true;
                    $ionicScrollDelegate.scrollBottom();
                    utilityService.hideSpinner();  
                }
            }else{
                utilityService.hideSpinner();
            }
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            hlNTBSubmitDetailsVm.initPage();
        });


        hlNTBSubmitDetailsVm.getSubmitPayload = function () {
           // utilityService.showSpinner();  
            var payld = {
                "sourceId": "",
                "comments": hlNTBSubmitDetailsVm.loanpurpose,
                "email": hlNTBSubmitDetailsVm.emailId,
                "firstname": hlNTBSubmitDetailsVm.fname,
                "lastname": hlNTBSubmitDetailsVm.lname,
                "mobile": hlNTBSubmitDetailsVm.mobileNumber,
                "branchcode": hlNTBSubmitDetailsVm.branch,
                "city": hlNTBSubmitDetailsVm.cityList[0].cityName,
                "pincode": hlNTBSubmitDetailsVm.pincode,
            }

            if (hlNTBCalculatorService.getIsCallBackRequset() === 'true') {
                payld.gender = 'F';
                payld.isCallbackRequest = 'Y';
            } else {
                payld.gender = hlNTBSubmitDetailsVm.eligibilityRequestData.applicantDetails.gender;
                payld.loanamount = hlNTBSubmitDetailsVm.eligibilityAmountDetail.eligibleLoanAmount;
                payld.isCallbackRequest = 'N';
                payld.otherLoanDetails = {};
                payld.otherLoanDetails.applicantDetails = [];
                var temp = {
                    "isPrimaryApplicant": 'Y',
                    "dob": hlNTBSubmitDetailsVm.eligibilityRequestData.applicantDetails.dateOfBirth,
                    "gender": hlNTBSubmitDetailsVm.eligibilityRequestData.applicantDetails.gender,
                    "incomeSource": hlNTBSubmitDetailsVm.eligibilityRequestData.applicantDetails.incomeSource,
                    "netMonthlyIncome": hlNTBSubmitDetailsVm.eligibilityRequestData.applicantDetails.netMonthlyIncome,
                    "totalEMI": hlNTBSubmitDetailsVm.eligibilityRequestData.applicantDetails.emiOnExistingLoan,
                   
                }
                if(hlNTBSubmitDetailsVm.eligibilityRequestData.applicantDetails.incomeSource == 'Salaried'){
                    temp.retirementAge = hlNTBSubmitDetailsVm.eligibilityRequestData.applicantDetails.retirementAge ;
                }
                payld.otherLoanDetails.applicantDetails.push(temp)
                if (hlNTBSubmitDetailsVm.eligibilityRequestData.coApplicantAdded) {
                    var tem1 = {
                        "isPrimaryApplicant": 'N',
                        "dob": hlNTBSubmitDetailsVm.eligibilityRequestData.coApplicantDetails.dateOfBirth,
                        "gender": hlNTBSubmitDetailsVm.eligibilityRequestData.coApplicantDetails.gender,
                        "incomeSource": hlNTBSubmitDetailsVm.eligibilityRequestData.coApplicantDetails.incomeSource,
                        "netMonthlyIncome": hlNTBSubmitDetailsVm.eligibilityRequestData.coApplicantDetails.netMonthlyIncome,
                        "totalEMI": hlNTBSubmitDetailsVm.eligibilityRequestData.coApplicantDetails.emiOnExistingLoan,
                    }
                    if(hlNTBSubmitDetailsVm.eligibilityRequestData.coApplicantDetails.incomeSource == 'Salaried'){
                        tem1.retirementAge = hlNTBSubmitDetailsVm.eligibilityRequestData.coApplicantDetails.retirementAge ;
                    }
                    payld.otherLoanDetails.applicantDetails.push(tem1);

                }
                payld.otherLoanDetails.eligibleLoanAmount = hlNTBSubmitDetailsVm.eligibilityAmountDetail.loanamount;
                payld.otherLoanDetails.monthlyEMI = hlNTBSubmitDetailsVm.eligibilityAmountDetail.monthlyEMI;
                payld.otherLoanDetails.interestRate = hlNTBSubmitDetailsVm.eligibilityAmountDetail.interestRate;
                payld.otherLoanDetails.loanTenure = hlNTBSubmitDetailsVm.eligibilityAmountDetail.loanTenure;
                payld.otherLoanDetails.propertyValue = 999999 //hlNTBSubmitDetailsVm.eligibilityAmountDetail.propertyValue;
                payld.otherLoanDetails.downPayment = 9999//hlNTBSubmitDetailsVm.eligibilityAmountDetail.downPayment;
            }
            hlNTBCalculatorService.setGenerateLeadData(payld);
            $scope.callService = $scope.callService + 1 ;
            if($scope.callService == 1){
                hlNTBSubmitDetailsVm.generateOTP(hlNTBSubmitDetailsVm.mobileNumber);
            }else{
                utilityService.hideSpinner();  
                return;
            }
           
        }

        hlNTBSubmitDetailsVm.generateOTP = function (mobileNumber) {
            var reqParams = {};
            reqParams["id"] = mobileNumber;
            reqParams.otpCode = constantConfig.keysForOTP.Register;
            reqParams.ocHash = cryptoService.getSHA512EncryptedData(constantConfig.keysForOTP.Register).toString();
            hlNTBCalculatorService.generateOTP(reqParams).then(function (data) {
                hlNTBCalculatorService.submitLeadData = hlNTBSubmitDetailsVm;
                hlNTBCalculatorService.setContactNumber(hlNTBSubmitDetailsVm.mobileNumber);
                $scope.callService = 0;
                utilityService.hideSpinner(); 
                $state.go('menu.hlNTBOTPVerification');
                hlNTBSubmitDetailsVm.updatedigest();
            }, function (error) {
                $scope.callService = 0;
                utilityService.hideSpinner(); 
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        hlNTBSubmitDetailsVm.updatedigest = function () {
            if (!$scope.$$phase)
                $scope.$apply();
            return;
        }
        return this;
    }
]);