'use strict';
angularApp.controller('pmayController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"$ionicScrollDelegate",
		"validateService",
		"homeLoanService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate,$ionicScrollDelegate,validateService,homeLoanService) {
			
			var pmayControllerVm = this;

			pmayControllerVm.detail = {};
			pmayControllerVm.errObj = {};
			
			function initPage() {
				pmayControllerVm.detail = {};
				pmayControllerVm.validateService = validateService;
				pmayControllerVm.getCarpetAreaMaster();
			};

			pmayControllerVm.validateForm = function(){
				pmayControllerVm.errObj = {};

				if(validateService.isPuccaHouse(pmayControllerVm.puccaHouse)){
					pmayControllerVm.errObj.puccaHouse = validateService.isPuccaHouse(pmayControllerVm.puccaHouse);
				}

				if(validateService.isGahi(pmayControllerVm.gahi)){
					pmayControllerVm.errObj.gahi = validateService.isGahi(pmayControllerVm.gahi);
				}
				
				if(validateService.isHouseCarpet(pmayControllerVm.houseCarpet)){
					pmayControllerVm.errObj.houseCarpet = validateService.isHouseCarpet(pmayControllerVm.houseCarpet);
				}

				if(validateService.isPropertyLocation(pmayControllerVm.propertyLocation)){
					pmayControllerVm.errObj.propertyLocation = validateService.isPropertyLocation(pmayControllerVm.propertyLocation);
				}

				return (angular.equals({}, pmayControllerVm.errObj)) ? true : false;
			}

			pmayControllerVm.getCarpetAreaMaster = function(){
				if(!homeLoanService.CarpetAreaMaster){
				var request = {};
	
				  homeLoanService.getCarpetAreaMaster(request).then(function(data) {
					homeLoanService.CarpetAreaMaster = data.info;
					pmayControllerVm.houseCarpetList = homeLoanService.CarpetAreaMaster;
					  
				  },function(error){
					  utilityService.showErrorMessage(error.responseMessage);
				  });
				}
				else{
					pmayControllerVm.houseCarpetList = homeLoanService.CarpetAreaMaster;
				}

			}

			
			

			$scope.$on('$ionicView.loaded', function () {
				
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				initPage();
			});

			pmayControllerVm.goBack = function(){
				if(homeLoanService.propIdentified == 'N'){
					if(homeLoanService.getIsCoApplicant()){
						$state.go('menu.coApplicantWorkDetails');
					}else{
						$state.go('menu.addCoApplicant');
					}
				}else{
					$ionicHistory.goBack(-1);
				}
			}

			

			

			pmayControllerVm.goToNextPage = function(){
				if(pmayControllerVm.validateForm()){

				homeLoanService.setPmayDetails(pmayControllerVm);
				$state.go('menu.calculateEmi');

				}
			}

			

			return this;
		}

		
]);


