'use strict';
angularApp.controller('calculateEmiTakeoverController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"validateService",
		"$filter","$interval",
		"homeLoanService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate,validateService,$filter,$interval,homeLoanService) {
			
			var calculateEmiTakeoverVm = this;
			
			function initPage() {
				
				calculateEmiTakeoverVm.calculateEmiResponse = homeLoanService.getEmiResponse();
				//calculateEmiTakeoverVm.emiAmount = parseInt(Math.ceil(homeLoanService.getEmiResponse().emi));
				var rupeeSymbol = String.fromCharCode(8377);
				calculateEmiTakeoverVm.detail = {};
				calculateEmiTakeoverVm.disableBackButton = homeLoanService.disableBackButton;
				calculateEmiTakeoverVm.detail.interestRate = parseFloat(calculateEmiTakeoverVm.calculateEmiResponse.rate);
				
				//calculateEmiTakeoverVm.emiCalculation();
				//calculateEmiTakeoverVm.checkBureau = true;
				calculateEmiTakeoverVm.checkBureau = false;
				calculateEmiTakeoverVm.waitBureau = true;

				calculateEmiTakeoverVm.tenureSlider = {
                    value: calculateEmiTakeoverVm.calculateEmiResponse.tenure.initial,
                    options: {
                    	showSelectionBar: true,
                    	floor :  calculateEmiTakeoverVm.calculateEmiResponse.tenure.min,
						ceil :  calculateEmiTakeoverVm.calculateEmiResponse.tenure.max,
						step :  calculateEmiTakeoverVm.calculateEmiResponse.tenure.step,
						onChange : function(id,model){
							calculateEmiTakeoverVm.emiCalculation();
							calculateEmiTakeoverVm.emiCalculationTopup();
						},
						translate : function(value){
							return  value + " mths";
						}	
                    }
                };

                calculateEmiTakeoverVm.emiCalculation();

                if(calculateEmiTakeoverVm.calculateEmiResponse.topupAmount){
                	calculateEmiTakeoverVm.topupSlider = {
	                    value: calculateEmiTakeoverVm.calculateEmiResponse.topupAmount.initial,
	                    options: {
	                    	showSelectionBar: true,
	                    	floor :  calculateEmiTakeoverVm.calculateEmiResponse.topupAmount.min,
							ceil :  calculateEmiTakeoverVm.calculateEmiResponse.topupAmount.max,
							step :  1,
							onChange : function(id,model){								
								calculateEmiTakeoverVm.emiCalculationTopup();
							},
							translate : function(value){
								return  rupeeSymbol + $filter('INR')(value);
							}	
	                    }
	                };

	                
	                if((calculateEmiTakeoverVm.calculateEmiResponse.topupAmount.max - calculateEmiTakeoverVm.calculateEmiResponse.topupAmount.min) < 1000){
	                	//set flag 
	                	calculateEmiTakeoverVm.fixedTopupAvail = true;
	                }else{
	                	calculateEmiTakeoverVm.fixedTopupAvail = false;
	                }

	                //topup display topUp
	                calculateEmiTakeoverVm.toAvailTopUp = homeLoanService.getTopupData();

	                calculateEmiTakeoverVm.topUpWithCheckbox = false;
	                calculateEmiTakeoverVm.topUpWithoutCheckbox = false;
	                calculateEmiTakeoverVm.topUpCheckbox = false;

	                if(!calculateEmiTakeoverVm.toAvailTopUp.topupLoanOutstandingAmount && calculateEmiTakeoverVm.calculateEmiResponse.topUp){
	                	calculateEmiTakeoverVm.topUpWithCheckbox = true;
	                	if(calculateEmiTakeoverVm.calculateEmiResponse.topUp) {	                		
	                		if(calculateEmiTakeoverVm.calculateEmiResponse.topUp.requestedTopupAmt){
	                			calculateEmiTakeoverVm.topUpCheckbox = true;
	                			calculateEmiTakeoverVm.topupSlider.value = calculateEmiTakeoverVm.calculateEmiResponse.topUp.requestedTopupAmt;
	                		}else{
	                			calculateEmiTakeoverVm.topupSlider.value = calculateEmiTakeoverVm.calculateEmiResponse.topupAmount.max;
	                		}
	                		
	                		var intRates = calculateEmiTakeoverVm.calculateEmiResponse.topUp.rateSlab;
							for(var i=0; i < intRates.length; i++){
								if(parseInt(calculateEmiTakeoverVm.topupSlider.value) > parseInt(intRates[i].minLoanAmt) && parseInt(calculateEmiTakeoverVm.topupSlider.value) < parseInt(intRates[i].maxLoanAmt)){
									calculateEmiTakeoverVm.calculateEmiResponse.topUp.rate= intRates[i].intRate;
								}
							}
	                	}
	                }else{
	                	calculateEmiTakeoverVm.topUpWithoutCheckbox = true;
	                	if(calculateEmiTakeoverVm.calculateEmiResponse.topUp) {
	                		if(calculateEmiTakeoverVm.calculateEmiResponse.topUp.requestedTopupAmt){
	                			calculateEmiTakeoverVm.topupSlider.value = calculateEmiTakeoverVm.calculateEmiResponse.topUp.requestedTopupAmt;
	                		}else{
	                			calculateEmiTakeoverVm.topupSlider.value = calculateEmiTakeoverVm.calculateEmiResponse.topUp.maxTopupLoanAmt;
	                		}
	                		
	                		var intRates = calculateEmiTakeoverVm.calculateEmiResponse.topUp.rateSlab;
							for(var i=0; i < intRates.length; i++){
								if(parseInt(calculateEmiTakeoverVm.topupSlider.value) > parseInt(intRates[i].minLoanAmt) && parseInt(calculateEmiTakeoverVm.topupSlider.value) < parseInt(intRates[i].maxLoanAmt)){
									calculateEmiTakeoverVm.calculateEmiResponse.topUp.rate= intRates[i].intRate;
								}
							}
	                	}
	                }

					calculateEmiTakeoverVm.emiCalculationTopup();
                }

				// var p = calculateEmiTakeoverVm.calculateEmiResponse.amount.max;
				// var i = (calculateEmiTakeoverVm.detail.interestRate/1200);
				// var t = calculateEmiTakeoverVm.calculateEmiResponse.tenure.max;
				// var numerator = p * i * Math.pow((1+i),t);
				// var denominator = Math.pow((1+i),t) - 1;
				// calculateEmiTakeoverVm.emiMaxAmount = Math.ceil((numerator/denominator));

				calculateEmiTakeoverVm.emiMaxAmount =  parseInt(Math.ceil(homeLoanService.getEmiResponse().emi));	

			};


			calculateEmiTakeoverVm.setMax = function(field,value){				

				if(field == "tenure"){
					// value = calculateEmiTakeoverVm.calculateEmiResponse.tenure.max;
					// if(parseInt(calculateEmiTakeoverVm.tenureSlider.value) > parseInt(value)){
					// 	calculateEmiTakeoverVm.tenureSlider.value = value + "";
					// }else if(parseInt(calculateEmiTakeoverVm.tenureSlider.value) < parseInt(calculateEmiTakeoverVm.calculateEmiResponse.tenure.min)){
					// 	calculateEmiTakeoverVm.tenureSlider.value = parseInt(calculateEmiTakeoverVm.calculateEmiResponse.tenure.min);
					// }

					if(isNaN(calculateEmiTakeoverVm.tenureSlider.value)){
						calculateEmiTakeoverVm.tenureSlider.value = calculateEmiTakeoverVm.calculateEmiResponse.tenure.min;
					}else{
						calculateEmiTakeoverVm.tenureSlider.value = calculateEmiTakeoverVm.tenureSlider.value < calculateEmiTakeoverVm.calculateEmiResponse.tenure.min ? calculateEmiTakeoverVm.calculateEmiResponse.tenure.min : calculateEmiTakeoverVm.tenureSlider.value;
						calculateEmiTakeoverVm.tenureSlider.value = calculateEmiTakeoverVm.tenureSlider.value > calculateEmiTakeoverVm.calculateEmiResponse.tenure.max ? calculateEmiTakeoverVm.calculateEmiResponse.tenure.max : calculateEmiTakeoverVm.tenureSlider.value;
					}

					if(calculateEmiTakeoverVm.tenureSlider.value % calculateEmiTakeoverVm.calculateEmiResponse.tenure.step > 0){
						calculateEmiTakeoverVm.tenureSlider.value -= (calculateEmiTakeoverVm.tenureSlider.value % calculateEmiTakeoverVm.calculateEmiResponse.tenure.step);
					}
				}
				if(field == "topup"){
					// value = calculateEmiTakeoverVm.calculateEmiResponse.topupAmount.max;
					// if(parseInt(calculateEmiTakeoverVm.topupSlider.value) > parseInt(value)){
					// 	calculateEmiTakeoverVm.topupSlider.value = value + "";
					// }
					// else if(parseInt(calculateEmiTakeoverVm.topupSlider.value) < parseInt(calculateEmiTakeoverVm.calculateEmiResponse.topupAmount.min)){
					// 	calculateEmiTakeoverVm.topupSlider.value = parseInt(calculateEmiTakeoverVm.calculateEmiResponse.topupAmount.min);
					// }
					if(isNaN(calculateEmiTakeoverVm.topupSlider.value)){
						calculateEmiTakeoverVm.topupSlider.value = calculateEmiTakeoverVm.calculateEmiResponse.topupAmount.min;
					}else{
						calculateEmiTakeoverVm.topupSlider.value = calculateEmiTakeoverVm.topupSlider.value < calculateEmiTakeoverVm.calculateEmiResponse.topupAmount.min ? calculateEmiTakeoverVm.calculateEmiResponse.topupAmount.min : calculateEmiTakeoverVm.topupSlider.value;
						calculateEmiTakeoverVm.topupSlider.value = calculateEmiTakeoverVm.topupSlider.value > calculateEmiTakeoverVm.calculateEmiResponse.topupAmount.max ? calculateEmiTakeoverVm.calculateEmiResponse.topupAmount.max : calculateEmiTakeoverVm.topupSlider.value;
					}

					if(calculateEmiTakeoverVm.topupSlider.value % calculateEmiTakeoverVm.calculateEmiResponse.topupAmount.step > 0){
						calculateEmiTakeoverVm.topupSlider.value -= (calculateEmiTakeoverVm.topupSlider.value % calculateEmiTakeoverVm.calculateEmiResponse.topupAmount.step);
					}
				}
				
				calculateEmiTakeoverVm.emiCalculation();
				calculateEmiTakeoverVm.emiCalculationTopup();
			}

			calculateEmiTakeoverVm.showAdditionalTopUp = function(){
				// calculateEmiTakeoverVm.topUpCheckbox = !calculateEmiTakeoverVm.topUpCheckbox;
				calculateEmiTakeoverVm.emiCalculationTotal();
			}

			calculateEmiTakeoverVm.emiCalculation = function(){
				calculateEmiTakeoverVm.emiAmount = homeLoanService.emiCalculation(calculateEmiTakeoverVm.calculateEmiResponse.requestedTakeoverAmt,calculateEmiTakeoverVm.detail.interestRate,calculateEmiTakeoverVm.tenureSlider.value);
				calculateEmiTakeoverVm.emiCalculationTotal();
			}

			calculateEmiTakeoverVm.emiCalculationTopup = function(){

				if(calculateEmiTakeoverVm.topupSlider.value % calculateEmiTakeoverVm.calculateEmiResponse.topupAmount.step > 0){
					calculateEmiTakeoverVm.topupSlider.value -= (calculateEmiTakeoverVm.topupSlider.value % calculateEmiTakeoverVm.calculateEmiResponse.topupAmount.step);
				}

				if(calculateEmiTakeoverVm.calculateEmiResponse.topupAmount.max - calculateEmiTakeoverVm.calculateEmiResponse.topupAmount.min > 1000){
					calculateEmiTakeoverVm.emiAmountTopup = homeLoanService.emiCalculation(calculateEmiTakeoverVm.topupSlider.value,calculateEmiTakeoverVm.calculateEmiResponse.topUp.rate,calculateEmiTakeoverVm.tenureSlider.value);
				}else{
					calculateEmiTakeoverVm.emiAmountTopup = homeLoanService.emiCalculation(calculateEmiTakeoverVm.calculateEmiResponse.topUp.maxTopupLoanAmt,calculateEmiTakeoverVm.calculateEmiResponse.topUp.rate,calculateEmiTakeoverVm.tenureSlider.value);
				}
				calculateEmiTakeoverVm.emiCalculationTotal();
			}
			
			calculateEmiTakeoverVm.emiCalculationTotal = function(){
				
					if(calculateEmiTakeoverVm.emiAmountTopup){
						if((calculateEmiTakeoverVm.topUpCheckbox && calculateEmiTakeoverVm.topUpWithCheckbox) || calculateEmiTakeoverVm.topUpWithoutCheckbox){
							calculateEmiTakeoverVm.emiTotalAmount = parseInt(calculateEmiTakeoverVm.emiAmount) + parseInt(calculateEmiTakeoverVm.emiAmountTopup);
							calculateEmiTakeoverVm.loanTotalAmount = parseInt(calculateEmiTakeoverVm.calculateEmiResponse.requestedTakeoverAmt) + parseInt(calculateEmiTakeoverVm.topupSlider.value);
						}else{
							calculateEmiTakeoverVm.emiTotalAmount = parseInt(calculateEmiTakeoverVm.emiAmount);
							calculateEmiTakeoverVm.loanTotalAmount = parseInt(calculateEmiTakeoverVm.calculateEmiResponse.requestedTakeoverAmt);
						}
						
					}else{
						calculateEmiTakeoverVm.emiTotalAmount = parseInt(calculateEmiTakeoverVm.emiAmount);
						calculateEmiTakeoverVm.loanTotalAmount = parseInt(calculateEmiTakeoverVm.calculateEmiResponse.requestedTakeoverAmt);
					}		
			}

			$scope.$on('$ionicView.loaded', function () {
				
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				initPage();
			});

			calculateEmiTakeoverVm.goToNext = function(){
				var request = {};
				if(homeLoanService.getPropertiesData()){
					if(homeLoanService.getPropertiesData().propertyIdentify == 'Y'){
						request = {
							"loanType": homeLoanService.getGroupId(),
							"loanAmount": calculateEmiTakeoverVm.calculateEmiResponse.requestedTakeoverAmt,
							"loanTenure": calculateEmiTakeoverVm.tenureSlider.value.toString(),
							"propertyIdentify": "Y",
							"propertyType":homeLoanService.getPropertiesData().propertyType.key,
							"propertyTypeValue": homeLoanService.getPropertiesData().propertyType ? JSON.stringify(homeLoanService.getPropertiesData().propertyType) : "",
							"propertyValue": homeLoanService.getPropertiesData().propertyValue,
							"numberOfFloors": homeLoanService.getPropertiesData().numberOfFloors,
							"moratoriumPeriod": homeLoanService.getPropertiesData().moratoriumPeriod,
							"carpetArea": homeLoanService.getPropertiesData().carpetArea,
							"propertySearchType":homeLoanService.propertySearchType,
							"propertyDetails": {
								"projectApproved": homeLoanService.propertySearchType == 'N' ? 'N' : 'Y',
							    "reraId": homeLoanService.reraPropertyDetails.reraId,
							    "projectId": homeLoanService.reraPropertyDetails.projectId,
							    "projectName": homeLoanService.reraPropertyDetails.projectName,
							    "propertyAddressline1": homeLoanService.reraPropertyDetails.propertyAddressline1,
							    "propertyAddressline2": homeLoanService.reraPropertyDetails.propertyAddressline2,
							    "pincode": homeLoanService.reraPropertyDetails.pincode,
							    "state": homeLoanService.propertySearchType == 'N' ? homeLoanService.reraPropertyDetails.losState.key : homeLoanService.reraPropertyDetails.state,
							    "city": homeLoanService.propertySearchType == 'N' ? homeLoanService.reraPropertyDetails.losCity.key : homeLoanService.reraPropertyDetails.city,
    							"stateText": homeLoanService.propertySearchType == 'N' ? JSON.stringify(homeLoanService.reraPropertyDetails.losState) : homeLoanService.reraPropertyDetails.state,
    							"cityText": homeLoanService.propertySearchType == 'N' ? JSON.stringify(homeLoanService.reraPropertyDetails.losCity) : homeLoanService.reraPropertyDetails.city
							  },
							  "requestedTopupAmt": ((calculateEmiTakeoverVm.topUpCheckbox && calculateEmiTakeoverVm.topUpWithCheckbox) || calculateEmiTakeoverVm.topUpWithoutCheckbox) ? calculateEmiTakeoverVm.topupSlider.value.toString() : "",
  							  "requestedTopupRate": ((calculateEmiTakeoverVm.topUpCheckbox && calculateEmiTakeoverVm.topUpWithCheckbox) || calculateEmiTakeoverVm.topUpWithoutCheckbox) ? calculateEmiTakeoverVm.calculateEmiResponse.topUp.rate : "",
  							  "requestedTopupEMI": ((calculateEmiTakeoverVm.topUpCheckbox && calculateEmiTakeoverVm.topUpWithCheckbox) || calculateEmiTakeoverVm.topUpWithoutCheckbox) ? calculateEmiTakeoverVm.emiAmountTopup : ""
  							  
						};
						homeLoanService.isPropertyIdentified = "Y";
					}
				}else{
					request = {
						"loanType": homeLoanService.getGroupId(),
						"loanAmount": calculateEmiTakeoverVm.calculateEmiResponse.amount.max,
						"loanTenure": calculateEmiTakeoverVm.calculateEmiResponse.tenure.max,
						"propertyIdentify": "N",
					};
					homeLoanService.isPropertyIdentified = "N";
				}
				
				homeLoanService.getBureauCheck(request).then(function(data) {
					if(data.status == "pending" || data.status == "reject"){
						var consentStatus = {};
						consentStatus.consentStatus = data.status.toLowerCase();
						consentStatus.customerName = homeLoanService.getCoApplicantDetails().name ? homeLoanService.getCoApplicantDetails().name : "Your Co-Applicant";
						homeLoanService.setConsentStatus(consentStatus);
						$state.go('menu.consentStatusHL');
					}else{
						calculateEmiTakeoverVm.showTimeRemaining = true;
						calculateEmiTakeoverVm.checkBureau = true;
						
						calculateEmiTakeoverVm.showTimer();
					}
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			calculateEmiTakeoverVm.showTimer = function(){
				var timeLeft = 30;
				//utilityService.showSpinner();

				//var timerId = setInterval(countdown, 1000);
				$interval(function(){
					if (timeLeft == 0) {
				    //clearTimeout(timerId);
				    //doSomething();
				    calculateEmiTakeoverVm.showTimeRemaining = false;
				    //utilityService.hideSpinner();
				  } else {
				    calculateEmiTakeoverVm.timeRemaining = timeLeft + ' seconds remaining';
				    timeLeft--;
				  }
				},1000)
				
			}

			calculateEmiTakeoverVm.triggerBureau = function(){
				var request = {
					"loanType": homeLoanService.getGroupId()
				};
				homeLoanService.getRecommendedProduct(request).then(function(data) {
					if(data.cirResult == "Y"){
						homeLoanService.setRecommendedResponse(data);
						$state.go('menu.recommendProduct');
					}else if(data.cirResult == "E"){
						//show popup
						calculateEmiTakeoverVm.showEStatus();
						
					}else if(data.cirResult == "P"){
						utilityService.showErrorMessage("Application check still in progress.");
					}else if(data.cirResult == "N"){
						calculateEmiTakeoverVm.waitBureau = false;
						calculateEmiTakeoverVm.refNumber = homeLoanService.getYonoDedupeData() ? homeLoanService.getYonoDedupeData().yonoRef : "";
					}
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});
							
			}

			calculateEmiTakeoverVm.showEStatus = function(){
				var backPopup = $ionicPopup.show({
					title: null,
					cssClass: 'my-custom-popup',
					template: '<div class="button_fund font-size-14 roboto-medium color-darkgrey" translate="HL_E_STATUS"></div>',
					buttons: [
					{
						text: 'OK',
						type: 'button-assertive',
						onTap: function () {
							//service call for reject
							calculateEmiTakeoverVm.checkBureau = false;
							backPopup.close();
						}
					}],
				});
			}

			calculateEmiTakeoverVm.goToAO = function(){
				$state.go('menu.accountOverviewMyBalance');
			}
			calculateEmiTakeoverVm.goBack = function(){
				if(homeLoanService.propIdentified == 'N'){
					if(homeLoanService.getIsCoApplicant()){
						$state.go('menu.coApplicantWorkDetails');
					}else{
						$state.go('menu.addCoApplicant');
					}
				}else{
					$ionicHistory.goBack(-1);
				}				
				
			}
			
			calculateEmiTakeoverVm.goToHome = function(){
				$state.go('menu.loans');
			}

			return this;
		}

		
]);


