'use strict';
angularApp.controller('recommendProductTopupController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"validateService",
		"$filter","homeLoanService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, validateService, $filter,homeLoanService) {
			
			var recommendProductTopupVm = this;

			recommendProductTopupVm.detail = {};
			
			
			function initPage() {
				recommendProductTopupVm.selectedIndex = 1000;
				var rupeeSymbol = String.fromCharCode(8377);
				recommendProductTopupVm.loanAmount = 100000;
				recommendProductTopupVm.showOtherProducts = false;
				recommendProductTopupVm.disableBackButton = homeLoanService.disableBackButton;
				
				recommendProductTopupVm.productDetails = homeLoanService.getRecommendedResponse();
				recommendProductTopupVm.recommendedProduct = [];
				recommendProductTopupVm.otherProduct = [];
				for(var i=0 ; i<recommendProductTopupVm.productDetails.topupProducts.product.length;i++){
					if(i==0){
						recommendProductTopupVm.recommendedProduct.push(recommendProductTopupVm.productDetails.products.product[i]);
					}else{
						recommendProductTopupVm.otherProduct.push(recommendProductTopupVm.productDetails.products.product[i]);
					}
				}

				//to show/hide edit product button
				if(homeLoanService.getGroupId() == "TAKEOVER"){
					recommendProductTopupVm.isEditButton = false;
				}else{
					recommendProductTopupVm.isEditButton = true;
				}
			};

			$scope.$on('$ionicView.loaded', function () {
				
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				initPage();
			});

			recommendProductTopupVm.goBack = function(){
				$ionicHistory.goBack(-1);
			}

			recommendProductTopupVm.editProduct = function(selectProduct){
				homeLoanService.editProduct = selectProduct;
				$state.go('menu.hlEditProduct');
			}

			recommendProductTopupVm.goToNextPage = function(){
				var selectedProduct = {
					"productCode" : "",
					"productName": ""
				}
				if(recommendProductTopupVm.selectedIndex == 1000){
					selectedProduct.productCode = recommendProductTopupVm.recommendedProduct[0].productcode;
					selectedProduct.productName = recommendProductTopupVm.recommendedProduct[0].productname;
				}else{
					selectedProduct.productCode = recommendProductTopupVm.otherProduct[recommendProductTopupVm.selectedIndex].productcode;
					selectedProduct.productName = recommendProductTopupVm.otherProduct[recommendProductTopupVm.selectedIndex].productname;
				}
				homeLoanService.setSelectedProductTopup(selectedProduct);
				$state.go('menu.homeLoanSelectBranch');
			}

			recommendProductTopupVm.show = function(){
				recommendProductTopupVm.showOtherProducts = !recommendProductTopupVm.showOtherProducts;
				if(!recommendProductTopupVm.showOtherProducts){
					recommendProductTopupVm.selectedIndex = 1000;
				}
			}

			recommendProductTopupVm.selectProduct = function(index){
				recommendProductTopupVm.selectedIndex = index;
			}

			recommendProductTopupVm.displayEMI = function(emiList){
				
				var templateInfo = '<div class="row roboto-regular color-darkgrey padtop10"><div class="col hlAllBorder"><span>Duration</span><br>(months)</div><div class="col hlAllBorder">EMI</div></div>';

				for(var i =0;i<emiList.length;i++){
					templateInfo += '<div class="row roboto-light font-size-14 color-darkgrey"><div class="col hlAllBorder"> ' + emiList[i].fromTenure + ' - '+ emiList[i].toTenure +'</div><div class="col hlAllBorder">&#8377;&nbsp;'+ emiList[i].emi + '</div></div>'; 
				}
				var templateInfoParent = '<div class="roboto-medium font-size-16 color-darkgrey">Flexipay</div>';
				
				var hlInfoIcon = $ionicPopup.show({
					template: templateInfoParent + templateInfo,
					title: '',
					cssClass: 'dialog',
					scope: $scope,
					buttons: [{
						text: 'OK',
						type: 'button-positive'
					}]
				});
			}

			return this;
		}

		
]);


