'use strict';
angularApp.controller('takeoverLoanDetailsController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"homeLoanService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate,homeLoanService) {
			
			var takeoverLoanDetailsVm = this;

			
			function initPage() {

				if (ionic.Platform.isIOS()) {
                	takeoverLoanDetailsVm.roi = "text";
            	} else {
                	takeoverLoanDetailsVm.roi = "tel";
            	}

				takeoverLoanDetailsVm.detail = {};
				takeoverLoanDetailsVm.errObj = {};
				takeoverLoanDetailsVm.topup = {};
				takeoverLoanDetailsVm.masterData = homeLoanService.userMaster;
				takeoverLoanDetailsVm.lenders = takeoverLoanDetailsVm.masterData.master.lenders;
				takeoverLoanDetailsVm.homeIntrestRates = takeoverLoanDetailsVm.masterData.master.homeIntrestRates;
				takeoverLoanDetailsVm.topupIntrestRates = takeoverLoanDetailsVm.masterData.master.topupIntrestRates;
				
				if(homeLoanService.getTakeoverData()){
					takeoverLoanDetailsVm.detail = homeLoanService.getTakeoverData();
					homeLoanService.selectedPropertyTakeover = takeoverLoanDetailsVm.detail.propertyType;
				}
				if(homeLoanService.getTopupData()){
					takeoverLoanDetailsVm.topup = homeLoanService.getTopupData();
				}
				takeoverLoanDetailsVm.detail.propertyType = homeLoanService.selectedPropertyTakeover;
				takeoverLoanDetailsVm.selectedProperty = homeLoanService.selectedPropertyTakeover;

			}

			takeoverLoanDetailsVm.validatePage = function(){
				takeoverLoanDetailsVm.errObj = {};

				if(takeoverLoanDetailsVm.selectedProperty == 'C'){
					if(!takeoverLoanDetailsVm.detail.existingLoanOutstandingAmount){
						takeoverLoanDetailsVm.errObj.existingLoanOutstandingAmount = $translate.instant('HLTO_ERR_OUTAMT');
					}else if(parseInt(takeoverLoanDetailsVm.detail.existingLoanOutstandingAmount) < 200000){
						takeoverLoanDetailsVm.errObj.existingLoanOutstandingAmount = $translate.instant('HLTO_ERR_OUTAMT_VAL');
					}

					if(!takeoverLoanDetailsVm.detail.totalMarketValue){
						takeoverLoanDetailsVm.errObj.totalMarketValue = $translate.instant('HLTO_ERR_MARVAL');
					}else if(parseInt(takeoverLoanDetailsVm.detail.totalMarketValue) < 1){
						takeoverLoanDetailsVm.errObj.totalMarketValue = $translate.instant('HLTO_ERR_MARVAL_VAL');
					}

					if(takeoverLoanDetailsVm.topup.topupLoanOutstandingAmount || takeoverLoanDetailsVm.topup.topupLoanCurrentInterest || takeoverLoanDetailsVm.topup.topupLoanEMI){
						if(!takeoverLoanDetailsVm.topup.topupLoanOutstandingAmount){
							takeoverLoanDetailsVm.errObj.topupLoanOutstandingAmount = $translate.instant('HLTO_ERR_OUTAMT');
						}else if(parseInt(takeoverLoanDetailsVm.topup.topupLoanOutstandingAmount) < 1000){
							takeoverLoanDetailsVm.errObj.topupLoanOutstandingAmount = $translate.instant('HLTO_ERR_OUTAMT_VAL');
						}

						if(!takeoverLoanDetailsVm.topup.topupLoanCurrentInterest){
							takeoverLoanDetailsVm.errObj.topupLoanCurrentInterest = $translate.instant('HLTO_ERR_CI');
						}else if(parseFloat(takeoverLoanDetailsVm.topup.topupLoanCurrentInterest) < 0.1){
							takeoverLoanDetailsVm.errObj.topupLoanCurrentInterest = $translate.instant('HLTO_ERR_CI_VAL');
						}

						if(!takeoverLoanDetailsVm.topup.topupLoanEMI){
							takeoverLoanDetailsVm.errObj.topupLoanEMI = $translate.instant('HLTO_ERR_EMI');
						}else if(parseInt(takeoverLoanDetailsVm.topup.topupLoanEMI) < 1){
							takeoverLoanDetailsVm.errObj.topupLoanEMI = $translate.instant('HLTO_ERR_EMI_VAL');
						}


					}
					
				}

				if(takeoverLoanDetailsVm.selectedProperty == 'UC'){
					if(!takeoverLoanDetailsVm.detail.existingLoanOutstandingAmount){
						takeoverLoanDetailsVm.errObj.existingLoanOutstandingAmount = $translate.instant('HLTO_ERR_TOAMT');
					}else if(parseInt(takeoverLoanDetailsVm.detail.existingLoanOutstandingAmount) < 200000){
						takeoverLoanDetailsVm.errObj.existingLoanOutstandingAmount = $translate.instant('HLTO_ERR_TOAMT_VAL');
					}

					if(!takeoverLoanDetailsVm.detail.totalProjectCost){
						takeoverLoanDetailsVm.errObj.totalProjectCost = $translate.instant('HLTO_ERR_PROJCOST');
					}else if(parseInt(takeoverLoanDetailsVm.detail.totalProjectCost) < 1){
						takeoverLoanDetailsVm.errObj.totalProjectCost = $translate.instant('HLTO_ERR_PROJCOST_VAL');
					}
					
				}

				if(!takeoverLoanDetailsVm.detail.existingLoanCurrentInterest){
					takeoverLoanDetailsVm.errObj.existingLoanCurrentInterest = $translate.instant('HLTO_ERR_CI');
				}else if(parseFloat(takeoverLoanDetailsVm.detail.existingLoanCurrentInterest) < 0.1){
					takeoverLoanDetailsVm.errObj.existingLoanCurrentInterest = $translate.instant('HLTO_ERR_CI_VAL');
				}

				if(!takeoverLoanDetailsVm.detail.existingLoanEMI){
					takeoverLoanDetailsVm.errObj.existingLoanEMI = $translate.instant('HLTO_ERR_EMI');
				}else if(parseInt(takeoverLoanDetailsVm.detail.existingLoanEMI) < 1){
					takeoverLoanDetailsVm.errObj.existingLoanEMI = $translate.instant('HLTO_ERR_EMI_VAL');
				}

				if(!takeoverLoanDetailsVm.detail.remainingTenureInMonths){
					takeoverLoanDetailsVm.errObj.remainingTenureInMonths = $translate.instant('HLTO_ERR_REMMONTH');
				}else if(parseInt(takeoverLoanDetailsVm.detail.remainingTenureInMonths) < 1){
					takeoverLoanDetailsVm.errObj.remainingTenureInMonths = $translate.instant('HLTO_ERR_REMMONTH_VAL');
				}

				if(!takeoverLoanDetailsVm.detail.currentLender){
					takeoverLoanDetailsVm.errObj.currentLender = $translate.instant('HLTO_ERR_LENDER');
				}

				return (angular.equals({}, takeoverLoanDetailsVm.errObj)) ? true : false;

			}

			takeoverLoanDetailsVm.goToBack = function(){
				//$ionicHistory.goBack(-1);
				$state.go('menu.hlTakeoverSelProperty');
			}

			takeoverLoanDetailsVm.goToNextPage = function(){
				
				
				if(takeoverLoanDetailsVm.validatePage()){

					homeLoanService.setTakeoverData(takeoverLoanDetailsVm.detail);
					homeLoanService.setTopupData(takeoverLoanDetailsVm.topup);
						
						var loanEMI = homeLoanService.emiCalculation(takeoverLoanDetailsVm.detail.existingLoanOutstandingAmount,takeoverLoanDetailsVm.detail.existingLoanCurrentInterest,takeoverLoanDetailsVm.detail.remainingTenureInMonths);


						if(takeoverLoanDetailsVm.detail.existingLoanEMI < (loanEMI + 1000) && takeoverLoanDetailsVm.detail.existingLoanEMI > (loanEMI - 1000)){
							//proceed 
							var intRates = takeoverLoanDetailsVm.homeIntrestRates;
							for(var i=0;i<intRates.length;i++){
								if(parseInt(takeoverLoanDetailsVm.detail.existingLoanEMI) > parseInt(intRates[i].minLoanAmt) && parseInt(takeoverLoanDetailsVm.detail.existingLoanEMI) < parseInt(intRates[i].maxLoanAmt)){
									var sbiEMI = homeLoanService.emiCalculation(takeoverLoanDetailsVm.detail.existingLoanOutstandingAmount,intRates[i].intRate,takeoverLoanDetailsVm.detail.remainingTenureInMonths);
									var sbiTenure = homeLoanService.getTenure(intRates[i].intRate,takeoverLoanDetailsVm.detail.existingLoanOutstandingAmount,takeoverLoanDetailsVm.detail.existingLoanEMI);

									if(sbiEMI < takeoverLoanDetailsVm.detail.existingLoanEMI){
										var topupObj  = {};
										// Check if top up available,
										if(takeoverLoanDetailsVm.topup.topupLoanOutstandingAmount){
											topupObj = takeoverLoanDetailsVm.calculateTakeoverTopup();
										}
										
										// show graph
										var obj = {
											sbiEMI : sbiEMI,
											userEMI : takeoverLoanDetailsVm.detail.existingLoanEMI,
											sbiTenure : sbiTenure,
											userTenure : takeoverLoanDetailsVm.detail.remainingTenureInMonths,
											sbiTopUpEMI : topupObj.sbiTopUpEMI ? topupObj.sbiTopUpEMI : "",
											userTopUpEMI : topupObj.userTopUpEMI ? topupObj.userTopUpEMI : "",
											sbiTopUpTenure : topupObj.sbiTopUpTenure ? topupObj.sbiTopUpTenure : "",
											userTopUpTenure : takeoverLoanDetailsVm.detail.remainingTenureInMonths
										};
										homeLoanService.setGraphEMI(obj);
										$state.go('menu.hlTakeoverLoanBenifit');
									}else{
										$state.go('menu.homeLoanPersonalDetails');
									}
								}
								
							}

							
						}else{
							//error 
							utilityService.showErrorMessage($translate.instant('HL_TO_ERR_LOAN_CALC'));
						}

						
					
					
				}
				
			}

			takeoverLoanDetailsVm.calculateTakeoverTopup = function(){
				var topupEMI = homeLoanService.emiCalculation(takeoverLoanDetailsVm.topup.topupLoanOutstandingAmount,takeoverLoanDetailsVm.topup.topupLoanCurrentInterest,takeoverLoanDetailsVm.detail.remainingTenureInMonths);

				if(takeoverLoanDetailsVm.topup.topupLoanEMI < (topupEMI + 1000) && takeoverLoanDetailsVm.topup.topupLoanEMI > (topupEMI - 1000)){
							//proceed 
							var intRates = takeoverLoanDetailsVm.topupIntrestRates;
							for(var i=0;i<intRates.length;i++){
								if(parseInt(takeoverLoanDetailsVm.topup.topupLoanEMI) > parseInt(intRates[i].minLoanAmt) && parseInt(takeoverLoanDetailsVm.topup.topupLoanEMI) < parseInt(intRates[i].maxLoanAmt)){
									var sbiTopUpEMI = homeLoanService.emiCalculation(takeoverLoanDetailsVm.topup.topupLoanOutstandingAmount,intRates[i].intRate,takeoverLoanDetailsVm.detail.remainingTenureInMonths);
									var sbiTopUpTenure = homeLoanService.getTenure(intRates[i].intRate,takeoverLoanDetailsVm.topup.topupLoanOutstandingAmount,takeoverLoanDetailsVm.topup.topupLoanEMI);

										if(Number.isNaN(sbiTopUpTenure)){
											utilityService.showErrorMessage($translate.instant('HL_TO_ERR_LOAN_CALC'));
											return ;
										}
												// show graph
										var obj = {
											sbiTopUpEMI : sbiTopUpEMI,
											userTopUpEMI : takeoverLoanDetailsVm.topup.topupLoanEMI,
											sbiTopUpTenure : sbiTopUpTenure,
											userTopUpTenure : takeoverLoanDetailsVm.detail.remainingTenureInMonths
										};
										return obj;
										//homeLoanService.setGraphEMI(obj);
										//$state.go('menu.hlTakeoverLoanBenifit');

										
									
								}else{
									var obj ={};
									return obj;
								}
								
							}
							
						}else{
							//error 
							utilityService.showErrorMessage($translate.instant('HL_TO_ERR_LOAN_CALC'));
						}

			}

			takeoverLoanDetailsVm.showMInfoPopup = function(type){
				var templateInfo = "";
				if(type == 'OUT'){
					templateInfo = '<p translate="HL_TO_INFO_OUT_LOAN"></p>';
				}else if(type == 'TO'){
					templateInfo = '<p translate="HL_TO_INFO_TOTAL_LOAN"></p>';
				}

				var hlInfoIcon = $ionicPopup.show({
					template: templateInfo,
					title: '',
					cssClass: 'dialog',
					scope: $scope,
					buttons: [{
						text: 'OK',
						type: 'button-positive'
					}]
				});
			}

			
			$scope.$on('$ionicView.loaded', function () {
				
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				initPage();
				//takeoverLoanDetailsVm.detail.existingLoanCurrentInterest="";
			});

			return this;
		}

		
]);


