'use strict';
angularApp.controller('addCoApplicantController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"validateService",
		"homeLoanService",
		"$filter","generalInsurenceHomeService","loggedInUserService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate,validateService,homeLoanService,$filter,generalInsurenceHomeService,loggedInUserService) {
			
			var addCoApplicantVm = this;

			addCoApplicantVm.detail = {};
			function validateForm() {
				addCoApplicantVm.coApplicantForm = {};
				if (validateService.isValidPhoneNo(addCoApplicantVm.detail.mobile)) {
					addCoApplicantVm.coApplicantForm.mobileNumber = validateService.isValidPhoneNo(addCoApplicantVm.detail.mobile);
				}
				if(validateService.isValidAccountNumber(addCoApplicantVm.detail.accountNo)){
					addCoApplicantVm.coApplicantForm.accountNumber = validateService.isValidAccountNumber(addCoApplicantVm.detail.accountNo);
				}
				if(validateService.isValidDateOfBirth(addCoApplicantVm.detail.dob)){
					addCoApplicantVm.coApplicantForm.dob = validateService.isValidDateOfBirth(addCoApplicantVm.detail.dob);
				}
				return (angular.equals({}, addCoApplicantVm.coApplicantForm)) ? true : false;
			}
			
			function initPage() {
				// addCoApplicantVm.detail.accountNo = "30002829895"; 30002831383
				// addCoApplicantVm.detail.mobile = "9803919728";
				// addCoApplicantVm.detail.dob = "23 May 1983";23 May 2000
				if(homeLoanService.getFetchCoApplicant()){
					addCoApplicantVm.detail = homeLoanService.getFetchCoApplicant();
					//addCoApplicantVm.detail.dob = $filter('homeDateFormat')(addCoApplicantVm.detail.dob);
				}
				addCoApplicantVm.referenceNumber = homeLoanService.getYonoRef() ? homeLoanService.getYonoRef() : "";
				addCoApplicantVm.validateService = validateService;
				addCoApplicantVm.isSkipRequired = (homeLoanService.getIsSkipRequired() && !homeLoanService.getHomeRetired());
				addCoApplicantVm.isRetiredHome = homeLoanService.getHomeRetired();
				addCoApplicantVm.showAccNo = true;
				addCoApplicantVm.mobile = true;
			};

			addCoApplicantVm.unmaskData = function(type){
				if(type == 'accNo'){
					addCoApplicantVm.showAccNo = !addCoApplicantVm.showAccNo;
				}
				if(type == 'mobile'){
					addCoApplicantVm.mobile = !addCoApplicantVm.mobile;
				}
			}

			$scope.$on('$ionicView.beforeEnter', function () {
				initPage();
			});

			addCoApplicantVm.goBack = function(){
				$state.go('menu.homeLoanWorkDetails');
			}

			addCoApplicantVm.goToNextPage = function(){
				addCoApplicantVm.coApplicantForm = {};
				if (validateForm()) {
					var coApplicant = {
						"loanType": homeLoanService.getGroupId(),
						"account": addCoApplicantVm.detail.accountNo,
						"mobile": addCoApplicantVm.detail.mobile,
						"dob": addCoApplicantVm.detail.dob
					}
					var primaryAge = generalInsurenceHomeService.calculateAge(new Date(),$filter('homeDateFormat')(homeLoanService.getPersonalPrimaryDetails().dob));
					homeLoanService.getCoApplicant(coApplicant).then(function(data) {
						if(data.status == "HL02"){
							homeLoanService.dedupErrors = data.reasons;
							$state.go('menu.homeLoanError');
						}else if(data.status == "HL01"){
							var message;
							var attemptsLeft = parseInt(3 - data.count);
							if(data.count < 3){
								message = 'Co-Applicant details could not be fetched.<br> Please try again. <br><br>'+attemptsLeft + ' attempts left';
								var alertPopup = $ionicPopup.alert({
									title: '',
									template: '<div class="popupBodyPadding font-dark-grey"></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'
									+ message + '</span></div></div></div>',
									cssClass: 'removePopup-head popupWidth90 popupMargin ftpopup-body popupBackgroundWhite textAlignCenter',
									scope: $scope,
									buttons: [
										{
											text: "OK",
											type: 'button-positive'
										}
									],
								});
							}else{
								if(homeLoanService.getHomeRetired()){
									message = '<b>Reference number: ' + addCoApplicantVm.referenceNumber + '<br> (Valid for 30 days)</b> <br><br><br> Co-Applicant details could not be fetched.<br>'+
									'Please visit your nearest branch.';
									var alertPopup = $ionicPopup.confirm({
										title: "",
										template: '<div class="popupBodyPadding font-dark-grey"></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'
										+ message + '</span></div></div></div>',
										cssClass: 'removePopup-head popupWidth90 popupMargin ftpopup-body popupBackgroundWhite textAlignCenter',
										buttons: [{ 	
											text: 'My Relationships',
											onTap: function(e) {
												$state.go('menu.accountOverviewMyBalance');
											}
										}]
									});
								}else{
									message = '<b>Reference number: ' + addCoApplicantVm.referenceNumber + '<br> (Valid for 30 days)</b> <br><br><br> Co-Applicant details could not be fetched.<br>'+
									'Please visit your nearest branch.<br> <b>-OR-</b> <br> Please re-login to try again or continue without a co-applicant.';
									var alertPopup = $ionicPopup.confirm({
										title: "",
										template: '<div class="popupBodyPadding font-dark-grey"></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'
										+ message + '</span></div></div></div>',
										cssClass: 'removePopup-head popupWidth90 popupMargin ftpopup-body popupBackgroundWhite textAlignCenter',
										buttons: [
										{ 	text: 'Logout',
											onTap: function(e) {
												//$state.go('menu.loans');
												loggedInUserService.logoutUser();
											}
											}, 
											{
											text: 'Continue',
											type: 'button-positive',
											onTap: function(e) {
												var request = {
													"loanType": homeLoanService.getGroupId()
												}
												homeLoanService.getNmiEmi(request).then(function(data) {
													homeLoanService.setIsCoApplicant(false);
													homeLoanService.setEmiResponse(data);
													//homeLoanService.setFetchCoApplicant(addCoApplicantVm.detail);
													$state.go('menu.calculateEmi');
												},function(error){
													utilityService.showErrorMessage(error.responseMessage);
												});
											}
										}]
									});
								}
							}
						}else if(data.status =="0000"){
							var age = generalInsurenceHomeService.calculateAge(new Date(),$filter('homeDateFormat')(data.dob));
							if(primaryAge >= 70 && age > 50){
								utilityService.showErrorMessage("Applicants other than 70 years are required to add co-applicant aged below 50 years.");
							}else{
								if(addCoApplicantVm.detail.mobile != data.mobile){
									var mobileMessage = "Mobile number entered does not match with our records.<br><br> SMS will be sent to the co-applicant's registered mobile number.";
									var mobileMismatchPopUp = $ionicPopup.confirm({
										title: "",
										template: '<div class="popupBodyPadding font-dark-grey"></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'
										+ mobileMessage + '</span></div></div></div>',
										cssClass: 'removePopup-head popupWidth90 popupMargin ftpopup-body popupBackgroundWhite textAlignCenter',
										buttons: [{ 	
											text: 'OK',
											onTap: function(e) {
												homeLoanService.setIsCoApplicant(true);
												data.accountNo = addCoApplicantVm.detail.accountNo;	
												homeLoanService.isResume = false;
												homeLoanService.setFetchCoApplicant(addCoApplicantVm.detail);
												homeLoanService.setFetchDetails(data);
												$state.go('menu.confirmApplicant');
											}
										}]
									});
								}else{
									homeLoanService.setIsCoApplicant(true);
									data.accountNo = addCoApplicantVm.detail.accountNo;	
									homeLoanService.isResume = false;
									homeLoanService.setFetchCoApplicant(addCoApplicantVm.detail);
									homeLoanService.setFetchDetails(data);
									$state.go('menu.confirmApplicant');
								}
							}
						}
					},function(error){
						utilityService.showErrorMessage(error.responseMessage);
					});		
				}
			}

			addCoApplicantVm.skip = function(){
				var request = {
					"loanType": homeLoanService.getGroupId()
				}
				homeLoanService.getNmiEmi(request).then(function(data) {
					homeLoanService.setIsCoApplicant(false);
					homeLoanService.setEmiResponse(data);
					//homeLoanService.setFetchCoApplicant(addCoApplicantVm.detail);
					if(homeLoanService.getGroupId() == "TAKEOVER"){
						homeLoanService.propIdentified = 'Y';
						var obj ={};
						homeLoanService.setPropertiesData(obj);
						$state.go('menu.propDetailsHL');
					}else{
						addCoApplicantVm.isPropertyIdentified();
					}
					
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			addCoApplicantVm.isPropertyIdentified = function(){
				var templateSpan = '<div class="text-center roboto-regular font-size-16 color-darkgrey"><span translate="HL_PROP_IDENTIFIED" class=""></span></div>';
				var backPopup = $ionicPopup.show({
					title: null,
					cssClass: 'my-custom-popup',
					template: templateSpan,
					buttons: [{
						text: 'No',
						type: 'button-assertive',
						onTap: function () {
							backPopup.close();
							homeLoanService.propIdentified = 'N';
							$state.go('menu.calculateEmi');
						}
					},
					{
						text: 'Yes',
						type: 'button-assertive',
						onTap: function () {
							//service call for reject
							homeLoanService.propIdentified = 'Y';
							var obj ={};
							homeLoanService.setPropertiesData(obj);
							backPopup.close();
							$state.go('menu.propDetailsHL');
							
						}
					}],
				});
			}

			addCoApplicantVm.openDatePicker = function(){
				var monList = ["JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC"];
				var newDate = new Date();
				newDate.setFullYear(newDate.getFullYear() - 100);
				var toDate = new Date();
				toDate.setFullYear(toDate.getFullYear() - 18);
				addCoApplicantVm.dateObj = {
						callback: function (val) {
							var dateOfBirth = new Date(val);
		                    addCoApplicantVm.detail.dob = dateOfBirth.getDate() + " " + monList[dateOfBirth.getMonth()] + " " + dateOfBirth.getFullYear();
						},
						inputDate: toDate,
						monthsList:monList,
						from: newDate,
						to: toDate,
						mondayFirst: true,
						closeOnSelect: false,
						templateType: 'popup',
						dateFormat: 'dd MMM yyyy'
				};

				ionicDatePicker.openDatePicker(addCoApplicantVm.dateObj);
			}

			return this;
		}

		
]);


