'use strict';
angularApp.controller('calculateEmiController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"validateService",
		"$filter","$interval",
		"homeLoanService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate,validateService,$filter,$interval,homeLoanService) {
			
			var calculateEmiVm = this;
			
			function initPage() {
				// calculateEmiVm.calculateEmiResponse = {
				// 	"minLoanAmt": "1",
				// 	"maxLoanAmt": "594000",
				// 	"minTenure": "1",
				// 	"maxTenure": "360",
				// 	"emi": "4525.32",
				// 	"emiPermissibleFlag": "Y",
				// 	"rate": "8.4",
				// 	"amount": {
				// 		"min": 1,
				// 		"max": 594000,
				// 		"step": 10000,
				// 		"initial": 100000
				// 	},
				// 	"tenure": {
				// 		"min": 1,
				// 		"max": 360,
				// 		"step": 1,
				// 		"initial": 15
				// 	}
				// };
				// homeLoanService.setEmiResponse(calculateEmiVm.calculateEmiResponse);
				calculateEmiVm.calculateEmiResponse = homeLoanService.getEmiResponse();
				calculateEmiVm.emiAmount = parseInt(homeLoanService.getEmiResponse().emi);
				var rupeeSymbol = String.fromCharCode(8377);
				calculateEmiVm.detail = {};
				calculateEmiVm.disableBackButton = homeLoanService.disableBackButton;
				calculateEmiVm.detail.interestRate = parseFloat(calculateEmiVm.calculateEmiResponse.rate);
				calculateEmiVm.amountSlider = {
                    value: calculateEmiVm.calculateEmiResponse.amount.initial,
                    options: {
                    	showSelectionBar: true,
                    	floor : calculateEmiVm.calculateEmiResponse.amount.min,
						ceil : calculateEmiVm.calculateEmiResponse.amount.max,
						step : calculateEmiVm.calculateEmiResponse.amount.step,
						onChange : function(id,model){
							calculateEmiVm.emiCalculation();
						},
						translate : function(value){
							return rupeeSymbol + $filter('INR')(value);
						}
                    }
                };

				calculateEmiVm.tenureSlider = {
                    value: calculateEmiVm.calculateEmiResponse.tenure.initial,
                    options: {
                    	showSelectionBar: true,
                    	floor :  calculateEmiVm.calculateEmiResponse.tenure.min,
						ceil :  calculateEmiVm.calculateEmiResponse.tenure.max,
						step :  calculateEmiVm.calculateEmiResponse.tenure.step,
						onChange : function(id,model){
							calculateEmiVm.emiCalculation();
						},
						translate : function(value){
							return  value + " Months";
						}	
                    }
                };

				calculateEmiVm.emiCalculation();
				//calculateEmiVm.checkBureau = true;
				calculateEmiVm.checkBureau = false;
				calculateEmiVm.waitBureau = true;

				var p = calculateEmiVm.calculateEmiResponse.amount.max;
				var i = (calculateEmiVm.detail.interestRate/1200);
				var t = calculateEmiVm.calculateEmiResponse.tenure.max;
				var numerator = p * i * Math.pow((1+i),t);
				var denominator = Math.pow((1+i),t) - 1;
				calculateEmiVm.emiMaxAmount = Math.ceil((numerator/denominator));	
			};

			$scope.$on('$ionicView.loaded', function () {
				
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				initPage();
			});

			calculateEmiVm.goToNext = function(){
				var request = {};
				if(homeLoanService.getPropertiesData() && homeLoanService.getPmayDetails()){
					if(homeLoanService.getPropertiesData().propertyIdentify == 'Y'){
						request = {
							"loanType": homeLoanService.getGroupId(),
							"loanAmount": calculateEmiVm.amountSlider.value.toString(),
							"loanTenure": calculateEmiVm.tenureSlider.value.toString(),
							"propertyIdentify": "Y",
							"propertyType":homeLoanService.getPropertiesData().propertyType.key,
							"propertyTypeValue": homeLoanService.getPropertiesData().propertyType ? JSON.stringify(homeLoanService.getPropertiesData().propertyType) : "",
							"propertyValue": homeLoanService.getPropertiesData().propertyValue,
							"numberOfFloors": homeLoanService.getPropertiesData().numberOfFloors,
							"moratoriumPeriod": homeLoanService.getPropertiesData().moratoriumPeriod,
							"carpetArea": homeLoanService.getPropertiesData().carpetArea,
							"propertySearchType":homeLoanService.propertySearchType,
							"propertyDetails": {
								"projectApproved": homeLoanService.propertySearchType == 'N' ? 'N' : 'Y',
							    "reraId": homeLoanService.reraPropertyDetails.reraId,
							    "projectId": homeLoanService.reraPropertyDetails.projectId,
							    "projectName": homeLoanService.reraPropertyDetails.projectName,
							    "propertyAddressline1": homeLoanService.reraPropertyDetails.propertyAddressline1,
							    "propertyAddressline2": homeLoanService.reraPropertyDetails.propertyAddressline2,
							    "pincode": homeLoanService.reraPropertyDetails.pincode,
							    "state": homeLoanService.propertySearchType == 'N' ? homeLoanService.reraPropertyDetails.losState.key : homeLoanService.reraPropertyDetails.state,
							    "city": homeLoanService.propertySearchType == 'N' ? homeLoanService.reraPropertyDetails.losCity.key : homeLoanService.reraPropertyDetails.city,
    							"stateText": homeLoanService.propertySearchType == 'N' ? JSON.stringify(homeLoanService.reraPropertyDetails.losState) : homeLoanService.reraPropertyDetails.state,
    							"cityText": homeLoanService.propertySearchType == 'N' ? JSON.stringify(homeLoanService.reraPropertyDetails.losCity) : homeLoanService.reraPropertyDetails.city
								},
								"puccaHousePmay": homeLoanService.getPmayDetails().puccaHouse,
								"grossAnnualIncomePmay": homeLoanService.getPmayDetails().gahi,
								// "carpetAreaPmayText": JSON.stringify(homeLoanService.getPmayDetails().houseCarpet),
								"carpetAreaPmay": homeLoanService.getPmayDetails().houseCarpet.key,
								"placeOfPropertyPmay": homeLoanService.getPmayDetails().propertyLocation,
						};
						homeLoanService.isPropertyIdentified = "Y";
					}
				}else if(homeLoanService.isPropertyIdentified == "Y"){
					request = {
						"loanType": homeLoanService.getGroupId(),
						"loanAmount": calculateEmiVm.amountSlider.value.toString(),
						"loanTenure": calculateEmiVm.tenureSlider.value.toString(),
						"propertyIdentify": "Y",
					};
				}else{
					request = {
						"loanType": homeLoanService.getGroupId(),
						"loanAmount": calculateEmiVm.amountSlider.value.toString(),
						"loanTenure": calculateEmiVm.tenureSlider.value.toString(),
						"propertyIdentify": "N",
					};
					homeLoanService.isPropertyIdentified = "N";
				}
				
				homeLoanService.getBureauCheck(request).then(function(data) {
					if(data.status == "pending" || data.status == "reject"){
						var consentStatus = {};
						consentStatus.consentStatus = data.status.toLowerCase();
						consentStatus.customerName = homeLoanService.getCoApplicantDetails().name ? homeLoanService.getCoApplicantDetails().name : "Your Co-Applicant";
						homeLoanService.setConsentStatus(consentStatus);
						$state.go('menu.consentStatusHL');
					}else{
						calculateEmiVm.showTimeRemaining = true;
						calculateEmiVm.checkBureau = true;
						
						calculateEmiVm.showTimer();
					}
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			calculateEmiVm.showTimer = function(){
				var timeLeft = 30;
				//utilityService.showSpinner();

				//var timerId = setInterval(countdown, 1000);
				$interval(function(){
					if (timeLeft == 0) {
				    //clearTimeout(timerId);
				    //doSomething();
				    calculateEmiVm.showTimeRemaining = false;
				    //utilityService.hideSpinner();
				  } else {
				    calculateEmiVm.timeRemaining = timeLeft + ' seconds remaining';
				    timeLeft--;
				  }
				},1000)
				
			}

			calculateEmiVm.triggerBureau = function(){
				var request = {
					"loanType": homeLoanService.getGroupId(),
					"loanAmount": calculateEmiVm.amountSlider.value.toString(),
					"tenure": calculateEmiVm.tenureSlider.value.toString()
				};
				homeLoanService.getRecommendedProduct(request).then(function(data) {
					if(data.cirResult == "Y"){
						homeLoanService.setRecommendedResponse(data);
						$state.go('menu.recommendProduct');
					}else if(data.cirResult == "E"){
						//show popup
						calculateEmiVm.showEStatus();
						
					}else if(data.cirResult == "P"){
						utilityService.showErrorMessage("Application check still in progress.");
					}else if(data.cirResult == "N"){
						calculateEmiVm.waitBureau = false;
						calculateEmiVm.refNumber = homeLoanService.getYonoDedupeData() ? homeLoanService.getYonoDedupeData().yonoRef : "";
					}
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});
							
			}

			calculateEmiVm.showEStatus = function(){
				var backPopup = $ionicPopup.show({
					title: null,
					cssClass: 'my-custom-popup',
					template: '<div class="button_fund font-size-14 roboto-medium color-darkgrey" translate="HL_E_STATUS"></div>',
					buttons: [
					{
						text: 'OK',
						type: 'button-assertive',
						onTap: function () {
							//service call for reject
							calculateEmiVm.checkBureau = false;
							backPopup.close();
						}
					}],
				});
			}

			calculateEmiVm.goToAO = function(){
				$state.go('menu.accountOverviewMyBalance');
			}
			calculateEmiVm.goBack = function(){


				if(homeLoanService.propIdentified == 'N'){
					if(homeLoanService.getIsCoApplicant()){
						$state.go('menu.coApplicantWorkDetails');
					}else{
						$state.go('menu.addCoApplicant');
					}
				}else{
					$state.go('menu.pmay');
				}
				
				
			}

			calculateEmiVm.emiCalculation = function(){
				var p = calculateEmiVm.amountSlider.value;
				var i = (calculateEmiVm.detail.interestRate/1200);
				var t = calculateEmiVm.tenureSlider.value;
				var numerator = p * i * Math.pow((1+i),t);
				var denominator = Math.pow((1+i),t) - 1;
				calculateEmiVm.emiAmount = Math.ceil((numerator/denominator));
			}
			
			calculateEmiVm.goToHome = function(){
				$state.go('menu.loans');
			}

			return this;
		}

		
]);


