'use strict';
angularApp.controller('confirmApplicantController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"$ionicScrollDelegate",
		"validateService",
		"homeLoanService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate,$ionicScrollDelegate,validateService,homeLoanService) {
			
			var confirmApplicantVm = this;

			confirmApplicantVm.detail = {};
			confirmApplicantVm.errObj = {};
			confirmApplicantVm.isMasked = true;
			confirmApplicantVm.inputImg = "img/Visibility_off.svg";
			
			
			function validateForm() {
				confirmApplicantVm.confirmApplicantForm = {};
				if(validateService.isValidAlternateContact(confirmApplicantVm.detail.alternateContact)){
					confirmApplicantVm.confirmApplicantForm.alternateContact = validateService.isValidAlternateContact(confirmApplicantVm.detail.alternateContact);
				}
				if (validateService.isValidRelationship(confirmApplicantVm.detail.relationship)) {
					confirmApplicantVm.confirmApplicantForm.relationship = validateService.isValidRelationship(confirmApplicantVm.detail.relationship);
				}
				if(validateService.isMarritialStatus(confirmApplicantVm.detail.maritalStatus)){
					confirmApplicantVm.confirmApplicantForm.maritalStatus = validateService.isMarritialStatus(confirmApplicantVm.detail.maritalStatus);
				}
				if(validateService.isValidFatherName(confirmApplicantVm.detail.fatherName)){
					confirmApplicantVm.confirmApplicantForm.fatherName = validateService.isValidFatherName(confirmApplicantVm.detail.fatherName);
				}
				if(validateService.isValidMotherName(confirmApplicantVm.detail.motherMaidenName)){
					confirmApplicantVm.confirmApplicantForm.motherMaidenName = validateService.isValidMotherName(confirmApplicantVm.detail.motherMaidenName);
				}
				if(validateService.isValidEducationQualification(confirmApplicantVm.detail.eduQualification)){
					confirmApplicantVm.confirmApplicantForm.eduQualification = validateService.isValidEducationQualification(confirmApplicantVm.detail.eduQualification);
				}
				if(confirmApplicantVm.detail.currentAddress == 'C'){
					if (validateService.isValidAdress(confirmApplicantVm.detail.addressLine1)) {
						confirmApplicantVm.confirmApplicantForm.addressLine1 = validateService.isValidAdress(confirmApplicantVm.detail.addressLine1);
					}
					if(validateService.isValidMonthsInResidence(confirmApplicantVm.detail.residenceMonthCurrent)){
						confirmApplicantVm.confirmApplicantForm.residenceMonthCurrent = validateService.isValidMonthsInResidence(confirmApplicantVm.detail.residenceMonthCurrent);
					}
					if(validateService.isValidResidentType(confirmApplicantVm.detail.residenceTypeCurrent)){
						confirmApplicantVm.confirmApplicantForm.residenceTypeCurrent = validateService.isValidResidentType(confirmApplicantVm.detail.residenceTypeCurrent);
					}
					// if(validateService.isValidPincode(confirmApplicantVm.detail.currentPincode)){
					// 	confirmApplicantVm.confirmApplicantForm.currentPincode = validateService.isValidPincode(confirmApplicantVm.detail.currentPincode);
					// }
					
					if(!confirmApplicantVm.detail.currentPincode){
						confirmApplicantVm.confirmApplicantForm.currentPincode = $translate.instant('HL_ERR_PINCODE');
					}else{
						confirmApplicantVm.detail.currentPincode = confirmApplicantVm.detail.currentPincode.replace(/ /g,'');
						if(parseInt(confirmApplicantVm.detail.currentPincode) < 1 || confirmApplicantVm.detail.currentPincode.length != 6){
							confirmApplicantVm.confirmApplicantForm.currentPincode = $translate.instant('HL_ERR_VALIDPINCODE');
						}
					}
					if(validateService.hlValidState(confirmApplicantVm.detail.currentState)){
						confirmApplicantVm.confirmApplicantForm.currentState = validateService.hlValidState(confirmApplicantVm.detail.currentState);
					}
					if(validateService.hlValidDistrict(confirmApplicantVm.detail.currentDistrict)){
						confirmApplicantVm.confirmApplicantForm.currentDistrict = validateService.hlValidDistrict(confirmApplicantVm.detail.currentDistrict);
					}
					if(validateService.hlValidCity(confirmApplicantVm.detail.currentCity)){
						confirmApplicantVm.confirmApplicantForm.currentCity = validateService.hlValidCity(confirmApplicantVm.detail.currentCity);
					}
				}
				return (angular.equals({}, confirmApplicantVm.confirmApplicantForm)) ? true : false;
			}
			
			function initPage() {
				confirmApplicantVm.detail = {};
				// var test = '{"eligible":"TRUE","coapplicantCIF":"","yonoRef":"HLY100718584417","title":"01","firstName":"hghish","middleName":"","lastName":"la","gender":"M","dob":"23/05/2000","pan":"","aadhar":"","email":"mxxxxxxv@ixxxxm.com","mobile":"9803919728","permanentAddress":{"addressLine1":"101","addressLine2":"","addressLine3":"mkmklmk","district":"27519:Mumbai","city":null,"state":null,"pincode":"400614","addressType":null},"status":"0000","count":0,"master":null,"reasons":null,"losRef":null}';
				// homeLoanService.setCoApplicantDetails(JSON.parse(test));
				// var masters = '{"eligible":"true","coapplicantCIF":null,"yonoRef":"HLY100718165228","title":"01","firstName":"ashish","middleName":"","lastName":"la","gender":"M","dob":"23/05/1983","pan":"XXXXXX575M","aadhar":"XXXXXXXX9995","email":"twisha.dhimar@sbi.co.in","mobile":null,"permanentAddress":{"addressLine1":"101","addressLine2":"","addressLine3":"mkmklmk","district":"27519:Mumbai","city":null,"state":null,"pincode":"400614","addressType":null},"status":"0000","count":0,"master":{"employmentTypes":[{"key":"Businessman","value":"Self-Employed Non-Professional(Businessman)"},{"key":"Others","value":"Others (Pensioner, Housewife etc.)"},{"key":"Salaried","value":"Salaried"},{"key":"Self-Employed","value":"Self-Employed Professional"}],"employerTypes":[{"key":"LIST","value":"LISTED PVT."},{"key":"MNC","value":"MNC"},{"key":"N","value":"NON WORKING"},{"key":"PEN","value":"PENSIONER"},{"key":"PSU","value":"Central/ State Govts /PSU"},{"key":"ULST","value":"UNLISTED PVT."}],"professionTypes":[{"key":"0700","value":"Retired"},{"key":"0999","value":"Others"},{"key":"0100","value":"State Govt Services"},{"key":"0101","value":"Central Govt Services"},{"key":"0110","value":"Services In Public Sector Undertaking"},{"key":"0160","value":"Services In Defence Establishment"},{"key":"0170","value":"Services In Private Establishment"},{"key":"0201","value":"Medical Profession"},{"key":"0202","value":"Legal Profession"},{"key":"0203","value":"CA/ICWA/Taxation/Finance"},{"key":"0204","value":"Engineering/Architect/Technical/Consultant"},{"key":"0205","value":"Artist/Writer Etc"},{"key":"0207","value":"Artisan/Craftsman"},{"key":"0208","value":"Journalists"},{"key":"0209","value":"Share and Stock Broker"},{"key":"0210","value":"Capital Market Maker"},{"key":"0299","value":"Other Professionals"},{"key":"0301","value":"Industrialist"},{"key":"0302","value":"Business In Trade sector"},{"key":"0303","value":"Business In Service sector"},{"key":"0500","value":"Housewives"},{"key":"0600","value":"Students"},{"key":"0200","value":"Other Pensionable Service"},{"key":"0304","value":"Migrant Laborers"}],"emiTypes":[{"key":"08","value":"WORKING CAPITAL OVERDRAFT"},{"key":"09","value":"WORKING CAPITAL TERM LOAN"},{"key":"02","value":"CREDIT CARD"},{"key":"03","value":"PERSONAL LOAN"},{"key":"05","value":"WORKING CAPITAL DEMAND LOAN"},{"key":"21","value":"AUTO LOAN"},{"key":"22","value":"EDUCATION LOAN"},{"key":"23","value":"TERM LOAN"},{"key":"24","value":"MUTUAL FUND"},{"key":"25","value":"HOME LOAN"}],"relWithPriApplicants":[{"key":"FTH","value":"FATHER"},{"key":"GD","value":"GUARANTOR"},{"key":"GDD","value":"GRAND DAUGHTER"},{"key":"GDS","value":"GRAND SON"},{"key":"MIL","value":"MOTHER IN LAW"},{"key":"MTH","value":"MOTHER"},{"key":"NBR","value":"NEIGHBOUR"},{"key":"NEP","value":"NEPHEW"},{"key":"NIC","value":"NIECE"},{"key":"NOT","value":"NOT AVAILABLE"},{"key":"OTH","value":"OTHERS"},{"key":"SIS","value":"SISTER"},{"key":"SON","value":"SON"},{"key":"SPS","value":"SPOUSE"},{"key":"UNC","value":"UNCLE"},{"key":"DIL","value":"DAUGHTER IN LAW"},{"key":"ANT","value":"AUNT"},{"key":"BIL","value":"BROTHER IN LAW"},{"key":"CAP","value":"COAPPLICANT"},{"key":"CHD","value":"CHILDREN"},{"key":"COL","value":"COLLEAGUE"},{"key":"DAU","value":"DAUGHTER"},{"key":"FIL","value":"FATHER IN LAW"},{"key":"FRD","value":"FRIEND"}],"titles":[{"key":"Admiral","value":"Admiral"},{"key":"Admiral of the Fleet","value":"Admiral of the Fleet"},{"key":"Air Chief Marshal","value":"Air Chief Marshal"},{"key":"Air Commodore","value":"Air Commodore"},{"key":"Air Marshal","value":"Air Marshal"},{"key":"Air Vice Marshal","value":"Air Vice Marshal"},{"key":"Bharatratna","value":"Bharatratna"},{"key":"Brigadier","value":"Brigadier"},{"key":"Captain","value":"Captain"},{"key":"Colonel","value":"Colonel"},{"key":"Commander","value":"Commander"},{"key":"Dr.","value":"Dr."},{"key":"Dr.(Mrs.)","value":"Dr.(Mrs.)"},{"key":"Flt.Lieutenant","value":"Flt.Lieutenant"},{"key":"Flying Officer","value":"Flying Officer"},{"key":"General","value":"General"},{"key":"Group Captain","value":"Group Captain"},{"key":"Lieutenant","value":"Lieutenant"},{"key":"Lieutenant Colone","value":"Lieutenant Colone"},{"key":"Lieutenant Commander","value":"Lieutenant Commander"},{"key":"Lt.General","value":"Lt.General"},{"key":"M/s.","value":"M/s."},{"key":"Major","value":"Major"},{"key":"Major General","value":"Major General"},{"key":"Master","value":"Master"},{"key":"Miss.","value":"Miss."},{"key":"01","value":"Mr."},{"key":"02","value":"Mrs."},{"key":"03","value":"Ms."},{"key":"Padmabhushan","value":"Padmabhushan"},{"key":"Padmashri","value":"Padmashri"},{"key":"Padmavibhushan","value":"Padmavibhushan"},{"key":"Pilot","value":"Pilot"},{"key":"Pilot Officer","value":"Pilot Officer"},{"key":"Rear Admiral","value":"Rear Admiral"},{"key":"Shri","value":"Shri"},{"key":"Squadron Leader","value":"Squadron Leader"},{"key":"Sub Lieutenant","value":"Sub Lieutenant"},{"key":"Wing Commander","value":"Wing Commander"}],"genders":[{"key":"F","value":"FEMALE"},{"key":"M","value":"MALE"},{"key":"T","value":"THIRD GENDER"}],"addressTypes":[{"key":"C","value":"Company Lease"},{"key":"O","value":"Owned"},{"key":"R","value":"Rented"}],"loanPurposes":[{"key":"1","value":"Others"},{"key":"2","value":"Under Construction - No Builder Tie-up"},{"key":"3","value":"Under Construction - Builder Tie-up"},{"key":"4","value":"New / Resale - Ready possession"},{"key":"5","value":"Land / Plot"}],"rePaymentTypes":[{"key":"PDC","value":"Post Dated Cheques"},{"key":"ECSO","value":"ECS/STANDING INSTRUCTION linked to other accounts"},{"key":"C","value":"Check Off"},{"key":"ECSC","value":"ECS/STANDING INSTRUCTION linked to salary account"}],"maritalStatuses":[{"key":"M","value":"MARRIED"},{"key":"S","value":"SINGLE"}]},"reasons":null,"losRef":null}';
				// homeLoanService.userMaster = JSON.parse(masters);

				confirmApplicantVm.houseSlider = {
					value: 3,
					options: {
						showSelectionBar: true,
						floor :  3,
						ceil :  10,
						step :  1,
						onChange : function(id,model){
							confirmApplicantVm.setNumberOfHouses();
						},
						translate : function(value){
							return  value + " Houses";
						}	
					}
				};

				confirmApplicantVm.setNumberOfHouses = function(){
					confirmApplicantVm.detail.numberOfHousesSliderValue = confirmApplicantVm.houseSlider.value;
				}


				confirmApplicantVm.relationshipList = homeLoanService.userMaster.master.relWithPriApplicants;
				confirmApplicantVm.residenceList = homeLoanService.userMaster.master.addressTypes;
				confirmApplicantVm.states = homeLoanService.userMaster.master.states;
				confirmApplicantVm.validateService = validateService;
				confirmApplicantVm.martialStatus = homeLoanService.userMaster.master.maritalStatuses;
				confirmApplicantVm.currentCities=[];
				confirmApplicantVm.currentDistricts=[];
				confirmApplicantVm.currentSubtDistricts=[];
				confirmApplicantVm.currentVillageTown=[];
				//confirmApplicantVm.detail.numberOfHousesValue = confirmApplicantVm.houseSlider.value;

				if(homeLoanService.isResume || homeLoanService.getCoApplicantDetails()){
					confirmApplicantVm.detail = homeLoanService.getCoApplicantDetails();
					var middleName = homeLoanService.getCoApplicantDetails().middleName ? homeLoanService.getCoApplicantDetails().middleName : "";
					confirmApplicantVm.detail.name = confirmApplicantVm.detail.title.value + " " + homeLoanService.getCoApplicantDetails().firstName + " " + middleName + " " + homeLoanService.getCoApplicantDetails().lastName;
					if(confirmApplicantVm.detail.currentCity){
						confirmApplicantVm.currentCities.push(confirmApplicantVm.detail.currentCity);
					}
					if(confirmApplicantVm.detail.currentDistrict){
						confirmApplicantVm.currentDistricts.push(confirmApplicantVm.detail.currentDistrict);
					}
					if(confirmApplicantVm.detail.currentSubDistrict){
						confirmApplicantVm.currentSubtDistricts.push(confirmApplicantVm.detail.currentSubDistrict);
					}
					if(confirmApplicantVm.detail.currentVillageTown){
						confirmApplicantVm.currentVillageTown.push(confirmApplicantVm.detail.currentVillageTown);
					}
					if(confirmApplicantVm.detail.numberOfHouses || confirmApplicantVm.detail.numberOfHousesSliderValue){
						confirmApplicantVm.detail.numberOfHousesCheckbox = true;
						if(homeLoanService.isResume){
						confirmApplicantVm.houseSlider.value = confirmApplicantVm.detail.numberOfHouses;
						}else{
						confirmApplicantVm.houseSlider.value = confirmApplicantVm.detail.numberOfHousesSliderValue;
						}
					}
				}else{
					confirmApplicantVm.detail.mobile = homeLoanService.getFetchDetails().mobile;
					confirmApplicantVm.detail.accountNo = homeLoanService.getFetchDetails().accountNo ? homeLoanService.getFetchDetails().accountNo : "";
					confirmApplicantVm.detail.dob = homeLoanService.getFetchDetails().dob;
					confirmApplicantVm.detail.email = homeLoanService.getFetchDetails().email;
					confirmApplicantVm.detail.title = homeLoanService.findObject(homeLoanService.getFetchDetails().title, homeLoanService.userMaster.master.titles);
					confirmApplicantVm.detail.gender = homeLoanService.findObject(homeLoanService.getFetchDetails().gender, homeLoanService.userMaster.master.genders);
					var middleName = homeLoanService.getFetchDetails().middleName ? homeLoanService.getFetchDetails().middleName : "";
					confirmApplicantVm.detail.name = confirmApplicantVm.detail.title.value + " " + homeLoanService.getFetchDetails().firstName + " " + middleName + " " + homeLoanService.getFetchDetails().lastName;
					confirmApplicantVm.detail.currentAddress = "P";
				}
				if(homeLoanService.getEducationMaster()){
					confirmApplicantVm.eduQualification = homeLoanService.getEducationMaster();
				}else{
					confirmApplicantVm.getEducationQualification();
				}
			};

			confirmApplicantVm.getEducationQualification = function (){
				var obj = {};
					homeLoanService.getEducationQualification(obj).then(function(data) {
						confirmApplicantVm.eduQualification = data.info;
						homeLoanService.setEducationMaster(confirmApplicantVm.eduQualification);			 		
					},function(error){
						utilityService.showErrorMessage(error.responseMessage);
					});
			}
			
			// $scope.$watch('confirmApplicantVm.houseSlider.value', function (newVal, oldVal) {
			// 	if (newVal !== oldVal) {
			// 		confirmApplicantVm.detail.numberOfHousesSliderValue = confirmApplicantVm.houseSlider.value;
			// 	}
			// });

			confirmApplicantVm.maskUnmask = function(){
				confirmApplicantVm.isMasked == true ? (confirmApplicantVm.isMasked = false , confirmApplicantVm.inputImg = "img/Visibility_on.svg") : (confirmApplicantVm.isMasked = true , confirmApplicantVm.inputImg = "img/Visibility_off.svg");
			};

			confirmApplicantVm.loadDistrictCurrent = function(type){
				var masterKey = "";
				if(type == 'district'){
					confirmApplicantVm.detail.currentDistrict = "";
					confirmApplicantVm.detail.currentSubDistrict = "";
					confirmApplicantVm.detail.currentVillageTown = "";
					confirmApplicantVm.detail.currentCity = "";
					masterKey = confirmApplicantVm.detail.currentState.key;
				}else if(type == 'subdistrict'){
					confirmApplicantVm.detail.currentSubDistrict = "";
					confirmApplicantVm.detail.currentVillageTown = "";
					confirmApplicantVm.detail.currentCity = "";
					masterKey = confirmApplicantVm.detail.currentDistrict.key;
				}else if(type == 'village'){
					confirmApplicantVm.detail.currentVillageTown = "";
					confirmApplicantVm.detail.currentCity = "";
					masterKey = confirmApplicantVm.detail.currentSubDistrict.key;
				}else if(type == 'city'){
					confirmApplicantVm.detail.currentCity = "";
					masterKey = confirmApplicantVm.detail.currentState.key;
				}

				var request = {
				  "key": masterKey,
				  "action": type
				};

				homeLoanService.getDistrictCity(request).then(function(data) {
					if(type == 'district'){
						confirmApplicantVm.currentDistricts = data.info;
					}else if(type == 'subdistrict'){
						confirmApplicantVm.currentSubtDistricts = data.info;
					}else if(type == 'village'){
						confirmApplicantVm.currentVillageTown = data.info;
					}else if(type == 'city'){
						confirmApplicantVm.currentCities = data.info;
					}
					
					
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			confirmApplicantVm.showCurrentAddress = function(){
				$ionicScrollDelegate.resize();
			}

			$scope.$on('$ionicView.loaded', function () {
				
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				initPage();
			});

			confirmApplicantVm.goBack = function(){
				$state.go('menu.addCoApplicant');
			}

			confirmApplicantVm.getCityState = function (pinCode,addType){
				var obj = {
						"pinCode": pinCode
					};
					homeLoanService.getPincodeData(obj).then(function(data) {
						if(addType == "P"){
							confirmApplicantVm.detail.address = confirmApplicantVm.detail.address +' '+ data.districtName +' '+data.stateName;
							confirmApplicantVm.detail.district = data.districtName;
							confirmApplicantVm.detail.state = data.stateName;
						}else if(addType == "C"){
							confirmApplicantVm.detail.currentCity = data.districtName;
							confirmApplicantVm.detail.currentState = data.stateName;
							confirmApplicantVm.detail.currentPincode = pinCode;
						}						
					},function(error){
						utilityService.showErrorMessage(error.responseMessage);
					});
			}

			confirmApplicantVm.loadCityState = function(){
				if(confirmApplicantVm.detail.currentPincode.length == 6){
					confirmApplicantVm.getCityState(confirmApplicantVm.detail.currentPincode,"C");					
				}
			}

			confirmApplicantVm.goToNextPage = function(){
				confirmApplicantVm.confirmApplicantForm = {};
				if (validateForm()) {
					homeLoanService.setCoApplicantDetails(confirmApplicantVm.detail);
					$state.go('menu.coApplicantWorkDetails');
				}
			}

			

			return this;
		}

		
]);


