'use strict';
angularApp.controller('consentCoApplicantController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"$ionicSideMenuDelegate",
		"homeLoanService",
		"validateService",
		"$filter",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, $ionicSideMenuDelegate,homeLoanService,validateService,$filter) {
			
			var consentCoApplicantVm = this;
			
			function initPage() {

				consentCoApplicantVm.groups = [{
					id : "office",
					name : "Office Details"
				}];
				
				consentCoApplicantVm.detail = homeLoanService.getOVDDetails();
				consentCoApplicantVm.consentData = homeLoanService.getConsentData();
				
				consentCoApplicantVm.consentCoApplicant = {};
				for(var i=0;i<consentCoApplicantVm.consentData.applicants.length;i++){
					if (consentCoApplicantVm.consentData.applicants[i].applicantType != 'P') {
						consentCoApplicantVm.consentCoApplicant = consentCoApplicantVm.consentData.applicants[i];
					}
				}

				consentCoApplicantVm.isMaskPan = true;
				consentCoApplicantVm.isMaskAd = true;
				consentCoApplicantVm.ovdTypes = consentCoApplicantVm.consentData.master.ovdTypes;

				consentCoApplicantVm.consentCoApplicant.middleName = consentCoApplicantVm.consentCoApplicant.middleName ? consentCoApplicantVm.consentCoApplicant.middleName : "";

				consentCoApplicantVm.fullName = consentCoApplicantVm.consentCoApplicant.firstName+ ' '+ consentCoApplicantVm.consentCoApplicant.middleName + ' ' +consentCoApplicantVm.consentCoApplicant.lastName;
				consentCoApplicantVm.custName =  JSON.parse(consentCoApplicantVm.consentCoApplicant.titleValue).value + ' '+consentCoApplicantVm.fullName;
				consentCoApplicantVm.dob = consentCoApplicantVm.consentCoApplicant.dob;
				consentCoApplicantVm.pan = consentCoApplicantVm.consentCoApplicant.pan;
				consentCoApplicantVm.aadhaar = consentCoApplicantVm.consentCoApplicant.aadhaar;
				consentCoApplicantVm.gender =  JSON.parse(consentCoApplicantVm.consentCoApplicant.genderValue).value;
				consentCoApplicantVm.email = consentCoApplicantVm.consentCoApplicant.email;
				consentCoApplicantVm.accountNumber = consentCoApplicantVm.consentCoApplicant.accountNo;
				consentCoApplicantVm.maritialStatus = JSON.parse(consentCoApplicantVm.consentCoApplicant.maritalStatusValue).value;
				consentCoApplicantVm.relationWithPrimary = JSON.parse(consentCoApplicantVm.consentCoApplicant.relationWithPrimApplicantValue).value;
				consentCoApplicantVm.mobile = consentCoApplicantVm.consentCoApplicant.mobile;



				consentCoApplicantVm.addressObj = {};
				if(consentCoApplicantVm.consentCoApplicant.address.length > 1){
					for(var i = 0;i<consentCoApplicantVm.consentCoApplicant.address.length;i++){
						if(consentCoApplicantVm.consentCoApplicant.address[i].addressType == 'C'){
							consentCoApplicantVm.addressObj = consentCoApplicantVm.consentCoApplicant.address[i];
						} else if(consentCoApplicantVm.consentCoApplicant.address[i].addressType == 'O'){
							consentCoApplicantVm.addressOfficeObj = consentCoApplicantVm.consentCoApplicant.address[i];
						}
					}
				}else{
					consentCoApplicantVm.addressObj = consentCoApplicantVm.consentCoApplicant.address[0];
				}
				
				if(JSON.stringify(consentCoApplicantVm.addressObj) == "{}"){
					for(var i = 0;i<consentCoApplicantVm.consentCoApplicant.address.length;i++){
						if(consentCoApplicantVm.consentCoApplicant.address[i].addressType == 'P'){
							consentCoApplicantVm.addressObj = consentCoApplicantVm.consentCoApplicant.address[i];
						}
					}
				}

				consentCoApplicantVm.addressLine1 = consentCoApplicantVm.addressObj.addressLine1 ? consentCoApplicantVm.addressObj.addressLine1 : "";
				consentCoApplicantVm.addressLine2 = consentCoApplicantVm.addressObj.addressLine2 ? consentCoApplicantVm.addressObj.addressLine2 : "";
				consentCoApplicantVm.addressLine3 = consentCoApplicantVm.addressObj.addressLine3 ? consentCoApplicantVm.addressObj.addressLine3 : "";

				consentCoApplicantVm.district = consentCoApplicantVm.addressObj.districtText ? JSON.parse(consentCoApplicantVm.addressObj.districtText).value : "";
				consentCoApplicantVm.city = consentCoApplicantVm.addressObj.cityText ? JSON.parse(consentCoApplicantVm.addressObj.cityText).value : "";
				consentCoApplicantVm.state = consentCoApplicantVm.addressObj.stateText ? JSON.parse(consentCoApplicantVm.addressObj.stateText).value : "";
				consentCoApplicantVm.pincode = consentCoApplicantVm.addressObj.pincode;

				consentCoApplicantVm.address = consentCoApplicantVm.addressLine1 + ' '+consentCoApplicantVm.addressLine2+' '+consentCoApplicantVm.addressLine3+','+ consentCoApplicantVm.city + ','+consentCoApplicantVm.district+','+consentCoApplicantVm.state+'-'+ consentCoApplicantVm.pincode;

				//Office Details
				if(consentCoApplicantVm.addressOfficeObj){
				consentCoApplicantVm.officeAddressLine1 = consentCoApplicantVm.addressOfficeObj.addressLine1 ? consentCoApplicantVm.addressOfficeObj.addressLine1 : "";
				consentCoApplicantVm.officeAddressLine2 = consentCoApplicantVm.addressOfficeObj.addressLine2 ? consentCoApplicantVm.addressOfficeObj.addressLine2 : "";

				consentCoApplicantVm.officeDistrict = consentCoApplicantVm.addressOfficeObj.districtText ? JSON.parse(consentCoApplicantVm.addressOfficeObj.districtText).value : "";
				consentCoApplicantVm.officeSubDistrict = consentCoApplicantVm.addressOfficeObj.subDistrictText ? JSON.parse(consentCoApplicantVm.addressOfficeObj.subDistrictText).value : "";
				consentCoApplicantVm.officeCity = consentCoApplicantVm.addressOfficeObj.cityText ? JSON.parse(consentCoApplicantVm.addressOfficeObj.cityText).value : "";
				consentCoApplicantVm.officeState = consentCoApplicantVm.addressOfficeObj.stateText ? JSON.parse(consentCoApplicantVm.addressOfficeObj.stateText).value : "";
				consentCoApplicantVm.officePincode = consentCoApplicantVm.addressOfficeObj.pincode;
				}

				//Emp Details
				if(consentCoApplicantVm.consentCoApplicant.employmentTypeValue){
					consentCoApplicantVm.employmentType = JSON.parse(consentCoApplicantVm.consentCoApplicant.employmentTypeValue).value;
				}
				
				consentCoApplicantVm.monthsInCurrResidence = consentCoApplicantVm.consentCoApplicant.monthsInCurrResidence;
				if(consentCoApplicantVm.consentCoApplicant.residenceTypeValue){
					consentCoApplicantVm.residenceType = JSON.parse(consentCoApplicantVm.consentCoApplicant.residenceTypeValue).value;
				}
				if(consentCoApplicantVm.consentCoApplicant.employerTypeValue){
					consentCoApplicantVm.employerType = JSON.parse(consentCoApplicantVm.consentCoApplicant.employerTypeValue).value;
				}

				if(consentCoApplicantVm.consentCoApplicant.otherProfessionType){
					consentCoApplicantVm.professionType = consentCoApplicantVm.consentCoApplicant.otherProfessionType;
				}else if(consentCoApplicantVm.consentCoApplicant.professionTypeValue){
					consentCoApplicantVm.professionType = JSON.parse(consentCoApplicantVm.consentCoApplicant.professionTypeValue).value;
				}

				consentCoApplicantVm.incomeHouseProperty = consentCoApplicantVm.consentCoApplicant.incomeHouseProperty;
				
				consentCoApplicantVm.retirementAge = consentCoApplicantVm.consentCoApplicant.retirementAge;
				consentCoApplicantVm.workExp = consentCoApplicantVm.consentCoApplicant.workExp;
				consentCoApplicantVm.monthsInCurrJob = consentCoApplicantVm.consentCoApplicant.monthsInCurrJob;

				//Existing EMI
				consentCoApplicantVm.emiObj = consentCoApplicantVm.consentCoApplicant.emi;
				consentCoApplicantVm.totalEMIs = [];
				if(consentCoApplicantVm.emiObj){
					for(var i =0 ; i<consentCoApplicantVm.emiObj.length;i++){
						var obj = {};
						obj.emiType = JSON.parse(consentCoApplicantVm.emiObj[i].typeValue).value;
						obj.amount = parseFloat(consentCoApplicantVm.emiObj[i].amount); 
						consentCoApplicantVm.totalEMIs.push(obj);

					}
				}



				
			};

			// ------------------------------------Office dtails--------------------------------------

			consentCoApplicantVm.toggleGroup = function(group) {
				if (group.id == "office") {
					if (consentCoApplicantVm.isGroupShown(group)) {
						consentCoApplicantVm.shownGroup = null;
					} else {
							consentCoApplicantVm.shownGroup = group;
					}
				}
	
	
			};



			consentCoApplicantVm.isGroupShown = function(group) {
				return consentCoApplicantVm.shownGroup === group;
			};




			// ------------------------------------Office dtails END--------------------------------------

			consentCoApplicantVm.unmaskData = function(idType){
				var request = {
				  "type": idType
				}
				if(idType == 'pan' || idType == 'aadhaar'){
					homeLoanService.getUnmaskData(request).then(function(data) {
						if (idType =='pan') {
							consentCoApplicantVm.isMaskPan = false;
							consentCoApplicantVm.pan = data;
						}else{
							consentCoApplicantVm.isMaskAd = false;
							consentCoApplicantVm.aadhaar = data;
						}
						
					},function(error){
						utilityService.showErrorMessage(error.responseMessage);
					});
				}else{
					if(idType == 'npan'){
						consentCoApplicantVm.isMaskPan = true;
						consentCoApplicantVm.pan = consentCoApplicantVm.consentCoApplicant.pan;
					}else{
						consentCoApplicantVm.isMaskAd = true;
						consentCoApplicantVm.aadhaar = consentCoApplicantVm.consentCoApplicant.aadhaar;
					}
					
				}
				
			}

			consentCoApplicantVm.hlConsentTNC = function(type){
				//Tnc Service call
				var request = {
					"type": "homeLoanTnc"
				};
				if(type == 'p'){
					 request = {
						"type": "homeLoanConsentTnc"
					};
				}

				homeLoanService.getTermsAndCondition(request).then(function(data) {
					var titlePopup = "Declaration";
						if (type == "p") {
							titlePopup = "Policies";
						}else{
							titlePopup = "Terms & Conditions";
						}
						
						var buttontext = "OK";
						var blankdata = null;
						var detail = $filter('ngBindHtmlFilter')(data);
						var tncStatus = $ionicPopup.show({
	                      title: titlePopup,
	                      cssClass: 'ftandcpopup-body popupBackgroundWhite popupWidth90  popupBackgroundDark',
	                      template: data,
	                      scope: $scope,
	                      buttons: [

	                          {
	                              text: '<b>OK</b>',
	                              type: 'button-positive',
	                              onTap: function(e) {
	                                  tncStatus.close();
	                              }
	                          }
	                      ]
	                  });
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});

			}

			consentCoApplicantVm.goBack = function() {
	            $ionicHistory.goBack(-1);
	           
	        }

			consentCoApplicantVm.goToNextPage = function(){
				homeLoanService.smsConsent = consentCoApplicantVm.consentCoApplicant.authorizeFlag;
				$state.go('menu.homeLoanConsentFinal');
			
			}

			$scope.$on('$ionicView.loaded', function () {
				
			});

			$scope.$on('$ionicView.beforeEnter', function () {		
				initPage();
			});

			return this;
		}

		
]);


