'use strict';
angularApp.controller('consentFinalApprovalController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"$ionicSideMenuDelegate",
		"homeLoanService",
		"validateService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, $ionicSideMenuDelegate,homeLoanService,validateService) {
			
			var consentFinalApprovalVm = this;
			
			function initPage() {
				consentFinalApprovalVm.isConsentAccepted = false;
				consentFinalApprovalVm.consentData = homeLoanService.getConsentData();
				consentFinalApprovalVm.primaryApplicant = {};
				for(var i=0;i<consentFinalApprovalVm.consentData.applicants.length;i++){
					if (consentFinalApprovalVm.consentData.applicants[i].applicantType == 'P') {
						consentFinalApprovalVm.primaryApplicant =consentFinalApprovalVm.consentData.applicants[i];
						
					}
				}

				consentFinalApprovalVm.primaryApplicant.middleName =consentFinalApprovalVm.primaryApplicant.middleName ?consentFinalApprovalVm.primaryApplicant.middleName : "";

				consentFinalApprovalVm.fullName =consentFinalApprovalVm.primaryApplicant.firstName+ ' '+consentFinalApprovalVm.primaryApplicant.middleName + ' ' +consentFinalApprovalVm.primaryApplicant.lastName;
				consentFinalApprovalVm.custName =  JSON.parse(consentFinalApprovalVm.primaryApplicant.titleValue).value + ' '+consentFinalApprovalVm.fullName;
				
				consentFinalApprovalVm.finalApprovalConsent = "I have reviewed the home loan application by "+ consentFinalApprovalVm.fullName +" and provide my consent for the application.";
				consentFinalApprovalVm.finalApprovalConsent2 = "Applicant "+ consentFinalApprovalVm.fullName +" can upload required documents on my behalf.";
				consentFinalApprovalVm.finalApprovalConsent3 = "I understand that I will be jointly responsible for the repayment of the loan and that the primary applicant can change the loan details before the final Loan sanction.";
				
			};

			consentFinalApprovalVm.updateConsent = function(consentFlag){

				var request = {
				  "loanType": homeLoanService.getGroupId(),
				  "yonoRef": homeLoanService.appOrTransNo,
					"action": consentFlag,
					"authorizeFlag": homeLoanService.smsConsent ? "true" : "false",
				};
				homeLoanService.updateConsent(request).then(function(data) {
					console.log(data);
					consentFinalApprovalVm.isConsentAccepted = true;
					//$state.go('menu.loans');
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			consentFinalApprovalVm.goPrevious = function(){
				$ionicHistory.goBack(-1);
			}

			consentFinalApprovalVm.goToAO = function(){
				$state.go('menu.accountOverviewMyBalance');
			}

			consentFinalApprovalVm.goBack = function() {
	            var backPopup = $ionicPopup.show({
					title: null,
					cssClass: 'my-custom-popup',
					template: '<div class="button_fund font-size-14 roboto-medium color-darkgrey" translate="HL_REJECT_APP"></div>',
					buttons: [{
						text: 'No',
						type: 'button-assertive',
						onTap: function () {

							backPopup.close();
						}
					},
					{
						text: 'Yes',
						type: 'button-assertive',
						onTap: function () {
							//service call for reject
							consentFinalApprovalVm.updateConsent("REJECT");
							backPopup.close();
						}
					}],
				});
	           
	        }

			consentFinalApprovalVm.goToNextPage = function(){
				var templateSpan = '<div class="text-center roboto-regular font-size-14 color-darkgrey"><span translate="HL_CONSENT_APPROVAL" class=""></span><br>' + consentFinalApprovalVm.custName + '&nbsp;<span translate="HL_CONSENT_APPROVAL_TEXT"></span></div>';
				var backPopup = $ionicPopup.show({
					title: null,
					cssClass: 'my-custom-popup',
					template: templateSpan,
					buttons: [{
						text: 'No',
						type: 'button-assertive',
						onTap: function () {
							backPopup.close();
						}
					},
					{
						text: 'Yes',
						type: 'button-assertive',
						onTap: function () {
							//service call for reject
							consentFinalApprovalVm.updateConsent("ACCEPT")
							backPopup.close();
						}
					}],
				});
			}

			$scope.$on('$ionicView.loaded', function () {
				
			});

			$scope.$on('$ionicView.beforeEnter', function () {		
			   initPage();
			});

			return this;
		}

		
]);


