'use strict';
angularApp.controller('consentStatusHLController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"validateService",
		"homeLoanService",
		"$filter",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate,validateService,homeLoanService,$filter) {
			
			var consentStatusHLVm = this;

			

			function initPage(){
				consentStatusHLVm.isConsentReject = homeLoanService.getConsentStatus().consentStatus == "reject" ? true : false;
				consentStatusHLVm.isConsentAccept = homeLoanService.getConsentStatus().consentStatus == "accept" ? true : false;
				consentStatusHLVm.isConsentPending = homeLoanService.getConsentStatus().consentStatus == "pending" ? true : false;
				consentStatusHLVm.customerName = homeLoanService.getConsentStatus().customerName ? homeLoanService.getConsentStatus().customerName  : "";
			}

			consentStatusHLVm.goToNextPage = function(){
				//$state.go('menu.calculateEmi');
				if(homeLoanService.getGroupId() == "TAKEOVER"){
					$state.go('menu.calculateEmiTakeover');
				}else{
					$state.go('menu.calculateEmi');
				}	
			}

			consentStatusHLVm.applyNew = function(){
				var backPopup = $ionicPopup.show({
					title: null,
					cssClass: 'my-custom-popup',
					template: '<div class="button_fund font-size-14 roboto-medium color-darkgrey" translate="HL_DELETE_APP"></div>',
					buttons: [{
						text: 'No',
						type: 'button-assertive',
						onTap: function () {
							backPopup.close();
						}
					},
					{
						text: 'Yes',
						type: 'button-assertive',
						onTap: function () {
							//service call for reject
							var request = {
								"loanType" : homeLoanService.getGroupId()
							};
							homeLoanService.removeApplication(request).then(function(data) {
								homeLoanService.clearAll();
								homeLoanService.isResume = false;
								$state.go('menu.loans');
								var alertPopup = $ionicPopup.alert({
									template: "<p style='text-align:center;font-weight:bold;font-size:16px'>All your pending applications have been deleted.</p>"
								});								
							},function(error){
								utilityService.showErrorMessage(error.responseMessage);
							});
							backPopup.close();
						}
					}],
				});
			}
			

			$scope.$on('$ionicView.beforeEnter', function () {
				initPage();
			});	

			return this;
		}

		
]);


