'use strict';
angularApp.controller('hlAddDocumentController', [
		"$state",
		"$scope",
		"$filter",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"xpressCreditService",
		"homeLoanService",
		"cameraService",
		function($state, $scope,$filter, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate,xpressCreditService,homeLoanService,cameraService) {
			
			var hlAddDocumentVm = this;
			
			function initPage() {
				hlAddDocumentVm.errObj = {};
				hlAddDocumentVm.detail = {};
				//homeLoanService.uploadType = docType;
				hlAddDocumentVm.index = homeLoanService.index ;
				hlAddDocumentVm.selectedDoc = homeLoanService.uploadType;
				hlAddDocumentVm.selectedDocVal = hlAddDocumentVm.selectedDoc.value;
				hlAddDocumentVm.selectedDocKey = hlAddDocumentVm.selectedDoc.key;
				hlAddDocumentVm.masterList = homeLoanService.userMaster.master.documentLists;
				hlAddDocumentVm.docNameTxt="";
				hlAddDocumentVm.detail.docType="";
			}

			hlAddDocumentVm.openFileBrowser = function(){
				if(!hlAddDocumentVm.detail.docType){
					hlAddDocumentVm.errObj.docType = $translate.instant("HL_VAL_DOCTOUPLOAD");
				}else{
					utilityService.showSpinner();
					if(utilityService.isAndroidPlatform()){
							homeLoanService.getFileForAndroid().then(function(data){
								var sizeInMB = data.length;
								var blob = new Blob([data], {type: 'image/jpeg'});
								var typecheck = data.substring(data.indexOf('/') + 1, data.indexOf(';base64'));
								hlAddDocumentVm.fileExtension = typecheck;
								utilityService.hideSpinner();
								if (typecheck == "jpeg" || typecheck == "pdf") {
									if (sizeInMB < 5000000){
										hlAddDocumentVm.fileData = data.split('base64,')[1];
										hlAddDocumentVm.docNameTxt = hlAddDocumentVm.selectedDocVal + "_" + hlAddDocumentVm.detail.docType.value +"."+ hlAddDocumentVm.fileExtension;
									}else{
										var errMsg = $translate.instant('HL_ERR_FILE_SIZE');
										utilityService.showErrorMessage(errMsg);
									}
									
								} else {
									var errMsg = $translate.instant('HL_ERR_FILE_TYPE');
									utilityService.showErrorMessage(errMsg);
								}

							}, function(error) { 
									utilityService.hideSpinner();
							});
						}else{
							homeLoanService.getFileForiOS().then(function(response) {
								var sizeInMB = response.size;
                                				var data = response.imagedata;
								var blob = new Blob([data], {type: 'image/jpeg'});
								var typecheck = data.substring(data.indexOf('/') + 1, data.indexOf(';base64'));
								hlAddDocumentVm.fileExtension = typecheck;
								utilityService.hideSpinner();
								if (typecheck == "jpeg" || typecheck == "pdf") {
									if (sizeInMB < 5000000){
										hlAddDocumentVm.fileData = data.split('base64,')[1];
										hlAddDocumentVm.docNameTxt = hlAddDocumentVm.selectedDocVal + "_" + hlAddDocumentVm.detail.docType.value +"."+ hlAddDocumentVm.fileExtension;
									}else{
										var errMsg = $translate.instant('HL_ERR_FILE_SIZE');
										utilityService.showErrorMessage(errMsg);
									}
									
								} else {
									var errMsg = $translate.instant('HL_ERR_FILE_TYPE');
									utilityService.showErrorMessage(errMsg);
								}

							}, function(error) { 
									utilityService.hideSpinner();
						});
					}
					
					

				}
					
			}

			hlAddDocumentVm.changeDocType = function (){
				hlAddDocumentVm.errObj.docType = false;
				//hlAddDocumentVm.errObj.docType = "";
			}

			hlAddDocumentVm.goBack = function(){
				$ionicHistory.goBack(-1);
			}

			hlAddDocumentVm.goToNextPage = function(){
				//$state.go('menu.hlConfirmSchedule');
				//go to doc upload API
				var docName = hlAddDocumentVm.selectedDocVal + "_" + hlAddDocumentVm.detail.docType.value +"."+ hlAddDocumentVm.fileExtension;
				if(hlAddDocumentVm.fileExtension == 'jpeg'){
					hlAddDocumentVm.mimeType = "application/jpeg";
				}else if(hlAddDocumentVm.fileExtension == 'pdf'){
					hlAddDocumentVm.mimeType = "application/pdf";
				}
				var request = {
				  "loanType": homeLoanService.getGroupId(),
				  "doclist": [
				    {
				      "docName": docName,
				      "category": hlAddDocumentVm.selectedDocKey,
				      "docType": hlAddDocumentVm.mimeType,
				      "base64": hlAddDocumentVm.fileData,
				      "subCategory": hlAddDocumentVm.detail.docType.value
				    }
				  ]
				};
				homeLoanService.myDoc = hlAddDocumentVm.selectedDocVal;
				homeLoanService.uploadDocument(request).then(function(data) {

					var obj = {
								"docName":docName,
								"category": hlAddDocumentVm.selectedDocKey,
								"subCategory": hlAddDocumentVm.detail.docType.value
							};
					if(data.doclist[0].rescanFlag == 'Y'){
						
					}else{
						homeLoanService.listOfIncomeDocuments.push(obj);
					}
					
					$ionicHistory.goBack(-1);
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			$scope.$on('$ionicView.loaded', function () {
				
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				initPage();
			});

			return this;
		}

		
]);


