'use strict';
angularApp.controller('hlDocLandingController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"customerInfoService",
		"homeLoanService",
		"openUrlInAppbroswerService",
		"irctcService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate,customerInfoService,homeLoanService,openUrlInAppbroswerService,irctcService) {
			
			var hlDocLandingVm = this;
			
			function initPage() {
				hlDocLandingVm.detail = homeLoanService.appointmentDetails;
				hlDocLandingVm.appDetail = homeLoanService.getApplicationDetails();
				
				hlDocLandingVm.pickupTimes = [{"key":"09:00am","value":"09:00 AM - 12:00 PM"},{"key":"12:00pm","value":"12:00 PM - 3:00 PM"},{"key":"03:00pm","value":"3:00 PM - 6:00 PM"}];
				hlDocLandingVm.detail.selDoc = homeLoanService.docSubmitType;
				hlDocLandingVm.selectedPrefBranch = homeLoanService.selectedPrefBranch;
				hlDocLandingVm.docLandingLocation = homeLoanService.docLandingLocation; // mm/dd/yyyy hh:mmam
				hlDocLandingVm.appointmentDate = new Date(hlDocLandingVm.appDetail.inPrincipleDate.split('/')[2],parseInt(hlDocLandingVm.appDetail.inPrincipleDate.split('/')[1]) - 1,hlDocLandingVm.appDetail.inPrincipleDate.split('/')[0]);
				if(!hlDocLandingVm.detail.selectedPrefBranch){
					hlDocLandingVm.detail.selectedPrefBranch = 1;
				}
				hlDocLandingVm.selectedLocation(hlDocLandingVm.detail.selectedPrefBranch);
				
			}

			hlDocLandingVm.manageDocTypes = function(){
				var selctedType = hlDocLandingVm.detail.docType.key;
				if(selctedType == 1){
					hlDocLandingVm.detail.selDoc = 1;
				}else if(selctedType == 2){
					hlDocLandingVm.detail.selDoc = 2;
				}else if(selctedType == 3){
					hlDocLandingVm.detail.selDoc = 3;
				}
			}

			hlDocLandingVm.selectedLocation = function(type){
				if(type == 1){
					hlDocLandingVm.prefCity = hlDocLandingVm.docLandingLocation.addLocation;
					hlDocLandingVm.resiAddress = hlDocLandingVm.appDetail.applicants[0].address;
					if(hlDocLandingVm.resiAddress.length > 1){
						hlDocLandingVm.detail.addObj = hlDocLandingVm.resiAddress[1];
					}else{
						hlDocLandingVm.detail.addObj = hlDocLandingVm.resiAddress[0];
					}

					if(!hlDocLandingVm.detail.addObj.addressLine1){
						hlDocLandingVm.detail.addObj.addressLine1 = "";
					}else{
						if(hlDocLandingVm.detail.addObj.addressLine1.indexOf(',')==-1)
						{
						hlDocLandingVm.detail.addObj.addressLine1 = hlDocLandingVm.detail.addObj.addressLine1 +",";
					}
					else
					{
						hlDocLandingVm.detail.addObj.addressLine1 = hlDocLandingVm.detail.addObj.addressLine1;
					}

					}
					if(!hlDocLandingVm.detail.addObj.addressLine2){
						hlDocLandingVm.detail.addObj.addressLine2 = "";
					}else{
						
						if(hlDocLandingVm.detail.addObj.addressLine2.indexOf(',')==-1)
							{
							hlDocLandingVm.detail.addObj.addressLine2 = hlDocLandingVm.detail.addObj.addressLine2 +",";
						}
						else
						{
							hlDocLandingVm.detail.addObj.addressLine2 = hlDocLandingVm.detail.addObj.addressLine2;
						}
					}


					if(!hlDocLandingVm.detail.addObj.addressLine3){
						hlDocLandingVm.detail.addObj.addressLine3 = "";
					}else{
							
						if(hlDocLandingVm.detail.addObj.addressLine3.indexOf(',')==-1)
						{
							hlDocLandingVm.detail.addObj.addressLine3 = hlDocLandingVm.detail.addObj.addressLine3 +",";
						}
						else
						{
							hlDocLandingVm.detail.addObj.addressLine3 = hlDocLandingVm.detail.addObj.addressLine3;
						}
					}

					if(!hlDocLandingVm.detail.addObj.pincode){
						hlDocLandingVm.detail.addObj.pincode = "";
					}
					else{
						if(hlDocLandingVm.detail.addObj.pincode.indexOf('-')==-1){
							hlDocLandingVm.detail.addObj.pincode = "-"+hlDocLandingVm.detail.addObj.pincode;
						}else{
							hlDocLandingVm.detail.addObj.pincode = hlDocLandingVm.detail.addObj.pincode;
						}
						
					}

					hlDocLandingVm.detail.pickUpAddress = hlDocLandingVm.detail.addObj.addressLine1+hlDocLandingVm.detail.addObj.addressLine2+hlDocLandingVm.detail.addObj.addressLine3 + JSON.parse(hlDocLandingVm.detail.addObj.cityText).value+',' + JSON.parse(hlDocLandingVm.detail.addObj.stateText).value+hlDocLandingVm.detail.addObj.pincode;
				}else if(type == 2){
					hlDocLandingVm.prefCity = hlDocLandingVm.docLandingLocation.propLocation;
					hlDocLandingVm.detail.addObjProp = hlDocLandingVm.appDetail.propertyDetails;
					if(!hlDocLandingVm.detail.addObjProp.propertyAddressline2){
						hlDocLandingVm.detail.addObjProp.propertyAddressline2 = "";
					}else{
						if(hlDocLandingVm.detail.addObjProp.propertyAddressline2.indexOf(',')==-1)
						{
							hlDocLandingVm.detail.addObjProp.propertyAddressline2 = hlDocLandingVm.detail.addObjProp.propertyAddressline2+",";
						}

						else
						{
							hlDocLandingVm.detail.addObjProp.propertyAddressline2 = hlDocLandingVm.detail.addObjProp.propertyAddressline2;
						}
						
					}
						if(!hlDocLandingVm.detail.addObjProp.propertyAddressline3){
						hlDocLandingVm.detail.addObjProp.propertyAddressline3 = "";
					}else{
						if(hlDocLandingVm.detail.addObjProp.propertyAddressline3.indexOf(',')==-1)
						{
							hlDocLandingVm.detail.addObjProp.propertyAddressline3 = hlDocLandingVm.detail.addObjProp.propertyAddressline3+",";
						}

						else
						{
							hlDocLandingVm.detail.addObjProp.propertyAddressline3 = hlDocLandingVm.detail.addObjProp.propertyAddressline3;
						}
						
					}
					if(!hlDocLandingVm.detail.addObjProp.propertyAddressline1){
						hlDocLandingVm.detail.addObjProp.propertyAddressline1 = "";
					}else{
						
						if(hlDocLandingVm.detail.addObjProp.propertyAddressline1.indexOf(',')==-1)
						{
							hlDocLandingVm.detail.addObjProp.propertyAddressline1 = hlDocLandingVm.detail.addObjProp.propertyAddressline1+",";
						}

						else
						{
							hlDocLandingVm.detail.addObjProp.propertyAddressline1 = hlDocLandingVm.detail.addObjProp.propertyAddressline1;
						}
					}

					if(!hlDocLandingVm.detail.addObjProp.pincode){
						hlDocLandingVm.detail.addObjProp.pincode = "";
					}
					else{
						if(hlDocLandingVm.detail.addObjProp.pincode.indexOf('-')==-1){
							hlDocLandingVm.detail.addObjProp.pincode = "-"+hlDocLandingVm.detail.addObjProp.pincode;
						}else{
							hlDocLandingVm.detail.addObjProp.pincode = hlDocLandingVm.detail.addObjProp.pincode;
						}
						
					}

					hlDocLandingVm.detail.pickUpAddress = hlDocLandingVm.detail.addObjProp.propertyAddressline1 + hlDocLandingVm.detail.addObjProp.propertyAddressline2 + hlDocLandingVm.detail.addObjProp.propertyAddressline3 + hlDocLandingVm.detail.addObjProp.city +','+ hlDocLandingVm.detail.addObjProp.state+hlDocLandingVm.detail.addObjProp.pincode;
				}



				if(hlDocLandingVm.docLandingLocation.propLocation === hlDocLandingVm.docLandingLocation.addLocation){
					hlDocLandingVm.listOfDocuments = [{"key":"1","value":"Submission"},{"key":"2","value":"Pickup"},{"key":"3","value":"Scan and Upload"}];
				}else{
					hlDocLandingVm.listOfDocuments = [{"key":"1","value":"Submission"},{"key":"3","value":"Scan and Upload"}];
				}

				if(!homeLoanService.getCRMData()){
					hlDocLandingVm.listOfDocuments = [{"key":"3","value":"Scan and Upload"}];
				}

				
			}

			hlDocLandingVm.openDatePicker = function(){
				var newDate = new Date();
				var nextDay = new Date();
				var destdate = hlDocLandingVm.appointmentDate;
				nextDay.setDate(newDate.getDate() + 1);
				destdate.setDate(hlDocLandingVm.appointmentDate.getDate() + 30);
				//var dateFromAPI = newDate.setMonth(newDate.getMonth() + 1);
				hlDocLandingVm.dateObj = {
					callback: function (val) {
		                    var tomorrow = new Date(val);
		                    tomorrow.setDate(tomorrow.getDate() + 1);
		                    hlDocLandingVm.detail.appDate = new Date(tomorrow).toISOString().slice(0,10);

		                    var myDate = hlDocLandingVm.detail.appDate.split('-');
							hlDocLandingVm.detail.startDateWithFormat = myDate[1]+"/"+myDate[2]+"/"+myDate[0];
						},
						inputDate: nextDay,
						monthsList:["JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC"],
						from: nextDay,
						to: destdate,
						mondayFirst: true,
						closeOnSelect: false,
						templateType: 'popup',
						dateFormat: 'dd MMM yyyy'

				};

				ionicDatePicker.openDatePicker(hlDocLandingVm.dateObj);
			}

			hlDocLandingVm.goToAccOverview = function(){
				$state.go('menu.accountOverviewMyBalance');
			}

			hlDocLandingVm.uploadDoc = function(){
				
			}

			hlDocLandingVm.goToNextPage = function(){
				if(hlDocLandingVm.validateForm()){
					homeLoanService.docSubmitType = hlDocLandingVm.detail.selDoc;
					if(hlDocLandingVm.detail.selDoc == 1 || hlDocLandingVm.detail.selDoc == 2){
						//go to processing fee page
						$state.go('menu.hlProcessFee');
					}else{
						//go to upload page
						if(homeLoanService.getApplicationDetails().doclist){
							homeLoanService.listOfIncomeDocuments = homeLoanService.getApplicationDetails().doclist;
						}else{
							homeLoanService.listOfIncomeDocuments = [];
						}
						
						$state.go('menu.hlDocUpload');
					}
					homeLoanService.appointmentDetails = hlDocLandingVm.detail;
				}
				
			}

			hlDocLandingVm.validateForm = function(){
				hlDocLandingVm.errObj = {};

				if(!hlDocLandingVm.detail.docType){
					hlDocLandingVm.errObj.docType = $translate.instant('HL_VAL_DOCTYPE');
				}

				if(hlDocLandingVm.detail.selDoc == 1 || hlDocLandingVm.detail.selDoc == 2){
					if(homeLoanService.isValidAppDate(hlDocLandingVm.detail.appDate)){
						hlDocLandingVm.errObj.appDate = homeLoanService.isValidAppDate(hlDocLandingVm.detail.appDate);
					}
				}

				if(hlDocLandingVm.detail.selDoc == 2){
					if(homeLoanService.isValidAppTime(hlDocLandingVm.detail.docPickTime)){
						hlDocLandingVm.errObj.docPickTime = homeLoanService.isValidAppTime(hlDocLandingVm.detail.docPickTime);
					}
				}

				

				return (angular.equals({}, hlDocLandingVm.errObj)) ? true : false;
			}


			
			hlDocLandingVm.goToHome = function(){
				$state.go('menu.homeScreen')
			}

			$scope.$on('$ionicView.loaded', function () {
				
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				initPage();
			});

			return this;
		}

		
]);


