'use strict';
angularApp.controller('hlDocUploadController', [
		"$state",
		"$scope",
		"$filter",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"customerInfoService",
		"homeLoanService",
		"openUrlInAppbroswerService",
		"irctcService",
		function($state, $scope,$filter, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate,customerInfoService,homeLoanService,openUrlInAppbroswerService,irctcService) {
			
			var hlDocUploadVm = this;
			
			function initPage() {
				hlDocUploadVm.listOfDocuments = homeLoanService.userMaster.master.documentTypes;
				hlDocUploadVm.listOfIncomeDocuments = homeLoanService.listOfIncomeDocuments;
				hlDocUploadVm.myDoc = homeLoanService.myDoc;
				hlDocUploadVm.checkAllDocuments();
			}

			hlDocUploadVm.skipUpload = function(){
				//homeLoanService.docSubmitType = 1;
				$state.go('menu.hlDocLanding');
				//$state.go('menu.hlProcessFee');
			}

			hlDocUploadVm.gotoUpload = function(docType,index){
				homeLoanService.uploadType = docType;
				homeLoanService.index = index;
				homeLoanService.listOfIncomeDocuments = hlDocUploadVm.listOfIncomeDocuments;
				$state.go('menu.hlAddDocument');
			}

			hlDocUploadVm.gotoRemove = function(item,selIndex){
				var obj = {
				  "loanType": homeLoanService.getGroupId(),
				  "docName": item.docName
				};

				homeLoanService.deleteDocument(obj).then(function(data) {

					if(data.doclist)
					{
					hlDocUploadVm.listOfIncomeDocuments = data.doclist;
				   }

				   else
				   {
				   	hlDocUploadVm.listOfIncomeDocuments=[];
				   }
				   homeLoanService.listOfIncomeDocuments=data.doclist;
					hlDocUploadVm.checkAllDocuments();
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			hlDocUploadVm.checkAllDocuments = function(){
				var isValidDoc = hlDocUploadVm.listOfIncomeDocuments;
				var allDocCheck = [];
				for(var i=0;i<isValidDoc.length;i++){
					if(allDocCheck.indexOf(isValidDoc[i].category) === -1){
						allDocCheck.push(isValidDoc[i].category);
					}
				}
				if(allDocCheck.length == hlDocUploadVm.listOfDocuments.length){
					hlDocUploadVm.disbaleUpdate = false;
				}else{
					hlDocUploadVm.disbaleUpdate = true;
				}
			}

			
			hlDocUploadVm.goBack = function(){
				$ionicHistory.goBack(-1);
				homeLoanService.getApplicationDetails().doclist = homeLoanService.listOfIncomeDocuments;
			}

			hlDocUploadVm.goToNextPage = function(){
				var isValidDoc = hlDocUploadVm.listOfIncomeDocuments;
				var allDocCheck = [];
				for(var i=0;i<isValidDoc.length;i++){
					if(allDocCheck.indexOf(isValidDoc[i].category) === -1){
						allDocCheck.push(isValidDoc[i].category);
					}
				}
				var obj = {
				  "loanType": homeLoanService.getGroupId()
				};

				if(allDocCheck.length == hlDocUploadVm.listOfDocuments.length){
					//make service call
					homeLoanService.finishDocUpload(obj).then(function(data) {
						$state.go('menu.hlDocUploadSuccess');					
					},function(error){
						utilityService.showErrorMessage(error.responseMessage);
					});
				}else{
					//show error message
					utilityService.showErrorMessage("Please upload all types of documents.");
				}

				

				
			}

			$scope.$on('$ionicView.loaded', function () {
				
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				initPage();
			});

			return this;
		}

		
]);


