'use strict';
angularApp.controller('hlProcessFeeController', [
		"$state",
		"$scope",
		"$filter",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"customerInfoService",
		"homeLoanService",
		"openUrlInAppbroswerService",
		"irctcService",
		function($state, $scope,$filter, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate,customerInfoService,homeLoanService,openUrlInAppbroswerService,irctcService) {
			
			var hlProcessFeeVm = this;
			
			function initPage() {
				
				hlProcessFeeVm.appDetail = homeLoanService.getApplicationDetails();
				hlProcessFeeVm.detail = hlProcessFeeVm.appDetail.processingFeeBreakup;
				hlProcessFeeVm.totalFee = hlProcessFeeVm.detail.processingFee;
				hlProcessFeeVm.appointmentDetails = homeLoanService.appointmentDetails;
			}

			hlProcessFeeVm.homeLoanTNC = function(){
				var request = {
					"type": "homeLoanPayment"
				};				

				homeLoanService.getTermsAndCondition(request).then(function(data) {
						var titlePopup = "Payment Terms";
						
						var buttontext = "OK";
						var blankdata = null;
						var detail = $filter('ngBindHtmlFilter')(data);
						var tncStatus = $ionicPopup.show({
	                      title: titlePopup,
	                      cssClass: 'ftandcpopup-body popupBackgroundWhite popupWidth90  popupBackgroundDark',
	                      template: data,
	                      scope: $scope,
	                      buttons: [

	                          {
	                              text: '<b>OK</b>',
	                              type: 'button-positive',
	                              onTap: function(e) {
	                                  tncStatus.close();
	                              }
	                          }
	                      ]
	                  });
						//utilityService.showAlertModal(title, detail, blankdata, blankdata, $state, buttontext);
					},function(error){
						utilityService.showErrorMessage(error.responseMessage);
					});
			}


			hlProcessFeeVm.goBack = function(){
				$ionicHistory.goBack(-1);
			}

			hlProcessFeeVm.goToNextPage = function(){
				//service call for confirm appoitment
				var obj = {};
				if(hlProcessFeeVm.appointmentDetails.selDoc == 1){
					var submissionDate = hlProcessFeeVm.appointmentDetails.startDateWithFormat +" " + "11:00am";
					obj = {
					  "loanType": homeLoanService.getGroupId(),
					  "appointmentDateTime": submissionDate,
					  "appointmentAddress": null
					};
				}else if(hlProcessFeeVm.appointmentDetails.selDoc == 2){
					var submissionDate = hlProcessFeeVm.appointmentDetails.startDateWithFormat +" " + hlProcessFeeVm.appointmentDetails.docPickTime.key;
					obj = {
					  "loanType": homeLoanService.getGroupId(),
					  "appointmentDateTime": submissionDate
					};
					var addressObj = {};
					if(hlProcessFeeVm.appointmentDetails.selectedPrefBranch == 1){
						addressObj = hlProcessFeeVm.appointmentDetails.addObj;
						obj.appointmentAddress = {
							"addressLine1": addressObj.addressLine1,
						    "addressLine2": addressObj.addressLine2,
						    "addressLine3": addressObj.addressLine3,
						    "districtCode": addressObj.districtCode,
						    "cityCode": addressObj.cityCode,
						    "stateCode": addressObj.stateCode,
						    "districtText": addressObj.districtText,
						    "cityText": addressObj.cityText,
						    "stateText": addressObj.stateText,
						    "pincode": addressObj.pincode
						}
					}else{
						addressObj = hlProcessFeeVm.appointmentDetails.addObjProp;
						obj.appointmentAddress = {
							"addressLine1": addressObj.propertyAddressline1,
						    "addressLine2": addressObj.propertyAddressline2,
						    "addressLine3": "",
						    "districtCode": "",
						    "cityCode": addressObj.city,
						    "stateCode": addressObj.state,
						    "districtText": "",
						    "cityText": addressObj.cityText,
						    "stateText": addressObj.stateText,
						    "pincode": addressObj.pincode
						}
					}
					

				}
				hlProcessFeeVm.schedulePickupAppointment(obj);
				//$state.go('menu.hlConfirmSchedule');
			}

			hlProcessFeeVm.schedulePickupAppointment = function(request){
				homeLoanService.setAppointment(request).then(function(data) {
					if(hlProcessFeeVm.appointmentDetails.selDoc == 1){
					//call branch details
						var payload = {
						  "locality": hlProcessFeeVm.appDetail.selectedBranchCode
						};

						homeLoanService.getBranchDetails(payload).then(function(data) {
							homeLoanService.docSubmitBranch = data.branches[0];
							$state.go('menu.hlConfirmSchedule');
						},function(error){
							utilityService.showErrorMessage(error.responseMessage);
						});
					}else if(hlProcessFeeVm.appointmentDetails.selDoc == 2){
						homeLoanService.pickUpContactDetails = data;
						$state.go('menu.hlConfirmSchedule');
					}
					
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			$scope.$on('$ionicView.loaded', function () {
				
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				initPage();
			});

			return this;
		}

		
]);


