'use strict';
angularApp.controller('editProductController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"validateService",
		"$filter","$interval",
		"homeLoanService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate,validateService,$filter,$interval,homeLoanService) {
			
			var editProductVm = this;
			
			function initPage() {
				// editProductVm.calculateEmiResponse = {
				// 	"minLoanAmt": "1",
				// 	"maxLoanAmt": "594000",
				// 	"minTenure": "1",
				// 	"maxTenure": "360",
				// 	"emi": "4525.32",
				// 	"emiPermissibleFlag": "Y",
				// 	"rate": "8.4",
				// 	"amount": {
				// 		"min": 1,
				// 		"max": 594000,
				// 		"step": 10000,
				// 		"initial": 100000
				// 	},
				// 	"tenure": {
				// 		"min": 1,
				// 		"max": 360,
				// 		"step": 1,
				// 		"initial": 15
				// 	}
				// };
				// homeLoanService.setEmiResponse(editProductVm.calculateEmiResponse);
				editProductVm.productResponse = homeLoanService.editProduct;
				editProductVm.maxTenure = homeLoanService.getRecommendedResponse().tenure;
				//editProductVm.calculateEmiResponse = homeLoanService.getEmiResponse();
				//editProductVm.emiAmount = parseInt(homeLoanService.getEmiResponse().emi);
				var rupeeSymbol = String.fromCharCode(8377);
				editProductVm.detail = {};
				//editProductVm.disableBackButton = homeLoanService.disableBackButton;
				editProductVm.detail.interestRate = parseFloat(editProductVm.productResponse.intrates.intrate[0].rate);

				editProductVm.amountSlider = {
                    value: parseInt(editProductVm.productResponse.intrates.intrate[0].toloanamount),
                    options: {
                    	showSelectionBar: true,
                    	floor : parseInt(editProductVm.productResponse.intrates.intrate[0].fromloanamount),
						ceil : parseInt(editProductVm.productResponse.intrates.intrate[0].toloanamount),
						step : 1,
						onChange : function(id,model){
							editProductVm.emiCalculation();
						},
						translate : function(value){
							return rupeeSymbol + $filter('INR')(value);
						}
                    }
                };


				editProductVm.tenureSlider = {
                    value: parseInt(editProductVm.maxTenure),
                    options: {
                    	showSelectionBar: true,
                    	floor :  parseInt(editProductVm.productResponse.emis.emi[0].fromTenure),
						ceil :  parseInt(editProductVm.maxTenure),
						step :  1,
						onChange : function(id,model){
							editProductVm.emiCalculation();
						},
						translate : function(value){
							return  value + " Months";
						}	
                    }
                };

                if(editProductVm.productResponse.emis.emi.length < 2){
                	editProductVm.emiCalculation();
					var p = parseInt(editProductVm.productResponse.intrates.intrate[0].toloanamount);
					var i = (editProductVm.detail.interestRate/1200);
					var t = parseInt(editProductVm.productResponse.emis.emi[0].toTenure);
					var numerator = p * i * Math.pow((1+i),t);
					var denominator = Math.pow((1+i),t) - 1;
					editProductVm.emiMaxAmount = Math.ceil((numerator/denominator));
                }

			};

			$scope.$on('$ionicView.loaded', function () {
				
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				initPage();
			});

			editProductVm.goToNext = function(){
				var request = {
					"loanType": homeLoanService.getGroupId(),
					"productcode": editProductVm.productResponse.productcode,
					"loanAmount": editProductVm.amountSlider.value.toString(),
					"tenure": editProductVm.tenureSlider.value.toString()
				};
				homeLoanService.getRecommendedProduct(request).then(function(data) {
					if(data.cirResult == "Y"){
						homeLoanService.setRecommendedResponse(data);
						$state.go('menu.recommendProduct');
					}else {
						utilityService.showErrorMessage("Application check still in progress.");
					}
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});
							
			}

			editProductVm.goBack = function(){
				$ionicHistory.goBack(-1);
			}

			editProductVm.emiCalculation = function(){
				var p = editProductVm.amountSlider.value;
				var i = (editProductVm.productResponse.intrates.intrate[0].rate/1200);
				var t = editProductVm.tenureSlider.value;
				var numerator = p * i * Math.pow((1+i),t);
				var denominator = Math.pow((1+i),t) - 1;
				editProductVm.emiAmount = Math.ceil((numerator/denominator));
			}

			return this;
		}

		
]);


