'use strict';
angularApp.controller('hlRefNumberController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"customerInfoService",
		"homeLoanService",
		"openUrlInAppbroswerService",
		"irctcService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate,customerInfoService,homeLoanService,openUrlInAppbroswerService,irctcService) {
			
			var hlRefNumberVm = this;
			
			function initPage() {
				hlRefNumberVm.crmDetails = {};
				hlRefNumberVm.applicationRef = homeLoanService.getConfirmProduct().yonoRef ?  homeLoanService.getConfirmProduct().yonoRef : "HLY**********";
				hlRefNumberVm.listOfDocuments = ["Agreement for Sale","Index 2","Allotment Letter","NOC for Builder (SBI format)","NOC for Project Finance","Aadhaar Copy"];
				
				if(homeLoanService.getConfirmProduct().crmAssignedName){
					hlRefNumberVm.crmDetails.crmAssignedName = homeLoanService.getConfirmProduct().crmAssignedName;
					hlRefNumberVm.crmDetails.crmAssignedNumber = homeLoanService.getConfirmProduct().crmAssignedNumber;
				}else{
					hlRefNumberVm.crmDetails = homeLoanService.getCRMData();
				}
				
				hlRefNumberVm.isProperty = homeLoanService.isPropertyIdentified;			

			};

			hlRefNumberVm.emailLetter = function(){


			}

			hlRefNumberVm.goToAccOverview = function(){
				$state.go('menu.accountOverviewMyBalance');
			}

			hlRefNumberVm.uploadDoc = function(){
				homeLoanService.getApplication().then(function(data) {
					homeLoanService.setApplicationDetails(data);
					homeLoanService.appointmentDetails = {};
					var obj = {
						"propLocation":data.propertyDetails.city,
						"addLocation":JSON.parse(data.applicants[0].address[0].cityText).value,
					};
					homeLoanService.docLandingLocation = obj;
					$state.go('menu.hlDocLanding');
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});
				
			}

			hlRefNumberVm.downloadLetter = function(isEmail){
				var payload = {};
				if(!isEmail){
					payload = {
					  "isEmail": false,
					  "type": "inprinciple"
					};
				}else{
					payload = {
					  "isEmail": true,
					  "type": "inprinciple"
					};
				}
				 

				homeLoanService.getDocument(payload).then(function(data) {

					if(!isEmail)
	                  {
			            var filename =  data.fileName+'.pdf';
			            var content =  data.pdf;
						var contentType = "application/pdf";
						if(utilityService.isAndroidPlatform()){
							hlRefNumberVm.android = true;

							hlRefNumberVm.folderpath = cordova.file.externalRootDirectory;
						}
						if(utilityService.isIOSPlatform()){
							hlRefNumberVm.folderpath = cordova.file.applicationDirectory;
						}
						 irctcService.savebase64AsPDF(hlRefNumberVm.folderpath,filename,content,contentType);
						if(utilityService.isIOSPlatform()){
						var finalObject = {"folderpath":hlRefNumberVm.folderpath,"filename":filename};
						openUrlInAppbroswerService.openUrl("data:application/pdf;base64,"+content+"","");
						}
						if(hlRefNumberVm.android) {
							var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="DOWNLOADFDRECEIPT" translate-values="{folderpath:hlRefNumberVm.folderpath}"></div>';
				    			hlRefNumberVm.downloadPopup = $ionicPopup.show({
				    				title: '',
				    				template: template,
				    				scope: $scope,
				    				cssClass: 'my-custom-popup',
				    				buttons: [{
				    					text:'OK',
				    					type: 'button-assertive',
				    					onTap: function() { 
				    						hlRefNumberVm.downloadPopup.close();

				    					}
				    				}],
				    			});
						
						}
						hlRefNumberVm.successPopup.close();
					}
					else
                        {
                        	var alertPopup = $ionicPopup.alert({
								template: "<p style='text-align:center;font-weight:bold;font-size:16px'>Email has been sent successfully</p>"
							});
                        }
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});

			}

			hlRefNumberVm.goToHome = function(){
				$state.go('menu.homeScreen')
			}

			$scope.$on('$ionicView.loaded', function () {
				
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				initPage();
			});

			return this;
		}

		
]);


