'use strict';
angularApp.controller('hlSelectBranchController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"customerInfoService",
		"homeLoanService",
		"getAccountDetailsService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate,customerInfoService,homeLoanService,getAccountDetailsService) {
			
			var hlSelectBranchVm = this;


			
			function initPage() {
				hlSelectBranchVm.homeBranchesAC = [];
				hlSelectBranchVm.homeBranches = [];
				hlSelectBranchVm.branchesByLocation = [];
				hlSelectBranchVm.selTab ='B';
				hlSelectBranchVm.selectedIndex = 0 ;
				hlSelectBranchVm.selectedIndexLocation = null;//hlSelectBranchVm.homeBranches
				hlSelectBranchVm.loadState();

				// if (getAccountDetailsService.accountOverviewData) {
	   //              var arr = getAccountDetailsService.accountOverviewData.accounts;
	   //              for (var i = 0; i < arr.length; i++) {
	   //                  hlSelectBranchVm.homeBranchesAC.push(arr[i].branchCode);	 
	   //              }  
	   //          }

	            hlSelectBranchVm.homeBranchesAC.push(homeLoanService.homeBranch);

	            //hlSelectBranchVm.homeBranchesAC = hlSelectBranchVm.removeDuplicate(hlSelectBranchVm.homeBranchesAC);

	            for(var i = 0;i< hlSelectBranchVm.homeBranchesAC.length;i++){
	            	var request = {
					  "locality": hlSelectBranchVm.homeBranchesAC[i]
					};

					homeLoanService.getBranchDetails(request).then(function(data) {
						hlSelectBranchVm.homeBranches.push(data.branches[0]);
						
					},function(error){
						utilityService.showErrorMessage(error.responseMessage);
					});
	            }



				

				hlSelectBranchVm.selectedBranch = "Branch";
				hlSelectBranchVm.alphabets = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
			};

			hlSelectBranchVm.getHomeBranch = function(selIndex){
				hlSelectBranchVm.selectedIndex = selIndex;
			}

			hlSelectBranchVm.getLocationBranch = function(selIndex){
				hlSelectBranchVm.selectedIndexLocation = selIndex;
			}

			

			hlSelectBranchVm.removeDuplicate = function(arr){
				var uniqArr = [];
				for (var i =0;i<arr.length;i++) {
					if(uniqArr.indexOf(arr[i]) == -1){
						uniqArr.push(arr[i]);
					}
				}
				return uniqArr;
			}

			hlSelectBranchVm.loadState = function(){
				var request = {
				  "masterId": [
				    "HL_Branch"
				  ]
				};
				homeLoanService.getStateForBranch(request).then(function(data) {
					hlSelectBranchVm.locationStates = data.branch;
					
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});

			}

			hlSelectBranchVm.loadDistrict = function(){
				//hlSelectBranchVm.locationState
				var request = {
				  "masterId": [
				    "HL_Branch"
				  ],
				  "stateCode": hlSelectBranchVm.locationState.stateCode
				};
				homeLoanService.getDistrictForBranch(request).then(function(data) {
					hlSelectBranchVm.locationDistricts = data.branch;
					
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});

			}

			hlSelectBranchVm.loadCity = function(){
				var request = {
				  "masterId": [
				    "HL_Branch"
				  ],
				  "districtName": hlSelectBranchVm.locationDistrict.district
				};
				homeLoanService.getCityForBranch(request).then(function(data) {
					var cities = data.branch;
					for(var i=0;i<cities.length;i++){
						if(cities[i].city==""){
							cities[i].city = "Others";
						}
					}
					hlSelectBranchVm.locationCities = cities;
					
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});

			}

			hlSelectBranchVm.loadBranchByLocation = function(){
				hlSelectBranchVm.expandLocationByBranch();
				hlSelectBranchVm.branchesByLocation = [];
				hlSelectBranchVm.selectedIndexLocation = null;
				var request ={
				  "masterId": [
				    "HL_Branch"
				  ],
				  "districtName": hlSelectBranchVm.locationDistrict.district,
				  "cityName": hlSelectBranchVm.locationCity.city
				};

				homeLoanService.getBranchForLocations(request).then(function(data) {
					hlSelectBranchVm.branchesByLocation = data.branch;
					
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});

			}

			hlSelectBranchVm.expandLocationByBranch = function(){
				hlSelectBranchVm.isLocationByBranch = !hlSelectBranchVm.isLocationByBranch;
			}

			

			hlSelectBranchVm.selType = function(recFlag){
				if(recFlag == 'B'){
					//By Branch
					hlSelectBranchVm.selTab = 'B';
				}else{
					//By Pincode
					hlSelectBranchVm.selTab = 'A';
				}
			}

			hlSelectBranchVm.goToNextPage = function(){
				var branchCode = hlSelectBranchVm.selTab == 'B' ? hlSelectBranchVm.homeBranches[hlSelectBranchVm.selectedIndex].id : hlSelectBranchVm.branchesByLocation[hlSelectBranchVm.selectedIndexLocation].branchCode;

				var confirmProduct = {
					"loanType": homeLoanService.getGroupId(),
					"productName": homeLoanService.getSelectedProduct().productName,
					"productCode": homeLoanService.getSelectedProduct().productCode,
					"topupProductName": homeLoanService.getSelectedProductTopup() ? homeLoanService.getSelectedProductTopup().productName : "",
					"topupProductCode": homeLoanService.getSelectedProductTopup() ? homeLoanService.getSelectedProductTopup().productCode : "",
					"branchCode": branchCode
				}
				homeLoanService.confirmProduct(confirmProduct).then(function(data) {
					utilityService.setCsatJournies('homeloan');
					homeLoanService.setConfirmProduct(data);
					$state.go('menu.homeLoanRefNo');
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			hlSelectBranchVm.goBack = function() {
	            $ionicHistory.goBack(-1);
	           
	        }
			
			$scope.$on('$ionicView.loaded', function () {
				
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				initPage();
			});

			return this;
		}

		
]);


