'use strict';
angularApp.controller('loanCaculatorController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"$filter",
		"homeLoanService",
		"lifeInsuranceBasicApplicationService",
		"ompMerchantsService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate,$filter,homeLoanService,lifeInsuranceBasicApplicationService,ompMerchantsService) {
			
			var loanCaculatorVm = this;
			
			loanCaculatorVm.initPage = function () {
				if(homeLoanService.getButtonText()){
					loanCaculatorVm.buttonText = homeLoanService.getButtonText()
				}
				
				loanCaculatorVm.homeLoanDetails = homeLoanService.getLoanDetails().getLoansDetails;
				loanCaculatorVm.eligibity = loanCaculatorVm.homeLoanDetails.eligibilty;
				loanCaculatorVm.features = loanCaculatorVm.homeLoanDetails.process;
				loanCaculatorVm.emiAmount = 0;
				loanCaculatorVm.tabOne = "single";
				var rupeeSymbol = String.fromCharCode(8377);
				loanCaculatorVm.amountSlider = {
                    value: loanCaculatorVm.homeLoanDetails.amount.initial,
                    options: {
                    	showSelectionBar: true,
                    	floor : loanCaculatorVm.homeLoanDetails.amount.min,
						ceil : loanCaculatorVm.homeLoanDetails.amount.max,
						step : loanCaculatorVm.homeLoanDetails.amount.step,
						onChange : function(id,model){
							//loanCaculatorVm.interestValue = $filter('percent')(loanCaculatorVm.interestSlider.value);
							loanCaculatorVm.emiCalculation();
						},
						translate : function(value){
							return rupeeSymbol + $filter('INR')(value);
						}
                    }
                };			

				loanCaculatorVm.tenureSlider = {
                    value: loanCaculatorVm.homeLoanDetails.tenure.initial,
                    options: {
                    	showSelectionBar: true,
                    	floor : loanCaculatorVm.homeLoanDetails.tenure.min,
						ceil : loanCaculatorVm.homeLoanDetails.tenure.max,
						step : loanCaculatorVm.homeLoanDetails.tenure.step,
						onChange : function(id,model){
							loanCaculatorVm.emiCalculation();
						},
						translate : function(value){
							return  value + " Months";
						}	
                    }
                };
			//	loanCaculatorVm.interestValue = $filter('percent')(loanCaculatorVm.interestSlider.value);
				loanCaculatorVm.emiCalculation();
			}
			
			$scope.$on('$ionicView.loaded', function () {
				
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				loanCaculatorVm.initPage();
			});

			loanCaculatorVm.emiCalculation = function(){
				var range = homeLoanService.getLoanDetails().loanDetails;
				var p = loanCaculatorVm.amountSlider.value;
				for(var i = 0; i < range.length ; i++){
					if(range[i].minLaonAmount <= p  && range[i].maxLaonAmount >= p){
						loanCaculatorVm.interestRate = range[i].intRate;
						break;
					}
				}
				var i = (loanCaculatorVm.interestRate/1200) ;
				var t = loanCaculatorVm.tenureSlider.value;
				var numerator = p * i * Math.pow((1+i),t);
				var denominator = Math.pow((1+i),t) - 1;
				loanCaculatorVm.emiAmount = Math.ceil((numerator/denominator));				
			}

			loanCaculatorVm.tabClicked = function (id) {
				if(id == '2'){
					loanCaculatorVm.tabOne = "multiple";
				}else if(id == '1'){
					loanCaculatorVm.tabOne = "single";
				}else if(id == '3'){
					loanCaculatorVm.tabOne = "three";
				}
				
			}

			// loanCaculatorVm.calculateEmi = function(){
			// 	//loanCaculatorVm.interestSlider.value = loanCaculatorVm.interestValue.replace(/[^0-9\s]/g, '');
			// //	loanCaculatorVm.interestValue = $filter('percent')(loanCaculatorVm.interestSlider.value);
			// }

			loanCaculatorVm.setMax = function(field,value){
				// if(field== "interestValue"){
				// 	loanCaculatorVm.interestValue = loanCaculatorVm.interestValue.replace(/[^0-9\s]/g, '');
				// 	if(parseInt(loanCaculatorVm.interestValue) > parseInt(value)){
				// 		loanCaculatorVm.interestValue = value+"";
				// 	}else if(parseInt(loanCaculatorVm.interestValue) < loanCaculatorVm.homeLoanDetails.rateOfIntrest.min){
				// 		loanCaculatorVm.interestValue = loanCaculatorVm.homeLoanDetails.rateOfIntrest.min+"";
				// 	}
				// }

				if(field == "tenure"){
					value = loanCaculatorVm.homeLoanDetails.tenure.max;
					if(parseInt(loanCaculatorVm.tenureSlider.value) > parseInt(value)){
						loanCaculatorVm.tenureSlider.value = value + "";
					}else if(parseInt(loanCaculatorVm.tenureSlider.value) == 0){
						loanCaculatorVm.tenureSlider.value = 1;
					}
				}
				if(field == "loan"){
					value = loanCaculatorVm.homeLoanDetails.amount.max;
					if(parseInt(loanCaculatorVm.amountSlider.value) > parseInt(value)){
						loanCaculatorVm.amountSlider.value = value + "";
					}
				}
				loanCaculatorVm.emiCalculation();
			}

			loanCaculatorVm.goToBack = function(){
				$ionicHistory.goBack(-1);
			}

			loanCaculatorVm.goToNext = function(){
				var request = {
					"loanType" : "home"
				}
				if(homeLoanService.getYonoDedupeData().status == '0' && homeLoanService.getYonoDedupeData().takeOverStatus == '0'){
					// homeLoanService.clearAll();
					homeLoanService.getEligiblityCheck(request).then(function(data) {
						homeLoanService.userMaster = data;
						homeLoanService.homeBranch = data.homeBranch;
						homeLoanService.setGroupId(request.loanType);
						if(data.status == "HL02"){
							homeLoanService.dedupErrors = data.reasons;
							$state.go('menu.homeLoanError');
						}else if(data.status =="0000"){
							$state.go('menu.homeLoanPersonalDetails');
						}else if(data.status == "HL03"){
							homeLoanService.multipleAppErrors = data;
							homeLoanService.isMultipleLOS = true;
							$state.go('menu.homeLoanRetApp');
						}
					},function(error){
						utilityService.showErrorMessage(error.responseMessage);
					});
				}else{
					homeLoanService.getLosDedupe(request).then(function(data) {
						homeLoanService.setLosDedupeData(data);
						$state.go('menu.homeLoanRetApp');
					},function(error){
						utilityService.showErrorMessage(error.responseMessage);
					});
				}	
			}

			loanCaculatorVm.openUrl = function(){
				var id = "home";
				lifeInsuranceBasicApplicationService.getHomeLoanRedirection1(id).then(function(response) {
					ompMerchantsService.inAppBrowser(response.url);
				}, function(error) { 
					utilityService.showErrorMessage(error.responseMessage);
				});	
			}
			

			return this;
		}

		
]);


