'use strict';
angularApp.controller('personalDetailsControllerHL', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"$ionicScrollDelegate",
		"customerInfoService",
		"homeLoanService",
		"validateService",
		"requestChequeBookService","generalInsurenceHomeService","$filter",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate,$ionicScrollDelegate,customerInfoService,homeLoanService,validateService,requestChequeBookService,generalInsurenceHomeService,$filter) {
			
			var personalDetailsVm = this;
			personalDetailsVm.detail = {};
			
			function initPage() {
				personalDetailsVm.masterData = homeLoanService.userMaster;
				personalDetailsVm.genderMaster = personalDetailsVm.masterData.master.genders;
				personalDetailsVm.addressMaster = personalDetailsVm.masterData.master.addressTypes;
				personalDetailsVm.martialStatus = personalDetailsVm.masterData.master.maritalStatuses;
				personalDetailsVm.states = personalDetailsVm.masterData.master.states;
				personalDetailsVm.isMasked = true;
				personalDetailsVm.emailInputType = "password";
				personalDetailsVm.inputImg = "img/Visibility_off.svg";
				personalDetailsVm.emailInputImg = "img/Visibility_off.svg";
				personalDetailsVm.districts = [];
				personalDetailsVm.subDistrict = [];
				personalDetailsVm.villageTown = [];
				personalDetailsVm.cities =[];
				personalDetailsVm.currentCities = [];
				personalDetailsVm.currentDistricts = [];
				personalDetailsVm.currentSubDistricts = [];
				personalDetailsVm.currentVillage = [];
				personalDetailsVm.isMaskPan = true;
				personalDetailsVm.isMaskAd = true;
				if(homeLoanService.getPersonalPrimaryDetails()){
					personalDetailsVm.detail = homeLoanService.getPersonalPrimaryDetails();
					personalDetailsVm.masterData.aadhaar = homeLoanService.getPersonalPrimaryDetails().aadhaar;
					personalDetailsVm.masterData.pan = homeLoanService.getPersonalPrimaryDetails().pan;
					personalDetailsVm.districts.push(personalDetailsVm.detail.district);
					personalDetailsVm.subDistrict.push(personalDetailsVm.detail.subDistrict);
					personalDetailsVm.cities.push(personalDetailsVm.detail.city);
					personalDetailsVm.villageTown.push(personalDetailsVm.detail.villageTown);
					if(personalDetailsVm.detail.currentCity){
						personalDetailsVm.currentCities.push(personalDetailsVm.detail.currentCity);
					}
					if(personalDetailsVm.detail.currentDistrict){
						personalDetailsVm.currentDistricts.push(personalDetailsVm.detail.currentDistrict);
					}
					if(personalDetailsVm.detail.currentSubDistrict){
						personalDetailsVm.currentSubDistricts.push(personalDetailsVm.detail.currentSubDistrict);
					}
					if(personalDetailsVm.detail.currentVillage){
						personalDetailsVm.currentVillage.push(personalDetailsVm.detail.currentVillage);
					}
					

				}else{
					//personalDetailsVm.detail.residenceType = personalDetailsVm.masterData.master.addressTypes[0].key;
					personalDetailsVm.detail.title = homeLoanService.findObject(personalDetailsVm.masterData.title, homeLoanService.userMaster.master.titles);
					personalDetailsVm.detail.currentAddressCheck = true;
					for(var i=0;i<personalDetailsVm.genderMaster.length;i++){
						if(personalDetailsVm.genderMaster[i].key == personalDetailsVm.masterData.gender){
							personalDetailsVm.detail.gender = personalDetailsVm.genderMaster[i];
							
						}
					}

					if(personalDetailsVm.detail.title.value){
						personalDetailsVm.detail.custName = personalDetailsVm.detail.title.value+ ' ' + personalDetailsVm.masterData.firstName+' ' + personalDetailsVm.masterData.lastName;
					}else{
						personalDetailsVm.detail.custName = personalDetailsVm.masterData.firstName+' ' + personalDetailsVm.masterData.lastName;
					}
					
					personalDetailsVm.detail.custNameFull = personalDetailsVm.masterData.firstName+' ' + personalDetailsVm.masterData.lastName;
					personalDetailsVm.detail.firstName = personalDetailsVm.masterData.firstName;
					personalDetailsVm.detail.lastName = personalDetailsVm.masterData.lastName;
					personalDetailsVm.detail.fatherName = personalDetailsVm.masterData.fatherName;
					personalDetailsVm.detail.motherMaidenName = personalDetailsVm.masterData.motherMaidenName;
					
					personalDetailsVm.detail.dob = personalDetailsVm.masterData.dob;
					var age = generalInsurenceHomeService.calculateAge(new Date(),$filter('homeDateFormat')(personalDetailsVm.detail.dob));
					if(age >= 18 && age < 70){
						homeLoanService.setIsSkipRequired(true);
					}else{
						homeLoanService.setIsSkipRequired(false);
					}

					personalDetailsVm.isMaskPan = true;
					personalDetailsVm.detail.pan = personalDetailsVm.masterData.pan;

					personalDetailsVm.isMaskAd = true;
					personalDetailsVm.detail.aadhaar = personalDetailsVm.masterData.aadhaar;

					personalDetailsVm.detail.email = personalDetailsVm.masterData.email;
					personalDetailsVm.detail.address = personalDetailsVm.masterData.permanentAddress.addressLine1+' '+personalDetailsVm.masterData.permanentAddress.addressLine2+' ' +personalDetailsVm.masterData.permanentAddress.addressLine3;
					personalDetailsVm.detail.permanentAddressLine1 = personalDetailsVm.masterData.permanentAddress.addressLine1;
					personalDetailsVm.detail.permanentAddressLine2 = personalDetailsVm.masterData.permanentAddress.addressLine2;
					personalDetailsVm.detail.permanentAddressLine3 = personalDetailsVm.masterData.permanentAddress.addressLine3;
					personalDetailsVm.detail.mobile = personalDetailsVm.masterData.mobile ? personalDetailsVm.masterData.mobile : "";
					personalDetailsVm.detail.alternateContact = personalDetailsVm.masterData.alternateContact ? personalDetailsVm.masterData.alternateContact : "";
					if(personalDetailsVm.masterData.permanentAddress.pincode){
						personalDetailsVm.detail.pincode = personalDetailsVm.masterData.permanentAddress.pincode;
						//personalDetailsVm.detail.address = personalDetailsVm.detail.address + '-'+ personalDetailsVm.detail.pincode;
						//personalDetailsVm.getCityState(personalDetailsVm.masterData.permanentAddress.pincode,"P");
						
					}
				}

				if(homeLoanService.getEducationMaster()){
					personalDetailsVm.eduQualification = homeLoanService.getEducationMaster();
				}else{
					personalDetailsVm.getEducationQualification();
				}

			};

			personalDetailsVm.showCurrentAddress = function(){
				$ionicScrollDelegate.resize();
			}
			

			personalDetailsVm.maskUnmask = function () {
					personalDetailsVm.isMasked == true ? (personalDetailsVm.isMasked = false , personalDetailsVm.inputImg = "img/Visibility_on.svg") : (personalDetailsVm.isMasked = true , personalDetailsVm.inputImg = "img/Visibility_off.svg");
			};

			personalDetailsVm.emailMaskUnmask = function (param) {
				personalDetailsVm.emailInputType == "password" ? (personalDetailsVm.emailInputType = "text" , personalDetailsVm.emailInputImg = "img/Visibility_on.svg") : (personalDetailsVm.emailInputType = "password" , personalDetailsVm.emailInputImg = "img/Visibility_off.svg");
			};

			personalDetailsVm.getEducationQualification = function (){
				var obj = {};
					homeLoanService.getEducationQualification(obj).then(function(data) {
						personalDetailsVm.eduQualification = data.info;			 
						homeLoanService.setEducationMaster(personalDetailsVm.eduQualification);		
					},function(error){
						utilityService.showErrorMessage(error.responseMessage);
					});
			}

			personalDetailsVm.getCityState = function (pinCode,addType){
				var obj = {
						"pinCode": pinCode
					};
					homeLoanService.getPincodeData(obj).then(function(data) {
						if(addType == "P"){
							personalDetailsVm.detail.address = personalDetailsVm.detail.address +' '+ data.districtName +' '+data.stateName;
							personalDetailsVm.detail.district = data.districtName;
							personalDetailsVm.detail.state = data.stateName;
						}else if(addType == "C"){
							personalDetailsVm.detail.currentCity = data.districtName;
							personalDetailsVm.detail.currentState = data.stateName;
							personalDetailsVm.detail.currentPincode = pinCode;
						}						
					},function(error){
						utilityService.showErrorMessage(error.responseMessage);
					});
			}

			personalDetailsVm.loadCityState = function(){
				if(personalDetailsVm.detail.currentPincode.length == 6){
					personalDetailsVm.getCityState(personalDetailsVm.detail.currentPincode,"C");
				}
			}

			personalDetailsVm.validateForm = function(){
				personalDetailsVm.errObj = {};
				
				// if(personalDetailsVm.detail.currentAddressCheck){
					if(validateService.isValidAlternateContact(personalDetailsVm.detail.alternateContact)){
						personalDetailsVm.errObj.alternateContact = validateService.isValidAlternateContact(personalDetailsVm.detail.alternateContact);
					}
					if(validateService.isValidFatherName(personalDetailsVm.detail.fatherName)){
						personalDetailsVm.errObj.fatherName = validateService.isValidFatherName(personalDetailsVm.detail.fatherName);
					}
					if(validateService.isValidMotherName(personalDetailsVm.detail.motherMaidenName)){
						personalDetailsVm.errObj.motherMaidenName = validateService.isValidMotherName(personalDetailsVm.detail.motherMaidenName);
					}
					if(validateService.isValidEducationQualification(personalDetailsVm.detail.eduQualification)){
						personalDetailsVm.errObj.eduQualification = validateService.isValidEducationQualification(personalDetailsVm.detail.eduQualification);
					}
					if(validateService.isValidEmailHL(personalDetailsVm.detail.email)){
						personalDetailsVm.errObj.email = validateService.isValidEmailHL(personalDetailsVm.detail.email);
					}
					
					if(validateService.isMarritialStatus(personalDetailsVm.detail.maritalStatus)){
						personalDetailsVm.errObj.maritalStatus = validateService.isMarritialStatus(personalDetailsVm.detail.maritalStatus);
					}					
					if(validateService.hlValidState(personalDetailsVm.detail.state)){
						personalDetailsVm.errObj.state = validateService.hlValidState(personalDetailsVm.detail.state);
					}
					if(validateService.hlValidDistrict(personalDetailsVm.detail.district)){
						personalDetailsVm.errObj.district = validateService.hlValidDistrict(personalDetailsVm.detail.district);
					}
					if(validateService.hlValidSubDistrict(personalDetailsVm.detail.subDistrict)){
						personalDetailsVm.errObj.subDistrict = validateService.hlValidSubDistrict(personalDetailsVm.detail.subDistrict);
					}
					if(validateService.hlValidVillage(personalDetailsVm.detail.villageTown)){
						personalDetailsVm.errObj.villageTown = validateService.hlValidVillage(personalDetailsVm.detail.villageTown);
					}
					if(validateService.hlValidCity(personalDetailsVm.detail.city)){
						personalDetailsVm.errObj.city = validateService.hlValidCity(personalDetailsVm.detail.city);
					}

					if(personalDetailsVm.detail.currentAddressCheck){
						if(validateService.isValidResidanceType(personalDetailsVm.detail.residenceType)){
							personalDetailsVm.errObj.residenceType = validateService.isValidResidanceType(personalDetailsVm.detail.residenceType);
						}
						if(validateService.isValidMonthsInResidence(personalDetailsVm.detail.residenceMonth)){
							personalDetailsVm.errObj.residenceMonth = validateService.isValidMonthsInResidence(personalDetailsVm.detail.residenceMonth);
						}
					}
				//}

				if(!personalDetailsVm.detail.currentAddressCheck){
					if (validateService.isValidAdress(personalDetailsVm.detail.addressLine1)) {
						personalDetailsVm.errObj.addressLine1 = validateService.isValidAdress(personalDetailsVm.detail.addressLine1);
					}

					if(validateService.isValidResidanceType(personalDetailsVm.detail.residenceTypeCurrent)){
						personalDetailsVm.errObj.residenceTypeCurrent = validateService.isValidResidanceType(personalDetailsVm.detail.residenceTypeCurrent);
					}

					if(validateService.isValidMonthsInResidence(personalDetailsVm.detail.residenceMonthCurrent)){
						personalDetailsVm.errObj.residenceMonthCurrent = validateService.isValidMonthsInResidence(personalDetailsVm.detail.residenceMonthCurrent);
					}

					// if(validateService.isValidPincode(personalDetailsVm.detail.currentPincode)){
					// 	personalDetailsVm.errObj.currentPincode = validateService.isValidPincode(personalDetailsVm.detail.currentPincode);
					// }
					if(!personalDetailsVm.detail.currentPincode){
						personalDetailsVm.errObj.currentPincode = $translate.instant('HL_ERR_PINCODE');
					}else{
						personalDetailsVm.detail.currentPincode = personalDetailsVm.detail.currentPincode.replace(/ /g,'');
						if(parseInt(personalDetailsVm.detail.currentPincode) < 1 || personalDetailsVm.detail.currentPincode.length != 6){
							personalDetailsVm.errObj.currentPincode = $translate.instant('HL_ERR_VALIDPINCODE');
						}
					}
					if(validateService.hlValidState(personalDetailsVm.detail.currentState)){
						personalDetailsVm.errObj.currentState = validateService.hlValidState(personalDetailsVm.detail.currentState);
					}
					if(validateService.hlValidDistrict(personalDetailsVm.detail.currentDistrict)){
						personalDetailsVm.errObj.currentDistrict = validateService.hlValidDistrict(personalDetailsVm.detail.currentDistrict);
					}
					if(validateService.hlValidSubDistrict(personalDetailsVm.detail.currentSubDistrict)){
						personalDetailsVm.errObj.currentSubDistrict = validateService.hlValidSubDistrict(personalDetailsVm.detail.currentSubDistrict);
					}
					if(validateService.hlValidVillage(personalDetailsVm.detail.currentVillage)){
						personalDetailsVm.errObj.currentVillage = validateService.hlValidVillage(personalDetailsVm.detail.currentVillage);
					}
					if(validateService.hlValidCity(personalDetailsVm.detail.currentCity)){
						personalDetailsVm.errObj.currentCity = validateService.hlValidCity(personalDetailsVm.detail.currentCity);
					}

					
				}



				return (angular.equals({}, personalDetailsVm.errObj)) ? true : false;
			}

			personalDetailsVm.loadDistrict = function(type){
				var masterKey = "";
				if(type == 'district'){
					personalDetailsVm.detail.district = "";
					personalDetailsVm.detail.subDistrict = "";
					personalDetailsVm.detail.villageTown = "";
					personalDetailsVm.detail.city="";
					masterKey = personalDetailsVm.detail.state.key;
				}else if(type == 'subdistrict'){
					personalDetailsVm.detail.subDistrict = "";
					personalDetailsVm.detail.villageTown = "";
					personalDetailsVm.detail.city="";
					masterKey = personalDetailsVm.detail.district.key;
				}else if(type == 'village'){
					personalDetailsVm.detail.villageTown = "";
					personalDetailsVm.detail.city="";
					masterKey = personalDetailsVm.detail.subDistrict.key;
				}else if(type == 'city'){
				personalDetailsVm.detail.city="";
				masterKey = personalDetailsVm.detail.state.key;
			}

				var request = {
				  "key": masterKey,
				  "action": type
				};

				homeLoanService.getDistrictCity(request).then(function(data) {
					if(type == 'district'){
						personalDetailsVm.districts = data.info;
					}else if(type == 'subdistrict'){
						personalDetailsVm.subDistrict = data.info;
					}else if(type == 'village'){
						personalDetailsVm.villageTown = data.info;
					}else if(type == 'city'){
						personalDetailsVm.cities = data.info;
					}
					
					
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			personalDetailsVm.loadDistrictCurrent = function(type){
				var masterKey = "";
				if(type == 'district'){
					personalDetailsVm.detail.currentDistrict = "";
					personalDetailsVm.detail.currentSubDistrict = "";
					personalDetailsVm.detail.currentVillage = "";
					personalDetailsVm.detail.currentCity="";
					masterKey = personalDetailsVm.detail.currentState.key;
				}else if(type == 'subdistrict'){
					personalDetailsVm.detail.currentSubDistrict = "";
					personalDetailsVm.detail.currentVillage = "";
					personalDetailsVm.detail.currentCity="";
					masterKey = personalDetailsVm.detail.currentDistrict.key;
				}else if(type == 'village'){
					personalDetailsVm.detail.currentVillage = "";
					personalDetailsVm.detail.currentCity="";
					masterKey = personalDetailsVm.detail.currentSubDistrict.key;
				}else if(type == 'city'){
					personalDetailsVm.detail.currentCity="";
					masterKey = personalDetailsVm.detail.currentState.key;
				}

				var request = {
				  "key": masterKey,
				  "action": type
				};

				homeLoanService.getDistrictCity(request).then(function(data) {
					if(type == 'district'){
						personalDetailsVm.currentDistricts = data.info;
					}else if(type == 'subdistrict'){
						personalDetailsVm.currentSubDistricts = data.info;
					}else if(type == 'village'){
						personalDetailsVm.currentVillage = data.info;
					}else if(type == 'city'){
						personalDetailsVm.currentCities = data.info;
					}
					
					
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			personalDetailsVm.unmaskData = function(idType){
				var request = {
				  "type": idType
				}
				if(idType == 'pan' || idType == 'aadhaar'){
					homeLoanService.getUnmaskData(request).then(function(data) {
						if (idType =='pan') {
							personalDetailsVm.isMaskPan = false;
							personalDetailsVm.detail.pan = data;
						}else{
							personalDetailsVm.isMaskAd = false;
							personalDetailsVm.detail.aadhaar = data;
						}
						
					},function(error){
						utilityService.showErrorMessage(error.responseMessage);
					});
				}else{
					if(idType == 'npan'){
						personalDetailsVm.isMaskPan = true;
						personalDetailsVm.detail.pan = personalDetailsVm.masterData.pan;
					}else{
						personalDetailsVm.isMaskAd = true;
						personalDetailsVm.detail.aadhaar = personalDetailsVm.masterData.aadhaar;
					}
					
				}
				
			}

			personalDetailsVm.goBack = function() {
				if(homeLoanService.getTakeoverData()){
					if(homeLoanService.getTakeoverData().propertyType){
	           			$state.go('menu.hlTakeoverLoanDetails');
	           		}else{
	           			$state.go('menu.loans');
	           		}
				}else{
	           		$state.go('menu.loans');
	           	}
	        }

			personalDetailsVm.goToNextPage = function(){
				if(personalDetailsVm.validateForm()){
					console.log("success");
					var resiFlag = "";
					if(personalDetailsVm.detail.currentAddressCheck){
						resiFlag = personalDetailsVm.detail.residenceType;
					}else{
						resiFlag = personalDetailsVm.detail.residenceTypeCurrent;
					}
					personalDetailsVm.detail.pan = personalDetailsVm.masterData.pan;
					personalDetailsVm.detail.aadhaar = personalDetailsVm.masterData.aadhaar;
					personalDetailsVm.populateResidenceType(resiFlag); 
					homeLoanService.setPersonalPrimaryDetails(personalDetailsVm.detail);
					$state.go('menu.homeLoanWorkDetails');
				}
				
			}

			personalDetailsVm.populateResidenceType = function(resiFlag){
				
				for(var i = 0;i< personalDetailsVm.addressMaster.length;i++){
					if(personalDetailsVm.addressMaster[i].key == resiFlag.key){
						personalDetailsVm.detail.residenceType = personalDetailsVm.addressMaster[i];
					}
				}
			}

			$scope.$on('$ionicView.loaded', function () {
				//initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				initPage();
			});

			return this;
		}

		
]);


