'use strict';
angularApp.controller('propDetailsHLController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"$ionicScrollDelegate",
		"customerInfoService",
		"validateService",
		"$filter",
		"homeLoanService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker,$ionicSideMenuDelegate,$ionicScrollDelegate,customerInfoService,validateService,$filter,homeLoanService) {
			
			var propDetailsHLVm = this;

			function initPage() {
				propDetailsHLVm.detail = {};
				propDetailsHLVm.errObj = {};
				propDetailsHLVm.masterData = homeLoanService.userMaster;
				propDetailsHLVm.loanPurposes = propDetailsHLVm.masterData.master.propertyTypes;
				propDetailsHLVm.rePaymentTypes = propDetailsHLVm.masterData.master.rePaymentTypes;
				propDetailsHLVm.employmentType = propDetailsHLVm.masterData.master.employmentTypes;
				propDetailsHLVm.loanPurposesDetails = [];
				if(homeLoanService.getPropertiesData()){
					propDetailsHLVm.detail = homeLoanService.getPropertiesData();
				}

				if(homeLoanService.getPrepolpulateWorkDetails()){
					propDetailsHLVm.detail.loanPurpose = homeLoanService.getPrepolpulateWorkDetails().loanPurpose.value;
					for(var i = 0;i<propDetailsHLVm.loanPurposes.length;i++){
						if(propDetailsHLVm.loanPurposes[i].keyMapping.indexOf(homeLoanService.getPrepolpulateWorkDetails().loanPurpose.key) > -1){
							propDetailsHLVm.loanPurposesDetails.push(propDetailsHLVm.loanPurposes[i]);
						}
					}
				}
				
			};

			propDetailsHLVm.validateForm = function(){
				propDetailsHLVm.errObj = {};

				// if(validateService.isValidEmploymentType(propDetailsHLVm.detail.loanPurpose)){
				// 	propDetailsHLVm.errObj.loanPurpose = validateService.isValidEmploymentType(propDetailsHLVm.detail.loanPurpose);
				// }

				if(validateService.isValidEmploymentType(propDetailsHLVm.detail.propertyType)){
					propDetailsHLVm.errObj.propertyType = $translate.instant('HL_ERR_PROPTYPE');
				}

				if(!propDetailsHLVm.detail.propertyValue){
					propDetailsHLVm.errObj.propertyValue = $translate.instant('HL_ERR_PROPVAL');
				}else{
					if(propDetailsHLVm.detail.propertyValue < 1){
						propDetailsHLVm.errObj.propertyValue = $translate.instant('HL_ERR_PROPVAL_VALID');
					}
				}

				if(!propDetailsHLVm.detail.numberOfFloors){
					propDetailsHLVm.errObj.numberOfFloors = $translate.instant('HL_ERR_FLOOR');
				}

				if(!propDetailsHLVm.detail.carpetArea){
					propDetailsHLVm.errObj.carpetArea = $translate.instant('HL_ERR_CARPET');
				}else{
					if(propDetailsHLVm.detail.carpetArea < 1){
						propDetailsHLVm.errObj.carpetArea = $translate.instant('HL_ERR_CARPET_VALID');
					}
				}

				if(propDetailsHLVm.detail.numberOfFloors){
					if(propDetailsHLVm.detail.moratoriumPeriod){
						if(propDetailsHLVm.detail.numberOfFloors < 8){
							if(propDetailsHLVm.detail.moratoriumPeriod > 18){
								propDetailsHLVm.errObj.moratoriumPeriod = $translate.instant('HL_ERR_MORAT') + "18";
							}
							
						}else if(propDetailsHLVm.detail.numberOfFloors < 15 && propDetailsHLVm.detail.numberOfFloors > 7){
							if(propDetailsHLVm.detail.moratoriumPeriod > 24){
								propDetailsHLVm.errObj.moratoriumPeriod =  $translate.instant('HL_ERR_MORAT') + "24";
							}
						}else if(propDetailsHLVm.detail.numberOfFloors < 22 && propDetailsHLVm.detail.numberOfFloors > 14){
							if(propDetailsHLVm.detail.moratoriumPeriod > 30){
								propDetailsHLVm.errObj.moratoriumPeriod =  $translate.instant('HL_ERR_MORAT') + "30";
							}
						}else if(propDetailsHLVm.detail.numberOfFloors > 21){
							if(propDetailsHLVm.detail.moratoriumPeriod > 36){
								propDetailsHLVm.errObj.moratoriumPeriod =  $translate.instant('HL_ERR_MORAT') + "36";
							}
						}
						
					}
				}

				return (angular.equals({}, propDetailsHLVm.errObj)) ? true : false;
			}

			propDetailsHLVm.saveApplication = function(){
				//homeLoanService.setPropertiesData
				var obj = {
				  "propertyIdentify": "Y",
				  "loanPurpose": propDetailsHLVm.detail.loanPurpose,
				  "propertyType": propDetailsHLVm.detail.propertyType,
				  "propertyValue": propDetailsHLVm.detail.propertyValue,
				  "numberOfFloors": propDetailsHLVm.detail.numberOfFloors,
				  "moratoriumPeriod": propDetailsHLVm.detail.moratoriumPeriod,
				  "carpetArea": propDetailsHLVm.detail.carpetArea
				};
				homeLoanService.setPropertiesData(obj);
				homeLoanService.searchPageDetails = {};
				
				$state.go('menu.searchPropHL');

			}

			propDetailsHLVm.validateWorkExp = function(){
				

			}

			propDetailsHLVm.goToNextPage = function(){
				
				if(propDetailsHLVm.validateForm()){
					propDetailsHLVm.saveApplication();
				}
			}

			propDetailsHLVm.goBack = function() {
				if(homeLoanService.getIsCoApplicant()){
					$state.go('menu.coApplicantWorkDetails');
				}else{
					$state.go('menu.addCoApplicant');
				}
	        }
			
			$scope.$on('$ionicView.loaded', function () {
				
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				initPage();
			});
			
		

			return this;
		}

		
]);


