'use strict';
angularApp.controller('searchPropHLController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"$ionicScrollDelegate",
		"customerInfoService",
		"validateService",
		"$filter",
		"homeLoanService",
	"$timeout",
	function ($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, $ionicScrollDelegate, customerInfoService, validateService, $filter, homeLoanService, $timeout) {
			
			var searchPropHLVm = this;

			function initPage() {
				searchPropHLVm.detail={};
				searchPropHLVm.errObj = {};
				searchPropHLVm.detail = homeLoanService.searchPageDetails;
				searchPropHLVm.selectedProperty = searchPropHLVm.detail.selectedProp;
				searchPropHLVm.losStates = homeLoanService.userMaster.master.states;
				searchPropHLVm.listOfProperty = [{"key":"R","value":"By RERA ID"},{"key":"P","value":"By Project Name"},{"key":"N","value":"Not Listed / Not SBI Approved"}];
				searchPropHLVm.getPropertyStateList('abc');

			searchPropHLVm.reraIdList = [];
			}

			searchPropHLVm.getPropertyStateList = function(type){
				var request = {};
				if(type == 'state'){
					request = {
						  "state": searchPropHLVm.detail.state
						};
				}
				homeLoanService.getPropertyStateCity(request).then(function(data) {
					
					if(type == 'state'){	
						//searchPropHLVm.detail.cities = [];
						searchPropHLVm.detail.city="";
						searchPropHLVm.detail.projName = "";
						searchPropHLVm.detail.cities = data;
						
					}else if(type == 'abc'){
						//searchPropHLVm.states = [];
						//searchPropHLVm.detail.city="";
						searchPropHLVm.states = data;
					}
					
					
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			searchPropHLVm.validateForm = function(){
				searchPropHLVm.errObj = {};
				if(!searchPropHLVm.detail.selectedProp){
					searchPropHLVm.errObj.selectedProp = $translate.instant('HL_ERR_PROPTYPE');
				}
				if(searchPropHLVm.selectedProperty == 'R'){
					if(!searchPropHLVm.detail.reraID){
						searchPropHLVm.errObj.reraID = $translate.instant('HL_ERR_RERAID');
					}
				}

				if(searchPropHLVm.selectedProperty == 'P'){
					if(!searchPropHLVm.detail.city){
						searchPropHLVm.errObj.city = $translate.instant('HL_ERR_CITY');
					}
					if(!searchPropHLVm.detail.state){
						searchPropHLVm.errObj.state = $translate.instant('HL_ERR_STATE');
					}
					if(!searchPropHLVm.detail.projName){
						searchPropHLVm.errObj.projName = $translate.instant('HL_ERR_SEL_PROJNAME');
					}
				}

				if(searchPropHLVm.selectedProperty == "N"){
					if(!searchPropHLVm.detail.losCity){
						searchPropHLVm.errObj.losCity = $translate.instant('HL_ERR_CITY');
					}
					if(!searchPropHLVm.detail.losState){
						searchPropHLVm.errObj.losState = $translate.instant('HL_ERR_STATE');
					}
					if(!searchPropHLVm.detail.projectName){
						searchPropHLVm.errObj.projectName = $translate.instant('HL_ERR_PROJNAME');
					}
					if(!searchPropHLVm.detail.propertyAddressline1){
						searchPropHLVm.errObj.propertyAddressline1 = $translate.instant('HL_ERR_ADDLINE1');
					}
					if(!searchPropHLVm.detail.propertyAddressline2){
						searchPropHLVm.errObj.propertyAddressline2 = $translate.instant('HL_ERR_ADDLINE2');
					}
					if(!searchPropHLVm.detail.pincode){
						searchPropHLVm.errObj.pincode = $translate.instant('HL_ERR_PINCODE');
					}else{
						searchPropHLVm.detail.pincode = searchPropHLVm.detail.pincode.replace(/ /g,'');
						if(parseInt(searchPropHLVm.detail.pincode) < 1 || searchPropHLVm.detail.pincode.length != 6){
							searchPropHLVm.errObj.pincode = $translate.instant('HL_ERR_VALIDPINCODE');
						}
					}
				}

				return (angular.equals({}, searchPropHLVm.errObj)) ? true : false;
			}

			searchPropHLVm.manageDocTypes = function(){
				var selctedType = searchPropHLVm.detail.selectedProp;
				if(selctedType == "R"){
					searchPropHLVm.selectedProperty = 'R';
					
				}else if(selctedType == "P"){
					searchPropHLVm.selectedProperty = 'P';
				}else if(selctedType == "N"){
					searchPropHLVm.selectedProperty = "N";
				}
			}

			searchPropHLVm.loadDistrict = function(type){
				var masterKey = "";
				if(type == 'district'){
					searchPropHLVm.detail.losCity = "";
					masterKey = searchPropHLVm.detail.losState.key;
				}

				var request = {
				  "key": masterKey,
				  "action": type
				};

				homeLoanService.getDistrictCity(request).then(function(data) {
					if(type == 'district'){			
						searchPropHLVm.losCities = data.info;
					}
					
					
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			searchPropHLVm.searchProjects = function(){
				var obj = {
						  "state": searchPropHLVm.detail.state,
						  "city":  searchPropHLVm.detail.city,
						  "reraId": ""
						};

				searchPropHLVm.fetchProperties(obj,searchPropHLVm.selectedProperty);
			}

			searchPropHLVm.fetchProperties = function(obj,index){
				homeLoanService.searchProperty(obj).then(function(data) {
					console.log(data);
					if(index == 'R'){
						
						if(data.properties.length > 0){
						//go to next page
						homeLoanService.reraPropertyDetails = data.properties[0];
						$state.go('menu.propByReraHL');
						}else{
							//show pop up project not approved
							searchPropHLVm.nonSBIApproved();
						}
					}else if(index == 'P'){
						searchPropHLVm.detail.listOfProperties = data.properties;
					}
					
				},function(error){

				});
			}

			searchPropHLVm.nonSBIApproved = function(){
				var templateSpan = '<div class="text-center roboto-regular font-size-14 color-darkgrey"><span translate="HL_NON_APPROVED_1" class=""></span><br><span translate="HL_NON_APPROVED_2"></span></div>';
				var backPopup = $ionicPopup.show({
					title: null,
					cssClass: 'my-custom-popup',
					template: templateSpan,
					buttons: [{
						text: 'OK',
						type: 'button-assertive',
						onTap: function () {
							backPopup.close();
							//$state.go('menu.calculateEmi');
							
						}
					}],
				});
			}
			

			searchPropHLVm.goToNextPage = function(){
				

				if(searchPropHLVm.validateForm()){
					homeLoanService.propertySearchType = searchPropHLVm.detail.selectedProp;
					var obj = {};
					if(searchPropHLVm.selectedProperty == 'R'){
						obj = {
						  "state": "",
						  "city": "",
						  "reraId": searchPropHLVm.detail.reraID
						};
						searchPropHLVm.fetchProperties(obj,searchPropHLVm.selectedProperty);
					}else if(searchPropHLVm.selectedProperty == "P"){
						homeLoanService.reraPropertyDetails = searchPropHLVm.detail.projName;

						$state.go('menu.propByReraHL');
					}else if(searchPropHLVm.selectedProperty == "N"){
						searchPropHLVm.detail.projName = "";
						searchPropHLVm.detail.reraID = "";
						homeLoanService.reraPropertyDetails = searchPropHLVm.detail;
						// $state.go('menu.pmay');
						if(homeLoanService.getGroupId() == "TAKEOVER"){
							$state.go('menu.calculateEmiTakeover');
						}else{
							$state.go('menu.pmay');
						}
					}
					homeLoanService.searchPageDetails = searchPropHLVm.detail;


					
					
				}
			}

			searchPropHLVm.goBack = function() {
				$state.go('menu.propDetailsHL');
	        }

		/**
		 * Displays the popup for selection of incoming RERA IDs.
		 * Will not be displayed if no incoming RERA ID available.
		 */
		searchPropHLVm.displayReraIdSelectionPopup = function (data) {
			var template = '';
			
			
			searchPropHLVm.detail.reraID = "";
			var tempData = data.toString().split(",");
			if (tempData && tempData.length <= 1) {
				searchPropHLVm.detail.reraID = data;
				template = '<form class="popupBodyPadding font-dark-grey"><div class="roboto-light font-content font-dark-grey "><p class="text-align-center font-content roboto-regular" ></p><br><p class="subtitle text-align-center"  translate="RERA_PROCEED_LABEL" ></p><div class="list text-center"><div class="item"><input type="radio"  name="searchPropHLVm.detail.reraID" ng-model="searchPropHLVm.detail.reraID" value="' + data + '"><strong>' + data + '</strong></div><div class="item separator">OR</div><div class="item"><input  name="searchPropHLVm.detail.reraID" type="radio" ng-model="searchPropHLVm.detail.reraID" value="P"><strong>{{ \'RERA_PNAME_LABEL\' | translate }}</strong></div></div></div></form>';
			} else {
				// In case of multiple RERA id, display popup for selection
				data = decodeURI(data.toString());
				data = data.split(',');
				searchPropHLVm.reraIdList = data;
				searchPropHLVm.detail.reraID = data[0];
				template = '<form class="popupBodyPadding font-dark-grey"><div align="center"><img class="fss-popup-activated-img" src="img/HomeLoan/Info.svg"></div><div class="roboto-light font-content font-dark-grey "><p class="title text-align-center font-content roboto-regular" translate="RERA_MULTIPLE_LABEL" ></p><br><p class="subtitle text-align-center"  translate="RERA_SELECT_LABEL" ></p><div class="list text-center scroll-list">';
				for (var id in data) {
					data[id] = data[id].trim();
					template += ('<div class="item"><input type="radio" name="searchPropHLVm.detail.reraID" ng-model="searchPropHLVm.detail.reraID" value="' + data[id] + '" /><strong>' + data[id] + '</strong></div>');
				}
				template = template + '</div><div class="list text-center"><div class="item separator">OR</div><div class="item"><input  name="searchPropHLVm.detail.reraID" type="radio" ng-model="searchPropHLVm.detail.reraID" value="P"><strong>{{ \'RERA_PNAME_LABEL\' | translate }}</strong></div></div></div></form>';
			}
			var showPopup = $ionicPopup.show({
				template: template,
				cssClass: 'rera-dialog',
				scope: $scope,
				buttons: [{
					text: 'Ok',
					type: 'button-positive',
					onTap: function (e) {
						if ("P" == searchPropHLVm.detail.reraID) {
							// update the selected property and clear selected rera id
							searchPropHLVm.detail.selectedProp = "P";
							searchPropHLVm.manageDocTypes();
						} else {
							// do nothing
						}
						showPopup.close();
					}
				}]
			});
		}
			$scope.$on('$ionicView.loaded', function () {
				
			});

			$scope.$on('$ionicView.beforeEnter', function () {
                initPage();
			
			$timeout(function () {
			var data = localStorage.getItem('reraId');
                if (data) {
                       searchPropHLVm.detail = {};
                       searchPropHLVm.detail.selectedProp =  "R";
					// if rera id is there, single/multiple, display selection popup
					searchPropHLVm.displayReraIdSelectionPopup(data);
                       document.getElementById("sel").value = "R";
                    localStorage.setItem('reraId' , "");
                       searchPropHLVm.manageDocTypes();
                }	
			}, 400);
				
			
            });
			
		

			return this;
		}

		
]);

