'use strict';
angularApp.controller('workDetailsController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"$ionicScrollDelegate",
		"customerInfoService",
		"validateService",
		"$filter",
		"homeLoanService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker,$ionicSideMenuDelegate,$ionicScrollDelegate,customerInfoService,validateService,$filter,homeLoanService) {
			
			var workDetailsVm = this;
			workDetailsVm.isMasked = true;
			workDetailsVm.inputImg = "img/Visibility_off.svg";
			workDetailsVm.emailInputType = "password";
			workDetailsVm.emailInputImg = "img/Visibility_off.svg";
			workDetailsVm.officeAddressLine1Text = "ADDRESS_LINE_1";
			workDetailsVm.officePincodeText = "PINCODE";
			workDetailsVm.officeStateText = "State";
			workDetailsVm.officeDistrictText = "District";
			workDetailsVm.officeSubDistrictText = "Sub-District";
			workDetailsVm.officeVillageTownText = "Village/Town";
			workDetailsVm.officeCityText = "City";
			workDetailsVm.officeEmailText = "OFFICE_EMAIL";

			function initPage() {
				workDetailsVm.groups = [{
					id : "office",
					name : "Office Details"
				}];

				workDetailsVm.detail = {};
				workDetailsVm.errObj = {};
				workDetailsVm.sbiLoanEMI = 0;
				workDetailsVm.masterData = homeLoanService.userMaster;
				workDetailsVm.loanPurposes = workDetailsVm.masterData.master.loanPurposes;
				workDetailsVm.rePaymentTypes = workDetailsVm.masterData.master.rePaymentTypes;
				workDetailsVm.employmentType = workDetailsVm.masterData.master.employmentTypes;
				workDetailsVm.employerType = workDetailsVm.masterData.master.employerTypes;
				workDetailsVm.emiTypes = workDetailsVm.masterData.master.emiTypes;
				workDetailsVm.professionTypeList = workDetailsVm.masterData.master.professionTypes;
				workDetailsVm.officeDistricts = [];
				workDetailsVm.officeSubDistricts = [];
				workDetailsVm.officeVillageTown = [];
				workDetailsVm.officeCities =[];
				workDetailsVm.states = workDetailsVm.masterData.master.states;
				
				
				workDetailsVm.emiType = [];

				if(workDetailsVm.masterData.totalSbiEmi){
					workDetailsVm.sbiLoanEMI = parseInt(workDetailsVm.masterData.totalSbiEmi);
				}


				workDetailsVm.numberOfHouses = {
                    value: 3,
                    options: {
                    	showSelectionBar: true,
                    	floor :  3,
						ceil :  10,
						step :  1,
						onChange : function(id,model){
							workDetailsVm.setNumberOfHouses();
						},
						translate : function(value){
							return  value + " Houses";
						}	
                    }
				};
				workDetailsVm.setNumberOfHouses = function(){
					workDetailsVm.detail.numberOfHouses = workDetailsVm.numberOfHouses.value;
				}


				if(homeLoanService.getPrepolpulateWorkDetails()){
					workDetailsVm.detail = homeLoanService.getPrepolpulateWorkDetails();
					workDetailsVm.showFieldsResume();
					workDetailsVm.tnc = true;
					workDetailsVm.totalEMIs = [];
					if(workDetailsVm.detail.officeDistrict){
					workDetailsVm.officeDistricts.push(workDetailsVm.detail.officeDistrict);
					}
					if(workDetailsVm.detail.officeSubDistrict){
					workDetailsVm.officeSubDistricts.push(workDetailsVm.detail.officeSubDistrict);
					}
					if(workDetailsVm.detail.officeCity){
					workDetailsVm.officeCities.push(workDetailsVm.detail.officeCity);
					}
					if(workDetailsVm.detail.officeVillageTown){
					workDetailsVm.officeVillageTown.push(workDetailsVm.detail.officeVillageTown);
					}
					if(workDetailsVm.detail.numberOfHouses){
						workDetailsVm.numberOfHouses.value = workDetailsVm.detail.numberOfHouses;
					}
					workDetailsVm.totalEMIs = homeLoanService.getPrepolpulateWorkDetails().emi ? homeLoanService.getPrepolpulateWorkDetails().emi : [];
					for(var i=0 ; i<workDetailsVm.totalEMIs.length ; i++){
						//workDetailsVm.emiType[i] = JSON.parse(workDetailsVm.totalEMIs[i].typeValue);
						workDetailsVm.totalEMIs[i].type = JSON.parse(workDetailsVm.totalEMIs[i].typeValue);
						workDetailsVm.totalEMIs[i].amount = parseFloat(workDetailsVm.totalEMIs[i].amount);												
					}
					
					//workDetailsVm.dob = workDetailsVm.detail.dob;
					workDetailsVm.calculateEMIs();
					workDetailsVm.showProfession();
				}else{
					workDetailsVm.totalEMIs=[];
					workDetailsVm.detail.dob = homeLoanService.userMaster.dob;
					workDetailsVm.tnc = false;
					workDetailsVm.hideAllFields();
					workDetailsVm.detail.custName = workDetailsVm.masterData.firstName + ' ' + workDetailsVm.masterData.lastName;
					workDetailsVm.calculateEMIs();
				}
				
			};

			workDetailsVm.maskUnmask = function () {
				workDetailsVm.isMasked == true ? (workDetailsVm.isMasked = false , workDetailsVm.inputImg = "img/Visibility_on.svg") : (workDetailsVm.isMasked = true , workDetailsVm.inputImg = "img/Visibility_off.svg");
			};

			workDetailsVm.emailMaskUnmask = function (param) {
				workDetailsVm.emailInputType == "password" ? (workDetailsVm.emailInputType = "text" , workDetailsVm.emailInputImg = "img/Visibility_on.svg") : (workDetailsVm.emailInputType = "password" , workDetailsVm.emailInputImg = "img/Visibility_off.svg");
			};


			// ------------------------------------Office dtails--------------------------------------

			workDetailsVm.toggleGroup = function(group) {
				workDetailsVm.officeDetailErrorFlag = false;
				if (group.id == "office") {
					if (workDetailsVm.isGroupShown(group)) {
						workDetailsVm.shownGroup = null;
					} else {
							workDetailsVm.shownGroup = group;
					}
				}
	
	
			};



			workDetailsVm.isGroupShown = function(group) {
				if(workDetailsVm.officeDetailErrorFlag){
					return true;
				}else{
					return workDetailsVm.shownGroup === group;
				}
				
			};




			// ------------------------------------Office dtails END--------------------------------------



			workDetailsVm.loadDistrictoffice = function(type){
				var masterKey = "";
				if(type == 'district'){
					workDetailsVm.detail.officeDistrict = "";
					workDetailsVm.detail.officeSubDistrict = "";
					workDetailsVm.detail.officeVillageTown = "";
					workDetailsVm.detail.officeCity="";
					masterKey = workDetailsVm.detail.officeState.key;
				}else if(type == 'subdistrict'){
					workDetailsVm.detail.officeSubDistrict = "";
					workDetailsVm.detail.officeVillageTown = "";
					workDetailsVm.detail.officeCity="";
					masterKey = workDetailsVm.detail.officeDistrict.key;
				}else if(type == 'village'){
					workDetailsVm.detail.officeVillageTown = "";
					workDetailsVm.detail.officeCity="";
					masterKey = workDetailsVm.detail.officeSubDistrict.key;
				}else if(type == 'city'){
				workDetailsVm.detail.officeCity="";
				masterKey = workDetailsVm.detail.officeState.key;
			}

				var request = {
				  "key": masterKey,
				  "action": type
				};

				homeLoanService.getDistrictCity(request).then(function(data) {
					if(type == 'district'){
						workDetailsVm.officeDistricts = data.info;
					}else if(type == 'subdistrict'){
						workDetailsVm.officeSubDistricts = data.info;
					}else if(type == 'village'){
						workDetailsVm.officeVillageTown = data.info;
					}else if(type == 'city'){
						workDetailsVm.officeCities = data.info;
					}
					
					
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});
			}




			workDetailsVm.validateForm = function(){
				workDetailsVm.errObj = {};

				if(validateService.isValidEmploymentType(workDetailsVm.detail.employmentType)){
					workDetailsVm.errObj.employmentType = validateService.isValidEmploymentType(workDetailsVm.detail.employmentType);
				}

				if(workDetailsVm.isProfessionType){
					if(validateService.isValidProfessionType(workDetailsVm.detail.professionType)){
						workDetailsVm.errObj.professionType = validateService.isValidProfessionType(workDetailsVm.detail.professionType);
					}
				}

				if(workDetailsVm.isEmployerType){
					if(validateService.isValidEmployerType(workDetailsVm.detail.employerType)){
						workDetailsVm.errObj.employerType = validateService.isValidEmployerType(workDetailsVm.detail.employerType);
					}
				}

				if(workDetailsVm.isNetMonthlyIncome){
					if(validateService.isValidMonthlyIncome(workDetailsVm.detail.netMonthlyIncome)){
						workDetailsVm.errObj.netMonthlyIncome = validateService.isValidMonthlyIncome(workDetailsVm.detail.netMonthlyIncome);
					}
				}

				if(workDetailsVm.isNetAnnualIncome){
					if(validateService.isValidAnnualIncomeHL(workDetailsVm.detail.netAnnualIncome)){
						workDetailsVm.errObj.netAnnualIncome = validateService.isValidAnnualIncomeHL(workDetailsVm.detail.netAnnualIncome);
					}
				}

				if(workDetailsVm.isProfession){
					if(validateService.isValidProfession(workDetailsVm.detail.profession)){
						workDetailsVm.errObj.profession = validateService.isValidProfession(workDetailsVm.detail.profession);
					}
				}
				
				// if(workDetailsVm.isIncomeFromHouseProp){
				// 	if(validateService.isValidIncome(workDetailsVm.detail.incomeHouseProperty)){
				// 		workDetailsVm.errObj.incomeFromHouseProp = validateService.isValidIncome(workDetailsVm.detail.incomeHouseProperty);
				// 	}
				// }
				
				if(workDetailsVm.isWorkExp){
					if(validateService.isValidMonthsInWork(workDetailsVm.detail.workExp)){
						workDetailsVm.errObj.workExp = validateService.isValidMonthsInWork(workDetailsVm.detail.workExp);
					}
				}

				if(workDetailsVm.isMonthsInCurrJob){
					if(validateService.isValidMonthsInJob(workDetailsVm.detail.monthsInCurrJob)){
						workDetailsVm.errObj.monthsInCurrJob = validateService.isValidMonthsInJob(workDetailsVm.detail.monthsInCurrJob);
					}
				}

				if(workDetailsVm.isOfficeDetails){
					if(validateService.isValidOfficeName(workDetailsVm.detail.officeName)){
						workDetailsVm.errObj.officeName = validateService.isValidOfficeName(workDetailsVm.detail.officeName);
						workDetailsVm.officeDetailErrorFlag = true;
					}


					if(workDetailsVm.detail.employmentType.key == "PensionerR"){

						if (validateService.isValidAdressNonMandatory(workDetailsVm.detail.addressLine1)) {
							workDetailsVm.errObj.addressLine1 = validateService.isValidAdressNonMandatory(workDetailsVm.detail.addressLine1);
							workDetailsVm.officeDetailErrorFlag = true;
						}

					}else{

						if (validateService.isValidAdress(workDetailsVm.detail.addressLine1)) {
							workDetailsVm.errObj.addressLine1 = validateService.isValidAdress(workDetailsVm.detail.addressLine1);
							workDetailsVm.officeDetailErrorFlag = true;
						}
					}


					if(workDetailsVm.detail.employmentType.key == "PensionerR"){

						// if (validateService.isValidPincodeNonMandatory(workDetailsVm.detail.officePincode)) {
						// 	workDetailsVm.errObj.officePincode = validateService.isValidPincodeNonMandatory(workDetailsVm.detail.officePincode);
						// }
						if(workDetailsVm.detail.officePincode){
						workDetailsVm.detail.officePincode = workDetailsVm.detail.officePincode.replace(/ /g,'');
							if(parseInt(workDetailsVm.detail.officePincode) < 1 || workDetailsVm.detail.officePincode.length != 6){
								workDetailsVm.errObj.officePincode = $translate.instant('HL_ERR_VALIDPINCODE');
								workDetailsVm.officeDetailErrorFlag = true;
							}
						}

					}else{

						// if (validateService.isValidPincode(workDetailsVm.detail.officePincode)) {
						// 	workDetailsVm.errObj.officePincode = validateService.isValidPincode(workDetailsVm.detail.officePincode);
						// }
						if(!workDetailsVm.detail.officePincode){
							workDetailsVm.errObj.officePincode = $translate.instant('HL_ERR_PINCODE');
							workDetailsVm.officeDetailErrorFlag = true;
						}else{
							workDetailsVm.detail.officePincode = workDetailsVm.detail.officePincode.replace(/ /g,'');
							if(parseInt(workDetailsVm.detail.officePincode) < 1 || workDetailsVm.detail.officePincode.length != 6){
								workDetailsVm.errObj.officePincode = $translate.instant('HL_ERR_VALIDPINCODE');
								workDetailsVm.officeDetailErrorFlag = true;
							}
						}
					}



					if(workDetailsVm.detail.employmentType.key != "PensionerR"){

						if (validateService.isValidState(workDetailsVm.detail.officeState)) {
							workDetailsVm.errObj.officeState = validateService.isValidState(workDetailsVm.detail.officeState);
							workDetailsVm.officeDetailErrorFlag = true;
						}
					}

					if(workDetailsVm.detail.employmentType.key != "PensionerR"){

						if (validateService.hlValidDistrict(workDetailsVm.detail.officeDistrict)) {
							workDetailsVm.errObj.officeDistrict = validateService.hlValidDistrict(workDetailsVm.detail.officeDistrict);
							workDetailsVm.officeDetailErrorFlag = true;
						}
					}

					if(workDetailsVm.detail.employmentType.key != "PensionerR"){

						if (validateService.hlValidSubDistrict(workDetailsVm.detail.officeSubDistrict)) {
							workDetailsVm.errObj.OfficeSubDistrict = validateService.hlValidSubDistrict(workDetailsVm.detail.officeSubDistrict);
							workDetailsVm.officeDetailErrorFlag = true;
						}
					}

					if(workDetailsVm.detail.employmentType.key != "PensionerR"){

						if (validateService.hlValidVillage(workDetailsVm.detail.officeVillageTown)) {
							workDetailsVm.errObj.OfficeVillageTown = validateService.hlValidVillage(workDetailsVm.detail.officeVillageTown);
							workDetailsVm.officeDetailErrorFlag = true;
						}
					}

					if(workDetailsVm.detail.employmentType.key != "PensionerR"){

						if (validateService.hlValidCity(workDetailsVm.detail.officeCity)) {
							workDetailsVm.errObj.officeCity = validateService.hlValidCity(workDetailsVm.detail.officeCity);
							workDetailsVm.officeDetailErrorFlag = true;
						}
					}

					// if(workDetailsVm.detail.employmentType.key != "PensionerR"){

					// 	if (validateService.isValidPhoneMandatory(workDetailsVm.detail.officePhone)) {
					// 		workDetailsVm.errObj.officePhone = validateService.isValidPhoneMandatory(workDetailsVm.detail.officePhone);
					// 	}
					// }


					if(workDetailsVm.detail.employmentType.key == "PensionerR"){

						if(validateService.isValidEmailHLNonMandatory(workDetailsVm.detail.officalEmail)){
							workDetailsVm.errObj.officalEmail = validateService.isValidEmailHLNonMandatory(workDetailsVm.detail.officalEmail);
							workDetailsVm.officeDetailErrorFlag = true;
						}

					}else{

						if(validateService.isValidEmailHL(workDetailsVm.detail.officalEmail)){
							workDetailsVm.errObj.officalEmail = validateService.isValidEmailHL(workDetailsVm.detail.officalEmail);
							workDetailsVm.officeDetailErrorFlag = true;
						}
					}

					
				}

				if(workDetailsVm.isMonthsInCurrJobProfession){
					if(validateService.isValidMonthsInJobProfession(workDetailsVm.detail.monthsInCurrJob)){
						workDetailsVm.errObj.monthsInCurrJob = validateService.isValidMonthsInJobProfession(workDetailsVm.detail.monthsInCurrJob);
					}
				}

				if(workDetailsVm.isRetirementAge){
					if(validateService.isValidRetire(workDetailsVm.detail.retirementAge,workDetailsVm.detail.employerType.key)){
						workDetailsVm.errObj.retirementAge = validateService.isValidRetire(workDetailsVm.detail.retirementAge,workDetailsVm.detail.employerType.key);						
					}
				}

				if(validateService.isValidLoanPurpose(workDetailsVm.detail.loanPurpose)){
					workDetailsVm.errObj.loanPurpose = validateService.isValidLoanPurpose(workDetailsVm.detail.loanPurpose);
				}

				if(validateService.isValidLoanRepayment(workDetailsVm.detail.loanRepaymentType)){
					workDetailsVm.errObj.loanRepaymentType = validateService.isValidLoanRepayment(workDetailsVm.detail.loanRepaymentType);
				}

				

				return (angular.equals({}, workDetailsVm.errObj)) ? true : false;
			}

			workDetailsVm.saveApplication = function(){
				var primaryDetails = homeLoanService.getPersonalPrimaryDetails();

				var addArray = [];
				var addObj = {
					"addressLine1": primaryDetails.permanentAddressLine1 ,
					"addressLine2": primaryDetails.permanentAddressLine2 ,
					"addressLine3": primaryDetails.permanentAddressLine3 ,
					"districtText": JSON.stringify(primaryDetails.district),
					"subDistrictText": JSON.stringify(primaryDetails.subDistrict),
					"villageTownText": JSON.stringify(primaryDetails.villageTown),
					"cityText": JSON.stringify(primaryDetails.city),
					"stateText": JSON.stringify(primaryDetails.state),
					"pincode": primaryDetails.pincode,
					"addressType": "P",
					"districtCode": primaryDetails.district.key,
					"subDistrict": primaryDetails.subDistrict.key,
					"villageTown": primaryDetails.villageTown.key,
					"cityCode": primaryDetails.city.key,
					"stateCode": primaryDetails.state.key
				};
				addArray.push(addObj);
				if(!primaryDetails.currentAddressCheck){
					var addObj2 = {
						"addressLine1": primaryDetails.addressLine1,
						"addressLine2": primaryDetails.addressLine2,
						"addressLine3": primaryDetails.addressLine3,
						"districtText": JSON.stringify(primaryDetails.currentDistrict),
						"subDistrictText": JSON.stringify(primaryDetails.currentSubDistrict),
						"villageTownText": JSON.stringify(primaryDetails.currentVillage),
						"cityText": JSON.stringify(primaryDetails.currentCity),
						"stateText": JSON.stringify(primaryDetails.currentState),
						"pincode": primaryDetails.currentPincode,
						"addressType": "C",
						"districtCode": primaryDetails.currentDistrict.key,
						"subDistrict": primaryDetails.currentSubDistrict.key,
						"villageTown": primaryDetails.currentVillage.key,
						"cityCode": primaryDetails.currentCity.key,
						"stateCode": primaryDetails.currentState.key
					};
					addArray.push(addObj2);
				}

				if(workDetailsVm.isOfficeDetails){
					var addObj3 = {
						"addressLine1": workDetailsVm.detail.addressLine1,
						"addressLine2": workDetailsVm.detail.addressLine2,
						"districtText": JSON.stringify(workDetailsVm.detail.officeDistrict),
						"subDistrictText": JSON.stringify(workDetailsVm.detail.officeSubDistrict),
						"villageTownText": JSON.stringify(workDetailsVm.detail.officeVillageTown),
						"cityText": JSON.stringify(workDetailsVm.detail.officeCity),
						"stateText": JSON.stringify(workDetailsVm.detail.officeState),
						"pincode": workDetailsVm.detail.officePincode,
						"addressType": "O",
						"districtCode": workDetailsVm.detail.officeDistrict ? workDetailsVm.detail.officeDistrict.key : "",
						"subDistrict": workDetailsVm.detail.officeSubDistrict ? workDetailsVm.detail.officeSubDistrict.key : "",
						"villageTown": workDetailsVm.detail.officeVillageTown ? workDetailsVm.detail.officeVillageTown.key : "",
						"cityCode": workDetailsVm.detail.officeCity ? workDetailsVm.detail.officeCity.key : "",
						"stateCode": workDetailsVm.detail.officeState ? workDetailsVm.detail.officeState.key : ""
					};
					addArray.push(addObj3);
				}
				
				var takeOverObj = {};
				if(homeLoanService.getTakeoverData()){
					takeOverObj =  {
					    "existingLoanOutstandingAmount": homeLoanService.getTakeoverData().existingLoanOutstandingAmount ? homeLoanService.getTakeoverData().existingLoanOutstandingAmount : "",
					    "existingLoanCurrentInterest": homeLoanService.getTakeoverData().existingLoanCurrentInterest ? homeLoanService.getTakeoverData().existingLoanCurrentInterest : "",
					    "existingLoanEMI": homeLoanService.getTakeoverData().existingLoanEMI ? homeLoanService.getTakeoverData().existingLoanEMI : "",
					    "remainingTenureInMonths": homeLoanService.getTakeoverData().remainingTenureInMonths ? homeLoanService.getTakeoverData().remainingTenureInMonths : "",
					    "totalMarketValue": homeLoanService.getTakeoverData().totalMarketValue ? homeLoanService.getTakeoverData().totalMarketValue : "",
					    "totalProjectCost": homeLoanService.getTakeoverData().totalProjectCost ? homeLoanService.getTakeoverData().totalProjectCost : "",
					    "currentLender": homeLoanService.getTakeoverData().currentLender ?  homeLoanService.getTakeoverData().currentLender.key : "",
					    "currentLenderValue":  homeLoanService.getTakeoverData().currentLender ? JSON.stringify(homeLoanService.getTakeoverData().currentLender) : "",
					    "propertyType": homeLoanService.getTakeoverData().propertyType ? homeLoanService.getTakeoverData().propertyType : "",
					    "propertyTypeValue": homeLoanService.getTakeoverData().propertyTypeValue ? homeLoanService.getTakeoverData().propertyTypeValue : ""
					};
				}

				var topUpObj = {};
				if(homeLoanService.getTopupData()){
					topUpObj =  {
					    "topupLoanOutstandingAmount": homeLoanService.getTopupData().topupLoanOutstandingAmount ? homeLoanService.getTopupData().topupLoanOutstandingAmount : "",
					    "topupLoanCurrentInterest": homeLoanService.getTopupData().topupLoanCurrentInterest ? homeLoanService.getTopupData().topupLoanCurrentInterest : "",
					    "topupLoanEMI": homeLoanService.getTopupData().topupLoanEMI ? homeLoanService.getTopupData().topupLoanEMI : ""
					};
				}

				var saveAppRequest = 
				{
					"loanType": homeLoanService.getGroupId(),
					"tnc": workDetailsVm.tnc ? "true" : "false",
					"applicants": [
						{
						
						"title": primaryDetails.title.key,
						"titleValue": JSON.stringify(primaryDetails.title),
						"applicantType": "",
						"firstName": primaryDetails.firstName,
						"middleName": primaryDetails.middleName ? primaryDetails.middleName : "",
						"lastName": primaryDetails.lastName,
						"fatherName": primaryDetails.fatherName,
						"motherMaidenName": primaryDetails.motherMaidenName,
						"gender": primaryDetails.gender.key,
						"genderValue": JSON.stringify(primaryDetails.gender),
						"dob": primaryDetails.dob,
						"email": primaryDetails.email,
						"mobile": primaryDetails.mobile ? primaryDetails.mobile : "",
						"alternateContact": primaryDetails.alternateContact,
						"pan": primaryDetails.pan,
						"aadhaar": primaryDetails.aadhar,
						"ovdType": primaryDetails.ovdType ? primaryDetails.ovdType.key : "",
      					"ovdTypeValue": primaryDetails.ovdType ? JSON.stringify(primaryDetails.ovdType) : "",
      					"ovdNumber": primaryDetails.ovdNumber ? primaryDetails.ovdNumber : "",
						"declaration": "",
						"address": addArray,
						"residenceType": primaryDetails.currentAddressCheck == true ? primaryDetails.residenceType.key :  primaryDetails.residenceTypeCurrent.key,
						"residenceTypeValue":  primaryDetails.currentAddressCheck == true ? JSON.stringify(primaryDetails.residenceType) :  JSON.stringify(primaryDetails.residenceTypeCurrent),
						"monthsInCurrResidence": primaryDetails.currentAddressCheck == true  ? primaryDetails.residenceMonth : primaryDetails.residenceMonthCurrent,
						"employmentType": workDetailsVm.detail.employmentType ? workDetailsVm.detail.employmentType.key : "",
						"employmentTypeValue": workDetailsVm.detail.employmentType ? JSON.stringify(workDetailsVm.detail.employmentType)  : "",
						"employerType": workDetailsVm.detail.employerType ? workDetailsVm.detail.employerType.key : "",
						"employerTypeValue": workDetailsVm.detail.employerType ? JSON.stringify(workDetailsVm.detail.employerType) : "",
						"professionType": workDetailsVm.detail.professionType ? workDetailsVm.detail.professionType.key : "",
						"professionTypeValue": workDetailsVm.detail.professionType ? JSON.stringify(workDetailsVm.detail.professionType) : "",
						"otherProfessionType": workDetailsVm.isProfession ? workDetailsVm.detail.profession : "",
						"retirementAge": workDetailsVm.detail.retirementAge ? workDetailsVm.detail.retirementAge : "",
						"maritalStatus": primaryDetails.maritalStatus ? primaryDetails.maritalStatus.key : "",
      					"maritalStatusValue": primaryDetails.maritalStatus ? JSON.stringify(primaryDetails.maritalStatus) : "",
						"workExp": workDetailsVm.detail.workExp ? workDetailsVm.detail.workExp : "",
						"monthsInCurrJob": workDetailsVm.detail.monthsInCurrJob ? workDetailsVm.detail.monthsInCurrJob : "",
						"netMonthlyIncome": workDetailsVm.detail.netMonthlyIncome ? workDetailsVm.detail.netMonthlyIncome : "",
						"netAnnualIncome": workDetailsVm.detail.netAnnualIncome ? workDetailsVm.detail.netAnnualIncome : "",
						"incomeHouseProperty": workDetailsVm.detail.incomeHouseProperty ? workDetailsVm.detail.incomeHouseProperty : "",
						"emi": workDetailsVm.emiExisting ? workDetailsVm.emiExisting : [],
						"totalExistingEMI": "",
						"accountNo": "",
						"numberOfHouses": workDetailsVm.numberOfHouses.value,
						// "eduQualification": primaryDetails.educationQualification.value,
						// "qualificationCode": primaryDetails.educationQualification.key,
						"eduQualificationValue": primaryDetails.eduQualification ? JSON.stringify(primaryDetails.eduQualification) : "",
						"eduQualification": primaryDetails.eduQualification.key,
						"officeName": workDetailsVm.detail.officeName,
						"officalEmail": workDetailsVm.detail.officalEmail,
						"officePhone": workDetailsVm.detail.officePhone
						}
					],
					 "propertyCost": workDetailsVm.detail.propertyCost,
					  "loanPurpose": workDetailsVm.detail.loanPurpose.key,
					  "loanPurposeValue": JSON.stringify(workDetailsVm.detail.loanPurpose),
					  "loanRePaymentType": workDetailsVm.detail.loanRepaymentType.key,
					  "loanRePaymentTypeValue": JSON.stringify(workDetailsVm.detail.loanRepaymentType),
					  "multipleHouse": workDetailsVm.detail.multipleHouse ? "true" : "false",
					  "primaryAuthorizeFlag": workDetailsVm.detail.primaryAuthorizeFlag ? "true" : "false",
					  "applicantType": "",
					  "applicantState": "",
					  "approvalStatus": "",
					  "takeOverDetails": takeOverObj,
					  "topupDetails": topUpObj
					};
					homeLoanService.savePrimaryApplicant(saveAppRequest).then(function(data) {
						console.log(data);
						if(data.crmAssignedName){
							var obj = {
								"crmAssignedName": data.crmAssignedName,
	    						"crmAssignedNumber": data.crmAssignedNumber
							}
							homeLoanService.setCRMData(obj);
						}
						
						homeLoanService.setYonoRef(data.yonoRef);
						homeLoanService.setPrepolpulateWorkDetails(workDetailsVm.detail);
						$state.go('menu.addCoApplicant');
						
					},function(error){
						utilityService.showErrorMessage(error.responseMessage);
					});

			}

			workDetailsVm.validateWorkExp = function(){
				

			}

			workDetailsVm.goToNextPage = function(){
				if(workDetailsVm.validateForm()){
					 if(workDetailsVm.detail.employmentType.key == "Salaried" || workDetailsVm.detail.employmentType.key == "Self-Employed" || workDetailsVm.detail.employmentType.key == "Businessman"){
						if(parseInt(workDetailsVm.detail.workExp) < parseInt(workDetailsVm.detail.monthsInCurrJob)){
							if(workDetailsVm.isMonthsInCurrJobProfession){
								utilityService.showErrorMessage("Months in current Profession cannot be greater than work experience");
							}else{
								utilityService.showErrorMessage("Months in current Job cannot be greater than work experience");
							}
							
							return;
						}

						//workDetailsVm.validateWorkExp();
						var myDOB = workDetailsVm.detail.dob;// homeLoanService.userMaster.dob;
						var today = new Date();

						var dob = new Date(myDOB);

						var year1=myDOB.split('/')[2];// dob.getFullYear();
						var year2=today.getFullYear();

						var totalYears = year2 - parseInt(year1) - 14;
						var month1=myDOB.split('/')[1];
						var month2=today.getMonth();

						var totalMonths = (totalYears * 12) + month2 - parseInt(month1);

						if(totalMonths < parseInt(workDetailsVm.detail.workExp)){
							utilityService.showErrorMessage("Maximum experience should be less than your age minus 14 years");
							return;
						} 

						
					}
					workDetailsVm.detail.emi = [];
					workDetailsVm.emiExisting = []; 
					if(workDetailsVm.totalEMIs.length > 0){
						for(var i = 0; i< workDetailsVm.totalEMIs.length;i++){							
							var obj = {};
							obj.type = workDetailsVm.totalEMIs[i].type.key;
							obj.typeValue = JSON.stringify(workDetailsVm.totalEMIs[i].type);
							obj.amount = workDetailsVm.totalEMIs[i].amount ? workDetailsVm.totalEMIs[i].amount : 0;
							var index = i+1;

							if(workDetailsVm.sbiLoanEMI > 0){
								if(!obj.type){
									utilityService.showErrorMessage("Please select Loan type of "+ (index + 1) + " in Existing EMI");
									return;
								}else if(parseInt(obj.amount) < 1){
									utilityService.showErrorMessage("Please enter EMI of "+ (index + 1) + " in Existing EMI");
									return;
								}
							}else{
								if(!obj.type){
									utilityService.showErrorMessage("Please select Loan type of "+ index + " in Existing EMI");
									return;
								}else if(parseInt(obj.amount) < 1){
									utilityService.showErrorMessage("Please enter EMI of "+ index + " in Existing EMI");
									return;
								}
							}
							
							workDetailsVm.detail.emi.push(obj);

							if(workDetailsVm.totalEMIs[i].type.key != '28'){		//SBI Loans
								var objFilter = {};
								objFilter.type = workDetailsVm.totalEMIs[i].type.key;
								objFilter.typeValue = JSON.stringify(workDetailsVm.totalEMIs[i].type);
								objFilter.amount = workDetailsVm.totalEMIs[i].amount ? workDetailsVm.totalEMIs[i].amount : 0;
								var index = i+1;								
								workDetailsVm.emiExisting.push(objFilter);
							}
						}
					}					
					workDetailsVm.saveApplication();
				}
			}

			workDetailsVm.goBack = function() {
				$state.go('menu.homeLoanPersonalDetails');
	        }

			workDetailsVm.addEMI = function(){
				workDetailsVm.emi = {
	                "type": "",
					"typeValue" : "",
	                "amount": ""
	            };
	            // if(workDetailsVm.totalEMIs.length < 6){
	            	workDetailsVm.totalEMIs.push(workDetailsVm.emi);
	            // }
			}

			workDetailsVm.calculateEMIs = function(){
				workDetailsVm.totalEMICost = 0;
				if(workDetailsVm.sbiLoanEMI){
					for(var i = 0; i< workDetailsVm.totalEMIs.length;i++){
						workDetailsVm.totalEMICost = workDetailsVm.totalEMICost + (parseFloat(workDetailsVm.totalEMIs[i].amount) ? parseFloat(workDetailsVm.totalEMIs[i].amount) : 0); 
					}
					workDetailsVm.totalEMICost = parseInt(workDetailsVm.sbiLoanEMI) + workDetailsVm.totalEMICost;
				}else{
					for(var i = 0; i< workDetailsVm.totalEMIs.length;i++){
						workDetailsVm.totalEMICost = workDetailsVm.totalEMICost + (parseFloat(workDetailsVm.totalEMIs[i].amount) ? parseFloat(workDetailsVm.totalEMIs[i].amount) : 0);						
					}
				}
			}

			workDetailsVm.deleteEMI = function(emiIndex){
	            workDetailsVm.totalEMIs.splice(emiIndex,1);
	            workDetailsVm.calculateEMIs();
			}

			workDetailsVm.homeLoanTNC = function(type){
				var request = {
					"type": "homeLoanTnc"
				};
				if(type == 'p'){
					 request = {
						"type": "homeLoanConsentTnc"
					};
				}
				

				homeLoanService.getTermsAndCondition(request).then(function(data) {
						var titlePopup = "Declaration";
						if (type == "p") {
							titlePopup = "Policies";
						}else{
							titlePopup = "Terms & Conditions";
						}
						
						var buttontext = "OK";
						var blankdata = null;
						var detail = $filter('ngBindHtmlFilter')(data);
						var tncStatus = $ionicPopup.show({
	                      title: titlePopup,
	                      cssClass: 'ftandcpopup-body popupBackgroundWhite popupWidth90  popupBackgroundDark',
	                      template: data,
	                      scope: $scope,
	                      buttons: [

	                          {
	                              text: '<b>OK</b>',
	                              type: 'button-positive',
	                              onTap: function(e) {
	                                  tncStatus.close();
	                              }
	                          }
	                      ]
	                  });
						//utilityService.showAlertModal(title, detail, blankdata, blankdata, $state, buttontext);
					},function(error){
						utilityService.showErrorMessage(error.responseMessage);
					});
			}

			workDetailsVm.hideAllFields = function(){
				workDetailsVm.isNetMonthlyIncome = false;
				workDetailsVm.isNetAnnualIncome = false;
				workDetailsVm.isIncomeFromHouseProp = false;
				workDetailsVm.isEmployerType = false;
				workDetailsVm.isRetirementAge = false;
				workDetailsVm.isProfessionType = false;
				workDetailsVm.isProfession = false;
				workDetailsVm.isWorkExp = false;
				workDetailsVm.isMonthsInCurrJob = false;
				workDetailsVm.isMonthsInCurrJobProfession = false;
				workDetailsVm.isOfficeDetails = false;
			}

			workDetailsVm.clearAllFields = function(){
				workDetailsVm.detail.retirementAge = "";
				workDetailsVm.detail.netAnnualIncome = "";
				workDetailsVm.detail.netMonthlyIncome = "";
				workDetailsVm.detail.incomeHouseProperty = "";
				workDetailsVm.detail.professionType="";
				workDetailsVm.detail.employerType = "";
				workDetailsVm.detail.profession = "";
				workDetailsVm.detail.workExp = "";
				workDetailsVm.detail.monthsInCurrJob = "";
				
			}

			workDetailsVm.validateAge = function(){
				if(workDetailsVm.detail.employerType.key == 'PEN'){
					workDetailsVm.isRetirementAge = false;
					workDetailsVm.detail.retirementAge = "";
				}else{
					workDetailsVm.isRetirementAge = true;
				}
			}

			workDetailsVm.showProfession = function(){
				workDetailsVm.isProfession = false;
				if((workDetailsVm.detail.professionType && workDetailsVm.detail.professionType.key == "0299") || (workDetailsVm.detail.employmentType && workDetailsVm.detail.employmentType.key == "Businessman")){
					workDetailsVm.isProfession = true;
				}	
			}

			workDetailsVm.showFields = function(){
				$ionicScrollDelegate.resize();
				workDetailsVm.errObj = {};
				//workDetailsVm.detail = {};
				workDetailsVm.errObj.employmentType = validateService.isValidEmploymentType(workDetailsVm.detail.employmentType);
				workDetailsVm.hideAllFields();
				workDetailsVm.clearAllFields();
				homeLoanService.setHomeRetired(false);
				if(workDetailsVm.detail.employmentType){
					if(workDetailsVm.detail.employmentType.key == "A"){

					}else if(workDetailsVm.detail.employmentType.key == "Businessman"){
						workDetailsVm.isIncomeFromHouseProp = true;
						workDetailsVm.isNetAnnualIncome = true;
						workDetailsVm.isWorkExp = true;
						workDetailsVm.isMonthsInCurrJobProfession = true;
						workDetailsVm.isProfession = true;
						workDetailsVm.detail.professionType = "";
						workDetailsVm.isOfficeDetails = true;
						workDetailsVm.officeAddressLine1Text = "ADDRESS_LINE_1";
						workDetailsVm.officePincodeText = "PINCODE";
						workDetailsVm.officeStateText = "State";
						workDetailsVm.officeDistrictText = "District";
						workDetailsVm.officeSubDistrictText = "Sub-District";
						workDetailsVm.officeVillageTownText = "Village/Town";
						workDetailsVm.officeCityText = "City";
						workDetailsVm.officeEmailText = "OFFICE_EMAIL";

					}else if(workDetailsVm.detail.employmentType.key == "Homemaker" || workDetailsVm.detail.employmentType.key == "Pensioner"){
						homeLoanService.setHomeRetired(true);
						workDetailsVm.isIncomeFromHouseProp = true;
					}else if(workDetailsVm.detail.employmentType.key == "PensionerR"){
						workDetailsVm.isNetMonthlyIncome = true;
						workDetailsVm.isIncomeFromHouseProp = true;
						workDetailsVm.isEmployerType = true;
						workDetailsVm.isWorkExp = true;
						workDetailsVm.isOfficeDetails = true;
						workDetailsVm.officeAddressLine1Text = "ADDRESS_LINE_1_OPT";
						workDetailsVm.officePincodeText = "PINCODE_OPT";
						workDetailsVm.officeStateText = "State (Optional)";
						workDetailsVm.officeDistrictText = "District (Optional)";
						workDetailsVm.officeSubDistrictText = "Sub-District (Optional)";
						workDetailsVm.officeVillageTownText = "Village/Town (Optional)";
						workDetailsVm.officeCityText = "City (Optional)";
						workDetailsVm.officeEmailText = "OFFICE_EMAIL_OPT";

					}else if(workDetailsVm.detail.employmentType.key == "Salaried"){
						workDetailsVm.isIncomeFromHouseProp = true;
						workDetailsVm.isNetMonthlyIncome = true;
						workDetailsVm.isRetirementAge = true;
						workDetailsVm.isWorkExp = true;
						workDetailsVm.isMonthsInCurrJob = true;
						workDetailsVm.isEmployerType = true;
						workDetailsVm.isOfficeDetails = true;
						workDetailsVm.officeAddressLine1Text = "ADDRESS_LINE_1";
						workDetailsVm.officePincodeText = "PINCODE";
						workDetailsVm.officeStateText = "State";
						workDetailsVm.officeDistrictText = "District";
						workDetailsVm.officeSubDistrictText = "Sub-District";
						workDetailsVm.officeVillageTownText = "Village/Town";
						workDetailsVm.officeCityText = "City";
						workDetailsVm.officeEmailText = "OFFICE_EMAIL";
					}else if(workDetailsVm.detail.employmentType.key == "Self-Employed"){
						workDetailsVm.isIncomeFromHouseProp = true;
						//workDetailsVm.isNetMonthlyIncome = true;
						workDetailsVm.isNetAnnualIncome = true;
						workDetailsVm.isWorkExp = true;
						workDetailsVm.isMonthsInCurrJobProfession = true;
						workDetailsVm.isProfessionType = true;
						workDetailsVm.isOfficeDetails = true;
						workDetailsVm.detail.professionType = "";
						workDetailsVm.officeAddressLine1Text = "ADDRESS_LINE_1";
						workDetailsVm.officePincodeText = "PINCODE";
						workDetailsVm.officeStateText = "State";
						workDetailsVm.officeDistrictText = "District";
						workDetailsVm.officeSubDistrictText = "Sub-District";
						workDetailsVm.officeVillageTownText = "Village/Town";
						workDetailsVm.officeCityText = "City";
						workDetailsVm.officeEmailText = "OFFICE_EMAIL";

					}else{
						workDetailsVm.hideAllFields();
					}
				}else{
					workDetailsVm.hideAllFields();
				}

			}

			workDetailsVm.showFieldsResume = function(){
				homeLoanService.setHomeRetired(false);
				if(workDetailsVm.detail.employmentType){
					if(workDetailsVm.detail.employmentType.key == "A"){

					}else if(workDetailsVm.detail.employmentType.key == "Businessman"){
						workDetailsVm.isIncomeFromHouseProp = true;
						workDetailsVm.isNetAnnualIncome = true;
						workDetailsVm.isWorkExp = true;
						workDetailsVm.isMonthsInCurrJobProfession = true;
						workDetailsVm.isProfession = true;
						workDetailsVm.isOfficeDetails = true;
						//workDetailsVm.detail.professionType = "";
						workDetailsVm.officeAddressLine1Text = "ADDRESS_LINE_1";
						workDetailsVm.officePincodeText = "PINCODE";
						workDetailsVm.officeStateText = "State";
						workDetailsVm.officeDistrictText = "District";
						workDetailsVm.officeSubDistrictText = "Sub-District";
						workDetailsVm.officeVillageTownText = "Village/Town";
						workDetailsVm.officeCityText = "City";
						workDetailsVm.officeEmailText = "OFFICE_EMAIL";

					}else if(workDetailsVm.detail.employmentType.key == "Homemaker" || workDetailsVm.detail.employmentType.key == "Pensioner"){
						homeLoanService.setHomeRetired(true);
						workDetailsVm.isIncomeFromHouseProp = true;
					}else if(workDetailsVm.detail.employmentType.key == "PensionerR"){
						workDetailsVm.isNetMonthlyIncome = true;
						workDetailsVm.isIncomeFromHouseProp = true;
						workDetailsVm.isEmployerType = true;
						workDetailsVm.isWorkExp = true;
						workDetailsVm.isOfficeDetails = true;
						workDetailsVm.officeAddressLine1Text = "ADDRESS_LINE_1_OPT";
						workDetailsVm.officePincodeText = "PINCODE_OPT";
						workDetailsVm.officeStateText = "State (Optional)";
						workDetailsVm.officeDistrictText = "District (Optional)";
						workDetailsVm.officeSubDistrictText = "Sub-District (Optional)";
						workDetailsVm.officeVillageTownText = "Village/Town (Optional)";
						workDetailsVm.officeCityText = "City (Optional)";
						workDetailsVm.officeEmailText = "OFFICE_EMAIL_OPT";

					}else if(workDetailsVm.detail.employmentType.key == "Salaried"){
						workDetailsVm.isIncomeFromHouseProp = true;
						workDetailsVm.isNetMonthlyIncome = true;
						workDetailsVm.isRetirementAge = true;
						workDetailsVm.isWorkExp = true;
						workDetailsVm.isMonthsInCurrJob = true;
						workDetailsVm.isEmployerType = true;
						workDetailsVm.isOfficeDetails = true;
						workDetailsVm.officeAddressLine1Text = "ADDRESS_LINE_1";
						workDetailsVm.officePincodeText = "PINCODE";
						workDetailsVm.officeStateText = "State";
						workDetailsVm.officeDistrictText = "District";
						workDetailsVm.officeSubDistrictText = "Sub-District";
						workDetailsVm.officeVillageTownText = "Village/Town";
						workDetailsVm.officeCityText = "City";
						workDetailsVm.officeEmailText = "OFFICE_EMAIL";
					}else if(workDetailsVm.detail.employmentType.key == "Self-Employed"){
						workDetailsVm.isIncomeFromHouseProp = true;
						//workDetailsVm.isNetMonthlyIncome = true;
						workDetailsVm.isNetAnnualIncome = true;
						workDetailsVm.isWorkExp = true;
						workDetailsVm.isMonthsInCurrJobProfession = true;
						workDetailsVm.isProfessionType = true;
						workDetailsVm.isOfficeDetails = true;
						//workDetailsVm.detail.professionType = "";
						workDetailsVm.officeAddressLine1Text = "ADDRESS_LINE_1";
						workDetailsVm.officePincodeText = "PINCODE";
						workDetailsVm.officeStateText = "State";
						workDetailsVm.officeDistrictText = "District";
						workDetailsVm.officeSubDistrictText = "Sub-District";
						workDetailsVm.officeVillageTownText = "Village/Town";
						workDetailsVm.officeCityText = "City";
						workDetailsVm.officeEmailText = "OFFICE_EMAIL";

					}else{
						workDetailsVm.hideAllFields();
					}
				}else{
					workDetailsVm.hideAllFields();
				}
			}

			workDetailsVm.showMInfoPopup = function(type){
				console.log("inininiinini")
				//alert("info icon ");
				var templateInfo = "";
				if(type == 'netMonthlyIncome'){
					templateInfo = '<p translate="MONTHLY_INCOME_TOOL_TIP"></p>';
				}else if(type == 'netAnnualIncome'){
					templateInfo = '<p translate="ANNUAL_INCOME_TOOL_TIP"></p>';
				}else if(type == 'houseProp'){
					templateInfo = '<p translate="INCOME_HOUSE_TOOL_TIP"></p>';
				}else if(type == 'propertyCost'){
					templateInfo = '<p translate="PROP_COST_TOOL_TIP"></p>';
				}

				var hlInfoIcon = $ionicPopup.show({
					template: templateInfo,
					title: '',
					cssClass: 'dialog',
					scope: $scope,
					buttons: [{
						text: 'OK',
						type: 'button-positive'
					}]
				});

			}
			
			$scope.$on('$ionicView.loaded', function () {
				
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				initPage();
				$ionicScrollDelegate.resize();
			});		
			
		

			return this;
		}

		
]);
