angularApp.value(
    'loanConfig', {
        "adapterURL": {
            "getLoanLanding": ['adapters/PreApprovedLoanAdapter/Home/getLoanLanding'],
            "getLoanDetail": ['adapters/PreApprovedLoanAdapter/Home/getLoanDetail'],
            "getYonoDedupe": ['adapters/PreApprovedLoanAdapter/Home/getYonoDedupe'],
            "getUnmaskData": ['adapters/PreApprovedLoanAdapter/Home/getUnmaskData'],
            "getPincodeData": ['adapters/ExistingCustomerAccountOpeningAdapter/fetchLocationByPinCode'],
            "getBranchData": ['adapters/ExistingCustomerAccountOpeningAdapter/getBranchesForLocality'],
            "getEligiblityCheck": ['adapters/PreApprovedLoanAdapter/Home/getEligiblityCheck'],
            "getDistrictCity":['adapters/PreApprovedLoanAdapter/Home/getDistrictSubDistrict'],
            "getLosDedupe": ['adapters/PreApprovedLoanAdapter/Home/getLosDedupe'],
            "reviewConsent": ['adapters/PreApprovedLoanAdapter/Home/getApplicationCoApplicant'],
            "updateConsent": ['adapters/PreApprovedLoanAdapter/Home/consentUpdate'],
            "getTermsAndCondition" : ['adapters/PreApprovedLoanAdapter/getTnC'],
            "savePrimaryApplicant" : ['adapters/PreApprovedLoanAdapter/Home/savePrimaryApplicant'],
            "getDocument":['adapters/PreApprovedLoanAdapter/Home/getDocument'],
            "getCoApplicant" : ['adapters/PreApprovedLoanAdapter/Home/getCoApplicant'],
            "saveCoApplicant" : ['adapters/PreApprovedLoanAdapter/Home/saveCoApplicant'],
            "getNmiEmi" : ['adapters/PreApprovedLoanAdapter/Home/getNmiEmi'],
            "getStateForBranch" : ['adapters/PreApprovedLoanAdapter/Home/getStateByBranch'],
            "getDistrictForBranch" : ['adapters/PreApprovedLoanAdapter/Home/getDistrictByBranch'],
            "getCityForBranch" : ['adapters/PreApprovedLoanAdapter/Home/getCityByBranch'],
            "getBranchForLocation" : ['adapters/PreApprovedLoanAdapter/Home/getBranchDetails'],
            "getRecommendedProduct" : ['adapters/PreApprovedLoanAdapter/Home/getRecommendedProduct'],
            "removeApplication" : ['adapters/PreApprovedLoanAdapter/Home/removeApplication'],
            "getBureauCheck" : ['adapters/PreApprovedLoanAdapter/Home/getBureauCheck'],
            "confirmProduct" : ['adapters/PreApprovedLoanAdapter/Home/confirmProduct'],
            "getApplication" : ['adapters/PreApprovedLoanAdapter/Home/getApplication']
        }
    });


angularApp.config([
        '$stateProvider',
        function ($stateProvider) {
            //Cards start
            $stateProvider

                .state('menu.loans', {
                    url: '/loans',
                    data: {
                        pageId: 'LOAN_LNDG'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/loans.html',
                            controller: 'loansController',
                            controllerAs: 'loansVm'
                        }
                    }
                })

                .state('menu.loanCaculator', {
                    url: '/loanCaculator',
                    data: {
                        pageId: 'HL_CAL'
                    },
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/loanCaculator.html',
                            controller: 'loanCaculatorController',
                            controllerAs: 'loanCaculatorVm'
                        }
                    }
                })

                .state('menu.homeLoanError', {
                    url: '/homeLoanError',
                    data: {
                        pageId: 'HL_ERR'
                    },
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/homeLoanError.html',
                            controller: 'homeLoanErrorController',
                            controllerAs: 'homeLoanErrorVm'
                        }
                    }
                })

                .state('menu.homeLoanPersonalDetails', {
                    url: '/homeLoanPersonalDetails',
                    data: {
                        pageId: 'HL_PRSNDETL'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/personalDetails.html',
                            controller: 'personalDetailsControllerHL',
                            controllerAs: 'personalDetailsVm'
                        }
                    }
                })

                .state('menu.calculateEmi', {
                    url: '/calculateEmi',
                    data: {
                        pageId: 'HL_CALEMI'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/calculateEmi.html',
                            controller: 'calculateEmiController',
                            controllerAs: 'calculateEmiVm'
                        }
                    }
                })

                .state('menu.homeLoanResumeLanding', {
                    url: '/homeLoanResumeLanding',
                    data: {
                        pageId: 'HL_RESUME'
                    },
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/resumeLanding.html',
                            controller: 'resumeLandingController',
                            controllerAs: 'resumeLandingVm'
                        }
                    }
                })

                .state('menu.homeLoanSelectBranch', {
                    url: '/homeLoanSelectBranch',
                    data: {
                        pageId: 'HL_SELBRNCH'
                    },
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/hlSelectBranch.html',
                            controller: 'hlSelectBranchController',
                            controllerAs: 'hlSelectBranchVm'
                        }
                    }
                })

                .state('menu.consentStatusHL', {
                    url: '/consentStatusHL',
                    data: {
                        pageId: 'HL_CNSNTSTATUS'
                    },
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/consentStatusHL.html',
                            controller: 'consentStatusHLController',
                            controllerAs: 'consentStatusHLVm'
                        }
                    }
                })

                .state('menu.homeLoanConsentCoApplicant', {
                    url: '/homeLoanConsentCoApplicant',
                    data: {
                        pageId: 'HL_CNSNTCOAPP'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/consentCoApplicant.html',
                            controller: 'consentCoApplicantController',
                            controllerAs: 'consentCoApplicantVm'
                        }
                    }
                })

                .state('menu.homeLoanConsentPrimary', {
                    url: '/homeLoanConsentPrimary',
                    data: {
                        pageId: 'HL_CNSNTPRI'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/consentPrimary.html',
                            controller: 'consentPrimaryController',
                            controllerAs: 'consentPrimaryVm'
                        }
                    }
                })

                .state('menu.homeLoanConsentFinal', {
                    url: '/homeLoanConsentFinal',
                    data: {
                        pageId: 'HL_CNSNTFNL'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/consentFinalApproval.html',
                            controller: 'consentFinalApprovalController',
                            controllerAs: 'consentFinalApprovalVm'
                        }
                    }
                })

                .state('menu.homeLoanDedup', {
                    url: '/homeLoanDedup',
                    data: {
                        pageId: 'HL_DEDUP'
                    },
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/dedup.html',
                            controller: 'dedupController',
                            controllerAs: 'dedupVm'
                        }
                    }
                })

                .state('menu.homeLoanRefNo', {
                    url: '/homeLoanRefNo',
                    data: {
                        pageId: 'HL_REFNO'
                    },
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/hlRefNumber.html',
                            controller: 'hlRefNumberController',
                            controllerAs: 'hlRefNumberVm'
                        }
                    }
                })

                .state('menu.homeLoanRetApp', {
                    url: '/homeLoanRetApp',
                    data: {
                        pageId: 'HL_RETAPP'
                    },
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/hlRetrieveApp.html',
                            controller: 'hlRetrieveAppController',
                            controllerAs: 'hlRetrieveAppVm'
                        }
                    }
                })                

                .state('menu.confirmApplicant', {
                    url: '/confirmApplicant',
                    data: {
                        pageId: 'HL_CNFAPP'
                    },
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/confirmApplicant.html',
                            controller: 'confirmApplicantController',
                            controllerAs: 'confirmApplicantVm'
                        }
                    }
                })

                .state('menu.homeLoanWorkDetails', {
                    url: '/homeLoanWorkDetails',
                    data: {
                        pageId: 'HL_WRKDTL'
                    }, 
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/workDetails.html',
                            controller: 'workDetailsController',
                            controllerAs: 'workDetailsVm'
                        }
                    }
                })

                .state('menu.propDetailsHL', {
                    url: '/propDetailsHL',
                    data: {
                        pageId: 'HL_PROPDTL'
                    }, 
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/propIdentity/propDetailsHL.html',
                            controller: 'propDetailsHLController',
                            controllerAs: 'propDetailsHLVm'
                        }
                    }
                })

                .state('menu.searchPropHL', {
                    url: '/searchPropHL',
                    data: {
                        pageId: 'HL_SRCHPROP'
                    }, 
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/propIdentity/searchPropHL.html',
                            controller: 'searchPropHLController',
                            controllerAs: 'searchPropHLVm'
                        }
                    }
                })

                .state('menu.searchPropDetailsHL', {
                    url: '/searchPropDetailsHL',
                    data: {
                        pageId: 'HL_SRCHPROPDTL'
                    }, 
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/propIdentity/searchPropDetailsHL.html',
                            controller: 'searchPropDetailsHLController',
                            controllerAs: 'searchPropDetailsHLVm'
                        }
                    }
                })

                .state('menu.propByReraHL', {
                    url: '/propByReraHL',
                    data: {
                        pageId: 'HL_PROPRERA'
                    }, 
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/propIdentity/propByReraHL.html',
                            controller: 'propByReraHLController',
                            controllerAs: 'propByReraHLVm'
                        }
                    }
                })

                .state('menu.hlDocLanding', {
                    url: '/hlDocLanding',
                    data: {
                        pageId: 'HL_DOCUPLD'
                    }, 
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/docUpload/hlDocLanding.html',
                            controller: 'hlDocLandingController',
                            controllerAs: 'hlDocLandingVm'
                        }
                    }
                })

                .state('menu.hlProcessFee', {
                    url: '/hlProcessFee',
                    data: {
                        pageId: 'HL_PROCESSFEE'
                    }, 
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/docUpload/hlProcessFee.html',
                            controller: 'hlProcessFeeController',
                            controllerAs: 'hlProcessFeeVm'
                        }
                    }
                })

                .state('menu.hlConfirmSchedule', {
                    url: '/hlConfirmSchedule',
                    data: {
                        pageId: 'HL_PROCESSFEE'
                    }, 
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/docUpload/hlConfirmSchedule.html',
                            controller: 'hlConfirmScheduleController',
                            controllerAs: 'hlConfirmScheduleVm'
                        }
                    }
                })

                .state('menu.hlDocUpload', {
                    url: '/hlDocUpload',
                    data: {
                        pageId: 'HL_DOCUPLD'
                    }, 
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/docUpload/hlDocUpload.html',
                            controller: 'hlDocUploadController',
                            controllerAs: 'hlDocUploadVm'
                        }
                    }
                })

                .state('menu.hlDocUploadSuccess', {
                    url: '/hlDocUploadSuccess',
                    data: {
                        pageId: 'HL_DOCUPLD'
                    }, 
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/docUpload/hlDocUploadSuccess.html',
                            controller: 'hlDocUploadSuccessController',
                            controllerAs: 'hlDocUploadSuccessVm'
                        }
                    }
                })

                .state('menu.hlAddDocument', {
                    url: '/hlAddDocument',
                    data: {
                        pageId: 'HL_ADDDOC'
                    }, 
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/docUpload/hlAddDocument.html',
                            controller: 'hlAddDocumentController',
                            controllerAs: 'hlAddDocumentVm'
                        }
                    }
                })

                .state('menu.addCoApplicant', {
                    url: '/addCoApplicant',
                    data: {
                        pageId: 'HL_ADDCOAPP'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/addCoApplicant.html',
                            controller: 'addCoApplicantController',
                            controllerAs: 'addCoApplicantVm'
                        }
                    }
                })

                .state('menu.recommendProduct', {
                    url: '/recommendProduct',
                    data: {
                        pageId: 'HL_RCMDPRDT'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/recommendProduct.html',
                            controller: 'recommendProductController',
                            controllerAs: 'recommendProductVm'
                        }
                    }
                })

                .state('menu.hlEditProduct', {
                    url: '/hlEditProduct',
                    data: {
                        pageId: 'HL_EDTPRDT'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/editProduct.html',
                            controller: 'editProductController',
                            controllerAs: 'editProductVm'
                        }
                    }
                })

                .state('menu.coApplicantWorkDetails', {
                    url: '/coApplicantWorkDetails',
                    data: {
                        pageId: 'HL_COAPPWRKDTLS'
                    },
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/coApplicantWorkDetails.html',
                            controller: 'coApplicantWorkDetailsController',
                            controllerAs: 'coApplicantWorkDetailsVm'
                        }
                    }
                })

                .state('menu.calculateEmiTakeover', {
                    url: '/calculateEmiTakeover',
                    data: {
                        pageId: 'HL_CALEMITO'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/Takeover/calculateEmiTakeover.html',
                            controller: 'calculateEmiTakeoverController',
                            controllerAs: 'calculateEmiTakeoverVm'
                        }
                    }
                })

                .state('menu.recommendProductTopup', {
                    url: '/recommendProductTopup',
                    data: {
                        pageId: 'HL_CALEMITO'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/Takeover/recommendProductTopup.html',
                            controller: 'recommendProductTopupController',
                            controllerAs: 'recommendProductTopupVm'
                        }
                    }
                })

                

                .state('menu.hlTakeoverSelProperty', {
                    url: '/hlTakeoverSelProperty',
                    data: {
                        pageId: 'HL_TOSELPROP'
                    },
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/Takeover/takeoverPropertyType.html',
                            controller: 'takeoverPropertyTypeController',
                            controllerAs: 'takeoverPropertyTypeVm'
                        }
                    }
                })

                .state('menu.hlTakeoverLoanDetails', {
                    url: '/hlTakeoverLoanDetails',
                    data: {
                        pageId: 'HL_TOLOANDTL'
                    },
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/Takeover/takeoverLoanDetails.html',
                            controller: 'takeoverLoanDetailsController',
                            controllerAs: 'takeoverLoanDetailsVm'
                        }
                    }
                })

                .state('menu.hlTakeoverLoanBenifit', {
                    url: '/hlTakeoverLoanBenifit',
                    data: {
                        pageId: 'HL_TOLOANBNFT'
                    },
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/Takeover/takeoverLoanBenifit.html',
                            controller: 'takeoverLoanBenifitController',
                            controllerAs: 'takeoverLoanBenifitVm'
                        }
                    }
                })

                .state('menu.pmay', {
                    url: '/pmay',
                    data: {
                        pageId: 'HL_PMAY'
                    },
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/PMAY/pmay.html',
                            controller: 'pmayController',
                            controllerAs: 'pmayControllerVm'
                        }
                    }
                })

                .state('menu.eduKnowMore', {
                    url: '/eduKnowMore',
                    data: {
                        pageId: 'EDU_KNOWMORE'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/education/knowMore.html',
                            controller: 'knowMoreController',
                            controllerAs: 'knowMoreVm'
                        }
                    }
                })

                .state('menu.eduSummary', {
                    url: '/eduSummary',
                    data: {
                        pageId: 'EDU_SUMM'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/education/eduSummary.html',
                            controller: 'eduSummaryController',
                            controllerAs: 'eduSummaryVm'
                        }
                    }
                })

                .state('menu.eduTransaction', {
                    url: '/eduTransaction',
                    data: {
                        pageId: 'EDU_TRANS'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/education/eduTransaction.html',
                            controller: 'eduTransactionController',
                            controllerAs: 'eduTransactionVm'
                        }
                    }
                })

                .state('menu.eduRequestDisburse', {
                    url: '/eduRequestDisburse',
                    data: {
                        pageId: 'EDU_REQDIS'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/education/eduRequestDisburse.html',
                            controller: 'eduRequestDisburseController',
                            controllerAs: 'eduRequestDisburseVm'
                        }
                    }
                })

                .state('menu.eduOtp', {
                    url: '/eduOtp',
                    data: {
                        pageId: 'EDU_OTP'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/education/eduOtp.html',
                            controller: 'eduOtpController',
                            controllerAs: 'eduOtpVm'
                        }
                    }
                })

                .state('menu.eduSuccess', {
                    url: '/eduSuccess',
                    data: {
                        pageId: 'EDU_SUCC'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/education/eduSuccess.html',
                            controller: 'eduSuccessController',
                            controllerAs: 'eduSuccessVm'
                        }
                    }
                })

                .state('menu.eduScan', {
                    url: '/eduScan',
                    data: {
                        pageId: 'EDU_SCAN'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/education/eduScan.html',
                            controller: 'eduScanController',
                            controllerAs: 'eduScanVm'
                        }
                    }
                })

                .state('menu.eduCheckStatus', {
                    url: '/eduCheckStatus',
                    data: {
                        pageId: 'EDU_STATUS'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/education/eduCheckStatus.html',
                            controller: 'eduCheckStatusController',
                            controllerAs: 'eduCheckStatusVm'
                        }
                    }
                })
				.state('menu.flpcLanding', {
                    url: '/flpcLanding',
                    data: {
                        pageId: 'LAS_FLPC'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/flpcLanding.html',
                            controller: 'flpcLandingController',
                            controllerAs: 'flpclandingVm'
                        }
                    }
                })
                .state('menu.mobilityLanding', {
                    url: '/mobilityLanding',
                    data: {
                        pageId: 'MOBILITY'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/mobility/mobilityLanding.html',
                            controller: 'mobilityLandingController',
                            controllerAs: 'mobilitylandingVm'
                        }
                    }
                }) 
                
        }
    ]);
