'use strict';
angularApp.controller('loansController', [
    "$state",
    "$scope",
    "$ionicPopup",
    "$translate",
    "$ionicHistory",
    "utilityService",
    "ionicDatePicker",
    "$ionicSideMenuDelegate",
    "loanConfig",
    "homeLoanService",
    "xpressCreditService", "carLoanService","homeScreenService","educationLoanService","ompMerchantsService","customerInfoService","getAccountDetailsService","mPinLoginService","goldLoanRLMSService","loggedInUserService","cryptoService","rxtcService",
    function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, loanConfig, homeLoanService,
     xpressCreditService, carLoanService, homeScreenService, educationLoanService,ompMerchantsService,customerInfoService, getAccountDetailsService,mPinLoginService,goldLoanRLMSService,loggedInUserService,cryptoService,rxtcService) {

        var loansVm = this;

        function initPage() {
            // whitlist check
            loansVm.cugFlagHL = false;
            if (homeLoanService.getlandingPageDetails()) {
                loansVm.groups = homeLoanService.getlandingPageDetails();

                /*Hamberger Menu code loan redirection starts */
                if(homeLoanService.hambergerSelectedLoanType || homeLoanService.preLoginSelectedLoanType){
                    loansVm.checkWhetherCallFromHambergerMenu();
                }
                /*Hamberger Menu code redirection ends */
            } else {
                if (utilityService.isAndroidPlatform()) {
                    loansVm.osType = "android";
                }
                if (utilityService.isIOSPlatform()) { 
                    loansVm.osType = "ios";
                }
                var payload = {
                    "osType": loansVm.osType ? loansVm.osType : ''
                }
                homeLoanService.getLoanLanding(payload).then(function (data) {
                    loansVm.groups = data.getLoans;
                    homeLoanService.setlandingPageDetails(data.getLoans);
                    /*Hamberger Menu code loan redirection starts */
                    if (homeLoanService.hambergerSelectedLoanType || homeLoanService.preLoginSelectedLoanType) {
                        loansVm.checkWhetherCallFromHambergerMenu();
                    }
                    /*Hamberger Menu code redirection ends */
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
            homeLoanService.source = "home";
            loansVm.isBackCheck=homeScreenService.isBackCheck;
            homeScreenService.isBackCheck	=false;
            homeScreenService.dummymenuCheck = true;
        };

        /*Hamberger Menu code loan redirection starts */
        loansVm.checkWhetherCallFromHambergerMenu = function(){
            //calling toggleGroup function from here is imporatnt to open toggle bar at time of redirection from hamberger menu type
            if(homeLoanService.hambergerSelectedLoanType || homeLoanService.preLoginSelectedLoanType){
                console.log("inside init if homeLoanService.hambergerSelectedLoanType = ", homeLoanService.hambergerSelectedLoanType);
                 angular.forEach(loansVm.groups, function (value, key) {
                    if(homeLoanService.hambergerSelectedLoanType == "goldv2"){
                        if(value.id == "gold" || value.id == "goldv2"){
                            homeLoanService.hambergerSelectedLoanType = value.id;
                        }
                    }
                    if (homeLoanService.hambergerSelectedLoanType == "RTXC") {
                        if (value.id == "xpress" || value.id == "RTXC") {
                            homeLoanService.hambergerSelectedLoanType = value.id;
                        }
                    }
                    if(value.id == homeLoanService.hambergerSelectedLoanType || value.id == homeLoanService.preLoginSelectedLoanType){
                        homeLoanService.hambergerSelectedLoanType = null;
                        homeLoanService.preLoginSelectedLoanType= null;
                        loansVm.toggleGroup(value);
                    }
                });
            }
        }
        /*Hamberger Menu code redirection ends */
        loansVm.cancel = function() {
            loansVm.myPopup.close();
        };
        
        loansVm.agree = function() {
            if (!mPinLoginService.isLoggedIn) {
                mPinLoginService.isLoggedIn = false;
            }
            var obj = {
                "pageId": "1"
            };
            ompMerchantsService.getAllCategory(obj).then(function(data) {
                for (var i = 0; i < data.length; i++) {
                    if (data[i].categoryCode.toUpperCase() == "OMPBO90") {
        
                        var obj = {
                            "categoryCode": data[i].categoryCode
                        };
                        ompMerchantsService.getMerchantsByCategory(obj).then(function(data) {
                            for (var i = 0; i < data.length; i++) {
                                if (data[i].merchant.categoryCode.toUpperCase() == "OMPBO90") {
        
                                    loansVm.merchant = data[i];
        
                    var mobileRedirectKey= cryptoService.getSHA512EncryptedData(loggedInUserService.tokenLotus + loansVm.merchant.merchant.mobileData[0].row[0].mobileRedirectUrl).toString();
                                    var saveLeadObj = {
                                        "leadId": "",
                                        "websiteId": loansVm.merchant.merchant.mobileData[0].row[0].websiteId,
                                        "affiliateId": loansVm.merchant.merchant.mobileData[0].row[0].affiliateId,
                                        "request": {
                                            "ompCcustToken": "",
                                            "loggedIn": "",
                                            "channel": "",
                                            "segId": "",
                                            "ompTokenId": "",
                                            "merchantSku": "",
                                            "prdPrice": "",
                                            "wishlistSkus": "",
                                            "ompDisValue": "",
                                            "ompDisPct": "",
                                            "ompDisType": "",
                                            "isLoggedIn": mPinLoginService.isLoggedIn
                                        },
                                        "leadParam": loansVm.merchant.merchant.mobileData[0].row[0].leadParam,
                                        "segmentParam": loansVm.merchant.merchant.mobileData[0].row[0].segmentParam,
                                        "affiliateIdParam": loansVm.merchant.merchant.mobileData[0].row[0].affiliateIdParam,
                     "mobileRedirectUrl" : loansVm.merchant.merchant.mobileData[0].row[0].mobileRedirectUrl,
                     "mobileRedirectKey" : mobileRedirectKey 
        
                                    }
                                    ompMerchantsService.saveLead(saveLeadObj).then(function(data) {
                                        var url = data.data.mobileUrl;
                                        ompMerchantsService.inChromeBrowser(url);
                                    }, function(error) {
                                        utilityService.showErrorMessage(error.responseMessage);
                                    });
                                }
                            }
                        }, function(error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });
        
                    }
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
            loansVm.myPopup.close();
        }
        loansVm.applyknowmore = function(group , isOpenChrome) {
                                          
            if(isOpenChrome){
                                         
                                          loansVm.myPopup = $ionicPopup.show({
                                                                                title: '',
                                                                                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',
                                                                                templateUrl: "pages/bookAndOrder/bookings/disclaimerPopup.html",
                                                                                scope: $scope
                                                                                });
                                          return "";
                }
            if (group.id == "xpress") {
                var request = {
                    "url": group.detailsService
                }
                
                xpressCreditService.getXpressCreditKnowMoreDetails(request).then(function(data) {
                    console.log("getXpressCreditKnowMoreDetails",data);
                    xpressCreditService.knowMoreData.eligibilty = data.getLoansDetails.eligibilty;
                    xpressCreditService.knowMoreData.features = data.getLoansDetails.features;
                    xpressCreditService.knowMoreData.documentation = data.getLoansDetails.documentation;
                    xpressCreditService.knowMoreData.interest = data.getLoansDetails.interest;
                    xpressCreditService.knowMoreData.loanDetails = data.loanDetails[0];
                    $state.go('menu.xcKnowmore');
                    // $state.go('menu.xcAssets');
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else if (group.id == "home") {
                if (homeLoanService.getLoanDetails()) {
                    $state.go('menu.loanCaculator');
                } else {
                    var request = {
                        "url": group.detailsService
                    }
                    homeLoanService.getLoanDetail(request).then(function(data) {

                        homeLoanService.setLoanDetails(data);
                        $state.go('menu.loanCaculator');

                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }
            } else if (group.id == "car") {
                var request = {
                    "url": group.detailsService
                }
                carLoanService.getCarLoanDetails(request).then(function(data) {

                    carLoanService.loanDetails = data;
                    $state.go('menu.carLoanKnowMore');

                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });

            }else if (group.id == "goldv2") {  
            if (goldLoanRLMSService.getGLLoanDetails()) {
                    $state.go('menu.goldKnowMoreRLMS');
                }else{
                    goldLoanRLMSService.getLoanDetail().then(function(data) {
                    goldLoanRLMSService.setGLLoanDetails(data);
                    $state.go('menu.goldKnowMoreRLMS');
                    }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    });
                }               
            }else if (group.id == "RTXC") {
                if (rxtcService.getKnowMoreDetailsData()) {
                    $state.go('menu.rxtcKnowMore');
                } else {
                    rxtcService.getKnowMoreDetails().then(function (data) {
                        rxtcService.setKnowMoreDetailsData(data);
                        $state.go('menu.rxtcKnowMore');
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }
            }

        }

        loansVm.applyloan = function(group,homeLoanIndex) {
            if (group.id == "xpress") {
                if(!customerInfoService.customer.isPanAvailable)
                {
                    homeScreenService.getCustomerInfo().then(function (data) {
                        getAccountDetailsService.accountOverviewData = data;
                        customerInfoService.customer.name = data.customerInformation.customerName;
                        customerInfoService.customer.type = data.customerInformation.customerType;
                        customerInfoService.customer.DOB = data.customerInformation.dob;
                        customerInfoService.customer.isPanAvailable = data.customerInformation.panNumber;
                        customerInfoService.customer.isStaffFlag = data.customerInformation.isStaffFlag;
                        customerInfoService.customer.emailID = data.customerInformation.emailID;
                        customerInfoService.customer.mobile = data.customerInformation.mobile;
                        customerInfoService.customer.title = data.customerInformation.title;
                        customerInfoService.customer.residentialStatus = data.customerInformation.residentialStatus;
                    },
                    function (error) {
                    
                });
                }

                if (xpressCreditService.statusXc == "0") {
                    xpressCreditService.getXpressMaster().then(function(data) {
                        console.log("getXpressMaster", data)
                        xpressCreditService.loanDataFetch(data, xpressCreditService.statusXc);
                        $state.go('menu.xcCreate');
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                } else if (xpressCreditService.statusXc == "1") {
                    xpressCreditService.getXpressCreditDetails().then(function(data) {
                        console.log("getXpressCreditDetails", data)
                        xpressCreditService.checkStatusData.loanAmount = data.loanAmount;
                        xpressCreditService.checkStatusData.referenceNumber = data.refnoLos;
                        xpressCreditService.checkStatusData.status = data.activityValue;
                        xpressCreditService.checkStatusData.date = data.date;
                        xpressCreditService.checkStatusData.branchCode = data.branchCode;
                        xpressCreditService.checkStatusData.conditionalDisplay = data.conditionalDisplay;
                        $state.go('menu.xcSanctionapp');
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                } else if (xpressCreditService.statusXc == "2") {
                    xpressCreditService.retrieveApplication().then(function(data) {
                        console.log("retrieveApplication", data)
                        xpressCreditService.loanDataFetch(data, xpressCreditService.statusXc);

                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }

            } else if (group.id == "home") {
                var request = {
                    "loanType": group.id
                }
                homeLoanService.disableBackButton = false;
                if (homeLoanService.getYonoDedupeData().status == '0' && homeLoanService.getYonoDedupeData().takeOverStatus == '0') {
                    // homeLoanService.clearAll();
                    homeLoanService.getEligiblityCheck(request).then(function(data) {

                        homeLoanService.homeBranch=data.homeBranch;
                        homeLoanService.setGroupId(group.id);
                        homeLoanService.userMaster = data;
                        if (data.status == "HL02") {
                            homeLoanService.dedupErrors = data.reasons;
                            $state.go('menu.homeLoanError');
                        } else if (data.status == "0000") {
                            if(homeLoanIndex == "1"){
                                $state.go('menu.homeLoanPersonalDetails');
                                 //$state.go('menu.hlNTBIdentification');
                            }else{
                                homeLoanService.setGroupId("TAKEOVER");
                                homeLoanService.selectedPropertyTakeover = "C";
                                $state.go('menu.hlTakeoverSelProperty');
                            }
                        } else if (data.status == "HL03") {
                            homeLoanService.multipleAppErrors = data;
                            homeLoanService.isMultipleLOS = true;
                            $state.go('menu.homeLoanRetApp');
                            //                                                                                                           $state.go('menu.homeLoanError');
                        }

                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                } else {
                    homeLoanService.getLosDedupe(request).then(function(data) {
                        homeLoanService.setLosDedupeData(data);
                        if(homeLoanIndex == "1"){
                               homeLoanService.setGroupId(group.id);
                            }else{
                                homeLoanService.setGroupId("TAKEOVER");
                            }
                        $state.go('menu.homeLoanRetApp');
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }
            } else if (group.id == "car") {
                var request = {
                    "loanType": group.id
                }

                if (carLoanService.YonodedupeData.status == '0') {

                    carLoanService.getEligiblityCheck(request).then(function(data) {
                       

                        carLoanService.userMaster = data;
                        carLoanService.homeBranch = data.homeBranch;
                        if (data.status == "CL02") {
                            homeLoanService.source='car';
                            homeLoanService.dedupErrors = data.reasons;
                            $state.go('menu.homeLoanError');
                        } else if (data.status == "0000") {
                            $state.go('menu.carPersonaldetails');

                        } else if (data.status == "CL03") {
                            // carLoanService.multipleAppErrors = data;
                            // carLoanService.isMultipleLOS = true;
                            $state.go('menu.cLExtinginLos');
                            //                                                                                                           $state.go('menu.homeLoanError');
                        }


                    }, function(error) {
                          
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                } else {
                    $state.go('menu.clApplicationStatus');  
                }

            }else if (group.id == "goldv2") {   
                var request = {
                    "loanType": group.id
                }

                if (goldLoanRLMSService.getYonoDedupeData().status == '0') {
                    goldLoanRLMSService.getEligiblityCheck(request).then(function(data) {
                        goldLoanRLMSService.homeBranch=data.homeBranch;
                        goldLoanRLMSService.setGroupId(group.id);
                        goldLoanRLMSService.userMaster = data;
                        if (data.status == "PSGL02") {
                            goldLoanRLMSService.dedupErrors = data.reasons;
                            $state.go('menu.goldLoanErrorRLMS');
                        }else if(data.status == "0000") {
                            $state.go('menu.glPersonalDetailsRLMS');                            
                        } 

                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }else if (goldLoanRLMSService.getYonoDedupeData().status == '1') {
                    goldLoanRLMSService.getEligiblityCheck(request).then(function(data) {
                        goldLoanRLMSService.homeBranch = data.homeBranch;
                        goldLoanRLMSService.setGroupId(group.id);
                        goldLoanRLMSService.resumeData = data;
                        if (data.status == "PSGL02") {
                            goldLoanRLMSService.dedupErrors = data.reasons;
                            $state.go('menu.goldLoanErrorRLMS');
                        }else if(data.status == "0000") {
                            $state.go('menu.glApplicationStatusRLMS');                       
                        }
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }else if (goldLoanRLMSService.getYonoDedupeData().status == '2') {
                    goldLoanRLMSService.getApplicationStatus(request).then(function(data) {
                        goldLoanRLMSService.homeBranch = data.homeBranch;
                        goldLoanRLMSService.setGroupId(group.id);
                        goldLoanRLMSService.retrieveData = data;
                        $state.go('menu.glApplicationStatusRLMS');
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }
            } else if (group.id == "RTXC") {
                rxtcService.salaryAccountSpecial = false;
                rxtcService.isLoanAppSanction = false;
                rxtcService.dataChangeforTNC = false;
                if (rxtcService.getYonoDedupeData().status == '0') {
                    rxtcService.getEligiblityCheck().then(function (data) {
                        rxtcService.clearAll();
                        rxtcService.rtxcPush = false;
                        rxtcService.backToDetails =  false;
                        rxtcService.resumeData = false;
                        rxtcService.setGroupId(group.id);
                        rxtcService.initialData = data;
                        rxtcService.userMaster = data.master;
                        rxtcService.yonoRef = data.yonoRef;
                        if (data.salaryAccountPackage == "DSP" || data.salaryAccountPackage == "PMSP" || data.salaryAccountPackage == "ICGSP") {
                            rxtcService.salaryAccountSpecial = true;
                        }
                        if (!rxtcService.initialData.isDuplicate && rxtcService.initialData.isSanctioned) {
                            rxtcService.isLoanAppSanction = true;
                            rxtcService.initialData.isYonoApp = false;
                            $state.go('menu.rtxcApplicationStatus');
                        }else if (!rxtcService.initialData.isYonoApp && !rxtcService.initialData.isNonYonoApp) {
                            $state.go('menu.rxtcDetails');
                        }else {
                            $state.go('menu.rtxcApplicationStatus');
                        }                      
                    }, function (error) {
                        if(error.responseCode == "IE01"){
                            rxtcService.showAlertPopup("error",error.responseMessage,"","menu.homeScreen","OK","","",""); 
                        }else{
                            utilityService.showErrorMessage(error.responseMessage);
                        }
                    });
                } else if (rxtcService.getYonoDedupeData().status == '1') {
                    rxtcService.getRlmsDedup().then(function (data) {
                        rxtcService.setGroupId(group.id);
                        rxtcService.resumeData = data;
                        rxtcService.userMaster = data.master;
                        rxtcService.yonoRef = data.referenceNo;
                        rxtcService.initialData = false;
                        if (!rxtcService.resumeData.isDuplicate && rxtcService.resumeData.isSanctioned) {
                            rxtcService.isLoanAppSanction = true;
                            rxtcService.resumeData.isYonoApp = false;
                            var reqParams = {
                                "isSanctioned": true
                            }                   
                            rxtcService.deleteApplication(reqParams).then(function() {
                                rxtcService.clearAll();
                                rxtcService.resumeData = false;
                                rxtcService.personalDetailCheck = false;                             
                            },function(error){
                                utilityService.showErrorMessage(error.responseMessage);
                            });
                        }else if (rxtcService.resumeData.isDuplicate) {
                            rxtcService.resumeData.isNonYonoApp = false;
                        }
                        $state.go('menu.rtxcApplicationStatus');
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }
            }
        }



        loansVm.goToAO = function() {
          if(homeScreenService.ishamMenu===true){
            $ionicHistory.goBack();
            //$state.go("menu.homeScreen");
            homeScreenService.ishamMenu=false;
          }else if(homeScreenService.isOMPMenu===true){
            homeScreenService.isOMPMenu=false;
            $state.go('menu.ompMerchants');
            
          }
          else{
          $state.go("menu.accountOverviewMyBalance");
        }
        }

        $scope.$on('$ionicView.loaded', function() {

        });

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        loansVm.toggleGroup = function(group) {
            if (group.id == "home") {
                if (loansVm.isGroupShown(group)) {
                    loansVm.shownGroup = null;
                } else {
                    
                    var request = {
                        "loanType": group.id
                    }
                    homeLoanService.getYonoDedupe(request).then(function(data) {

                        // whitlist check
                        loansVm.cugFlagHL = data.takeoverFlag;
                       
                        loansVm.shownGroup = group;
                        if (group.id == "home") {
                            homeLoanService.setYonoDedupeData(data);
                        } 
                        if (data.status == "0") {
                            loansVm.buttonText = "Apply New Loan";
                        } else if (data.status == "1") {
                            loansVm.buttonText = " Resume ";
                        } else if (data.status == "2") {
                            loansVm.buttonText = " Retrieve ";
                        }

                          loansVm.takeOverStatus = data.takeOverStatus;
                        if (data.takeOverStatus == "0") {
                            loansVm.buttonTextTakeover = "Avail Takeover";
                        } else if (data.takeOverStatus == "1") {
                            loansVm.buttonTextTakeover = " Resume ";
                        } else if (data.takeOverStatus == "2") {
                            loansVm.buttonTextTakeover = " Retrieve ";
                        }

                        homeLoanService.setButtonText(loansVm.buttonText);
                    }, function(error) {
                        loansVm.shownGroup = group;
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }
            } else if (group.id == "car") {
                if (loansVm.isGroupShown(group)) {
                    loansVm.shownGroup = null;
                } else {
                    var request = {
                        "loanType": group.id
                    }
                    carLoanService.getYonoDedupe(request).then(function(data) {
                         loansVm.shownGroup = group;
                        carLoanService.YonodedupeData = data;

                        if (data.status == "0") {
                            loansVm.buttonText = "Apply Now";
                        } else if (data.status == "1") {
                            loansVm.buttonText = " Resume ";
                        }
                        carLoanService.buttonText=loansVm.buttonText;
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }
            } else if (group.id == "xpress") {
                if (loansVm.isGroupShown(group)) {
                    loansVm.shownGroup = null;
                } else {
                    loansVm.shownGroup = group;
                    loansVm.buttonText = "";
                    xpressCreditService.checkApplicationAlreadyApplied().then(function(data) {

                        console.log("checkApplicationAlreadyApplied", data)
                        if (data.buttonText == "0") {
                            loansVm.buttonText = "Apply Now";
                        } else if (data.buttonText == "1") {
                            loansVm.buttonText = " Check Status ";
                        } else if (data.buttonText == "2") {
                            loansVm.buttonText = " Retrieve ";
                        }

                        homeLoanService.setButtonText(loansVm.buttonText);
                        xpressCreditService.statusXc = data.buttonText;
                    }, function(error) {
                        loansVm.buttonText = "Apply Now";
                        xpressCreditService.statusXc = "0";
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }
            } else if(group.id == "education"){
                if(educationLoanService.getKnowMore()){
                    $state.go('menu.eduKnowMore');
                }else{
                    educationLoanService.knowMore().then(function(data) {
                        educationLoanService.setKnowMore(data);
                        $state.go('menu.eduKnowMore');
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }
            }else if (group.id == "goldv2") {
                if (loansVm.isGroupShown(group)) {
                    loansVm.shownGroup = null;
                }else{
                    goldLoanRLMSService.getYonoDedupe().then(function(data) {
                    loansVm.shownGroup = group;
                    if (group.id == "goldv2") {
                        goldLoanRLMSService.setYonoDedupeData(data);  
                    }

                    if (data.status == "0") {
                        loansVm.buttonText = "Apply Now";
                    } else if (data.status == "1") {
                        loansVm.buttonText = " Resume ";
                    } else if (data.status == "2") {
                        loansVm.buttonText = " Retrieve ";
                    }

                    goldLoanRLMSService.setButtonText(loansVm.buttonText);
                }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }                               
            }else if (group.id == "RTXC") {
                if (loansVm.isGroupShown(group)) {
                    loansVm.shownGroup = null;
                } else {
                    rxtcService.getYonoDedupe().then(function (data) {
                        loansVm.shownGroup = group;
                        if (group.id == "RTXC") {
                            rxtcService.setYonoDedupeData(data);
                        }
                        if (data.status == "0") {
                            loansVm.buttonText = "Apply Now";
                        } else if (data.status == "1") {
                            loansVm.buttonText = " Resume ";
                        }
                        rxtcService.setButtonText(loansVm.buttonText);
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                } 
            }else {
                var commingSoon = group.message;
                var alertPopup = $ionicPopup.alert({
                    template: "<p style='text-align:center;font-weight:bold;font-size:16px'>"+commingSoon+"</p>"
                }); 
            }


        };
        loansVm.isGroupShown = function(group) {
            return loansVm.shownGroup === group;
        };
		
		 /* for flpc landing page */
        loansVm.FlpcLanding = function () {
			$state.go('menu.flpcLanding');
		};

        return this;
    }


]);
