'use strict';

angularApp.controller('mobilityLandingController', ["$state", "$scope", "$translate","mobilityLandingService","$ionicSideMenuDelegate","utilityService","$ionicSlideBoxDelegate","homeLoanService","automallService","$filter","homeScreenService","patwlService","loggedInUserService",
    function($state, $scope,$translate,mobilityLandingService, $ionicSideMenuDelegate, utilityService,$ionicSlideBoxDelegate,homeLoanService,automallService,$filter,homeScreenService,patwlService,loggedInUserService) {

        var mobilitylandingVm = this;
        mobilitylandingVm.mobilityData = "";
         mobilitylandingVm.fastTagflag=loggedInUserService.fastTagFlag;
    
        function initPage() {
            mobilitylandingVm.mobilityData = mobilityLandingService.getBannersData();
            mobilitylandingVm.banner1List=[];
            mobilitylandingVm.banner2List=[];
            mobilitylandingVm.getBannersList();            
        }

        mobilitylandingVm.getBannersList = function(){
            if(mobilitylandingVm.mobilityData){
                mobilitylandingVm.banner1List = mobilitylandingVm.mobilityData.level1Banners;            
                if(mobilitylandingVm.mobilityData.level2Banners.length > 0){
                    for (var i = 0; i < mobilitylandingVm.mobilityData.level2Banners.length; i++) {
                        var eligibleSumAssured = $filter('INR')(parseInt(mobilitylandingVm.mobilityData.level2Banners[i].amount));
                        mobilitylandingVm.mobilityData.level2Banners[i].message = mobilitylandingVm.mobilityData.level2Banners[i].message ? mobilitylandingVm.mobilityData.level2Banners[i].message.replace("FIELD_1}}", eligibleSumAssured).replace("Rs. ", String.fromCharCode(8377)) : eligibleSumAssured;
                    }
                }
                mobilitylandingVm.banner2List = mobilitylandingVm.mobilityData.level2Banners;
            }
            
            setTimeout(function () {
                $ionicSlideBoxDelegate.update();
                $ionicSlideBoxDelegate.loop(true);
            }, 500);
        }

        mobilitylandingVm.goBacktoPrevious = function() {
            $state.go('menu.homeScreen');
        };

        mobilitylandingVm.goToLandingPage = function(redirectURL) {
            if(redirectURL=="menu.loans"){
                mobilitylandingVm.gotoCarloan();
            }else if(redirectURL=="menu.automall"){
                mobilitylandingVm.gotoAutomall();
            }else{
                $state.go(redirectURL);
            }
        }

        mobilitylandingVm.goToPreApproved = function(category) {
            if(category == "PA2WL"){
                patwlService.getInitialEligibility().then(function (response) {
					if (response.eligibilityResult.toUpperCase() == 'Y') {
						patwlService.setInitailEligibilityData(response);
						$state.go('menu.patwlLandingPage');
					}
				}, function (error) {
					if (error.responseCode == "IE01") {						
						homeScreenService.isNotificationDataAvail = false;
						patwlService.showAlertPopup("error", error.responseMessage, "", "menu.homeScreen", "OK", "", "", "");
					} else {
						utilityService.showErrorMessage(error.responseMessage);
					}
				});
            }else if(category == "PACL"){
                $state.go('menu.paclReqDetails');
            }
        }

        mobilitylandingVm.gotoCarloan = function() {
            homeLoanService.hambergerSelectedLoanType = "car";
            $state.go('menu.loans');
        };

        mobilitylandingVm.gotoAutomall = function() {
            automallService.getEmiMasterService().then(function (emiMaster) {
                automallService.setMasterEmiData(emiMaster);
                automallService.getAutomallBanners().then(function (banner) {
                    automallService.setLandingBanners(banner);
                    automallService.getOEMListService().then(function (oemList) {
                        automallService.setOemList(oemList);
                        $state.go('menu.automall');
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                        });
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        };

        mobilitylandingVm.gotoFastag = function() {
            $state.go('menu.fasTagLanding');
        };

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });
	
        return this;
    }
]);
