'use strict';

angularApp.controller('branchSelectionController', [
    "$state",
    "$scope",
    "$translate",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService", 
    "$filter",
    "rxtcService",
    "currentLocationService",

    function($state,
        $scope,
        $translate,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        $filter,
        rxtcService,
        currentLocationService) {

        var branchSelectionVm = this;

        branchSelectionVm.initPage = function () {
            rxtcService.ddeFlag = false;
            branchSelectionVm.neslFailedBack = rxtcService.neslFailedBack;
            if (branchSelectionVm.neslFailedBack) {
                branchSelectionVm.hideBackBtn = "Y";
            }else{
                branchSelectionVm.hideBackBtn = "N";
            }
            branchSelectionVm.branchDetails = {};
            branchSelectionVm.salaryAccountSpecial = rxtcService.salaryAccountSpecial;
            if (rxtcService.resumeData) {
                branchSelectionVm.branchCode = rxtcService.getRetrieveData().salaryAccountBranchCode;
            }else{
                branchSelectionVm.branchCode = rxtcService.initialData.salaryAccountBranchCode;
            }

            branchSelectionVm.getHomeBranch();
        }

        branchSelectionVm.getHomeBranch = function() {
            var appRequest= {  
                "code": branchSelectionVm.branchCode
            }

            rxtcService.getBranchByCode(appRequest).then(function(data) {
                if(data.branch.length > 0) {
                    branchSelectionVm.branchDetails.branchName = data.branch[0].branchName;
                    branchSelectionVm.branchDetails.add1 = data.branch[0].add1;
                    branchSelectionVm.branchDetails.add2 = data.branch[0].add2;
                    branchSelectionVm.branchDetails.add3 = data.branch[0].add3;
                    branchSelectionVm.branchDetails.pinCode = data.branch[0].pinCode;
                    branchSelectionVm.branchDetails.latitude = data.branch[0].latitude;
                    branchSelectionVm.branchDetails.longitude = data.branch[0].longitude;
                    branchSelectionVm.branchDetails.brCode = data.branch[0].brCode;
                    rxtcService.setSelectedBranchData(branchSelectionVm.branchDetails);
                }                                         
            },function(error){
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
      

        branchSelectionVm.goback = function() {
            $state.go('menu.rxtcXpressCredit');
        };

        branchSelectionVm.goToReview = function(){
            $state.go('menu.reviewExpressCredit');
        }

        branchSelectionVm.goToNearBranches = function() {
            branchSelectionVm.findBranchesByGPS();
        }

        branchSelectionVm.findBranchesByGPS = function() {
            rxtcService.onlyGoldBranches = false ;
            utilityService.showSpinner();
                currentLocationService.getCurrentPosition().then(
                    function (position) {
                        utilityService.hideSpinner();
                        rxtcService.geocoords = position.coords.latitude + "," + position.coords.longitude;
                        var latitude = position.coords.latitude;
                        var longitude = position.coords.longitude;
                        rxtcService.locateByGPS.length = 0;
                        var params = {
                            "latitude": latitude.toString(),
                            "longitude": longitude.toString(),
                        }
                        
                        if (utilityService.isUndefined(rxtcService.locateByGPS) || rxtcService.locateByGPS.length === 0) {
                            //service call
                            rxtcService.getBranchListByGeo(params).then(function (data) {
                                if (!utilityService.isUndefined(data)) {
                                    rxtcService.locateByGPS = [];
                                    for (var i = 0; i < data.length; i++) {
                                        rxtcService.locateByGPS.push(data[i]);                                                                               
                                        rxtcService.selectedBranch = "";
                                        $state.go('menu.rtxcBranchesNear'); 
                                    }
                                }
                            }, function (error) {
                                utilityService.showErrorMessage(error.responseMessage);                                    
                            });
                        } 
                    },function (err) {
                        //Location permission off
                        utilityService.hideSpinner();
                        rxtcService.onlyGoldBranches = false;
                        $state.go('menu.rtxcGPSError');                      
                    }                    
                );
        }
       

        branchSelectionVm.goToLocCode = function(){
            var appRequest = {};
            rxtcService.getBranchState(appRequest).then(function(data) {
                rxtcService.setBranchStateData(data);                 
                $state.go('menu.rtxcSelectBranchLocCode');
            },function(error){
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            branchSelectionVm.initPage();
        });

        return this;
    }
]);