'use strict';

angularApp.controller('otpExpressCreditController', [
    "$state",
    "$scope",
    "$translate",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService", 
    "$filter",
    "rxtcService",
    "homeLoanService",
    "constantConfig","cryptoService","customerInfoService",

    function($state,
        $scope,
        $translate,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        $filter,
        rxtcService,
        homeLoanService,
        constantConfig,cryptoService,customerInfoService) {

        var otpExpressCreditVm = this;

        otpExpressCreditVm.initPage = function () {
            $scope.resendOtpCounter = 0;
            $scope.invalidOtpCounter = 0;
            otpExpressCreditVm.mobileNo = customerInfoService.customer.mobile;
        }

        otpExpressCreditVm.goback = function() {
            $state.go('menu.accountOverviewMyBalance');
        };

        otpExpressCreditVm.submitOTP = function(){
            if(rxtcService.isValidField(otpExpressCreditVm.otp,"OTP")) {
                otpExpressCreditVm.otpError = rxtcService.isValidField(otpExpressCreditVm.otp,"OTP");
            }else{
                var reqParams = {
                    "otp": otpExpressCreditVm.otp
                }
                var request = {
                    "branchCode": rxtcService.selectedBranchCode,
                    "branchName" : rxtcService.getSelectedBranchData().branchName,
                    "tncFlag": true
                }

                rxtcService.validateOTP(reqParams).then(function(response) {
                    rxtcService.submitApplication(request).then(function(data) {
                        rxtcService.yonoRef = data.yonoRef;
                        rxtcService.validityDate = data.validityDate;
                        $state.go('menu.rxtcCongratulations');
                    },function(error){
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                },function(error){
                    otpExpressCreditVm.otp = null;
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }            
        }

        otpExpressCreditVm.resendOTP = function() {
            $scope.invalidOtpCounter = 0;
            if ($scope.isDisabledOTPbtn) {
                return true;
            }
            otpExpressCreditVm.otp = null;
            otpExpressCreditVm.isValidOtp = true;
            var reqParams = {};           
            reqParams["id"] = otpExpressCreditVm.mobileNumber;
            reqParams.otpCode = constantConfig.keysForOTP.Register;
            reqParams.ocHash = cryptoService.getSHA512EncryptedData(constantConfig.keysForOTP.Register).toString();
            rxtcService.generateOTP(reqParams).then(function (data) {
                rxtcService.showAlertPopup("", "OTP resent Successfully", "", "", "OK", "", "", "");
                $scope.resendOtpCounter += 1;
                if ($scope.resendOtpCounter === 2) {
                    $scope.isDisabledOTPbtn = true;
                }
            }, function (error) {
                otpExpressCreditVm.otpError = '';
                utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });
        };
        $scope.$on('$ionicView.beforeEnter', function() {
            otpExpressCreditVm.initPage();
        });

        return this;
    }
]);