'use strict';

angularApp.controller('reviewExpressCreditController', [
    "$state",
    "$scope",
    "$translate",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService",
    "$filter",
    "rxtcService",
    "homeLoanService",
    "$ionicScrollDelegate",
    "constantConfig",
    "$timeout",
    "$interval",

    function ($state,
        $scope,
        $translate,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        $filter,
        rxtcService,
        homeLoanService,
        $ionicScrollDelegate,
        constantConfig,
        $timeout,
        $interval) {

        var reviewExpressCreditVm = this;
        var intervalCount = 0;

        reviewExpressCreditVm.initPage = function () {
            reviewExpressCreditVm.hideBackBtn = false;
            if (rxtcService.dataChangeforTNC && (rxtcService.letterDownloadedCounter > 0)) {
                reviewExpressCreditVm.letterDownloadedCounter = 1;
            }else{
                reviewExpressCreditVm.letterDownloadedCounter = 0;
            }

            if (rxtcService.neslFailedBack) {
                if (rxtcService.letterDownloadedCounter > 0) {
                    reviewExpressCreditVm.letterDownloadedCounter = 1;
                }else{
                    reviewExpressCreditVm.letterDownloadedCounter = 0;
                }
            }         

            reviewExpressCreditVm.dde = rxtcService.isFromNesl;

            if (rxtcService.getRetrieveData()) {
                reviewExpressCreditVm.reviewDetails = rxtcService.getRetrieveData();
                if (reviewExpressCreditVm.reviewDetails.selectedProductDetail.requestedAmount) {
                    reviewExpressCreditVm.amount = reviewExpressCreditVm.reviewDetails.selectedProductDetail.requestedAmount;
                    reviewExpressCreditVm.tenure = reviewExpressCreditVm.reviewDetails.selectedProductDetail.tenure;
                    reviewExpressCreditVm.interestRate = reviewExpressCreditVm.reviewDetails.selectedProductDetail.interestRate;
                    reviewExpressCreditVm.processingFee = reviewExpressCreditVm.reviewDetails.selectedProductDetail.processingFee;
                    reviewExpressCreditVm.emiAmount = reviewExpressCreditVm.reviewDetails.selectedProductDetail.emi;
                    reviewExpressCreditVm.selectedProduct = reviewExpressCreditVm.reviewDetails.selectedProductDetail.loanproductName;
                }
                reviewExpressCreditVm.isNeslSuccess = false;               
                if (reviewExpressCreditVm.reviewDetails.repaymentDay) {
                    var repaymentDay = reviewExpressCreditVm.reviewDetails.repaymentDay;
                    reviewExpressCreditVm.selectRepaymentDate(repaymentDay);
                }
                if (reviewExpressCreditVm.reviewDetails.ddeFee) {
                    reviewExpressCreditVm.ddeFees = reviewExpressCreditVm.reviewDetails.ddeFee;
                }else{
                    reviewExpressCreditVm.ddeFees = 0;
                }
                if (reviewExpressCreditVm.reviewDetails.stampDutyFee) {
                    reviewExpressCreditVm.stampDuty = reviewExpressCreditVm.reviewDetails.stampDutyFee;
                }
            }

            if (rxtcService.getSelectedBranchData()) {
                reviewExpressCreditVm.branch = rxtcService.getSelectedBranchData();
                reviewExpressCreditVm.branchName = reviewExpressCreditVm.branch.branchName;
                reviewExpressCreditVm.brCode = reviewExpressCreditVm.branch.brCode;
                reviewExpressCreditVm.address = reviewExpressCreditVm.branch.add1 + reviewExpressCreditVm.branch.add2 + reviewExpressCreditVm.branch.add3 + reviewExpressCreditVm.branch.pinCode;
                rxtcService.selectedBranchCode = reviewExpressCreditVm.brCode;
            }
        }

        reviewExpressCreditVm.fileAlreadyDownloaded = function () {
            reviewExpressCreditVm.myPopup1 = $ionicPopup.show({
                template: 'Your Terms and Condition is already downloaded',
                title: '',
                cssClass: 'dialog',
                scope: $scope,
                buttons: [{
                    text: 'OK',
                    type: 'button-positive'
                }]
            });
        }

        reviewExpressCreditVm.selectRepaymentDate = function (repayDay) {
            var monthList = ["JAN", "FEB", "MAR", "APR", "MAY", "JUN", "JUL", "AUG", "SEP", "OCT", "NOV", "DEC"];

            var d = new Date();

            reviewExpressCreditVm.day = d.getDate();

            if (repayDay <= reviewExpressCreditVm.day) {
                reviewExpressCreditVm.repaymentMonth = monthList[(d.getMonth()) + 1];
            } else {
                reviewExpressCreditVm.repaymentMonth = monthList[d.getMonth()];
            }

            reviewExpressCreditVm.repaymentDay = repayDay;
            reviewExpressCreditVm.repaymentyear = d.getFullYear();

            reviewExpressCreditVm.selectedDate = reviewExpressCreditVm.repaymentDay + " " + reviewExpressCreditVm.repaymentMonth + " " + reviewExpressCreditVm.repaymentyear;
        }

        reviewExpressCreditVm.showTnC = function () {
            if (rxtcService.isFromNesl) {
                reviewExpressCreditVm.ddeTnC = "dde";
            } else {
                reviewExpressCreditVm.ddeTnC = "";
            }

            var tncRequest = {
                "type": reviewExpressCreditVm.ddeTnC ? reviewExpressCreditVm.ddeTnC : ""
            };

            rxtcService.getTnC(tncRequest).then(function (data) {
                reviewExpressCreditVm.ddeTnCContent = data;
                reviewExpressCreditVm.tncPopup(reviewExpressCreditVm.ddeTnCContent);
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        reviewExpressCreditVm.tncPopup = function (data) {
            var test = '<ion-content class="padding bottomZero rtxc_tnc_popup_list">'
                + data +
                '<div class="rtxcTnC"><button class="rxtcTnC_button" ng-click="closePopup()">OK</button></div></ion-content>';
                 $scope.bhimErrorPopup = $ionicPopup.show({
                template: test,
                title: 'Terms & Conditions',
                scope: $scope,
                cssClass: 'bhim-alert-popup hlTermnCondition ',
            });
        }

        $scope.closePopup =  function(){
            $scope.bhimErrorPopup.close();
            if (reviewExpressCreditVm.letterDownloadedCounter > 0) {
                reviewExpressCreditVm.fileAlreadyDownloaded();
                if (rxtcService.isFromNesl) {
                    reviewExpressCreditVm.ddeTnCLetter = "TnCWithDDE";
                } else {
                    reviewExpressCreditVm.ddeTnCLetter = "TnCWithoutDDE";
                }
                reviewExpressCreditVm.downloadTnCErrorCheck = '';
            }else{
                reviewExpressCreditVm.downloadTnCLetter();
            }           
        }

        function savebase64AsPDF(filename, content, contentType) {
            reviewExpressCreditVm.popupFolderpath = "";
            var DataBlob = b64toBlob(content, contentType);
            if (utilityService.isAndroidPlatform()) {
                if(device.version==10) {
                    const folderpath = cordova.file.externalDataDirectory;
                    reviewExpressCreditVm.popupFolderpath = folderpath.replace(cordova.file.externalRootDirectory,"") + filename;
                    window.resolveLocalFileSystemURL(folderpath, function(dir) {
                        dir.getFile(filename, { create: true }, function(file) {
                            file.createWriter(function(fileWriter) {
                                fileWriter.write(DataBlob);
                                 //Show popup 
                                var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="RTXC_DOWNLOAD_RECEIPT" translate-values="{filePath:reviewExpressCreditVm.popupFolderpath}"></div>';
                                reviewExpressCreditVm.downloadPopup = $ionicPopup.show({
                                    title: '',
                                    template: template,
                                    scope: $scope,
                                    cssClass: 'my-custom-popup',
                                    buttons: [{
                                        text:'OK',
                                        type: 'button-assertive',
                                        onTap: function() { 
                                            reviewExpressCreditVm.downloadPopup.close();

                                        }
                                    }],
                                });
                            }, function() {});
                        });
                    });
                } else {
                    //for Android below 10 and Android 11 not for 10
                    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem) {
                        fileSystem.root.getDirectory("Download", {create: true, exclusive: false},function(dir) {
                            reviewExpressCreditVm.popupFolderpath = dir.fullPath + filename;
                            dir.getFile(filename, { create: true }, function(file) {
                                file.createWriter(function(fileWriter) {
                                    fileWriter.write(DataBlob);
                                     //Show popup 
                                    var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="RTXC_DOWNLOAD_RECEIPT" translate-values="{filePath:reviewExpressCreditVm.popupFolderpath}"></div>';
                                    reviewExpressCreditVm.downloadPopup = $ionicPopup.show({
                                        title: '',
                                        template: template,
                                        scope: $scope,
                                        cssClass: 'my-custom-popup',
                                        buttons: [{
                                            text:'OK',
                                            type: 'button-assertive',
                                            onTap: function() { 
                                                reviewExpressCreditVm.downloadPopup.close();
                                            }
                                        }],
                                    });
                                }, function() {});
                            });
                        });
                    });
                }               
            }
            if (utilityService.isIOSPlatform()){
                const folderpath = cordova.file.documentsDirectory;
                const finalPath = folderpath + filename;
                window.resolveLocalFileSystemURL(folderpath, function (dir) {
                    dir.getFile(filename, { create: true }, function (file) {
                        file.createWriter(function (fileWriter) {
                            fileWriter.write(DataBlob);
                        }, function () { });
                    });
                });
                cordova.plugins.fileOpener2.open(
                    finalPath,
                    'application/pdf', {
                        error: function (e) {
                            console.log('Error status: ' + e.status + ' - Error message: ' + e.message);
                        },
                        success: function () {
                            console.log('file opened successfully');
                        }
                    }
                );
            }          
        }

        function b64toBlob(b64Data, contentType, sliceSize) {
            contentType = contentType || '';
            sliceSize = sliceSize || 512;
            var byteCharacters = atob(b64Data);
            var byteArrays = [];

            //Check PDF SIZE
            if (byteCharacters.length >= constantConfig.accOverview.pdfSize) {                           
                utilityService.showErrorMessage(constantConfig.accOverview.sizeLimitMessage);
                return;
            }

            for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
                var slice = byteCharacters.slice(offset, offset + sliceSize);
                var byteNumbers = [];
                for (var i = 0; i < slice.length; i++) {
                    byteNumbers[i] = slice.charCodeAt(i);
                }
                var byteArray = new Uint8Array(byteNumbers);
                byteArrays.push(byteArray);
            }
            var blob = new Blob(byteArrays, { type: contentType });
            return blob;
        }


        reviewExpressCreditVm.downloadTnCLetter = function () {
            if (rxtcService.isFromNesl) {
                reviewExpressCreditVm.ddeTnCLetter = "TnCWithDDE";
            } else {
                reviewExpressCreditVm.ddeTnCLetter = "TnCWithoutDDE";
            }

            var payload = {};
            payload = {
                "type": reviewExpressCreditVm.ddeTnCLetter ? reviewExpressCreditVm.ddeTnCLetter : ""
            };

            rxtcService.getPDFContent(payload).then(function (data) {
                reviewExpressCreditVm.letterDownloadedCounter = 1;
                rxtcService.letterDownloadedCounter = reviewExpressCreditVm.letterDownloadedCounter;
                reviewExpressCreditVm.downloadTnCErrorCheck = "";
                var content = data.pdf;
                var filename = data.fileName;
                var contentType = "application/pdf";
                savebase64AsPDF(filename + ".pdf", content, contentType);
            }, function (error) {
                reviewExpressCreditVm.letterDownloadedCounter = 0;
                reviewExpressCreditVm.downloadTnCErrorCheck = "Please download Terms and Conditions to proceed.";
                utilityService.showErrorMessage(error.responseMessage);
            });
        }


        reviewExpressCreditVm.openMaps = function (loc) {
            var geocoords = loc.latitude + "," + loc.longitude;
            if (utilityService.isIOSPlatform()) {
                cordova.ThemeableBrowser.open('https://www.google.com/maps/search/?api=1&query=' + geocoords, '_blank',
                    {
                        statusbar: {
                            color: '#ffffffff'
                        },
                        toolbar: {
                            height: 37,
                            color: '#ffffffff',
                            image: 'share'
                        },

                         closeButton: {
                            image: 'back',
                            height: 37,
                            width: 32,
                            align: 'left',
                            event: 'closePressed'
                        },
                        backButtonCanClose: true
                    });
            } else {
                var label = encodeURI('Your Destination'); // encode the label!
                window.open('geo:0,0?q=' + geocoords + '(' + label + ')', '_system');
            }
        }

        reviewExpressCreditVm.verifyCheckBox = function (val) {
            if (val) {
                reviewExpressCreditVm.errorCheck = '';
                if (reviewExpressCreditVm.letterDownloadedCounter < 1) {
                    reviewExpressCreditVm.showTnC();
                }                         
            } else {
                reviewExpressCreditVm.errorCheck = true;
            }
        }

        reviewExpressCreditVm.goback = function () {
            if (rxtcService.isFromNesl) {
                $state.go('menu.rxtcXpressCredit');
            } else {
                $state.go('menu.branchSelection');
            }
        };

        reviewExpressCreditVm.goToNextPage = function() {
            if(reviewExpressCreditVm.letterDownloadedCounter > 0) {
                if (reviewExpressCreditVm.authorizeEmpCheck) {
                    reviewExpressCreditVm.downloadTnCErrorCheck = "";                
                    if(rxtcService.isFromNesl) {
                        var request = {
                            "tncFlag": reviewExpressCreditVm.authorizeEmpCheck ? "Y" : "N"
                        }
                        rxtcService.getNESLFormData(request).then(function(data) {
                            reviewExpressCreditVm.hideBackBtn = true;
                            var initiatedReq = {
                                "appStatus" : "NESLINITIATED"
                            }
                            rxtcService.saveUpdateAppStatus(initiatedReq).then(function() {
                            },function(error){
                            });
                            rxtcService.yonoRef = data.yonoRef;
                            rxtcService.selectedBranchCode = data.branchCode;
                            var	pageContent = '<!DOCTYPE html><html><head><meta charset="ISO-8859-1"><title>Sample NESL Test</title></head><body><form id="sampleForm" name="sampleForm" action="'+ data.actUrl+'" method="post">' +
                                        '<input type="hidden" id="META_DATA" name="META_DATA" value="'+ data.metaData + '">' +
                                        '<input type="hidden" id="api-key" name="api-key" value="'+ data.apiKey + '">' +
                                        '<input type="hidden" id="Authorization" name="Authorization" value="'+ data.authorization + '">' +
                                        '<input type="hidden" id="clientID" name="clientID" value="'+ data.clientId + '">' +
                                        '<input type="hidden" id="resp-url" name="resp-url" value="'+ data.respUrl + '">' +
                                        '</form> <script type="text/javascript">document.getElementById("sampleForm").submit();'+
                                        '</script></body></html>';
                            var pageContentUrl = 'data:text/html;base64,' + btoa(pageContent);
                            
                            var ref = cordova.ThemeableBrowser.open(pageContentUrl, '_blank', {
                                statusbar:{
                                    color: '#ffffffff'
                                },
                                toolbar: {
                                    height: 37,
                                    color: '#ffffffff',
                                    image: 'share'
                                },
                                backButtonCanClose: true
                            });

                            reviewExpressCreditVm.interval = $interval(function() {
                                intervalCount++ ;                
                                if (intervalCount < 4) {
                                    rxtcService.keepSessionActive().then(function() {
                                    },function(error){
                                    });
                                }else{
                                    $interval.cancel(reviewExpressCreditVm.interval);
                                }
                            }, 150000);

                            ref.addEventListener('loadstart', function (event) {
                                var URL = event.url;
                                console.log("loadstart",event);

                                if(URL.indexOf("sbiyono.sbi/app") > -1) {
                                    $timeout(function () {
                                        ref.close(); 
                                        reviewExpressCreditVm.isNeslSuccess = true;
                                        $state.go('menu.rxtcCongratulations');
                                    }, 100);
                                }else if(URL.indexOf("sbiyono.sbi/index") > -1) {
                                    $timeout(function () {
                                        ref.close(); 
                                        rxtcService.isFromNesl = false;
                                        reviewExpressCreditVm.isNeslSuccess = true;
                                        rxtcService.showAlertPopup("alert","Your DDE process was not successful. Please select branch to proceed further.","","menu.branchSelection","OK","","","");  
                                        rxtcService.neslFailedBack = true;
                                        rxtcService.letterDownloadedCounter = 0 ;
                                        var updateRequest = {
                                            "appStatus" : "NESLFAILED"
                                        }
                                        rxtcService.saveUpdateAppStatus(updateRequest).then(function() {
                                        },function(error){                                            
                                        });
                                    }, 100);
                                }                 
                            });
                            ref.addEventListener("exit", function (event) {
                                $timeout(function () { 
                                    if(!reviewExpressCreditVm.isNeslSuccess) {
                                        $interval.cancel(reviewExpressCreditVm.interval);
                                        rxtcService.isFromNesl = false;
                                        rxtcService.showAlertPopup("alert","Your DDE process was not successful. Please select branch to proceed further.","","menu.branchSelection","OK","","",""); 
                                        rxtcService.neslFailedBack = true;
                                        rxtcService.letterDownloadedCounter = 0 ;
                                        var updateReq = {
                                            "appStatus" : "NESLFAILED"
                                        }
                                        rxtcService.saveUpdateAppStatus(updateReq).then(function() {
                                        },function(error){
                                        });
                                    } 
                                }, 500);
                            });                           
                        }, function(error) {
                            if(error.responseCode == "FT01") {
                                rxtcService.isFromNesl = false;
                                rxtcService.showAlertPopup("error",error.responseMessage,"","menu.branchSelection","OK","","",""); 
                            }else{
                                utilityService.showErrorMessage(error.responseMessage);
                            }
                        });
                    }else{
                        rxtcService.generateOTP().then(function(data) {
                            $state.go('menu.otpExpressCredit');
                        },function(error){
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    }            
                }else{
                    reviewExpressCreditVm.downloadTnCErrorCheck = "";
                    reviewExpressCreditVm.errorCheck = true;
                    $ionicScrollDelegate.scrollBottom();
                }
            }else{                
                reviewExpressCreditVm.downloadTnCErrorCheck = "Please download Terms and Conditions to proceed.";
                $ionicScrollDelegate.scrollBottom();
            }
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            reviewExpressCreditVm.initPage();
        });

        $scope.$on('$ionicView.afterLeave', function () {
            $interval.cancel(reviewExpressCreditVm.interval);
        });

        return this;
    }
]);