'use strict';

angularApp.controller('rtxcApplicationStatusController', [
    "$state",
    "$scope",
    "$translate",  
    "$ionicSideMenuDelegate",
    "$filter", "rxtcService", "$ionicPopup", "utilityService", "$ionicHistory",

    function($state,
        $scope,
        $translate,        
        $ionicSideMenuDelegate,
        $filter, rxtcService, $ionicPopup, utilityService, $ionicHistory) {

        var rtxcApplicationStatusVm = this;
       

        function initPage() {
            rtxcApplicationStatusVm.isLoanAppSanction = rxtcService.isLoanAppSanction;
            if (rxtcService.resumeData) {
                rtxcApplicationStatusVm.isResumeApp = true;
                rtxcApplicationStatusVm.isLoanExistsOnYONO = rxtcService.resumeData.isYonoApp;
                rtxcApplicationStatusVm.isLoanExistsOnNonYONO = rxtcService.resumeData.isNonYonoApp;
                rtxcApplicationStatusVm.refNo = rxtcService.getYonoDedupeData().yonoRef;
            }else{
                rtxcApplicationStatusVm.isLoanExistsOnYONO = rxtcService.initialData.isYonoApp;
                rtxcApplicationStatusVm.isLoanExistsOnNonYONO = rxtcService.initialData.isNonYonoApp;
                rtxcApplicationStatusVm.refNo = rxtcService.initialData.yonoRef;
            }
        }

        rtxcApplicationStatusVm.resumeApp = function() {
            rxtcService.retrieveApplication().then(function(data) {
                rxtcService.reportInitiated = false;
                if (data.salaryAccountType == "DSP" || data.salaryAccountType == "PMSP" || data.salaryAccountType == "ICGSP") {
                    rxtcService.salaryAccountSpecial = true;
                }
                rxtcService.neslFailedBack = false;
                if (!data.stageId) {
                    data.stageId = "1";
                }  
                rxtcService.setRetrieveData(data);
                rxtcService.setPushData();
                if(data.pageId == "1"){
                    if (data.stageId < 3 || (data.stageId == 3 && !data.finalResultOfRTXCDXC)) {
                        $state.go('menu.rtxcEligibilityChecks');
                    }else if ((data.stageId == 3 && ((data.finalResultOfRTXCDXC.toUpperCase()) == "DXC")) || data.stageId == 4) {
                        $state.go('menu.rxtcUploadPhotograph');
                    }else if (data.stageId == 3 && ((data.finalResultOfRTXCDXC.toUpperCase()) == "NONE")) {
                        $state.go('menu.rtxcEligibilityChecks');
                    }                  
                }else if(data.pageId == "2") {
                    if(rxtcService.getRetrieveData().selectedProductDetail){
                        rxtcService.getRetrieveData().selectedProductDetail = "";                  
                    }
                    $state.go('menu.rxtcXpressCredit');
                }else if(data.pageId == "3") {                    
                    if (data.ddeEligible) {
                        if (data.appStatus.toUpperCase() == "NESLFAILED" || data.appStatus.toUpperCase() == "NESLINITIATED" || data.appStatus.toUpperCase() == "FTSUCCESS") {
                            rxtcService.neslFailedBack = true;
                            $state.go('menu.branchSelection');
                        }else if (data.ddeEligible.toUpperCase() == "Y") {
                            rxtcService.ddeEligible = true;
                            $state.go('menu.rxtcXpressCredit');
                        }else{
                            $state.go('menu.branchSelection');
                        } 
                    }else{
                        $state.go('menu.branchSelection');
                    }                                       
                }
                rxtcService.stageId = data.stageId;
            },function(error){
                utilityService.showErrorMessage(error.responseMessage);
            });  
        }

        rtxcApplicationStatusVm.goBack = function() {
            $ionicHistory.goBack(-1);
        }

        rtxcApplicationStatusVm.goToAccOverview = function(){
            $state.go('menu.accountOverviewMyBalance');
        }
        
        rtxcApplicationStatusVm.applyNew = function() {        
            var backPopup = $ionicPopup.alert({
                cssClass: 'bhim-alert-popup',
                template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/alertSymbol.svg"/></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div>'+
                          '<div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter roboto-medium font-size-16 color-darkgrey"><span>Are you sure you want to apply for a new loan?</span><div class="textAlignCenter roboto-regular font-size-14 color-darkgrey">This will delete your current loan application.</div></div></div></div>',
                buttons: [{
                    text: 'Cancel',
                    type: 'button-negative',
                    onTap: function () {
                        backPopup.close();
                    }
                },
                {
                    text: 'Proceed',
                    type: 'button-positive',
                    onTap: function () {
                        var reqParams = {
                            "isSanctioned": false
                        }                   
                        rxtcService.deleteApplication(reqParams).then(function() {
                            rxtcService.clearAll();
                            rxtcService.clearAllFields();
                            rxtcService.resumeData = false;
                            rxtcService.personalDetailCheck = false;
                            $state.go('menu.loans');
                            rxtcService.showAlertPopup("","All your pending applications have been deleted.","",
                                            "menu.loans","OK","","","");                             
                        },function(error){
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                        backPopup.close();
                    }
                }],
            });           
        }



        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        return this;
    }
]);