'use strict';

angularApp.controller('rtxcBranchesNearController', [
    "$state",
    "$scope",
    "$translate",  
    "$ionicSideMenuDelegate",
    "$filter", "rxtcService","$ionicPopover","$ionicPopup","utilityService",
    "$ionicScrollDelegate","currentLocationService",

    function($state,
        $scope,
        $translate,        
        $ionicSideMenuDelegate,
        $filter, rxtcService, $ionicPopover, $ionicPopup,utilityService,
        $ionicScrollDelegate,currentLocationService) {

        var rtxcBranchesNearVm = this;

        function initPage() {
            rtxcBranchesNearVm.branches = [];
            rtxcBranchesNearVm.enableGoldPoint = false;
            rtxcBranchesNearVm.branchError = "";
            rtxcBranchesNearVm.authorizeEmpCheck = false
            
            if(!rxtcService.selectedBranch) {
                rtxcBranchesNearVm.selectedIndexLocation = 100000;
            }
            rtxcBranchesNearVm.branches = angular.copy(rxtcService.locateByGPS);
        }

        rtxcBranchesNearVm.selectBranch = function(loc,index){
            rtxcBranchesNearVm.selectedBranch = loc;
            rxtcService.selectedBranch = rtxcBranchesNearVm.selectedBranch;
            rtxcBranchesNearVm.selectedIndexLocation = index;
            rtxcBranchesNearVm.branchError = "";
        }

        rtxcBranchesNearVm.openMaps = function(loc){
             var geocoords = loc.latitude + "," + loc.longitude;
             if (utilityService.isIOSPlatform()) {
                cordova.ThemeableBrowser.open('https://www.google.com/maps/search/?api=1&query=' + geocoords, '_blank',
                {
                    statusbar: {
                        color:'#ffffffff'
                    },
                    toolbar: {
                        height: 37,
                        color: '#ffffffff',
                        image: 'share'
                    },

                    closeButton: {
                        image:'back',
                        height: 37,
                        width: 32,
                        align: 'left',
                        event: 'closePressed'
                    },

                    backButtonCanClose: true
                });
            }else {
                var label = encodeURI('Your Destination'); // encode the label!
                window.open('geo:0,0?q=' + geocoords + '(' + label + ')', '_system');
            }
         }

        

        rtxcBranchesNearVm.goBack = function() {
            $state.go('menu.branchSelection');
        };

        rtxcBranchesNearVm.goToNextPage = function() {
            rtxcBranchesNearVm.branchError = "";            

            if(rtxcBranchesNearVm.selectedBranch){
                if(rtxcBranchesNearVm.authorizeEmpCheck){
                    rtxcBranchesNearVm.errorCheck = false;
                    rxtcService.setSelectedBranchData(rxtcService.selectedBranch);
                    $state.go('menu.reviewExpressCredit');
                }else{
                    rtxcBranchesNearVm.errorCheck = true;
                    $ionicScrollDelegate.scrollBottom();
                } 
            }else{
                rtxcBranchesNearVm.branchError = true;
                $ionicScrollDelegate.scrollTop();
            }
        };

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        return this;
    }
]);