'use strict';
angularApp.controller('rtxcEligibilityChecksController', [
    "$state",
    "$scope",
    "$ionicPopup",
    "$translate",
    "$ionicHistory",
    "utilityService",
    "ionicDatePicker",
    "$ionicSideMenuDelegate",
    "rxtcService","$timeout","$interval",
    function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate,
        rxtcService, $timeout, $interval) {

        var rtxcEligibilityChecksVm = this;
        var intervalCount = 0;

        function initPage() {            
            rtxcEligibilityChecksVm.pushDataDetails = [];
            rtxcEligibilityChecksVm.stageResponseCheck = true;
            rtxcEligibilityChecksVm.retryFlag = false;

            if(rxtcService.reportInitiated) {
                utilityService.showSpinner();            
                if (!rtxcEligibilityChecksVm.pushData) {
                    rtxcEligibilityChecksVm.serviceResponse = "S";                             
                }
                rtxcEligibilityChecksVm.stageId = rxtcService.getRetrieveData().stageId;

                rtxcEligibilityChecksVm.enquireStageData();                               
            }    

            if (rxtcService.getYonoDedupeData().status == '1' || rxtcService.backToDetails) {
                utilityService.showSpinner();
                if (rxtcService.backToDetails) {
                    rxtcService.backToDetails = false;
                    var stageId = parseInt(rxtcService.initiateReportRequest.stageId) - 1;
                    rtxcEligibilityChecksVm.stageId = stageId.toString();
                    rtxcEligibilityChecksVm.serviceResponse = "S";
                }else{
                    if (parseInt(rxtcService.getRetrieveData().stageId) < 4) {
                        rtxcEligibilityChecksVm.stageId = rxtcService.getRetrieveData().stageId;                        
                        rtxcEligibilityChecksVm.serviceResponse = "S";
                        if (rxtcService.getRetrieveData().finalResultOfRTXCDXC) {
                            if((rxtcService.getRetrieveData().finalResultOfRTXCDXC.toUpperCase()) == "NONE") {
                                utilityService.hideSpinner();
                                rxtcService.clearAll();
                                rxtcService.showAlertPopup("","Looks like your income does not match our criteria for the loan! Please contact your Home Branch for details.","","menu.loans","OK","","",""); 
                            }
                        }else{
                            rtxcEligibilityChecksVm.retrieveData = rxtcService.getRetrieveData();
                            rtxcEligibilityChecksVm.amount = rtxcEligibilityChecksVm.retrieveData.userFilledLoanAmount;
                            rtxcEligibilityChecksVm.emiAmount = rtxcEligibilityChecksVm.retrieveData.userFilledEMI;
                            rtxcEligibilityChecksVm.stageId = rtxcEligibilityChecksVm.retrieveData.stageId;
                            rtxcEligibilityChecksVm.employerDetails = rtxcEligibilityChecksVm.retrieveData.employerDetails;
                            if (rtxcEligibilityChecksVm.retrieveData.stageId > 1) {
                                var stageIdProg = parseInt(rtxcEligibilityChecksVm.retrieveData.stageId) + 1;
                                rtxcEligibilityChecksVm.stageIdInProgress = stageIdProg.toString();
                            }else{
                                rtxcEligibilityChecksVm.stageIdInProgress = rtxcEligibilityChecksVm.retrieveData.stageId;
                            }
                            
                            var request = {
                                "consentRequest" : "N",
                                "userFilledLoanAmount": rtxcEligibilityChecksVm.amount ? rtxcEligibilityChecksVm.amount : "",
                                "userFilledEMI": rtxcEligibilityChecksVm.emiAmount ? rtxcEligibilityChecksVm.emiAmount : "",
                                "stageId": rtxcEligibilityChecksVm.stageIdInProgress ? rtxcEligibilityChecksVm.stageIdInProgress : "",
                                "employerDetails": rtxcEligibilityChecksVm.employerDetails ? rtxcEligibilityChecksVm.employerDetails : "",
                                "authorizeFlag": true
                            }
                            rxtcService.initiateReportRequest = request;
                            rxtcService.initiateReport(request).then(function(data){
                                rtxcEligibilityChecksVm.enquireStageData();
                                utilityService.showSpinner();                  
                            },function(error){
                                if (rtxcEligibilityChecksVm.retrieveData.stageId > 1) {
                                    rtxcEligibilityChecksVm.stageId = parseInt(rtxcEligibilityChecksVm.retrieveData.stageId) + 1;
                                }else{
                                    rtxcEligibilityChecksVm.stageId = rtxcEligibilityChecksVm.retrieveData.stageId;
                                }
                                rtxcEligibilityChecksVm.retryFlag = false;
                                rtxcEligibilityChecksVm.serviceResponse = 'F1';
                                $interval.cancel(rtxcEligibilityChecksVm.pushInterval1);
                            });
                        }
                    }                    
                }                               
            }            
            
            rxtcService.stageId = rtxcEligibilityChecksVm.stageId;
        }

        

        rtxcEligibilityChecksVm.enquireStageData = function(){
            utilityService.showSpinner();
            rtxcEligibilityChecksVm.pushInterval1 = $interval(function() {
                intervalCount++ ;                
                if (intervalCount > 2) {
                    $interval.cancel(rtxcEligibilityChecksVm.pushInterval1);
                    rtxcEligibilityChecksVm.stageId = parseInt(rtxcEligibilityChecksVm.stageId) + 1;
                    utilityService.hideSpinner();
                    rtxcEligibilityChecksVm.retryFlag = false;
                    rtxcEligibilityChecksVm.serviceResponse = 'F1';                    
                }else{
                    rxtcService.enquireEligibilityStage().then(function(data) {
                        rtxcEligibilityChecksVm.pushData = data;
                        rtxcEligibilityChecksVm.updateStageData();          
                    },function(error){
                        $interval.cancel(rtxcEligibilityChecksVm.pushInterval1);
                        rtxcEligibilityChecksVm.stageId = parseInt(rtxcEligibilityChecksVm.stageId) + 1;
                        rtxcEligibilityChecksVm.serviceResponse = 'F1';
                        rtxcEligibilityChecksVm.retryFlag = false;
                    });
                }                    
            },30000); 
        }        


        rtxcEligibilityChecksVm.updateStageData = function() {
            utilityService.showSpinner();
            if (rtxcEligibilityChecksVm.pushData) {
                rtxcEligibilityChecksVm.pushDataDetails = rtxcEligibilityChecksVm.pushData.split('-');
                rtxcEligibilityChecksVm.serviceResponse = rtxcEligibilityChecksVm.pushDataDetails[1];
                rtxcEligibilityChecksVm.stageId = rtxcEligibilityChecksVm.pushDataDetails[2];
            }
            
            if (rtxcEligibilityChecksVm.serviceResponse === 'F1' || rtxcEligibilityChecksVm.serviceResponse === 'F2') {              
                utilityService.hideSpinner();
                $interval.cancel(rtxcEligibilityChecksVm.pushInterval1);
                if (rtxcEligibilityChecksVm.serviceResponse === 'F2'){
                    rxtcService.clearAll();
                    rxtcService.showAlertPopup("","Looks like your income does not match our criteria for the loan! Please contact your Home Branch for details.","","menu.homeScreen","OK","","",""); 
                }                
            }

            if (rtxcEligibilityChecksVm.pushDataDetails.length == 4) {
                $interval.cancel(rtxcEligibilityChecksVm.pushInterval1);
                rtxcEligibilityChecksVm.journeyType = rtxcEligibilityChecksVm.pushDataDetails[3];
                if (rtxcEligibilityChecksVm.journeyType === 'D') {
                    rxtcService.dxcFlag = true;
                }else{
                    rxtcService.dxcFlag = false;
                }
                if (rtxcEligibilityChecksVm.serviceResponse === 'S') {
                    utilityService.hideSpinner();
                    if (!rxtcService.dxcFlag) {
                        $timeout(function() {
                            $state.go('menu.rxtcUploadPhotograph');
                        }, 500);                        
                    }else{
                        rxtcService.showAlertPopup("","Sorry, you are not eligible for Real Time Xpress Credit as of now. Kindly contact the Branch.","","menu.homeScreen","OK","","",""); 
                    }                  
                }
            }
            rxtcService.stageId = rtxcEligibilityChecksVm.stageId;
        }


        rtxcEligibilityChecksVm.retry = function() {
            intervalCount = 0;  
            rtxcEligibilityChecksVm.retryFlag = true;
            utilityService.showSpinner();

            var saveRequest = rxtcService.initiateReportRequest;
            saveRequest.stageId = rtxcEligibilityChecksVm.stageId;
            saveRequest.consentRequest = "N";
            rxtcService.initiateReport(saveRequest).then(function(data) {
                utilityService.showSpinner();
                rtxcEligibilityChecksVm.enquireStageData();                  
            },function(error){
                $interval.cancel(rtxcEligibilityChecksVm.pushInterval1);
                rtxcEligibilityChecksVm.retryFlag = false;
                rtxcEligibilityChecksVm.serviceResponse = 'F1';
            });
        }

        rtxcEligibilityChecksVm.exit = function() {
            $state.go('menu.homeScreen');
        }

        $scope.$on('$ionicView.loaded', function() {
        });

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        $scope.$on('$ionicView.afterLeave', function () {     
            $interval.cancel(rtxcEligibilityChecksVm.pushInterval1);
            // $interval.cancel(rtxcEligibilityChecksVm.pushInterval2);
        });

        return this;
    }


]);