'use strict';

angularApp.controller('rtxcLoanProductController', [
    "$state",
    "$scope",
    "$translate",  
    "$ionicSideMenuDelegate",
    "$filter", "rxtcService", "$ionicPopover", "utilityService",

    function($state,
        $scope,
        $translate,        
        $ionicSideMenuDelegate,
        $filter, rxtcService, $ionicPopover, utilityService) {

        var rtxcLoanProductVm = this;

        function initPage() {
            rtxcLoanProductVm.termloanProductsList = [];
            rtxcLoanProductVm.overDraftProductsList = [];
            rtxcLoanProductVm.loanProductsList = [];
            rtxcLoanProductVm.chooseOverDraft = "Overdraft";
            rtxcLoanProductVm.productsList = [
                                                    {
                                                    "amount": "2000000",
                                                    "productName": "Xpress Credit",
                                                    "productCode": "Code1",
                                                    "productId": "ProductID1",
                                                    "intRate": "12.5",
                                                    "emi": "9166",
                                                    "name": "Xpress Credit",
                                                    "processingFee": "2360",
                                                    "tenure": "72",
                                                    "type" : "term"
                                                  },
                                                  {
                                                    "amount": "500000",
                                                    "productName": "Xpress Overdraft Credit for NPEs",
                                                    "productCode": "Code2",
                                                    "productId": "ProductID2",
                                                    "intRate": "10",
                                                    "emi": "9166",
                                                    "name": "Xpress Overdraft Credit for NPEs",
                                                    "processingFee": "100",
                                                    "tenure": "70",
                                                    "type" : "Overdraft"
                                                  },
                                                    {
                                                    "amount": "5500000",
                                                    "productName": "Xpress term Credit",
                                                    "productCode": "Code3",
                                                    "productId": "ProductID3",
                                                    "intRate": "11.5",
                                                    "emi": "9166",
                                                    "name": "Xpress term Credit",
                                                    "processingFee": "2560",
                                                    "tenure": "75",
                                                    "type" : "term"
                                                  },
                                                  {
                                                    "amount": "1000000",
                                                    "productName": "Xpress Credit Overdraft NPEs",
                                                    "productCode": "Code4",
                                                    "productId": "ProductID4",
                                                    "intRate": "10.25",
                                                    "emi": "9166",
                                                    "name": "Xpress Credit Overdraft NPEs",
                                                    "processingFee": "1000",
                                                    "tenure": "65",
                                                    "type" : "Overdraft"
                                                  },
                                                  {
                                                    "amount": "1500000",
                                                    "productName": "Xpress Credit Overdraft NPEs 2",
                                                    "productCode": "Code5",
                                                    "productId": "ProductID5",
                                                    "intRate": "10",
                                                    "emi": "9166",
                                                    "name": "Xpress Credit Overdraft NPEs 2",
                                                    "processingFee": "100",
                                                    "tenure": "68",
                                                    "type" : "Overdraft"
                                                  }
                                                ];



      
            for(var i=0; i < rtxcLoanProductVm.productsList.length; i++){
                if(rtxcLoanProductVm.productsList[i].type == "term"){
                    rtxcLoanProductVm.termloanProductsList.push(rtxcLoanProductVm.productsList[i]);
                }else{
                    rtxcLoanProductVm.overDraftProductsList.push(rtxcLoanProductVm.productsList[i]);
                }
            }

            if(rtxcLoanProductVm.chooseOverDraft == "TermLoan") {
                rtxcLoanProductVm.loanProductsList = rtxcLoanProductVm.termloanProductsList;
            }else{
                rtxcLoanProductVm.loanProductsList = rtxcLoanProductVm.overDraftProductsList;
            }
            
            rtxcLoanProductVm.productTypeRadio = rtxcLoanProductVm.loanProductsList[0].productCode;
            rtxcLoanProductVm.name = rtxcLoanProductVm.loanProductsList[0].productName;
            rtxcLoanProductVm.intRate = parseFloat(rtxcLoanProductVm.loanProductsList[0].intRate);
            rtxcLoanProductVm.processingFee = parseInt(rtxcLoanProductVm.loanProductsList[0].processingFee);
            rtxcLoanProductVm.tenure = parseInt(rtxcLoanProductVm.loanProductsList[0].tenure);
            rtxcLoanProductVm.amount = parseInt(rtxcLoanProductVm.loanProductsList[0].amount);
            rtxcLoanProductVm.emi = rxtcService.emiCalculation(rtxcLoanProductVm.amount,rtxcLoanProductVm.intRate,rtxcLoanProductVm.tenure);
        }

        rtxcLoanProductVm.toggleProducts = function(product) {
            if (product == "TermLoan") {
                rtxcLoanProductVm.chooseOverDraft = "TermLoan";
                rtxcLoanProductVm.loanProductsList = rtxcLoanProductVm.termloanProductsList;
            }
            if (product == "Overdraft") {
                rtxcLoanProductVm.chooseOverDraft = "Overdraft";
                rtxcLoanProductVm.loanProductsList = rtxcLoanProductVm.overDraftProductsList;
            }
            
            rtxcLoanProductVm.productTypeRadio = rtxcLoanProductVm.loanProductsList[0].productCode;
            rtxcLoanProductVm.name = rtxcLoanProductVm.loanProductsList[0].productName;
            rtxcLoanProductVm.intRate = parseFloat(rtxcLoanProductVm.loanProductsList[0].intRate);
            rtxcLoanProductVm.processingFee = parseInt(rtxcLoanProductVm.loanProductsList[0].processingFee);
            rtxcLoanProductVm.tenure = parseInt(rtxcLoanProductVm.loanProductsList[0].tenure);
            rtxcLoanProductVm.amount = parseInt(rtxcLoanProductVm.loanProductsList[0].amount);
            rtxcLoanProductVm.emi = rxtcService.emiCalculation(rtxcLoanProductVm.amount,rtxcLoanProductVm.intRate,rtxcLoanProductVm.tenure);
                
        }  

        
        rtxcLoanProductVm.selectScheme = function(product) {
            for(var i=0; i < rtxcLoanProductVm.loanProductsList.length; i++) {    
                if(product == rtxcLoanProductVm.loanProductsList[i].productCode) {
                    rtxcLoanProductVm.productTypeRadio = rtxcLoanProductVm.loanProductsList[i].productCode;
                    rtxcLoanProductVm.name = rtxcLoanProductVm.loanProductsList[i].productName;
                    rtxcLoanProductVm.intRate = rtxcLoanProductVm.loanProductsList[i].intRate;
                    rtxcLoanProductVm.processingFee = rtxcLoanProductVm.loanProductsList[i].processingFee;
                    rtxcLoanProductVm.tenure = rtxcLoanProductVm.loanProductsList[i].tenure;
                    rtxcLoanProductVm.amount = rtxcLoanProductVm.loanProductsList[i].amount;
                    rtxcLoanProductVm.emi = rxtcService.emiCalculation(rtxcLoanProductVm.amount,rtxcLoanProductVm.intRate,rtxcLoanProductVm.tenure);
                }
            }
        } 

        rtxcLoanProductVm.goBack = function() {            
            $state.go('menu.rxtcUploadPhotograph');
        };

        rtxcLoanProductVm.goToNextPage = function() {
            $state.go('menu.rxtcDetails');
        };


        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

   
        return this;
    }
]);