'use strict';

angularApp.controller('rtxcSelectBranchLocCodeController', [
    "$state",
    "$scope",
    "$translate",  
    "$ionicSideMenuDelegate",
    "$filter", "rxtcService", "$ionicPopover", "$ionicPopup", "$ionicScrollDelegate", "utilityService",

    function($state,
        $scope,
        $translate,        
        $ionicSideMenuDelegate,
        $filter, rxtcService, $ionicPopover, $ionicPopup, $ionicScrollDelegate, utilityService) {

        var rtxcSelectBranchLocCodeVm = this;

        function initPage() {            
            rtxcSelectBranchLocCodeVm.selTab = 'A';
            if(rxtcService.getBranchStateData()) {
                rtxcSelectBranchLocCodeVm.states = rxtcService.getBranchStateData().state;
            }    
        } 
     
        rtxcSelectBranchLocCodeVm.selType = function(recFlag){
            if(recFlag == 'A'){
                rtxcSelectBranchLocCodeVm.selTab = 'A';
            }else{
                rtxcSelectBranchLocCodeVm.selTab = 'B';
            }
        }

        rtxcSelectBranchLocCodeVm.loadCityArea = function(type) {
                var masterKey = "";
                if(type == 'city') {
                    rtxcSelectBranchLocCodeVm.city="";
                    masterKey = rtxcSelectBranchLocCodeVm.state.key;
                }
            var request = {
                "key": masterKey                  
              };

                if(type == 'city') {
                    rxtcService.getBranchCity(request).then(function(data) {             
                        rtxcSelectBranchLocCodeVm.cities = data.city;                    
                    },function(error){
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }             
            }

        rtxcSelectBranchLocCodeVm.validateForm = function(){
            rtxcSelectBranchLocCodeVm.errObj = {};

            if(rtxcSelectBranchLocCodeVm.selTab == 'A'){
                if(rxtcService.isValidField(rtxcSelectBranchLocCodeVm.state,"State")){
                    rtxcSelectBranchLocCodeVm.errObj.stateError = rxtcService.isValidField(rtxcSelectBranchLocCodeVm.state,"State");
                }
                if(rxtcService.isValidField(rtxcSelectBranchLocCodeVm.city,"City")){
                    rtxcSelectBranchLocCodeVm.errObj.cityError = rxtcService.isValidField(rtxcSelectBranchLocCodeVm.city,"City");
                }
            }else{
                if(rxtcService.isValidField(rtxcSelectBranchLocCodeVm.branchCode,"Branch Code")){
                    rtxcSelectBranchLocCodeVm.errObj.branchCode = rxtcService.isValidField(rtxcSelectBranchLocCodeVm.branchCode,"Branch Code");
                }
            }

            return (angular.equals({}, rtxcSelectBranchLocCodeVm.errObj)) ? true : false;
        }

     

        rtxcSelectBranchLocCodeVm.goBack = function() {
            $state.go('menu.branchSelection');
        };

        rtxcSelectBranchLocCodeVm.goToNextPage = function() {
            if(rtxcSelectBranchLocCodeVm.validateForm()) {
                if(rtxcSelectBranchLocCodeVm.selTab == 'A') {
                    var request= {  
                            "key": rtxcSelectBranchLocCodeVm.state.key+rtxcSelectBranchLocCodeVm.city.key
                        }
                    rxtcService.getBranchByLocation(request).then(function(data) {
                        if(data.branch.length > 0) {
                            rxtcService.setBranchByCodeData(); 
                            rxtcService.setBranchByLocationData(data);          
                            $state.go('menu.rtxcSelectBranchLocCodeList'); 
                        }else{
                            rxtcService.showAlertPopup("","No Branches found.","","menu.rtxcSelectBranchLocCode","OK","","",""); 
                        }                                          
                    },function(error){
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }else{
                    var appRequest= {  
                            "code": rtxcSelectBranchLocCodeVm.branchCode
                        }
                    rxtcService.getBranchByCode(appRequest).then(function(data) {
                        if(data.branch.length > 0) {
                            rxtcService.setBranchByLocationData();
                            rxtcService.setBranchByCodeData(data);             
                            $state.go('menu.rtxcSelectBranchLocCodeList'); 
                        }else{
                            rtxcSelectBranchLocCodeVm.errObj.branchCode = "Incorrect branch code. Please re-check the code";
                        }
                                            
                    },function(error){
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }
            }
        };

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        return this;
    }
]);