'use strict';

angularApp.controller('rtxcSelectBranchLocCodeListController', [
    "$state",
    "$scope",
    "$translate",  
    "$ionicSideMenuDelegate",
    "$filter", "rxtcService", "$ionicPopover", "$ionicPopup", "$ionicScrollDelegate", "utilityService",

    function($state,
        $scope,
        $translate,        
        $ionicSideMenuDelegate,
        $filter, rxtcService, $ionicPopover, $ionicPopup, $ionicScrollDelegate, utilityService) {

        var rtxcSelectBranchLocCodeListVm = this;

        function initPage() {
            rtxcSelectBranchLocCodeListVm.branchError = "";
            rtxcSelectBranchLocCodeListVm.authorizeEmpCheck = false ;
            if(!rxtcService.selectedBranch){
                rtxcSelectBranchLocCodeListVm.selectedIndexLocation = 10000;
            }

            if(rxtcService.getBranchByLocationData()) {
                rtxcSelectBranchLocCodeListVm.branchesByLoCode = rxtcService.getBranchByLocationData().branch;
            }

            if(rxtcService.getBranchByCodeData()) {
                rtxcSelectBranchLocCodeListVm.branchesByLoCode = rxtcService.getBranchByCodeData().branch;
            }
        }

        rtxcSelectBranchLocCodeListVm.selectBranch = function(loc,index){
            rtxcSelectBranchLocCodeListVm.selectedBranch = loc;
            rxtcService.selectedBranch = rtxcSelectBranchLocCodeListVm.selectedBranch;
            rtxcSelectBranchLocCodeListVm.selectedIndexLocation = index;
            rtxcSelectBranchLocCodeListVm.branchError = "";
        }

        rtxcSelectBranchLocCodeListVm.openMaps = function(loc){
             var geocoords = loc.latitude + "," + loc.longitude;
             if (utilityService.isIOSPlatform()) {
                cordova.ThemeableBrowser.open('https://www.google.com/maps/search/?api=1&query='+geocoords, '_blank',
                {
                    statusbar: {
                        color:'#ffffffff'
                    },
                    toolbar: {
                        height: 37,
                        color: '#ffffffff',
                        image: 'share'
                    },

                    closeButton: {
                        image:'back',
                        height: 37,
                        width: 32,
                        align: 'left',
                        event: 'closePressed'
                    },

                    backButtonCanClose: true
                });
            }else {
                var label = encodeURI('Your Destination'); // encode the label!
                window.open('geo:0,0?q=' + geocoords + '(' + label + ')', '_system');
            }
         }

        rtxcSelectBranchLocCodeListVm.goBack = function() {
            $state.go('menu.rtxcSelectBranchLocCode');
        };

        rtxcSelectBranchLocCodeListVm.goToNextPage = function() {
            rtxcSelectBranchLocCodeListVm.branchError = "";
         
            if(rtxcSelectBranchLocCodeListVm.branchesByLoCode.length > 0 && rtxcSelectBranchLocCodeListVm.selectedBranch) {
                if(rtxcSelectBranchLocCodeListVm.authorizeEmpCheck) {
                     rtxcSelectBranchLocCodeListVm.errorCheck = false;
                    rxtcService.setSelectedBranchData(rxtcService.selectedBranch);
                    $state.go('menu.reviewExpressCredit');
                }else{
                    rtxcSelectBranchLocCodeListVm.errorCheck = true;
                    $ionicScrollDelegate.scrollBottom();
                }
            }else{
                rtxcSelectBranchLocCodeListVm.branchError = true;
                $ionicScrollDelegate.scrollTop();
            }   
        };

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        return this;
    }
]);