'use strict';

angularApp.controller('rxtcDetailsController', [
    "$state",
    "$scope",
    "$translate",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService", 
    "$filter",
    "rxtcService",
    "ionicDatePicker",
    "$ionicScrollDelegate",
    "$timeout","customerInfoService",

    function($state,
        $scope,
        $translate,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        $filter,
        rxtcService,
        ionicDatePicker,
        $ionicScrollDelegate,
        $timeout,customerInfoService) {

        var rxtcDetailsVm = this;
        var panReg = /[A-Z]{5}[0-9]{4}[A-Z]{1}/;

        rxtcDetailsVm.initPage = function () {
            rxtcDetailsVm.customerDob = customerInfoService.customer.DOB;
            rxtcDetailsVm.panValidated = false;
            var today = new Date();
            var maxDate = new Date(today.getFullYear(),today.getMonth() , today.getDate() - 1);
            $scope.dateobj = {};
            $scope.dateobj.dt = maxDate;
            var maxDOBDate = new Date(today.getFullYear()-18, today.getMonth(), today.getDate());
            $scope.dateDOBobj = {};
            $scope.dateDOBobj.dt = maxDOBDate;          
            rxtcDetailsVm.errEmpObj = {};
            rxtcDetailsVm.errAmtObj = {};
            rxtcDetailsVm.errPANObj = {};
            rxtcDetailsVm.natureEmp = {};
            rxtcDetailsVm.orgType = {};
            rxtcDetailsVm.existingEMI = false;            
            rxtcDetailsVm.errorCheck = false;
            var monthList = [];
            var yearList = [];
            rxtcDetailsVm.isValidEmployee = false;
            rxtcDetailsVm.masterData = rxtcService.userMaster;
            rxtcDetailsVm.natureEmpList = rxtcDetailsVm.masterData.natureOfEmploymentTypes;
            rxtcDetailsVm.orgTypeList = rxtcDetailsVm.masterData.organisationTypes;
            rxtcDetailsVm.minYear = parseInt(rxtcDetailsVm.masterData.minWorkExpInYear);
            rxtcDetailsVm.maxYear = parseInt(rxtcDetailsVm.masterData.maxWorkExpInYear);
            rxtcDetailsVm.minMonth = parseInt(rxtcDetailsVm.masterData.minWorkExpInMonth);
            rxtcDetailsVm.maxMonth = parseInt(rxtcDetailsVm.masterData.maxWorkExpInMonth);

            for (var i = rxtcDetailsVm.minYear; i <= rxtcDetailsVm.maxYear; i++) {
                yearList.push({
                    key: i,
                    value: i
                });               
            }

            for (var j = rxtcDetailsVm.minMonth; j <= rxtcDetailsVm.maxMonth; j++) {
                monthList.push({
                    key: j,
                    value: j
                });          
            }

            rxtcDetailsVm.monthList = monthList;
            rxtcDetailsVm.yearList = yearList;

            if(rxtcService.initialData){
                rxtcDetailsVm.minLoanAmount = parseInt(rxtcService.initialData.minLoanAmount);
                rxtcDetailsVm.maxLoanAmount = parseInt(rxtcService.initialData.maxLoanAmount);
            }

            if(rxtcService.resumeData){
                rxtcDetailsVm.minLoanAmount = parseInt(rxtcService.resumeData.minLoanAmount);
                rxtcDetailsVm.maxLoanAmount = parseInt(rxtcService.resumeData.maxLoanAmount);
            }

            if(rxtcService.getRetrieveData().userFilledLoanAmount) {
                var totalExp = [];
                var year = '';
                var month = '';
                rxtcDetailsVm.retrieveData = rxtcService.getRetrieveData();
                
                rxtcDetailsVm.pan = rxtcDetailsVm.retrieveData.pan;
                rxtcDetailsVm.dob = rxtcDetailsVm.retrieveData.dob;
                if (rxtcDetailsVm.dob) {
                    $scope.dateDOBobj.dt = rxtcDetailsVm.dob;
                }
                
                rxtcDetailsVm.amount = rxtcDetailsVm.retrieveData.userFilledLoanAmount;
                rxtcDetailsVm.emiAmount = parseInt(rxtcDetailsVm.retrieveData.userFilledEMI);
                if (rxtcDetailsVm.emiAmount > 0) {
                    rxtcDetailsVm.existingEMI = true;
                    rxtcDetailsVm.emiAmount = rxtcDetailsVm.retrieveData.userFilledEMI;
                }

                rxtcDetailsVm.emprName = rxtcDetailsVm.retrieveData.employerDetails.employerName;
                rxtcDetailsVm.isValidEmployee = rxtcDetailsVm.emprName ? true : false;
                rxtcDetailsVm.emprKey = rxtcDetailsVm.retrieveData.employerDetails.employerCode;               
                rxtcDetailsVm.natureEmp = rxtcDetailsVm.retrieveData.employerDetails.employmentNatureForUI;
                rxtcDetailsVm.orgType = rxtcDetailsVm.retrieveData.employerDetails.organisationTypeForUI;
                rxtcDetailsVm.startDate = rxtcDetailsVm.retrieveData.employerDetails.jobStrDate;
                if (rxtcDetailsVm.startDate) {
                    $scope.dateobj.dt = rxtcDetailsVm.startDate;
                }
                rxtcDetailsVm.totalExp = rxtcDetailsVm.retrieveData.employerDetails.totalExp;
                totalExp = rxtcDetailsVm.totalExp.split('/');
                year = (totalExp[0]).toString();
                month = (totalExp[1]).toString();
                rxtcDetailsVm.year = year ? {"key":year,"value":year} : "";
                rxtcDetailsVm.month = month ? {"key":month,"value":month} : "";
                rxtcDetailsVm.authorizeEmpCheck = rxtcDetailsVm.retrieveData.authorizeFlag;                        
            }
           
            if(rxtcDetailsVm.validatedPAN){
                rxtcDetailsVm.expandloanAmnt = true;
                rxtcDetailsVm.expandEmpDetails = false;
            }else{
                rxtcDetailsVm.expandPAN = true;
                rxtcDetailsVm.expandloanAmnt = false;
                rxtcDetailsVm.expandEmpDetails = false;
            }
        }

        rxtcDetailsVm.isPANInput = function() {
            if(rxtcService.isValidField(rxtcDetailsVm.pan,"PAN")) {
                rxtcDetailsVm.errPANObj.panError = rxtcService.isValidField(rxtcDetailsVm.pan,"PAN");
            }
                       
            if(rxtcDetailsVm.pan){
                if (!panReg.test(rxtcDetailsVm.pan)) {
                    rxtcDetailsVm.errPANObj.panError = 'Please enter valid PAN.';
                }else{
                    rxtcDetailsVm.errPANObj.panError = "";
                }
            }
        };

        rxtcDetailsVm.isDOBInput = function() {
            rxtcDetailsVm.errPANObj.dobError = rxtcService.isValidField(rxtcDetailsVm.dob,"Date of Birth");
        };      

        rxtcDetailsVm.isLoanAmtInput = function(amnt) {
            if(amnt){
                    if(amnt > rxtcDetailsVm.maxLoanAmount){
                        rxtcDetailsVm.errAmtObj.amountError = 'You can enter an amount upto a maximum of ₹'+rxtcDetailsVm.maxLoanAmount;
                    }
                    else if(amnt < rxtcDetailsVm.minLoanAmount){
                        rxtcDetailsVm.errAmtObj.amountError = 'You can enter minimum amount of ₹'+rxtcDetailsVm.minLoanAmount;
                    }
                    else{
                        rxtcDetailsVm.errAmtObj.amountError = '';
                        // rxtcDetailsVm.amount -= (amnt % 1000);
                    }
            }else{
                rxtcDetailsVm.errAmtObj.amountError = rxtcService.isValidField(rxtcDetailsVm.amount,"Amount");
            }
        };

        rxtcDetailsVm.isExistingEMIInput = function() {
            if (rxtcService.isValidField(rxtcDetailsVm.emiAmount,"Total EMI Amount")) {
                rxtcDetailsVm.errAmtObj.emiAmountError = rxtcService.isValidField(rxtcDetailsVm.emiAmount,"Total EMI Amount");
            }else{
                rxtcDetailsVm.expandloanAmnt = false;
                rxtcDetailsVm.expandEmpDetails = true;
                rxtcDetailsVm.loanAmntValidated = true;     
            }
               
        };

        rxtcDetailsVm.isEmployerInput = function() {
            rxtcDetailsVm.errEmpObj.emprNameError = rxtcService.isValidField(rxtcDetailsVm.emprName,"Employer Name");
        };

        rxtcDetailsVm.isNatureEmpInput = function() {
            rxtcDetailsVm.errEmpObj.natureEmpError = rxtcService.isValidField(rxtcDetailsVm.natureEmp.value,"Nature of Employment");
        };

        rxtcDetailsVm.isOrgTypeInput = function() {
            rxtcDetailsVm.errEmpObj.orgTypeError = rxtcService.isValidField(rxtcDetailsVm.orgType.value,"Organisation Type");
        };

        rxtcDetailsVm.isStartDateInput = function() {
            rxtcDetailsVm.errEmpObj.startDateError = rxtcService.isValidField(rxtcDetailsVm.startDate,"Current Job Start Date");
        };       

        rxtcDetailsVm.isYearInput = function() {
            rxtcDetailsVm.errEmpObj.yearError = rxtcService.isValidField(rxtcDetailsVm.year.value,"Years");
        };

        rxtcDetailsVm.isMonthInput = function() {
            rxtcDetailsVm.errEmpObj.monthError = rxtcService.isValidField(rxtcDetailsVm.month.value,"Months");
        };

        rxtcDetailsVm.validateBlocks = function(){
            if(rxtcDetailsVm.validateAmountForm()){
                rxtcDetailsVm.loanAmntValidated = true;
            }else{
                rxtcDetailsVm.errAmtObj = {};
                rxtcDetailsVm.loanAmntValidated = false;
            }

            if(rxtcDetailsVm.validateEmpDetailsForm()){
                rxtcDetailsVm.empDetailsValidated = true;
            }else{
                rxtcDetailsVm.errEmpObj = {};
                rxtcDetailsVm.empDetailsValidated = false;
            } 
        }

        rxtcDetailsVm.expandBlock = function(block) {
            rxtcDetailsVm.expandPAN = false;
            rxtcDetailsVm.expandloanAmnt = false;
            rxtcDetailsVm.expandEmpDetails = false;

            if(block == "PAN") {
                rxtcDetailsVm.expandPAN = true;
                rxtcDetailsVm.validateBlocks();     
            }else if(block == "LoanAmount") {
                rxtcDetailsVm.expandloanAmnt = true;
                rxtcDetailsVm.validateBlocks();  
            }else if(block == "EmpDetails") {
                rxtcDetailsVm.expandEmpDetails = true;
                rxtcDetailsVm.validateBlocks();
            }
        }


        rxtcDetailsVm.validatePANDOB = function () {
            if(rxtcDetailsVm.validatePANDOBForm()){
                var saveRequest = {
                    "pan": rxtcDetailsVm.pan ? rxtcDetailsVm.pan : "",
                    "dob": rxtcDetailsVm.dob ? rxtcDetailsVm.dob : ""
                }
                rxtcService.validateUserPAN(saveRequest).then(function(data) {
                    rxtcDetailsVm.expandPAN = false;
                    rxtcDetailsVm.expandloanAmnt = true;
                    rxtcDetailsVm.panValidated = true;
                },function(error) {
                    if(error.responseCode == "DX01") {
                        rxtcService.showAlertPopup("error",error.responseMessage,"","menu.homeScreen","OK","","",""); 
                    }else{
                        utilityService.showErrorMessage(error.responseMessage);
                    }
                }); 
            }                               
        }

        rxtcDetailsVm.submitLoanAmountDetails = function($event) {
            if ($event.keyCode == 13 || $event.which == 13) {
                if(rxtcDetailsVm.validateAmountForm()) {
                    rxtcDetailsVm.expandloanAmnt = false;
                    rxtcDetailsVm.expandEmpDetails = true;
                    rxtcDetailsVm.loanAmntValidated = true;
                }                
            }
        }

        rxtcDetailsVm.selectedName = function(name){
            rxtcDetailsVm.emprName = name.value;
            rxtcDetailsVm.emprKey = name.key;
            rxtcDetailsVm.employeeNames = [];
            rxtcDetailsVm.isValidEmployee = true;
        }

        rxtcDetailsVm.callEmplyeeNames = function(){
            rxtcDetailsVm.isValidEmployee = false;
            if(rxtcDetailsVm.emprName && rxtcDetailsVm.emprName.length >= 3){
                var request = {
                    "key" : rxtcDetailsVm.emprName
                }

                rxtcService.searchEmployerByName(request).then(function(data) {
                    rxtcDetailsVm.employeeNames = [];
                    rxtcDetailsVm.employeeNames = data;
                    $timeout(function(){
                        rxtcDetailsVm.scrollHeight = { "height" : document.getElementsByClassName("list")[0].getBoundingClientRect().height+"px"};
                    },100); 
                }, function(error) {
                    rxtcDetailsVm.employeeNames = [];
                });
            }else{
                rxtcDetailsVm.employeeNames = [];
            }
        }

        rxtcDetailsVm.validateEmpDetailsForm = function() {
            rxtcDetailsVm.errEmpObj = {};
            if(rxtcService.isValidField(rxtcDetailsVm.emprName,"Employer Name")) {
                rxtcDetailsVm.errEmpObj.emprNameError = rxtcService.isValidField(rxtcDetailsVm.emprName,"Employer Name");
            }
            if(rxtcService.isValidField(rxtcDetailsVm.natureEmp.value,"Nature of Employment")) {
                rxtcDetailsVm.errEmpObj.natureEmpError = rxtcService.isValidField(rxtcDetailsVm.natureEmp.value,"Nature of Employment");
            }
            if(rxtcService.isValidField(rxtcDetailsVm.orgType.value,"Organisation Type")) {
                rxtcDetailsVm.errEmpObj.orgTypeError = rxtcService.isValidField(rxtcDetailsVm.orgType.value,"Organisation Type");
            }
            if(rxtcService.isValidField(rxtcDetailsVm.startDate,"Current Job Start Date")) {
                rxtcDetailsVm.errEmpObj.startDateError = rxtcService.isValidField(rxtcDetailsVm.startDate,"Current Job Start Date");
            }
            if(rxtcService.isValidField(rxtcDetailsVm.year,"Years")) {
                rxtcDetailsVm.errEmpObj.yearError = rxtcService.isValidField(rxtcDetailsVm.year,"Years");
            }
            if(rxtcService.isValidField(rxtcDetailsVm.month,"Months")) {
                rxtcDetailsVm.errEmpObj.monthError = rxtcService.isValidField(rxtcDetailsVm.month,"Months");
            }
         
            return (angular.equals({}, rxtcDetailsVm.errEmpObj)) ? true : false;           
        }

        rxtcDetailsVm.validatePANDOBForm = function() {
            rxtcDetailsVm.errPANObj = {};
            if(rxtcService.isValidField(rxtcDetailsVm.pan,"PAN")) {
                rxtcDetailsVm.errPANObj.panError = rxtcService.isValidField(rxtcDetailsVm.pan,"PAN");
            }

            if(rxtcDetailsVm.pan){
                if (!panReg.test(rxtcDetailsVm.pan)) {
                    rxtcDetailsVm.errPANObj.panError = 'Please enter valid PAN.';
                }
            }

            if(rxtcService.isValidField(rxtcDetailsVm.dob,"Date of Birth")) {
                rxtcDetailsVm.errPANObj.dobError = rxtcService.isValidField(rxtcDetailsVm.dob,"Date of Birth");
            }
          
            return (angular.equals({}, rxtcDetailsVm.errPANObj)) ? true : false;        
        }

        rxtcDetailsVm.validateAmountForm = function() {
            rxtcDetailsVm.errAmtObj = {}; 
            if(rxtcService.isValidField(rxtcDetailsVm.amount,"Amount")) {
                rxtcDetailsVm.errAmtObj.amountError = rxtcService.isValidField(rxtcDetailsVm.amount,"Amount");
            }
            if(rxtcDetailsVm.existingEMI) {
               if(rxtcService.isValidField(rxtcDetailsVm.emiAmount,"total EMI amount")) {
                    rxtcDetailsVm.errAmtObj.emiAmountError = rxtcService.isValidField(rxtcDetailsVm.emiAmount,"Total EMI Amount");
                }  
            }
            if(rxtcDetailsVm.amount){
                var amount = parseInt(rxtcDetailsVm.amount);
                if(amount > 2000000){
                    rxtcDetailsVm.errAmtObj.amountError = 'You can enter an amount upto a maximum of ₹20 Lakhs.';
                }else if(rxtcDetailsVm.amount < 25000){
                    rxtcDetailsVm.errAmtObj.amountError = 'You can enter minimum amount of ₹25000.';
                }
            }

            return (angular.equals({}, rxtcDetailsVm.errAmtObj)) ? true : false;        
        }

        rxtcDetailsVm.openDatePicker = function() {
            if(rxtcDetailsVm.dob){            
                var todayInPicker = new Date();
                var maxDateInPicker = new Date(todayInPicker.getFullYear(),todayInPicker.getMonth(),todayInPicker.getDate() - 1); 
                var birthDate = new Date(rxtcDetailsVm.dob);
                var minDateInPicker = new Date(birthDate.getFullYear() + 18,birthDate.getMonth(),birthDate.getDate() + 1);        
                $scope.dateOptions = {
                    maxDate: maxDateInPicker,
                    minDate: minDateInPicker,
                    formatYear: 'yy',
                    startingDay: 1
                }
                var datePickerPopup = $ionicPopup.alert({
                    cssClass: 'rtxc-datepicker-popup',
                    template: '<div class="datePickerBlock font-size-14">'+
                        '<input type="text" datepicker="dd MMM yyyy" ng-model="dateobj.dt" max-date="dateOptions.maxDate" min-date="dateOptions.minDate" format-day-title="dd MMM yyyy" is-open="true" show-weeks="false"/>'+
                        '</div>',
                    scope: $scope, 
                    buttons: [{
                        text: 'Cancel',
                        type: 'button-negative',
                        onTap: function (res) {
                            datePickerPopup.close();
                        }
                    },{
                        text: 'OK',
                        type: 'button-positive',
                        onTap: function (res) {
                            rxtcDetailsVm.errEmpObj.startDateError = '';
                            rxtcDetailsVm.startDate = $filter('date')($scope.dateobj.dt, "dd MMM yyyy");
                        }
                    }],
                });
            }else{
                rxtcDetailsVm.expandPAN = true;
                rxtcDetailsVm.expandEmpDetails = false;
                rxtcDetailsVm.errPANObj.dobError = rxtcService.isValidField(rxtcDetailsVm.dob,"Date of Birth");
            }
        }

        rxtcDetailsVm.openDOBDatePicker = function() {
            var todayInPicker = new Date();
            var maxDateInPicker = new Date(todayInPicker.getFullYear() - 18,todayInPicker.getMonth(),todayInPicker.getDate()); 
            var minDateInPicker = new Date(todayInPicker.getFullYear() - 60,todayInPicker.getMonth(),todayInPicker.getDate());        
            $scope.dateOptions = {
                maxDate: maxDateInPicker,
                minDate: minDateInPicker,
                formatYear: 'yy',
                startingDay: 1
            }
            var datePickerPopup = $ionicPopup.alert({
                cssClass: 'rtxc-datepicker-popup',
                template: '<div class="datePickerBlock font-size-14">'+
                    '<input type="text" datepicker="dd MMM yyyy" ng-model="dateDOBobj.dt" max-date="dateOptions.maxDate" min-date="dateOptions.minDate" format-day-title="dd MMM yyyy" is-open="true" show-weeks="false"/>'+
                    '</div>',
                    scope: $scope, 
                    buttons: [{
                        text: 'Cancel',
                        type: 'button-negative',
                        onTap: function (res) {
                            datePickerPopup.close();
                        }
                    },{
                        text: 'OK',
                        type: 'button-positive',
                        onTap: function (res) {
                            rxtcDetailsVm.errPANObj.dobError = '';
                            rxtcDetailsVm.dob = $filter('date')($scope.dateDOBobj.dt, "dd MMM yyyy");
                        }
                    }],
                });  
        }

        rxtcDetailsVm.goback = function() {
            $state.go('menu.loans');
        };        

        rxtcDetailsVm.goToNextPage = function() {
            if(rxtcDetailsVm.retrieveData){
                if(rxtcDetailsVm.retrieveData.pan || rxtcDetailsVm.retrieveData.dob){
                    if(rxtcDetailsVm.pan === rxtcDetailsVm.retrieveData.pan && rxtcDetailsVm.dob === rxtcDetailsVm.retrieveData.dob){
                        rxtcDetailsVm.panValidated = true;
                    }else{
                        rxtcDetailsVm.panValidated = false;
                    }
                }                
            }

            if(rxtcDetailsVm.validateAmountForm()) {
                rxtcDetailsVm.loanAmntValidated = true;
            }else{
                rxtcDetailsVm.loanAmntValidated = false;
            }

            if(rxtcDetailsVm.validateEmpDetailsForm()) {
                rxtcDetailsVm.empDetailsValidated = true;
            }else{
                 rxtcDetailsVm.empDetailsValidated = false;
            }
                                
            if(rxtcDetailsVm.panValidated && rxtcDetailsVm.loanAmntValidated && rxtcDetailsVm.empDetailsValidated) {
                rxtcDetailsVm.totalExp = rxtcDetailsVm.year.value + '/' + rxtcDetailsVm.month.value;
                rxtcDetailsVm.stageId = 1;
                if(rxtcDetailsVm.authorizeEmpCheck) {
                    if (rxtcService.backToDetails) {
                        rxtcDetailsVm.stageId = rxtcService.stageId;
                    }
                var saveRequest = {
                    "consentRequest" : "Y",
                    "userFilledLoanAmount": rxtcDetailsVm.amount ? rxtcDetailsVm.amount : "",
                    "userFilledEMI": rxtcDetailsVm.emiAmount ? rxtcDetailsVm.emiAmount : "",
                    "stageId": rxtcDetailsVm.stageId ? rxtcDetailsVm.stageId : "",
                    "employerDetails": {
                        "employerCode": rxtcDetailsVm.emprKey ? rxtcDetailsVm.emprKey : "",
                        "employerName": rxtcDetailsVm.emprName ? rxtcDetailsVm.emprName : "",
                        "employmentNatureCode": rxtcDetailsVm.natureEmp ? rxtcDetailsVm.natureEmp.key : "",
                        "employmentNature": rxtcDetailsVm.natureEmp ? rxtcDetailsVm.natureEmp.value : "",
                        "employmentNatureForUI": {
                          "key": rxtcDetailsVm.natureEmp ? rxtcDetailsVm.natureEmp.key : "",
                          "value": rxtcDetailsVm.natureEmp ? rxtcDetailsVm.natureEmp.value : ""
                        },
                        "organisationTypeCode": rxtcDetailsVm.orgType ? rxtcDetailsVm.orgType.key : "",
                        "organisationType": rxtcDetailsVm.orgType ? rxtcDetailsVm.orgType.value : "",
                        "organisationTypeForUI": {
                          "key": rxtcDetailsVm.orgType ? rxtcDetailsVm.orgType.key : "",
                          "value": rxtcDetailsVm.orgType ? rxtcDetailsVm.orgType.value : ""
                        },
                        "totalExp": rxtcDetailsVm.totalExp ? rxtcDetailsVm.totalExp : "",
                        "jobStrDate": rxtcDetailsVm.startDate ? rxtcDetailsVm.startDate : ""
                    },
                    "authorizeFlag": true
                    }    
                    if(rxtcDetailsVm.isValidEmployee){
                        rxtcService.initiateReportRequest = saveRequest;
                        rxtcService.initiateReport(saveRequest).then(function(data) {
                            rxtcService.reportInitiated = true;
                            if (rxtcDetailsVm.pan) {
                                saveRequest.pan = rxtcDetailsVm.pan;
                                saveRequest.dob = rxtcDetailsVm.dob;
                            }                                                   
                            rxtcService.savePageDetails(saveRequest);                 
                            $state.go('menu.rtxcEligibilityChecks');
                        },function(error){
                            utilityService.showErrorMessage(error.responseMessage);
                        }); 
                    }else{
                        utilityService.showErrorMessage("Employer name not found. Please choose value from drop-down list only.");
                    }            
                }else{
                    rxtcDetailsVm.expandPAN = false;
                    rxtcDetailsVm.expandloanAmnt = false;
                    rxtcDetailsVm.expandEmpDetails = false;
                    rxtcDetailsVm.errorCheck = true;
                    $ionicScrollDelegate.scrollBottom();
                }    
            }else{
                rxtcDetailsVm.errorCheck = false;
            }              
        }


        $scope.$on('$ionicView.beforeEnter', function() {
            rxtcDetailsVm.initPage();
            $ionicScrollDelegate.resize();        
        });

        return this;
    }
]);