'use strict';

angularApp.controller('rxtcKnowMoreController', [
    "$state",
    "$scope",
    "$translate",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService", 
    "$filter",
    "rxtcService",
    "$morphCarousel",

    function($state,
        $scope,
        $translate,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        $filter,
        rxtcService,$morphCarousel) {

        var rxtcKnowMoreVm = this;

        rxtcKnowMoreVm.initPage = function () {
            var tenures = [];
            rxtcKnowMoreVm.tab = 1;

            rxtcKnowMoreVm.rtxcKnowMoreDetails = rxtcService.getKnowMoreDetailsData();
    
            rxtcKnowMoreVm.features = rxtcKnowMoreVm.rtxcKnowMoreDetails.getLoansDetails.features;
            rxtcKnowMoreVm.eligibilty = rxtcKnowMoreVm.rtxcKnowMoreDetails.getLoansDetails.eligibilty;
            rxtcKnowMoreVm.documentation = rxtcKnowMoreVm.rtxcKnowMoreDetails.getLoansDetails.documentation;
            rxtcKnowMoreVm.interest = rxtcKnowMoreVm.rtxcKnowMoreDetails.getLoansDetails.interest;

            rxtcKnowMoreVm.loanMaxAmount = rxtcKnowMoreVm.rtxcKnowMoreDetails.emiCalcDetails.maxLoanAmount;
            rxtcKnowMoreVm.loanMinAmount = rxtcKnowMoreVm.rtxcKnowMoreDetails.emiCalcDetails.minLoanAmount;
            rxtcKnowMoreVm.tenures = [];
            var minTenure = parseInt(rxtcKnowMoreVm.rtxcKnowMoreDetails.emiCalcDetails.minTenure);
            var maxTenure = parseInt(rxtcKnowMoreVm.rtxcKnowMoreDetails.emiCalcDetails.maxTenure);
            rxtcKnowMoreVm.steppingAmount = parseInt(rxtcKnowMoreVm.rtxcKnowMoreDetails.emiCalcDetails.steppingAmount);

            for (var i = minTenure; i <= maxTenure; i++) {
                tenures.push(i);
            }

            rxtcKnowMoreVm.tenures = tenures;

            rxtcKnowMoreVm.disableMBtn = false;
            rxtcKnowMoreVm.disablePBtn = false;
            rxtcKnowMoreVm.selectedTenure = maxTenure;

            // rxtcKnowMoreVm.loanAmount = 50000;
            rxtcKnowMoreVm.interestRate = rxtcKnowMoreVm.rtxcKnowMoreDetails.emiCalcDetails.rateOfInterest;
            rxtcKnowMoreVm.tenure = rxtcKnowMoreVm.selectedTenure;

            if(rxtcKnowMoreVm.loanAmount <= rxtcKnowMoreVm.loanMinAmount){          
                rxtcKnowMoreVm.disableMBtn = true;
            }
            if(rxtcKnowMoreVm.loanAmount >= rxtcKnowMoreVm.loanMaxAmount){
                rxtcKnowMoreVm.disablePBtn = true;
            }

            rxtcKnowMoreVm.emiCalculation();
            
            if (rxtcService.getYonoDedupeData().status == '0') {
                rxtcKnowMoreVm.buttonText = "Apply Now";
            }else if(rxtcService.getYonoDedupeData().status == '1'){
                rxtcKnowMoreVm.buttonText = "Resume";
            }
        }

        var listener = $scope.$watch(function () {
            return (rxtcKnowMoreVm.selectedTenure);
        },
        function (tenureValue) {
            if (tenureValue !== undefined) {
                rxtcKnowMoreVm.selectedTenure = tenureValue;
                if (rxtcKnowMoreVm.selectedTenure) {
                    rxtcKnowMoreVm.tenure = rxtcKnowMoreVm.selectedTenure;
                    rxtcKnowMoreVm.emiCalculation();
                }
            }
        });

        rxtcKnowMoreVm.loanAmountCheck = function(loanValue){
            var loanAmt = parseInt(loanValue);
            if((loanAmt % parseInt(rxtcKnowMoreVm.steppingAmount)) > 0){
                rxtcKnowMoreVm.loanAmount -= (loanAmt % parseInt(rxtcKnowMoreVm.steppingAmount));
            }else{
                rxtcKnowMoreVm.loanAmount = loanAmt;
            }
            if(rxtcKnowMoreVm.loanAmount <= rxtcKnowMoreVm.loanMinAmount){
                rxtcKnowMoreVm.loanAmount = parseInt(rxtcKnowMoreVm.loanMinAmount);
                rxtcKnowMoreVm.disableMBtn = true;
            }else{
                rxtcKnowMoreVm.disableMBtn = false;
            }
            if(rxtcKnowMoreVm.loanAmount >= rxtcKnowMoreVm.loanMaxAmount){
                rxtcKnowMoreVm.loanAmount = parseInt(rxtcKnowMoreVm.loanMaxAmount)
                rxtcKnowMoreVm.disablePBtn = true;
            }else{
                rxtcKnowMoreVm.disablePBtn = false;
            }
            rxtcKnowMoreVm.emiCalculation();
        }

        rxtcKnowMoreVm.emiCalculation = function() {
            rxtcKnowMoreVm.emiAmount = rxtcService.emiCalculation(rxtcKnowMoreVm.loanAmount,rxtcKnowMoreVm.interestRate,rxtcKnowMoreVm.tenure);
        }

        rxtcKnowMoreVm.decreaseAmount = function (loanValue) {
            var loanAmount = parseInt(loanValue);
            if(loanAmount){
                rxtcKnowMoreVm.disablePBtn = false;
                if(loanAmount <= rxtcKnowMoreVm.loanMinAmount){
                    rxtcKnowMoreVm.disableMBtn = true;               
                }else{
                    rxtcKnowMoreVm.loanAmount = loanAmount - parseInt(rxtcKnowMoreVm.steppingAmount);
                    if(rxtcKnowMoreVm.loanAmount <= rxtcKnowMoreVm.loanMinAmount){
                        rxtcKnowMoreVm.disableMBtn = true;               
                    }
                }
                rxtcKnowMoreVm.loanAmountCheck(rxtcKnowMoreVm.loanAmount);
                // rxtcKnowMoreVm.emiCalculation();
            }  
        }

        rxtcKnowMoreVm.increaseAmount = function (loanValue) {
            var loanAmount = parseInt(loanValue);
            if(loanAmount){
                rxtcKnowMoreVm.disableMBtn = false;
                if(loanAmount >= rxtcKnowMoreVm.loanMaxAmount){
                    rxtcKnowMoreVm.disablePBtn = true;              
                }else{
                    rxtcKnowMoreVm.loanAmount = loanAmount + parseInt(rxtcKnowMoreVm.steppingAmount);
                    if(rxtcKnowMoreVm.loanAmount >= rxtcKnowMoreVm.loanMaxAmount){
                        rxtcKnowMoreVm.disablePBtn = true;              
                    }
                }
                rxtcKnowMoreVm.loanAmountCheck(rxtcKnowMoreVm.loanAmount);
            }
        }

        rxtcKnowMoreVm.goback = function() {
            $ionicHistory.goBack(-1);
        };
        
        $scope.$on('$ionicView.beforeEnter', function() {
            rxtcKnowMoreVm.initPage();  
            // $state.go("menu.rxtcUploadPhotograph");        
        });

        rxtcKnowMoreVm.selTab = function(sel) {
            rxtcKnowMoreVm.tab = sel;
        }

        rxtcKnowMoreVm.applyNewRTXCLoan = function() {            
            rxtcService.isLoanAppSanction = false;
            if (rxtcService.getYonoDedupeData().status == '0') {
                rxtcService.getEligiblityCheck().then(function(data) {
                    listener();
                    rxtcService.clearAll();
                    rxtcService.rtxcPush = false;
                    rxtcService.backToDetails =  false;
                    rxtcService.resumeData = false;
                    rxtcService.initialData = data;
                    rxtcService.userMaster = data.master;
                    rxtcService.yonoRef = data.yonoRef;
                    if (data.salaryAccountPackage == "DSP" || data.salaryAccountPackage == "PMSP" || data.salaryAccountPackage == "ICGSP") {
                        rxtcService.salaryAccountSpecial = true;
                    }
                    if (!rxtcService.initialData.isDuplicate && rxtcService.initialData.isSanctioned) {
                        rxtcService.isLoanAppSanction = true;
                        rxtcService.initialData.isYonoApp = false;
                        $state.go('menu.rtxcApplicationStatus');
                    }else if (!rxtcService.initialData.isYonoApp && !rxtcService.initialData.isNonYonoApp) {
                        $state.go('menu.rxtcDetails');
                    }else {
                        $state.go('menu.rtxcApplicationStatus');
                    }
                }, function(error) {
                    if(error.responseCode == "IE01"){
                        rxtcService.showAlertPopup("error",error.responseMessage,"","menu.homeScreen","OK","","",""); 
                    }else{
                        utilityService.showErrorMessage(error.responseMessage);
                    }
                });
            }else if (rxtcService.getYonoDedupeData().status == '1') {
                rxtcService.getRlmsDedup().then(function(data) {
                    listener();
                    rxtcService.resumeData = data;
                    rxtcService.userMaster = data.master;
                    rxtcService.yonoRef = data.referenceNo;
                    rxtcService.initialData = false;
                    if (!rxtcService.resumeData.isDuplicate && rxtcService.resumeData.isSanctioned) {
                        rxtcService.isLoanAppSanction = true;
                        rxtcService.resumeData.isYonoApp = false;
                        var reqParams = {
                            "isSanctioned": true
                        }                   
                        rxtcService.deleteApplication(reqParams).then(function() {
                            rxtcService.clearAll();
                            rxtcService.resumeData = false;
                            rxtcService.personalDetailCheck = false;                             
                        },function(error){
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    }else if (rxtcService.resumeData.isDuplicate) {
                        rxtcService.resumeData.isNonYonoApp = false;
                    }
                    $state.go('menu.rtxcApplicationStatus');                        
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }        
        }

        return this;
    }
]);