/**
 *   @ngdoc config
 *   @name angularApp.config : sbiQuickConfig
 *   @description
 *  configuration file for SBI Quick module
 */

/*This function defines all the constants named  Adapters url for cards module*/
angularApp
    /*State defination with respective names, urls, controllers and templates */
    .config([
        '$stateProvider',
        function ($stateProvider) {
            //Cards start
            $stateProvider
                .state('menu.NCMCLanding', {
                    url: '/NCMCLanding',
                    data: {
                        pageId: 'NCMCLANDING'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/ncmc/NCMCLanding.html',
                            controller: 'NCMCLandingController',
                            controllerAs: 'NCMCLandingVm'
                        }
                    }
                })
                .state('menu.NCMCManageNFC', {
                    url: '/NCMCManageNFC',
                    data: {
                        pageId: 'NCMC_MANAGENFC'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/ncmc/manageNFC/NCMCManageNFC.html',
                            controller: 'NCMCManageNFCController',
                            controllerAs: 'NCMCManageNFCVm'
                        }
                    }
                })
                .state('menu.ncmcSuccessMsg', {
                    url: '/NCMCSuccessMsg',
                    data: {
                        pageId: 'NCMC_MANAGENFCSUCCESS'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/ncmc/ncmcSuccess/ncmcSuccess.html',
                            controller: 'ncmcSuccessController',
                            controllerAs: 'ncmcSuccessVm'
                        }
                    }
                })
                .state('menu.NCMCLoadCard', {
                    url: '/NCMCLoadCard',
                    data: {
                        pageId: 'NCMC_LOADCARD'
                    },
                    cache: true,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/ncmc/loadNCMC/NCMCLoadCard.html',
                            controller: 'NCMCLoadCardController',
                            controllerAs: 'NCMCLoadCardVm'
                        }
                    }
                })
                .state('menu.loadNCMCReview', {
                    url: '/loadNCMCReview',
                    data: {
                        pageId: 'NCMC_LOADCARDREVIEW'
                    },
                    cache: true,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/ncmc/loadNCMCReview/loadNCMCReview.html',
                            controller: 'loadNCMCReviewController',
                            controllerAs: 'loadNCMCReviewVm'
                        }
                    }
                })
                .state('menu.loadNCMCOTP', {
                    url: '/loadNCMCOTP',
                    data: {
                        pageId: 'NCMC_LOADNCMCOTP'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/ncmc/loadNCMC/ncmcOtp.html',
                            controller: 'ncmcOtpController',
                            controllerAs: 'ncmcOtpVm'
                        }
                    }
                })
                .state('menu.offlineNCMCStatement', {
                    url: '/offlineNCMCStatement',
                    data: {
                        pageId: 'NCMC_OFFLINENCMCSTATEMENT'
                    },
                    cache: true,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/ncmc/offlineNCMCStatement/offlineNCMCStatement.html',
                            controller: 'offlineNCMCStatementController',
                            controllerAs: 'offlineNCMCStatementVm'
                        }
                    }
                })
                .state('menu.offlineNCMCStatementDetails', {
                    url: '/offlineNCMCStatementDetails',
                    data: {
                        pageId: 'NCMC_OFFLINENCMCSTATEMENTDETAILS'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/ncmc/offlineNCMCStatement/offlineNCMCStatementDetails.html',
                            controller: 'offlineNCMCStatementDetailsController',
                            controllerAs: 'offlineNCMCStatementDetailsVm'
                        }
                    }
                })
                
        }
    ]);
