angularApp.service('NCMCService',
	function ($q, utilityService, AdapterUtils, $state,$ionicPopup) {
		var NCMCservice = this;
		NCMCservice.successMsg = "";
		NCMCservice.refNumber = "";
		NCMCservice.cardNumber = "";
		NCMCservice.accountDetails = [];
		NCMCservice.transactionDetails = [];
		NCMCservice.cardDetails = [];
		NCMCservice.cardFlag = false;
		NCMCservice.normalFDTnC = "";
		NCMCservice.loadAmountData = {
			"accountNumber" : "",
			"cardNumber" : "",
			"cardBalance" : "",
			"amount" : 100,
			"maxAmount":"2000",
			"minAmount":"100",
			"displayName":"",
			"balance":"",
			"accountType":""
		};
		

		NCMCservice.clearNCMCData = function(){
		NCMCservice.successMsg = "";
		NCMCservice.refNumber = "";
		NCMCservice.cardNumber = "";
		NCMCservice.accountDetails = [];
		NCMCservice.transactionDetails = [];
		NCMCservice.cardDetails = [];
		NCMCservice.cardFlag = false;
		NCMCservice.loadAmountData = {
			"accountNumber" : "",
			"cardNumber" : "",
			"cardBalance" : "",
			"amount" : 100,
			"maxAmount":"2000",
			"minAmount":"100",
			"displayName":"",
			"balance":"",
			"accountType":""
		};
		NCMCservice.statementData = {
			"accountNumber" : "",
			"cardNumber" : "",
			
		};
		}

	NCMCservice.getOtp = function() {
	    var q = $q.defer();
	    AdapterUtils.postData("adapters/OTPAdapter/getOTPTokenSecure", {}, true).then(
		    function(response) {
		        q.resolve(response.data);
		    },
		    function(error) {
		        q.reject(error);
		    }
	    );
        return q.promise;
    };

    NCMCservice.validateOtp = function(payLoad) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/OTPAdapter/validateOTPTokenSecure", payLoad, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    NCMCservice.getAccountList = function (obj) {
			var q = $q.defer();
			//AdapterUtils.postData("adapters/FundsTransferAdapter/accountList", obj, true).then(
			AdapterUtils.postData("adapters/HomeAdapter/getAccountsAccessRights", obj, true).then(
				function (response) {
					q.resolve(response.data);
				}, function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
	NCMCservice.getCardListByAcc = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FundsTransferAdapter/Ncmc/cardEnquiryByAccNo", obj, true).then(
				function (response) {
					q.resolve(response.data);
				}, function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
    NCMCservice.getCardFlag = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FundsTransferAdapter/Ncmc/getCardEnquiry", obj, true).then(
				function (response) {
					q.resolve(response.data);
				}, function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		NCMCservice.flagUpdate = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FundsTransferAdapter/Ncmc/flagUpdate", obj, true).then(
				function (response) {
					q.resolve(response.data);
				}, function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		NCMCservice.balanceEnquiry = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FundsTransferAdapter/Ncmc/balanceEnquiry", obj, true).then(
				function (response) {
					q.resolve(response.data);
				}, function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		NCMCservice.addMoney = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FundsTransferAdapter/Ncmc/addMoney", obj, true).then(
				function (response) {
					q.resolve(response.data);
				}, function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		NCMCservice.walletList = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FundsTransferAdapter/Ncmc/walletList", obj, true).then(
				function (response) {
					q.resolve(response.data);
				}, function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		NCMCservice.getTransReceipt = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FundsTransferAdapter/Ncmc/ncmcTransReceipt", obj, true).then(
				function (response) {
					q.resolve(response.data);
				}, function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		NCMCservice.fetchRtermcondition = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/getTnC", obj, true).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		NCMCservice.showTnCAlertModal = function (heading,message,buttonText,callBack) {
			var alertPopup = $ionicPopup.alert({
            title: heading,
            template: '<div class="popupTextBottomPadding ss-p-r-f-8 ss-popup-list font-size-12 font-light ss-text-color">'
            + message + '</div></div>',
            cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite ss-popup',
            buttons: [
					{
						text: buttonText,
						onTap: function(e) {
							callBack();
						}
					}
				],
        	});
		}

		NCMCservice.getFormattedDate = function(date){
			date = new Date(date);
			var dd = date.getDate();
			var mm = date.getMonth() + 1; //January is 0!

			var yyyy = date.getFullYear();
			if (dd < 10) {
			  dd = '0' + dd;
			} 
			if (mm < 10) {
			  mm = '0' + mm;
			} 
			var date = dd + '/' + mm + '/' + yyyy;
			return date;
		}


		return NCMCservice;
	});  
