'use strict';
angularApp.controller('NCMCLoadCardController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"NCMCService",
		"getAccountDetailsService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, NCMCService, getAccountDetailsService) {
			
			var NCMCLoadCardVm = this;
			
			function initPage() {
				$translate(['LOAD_NCMC_SUCCESS']).then(function (translations) {
					NCMCLoadCardVm.success_desc = translations['LOAD_NCMC_SUCCESS'];
					
				});
				

			};
			function initializaValues(){
				NCMCLoadCardVm.showSelect = true;
				NCMCLoadCardVm.showSelectCard = true;
				NCMCLoadCardVm.maxAmount = NCMCService.loadAmountData.maxAmount;
				NCMCLoadCardVm.minAmount = NCMCService.loadAmountData.minAmount;
				NCMCLoadCardVm.amount = NCMCService.loadAmountData.amount;
				NCMCLoadCardVm.cardBalance = NCMCService.loadAmountData.cardBalance;
				NCMCLoadCardVm.cardDetails = NCMCService.cardDetails;
				NCMCLoadCardVm.accType = NCMCService.loadAmountData.accountType;
				NCMCLoadCardVm.lookFor = {
	                value: parseInt(NCMCLoadCardVm.amount),
	                options: {  
	                    ceil: parseInt(NCMCLoadCardVm.maxAmount),
	                    floor: parseInt(NCMCLoadCardVm.minAmount),
	                    showSelectionBar: true,
	                    step: 100,
	                    //onChange: NCMCLoadCardVm.onChangeRangeAmount,
	                    translate: function(value) {
	                    	NCMCLoadCardVm.amount = value;
							return '&#8377;' + value;
	                    }
	                }
	            };
			}
			
			NCMCLoadCardVm.getAccountDetails = function() {	
				if (!NCMCService.accountDetails.length) {
					NCMCService.getAccountList().then(function(data) {
						var account_list = data.accounts;
						var customeInfoAccountList = getAccountDetailsService.accountOverviewData.accounts;

						for(var j=0; j<account_list.length; j++)
						{
							var isAccountExists = -1;
							customeInfoAccountList.some(function(obj, i) {
  								return obj.accountNumber == account_list[j].accountNumber ? isAccountExists = i : false;
							});

							if(isAccountExists !== -1) {
								account_list[j].accountType = customeInfoAccountList[isAccountExists].accountType;
								account_list[j].accountBalance = customeInfoAccountList[isAccountExists].accountBalance;
							}
						}
						NCMCService.accountDetails = account_list;
						NCMCLoadCardVm.accountDetails = NCMCService.accountDetails;
						if(NCMCLoadCardVm.accountDetails.length == 0){
							NCMCLoadCardVm.marginError = "No account available.";
						}
	                },function(error) {
						utilityService.showErrorMessage(error.responseMessage);
						NCMCLoadCardVm.marginError = "No account available.";
					});
				} 
				else {
	                NCMCLoadCardVm.accountDetails = NCMCService.accountDetails; 
				}
			};
			
			NCMCLoadCardVm.getCardDetails = function() {
				NCMCService.cardDetails = [];
						NCMCLoadCardVm.cardDetails = [];
						NCMCLoadCardVm.cardMarginError = "";
						NCMCLoadCardVm.cardNumber = "";
				NCMCLoadCardVm.displayName = "";
				NCMCLoadCardVm.selectedCard = 0;
				NCMCLoadCardVm.showSelectCard = true;	
				//if (!NCMCService.cardDetails.length) {
					var obj = {
  								"accountNumber": NCMCLoadCardVm.accountNumber
							};
					NCMCService.getCardListByAcc(obj).then(function(data) {
						NCMCService.cardDetails = data.cardDetails;
						NCMCLoadCardVm.cardDetails = NCMCService.cardDetails;
						if(NCMCLoadCardVm.cardDetails.length == 0){
							NCMCLoadCardVm.cardMarginError = "No NCMC card is available for the selected account.";
						}
	                },function(error) {
						//utilityService.showErrorMessage(error.responseMessage);
						NCMCLoadCardVm.cardMarginError = "No NCMC card is available for the selected account.";
					});
				
			};
			
			NCMCLoadCardVm.goToManageNFC = function(){
				$state.go('menu.accountServices');
			};
			
			NCMCLoadCardVm.goBacktoPrevious = function(){
				 $ionicHistory.goBack();
			};

			NCMCLoadCardVm.showPop = function(){
				if(NCMCLoadCardVm.accountDetails.length > 0)
				{
					NCMCLoadCardVm.popUp = $ionicPopup.show({
						title: '',
						cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
						templateUrl: 'pages/ncmc/loadNCMC/dropdownModal.html',
						scope: $scope
					});
				}
			}
			NCMCLoadCardVm.showPopCard = function(){
				if(NCMCLoadCardVm.cardDetails.length > 0)
				{
					NCMCLoadCardVm.popUpCard = $ionicPopup.show({
						title: '',
						cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
						templateUrl: 'pages/ncmc/loadNCMC/cardDropdownModal.html',
						scope: $scope
					});
				}
			}
			NCMCLoadCardVm.close = function(index){
				NCMCLoadCardVm.marginError = "";
				NCMCLoadCardVm.cardBalance = "";
				NCMCLoadCardVm.cardBalanceError = "";
				NCMCLoadCardVm.popUp.close();
				NCMCLoadCardVm.balance = NCMCLoadCardVm.accountDetails[index].accountBalance;
				NCMCLoadCardVm.accType = NCMCLoadCardVm.accountDetails[index].accountType;
				NCMCLoadCardVm.accountNumber = NCMCLoadCardVm.accountDetails[index].accountNumber;
				NCMCLoadCardVm.selectedAccount = NCMCLoadCardVm.accountDetails[index];
				NCMCLoadCardVm.showSelect = false;
				if(parseFloat(NCMCLoadCardVm.balance) == 0){
					NCMCLoadCardVm.marginError = "Account does not have balance kindly ensure funds availability before branch proceesing.";
				}
				else{
					NCMCLoadCardVm.getCardDetails();
				}
				
			}

			NCMCLoadCardVm.getBalanceEnquiry = function() {
				NCMCLoadCardVm.cardBalance = "";
				NCMCLoadCardVm.cardBalanceError = "";
				var obj = {
  								"cardNumber": NCMCLoadCardVm.cardNumber
							};
					NCMCService.balanceEnquiry(obj).then(function(data) {
						NCMCLoadCardVm.cardBalance = data.balanceAmount;
					},function(error) {
						utilityService.showErrorMessage(error.responseMessage);
						NCMCLoadCardVm.cardBalanceError = "Balance not available.";
					});
				
			}
			
	        NCMCLoadCardVm.onChangeRangeAmount = function () {
	        }

			NCMCLoadCardVm.closeCardPopup = function(index){
				NCMCLoadCardVm.cardMarginError = "";
				NCMCLoadCardVm.popUpCard.close();
				NCMCLoadCardVm.cardNumber = NCMCLoadCardVm.cardDetails[index].cardNumber;
				NCMCLoadCardVm.displayName = NCMCLoadCardVm.cardDetails[index].displayName;
				NCMCLoadCardVm.selectedCard = NCMCLoadCardVm.cardDetails[index];
				NCMCLoadCardVm.showSelectCard = false;
				//service call to get card balance
				NCMCLoadCardVm.getBalanceEnquiry();
				
			}



			NCMCLoadCardVm.goNext = function(){
				
				if(NCMCLoadCardVm.marginError != ""){

				}
				else if(NCMCLoadCardVm.cardMarginError != ""){

				}
				else if(NCMCLoadCardVm.cardBalanceError != ""){

				}
				else if(!NCMCLoadCardVm.accountNumber || NCMCLoadCardVm.accountNumber == ""){
						if(NCMCLoadCardVm.accountDetails.length > 0)
						{
							NCMCLoadCardVm.marginError = "Please select account.";
						}
						else{
							NCMCLoadCardVm.marginError = "No account available.";
						}
				}
				else if(!NCMCLoadCardVm.cardNumber || NCMCLoadCardVm.cardNumber == ""){
					if(NCMCLoadCardVm.cardDetails.length > 0)
						{
							NCMCLoadCardVm.cardMarginError = "Please select card.";
						}
						else{
							NCMCLoadCardVm.cardMarginError = "No NCMC card is available for the selected account.";
						}
					
				}
				// if(NCMCLoadCardVm.marginError == "" && NCMCLoadCardVm.cardMarginError == "" && NCMCLoadCardVm.cardBalanceError == "" && (NCMCLoadCardVm.accountNumber && NCMCLoadCardVm.accountNumber != "") && (NCMCLoadCardVm.cardNumber && NCMCLoadCardVm.cardNumber != "") )
				// {
				
				
					else{
						var total_amount = parseFloat(NCMCLoadCardVm.cardBalance) + parseFloat(NCMCLoadCardVm.amount);
						if(total_amount > 2000)
					{
						utilityService.showErrorMessage('You can maintain a maximum balance of Rs 2,000 in your NCMC Card. Please reduce the amount and try again.');
					}
					else{
						NCMCService.cardNumber = NCMCLoadCardVm.cardNumber;
						NCMCService.loadAmountData.accountNumber = NCMCLoadCardVm.accountNumber;
						NCMCService.loadAmountData.cardNumber = NCMCLoadCardVm.cardNumber;
						NCMCService.loadAmountData.cardBalance = NCMCLoadCardVm.cardBalance;
						NCMCService.loadAmountData.amount = NCMCLoadCardVm.amount;
						//NCMCService.loadAmountData.amount = 1;
						NCMCService.loadAmountData.displayName = NCMCLoadCardVm.displayName;
						NCMCService.loadAmountData.balance = NCMCLoadCardVm.balance;
						NCMCService.loadAmountData.accountType = NCMCLoadCardVm.accType;
						$translate(['LOAD_NCMC_SUCCESS'], {card_number : NCMCService.loadAmountData.cardNumber, load_amount : NCMCService.loadAmountData.amount}).then(function (translations) {
							NCMCLoadCardVm.success_desc = translations['LOAD_NCMC_SUCCESS'];
							NCMCService.successMsg = NCMCLoadCardVm.success_desc;
						$state.go('menu.loadNCMCReview');
					
						});
						}
					}
					
				// }
				// else{
				// 	utilityService.showErrorMessage('Please select both account and card.');
				// }
			}
			NCMCLoadCardVm.goBack = function(){
				$state.go('menu.NCMCLanding');
			}
			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				NCMCLoadCardVm.marginError = "";
				NCMCLoadCardVm.cardMarginError = "";
				NCMCLoadCardVm.cardBalanceError = "";
				if(NCMCService.loadAmountData.accountNumber == "")
				{
					initializaValues();
					if (!getAccountDetailsService.accountOverviewData) {
                
                getAccountDetailsService.getAccountDetails().then(function (data) {
                	
                    getAccountDetailsService.accountOverviewData = data;
                    NCMCLoadCardVm.getAccountDetails();
                    
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
            else{
            	NCMCLoadCardVm.getAccountDetails();
            }
					
				}
				else{
						NCMCLoadCardVm.accountNumber = NCMCService.loadAmountData.accountNumber;
						NCMCLoadCardVm.cardNumber = NCMCService.loadAmountData.cardNumber;
						NCMCLoadCardVm.cardBalance = NCMCService.loadAmountData.cardBalance;
						NCMCLoadCardVm.amount = NCMCService.loadAmountData.amount;
						NCMCLoadCardVm.displayName = NCMCService.loadAmountData.displayName;
						NCMCLoadCardVm.balance = NCMCService.loadAmountData.balance;
						NCMCLoadCardVm.accType = NCMCService.loadAmountData.accountType;
				}
				
				
			});

			return this;
		}
]);


