'use strict';
angularApp.controller('ncmcOtpController', [
		"$state",
		"$scope",		
		"utilityService",
		"NCMCService","customerInfoService","$filter","getAccountDetailsService",
		function($state, $scope,utilityService,NCMCService,customerInfoService,$filter,getAccountDetailsService) {
			
			var ncmcOtpVm = this;

			function initPage(){
				ncmcOtpVm.otpCount = 0;
				ncmcOtpVm.clickCount = 0;
				ncmcOtpVm.isResendDisabled = false;
				ncmcOtpVm.mobileNumber = $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4);
			}

			ncmcOtpVm.goNext = function(){
				ncmcOtpVm.resetPinOTP = "";
				if(!ncmcOtpVm.otpNumber){
					ncmcOtpVm.resetPinOTP = "Please Enter the OTP";
				}else if(ncmcOtpVm.otpNumber.length != 6){
					ncmcOtpVm.resetPinOTP = "Please enter 6 digits OTP";
				}else{
					var request = {
						"otp" : ncmcOtpVm.otpNumber
					}
					NCMCService.validateOtp(request).then(function(data) {
						//call add money service
						var obj = {
								  "cardNumber": NCMCService.loadAmountData.cardNumber,
								  "topupAmount": NCMCService.loadAmountData.amount,
								  "fromAccount": NCMCService.loadAmountData.accountNumber
								};
						NCMCService.addMoney(obj).then(function(data) {
							getAccountDetailsService.accountOverviewData = "";
							NCMCService.refNumber = data.refNumber;
							$state.go('menu.ncmcSuccessMsg');
						},function(error){
							utilityService.showErrorMessage(error.responseMessage);
						});
						
						
					},function(error){
						ncmcOtpVm.otpNumber = "";
						ncmcOtpVm.otpCount++;
						if(ncmcOtpVm.otpCount >= 3){
							var title = '';
							var template = error.responseMessage;
							var onTap = 'menu.homeScreen';
							var buttontext = "OK";
							//utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
							utilityService.showBhimUpiAlert('error', template, onTap, buttontext, $scope);
						}else{
							utilityService.showErrorMessage(error.responseMessage);
						}
					});
				}
			}

			ncmcOtpVm.resendOTP = function(){
				NCMCService.getOtp().then(function(data) {
					ncmcOtpVm.otpNumber = "";
					ncmcOtpVm.resetPinOTP = "";
					ncmcOtpVm.clickCount++;
					if(ncmcOtpVm.clickCount >= 2){
						ncmcOtpVm.isResendDisabled = true;
					}
					var title = '';
					var template = "OTP has been sent to your registered mobile number.";
					var onTap = '';
					var buttontext = "OK";
					//utilityService.showAlertModal('', template, onTap, $scope, $state, buttontext);
					utilityService.showBhimUpiAlert('success', template, onTap, buttontext, $scope);
				},function(error){
					ncmcOtpVm.otpNumber = "";
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			

			$scope.$on('$ionicView.beforeEnter', function() {
				initPage();
			});
			
			return this;
		}

		
]);


