'use strict';
angularApp.controller('loadNCMCReviewController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"NCMCService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, NCMCService) {
			
			var loadNCMCReviewVm = this;
			
			function initPage() {
			};
			
			function initializaValues(){
				loadNCMCReviewVm.showSelect = true;
				loadNCMCReviewVm.showSelectCard = true;
				loadNCMCReviewVm.accType = NCMCService.loadAmountData.accountType;
				loadNCMCReviewVm.loadAmount = NCMCService.loadAmountData.amount;
				loadNCMCReviewVm.accountNumber = NCMCService.loadAmountData.accountNumber;
				loadNCMCReviewVm.cardBalance = NCMCService.loadAmountData.cardBalance;
				loadNCMCReviewVm.cardNumber = NCMCService.loadAmountData.cardNumber;
				loadNCMCReviewVm.balance = NCMCService.loadAmountData.balance;
				loadNCMCReviewVm.displayName = NCMCService.loadAmountData.displayName;
			}
			
			loadNCMCReviewVm.goToManageNFC = function(){
				$state.go('menu.accountServices');
			};
			
			loadNCMCReviewVm.goBacktoPrevious = function(){
				 $ionicHistory.goBack();
			};

			loadNCMCReviewVm.getCBValue = function(isChecked){
				if(!isChecked){
					loadNCMCReviewVm.checkboxError = "Check this box to proceed";
					loadNCMCReviewVm.ischeckboxSelected = false;
				}
				else{
					loadNCMCReviewVm.ischeckboxSelected = true;
					loadNCMCReviewVm.checkboxError = "";
				}
			}
			
			loadNCMCReviewVm.goNext = function(){
				if(loadNCMCReviewVm.ischeckboxSelected)
				{
					NCMCService.cardNumber = loadNCMCReviewVm.cardNumber;
				
				NCMCService.getOtp().then(function (data) {
					$state.go('menu.loadNCMCOTP');
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
				}
				else{
					loadNCMCReviewVm.checkboxError = "Check this box to proceed";
					loadNCMCReviewVm.ischeckboxSelected = false;
				}
				
			}

			loadNCMCReviewVm.termcondition = function(){
				if(NCMCService.normalFDTnC == ""){
				var obj = {
						"type" : "ncmcTnC"
					}
					NCMCService.fetchRtermcondition(obj).then(function (data) {
						
						if (!utilityService.isUndefined(data)) {
							NCMCService.normalFDTnC = data;
							loadNCMCReviewVm.termconditionPopUp(NCMCService.normalFDTnC);
						}
					}, function (error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
					}
					else{
						loadNCMCReviewVm.termconditionPopUp(NCMCService.normalFDTnC);
					}
			}
			loadNCMCReviewVm.termconditionPopUp = function (TnCDetails) {
				var title = "";
                var buttontext = "OK";
                var detail = TnCDetails;
                NCMCService.showTnCAlertModal(title, detail, buttontext,function(){});
			}
			loadNCMCReviewVm.goBack = function(){
				$state.go('menu.NCMCLoadCard');
			}
			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				initializaValues();
				loadNCMCReviewVm.checkboxError = "";
				loadNCMCReviewVm.ischeckboxSelected = false;
				loadNCMCReviewVm.isChecked = false;
			});

			return this;
		}
]);


