'use strict';
angularApp.controller('NCMCManageNFCController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"NCMCService",
		"getAccountDetailsService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, NCMCService, getAccountDetailsService) {
			
			var NCMCManageNFCVm = this;
			
			function initPage() {
				$translate(['MANAGE_NFC_SUCCESS']).then(function (translations) {
					NCMCManageNFCVm.success_desc = translations['MANAGE_NFC_SUCCESS'];
					
				});
				NCMCManageNFCVm.showSelect = true;
				NCMCManageNFCVm.showSelectCard = true;
			};

			NCMCManageNFCVm.getAccountDetails = function() {	
				if (!NCMCService.accountDetails.length) {
					NCMCService.getAccountList().then(function(data) {
						var account_list = data.accounts;
						var customeInfoAccountList = getAccountDetailsService.accountOverviewData.accounts;

						for(var j=0; j<account_list.length; j++)
						{
							var isAccountExists = -1;
							customeInfoAccountList.some(function(obj, i) {
  								return obj.accountNumber == account_list[j].accountNumber ? isAccountExists = i : false;
							});

							if(isAccountExists !== -1) {
								account_list[j].accountType = customeInfoAccountList[isAccountExists].accountType;
								account_list[j].accountBalance = customeInfoAccountList[isAccountExists].accountBalance;
							}
						}
						NCMCService.accountDetails = account_list;
						NCMCManageNFCVm.accountDetails = NCMCService.accountDetails;
						if(NCMCManageNFCVm.accountDetails.length == 0){
							NCMCManageNFCVm.marginError = "No account available.";
						}
	                },function(error) {
						utilityService.showErrorMessage(error.responseMessage);
						NCMCManageNFCVm.marginError = "No account available.";
					});
				} 
				else {
	                NCMCManageNFCVm.accountDetails = NCMCService.accountDetails; 
				}
			}

			NCMCManageNFCVm.getCardDetails = function() {
				NCMCService.cardDetails = [];
				NCMCManageNFCVm.cardDetails = [];
				NCMCManageNFCVm.cardMarginError = "";
				NCMCManageNFCVm.cardNumber = "";
				NCMCManageNFCVm.displayName = "";
				NCMCManageNFCVm.selectedCard = 0;
				NCMCManageNFCVm.showSelectCard = true;	
				//if (!NCMCService.cardDetails.length) {
					var obj = {
  								"accountNumber": NCMCManageNFCVm.accountNumber
							};
							console.log("accountNumber : "+ NCMCManageNFCVm.accountNumber);
					NCMCService.getCardListByAcc(obj).then(function(data) {
						NCMCService.cardDetails = data.cardDetails;
						NCMCManageNFCVm.cardDetails = NCMCService.cardDetails;
						if(NCMCManageNFCVm.cardDetails.length == 0){
							NCMCManageNFCVm.cardMarginError = "No NCMC card is available for the selected account";
						}
	                },function(error) {
						utilityService.showErrorMessage(error.responseMessage);
						NCMCManageNFCVm.cardMarginError = "No NCMC card is available for the selected account";
					});
				
			}

			NCMCManageNFCVm.getCardFlag = function() {
				NCMCService.cardFlag = false;
				NCMCManageNFCVm.enableNFC = {"checked":false};	
				//if (!NCMCService.cardDetails.length) {
					var obj = {
  								"accountNumber": NCMCManageNFCVm.accountNumber,
  								"cardNumber": NCMCManageNFCVm.cardNumber
							};
					NCMCService.getCardFlag(obj).then(function(data) {
						if(data.ncmcFlag == 'Y')
						{
							NCMCService.cardFlag = true;
							NCMCManageNFCVm.enableNFC = {"checked":true};
						}
						else{
							NCMCService.cardFlag = false;
							NCMCManageNFCVm.enableNFC = {"checked":false};
						}
						
	                },function(error) {
						utilityService.showErrorMessage(error.responseMessage);
						
					});
			}

			NCMCManageNFCVm.enableNFCChange = function(){
				
			}

			NCMCManageNFCVm.goToManageNFC = function(){
				$state.go('menu.accountServices');
			};
			
			NCMCManageNFCVm.goBacktoPrevious = function(){
				 $ionicHistory.goBack();
			};

			NCMCManageNFCVm.showPop = function(){
				if(NCMCManageNFCVm.accountDetails.length > 0)
				{
					NCMCManageNFCVm.popUp = $ionicPopup.show({
						title: '',
						cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
						templateUrl: 'pages/ncmc/manageNFC/dropdownModal.html',
						scope: $scope
					});
				}
				
			}
			NCMCManageNFCVm.showPopCard = function(){
				if(NCMCManageNFCVm.cardDetails.length > 0)
				{
					NCMCManageNFCVm.popUpCard = $ionicPopup.show({
						title: '',
						cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
						templateUrl: 'pages/ncmc/manageNFC/cardDropdownModal.html',
						scope: $scope
					});
				}
			}
			NCMCManageNFCVm.close = function(index){

				NCMCManageNFCVm.marginError = "";
				NCMCManageNFCVm.popUp.close();
				NCMCManageNFCVm.balance = NCMCManageNFCVm.accountDetails[index].accountBalance;
				NCMCManageNFCVm.accType = NCMCManageNFCVm.accountDetails[index].accountType;
				NCMCManageNFCVm.accountNumber = NCMCManageNFCVm.accountDetails[index].accountNumber;
				NCMCManageNFCVm.selectedAccount = NCMCManageNFCVm.accountDetails[index];
				NCMCManageNFCVm.showSelect = false;
				NCMCManageNFCVm.getCardDetails();

				
			}

			NCMCManageNFCVm.closeCardPopup = function(index){
				NCMCManageNFCVm.cardMarginError = "";
				NCMCManageNFCVm.popUpCard.close();
				NCMCManageNFCVm.cardNumber = NCMCManageNFCVm.cardDetails[index].cardNumber;
				NCMCManageNFCVm.displayName = NCMCManageNFCVm.cardDetails[index].displayName;
				NCMCManageNFCVm.selectedCard = NCMCManageNFCVm.cardDetails[index];
				NCMCManageNFCVm.showSelectCard = false;
				NCMCManageNFCVm.getCardFlag();
				
			}
			NCMCManageNFCVm.goNext = function(){
				if(!NCMCManageNFCVm.accountNumber){
					NCMCManageNFCVm.marginError = "Please select account.";
				}else if(!NCMCManageNFCVm.cardNumber){
					NCMCManageNFCVm.cardMarginError = "Please select card.";
				}else if(NCMCManageNFCVm.marginError == "" && NCMCManageNFCVm.cardMarginError == "")
				{
					var ncmcFlag = "";
					if(NCMCManageNFCVm.enableNFC.checked)
					{
						ncmcFlag = "Y";
						$translate(['MANAGE_NFC_SUCCESS'],{status : 'enabled'}).then(function (translations) {
							NCMCManageNFCVm.success_desc = translations['MANAGE_NFC_SUCCESS'];
					
						});
					}
					else{
						ncmcFlag = "N";
						$translate(['MANAGE_NFC_SUCCESS'], {status : 'disabled'}).then(function (translations) {
							NCMCManageNFCVm.success_desc = translations['MANAGE_NFC_SUCCESS'];
					
						});
					}
					var obj = {
						"cardNumber":NCMCManageNFCVm.cardNumber,
						"accountNumber":NCMCManageNFCVm.accountNumber,
						"ncmcFlag": ncmcFlag
					}
						NCMCService.flagUpdate(obj).then(function(data) {
						NCMCService.successMsg = NCMCManageNFCVm.success_desc;
						NCMCService.cardNumber = NCMCManageNFCVm.cardNumber;
						NCMCService.refNumber = "";
						$state.go('menu.ncmcSuccessMsg');
						
		                },function(error) {
							utilityService.showErrorMessage(error.responseMessage);
							
						});

				}
				else{
					utilityService.showErrorMessage('Please select both account and card.');
				}
				
			}
			NCMCManageNFCVm.goBack = function(){
				$state.go('menu.NCMCLanding');
			}
			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				NCMCManageNFCVm.marginError = "";
				NCMCManageNFCVm.cardMarginError = "";
				
				
				if (!getAccountDetailsService.accountOverviewData) {
                
                getAccountDetailsService.getAccountDetails().then(function (data) {
                	
                    getAccountDetailsService.accountOverviewData = data;
                    NCMCManageNFCVm.getAccountDetails();
                    
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
            else{
            	NCMCManageNFCVm.getAccountDetails();
            }
			});

			return this;
		}
]);


