'use strict';
angularApp.controller('offlineNCMCStatementDetailsController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"NCMCService",
		"ionicDatePicker",
		"constantConfig",
		"openUrlInAppbroswerService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, NCMCService, ionicDatePicker, constantConfig, openUrlInAppbroswerService) {
			
			var offlineNCMCStatementDetailsVm = this;
			
			function initPage() {
				
			};

			

			offlineNCMCStatementDetailsVm.goToManageNFC = function(){
				$state.go('menu.accountServices');
			};
			
			function b64toBlob(b64Data, contentType, sliceSize) {
				contentType = contentType || '';
				sliceSize = sliceSize || 512;

				var byteCharacters = atob(b64Data);
				var byteArrays = [];

				for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
					var slice = byteCharacters.slice(offset, offset + sliceSize);

					var byteNumbers = [];
					for (var i = 0; i < slice.length; i++) {
						byteNumbers[i] = slice.charCodeAt(i);
					}

					var byteArray = new Uint8Array(byteNumbers);

					byteArrays.push(byteArray);
				}

				var blob = new Blob(byteArrays, { type: contentType });
				return blob;
			}
			
			function savebase64AsPDF(folderpath, filename, content, contentType) {
				var contentStr = atob(content);
                        var contentLen = contentStr.length;
                        if (contentLen >= constantConfig.accOverview.pdfSize) {
                           
                            utilityService.showErrorMessage(constantConfig.accOverview.sizeLimitMessage);
                            return;
                        }
				// Convert the base64 string in a Blob
				var DataBlob = b64toBlob(content, contentType);
				filename = filename;
				window.resolveLocalFileSystemURL(folderpath, function (dir) {
					dir.getFile(filename, { create: true }, function (file) {
						file.createWriter(function (fileWriter) {
							fileWriter.write(DataBlob);
						}, function (error) {

						});
					});
				});
			}
			
			
			offlineNCMCStatementDetailsVm.goBack = function(){
				$state.go('menu.offlineNCMCStatement');
			}
			offlineNCMCStatementDetailsVm.getTransReceipt = function(isEmail){
				var obj = {};
				if(isEmail){
					obj = {"downloadOrEmail" : "1"};
				}
				else{
					obj = {"downloadOrEmail" : "0"};
				}

				NCMCService.walletList(obj).then(function (data) {
					if(isEmail){
						var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="">Mail has been sent to your registered email id.</div>';
					$ionicPopup.show({
						title: '',
						template: template,
						cssClass: 'my-custom-popup',
						buttons: [{
							text:'OK',
							type: 'button-assertive',
							onTap: function() { 
							}
						}],
					});
					}
						else{
								if(data==null){
									utilityService.showErrorMessage('No data available in the selected period');
								}
								else{
									var content = data.pdf;
								var filename = data.fileName + '.pdf';
								var contentType = "application/pdf";
								if (utilityService.isAndroidPlatform()) {
									offlineNCMCStatementDetailsVm.folderpath = cordova.file.externalRootDirectory;
								}
								if (utilityService.isIOSPlatform()) {
									offlineNCMCStatementDetailsVm.folderpath = cordova.file.documentsDirectory;
								}
								savebase64AsPDF(offlineNCMCStatementDetailsVm.folderpath, filename, content, contentType);
								if (utilityService.isIOSPlatform()) {
									filename = filename;
									var finalObject = { "folderpath": offlineNCMCStatementDetailsVm.folderpath, "filename": filename };
									openUrlInAppbroswerService.openUrl("data:application/pdf;base64," + content + "","");
									//$state.go('menu.instaClosure');
								}
								if (utilityService.isAndroidPlatform()) {
									var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="DOWNLOADFDRECEIPTINSTA"></div>';
									offlineNCMCStatementDetailsVm.downloadPopup = $ionicPopup.show({
										title: '',
										template: template,
										scope: $scope,
										cssClass: 'my-custom-popup',
										buttons: [{
											text: 'OK',
											type: 'button-assertive'
											
										}],
									});
								}
								}
								
								}
							}, function (error) {
								utilityService.showErrorMessage(error.responseMessage);
							});

			}

			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				offlineNCMCStatementDetailsVm.cardNumber = NCMCService.cardNumber;
				offlineNCMCStatementDetailsVm.transactionDetails = NCMCService.transactionDetails;
				
			});

			return this;
		}
]);


