'use strict';
angularApp.controller('offlineNCMCStatementController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"NCMCService",
		"getAccountDetailsService",
		"ionicDatePicker",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, NCMCService, getAccountDetailsService, ionicDatePicker) {
			
			var offlineNCMCStatementVm = this;
			
			function initPage() {
				$translate(['MANAGE_NFC_SUCCESS']).then(function (translations) {
					offlineNCMCStatementVm.success_desc = translations['MANAGE_NFC_SUCCESS'];
				});
				offlineNCMCStatementVm.showSelect = true;
				offlineNCMCStatementVm.showSelectCard = true;
			};

			offlineNCMCStatementVm.openFromDatePicker = function(){
				var date = new Date();
                var getCurrentYear = new Date().getFullYear();
                var setYear = date.setFullYear((getCurrentYear-1));
				offlineNCMCStatementVm.fromDateObj = {
					callback: function (val) {
		                    
		                    offlineNCMCStatementVm.fromDate = val;
		                    offlineNCMCStatementVm.fromDateError = "";
						},
						inputDate: new Date(),
						monthsList:["JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC"],
						from: date,
						to: new Date(),
						mondayFirst: true,
						closeOnSelect: false,
						templateType: 'popup',
						dateFormat: 'dd MMM yyyy'

				};

				ionicDatePicker.openDatePicker(offlineNCMCStatementVm.fromDateObj);
			}

			offlineNCMCStatementVm.openToDatePicker = function(){
				var date = new Date();
                var getCurrentYear = new Date().getFullYear();
                var setYear = date.setFullYear((getCurrentYear-1));
				offlineNCMCStatementVm.toDateObj = {
					callback: function (val) {
		                    
		                    offlineNCMCStatementVm.toDate = val;
		                    offlineNCMCStatementVm.toDateError = "";
						},
						inputDate: new Date(),
						monthsList:["JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC"],
						from: date,
						to: new Date(),
						mondayFirst: true,
						closeOnSelect: false,
						templateType: 'popup',
						dateFormat: 'dd MMM yyyy'

				};

				ionicDatePicker.openDatePicker(offlineNCMCStatementVm.toDateObj);
			}

			offlineNCMCStatementVm.getStatement = function(){
				var from_date = new Date();
				var to_date = new Date();
				if(offlineNCMCStatementVm.selectPeriod != ""){

					if(offlineNCMCStatementVm.selectPeriod == "1")
					{
						from_date = from_date.setMonth(from_date.getMonth()-1);
					}
					if(offlineNCMCStatementVm.selectPeriod == "3")
					{
						from_date = from_date.setMonth(from_date.getMonth()-3);
					}
					if(offlineNCMCStatementVm.selectPeriod == "6")
					{
						from_date = from_date.setMonth(from_date.getMonth()-6);
					}
					if(offlineNCMCStatementVm.selectPeriod == "by_date"){
						from_date = offlineNCMCStatementVm.fromDate;
						to_date = offlineNCMCStatementVm.toDate;
					}
					var obj = {
	  							"cardNumber": offlineNCMCStatementVm.cardNumber,
								"fromDate": NCMCService.getFormattedDate(from_date),
								"toDate": NCMCService.getFormattedDate(to_date)
							};

							NCMCService.walletList(obj).then(function(data) {
							offlineNCMCStatementVm.transactionDetails = data.stmtDetails;
							NCMCService.cardNumber = offlineNCMCStatementVm.cardNumber;
						
							NCMCService.transactionDetails = offlineNCMCStatementVm.transactionDetails;
							$state.go('menu.offlineNCMCStatementDetails');
							
		                },function(error) {
							utilityService.showErrorMessage(error.responseMessage);
							
						});
				}
			}

			offlineNCMCStatementVm.getAccountDetails = function() {	
				if (!NCMCService.accountDetails.length) {
					NCMCService.getAccountList().then(function(data) {
						console.log(data);
						var account_list = data.accounts;
						var customeInfoAccountList = getAccountDetailsService.accountOverviewData.accounts;

						for(var j=0; j<account_list.length; j++)
						{
							var isAccountExists = -1;
							customeInfoAccountList.some(function(obj, i) {
  								return obj.accountNumber == account_list[j].accountNumber ? isAccountExists = i : false;
							});

							if(isAccountExists !== -1) {
								account_list[j].accountType = customeInfoAccountList[isAccountExists].accountType;
								account_list[j].accountBalance = customeInfoAccountList[isAccountExists].accountBalance;
							}
						}
						console.log(account_list);
						NCMCService.accountDetails = account_list;
						offlineNCMCStatementVm.accountDetails = NCMCService.accountDetails;
						if(offlineNCMCStatementVm.accountDetails.length == 0){
							offlineNCMCStatementVm.marginError = "No account available.";
						}
	                },function(error) {
						utilityService.showErrorMessage(error.responseMessage);
						offlineNCMCStatementVm.marginError = "No account available.";
					});
				} else {
	                offlineNCMCStatementVm.accountDetails = NCMCService.accountDetails; 
				}
			}

			offlineNCMCStatementVm.getCardDetails = function() {


				NCMCService.cardDetails = [];
				offlineNCMCStatementVm.cardDetails = [];
				offlineNCMCStatementVm.cardMarginError = "";
				offlineNCMCStatementVm.cardNumber = "";
				offlineNCMCStatementVm.displayName = "";
				offlineNCMCStatementVm.selectedCard = 0;
				offlineNCMCStatementVm.showSelectCard = true;	
				//if (!NCMCService.cardDetails.length) {
					var obj = {
  								"accountNumber": offlineNCMCStatementVm.accountNumber
							};
							console.log("accountNumber : "+ offlineNCMCStatementVm.accountNumber);
					NCMCService.getCardListByAcc(obj).then(function(data) {
						NCMCService.cardDetails = data.cardDetails;
						offlineNCMCStatementVm.cardDetails = NCMCService.cardDetails;
						if(offlineNCMCStatementVm.cardDetails.length == 0){
							offlineNCMCStatementVm.cardMarginError = "No NCMC card is available for the selected account";
						}
	                },function(error) {
						utilityService.showErrorMessage(error.responseMessage);
						offlineNCMCStatementVm.cardMarginError = "No NCMC card is available for the selected account";
					});

			}

			offlineNCMCStatementVm.goToManageNFC = function(){
				$state.go('menu.accountServices');
			};
			
			offlineNCMCStatementVm.goBacktoPrevious = function(){
				 $ionicHistory.goBack();
			};

			offlineNCMCStatementVm.showPop = function(){
				if(offlineNCMCStatementVm.accountDetails.length > 0)
				{
					offlineNCMCStatementVm.popUp = $ionicPopup.show({
						title: '',
						cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
						templateUrl: 'pages/ncmc/offlineNCMCStatement/dropdownModal.html',
						scope: $scope
					});
				}
				
			}
			offlineNCMCStatementVm.showPopCard = function(){
				if(offlineNCMCStatementVm.cardDetails.length > 0)
				{
					offlineNCMCStatementVm.popUpCard = $ionicPopup.show({
						title: '',
						cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
						templateUrl: 'pages/ncmc/offlineNCMCStatement/cardDropdownModal.html',
						scope: $scope
					});
				}
			}
			offlineNCMCStatementVm.close = function(index){
				offlineNCMCStatementVm.marginError = "";
				offlineNCMCStatementVm.popUp.close();
				offlineNCMCStatementVm.balance = offlineNCMCStatementVm.accountDetails[index].accountBalance;
				offlineNCMCStatementVm.accType = offlineNCMCStatementVm.accountDetails[index].accountType;
				offlineNCMCStatementVm.accountNumber = offlineNCMCStatementVm.accountDetails[index].accountNumber;
				offlineNCMCStatementVm.selectedAccount = offlineNCMCStatementVm.accountDetails[index];
				offlineNCMCStatementVm.showSelect = false;
				offlineNCMCStatementVm.getCardDetails();
				// if(parseFloat(offlineNCMCStatementVm.balance) == 0){
				// 	offlineNCMCStatementVm.marginError = "Account does not have balance kindly ensure funds availability proceesing.";
				// }
				// else{
				// 	//get cards under selected account
				// }
			}

			offlineNCMCStatementVm.closeCardPopup = function(index){
				offlineNCMCStatementVm.cardMarginError = "";
				offlineNCMCStatementVm.popUpCard.close();
				offlineNCMCStatementVm.cardNumber = offlineNCMCStatementVm.cardDetails[index].cardNumber;
				offlineNCMCStatementVm.displayName = offlineNCMCStatementVm.cardDetails[index].displayName;
				offlineNCMCStatementVm.selectedCard = offlineNCMCStatementVm.cardDetails[index];
				offlineNCMCStatementVm.showSelectCard = false;
			}

			offlineNCMCStatementVm.goBack = function(){
				$state.go('menu.NCMCLanding');
			}
			offlineNCMCStatementVm.validate = function(){
				if(!offlineNCMCStatementVm.selectPeriod || offlineNCMCStatementVm.selectPeriod == "")
				{
					offlineNCMCStatementVm.selectDateError = "Select a date range";
				}else{
					offlineNCMCStatementVm.selectDateError = "";
				}
			}

			offlineNCMCStatementVm.goNextPage = function(){
				offlineNCMCStatementVm.marginError = "";
				offlineNCMCStatementVm.cardMarginError = "";
				offlineNCMCStatementVm.selectDateError = "";
				offlineNCMCStatementVm.fromDateError = "";
				offlineNCMCStatementVm.toDateError = "";
				if(!offlineNCMCStatementVm.accountNumber || offlineNCMCStatementVm.accountNumber == "")
				{
					offlineNCMCStatementVm.marginError = "Select an account number";
				}
				else if(!offlineNCMCStatementVm.cardNumber || offlineNCMCStatementVm.cardNumber == ""){
					offlineNCMCStatementVm.cardMarginError = "Select a card number";
				}
				else if(!offlineNCMCStatementVm.selectPeriod || offlineNCMCStatementVm.selectPeriod == ""){
					offlineNCMCStatementVm.selectDateError = "Select a date range";
				}
				else if(offlineNCMCStatementVm.selectPeriod == "by_date"){
					if(!offlineNCMCStatementVm.fromDate || offlineNCMCStatementVm.fromDate == ""){
						offlineNCMCStatementVm.fromDateError = "Select a from date";
					}
					if(!offlineNCMCStatementVm.toDate || offlineNCMCStatementVm.toDate == ""){
						offlineNCMCStatementVm.toDateError = "Select a to date";
					}
					//if from date is greater than to date apply validation
				}
				else{

				}

				if(offlineNCMCStatementVm.marginError == "" && offlineNCMCStatementVm.cardMarginError == "" && offlineNCMCStatementVm.selectDateError == "" && offlineNCMCStatementVm.fromDateError == "" && offlineNCMCStatementVm.toDateError == ""){
					offlineNCMCStatementVm.getStatement();
				}
				
				
			}
			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				offlineNCMCStatementVm.marginError = "";
				offlineNCMCStatementVm.getAccountDetails();
			});

		

			return this;
		}
]);


