'use strict';

angularApp.controller('atmCardActivationOtpController', ["$timeout",
	"$state",
	"$ionicPopup",
	"$scope",
	"homeScreenService",
	"openAccountService",
	"$rootScope",
	"customerInfoService",
	"getAccountDetailsService",
	"wishListService",
	"utilityService",
	"mPinLoginService",
	"billDeskService",
	"personalLoanService", "myProfileService",
	"$ionicSideMenuDelegate",
	"$ionicScrollDelegate",
	"fTBeneficiaryService",
	"constantConfig",
	"atmCardActivationService",
	"cardsService",
	function ($timeout,
		$state, $ionicPopup,
		$scope,
		homeScreenService,
		openAccountService,
		$rootScope,
		customerInfoService,
		getAccountDetailsService,
		wishListService, utilityService,
		mPinLoginService,
		billDeskService,
		personalLoanService,
		myProfileService,
		$ionicSideMenuDelegate,
		$ionicScrollDelegate,
		fTBeneficiaryService,
		constantConfig,
		atmCardActivationService,
		cardsService) {

		//functions, variables that can be accessed from the HTML come here
		var atmCardActivationOtpVm = this;
		atmCardActivationOtpVm.mobileNumber = $rootScope.mobileNo;
		atmCardActivationOtpVm.otp = "";
		atmCardActivationOtpVm.cardNumberMask = "XXXX-XXXX-XXXX-"+atmCardActivationService.activationCardNumber.substring(atmCardActivationService.activationCardNumber.length - 4);
		var count = 0;
		atmCardActivationOtpVm.disableCount = function () {
			count += 1;
			if (count >= 3) {
				atmCardActivationOtpVm.isNextEnabled = true;
				atmCardActivationOtpVm.isDisabledOTP = true;
			}

		}

		atmCardActivationOtpVm.goToNext = function () {

			if (atmCardActivationOtpVm.otp.length < 6) {
				atmCardActivationOtpVm.nextEnable();

			} else {

				var requestParams = {
					otp: atmCardActivationOtpVm.otp,
					mobile: customerInfoService.customer.mobile
				}

				personalLoanService.requestOtp(requestParams).then(function (data) {

					if (data.status == "Success") {

						atmCardActivationOtpVm.cardNumber = atmCardActivationService.activationCardNumber;

						var reqData = {
							"cardNumber": atmCardActivationService.activationCardNumber
						}


						atmCardActivationService.activationRequest(reqData).then(function (data) {
							

							atmCardActivationOtpVm.myPopup = $ionicPopup.show({
								title: '',
								cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
								templateUrl: 'pages/nfs/atmCardActivation/Congratulations.html',
								scope: $scope
							});
						}, function (error) {
							utilityService.showErrorMessage(error.responseMessage);

						});

					}
					else {
						utilityService.showErrorMessage(data.status);
					}

				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
					//$state.go('menu.serviceRequest');

				});

			}










		};

		atmCardActivationOtpVm.ok = function () {
			atmCardActivationOtpVm.myPopup.close();
			atmCardActivationOtpVm.otp = "";
			$state.go('menu.innerPage');
		};

		atmCardActivationOtpVm.nextEnable = function () {
			atmCardActivationOtpVm.showNameError = atmCardActivationOtpVm.otp.length;
			if (atmCardActivationOtpVm.otp === atmCardActivationOtpVm.otpValue)
				atmCardActivationOtpVm.disableNext = false;
			else
				atmCardActivationOtpVm.disableNext = true;
		}
		atmCardActivationOtpVm.goToHome = function () {
			$state.go('menu.homeScreen');
		}


		atmCardActivationOtpVm.resendOTP = function () {
			if (atmCardActivationOtpVm.isDisabledOTP) { return true }
			//    $scope.resendLable = true;
			//    $scope.sendLable = false;
			atmCardActivationOtpVm.otp = "";
			var reqData = {
				"id": customerInfoService.customer.mobile,
				"emailId": customerInfoService.customer.emailID
			}
			personalLoanService.otpLoan(reqData).then(function (data) {

			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});

			atmCardActivationOtpVm.isDisabledOTP = true;
		}







		atmCardActivationOtpVm.goToBack = function () {
			$state.go('menu.atmCardActivation');
		}







		return this;
	}
]);
