'use strict';

angularApp.controller('blockUnblockController', ["$state",
	"$ionicPopup",
	"$scope",
	"utilityService",
	"blockUnblockService",
	function ($state,
		$ionicPopup,
		$scope,
		utilityService,
		blockUnblockService) {

		var blockUnblockVm = this;
		blockUnblockVm.accList = [];
		blockUnblockVm.cardList = [];
		blockUnblockVm.isNextEnabled = true;
		blockUnblockVm.disabledSelAcc = true;
		blockUnblockVm.disabledcardBlock = true;
		blockUnblockVm.disabledcardType = false;
		blockUnblockVm.blockAllCards = false;
		blockUnblockVm.selectedAccount = {};
		blockUnblockVm.selectedCard = "";

		blockUnblockVm.init = function () {
			blockUnblockVm.blockUnblockTab = blockUnblockService.blockUnblockTab;
			blockUnblockVm.selectedCardType = blockUnblockService.selectedCardType;
			blockUnblockVm.blockAllCards = blockUnblockService.blockAllCards;
			//blockUnblockVm.getUnBlockCardList();
			//blockUnblockVm.getBlockCardList();
		}

		$scope.$on('$ionicView.loaded', function () {
			blockUnblockVm.init();
			blockUnblockVm.getAccountList();
		});

		blockUnblockVm.getAccountList = function () {
			if (!blockUnblockService.accList.length) {
				blockUnblockService.accountFilterRequest().then(function (data) {
					blockUnblockService.accList = data.accList;
					blockUnblockVm.accList = blockUnblockService.accList;
					blockUnblockService.selectedAccValue = blockUnblockVm.accList[0];
					// blockUnblockVm.selectedAccount = JSON.stringify(blockUnblockService.selectedAccValue);
					blockUnblockVm.selectedAccount = "";
					blockUnblockVm.selectedAccountFun();
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
					blockUnblockVm.isNextEnabled = true;
					
				});
			} else {
				blockUnblockVm.accList = blockUnblockService.accList;
				blockUnblockVm.selectedAccount = blockUnblockService.selectedAccValue == null ? "" : JSON.stringify(blockUnblockService.selectedAccValue);
				if(blockUnblockService.selectedAccValue == null){
					blockUnblockVm.cardList = [];
					blockUnblockService.cardList = [];
					blockUnblockVm.selectedCard = "";
					blockUnblockService.selectedCardValue = "";
				} else {
					blockUnblockVm.cardList = blockUnblockService.cardList;
					blockUnblockVm.selectedCard = JSON.stringify(blockUnblockService.selectedCardValue);
				}
			}
			blockUnblockVm.enableNext();
		}

		blockUnblockVm.selectedAccountFun = function () {
			blockUnblockService.selectedAccValue = blockUnblockVm.selectedAccount == "" ? null : JSON.parse(blockUnblockVm.selectedAccount);
			blockUnblockVm.disabledcardBlock = true;
			if (blockUnblockService.selectedAccValue) {
				if (blockUnblockService.blockUnblockTab == "block") {
					blockUnblockVm.getUnBlockCardList();
				} else {
					blockUnblockVm.getBlockCardList();
					
				}
			} else {
				blockUnblockVm.getAccountList();
			}
		}

		blockUnblockVm.getUnBlockCardList = function () {
			var requestparams = {
				"accountNumber": blockUnblockService.selectedAccValue.accountNumber
			};
			blockUnblockService.viewDebitCards(requestparams).then(function (data) {
				blockUnblockService.cardList = data.cardList;
				blockUnblockVm.cardList = blockUnblockService.cardList;
				blockUnblockService.selectedCardValue = blockUnblockVm.cardList[0];
				// blockUnblockVm.selectedCard = JSON.stringify(blockUnblockService.selectedCardValue);
				blockUnblockVm.selectedCard = "";
				blockUnblockVm.disabledcardBlock = false;
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
				blockUnblockVm.selectedCard = "";
				blockUnblockVm.isNextEnabled = true;
			});
			blockUnblockVm.enableNext();
		}

		blockUnblockVm.getBlockCardList = function () {
			var requestparams = {
				"accountNumber": blockUnblockService.selectedAccValue.accountNumber
			};
			blockUnblockService.viewBlockedDebitCards(requestparams).then(function (data) {
				blockUnblockService.cardList = data.cardList;
				blockUnblockVm.cardList = blockUnblockService.cardList;
				blockUnblockService.selectedCardValue = blockUnblockVm.cardList[0];
				// blockUnblockVm.selectedCard = JSON.stringify(blockUnblockService.selectedCardValue);
				blockUnblockVm.selectedCard = "";
				blockUnblockVm.disabledcardBlock = false;
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
				blockUnblockVm.selectedCard = "";
				blockUnblockVm.isNextEnabled = true;
			});
			blockUnblockVm.enableNext();
		}

		blockUnblockVm.selectedTabFun = function () {
			blockUnblockService.blockUnblockTab = blockUnblockVm.blockUnblockTab;
			blockUnblockVm.selectedAccount = "";
			blockUnblockVm.selectedCard = "";
			blockUnblockVm.blockAllCards = false;
			blockUnblockVm.enableblockAllCards();
			blockUnblockVm.selectedAccountFun();
		}

		blockUnblockVm.selectedCardFun = function () {
			blockUnblockService.selectedCardValue = blockUnblockVm.selectedCard == "" ? null : JSON.parse(blockUnblockVm.selectedCard);
			blockUnblockVm.enableNext();
		}

		blockUnblockVm.selectedCardTypeFun = function () {
			blockUnblockService.selectedCardType = blockUnblockVm.selectedCardType;
			blockUnblockVm.enableNext();
		}

		blockUnblockVm.enableNext = function () {
			if(blockUnblockService.blockUnblockTab == "block"){
				if (blockUnblockService.selectedAccValue != "" && blockUnblockService.selectedCardValue != "" && blockUnblockService.selectedCardType != "" && blockUnblockVm.selectedCardType != "" && blockUnblockVm.selectedCardType != null && blockUnblockVm.selectedCardType != undefined && blockUnblockVm.selectedAccount != "" && blockUnblockVm.selectedAccount != null && blockUnblockVm.selectedAccount != undefined && blockUnblockVm.selectedCard != "" && blockUnblockVm.selectedCard != undefined && blockUnblockVm.selectedCard != "") {
					blockUnblockVm.isNextEnabled = false;
				} else {
					blockUnblockVm.isNextEnabled = blockUnblockVm.blockAllCards ? false : true;
				}
			} else {
				if (blockUnblockService.selectedAccValue != "" && blockUnblockService.selectedCardValue != "" && blockUnblockService.selectedCardValue != null) {
					blockUnblockVm.isNextEnabled = false;
				} else {
					blockUnblockVm.isNextEnabled = true;
				}
			}
		}

		blockUnblockVm.enableblockAllCards = function () {
			blockUnblockService.blockAllCards = blockUnblockVm.blockAllCards;
			if (blockUnblockVm.blockAllCards) {
				blockUnblockVm.disabledSelAcc = true;
				blockUnblockVm.selectedAccount = "";
				blockUnblockService.selectedAccValue = "";
				blockUnblockVm.disabledcardBlock = true;
				blockUnblockVm.disabledcardType = true;
				blockUnblockVm.selectedCard = "";
				blockUnblockService.selectedCardValue = "";
				blockUnblockService.selectedCardType = "Permanent";
				blockUnblockVm.selectedCardType = blockUnblockService.selectedCardType;
				
			} else {
				
				blockUnblockVm.disabledSelAcc = false;
				blockUnblockVm.disabledcardBlock = false;
				blockUnblockVm.disabledcardType = false;
				if(blockUnblockVm.selectedCard != ""){
						blockUnblockVm.selectedCardType = blockUnblockService.selectedCardType;
				}else {
					blockUnblockVm.selectedCardType = "";
					blockUnblockService.selectedCardType = "";
				}
				
				
			}
			blockUnblockVm.enableNext();
		}

		$scope.$on('$ionicView.beforeEnter', function () {
			blockUnblockVm.enableblockAllCards();
		});

		blockUnblockVm.blockAllPermanentCards = function () {
			blockUnblockVm.enableblockAllCards();
		}

		blockUnblockVm.blockAll = function () {
			blockUnblockVm.BlockUnblock = "block";
			blockUnblockService.BlockUnblock = true;
		}

		blockUnblockVm.info = function () {
			if(!blockUnblockVm.blockAllCards){
				blockUnblockVm.myPopup = $ionicPopup.show({
				title: '',
				cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
				templateUrl: 'pages/nfs/blockUnblock/cardType.html',
				scope: $scope
			});
		}
			}

			

		blockUnblockVm.ok = function () {
			blockUnblockVm.myPopup.close();
		};

		blockUnblockVm.goToback = function () {
			blockUnblockService.clearAllData();
			$state.go('menu.innerPage');
			
		}

		blockUnblockVm.goToHome = function () {
			$state.go('menu.homeScreen');
		}
	

		blockUnblockVm.goToNext = function () {
			$state.go('menu.blockUnblockReview');
		}
		return this;
	}
]);
