'use strict';

angularApp.controller('blockUnblockReviewController', ["$timeout",
	"$state",
	"$ionicPopup",
	"$scope",
	"utilityService",
	"customerInfoService",
	"personalLoanService",
	"blockUnblockService",
	function ($timeout,
		$state, $ionicPopup,
		$scope,
		utilityService,
		customerInfoService,
		personalLoanService,
		blockUnblockService) {

		//functions, variables that can be accessed from the HTML come here
		var blockUnblockReviewVm = this;
		blockUnblockReviewVm.blockAccSelectedValue = {};
		blockUnblockReviewVm.blockCardSelectedValue = {};

		blockUnblockReviewVm.init = function () {
			blockUnblockReviewVm.showAllpermanentCards = blockUnblockService.blockAllCards;
			blockUnblockReviewVm.blockData = blockUnblockService.blockUnblockTab == "block" ? false : true;
		}

		$scope.$on('$ionicView.loaded', function () {
			blockUnblockReviewVm.init();
			if(blockUnblockReviewVm.showAllpermanentCards){
				blockUnblockReviewVm.getPermanentBlockList();
			}else{
				blockUnblockReviewVm.blockAccSelectedValue = blockUnblockService.selectedAccValue;
				blockUnblockReviewVm.blockCardSelectedValue = blockUnblockService.selectedCardValue;
				blockUnblockReviewVm.selectedCardType = blockUnblockService.selectedCardType;
			}
		});

		blockUnblockReviewVm.getPermanentBlockList = function () {
			blockUnblockService.permanentBlockList().then(function (data) {
				blockUnblockReviewVm.permanentBlockCardList = data.cardList;
				blockUnblockService.permanentBlockCardList = blockUnblockReviewVm.permanentBlockCardList;
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
				blockUnblockReviewVm.disabledcardBlock = true;
				
			});
		}

		blockUnblockReviewVm.goToNext = function () {
			//$state.go('menu.blockUnblockOtp');
			var reqData = {
				// "id": customerInfoService.customer.mobile,
				// "emailId": customerInfoService.customer.emailID
				 "id": customerInfoService.customer.mobile,
				 "emailId": customerInfoService.customer.emailID
			}
			personalLoanService.otpLoan(reqData).then(function (data) {
				//personalLoanService.otp=data.otp;
				$state.go('menu.blockUnblockOtp');
			}, function (error) {
				
				utilityService.showErrorMessage(error.responseMessage);
				blockUnblockReviewVm.disabledcardBlock = true;
			});
		}

		blockUnblockReviewVm.goToback = function () {
			$state.go('menu.blockUnblock');
			

		}
		blockUnblockReviewVm.goToHome = function () {
			blockUnblockService.clearAllData();
				$state.go('menu.homeScreen');
		}

		$scope.$on('$ionicView.beforeEnter', function () {

	


		});



		return this;
	}
]);
