'use strict';

angularApp.service('blockUnblockService',
	function ($q, AdapterUtils) {

		var blockUnblockService = this;

		blockUnblockService.blockUnblockTab = "block";
		blockUnblockService.accList = [];
		blockUnblockService.cardList = [];
		blockUnblockService.selectedAccValue = null;
		blockUnblockService.selectedCardValue = null;
		blockUnblockService.selectedCardType = "";
		blockUnblockService.blockAllCards = false;

		blockUnblockService.clearAllData = function () {
			blockUnblockService.blockUnblockTab = "block";
			blockUnblockService.accList = [];
			blockUnblockService.cardList = [];
			blockUnblockService.selectedAccValue = null;
			blockUnblockService.selectedCardValue = null;
			blockUnblockService.selectedCardType = "";
			blockUnblockService.blockAllCards = false;
		}

		blockUnblockService.viewBlockedDebitCards = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/viewBlockedDebitCards", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		blockUnblockService.viewDebitCards = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/viewDebitCards", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		blockUnblockService.unblockDebitCard = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/unblockDebitCard", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};


		blockUnblockService.blockRequest = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/blockRequest", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		blockUnblockService.permanentBlockList = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/permanentBlockList", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		blockUnblockService.permanentBlockRequest = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/permanentBlockRequest", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		blockUnblockService.unblockDebitCard = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/unblockDebitCard", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		

		blockUnblockService.accountFilterRequest = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/accountFilterRequest", {}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		return blockUnblockService;
	});
