'use strict';

angularApp.service('personalLoanService',
	function($q, AdapterUtils ) {

		var accountNumber = "";
		var loanAmount = "";
		var duration = "";
		var emiDate = "";
		var emiAmount = "";
		var loanAccountNumber = "";
		var accNo = "";
		var amount = "";
		var personalLoanData ={};
		var otp = "";
		var checkBox = 'N';
		var minDuration="";
		var maxDuration="";
		var minBestOffer="";
		var interestRate="";
		var activityCode="";
		var schemeCode="";
		var interest="";
		var product="";
		var checkTnC = false;




		var getLoanDetails = function() {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/getPreApprovedData", true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				);
			return q.promise;
		};

		var getMasterData = function(reqData) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/getProductDetails",reqData, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				);
			return q.promise;
		};

		var pALTerm = function() {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/termsConditions", true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				);
			return q.promise;
		};

		var otpLoan = function(reqData) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/OTPAdapter/getOTPTokenSecure",reqData, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				);
			return q.promise;
		};

		var requestOtp = function(reqData) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/OTPAdapter/validateOTPTokenSecure",reqData, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				);
			return q.promise;
		};

		var applyForLoan = function(reqData) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/createPreApprovedLoan",reqData, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				);
			return q.promise;
		};


		return{
			getMasterData : getMasterData,
			getLoanDetails : getLoanDetails,
			pALTerm : pALTerm,
			otpLoan : otpLoan,
			requestOtp : requestOtp,
			applyForLoan : applyForLoan,
			accountNumber : accountNumber,
			loanAmount : loanAmount,
			duration : duration,
			emiAmount : emiAmount,
			emiDate : emiDate,
			loanAccountNumber : loanAccountNumber,
			amount : amount,
			accNo : accNo,
			personalLoanData : personalLoanData,
			otp : otp,
			checkBox : checkBox,
			minDuration : minDuration,
			maxDuration : maxDuration,
            minBestOffer : minBestOffer,
            interestRate : interestRate,
			activityCode : activityCode,
			schemeCode : schemeCode,
			interest : interest,
			product:product,
			checkTnC:checkTnC


			};
			});
