'use strict';

angularApp.controller('selAccToEnableCBController', ["$state",
	"$ionicPopup",
	"$scope",
	"changeAccountTypeService",
	"customerInfoService",
	"personalLoanService",
	"utilityService",

	function ($state,
		$ionicPopup,
		$scope,
		changeAccountTypeService,
		customerInfoService,
		personalLoanService,
		utilityService) {

		var selAccToEnableCBVm = this;

		selAccToEnableCBVm.goToback = function () {
			changeAccountTypeService.clearAll();
				$state.go('menu.innerPage');

		}

		selAccToEnableCBVm.goToHome = function () {
			changeAccountTypeService.clearAll();
				$state.go('menu.homeScreen');
		}

		selAccToEnableCBVm.goToNext = function () {

			var reqData = {
				"id": customerInfoService.customer.mobile,
				"emailId": customerInfoService.customer.emailID
			}

			personalLoanService.otpLoan(reqData).then(function (data) {
				$state.go('menu.changeAccTypeOtp');
			}, function (error) {

				utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");


			});

		}

		selAccToEnableCBVm.selectedAccountFun = function () {

			changeAccountTypeService.selectedAccount = selAccToEnableCBVm.selectedAccount == "" ? null : JSON.parse(selAccToEnableCBVm.selectedAccount);
			selAccToEnableCBVm.nextEnable();
		}

		selAccToEnableCBVm.nextEnable = function () {
			if (selAccToEnableCBVm.selectedAccount) {
				selAccToEnableCBVm.isNextEnabled = false;
			} else {
				selAccToEnableCBVm.isNextEnabled = true;

			}

		}

		selAccToEnableCBVm.init = function () {
			selAccToEnableCBVm.nextEnable();
		}

		$scope.$on('$ionicView.beforeEnter', function () {

			changeAccountTypeService.getAccountsForProductTypeChange().then(function (data) {
				
				selAccToEnableCBVm.accList = data.accList;
				changeAccountTypeService.accList = selAccToEnableCBVm.accList;

				
			}, function (error) {
				utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
			});

			selAccToEnableCBVm.init();

		});


		return this;
	}



]);
