'use strict';

angularApp.controller('chequeEnquiryController', ["$state",
	"$ionicPopup",
	"$scope",
	"chequeEnquiryService",
	"utilityService",

	function ($state,
		$ionicPopup,
		$scope,
		chequeEnquiryService,
		utilityService) {

		var chequeEnquiryVm = this;

		chequeEnquiryVm.isNextEnable = true;


		chequeEnquiryVm.init = function () {
			chequeEnquiryVm.typesOfCheque = chequeEnquiryService.typesOfCheque;
			chequeEnquiryVm.EnterCheque = chequeEnquiryService.EnterCheque;
			chequeEnquiryVm.toCheque = chequeEnquiryService.toCheque;
			chequeEnquiryVm.fromCheque = chequeEnquiryService.fromCheque;
			chequeEnquiryVm.selectedCardType = chequeEnquiryService.selectedCardType;
			chequeEnquiryVm.multiSelectedCardType = chequeEnquiryService.multiSelectedCardType;
			chequeEnquiryVm.selectedAccount = chequeEnquiryService.selectedAccValue == null ? "" : JSON.stringify(chequeEnquiryService.selectedAccValue);
			chequeEnquiryVm.chqResult = false;
			chequeEnquiryVm.nextEnable();
		}





		chequeEnquiryVm.goToNext = function () {

			if (chequeEnquiryService.typesOfCheque == "single") {
				var requestData = {
					"branchCode": chequeEnquiryService.selectedAccValue.branchCode,
					"accountNumber": chequeEnquiryService.selectedAccValue.accountNumber,
					"fromChequeNumber": chequeEnquiryService.EnterCheque,
					"toChequeNumber": chequeEnquiryService.EnterCheque,
					"branchName": chequeEnquiryService.selectedAccValue.branchName,
					"instrumentType": chequeEnquiryService.selectedCardType,
					"accountType": chequeEnquiryService.selectedAccValue.accountType


				}

			} else {
				var requestData = {
					"branchCode": chequeEnquiryService.selectedAccValue.branchCode,
					"accountNumber": chequeEnquiryService.selectedAccValue.accountNumber,
					"fromChequeNumber": chequeEnquiryService.fromCheque,
					"toChequeNumber": chequeEnquiryService.toCheque,
					"branchName": chequeEnquiryService.selectedAccValue.branchName,
					"instrumentType": chequeEnquiryService.multiSelectedCardType,
					"accountType": chequeEnquiryService.selectedAccValue.accountType
				}
			}

	

			chequeEnquiryService.chequeStatusEnquiry(requestData).then(function (data) {
				
				chequeEnquiryService.chequeDetails = data.chequeDetails;
				chequeEnquiryService.referenceNumber = data.referenceNumber;
				utilityService.setCsatJournies('chequeStatusEnquiry');
				$state.go('menu.chequeEnquiryResult');

			}, function (error) {
				//chequeEnquiryService.clearAll();
				utilityService.showNfsAlertModal("", error.responseMessage, "menu.chequeEnquiry", $scope, $state, "OK");


			});


		}

		chequeEnquiryVm.ok = function () {

			$state.go('menu.chequeEnquiryResult');
			chequeEnquiryVm.myPopup.close();

		};




		chequeEnquiryVm.goToHome = function () {
			chequeEnquiryService.clearAll();
			$state.go('menu.homeScreen');

		}

		chequeEnquiryVm.goToback = function () {
			chequeEnquiryService.clearAll();
			$state.go('menu.innerPage');
		}

		chequeEnquiryVm.selectedAccountFun = function () {
			chequeEnquiryService.selectedAccValue = chequeEnquiryVm.selectedAccount == "" ? null : JSON.parse(chequeEnquiryVm.selectedAccount);
			chequeEnquiryVm.nextEnable();
		}

		chequeEnquiryVm.enterCheque = function () {
			if (chequeEnquiryVm.EnterCheque.length < 6) {

				chequeEnquiryVm.isValidError = true;

			} else {
				chequeEnquiryVm.isValidError = false;
				chequeEnquiryService.EnterCheque = chequeEnquiryVm.EnterCheque;
			}
			chequeEnquiryVm.nextEnable();
		}

		chequeEnquiryVm.fromChequeFun = function () {
			chequeEnquiryService.fromCheque = chequeEnquiryVm.fromCheque;
			if (chequeEnquiryVm.fromCheque.length < 6) {
				chequeEnquiryVm.fromChequeError = true;
				chequeEnquiryVm.validCheckrange = false;
				chequeEnquiryVm.chqResult = false;

			} else if (parseInt(chequeEnquiryVm.toCheque) < parseInt(chequeEnquiryVm.fromCheque)) {
				chequeEnquiryVm.chqResult = false;
				chequeEnquiryVm.fromChequeError = false;
				chequeEnquiryVm.validCheckrange = true;
				chequeEnquiryVm.isNextEnable = true;


			} else {
				chequeEnquiryVm.fromChequeError = false;
				chequeEnquiryVm.validCheckrange = false;
				chequeEnquiryVm.chqResult = false;
				chequeEnquiryVm.validate12cheque();
				
			}

			chequeEnquiryVm.nextEnable();
		}


		chequeEnquiryVm.toChequeFun = function () {
			chequeEnquiryService.toCheque = chequeEnquiryVm.toCheque;
			if (chequeEnquiryVm.toCheque.length < 6) {
				chequeEnquiryVm.toChequeError = true;
				chequeEnquiryVm.validCheckrange = false;
				chequeEnquiryVm.chqResult = false;



			} else if (parseInt(chequeEnquiryVm.toCheque) < parseInt(chequeEnquiryVm.fromCheque)) {

				chequeEnquiryVm.toChequeError = false;
				chequeEnquiryVm.validCheckrange = true;
				chequeEnquiryVm.isNextEnable = true;
				chequeEnquiryVm.chqResult = false;

			}
			else {
				chequeEnquiryVm.toChequeError = false;
				chequeEnquiryVm.validCheckrange = false;
				chequeEnquiryVm.chqResult = false;
				chequeEnquiryVm.validate12cheque();
				
			}


			chequeEnquiryVm.nextEnable();
		}


		chequeEnquiryVm.validate12cheque = function () {

			if (chequeEnquiryVm.toCheque.length != 6) {
				// nothing to do
			} else {

				var FromChq = parseInt(chequeEnquiryVm.fromCheque);
				var toChq = parseInt(chequeEnquiryVm.toCheque);
				var resultChq = toChq - FromChq;

				if (resultChq < 12) {
					chequeEnquiryVm.chqResult = false;
					chequeEnquiryVm.isNextEnable = false;
				} else {
					var errorData = "Cannot accept more than 12 Cheques";
					utilityService.showNfsAlertModal("", errorData, "menu.chequeEnquiry", $scope, $state, "OK");
					chequeEnquiryVm.chqResult = true;
					chequeEnquiryVm.isNextEnable = true;
				}

			}

			chequeEnquiryVm.nextEnable();


		}

		chequeEnquiryVm.selectedTabFun = function () {
			chequeEnquiryService.typesOfCheque = chequeEnquiryVm.typesOfCheque;
			chequeEnquiryVm.selectedAccount = "";
			chequeEnquiryVm.selectedCardType = "";
			chequeEnquiryVm.toCheque = "";
			chequeEnquiryVm.fromCheque = "";
			chequeEnquiryVm.EnterCheque = "";
			chequeEnquiryVm.multiSelectedCardType = "";
			chequeEnquiryVm.nextEnable();
		}

		chequeEnquiryVm.getAccountList = function () {
			if (!chequeEnquiryService.accList.length) {
				var reqData = {
					"journey": "STATUS",
				}
				chequeEnquiryService.chequeAccountFilterRequest(reqData).then(function (data) {
					chequeEnquiryService.accList = data.accList;
					chequeEnquiryVm.accList = chequeEnquiryService.accList;


				}, function (error) {

					utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
				});

			} else {
				chequeEnquiryVm.accList = chequeEnquiryService.accList;
				chequeEnquiryVm.selectedAccount = chequeEnquiryService.selectedAccValue == null ? "" : JSON.stringify(chequeEnquiryService.selectedAccValue);
			}
			chequeEnquiryVm.nextEnable();

		}

		chequeEnquiryVm.selectedCardTypeFun = function () {
			chequeEnquiryService.selectedCardType = chequeEnquiryVm.selectedCardType;
			// chequeEnquiryVm.toCheque = "";
			// chequeEnquiryVm.fromCheque = "";
			// chequeEnquiryVm.EnterCheque = "";
			chequeEnquiryVm.nextEnable();
		}

		chequeEnquiryVm.multiSelectedCardTypeFun = function () {
			chequeEnquiryService.multiSelectedCardType = chequeEnquiryVm.multiSelectedCardType;
			chequeEnquiryVm.toCheque = "";
			chequeEnquiryVm.fromCheque = "";
			chequeEnquiryVm.EnterCheque = "";
			chequeEnquiryVm.nextEnable();
		}

		chequeEnquiryVm.nextEnable = function () {

			if (chequeEnquiryService.typesOfCheque == "single") {

				if (chequeEnquiryVm.selectedAccount != undefined && chequeEnquiryVm.selectedAccount != null && chequeEnquiryVm.selectedCardType != "" && chequeEnquiryVm.selectedCardType != null && chequeEnquiryVm.selectedCardType != undefined && chequeEnquiryVm.selectedAccount != "" && chequeEnquiryVm.EnterCheque != "" && chequeEnquiryVm.EnterCheque != null && chequeEnquiryVm.EnterCheque != undefined && chequeEnquiryVm.EnterCheque.length === 6) {
					chequeEnquiryVm.isNextEnable = false;
				} else {
					chequeEnquiryVm.isNextEnable = true;
				}


			} else {

			if (chequeEnquiryVm.selectedAccount != undefined && chequeEnquiryVm.selectedAccount != null && chequeEnquiryVm.selectedAccount != "" && chequeEnquiryVm.multiSelectedCardType != "" && chequeEnquiryVm.multiSelectedCardType != null && chequeEnquiryVm.multiSelectedCardType != undefined && chequeEnquiryVm.fromCheque != "" && chequeEnquiryVm.fromCheque != null && chequeEnquiryVm.fromCheque != undefined && chequeEnquiryVm.fromCheque.length === 6 && chequeEnquiryVm.chqResult == false && chequeEnquiryVm.toCheque != "" && chequeEnquiryVm.toCheque != undefined && chequeEnquiryVm.toCheque != null && chequeEnquiryVm.toCheque.length === 6 && parseInt(chequeEnquiryVm.fromCheque) <= parseInt(chequeEnquiryVm.toCheque)) {
					chequeEnquiryVm.isNextEnable = false;
				} else {
					chequeEnquiryVm.isNextEnable = true;
				}

			}

		}


		$scope.$on('$ionicView.loaded', function () {


			chequeEnquiryVm.getAccountList();

			// chequeEnquiryVm.accData = {

			// 	"accList": [
			// 		{ "accountNumber": "XXXXXXX2015", "accountType": "overdraft", "accountBalance": "17600.00", "branchCode": "00437", "branchName": "Nasik", "productCode": "50111101" },
			// 		{ "accountNumber": "XXXXXXX2015", "accountType": "Current", "accountBalance": "7600.00", "branchCode": "00437", "branchName": "pune", "productCode": "50111101" },
			// 		{ "accountNumber": "XXXXXXX7218", "accountType": "Savings", "accountBalance": "319851.00", "branchCode": "04791", "branchName": "mumbai", "productCode": "10111101" }
			// 	]
			// }



		});

		$scope.$on('$ionicView.beforeEnter', function () {

			chequeEnquiryVm.init();

		});

		return this;
	}
]);
