'use strict';

angularApp.controller('emailUpdateOTPNewController', [
	"$state",
	"$ionicPopup",
	"$scope",
	"emaillDetailsService",
	"serviceRequestService",
	"utilityService",
	"getAccountDetailsService",
	"fTSetOTPService",
	"$rootScope",
	"customerInfoService",
	"constantConfig",
	"cryptoService",
	"$ionicHistory",
	"loggedInUserService",
	"$ionicViewSwitcher",
	function (
		$state,
		$ionicPopup,
		$scope,
		emaillDetailsService,
		serviceRequestService,
		utilityService,
		getAccountDetailsService,
		fTSetOTPService,
		$rootScope,
		customerInfoService,
		constantConfig,
		cryptoService,
		$ionicHistory,
		loggedInUserService,
		$ionicViewSwitcher) {

		var emailUpdateOtpNewVm = this;

		var resendCount = 0;
		emailUpdateOtpNewVm.mobileNo = customerInfoService.customer.mobile;
		emailUpdateOtpNewVm.isDisabledOTP = false;
		var isResendCalled = false;
		emailUpdateOtpNewVm.isRequired = false; 
		emailUpdateOtpNewVm.isInvalid = false;
		emailUpdateOtpNewVm.submitted = false;

		emailUpdateOtpNewVm.goBack = function () {
			$ionicHistory.goBack();
		}

		emailUpdateOtpNewVm.otpValidate = function () {
			emailUpdateOtpNewVm.submitted = true;
			if(!emailUpdateOtpNewVm.otp || emailUpdateOtpNewVm.otp.length === 0){
				emailUpdateOtpNewVm.isRequired = true; 
				emailUpdateOtpNewVm.isInvalid = false;
			}else if(emailUpdateOtpNewVm.otp.length > 0 && emailUpdateOtpNewVm.otp.length < 6){
				emailUpdateOtpNewVm.isRequired = false; 
				emailUpdateOtpNewVm.isInvalid = true;
			}else{
				var reqParams = {};
				reqParams["otp"] = emailUpdateOtpNewVm.otp;
				reqParams["mobile"] = customerInfoService.customer.mobile;
				fTSetOTPService.validateOTP(reqParams).then(function (data) {
					emailUpdateOtpNewVm.updateEmail();
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}
		}

		emailUpdateOtpNewVm.updateEmail = function () {
			var hashEmail = loggedInUserService.tokenLotus + emaillDetailsService.emailId;
			var emailSHA512 = cryptoService.getSHA512EncryptedData(hashEmail).toString();

			var requestData = {
				"emailId": emaillDetailsService.emailId,
				"hash": emailSHA512
			}

			emaillDetailsService.update(requestData).then(function (data) {
				$ionicViewSwitcher.nextDirection('back');
				emaillDetailsService.clearAllData();
				var template = "<span translate='NFS_EMAIL_UPDATE_SUCCESS_MSG'></span>";
				utilityService.showBhimUpiAlert('success',template,'menu.homeScreen','Ok',$scope);
			}, function (error) {
				$ionicViewSwitcher.nextDirection('back');
				utilityService.showBhimUpiAlert("error", error.responseMessage, "menu.homeScreen", 'Ok',$scope);

			});
		}

		emaillDetailsService.generateOTP = function(){
			var template = "<span translate='LBL_STEP1_RESEND_OTP_SUCCESS_MSG'></span>";
			var reqParams = {};
			reqParams["id"] = customerInfoService.customer.mobile;
			reqParams.otpCode = constantConfig.keysForOTP.ftNormalFundTransfer;
			reqParams.ocHash = cryptoService.getSHA512EncryptedData(constantConfig.keysForOTP.ftNormalFundTransfer).toString();
			fTSetOTPService.generateOTP(reqParams).then(function (data) {
				isResendCalled ? resendCount++ : resendCount = 0;
				if(isResendCalled){
					utilityService.showBhimUpiAlert('info',template,'','Ok',$scope);
				}
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		}

		$scope.$on('$ionicView.beforeEnter', function () {
			emaillDetailsService.generateOTP();
		});

		emailUpdateOtpNewVm.resendOTP = function(){
			if(!emailUpdateOtpNewVm.isDisabledOTP && resendCount < 2){
				isResendCalled = true;
				emaillDetailsService.generateOTP();
			}else{
				emailUpdateOtpNewVm.isDisabledOTP = true;
			}
		}



		return this;
	}
]);
