'use strict';

angularApp.controller('resetProfilePwdController', ["$state",
	"$ionicPopup",
	"$scope",
	"$filter",
	"loggedInUserService",
	"customerInfoService",
	"cryptoService",
	"fgtProfilePwdService",
	"utilityService", "inbForgotPwdService",
	"constantConfig",
	function ($state,
		$ionicPopup,
		$scope,
		$filter,
		loggedInUserService,
		customerInfoService,
		cryptoService,
		fgtProfilePwdService,
		utilityService, inbForgotPwdService,
		constantConfig) {

		var resetProfilePwdVm = this;
		resetProfilePwdVm.errorPassword = false;
		resetProfilePwdVm.passWordMatch = false;
		resetProfilePwdVm.isNextEnabled = true;
		resetProfilePwdVm.isTextReadable = false;
		resetProfilePwdVm.isTextReadablereEnter = false
		resetProfilePwdVm.resetPasswordFun = function () {
			fgtProfilePwdService.reEnterPassword = resetProfilePwdVm.reEnterPassword;
			var regularExpression = /^(?=.*[0-9])(?=.*[a-z])(?=.*[A-Z])(?=.*[~`!"',-./@#$%^&*+/(/)\s])[a-zA-Z0-9~`!"',-./@#$%^&*+/(/)\s]{8,20}$/;

			if (!regularExpression.test(resetProfilePwdVm.resetPassword)) {
				resetProfilePwdVm.errorPassword = true;
				resetProfilePwdVm.notMatch = false;
			} else {
				resetProfilePwdVm.errorPassword = false;
				resetProfilePwdVm.notMatch = true;
				if (resetProfilePwdVm.reEnterPassword == resetProfilePwdVm.resetPassword) {
					resetProfilePwdVm.passWordMatch = true;
					resetProfilePwdVm.notMatch = false;
				} else {
					resetProfilePwdVm.passWordMatch = false;
					resetProfilePwdVm.notMatch = true;
				}

			}
			resetProfilePwdVm.nextEnable();
		}

		resetProfilePwdVm.reset = function () {
			resetProfilePwdVm.reEnterPassword = "";
			resetProfilePwdVm.resetPassword = "";
			resetProfilePwdVm.errorPassword = false;
			resetProfilePwdVm.notMatch = false;
			resetProfilePwdVm.passWordMatch = false;
			resetProfilePwdVm.isNextEnabled = true;

		}

		resetProfilePwdVm.submit = function () {
			var loggedInUserDetails = loggedInUserService.getUserProfileDetails();
			var SaltValue = "|";
			var finalSHA512Val = cryptoService.encryptRSAWithPublicKey(resetProfilePwdVm.reEnterPassword, cryptoService.rsaPublicKey);
			var reqData = {
				"toChange": finalSHA512Val,
				"mode": inbForgotPwdService.profile,
				"journeyName":constantConfig.OTP_EMAIL_SMS_TEMPLATE.RESET_PROFILE_PASS
			}

			fgtProfilePwdService.getOTPSecure(reqData).then(function (data) {
				
				$state.go('menu.forgotProfilePwdOtp');

			}, function (error) {
			
				utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
			});
		}

		resetProfilePwdVm.nextEnable = function () {
			if (resetProfilePwdVm.reEnterPassword && resetProfilePwdVm.resetPassword && resetProfilePwdVm.passWordMatch && !resetProfilePwdVm.errorPassword) {
				resetProfilePwdVm.isNextEnabled = false;
			} else {
				resetProfilePwdVm.isNextEnabled = true;
			}


		}
		resetProfilePwdVm.toggleEyeEnter = function () {
			resetProfilePwdVm.isTextReadable == true ? resetProfilePwdVm.isTextReadable = false : resetProfilePwdVm.isTextReadable = true;
		};

		resetProfilePwdVm.toggleEyeReEnter = function () {
			resetProfilePwdVm.isTextReadablereEnter == true ? resetProfilePwdVm.isTextReadablereEnter = false : resetProfilePwdVm.isTextReadablereEnter = true;
		};
		$scope.$on('$ionicView.loaded', function () {
		});

		$scope.$on('$ionicView.beforeEnter', function () {


		});

		resetProfilePwdVm.goToHome = function () {
			$state.go('menu.homeScreen');
		}
		
		resetProfilePwdVm.sessionLogout = function () {
			AdapterUtils.sessionLogout().then(
				function (response) {
				loggedInUserService.logoutUser();
				},
				function (error) {
				loggedInUserService.logoutUser();
				}
			);
		}



		return this;
	}

]);
