'use strict';

angularApp.controller('form15SubmissionLandingController', ["$state",
	"$ionicPopup",
	"$scope",
	"requestChequeBookService",
	"serviceRequestService",
	"utilityService",
	"form15SubmissionService",
	"customerInfoService",
	"formEnquiryService",

	function ($state,
		$ionicPopup,
		$scope,
		requestChequeBookService,
		serviceRequestService,
		utilityService,
		form15SubmissionService,
		customerInfoService,
		formEnquiryService) {

		var form15SubmissionLandingControllerVm = this;
		form15SubmissionLandingControllerVm.isTextMasked = true;
		form15SubmissionLandingControllerVm.isTextUnMasked = false;

		form15SubmissionLandingControllerVm.goBacktoPrevious = function () {
			serviceRequestService.innerpageHeader = "Tax & Investments";
			serviceRequestService.imageIcon = 'img/serviceRequest/Tax.svg';
			serviceRequestService.innerLinks = serviceRequestService.getTaxInvOptions();
			$state.go('menu.innerPage');
		}

		form15SubmissionLandingControllerVm.selectedBranch = function () {
			form15SubmissionService.branch = form15SubmissionLandingControllerVm.branch;
		}

		form15SubmissionLandingControllerVm.next = function (selectedBranch) {
			if (form15SubmissionLandingControllerVm.validateForm()) {
				form15SubmissionLandingControllerVm.branchDtls = JSON.parse(selectedBranch);
				var requestParams = {
					branch: {
						"branchCode": form15SubmissionLandingControllerVm.branchDtls.branchCode,
						"branchName": form15SubmissionLandingControllerVm.branchDtls.branchName,
						"displayName": form15SubmissionLandingControllerVm.branchDtls.displayName
					}
				}

				form15SubmissionService.getForm15GHDetails(requestParams).then(function (response) {
					form15SubmissionService.formDetails = response.data;
					if (form15SubmissionService.formDetails.form15Type == "G") {
						form15SubmissionService.fromTypeG = true;
					} else {
						form15SubmissionService.fromTypeH = true;
					}
					$state.go('menu.formSubmisDetailScreenOne');
				}, function (error) {
					formEnquiryService.displayPopUp('<center><img class="inb-error-sym" src="img/FT/BhimUpi/errorSymbol.svg" /><br><p class="inb-alert-header inb-mart-12"></p><center/>',
						error.responseMessage, ["OK"], function () {
							$state.go('menu.homeScreen');
						});
				});
			}
		}

		form15SubmissionLandingControllerVm.validateForm = function () {
			form15SubmissionLandingControllerVm.errObj = {};
			if (!form15SubmissionLandingControllerVm.branch) {
				form15SubmissionLandingControllerVm.errObj.selectBranch = true;
			}
			return (angular.equals({}, form15SubmissionLandingControllerVm.errObj)) ? true : false;
		}

		form15SubmissionLandingControllerVm.maskedText = function () {
			form15SubmissionLandingControllerVm.isTextMasked = false;
			form15SubmissionLandingControllerVm.isTextUnMasked = true;
			form15SubmissionLandingControllerVm.cifNumber = form15SubmissionService.cifNum;
		};

		form15SubmissionLandingControllerVm.unMaskedText = function () {
			form15SubmissionLandingControllerVm.isTextUnMasked = false;
			form15SubmissionLandingControllerVm.isTextMasked = true;
			var reqParams = {
				"isMasked": "N"
			}
			form15SubmissionService.checkPreValidation(reqParams).then(function (response) {
				form15SubmissionLandingControllerVm.cifNumber = response.cif;
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		};

		$scope.$on('$ionicView.beforeEnter', function () {
			form15SubmissionLandingControllerVm.maskedText();
			form15SubmissionLandingControllerVm.branch = form15SubmissionService.branch;
			form15SubmissionLandingControllerVm.cifNumber = form15SubmissionService.cifNum;
			form15SubmissionService.getBranchList().then(function (response) {
				console.log(response);
				form15SubmissionLandingControllerVm.branchDetails = response.branchDetails;
				form15SubmissionService.branchDetails = form15SubmissionLandingControllerVm.branchDetails;
			}, function (error) {
				formEnquiryService.displayPopUp('<center><img class="inb-error-sym" src="img/FT/BhimUpi/errorSymbol.svg" /><br><p class="inb-alert-header inb-mart-12"></p><center/>',
					error.responseMessage, ["OK"], function () {
						$state.go('menu.homeScreen');
					});
			});
		});

		return this;
	}
]);
