'use strict';

angularApp.controller('formSubDetailScreenFourController', ["$state",
	"$ionicPopup",
	"$scope",
	"requestChequeBookService",
	"serviceRequestService",
	"utilityService",
	"form15SubmissionService",
	"formEnquiryService",
	"$ionicPopover",

	function ($state,
		$ionicPopup,
		$scope,
		requestChequeBookService,
		serviceRequestService,
		utilityService,
		form15SubmissionService,
		formEnquiryService,
		$ionicPopover) {

		var formSubDetailScreenFourControllerVm = this;

		formSubDetailScreenFourControllerVm.validateAmount = function(){
			formSubDetailScreenFourControllerVm.aggregateAmountError = false;
			if(formSubDetailScreenFourControllerVm.aggregateAmount && formSubDetailScreenFourControllerVm.aggregateAmount.split(".")[0].length > 6){
				formSubDetailScreenFourControllerVm.aggregateAmount = formSubDetailScreenFourControllerVm.aggregateAmount.slice(0, 6);
			}
		}

		formSubDetailScreenFourControllerVm.goToDeclarations = function () {
			if (formSubDetailScreenFourControllerVm.validateFormFields()) {
				formSubDetailScreenFourControllerVm.whetherAssessedToTac = form15SubmissionService.valueChecked;
				formSubDetailScreenFourControllerVm.estimatedTotalIncomeOfPY = form15SubmissionService.estimTotalIncome;
				formSubDetailScreenFourControllerVm.selectedYear = form15SubmissionService.selectedYear;
				form15SubmissionService.otherFormDetailsFlag = formSubDetailScreenFourControllerVm.otherFormDetailsFlag;
				form15SubmissionService.numOfFormFiled = formSubDetailScreenFourControllerVm.numOfFormFiled || "";
				form15SubmissionService.filedAggregateAmount = formSubDetailScreenFourControllerVm.aggregateAmount ? formSubDetailScreenFourControllerVm.aggregateAmount : "";
				if(formSubDetailScreenFourControllerVm.whetherAssessedToTac == 'N'){
					formSubDetailScreenFourControllerVm.selectedYear = {};
				}
				var reqParams = {
					"whetherAssessedToTax": formSubDetailScreenFourControllerVm.whetherAssessedToTac,
					"estimatedTotalIncomeOfPY": formSubDetailScreenFourControllerVm.estimatedTotalIncomeOfPY ? Number(formSubDetailScreenFourControllerVm.estimatedTotalIncomeOfPY).toFixed(2) : "",
					"noOfForms": formSubDetailScreenFourControllerVm.numOfFormFiled || "",
					"aggIncome":  form15SubmissionService.filedAggregateAmount ? Number(form15SubmissionService.filedAggregateAmount).toFixed(2): "",
					"userSelectedLatestAssessmentYear": formSubDetailScreenFourControllerVm.selectedYear,
					"otherFormDetailsFlag" : formSubDetailScreenFourControllerVm.otherFormDetailsFlag
				};

				form15SubmissionService.submitForm15GH(reqParams).then(function (data) {
					$state.go('menu.formSubDetailReview');
				}, function (error) {
					formEnquiryService.displayPopUp('<center><img class="inb-error-sym" src="img/FT/BhimUpi/errorSymbol.svg" /><br><p class="inb-alert-header inb-mart-12"></p><center/>',
						error.responseMessage, ["OK"], function () {
							$state.go('menu.homeScreen');
						});
				});
			}
		}

		formSubDetailScreenFourControllerVm.validateFormFields = function () {
			formSubDetailScreenFourControllerVm.otherFormDetailsFlagError = false;
			formSubDetailScreenFourControllerVm.numOfFormFiledError = false;
			formSubDetailScreenFourControllerVm.aggregateAmountError = false;
			if(!formSubDetailScreenFourControllerVm.otherFormDetailsFlag){
				formSubDetailScreenFourControllerVm.otherFormDetailsFlagError = true;
				//return false;
			}
			if(formSubDetailScreenFourControllerVm.otherFormDetailsFlag !=='N' && !formSubDetailScreenFourControllerVm.numOfFormFiled){
				formSubDetailScreenFourControllerVm.numOfFormFiledErrorMsg = 'Enter the number';
				formSubDetailScreenFourControllerVm.numOfFormFiledError = true;
				//return false;
			}
			if(formSubDetailScreenFourControllerVm.otherFormDetailsFlag !=='N' && Number(formSubDetailScreenFourControllerVm.numOfFormFiled) == 0){
				formSubDetailScreenFourControllerVm.numOfFormFiledErrorMsg = 'Please enter the valid number';
				formSubDetailScreenFourControllerVm.numOfFormFiledError = true;
				//return false;
			}
			if(formSubDetailScreenFourControllerVm.otherFormDetailsFlag !=='N' && formSubDetailScreenFourControllerVm.typeG && formSubDetailScreenFourControllerVm.aggregateAmount && Number(formSubDetailScreenFourControllerVm.aggregateAmount) > 250000){
				formSubDetailScreenFourControllerVm.aggregateAmountError = true;
				formSubDetailScreenFourControllerVm.aggregateAmountErrorMsg = 'Maximum amount should not exceed Rs.2,50,000/-';
				//return false
			}
			if(formSubDetailScreenFourControllerVm.otherFormDetailsFlag !=='N' && !formSubDetailScreenFourControllerVm.aggregateAmount){
				formSubDetailScreenFourControllerVm.aggregateAmountError = true;
				formSubDetailScreenFourControllerVm.aggregateAmountErrorMsg = 'Enter an amount';
				//return false;
			}
			if(formSubDetailScreenFourControllerVm.otherFormDetailsFlag !=='N' && Number(formSubDetailScreenFourControllerVm.aggregateAmount) < 1){
				formSubDetailScreenFourControllerVm.aggregateAmountError = true;
				formSubDetailScreenFourControllerVm.aggregateAmountErrorMsg = 'Enter the valid amount';
				//return false;
			}
			if(formSubDetailScreenFourControllerVm.otherFormDetailsFlag !=='N' && isNaN(formSubDetailScreenFourControllerVm.aggregateAmount)){
				formSubDetailScreenFourControllerVm.aggregateAmountError = true;
				formSubDetailScreenFourControllerVm.aggregateAmountErrorMsg = 'Enter the valid amount';
				//return false;
			}
			
			if(formSubDetailScreenFourControllerVm.otherFormDetailsFlagError || formSubDetailScreenFourControllerVm.numOfFormFiledError || formSubDetailScreenFourControllerVm.aggregateAmountError){
				return false;
			}
			else{
				return true;
			}
			//return true;
		}

		formSubDetailScreenFourControllerVm.filedDeclarations = function () {
			formSubDetailScreenFourControllerVm.declarationList = form15SubmissionService.formDetails.incomeDetails;
			form15SubmissionService.numOfFormFiled = formSubDetailScreenFourControllerVm.numOfFormFiled;
			form15SubmissionService.filedAggregateAmount = formSubDetailScreenFourControllerVm.aggregateAmount;
			$state.go('menu.formFiledDeclarations');
		}

		formSubDetailScreenFourControllerVm.back = function () {
			$state.go('menu.formSubmisDetailScreenThree');
		}

		formSubDetailScreenFourControllerVm.infoDetails = function ($event) {
			if(utilityService.isIOSPlatform()){
              formSubDetailScreenFourControllerVm.topStyle = "margin-top : -5px; right:15px; width:90%; height:300px; left:unset !important;background: #d7d7d7 !important;";
            }
            else{
              formSubDetailScreenFourControllerVm.topStyle = "margin-top : 10px; right:15px; width:90%; height:300px; left:unset !important;background: #d7d7d7 !important;";
            }
			var template = '<ion-popover-view class=" loginnewarrow form15" style="{{formSubDetailScreenFourControllerVm.topStyle}}" id="nfsruntimeHeight" >' + '<div class="form-15-popover-arrow" style="right:11px !important;"></div>' + '<ion-content has-bouncing="false" class="col">' +
				'<div id="renderHeight" class="text-left form15-pad-lft30 padding-right-10 font-size-12" translate=""><ul style="list-style-type:disc"><li class="margin-lft24" ng-if="formSubDetailScreenFourControllerVm.typeG" translate="NFS_SUB_FORTH_ONE"></li><li class="margin-lft24" ng-if="formSubDetailScreenFourControllerVm.typeH" translate="NFS_SUB_FORTH_ONE_H"></li><li class="margin-lft24" translate="NFS_SUB_FORTH_TWO"></li></ul></div>' + '</ion-content>' + '</ion-popover-view>';
			$scope.popover = $ionicPopover.fromTemplate(template, {
				scope: $scope
			});
			$scope.popover.show($event);
		}

		formSubDetailScreenFourControllerVm.closePopover = function () {
			$scope.popover.hide();
		}

		formSubDetailScreenFourControllerVm.changeotherFormDetailsFlagVal = function(otherFormDetailsFlag){
			if(otherFormDetailsFlag == 'N'){
				formSubDetailScreenFourControllerVm.numOfFormFiled = '';
				formSubDetailScreenFourControllerVm.aggregateAmount = '';
				formSubDetailScreenFourControllerVm.aggregateAmountError = false;
				formSubDetailScreenFourControllerVm.numOfFormFiledError = "";
			}
		}

		$scope.$on('$ionicView.beforeEnter', function () {
			formSubDetailScreenFourControllerVm.numOfFormFiledError = "";
			formSubDetailScreenFourControllerVm.aggregateAmountError = false;

			formSubDetailScreenFourControllerVm.otherFormDetailsFlag = form15SubmissionService.otherFormDetailsFlag || 'Y';
			formSubDetailScreenFourControllerVm.typeG = form15SubmissionService.fromTypeG;
			formSubDetailScreenFourControllerVm.typeH = form15SubmissionService.fromTypeH;
			if(utilityService.isIOSPlatform()){
				formSubDetailScreenFourControllerVm.inputType = "text";
				formSubDetailScreenFourControllerVm.maxlength = "11";
				
			}
			else{
				formSubDetailScreenFourControllerVm.inputType = "tel";
				formSubDetailScreenFourControllerVm.maxlength = "11";
				
			}
			if(formSubDetailScreenFourControllerVm.typeG){
				formSubDetailScreenFourControllerVm.count = 18;
			}
			if(formSubDetailScreenFourControllerVm.typeH){
				formSubDetailScreenFourControllerVm.count = 17;
			}
			formSubDetailScreenFourControllerVm.thirdPageDetails = form15SubmissionService.formDetails;
			if(formSubDetailScreenFourControllerVm.otherFormDetailsFlag !== 'N'){
				formSubDetailScreenFourControllerVm.numOfFormFiled = form15SubmissionService.numOfFormFiled;
				formSubDetailScreenFourControllerVm.aggregateAmount = form15SubmissionService.filedAggregateAmount;
			} else {
				formSubDetailScreenFourControllerVm.numOfFormFiled = '';
				formSubDetailScreenFourControllerVm.aggregateAmount = '';
			}
		});

		return this;
	}
]);
