'use strict';
angularApp.controller('formEnquiryLandingController', ["$state",
	"$ionicPopup",
	"$scope",
	"requestChequeBookService",
	"serviceRequestService",
	"utilityService",
	"MonthPicker",
	"formEnquiryService",
	"regProcessWithAccNoService",
	"openUrlInAppbroswerService",
	"inbLockUnlockService",
	"customerInfoService",
	"pdfDownloadService",
	"$ionicPopover",
	function ($state,
		$ionicPopup,
		$scope,
		requestChequeBookService,
		serviceRequestService,
		utilityService,
		MonthPicker,
		formEnquiryService,
		regProcessWithAccNoService,
		openUrlInAppbroswerService,
		inbLockUnlockService,
		customerInfoService,
		pdfDownloadService,
		$ionicPopover
	) {
		var formEnquiryLandingVm = this;
		formEnquiryLandingVm.selectYearError = false;
		formEnquiryLandingVm.showRecords = false;
		formEnquiryLandingVm.downColor = false;
		formEnquiryLandingVm.isTextMasked = true;
		formEnquiryLandingVm.isTextUnMasked = false;
		formEnquiryLandingVm.goBack = function () {
			$state.go('menu.innerPage');
		}
		formEnquiryLandingVm.yearSelection = function () {
			formEnquiryLandingVm.year = new Date().getFullYear();
			formEnquiryLandingVm.range = [];
			for (var i = 0; i < 2; i++) {
				formEnquiryLandingVm.range.push({
					label: (formEnquiryLandingVm.year -i).toString() + "-" + parseInt(String(formEnquiryLandingVm.year + 1 - i).slice(2, 4)),
				});
			}
			formEnquiryLandingVm.yearsVal = formEnquiryLandingVm.range;
		
		}

		$scope.$on('$ionicView.beforeEnter', function () {

			serviceRequestService.kycAndNightModeValidation().then(function (data) {

				serviceRequestService.isNightMode = data.isNightMode;

				if (serviceRequestService.isNightMode) {
					formEnquiryService.displayPopUp('<center><img class="inb-error-sym" src="img/FT/BhimUpi/errorSymbol.svg" /><br><p class="inb-alert-header inb-mart-12"></p><center/>',
								"Request can not be processed now. Please try between 08:00 Hrs(IST) to 20.00 Hrs(IST).", ["OK"], function () {
									$state.go('menu.homeScreen');
								});
				}
				else if(customerInfoService.customer.residentialStatus != '1'){
						formEnquiryService.displayPopUp('<center><img class="inb-error-sym" src="img/FT/BhimUpi/errorSymbol.svg" /><br><p class="inb-alert-header inb-mart-12"></p><center/>',
								"Sorry, you cannot access Tax & Investments services online.Please visit / contact your home branch.", ["OK"], function () {
									$state.go('menu.homeScreen');
								});
				}

				else {
					formEnquiryService.getCifDetails().then(function (response) {
						formEnquiryLandingVm.cifNumber = response.cif;
						formEnquiryService.cifNum = formEnquiryLandingVm.cifNumber;
						formEnquiryLandingVm.yearSelection();
					}, function (error) {
						utilityService.showErrorMessage(error.responseMessage);
					});

				}

			}, function (error) {
					formEnquiryService.displayPopUp('<center><img class="inb-error-sym" src="img/FT/BhimUpi/errorSymbol.svg" /><br><p class="inb-alert-header inb-mart-12"></p><center/>',
								error.responseMessage, ["OK"], function () {
									$state.go('menu.homeScreen');
								});
			});

		});
		formEnquiryLandingVm.seletedYear = function () {
			formEnquiryLandingVm.yearValue = formEnquiryLandingVm.selectedYear.slice(0, 4);
			formEnquiryService.selectedYear = formEnquiryLandingVm.selectedYear;
				if (formEnquiryLandingVm.selectedYear == "" || formEnquiryLandingVm.selectedYear == undefined) {
				formEnquiryLandingVm.selectYearError = true;
				formEnquiryLandingVm.showRecords=false;
				return false;
			}
			else
			{
				formEnquiryLandingVm.selectYearError=false;
			}
			//  formEnquiryLandingVm.yearValue = formEnquiryLandingVm.year.slice(0, 4);
			var reqParams = {
				"taxYear": formEnquiryLandingVm.yearValue,
				"cif": formEnquiryLandingVm.cifNumber
			};
			formEnquiryService.getPYDetailsEnquiry(reqParams).then(function (data) {
				formEnquiryLandingVm.pyDetails = data.data.pyDetails;
				formEnquiryService.pyDetailsList = formEnquiryLandingVm.pyDetails;
				formEnquiryLandingVm.showRecords = true;
			}, function (error) {
				formEnquiryService.displayPopUp('<center><img class="inb-error-sym" src="img/FT/BhimUpi/errorSymbol.svg" /><br><p class="inb-alert-header inb-mart-12"></p><center/>',
								error.responseMessage, ["OK"], function () {
									$state.go('menu.homeScreen');
								});
			});
		}

		formEnquiryLandingVm.gotToRelationships = function () {
				$state.go('menu.accountOverviewMyBalance');

		}

		formEnquiryLandingVm.downloadPDF = function(uniqueRefNo, index) {
            formEnquiryLandingVm.downColor = true;
            formEnquiryLandingVm.downloadLoader = true;
            var requestParams = {
                "uniqueRefNo": uniqueRefNo,
                "isEmail": "false"
            }

            formEnquiryService.getForm15GHPdf(requestParams).then(function(data) {
                var content = data.pdf;
                var filename = data.fileName + '.pdf';
                pdfDownloadService.savePDF(filename, content, "").then(function(response){
                formEnquiryLandingVm.folderpath = response.folderpath ? response.folderpath : "";
                 formEnquiryLandingVm.downloadLoader = false;
                if (utilityService.isAndroidPlatform()) {                
                     var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="DOWNLOADFDRECEIPT" translate-values="{folderpath:formEnquiryLandingVm.folderpath}"></div>';
                    formEnquiryLandingVm.downloadPopup = $ionicPopup.show({
                    title: '',
                    template: template,
                    scope: $scope,
                    cssClass: 'my-custom-popup',
                    buttons: [{
                        text: 'OK',
                        type: 'button-assertive',
                        onTap: function() {
                            formEnquiryLandingVm.downloadPopup.close();                        
                             $state.go('menu.formEnquiryLanding');
                        }
                    }],
                });
                }
                else
                {
                    cordova.plugins.fileOpener2.open(
								cordova.file.documentsDirectory + filename,
								'application/pdf', {
								error: function (e) {
									console.log('Error status: ' + e.status + ' - Error message: ' + e.message);
								},
								success: function () {
									console.log('file opened successfully');
								}
					});
                }
               
               
                 },function error(e){
						utilityService.showErrorMessage(e);
				});
               
            }, function(error) {
                formEnquiryLandingVm.downloadLoader = false;
                utilityService.showNfsAlertModal("", error.responseMessage, "menu.serviceRequest", $scope, $state, "OK");

            });
        };


			formEnquiryLandingVm.maskedText = function () {
			formEnquiryLandingVm.isTextMasked = false;
			formEnquiryLandingVm.isTextUnMasked = true;

		};

		formEnquiryLandingVm.unMaskedText = function () {
			formEnquiryLandingVm.isTextUnMasked = false;
			formEnquiryLandingVm.isTextMasked = true;
		};
				formEnquiryLandingVm.goToformEnquiry = function () {
            $scope.popover.hide();
        }
		formEnquiryLandingVm.infoDetails = function ($event) {
        var template = '<ion-popover-view class="loginnewarrow pens-pop-style" id="runtimeHeight" >' + '<div class="pens-arrow-upper" style="right:15%!important;"></div>' + '<ion-content class="col-100" scroll="false" style="top: 1% !important;margin: 0px !important;">' + '<strong><div><div translate="Pass" class="passeg pens-para pay-pos font-size-year" style="font-family: Roboto-Bold !important; border-bottom: 0.5px solid white !important;font-size: 14px !important;padding-top: 10px !important;"></div><span style="float: right !important;margin-top: -8% !important;margin-right: 3% !important; "ng-click="formEnquiryLandingVm.goToformEnquiry()"><img src="img/closed.svg" class="" style="" id="CLS_BTN"></span></div></strong>' + '<div>' + '<span class="dobFirstDigit" style="background-color: #5553AA !important;text-decoration: underline;font-size: 12px !important;margin-left:9px !important;color: #FFFFFF !important;">05Mar</span>' + '<span style="float: left;font-size:12px !important;font-family: Roboto-Light;color: #FFFFFF !important;">ch</span>' + '<span class="firstPlusDigit" style="margin-left: 45px !important;font-family: Roboto-Light !important;font-size: 12px !important;color: #FFFFFF !important;">+</span>' + '<span class="excladigit" style="background-color: #5553AA !important;text-decoration: underline; margin-left: 12px !important;padding-left: 35px !important;font-family: Roboto-Bold !important;font-size: 12px !important;color: #FFFFFF !important;">!</span>' + '<span class="plusdigit" style="color: #FFFFFF !important;margin-left: 38px !important;font-family: Roboto-Light !important;font-size: 12px !important;">+</span>' + '<span class="mobxxdigit" style="padding-left:20px !important;;font-size: 12px !important;margin-left: 0px !important;color: #FFFFFF !important;">9xxxxx</span>' + '<span class="lastmobdigit" style="background-color: #5553AA !important;text-decoration: underline;font-size: 12px !important;color: #FFFFFF !important;">8899</span>' + '</div>' + '<div>' + '<table style="margin-left:12px; padding-top:8px;">' + '<tr>' + '<td class="tableForMsg width38" style="width: 119px !important;height: 42px !important;line-height: 14px;color: #FFFFFF !important;font-family: Roboto-Light !important;">Birth date and first 3 letters of birth month with first letter capital</td>' + '<td style=class="tableForMsg width8">' + '</td>' + '<td class="tableForMsg width20" width="20%" style="width: 57px !important;height: 28px !important;line-height: 14px;padding-left: 10px !important;color: #FFFFFF !important;font-family: Roboto-Light !important;">Mandatory “ ! ” sign</td>' + '<td style=class="tableForMsg width8">' + '</td>' + '<td class="tableForMsg width36" style="width: 119px !important;height: 42px !important;line-height: 14px;padding-left:10% !important;color: #FFFFFF !important;font-family: Roboto-Light !important;">Last 4 digits of the registered mobile number</td>' + '</tr>' + '</table>' + '</ion-content>' + '</ion-popover-view>';
        $scope.popover = $ionicPopover.fromTemplate(template, {
            scope: $scope
        });
            $scope.popover.show($event);
        }
		return this;
	}
]);
