'use strict';

angularApp.controller('accSelectHMBRTController', ["$state",
	"$ionicPopup",
	"$scope",
	"hmbrtService",
	"serviceRequestService",
	"utilityService","$ionicPopover","$translate",

	function ($state,
		$ionicPopup,
		$scope,
		hmbrtService,
		serviceRequestService,
		utilityService,$ionicPopover,$translate) {

		var accSelectHmbrtVm = this;

		accSelectHmbrtVm.init = function () {
			if(!accSelectHmbrtVm.transferType){
				accSelectHmbrtVm.transferType = "acc";
			}			
			if(angular.equals({}, hmbrtService.getAccountList)){
				accSelectHmbrtVm.showSelect = true;
				accSelectHmbrtVm.accData = {};
				accSelectHmbrtVm.branchName= "";
				accSelectHmbrtVm.transferType = "acc";
				accSelectHmbrtVm.selectedAccount = {};
				accSelectHmbrtVm.showOption = false;
				hmbrtService.getAccountForHomeBranch().then(function (data) {
				 	accSelectHmbrtVm.accData = {};
					accSelectHmbrtVm.accData.accList = data.accList;
					hmbrtService.getAccountList = accSelectHmbrtVm.accData;
					if(accSelectHmbrtVm.accData.accList.length == 1){
						accSelectHmbrtVm.singleSaving = accSelectHmbrtVm.accData.accList[0];
						accSelectHmbrtVm.isSigleAccount = true;
					}else if(accSelectHmbrtVm.accData.accList.length > 1){
						accSelectHmbrtVm.savingCount = 0;
						for (var i = 0; i < accSelectHmbrtVm.accData.accList.length; i++) {
							if (accSelectHmbrtVm.accData.accList[i].accountType.toUpperCase() == "SAVINGS"){
								accSelectHmbrtVm.savingCount++;
							}
						}
						if(accSelectHmbrtVm.savingCount > 1){
							accSelectHmbrtVm.showOption = true;
						}
					}
					hmbrtService.userCif = data.cif;
				}, function (error) {
					hmbrtService.displayPopUp("","padBtm25 top-padding26",error.responseMessage,"OK",function(){
						$state.go('menu.homeScreen');
					});
				});
			}
		}

		accSelectHmbrtVm.goToHome = function () {
			$state.go('menu.homeScreen');
		}
		
		accSelectHmbrtVm.goToback = function () {
			$state.go('menu.innerPage');
		}

		accSelectHmbrtVm.goToNext = function () {
			accSelectHmbrtVm.accountError = "";
			if(accSelectHmbrtVm.accData.accList.length > 1){
				if(!accSelectHmbrtVm.branchName){
					accSelectHmbrtVm.accountError = $translate.instant('HMBR_ACCOUNT_ERROR');
				}else{
					hmbrtService.selectedAcc = accSelectHmbrtVm.selectedAccount;
					if(accSelectHmbrtVm.transferType == "cif" || accSelectHmbrtVm.transferType == "acc"){
						hmbrtService.transferType = accSelectHmbrtVm.transferType;
					}
					if(accSelectHmbrtVm.selectedAccount.accountType.toUpperCase() == "PPF"){
						accSelectHmbrtVm.transferType = "acc";
						hmbrtService.transferType = "acc";
					}
					accSelectHmbrtVm.nextPageCall(accSelectHmbrtVm.selectedAccount.accountNumber);
				}
			}else if(accSelectHmbrtVm.accData.accList.length == 1){
				hmbrtService.selectedAcc = accSelectHmbrtVm.singleSaving;
				if(accSelectHmbrtVm.singleSaving.accountType.toUpperCase() == "PPF"){
					hmbrtService.transferType = "acc";
				}else{
					hmbrtService.transferType = "cif";
				}
				accSelectHmbrtVm.nextPageCall(accSelectHmbrtVm.singleSaving.accountNumber);
			}
		}

		accSelectHmbrtVm.nextPageCall = function(accountNumber){
			var request = {
				"accountNumber" : accountNumber
			}
			hmbrtService.validateAccount(request).then(function (data) {
				$state.go('menu.hbSearch');
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		}

		accSelectHmbrtVm.openInfo = function($event){
			accSelectHmbrtVm.leftStyle = "left : " + ($event.clientX - 30) + "px";
			if(utilityService.isIOSPlatform()){
				accSelectHmbrtVm.topStyle = "margin-top : -20px !important";
			}else{
				accSelectHmbrtVm.topStyle = "margin-top : -12px";
			}
			accSelectHmbrtVm.template = '<ion-popover-view class="loginnewarrow hmbr-info hmbr-info-popnew" id="runtimeHeight" style="{{accSelectHmbrtVm.topStyle}}">' + '<div class="edu-arrow-downnew" style="{{accSelectHmbrtVm.leftStyle}}"></div>' + 
			'<a class="iconsubtext closeinfobutton float-right" id="CALL_ANC" click-stream="click" ng-click="accSelectHmbrtVm.closePopover()">' + '<i class="ico-close ver-align-middle"></i>' + '</a>' + '<ion-content class="col-90" has-bouncing="false">' +
			'<div id="renderHeight" class="text-left padding-left-10 padding-right-10 font-size-12">'+
			'<div>CIF number is a unique number related to a computerised file, which holds all the personal as well as account related information of the customer of the bank.</div>' + 
			'</div>' + '</ion-content>' + '</ion-popover-view>';
			$scope.popover = $ionicPopover.fromTemplate(accSelectHmbrtVm.template, {
				scope: $scope
			});
			$scope.popover.show($event);
		}

		accSelectHmbrtVm.openInfoForCif = function($event){
			accSelectHmbrtVm.leftStyle = "left : " + ($event.clientX - 30) + "px";
			accSelectHmbrtVm.template = '<ion-popover-view class="loginnewarrow hmbr-info edu-fraudemergencypopovernew hmbr-cif-info" id="runtimeHeight">' + '<div class="hmbr-arrow-upnew" style="{{accSelectHmbrtVm.leftStyle}}"></div>' + '<a class="iconsubtext closeinfobutton float-right" id="CALL_ANC" click-stream="click" ng-click="accSelectHmbrtVm.closePopover()">' + '<i class="ico-close ver-align-middle"></i>' + '</a>' + '<ion-content class="col-90" has-bouncing="false">' +
			'<div id="renderHeight" class="text-left padding-left-10 padding-right-10 font-size-12">CIF number is a unique number related to a computerised file, which holds all the personal as well as account related information of the customer of the bank.</div>' + '</ion-content>' + '</ion-popover-view>';
			$scope.popover = $ionicPopover.fromTemplate(accSelectHmbrtVm.template, {
				scope: $scope
			});
			$scope.popover.show($event);
		}

		accSelectHmbrtVm.closePopover = function(){
			$scope.popover.hide();
		}

		accSelectHmbrtVm.showPop = function(){
			if(accSelectHmbrtVm.accData && accSelectHmbrtVm.accData.accList && accSelectHmbrtVm.accData.accList.length > 0){
                accSelectHmbrtVm.popUpTemplate = hmbrtService.formPopUpTemplate("accSelectHmbrtVm.accData.accList","accSelectHmbrtVm");
                accSelectHmbrtVm.popUp = $ionicPopup.show({
                    title: '',
                    cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
                    template: accSelectHmbrtVm.popUpTemplate,
                    scope: $scope
                });
            }
		}

		accSelectHmbrtVm.close = function(index){
            accSelectHmbrtVm.popUp.close();
            accSelectHmbrtVm.branchName = accSelectHmbrtVm.accData.accList[index].branchName;
            accSelectHmbrtVm.accType = accSelectHmbrtVm.accData.accList[index].accountType;
            accSelectHmbrtVm.accountNumber = accSelectHmbrtVm.accData.accList[index].accountNumber;
            accSelectHmbrtVm.selectedAccount = accSelectHmbrtVm.accData.accList[index];
			accSelectHmbrtVm.accountError = "";
			if(accSelectHmbrtVm.accType.toUpperCase()=="PPF"){
				accSelectHmbrtVm.showOption = false;
			}else{
				if(accSelectHmbrtVm.savingCount > 1){
					accSelectHmbrtVm.showOption = true;
				}else{
					accSelectHmbrtVm.transferType = "acc";
				}
			}
            accSelectHmbrtVm.showSelect = false;
        }

		$scope.$on('$ionicView.beforeEnter', function () {
			accSelectHmbrtVm.init();
		});

		return this;
	}
]);
