'use strict';

angularApp.service('hmbrtService',
	function ($q, AdapterUtils,$ionicPopup) {

		var hmbrtService = this;

		hmbrtService.localityFlag = false;
		hmbrtService.branchCodeFlag = false;
		hmbrtService.gpsFlag = false;
		hmbrtService.selectedAcc = {};
		hmbrtService.accountCount = 0; 
		hmbrtService.locateByGPS = [];
		hmbrtService.selecltedGps = null;
		hmbrtService.selectedLocality = null;
		hmbrtService.locateBylocality = [];
		hmbrtService.userCif = "";
		hmbrtService.geocoords = "";
		hmbrtService.selectedBranch = "";
		hmbrtService.transferType = "";
		hmbrtService.selectedMethod = "";
		hmbrtService.getAllStates = "";
		hmbrtService.getAccountList = {};

		hmbrtService.getBranchesForLocality = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ExistingCustomerAccountOpeningAdapter/getBranchesForLocality", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		hmbrtService.getBranchesByBranchCode = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/getBranchesByBranchCode", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		hmbrtService.validateOtp = function(payLoad) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/OTPAdapter/validateOTPTokenSecure", payLoad, true).then(
				function(response) {
					q.resolve(response.data);
				},
				function(error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		hmbrtService.getBranchesForGeo = function(payLoad) {
			var q = $q.defer();
			AdapterUtils.getData("adapters/ServiceRequestAdapter/branchesForGeo?longitude=" + payLoad.longitude + "&latitude=" + payLoad.latitude +  "&branchLocator=" + payLoad.branchLocator + "&branchCode=" + payLoad.branchCode, true).then(
				function(response) {
					q.resolve(response.data);
				},
				function(error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		hmbrtService.getOtp = function() {
			var q = $q.defer();
			AdapterUtils.postData("adapters/OTPAdapter/getOTPTokenSecure", {}, true).then(
				function(response) {
					q.resolve(response.data);
				},
				function(error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		hmbrtService.updateHomeBranch = function(payLoad) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/updateHomeBranchByAccNo", payLoad, true).then(
				function(response) {
					q.resolve(response.data);
				},
				function(error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		hmbrtService.updateHomeBranchWithCif = function(payLoad) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/updateHomeBranchByCIF", payLoad, true).then(
				function(response) {
					q.resolve(response.data);
				},
				function(error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		hmbrtService.getAllCities = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ExistingCustomerAccountOpeningAdapter/getAllCities", {}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		hmbrtService.getAccountForHomeBranch = function() {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/getAccountsForHomeBranch", {}, true).then(
				function(response) {
					q.resolve(response.data);
				},
				function(error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		hmbrtService.getAllStates = function() {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/getCBSState", {}, true).then(
				function(response) {
					q.resolve(response.data);
				},
				function(error) {
					q.reject(error);
				}
			);			
			return q.promise;
		};

		hmbrtService.getAllCities = function(payLoad){
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/getCBSDsitrict", payLoad , true).then(
				function(response) {
					q.resolve(response.data);
				},
				function(error) {
					q.reject(error);
				}
			);
			return q.promise;
		}

		hmbrtService.getBranchesFromLocality = function(payLoad){
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/getBranchesByLocality", payLoad , true).then(
				function(response) {
					q.resolve(response.data);
				},
				function(error) {
					q.reject(error);
				}
			);
			return q.promise;
		}

		hmbrtService.validateAccount = function(payLoad){
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/monthValidityCheck", payLoad , true).then(
				function(response) {
					q.resolve(response.data);
				},
				function(error) {
					q.reject(error);
				}
			);
			return q.promise;
		}

		hmbrtService.displayPopUp = function(heading,css,message,buttonText,callBack){
			var alertPopup = $ionicPopup.alert({
				title: heading,
				template: '<div class="popupTextBottomPadding  ss-popup-list fontSize-subHeading roboto-medium text-center '+ css +'">'
				+ message + '</div></div>',
				cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite ss-popup',
				buttons: [
					{
						text: buttonText,
						onTap: function(e) {
							callBack();
						}
					}
				],
			});
		};

		hmbrtService.formPopUpTemplate = function(array,controllerName){
			var template = '<div class="font-dark-grey irctc">'+
					'<div ng-repeat="acc in '+ array + ' track by $index">'+
						'<div class="row  borderbtm" ng-click="'+controllerName + '.close($index)">'+
						'<div class="col padtop10 font-size-20 roboto-regular color545454">₹ {{acc.accountBalance |INR}}</div>'+
						'<div class="col padTopBTM30 font-size-12 roboto-medium color545454">{{acc.accountType}}<br><span class="font-size-14 roboto-medium color545454">{{acc.accountNumber}}</span></div>'+
						'</div></div></div>';
			return template;
		}

		return hmbrtService;
	});
