'use strict';

angularApp.controller('locationHMBRTController', ["$state",
	"$scope",
	"hmbrtService",
	"utilityService","$ionicScrollDelegate",
	function ($state,
		$scope,
		hmbrtService,
		utilityService,$ionicScrollDelegate) {

		var locationHmbrtVm = this;

		locationHmbrtVm.goToHome = function () {
			$state.go('menu.homeScreen');
		}

		locationHmbrtVm.goToback = function () {
			if(hmbrtService.selectedMethod && hmbrtService.selectedMethod == "loc"){
				$state.go('menu.hbBranchCode');
			}else{
				$state.go('menu.hbSearch');
			}
		}

		locationHmbrtVm.goToNext = function () {
			locationHmbrtVm.branchError = "";
			if(hmbrtService.selectedBranch){
				$state.go('menu.hbReview');
			}else{
				locationHmbrtVm.branchError = "Please Select Branch";
				$ionicScrollDelegate.scrollTop();
			}
		}

		locationHmbrtVm.init = function(){
			if(!hmbrtService.selectedBranch){
				locationHmbrtVm.selectedIndexLocation = 10000;
			}
			locationHmbrtVm.branches = hmbrtService.locateByGPS;
			locationHmbrtVm.branchError = "";
			if(hmbrtService.selectedMethod && hmbrtService.selectedMethod == "loc"){
				hmbrtService.selectedBranch = locationHmbrtVm.branches[0];
				locationHmbrtVm.selectedIndexLocation = 0;
			}
		}

		locationHmbrtVm.selectBranch = function(loc,index){
			hmbrtService.selectedBranch = loc;
			locationHmbrtVm.selectedIndexLocation = index;
			locationHmbrtVm.branchError = "";
		}

		locationHmbrtVm.openMaps = function(loc){
			 var geocoords = loc.latitude + "," + loc.longitude;
			 if (utilityService.isIOSPlatform()) {
				cordova.ThemeableBrowser.open('https://www.google.com/maps/search/?api=1&query='+geocoords, '_blank',
				{
					statusbar: {
						color:'#ffffffff'
					},
					toolbar: {
						height: 37,
						color: '#ffffffff',
						image: 'share'
					},

					closeButton: {
						image:'back',
						height: 37,
						width: 32,
						align: 'left',
						event: 'closePressed'
					},

					backButtonCanClose: true
				});
			}else {
				var label = encodeURI('Your Destination');
				window.open('geo:0,0?q=' + geocoords + '(' + label + ')', '_system');
			}
		 }

		$scope.$on('$ionicView.beforeEnter', function () {
			locationHmbrtVm.init();
		});

		return this;
	}
]);
