'use strict';

angularApp.controller('hbOtpController', [
	"$state",
	"$scope",
	"$rootScope",
	"utilityService","hmbrtService","loggedInUserService","customerInfoService","$filter",
	function ($state,
		$scope,
		$rootScope,
		utilityService,hmbrtService,loggedInUserService,customerInfoService,$filter) {

		var hbOtpTVm = this;

		hbOtpTVm.init = function(){
			hbOtpTVm.mobileNumber = $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4);
			hbOtpTVm.resetPinOTP = "";
			hbOtpTVm.otpCount = 0;
			hbOtpTVm.clickCount = 0;
			hbOtpTVm.isResendDisabled = false;
		}

		hbOtpTVm.goNext = function(){
			hbOtpTVm.resetPinOTP = "";
			if(!hbOtpTVm.otpNumber || hbOtpTVm.otpNumber.length != 6){
				hbOtpTVm.resetPinOTP = "Enter the valid OTP";
			}else{
				var request = {
					"otp" : hbOtpTVm.otpNumber
				}
				hmbrtService.validateOtp(request).then(function(data) {
					var payLoad = {
						"newHomeBranch": hmbrtService.selectedBranch.id,
						"accountNumber": hmbrtService.selectedAcc.accountNumber,
						"branchCode": hmbrtService.selectedAcc.branchCode
					}
					if(hmbrtService.transferType == "acc"){
						hmbrtService.updateHomeBranch(payLoad).then(function(data) {
							//hmbrtService.refNo = data.referenceNumber;
							$state.go('menu.hbSuccess');
							hmbrtService.getAccountList = {};
						},function(error){
							hbOtpTVm.otpNumber = "";
							hmbrtService.displayPopUp("","padBtm25 top-padding26",error.responseMessage,"OK",function(){
								$state.go('menu.homeScreen');
							});
						});
					}else{
						hmbrtService.updateHomeBranchWithCif(payLoad).then(function(data) {
							//hmbrtService.refNo = data.referenceNumber;
							$state.go('menu.hbSuccess');
							hmbrtService.getAccountList = {};
						},function(error){
							hbOtpTVm.otpNumber = "";
							hmbrtService.displayPopUp("","padBtm25 top-padding26",error.responseMessage,"OK",function(){
								$state.go('menu.homeScreen');
							});
						});
					}
				},function(error){
					hbOtpTVm.otpNumber = "";
					hbOtpTVm.otpCount++;
					if(hbOtpTVm.otpCount >= 3){
						var title = '';
						var template = "<p> "+error.responseMessage +" </p>";
						var onTap = 'menu.homeScreen';
						var buttontext = "<b>OK</b>";
						utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
					}else{
						utilityService.showErrorMessage(error.responseMessage);
					}
				});
			}
		}

		hbOtpTVm.resendOTP = function(){
			hmbrtService.getOtp().then(function(data) {
				hbOtpTVm.otpNumber = "";
				hbOtpTVm.resetPinOTP = "";
				hbOtpTVm.clickCount++;
				if(hbOtpTVm.clickCount >= 2){
					hbOtpTVm.isResendDisabled = true;
				}
				var template = "<p> "+ "OTP has been sent to your registered mobile number." +" </p>";
				var onTap = '';
				var buttontext = "<b>OK</b>";
				utilityService.showAlertModal('', template, onTap, $scope, $state, buttontext);
			},function(error){
				utilityService.showErrorMessage(error.responseMessage);
			});
		}

		$scope.$on('$ionicView.beforeEnter', function () {
			hbOtpTVm.init();
		});

		return this;
	}
]);
