'use strict';

angularApp.controller('resultLocationHMBRTController', ["$state",
	"$ionicPopup",
	"$scope",
	"hmbrtService",
	"utilityService","homeLoanService",
	function ($state,
		$ionicPopup,
		$scope,
		hmbrtService,
		utilityService,homeLoanService) {

		var resultLocationHMBRTVm = this;

		resultLocationHMBRTVm.init = function () {
			resultLocationHMBRTVm.isLocation = true;
			if(!hmbrtService.getAllStatesList){
				resultLocationHMBRTVm.getStateList();
			}else{
				resultLocationHMBRTVm.stateList = hmbrtService.getAllStatesList;
			}
		}

		resultLocationHMBRTVm.goToback = function () {
			$state.go('menu.hbSearch');
		}

		resultLocationHMBRTVm.tabSelected = function(type){
			if(type == "loc"){
				resultLocationHMBRTVm.isLocation = true;	
			}else{
				resultLocationHMBRTVm.isLocation = false;
			}
		}

		resultLocationHMBRTVm.goToNext = function () {
			if(!resultLocationHMBRTVm.isLocation){
				resultLocationHMBRTVm.branchError = "";
				if(!resultLocationHMBRTVm.branchCode ){
					resultLocationHMBRTVm.branchError = "Enter a branch code";
				}else if(resultLocationHMBRTVm.branchCode.length < 5){
					resultLocationHMBRTVm.branchError = "Please enter a valid branch code";
				}else if(hmbrtService.selectedAcc.branchCode == resultLocationHMBRTVm.branchCode){
					utilityService.showErrorMessage("You have selected the existing Branch. Please select a different Branch for Account / CIF Transfer");
				}else{
					var request = {
					    "locality": resultLocationHMBRTVm.branchCode
					};
					hmbrtService.getBranchesByBranchCode(request).then(function(data) {
						if (!utilityService.isUndefined(data)) {
							hmbrtService.locateByGPS = [];
							for (var i = 0; i < data.branches.length; i++) {
								hmbrtService.locateByGPS.push(data.branches[i]);
							}
							setTimeout(function () {
								if (hmbrtService.locateByGPS.length == 0) {
									utilityService.showErrorMessage("Please enter a valid branch code");
								}else{
									$state.go('menu.hbBranchLocation');
								}
							}, 300);
						}
					},function(error){
						utilityService.showErrorMessage(error.responseMessage);
					});
				}
			}else{
				resultLocationHMBRTVm.stateError = "";
				resultLocationHMBRTVm.cityError = "";
				resultLocationHMBRTVm.areaError = "";
				var valid = true;
				if(!resultLocationHMBRTVm.state){
					resultLocationHMBRTVm.stateError = "Select a state";
					valid = false;
				}
				if(!resultLocationHMBRTVm.city){
					resultLocationHMBRTVm.cityError = "Select a city";
					valid = false;
				}
				if(!resultLocationHMBRTVm.area){
					resultLocationHMBRTVm.areaError = "Enter an area";
					valid = false;
				}
				if(valid){
					var request = {
						"state" : resultLocationHMBRTVm.state.value,
						"district": resultLocationHMBRTVm.city.value,
						"locality": resultLocationHMBRTVm.area,
						"branchCode" : hmbrtService.selectedAcc.branchCode
					}
					hmbrtService.getBranchesFromLocality(request).then(function (data) {
						hmbrtService.locateByGPS = [];
						for (var i = 0; i < data.branches.length; i++) {
							hmbrtService.locateByGPS.push(data.branches[i]);
						}
						setTimeout(function () {
							if (hmbrtService.locateByGPS.length == 0) {
								var title = '';
								var template = '{{"UNABLE_TO_GET_BRANCH" | translate}}';
								var onTap = '';
								var buttontext = 'OK';
								utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
							}else{
								$state.go('menu.hbBranchLocation');
							}
						}, 300);
					}, function (error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				}
			}
		}

		resultLocationHMBRTVm.populateArea = function(){
			resultLocationHMBRTVm.cityError = "";
			resultLocationHMBRTVm.area = "";
		}

		resultLocationHMBRTVm.blurEvent = function(field){
			if(field == "area"){
				if(!resultLocationHMBRTVm.area){
					resultLocationHMBRTVm.areaError = "Enter an area";
				}else{
					resultLocationHMBRTVm.areaError = "";
				}
			}else if(field == "branch"){
				if(!resultLocationHMBRTVm.branchCode){
					resultLocationHMBRTVm.branchError = "Enter a branch code";
				}else if(resultLocationHMBRTVm.branchCode.length < 5){
					resultLocationHMBRTVm.branchError = "Please enter a valid branch code";
				}else{
					resultLocationHMBRTVm.branchError = "";
				}
			}
		}

		resultLocationHMBRTVm.populateCity = function(){
			resultLocationHMBRTVm.stateError = "";
			resultLocationHMBRTVm.area = "";
			resultLocationHMBRTVm.city = "";
			var request = {
				"key" : resultLocationHMBRTVm.state.key
			}
			hmbrtService.getAllCities(request).then(function (data) {
				resultLocationHMBRTVm.cities = data;
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		}

		resultLocationHMBRTVm.getStateList = function () {
			hmbrtService.getAllStates().then(function (data) {
				resultLocationHMBRTVm.stateList = data;
				hmbrtService.getAllStatesList = data;
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		}

		$scope.$on('$ionicView.beforeEnter', function () {
			resultLocationHMBRTVm.init();
		});


		return this;
	}
]);
