'use strict';

angularApp.controller('transferHMBRTController', ["$state",
	"$ionicPopup",
	"$scope",
	"hmbrtService",
	"utilityService",
	"$timeout",
	"currentLocationService","locateNearestBranchServiceOVD",
	function ($state,
		$ionicPopup,
		$scope,
		hmbrtService,
		utilityService,
		$timeout,
		currentLocationService,
		locateNearestBranchServiceOVD) {

		var transferHmbrtVm = this;

		transferHmbrtVm.goToback = function () {
			$state.go('menu.hbAccSelect');
		}
	
		transferHmbrtVm.goToBranchSelection = function(type){
			if(type=="loc"){
				hmbrtService.selectedMethod = "loc";
				$state.go('menu.hbBranchCode');
			}else if(type == 'gps'){
				utilityService.showSpinner();
				CheckGPS.check(function () {
					currentLocationService.getCurrentPosition().then(
						function (position) {
							utilityService.hideSpinner();
							hmbrtService.geocoords = position.coords.latitude + "," + position.coords.longitude;
							var latitude = position.coords.latitude;
							var longitude = position.coords.longitude;
							hmbrtService.locateByGPS.length = 0;
							var params = {
								"latitude": latitude,
								"longitude": longitude,
								"branchCode" : hmbrtService.selectedAcc.branchCode
							}
							if (utilityService.isUndefined(hmbrtService.locateByGPS) || hmbrtService.locateByGPS.length === 0) {
								hmbrtService.getBranchesForGeo(params).then(function (data) {
									if (!utilityService.isUndefined(data)) {
										hmbrtService.locateByGPS = [];
										for (var i = 0; i < data.branches.length; i++) {
											hmbrtService.locateByGPS.push(data.branches[i]);
										}
										setTimeout(function () {
											if (hmbrtService.locateByGPS.length == 0) {
												var title = '';
												var template = '{{"UNABLE_TO_GET_BRANCH" | translate}}';
												var onTap = '';
												var buttontext = 'OK';
												utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
											}else{
												hmbrtService.selectedMethod = "gps";
												hmbrtService.selectedBranch = "";
												$state.go('menu.hbBranchLocation');
											}
										}, 300);
									}
								}, function (error) {
									utilityService.showErrorMessage(error.responseMessage);
								});
							}
							else {

							}
						},function (err) {
							utilityService.hideSpinner();
							var title = '';
							var template = '{{"ON_GPS" | translate}}';
							var onTap = '';
							var buttontext = '<b>OK</b>';
							utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
						}
					);
           		 },function () {
					utilityService.hideSpinner();
                    var title = '';
                    var template = '{{"ENABLE_GPS" | translate}}';
                    var onTap = '';
                    var buttontext = '<b>OK</b>';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                });
			}
		}

		transferHmbrtVm.init = function () {
		
		}
			
		$scope.$on('$ionicView.loaded', function () {
			transferHmbrtVm.init();

		});

		return this;
	}
]);
