'use strict';

angularApp.controller('forgotPasswordOtpController', ["$timeout",
	"$state",
	"$ionicPopup",
	"$scope",
	"homeScreenService",
	"$rootScope",
	"customerInfoService",
	"internetBankingService",
	"getAccountDetailsService",
	"wishListService",
	"utilityService",
	"mPinLoginService",
	"billDeskService",
	"personalLoanService", "myProfileService",
	"$ionicSideMenuDelegate",
	"$ionicScrollDelegate",
	"fTBeneficiaryService",
	"constantConfig",
	"inbForgotPwdService",
	"cryptoService",
	"loggedInUserService",
	"cardsService", "clearServiceDataService", "feedebackService",
	function ($timeout,
		$state, $ionicPopup,
		$scope,
		homeScreenService,
		$rootScope,
		customerInfoService,
		internetBankingService,
		getAccountDetailsService,
		wishListService, utilityService,
		mPinLoginService,
		billDeskService,
		personalLoanService,
		myProfileService,
		$ionicSideMenuDelegate,
		$ionicScrollDelegate,
		fTBeneficiaryService,
		constantConfig,
		inbForgotPwdService,
		cryptoService,
		loggedInUserService,
		cardsService, clearServiceDataService, feedebackService) {

		var forgotPasswordOtpVm = this;

		forgotPasswordOtpVm.otp = "";
		var count = 0;

		forgotPasswordOtpVm.disableCount = function () {
			count += 1;
			if (count >= 3) {
				forgotPasswordOtpVm.isNextEnabled = true;
				forgotPasswordOtpVm.isDisabledOTP = true;
			}

		}

		//forgotPasswordOtpVm.mobileNumber = loggedInUserService.inbUserId.data.mobileNumber;

		forgotPasswordOtpVm.goToNext = function () {
			if (forgotPasswordOtpVm.otp.length < 6) {
				forgotPasswordOtpVm.nextEnable();
			} else {
				var requestParams = {
					otp: forgotPasswordOtpVm.otp
				}
				inbForgotPwdService.validateOTP(requestParams).then(function (data) {
					var SaltValue = "#";
					var rsaValue = cryptoService.encryptRSAWithPublicKey(inbForgotPwdService.reEnterPassword, cryptoService.rsaPublicKey);
					var finalSHA512Val = rsaValue;
					var reqData = {
						"newPassword": finalSHA512Val
					};
					inbForgotPwdService.setLoginPassword(reqData).then(function (data) {
						forgotPasswordOtpVm.myPopup = $ionicPopup.show({
							title: '',
							cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
							templateUrl: 'pages/nfs/inbForgotPassword/passwordChangedSuccessPopUp.html',
							scope: $scope
						})
					}, function (error) {
						forgotPasswordOtpVm.disableCount();
						utilityService.showErrorMessage(error.responseMessage);
					});
				}, function (error) {
					forgotPasswordOtpVm.disableCount();
					utilityService.showErrorMessage(error.responseMessage);
				});
			}
		};

		forgotPasswordOtpVm.nextEnable = function () {
			forgotPasswordOtpVm.showNameError = forgotPasswordOtpVm.otp.length;
			if (forgotPasswordOtpVm.otp === forgotPasswordOtpVm.otpValue)
				forgotPasswordOtpVm.disableNext = false;
			else
				forgotPasswordOtpVm.disableNext = true;
		}

		forgotPasswordOtpVm.goToHome = function () {
			$state.go('menu.userLogin');
		}

		forgotPasswordOtpVm.goToLogin = function () {
			forgotPasswordOtpVm.myPopup.close();
			utilityService.setCsatJournies('updateINBPassword');
			utilityService.hideSpinner();
			clearServiceDataService.clearServiceData();
			forgotPasswordOtpVm.getCSATDetails();
		};


		forgotPasswordOtpVm.getCSATDetails = function () {
			if (mPinLoginService.isLoggedIn) {
				if (utilityService.timeSpent > 0) {
					utilityService.setCsatJournies('ompShoppingDeals');
				}
				var allJournies = utilityService.getCsatJournies();
				feedebackService.getFeedbackData(allJournies).then(function (data) {
					utilityService.hideSpinner();
					if (!data || data == null) {
						
					
					} else {
						
						feedebackService.data = data;
						$state.go('menu.feedback');
					}
				}, function (error) {
					utilityService.hideSpinner();
				
				
					
				});
			} else {
				var allJournies = utilityService.getCsatJournies();
				feedebackService.getFeedbackDataPreLogin(allJournies).then(function (data) {
					utilityService.hideSpinner();
					if (!data || data == null) {
					
					
					} else {
						
						feedebackService.data = data;
						$state.go('menu.feedback');
					}
				}, function (error) {
					utilityService.hideSpinner();
					
					
				});
			}
		}

		forgotPasswordOtpVm.resendOTP = function () {
			if (forgotPasswordOtpVm.isDisabledOTP) { return true }
			forgotPasswordOtpVm.otp = "";

			var rsaValue = cryptoService.encryptRSAWithPublicKey(inbForgotPwdService.reEnterPassword, cryptoService.rsaPublicKey);
			var finalSHA512Val = rsaValue;

			var reqData = {
				"toChange": finalSHA512Val,
				"mode": inbForgotPwdService.profile
			};


			inbForgotPwdService.getOTP(reqData).then(function (data) {


			}, function (error) {

				utilityService.showNfsAlertModal("", error.responseMessage, "menu.userLogin", $scope, $state, "OK");
			});

			forgotPasswordOtpVm.isDisabledOTP = true;
		}



		return this;
	}
]);
