'use strict';

angularApp.controller('setPasswordController', ["$state",
	"$ionicPopup",
	"$scope",
	"$rootScope",
	"$filter",
	"loggedInUserService",
	"cryptoService",
	"inbForgotPwdService",
	"utilityService",

	function ($state,
		$ionicPopup,
		$scope,
		$rootScope,
		$filter,
		loggedInUserService,
		cryptoService,
		inbForgotPwdService,
		utilityService) {

		var setPasswordVm = this;
		setPasswordVm.errorPassword = false;
		setPasswordVm.passWordMatch = false;
		setPasswordVm.isNextEnabled = true;
		setPasswordVm.isTextReadable = false;
		setPasswordVm.isTextReadablereEnter = false;

		setPasswordVm.mobileNumber = $rootScope.mobileNo;
		setPasswordVm.goToHome = function () {
				$state.go('menu.userLogin');
		}

		setPasswordVm.enterPasswordFun=function () {
			
			var regularExpression = /^(?=.*[0-9])(?=.*[a-z])(?=.*[A-Z])(?=.*[~`!"',-./@#$%^&*+/(/)\s])[a-zA-Z0-9~`!"',-./@#$%^&*+/(/)\s]{8,20}$/;

			if(!regularExpression.test(setPasswordVm.enterPassword)){
				setPasswordVm.errorPassword = true;
				setPasswordVm.passWordMatch = false;
			}else{
				setPasswordVm.errorPassword = false;
				setPasswordVm.passWordMatch = false;

				
			}
			if(!setPasswordVm.errorPassword){
				setPasswordVm.notMatch = true;
				if(setPasswordVm.reEnterPassword === setPasswordVm.enterPassword){
				setPasswordVm.passWordMatch = true;
				setPasswordVm.notMatch = false;
				setPasswordVm.isNextEnabled = false;
			}else{
				setPasswordVm.passWordMatch = false;
				setPasswordVm.notMatch = true;
			}
			}
			

			setPasswordVm.nextEnable();

		}
		

		setPasswordVm.nextEnable = function () {
			if (setPasswordVm.reEnterPassword && setPasswordVm.enterPassword && setPasswordVm.passWordMatch && !setPasswordVm.errorPassword) {
				setPasswordVm.isNextEnabled = false;
			} else {
				setPasswordVm.isNextEnabled = true;
			}


		}

		setPasswordVm.reset = function () {
			setPasswordVm.reEnterPassword = "";
			setPasswordVm.enterPassword = "";
			setPasswordVm.errorPassword = false;
			setPasswordVm.passWordMatch = false;
			setPasswordVm.notMatch = false;
			setPasswordVm.nextEnable();
		}

		setPasswordVm.goToNext = function () {
		inbForgotPwdService.reEnterPassword = setPasswordVm.reEnterPassword
			var SaltValue = "#";
			var toChange = loggedInUserService.getInbUserId() + SaltValue + setPasswordVm.reEnterPassword;
			var rsaValue = cryptoService.encryptRSAWithPublicKey(setPasswordVm.reEnterPassword, cryptoService.rsaPublicKey);
			var finalSHA512Val = rsaValue;
		

	
			

			var reqData = {
				"toChange": finalSHA512Val,
                 "mode": inbForgotPwdService.profile
				}
				
			

			inbForgotPwdService.getOTP(reqData).then(function (data) {
				console.log(JSON.stringify(data));
				$state.go('menu.forgotPasswordOtp');

		 }, function (error) {
				utilityService.showNfsAlertModal("", error.responseMessage, "menu.userLogin", $scope, $state, "OK");
			 });
		}

			setPasswordVm.toggleEyeEnter = function () {
			setPasswordVm.isTextReadable == true ? setPasswordVm.isTextReadable = false : setPasswordVm.isTextReadable = true;
		};
			setPasswordVm.toggleEyeReEnter = function () {
			setPasswordVm.isTextReadablereEnter == true ? setPasswordVm.isTextReadablereEnter = false : setPasswordVm.isTextReadablereEnter = true;
		};
		
		return this;
	}

]);


