'use strict';

angularApp.controller('inbLockAccessDeatilsController', ["$state",
	"$ionicPopup",
	"$scope",
	"customerInfoService",
	"utilityService",
	"loggedInUserService",
	"$rootScope",
	"constantConfig",
	"ionicToast",
	"validationService",
	"inbLockUnlockService",
	"$ionicPopover",
	

	function ($state,
		$ionicPopup,
		$scope,
		customerInfoService,
		utilityService,
		loggedInUserService,
		$rootScope,
		constantConfig,
		ionicToast,
		validationService,
		inbLockUnlockService,
		$ionicPopover) {

		var inbLockAccessDeatilsVm = this;
		inbLockAccessDeatilsVm.isNextEnable = false;
		inbLockAccessDeatilsVm.validateMobNum = false;
		inbLockAccessDeatilsVm.validateUsername = false;
		inbLockAccessDeatilsVm.validateAccountNum = false;
		inbLockAccessDeatilsVm.userName = loggedInUserService.getInbUserId().data.inbUserId;
		inbLockAccessDeatilsVm.registeredMobNum = loggedInUserService.getInbUserId().data.mobileNumber;
		

		inbLockAccessDeatilsVm.close = function () {
			$state.go('menu.userLogin');
		}

		inbLockAccessDeatilsVm.selectedAccFun = function () {
			inbLockAccessDeatilsVm.mobileNum ="";

			inbLockAccessDeatilsVm.countryIndia = "";
			if (inbLockAccessDeatilsVm.country == "") {
				inbLockAccessDeatilsVm.isdCode = "";
			}
			var isdCode = JSON.parse(inbLockAccessDeatilsVm.country).isdCode;
			inbLockAccessDeatilsVm.countryName = JSON.parse(inbLockAccessDeatilsVm.country).countryName
			inbLockAccessDeatilsVm.isdCode = "+" + isdCode;

		}

		inbLockAccessDeatilsVm.goNext = function () {
			if(inbLockAccessDeatilsVm.validateForm()){
			inbLockAccessDeatilsVm.contryCode = JSON.parse(inbLockAccessDeatilsVm.country).countryCode;
			inbLockAccessDeatilsVm.countryName = JSON.parse(inbLockAccessDeatilsVm.country).countryName;
			var reqParams = {
				"userName": inbLockAccessDeatilsVm.intBankUname,
				"accountNumber": inbLockAccessDeatilsVm.accountNum,
				"mobileNumber": inbLockAccessDeatilsVm.mobileNum,
				"isdCode": inbLockAccessDeatilsVm.isdCode.replace("+", "")
			};

			inbLockUnlockService.lockAccessDataValidation(reqParams).then(function (response) {
				var reqParams = {
					"userName": inbLockAccessDeatilsVm.intBankUname,
					"mobileNumber": inbLockAccessDeatilsVm.mobileNum
				};
				inbLockUnlockService.getLockAccessOTP(reqParams).then(function (data) {
					$state.go('menu.inbLockAccessOtp');
				}, function (error) {
					inbLockUnlockService.displayPopUp('<center><img class="inb-error-sym" src="img/FT/BhimUpi/errorSymbol.svg" /><br><p class="inb-alert-header inb-mart-12"></p><center/>',
						error.responseMessage, ["OK"], function () {
							$state.go('menu.inbLockAccessDeatils');
						});
				});

			}, function (error) {
				if (error.responseCode == "LOCK.001") {
					inbLockUnlockService.displayPopUp('<center><img class="inb-error-sym" src="img/FT/BhimUpi/errorSymbol.svg" /><br><p class="inb-alert-header inb-mart-12">Your access is already locked.</p><center/>',
						error.responseMessage, ["OK"], function () {
							$state.go('menu.userLogin');
						}, function () {
							clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "PROCEED_BTN"));
							$state.go('menu.userLogin');
						});
				} else {
					inbLockUnlockService.displayPopUp('<center><img class="inb-error-sym" src="img/FT/BhimUpi/errorSymbol.svg" /><br><p class="inb-alert-header inb-mart-12"></p><center/>',
						error.responseMessage, ["OK"], function () {
							$state.go('menu.inbLockAccessDeatils');
						}, function () {
							clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "PROCEED_BTN"));
							$state.go('menu.inbLockAccessDeatils');
						});
				}
			});
		}
		}
		inbLockAccessDeatilsVm.validateUname = function () {
			if (inbLockAccessDeatilsVm.intBankUname != inbLockAccessDeatilsVm.userName) {
				inbLockAccessDeatilsVm.validateUsername = true;
			} else {
				inbLockAccessDeatilsVm.validateUsername = false;
				
			}
		}
		inbLockAccessDeatilsVm.validateAccNum = function () {
			if (inbLockAccessDeatilsVm.accountNum.length < 11) {
				inbLockAccessDeatilsVm.validateAccountNum = true;
			} else {
				inbLockAccessDeatilsVm.validateAccountNum = false;
			}

		}

		inbLockAccessDeatilsVm.validMobileNum = function () {
			inbLockAccessDeatilsVm.countryNameInd = JSON.parse(inbLockAccessDeatilsVm.country).countryName;
			if(inbLockAccessDeatilsVm.countryNameInd === "India"){
				// inbLockUnlockService.indianNum === "India";
				inbLockAccessDeatilsVm.maxlength = 10;
			}else{
				inbLockAccessDeatilsVm.maxlength = 17;
			}
		}

		$scope.$on('$ionicView.beforeEnter', function () {

			inbLockUnlockService.getCountryDetailList().then(function (data) {
				inbLockAccessDeatilsVm.countryList = data.data;
				inbLockUnlockService.countryList = inbLockAccessDeatilsVm.countryList;
				inbLockAccessDeatilsVm.country = angular.toJson(inbLockUnlockService.countryList[94]);
				inbLockAccessDeatilsVm.isdCode = "+" + Number(inbLockAccessDeatilsVm.countryList[94].isdCode);
				inbLockAccessDeatilsVm.countryIndia = JSON.parse(inbLockAccessDeatilsVm.country).countryName;
			}, function (error) {
				utilityService.showNfsAlertModal("", error.responseMessage, "menu.userLogin", $scope, $state, "OK");
			});

			inbLockAccessDeatilsVm.init();

		});
		inbLockAccessDeatilsVm.init = function () {
		}
		inbLockAccessDeatilsVm.validateForm = function () {
			inbLockAccessDeatilsVm.errObj = {};
			if (!inbLockAccessDeatilsVm.intBankUname || (inbLockAccessDeatilsVm.intBankUname != inbLockAccessDeatilsVm.userName)) {
				inbLockAccessDeatilsVm.errObj.inbUname = true;
			}
			if (!inbLockAccessDeatilsVm.accountNum || inbLockAccessDeatilsVm.accountNum.length < 11) {
				inbLockAccessDeatilsVm.errObj.accNum = true;
			}
			if (!inbLockAccessDeatilsVm.mobileNum) {
				 inbLockAccessDeatilsVm.errObj.mobNum = true;
			}else if(inbLockAccessDeatilsVm.countryNameInd === "India"){
					if(inbLockAccessDeatilsVm.mobileNum.length <10){
						inbLockAccessDeatilsVm.errObj.mobNum = true;
					}
				}else if(inbLockAccessDeatilsVm.countryNameInd !== "India"){
					if(inbLockAccessDeatilsVm.mobileNum.length >17){
						inbLockAccessDeatilsVm.errObj.mobNum = true;
					}
				}
          	return (angular.equals({}, inbLockAccessDeatilsVm.errObj)) ? true : false;

		}

		return this;
	}



]);
