'use strict';

angularApp.controller('inbLockAccessOtpController', ["$timeout",
	"$state",
	"$ionicPopup",
	"$scope",
	"homeScreenService",
	"$rootScope",
	"customerInfoService",
	"internetBankingService",
	"getAccountDetailsService",
	"wishListService",
	"utilityService",
	"mPinLoginService",
	"billDeskService",
	"personalLoanService", "myProfileService",
	"$ionicSideMenuDelegate",
	"$ionicScrollDelegate",
	"fTBeneficiaryService",
	"constantConfig",
	"inbForgotPwdService",
	"cryptoService",
	"loggedInUserService",
	"cardsService", "clearServiceDataService", "feedebackService", "sampoornSurakshaService", "inbLockUnlockService",
	function ($timeout,
		$state, $ionicPopup,
		$scope,
		homeScreenService,
		$rootScope,
		customerInfoService,
		internetBankingService,
		getAccountDetailsService,
		wishListService, utilityService,
		mPinLoginService,
		billDeskService,
		personalLoanService,
		myProfileService,
		$ionicSideMenuDelegate,
		$ionicScrollDelegate,
		fTBeneficiaryService,
		constantConfig,
		inbForgotPwdService,
		cryptoService,
		loggedInUserService,
		cardsService, clearServiceDataService, feedebackService, sampoornSurakshaService, inbLockUnlockService) {

		var inbLockAccessOtpVm = this;
		inbLockAccessOtpVm.isNextEnabled = false;
		inbLockAccessOtpVm.isDisabledOTP = false;
		inbLockAccessOtpVm.disableNext = false;
		inbLockAccessOtpVm.mobileNum = loggedInUserService.inbUserId.data.mobileNumber;

		inbLockAccessOtpVm.otp = "";
		var count = 0;
		var countInbLockOtpAttempts = 0;

		inbLockAccessOtpVm.disableCount = function () {
			count += 1;
			if (count >= 2) {
				inbLockAccessOtpVm.isDisabledOTP = true;
				inbLockAccessOtpVm.disableNext = true;
			}
			else {
				inbLockAccessOtpVm.isDisabledOTP = false;

			}
		}

		inbLockAccessOtpVm.nextEnable = function () {
			if (inbLockAccessOtpVm.otp.length == 6) {
				if (countInbLockOtpAttempts >= 3) {
					inbLockAccessOtpVm.isNextEnabled = true;
				} else {
					inbLockAccessOtpVm.isNextEnabled = false;
				}
			} else {
				inbLockAccessOtpVm.isNextEnabled = true;
			}
		}

		inbLockAccessOtpVm.goToNext = function () {
			if (inbLockAccessOtpVm.otp.length < 6) {
			} else {
				countInbLockOtpAttempts += 1;
				var reqParams = {};
				reqParams.otp = inbLockAccessOtpVm.otp;
				inbLockUnlockService.validateOTP(reqParams).then(function (data) {
					inbLockAccessOtpVm.mobileNum = loggedInUserService.inbUserId.data.mobileNumber;
					inbLockAccessOtpVm.intBankUname = loggedInUserService.getInbUserId().data.inbUserId;
					var reqParams = {
						"userName": inbLockAccessOtpVm.intBankUname,
						"mobileNumber": inbLockAccessOtpVm.mobileNum
					};
					inbLockUnlockService.lockAccess(reqParams).then(function (response) {
						inbLockUnlockService.displayPopUp('<center><img class="inb-error-sym" src="img/FT/BhimUpi/successSymbol.svg" /><br><p class="inb-alert-header inb-mart-12">You have Successfully Locked the Access.</p><center/>',
							response.responseMessage, ["Login"], function () {
								$state.go('menu.userLogin');
							});
					}, function (error) {
						inbLockUnlockService.displayPopUp('<center><img class="inb-error-sym" src="img/FT/BhimUpi/errorSymbol.svg" /><br><p class="inb-alert-header inb-mart-12"></p><center/>',
							error.responseMessage, ["OK"], function () {
								$state.go('menu.userLogin');
							});
					});
				}, function (error) {
					if(countInbLockOtpAttempts >= 3){
						inbLockUnlockService.displayPopUp('<center><img class="inb-error-sym" src="img/FT/BhimUpi/errorSymbol.svg" /><br><p class="inb-alert-header inb-mart-12"></p><center/>',
						error.responseMessage, ["OK"], function () {
							$state.go('menu.userLogin');
						});
                            
					}else{
					inbLockUnlockService.displayPopUp('<center><img class="inb-error-sym" src="img/FT/BhimUpi/errorSymbol.svg" /><br><p class="inb-alert-header inb-mart-12"></p><center/>',
						error.responseMessage, ["OK"], function () {
							$state.go('menu.inbLockAccessOtp');
						});
						}
				});
			}
		};

		inbLockAccessOtpVm.resendOTP = function () {
			if (inbLockAccessOtpVm.isDisabledOTP) { return true }
			inbLockAccessOtpVm.otp = "";


			inbLockAccessOtpVm.inbUserName = loggedInUserService.getInbUserId().data.inbUserId;
			var reqParams = {
				"userName": inbLockAccessOtpVm.inbUserName,
				"mobileNumber": inbLockAccessOtpVm.mobileNum
			};
			inbLockUnlockService.getLockAccessOTP(reqParams).then(function (data) {
				inbLockUnlockService.displayPopUp('<center><img class="inb-error-sym" src="img/FT/BhimUpi/successSymbol.svg" /><br><p class="inb-alert-header inb-mart-12"></p><center/>',
					"OTP has been send to your registered mobile number.", ["OK"], function () {
						$state.go('menu.inbLockAccessOtp');
					});
				inbLockAccessOtpVm.disableCount();
			}, function (error) {
				inbLockUnlockService.displayPopUp('<center><img class="inb-error-sym" src="img/FT/BhimUpi/errorSymbol.svg" /><br><p class="inb-alert-header inb-mart-12"></p><center/>',
					error.responseMessage, ["OK"], function () {
						$state.go('menu.inbLockAccessOtp');
					});
			});
			inbLockAccessOtpVm.isDisabledOTP = true;
		}
		return this;
	}
]);
