'use strict';

angularApp.controller('inbUnlockSetNewPasswordController', ["$state",
	"$ionicPopup",
	"$scope",
	"$rootScope",
	"$filter",
	"loggedInUserService",
	"cryptoService",
	"inbForgotPwdService",
	"utilityService",
	"inbLockUnlockService",

	function ($state,
		$ionicPopup,
		$scope,
		$rootScope,
		$filter,
		loggedInUserService,
		cryptoService,
		inbForgotPwdService,
		utilityService,
		inbLockUnlockService) {

		var inbUnlockSetNewPasswordVm = this;
		inbUnlockSetNewPasswordVm.errorPassword = false;
		inbUnlockSetNewPasswordVm.passWordMatch = false;
		inbUnlockSetNewPasswordVm.isNextEnabled = true;


		inbUnlockSetNewPasswordVm.enterPwdFun = function (event) {
			var regularExpression = /^(?=.*[0-9])(?=.*[a-z])(?=.*[A-Z])(?=.*[~`!"',-.;/@#$%^&*+/(/)\\\s])[a-zA-Z0-9~`!"',-.;/@#$%^&*+/(/)\\\s]{8,20}$/;

			if (!regularExpression.test(inbUnlockSetNewPasswordVm.enterPwd)) {
				
				inbUnlockSetNewPasswordVm.errorPassword = true;
			} else {
				inbUnlockSetNewPasswordVm.errorPassword = false;
			}
			if (!inbUnlockSetNewPasswordVm.errorPassword) {
				inbUnlockSetNewPasswordVm.notMatch = true;
				if (inbUnlockSetNewPasswordVm.reEnterPwd === inbUnlockSetNewPasswordVm.enterPwd) {
					inbUnlockSetNewPasswordVm.passWordMatch = true;
					inbUnlockSetNewPasswordVm.isNextEnabled = false;
					inbUnlockSetNewPasswordVm.notMatch = false;
				} else {
					inbUnlockSetNewPasswordVm.passWordMatch = false;
					inbUnlockSetNewPasswordVm.notMatch = true;
					inbUnlockSetNewPasswordVm.isNextEnabled = true;
				}
			}
		}
		inbUnlockSetNewPasswordVm.reset = function () {
			inbUnlockSetNewPasswordVm.enterPwd = "";
			inbUnlockSetNewPasswordVm.reEnterPwd = "";
			inbUnlockSetNewPasswordVm.errorPassword = false;
			inbUnlockSetNewPasswordVm.notMatch = false;
			inbUnlockSetNewPasswordVm.passWordMatch = false;
			inbUnlockSetNewPasswordVm.isNextEnabled =true;


		}

		inbUnlockSetNewPasswordVm.goToNext = function () {
			if(!inbUnlockSetNewPasswordVm.enterPwd || inbUnlockSetNewPasswordVm.errorPassword || !inbUnlockSetNewPasswordVm.reEnterPwd || inbUnlockSetNewPasswordVm.notMatch){
				inbUnlockSetNewPasswordVm.errorPassword = true;
				inbUnlockSetNewPasswordVm.notMatch = true;
				return false;
			}
			inbLockUnlockService.reEnterPassword = inbUnlockSetNewPasswordVm.reEnterPwd;
			var SaltValue = "#";
			var toChange = loggedInUserService.getInbUserId().data.inbUserId + SaltValue + inbUnlockSetNewPasswordVm.reEnterPwd;
			var rsaValue = cryptoService.encryptRSAWithPublicKey(inbUnlockSetNewPasswordVm.reEnterPwd, cryptoService.rsaPublicKey);
			var finalSHA512Val = rsaValue;

			var reqData = {
				"toChange": finalSHA512Val,
				"mode": inbLockUnlockService.profile
			}
			inbForgotPwdService.getOTP(reqData).then(function (data) {
				$state.go('menu.inbUnLockAccessOtp');

			}, function (error) {
					inbLockUnlockService.displayPopUp('<center><img class="inb-error-sym" src="img/FT/BhimUpi/errorSymbol.svg" /><br><p class="inb-alert-header inb-mart-12"></p><center/>',
							error.responseMessage, ["OK"], function () {
								$state.go('menu.inbUnlockSetNewPassword');
							});
			});
		}

		return this;
	}

]);


