'use strict';

angularApp.service('inbLockUnlockService',
    function ($q, AdapterUtils, accountDetailsService, utilityService, $state, $filter, $ionicPopup) {

        var inbLockUnlockService = this;
        inbLockUnlockService.profile = "PROFILE";
        inbLockUnlockService.countryList = [];
        inbLockUnlockService.reEnterPassword = "";
        inbLockUnlockService.intBankUname = "";
        inbLockUnlockService.finalSHA512Val = "";
        inbLockUnlockService.serviceId = "";
        inbLockUnlockService.NoMpinCreated = false;
        inbLockUnlockService.challengeErrorCode = "";
        

        inbLockUnlockService.lockAccessDataValidation = function (obj) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/ServiceRequestAdapter/lockAccessDataValidation", obj, true).then(
                function (response) {
                    q.resolve(response);
                },
                function (error) {

                    q.reject(error);
                }
            );
            return q.promise;
        }
        inbLockUnlockService.getCountryDetailList = function () {

            var q = $q.defer();
            AdapterUtils.postData("adapters/ServiceRequestAdapter/getCountryDetailList", {}, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {

                    q.reject(error);
                }
            );
            return q.promise;

        }
        inbLockUnlockService.getLockAccessOTP = function (reqParams) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/ServiceRequestAdapter/getLockAccessOTP", reqParams, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        inbLockUnlockService.validateOTP = function (reqParams) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/ServiceRequestAdapter/validateOTP", reqParams, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        inbLockUnlockService.lockAccess = function (reqParams) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/ServiceRequestAdapter/lockAccess", reqParams, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        inbLockUnlockService.unlockUser = function (reqParams) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/ServiceRequestAdapter/unlockUser", reqParams, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
           inbLockUnlockService.unlockUserDataValidation = function (reqParams) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/ServiceRequestAdapter/unlockUserDataValidation", reqParams, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
           inbLockUnlockService.validateProfilePasswordUnlock = function (reqParams) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/ServiceRequestAdapter/validateProfilePasswordUnlock", reqParams, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        inbLockUnlockService.displayErrorPopUp = function (heading, message, buttonText, button1, button2) {
            var alertPopup = $ionicPopup.alert({
                title: heading,
                template: '<div class=""></div><div class="inb-alert-msg popupTextBottomPadding fontSize-subHeading inb-p20 fss-common-ul-list">'
                + message + '</div></div>',
                cssClass: 'removePopup-head popupWidth90 popupMargin ftpopup-body popupBackgroundWhite ss-medical-page inb-popUp-sub-btn',
                buttons: [
                    {
                        text: buttonText[0],
                        onTap: function (e) {
                            button1();
                        }
                    },
                    {
                        text: buttonText[1],
                        onTap: function (e) {
                            button2();
                        }
                    }
                ],
            });
        };
   
            inbLockUnlockService.displayPopUp = function(heading,message,buttonText,callBack){
	        if(message == null) {
				message =  "Something went wrong. Please try again after sometime.";
			}	
            var alertPopup = $ionicPopup.alert({
            title: heading,
            template: '<div class="popupTextBottomPadding ss-p-r-f-8 ss-popup-list inb-txt-center inb-lock-error-msg">'
            + message + '</div></div>',
            cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup',
            buttons: [
                {
                    text: buttonText,
                    onTap: function(e) {
                        callBack();
                    }
                }
            ],
        });
    };

        return inbLockUnlockService;
    });
