'use strict';

angularApp.controller('inbResetPasswordController', ["$state",
	"$ionicPopup",
	"$scope",
	"$filter",
	"loggedInUserService",
	"inbResetPwdService",
	"cryptoService",
	"fTReviewService",
	"utilityService",
	"constantConfig",

	function ($state,
		$ionicPopup,
		$scope,
		$filter,
		loggedInUserService,
		inbResetPwdService,
		cryptoService,
		fTReviewService,
		utilityService,
		constantConfig) {

		var inbResetPasswordVm = this;
		inbResetPasswordVm.goToHome = function () {
			$state.go('menu.homeScreen');
		}


		inbResetPasswordVm.validateProfilePasswordSecure = function () {

			fTReviewService.getProfilePassAndSerKey().then(function (response) {
				var options = {
					inbUserName:loggedInUserService.getUserProfileDetails().inbUsername,
					strPass:inbResetPasswordVm.profilePassword,
					keyId:response.keyId,
					serviceId:response.serviceId,
					osName:device.platform,
					type:constantConfig.commonObj.type
				};
				var reqParams = utilityService.commonRequestForValidateProfilePass(options);
				inbResetPwdService.validateProfilePasswordSecure(reqParams).then(function (response) {
					console.log(JSON.stringify(response));

					$state.go('menu.resetPassword');

				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
					
				});

			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		};
		inbResetPasswordVm.unblockProfilePass = function(){
				$state.go('menu.forgotProfilePwd');
		}
		return this;
	}

]);
