'use strict';

angularApp.service('inbResetPwdService',
	function ($q, AdapterUtils, accountDetailsService, utilityService, $state, $filter, $ionicPopup) {

		var inbResetPwdService = this;
		inbResetPwdService.SecurityQuestion = "";
		inbResetPwdService.answer = "";
		inbResetPwdService.atmCardNumber = "";
		inbResetPwdService.atmPin = "";
		inbResetPwdService.reEnterPassword = "";
		inbResetPwdService.settingPage = false;
		inbResetPwdService.profile = "PROFILE";


		inbResetPwdService.goToAccAndBankDetails = function (atmNumber, atmPin) {
			var finalThreeDES = "";
			var strPIN = "0";
			var PIN = atmPin;
			var pinLength = PIN.toString().length;
			var strHLen = pinLength.toString();
			strPIN = strPIN + strHLen;
			strPIN = strPIN + PIN;
			var yourNumber4 = strPIN.length;
			var lastValue = []
			for (yourNumber4; yourNumber4 < 16; yourNumber4++) {
				lastValue.push('F');
			}
			strPIN = strPIN + (lastValue.toString()).replace(/[^a-zA-Z ]/g, "");
			var strPAN = "0000";
			var pandigit = atmNumber;
			var resource = pandigit.slice(-13);
			var resource1 = resource.slice(0, 12);
			strPAN = strPAN + resource1;
			var s = strPAN.toString();
			function hexToBinary(s) {
				var i, k, part, ret = '';
				var lookupTable = {
					'0': '0000', '1': '0001', '2': '0010', '3': '0011', '4': '0100',
					'5': '0101', '6': '0110', '7': '0111', '8': '1000', '9': '1001',
					'a': '1010', 'b': '1011', 'c': '1100', 'd': '1101',
					'e': '1110', 'f': '1111',
					'A': '1010', 'B': '1011', 'C': '1100', 'D': '1101',
					'E': '1110', 'F': '1111'
				};
				for (i = 0; i < s.length; i += 1) {
					if (lookupTable.hasOwnProperty(s[i])) {
						ret += lookupTable[s[i]];
					} else {
						return { valid: false };
					}
				}
				return { valid: true, result: ret };
			}

			var output1 = hexToBinary(strPIN);
			var strBPIN = output1.result;
			var output2 = hexToBinary(strPAN);
			var strBPAN = output2.result;
			var result = "0100" ^ "0101";
			var FinalOutput = strBPIN;
			var FinalOutput2 = strBPAN;
			var Slice1 = FinalOutput;
			var SlicePan = FinalOutput2;
			var FinalSlice1 = "";
			var FinalSlice2 = "";
			var strXOR = "";
			var finalXor = [];
			var blockLen = strBPIN / 4;
			var xorStr = "";
			for (var i = 0; i <= 15; i++) {
				FinalSlice1 = strBPIN.slice(i * 4, i * 4 + 4);
				FinalSlice2 = strBPAN.slice(i * 4, i * 4 + 4);
				var xorBahubali = FinalSlice1 ^ FinalSlice2;
				for (var j = 0; j < 4; j++) {
					var pinBit = FinalSlice1.slice(j, j + 1)
					var panBit = FinalSlice2.slice(j, j + 1)
					xorStr = xorStr + (pinBit ^ panBit).toString();
				}
			}

			var s = xorStr;

			function binaryToHex(s) {
				var i, k, part, accum, ret = '';
				for (i = s.length - 1; i >= 3; i -= 4) {
					part = s.substr(i + 1 - 4, 4);
					accum = 0;
					for (k = 0; k < 4; k += 1) {
						if (part[k] !== '0' && part[k] !== '1') {
							return { valid: false };
						}
						accum = accum * 2 + parseInt(part[k], 10);
					}
					if (accum >= 10) {
						ret = String.fromCharCode(accum - 10 + 'A'.charCodeAt(0)) + ret;
					} else {
						ret = String(accum) + ret;
					}
				}
				if (i >= 0) {
					accum = 0;
					for (k = 0; k <= i; k += 1) {
						if (s[k] !== '0' && s[k] !== '1') {
							return { valid: false };
						}
						accum = accum * 2 + parseInt(s[k], 10);
					}
					ret = String(accum) + ret;
				}
				return { valid: true, result: ret };
			}

			var pinPanBlockValue = binaryToHex(s).result;
			var currDate = new Date();
			var txtDate = $filter('date')(currDate, 'MMddHHmmss');

			var pinPanBlockEncrypt = pinPanBlockValue.toString();
			var atmNumberEncrypt = atmNumber.toString();

			var reqParams = {};
			reqParams["pinPanBlock"] = pinPanBlockEncrypt;
			reqParams["atmNumber"] = atmNumberEncrypt;
			reqParams["txnDate"] = txtDate;

			accountDetailsService.validateUserThroughATMPreLogin(reqParams).then(function (data) {
				$state.go('menu.resetProfilePwd');
			}, function (error) {
				if (error.data) {
					if (error.data.responseCode == '111' || error.data.responseCode == '117') {
						var atmCredInvalidPopUp = $ionicPopup.show({
							template: '<p>Please enter valid ATM card Number and ATM Pin.<br><br>' +
							'Or visit <a href="#" class="decornone txt-blue">onlinesbi.com</a><br><br>' +
							'or contact your nearest branch.<br><br>' +
							'or call us at</br>' +
							'1800 11 2211</br>' +
							'1800 425 3800</p>',
							title: '',
							cssClass: 'dialog',
							scope: $scope,
							buttons: [{
								text: 'OK',
								type: 'button-positive',
								onTap: function (e) {
									$state.go('menu.accountDetailsPage');
								}
							}]
						});
					} else {
						utilityService.showErrorMessage(error.responseMessage);
					}
				} else {
					utilityService.showErrorMessage(error.responseMessage);
				}
			});
		}

		inbResetPwdService.getOTPSecure = function (obj) {
			
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/getOTPSecure", obj, true).then(
				function (response) {
					q.resolve(response);
				},
				function (error) {

					q.reject(error);
				}
			);
			return q.promise;

		}


		inbResetPwdService.validateOTP = function (obj) {

			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/validateOTPSecure", obj, true).then(
				function (response) {
					q.resolve(response);
				},
				function (error) {

					q.reject(error);
				}
			);
			return q.promise;

		}

		inbResetPwdService.setLoginPasswordSecure = function (obj) {

			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/setLoginPasswordSecure", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {

					q.reject(error);
				}
			);
			return q.promise;

		}

		inbResetPwdService.validateProfilePasswordSecure = function (reqParams) {

			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/validateProfilePasswordSecure", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {

					q.reject(error);
				}
			);
			return q.promise;

		}
		return inbResetPwdService;
	});
