'use strict';

angularApp.controller('resetPasswordController', ["$state",
	"$ionicPopup",
	"$scope",
	"$filter",
	"loggedInUserService",
	"inbResetPwdService",
	"cryptoService",
	"utilityService",
	"constantConfig",

	function ($state,
		$ionicPopup,
		$scope,
		$filter,
		loggedInUserService,
		inbResetPwdService,
		cryptoService,
		utilityService,
		constantConfig) {

		var resetPasswordVm = this;
		resetPasswordVm.errorPassword = false;
		resetPasswordVm.passWordMatch = false;
		resetPasswordVm.isNextEnabled = true;
		resetPasswordVm.isTextReadable = false;
		resetPasswordVm.isTextReadablereEnter = false;



		resetPasswordVm.enterPasswordFun = function () {
			var regularExpression = /^(?=.*[0-9])(?=.*[a-z])(?=.*[A-Z])(?=.*[~`!"',-./@#$%^&*+/(/)\s])[a-zA-Z0-9~`!"',-./@#$%^&*+/(/)\s]{8,20}$/;

			if (!regularExpression.test(resetPasswordVm.enterPassword)) {
				resetPasswordVm.errorPassword = true;
			} else {
				resetPasswordVm.errorPassword = false;


			}
			if (!resetPasswordVm.errorPassword) {
				resetPasswordVm.notMatch = true;
				if (resetPasswordVm.reEnterPassword === resetPasswordVm.enterPassword) {
					resetPasswordVm.passWordMatch = true;
					resetPasswordVm.isNextEnabled = false;
					resetPasswordVm.notMatch = false;
				} else {
					resetPasswordVm.passWordMatch = false;
					resetPasswordVm.notMatch = true;
				}
			}

			resetPasswordVm.nextEnable();

		}


		resetPasswordVm.nextEnable = function () {
			if (resetPasswordVm.reEnterPassword && resetPasswordVm.enterPassword && resetPasswordVm.passWordMatch && !resetPasswordVm.errorPassword) {
				resetPasswordVm.isNextEnabled = false;
			} else {
				resetPasswordVm.isNextEnabled = true;
			}


		}

		resetPasswordVm.reset = function () {
			resetPasswordVm.reEnterPassword = "";
			resetPasswordVm.enterPassword = "";
			resetPasswordVm.errorPassword = false;
			resetPasswordVm.passWordMatch = false;
			resetPasswordVm.notMatch = false;
			resetPasswordVm.nextEnable();
		}
		resetPasswordVm.goToNext = function () {
			resetPasswordVm.inbUser = loggedInUserService.getUserProfileDetails().inbUsername;
			inbResetPwdService.reEnterPassword = resetPasswordVm.reEnterPassword
			var SaltValue = "#";
			var toChange = resetPasswordVm.inbUser + SaltValue + resetPasswordVm.reEnterPassword;
			var rsaValue = cryptoService.encryptRSAWithPublicKey(resetPasswordVm.reEnterPassword, cryptoService.rsaPublicKey);
			var finalSHA512Val = rsaValue;

			var reqData = {
				"toChange": finalSHA512Val,
				"mode": "PROFILE",
				"journeyName":constantConfig.OTP_EMAIL_SMS_TEMPLATE.RESET_LOGIN_PASS
			}

			inbResetPwdService.getOTPSecure(reqData).then(function (data) {
				console.log(JSON.stringify(data));
				$state.go('menu.resetPasswordOtp');

			}, function (error) {

				utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
			});
		}
		resetPasswordVm.goToHome = function () {
			$state.go('menu.homeScreen');
		}
		resetPasswordVm.toggleSecretAns = function () {
			resetPasswordVm.isTextReadable == true ? resetPasswordVm.isTextReadable = false : resetPasswordVm.isTextReadable = true;
		};
		resetPasswordVm.toggleReEnter = function () {
			resetPasswordVm.isTextReadablereEnter == true ? resetPasswordVm.isTextReadablereEnter = false : resetPasswordVm.isTextReadablereEnter = true;
		};


		return this;
	}

]);
