'use strict';

angularApp.controller('resetPasswordOtpController', ["$timeout",
	"$state",
	"$ionicPopup",
	"$scope",
	"homeScreenService",
	"$rootScope",
	"customerInfoService",
	"inbResetPwdService",
	"getAccountDetailsService",
	"wishListService",
	"utilityService",
	"mPinLoginService",
	"billDeskService",
	"personalLoanService", "myProfileService",
	"$ionicSideMenuDelegate",
	"$ionicScrollDelegate",
	"fTBeneficiaryService",
	"inbForgotPwdService",
	"constantConfig",
	"cryptoService",
	"loggedInUserService",
	"clearServiceDataService",
	"cardsService",
	"feedebackService",
	"AdapterUtils",
	function ($timeout,
		$state, $ionicPopup,
		$scope,
		homeScreenService,
		$rootScope,
		customerInfoService,
		inbResetPwdService,
		getAccountDetailsService,
		wishListService, utilityService,
		mPinLoginService,
		billDeskService,
		personalLoanService,
		myProfileService,
		$ionicSideMenuDelegate,
		$ionicScrollDelegate,
		fTBeneficiaryService,
		inbForgotPwdService,
		constantConfig,
		cryptoService,
		loggedInUserService,
		clearServiceDataService,
		cardsService,
		feedebackService,
		AdapterUtils) {

		//functions, variables that can be accessed from the HTML come here
		var resetPasswordOtpVm = this;
		resetPasswordOtpVm.mobileNumber = $rootScope.mobileNo;
		var count = 0;
		resetPasswordOtpVm.otp = "";


		resetPasswordOtpVm.disableCount = function () {
			count += 1;
			if (count >= 3) {
				resetPasswordOtpVm.isNextEnabled = true;
				resetPasswordOtpVm.isDisabledOTP = true;
			}

		}


		resetPasswordOtpVm.goToNext = function () {



			if (resetPasswordOtpVm.otp.length < 6) {
				resetPasswordOtpVm.nextEnable();

			} else {

				var requestParams = {
					otp: resetPasswordOtpVm.otp
				}

				inbResetPwdService.validateOTP(requestParams).then(function (data) {

					if (data.responseCode == "0000") {
						resetPasswordOtpVm.inbUser = loggedInUserService.getUserProfileDetails().inbUsername;
						var SaltValue = "#";
						var toChange = resetPasswordOtpVm.inbUser + SaltValue + inbResetPwdService.reEnterPassword;
						var rsaValue = cryptoService.encryptRSAWithPublicKey(inbResetPwdService.reEnterPassword, cryptoService.rsaPublicKey);
						var finalSHA512Val = rsaValue;

						var reqData = {
							"newPassword": finalSHA512Val
						};


						inbResetPwdService.setLoginPasswordSecure(reqData).then(function (data) {
							resetPasswordOtpVm.myPopup = $ionicPopup.show({
								title: '',
								cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
								templateUrl: 'pages/nfs/inbResetPassword/resetPasswordSuccessPopUp.html',
								scope: $scope
							})
						}, function (error) {
							utilityService.showErrorMessage(error.responseMessage);
						});



					}
					else {
						resetPasswordOtpVm.disableCount();
						utilityService.showErrorMessage(data.status);
					}

				}, function (error) {
					resetPasswordOtpVm.disableCount();
					utilityService.showErrorMessage(error.responseMessage);
					resetPasswordOtpVm.otp = "";
				});
			}



		};

		resetPasswordOtpVm.nextEnable = function () {
			resetPasswordOtpVm.showNameError = resetPasswordOtpVm.otp.length;
			if (resetPasswordOtpVm.otp === resetPasswordOtpVm.otpValue)
				resetPasswordOtpVm.disableNext = false;
			else
				resetPasswordOtpVm.disableNext = true;
		}

		resetPasswordOtpVm.goToHome = function () {
			$state.go('menu.homeScreen');
		}

		resetPasswordOtpVm.resendOTP = function () {
			if (resetPasswordOtpVm.isDisabledOTP) { return true }
			resetPasswordOtpVm.otp = "";

			var rsaValue = cryptoService.encryptRSAWithPublicKey(inbResetPwdService.reEnterPassword, cryptoService.rsaPublicKey);
			var finalSHA512Val = rsaValue;
			var reqData = {
				"toChange": finalSHA512Val,
				"mode": inbResetPwdService.profile,
				"journeyName":constantConfig.OTP_EMAIL_SMS_TEMPLATE.RESET_LOGIN_PASS
			};


			
			inbResetPwdService.getOTPSecure(reqData).then(function (data) {	

			}, function (error) {

				utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
			});

			resetPasswordOtpVm.isDisabledOTP = true;
		}


		resetPasswordOtpVm.goToLogin = function () {
			
			resetPasswordOtpVm.myPopup.close();
			utilityService.setCsatJournies('updateINBPassword');
			utilityService.showSpinner();
			clearServiceDataService.clearServiceData();
			resetPasswordOtpVm.getCSATDetails();

		};
		resetPasswordOtpVm.getCSATDetails = function () {
			
	
			if (utilityService.timeSpent > 0) {
				utilityService.setCsatJournies('ompShoppingDeals');
			}
			var allJournies = utilityService.getCsatJournies();
			feedebackService.getFeedbackData(allJournies).then(function (data) {
				utilityService.hideSpinner();
				if (!data || data == null) {
			utilityService.hideSpinner();
			$state.go('menu.feedback');
				} else {
					
					feedebackService.data = data;
					utilityService.hideSpinner();
			$state.go('menu.feedback');
				}
			}, function (error) {
				utilityService.hideSpinner();
			
				loggedInUserService.logoutUser();
			});
		
		}
		resetPasswordOtpVm.sessionLogout = function () {
			AdapterUtils.sessionLogout().then(
				function (response) {
				console.log("Logout success !!");
				loggedInUserService.logoutUser();
				},
				function (error) {
				console.log("Logout failure !!!");
				loggedInUserService.logoutUser();
				}
			);
		}
		return this;
	}
]);
