'use strict';

angularApp.controller('manageAtmOtpController', ["$timeout",
	"$state",
	"$ionicPopup",
	"$scope",
	"homeScreenService",
	"openAccountService",
	"$rootScope",
	"customerInfoService",
	"getAccountDetailsService",
	"wishListService",
	"utilityService",
	"mPinLoginService",
	"billDeskService",
	"personalLoanService", "myProfileService",
	"$ionicSideMenuDelegate",
	"$ionicScrollDelegate",
	"fTBeneficiaryService",
	"constantConfig",
	"manageAtmService",
	"cardsService",
	function ($timeout,
		$state, $ionicPopup,
		$scope,
		homeScreenService,
		openAccountService,
		$rootScope,
		customerInfoService,
		getAccountDetailsService,
		wishListService, utilityService,
		mPinLoginService,
		billDeskService,
		personalLoanService,
		myProfileService,
		$ionicSideMenuDelegate,
		$ionicScrollDelegate,
		fTBeneficiaryService,
		constantConfig,
		manageAtmService,
		cardsService) {

		//functions, variables that can be accessed from the HTML come here
		var manageAtmOtpVm = this;

		manageAtmOtpVm.mobileNumber = $rootScope.mobileNo;
		manageAtmOtpVm.otp = "";
		var count = 0;
		manageAtmOtpVm.disableCount = function () {
			count += 1;
			if (count >= 3) {
				manageAtmOtpVm.isNextEnabled = true;
				manageAtmOtpVm.isDisabledOTP = true;
			}

		}

		manageAtmOtpVm.goToNext = function () {
			
			if(manageAtmService.amtAtmData == "" || manageAtmService.amtAtmData == null || manageAtmService.amtAtmData == undefined){
						manageAtmService.amtAtmData =  manageAtmService.usageLimit.atmLimit;
					}

					if(manageAtmService.amtPosData == "" || manageAtmService.amtPosData == null || manageAtmService.amtPosData == undefined){
						manageAtmService.amtPosData =  manageAtmService.usageLimit.posLimit;
					}

			if (manageAtmOtpVm.otp.length < 6) {
				blockUnblockOtpVm.nextEnable();

			} else {

				var requestParams = {
					otp: manageAtmOtpVm.otp,
					mobile: customerInfoService.customer.mobile
				}

				personalLoanService.requestOtp(requestParams).then(function (data) {

					if (data.status == "Success") {
						manageAtmService.reqData.cardNumber = manageAtmService.manageCardNumber;
						
						manageAtmService.manageUpdation(manageAtmService.reqData).then(function (data) {

							console.log(JSON.stringify(data));
							manageAtmOtpVm.showCardNumber = manageAtmService.manageCardNumber;
							
							//alert("manageUpdation"+JSON.stringify(data));

							if (data.responseCode == "0000") {

								manageAtmOtpVm.myPopup = $ionicPopup.show({
									title: '',
									cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
									templateUrl: 'pages/nfs/manageAtm/Congratulations.html',
									scope: $scope
								});

							}
							else {

								manageAtmOtpVm.myPopup = $ionicPopup.show({
									title: '',
									cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
									templateUrl: 'pages/nfs/manageAtm/partlyComplete.html',
									scope: $scope
								});


							}


						}, function (error) {
							utilityService.showErrorMessage(error.responseMessage);
						});

					}
					else {
						utilityService.showErrorMessage(data.status);
						manageAtmOtpVm.disableCount();
					}

				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
					manageAtmOtpVm.disableCount();
					//$state.go('menu.serviceRequest');

				});

			}








		};

		manageAtmOtpVm.ok = function () {
			manageAtmOtpVm.myPopup.close();
			manageAtmOtpVm.otp = "";
			$state.go('menu.innerPage');
		};


		manageAtmOtpVm.goToHome = function () {
			$state.go('menu.homeScreen');
		}


		manageAtmOtpVm.resendOTP = function () {
			if (manageAtmOtpVm.isDisabledOTP) { return true }
			//    $scope.resendLable = true;
			//    $scope.sendLable = false;
			manageAtmOtpVm.otp = "";
			var reqData = {
				"id": customerInfoService.customer.mobile,
				"emailId": customerInfoService.customer.emailID
			}
			personalLoanService.otpLoan(reqData).then(function (data) {

			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});

			manageAtmOtpVm.isDisabledOTP = true;
		}


		manageAtmOtpVm.nextEnable = function () {
			manageAtmOtpVm.showNameError = manageAtmOtpVm.otp.length;
			if (manageAtmOtpVm.otp === manageAtmOtpVm.otpValue)
				manageAtmOtpVm.disableNext = false;
			else
				manageAtmOtpVm.disableNext = true;
		}









		manageAtmOtpVm.goToBack = function () {
			$state.go('menu.manageAtm');
		}







		return this;
	}
]);
