'use strict';

angularApp.controller('newDebitCardOtpController', ["$timeout",
	"$state",
	"$ionicPopup",
	"$scope",
	"homeScreenService",
	"openAccountService",
	"$rootScope",
	"customerInfoService",
	"getAccountDetailsService",
	"wishListService",
	"utilityService",
	"mPinLoginService",
	"billDeskService",
	"personalLoanService", "myProfileService",
	"$ionicSideMenuDelegate",
	"$ionicScrollDelegate",
	"fTBeneficiaryService",
	"constantConfig",
	"newDebitCardService",
	"cardsService","fTSetOTPService","$filter","cryptoService","loggedInUserService",
	function ($timeout,
		$state, $ionicPopup,
		$scope,
		homeScreenService,
		openAccountService,
		$rootScope,
		customerInfoService,
		getAccountDetailsService,
		wishListService, utilityService,
		mPinLoginService,
		billDeskService,
		personalLoanService,
		myProfileService,
		$ionicSideMenuDelegate,
		$ionicScrollDelegate,
		fTBeneficiaryService,
		constantConfig,
		newDebitCardService,
		cardsService,fTSetOTPService,$filter,cryptoService,loggedInUserService) {

		//functions, variables that can be accessed from the HTML come here
		var newDebitCardOtpVm = this;


		$scope.$on('$ionicView.beforeEnter', function() {         
	
			 
			newDebitCardOtpVm.userMobile = $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4);
			newDebitCardOtpVm.isDisabledOTP=false;
			newDebitCardOtpVm.clickCount=0;
			newDebitCardOtpVm.disableNext=true;
			//newDebitCardOtpVm.isNextEnabled = true;
			newDebitCardOtpVm.clickSubmitCount = 0;
	
		 });
 

		 newDebitCardOtpVm.resendOTP = function () {
			newDebitCardOtpVm.otp="";
            newDebitCardOtpVm.isResendOTP=true;
            var reqData = {};

			reqData["id"] = $rootScope.mobileNo;
			reqData.otpCode = constantConfig.keysForOTP.CARDOTP;
			reqData.ocHash = cryptoService.getSHA512EncryptedData(constantConfig.keysForOTP.CARDOTP).toString();
            fTSetOTPService.generateOTP(reqData).then(function (response) {
                newDebitCardOtpVm.clickCount++;
                if(newDebitCardOtpVm.clickCount>=2){
                    newDebitCardOtpVm.isDisabledOTP=true;
                }
                else{
                    newDebitCardOtpVm.isDisabledOTP=true;
                    $timeout(function () {
                        newDebitCardOtpVm.isDisabledOTP=false;
                    }, 30000);
                }

            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
		
		}


		
		newDebitCardOtpVm.nextEnable = function () {
			newDebitCardOtpVm.showNameError = newDebitCardOtpVm.otp.length;
			if (newDebitCardOtpVm.otp.length==6 || !newDebitCardOtpVm.otp)

				newDebitCardOtpVm.disableNext = false;
			else
				newDebitCardOtpVm.disableNext = true;
		}

		newDebitCardOtpVm.goToNext = function () {


			if (newDebitCardOtpVm.otp.length < 6) {
				newDebitCardOtpVm.nextEnable();

			} else {

				var requestParams = {
					otp: newDebitCardOtpVm.otp,
					mobile: customerInfoService.customer.mobile
				}
				newDebitCardOtpVm.clickSubmitCount++;
				if(newDebitCardOtpVm.clickSubmitCount<=3){
					
			   
				fTSetOTPService.validateOTP(requestParams).then(function (response) {
				if (response.status.toLowerCase() == 'success') {
				
						var newcardData = newDebitCardService.accountNumber + newDebitCardService.newcardName;
						var totalcardDataSubmit = newDebitCardService.newcardName +newDebitCardService.selectedCardType + newDebitCardService.accountNumber + newDebitCardService.addressType + newDebitCardService.tncStateCheck; 
						var newCardSubmitKeyfinal= cryptoService.getSHA512EncryptedData(loggedInUserService.tokenLotus + totalcardDataSubmit + newcardData).toString();
						var reqDataSubmit = {
							"nameOnCard": newDebitCardService.newcardName,
							"typeOfCard": newDebitCardService.selectedCardType,
							"branchCode": "",
							"accountNumber": newDebitCardService.accountNumber,
							"typeOfAddress": newDebitCardService.addressType,
							"termsNcondition": newDebitCardService.tncStateCheck,
							"newCardSubmitKey":newCardSubmitKeyfinal
						}


						



						newDebitCardService.newDebitCardRequest(reqDataSubmit).then(function (data) {
							newDebitCardOtpVm.requestReferenceNumber = data.requestReferenceNumber;
							newDebitCardOtpVm.storeRefNumber = data.storeRefNumber;
							newDebitCardOtpVm.nightMode = data.nightMode;
							if(newDebitCardOtpVm.nightMode == "Y"){
								newDebitCardOtpVm.showNightMode = true;
							}else{
								newDebitCardOtpVm.dayMode = true;
							}
							newDebitCardOtpVm.myPopup = $ionicPopup.show({
								title: '',
								cssClass: 'new-purp-popup my-custom-popup',
								templateUrl: 'pages/nfs/newDebitCard/Congratulations.html',
								scope: $scope
							});
						}, function (error) {
							utilityService.showNfsAlertModal("", error.responseMessage, "menu.innerPage", $scope, $state, "OK");
							//utilityService.showErrorMessage(error.responseMessage);
						});

						

					}
					else {
						utilityService.showErrorMessage(response.status);
					}

				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);

				});



			}
			else{
					newDebitCardOtpVm.disableNext=true;
			}



			}

		};

		newDebitCardOtpVm.ok = function () {
			newDebitCardOtpVm.myPopup.close();
			utilityService.setCsatJournies('newDebitCard');
			newDebitCardOtpVm.otp = "";
			$state.go('menu.innerPage');
		};


		return this;
	}
]);
