'use strict';

angularApp.controller('paymentInformationController', ["$timeout",
    "$state",
    "$location",
    "$scope",
    "$rootScope",
    "customerInfoService",
    "utilityService",
    "$ionicPopup","ionicDatePicker","pensionInformationService","AdapterUtils","$q",

    function ($timeout,
        $state,
        $location,
        $scope,
        $rootScope,
        customerInfoService,
        utilityService,
        $ionicPopup,
        ionicDatePicker,
        pensionInformationService,AdapterUtils,$q) {

        var paymentInformationVM = this;
        
        paymentInformationVM.goToHome=function (){
            
            $state.go('menu.homeScreen');
        }
        
        paymentInformationVM.getPensionAccountDetails = function() {
        console.log("inside conctroller");
        pensionInformationService.getPensionAccountDetails().then(function(data){
            pensionInformationService.accList = data.accList;
            paymentInformationVM.accList = pensionInformationService.accList;
         },function (error) {
            if (error.responseCode == "cs002") {
                var comingsoonPopup = $ionicPopup.alert({
                  template: '<div class="CSPadding font-dark-grey "><div class="parentCS"><img class="imgwidthCS" src="img/Coming_Soon_Illustration.svg"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="childCS">'
                  + "Coming Soon" + '</div></div></div></div></div></div>',
                  cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter custButtonCS button0pd',
                  buttons: [
                    {
                      text: 'OK',
                      type: 'button-positive',
                      onTap: function (e) {
                        comingsoonPopup.close();
                        $state.go('menu.homeScreen');
                      }
                    }
                  ]
                });
              } else {
                utilityService.showErrorMessage(error.responseMessage);
              }
                // utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
            });
        }

        paymentInformationVM.getPPODetails = function (selectedObj) {
           selectedObj = JSON.parse(selectedObj);
           pensionInformationService.selectedAccValue = selectedObj.accountNumber;
           paymentInformationVM.selectedPPONumber = "";
           paymentInformationVM.ppoList = [];
           paymentInformationVM.ppoList = selectedObj.ppoDetails;
           paymentInformationVM.showMoreDetail = true;
           paymentInformationVM.showMoreDetailPPO = false;
        }

        paymentInformationVM.getPensionerDetails = function (selectedObj) {
                   selectedObj = JSON.parse(selectedObj);
                   //console.log("selectedObj = ", selectedObj);
                    paymentInformationVM.showMoreDetails = true;
                    paymentInformationVM.showMoreDetailPPO = true;
                   paymentInformationVM.pensionerName = selectedObj.pensionerName;
                   paymentInformationVM.pensionCategory = selectedObj.pensionCategory;
         }

        paymentInformationVM.getLastPension = function () {
             var requestparams = {
                "accountNumber": JSON.parse(paymentInformationVM.selectedValue).accountNumber,
                "ppoUniqueID": JSON.parse(paymentInformationVM.selectedPPONumber).ppoUniqueID
            };
            console.log("requestparams = ", requestparams);

            pensionInformationService.getLastPensionDetails(requestparams).then(function(data){
                console.log("data = ", data);
                paymentInformationVM.popupData = data;
                paymentInformationVM.popupData.pensionSlipMonth = paymentInformationVM.convertDate(data.pensionSlipMonth);
               
                paymentInformationVM.alertPopup = $ionicPopup.show({
                   title: '',
                   templateUrl: 'pages/nfs/paymentInformation/lastPensionSlipPopup.html',
                   scope: $scope,
                   cssClass: 'my-pension-popup',
                        buttons: []
               }); 
                utilityService.setCsatJournies('pensionPaymentInfo');

            },function (error) {
                utilityService.showNfsAlertModal("", error.responseMessage, "menu.paymentInformation", $scope, $state, "OK");
            });
        }

       paymentInformationVM.getCummuteDetails = function () {
           var requestparams = {
                 "accountNumber": JSON.parse(paymentInformationVM.selectedValue).accountNumber,
                "ppoUniqueID": JSON.parse(paymentInformationVM.selectedPPONumber).ppoUniqueID
            };
            console.log("requestparams = ", requestparams);

            pensionInformationService.getCommutationInstallmentDetails(requestparams).then(function(data){
                console.log("data = ", data);
               //  paymentInformationVM.popupDataCommute = data;
			   
			   if(data.commutationInstallments == "" || data.commutationInstallments == null)
			   {
				   utilityService.showNfsAlertModal("", "No data available", "menu.paymentInformation", $scope, $state, "OK");
			   }
			   else{
               var dateCD;
                pensionInformationService.commutationInstallments = data.commutationInstallments;
                 paymentInformationVM.commutationInstallments = pensionInformationService.commutationInstallments;
               for(var i=0; i < data.commutationInstallments.length; i++)
               {
                  dateCD = paymentInformationVM.convertDate(data.commutationInstallments[i].endDate);
                  paymentInformationVM.commutationInstallments[i].endDate = dateCD;
               }
                //paymentInformationVM.popupDataCommute = [{Date:"12/11/2019", Desc:"ABC"},{Date:"12/11/2019", Desc:"DEF"}];
                paymentInformationVM.alertPopup = $ionicPopup.show({
                   title: '',
                   templateUrl: 'pages/nfs/paymentInformation/commutationInstallmentDetails.html',
                 //templateUrl: 'pages/nfs/paymentInformation/lastPensionSlipPopup.html',
                   scope: $scope,
                   cssClass: 'my-pension-popup-commute',//'ftpopup-bodyPension popupWidth90Pension popupMarginPension popupBackgroundWhitePension removePopup-headPension',
                   buttons: []
               });
                utilityService.setCsatJournies('pensionPaymentInfo');
			   }
      
         
            },function (error) {
			
                utilityService.showNfsAlertModal("", error.responseMessage, "menu.paymentInformation", $scope, $state, "OK");
            });
        }
        paymentInformationVM.getLifeCerti = function () {
           var requestparams = {
                 "accountNumber": JSON.parse(paymentInformationVM.selectedValue).accountNumber,
                "ppoUniqueID": JSON.parse(paymentInformationVM.selectedPPONumber).ppoUniqueID
            };
            console.log("requestparams = ", requestparams);

            pensionInformationService.getLifeCertificateDetails(requestparams).then(function(data){
                console.log("data = ", data);
                 paymentInformationVM.validitydate = false;

                paymentInformationVM.popupDataLifeCerti = data;
               // var dateCD = new Date(data.validUpto);
               var dateLastSubmitted = paymentInformationVM.convertDate(data.lastSubmittedOn);
                var dateValidUpto = paymentInformationVM.convertDate(data.validUpto);
                var today = new Date(); 
               // console.log(dateCD);
               paymentInformationVM.popupDataLifeCerti.lastSubmittedOn = dateLastSubmitted;
                paymentInformationVM.popupDataLifeCerti.validUpto=dateValidUpto;
                if(today > dateValidUpto)
                {
                    paymentInformationVM.validitydate = true;
                }
             
                paymentInformationVM.alertPopup = $ionicPopup.show({
                   title: '',
                   templateUrl: 'pages/nfs/paymentInformation/lifeCertificateDetails.html',
                   scope: $scope,
                   cssClass: 'my-pension-popup',//'ftpopup-bodyPension popupWidth90Pension popupMarginPension popupBackgroundWhitePension removePopup-headPension',
                   buttons: []
               });
                 utilityService.setCsatJournies('pensionPaymentInfo');
            },function (error) {
                utilityService.showNfsAlertModal("", error.responseMessage, "menu.paymentInformation", $scope, $state, "OK");
            });
        }
 
		paymentInformationVM.goToBack = function(){
			$state.go('menu.innerPage');
		}
		
        paymentInformationVM.goToPaymentInfo = function(){
            paymentInformationVM.alertPopup.close();
        }
        paymentInformationVM.convertDate = function(date){
          var datePart=date.split("/");
          console.log(datePart);
           var returnDate= new Date (datePart[2],datePart[1] - 1,datePart[0]);
           console.log(returnDate);
             return (returnDate);
        }
        $scope.$on('$ionicView.beforeEnter', function () {
             paymentInformationVM.getPensionAccountDetails();
             paymentInformationVM.showMoreDetail = false;
             paymentInformationVM.showMoreDetailPPO = false;
             
        });

    return this;
  }
]);
