'use strict';

angularApp.controller('pensionForm16BController', ["$timeout",
    "$state",
    "$location",
    "$scope",
    "$rootScope",
    "customerInfoService",
    "utilityService",
    "$ionicPopup", "serviceRequestService","AdapterUtils","$q","openUrlInAppbroswerService","constantConfig","pensionForm16BService","$ionicPopover", "inbLockUnlockService","clickStreamService",

    function ($timeout,
        $state,
        $location,
        $scope,
        $rootScope,
        customerInfoService,
        utilityService,
        $ionicPopup,serviceRequestService,AdapterUtils,$q,openUrlInAppbroswerService,constantConfig,pensionForm16BService,$ionicPopover,inbLockUnlockService,clickStreamService) {

        var pensionForm16BVM = this;
        //functions to get pension account details from Adapter and variables that can be accessed from the HTML template defined below.
        pensionForm16BVM.getPensionAccountDetails = function() {
  		  /* Stub data starts here*/
  		  //pensionForm16BVM.accList = [{"accountNumber":"99999999999","availableBalance":"83,55,530.58","ppoDetails":[{"ppoUniqueID":"00000","ppoNumber":"11111"}]},{"accountNumber":"88888888888","availableBalance":"10,000.00","ppoDetails":[{"ppoUniqueID":"22222","ppoNumber":"33333"}]}];
  		  /* Stub data ends here*/

          //*/-----------------------
          pensionForm16BService.getPensionAccountDetails().then(function(data){
          pensionForm16BService.accList = data.accList;
          pensionForm16BVM.accList = pensionForm16BService.accList;

          pensionForm16BVM.showEmailDownload = false;
          //pensionForm16BVM.showForm16BMessage = false;
          },function (error) {
            if (error.responseCode == "cs002") {
                var comingsoonPopup = $ionicPopup.alert({
                  template: '<div class="CSPadding font-dark-grey "><div class="parentCS"><img class="imgwidthCS" src="img/Coming_Soon_Illustration.svg"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="childCS">'
                  + "Coming Soon" + '</div></div></div></div></div></div>',
                  cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter custButtonCS button0pd',
                  buttons: [
                    {
                      text: 'OK',
                      type: 'button-positive',
                      onTap: function (e) {
                        comingsoonPopup.close();
                        $state.go('menu.homeScreen');
                      }
                    }
                  ]
                });
              } else {
                utilityService.showErrorMessage(error.responseMessage);
              }
        //   utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
         });
         //-----------------------*/
         }

        //funtion to get PPO details from pension account selected object
        pensionForm16BVM.getPPODetails = function (selectedObj) {
          selectedObj = JSON.parse(selectedObj);
          pensionForm16BService.selectedAccValue = selectedObj.accountNumber;
          pensionForm16BVM.selectedPPONumber = "";
          pensionForm16BVM.selectedYear = "";
          pensionForm16BVM.ppoList = [];
          pensionForm16BVM.ppoList = selectedObj.ppoDetails;
          pensionForm16BVM.showEmailDownload = false;
          //pensionForm16BVM.showForm16BMessage = false;
        }

        //function to get Financial years from adapter
        pensionForm16BVM.getFinYear=function(){
        /* Stub data starts here*/
        //pensionForm16BVM.listOfFinancialYears=["2015-2016","2016-2017","2017-2018","2018-2019"];
        /* Stub data ends here*/
        //*/-----------------------
        pensionForm16BService.getFinYears().then(function(data){
           pensionForm16BVM.listOfFinancialYears=data.financialYears;
           pensionForm16BVM.showEmailDownload = false;
           //pensionForm16BVM.showForm16BMessage = false;
            },function (error) {
            utilityService.showErrorMessage(error.responseMessage);
            }
        );
        //-----------------------*/
       }

        //function to get Form16 or Income Certificate Flag
        pensionForm16BVM.getForm16IncomeCerFlag = function(selectedAccount,selectedYear,selectedPPONumber) {
           //console.log("getForm16IncomeCerFlag() called "+selectedAccount);
           var selectedAccountPensionForm16B = JSON.parse(selectedAccount);
           //console.log("Acc no. is "+selectedAccountPensionForm16B.accountNumber);
           //console.log("Bal. is "+selectedAccountPensionForm16B.availableBalance);
           var request = { "accountNumber": selectedAccountPensionForm16B.accountNumber, "financialYear": selectedYear, "ppoUniqueID": selectedPPONumber };
           //console.log(request);
           /* Stub data starts here*/
           /*
    		   pensionForm16BVM.Flag = "F";
           pensionForm16BVM.responseFlag = "Form16 (Part B)";
           pensionForm16BVM.showEmailDownload = true;
           //pensionForm16BVM.showForm16BMessage = true;
           /*/
    		   /* Stub data ends here*/
           //*/-----------------------
           pensionForm16BService.getForm16IncomeCerFlag(request).then(function(data){
             if(data.flag == "I"){
               pensionForm16BVM.Flag = "I";
               pensionForm16BVM.responseFlag = "Income Certificate";
            }else{
               pensionForm16BVM.Flag = "F";
               pensionForm16BVM.responseFlag = "Form16 (Part B)";
               //pensionForm16BVM.showForm16BMessage = true;
            }
            pensionForm16BVM.showEmailDownload = true;
           },function (error) {
                 utilityService.showErrorMessage(error.responseMessage);
                 pensionForm16BVM.showEmailDownload = false;
                 //pensionForm16BVM.showForm16BMessage = false;
           });
           //-----------------------*/
        }
        //function to call adapter service for form16 / Income certificate
        pensionForm16BVM.submitRequest = function (selectedAccount,selectedYear,selectedPPONumber,selectedFlag,isEmail){
			  //console.log("submitRequest method called");
			  var selectedAccountJsonObject = JSON.parse(selectedAccount);
		  	//console.log("Account No. after Json parsing"+selectedAccountJsonObject.accountNumber);
        var q = $q.defer();
        var request = { "accountNumber": selectedAccountJsonObject.accountNumber, "financialYear": selectedYear, "ppoUniqueID": selectedPPONumber,"isEmail":isEmail };
        //console.log("Request object in submitRequest()"+request);
			  //console.log("I am isEmail:"+isEmail);
            if(isEmail=='false') {
              //console.log("submitRequest for download");
              pensionForm16BService.getpensionForm16BDetails(request).then(function(res){
                  pensionForm16BVM.response=res;
				          //console.log("Going 2 download");
                  pensionForm16BVM.receiptDownload(res);
              },function (error) {
              utilityService.showNfsAlertModal("", error.responseMessage, "menu.innerPage", $scope, $state, "OK");
              });
            }else{
              //console.log("isEmail true called...selected flag"+selectedFlag );
              pensionForm16BService.getpensionForm16BDetails(request).then(function(res){
              pensionForm16BVM.response=res;
              inbLockUnlockService.displayPopUp('<center><img class="inb-error-sym" src="img/Successfully.svg" /><br><p class="inb-alert-header inb-mart-12"></p><center/>',
					    '<p>' + pensionForm16BVM.responseFlag +' has been succesfully <br> Emailed to your registered Email ID.</p>', ["OK"], function () {
                      //utilityService.setCsatJournies('form16Info');
						          $state.go('menu.homeScreen');
              });
              },function (error) {
                  if (error.responseCode === "002") {
                    inbLockUnlockService.displayErrorPopUp('<img class="inb-error-icon" src="img/emailPurple.svg" />',
                        '<center class="inb-alert-header">Your Email ID is not registered.<br>Do you want to register Email ID now?</center>', ["Later", "Yes"], function () {
                              clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "PROCEED_BTN"));
                              //utilityService.setCsatJournies('form16Info');
                            $state.go('menu.homeScreen');
                        }, function () {
                            clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "PROCEED_BTN"));
                            //utilityService.setCsatJournies('form16Info');
                            $state.go('menu.emailDetails');
                        });
                }else{
                  inbLockUnlockService.displayPopUp('<center><img class="inb-error-sym" src="img/errorSymbol.svg" /><br><p class="inb-alert-header inb-mart-12"></p><center/>',
  						    error.responseMessage, ["OK"], function () {
                  //utilityService.setCsatJournies('form16Info');
  							  $state.go('menu.homeScreen');
  						});
              }
              });
            }
      }

    // Download receipt code begin
    pensionForm16BVM.receiptDownload = function(res) {
        pensionForm16BVM.downloadLoader = true;
        var content = res.pdf;
        var filename = res.fileName;
        var contentStr = atob(content);
        var contentLen = contentStr.length;
        if(contentLen >= constantConfig.accOverview.pdfSize) {
            utilityService.showErrorMessage(constantConfig.accOverview.sizeLimitMessage);
            return;
        }
        var contentType = "application/pdf";
        if (utilityService.isAndroidPlatform()) {
            pensionForm16BVM.folderpath = cordova.file.externalRootDirectory;
        }
        if (utilityService.isIOSPlatform()) {
            pensionForm16BVM.folderpath = cordova.file.documentsDirectory;
        }
        savebase64AsPDF(pensionForm16BVM.folderpath, filename, content, contentType, contentLen);
        if (utilityService.isIOSPlatform()) {
            filename = filename + ".pdf";
            var finalObject = { "folderpath": pensionForm16BVM.folderpath, "filename": filename };
            openUrlInAppbroswerService.openUrl("data:application/pdf;base64," + content + "","");
            //utilityService.setCsatJournies('form16Info');
         //   $state.go('menu.innerPage');
        }

        /* to show information popup for downlaod receipt, which will tell user format of passowrd for android and ios */
        if (utilityService.isAndroidPlatform()) {
          inbLockUnlockService.displayPopUp('<center><img class="inb-error-sym" src="img/FT/BhimUpi/successSymbol.svg" /></center>', '<center class="inb-alert-header">File Downloaded to Internal Storage </center>', ["OK"], function () {
		               //utilityService.setCsatJournies('form16Info');
                       //$state.go('menu.innerPage');
          });
          /*
            var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="DOWNLOADFDRECEIPT" translate-values="{folderpath:pensionForm16BVM.folderpath}"></div>';
            pensionForm16BVM.downloadPopup = $ionicPopup.show({
                title: '',
                template: template,
                scope: $scope,
                cssClass: 'my-custom-popup',
                buttons: [{
                    text: 'OK',
                    type: 'button-assertive',
                    onTap: function () {
                        pensionForm16BVM.downloadPopup.close();
                        utilityService.setCsatJournies('pensionForm16B');
                        $state.go('menu.innerPage');
                    }
                }],
            });
          */
        }
        pensionForm16BVM.downloadLoader = false;
    };
    // Download receipt code ends

    function b64toBlob(b64Data, contentType, sliceSize) {
        contentType = contentType || '';
        sliceSize = sliceSize || 512;
        var byteCharacters = atob(b64Data);
        var byteArrays = [];
        for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
            var slice = byteCharacters.slice(offset, offset + sliceSize);
            var byteNumbers =[];
            for (var i = 0; i < slice.length; i++) {
                byteNumbers[i] = slice.charCodeAt(i);
            }
            var byteArray = new Uint8Array(byteNumbers);
            byteArrays.push(byteArray);
        }
        var blob = new Blob(byteArrays, {type: contentType});
        return blob;
    }

    function savebase64AsPDF(folderpath, filename, content, contentType, contentLen) {
        // Convert the base64 string in a Blob
        var DataBlob = b64toBlob(content, contentType);
        filename = filename + ".pdf";
        window.resolveLocalFileSystemURL(folderpath, function (dir) {
            dir.getFile(filename, { create: true }, function (file) {
                file.createWriter(function (fileWriter) {
                  if(contentLen < constantConfig.accOverview.pdfSize) {
                    fileWriter.write(DataBlob);
                  }
                }, function () {
                });
            });
        });
    }

    // Ionic popover coding
      var template = '<ion-popover-view class="loginnewarrow pensionForm16B-passpropopover" id="runtimeHeight" >'
                  + '<a class="iconsubtext closeinfobutton float-right"  id="CALL_ANC" click-stream="click" ng-click="pensionForm16BVM.goToPenslip()">'
                  + '<i class="pensionForm16B-icon-close ver-align-middle"></i>'
                  + '</a>'
                  + '<ion-content class="col-97" has-bouncing="false">'
				  
                  + '<strong><div translate="PensionForm16Pass" class="passeg pay-pos roboto-regular font-size-year font-bold" style="color:#FFFFFF!important;" ></div></strong>'
                  +'<table style="width: 100%;"><tr class="col-100">'
                  +'<td class="pensionForm16B-popover-explanation" style="width:25%;padding-left:3.5%;"><div style="display:inline;font-weight:bold;color:#000000!important;background-color:#C0C0C0!important;">05Mar</div>ch</td>'
                  +'<td class="pensionForm16B-popover-explanation " style="width:15%;text-align: right">+</td>'
                  +'<td class="pensionForm16B-popover-explanation " style="width:10%"><div style="display:inline;font-weight:bold;color:#000000!important;background-color:#C0C0C0!important;">&nbsp;!&nbsp;</div></td>'
                  +'<td class="pensionForm16B-popover-explanation" style="width:33%;">+&nbsp;&nbsp;&nbsp;9XXXXX<span class="pensionForm16B-password-example" style="color:#000000!important;">6047</span></td>'
                  +'</tr></table>'
                  +'<table style="margin-left:12px;"><tr>'
                  +'<td class="pensionForm16B-popover-explanation" style="width:33%" >Birth date and first 3 letters of birth month with first letter capital</td>'
                  +'<td class="pensionForm16B-popover-explanation" style="width:25%;padding-left: 4%;padding-right: 4%;">Mandatory <br>“ ! ” sign</td>'
                  +'<td class="pensionForm16B-popover-explanation" style="width:33%;" >Last 4 digits of the registered mobile number</td></tr></table>'
				
                  +'</ion-content>'
                  + '</ion-popover-view>';

    $scope.popover = $ionicPopover.fromTemplate(template, {
        scope: $scope
    });
    pensionForm16BVM.infoDetails = function($event) {
        pensionForm16BVM.showIndicator=true;
        $scope.popover.show($event);
    }
    pensionForm16BVM.goToPenslip = function(){
        pensionForm16BVM.showIndicator=false;
         $scope.popover.hide();
    }
    $scope.$on('popover.hidden', function() {
        // Execute action
        pensionForm16BVM.showIndicator=false;
    });

    // Execute action on remove popover
    $scope.$on('popover.removed', function() {
        pensionForm16BVM.showIndicator=false;
    });

    /*** Function to go Back to Previous screen  ***/
    pensionForm16BVM.goToback=function() {
        $state.go('menu.innerPage');
    }

    /*** Function to call getPensionAccountDetails  ***/
    $scope.$on('$ionicView.beforeEnter', function () {
        pensionForm16BVM.getPensionAccountDetails();
        pensionForm16BVM.showEmailDownload = false;
        //pensionForm16BVM.showForm16BMessage = false;
    });
        return this;
    }
]);
