'use strict';

angularApp.controller('pensionSlipController', ["$timeout",
    "$state",
    "$location",
    "$scope",
    "$rootScope",
    "ionicDatePicker",
    "customerInfoService",
    "utilityService",
    "$ionicPopup", "pensionSlipService", "AdapterUtils", "$q", "$ionicPopover", "inbLockUnlockService", "clickStreamService", "MonthPicker","openUrlInAppbroswerService",

    function ($timeout,
        $state,
        $location,
        $scope,
        $rootScope,
        ionicDatePicker,
        customerInfoService,
        utilityService,
        $ionicPopup,
        pensionSlipService, AdapterUtils, $q, $ionicPopover, inbLockUnlockService, clickStreamService, MonthPicker,openUrlInAppbroswerService) {

        var pensionSlipVm = this;
        pensionSlipVm.noRecordsFlag = false;
        pensionSlipVm.ppoNumFlag = true;
        pensionSlipVm.ppoError = false;
    


        pensionSlipVm.goToHome = function () {
            $state.go('menu.homeScreen');
        }
        pensionSlipVm.goToBack = function () {
            $state.go('menu.innerPage');
        }

        pensionSlipVm.getPPODetails = function (selectedObj) {


            selectedObj = JSON.parse(selectedObj);
            if (selectedObj.ppoDetails == "" || selectedObj.ppoDetails == null) {
                pensionSlipVm.noRecordsFlag = true;
            } else {
                pensionSlipService.selectedAccValue = selectedObj.accountNumber;
                pensionSlipVm.selectedPPONumber = "";
                pensionSlipVm.ppoList = [];
                pensionSlipVm.ppoList = selectedObj.ppoDetails;
                pensionSlipVm.showMoreDetail = true;
                pensionSlipVm.showMoreDetailPPO = false;
                pensionSlipVm.noRecordsFlag = false;
            }
        }

        pensionSlipVm.getPensionAccountDetails = function () {
            pensionSlipService.getPensionAccountDetails().then(function (data) {
                pensionSlipService.accList = data.accList;
                pensionSlipVm.accList = pensionSlipService.accList;
                
                if(pensionSlipService.accList.length == 1){
            pensionSlipVm.balance = pensionSlipVm.accList[0].availableBalance;
            pensionSlipVm.accountNumber = pensionSlipVm.accList[0].accountNumber;
            pensionSlipVm.accType = pensionSlipVm.accList[0].accountType;
            pensionSlipVm.selectedppoDetails = pensionSlipVm.accList[0].ppoDetails
            pensionSlipVm.ppoNumFlag = false;
            
                } 
            }, function (error) {
            if (error.responseCode == "cs002") {
            var comingsoonPopup = $ionicPopup.alert({
              template: '<div class="CSPadding font-dark-grey "><div class="parentCS"><img class="imgwidthCS" src="img/Coming_Soon_Illustration.svg"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="childCS">'
              + "Coming Soon" + '</div></div></div></div></div></div>',
              cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter custButtonCS button0pd',
              buttons: [
                {
                  text: 'OK',
                  type: 'button-positive',
                  onTap: function (e) {
                    comingsoonPopup.close();
                    $state.go('menu.homeScreen');
                  }
                }
              ]
            });
          } else {
            utilityService.showErrorMessage(error.responseMessage);
          }
                
            });
        }




        pensionSlipVm.infoDetails = function ($event) {
            var template = '<ion-popover-view class="loginnewarrow pens-pop-style" id="runtimeHeight" >' + '<div class="pens-arrow-upper"></div>' + '<ion-content class="col-100" scroll="false" style="top: 1% !important;margin: 0px !important;">' + '<strong><div><div translate="Pass" class="passeg pens-para pay-pos font-size-year" style="font-family: Roboto-Bold !important; border-bottom: 0.5px solid white !important;font-size: 14px !important;padding-top: 10px !important;"></div><span style="float: right !important;margin-top: -8% !important;margin-right: 3% !important; "ng-click="pensionSlipVm.goToPenslip()"><img src="img/closed.svg" class="" style="" id="CLS_BTN"></span></div></strong>' + '<div>' + '<span class="dobFirstDigit" style="background-color: #5553AA !important;text-decoration: underline;font-size: 12px !important;margin-left:9px !important;color: #FFFFFF !important;">05Mar</span>' + '<span style="float: left;font-size:12px !important;font-family: Roboto-Light;color: #FFFFFF !important;">ch</span>' + '<span class="firstPlusDigit" style="margin-left: 45px !important;font-family: Roboto-Light !important;font-size: 12px !important;color: #FFFFFF !important;">+</span>' + '<span class="excladigit" style="background-color: #5553AA !important;text-decoration: underline; margin-left: 12px !important;padding-left: 35px !important;font-family: Roboto-Bold !important;font-size: 12px !important;color: #FFFFFF !important;">!</span>' + '<span class="plusdigit" style="color: #FFFFFF !important;margin-left: 38px !important;font-family: Roboto-Light !important;font-size: 12px !important;">+</span>' + '<span class="mobxxdigit" style="padding-left:20px !important;;font-size: 12px !important;margin-left: 0px !important;color: #FFFFFF !important;">9xxxxx</span>' + '<span class="lastmobdigit" style="background-color: #5553AA !important;text-decoration: underline;font-size: 12px !important;color: #FFFFFF !important;">8899</span>' + '</div>' + '<div>' + '<table style="margin-left:12px; padding-top:8px;">' + '<tr>' + '<td class="tableForMsg width38" style="width: 119px !important;height: 42px !important;line-height: 14px;color: #FFFFFF !important;font-family: Roboto-Light !important;">Birth date and first 3 letters of birth month with first letter capital</td>' + '<td style=class="tableForMsg width8">' + '</td>' + '<td class="tableForMsg width20" width="20%" style="width: 57px !important;height: 28px !important;line-height: 14px;padding-left: 10px !important;color: #FFFFFF !important;font-family: Roboto-Light !important;">Mandatory “ ! ” sign</td>' + '<td style=class="tableForMsg width8">' + '</td>' + '<td class="tableForMsg width36" style="width: 119px !important;height: 42px !important;line-height: 14px;padding-left:12% !important;color: #FFFFFF !important;font-family: Roboto-Light !important;">Last 4 digits of the registered mobile number</td>' + '</tr>' + '</table>' + '</ion-content>' + '</ion-popover-view>';



        $scope.popover = $ionicPopover.fromTemplate(template, {
            scope: $scope
        });
            $scope.popover.show($event);
        }
        pensionSlipVm.goToPenslip = function () {
            $scope.popover.hide();
        }
        pensionSlipVm.sendEmail = function () {

        }
        pensionSlipVm.downloadPDF = function () {


        }

        $scope.$on('$ionicView.beforeEnter', function () {
            pensionSlipVm.currentDate = new Date();
            var month = pensionSlipVm.currentDate.getMonth() + 1;
            var year = pensionSlipVm.currentDate.getFullYear();

            if (month < 10) {
                month = "0" + month;
            }
            pensionSlipVm.month1 = year + '-' + month;

            pensionSlipVm.getPensionAccountDetails();
            pensionSlipVm.showMoreDetail = false;
            pensionSlipVm.showMoreDetailPPO = false;

        });


        function b64toBlob(b64Data, contentType, sliceSize) {
            contentType = contentType || '';
            sliceSize = sliceSize || 512;
            var byteCharacters = atob(b64Data);
            var byteArrays = [];
            for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
                var slice = byteCharacters.slice(offset, offset + sliceSize);
                var byteNumbers = [];
                for (var i = 0; i < slice.length; i++) {
                    byteNumbers[i] = slice.charCodeAt(i);
                }
                var byteArray = new Uint8Array(byteNumbers);
                byteArrays.push(byteArray);
            }
            var blob = new Blob(byteArrays, { type: contentType });
            return blob;
        }

        function savebase64AsPDF(folderpath, filename, content, contentType) {
            var DataBlob = b64toBlob(content, contentType);
            filename = filename + ".pdf";
            window.resolveLocalFileSystemURL(folderpath, function (dir) {
                dir.getFile(filename, { create: true }, function (file) {
                    file.createWriter(function (fileWriter) {
                        fileWriter.write(DataBlob);
                    }, function () {
                    });
                });
            });
        }



        pensionSlipVm.sendEmail = function () {
              if(pensionSlipVm.selectedPpoNumber == "" || pensionSlipVm.selectedPpoNumber == undefined){
                pensionSlipVm.ppoError = true;
                return false;
            }
            pensionSlipVm.mailLoader = true;
            pensionSlipVm.PpoNumber = pensionSlipVm.selectedPpoNumber;
            pensionSlipVm.ppoUniqueID = pensionSlipVm.ppoUniqueID
            pensionSlipVm.monthNames = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"];
            pensionSlipVm.monthsNum = pensionSlipVm.monthNames.indexOf(pensionSlipVm.month) + 1;

            var requestParams = {
                "accountNumber": pensionSlipVm.accountNumber,
                "ppo": pensionSlipVm.ppoUniqueID,
                "month": pensionSlipService.monthVal,
                "year": pensionSlipVm.year,
                "isEmail": "true"
            };

            pensionSlipService.getPensionSlipDetails(requestParams).then(function (data) {
                inbLockUnlockService.displayPopUp('<center><img class="inb-error-sym" src="img/FT/BhimUpi/successSymbol.svg" /></center>', '<center class="inb-alert-header">Pension Slip has been successfully Emailed to your registered Email ID.</center>', ["OK"], function () {
                    $state.go('menu.serviceRequest');
                });
                pensionSlipVm.mailLoader = false;
            }, function (error) {
                if (error.responseCode === "002") {
                    inbLockUnlockService.displayErrorPopUp('<img class="inb-error-icon" src="img/FT/BhimUpi/alertSymbol.svg" />',
                        '<center class="inb-alert-header">Your Email ID is not registered.Do you want to register Email ID now?</center>', ["Later", "Yes"], function () {
                              clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "PROCEED_BTN"));
                            $state.go('menu.homeScreen');
                        }, function () {
                            clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "PROCEED_BTN"));
                            $state.go('menu.emailDetails');
                        });
                }
                else if(error.responseCode === "003"){
                    pensionSlipVm.noRecordsFlag = true;
                }else{
                       inbLockUnlockService.displayPopUp('<center><img class="inb-error-sym" src="img/FT/BhimUpi/errorSymbol.svg" /><br><p class="inb-alert-header inb-mart-12"></p><center/>',
						error.responseMessage, ["OK"], function () {
							$state.go('menu.homeScreen');
						});
                }

                pensionSlipVm.mailLoader = false;
            });
        };


        pensionSlipVm.downloadPDF = function () {
            if(pensionSlipVm.selectedPpoNumber == "" || pensionSlipVm.selectedPpoNumber == undefined){
                pensionSlipVm.ppoError = true;
                return false;
            }
            pensionSlipVm.downloadLoader = true;
            var requestParams = {
                "accountNumber": pensionSlipVm.accountNumber,
                "ppo": pensionSlipVm.ppoUniqueID,
                "month": pensionSlipService.monthVal,
                "year": pensionSlipVm.year,
                "isEmail": "false"
            }

            pensionSlipService.getPensionSlipDetails(requestParams).then(function (data) {
                var content = data.pdf;
                var filename = data.fileName;
                var contentType = "application/pdf";
                if (utilityService.isAndroidPlatform()) {
                    pensionSlipVm.folderpath = cordova.file.externalRootDirectory;
                }
                if (utilityService.isIOSPlatform()) {
                    pensionSlipVm.folderpath = cordova.file.documentsDirectory;
                }
                savebase64AsPDF(pensionSlipVm.folderpath, filename, content, contentType);
                if (utilityService.isIOSPlatform()) {
                    filename = filename + ".pdf";
                    var finalObject = { "folderpath": pensionSlipVm.folderpath, "filename": filename };
                    openUrlInAppbroswerService.openUrl("data:application/pdf;base64," + content + "", "");
                }
                if (utilityService.isAndroidPlatform()) {
                    inbLockUnlockService.displayPopUp('<center><img class="inb-error-sym" src="img/FT/BhimUpi/successSymbol.svg" /></center>', '<center class="inb-alert-header">File Downloaded to Internal Storage </center>', ["OK"], function () {
                    $state.go('menu.pensionSlip');
                });
                }
                pensionSlipVm.downloadLoader = false;
            }, function (error) {
                if (error.responseCode === "003") {
                    pensionSlipVm.noRecordsFlag = true;
                } else {
                    pensionSlipVm.downloadLoader = false;
                     inbLockUnlockService.displayPopUp('<center><img class="inb-error-sym" src="img/FT/BhimUpi/errorSymbol.svg" /><br><p class="inb-alert-header inb-mart-12"></p><center/>',
						error.responseMessage, ["OK"], function () {
							$state.go('menu.homeScreen');
						});
                }
            });
        };
        
        pensionSlipVm.ChangePpoNum = function (selectedPpoNumber){
           pensionSlipVm.ppoUnique = JSON.parse(selectedPpoNumber);
           pensionSlipVm.ppoUniqueID = pensionSlipVm.ppoUnique.ppoUniqueID;
            if(pensionSlipVm.selectedPpoNumber){
                  pensionSlipVm.ppoError = false;
            }else{
                  pensionSlipVm.ppoError = true;
            }
        }

    

        pensionSlipVm.monthPicker = function () {
            MonthPicker.init({
                minYear: new Date().getFullYear() - 13,
                minMonthIndex : 9,
                monthLabels: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"]
            });
            MonthPicker.show(function (res) {
                pensionSlipVm.months = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
                if (res.month < 10) {
                    pensionSlipService.monthVal = "0" + (res.month + 1);
                } else {
                    pensionSlipService.monthVal = res.month + 1;
                }

                pensionSlipVm.month = pensionSlipVm.months[res.month];

                pensionSlipVm.year = res.year;
            });
        };
      
        pensionSlipVm.showPop = function () {
            if (pensionSlipVm.accList && pensionSlipVm.accList.length > 0) {
                pensionSlipVm.popUp = $ionicPopup.show({
                    title: '',
                    cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
                    templateUrl: 'pages/nfs/pensionSlip/dropDown.html',
                    scope: $scope
                });
            }
        }

        pensionSlipVm.close = function (index) {
            pensionSlipVm.popUp.close();
            pensionSlipVm.selectedPpoNumber = "";
            pensionSlipVm.showSelect = false;
            pensionSlipVm.ppoNumFlag = false;
            pensionSlipVm.balance = pensionSlipVm.accList[index].availableBalance;
            pensionSlipVm.accountNumber = pensionSlipVm.accList[index].accountNumber;
            pensionSlipVm.accType = pensionSlipVm.accList[index].accountType;
            pensionSlipVm.selectedppoDetails = pensionSlipVm.accList[index].ppoDetails
            pensionSlipVm.ppoUniqueID = pensionSlipVm.selectedppoDetails[index].ppoUniqueID;

        }
        return this;
    }
]);
