'use strict';

angularApp.controller('ppsChequeDetailsController', ["$timeout",
    "$state",
    "$location",
    "$scope",
    "$rootScope",
    "customerInfoService",
    "utilityService",
    "$ionicPopup",
    "chequeDepositsService",
    "AdapterUtils",
    "$q",
    "$ionicPopover",
    "$filter",
    "$ionicHistory",
    "getAccountDetailsService",
    "ionicDatePicker",
    "homeScreenService",
    "ppsServices",
    function ($timeout,
        $state,
        $location,
        $scope,
        $rootScope,
        customerInfoService,
        utilityService,
        $ionicPopup,
        chequeDepositsService,
        AdapterUtils,
        $q,
        $ionicPopover,
        $filter,
        $ionicHistory,
        getAccountDetailsService,
        ionicDatePicker,
        homeScreenService,
        ppsServices) {

        var ppsChequeDetailsControllerVm = this;
        ppsChequeDetailsControllerVm.validateChequeDate = false;
        ppsChequeDetailsControllerVm.validateChequeNo = false;
        ppsChequeDetailsControllerVm.validateChequeAmount = false;
        ppsChequeDetailsControllerVm.validateBenName = false;
        ppsChequeDetailsControllerVm.validateInstrumentType = false;
        ppsChequeDetailsControllerVm.validateAccount = false;
        ppsChequeDetailsControllerVm.checkEligibilityErr="";

        //Account list selectionEnd

        ppsChequeDetailsControllerVm.getAccountList = function () {

            if (!getAccountDetailsService.accountOverviewData) {
                utilityService.showSpinner();
                homeScreenService.getCustomerInfo().then(function (data) {
                    utilityService.hideSpinner();
                    getAccountDetailsService.accountOverviewData = data;
                    ppsChequeDetailsControllerVm.accDetails = getAccountDetailsService.accountOverviewData.accounts;
                    if (ppsChequeDetailsControllerVm.accDetails.length == 0) {
                        ppsServices.displayPopUp("", "padBtm25 top-padding26", "No Accounts available", "OK", function () {
                            $state.go('menu.homeScreen');
                        });
                    }
                    ppsChequeDetailsControllerVm.setPrimaryAccount();
                    

                }, function (error) {
                    utilityService.hideSpinner();
                });
            } else {

                ppsChequeDetailsControllerVm.accDetails = getAccountDetailsService.accountOverviewData.accounts;
                if (ppsChequeDetailsControllerVm.accDetails.length == 0) {
                    ppsServices.displayPopUp("", "padBtm25 top-padding26", "No Accounts available", "OK", function () {
                        $state.go('menu.homeScreen');
                    });
                }
                ppsChequeDetailsControllerVm.setPrimaryAccount();

            }




        }

        ppsChequeDetailsControllerVm.setPrimaryAccount = function () {

            if (getAccountDetailsService.accountOverviewData.customerInformation.accountNumber) {
                var arr = ppsChequeDetailsControllerVm.accDetails;
                
                for (var i = 0; i < arr.length; i++) {
                    if (arr[i].accountNumber == getAccountDetailsService.accountOverviewData.customerInformation.accountNumber) {
                        var topElement = ppsChequeDetailsControllerVm.accDetails[i];
                        ppsChequeDetailsControllerVm.close(i);
                        if (ppsChequeDetailsControllerVm.accDetails.indexOf(topElement) > 0) {
                            ppsChequeDetailsControllerVm.accDetails.splice(ppsChequeDetailsControllerVm.accDetails.indexOf(topElement), 1);
                            ppsChequeDetailsControllerVm.accDetails.unshift(topElement);
                        }else{}
                    }
                }


            } else {

                var arrAccount = ppsChequeDetailsControllerVm.accDetails;
                
                var max = 0;
                var maxAccNo = 0;  var maxBal=0;  
                for (var k=0 ; k<arrAccount.length ; k++) {
                if (maxBal == 0 || parseInt(arrAccount[k].accountBalance) > parseInt(maxBal)){
                    max = arrAccount[k].accountNumber;
                    maxBal = arrAccount[k].accountBalance;
                }
                }
                maxAccNo = max;
                for (var j = 0; j < arrAccount.length; j++) {
                    if (arrAccount[j].accountNumber == maxAccNo) {
                        var topElement_Max = ppsChequeDetailsControllerVm.accDetails[j];
                        ppsChequeDetailsControllerVm.close(j);
                        if (ppsChequeDetailsControllerVm.accDetails.indexOf(topElement_Max) > 0) {
                            ppsChequeDetailsControllerVm.accDetails.splice(ppsChequeDetailsControllerVm.accDetails.indexOf(topElement_Max), 1);
                            ppsChequeDetailsControllerVm.accDetails.unshift(topElement_Max);
                        }else{}
                    }
                }
              
        }


        }

        // Check customer eligibility
        ppsChequeDetailsControllerVm.customerEligibility = function () {
            var reqData ={
                "accountNumber": ppsChequeDetailsControllerVm.accountNumber
            }
             ppsServices.customerEligibility(reqData).then(function (data) {
                     ppsChequeDetailsControllerVm.checkEligibilityErr = "";
                     ppsChequeDetailsControllerVm.validateAccount = false;
                     ppsChequeDetailsControllerVm.instrumentTypes = data.instrumentType;
                 
             }, function (error) {
                 ppsChequeDetailsControllerVm.validateAccount = true;
                 ppsChequeDetailsControllerVm.checkEligibilityErr = error.responseMessage;
             });
           //ppsChequeDetailsControllerVm.instrumentTypes = ["29", "30"];
        };

        ppsChequeDetailsControllerVm.showPop = function () {
            if (ppsChequeDetailsControllerVm.accDetails.length > 1) {
                ppsChequeDetailsControllerVm.popUp = $ionicPopup.show({
                    title: '',
                    cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll yonoWeableBackdrop',
                    templateUrl: 'pages/nfs/positivePaymentSystem/accListDropdown.html',
                    scope: $scope
                });
            }

        }


        ppsChequeDetailsControllerVm.close = function (index) {
           
            if (ppsChequeDetailsControllerVm.popUp) {
                ppsChequeDetailsControllerVm.popUp.close();
            }

            ppsChequeDetailsControllerVm.balance = ppsChequeDetailsControllerVm.accDetails[index].accountBalance;
            ppsChequeDetailsControllerVm.accType = ppsChequeDetailsControllerVm.accDetails[index].accountType;
            ppsChequeDetailsControllerVm.accountNumber = ppsChequeDetailsControllerVm.accDetails[index].accountNumber;
            ppsChequeDetailsControllerVm.isActive = ppsChequeDetailsControllerVm.accDetails[index].isActive;
            ppsChequeDetailsControllerVm.isTransactional = ppsChequeDetailsControllerVm.accDetails[index].isTransactional;
            ppsChequeDetailsControllerVm.showSelect = false;

            ppsChequeDetailsControllerVm.customerEligibility();

        }

        ppsChequeDetailsControllerVm.goToNext = function () {

            if (ppsChequeDetailsControllerVm.chequeDate == null || ppsChequeDetailsControllerVm.chequeDate == undefined) {
                ppsChequeDetailsControllerVm.validateChequeDate = true;
            } else if (ppsChequeDetailsControllerVm.chequeNo == "" || ppsChequeDetailsControllerVm.chequeNo == undefined) {
                ppsChequeDetailsControllerVm.validateChequeNo = true;
            } else if (ppsChequeDetailsControllerVm.chequeAmount == "" || ppsChequeDetailsControllerVm.chequeAmount == undefined || parseFloat(ppsChequeDetailsControllerVm.chequeAmount) < 1 || parseFloat(ppsChequeDetailsControllerVm.chequeAmount) > 999999999.99) {
                ppsChequeDetailsControllerVm.validateChequeAmount = true;
            } else if (ppsChequeDetailsControllerVm.benName == "" || ppsChequeDetailsControllerVm.benName == undefined) {
                ppsChequeDetailsControllerVm.validateBenName = true;
            } else if (ppsChequeDetailsControllerVm.instrumentType == "" || ppsChequeDetailsControllerVm.instrumentType == undefined) {
                ppsChequeDetailsControllerVm.validateInstrumentType = true;
            } else {
                ppsServices.chequedetailsData.accountNumber = ppsChequeDetailsControllerVm.accountNumber;
                ppsServices.chequedetailsData.chequeDate = ppsChequeDetailsControllerVm.chequeDate;
                ppsServices.chequedetailsData.chequeNumber = ppsChequeDetailsControllerVm.chequeNo;
                ppsServices.chequedetailsData.amount = ppsChequeDetailsControllerVm.chequeAmount;
                ppsServices.chequedetailsData.benName = ppsChequeDetailsControllerVm.benName;
                ppsServices.chequedetailsData.instrumentType = ppsChequeDetailsControllerVm.instrumentType;
                ppsServices.chequeNumber = ppsChequeDetailsControllerVm.chequeNo;
                $state.go('menu.ppsChequeReview');
            }
        }



        

        ppsChequeDetailsControllerVm.openDatePicker = function () {
            ionicDatePicker.openDatePicker(ppsChequeDetailsControllerVm.dateObj);
             ppsChequeDetailsControllerVm.validateChequeDate = false;
        };

        ppsChequeDetailsControllerVm.dateObj = {
            callback: function (val) {
                ppsChequeDetailsControllerVm.chequeDate = new Date(val);

            },
            inputDate: new Date(),
            from: new Date().setDate((new Date).getDate() - 90), // from:(new Date().setYear(new Date().getFullYear() - 120)) --for help
            to: (new Date().setYear(new Date().getFullYear() + 1)),
            mondayFirst: true,
            closeOnSelect: false,
            templateType: 'popup',
            dateFormat: 'dd/MM/yyyy'
        };

        ppsChequeDetailsControllerVm.goToPrevious = function () {
            $state.go("menu.positivePayment");
        }

         /* Info Popup */

         ppsChequeDetailsControllerVm.openChequeInfo = function ($event) {
            ppsChequeDetailsControllerVm.leftStyle = "left : " + ($event.clientX - 10) + "px";           
            ppsChequeDetailsControllerVm.template = '<ion-popover-view class="loginnewarrow hmbr-info chequedetails-info-popnew-pps chequedetailsInfoPopup-rlms" id="runtimeHeight">'+ 
                '<div class="chequedetails-arrow-upnew-rlms" style="{{ppsChequeDetailsControllerVm.leftStyle}}"></div>'+'<div class="padBottom3"><span class="inb-lock-roboto-bold font-size-14">' +
                '<img  alt="infoicon" class="chequedetails_img_pps" src="img/cheque.jpg"/></span>' + '</div></ion-popover-view>';
            $scope.popover = $ionicPopover.fromTemplate(ppsChequeDetailsControllerVm.template, {
                scope: $scope
            });
            $scope.popover.show($event);   
        };

        ppsChequeDetailsControllerVm.closePopover = function(){
            $scope.popover.hide();
            $ionicScrollDelegate.resize();
        }
   
        
        $scope.$on('$ionicView.beforeEnter', function () {
            ppsChequeDetailsControllerVm.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            ppsChequeDetailsControllerVm.getAccountList();
            // ppsChequeDetailsControllerVm.getInstrumentList();
            if (Object.keys(ppsServices.chequedetailsData).length !== 0 ) {
                ppsChequeDetailsControllerVm.accountNumber = ppsServices.chequedetailsData.accountNumber;
                ppsChequeDetailsControllerVm.chequeDate = ppsServices.chequedetailsData.chequeDate;
                ppsChequeDetailsControllerVm.chequeNo = ppsServices.chequedetailsData.chequeNumber;
                ppsChequeDetailsControllerVm.chequeAmount = ppsServices.chequedetailsData.amount;
                ppsChequeDetailsControllerVm.benName = ppsServices.chequedetailsData.benName;
                ppsChequeDetailsControllerVm.instrumentType = ppsServices.chequedetailsData.instrumentType;

                for (var k = 0; k< ppsChequeDetailsControllerVm.accDetails.length ; k++) {
                    if (tempAccNo[k].accountNumber == ppsChequeDetailsControllerVm.accountNumberr) {
                        
                        ppsChequeDetailsControllerVm.close(k);
                    }
                }
            }
        });

        return this;
    }
]);
