'use strict';

angularApp.controller('ppsChequeReviewController', ["$timeout",
    "$state",
    "$location",
    "$scope",
    "$rootScope",
    "customerInfoService",
    "utilityService",
    "$ionicPopup",
    "chequeDepositsService",
    "AdapterUtils",
    "$q",
    "$ionicPopover",
    "$filter",
    "$ionicHistory",
    "getAccountDetailsService",
    "ionicDatePicker",
    "homeScreenService",
    "ppsServices",
    function ($timeout,
        $state,
        $location,
        $scope,
        $rootScope,
        customerInfoService,
        utilityService,
        $ionicPopup,
        chequeDepositsService,
        AdapterUtils,
        $q,
        $ionicPopover,
        $filter,
        $ionicHistory,
        getAccountDetailsService,
        ionicDatePicker,
        homeScreenService,
        ppsServices) {

        var ppsChequeReviewControllerVm = this;
        ppsChequeReviewControllerVm.isAccountMasked = false;
        ppsChequeReviewControllerVm.isChecked = false;
        ppsChequeReviewControllerVm.isCheckedValidate = false;

        ppsChequeReviewControllerVm.eyesOnFun = function (accNo) {
            ppsChequeReviewControllerVm.isAccountMasked = false;
            ppsChequeReviewControllerVm.accountNo = ppsChequeReviewControllerVm.accNo;
        }

        ppsChequeReviewControllerVm.eyesOffFun = function (accNo) {
            ppsChequeReviewControllerVm.isAccountMasked = true;
            ppsChequeReviewControllerVm.accNo = accNo;
            ppsChequeReviewControllerVm.maskedAccNo = utilityService.maskData(accNo, "front", 4);
        }

        ppsChequeReviewControllerVm.getCBValue = function (_check) {

            if (_check == true) {
                ppsChequeReviewControllerVm.isChecked = true;
                ppsChequeReviewControllerVm.isCheckedValidate = false;
                ppsServices.chequedetailsData.timestamp = new Date().toString();
            } else {
                ppsChequeReviewControllerVm.isChecked = false;
                ppsChequeReviewControllerVm.isCheckedValidate = true;
            }

        }

        ppsChequeReviewControllerVm.showTermsAndConditions = function () {
            ppsChequeReviewControllerVm.myPopup = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark yonoWeableBackdrop',
                templateUrl: "pages/nfs/positivePaymentSystem/ppsTnCPopup.html",
                scope: $scope
            });
        }

        ppsChequeReviewControllerVm.goToNext = function () {
            if (ppsChequeReviewControllerVm.isChecked) {
                ppsChequeReviewControllerVm.isCheckedValidate = false;
                ppsServices.chequedetailsData.consent = "true";
                $state.go("menu.ppsOTPPage", { action: 'make_request' });
            } else {
                ppsServices.chequedetailsData.consent = "false";
                ppsChequeReviewControllerVm.isCheckedValidate = true;
            }

        }

        ppsChequeReviewControllerVm.goToPrevious = function () {
            $ionicHistory.goBack();
        }

        ppsChequeReviewControllerVm.fetchTermsAndConditions = function () {
             ppsServices.termsAndConditions().then(function (data) {
                ppsChequeReviewControllerVm.tncData = data;
                
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

         ppsChequeReviewControllerVm.closePopUp = function(){
             ppsChequeReviewControllerVm.myPopup.close();
         }

        $scope.$on('$ionicView.beforeEnter', function () {
            ppsChequeReviewControllerVm.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            if (Object.keys(ppsServices.chequedetailsData).length !== 0) {
                ppsChequeReviewControllerVm.accountNo = ppsServices.chequedetailsData.accountNumber;
                ppsChequeReviewControllerVm.eyesOffFun(ppsChequeReviewControllerVm.accountNo);
                ppsChequeReviewControllerVm.chequeNo = ppsServices.chequedetailsData.chequeNumber;
                ppsChequeReviewControllerVm.chequeDate = ppsServices.chequedetailsData.chequeDate;
                ppsChequeReviewControllerVm.chequeAmount = ppsServices.chequedetailsData.amount;
                ppsChequeReviewControllerVm.benName = ppsServices.chequedetailsData.benName;
                ppsChequeReviewControllerVm.instrumentType = ppsServices.chequedetailsData.instrumentType;
            }
            ppsChequeReviewControllerVm.fetchTermsAndConditions();

        });

        return this;
    }
]);
