'use strict';

angularApp.controller('ppsCommonOTPController', ["$timeout",
     "$state",
     "$location",
     "$scope",
     "$rootScope",
     "customerInfoService",
     "utilityService",
     "$ionicPopup",
     "chequeDepositsService",
     "AdapterUtils",
     "$q",
     "$ionicPopover",
     "$filter",
     "$ionicHistory",
     "getAccountDetailsService",
     "ionicDatePicker",
     "homeScreenService",
     "ppsServices",
     "$ionicViewSwitcher",
     "autoOtpReadService",
     "loggedInUserService",
     "cryptoService",
     function ($timeout,
          $state,
          $location,
          $scope,
          $rootScope,
          customerInfoService,
          utilityService,
          $ionicPopup,
          chequeDepositsService,
          AdapterUtils,
          $q,
          $ionicPopover,
          $filter,
          $ionicHistory,
          getAccountDetailsService,
          ionicDatePicker,
          homeScreenService,
          ppsServices,
          $ionicViewSwitcher,
          autoOtpReadService,
          loggedInUserService,
          cryptoService) {

          var ppsCommonOTPVm = this;
          ppsCommonOTPVm.isOTPRequired = false;
          ppsCommonOTPVm.resendOTPCout = 1;
          ppsCommonOTPVm.otpErrorMsg = "";
          ppsCommonOTPVm.selectedType = ppsServices.selectedType;
          var token = loggedInUserService.tokenLotus;

          ppsCommonOTPVm.custMobNo = customerInfoService.customer ? customerInfoService.customer.mobile : "";

          ppsCommonOTPVm.otpValidate = function () {
               var otp = ppsCommonOTPVm.otp1 + ppsCommonOTPVm.otp2 + ppsCommonOTPVm.otp3 + ppsCommonOTPVm.otp4 + ppsCommonOTPVm.otp5 + ppsCommonOTPVm.otp6;
               if (!otp) {
                    ppsCommonOTPVm.isOTPRequired = true;
                    ppsCommonOTPVm.otpErrorMsg = "Please enter OTP";
               } else if (otp.length >= 1 && otp.length < 6) {
                    ppsCommonOTPVm.isOTPRequired = true;
                    ppsCommonOTPVm.otpErrorMsg = "Please enter 6 digits OTP";
               } else {
                    ppsCommonOTPVm.isOTPRequired = false;
                    ppsCommonOTPVm.validate(otp);
                    //$state.go("menu.ppsCommonSuccessView");
               }
          }

          ppsCommonOTPVm.validate = function (otp) {
               var reqParams = {};
               reqParams["otp"] = otp;
               reqParams["mobile"] = ppsCommonOTPVm.custMobNo;
               ppsServices.validateOTP(reqParams).then(function (data) {
                    //$state.go("menu.ppsCommonSuccessView");
                    ppsCommonOTPVm.successScenario();
               }, function (error) {
                    ppsCommonOTPVm.setFields('clear');
                    utilityService.showErrorMessage(error.responseMessage);
               });
          }

          ppsCommonOTPVm.successScenario = function () {
               ppsCommonOTPVm.selectedAccNo = ppsServices.ppsDetails.selectedAccNo;
               var reqParams = {};
               var url = "";

               if (ppsCommonOTPVm.selectedType === "regiAcc" || ppsCommonOTPVm.selectedType === "changeAccLmt") {
                    if (ppsCommonOTPVm.selectedType === "regiAcc") {
                         url = "registerAccountsForPPS";
                         reqParams = {
                              "accountNumber": ppsServices.ppsDetails.selectedAccNo.toString(),
                              "limitAmount": ppsServices.ppsDetails.newAmtLmt.toString(),
                              "hash": (cryptoService.getSHA512EncryptedData(token + ppsServices.ppsDetails.selectedAccNo + ppsServices.ppsDetails.newAmtLmt)).toString(),
                              "consent": "true"
                         };
                    } else {
                         url = "changeLimit";
                         reqParams = {
                              "accountNumber": ppsServices.ppsDetails.selectedAccNo.toString(),
                              "limitAmount": ppsServices.ppsDetails.newAmtLmt.toString(),
                              "hash": (cryptoService.getSHA512EncryptedData(token + ppsServices.ppsDetails.selectedAccNo + ppsServices.ppsDetails.newAmtLmt)).toString()
                         };
                    }

               } else {
                    reqParams = {
                         "accountNumber": ppsServices.ppsDetails.selectedAccNo.toString(),
                         "hash": (cryptoService.getSHA512EncryptedData(token + ppsServices.ppsDetails.selectedAccNo)).toString()
                    };
                    url = "deRegisterAccountsForPPS";
               }
               ppsServices.commonService(reqParams, url).then(function (data) {
                    ppsServices.ppsDetails.refNumber = data.jrnlNumber;
                    ppsServices.ppsDetails.limitAmount = data.limitAmount;
                    $state.go("menu.ppsCommonSuccessView");
               }, function (error) {
                    utilityService.showBhimUpiAlert("error", error.responseMessage, "menu.positivePayment", "OK", $scope);
               });
          }

          ppsCommonOTPVm.setFields = function (type) {
               if (type === 'clear') {
                    ppsCommonOTPVm.otp1 = '';
                    ppsCommonOTPVm.otp2 = '';
                    ppsCommonOTPVm.otp3 = '';
                    ppsCommonOTPVm.otp4 = '';
                    ppsCommonOTPVm.otp5 = '';
                    ppsCommonOTPVm.otp6 = '';
               }
               else {
                    ppsCommonOTPVm.otp1 = $rootScope.otpReadData.otp1;
                    ppsCommonOTPVm.otp2 = $rootScope.otpReadData.otp2;
                    ppsCommonOTPVm.otp3 = $rootScope.otpReadData.otp3;
                    ppsCommonOTPVm.otp4 = $rootScope.otpReadData.otp4;
                    ppsCommonOTPVm.otp5 = $rootScope.otpReadData.otp5;
                    ppsCommonOTPVm.otp6 = $rootScope.otpReadData.otp6;
               }
          }

          ppsCommonOTPVm.resendOTP = function () {
               ppsCommonOTPVm.setFields('clear');
               if (!ppsCommonOTPVm.isDisabledOTPbtn) {
                    var reqParams = {
                         "id": ppsCommonOTPVm.custMobNo
                    };
                    ppsServices.generateOTP(reqParams).then(function (data) {
                         if (ppsCommonOTPVm.resendOTPCout != 2) {
                              ppsCommonOTPVm.resendOTPCout = ppsCommonOTPVm.resendOTPCout + 1;
                         } else {
                              ppsCommonOTPVm.isDisabledOTPbtn = true;
                         }
                         if (utilityService.isAndroidPlatform()) {
                              autoOtpReadService.startOtpReading().then(function (result) {
                                   ppsCommonOTPVm.setFields('');
                              }, function (error) {
                                   console.log(error);
                              });
                         }
                    }, function (error) {
                         utilityService.showErrorMessage(error.responseMessage);
                    });
               }
          }

          ppsCommonOTPVm.generateOTP = function () {
               var reqObj = {
                    "id": ppsCommonOTPVm.custMobNo
               }
               ppsServices.generateOTP(reqObj).then(function (data) {
                    if (utilityService.isAndroidPlatform()) {
                         autoOtpReadService.startOtpReading().then(function (result) {
                              regOTPControllerVm.setFields('');
                         }, function (error) {
                              console.log(error);
                         });
                    }
               });
          }

          $scope.$on('$ionicView.beforeEnter', function () {
               ppsCommonOTPVm.setFields('clear');
               ppsCommonOTPVm.generateOTP();
          });

          ppsCommonOTPVm.closeOTP = function () {
               $ionicViewSwitcher.nextDirection('back');
               $state.go("menu.ppsCommonView");
          }

          return this;
     }
]);
