'use strict';

angularApp.controller('ppsCommonViewController', ["$timeout",
     "$state",
     "$location",
     "$scope",
     "$rootScope",
     "customerInfoService",
     "utilityService",
     "$ionicPopup",
     "chequeDepositsService",
     "AdapterUtils",
     "$q",
     "$ionicPopover",
     "$filter",
     "$ionicHistory",
     "getAccountDetailsService",
     "ionicDatePicker",
     "homeScreenService",
     "ppsServices",
     "$ionicViewSwitcher",
     "cryptoService",
     "loggedInUserService",
     function ($timeout,
          $state,
          $location,
          $scope,
          $rootScope,
          customerInfoService,
          utilityService,
          $ionicPopup,
          chequeDepositsService,
          AdapterUtils,
          $q,
          $ionicPopover,
          $filter,
          $ionicHistory,
          getAccountDetailsService,
          ionicDatePicker,
          homeScreenService,
          ppsServices,
          $ionicViewSwitcher,
          cryptoService,
          loggedInUserService) {

          var ppsCommonViewVm = this;
          ppsCommonViewVm.selectedType = ppsServices.selectedType;
          ppsCommonViewVm.isChecked = false;
          ppsCommonViewVm.isCheckedValidate = false;
          ppsCommonViewVm.isAmtError = false;
          ppsCommonViewVm.checkEligibilityErr = "";
          ppsCommonViewVm.isValidAccount = false;
          ppsCommonViewVm.currentAccLimit = "";
          var token = loggedInUserService.tokenLotus;
          ppsCommonViewVm.tncData = "";

          ppsCommonViewVm.showPop = function () {
               if (ppsCommonViewVm.accDetails.length > 1) {
                    ppsCommonViewVm.popUp = $ionicPopup.show({
                         title: '',
                         cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll yonoWeableBackdrop',
                         templateUrl: 'pages/nfs/positivePaymentSystem/commonAccList.html',
                         scope: $scope
                    });
               }

          }

          ppsCommonViewVm.customerEligibility = function () {
               var reqData = {
                    "accountNumber": ppsCommonViewVm.accountNumber
               }
               ppsServices.customerEligibility(reqData).then(function (data) {
                    ppsCommonViewVm.checkEligibilityErr = "";
                    ppsCommonViewVm.isValidAccount = false;
                    if (ppsCommonViewVm.selectedType === "changeAccLmt") { 
                         ppsCommonViewVm.enquiry(); 
                    }else{
                         utilityService.hideSpinner();
                    }

               }, function (error) {
                    utilityService.hideSpinner();
                    ppsCommonViewVm.isValidAccount = true;
                    ppsCommonViewVm.checkEligibilityErr = error.responseMessage ? error.responseMessage : error;
               });
          };

          ppsCommonViewVm.enquiry = function () {
               utilityService.showSpinner();
               var reqData = {
                    "accountNumber": ppsCommonViewVm.accountNumber.toString(),
                    "hash": (cryptoService.getSHA512EncryptedData(token + ppsCommonViewVm.accountNumber)).toString()
               }
               ppsServices.enquiry(reqData).then(function (data) {
                    utilityService.hideSpinner();
                    ppsCommonViewVm.currentAccLimit = data.limitAmount;
               }, function (error) {
                    utilityService.hideSpinner();
                    ppsCommonViewVm.currentAccLimit = "";
                    //utilityService.showErrorMessage(error.responseMessage);
               });
          };

          ppsCommonViewVm.showTnC = function () {
               var reqParas = {
                    type: "ppsRegistrationTnC"
               };
               if (!ppsCommonViewVm.tncData) {
                    ppsServices.ppsCommonTnC(reqParas).then(function (data) {
                         ppsCommonViewVm.tncData = data.replace("<ol>","<ol class='tnc_popup_txt1_ol' style='list-style: inside;'>").replace(new RegExp("<li>","g"),"<li class='tnc_popup_txt1_ol_li'>");
                         ppsCommonViewVm.showTnCPopup();
                    }, function (error) {
                         utilityService.showErrorMessage(error.responseMessage);
                    });
               }else{
                    ppsCommonViewVm.showTnCPopup();
               }
          }

          ppsCommonViewVm.showTnCPopup = function(){
               ppsCommonViewVm.tncPopup = $ionicPopup.show({
                    title: '',
                    cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll yonoWeableBackdrop',
                    templateUrl: 'pages/nfs/positivePaymentSystem/ppsCommon/pps_setLmt_tnc.html',
                    scope: $scope
               });
          }

          ppsCommonViewVm.closePopUp = function () {
               ppsCommonViewVm.tncPopup.close();
          }

          ppsCommonViewVm.setPrimaryAccount = function () {
               utilityService.showSpinner();
               if (getAccountDetailsService.accountOverviewData.customerInformation.accountNumber) {
                    var accList = ppsCommonViewVm.accDetails;
                    for (var i = 0; i < accList.length; i++) {
                         if (accList[i]["accountNumber"] == getAccountDetailsService.accountOverviewData.customerInformation.accountNumber) {
                              var topElement = ppsCommonViewVm.accDetails[i];
                              ppsCommonViewVm.close(i, accList[i]);
                              if (ppsCommonViewVm.accDetails.indexOf(topElement) >= 0) {
                                   ppsCommonViewVm.accDetails.splice(ppsCommonViewVm.accDetails.indexOf(topElement), 1);
                                   ppsCommonViewVm.accDetails.unshift(topElement);
                              }
                         }
                    }
               }else{
                    var arrAccount = ppsCommonViewVm.accDetails;
                    var max = 0;
                    var maxAccNo = 0;  var maxBal=0;  
                    for (var k=0 ; k<arrAccount.length ; k++) {
                         if (maxBal == 0 || parseInt(arrAccount[k].accountBalance) > parseInt(maxBal)){
                              max = arrAccount[k].accountNumber;
                              maxBal = arrAccount[k].accountBalance;
                         }
                    }
                    maxAccNo = max;
                    for (var j = 0; j < arrAccount.length; j++) {
                         if (arrAccount[j].accountNumber == maxAccNo) {
                              var topElement_Max = ppsCommonViewVm.accDetails[j];
                              ppsCommonViewVm.close(j, arrAccount[j]);
                              if (ppsCommonViewVm.accDetails.indexOf(topElement_Max) >= 0) {
                                   ppsCommonViewVm.accDetails.splice(ppsCommonViewVm.accDetails.indexOf(topElement_Max), 1);
                                   ppsCommonViewVm.accDetails.unshift(topElement_Max);
                              }
                         }
                    }
               }
               
          }

          ppsCommonViewVm.close = function (index, obj) {
               if (ppsCommonViewVm.popUp) {
                    ppsCommonViewVm.popUp.close();
               }

               ppsCommonViewVm.balance = obj.accountBalance;
               ppsCommonViewVm.accType = obj.accountType;
               ppsCommonViewVm.accountNumber = obj.accountNumber;
               ppsCommonViewVm.isActive = obj.isActive;
               ppsCommonViewVm.isTransactional = obj.isTransactional;
               ppsCommonViewVm.customerEligibility();
               
          }

          ppsCommonViewVm.getAccountList  = function(){
               if (!getAccountDetailsService.accountOverviewData) {
                    utilityService.showSpinner();
                    homeScreenService.getCustomerInfo().then(function (data) {
                         utilityService.hideSpinner();
                         getAccountDetailsService.accountOverviewData = data;
                         ppsCommonViewVm.accDetails = getAccountDetailsService.accountOverviewData.accounts;
                         ppsCommonViewVm.setPrimaryAccount();
                         

                    }, function (error) {
                         utilityService.hideSpinner();
                    });
               } else {
                    ppsCommonViewVm.accDetails = getAccountDetailsService.accountOverviewData.accounts;
                    ppsCommonViewVm.setPrimaryAccount();

               }
          }
         

          $scope.$on('$ionicView.beforeEnter', function () {
               ppsCommonViewVm.getAccountList();
                   
          });

          ppsCommonViewVm.goToNext = function () {
               ppsServices.ppsDetails = {
                    selectedAccNo: ppsCommonViewVm.accountNumber,
                    newAmtLmt: ppsCommonViewVm.amountLmt ? ppsCommonViewVm.amountLmt : ""
               };
               if (ppsCommonViewVm.selectedType === "deregiAcc") {
                    var message = "<div class='pps_lbl_dereg_info1' translate='PPS_DE_REG_ACC_CONFIRM_INFO1'></div><div class='pps_lbl_dereg_info2' translate='PPS_DE_REG_ACC_CONFIRM_INFO2'></div>";
                    utilityService.showBhimUpiAlert("info", message, "menu.ppsCommonOTPView", "OK", $scope);
               } else {
                    ppsCommonViewVm.validation();
               }
          }

          ppsCommonViewVm.validation = function () {
               var maxAmount = "999999999.99"
               var minAmount = "1.00";
               
               if(ppsCommonViewVm.checkEligibilityErr === ""){
                    if(ppsCommonViewVm.selectedType === "changeAccLmt" && ppsCommonViewVm.currentAccLimit === ""){
                         utilityService.showBhimUpiAlert("error", "PPS service is not allowed for this account under YONO", "menu.positivePayment", "OK", $scope);
                    }else{
                         if (ppsCommonViewVm.amountLmt && (parseFloat(ppsCommonViewVm.amountLmt) >= minAmount && parseFloat(ppsCommonViewVm.amountLmt) <= parseFloat(maxAmount))) {
                              ppsCommonViewVm.isAmtError = false;
                              if (ppsCommonViewVm.selectedType === "changeAccLmt") {
                                   $state.go('menu.ppsCommonReview')
                              } else {
                                   if (!ppsCommonViewVm.isChecked) {
                                        ppsCommonViewVm.isCheckedValidate = true;
                                   } else {
                                        ppsCommonViewVm.isCheckedValidate = false;
                                        $state.go('menu.ppsCommonOTPView');
                                   }
                              }
                         } else {
                              ppsCommonViewVm.isAmtError = true;
                         }
                    }
               }
          }

          ppsCommonViewVm.goToPrevious = function () {
               $ionicViewSwitcher.nextDirection('back');
               $state.go('menu.positivePayment');
          }

          return this;
     }
]);
