
'use strict';

/*State defination with respective names, urls, controllers and templates */
angularApp.config(['$stateProvider',
	function ($stateProvider) {
		$stateProvider
          .state('menu.positivePayment', {
			url: '/positivePayment',
			cache: false,
			data: {
				pageId: 'POSITIVE_PAYMENT_LANDING'
			},
			views: {
				'menuContent': {
					templateUrl: 'pages/nfs/positivePaymentSystem/positivePayment.html',
					controller: 'positivePaymentController',
					controllerAs: 'positivePaymentControllerVm'
				}
			}
		})

		.state('menu.ppsChequeDetails', {
			url: '/ppsChequeDetails',
			cache: false,
			data: {
				pageId: 'POSITIVE_PAYMENT_CHEQUE_DETAILS'
			},
			views: {
				'menuContent': {
					templateUrl: 'pages/nfs/positivePaymentSystem/ppsChequeDetails.html',
					controller: 'ppsChequeDetailsController',
					controllerAs: 'ppsChequeDetailsControllerVm'
				}
			}
		})

		.state('menu.ppsChequeReview', {
			url: '/ppsChequeReview',
			cache: false,
			data: {
				pageId: 'POSITIVE_PAYMENT_CHEQUE_REVIEW'
			},
			views: {
				'menuContent': {
					templateUrl: 'pages/nfs/positivePaymentSystem/ppsChequeReview.html',
					controller: 'ppsChequeReviewController',
					controllerAs: 'ppsChequeReviewControllerVm'
				}
			}
		})

		.state('menu.ppsOTPPage', {
			url: '/ppsOTPPage',
			cache: false,
			data: {
				pageId: 'POSITIVE_PAYMENT_OTP'
			},
			params: { action:null },
			views: {
				'menuContent': {
					templateUrl: 'pages/nfs/positivePaymentSystem/ppsOTPPage.html',
					controller: 'ppsOTPPageController',
					controllerAs: 'ppsOTPPageControllerVm'
				}
			}
		})

		.state('menu.ppsChequeSuccess', {
			url: '/ppsChequeSuccess',
			cache: false,
			data: {
				pageId: 'POSITIVE_PAYMENT_CHEQUE_SUCCESS'
			},
			params: { action:null },
			views: {
				'menuContent': {
					templateUrl: 'pages/nfs/positivePaymentSystem/ppsChequeSuccess.html',
					controller: 'ppsChequeSuccessController',
					controllerAs: 'ppsChequeSuccessControllerVm'
				}
			}
		})
		
		.state('menu.ppsFetchRequestDetails', {
			url: '/fetchRequestDetails',
			cache: false,
			data: {
				pageId: 'POSITIVE_PAYMENT_FETCH_DETAILS'
			},
			views: {
				'menuContent': {
					templateUrl: 'pages/nfs/positivePaymentSystem/ppsFetchRequestDetails.html',
					controller: 'ppsFetchRequestDetailsController',
					controllerAs: 'ppsFetchRequestDetailsControllerVm'
				}
			}
		})
		
		.state('menu.ppsChequeList', {
			url: '/ppsChequeList',
			cache: false,
			data: {
				pageId: 'POSITIVE_PAYMENT_CHEQUE_LIST'
			},
			views: {
				'menuContent': {
					templateUrl: 'pages/nfs/positivePaymentSystem/ppsChequeList.html',
					controller: 'ppsChequeListController',
					controllerAs: 'ppsChequeListControllerVm'
				}
			}
		})

		.state('menu.ppsNoRecordFound', {
			url: '/ppsNoRecordFound',
			cache: false,
			data: {
				pageId: 'POSITIVE_PAYMENT_NO_RECORD_FOUND'
			},
			views: {
				'menuContent': {
					templateUrl: 'pages/nfs/positivePaymentSystem/ppsNoRecordFound.html',
					controller: 'ppsNoRecordFoundController',
					controllerAs: 'ppsNoRecordFoundControllerVm'
				}
			}
		})

          .state('menu.ppsCommonView', {
			url: '/ppsCommonView',
			cache: false,
			data: {
				pageId: 'POSITIVE_PAYMENT_COMMON_VIEW'
			},
			views: {
				'menuContent': {
					templateUrl: 'pages/nfs/positivePaymentSystem/ppsCommon/ppsCommonView.html',
					controller: 'ppsCommonViewController',
					controllerAs: 'ppsCommonViewVm'
				}
			}
		})

          .state('menu.ppsCommonOTPView', {
			url: '/ppsCommonOTPView',
			cache: false,
			data: {
				pageId: 'POSITIVE_PAYMENT_COMMON_OTP_VIEW'
			},
			views: {
				'menuContent': {
					templateUrl: 'pages/nfs/positivePaymentSystem/ppsCommon/ppsCommonOTP.html',
					controller: 'ppsCommonOTPController',
					controllerAs: 'ppsCommonOTPVm'
				}
			}
		})

          .state('menu.ppsCommonSuccessView', {
			url: '/ppsCommonSuccessView',
			cache: false,
			data: {
				pageId: 'POSITIVE_PAYMENT_COMMON_SUCCESS_VIEW'
			},
			views: {
				'menuContent': {
					templateUrl: 'pages/nfs/positivePaymentSystem/ppsCommon/ppsCommonSuccess.html',
					controller: 'ppsCommonSuccessController',
					controllerAs: 'ppsCmmSuccessVm'
				}
			}
		})

		.state('menu.ppsCommonReview', {
			url: '/ppsCommonReview',
			cache: false,
			data: {
				pageId: 'POSITIVE_PAYMENT_COMMON_REVIEW_VIEW'
			},
			views: {
				'menuContent': {
					templateUrl: 'pages/nfs/positivePaymentSystem/ppsCommon/ppsCommonReview.html',
					controller: 'ppsCommonReviewController',
					controllerAs: 'ppsCmmReviewVm'
				}
			}
		})

          
     }
]);