'use strict';

angularApp.controller('ppsFetchRequestDetailsController', ["$timeout",
    "$state",
    "$location",
    "$scope",
    "$rootScope",
    "customerInfoService",
    "utilityService",
    "$ionicPopup", "chequeDepositsService", "AdapterUtils", "$q", "$ionicPopover", "$filter", "$ionicHistory", "getAccountDetailsService", "currentLocationService", "ionicDatePicker", "homeScreenService", "ppsServices", "cryptoService","loggedInUserService",

    function ($timeout,
        $state,
        $location,
        $scope,
        $rootScope,
        customerInfoService,
        utilityService,
        $ionicPopup,
        chequeDepositsService, AdapterUtils, $q, $ionicPopover, $filter, $ionicHistory, getAccountDetailsService, currentLocationService, ionicDatePicker, homeScreenService, ppsServices, cryptoService, loggedInUserService) {

        var ppsFetchRequestDetailsControllerVm = this;
        ppsFetchRequestDetailsControllerVm.validateChequeNo = false;
        ppsFetchRequestDetailsControllerVm.validateInstrumentType = false;
        ppsFetchRequestDetailsControllerVm.validateAccount = false;
        ppsFetchRequestDetailsControllerVm.checkEligibilityErr ="";

        //Account list selectionEnd

        ppsFetchRequestDetailsControllerVm.getAccountList = function () {

            if (!getAccountDetailsService.accountOverviewData) {
                utilityService.showSpinner();
                homeScreenService.getCustomerInfo().then(function (data) {
                    utilityService.hideSpinner();
                    getAccountDetailsService.accountOverviewData = data;
                    ppsFetchRequestDetailsControllerVm.accDetails = getAccountDetailsService.accountOverviewData.accounts;
                    if (ppsFetchRequestDetailsControllerVm.accDetails.length == 0) {
                        ppsServices.displayPopUp("", "padBtm25 top-padding26", "No Accounts available", "OK", function () {
                            $state.go('menu.homeScreen');
                        });
                    }
                    ppsFetchRequestDetailsControllerVm.setPrimaryAccount();


                }, function (error) {
                    utilityService.hideSpinner();
                });
            } else {

                ppsFetchRequestDetailsControllerVm.accDetails = getAccountDetailsService.accountOverviewData.accounts;
                if (ppsFetchRequestDetailsControllerVm.accDetails.length == 0) {
                    ppsServices.displayPopUp("", "padBtm25 top-padding26", "No Accounts available", "OK", function () {
                        $state.go('menu.homeScreen');
                    });
                }
               ppsFetchRequestDetailsControllerVm.setPrimaryAccount();

            }




        }

        ppsFetchRequestDetailsControllerVm.setPrimaryAccount = function () {

            if (getAccountDetailsService.accountOverviewData.customerInformation.accountNumber) {
                var arr = ppsFetchRequestDetailsControllerVm.accDetails;

                for (var i = 0; i < arr.length; i++) {
                    if (arr[i].accountNumber == getAccountDetailsService.accountOverviewData.customerInformation.accountNumber) {
                        var topElement = ppsFetchRequestDetailsControllerVm.accDetails[i];
                        ppsFetchRequestDetailsControllerVm.close(i);
                        if (ppsFetchRequestDetailsControllerVm.accDetails.indexOf(topElement) > 0) {
                            ppsFetchRequestDetailsControllerVm.accDetails.splice(ppsFetchRequestDetailsControllerVm.accDetails.indexOf(topElement), 1);
                            ppsFetchRequestDetailsControllerVm.accDetails.unshift(topElement);
                        }else{}
                    }
                };


            } else {
                var arrAccount = ppsChequeDetailsControllerVm.accDetails;
                var max = 0;
                var maxAccNo = 0;  var maxBal=0;  
                for (var k=0 ; k<arrAccount.length ; k++) {
                if (maxBal == 0 || parseInt(arrAccount[k].accountBalance) > parseInt(maxBal)){
                    max = arrAccount[k].accountNumber;
                    maxBal = arrAccount[k].accountBalance;
                }
                }
                maxAccNo = max;
                for (var j = 0; j < arrAccount.length; j++) {
                    if (arrAccount[j].accountNumber == maxAccNo) {
                        var topElement_max = ppsChequeDetailsControllerVm.accDetails[j];
                        ppsChequeDetailsControllerVm.close(j);
                        if (ppsChequeDetailsControllerVm.accDetails.indexOf(topElement_max) > 0) {
                            ppsChequeDetailsControllerVm.accDetails.splice(ppsChequeDetailsControllerVm.accDetails.indexOf(topElement_max), 1);
                            ppsChequeDetailsControllerVm.accDetails.unshift(topElement_max);
                        }else{}
                    }
                }
            }
            

        }

        // Check customer eligibility
        ppsFetchRequestDetailsControllerVm.customerEligibility = function () {
             var reqData ={
                "accountNumber": ppsFetchRequestDetailsControllerVm.accountNumber
            }
             ppsServices.customerEligibility(reqData).then(function (data) {
                    ppsFetchRequestDetailsControllerVm.checkEligibilityErr="";
                     ppsFetchRequestDetailsControllerVm.validateAccount = false;
                     ppsFetchRequestDetailsControllerVm.instrumentTypes = data.instrumentType;
                 
             }, function (error) {
                 ppsFetchRequestDetailsControllerVm.validateAccount = true;
                 ppsFetchRequestDetailsControllerVm.checkEligibilityErr = error.responseMessage;
             });
            //ppsFetchRequestDetailsControllerVm.instrumentTypes = ["29", "30"];
        };

        ppsFetchRequestDetailsControllerVm.showPop = function () {
            if (ppsFetchRequestDetailsControllerVm.accDetails.length > 1) {
                ppsFetchRequestDetailsControllerVm.popUp = $ionicPopup.show({
                    title: '',
                    cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll yonoWeableBackdrop',
                    templateUrl: 'pages/nfs/positivePaymentSystem/dropdownModal.html',
                    scope: $scope
                });
            }
        }


        ppsFetchRequestDetailsControllerVm.close = function (index) {
            
            
            if (ppsFetchRequestDetailsControllerVm.popUp) {
                ppsFetchRequestDetailsControllerVm.popUp.close();
            }

            ppsFetchRequestDetailsControllerVm.balance = ppsFetchRequestDetailsControllerVm.accDetails[index].accountBalance;
            ppsFetchRequestDetailsControllerVm.accType = ppsFetchRequestDetailsControllerVm.accDetails[index].accountType;
            ppsFetchRequestDetailsControllerVm.accountNumber = ppsFetchRequestDetailsControllerVm.accDetails[index].accountNumber;
            ppsFetchRequestDetailsControllerVm.isActive = ppsFetchRequestDetailsControllerVm.accDetails[index].isActive;
            ppsFetchRequestDetailsControllerVm.isTransactional = ppsFetchRequestDetailsControllerVm.accDetails[index].isTransactional;
            
            ppsFetchRequestDetailsControllerVm.customerEligibility();


        }

        ppsFetchRequestDetailsControllerVm.goTochequeList = function () {

            if(ppsFetchRequestDetailsControllerVm.chequeNo == "" || ppsFetchRequestDetailsControllerVm.chequeNo == undefined){
                ppsFetchRequestDetailsControllerVm.validateChequeNo = true;
            }else if(ppsFetchRequestDetailsControllerVm.instrumentType == "" || ppsFetchRequestDetailsControllerVm.instrumentType == undefined){
                ppsFetchRequestDetailsControllerVm.validateInstrumentType = true;
            }else{
            var reqData = {
                "accountNumber": ppsFetchRequestDetailsControllerVm.accountNumber,
                "chequeNumber": ppsFetchRequestDetailsControllerVm.chequeNo,
                "instrumentType": ppsFetchRequestDetailsControllerVm.instrumentType,
                "hash":  (cryptoService.getSHA512EncryptedData(loggedInUserService.tokenLotus+ppsFetchRequestDetailsControllerVm.accountNumber+ppsFetchRequestDetailsControllerVm.chequeNo)).toString()
            }
            
             ppsServices.viewRequest(reqData).then(function (data) {

                ppsServices.viewChequeData = data;
                ppsServices.chequeNumberDelete = data.chequeNumber;
                 $state.go('menu.ppsChequeList');
             }, function (error) {
                 //utilityService.showErrorMessage(error.responseMessage); //need to add display inline here
                 $state.go('menu.ppsNoRecordFound');
             });
            }

        }

       
        ppsFetchRequestDetailsControllerVm.goToPrevious = function () {
            $state.go("menu.positivePayment");
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            ppsFetchRequestDetailsControllerVm.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            ppsFetchRequestDetailsControllerVm.getAccountList();
        });

        return this;
    }
]);
