'use strict';
angularApp.controller('ppsOTPPageController', [
	"$state",
	"$scope",
	"utilityService",
	"customerInfoService", "$filter", "getAccountDetailsService", "cryptoService", "$stateParams", "$ionicHistory",
	"loggedInUserService", "internetBankingService", "ppsServices","$ionicPopup",
	function ($state, $scope, utilityService, customerInfoService, $filter, getAccountDetailsService,
		cryptoService, $stateParams, $ionicHistory, loggedInUserService, internetBankingService, ppsServices, $ionicPopup) {

		var ppsOTPPageControllerVm = this;

		function initPage() {
			ppsOTPPageControllerVm.otpCount = 0;
			ppsOTPPageControllerVm.clickCount = 0;
			ppsOTPPageControllerVm.isResendDisabled = false;
			ppsOTPPageControllerVm.goBackState = $stateParams.goBackToState;
			ppsOTPPageControllerVm.mobileNumber = $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4);
			ppsOTPPageControllerVm.pageName = $stateParams.action;

			var reqObj = {
				"id": customerInfoService.customer.mobile,
				"emailId": customerInfoService.customer.emailID
			}
			ppsServices.generateOTP(reqObj).then(function (data) {
				ppsOTPPageControllerVm.otpNumber = "";
				ppsOTPPageControllerVm.resetPinOTP = "";
				
			}, function (error) {
				ppsOTPPageControllerVm.otpNumber = "";
				utilityService.showErrorMessage(error.responseMessage);
			});
		}
		ppsOTPPageControllerVm.goToPrevious = function () {
			$ionicHistory.goBack();
		}
		ppsOTPPageControllerVm.goNext = function () {
			ppsOTPPageControllerVm.resetPinOTP = "";
			if (!ppsOTPPageControllerVm.otpNumber) {
				ppsOTPPageControllerVm.resetPinOTP = "Please Enter the OTP";
			} else if (ppsOTPPageControllerVm.otpNumber.length != 6) {
				ppsOTPPageControllerVm.resetPinOTP = "Please enter 6 digits OTP";
			} else {

				var reqParams = {};
				reqParams["otp"] = ppsOTPPageControllerVm.otpNumber;
				reqParams["mobile"] = customerInfoService.customer.mobile;


				ppsServices.validateOTP(reqParams).then(function (data) {
					if(ppsOTPPageControllerVm.pageName == 'make_request'){
						ppsOTPPageControllerVm.goToMakeSuccess();
					}
					if(ppsOTPPageControllerVm.pageName == 'delete_request'){
						ppsOTPPageControllerVm.goToDeleteSuccess();
					}
					
				}, function (error) {
					ppsOTPPageControllerVm.otpNumber = "";
					ppsOTPPageControllerVm.otpCount++;
					if (ppsOTPPageControllerVm.otpCount >= 3) {
						
						var template = error.responseMessage;
						var onTap = '';
						var buttontext = "OK";
						utilityService.showBhimUpiAlert('error', template, onTap, buttontext, $scope);
					} else {
						utilityService.showErrorMessage(error.responseMessage);
					}
				});


			}
		}

		ppsOTPPageControllerVm.resendOTP = function () {
			
			var reqObj = {
				"id": customerInfoService.customer.mobile,
				"emailId": customerInfoService.customer.emailID
			}
			ppsServices.generateOTP(reqObj).then(function (data) {
				ppsOTPPageControllerVm.otpNumber = "";
				ppsOTPPageControllerVm.resetPinOTP = "";
				ppsOTPPageControllerVm.clickCount++;
				if (ppsOTPPageControllerVm.clickCount >= 2) {
					ppsOTPPageControllerVm.isResendDisabled = true;
				}
				
				var template = "OTP has been sent to your registered mobile number.";
				var onTap = '';
				var buttontext = "OK";
				
				utilityService.showBhimUpiAlert('success', template, onTap, buttontext, $scope);
			}, function (error) {
				ppsOTPPageControllerVm.otpNumber = "";
				utilityService.showErrorMessage(error.responseMessage);
			});
		}

		ppsOTPPageControllerVm.goToMakeSuccess = function () {
			var chequeDate = ppsServices.chequedetailsData.chequeDate;
			ppsServices.chequedetailsData.chequeDate = "" + String(chequeDate.getDate()).padStart(2, '0') + (String(chequeDate.getMonth()+1).padStart(2, '0')) + chequeDate.getFullYear();
			ppsServices.chequedetailsData.hash = (cryptoService.getSHA512EncryptedData(loggedInUserService.tokenLotus+ppsServices.chequedetailsData.accountNumber+ppsServices.chequedetailsData.chequeNumber)).toString();
			var makeReqData = ppsServices.chequedetailsData;
			ppsServices.raiseRequest(makeReqData).then(function (data) {
				ppsServices.refNumber = data.jrnlNumber;
				ppsServices.chequedetailsData = {};
				$state.go("menu.ppsChequeSuccess", {action : 'make_request'});
			}, function (error) {
				ppsServices.chequedetailsData = {};
				var ppsRaiseErrorPopup = $ionicPopup.alert({
				template: '<div class="CSPadding font-dark-grey "><div class="parentCS"><img class="ppsimgwidthCS roboto-medium" src="img/errorDndRed.svg" alt="error"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="ppschildCS" >'+error.responseMessage+'</div></div></div></div></div></div>',
				cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter ppscustBtn button0pd',
				buttons: [
					{
					text: 'OK',
					type: 'button-positive',
					onTap: function (e) {
					ppsRaiseErrorPopup.close();
					$state.go("menu.positivePayment");
					}
					}
				]
            });
				
			});
		}

		ppsOTPPageControllerVm.goToDeleteSuccess = function () {
			var reqData = ppsServices.viewChequeData;
			ppsServices.deleteRequest(reqData).then(function (data) {
				ppsServices.deleteRefNumber = data.jrnlNumber;
				ppsServices.viewChequeData ={};
				$state.go("menu.ppsChequeSuccess", {action : 'delete_request'});
			}, function (error) {
				
				ppsServices.viewChequeData ={};
				var ppsViewReqErrorPopup = $ionicPopup.alert({
				template: '<div class="CSPadding font-dark-grey "><div class="parentCS"><img class="ppsimgwidthCS roboto-medium" src="img/errorDndRed.svg" alt="error"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="ppschildCS" >'+error.responseMessage+'</div></div></div></div></div></div>',
				cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter ppscustBtn button0pd',
				buttons: [
					{
					text: 'OK',
					type: 'button-positive',
					onTap: function (e) {
					ppsViewReqErrorPopup.close();
					$state.go("menu.positivePayment");
					}
					}
				]
            });
				
			});
		}


		$scope.$on('$ionicView.beforeEnter', function () {
			initPage();
			ppsOTPPageControllerVm.goBackState = $stateParams.goBackToState;
			ppsOTPPageControllerVm.action = $stateParams.action;
			ppsOTPPageControllerVm.goBackToState = '';
			
			
		});

		return this;
	}


]);


