angularApp.service('ppsServices', function ($q, $http, AdapterUtils, utilityService,$ionicPopup) {
	var ppsServices = this;
	ppsServices.chequedetailsData = {};

	ppsServices.viewChequeData = {};
	ppsServices.refNumber = '';
	ppsServices.deleteRefNumber = '';
	ppsServices.selectedType = '';
	ppsServices.ppsDetails = {};

	ppsServices.raiseRequest = function (requestData) {
		var q = $q.defer();
		var obj = requestData;
		AdapterUtils.postData("adapters/ServiceRequestAdapter/raiseRequest", obj, true).then(
			function (response) {
				q.resolve(response.data);
			},
			function (error) {
				q.reject(error);
			}
		);
		return q.promise;
	};



	//View Request 

	ppsServices.viewRequest = function (requestData) {
		var q = $q.defer();
		var obj = requestData;
		AdapterUtils.postData("adapters/ServiceRequestAdapter/viewRequest", obj, true).then(
			function (response) {
				q.resolve(response.data);
			},
			function (error) {
				q.reject(error);
			}
		);
		return q.promise;
	};


	//Delete Request

	ppsServices.deleteRequest = function (requestData) {
		var q = $q.defer();
		var obj = requestData;
		AdapterUtils.postData("adapters/ServiceRequestAdapter/deleteRequest", obj, true).then(
			function (response) {
				q.resolve(response.data);
			},
			function (error) {
				q.reject(error);
			}
		);
		return q.promise;
	};

	ppsServices.displayPopUp = function (heading, css, message, buttonText, callBack) {
		var alertPopup = $ionicPopup.alert({
			title: heading,
			template: '<div class="popupTextBottomPadding  ss-popup-list fontSize-subHeading roboto-medium text-center ' + css + '">'
			+ message + '</div></div>',
			cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite ss-popup',
			buttons: [
				{
					text: buttonText,
					onTap: function (e) {
						callBack();
					}
				}
			],
		});
	};

	ppsServices.generateOTP = function (requestData) {
		var q = $q.defer();
		AdapterUtils.postData("adapters/OTPAdapter/getOTPTokenSecure", requestData, false).then(function (response) {
			q.resolve(response.data);
		},
			function (error) {
				q.reject(error);
			});
		return q.promise;
	};

	ppsServices.validateOTP = function (requestData) {
		var q = $q.defer();
		AdapterUtils.postData("adapters/OTPAdapter/validateOTPTokenSecure", requestData, true).then(function (response) {
			q.resolve(response.data);
		},
			function (error) {
				q.reject(error);
			});
		return q.promise;
	};

	ppsServices.termsAndConditions = function () {
		var q = $q.defer();
		var obj={"type":"ppsRaiseTmC"};
		AdapterUtils.postData("adapters/ServiceRequestAdapter/getTnC", obj , true).then(function (response) {
			q.resolve(response.data);
		},
			function (error) {
				q.reject(error);
			});
		return q.promise;
	};

	ppsServices.verifySecKey = function (secKey) {
		return ((secKey / 2) - 1) / 99;
	}

	ppsServices.customerEligibility = function (reqData) {
		var q = $q.defer();
		var requestSecKey = '';
		var random_num = (window.crypto.getRandomValues(new Uint32Array(1))[0]);
		requestSecKey = (random_num * 10 + 1);
		reqData.secKey = requestSecKey;
		AdapterUtils.postData("adapters/ServiceRequestAdapter/customerEligibility", reqData, true).then(
			function (response) {
				var finalcalculatedKey = ppsServices.verifySecKey(parseInt(response.secKey));
				if(requestSecKey === finalcalculatedKey)
					q.resolve(response.data);
				else{
					q.reject("Technical error, please try later.");
				}
			},
			function (error) {
				q.reject(error);
			}
		);
		return q.promise;
	};

	ppsServices.commonService = function (reqData,url) {
		var q = $q.defer();
		AdapterUtils.postData("adapters/ServiceRequestAdapter/"+url, reqData, true).then(
			function (response) {
				q.resolve(response.data);
			},
			function (error) {
				q.reject(error);
			}
		);
		return q.promise;
	};

	ppsServices.enquiry = function (reqData) {
		var q = $q.defer();
		AdapterUtils.postData("adapters/ServiceRequestAdapter/enquiry", reqData, true).then(
			function (response) {
				q.resolve(response.data);
			},
			function (error) {
				q.reject(error);
			}
		);
		return q.promise;
	};

	ppsServices.ppsCommonTnC = function(obj) {
		var q = $q.defer();	
		var object = {"type":obj.type};
		AdapterUtils.postData("adapters/ServiceRequestAdapter/getTnC",object,true).then(function(response){
				q.resolve(response.data);
			},
			function(error){
				q.reject(error);
			}); 
		return q.promise;
	};

	return ppsServices;
});
