'use strict';

angularApp.controller('ppfReviewDtlController', ["$timeout",
    "$state",
    "$location",
    "$scope",
    "$rootScope",
    "customerInfoService",
    "utilityService",
    "$ionicPopup", "ppfEReceiptService","AdapterUtils","$q","ionicDatePicker","openUrlInAppbroswerService","constantConfig",


    function ($timeout,
        $state,
        $location,
        $scope,
        $rootScope,
        customerInfoService,
        utilityService,
        $ionicPopup,ppfEReceiptService,AdapterUtils,$q,ionicDatePicker,openUrlInAppbroswerService,constantConfig) {

        var ppfReviewDtlVm = this;
        //functions, variables that can be accessed from the HTML template

        ppfReviewDtlVm.downloadppfDetails = function (){

            var q = $q.defer();
            var request = { "accountNumber": ppfReviewDtlVm.ppfDetailone.accountNumber,"referenceNumber":ppfReviewDtlVm.ppfDetail.referenceNumber }
                    ppfEReceiptService.getPPFTransactionReceipt(request).then(function(res){
                    ppfReviewDtlVm.response=res;
                    ppfReviewDtlVm.ppfreceiptDownload(res);
                },function (error) {
                utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
            });
        }


    // Download receipt code begin

    ppfReviewDtlVm.ppfreceiptDownload = function(res) {

            var content = res.pdf;
            var filename = res.fileName;

            var contentStr = atob(content);
            var contentLen = contentStr.length;

            if(contentLen >= constantConfig.accOverview.pdfSize) {
                utilityService.showErrorMessage(constantConfig.accOverview.sizeLimitMessage);
                return;
            }

            var contentType = "application/pdf";
            if (utilityService.isAndroidPlatform()) {
                ppfReviewDtlVm.folderpath = cordova.file.externalRootDirectory;
            }

            if (utilityService.isIOSPlatform()) {
                ppfReviewDtlVm.folderpath = cordova.file.documentsDirectory;
            }

            savebase64AsPDF(ppfReviewDtlVm.folderpath, filename, content, contentType);

            if (utilityService.isIOSPlatform()) {
                filename = filename + ".pdf";
                var finalObject = { "folderpath": ppfReviewDtlVm.folderpath, "filename": filename };
                openUrlInAppbroswerService.openUrl("data:application/pdf;base64," + content + "","");
                utilityService.setCsatJournies('ppfEReceipt');
                $state.go('menu.serviceRequest');
            }

            if (utilityService.isAndroidPlatform()) {
                var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="DWN_RECEIPT"></div>';
                ppfReviewDtlVm.downloadPopup = $ionicPopup.show({
                    title: '',
                    template: template,
                    scope: $scope,
                    cssClass: 'my-custom-popup',
                    buttons: [{
                        text: 'OK',
                        type: 'button-assertive',
                        onTap: function () {
                            ppfReviewDtlVm.downloadPopup.close();
                            utilityService.setCsatJournies('ppfEReceipt');
                            $state.go('menu.serviceRequest');
                        }
                    }],
                });
            }
    };
    // Download receipt code ends


function b64toBlob(b64Data, contentType, sliceSize) {
        contentType = contentType || '';
        sliceSize = sliceSize || 512;
        var byteCharacters = atob(b64Data);
        var byteArrays = [];
        for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
            var slice = byteCharacters.slice(offset, offset + sliceSize);
            var byteNumbers =[];
            for (var i = 0; i < slice.length; i++) {
                byteNumbers[i] = slice.charCodeAt(i);
            }
            var byteArray = new Uint8Array(byteNumbers);
            byteArrays.push(byteArray);
        }
        var blob = new Blob(byteArrays, {type: contentType});
        return blob;
    }

    function savebase64AsPDF(folderpath, filename, content, contentType) {
        // Convert the base64 string in a Blob
        var DataBlob = b64toBlob(content, contentType);
        filename = filename + ".pdf";
        window.resolveLocalFileSystemURL(folderpath, function (dir) {
            dir.getFile(filename, { create: true }, function (file) {
                file.createWriter(function (fileWriter) {
                    fileWriter.write(DataBlob);
                }, function () {
                });
            });
        });
    }

            $scope.$on('$ionicView.beforeEnter', function() {
            var ref = ppfEReceiptService.refno1;
            var ppfObj = ppfEReceiptService.getppfstmtList();

            ppfReviewDtlVm.ppfDetail =  ppfEReceiptService.obj;
            ppfReviewDtlVm.ppfDetailone  = ppfEReceiptService.getppfstmtList();
            });

            ppfReviewDtlVm.goToHome=function (){
                $state.go('menu.homeScreen');
            }

            ppfReviewDtlVm.goToback = function(){
                 $state.go('menu.ppfViewDetails');
             }
        return this;
    }

]);



