'use strict';

angularApp.controller('reprintITChallanController', ["$timeout",
    "$state",
    "$location",
    "$scope",
    "$rootScope",
    "customerInfoService",
    "utilityService",    
    "$ionicPopup", "reprintITChallanService","AdapterUtils","$q","ionicDatePicker","ionicToast",

    function ($timeout,
        $state,
        $location,
        $scope,
        $rootScope,
        customerInfoService,
        utilityService,
        $ionicPopup,reprintITChallanService,AdapterUtils,$q,ionicDatePicker,ionicToast) {

        var reprintITChallanVm = this;
        //functions, variables that can be accessed from the HTML template

        reprintITChallanVm.goToHome=function (){
            $state.go('menu.homeScreen');
        }

        reprintITChallanVm.goToback = function(){
            $state.go('menu.innerPage');
        }


        reprintITChallanVm.showDateRangeInfoPopup = function () {
                ionicToast.show("Date range allowed is one year i.e. 365 days inclusive of dates chosen. Last three years data only will be available from the current date", 'middle', false, 2000);
        };

	/***Function to openDatePicker***/
        reprintITChallanVm.startDatePicker = function(){
                            reprintITChallanVm.itc_end_date="";
                            var newDate = new Date();
                            newDate.setDate(newDate.getDate() -1094);

                            reprintITChallanVm.dateObj = {
                                    callback: function (val) {
                                            var tomorrow = new Date(val);
                                            tomorrow.setDate(tomorrow.getDate() + 1);
                                            tomorrow.setDate(tomorrow.getDate());
                                            reprintITChallanVm.itc_start_date = new Date(tomorrow).toISOString().slice(0,10);
                                        },
                                        inputDate: new Date(),
                                        from: newDate,
                                        to: new Date(),
                                        mondayFirst: true,
                                        closeOnSelect: false,
                                        templateType: 'popup',
                                        dateFormat: 'dd MMM yyyy'
                                };
                                ionicDatePicker.openDatePicker(reprintITChallanVm.dateObj);
        }


	    reprintITChallanVm.endDatePicker = function(){
                            var newDate = new Date();
                            var startDate = new Date(reprintITChallanVm.itc_start_date);
                            var endDate = new Date(reprintITChallanVm.itc_start_date);
                            endDate.setDate(startDate.getDate() +364);

                            if(endDate.getTime() > new Date().getTime()){
                                endDate = new Date();
                            }
                            reprintITChallanVm.dateObj = {
                                    callback: function (val) {
                                                var tomorrow = new Date(val);
                                                tomorrow.setDate(tomorrow.getDate() + 1);
                                                reprintITChallanVm.itc_end_date = new Date(tomorrow).toISOString().slice(0,10);
                                        },
                                            inputDate: endDate,
                                            from: startDate,
                                            to: endDate,
                                            mondayFirst: true,
                                            closeOnSelect: false,
                                            templateType: 'popup',
                                            dateFormat: 'dd MMM yyyy'
                                 };
                                 ionicDatePicker.openDatePicker(reprintITChallanVm.dateObj);
	    }


           reprintITChallanVm.submitITDetails = function (){
               var q = $q.defer();
                var startDate = new Date(reprintITChallanVm.itc_start_date);
                var month = startDate.getMonth()+1;
                var requestStartDate = startDate.getDate()+"/"+month+"/"+startDate.getFullYear();
                var endDate = new Date(reprintITChallanVm.itc_end_date);
                var month2 = endDate.getMonth()+1;
                var requestEndDate = endDate.getDate()+"/"+month2+"/"+endDate.getFullYear();

               var request = {"fromDate":requestStartDate,"toDate":requestEndDate}

           reprintITChallanService.getChallanDtl(request).then(function(data){
                reprintITChallanService.setChallanDtlList(data);
                    $state.go('menu.viewChallanDtl');
                   },function (error) {
                   utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
               });

           }

        return this;
    }

]);