'use strict';

angularApp.controller('revokeChequeController', ["$state",
	"$ionicPopup",
	"$scope",
	"revokeChequeService",
	"serviceRequestService",
	"utilityService",

	function ($state,
		$ionicPopup,
		$scope,
		revokeChequeService,
		serviceRequestService,
		utilityService) {

		var revokeChequeVm = this;

		revokeChequeVm.isNextEnable = true;

		revokeChequeVm.init = function () {
			revokeChequeVm.typesOfCheque = revokeChequeService.typesOfCheque;
			revokeChequeVm.EnterCheque = revokeChequeService.EnterCheque;
			revokeChequeVm.toCheque = revokeChequeService.toCheque;
			revokeChequeVm.fromCheque = revokeChequeService.fromCheque;
			revokeChequeVm.selectedCardType = revokeChequeService.selectedCardType;
			revokeChequeVm.multiSelectedCardType = revokeChequeService.multiSelectedCardType;
			revokeChequeVm.selectedAccount = revokeChequeService.selectedAccValue == null ? "" : JSON.stringify(revokeChequeService.selectedAccValue);
			revokeChequeVm.nextEnable();
		}



		revokeChequeVm.goToNext = function () {
			$state.go('menu.revokeChequeReview');
		}

		revokeChequeVm.goToHome = function () {
			revokeChequeService.clearAll();
			$state.go('menu.homeScreen');

		}

		revokeChequeVm.goToback = function () {
			revokeChequeService.clearAll();
			$state.go('menu.innerPage');
		}

		revokeChequeVm.selectedAccountFun = function () {
			revokeChequeService.selectedAccValue = revokeChequeVm.selectedAccount == "" ? null : JSON.parse(revokeChequeVm.selectedAccount);
			revokeChequeVm.nextEnable();
		}

		revokeChequeVm.enterCheque = function () {
			if (revokeChequeVm.EnterCheque.length < 6) {

				revokeChequeVm.isValidError = true;

			} else {
				revokeChequeVm.isValidError = false;
				revokeChequeService.EnterCheque = revokeChequeVm.EnterCheque;
			}
			revokeChequeVm.nextEnable();
		}

		revokeChequeVm.fromChequeFun = function () {
			if (revokeChequeVm.fromCheque.length < 6) {
				revokeChequeVm.fromChequeError = true;
				revokeChequeVm.validCheckrange = false;

			} else if (parseInt(revokeChequeVm.toCheque) < parseInt(revokeChequeVm.fromCheque)) {

				revokeChequeVm.fromChequeError = false;
				revokeChequeVm.validCheckrange = true;
				revokeChequeVm.isNextEnable = true;

			} else {
				revokeChequeVm.fromChequeError = false;
				revokeChequeVm.validCheckrange = false;
				revokeChequeService.fromCheque = revokeChequeVm.fromCheque;
			}
			revokeChequeVm.nextEnable();
		}


		revokeChequeVm.toChequeFun = function () {
			if (revokeChequeVm.toCheque.length < 6) {
				revokeChequeVm.toChequeError = true;
				revokeChequeVm.validCheckrange = false;




			} else if (parseInt(revokeChequeVm.toCheque) < parseInt(revokeChequeVm.fromCheque)) {

				revokeChequeVm.toChequeError = false;
				revokeChequeVm.validCheckrange = true;
				revokeChequeVm.isNextEnable = true;

			}
			else {
				revokeChequeVm.toChequeError = false;
				revokeChequeVm.validCheckrange = false;
				revokeChequeService.toCheque = revokeChequeVm.toCheque;
			}


			revokeChequeVm.nextEnable();
		}



		revokeChequeVm.selectedTabFun = function () {
			revokeChequeService.typesOfCheque = revokeChequeVm.typesOfCheque;
			revokeChequeVm.selectedAccount = "";
			revokeChequeVm.selectedCardType = "";
			revokeChequeVm.toCheque = "";
			revokeChequeVm.fromCheque = "";
			revokeChequeVm.EnterCheque = "";
			revokeChequeVm.multiSelectedCardType = "";
			revokeChequeVm.nextEnable();
		}

		revokeChequeVm.getAccountList = function () {
			if (!revokeChequeService.accList.length) {
				var reqData = {
					"journey": "REVOKE",
				}
				revokeChequeService.chequeAccountFilterRequest(reqData).then(function (data) {
					revokeChequeService.accList = data.accList;
					revokeChequeVm.accList = revokeChequeService.accList;


					
				}, function (error) {
					utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
				});

			} else {
				revokeChequeVm.accList = revokeChequeService.accList;
				revokeChequeVm.selectedAccount = revokeChequeService.selectedAccValue == null ? "" : JSON.stringify(revokeChequeService.selectedAccValue);
			}
			revokeChequeVm.nextEnable();

		}

		revokeChequeVm.selectedCardTypeFun = function () {
			revokeChequeService.selectedCardType = revokeChequeVm.selectedCardType;
			revokeChequeVm.nextEnable();

		}
		revokeChequeVm.multiSelectedCardTypeFun = function () {
			revokeChequeService.multiSelectedCardType = revokeChequeVm.multiSelectedCardType;
			revokeChequeVm.nextEnable();

		}

		revokeChequeVm.nextEnable = function () {

			if (revokeChequeService.typesOfCheque == "single") {

				if (revokeChequeVm.selectedAccount != undefined && revokeChequeVm.selectedAccount != null && revokeChequeVm.selectedAccount != "" && revokeChequeVm.EnterCheque != "" && revokeChequeVm.EnterCheque != null && revokeChequeVm.EnterCheque != undefined && revokeChequeVm.EnterCheque.length === 6 && revokeChequeVm.selectedCardType != "" && revokeChequeVm.selectedCardType != null && revokeChequeVm.selectedCardType != undefined) {
					revokeChequeVm.isNextEnable = false;
				} else {
					revokeChequeVm.isNextEnable = true;
				}


			} else {

				if (revokeChequeVm.selectedAccount != undefined && revokeChequeVm.selectedAccount != null && revokeChequeVm.selectedAccount != "" && revokeChequeVm.fromCheque != "" && revokeChequeVm.fromCheque != null && revokeChequeVm.fromCheque != undefined && revokeChequeVm.fromCheque.length === 6 && revokeChequeVm.toCheque != "" && revokeChequeVm.toCheque != undefined && revokeChequeVm.toCheque != null && revokeChequeVm.toCheque.length === 6 && revokeChequeVm.multiSelectedCardType != "" && revokeChequeVm.multiSelectedCardType != null && revokeChequeVm.multiSelectedCardType != undefined && parseInt(revokeChequeVm.fromCheque) <= parseInt(revokeChequeVm.toCheque)) {
					revokeChequeVm.isNextEnable = false;
				} else {
					revokeChequeVm.isNextEnable = true;
				}

			}

		}


		$scope.$on('$ionicView.loaded', function () {
		

			revokeChequeVm.getAccountList();



		});

		$scope.$on('$ionicView.beforeEnter', function () {
			
			revokeChequeVm.init();
			
			

		});

		return this;
	}
]);
