'use strict';

angularApp.controller('revokeChequeReviewController', ["$state",
	"$ionicPopup",
	"$scope",
	"revokeChequeService",
	"utilityService",
	
	function ($state,
		$ionicPopup,
		$scope,
		revokeChequeService,
		utilityService) {

		var revokeChequeReviewVm = this;
		revokeChequeReviewVm.isNextEnabled = true;
		revokeChequeReviewVm.fromCheque = revokeChequeService.fromCheque;
		revokeChequeReviewVm.typesOfCheque = revokeChequeService.typesOfCheque;
		revokeChequeReviewVm.toCheque = revokeChequeService.toCheque;
		revokeChequeReviewVm.EnterCheque = revokeChequeService.EnterCheque;
		revokeChequeReviewVm.accountNumber = revokeChequeService.selectedAccValue.accountNumber;
		revokeChequeReviewVm.accountType = revokeChequeService.selectedAccValue.accountType;
		revokeChequeReviewVm.branchName = revokeChequeService.selectedAccValue.branchName;

		if (revokeChequeService.typesOfCheque == "single") {
			revokeChequeReviewVm.singleChequeData = true;
		} else {
			revokeChequeReviewVm.multipleChequeData = true;
		}

		revokeChequeReviewVm.goToback = function () {
			$state.go('menu.revokeCheque');
		}

		revokeChequeReviewVm.goToHome = function () {
			revokeChequeService.clearAll();
			$state.go('menu.homeScreen');
			
		}

		revokeChequeReviewVm.goToNext = function () {

			if (revokeChequeService.typesOfCheque == "single") {
				var requestData = {
			
					"branchCode": revokeChequeService.selectedAccValue.branchCode,
					"accountNumber": revokeChequeService.selectedAccValue.accountNumber,
					"fromChequeNumber": revokeChequeService.EnterCheque,
					"toChequeNumber": revokeChequeService.EnterCheque,
					"type": revokeChequeService.typesOfCheque,
					"instrumentType": revokeChequeService.selectedCardType,
					"accountType": revokeChequeService.selectedAccValue.accountType,
					"termsNcondition": true
				}

			} else {
				var requestData = {
					"branchCode": revokeChequeService.selectedAccValue.branchCode,
					"accountNumber": revokeChequeService.selectedAccValue.accountNumber,
					"fromChequeNumber": revokeChequeService.fromCheque,
					"toChequeNumber": revokeChequeService.toCheque,
					"type": revokeChequeService.typesOfCheque,
					"instrumentType": revokeChequeService.multiSelectedCardType,
					"accountType": revokeChequeService.selectedAccValue.accountType,
					"termsNcondition": true
				}
			}

			revokeChequeService.revokeStopRequest(requestData).then(function (data) {
			
				revokeChequeReviewVm.referenceNumber = data.referenceNumber;
				revokeChequeReviewVm.myPopup = $ionicPopup.show({
								title: '',
								cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
								templateUrl: 'pages/nfs/revokeCheque/Congratulations.html',
								scope: $scope
							});
			
			}, function (error) {
				revokeChequeService.clearAll();
				 utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
			
			});


		}


	revokeChequeReviewVm.ok = function () {
		   revokeChequeService.clearAll();
			revokeChequeReviewVm.myPopup.close();
			utilityService.setCsatJournies('revokeCheque');
			 $state.go('menu.homeScreen');
			
		};

		revokeChequeReviewVm.tncStateCheck = function () {
		revokeChequeReviewVm.nextEnable();
	}

		revokeChequeReviewVm.nextEnable = function () {

		if (revokeChequeReviewVm.tncCheck == true) {
			revokeChequeReviewVm.isNextEnabled = false;
		} else {
			revokeChequeReviewVm.isNextEnabled = true;
		}

	}

		revokeChequeReviewVm.tncFun = function () {

			var requestData = {
			"type": "getRevokeStopTnC"
		};

		revokeChequeService.getTnC(requestData).then(function (data) {
			revokeChequeReviewVm.tncData = data;
			

			var alertPopup = $ionicPopup.alert({
			title: 'Terms and Conditions',
			templateUrl: 'pages/nfs/revokeCheque/revokeCheque_tncPopup.html',
			scope: $scope,
			cssClass: 'bi-table',
			buttons: [
				{
					text: 'OK',
					type: 'button-positive',
					onTap: function (e) {
						return true;
					}
				}]
		});
			
		}, function (error) {
			utilityService.showErrorMessage(error.responseMessage);
			revokeChequeReviewVm.isNextEnabled = true;
			
		});



		
	}

	



		$scope.$on('$ionicView.loaded', function () {

		



	});



return this;
	}
]);
