'use strict';

angularApp.controller('selAccountController', ["$state",
	"$ionicPopup",
	"$scope",
	"$ionicHistory",
	"$filter","siNfsService",
	"loggedInUserService",
	"cryptoService",
	"utilityService",
	"chequeEnquiryService",
	"ionicDatePicker",
	"sampoornSurakshaService",
	function ($state,
		$ionicPopup,
		$scope,
		$ionicHistory,
		$filter,siNfsService,
		loggedInUserService,
		cryptoService,
		utilityService,
		chequeEnquiryService,
		ionicDatePicker,
		sampoornSurakshaService) {

		var selAccountVm = this;

		selAccountVm.selType = function(bookingCategory){
			siNfsService.myTab = bookingCategory;
			selAccountVm.selTab = siNfsService.myTab;
			if(bookingCategory == 'Y'){
				selAccountVm.classForMpinLoginOpt = 'tab-item tabs-style div-bottom bor-bot-active';
				selAccountVm.classForUserLoginOpt = 'tab-item tabs-style div-bottom';
			}else{
				selAccountVm.classForMpinLoginOpt = 'tab-item tabs-style div-bottom';
				selAccountVm.classForUserLoginOpt = 'tab-item tabs-style div-bottom bor-bot-active';
			}
			
		}

		selAccountVm.goToBack = function(){
			$state.go('menu.serviceRequest');
		}

		selAccountVm.selectToAccFun = function(){
			console.log(selAccountVm.detail.toAccount);
			selAccountVm.detail.toAccountType = JSON.parse(selAccountVm.detail.toAccount).accountType;
		}

		selAccountVm.goToNext = function(){
			if(selAccountVm.validateForm()){
				var fromAcc = JSON.parse(selAccountVm.detail.fromAccount).accountNumber;
				var toAcc = JSON.parse(selAccountVm.detail.toAccount).accountNumber;
				if(fromAcc == toAcc){
					utilityService.showBhimUpiAlert("alert","From Account and To Account should not be the same.","","Ok",$scope);
				}else{
					siNfsService.setNew.accDetails = selAccountVm.detail;
					siNfsService.setNew.freqDetails = {};
					$state.go('menu.siReview');
				}
				

			}

		}

		selAccountVm.selectedFromAccount = function(){
			var brCode = JSON.parse(selAccountVm.detail.fromAccount).accountNumber;
			selAccountVm.detail.branchCode = brCode;
			var obj = {
				"accountNumber":brCode
			}
			siNfsService.getSItoAccounts(obj).then(function(data){
            	if(data.accList.length > 0){
            		siNfsService.setToAccountDetails(data.accList);
            		selAccountVm.toAccData = siNfsService.getToAccountDetails();
            	} else{
            		utilityService.showBhimUpiAlert("alert","No Accounts Available.","","Ok",$scope);
            	}         
	            
	        },function (error) {
	            utilityService.showBhimUpiAlert("alert",error.responseMessage,"","Ok",$scope);
            });
		}

		selAccountVm.selectedFromViewAccount = function(){
			selAccountVm.viewDetail.listOfSI = [];
			siNfsService.viewDetail.listOfSI = selAccountVm.viewDetail.listOfSI;
			var accNumber = JSON.parse(selAccountVm.viewDetail.fromAccountView).accountNumber;
			var brCode = JSON.parse(selAccountVm.viewDetail.fromAccountView).branchCode;
			var accNumberHash = loggedInUserService.tokenLotus + accNumber;
			var accNumberSHA512 = cryptoService.getSHA512EncryptedData(accNumberHash).toString();

			var obj = {
			  "accountNumber": accNumber,
			  "hash": accNumberSHA512,
			  "branchCode": brCode
			};

			siNfsService.getSIEnquiry(obj).then(function(data){
            	selAccountVm.viewDetail.listOfSI = data.siDetails;
            	siNfsService.viewDetail.listOfSI = selAccountVm.viewDetail.listOfSI;
            	if(selAccountVm.listOfSI.length > 0){

            	}else{
            		var alertPopup = $ionicPopup.alert({
						template: "<p class='roboto-regular color-darkgrey'>No SI are available for selected account.</p>"
					});
            	}
	        },function (error) {
	            utilityService.showBhimUpiAlert("alert",error.responseMessage,"","Ok",$scope);
            });

		}

		selAccountVm.viewSIDetails = function(item,index){
			siNfsService.siViewCancelDetails = item;
			if(index == '1'){
				siNfsService.isDeleteSI = false;
			}else{
				siNfsService.isDeleteSI = true;
			}
			$state.go("menu.siViewCancel");

		}

		selAccountVm.cancelSIDetails = function(){

		}

		selAccountVm.validateForm = function(){
			selAccountVm.errObj = {};
			

			if(!selAccountVm.detail.fromAccount){
				selAccountVm.errObj.fromAccount = "Please select From Account";
			}

			if(!selAccountVm.detail.toAccount){
				selAccountVm.errObj.toAccount = "Please select To Account";
			}

			if(!selAccountVm.detail.purpose){
				selAccountVm.errObj.purpose = "Please select purpose";
			}

			if(selAccountVm.detail.purpose == 'Others'){
				if(!selAccountVm.detail.purposeOther){
					selAccountVm.errObj.purposeOther = "Please enter purpose";
				}
			}
			if(!selAccountVm.detail.amount){
				selAccountVm.errObj.amount = "Please enter amount";
			}
			else{
				if(parseInt(selAccountVm.detail.amount) <= 0){
					selAccountVm.errObj.amount = "Please enter valid amount";
				}
			}

			// if(!selAccountVm.detail.freqCycle){
			// 	selAccountVm.errObj.freqCycle = "Please select frequency";
			// }
			if(!selAccountVm.detail.noOFPayment){
				selAccountVm.errObj.noOFPayment = "Please enter valid number of payments.";
			}else{
				if(parseInt(selAccountVm.detail.noOFPayment) < 2){
					selAccountVm.errObj.noOFPayment = "Please enter valid number of payments.";
				}
			}
			if(selAccountVm.detail.freqCycle == 'Months'){
				if(!selAccountVm.detail.noOfMonth){
					selAccountVm.errObj.noOfMonth = "Please select number of months.";
				}
			}

			if(selAccountVm.detail.freqCycle == 'Days'){
				if(!selAccountVm.detail.noOfDay){
					selAccountVm.errObj.noOfDay = "Please select number of days.";
				}
			}

			if(!selAccountVm.detail.startDate){
				selAccountVm.errObj.startDate = "Please select start date.";
			}



			
			return (angular.equals({}, selAccountVm.errObj)) ? true : false;
		}



		selAccountVm.showInstructions = function() {
            var request = {
                "type": "getNFSTnC"
            };



            chequeEnquiryService.getTnC(request).then(function(data) {

            	var title = '<h3 class="text-center">Terms and conditions</h3>';
                var buttontext = "OK";
                var detail = data;
                sampoornSurakshaService.displayPopUp(title, detail, buttontext,function(){});
            }, function(error) {
                utilityService.showBhimUpiAlert("alert",error.responseMessage,"","Ok",$scope);
            });
        }

        selAccountVm.openDatePicker = function(){
				var newDate = new Date();
				var nextDay = new Date();
				nextDay.setDate(newDate.getDate() + 1);
				var dateFromAPI = newDate.setMonth(newDate.getMonth() + 3);
				selAccountVm.dateObj = {
					callback: function (val) {
		                    var tomorrow = new Date(val);
		                    tomorrow.setDate(tomorrow.getDate() + 1);
		                    selAccountVm.detail.startDate = new Date(tomorrow).toISOString().slice(0,10);
						},
						inputDate: nextDay,
						monthsList:["JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC"],
						from: nextDay,
						to: dateFromAPI,
						mondayFirst: true,
						closeOnSelect: false,
						templateType: 'popup',
						dateFormat: 'dd MMM yyyy'

				};

				ionicDatePicker.openDatePicker(selAccountVm.dateObj);
		}

        $scope.$on('$ionicView.loaded', function () {
			//selAccountVm.detail = {};
		});

		$scope.$on('$ionicView.beforeEnter', function () {
			selAccountVm.classForMpinLoginOpt = 'tab-item tabs-style div-bottom bor-bot-active';
			selAccountVm.classForUserLoginOpt = 'tab-item tabs-style div-bottom';
			selAccountVm.detail = siNfsService.setNew.accDetails;
			selAccountVm.fromAccData = siNfsService.getFromAccountDetails();
			selAccountVm.toAccData = siNfsService.getToAccountDetails();
			selAccountVm.viewDetail = siNfsService.viewDetail;
			selAccountVm.selTab = siNfsService.myTab ;
			selAccountVm.selType(selAccountVm.selTab);
			
			siNfsService.purpose = [
				{ "key": "100","value":"Loan Servicing"},
				{ "key": "200","value":"Deposits"},
				{ "key": "300","value":"RD"},
				{ "key": "500", "value":"Locker"}
			];

			selAccountVm.purpose = siNfsService.purpose;

			//initialize basic values
			selAccountVm.freqCycles = ["Days","Months"];
			selAccountVm.noOfMonths = [{"key":"1","value":"1 Month"},{"key":"2","value":"2 Months"},
										{"key":"3","value":"3 Months"},{"key":"4","value":"4 Months"},
										{"key":"5","value":"5 Months"},{"key":"6","value":"6 Months"},
										{"key":"7","value":"7 Months"},{"key":"8","value":"8 Months"},
										{"key":"9","value":"9 Months"},{"key":"10","value":"10 Months"},
										{"key":"11","value":"11 Months"},{"key":"12","value":"12 Months"}];

			selAccountVm.noOfDays = [{"key":"1","value":"1 Day"},{"key":"7","value":"7 Days"},{"key":"14","value":"14 Days"},{"key":"28","value":"28 Days"}];

			if(!selAccountVm.detail.freqCycle){
				selAccountVm.detail.freqCycle = "Days";
			}

		});

		

		return this;
	}

]);
