'use strict';

angularApp.controller('selFrequencyController', ["$state",
	"$ionicPopup",
	"$scope",
	"$filter",
	"$ionicHistory",
	"loggedInUserService",
	"cryptoService",
	"utilityService",
	"ionicDatePicker",
	"chequeEnquiryService",
	"siNfsService",


	function ($state,
		$ionicPopup,
		$scope,
		$filter,
		$ionicHistory,
		loggedInUserService,
		cryptoService,
		utilityService,
		ionicDatePicker,
		chequeEnquiryService,
		siNfsService) {

		var selFrequencyVm = this;

		selFrequencyVm.goToNext =function(){
			//$state.go('menu.siReview');
			if(selFrequencyVm.validateForm()){
				console.log("success");
				siNfsService.setNew.freqDetails = selFrequencyVm.detail;
				$state.go('menu.siReview');
			}
		}

		selFrequencyVm.goToback=function(){
			$ionicHistory.goBack(-1);
		}

		selFrequencyVm.validateForm = function(){
			selFrequencyVm.errObj = {};

			if(!selFrequencyVm.detail.freqCycle){
				selFrequencyVm.errObj.freqCycle = "Please select frequency";
			}
			if(!selFrequencyVm.detail.noOFPayment){
				selFrequencyVm.errObj.noOFPayment = "Please enter number of payments.";
			}else{
				if(parseInt(selFrequencyVm.detail.noOFPayment) < 2){
					selFrequencyVm.errObj.noOFPayment = "Please enter number of payments greater than 2";
				}
			}
			if(selFrequencyVm.detail.freqCycle == 'Months'){
				if(!selFrequencyVm.detail.noOfMonth){
					selFrequencyVm.errObj.noOfMonth = "Please select number of months.";
				}
			}

			if(selFrequencyVm.detail.freqCycle == 'Days'){
				if(!selFrequencyVm.detail.noOfDay){
					selFrequencyVm.errObj.noOfDay = "Please select number of days.";
				}
			}

			if(!selFrequencyVm.detail.startDate){
				selFrequencyVm.errObj.startDate = "Please select start date.";
			}

			return (angular.equals({}, selFrequencyVm.errObj)) ? true : false;
		}

		selFrequencyVm.showInstructions = function() {
            var request = {
                "type": "getNFSTnC"
            };



            chequeEnquiryService.getTnC(request).then(function(data) {
                var titlePopup = "Instructions";
                var buttontext = "OK";
                var blankdata = null;
                var detail = $filter('ngBindHtmlFilter')(data);
                var tncStatus = $ionicPopup.show({
                    title: titlePopup,
                    cssClass: 'ftandcpopup-body popupBackgroundWhite popupWidth90 popupBackgroundDark',
                    template: data,
                    scope: $scope,
                    buttons: [

                        {
                            text: '<b>OK</b>',
                            type: 'button-positive',
                            onTap: function(e) {
                                tncStatus.close();
                            }
                        }
                    ]
                });
                //utilityService.showAlertModal(title, detail, blankdata, blankdata, $state, buttontext);
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

		selFrequencyVm.openDatePicker = function(){
				var newDate = new Date();
				//newDate.setMonth(newDate.getMonth() + 3);
				var dateFromAPI = newDate.setMonth(newDate.getMonth() + 12);
				selFrequencyVm.dateObj = {
					callback: function (val) {
		                    var tomorrow = new Date(val);
		                    tomorrow.setDate(tomorrow.getDate() + 1);
		                    selFrequencyVm.detail.startDate = new Date(tomorrow).toISOString().slice(0,10);
						},
						inputDate: new Date(),
						monthsList:["JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC"],
						from: new Date(),
						to: dateFromAPI,
						mondayFirst: true,
						closeOnSelect: false,
						templateType: 'popup',
						dateFormat: 'dd MMM yyyy'

				};

				ionicDatePicker.openDatePicker(selFrequencyVm.dateObj);
		}

		$scope.$on('$ionicView.loaded', function () {
			selFrequencyVm.detail = {};
		});

		$scope.$on('$ionicView.beforeEnter', function () {
			selFrequencyVm.detail = siNfsService.setNew.freqDetails;
			selFrequencyVm.freqCycles = ["Days","Months"];
			selFrequencyVm.noOfMonths = [{"key":"1","value":"1 Month"},{"key":"2","value":"2 Month"},
										{"key":"3","value":"3 Month"},{"key":"4","value":"4 Month"},
										{"key":"5","value":"5 Month"},{"key":"6","value":"6 Month"},
										{"key":"7","value":"7 Month"},{"key":"8","value":"8 Month"},
										{"key":"9","value":"9 Month"},{"key":"10","value":"10 Month"},
										{"key":"11","value":"11 Month"},{"key":"12","value":"12 Month"}];

			selFrequencyVm.noOfDays = [{"key":"1","value":"1 Day"},{"key":"7","value":"7 Days"},{"key":"14","value":"14 Days"},{"key":"28","value":"28 Days"}];
			
		});

		

		return this;
	}

]);
