'use strict';

angularApp.controller('siCreationOtpController', ["$timeout",
	"$state",
	"$ionicPopup",
	"$scope",
	"$filter",
	"$rootScope",
	"customerInfoService",
	"$ionicSideMenuDelegate",
	"$ionicScrollDelegate",
	"siNfsService",
	"fTSetOTPService",
	"utilityService",
	function ($timeout,
		$state, $ionicPopup,
		$scope,$filter,
		$rootScope,
		customerInfoService,
		$ionicSideMenuDelegate,
		$ionicScrollDelegate,
		siNfsService,
		fTSetOTPService,
		utilityService
		) {

		//functions, variables that can be accessed from the HTML come here
		var siCreationOtpVm = this;

		siCreationOtpVm.goToNext = function(){
			var reqParams = {};
			reqParams["otp"] = siCreationOtpVm.getOTPNumber;
			reqParams["mobile"] =customerInfoService.customer.mobile;
				
			fTSetOTPService.validateOTP(reqParams).then(function(response){
				siCreationOtpVm.createSI();
			}, function(error) {
			    utilityService.showBhimUpiAlert("alert",error.responseMessage,"","Ok",$scope);
			});

		}

		siCreationOtpVm.createSI = function(){
			var obj = siNfsService.createSI;
			siNfsService.createSIRequest(obj).then(function(response){  
				utilityService.setCsatJournies('siRequests');				
				var message = "Your Standing Instruction has been successfully created with reference number "+ response.referenceNumber +".";
            	utilityService.showBhimUpiAlert("success",message,"menu.serviceRequest","Ok",$scope);      
                //siCreationOtpVm.showRefNo(); 
             }, function(error) {
                utilityService.showBhimUpiAlert("alert",error.responseMessage,"","Ok",$scope);
             });
		}

		siCreationOtpVm.showRefNo = function(){
			var showPopup = $ionicPopup.show({
			templateUrl: 'pages/nfs/siCreationAndCancellation/siCreationSuccessPopUp.html',
			cssClass: 'dialog',
			buttons: [{
				text: 'Ok',
				type: 'button-positive',
				onTap: function(e) {
					showPopup.close();
					$state.go('menu.homeScreen');
					e.preventDefault();
						
				}
			}]
		});
		}

		siCreationOtpVm.resendOTP=function()
          {
            siCreationOtpVm.getOTPNumber="";
            siCreationOtpVm.isResendOTP=true;
            var reqData = {};
            utilityService.showSpinner();
             fTSetOTPService.generateOTP(reqData).then(function(response){              
                siCreationOtpVm.isResendDisabled=true;
                utilityService.hideSpinner();
             }, function(error) {
             	utilityService.hideSpinner();
               	utilityService.showBhimUpiAlert("alert",error.responseMessage,"","Ok",$scope);
             });
          }

        siCreationOtpVm.checkOTPLength = function(){
          	if(siCreationOtpVm.getOTPNumber.length==6)
		       {
		        
		         siCreationOtpVm.isNextEnabled=false;
		       }

		       else
		       {
		        siCreationOtpVm.isNextEnabled=true;
		       }
        }



		
		$scope.$on('$ionicView.beforeEnter', function () {
			siCreationOtpVm.isResendOTP=false;
         
			siCreationOtpVm.userMobile = $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4);
		    siCreationOtpVm.isResendDisabled=false;
		    siCreationOtpVm.clickCount=0;
		    siCreationOtpVm.disableNext=true;
		    siCreationOtpVm.isNextEnabled = true;
		});

	// siCreationOtpVm.goToNext = function () {
	// 		siCreationOtpVm.myPopup = $ionicPopup.show({
	// 			title: '',
	// 			cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
	// 			templateUrl: 'pages/nfs/siCreationAndCancellation/siCreationSuccessPopUp.html',
	// 			scope: $scope
	// 		})
	// 	}
		
      
		return this;
	}
]);
