'use strict';

angularApp.controller('siReviewController', ["$state",
	"$ionicPopup",
	"$scope",
	"$filter",
	"$ionicHistory",
	"loggedInUserService",
	"cryptoService",
	"utilityService",
	"siNfsService",
	"chequeEnquiryService",
	"fTSetOTPService",
	"sampoornSurakshaService",
	function ($state,
		$ionicPopup,
		$scope,
		$filter,
		$ionicHistory,
		loggedInUserService,
		cryptoService,
		utilityService,
		siNfsService,
		chequeEnquiryService,
		fTSetOTPService,
		sampoornSurakshaService) {

		var siReviewVm = this;

		siReviewVm.goToNext =function(){
			var reqData = {};
			utilityService.showSpinner();
            fTSetOTPService.generateOTP(reqData).then(function(response){
            	utilityService.hideSpinner();
		        $state.go('menu.siCreationOtp');
		        siNfsService.createSI = {
				  "fromAccount": siReviewVm.detail.fromAccount,
				  "toAccount": siReviewVm.detail.toAccount,
				  "siAmount": siReviewVm.detail.siAmount,
				  "purpose": siReviewVm.detail.siPurpose,
				  "frequencyCode": siReviewVm.detail.siFrequencyCode,
				  "frequency": siReviewVm.detail.siFrequency,
				  "numberOfPayments": siReviewVm.detail.siNoOfPayment,
				  "startDate": siReviewVm.detail.startDateWithFormat,
				  "branchCode": siReviewVm.detail.branchCode
				};
		    }, function(error) {
		    	utilityService.hideSpinner();
		        utilityService.showBhimUpiAlert("alert",error.responseMessage,"","Ok",$scope);
		    });
		}
		siReviewVm.goToback=function(){
			$ionicHistory.goBack(-1);
		}

		siReviewVm.viewSchedule = function(){
			siNfsService.scheduleDate = siNfsService.setNew.accDetails;
			$state.go('menu.siSchedule');
		}

		siReviewVm.viewSchedule = function(){
			var obj = {
			  "accountNumber": siReviewVm.detail.fromAccount,
			  "startDate": siReviewVm.detail.startDateWithFormat,
			  "frequency": siReviewVm.detail.siFrequency,
			  "numberOfPayments": siReviewVm.detail.siNoOfPayment,
			  "frequencyCode": siReviewVm.detail.siFrequencyCode
			};
			siNfsService.viewSISchedule(obj).then(function(data){
            	siNfsService.sceduleDetails=[];
            	siNfsService.sceduleDetails = data.paymentDetails;
            	$state.go('menu.siSchedule');

	        },function (error) {
	            utilityService.showBhimUpiAlert("alert",error.responseMessage,"","Ok",$scope);
            });
		}

		siReviewVm.loadTnc = function () {
			var request = {
                "type": "getNFSTnC"
            };

            chequeEnquiryService.getTnC(request).then(function(data) {

            	var title = '<h3 class="text-center">Terms and conditions</h3>';
                var buttontext = "OK";
                var detail = data;
                sampoornSurakshaService.displayPopUp(title, detail, buttontext,function(){});

      //           var titlePopup = '<h3 class="text-center">Terms and conditions</h3>';
      //           var buttontext = "OK";
      //           var blankdata = null;
      //           var detail = $filter('ngBindHtmlFilter')(data);
      //           var tncStatus = $ionicPopup.show({
      //               title: titlePopup,
      //               cssClass: 'ftandcpopup-body popupBackgroundWhite popupWidth90 popupBackgroundDark',
      //               template: data,
      //               scope: $scope,
      //               buttons: [
						// {
      //                       text: '<b>OK</b>',
      //                       type: 'button-positive',
      //                       onTap: function(e) {
      //                           tncStatus.close();
      //                       }
      //                   }
      //               ]
      //           });
                //utilityService.showAlertModal(title, detail, blankdata, blankdata, $state, buttontext);
            }, function(error) {
                utilityService.showBhimUpiAlert("alert",error.responseMessage,"","Ok",$scope);
            });
		}

		$scope.$on('$ionicView.beforeEnter', function () {
			siReviewVm.detail={};
			siReviewVm.accDetails = siNfsService.setNew.accDetails;
			siReviewVm.freqDetails = siNfsService.setNew.freqDetails;
			siReviewVm.detail.fromAccount = JSON.parse(siReviewVm.accDetails.fromAccount).accountNumber;
			siReviewVm.detail.toAccount = JSON.parse(siReviewVm.accDetails.toAccount).accountNumber;
			siReviewVm.detail.siAmount = siReviewVm.accDetails.amount;
			siReviewVm.detail.branchCode = siReviewVm.accDetails.branchCode;
			siReviewVm.detail.siPurpose = siReviewVm.accDetails.purpose;
			
			for(var i = 0; i< siNfsService.purpose.length;i++){
				if(siReviewVm.detail.siPurpose == siNfsService.purpose[i].key){
					siReviewVm.detail.siPurposeValue = siNfsService.purpose[i].value;
				}
			}
			
			siReviewVm.detail.startDate = siReviewVm.accDetails.startDate;
			if(siReviewVm.accDetails.freqCycle == 'Months'){
				siReviewVm.detail.siFrequency = siReviewVm.accDetails.noOfMonth;
				siReviewVm.detail.siFrequencyCode = "M";
			}
			if(siReviewVm.accDetails.freqCycle == 'Days'){
				siReviewVm.detail.siFrequency = siReviewVm.accDetails.noOfDay;
				siReviewVm.detail.siFrequencyCode = "D";
			}
			
			siReviewVm.detail.siNoOfPayment = siReviewVm.accDetails.noOFPayment;
			var myDate = siReviewVm.detail.startDate.split('-');
			siReviewVm.detail.startDateWithFormat = myDate[2]+"/"+myDate[1]+"/"+myDate[0];
			
		});

		

		return this;
	}

]);
