'use strict';

angularApp.controller('siViewCancelController', ["$state",
	"$ionicPopup",
	"$scope",
	"$rootScope",
	"$ionicHistory",
	"$filter",
	"loggedInUserService",
	"cryptoService",
	"utilityService",
	"siNfsService",
	function ($state,
		$ionicPopup,
		$scope,$rootScope,
		$ionicHistory,
		$filter,
		loggedInUserService,
		cryptoService,
		utilityService,
		siNfsService) {

		var siViewCancelVm = this;

		siViewCancelVm.goToNext = function(){
			if(!siViewCancelVm.detail.reasonForDelete){
				siViewCancelVm.errObj.reasonForDelete = "Please enter reason to delete.";
				return;
			}
			var obj = {
				  "branchCode": "",
				  "fromAccount": siViewCancelVm.detail.fromAccount,
				  "toAccount": siViewCancelVm.detail.toAccount,
				  "purpose": siViewCancelVm.detail.purpose,
				  "recordNumber": siViewCancelVm.detail.recordNumber,
				  "pushPullFlag": siViewCancelVm.detail.pushPullFlag
				};

			siNfsService.deleteSI(obj).then(function(data){
            	//show Popup
            	utilityService.setCsatJournies('siRequests');
            	var message = "Your Standing Instruction has been successfully cancelled with reference number "+ data.referenceNumber +".";
            	utilityService.showBhimUpiAlert("success",message,"menu.homeScreen","Ok",$scope);       
                //siViewCancelVm.showRefNo();

	        },function (error) {
	            utilityService.showBhimUpiAlert("alert",error.responseMessage,"","Ok",$scope);
            });

		}

		siViewCancelVm.showRefNo = function(){

			var showPopup = $ionicPopup.show({
				templateUrl: 'pages/nfs/siCreationAndCancellation/siDeletionSuccessPopUp.html',
				cssClass: 'dialog',
				buttons: [{
					text: 'Ok',
					type: 'button-positive',
					onTap: function(e) {
						showPopup.close();
						$state.go('menu.serviceRequest');
						e.preventDefault();
							
					}
				}]
			});
		}

		siViewCancelVm.goToback = function(){
			$ionicHistory.goBack(-1);
		}

		siViewCancelVm.viewSchedule = function(){
			var obj = {
			  "accountNumber": siViewCancelVm.detail.fromAccount,
			  "startDate": siViewCancelVm.detail.startDate,
			  "frequency": siViewCancelVm.detail.frequency,
			  "numberOfPayments": siViewCancelVm.detail.noOfPayments,
			  "frequencyCode": siViewCancelVm.detail.frequencyCode
			};
			siNfsService.viewSISchedule(obj).then(function(data){
            	siNfsService.sceduleDetails=[];
            	siNfsService.sceduleDetails = data.paymentDetails;
            	$state.go('menu.siSchedule');

	        },function (error) {
	            utilityService.showBhimUpiAlert("alert",error.responseMessage,"","Ok",$scope);
            });
		}


		$scope.$on('$ionicView.beforeEnter', function() {
			siViewCancelVm.detail =siNfsService.siViewCancelDetails;
			if(siNfsService.isDeleteSI){
				siViewCancelVm.isDelete = true;
			}

			for(var i = 0; i< siNfsService.purpose.length;i++){
				if(siViewCancelVm.detail.purpose == siNfsService.purpose[i].key){
					siViewCancelVm.detail.siPurposeValue = siNfsService.purpose[i].value;
				}
			}
		});

		return this;
	}

]);
