'use strict';

angularApp.controller('smsAlertActivationController', ["$state",
	"$ionicPopup",
	"$scope",
	"$filter",
	"loggedInUserService",
	"cryptoService",
	"smsAlertActivationService",
	"utilityService",
	"feedebackService",
	"AdapterUtils",



	function ($state,
		$ionicPopup,
		$scope,
		$filter,
		loggedInUserService,
		cryptoService,
		smsAlertActivationService,
		utilityService,
		feedebackService,
		AdapterUtils) {

		var smsAlertActivationVm = this;
		smsAlertActivationVm.disableAlert = false;



		smsAlertActivationVm.disableAlertFun = function () {
			if (smsAlertActivationVm.disableAllSms == "N") {
				smsAlertActivationVm.disableAlert = false;
			} else {
				smsAlertActivationVm.disableAlert = true;
			}
		}

		smsAlertActivationVm.validate = function () {
			smsAlertActivationVm.disableAlert = false;
			smsAlertActivationVm.myPopup.close();

		}

		smsAlertActivationVm.mayBeLater = function () {
			smsAlertActivationService.clearAll();
			smsAlertActivationVm.myPopup.close();
			$state.go('menu.homeScreen');

		}


		smsAlertActivationVm.submit = function () {
			smsAlertActivationVm.disableAlert = true;
			if (angular.equals(smsAlertActivationService.oldenquiryData, smsAlertActivationService.enquiryData)) {

                
				smsAlertActivationVm.myPopup = $ionicPopup.show({
					title: '',
					cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
					templateUrl: 'pages/nfs/smsAlertActivation/validate.html',
					scope: $scope
				})



			} else {

				var hashReqData = loggedInUserService.tokenLotus + smsAlertActivationService.selectedAccount.accountNumber + smsAlertActivationService.enquiryData.chequeBookIssue + smsAlertActivationService.enquiryData.chequeDishonorAlert + smsAlertActivationService.enquiryData.chequeStopAlert + smsAlertActivationService.enquiryData.creditThresholdAlert + smsAlertActivationService.enquiryData.holdAccountBalance + smsAlertActivationService.enquiryData.mobileNumber + smsAlertActivationService.enquiryData.removeHoldAccountBalance + smsAlertActivationService.enquiryData.balanceThresholdAlert + smsAlertActivationService.enquiryData.debitThresholdAlert + smsAlertActivationService.enquiryData.debitCardUsageAlert + smsAlertActivationService.enquiryData.disableAllAlerts;
				var ReqDatasha512 = cryptoService.getSHA512EncryptedData(hashReqData).toString();

				var reqParams = {

					"accountNumber": smsAlertActivationService.selectedAccount.accountNumber,
					"mobileNumber": smsAlertActivationService.enquiryData.mobileNumber,
					"chequeStopAlert": smsAlertActivationService.enquiryData.chequeStopAlert,
					"chequeDishonorAlert": smsAlertActivationService.enquiryData.chequeDishonorAlert,
					"chequeBookIssue": smsAlertActivationService.enquiryData.chequeBookIssue,
					"debitThresholdAlert": smsAlertActivationService.enquiryData.debitThresholdAlert,
					"creditThresholdAlert": smsAlertActivationService.enquiryData.creditThresholdAlert,
					"balanceThresholdAlert": smsAlertActivationService.enquiryData.balanceThresholdAlert,
					"holdAccountBalance": smsAlertActivationService.enquiryData.holdAccountBalance,
					"removeHoldAccountBalance": smsAlertActivationService.enquiryData.removeHoldAccountBalance,
					"disableAllAlerts": smsAlertActivationService.enquiryData.disableAllAlerts,
					"debitCardUsageAlert": smsAlertActivationService.enquiryData.debitCardUsageAlert,
					"hash": ReqDatasha512

				}
				smsAlertActivationService.updateSMSAlerts(reqParams).then(function (data) {
					smsAlertActivationVm.reviewAccount = smsAlertActivationService.selectedAccount.accountNumber
					smsAlertActivationVm.myPopup = $ionicPopup.show({
						title: '',
						cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
						templateUrl: 'pages/nfs/smsAlertActivation/smsSuccessPopUp.html',
						scope: $scope
					})


				}, function (error) {
					smsAlertActivationService.clearAll();
					utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
				});

			}




		}

		smsAlertActivationVm.ok = function () {
			smsAlertActivationService.clearAll();
			smsAlertActivationVm.myPopup.close();
			utilityService.setCsatJournies('smsAlerts');
			smsAlertActivationVm.getCSATDetails();

		};
			smsAlertActivationVm.getCSATDetails = function () {
			
	
			if (utilityService.timeSpent > 0) {
				utilityService.setCsatJournies('ompShoppingDeals');
			}
			var allJournies = utilityService.getCsatJournies();
			feedebackService.getFeedbackData(allJournies).then(function (data) {
				utilityService.hideSpinner();
				if (!data || data == null) {
			utilityService.hideSpinner();
			$state.go('menu.feedback');
				} else {
					
					feedebackService.data = data;
					utilityService.hideSpinner();
			$state.go('menu.feedback');
				}
			}, function (error) {
				utilityService.hideSpinner();
			
				loggedInUserService.logoutUser();
			});
		
		}

		smsAlertActivationVm.sendBoolean = function (value) {
			if (value == "Y") {
				return true;
			}
			return false;
		}
		smsAlertActivationVm.init = function () {
			smsAlertActivationVm.nextEnable();
			smsAlertActivationVm.gettingCreditErorr = false;
			smsAlertActivationVm.gettingDebitedtErorr = false;
			smsAlertActivationVm.balanceFallErorr = false;

			if (utilityService.isAndroidPlatform()) {
				smsAlertActivationVm.scrollDevice = true;
			}

			if (utilityService.isIOSPlatform()) {
				smsAlertActivationVm.scrollDevice = false;
			}

		}

		smsAlertActivationVm.setDefalut = function () {
			smsAlertActivationVm.chequeBookIssue = "N";
			smsAlertActivationVm.chequeStopAlert = "N";
			smsAlertActivationVm.chequeDishonorAlert = "N";
			smsAlertActivationVm.setHold = "N";
			smsAlertActivationVm.removeHold = "N";
			smsAlertActivationVm.gettingCreditErorr = false;
			smsAlertActivationVm.gettingDebitedtErorr = false;
			smsAlertActivationVm.balanceFallErorr = false;

		}

		smsAlertActivationVm.selectedAccFun = function () {
			smsAlertActivationVm.setDefalut();
			smsAlertActivationService.selectedAccount = smsAlertActivationVm.selectedAccount == "" ? null : JSON.parse(smsAlertActivationVm.selectedAccount);
			if (smsAlertActivationService.selectedAccount) {

				var reqData = {
					"accountNumber": smsAlertActivationService.selectedAccount.accountNumber
				}
				smsAlertActivationService.getSMSEnquiry(reqData).then(function (data) {
					smsAlertActivationService.enquiryData = data;
					smsAlertActivationService.oldenquiryData = angular.copy(data);
					smsAlertActivationVm.chequeBookIssue = smsAlertActivationVm.sendBoolean(smsAlertActivationService.enquiryData.chequeBookIssue);
					smsAlertActivationVm.chequeStopAlert = smsAlertActivationVm.sendBoolean(smsAlertActivationService.enquiryData.chequeStopAlert);
					smsAlertActivationVm.chequeDishonorAlert = smsAlertActivationVm.sendBoolean(smsAlertActivationService.enquiryData.chequeDishonorAlert);
					smsAlertActivationVm.setHold = smsAlertActivationVm.sendBoolean(smsAlertActivationService.enquiryData.holdAccountBalance);
					smsAlertActivationVm.removeHold = smsAlertActivationVm.sendBoolean(smsAlertActivationService.enquiryData.removeHoldAccountBalance);
					smsAlertActivationVm.debitThresholdAlert = smsAlertActivationService.enquiryData.debitThresholdAlert;
					smsAlertActivationVm.gettingCredit = smsAlertActivationService.enquiryData.creditThresholdAlert;
					smsAlertActivationVm.balanceFalls = smsAlertActivationService.enquiryData.balanceThresholdAlert;
					smsAlertActivationVm.disableAllSms = smsAlertActivationService.enquiryData.disableAllAlerts;
					smsAlertActivationVm.debitCardusageAlert = smsAlertActivationVm.sendBoolean(smsAlertActivationService.enquiryData.debitCardUsageAlert);
					smsAlertActivationVm.disableAllSmsFun();
				}, function (error) {
					utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
				});

			} else {

			}
			smsAlertActivationVm.nextEnable();


		}
		smsAlertActivationVm.gettingCreditFun = function () {
			smsAlertActivationService.enquiryData.creditThresholdAlert = smsAlertActivationVm.gettingCredit;
			if (smsAlertActivationService.enquiryData.creditThresholdAlert < 5000 || smsAlertActivationService.enquiryData.creditThresholdAlert == "") {
				smsAlertActivationVm.gettingCreditErorr = true;
			} else {
				smsAlertActivationVm.gettingCreditErorr = false;
			}
			smsAlertActivationVm.nextEnable();
		}

		smsAlertActivationVm.gettingDebitedFun = function () {
			smsAlertActivationService.enquiryData.debitThresholdAlert = smsAlertActivationVm.debitThresholdAlert;
			if (smsAlertActivationService.enquiryData.debitThresholdAlert < 5000 || smsAlertActivationService.enquiryData.debitThresholdAlert == "") {
				smsAlertActivationVm.gettingDebitedtErorr = true;
			} else {
				smsAlertActivationVm.gettingDebitedtErorr = false;
			}
			smsAlertActivationVm.nextEnable();
		}

		smsAlertActivationVm.balanceFallFun = function () {
			smsAlertActivationService.enquiryData.balanceThresholdAlert = smsAlertActivationVm.balanceFalls;
			if (smsAlertActivationService.enquiryData.balanceThresholdAlert <= 0 || smsAlertActivationService.enquiryData.balanceThresholdAle == "") {
				smsAlertActivationVm.balanceFallErorr = true;
			} else {
				smsAlertActivationVm.balanceFallErorr = false;
			}
			smsAlertActivationVm.nextEnable();

		}

		smsAlertActivationVm.goToback = function () {
			smsAlertActivationService.clearAll();
			$state.go('menu.serviceRequest');
		}

		smsAlertActivationVm.goToHome = function () {
			smsAlertActivationService.clearAll();
			$state.go('menu.homeScreen');
		}

		smsAlertActivationVm.chequeBookIssueFun = function () {
			if (smsAlertActivationVm.chequeBookIssue) {

				smsAlertActivationService.enquiryData.chequeBookIssue = "Y";
			} else {

				smsAlertActivationService.enquiryData.chequeBookIssue = "N";
			}
		}

		smsAlertActivationVm.chequeStopAlertFun = function () {
			if (smsAlertActivationVm.chequeStopAlert) {

				smsAlertActivationService.enquiryData.chequeStopAlert = "Y";
			} else {

				smsAlertActivationService.enquiryData.chequeStopAlert = "N";
			}
		}

		smsAlertActivationVm.chequeDishonorAlertFun = function () {
			if (smsAlertActivationVm.chequeDishonorAlert) {

				smsAlertActivationService.enquiryData.chequeDishonorAlert = "Y";
			} else {

				smsAlertActivationService.enquiryData.chequeDishonorAlert = "N";
			}
		}

		smsAlertActivationVm.setHoldFun = function () {
			if (smsAlertActivationVm.setHold) {

				smsAlertActivationService.enquiryData.holdAccountBalance = "Y";
			} else {

				smsAlertActivationService.enquiryData.holdAccountBalance = "N";
			}
		}

		smsAlertActivationVm.removeHoldFun = function () {
			if (smsAlertActivationVm.removeHold) {

				smsAlertActivationService.enquiryData.removeHoldAccountBalance = "Y";
			} else {

				smsAlertActivationService.enquiryData.removeHoldAccountBalance = "N";
			}
		}

		smsAlertActivationVm.debitCardusageAlertFun = function () {

			if (smsAlertActivationVm.debitCardusageAlert) {

				smsAlertActivationService.enquiryData.debitCardUsageAlert = "Y";
			} else {

				smsAlertActivationService.enquiryData.debitCardUsageAlert = "N";
			}

		}

		smsAlertActivationVm.disableAllSmsFun = function () {

			if (smsAlertActivationVm.disableAllSms == "Y") {

				smsAlertActivationService.enquiryData.disableAllAlerts = "Y";
			} else {

				smsAlertActivationService.enquiryData.disableAllAlerts = "N";
			}
			smsAlertActivationVm.disableAlertFun();

		}

		smsAlertActivationVm.nextEnable = function () {
			if (smsAlertActivationVm.selectedAccount && smsAlertActivationVm.gettingCreditErorr == false && smsAlertActivationVm.gettingDebitedtErorr == false && smsAlertActivationVm.balanceFallErorr == false) {
				smsAlertActivationVm.isNextEnabled = false;
			} else {
				smsAlertActivationVm.isNextEnabled = true;
			}
		}

		smsAlertActivationVm.chargesPopUp = function(){

			smsAlertActivationService.getChargesPopup().then(function (data) {
				
				smsAlertActivationVm.getchargeDetails = data.body;
			
			}, function (error) {
				utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
			});


			smsAlertActivationVm.myPopup = $ionicPopup.show({
                title: '',
                cssClass: 'new-purp-popup my-custom-popup',
                templateUrl: 'pages/nfs/smsAlertActivation/smsAlertActivationChargesPopUp.html',
                scope: $scope
            })

		}

		smsAlertActivationVm.closepopup = function(){
			smsAlertActivationVm.myPopup.close();
			
		}
		$scope.$on('$ionicView.beforeEnter', function () {

			smsAlertActivationService.getAccountsForSMSAlerts().then(function (data) {
				smsAlertActivationVm.accList = data.accList;
				smsAlertActivationService.accList = smsAlertActivationVm.accList;
			}, function (error) {
				utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
			});

			smsAlertActivationVm.init();

		});

		return this;
	}

]);
