'use strict';

angularApp.controller('stopChequeController', ["$state",
	"$ionicPopup",
	"$scope",
	"stopChequeService",
	"serviceRequestService",
	"utilityService",

	function ($state,
		$ionicPopup,
		$scope,
		stopChequeService,
		serviceRequestService,
		utilityService) {

		var stopChequeVm = this;

		stopChequeVm.isNextEnable = true;

		stopChequeVm.init = function () {
			stopChequeVm.typesOfCheque = stopChequeService.typesOfCheque;
			stopChequeVm.EnterCheque = stopChequeService.EnterCheque;
			stopChequeVm.toCheque = stopChequeService.toCheque;
			stopChequeVm.fromCheque = stopChequeService.fromCheque;
			stopChequeVm.selectedCardType = stopChequeService.selectedCardType;
			stopChequeVm.stopReason = stopChequeService.stopReason;
			stopChequeVm.multiSelectedCardType = stopChequeService.multiSelectedCardType;
			stopChequeVm.selectedAccount = stopChequeService.selectedAccValue == null ? "" : JSON.stringify(stopChequeService.selectedAccValue);
			stopChequeVm.nextEnable();
		}

		stopChequeVm.stopReasonFun = function () {
			stopChequeService.stopReason = stopChequeVm.stopReason;
			stopChequeVm.nextEnable();
		}



		stopChequeVm.goToNext = function () {
			$state.go('menu.stopChequeReview');
		}

		stopChequeVm.goToHome = function () {
			stopChequeService.clearAll();
			$state.go('menu.homeScreen');

		}

		stopChequeVm.goToback = function () {
			stopChequeService.clearAll();
			if(serviceRequestService.backFlag=="emergencyFlag"){
			$state.go('menu.serviceRequest')
		}else
			{
			$state.go('menu.innerPage');
		}
		}
		stopChequeVm.selectedAccountFun = function () {
			stopChequeService.selectedAccValue = stopChequeVm.selectedAccount == "" ? null : JSON.parse(stopChequeVm.selectedAccount);
			stopChequeVm.nextEnable();
		}

		stopChequeVm.enterCheque = function () {
			if (stopChequeVm.EnterCheque.length < 6) {

				stopChequeVm.isValidError = true;

			} else {
				stopChequeVm.isValidError = false;
				stopChequeService.EnterCheque = stopChequeVm.EnterCheque;
			}
			stopChequeVm.nextEnable();
		}

		stopChequeVm.fromChequeFun = function () {
			if (stopChequeVm.fromCheque.length < 6) {
				stopChequeVm.fromChequeError = true;
				stopChequeVm.validCheckrange = false;

			} else if (parseInt(stopChequeVm.toCheque) < parseInt(stopChequeVm.fromCheque)) {

				stopChequeVm.fromChequeError = false;
				stopChequeVm.validCheckrange = true;
				stopChequeVm.isNextEnable = true;

			} else {
				stopChequeVm.fromChequeError = false;
				stopChequeVm.validCheckrange = false;
				stopChequeService.fromCheque = stopChequeVm.fromCheque;
			}
			stopChequeVm.nextEnable();
		}


		stopChequeVm.toChequeFun = function () {
			if (stopChequeVm.toCheque.length < 6) {
				stopChequeVm.toChequeError = true;
				stopChequeVm.validCheckrange = false;




			} else if (parseInt(stopChequeVm.toCheque) < parseInt(stopChequeVm.fromCheque)) {

				stopChequeVm.toChequeError = false;
				stopChequeVm.validCheckrange = true;
				stopChequeVm.isNextEnable = true;

			}
			else {
				stopChequeVm.toChequeError = false;
				stopChequeVm.validCheckrange = false;
				stopChequeService.toCheque = stopChequeVm.toCheque;
			}


			stopChequeVm.nextEnable();
		}



		stopChequeVm.selectedTabFun = function () {
			stopChequeService.typesOfCheque = stopChequeVm.typesOfCheque;
			stopChequeVm.selectedAccount = "";
			stopChequeVm.selectedCardType = "";
			stopChequeVm.toCheque = "";
			stopChequeVm.fromCheque = "";
			stopChequeVm.EnterCheque = "";
			stopChequeVm.multiSelectedCardType = "";
			stopChequeVm.stopReason = "";
			stopChequeVm.nextEnable();
		}

		stopChequeVm.getAccountList = function () {
			if (!stopChequeService.accList.length) {
				
				var reqData = {
					"journey": "STOP",
				}
				stopChequeService.chequeAccountFilterRequest(reqData).then(function (data) {
					stopChequeService.accList = data.accList;
					stopChequeVm.accList = stopChequeService.accList;


					
				}, function (error) {
					utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
				});

			} else {
				stopChequeVm.accList = stopChequeService.accList;
				stopChequeVm.selectedAccount = stopChequeService.selectedAccValue == null ? "" : JSON.stringify(stopChequeService.selectedAccValue);
			}
			stopChequeVm.nextEnable();

		}

		stopChequeVm.selectedCardTypeFun = function () {
			stopChequeService.selectedCardType = stopChequeVm.selectedCardType;
			stopChequeVm.nextEnable();
		}
		stopChequeVm.multiSelectedCardTypeFun = function () {
			stopChequeService.multiSelectedCardType = stopChequeVm.multiSelectedCardType;
			stopChequeVm.nextEnable();
		}

		stopChequeVm.nextEnable = function () {

			if (stopChequeService.typesOfCheque == "single") {

				if (stopChequeVm.selectedAccount != undefined && stopChequeVm.selectedAccount != null && stopChequeVm.selectedAccount != "" && stopChequeVm.EnterCheque != "" && stopChequeVm.EnterCheque != null && stopChequeVm.EnterCheque != undefined && stopChequeVm.EnterCheque.length === 6 && stopChequeVm.selectedCardType != "" && stopChequeVm.selectedCardType != null && stopChequeVm.selectedCardType != undefined && stopChequeVm.stopReason != "" && stopChequeVm.stopReason != undefined && stopChequeVm.stopReason != null) {
					stopChequeVm.isNextEnable = false;
				} else {
					stopChequeVm.isNextEnable = true;
				}


			} else {

				if (stopChequeVm.selectedAccount != undefined && stopChequeVm.selectedAccount != null && stopChequeVm.selectedAccount != "" && stopChequeVm.fromCheque != "" && stopChequeVm.fromCheque != null && stopChequeVm.fromCheque != undefined && stopChequeVm.fromCheque.length === 6 && stopChequeVm.toCheque != "" && stopChequeVm.toCheque != undefined && stopChequeVm.toCheque != null && stopChequeVm.toCheque.length === 6 && stopChequeVm.stopReason != "" && stopChequeVm.stopReason != undefined && stopChequeVm.stopReason != null && stopChequeVm.multiSelectedCardType != "" && stopChequeVm.multiSelectedCardType != null && stopChequeVm.multiSelectedCardType != undefined && parseInt(stopChequeVm.fromCheque) <= parseInt(stopChequeVm.toCheque)) {
					stopChequeVm.isNextEnable = false;
				} else {
					stopChequeVm.isNextEnable = true;
				}

			}

		}


		$scope.$on('$ionicView.loaded', function () {
			stopChequeVm.getAccountList();



		});

		$scope.$on('$ionicView.beforeEnter', function () {

			stopChequeVm.init();

		});

		return this;
	}
]);
