'use strict';

angularApp.controller('stopChequeReviewController', ["$state",
	"$ionicPopup",
	"$scope",
	"stopChequeService",
	"utilityService",
	function ($state,
		$ionicPopup,
		$scope,
		stopChequeService,
		utilityService) {

		var stopChequeReviewVm = this;
		stopChequeReviewVm.isNextEnabled = true;
		stopChequeReviewVm.fromCheque = stopChequeService.fromCheque;
		stopChequeReviewVm.typesOfCheque = stopChequeService.typesOfCheque;
		stopChequeReviewVm.toCheque = stopChequeService.toCheque;
		stopChequeReviewVm.EnterCheque = stopChequeService.EnterCheque;
		stopChequeReviewVm.accountNumber = stopChequeService.selectedAccValue.accountNumber;
		stopChequeReviewVm.accountType = stopChequeService.selectedAccValue.accountType;
		stopChequeReviewVm.branchName = stopChequeService.selectedAccValue.branchName;
		stopChequeReviewVm.stopReason = stopChequeService.stopReason;
		stopChequeReviewVm.selectedCardType = stopChequeService.selectedCardType;
		


		if (stopChequeService.typesOfCheque == "single") {
			stopChequeReviewVm.singleChequeData = true;
		} else {
			stopChequeReviewVm.multipleChequeData = true;
		}

		stopChequeReviewVm.goToback = function () {
			$state.go('menu.stopCheque');
		}

		stopChequeReviewVm.goToHome = function () {
			stopChequeService.clearAll();
			
			$state.go('menu.homeScreen');
			
		}



		stopChequeReviewVm.goToNext = function () {

			if (stopChequeService.typesOfCheque == "single") {
				var requestData = {
					"type":stopChequeService.typesOfCheque,
					"branchCode": stopChequeService.selectedAccValue.branchCode,
					"accountNumber": stopChequeService.selectedAccValue.accountNumber,
					"fromChequeNumber": stopChequeService.EnterCheque,
					"toChequeNumber": stopChequeService.EnterCheque,
					"type": stopChequeService.typesOfCheque,
					"stopReason": stopChequeService.stopReason,
					"instrumentType": stopChequeService.selectedCardType,
					"accountType": stopChequeService.selectedAccValue.accountType,
					"termsNcondition": true
				}

			} else {
				var requestData = {
					"type":stopChequeService.typesOfCheque,
					"branchCode": stopChequeService.selectedAccValue.branchCode,
					"accountNumber": stopChequeService.selectedAccValue.accountNumber,
					"fromChequeNumber": stopChequeService.fromCheque,
					"toChequeNumber": stopChequeService.toCheque,
					"type": stopChequeService.typesOfCheque,
					"stopReason": stopChequeService.stopReason,
					"instrumentType": stopChequeService.multiSelectedCardType,
					"accountType": stopChequeService.selectedAccValue.accountType,
					"termsNcondition": true
				}
			}

			stopChequeService.stopChequeRequest(requestData).then(function (data) {
				
				stopChequeReviewVm.referenceNumber = data.referenceNumber;
				stopChequeReviewVm.myPopup = $ionicPopup.show({
								title: '',
								cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
								templateUrl: 'pages/nfs/stopCheque/Congratulations.html',
								scope: $scope
							});
			
			}, function (error) {
				stopChequeService.clearAll();
				 utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
			
			});


		}


	stopChequeReviewVm.ok = function () {
		   stopChequeService.clearAll();
		   utilityService.setCsatJournies('stopCheque');
			stopChequeReviewVm.myPopup.close();
			 $state.go('menu.homeScreen');
			
		};

		stopChequeReviewVm.tncStateCheck = function () {
		stopChequeReviewVm.nextEnable();
	}

		stopChequeReviewVm.nextEnable = function () {

		if (stopChequeReviewVm.tncCheck == true) {
			stopChequeReviewVm.isNextEnabled = false;
		} else {
			stopChequeReviewVm.isNextEnabled = true;
		}

	}

		stopChequeReviewVm.tncFun = function () {

			var requestData = {
			"type": "getStopChequeTnC"
		};

		stopChequeService.getTnC(requestData).then(function (data) {
			stopChequeReviewVm.tncData = data;
		

			var alertPopup = $ionicPopup.alert({
			title: 'Terms and Conditions',
			templateUrl: 'pages/nfs/stopCheque/stopCheque_tncPopup.html',
			scope: $scope,
			cssClass: 'bi-table',
			buttons: [
				{
					text: 'OK',
					type: 'button-positive',
					onTap: function (e) {
						return true;
					}
				}]
		});
			
		}, function (error) {
			utilityService.showErrorMessage(error.responseMessage);
			stopChequeReviewVm.isNextEnabled = true;
			
		});



		
	}

	



		$scope.$on('$ionicView.loaded', function () {

		



	});



return this;
	}
]);
