'use strict';
angularApp.controller('updateCardDetailsController', [
		"$state",
		"$scope",		
		"utilityService","getAccountDetailsService","nfsService","$filter","$ionicPopup","customerInfoService",
		
		function($state, $scope,utilityService,getAccountDetailsService,nfsService,$filter,$ionicPopup,customerInfoService) {
			
			var updateCardDetailsVm = this;

			updateCardDetailsVm.initPage = function(){
				updateCardDetailsVm.showSelect = true;
				nfsService.getAccountDetails().then(function (data) {
					updateCardDetailsVm.accList = data.accList;
					 if(updateCardDetailsVm.accList.length == 0){
						nfsService.displayPopUp("","padBtm25 top-padding26","No Accounts available","OK",function(){
							$state.go('menu.homeScreen');
						});
					 }else{
						updateCardDetailsVm.balance = updateCardDetailsVm.accList[0].accountBalance;
						updateCardDetailsVm.accType = updateCardDetailsVm.accList[0].accountType;
						updateCardDetailsVm.accountNumber = updateCardDetailsVm.accList[0].accountNumber;
						updateCardDetailsVm.showSelect = false;
						updateCardDetailsVm.getActiveCards();
					 }
				}, function (error) {
					nfsService.displayPopUp("","padBtm25 top-padding26",error.responseMessage,"OK",function(){
						$state.go('menu.homeScreen');
					});
				});
			}

			updateCardDetailsVm.getActiveCards = function(){
				var request = {
					"accountNumber": updateCardDetailsVm.accountNumber
				}
				nfsService.getCardsList(request).then(function (data) {
					updateCardDetailsVm.cardNumbers = data.cardList;
					updateCardDetailsVm.atmCard = "";
					updateCardDetailsVm.atmError = "";
					updateCardDetailsVm.cardNumberError = "";
					updateCardDetailsVm.atmCardError = "";
					updateCardDetailsVm.accountError = "";
					if(updateCardDetailsVm.cardNumbers.length == 0){
						nfsService.displayPopUp("","padBtm25 top-padding26","No active Cards found","OK",function(){
							//$state.go('menu.homeScreen');
						});
					 }
				}, function (error) {
					nfsService.displayPopUp("","padBtm25 top-padding26",error.responseMessage,"OK",function(){
						//$state.go('menu.homeScreen');
					});
				});
			}

			updateCardDetailsVm.showPop = function(){
				updateCardDetailsVm.popUp = $ionicPopup.show({
					title: '',
					cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
					templateUrl: 'pages/nfs/updateMobileNumber/dropdownModal.html',
					scope: $scope
				});
			}

			updateCardDetailsVm.close = function(index){
				updateCardDetailsVm.popUp.close();
				updateCardDetailsVm.balance = updateCardDetailsVm.accList[index].accountBalance;
				updateCardDetailsVm.accType = updateCardDetailsVm.accList[index].accountType;
				updateCardDetailsVm.accountNumber = updateCardDetailsVm.accList[index].accountNumber;
				updateCardDetailsVm.showSelect = false;
				updateCardDetailsVm.getActiveCards();
			}

			updateCardDetailsVm.goNext = function(){
				updateCardDetailsVm.atmError = "";
				updateCardDetailsVm.cardNumberError = "";
				updateCardDetailsVm.accountError = "";
				updateCardDetailsVm.atmCardError = "";
				updateCardDetailsVm.isError = false;
				if(!updateCardDetailsVm.cardNumber){
					updateCardDetailsVm.cardNumberError = "Please Enter Debit Card Number";
					updateCardDetailsVm.isError = true;
				}
				if(updateCardDetailsVm.cardNumber && updateCardDetailsVm.cardNumber.length != 16){
					updateCardDetailsVm.cardNumberError = "Enter Valid Debit Card Number";
					updateCardDetailsVm.isError = true;
				}
				if(!updateCardDetailsVm.atmPin){
					updateCardDetailsVm.atmError = "Please Enter ATM Pin";
					updateCardDetailsVm.isError = true;
				}
				if(updateCardDetailsVm.atmPin && updateCardDetailsVm.atmPin.length != 4){
					updateCardDetailsVm.atmError = "Enter Valid ATM PIN";
					updateCardDetailsVm.isError = true;
				}
				if(updateCardDetailsVm.showSelect){
					updateCardDetailsVm.accountError = "Select Account Number";
					updateCardDetailsVm.isError = true;
				}
				if(!updateCardDetailsVm.atmCard){
					updateCardDetailsVm.atmCardError = "Select Atm Card";
					updateCardDetailsVm.isError = true;
				}
				if(!updateCardDetailsVm.isError){
					var finalThreeDES = "";
					var strPIN = "0";
					var PIN = updateCardDetailsVm.atmPin;
					var pinLength = PIN.toString().length;
					var strHLen = pinLength.toString();
					strPIN = strPIN + strHLen;
					strPIN = strPIN + PIN;
					var yourNumber4 = strPIN.length;
					var lastValue = []
					for (yourNumber4; yourNumber4 < 16; yourNumber4++) {
						lastValue.push('F');
					}
					strPIN = strPIN + (lastValue.toString()).replace(/[^a-zA-Z ]/g, "");
					var strPAN = "0000";
					var pandigit = updateCardDetailsVm.cardNumber;
					var resource = pandigit.slice(-13);
					var resource1 = resource.slice(0, 12);
					strPAN = strPAN + resource1;
					var s = strPAN.toString();
					var hexToBinary = function(s) {
						var i, k, part, ret = '';
						var lookupTable = {
							'0': '0000', '1': '0001', '2': '0010', '3': '0011', '4': '0100',
							'5': '0101', '6': '0110', '7': '0111', '8': '1000', '9': '1001',
							'a': '1010', 'b': '1011', 'c': '1100', 'd': '1101',
							'e': '1110', 'f': '1111',
							'A': '1010', 'B': '1011', 'C': '1100', 'D': '1101',
							'E': '1110', 'F': '1111'
						};
						for (i = 0; i < s.length; i += 1) {
							if (lookupTable.hasOwnProperty(s[i])) {
								ret += lookupTable[s[i]];
							} else {
								return { valid: false };
							}
						}
						return { valid: true, result: ret };
					}

					var output1 = hexToBinary(strPIN);
					var strBPIN = output1.result;
					var output2 = hexToBinary(strPAN);
					var strBPAN = output2.result;
					var result = "0100" ^ "0101";
					var FinalOutput = strBPIN;
					var FinalOutput2 = strBPAN;
					var Slice1 = FinalOutput;
					var SlicePan = FinalOutput2;
					var FinalSlice1 = "";
					var FinalSlice2 = "";
					var strXOR = "";
					var finalXor = [];
					var blockLen = strBPIN / 4;
					var xorStr = "";
					for (var i = 0; i <= 15; i++) {
						FinalSlice1 = strBPIN.slice(i * 4, i * 4 + 4);
						FinalSlice2 = strBPAN.slice(i * 4, i * 4 + 4);
						var xorBahubali = FinalSlice1 ^ FinalSlice2;
						for (var j = 0; j < 4; j++) {
							var pinBit = FinalSlice1.slice(j, j + 1)
							var panBit = FinalSlice2.slice(j, j + 1)
							xorStr = xorStr + (pinBit ^ panBit).toString();
						}
					}

					var s = xorStr;

					var binaryToHex = function(s) {
						var i, k, part, accum, ret = '';
						for (i = s.length - 1; i >= 3; i -= 4) {
							part = s.substr(i + 1 - 4, 4);
							accum = 0;
							for (k = 0; k < 4; k += 1) {
								if (part[k] !== '0' && part[k] !== '1') {
									return { valid: false };
								}
								accum = accum * 2 + parseInt(part[k], 10);
							}
							if (accum >= 10) {
								ret = String.fromCharCode(accum - 10 + 'A'.charCodeAt(0)) + ret;
							} else {
								ret = String(accum) + ret;
							}
						}
						if (i >= 0) {
							accum = 0;
							for (k = 0; k <= i; k += 1) {
								if (s[k] !== '0' && s[k] !== '1') {
									return { valid: false };
								}
								accum = accum * 2 + parseInt(s[k], 10);
							}
							ret = String(accum) + ret;
						}
						return { valid: true, result: ret };
					}

					var pinPanBlockValue = binaryToHex(s).result;
					var currDate = new Date();
					var txtDate = $filter('date')(currDate, 'MMddHHmmss');

					var pinPanBlockEncrypt = pinPanBlockValue.toString();
					var atmNumberEncrypt = updateCardDetailsVm.cardNumber.toString();
					var reqParams = {};
					reqParams["atmPin"] = pinPanBlockEncrypt;
					reqParams["userFilledCardNumber"] = atmNumberEncrypt;
					reqParams["txnDate"] = txtDate;
					reqParams["type"] = "PROFILE";
					reqParams["maskedCardNumber"] = updateCardDetailsVm.atmCard.cardNo;
					nfsService.validateDebitCardNumber(reqParams).then(function (data) {
						getAccountDetailsService.accountOverviewData = "";
						$state.go('menu.updateSuccess');
					}, function (error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				}
			}

			$scope.$on('$ionicView.beforeEnter', function() {
				updateCardDetailsVm.initPage();
			});

			return this;
		}	
]);