'use strict';
angularApp.controller('updateLandingController', [
		"$state",
		"$scope",		
		"utilityService","customerInfoService","nfsService","validationService","$filter",
		
		function($state, $scope,utilityService,customerInfoService,nfsService,validationService,$filter) {
			
			var updateLandingVm = this;

			function initPage(){
				updateLandingVm.verifyMethod = "otp";
				updateLandingVm.showEye = false;
				updateLandingVm.mobileNumber = customerInfoService.customer.mobile ? $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4) : "";
			}

			updateLandingVm.validatePage = function(){
				updateLandingVm.errObj = {};
				if(!updateLandingVm.newNumber){
					updateLandingVm.errObj.phoneError = "Please enter mobile number";
					return false;
				}
				if(updateLandingVm.newNumber.length != 10){
					updateLandingVm.errObj.phoneError = "Invalid Mobile Number";
					return false;
				}
				return true;
			}

			updateLandingVm.showEyeIcon = function(icon){
				if(icon == "enable"){
					updateLandingVm.showEye = true;
					updateLandingVm.mobileNumber = customerInfoService.customer.mobile ? customerInfoService.customer.mobile : "";
				}else if(icon == "disable"){
					updateLandingVm.showEye = false;
					updateLandingVm.mobileNumber = customerInfoService.customer.mobile ? $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4) : "";
				}
			}

			updateLandingVm.goNext = function(){
				if(updateLandingVm.validatePage()){
					if(customerInfoService.customer.mobile == updateLandingVm.newNumber){
						utilityService.showErrorMessage("Mobile Number is already registered");
					}else{
						nfsService.setUpdateMethod(updateLandingVm.verifyMethod);
						nfsService.setNewNumber(updateLandingVm.newNumber);
						if(updateLandingVm.verifyMethod == "otp"){
							nfsService.getOtp().then(function(data) {
								$state.go('menu.updateOTP');
							},function(error){
								utilityService.showErrorMessage(error.responseMessage);
							});
						}else{
							var newRequest = {
								"newMobileNumber" : updateLandingVm.newNumber,
								"type" : nfsService.getUpdateMethod()
							}
							nfsService.getOtpNew(newRequest).then(function(data) {		
								$state.go('menu.updateOTP');
							},function(error){
								utilityService.showErrorMessage(error.responseMessage);
							});
						}
					}
				}
			}

			updateLandingVm.goBacktoPrevious = function(){
				$state.go('menu.homeScreen');
			}

			$scope.$on('$ionicView.beforeEnter', function() {
				initPage();
			});

			return this;
		}

		
]);


