'use strict';
angularApp.controller('updateOTPController', [
		"$state",
		"$scope",		
		"utilityService","$filter","nfsService","getAccountDetailsService","customerInfoService","clickStreamService",
		
		function($state, $scope,utilityService,$filter,nfsService,getAccountDetailsService,customerInfoService,clickStreamService) {
			
			var updateOTPVm = this;

			function initPage(){
				if(nfsService.getUpdateMethod() == "otp"){
					updateOTPVm.old = true;
				}else{
					updateOTPVm.old = false;
				}
				updateOTPVm.otpCount = 0;
				updateOTPVm.isResendDisabled = false;
				updateOTPVm.clickCount = 0;
				updateOTPVm.mobileNumber = customerInfoService.customer.mobile ? $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4) : "";
				updateOTPVm.newNumber = nfsService.getNewNumber() ? $filter('cardmask')(nfsService.getNewNumber(), 'X', 4) : "";
			}

			updateOTPVm.submit = function(){
				updateOTPVm.resetPinOTP = "";
				if(!updateOTPVm.otp){
					updateOTPVm.resetPinOTP = "Enter the valid OTP.";
				}else if(updateOTPVm.otp.length != 6){
					updateOTPVm.resetPinOTP = "Please enter 6 digits OTP";
				}else{
					if(updateOTPVm.old){
						var request = {
							"otp" : updateOTPVm.otp
						}
						clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "SUBMIT_OLD_OTP"));
						nfsService.validateOtp(request).then(function(data) {
							var newRequest = {
								"newMobileNumber" : nfsService.getNewNumber(),
								"type" : nfsService.getUpdateMethod()
							}
							nfsService.getOtpNew(newRequest).then(function(data) {
								updateOTPVm.otpCount = 0;
								updateOTPVm.otp = "";
								updateOTPVm.old = false;
								updateOTPVm.clickCount = 0;
								updateOTPVm.isResendDisabled = false;
							},function(error){
								utilityService.showErrorMessage(error.responseMessage);
							});
						},function(error){
							updateOTPVm.otp = "";
							updateOTPVm.showErrorOTP(error);
						});
					}else{
						var request = {
							"otp": updateOTPVm.otp,
							"newMobileNumber": nfsService.getNewNumber()
						}
						clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "SUBMIT_NEW_OTP"));
						nfsService.validateOtpNew(request).then(function(data) {
							if(nfsService.getUpdateMethod() == "card"){
								$state.go('menu.updateCardDetails');
							}else{	
								nfsService.updateNumber().then(function(data) {
									getAccountDetailsService.accountOverviewData = "";
									$state.go('menu.updateSuccess');
								},function(error){
									utilityService.showErrorMessage(error.responseMessage);
								});
							}
						},function(error){
							updateOTPVm.otp = "";
							updateOTPVm.showErrorOTP(error);
						});
					}
				}
			}

			updateOTPVm.resendOTP = function(){
				if(updateOTPVm.old){
					nfsService.getOtp().then(function(data) {
						updateOTPVm.clickCount++;
						if(updateOTPVm.clickCount >= 2){
							updateOTPVm.isResendDisabled = true;
						}
					},function(error){
						utilityService.showErrorMessage(error.responseMessage);
					});
				}else{
					var newRequest = {
						"newMobileNumber" : nfsService.getNewNumber(),
						"type" : nfsService.getUpdateMethod()
					}
					nfsService.getOtpNew(newRequest).then(function(data) {
						updateOTPVm.clickCount++;
						if(updateOTPVm.clickCount >= 2){
							updateOTPVm.isResendDisabled = true;
						}
					},function(error){
						utilityService.showErrorMessage(error.responseMessage);
					});
				}
			}

			updateOTPVm.showErrorOTP = function(error){
				updateOTPVm.otpCount++;
				if(updateOTPVm.otpCount >= 3){
					var title = '';
					var template = "<p> "+error.responseMessage +" </p>";
					var onTap = 'menu.homeScreen';
					var buttontext = "<b>OK</b>";
					utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
				}else{
					utilityService.showErrorMessage(error.responseMessage);
				}
			}

			$scope.$on('$ionicView.beforeEnter', function() {
				initPage();
			});

			return this;
		}

		
]);


