'use strict';
angularApp.controller('updateProfileController', [
		"$state",
		"$scope",		
		"utilityService",
		"$ionicPopover","loggedInUserService","fTReviewService","cryptoService","$ionicPopup",
		function($state, $scope,utilityService,$ionicPopover,loggedInUserService,fTReviewService,cryptoService,$ionicPopup) {
			
			var updateProfileVm = this;

			updateProfileVm.initPage = function(){
				updateProfileVm.template = '<ion-popover-view class=" loginnewarrow edu-popover udp-max-height-100" id="runtimeHeight" >'+'<div class="arrowDownLogin edu-arrow-down"></div>' + '<a class="iconsubtext closeinfobutton float-right" id="CALL_ANC" click-stream="click" ng-click="updateProfileVm.closePopover()">' + '<i class="ico-close ver-align-middle"></i>' + '</a>' + '<ion-content class="col-90">' +
				'<div id="renderHeight" class="text-left padding-left-10 padding-right-10 font-size-12 " translate="NFS_FORGOT_PASS"></div>' + '</ion-content>' + '</ion-popover-view>';

				$scope.popover = $ionicPopover.fromTemplate(updateProfileVm.template, {
					scope: $scope
				});
			}

			updateProfileVm.forgotPass = function(){
				$state.go('menu.forgotProfilePwd');
			}

			updateProfileVm.closePopover = function(){
				$scope.popover.hide();
			}

			updateProfileVm.submit = function(){
				var loggedInUserDetails = loggedInUserService.getUserProfileDetails();
				if (updateProfileVm.profilePassword) {
					fTReviewService.getProfilePassAndSerKey().then(function (response) {
						var options = {
							inbUserName:loggedInUserDetails.inbUsername,
							strPass:updateProfileVm.profilePassword,
							keyId:response.keyId,
							serviceId:response.serviceId,
							osName:device.platform
						};
						var reqParams = utilityService.commonRequestForValidateProfilePass(options);
						fTReviewService.getProfilePassAuth(reqParams).then(function (data) {
							$state.go('menu.updateLanding');
						}, function (error) {
							if (error.responseCode == "INB.AUTH.016") {
								var template = '<div class="popupBodyPadding font-dark-grey"><div class="popupTextBottomPadding fontSize-subHeading"><div>Your profile password has been BLOCKED.'+
								'</div></div></br><div class="popupTextBottomPadding fontSize-subHeading"><div><h5>To unblock the proﬁle password, kindly follow process by clicking the unblock button.</h5>'+
								'</div></div></div><div class="button-bar"><button class="button-block popupButton font-link-blue backgroundWhite popupButtonHeight font-button" id="CANCEL" click-stream="click"'+
								'ng-click="updateProfileVm.cancel()" translate="NFS_INB_CANCEL"></button><button class="button-block popupButton font-link-blue backgroundWhite popupButtonHeight font-button" id="UNBLOCK" click-stream="click"'+
								'ng-click="updateProfileVm.unblockProfilePass()" translate="NFS_INB_UNBLOCK"></button></div>'
								updateProfileVm.myPopup = $ionicPopup.show({
									title: '',
									cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
									template: template,
									scope: $scope
								})
							} else {
								utilityService.showErrorMessage(error.responseMessage);
							}
						});

					}, function (error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				} else {
					utilityService.showErrorMessage('Please enter your Internet Banking Profile Password.')
				}
			}

			updateProfileVm.unblockProfilePass = function(){
				updateProfileVm.myPopup.close();
             	$state.go('menu.forgotProfilePwd');
			}

			updateProfileVm.cancel = function(){
				updateProfileVm.myPopup.close();
				$state.go('menu.homeScreen');
			}

			updateProfileVm.forgotpassPopup = function($event){
				$scope.popover.show($event);
			}

			$scope.$on('$ionicView.beforeEnter', function() {
				updateProfileVm.initPage();
			});

			return this;
		}

		
]);


