'use strict';

angularApp.controller('accountDetailsNPSController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices) {

        var accountDetailsNPSControllerVM = this;
        $scope.currentPage = "1";
        $scope.lastPage = "16";
        accountDetailsNPSControllerVM.validAccountFlag = false;

        accountDetailsNPSControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        accountDetailsNPSControllerVM.goBack = function () {
            $state.go('menu.termsConditionsNPSView');
        }

        accountDetailsNPSControllerVM.getAccountList = function () {

            accountDetailsNPSControllerVM.accDetails = npsServices.accDetails;
            accountDetailsNPSControllerVM.balance = accountDetailsNPSControllerVM.accDetails[0].accountBalance;
            accountDetailsNPSControllerVM.accType = accountDetailsNPSControllerVM.accDetails[0].accountType;
            accountDetailsNPSControllerVM.accountNumber = accountDetailsNPSControllerVM.accDetails[0].accountNumber;
        }


        accountDetailsNPSControllerVM.showPop = function () {
            accountDetailsNPSControllerVM.popUp = $ionicPopup.show({
                title: '',
                cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
                templateUrl: 'pages/nps/accountDetails/accountListModal.html',
                scope: $scope
            });
        }
        accountDetailsNPSControllerVM.closePopup = function (index) {
            accountDetailsNPSControllerVM.popUp.close();
            accountDetailsNPSControllerVM.npsAccountDetails.accountSelectedIndex = index;
            accountDetailsNPSControllerVM.balance = accountDetailsNPSControllerVM.accDetails[index].accountBalance;
            accountDetailsNPSControllerVM.accType = accountDetailsNPSControllerVM.accDetails[index].accountType;
            accountDetailsNPSControllerVM.accountNumber = accountDetailsNPSControllerVM.accDetails[index].accountNumber;
            accountDetailsNPSControllerVM.showSelect = false;
            accountDetailsNPSControllerVM.validateAccountNumber();
        }

        accountDetailsNPSControllerVM.validateAccountNumber = function () {

            var requestParams = {
                "cif": "",
                "makerId": "",
                "accNo": accountDetailsNPSControllerVM.accountNumber,
                "branchCode": ""
              }

            npsServices.validateAccountNumber(requestParams).then(function (data) {
                accountDetailsNPSControllerVM.validAccountFlag = true;
                console.log("Validate account success");

            }, function (error) {
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(error.responseMessage);
                accountDetailsNPSControllerVM.validAccountFlag = false;
            });

        }



        accountDetailsNPSControllerVM.goNext = function () {
            npsServices.npsAccountDetails.accountSelectedIndex = accountDetailsNPSControllerVM.npsAccountDetails.accountSelectedIndex;
            npsServices.npsAccountDetails.npsAccountType = accountDetailsNPSControllerVM.npsAccountDetails.npsAccountType;
            npsServices.npsAccountDetails.ckycNumber = accountDetailsNPSControllerVM.npsAccountDetails.ckycNumber;
            npsServices.npsAccountDetails.preExistingNpsAccount = accountDetailsNPSControllerVM.npsAccountDetails.preExistingNpsAccount;
            npsServices.npsAccountDetails.bankAccountNumber = accountDetailsNPSControllerVM.accountNumber;
            npsServices.npsAccountDetails.bankAccountType = accountDetailsNPSControllerVM.accType;

            var requestParams = {
                "cifNumber": "",
                "accountNo": accountDetailsNPSControllerVM.accountNumber,
                "npsAccountType": accountDetailsNPSControllerVM.npsAccountDetails.npsAccountType,
                "npsAccountTypeCode": "",
                "recordingAgencyCode": "",
                "recordingAgency": accountDetailsNPSControllerVM.npsAccountDetails.crAgency,
                "ckycNO": accountDetailsNPSControllerVM.npsAccountDetails.ckycNumber,
                "deviceInfo": {
                    "deviceIMEI": npsServices.deviceInfo.deviceIMEI,
                    "deviceOS": npsServices.deviceInfo.deviceOS
                },
                "userConsent": {
                    "termsAndConditionsFlag": npsServices.npsTermsAndCondition.tncFlag == true ? "Y" : "N",
                    "noNPSConsent": accountDetailsNPSControllerVM.npsAccountDetails.preExistingNpsAccount == true ? "Y" : "N"
                }
            };
            // if (!accountDetailsNPSControllerVM.npsTprnSuccessData.tprn) {

                npsServices.registerCustomerForNPS(requestParams).then(function (response) {
                    npsServices.npsTprnSuccessData.tprn = response.data.tprn;
                    npsServices.npsTprnSuccessData.createdDate = response.data.createdDate;
                    if (!accountDetailsNPSControllerVM.npsTprnSuccessData.tprn) {
                        $state.go('menu.trpnSuccess');
                    } else {
                        if (!npsServices.applicantData.panNumber) {
                            npsServices.getCIFDetails().then(function (data) {
                                npsServices.applicantData = data;
                                $state.go('menu.npsPersonalDetails');

                            }, function (error) {
                                utilityService.enableShowErrorMessage();
                                utilityService.showErrorMessage(error.responseMessage);
                            });
                        } else {
                            $state.go('menu.npsPersonalDetails');
                        }
                    }


                }, function (error) {
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                });

            // } else {

            //     if (!npsServices.applicantData.panNumber) {
            //         npsServices.getCIFDetails().then(function (data) {
            //             npsServices.applicantData = data;
            //             $state.go('menu.npsPersonalDetails');

            //         }, function (error) {
            //             utilityService.enableShowErrorMessage();
            //             utilityService.showErrorMessage(error.responseMessage);
            //         });
            //     } else {
            //         $state.go('menu.npsPersonalDetails');
            //     }


            // }

        }


        $scope.$on('$ionicView.beforeEnter', function () {
            accountDetailsNPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            accountDetailsNPSControllerVM.getAccountList();
            accountDetailsNPSControllerVM.npsTprnSuccessData = angular.copy(npsServices.npsTprnSuccessData);
            if (npsServices.npsAccountDetails) {
                accountDetailsNPSControllerVM.npsAccountDetails = angular.copy(npsServices.npsAccountDetails);

                // if (accountDetailsNPSControllerVM.accDetails && accountDetailsNPSControllerVM.npsAccountDetails.accountSelectedIndex) {
                //     accountDetailsNPSControllerVM.balance = accountDetailsNPSControllerVM.accDetails[accountDetailsNPSControllerVM.npsAccountDetails.accountSelectedIndex].accountBalance;
                //     accountDetailsNPSControllerVM.accType = accountDetailsNPSControllerVM.accDetails[accountDetailsNPSControllerVM.npsAccountDetails.accountSelectedIndex].accountType;
                //     accountDetailsNPSControllerVM.accountNumber = accountDetailsNPSControllerVM.accDetails[accountDetailsNPSControllerVM.npsAccountDetails.accountSelectedIndex].accountNumber;
                //     accountDetailsNPSControllerVM.showSelect = false;
                // }
                if (accountDetailsNPSControllerVM.accDetails && accountDetailsNPSControllerVM.npsAccountDetails.bankAccountNumber) {
                    for (var i = 0; i < accountDetailsNPSControllerVM.accDetails.length; i++) {
                        if (accountDetailsNPSControllerVM.accDetails[i].accountNumber.trim() == accountDetailsNPSControllerVM.npsAccountDetails.bankAccountNumber.trim()) {
                            accountDetailsNPSControllerVM.balance = accountDetailsNPSControllerVM.accDetails[i].accountBalance;
                            accountDetailsNPSControllerVM.accType = accountDetailsNPSControllerVM.accDetails[i].accountType;
                            accountDetailsNPSControllerVM.accountNumber = accountDetailsNPSControllerVM.accDetails[i].accountNumber;
                            accountDetailsNPSControllerVM.showSelect = false;
                        }
                    }

                }
            }

            accountDetailsNPSControllerVM.validateAccountNumber();
        });



        return this;
    }
]);
