'use strict';

angularApp.controller('bankDetailsNPSController', ["$timeout",
  "$ionicPopup",
  "$state",
  "$scope",
  "$rootScope",
  "$translate",
  "$location",
  "$ionicScrollDelegate",
  "getAccountDetailsService",
  "$ionicSlideBoxDelegate",
  "utilityService",
  "$ionicHistory",
  "homeScreenService",
  "$ionicViewSwitcher",
  "npsServices",
  "$filter",
  function ($timeout,
    $ionicPopup,
    $state,
    $scope,
    $rootScope,
    $translate,
    $location,
    $ionicScrollDelegate,
    getAccountDetailsService,
    $ionicSlideBoxDelegate,
    utilityService,
    $ionicHistory,
    homeScreenService,
    $ionicViewSwitcher,
    npsServices,
    $filter) {

    var bankDetailsNPSControllerVM = this;
    $scope.currentPage = "10";
    $scope.lastPage = "16";

    bankDetailsNPSControllerVM.close = function () {
      $ionicViewSwitcher.nextDirection('back');
      $state.go('menu.homeScreen');
    }

    bankDetailsNPSControllerVM.goBack = function () {
      $state.go("menu.npsTakeSignature");
    }

    bankDetailsNPSControllerVM.goNext = function () {
      npsServices.npsBankDetails.micrCode = bankDetailsNPSControllerVM.npsBankDetails.micrCode;
      npsServices.npsBankDetails.stateCode = bankDetailsNPSControllerVM.npsBankDetails.stateCode;
      npsServices.npsBankDetails.state = bankDetailsNPSControllerVM.npsBankDetails.state;

      var requestParams = {
        "otherDetails": {
          "residentialStatus": "",
          "education": npsServices.npsOtherDetails.educationText,
          "occupation": npsServices.npsOtherDetails.occupationText,
          "annualIncome": npsServices.npsOtherDetails.incomeText,
          "annualIncomeCode": npsServices.npsOtherDetails.income,
          "subOccupation": npsServices.npsOtherDetails.otherOccupationDetails,
          "educationCode": npsServices.npsOtherDetails.education,
          "occupationCode": npsServices.npsOtherDetails.occupation,
          "subOccupationCode": "",
          "thresholdLimitAmount": ""
        },
        "bankDetails": {
          "micr": bankDetailsNPSControllerVM.npsBankDetails.micrCode,
          "state": npsServices.npsBankDetails.state,
          "stateCode": npsServices.npsBankDetails.stateCode
        },
        "userConsent": {
          "isPoliticallyExposed": npsServices.npsOtherDetails.politicalExposed
        }
      };

      npsServices.saveOtherDetails(requestParams).then(function (response) {
        $state.go("menu.npsNominationDetails");

      }, function (error) {
        utilityService.enableShowErrorMessage();
        utilityService.showErrorMessage(error.responseMessage);
      });


    }

    bankDetailsNPSControllerVM.selectedStateUnionTerritory = function (index) {
      bankDetailsNPSControllerVM.npsBankDetails.state = utilityService.getTextFromDropdown("value", bankDetailsNPSControllerVM.npsBankDetails.stateCode, bankDetailsNPSControllerVM.stateList, "description");
    }

    $scope.$on('$ionicView.beforeEnter', function () {
      bankDetailsNPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
      homeScreenService.isBackCheck = false;
      bankDetailsNPSControllerVM.stateList = npsServices.npsDropdownData.stateMasters;
      bankDetailsNPSControllerVM.npsBankDetails = angular.copy(npsServices.npsBankDetails);
      bankDetailsNPSControllerVM.npsAccountDetails = angular.copy(npsServices.npsAccountDetails);

    });

    return this;
  }
]);
