'use strict';

angularApp.controller('contactDetailsNPSController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    "$filter",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices,
        $filter) {

        var contactDetailsNPSControllerVM = this;
        $scope.currentPage = "7";
        $scope.lastPage = "16";


        contactDetailsNPSControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        contactDetailsNPSControllerVM.goBack = function () {
            $state.go('menu.npsAddressDetails');
        }

        contactDetailsNPSControllerVM.goNext = function () {
            npsServices.applicantData.email = contactDetailsNPSControllerVM.applicantData.email;
            npsServices.applicantData.mobileNumber = contactDetailsNPSControllerVM.applicantData.mobileNumber;
            npsServices.applicantData.telPhoneNumberResidential = contactDetailsNPSControllerVM.applicantData.telPhoneNumberResidential;
            npsServices.applicantData.telPhoneNumberOffice = contactDetailsNPSControllerVM.applicantData.telPhoneNumberOffice;

            var requestParams = {
                "personalDetails": {
                    "personalTelePhone": contactDetailsNPSControllerVM.applicantData.telPhoneNumberResidential,
                    "officeTelePhone": contactDetailsNPSControllerVM.applicantData.telPhoneNumberOffice,
                    "email": contactDetailsNPSControllerVM.applicantData.email,
                    "state": npsServices.applicantData.state,
                    "stateCode": npsServices.applicantData.stateCode
                }
            };
            npsServices.saveAddressAndContactDetails(requestParams).then(function (response) {
                $state.go("menu.npsOtherDetails");

            }, function (error) {
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(error.responseMessage);
            });


        }


        $scope.$on('$ionicView.beforeEnter', function () {
            contactDetailsNPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            contactDetailsNPSControllerVM.applicantData = angular.copy(npsServices.applicantData);

            if (npsServices.npsContactDetails.displayOnlyEmail == "true" || npsServices.npsContactDetails.displayOnlyEmail == "false") {

                if (npsServices.npsContactDetails.displayOnlyEmail == "true") {
                    contactDetailsNPSControllerVM.displayOnlyEmail = true;
                } else {
                    contactDetailsNPSControllerVM.displayOnlyEmail = false;
                }

            } else {

                if (contactDetailsNPSControllerVM.applicantData.email) {
                    contactDetailsNPSControllerVM.displayOnlyEmail = true;
                    npsServices.npsContactDetails.displayOnlyEmail = "true";
                } else {
                    contactDetailsNPSControllerVM.displayOnlyEmail = false;
                    npsServices.npsContactDetails.displayOnlyEmail = "false";
                }

            }

        });


        return this;
    }
]);
