'use strict';

angularApp.controller('contributionDetailsNPSController', ["$timeout",
  "$ionicPopup",
  "$state",
  "$scope",
  "$rootScope",
  "$translate",
  "$location",
  "$ionicScrollDelegate",
  "getAccountDetailsService",
  "$ionicSlideBoxDelegate",
  "utilityService",
  "$ionicHistory",
  "homeScreenService",
  "$ionicViewSwitcher",
  "npsServices",
  "$ionicPopover",
  function ($timeout,
    $ionicPopup,
    $state,
    $scope,
    $rootScope,
    $translate,
    $location,
    $ionicScrollDelegate,
    getAccountDetailsService,
    $ionicSlideBoxDelegate,
    utilityService,
    $ionicHistory,
    homeScreenService,
    $ionicViewSwitcher,
    npsServices,
    $ionicPopover) {

    var contributionDetailsNPSControllerVM = this;
    $scope.currentPage = "14";
    $scope.lastPage = "16";

    contributionDetailsNPSControllerVM.close = function () {
      $ionicViewSwitcher.nextDirection('back');
      $state.go('menu.homeScreen');
    }

    contributionDetailsNPSControllerVM.goBack = function () {
      $state.go("menu.moneyLaunderingDeclaration");
    }

    contributionDetailsNPSControllerVM.validateAmount = function () {

      if (contributionDetailsNPSControllerVM.npsContributionDetails.contributionAmountTierI) {
        if (contributionDetailsNPSControllerVM.npsContributionDetails.contributionAmountTierI < 500) {
          contributionDetailsNPSControllerVM.tier1AmountError = true;
        } else {
          contributionDetailsNPSControllerVM.tier1AmountError = false;
        }

      }

      if (contributionDetailsNPSControllerVM.npsContributionDetails.contributionAmountTierII) {
        if (contributionDetailsNPSControllerVM.npsContributionDetails.contributionAmountTierII < 1000) {
          contributionDetailsNPSControllerVM.tier2AmountError = true;
        } else {
          contributionDetailsNPSControllerVM.tier2AmountError = false;
        }

      }


    }

    contributionDetailsNPSControllerVM.fetchConributionCharges = function () {


      var requestParams = {
        "reqTier1Amount": contributionDetailsNPSControllerVM.npsContributionDetails.contributionAmountTierI,
        "reqTier2Amount": contributionDetailsNPSControllerVM.npsContributionDetails.contributionAmountTierII,
        "reqType": "",
        "reqTierType": "",
        "launderingFlag": npsServices.npsMoneyLaunderingDetails.moneyLaunderingFlag == true ? "Y" : "N"
      }

      npsServices.fetchConributionCharges(requestParams).then(function (response) {
        npsServices.npsContributionReviewDetails.charges = response.charges;
        npsServices.npsContributionReviewDetails.gst = response.gst;
        npsServices.npsContributionReviewDetails.totalAmtReceivable = response.totalAmtReceivable;
        npsServices.npsContributionReviewDetails.totalInvestmentAmount = response.totalinvestedamount;
        npsServices.npsContributionReviewDetails.registrationCharges = response.registrationCharges;
        $state.go("menu.contributionReview");

      }, function (error) {
        utilityService.enableShowErrorMessage();
        utilityService.showErrorMessage(error.responseMessage);
      });


    }
    contributionDetailsNPSControllerVM.resetValidationTier1 = function () {
      contributionDetailsNPSControllerVM.tier1AmountError = false;
    }
    contributionDetailsNPSControllerVM.resetValidationTier2 = function () {
      contributionDetailsNPSControllerVM.tier2AmountError = false;
    }

    contributionDetailsNPSControllerVM.goNext = function () {
      npsServices.npsContributionDetails.contributionAmountTierI = contributionDetailsNPSControllerVM.npsContributionDetails.contributionAmountTierI;
      npsServices.npsContributionDetails.contributionAmountTierII = contributionDetailsNPSControllerVM.npsContributionDetails.contributionAmountTierII;
      contributionDetailsNPSControllerVM.validateAmount();

      if (contributionDetailsNPSControllerVM.npsAccountDetails.npsAccountType.toUpperCase() == 'TIER2') {

        if (!contributionDetailsNPSControllerVM.tier1AmountError && !contributionDetailsNPSControllerVM.tier2AmountError) {
          contributionDetailsNPSControllerVM.fetchConributionCharges();
        }

      } else {

        if (!contributionDetailsNPSControllerVM.tier1AmountError) {
          contributionDetailsNPSControllerVM.fetchConributionCharges();
        }

      }



    }

    /* Info Popup */
    var template = '<ion-popover-view class="nps-tooltip-after tooltiptext nps-otherDetails-tooltip roboto-regular" style = "height: 66px;">' + '<ion-content>' +
      '<div class="text-left" ng-bind-html="contributionDetailsNPSControllerVM.getInfoMsg"></div>' + '</ion-content>' + '</ion-popover-view>';

    $scope.popover = $ionicPopover.fromTemplate(template, {
      scope: $scope
    });

    contributionDetailsNPSControllerVM.contributionTier1Info = function ($event) {
      contributionDetailsNPSControllerVM.getInfoMsg = "<div>Contribution amount for Tier I (Min Amount Rs 500 )</div> ";
      $scope.popover.show($event);
    }

    contributionDetailsNPSControllerVM.contributionTier2Info = function ($event) {
      contributionDetailsNPSControllerVM.getInfoMsg = "<div>Contribution amount for Tier II (Min Amount Rs 1000)</div> ";
      $scope.popover.show($event);
    }

    $scope.$on('$ionicView.beforeEnter', function () {
      contributionDetailsNPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
      homeScreenService.isBackCheck = false;
      contributionDetailsNPSControllerVM.npsContributionDetails = angular.copy(npsServices.npsContributionDetails);
      contributionDetailsNPSControllerVM.npsAccountDetails = angular.copy(npsServices.npsAccountDetails);

    });



    return this;
  }
]);
