'use strict';

angularApp.controller('fatcaDetailsNPSController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    "$filter",
    "ionicDatePicker",
    "$ionicPopover",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices,
        $filter,
        ionicDatePicker,
        $ionicPopover) {

        var fatcaDetailsNPSControllerVM = this;
        $scope.currentPage = "13";
        $scope.lastPage = "16";
        fatcaDetailsNPSControllerVM.countryLabel = "Country";

        fatcaDetailsNPSControllerVM.residentCountries = [{
            count: 1,
            enableDelete: false,
            displayOnlyField: true,
            residentCountry: "IN",
            residentCountryText: "India",
            residentCountryAddress: { addressLine1: "", cityTownVillage: "", state: "", stateCode: "", pinCode: "" },
            taxIdentificationNo: "",
            tinIssuingCountry: "IN",
            tinIssuingCountryText: "India",
            validTill: ""

        }];

        fatcaDetailsNPSControllerVM.setDefaultData = function () {
            fatcaDetailsNPSControllerVM.residentCountries[0].residentCountryAddress.addressLine1 = fatcaDetailsNPSControllerVM.applicantData.addressLine1;
            fatcaDetailsNPSControllerVM.residentCountries[0].residentCountryAddress.cityTownVillage = fatcaDetailsNPSControllerVM.applicantData.city;
            fatcaDetailsNPSControllerVM.residentCountries[0].residentCountryAddress.state = fatcaDetailsNPSControllerVM.applicantData.state;
            fatcaDetailsNPSControllerVM.residentCountries[0].residentCountryAddress.stateCode = fatcaDetailsNPSControllerVM.applicantData.stateCode;
            fatcaDetailsNPSControllerVM.residentCountries[0].residentCountryAddress.pinCode = fatcaDetailsNPSControllerVM.applicantData.pinCode;
            fatcaDetailsNPSControllerVM.residentCountries[0].taxIdentificationNo = fatcaDetailsNPSControllerVM.applicantData.panNumber;
        }

        fatcaDetailsNPSControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        fatcaDetailsNPSControllerVM.goBack = function () {

            if (!npsServices.npsPensionDetails.pensionFundList[0] || !npsServices.npsPensionDetails.assetAllocationList[0]) {

                npsServices.fetchPensionFundList().then(function (response) {
                    npsServices.npsPensionDetails.pensionFundList = response.pensionFundList;
                    npsServices.npsPensionDetails.assetAllocationList = response.autoAssetAllocationList;

                    if (npsServices.npsAccountDetails.npsAccountType.toUpperCase() == "TIER1") {
                        $state.go("menu.npsPensionFundDetails");
                    } else {
                        $state.go("menu.npsPensionFundDetailsTierII");
                    }

                }, function (error) {
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                });

            } else {

                if (npsServices.npsAccountDetails.npsAccountType.toUpperCase() == "TIER1") {
                    $state.go("menu.npsPensionFundDetails");
                } else {
                    $state.go("menu.npsPensionFundDetailsTierII");
                }
            }

        }



        fatcaDetailsNPSControllerVM.selectedCountry = function (index) {

            fatcaDetailsNPSControllerVM.residentCountries[index].residentCountryText = utilityService.getTextFromDropdown("value", fatcaDetailsNPSControllerVM.residentCountries[index].residentCountry, fatcaDetailsNPSControllerVM.countryList, "description");

        }

        fatcaDetailsNPSControllerVM.selectedTinIssuingCountry = function (index) {

            fatcaDetailsNPSControllerVM.residentCountries[index].tinIssuingCountryText = utilityService.getTextFromDropdown("value", fatcaDetailsNPSControllerVM.residentCountries[index].tinIssuingCountry, fatcaDetailsNPSControllerVM.countryList, "description");

        }

        fatcaDetailsNPSControllerVM.selectedState = function (index) {

            fatcaDetailsNPSControllerVM.residentCountries[index].residentCountryAddress.state = utilityService.getTextFromDropdown("value", fatcaDetailsNPSControllerVM.residentCountries[index].residentCountryAddress.stateCode, fatcaDetailsNPSControllerVM.stateList, "description");

        }

        fatcaDetailsNPSControllerVM.addCountry = function () {

            if (fatcaDetailsNPSControllerVM.residentCountries.length < 3) {

                if (fatcaDetailsNPSControllerVM.residentCountries.length == 2) {
                    fatcaDetailsNPSControllerVM.disableAddCountry = true;
                } else {
                    fatcaDetailsNPSControllerVM.disableAddCountry = false;
                }

                var incrementValue = fatcaDetailsNPSControllerVM.residentCountries[fatcaDetailsNPSControllerVM.residentCountries.length - 1].count + 1;

                var insert = {
                    count: incrementValue,
                    enableDelete: true,
                    displayOnlyField: false,
                    residentCountry: "",
                    residentCountryText: "",
                    residentCountryAddress: { addressLine1: "", cityTownVillage: "", state: "", stateCode: "", pinCode: "" },
                    taxIdentificationNo: "",
                    tinIssuingCountry: "",
                    tinIssuingCountryText: "",
                    validTill: ""
                }

                fatcaDetailsNPSControllerVM.residentCountries.push(insert);
            } else {
                console.log("Not allowed");
                fatcaDetailsNPSControllerVM.disableAddCountry = true;
            }

        }

        fatcaDetailsNPSControllerVM.deleteCountry = function (index) {
            fatcaDetailsNPSControllerVM.residentCountries.splice(index, 1);

            if (fatcaDetailsNPSControllerVM.residentCountries.length < 3) {
                fatcaDetailsNPSControllerVM.disableAddCountry = false;
            }

            for (var i = 0; i < (fatcaDetailsNPSControllerVM.residentCountries.length); i++) {
                fatcaDetailsNPSControllerVM.residentCountries[i].count = i + 1;
            }

        }

        /* Open the date picker popup */
        fatcaDetailsNPSControllerVM.openDatePicker = function (index) {


            var nextDate = new Date().setDate(new Date().getDate() + 8);
            var toDate = new Date().setDate(new Date().getDate() + 365);
            fatcaDetailsNPSControllerVM.ipObj1 = {
                callback: function (val) {
                    var date = new Date(val);
                    fatcaDetailsNPSControllerVM.residentCountries[index].validTill = $filter('date')(date, "dd MMM yyyy");
                },
                inputDate: new Date(nextDate),
                from: nextDate,
                to: toDate,
                mondayFirst: true,
                closeOnSelect: false,
                templateType: 'popup',
            };

            ionicDatePicker.openDatePicker(fatcaDetailsNPSControllerVM.ipObj1);
        };

        fatcaDetailsNPSControllerVM.declarationPopup = function () {

            fatcaDetailsNPSControllerVM.myPopup = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',
                templateUrl: "pages/nps/fatcaDetails/declarationPopup.html",
                scope: $scope
            });
        };

        fatcaDetailsNPSControllerVM.goNext = function () {
            npsServices.npsFatcaDetails.residentCountries = fatcaDetailsNPSControllerVM.residentCountries;
            npsServices.npsFatcaDetails.isUsCitizen = fatcaDetailsNPSControllerVM.isUsCitizen;
            npsServices.npsFatcaDetails.tncFlag = fatcaDetailsNPSControllerVM.tncFlag;
            npsServices.npsFatcaDetails.autoFetchConsent = fatcaDetailsNPSControllerVM.autoFetchConsent;

            fatcaDetailsNPSControllerVM.residentCountriesRequest = [];

            for (var i = 0; i < fatcaDetailsNPSControllerVM.residentCountries.length; i++) {
                var insert = {

                    "country": fatcaDetailsNPSControllerVM.residentCountries[i].residentCountryText,
                    "countryCode": fatcaDetailsNPSControllerVM.residentCountries[i].residentCountry,
                    "addressLine1": fatcaDetailsNPSControllerVM.residentCountries[i].residentCountryAddress.addressLine1,
                    "city": fatcaDetailsNPSControllerVM.residentCountries[i].residentCountryAddress.cityTownVillage,
                    "cityCode": "",
                    "pincode": fatcaDetailsNPSControllerVM.residentCountries[i].residentCountryAddress.pinCode,
                    "state": fatcaDetailsNPSControllerVM.residentCountries[i].residentCountryAddress.state,
                    "stateCode": fatcaDetailsNPSControllerVM.residentCountries[i].residentCountryAddress.stateCode,
                    "tin": fatcaDetailsNPSControllerVM.residentCountries[i].taxIdentificationNo,
                    "validity": fatcaDetailsNPSControllerVM.residentCountries[i].validTill,
                    "tinIssuingCountryCode": fatcaDetailsNPSControllerVM.residentCountries[i].tinIssuingCountry,
                    "tinIssuingCountry": fatcaDetailsNPSControllerVM.residentCountries[i].tinIssuingCountryText
                }

                fatcaDetailsNPSControllerVM.residentCountriesRequest.push(insert);

            }

            var requestParams = {
                "fatcaDetails": fatcaDetailsNPSControllerVM.residentCountriesRequest,
                "userConsent": {
                    "autoFetchConsent": fatcaDetailsNPSControllerVM.autoFetchConsent == true ? "Y" : "N",
                    "tncFlag": fatcaDetailsNPSControllerVM.tncFlag == true ? "Y" : "N",
                    "isUSCitizen": fatcaDetailsNPSControllerVM.isUsCitizen
                }
            }

            npsServices.saveFatcaDetails(requestParams).then(function (response) {
                $state.go("menu.moneyLaunderingDeclaration");

            }, function (error) {
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(error.responseMessage);
            });

        }

        /* Info Popup */
        var template = '<ion-popover-view class="tooltiptext nps-tooltip nps-fatca-tooltip roboto-regular">' + '<ion-content>' +
            '<div class="text-left" ng-bind-html="fatcaDetailsNPSControllerVM.getInfoMsg"></div>' + '</ion-content>' + '</ion-popover-view>';

        $scope.popover = $ionicPopover.fromTemplate(template, {
            scope: $scope
        });


        fatcaDetailsNPSControllerVM.fatcaInfo = function ($event) {
            fatcaDetailsNPSControllerVM.getInfoMsg = "<div><strong>Clarification / Guidelines</strong></div><div>Clarification / Guidelines on filling details if applicant residence for tax purposes in jurisdiction(s) outside India</div><div><ul><li>Jurisdiction(s) of Tax Residence: Since US taxes the global income of its citizen, every US citizen of whatever nationality, is also a resident for tax purpose in USA.</li><li>Tax identification Number (TIN): TIN need not be reported if it has not been issued by the jurisdiction. However, if the said jurisdiction has issued a high integrity number with an equivalent level of identification (a 'Functional equivalent'), the same may be reported. Examples of that type of number for individual include, a social security/insurance number, citizen/personal identification/services code/number and resident registration number)</li><li>If applicant residence for tax purpose in jurisdiction(s) within India, Permanent Account Number (PAN) to be provided as Tax Identification Number (TIN)</li><li>In case applicant is declaring US person status as ‘No’ but his/her Country of Birth is US, document evidencing Relinquishment of Citizenship should be provided or reasons for not having relinquishment certificate is to be provided.</li ></ul ></div > ";
            $scope.popover.show($event);

        };


        $scope.$on('$ionicView.beforeEnter', function () {
            fatcaDetailsNPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            fatcaDetailsNPSControllerVM.npsFatca = npsServices.NPSDetails.npsFatca;
            fatcaDetailsNPSControllerVM.applicantData = angular.copy(npsServices.applicantData);
            fatcaDetailsNPSControllerVM.countryList = npsServices.npsDropdownData.countryMasters;
            fatcaDetailsNPSControllerVM.stateList = npsServices.npsDropdownData.stateMasters;
            fatcaDetailsNPSControllerVM.isUsCitizen = npsServices.npsFatcaDetails.isUsCitizen ? npsServices.npsFatcaDetails.isUsCitizen : "N";
            fatcaDetailsNPSControllerVM.tncFlag = npsServices.npsFatcaDetails.tncFlag;
            fatcaDetailsNPSControllerVM.autoFetchConsent = npsServices.npsFatcaDetails.autoFetchConsent;
            if (npsServices.npsFatcaDetails.residentCountries[0]) {
                fatcaDetailsNPSControllerVM.residentCountries = npsServices.npsFatcaDetails.residentCountries;
            }
            fatcaDetailsNPSControllerVM.setDefaultData();

        });


        return this;
    }
]);
