'use strict';

angularApp.controller('finalSuccessNPSController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    "openUrlInAppbroswerService",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices,
        openUrlInAppbroswerService) {

        var finalSuccessNPSControllerVM = this;
        $scope.currentPage = "16";
        $scope.lastPage = "16";

        finalSuccessNPSControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        finalSuccessNPSControllerVM.goBack = function () {
            $ionicHistory.goBack();
        }

        finalSuccessNPSControllerVM.goNext = function () {
            $state.go('menu.homeScreen');
        }

        //Download PDF
        finalSuccessNPSControllerVM.pranPdfDownload = function () {

            npsServices.getDocument().then(function (response) {

            var myBase64 = finalSuccessNPSControllerVM.pdfContent = response.data.base64Pdf;
            var contentType = "application/pdf";
            if (utilityService.isAndroidPlatform()) {
                finalSuccessNPSControllerVM.folderpath = cordova.file.externalRootDirectory;
            }
            if (utilityService.isIOSPlatform()) {
                //finalSuccessNPSControllerVM.folderpath = cordova.file.documentsDirectory;
                if (finalSuccessNPSControllerVM.pdfContent !== "") {
                    finalSuccessNPSControllerVM.isTncDownloaded = true;
                    finalSuccessNPSControllerVM.openPdf();
                }
            }
            // var folderpath = cordova.file.externalRootDirectory;

            if (utilityService.isAndroidPlatform()) {

                var filename = finalSuccessNPSControllerVM.npsFinalSuccessDetails.pdfDocName + ".pdf";



                finalSuccessNPSControllerVM.b64toBlob = function (b64Data, contentType, sliceSize) {
                    contentType = contentType || '';
                    sliceSize = sliceSize || 512;

                    var byteCharacters = atob(b64Data);
                    var byteArrays = [];

                    for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
                        var slice = byteCharacters.slice(offset, offset + sliceSize);

                        var byteNumbers = new Array(slice.length);
                        for (var i = 0; i < slice.length; i++) {
                            byteNumbers[i] = slice.charCodeAt(i);
                        }

                        var byteArray = new Uint8Array(byteNumbers);

                        byteArrays.push(byteArray);
                    }

                    var blob = new Blob(byteArrays, { type: contentType });
                    return blob;
                }


                finalSuccessNPSControllerVM.savebase64AsPDF = function (folderpath, filename, content, contentType) {
                    var contentStr = atob(content);
                    var contentLen = contentStr.length;
                    // if (contentLen >= constantConfig.accOverview.pdfSize) {

                    //     utilityService.showErrorMessage(constantConfig.accOverview.sizeLimitMessage);
                    //     return;
                    // }
                    // Convert the base64 string in a Blob
                    var DataBlob = finalSuccessNPSControllerVM.b64toBlob(content, contentType);

                    console.log("Starting to write the file :3");

                    window.resolveLocalFileSystemURL(folderpath, function (dir) {
                        console.log("Access to the directory granted succesfully");
                        dir.getFile(filename, { create: true }, function (file) {
                            console.log("File created succesfully.");
                            file.createWriter(function (fileWriter) {
                                console.log("Writing content to file");
                                fileWriter.write(DataBlob);
                                finalSuccessNPSControllerVM.isTncDownloaded = true;
                                // alert("your TnC is downloaded in : " + finalSuccessNPSControllerVM.folderpath);


                                finalSuccessNPSControllerVM.myPopup = $ionicPopup.show({
                                    template: 'File Downloaded to Internal Storage',
                                    title: '',
                                    cssClass: 'dialog',
                                    scope: $scope,
                                    buttons: [{
                                        text: 'OK',
                                        type: 'button-positive'
                                    }]
                                });


                            }, function () {
                                alert('Unable to save file in path ' + folderpath);
                            });
                        });
                    });
                }

                finalSuccessNPSControllerVM.savebase64AsPDF(finalSuccessNPSControllerVM.folderpath, filename, myBase64, contentType);

            }

            }, function (error) {
                console.log(error);
                utilityService.showErrorMessage(error.responseMessage);
            });


        }

        finalSuccessNPSControllerVM.openPdf = function () {
            openUrlInAppbroswerService.openUrl("data:application/pdf;base64," + finalSuccessNPSControllerVM.pdfContent + "", "");
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            finalSuccessNPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            finalSuccessNPSControllerVM.npsFinalSuccessDetails = angular.copy(npsServices.npsFinalSuccessDetails);
            finalSuccessNPSControllerVM.totalInvestmentAmount = npsServices.npsContributionReviewDetails.totalInvestmentAmount;
            finalSuccessNPSControllerVM.npsAccountType = npsServices.npsAccountDetails.npsAccountType;
        });

        return this;
    }
]);
