'use strict';

angularApp.controller('nominationDetailsNPSController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    "$filter",
    "ionicDatePicker",
    "$q",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices,
        $filter,
        ionicDatePicker,
        $q) {

        var nominationDetailsNPSControllerVM = this;
        nominationDetailsNPSControllerVM.totalPercentageShare = 0;
        $scope.currentPage = "11";
        $scope.lastPage = "16";
        nominationDetailsNPSControllerVM.nomineeLabel = "Nominee";
        nominationDetailsNPSControllerVM.sameNomineeForTierII = false;
        nominationDetailsNPSControllerVM.nominees = [{
            count: 1,
            enableDelete: false,
            npsNomineeType: "",
            nomineeFirstName: "",
            nomineeMiddleName: "",
            nomineeSurname: "",
            nomineeRelationship: "",
            nomineeDob: "",
            percentageShare: "",
            guardianFirstName: "",
            guardianMiddleName: "",
            guardianSurname: ""

        }];


        nominationDetailsNPSControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        nominationDetailsNPSControllerVM.goBack = function () {
            $state.go('menu.npsBankDetails');
        }

        nominationDetailsNPSControllerVM.goNext = function () {

            npsServices.npsNominationDetails.numberOfNominee = nominationDetailsNPSControllerVM.nominees.length;
            npsServices.npsNominationDetails.nominees = nominationDetailsNPSControllerVM.nominees;
            npsServices.npsNominationDetails.sameNomineeForTierII = nominationDetailsNPSControllerVM.sameNomineeForTierII;
            if (nominationDetailsNPSControllerVM.nominees.length > 1) {
                $state.go("menu.npsNomineeAddress");
            } else {

                var requestParams = {
                    "npsAccountType": "Tier1",
                    "isNomineeSame": nominationDetailsNPSControllerVM.sameNomineeForTierII,
                    "nominees": [{
                        "type": "Tier1_Nominee1",
                        "firstName": nominationDetailsNPSControllerVM.nominees[0].nomineeFirstName,
                        "middleName": nominationDetailsNPSControllerVM.nominees[0].nomineeMiddleName,
                        "lastName": nominationDetailsNPSControllerVM.nominees[0].nomineeSurname,
                        "relationship": nominationDetailsNPSControllerVM.nominees[0].nomineeRelationship,
                        "isMajor": nominationDetailsNPSControllerVM.nominees[0].npsNomineeType,
                        "percentageShare": nominationDetailsNPSControllerVM.nominees[0].percentageShare,
                        "dob": nominationDetailsNPSControllerVM.nominees[0].nomineeDob,
                        "guardian": {
                            "firstName": nominationDetailsNPSControllerVM.nominees[0].guardianFirstName,
                            "middleName": nominationDetailsNPSControllerVM.nominees[0].guardianMiddleName,
                            "lastName": nominationDetailsNPSControllerVM.nominees[0].guardianSurname
                        }
                    }]
                };

                if (nominationDetailsNPSControllerVM.sameNomineeForTierII || nominationDetailsNPSControllerVM.npsAccountType.toUpperCase() == "TIER1") {


                    if (!npsServices.npsPensionDetails.pensionFundList[0] || !npsServices.npsPensionDetails.assetAllocationList[0]) {

                        $q.all([npsServices.saveNomineeDetails(requestParams), npsServices.fetchPensionFundList()]).then(function (response) {
                            npsServices.npsPensionDetails.pensionFundList = response[1].pensionFundList;
                            npsServices.npsPensionDetails.assetAllocationList = response[1].autoAssetAllocationList;
                            $state.go("menu.npsPensionFundDetails");

                        }, function (error) {
                            utilityService.enableShowErrorMessage();
                            utilityService.showErrorMessage(error.responseMessage);
                        });

                    } else {

                        npsServices.saveNomineeDetails(requestParams).then(function (response) {
                            $state.go("menu.npsPensionFundDetails");

                        }, function (error) {
                            utilityService.enableShowErrorMessage();
                            utilityService.showErrorMessage(error.responseMessage);
                        });

                    }

                } else {

                    npsServices.saveNomineeDetails(requestParams).then(function (response) {
                        $state.go("menu.npsNominationDetailsTierII");

                    }, function (error) {
                        utilityService.enableShowErrorMessage();
                        utilityService.showErrorMessage(error.responseMessage);
                    });


                }
            }

        }

        nominationDetailsNPSControllerVM.resetTotalPercentageShare = function () {
            nominationDetailsNPSControllerVM.totalPercentageShare = 0;
            for (var i = 0; i < (nominationDetailsNPSControllerVM.nominees.length); i++) {
                nominationDetailsNPSControllerVM.totalPercentageShare = nominationDetailsNPSControllerVM.totalPercentageShare + parseFloat(nominationDetailsNPSControllerVM.nominees[i].percentageShare);
            }

            if (nominationDetailsNPSControllerVM.totalPercentageShare == 100.0) {
                nominationDetailsNPSControllerVM.disableNextButton = false
                nominationDetailsNPSControllerVM.disableAddNominiee = true;
            } else {
                nominationDetailsNPSControllerVM.disableNextButton = true
                if (nominationDetailsNPSControllerVM.nominees.length < 3) {
                    nominationDetailsNPSControllerVM.disableAddNominiee = false;
                }
            }
        }

        nominationDetailsNPSControllerVM.addNominee = function () {
            // utilityService.doNotHideSpinner();
            // utilityService.showSpinner();

            if (nominationDetailsNPSControllerVM.nominees.length < 3) {

                if (nominationDetailsNPSControllerVM.nominees.length == 2) {
                    nominationDetailsNPSControllerVM.disableAddNominiee = true;
                } else {
                    nominationDetailsNPSControllerVM.disableAddNominiee = false;
                }

                var incrementValue = nominationDetailsNPSControllerVM.nominees[nominationDetailsNPSControllerVM.nominees.length - 1].count + 1;

                var insert = {
                    count: incrementValue,
                    enableDelete: true,
                    npsNomineeType: "",
                    nomineeFirstName: "",
                    nomineeMiddleName: "",
                    nomineeSurname: "",
                    nomineeRelationship: "",
                    nomineeDob: "",
                    percentageShare: nominationDetailsNPSControllerVM.percentageShareList[0].value,
                    guardianFirstName: "",
                    guardianMiddleName: "",
                    guardianSurname: ""
                }

                nominationDetailsNPSControllerVM.nominees.push(insert);
            } else {
                console.log("Not allowed");
                nominationDetailsNPSControllerVM.disableAddNominiee = true;
            }

            nominationDetailsNPSControllerVM.resetTotalPercentageShare();

            // $timeout(function(){
            //     utilityService.hideSpinner();
            // },1000)

        }

        nominationDetailsNPSControllerVM.deleteNominee = function (index) {
            nominationDetailsNPSControllerVM.nominees.splice(index, 1);

            if (nominationDetailsNPSControllerVM.nominees.length < 3) {
                nominationDetailsNPSControllerVM.disableAddNominiee = false;
            }

            for (var i = 0; i < (nominationDetailsNPSControllerVM.nominees.length); i++) {
                nominationDetailsNPSControllerVM.nominees[i].count = i + 1;
            }

            nominationDetailsNPSControllerVM.resetTotalPercentageShare();

        }

        nominationDetailsNPSControllerVM.percentageShareChange = function (index) {

            nominationDetailsNPSControllerVM.resetTotalPercentageShare();

            console.log(nominationDetailsNPSControllerVM.totalPercentageShare);
            if (nominationDetailsNPSControllerVM.totalPercentageShare > 100.0) {
                var message = "Nominee share cannot be more than 100%";
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(message);
                nominationDetailsNPSControllerVM.nominees[index].percentageShare = nominationDetailsNPSControllerVM.percentageShareList[0].value;

                nominationDetailsNPSControllerVM.resetTotalPercentageShare();
            }

            if (nominationDetailsNPSControllerVM.totalPercentageShare >= 100.0) {
                nominationDetailsNPSControllerVM.disableAddNominiee = true;
            } else {
                nominationDetailsNPSControllerVM.disableAddNominiee = false;
            }
        }

        /* Open the date picker popup */
        nominationDetailsNPSControllerVM.openDatePicker = function (index) {


            // var nextDate = new Date().setDate(new Date().getDate() - 365);
            // var nextDate = new Date("01 Jan 1800");

            var nextDate = new Date().setDate(new Date().getDate() - 6570); // Date range of -18 years from current year
            var toDate = new Date().setDate(new Date().getDate());

            nominationDetailsNPSControllerVM.ipObj1 = {
                callback: function (val) {
                    var date = new Date(val);
                    nominationDetailsNPSControllerVM.nominees[index].nomineeDob = $filter('date')(date, "dd MMM yyyy");
                },
                inputDate: new Date(toDate),
                from: nextDate,
                to: toDate,
                mondayFirst: true,
                closeOnSelect: false,
                templateType: 'popup',
            };

            ionicDatePicker.openDatePicker(nominationDetailsNPSControllerVM.ipObj1);
        };

        $scope.$on('$ionicView.beforeEnter', function () {
            nominationDetailsNPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            nominationDetailsNPSControllerVM.npsAccountType = npsServices.npsAccountDetails.npsAccountType;
            nominationDetailsNPSControllerVM.percentageShareList = npsServices.npsDropdownData.nomineePercentage;
            nominationDetailsNPSControllerVM.nominees[0].percentageShare = nominationDetailsNPSControllerVM.percentageShareList[nominationDetailsNPSControllerVM.percentageShareList.length - 1].value;

            if (npsServices.npsNominationDetails.nominees[0]) {
                nominationDetailsNPSControllerVM.nominees = npsServices.npsNominationDetails.nominees;
            }
            nominationDetailsNPSControllerVM.sameNomineeForTierII = npsServices.npsNominationDetails.sameNomineeForTierII;
            nominationDetailsNPSControllerVM.resetTotalPercentageShare();
        });
        return this;
    }
]);
