'use strict';

angularApp.controller('nominationDetailsTierIINPSController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    "$filter",
    "ionicDatePicker",
    "$q",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices,
        $filter,
        ionicDatePicker,
        $q) {

        var nominationDetailsTierIINPSControllerVM = this;
        nominationDetailsTierIINPSControllerVM.totalPercentageShare = 0;
        $scope.currentPage = "11";
        $scope.lastPage = "16";
        nominationDetailsTierIINPSControllerVM.nomineeLabel = "Nominee";
        nominationDetailsTierIINPSControllerVM.nominees = [{
            count: 1,
            enableDelete: false,
            npsNomineeType: "",
            nomineeFirstName: "",
            nomineeMiddleName: "",
            nomineeSurname: "",
            nomineeRelationship: "",
            nomineeDob: "",
            percentageShare: "",
            guardianFirstName: "",
            nomineeMiddleName: "",
            guardianSurname: ""

        }];


        nominationDetailsTierIINPSControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        nominationDetailsTierIINPSControllerVM.goBack = function () {
            if (npsServices.npsAccountDetails.npsAccountType.toUpperCase() == "TIER1" || npsServices.npsNominationDetails.numberOfNominee == 1) {
                $state.go('menu.npsNominationDetails');
            } else {
                $state.go("menu.npsNomineeAddress");
            }

        }

        nominationDetailsTierIINPSControllerVM.goNext = function () {

            npsServices.npsNominationDetailsTierII.numberOfNominee = nominationDetailsTierIINPSControllerVM.nominees.length;
            npsServices.npsNominationDetailsTierII.nominees = nominationDetailsTierIINPSControllerVM.nominees;

            if (nominationDetailsTierIINPSControllerVM.nominees.length > 1) {
                $state.go("menu.npsNomineeAddressTierII");
            } else {


                var requestParams = {
                    "npsAccountType": "Tier2",
                    "isNomineeSame": nominationDetailsTierIINPSControllerVM.sameNomineeForTierII,
                    "nominees": [{
                        "type": "Tier2_Nominee1",
                        "firstName": nominationDetailsTierIINPSControllerVM.nominees[0].nomineeFirstName,
                        "middleName": nominationDetailsTierIINPSControllerVM.nominees[0].nomineeMiddleName,
                        "lastName": nominationDetailsTierIINPSControllerVM.nominees[0].nomineeSurname,
                        "relationship": nominationDetailsTierIINPSControllerVM.nominees[0].nomineeRelationship,
                        "isMajor": nominationDetailsTierIINPSControllerVM.nominees[0].npsNomineeType,
                        "percentageShare": nominationDetailsTierIINPSControllerVM.nominees[0].percentageShare,
                        "dob": nominationDetailsTierIINPSControllerVM.nominees[0].nomineeDob,
                        "guardian": {
                            "firstName": nominationDetailsTierIINPSControllerVM.nominees[0].guardianFirstName,
                            "middleName": nominationDetailsTierIINPSControllerVM.nominees[0].guardianMiddleName,
                            "lastName": nominationDetailsTierIINPSControllerVM.nominees[0].guardianSurname
                        }
                    }]
                };

                if (!npsServices.npsPensionDetails.pensionFundList[0] || !npsServices.npsPensionDetails.assetAllocationList[0]) {

                    $q.all([npsServices.saveNomineeDetails(requestParams), npsServices.fetchPensionFundList()]).then(function (response) {
                        npsServices.npsPensionDetails.pensionFundList = response[1].pensionFundList;
                        npsServices.npsPensionDetails.assetAllocationList = response[1].autoAssetAllocationList;
                        $state.go("menu.npsPensionFundDetails");

                    }, function (error) {
                        utilityService.enableShowErrorMessage();
                        utilityService.showErrorMessage(error.responseMessage);
                    });

                } else {

                    npsServices.saveNomineeDetails(requestParams).then(function (response) {
                        $state.go("menu.npsPensionFundDetails");

                    }, function (error) {
                        utilityService.enableShowErrorMessage();
                        utilityService.showErrorMessage(error.responseMessage);
                    });

                }


            }
        }

        nominationDetailsTierIINPSControllerVM.resetTotalPercentageShare = function () {
            nominationDetailsTierIINPSControllerVM.totalPercentageShare = 0;
            for (var i = 0; i < (nominationDetailsTierIINPSControllerVM.nominees.length); i++) {
                nominationDetailsTierIINPSControllerVM.totalPercentageShare = nominationDetailsTierIINPSControllerVM.totalPercentageShare + parseFloat(nominationDetailsTierIINPSControllerVM.nominees[i].percentageShare);
            }

            if (nominationDetailsTierIINPSControllerVM.totalPercentageShare == 100.0) {
                nominationDetailsTierIINPSControllerVM.disableNextButton = false
                nominationDetailsTierIINPSControllerVM.disableAddNominiee = true;
            } else {
                nominationDetailsTierIINPSControllerVM.disableNextButton = true
                if (nominationDetailsTierIINPSControllerVM.nominees.length < 3) {
                    nominationDetailsTierIINPSControllerVM.disableAddNominiee = false;
                }
            }
        }

        nominationDetailsTierIINPSControllerVM.addNominee = function () {
            // utilityService.doNotHideSpinner();
            // utilityService.showSpinner();

            if (nominationDetailsTierIINPSControllerVM.nominees.length < 3) {

                if (nominationDetailsTierIINPSControllerVM.nominees.length == 2) {
                    nominationDetailsTierIINPSControllerVM.disableAddNominiee = true;
                } else {
                    nominationDetailsTierIINPSControllerVM.disableAddNominiee = false;
                }

                var incrementValue = nominationDetailsTierIINPSControllerVM.nominees[nominationDetailsTierIINPSControllerVM.nominees.length - 1].count + 1;

                var insert = {
                    count: incrementValue,
                    enableDelete: true,
                    npsNomineeType: "",
                    nomineeFirstName: "",
                    nomineeMiddleName: "",
                    nomineeSurname: "",
                    nomineeRelationship: "",
                    nomineeDob: "",
                    percentageShare: nominationDetailsTierIINPSControllerVM.percentageShareList[0].value,
                    guardianFirstName: "",
                    guardianMiddleName: "",
                    guardianSurname: ""
                }

                nominationDetailsTierIINPSControllerVM.nominees.push(insert);
            } else {
                console.log("Not allowed");
                nominationDetailsTierIINPSControllerVM.disableAddNominiee = true;
            }

            nominationDetailsTierIINPSControllerVM.resetTotalPercentageShare();

            // $timeout(function(){
            //     utilityService.hideSpinner();
            // },1000)

        }

        nominationDetailsTierIINPSControllerVM.deleteNominee = function (index) {
            nominationDetailsTierIINPSControllerVM.nominees.splice(index, 1);

            if (nominationDetailsTierIINPSControllerVM.nominees.length < 3) {
                nominationDetailsTierIINPSControllerVM.disableAddNominiee = false;
            }

            for (var i = 0; i < (nominationDetailsTierIINPSControllerVM.nominees.length); i++) {
                nominationDetailsTierIINPSControllerVM.nominees[i].count = i + 1;
            }

            nominationDetailsTierIINPSControllerVM.resetTotalPercentageShare();

        }

        nominationDetailsTierIINPSControllerVM.percentageShareChange = function (index) {

            nominationDetailsTierIINPSControllerVM.resetTotalPercentageShare();

            console.log(nominationDetailsTierIINPSControllerVM.totalPercentageShare);
            if (nominationDetailsTierIINPSControllerVM.totalPercentageShare > 100.0) {
                var message = "Nominee share cannot be more than 100%";
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(message);
                nominationDetailsTierIINPSControllerVM.nominees[index].percentageShare = nominationDetailsTierIINPSControllerVM.percentageShareList[0].value;

                nominationDetailsTierIINPSControllerVM.resetTotalPercentageShare();
            }

            if (nominationDetailsTierIINPSControllerVM.totalPercentageShare >= 100.0) {
                nominationDetailsTierIINPSControllerVM.disableAddNominiee = true;
            } else {
                nominationDetailsTierIINPSControllerVM.disableAddNominiee = false;
            }
        }

        /* Open the date picker popup */
        nominationDetailsTierIINPSControllerVM.openDatePicker = function (index) {


            // var nextDate = new Date().setDate(new Date().getDate() + 1);

            var nextDate = new Date().setDate(new Date().getDate() - 6570); // Date range of -18 years from current year
            var toDate = new Date().setDate(new Date().getDate());

            nominationDetailsTierIINPSControllerVM.ipObj1 = {
                callback: function (val) {
                    var date = new Date(val);
                    nominationDetailsTierIINPSControllerVM.nominees[index].nomineeDob = $filter('date')(date, "dd MMM yyyy");
                },
                inputDate: new Date(toDate),
                from: nextDate,
                to: toDate,
                mondayFirst: true,
                closeOnSelect: false,
                templateType: 'popup',
            };

            ionicDatePicker.openDatePicker(nominationDetailsTierIINPSControllerVM.ipObj1);
        };
        $scope.$on('$ionicView.beforeEnter', function () {
            nominationDetailsTierIINPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            nominationDetailsTierIINPSControllerVM.percentageShareList = npsServices.npsDropdownData.nomineePercentage;
            nominationDetailsTierIINPSControllerVM.nominees[0].percentageShare = nominationDetailsTierIINPSControllerVM.percentageShareList[nominationDetailsTierIINPSControllerVM.percentageShareList.length - 1].value;

            if (npsServices.npsNominationDetailsTierII.nominees[0]) {
                nominationDetailsTierIINPSControllerVM.nominees = npsServices.npsNominationDetailsTierII.nominees;
            }

            nominationDetailsTierIINPSControllerVM.resetTotalPercentageShare();
        });
        return this;
    }
]);
