'use strict';

angularApp.controller('nomineeAddressNPSController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    "$filter",
    "$q",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices,
        $filter,
        $q) {

        var nomineeAddressNPSControllerVM = this;
        nomineeAddressNPSControllerVM.totalPercentageShare = 0;
        $scope.currentPage = "9";
        $scope.lastPage = "16";
        nomineeAddressNPSControllerVM.nomineeLabel = "Nominee";
        nomineeAddressNPSControllerVM.nomineeAddressDetails = [{
            count: 1,
            addressLine1: "",
            addressLine2: "",
            districtTownCity: "",
            pinCode: "",
            stateUnionTerritory: "",
            stateUnionTerritoryText: "",
            country: "IN",
            countryText: "India"

        }];


        nomineeAddressNPSControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        nomineeAddressNPSControllerVM.goBack = function () {
            $state.go('menu.npsNominationDetails');
        }

        nomineeAddressNPSControllerVM.goNext = function () {
            npsServices.npsNomineeAddressDetails.nomineesAddress = nomineeAddressNPSControllerVM.nomineeAddressDetails;

            nomineeAddressNPSControllerVM.nomineesRequest = [];

            for (var i = 0; i < nomineeAddressNPSControllerVM.numberOfNominee; i++) {
                var insert = {
                    "type": "Tier1_Nominee" + (i + 1),
                    "firstName": npsServices.npsNominationDetails.nominees[i].nomineeFirstName,
                    "middleName": npsServices.npsNominationDetails.nominees[i].nomineeMiddleName,
                    "lastName": npsServices.npsNominationDetails.nominees[i].nomineeSurname,
                    "relationship": npsServices.npsNominationDetails.nominees[i].nomineeRelationship,
                    "isMajor": npsServices.npsNominationDetails.nominees[i].npsNomineeType,
                    "percentageShare": npsServices.npsNominationDetails.nominees[i].percentageShare,
                    "dob": npsServices.npsNominationDetails.nominees[i].nomineeDob,
                    "addresses": [
                        {
                            "type": "Tier1_Nominee" + (i + 1),
                            "locality": "",
                            "addressLine1": nomineeAddressNPSControllerVM.nomineeAddressDetails[i].addressLine1,
                            "addressLine2": nomineeAddressNPSControllerVM.nomineeAddressDetails[i].addressLine2,
                            "pincode": nomineeAddressNPSControllerVM.nomineeAddressDetails[i].pinCode,
                            "city": nomineeAddressNPSControllerVM.nomineeAddressDetails[i].districtTownCity,
                            "cityCode": "",
                            "stateCode": nomineeAddressNPSControllerVM.nomineeAddressDetails[i].stateUnionTerritory,
                            "state": nomineeAddressNPSControllerVM.nomineeAddressDetails[i].stateUnionTerritoryText,
                            "districtCode": "",
                            "district": nomineeAddressNPSControllerVM.nomineeAddressDetails[i].districtTownCity,
                            "subDist": "",
                            "subDistrictCode": "",
                            "village": "",
                            "villageCode": "",
                            "country": nomineeAddressNPSControllerVM.nomineeAddressDetails[i].countryText,
                            "countryCode": nomineeAddressNPSControllerVM.nomineeAddressDetails[i].country,
                        }
                    ],
                    "guardian": {
                        "firstName": npsServices.npsNominationDetails.nominees[i].guardianFirstName,
                        "middleName": npsServices.npsNominationDetails.nominees[i].guardianMiddleName,
                        "lastName": npsServices.npsNominationDetails.nominees[i].guardianSurname
                    }
                }

                nomineeAddressNPSControllerVM.nomineesRequest.push(insert);

            }

            var requestParams = {
                "npsAccountType": "Tier1",
                "isNomineeSame": npsServices.npsNominationDetails.sameNomineeForTierII == true ? "Y" : "N",
                "nominees": nomineeAddressNPSControllerVM.nomineesRequest
            };


            if (npsServices.npsNominationDetails.sameNomineeForTierII || npsServices.npsAccountDetails.npsAccountType.toUpperCase() == "TIER1") {

                if (!npsServices.npsPensionDetails.pensionFundList[0] || !npsServices.npsPensionDetails.assetAllocationList[0]) {

                    $q.all([npsServices.saveNomineeDetails(requestParams), npsServices.fetchPensionFundList()]).then(function (response) {
                        npsServices.npsPensionDetails.pensionFundList = response[1].pensionFundList;
                        npsServices.npsPensionDetails.assetAllocationList = response[1].autoAssetAllocationList;
                        $state.go("menu.npsPensionFundDetails");

                    }, function (error) {
                        utilityService.enableShowErrorMessage();
                        utilityService.showErrorMessage(error.responseMessage);
                    });

                } else {

                    npsServices.saveNomineeDetails(requestParams).then(function (response) {
                        $state.go("menu.npsPensionFundDetails");

                    }, function (error) {
                        utilityService.enableShowErrorMessage();
                        utilityService.showErrorMessage(error.responseMessage);
                    });

                }

            } else {

                npsServices.saveNomineeDetails(requestParams).then(function (response) {
                    $state.go("menu.npsNominationDetailsTierII");

                }, function (error) {
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                });


            }
        }

        nomineeAddressNPSControllerVM.selectedStateUnionTerritory = function (index) {
            nomineeAddressNPSControllerVM.nomineeAddressDetails[index].stateUnionTerritoryText = utilityService.getTextFromDropdown("value", nomineeAddressNPSControllerVM.nomineeAddressDetails[index].stateUnionTerritory, nomineeAddressNPSControllerVM.stateList, "description");
        }

        nomineeAddressNPSControllerVM.selectedCountry = function (index) {
            nomineeAddressNPSControllerVM.nomineeAddressDetails[index].countryText = utilityService.getTextFromDropdown("value", nomineeAddressNPSControllerVM.nomineeAddressDetails[index].country, nomineeAddressNPSControllerVM.countryList, "description");
        }



        $scope.$on('$ionicView.beforeEnter', function () {
            nomineeAddressNPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            nomineeAddressNPSControllerVM.stateList = npsServices.npsDropdownData.stateMasters;
            nomineeAddressNPSControllerVM.countryList = npsServices.npsDropdownData.countryMasters;
            nomineeAddressNPSControllerVM.numberOfNominee = npsServices.npsNominationDetails.numberOfNominee;

            if (npsServices.npsNomineeAddressDetails.nomineesAddress[0]) {
                nomineeAddressNPSControllerVM.nomineeAddressDetails = npsServices.npsNomineeAddressDetails.nomineesAddress;
                if (nomineeAddressNPSControllerVM.numberOfNominee > nomineeAddressNPSControllerVM.nomineeAddressDetails.length) {

                    var nomineeDifference = nomineeAddressNPSControllerVM.numberOfNominee - nomineeAddressNPSControllerVM.nomineeAddressDetails.length;

                    for (var i = 0; i < nomineeDifference; i++) {
                        var insert = {
                            count: (nomineeAddressNPSControllerVM.nomineeAddressDetails.length + 1),
                            addressLine1: "",
                            addressLine2: "",
                            districtTownCity: "",
                            pinCode: "",
                            stateUnionTerritory: "",
                            stateUnionTerritoryText: "",
                            country: "IN",
                            countryText: "India"
                        }

                        nomineeAddressNPSControllerVM.nomineeAddressDetails.push(insert);

                    }
                } else if (nomineeAddressNPSControllerVM.numberOfNominee < nomineeAddressNPSControllerVM.nomineeAddressDetails.length) {

                    var nomineeDifference = nomineeAddressNPSControllerVM.nomineeAddressDetails.length - nomineeAddressNPSControllerVM.numberOfNominee;

                    for (var i = 0; i < nomineeDifference; i++) {
                        nomineeAddressNPSControllerVM.nomineeAddressDetails.pop();
                    }
                }
            } else {


                for (var i = 1; i < nomineeAddressNPSControllerVM.numberOfNominee; i++) {
                    var insert = {
                        count: (i + 1),
                        addressLine1: "",
                        addressLine2: "",
                        districtTownCity: "",
                        pinCode: "",
                        stateUnionTerritory: "",
                        stateUnionTerritoryText: "",
                        country: "IN",
                        countryText: "India"
                    }

                    nomineeAddressNPSControllerVM.nomineeAddressDetails.push(insert);

                }

            }

        });
        return this;
    }
]);
