'use strict';

angularApp.controller('nomineeAddressTierIINPSController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    "$filter",
    "$q",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices,
        $filter,
        $q) {

        var nomineeAddressTierIINPSControllerVM = this;
        nomineeAddressTierIINPSControllerVM.totalPercentageShare = 0;
        $scope.currentPage = "9";
        $scope.lastPage = "16";
        nomineeAddressTierIINPSControllerVM.nomineeLabel = "Nominee";
        nomineeAddressTierIINPSControllerVM.nomineeAddressDetails = [{
            count: 1,
            addressLine1: "",
            addressLine2: "",
            districtTownCity: "",
            pinCode: "",
            stateUnionTerritory: "",
            stateUnionTerritoryText: "",
            country: "IN",
            countryText: "India"

        }];


        nomineeAddressTierIINPSControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        nomineeAddressTierIINPSControllerVM.goBack = function () {
            $state.go("menu.npsNominationDetailsTierII");
        }

        nomineeAddressTierIINPSControllerVM.goNext = function () {
            npsServices.npsNomineeAddressDetailsTierII.nomineesAddress = nomineeAddressTierIINPSControllerVM.nomineeAddressDetails;

            nomineeAddressTierIINPSControllerVM.nomineesRequest = [];

            for (var i = 0; i < nomineeAddressTierIINPSControllerVM.numberOfNominee; i++) {
                var insert = {
                    "type": "Tier2_Nominee" + (i + 1),
                    "firstName": npsServices.npsNominationDetailsTierII.nominees[i].nomineeFirstName,
                    "middleName": npsServices.npsNominationDetailsTierII.nominees[i].nomineeMiddleName,
                    "lastName": npsServices.npsNominationDetailsTierII.nominees[i].nomineeSurname,
                    "relationship": npsServices.npsNominationDetailsTierII.nominees[i].nomineeRelationship,
                    "isMajor": npsServices.npsNominationDetailsTierII.nominees[i].npsNomineeType,
                    "percentageShare": npsServices.npsNominationDetailsTierII.nominees[i].percentageShare,
                    "dob": npsServices.npsNominationDetailsTierII.nominees[i].nomineeDob,
                    "addresses": [
                        {
                            "type": "Tier2_Nominee" + (i + 1),
                            "locality": "",
                            "addressLine1": nomineeAddressTierIINPSControllerVM.nomineeAddressDetails[i].addressLine1,
                            "addressLine2": nomineeAddressTierIINPSControllerVM.nomineeAddressDetails[i].addressLine2,
                            "pincode": nomineeAddressTierIINPSControllerVM.nomineeAddressDetails[i].pinCode,
                            "city": nomineeAddressTierIINPSControllerVM.nomineeAddressDetails[i].districtTownCity,
                            "cityCode": "",
                            "stateCode": nomineeAddressTierIINPSControllerVM.nomineeAddressDetails[i].stateUnionTerritory,
                            "state": nomineeAddressTierIINPSControllerVM.nomineeAddressDetails[i].stateUnionTerritoryText,
                            "districtCode": "",
                            "district": nomineeAddressTierIINPSControllerVM.nomineeAddressDetails[i].districtTownCity,
                            "subDist": "",
                            "subDistrictCode": "",
                            "village": "",
                            "villageCode": "",
                            "country": nomineeAddressTierIINPSControllerVM.nomineeAddressDetails[i].countryText,
                            "countryCode": nomineeAddressTierIINPSControllerVM.nomineeAddressDetails[i].country,
                        }
                    ],
                    "guardian": {
                        "firstName": npsServices.npsNominationDetailsTierII.nominees[i].guardianFirstName,
                        "middleName": npsServices.npsNominationDetailsTierII.nominees[i].guardianMiddleName,
                        "lastName": npsServices.npsNominationDetailsTierII.nominees[i].guardianSurname
                    }
                }

                nomineeAddressTierIINPSControllerVM.nomineesRequest.push(insert);

            }

            var requestParams = {
                "npsAccountType": "Tier2",
                "isNomineeSame": "",
                "nominees": nomineeAddressTierIINPSControllerVM.nomineesRequest
            };

            if (!npsServices.npsPensionDetails.pensionFundList[0] || !npsServices.npsPensionDetails.assetAllocationList[0]) {

                $q.all([npsServices.saveNomineeDetails(requestParams), npsServices.fetchPensionFundList()]).then(function (response) {
                    npsServices.npsPensionDetails.pensionFundList = response[1].pensionFundList;
                    npsServices.npsPensionDetails.assetAllocationList = response[1].autoAssetAllocationList;
                    $state.go("menu.npsPensionFundDetails");

                }, function (error) {
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                });

            } else {

                npsServices.saveNomineeDetails(requestParams).then(function (response) {
                    $state.go("menu.npsPensionFundDetails");

                }, function (error) {
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                });

            }

        }

        nomineeAddressTierIINPSControllerVM.selectedStateUnionTerritory = function (index) {
            nomineeAddressTierIINPSControllerVM.nomineeAddressDetails[index].stateUnionTerritoryText = utilityService.getTextFromDropdown("value", nomineeAddressTierIINPSControllerVM.nomineeAddressDetails[index].stateUnionTerritory, nomineeAddressTierIINPSControllerVM.stateList, "description");
        }

        nomineeAddressTierIINPSControllerVM.selectedCountry = function (index) {
            nomineeAddressTierIINPSControllerVM.nomineeAddressDetails[index].countryText = utilityService.getTextFromDropdown("value", nomineeAddressTierIINPSControllerVM.nomineeAddressDetails[index].country, nomineeAddressTierIINPSControllerVM.countryList, "description");
        }


        $scope.$on('$ionicView.beforeEnter', function () {
            nomineeAddressTierIINPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            nomineeAddressTierIINPSControllerVM.stateList = npsServices.npsDropdownData.stateMasters;
            nomineeAddressTierIINPSControllerVM.countryList = npsServices.npsDropdownData.countryMasters;
            nomineeAddressTierIINPSControllerVM.numberOfNominee = npsServices.npsNominationDetailsTierII.numberOfNominee;

            if (npsServices.npsNomineeAddressDetailsTierII.nomineesAddress[0]) {
                nomineeAddressTierIINPSControllerVM.nomineeAddressDetails = npsServices.npsNomineeAddressDetailsTierII.nomineesAddress;
                if (nomineeAddressTierIINPSControllerVM.numberOfNominee > nomineeAddressTierIINPSControllerVM.nomineeAddressDetails.length) {

                    var nomineeDifference = nomineeAddressTierIINPSControllerVM.numberOfNominee - nomineeAddressTierIINPSControllerVM.nomineeAddressDetails.length;

                    for (var i = 0; i < nomineeDifference; i++) {
                        var insert = {
                            count: (nomineeAddressTierIINPSControllerVM.nomineeAddressDetails.length + 1),
                            addressLine1: "",
                            addressLine2: "",
                            districtTownCity: "",
                            pinCode: "",
                            stateUnionTerritory: "",
                            stateUnionTerritoryText: "",
                            country: "IN",
                            countryText: "India"
                        }

                        nomineeAddressTierIINPSControllerVM.nomineeAddressDetails.push(insert);

                    }
                } else if (nomineeAddressTierIINPSControllerVM.numberOfNominee < nomineeAddressTierIINPSControllerVM.nomineeAddressDetails.length) {

                    var nomineeDifference = nomineeAddressTierIINPSControllerVM.nomineeAddressDetails.length - nomineeAddressTierIINPSControllerVM.numberOfNominee;

                    for (var i = 0; i < nomineeDifference; i++) {
                        nomineeAddressTierIINPSControllerVM.nomineeAddressDetails.pop();
                    }
                }
            } else {


                for (var i = 1; i < nomineeAddressTierIINPSControllerVM.numberOfNominee; i++) {
                    var insert = {
                        count: (i + 1),
                        addressLine1: "",
                        addressLine2: "",
                        districtTownCity: "",
                        pinCode: "",
                        stateUnionTerritory: "",
                        stateUnionTerritoryText: "",
                        country: "IN",
                        countryText: "India"
                    }

                    nomineeAddressTierIINPSControllerVM.nomineeAddressDetails.push(insert);

                }

            }

        });
        return this;
    }
]);
