/**
*   @ngdoc config
*   @name angularApp.config : npsConfig
*   @description
*	configuration file for NPS module
*/

'use strict';

/*State defination with respective names, urls, controllers and templates */
angularApp.config(['$stateProvider',
    function ($stateProvider) {
        $stateProvider
            .state('menu.landingNPSView', {
                url: '/landingNPSView',
                cache: false,
                data: {
                    pageId: 'NPS_LANDING_VIEW'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/nps/landing/landingNPS.html',
                        controller: 'landingNPSController',
                        controllerAs: 'landingNPSControllerVM',
                    }
                }
            })
            .state('menu.termsConditionsNPSView', {
                url: '/termsConditionsNPSView',
                cache: false,
                data: {
                    pageId: 'NPS_TERMSCONDITIONS_VIEW'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/nps/termsConditions/termsConditionsNPS.html',
                        controller: 'termsConditionsNPSController',
                        controllerAs: 'termsConditionsNPSControllerVM',
                    }
                }
            })
            .state('menu.accountDetailsNPSView', {
                url: '/accountDetailsNPSView',
                cache: false,
                data: {
                    pageId: 'NPS_ACCDETAILS_VIEW'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/nps/accountDetails/accountDetailsNPS.html',
                        controller: 'accountDetailsNPSController',
                        controllerAs: 'accountDetailsNPSControllerVM',
                    }
                }
            })
            .state('menu.trpnSuccess', {
                url: '/trpnSuccess',
                cache: false,
                data: {
                    pageId: 'NPS_TRPNSUCCESS_VIEW'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/nps/trpnSuccess/trpnSuccessNPS.html',
                        controller: 'trpnSuccessNPSController',
                        controllerAs: 'trpnSuccessNPSControllerVM',
                    }
                }
            })
            .state('menu.npsPersonalDetails', {
                url: '/npsPersonalDetails',
                cache: false,
                data: {
                    pageId: 'NPS_PERSONAL_DETAILS_VIEW'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/nps/personalDetails/personalDetailsNPS.html',
                        controller: 'personalDetailsNPSController',
                        controllerAs: 'personalDetailsNPSControllerVM',
                    }
                }
            })
            .state('menu.npsTakeSelfie', {
                url: '/npsTakeSelfie',
                cache: false,
                data: {
                    pageId: 'NPS_TAKE_SELFIE'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/nps/personalDetails/takeSelfieNPS.html',
                        controller: 'takeSelfieNPSController',
                        controllerAs: 'takeSelfieNPSControllerVM',
                    }
                }
            })
            .state('menu.npsLooksGreat', {
                url: '/npsLooksGreat',
                cache: false,
                data: {
                    pageId: 'NPS_LOOKS_GREAT'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/nps/personalDetails/looksGreatNPS.html',
                        controller: 'looksGreatNPSController',
                        controllerAs: 'looksGreatNPSControllerVM',
                    }
                }
            })
            .state('menu.npsParentDetails', {
                url: '/npsParentDetails',
                cache: false,
                data: {
                    pageId: 'NPS_PARENTS_DETAILS_VIEW'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/nps/personalDetails/parentsDetailsNPS.html',
                        controller: 'parentsDetailsNPSController',
                        controllerAs: 'parentsDetailsNPSControllerVM',
                    }
                }
            })
            .state('menu.npsAddressDetails', {
                url: '/npsAddressDetails',
                cache: false,
                data: {
                    pageId: 'NPS_ADDRRESS_DETAILS_VIEW'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/nps/addressDetails/addressDetailsNPS.html',
                        controller: 'addressDetailsNPSController',
                        controllerAs: 'addressDetailsNPSControllerVM',
                    }
                }
            })
            .state('menu.npsContactDetails', {
                url: '/npsContactDetails',
                cache: false,
                data: {
                    pageId: 'NPS_CONTACT_DETAILS_VIEW'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/nps/contactDetails/contactDetailsNPS.html',
                        controller: 'contactDetailsNPSController',
                        controllerAs: 'contactDetailsNPSControllerVM',
                    }
                }
            })
            .state('menu.npsOtherDetails', {
                url: '/npsOtherDetails',
                cache: false,
                data: {
                    pageId: 'NPS_OTHER_DETAILS_VIEW'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/nps/otherDetails/otherDetailsNPS.html',
                        controller: 'otherDetailsNPSController',
                        controllerAs: 'otherDetailsNPSControllerVM',
                    }
                }
            })
            .state('menu.npsTakeSignature', {
                url: '/npsTakeSignature',
                cache: false,
                data: {
                    pageId: 'NPS_TAKE_SIGNATURE'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/nps/otherDetails/takeSignatureNPS.html',
                        controller: 'takeSignatureNPSController',
                        controllerAs: 'takeSignatureNPSControllerVM',
                    }
                }
            })
            .state('menu.npsSignaturePreview', {
                url: '/npsSignaturePreview',
                cache: false,
                data: {
                    pageId: 'NPS_SIGNATURE_PREVIEW'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/nps/otherDetails/signaturePreviewNPS.html',
                        controller: 'signaturePreviewNPSController',
                        controllerAs: 'signaturePreviewNPSControllerVM',
                    }
                }
            })
            .state('menu.npsBankDetails', {
                url: '/npsBankDetails',
                cache: false,
                data: {
                    pageId: 'NPS_BANK_DETAILS_VIEW'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/nps/bankDetails/bankDetailsNPS.html',
                        controller: 'bankDetailsNPSController',
                        controllerAs: 'bankDetailsNPSControllerVM',
                    }
                }
            })
            .state('menu.npsNominationDetails', {
                url: '/npsNominationDetails',
                cache: false,
                data: {
                    pageId: 'NPS_NOMINATION_DETAILS_VIEW'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/nps/nominationDetails/nominationDetailsNPS.html',
                        controller: 'nominationDetailsNPSController',
                        controllerAs: 'nominationDetailsNPSControllerVM',
                    }
                }
            })
            .state('menu.npsNomineeAddress', {
                url: '/npsNomineeAddress',
                cache: false,
                data: {
                    pageId: 'NPS_NOMINEE_ADDRESS_VIEW'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/nps/nominationDetails/nomineeAddressNPS.html',
                        controller: 'nomineeAddressNPSController',
                        controllerAs: 'nomineeAddressNPSControllerVM',
                    }
                }
            })
            .state('menu.npsNominationDetailsTierII', {
                url: '/npsNominationDetailsTierII',
                cache: false,
                data: {
                    pageId: 'NPS_NOMINATION_DETAILS_TIERII_VIEW'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/nps/nominationDetails/nominationDetailsTierIINPS.html',
                        controller: 'nominationDetailsTierIINPSController',
                        controllerAs: 'nominationDetailsTierIINPSControllerVM',
                    }
                }
            })
            .state('menu.npsNomineeAddressTierII', {
                url: '/npsNomineeAddressTierII',
                cache: false,
                data: {
                    pageId: 'NPS_NOMINEE_ADDRESS_TIERII_VIEW'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/nps/nominationDetails/nomineeAddressTierIINPS.html',
                        controller: 'nomineeAddressTierIINPSController',
                        controllerAs: 'nomineeAddressTierIINPSControllerVM',
                    }
                }
            })
            .state('menu.npsPensionFundDetails', {
                url: '/npsPensionFundDetails',
                cache: false,
                data: {
                    pageId: 'NPS_PENSION_FUND_DETAILS_VIEW'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/nps/pensionFundDetails/pensionFundDetailsNPS.html',
                        controller: 'pensionFundDetailsNPSController',
                        controllerAs: 'pensionFundDetailsNPSControllerVM',
                    }
                }
            })
            .state('menu.npsPensionFundDetailsTierII', {
                url: '/npsPensionFundDetailsTierII',
                cache: false,
                data: {
                    pageId: 'NPS_PENSION_FUND_DETAILS_TIERII_VIEW'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/nps/pensionFundDetails/pensionFundDetailsTierIINPS.html',
                        controller: 'pensionFundDetailsTierIINPSController',
                        controllerAs: 'pensionFundDetailsTierIINPSControllerVM',
                    }
                }
            })
            .state('menu.npsAssetAllocationDetails', {
                url: '/npsAssetAllocationDetails',
                cache: false,
                data: {
                    pageId: 'NPS_ASSET_ALLOCATION_DETAILS_VIEW'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/nps/pensionFundDetails/assetAllocationDetailsNPS.html',
                        controller: 'assetAllocationDetailsNPSController',
                        controllerAs: 'assetAllocationDetailsNPSControllerVM',
                    }
                }
            })
            .state('menu.fatcaDetails', {
                url: '/fatcaDetails',
                cache: false,
                data: {
                    pageId: 'NPS_FATCA_DETAILS_VIEW'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/nps/fatcaDetails/fatcaDetailsNPS.html',
                        controller: 'fatcaDetailsNPSController',
                        controllerAs: 'fatcaDetailsNPSControllerVM',
                    }
                }
            })
            .state('menu.moneyLaunderingDeclaration', {
                url: '/moneyLaunderingDeclaration',
                cache: false,
                data: {
                    pageId: 'NPS_MONEY_LAUNDERING_DECLARATION'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/nps/moneyLaunderingDeclaration/moneyLaunderingDeclarationNPS.html',
                        controller: 'moneyLaunderingDeclarationNPSController',
                        controllerAs: 'moneyLaunderingDeclarationNPSControllerVM',
                    }
                }
            })
            .state('menu.contributionDetails', {
                url: '/contributionDetails',
                cache: false,
                data: {
                    pageId: 'NPS_CONTRIBUTION_DETAILS_VIEW'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/nps/contributionDetails/contributionDetailsNPS.html',
                        controller: 'contributionDetailsNPSController',
                        controllerAs: 'contributionDetailsNPSControllerVM',
                    }
                }
            })
            .state('menu.contributionReview', {
                url: '/contributionReview',
                cache: false,
                data: {
                    pageId: 'NPS_CONTRIBUTION_REVIEW_VIEW'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/nps/contributionDetails/contributionReviewNPS.html',
                        controller: 'contributionReviewNPSController',
                        controllerAs: 'contributionReviewNPSControllerVM',
                    }
                }
            })
            .state('menu.reviewDetailsNps', {
                url: '/reviewDetailsNps',
                cache: false,
                data: {
                    pageId: 'NPS_CONTRIBUTION_REVIEW_DETAILS'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/nps/reviewDetails/reviewDetailsNPS.html',
                        controller: 'reviewDetailsNPSController',
                        controllerAs: 'reviewDetailsNPSControllerVM',
                    }
                }
            })
            .state('menu.otpNps', {
                url: '/otpNps',
                cache: false,
                data: {
                    pageId: 'NPS_OTP'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/nps/npsOTP/otpNPS.html',
                        controller: 'otpNPSController',
                        controllerAs: 'otpNPSControllerVM',
                    }
                }
            })
            .state('menu.finalSuccessNps', {
                url: '/finalSuccessNps',
                cache: false,
                data: {
                    pageId: 'NPS_FINAL_SUCCESS_VIEW'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/nps/finalSuccess/finalSuccessNPS.html',
                        controller: 'finalSuccessNPSController',
                        controllerAs: 'finalSuccessNPSControllerVM',
                    }
                }
            })
    }
]);