'use strict';

angularApp.controller('otpNPSController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "npsServices",
    "$ionicViewSwitcher",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        npsServices,
        $ionicViewSwitcher) {

        var otpNPSControllerVM = this;
        $scope.currentPage = "15";
        $scope.lastPage = "16";

        otpNPSControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        otpNPSControllerVM.goBack = function () {
            $ionicHistory.goBack();
        }

        otpNPSControllerVM.goNext = function () {

            var requestParams = {
                otp: otpNPSControllerVM.otp
            };

            npsServices.validateOTP(requestParams).then(function (response) {


                // Call after OTP validated

                var requestParams = {
                    "tprn": npsServices.npsTprnSuccessData.tprn
                }

                npsServices.generatePRAN(requestParams).then(function (response) {
                    npsServices.npsFinalSuccessDetails.pran = response.pranNumber;
                    npsServices.npsFinalSuccessDetails.registrationReceiptNo = response.registrationNumber;
                    npsServices.npsFinalSuccessDetails.contributionReceiptNo = response.contributionReferenceNumber;
                    npsServices.npsFinalSuccessDetails.pdfDocName = response.pdfDocName;
                    npsServices.npsFinalSuccessDetails.applicationSubmittedDate = response.applisubmitdate;
                    $state.go("menu.finalSuccessNps");

                }, function (error) {
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                });




            }, function (error) {
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(error.responseMessage);
            });

        }

        otpNPSControllerVM.resendOTP = function () {

            var requestParams = {
                "reviewconsent": npsServices.applicantData.reviewconsent == true ? "Y" : "N",
                "otpflag": npsServices.applicantData.otpflag == true ? "Y" : "N"
              }

            npsServices.generateOTP(requestParams).then(function (response) {

            }, function (error) {
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(error.responseMessage);
            });


        }


        $scope.$on('$ionicView.beforeEnter', function () {
            otpNPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
        });


        return this;
    }
]);
