'use strict';

angularApp.controller('otherDetailsNPSController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    "$filter",
    "$ionicPopover",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices,
        $filter,
        $ionicPopover) {

        var otherDetailsNPSControllerVM = this;
        $scope.currentPage = "8";
        $scope.lastPage = "16";


        otherDetailsNPSControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        otherDetailsNPSControllerVM.goBack = function () {
            $state.go('menu.npsContactDetails');
        }

        otherDetailsNPSControllerVM.selectedOccupation = function () {

            otherDetailsNPSControllerVM.npsOtherDetails.occupationText = utilityService.getTextFromDropdown("value", otherDetailsNPSControllerVM.npsOtherDetails.occupation, otherDetailsNPSControllerVM.occupationList, "description");

        }

        otherDetailsNPSControllerVM.selectedIncomeRange = function () {

            otherDetailsNPSControllerVM.npsOtherDetails.incomeText = utilityService.getTextFromDropdown("value", otherDetailsNPSControllerVM.npsOtherDetails.income, otherDetailsNPSControllerVM.incomeList, "description");

        }

        otherDetailsNPSControllerVM.selectedEducationQualification = function () {

            otherDetailsNPSControllerVM.npsOtherDetails.educationText = utilityService.getTextFromDropdown("value", otherDetailsNPSControllerVM.npsOtherDetails.education, otherDetailsNPSControllerVM.educationList, "description");

        }

        /* Info Popup */
        var template = '<ion-popover-view class="nps-tooltip-after tooltiptext nps-otherDetails-tooltip roboto-regular">' + '<ion-content>' +
            '<div class="text-left" ng-bind-html="otherDetailsNPSControllerVM.getInfoMsg"></div>' + '</ion-content>' + '</ion-popover-view>';

        $scope.popover = $ionicPopover.fromTemplate(template, {
            scope: $scope
        });

        otherDetailsNPSControllerVM.politicalInfo = function ($event) {
            otherDetailsNPSControllerVM.getInfoMsg = "<div><strong>Information</strong></div><div>Politically Exposed Persons’ (PEPs) are individuals who are or have been entrusted with prominent public functions in a foreign country, for example heads of state or of the government, senior politicians, senior government, judicial or military officials, senior executives of state-owned corporations, important political party officials.</div > ";
            $scope.popover.show($event);
        }


        otherDetailsNPSControllerVM.goNext = function () {
            npsServices.npsOtherDetails.occupation = otherDetailsNPSControllerVM.npsOtherDetails.occupation;
            npsServices.npsOtherDetails.occupationText = otherDetailsNPSControllerVM.npsOtherDetails.occupationText;
            npsServices.npsOtherDetails.otherOccupationDetails = otherDetailsNPSControllerVM.npsOtherDetails.otherOccupationDetails;
            npsServices.npsOtherDetails.income = otherDetailsNPSControllerVM.npsOtherDetails.income;
            npsServices.npsOtherDetails.incomeText = otherDetailsNPSControllerVM.npsOtherDetails.incomeText;
            npsServices.npsOtherDetails.education = otherDetailsNPSControllerVM.npsOtherDetails.education;
            npsServices.npsOtherDetails.educationText = otherDetailsNPSControllerVM.npsOtherDetails.educationText;
            npsServices.npsOtherDetails.politicalExposed = otherDetailsNPSControllerVM.npsOtherDetails.politicalExposed;

            if(npsServices.applicantData.customerSignature || npsServices.applicantData.custsignid){
                $state.go('menu.npsSignaturePreview');
            }else{
                $state.go("menu.npsTakeSignature");
            }

        }

        $scope.$on('$ionicView.beforeEnter', function () {
            otherDetailsNPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            otherDetailsNPSControllerVM.occupationList = npsServices.npsDropdownData.rioccupation;
            otherDetailsNPSControllerVM.educationList = npsServices.npsDropdownData.educationMaster;
            otherDetailsNPSControllerVM.incomeList = npsServices.npsDropdownData.incomeMaster;
            otherDetailsNPSControllerVM.npsOtherDetails = angular.copy(npsServices.npsOtherDetails);
            // if(!npsServices.npsOtherDetails.occupation){
            //     otherDetailsNPSControllerVM.npsOtherDetails.occupation = otherDetailsNPSControllerVM.occupationList[0].value;
            // }
            // if(!npsServices.npsOtherDetails.income){
            //     otherDetailsNPSControllerVM.npsOtherDetails.income = otherDetailsNPSControllerVM.incomeList[0].value;
            // }
            // if(!npsServices.npsOtherDetails.education){
            //     otherDetailsNPSControllerVM.npsOtherDetails.education = otherDetailsNPSControllerVM.educationList[0].value;
            // }



        });


        return this;
    }
]);
