'use strict';

angularApp.controller('signaturePreviewNPSController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    "$filter",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices,
        $filter) {

        var signaturePreviewNPSControllerVM = this;
        $scope.currentPage = "9";
        $scope.lastPage = "16";
        signaturePreviewNPSControllerVM.isPanNumMasked = false;
        signaturePreviewNPSControllerVM.isAadhaarNumMasked = false;


        signaturePreviewNPSControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        signaturePreviewNPSControllerVM.sizeInfo = function ($event) {
            npsServices.sizeInfoPopover($event, $scope);
        }

        // signaturePreviewNPSControllerVM.imgSizeValidation = function () {
        //     var imgBase = npsServices.customer.photo;

        //     var blob = new Blob([imgBase], { type: 'image/jpeg' });

        //     if (blob.size < 54 * 1024) {
        //         signaturePreviewNPSControllerVM.handleApply();
        //     }
        //     else {
        //         var title = '';
        //         var template = '{{"UPLOAD_IMG_SIZE" | translate}}';
        //         var onTap = 'menu.looksGreatAO';
        //         var buttontext = '<b>' + signaturePreviewNPSControllerVM.okBtntext + '</b>';
        //         utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
        //     }
        // }

        /* Functionality : Service to upload the customer photo
   Event : On click of "tick" image
*/
        // signaturePreviewNPSControllerVM.handleApply = function () {
        //     var newImg = npsServices.customer.photo;
        //     var baseImg = newImg.split("base64,")[1];
        //     var requestParams = {
        //         "documentClass": "LT_AccountOpening_NPS",
        //         "mimeType": "image/jpg",
        //         "documentTitle": "Customer Signature",
        //         "documentData": baseImg,
        //         "documentType": "Signature",
        //         "accountNo": "",
        //         "documentID": "",
        //         "commonId": "",
        //         "id": npsServices.picId
        //     }
        //     npsServices.uploadDocument(requestParams).then(function (response) {
        //         npsServices.picId = response.data.docRef;
        //         $state.go('menu.annualIncomeAO');
        //     }, function (error) {
        //         utilityService.showErrorMessage(error.responseMessage);
        //     });
        // }

        // signaturePreviewNPSControllerVM.retrievePhotoCall = function () {
        //     var param = npsServices.picId;

        //     npsServices.retrievePhoto(param).then(function (response) {

        //         signaturePreviewNPSControllerVM.croppedImage = "data:image/jpeg;base64," + response.data.documentData;
        //         npsServices.customer.photo = signaturePreviewNPSControllerVM.croppedImage;
        //     }, function (error) {
        //         utilityService.showErrorMessage(error.responseMessage);
        //     });
        // }

        signaturePreviewNPSControllerVM.goBack = function () {

            $state.go("menu.npsTakeSignature");

        }

        signaturePreviewNPSControllerVM.getBranchName = function () {

            if (!npsServices.npsBankDetails.branchName) {
                var requestParams = {};
                npsServices.fetchBranchDetails(requestParams).then(function (response) {
                    npsServices.npsBankDetails = response.data.branches[0];
                    $state.go("menu.npsBankDetails");

                }, function (error) {
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else {
                $state.go("menu.npsBankDetails");
            }

        }

        signaturePreviewNPSControllerVM.goNext = function () {

            var newImg = signaturePreviewNPSControllerVM.croppedImage;
            var baseImg = newImg.split("base64,")[1];
            var requestParams = {
                "documentClass": "LT_AccountOpening_NPS",
                "mimeType": "image/jpg",
                "documentTitle": "Customer Signature",
                "documentData": baseImg,
                "documentType": "Signature",
                "accountNo": "",
                "documentID": "",
                "commonId": "",
                "id": npsServices.applicantData.custsignid,
                "confirmFlag": signaturePreviewNPSControllerVM.applicantData.signConfirmFlag == true ? "Y" : "N"
            }
            npsServices.uploadDocument(requestParams).then(function (response) {
                npsServices.applicantData.custsignid = response.data.docRef;
                signaturePreviewNPSControllerVM.getBranchName();
            }, function (error) {
                npsServices.showErrorMessage(error.responseMessage);
            });
            

        }

        signaturePreviewNPSControllerVM.retrievePhotoCall = function () {
            var param = npsServices.applicantData.custsignid;

            npsServices.retrievePhoto(param).then(function (response) {

                signaturePreviewNPSControllerVM.croppedImage = "data:image/jpeg;base64," + response.data.documentData;
                npsServices.applicantData.customerSignature = signaturePreviewNPSControllerVM.croppedImage;
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }



        $scope.$on('$ionicView.beforeEnter', function () {
            signaturePreviewNPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            signaturePreviewNPSControllerVM.disableTitle = false;

            if (!npsServices.applicantData.customerSignature) {
                if (!utilityService.isUndefined(npsServices.applicantData.custsignid)) {
                    signaturePreviewNPSControllerVM.retrievePhotoCall();
                }
            }
            else {
                signaturePreviewNPSControllerVM.croppedImage = npsServices.applicantData.customerSignature;

            }

            signaturePreviewNPSControllerVM.applicantData.signConfirmFlag = npsServices.applicantData.signConfirmFlag;

            



        });

        return this;
    }
]);
