'use strict';

angularApp.controller('takeSignatureNPSController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    "$filter",
    "cameraService",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices,
        $filter,
        cameraService) {

        var takeSignatureNPSControllerVM = this;
        $scope.currentPage = "9";
        $scope.lastPage = "16";
        takeSignatureNPSControllerVM.isPanNumMasked = false;
        takeSignatureNPSControllerVM.isAadhaarNumMasked = false;

        function initPage() {

            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                takeSignatureNPSControllerVM.okBtntext = translatedvalue;
            });
        }

        takeSignatureNPSControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        takeSignatureNPSControllerVM.goBack = function () {
            $state.go("menu.npsOtherDetails");
        }

        takeSignatureNPSControllerVM.sizeInfo = function ($event) {
            npsServices.sizeInfoPopover($event, $scope);
        }

        /* Opens Mobile Camera */
        takeSignatureNPSControllerVM.openCamera = function () {
            cameraService.getnewSignatureAoNps().then(function (data) {
                takeSignatureNPSControllerVM.setImage(data);
                $state.go('menu.npsSignaturePreview');
            }, function (error) {
                if(error != "error"){
                var title = '';
                var template = error;
                var onTap = '';
                var buttontext = '<strong>' + takeSignatureNPSControllerVM.okBtntext + '</strong>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                }else {
                var title1 = '';
                var template1 = '{{"SERVICE_ERR_MSG" | translate}}';
                var onTap1 = '';
                var buttontext1 = '<strong>' + takeSignatureNPSControllerVM.okBtntext + '</strong>';
                utilityService.showAlertModal(title1, template1, onTap1, $scope, $state, buttontext1);
                }
            });
        }

        /* Set the image captured in camera */
        takeSignatureNPSControllerVM.setImage = function (img) {
            npsServices.applicantData.customerSignature = img;
        }

        /* Fetch image from gallery */
        takeSignatureNPSControllerVM.chooseFromGallery = function () {
            cameraService.getSignatureFromGalleryAoNps().then(function (data) {
                takeSignatureNPSControllerVM.setImage(data);
                $state.go('menu.npsSignaturePreview');
            }, function (error) {
                if(error != "error"){
                    var title2 = '';
                    var template2 = error;
                    var onTap2 = '';
                    var buttontext2 = '<strong>' + takeSignatureNPSControllerVM.okBtntext + '</strong>';
                    utilityService.showAlertModal(title2, template2, onTap2, $scope, $state, buttontext2);
                    }else {
                    var title3 = '';
                    var template3 = '{{"SERVICE_ERR_MSG" | translate}}';
                    var onTap3 = '';
                    var buttontext3 = '<strong>' + takeSignatureNPSControllerVM.okBtntext + '</strong>';
                    utilityService.showAlertModal(title3, template3, onTap3, $scope, $state, buttontext3);
                    }
            });
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });


        $scope.$on('$ionicView.beforeEnter', function () {
            takeSignatureNPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
        });

        return this;
    }
]);
