'use strict';

angularApp.controller('pensionFundDetailsNPSController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    "$filter",
    "constantConfig",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices,
        $filter,
        constantConfig) {

        var pensionFundDetailsNPSControllerVM = this;
        $scope.currentPage = "12";
        $scope.lastPage = "16";
        pensionFundDetailsNPSControllerVM.npsInvestmentOptionFlag = false;
        pensionFundDetailsNPSControllerVM.showActive = true;

        pensionFundDetailsNPSControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        pensionFundDetailsNPSControllerVM.goBack = function () {
            if (npsServices.npsNominationDetails.sameNomineeForTierII || npsServices.npsAccountDetails.npsAccountType.toUpperCase() == "TIER1") {

                if (npsServices.npsNominationDetails.numberOfNominee > 1) {
                    $state.go("menu.npsNomineeAddress");
                } else {
                    $state.go('menu.npsNominationDetails');
                }

            } else {

                if (npsServices.npsNominationDetailsTierII.numberOfNominee > 1) {
                    $state.go("menu.npsNomineeAddressTierII");
                } else {
                    $state.go("menu.npsNominationDetailsTierII");
                }

            }
        }


        pensionFundDetailsNPSControllerVM.goNext = function () {
            npsServices.npsPensionDetails.tierIdata.pensionFund = pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.pensionFund;
            npsServices.npsPensionDetails.tierIdata.pensionFundText = pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.pensionFundText;
            npsServices.npsPensionDetails.tierIdata.investmentOption = pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.investmentOption;
            npsServices.npsPensionDetails.tierIdata.assetAllocation = pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.assetAllocation;
            npsServices.npsPensionDetails.tierIdata.assetAllocationText = pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.assetAllocationText;
            npsServices.npsPensionDetails.tierIdata.equity = pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.equity;
            npsServices.npsPensionDetails.tierIdata.equityCode = pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.equityCode;
            npsServices.npsPensionDetails.tierIdata.corporateDebt = pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.corporateDebt;
            npsServices.npsPensionDetails.tierIdata.corporateDebtCode = pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.corporateDebtCode;
            npsServices.npsPensionDetails.tierIdata.governmentBond = pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.governmentBond;
            npsServices.npsPensionDetails.tierIdata.governmentBondCode = pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.governmentBondCode;
            npsServices.npsPensionDetails.tierIdata.alternativeFund = pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.alternativeFund;
            npsServices.npsPensionDetails.tierIdata.alternativeFundCode = pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.alternativeFundCode;

            var requestParams = {
                "npsAccountType": "Tier1",
                "pensionFund": {
                    "nameOfFund": pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.pensionFundText,
                    "fundCode": pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.pensionFund,
                    "investmentType": pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.investmentOption,
                    "assetAllocation": pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.investmentOption.toLowerCase() == 'auto' ? pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.assetAllocationText : '',
                    "assetAllocationCode": pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.investmentOption.toLowerCase() == 'auto' ? pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.assetAllocation : '',
                    "equity": pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.investmentOption.toLowerCase() == 'active' ? pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.equity : '',
                    "equityCode": pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.investmentOption.toLowerCase() == 'active' ? pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.equityCode : '',
                    "corporateDebt": pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.investmentOption.toLowerCase() == 'active' ? pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.corporateDebt : '',
                    "corporateDebtCode": pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.investmentOption.toLowerCase() == 'active' ? pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.corporateDebtCode : '',
                    "governmentBond": pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.investmentOption.toLowerCase() == 'active' ? pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.governmentBond : '',
                    "governmentBondCode": pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.investmentOption.toLowerCase() == 'active' ? pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.governmentBondCode : '',
                    "alternativeFund": pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.investmentOption.toLowerCase() == 'active' ? pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.alternativeFund : '',
                    "alternativeFundCode": pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.investmentOption.toLowerCase() == 'active' ? pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.alternativeFundCode : ''
                }
            };

            if (pensionFundDetailsNPSControllerVM.npsAccountType.toUpperCase() == "TIER1") {

                npsServices.savePensionFundDetails(requestParams).then(function (response) {
                    $state.go("menu.fatcaDetails");

                }, function (error) {
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                });

            } else {

                npsServices.savePensionFundDetails(requestParams).then(function (response) {
                    $state.go("menu.npsPensionFundDetailsTierII");

                }, function (error) {
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                });


                // var requestParams = {
                //     pfmId: pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.pensionFund
                // };

                // npsServices.fetchAssetAllocation(requestParams).then(function (response) {
                //     $state.go("menu.npsPensionFundDetailsTierII");

                // }, function (error) {
                //     utilityService.enableShowErrorMessage();
                //     utilityService.showErrorMessage(error.responseMessage);
                // });
            }
        }

        pensionFundDetailsNPSControllerVM.fetchActiveAssetAllocationData = function () {
            var requestParams = {
                pfmId: pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.pensionFund
            };

            npsServices.fetchAssetAllocation(requestParams).then(function (response) {

                pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.equityCode = response.assetClassETier1;
                pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.corporateDebtCode = response.assetClassCTier1;
                pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.governmentBondCode = response.assetClassGTier1;
                pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.alternativeFundCode = response.assetClassATier1;
                pensionFundDetailsNPSControllerVM.showActive = true;

            }, function (error) {
                pensionFundDetailsNPSControllerVM.showActive = false;
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        pensionFundDetailsNPSControllerVM.npsPFInvestmentOptionChange = function () {
            if (pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.investmentOption.toLowerCase() == 'active') {
                pensionFundDetailsNPSControllerVM.fetchActiveAssetAllocationData();
                pensionFundDetailsNPSControllerVM.assetPercentageChange();
            } else {
                pensionFundDetailsNPSControllerVM.disableNext = false;
            }
        }

        pensionFundDetailsNPSControllerVM.moreDetails = function () {

            npsServices.npsPensionDetails.tierIdata.pensionFund = pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.pensionFund;
            npsServices.npsPensionDetails.tierIdata.pensionFundText = pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.pensionFundText;
            npsServices.npsPensionDetails.tierIdata.investmentOption = pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.investmentOption;
            npsServices.npsPensionDetails.tierIdata.assetAllocation = pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.assetAllocation;
            npsServices.npsPensionDetails.tierIdata.assetAllocationText = pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.assetAllocationText;
            npsServices.npsPensionDetails.tierIdata.equity = pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.equity;
            npsServices.npsPensionDetails.tierIdata.equityCode = pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.equityCode;
            npsServices.npsPensionDetails.tierIdata.corporateDebt = pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.corporateDebt;
            npsServices.npsPensionDetails.tierIdata.corporateDebtCode = pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.corporateDebtCode;
            npsServices.npsPensionDetails.tierIdata.governmentBond = pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.governmentBond;
            npsServices.npsPensionDetails.tierIdata.governmentBondCode = pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.governmentBondCode;
            npsServices.npsPensionDetails.tierIdata.alternativeFund = pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.alternativeFund;
            npsServices.npsPensionDetails.tierIdata.alternativeFundCode = pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.alternativeFundCode;

            $state.go("menu.npsAssetAllocationDetails");
        }

        pensionFundDetailsNPSControllerVM.assetPercentageChange = function () {
            pensionFundDetailsNPSControllerVM.totalPensionPercentage = parseFloat(pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.equity && pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.equity != '.' ? pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.equity : "0") + parseFloat(pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.corporateDebt && pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.corporateDebt != '.' ? pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.corporateDebt : "0") + parseFloat(pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.governmentBond && pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.governmentBond != '.' ? pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.governmentBond : "0") + parseFloat(pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.alternativeFund && pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.alternativeFund != '.' ? pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.alternativeFund : "0");

            if (pensionFundDetailsNPSControllerVM.totalPensionPercentage == 100 || pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.investmentOption.toLowerCase() != 'active') {
                pensionFundDetailsNPSControllerVM.disableNext = false;
            } else {
                pensionFundDetailsNPSControllerVM.disableNext = true;
            }
        }

        pensionFundDetailsNPSControllerVM.selectedPensionFund = function () {

            pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.pensionFundText = utilityService.getTextFromDropdown("pfmId", pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.pensionFund, pensionFundDetailsNPSControllerVM.npsPensionDetails.pensionFundList, "pfmName");

        }

        pensionFundDetailsNPSControllerVM.selectedAssetAllocation = function () {

            pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.assetAllocationText = utilityService.getTextFromDropdown("assetAllocationCode", pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.assetAllocation, pensionFundDetailsNPSControllerVM.npsPensionDetails.assetAllocationList, "assetAllocation");

        }

        pensionFundDetailsNPSControllerVM.calculateEquityPercentage = function () {

            var age = utilityService.getAge(npsServices.applicantData.dateOfBirth);

            if (age <= 50) {
                pensionFundDetailsNPSControllerVM.maxEquityPercentage = "75%";
                pensionFundDetailsNPSControllerVM.maxEquityPercentageValue = "75.0";
            } else if (age == 51) {
                pensionFundDetailsNPSControllerVM.maxEquityPercentage = "72.5%";
                pensionFundDetailsNPSControllerVM.maxEquityPercentageValue = "72.5";
            } else if (age == 52) {
                pensionFundDetailsNPSControllerVM.maxEquityPercentage = "70%";
                pensionFundDetailsNPSControllerVM.maxEquityPercentageValue = "70.0";
            } else if (age == 53) {
                pensionFundDetailsNPSControllerVM.maxEquityPercentage = "67.5%";
                pensionFundDetailsNPSControllerVM.maxEquityPercentageValue = "67.5";
            } else if (age == 54) {
                pensionFundDetailsNPSControllerVM.maxEquityPercentage = "65%";
                pensionFundDetailsNPSControllerVM.maxEquityPercentageValue = "65.0";
            } else if (age == 55) {
                pensionFundDetailsNPSControllerVM.maxEquityPercentage = "62.5%";
                pensionFundDetailsNPSControllerVM.maxEquityPercentageValue = "62.5";
            } else if (age == 56) {
                pensionFundDetailsNPSControllerVM.maxEquityPercentage = "60%";
                pensionFundDetailsNPSControllerVM.maxEquityPercentageValue = "60.0";
            } else if (age == 57) {
                pensionFundDetailsNPSControllerVM.maxEquityPercentage = "57.5%";
                pensionFundDetailsNPSControllerVM.maxEquityPercentageValue = "57.5";
            } else if (age == 58) {
                pensionFundDetailsNPSControllerVM.maxEquityPercentage = "55%";
                pensionFundDetailsNPSControllerVM.maxEquityPercentageValue = "55.0";
            } else if (age == 59) {
                pensionFundDetailsNPSControllerVM.maxEquityPercentage = "52.5%";
                pensionFundDetailsNPSControllerVM.maxEquityPercentageValue = "52.5";
            } else if (age >= 60) {
                pensionFundDetailsNPSControllerVM.maxEquityPercentage = "50%";
                pensionFundDetailsNPSControllerVM.maxEquityPercentageValue = "50.0";
            }
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            pensionFundDetailsNPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            pensionFundDetailsNPSControllerVM.calculateEquityPercentage();
            pensionFundDetailsNPSControllerVM.npsAccountType = npsServices.npsAccountDetails.npsAccountType;
            pensionFundDetailsNPSControllerVM.npsPensionDetails = angular.copy(npsServices.npsPensionDetails);
            if (!pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.pensionFund) {
                pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.pensionFund = "PFM001";
            }
            if (!pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.assetAllocation) {
                pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.assetAllocation = pensionFundDetailsNPSControllerVM.npsPensionDetails.assetAllocationList[1].assetAllocationCode;
            }
            if (!pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.equity) {
                pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.equity = 0;
            }
            if (!pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.corporateDebt) {
                pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.corporateDebt = 0;
            }
            if (!pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.governmentBond) {
                pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.governmentBond = 0;
            }
            if (!pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.alternativeFund) {
                pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.alternativeFund = 0;
            }


            pensionFundDetailsNPSControllerVM.selectedPensionFund();
            if (pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.assetAllocation && pensionFundDetailsNPSControllerVM.npsPensionDetails.tierIdata.assetAllocation != "0") {
                pensionFundDetailsNPSControllerVM.selectedAssetAllocation();
            }
            pensionFundDetailsNPSControllerVM.assetPercentageChange();


        });



        return this;
    }
]);
