'use strict';

angularApp.controller('looksGreatNPSController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    "$filter",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices,
        $filter) {

        var looksGreatNPSControllerVM = this;
        $scope.currentPage = "4";
        $scope.lastPage = "16";
        looksGreatNPSControllerVM.isPanNumMasked = false;
        looksGreatNPSControllerVM.isAadhaarNumMasked = false;


        looksGreatNPSControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        looksGreatNPSControllerVM.sizeInfo = function ($event) {
            npsServices.sizeInfoPopover($event, $scope);
        }

        // looksGreatNPSControllerVM.imgSizeValidation = function () {
        //     var imgBase = npsServices.customer.photo;

        //     var blob = new Blob([imgBase], { type: 'image/jpeg' });

        //     if (blob.size < 54 * 1024) {
        //         looksGreatNPSControllerVM.handleApply();
        //     }
        //     else {
        //         var title = '';
        //         var template = '{{"UPLOAD_IMG_SIZE" | translate}}';
        //         var onTap = 'menu.looksGreatAO';
        //         var buttontext = '<b>' + looksGreatNPSControllerVM.okBtntext + '</b>';
        //         utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
        //     }
        // }

        looksGreatNPSControllerVM.goBack = function () {

            $state.go("menu.npsTakeSelfie");

        }

        looksGreatNPSControllerVM.goNext = function () {

            var newImg = looksGreatNPSControllerVM.croppedImage;
            var baseImg = newImg.split("base64,")[1];
            var requestParams = {
                "documentClass": "LT_AccountOpening_NPS",
                "mimeType": "image/jpg",
                "documentTitle": "Customer Photo",
                "documentData": baseImg,
                "documentType": "Photograph",
                "accountNo": "",
                "documentID": "",
                "commonId": "",
                "id": npsServices.applicantData.custphotoid,
                "confirmFlag": looksGreatNPSControllerVM.applicantData.photoConfirmFlag == true ? "Y" : "N"
            }
            npsServices.uploadDocument(requestParams).then(function (response) {
                npsServices.applicantData.custphotoid = response.data.docRef;
                $state.go("menu.npsParentDetails");
            }, function (error) {
                npsServices.showErrorMessage(error.responseMessage);
            });

            // $state.go("menu.npsParentDetails");
        }

        looksGreatNPSControllerVM.retrievePhotoCall = function () {
            var param = npsServices.applicantData.custphotoid;

            npsServices.retrievePhoto(param).then(function (response) {

                looksGreatNPSControllerVM.croppedImage = "data:image/jpeg;base64," + response.data.documentData;
                npsServices.applicantData.customerPhoto = looksGreatNPSControllerVM.croppedImage;
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }



        $scope.$on('$ionicView.beforeEnter', function () {
            looksGreatNPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            looksGreatNPSControllerVM.disableTitle = false;
            looksGreatNPSControllerVM.croppedImage = "img/client-img.png";

            if (!npsServices.applicantData.customerPhoto) {
                if (!utilityService.isUndefined(npsServices.applicantData.custphotoid)) {
                    looksGreatNPSControllerVM.retrievePhotoCall();
                }
            }
            else {
                looksGreatNPSControllerVM.croppedImage = npsServices.applicantData.customerPhoto;

            }

            looksGreatNPSControllerVM.applicantData.photoConfirmFlag = npsServices.applicantData.photoConfirmFlag;





        });

        return this;
    }
]);
