'use strict';

angularApp.controller('parentsDetailsNPSController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    "$filter",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices,
        $filter) {

        var parentsDetailsNPSControllerVM = this;
        $scope.currentPage = "5";
        $scope.lastPage = "16";


        parentsDetailsNPSControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        parentsDetailsNPSControllerVM.goBack = function () {

            $state.go("menu.npsTakeSelfie");
        }

        parentsDetailsNPSControllerVM.goNext = function () {

            npsServices.applicantData.fatherFirstName = parentsDetailsNPSControllerVM.applicantData.fatherFirstName;
            npsServices.applicantData.fatherMiddleName = parentsDetailsNPSControllerVM.applicantData.fatherMiddleName;
            npsServices.applicantData.fatherLastName = parentsDetailsNPSControllerVM.applicantData.fatherLastName;

            npsServices.npsParentsDetails.motherNamePrintCheckbox = parentsDetailsNPSControllerVM.npsParentsDetails.motherNamePrintCheckbox;

            npsServices.applicantData.motherFirstName = parentsDetailsNPSControllerVM.applicantData.motherFirstName;
            npsServices.applicantData.motherMiddleName = parentsDetailsNPSControllerVM.applicantData.motherMiddleName;
            npsServices.applicantData.motherLastName = parentsDetailsNPSControllerVM.applicantData.motherLastName;

            npsServices.applicantData.maritalStatus = parentsDetailsNPSControllerVM.applicantData.maritalStatus;

            npsServices.applicantData.spouseFirstName = parentsDetailsNPSControllerVM.applicantData.spouseFirstName;
            npsServices.applicantData.spouseMiddleName = parentsDetailsNPSControllerVM.applicantData.spouseMiddleName;
            npsServices.applicantData.spouseLastName = parentsDetailsNPSControllerVM.applicantData.spouseLastName;


            var requestParams = {
                "personalDetails": {
                    "title": npsServices.applicantData.salutationValue,
                    "titleCode": npsServices.applicantData.salutation,
                    "maiodenName": npsServices.applicantData.maidenName,
                    "cityOfBirth": npsServices.applicantData.placeOfBirth,
                    "countryOfBirth": npsServices.applicantData.countryOfBirth,
                    "countryOfBirthValue": npsServices.applicantData.countryOfBirthValue
                },
                "familyDetails": {
                    "motherFirstName": parentsDetailsNPSControllerVM.applicantData.motherFirstName,
                    "motherMiddleName": parentsDetailsNPSControllerVM.applicantData.motherMiddleName,
                    "motherLastName": parentsDetailsNPSControllerVM.applicantData.motherLastName,
                    "motherNamePrintRequired": parentsDetailsNPSControllerVM.npsParentsDetails.motherNamePrintCheckbox == true ? "Y" : "N",
                    "maritalStatus": parentsDetailsNPSControllerVM.applicantData.maritalStatusValue,
                    "maritalStatusCode": parentsDetailsNPSControllerVM.applicantData.maritalStatus,
                    "spouseFirstName": parentsDetailsNPSControllerVM.applicantData.spouseFirstName,
                    "spouseMiddleName": parentsDetailsNPSControllerVM.applicantData.spouseMiddleName,
                    "spouseLastName": parentsDetailsNPSControllerVM.applicantData.spouseLastName,
                    "fatherFirstName": parentsDetailsNPSControllerVM.applicantData.fatherFirstName,
                    "fatherMiddleName": parentsDetailsNPSControllerVM.applicantData.fatherMiddleName,
                    "fatherLastName": parentsDetailsNPSControllerVM.applicantData.fatherLastName
                }
            };
            npsServices.savePersonalAndParentsDetails(requestParams).then(function (response) {
                $state.go("menu.npsAddressDetails");

            }, function (error) {
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(error.responseMessage);
            });


        }

        parentsDetailsNPSControllerVM.selectedMaritalStatus = function () {

            parentsDetailsNPSControllerVM.applicantData.maritalStatusValue = utilityService.getTextFromDropdown("value", parentsDetailsNPSControllerVM.applicantData.maritalStatus, parentsDetailsNPSControllerVM.maritalStatusList, "description");

        }

        parentsDetailsNPSControllerVM.resetMaritalStatus = function () {

            parentsDetailsNPSControllerVM.applicantData.spouseFirstName = "";
            parentsDetailsNPSControllerVM.applicantData.spouseMiddleName = "";
            parentsDetailsNPSControllerVM.applicantData.spouseLastName = "";

        }

        $scope.$on('$ionicView.beforeEnter', function () {
            parentsDetailsNPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            parentsDetailsNPSControllerVM.maritalStatusList = npsServices.npsDropdownData.maritalStatusMaster;
            parentsDetailsNPSControllerVM.applicantData = angular.copy(npsServices.applicantData);
            parentsDetailsNPSControllerVM.npsParentsDetails = angular.copy(npsServices.npsParentsDetails);

            if(parentsDetailsNPSControllerVM.applicantData.maritalStatus){
                parentsDetailsNPSControllerVM.selectedMaritalStatus();
            }

        });

        return this;
    }
]);
