'use strict';

angularApp.controller('personalDetailsNPSController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    "$filter",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices,
        $filter) {

        var personalDetailsNPSControllerVM = this;
        $scope.currentPage = "3";
        $scope.lastPage = "16";
        personalDetailsNPSControllerVM.isPanNumMasked = false;
        personalDetailsNPSControllerVM.isAadhaarNumMasked = false;

        personalDetailsNPSControllerVM.eyesOnFun = function (numForMasked, type) {
            if (type === "pan") {
                personalDetailsNPSControllerVM.isPanNumMasked = false;
                personalDetailsNPSControllerVM.applicantData.panNumber = personalDetailsNPSControllerVM.oldPANValue;
            } else {
                personalDetailsNPSControllerVM.isAadhaarNumMasked = false;
                personalDetailsNPSControllerVM.applicantData.aadhaarNumber = personalDetailsNPSControllerVM.oldAadhaarValue;
            }
        }

        personalDetailsNPSControllerVM.eyesOffFun = function (numForMasked, type) {
            if (type === "pan") {
                personalDetailsNPSControllerVM.isPanNumMasked = true;
                personalDetailsNPSControllerVM.oldPANValue = numForMasked;
                personalDetailsNPSControllerVM.applicantData.panNumber = utilityService.maskData(numForMasked, "front", 4);
            } else {
                personalDetailsNPSControllerVM.isAadhaarNumMasked = true;
                personalDetailsNPSControllerVM.oldAadhaarValue = numForMasked;
                personalDetailsNPSControllerVM.applicantData.aadhaarNumber = utilityService.maskData(numForMasked, "front", 4);
            }
        }

        personalDetailsNPSControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        personalDetailsNPSControllerVM.goBack = function () {

            var requestData = {};

            if (!npsServices.accDetails) {

                npsServices.getAccountList(requestData).then(function (response) {

                    npsServices.accDetails = response.data.accList;
                    $state.go('menu.accountDetailsNPSView');

                }, function (error) {
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                });

            } else {
                $state.go('menu.accountDetailsNPSView');
            }


        }

        personalDetailsNPSControllerVM.goNext = function () {
            npsServices.applicantData.maidenName = personalDetailsNPSControllerVM.applicantData.maidenName;
            npsServices.applicantData.placeOfBirth = personalDetailsNPSControllerVM.applicantData.placeOfBirth;
            npsServices.applicantData.countryOfBirth = personalDetailsNPSControllerVM.applicantData.countryOfBirth;
            npsServices.applicantData.countryOfBirthValue = personalDetailsNPSControllerVM.applicantData.countryOfBirthValue;
            npsServices.applicantData.salutation = personalDetailsNPSControllerVM.applicantData.salutation;
            npsServices.applicantData.salutationValue = personalDetailsNPSControllerVM.applicantData.salutationValue;

            if(npsServices.applicantData.customerPhoto || npsServices.applicantData.custphotoid){
                $state.go('menu.npsLooksGreat');
            }else{
                $state.go("menu.npsTakeSelfie");
            }
        }

        personalDetailsNPSControllerVM.selectedTitle = function () {

            personalDetailsNPSControllerVM.applicantData.salutationValue = utilityService.getTextFromDropdown("value", personalDetailsNPSControllerVM.applicantData.salutation, personalDetailsNPSControllerVM.titleList, "description");

        }

        personalDetailsNPSControllerVM.selectedCountry = function () {
            personalDetailsNPSControllerVM.applicantData.countryOfBirthValue = utilityService.getTextFromDropdown("value", personalDetailsNPSControllerVM.applicantData.countryOfBirth, personalDetailsNPSControllerVM.countryList, "description");
        }


        $scope.$on('$ionicView.beforeEnter', function () {
            personalDetailsNPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            personalDetailsNPSControllerVM.disableTitle = false;
            personalDetailsNPSControllerVM.titleList = angular.copy(npsServices.npsDropdownData.titleMaster);
            personalDetailsNPSControllerVM.countryList = npsServices.npsDropdownData.countryMasters;
            personalDetailsNPSControllerVM.applicantData = angular.copy(npsServices.applicantData);
            personalDetailsNPSControllerVM.eyesOffFun(personalDetailsNPSControllerVM.applicantData.panNumber, 'pan');
            personalDetailsNPSControllerVM.eyesOffFun(personalDetailsNPSControllerVM.applicantData.aadhaarNumber, 'aadhaar');

            if(personalDetailsNPSControllerVM.applicantData.gender.toLowerCase()=="male"){
                if(personalDetailsNPSControllerVM.titleList){
                    personalDetailsNPSControllerVM.titleList.pop();
                    personalDetailsNPSControllerVM.titleList.pop();
                }
            personalDetailsNPSControllerVM.applicantData.salutation = "01";
            }else if(personalDetailsNPSControllerVM.applicantData.gender.toLowerCase()=="female"){
                if(personalDetailsNPSControllerVM.titleList){
                    personalDetailsNPSControllerVM.titleList.shift();
                }
            }

            if (personalDetailsNPSControllerVM.applicantData.salutation) {
                personalDetailsNPSControllerVM.selectedTitle();
            }

        });

        return this;
    }
]);
