'use strict';

angularApp.controller('reviewDetailsNPSController', ["$timeout",
  "$ionicPopup",
  "$state",
  "$scope",
  "utilityService",
  "$ionicHistory",
  "homeScreenService",
  "$ionicViewSwitcher",
  "npsServices",
  "$ionicPopover",
  function ($timeout,
    $ionicPopup,
    $state,
    $scope,
    utilityService,
    $ionicHistory,
    homeScreenService,
    $ionicViewSwitcher,
    npsServices,
    $ionicPopover) {

    var reviewDetailsNPSControllerVM = this;
    $scope.currentPage = "16";
    $scope.lastPage = "16";
    reviewDetailsNPSControllerVM.isPanNumMasked = false;
    reviewDetailsNPSControllerVM.nomineeLabel = "Nominee";
    reviewDetailsNPSControllerVM.countryLabel = "Country";


    reviewDetailsNPSControllerVM.close = function () {
      $ionicViewSwitcher.nextDirection('back');
      $state.go('menu.homeScreen');
    }

    reviewDetailsNPSControllerVM.goBack = function () {
      $state.go("menu.contributionReview");
    }


    reviewDetailsNPSControllerVM.goNext = function () {

      npsServices.applicantData.reviewconsent = reviewDetailsNPSControllerVM.applicantData.reviewconsent;
      npsServices.applicantData.otpflag = reviewDetailsNPSControllerVM.applicantData.otpflag;

      var requestParams = {
        "reviewconsent": reviewDetailsNPSControllerVM.applicantData.reviewconsent == true ? "Y" : "N",
        "otpflag": reviewDetailsNPSControllerVM.applicantData.otpflag == true ? "Y" : "N"
      }

      npsServices.generateOTP(requestParams).then(function (response) {
        $state.go("menu.otpNps");

      }, function (error) {
        utilityService.enableShowErrorMessage();
        utilityService.showErrorMessage(error.responseMessage);
      });


    }

    reviewDetailsNPSControllerVM.edit = function (data) {
      if(reviewDetailsNPSControllerVM.npsFinalSuccessDetails && reviewDetailsNPSControllerVM.npsFinalSuccessDetails.leg){
              console.log('edit disabled');
      }else{
      switch (data) {

        case 'accountDetails':
          var requestData = {}; 

          if(!npsServices.accDetails){

            npsServices.getAccountList(requestData).then(function (response) {
                
                npsServices.accDetails = response.data.accList;    
                $state.go("menu.accountDetailsNPSView");

            }, function (error) {
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(error.responseMessage);
            });

          }else{
                $state.go("menu.accountDetailsNPSView");
          }

          break;

        case 'personalDetails':
          $state.go('menu.npsPersonalDetails');
          break;

        case 'parentsDetails':
          $state.go('menu.npsParentDetails');
          break;

        case 'addressDetails':
          $state.go('menu.npsAddressDetails');
          break;

        case 'contactDetails':
          $state.go('menu.npsContactDetails');
          break;

        case 'otherDetails':
          $state.go('menu.npsOtherDetails');
          break;

        case 'bankDetailS':
          $state.go('menu.npsBankDetails');
          break;

        case 'nominationDetails':
          $state.go('menu.npsNominationDetails');
          break;

        case 'npsNominationDetailsTierII':
          $state.go('menu.npsNominationDetailsTierII');
          break;

        case 'pensionFund':
          if (!npsServices.npsPensionDetails.pensionFundList[0] || !npsServices.npsPensionDetails.assetAllocationList[0]) {

            npsServices.fetchPensionFundList().then(function (response) {
              npsServices.npsPensionDetails.pensionFundList = response.pensionFundList;
              npsServices.npsPensionDetails.assetAllocationList = response.autoAssetAllocationList;
              $state.go("menu.npsPensionFundDetails");

            }, function (error) {
              utilityService.enableShowErrorMessage();
              utilityService.showErrorMessage(error.responseMessage);
            });

          } else {
            $state.go("menu.npsPensionFundDetails");
          }

          break;

        case 'pensionFundTier2':
          if (!npsServices.npsPensionDetails.pensionFundList[0] || !npsServices.npsPensionDetails.assetAllocationList[0]) {

            npsServices.fetchPensionFundList().then(function (response) {
              npsServices.npsPensionDetails.pensionFundList = response.pensionFundList;
              npsServices.npsPensionDetails.assetAllocationList = response.autoAssetAllocationList;
              $state.go('menu.npsPensionFundDetailsTierII');

            }, function (error) {
              utilityService.enableShowErrorMessage();
              utilityService.showErrorMessage(error.responseMessage);
            });

          } else {
            $state.go('menu.npsPensionFundDetailsTierII');
          }

          break;

        case 'fatcaDetails':
          $state.go('menu.fatcaDetails');
          break;

        case 'contributionDetails':
          $state.go('menu.contributionDetails');
          break;

      }
     }
    }


    reviewDetailsNPSControllerVM.toggleGroup = function (group) {
      if (reviewDetailsNPSControllerVM.isGroupShown(group)) {
        reviewDetailsNPSControllerVM.shownGroup = null;
      } else {
        reviewDetailsNPSControllerVM.shownGroup = group;
      }
    };
    reviewDetailsNPSControllerVM.isGroupShown = function (group) {
      return reviewDetailsNPSControllerVM.shownGroup === group;
    };

    reviewDetailsNPSControllerVM.eyesOnFun = function (numForMasked, type) {
      if (type === "pan") {
        reviewDetailsNPSControllerVM.isPanNumMasked = false;
        reviewDetailsNPSControllerVM.applicantData.panNumber = reviewDetailsNPSControllerVM.oldPANValue;
      } else {
        reviewDetailsNPSControllerVM.isAadhaarNumMasked = false;
        reviewDetailsNPSControllerVM.applicantData.aadhaarNumber = reviewDetailsNPSControllerVM.oldAadhaarValue;
      }
    }

    reviewDetailsNPSControllerVM.eyesOffFun = function (numForMasked, type) {
      if (type === "pan") {
        reviewDetailsNPSControllerVM.isPanNumMasked = true;
        reviewDetailsNPSControllerVM.oldPANValue = numForMasked;
        reviewDetailsNPSControllerVM.applicantData.panNumber = utilityService.maskData(numForMasked, "front", 4);
      } else {
        reviewDetailsNPSControllerVM.isAadhaarNumMasked = true;
        reviewDetailsNPSControllerVM.oldAadhaarValue = numForMasked;
        reviewDetailsNPSControllerVM.applicantData.aadhaarNumber = utilityService.maskData(numForMasked, "front", 4);
      }
    }

    reviewDetailsNPSControllerVM.calculateTotalCharges = function () {
      reviewDetailsNPSControllerVM.charges = parseFloat(reviewDetailsNPSControllerVM.npsContributionReviewDetails.charges ? reviewDetailsNPSControllerVM.npsContributionReviewDetails.charges : 0) + parseFloat(reviewDetailsNPSControllerVM.npsContributionReviewDetails.registrationCharges ? reviewDetailsNPSControllerVM.npsContributionReviewDetails.registrationCharges : 0);
    }

    reviewDetailsNPSControllerVM.npsPensionTier1Total = function () {
      return parseFloat(reviewDetailsNPSControllerVM.npsPensionDetails.tierIdata.equity && reviewDetailsNPSControllerVM.npsPensionDetails.tierIdata.equity != '.' ? reviewDetailsNPSControllerVM.npsPensionDetails.tierIdata.equity : "0") + parseFloat(reviewDetailsNPSControllerVM.npsPensionDetails.tierIdata.corporateDebt && reviewDetailsNPSControllerVM.npsPensionDetails.tierIdata.corporateDebt != '.' ? reviewDetailsNPSControllerVM.npsPensionDetails.tierIdata.corporateDebt : "0") + parseFloat(reviewDetailsNPSControllerVM.npsPensionDetails.tierIdata.governmentBond && reviewDetailsNPSControllerVM.npsPensionDetails.tierIdata.governmentBond != '.' ? reviewDetailsNPSControllerVM.npsPensionDetails.tierIdata.governmentBond : "0") + parseFloat(reviewDetailsNPSControllerVM.npsPensionDetails.tierIdata.alternativeFund && reviewDetailsNPSControllerVM.npsPensionDetails.tierIdata.alternativeFund != '.' ? reviewDetailsNPSControllerVM.npsPensionDetails.tierIdata.alternativeFund : "0");
    }

    reviewDetailsNPSControllerVM.npsPensionTier2Total = function () {
      return parseFloat(reviewDetailsNPSControllerVM.npsPensionDetails.tierIIdata.equity && reviewDetailsNPSControllerVM.npsPensionDetails.tierIIdata.equity != '.' ? reviewDetailsNPSControllerVM.npsPensionDetails.tierIIdata.equity : "0") + parseFloat(reviewDetailsNPSControllerVM.npsPensionDetails.tierIIdata.corporateDebt && reviewDetailsNPSControllerVM.npsPensionDetails.tierIIdata.corporateDebt != '.' ? reviewDetailsNPSControllerVM.npsPensionDetails.tierIIdata.corporateDebt : "0") + parseFloat(reviewDetailsNPSControllerVM.npsPensionDetails.tierIIdata.governmentBond && reviewDetailsNPSControllerVM.npsPensionDetails.tierIIdata.governmentBond != '.' ? reviewDetailsNPSControllerVM.npsPensionDetails.tierIIdata.governmentBond : "0");
    }




    $scope.$on('$ionicView.beforeEnter', function () {
      
      reviewDetailsNPSControllerVM.npsAccountDetails = angular.copy(npsServices.npsAccountDetails);
      reviewDetailsNPSControllerVM.applicantData = angular.copy(npsServices.applicantData);
      reviewDetailsNPSControllerVM.npsOtherDetails = angular.copy(npsServices.npsOtherDetails);
      reviewDetailsNPSControllerVM.npsBankDetails = angular.copy(npsServices.npsBankDetails);
      reviewDetailsNPSControllerVM.npsFinalSuccessDetails = angular.copy(npsServices.npsFinalSuccessDetails);
      if (npsServices.npsNominationDetails.nominees[0]) {
        reviewDetailsNPSControllerVM.nominees = npsServices.npsNominationDetails.nominees;
      }
      reviewDetailsNPSControllerVM.sameNomineeForTierII = npsServices.npsNominationDetails.sameNomineeForTierII;

      if (npsServices.npsNominationDetailsTierII.nominees[0]) {
        reviewDetailsNPSControllerVM.nomineesTierII = npsServices.npsNominationDetailsTierII.nominees;
      }

      reviewDetailsNPSControllerVM.npsPensionDetails = angular.copy(npsServices.npsPensionDetails);
      reviewDetailsNPSControllerVM.npsFatcaDetails = angular.copy(npsServices.npsFatcaDetails);
      if (npsServices.npsFatcaDetails.residentCountries[0]) {
        reviewDetailsNPSControllerVM.residentCountries = npsServices.npsFatcaDetails.residentCountries;

      }

      if(npsServices.npsFatcaDetails.residentCountries.length > 0){
        for(var i=0; i < npsServices.npsFatcaDetails.residentCountries.length; i++){
          if(npsServices.npsFatcaDetails.residentCountries[i].validTill == undefined || npsServices.npsFatcaDetails.residentCountries[i].validTill == null || npsServices.npsFatcaDetails.residentCountries[i].validTill == ""){
            reviewDetailsNPSControllerVM.residentCountries[i].validTill = "-"
          }
        }
      }

      reviewDetailsNPSControllerVM.npsContributionDetails = angular.copy(npsServices.npsContributionDetails);
      reviewDetailsNPSControllerVM.npsContributionReviewDetails = angular.copy(npsServices.npsContributionReviewDetails);
      reviewDetailsNPSControllerVM.npsFinalSuccessDetails = angular.copy(npsServices.npsFinalSuccessDetails);

      reviewDetailsNPSControllerVM.calculateTotalCharges();
      reviewDetailsNPSControllerVM.eyesOffFun(reviewDetailsNPSControllerVM.applicantData.panNumber, 'pan');

    });


    return this;
  }
]);
