'use strict';

angularApp.controller('termsConditionsNPSController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "npsServices",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        npsServices) {

        var termsConditionsNPSControllerVM = this;
        termsConditionsNPSControllerVM.disableCheckbox = true;

        termsConditionsNPSControllerVM.goBack = function(){
            $state.go("menu.landingNPSView");
        }

        termsConditionsNPSControllerVM.agree = function(){

            npsServices.npsTermsAndCondition.tncFlag = termsConditionsNPSControllerVM.tncFlag;

            var requestData = {}; 

            if(!npsServices.accDetails){

            npsServices.getAccountList(requestData).then(function (response) {
                
                npsServices.accDetails = response.data.accList;    
                $state.go("menu.accountDetailsNPSView");

            }, function (error) {
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(error.responseMessage);
            });

            }else{
                $state.go("menu.accountDetailsNPSView");
            }

        }

        termsConditionsNPSControllerVM.checkScrollOnLoad = function(){
            var tc = document.getElementById("tcId").offsetHeight;
            var tcContent = document.getElementById("tcContent").offsetHeight;
            if(tcContent <= tc){
                termsConditionsNPSControllerVM.disableCheckbox = false;
                var childNodes = document.getElementById('TNC_CHK').removeAttribute("disabled");
            }
        }

        termsConditionsNPSControllerVM.checkScroll = function() {
            var currentTop = $ionicScrollDelegate.$getByHandle('scroller').getScrollPosition().top;
            var maxTop = $ionicScrollDelegate.$getByHandle('scroller').getScrollView().__maxScrollTop;
            if (currentTop >= maxTop) {
                termsConditionsNPSControllerVM.disableCheckbox = false;
                var childNodes = document.getElementById('TNC_CHK').removeAttribute("disabled");
            }
        }


        $scope.$on('$ionicView.beforeEnter', function () {
            termsConditionsNPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            termsConditionsNPSControllerVM.npsTnc = npsServices.NPSDetails.npsTnc;
            if(npsServices.npsTermsAndCondition.tncFlag){
                termsConditionsNPSControllerVM.tncFlag = npsServices.npsTermsAndCondition.tncFlag;
            }
            $timeout(function() {
                termsConditionsNPSControllerVM.checkScrollOnLoad();
            });
        });


        return this;
    }
]);
