'use strict';

angularApp.controller('ompOffersController', ["$timeout",
    "$state",
    "$scope",
    "$rootScope",
    "utilityService",
    "$ionicPopup",
    "ompOffersService",
	"loggedInUserService",
	"constantConfig",
	"cryptoService",
	"encryptionService",
    "AdapterUtils",
    "homeScreenService",
    function ($timeout,
        $state,
        $scope,
        $rootScope,
        utilityService,
        $ionicPopup,
        ompOffersService,
        loggedInUserService,
        constantConfig,
        cryptoService,
        encryptionService,
        AdapterUtils,
        homeScreenService) {

        var ompOffersControllerVm = this;
        $rootScope.isInUserLogin = false;
        ompOffersControllerVm.keystoreValue = loggedInUserService.keystoreValue;
        $scope.err = '';
        var db = null;
        var ompOffersData=[];
        if (utilityService.isAndroidPlatform()) {
		db = window.sqlitePlugin.openDatabase({
											  name: 'my.db',
											  location:'default',
											  });
		} else {
		db = window.sqlitePlugin.openDatabase({name: 'my.db', iosDatabaseLocation: 'Library'});
	     }

        function connectServer() {
            try {
                var payload = {
                    "data": cryptoService.encryptRSAWithPublicKey(encryptionService.iv + "^" + encryptionService.passphrase + "^" + encryptionService.salt, cryptoService.rsaPublicKey),
                    "src": ompOffersControllerVm.keystoreValue != "" ? cryptoService.encryptRSAWithPublicKey(ompOffersControllerVm.keystoreValue, cryptoService.rsaPublicKey) : "",
                };
                utilityService.showSpinner();
                var resourceRequest = new WLResourceRequest("adapters/CustomSessionAdapter/saveCustomInformation", WLResourceRequest.POST, { timeout: 15000 });
                resourceRequest.send(payload).then(function (response) {
                    utilityService.lastTimeStamp = new Date();
                    response.responseText = utilityService.isJSON(response.responseText) ? JSON.parse(response.responseText) : JSON.parse(encryptionService.getAES256DecryptedData(response.responseText));
                    if (response.responseText.responseCode == '0000') {
                        AdapterUtils.secretData = response.responseText.data.key;
                        loggedInUserService.keyId = response.responseText.data.keyId;
                        loggedInUserService.deviceIdForMpin = response.responseText.data.deviceId;
                        loggedInUserService.upiPermissionKey = response.responseText.data.upiPermissionVal;
                        loggedInUserService.billDeskUrl = response.responseText.data.billDeskUrl;
                        loggedInUserService.sbiCollectUrl = response.responseText.data.sbiCollectUrl;
                        utilityService.getUPIPermissions(loggedInUserService.upiPermissionKey);
                        loggedInUserService.isServerConnected = true;
                        utilityService.hideSpinner();
                        ompOffersControllerVm.deleteExpiredOffersFromDB();
                    } else if (response.responseText.responseCode == '0001') {
                        $scope.err = response.responseText.responseCode + " : " + constantConfig.adapter.CANNOT_PROCESS_NOW;
                        loggedInUserService.isServerConnected = false;
                        utilityService.hideSpinner();
                        utilityService.showErrorMessage($scope.err);
                        return;
                    } else if (response.responseText.responseCode == '0002') {
                        $scope.err = response.responseText.responseCode + " : " + constantConfig.adapter.CANNOT_PROCESS_NOW;
                        loggedInUserService.isServerConnected = false;
                        utilityService.hideSpinner();
                        utilityService.showErrorMessage($scope.err);
                        return;
                    } else if (response.responseText.responseCode == '0003' || response.responseText.responseCode == '0004') {
                        $scope.err = response.responseText.responseCode + " : " + response.responseText.responseMessage;
                        loggedInUserService.isServerConnected = false;
                        utilityService.hideSpinner();
                        utilityService.showErrorMessage($scope.err);
                        return;
                    }
                }, function (error) {
                    if (error.errorCode == 'APPLICATION_DOES_NOT_EXIST') {
                        $scope.err = error;
                        utilityService.hideSpinner();
                        utilityService.showUpgradeMessage($scope.err);
                    } else {
                        $scope.err = utilityService.getServerExceptionMessage(error);
                        utilityService.hideSpinner();
                        utilityService.showErrorMessage($scope.err);
                    }
                    loggedInUserService.isServerConnected = false;
                });
            } catch (err) {
                $scope.err = constantConfig.adapter.SOMETHING_WENT_WRONG;
                loggedInUserService.isServerConnected = false;
                utilityService.hideSpinner();
                utilityService.showErrorMessage($scope.err);
            }
        }

        function ordinal_suffix_of(i) {
            var j = i % 10,
                k = i % 100;
            if (j == 1 && k != 11) {
                return i + "st";
            }
            if (j == 2 && k != 12) {
                return i + "nd";
            }
            if (j == 3 && k != 13) {
                return i + "rd";
            }
            return i + "th";
        }

        ompOffersControllerVm.formatDate=function(date) {
            var d = new Date(date),
                month = '' + (d.getMonth() + 1),
                day = '' + d.getDate(),
                year = d.getFullYear();
            if (month.length < 2) month = '0' + month;
            if (day.length < 2) day = '0' + day;
            return [year, month, day].join('-');
        };

        ompOffersControllerVm.goNext = function (offerData) {
                ompOffersControllerVm.disclaimer(offerData);
          };

          ompOffersControllerVm.disclaimer = function (offerData) {
              ompOffersControllerVm.selectedOffer=offerData;
              ompOffersService.offerData=offerData;
             var validTill=ompOffersControllerVm.selectedOffer.expiryDate;
             var validTillNew=validTill.split(" ");
             var newday="";
              newday=ordinal_suffix_of(validTillNew[0]);
             var newFormattedDate=newday.concat(" "+validTillNew[1]);
             ompOffersControllerVm.selectedOffer.expiryDateToShow=newFormattedDate;
            
          ompOffersControllerVm.myPopup = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',
                templateUrl: "pages/ompOffers/disclaimerPopup.html",
                scope: $scope
            });
        };

        ompOffersControllerVm.agree = function () {
            ompOffersControllerVm.myPopup.close();
            ompOffersService.fromOfferPage=true;
            ompOffersService.redirectURL= ompOffersService.offerData.redirectUrl;
             var categoryCode=ompOffersService.offerData.categoryCode;
            var categoryTitle=ompOffersService.offerData.categoryTitle;
            if(categoryTitle != " "){
                 homeScreenService.storeSelected=categoryTitle;
            }
            if(categoryCode != " "){
                homeScreenService.categoryCode=categoryCode;
            }
            $state.go('menu.userLogin');
        };

        $scope.$on('$ionicView.beforeEnter', function () {
            navigator.splashscreen.hide();
            if(loggedInUserService.isServerConnected==true) {
                ompOffersControllerVm.deleteExpiredOffersFromDB();
            } else {
                connectServer();
            }
        });

        ompOffersControllerVm.getCombinedNotification=function(){
            var newompCommonData=[];
            newompCommonData=ompOffersData.concat(ompOffersControllerVm.commonData);
            ompOffersData=newompCommonData;
            ompOffersControllerVm.ompOffersArray=ompOffersData;
         for(var j=0;j<ompOffersControllerVm.ompOffersArray.length;j++){
           var dateFromDB=ompOffersControllerVm.ompOffersArray[j].expiryDate;
           var dateToFormat=new Date(dateFromDB);
           var day=dateToFormat.getDate();
           var monthNames = ["January", "February", "March", "April", "May", "June",
           "July", "August", "September", "October", "November", "December"
         ];
           var month=monthNames[dateToFormat.getMonth()];
           var finalDate=day+" "+month;
           ompOffersControllerVm.ompOffersArray[j].expiryDate=finalDate;
        }
        if(ompOffersService.isOfferExpired){
            ompOffersControllerVm.myPopupExpired = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',
                templateUrl: "pages/ompOffers/disclaimerPopupExpired.html",
                scope: $scope
            });
        }
    };
        ompOffersControllerVm.getCommonPush=function(){
             utilityService.showSpinner();
            var obj = {
          
            };
            ompOffersService.getCommonPush(obj).then(function (data) {
               utilityService.hideSpinner();
            ompOffersControllerVm.commonData=data;
              utilityService.showSpinner();
            db.transaction(function (tx){
                tx.executeSql('SELECT headerTxt, logoUrl,headerDetails,expiryDate,redirectUrl,tnc,nid,buttonTxt,promoCode,publishDate,categoryCode,categoryTitle FROM OfferTable ORDER BY datetime(publishDate) DESC',[],function(tx,results){
                    utilityService.hideSpinner();
                    var len = results.rows.length;     
                 if(len>0){
                     for (var i = 0; i < len; i++){
                         ompOffersData.push(results.rows.item(i));
                     }
                 }
                 ompOffersControllerVm.getCombinedNotification();
             }, function(error) {
                     utilityService.hideSpinner();
                     ompOffersControllerVm.getCombinedNotification();
                   });
           });
        }, function (error) {
             utilityService.hideSpinner();
            utilityService.showErrorMessage(error.responseMessage);
        });  
        };
        ompOffersControllerVm.deleteExpiredOffersFromDB=function(){
            var currentDate=ompOffersControllerVm.formatDate(new Date());
            db.transaction(function (tx){
                tx.executeSql('DELETE FROM OfferTable WHERE expiryDate < ?',[currentDate],function(tx,results){
                    ompOffersControllerVm.getCommonPush();
             }, function(error) {
                ompOffersControllerVm.getCommonPush();
                   });
           });
        };
        ompOffersControllerVm.cancel=function(){
            ompOffersService.notificationRecieved =false;
            ompOffersService.fromPush=false;
                $state.go('menu.userLogin');
        };
          ompOffersControllerVm.skip=function(){
            ompOffersService.notificationRecieved =false;
            ompOffersService.fromPush=false;
              ompOffersControllerVm.myPopup.close();
        };
        ompOffersControllerVm.expiredOffer=function(){
            ompOffersService.notificationRecieved =false;
            ompOffersService.fromPush=false;
            ompOffersService.isOfferExpired=false;
            ompOffersControllerVm.myPopupExpired.close();
      };
        return this;
    }
]);
