'use strict';

angularApp.controller('pendingRequestInstaController', ["$timeout",
    "$state",
    "$location",
    "$scope",
    "$rootScope",
    "customerInfoService",
    "emaillDetailsService",
    "utilityService",
    "$ionicPopup",
    "pendingRequestService",
    "instaHomeService",
    "getAccountDetailsService",
    function ($timeout,
        $state,
        $location,
        $scope,
        $rootScope,
        customerInfoService,
        emaillDetailsService,
        utilityService,
        $ionicPopup,
        pendingRequestService,
        instaHomeService,
        getAccountDetailsService) {

        //functions, variables that can be accessed from the HTML template
        var pendingRequestInstaVm = this;
            
        function initPage() {
            pendingRequestInstaVm.disableconfirm = true;
            pendingRequestInstaVm.availod = true;
            pendingRequestInstaVm.closeDetails = [];
            pendingRequestInstaVm.nightMode = false;
            pendingRequestInstaVm.showDateDiv = true;
            pendingRequestInstaVm.indexId = 0;

            pendingRequestInstaVm.isMaskPan = true;
        };

        pendingRequestInstaVm.goToAO = function () {
            $state.go('menu.innerPage');
        }

        pendingRequestInstaVm.interestRateFunc = function () {
            var template =  '<div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter">1% above 1 year MCLR, current effective rate '+pendingRequestInstaVm.interestRateVal+'% p.a. Interest rate, subject to interest rate reset at the end of every year from the date of first disbursement on the basis of prevailing 1 year MCLR as on the date of reset.</div></div>';
            $ionicPopup.show({
                title: '',
                template: template,
                scope: $scope,
                cssClass: 'my-custom-popup',
                buttons: [{
                    text: 'OK',
                    type: 'button-assertive',
                    onTap: function () {
                        $state.go('menu.pendingRequestInsta');
                    }
                }],
            });
        }

        pendingRequestInstaVm.loanLimitFunc = function () {
            var template = "";
            if(pendingRequestInstaVm.feesVal > 0){
                template =  '<div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter">A flat Processing Fee of Rs.'+pendingRequestInstaVm.feesVal+' plus applicable Service Tax will be levied under the product. Processing fee will be deducted from the loan amount before disbursement.</div></div>';
            }else{
                template =  '<div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter">A flat Processing Fee of Rs.'+pendingRequestInstaVm.feesVal+' (Processing fee is waived as an introductory offer) will be levied under the product. Processing fee will be deducted from the loan amount before disbursement.</div></div>';
            }
            $ionicPopup.show({
                title: '',
                template: template,
                scope: $scope,
                cssClass: 'my-custom-popup',
                buttons: [{
                    text: 'OK',
                    type: 'button-assertive',
                    onTap: function () {
                        $state.go('menu.pendingRequestInsta');
                    }
                }],
            });
        }

        pendingRequestInstaVm.closePopup = function () {
            pendingRequestInstaVm.closeTnC.close();
            utilityService.hideSpinner();
        }

        pendingRequestInstaVm.termconditionPopUp = function (TnCDetails) {
            var title = "Terms & Conditions";
            var buttontext = "OK";
            var detail = TnCDetails;
            instaHomeService.showTnCAlertModal(title, detail, buttontext,function(){});
        }

        pendingRequestInstaVm.unmaskData = function(idType) {
            var request = {
                "type": idType,
                "keyType": "instaCreateAccountNumber",
                "loanType": "IHL"
            }
            if (idType == 'accountno') {
                instaHomeService.getUnmaskData(request).then(function(data) {
                    if (idType == 'accountno') {
                        pendingRequestInstaVm.isMaskPan = false;
                        pendingRequestInstaVm.accountNumber = data;
                    }
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else {
                if (idType == 'naccountno') {
                    pendingRequestInstaVm.isMaskPan = true;
                    pendingRequestInstaVm.accountNumber = instaHomeService.customer.accountno;
                }
            }
        }

        pendingRequestInstaVm.goToAO = function() {
            $state.go('menu.pendingRequest');
        }

        //public functions end
        pendingRequestInstaVm.termcondition = function () {
            
                var obj = {
                    "type" : "instaTC"
                }
                instaHomeService.fetchRtermcondition(obj).then(function (data) {
                    if (!utilityService.isUndefined(data)) {
                        data = data.replace("FIELD_1}}", '&#8377;&nbsp;' + pendingRequestInstaVm.installmentVal);
                            data = data.replace("FIELD_2}}", pendingRequestInstaVm.emiDateVal);
                            if(pendingRequestInstaVm.feesVal > 0)
                            {
                                data = data.replace("FIELD_3}}", pendingRequestInstaVm.feesVal);
                            }
                            else{
                                data = data.replace("FIELD_3}} plus GST", pendingRequestInstaVm.feesVal + ' (Processing fee is waived as an introductory offer)');
                            }
                            
                            data = data.replace("FIELD_4}}", pendingRequestInstaVm.mclr + '%');
                            data = data.replace("FIELD_5}}", pendingRequestInstaVm.interestRateVal + '%');
                        instaHomeService.normalFDTnC = data;
                        pendingRequestInstaVm.termconditionPopUp(instaHomeService.normalFDTnC);
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            
        }

        pendingRequestInstaVm.confirmCreate = function () {
            pendingRequestService.instaUpdateConsent().then(function (data) {
                // console.log("requestOtp",data)
                var template =  '<div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter">Thanks for providing consent for Insta Home Loan Top up for Home loan A/c '+pendingRequestInstaVm.loanAccountNumber+'.<br> The process has been initiated.</div></div>';
                $ionicPopup.show({
                    title: '',
                    template: template,
                    scope: $scope,
                    cssClass: 'my-custom-popup',
                    buttons: [{
                        text: 'OK',
                        type: 'button-assertive',
                        onTap: function () {
                            getAccountDetailsService.accountOverviewData = "";
                            $state.go('menu.accountOverviewMyBalance');
                        }
                    }],
                });
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
            
        }

        pendingRequestInstaVm.backFunc = function () {
            $state.go('menu.instaDeposit');
        }

        pendingRequestInstaVm.getCBValue = function (isChecked) {
            if (isChecked === true) {
                pendingRequestInstaVm.disableconfirm = false;
            } else {
                pendingRequestInstaVm.disableconfirm = true;
            }
        }

        pendingRequestInstaVm.getPreFilledData = function () {
            console.log("pendingRequestService.getRequestDetailData",pendingRequestService.getRequestDetailData)
            pendingRequestInstaVm.loanAmountVal = pendingRequestService.getRequestDetailData.disbursedAmount;
            pendingRequestInstaVm.durationVal = pendingRequestService.getRequestDetailData.loanDuration;
            //pendingRequestInstaVm.installmentVal = pendingRequestService.getRequestDetailData.emi;
            var exponent = pendingRequestService.getRequestDetailData.loanDuration;
            var rateOfInterest = pendingRequestService.getRequestDetailData.intRate;
            var r = ((rateOfInterest/100.0)/12.0);
            var exponentValue = Math.pow(1+r, exponent);
            pendingRequestInstaVm.installmentVal = Math.round((pendingRequestService.getRequestDetailData.disbursedAmount *(r*exponentValue)/(exponentValue-1)).toFixed(2));
            pendingRequestInstaVm.accountNumber = pendingRequestService.getRequestDetailData.disbursementAccountNumber;
            pendingRequestInstaVm.loanAccountNumber = pendingRequestService.getRequestDetailData.accountNumber;
            pendingRequestInstaVm.emiDateVal = pendingRequestService.getRequestDetailData.dateOfEmi;
            pendingRequestInstaVm.interestRateVal = pendingRequestService.getRequestDetailData.intRate;
            pendingRequestInstaVm.feesVal = pendingRequestService.getRequestDetailData.processingFee;
            pendingRequestInstaVm.mclr = pendingRequestService.getRequestDetailData.mclr;
        }

        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        $scope.$on('$ionicView.beforeEnter', function () {
            pendingRequestInstaVm.getPreFilledData();
        });

        return this;
    }
]);
