'use strict';

angularApp.controller('personalLoanController', [
    "$state",
    "$scope",
    "utilityService",
    "$ionicPopup",
    "$ionicPopover",
    "personalLoanService",
    "$ionicHistory",
    "$rootScope",
    "$filter",
    function ($state,
        $scope,
        utilityService,
        $ionicPopup,
        $ionicPopover,
        personalLoanService,
        $ionicHistory,
        $rootScope,
        $filter) {

        var personalLoanVm = this;

        personalLoanVm.showAmountError = false;
        personalLoanVm.showDurationError = false;
        personalLoanVm.disableNext = false;
        personalLoanVm.maxEmiError = false;
        if(personalLoanService.categoryType == "KAVACH"){
            $scope.isKavach = true;
        }else{
            $scope.isKavach = false; 
        }

        personalLoanVm.isCOVIDPAPL = false;

        $rootScope.currentPage = 1;
        $rootScope.lastPage = 4;

        personalLoanVm.goBack = function(){
            $ionicHistory.goBack(-1);
        };

        personalLoanVm.goToNext = function(){
            personalLoanService.accountNumber = personalLoanVm.accountNumber;
            personalLoanService.loanAmount = $scope.loanAmountSlider.value;
            personalLoanService.duration = $scope.loanDurSlider.value;
            personalLoanService.emiAmount = personalLoanVm.emi;
            $state.go('menu.emiPayDate');

        };

        personalLoanVm.openInfo = function ($event) {
            $ionicPopover.fromTemplateUrl('pages/personalLoan/personalLoan/popover.html', {
                scope: $scope
            }).then(function (popover) {
                $scope.popover = popover;
                $scope.popover.show($event);
            });


        };

        personalLoanVm.inputValidate = function($event){
            if ($scope.loanAmountSlider.value > $scope.loanAmountSlider.options.ceil)
                $event.preventDefault();
        }
        personalLoanVm.validateAmount = function() {
            if($scope.loanAmountSlider.value < $scope.loanAmountSlider.options.floor){
                personalLoanVm.showAmountError = true;
                personalLoanVm.showAmountErrorMsg = "Please Enter Valid Amount";
                personalLoanVm.disableNextBtn();
            } else if($scope.loanAmountSlider.value > $scope.loanAmountSlider.options.ceil){
                personalLoanVm.showAmountError = true;
                personalLoanVm.showAmountErrorMsg = "Please Enter Valid Amount";
                personalLoanVm.disableNextBtn();
            } else{
                personalLoanVm.showAmountErrorMsg = "";
                personalLoanVm.disableNextBtn();
            }

            if(personalLoanService.product && personalLoanService.product === "64514034"){
                personalLoanVm.processingFee = personalLoanService.setConfigValues(personalLoanService.configDetails,$scope.loanAmountSlider.value).processingFee;
            }
           else if (personalLoanService.categoryType == "KAVACH" ){
                if(parseInt(personalLoanService.processingFee) <= 0){
                    personalLoanVm.processingFee = 'NIL';
                }else{
                    personalLoanVm.processingFee = personalLoanService.processingFee;
                }
           
        }else{
            personalLoanVm.processingFee = personalLoanService.processingFee;
        }
        };

        personalLoanVm.validateDuration = function() {
            if($scope.loanDurSlider.value < $scope.loanDurSlider.options.floor){
                personalLoanVm.showDurationError = true;
                personalLoanVm.showDurationErrorMsg = "Please Enter Valid Duration";
                personalLoanVm.disableNextBtn();
            } else if ($scope.loanDurSlider.value > $scope.loanDurSlider.options.ceil) {
                personalLoanVm.showDurationError = true;
                personalLoanVm.showDurationErrorMsg = "Please Enter Valid Duration";
                personalLoanVm.disableNextBtn();
            } else {
                personalLoanVm.showDurationErrorMsg = "";
                personalLoanVm.disableNextBtn();
            }
        };



        personalLoanVm.disableNextBtn = function () {
            if (personalLoanVm.showAmountError || personalLoanVm.showDurationError || personalLoanVm.maxEmiError || !personalLoanService.maxDuration || !personalLoanService.minBestOffer || !personalLoanService.personalLoanData.palAmount || !personalLoanService.minDuration || $scope.loanAmountSlider.value == 0)
                personalLoanVm.disableNext = true;
            else
                personalLoanVm.disableNext = false;



        };
        personalLoanVm.ok = function(){
            personalLoanVm.myPopup.close();
        };
        personalLoanVm.emicalculation = function () {
            var r = personalLoanVm.intRate / 1200;
            var n = $scope.loanDurSlider.value;
            var p = $scope.loanAmountSlider.value;

            if(personalLoanService.product && personalLoanService.product === "64514034"){
                var m = personalLoanService.configDetails.monthPeriod;
                var f = personalLoanService.configDetails.factor;
                var val = Math.ceil((p * r * (Math.pow((1 + r), m)) * (Math.pow((1 + r), (n - m)))) / (Math.pow((1 + r), (n - m)) - 1));
                personalLoanVm.emi = Math.ceil(val + f * p / 100000);
            }else if( personalLoanService.categoryType == "KAVACH"){
                var m = personalLoanService.configDetails.monthPeriod;
                personalLoanVm.emi =  personalLoanService.kavachEMICalculation(p, personalLoanVm.intRate, n, m)        // Math.ceil(val + f * p / 100000);
            }
            else {
                personalLoanVm.emi = Math.ceil(p * (r * (Math.pow((1 + r), n)) / (Math.pow((1 + r), n) - 1)));
            }

            if (personalLoanVm.emiMaxLimit && personalLoanVm.emi > personalLoanVm.emiMaxLimit) {
                personalLoanVm.maxEmiError = true;
                personalLoanVm.disableNextBtn();
            }
            else {
                personalLoanVm.maxEmiError = false;
                personalLoanVm.disableNextBtn();
            }
            return personalLoanVm.emi;
        };

        $scope.goToHome = function(){
            $state.go('menu.homeScreen');
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            personalLoanVm.showAmountError = false;
            personalLoanVm.showDurationError = false;
            $scope.loanAmountSlider = {
                value: parseInt(personalLoanService.personalLoanData.palAmount),
                options: {
                    floor: parseInt(personalLoanService.minBestOffer),
                    ceil: parseInt(personalLoanService.personalLoanData.palAmount),
                    showSelectionBar: true,
                    hidePointerLabels: true,
                    onChange: personalLoanVm.validateAmount,
                    step: 100
                }
            };
            $scope.loanDurSlider = {
                value: parseInt(personalLoanService.maxDuration),
                options: {
                    floor: parseInt(personalLoanService.minDuration),
                    ceil: parseInt(personalLoanService.maxDuration),
                    showSelectionBar: true,
                    hidePointerLabels: true,
                    onChange: personalLoanVm.validateDuration,
                    disabled: false
                }
            };
            if (personalLoanService.categoryType == 'KAVACH') {
                $scope.loanDurSlider.options.disabled = true;
            }

            personalLoanVm.intRate = parseFloat(personalLoanService.interestRate);
            personalLoanVm.emiMaxLimit = personalLoanService.maxEmiLimit;

            personalLoanVm.accountNumber = personalLoanService.personalLoanData.accountNumber;
            if(!utilityService.isEmpty(personalLoanService.loanAmount))
                $scope.loanAmountSlider.value = personalLoanService.loanAmount;
            if(!utilityService.isEmpty(personalLoanService.duration))
                $scope.loanDurSlider.value = personalLoanService.duration;
            if(!utilityService.isEmpty(personalLoanService.emiAmount))
                personalLoanVm.emi = personalLoanService.emiAmount;

            //Get configurable details
            if(personalLoanService.product && personalLoanService.product === "64514034"){
                personalLoanVm.isCOVIDPAPL = true;
                personalLoanService.configurableDetails().then(function (response) {
                    personalLoanService.configDetails = {
                        monthPeriod:parseInt(response.monthPeriod),
                        minAmount:response.minAmount,
                        uptoAmount:parseInt(response.uptoAmount),
                        aboveAmount:parseInt(response.aboveAmount),
                        minAmountInt:parseInt(response.minAmountInt),
                        factor:parseFloat(response.adjustmentValue)
                    };
                    personalLoanVm.configValues = personalLoanService.setConfigValues(personalLoanService.configDetails,$scope.loanAmountSlider.value);
                    personalLoanVm.processingFee = personalLoanVm.configValues.processingFee;
                },function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else if (personalLoanService.categoryType == 'KAVACH') {
                personalLoanService.configurableDetails().then(function (response) {
                    personalLoanService.configDetails = {
                        monthPeriod: parseInt(response.monthPeriod),
                        minAmount: response.minAmount,
                        uptoAmount: parseInt(response.uptoAmount),
                        aboveAmount: parseInt(response.aboveAmount),
                        minAmountInt: parseInt(response.minAmountInt),
                        factor: parseFloat(response.adjustmentValue)
                    };
                    if(parseInt(personalLoanService.processingFee) <= 0){
                        personalLoanVm.processingFee = 'NIL';
                    }else{
                        personalLoanVm.processingFee = personalLoanService.processingFee;
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
            else{
                personalLoanVm.isCOVIDPAPL = false;
                personalLoanVm.processingFee = personalLoanService.processingFee ? personalLoanService.processingFee : "NIL";
            }

        });



        return this;
    }
]);
