'use strict';

angularApp.service('personalLoanService',
	function ($q, AdapterUtils, $filter, $ionicPopup, $state, utilityService, homeScreenService) {
		var personalLoanService = this;
		var panDobData;
		personalLoanService.accountNumber = "";
		personalLoanService.loanAmount = "";
		personalLoanService.duration = "";
		personalLoanService.emiDate = "";
		personalLoanService.emiAmount = "";
		personalLoanService.loanAccountNumber = "";
		personalLoanService.accNo = "";
		personalLoanService.amount = "";
		personalLoanService.personalLoanData = {};
		personalLoanService.otp = "";
		personalLoanService.checkBox = 'N';
		personalLoanService.minDuration = "";
		personalLoanService.maxDuration = "";
		personalLoanService.minBestOffer = "";
		personalLoanService.interestRate = "";
		personalLoanService.activityCode = "";
		personalLoanService.schemeCode = "";
		personalLoanService.interest = "";
		personalLoanService.product = "";
		personalLoanService.checkTnC = false;
		personalLoanService.maxEmiLimit = "";
		personalLoanService.processingFee = "";
		personalLoanService.storeRefNumber = "";
		personalLoanService.configDetails = {monthPeriod:'',minAmount:'',uptoAmount:'',aboveAmount:'', factor:''};
		personalLoanService.categoryType = "";
		personalLoanService.kavachDeclarationText = "";

		personalLoanService.clearAll = function () {
			personalLoanService.accountNumber = "";
			personalLoanService.loanAmount = "";
			personalLoanService.duration = "";
			personalLoanService.emiDate = "";
			personalLoanService.emiAmount = "";
			personalLoanService.loanAccountNumber = "";
			personalLoanService.accNo = "";
			personalLoanService.amount = "";
			personalLoanService.personalLoanData = {};
			personalLoanService.otp = "";
			personalLoanService.checkBox = 'N';
			personalLoanService.minDuration = "";
			personalLoanService.maxDuration = "";
			personalLoanService.minBestOffer = "";
			personalLoanService.interestRate = "";
			personalLoanService.activityCode = "";
			personalLoanService.schemeCode = "";
			personalLoanService.interest = "";
			personalLoanService.product = "";
			personalLoanService.checkTnC = false;
			personalLoanService.maxEmiLimit = "";
			personalLoanService.processingFee = "";
			personalLoanService.categoryType = "";
			personalLoanService.kavachDeclarationText = "";
		}

        personalLoanService.isValidField = function(obj,field) {
            if (!obj) {
                return 'Please provide ' +field;
            }
        };

		personalLoanService.showPANDOBConfirmPopup = function (pan,dob) {
            var test = '<div class="homeLoan textCenter color-darkgrey padTop10">'+
				'<div class="roboto-regular font-size-12">You have provided the following information</div>'+
				'<div class="roboto-regular font-size-14 padTop20">PAN:</div>'+
				'<div class="roboto-bold font-size-14 padTop5" style="font-weight: bold;">'+pan+'</div>'+
				'<div class="roboto-regular font-size-14 padTop15">Date Of Birth:</div>'+
				'<div class="roboto-bold font-size-14 padTop5" style="font-weight: bold;">'+dob+'</div>'+
				'<div class="roboto-regular font-size-12 padTop30">Would you like to proceed?</div>'+
			'</div>';
            $ionicPopup.show({
                template: test,
                title: 'Please Confirm',
                cssClass: 'bhim-alert-popup paplPANDOBConfirmBox',
				buttons: [
                    {
                        text: "No",
                        type: 'button-negative',
                        onTap: function () {
                           $state.go('menu.plPanDob');
                        }
                    },{
                        text: "Yes",
                        type: 'button-positive',
                        onTap: function () {
                           personalLoanService.getPanDobData(pan,dob);
                        }
                    }
                ]
            });           
        };

		personalLoanService.showAlertPopup = function (imageType, message1, message2, onTapgo, buttontext1, buttontext2, $scope, obj) {
            var btn_array = [];
            if (buttontext1 != "" && buttontext2 != "") {
                btn_array = [
                    {
                        text: buttontext2 || "Cancel",
                        type: 'button-negative'
                    },{
                        text: buttontext1 || "OK",
                        type: 'button-positive',
                        onTap: function () {
                            if (onTapgo) {
                                $state.go(onTapgo);
                            }
                        }
                    }
                ];
            } else {
                btn_array = [
                    {
                        text: buttontext1 || "OK",
                        type: 'button-positive',
                        onTap: function () {
                            if (onTapgo) {
                                $state.go(onTapgo);
                            }
                        }
                    }
                ];
            }

            if (imageType && imageType.toLowerCase() == 'error') {
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/errorSymbol.svg"/></div>';
            } else if (imageType && imageType.toLowerCase() == 'success') {
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/successSymbol.svg"/></div>';
            } else if (imageType && imageType.toLowerCase() == 'alert') {
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/alertSymbol.svg"/></div>';
            } else {
                imageType = "";
            }
            $ionicPopup.alert({
                template: '<div class="font-dark-grey">' + imageType + '<div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter roboto-medium font-size-16 color-darkgrey"><span>'
                    + message1 + '</span><div class="textAlignCenter roboto-medium font-size-14 color-darkgrey padTop15">' + message2 + '</div></div></div></div>', //template,
                scope: $scope,
                cssClass: 'bhim-alert-popup patwl_popup_border',
                buttons: btn_array
            });
        };

		personalLoanService.setPANDOBData = function(data) {
            panDobData = data;
        };

        personalLoanService.getPANDOBData = function() {
            return panDobData;
        };

		 // PAN & DOB Validation service call
		personalLoanService.getPanDobData = function (pan,dob) {
			var request = {
				"panNumber": pan,
				"dob": dob
			};			
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/getPanDobData", request, true).then(
				function (response) {
					personalLoanService.setPANDOBData(request);
					q.resolve(response.data);
					$state.go('menu.personalLoan');
				},
				function (error) {
					q.reject(error);
					if(error.responseCode == "VPD1") {
						homeScreenService.isNotificationDataAvail = false;
						personalLoanService.showAlertPopup("alert", error.responseMessage, "", "menu.homeScreen", "OK", "", "", "");
					}else if(error.responseCode == "VPD2"){
						personalLoanService.showAlertPopup("alert","Try Again", error.responseMessage, "", "OK", "", "", "");
					}else{
						personalLoanService.showAlertPopup("alert", error.responseMessage, "", "", "OK", "", "", "");
					}
				}
			);
			return q.promise;
		};

		personalLoanService.getKavachDeclaration = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/getKavachDeclaration", {}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		personalLoanService.getLoanDetails = function (data) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/getPreApprovedData", data, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		personalLoanService.getMasterData = function (reqData) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/getProductDetails", reqData, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		personalLoanService.requestPalTerm = function (reqData) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/termsConditionsService", reqData, true).then(
				function (response) {
					q.resolve(response);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		personalLoanService.pALTerm = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/termsConditions", {}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		personalLoanService.otpLoan = function (reqData) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/OTPAdapter/getOTPTokenSecure", reqData, false).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		personalLoanService.requestOtp = function (reqData) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/OTPAdapter/validateOTPTokenSecure", reqData, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		personalLoanService.applyForLoan = function (reqData) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/createPreApprovedLoan", reqData, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		personalLoanService.configurableDetails = function (reqData) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/retrieveConfigValues", {}, false).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		personalLoanService.setConfigValues = function (item,loanAmt) {
			var obj = {
				tenureInfo : $filter('translate')('PAPL_SEL_LOAN_DUR_COPAPL_PART1')+ item.monthPeriod + $filter('translate')('PAPL_SEL_LOAN_DUR_COPAPL_PART2'),
				emiInfo : $filter('translate')('PAPL_EMI_HOLIDAY_NOTE_PART1')+ item.monthPeriod + $filter('translate')('PAPL_EMI_HOLIDAY_NOTE_PART2'),
				forLoanUpto : $filter('translate')('PAPL_FOR_LOAN_UPTO_PART1')+ item.minAmount + $filter('translate')('PAPL_FOR_LOAN_UPTO_PART2')+item.uptoAmount,
				forLoanAbove : $filter('translate')('PAPL_FOR_LOAN_ABOVE_PART1')+ item.minAmount + $filter('translate')('PAPL_FOR_LOAN_ABOVE_PART2')+item.aboveAmount,
				processingFee : (parseInt(item.minAmountInt) < parseInt(loanAmt)) ? item.aboveAmount : item.uptoAmount
			}			
			return obj;
		};

		personalLoanService.kavachEMICalculation = function (p, i, t, m) {
			p = parseInt(p);
			i = parseFloat(i) / 1200;
			t = parseInt(t);
			m = parseInt(m);
			var expression = ((p * (Math.pow((1 + i), m))) - p) * 100;
			var totalInterestCapitalized = Math.round(Math.round(expression) / 100);
			var num = (p + totalInterestCapitalized) * i * (Math.pow(1 + (i), t - m));
			var denom = (Math.pow(1 + (i), t - m) - 1) * 100 / 100;
			var emi = Math.round((num) / (denom) * 100 / 100);
			return emi;
		}

		return personalLoanService;
	});
