'use strict';

angularApp.controller('plPanDobController', [
    "$state",
    "$scope",
    "$rootScope",
    "utilityService",
    "$ionicPopup",
    "personalLoanService",    
    "$ionicHistory",
    "clickStreamService",
    "$filter",
    function ($state,
        $scope,
        $rootScope,
        utilityService,
        $ionicPopup,
        personalLoanService,
        $ionicHistory,
        clickStreamService,
        $filter) {

        var plPanDobVm = this;
        var panReg = /[A-Z]{5}[0-9]{4}[A-Z]{1}/;

        plPanDobVm.init = function () {
            plPanDobVm.errPANObj = {};
            var today = new Date();
            var maxDOBDate = new Date(today.getFullYear()-18, today.getMonth(), today.getDate());
            $scope.dateDOBobj = {};
            $scope.dateDOBobj.dt = maxDOBDate;
            if(personalLoanService.getPANDOBData()){
                plPanDobVm.dob = personalLoanService.getPANDOBData().dob;
                $scope.dateDOBobj.dt = plPanDobVm.dob;
                plPanDobVm.pan = personalLoanService.getPANDOBData().panNumber;
            }
        }

        plPanDobVm.goToNext = function(){
            if(plPanDobVm.validatePANDOBForm()){
               personalLoanService.showPANDOBConfirmPopup(plPanDobVm.pan,plPanDobVm.dob);
            }
        }

        // PAN Validation
        plPanDobVm.isPANInput = function() {
            if(personalLoanService.isValidField(plPanDobVm.pan,"PAN")) {
                plPanDobVm.errPANObj.panError = personalLoanService.isValidField(plPanDobVm.pan,"PAN");
            }
                       
            if(plPanDobVm.pan){
                if (!panReg.test(plPanDobVm.pan)) {
                    plPanDobVm.errPANObj.panError = 'Please enter valid PAN details!';
                }else{
                    plPanDobVm.errPANObj.panError = "";
                }
            }
        };


        // DOB Validation
        plPanDobVm.isDOBInput = function() {
            plPanDobVm.errPANObj.dobError = personalLoanService.isValidField(plPanDobVm.dob,"Date of Birth");
        };

        // PAN & DOB Validation
        plPanDobVm.validatePANDOBForm = function() {
            plPanDobVm.errPANObj = {};
            if(personalLoanService.isValidField(plPanDobVm.pan,"PAN")) {
                plPanDobVm.errPANObj.panError = personalLoanService.isValidField(plPanDobVm.pan,"PAN");
            }

            if(plPanDobVm.pan){
                if (!panReg.test(plPanDobVm.pan)) {
                    plPanDobVm.errPANObj.panError = 'Please enter valid PAN details!';
                }
            }

            if(personalLoanService.isValidField(plPanDobVm.dob,"Date of Birth")) {
                plPanDobVm.errPANObj.dobError = personalLoanService.isValidField(plPanDobVm.dob,"Date of Birth");
            }
          
            return (angular.equals({}, plPanDobVm.errPANObj)) ? true : false;        
        }

        plPanDobVm.openDOBDatePicker = function() {      
            $scope.dateOptions = {
                formatYear: 'yy',
                startingDay: 1
            }
            var datePickerPopup = $ionicPopup.alert({
                cssClass: 'rtxc-datepicker-popup',
                template: '<div class="datePickerBlock font-size-14">'+
                    '<input type="text" datepicker="dd MMM yyyy" ng-model="dateDOBobj.dt" format-day-title="dd MMM yyyy" is-open="true" show-weeks="false"/>'+
                    '</div>',
                scope: $scope, 
                buttons: [{
                    text: 'Cancel',
                    type: 'button-negative',
                    onTap: function (res) {
                        datePickerPopup.close();
                    }
                },{
                    text: 'OK',
                    type: 'button-positive',
                    onTap: function (res) {
                        plPanDobVm.errPANObj.dobError = '';
                        plPanDobVm.dob = $filter('date')($scope.dateDOBobj.dt, "dd MMM yyyy");
                    }
                }],
            });           
        }
            
        plPanDobVm.goToBack = function () {
            $ionicHistory.goBack(-1);
        };

        $scope.goToHome = function () {
            $state.go('menu.homeScreen');        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.beforeEnter', function () {
            plPanDobVm.init();
        });
        
        return this;
    }
]);
