'use strict';

angularApp.controller('plOTPController', [
	"$state",
	"$scope",
	"$rootScope",
	"utilityService",
	"$ionicPopup",
	"personalLoanService",
	"getAccountDetailsService",
	"$ionicHistory",
	"clickStreamService",
	//"autoOtpReadService",
	"sampoornSurakshaService",
	"generalInsurenceHomeService",
	"homeScreenService",
	function ($state,
		$scope,
		$rootScope,
		utilityService,
		$ionicPopup,
		personalLoanService,
		getAccountDetailsService,
		$ionicHistory,
		clickStreamService,
		//autoOtpReadService,
		sampoornSurakshaService,
		generalInsurenceHomeService,
		homeScreenService) {

		var plOTPVm = this;
		$scope.resendLable = false;
		$scope.sendLable = true;
		plOTPVm.mobileNumber = $rootScope.mobileNo;
		$rootScope.currentPage = 4;
		$scope.isKavach = false;

		plOTPVm.nextEnable = function () {
			plOTPVm.showNameError = plOTPVm.otp.length;
			if (plOTPVm.otp === plOTPVm.otpValue) {
				plOTPVm.disableNext = false;
			} else {
				plOTPVm.disableNext = true;
			}
		}

		plOTPVm.goToBack = function () {
			plOTPVm.otp = "";
			$ionicHistory.goBack(-1);
		};

		plOTPVm.sendTxnIdData = function (transactionId) {
			clickStreamService.clickStreamData = transactionId;
			clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "APLY_LOAN_BTN"));
		}

		plOTPVm.goToNext = function () {
			var requestParams = {
				otp: plOTPVm.otp
			}
			personalLoanService.requestOtp(requestParams).then(function (data) {
				if (data.status.toLowerCase() == "success") {
					var transactionId = utilityService.getRandomNumber();
					var reqData = {
						product: personalLoanService.product,
						applicationAmount: personalLoanService.loanAmount,
						loanTerm: personalLoanService.duration,
						toDepositAccount: personalLoanService.personalLoanData.accountNumber,
						emiPaymentStartDate: personalLoanService.emiDate,
						termsNcondition: personalLoanService.checkTnC,
						txnId: transactionId
					}
					personalLoanService.applyForLoan(reqData).then(function (data) {
						homeScreenService.isNotificationDataAvail = false;
						personalLoanService.storeRefNumber = data.storeRefNumber;
						plOTPVm.sendTxnIdData(reqData.txnId);
						plOTPVm.successData = data.responseStatus;
						$state.go('menu.congratulations');
					}, function (error) {
						plOTPVm.sendTxnIdData(reqData.txnId);
						utilityService.showErrorMessage(error.responseMessage);
					});
				} else {
					utilityService.showErrorMessage(data.status);
				}
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});			
		};
		
		plOTPVm.buySS = function(){
			sampoornSurakshaService.getPremiumAndNomineeInfo().then(function(data) {
				sampoornSurakshaService.clearAll();
				sampoornSurakshaService.setPremiumDetails(data);
				$state.go('menu.ssPremiumCalculation');
			}, function(error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		}

		plOTPVm.buyPAI = function() {
			generalInsurenceHomeService.setGIProductsID("personal-accident-insurance-buy");
			generalInsurenceHomeService.setBackNavigationState("menu.congratulations");
			$state.go('menu.declaimer');
		}

		plOTPVm.knowMorePAI = function() {
			generalInsurenceHomeService.setGIProductsID("personal-accident-insurance-details");
			generalInsurenceHomeService.setBackNavigationState("menu.congratulations");
			$state.go('menu.declaimer');
		}


		plOTPVm.knowMore = function(){
			sampoornSurakshaService.getPolicyFeatures().then(function(data) {
				sampoornSurakshaService.setPolicyDetails(data);
				sampoornSurakshaService.setBuyNow(true);
				sampoornSurakshaService.isFromPapl = true;
				$state.go('menu.ssPolicyFeatures');
			}, function(error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		}

		plOTPVm.ok = function () {
			// plOTPVm.myPopup.close();
			plOTPVm.otp = "";
			utilityService.setCsatJournies("preApprovedPersonalLoans");
			getAccountDetailsService.accountOverviewData = "";
			$state.go('menu.accountOverviewMyBalance');
		};

		$scope.goToHome = function () {
			$state.go('menu.homeScreen');
		}

		plOTPVm.sendOTP = function () {

			if (utilityService.isAndroidPlatform()) {
			// autoOtpReadService.startOtpReading().then(function (result) {
			// 	plOTPVm.otp = result;
			// 	// plOTPVm.goToNext();
			// }, function (error) {
			// 	console.log(error);
			// }, function (watchStatus) {
				var reqData = {}
				personalLoanService.otpLoan(reqData).then(function (data) {
					personalLoanService.otp = data.otp;
					console.log("PersonalLoanOTPSuccess")
				}, function (error) {
					autoOtpReadService.stopOtpReading();
					utilityService.showErrorMessage(error.responseMessage);
				});
			//});
			} else {
				var reqData = {}
				personalLoanService.otpLoan(reqData).then(function (data) {
					personalLoanService.otp = data.otp;
					console.log("PersonalLoanOTPSuccess")
				}, function (error) {
					autoOtpReadService.stopOtpReading();
					utilityService.showErrorMessage(error.responseMessage);
				});
			}


		}
		//Function call to redirect to cards journey
		plOTPVm.gotoCards = function(){
			getAccountDetailsService.tabIndex.tabIndex=5;
			homeScreenService.isCreditCardFlag = true;//set in order to load cards api
          	$state.go('menu.accountOverviewMyBalance');
		}

		plOTPVm.slideChanged = function (index) {
			$scope.slideIndex = index;
		};

		plOTPVm.resendOTP = function () {
			if (plOTPVm.isDisabledOTP) { return true }
			$scope.resendLable = true;
			$scope.sendLable = false;
			plOTPVm.otp = "";

			if (utilityService.isAndroidPlatform()) {
			// autoOtpReadService.startOtpReading().then(function (result) {
			// 	plOTPVm.otp = result;
			// 	// plOTPVm.goToNext();
			// }, function (error) {
			// 	console.log(error);
			// }, function (watchStatus) {
				var reqData = {}
				personalLoanService.otpLoan(reqData).then(function (data) {
					personalLoanService.otp = data.otp;
					plOTPVm.otpValue = personalLoanService.otp;
					plOTPVm.isDisabledOTP = true;
				}, function (error) {
					autoOtpReadService.stopOtpReading();
					utilityService.showErrorMessage(error.responseMessage);
				});
			//});
			} else {
				var reqData = {}
				personalLoanService.otpLoan(reqData).then(function (data) {
					personalLoanService.otp = data.otp;
					plOTPVm.otpValue = personalLoanService.otp;
					plOTPVm.isDisabledOTP = true;
				}, function (error) {
					autoOtpReadService.stopOtpReading();
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

		}

		//one time initialization to be done when the controller is loaded
		$scope.$on('$ionicView.beforeEnter', function () {
			plOTPVm.disableNext = true;
			plOTPVm.loanAccountNumber = personalLoanService.loanAccountNumber;
			plOTPVm.storeRefNumber = personalLoanService.storeRefNumber;
			plOTPVm.amount = personalLoanService.loanAmount;
			plOTPVm.accNo = personalLoanService.personalLoanData.accountNumber;
			plOTPVm.otpValue = personalLoanService.otp;
			plOTPVm.isDisabledOTP = false;
			if(personalLoanService.categoryType == "KAVACH"){
				$scope.isKavach = true ;
			}else{
				$scope.isKavach = false;
			}
		});

		$scope.$on('$ionicView.loaded', function () {
			if ($state.current.name == "menu.plOTP") {
				plOTPVm.sendOTP();
			}
			if($state.current.name == "menu.congratulations"){
				var request = {
					"journey" : "PAPL"
				}
				sampoornSurakshaService.checkCustomerStatusPAPL(request).then(function (data) {
					if(data && data.customerFlag === 'true'){
						plOTPVm.showBanner = true;
						plOTPVm.bannerMsg = data.bannerMsg;
						plOTPVm.bannerImg = data.bannerImg;
					}else{
						plOTPVm.showBanner = false;
					}
					$ionicSlideBoxDelegate.update();
				}, function (error) {
				});

				generalInsurenceHomeService.loadPersonalAccidentBannerInfo().then(function (data) {
					for(var notif = 0 ; notif < data.notifications.length ; notif++) {
						if(data.notifications[notif].category == "PAPL_PAI") {
							var mssg = data.notifications[notif].message;
							plOTPVm.bannerMsgPAI = mssg.replace("Rs.","&#8377;");
							plOTPVm.bannerImgPAI = data.notifications[notif].offerImgMobile;
						} 
					}
					$ionicSlideBoxDelegate.update();
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
				//wcm service call for cards papl image banner
				generalInsurenceHomeService.getCardswithPapl().then(function(data){
					 plOTPVm.cardImage = true; 
					 plOTPVm.cardsPaplBanner = data.imgUrl;
					 $ionicSlideBoxDelegate.update();
				}, function(error) {
					plOTPVm.cardImage = false;
					utilityService.showErrorMessage(error.responseMessage);
				});
				
			}
		});

		$scope.$on('$ionicView.afterEnter', function () {
			$ionicSlideBoxDelegate.update();
		});

		return this;
	}
]);
