'use strict';

angularApp.controller('plTermsController', ["$state",
    "$scope",
    "$translate",
    "$ionicScrollDelegate",
    "utilityService",
    "$ionicPopup",
    "personalLoanService", "$sce", "$rootScope", "constantConfig",

    function ($state,
        $scope,
        $translate,
        $ionicScrollDelegate,
        utilityService,
        $ionicPopup,
        personalLoanService, $sce, $rootScope, constantConfig) {

        var plTermsVm = this;
        $rootScope.currentPage = 3;

        function initPage() {
            plTermsVm.showBack = true;
            plTermsVm.showNext = true;
            plTermsVm.disableNext = true;
            plTermsVm.aofooter = true;
            plTermsVm.isTncDownloaded = false;
            plTermsVm.ConditionsJson = [];
            plTermsVm.conditionsList();
            plTermsVm.disableCheckbox = true;
        }

        plTermsVm.goBacktoPrevious = function () {
            $state.go('menu.emiPayDate');
        }

        plTermsVm.goToNextPage = function () {
            //$state.go('menu.plOTP');
            $state.go('menu.reviewLoan');
        }

        plTermsVm.checkScroll = function () {
            var currentTop = $ionicScrollDelegate.$getByHandle('scroller').getScrollPosition().top;
            var maxTop = $ionicScrollDelegate.$getByHandle('scroller').getScrollView().__maxScrollTop;
            if (currentTop >= maxTop) {
                plTermsVm.disableCheckbox = false;
                var childNodes = document.getElementById('TNC_CHK').children[0].children[0].removeAttribute("disabled");
            }
        }

        plTermsVm.conditionsList = function () {
            plTermsVm.ConditionsJson = personalLoanService.ConditionsJson;
        }

        $scope.goToHome = function () {
            $state.go('menu.homeScreen');
        }

        plTermsVm.agreeChkBox = function () {
            if (plTermsVm.isChecked) {
                plTermsVm.disableNext = false;
                personalLoanService.checkTnC = true;

                if (!plTermsVm.isTncDownloaded) {
                    plTermsVm.generatePDF();
                }
            } else {
                plTermsVm.disableNext = true;
                personalLoanService.checkTnC = false;
            }
        }

        plTermsVm.generatePDF = function () {
            var myBase64 = personalLoanService.pdfContent;
            var fileContentType = "application/pdf";
            var tcFileName = '';

            //added file name for kavach file get replaced with new file with same name.
            if (personalLoanService.categoryType == 'KAVACH') {
                tcFileName = "terms_and_condition_kavach";
            } else {
                if (utilityService.isAndroidPlatform()) {
                    var pdfTimestamp = new Date().getTime();
                    tcFileName = "terms_and_conditions_personal_loan_"+pdfTimestamp;
                }else{
                    tcFileName = "terms_and_conditions_personal_loan";
                }
            }

            plTermsVm.b64toBlob = function (b64Data, contentType, sliceSize) {
                contentType = contentType || '';
                sliceSize = sliceSize || 512;

                var byteCharacters = atob(b64Data);
                var byteArrays = [];

                //Check PDF SIZE
                if (byteCharacters.length >= constantConfig.accOverview.pdfSize) {
                    utilityService.showErrorMessage(constantConfig.accOverview.sizeLimitMessage);
                    return;
                }

                for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
                    var slice = byteCharacters.slice(offset, offset + sliceSize);
                    var byteNumbers = new Array(slice.length);
                    for (var i = 0; i < slice.length; i++) {
                        byteNumbers[i] = slice.charCodeAt(i);
                    }
                    var byteArray = new Uint8Array(byteNumbers);
                    byteArrays.push(byteArray);
                }
                var blob = new Blob(byteArrays, { type: contentType });
                return blob;
            }


            plTermsVm.savebase64AsPDF = function (filename, content, contentType) {
                // Convert the base64 string in a Blob
                var DataBlob = plTermsVm.b64toBlob(content, contentType);
                if (utilityService.isAndroidPlatform()) {
                    if (device.version == 10) {
                        const folderpath = cordova.file.externalDataDirectory;
                        plTermsVm.popupFolderpath = cordova.file.externalDataDirectory + filename;    //folderpath.replace(cordova.file.externalRootDirectory, "") + filename;
                        window.resolveLocalFileSystemURL(folderpath, function (dir) {
                            dir.getFile(filename, { create: true }, function (file) {
                                file.createWriter(function (fileWriter) {
                                    fileWriter.write(DataBlob);
                                }, function () { });
                            });
                        });
                    } else {
                        //for Android below 10 and Android 11 not for 10
                        window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fileSystem) {
                            fileSystem.root.getDirectory("Download", { create: true, exclusive: false }, function (dir) {
                                plTermsVm.popupFolderpath = dir.fullPath + filename;
                                dir.getFile(filename, { create: true }, function (file) {
                                    file.createWriter(function (fileWriter) {
                                        fileWriter.write(DataBlob);
                                    }, function () { });
                                });
                            });
                        });
                    }

                    //Show popup 
                    var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="RTXC_DOWNLOAD_RECEIPT" translate-values="{filePath:plTermsVm.popupFolderpath}"></div>';
                    plTermsVm.downloadPopup = $ionicPopup.show({
                        title: '',
                        template: template,
                        scope: $scope,
                        cssClass: 'my-custom-popup',
                        buttons: [{
                            text: 'OK',
                            type: 'button-assertive',
                            onTap: function () {
                                plTermsVm.downloadPopup.close();
                            }
                        }],
                    });
                }
                if (utilityService.isIOSPlatform()) {
                    const folderpath = cordova.file.documentsDirectory;
                    const finalPath = folderpath + filename;
                    window.resolveLocalFileSystemURL(folderpath, function (dir) {
                        dir.getFile(filename, { create: true }, function (file) {
                            file.createWriter(function (fileWriter) {
                                fileWriter.write(DataBlob);
                            }, function () { });
                        });
                    });
                    cordova.plugins.fileOpener2.open( finalPath, 'application/pdf', {
                        error: function (e) {
                            console.log('Error status: ' + e.status + ' - Error message: ' + e.message);
                        },
                        success: function () {
                            console.log('file opened successfully');
                        }
                    });
                }
            }
            plTermsVm.savebase64AsPDF(tcFileName + ".pdf", myBase64, fileContentType);
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        return this;
    }
]);
