'use strict';

angularApp.controller('atmCardNumberController',
	["$state", "$scope","regProcessWithAccNoService","cryptoService","utilityService","$ionicPopup",
	function ($state, $scope, regProcessWithAccNoService, cryptoService, utilityService, $ionicPopup) {
							
	var atmCardNumberVm = this;
	atmCardNumberVm.hideCardInput = true;
	atmCardNumberVm.cardNo1 = '';
	atmCardNumberVm.cardNo2 = '';
	atmCardNumberVm.cardNo3 = '';
	atmCardNumberVm.cardNo4 = '';
	atmCardNumberVm.cardNo5 = '';
	atmCardNumberVm.cardNo6 = '';
	atmCardNumberVm.cardNumberRequired = false;

	atmCardNumberVm.next = function(){
		regProcessWithAccNoService.atmCardNumber = atmCardNumberVm.cardNo1+atmCardNumberVm.cardNo2+atmCardNumberVm.cardNo3+atmCardNumberVm.cardNo4+atmCardNumberVm.cardNo5+atmCardNumberVm.cardNo6;
		if(regProcessWithAccNoService.atmCardNumber.length === 6){
			atmCardNumberVm.cardNumberRequired = false;
			atmCardNumberVm.getDetails(regProcessWithAccNoService.atmCardNumber);
			//$state.go("menu.atmCardPin");
		}else{
			atmCardNumberVm.cardNumberRequired = true;
		}
	}

	atmCardNumberVm.getDetails = function(num){
		var reqParams = {};
		reqParams["digitsForATM"] = num;
		regProcessWithAccNoService.getACardDetails(reqParams).then(function(response){
			var tenDigitNumber = response["tenDigitNumber"];
			var hshVal = cryptoService.getSHA512EncryptedData(tenDigitNumber+"#"+num).toString();
			var finalHshVal = cryptoService.getSHA512EncryptedData(hshVal).toString();
			if(finalHshVal === response["shaValueForAtm"]){
				regProcessWithAccNoService.atmCardNumber = tenDigitNumber + num;
				$state.go("menu.atmCardPin");
			 }else{
			 	utilityService.showErrorMessage("Something went wrong. Please try again after sometime.");
			 }
			
		},function(error){
			utilityService.showBhimUpiAlert("error", error.responseMessage, "menu.selectSim", "OK", $scope);
		});
	}

	atmCardNumberVm.close = function() {
		$state.go("menu.selectSim");
	}
	
}]);
