'use strict';

angularApp.controller('cifDetailsController',
    ["$timeout", 
    "$state", 
    "$scope", 
    "$translate", 
    "$ionicSideMenuDelegate", 
    "ionicToast", 
    "$ionicPopup", 
    "$ionicScrollDelegate",
    "utilityService",
    "$ionicHistory",
    "ionicDatePicker",
    "regProcessWithAccNoService",
    "$filter",
    "constantConfig",
    "encryptionService",
    "cryptoService",
    function (
        $timeout, 
        $state, 
        $scope, 
        $translate, 
        $ionicSideMenuDelegate, 
        ionicToast, 
        $ionicPopup, 
        $ionicScrollDelegate,
        utilityService,
        $ionicHistory,
        ionicDatePicker,
        regProcessWithAccNoService,
        $filter,
        constantConfig,
        encryptionService,
        cryptoService) {

        var cifDetailsVm = this;
        cifDetailsVm.submitted = false;
        cifDetailsVm.cifNumber = "";
        cifDetailsVm.accountNumber = "";

        cifDetailsVm.closeView = function(){
            $state.go("menu.selectSim");
        }
        cifDetailsVm.goBack = function(){
            $ionicHistory.goBack(); 
        }

        
        cifDetailsVm.continue = function(isValid){
            cifDetailsVm.submitted = true;
            if(isValid && cifDetailsVm.accountNumber && cifDetailsVm.cifNumber){
                cifDetailsVm.submitted = false;
                var requestParams = {
                    "accountNumber":cifDetailsVm.accountNumber,
                    "cif":cifDetailsVm.cifNumber
                }
                regProcessWithAccNoService.getCustomerDetailsForATM(requestParams).then(function(response){
                    utilityService.hideSpinner();
                    regProcessWithAccNoService.customerDetailsForATM = response.customerInformation;
                    $state.go('menu.regOTPForATM');
                },
                function(error){
                    utilityService.hideSpinner();
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
            //$state.go('menu.regOTPForATM');
        }

       
}]);
