'use strict';

angularApp.controller('generateOTPController', ["$timeout", "$state", "$scope", "$translate", "$stateParams",
	"utilityService", "internetBankingService", "accountDetailsService", "constantConfig", "cryptoService", "autoOtpReadService",
	function ($timeout, $state, $scope, $translate, $stateParams, utilityService, internetBankingService, accountDetailsService, constantConfig, cryptoService, autoOtpReadService) {

		var generateOTPVm = this;

		generateOTPVm.init = function () {
			$scope.isDisabledOTPbtn = false;
			var accAndBankDetails = accountDetailsService.getDetails();
			generateOTPVm.mobileNumber = accAndBankDetails.mobileNumber;
			generateOTPVm.generateOTP(generateOTPVm.mobileNumber);
		}

		//Generate OTP and send to registered mobile number
		generateOTPVm.generateOTP = function (mobileNumber) {
			var reqParams = {};
			reqParams["id"] = mobileNumber;
			reqParams.otpCode = constantConfig.keysForOTP.Register;
			reqParams.ocHash = cryptoService.getSHA512EncryptedData(constantConfig.keysForOTP.Register).toString();
			if(utilityService.isAndroidPlatform()) {
				autoOtpReadService.startOtpReading().then(function (result) {
					generateOTPVm.otp = result;
					// generateOTPVm.goToSetTemporaryPassword(generateOTPVm.otp);
				}, function (error) {
					console.log(error);
				}, function (watchStatus) {
					accountDetailsService.generateOTP(reqParams).then(function (data) {
														
					}, function (error) {
						autoOtpReadService.stopOtpReading();
						utilityService.showErrorMessage(error.responseMessage);
					});
				});
			} else {
				accountDetailsService.generateOTP(reqParams).then(function (data) {
														
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}
		}

		//Resend OTP
		generateOTPVm.resendOTP = function () {
			if ($scope.isDisabledOTPbtn) { return true }
			var reqParams = {};
			reqParams["id"] = generateOTPVm.mobileNumber;
			reqParams.otpCode = constantConfig.keysForOTP.Register;
			reqParams.ocHash = cryptoService.getSHA512EncryptedData(constantConfig.keysForOTP.Register).toString();
			if(utilityService.isAndroidPlatform()) {
				autoOtpReadService.startOtpReading().then(function (result) {
					generateOTPVm.otp = result;
					// generateOTPVm.goToSetTemporaryPassword(generateOTPVm.otp);
				}, function (error) {
					console.log(error);
				}, function (watchStatus) {
					accountDetailsService.generateOTP(reqParams).then(function (data) {
						$scope.isDisabledOTPbtn = true;						
					}, function (error) {
						autoOtpReadService.stopOtpReading();
						utilityService.showErrorMessage(error.responseMessage);
					});
				});
			} else {
				accountDetailsService.generateOTP(reqParams).then(function (data) {
					$scope.isDisabledOTPbtn = true;						
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}
		}

		//Validate OTP
		generateOTPVm.goToSetTemporaryPassword = function (otp) {
			if (otp !== undefined && otp !== '') {
				var reqParams = {};
				reqParams["otp"] = otp;
				reqParams["mobile"] = generateOTPVm.mobileNumber;
				accountDetailsService.validateOTP(reqParams).then(function (data) {
					if (data.status.toLowerCase() === 'success') {
						$state.go('menu.setTemporaryPassword');
					} else {
						utilityService.showErrorMessage(data.status);
					}
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			} else {
				utilityService.showErrorMessage('Please input One Time Password received on your registered mobile. The OTP field can not be blank.');
			}
		}

		//Go to CIF details
		generateOTPVm.goToBack = function () {
			generateOTPVm.messageSentSuccess = false;
			generateOTPVm.messageSentFailure = false;
			$state.go('menu.accAndBankDetails', { accAndBankDetails: accAndBankDetails, atmDetails: atmDetails });
		}

		generateOTPVm.closeView = function () {
			generateOTPVm.messageSentSuccess = false;
			generateOTPVm.messageSentFailure = false;
			$state.go('menu.selectSim');
		}

		//actions to done everytime the view is shown
		$scope.$on('$ionicView.beforeEnter', function () {
			generateOTPVm.init();
		});

	}]);