'use strict';

angularApp.controller('regOTPATMController',
    ["$timeout", 
    "$state", 
    "$scope", 
    "$translate", 
    "$ionicSideMenuDelegate", 
    "ionicToast", 
    "$ionicPopup", 
    "$ionicScrollDelegate",
    "utilityService",
    "$ionicHistory",
    "ionicDatePicker",
    "internetBankingService",
    "regProcessWithAccNoService",
    function (
        $timeout, 
        $state, 
        $scope, 
        $translate, 
        $ionicSideMenuDelegate, 
        ionicToast, 
        $ionicPopup, 
        $ionicScrollDelegate,
        utilityService,
        $ionicHistory,
        ionicDatePicker,
        internetBankingService,
        regProcessWithAccNoService) {

        var regOTPATMControllerVm = this;
        regOTPATMControllerVm.resendOTPCout = 1;
        regOTPATMControllerVm.customerDetails = regProcessWithAccNoService.customerDetailsForATM;
        regOTPATMControllerVm.isOTPRequired = false;
        regOTPATMControllerVm.submitted = false;
        regOTPATMControllerVm.isDisabledOTPbtn = false;

        regOTPATMControllerVm.close = function(){
            $state.go("menu.selectSim");
        }
        regOTPATMControllerVm.goBack = function(){
            $ionicHistory.goBack(); 
        }
        regOTPATMControllerVm.otpValidate = function(){
            regOTPATMControllerVm.submitted = true;
            if(regOTPATMControllerVm.otp){
                regOTPATMControllerVm.submitted = false;
                var reqParams = {
                    "otp":regOTPATMControllerVm.otp,
                    "mobile":regOTPATMControllerVm.customerDetails.mobile,
                    "journeyName":"RegistrationwithATM",
                    "data": {
                        "commonId": ""
                    }
                };
                regProcessWithAccNoService.validateOTP(reqParams).then(function (data) {
                    $state.go('menu.accountDetailsPage');
                }, function (error) {
                    regOTPATMControllerVm.otp = "";
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
            
            //$state.go('menu.accountDetailsPage');
            
        }

        //Resend OTP
        regOTPATMControllerVm.resendOTP = function(){
            if(!regOTPATMControllerVm.isDisabledOTPbtn){
                var reqParams = {
                    "id":regOTPATMControllerVm.customerDetails.mobile,
                    "recipientMailId":"",
                    "journeyName":"RegistrationwithATM",
                    "sendOTPFlag":""
                };
                regProcessWithAccNoService.generateOTP(reqParams).then(function (data) {
                    var confirmPopup = $ionicPopup.confirm({
                        title: "",
                        template: "<div>OTP has been sent to your mobile number.</div>",
                        cssClass: 'dialog',
                        scope: $scope,
                        buttons: [
                            {
                                text: 'OK',
                                onTap: function (e) {
                                    confirmPopup.close();
                                }
                            }
                        ]
                    });
                    if(regOTPATMControllerVm.resendOTPCout != 2){
                        regOTPATMControllerVm.resendOTPCout = regOTPATMControllerVm.resendOTPCout+1;
                    }else{
                        regOTPATMControllerVm.resendOTPCout = regOTPATMControllerVm.resendOTPCout+1;
                        regOTPATMControllerVm.isDisabledOTPbtn = true;
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        }
}]);