'use strict';

angularApp.controller('setTemporaryPasswordController', ["$timeout", "$state", "$scope", "$translate", "$ionicPopup",
					  "accountDetailsService","utilityService","internetBankingService", "cryptoService","encryptionService","$ionicViewSwitcher",
						function ($timeout, $state, $scope, $translate, $ionicPopup, accountDetailsService, 
									utilityService, internetBankingService, cryptoService, encryptionService,$ionicViewSwitcher) {
							
	var setTemporaryPasswordVm = this;
	
	setTemporaryPasswordVm.passwordMatchFlag = true;
	setTemporaryPasswordVm.IsHiddenUserInfoPopup = true;
	
	//Show - Hide user info popup
	setTemporaryPasswordVm.showUserInfoPopup = function(){
		setTemporaryPasswordVm.IsHiddenUserInfoPopup = setTemporaryPasswordVm.IsHiddenUserInfoPopup ? false : true;
	}
	
	// Temporary passord info icon click
	setTemporaryPasswordVm.passwordInfoPopup = function() {
		var userInfoPopUp = $ionicPopup.show({
			template: '<p>Text content goes here</p>',
			title: '',
			cssClass: 'dialog',
			scope: $scope,
			buttons: [{
				text: 'OK',
				type: 'button-positive'
			}]
		});
	}

	//Reset all form fields
	setTemporaryPasswordVm.resetForm = function() {
		setTemporaryPasswordVm.passwordMatchFlag = true;
		setTemporaryPasswordVm.newTemporaryPassword = '';
		setTemporaryPasswordVm.reEnterTempPassword = '';
	}
	
	//Check wheather the new password and re-entered password match or not
	setTemporaryPasswordVm.checkPasswordMatches = function(newPassword, reEnteredPassword){
		if(newPassword !== reEnteredPassword){
			setTemporaryPasswordVm.passwordMatchFlag = false;
			return false;
		}
		setTemporaryPasswordVm.passwordMatchFlag = true;
		return true;
	}
	
	//Function for divert to Generate username, password once new password and re-entered password match.
	setTemporaryPasswordVm.confirmTemporaryPassword = function(newPassword, reEnteredPassword, form){
		if(setTemporaryPasswordVm.checkPasswordMatches(newPassword, reEnteredPassword)){
			setTemporaryPasswordVm.accounts = accountDetailsService.getDetails();
			
			var curdate = new Date();
			setTemporaryPasswordVm.timestampData = "LO"+curdate.getDay() + "" + curdate.getMonth() + "" + curdate.getFullYear() + "" +curdate.getHours() + "" + curdate.getMinutes() + "" + curdate.getSeconds();
			
			var reqParams = {};
			reqParams["cifNumber"] = setTemporaryPasswordVm.accounts.cifNumber;
			reqParams["accountNumber"] = setTemporaryPasswordVm.accounts.accountNumber;
			reqParams["branchCode"] = setTemporaryPasswordVm.accounts.branchCode;
			reqParams["countryCode"] = setTemporaryPasswordVm.accounts.country;
			reqParams["mobileNumber"] = setTemporaryPasswordVm.accounts.mobileNumber;
			reqParams["password"] = newPassword.toString();
			reqParams["transactionRights"] = '09';
			reqParams["creationMode"] = 'lotus';
			reqParams["contextName"] = 'retail';
			reqParams["referenceNo"] = setTemporaryPasswordVm.timestampData;
			
			accountDetailsService.createLotusINBUser(reqParams).then(function(data){
				var lotusUserCreatedPop = $ionicPopup.show({       
				//template: '<p>Your temporary internet user name has been sent to your registered mobile number. '+ 
				//		  'Press "OK" and enter your temporary internet username to proceed.</p>',
				template:"You have successfully set your temporary ID and password (Same has been sent on your registered mobile number through SMS)"+
					"Press OK to continue the registration process.",
				title: '',
				cssClass: 'dialog',
				scope: $scope,			
				buttons: [{
					text: 'OK',
					type: 'button-positive',
						onTap: function(e) {  
							$state.go('menu.inbLogin',{previousPage : "preHomeLoginPage"});
						}
					}]
				});
			}, function(error){
				if(error.responseCode === 'LOTUS008'){
					$ionicViewSwitcher.nextDirection('back');
					var atmCredInvalidPopUp = $ionicPopup.show({       
						template: error.responseMessage,
						title: '',
						cssClass: 'dialog',
						scope: $scope,			
						buttons: [{
							text: 'OK',
							type: 'button-positive',
							onTap: function(e) {          
								$state.go('menu.cifDetails');
							}
						}]
					});
				} else {
					utilityService.showErrorMessage(error.responseMessage);
					form.$submitted = false;
					setTemporaryPasswordVm.resetForm();
				}
			});  
		}
	}	
	
	setTemporaryPasswordVm.closeView = function(){
		$state.go('menu.selectSim');
	}
	
}]);