'use strict';

angularApp.controller('setUserNameController', ["$timeout",
	"$state",
	"$scope",
	"$translate",
	"$ionicPopup",
	"internetBankingService",
	"loggedInUserService",
	"utilityService",
	"cryptoService",
	"$rootScope",
	"encryptionService",
	function ($timeout,
		$state,
		$scope,
		$translate,
		$ionicPopup,
		internetBankingService,
		loggedInUserService,
		utilityService,
		cryptoService,
		$rootScope,
		encryptionService) {

		var setUserNameVm = this;
		setUserNameVm.passwordMatchFlag = true;
		setUserNameVm.bothPasswordMatchFlag= false;
		setUserNameVm.isUserAvailable = false;
		setUserNameVm.isTempUser = false;
		var loggedInUserDetails = loggedInUserService.getUserProfileDetails();

		//Check username availability
		setUserNameVm.checkUserAvailability = function (userName) {
			if (loggedInUserService.tempUserName.trim() == userName.trim()) {
				setUserNameVm.isTempUser = true;
			} else {
				var reqParams = {};
				reqParams["userName"] = userName.trim();
				reqParams["channel"] = 'LOTUS';
				if (userName !== undefined && userName !== '') {
					internetBankingService.checkUserAvailability(reqParams).then(function (data) {
						if (!data.isUserAvaliable) {
							utilityService.showErrorMessage(data.statusDesc);
						} else {
							setUserNameVm.isUserAvailable = true;
						}
					}, function (error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				}
			}
		};

		//Hide user available or not error messages
		setUserNameVm.hideUserAvailMessages = function () {
			setUserNameVm.isUserAvailable = false;
			setUserNameVm.isTempUser = false;
		};

		//Reset form fields
		setUserNameVm.resetForm = function () {
			setUserNameVm.userName = '';
			setUserNameVm.newPassword = '';
			setUserNameVm.confirmPassword = '';
		};

		/* Show username info popup */
		setUserNameVm.userNameInfoPopup = function () {
			var userInfoPopUp = $ionicPopup.show({
				template: '<p>Text content goes here</p>',
				title: '',
				cssClass: 'dialog',
				scope: $scope,
				buttons: [{
					text: 'OK',
					type: 'button-positive'
				}]
			});
		};

		/* Show password info popup */
		setUserNameVm.passwordInfoPopup = function () {
			var userInfoPopUp = $ionicPopup.show({
				template: '<p>Text content goes here</p>',
				title: '',
				cssClass: 'dialog',
				scope: $scope,
				buttons: [{
					text: 'OK',
					type: 'button-positive'
				}]
			});
		};
		//function to show password matches
		
		setUserNameVm.checkBothPasswordMatches = function (newPassword, reEnteredPassword) {
			if (newPassword !== reEnteredPassword) {
				setUserNameVm.bothPasswordMatchFlag = false;
				return false;
			}
			setUserNameVm.bothPasswordMatchFlag = true;
			return true;
		};
		//function to show password matches Ends

		//Check wheather the new and re-entered password match or not 
		setUserNameVm.checkPasswordMatches = function (newPassword, reEnteredPassword) {
			if (newPassword !== reEnteredPassword) {
				setUserNameVm.passwordMatchFlag = false;
				return false;
			}
			setUserNameVm.passwordMatchFlag = true;
			return true;
		};

		//Change password (i.e. Create temp to permanant user)
		setUserNameVm.goToInbLogin = function (newPassword, reEnteredPassword) {
			if (setUserNameVm.checkPasswordMatches(newPassword, reEnteredPassword) && !setUserNameVm.isTempUser) {
				var reqParams = {};
				reqParams["userName"] = setUserNameVm.userName.trim();
				reqParams["oldPassword"] = loggedInUserService.aesOldPassword.trim();
				reqParams["newPassword"] = newPassword.trim();
				reqParams["osName"] = device.platform.trim();
				reqParams["cifNo"] = loggedInUserDetails.cifNo;

				internetBankingService.createPermanantUser(reqParams).then(function (data) {
					loggedInUserService.aesOldPassword = '';
					var mpinUserPopUp = $ionicPopup.show({
						template: '<img src="img/mf/bg-approved.svg" alt="Success Screen"><h2> Congratulations!</h2> <p>You have successfully registered for Internet Banking.</p>',
						title: '',
						cssClass: 'dialog',
						scope: $scope,
						buttons: [{
							text: 'OK',
							type: 'button-positive',
							onTap: function (e) {
								loggedInUserService.logoutUser();
							}
						}]
					});
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}
		};

		setUserNameVm.closeView = function () {
			$state.go('menu.selectSim');
		};

	}]);