'use strict';
angularApp.controller('bhimUpiPaymentsController', [
	"$state",
	"$ionicPopup",
	"$scope",
	"ionicToast",
	"customerInfoService",
	"utilityService",
	"constantConfig",
	"loggedInUserService",
	"validationService",
	"bhimUpiService",
	function ($state, $ionicPopup, $scope, ionicToast, customerInfoService, utilityService, constantConfig, loggedInUserService, validationService, bhimUpiService) {

		var bhimUpiPaymentsVm = this;

		bhimUpiPaymentsVm.tabClicked = function (id) {
			if (id == '1') {
				bhimUpiPaymentsVm.tabIndex = "one";
				bhimUpiService.tabIndex = bhimUpiPaymentsVm.tabIndex;
			} else if (id == '2') {
				bhimUpiPaymentsVm.tabIndex = "two";
				bhimUpiPaymentsVm.tabIndex = bhimUpiService.tabIndex;
				if (device.platform.toLowerCase() == 'android') {
					bhimUpiService.getNativeData("getcontactpermission", {}).then(function (data) {
						if (data.contactpermission === 'Allowed') {
							bhimUpiService.getNativeData("openContacts", {}).then(function (data) {
								var contact = data;
								if (contact && contact.number) {
									var x = contact.number.replace(/\s/g, '');
									if (x.length >= 10) {
										bhimUpiPaymentsVm.vpa = x.substr(x.length - 10) + "@sbi";
									} else {
										return false;
										utilityService.showBhimUpiAlert("alert", 'Please select valid mobile number');
									}
								} else {
									return false;
									utilityService.showBhimUpiAlert("alert", 'Please select valid mobile number');
								}
								utilityService.showSpinner();
								var json = JSON.stringify({
									"addInfo": {
										"addInfo10": constantConfig.upiConstant.addInfo10,
										"addInfo9": constantConfig.upiConstant.addInfo9
									},
									"payeeType": {
										"virtualAddress": bhimUpiPaymentsVm.vpa
									},
									"requestInfo": {
										"pspId": constantConfig.upiConstant.pspId,
										"pspRefNo": generateRandomString(27)
									},
									"vAReqType": constantConfig.upiConstant.vAReqType_T
								});
								bhimUpiService.getNativeData(constantConfig.upiConstant.checkVirtualAddressAPI, json).then(function (data) {
									var checkVpaResponse = JSON.parse(data);
									if (checkVpaResponse.status == 'VE') {
										customerInfoService.payeeDetails = {
											payeeType: "VA",
											requestType: 'pay',
											accountNo: "",
											ifsc: "",
											name: checkVpaResponse.payeeType.name || "",
											vpa: checkVpaResponse.payeeType.virtualAddress || "",
											amount: "",
											remark: "",
											nickName: "",
											phoneNumber: "",
											savePayee: false
										}
										bhimUpiPaymentsVm.getProfile();
									} else {
										utilityService.hideSpinner();
										utilityService.showBhimUpiAlert("error", checkVpaResponse.statusDesc);
									}
								}, function (msg) {
									utilityService.hideSpinner();
									utilityService.showBhimUpiAlert("error", msg);
								});
							}, function (msg) {
								utilityService.hideSpinner();
								utilityService.showBhimUpiAlert("error", msg);
							});
						} else {
							utilityService.hideSpinner();
							ionicToast.show("Contact permission denied. Please allow to proceed", 'bottom', false, 3000);
						}
					}, function (msg) {
						utilityService.hideSpinner();
						utilityService.showBhimUpiAlert("error", msg);
					});
				} else {
					bhimUpiService.getNativeData("openContacts", {}).then(function (data) {
						var contact = data;
						if (contact) {
							var x = contact.replace(/\s/g, '');
							if (x.length >= 10) {
								bhimUpiPaymentsVm.vpa = x.substr(x.length - 10) + "@sbi";
							} else {
								return false;
								utilityService.showBhimUpiAlert("alert", 'Please select valid mobile number');
							}
						} else {
							return false;
							utilityService.showBhimUpiAlert("alert", 'Please select valid mobile number');
						}
						utilityService.showSpinner();
						var json = JSON.stringify({
							"addInfo": {
								"addInfo10": constantConfig.upiConstant.addInfo10,
								"addInfo9": constantConfig.upiConstant.addInfo9
							},
							"payeeType": {
								"virtualAddress": bhimUpiPaymentsVm.vpa
							},
							"requestInfo": {
								"pspId": constantConfig.upiConstant.pspId,
								"pspRefNo": generateRandomString(27)
							},
							"vAReqType": constantConfig.upiConstant.vAReqType_T
						});
						bhimUpiService.getNativeData(constantConfig.upiConstant.checkVirtualAddressAPI, json).then(function (data) {
							var checkVpaResponse = JSON.parse(data);
							if (checkVpaResponse.status == 'VE') {
								customerInfoService.payeeDetails = {
									payeeType: "VA",
									requestType: 'pay',
									accountNo: "",
									ifsc: "",
									name: checkVpaResponse.payeeType.name || "",
									vpa: checkVpaResponse.payeeType.virtualAddress || "",
									amount: "",
									remark: "",
									nickName: "",
									phoneNumber: "",
									savePayee: false
								}
								bhimUpiPaymentsVm.getProfile();
							} else {
								utilityService.hideSpinner();
								utilityService.showBhimUpiAlert("error", checkVpaResponse.statusDesc);
							}
						}, function (msg) {
							utilityService.hideSpinner();
							utilityService.showBhimUpiAlert("error", msg);
						});
					}, function (msg) {
						utilityService.hideSpinner();
						utilityService.showBhimUpiAlert("error", msg);
					});
				}
			} else if (id == '3') {
				bhimUpiPaymentsVm.tabIndex = "three";
				bhimUpiService.tabIndex = bhimUpiPaymentsVm.tabIndex;
			}
		}

		bhimUpiPaymentsVm.payNewBeneficiary = function (contact) {
			if (bhimUpiPaymentsVm.tabIndex == "one") {
				if (!bhimUpiPaymentsVm.payeeUpi) {
					utilityService.showBhimUpiAlert("alert", "Please Enter Payee UPI Id");
					return false;
				}

				utilityService.showSpinner();
				var json = JSON.stringify({
					"addInfo": {
						"addInfo10": constantConfig.upiConstant.addInfo10,
						"addInfo9": constantConfig.upiConstant.addInfo9
					},
					"payeeType": {
						"virtualAddress": bhimUpiPaymentsVm.payeeUpi.toString()
					},
					"requestInfo": {
						"pspId": constantConfig.upiConstant.pspId,
						"pspRefNo": generateRandomString(27)
					},
					"vAReqType": constantConfig.upiConstant.vAReqType_T
				});
				bhimUpiService.getNativeData(constantConfig.upiConstant.checkVirtualAddressAPI, json).then(function (data) {
					var checkVpaResponse = JSON.parse(data);
					if (checkVpaResponse.status == 'VE') {
						customerInfoService.payeeDetails = {
							payeeType: "VA",
							requestType: 'pay',
							accountNo: "",
							ifsc: "",
							name: checkVpaResponse.payeeType.name || "",
							vpa: checkVpaResponse.payeeType.virtualAddress || "",
							amount: "",
							remark: "",
							nickName: "",
							phoneNumber: "",
							savePayee: false
						}
						bhimUpiPaymentsVm.getProfile();
					} else {
						utilityService.hideSpinner();
						utilityService.showBhimUpiAlert("error", checkVpaResponse.statusDesc);
					}
				}, function (msg) {
					utilityService.hideSpinner();
					bhimUpiPaymentsVm.showVpaErrorMessage(msg);
				});
			}
			if (bhimUpiPaymentsVm.tabIndex == "two") {

			}
			if (bhimUpiPaymentsVm.tabIndex == "three") {
				if (!(bhimUpiPaymentsVm.ifsc && bhimUpiPaymentsVm.isValidIfscFormat)) {
					utilityService.showBhimUpiAlert("alert", "Please Enter Valid IFSC");
					return false;
				}
				if (bhimUpiPaymentsVm.accountNumber) {
					if (bhimUpiPaymentsVm.accountNumber !== bhimUpiPaymentsVm.confirmAccountNumber) {
						utilityService.showBhimUpiAlert("alert", "Account Number and Confirm Account Number should Be Same");
						return false;
					}
				} else {
					utilityService.showBhimUpiAlert("alert", "Please Enter Account Number");
					return false;
				}
				if (!bhimUpiPaymentsVm.payeeName) {
					utilityService.showBhimUpiAlert("alert", "Please Enter Beneficiary Name");
					return false;
				}
				bhimUpiPaymentsVm.getProfileForAcc();
			}
		}

		bhimUpiPaymentsVm.getProfileForAcc = function () {
			utilityService.showSpinner();
			var json = JSON.stringify({
				"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"updateFlag": constantConfig.upiConstant.updateFlag
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.getProfile, json).then(function (data) {
				utilityService.hideSpinner();
				var getProfileResponse = JSON.parse(data);
				if (getProfileResponse.status == "S") {
					customerInfoService.payerProfileDtls = getProfileResponse;
					loggedInUserService.productClicked = 'menu.payToVpa_PayeeDetails';
					customerInfoService.payeeDetails = {
						payeeType: "AC",
						requestType: 'pay',
						accountNo: bhimUpiPaymentsVm.accountNumber,
						ifsc: bhimUpiPaymentsVm.ifsc,
						name: bhimUpiPaymentsVm.payeeName,
						vpa: "",
						amount: "",
						remark: "",
						nickName: "",
						phoneNumber: "",
						savePayee: false
					}
					$state.go('menu.userLogin');
				} else {
					utilityService.showBhimUpiAlert("error", getProfileResponse.statusDesc);
				}
			}, function (msg) {
				utilityService.hideSpinner();
				bhimUpiPaymentsVm.showVpaErrorMessage(msg);
			});
		}

		bhimUpiPaymentsVm.getProfile = function () {
			utilityService.showSpinner();
			var json = JSON.stringify({
				"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"updateFlag": constantConfig.upiConstant.updateFlag
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.getProfile, json).then(function (data) {
				utilityService.hideSpinner();
				var getProfileResponse = JSON.parse(data);
				if (getProfileResponse.status == "S") {
					customerInfoService.payerProfileDtls = getProfileResponse;
					loggedInUserService.productClicked = 'menu.payToVpa_PayeeDetails';
					$state.go('menu.userLogin');
				} else {
					utilityService.showBhimUpiAlert("error", getProfileResponse.statusDesc);
				}
			}, function (msg) {
				utilityService.hideSpinner();
				bhimUpiPaymentsVm.showVpaErrorMessage(msg);
			});
		}

		bhimUpiPaymentsVm.validateIfsc = function () {
			if (!utilityService.isEmpty(bhimUpiPaymentsVm.ifsc)) {
				bhimUpiPaymentsVm.isValidIfscFormat = validationService.isValidIFSC(bhimUpiPaymentsVm.ifsc);
			}
		}

		bhimUpiPaymentsVm.goBack = function () {
			$state.go('menu.userLogin');
		}

		bhimUpiPaymentsVm.showVpaErrorMessage = function (errorCode) {
			switch (errorCode) {
				case -1: utilityService.showErrorMessage(constantConfig.upiConstant.minusOne);
					break;

				case -2: utilityService.showErrorMessage(constantConfig.upiConstant.minusTwo);
					break;

				case -3: utilityService.showErrorMessage(constantConfig.upiConstant.minusThree);
					break;

				case -4: utilityService.showErrorMessage(constantConfig.upiConstant.minusFour);
					break;

				case -5: utilityService.showErrorMessage(constantConfig.upiConstant.minusFive);
					break;

				case -6: utilityService.showErrorMessage(constantConfig.upiConstant.minusSix);
					break;

				case -7: utilityService.showErrorMessage(constantConfig.upiConstant.minusSeven);
					break;

				default: utilityService.showErrorMessage(constantConfig.upiConstant.someWentWrong);
			}
		};

		$scope.$on('$ionicView.beforeEnter', function () {
			bhimUpiPaymentsVm.tabIndex = "one";
			bhimUpiService.tabIndex = bhimUpiPaymentsVm.tabIndex;
		});

		return this;
	}
]);
