'use strict';
angularApp.controller('inbLoginController', ["$timeout", "$state", "$scope", "$translate", "internetBankingService",
	"utilityService", "$ionicPopup", "cryptoService", "ConnectivityMonitorUtils", "loggedInUserService", "$rootScope", "$ionicSideMenuDelegate", "encryptionService", "$stateParams", "mPinLoginService", "constantConfig", "getOTPService", "AdapterUtils", "clickStreamService","$filter","$ionicViewSwitcher",
	"registerWithSimService",
	function ($timeout, $state, $scope, $translate, internetBankingService,
		utilityService, $ionicPopup, cryptoService, ConnectivityMonitorUtils, loggedInUserService, $rootScope, $ionicSideMenuDelegate, encryptionService, $stateParams, mPinLoginService, constantConfig, getOTPService, AdapterUtils, clickStreamService,$filter,$ionicViewSwitcher,
			  registerWithSimService) {

		var inbLoginVm = this;
		inbLoginVm.isChallenged = false;
		inbLoginVm.securityCheckName = "AuthenticateMPinSecurityCheck";
		inbLoginVm.mPinAuthChallengeHandler = WL.Client.createSecurityCheckChallengeHandler(inbLoginVm.securityCheckName);
		inbLoginVm.mPinAuthChallengeHandler.securityCheckName = inbLoginVm.securityCheckName;
		inbLoginVm.inbUserName = "";
		inbLoginVm.inbPassword = "";
		var previousScreen = $stateParams.previousPage;
		loggedInUserService.previousJourney = $stateParams.previousPage;
		inbLoginVm.invalidReferralCode = false;

		inbLoginVm.keystoreValue = loggedInUserService.keystoreValue;
		$scope.err = '';
		//user validation
		inbLoginVm.userValidate = function (formName) {
			inbLoginVm.submitted = true;
			var pattern = /^[16789]\d{9}$/;
			if (inbLoginVm.referralMobNo && pattern.test(inbLoginVm.referralMobNo)) {
				/*condition for Login improvements*/
				if (loggedInUserService.isServerConnected) {
					inbLoginVm.validateCustomerFun();
				} else {
					connectServer();
				}
			} else if (inbLoginVm.referralMobNo && !pattern.test(inbLoginVm.referralMobNo)) {
				inbLoginVm.invalidReferralCode = true;
			} else {
				/*condition for Login improvements*/
				if (loggedInUserService.isServerConnected) {
					inbLoginVm.validateCustomerFun();
				} else {
					connectServer();
				}
			}
		};

		//Function for set referral Mobile Number
		inbLoginVm.setReferralMobNo = function (user_mob_no, ref_mob_no) {
			var requestParams = {
				"mobileNo": user_mob_no,
				"referralMobNo": ref_mob_no,
				"journeyName": "PRE HOME LOGIN"
			}
			getOTPService.setReferralMobNo(requestParams).then(function (response) {
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		};

		//Username info popup
		inbLoginVm.openUserNameInfoPopup = function () {
			var userInfoPopUp = $ionicPopup.show({
				template: '<p>Please use your internet banking credentials to register.' +
					'<br> If you have a temporary user name and password, please enter here to proceed for registration.</p>',
				title: '',
				cssClass: 'dialog',
				scope: $scope,
				buttons: [{
					text: 'OK',
					type: 'button-positive'
				}]
			});
		};
		/*Referral info popup starts */
		inbLoginVm.openReferralInfoPopup = function () {
			var userInfoPopUp = $ionicPopup.show({
				template: '<p>Enter a valid 10 digit mobile number starting with 1, 6, 7, 8 & 9 only.' +
					'<br> (For customer the mobile number entered should be available in core banking system. For Staff, Mobile Number entered should be the same as updated in HRMS)</p>',
				title: '',
				cssClass: 'dialog',
				scope: $scope,
				buttons: [{
					text: 'OK',
					type: 'button-positive'
				}]
			});
		};
		/*Referral info popup starts */
		//Internet Banking login
		inbLoginVm.validateCustomerFun = function () {
			if (inbLoginVm.inbUserName && inbLoginVm.inbPassword) {
				inbLoginVm.submitted = false;
				utilityService.showSpinner();
				internetBankingService.getServiceIdAndKey().then(function (data) {
					loggedInUserService.keyIdINB = data.keyId;
					loggedInUserService.serviceIdINB = data.serviceId;
					loggedInUserService.finalSHA512Val = loggedInUserService.generateINBSHA512Val(inbLoginVm.inbUserName, inbLoginVm.inbPassword);
					if (utilityService.isAndroidPlatform() && registerWithSimService.isSimLogin) {
						utilityService.showSpinner();
						readSimcardInfo();
					}
					else inbLoginVm.userloginStart();
				}, function (error) {
					inbLoginVm.inbUserName = "";
					inbLoginVm.inbPassword = "";
					inbLoginVm.referralMobNo = "";
					utilityService.hideSpinner();
					if (error.responseMessage) {
						utilityService.showErrorMessage(error.responseMessage);
					} else {
						utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
					}
				});
			}
		}

		inbLoginVm.userloginStart = function () {
			inbLoginVm.mPinAuthChallengeHandler.handleChallenge = function (challenge) {
				inbLoginVm.isChallenged = true;
				inbLoginVm.inbUserName = "";
				inbLoginVm.inbPassword = "";
				inbLoginVm.referralMobNo = "";
				utilityService.accessRestricted = "";
				utilityService.hideSpinner();
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "SUBMIT_BTN"));
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "LOGIN_FAILURE"));
				internetBankingService.errorMsgs = challenge;
				$ionicViewSwitcher.nextDirection('forward');
				inbLoginVm.mPinAuthChallengeHandler.cancel();
				$state.go('menu.setMPINOTP', {mpin:"", simInfo:""});
				// if (challenge.errorCode == "LOCK.001" || challenge.errorCode == "M003") {
				// 	utilityService.showErrorMessage(constantConfig.adapter.USER_ID_BLOCKED);
				// }
				// else if (challenge.errorMsg !== null) {
				// 	utilityService.showErrorMessage(utilityService.getServerExceptionMessage(challenge));
				// } else {
				// 	utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
				// }
			};

			inbLoginVm.mPinAuthChallengeHandler.handleSuccess = function (data) {
				inbLoginVm.isChallenged = false;
				if (data.user) {
					loggedInUserService.keyId = AdapterUtils.secretData == "" ? data.user.attributes.keyId : encryptionService.getAES256DecryptedData(data.user.attributes.keyId);
					loggedInUserService.tokenLotus = AdapterUtils.secretData == "" ? data.user.attributes.lotusToken : encryptionService.getAES256DecryptedData(data.user.attributes.lotusToken);
					var userDetails = AdapterUtils.secretData == "" ? data.user.attributes.userDetails : encryptionService.getAES256DecryptedData(data.user.attributes.userDetails);
					if(data.user.attributes.sessionId && data.user.attributes.lotusId){
						clickStreamService.sessionId = AdapterUtils.secretData == "" ? data.user.attributes.sessionId : encryptionService.getAES256DecryptedData(data.user.attributes.sessionId);
						clickStreamService.lotusId = AdapterUtils.secretData == "" ? data.user.attributes.lotusId : encryptionService.getAES256DecryptedData(data.user.attributes.lotusId);
					}
					internetBankingService.errorMsgs = "";
					loggedInUserService.setUserProfileDetails(JSON.parse(userDetails));
				}
			};

			inbLoginVm.mPinAuthChallengeHandler.handleFailure = function (error) {
				inbLoginVm.mPinAuthChallengeHandler.cancel();
				inbLoginVm.isChallenged = false;
				inbLoginVm.inbUserName = "";
				inbLoginVm.inbPassword = "";
				inbLoginVm.referralMobNo = "";
				utilityService.accessRestricted = "";
				utilityService.hideSpinner();
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "SUBMIT_BTN_MOB"));
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "LOGIN_FAILURE_MOB"));
				internetBankingService.errorMsgs = error;
				inbLoginVm.mPinAuthChallengeHandler.cancel();
				if (error.errorCode == "INVALID_REQUEST" || error.errorCode == "invalid_client") {
					loggedInUserService.setMFPUrl(false);
					return;
				}
				$ionicViewSwitcher.nextDirection('forward');
				$state.go('menu.setMPINOTP', {mpin:"", simInfo:""});
				// if (error.failure) {
				// 	utilityService.showErrorMessage(error.failure);
				// } else {
				// 	utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
				// }
			}

			var payload = {};
			var hashedSimInfo = "";
			if (utilityService.isAndroidPlatform()) {
				hashedSimInfo = registerWithSimService.isSimLogin ? inbLoginVm.hashedSimInfo : '';
			}
			var requestParams = {
				"userName": inbLoginVm.inbUserName,
				"sha512Password": loggedInUserService.finalSHA512Val,
				"bankCode": "0",
				"osName": device.platform,
				"channel": "lotus",
				"serviceId": loggedInUserService.serviceIdINB,
				"referralMobNo": inbLoginVm.referralMobNo ? inbLoginVm.referralMobNo : "",
				"mfDeviceId": loggedInUserService.deviceIdForMpin,
				"id": loggedInUserService.deviceInfo,
				"isRegister": "true",
				"simId": hashedSimInfo.toString()
			}

			var src = cryptoService.encryptRSAWithPublicKey(encryptionService.iv + "^" + encryptionService.passphrase + "^" + encryptionService.salt, cryptoService.rsaPublicKey);
			payload = {
				"data": AdapterUtils.secretData + encryptionService.getAES256EncryptedData(JSON.stringify(requestParams)),
				"src": src
			}

			payload = AdapterUtils.secretData == "" ? requestParams : payload;
			if (inbLoginVm.isChallenged) {
				inbLoginVm.mPinAuthChallengeHandler.submitChallengeAnswer(payload);
			} else {
				WLAuthorizationManager.login(inbLoginVm.mPinAuthChallengeHandler.securityCheckName, payload).then(
					function (data) {
						utilityService.accessRestricted = utilityService.mPinAuthRequire;
						// Checking wheather user is Temporary or Permanant
						//if (loggedInUserService.userProfile.loginCount !== '0') {
							//if (loggedInUserService.userProfile.profilePasswordSetFlag == 'true') {
								$ionicViewSwitcher.nextDirection('forward');
								$state.go('menu.setMPINOTP', {mpin:""});
							//} else {
							//	$state.go('menu.setProfilePassword');
							//}
						// } else {
						// 	loggedInUserService.tempUserName = inbLoginVm.inbUserName;
						// 	$state.go('menu.setUserName');
						// }
						internetBankingService.errorMsgs = "";
						utilityService.hideSpinner();
						clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "SUBMIT_BTN_MOB"));
						clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "LOGIN_SUCCESS_MOB"));
					},
					function (error) {
						inbLoginVm.inbUserName = "";
						inbLoginVm.inbPassword = "";
						inbLoginVm.referralMobNo = "";
						utilityService.accessRestricted = "";
						utilityService.hideSpinner();
						if (error.errorCode == 'CHALLENGE_HANDLING_CANCELED' || error.errorCode == 'APPLICATION_DISABLED') {
							return;
						}
						if (error.errorCode == "LOGIN_ALREADY_IN_PROCESS") {
							inbLoginVm.mPinAuthChallengeHandler.cancel();
						}
						internetBankingService.errorMsgs = error;
						clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "SUBMIT_BTN_MOB"));
						clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "LOGIN_FAILURE_MOB"));
						if (error.errorCode == "INVALID_REQUEST" || error.errorCode == "invalid_client") {
							loggedInUserService.setMFPUrl(false);
							return;
						}
						$ionicViewSwitcher.nextDirection('forward');
						$state.go('menu.setMPINOTP', {mpin:"", simInfo:""});
						//utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
					});
			}
		}

		//Popup for having problem in login
		inbLoginVm.showHavingProblemPopup = function () {
			var havingPrblmPopUp = $ionicPopup.show({
				template: '<p>Please visit <a href="#" class="decornone txt-blue">onlinesbi.com</a> ' +
					'or contact your nearest branch or call us at <br>1800 11 2211 <br> 1800 425 3800</p>',
				title: '',
				cssClass: 'dialog',
				scope: $scope,
				buttons: [{
					text: 'OK',
					type: 'button-positive'
				}]
			});
		};
		/* Login flow imrpovements */
		inbLoginVm.serverConnectErrorPopup = function () {
			inbLoginVm.inbUserName = "";
			inbLoginVm.inbPassword = "";
			inbLoginVm.referralMobNo = "";
			utilityService.hideSpinner();
			utilityService.showErrorMessage($scope.err);
		};

		function connectServer() {
			try {
				var payload = {
					"data": cryptoService.encryptRSAWithPublicKey(encryptionService.iv + "^" + encryptionService.passphrase + "^" + encryptionService.salt, cryptoService.rsaPublicKey),
					"src": inbLoginVm.keystoreValue != "" ? cryptoService.encryptRSAWithPublicKey(inbLoginVm.keystoreValue, cryptoService.rsaPublicKey) : "",
				};
				inbLoginVm.submitted = false;
				utilityService.showSpinner();
				var resourceRequest = new WLResourceRequest("adapters/CustomSessionAdapter/saveCustomInformation", WLResourceRequest.POST, { timeout: 15000 });
				resourceRequest.send(payload).then(function (response) {
					utilityService.lastTimeStamp = new Date();
					response.responseText = utilityService.isJSON(response.responseText) ? JSON.parse(response.responseText) : JSON.parse(encryptionService.getAES256DecryptedData(response.responseText));
					if (response.responseText.responseCode == '0000') {
						AdapterUtils.secretData = response.responseText.data.key;
						loggedInUserService.keyId = response.responseText.data.keyId;
						loggedInUserService.deviceIdForMpin = response.responseText.data.deviceId;
						loggedInUserService.upiPermissionKey = response.responseText.data.upiPermissionVal;
						loggedInUserService.billDeskUrl = response.responseText.data.billDeskUrl;
						loggedInUserService.sbiCollectUrl = response.responseText.data.sbiCollectUrl;
						utilityService.getUPIPermissions(loggedInUserService.upiPermissionKey);
						loggedInUserService.isServerConnected = true;
						utilityService.hideSpinner();
						inbLoginVm.validateCustomerFun();
					} else if (response.responseText.responseCode == '0001') {
						$scope.err = response.responseText.responseCode + " : " + constantConfig.adapter.CANNOT_PROCESS_NOW;
						loggedInUserService.isServerConnected = false;
						inbLoginVm.serverConnectErrorPopup();
						return;
					} else if (response.responseText.responseCode == '0002') {
						$scope.err = response.responseText.responseCode + " : " + constantConfig.adapter.CANNOT_PROCESS_NOW;
						loggedInUserService.isServerConnected = false;
						inbLoginVm.serverConnectErrorPopup();
						return;
					} else if (response.responseText.responseCode == '0003' || response.responseText.responseCode == '0004') {
						$scope.err = response.responseText.responseCode + " : " + response.responseText.responseMessage;
						loggedInUserService.isServerConnected = false;
						inbLoginVm.serverConnectErrorPopup();
						return;
					}
				}, function (error) {
					if (error.errorCode == 'APPLICATION_DOES_NOT_EXIST') {
							$scope.err = error;
							inbLoginVm.inbUserName = "";
							inbLoginVm.inbPassword = "";
							inbLoginVm.referralMobNo = "";
							utilityService.hideSpinner();
							utilityService.showUpgradeMessage($scope.err);
						} else {
							$scope.err = utilityService.getServerExceptionMessage(error);
							inbLoginVm.serverConnectErrorPopup();
						}
					loggedInUserService.isServerConnected = false;
					
				});
			} catch (err) {
				$scope.err = constantConfig.adapter.SOMETHING_WENT_WRONG;
				loggedInUserService.isServerConnected = false;
				inbLoginVm.serverConnectErrorPopup();
			}
		}
		/* End of Login flow imrpovements */

		inbLoginVm.goToBack = function () {
			if (previousScreen == "openNewDigitalAccountPage") {
				$state.go('menu.openNewDigitalAccount');
			} else {
				$state.go('menu.userLogin');
			}
		};

		inbLoginVm.closeView = function () {
			if (previousScreen == "openNewDigitalAccountPage") {
				$state.go('menu.openNewDigitalAccount');
			} else {
				$state.go('menu.userLogin');
			}
		};

		//one time initialization to be done when the controller is loaded
		$scope.$on('$ionicView.loaded', function () {
			$ionicSideMenuDelegate.canDragContent(false)
		});

		//actions to done everytime the view is shown
		$scope.$on('$ionicView.beforeEnter', function () {
			mPinLoginService.isSetMPIN == true ? mPinLoginService.isSetMPIN : false;
			inbLoginVm.isSimChanged = false;
			$ionicSideMenuDelegate.canDragContent(false);
		});
		function readSimcardInfo() {
			/*Sim card Info fetching - Start*/
			function simInfosuccessCallback(result) {
				utilityService.hideSpinner();
				var str = "";
				inbLoginVm.isSimChanged = false;
				if(result.cards && result.cards.length > 0)
				{
					inbLoginVm.simList = result.cards;
					var isAccountExists = -1;
					inbLoginVm.simList.some(function (obj, i) {
						return obj.subscriptionId == registerWithSimService.simSubscriptionId ? isAccountExists = i : false;
					});
					if (isAccountExists !== -1) {
						str = device.uuid + registerWithSimService.simSubscriptionId;
						inbLoginVm.simSubscriptionId = registerWithSimService.simSubscriptionId;
						inbLoginVm.hashedSimInfo = cryptoService.getSHA512EncryptedData(str);
						inbLoginVm.userloginStart();
					}
					else{
						//either sim card is removed or slot changed or subscription id changed due to sim changes
						inbLoginVm.isSimChanged = true;
						str = device.uuid + "";
						inbLoginVm.simSubscriptionId = "";
						inbLoginVm.hashedSimInfo = cryptoService.getSHA512EncryptedData(str);
					}

				}
					if (inbLoginVm.isSimChanged) {
						registerWithSimService.reloadAppSimOk(registerWithSimService.changedSimMsg);
					}
					else if (inbLoginVm.simList == undefined || inbLoginVm.simList.length == 0)
						utilityService.showBhimUpiAlert("alert", registerWithSimService.noSimMsg);

				$scope.$apply();
			}

			function HasPerminionSuccessCallback(result) {
				if (result) {
					window.plugins.sim.getSimInfo(simInfosuccessCallback, errorCallback);
				} else {
					requestReadPermission();
				}
			}

			function errorCallback(error) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("Permission denied.");
			}

			function requestSuccessCallback(result) {
				if (result) {
					hasReadPermission();
				}
			}
			// Android only: check permission
			function hasReadPermission() {
				window.plugins.sim.hasReadPermission(HasPerminionSuccessCallback, errorCallback);
			}
			// Android only: request permission
			function requestReadPermission() {
				window.plugins.sim.requestReadPermission(requestSuccessCallback, errorCallback);
			}
			hasReadPermission();
			/*Sim card Info fetching - End*/
		}
		//any cleanup needs to be done here: executes everytime when page is left
		$scope.$on('$ionicView.afterLeave', function () {
			$ionicSideMenuDelegate.canDragContent(false)
		});

		$scope.$on('$ionicView.beforeLeave', function () {
			
		});



	}]);
