
angularApp.service('internetBankingService',
	function($q, $http, AdapterUtils, utilityService, loggedInUserService, mPinLoginService, regProcessWithAccNoService, $state, $ionicPopup, registerWithSimService){
		var internetBankingService =this;
		internetBankingService.bannerDetails = {};
		internetBankingService.banners = {
			"landing": [],
			"login": []
		};
		internetBankingService.errorMsgs = "";
		internetBankingService.findOutMoreUrl = "";
		//Check device on App launch
		internetBankingService.checkDevicePrint = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreHomeLoginAdapter/checkDevicePrint", reqParams, true).then(function (response) {
				q.resolve(response);
			},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		//Get service ID and service Key(i.e.Blank call)
		internetBankingService.getServiceIdAndKey = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreHomeLoginAdapter/getServiceIdAndSecreteKey", {}, false).then(function (response) {
				q.resolve(response.data);
			},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		//Validate user thru username And Password
		internetBankingService.validateUser = function (requestData) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreHomeLoginAdapter/authenticateLogin", requestData, true).then(function (response) {
				q.resolve(response.data);
			},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		//Get user details
		internetBankingService.getUserDetails = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreHomeLoginAdapter/getUserDetails", {}, false).then(function (response) {
				q.resolve(response);
			},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		}

		//Validate user through mpin
		internetBankingService.validateUserThruMpin = function (requestData) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreHomeLoginAdapter/validateUserThruMpin", requestData, true).then(function (response) {
				q.resolve(response.data);
			},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		//Change password (i.e Create permanant credentials from temp. user)
		internetBankingService.createPermanantUser = function (requestData) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreHomeLoginAdapter/changeLoginPassword", requestData, true).then(function (response) {
				q.resolve(response.data);
			},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		//Set new INB username and password (i.e. createInbUser - set permanant user)
		internetBankingService.createINBUser = function (requestData) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreHomeLoginAdapter/createInBUser", requestData, true).then(function (response) {
				q.resolve(response.data);
			},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		//Check User Availability
		internetBankingService.checkUserAvailability = function (requestData) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreHomeLoginAdapter/checkUserAvailability", requestData, true).then(function (response) {
				q.resolve(response.data);
			},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		}

		//Get Security questions
		internetBankingService.getSecurityQuestions = function (requestData) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreHomeLoginAdapter/getSecurityQuestions", requestData, true).then(function (response) {
				q.resolve(response.payLoad.securityQuestions.data);
			},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		//Set security Questions
		internetBankingService.createUserProfile = function (requestData) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreHomeLoginAdapter/createUserProfile", requestData, true).then(function (response) {
				q.resolve(response.data);
			},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		//Get user details for Mpin validations(i.e. MPIN policies)
		internetBankingService.getUserDetailsForMpin = function (requestData) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreHomeLoginAdapter/checkUserDetails", requestData, true).then(function (response) {
				q.resolve(response);
			},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		//Generate OTP
		internetBankingService.generateOTP = function (requestData) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/OTPAdapter/getOTPTokenSecure", requestData, false).then(function (response) {
				q.resolve(response.data);
			},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		//Validate OTP
		internetBankingService.validateOTP = function (requestData) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/OTPAdapter/validateOTPTokenSecure", requestData, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		internetBankingService.validateOTPRegister = function(requestData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/OTPAdapter/validateOTPTokenSecureRegister",requestData,true).then(
			function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}); 
			return q.promise;
		};
		
		//Set MPIN
		internetBankingService.setMPIN = function (requestData) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreHomeLoginAdapter/setMPin", requestData, true).then(function (response) {
				q.resolve(response);
			},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		//Get Mpin Consent data from WCM
		internetBankingService.getMpinConsentData = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/CommonAdapter/getTnC", reqParams, true).then(function (response) {
				q.resolve(response);
			},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		//Get Mpin Terms & Conditions from WCM
		internetBankingService.getTermsCondition = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/CommonAdapter/getTnC", reqParams, true).then(function (response) {
				q.resolve(response);
			},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};
		// Forgot Login Password
		internetBankingService.fetchDetailsByDeviceID = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/fetchDetailsByDeviceID", reqParams, true).then(function (response) {
				q.resolve(response);
			},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		internetBankingService.checkSession = function () {
			if(!loggedInUserService.isFirstLogin) {
				loggedInUserService.manageLocalData('', "YONOLocalStorageData.json", false, 'read').then(function (res) {
					loggedInUserService.isFirstLogin = res.isFirstLogin;
					console.log("loggedInUserService.isFirstLogin: ",loggedInUserService.isFirstLogin);
				}, function (e) {
				});
			}
			var q = $q.defer();
			AdapterUtils.postData("adapters/CommonAdapter/checkSession", {}, false).then(
				function (response) {
					q.resolve(response);
				}, function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		internetBankingService.getLoginPageBanner = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/HomeAdapter/getLogInPageBanner", {}, false).then(function (response) {
				q.resolve(response);
			},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		internetBankingService.preHomeBanners = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/HomeAdapter/preHomeBanners", {}, false).then(function (response) {
				q.resolve(response);
			},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		internetBankingService.otpForYonoRegistration = function (requestData) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreHomeLoginAdapter/generateOTPForYonoRegistration", requestData, false).then(function (response) {
				q.resolve(response);
			},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		internetBankingService.generateOTPYONORegistration = function (requestData) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/OTPAdapter/generateOVDOTPCommonRequest", requestData, false).then(function (response) {
				q.resolve(response.data);
			},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		internetBankingService.validateOTPYONORegistration = function (requestData) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/OTPAdapter/validateOTPTokenOVD", requestData, true).then(function (response) {
				q.resolve(response.data);
			},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		internetBankingService.verifySecKey = function (secKey) {
			return ((secKey / 2) - 1) / 99;
		}

		internetBankingService.comCodeForYONORegistration = function (aesHashedMpin, aesHashedSimInfo) {
				var customerdetails;
			var requestParams = {};
			var requestSecKey = '';
			var requestDate = new Date();
			requestDate = requestDate.getTime();
			requestSecKey = Math.floor((Math.random()) + requestDate);
			requestSecKey = (requestSecKey * 10 + 1);
			requestParams.secKey = requestSecKey;
			if (internetBankingService.mpinConsent) {
				requestParams["id"] = loggedInUserService.deviceInfo;
				requestParams["mpin"] = aesHashedMpin.toString();
				requestParams["simId"] = aesHashedSimInfo.toString();
				

				internetBankingService.setMPIN(requestParams).then(function (data) {
                    if(data.responseCode == "0000"){
                        var finalcalculatedKey = internetBankingService.verifySecKey(parseInt(data.secKey));
                        if (requestSecKey == finalcalculatedKey) {
                             customerdetails = loggedInUserService.getUserProfileDetails();

                            loggedInUserService.fileForStorageData('{"isDeviceRegistered":true,"mpinConsent":true,"customername": "' + customerdetails.customerName + '", "simSubscriptionId": "'+ registerWithSimService.simSubscriptionId +'"}').then(function (res) {
                            
                            
                            
                                
                                    localStorage.setItem('isDeviceRegistered', true);
                                    localStorage.setItem('mpinConsent', true);
                                    //user name to be shown on login page for new design
                                    localStorage.setItem('customername', customerdetails.customerName);
									localStorage.setItem('simSubscriptionId', registerWithSimService.simSubscriptionId);
                                    mPinLoginService.userLoginStatus.isRegistered = true;
                                    mPinLoginService.isLoggedIn = false;
                                    var alertMessage = "";
                                    mPinLoginService.isSetMPIN ? alertMessage = "You have successfully created your MPIN." : alertMessage = "You have successfully registered.";
                                     $ionicPopup.show({
                                        template: '<img src="img/mf/bg-approved.svg" alt="Success Screen"><h2> Congratulations! </h2> <p>' + alertMessage + '</p>',
                                        title: '',
                                        cssClass: 'dialog',
                                        //scope: $scope,
                                        buttons: [{
                                            text: 'OK',
                                            type: 'button-positive',
                                            onTap: function (e) {
                                                if (regProcessWithAccNoService.registerWithATM !== 'Y') {
                                                    internetBankingService.commonFnToGoToHomeScreen();
                                                }
                                                else {
                                                    loggedInUserService.logoutUser();
                                                }
                                            }
                                        }]
                                });
                            
                        
                        }, function (err) {
                            localStorage.setItem('isDeviceRegistered', true);
                            localStorage.setItem('mpinConsent', true);
                            //user name to be shown on login page for new design
                             customerdetails = loggedInUserService.getUserProfileDetails();
                            localStorage.setItem('customername', customerdetails.customerName);
                            mPinLoginService.userLoginStatus.isRegistered = true;
                            mPinLoginService.isLoggedIn = false;
                            var alertMessage = "";
                            mPinLoginService.isSetMPIN ? alertMessage = "You have successfully created your MPIN." : alertMessage = "You have successfully registered.";
                            $ionicPopup.show({
                                template: '<img src="img/mf/bg-approved.svg" alt="Success Screen"><h2> Congratulations! </h2> <p>' + alertMessage + '</p>',
                                title: '',
                                cssClass: 'dialog',
                                //scope: $scope,
                                buttons: [{
                                    text: 'OK',
                                    type: 'button-positive',
                                    onTap: function (e) {
                                        if (regProcessWithAccNoService.registerWithATM !== 'Y') {
                                            internetBankingService.commonFnToGoToHomeScreen();
                                        }
                                        else {
                                            loggedInUserService.logoutUser();
                                        }
                                    }
                                }]
                            });
                        });
                        }else{
                            utilityService.showErrorMessage('Technical error, please try later.');
                        }
                    }else{
                        utilityService.showErrorMessage(error.responseMessage);
                    }

				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			} else {
				requestParams["id"] = loggedInUserService.deviceInfo;
				requestParams["mpin"] = "";
				requestParams["simId"] = aesHashedSimInfo.toString();
				internetBankingService.setMPIN(requestParams).then(function (data) {
                    if(data.responseCode == "0000"){
                        var finalcalculatedKey = internetBankingService.verifySecKey(parseInt(data.secKey));
                        if (requestSecKey == finalcalculatedKey) {
                             customerdetails = loggedInUserService.getUserProfileDetails();
                            loggedInUserService.fileForStorageData('{"isDeviceRegistered":true,"mpinConsent":false,"customername": "' + customerdetails.customerName + '", "simSubscriptionId": "'+ registerWithSimService.simSubscriptionId +'"}').then(function (res) {
                            
                                
                                    localStorage.setItem('isDeviceRegistered', true);
                                    localStorage.setItem('mpinConsent', false);
                                    //user name to be shown on login page for new design

                                    localStorage.setItem('customername', customerdetails.customerName);
									localStorage.setItem('simSubscriptionId', registerWithSimService.simSubscriptionId);
                                    mPinLoginService.userLoginStatus.isRegistered = true;
                                    mPinLoginService.isLoggedIn = false;
                                    $ionicPopup.show({
                                        template: '<img src="img/mf/bg-approved.svg" alt="Success Screen"><h2> Congratulations! </h2> <p>You have successfully registered.</p>',
                                        title: '',
                                        cssClass: 'dialog',
                                        //scope: $scope,
                                        buttons: [{
                                            text: 'OK',
                                            type: 'button-positive',
                                            onTap: function (e) {
                                                internetBankingService.commonFnToGoToHomeScreen();
                                                //loggedInUserService.logoutUser();
                                            }
                                        }]
                                    });
                    
                        
                        }, function (err) {
                            localStorage.setItem('isDeviceRegistered', true);
                            localStorage.setItem('mpinConsent', false);
                            //user name to be shown on login page for new design
                                 customerdetails = loggedInUserService.getUserProfileDetails();
                                localStorage.setItem('customername', customerdetails.customerName);
                                mPinLoginService.userLoginStatus.isRegistered = true;
                                mPinLoginService.isLoggedIn = false;
                                 $ionicPopup.show({
                                template: '<img src="img/mf/bg-approved.svg" alt="Success Screen"><h2> Congratulations! </h2> <p>You have successfully registered.</p>',
                                title: '',
                                cssClass: 'dialog',
                                //scope: $scope,
                                    buttons: [{
                                        text: 'OK',
                                        type: 'button-positive',
                                        onTap: function (e) {
                                            internetBankingService.commonFnToGoToHomeScreen();
                                            //loggedInUserService.logoutUser();
                                        }
                                    }]
                                });
                            });
                        }else{
                            utilityService.showErrorMessage('Technical error, please try later.');
                        }
                    }else{
                        utilityService.showErrorMessage(error.responseMessage);
                    }
					//}
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}
		}

		internetBankingService.commonFnToGoToHomeScreen = function () {
			mPinLoginService.isLoggedIn = true;
			$state.go("menu.homeScreen");
		}

		return internetBankingService;
	});
