'use strict';

angularApp.controller('mpinConsentController', ["$timeout", "$state", "$scope", "$translate", "$ionicPopup", 
					  "loggedInUserService", "internetBankingService", "utilityService", "$stateParams","$ionicSideMenuDelegate","mPinLoginService", "fTBeneficiaryService",
					  "registerWithSimService","cryptoService",
					function ($timeout, $state, $scope, $translate, $ionicPopup, loggedInUserService, internetBankingService, utilityService, $stateParams, $ionicSideMenuDelegate , mPinLoginService, fTBeneficiaryService,
					registerWithSimService, cryptoService) {
							
	var mpinConsentVm = this;
	
	var previousJourney = $stateParams.previousJourney;
	loggedInUserService.previousJourney = $stateParams.previousJourney;
	mpinConsentVm.isSetMPIN = mPinLoginService.isSetMPIN;
	mpinConsentVm.consentValue = true;
	internetBankingService.mpinConsent = mpinConsentVm.consentValue;
	var loggedInUserDetails = loggedInUserService.getUserProfileDetails();
	
	mpinConsentVm.toggleCheckboxVal = function(isChecked){
		internetBankingService.mpinConsent = isChecked;
	};
	
	mpinConsentVm.goToOtpScreen = function(){
		var reqParams = {};
		reqParams["id"] = device.uuid;
		reqParams["fields"] = ["ckyc.dob", "ckyc.address", "profile.anniversaryDate"];
		internetBankingService.getUserDetailsForMpin(reqParams).then(function(data){
			//User details used for MPIN policies.
			var userDetails = {}
			userDetails["birthDate"] = data.payLoad.ckyc.dob;
			internetBankingService.userDetailsForMpin = userDetails;
			
			if(internetBankingService.mpinConsent){
				$state.go('menu.setMPIN');
			} else {
				var dataForSimHash = "";
				var aesHashedSimInfo = "";
				if (utilityService.isAndroidPlatform()) {
					dataForSimHash = device.uuid + registerWithSimService.simSubscriptionId;
					aesHashedSimInfo = cryptoService.getSHA512EncryptedData(dataForSimHash);
				}
				if(!loggedInUserService.isNormalRegistration){
					$state.go('menu.setMPINOTP', {mpin:"",simInfo:aesHashedSimInfo.toString()});
				}else{
					internetBankingService.comCodeForYONORegistration("",aesHashedSimInfo);
				}
			}
		},  function(error){
			utilityService.showErrorMessage(error.responseMessage);
		});
	};
	
	mpinConsentVm.consentDataAvl = true;
	mpinConsentVm.getMpinConsentData = function(type){
		if(!internetBankingService.consentData){
			var reqParams = {
			  "type": type
			}
			internetBankingService.getMpinConsentData(reqParams).then(
				function(data) {
					mpinConsentVm.consentDataAvl = true;
					$scope.mpinConsentData = data.data;
					internetBankingService.consentData = $scope.mpinConsentData;
				},
				function(error) {
					mpinConsentVm.consentDataAvl = false;
				}
			); 
		} else {
			$scope.mpinConsentData = internetBankingService.consentData;
		}
	};
	
	//Function for Mpin consent T&C
	mpinConsentVm.openTC = function(type){
		var reqParams = {
		  "type": type
		}
		internetBankingService.getTermsCondition(reqParams).then(
			function(data) {
				mpinConsentVm.termsConditions = data.data;
				$state.go('menu.loginTermsAndConditions',{obj:mpinConsentVm.termsConditions});
			},
			function(error) {
				utilityService.showErrorMessage(error.responseMessage);
			}
		);
	};
	
	mpinConsentVm.closeView = function(){
		if(loggedInUserService.previousJourney == 'settings'){
			$state.go('menu.settings');
		}else if(loggedInUserService.previousJourney == 'UserLoginPage'){
			$state.go('menu.userLogin');
		} else {
			$state.go('menu.openNewDigitalAccount');
		}
	};
	
	//one time initialization to be done when the controller is loaded
	$scope.$on('$ionicView.loaded', function() {
		$ionicSideMenuDelegate.canDragContent(false)
	});
	
	//actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function() {
		$ionicSideMenuDelegate.canDragContent(false);
	});
	
	//any cleanup needs to be done here: executes everytime when page is left
	$scope.$on('$ionicView.afterLeave', function() {
		$ionicSideMenuDelegate.canDragContent(false)
	});
	
}]);
