'use strict';

angularApp.controller('securityQuestionsController', 
						["$timeout", "$state", "$scope", "$translate", "internetBankingService","utilityService","$stateParams","loggedInUserService","$ionicSideMenuDelegate","$ionicPopup","getAccountDetailsService",
						function ($timeout, $state, $scope, $translate, internetBankingService, utilityService, $stateParams, loggedInUserService, $ionicSideMenuDelegate, $ionicPopup,getAccountDetailsService) {
							
	var securityQuestionsVm = this;
	securityQuestionsVm.profilePassword = $stateParams.profileDetails;
	securityQuestionsVm.isSecQuestionSelected = true;
	
	securityQuestionsVm.closeView = function(){
		//if(getAccountDetailsService.accountOverviewData.profilePasswordFlag){
		$state.go(getAccountDetailsService.prevPage);
		// }else{
		// 	$state.go('menu.openNewDigitalAccount');	
		// }
		
	}
	
	//Get security questions list
	securityQuestionsVm.getSecurityQuestions = function() {
		var reqParams = {};
		reqParams["id"] = "MasterDataTry1"; 
		reqParams["fields"] = ["securityQuestions.data.masterDetails"];
		
		internetBankingService.getSecurityQuestions(reqParams).then(function(data){
				securityQuestionsVm.secQuestionsList = data.masterDetails;
			}, function(error){
				utilityService.showErrorMessage(error.responseMessage);
		});
	}
	
	//Create user profile
	securityQuestionsVm.goToSetMPIN = function(){
		if(securityQuestionsVm.hintQuestion !== '' && securityQuestionsVm.hintQuestion !== undefined){
			var loggedInUserDetails = loggedInUserService.getUserProfileDetails();
			var reqParams = {};
			reqParams["userName"] = loggedInUserDetails.inbUsername;
			reqParams["profilePassword"] = securityQuestionsVm.profilePassword;
			reqParams["hintQuestion"] = securityQuestionsVm.hintQuestion;
			reqParams["hintAnswer"] = securityQuestionsVm.hintAnswer;
			reqParams["countryCode"] = loggedInUserDetails.countryCode;
			reqParams["mobileNo"] = securityQuestionsVm.mobileNumber;
			
			internetBankingService.createUserProfile(reqParams).then(function(data){
				//$state.go('menu.mpinConsent',{previousJourney : "registration"});
				securityQuestionsVm.gotoSetMpinPopup();
			}, function(error){
				utilityService.showErrorMessage(error.responseMessage);
			});
		} else {
			securityQuestionsVm.isSecQuestionSelected = false;
		}
	}

	/* Popup to show success message once mpin is set*/
	securityQuestionsVm.gotoSetMpinPopup = function(){
	var alertMessage = "";
	alertMessage="You have successfully set your Internet Banking Profile Password.";
	var mpinSetPopUp = $ionicPopup.show({
		template: '<img src="img/mf/bg-approved.svg" alt="Success Screen"><h2> Congratulations! </h2> <p>'+alertMessage+'</p>',
		title: '',
		cssClass: 'dialog',
		scope: $scope,
		buttons: [{
			text: 'OK',
			type: 'button-positive',
			onTap: function (e) {
				//if(getAccountDetailsService.accountOverviewData.profilePasswordFlag){
					getAccountDetailsService.accountOverviewData.profilePasswordFlag = true;
					getAccountDetailsService.isProfilePwdSet = true;
					$state.go(utilityService.nextPage);
				//}else{
				//	$state.go('menu.mpinConsent',{previousJourney : "registration"});	
				//}
				
			}
		}]
	});
}
	
	securityQuestionsVm.goToBack = function(){
		$state.go('menu.setProfilePassword');
	}
	
	//one time initialization to be done when the controller is loaded
	$scope.$on('$ionicView.loaded', function() {
		$ionicSideMenuDelegate.canDragContent(false)
	});
	
	//actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function() {
		$ionicSideMenuDelegate.canDragContent(false);
	});
	
	//any cleanup needs to be done here: executes everytime when page is left
	$scope.$on('$ionicView.afterLeave', function() {
		$ionicSideMenuDelegate.canDragContent(false)
	});
	
	
}]);