'use strict';

angularApp.controller('setMPINController', ["$timeout", "$state", "$scope", "$translate",
											"internetBankingService", "utilityService","loggedInUserService", "cryptoService", "$rootScope","$ionicSideMenuDelegate","encryptionService","constantConfig","mPinLoginService","regProcessWithAccNoService",
											"registerWithSimService",
						function ($timeout, $state, $scope, $translate, internetBankingService, utilityService, loggedInUserService, cryptoService, $rootScope, $ionicSideMenuDelegate, encryptionService,constantConfig, mPinLoginService, regProcessWithAccNoService,
						registerWithSimService) {
							
	var setMPINVm = this;
	var dataForHashing = "";
	var aesHashedMpin = "";
	var loggedInUserDetails = loggedInUserService.getUserProfileDetails();
	
	//to submit mpin change
	setMPINVm.changeMpinSubmit = function(){
		setMPINVm.validConfirmFlag = true;
		setMPINVm.requiredFlag = false;
		var newMpin = setMPINVm.newMpin1 + setMPINVm.newMpin2 + setMPINVm.newMpin3 + setMPINVm.newMpin4 + setMPINVm.newMpin5 + setMPINVm.newMpin6;
		var confirmMpin = setMPINVm.reMpin1 + setMPINVm.reMpin2 + setMPINVm.reMpin3 + setMPINVm.reMpin4 + setMPINVm.reMpin5 + setMPINVm.reMpin6;	
		
		if(!confirmMpin || !newMpin){
			setMPINVm.requiredFlag = true;
		} else {
			var mpinPolicyMsg = setMPINVm.checkMPINConditions(newMpin, confirmMpin);
			if(mpinPolicyMsg == true){
				setMPINVm.validConfirmFlag = false;
				dataForHashing = newMpin + loggedInUserService.deviceInfo;
				var dataForSimHash = "";
				var aesHashedSimInfo = "";
				if (utilityService.isAndroidPlatform()) {
					dataForHashing = dataForHashing + registerWithSimService.simSubscriptionId;
					aesHashedMpin = cryptoService.getSHA512EncryptedData(dataForHashing);
					dataForSimHash = device.uuid + registerWithSimService.simSubscriptionId;
					aesHashedSimInfo = cryptoService.getSHA512EncryptedData(dataForSimHash);
				}
				else{
					aesHashedMpin = cryptoService.getSHA512EncryptedData(dataForHashing);
				}
				if(!loggedInUserService.isNormalRegistration){
					$state.go('menu.setMPINOTP', {mpin: aesHashedMpin.toString(), simInfo: aesHashedSimInfo.toString()});
				}else{
					internetBankingService.comCodeForYONORegistration(aesHashedMpin,aesHashedSimInfo);
				}
			} else {
				setMPINVm.clearMpin();
				utilityService.showErrorMessage(mpinPolicyMsg);
			}
		}
	};
	
	//Check B'date combinations for set MPIN.
	setMPINVm.checkDateCombinations = function(mpin, date){
		var dd = date.substring(0,2);
		var mm = date.substring(2,4);
		var yy = date.substring(6,8);
		if(mpin == (dd + mm + yy) || mpin == (mm + dd + yy) || mpin == (yy + dd + mm) || mpin == (yy + mm + dd) || mpin == (dd + yy + mm) || mpin == (mm + yy + dd)){
			return true;
		}else{
			return false;
		}
	};
	
	setMPINVm.checkMPINConditions = function(newMpin, confirmMpin){
		var userDetails = internetBankingService.userDetailsForMpin;
		if((newMpin.toString()).length !== 6){
			return 'MPIN cannot be less than 6 digits';
		}
		if(newMpin !== confirmMpin){
			return 'MPIN does not match';
		}
		if(/(.)\1\1/.test(newMpin.toString())){
			return 'Three consecutive numbers should not be same';
		}
		for(var i = 0; i < 4; i++){
			if(newMpin[i + 1] == parseInt(newMpin[i]) + 1){
				if(newMpin[i + 2] == parseInt(newMpin[i + 1]) + 1){
					return 'Three consecutive numbers should not be in sequence';
				}
			}
		}
		for(var i = 0; i < 4; i++){
			if(newMpin[i] == parseInt(newMpin[i + 1]) + 1){
				if(newMpin[i + 1] == parseInt(newMpin[i + 2]) + 1){
					return 'Three consecutive numbers should not be in sequence';
				}
			}
		}
		if(setMPINVm.checkDateCombinations(newMpin, userDetails.birthDate)){
			return 'Birthdate combinations cannot be set as MPIN';
		} 
		var validArrSet =  [newMpin[0], newMpin[1], newMpin[2],newMpin[3], newMpin[4], newMpin[5]];
		var newArr = [];
	    for (var i=0;i < validArrSet.length ; i++){
			if(newArr.indexOf(validArrSet[i]) == -1){
				newArr.push(validArrSet[i]);
			}
	    }
	    if(newArr.length < 3){
			return 'Please use 3 unqiue numbers to set MPIN.';
	    }
		return true;
	};
	/*clearMpin starts here*/
		setMPINVm.clearMpin = function(){
			setMPINVm.newMpin1 = '';
			setMPINVm.newMpin2 = '';
			setMPINVm.newMpin3 = '';
			setMPINVm.newMpin4 = '';
			setMPINVm.newMpin5 = '';
			setMPINVm.newMpin6 = '';
			setMPINVm.reMpin1 = '';
			setMPINVm.reMpin2 = '';
			setMPINVm.reMpin3 = '';
			setMPINVm.reMpin4 = '';
			setMPINVm.reMpin5 = '';
			setMPINVm.reMpin6 = '';
		};
	/*clearMpin ends here*/
	
	setMPINVm.goToSendMPINOTP = function() {
		setMPINVm.changeMpinSubmit();
	};
	
	setMPINVm.goToBack = function(){
		$state.go('menu.inbLogin',{previousPage : "openNewDigitalAccountPage"});
	};
	
	setMPINVm.closeView = function(){
		if(loggedInUserService.previousJourney == 'settings'){
			$state.go('menu.settings');
		} else if(loggedInUserService.previousJourney == 'UserLoginPage'){
			$state.go('menu.userLogin');
		} else {
			$state.go('menu.openNewDigitalAccount');
		}
	};
	
	//one time initialization to be done when the controller is loaded
	$scope.$on('$ionicView.loaded', function() {
		$ionicSideMenuDelegate.canDragContent(false)
	});
	
	//actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function() {
		$ionicSideMenuDelegate.canDragContent(false);
	});
	
	//any cleanup needs to be done here: executes everytime when page is left
	$scope.$on('$ionicView.afterLeave', function() {
		$ionicSideMenuDelegate.canDragContent(false)
	});
	
}]);
