'use strict';

angularApp.controller('setMPINOTPController', ["$timeout", "$state", "$scope", "$translate", "$ionicPopup",
	"loggedInUserService", "internetBankingService", "utilityService", "$stateParams", "$ionicSideMenuDelegate", "mPinLoginService", "$rootScope", "cryptoService", "constantConfig", "autoOtpReadService","$filter","regProcessWithAccNoService", "encryptionService","AdapterUtils","getOTPService","clickStreamService","$ionicViewSwitcher",
	"registerWithSimService",
	function ($timeout, $state, $scope, $translate, $ionicPopup, loggedInUserService, internetBankingService, utilityService, $stateParams, $ionicSideMenuDelegate, mPinLoginService, $rootScope, cryptoService, constantConfig, autoOtpReadService,$filter,regProcessWithAccNoService,encryptionService,AdapterUtils,getOTPService,clickStreamService,$ionicViewSwitcher,
	registerWithSimService) {

		var setMPINOTPVm = this;

		setMPINOTPVm.isValidOtp = true;
		var mpin = $stateParams.mpin;
		$scope.isDisabledOTPbtn = false;
		var resendOTPCount = 1;

		var errMsgs = internetBankingService.errorMsgs ? internetBankingService.errorMsgs : "";
		
		setMPINOTPVm.loggedInUserDetails = loggedInUserService.getUserProfileDetails();
		//setMPINOTPVm.loggedInUserMobNo = setMPINOTPVm.loggedInUserDetails.mobileNumber;

		setMPINOTPVm.mpinSetStatus = function () {
			var otpSuccess = setMPINOTPVm.otp + "0000";
			var reqParams = {};
			if(!errMsgs){
				reqParams["otp"] = setMPINOTPVm.otp;
				internetBankingService.validateOTPRegister(reqParams).then(function (data) {
					if (data.status.toLowerCase() === 'success' && data.rhValue == cryptoService.getSHA512EncryptedData(otpSuccess).toString()) {
						if (!loggedInUserService.isNormalRegistration) {
							var dataForSimHash = "";
							var aesHashedSimInfo = "";
							if (utilityService.isAndroidPlatform()) {
								dataForSimHash = device.uuid + registerWithSimService.simSubscriptionId;
								aesHashedSimInfo = cryptoService.getSHA512EncryptedData(dataForSimHash);
							}
							internetBankingService.comCodeForYONORegistration(mpin, aesHashedSimInfo);
						}else{
							$state.go('menu.mpinConsent');
						}
					}else if(data.rhValue != cryptoService.getSHA512EncryptedData(otpSuccess).toString()){
						utilityService.showBhimUpiAlert('error', constantConfig.adapter.SOMETHING_WENT_WRONG, 'menu.inbLogin', 'OK', $scope);
					}
					else {
						setMPINOTPVm.isValidOtp = false;
					}
				}, function (error) {
					if(error.responseMessage === "OTP does not match"){
						utilityService.showErrorMessage(error.responseMessage);
					}else if (error.rhValue == cryptoService.getSHA512EncryptedData(error.responseCode).toString()){
						utilityService.showForcePasswordPopup(error.responseMessage,"menu.inbLogin");
					}else if (error.responseCode == constantConfig.FORCE_PWD_ERROR_CODES.FP01) {
						utilityService.showForcePasswordPopup(error.responseMessage, "");
					}
					else{
						$ionicViewSwitcher.nextDirection('back');
						utilityService.showBhimUpiAlert('error', error.responseMessage, 'menu.inbLogin', 'OK', $scope);
					}
				});
			}else{
				$ionicViewSwitcher.nextDirection('back');
				if(errMsgs.errorCode == "LOCK.001" || errMsgs.errorCode == "M003"){
					utilityService.showBhimUpiAlert('error', constantConfig.adapter.USER_ID_BLOCKED, 'menu.inbLogin', 'OK', $scope);
				}
				else if(errMsgs.errorCode == "SB001" || errMsgs.errorCode == "F001"){
						registerWithSimService.reloadAppSimOk(errMsgs.errorMsg);
					}
				else if(errMsgs.failure){
					utilityService.showBhimUpiAlert('error', errMsgs.failure, 'menu.inbLogin', 'OK', $scope);
				}
				else if(errMsgs){
					utilityService.showBhimUpiAlert('error', utilityService.getServerExceptionMessage(errMsgs), 'menu.inbLogin', 'OK', $scope);
				}
				else {
					utilityService.showBhimUpiAlert('error', constantConfig.adapter.CANNOT_PROCESS_NOW, 'menu.inbLogin', 'OK', $scope);
				}
			}
		}
		
		//Reset OTP text field
		setMPINOTPVm.resetOtpField = function () {
			setMPINOTPVm.isValidOtp = true;
		}

		setMPINOTPVm.generateOTP = function () {
			var reqParams = {};
			reqParams.otpCode = constantConfig.keysForOTP.setMpin;
			reqParams.ocHash = cryptoService.getSHA512EncryptedData(constantConfig.keysForOTP.setMpin).toString();
			reqParams.journeyName = mPinLoginService.isSetMPIN ? constantConfig.OTP_EMAIL_SMS_TEMPLATE.SET_MPIN : constantConfig.OTP_EMAIL_SMS_TEMPLATE.YONO_REGISTRATION_OTP;

				internetBankingService.generateOTP(reqParams).then(function (data) {
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			
		}

		//Resend OTP
		setMPINOTPVm.resendOTP = function () {
			if(!errMsgs){
				if(!$scope.isDisabledOTPbtn){
					setMPINOTPVm.otp = null;
					setMPINOTPVm.isValidOtp = true;
					var reqParams = {};
					reqParams.otpCode = constantConfig.keysForOTP.setMpin;
					reqParams.ocHash = cryptoService.getSHA512EncryptedData(constantConfig.keysForOTP.setMpin).toString();
					reqParams.journeyName = mPinLoginService.isSetMPIN ? constantConfig.OTP_EMAIL_SMS_TEMPLATE.SET_MPIN : constantConfig.OTP_EMAIL_SMS_TEMPLATE.YONO_REGISTRATION_OTP;

						internetBankingService.generateOTP(reqParams).then(function (data) {
							if(resendOTPCount !== 2){
								resendOTPCount = resendOTPCount+1;
							}else{
								$scope.isDisabledOTPbtn = true;
							}
						}, function (error) {
							utilityService.showErrorMessage(error.responseMessage);
						});
				}
			}else{
				$ionicViewSwitcher.nextDirection('back');
				if(errMsgs.errorCode == "LOCK.001" || errMsgs.errorCode == "M003"){
					utilityService.showBhimUpiAlert('error', constantConfig.adapter.USER_ID_BLOCKED, 'menu.inbLogin', 'OK', $scope);
				}
				else if(errMsgs.errorCode == "SB001" || errMsgs.errorCode == "F001"){
						registerWithSimService.reloadAppSimOk(errMsgs.errorMsg);
					}
				else if(errMsgs.failure){
					utilityService.showBhimUpiAlert('error', errMsgs.failure, 'menu.inbLogin', 'OK', $scope);
				}
				else if(errMsgs){
					utilityService.showBhimUpiAlert('error', utilityService.getServerExceptionMessage(errMsgs), 'menu.inbLogin', 'OK', $scope);
				}
				else {
					utilityService.showBhimUpiAlert('error', constantConfig.adapter.CANNOT_PROCESS_NOW, 'menu.inbLogin', 'OK', $scope);
				}
			}
		}

		setMPINOTPVm.closeView = function () {
			if (loggedInUserService.previousJourney == 'settings') {
				$state.go('menu.settings');
			} else if (loggedInUserService.previousJourney == 'UserLoginPage') {
				$state.go('menu.userLogin');
			} else {
				$state.go('menu.openNewDigitalAccount');
			}
		}

		//one time initialization to be done when the controller is loaded
		$scope.$on('$ionicView.loaded', function () {
			$ionicSideMenuDelegate.canDragContent(false)
		});

		//actions to done everytime the view is shown
		$scope.$on('$ionicView.beforeEnter', function () {
			$ionicSideMenuDelegate.canDragContent(false);
			$scope.isDisabledOTPbtn = false;
			if(!errMsgs && setMPINOTPVm.loggedInUserDetails.mobileNumber){
				setMPINOTPVm.generateOTP();
			}
		});

		//any cleanup needs to be done here: executes everytime when page is left
		$scope.$on('$ionicView.afterLeave', function () {
			$ionicSideMenuDelegate.canDragContent(false);
		});

	}]);
