'use strict';

angularApp.controller('termsandconditionsController', ["$state", "$scope", "termsPolicyService","$ionicSideMenuDelegate","utilityService",
    function($state, $scope, termsPolicyService, $ionicSideMenuDelegate, utilityService) {

        var termsandconditionsVm = this;

        function initPage() {
            termsandconditionsVm.loadProductFeatures();
        };

        termsandconditionsVm.loadProductFeatures = function() {
            termsPolicyService.getTnCData('TnCLOGIN').then(function(data) {
                termsandconditionsVm.featuresJson = data;
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        };

        termsandconditionsVm.goBacktoPrevious = function() {
            $state.go('menu.userLogin');
        };

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });
		
		//one time initialization to be done when the controller is loaded
		$scope.$on('$ionicView.loaded', function() {
			$ionicSideMenuDelegate.canDragContent(false)
		});
		
		//actions to done everytime the view is shown
		$scope.$on('$ionicView.beforeEnter', function() {
			$ionicSideMenuDelegate.canDragContent(false);
		});
		
		//any cleanup needs to be done here: executes everytime when page is left
		$scope.$on('$ionicView.afterLeave', function() {
			$ionicSideMenuDelegate.canDragContent(false)
		});
	
        return this;
    }
]);
