'use strict';

angularApp.controller('investmentController',
	["$state", "$scope", "loggedInUserService", "mPinLoginService", "$ionicHistory", "$ionicSlideBoxDelegate", "utilityService", "mutualFundsService",
		"getAccountDetailsService", "mySecurityProfileService", "openAccountService", "$q", "$rootScope","clickStreamService","$filter","newCardService","myDreamsService","homeScreenService","generalInsurenceHomeService",
		"leadGenerationService",
		function ($state, $scope, loggedInUserService, mPinLoginService, $ionicHistory, $ionicSlideBoxDelegate, utilityService, mutualFundsService,
			getAccountDetailsService, mySecurityProfileService, openAccountService, $q, $rootScope,clickStreamService,$filter,newCardService,myDreamsService,homeScreenService,generalInsurenceHomeService,
			leadGenerationService) {

			var investmentVm = this;
			$scope.isLoggedIn = mPinLoginService.isLoggedIn;

			//one time initialization to be done when the controller is loaded
			$scope.$on('$ionicView.loaded', function () {
				
				utilityService.hideSpinner();
			});

			//for banner 

				investmentVm.bannersIns = [];
                investmentVm.isAnalyticBanner = [];
                investmentVm.isNotAnalyticBanner = [];
                generalInsurenceHomeService.browseMoreProducts().then(function(body) {
                    
                    utilityService.showSpinner();
                if(!utilityService.isUndefined(body)){
                    
                    console.log("bannersnew", investmentVm.bannersIns);
                     for (var i = 0; i < body.length; i++) {
                        investmentVm.browseData = body;
                        utilityService.hideSpinner();
                        generalInsurenceHomeService.browseData = investmentVm.browseData;
                        investmentVm.yonotCat = investmentVm.browseData[i].category;
                        investmentVm.yonoBanners = investmentVm.browseData[i].banners;
                        
						 //for banners
							if(investmentVm.yonotCat == 'MF'){
									angular.forEach(investmentVm.yonoBanners, function(mf) {
										if(mf.isAnalyticsBanner === 'true'){
											investmentVm.isAnalyticBanner.push(mf);
										}else{
											investmentVm.isNotAnalyticBanner.push(mf);	
										}
									})
							}

						//starts LI
							if(investmentVm.yonotCat == 'DM'){

								angular.forEach(investmentVm.yonoBanners, function(dm) {
										if(dm.isAnalyticsBanner === 'true'){
											investmentVm.isAnalyticBanner.push(dm);
										}else{
											investmentVm.isNotAnalyticBanner.push(dm);
										}
									})

							}
                    }

					//check isNotAnalyticBanner length
						if(investmentVm.isAnalyticBanner.length == 2 && (investmentVm.isNotAnalyticBanner.length >=1) ){
							
							investmentVm.isNotAnalyticBanner.splice(1);
						}
						
							if(investmentVm.isAnalyticBanner.length == 1 && investmentVm.isNotAnalyticBanner.length >=2){
							investmentVm.isNotAnalyticBanner.splice(2);
						}
						
						if(investmentVm.isAnalyticBanner.length == 0 && investmentVm.isNotAnalyticBanner.length >=2){
							investmentVm.isNotAnalyticBanner.splice(3);
						}

					 investmentVm.bannersIns = investmentVm.isAnalyticBanner.concat(investmentVm.isNotAnalyticBanner);
                }


                }, function(error) {
                    
                    utilityService.showErrorMessage(error.responseMessage);

                });
			

			investmentVm.checkDematAcc = function () {
				if (mutualFundsService.totalSecurities.dpList && mutualFundsService.totalSecurities.dpList.length > 0) {
					investmentVm.showInvestmentAc = false;
				} else {
					openAccountService.checkDematApplicationExists().then(function(data){
						if(data.applicationStatus == null || data.applicationStatus.trim() == "" || data.applicationStatus.toLowerCase() == "initiated"){
							investmentVm.showInvestmentAc = true;
						}else{
							investmentVm.showInvestmentAc = false;
						}
					},function(error){
						investmentVm.showInvestmentAc = false;
					})
				}
			}

			investmentVm.checkFolio = function () {
				var show = true;
				angular.forEach(mutualFundsService.multiFolio.portFolio, function (value, key) {
					if (value.isLotusfolio.toLowerCase() == "yes") {
						show = false;
					}
				});
				investmentVm.showFolio = show;
			}
			investmentVm.bannerRedirect= function (page) {
				if(page == "AOV_MYINVT"){
					investmentVm.redirect('investment');
				}else if(page == "AOV_MYINVT_OPENDEMATACC"){
					investmentVm.redirect('investment');
				}else if(page == "AOV_MYINVT_OPENFOLIO"){
					investmentVm.redirect('open');
				}else if(page == "AOV_MYINVT_ELSS"){
					investmentVm.redirect('elss');
				}				
			}

			investmentVm.redirect = function (page) {
				if (page == "investment") {
					myDreamsService.dreamId = "";
					homeScreenService.ishamburgerMenuRO=false;
					homeScreenService.isInvestmentFlag = true;
					getAccountDetailsService.tabIndex.tabIndex=3;
					$state.go('menu.accountOverviewMyBalance');
				} else if (page == "know") {
					$state.go('menu.startInvesting');
				} else if (page == "elss") {
					if (!mutualFundsService.taxSaverFunds) {
						mutualFundsService.taxSaver().then(function (data) {
							mutualFundsService.taxSaverFunds = data;
							var index = mutualFundsService.taxSaverFunds.findIndex(function (fund) {
								return fund.schemeOptions == "G"
							});
							if(index > 0){
								var element = mutualFundsService.taxSaverFunds[index];
								mutualFundsService.taxSaverFunds.splice(index, 1);
								mutualFundsService.taxSaverFunds.splice(0, 0, element);
							}
							$state.go('menu.mutualTaxSaver');
						}, function (error) {
							utilityService.showErrorMessage(error.responseMessage);
						});
					} else {
						$state.go('menu.mutualTaxSaver');
					}
				} else if (page == "open") {
					 //Adding below code for centralised consent sprint 2 journey
                	leadGenerationService.checkConsent().then(function(response){
                    	if(response.customerRecordExists == "false"){
                    	    openAccountService.setStatusOfOpenAccount(0);
							clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "ONLINE_DEMAT_OPEN_NOW"));
							newCardService.setPreLoginSelectedMenu('open');
							loggedInUserService.productClicked = 'menu.termsAndConditionsOutboundAnalytics';
							$state.go('menu.termsAndConditionsOutboundAnalytics');
                    	}else{
                    	    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "DM_START_NXT_BTN"));
            				openAccountService.setStatusOfOpenAccount(0);
            				$state.go('menu.dematAndTradingAccount');  
                    	}
                	}, function(error) {
                    	utilityService.showErrorMessage(error.responseMessage);
                	});					
				} else if (page == "folio") {
					
					investmentVm.getServerUrl().then(function (data) {
						investmentVm.URL = data;
						investmentVm.panCard = investmentVm.URL.kycNo;
						if (investmentVm.panCard == '' || investmentVm.panCard == null || investmentVm.panCard == undefined) {
							$rootScope.isCreateFolio = 1;
							$rootScope.checkStatusPage = 1;
							$rootScope.kycCompliant = 0;
							$rootScope.kycNonCompliant = 0;
							$state.go('menu.KYC');
						} else {
							investmentVm.checkKycStatus();
						}
					}, function (error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				}
			}

			investmentVm.getServerUrl = function () {
				var q = $q.defer();
				mutualFundsService.getServerUrl().then(function (data) {
					q.resolve(data);
				}, function (error) {
					q.reject(error);
				});
				return q.promise;
			}

			//kyc check for create folio user
			/***Function to check KYC Status***/
			investmentVm.checkKycStatus = function (formData) {
				var pageContent = "";
				var pageContentUrl = "";
				$rootScope.isCreateFolio = 1;
				// $rootScope.ekycPan=Vm.panCard.toUpperCase();
				investmentVm.sessionId = utilityService.getRandomNumber();
				//clickStreamService.clickStreamData=Vm.sessionId;
				// Vm.kycData = Vm.panCard.toUpperCase() + '|' + Vm.emailId + '|' + Vm.mobile + '|sbiApp|' + Vm.URL.camsUserId + '|' + Vm.URL.camsPwd + '|L||sess_id';

				var reqPara = {};
				reqPara['panId'] = investmentVm.panCard.toUpperCase();
				mutualFundsService.getEncryptString(reqPara).then(function (data) {
					investmentVm.encKycData = JSON.parse(data.encryptedString).data.responseString;

					pageContent = '<html><head></head><body><form id="form_Id" enctype="application/x-www-form-urlencoded" name="cbsulogin" action="' + investmentVm.URL.camsUrl + '" method="POST">' +
						'<input type="hidden" name="url" value="' + investmentVm.URL.mobileUrl + '">' +
						'<input type="hidden" name="sess_id" value="abcd1234">' +
						'<input type="hidden" name="ekyctype" value="E">' +
						 '<input type="hidden" name="plkyc_type" value="INVESTOR">' +
						'<input type="hidden" name="kyc_data" value="' + investmentVm.encKycData + '">' +
						'</form> <script type="text/javascript">document.getElementById("form_Id").submit();</script></body></html>';

					pageContentUrl = 'data:text/html;base64,' + btoa(pageContent);
					var ref = cordova.ThemeableBrowser.open(pageContentUrl, '_blank', {
						statusbar: { color: '#ffffffff' },
						toolbar: {
							height: 37,
							color: '#ffffffff',
							image: 'share'
						}, closeButton: {
							image: 'back',
							height: 37,
							width: 32,
							align: 'left',
							event: 'closePressed'
						}, backButtonCanClose: true
					});

					ref.addEventListener('loadstart', function (event) {
						var URL = event.url;
						var n = URL.indexOf("result");
						if (n == -1) {
							return;
						}
						if (n) {
							var sessId = '';
							var result = URL.split('?')[1];
							result = result.split("=")[1];
							result = decodeURIComponent(result).toString();
						}
						mutualFundsService.getDecryptString(result).then(function (data) {
							try {
								var resultData = JSON.parse(data.plainString);
								resultData = resultData.data.responseString.split("|")[2];
								resultData = resultData.replace('&sess_id', '');
								investmentVm.todayDate = $scope.currentDate.setDate($scope.currentDate.getDate());
								investmentVm.ekycType = JSON.parse(data.plainString).data.responseString.split("|")[0];
							} catch (e) {
								ref.close();
							}
							if (n != -1) {
								if (investmentVm.ekycType == 'Y' || resultData == 'KS100') {
									investmentVm.reqParams = {
										"mfKyc": {
											"panNo": investmentVm.panCard ? investmentVm.panCard : "",
											"aadharNo": investmentVm.aadhaarCard ? investmentVm.aadhaarCard : "",
											"gender": investmentVm.gender ? investmentVm.gender : "",
											"dob": investmentVm.dob ? investmentVm.dob : "",
											"ekycStatus": "Submitted",
											"aofStatus": "",
											"ekycType": investmentVm.ekycType ? investmentVm.ekycType : "",
											"ekycTimeStamp": investmentVm.todayDate ? investmentVm.todayDate : "",
											"ekycMaxInvestmentLimit": ""
										}
									};
									utilityService.showSpinner();
									mutualFundsService.checkKYCStatus(investmentVm.reqParams).then(function (data) {
										if (data.id) {
											var reqParams = {};
											reqParams['id'] = '';
											mutualFundsService.getPanCardNumber(reqParams).then(function (data) {
												investmentVm.divPayOutMechanism = data.mfKyc.divPayOutMechanism;
												investmentVm.redPayOutMechanism = data.mfKyc.redPayOutMechanism;
												investmentVm.applicationStatus = data.mfKyc.aofStatus;
												mutualFundsService.addeKycPanDetails(investmentVm.URL.kycNo);
												$rootScope.kycCompliant = 1;
												$rootScope.checkStatusPage = 0;
												$rootScope.kycNonCompliant = 0;
												utilityService.hideSpinner();
												$state.go('menu.KYC');
											}, function (error) {
												utilityService.hideSpinner();
												utilityService.showErrorMessage(error.responseMessage);
											});
										}
									}, function (error) {
										utilityService.hideSpinner();
										utilityService.showErrorMessage(error.responseMessage);
									});
								} else if (investmentVm.ekycType == 'N' || resultData == 'KS101') {
									$rootScope.kycCompliant = 0;
									$rootScope.checkStatusPage = 0;
									$rootScope.kycNonCompliant = 1;
									$state.go('menu.KYC');
								} else {
									if (resultData == 'KS102') {
										investmentVm.showInformationPopup("KYC status is incomplete, please update KYC with your current KRA through Point of Service of any Intermediary");
									} else if (resultData == 'EK-999') {
										investmentVm.showInformationPopup("Internal Error.Retry after some time");
									} else {
										investmentVm.showInformationPopup("Internal Error.Retry after some time");
									}
								}
								ref.close();
							}
						}, function (error) {
							ref.close(); 	      	 
			                utilityService.showErrorMessage(error.responseMessage); 					 
						});
					});
					ref.addEventListener('loadstop', function (event) {

					});
				}, function (error) {
					ref.close();  
					utilityService.showErrorMessage(error.responseMessage);
				})
			}

			/***Function to show alert POP UP***/
			investmentVm.showInformationPopup = function (message) {
				var infoPopup = $ionicPopup.show({
					template: '<p>' + message + '</p>',
					title: 'Alert',
					cssClass: 'dialog',
					scope: $scope,
					buttons: [{
						text: 'Ok',
						onTap: function (e) {
							$state.go('menu.accountOverviewMyBalance');
							infoPopup.close();
						}
					}]
				});
			}



			investmentVm.getFundDetail = function (fund) {
				var request = {
					'amfiCode': fund.amfiCode
				}
				mutualFundsService.getAllMutualFunds().then(function(data) {
					//mutualFundsService.addFundList(data.fundList);
					investmentVm.fundList1 = data.fundList;
					var temparray=[];
					if(investmentVm.fundList1.length > 0){	 
						for (var k = 0; k <investmentVm.fundList1.length; k++) {
							for (var j = 0; j <investmentVm.fundList1[k].fundSchemeList.length; j++){ 	
								if(investmentVm.fundList1[k].fundSchemeName != "NFO" && investmentVm.fundList1[k].fundSchemeName != "Popular"){	
									temparray.push(investmentVm.fundList1[k].fundSchemeList[j]); 
								}
							}		
						}
						temparray = $filter('uniqueArr')(temparray, 'fundId');
					}
					var fundobject = "";
					for (var z=0; z<temparray.length; z++){
						if(temparray[z].amfiCode == request.amfiCode){
							fundobject = temparray[z];
							break;
						}
					}

					var fundoptnArr = [];
					if(fundobject.isNfo == "Y"){
						var id = fundobject.fundName;
						fundoptnArr.push(fundobject);
						for (var i = 0; i <investmentVm.fundList1.length; i++) {
							for (var m = 0; m <investmentVm.fundList1[i].fundSchemeList.length; m++){ 
								if(investmentVm.fundList1[i].fundSchemeName == "NFO"){
									if(investmentVm.fundList1[i].fundSchemeList[m].fundName == id){
										fundoptnArr.push(investmentVm.fundList1[i].fundSchemeList[m]);
									}
								}
							}	
						}
					}
					else{
						var schFndID = fundobject.schemeFundId;
						fundoptnArr.push(fundobject);
						for (var n = 0; n <temparray.length; n++) {
							if(temparray[n].schemeFundId == schFndID){
								fundoptnArr.push(temparray[n]);
							}
						}
					}
					fundoptnArr = $filter('uniqueArr')(fundoptnArr, 'fundId');
					mutualFundsService.addFundId(fundoptnArr);
					$state.go('menu.fundDetails');
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			investmentVm.loadMF = function () {
				var reqParams = {};
				mutualFundsService.getUserWhiteListed(reqParams).then(function (response) {
					if (response.isWhiteListed == "true") {
						investmentVm.emptyMF = true;
					} else {
						investmentVm.emptyMF = false;
					}
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				})
			}

			investmentVm.redirectUrl = function (url) {
				if (!mPinLoginService.userLoginStatus.isRegistered) {
					$state.go('menu.openNewDigitalAccount');
				} else if (!mPinLoginService.isLoggedIn) {
					loggedInUserService.productClicked = url;
					$state.go('menu.userLogin');
				} else {
					if (url == "menu.mutualFunds") {

						//$state.go("menu.mutualFunds")
						var nfoArray = [];
						mutualFundsService.getAllMutualFunds().then(function (data) {
							if (data.fundList.length > 5) {
								angular.forEach(data, function (value, key) {
									for (var i in value) {
										if (value[i].fundSchemeName == "NFO") {
											nfoArray.push(data.fundList[i]);
											data.fundList.splice(i, 1);
											data.fundList.splice(1, 0, nfoArray[0]);
										}
									}
								});
							}

							//data.fundList.splice(1,0,data.fundList[4])
							//mutualFundsVm.popularFunds = data.fundList;
							mutualFundsService.addFundList(data.fundList);
							//$ionicLoading.hide();
							mutualFundsService.setPageId('quickBuy');
							$state.go('menu.mutualFundsList');
						}, function (error) {
							//$ionicLoading.hide();
							utilityService.showErrorMessage(error.responseMessage);
						});
					} else {
						$state.go("menu.securityLanding");
					}
				}
			}

			investmentVm.tryAgain = function () {
				investmentVm.showSpinner = true;
				mutualFundsService.trendingFunds().then(function (data) {
					investmentVm.showSpinner = false;
					investmentVm.trendingFunds = data.topTrendingFundsResult;
					mutualFundsService.mostTrendingFunds = data.topTrendingFundsResult;
				}, function (error) {
					investmentVm.showSpinner = false;
					investmentVm.showError = true;
				});
			}

			//actions to done everytime the view is shown
			$scope.$on('$ionicView.beforeEnter', function () {

				// $scope.showInvestments=false;
				//$ionicSideMenuDelegate.canDragContent($scope.isLoggedIn);

				investmentVm.showFolio = false;
				investmentVm.showInvestmentAc = false;
				investmentVm.showError = false;
				investmentVm.showSpinner = false;
				if (!mutualFundsService.multiFolio) {
					mutualFundsService.getPortfolio().then(function (data) {
						data = data.multiFolio;
						mutualFundsService.multiFolio = data;
						investmentVm.checkFolio();
					}, function (error) {
					});
				} else {
					investmentVm.checkFolio();
				}
				if (!mutualFundsService.totalSecurities) {
					mySecurityProfileService.getSecProfile().then(function (data) {
						mutualFundsService.totalSecurities = data.securities;
						investmentVm.checkDematAcc();
					}, function (error) {
					});
				} else {
					investmentVm.checkDematAcc();
				}
				if (!mutualFundsService.mostTrendingFunds) {
					mutualFundsService.trendingFunds().then(function (data) {
						investmentVm.trendingFunds = data.topTrendingFundsResult;
						mutualFundsService.mostTrendingFunds = data.topTrendingFundsResult;
					}, function (error) {
						investmentVm.showError = true;
					});
				} else {
					investmentVm.trendingFunds = mutualFundsService.mostTrendingFunds;
				}
			});

			
			

		}]);
