'use strict';

angularApp.controller('preHomeLoginController',
						["$filter","$timeout", "$state", "$scope", "$translate", "$ionicSideMenuDelegate","ionicToast" ,"$ionicScrollDelegate","needHelpService", "utilityService","$ionicSlideBoxDelegate","loggedInUserService","constantConfig","cryptoService","encryptionService","AdapterUtils","regProcessWithAccNoService","ompMerchantsService","preHomeLoginService","$ionicPopup","$sce",
						function ($filter,$timeout, $state, $scope, $translate, $ionicSideMenuDelegate,ionicToast ,$ionicScrollDelegate,needHelpService,utilityService,$ionicSlideBoxDelegate, loggedInUserService, constantConfig, cryptoService, encryptionService, AdapterUtils, regProcessWithAccNoService,ompMerchantsService,preHomeLoginService,$ionicPopup,$sce) {

	var preHomeLoginVm = this;
	preHomeLoginVm.keystoreValue = loggedInUserService.keystoreValue;
	$scope.err = '';
	regProcessWithAccNoService.isActivationCodeBtnClicked = false;
	//Open new Do you have internet banking page
	preHomeLoginVm.doYouHaveAcc = function(){
		$state.go('menu.existingCustomer',{previousPage : "preHomeLoginPage"});
	}

	preHomeLoginVm.loginUsingInternetBanking = function(){
		$state.go('menu.openNewDigitalAccount',{previousPage : "existingCustomer"});
	}
	/* login flow improvement*/
	function connectServer() {
		try {
			var payload = {
				"data": cryptoService.encryptRSAWithPublicKey(encryptionService.iv + "^" + encryptionService.passphrase + "^" + encryptionService.salt, cryptoService.rsaPublicKey),
				"src": preHomeLoginVm.keystoreValue != "" ? cryptoService.encryptRSAWithPublicKey(preHomeLoginVm.keystoreValue, cryptoService.rsaPublicKey) : "",
			};
			utilityService.showSpinner();
			var resourceRequest = new WLResourceRequest("adapters/CustomSessionAdapter/saveCustomInformation", WLResourceRequest.POST, { timeout: 15000 });
			resourceRequest.send(payload).then(function (response) {
				utilityService.lastTimeStamp = new Date();
				response.responseText = utilityService.isJSON(response.responseText) ? JSON.parse(response.responseText) : JSON.parse(encryptionService.getAES256DecryptedData(response.responseText));
				if (response.responseText.responseCode == '0000') {
					AdapterUtils.secretData = response.responseText.data.key;
					loggedInUserService.keyId = response.responseText.data.keyId;
					loggedInUserService.deviceIdForMpin = response.responseText.data.deviceId;
					loggedInUserService.upiPermissionKey = response.responseText.data.upiPermissionVal;
					loggedInUserService.billDeskUrl = response.responseText.data.billDeskUrl;
					loggedInUserService.sbiCollectUrl = response.responseText.data.sbiCollectUrl;
					utilityService.getUPIPermissions(loggedInUserService.upiPermissionKey);
					loggedInUserService.isServerConnected = true;
					utilityService.hideSpinner();
					//$state.go("menu.grabOffers");
					$state.go("menu.homePageAO");
				} else if (response.responseText.responseCode == '0001') {
					$scope.err = response.responseText.responseCode + " : " + constantConfig.adapter.CANNOT_PROCESS_NOW;
					loggedInUserService.isServerConnected = false;
					utilityService.hideSpinner();
					utilityService.showErrorMessage($scope.err);
					return;
				} else if (response.responseText.responseCode == '0002') {
					$scope.err = response.responseText.responseCode + " : " + constantConfig.adapter.CANNOT_PROCESS_NOW;
					loggedInUserService.isServerConnected = false;
					utilityService.hideSpinner();
					utilityService.showErrorMessage($scope.err);
					return;
				} else if (response.responseText.responseCode == '0003' || response.responseText.responseCode == '0004') {
					$scope.err = response.responseText.responseCode + " : " + response.responseText.responseMessage;
					loggedInUserService.isServerConnected = false;
					utilityService.hideSpinner();
					utilityService.showErrorMessage($scope.err);
					return;
				}
			}, function (error) {
				if (error.errorCode == 'APPLICATION_DOES_NOT_EXIST') {
					$scope.err = error;
					utilityService.hideSpinner();
					utilityService.showUpgradeMessage($scope.err);
				} else {
					$scope.err = utilityService.getServerExceptionMessage(error);
					utilityService.hideSpinner();
					utilityService.showErrorMessage($scope.err);
				}
				loggedInUserService.isServerConnected = false;
			});
		} catch (err) {
			$scope.err = constantConfig.adapter.SOMETHING_WENT_WRONG;
			loggedInUserService.isServerConnected = false;
			utilityService.hideSpinner();
			utilityService.showErrorMessage($scope.err);
		}
	}
	/* End of login flow improvement*/

	//Open new didital Account
	preHomeLoginVm.goToOpenNewDigiAcc = function(){
			$state.go("menu.newToSbiLanding");
			//$state.go("menu.homePageAO");       //To run only OVD account opening No Insta -- comment above redirection and uncomment this
	}
	preHomeLoginVm.goToGrabOffers= function(){
		if(loggedInUserService.isServerConnected==true) {
			// $state.go("menu.grabOffers");
			$state.go("menu.homePageAO");
		} else {
			connectServer();
		}
	}

	//one time initialization to be done when the controller is loaded
	$scope.$on('$ionicView.loaded', function() {
		$ionicSideMenuDelegate.canDragContent(false);
		$ionicScrollDelegate.$getByHandle("formularContent").freezeAllScrolls(true);
		$ionicScrollDelegate.$getByHandle("formularContent").freezeScroll(true);
		$ionicScrollDelegate.freezeAllScrolls(true);
		$ionicScrollDelegate.$getByHandle("formularContent").getScrollView().options.scrollingY = false;
	        navigator.splashscreen.hide();
	});
	
	
	preHomeLoginVm.openNeedHelp = function(){
		
		if(!needHelpService.knowMoreContent){
			utilityService.showSpinner();
		needHelpService.getknowMoreContent().then(function(data) {
				utilityService.hideSpinner();
				needHelpService.knowMoreContent = data.contentMessage;
				$state.go('menu.needHelp');
			}, function(error) {
				utilityService.hideSpinner();
				utilityService.showErrorMessage(error.responseMessage);
			});
		}else{
			$state.go('menu.needHelp');
		}
	}
  preHomeLoginVm.goToTeasers = function(){
		$state.go('menu.landingWithOptions');
	}
	//actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function() {
		$ionicSideMenuDelegate.canDragContent(false);
	});
	preHomeLoginVm.updateToStore = function () {
      utilityService.upgradeApp()
    }

    preHomeLoginVm.exitForUpdateApp = function () {
      ionic.Platform.exitApp();
      navigator.app.exitApp();
    }
	
	

	//any cleanup needs to be done here: executes everytime when page is left
	$scope.$on('$ionicView.afterLeave', function() {
		$ionicSideMenuDelegate.canDragContent(false);
	});

	preHomeLoginVm.activationCode = function(){
		regProcessWithAccNoService.isActivationCodeBtnClicked = true;
		$state.go("menu.regProcessMenu",{previousPage:"preHomeLogin"});
	}
	preHomeLoginVm.registeredWithAccountDetails = function(){
		regProcessWithAccNoService.registerWithATM = '';
		regProcessWithAccNoService.isStepDisplay = true;
		regProcessWithAccNoService.isActivationCodeBtnClicked = false;
		$state.go("menu.regProcessMenu");
	}

	preHomeLoginVm.registeredWithATMCard = function(){
		regProcessWithAccNoService.registerWithATM = 'Y';
		$state.go("menu.regAccountDetails");
	}

	
	preHomeLoginVm.openVideo = function(videoId){

	 preHomeLoginService.gethowdoiContent().then(function(response) {
		  angular.forEach(response.videoList, function (value, key) {
		 	 if (value.videoName == videoId) {
		 			 //ompMerchantsService.inAppBrowser(value.videoURL);
					 $scope.videoUrl=value.videoUrl;
					 $scope.trustSrcVideo = function(videoUrl){
						 return  $sce.trustAsResourceUrl(videoUrl)
				}
				$scope.videoTitle=value.videoTitle;
				preHomeLoginService.videopopup=$ionicPopup.alert({
			 title: '',
			 templateUrl: 'pages/preHomeLogin/howDoIVideoPopup.html',
			 scope: $scope,
			 cssClass: 'dialog',
			 buttons: [
				 {
				   text: 'Close',
					  onTap: function(e) {
							preHomeLoginService.videopopup.close();
						//$state.go('menu.howDoIVideoPopup');
					  }
				}
			 ]
		   });
		 	 }
		 })
			}, function(error) {
			utilityService.showErrorMessage(error.responseMessage);
		});

	}
}]);
