'use strict';

angularApp.controller('productsController', 
						[ "$state", "$scope",  "loggedInUserService","mPinLoginService", "$ionicSideMenuDelegate","$ionicHistory","lifeInsuranceBasicApplicationService","$ionicSlideBoxDelegate","$timeout","$rootScope","mutualFundsService","utilityService",
						"cardCompareService","sampoornSurakshaService","$filter",
						function ( $state, $scope, loggedInUserService,mPinLoginService,$ionicSideMenuDelegate,$ionicHistory,lifeInsuranceBasicApplicationService,$ionicSlideBoxDelegate,$timeout,$rootScope,mutualFundsService,utilityService,
							cardCompareService,sampoornSurakshaService,$filter) {
							
	var	productsVm=this;
	$scope.isLoggedin = mPinLoginService.isLoggedIn;
	productsVm.isLoggedin = $scope.isLoggedin;
	
	productsVm.goBack = function() {
		$ionicHistory.clearCache().then(function() {
			$ionicHistory.goBack(-1);
		})
	};
	
	productsVm.getisWhiteList=function(){
		var reqParams = {};
		reqParams['panNo'] = '';
		mutualFundsService.getPortfolio(reqParams).then(function(data) {
			if(data.authorised=='true'){
				$rootScope.showMF=true;
			}else{
				$rootScope.showMF=false;
			}		
		},function(error){
			if(error.data.authorised=='true'){
				$rootScope.showMF=true;
			}else{
				$rootScope.showMF=false;
			}
		})
	}
	//productsVm.getisWhiteList();
	productsVm.redirectInvestment= function(url) {
		if(!mPinLoginService.userLoginStatus.isRegistered ){
			$state.go('menu.openNewDigitalAccount');
		} else if(!$scope.isLoggedin){
			loggedInUserService.productClicked=url;
			$state.go('menu.userLogin');	
		} else {
			if(url=="menu.mutualFunds"){
				$state.go("menu.mutualFunds");
			}else {
				$state.go("menu.securitiesPortfolio");
			}
		}
	};

	productsVm.inAppBrowser = function(url){
		cordova.ThemeableBrowser.open(url, '_blank', {
			statusbar: {
				color: '#ffffffff'
			},
			toolbar: {
				height: 40,
				color: '#ffffffff',
				image: 'share'
			},

			closeButton: {
				image: 'back',
				height: 40,
				width: 32,
				align: 'left',
				event: 'closePressed'
			},

			backButtonCanClose: true
		}).addEventListener('backPressed', function (e) {
			
		}).addEventListener('helloPressed', function (e) {

		}).addEventListener('sharePressed', function (e) {

		}).addEventListener('loadstop', function (e) {
			
		}).addEventListener('loadstart', function (e) {
			
		}).addEventListener(cordova.ThemeableBrowser.EVT_ERR, function (e) {

		}).addEventListener(cordova.ThemeableBrowser.EVT_WRN, function (e) {

		});
	}

	productsVm.getCardsRouting = function(){
		if(cardCompareService.shikharFlag == true || cardCompareService.shikharFlag == "true"){
			$state.go('menu.shikharCards');
		}else if(cardCompareService.shikharFlag == false || cardCompareService.shikharFlag == "false"){
   			$state.go('menu.cardIntroduction');
		}else{
			 utilityService.showErrorMessage("Unable to connect. Please try after some time");
		}	
	}
	
	productsVm.redirectToUrl = function(url) {
			if(!mPinLoginService.userLoginStatus.isRegistered){
				if(url == 'homeLoan'){
					$state.go('menu.loansLanding');
				}else{
				switch(url){
					case 'menu.cardIntroduction' : 
						var element=document.getElementsByClassName("cc");
						element[0].classList.add("active");
						break;
					case 'menu.generalInsurance' :
						var element=document.getElementsByClassName("ins");
						element[0].classList.add("active");
						break;
					case 'Investments' : 
						var element=document.getElementsByClassName("invst");
						var investmentImgSrc=document.getElementById("invest");
						element[0].classList.add("active");						
						break;
				}
				$state.go('menu.openNewDigitalAccount');
				}
			} else if(! $scope.isLoggedin){
				if(url == 'homeLoan'){
				$state.go('menu.loansLanding');
				}else{
					switch(url){
					case 'menu.cardIntroduction' : 
						var element=document.getElementsByClassName("cc");
						element[0].classList.add("active");
						break;
					case 'menu.generalInsurance' :
						var element=document.getElementsByClassName("ins");
						element[0].classList.add("active");
						break;
					case 'Investments' : 
						var element=document.getElementsByClassName("invst");
						var investmentImgSrc=document.getElementById("invest");
						element[0].classList.add("active");						
						break;
					
				}
				loggedInUserService.productClicked=url;
				$state.go('menu.userLogin');
				}
					
			} else{
				if(url == 'homeLoan'){
					$state.go('menu.loansLanding');
				}else{
				switch(url){
					case 'menu.cardIntroduction' : 
						var element=document.getElementsByClassName("cc");
						element[0].classList.add("active");
						productsVm.getCardsRouting();
						break;
					case 'menu.generalInsurance' :
						var element=document.getElementsByClassName("ins");
						element[0].classList.add("active");
						$state.go('menu.generalInsurance')
						break;
					case 'Investments' : 
						var element=document.getElementsByClassName("invst");
						var investmentImgSrc=document.getElementById("invest");
						element[0].classList.add("active");
						$scope.showInvestments=true;
						$state.go('menu.Investments');
					
						break;
				}
				}
			}
	};
	//code to redirect from corousel on click
	productsVm.redirectFromCorousel = function(url) {
		
		if(url==="Investments")
			{
			
			//var element=document.getElementsByClassName("invst");
			var investmentImgSrc=document.getElementById("invest");
			//investmentImgSrc.src="img/FSS/Investment_white.svg";
			//element[0].classList.add("active");
			//$scope.showInvestments=true;
			$state.go('menu.Investments');	
			
			}
		else
		{
         
		if(!mPinLoginService.userLoginStatus.isRegistered)
			{
			
			 switch(url){
             case 'menu.cardIntroduction' : 
             break;
             case 'menu.generalInsurance' :
              break;
			 }
			 $state.go('menu.openNewDigitalAccount');
			}
		
		else if(! $scope.isLoggedin)
			{
			
			 switch(url){
             case 'menu.cardIntroduction' : 
             break;
             case 'menu.generalInsurance' :
              break;
           	  
			 }
			
			 loggedInUserService.productClicked=url;
			 $state.go('menu.userLogin');	
			}
			
		else
		{
         switch(url){
              case 'menu.cardIntroduction' : 
            	  productsVm.getCardsRouting();
              break;
              case 'menu.generalInsurance' :
            	  $state.go('menu.generalInsurance')
               break;
              case 'Investments' : 
            	  $scope.showInvestments=true;
               break;
         }
		}
		}
	};

	productsVm.ssBuy = function(){
		sampoornSurakshaService.getPremiumAndNomineeInfo().then(function(data) {
			sampoornSurakshaService.clearAll();
			sampoornSurakshaService.setPremiumDetails(data);
			$state.go('menu.ssPremiumCalculation');
		}, function(error) {
			utilityService.showErrorMessage(error.responseMessage);
		});
		//$state.go('menu.ssMedicalInformation');
	}

	productsVm.ssKnowMore = function(){
		sampoornSurakshaService.getPolicyFeatures().then(function(data) {
			sampoornSurakshaService.setPolicyDetails(data);
			sampoornSurakshaService.setBuyNow(true);
			$state.go('menu.ssPolicyFeatures');
		}, function(error) {
			utilityService.showErrorMessage(error.responseMessage);
		}); 

	}
	//click listener for corousel
	productsVm.gotoProductBanner = function(key){
		var url = "";
		if(key == "creditCardsPage"){
			url = 'menu.cardIntroduction';
		}
		else if(key == "insurance"){
			url = 'menu.generalInsurance'
		}
		else{
			url = 'Investments';
		}
		productsVm.redirectFromCorousel(url);
	};
	
	//One time initialization to be done when the controller is loaded
	$scope.$on('$ionicView.loaded', function() {
		$ionicSideMenuDelegate.canDragContent($scope.isLoggedIn);
		$timeout(function(){
			$scope.isIonBack = true;
		},100);
	});
	
	//Actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function() {
		productsVm.images = [];
		productsVm.ssproduct = {};
		lifeInsuranceBasicApplicationService.getFSSBannerImages().then(function(response) {
			productsVm.images = response.products;
			$ionicSlideBoxDelegate.update();
			$ionicSlideBoxDelegate.loop(true);
			if(response.subCategory.length > 0){
				for(var i=0;i<response.subCategory.length;i++){
					if(response.subCategory[i].subCode == "sampoorna"){
						productsVm.ssContent = response.subCategory[i];
					}
				}
			}
		}, function(error) { 	
		});
		
		sampoornSurakshaService.checkCustomerStatus().then(function(data) {
			productsVm.ssproduct = data;
			if(productsVm.ssContent){
				var eligibleSumAssured = String.fromCharCode(8377) + $filter('INR')(parseInt(productsVm.ssproduct.eligibleSumAssured)); 
				productsVm.ssContent.message = productsVm.ssContent ? productsVm.ssContent.message.replace("FIELD_1}}",eligibleSumAssured) : eligibleSumAssured;
			}
		}, function(error) {
			//utilityService.showErrorMessage(error.responseMessage);
		});
		
		$scope.showInvestments=false;
		
		if(!cardCompareService.shikharFlag){
			cardCompareService.getShikharEligibilityCheck().then(function(response){
			cardCompareService.shikharFlag = response.data.shikharFlag;
		},function(error){
			cardCompareService.shikharFlag = "";
		});
	   }

		$ionicSideMenuDelegate.canDragContent($scope.isLoggedIn);
	});
	
	//Any cleanup needs to be done here: executes everytime when page is left
	$scope.$on('$ionicView.afterLeave', function() {
		$ionicSideMenuDelegate.canDragContent($scope.isLoggedIn);
	});
	
}]);