'use strict';

angularApp.controller('loadSimDataController',
    ["$state",
        "$scope",
        "$interval",
        "utilityService",
        "registerWithSimService",
        "regProcessWithAccNoService",
        "quickPayService",
        "cryptoService",
        "constantConfig",
        "$translate",
        function (
            $state,
            $scope,
            $interval,
            utilityService,
            registerWithSimService,
            regProcessWithAccNoService,
            quickPayService,
            cryptoService,
            constantConfig,
            $translate) {
            var loadSimDataVm = this;
            var x = 70;
            var serviceCall1;
            var serviceCall2;
            var serviceCall3;
            loadSimDataVm.timer = utilityService.numberToTime(x);
            var timer = $interval(function () {
                x--;
                if (x == 0) {
                    quickPayService.showAuthFailurePopup('alert', "Something went wrong. Please try after sometime.", 'menu.selectSim', '', 'OK', '', $scope, false, function () { });
                    //utilityService.showBhimUpiAlert("alert", "");
                    $interval.cancel(timer);
                    clearTimeout(serviceCall1);
                    clearTimeout(serviceCall2);
                    clearTimeout(serviceCall3);
                }
                else {
                    loadSimDataVm.timer = utilityService.numberToTime(x);
                }

            }, 1000);
            $scope.$on('$ionicView.beforeLeave', function () {
                $interval.cancel(timer);
                clearTimeout(serviceCall1);
                clearTimeout(serviceCall2);
                clearTimeout(serviceCall3);
            });
            $scope.$on('$ionicView.beforeEnter', function () {
                utilityService.hideSpinner();
                $translate('OK').then(function(translatedvalue) {
                    loadSimDataVm.btnText = translatedvalue;
                });
                var simInfo = "";
                if (utilityService.isAndroidPlatform()) {
                    simInfo = cryptoService.getSHA512EncryptedData(device.uuid + registerWithSimService.simSubscriptionId).toString();
                }
                else {
                    simInfo = cryptoService.getSHA512EncryptedData(device.uuid).toString();
                }
                var payLoad = {
                    'msgKey': registerWithSimService.textMsg,
                    'deviceId': device.uuid,
                    'validateReq': simInfo,
                    'virtualMobNo': registerWithSimService.simBindingVirtualMobile,
                    'isVkyc': true,
                    'userMsgTime': moment(registerWithSimService.msgSentTimeUi).format("DD/MM/YYYY HH:mm:ss")
                };
                serviceCall1 = setTimeout(function () {
                    registerWithSimService.getRegTypeByMobile(payLoad).then(function (data) {
                        if (!data || data.type === null || data.type === "") {
                            $state.go("menu.selectSim");
                        }
                        else {
                            registerWithSimService.userRegFlag = data.type;
                            $interval.cancel(timer);
                            if (data.type === 'MLTCF') {
                                regProcessWithAccNoService.registerWithATM = '';
                                registerWithSimService.MLTCFAcc = 'Y';
                                $state.go("menu.regAccountDetails");
                            } else $state.go('menu.userEligibility');
                        }
                    }, function (error) {
                        if (error.responseCode === constantConfig.SB.errorCodeSB003) {
                            quickPayService.showAuthFailurePopup('error', error.responseMessage, 'menu.selectSim', '', loadSimDataVm.btnText, '', $scope, false, function () { });
                            $interval.cancel(timer);
                        }
                        else {
                            //call service again on error after 14 seconds
                            serviceCall2 = setTimeout(function () {
                                registerWithSimService.getRegTypeByMobile(payLoad).then(function (data) {
                                    if (!data || data.type === null || data.type === "") {
                                        $state.go("menu.selectSim");
                                    }
                                    else {
                                        registerWithSimService.userRegFlag = data.type;
                                        $interval.cancel(timer);
                                        if (data.type === 'MLTCF') {
                                            regProcessWithAccNoService.registerWithATM = '';
                                            registerWithSimService.MLTCFAcc = 'Y';

                                            $state.go("menu.regAccountDetails");
                                        } else $state.go('menu.userEligibility');
                                    }
                                }, function (error2) {
                                    if (error2.responseCode === constantConfig.SB.errorCodeSB003) {
                                        quickPayService.showAuthFailurePopup('error', error2.responseMessage, 'menu.selectSim', '', loadSimDataVm.btnText, '', $scope, false, function () { });
                                        $interval.cancel(timer);
                                    }
                                    else {
                                        serviceCall3 = setTimeout(function () {
                                            registerWithSimService.getRegTypeByMobile(payLoad).then(function (data) {
                                                if (!data || data.type === null || data.type === "") {
                                                    $state.go("menu.selectSim");
                                                }
                                                else {
                                                    registerWithSimService.userRegFlag = data.type;
                                                    $interval.cancel(timer);
                                                    if (data.type === 'MLTCF') {
                                                        regProcessWithAccNoService.registerWithATM = '';
                                                        registerWithSimService.MLTCFAcc = 'Y';

                                                        $state.go("menu.regAccountDetails");
                                                    } else $state.go('menu.userEligibility');
                                                }
                                            }, function (error1) {
                                                if (error1.responseCode === constantConfig.SB.errorCodeSB002) {
                                                    if (error1.responseMessage) {
                                                        var template = "<div class='sb_selection_error_msg'>" + error1.responseMessage + "</div>";
                                                        utilityService.showAlertPopUp('error', template, 'menu.landingWithOptions', loadSimDataVm.btnText, $scope, "sb_selection_error_popup");
                                                    }
                                                } else {
                                                    quickPayService.showAuthFailurePopup('error', error1.responseMessage, 'menu.selectSim', '', loadSimDataVm.btnText, '', $scope, false, function () { });
                                                }
                                                $interval.cancel(timer);
                                            });
                                        }, 15000);
                                    }
                                });
                            }, 15000);
                        }
                    });
                }, 15000);
            });
            return this;
        }
    ]);
