angularApp.service('registerWithSimService',
	function ($q, utilityService, AdapterUtils, $ionicPopup, $translate, loggedInUserService) {
		var registerWithSimService = this;
		registerWithSimService.simSubscriptionId = "";
		registerWithSimService.textMsg = "";
		registerWithSimService.simVMNValidate = "";
		registerWithSimService.simBindingVirtualMobile = "";
		registerWithSimService.userRegFlag = "";
		registerWithSimService.MLTCFAcc = "";
		registerWithSimService.isSimLogin = true;
		registerWithSimService.userWithoutSimReg = false;
		$translate('NO_SIM').then(function (translatedvalue) {
			registerWithSimService.noSimMsg = translatedvalue;
		});
		$translate('CHANGED_SIM').then(function (translatedvalue) {
			registerWithSimService.changedSimMsg = translatedvalue;
		});

		registerWithSimService.getRegTypeByMobile = function (payLoad) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreHomeLoginAdapter/getRegTypeByMobile", payLoad, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		registerWithSimService.getAccountByMultipleCIF = function (payLoad) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreHomeLoginAdapter/getAccountByMultipleCIF", payLoad, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		registerWithSimService.sbClearDataOnInvalidUser = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreHomeLoginAdapter/sbClearDataOnInvalidUser", {}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		registerWithSimService.logSBMsgSentTime = function (params) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreHomeLoginAdapter/logSBMsgSentTime", params , false).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		registerWithSimService.reloadAppSimBinding = function (message) {
			var reloadPopup = $ionicPopup.show({
				title: null,
				cssClass: 'my-custom-popup',
				template: '<div class="button_fund fontSize-subHeading roboto-light font-dark-grey">' + message + '</div>',
				scope: '',
				buttons: [{
					text: 'OK',
					type: 'button-assertive',
					onTap: function () {
						reloadPopup.close();
						utilityService.showSpinner();
						registerWithSimService.sbClearDataOnInvalidUser().then(function (response) {
							loggedInUserService.fileForStorageData('{"isDeviceRegistered":false,"mpinConsent":false, "simSubscriptionId":""}').then(function (res) {
								utilityService.hideSpinner();
								localStorage.setItem('isDeviceRegistered', false);
								localStorage.setItem('mpinConsent', false);
								loggedInUserService.logoutUser();
							}, function (err) {
								utilityService.hideSpinner();
								localStorage.setItem('isDeviceRegistered', false);
								localStorage.setItem('mpinConsent', false);
								loggedInUserService.logoutUser();
							});
						}, function (error) {
							utilityService.hideSpinner();
							utilityService.showErrorMessage(error.responseMessage);
						});
					}
				}, {
					text: 'Cancel',
					type: 'button-assertive',
					onTap: function () {
						reloadPopup.close();
					}
				}],
			});
		}
		registerWithSimService.reloadAppSimOk = function (message) {
			loggedInUserService.fileForStorageData('{"isDeviceRegistered":false,"mpinConsent":false, "simSubscriptionId":""}').then(function (res) {
				localStorage.setItem('isDeviceRegistered', false);
				localStorage.setItem('mpinConsent', false);
				registerWithSimService.showReloadPopup(message);
			}, function (err) {
				localStorage.setItem('isDeviceRegistered', false);
				localStorage.setItem('mpinConsent', false);
				registerWithSimService.showReloadPopup(message);
			});

		}
		registerWithSimService.showReloadPopup = function (message) {
			var reloadPopup = $ionicPopup.show({
				title: null,
				cssClass: 'my-custom-popup',
				template: '<div class="button_fund fontSize-subHeading roboto-light font-dark-grey">' + message + '</div>',
				scope: '',
				buttons: [{
					text: 'OK',
					type: 'button-assertive',
					onTap: function () {
						reloadPopup.close();
						loggedInUserService.logoutUser();
					}
				}],
			});
		}
		return registerWithSimService;
	});  
