'use strict';

angularApp.controller('activationCodeInbLoginController',
    ["$timeout", 
    "$state", 
    "$scope", 
    "$translate", 
    "$ionicSideMenuDelegate", 
    "ionicToast", 
    "$ionicPopup", 
    "$ionicScrollDelegate",
    "utilityService",
    "$ionicHistory",
    "ionicDatePicker",
    "$filter",
    "regProcessWithAccNoService",
    "$ionicPopover",
    "loggedInUserService",
    "cryptoService",
    "AdapterUtils",
    "constantConfig",
    "encryptionService",
    "internetBankingService",
    "clickStreamService",
    "$stateParams",
    function (
        $timeout, 
        $state, 
        $scope, 
        $translate, 
        $ionicSideMenuDelegate, 
        ionicToast, 
        $ionicPopup, 
        $ionicScrollDelegate,
        utilityService,
        $ionicHistory,
        ionicDatePicker,
        $filter,
        regProcessWithAccNoService,
        $ionicPopover,
        loggedInUserService,
        cryptoService,
        AdapterUtils,
        constantConfig,
        encryptionService,
        internetBankingService,
        clickStreamService,
        $stateParams) {

        var activationCodeInbLoginVM = this;
        activationCodeInbLoginVM.userNameMessage = "";
        activationCodeInbLoginVM.submitted = false;
        var patternForUserName = /^(?=.*[A-Z])(?=.*[a-z])(?=.*[0-9])/;
        var patternForPd = /^(?=.*[A-Z])(?=.*[a-z])(?=.*[0-9])(?=.*[#?!@$%^&*-])/;
        activationCodeInbLoginVM.isEyeClose = true;
        activationCodeInbLoginVM.isActivationCodeRequired = false;
        var previousScreen = $stateParams.previousPage;
        loggedInUserService.previousJourney = $stateParams.previousPage;
        activationCodeInbLoginVM.invalidReferralCode = false;
        var validRefCodePattern = /^[0][1-9]\d{9}$|^[1,6-9]\d{9}$/;
        
        var info = '';
        activationCodeInbLoginVM.goBack = function(){
            $ionicHistory.goBack(); 
        }

        activationCodeInbLoginVM.close = function(){
            $state.go("menu.selectSim");
        }
        
        activationCodeInbLoginVM.offeyeClick = function(){
            activationCodeInbLoginVM.isEyeClose = false;
        }
        activationCodeInbLoginVM.oneyeClick = function(){
            activationCodeInbLoginVM.isEyeClose = true;
        }

        activationCodeInbLoginVM.clearFields = function(){
            activationCodeInbLoginVM.inbUserName = "";
            activationCodeInbLoginVM.inbPassword = "";
            activationCodeInbLoginVM.inbReferralCode = "";
            activationCodeInbLoginVM.activationCode = "";
            activationCodeInbLoginVM.invalidReferralCode = false;
        };

        activationCodeInbLoginVM.refCodeChanged = function(){
            if(activationCodeInbLoginVM.inbReferralCode && (activationCodeInbLoginVM.inbReferralCode.length < 10 || activationCodeInbLoginVM.inbReferralCode.length > 0) && !validRefCodePattern.test(activationCodeInbLoginVM.inbReferralCode)){
                activationCodeInbLoginVM.invalidReferralCode = true;
            }
            else{
                activationCodeInbLoginVM.invalidReferralCode = false;
            }
        }

        activationCodeInbLoginVM.nextClick = function(){
            activationCodeInbLoginVM.submitted = true;
            if(!activationCodeInbLoginVM.invalidReferralCode){
                if(activationCodeInbLoginVM.inbUserName && activationCodeInbLoginVM.inbPassword && activationCodeInbLoginVM.activationCode){
                    activationCodeInbLoginVM.submitted = false;
                    utilityService.showSpinner();
                    internetBankingService.getServiceIdAndKey().then(function (data) {
                        loggedInUserService.keyIdINB = data.keyId;
                        loggedInUserService.serviceIdINB = data.serviceId;
                        loggedInUserService.finalSHA512Val = loggedInUserService.generateINBSHA512Val(activationCodeInbLoginVM.inbUserName, activationCodeInbLoginVM.inbPassword);
                        activationCodeInbLoginVM.continues();
                    }, function (error) {
                        activationCodeInbLoginVM.clearFields();
                        utilityService.hideSpinner();
                        if (error.responseMessage) {
                            utilityService.showErrorMessage(error.responseMessage);
                        } else {
                            utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
                        }
                    });
                   
                }
            }
        }
        activationCodeInbLoginVM.continues = function(){
            utilityService.showSpinner();
            loggedInUserService.inbUserName = activationCodeInbLoginVM.inbUserName;
            var reqParams = {
                "userName":activationCodeInbLoginVM.inbUserName,
                "sha512Password":loggedInUserService.finalSHA512Val,
                "bankCode": "0",
                "osName": device.platform,
                "channel": "lotus",
                "serviceId": loggedInUserService.serviceIdINB,
                "activationCode":activationCodeInbLoginVM.activationCode,
                "referralCode":activationCodeInbLoginVM.inbReferralCode ? activationCodeInbLoginVM.inbReferralCode : ""
            };
            
            regProcessWithAccNoService.custDetails = {
                uname:activationCodeInbLoginVM.inbUserName,
                pd:activationCodeInbLoginVM.inbPassword            
            }
            regProcessWithAccNoService.authenticateLogin(reqParams).then(function(response){
                utilityService.hideSpinner(); 
                regProcessWithAccNoService.cifn = response["cifNo"];
                $state.go("menu.successAccount");
            },function(error){
                utilityService.hideSpinner();
                activationCodeInbLoginVM.clearFields();
                var title = '';
                var template = error.responseMessage;
                var onTap = (error.responseCode && error.responseCode === "INB.AUTH.00") ? "menu.selectSim" : "";
                var buttontext = '<b>OK</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            });
        }

        activationCodeInbLoginVM.refCodeInfo = function($event){
        	var template = '<ion-popover-view class="tooltiptext-reg reg_popupinfo roboto-regular">'+
                            '<ion-content>'+
                                '<div class="reg_popupInfoCloseImg" ng-click="activationCodeInbLoginVM.closePopover()"><img alt="" src="./img/closed.svg"/></div>'+
                                '<div style="padding-right:20px;" translate="LBL_STEP3_REF_CODE_INFO_MSG"></div>'+
                            '</ion-content>'+
                        '</ion-popover-view>';

        $scope.popover = $ionicPopover.fromTemplate(template, {
            scope: $scope
        });
            $scope.popover.show($event);
        }
        activationCodeInbLoginVM.closePopover = function(){
            $scope.popover.hide();
        }

}]);