'use strict';

angularApp.controller('regOTPController',
    ["$timeout", 
    "$state", 
    "$scope", 
    "$translate", 
    "$ionicSideMenuDelegate", 
    "ionicToast", 
    "$ionicPopup", 
    "$ionicScrollDelegate",
    "utilityService",
    "$ionicHistory",
    "ionicDatePicker",
    "internetBankingService",
    "regProcessWithAccNoService",
    function (
        $timeout, 
        $state, 
        $scope, 
        $translate, 
        $ionicSideMenuDelegate, 
        ionicToast, 
        $ionicPopup, 
        $ionicScrollDelegate,
        utilityService,
        $ionicHistory,
        ionicDatePicker,
        internetBankingService,
        regProcessWithAccNoService) {

        var regOTPControllerVm = this;
        regOTPControllerVm.resendOTPCout = 1;
        regOTPControllerVm.customerDetails = regProcessWithAccNoService.customerDetails;
        regOTPControllerVm.customerDetails.mobileNumber = regProcessWithAccNoService.customerDetails.mobileNumber;
        if(regProcessWithAccNoService.customerDetails.email){
           	var mail = regProcessWithAccNoService.customerDetails.email;
			var subStr = mail.split("@")
			var tempOne = subStr[0]
			var a = tempOne.replace(/[0-9a-zA-Z.*+?^${}()|[\]\\]/g, 'X')
			a = a.split("")
			a[a.length - 1] = (tempOne.slice(-1));
			a[0] = (tempOne.substring(0,1));
			var tempTwo = subStr[1]
			var domainArr = tempTwo.split(".")
			var domain = domainArr[domainArr .length - 1]
			var maskCharSet = tempTwo.replace(/[0-9a-zA-Z.*+?^${}()|[\]\\]/g, 'X')
			var completeDomain = maskCharSet +"."+ domain
			completeDomain = completeDomain.substr((completeDomain.length - tempTwo.length), tempTwo.length)
			var emailFirstPart =  a.toString()
			emailFirstPart =  emailFirstPart.replace(",", "")
			emailFirstPart =  emailFirstPart.replace(/,/g, "")
			var maskedEmail = emailFirstPart +"@"+ completeDomain
            regOTPControllerVm.customerDetails.customerMaskedEmail = maskedEmail;
            regOTPControllerVm.isEmail = true;
           }
        regOTPControllerVm.isOTPRequired = false;

        regOTPControllerVm.close = function(){
            $state.go("menu.selectSim");
        }
        regOTPControllerVm.goBack = function(){
            $ionicHistory.goBack(); 
        }
        regOTPControllerVm.otpValidate = function(otpForm){
            if(regOTPControllerVm.otp1 && regOTPControllerVm.otp2 && regOTPControllerVm.otp3 && regOTPControllerVm.otp4 && regOTPControllerVm.otp5 && regOTPControllerVm.otp6){
                regOTPControllerVm.isOTPRequired = false;
                var otp = regOTPControllerVm.otp1+""+regOTPControllerVm.otp2+""+regOTPControllerVm.otp3+""+regOTPControllerVm.otp4+""+regOTPControllerVm.otp5+""+regOTPControllerVm.otp6;
                var reqParams = {
                    "otp":otp,
                    "mobile":regProcessWithAccNoService.customerDetails.mobileNumber,
                    "journeyName":regProcessWithAccNoService.registerWithATM !== 'Y' ? "REGISTRATION" : "NewAtmRegistration",
                    "data": {
                        "commonId": ""
                    }
                };
                regProcessWithAccNoService.validateOTP(reqParams).then(function (data) {
                    $state.go("menu.regReviewUserDetails");
                }, function (error) {
                    regOTPControllerVm.otp1 = "";
                    regOTPControllerVm.otp2 = "";
                    regOTPControllerVm.otp3 = "";
                    regOTPControllerVm.otp4 = "";
                    regOTPControllerVm.otp5 = "";
                    regOTPControllerVm.otp6 = "";
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
            else{
                regOTPControllerVm.isOTPRequired = true;
            }
            
            
        }

        //Resend OTP
        regOTPControllerVm.resendOTP = function(){
            if(!regOTPControllerVm.isDisabledOTPbtn){
                var reqParams = {
                    "id":regProcessWithAccNoService.customerDetails.mobileNumber,
                    "recipientMailId":"",
                    "sendOTPFlag":"",
                    "journeyName":regProcessWithAccNoService.registerWithATM !== 'Y' ? "REGISTRATION" : "NewAtmRegistration",
                };
                regProcessWithAccNoService.generateOTP(reqParams).then(function (data) {
                    var confirmPopup = $ionicPopup.confirm({
                        title: "",
                        template: "<div translate='LBL_STEP1_RESEND_OTP_SUCCESS_MSG'></div>",
                        cssClass: 'dialog',
                        scope: $scope,
                        buttons: [
                            {
                                text: 'OK',
                                onTap: function (e) {
                                    confirmPopup.close();
                                }
                            }
                        ]
                    });
                    if(regOTPControllerVm.resendOTPCout != 2){
                        regOTPControllerVm.resendOTPCout = regOTPControllerVm.resendOTPCout+1;
                    }else{
                        regOTPControllerVm.isDisabledOTPbtn = true;
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        }
}]);
