'use strict';

angularApp.controller('regProcessMenuController',
    ["$timeout", 
    "$state", 
    "$scope", 
    "$translate", 
    "$ionicSideMenuDelegate", 
    "ionicToast", 
    "$ionicPopup", 
    "$ionicScrollDelegate",
    "utilityService",
    "$ionicHistory",
    "regProcessWithAccNoService",
    "loggedInUserService",
    "currentLocationService",
    function (
        $timeout, 
        $state, 
        $scope, 
        $translate, 
        $ionicSideMenuDelegate, 
        ionicToast, 
        $ionicPopup, 
        $ionicScrollDelegate,
        utilityService,
        $ionicHistory,
        regProcessWithAccNoService,
        loggedInUserService,
        currentLocationService) {

        var regProcessMenuControllerVm = this;

        regProcessMenuControllerVm.isRequestNumberCreated = regProcessWithAccNoService.isRequestNumberCreated;
        regProcessMenuControllerVm.reqNumber = regProcessWithAccNoService.requestNumber;
        regProcessMenuControllerVm.selectedBranchDetails = regProcessWithAccNoService.selectedBranchDetails;
        regProcessMenuControllerVm.isActivationCodeBtnClicked = regProcessWithAccNoService.isActivationCodeBtnClicked;
        regProcessMenuControllerVm.isStepDisplay = regProcessWithAccNoService.isStepDisplay;

        regProcessMenuControllerVm.goBack = function(){
            $ionicHistory.goBack();    
        }
        regProcessMenuControllerVm.close = function(){
            loggedInUserService.exitApplication();
        }
        regProcessMenuControllerVm.continue = function(){
            if(regProcessMenuControllerVm.isActivationCodeBtnClicked){
                $state.go("menu.activationCodeInbLogin");
            }
            else{
                $state.go("menu.regAccountDetails");
              
            }
        }

        regProcessMenuControllerVm.locateNearestBranch = function(){
            utilityService.showSpinner();
            $timeout(function () {
                currentLocationService.getCurrentPosition().then(
					function (position) {
                        utilityService.hideSpinner();
                        var geocoords = regProcessMenuControllerVm.selectedBranchDetails.latitude + ',' + regProcessMenuControllerVm.selectedBranchDetails.longitude;
                        
                            cordova.ThemeableBrowser.open('https://www.google.com/maps/search/?api=1&query='+geocoords, '_blank',
                            {
                                statusbar: {
                                    color:'#ffffffff'
                                },
                                toolbar: {
                                    height: 37,
                                    color: '#ffffffff',
                                    image: 'share'
                                },
          
                                closeButton: {
                                    image:'back',
                                    height: 37,
                                    width: 32,
                                    align: 'left',
                                    event: 'closePressed'
                                },
          
                                backButtonCanClose: true
                            });
                        
					},
					function (err) {
						utilityService.hideSpinner();
						var title = '';
						var template = '{{"ON_GPS" | translate}}';
						var onTap = '';
						var buttontext = '<b>OK</b>';
						utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
					});
            },2000);
        }
}]);