'use strict';

angularApp.controller('regSetInbPasswordController',
    ["$timeout", 
    "$state", 
    "$scope", 
    "$translate", 
    "$ionicSideMenuDelegate", 
    "ionicToast", 
    "$ionicPopup", 
    "$ionicScrollDelegate",
    "utilityService",
    "$ionicHistory",
    "ionicDatePicker",
    "$filter",
    "regProcessWithAccNoService",
    "loggedInUserService",
    "constantConfig",
    "cryptoService",
    "encryptionService",
    "AdapterUtils",
    "internetBankingService",
    "clickStreamService",
    "mPinLoginService",
    "$rootScope",
    function (
        $timeout, 
        $state, 
        $scope, 
        $translate, 
        $ionicSideMenuDelegate, 
        ionicToast, 
        $ionicPopup, 
        $ionicScrollDelegate,
        utilityService,
        $ionicHistory,
        ionicDatePicker,
        $filter,
        regProcessWithAccNoService,
        loggedInUserService,
        constantConfig,
        cryptoService,
        encryptionService,
        AdapterUtils,
        internetBankingService,
        clickStreamService,
        mPinLoginService,
        $rootScope) {

        if(window.cordova && window.cordova.plugins.Keyboard){
            window.cordova.plugins.Keyboard.disableScroll(true);
        }   
        
        var regSetInbPasswordVm = this; 
        regSetInbPasswordVm.userProfile = loggedInUserService.userProfile;
        regSetInbPasswordVm.inbUsername = loggedInUserService.inbUserName;
        regSetInbPasswordVm.userNameMessage = "";
        regSetInbPasswordVm.submitted = false;
        regSetInbPasswordVm.pwdErrorMessgae = "";
        var patternForPd = /^(?=.*[A-Z])(?=.*[a-z])(?=.*[0-9])(?=.*[#?!@$%^&*-])/;
        regSetInbPasswordVm.isReEnterNotPdMatch = false;
        regSetInbPasswordVm.isEyeClose = true;
        regSetInbPasswordVm.customerDetails = regProcessWithAccNoService.customerDetails;

        regSetInbPasswordVm.isChallenged = false;
		regSetInbPasswordVm.securityCheckName = "AuthenticateMPinSecurityCheck";
		regSetInbPasswordVm.mPinAuthChallengeHandler = WL.Client.createSecurityCheckChallengeHandler(regSetInbPasswordVm.securityCheckName);
        regSetInbPasswordVm.mPinAuthChallengeHandler.securityCheckName = regSetInbPasswordVm.securityCheckName;
        regSetInbPasswordVm.keystoreValue = loggedInUserService.keystoreValue;
        $scope.passwordFocus = false;

        regSetInbPasswordVm.inbPassword = "";
        regSetInbPasswordVm.inbRePassword = "";

        regSetInbPasswordVm.close = function(){
            $state.go("menu.selectSim");
        }

        
        regSetInbPasswordVm.passFieldValidate = function(){
            var isValidPd = patternForPd.test(regSetInbPasswordVm.inbPassword);
			if(regSetInbPasswordVm.inbPassword.length <= 7 || !isValidPd){
                $ionicScrollDelegate.scrollTop();
                regSetInbPasswordVm.pwdErrorMessgae = $filter('translate')("LBL_PASSWORD_ERROR_MESSAGE");
            }
            else{
                regSetInbPasswordVm.pwdErrorMessgae = "";
                regSetInbPasswordVm.inbPassword !== regSetInbPasswordVm.inbRePassword ? regSetInbPasswordVm.isReEnterNotPdMatch = true : regSetInbPasswordVm.isReEnterNotPdMatch = false;
            }
        }

        regSetInbPasswordVm.confirmPassFieldValidate = function(){
            var isValidPd = patternForPd.test(regSetInbPasswordVm.inbRePassword);
			if(regSetInbPasswordVm.inbPassword.length <= 7 || !isValidPd){
                $ionicScrollDelegate.scrollTop();
                regSetInbPasswordVm.pwdErrorMessgae = $filter('translate')("LBL_PASSWORD_ERROR_MESSAGE");
            }
            else{
                regSetInbPasswordVm.pwdErrorMessgae = "";
                regSetInbPasswordVm.inbPassword !== regSetInbPasswordVm.inbRePassword ? regSetInbPasswordVm.isReEnterNotPdMatch = true : regSetInbPasswordVm.isReEnterNotPdMatch = false;
            }
        }
        
        regSetInbPasswordVm.userValidate = function(bankForm){
            
            regSetInbPasswordVm.submitted = true;
            var isValidPd = patternForPd.test(regSetInbPasswordVm.inbPassword);

            if(!regSetInbPasswordVm.inbPassword || regSetInbPasswordVm.inbPassword.length <= 7 || !isValidPd){
                regSetInbPasswordVm.pwdErrorMessgae = $filter('translate')("LBL_PASSWORD_ERROR_MESSAGE");
            }
            else{
                regSetInbPasswordVm.pwdErrorMessgae = "";
                regSetInbPasswordVm.inbPassword !== regSetInbPasswordVm.inbRePassword ? regSetInbPasswordVm.isReEnterNotPdMatch = true : regSetInbPasswordVm.isReEnterNotPdMatch = false;

                if(!regSetInbPasswordVm.isReEnterNotPdMatch)
                    regSetInbPasswordVm.userregistrationService();
            }
        }

        regSetInbPasswordVm.userregistrationService = function(){
            var reqParams = {};
            if (loggedInUserService.isServerConnected) {
                regSetInbPasswordVm.validateUser();
            } else {
                regSetInbPasswordVm.connectServer();
            }
            
        }
        
        regSetInbPasswordVm.offeyeClick = function(){
            regSetInbPasswordVm.isEyeClose = false;
        }
        regSetInbPasswordVm.oneyeClick = function(){
            regSetInbPasswordVm.isEyeClose = true;
        }

        regSetInbPasswordVm.validateUser = function(){
            utilityService.showSpinner();
            internetBankingService.getServiceIdAndKey().then(function (data) {
                loggedInUserService.keyIdINB = data.keyId;
                loggedInUserService.serviceIdINB = data.serviceId;
                loggedInUserService.finalSHA512Val = loggedInUserService.generateINBSHA512Val(loggedInUserService.inbUserName, regSetInbPasswordVm.inbPassword);
                regSetInbPasswordVm.continues();
            }, function (error) {
                regSetInbPasswordVm.clearFields();
                utilityService.hideSpinner();
                if (error.responseMessage) {
                    utilityService.showErrorMessage(error.responseMessage);
                } else {
                    utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
                }
            });
        }

        regSetInbPasswordVm.continues = function(){
            regSetInbPasswordVm.mPinAuthChallengeHandler.handleChallenge = function (challenge) {
                regSetInbPasswordVm.isChallenged = true;
                utilityService.accessRestricted = "";
                utilityService.hideSpinner();
                regSetInbPasswordVm.clearFields();
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "NEXT_BTN"));
            }

            regSetInbPasswordVm.mPinAuthChallengeHandler.handleSuccess = function (data) {
                var today = $filter('date')(new Date(), 'dd MM yyyy HH:mm:ss:sss');
                regSetInbPasswordVm.isChallenged = false;
                if (data.user) {
                    loggedInUserService.keyId = AdapterUtils.secretData == "" ? data.user.attributes.keyId : encryptionService.getAES256DecryptedData(data.user.attributes.keyId);
                    loggedInUserService.tokenLotus = AdapterUtils.secretData == "" ? data.user.attributes.lotusToken : encryptionService.getAES256DecryptedData(data.user.attributes.lotusToken);
                    var userDetails = AdapterUtils.secretData == "" ? data.user.attributes.userDetails : encryptionService.getAES256DecryptedData(data.user.attributes.userDetails);
                    if (data.user.attributes.sessionId && data.user.attributes.lotusId) {
                        clickStreamService.sessionId = AdapterUtils.secretData == "" ? data.user.attributes.sessionId : encryptionService.getAES256DecryptedData(data.user.attributes.sessionId);
                        clickStreamService.lotusId = AdapterUtils.secretData == "" ? data.user.attributes.lotusId : encryptionService.getAES256DecryptedData(data.user.attributes.lotusId);
                    }
                    utilityService.hideSpinner();
                    
                    loggedInUserService.setUserProfileDetails(JSON.parse(userDetails));
                }
            }

            regSetInbPasswordVm.mPinAuthChallengeHandler.handleFailure = function (error) {
                var today = $filter('date')(new Date(), 'dd MM yyyy HH:mm:ss:sss');
                if (regSetInbPasswordVm.isChallenged) {
                    regSetInbPasswordVm.mPinAuthChallengeHandler.cancel();
                    regSetInbPasswordVm.isChallenged = false;
                }
                regSetInbPasswordVm.clearFields();
                utilityService.accessRestricted = "";
                utilityService.hideSpinner();
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "NEXT_BTN"));
                if (error.failure) {
                    utilityService.showErrorMessage(error.failure);
                } else {
                    utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
                }
            }

            var payload = {};
            var today = $filter('date')(new Date(), 'dd MM yyyy HH:mm:ss:sss');
            var requestParams = {
        		"userName": loggedInUserService.inbUserName,
        		"newPassword" : regSetInbPasswordVm.inbPassword.trim(),
        		"cifNo" : regProcessWithAccNoService.cifn,
                "mfDeviceId":loggedInUserService.deviceIdForMpin,
                "deviceId":loggedInUserService.deviceInfo
        	};

        	var src = cryptoService.encryptRSAWithPublicKey(encryptionService.iv + "^" + encryptionService.passphrase + "^" + encryptionService.salt, cryptoService.rsaPublicKey);
        	payload = {
        		"data": AdapterUtils.secretData + encryptionService.getAES256EncryptedData(JSON.stringify(requestParams)),
        		"src": src
            }
            payload = AdapterUtils.secretData == "" ? requestParams : payload;
        	if (regSetInbPasswordVm.isChallenged) {
        		regSetInbPasswordVm.mPinAuthChallengeHandler.submitChallengeAnswer(payload);
        	} else {
        		WLAuthorizationManager.login(regSetInbPasswordVm.mPinAuthChallengeHandler.securityCheckName, payload).then(
        			function (data) {
        				mPinLoginService.isLoggedIn = true;
                        utilityService.accessRestricted = utilityService.mPinAuthRequire;
        				utilityService.hideSpinner();
        				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "NEXT_BTN"));
        				$state.go('menu.skipsetMpin');
        			},
        			function (error) {
        				regSetInbPasswordVm.clearFields();
        				utilityService.accessRestricted = "";
        				utilityService.hideSpinner();
        				if (error.errorCode == 'CHALLENGE_HANDLING_CANCELED' || error.errorCode == 'APPLICATION_DISABLED') {
        					return;
        				}
        				if (error.errorCode == "LOGIN_ALREADY_IN_PROCESS") {
        					regSetInbPasswordVm.mPinAuthChallengeHandler.cancel();
        				}
        				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "NEXT_BTN"));
        				utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
        			});
        	}
        }
        regSetInbPasswordVm.clearFields = function(){
            regSetInbPasswordVm.inbPassword = "";
            regSetInbPasswordVm.inbRePassword = "";
        }

        regSetInbPasswordVm.connectServer = function(){
            var err = "";
            try{
                utilityService.showSpinner();
                var payload = {
                    "data": cryptoService.encryptRSAWithPublicKey(encryptionService.iv + "^" + encryptionService.passphrase + "^" + encryptionService.salt, cryptoService.rsaPublicKey),
                    "src": regSetInbPasswordVm.keystoreValue != "" ? cryptoService.encryptRSAWithPublicKey(regSetInbPasswordVm.keystoreValue, cryptoService.rsaPublicKey) : "",
                };
                var resourceRequest = new WLResourceRequest("adapters/CustomSessionAdapter/saveCustomInformation", WLResourceRequest.POST, { timeout: 15000 });
                resourceRequest.send(payload).then(function (response) {
                    utilityService.lastTimeStamp = new Date();
					response.responseText = utilityService.isJSON(response.responseText) ? JSON.parse(response.responseText) : JSON.parse(encryptionService.getAES256DecryptedData(response.responseText));
					if (response.responseText.responseCode == '0000') {
						AdapterUtils.secretData = response.responseText.data.key;
						loggedInUserService.keyId = response.responseText.data.keyId;
						loggedInUserService.deviceIdForMpin = response.responseText.data.deviceId;
						loggedInUserService.upiPermissionKey = response.responseText.data.upiPermissionVal;
						utilityService.getUPIPermissions(loggedInUserService.upiPermissionKey);
						loggedInUserService.isServerConnected = true;
						utilityService.hideSpinner();
						regSetInbPasswordVm.validateUser();
					} else if (response.responseText.responseCode == '0001') {
						err = response.responseText.responseCode + " : " + constantConfig.adapter.CANNOT_PROCESS_NOW;
						loggedInUserService.isServerConnected = false;
						regSetInbPasswordVm.serverConnectErrorPopup(err);
						return;
					} else if (response.responseText.responseCode == '0002') {
						err = response.responseText.responseCode + " : " + constantConfig.adapter.CANNOT_PROCESS_NOW;
						loggedInUserService.isServerConnected = false;
						regSetInbPasswordVm.serverConnectErrorPopup(err);
						return;
					} else if (response.responseText.responseCode == '0003' || response.responseText.responseCode == '0004') {
						err = response.responseText.responseCode + " : " + response.responseText.responseMessage;
						loggedInUserService.isServerConnected = false;
						regSetInbPasswordVm.serverConnectErrorPopup(err);
						return;
					}
                }, function (error) {
                    loggedInUserService.isServerConnected = false;
                    if (error.errorCode == 'APPLICATION_DOES_NOT_EXIST') {
                        err = error;
                        regSetInbPasswordVm.inbPassword = "";
                        regSetInbPasswordVm.inbRePassword = "";
                        utilityService.hideSpinner();
                        utilityService.showUpgradeMessage(err);
                    } else {
                        err = utilityService.getServerExceptionMessage(error);
                        regSetInbPasswordVm.serverConnectErrorPopup(err);
                    }
                });
            }
            catch(error){
                loggedInUserService.isServerConnected = false;
                err = constantConfig.adapter.SOMETHING_WENT_WRONG;
                regSetInbPasswordVm.serverConnectErrorPopup(err);
            }
        }

        regSetInbPasswordVm.serverConnectErrorPopup = function(err){
            regSetInbPasswordVm.inbPassword = "";
            regSetInbPasswordVm.inbRePassword = "";
            utilityService.hideSpinner();
            utilityService.showErrorMessage(err);
        }

        $scope.$on('$ionicView.loaded', function () {
			$ionicSideMenuDelegate.canDragContent(false);
            $rootScope.isInUserLogin = true;
        });
        
        $scope.$on('$ionicView.afterLeave', function () {
			$ionicSideMenuDelegate.canDragContent(false);
			$rootScope.isInUserLogin = false;
		});
}]);