'use strict';

angularApp.controller('regSetIntBankingDetailsController',
    ["$timeout", 
    "$state", 
    "$scope", 
    "$translate", 
    "$ionicSideMenuDelegate", 
    "ionicToast", 
    "$ionicPopup", 
    "$ionicScrollDelegate",
    "utilityService",
    "$ionicHistory",
    "ionicDatePicker",
    "$filter",
    "loggedInUserService",
    "AdapterUtils",
    "constantConfig",
    "clickStreamService",
    "cryptoService",
    "encryptionService",
    "mPinLoginService",
    "regProcessWithAccNoService",
    "internetBankingService",
    function (
        $timeout, 
        $state, 
        $scope, 
        $translate, 
        $ionicSideMenuDelegate, 
        ionicToast, 
        $ionicPopup, 
        $ionicScrollDelegate,
        utilityService,
        $ionicHistory,
        ionicDatePicker,
        $filter,
        loggedInUserService,
        AdapterUtils,
        constantConfig,
        clickStreamService,
        cryptoService,
        encryptionService,
        mPinLoginService,
        regProcessWithAccNoService,
        internetBankingService) {

        var regSetBankDetailsVM = this;
        regSetBankDetailsVM.userNameMessage = "";
        regSetBankDetailsVM.isUserNameAvailable = false;
        regSetBankDetailsVM.userNameErrorMessgae = "";
        regSetBankDetailsVM.submitted = false;
        regSetBankDetailsVM.pwdErrorMessgae = "";
        var patternForUserName = /^(?=.*[a-z])(?=.*[0-9])/;
        var patternForPd = /^(?=.*[A-Z])(?=.*[a-z])(?=.*[0-9])(?=.*[#?!@$%^&*-])/;
        var patternForInvalidUserName = /^(?=.*[#?!@$%^&*(){};.,'"_=~:₹|/\-+\s.+$])/;
        regSetBankDetailsVM.isReEnterNotPdMatch = false;
        regSetBankDetailsVM.isEyeClose = true;
        regSetBankDetailsVM.reenterisEyeClose = true;
        regSetBankDetailsVM.customerDetails = regProcessWithAccNoService.customerDetails;
        regSetBankDetailsVM.isAndroid = utilityService.isAndroidPlatform();
        regSetBankDetailsVM.inputType = "password";
        regSetBankDetailsVM.reenterinputType = "password";
        regSetBankDetailsVM.registerWithATM = regProcessWithAccNoService.registerWithATM;
        $scope.focus = false;
        $scope.reFocus =false;

        regSetBankDetailsVM.inbUserName = "";
        regSetBankDetailsVM.inbPassword = "";
        regSetBankDetailsVM.inbRePassword = "";

        regSetBankDetailsVM.isChallenged = false;
        regSetBankDetailsVM.securityCheckName = "AuthenticateMPinSecurityCheck";
        regSetBankDetailsVM.mPinAuthChallengeHandler = WL.Client.createSecurityCheckChallengeHandler(regSetBankDetailsVM.securityCheckName);
        regSetBankDetailsVM.mPinAuthChallengeHandler.securityCheckName = regSetBankDetailsVM.securityCheckName;
        regSetBankDetailsVM.keystoreValue = loggedInUserService.keystoreValue;

        regSetBankDetailsVM.close = function(){
            $state.go("menu.selectSim");
        }


        
        
        regSetBankDetailsVM.usernameValidate = function(){
            $scope.focus = false;
            $scope.isScroll = false;
        	//regSetBankDetailsVM.submitted = true;
            var isValidUsername = patternForUserName.test(regSetBankDetailsVM.inbUserName);
            var isInvalidUsername = patternForInvalidUserName.test(regSetBankDetailsVM.inbUserName);
            
            if(regSetBankDetailsVM.inbUserName.length <= 2 || !isValidUsername || isInvalidUsername){
                regSetBankDetailsVM.isAndroid ? $ionicScrollDelegate.scrollTop() : "";
                regSetBankDetailsVM.userNameErrorMessgae = $filter('translate')("LBL_USERNAME_ERROR_MESSAGE");
            }
            else{
                regSetBankDetailsVM.userNameErrorMessgae = "";
            }

        }
        
        regSetBankDetailsVM.passFieldValidate = function(bankForm){
        	var isValidPd = patternForPd.test(regSetBankDetailsVM.inbPassword);
			if(regSetBankDetailsVM.inbPassword.length <= 7 || !isValidPd){
                regSetBankDetailsVM.isAndroid ? $ionicScrollDelegate.scrollTop() : "";
                regSetBankDetailsVM.pwdErrorMessgae = $filter('translate')("LBL_PASSWORD_ERROR_MESSAGE");
            }
            else{
                regSetBankDetailsVM.pwdErrorMessgae = "";
                regSetBankDetailsVM.inbPassword !== regSetBankDetailsVM.inbRePassword ? regSetBankDetailsVM.isReEnterNotPdMatch = true : regSetBankDetailsVM.isReEnterNotPdMatch = false;
            }
        }
        
        regSetBankDetailsVM.confirmPassFieldValidate = function(bankForm){
        	var isValidPd = patternForPd.test(regSetBankDetailsVM.inbPassword);
			if(regSetBankDetailsVM.inbPassword.length <= 7 || !isValidPd){
                regSetBankDetailsVM.isAndroid ? $ionicScrollDelegate.scrollTop() : "";
                regSetBankDetailsVM.pwdErrorMessgae = $filter('translate')("LBL_PASSWORD_ERROR_MESSAGE");
            }
            else{
                regSetBankDetailsVM.pwdErrorMessgae = "";
                regSetBankDetailsVM.inbPassword !== regSetBankDetailsVM.inbRePassword ? regSetBankDetailsVM.isReEnterNotPdMatch = true : regSetBankDetailsVM.isReEnterNotPdMatch = false;
            }
        }
       
        
        regSetBankDetailsVM.userValidate = function(bankForm){
            regSetBankDetailsVM.submitted = true;
            var isValidUsername = patternForUserName.test(regSetBankDetailsVM.inbUserName);
            var isValidPd = patternForPd.test(regSetBankDetailsVM.inbPassword);
            var isInvalidUsername = patternForInvalidUserName.test(regSetBankDetailsVM.inbUserName);

            if(!regSetBankDetailsVM.inbUserName || regSetBankDetailsVM.inbUserName.length <= 2 || !isValidUsername || isInvalidUsername){
                regSetBankDetailsVM.isAndroid ? $ionicScrollDelegate.scrollTop() : "";
                regSetBankDetailsVM.userNameErrorMessgae = $filter('translate')("LBL_USERNAME_ERROR_MESSAGE");
            }
            else{
                regSetBankDetailsVM.userNameErrorMessgae = "";
            }

            if(!regSetBankDetailsVM.inbPassword || regSetBankDetailsVM.inbPassword.length <= 7 || !isValidPd){
                regSetBankDetailsVM.isAndroid ? $ionicScrollDelegate.scrollTop() : "";
                regSetBankDetailsVM.pwdErrorMessgae = $filter('translate')("LBL_PASSWORD_ERROR_MESSAGE");
            }
            else{
                regSetBankDetailsVM.pwdErrorMessgae = "";
                regSetBankDetailsVM.inbPassword !== regSetBankDetailsVM.inbRePassword ? regSetBankDetailsVM.isReEnterNotPdMatch = true : regSetBankDetailsVM.isReEnterNotPdMatch = false;

                if(!regSetBankDetailsVM.isReEnterNotPdMatch)
                    regSetBankDetailsVM.userregistrationService();
            }
        }

        regSetBankDetailsVM.userregistrationService = function() {
            if (!regSetBankDetailsVM.userNameErrorMessgae && !regSetBankDetailsVM.pwdErrorMessgae) {
                if(regSetBankDetailsVM.registerWithATM === 'Y')
                    regSetBankDetailsVM.atmRegistration();
                else regSetBankDetailsVM.branchRegistration();
            }
        }
        regSetBankDetailsVM.branchRegistration = function(){
            var requestParams = {
                "userName":regSetBankDetailsVM.inbUserName,
                "password":regSetBankDetailsVM.inbPassword,
                "channel":"",
                "cifNo":regSetBankDetailsVM.customerDetails.cifNumber,
                "referenceNumber":"",
                "transactionRights":regProcessWithAccNoService.transactionDetails.transType,
                "activationBranchCode":regProcessWithAccNoService.selectedBranchDetails.id,
                "activationBranchName":regProcessWithAccNoService.selectedBranchDetails.branchName,
            }
            regProcessWithAccNoService.setInternetBankingDetails(requestParams).then(function (response) {
                regProcessWithAccNoService.isRequestNumberCreated = true;
                regProcessWithAccNoService.requestNumber = response.id;
                regProcessWithAccNoService.isStepDisplay = false;
                $state.go('menu.regProcessMenu');
            }, function (error) {
                regSetBankDetailsVM.isAndroid ? $ionicScrollDelegate.scrollTop() : "";
                if(error.responseCode === "0001"){
                    regSetBankDetailsVM.userNameErrorMessgae = error.responseMessage;
                }
                else{
                    utilityService.showErrorMessage(error.responseMessage);
                }
            });
            
        }
        regSetBankDetailsVM.atmRegistration = function(){
            var reqParams = {};
            //Challenge Handler
            if (loggedInUserService.isServerConnected) {
                regSetBankDetailsVM.validateUser();
            } else {
                regSetBankDetailsVM.connectServer();
            }
        }
        regSetBankDetailsVM.validateUser = function() {
            utilityService.showSpinner();
            regSetBankDetailsVM.mPinAuthChallengeHandler.handleChallenge = function (challenge) {
                regSetBankDetailsVM.isChallenged = true;
                utilityService.accessRestricted = "";
                utilityService.hideSpinner();
                regSetBankDetailsVM.clearFields();
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "NEXT_BTN"));
                
                if(challenge.errorCode === "0002"){
                    regSetBankDetailsVM.userNameErrorMessgae = challenge.errorMsg;
                }
                else{
                    utilityService.showErrorMessage(challenge.errorMsg);
                }
            }

            regSetBankDetailsVM.mPinAuthChallengeHandler.handleSuccess = function (data) {
                var today = $filter('date')(new Date(), 'dd MM yyyy HH:mm:ss:sss');
                regSetBankDetailsVM.isChallenged = false;
                if (data.user) {
                    loggedInUserService.keyId = AdapterUtils.secretData === "" ? data.user.attributes.keyId : encryptionService.getAES256DecryptedData(data.user.attributes.keyId);
                    loggedInUserService.tokenLotus = AdapterUtils.secretData === "" ? data.user.attributes.lotusToken : encryptionService.getAES256DecryptedData(data.user.attributes.lotusToken);
                    var userDetails = AdapterUtils.secretData === "" ? data.user.attributes.userDetails : encryptionService.getAES256DecryptedData(data.user.attributes.userDetails);
                    if (data.user.attributes.sessionId && data.user.attributes.lotusId) {
                        clickStreamService.sessionId = AdapterUtils.secretData === "" ? data.user.attributes.sessionId : encryptionService.getAES256DecryptedData(data.user.attributes.sessionId);
                        clickStreamService.lotusId = AdapterUtils.secretData === "" ? data.user.attributes.lotusId : encryptionService.getAES256DecryptedData(data.user.attributes.lotusId);
                    }
                    utilityService.hideSpinner();
                    loggedInUserService.setUserProfileDetails(JSON.parse(userDetails));
                }
            }

            regSetBankDetailsVM.mPinAuthChallengeHandler.handleFailure = function (error) {
                var today = $filter('date')(new Date(), 'dd MM yyyy HH:mm:ss:sss');
                if (regSetBankDetailsVM.isChallenged) {
                    regSetBankDetailsVM.mPinAuthChallengeHandler.cancel();
                    regSetBankDetailsVM.isChallenged = false;
                }
                regSetBankDetailsVM.clearFields();
                utilityService.accessRestricted = "";
                utilityService.hideSpinner();
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "NEXT_BTN"));
                if (error.failure) {
                    utilityService.showErrorMessage(error.failure);
                } else {
                    utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
                }
            }

            var payload = {};
            var today = $filter('date')(new Date(), 'dd MM yyyy HH:mm:ss:sss');

            var requestParams = {
                "userName": regSetBankDetailsVM.inbUserName,
                "blockPassword" : regSetBankDetailsVM.inbPassword.trim(),
                "cifNo" : regProcessWithAccNoService.customerDetails.cifNumber,
                "mfDeviceId":loggedInUserService.deviceIdForMpin,
                "deviceId":loggedInUserService.deviceInfo,
                "transactionRights":regProcessWithAccNoService.transactionDetails.transType,
                "referralCode":regProcessWithAccNoService.regReferralCode || '',
                "bankCode": "0",
                "osName": device.platform
            };
            var src = cryptoService.encryptRSAWithPublicKey(encryptionService.iv + "^" + encryptionService.passphrase + "^" + encryptionService.salt, cryptoService.rsaPublicKey);
            payload = {
                "data": AdapterUtils.secretData + encryptionService.getAES256EncryptedData(JSON.stringify(requestParams)),
                "src": src
            }
            payload = AdapterUtils.secretData === "" ? requestParams : payload;
            if (regSetBankDetailsVM.isChallenged) {
                regSetBankDetailsVM.mPinAuthChallengeHandler.submitChallengeAnswer(payload);
            } else {
                WLAuthorizationManager.login(regSetBankDetailsVM.mPinAuthChallengeHandler.securityCheckName, payload).then(
                function (data) {
                    mPinLoginService.isLoggedIn = true;
                    utilityService.accessRestricted = utilityService.mPinAuthRequire;
                    utilityService.hideSpinner();
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "NEXT_BTN"));
                    $state.go('menu.skipsetMpin');
                },
                function (error) {
                    regSetBankDetailsVM.clearFields();
                    utilityService.accessRestricted = "";
                    utilityService.hideSpinner();
                    if (error.errorCode == 'CHALLENGE_HANDLING_CANCELED' || error.errorCode == 'APPLICATION_DISABLED') {
                        return;
                    }
                    if (error.errorCode == "LOGIN_ALREADY_IN_PROCESS") {
                        regSetBankDetailsVM.mPinAuthChallengeHandler.cancel();
                    }
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "NEXT_BTN"));
                    utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
                });
            }
        }
        regSetBankDetailsVM.clearFields = function(){
            regSetBankDetailsVM.inbPassword = "";
            regSetBankDetailsVM.inbRePassword = "";
        }

        regSetBankDetailsVM.connectServer = function(){
            var err = "";
            try{
                utilityService.showSpinner();
                var payload = {
                    "data": cryptoService.encryptRSAWithPublicKey(encryptionService.iv + "^" + encryptionService.passphrase + "^" + encryptionService.salt, cryptoService.rsaPublicKey),
                    "src": regSetBankDetailsVM.keystoreValue != "" ? cryptoService.encryptRSAWithPublicKey(regSetBankDetailsVM.keystoreValue, cryptoService.rsaPublicKey) : "",
                };
                var resourceRequest = new WLResourceRequest("adapters/CustomSessionAdapter/saveCustomInformation", WLResourceRequest.POST, { timeout: 15000 });
                resourceRequest.send(payload).then(function (response) {
                    utilityService.lastTimeStamp = new Date();
                    response.responseText = utilityService.isJSON(response.responseText) ? JSON.parse(response.responseText) : JSON.parse(encryptionService.getAES256DecryptedData(response.responseText));
                    if (response.responseText.responseCode == '0000') {
                        AdapterUtils.secretData = response.responseText.data.key;
                        loggedInUserService.keyId = response.responseText.data.keyId;
                        loggedInUserService.deviceIdForMpin = response.responseText.data.deviceId;
                        loggedInUserService.upiPermissionKey = response.responseText.data.upiPermissionVal;
                        utilityService.getUPIPermissions(loggedInUserService.upiPermissionKey);
                        loggedInUserService.isServerConnected = true;
                        utilityService.hideSpinner();
                        regSetBankDetailsVM.validateUser();
                    } else if (response.responseText.responseCode == '0001') {
                        err = response.responseText.responseCode + " : " + constantConfig.adapter.CANNOT_PROCESS_NOW;
                        loggedInUserService.isServerConnected = false;
                        regSetBankDetailsVM.serverConnectErrorPopup(err);
                        return;
                    } else if (response.responseText.responseCode == '0002') {
                        err = response.responseText.responseCode + " : " + constantConfig.adapter.CANNOT_PROCESS_NOW;
                        loggedInUserService.isServerConnected = false;
                        regSetBankDetailsVM.serverConnectErrorPopup(err);
                        return;
                    } else if (response.responseText.responseCode == '0003' || response.responseText.responseCode == '0004') {
                        err = response.responseText.responseCode + " : " + response.responseText.responseMessage;
                        loggedInUserService.isServerConnected = false;
                        regSetBankDetailsVM.serverConnectErrorPopup(err);
                        return;
                    }
                }, function (error) {
                    loggedInUserService.isServerConnected = false;
                    if (error.errorCode == 'APPLICATION_DOES_NOT_EXIST') {
                        err = error;
                        regSetBankDetailsVM.clearFields();
                        utilityService.hideSpinner();
                        utilityService.showUpgradeMessage(err);
                    } else {
                        err = utilityService.getServerExceptionMessage(error);
                        regSetBankDetailsVM.serverConnectErrorPopup(err);
                    }
                });
            }
            catch(error){
                loggedInUserService.isServerConnected = false;
                err = constantConfig.adapter.SOMETHING_WENT_WRONG;
                regSetBankDetailsVM.serverConnectErrorPopup(err);
            }
        }

        regSetBankDetailsVM.serverConnectErrorPopup = function(err){
            regSetBankDetailsVM.clearFields();
            utilityService.hideSpinner();
            utilityService.showErrorMessage(err);
        }
        regSetBankDetailsVM.offeyeClick = function(){
            regSetBankDetailsVM.inputType = "text";
            regSetBankDetailsVM.isEyeClose = false;
        }
        regSetBankDetailsVM.oneyeClick = function(){
            regSetBankDetailsVM.inputType = "password";
            regSetBankDetailsVM.isEyeClose = true;
        }
        regSetBankDetailsVM.reenteroffeyeClick = function(){
            regSetBankDetailsVM.reenterinputType = "text";
            regSetBankDetailsVM.reenterisEyeClose = false;
        }
        regSetBankDetailsVM.reenteroneyeClick = function(){
            regSetBankDetailsVM.reenterinputType = "password";
            regSetBankDetailsVM.reenterisEyeClose = true;
        }
}]);
