'use strict';
angularApp.controller('quickPayBiometricSetUpController', [
      "$state",
      "$stateParams",
      "$scope",
      "$ionicPopup",
      "$translate",
      "$ionicHistory",
      "utilityService",
      "loggedInUserService",
      "cryptoService",
      "mPinLoginService",
      "quickPayService",
      function ($state, $stateParams, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, loggedInUserService, cryptoService, mPinLoginService, quickPayService) {

            var quickPayBiometricSetUpVm = this;

            function initPage() {

                  quickPayBiometricSetUpVm.toggle = { "checked": false };
                  quickPayBiometricSetUpVm.bio_text = "";
                  if (quickPayService.isBiometricType == 'face')
                        quickPayBiometricSetUpVm.bio_text = "Face ID";
                  else
                        quickPayBiometricSetUpVm.bio_text = "Touch ID";

                  $translate(['ENABLE_FACEID', 'ENABLE_FACEID_DESC', 'YQP_AUTH_MSG', 'YQP_OK', 'YQP_CANCEL', 'YQP_DISABLE_DISCLAIMER', 'YQP_ENABLE_DISCLAIMER'], { FIELD_1: quickPayBiometricSetUpVm.bio_text }).then(function (translations) {
                        quickPayBiometricSetUpVm.ENABLE_FACEID = translations['ENABLE_FACEID'];
                        quickPayBiometricSetUpVm.ENABLE_FACEID_DESC = translations['ENABLE_FACEID_DESC'];
                        quickPayBiometricSetUpVm.YQP_AUTH_MSG = translations['YQP_AUTH_MSG'];
                        quickPayBiometricSetUpVm.OK_TXT = translations['YQP_OK'];
                        quickPayBiometricSetUpVm.CANCEL_TXT = translations['YQP_CANCEL'];
                        quickPayBiometricSetUpVm.YQP_DISABLE_DISCLAIMER = translations['YQP_DISABLE_DISCLAIMER'];
                        quickPayBiometricSetUpVm.YQP_ENABLE_DISCLAIMER = translations['YQP_ENABLE_DISCLAIMER'];
                  });
            }

            quickPayBiometricSetUpVm.goToUserLogin = function () {
                  $state.go('menu.userLogin');
            }


            quickPayBiometricSetUpVm.goBack = function () {
                  $state.go(quickPayBiometricSetUpVm.goBackToState);

            }

            quickPayBiometricSetUpVm.getCBValue = function (isChecked) {
                  if (!isChecked) {
                        quickPayBiometricSetUpVm.checkboxError = "Check this box to proceed";
                        quickPayBiometricSetUpVm.ischeckboxSelected = false;
                  }
                  else {
                        quickPayBiometricSetUpVm.ischeckboxSelected = true;
                        quickPayBiometricSetUpVm.checkboxError = "";
                  }
            }
            quickPayBiometricSetUpVm.submit = function () {
                  var message = "";
                  if (quickPayBiometricSetUpVm.isFingerprintAvlDevice) {
                        if (quickPayBiometricSetUpVm.ischeckboxSelected) {
                              if (quickPayBiometricSetUpVm.toggle.checked) {
                                    //in case of enable
                                    quickPayService.isFingerprintAvailable().then(function (response) {
                                          var encryptConfig = {
                                                clientId: "SBI YONO", //Android: Used for encryption. iOS: used for dialogue if no `localizedReason` is given.
                                                clientSecret: loggedInUserService.deviceInfo, //Necessary for Android encrpytion of keys. Use random secret key.
                                                disableBackup: true,

                                          };
                                          Fingerprint.show(encryptConfig, successCallback, errorCallback);
                                    }, function (error) {

                                    });
                              }
                              else {
                                    //in case if disable
                                    message = quickPayBiometricSetUpVm.YQP_DISABLE_DISCLAIMER;
                                    var btn_array = [
                                          {
                                                text: quickPayBiometricSetUpVm.CANCEL_TXT,
                                                type: 'button-negative',
                                                onTap: function () {
                                                      $state.go('menu.settings');
                                                }
                                          },
                                          {
                                                text: quickPayBiometricSetUpVm.OK_TXT,
                                                type: 'button-positive',
                                                onTap: function () {
                                                      goToOtp('disable');
                                                }
                                          }
                                    ];


                                    var imageType = 'img/FT/BhimUpi/alertSymbol.svg';

                                    var bhimErrorPopup = $ionicPopup.alert({
                                          template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" alt="popup_icon" src=' + imageType + ' /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'
                                          + message + '</span></div></div></div>', //template,
                                          scope: $scope,
                                          cssClass: 'bhim-alert-popup',
                                          buttons: btn_array,
                                    });
                                    bhimErrorPopup.then(function (res) {
                                    });
                              }

                        }
                        else {
                              quickPayBiometricSetUpVm.checkboxError = "Check this box to proceed";
                              quickPayBiometricSetUpVm.ischeckboxSelected = false;
                        }
                  }
                  else {

                        message = ' <strong>Unable to setup the biometric authentication functionality!</strong> <br><br> This may be due to either your phone does not have the biometric feature or the biometric functionality in your phone is dis-abled. Please check';
                        var ok_btn = "OK";
                        var onTapgo = '';
                        var onTapCancel = '';
                        var cancel_btn = 'Cancel'
                        quickPayService.showAlertPopup("", message, onTapgo, onTapCancel, ok_btn, cancel_btn, $scope);
                  }
            }







            function successCallback() {
                  var action = 'enable';
				  goToOtp(action);
                  /*if (result.withFingerprint) {
                        var token = result.withFingerprint;
                        //call service to save token at adapter
                        goToOtp(action);
                  } else if (result.withBackup) {
                        //call service to save token at adapter
                        goToOtp(action);
                  }
                  else if (result == 'Success') {
                        //call service to save token at adapter
                        goToOtp(action);
                  }*/
            }

            function goToOtp(action) {
                  if (quickPayBiometricSetUpVm.goBackState == '1' || quickPayBiometricSetUpVm.goBackState == '2' || quickPayBiometricSetUpVm.goBackState == '3') {
                        quickPayService.getOtp().then(function (data) {
                              $state.go('menu.setBiometricOTP', { goBackToState: quickPayBiometricSetUpVm.goBackState, action: action });
                        }, function (error) {
                              utilityService.showErrorMessage(error.responseMessage);
                        });
                  }
                  else {
                        quickPayService.getOtpSecure().then(function (data) {
                              $state.go('menu.setBiometricOTP', { goBackToState: quickPayBiometricSetUpVm.goBackState, action: action });
                        }, function (error) {
                              utilityService.showErrorMessage(error.responseMessage);
                        });
                  }
            }

            function errorCallback(error) {

            }
            quickPayBiometricSetUpVm.termcondition = function () {
                  if (quickPayService.setBioTnC == "") {
                        var obj = {
                              "type": "yqpBiometricTnC"
                        }
                        quickPayService.fetchRtermcondition(obj).then(function (data) {

                              if (!utilityService.isUndefined(data)) {
                                    quickPayService.setBioTnC = data;
                                    quickPayBiometricSetUpVm.termconditionPopUp(quickPayService.setBioTnC);
                              }
                        }, function (error) {
                              utilityService.showErrorMessage(error.responseMessage);
                        });
                  }
                  else {
                        quickPayBiometricSetUpVm.termconditionPopUp(quickPayService.setBioTnC);
                  }
            }

            quickPayBiometricSetUpVm.termconditionPopUp = function (TnCDetails) {
                  var title = "Terms & Conditions";
                  var buttontext = "Ok";
                  var detail = TnCDetails;
                  quickPayService.showTnCAlertModal(title, detail, buttontext, function () { });
            }

            $scope.$on('$ionicView.loaded', function () {
                  initPage();
            });

            $scope.$on('$ionicView.beforeEnter', function () {
                  quickPayBiometricSetUpVm.isFingerprintAvl = false;
                  quickPayBiometricSetUpVm.isFingerprintAvlDevice = false;
                  quickPayBiometricSetUpVm.toggle = { "checked": false };
                  quickPayService.isFingerprintAvailable().then(function (response) {
                        quickPayBiometricSetUpVm.isFingerprintAvlDevice = true;

                        var fingerprintToken = "";
                        cordova.plugins.SecureKeyStore.get(function (res) {
                              fingerprintToken = res;


                              if (fingerprintToken == null || fingerprintToken == "null" || fingerprintToken == undefined || fingerprintToken == "undefined" || fingerprintToken == "") {

                                    quickPayBiometricSetUpVm.isFingerprintAvl = false;
                                    quickPayBiometricSetUpVm.toggle = { "checked": false };

                              }
                              else {
                                    quickPayBiometricSetUpVm.isFingerprintAvl = true;
                                    quickPayBiometricSetUpVm.toggle = { "checked": true };
                              }
                        }, function (error) {

                              quickPayBiometricSetUpVm.isFingerprintAvl = false;
                              quickPayBiometricSetUpVm.toggle = { "checked": false };
                        }, loggedInUserService.deviceInfo);
                  }, function (error) {
                        //utilityService.showErrorMessage(error.responseMessage);
                  });

                  quickPayBiometricSetUpVm.goBackState = $stateParams.goBackToState;
                  quickPayBiometricSetUpVm.goBackToState = '';
                  if (quickPayBiometricSetUpVm.goBackState == 1) {
                        quickPayBiometricSetUpVm.goBackToState = 'menu.viewBalanceSetUp';
                  }
                  else if (quickPayBiometricSetUpVm.goBackState == 2) {
                        quickPayBiometricSetUpVm.goBackToState = 'menu.quickPaySetUp';
                  }
                  else if (quickPayBiometricSetUpVm.goBackState == 3) {
                        quickPayBiometricSetUpVm.goBackToState = 'menu.userLanding';
                  }
                  else {
                        quickPayBiometricSetUpVm.goBackToState = 'menu.settings';
                  }

            });

            quickPayBiometricSetUpVm.toggleValues = function () {
                  if (quickPayBiometricSetUpVm.toggle.checked) {
                        var message = quickPayBiometricSetUpVm.YQP_ENABLE_DISCLAIMER;
                        var btn_array = [
                              {
                                    text: quickPayBiometricSetUpVm.CANCEL_TXT,
                                    type: 'button-negative',
                                    onTap: function () {
                                          checkEnablePopup.close();
                                          quickPayBiometricSetUpVm.toggle.checked = false;
                                    }
                              },
                              {
                                    text: quickPayBiometricSetUpVm.OK_TXT,
                                    type: 'button-positive',
                                    onTap: function () {
                                          checkEnablePopup.close();
                                    }
                              }
                        ];




                        var checkEnablePopup = $ionicPopup.alert({
                              template: '<div class="font-dark-grey"><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'
                              + message + '</span></div></div></div>', //template,
                              scope: $scope,
                              cssClass: 'bhim-alert-popup',
                              buttons: btn_array,
                        });
                        checkEnablePopup.then(function (res) {
                        });
                  }
            }



            return this;
      }
]);


