/**
 *   @ngdoc config
 *   @name angularApp.config : quickPayConfig
 *   @description
 *   configuration file for Quick Pay module
 *   @author : Hitesh Dadhich
 */

/*This function defines all the constants named  Adapters url for cards module*/
angularApp
    /*State defination with respective names, urls, controllers and templates */
    .config([
        '$stateProvider',
        function ($stateProvider) {
            //Cards start
            $stateProvider
                .state('menu.quickPaySetUp', {
                    url: '/quickPaySetUp',
                    data: {
                        pageId: 'QUICKPAYSETUP'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/quickPay/quickPaySetUp.html',
                            controller: 'quickPaySetUpController',
                            controllerAs: 'quickPaySetUpVm'
                        }
                    }
                })
                .state('menu.quickPayLanding', {
                    url: '/quickPayLanding',
                    data: {
                        pageId: 'QUICKPAYLANDING'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/quickPay/quickPayLanding.html',
                            controller: 'quickPayLandingController',
                            controllerAs: 'quickPayLandingVm'
                        }
                    }
                })
                .state('menu.userLanding', {
                    url: '/userLanding',
                    data: {
                        pageId: 'USERLANDING'
                    },
                    params: { showViewBalance: null },
                    cache: true,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/quickPay/userLanding.html',
                            controller: 'userLandingController',
                            controllerAs: 'userLandingVm'
                        }
                    }
                })
                .state('menu.viewBalanceSetUp', {
                    url: '/viewBalanceSetUp',
                    data: {
                        pageId: 'VIEWBALANCESETUP'
                    },
                    params: { showViewBalance: null },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/quickPay/viewBalanceSetUp.html',
                            controller: 'viewBalanceSetUpController',
                            controllerAs: 'viewBalanceSetUpVm'
                        }
                    }
                })
                .state('menu.quickPayBiometricSetUp', {
                    url: '/quickPayBiometricSetUp',
                    data: {
                        pageId: 'QUICKPAYBIOSETUP'
                    },
                    params: { goBackToState: null },
                    cache: true,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/quickPay/quickPayBiometricSetUp.html',
                            controller: 'quickPayBiometricSetUpController',
                            controllerAs: 'quickPayBiometricSetUpVm'
                        }
                    }
                })

                .state('menu.setBiometricOTP', {
                    url: '/setBiometricOTP',
                    data: {
                        pageId: 'SETBIOMETRICOTP'
                    },
                    params: { goBackToState: null, action : null },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/quickPay/setBiometricOTP.html',
                            controller: 'setBiometricOTPController',
                            controllerAs: 'setBiometricOTPVm'
                        }
                    }
                })

		.state('menu.quickPaymentSuccess', {
                    url: '/quickPaymentSuccess',
                    data: {
                        pageId: 'YQP_SUCCESS'
                    },
                    cache: false,
                    params: { goBackToState: null, action:null, isSuccess: null },
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/quickPay/quickPaymentSuccess.html',
                            controller: 'quickPaymentSuccessController',
                            controllerAs: 'quickPaymentSuccessVm'
                        }
                    }
                })
                .state('menu.quickPayUserAuth', {
                    url: '/quickPayUserAuth',
                    data: {
                        pageId: 'YQP_USRAUTH'
                    },
                    params: { goBackToState: null, action:null },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/quickPay/quickPayUserAuth.html',
                            controller: 'quickPayUserAuthController',
                            controllerAs: 'quickPayUserAuthVm'
                        }
                    }
                })
                .state('menu.quickPayOTP', {
                    url: '/quickPayOTP',
                    data: {
                        pageId: 'QUICKPAYOTP'
                    },
                    params: { goBackToState: null, action:null },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/quickPay/quickPayOTP.html',
                            controller: 'quickPayOTPController',
                            controllerAs: 'quickPayOTPVm'
                        }
                    }
                })
                .state('menu.quickPayTransactions', {
                    url: '/quickPayTransactions',
                    data: {
                        pageId: 'QP_TRANSACTIONS'
                    },
                    params: { goBackToState: null, action:null },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/quickPay/quickPayTransactions.html',
                            controller: 'quickPayTransactionsController',
                            controllerAs: 'quickPayTransactionsVm'
                        }
                    }
                })
                .state('menu.quickPayPendingReq', {
                    url: '/quickPayPendingReq',
                    data: {
                        pageId: 'QUICKPAYPENDINGREQ'
                    },
                    params: { goBackToState: null, action:null },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/quickPay/quickPayPendingReq.html',
                            controller: 'quickPayPendingReqController',
                            controllerAs: 'quickPayPendingReqVm'
                        }
                    }
                })
                .state('menu.quickPayPreAuth', {
                    url: '/quickPayPreAuth',
                    data: {
                        pageId: 'QUICKPAYPREAUTH'
                    },
                    params: { goBackToState: null, action:null },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/quickPay/quickPayPreAuth.html',
                            controller: 'quickPayPreAuthController',
                            controllerAs: 'quickPayPreAuthVm'
                        }
                    }
                })
                
        }
    ]);
