'use strict';
angularApp.controller('quickPayOTPController', [
		"$state",
		"$scope",		
		"utilityService",
		"customerInfoService","$filter","getAccountDetailsService","quickPayService","cryptoService","$stateParams","$ionicHistory",
		"loggedInUserService",
		function($state, $scope,utilityService,customerInfoService,$filter,getAccountDetailsService,quickPayService,
			cryptoService,$stateParams,$ionicHistory,loggedInUserService) {
			
			var quickPayOTPVm = this;

			function initPage(){
				quickPayOTPVm.otpCount = 0;
				quickPayOTPVm.clickCount = 0;
				quickPayOTPVm.isResendDisabled = false;
				quickPayOTPVm.goBackState = $stateParams.goBackToState;
				quickPayOTPVm.mobileNumber = $filter('cardmask')(quickPayService.customerInfo.customerInformation.mobile, 'X', 4);
				
			}
			quickPayOTPVm.goBack = function(){
				$ionicHistory.goBack();
			}
			quickPayOTPVm.goNext = function(){
				quickPayOTPVm.resetPinOTP = "";
				if(!quickPayOTPVm.otpNumber){
					quickPayOTPVm.resetPinOTP = "Please Enter the OTP";
				}else if(quickPayOTPVm.otpNumber.length != 6){
					quickPayOTPVm.resetPinOTP = "Please enter 6 digits OTP";
				}else{
					var request = {
						"otp" : quickPayOTPVm.otpNumber
					}


         quickPayService.validateOtp(request).then(function(data) {
						
			if(quickPayOTPVm.action == 'pay_to_existing_beneficiary')
	        {
	            payToExistingBeneficiary();
	        }
            else if(quickPayOTPVm.action == 'pay_to_new_sbi'){
                payToNewSbiBeneficiary();
            }
            else if(quickPayOTPVm.action == 'pay_to_new_other'){
                payToNewOtherBeneficiary();
            }
            else if(quickPayOTPVm.action == 'pay_to_contact'){
                payToContact();
            }
						
						
						
					},function(error){
						quickPayOTPVm.otpNumber = "";
						quickPayOTPVm.otpCount++;
						if(quickPayOTPVm.otpCount >= 3){
							var title = '';
							var template = error.responseMessage;
							var onTap = '';
							var buttontext = "OK";
							//utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
							utilityService.showBhimUpiAlert('error', template, onTap, buttontext, $scope);
						}else{
							utilityService.showErrorMessage(error.responseMessage);
						}
					});
      
	
				}
			}

			quickPayOTPVm.resendOTP = function(){
				quickPayService.getOtp().then(function(data) {
					quickPayOTPVm.otpNumber = "";
					quickPayOTPVm.resetPinOTP = "";
					quickPayOTPVm.clickCount++;
					if(quickPayOTPVm.clickCount >= 2){
						quickPayOTPVm.isResendDisabled = true;
					}
					var title = '';
					var template = "OTP has been sent to your registered mobile number.";
					var onTap = '';
					var buttontext = "OK";
					//utilityService.showAlertModal('', template, onTap, $scope, $state, buttontext);
					utilityService.showBhimUpiAlert('success', template, onTap, buttontext, $scope);
				},function(error){
					quickPayOTPVm.otpNumber = "";
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

function payToExistingBeneficiary(){
    var params = {
  
              "amount": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.amount,
              "inbUserId": "",
              "accountTypeCode": "",
              "benMMID": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.benMMID,
              "benNickName": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.benNickName,
              "benIfscCode": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.benIFSCCode,
              "isStaffFlag": "",
              "intCategory": "",
              "benType": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.benType,
              "benName": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.benName,
              "intraBankFlag": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.intraBankFlag,
              "isOwnAccntFlag": "",
              "remAccntNo": "",
              "benAccntNo": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.benAccntNo,
              "benStatus": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.benStatus,
              "debitNriflag": "",
              "remark":(quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.remark == undefined || quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.remark == null) ? "" : quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.remark,
              "yqpValidateReq" : (cryptoService.getSHA512EncryptedData(quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.benName + quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.benNickName + quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.benAccntNo + quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.amount)).toString()
        };
        quickPayService.postTxn(params).then(function(response) {
                quickPayService.paymentResponse = response;
                 $state.go('menu.quickPaymentSuccess',{action:'pay_to_existing_beneficiary', isSuccess: true});
          },function(error){
              quickPayService.paymentResponse = error;
              $state.go('menu.quickPaymentSuccess',{action:'pay_to_existing_beneficiary', isSuccess: false});
            //utilityService.showErrorMessage(error.responseMessage);
          });
}
function payToContact(){
   var params = {"amount": quickPayService.payToContactData.amount,"payRequestId": quickPayService.payRequestId};
   quickPayService.payToContact(params).then(function (data) {
       quickPayService.paymentResponse = data;
         quickPayService.pendingLists = [];
         quickPayService.payRequestId="";
        $state.go('menu.quickPaymentSuccess',{action:'pay_to_contact', isSuccess: true});
    }, function (error) {
        quickPayService.paymentResponse = error;
        $state.go('menu.quickPaymentSuccess',{action:'pay_to_contact', isSuccess: false});
          //utilityService.showErrorMessage(error.responseMessage);
    });
}
function payToNewSbiBeneficiary(){
    var params = {
  
              "amount": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.amount,
              "inbUserId": "",
              "accountTypeCode": "",
              "benMMID": "",
              "benNickName": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.recipient_name,
              "benIfscCode": "",
              "isStaffFlag": "",
              "intCategory": "",
              "benType": "account",
              "benName": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.recipient_name,
              "intraBankFlag": "Y",
              "isOwnAccntFlag": "",
              "remAccntNo": "",
              "benAccntNo": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.account_number,
              "benStatus": "New",
              "debitNriflag": "",
              "remark": (quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.remark == undefined || quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.remark == null) ? "" : quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.remark,
              "yqpValidateReq" : (cryptoService.getSHA512EncryptedData(quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.recipient_name + quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.recipient_name + quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.account_number + quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.amount)).toString()
        };
        quickPayService.postTxn(params).then(function(response) {
            quickPayService.paymentResponse = response;
                 $state.go('menu.quickPaymentSuccess',{action:'pay_to_new_sbi', isSuccess: true});
          },function(error){
              quickPayService.paymentResponse = error;
            $state.go('menu.quickPaymentSuccess',{action:'pay_to_new_sbi', isSuccess: false});
            //utilityService.showErrorMessage(error.responseMessage);
          });
}
function payToNewOtherBeneficiary(){
    var params = {
  
              "amount": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.amount,
              "inbUserId": "",
              "accountTypeCode": "",
              "benMMID": "",
              "benNickName": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.recipient_name,
              "benIfscCode": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.ifsc,
              "isStaffFlag": "",
              "intCategory": "",
              "benType": "account",
              "benName": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.recipient_name,
              "intraBankFlag": "N",
              "isOwnAccntFlag": "",
              "remAccntNo": "",
              "benAccntNo": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.account_number,
              "benStatus": "New",
              "debitNriflag": "",
              "remark": (quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.remark == undefined || quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.remark ==null) ? "" : quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.remark,
              "yqpValidateReq" : (cryptoService.getSHA512EncryptedData(quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.recipient_name + quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.recipient_name + quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.account_number + quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.amount)).toString()
        };
        quickPayService.postTxn(params).then(function(response) {
            quickPayService.paymentResponse = response;
                 $state.go('menu.quickPaymentSuccess',{action:'pay_to_new_other', isSuccess: true});
          },function(error){
              quickPayService.paymentResponse = error;
            $state.go('menu.quickPaymentSuccess',{action:'pay_to_new_other', isSuccess: false});
            //utilityService.showErrorMessage(error.responseMessage);
          });
}

			$scope.$on('$ionicView.beforeEnter', function() {
				initPage();
				quickPayOTPVm.goBackState = $stateParams.goBackToState;
				quickPayOTPVm.action = $stateParams.action;
           quickPayOTPVm.goBackToState = '';
           if(quickPayOTPVm.goBackState == 1){
            quickPayOTPVm.goBackToState = 'menu.viewBalanceSetUp';
           }
           else if(quickPayOTPVm.goBackState == 2){
            quickPayOTPVm.goBackToState = 'menu.quickPaySetUp';
           }
           else{
            quickPayOTPVm.goBackToState = 'menu.settings';
           }
			});
			
			return this;
		}

		
]);


