'use strict';
angularApp.controller('quickPayPendingReqController', [
  "$state",
  "$scope",
  "$ionicPopup",
  "$translate",
  "$ionicHistory",
  "utilityService",
  "quickPayService",
  "constantConfig",
  "bhimUpiService",
  "$filter",
  "cryptoService",
  function ($state,
    $scope,
    $ionicPopup,
    $translate,
    $ionicHistory,
    utilityService,
    quickPayService,
    constantConfig,
    bhimUpiService,
    $filter,
    cryptoService
  ) {

    var quickPayPendingReqVm = this;

    function initPage() {
      $translate(['YQP_RECEIVEMONEY_YES', 'YQP_RECEIVEMONEY_CANCEL', 'YQP_RECEIVEMONEY_DECLINE', 'YQP_RECEIVEMONEY_BLOCK', 'YQP_RECEIVEMONEY_BLOCK_BTN', 'YQP_PAYNOW', 'YQP_PEND_REQ_CONF']).then(function (translations) {
        quickPayPendingReqVm.YQP_RECEIVEMONEY_YES = translations['YQP_RECEIVEMONEY_YES'];
        quickPayPendingReqVm.YQP_RECEIVEMONEY_CANCEL = translations['YQP_RECEIVEMONEY_CANCEL'];
        quickPayPendingReqVm.YQP_RECEIVEMONEY_DECLINE = translations['YQP_RECEIVEMONEY_DECLINE'];
        quickPayPendingReqVm.YQP_RECEIVEMONEY_BLOCK = translations['YQP_RECEIVEMONEY_BLOCK'];
        quickPayPendingReqVm.YQP_RECEIVEMONEY_BLOCK_BTN = translations['YQP_RECEIVEMONEY_BLOCK_BTN'];
        quickPayPendingReqVm.YQP_PAYNOW = translations['YQP_PAYNOW'];
        quickPayPendingReqVm.YQP_PEND_REQ_CONF = translations['YQP_PEND_REQ_CONF'];
      });

    };

    quickPayPendingReqVm.blockRequest = function (collectRequest, indexVal) {
      utilityService.showSpinner();
      var json = JSON.stringify({
        "addInfo": {
          "addInfo10": constantConfig.upiConstant.addInfo10,
          "addInfo9": constantConfig.upiConstant.addInfo9
        },
        "approvalStatus": "S",
        "expiryTime": 0,
        "npciTranId": collectRequest.txnId,
        "payerType": {
          "accountId": "1234",
          "virtualAddress": "sbi"
        },
        "requestInfo": {
          "pspId": constantConfig.upiConstant.pspId,
          "pspRefNo": generateRandomString(27)
        },
        "upiTransRefNo": collectRequest.upiTrnRefNo
      });
      bhimUpiService.getNativeData(constantConfig.upiConstant.onCollectApprove, json, "YQP").then(function (data) {
        var collectApproveResp = JSON.parse(data).apiResp;
        utilityService.hideSpinner();
        if (collectApproveResp.status == 'R') {
          quickPayPendingReqVm.collectLists.splice(indexVal, 1);
          quickPayService.pendingLists = [];

        } else {
          utilityService.showBhimUpiAlert("error", collectApproveResp.statusDesc);
        }
      }, function (msg) {
        utilityService.hideSpinner();
        utilityService.showBhimUpiAlert("error", msg);
      });
    }

    quickPayPendingReqVm.checkApprove = function (data, index) {
      $translate(['YQP_PEND_REQ_DESC'], { amount: $filter('INRFLOAT')(parseInt(data.txnAmount), 2), name: data.payeeName }).then(function (translations) {
        quickPayPendingReqVm.YQP_PEND_REQ_DESC = translations['YQP_PEND_REQ_DESC'];
        var btn_array = [
          {
            text: quickPayPendingReqVm.YQP_RECEIVEMONEY_CANCEL,
            type: 'button-negative',
            onTap: function () {
              checkDeclinePopup.close();
            }
          },
          {
            text: quickPayPendingReqVm.YQP_PAYNOW,
            type: 'button-positive',
            onTap: function () {
              checkDeclinePopup.close();
              //call reject bhimUpiService
              quickPayPendingReqVm.approveRequest(data);
            }
          }
        ];
        var checkDeclinePopup = $ionicPopup.alert({
          template: '<div class="font-dark-grey"><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span class="roboto-medium color3f3f3f font-size-16 line-height-24">'
          + quickPayPendingReqVm.YQP_PEND_REQ_DESC + '</span></div><div class="textAlignCenter roboto-medium color3f3f3f font-size-16 line-height-24">' + quickPayPendingReqVm.YQP_PEND_REQ_CONF + '</div></div></div>',
          scope: $scope,
          cssClass: 'bhim-alert-popup',
          buttons: btn_array,
        });
        checkDeclinePopup.then(function (res) {
        });
      });
    }
    quickPayPendingReqVm.approveRequest = function (collectRequest) {
      quickPayService.payFromCollectRequest = true;
      quickPayService.payFromCollectRequestData = collectRequest;
      quickPayService.payRequestId = collectRequest.payRequestId;
      $state.go('menu.quickPayLanding');
    }

    quickPayPendingReqVm.rejectRequest = function (collectRequest, indexVal) {
      utilityService.showSpinner();
      var json = JSON.stringify({
        "addInfo": {
          "addInfo10": constantConfig.upiConstant.addInfo10,
          "addInfo9": constantConfig.upiConstant.addInfo9
        },
        "approvalStatus": "R",
        "expiryTime": 0,
        "npciTranId": collectRequest.txnId,
        "payerType": {
          "accountId": "1234",
          "virtualAddress": "sbi"
        },
        "requestInfo": {
          "pspId": constantConfig.upiConstant.pspId,
          "pspRefNo": generateRandomString(27)
        },
        "upiTransRefNo": collectRequest.upiTrnRefNo
      });
      bhimUpiService.getNativeData(constantConfig.upiConstant.onCollectApprove, json, "YQP").then(function (data) {
        var collectApproveResp = JSON.parse(data).apiResp;
        utilityService.hideSpinner();
        if (collectApproveResp.status == 'R') {
          quickPayPendingReqVm.collectLists.splice(indexVal, 1);
          quickPayService.pendingLists = [];

        } else {
          utilityService.showBhimUpiAlert("error", collectApproveResp.statusDesc);
        }
      }, function (msg) {
        utilityService.hideSpinner();
        utilityService.showBhimUpiAlert("error", msg);
      });
    }

    quickPayPendingReqVm.goToQuickPayLanding = function () {
      $state.go('menu.quickPayLanding');
    }

    $scope.$on('$ionicView.loaded', function () {
      initPage();
    });

    $scope.$on('$ionicView.beforeEnter', function () {
      quickPayPendingReqVm.collectLists = quickPayService.pendingLists;
      quickPayPendingReqVm.showPendingError = quickPayService.showPendingError;
    });

    quickPayPendingReqVm.checkDecline = function (declineData, index) {
      var message = quickPayPendingReqVm.YQP_RECEIVEMONEY_DECLINE;
      var btn_array = [
        {
          text: quickPayPendingReqVm.YQP_RECEIVEMONEY_CANCEL,
          type: 'button-negative',
          onTap: function () {
            checkDeclinePopup.close();

          }
        },
        {
          text: quickPayPendingReqVm.YQP_RECEIVEMONEY_YES,
          type: 'button-positive',
          onTap: function () {
            checkDeclinePopup.close();
            //call reject bhimUpiService
            if(declineData.type == 'contact'){
              quickPayPendingReqVm.rejectRequestAccountFlow(declineData, index);
            }else{
              quickPayPendingReqVm.rejectRequest(declineData, index);
            }
            
          }
        }
      ];


      var imageType = 'img/FT/BhimUpi/alertSymbol.svg';

      var checkDeclinePopup = $ionicPopup.alert({
        template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src=' + imageType + ' /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span class="roboto-medium color545454 font-size-16">'
        + message + '</span></div></div></div>',
        scope: $scope,
        cssClass: 'bhim-alert-popup',
        buttons: btn_array,
      });
      checkDeclinePopup.then(function (res) {
      });
    }

    quickPayPendingReqVm.checkBlockUser = function (blockData, index) {
      var message = quickPayPendingReqVm.YQP_RECEIVEMONEY_BLOCK;
      var btn_array = [
        {
          text: quickPayPendingReqVm.YQP_RECEIVEMONEY_CANCEL,
          type: 'button-negative',
          onTap: function () {
            checkBlockUser.close();

          }
        },
        {
          text: quickPayPendingReqVm.YQP_RECEIVEMONEY_BLOCK_BTN,
          type: 'button-positive',
          onTap: function () {
            checkBlockUser.close();
            //call block bhimUpiService
            if(blockData.type == 'contact'){
              quickPayPendingReqVm.blockRequestAccountFlow(blockData, index);
            }else{
              quickPayPendingReqVm.blockRequest(blockData, index);
            }
            
          }
        }
      ];


      var imageType = 'img/FT/BhimUpi/alertSymbol.svg';

      var checkBlockUser = $ionicPopup.alert({
        template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src=' + imageType + ' /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span class="roboto-medium color545454 font-size-16">'
        + message + '</span></div></div></div>',
        scope: $scope,
        cssClass: 'bhim-alert-popup',
        buttons: btn_array,
      });
      checkBlockUser.then(function (res) {
      });
    }

    quickPayPendingReqVm.rejectRequestAccountFlow = function(declineData, index){
      var hashedRejectData = (cryptoService.getSHA512EncryptedData(declineData.payRequestId+declineData.txnAmount+declineData.receiverPhnNumber+declineData.mobileNo+"/updatePendingList")).toString();
      var params = { 
        "payRequestId":declineData.payRequestId,
        "status":"decline",
        "reqName" : declineData.payeeName,
        "amount": declineData.txnAmount,
        "phnNumber":declineData.receiverPhnNumber,
        "lastTransactionType":declineData.mobileNo,
        "validateReq":hashedRejectData
      }
      quickPayService.updatePendingCollectRequest(params).then(function (data) {
        quickPayPendingReqVm.collectLists.splice(index, 1);
        quickPayService.pendingLists = [];
      }, function (error) {
      utilityService.showErrorMessage(error.responseMessage);
      });
    }


    quickPayPendingReqVm.blockRequestAccountFlow = function(blockData, index){
      var hashedBlockData = (cryptoService.getSHA512EncryptedData(blockData.payRequestId+blockData.txnAmount+blockData.receiverPhnNumber+blockData.mobileNo+"/updatePendingList")).toString();
      var params = { 
        "payRequestId":blockData.payRequestId,
        "status":"block",
        "amount": blockData.txnAmount,
        "phnNumber":blockData.receiverPhnNumber,
        "lastTransactionType":blockData.mobileNo,
        "validateReq":hashedBlockData
      }
      quickPayService.updatePendingCollectRequest(params).then(function (data) {
        quickPayPendingReqVm.collectLists.splice(index, 1);
        quickPayService.pendingLists = [];
      }, function (error) {
      utilityService.showErrorMessage(error.responseMessage);
      });
    }



    return this;
  }
]);


