'use strict';
angularApp.controller('quickPayPreAuthController', [
    "$state",
    "$scope",
    "$rootScope",
    "$ionicPopup",
    "$translate",
    "utilityService",
    "loggedInUserService",
    "cryptoService",
    "mPinLoginService",
    "quickPayService",
    "constantConfig",
    "AdapterUtils",
    "encryptionService",
    "ConnectivityMonitorUtils",
    "internetBankingService",
    "inbLockUnlockService",
    "clickStreamService",
    "getAccountDetailsService",
    "homeScreenService",
    "customerInfoService",
    "registerWithSimService",
    function ($state,
        $scope,
        $rootScope,
        $ionicPopup,
        $translate,
        utilityService,
        loggedInUserService,
        cryptoService,
        mPinLoginService,
        quickPayService,
        constantConfig,
        AdapterUtils,
        encryptionService,
        ConnectivityMonitorUtils,
        internetBankingService,
        inbLockUnlockService,
        clickStreamService,
        getAccountDetailsService,
        homeScreenService,
        customerInfoService,
        registerWithSimService) {

        var quickPayPreAuthVm = this;
        quickPayPreAuthVm.isChallenged = false;
        quickPayPreAuthVm.mpinErrorMsg = "";
        quickPayPreAuthVm.mpinErrorMsgFlag = false;
        quickPayPreAuthVm.securityCheckName = "AuthenticateMPinSecurityCheck";
        quickPayPreAuthVm.mPinAuthChallengeHandler = WL.Client.createSecurityCheckChallengeHandler(quickPayPreAuthVm.securityCheckName);
        quickPayPreAuthVm.mPinAuthChallengeHandler.securityCheckName = quickPayPreAuthVm.securityCheckName;
        quickPayPreAuthVm.keystoreValue = loggedInUserService.keystoreValue;


        quickPayPreAuthVm.goBack = function () {
            $state.go('menu.userLanding');
        }

        /*Custom Keypad for MPIN*/
        $scope.password = '';
        $scope.canErase = false;
        $scope.pinDotVisible = {};
        $scope.success = null;
        $scope.keyboardVisible = false;
        $scope.pinArray = [];

        $scope.keyboardSettings = {
            action: function (number) {
                if ($scope.password.length < 6) {
                    $scope.password += number;
                    $scope.pinArray.push(number);
                    $scope.pinDotVisible[$scope.password.length] = true;
                    $scope.canErase = true;
                    $scope.success = null;
                    var pass = $scope.password;
                    pass = pass.split("");
                    try {
                        quickPayPreAuthVm.first = pass[0];
                        quickPayPreAuthVm.second = pass[1];
                        quickPayPreAuthVm.third = pass[2];
                        quickPayPreAuthVm.fourth = pass[3];
                        quickPayPreAuthVm.fifth = pass[4];
                        quickPayPreAuthVm.sixth = pass[5];
                    } catch (err) { }

                }
                if ($scope.password && $scope.password.length === 6) {
                    var e = {};
                    var pass = $scope.password;
                    pass = pass.split("");
                    try {
                        quickPayPreAuthVm.first = pass[0];
                        quickPayPreAuthVm.second = pass[1];
                        quickPayPreAuthVm.third = pass[2];
                        quickPayPreAuthVm.fourth = pass[3];
                        quickPayPreAuthVm.fifth = pass[4];
                        quickPayPreAuthVm.sixth = pass[5];
                    } catch (err) { }
                    var e = {};
                    e.srcElement = {};
                    e.srcElement.value = 2;
                    quickPayPreAuthVm.changeInput(e, 6);
                }
            },

            // Clear
            leftButton: {
                html: '<i class="icon ion-backspace"></i>',
                action: function () {
                    $scope.doErase();
                },
                style: {
                    bgColor: '#fff',
                    activeBgColor: '#dfdfdf',
                    borderColor: '#dfdfdf',
                    fontSize: '20px'
                }
            },

            // Submit login
            rightButton: {
                html: '<i class="icon ion-eye"></i>	<i class="icon ion-eye-disabled login-eye-btn" ></i>',
                action: function () {
                    if ($scope.isPassVisible) {
                        var elementHide = document.getElementsByClassName("ion-eye-disabled")[0];
                        elementHide.classList.add("login-eye-btn");
                        var elementShow = document.getElementsByClassName("ion-eye")[0];
                        elementShow.classList.remove("login-eye-btn");

                        $scope.isPassVisible = false;
                    } else {
                        $scope.isPassVisible = true;
                        var elementHide = document.getElementsByClassName("ion-eye")[0];
                        elementHide.classList.add("login-eye-btn");
                        var elementShow = document.getElementsByClassName("ion-eye-disabled")[0];
                        elementShow.classList.remove("login-eye-btn");
                    }
                },
                style: {
                    bgColor: '#fff',
                    activeBgColor: '#dfdfdf',
                    borderColor: '#dfdfdf',
                    fontSize: '30px'
                }
            }
        }

        $scope.doErase = function () {
            $scope.pinDotVisible[$scope.password.length] = false;
            $scope.password = $scope.password.slice(0, -1);
            if ($scope.password.length == 0) $scope.canErase = false;
            try {
                var pass = $scope.password;
                pass = pass.split("");
                quickPayPreAuthVm.first = pass[0] ? pass[0] : "";
                quickPayPreAuthVm.second = pass[1] ? pass[1] : "";
                quickPayPreAuthVm.third = pass[2] ? pass[2] : "";
                quickPayPreAuthVm.fourth = pass[3] ? pass[3] : "";
                quickPayPreAuthVm.fifth = pass[4] ? pass[4] : "";
                quickPayPreAuthVm.sixth = pass[5] ? pass[5] : "";
            } catch (err) { }
        }

        $scope.rightAction = function () {
            pinDotVisible[0] = false;
            pinDotVisible[1] = false;
            pinDotVisible[2] = false;
            pinDotVisible[3] = false;
            pinDotVisible[4] = false;
            pinDotVisible[5] = false;
        }

        $scope.showKeyboard = function () {
            $scope.keyboardVisible = true;
        }

        $rootScope.hidekeypad = function ($event) {
            switch ($event.target.className) {
                case "mpin1 activated":
                // code block
                case "mpin1 border-black activated":
                // code block
                case "digit-keyboard-key":
                // code block

                case "digit-keyboard-key-action ng-binding":
                // code block

                case "icon ion-record":
                // code block

                case "digit-keyboard-key activated":
                // code block

                case "icon ion-backspace":
                // code block

                case "mpin1 ng-pristine ng-untouched ng-valid ng-empty activated":
                // code block

                case "mpin1 ng-binding":
                // code block

                case "icon ion-eye-disabled login-eye-btn":
                // code block

                case "icon ion-eye login-eye-btn":
                // code block

                case "digit-keyboard-key-number":
                    if (!$scope.keyboardVisible) {
                        $scope.showKeyboard();
                    }
                    break;
                default:
                    if ($scope.keyboardVisible) {
                        $scope.hideKeyboard();
                    }
                    break;
            }
        }

        $scope.hideKeyboard = function () {
            $scope.keyboardVisible = false;
        }

        $scope.clearMpin = function () {
            $scope.doErase();
            $scope.doErase();
            $scope.doErase();
            $scope.doErase();
            $scope.doErase();
            $scope.doErase();
        }
        /*End of Custom Keypad for MPIN*/

        quickPayPreAuthVm.changeInput = function ($event, index) {
            cordova.plugins.Keyboard.close();
            if (loggedInUserService.isServerConnected) {
                quickPayPreAuthVm.loginWithMpin();
            } else {
                connectServer();
            }
        }
        function connectServer() {
            try {
                var payload = {
                    "data": cryptoService.encryptRSAWithPublicKey(encryptionService.iv + "^" + encryptionService.passphrase + "^" + encryptionService.salt, cryptoService.rsaPublicKey),
                    "src": quickPayPreAuthVm.keystoreValue != "" ? cryptoService.encryptRSAWithPublicKey(quickPayPreAuthVm.keystoreValue, cryptoService.rsaPublicKey) : "",
                };
                utilityService.showSpinner();
                var resourceRequest = new WLResourceRequest("adapters/CustomSessionAdapter/saveCustomInformation", WLResourceRequest.POST, { timeout: 15000 });
                resourceRequest.send(payload).then(function (response) {
                    utilityService.lastTimeStamp = new Date();
                    response.responseText = utilityService.isJSON(response.responseText) ? JSON.parse(response.responseText) : JSON.parse(encryptionService.getAES256DecryptedData(response.responseText));
                    if (response.responseText.responseCode == '0000') {
                        //landingVM.isServerconnected = true;
                        AdapterUtils.secretData = response.responseText.data.key;
                        loggedInUserService.keyId = response.responseText.data.keyId;
                        loggedInUserService.deviceIdForMpin = response.responseText.data.deviceId;
                        loggedInUserService.upiPermissionKey = response.responseText.data.upiPermissionVal;
                        loggedInUserService.billDeskUrl = response.responseText.data.billDeskUrl;
                        loggedInUserService.sbiCollectUrl = response.responseText.data.sbiCollectUrl;
                        utilityService.getUPIPermissions(loggedInUserService.upiPermissionKey);
                        quickPayService.yqpVpaLimit = response.responseText.data.yqpVpaLimit;
                        quickPayService.yqpRaiseRequestLimit = response.responseText.data.yqpRaiseRequestLimit;
                        quickPayService.yqpBeneficiaryLimit = response.responseText.data.yqpBeneficiaryLimit;
                        loggedInUserService.isServerConnected = true;
                        utilityService.hideSpinner();

                        quickPayPreAuthVm.loginWithMpin();

                    } else if (response.responseText.responseCode == '0001') {
                        $scope.err = response.responseText.responseCode + " : " + constantConfig.adapter.CANNOT_PROCESS_NOW;
                        loggedInUserService.isServerConnected = false;
                        quickPayPreAuthVm.serverConnectErrorPopup();
                        return;
                    } else if (response.responseText.responseCode == '0002') {
                        $scope.err = response.responseText.responseCode + " : " + constantConfig.adapter.CANNOT_PROCESS_NOW;
                        loggedInUserService.isServerConnected = false;
                        quickPayPreAuthVm.serverConnectErrorPopup();
                        return;
                    } else if (response.responseText.responseCode == '0003' || response.responseText.responseCode == '0004') {
                        $scope.err = response.responseText.responseCode + " : " + response.responseText.responseMessage;
                        loggedInUserService.isServerConnected = false;
                        quickPayPreAuthVm.serverConnectErrorPopup();
                        return;
                    }
                }, function (error) {
                    if (error.errorCode == 'APPLICATION_DOES_NOT_EXIST') {
                        $scope.err = error;
                        quickPayPreAuthVm.showUpgradeMsg($scope.err);
                    } else {
                        $scope.err = utilityService.getServerExceptionMessage(error);
                        quickPayPreAuthVm.serverConnectErrorPopup();
                    }
                    loggedInUserService.isServerConnected = false;
                });
            } catch (err) {
                $scope.err = constantConfig.adapter.SOMETHING_WENT_WRONG;
                loggedInUserService.isServerConnected = false;
                quickPayPreAuthVm.serverConnectErrorPopup();
            }
        }

        quickPayPreAuthVm.clearMpin = function () {
            quickPayPreAuthVm.first = '';
            quickPayPreAuthVm.second = '';
            quickPayPreAuthVm.third = '';
            quickPayPreAuthVm.fourth = '';
            quickPayPreAuthVm.fifth = '';
            quickPayPreAuthVm.sixth = '';
            $scope.doErase();
            $scope.doErase();
            $scope.doErase();
            $scope.doErase();
            $scope.doErase();
            $scope.doErase();
        }
        quickPayPreAuthVm.loginWithMpin = function () {
            if(utilityService.isAndroidPlatform() && registerWithSimService.isSimLogin && !registerWithSimService.userWithoutSimReg && (quickPayPreAuthVm.isSimChanged || quickPayPreAuthVm.simList == undefined || quickPayPreAuthVm.simList.length == 0)){
                if(quickPayPreAuthVm.isSimChanged)
                {
					
						loggedInUserService.fileForStorageData('{"isDeviceRegistered":false,"mpinConsent":false, "simSubscriptionId":""}').then(function (res) {
							localStorage.setItem('isDeviceRegistered', false);
							localStorage.setItem('mpinConsent', false);
							quickPayPreAuthVm.reloadApp(registerWithSimService.changedSimMsg);
						}, function (err) {
							localStorage.setItem('isDeviceRegistered', false);
							localStorage.setItem('mpinConsent', false);
							quickPayPreAuthVm.reloadApp(registerWithSimService.changedSimMsg);
						});
					
				}
                    //utilityService.showBhimUpiAlert("alert", registerWithSimService.changedSimMsg);
                else if(quickPayPreAuthVm.simList == undefined || quickPayPreAuthVm.simList.length == 0)
                    utilityService.showBhimUpiAlert("alert", registerWithSimService.noSimMsg);
				quickPayPreAuthVm.clearMpin();
				quickPayPreAuthVm.enabledThisInput(1);
				return;
			}
            var newMpin = quickPayPreAuthVm.first.trim() +
                quickPayPreAuthVm.second.trim() +
                quickPayPreAuthVm.third.trim() +
                quickPayPreAuthVm.fourth.trim() +
                quickPayPreAuthVm.fifth.trim() +
                quickPayPreAuthVm.sixth.trim();
            //var newMpin = quickPayPreAuthVm.setpassword;;
            if (newMpin.length == 6) {
                if (ConnectivityMonitorUtils.isOffline()) {
                    quickPayPreAuthVm.clearMpin();
                    //quickPayPreAuthVm.enabledThisInput(1);
                    /*login flow improvement*/
                    var inputElement = document.getElementById('InputTxt1');
                    inputElement.disabled = false;
                    utilityService.offlineAlert();
                    return;
                }
                utilityService.showSpinner();
                loggedInUserService.finalSHA512Val = registerWithSimService.isSimLogin ?
                    loggedInUserService.generateMPINSHA512ValWithSim(newMpin, quickPayPreAuthVm.simSubscriptionId) :
                    loggedInUserService.generateMPINSHA512Val(newMpin) ;
                quickPayPreAuthVm.mPinAuthChallengeHandler.handleChallenge = function (challenge) {
                    quickPayPreAuthVm.isChallenged = true;
                    //quickPayPreAuthVm.setpassword = "";
                    quickPayPreAuthVm.clearMpin();
                    quickPayPreAuthVm.enabledThisInput(1);
                    utilityService.accessRestricted = "";
                    utilityService.hideSpinner();
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "MPINLGN_BTN"));
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "LOGIN_FAILURE"));
                    if (challenge.errorMsg !== null) {
                        if (challenge.errorMsg.indexOf("2003:") !== -1) {
                            challenge.errorMsg = challenge.errorMsg.replace("2003:", "");
                            //if (!utilityService.isAndroidPlatform()) {
                            loggedInUserService.fileForStorageData('{"isDeviceRegistered":false,"mpinConsent":false, "simSubscriptionId":""}').then(function (res) {
                                localStorage.setItem('isDeviceRegistered', false);
                                localStorage.setItem('mpinConsent', false);
                                quickPayPreAuthVm.reloadApp(challenge.errorMsg);
                            }, function (err) {
                                localStorage.setItem('isDeviceRegistered', false);
                                localStorage.setItem('mpinConsent', false);
                                quickPayPreAuthVm.reloadApp(challenge.errorMsg);
                            });
                            //}
                        } else if (challenge.errorMsg.indexOf("2005:") !== -1) {
                            challenge.errorMsg = challenge.errorMsg.replace("2005:", "");
                            quickPayPreAuthVm.reloadApp(challenge.errorMsg);
                        } else if (challenge.errorCode == "M003" || challenge.errorCode == "LOCK.001") {
                            if (challenge.errorCode == "LOCK.001") {
                                inbLockUnlockService.challengeErrorCode = "LOCK.001";
                            }
                            inbLockUnlockService.displayErrorPopUp('<img class="inb-error-icon" src="img/FT/BhimUpi/errorSymbol.svg" /><br><p class="inb-alert-header inb-mart-12">Your access has been locked.</p>',
                                challenge.errorMsg, ["Cancel", "Unlock"], function () {
                                }, function () {
                                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "PROCEED_BTN"));
                                    var reqParams = {
                                        "deviceId": device.uuid,
                                        "journeyName": "N25"
                                    }
                                    internetBankingService.fetchDetailsByDeviceID(reqParams).then(function (data) {
                                        loggedInUserService.setInbUserId(data);
                                        $state.go('menu.inbUnlockAccessDetails');

                                    }, function (error) {
                                        // utilityService.showErrorMessage(error.responseMessage);
                                        if (error.responseCode == "cs002") {
                                            utilityService.comingSoon(error.responseMessage);
                                        } else {
                                            utilityService.showErrorMessage(error.responseMessage);
                                        }
                                    });

                                });
                            return

                        }
                        else if(challenge.errorCode == constantConfig.FORCE_PWD_ERROR_CODES.FP01){
							utilityService.showForcePasswordPopup(challenge.errorMsg,"");
						}
                        else if(challenge.errorCode == "SB001"){
                            loggedInUserService.fileForStorageData('{"isDeviceRegistered":false,"mpinConsent":false, "simSubscriptionId":""}').then(function (res) {
                                localStorage.setItem('isDeviceRegistered', false);
                                localStorage.setItem('mpinConsent', false);
                                quickPayPreAuthVm.reloadApp(challenge.errorMsg);
                            }, function (err) {
                                localStorage.setItem('isDeviceRegistered', false);
                                localStorage.setItem('mpinConsent', false);
                                quickPayPreAuthVm.reloadApp(challenge.errorMsg);
                            });
                        }
                        else if(challenge.errorCode === "F001") {
                            registerWithSimService.reloadAppSimBinding(challenge.errorMsg);
                        }
                        else {
                            quickPayPreAuthVm.mpinErrorMsg = challenge.errorMsg;
                            quickPayPreAuthVm.mpinErrorMsgFlag = true;
                        }
                    } else {
                        utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
                    }
                };

                quickPayPreAuthVm.mPinAuthChallengeHandler.handleSuccess = function (data) {
                    quickPayPreAuthVm.isChallenged = false;
                    if (data.user) {
                        loggedInUserService.keyId = AdapterUtils.secretData == "" ? data.user.attributes.keyId : encryptionService.getAES256DecryptedData(data.user.attributes.keyId);
                        loggedInUserService.tokenLotus = AdapterUtils.secretData == "" ? data.user.attributes.lotusToken : encryptionService.getAES256DecryptedData(data.user.attributes.lotusToken);
                        var userDetails = AdapterUtils.secretData == "" ? data.user.attributes.userDetails : encryptionService.getAES256DecryptedData(data.user.attributes.userDetails);
                        if (data.user.attributes.sessionId && data.user.attributes.lotusId) {
                            clickStreamService.sessionId = AdapterUtils.secretData == "" ? data.user.attributes.sessionId : encryptionService.getAES256DecryptedData(data.user.attributes.sessionId);
                            clickStreamService.lotusId = AdapterUtils.secretData == "" ? data.user.attributes.lotusId : encryptionService.getAES256DecryptedData(data.user.attributes.lotusId);
                        }
                        loggedInUserService.setUserProfileDetails(JSON.parse(userDetails));
                    }
                };

                quickPayPreAuthVm.mPinAuthChallengeHandler.handleFailure = function (error) {
                    quickPayPreAuthVm.mPinAuthChallengeHandler.cancel();
                    quickPayPreAuthVm.isChallenged = false;
                    //quickPayPreAuthVm.setpassword = "";
                    quickPayPreAuthVm.clearMpin();
                    quickPayPreAuthVm.enabledThisInput(1);
                    utilityService.accessRestricted = "";
                    utilityService.hideSpinner();
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "MPINLGN_BTN"));
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "LOGIN_FAILURE"));
                    if (error.failure) {
                        utilityService.showErrorMessage(error.failure);
                    } else {
                        utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
                    }
                }

                var payload = {};
                var hasedSimInfo = "";
                if(utilityService.isAndroidPlatform()){
                    hasedSimInfo = quickPayPreAuthVm.hasedSimInfo;
                }
                var requestParams = {
                    "mPinNumber": loggedInUserService.finalSHA512Val,
                    "mfDeviceId": loggedInUserService.deviceIdForMpin,
                    "id": loggedInUserService.deviceInfo,
                    "osName": device.platform,
                    "keyId": loggedInUserService.keyId,
                    "reqTimeStamp": (new Date()).toString(),
                    "simId": hasedSimInfo.toString()
                };

                var src = cryptoService.encryptRSAWithPublicKey(encryptionService.iv + "^" + encryptionService.passphrase + "^" + encryptionService.salt, cryptoService.rsaPublicKey);
                payload = {
                    "data": AdapterUtils.secretData + encryptionService.getAES256EncryptedData(JSON.stringify(requestParams)),
                    "src": src
                }

                payload = AdapterUtils.secretData == "" ? requestParams : payload;
                if (quickPayPreAuthVm.isChallenged) {
                    quickPayPreAuthVm.mPinAuthChallengeHandler.submitChallengeAnswer(payload);
                } else {
                    WLAuthorizationManager.login(quickPayPreAuthVm.mPinAuthChallengeHandler.securityCheckName, payload).then(
                        function (data) {
                            utilityService.accessRestricted = utilityService.mPinAuthRequire;
                            utilityService.csatJournies = [];
                            internetBankingService.checkSession().then(function (data) {
                                utilityService.hideSpinner();

                                quickPayPreAuthVm.setRedirection();

                            }, function (error) {
                                utilityService.hideSpinner();

                                quickPayPreAuthVm.setRedirection();

                            });

                            clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "MPINLGN_BTN"));
                            clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "LOGIN_SUCCESS"));
                        },
                        function (error) {
                            //quickPayPreAuthVm.setpassword = "";
                            quickPayPreAuthVm.clearMpin();
                            quickPayPreAuthVm.enabledThisInput(1);
                            utilityService.accessRestricted = "";
                            utilityService.hideSpinner();
                            if (error.errorCode == 'CHALLENGE_HANDLING_CANCELED' || error.errorCode == 'APPLICATION_DISABLED') {
                                return;
                            }
                            if (error.errorCode == "LOGIN_ALREADY_IN_PROCESS") {
                                quickPayPreAuthVm.mPinAuthChallengeHandler.cancel();
                            }
                            clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "MPINLGN_BTN"));
                            clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "LOGIN_FAILURE"));
                            utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
                        });
                }
            } else {
                //quickPayPreAuthVm.setpassword = "";
                quickPayPreAuthVm.clearMpin();
                quickPayPreAuthVm.enabledThisInput(1);
                utilityService.showErrorMessage('Please Enter 6 digit valid MPIN');
            }
        };
        quickPayPreAuthVm.serverConnectErrorPopup = function () {

            quickPayPreAuthVm.clearMpin();
            var inputElement = document.getElementById('InputTxt1');
            if (inputElement) {
                inputElement.disabled = false;
            }

            utilityService.hideSpinner();
            utilityService.showErrorMessage($scope.err);
        };

        quickPayPreAuthVm.showUpgradeMsg = function (errormessage) {

            quickPayPreAuthVm.clearMpin();
            var inputElement = document.getElementById('InputTxt1');
            if (inputElement) {
                inputElement.disabled = false;
            }

            utilityService.hideSpinner();
            utilityService.showUpgradeMessage(errormessage);
        }
        quickPayPreAuthVm.reloadApp = function (message) {
            quickPayPreAuthVm.mPinAuthChallengeHandler.cancel();
            quickPayPreAuthVm.isChallenged = false;
            /*Condition not to show popup if session is expired and reloads automatically as suggested */
            if (message == constantConfig.adapter.CHALLENGE_HANDLING_CANCELED || message == constantConfig.adapter.SESSION_INACTIVITY) {
                loggedInUserService.logoutUser();
            } else {
                var backPopup = $ionicPopup.show({
                    title: null,
                    cssClass: 'my-custom-popup',
                    template: '<div class="button_fund fontSize-subHeading roboto-light font-dark-grey">' + message + '</div>',
                    scope: '',
                    buttons: [{
                        text: 'OK',
                        type: 'button-assertive',
                        onTap: function () {
                            loggedInUserService.logoutUser();
                        }
                    }],
                });
            }
        }
        quickPayPreAuthVm.setRedirection = function () {
            quickPayService.preAuthType = 'mpin';
                homeScreenService.isCustCalled = true;
                quickPayService.getCustomerInfo().then(function (data) {
                    mPinLoginService.isLoggedIn = true;
                    getAccountDetailsService.accountOverviewData = data;
                    homeScreenService.isCustCalled = false;
                    customerInfoService.customerInfo = data.customerInformation;
                    quickPayService.customerInfo = getAccountDetailsService.accountOverviewData;
                    getAccountDetailsService.accountOverviewData = "";
                    $state.go('menu.quickPayLanding');
                }, function (error) {
                    homeScreenService.isCustCalled = false;
                    //homeScreenVM.welcomeTitleSpinner = false;
                    $rootScope.profileImageUrl = 'img/profile_placeholder.svg';
                    utilityService.showErrorMessage(error.responseMessage);
                });
        }

        function afterUserAuthSuccess(data, $event) {
            quickPayService.customerInfo = data;
            quickPayService.yqpBiometricLimit = quickPayService.customerInfo.yqpBiometricLimit;
            quickPayService.yqpVpaLimit = quickPayService.customerInfo.yqpVpaLimit;
            quickPayService.yqpBeneficiaryLimit = quickPayService.customerInfo.yqpBeneficiaryLimit;
            quickPayService.yqpRaiseRequestLimit = quickPayService.customerInfo.yqpRaiseRequestLimit;
            $state.go('menu.quickPayLanding');
        }


        quickPayPreAuthVm.checkBiometric = function () {
            quickPayService.isFingerprintAvailable().then(function (response) {
                var encryptConfig = {
                    clientId: "SBI YONO", //Android: Used for encryption. iOS: used for dialogue if no `localizedReason` is given.
                    clientSecret: loggedInUserService.deviceInfo, //Necessary for Android encrpytion of keys. Use random secret key.
                    disableBackup: true,

                };
                Fingerprint.show(encryptConfig, successCallback, errorCallback);
            }, function (error) {
                utilityService.showErrorMessage('Please enable biometric from device settings.');
            });


        }
        function successCallback() {
			      authByBiometric();
            /*if (result.withFingerprint) {
                //call service to Auth
                authByBiometric();
            } else if (result.withBackup) {
                //call service to retrieve token at adapter

            }
            else if (result == 'Success') {
                //call service to Auth
                authByBiometric();
            }*/
        }

        function errorCallback(error) {

        }

        function authByBiometric() {
            var params = {};
            if(utilityService.isAndroidPlatform() && registerWithSimService.isSimLogin && !registerWithSimService.userWithoutSimReg && (quickPayPreAuthVm.isSimChanged || quickPayPreAuthVm.simList == undefined || quickPayPreAuthVm.simList.length == 0)){
                if(quickPayPreAuthVm.isSimChanged)
                {
					
						loggedInUserService.fileForStorageData('{"isDeviceRegistered":false,"mpinConsent":false, "simSubscriptionId":""}').then(function (res) {
							localStorage.setItem('isDeviceRegistered', false);
							localStorage.setItem('mpinConsent', false);
							quickPayPreAuthVm.reloadApp(registerWithSimService.changedSimMsg);
						}, function (err) {
							localStorage.setItem('isDeviceRegistered', false);
							localStorage.setItem('mpinConsent', false);
							quickPayPreAuthVm.reloadApp(registerWithSimService.changedSimMsg);
						});
					
				}
                    //utilityService.showBhimUpiAlert("alert", registerWithSimService.changedSimMsg);
                else if(quickPayPreAuthVm.simList == undefined || quickPayPreAuthVm.simList.length == 0)
                    utilityService.showBhimUpiAlert("alert", registerWithSimService.noSimMsg);
				return;
			}
            var hasedSimInfo = "";
				if(utilityService.isAndroidPlatform()){
					hasedSimInfo = quickPayPreAuthVm.hasedSimInfo;
				}
            params = { 'type': 'biometric', "simId": hasedSimInfo.toString()};

            //call service to retrieve token at adapter
            quickPayService.userAuthentication(params).then(function (data) {
                quickPayService.preAuthType = 'biometric';
                afterUserAuthSuccess(data);
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_AUTHBYBIOSUCCESS"));
            }, function (error) {
                //$state.go('menu.quickPaySetUp');
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_AUTHBYBIOFAIL"));
                if(error.responseCode == "SB001" || error.responseCode == "F001"){
                    registerWithSimService.reloadAppSimOk(error.responseMessage);
                }
                else if(error.responseCode == constantConfig.FORCE_PWD_ERROR_CODES.FP01){
                    utilityService.showForcePasswordPopup(error.responseMessage,"");
                }
                else
                {
                    utilityService.showErrorMessage(error.responseMessage);
                }
            });
        }


        quickPayPreAuthVm.enabledThisInput = function (index) {
            try {
                quickPayPreAuthVm.mpinErrorMsgFlag = false;
                for (var i = 1; i <= 6; i++) {
                    var inputElement = document.getElementById('InputTxt' + i);
                    if (index == i) {
                        inputElement.disabled = false;
                        inputElement.style = "border-bottom:1px solid #0095da !important;"
                    } else {
                        inputElement.disabled = true;
                        inputElement.style = "border-bottom:1px solid #bcbebf !important;"
                    }
                }
            } catch (err) { }
        }
        $scope.$on('$ionicView.beforeEnter', function () {
            quickPayPreAuthVm.simSubscriptionId = "";
            quickPayPreAuthVm.hasedSimInfo = "";
            quickPayPreAuthVm.simList = [];
            quickPayPreAuthVm.isSimChanged = false;
            quickPayService.exitYqp().then(function (data) {
                loggedInUserService.tokenLotus = "";
            }, function (error) {
                //utilityService.showErrorMessage(error.responseMessage);
            });
            quickPayService.clearVariables();
            quickPayPreAuthVm.isChallenged = false;
            quickPayPreAuthVm.isBiometricSet = localStorage.getItem("isBiometricSet");
            //Check device is locked or not, depend on that go to User ID tab as default
            quickPayPreAuthVm.keyguardValue = internetBankingService.checkKeyguardValue;
            quickPayPreAuthVm.yqpBiometricLimit = quickPayService.customerInfo.yqpBiometricLimit ? parseInt(quickPayService.customerInfo.yqpBiometricLimit) : "";
            //quickPayPreAuthVm.keyguardValue = 'true';
            if (quickPayPreAuthVm.isBiometricSet == undefined || quickPayPreAuthVm.isBiometricSet == "false") {
                quickPayPreAuthVm.isBiometricSet = false;
            }
            else {
                quickPayPreAuthVm.isBiometricSet = true;
            }
            quickPayPreAuthVm.isMpinSet = loggedInUserService.mpinConsent;
            quickPayPreAuthVm.bio_text = "";
            if (quickPayService.isBiometricType == 'face')
                quickPayPreAuthVm.bio_text = "Face ID";
            else
                quickPayPreAuthVm.bio_text = "Touch ID";

            $translate(['ENABLE_FACEID', 'ENABLE_FACEID_DESC', 'YQP_AUTH_MSG'], { FIELD_1: quickPayPreAuthVm.bio_text }).then(function (translations) {
                quickPayPreAuthVm.ENABLE_FACEID = translations['ENABLE_FACEID'];
                quickPayPreAuthVm.ENABLE_FACEID_DESC = translations['ENABLE_FACEID_DESC'];
                quickPayPreAuthVm.YQP_AUTH_MSG = translations['YQP_AUTH_MSG'];
            });
            quickPayPreAuthVm.isFingerprintAvl = false;
            quickPayPreAuthVm.isFingerprintAvlDevice = false;

            quickPayService.isFingerprintAvailable().then(function (response) {
                quickPayPreAuthVm.isFingerprintAvlDevice = true;

                var fingerprintToken = "";
                cordova.plugins.SecureKeyStore.get(function (res) {
                    fingerprintToken = res;
                    if (fingerprintToken == null || fingerprintToken == "null" || fingerprintToken == undefined || fingerprintToken == "undefined" || fingerprintToken == "") {
                        quickPayPreAuthVm.isFingerprintAvl = false;
                    }
                    else {
                        quickPayPreAuthVm.isFingerprintAvl = true;
                        //to auto populate fingerprint option
                        quickPayPreAuthVm.checkBiometric();
                    }
                }, function (error) {

                }, loggedInUserService.deviceInfo);
            }, function (error) {
            });

            if(quickPayPreAuthVm.isMpinSet && quickPayPreAuthVm.keyguardValue === 'true'){
                event = {};
                event.target = {};
                event.target.className = "mpin1 border-black activated";
                $rootScope.hidekeypad(event);
            }
            if (utilityService.isAndroidPlatform()) {
                utilityService.showSpinner();
                readSimcardInfo();
            }
        });

        function readSimcardInfo() {
            /*Sim card Info fetching - Start*/
            function simInfosuccessCallback(result) {
                utilityService.hideSpinner();
                var str = "";
                quickPayPreAuthVm.isSimChanged = false;
                if(result.cards && result.cards.length > 0)
                {
                    quickPayPreAuthVm.simList = result.cards;
                    var isAccountExists = -1;
                    quickPayPreAuthVm.simList.some(function (obj, i) {
                        return obj.subscriptionId == registerWithSimService.simSubscriptionId ? isAccountExists = i : false;
                    });
                    if (isAccountExists !== -1) {
                        str = device.uuid + registerWithSimService.simSubscriptionId;
                        quickPayPreAuthVm.simSubscriptionId = registerWithSimService.simSubscriptionId;
                        quickPayPreAuthVm.hasedSimInfo = cryptoService.getSHA512EncryptedData(str);
                    }
                    else{
                        //either sim card is removed or slot changed or subscription id changed due to sim changes
                        quickPayPreAuthVm.isSimChanged = true;
                        quickPayPreAuthVm.simSubscriptionId = "";

                    }
                }
                if (quickPayPreAuthVm.simList == undefined || quickPayPreAuthVm.simList.length == 0) {
                    utilityService.showBhimUpiAlert("alert", registerWithSimService.noSimMsg);
                }

                $scope.$apply();
            }

                function HasPerminionSuccessCallback(result) {
                    if (result) {
                        window.plugins.sim.getSimInfo(simInfosuccessCallback, errorCallbackSim);
                    } else {
                        requestReadPermission();
                    }
                }

                function errorCallbackSim(error) {
                    utilityService.hideSpinner();
                    utilityService.showBhimUpiAlert("Permission denied.");
                }

                function requestSuccessCallback(result) {
                    if (result) {
                        hasReadPermission();
                    }
                }
                // Android only: check permission
                function hasReadPermission() {
                    window.plugins.sim.hasReadPermission(HasPerminionSuccessCallback, errorCallbackSim);
                }
                // Android only: request permission
                function requestReadPermission() {
                    window.plugins.sim.requestReadPermission(requestSuccessCallback, errorCallbackSim);
                }
                hasReadPermission();
                /*Sim card Info fetching - End*/
            }

        return this;
    }
]);


