angularApp.service('quickPayService',
	function ($q, utilityService, AdapterUtils, $state, $ionicPopup, loggedInUserService, cryptoService, internetBankingService, encryptionService, clickStreamService, registerWithSimService) {
		var quickPayService = this;

		quickPayService.customerInfo = "";
		quickPayService.myTab = "P";
		quickPayService.mySubTab = '';
		quickPayService.isFingerprintAviFlag = false;
		quickPayService.isBiometricType = 'finger';

		quickPayService.setBioTnC = "";
		quickPayService.viewbalAvl = false;

		quickPayService.payToBeneficiaryData = {};
		quickPayService.payToContactData = {};
		quickPayService.payToVPAData = {};
		quickPayService.payToQRData = {};
		quickPayService.transactionLists = [];
		quickPayService.favLists = [];
		quickPayService.pendingLists = [];
		quickPayService.payToContactFrequent = [];
		quickPayService.payFromTransList = false;
		quickPayService.payFromTransListData = [];
		quickPayService.isSplitChecked = false;
		quickPayService.payFromCollectRequest = false;
		quickPayService.payFromCollectRequestData = {};
		quickPayService.billCategoryLists = [];
		quickPayService.preAuthType = '';
		quickPayService.receiveMoneyFrequentContact = [];
		quickPayService.payRequestId ="";
		quickPayService.payToCollectContactData = {};
		quickPayService.clearVariables = function () {
			quickPayService.myTab = "P";
			quickPayService.mySubTab = '';
			quickPayService.payToBeneficiaryData = {};
			quickPayService.payToContactData = {};
			quickPayService.payToVPAData = {};
			quickPayService.payToQRData = {};
			quickPayService.transactionLists = [];
			quickPayService.favLists = [];
			quickPayService.isSplitChecked = false;
			quickPayService.pendingLists = [];
			quickPayService.receiveMoneyFrequentContact = [];
			quickPayService.payToCollectContactData={};
		}
		quickPayService.pendingCallInitiated = false;
		quickPayService.isFingerprintAvailable = function () {
			var q = $q.defer();
			Fingerprint.isAvailable(function (result) {
				if (result == 'finger' || result == 'face' || result == 'biometric') {
					quickPayService.isFingerprintAviFlag = true;
					if (result == 'face') {
						quickPayService.isBiometricType = 'face';
					}else if (result == 'finger') {
						quickPayService.isBiometricType = 'finger';
					}
					else if (result == 'biometric') {
						quickPayService.isBiometricType = 'biometric';
					}
					q.resolve({ "responseMessage": true });
				}
				else {
					//Display error fingerprint not available
					quickPayService.isFingerprintAviFlag = false;
					q.reject({ "responseMessage": "Fingerprint not found" });
				}
			}, function (message) {
				quickPayService.isFingerprintAviFlag = false;
				q.reject({ "responseMessage": "Fingerprint not found" });
				//Display error fingerprint not available
			});
			return q.promise;
		}
		function isAvailableSuccess(result) {
			var q = $q.defer();
			if (result == 'finger' || result == 'face') {
				quickPayService.isFingerprintAviFlag = true;
				q.resolve({ "responseMessage": true });

			}
			else {
				//Display error fingerprint not available
				quickPayService.isFingerprintAviFlag = false;
				q.reject({ "responseMessage": "Fingerprint not found" });

			}
		}

		function isAvailableError(message) {
			var q = $q.defer();
			quickPayService.isFingerprintAviFlag = false;
			q.reject({ "responseMessage": "Fingerprint not found" });
			//Display error fingerprint not available
		}
		quickPayService.registerCif = function (params) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/HomeAdapter/yqp/fetchDetailsByDeviceId", params, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		quickPayService.generateBiometricSHA512Val = function (bio_id) {
			var SHA512HashedVal = bio_id + loggedInUserService.keyId;
			return cryptoService.getSHA512EncryptedData(SHA512HashedVal).toString();
		}

		quickPayService.generateBenSHA512Val = function () {
			var SHA512HashedVal = loggedInUserService.deviceIdForMpin + loggedInUserService.keyId;
			return cryptoService.getSHA512EncryptedData(SHA512HashedVal).toString();
		}

		quickPayService.userAuthentication = function (requestParams) {
			var q = $q.defer();
			var params = {};
			if (requestParams.type == 'biometric') {
				var fingerprintToken = "";
				cordova.plugins.SecureKeyStore.get(function (res) {
					fingerprintToken = res;


					if (fingerprintToken == null || fingerprintToken == "null" || fingerprintToken == undefined || fingerprintToken == "undefined" || fingerprintToken == "") {

						q.reject({ "responseMessage": "Fingerprint not found" });

					}
					else {
						var finalSHA512Val = quickPayService.generateBiometricSHA512Val(fingerprintToken);
						if (requestParams.amount && requestParams.amount != '') {
							params = {
								"deviceId": device.uuid,
								"concatenateId": finalSHA512Val,
								"amount": requestParams.amount,
								"benAccntNo": requestParams.benAccntNo,
								"simId" : requestParams.simId
							};
						}
						else {
							params = {
								"deviceId": device.uuid,
								"concatenateId": finalSHA512Val,
								"simId" : requestParams.simId
							};
						}

						
						AdapterUtils.postData("adapters/HomeAdapter/yqp/authenticateUser", params, true).then(
							function (response) {
								loggedInUserService.keyId = response.data.salt;
								if (response.data.lotusToken) {
									loggedInUserService.tokenLotus = AdapterUtils.secretData == "" ? response.data.lotusToken : encryptionService.getAES256DecryptedData(response.data.lotusToken);
								}
								if (response.data.lotusId) {
									clickStreamService.lotusId = AdapterUtils.secretData == "" ? response.data.lotusId : encryptionService.getAES256DecryptedData(response.data.lotusId);
								}
								q.resolve(response.data);
							},
							function (error) {
								q.reject(error);
							}
						);
					}
				}, function (error) {
					q.reject({ "responseMessage": "Fingerprint not found" });
				}, loggedInUserService.deviceInfo);
			}
			else if (requestParams.type == 'mpin') {
				var finalSHA512Val = registerWithSimService.isSimLogin ?
					loggedInUserService.generateMPINSHA512ValWithSim(requestParams.mPinNumber, requestParams.simSubId) :
					loggedInUserService.generateMPINSHA512Val(requestParams.mPinNumber) ;
				if (requestParams.amount && requestParams.amount != '') {
					params = {
						"deviceId": device.uuid,
						"mpinNumber": finalSHA512Val,
						"amount": requestParams.amount,
						"benAccntNo": requestParams.benAccntNo,
						"simId" : requestParams.simId
					};
				}
				else {
					params = {
						"deviceId": device.uuid,
						"mpinNumber": finalSHA512Val,
						"simId" : requestParams.simId
					};
				}

				if (requestParams.isVpa) {
					params.isVpa = true;
				} else {
					params.isVpa = false;
				}
				AdapterUtils.postData("adapters/HomeAdapter/yqp/authenticateUser", params, true).then(
					function (response) {
						loggedInUserService.keyId = response.data.salt;
						
						if (response.data.lotusToken) {
							loggedInUserService.tokenLotus = AdapterUtils.secretData == "" ? response.data.lotusToken : encryptionService.getAES256DecryptedData(response.data.lotusToken);
						}
						if (response.data.lotusId) {
							clickStreamService.lotusId = AdapterUtils.secretData == "" ? response.data.lotusId : encryptionService.getAES256DecryptedData(response.data.lotusId);
						}
						q.resolve(response.data);
					},
					function (error) {
						q.reject(error);
					}
				);
			}
			else if (requestParams.type == 'username') {
				if (requestParams.amount && requestParams.amount != '') {
					params = {
						"deviceId": device.uuid,
						"userName": requestParams.userName,
						"sha512Password": requestParams.sha512Password,
						"bankCode": "0",
						"osName": device.platform,
						"channel": "lotus",
						"serviceId": loggedInUserService.serviceIdINB,
						"amount": requestParams.amount,
						"simId" : requestParams.simId
					};
				}
				else {
					params = {
						"deviceId": device.uuid,
						"userName": requestParams.userName,
						"sha512Password": requestParams.sha512Password,
						"bankCode": "0",
						"osName": device.platform,
						"channel": "lotus",
						"serviceId": loggedInUserService.serviceIdINB,
						"simId" : requestParams.simId

					};
				}

				AdapterUtils.postData("adapters/HomeAdapter/yqp/authenticateUser", params, true).then(
					function (response) {
						//loggedInUserService.keyId = response.data.salt;
						if (response.data.lotusToken) {
							loggedInUserService.tokenLotus = AdapterUtils.secretData == "" ? response.data.lotusToken : encryptionService.getAES256DecryptedData(response.data.lotusToken);
						}
						if (response.data.lotusId) {
							clickStreamService.lotusId = AdapterUtils.secretData == "" ? response.data.lotusId : encryptionService.getAES256DecryptedData(response.data.lotusId);
						}
						q.resolve(response.data);
					},
					function (error) {
						q.reject(error);
					}
				);
			}
			return q.promise;
		}



		quickPayService.getOtp = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/OTPAdapter/getOTPTokenUnsecure", {}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		quickPayService.getOtpSecure = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/OTPAdapter/getOTPTokenSecure", {}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		quickPayService.validateOtp = function (payLoad) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/OTPAdapter/validateOTPTokenUnsecure", payLoad, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		quickPayService.validateOtpSecure = function (payLoad) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/OTPAdapter/validateOTPTokenSecure", payLoad, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		quickPayService.fetchRtermcondition = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/getTnC", obj, true).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		quickPayService.showTnCAlertModal = function (heading, message, buttonText, callBack) {
			var alertPopup = $ionicPopup.alert({
				title: heading,
				template: '<div class="popupTextBottomPadding ss-p-r-f-8 ss-popup-list font-size-12 font-light ss-text-color">'
				+ message + '</div></div>',
				cssClass: 'quickpaytnc removePopup-head popupWidth90 popupMargin popupBackgroundWhite ss-popup',
				buttons: [
					{
						text: buttonText,
						onTap: function (e) {
							callBack();
						}
					}
				],
			});
		}

		quickPayService.setPrimary = function (params) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/SettingsAdapter/yqp/setDefaultAccount", params, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		quickPayService.saveBiometricToken = function (params) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/HomeAdapter/yqp/auth/saveBiometricAuth", params, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		quickPayService.disableBiometricToken = function (params) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/HomeAdapter/yqp/auth/disableBiometricAuth", params, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		quickPayService.getImageById = function (params) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MyDreamsAdapter/yqp/getImageById", params, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		quickPayService.getBeneficiaryList = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FundsTransferAdapter/yqp/auth/allBeneficiaryList", { "key": quickPayService.generateBenSHA512Val() }, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		quickPayService.validateTxn = function (params) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FundsTransferAdapter/yqp/auth/validateTxn", params, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		quickPayService.postTxn = function (params) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FundsTransferAdapter/yqp/auth/postTxn", params, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		quickPayService.userAuthPopoverTemplate = function (array, controllerName) {
			var template = '<ion-popover-view class="user-auth-modal">' +
				'<ion-content class="quickpay" id="userAuthModalICId">' +
				'<div class="">' +
				'<div class="col col-40 float-left txt-right pad-top-2" ng-class="{' + '\'font-size-16 colorB22382 roboto-regular\'' + ' : !' + controllerName + '.toggle.checked, ' + '\'font-size-14 color545454 roboto-light\'' + ' : ' + controllerName + '.toggle.checked}" translate="YQP_MPIN"></div>' +
				'<div class="col col-20 float-left txt-center">' +
				'<ion-toggle class="ncmc-toggle color545454" ng-disabled="!' + controllerName + '.isMpinSet || ' + controllerName + '.authFailure" ng-model="' + controllerName + '.toggle.checked" ng-change="' + controllerName + '.toggle()">' +
				'</ion-toggle>' +
				'</div>' +
				'<div class="col col-40 float-left txt-left pad-top-2" ng-class="{' + '\'font-size-16 colorB22382 roboto-regular\'' + ' : ' + controllerName + '.toggle.checked, ' + '\'font-size-14 color545454 roboto-light\'' + ' : !' + controllerName + '.toggle.checked}" translate="YQP_USERID"></div>' +
				'<div class="clear"></div>' +
				'</div>' +

				'<div class="mar-l-r-12" ng-if="' + controllerName + '.toggle.checked">' +
				'<form  ng-click = "hidekeypad($event)" name="userLandingLoginForm" novalidate ng-submit="userLandingLoginForm.$valid">' +
				'<div>' +
				'<label class="fss-input-box item-floating-label form-field fss-select-box-div border-bot-light-black">' +
				'<span class="input-label font-desc txt-left">{{' + controllerName + '.usernameTxt}}</span>' +
				'<input required maxlength="30" type="text" placeholder="{{' + controllerName + '.usernameTxt}}" ng-model="' + controllerName + '.userName" ng-click="" class="fontSize-subHeading roboto-regular color747474" ng-disabled="' + controllerName + '.authFailure" name="username" autocorrect="off" disable-cut-copy-paste autocapitalize="none">' +
				'</label>' +
				'<div class="sbi-error-msg width100Percent txt-left">' +
				'<span ng-show="userLandingLoginForm.username.$error.required && ' + controllerName + '.isLoginBtnClicked" class="error" translate="REQUIRED_ERROR"></span>' +
				'</div>' +
				'</div>' +
				'<div class="mar-top-24">' +
				'<label class=" fss-input-box item-floating-label form-field fss-select-box-div border-bot-light-black">' +
				'<span class="input-label font-desc txt-left">{{' + controllerName + '.passwordTxt}}</span>' +
				'<input required maxlength="30" type="password" placeholder="{{' + controllerName + '.passwordTxt}}" ng-model="' + controllerName + '.password" ng-click="" class="fontSize-subHeading roboto-regular color747474" ng-disabled="' + controllerName + '.authFailure" name="password" autocorrect="off" disable-cut-copy-paste>' +
				'</label>' +
				'<div class="sbi-error-msg width100Percent txt-left">' +
				'<span ng-show="userLandingLoginForm.password.$error.required && ' + controllerName + '.isLoginBtnClicked" class="error" translate="REQUIRED_ERROR"></span>' +
				'</div>' +
				'</div>' +
				'</form>' +
				'<div class="mar-top-24">' +
				'<button type="submit" class="quickpay confirm-btn button button-small colorf7f7f7 bhim-btn-spec-dbl bqr-font-rob-med btn-rad" id="QUICK_PAY_AUTHENTICATE" click-stream="click" ng-click="' + controllerName + '.authenticate()" ng-disabled="' + controllerName + '.authFailure" translate="YQP_AUTHENTICATE">' +
				'</button>' +
				'</div>' +
				/*'<div ng-if="' + controllerName + '.isBiometricSet && ' + controllerName + '.isFingerprintAvl">' +
				'<div class="mar-top-60">' +
				'<div class="or-block-hr">' +
				'<div class="or-block">or</div>' +
				'</div>' +
				'</div>' +
				'<div class="mar-top-42" ng-click="' + controllerName + '.checkBiometric()">' +
				'<div class="txt-center"><img src="img/quickpay/biometric.svg" class="" height="42" /></div>' +
				'<div class="txt-center roboto-medium font-size-19 line-height-23 color3f3f3f mar-top-16" translate="YQP_BIO"></div>' +
				'<div class="txt-center roboto-light font-size-12 color3f3f3f pad-top-4">{{' + controllerName + '.YQP_AUTH_MSG}}</div>' +
				'</div>' +
				'</div>' +*/
				'</div>' +
				'<div class="form pad-left-28 pad-right-28 pad-top-24" ng-if="!' + controllerName + '.toggle.checked">' +
				'<div translate="YQP_MPIN" class="txt-center pad-bot-30"></div>' +
				'<div id="login-2" ng-if="' + controllerName + '.keyguardValue === \'true\'" class="pad-bot-25">' +
				'<div id="pin">' +
				'<div  id="yqp_pin1" class ="mpin1" ng-click="showKeyboard()"><i class="icon ion-record" ng-show="pinDotVisible[&apos;1&apos;] && isPassVisible !== true"></i><span ng-if="isPassVisible === true" >{{' + controllerName + '.first}} </span></div>' +
				'<div  id="yqp_pin2" class="mpin1" ng-click="showKeyboard()"><i class="icon ion-record" ng-show="pinDotVisible[&apos;2&apos;] && isPassVisible !== true"></i><span ng-if="isPassVisible === true" >{{' + controllerName + '.second}}</span></div>' +
				'<div  id="yqp_pin3" class="mpin1" ng-click="showKeyboard()"><i class="icon ion-record" ng-show="pinDotVisible[&apos;3&apos;] && isPassVisible !== true"></i><span ng-if="isPassVisible === true" >{{' + controllerName + '.third}}</span></div>' +
				'<div  id="yqp_pin4" class="mpin1" ng-click="showKeyboard()"><i class="icon ion-record" ng-show="pinDotVisible[&apos;4&apos;] && isPassVisible !== true"></i><span ng-if="isPassVisible === true" >{{' + controllerName + '.fourth}} </span></div>' +
				'<div  id="yqp_pin5" class="mpin1" ng-click="showKeyboard()"><i class="icon ion-record" ng-show="pinDotVisible[&apos;5&apos;] && isPassVisible !== true"></i><span ng-if="isPassVisible === true" >{{' + controllerName + '.fifth}} </span></div>' +
				'<div  id="yqp_pin6" class="mpin1" ng-click="showKeyboard()"><i class="icon ion-record" ng-show="pinDotVisible[&apos;6&apos;] && isPassVisible !== true"></i><span ng-if="isPassVisible === true" >{{' + controllerName + '.sixth}} </span></div>' +
				'</div>' +
				'</div>' +
				'<div align="center">' +
				'<div class="homeLoan" ng-if="' + controllerName + '.keyguardValue !== \'true\'" >' +
				'<div class="txt-center">' +
				'<img src="img/FT/BhimUpi/alertSymbol.svg" alt="" title="" class="approvedIconPosition" />' +
				'</div>' +
				'<div class="pad-top-20 txt-center colr3f3f3f" style="padding-left: 5%;padding-right: 5%;">' +
				'<span class="font-size-14" translate="YQP_KEYGUARD_ERR_MSG"></span>' +
				'</div>' +
				'</div>' +
				'</div>' +

				'<div ng-if="' + controllerName + '.isBiometricSet && ' + controllerName + '.isFingerprintAvl">' +
				'<div class="mar-top-60">' +
				'<div class="or-block-hr">' +
				'<div class="or-block">or</div>' +
				'</div>' +
				'</div>' +
				'<div class="mar-top-42" ng-click="' + controllerName + '.checkBiometric()">' +
				'<div class="txt-center"><img src="img/quickpay/biometric.svg" class="" height="42" /></div>' +
				'<div class="txt-center roboto-medium font-size-19 line-height-23 color3f3f3f mar-top-16" translate="YQP_BIO"></div>' +
				'<div class="txt-center roboto-light font-size-12 color3f3f3f pad-top-4">{{' + controllerName + '.YQP_AUTH_MSG}}</div>' +
				'</div>' +
				'</div>' +

				'</div>' +

				'</ion-content>' +

				'</ion-popover-view>' +
				'<ion-digit-keyboard settings="keyboardSettings" ng-if="' + controllerName + '.isMpinSet && !' + controllerName + '.toggle.checked" ng-show="keyboardVisible && !' + controllerName + '.authFailure"></ion-digit-keyboard>';

			
			return template;
		}
		//Don't use this popup for common functionality

		// below popup template is rewritten because above popup is commonly used by many journeys, but their is some ISD observation which need to be fixed for this common popup
		// but fixing ISD issue in prod env will have impact on other journey popup
		// this common popup is removed in SIT env by team in prelogin revamp page.
		quickPayService.userAuthPopoverTemplateOmp = function (array, controllerName) {
			return '<ion-popover-view class="user-auth-modal">' +
				'<ion-content class="quickpay" id="userAuthModalICId">' +
				'<div class="">' +
				'<div class="col col-40 float-left txt-right pad-top-2" ng-class="{' + '\'font-size-16 colorB22382 roboto-regular\'' + ' : !' + controllerName + '.toggle.checked, ' + '\'font-size-14 color545454 roboto-light\'' + ' : ' + controllerName + '.toggle.checked}" translate="YQP_MPIN"></div>' +
				'<div class="col col-20 float-left txt-center">' +
				'<ion-toggle class="ncmc-toggle color545454" ng-disabled="!' + controllerName + '.isMpinSet || ' + controllerName + '.authFailure" ng-model="' + controllerName + '.toggle.checked" ng-change="' + controllerName + '.toggle()">' +
				'</ion-toggle>' +
				'</div>' +
				'<div class="col col-40 float-left txt-left pad-top-2" ng-class="{' + '\'font-size-16 colorB22382 roboto-regular\'' + ' : ' + controllerName + '.toggle.checked, ' + '\'font-size-14 color545454 roboto-light\'' + ' : !' + controllerName + '.toggle.checked}" translate="YQP_USERID"></div>' +
				'<div class="clear"></div>' +
				'</div>' +
				'<div class="mar-l-r-12" ng-if="' + controllerName + '.toggle.checked">' +
				'<form  ng-click = "hidekeypad($event)" name="userLandingLoginForm" novalidate ng-submit="userLandingLoginForm.$valid">' +
				'<div>' +
				'<label class="fss-input-box item-floating-label form-field fss-select-box-div border-bot-light-black">' +
				'<span class="input-label font-desc txt-left">{{' + controllerName + '.usernameTxt}}</span>' +
				'<input required maxlength="30" type="text" placeholder="{{' + controllerName + '.usernameTxt}}" ng-model="' + controllerName + '.userName" ng-click="" class="fontSize-subHeading roboto-regular color747474" ng-disabled="' + controllerName + '.authFailure" name="username" autocorrect="off" disable-cut-copy-paste autocapitalize="none">' +
				'</label>' +
				'<div class="sbi-error-msg width100Percent txt-left">' +
				'<span ng-show="userLandingLoginForm.username.$error.required && ' + controllerName + '.isLoginBtnClicked" class="error" translate="REQUIRED_ERROR"></span>' +
				'</div>' +
				'</div>' +
				'<div class="mar-top-24">' +
				'<label class=" fss-input-box item-floating-label form-field fss-select-box-div border-bot-light-black">' +
				'<span class="input-label font-desc txt-left">{{' + controllerName + '.passwordTxt}}</span>' +
				'<input required maxlength="30" type="password" placeholder="{{' + controllerName + '.passwordTxt}}" ng-model="' + controllerName + '.pswd" ng-click="" class="fontSize-subHeading roboto-regular color747474" ng-disabled="' + controllerName + '.authFailure" name="password" autocorrect="off" disable-cut-copy-paste>' +
				'</label>' +
				'<div class="sbi-error-msg width100Percent txt-left">' +
				'<span ng-show="userLandingLoginForm.password.$error.required && ' + controllerName + '.isLoginBtnClicked" class="error" translate="REQUIRED_ERROR"></span>' +
				'</div>' +
				'</div>' +
				'</form>' +
				'<div class="mar-top-24">' +
				'<button type="submit" class="quickpay confirm-btn button button-small colorf7f7f7 bhim-btn-spec-dbl bqr-font-rob-med btn-rad" id="QUICK_PAY_AUTHENTICATE" click-stream="click" ng-click="' + controllerName + '.authenticate()" ng-disabled="' + controllerName + '.authFailure" translate="YQP_AUTHENTICATE">' +
				'</button>' +
				'</div>' +
				'</div>' +
				'<div class="form pad-left-28 pad-right-28 pad-top-24" ng-if="!' + controllerName + '.toggle.checked">' +
				'<div translate="YQP_MPIN" class="txt-center pad-bot-30"></div>' +
				'<div id="login-2" ng-if="' + controllerName + '.keyguardValue === \'true\'" class="pad-bot-25">' +
				'<div id="pin">' +
				'<div  id="yqp_pin1" class ="mpin1" ng-click="showKeyboard()"><i class="icon ion-record" ng-show="pinDotVisible[&apos;1&apos;] && isPassVisible !== true"></i><span ng-if="isPassVisible === true" >{{' + controllerName + '.first}} </span></div>' +
				'<div  id="yqp_pin2" class="mpin1" ng-click="showKeyboard()"><i class="icon ion-record" ng-show="pinDotVisible[&apos;2&apos;] && isPassVisible !== true"></i><span ng-if="isPassVisible === true" >{{' + controllerName + '.second}}</span></div>' +
				'<div  id="yqp_pin3" class="mpin1" ng-click="showKeyboard()"><i class="icon ion-record" ng-show="pinDotVisible[&apos;3&apos;] && isPassVisible !== true"></i><span ng-if="isPassVisible === true" >{{' + controllerName + '.third}}</span></div>' +
				'<div  id="yqp_pin4" class="mpin1" ng-click="showKeyboard()"><i class="icon ion-record" ng-show="pinDotVisible[&apos;4&apos;] && isPassVisible !== true"></i><span ng-if="isPassVisible === true" >{{' + controllerName + '.fourth}} </span></div>' +
				'<div  id="yqp_pin5" class="mpin1" ng-click="showKeyboard()"><i class="icon ion-record" ng-show="pinDotVisible[&apos;5&apos;] && isPassVisible !== true"></i><span ng-if="isPassVisible === true" >{{' + controllerName + '.fifth}} </span></div>' +
				'<div  id="yqp_pin6" class="mpin1" ng-click="showKeyboard()"><i class="icon ion-record" ng-show="pinDotVisible[&apos;6&apos;] && isPassVisible !== true"></i><span ng-if="isPassVisible === true" >{{' + controllerName + '.sixth}} </span></div>' +
				'</div>' +
				'</div>' +
				'<div align="center">' +
				'<div class="homeLoan" ng-if="' + controllerName + '.keyguardValue !== \'true\'" >' +
				'<div class="txt-center">' +
				'<img src="img/FT/BhimUpi/alertSymbol.svg" alt="" title="" class="approvedIconPosition" />' +
				'</div>' +
				'<div class="pad-top-20 txt-center colr3f3f3f padding-left-5-per padding-right-5-per">' +
				'<span class="font-size-14" translate="YQP_KEYGUARD_ERR_MSG"></span>' +
				'</div>' +
				'</div>' +
				'</div>' +
				'<div ng-if="' + controllerName + '.isBiometricSet && ' + controllerName + '.isFingerprintAvl">' +
				'<div class="mar-top-60">' +
				'<div class="or-block-hr">' +
				'<div class="or-block">or</div>' +
				'</div>' +
				'</div>' +
				'<div class="mar-top-42" ng-click="' + controllerName + '.checkBiometric()">' +
				'<div class="txt-center"><img src="img/quickpay/biometric.svg" class="" height="42" /></div>' +
				'<div class="txt-center roboto-medium font-size-19 line-height-23 color3f3f3f mar-top-16" translate="YQP_BIO"></div>' +
				'<div class="txt-center roboto-light font-size-12 color3f3f3f pad-top-4">{{' + controllerName + '.YQP_AUTH_MSG}}</div>' +
				'</div>' +
				'</div>' +
				'</div>' +
				'</ion-content>' +
				'</ion-popover-view>' +
				'<ion-digit-keyboard settings="keyboardSettings" ng-if="' + controllerName + '.isMpinSet && !' + controllerName + '.toggle.checked" ng-show="keyboardVisible && !' + controllerName + '.authFailure"></ion-digit-keyboard>';
		}
		quickPayService.showAlertPopupForViewBalSetUp = function (imageType, message, onTapgo, OnTapCancel, buttontext1, buttontext2, $scope) {

			var btn_array = [];
			if (buttontext1 != "" && buttontext2 != "") {
				btn_array = [
					{
						text: buttontext2 || "Cancel",
						type: 'button-negative',
						onTap: function () {
							if (OnTapCancel != '')
								$state.go(OnTapCancel);

							
						}
					},
					{
						text: buttontext1 || "OK",
						type: 'button-positive',
						onTap: function () {
							if (onTapgo) {
								if (onTapgo != '')
									$state.go(onTapgo);
							}
						}
					}
				];
			}


			if (imageType && imageType.toLowerCase() == 'error') {
				imageType = 'img/FT/BhimUpi/errorSymbol.svg';
			} else if (imageType && imageType.toLowerCase() == 'success') {
				imageType = 'img/FT/BhimUpi/successSymbol.svg';
			} else {
				imageType = 'img/FT/BhimUpi/alertSymbol.svg';
			}
			var bhimErrorPopup = $ionicPopup.alert({
				template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src=' + imageType + ' /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'
				+ message + '</span></div></div></div>', //template,
				scope: $scope,
				cssClass: 'bhim-alert-popup',
				buttons: btn_array,
			});
			bhimErrorPopup.then(function (res) {
			});
		};

		quickPayService.showAlertPopup = function (imageType, message, onTapgo, OnTapCancel, buttontext1, buttontext2, $scope) {
			var btn_array = [];
			if (buttontext1 != "" && buttontext2 != "") {
				btn_array = [
					{
						text: buttontext2 || "Cancel",
						type: 'button-negative',
						onTap: function () {
							if (OnTapCancel != '')
								$state.go(OnTapCancel);
						}
					},
					{
						text: buttontext1 || "OK",
						type: 'button-positive',
						onTap: function () {
							if (onTapgo) {
								if (onTapgo != '')
									$state.go(onTapgo);
							}
						}
					}
				];
			}
			else {
				btn_array = [
					{
						text: buttontext1 || "OK",
						type: 'button-positive',
						onTap: function () {
							if (onTapgo) {
								$state.go(onTapgo);
							}
						}
					}
				];
			}
			var imgsrc = "";
			if (imageType && imageType.toLowerCase() == 'error') {
				imgsrc = 'img/FT/BhimUpi/errorSymbol.svg';
			} else if (imageType && imageType.toLowerCase() == 'success') {
				imgsrc = 'img/FT/BhimUpi/successSymbol.svg';
			} else {
				imgsrc = 'img/FT/BhimUpi/alertSymbol.svg';
			}
			var template = "";
			if (imageType == 'noImage') {
				template = '<div class="font-dark-grey"><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'
					+ message + '</span></div></div></div>';
			}
			else {
				template = '<div class="font-dark-grey"><div><img class="approvedIconPosition" src=' + imgsrc + ' /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'
					+ message + '</span></div></div></div>';
			}
			var bhimErrorPopup = $ionicPopup.alert({
				template: template,
				scope: $scope,
				cssClass: 'bhim-alert-popup',
				buttons: btn_array,
			});
			bhimErrorPopup.then(function (res) {
			});
		};
		quickPayService.isUndefined = function (obj) {
			return (typeof obj === "undefined" || obj === null || obj === '' || obj === 'null' || obj === 'string');
		};
		quickPayService.showAuthFailurePopup = function (imageType, message, onTapgo, OnTapCancel, buttontext1, buttontext2, $scope, iscallback, callBack) {
			var btn_array = [];
			if (buttontext1 != "" && buttontext2 != "") {
				btn_array = [
					{
						text: buttontext2 || "Cancel",
						type: 'button-negative',
						onTap: function () {
							if (OnTapCancel != '')
								$state.go(OnTapCancel);

							if (iscallback) {
								callBack();
							}
						}

					},
					{
						text: buttontext1 || "OK",
						type: 'button-positive',
						onTap: function () {
							if (onTapgo) {
								if (onTapgo != '')
									$state.go(onTapgo);
							}
							if (buttontext1 == 'Unlock') {
								var reqParams = {
									"deviceId": device.uuid
								}
								internetBankingService.fetchDetailsByDeviceID(reqParams).then(function (data) {
									$scope.hideKeyboard();
									$scope.popover.hide();
									loggedInUserService.setInbUserId(data);
									$state.go('menu.inbUnlockAccessDetails');
								}, function (error) {
									//utilityService.showErrorMessage(error.responseMessage);
								});
							}
							if (iscallback) {
								callBack();
							}
						}
					}
				];
			}
			else {
				btn_array = [
					{
						text: buttontext1 || "OK",
						type: 'button-positive',
						onTap: function () {
							if (onTapgo) {
								$state.go(onTapgo);
							}
							if (iscallback) {
								callBack();
							}
						}
					}
				];
			}

			if (imageType && imageType.toLowerCase() == 'error') {
				imageType = 'img/FT/BhimUpi/errorSymbol.svg';
			} else if (imageType && imageType.toLowerCase() == 'success') {
				imageType = 'img/FT/BhimUpi/successSymbol.svg';
			} else {
				imageType = 'img/FT/BhimUpi/alertSymbol.svg';
			}

			if (message && message.errorMsg) {
				message = "Unable to connect to Internet. Please check your connectivity." + message.errorMsg;
			} else {
				message = quickPayService.isUndefined(message) ? "Something went wrong. Please try again after sometime." : message;
			}
			if (message == "Conflict") {
				message = "Unable to process now, Please try after sometime.";
			} else if (message == "Incorrect JWT Format") {
				message = "Unable to process now,Please try after sometime.";
			}
			var bhimErrorPopup = $ionicPopup.alert({
				template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src=' + imageType + ' /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'
				+ message + '</span></div></div></div>', //template,
				scope: $scope,
				cssClass: 'bhim-alert-popup',
				buttons: btn_array,
			});
			bhimErrorPopup.then(function (res) {
			});
		};

		quickPayService.addTofavorite = function (params) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FundsTransferAdapter/yqp/auth/manageQPBeneficiary", params, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		quickPayService.getContactDetails = function (params) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FundsTransferAdapter/yqp/auth/getDetailsByMobileNumber", params, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		quickPayService.payToContact = function (params) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FundsTransferAdapter/yqp/auth/payToContact", params, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		quickPayService.getVpaByMobileNumber = function (params) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FundsTransferAdapter/yqp/auth/getVpaByMobile", params, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		quickPayService.getCategoryList = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FundsTransferAdapter/yqp/auth/getCategoryList", {}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		quickPayService.validateTransaction = function (params) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/HomeAdapter/yqp/auth/validateTransaction", params, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		quickPayService.getReceiveMoney = function (params) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FundsTransferAdapter/yqp/auth/getReceiveMoney", params, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		quickPayService.accountListPopupTemplate = function (array, controllerName, type) {

			var template = '<div class="font-dark-grey irctc">' +
				'<div ng-repeat="number in ' + array + ' track by $index">' +
				'<div class="row  borderbtm" ng-click="' + controllerName + '.close($index,' + type + ')">' +
				'<div class="col padtop10 font-size-20 roboto-regular color545454 width30 padRight0">{{number.value}}</div>' +
				'</div></div></div>';
			return template;
		}

		quickPayService.exitYqp = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FundsTransferAdapter/yqp/auth/exitYqp", {}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		quickPayService.getPendingCollectRequestList = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FundsTransferAdapter/yqp/auth/getPendingCollectRequestList", {}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		quickPayService.saveCollectRequestDetails = function (params) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FundsTransferAdapter/yqp/auth/saveCollectRequestDetails", params, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		quickPayService.getFrequentCollectRequestList = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FundsTransferAdapter/yqp/auth/getFrequentCollectRequestList", {}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		quickPayService.getCustomerInfo = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/HomeAdapter/customerAndAccountInfo", {}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		quickPayService.updatePendingCollectRequest = function (params) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FundsTransferAdapter/yqp/auth/updatePendingCollectRequest", params, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		quickPayService.isUserWhitelisted = function () {
			var q = $q.defer();
			var params = {'journeyName' : 'YQP'};
			AdapterUtils.postData("adapters/FundsTransferAdapter/isUserWhiteListed", params, true).then(
				function (response) {
					q.resolve(response);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		return quickPayService;
	});  
