'use strict';
angularApp.controller('quickPaySetUpController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
      "loggedInUserService",
      "cryptoService",
      "mPinLoginService",
      "quickPayService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, loggedInUserService, cryptoService, mPinLoginService, quickPayService) {
			
			var quickPaySetUpVm = this;
			
			function initPage() {
            $translate(['BIOMETRIC_DISC','IGNORE','SET_UP']).then(function (translations) {
               quickPaySetUpVm.BIOMETRIC_DISC = translations['BIOMETRIC_DISC'];
               quickPaySetUpVm.ignore_txt = translations['IGNORE'];
               quickPaySetUpVm.setup_up_txt = translations['SET_UP'];
            });
				
			};

			quickPaySetUpVm.goToUserLogin = function(){
				$state.go('menu.userLogin');
			}
         quickPaySetUpVm.goToUserLanding = function(){
            //$state.go('menu.userLanding');
            var message = quickPaySetUpVm.BIOMETRIC_DISC;
            var cancel_btn = quickPaySetUpVm.ignore_txt;
            var ok_btn = quickPaySetUpVm.setup_up_txt;
            var onTapgo = '';
            var onTapCancel = 'menu.userLanding';
            quickPayService.showAlertPopup("", message, onTapgo, onTapCancel, ok_btn, cancel_btn, $scope);
         }
			quickPaySetUpVm.skip = function(){
            //$state.go('menu.userLogin');
            var message = quickPaySetUpVm.BIOMETRIC_DISC;
            var cancel_btn = quickPaySetUpVm.ignore_txt;
            var ok_btn = quickPaySetUpVm.setup_up_txt;
            var onTapgo = 'menu.quickPayLanding';
            var onTapCancel = 'menu.userLanding';
            quickPayService.showAlertPopup("", message, onTapgo, onTapCancel, ok_btn, cancel_btn, $scope);
         }
         quickPaySetUpVm.setBiometric = function(){
          $ionicHistory.clearCache().then(function(){
          $state.go('menu.quickPayBiometricSetUp',{goBackToState:2});
        });
            
          
         }

         
 

   function successCallback(result) {
         if (result.withFingerprint) {
         var token = result.withFingerprint;

         //call service to save token at adapter
         saveToken();
         } else if (result.withBackup) {
               //call service to save token at adapter
               saveToken();
         }
         else if(result == 'Success'){
               //call service to save token at adapter
               saveToken();
         }
   }

   function saveToken(){
      var random_str = utilityService.getRandomNumber(10);
      var fingerprint_token = cryptoService.encryptRSAWithPublicKey(random_str, cryptoService.rsaPublicKey);
      var obj = {'bioauthid':fingerprint_token};
      quickPayService.saveBiometricToken(obj).then(function(data) {
         localStorage.setItem("isBiometricSet", true);
         quickPaySetUpVm.isBiometricSet = true;
         cordova.plugins.SecureKeyStore.set(function (res) {
                       }, function (error) {
                       }, loggedInUserService.deviceInfo, random_str);             
      },function(error){
         utilityService.showErrorMessage(error.responseMessage);
      });

   }
   
   function errorCallback(error) {
               
   }

         quickPaySetUpVm.editPrimaryAccount = function(){
            quickPaySetUpVm.isPrimarySet = false;
         }
         quickPaySetUpVm.setPrimary = function(){
            var obj = {"accountNumber":quickPaySetUpVm.sel_primary_account};
            quickPayService.setPrimary(obj).then(function(data) {
                        quickPaySetUpVm.isPrimarySet = true;
                        var message = 'You have changed your primary account from ' + quickPaySetUpVm.primary_account + ' to ' + quickPaySetUpVm.sel_primary_account;
                        quickPaySetUpVm.customerInfo.customerInformation.accountNumber = quickPaySetUpVm.sel_primary_account;
                        quickPaySetUpVm.primary_account = quickPaySetUpVm.customerInfo.customerInformation.accountNumber;
                        var ok_btn = "OK";
                        var onTapgo = '';
                        var onTapCancel = '';
                        quickPayService.showAlertPopup("success", message, onTapgo, onTapCancel, ok_btn, "", $scope);
                     },function(error){
                        utilityService.showErrorMessage(error.responseMessage);
                     });
         }

         quickPaySetUpVm.setMpin = function(){
            mPinLoginService.isSetMPIN = true;
            $state.go('menu.inbLogin', { previousPage: "UserLoginPage" });
         }


			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				
            //quickPaySetUpVm.isBiometricSet = false;
            //quickPaySetUpVm.isMpinSet = false;
            quickPaySetUpVm.isBiometricSet = localStorage.getItem("isBiometricSet");
            if(quickPaySetUpVm.isBiometricSet == undefined || quickPaySetUpVm.isBiometricSet == "false"){
        quickPaySetUpVm.isBiometricSet = false;
      }
      else{
        quickPaySetUpVm.isBiometricSet = true;
      }
            quickPaySetUpVm.isMpinSet = loggedInUserService.mpinConsent;
            quickPaySetUpVm.customerInfo = quickPayService.customerInfo;
            
				quickPaySetUpVm.accountLists = quickPaySetUpVm.customerInfo.accounts;
            if(quickPaySetUpVm.customerInfo.customerInformation.accountNumber != ''){
               quickPaySetUpVm.primary_account = quickPaySetUpVm.customerInfo.customerInformation.accountNumber;
               quickPaySetUpVm.sel_primary_account = quickPaySetUpVm.customerInfo.customerInformation.accountNumber;
               quickPaySetUpVm.isPrimarySet = true;
            }
            else{
               quickPaySetUpVm.primary_account = "";
               quickPaySetUpVm.isPrimarySet = false;
            }
            
			});

			return this;
		}
]);


