'use strict';
angularApp.controller('quickPayUserAuthController', [
    "$state",
    "$scope",
    "$rootScope",
    "$ionicPopup",
    "$translate",
    "$ionicHistory",
    "utilityService",
    "loggedInUserService",
    "cryptoService",
    "mPinLoginService",
    "quickPayService",
    "$ionicModal",
    "constantConfig",
    "bhimUpiService",
    "AdapterUtils",
    "encryptionService",
    "$stateParams",
    "ConnectivityMonitorUtils",
    "$filter",
    "clickStreamService",
    "registerWithSimService",
    function ($state,
        $scope,
        $rootScope,
        $ionicPopup,
        $translate,
        $ionicHistory,
        utilityService,
        loggedInUserService,
        cryptoService,
        mPinLoginService,
        quickPayService,
        $ionicModal,
        constantConfig,
        bhimUpiService,
        AdapterUtils,
        encryptionService,
        $stateParams,
        ConnectivityMonitorUtils,
        $filter,
        clickStreamService,
        registerWithSimService) {

        var quickPayUserAuthVm = this;

        quickPayUserAuthVm.goBack = function () {
            $state.go('menu.quickPayLanding');
        }

        /*Custom Keypad for MPIN*/
        $scope.password = '';
        $scope.canErase = false;
        $scope.pinDotVisible = {};
        $scope.success = null;
        $scope.keyboardVisible = false;
        $scope.pinArray = [];

        $scope.keyboardSettings = {
            action: function (number) {
                if ($scope.password.length < 6) {
                    $scope.password += number;
                    $scope.pinArray.push(number);
                    $scope.pinDotVisible[$scope.password.length] = true;
                    $scope.canErase = true;
                    $scope.success = null;
                    var pass = $scope.password;
                    pass = pass.split("");
                    try {
                        quickPayUserAuthVm.first = pass[0];
                        quickPayUserAuthVm.second = pass[1];
                        quickPayUserAuthVm.third = pass[2];
                        quickPayUserAuthVm.fourth = pass[3];
                        quickPayUserAuthVm.fifth = pass[4];
                        quickPayUserAuthVm.sixth = pass[5];
                    } catch (err) { }

                }
                if ($scope.password && $scope.password.length === 6) {
                    var e = {};
                    var pass = $scope.password;
                    pass = pass.split("");
                    try {
                        quickPayUserAuthVm.first = pass[0];
                        quickPayUserAuthVm.second = pass[1];
                        quickPayUserAuthVm.third = pass[2];
                        quickPayUserAuthVm.fourth = pass[3];
                        quickPayUserAuthVm.fifth = pass[4];
                        quickPayUserAuthVm.sixth = pass[5];
                    } catch (err) { }
                    var e = {};
                    e.srcElement = {};
                    e.srcElement.value = 2;
                    quickPayUserAuthVm.changeInput(e, 6);
                }
            },

            // Clear
            leftButton: {
                html: '<i class="icon ion-backspace"></i>',
                action: function () {
                    $scope.doErase();
                },
                style: {
                    bgColor: '#fff',
                    activeBgColor: '#dfdfdf',
                    borderColor: '#dfdfdf',
                    fontSize: '20px'
                }
            },

            // Submit login
            rightButton: {
                html: '<i class="icon ion-eye"></i>	<i class="icon ion-eye-disabled login-eye-btn" ></i>',
                action: function () {
                    if ($scope.isPassVisible) {
                        var elementHide = document.getElementsByClassName("ion-eye-disabled")[0];
                        elementHide.classList.add("login-eye-btn");
                        var elementShow = document.getElementsByClassName("ion-eye")[0];
                        elementShow.classList.remove("login-eye-btn");

                        $scope.isPassVisible = false;
                    } else {
                        $scope.isPassVisible = true;
                        var elementHide = document.getElementsByClassName("ion-eye")[0];
                        elementHide.classList.add("login-eye-btn");
                        var elementShow = document.getElementsByClassName("ion-eye-disabled")[0];
                        elementShow.classList.remove("login-eye-btn");
                    }
                },
                style: {
                    bgColor: '#fff',
                    activeBgColor: '#dfdfdf',
                    borderColor: '#dfdfdf',
                    fontSize: '30px'
                }
            }
        }

        $scope.doErase = function () {
            $scope.pinDotVisible[$scope.password.length] = false;
            $scope.password = $scope.password.slice(0, -1);
            if ($scope.password.length == 0) $scope.canErase = false;
            try {
                var pass = $scope.password;
                pass = pass.split("");
                quickPayUserAuthVm.first = pass[0] ? pass[0] : "";
                quickPayUserAuthVm.second = pass[1] ? pass[1] : "";
                quickPayUserAuthVm.third = pass[2] ? pass[2] : "";
                quickPayUserAuthVm.fourth = pass[3] ? pass[3] : "";
                quickPayUserAuthVm.fifth = pass[4] ? pass[4] : "";
                quickPayUserAuthVm.sixth = pass[5] ? pass[5] : "";
            } catch (err) { }
        }

        $scope.rightAction = function () {
            pinDotVisible[0] = false;
            pinDotVisible[1] = false;
            pinDotVisible[2] = false;
            pinDotVisible[3] = false;
            pinDotVisible[4] = false;
            pinDotVisible[5] = false;
        }

        $scope.showKeyboard = function () {
            $scope.keyboardVisible = true;
        }

        $rootScope.hidekeypad = function ($event) {
            switch ($event.target.className) {
                case "mpin1 activated":
                // code block

                case "digit-keyboard-key":
                // code block

                case "digit-keyboard-key-action ng-binding":
                // code block

                case "icon ion-record":
                // code block

                case "digit-keyboard-key activated":
                // code block

                case "icon ion-backspace":
                // code block

                case "mpin1 ng-pristine ng-untouched ng-valid ng-empty activated":
                // code block

                case "mpin1 ng-binding":
                // code block

                case "icon ion-eye-disabled login-eye-btn":
                // code block

                case "icon ion-eye login-eye-btn":
                // code block

                case "digit-keyboard-key-number":
                    if (!$scope.keyboardVisible) {
                        $scope.showKeyboard();
                    }
                    break;
                default:
                    if ($scope.keyboardVisible) {
                        $scope.hideKeyboard();
                    }
                    break;
            }
        }

        $scope.hideKeyboard = function () {
            $scope.keyboardVisible = false;
        }

       
        /*End of Custom Keypad for MPIN*/

        quickPayUserAuthVm.changeInput = function ($event, index) {
            cordova.plugins.Keyboard.close();
            if (loggedInUserService.isServerConnected) {
                quickPayUserAuthVm.loginWithMpin();
            } else {
                //connectServer();
            }
        }
        quickPayUserAuthVm.clearMpin = function(){
                    quickPayUserAuthVm.first = '';
					quickPayUserAuthVm.second = '';
					quickPayUserAuthVm.third = '';
					quickPayUserAuthVm.fourth = '';
					quickPayUserAuthVm.fifth = '';
					quickPayUserAuthVm.sixth = '';
					$scope.doErase();
					$scope.doErase();
					$scope.doErase();
					$scope.doErase();
					$scope.doErase();
					$scope.doErase();
        }
        quickPayUserAuthVm.loginWithMpin = function () {
            if(utilityService.isAndroidPlatform() && registerWithSimService.isSimLogin && !registerWithSimService.userWithoutSimReg &&  (quickPayUserAuthVm.isSimChanged || quickPayUserAuthVm.simList == undefined || quickPayUserAuthVm.simList.length == 0)){
                if(quickPayUserAuthVm.isSimChanged)
                    registerWithSimService.reloadAppSimOk(registerWithSimService.changedSimMsg);
                else if(quickPayUserAuthVm.simList == undefined || quickPayUserAuthVm.simList.length == 0)
                    utilityService.showBhimUpiAlert("alert", registerWithSimService.noSimMsg);
                return;
            }
            var newMpin = quickPayUserAuthVm.first.trim() +
                quickPayUserAuthVm.second.trim() +
                quickPayUserAuthVm.third.trim() +
                quickPayUserAuthVm.fourth.trim() +
                quickPayUserAuthVm.fifth.trim() +
                quickPayUserAuthVm.sixth.trim();
            //var newMpin = quickPayUserAuthVm.setpassword;;
            if (newMpin.length == 6) {
                if (ConnectivityMonitorUtils.isOffline()) {
                    quickPayUserAuthVm.clearMpin();
                    //quickPayUserAuthVm.enabledThisInput(1);
                    /*login flow improvement*/
                    var inputElement = document.getElementById('InputTxt1');
                    inputElement.disabled = false;
                    utilityService.offlineAlert();
                    return;
                }


                var params = {};
                var hasedSimInfo = "";
				if(utilityService.isAndroidPlatform()){
					hasedSimInfo = quickPayUserAuthVm.hasedSimInfo;
				}
                if (quickPayUserAuthVm.action == 'pay_to_existing_beneficiary') {
                    params = {
                        "mPinNumber": newMpin,
                        "type": "mpin",
                        "amount": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.amount,
                        "benAccntNo": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.benAccntNo,
                        "isVpa": false
                    };
                }
                else if (quickPayUserAuthVm.action == 'pay_to_new_sbi') {
                    params = {
                        "mPinNumber": newMpin,
                        "type": "mpin",
                        'amount': quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.amount,
                        "benAccntNo": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.account_number,
                        "isVpa": false
                    };
                } else if (quickPayUserAuthVm.action == 'pay_to_new_other') {
                    //payToNewOtherBeneficiary();
                    params = {
                        "mPinNumber": newMpin,
                        "type": "mpin",
                        'amount': quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.amount,
                        "benAccntNo": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.account_number,
                        "isVpa": false
                    };
                }
                else if (quickPayUserAuthVm.action == 'pay_to_contact') {
                    if (quickPayService.payToContactData.payment_type == 'account')
                        params = { "mPinNumber": newMpin, "type": "mpin", 'amount': quickPayService.payToContactData.amount, "isVpa": false };
                    else
                        params = { "mPinNumber": newMpin, "type": "mpin", 'amount': quickPayService.payToContactData.amount, "isVpa": true };
                }
                else {
                    params = { "mPinNumber": newMpin, "type": "mpin", "isVpa": true };
                }
                params.simId = hasedSimInfo.toString();
                params.simSubId = quickPayUserAuthVm.simSubscriptionId;
                quickPayService.userAuthentication(params).then(function (data) {
                    $scope.hideKeyboard();
                    afterUserAuthSuccess(data);
                    quickPayUserAuthVm.clearMpin();
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_AUTHBYMPINSUCCESS"));
                }, function (error) {
                    quickPayUserAuthVm.clearMpin();
                    quickPayUserAuthVm.enabledThisInput(1);
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_AUTHBYMPINFAIL"));
                    if(error.responseCode == "SB001" || error.responseCode == "F001"){
                        registerWithSimService.reloadAppSimOk(error.responseMessage);
                    }
                    else {
                        utilityService.showErrorMessage(error.responseMessage);
                    }
                });

            } else {
                quickPayUserAuthVm.clearMpin();
                quickPayUserAuthVm.enabledThisInput(1);
                utilityService.showErrorMessage('Please Enter 6 digit valid MPIN');
            }


        }

        function afterUserAuthSuccess(data, $event) {
            quickPayService.customerInfo = data;
            if (quickPayUserAuthVm.action == 'pay_to_existing_beneficiary') {

                if (data.yqpOtpFlag) {
                    //payToExistingBeneficiary();
                    quickPayService.getOtp().then(function (data) {
                        $state.go('menu.quickPayOTP', { goBackToState: 'menu.quickPayLanding', action: 'pay_to_existing_beneficiary' });
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }
                else {
                    payToExistingBeneficiary();
                }
                //}

            }
            else if (quickPayUserAuthVm.action == 'pay_to_new_sbi') {
                //payToNewSbiBeneficiary();
                //check if to and from account number are same
                var accNo = $filter('cardmask')(quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.account_number, 'X', 4);
                if (quickPayService.customerInfo.customerInformation.accountNumber != "" && (quickPayService.customerInfo.customerInformation.accountNumber == accNo)) {
                    utilityService.showErrorMessage("Please select different TO and FROM account.");
                }
                else {
                    if (data.yqpOtpFlag) {
                        quickPayService.getOtp().then(function (data) {
                            $state.go('menu.quickPayOTP', { goBackToState: 'menu.quickPayLanding', action: 'pay_to_new_sbi' });
                        }, function (error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    }
                    else {
                        payToNewSbiBeneficiary();
                    }
                }

            } else if (quickPayUserAuthVm.action == 'pay_to_new_other') {
                //payToNewOtherBeneficiary();

                if (data.yqpOtpFlag) {
                    quickPayService.getOtp().then(function (data) {
                        $state.go('menu.quickPayOTP', { goBackToState: 'menu.quickPayLanding', action: 'pay_to_new_other' });
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }
                else {
                    payToNewOtherBeneficiary();
                }


            }
            else if (quickPayUserAuthVm.action == 'pay_to_contact') {
                //payToNewOtherBeneficiary();
                if (quickPayService.payToContactData.payment_type == 'account') {
                    if (data.yqpOtpFlag) {
                        quickPayService.getOtp().then(function (data) {
                            $state.go('menu.quickPayOTP', { goBackToState: 'menu.quickPayLanding', action: 'pay_to_contact' });
                        }, function (error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    }
                    else {
                        payToContact();
                    }
                }
                else {
                    //quickPayUserAuthVm.payToVpaByContact();
                }

            }
            else if (quickPayUserAuthVm.action == 'pay_to_qr' || quickPayUserAuthVm.action == 'pay_to_vpa') {
                //quickPayUserAuthVm.upiPayment(quickPayUserAuthVm.action);
            }
            else {
                //quickPayUserAuthVm.upiPayment();
            }
        }


        function payToExistingBeneficiary() {
            var params = {

                "amount": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.amount,
                "inbUserId": "",
                "accountTypeCode": "",
                "benMMID": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.benMMID,
                "benNickName": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.benNickName,
                "benIfscCode": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.benIFSCCode,
                "isStaffFlag": "",
                "intCategory": "",
                "benType": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.benType,
                "benName": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.benName,
                "intraBankFlag": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.intraBankFlag,
                "isOwnAccntFlag": "",
                "remAccntNo": "",
                "benAccntNo": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.benAccntNo,
                "benStatus": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.benStatus,
                "debitNriflag": "",
                "remark": (quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.remark == undefined || quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.remark == null) ? "" : quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.remark,
                "yqpValidateReq": (cryptoService.getSHA512EncryptedData(quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.benName + quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.benNickName + quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.benAccntNo + quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.amount)).toString()
            };
            quickPayService.postTxn(params).then(function (response) {
                quickPayService.paymentResponse = response;
                $state.go('menu.quickPaymentSuccess', { action: 'pay_to_existing_beneficiary', isSuccess: true });
            }, function (error) {
                quickPayService.paymentResponse = error;
                $state.go('menu.quickPaymentSuccess', { action: 'pay_to_existing_beneficiary', isSuccess: false });
                //utilityService.showErrorMessage(error.responseMessage);
            });
        }
        function payToContact() {
            var params = { "amount": quickPayService.payToContactData.amount , "payRequestId": quickPayService.payRequestId };
            quickPayService.payToContact(params).then(function (data) {
                quickPayService.paymentResponse = data;
                quickPayService.pendingLists = [];
                quickPayService.payRequestId="";
                $state.go('menu.quickPaymentSuccess', { action: 'pay_to_contact', isSuccess: true });
            }, function (error) {
                quickPayService.paymentResponse = error;
                $state.go('menu.quickPaymentSuccess', { action: 'pay_to_contact', isSuccess: false });
                //utilityService.showErrorMessage(error.responseMessage);
            });
        }
        function payToNewSbiBeneficiary() {
            var params = {

                "amount": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.amount,
                "inbUserId": "",
                "accountTypeCode": "",
                "benMMID": "",
                "benNickName": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.recipient_name,
                "benIfscCode": "",
                "isStaffFlag": "",
                "intCategory": "",
                "benType": "account",
                "benName": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.recipient_name,
                "intraBankFlag": "Y",
                "isOwnAccntFlag": "",
                "remAccntNo": "",
                "benAccntNo": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.account_number,
                "benStatus": "New",
                "debitNriflag": "",
                "remark": (quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.remark == undefined || quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.remark == null) ? "" : quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.remark,
                "yqpValidateReq": (cryptoService.getSHA512EncryptedData(quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.recipient_name + quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.recipient_name + quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.account_number + quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.amount)).toString()
            };
            quickPayService.postTxn(params).then(function (response) {
                quickPayService.paymentResponse = response;
                $state.go('menu.quickPaymentSuccess', { action: 'pay_to_new_sbi', isSuccess: true });
            }, function (error) {
                quickPayService.paymentResponse = error;
                $state.go('menu.quickPaymentSuccess', { action: 'pay_to_new_sbi', isSuccess: false });
                //utilityService.showErrorMessage(error.responseMessage);
            });
        }
        function payToNewOtherBeneficiary() {
            var params = {

                "amount": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.amount,
                "inbUserId": "",
                "accountTypeCode": "",
                "benMMID": "",
                "benNickName": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.recipient_name,
                "benIfscCode": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.ifsc,
                "isStaffFlag": "",
                "intCategory": "",
                "benType": "account",
                "benName": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.recipient_name,
                "intraBankFlag": "N",
                "isOwnAccntFlag": "",
                "remAccntNo": "",
                "benAccntNo": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.account_number,
                "benStatus": "New",
                "debitNriflag": "",
                "remark": (quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.remark == undefined || quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.remark == null) ? "" : quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.remark,
                "yqpValidateReq": (cryptoService.getSHA512EncryptedData(quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.recipient_name + quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.recipient_name + quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.account_number + quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.amount)).toString()
            };
            quickPayService.postTxn(params).then(function (response) {
                quickPayService.paymentResponse = response;
                $state.go('menu.quickPaymentSuccess', { action: 'pay_to_new_other', isSuccess: true });
            }, function (error) {
                quickPayService.paymentResponse = error;
                $state.go('menu.quickPaymentSuccess', { action: 'pay_to_new_other', isSuccess: false });
                //utilityService.showErrorMessage(error.responseMessage);
            });
        }

        quickPayUserAuthVm.enabledThisInput = function (index) {
            try {
                quickPayUserAuthVm.mpinErrorMsgFlag = false;
                for (var i = 1; i <= 6; i++) {
                    var inputElement = document.getElementById('InputTxt' + i);
                    if (index == i) {
                        inputElement.disabled = false;
                        inputElement.style = "border-bottom:1px solid #0095da !important;"
                    } else {
                        inputElement.disabled = true;
                        inputElement.style = "border-bottom:1px solid #bcbebf !important;"
                    }
                }
            } catch (err) { }
        }
        $scope.$on('$ionicView.beforeEnter', function () {
            quickPayUserAuthVm.simSubscriptionId = "";
            quickPayUserAuthVm.isChallenged = false;
            quickPayUserAuthVm.isMpinSet = loggedInUserService.mpinConsent;
            quickPayUserAuthVm.action = $stateParams.action;
            quickPayUserAuthVm.goBackToState = $stateParams.goBackToState;
            quickPayUserAuthVm.bio_text = "";
            quickPayUserAuthVm.hasedSimInfo = "";
			quickPayUserAuthVm.simList = [];
            quickPayUserAuthVm.isSimChanged = false;
            $translate(['YQP_AUTH_MSG'], { FIELD_1: quickPayUserAuthVm.bio_text }).then(function (translations) {
                quickPayUserAuthVm.YQP_AUTH_MSG = translations['YQP_AUTH_MSG'];
            });
            quickPayUserAuthVm.isFingerprintAvl = false;
            if (utilityService.isAndroidPlatform()) {
                            utilityService.showSpinner();
                            readSimcardInfo();
                        }

        });

        function readSimcardInfo() {
            /*Sim card Info fetching - Start*/
            function simInfosuccessCallback(result) {
                utilityService.hideSpinner();
                var str = "";
                quickPayUserAuthVm.isSimChanged = false;
                if(result.cards && result.cards.length > 0)
                {
                    quickPayUserAuthVm.simList = result.cards;
                    var isAccountExists = -1;
                    quickPayUserAuthVm.simList.some(function (obj, i) {
                        return obj.subscriptionId == registerWithSimService.simSubscriptionId ? isAccountExists = i : false;
                    });
                    if (isAccountExists !== -1) {
                        str = device.uuid + registerWithSimService.simSubscriptionId;
                        quickPayUserAuthVm.simSubscriptionId = registerWithSimService.simSubscriptionId;
                        quickPayUserAuthVm.hasedSimInfo = cryptoService.getSHA512EncryptedData(str);
                    }
                    else{
                        //either sim card is removed or slot changed or subscription id changed due to sim changes
                        quickPayUserAuthVm.isSimChanged = true;
                        quickPayUserAuthVm.simSubscriptionId = "";

                    }
                }
                if (quickPayUserAuthVm.simList == undefined || quickPayUserAuthVm.simList.length == 0) {
                    utilityService.showBhimUpiAlert("alert", registerWithSimService.noSimMsg);
                }

                $scope.$apply();
            }

                function HasPerminionSuccessCallback(result) {
                    if (result) {
                        window.plugins.sim.getSimInfo(simInfosuccessCallback, errorCallbackSim);
                    } else {
                        requestReadPermission();
                    }
                }

                function errorCallbackSim(error) {
                    utilityService.hideSpinner();
                    utilityService.showBhimUpiAlert("Permission denied.");
                }

                function requestSuccessCallback(result) {
                    if (result) {
                        hasReadPermission();
                    }
                }
                // Android only: check permission
                function hasReadPermission() {
                    window.plugins.sim.hasReadPermission(HasPerminionSuccessCallback, errorCallbackSim);
                }
                // Android only: request permission
                function requestReadPermission() {
                    window.plugins.sim.requestReadPermission(requestSuccessCallback, errorCallbackSim);
                }
                hasReadPermission();
                /*Sim card Info fetching - End*/
            }

        return this;
    }
]);


