'use strict';
angularApp.controller('quickPaymentSuccessController', [
    "$state",
    "$scope",
    "$ionicPopup",
    "$translate",
    "$ionicHistory",
    "utilityService",
    "loggedInUserService",
    "cryptoService",
    "mPinLoginService",
    "quickPayService",
    "$ionicModal",
    "constantConfig",
    "bhimUpiService",
    "$stateParams",
    "clickStreamService",
    "getAccountDetailsService",
    "clearServiceDataService",
    "AdapterUtils",
    "appRateService",
    "csatService",
    function ($state,
        $scope,
        $ionicPopup,
        $translate,
        $ionicHistory,
        utilityService,
        loggedInUserService,
        cryptoService,
        mPinLoginService,
        quickPayService,
        $ionicModal,
        constantConfig,
        bhimUpiService,
        $stateParams,
        clickStreamService,
        getAccountDetailsService,
        clearServiceDataService,
        AdapterUtils,
        appRateService,
        csatService) {

        var quickPaymentSuccessVm = this;
        quickPaymentSuccessVm.getCSATDetails = function () {
            mPinLoginService.isLoggedIn = false;
            quickPaymentSuccessVm.sessionLogout();

        }

        quickPaymentSuccessVm.sessionLogout = function () {
            AdapterUtils.sessionLogout().then(
                function (response) {
                    loggedInUserService.logoutUser(true);
                },
                function (error) {
                    loggedInUserService.logoutUser(true);
                }
            );
        }
        quickPaymentSuccessVm.goToUserLogin = function () {
            if (quickPaymentSuccessVm.isSuccess) {
                //quickPaymentSuccessVm.redirectToUserLogin();
                clearServiceVars();
                csatService.getGoldenJourneyStatus().then(function (data) {
                    if (data.csatFeedbackType == constantConfig.CSAT.CSAT_CSR || data.csatFeedbackType == constantConfig.CSAT.CSAT_NPR) {
                        csatService.showCsatScreen = true;
                        csatService.csatScreenType = data.csatFeedbackType;
                        $state.go('menu.csatLanding');
                    }
                    else {
                        csatService.showCsatScreen = false;
                        utilityService.showSpinner();
                        sessionStorage.setItem('getNRICounterFromLocalStorage', "0");
                        clearServiceDataService.clearServiceData();
                        quickPaymentSuccessVm.getCSATDetails();
                    }
                }, function (error) {
                    quickPaymentSuccessVm.redirectToUserLogin();
                    if (quickPaymentSuccessVm.preAuthType == 'mpin') {
                        sessionStorage.setItem('getNRICounterFromLocalStorage', "0");
                        clearServiceDataService.clearServiceData();
                        quickPaymentSuccessVm.getCSATDetails();
                    }
                    else {
                        $state.go('menu.userLanding');
                    }
                });
            }
            else {
                quickPaymentSuccessVm.redirectToUserLogin();
                $state.go('menu.userLanding');
            }
        }
        quickPaymentSuccessVm.redirectToUserLogin = function () {
            clearServiceVars();
            quickPayService.exitYqp().then(function (data) {
                loggedInUserService.tokenLotus = "";
            }, function (error) {
                //utilityService.showErrorMessage(error.responseMessage);
            });
        }
        quickPaymentSuccessVm.goToYonoHome = function () {
            clearServiceVars();
            $state.go('menu.homeScreen');
        }
        quickPaymentSuccessVm.goToPreAuth = function () {
            clearServiceVars();
            $state.go('menu.quickPayPreAuth');
        }
        quickPaymentSuccessVm.goToQuickPayLanding = function () {
            clearServiceVars();
            $state.go('menu.quickPayLanding');
        }

        quickPaymentSuccessVm.setBiometric = function () {
            $ionicHistory.clearCache().then(function () {
                $state.go('menu.quickPayBiometricSetUp', { goBackToState: 3 });
            });
        }

        quickPaymentSuccessVm.addToFavourite = function () {
            //utilityService.comingSoon('Coming Soon');return;
            if (!quickPaymentSuccessVm.addFavFlag)
                quickPaymentSuccessVm.manageBeneficiary();
        }
        quickPaymentSuccessVm.manageBeneficiary = function () {
            var params = {};
            params = {
                "beneficiaryList": [
                    {
                        //"beneficiaryId": quickPaymentSuccessVm.benID
                    }
                ],
                "methodName": "updateBeneficiary"
            }

            quickPayService.addTofavorite(params).then(function (data) {
                quickPaymentSuccessVm.addFavFlag = true;
                quickPayService.favLists = [];
            }, function (error) {
                //utilityService.showErrorMessage(error.responseMessage);
            });
        }
        //function to clear service variables
        function clearServiceVars() {
            quickPayService.clearVariables();
        }
        $scope.$on('$ionicView.beforeEnter', function () {
            quickPaymentSuccessVm.preAuthType = quickPayService.preAuthType;
            quickPaymentSuccessVm.benID = "";
            quickPaymentSuccessVm.addFavFlag = false;
            quickPaymentSuccessVm.showAddToFavBtn = true;
            quickPaymentSuccessVm.showReceiveContent = false;
            quickPaymentSuccessVm.isBiometricSet = localStorage.getItem("isBiometricSet");
            if (quickPaymentSuccessVm.isBiometricSet == undefined || quickPaymentSuccessVm.isBiometricSet == "false") {
                quickPaymentSuccessVm.isBiometricSet = false;
            }
            else {
                quickPaymentSuccessVm.isBiometricSet = true;
            }
            quickPaymentSuccessVm.action = $stateParams.action;
            quickPaymentSuccessVm.isSuccess = $stateParams.isSuccess;

            if (quickPaymentSuccessVm.isSuccess && quickPaymentSuccessVm.preAuthType == 'mpin') {
                getAccountDetailsService.accountOverviewData = "";
            }
            if (quickPaymentSuccessVm.isSuccess) {
                if (quickPaymentSuccessVm.action == 'pay_to_existing_beneficiary') {
                    quickPaymentSuccessVm.paymentResponse = quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails;
                    quickPaymentSuccessVm.amount = quickPaymentSuccessVm.paymentResponse.amount;
                    quickPaymentSuccessVm.name = quickPaymentSuccessVm.paymentResponse.benName;

                    $translate(['YQP_SUCCESS_MSG'], { amount: quickPaymentSuccessVm.amount, type: 'Beneficiary ', name: quickPaymentSuccessVm.name }).then(function (translations) {
                        quickPaymentSuccessVm.paymentResponse = translations['YQP_SUCCESS_MSG'];
                    });

                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPSUCCESS_PAYTOEXTBEN"));
                }
                else if (quickPaymentSuccessVm.action == 'pay_to_new_sbi') {
                    quickPaymentSuccessVm.paymentResponse = quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails;
                    quickPaymentSuccessVm.amount = quickPaymentSuccessVm.paymentResponse.amount;
                    quickPaymentSuccessVm.name = quickPaymentSuccessVm.paymentResponse.recipient_name;

                    $translate(['YQP_SUCCESS_MSG'], { amount: quickPaymentSuccessVm.amount, type: 'Beneficiary ', name: quickPaymentSuccessVm.name }).then(function (translations) {
                        quickPaymentSuccessVm.paymentResponse = translations['YQP_SUCCESS_MSG'];

                    });
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPSUCCESS_PAYTONEWSBIBEN"));
                }
                else if (quickPaymentSuccessVm.action == 'pay_to_new_other') {
                    quickPaymentSuccessVm.paymentResponse = quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails;
                    quickPaymentSuccessVm.amount = quickPaymentSuccessVm.paymentResponse.amount;
                    quickPaymentSuccessVm.name = quickPaymentSuccessVm.paymentResponse.recipient_name;

                    $translate(['YQP_SUCCESS_MSG'], { amount: quickPaymentSuccessVm.amount, type: 'Beneficiary ', name: quickPaymentSuccessVm.name }).then(function (translations) {
                        quickPaymentSuccessVm.paymentResponse = translations['YQP_SUCCESS_MSG'];
                    });
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPSUCCESS_PAYTONEWOTHERBEN"));
                }
                else if (quickPaymentSuccessVm.action == 'pay_to_contact') {
                    quickPaymentSuccessVm.paymentResponse = quickPayService.payToContactData;

                    if (quickPaymentSuccessVm.paymentResponse.payment_type == 'account') {
                        //pay by contact account flow
                        quickPaymentSuccessVm.amount = quickPaymentSuccessVm.paymentResponse.amount;
                        quickPaymentSuccessVm.name = quickPaymentSuccessVm.paymentResponse.name;

                        $translate(['YQP_SUCCESS_MSG'], { amount: quickPaymentSuccessVm.amount, type: 'Contact ', name: quickPaymentSuccessVm.name }).then(function (translations) {
                            quickPaymentSuccessVm.paymentResponse = translations['YQP_SUCCESS_MSG'];

                        });
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPSUCCESS_PAYTOCONTACTACC"));
                    }
                    else {
                        //pay by contact vpa flow
                        quickPaymentSuccessVm.paymentResponse = quickPayService.paymentResponse;
                        quickPaymentSuccessVm.amount = quickPaymentSuccessVm.paymentResponse.amount;
                        quickPaymentSuccessVm.name = quickPaymentSuccessVm.paymentResponse.payeeVPA;

                        $translate(['YQP_SUCCESS_MSG'], { amount: quickPaymentSuccessVm.amount, type: 'VPA ID ', name: quickPaymentSuccessVm.name }).then(function (translations) {
                            quickPaymentSuccessVm.paymentResponse = translations['YQP_SUCCESS_MSG'];

                        });
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPSUCCESS_PAYTOCONTACTVPA"));
                        var params = {
                            "beneficiaryList": [
                                {
                                    "beneficiaryName": quickPayService.paymentResponse.payeeName,
                                    "beneficiaryTransferAmount": quickPayService.paymentResponse.amount,
                                    "beneficiaryType": "Contact",
                                    "favoriteFlag": "",
                                    "lastTransactionType": quickPayService.payToContactData.mobile_number

                                }
                            ]
                        }

                        quickPayService.addTofavorite(params).then(function (data) {
                            quickPaymentSuccessVm.benID = "";
                            
                        }, function (error) {
                            //utilityService.showErrorMessage(error.responseMessage);
                        });
                    }
                }
                else if (quickPaymentSuccessVm.action == 'collect_via_vpa') {
                    quickPaymentSuccessVm.showAddToFavBtn = false;
                    quickPaymentSuccessVm.showReceiveContent = true;
                    quickPaymentSuccessVm.name = quickPayService.splitPaymentIds[0];
                    $translate(['YQP_COLLECT_SUCCESS_MSG'], { name: quickPaymentSuccessVm.name }).then(function (translations) {
                        quickPaymentSuccessVm.paymentResponse = translations['YQP_COLLECT_SUCCESS_MSG'];

                    });
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPSUCCESS_COLLECTVPA"));
                }
                else if (quickPaymentSuccessVm.action == 'collect_via_contact') {
                    quickPaymentSuccessVm.showAddToFavBtn = false;
                    quickPaymentSuccessVm.showReceiveContent = true;
                    quickPaymentSuccessVm.paymentResponse = quickPayService.payToCollectContactData;
                    if (quickPaymentSuccessVm.paymentResponse.payment_type == 'account') {
                        //pay by contact account flow
                        quickPaymentSuccessVm.name = quickPaymentSuccessVm.paymentResponse.payerDisplayName;
                        $translate(['YQP_COLLECT_SUCCESS_MSG'], { name: quickPaymentSuccessVm.name }).then(function (translations) {
                            quickPaymentSuccessVm.paymentResponse = translations['YQP_COLLECT_SUCCESS_MSG'];
                        });
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPSUCCESS_COLLECTCONTACTACC"));
                    }
                    else {
                        //pay by contact vpa flow
                        quickPaymentSuccessVm.name = quickPaymentSuccessVm.paymentResponse.payerDisplayName;
                        $translate(['YQP_COLLECT_SUCCESS_MSG'], { name: quickPaymentSuccessVm.name }).then(function (translations) {
                            quickPaymentSuccessVm.paymentResponse = translations['YQP_COLLECT_SUCCESS_MSG'];
                        });
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPSUCCESS_COLLECTCONTACTVPA"));
                    }
                }
                else {
                    quickPaymentSuccessVm.paymentResponse = quickPayService.paymentResponse;
                    quickPaymentSuccessVm.amount = quickPaymentSuccessVm.paymentResponse.amount;
                    quickPaymentSuccessVm.name = quickPaymentSuccessVm.paymentResponse.payeeVPA;
                    $translate(['YQP_SUCCESS_MSG'], { amount: quickPaymentSuccessVm.amount, type: 'VPA ID ', name: quickPaymentSuccessVm.name }).then(function (translations) {
                        quickPaymentSuccessVm.paymentResponse = translations['YQP_SUCCESS_MSG'];

                    });
                    var type = '';
                    if (quickPaymentSuccessVm.action == 'pay_to_vpa') {
                        type = 'VPA';
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPSUCCESS_PAYTOVPA"));
                    }
                    else {
                        type = 'QR';
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPSUCCESS_PAYTOQR"));
                    }
                    var params1 = {
                        "beneficiaryList": [
                            {
                                "beneficiaryName": quickPayService.paymentResponse.payeeName,
                                "beneficiaryTransferAmount": quickPayService.paymentResponse.amount,
                                "beneficiaryType": type,
                                "favoriteFlag": "",
                                "lastTransactionType": quickPayService.paymentResponse.payeeVPA
                            }
                        ]
                    }

                    quickPayService.addTofavorite(params1).then(function (data) {
                        quickPaymentSuccessVm.benID = "";
                       
                    }, function (error) {
                        //utilityService.showErrorMessage(error.responseMessage);
                    });
                }
            }
            else {
                //in case of failure
                quickPaymentSuccessVm.showAddToFavBtn = false;
                if (quickPaymentSuccessVm.action == 'pay_to_existing_beneficiary') {
                    quickPaymentSuccessVm.paymentResponse = quickPayService.paymentResponse.responseMessage;
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPFAIL_PAYTOEXTBEN"));
                }
                else if (quickPaymentSuccessVm.action == 'pay_to_new_sbi') {
                    quickPaymentSuccessVm.paymentResponse = quickPayService.paymentResponse.responseMessage;
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPFAIL_PAYTONEWSBIBEN"));
                }
                else if (quickPaymentSuccessVm.action == 'pay_to_new_other') {
                    quickPaymentSuccessVm.paymentResponse = quickPayService.paymentResponse.responseMessage;
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPFAIL_PAYTONEWOTHERBEN"));
                }
                else if (quickPaymentSuccessVm.action == 'pay_to_contact') {
                    quickPaymentSuccessVm.paymentResponse = quickPayService.payToContactData;

                    if (quickPaymentSuccessVm.paymentResponse.payment_type == 'account') {
                        quickPaymentSuccessVm.paymentResponse = quickPayService.paymentResponse.responseMessage;
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPFAIL_PAYTOCONTACTACC"));
                    }
                    else {
                        if (quickPayService.paymentResponse.responseMsg) {
                            quickPaymentSuccessVm.paymentResponse = quickPayService.paymentResponse.responseMsg;
                        }
                        else {
                            quickPaymentSuccessVm.paymentResponse = quickPayService.paymentResponse.statusDesc;
                        }
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPFAIL_PAYTOCONTACTVPA"));
                    }
                }
                else if (quickPaymentSuccessVm.action == 'collect_via_vpa') {
                    if (quickPayService.paymentResponse.responseMsg)
                        quickPaymentSuccessVm.paymentResponse = quickPayService.paymentResponse.responseMsg;
                    else
                        quickPaymentSuccessVm.paymentResponse = quickPayService.paymentResponse.statusDesc;
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPFAIL_COLLECTVPA"));
                }
                else if (quickPaymentSuccessVm.action == 'collect_via_contact') {
                    quickPaymentSuccessVm.paymentResponse = quickPayService.payToCollectContactData;
                    if (quickPaymentSuccessVm.paymentResponse.payment_type == 'account') {
                        //pay by contact account flow
                        quickPaymentSuccessVm.paymentResponse = quickPayService.paymentResponse.responseMessage;
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPFAIL_COLLECTCONTACTACC"));
                    }
                    else {
                        //pay by contact vpa flow
                        if (quickPayService.paymentResponse.responseMsg)
                            quickPaymentSuccessVm.paymentResponse = quickPayService.paymentResponse.responseMsg;
                        else
                            quickPaymentSuccessVm.paymentResponse = quickPayService.paymentResponse.statusDesc;
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPFAIL_COLLECTCONTACTVPA"));
                    }
                }
                else {
                    if (quickPayService.paymentResponse.responseMsg) {
                        quickPaymentSuccessVm.paymentResponse = quickPayService.paymentResponse.responseMsg;
                    }
                    else {
                        quickPaymentSuccessVm.paymentResponse = quickPayService.paymentResponse.statusDesc;
                    }
                    if (quickPaymentSuccessVm.action == 'pay_to_vpa') {
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPFAIL_PAYTOVPA"));
                    }
                    else {
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPFAIL_PAYTOQR"));
                    }
                }
            }
        });

        $scope.$on('$ionicView.beforeLeave', function () {

            clearServiceVars();


        });
        return this;
    }
]);
