'use strict';
angularApp.controller('setBiometricOTPController', [
	"$state",
	"$scope",
	"utilityService",
	"customerInfoService",
	"$filter",
	"getAccountDetailsService",
	"quickPayService",
	"cryptoService",
	"$stateParams",
	"$ionicHistory",
	"loggedInUserService",
	"clickStreamService",
	function (
		$state,
		$scope,
		utilityService,
		customerInfoService,
		$filter,
		getAccountDetailsService,
		quickPayService,
		cryptoService,
		$stateParams,
		$ionicHistory,
		loggedInUserService,
		clickStreamService) {

		var setBiometricOTPVm = this;

		function initPage() {
			setBiometricOTPVm.otpCount = 0;
			setBiometricOTPVm.clickCount = 0;
			setBiometricOTPVm.isResendDisabled = false;
			setBiometricOTPVm.goBackState = $stateParams.goBackToState;
			if (customerInfoService.customer.mobile)
				setBiometricOTPVm.mobileNumber = $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4);
			else
				setBiometricOTPVm.mobileNumber = $filter('cardmask')(quickPayService.customerInfo.customerInformation.mobile, 'X', 4);

		}
		setBiometricOTPVm.goBack = function () {
			$ionicHistory.goBack();
		}
		setBiometricOTPVm.goNext = function () {
			setBiometricOTPVm.resetPinOTP = "";
			if (!setBiometricOTPVm.otpNumber) {
				setBiometricOTPVm.resetPinOTP = "Please Enter the OTP";
			} else if (setBiometricOTPVm.otpNumber.length != 6) {
				setBiometricOTPVm.resetPinOTP = "Please enter 6 digits OTP";
			} else {
				var request = {
					"otp": setBiometricOTPVm.otpNumber
				}


				if (setBiometricOTPVm.goBackState == '1' || setBiometricOTPVm.goBackState == '2' || setBiometricOTPVm.goBackState == '3') {
					quickPayService.validateOtp(request).then(function (data) {
						if (setBiometricOTPVm.action === 'enable')
							enableBiometric();
						else
							disableBiometric();
					}, function (error) {
						setBiometricOTPVm.otpNumber = "";
						setBiometricOTPVm.otpCount++;
						if (setBiometricOTPVm.otpCount >= 3) {
							var title = '';
							var template = error.responseMessage;
							var onTap = '';
							var buttontext = "OK";
							//utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
							utilityService.showBhimUpiAlert('error', template, onTap, buttontext, $scope);
						} else {
							utilityService.showErrorMessage(error.responseMessage);
						}
					});
				}
				else {
					quickPayService.validateOtpSecure(request).then(function (data) {
						if (setBiometricOTPVm.action === 'enable')
							enableBiometric();
						else
							disableBiometric();
					}, function (error) {
						setBiometricOTPVm.otpNumber = "";
						setBiometricOTPVm.otpCount++;
						if (setBiometricOTPVm.otpCount >= 3) {
							var title = '';
							var template = error.responseMessage;
							var onTap = '';
							var buttontext = "OK";
							//utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
							utilityService.showBhimUpiAlert('error', template, onTap, buttontext, $scope);
						} else {
							utilityService.showErrorMessage(error.responseMessage);
						}
					});
				}






			}
		}

		function enableBiometric() {
			var random_str = utilityService.getRandomNumber(10);
			var fingerprint_token = cryptoService.encryptRSAWithPublicKey(random_str, cryptoService.rsaPublicKey);
			var obj = { 'bioauthid': fingerprint_token };
			quickPayService.saveBiometricToken(obj).then(function (data) {
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_ENABLEBIOSUCCESS"));
				localStorage.setItem("isBiometricSet", true);
				setBiometricOTPVm.isBiometricSet = true;
				cordova.plugins.SecureKeyStore.set(function (res) {
				}, function (error) {

				}, loggedInUserService.deviceInfo, random_str);

				var title = '';
				var template = '';
				if (quickPayService.isBiometricType == 'face')
					template = "Face ID has been enabled";
				else
					template = "Touch ID has been enabled";
				var onTap = setBiometricOTPVm.goBackToState;
				var buttontext = "OK";
				//utilityService.showAlertModal('', template, onTap, $scope, $state, buttontext);
				utilityService.showBhimUpiAlert('success', template, onTap, buttontext, $scope);
			}, function (error) {
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_ENABLEBIOFAIL"));
				utilityService.showErrorMessage(error.responseMessage);
			});
		}
		function disableBiometric() {
			var obj = {};
			quickPayService.disableBiometricToken(obj).then(function (data) {
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_DISABLEBIOSUCCESS"));
				localStorage.setItem("isBiometricSet", false);
				setBiometricOTPVm.isBiometricSet = false;
				cordova.plugins.SecureKeyStore.remove(function (res) {
				}, function (error) {

				}, loggedInUserService.deviceInfo);

				var title = '';
				var template = '';
				if (quickPayService.isBiometricType == 'face')
					template = "Face ID has been disabled";
				else
					template = "Touch ID has been disabled";
				var onTap = setBiometricOTPVm.goBackToState;
				var buttontext = "OK";
				//utilityService.showAlertModal('', template, onTap, $scope, $state, buttontext);
				utilityService.showBhimUpiAlert('success', template, onTap, buttontext, $scope);
			}, function (error) {
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_DISABLEBIOFAIL"));
				utilityService.showErrorMessage(error.responseMessage);
			});
		}
		setBiometricOTPVm.resendOTP = function () {

			if (setBiometricOTPVm.goBackState == '1' || setBiometricOTPVm.goBackState == '2' || setBiometricOTPVm.goBackState == '3') {
				quickPayService.getOtp().then(function (data) {
					setBiometricOTPVm.otpNumber = "";
					setBiometricOTPVm.resetPinOTP = "";
					setBiometricOTPVm.clickCount++;
					if (setBiometricOTPVm.clickCount >= 2) {
						setBiometricOTPVm.isResendDisabled = true;
					}
					var title = '';
					var template = "OTP has been sent to your registered mobile number.";
					var onTap = '';
					var buttontext = "OK";
					//utilityService.showAlertModal('', template, onTap, $scope, $state, buttontext);
					utilityService.showBhimUpiAlert('success', template, onTap, buttontext, $scope);
				}, function (error) {
					setBiometricOTPVm.otpNumber = "";
					utilityService.showErrorMessage(error.responseMessage);
				});
			}
			else {
				quickPayService.getOtpSecure().then(function (data) {
					setBiometricOTPVm.otpNumber = "";
					setBiometricOTPVm.resetPinOTP = "";
					setBiometricOTPVm.clickCount++;
					if (setBiometricOTPVm.clickCount >= 2) {
						setBiometricOTPVm.isResendDisabled = true;
					}
					var title = '';
					var template = "OTP has been sent to your registered mobile number.";
					var onTap = '';
					var buttontext = "OK";
					//utilityService.showAlertModal('', template, onTap, $scope, $state, buttontext);
					utilityService.showBhimUpiAlert('success', template, onTap, buttontext, $scope);
				}, function (error) {
					setBiometricOTPVm.otpNumber = "";
					utilityService.showErrorMessage(error.responseMessage);
				});
			}



		}



		$scope.$on('$ionicView.beforeEnter', function () {

			setBiometricOTPVm.goBackState = $stateParams.goBackToState;
			setBiometricOTPVm.action = $stateParams.action;
			setBiometricOTPVm.goBackToState = '';
			if (setBiometricOTPVm.goBackState == 1) {
				setBiometricOTPVm.goBackToState = 'menu.viewBalanceSetUp';
			}
			else if (setBiometricOTPVm.goBackState == 2) {
				setBiometricOTPVm.goBackToState = 'menu.quickPaySetUp';
			}
			else if (setBiometricOTPVm.goBackState == 3) {
				setBiometricOTPVm.goBackToState = 'menu.userLanding';
			}
			else {
				setBiometricOTPVm.goBackToState = 'menu.settings';
			}
			initPage();
		});

		return this;
	}


]);


