'use strict';
angularApp.controller('interestRatesController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"interestRatesRdService",
		"rdService",
		"customerInfoService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker,$ionicSideMenuDelegate,interestRatesRdService,rdService,customerInfoService) {
			
			var interestRatesVm = this;
			
			function initPage() {
				// interestRatesVm.showBack = false;
				// interestRatesVm.showNext = true;
				// interestRatesVm.disablenext = true;
				// interestRatesVm.isValidError = false;
				// interestRatesVm.validErrorMessage = "";
				// interestRatesVm.isValidAccount = false;
				// interestRatesVm.validAccountMessage = "";

				$translate(['SAVING_INFO', 'AMOUNT', 'DEPOSIT_FROM', 'TAX_SAVER', 'FIXED_DEPOSIT', 'AMOUNT_COMPARE', 'SENIOR_CITIZEN', 'SELECT_ACCOUNT', 'FDINFOMSG', 'FDINFOMSG_NEXT', 'FDINFOMSG_DOWN', 'AMOUNT_LIMIT', 'SENIOR_AMOUNT_LIMIT', 'TAX_AMOUNT', 'SENIOR_TAX_AMOUNT', 'INACTIVE_ACCOUNT', 'NO_TRANS_RIGHTS','ACC_TRANS_RIGHTS','FETCH_TRANS_RGTS']).then(function (translations) {
					interestRatesVm.fixedDeposit = translations['SAVING_INFO'];
					interestRatesVm.amount = translations['AMOUNT'];
					interestRatesVm.depositFrom = translations['DEPOSIT_FROM'];
					interestRatesVm.taxSaver = translations['TAX_SAVER'];
					interestRatesVm.fdTitle = translations['FIXED_DEPOSIT'];
					interestRatesVm.amtCmperror = translations['AMOUNT_COMPARE'];
					interestRatesVm.seniorCitizen = translations['SENIOR_CITIZEN'];
					interestRatesVm.selectedAccount = translations['SELECT_ACCOUNT'];
					interestRatesVm.amountinfofd = translations['FDINFOMSG'];
					interestRatesVm.amountinfotsfd = translations['FDINFOMSG_NEXT'];
					interestRatesVm.taxsaverinfo = translations['FDINFOMSG_DOWN'];
					interestRatesVm.normalAmountLimit = translations['AMOUNT_LIMIT'];
					interestRatesVm.senioramountLimit = translations['SENIOR_AMOUNT_LIMIT'];
					interestRatesVm.taxAmounLimit = translations['TAX_AMOUNT'];
					interestRatesVm.seniorTaxAmounLimit = translations['SENIOR_TAX_AMOUNT'];
					interestRatesVm.activeAccount = translations['INACTIVE_ACCOUNT'];
					interestRatesVm.transactionRights = translations['NO_TRANS_RIGHTS'];
					interestRatesVm.accTransRights = translations['ACC_TRANS_RIGHTS'];
					interestRatesVm.fetchTransRights = translations['FETCH_TRANS_RGTS'];
				});
			};

			interestRatesVm.goToCreateSave = function () {
				rdService.createRdData.interestSelectYear = "";
				$state.go("menu.createRdSave");
			}

			interestRatesVm.goReview = function () {
				$state.go("menu.createRdSave");
			}

			interestRatesVm.setSelected = function(duration) {
				rdService.createRdData.interestSelectYear = duration
				console.log(duration)
			}

			$scope.$on('$ionicView.loaded', function () {
				initPage();
				// if(getAccountDetailsService.accessRightsData.accounts == null || getAccountDetailsService.accessRightsData.accounts == "") {
				// 	getAccountDetailsService.getAccountsAccessRights('').then( function(data) {
                //     getAccountDetailsService.accessRightsData = data;
				// 	}, function(error) {
				// 		// Failure block
				// 	});
				// }
			});

			$scope.$on('$ionicView.beforeEnter', function() {
				if(rdService.customer.viewInterest === false){
					interestRatesVm.idSelectedVote =  false;
				}
				interestRatesVm.isStaffFlag = customerInfoService.customer.isStaffFlag;
				interestRatesVm.amount = rdService.customer.amountData;
				interestRatesVm.years = rdService.customer.years;
				interestRatesVm.months = rdService.customer.months;
				interestRatesVm.days = rdService.customer.days;
				interestRatesVm.isTaxable = rdService.customer.isTaxable;
				interestRatesVm.isScitizen = rdService.customer.isSenior;
				if(interestRatesVm.isStaffFlag === 'Y') {
					if(rdService.customer.isSenior === true){
					interestRatesVm.custype = "staff_senior_citizen";
					rdService.customer.custype = "staff_senior_citizen";
					} else {
						interestRatesVm.custype = "staff_customer";
						rdService.customer.custype = "staff_customer";
					}
				}
				if(interestRatesVm.isStaffFlag === 'N') {
					if(rdService.customer.isSenior === true){
					interestRatesVm.custype = "senior_citizen";
					rdService.customer.custype = "senior_citizen";
					} else {
						interestRatesVm.custype = "normal_customer";
						rdService.customer.custype = "normal_customer";
					}
				}

				if (rdService.createRdData.interestSelectYear != "") {
					// console.log(rdService.createRdData.interestSelectYear)
					interestRatesVm.yearValue = rdService.createRdData.interestSelectYear;
					// console.log(interestRatesVm.yearValue)
				}

				if (!rdService.interestRateDetails.length) {
					interestRatesRdService.fetchInterestRate().then(function(data) {
						// console.log("interest data",data)
						if(!utilityService.isUndefined(data)) {
							interestRatesVm.durationRate=[];
							rdService.interestRateDetails = data
							for (var i=0;i <data.length;i++){
								interestRatesVm.durationRate.push(data[i]);
							}
						}
					}, function(error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				} else {
					interestRatesVm.durationRate = [];
					interestRatesVm.durationRate = rdService.interestRateDetails;
				}
			});

			return this;
		}
]);