/**
 *   @ngdoc config
 *   @name angularApp.config : cardConfig
 *   @description
 *  configuration file for cards module
 */

/*This function defines all the constants named  Adapters url for cards module*/
angularApp
    /*State defination with respective names, urls, controllers and templates */
    .config([
        '$stateProvider',
        function ($stateProvider) {
            //Cards start
            $stateProvider
                .state('menu.createRd', {
                    url: '/createRd',
                    data: {
                        pageId: 'RD_HOM'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/recurringDeposite/createRd/createRd.html',
                            controller: 'createRdController',
                            controllerAs: 'createRdVm'
                        }
                    }
                })
                .state('menu.createRdSave', {
                    url: '/createRdSave',
                    data: {
                        pageId: 'RD_CRTRDSAVE'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/recurringDeposite/createRd/createRdSave.html',
                            controller: 'createRdController',
                            controllerAs: 'createRdVm'
                        }
                    }
                })
                .state('menu.interestRates', {
                    url: '/interestRates',
                    data: {
                        pageId: 'RD_INSTRATE'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/recurringDeposite/interestRates/interestRates.html',
                            controller: 'interestRatesController',
                            controllerAs: 'interestRatesVm'
                        }
                    }
                })
                .state('menu.rdDetailsClosure', {
                    url: '/rdDetailsClosure',
                    data: {
                        pageId: 'RD_DETLCLSR'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/recurringDeposite/rdDetails/rdDetailsClosure.html',
                            controller: 'rdDetailsController',
                            controllerAs: 'rdDetailsVm'
                        }
                    }
                })
                .state('menu.rdDetailsClosureConfirm', {
                    url: '/rdDetailsClosureConfirm',
                    data: {
                        pageId: 'RD_DETLCLSRCNFM'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/recurringDeposite/rdDetails/rdDetailsClosureConfirm.html',
                            controller: 'rdDetailsController',
                            controllerAs: 'rdDetailsVm'
                        }
                    }
                })
                .state('menu.reviewRd', {
                    url: '/reviewRd',
                    data: {
                        pageId: 'RD_RVW'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/recurringDeposite/reviewRd/reviewRd.html',
                            controller: 'reviewRdController',
                            controllerAs: 'reviewRdVm'
                        }
                    }
                })
                .state('menu.rdDetails', {
                    url: '/rdDetails',
                    data: {
                        pageId: 'RD_DETLS'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/recurringDeposite/rdDetails/rdDetails.html',
                            controller: 'rdDetailsController',
                            controllerAs: 'rdDetailsVm'
                        }
                    }
                })
                .state('menu.nomineeRd', {
                    url: '/nomineeRd',
                    data: {
                        pageId: 'RD_NOMNE'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/recurringDeposite/nominee/nomineeRd.html',
                            controller: 'nomineeRdController',
                            controllerAs: 'nomineeRdVm'
                        }
                    }
                })
                 
        }
    ]);
