'use strict';

angularApp.controller('reportController', [
	"$scope",
	"reportService",
	"utilityService",
	"$ionicPopup",
	"$translate",

	function ($scope,
		reportService,
		utilityService,
		$ionicPopup,
		$translate) {
		
	//functions, variables that can be accessed from the HTML come here
	var reportVm = this;
	reportVm.bugDetails = reportService.bugDetails;
	reportVm.isDescEmpty = false;
	reportVm.isTitleEmpty = false;
	reportVm.selectedSeverities = [
		{
			name: "1-Functionality blocked",
			key: "1-Showstopper"
		},
		{
			name: "2-Functionality partially impacted",
			key: "2-Critical"
		},
		{
			name: "3-User interface related",
			key: "3-Non-Critical"
		},
		{
			name: "4-Improvement",
			key: "4-Live with"
		}];
	$translate(['VERSION_NO']).then(function (translations) {
			reportVm.bugDetails.vesionNo=translations['VERSION_NO'];
			});

	reportVm.selectedJourney = 
		[{
			name: "Generic Bugs",
			key: "LOTUS"
		},
		{
			name: "Journey 01 - Fund Transfer",
			key: "J1FT"
		},
		{
			name: "Journey 02 - Fixed Deposit",
			key: "J2FD"
		},
		{
			name: "Journey 03 - Relationship Overview",
			key: "J3AO"
		},
		{
			name: "Journey 04 - Account Transaction Enquiry",
			key: "J4ATE"
		},
		{
			name: "Journey 05 - Spend Analysis",
			key: "J5SA"
		},
		{
			name: "Journey 06 - Goal Based Saving - My Dreams",
			key: "J6GBSMD"
		},
		{
			name: "Journey 07 - Help",
			key: "J7H"
		},
		{
			name: "Journey 08 - Settings",
			key: "J8S"
		},
		{
			name: "Journey 09 - Login",
			key: "J9L"
		},
		{
			name: "Journey 10 - Home Page",
			key: "J10HP"
		},
		{
			name: "Journey 11 - Tax Saver FD",
			key: "J11TSF"
		},
		{
			name: "Journey 12 - OD Against FD",
			key: "J12OAF"
		},
		{
			name: "Journey 13 - Bill Payment",
			key: "J13BP"
		},
		{
			name: "Journey 14 - Life Insurance",
			key: "J14LI"
		},
		{
			name: "Journey 15 - Mutual Funds",
			key: "J15MF"
		},
		{
			name: "Journey 16 - Cards",
			key: "J16C"
		},
		{
			name: "Journey 17 - General Insurance",
			key: "J17GI"
		},
		{
			name: "Journey 18 - Securities",
			key: "J18S"
		},
		{
			name: "Journey 19 & 20 - OMP Shopping & Deals",
			key: "J1920OSD"
		},
		{
			name: "Journey 21 - OMP Search",
			key: "J21OS"
		},
		{
			name: "Journey 22 - OMP Filters Sort",
			key: "J22OFS"
		},
		{
			name: "Journey 23 - Account Opening- Digital with AADHAR(Regular)",
			key: "J23AODWAR"
		},
		{
			name: "Journey 24 - Account Opening with Aaadhar-Assist in Regular - Portal",
			key: "J24AOWAIRP"
		},
		{
			name: "Journey 25 - Account Opening with OVD's-Assist in Regular - Portal",
			key: "J25AOWOIRP"
		},
		{
			name: "Journey 26 - Account Opening Regular -with Product Backlog",
			key: "J26AO"
		},
		{
			name: "Journey 27 - Customer Onboarding in first 60 days",
			key: "J27COIFD"
		},
		{
			name: "Journey 28 - Account Opening - Digital with AADHAR (In Touch)",
			key: "J28AODWAI"
		},
		{
			name: "Journey 29 - Pre-Approved Personal Loans",
			key: "J29PPL"
		},
		{
			name: "TEST PROJECT",
			key: "GLOS"
		}];
	reportVm.checkTitle=function(){
		if(utilityService.isEmpty(reportVm.bugDetails.title))
			reportVm.isTitleEmpty=true;
		else
			reportVm.isTitleEmpty=false;
	}
	reportVm.checknumber=function(){
		if(utilityService.isEmpty(reportVm.bugDetails.mobileNo))
			reportVm.isTitleEmpty=true;
		else
			reportVm.isTitleEmpty=false;
	}

	reportVm.checkDesc=function(){
		if(utilityService.isEmpty(reportVm.bugDetails.bugDesc))
			reportVm.isDescEmpty=true;
		else
			reportVm.isDescEmpty=false;
	}
	
	reportVm.resetBugDetails = function(){
		reportService.bugDetails.title = "";
		reportService.bugDetails.name = "";
		reportService.bugDetails.bugDesc = "";
		reportService.bugDetails.expectedBeh = "";
		reportService.bugDetails.bugSeverity = "";
	};
	reportVm.getSelectedJourney = function(value) {
		if (value !== null) {
			reportVm.bugDetails.journey = value.key;
		} else {
			reportVm.bugDetails.journey = "";
		}
	}
     /* Based on the severity change, populate the severity dropdown */
	reportVm.severityUpdate = function(value) {
		if (value !== null) {
			reportVm.bugDetails.bugSeverity = value.key;
		} else {
			reportVm.bugDetails.bugSeverity = "";
		}
     }

	reportVm.submit=function(){		
		if(!utilityService.isEmpty(reportVm.bugDetails.bugDesc) && !utilityService.isEmpty(reportVm.bugDetails.title)){
			reportVm.isDescEmpty = false;
			reportVm.isTitleEmpty = false;
			reportService.reportBug(reportVm.bugDetails).then(function(data) {
				if(utilityService.getValue(data) !== "")
				reportVm.submitPopup();
			}, function(error) {
				utilityService.showErrorMessage(error);
			});
		}else{
			if(utilityService.isEmpty(reportVm.bugDetails.bugDesc) && utilityService.isEmpty(reportVm.bugDetails.title))
			{
				reportVm.isDescEmpty = true;				
				reportVm.isTitleEmpty = true;
			}
			else if(utilityService.isEmpty(reportVm.bugDetails.title)){
				reportVm.isTitleEmpty = true;
			}
			else
			{				
				reportVm.isDescEmpty = true;
			}
		}
	};

	reportVm.submitPopup = function() {

		reportVm.submitPopupName = $ionicPopup.show({
			title : "",
			cssClass:'popupWidth90 popupMargin ftpopup-body popupBackgroundWhite textAlignCenter removePopup-head',
			templateUrl : 'pages/report/submitPopup.html',
			scope : $scope
		});
	};

	reportVm.submitClose=function(){
		reportVm.submitPopupName.close();
		//reportVm.resetBugDetails();
	};

	return this;
}]);