'use strict';

angularApp.service('reportService',
	function ($http, $q, utilityService, AdapterUtils) {

		var bugDetails = {
			journey: "",
			title: "",
			name: "",
			bugDesc: "",
			expectedBeh: "",
			bugSeverity: "",
			vesionNo: "",
			mobileNo: ""
		};

		var reportBug = function (bugDetails) {
			//Start: production changes for raise an incident
			utilityService.showSpinner();
			//End: production changes for raise an incident
			var q = $q.defer();
			var payload = {
				"projectKey": bugDetails.journey,
				"title": bugDetails.title,
				"incidentDescription": bugDetails.bugDesc,
				"expectedBehaviour": bugDetails.expectedBeh,
				"bugSeverity": bugDetails.bugSeverity,
				"raisedBy": "\nName: " + bugDetails.name + "\nMobile Number: " + bugDetails.mobileNo,
				"buildNumber": bugDetails.vesionNo
			}
			//Start: production changes for raise an incident
			$http({
				method: 'POST',
				url: "https://muat.intouch.onlinesbi.com/mfp/api/adapters/FeedbackAdapterProd/submitFeedback",
				data: payload
			}).then(function (response) {
				q.resolve(response.data);
				utilityService.hideSpinner();
			}, function (error) {
				q.reject(error);
				utilityService.hideSpinner();
			});
			//End: production changes for raise an incident
			
			//Start: uncomment below changes for raise an incident in production
			/*
			AdapterUtils.postData("adapters/FeedbackAdapter/submitFeedback", payload, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			*/
			//End: uncomment above changes for raise an incident in production
			return q.promise;
		};

		return {
			bugDetails: bugDetails,
			reportBug: reportBug
		};
	});