'use strict';

angularApp.controller('rrEditAddressController', ["$state",
    "$scope",
    "aoService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "$translate",
    "requestYCService",
    "getAccountDetailsService",
    "utilityService",
    "homeScreenService",
    "$ionicPopup",
    "$rootScope",
    "$filter",
    "ionicDatePicker",
    "$stateParams",
    "rrService",
    "validateService",

    function ($state,
        $scope,
        aoService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        $translate,
        requestYCService,
        getAccountDetailsService,
        utilityService,
        homeScreenService,
        $ionicPopup,
        $rootScope,
        $filter,
        ionicDatePicker,
        $stateParams,
        rrService,
        validateService
    ) {

        var rrEditAddressVm = this;
        rrEditAddressVm.isChallenged = false;
        rrEditAddressVm.disablenext = false;


        function initPage() {
            
            rrEditAddressVm.showBack = true;
            rrEditAddressVm.showConfirm = true;
            rrEditAddressVm.validateService = validateService;

            var title = '';
            var onTap = '';

            rrEditAddressVm.edit = $stateParams.termsObj;
            if(rrEditAddressVm.edit == 'All'){
            rrEditAddressVm.flatName = rrService.saveData.application.app.personal.address.building;
            rrEditAddressVm.streetName = rrService.saveData.application.app.personal.address.locality;
            rrEditAddressVm.landmarkName = rrService.saveData.application.app.personal.address.landMark;
            rrEditAddressVm.pinCode = rrService.saveData.application.app.personal.address.pincode;
            

            if(rrEditAddressVm.flatName == null || rrEditAddressVm.flatName == 'null' || !rrEditAddressVm.flatName){
                rrEditAddressVm.flatName = '';
            }
            if(rrEditAddressVm.streetName == null || rrEditAddressVm.streetName == 'null' || !rrEditAddressVm.streetName){
                rrEditAddressVm.streetName = '';
            }
            if(rrEditAddressVm.landmarkName == null || rrEditAddressVm.landmarkName == 'null' || !rrEditAddressVm.landmarkName){
                rrEditAddressVm.landmarkName = '';
            }
            
            rrEditAddressVm.pinCode = rrService.saveData.application.app.personal.address.pincode;
                if(rrEditAddressVm.pinCode){
                    rrEditAddressVm.savedPinCode = true;
                    rrEditAddressVm.getPinData(rrEditAddressVm.pinCode);
                }  
            }           

        }

        rrEditAddressVm.getPinData = function (pinCode) {
                if(pinCode.length == 6){
                    var inputparams = {
				    "pinCode" : pinCode
                    }                    
                    rrService.getPostalDetailByPincode(inputparams).then(function(data) {                         
                        rrEditAddressVm.areaDetailsList = data;                            
                        rrEditAddressVm.city =  rrEditAddressVm.areaDetailsList[0].cityCode;
                        rrEditAddressVm.state =  rrEditAddressVm.areaDetailsList[0].stateCode;
                        if(rrEditAddressVm.savedPinCode){
                            for (var i in rrEditAddressVm.areaDetailsList) {
                                    if (rrEditAddressVm.areaDetailsList[i].city == rrService.saveData.application.app.personal.address.city) {
                                         rrEditAddressVm.city = rrEditAddressVm.areaDetailsList[i].cityCode
                                    }
                                    if (rrEditAddressVm.areaDetailsList[i].state == rrService.saveData.application.app.personal.address.state) {
                                         rrEditAddressVm.state = rrEditAddressVm.areaDetailsList[i].stateCode
                                    }
                                }   
                        }
                        validateForm();
                    }, function(error) {                        
                        rrEditAddressVm.areaDetailsList='';
                        rrEditAddressVm.city = '';
                        rrEditAddressVm.state = '';

                        utilityService.showErrorMessage(error.responseMessage);
                    });
                    
                }
			}

        function validateForm() {
            rrEditAddressVm.rrEditAddForm = {};
            if(!rrEditAddressVm.flatName){
                rrEditAddressVm.rrEditAddForm.flatName = 'Please enter Flat/House No./Floor/Building'
            }
            if(!rrEditAddressVm.streetName){
                rrEditAddressVm.rrEditAddForm.streetName = 'Please enter Colony/Street/Locality'
            }
            if(!rrEditAddressVm.pinCode){
                rrEditAddressVm.rrEditAddForm.pinCode = 'Please enter Pin Code'
            }else if(rrEditAddressVm.validateService.isValidPincode(rrEditAddressVm.pinCode)){
                rrEditAddressVm.rrEditAddForm.pinCode = rrEditAddressVm.validateService.isValidPincode(rrEditAddressVm.pinCode);
            }
            if(!rrEditAddressVm.city){
                rrEditAddressVm.rrEditAddForm.city = 'Please enter City'
            }
            if(!rrEditAddressVm.state){
                rrEditAddressVm.rrEditAddForm.state = 'Please enter State'
            }                             
            rrEditAddressVm.retValue =  (angular.equals({}, rrEditAddressVm.rrEditAddForm)) ? true : false;    
            return rrEditAddressVm.retValue;
               
            }    



        //Function for close view
        rrEditAddressVm.closeView = function () {
            $state.go('menu.homeScreen');
        }

        

        //onclick of Back button
        rrEditAddressVm.goBacktoPrevious = function () {
             $state.go('menu.rrReviewDetails');
        };

        //onclick of next button
        rrEditAddressVm.goToNextPage = function () {

         if(validateForm()){
            rrService.saveData.application.app.personal.address.building =  rrEditAddressVm.flatName;
            rrService.saveData.application.app.personal.address.locality = rrEditAddressVm.streetName;
            rrService.saveData.application.app.personal.address.landMark = rrEditAddressVm.landmarkName;
            rrService.saveData.application.app.personal.address.pincode = rrEditAddressVm.pinCode;
            rrService.saveData.application.app.personal.address.city = rrEditAddressVm.city;
            rrService.saveData.application.app.personal.address.state = rrEditAddressVm.state;   


            rrService.saveApplication().then(function (data) {
                utilityService.hideSpinner();    
                $state.go('menu.rrReviewDetails');
            }, function (error) {
                utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
                $state.go('menu.rrReviewDetails');
            }); 

         }    


       
            
        }

      

     


        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
           
        });


        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
           
            initPage();      
             
        });

        $scope.$on('$ionicView.beforeLeave', function () {

        });

        return this;
    }
]);