/**
*   @ngdoc config
*   @name angularApp.config : rrConfig
*   @description
*	configuration file for RinnRaksha module
*/

'use strict';

/*State defination with respective names, urls, controllers and templates */
angularApp.config(['$stateProvider',
	function ($stateProvider) {
		//RinnRaksha start
		$stateProvider
			.state('menu.rinnRaksha', {
				url: '/rinnRaksha',
				data: {
					pageId: 'RR_PREMIUM_CALCULATOR'
				},
				params: { lifeGeneInsure:null },
				views: {
					'menuContent': {
						templateUrl: 'pages/rinnraksha/premiumCalculator/premiumCalculator.html',
						controller: 'premiumCalculatorController',
						controllerAs: 'premiumCalculatorVm',
					}
				}
			})

			.state('menu.rrPersonalDetails', {
				url: '/rinnRakshaPD',
				data: {
					pageId: 'RR_PERSONAL_DETAILS'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/rinnraksha/personalDetails/personalDetails.html',
						controller: 'personalDetailsController',
						controllerAs: 'personalDetailsVm',
					}
				},params: { termsObj: null }
			})

			.state('menu.rrNomioneeDetails', {
				url: '/rinnRakshaND',
				data: {
					pageId: 'RR_NOMINEE_DETAILS'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/rinnraksha/personalDetails/nomineeDetails.html',
						controller: 'nomineeDetailsController',
						controllerAs: 'nomineeDetailsVm',
					}
				},params: { termsObj: null }
			})
			.state('menu.rinQuestionsAns', {
				url: '/rinQuestionsAns',
				data: {
					pageId: 'RR_MEDICAL_DETAILS'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/rinnraksha/rinRakshaQuestions/rinQuestionsAns.html',
						controller: 'rinQuestionsAnsController',
						controllerAs: 'rinQuestionsAnsVm',
					}
				},params: { termsObj: null }
			})
			.state('menu.rrReviewDetails', {
				url: '/rinnRakshaRD',
				data: {
					pageId: 'RR_REVIEW_DETAILS'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/rinnraksha/personalDetails/rrReviewDetails.html',
						controller: 'rrReviewDetailsController',
						controllerAs: 'rrReviewDetailsVm',
					}
				},params: { termsObj: null }
			})

			.state('menu.rrPaymantDetails', {
				url: '/rinnRakshaPAYD',
				data: {
					pageId: 'RR_PAYMENT_DETAILS'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/rinnraksha/paymentDetails/paymentDetails.html',
						controller: 'rrpaymentDetailsController',
						controllerAs: 'rrpaymentDetailsVm',
					}
				}
			})
			.state('menu.rrOTP', {
				url: '/rinnRakshaOTP',
				data: {
					pageId: 'RR_OTP'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/rinnraksha/paymentDetails/rrOTP.html',
						controller: 'rrOTPController',
						controllerAs: 'rrOTPVm',
					}
				}
			})
			.state('menu.rrSuccess', {
				url: '/rinnRakshaSS',
				data: {
					pageId: 'RR_SUCCESS'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/rinnraksha/paymentDetails/rrSuccess.html',
						controller: 'rrSuccessController',
						controllerAs: 'rrSuccessVm',
					}
				}
			})
			.state('menu.rrKnowMore', {
				url: '/rinnRakshaKM',
				data: {
					pageId: 'RR_KNOW_MORE'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/rinnraksha/premiumCalculator/rrKnowMore.html',
						controller: 'rrKnowMoreController',
						controllerAs: 'rrKnowMoreVm',
					}
				}
			})
			.state('menu.rrPenApplication', {
				url: '/rinnRakshaPA',
				data: {
					pageId: 'RR_PENDING_APPLICATION'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/rinnraksha/rrApplicationDetails/rrApplicationPending.html',
						controller: 'rrApplicationPendingController',
						controllerAs: 'rrApplicationPendingVm',
					}
				},params: { termsObj: null }
			})
			.state('menu.rrEditAddress', {
				url: '/rinnRakshaEA',
				data: {
					pageId: 'RR_EDIT_PERSONAL_ADD'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/rinnraksha/rrApplicationDetails/rrEditAddress.html',
						controller: 'rrEditAddressController',
						controllerAs: 'rrEditAddressVm',
					}
				},params: { termsObj: null }
			})
			.state('menu.rrPolicySummary', {
                url: '/rrPolicySummary',
                data: {
                    pageId: 'RR_POLICY_SUMMARY'
                },
                params: { page: 'life' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/rinnraksha/rrApplicationDetails/rrPolicySummary.html',
                        controller: 'rrPolicySummaryController',
                        controllerAs: 'rrPolicySummaryVm',
                    }
                }
            })
		
	}]);
