/******* Introduction securities  Controller ******/
'use strict';

angularApp.controller('introSecuritiesController', 
						["$timeout",
						 "$state",
						 "$scope",
						 "$translate",
						 "$location",
						 "$ionicScrollDelegate","introSecurityService","utilityService","$sce","homeScreenService",
				 
function ($timeout,
		 $state,
		 $scope,
		 $translate,
		 $location,
		 $ionicScrollDelegate,introSecurityService,utilityService,$sce,homeScreenService) {
	
	
	var introSecuritiesVm = this;
	
	/*** Initialize the variables that has to show in  the HTML come here ***/
	function initPage(){
		introSecuritiesVm.isBackCheck=homeScreenService.isBackCheck;
		homeScreenService.isBackCheck	=false;
		introSecuritiesVm.videoList();
	}
	
	/** function to call video service **/
	introSecuritiesVm.videoList=function(){
		$scope.currentIndex=0;
		//call Service to fetch all video list
		
		introSecurityService.getSecuritiesVideos().then(function(data){
			
			introSecuritiesVm.videoList=data.videoList;
			for(var vList=0;vList< introSecuritiesVm.videoList.length;vList++){
				introSecuritiesVm.videoList[vList].videoUrl= $sce.trustAsResourceUrl(introSecuritiesVm.videoList[vList].videoUrl+'&other:embedded'); //ngSanitizer to make it trusted/safe url and resource
			}
			
			
		}, function(error){
			
			utilityService.showErrorMessage(error.responseMessage);
		});
		introSecuritiesVm.stopVideo();
		
	}
	/*** Function to go to Start investing page  ***/
	introSecuritiesVm.startInvesting=function (){
		introSecuritiesVm.stopVideo();
		$state.go('menu.startInvesting');
	}
	
	/*** Function to play video page  ***/
	introSecuritiesVm.openVideo=function (index){
		
		$scope.currentIndex=index;
		
		/** Auto play video**/
		$timeout(function(){
			introSecuritiesVm.videoPlay = document.getElementById("mfVideo"); 
			introSecuritiesVm.videoPlay.play();
			introSecuritiesVm.videoPlay.currentTime = 0;
		},500);
	}
	
	/**stopVideo from playing**/
	introSecuritiesVm.stopVideo=function (){
		introSecuritiesVm.videoPlay = document.getElementById("mfVideo"); 
		introSecuritiesVm.videoPlay.pause(); 
		introSecuritiesVm.videoPlay.currentTime = 0;
		
	}
	
	/*** one time initialization to be done when the controller is loaded***/
	$scope.$on('$ionicView.loaded', function() {
		
	});
	
	/*** actions to done everytime the view is shown***/	
	$scope.$on('$ionicView.beforeEnter', function() {
		initPage();
		
	});
	
	 /***any cleanup needs to be done here: executes everytime when page is left***/
	$scope.$on('$ionicView.afterLeave', function() {
	
	});
	return this;
}]);

