'use strict';

angularApp.controller('accountToBeMappedController', 
	["$state",
	"$scope",
	"$translate",
	"$ionicPopup",
	"dematService",
	"utilityService","openUrlInAppbroswerService",
    "validateService","openAccountService","getAccountDetailsService","homeScreenService",
    "$filter","$ionicPopover","arogyaSanjeevaniService",
		
	function ($state,
		$scope,
		$translate,
		$ionicPopup,dematService,utilityService,openUrlInAppbroswerService,
        validateService,openAccountService,getAccountDetailsService,
        homeScreenService,$filter,$ionicPopover,arogyaSanjeevaniService) {
	
		var accountToBeMappedVm = this;
		accountToBeMappedVm.isChecked =false;
		accountToBeMappedVm.isCheckedBRD =false;
        var addressLine1 = "";
        var addressLine2 = "";
        var addressLine3 = "";
        var city = "";
        var state = "";
        var pincode = "";

		accountToBeMappedVm.initPage = function(){
			accountToBeMappedVm.showContect = 0;
			accountToBeMappedVm.isOpened=true;
			accountToBeMappedVm.planFeatures = [
				{name:"Process"},
				{name:"Why SBI Smart"},
				{name:"Charges"}
			]
			accountToBeMappedVm.isMaskedMob = true;
            accountToBeMappedVm.isMaskedDOB = true;
            accountToBeMappedVm.isMaskedPAN = true;          
            accountToBeMappedVm.isMaskedEmail = true;
            accountToBeMappedVm.showSelect = true; 
            accountToBeMappedVm.inputImgMob = "img/Visibility_off.svg";
            accountToBeMappedVm.inputImgDOB = "img/Visibility_off.svg";
            accountToBeMappedVm.inputImgPAN = "img/Visibility_off.svg";    
            accountToBeMappedVm.emailInputImg = "img/Visibility_off.svg"; 
            if(dematService.accList.length !=0) {
			    accountToBeMappedVm.getcapSecAccounts();
            }      
		}
		
		accountToBeMappedVm.getcapSecAccounts = function(){
            accountToBeMappedVm.age  =  validateService.calcAge(getAccountDetailsService.accountOverviewData.customerInformation.dob);
            accountToBeMappedVm.accDetails = dematService.accList;
            accountToBeMappedVm.close(0);
        }

        accountToBeMappedVm.close = function(index){
            var reqParams={
                "accountNumber":accountToBeMappedVm.accDetails[index].accountNumber
            } 
             if(accountToBeMappedVm.popUp){
                accountToBeMappedVm.popUp.close();
            } 
            openAccountService.checkAccountModeOfOperation(reqParams).then(function(data){
                if(data.isPrimaryHolderFlag!='Y'){
                    openAccountService.displayPopUp("", "demat-padBtm15 demat-top-padding10", "Selected account is not a Single/ Primary account holder", "OK", function () {},
                    function(error){}); 
                }else{ 
                    if(data && parseInt(data.kycPoints) >= 110) {
                        accountToBeMappedVm.balance = accountToBeMappedVm.accDetails[index].accountBalance;
                        accountToBeMappedVm.accType = accountToBeMappedVm.accDetails[index].accountType;
                        accountToBeMappedVm.accountNumber = accountToBeMappedVm.accDetails[index].accountNumber;
                        openAccountService.selectedDetails.selIndex = accountToBeMappedVm.accDetails[index].index ;
                        openAccountService.selectedDetails.accountNumber = accountToBeMappedVm.accDetails[index].accountNumber;
                        openAccountService.selectedDetails.accountBalance = accountToBeMappedVm.accDetails[index].accountBalance;
                        accountToBeMappedVm.showSelect = false; 
                    } else {
                        arogyaSanjeevaniService.showError($translate.instant('OPEN_DEMAT_KYC_MSSG'));
                    }
                }              
            },function(error){
                utilityService.showErrorMessage(error.responseMessage);
            });              
        }

        accountToBeMappedVm.getDematAccopeningTermsAndCondition = function(){
            utilityService.showSpinner();
            if(accountToBeMappedVm.dematAccopeningTermsAndCondition==undefined){
            openAccountService.getDematAccopeningTermsAndConditions().then(function(data){
                utilityService.hideSpinner();
                accountToBeMappedVm.dematAccopeningTermsAndCondition=data.message;
                accountToBeMappedVm.showTnC(accountToBeMappedVm.dematAccopeningTermsAndCondition,"Terms & Conditions");
            },function(error){
                utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            })
            }else{
                accountToBeMappedVm.showTnC(accountToBeMappedVm.dematAccopeningTermsAndCondition,"Terms & Conditions");
                utilityService.hideSpinner();
            }
        };
        
        accountToBeMappedVm.showPop = function(){
            accountToBeMappedVm.popUp = $ionicPopup.show({
                title: '',
                cssClass: 'popupWidth95 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
                templateUrl: 'pages/securities/openNewDematAndTradingAccount/dropdownModal.html',
                scope: $scope
            });
        }

		accountToBeMappedVm.goToNextPage = function(){
			if(!accountToBeMappedVm.isChecked){
				accountToBeMappedVm.tncMsg=$translate.instant('OPEN_DEMAT_TNC_ERRMSG');
				accountToBeMappedVm.exceptionMessage(accountToBeMappedVm.tncMsg);				
			}else if(!accountToBeMappedVm.isCheckedBRD){
				accountToBeMappedVm.brdMsg=$translate.instant('OPEN_DEMAT_BRD');
				accountToBeMappedVm.exceptionMessage(accountToBeMappedVm.brdMsg);				
			}else if(!accountToBeMappedVm.accountNumber){                
				accountToBeMappedVm.exceptionMessage($translate.instant('OPEN_ACCOUNT_ERROR'));
            }else{
                openAccountService.getOTP({}).then(function(response) {
       	            var requestDate = new Date();
                    var accountDetails = {
                        "selectedAccountNumber":accountToBeMappedVm.accountNumber,
                        "acceptedTnC":accountToBeMappedVm.isChecked,
                        "acceptedTnCAtDateTime":requestDate,
                        "authorizesShareBankingRelDetails":accountToBeMappedVm.isCheckedBRD,
                        "sbiReferralCode":accountToBeMappedVm.sbireferral?accountToBeMappedVm.sbireferral:"",
                        "sslReferralCode":accountToBeMappedVm.sslreferral?accountToBeMappedVm.sslreferral:""
                    }
                    openAccountService.setAccountDetails(accountDetails);
                    $state.go('menu.dematOTPAuthenticate');

                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
		}
		
       //Show popup of Term&Condition
        accountToBeMappedVm.showTnC = function (tncData,title) {
             accountToBeMappedVm.showTncPopup = $ionicPopup.confirm({
                template: tncData,
                title: title,
                scope: $scope,
                cssClass: 'removePopup-head popupBackgroundWhite popupWidth90 showtncPopup ss-popup ODtncPopup termcss',
                    buttons: [
                        {
                            text: "OK",
                            onTap: function (e) { }
                        }
                    ],
            });
            accountToBeMappedVm.showTncPopup.then(function(res) {});
        }


        accountToBeMappedVm.exceptionMessage = function (message) {
            var infoPopup = $ionicPopup.show({
                template:  '<div class="popup-padding font-dark-grey"><div><center><img class="approvedIconPosition" src="img/FT/BhimUpi/errorSymbol.svg"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><span class="popUp-msg-color">'
                        + message + '</span></div></div></div>',
                title: 'Alert',
                cssClass: 'dialog',
                scope: $scope,
                buttons: [{
                    text: 'Ok',
                    onTap: function (e) {
                        infoPopup.close();
                    }
                }]
            });
        }
        
        //Show popup of open account
		accountToBeMappedVm.showBankingDetails = function(){
            var custInfoReq = {
                "selectedAccountNumber": accountToBeMappedVm.accountNumber
            }
            if(!accountToBeMappedVm.bankRelationDetails){
                openAccountService.viewCustomerInformation(custInfoReq).then(function(data){
                    accountToBeMappedVm.bankRelationDetails = data;
                    accountToBeMappedVm.showPopUp();
                },function(error){
                    utilityService.showErrorMessage(error.responseMessage);
                })
            }else{
                accountToBeMappedVm.showPopUp();
            }
        	
		}

        accountToBeMappedVm.showPopUp = function(){
            if(accountToBeMappedVm.bankRelationDetails && accountToBeMappedVm.bankRelationDetails.panNumber){
                accountToBeMappedVm.panMaskCheck(accountToBeMappedVm.bankRelationDetails.panNumber);
            }
            if(accountToBeMappedVm.bankRelationDetails && accountToBeMappedVm.bankRelationDetails.emailId){                                 
                accountToBeMappedVm.emailMaskCheck(accountToBeMappedVm.bankRelationDetails.emailId);
            }
            addressLine1 = accountToBeMappedVm.bankRelationDetails.addressLine1 ? accountToBeMappedVm.bankRelationDetails.addressLine1+', ' : '';
            addressLine2 = accountToBeMappedVm.bankRelationDetails.addressLine2 ? accountToBeMappedVm.bankRelationDetails.addressLine2+', ' : '';
            addressLine3 = accountToBeMappedVm.bankRelationDetails.addressLine3 ? accountToBeMappedVm.bankRelationDetails.addressLine3+', ' : '';
            city = accountToBeMappedVm.bankRelationDetails.city ? accountToBeMappedVm.bankRelationDetails.city+', ' : '';
            state = accountToBeMappedVm.bankRelationDetails.state ? accountToBeMappedVm.bankRelationDetails.state+', ' : '';
            pincode = accountToBeMappedVm.bankRelationDetails.pinCode?accountToBeMappedVm.bankRelationDetails.pinCode:'';
            accountToBeMappedVm.bankRelationDetails.address = addressLine1+addressLine2+addressLine3+city+state+pincode;

            accountToBeMappedVm.confirmPopup = $ionicPopup.confirm({
                templateUrl: 'pages/securities/openNewDematAndTradingAccount/bankRelationDetails.html',
                scope: $scope,
                cssClass: 'removePopup-head popupWidth95 dematpopupMargin popupBackgroundWhite ss-popup',
                    buttons: [
                        {
                            text: "OK",
                            onTap: function (e) { }
                        }
                    ],
            });
            accountToBeMappedVm.confirmPopup.then(function(res) {});
        }

		accountToBeMappedVm.showSSLCode = function(){
			accountToBeMappedVm.isOpened=true;
		}
		accountToBeMappedVm.showSSLCode = function(){
			accountToBeMappedVm.isOpened=true;
		}
		accountToBeMappedVm.showSBICode = function(){
			accountToBeMappedVm.isOpened=false;
		}
		//function to go back to account overview page
		accountToBeMappedVm.goToHome = function(){
			$state.go('menu.accountOverviewMyBalance');
		}
		//Go to previous page
		accountToBeMappedVm.goToPreviousPage = function(){
			$state.go('menu.dematAndTradingAccount');					
		}
		accountToBeMappedVm.maskUnmaskMob = function () {
             if(accountToBeMappedVm.isMaskedMob) {
                 accountToBeMappedVm.isMaskedMob = false;
                 accountToBeMappedVm.inputImgMob = "img/Visibility_on.svg";
             } else {
                 accountToBeMappedVm.isMaskedMob = true;
                 accountToBeMappedVm.inputImgMob = "img/Visibility_off.svg";
             }
        };
         accountToBeMappedVm.maskUnmaskDOB = function () {
             if(accountToBeMappedVm.isMaskedDOB) {
                accountToBeMappedVm.isMaskedDOB = false;
                accountToBeMappedVm.inputImgDOB = "img/Visibility_on.svg"; 
             } else {
                accountToBeMappedVm.isMaskedDOB = true;
                accountToBeMappedVm.inputImgDOB = "img/Visibility_off.svg";
             }
        };
		
		accountToBeMappedVm.panMaskCheck = function (pan) {
           accountToBeMappedVm.panMask = $filter('cardmask')(pan, 'X', 4);
        }

         accountToBeMappedVm.maskUnmaskPAN = function (panNo) {
             if(!utilityService.isUndefined(panNo)) {
                if (accountToBeMappedVm.isMaskedPAN) {
                    accountToBeMappedVm.panMaskCheck(accountToBeMappedVm.bankRelationDetails.panNumber);
                    accountToBeMappedVm.isMaskedPAN = false;
                    accountToBeMappedVm.inputImgPAN = "img/Visibility_off.svg";
                } else {
                    accountToBeMappedVm.panMask = accountToBeMappedVm.bankRelationDetails.panNumber; 
                    accountToBeMappedVm.isMaskedPAN = true;
                    accountToBeMappedVm.inputImgPAN = "img/Visibility_on.svg";
                }
             }
         };

        accountToBeMappedVm.emailMaskUnmask = function (param) {     
            if(!utilityService.isUndefined(param)) {
                if(accountToBeMappedVm.isMaskedEmail){
                    accountToBeMappedVm.emailMask = accountToBeMappedVm.bankRelationDetails.emailId;
                    accountToBeMappedVm.isMaskedEmail = false ;
                    accountToBeMappedVm.emailInputImg = "img/Visibility_on.svg";
                }else{
                    accountToBeMappedVm.emailMaskCheck(accountToBeMappedVm.bankRelationDetails.emailId);
                    accountToBeMappedVm.isMaskedEmail = true ;
                    accountToBeMappedVm.emailInputImg = "img/Visibility_off.svg";
                } 
            }       
        };
    

        accountToBeMappedVm.emailMaskCheck = function(email){
            if(!utilityService.isUndefined(email)) {
                var arr = email.split("@");
                var firstDotIndex = arr[1].indexOf('.');
                var emailFirstPart = arr[1].substring(0, firstDotIndex);
                var emailSecondPart = arr[1].substring(firstDotIndex + 1);
                accountToBeMappedVm.emailMask = accountToBeMappedVm.maskEmail2(arr[0]) + "@" + emailFirstPart+"."+emailSecondPart;
            }
		}


		accountToBeMappedVm.maskEmail2 = function (str) {
            return str[0] + "x".repeat(str.length - 2) + str[str.length - 1] ;  
		}

        accountToBeMappedVm.displayInfo = function($event) {
            accountToBeMappedVm.template = '<ion-popover-view class="quickpay loginnewarrow hmbr-info demat-popOver-Dimension">'+'<div class="demat-hint-arrow-upnew" style="{{newRenewalSuccessVm.leftStyle}}"></div>' + 
            '<ion-content class="nfs-popover demat-lr-popover" style="margin: 0px !important;">' +'<div class="demat-popOver-Mssg">Only Active Savings Bank Account are eligible</div>' + '</ion-content>' + '</ion-popover-view>';
			$scope.popover = $ionicPopover.fromTemplate(accountToBeMappedVm.template, {
				scope: $scope
			});
			$scope.popover.show($event);
        }

		//one time initialization to be done when the controller is loaded
		$scope.$on('$ionicView.loaded', function() {
			
		});
		
		//actions to done everytime the view is shown
		$scope.$on('$ionicView.beforeEnter', function() {			
	    	accountToBeMappedVm.initPage();
		
		});

		//actions to done everytime the view is hidden
		$scope.$on('$ionicView.afterLeave', function() {

		});

		
		
	}]);