
/*File Name: appStatusController
Developer name: Vaibhav*/

'use strict';

angularApp.controller('appStatusController', 
	["$state",
	"$scope",
	"$translate",
	"$ionicPopup",
	"dematService",
	"utilityService","openAccountService","homeScreenService","getAccountDetailsService","AdapterUtils","loggedInUserService",
	
	function ($state,
		$scope,
		$translate,
		$ionicPopup,dematService,utilityService,openAccountService,homeScreenService,getAccountDetailsService,AdapterUtils,loggedInUserService) {
	
		var appStatusVm = this;
		var disclaimerPopup;
		var confirmPopupIonic;
		
		//Function to intialize variables ....
		appStatusVm.initPage = function(){
			appStatusVm.isVerfiedFailed = false;
			appStatusVm.isFormFalied = false;
			appStatusVm.isOpened = false;
			appStatusVm.initiated = true;
			appStatusVm.isRejected = false;
			appStatusVm.eSign = dematService.trackStatusData.eSign;
			appStatusVm.statusDescription = dematService.trackStatusData.statusDescription ? dematService.trackStatusData.statusDescription : "";
			appStatusVm.helplineHtml = dematService.trackStatusData.helplineHtml ? dematService.trackStatusData.helplineHtml : "";
			
			if(dematService.trackStatusData.statusCode == "0045"){
				appStatusVm.isOpened = true;	
			}else if(dematService.trackStatusData.statusCode == "0005"){
				appStatusVm.isVerfiedFailed = true;	
			}else if(dematService.trackStatusData.statusCode == "0020"){
				appStatusVm.isRejected = true;
			}
			if(appStatusVm.eSign == "N" && (dematService.trackStatusData.statusCode == "0021")){
				appStatusVm.isFormFalied = true;
			}
			appStatusVm.appNo = dematService.trackStatusData.applicationNumber;
		}	
		
		//function to go a/c linking page
		appStatusVm.goToLinking = function(){
			$state.go('menu.linkAccount');
		}
		
		//Go to previous page
		appStatusVm.goToPreviousPage = function(){
			homeScreenService.isInvestmentFlag = true;
           	getAccountDetailsService.tabIndex.tabIndex = 3;
			$state.go('menu.accountOverviewMyBalance');					
		}

		appStatusVm.resumeApplication = function(){
			disclaimerPopup = $ionicPopup.alert({
				title: '',
				template: '<div class=""><div><h2 class="disclaimer" translate="OPEN_DEMAT_DSCLMR"></h2></div><div class="desclaimer-text-align"><div class="popup-msg">You will be redirected to page owned by SBICAP Securities Limited (SSL) for completing Demat & Trading account opening process. This facility is purely governed by SBICAP Securities Limited usage agreement.</div></div><div class="row popup-custombtn"><button class="ycbutton-color button col-100" ng-click="appStatusVm.callSBICap()" translate="OPEN_DEMAT_AGREE" sid="FTR_BCK_BTN" click-stream="click"></button></div><div class="row">    <button class="button col-100 popup-cancelbtn" ng-click="appStatusVm.cancel()" translate="OPEN_DEMAT_CANCEL" sid="FTR_BCK_BTN" click-stream="click"></button></div></div>',
				cssClass: 'new-purp-popup my-custom-popup trading', 
				scope: $scope,               
			});
		}

		appStatusVm.cancel = function(){
			disclaimerPopup.close();  
		}

		appStatusVm.callSBICap = function(){
			disclaimerPopup.close();  
			openAccountService.getRedirectionToSbicapUrl().then(function(res){
				appStatusVm.url=res.url;
				var reqParams={
					"selectedAccountNumber" : "",
					"tnCAccepted" : "",
					"tnCAcceptedAtDateTime" : "",
					"sharingAuthorized" : "",
					"sbiReferralCode" : "",
					"sslReferralCode" : "",
					"resumeApplication" : true
				}
				dematService.dematAccountOpenRequest(reqParams).then(function(data){
					var capSecurl = appStatusVm.url +'?param1='+ data.accessToken + '&param2='+ data.referenceNumber;
					SafariViewController.isAvailable(function (available) {
						if (available) {
						SafariViewController.show({
								url: capSecurl,//'https://predigikyc.sbismart.com',
								hidden: false, // default false. You can use this to load cookies etc in the background (see issue #1 for details).
								animated: false, // default true, note that 'hide' will reuse this preference (the 'Done' button will always animate though)
								transition: 'curl', // (this only works in iOS 9.1/9.2 and lower) unless animated is false you can choose from: curl, flip, fade, slide (default)
								enterReaderModeIfAvailable: false, // default false
								tintColor: "#00ffff", // default is ios blue
								toolbarColor: "#90305e", // change color of address bar in android
								barColor: "#90305e", // on iOS 10+ you can change the background color as well
								controlTintColor: "#ffffff" // on iOS 10+ you can override the default tintColor
							},
							// this success handler will be invoked for the lifecycle events 'opened', 'loaded' and 'closed'
							function(result) {
								if (result.event === 'opened') {
								console.log('opened');
								} else if (result.event === 'loaded') {
								console.log('loaded');
								} else if (result.event === 'closed') {
								console.log('closed');
								 var message = "Your session has expired. Please login again."
                                  confirmPopupIonic = $ionicPopup.alert({
                                    title: "",
                                    template: message,
                                    scope: $scope,
                                    cssClass: 'arsa-alert-popup',
                                    buttons: [{
                                        text: 'OK',
                                        onTap: function () {
                                            appStatusVm.logOutUser();
                                        }
                                    }]
                                })
								}
							},
							function(msg) {
								console.log("Error: " + msg);
							})
						} else {
							// potentially powered by InAppBrowser because that (currently) clobbers window.open
							window.open(capSecurl, '_blank', 'location=yes');
							 var message1 = "Your session has expired. Please login again."
                                  confirmPopupIonic = $ionicPopup.alert({
                                    title: "",
                                    template: message1,
                                    scope: $scope,
                                    cssClass: 'arsa-alert-popup',
                                    buttons: [{
                                        text: 'OK',
                                        onTap: function () {
                                            appStatusVm.logOutUser();
                                        }
                                    }]
                                })
						}
					})
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
				})
			},function(error){

			});
		}

		appStatusVm.logOutUser = function() {
           AdapterUtils.sessionLogout().then(
			function (response) {
				loggedInUserService.logoutUser(true);
				confirmPopupIonic.close();
			},
			function (error) {
				loggedInUserService.logoutUser(true);
			}
		);
       }
		
		//actions to done everytime the view is shown
		$scope.$on('$ionicView.beforeEnter', function() {			
	    	appStatusVm.initPage();
		
		});

		
	}]);