/*File Name: dematAccountHomeController
Developer name: Dinkar*/

'use strict';

angularApp.controller('dematAndTradingAccountController', 
	["$timeout",
	"$state",
	"$scope",
	"$translate",
	"$ionicPopup",
	"dematService",
	"utilityService",
	"openAccountService","getAccountDetailsService","validateService",
	"customerInfoService","homeScreenService","$ionicHistory",
	
	function ($timeout,
		$state,
		$scope,
		$translate,
		$ionicPopup,dematService,utilityService,
		openAccountService,getAccountDetailsService,validateService,customerInfoService,homeScreenService,$ionicHistory) {
	
		var dematAndTradingAccountVm = this;
		var linkingPopup='';		
		
        dematAndTradingAccountVm.isSbiSmartActive = false;
        dematAndTradingAccountVm.isChargesActive = false;
        dematAndTradingAccountVm.showContect=0;
        dematAndTradingAccountVm.emptyObject = "&lt;p&gt; &lt;br /&gt; &lt;/p&gt;";

		//Function to intialize variables ....
		dematAndTradingAccountVm.initPage = function (){	
			dematAndTradingAccountVm.age  =  customerInfoService.customer.DOB ? validateService.calcAge(customerInfoService.customer.DOB) : "";		
			
			dematAndTradingAccountVm.getDpList=openAccountService.getDpList();
			dematAndTradingAccountVm.getDematWcmData();
		}
		
		//Function to call demat list 
		dematAndTradingAccountVm.getDematWcmData=function(){			
			openAccountService.getDematWcmData().then(function(data) {
				dematAndTradingAccountVm.subPlanFeatures = data;
				dematAndTradingAccountVm.isProcessActive = true;			
			}, function(error){		
				utilityService.showErrorMessage(error.responseMessage);
			});
			
		};	

        dematAndTradingAccountVm.showFAQS = function(type) {
        	dematAndTradingAccountVm.isProcessActive = type.heading === 'Process' ? true : false;
            dematAndTradingAccountVm.DetailsFAQ = type.content;
        }

		 //Show popup of open account
		dematAndTradingAccountVm.linkPopup = function() {
             linkingPopup = $ionicPopup.alert({
                title: '',
                template: '<div class="popup-padding font-dark-grey"><div><center><img class="approvedIconPosition" src="img/capSec/Pending-Alert.svg"></center></div></div><div class="text-left"><div class="popup-msg">You already have an account with SBICAP<br> securities. Please proceed to link.</div></div><div class="row popup-custombtn">	<button class="ycbutton-color button col-100" ng-click="dematAndTradingAccountVm.linkNow()" translate="OPEN_DEMAT_LINKNOW" sid="FTR_BCK_BTN" click-stream="click"></button></div><div class="row">    <button class="button col-100 popup-cancelbtn" ng-click="dematAndTradingAccountVm.linkLater()" translate="OPEN_DEMAT_LINKLTR" sid="FTR_BCK_BTN" click-stream="click"></button></div></div>',
                cssClass: 'new-purp-popup my-custom-popup trading', 
                scope: $scope,               
                
            });
       }
       
       dematAndTradingAccountVm.linkLater = function(){
    	  	linkingPopup.close();
       }
		
		//Go to previous page
		dematAndTradingAccountVm.goToPreviousPage = function(){
			homeScreenService.isInvestmentFlag = true;
            getAccountDetailsService.tabIndex.tabIndex = 3;
			$ionicHistory.goBack();				
		}

		//Go to Account mapped page
		dematAndTradingAccountVm.startNow = function() {
			if(!angular.equals({}, customerInfoService.customer)) {
				if(customerInfoService.customer.residentialStatus && customerInfoService.customer.residentialStatus != '1'){
					dematAndTradingAccountVm.showError($translate.instant('OPEN_DEMAT_NRI_ERROR_MSSG'));
				}else if(!customerInfoService.customer.isPanAvailable){
					dematAndTradingAccountVm.panMsg=$translate.instant('OPEN_DEMAT_PAN_ERROR');
					dematAndTradingAccountVm.showError(dematAndTradingAccountVm.panMsg);
				}else if(dematAndTradingAccountVm.age < 18){
					dematAndTradingAccountVm.ageMsg=$translate.instant('OPEN_DEMAT_AGE_ERR');
					dematAndTradingAccountVm.showError(dematAndTradingAccountVm.ageMsg);
				}else{
					openAccountService.customerHasEligibleSavingsAccount().then(function(data){	
						if(data.foundEligibleSavingsAccounts=='true'){
							dematService.accList = data.eligibleAccounts;
							$state.go('menu.accountToBeMapped');
						}else {
							openAccountService.showErrorCaution("", "padBtm25 top-padding26", "No Savings account found with eligible mode of Operation", "OK", function () {
								homeScreenService.isInvestmentFlag = true;
								getAccountDetailsService.tabIndex.tabIndex = 3;
								$state.go('menu.accountOverviewMyBalance');
							},function(error){

							}); 
						}
					},function(error){
						utilityService.showErrorMessage(error.responseMessage);
					})
				}
			} else {
				utilityService.showErrorMessage('Technical error, please try later.');
			}
								
		}

		
		//Show popup of showError of if not available PAN
        dematAndTradingAccountVm.showError = function (message) {
            $ionicPopup.show({
                template:  '<div class="popup-padding font-dark-grey"><div><center><img class="approvedIconPosition" src="img/FT/BhimUpi/errorSymbol.svg"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><span class="popUp-msg-color">'
                        + message + '</span></div></div></div>',
                title: 'Alert',
                cssClass: 'dialog',
                scope: $scope,
                buttons: [{
                    text: 'Ok',
                    onTap: function (e) {
                        homeScreenService.isInvestmentFlag = true;
                        getAccountDetailsService.tabIndex.tabIndex = 3;
                        $state.go('menu.accountOverviewMyBalance');
                    }
                }]
            });
        }

		//Link Now
		dematAndTradingAccountVm.linkNow = function () {
			linkingPopup.close();
            $state.go('menu.linkAccount');
        }
		
		//actions to done everytime the view is shown
		$scope.$on('$ionicView.beforeEnter', function() {			
	    	dematAndTradingAccountVm.initPage();
		
		});
		
	}]);