'use strict';

angularApp.controller('otpAuthenticateController', ["$state",
    "$scope",
    "$translate",
    "getAccountDetailsService",
    "utilityService",
    "$ionicPopup","$filter","customerInfoService","openAccountService","dematService","homeScreenService",
    "AdapterUtils","loggedInUserService","$ionicHistory","clickStreamService",

    function ($state,
        $scope,
        $translate,
        getAccountDetailsService,
        utilityService,
        $ionicPopup, $filter,customerInfoService,openAccountService,dematService,homeScreenService,
        AdapterUtils,loggedInUserService,$ionicHistory,clickStreamService
    ) {

        var dematOTPAuthVm = this;      
        dematOTPAuthVm.showSubmit =true;
        dematOTPAuthVm.showBack = true;
        var count = 0;
		var disclaimerPopup='';
        var linkPopUp;
        var confirmPopupIonic = '';
        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            dematOTPAuthVm.initPage();           
        });

        /* Function to display the necessary information
         & put validation on Page load*/
        dematOTPAuthVm.initPage = function()  {            
            dematOTPAuthVm.mobileNumber =  $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4);
            dematOTPAuthVm.otp = "";
            dematOTPAuthVm.clickCount = 0;
            dematOTPAuthVm.otpValid = false;
            dematOTPAuthVm.disableLink = false;
            dematOTPAuthVm.otpError = "";
        }

        /* Function to send OTP on click of Resend OTP button*/
        dematOTPAuthVm.resendOtp = function(){    
            	count += 1;
                dematOTPAuthVm.otp = '';
		        if (count > 2) {
                    var mssgTxt = $translate.instant('ARSA_MAX_OTP_GENERATION');
                    openAccountService.showError(mssgTxt);
                    dematOTPAuthVm.disableLink = true;
                }else {
                    dematOTPAuthVm.disableLink = false;
                    openAccountService.getOTP().then(function(data) {
                        var successMssg = $translate.instant('ASRA_SUCCESS_OTP_RESENT_MSSG');
                        openAccountService.displayPopUp("", "demat-padBtm15 demat-top-padding10", successMssg, "OK", function () {},function(error){});
                    },function(error){
                        count = count - 1;
                        openAccountService.showError(error.responseMessage,'menu.accountOverviewMyBalance','', function () { 
                            homeScreenService.isInvestmentFlag = true;
                            getAccountDetailsService.tabIndex.tabIndex = 3;
                            $state.go('menu.accountOverviewMyBalance');
                        } );
                    })
                } 
        }

        /* Function is called on change of OTP input */
        dematOTPAuthVm.changeOtp =  function(){
             if(dematOTPAuthVm.otp == '' || ! dematOTPAuthVm.otp){
                dematOTPAuthVm.otpValid = true;
                dematOTPAuthVm.otpError = $translate.instant('INVALID_OTP_ERR');
             }else if(dematOTPAuthVm.otp.length < 6){
                dematOTPAuthVm.otpValid = true;
                dematOTPAuthVm.otpError = $translate.instant('ARSA_INVALID_OTP');
             }else{
                 dematOTPAuthVm.otpValid = false;
                 dematOTPAuthVm.otpError = "";
             }
        }
    
        /* Function is validate the entered OTP */
         dematOTPAuthVm.validateOTP = function(){
             if(dematOTPAuthVm.otp == '' || !dematOTPAuthVm.otp){
                dematOTPAuthVm.otpValid = true;
                dematOTPAuthVm.otpError = $translate.instant('INVALID_OTP_ERR');
             }else if(dematOTPAuthVm.otp.length != 6){
				dematOTPAuthVm.otpValid = true;
                dematOTPAuthVm.otpError = $translate.instant('ARSA_INVALID_OTP');
			 }else{
                dematOTPAuthVm.otpValid = false;
                dematOTPAuthVm.otpError = "";
                var reqParams = {};
                reqParams["otp"] = dematOTPAuthVm.otp;
                openAccountService.validateOTP(reqParams).then(function(data) {
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("SEC_OPNDEMATOTPAUTH" + "_" + "DM_END_NXT_BTN"));
                    dematOTPAuthVm.goToPopUp();
                },function(error){
                    dematOTPAuthVm.clickCount ++;
                    dematOTPAuthVm.otp ='';  
                    if(dematOTPAuthVm.clickCount >= 3){
                        openAccountService.showError(error.responseMessage,'menu.accountOverviewMyBalance','', function () { 
                            homeScreenService.isInvestmentFlag = true;
                            getAccountDetailsService.tabIndex.tabIndex = 3;
                            $state.go('menu.accountOverviewMyBalance');
                        } ); 
                    }  else {
                        openAccountService.showError(error.responseMessage);
                    }
                        
                })

             }
            
        }

        //Show popup of open account
		dematOTPAuthVm.goToPopUp = function() { 
            var sbiCapRequest = {
                 "accountNumber": openAccountService.getAccountDetails().selectedAccountNumber,
            }
            dematService.checkDematOpenedInSbicap(sbiCapRequest).then(function(res){
               if(res.isSuccess == "true"){
                    disclaimerPopup = $ionicPopup.alert({
                        title: '',
                        template: '<div class=""><div><h2 class="disclaimer" translate="OPEN_DEMAT_DSCLMR"></h2></div><div class="desclaimer-text-align"><div class="popup-msg">You will be redirected to page owned by SBICAP Securities Limited (SSL) for completing Demat & Trading account opening process. This facility is purely governed by SBICAP Securities Limited usage agreement.</div></div><div class="row popup-custombtn">	<button class="ycbutton-color button col-100" ng-click="dematOTPAuthVm.saveDematRequest()" translate="OPEN_DEMAT_AGREE" id="ONLINE_DEMAT_I_AGREE_BTN" click-stream="click"></button></div><div class="row">    <button class="button col-100 popup-cancelbtn" ng-click="dematOTPAuthVm.cancelIAgree()" translate="OPEN_DEMAT_CANCEL" id="ONLINE_DEMAT_CANCEL_BTN" click-stream="click"></button></div></div>',
                        cssClass: 'new-purp-popup my-custom-popup trading', 
                        scope: $scope
                    });
               }else if(res.isSuccess == "false"){
                    linkPopUp = $ionicPopup.alert({
                        title: '', 
                        template: '<div class="text-center"><div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/alertSymbol.svg"/></div><div class="text-left"><div class="popup-msg">You already have an account with SBICAP securities. Please proceed to link.</div></div><div class="row popup-custombtn">	<button class="ycbutton-color button col-100" ng-click="dematOTPAuthVm.linkDemat()" translate="OPEN_DEMAT_LINKNOW" id="ONLINE_DEMAT_LINKNOW_BTN" click-stream="click"></button></div><div class="row">    <button class="button col-100 popup-cancelbtn" ng-click="dematOTPAuthVm.cancel()" translate="OPEN_LATER" id="ONLINE_DEMAT_LINKLATER_BTN" click-stream="click"></button></div></div>',
                        cssClass: 'new-purp-popup my-custom-popup trading', 
                        scope: $scope
                    });
               }else{
                   utilityService.showErrorMessage("Technical error. Please try later.");
               }
            },function(error){
                 utilityService.showErrorMessage(error.responseMessage);
            })
       }

             

        dematOTPAuthVm.linkDemat = function(){
            linkPopUp.close();
            $state.go('menu.linkAccount');
        }

       dematOTPAuthVm.saveDematRequest = function(){
           //Add click stream anupam
       	disclaimerPopup.close();  
       	utilityService.showSpinner();   
       	var reqParams={
		  "selectedAccountNumber": openAccountService.getAccountDetails().selectedAccountNumber,
		  "tnCAccepted": openAccountService.getAccountDetails().acceptedTnC ? "true" : "false",
		  "tnCAcceptedAtDateTime":openAccountService.getAccountDetails().acceptedTnCAtDateTime ? "true" : "false",
		  "sharingAuthorized":openAccountService.getAccountDetails().authorizesShareBankingRelDetails,
		  "sbiReferralCode":openAccountService.getAccountDetails().sbiReferralCode ? openAccountService.getAccountDetails().sbiReferralCode : "",
		  "sslReferralCode":openAccountService.getAccountDetails().sslReferralCode ? openAccountService.getAccountDetails().sslReferralCode : "",
          "resumeApplication" : false
		};

        openAccountService.getRedirectionToSbicapUrl().then(function(res){
       		dematOTPAuthVm.url=res.url;
            if(dematOTPAuthVm.url) { 
                    dematService.dematAccountOpenRequest(reqParams).then(function(data){
                        var capSecurl = dematOTPAuthVm.url +'?param1='+ data.accessToken + '&param2='+ data.referenceNumber;
                        SafariViewController.isAvailable(function (available) {
                            if (available) {
                                SafariViewController.show({
                                    url: capSecurl,//'https://predigikyc.sbismart.com',
                                    hidden: false, // default false. You can use this to load cookies etc in the background (see issue #1 for details).
                                    animated: false, // default true, note that 'hide' will reuse this preference (the 'Done' button will always animate though)
                                    transition: 'curl', // (this only works in iOS 9.1/9.2 and lower) unless animated is false you can choose from: curl, flip, fade, slide (default)
                                    enterReaderModeIfAvailable: false, // default false
                                    tintColor: "#00ffff", // default is ios blue
                                    toolbarColor: "#90305e", // change color of address bar in android
                                    barColor: "#90305e", // on iOS 10+ you can change the background color as well
                                    controlTintColor: "#ffffff" // on iOS 10+ you can override the default tintColor
                                    },
                                    // this success handler will be invoked for the lifecycle events 'opened', 'loaded' and 'closed'
                                    function(result) {
                                    if (result.event === 'opened') {
                                        console.log('opened');
                                    } else if (result.event === 'loaded') {
                                        console.log('loaded');
                                    } else if (result.event === 'closed') {
                                        console.log('closed');
                                        var message = "Your session has expired. Please login again."
                                        confirmPopupIonic = $ionicPopup.alert({
                                        title: "",
                                        template: message,
                                        scope: $scope,
                                        cssClass: 'arsa-alert-popup',
                                        buttons: [{
                                            text: 'OK',
                                            onTap: function () {
                                                //url ? callback() : confirmPopupIonic.close();
                                                dematOTPAuthVm.logOutUser();
                                            }
                                        }]
                                    })
                                    }
                                    },
                                    function(msg) {
                                    console.log("Error: " + msg);
                                    })
                            } else {
                                // potentially powered by InAppBrowser because that (currently) clobbers window.open
                                window.open(capSecurl, '_blank', 'location=yes');
                                var message1 = "Your session has expired. Please login again."
                                confirmPopupIonic = $ionicPopup.alert({
                                    title: "",
                                    template: message1,
                                    scope: $scope,
                                    cssClass: 'arsa-alert-popup',
                                    buttons: [{
                                        text: 'OK',
                                        onTap: function () {
                                            //url ? callback() : confirmPopupIonic.close();
                                            dematOTPAuthVm.logOutUser();
                                        }
                                    }]
                                })
                            }
                            })
                    },function(error){
                        utilityService.hideSpinner();
                        utilityService.showErrorMessage(error.responseMessage);
                    })  
                } else {
                    utilityService.showErrorMessage('Technical error, please try later.');
                }   
            },function(error){
            });
        
        
       }
       
       dematOTPAuthVm.logOutUser = function() {
           AdapterUtils.sessionLogout().then(
                function (response) {
                    loggedInUserService.logoutUser(true);
                    confirmPopupIonic.close();
                },
                function (error) {
                    loggedInUserService.logoutUser(true);
                }
            );
       }

       dematOTPAuthVm.agree = function(){
       	    disclaimerPopup.close();
       }

       dematOTPAuthVm.cancel = function(){
            linkPopUp.close();
            homeScreenService.isInvestmentFlag = true;
            getAccountDetailsService.tabIndex.tabIndex = 3;
            $state.go('menu.accountOverviewMyBalance');    
       }

       dematOTPAuthVm.cancelIAgree = function() {
           disclaimerPopup.close();
           $ionicHistory.goBack(-1);
       }

        //Go to previous page
		dematOTPAuthVm.goToPreviousPage = function(){
            homeScreenService.isInvestmentFlag = true;
            getAccountDetailsService.tabIndex.tabIndex = 3;
			$state.go('menu.accountOverviewMyBalance');					
		}
       

        return this;
    }
]);