'use strict';
/****************************************assetsDetailsController*************************************************/
angularApp.controller('assetsDetailsController', ["$timeout",
    "$state",
    "$scope",
    "$translate",
    "$ionicPopup", "$stateParams", "assetDetailsService", "utilityService","linkAccountService","$rootScope","mySecurityProfileService","openUrlInAppbroswerService",


    function($timeout,
        $state,
        $scope,
        $translate,
        $ionicPopup, $stateParams, assetDetailsService, utilityService,linkAccountService,$rootScope,mySecurityProfileService,openUrlInAppbroswerService) {

        var assetsVm = this;

        //Initialize html variables
        function initPage() {

            assetsVm.assetsDiv=1;
			assetsVm.disclaimer=0;
            assetsVm.investment = true;
            assetsVm.currentValue = true;
            assetsVm.gainloss = false;
            assetsVm.quantity = false;
            assetsVm.assetTypeFeild1 = "inv"; //Make it constant
            assetsVm.assetTypeFeild2 = "current"; //Make it constant
			assetsVm.assetDetails=mySecurityProfileService.getDetails();
			assetsVm.assetsId = assetsVm.assetDetails[0].assetId;
            assetsVm.assetName =  assetsVm.assetDetails[0].assetName;
			$timeout(function(){
				assetsVm.callAssets();
			},500);


        }
		assetsVm.callAssets=function(){

			assetsVm.reqParams = {};
            assetsVm.reqParams["assetId"] = assetsVm.assetsId;
			assetsVm.reqParams["assetName"] = assetsVm.assetName;
			//Call service to fetch assets details list
            mySecurityProfileService.assetsDetails(assetsVm.reqParams).then(function(data) {
				assetsVm.dataResponceRecievied = true;
                assetsVm.assetScriptLists = data.assetScriptDetails.assetScriptList;
				assetsVm.totalInvestments = data.investedAmount;
				assetsVm.totalCurrentValue = data.currentValue;
				assetsVm.gainLossStatus = data.totalGainOrLossStatus;
				assetsVm.totalgainLossPer = data.totalGainOrLossPercentage;
				assetsVm.totalgainLossAmount = data.totalGainOrLossAmount;
				assetsVm.percentage=data.totalGainOrLossPercentage;
				assetsVm.gainOrLossPercentage= data.totalGainOrLossPercentage;

				if(assetsVm.totalgainLossPer<0){
						assetsVm.percentage= -(parseInt(assetsVm.totalgainLossPer));
				}
				if(assetsVm.totalInvestments> assetsVm.totalCurrentValue){
					assetsVm.totalINVPercent = 100;
					assetsVm.totalCVPercent=(assetsVm.totalCurrentValue/assetsVm.totalInvestments)*100;
					//assetsVm.totalCVPercent = 100 - assetsVm.percentage;
				}
				else if(assetsVm.totalInvestments<assetsVm.totalCurrentValue){
					assetsVm.totalCVPercent = 100;
					assetsVm.totalINVPercent=(assetsVm.totalInvestments/assetsVm.totalCurrentValue)*100;
				}
				else if(assetsVm.totalInvestments==assetsVm.totalCurrentValue){
					assetsVm.totalCVPercent = 100;
						assetsVm.totalINVPercent = 100;
				}


            }, function(error) {
            	assetsVm.dataResponceRecievied = true;
            	assetsVm.totalCurrentValue = false;
               utilityService.showErrorMessage(error.responseMessage);
            });
		}
		assetsVm.onTradeNow = function() {
			assetsVm.confirmPopup.close();
			assetsVm.assetsDiv=1;
			assetsVm.disclaimer=0;
		}
        assetsVm.onTradeNow = function() {
            assetsVm.confirmPopup = $ionicPopup.confirm({
				cssClass: 'dialog',
                templateUrl: 'pages/securities/securityProfile/trade/tradePopupInAssets.html',
                buttons: [{
                    text: '<span class="txt-black">Cancel</span>',onTap:function(e){ assetsVm.confirmPopup.close();}
                }, {
                    text: 'I Agree',

                    onTap: function(e) {
                         assetsVm.confirmPopup.then(function(res) {
                            if (res) {

                            }else {
                                assetsVm.onTradeNowFinal();
                            }
                        });
                    }
                }],
            });

             assetsVm.confirmPopup.then(function(res) {

            });

        }
        $rootScope.showAssetTradeDisclaimer = function(){
			assetsVm.assetsDiv=0;
			assetsVm.disclaimer=1;
			assetsVm.confirmPopup.close();
			assetsVm.reqParams={};
			assetsVm.reqParams['sourceType']="TradeNow";
			 //Call service to fetch assets details list
			linkAccountService.getDisclaimer(assetsVm.reqParams).then(function(data) {
				assetsVm.termsConditionsMessage=data.message;

			}, function(error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		}
		//Change function
        assetsVm.getInvestmentQuantityValues = function(param) {
            if (param == "qnt") {
                assetsVm.investment = false;
                assetsVm.quantity = true;

            } else if (param == "inv") {

                assetsVm.investment = true;
                assetsVm.quantity = false;

            }

        }

        assetsVm.getCurrentGainLossValue = function(param) {

            if (param == "current") {
                assetsVm.currentValue = true;
                assetsVm.gainloss = false;
            } else if (param == "gainloss") {
                assetsVm.currentValue = false;
                assetsVm.gainloss = true;
            }
        }
        assetsVm.onTradeNowFinal = function() {

			assetsVm.goToPreviousPage();
			assetsVm.agreeToOpenAccount();

		}
		//function to call url on agree button
		assetsVm.agreeToOpenAccount=function(){
			assetsVm.goToPreviousPage();
			assetsVm.reqParams="";

			mySecurityProfileService.tradeNowUrl().then(function(data) {
				assetsVm.tradeUrl=data.url;
				openUrlInAppbroswerService.openUrl(assetsVm.tradeUrl,assetsVm.reqParams);
			}, function(error) {
				utilityService.showErrorMessage(error.responseMessage);
			});




		}
		assetsVm.goToPreviousPage = function() {
			assetsVm.assetsDiv=1;
			assetsVm.disclaimer=0;
			initPage();
		}
		assetsVm.goToPotfolio = function() {
			$state.go('menu.securitiesPortfolio');
		}
		assetsVm.goToHome = function() {
			$state.go('menu.accountOverviewMyBalance');
		}
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {

        });
		// actions to done everytime the view is shown
		$scope.$on('$ionicView.beforeEnter', function() {
			initPage();
			assetsVm.totalCurrentValue = true;
			assetsVm.dataResponceRecievied = false;
		});

		//any cleanup needs to be done here: executes everytime when page is left
		$scope.$on('$ionicView.afterLeave', function() {
		});


    }
]);
