'use strict';
/****************************************portfolioController*************************************************/
angularApp.controller('securitiesPortfolioController', ["$timeout",'$filter',
    "$state",
    "$scope",
    "$translate",
    "$ionicPopup", "mySecurityProfileService", "utilityService","linkAccountService","$rootScope","openUrlInAppbroswerService","$ionicSlideBoxDelegate","$ionicHistory","homeScreenService",

    function($timeout,$filter,
        $state,
        $scope,
        $translate,
        $ionicPopup, mySecurityProfileService, utilityService,linkAccountService,$rootScope,openUrlInAppbroswerService,$ionicSlideBoxDelegate,$ionicHistory,homeScreenService) {
        var securitiesPortfolioVm = this;

		//Initialize html variables here
		 function initPage() {
            securitiesPortfolioVm.isBackCheck=homeScreenService.isBackCheck;
            homeScreenService.isBackCheck	=false;
            securitiesPortfolioVm.totalCurrentValue = true;
            securitiesPortfolioVm.gainPercent = 0;
            securitiesPortfolioVm.lossPercent = 0;
            securitiesPortfolioVm.disclaimer=0;
			securitiesPortfolioVm.portfolioDiv=1;
			securitiesPortfolioVm.currentAndGainLossSelect='current';
				
			//fetch all assets lists from mySecurityProfile Service . Calling mySecurityProfileService ..
			mySecurityProfileService.getSecuityProfileDetails().then(function(data) {
				//debugger;
					
					securitiesPortfolioVm.assetTypes = data.assetDetails.assetPortfolioList;
					securitiesPortfolioVm.totalGainOrLossPercentage = data.totalGainOrLossPercentage;
					securitiesPortfolioVm.totalInvestments = data.totalInvestedAmount;
					securitiesPortfolioVm.totalCurrentValue =data.totalCurrentValue;
					securitiesPortfolioVm.totalProfit = data.totalGainOrLossAmount;        //Total gain or loss amount
					securitiesPortfolioVm.totalGainOrLossStatus=data.totalGainOrLossStatus ;  //To show gain or loss arrow
					securitiesPortfolioVm.percentage= data.totalGainOrLossPercentage;
					
					if(securitiesPortfolioVm.totalGainOrLossPercentage<0){
						securitiesPortfolioVm.percentage= -(parseInt(securitiesPortfolioVm.totalGainOrLossPercentage));
					}
					if(securitiesPortfolioVm.totalInvestments> securitiesPortfolioVm.totalCurrentValue){   
						securitiesPortfolioVm.totalINVPercent = 100;
						securitiesPortfolioVm.totalCVPercent=(securitiesPortfolioVm.totalCurrentValue/securitiesPortfolioVm.totalInvestments)*100;
						//securitiesPortfolioVm.totalCVPercent = 100 - securitiesPortfolioVm.percentage;
					}
					else if(securitiesPortfolioVm.totalInvestments<securitiesPortfolioVm.totalCurrentValue){
						securitiesPortfolioVm.totalCVPercent = 100;
						//securitiesPortfolioVm.totalINVPercent = 100 - securitiesPortfolioVm.percentage;
						securitiesPortfolioVm.totalINVPercent=(securitiesPortfolioVm.totalInvestments/securitiesPortfolioVm.totalCurrentValue)*100;
					}
					else if(securitiesPortfolioVm.totalInvestments==securitiesPortfolioVm.totalCurrentValue){
						securitiesPortfolioVm.totalCVPercent = 100;
						securitiesPortfolioVm.totalINVPercent = 100;
					}
					securitiesPortfolioVm.isProfit = true;
					securitiesPortfolioVm.labelArray = [];
					securitiesPortfolioVm.dataArray = [];
					securitiesPortfolioVm.colorSetArray = ["#0095da", "#86caec", "#caebf9", "#4cb5e5", "#66bfe9", "#7fcaec", "#99d5f0", "#b2dff4", "#cceaf8", "#e5f4fb"]; //Set of colors
					securitiesPortfolioVm.colorArray = [];

					for (var list = 0; list < data.assetDetails.assetPortfolioList.length; list++) {
						securitiesPortfolioVm.formattedCurrentValue=$filter('number')(data.assetDetails.assetPortfolioList[list].currentValPer,2);
						
						if(data.assetDetails.assetPortfolioList[list].assetId=='3'){
							$translate('MUTUAL_FUNDS').then(function(mutualFundText) {
								securitiesPortfolioVm.labelArray.push(mutualFundText +  "<br/>  " + securitiesPortfolioVm.formattedCurrentValue+" % ");
							});
							
						}else{ 
							securitiesPortfolioVm.labelArray.push(data.assetDetails.assetPortfolioList[list].assetName + "<br/> " + securitiesPortfolioVm.formattedCurrentValue+" % ");
						}
						securitiesPortfolioVm.colorArray.push(securitiesPortfolioVm.colorSetArray[list]);
						//securitiesPortfolioVm.labelArray.push(data.assetDetails.assetPortfolioList[list].currentValue + " " + data.assetDetails.assetPortfolioList[list].assetName);
						securitiesPortfolioVm.dataArray.push(data.assetDetails.assetPortfolioList[list].currentValPer);
					}
					 /** Load Pie chart**/

					$timeout(function() {
						var pieChart = document.getElementById("pieChartInSecurity");
						securitiesPortfolioVm.pieChartObj = new Chart(pieChart, {
							type: 'doughnut',
							data: {
								labels: securitiesPortfolioVm.labelArray,
								datasets: [{
									data: securitiesPortfolioVm.dataArray,
									backgroundColor: securitiesPortfolioVm.colorArray
								}]
							},
							options: {
								tooltips: {
									enabled: false
								},
								legend: {
									/* position: 'right',
									fullWidth: true,
									labels: {
										boxWidth: 15,
										fontSize: 13,
										fontColor: '#5d6b7a',
										padding: 20
									} */
									display: false
								},
								animation: {
									animateScale: true,
									animateRotate: true
								},
								cutoutPercentage: 70
							}
						});
						document.getElementById('js-legend').innerHTML = securitiesPortfolioVm.pieChartObj.generateLegend();
						// securitiesPortfolioVm.isProfit = true;
					},2000);
				
            }, function(error) {
            	securitiesPortfolioVm.totalCurrentValue = false;
				utilityService.showErrorMessage(error.responseMessage);
            });

           
          
        }

        //Function to show trade now popup
        securitiesPortfolioVm.onTradeNow = function() {
            securitiesPortfolioVm.confirmPopup = $ionicPopup.confirm({
                cssClass: 'dialog',
                templateUrl: 'pages/securities/securityProfile/trade/tradepopup.html',
                buttons: [{
                    text: '<span class="txt-black">Cancel</span>',onTap:function(e){ $state.go('menu.securitiesPortfolio');}
                }, {
                    text: 'I Agree',
                    type: 'button-positive',
                    onTap: function(e) {
                        securitiesPortfolioVm.confirmPopup.then(function(res) {
                            if (res) {
                            } else {
                                securitiesPortfolioVm.onTradeNowFinal();
                            }
                        });
                    }
                }],
            });

            securitiesPortfolioVm.confirmPopup.then(function(res) {
               
            });
           
        }

		//Function to show next slide
        $rootScope.goToNextSlide = function() {
			$ionicSlideBoxDelegate.next();
		 }
		 
		//Function to show Previous slide
        $rootScope.goToPreviousSlide = function() {
			$ionicSlideBoxDelegate.previous();
		 }
		
		//Function to show trade now success popup
        securitiesPortfolioVm.onTradeNowFinal = function() {
          securitiesPortfolioVm.agreeToOpenAccount();
        }
		//function to call url on agree button
		securitiesPortfolioVm.agreeToOpenAccount=function(){
			securitiesPortfolioVm.goToPotfolio();
			
			securitiesPortfolioVm.reqParams=""; //TODO Changes
			
			mySecurityProfileService.tradeNowUrl().then(function(data) {
				securitiesPortfolioVm.tradeUrl=data.url;
				openUrlInAppbroswerService.openUrl(securitiesPortfolioVm.tradeUrl,securitiesPortfolioVm.reqParams);
			}, function(error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
			

			
            
           
		}
        //Function to call assets details
        securitiesPortfolioVm.assetCall = function(assetId, assetName) {
			securitiesPortfolioVm.reqParams={};
			securitiesPortfolioVm.reqParams['assetName']=assetName;
			securitiesPortfolioVm.reqParams['assetId']=assetId;
			
			mySecurityProfileService.addDetails(securitiesPortfolioVm.reqParams);
            $state.go("menu.launchAsset");

        }
		
		$rootScope.showDisclaimer = function(){
			securitiesPortfolioVm.portfolioDiv=0;	
			securitiesPortfolioVm.disclaimer=1;
			securitiesPortfolioVm.confirmPopup.close();
			securitiesPortfolioVm.reqParams={};
			securitiesPortfolioVm.reqParams['sourceType']="TradeNow";
			 //Call service to fetch assets details list
			linkAccountService.getDisclaimer(securitiesPortfolioVm.reqParams).then(function(data) {
				securitiesPortfolioVm.termsConditionsMessage=data.message;
			}, function(error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		}
		//Go to portfolio Page
		securitiesPortfolioVm.goToPotfolio = function() {
			initPage();
		}
		
		securitiesPortfolioVm.goToHome = function() {
      if(homeScreenService.ishamMenu===true){
        $ionicHistory.goBack();
        //$state.go("menu.homeScreen");
        homeScreenService.ishamMenu=false;
      }
      else{
      $state.go("menu.accountOverviewMyBalance");
    }
		}
		
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {

        });
		// actions to done everytime the view is shown
		$scope.$on('$ionicView.beforeEnter', function() {
			initPage();
		});
	
		//any cleanup needs to be done here: executes everytime when page is left
		$scope.$on('$ionicView.afterLeave', function() {
		});
       
		

    }
]);
