'use strict';

angularApp.controller('serviceRequestInnerController', ["$timeout",
  "$state",
  "$location",
  "$scope",
  "$rootScope",
  "customerInfoService",
  "utilityService",
  "$ionicPopup", "serviceRequestService","ppfEReceiptService","siNfsService","getAccountDetailsService","homeScreenService","manageEstatementService","formEnquiryService","hmbrtService","$ionicHistory", "chequeDepositsService", "form15SubmissionService",
  "bhimUpiService",
  "constantConfig",
  "loggedInUserService",
  function ($timeout,
    $state,
    $location,
    $scope,
    $rootScope,
    customerInfoService,
    utilityService,
    $ionicPopup, serviceRequestService, ppfEReceiptService,siNfsService,getAccountDetailsService,homeScreenService,manageEstatementService,formEnquiryService,hmbrtService,$ionicHistory,chequeDepositsService,form15SubmissionService,bhimUpiService, constantConfig, loggedInUserService) {


    //functions, variables that can be accessed from the HTML template
    var serviceRequestInnerVm = this;



    function isEmpty(obj) {
      return !Object.keys(obj).length > 0;
    }

    serviceRequestInnerVm.innerPageResponse = {
      "data": {
        "getLinks": [
          {
            "linkText": "ATM/Debit Card Block",
            "mobileLink": "menu.blockUnblock"
          },
          {
            "linkText": "Stop Cheque",
            "mobileLink": ""
          }
        ]
      },
      "responseMessage": "Success",
      "responseCode": "0000",
      "errorLog": ""
    };



    serviceRequestInnerVm.goToSubPage = function (innerPageID, linkText) {

      //KYC Validation call
      if (linkText == "Revoke Stop" || linkText == "Stop Cheque" || linkText == "Request Cheque Book") {
        if (customerInfoService.customer.residentialStatus == "1") {
        serviceRequestService.kycAndNightModeValidation().then(function (data) {
          serviceRequestInnerVm.kycValidation = data.flag;
          serviceRequestService.isNightMode = data.isNightMode;

          if (serviceRequestService.isNightMode) {

            var NightModetxt = "Request can not be processed now. Please try between 08:00 Hrs(IST) to 20.00 Hrs(IST).";
            utilityService.showNfsAlertModal("", NightModetxt, "menu.homeScreen", $scope, $state, "OK", "errorImgTitle");
          } else {
            if (serviceRequestInnerVm.kycValidation == "TRUE") {
              $state.go(innerPageID);
            }

          }



        }, function (error) {
          //utilityService.showErrorMessage(error.responseMessage);
          utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
        });
        }else {
                      var errorText = "Sorry, you cannot access cheque services online.Please visit / contact your home branch.";
                      utilityService.showNfsAlertModal("", errorText, "menu.homeScreen", $scope, $state, "OK");
              }



      }
      else if (linkText == "Enquiry") {
        if (customerInfoService.customer.residentialStatus == "1") {
        serviceRequestService.kycValidation().then(function (data) {
          serviceRequestInnerVm.kycValidation = data.flag;

          if (serviceRequestInnerVm.kycValidation == "TRUE") {
            $state.go(innerPageID);
          }

        }, function (error) {
          utilityService.showErrorMessage(error.responseMessage);
        });
        }else {
                      var errorText = "Sorry, you cannot access cheque services online.Please visit / contact your home branch.";
                      utilityService.showNfsAlertModal("", errorText, "menu.homeScreen", $scope, $state, "OK");
              }
      }
      else if (linkText == "Change Account Type") {

        var isEmptyCustomerInfo = isEmpty(customerInfoService.customer);
        if (isEmptyCustomerInfo == false) {

          if (customerInfoService.customer.residentialStatus == "1") {

            serviceRequestService.kycValidation().then(function (data) {
              serviceRequestInnerVm.kycValidation = data.flag;

              if (serviceRequestInnerVm.kycValidation == "TRUE") {
                $state.go('menu.selAccToEnableChangeAcc');
              }

            }, function (error) {
               utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
              //utilityService.showErrorMessage(error.responseMessage);
            });


          } else {
            var errorText = "Sorry, you cannot access Change Account Type services online. Please visit/contact your home branch.";
            utilityService.showNfsAlertModal("", errorText, "menu.homeScreen", $scope, $state, "OK");
          }

        } else {
          var errorData = "Something went wrong. Please try again after sometime.";
          utilityService.showNfsAlertModal("", errorData, "menu.homeScreen", $scope, $state, "OK");

        }



      }
          else if (linkText == "Cheque Deposits") {

        var isEmptyCustomerInfo = isEmpty(customerInfoService.customer);
        if (isEmptyCustomerInfo == false) {

          if (customerInfoService.customer.residentialStatus == "1") {

            serviceRequestService.kycValidation().then(function (data) {
              serviceRequestInnerVm.kycValidation = data.flag;

              if (serviceRequestInnerVm.kycValidation == "TRUE") {
                $state.go('menu.chequeDeposits');
                // chequeDepositsService.isUserWhiteListed().then(function(response) {
                //     if (response.isUserWhiteListed == true) {
                //        $state.go('menu.chequeDeposits');
                //     }
                //       }, function(error) {      

                //           if(error.responseMessage.toLowerCase() == 'coming soon'){
                //             var comingsoonPopup = $ionicPopup.alert({
                //               template: '<div class="CSPadding font-dark-grey "><div class="parentCS"><img class="imgwidthCS" src="img/Coming_Soon_Illustration.svg"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="childCS">'
                //               + "Coming Soon" + '</div></div></div></div></div></div>',
                //               cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter custButtonCS button0pd',
                //               buttons: [
                //                   {
                //                       text: 'OK',
                //                       type: 'button-positive',
                //                       onTap: function (e) {
                //                           comingsoonPopup.close();
                //                       }
                //                   }
                //               ]
                //           });
                //           }else{
                //             utilityService.showErrorMessage(error.responseMessage);
                //           }  
                          
                //       }); 
              }
              else
              {
                utilityService.showNfsAlertModal("", "User is not KYC compliant, Cannot proceed.", "menu.homeScreen", $scope, $state, "OK");
              }

            }, function (error) {
               utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
              //utilityService.showErrorMessage(error.responseMessage);
            });


          } else {
            var errorText = "Sorry, you cannot access cheque services online. Please visit / contact your home branch";
            utilityService.showNfsAlertModal("", errorText, "menu.homeScreen", $scope, $state, "OK");
          }

        } else {
          var errorData = "Something went wrong. Please try again after sometime.";
          utilityService.showNfsAlertModal("", errorData, "menu.homeScreen", $scope, $state, "OK");

        }



      }
	  
	    
	  //N35 starts
       else if (linkText == "Payment Information") {
       
                $state.go('menu.paymentInformation');
       }
	   
	   //N35 Ends
	   //Pension Form16B starts here
       else if (linkText == "Form 16 \n(PartB)") {

                $state.go('menu.pensionForm16B');
       }
       // Pension Form16 B ends here
      else if (linkText == "Activate SMS Alerts") {


        var isEmptyCustomerInfo = isEmpty(customerInfoService.customer);
        if (isEmptyCustomerInfo == false) {

          if (customerInfoService.customer.residentialStatus == "1") {

             serviceRequestService.kycAndNightModeValidation().then(function (data) {
          serviceRequestInnerVm.kycValidation = data.flag;
          serviceRequestService.isNightMode = data.isNightMode;

          if (serviceRequestService.isNightMode) {

            var NightModetxt = "Request cannot be processed now. Please try between 08:00 Hrs(IST) to 20.00 Hrs(IST).";
            utilityService.showNfsAlertModal("", NightModetxt, "menu.homeScreen", $scope, $state, "OK", "errorImgTitle");
          } else {
            if (serviceRequestInnerVm.kycValidation == "TRUE") {
                $state.go('menu.smsAlertActivation');
            }

          }



        }, function (error) {
          //utilityService.showErrorMessage(error.responseMessage);
          utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
        });


          } else {
            var errorText = "Sorry your request for change account type cannot be processed online. Please visit / contact your home branch";
            utilityService.showNfsAlertModal("", errorText, "menu.innerPage", $scope, $state, "OK");
          }

        } else {
          var errorData = "Something went wrong. Please try again after sometime.";
          utilityService.showNfsAlertModal("", errorData, "menu.innerPage", $scope, $state, "OK");

        }



      }
      else if (linkText == "Standing Instruction"){

        if(!customerInfoService.customer.residentialStatus)
        {
            utilityService.showSpinner();
            homeScreenService.getCustomerInfo().then(function (data) {
                getAccountDetailsService.accountOverviewData = data;
                customerInfoService.customer.name = data.customerInformation.customerName;
                customerInfoService.customer.type = data.customerInformation.customerType;
                customerInfoService.customer.DOB = data.customerInformation.dob;
                customerInfoService.customer.isPanAvailable = data.customerInformation.panNumber;
                customerInfoService.customer.isStaffFlag = data.customerInformation.isStaffFlag;
                customerInfoService.customer.emailID = data.customerInformation.emailID;
                customerInfoService.customer.mobile = data.customerInformation.mobile;
                customerInfoService.customer.title = data.customerInformation.title;
                customerInfoService.customer.residentialStatus = data.customerInformation.residentialStatus;
                serviceRequestInnerVm.gotoSIDetails();
                
            },
            function (error) {
                utilityService.hideSpinner();
                utilityService.showBhimUpiAlert("alert",error.responseMessage,"menu.homeScreen","Ok",$scope);
          });
        }else{
          serviceRequestInnerVm.gotoSIDetails();
        }   


      }

       else if (linkText == "PPF Loan & Withdrawal Eligibility") {

          $state.go("menu.ppfEligibility");

     }
      else if (linkText == "Form 15 G/H Enquiry") {
        formEnquiryService.getCifDetails().then(function (response) {
          serviceRequestInnerVm.cifNumber = response.cif;
          formEnquiryService.cifNum = serviceRequestInnerVm.cifNumber;
          $state.go("menu.formEnquiryLanding");
        }, function (error) {
          if (error.responseCode == "cs002") {
            var comingsoonPopup = $ionicPopup.alert({
              template: '<div class="CSPadding font-dark-grey "><div class="parentCS"><img class="imgwidthCS" src="img/Coming_Soon_Illustration.svg"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="childCS">'
              + "Coming Soon" + '</div></div></div></div></div></div>',
              cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter custButtonCS button0pd',
              buttons: [
                {
                  text: 'OK',
                  type: 'button-positive',
                  onTap: function (e) {
                    comingsoonPopup.close();
                  }
                }
              ]
            });
          } else {
            utilityService.showErrorMessage(error.responseMessage);
          }

        });


      }
      else if (linkText == "Form 15 G/H Submission") {
        form15SubmissionService.clearServiceVars();
        var isEmptyCustomerInfo = isEmpty(customerInfoService.customer);
        if (isEmptyCustomerInfo == false) {
          var reqParams = {
            "isMasked": "Y"
          }
          form15SubmissionService.checkPreValidation(reqParams).then(function (response) {
            serviceRequestInnerVm.cifNumber = response.cif;
            form15SubmissionService.cifNum = serviceRequestInnerVm.cifNumber;
            form15SubmissionService.branch = '';
            //$state.go('menu.form15SubmissionLanding');
			if( response.popupMessage != ""){
				//utilityService.showBhimUpiAlert("alert", response.popupMessage, 'menu.form15SubmissionLanding');
				var bhimErrorPopup = $ionicPopup.alert({
				  template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src="img/FT/BhimUpi/alertSymbol.svg" /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div style="text-align:left"><span>'
				  + response.popupMessage + '</span></div></div></div>', //template,
				  scope: $scope,
				  cssClass: 'bhim-alert-popup form15popup',
				  buttons: [
					{
					  text: "OK",
					  type: 'button-positive',
					  onTap: function () {
						
						  $state.go('menu.form15SubmissionLanding');
						
					  }
					}
				  ],
				});
            }
            else{
            $state.go('menu.form15SubmissionLanding');
            }
          }, function (error) {
            if (error.responseCode == "cs002") {
              var comingsoonPopup = $ionicPopup.alert({
                template: '<div class="CSPadding font-dark-grey "><div class="parentCS"><img class="imgwidthCS" src="img/Coming_Soon_Illustration.svg"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="childCS">'
                + "Coming Soon" + '</div></div></div></div></div></div>',
                cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter custButtonCS button0pd',
                buttons: [
                  {
                    text: 'OK',
                    type: 'button-positive',
                    onTap: function (e) {
                      comingsoonPopup.close();
                    }
                  }
                ]
              });
            } else {
              if (error.alertFlag && error.alertFlag == 'Y') {
                utilityService.showBhimUpiAlert("alert", error.responseMessage, 'menu.homeScreen');
              } else {
                utilityService.showErrorMessage(error.responseMessage);
              }
            }
          });
        }
        else {
          var errorData = "Cannot process now, please try after some time.";
          utilityService.showNfsAlertModal("", errorData, "menu.homeScreen", $scope, $state, "OK");
        }
      }
      else if (linkText == "Request New / Replacement") {

        //NRI NRO CHECK
        // if (customerInfoService.customer.residentialStatus == "1") {
        //   $state.go('menu.newDebitCard');
        // }else if(customerInfoService.customer.residentialStatus == "" || customerInfoService.customer.residentialStatus == null || customerInfoService.customer.residentialStatus == undefined ){

        //      var errorData = "Something went wrong. Please try again after sometime.";
        //   utilityService.showNfsAlertModal("", errorData, "menu.innerPage", $scope, $state, "OK");
        // } 
        // else {
        //   var errorText = "Sorry your request for new Debit card cannot be processed online. Please visit / contact your home branch";
        //   utilityService.showNfsAlertModal("", errorText, "menu.innerPage", $scope, $state, "OK");

        // }
        var isEmptyCustomerInfo = isEmpty(customerInfoService.customer);
        if (isEmptyCustomerInfo == false) {

          if (customerInfoService.customer.residentialStatus == "1") {
            $state.go('menu.newDebitCard');
          } else {
            var errorText = "Sorry your request for new Debit card cannot be processed online. Please visit / contact your home branch";
            utilityService.showNfsAlertModal("", errorText, "menu.innerPage", $scope, $state, "OK");
          }

        } else {
          var errorData = "Something went wrong. Please try again after sometime.";
          utilityService.showNfsAlertModal("", errorData, "menu.innerPage", $scope, $state, "OK");

        }
      }
      else if (linkText == "Print PPF e\u2011receipt") {

            ppfEReceiptService.getPPFAccounts().then(function(data){
            ppfEReceiptService.addppfList(data.ppfAccountList);
            $state.go('menu.ppfEReceipt');
            },function (error) {
                utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
            });



      }  else if (linkText == "Scheduled Request") {
              $state.go('menu.scheduledRequests');
        }
     /* else if (linkText == "Reprint Challan Tax") {
        var isEmptyCustomerInfo = isEmpty(customerInfoService.customer);
            if (isEmptyCustomerInfo == false) {
                if (customerInfoService.customer.residentialStatus == "1") {
                    serviceRequestService.kycValidation().then(function (data) {
                    serviceRequestInnerVm.kycValidation = data.flag;
                          if (serviceRequestInnerVm.kycValidation == "TRUE") {
                                $state.go('menu.reprintChallan');
                          }
                    }, function (error) {
                        utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
                       });
                } else {
                    var errorText = "Sorry, you cannot access e-Tax services online. Please visit / contact your home branch.";
                    utilityService.showNfsAlertModal("", errorText, "menu.homeScreen", $scope, $state, "OK");
                }
        } else {
          var errorData = "Cannot process now, please try after some time.";
          utilityService.showNfsAlertModal("", errorData, "menu.homeScreen", $scope, $state, "OK");
        }
     }*/
	 else if (linkText == "Change Home Branch") {
        var isEmptyCustomerInfo = isEmpty(customerInfoService.customer);
            if (isEmptyCustomerInfo == false) {
                if (customerInfoService.customer.residentialStatus == "1") {

                   serviceRequestService.checkWhiteListUser().then(function (data) {
                        serviceRequestService.kycAndNightModeValidation().then(function (data) {
                            serviceRequestService.isNightMode = data.isNightMode;
                            if (serviceRequestService.isNightMode) {
                              var NightModetxt = "Request can not be processed now. Please try between 08.00 Hrs (IST) to 20.00 Hrs (IST).";
                              utilityService.showNfsAlertModal("", NightModetxt, "menu.homeScreen", $scope, $state, "OK", "errorImgTitle");
                            } else {
                              $ionicHistory.clearCache().then(function () {
                                hmbrtService.getAccountList = {};
                                $state.go('menu.hbAccSelect');
                              })
                            }
                        }, function (error) {
                            utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
                        });
                    }, function (error) {
                      if(error.responseCode == "CHB01"){
                        utilityService.comingSoon();
                      }else{
                        utilityService.showErrorMessage(error.responseMessage);
                      }
                    });
                } else {
                    var errorText = "Sorry, you cannot access Change Home Branch services online. Please visit/contact your home branch.";
                    utilityService.showNfsAlertModal("", errorText, "menu.homeScreen", $scope, $state, "OK");
                }
            }
     }
else if(linkText == "Manage e-Statements"){
      var isEmptyCustomerInfo = isEmpty(customerInfoService.customer);
            if (isEmptyCustomerInfo == false) {
                if (customerInfoService.customer.emailID != "") {
                  manageEstatementService.initializeValues();
                    $state.go('menu.manageEstmt');
                } else {
                  //to redirect user to email update page
                  emaillDetailsService.emailupdate = true;
                  emaillDetailsService.CorrAdd = false;
                    var errorText = "You do not have a valid email Id registered with the bank. Kindly update your e-mail id through YONO or visit your nearest branch.";
                    manageEstatementService.showAlertPopup("alert",errorText,"menu.emailUpdate","OK","Cancel",$scope);
                }
          } else {
              var errorData = "Cannot process now, please try after some time.";
              manageEstatementService.showAlertPopup("alert",errorData,"menu.homeScreen","OK","",$scope);
          }
     }
     else if (linkText == "Disable / Enable Account (UPI)") {
        bhimUpiService.accountListFromAPI = [];
        bhimUpiService.accountListFromSDK = [];
        bhimUpiService.accountList = [];
        if (!getAccountDetailsService.accountOverviewData) {
          utilityService.showErrorMessage('Cannot process now, please try after some time.');
        }
        else{
          if(getAccountDetailsService.accountOverviewData.accounts.length > 0){
              bhimUpiService.accountListFromAPI =  getAccountDetailsService.accountOverviewData.accounts.filter(function(obj) {
                return obj.accountType == "Current A/c" || obj.accountType == "Overdraft A/c" || obj.accountType == "Savings A/c";
              });
          }
          
                
                bhimUpiService.accountList = angular.copy(bhimUpiService.accountListFromAPI);
                bhimUpiService.entryForEnableDisable = "Account";
                //$state.go('menu.enableDisableUpi');
                utilityService.showSpinner();
                if (!localStorage.getItem("appGenId")) {
                  bhimUpiService.getNativeData("generateAppGenId", {}).then(function (data) {
                    if (device.platform.toLowerCase() == 'android') {
                      bhimUpiService.appGenId = data.appGenId;
                    } else {
                      bhimUpiService.appGenId = data;
                    }
                    getDeviceInfo();
                  }, function (msg) {
                    utilityService.hideSpinner();
                    //utilityService.showBhimUpiAlert("error", msg);
                  });
                } else {
                  bhimUpiService.getNativeData("setAppGenId", localStorage.getItem("appGenId")).then(function (data) {
                    getDeviceInfo();
                  }, function (msg) {
                    utilityService.hideSpinner();
                    //utilityService.showBhimUpiAlert("error", msg);
                  });
                }
        }
      }else if(linkText == "Positive Payment System"){
        if(customerInfoService.customer.residentialStatus == "1" || customerInfoService.customer.residentialStatus == "2"){
          $state.go(innerPageID);
        }else{
          var ppsRiNriCheck = $ionicPopup.alert({
              template: '<div class="CSPadding font-dark-grey "><div class="parentCS"><img class="ppsimgwidthCS roboto-medium" src="img/errorDndRed.svg" alt="error"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="ppschildCS" translate="PPS_RI_NRI_CHECK"></div></div></div></div></div></div>',
              cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter ppscustBtn button0pd',
              buttons: [
                {
                  text: 'OK',
                  type: 'button-positive',
                  onTap: function (e) {
                  ppsRiNriCheck.close();
                  
                  }
                }
              ]
            });
        }
        
      }else {
        $state.go(innerPageID);
      }
   }
function getDeviceInfo(){
      if (device.platform.toLowerCase() == 'android') {
        utilityService.showSpinner();
        var json = JSON.stringify({});
        bhimUpiService.getNativeData(constantConfig.upiConstant.getpermission, json).then(function (data) {
          if (data.permission === 'Allowed') {
            redirectToEnableDisableJourney();
          } else {
            utilityService.hideSpinner();
            //utilityService.showBhimUpiAlert("alert", "Permission Denied");
          }
        }, function (msg) {
          utilityService.hideSpinner();
          //utilityService.showBhimUpiAlert("error", msg);
        });
      } else if (device.platform.toLowerCase() == 'windows') {
        ionicToast.show("The functionality is not available in windows currently.", 'bottom', false, 3000);
      } else {
        utilityService.showSpinner();
        var json = JSON.stringify({
          "pspId": constantConfig.upiConstant.pspId,
          "encryptionKey": loggedInUserService.upiPermissionKey.split("^")[2]
        });
        bhimUpiService.getNativeData(constantConfig.upiConstant.initializeIOSsdk, json).then(function (data) {
          if (data !== "S") {
            utilityService.hideSpinner();
            //utilityService.showBhimUpiAlert("error", data);
            return false;
          }
          utilityService.showSpinner();
          var json = JSON.stringify({
            "addInfo": {
              "addInfo10": constantConfig.upiConstant.addInfo10,
              "addInfo9": constantConfig.upiConstant.addInfo9
            },
            "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
            "requestInfo": {
              "pspId": constantConfig.upiConstant.pspId,
              "pspRefNo": generateRandomString(27)
            },
            "updateFlag": constantConfig.upiConstant.updateFlag,
            "smsSent": "false"
          });
          bhimUpiService.getNativeData(constantConfig.upiConstant.checkDevice, json).then(function (data) {
            $rootScope.checkDeviceInfo = JSON.parse(data);
            if ($rootScope.checkDeviceInfo.status == 'S') {
              if ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNM') {
                getAccountListFromUPISDK();
              } else {
                utilityService.hideSpinner();
                //utilityService.showBhimUpiAlert("error", "Looks like your mobile number have not UPI profile to make payments. Please login and set the UPI profile");
              }
            } else {
              utilityService.hideSpinner();
              //utilityService.showBhimUpiAlert("error", $rootScope.checkDeviceInfo.statusDesc);
            }
          }, function (msg) {
            utilityService.hideSpinner();
            //quickPayLandingVm.showVpaErrorMessage(msg);
          });
        }, function (msg) {
          utilityService.hideSpinner();
          //quickPayLandingVm.showVpaErrorMessage(msg);
        });
      }
    }
function redirectToEnableDisableJourney(){
  /*Sim card Info fetching - Start*/
      function simInfosuccessCallback(result) {
        if (result !== undefined && result != null && result != '') {
          if (result.cards && result.cards.length > 0) {
            customerInfoService.simCardInfo = result;

            utilityService.showSpinner();
            var json = JSON.stringify({
              "addInfo": {
                "addInfo10": constantConfig.upiConstant.addInfo10,
                "addInfo9": constantConfig.upiConstant.addInfo9
              },
              "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
              "requestInfo": {
                "pspId": constantConfig.upiConstant.pspId,
                "pspRefNo": generateRandomString(27)
              },
              "updateFlag": constantConfig.upiConstant.updateFlag,
              "smsSent": false
            });
            bhimUpiService.getNativeData(constantConfig.upiConstant.checkDevice, json).then(function (data) {
              $rootScope.checkDeviceInfo = JSON.parse(data);
              if ($rootScope.checkDeviceInfo.status == 'S') {
                if ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNM') {
                  //call SDK account list service
                  getAccountListFromUPISDK();
                  //quickPayLandingVm.getUPIProfile("collect");
                } else {
                  //user not UPI registered so display accounts only from adapter call
                  bhimUpiService.accountList = bhimUpiService.accountListFromAPI;
                  utilityService.hideSpinner();
                  if(bhimUpiService.accountList.length > 0)
                  $state.go('menu.enableDisableUpi');
                  else
                  utilityService.showBhimUpiAlert("error", "No Account Available.");
                  
                }
              } else {
                utilityService.hideSpinner();
                //utilityService.showBhimUpiAlert("error", $rootScope.checkDeviceInfo.statusDesc);
              }
            }, function (msg) {
              utilityService.hideSpinner();
              
            });

          } else {
            utilityService.hideSpinner();
            utilityService.showBhimUpiAlert("alert", "Please insert simcard to proceed further");
          }
        } else {
          utilityService.hideSpinner();
          utilityService.showBhimUpiAlert("alert", "Please insert simcard to proceed further");
        }
      }

      function HasPerminionSuccessCallback(result) {
        if (result) {
          window.plugins.sim.getSimInfo(simInfosuccessCallback, errorCallback);
        } else {
          requestReadPermission();
        }
      }

      function errorCallback(error) {
        var elementSimInfo = document.getElementById('ErrorInfo');
        elementSimInfo.innerHTML = error;
      }

      function requestSuccessCallback(result) {
        if (result) {
          hasReadPermission();
        }
      }
      // Android only: check permission
      function hasReadPermission() {
        window.plugins.sim.hasReadPermission(HasPerminionSuccessCallback, errorCallback);
      }
      // Android only: request permission
      function requestReadPermission() {
        window.plugins.sim.requestReadPermission(requestSuccessCallback, errorCallback);
      }
      hasReadPermission();
      /*Sim card Info fetching - End*/
}

function getAccountListFromUPISDK(){
  
            var json = JSON.stringify({
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "userInfo": {
                    "defVPAStatus": constantConfig.upiConstant.defVPAStatus,
                    "isMerchant": constantConfig.upiConstant.isMerchant,
                    "showMerchant": constantConfig.upiConstant.showMerchant
                }
            });
            bhimUpiService.getNativeData("getAccountListForEnableDisableServices", json).then(function (data) {
              
                var accObj = JSON.parse(data);
                utilityService.hideSpinner();
                var isAccountExists = -1;
                if (accObj.status == 'S') {
                    bhimUpiService.accountListFromSDK = accObj.accountList || [];
                    for(var i=0; i<bhimUpiService.accountListFromSDK.length; i++){
                      if(bhimUpiService.accountListFromAPI.length > 0){
                      isAccountExists = -1;
                      bhimUpiService.accountListFromAPI.some(function (obj, j) {
                        var accNumberFromAPI = obj.accountNumber.substring(obj.accountNumber.length - 4);
                        var accNumberFromSDK = bhimUpiService.accountListFromSDK[i].maskedAccountNumber.substring(bhimUpiService.accountListFromSDK[i].maskedAccountNumber.length - 4);
                        return accNumberFromAPI == accNumberFromSDK ? isAccountExists = j : false;
                      });
                      if (isAccountExists !== -1) {
                        //account already exist
                      }else{
                        //push account to acc list
                        var arr = [];
                        arr.accountNumber = bhimUpiService.accountListFromSDK[i].maskedAccountNumber;
                        arr.unmaskedAccountNumber = bhimUpiService.accountListFromSDK[i].accountNumber;
                        arr.accounttype = bhimUpiService.accountListFromSDK[i].accountType;
                        arr.branchCode = bhimUpiService.accountListFromSDK[i].ifscCode.slice(6, 11);
                        arr.type = "sdk";
                        bhimUpiService.accountList.push(arr);
                      }
                      }
                    }
                    $state.go('menu.enableDisableUpi');  
                } else {
                    utilityService.showBhimUpiAlert("alert", accObj.statusDesc);
                }
            }, function (msg) {
                utilityService.hideSpinner();
                utilityService.showBhimUpiAlert("error", msg);
            });
}
   serviceRequestInnerVm.gotoSIDetails = function(){
      if (customerInfoService.customer.residentialStatus == "1") {
            serviceRequestService.kycAndNightModeValidation().then(function (data) {
            var isNightModeSI = data.isNightMode;

            if (isNightModeSI) {
              var NightModetxt = "Request cannot be processed now. Please try between 08:00 Hrs(IST) to 20.00 Hrs(IST).";
              utilityService.showBhimUpiAlert("alert",NightModetxt,"menu.homeScreen","Ok",$scope);
            } else {
              siNfsService.getSIAccounts().then(function(data){
                if(data.accList){
                  if(data.accList.length > 0){            
                        siNfsService.setFromAccountDetails(data.accList);
                        siNfsService.setNew.accDetails = {};
                        siNfsService.viewDetail = {};
                        siNfsService.myTab = 'Y';
                        $state.go('menu.siSelAccount');
                    }else{
                      utilityService.showBhimUpiAlert("alert","No Accounts Available","menu.homeScreen","Ok",$scope);
                    }
                }else{
                  utilityService.showBhimUpiAlert("alert","No Accounts Available","menu.homeScreen","Ok",$scope);
                }
              
              },function (error) {
                  utilityService.showBhimUpiAlert("alert",error.responseMessage,"menu.homeScreen","Ok",$scope);
              });
            }
          }, function (error) {
            utilityService.showBhimUpiAlert("alert",error.responseMessage,"menu.homeScreen","Ok",$scope);
          });
        }else {
        var errorText = "Sorry, you cannot access Standing Instruction services online. Please visit/contact your home branch.";
        utilityService.showBhimUpiAlert("alert",errorText,"menu.homeScreen","Ok",$scope);
      }
    }
    serviceRequestInnerVm.scheduledRequest = function () {
      $state.go('menu.scheduledRequests');
    };
    serviceRequestInnerVm.nextPage = function (xyz) {
      
      $state.go(xyz);
    };



    serviceRequestInnerVm.goToHome = function () {
      $state.go('menu.homeScreen');
    }

    serviceRequestInnerVm.goBacktoPrevious = function () {
      $state.go('menu.serviceRequest');
    }

    serviceRequestInnerVm.blockUnblock = function () {
      $state.go('menu.blockUnblock');
    }
    serviceRequestInnerVm.manageAtm = function () {
      $state.go('menu.manageAtm');
    }
    serviceRequestInnerVm.atmCardActivation = function () {
      $state.go('menu.atmCardActivation');
    }
    serviceRequestInnerVm.newDebitCard = function () {
      $state.go('menu.newDebitCard');
    }

    //actions to done everytime the view is shown
    $scope.$on('$ionicView.beforeEnter', function () {
      serviceRequestInnerVm.innerpageHeader = serviceRequestService.innerpageHeader;
      serviceRequestInnerVm.imageIcon=serviceRequestService.imageIcon;
      serviceRequestInnerVm.callCenterNo=serviceRequestService.callCenterNo;
    //  if(serviceRequestInnerVm.innerpageHeader!=null){
      serviceRequestInnerVm.serviceNameInnerURL = serviceRequestService.innerLinks;
    // }
    // else{
    //   $state.go('menu.serviceRequest');
     //}
    });

   
    return this;
  }
]);
