/**
 *   @ngdoc config
 *   @name angularApp.config : cardConfig
 *   @description
 *  configuration file for cards module
 */

/*This function defines all the constants named  Adapters url for cards module*/
angularApp
   

/*State defination with respective names, urls, controllers and templates */

.config([
    '$stateProvider',
    function($stateProvider) {

        //Cards start
        $stateProvider
            //Manage e-Statement starts from here
            .state('menu.manageEstmt', {
                url: '/manageEstmt',
                cache: false,
                data: {
                    pageId: 'NFS_MANAGE_ESTMT'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/serviceRequest/manageEstatement/manageEstmt.html',
                        controller: 'manageEstmtController',
                        controllerAs: 'manageEstmtVm',
                    }
                }
            })
                .state('menu.reviewDetails', {
                                    url: '/reviewDetails',
                                    cache: false,
                                    data: {
                                            pageId: 'NFS_REVIEW_ESTMT'
                                    },
                                    views: {
                                            'menuContent': {
                                                    templateUrl: 'pages/serviceRequest/manageEstatement/reviewDetails.html',
                                                    controller: 'reviewDetailsController',
                                                    controllerAs: 'reviewDetailsVm',
                                            }
                                    }
                            })
                .state('menu.manageEstmtOTP', {
                                    url: '/manageEstmtOTP',
                                    cache: false,
                                    data: {
                                            pageId: 'NFS_MANAGE_ESTMT_OTP'
                                    },
                                    views: {
                                        'menuContent': {
                                                    templateUrl: 'pages/serviceRequest/manageEstatement/manageEstatementOTP.html',
                                                    controller: 'manageEstatementOTPController',
                                                    controllerAs: 'manageEstatementOTPVm',
                                            }
                                    }
                            })
                .state('menu.manageEstmtSuccess', {
                                    url: '/manageEstmtSuccess',
                                    cache: false,
                                    data: {
                                            pageId: 'NFS_MANAGE_ESTMT_SUCCESS'
                                    },
                                    views: {
                                        'menuContent': {
                                                    templateUrl: 'pages/serviceRequest/manageEstatement/manageEstatementSuccess.html',
                                                    controller: 'manageEstatementSuccessController',
                                                    controllerAs: 'manageEstatementSuccessVm',
                                            }
                                    }
                            })
            //Manage e-Statement ends here

    }
]);
