'use strict';

angularApp.controller('manageEstatementOTPController', ["$timeout",
	"$state",
	"$ionicPopup",
	"$scope",
	"$filter",
	"$rootScope",
	"customerInfoService",
	"utilityService",
	"manageEstatementService",
	function ($timeout,
		$state, $ionicPopup,
		$scope,$filter,
		$rootScope,
		customerInfoService,
		utilityService,
		manageEstatementService
		) {

		//functions, variables that can be accessed from the HTML come here
		var manageEstatementOTPVm = this;

		

			function initPage(){
				manageEstatementOTPVm.otpCount = 0;
				manageEstatementOTPVm.clickCount = 0;
				manageEstatementOTPVm.isResendDisabled = false;
				manageEstatementOTPVm.mobileNumber = $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4);
			}

			manageEstatementOTPVm.goNext = function(){
				manageEstatementOTPVm.resetPinOTP = "";
				if(!manageEstatementOTPVm.otpNumber){
					manageEstatementOTPVm.resetPinOTP = "Please Enter the OTP";
				}else if(manageEstatementOTPVm.otpNumber.length != 6){
					manageEstatementOTPVm.resetPinOTP = "Please enter 6 digits OTP";
				}else{
					var request = {
						"otp" : manageEstatementOTPVm.otpNumber
					}
					manageEstatementService.validateOtp(request).then(function(data) {
						manageEstatementService.refNumber = "";
						if(manageEstatementService.checkRegOrDereg == 'register')
						{
							//call registration service
							var obj = {
										  "accountNumber": manageEstatementService.registerData.accountNumber,
										  "statementFrequency": manageEstatementService.registerData.frequency,
										  "cycle": manageEstatementService.registerData.month,
										  "day": manageEstatementService.registerData.day,
										  
									}
							manageEstatementService.doRegistration(obj).then(function(data) {
							
								console.log('register', data);
								manageEstatementService.refNumber = data.journelNumber;
								$state.go('menu.manageEstmtSuccess');
							
							
							},function(error){
								utilityService.showErrorMessage(error.responseMessage);
							});
						}
						else{
							//call deregister service
							var obj = {
										  "accountNumber": manageEstatementService.DeRegisterData.accountNumber,
										  "statementFrequency": 'N',
										  
									}
							manageEstatementService.doRegistration(obj).then(function(data) {
							
								console.log('deregister', data);
								manageEstatementService.refNumber = data.journelNumber;
								$state.go('menu.manageEstmtSuccess');
							
							
							},function(error){
								utilityService.showErrorMessage(error.responseMessage);
							});
						}
						
						
						
					},function(error){
						manageEstatementOTPVm.otpNumber = "";
						manageEstatementOTPVm.otpCount++;
						if(manageEstatementOTPVm.otpCount >= 3){
							var title = '';
							var template = error.responseMessage;
							var onTap = 'menu.homeScreen';
							var buttontext = "OK";
							//utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
							utilityService.showBhimUpiAlert('error', template, onTap, buttontext, $scope);
						}else{
							utilityService.showErrorMessage(error.responseMessage);
						}
					});
				}
			}

			manageEstatementOTPVm.resendOTP = function(){
				manageEstatementService.getOtp().then(function(data) {
					manageEstatementOTPVm.otpNumber = "";
					manageEstatementOTPVm.resetPinOTP = "";
					manageEstatementOTPVm.clickCount++;
					if(manageEstatementOTPVm.clickCount >= 2){
						manageEstatementOTPVm.isResendDisabled = true;
					}
					var title = '';
					var template = "OTP has been sent to your registered mobile number.";
					var onTap = '';
					var buttontext = "OK";
					//utilityService.showAlertModal('', template, onTap, $scope, $state, buttontext);
					utilityService.showBhimUpiAlert('success', template, onTap, buttontext, $scope);
				},function(error){
					manageEstatementOTPVm.otpNumber = "";
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			

			$scope.$on('$ionicView.beforeEnter', function() {
				initPage();
			});
			
			return this;
	}
]);
