'use strict';

angularApp.controller('reviewDetailsController', ["$state",
    "$ionicPopup",
    "$scope",
    "utilityService",
    "manageEstatementService",
    "ionicDatePicker",
    "$ionicHistory",
    "customerInfoService",
    "$ionicPopover",

    function($state,
        $ionicPopup,
        $scope,
        utilityService,
        manageEstatementService,
        ionicDatePicker,
        $ionicHistory,
        customerInfoService,
        $ionicPopover) {

        var reviewDetailsVm = this;

        reviewDetailsVm.goToHome = function() {
              $state.go('menu.innerPage');
        }
        reviewDetailsVm.goToBack = function() {
             $state.go('menu.manageEstmt');
        }
        reviewDetailsVm.goToNext = function() {
              manageEstatementService.getOtp().then(function (data) {
                manageEstatementService.checkRegOrDereg = 'register';
                    $state.go('menu.manageEstmtOTP');
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
        }




        /* Double Tab */
        reviewDetailsVm.selType = function(bookingCategory){
    			manageEstatementService.myTab = bookingCategory;
    			reviewDetailsVm.selTab = manageEstatementService.myTab;
    			if(bookingCategory == 'Y'){
    				reviewDetailsVm.classForMpinLoginOpt = 'tab-item tabs-style div-bottom e-stmt-bor-bot-active roboto-medium';
    				reviewDetailsVm.classForUserLoginOpt = 'tab-item tabs-style div-bottom';
    			}else{
    				reviewDetailsVm.classForMpinLoginOpt = 'tab-item tabs-style div-bottom';
    				reviewDetailsVm.classForUserLoginOpt = 'tab-item tabs-style div-bottom e-stmt-bor-bot-active roboto-medium';
                    $state.go('menu.manageEstmt');
    			}

    		}
        /* End of Double Tab */

        reviewDetailsVm.eyesOffFun = function (mask){
            if(mask =="account"){
                    reviewDetailsVm.accountNumber = manageEstatementService.registerData.accountNumber;
                    reviewDetailsVm.AccountCloseEye = true;
                    reviewDetailsVm.AccountOpenEye = false;
            }else if(mask =="email"){
                        reviewDetailsVm.email = manageEstatementService.custEmail;
                        reviewDetailsVm.emailCloseEye = true;
                        reviewDetailsVm.emailOpenEye = false;
            }
        }

        reviewDetailsVm.eyesOnFun = function (mask){
                if(mask =="account"){
                    var obj = {
                              "keyType": "eStmtKeyTypeAccount",
                              "debitAccount": reviewDetailsVm.accountNumber,
                              
                            }
                    manageEstatementService.getUnmaskData(obj).then(function (data) {
                        console.log('account unmask data', data)
                            reviewDetailsVm.accountNumber = data;
                            reviewDetailsVm.AccountCloseEye = false;
                            reviewDetailsVm.AccountOpenEye = true;
                        }, function (error) {
                            utilityService.showErrorMessage(error.responseMessage);
                    });
                    
                }else if(mask =="email"){
                            var obj = {
                              "keyType": "eStmtKeyTypeEmail",
                              "emailId": reviewDetailsVm.email
                            }
                    manageEstatementService.getUnmaskData(obj).then(function (data) {
                        console.log('email unmask data', data);
                        reviewDetailsVm.email = data;
                        reviewDetailsVm.emailCloseEye = false;
                        reviewDetailsVm.emailOpenEye = true;
                            
                        }, function (error) {
                            utilityService.showErrorMessage(error.responseMessage);
                    });
                    
                    
                }
        }

      $scope.$on('$ionicView.beforeEnter', function () {
        reviewDetailsVm.AccountCloseEye = true;
            reviewDetailsVm.emailCloseEye = true;
  			reviewDetailsVm.classForMpinLoginOpt = 'tab-item tabs-style div-bottom e-stmt-bor-bot-active roboto-medium';
  			reviewDetailsVm.classForUserLoginOpt = 'tab-item tabs-style div-bottom';
  			// reviewDetailsVm.selTab = manageEstmtService.myTab ;
  			 reviewDetailsVm.selType('Y');
         console.log(customerInfoService.customer);
         reviewDetailsVm.email = manageEstatementService.custEmail;
         //reviewDetailsVm.email = customerInfoService.customer.emailID;
         reviewDetailsVm.name  = customerInfoService.customer.name;
         reviewDetailsVm.accountNumber  = manageEstatementService.registerData.accountNumber;
         reviewDetailsVm.frequency  = manageEstatementService.registerData.frequency;
         reviewDetailsVm.frequencyText = '';
         if(reviewDetailsVm.frequency == 'D')
         {
            reviewDetailsVm.frequencyText = 'Daily';
         }
         else if(reviewDetailsVm.frequency == 'W')
         {
            reviewDetailsVm.frequencyText = 'Weekly';
         }
         else if(reviewDetailsVm.frequency == 'F')
         {
            reviewDetailsVm.frequencyText = 'Fortnightly';
         }
         else if(reviewDetailsVm.frequency == 'M')
         {
            reviewDetailsVm.frequencyText = 'Monthly';
         }
         else if(reviewDetailsVm.frequency == 'Q')
         {
            reviewDetailsVm.frequencyText = 'Quaterly';
         }
         else if(reviewDetailsVm.frequency == 'Y')
         {
            reviewDetailsVm.frequencyText = 'Yearly';
         }
         else if(reviewDetailsVm.frequency == 'H')
         {
            reviewDetailsVm.frequencyText = 'Half Yearly';
         }
         else{
            reviewDetailsVm.frequencyText = reviewDetailsVm.frequency;
         }
         reviewDetailsVm.month  = manageEstatementService.registerData.month;
         reviewDetailsVm.day  = manageEstatementService.registerData.day;
      });
        return this;
    }
]);
