'use strict';

angularApp.controller('profilePasswordController', [
	"$state",
	"$scope",
	"$ionicHistory",
	"emaillDetailsService",
	"serviceRequestService",
	"fgtProfilePwdService",
	"inbForgotPwdService",
	"inbResetPwdService",
	"cameraService",
	"fTBeneficiaryService",
	"utilityService",
	"constantConfig",
	"validationService",
	"$ionicPopup",
	"fTSetOTPService",
	"loggedInUserService",
	"$rootScope",

	"fTReviewService",
	"cryptoService",

	function (
		$state,
		$scope,
		$ionicHistory,
		emaillDetailsService,
		serviceRequestService,
		fgtProfilePwdService,
		inbForgotPwdService,
		inbResetPwdService,
		cameraService,
		fTBeneficiaryService,
		utilityService,
		constantConfig,
		validationService,
		$ionicPopup, fTSetOTPService, loggedInUserService, $rootScope, fTReviewService, cryptoService) {

		var profilePasswordVm = this;

		//var loggedInUserDetails = loggedInUserService.getUserProfileDetails();
		profilePasswordVm.isTextReadable = false;
	 	profilePasswordVm.isTextReadablereEnter = false;
		profilePasswordVm.userMobileNo = $rootScope.mobileNo;
		profilePasswordVm.isOtpFieldEmpty = false;

		/* Page navigates back to Funds Transfer */
		profilePasswordVm.goBack = function () {
			$state.go('menu.serviceRequest');
		};

		profilePasswordVm.forgotPass = function () {
			$state.go('menu.forgotProfilePwd');
		};

		profilePasswordVm.goToHome = function () {

			//$state.go('menu.homeScreen');
			  $ionicHistory.goBack();
		}

		profilePasswordVm.forgotpassPopup = function () {
			var havingMPINPrblmPopUp = $ionicPopup.show({
				template: "<p> If you have forgotton your profile password, you can reset the same yourself. You need to  authenticate yourself either with the hint question and answer that you had set for the Profile password or ATM Card details & PIN. You can approach branch in case you don't remember Hint Question/answer or ATM card details & PIN </p>",
				title: '',
				cssClass: 'dialog',
				scope: $scope,
				buttons: [{
					text: 'OK',
					type: 'button-positive'
				}]
			});
		};

		profilePasswordVm.profilePopup = function () {
			profilePasswordVm.myPopup = $ionicPopup.show({
				title: '',
				cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
				templateUrl: 'pages/serviceRequest/pwdPopup.html',
				scope: $scope
			});
		}

		profilePasswordVm.ok = function () {
			profilePasswordVm.myPopup.close();
		};



		profilePasswordVm.validateProfilePwd = function () {
			var loggedInUserDetails = loggedInUserService.getUserProfileDetails();
			if (profilePasswordVm.newProfilePassword) {
				fTReviewService.getProfilePassAndSerKey().then(function (response) {
					var options = {
                        inbUserName:loggedInUserDetails.inbUsername,
                        strPass:profilePasswordVm.newProfilePassword,
                        keyId:response.keyId,
                        serviceId:response.serviceId,
                        osName:device.platform,
                        type:fgtProfilePwdService.type
                    };
                    var reqParams = utilityService.commonRequestForValidateProfilePass(options);

					if (emaillDetailsService.emailupdate) {

						fTReviewService.getProfilePassAuth(reqParams).then(function (data) {
							$state.go("menu.emailUpdate");
							/*var hashEmail = loggedInUserService.tokenLotus + emaillDetailsService.emailId;
							var emailSHA512 = cryptoService.getSHA512EncryptedData(hashEmail).toString();
							console.log(emailSHA512);
							var requestData = {
								"emailId": emaillDetailsService.emailId,
								"hash": emailSHA512
							}

							emaillDetailsService.update(requestData).then(function (data) {

								console.log(JSON.stringify(data));
								profilePasswordVm.emailupdate = emaillDetailsService.emailupdate;

								if (emaillDetailsService.emailupdate) {
									utilityService.setCsatJournies('updateEmail');
								} else {
									utilityService.setCsatJournies('updateAddress');
								}
								//emailUpdateOtpVm.referenceNumber = data.referenceNumber;
								profilePasswordVm.myPopup = $ionicPopup.show({

									title: '',
									cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
									templateUrl: 'pages/nfs/emailUpdate/Congratulations.html',
									scope: $scope,
									buttons: [{
										text: 'OK',
										type: 'button-assertive',
										onTap: function (e) {
											emaillDetailsService.clearAllData();
											$state.go('menu.homeScreen');

										}
									}

									]
								});


							}, function (error) {
								utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
							
							});*/
							



						}, function (error) {
							//utilityService.showErrorMessage(error.responseMessage);
							if (error.responseCode == "INB.AUTH.016") {
								profilePasswordVm.myPopup = $ionicPopup.show({
									title: '',
									cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
									templateUrl: 'pages/nfs/inbResetPassword/passwordUnblockPopUp.html',
									scope: $scope
								})
							} else {
								utilityService.showErrorMessage(error.responseMessage);
							}

						});




					}
					// PAN changes start
					else if (emaillDetailsService.panUpdate) {
						fTReviewService.getProfilePassAuth(reqParams).then(function (data) {
							var hashEmail = loggedInUserService.tokenLotus + emaillDetailsService.pan.toUpperCase();
							var emailSHA512 = cryptoService.getSHA512EncryptedData(hashEmail).toString();
							console.log(emailSHA512);
							var requestData = {
								"pan": emaillDetailsService.pan.toUpperCase(),
								"hash": emailSHA512
							}
							emaillDetailsService.updatePAN(requestData).then(function (data) {
							console.log(JSON.stringify(data.panUpdateResponse.statusDesc));

                             var panUpdatePopup = $ionicPopup.show({
                                                    template: '<img src="img/mf/bg-approved.svg" alt="Success Screen"><p>'+data.panUpdateResponse.statusDesc+'</p>',
                                                    title: '',
                                                    cssClass: 'dialog',
                                                    scope: $scope,
                                                    buttons: [{
                                                        text: 'OK',
                                                        type: 'button-positive',
                                                        onTap: function(e) {
											            emaillDetailsService.clearAllData();
            								            utilityService.setCsatJournies('AddUpdatePAN');
											            $state.go('menu.homeScreen');
                                                        }
                                                    }]
                                                });
							}, function (error) {
                               utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
							});
						}, function (error) {
							if (error.responseCode == "INB.AUTH.016") {
								profilePasswordVm.myPopup = $ionicPopup.show({
									title: '',
									cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
									templateUrl: 'pages/nfs/inbResetPassword/passwordUnblockPopUp.html',
									scope: $scope
								})
							} else {
								utilityService.showErrorMessage(error.responseMessage);
							}
							//utilityService.showErrorMessage(error.responseMessage);
						});
					}
					// PAN changes end
					else if (fgtProfilePwdService.settingPage == true) {

						inbResetPwdService.validateProfilePasswordSecure(reqParams).then(function (data) {
							$state.go('menu.resetProfilePwd');

						}, function (error) {
										if(error.responseCode=="INB.AUTH.016"){
						     profilePasswordVm.myPopup = $ionicPopup.show({
							title: '',
							cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
							templateUrl: 'pages/nfs/inbResetPassword/passwordUnblockPopUp.html',
							scope: $scope
						})
					}else{
						utilityService.showErrorMessage(error.responseMessage);
					}
						});

					} else if (inbForgotPwdService.resetPage) {

						fTReviewService.getProfilePassAuth(reqParams).then(function (response) {
							console.log(JSON.stringify(response));

							$state.go('menu.resetPassword');

						}, function (error) {
							//utilityService.showErrorMessage(error.responseMessage);
										if(error.responseCode=="INB.AUTH.016"){
						     profilePasswordVm.myPopup = $ionicPopup.show({
							title: '',
							cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
							templateUrl: 'pages/nfs/inbResetPassword/passwordUnblockPopUp.html',
							scope: $scope
						})
					}else{
						utilityService.showErrorMessage(error.responseMessage);
					}
						});

					}
					else {

						fTReviewService.getProfilePassAuth(reqParams).then(function (data) {

							/*var url = serviceRequestService.innerURL;
							console.log('URL ::: ' + url);
							serviceRequestService.getMenuOptionTypes(url).then(function (data) {
								serviceRequestService.serviceNameInnerURL = data.getLinks;
								console.log(JSON.stringify(data));
								$state.go('menu.innerPage');

							}, function (err) {
								utilityService.showErrorMessage(err.responseMessage);
							});*/
							$state.go('menu.innerPage');






						}, function (error) {
							//utilityService.showErrorMessage(error.responseMessage);
								if (error.responseCode == "INB.AUTH.016") {
								profilePasswordVm.myPopup = $ionicPopup.show({
									title: '',
									cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
									templateUrl: 'pages/nfs/inbResetPassword/passwordUnblockPopUp.html',
									scope: $scope
								})
							} else {
								utilityService.showErrorMessage(error.responseMessage);
							}

						});

					}



				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			} else {
				utilityService.showErrorMessage('Please enter your Internet Banking Profile Password.')
			}
		};

		// profilePasswordVm.profileEye = function () {
		// 	profilePasswordVm.isTextReadable == true ? profilePasswordVm.isTextReadable = false : profilePasswordVm.isTextReadable = true;
		// };

  	profilePasswordVm.unblockProfilePass = function(){
		       profilePasswordVm.myPopup.close();
				$state.go('menu.forgotProfilePwd');
				
		}
		profilePasswordVm.cancel = function(){
			 profilePasswordVm.myPopup.close();
			$state.go('menu.homeScreen');
		}

		
        	profilePasswordVm.toggleSecretAns = function () {
			profilePasswordVm.isTextReadable == true ? profilePasswordVm.isTextReadable = false : profilePasswordVm.isTextReadable = true;
		};
		profilePasswordVm.toggleReEnter = function () {
			profilePasswordVm.isTextReadablereEnter == true ? profilePasswordVm.isTextReadablereEnter = false : profilePasswordVm.isTextReadablereEnter = true;
		};


		return this;
	}
]);
