'use strict';
angularApp.controller('scheduledRequestsController', ["$timeout",
	"$state",
	"$location",
	"$scope",
	"$rootScope",
	"utilityService",
	"$ionicPopup",
	"serviceRequestService",
	function ($timeout,
		$state,
		$location,
		$scope,
		$rootScope,
		utilityService,
		$ionicPopup,
		serviceRequestService) {
		var scheduledRequestVm = this;

		function initPage() {
			scheduledRequestVm.getServiceRequest();
		};

		scheduledRequestVm.getServiceRequest = function () {
			scheduledRequestVm.spinner = true;
			serviceRequestService.getServiceRequest().then(function (response) {
				scheduledRequestVm.serviceDetailResponses = response.serviceDetailResponses;
				scheduledRequestVm.spinner = false;
				scheduledRequestVm.serviceReqFail = false;
			}, function (error) {
				scheduledRequestVm.spinner = false;
				scheduledRequestVm.serviceReqFail = true;
				//   utilityService.showErrorMessage(error.responseMessage);
			});
		}

		scheduledRequestVm.getRequestDetail = function (module, storeRefNumber) {
			serviceRequestService.getRequestDetail(storeRefNumber).then(function (response) {
				serviceRequestService.getRequestDetailData = response;
				if (module === "FixedDeposit" || (serviceRequestService.getRequestDetailData.serviceDetail.action === "FDCreation" && module === "myDreams")) {
					serviceRequestService.module_LBL = "Fixed Deposit Requested Details";
					serviceRequestService.name_LBL = "Reference Number";
					serviceRequestService.storeRefNumber = storeRefNumber;
					serviceRequestService.amount_LBL = "Amount";
					serviceRequestService.amount_Value = "&#8377;&nbsp;" + serviceRequestService.getRequestDetailData.serviceDetail.amount;
					serviceRequestService.roi_LBL = "Rate of Interest";
					serviceRequestService.roi_Value = serviceRequestService.getRequestDetailData.serviceDetail.interestRate;
					$state.go('menu.scheduledFdDetails');
				} else if (module === "GoalBasedSavings") {
					serviceRequestService.module_LBL = "My Dreams Requested Details";
					serviceRequestService.name_LBL = "Dream Name";
					serviceRequestService.storeRefNumber = serviceRequestService.getRequestDetailData.serviceDetail.dreamName;
					serviceRequestService.amount_LBL = "Goal Amount";
					serviceRequestService.amount_Value = "&#8377;&nbsp;" + serviceRequestService.getRequestDetailData.serviceDetail.totalAmount;
					serviceRequestService.roi_LBL = "";
					serviceRequestService.roi_Value = "";
					$state.go('menu.scheduledFdDetails');
				} else if (module === "OD") {
					serviceRequestService.module_LBL = "Over Draft Requested Details";
					serviceRequestService.name_LBL = "OD Limit";
					serviceRequestService.storeRefNumber = "&#8377;&nbsp;" + serviceRequestService.getRequestDetailData.serviceDetail.odLimit;
					serviceRequestService.amount_LBL = "Expiry Date";
					var odExpiryDay = serviceRequestService.getRequestDetailData.serviceDetail.odExpiryDate.substring(0, 2);
					var odExpiryMonth = serviceRequestService.getRequestDetailData.serviceDetail.odExpiryDate.substring(2, 4);
					var odExpiryYear = serviceRequestService.getRequestDetailData.serviceDetail.odExpiryDate.substring(4, 8);
					serviceRequestService.amount_Value = odExpiryDay + "-" + odExpiryMonth + "-" + odExpiryYear;
					serviceRequestService.roi_LBL = "Rate of Interest";
					serviceRequestService.roi_Value = serviceRequestService.getRequestDetailData.serviceDetail.odInterestRate;
					$state.go('menu.scheduledFdDetails');
				} else if (module === "PreApprovedLoan") {
					serviceRequestService.module_LBL = "PAPL Requested Details";
					serviceRequestService.name_LBL = "Reference Number";
					serviceRequestService.storeRefNumber = storeRefNumber;
					serviceRequestService.amount_LBL = "Amount";
					serviceRequestService.amount_Value = "&#8377;&nbsp;" + serviceRequestService.getRequestDetailData.serviceDetail.amount;
					$state.go('menu.scheduledFdDetails');
				} else if(module=="issueDebitCard") {
					$state.go("menu.scheduledNewDebitCard");
				} else if(module === "eRD" || (serviceRequestService.getRequestDetailData.serviceDetail.action === "RDCreation" && module === "myDreams")) {
					$state.go("menu.scheduledRDDetails");
				} else if (module === "IHL") {
					$state.go('menu.scheduledIHLDetails');
				} else if (module === "pa2wl") {
					serviceRequestService.module_LBL = "PA2WL Requested Details";
					serviceRequestService.name_LBL = "Reference Number";
					serviceRequestService.storeRefNumber = storeRefNumber;
					serviceRequestService.amount_LBL = "Amount";
					serviceRequestService.amount_Value = "&#8377;&nbsp;" + serviceRequestService.getRequestDetailData.serviceDetail.loanDetails.loanAmount;
					serviceRequestService.roi_LBL = "Rate of Interest";
					serviceRequestService.roi_Value = serviceRequestService.getRequestDetailData.serviceDetail.loanDetails.interestRate;
					$state.go('menu.scheduledFdDetails');
				}
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		};

		scheduledRequestVm.scheduledfdDetails = function (module, storeRefNumber) {
			scheduledRequestVm.getRequestDetail(module, storeRefNumber);
		};

		scheduledRequestVm.goBacktoPrevious = function () {
			serviceRequestService.getRequestDetailData = "";
			$state.go('menu.innerPage');
		}

		//actions to done everytime the view is shown
		$scope.$on('$ionicView.beforeEnter', function () {
			scheduledRequestVm.spinner = true;
			scheduledRequestVm.serviceReqFail = false;
			initPage();
		});
		return this;
	}
]);
