'use strict';

angularApp.controller('tdsEnquiryController', ["$timeout",
    "$state",
    "$location",
    "$scope",
    "$rootScope",
    "customerInfoService",
    "utilityService",
    "$ionicPopup", "serviceRequestService", "AdapterUtils", "$q", "openUrlInAppbroswerService", "pdfDownloadService","constantConfig",

    function($timeout,
        $state,
        $location,
        $scope,
        $rootScope,
        customerInfoService,
        utilityService,
        $ionicPopup, serviceRequestService, AdapterUtils, $q, openUrlInAppbroswerService,pdfDownloadService, constantConfig) {

        var tdsEnquiryVm = this;
        //functions, variables that can be accessed from the HTML template

        tdsEnquiryVm.goToback = function() {
            $state.go('menu.serviceRequest');
        }

        tdsEnquiryVm.getFinYear = function() {
            serviceRequestService.getFinYears().then(function(data) {
                tdsEnquiryVm.listOfResponse = data;
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        tdsEnquiryVm.submitTDSDetails = function(selectedYear) {
            var q = $q.defer();
			tdsEnquiryVm.taxYear  = selectedYear;
            var request = { "taxYear": tdsEnquiryVm.taxYear, "getChoice": "enquiry" }

            serviceRequestService.getTDSDetails(request).then(function(res) {
                var backPopup = $ionicPopup.show({
                    title: null,
                    cssClass: 'my-custom-popup',
                    template: '<div class="button_fund fontSize-subHeading roboto-light font-dark-grey" translate="TDS_DOC_MSG"></div>',
                    buttons: [{
                            text: 'Email',
                            type: 'button-assertive',
                            onTap: function() {
                                var request = { "taxYear": tdsEnquiryVm.taxYear, "getChoice": "email" }
                                serviceRequestService.getTDSDetails(request).then(function(res) {
                                    tdsEnquiryVm.emailPopup = $ionicPopup.show({
                                        template: '<p>TDS certificate has been sent to your registered Email Id.</p>',
                                        title: '',
                                        scope: $scope,
                                        cssClass: 'my-custom-popup',
                                        buttons: [{
                                            text: 'OK',
                                            type: 'button-assertive',
                                            onTap: function() {
                                                tdsEnquiryVm.emailPopup.close();
                                                utilityService.setCsatJournies('tdsEnquiry');
                                                $state.go('menu.serviceRequest');
                                            }
                                        }],
                                    });

                                }, function(error) {
                                    utilityService.showNfsAlertModal("", error.responseMessage, "menu.serviceRequest", $scope, $state, "OK");
                                });
                            }
                        },
                        {
                            text: 'Download',
                            type: 'button-assertive',
                            onTap: function() {
                                var request = { "taxYear": tdsEnquiryVm.taxYear, "getChoice": "download" }
                                serviceRequestService.getTDSDetails(request).then(function(res) {
                                    tdsEnquiryVm.receiptDownload(res);
                                }, function(error) {
                                    utilityService.showNfsAlertModal("", error.responseMessage, "menu.serviceRequest", $scope, $state, "OK");
                                });
                            }
                        }
                    ],
                });
            }, function(error) {
                var noRecPopup = $ionicPopup.show({
									template: '<img src="img/Info-icon.svg" alt="Success Screen"><p></p><p>' + error.responseMessage + '</p>',
									title: '',
									cssClass: 'dialog',
									scope: $scope,
									buttons: [{
										text: 'OK',
										type: 'button-positive',
										onTap: function () {
											$state.go('menu.serviceRequest');
										}
									}]
								});
            });
        }

        // Download receipt code begin

        tdsEnquiryVm.receiptDownload = function(res) {
            var content = res.pdf;
            var filename = res.fileName + '.pdf';;

             pdfDownloadService.savePDF(filename, content, "").then(function(response){
                tdsEnquiryVm.folderpath = response.folderpath ? response.folderpath : "";
				if (utilityService.isAndroidPlatform()) {
                var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="DOWNLOADFDRECEIPT" translate-values="{folderpath:tdsEnquiryVm.folderpath}"></div>';
                tdsEnquiryVm.downloadPopup = $ionicPopup.show({
                    title: '',
                    template: template,
                    scope: $scope,
                    cssClass: 'my-custom-popup',
                    buttons: [{
                        text: 'OK',
                        type: 'button-assertive',
                        onTap: function() {
                            tdsEnquiryVm.downloadPopup.close();
                            utilityService.setCsatJournies('tdsEnquiry');
                            $state.go('menu.serviceRequest');
                        }
                    }],
                });
              }
             else
                { 
                    cordova.plugins.fileOpener2.open(
								cordova.file.documentsDirectory + filename,
								'application/pdf', {
								error: function (e) {
									console.log('Error status: ' + e.status + ' - Error message: ' + e.message);
								},
								success: function () {
									console.log('file opened successfully');
								}
							});
                              utilityService.setCsatJournies('tdsEnquiry');
                              $state.go('menu.serviceRequest');
                   }	
					},function error(e){
						utilityService.showErrorMessage(e);
					});
             }   

        // Download receipt code ends
       

        /*** Function to go to Back to Account overview Page  ***/
        tdsEnquiryVm.goToHome = function() {
            $state.go('menu.homeScreen');
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            //load financial years
            tdsEnquiryVm.getFinYear();
        });
        return this;
    }
]);
