'use strict';

angularApp.controller('updateKYCProfilePasswordController',
    ["$timeout",
        "$state",
        "$scope",
        "$translate",
        "$ionicPopup",
        "utilityService",
        "$ionicHistory",
        "loggedInUserService",
        "fTReviewService",
        "constantConfig",
        "updateKYCService",
        "fgtProfilePwdService",
        function ($timeout,
            $state,
            $scope,
            $translate,
            $ionicPopup,
            utilityService,
            $ionicHistory,
            loggedInUserService,
            fTReviewService,
            constantConfig,
            updateKYCService,
            fgtProfilePwdService
        ) {

            var updateKYCProfPassVm = this;
            updateKYCProfPassVm.isTextReadable = false;
            updateKYCProfPassVm.showProfilePasswordError = false;

            updateKYCProfPassVm.goToPrevious = function () {
                $ionicHistory.goBack();
            }

            updateKYCProfPassVm.toggleSecretAns = function () {
                if(updateKYCProfPassVm.isTextReadable){
                    updateKYCProfPassVm.isTextReadable = false
                }
                else{
                    updateKYCProfPassVm.isTextReadable = true
                }
                
            };

            updateKYCProfPassVm.forgotPass = function () {
                $state.go('menu.forgotProfilePwd');
            }

            updateKYCProfPassVm.validateProfilePwd = function () {
                var loggedInUserDetails = loggedInUserService.getUserProfileDetails();
                if (updateKYCProfPassVm.newProfilePassword) {
                    fTReviewService.getProfilePassAndSerKey().then(function (response) {
                        var options = {
                            inbUserName: loggedInUserDetails.inbUsername,
                            strPass: updateKYCProfPassVm.newProfilePassword,
                            keyId: response.keyId,
                            serviceId: response.serviceId,
                            osName: device.platform,
                            type: fgtProfilePwdService.type
                        };
                        var reqParams = utilityService.commonRequestForValidateProfilePass(options);

                        fTReviewService.getProfilePassAuth(reqParams).then(function (data) {
                            updateKYCService.getCustomerDetails().then(function (data) {
                                updateKYCService.customerDetails = data;
                                $state.go("menu.updateKYCPersonalDetails")
                            }, function (error) {
                                utilityService.showErrorMessage(error.responseMessage);
                            });
                        }, function (error) {
                            if (error.responseCode == "INB.AUTH.016") {
                                updateKYCProfPassVm.myPopup = $ionicPopup.show({
                                    title: '',
                                    cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
                                    templateUrl: 'pages/nfs/inbResetPassword/passwordUnblockPopUp.html',
                                    scope: $scope
                                })
                            } else {
                                utilityService.showErrorMessage(error.responseMessage);
                            }
                        });
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                } else {
                    utilityService.showErrorMessage('Please enter your Internet Banking Profile Password.')
                }
            }

            updateKYCProfPassVm.forgotpassPopup = function () {
                $ionicPopup.show({
                    template: "<p> If you have forgotton your profile password, you can reset the same yourself. You need to  authenticate yourself either with the hint question and answer that you had set for the Profile password or ATM Card details & PIN. You can approach branch in case you don't remember Hint Question/answer or ATM card details & PIN </p>",
                    title: '',
                    cssClass: 'dialog',
                    scope: $scope,
                    buttons: [{
                        text: 'OK',
                        type: 'button-positive'
                    }]
                });
            };

            return this;
        }]);
