'use strict';

angularApp.service('updateKYCService',
    function ($q, AdapterUtils, $ionicPopup, $state) {

        var updateKYCService = this;

        updateKYCService.checkEligibilityKYC = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/ServiceRequestAdapter/checkEligibilityStatus", {}, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        updateKYCService.getCustomerDetails = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/ServiceRequestAdapter/getCustomerDetails", {}, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        updateKYCService.withoutAddressUpdate = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/ServiceRequestAdapter/kycWithoutAddressUpdate", {}, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        updateKYCService.validateOtpSecure = function (payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/OTPAdapter/validateOTPTokenSecure", payLoad, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        updateKYCService.getOtpSecure = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/OTPAdapter/getOTPTokenSecure", {}, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        updateKYCService.showAlertPopup = function (imageType, message1, message2, message3, onTapgo, buttontext1, buttontext2, $scope, obj) {
            var btn_array = [];
            var showReason1 = message2 ? true : false
            var showReason2 = message3 ? true : false
            if (buttontext1 != "" && buttontext2 != "") {
                btn_array = [
                    {
                        text: buttontext2 || "Cancel",
                        type: 'button-negative'
                       
                    },
                    {
                        text: buttontext1 || "OK",
                        type: 'button-positive',
                        onTap: function () {
                            if (onTapgo) {
                                $state.go(onTapgo);
                            }
                        }
                    }
                ];
            }
            else {
                btn_array = [
                    {
                        text: buttontext1 || "OK",
                        type: 'button-positive',
                        onTap: function () {
                            if (onTapgo) {
                                $state.go(onTapgo);
                            }
                        }
                    }
                ];
            }

            if (imageType && imageType.toLowerCase() == 'error') {
                imageType = '<div class="align-center"><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/errorSymbol.svg"/></div>';
            } else if (imageType && imageType.toLowerCase() == 'success') {
                imageType = '<div class="align-center"><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/successSymbol.svg"/></div>';
            } else if (imageType && imageType.toLowerCase() == 'alert') {
                imageType = '<div class="align-center"><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/alertSymbol.svg"/></div>';
            } else {
                imageType = "";
            }
            var bhimErrorPopup = $ionicPopup.alert({
                template: imageType + '<div class="popupMsgPadding"><div class="align-center roboto-medium font-size-16 color-54">'
                + message1 + '</div><div ng-if="' + showReason1 + '" class="reason-list roboto-regular font-size-14 color-74 padTop10"><ul><li ng-if="' + showReason1 + '" >' + message2 + '</li><li class="pad-top-8" ng-if="' + showReason2 + '">' + message3 + '</li></ul></div></div>',
                scope: $scope,
                cssClass: 'bhim-alert-popup kyc-popup',
                buttons: btn_array,
            });
            bhimErrorPopup.then(function (res) {
                console.log('show alert popup');
            });
        };


        updateKYCService.showAlertPopupWithCallback = function (imageType, message1, message2, message3, buttontext1, buttontext2, $scope, button1, button2) {
            if (imageType && imageType.toLowerCase() == 'error') {
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/errorSymbol.svg"/></div>';
            } else if (imageType && imageType.toLowerCase() == 'success') {
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/successSymbol.svg"/></div>';
            } else if (imageType && imageType.toLowerCase() == 'alert') {
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/alertSymbol.svg"/></div>';
            } else {
                imageType = "";
            }
            var rtxcPopUp = $ionicPopup.alert({
                template: '<div class="font-dark-grey">' + imageType + '<div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter roboto-medium font-size-16 color-darkgrey"><span>'
                + message1 + '</span><div  class="textAlignCenter roboto-regular font-size-14 color-darkgrey padTop10">' + message2 + '</div><div  class="textAlignCenter roboto-bold font-size-14 color-darkgrey padTop10">' + message3 + '</div></div></div></div>', //template,
                scope: $scope,
                cssClass: 'bhim-alert-popup',
                buttons: [
                    {
                        text: buttontext2 || "Cancel",
                        type: 'button-negative',
                        onTap: function () {
                            button1()
                        }
                    },
                    {
                        text: buttontext1 || "OK",
                        type: 'button-positive',
                        onTap: function () {
                            button2()
                        }
                    }
                ]
            });
            rtxcPopUp.then(function (res) {
                 console.log('show alert popup');
            });
        };


        updateKYCService.showTncAlertPopup = function (content) {
            var test = '<div>'
                + content +
                '<div class="rtxcTnC"> <button class="rxtcTnC_button" ng-click = "closePopup()" >OK</button></div></div>';
            var bhimErrorPopup = $ionicPopup.show({
                template: test,
                title: 'Terms & Conditions',
                cssClass: 'bhim-alert-popup hlTermnCondition',
            });
            bhimErrorPopup.then(function (res) {
                console.log("hii tabbed", res)
                
            });

        };

        return updateKYCService;

    });