'use strict';

angularApp.controller('updateKYCVerifyOtpController',
    ["$timeout",
        "$state",
        "$scope",
        "$translate",
        "$ionicPopup",
        "utilityService",
        "$ionicHistory",
        "loggedInUserService",
        "fTReviewService",
        "constantConfig",
        "updateKYCService",
        "customerInfoService",
        function ($timeout,
            $state,
            $scope,
            $translate,
            $ionicPopup,
            utilityService,
            $ionicHistory,
            loggedInUserService,
            fTReviewService,
            constantConfig,
            updateKYCService,
            customerInfoService
        ) {

            var updateKYCVerifyOtpVm = this;

            function initPage() {
                updateKYCVerifyOtpVm.otpCount = 0;
                updateKYCVerifyOtpVm.clickCount = 0;
                updateKYCVerifyOtpVm.isResendDisabled = false;
                updateKYCVerifyOtpVm.mobileNumber = customerInfoService.customerInfo.mobile;
            }

            updateKYCVerifyOtpVm.goToPrevious = function () {
                $ionicHistory.goBack();
            }

            updateKYCVerifyOtpVm.goToNextPage = function () {
                updateKYCVerifyOtpVm.resetPinOTP = "";
                if (!updateKYCVerifyOtpVm.otpNumber) {
                    updateKYCVerifyOtpVm.resetPinOTP = "Please Enter the OTP";
                } else if (updateKYCVerifyOtpVm.otpNumber.length != 6) {
                    updateKYCVerifyOtpVm.resetPinOTP = "Please enter 6 digits OTP";
                } else {
                    var request = {
                        "otp": updateKYCVerifyOtpVm.otpNumber
                    }
                    updateKYCService.validateOtpSecure(request).then(function (data) {
                        updateKYCService.withoutAddressUpdate().then(function (data) {
                            $state.go("menu.updateKYCSuccess")
                        }, function (error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });

                    }, function (error) {
                        updateKYCVerifyOtpVm.otpNumber = "";
                        updateKYCVerifyOtpVm.otpCount++;
                        if (updateKYCVerifyOtpVm.otpCount >= 3) {
                            var template = error.responseMessage;
                            var onTap = '';
                            var buttontext = "OK";
                            utilityService.showBhimUpiAlert('error', template, onTap, buttontext, $scope);
                        } else {
                            utilityService.showErrorMessage(error.responseMessage);
                        }
                    });
                }
            }

            updateKYCVerifyOtpVm.resendOTP = function () {
                updateKYCService.getOtpSecure().then(function (data) {
                    updateKYCVerifyOtpVm.otpNumber = "";
                    updateKYCVerifyOtpVm.resetPinOTP = "";
                    updateKYCVerifyOtpVm.clickCount++;
                    if (updateKYCVerifyOtpVm.clickCount >= 2) {
                        updateKYCVerifyOtpVm.isResendDisabled = true;
                    }
                    var template = "OTP has been sent to your registered mobile number.";
                    var onTap = '';
                    var buttontext = "OK";
                    utilityService.showBhimUpiAlert('success', template, onTap, buttontext, $scope);
                }, function (error) {
                    updateKYCVerifyOtpVm.otpNumber = "";
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }

            $scope.$on('$ionicView.beforeEnter', function () {
                initPage();
            });

            return this;
        }]);
