/**
 *   @ngdoc config
 *   @name angularApp.config : cardConfig
 *   @description
 *  configuration file for cards module
 */

/*This function defines all the constants named  Adapters url for cards module*/
angularApp
        /*State defination with respective names, urls, controllers and templates */

        .config([
                '$stateProvider',
                function ($stateProvider) {

                        //Cards start
                        $stateProvider
                                //Manage e-Statement starts from here
                                .state('menu.updateKYCProfilePassword', {
                                        url: '/updateKYCProfilePassword',
                                        cache: false,
                                        data: {
                                                pageId: 'UPDATE_KYC_PROFILE_PASSWORD'
                                        },
                                        views: {
                                                'menuContent': {
                                                        templateUrl: 'pages/serviceRequest/updateKYC/updateKYCProfilePassword.html',
                                                        controller: 'updateKYCProfilePasswordController',
                                                        controllerAs: 'updateKYCProfPassVm',
                                                }
                                        }
                                })
                                .state('menu.updateKYCPersonalDetails', {
                                        url: '/updateKYCPersonalDetails',
                                        cache: false,
                                        data: {
                                                pageId: 'UPDATE_KYC_PERSONAL_DTLS'
                                        },
                                        views: {
                                                'menuContent': {
                                                        templateUrl: 'pages/serviceRequest/updateKYC/updateKYCPersonalDetails.html',
                                                        controller: 'updateKYCPersonalDetailsController',
                                                        controllerAs: 'updateKYCPersonalDtlsVm',
                                                }
                                        }
                                })
                                .state('menu.updateKYCAddress', {
                                        url: '/updateKYCAddress',
                                        cache: false,
                                        data: {
                                                pageId: 'UPDATE_KYC_ADDRESS'
                                        },
                                        views: {
                                                'menuContent': {
                                                        templateUrl: 'pages/serviceRequest/updateKYC/updateKYCAddress.html',
                                                        controller: 'updateKYCAddressController',
                                                        controllerAs: 'updateKYCAddressVm',
                                                }
                                        }
                                })
                                .state('menu.updateKYCVerifyOtp', {
                                        url: '/updateKYCVerifyOtp',
                                        cache: false,
                                        data: {
                                                pageId: 'UPDATE_KYC_VERIFY_OTP'
                                        },
                                        views: {
                                                'menuContent': {
                                                        templateUrl: 'pages/serviceRequest/updateKYC/updateKYCVerifyOtp.html',
                                                        controller: 'updateKYCVerifyOtpController',
                                                        controllerAs: 'updateKYCVerifyOtpVm',
                                                }
                                        }
                                })
                                .state('menu.updateKYCSuccess', {
                                        url: '/updateKYCSuccess',
                                        cache: false,
                                        data: {
                                                pageId: 'UPDATE_KYC_PERSONAL_DTLS'
                                        },
                                        views: {
                                                'menuContent': {
                                                        templateUrl: 'pages/serviceRequest/updateKYC/updateKYCSuccess.html',
                                                        controller: 'updateKYCSuccessController',
                                                        controllerAs: 'updateKYCSuccessVm',
                                                }
                                        }
                                })
                                .state('menu.updateKYCAadhaar', {
                                        url: '/updateKYCAadhaar',
                                        cache: false,
                                        data: {
                                                pageId: 'UPDATE_KYC_AADHAAR'
                                        },
                                        views: {
                                                'menuContent': {
                                                        templateUrl: 'pages/serviceRequest/updateKYC/updateKYCAadhaar.html',
                                                        controller: 'reviewDetailsController',
                                                        controllerAs: 'reviewDetailsVm',
                                                }
                                        }
                                })
                                .state('menu.updateKYCAadhaarAddress', {
                                        url: '/updateKYCAadhaarAddress',
                                        cache: false,
                                        data: {
                                                pageId: 'UPDATE_KYC_AADHAAR_ADDRESS'
                                        },
                                        views: {
                                                'menuContent': {
                                                        templateUrl: 'pages/serviceRequest/updateKYC/updateKYCAadhaarAddress.html',
                                                        controller: 'updateKYCSuccessController',
                                                        controllerAs: 'updateKYCSuccessVm',
                                                }
                                        }
                                })
                        //Manage e-Statement ends here

                }
        ]);
