'use strict';

angularApp.controller('qrCodeController', ["$timeout",
    "$state",
    "$location",
    "$scope",
    "$rootScope",
    "utilityService",
    "manageQrCodeService",
    "$ionicPopup",
    "$ionicSideMenuDelegate",
    "constantConfig",
    "loggedInUserService",
    "customerInfoService",

    function ($timeout,
        $state,
        $location,
        $scope,
        $rootScope,
        utilityService,
        manageQrCodeService,
        $ionicPopup,
        $ionicSideMenuDelegate,
        constantConfig,
        loggedInUserService,
        customerInfoService) {

        //functions, variables that can be accessed from the HTML come here
        var qrCodeVm = this;
        var selectedBankAccount = '';
        qrCodeVm.vpaImage = "";
        if ($rootScope.checkDeviceInfo.userInfo.virtualAddress) {
            qrCodeVm.vpa = $rootScope.checkDeviceInfo.userInfo.virtualAddress;
        }

        var loggedInUserDetails = loggedInUserService.getUserProfileDetails();

        //private methods section start
        function initPage() {
            qrCodeVm.showBack = true;
            qrCodeVm.showNext = true;
            qrCodeVm.getAccountList();
            qrCodeVm.generateQrFlag = false;
            qrCodeVm.getQrCode();
        }

        qrCodeVm.deviceRegStatus = $rootScope.checkDeviceInfo.deviceStatus;
        qrCodeVm.simStatus = $rootScope.checkDeviceInfo.simStatus;
        qrCodeVm.getAccountList = function () {
            utilityService.showSpinner();
            var json = '';
            if (qrCodeVm.deviceRegStatus === 'DR' && qrCodeVm.simStatus === 'SNM') {
                json = JSON.stringify({
                    "addInfo": {
                        "addInfo10": constantConfig.upiConstant.addInfo10,
                        "addInfo9": constantConfig.upiConstant.addInfo9
                    },
                    "bankCode": constantConfig.upiConstant.bankCode,
                    "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                    "requestInfo": {
                        "pspId": constantConfig.upiConstant.pspId,
                        "pspRefNo": generateRandomString(27)
                    },
                    "requestType": constantConfig.upiConstant.requestType_E,
                    "updateFlag": constantConfig.upiConstant.updateFlag,
                    "userInfo": {
                        "defVPAStatus": constantConfig.upiConstant.defVPAStatus,
                        "isMerchant": constantConfig.upiConstant.isMerchant,
                        "name": $rootScope.checkDeviceInfo.userInfo.name,
                        "showMerchant": constantConfig.upiConstant.showMerchant,
                        "accountId": 0,
                        "virtualAddress": $rootScope.checkDeviceInfo.userInfo.virtualAddress
                    }
                });
            } else {
                json = JSON.stringify({
                    "addInfo": {
                        "addInfo10": constantConfig.upiConstant.addInfo10,
                        "addInfo9": constantConfig.upiConstant.addInfo9
                    },
                    "bankCode": constantConfig.upiConstant.bankCode,
                    "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                    "requestInfo": {
                        "pspId": constantConfig.upiConstant.pspId,
                        "pspRefNo": generateRandomString(27)
                    },
                    "requestType": constantConfig.upiConstant.requestType_R,
                    "updateFlag": constantConfig.upiConstant.updateFlag,
                    "userInfo": {
                        "defVPAStatus": constantConfig.upiConstant.defVPAStatus,
                        "isMerchant": constantConfig.upiConstant.isMerchant,
                        "name": loggedInUserDetails.inbUsername, //Here need to add logged in user name
                        "showMerchant": constantConfig.upiConstant.showMerchant,
                        "accountId": 0,
                        "virtualAddress": $rootScope.checkDeviceInfo.deviceInfo.mobileNo + "@sbi"
                    }
                });
            }
            getNativeData(constantConfig.upiConstant.getaccountListAPI, function (data) {
                var accObj = JSON.parse(data);
                if (accObj.status === 'S') {
                    // qrCodeVm.pspRespRefNo = accObj.requestInfo.pspRespRefNo;
                    qrCodeVm.accounts = accObj.accountList;
                    qrCodeVm.account = accObj.accountList[0].accId.toString().trim();
                    qrCodeVm.getVpaListByAcc(qrCodeVm.account);
                } else {
                    utilityService.hideSpinner();
                    utilityService.showErrorMessage(accObj.statusDesc);
                }
            }, function (msg) {
                utilityService.hideSpinner();
                qrCodeVm.showVpaErrorMessage(msg);
            }, json);
        }

        qrCodeVm.getVpaListByAcc = function (selectedBankId) {
            utilityService.showSpinner();
            qrCodeVm.vpaListAgainstAcc = [];

            var json = JSON.stringify({
                "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "updateFlag": constantConfig.upiConstant.updateFlag
            });
            getNativeData(constantConfig.upiConstant.getProfile, function (data) {
                qrCodeVm.selectedBankAccFromDD = [];
                var profileObj = JSON.parse(data);
                qrCodeVm.vpaListByAcc = profileObj;
                qrCodeVm.vpaListAgainstAcc = profileObj.vpaAccountDetails;
                selectedBankAccount = qrCodeVm.account;
                for (var i = 0; i < profileObj.vpaAccountDetails.length; i++) {
                    for (var j = 0; j < profileObj.vpaAccountDetails[i].accountInfo.length; j++) {
                        if (profileObj.vpaAccountDetails[i].accountInfo[j].accId == selectedBankAccount) {
                            qrCodeVm.selectedBankAccFromDD.push(profileObj.vpaAccountDetails[i].accountInfo[j]);
                        }
                    }
                }
                qrCodeVm.vpaLists = qrCodeVm.vpaListAgainstAcc;
                utilityService.hideSpinner();
            }, function (msg) {
                utilityService.hideSpinner();
                qrCodeVm.showVpaErrorMessage(msg);
            }, json);
        };

        qrCodeVm.showVpaErrorMessage = function (errorCode) {
            switch (errorCode) {
                case -1: utilityService.showErrorMessage(constantConfig.upiConstant.minusOne);
                    break;

                case -2: utilityService.showErrorMessage(constantConfig.upiConstant.minusTwo);
                    break;

                case -3: utilityService.showErrorMessage(constantConfig.upiConstant.minusThree);
                    break;

                case -4: utilityService.showErrorMessage(constantConfig.upiConstant.minusFour);
                    break;

                case -5: utilityService.showErrorMessage(constantConfig.upiConstant.minusFive);
                    break;

                case -6: utilityService.showErrorMessage(constantConfig.upiConstant.minusSix);
                    break;

                case -7: utilityService.showErrorMessage(constantConfig.upiConstant.minusSeven);
                    break;

                default: utilityService.showErrorMessage(constantConfig.upiConstant.someWentWrong);
            }
        };

        //this function is used to get VPA list on account change
        qrCodeVm.accountChange = function () {
            qrCodeVm.getVpaList();
        }

        //this function is used to close current page
        qrCodeVm.closeView = function () {
            $state.go('menu.settings');
        }

        //this function used to save QR code image to gallery
        qrCodeVm.saveToGallery = function () {
            if (qrCodeVm.vpaImage !== "" && qrCodeVm.vpaImage !== null) {
                var params = {
                    data: qrCodeVm.vpaImage,
                    format: 'JPG',
                    quality: 80,
                    mediaScanner: true
                };



                var myBaseString = qrCodeVm.vpaImage;
                var block = myBaseString.split(";");
                var dataType = block[0].split(":")[1];
                var myBase64 = block[1].split(",")[1];
                var displayTime = function () {
                    var str = "";

                    var currentTime = new Date();
                    var hours = currentTime.getHours();
                    var minutes = currentTime.getMinutes();
                    var seconds = currentTime.getSeconds();

                    if (minutes < 10) {
                        minutes = "0" + minutes;
                    }
                    if (seconds < 10) {
                        seconds = "0" + seconds;
                    }
                    str += hours + "-" + minutes + "-" + seconds + "-";
                    if (hours > 11) {
                        str += "PM";
                    } else {
                        str += "AM";
                    }
                    return str;
                };
                var contentType = "image/png";
                var folderpath = cordova.file.externalRootDirectory;
                var filename = "QR code-" + qrCodeVm.vpa + "=" + displayTime() + ".png";
                qrCodeVm.savebase64AsImageFile(folderpath, filename, myBase64, contentType);

            } else {
                utilityService.showErrorMessage("Kindly select the virtual address.");
            }
        };

        qrCodeVm.b64toBlob = function (b64Data, contentType, sliceSize) {
            contentType = contentType || '';
            sliceSize = sliceSize || 512;

            var byteCharacters = atob(b64Data);
            var byteArrays = [];
            //Check PDF SIZE
            if (byteCharacters.length >= constantConfig.accOverview.pdfSize) {
                utilityService.showErrorMessage(constantConfig.accOverview.sizeLimitMessage);
                return;
            }
            for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
                var slice = byteCharacters.slice(offset, offset + sliceSize);

                var byteNumbers = new Array(slice.length);
                for (var i = 0; i < slice.length; i++) {
                    byteNumbers[i] = slice.charCodeAt(i);
                }

                var byteArray = new Uint8Array(byteNumbers);

                byteArrays.push(byteArray);
            }

            var blob = new Blob(byteArrays, { type: contentType });
            return blob;
        };
        qrCodeVm.savebase64AsImageFile = function (folderpath, filename, content, contentType, share) {
            var DataBlob = qrCodeVm.b64toBlob(content, contentType);
            if (device.version == 10) {
                folderpath = cordova.file.externalDataDirectory;
                window.resolveLocalFileSystemURL(folderpath, function (dir) {
                    qrCodeVm.popupFolderpath = dir.nativeURL + filename;
                    dir.getFile(filename, { create: true }, function (file) {
                        file.createWriter(function (fileWriter) {
                            fileWriter.write(DataBlob);
                            qrCodeVm.downloadOrShare(share);
                        }, function () {
                            utilityService.showBhimUpiAlert("error", 'Unable to save file in path ' + folderpath);
                        });
                    });
                });
            }
            else {
                window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fileSystem) {
                    fileSystem.root.getDirectory("Download", { create: true, exclusive: false }, function (dir) {
                        qrCodeVm.popupFolderpath = dir.nativeURL + filename;
                        dir.getFile(filename, { create: true }, function (file) {
                            file.createWriter(function (fileWriter) {
                                fileWriter.write(DataBlob);
                                qrCodeVm.downloadOrShare(share);
                            }, function () {
                                utilityService.showBhimUpiAlert("error", 'Unable to save file in path ' + folderpath);
                            });
                        });
                    });
                });
            }
        };

        qrCodeVm.downloadOrShare = function (share) {
            if (share) {
                var options = {
                        message: 'QR code : ',
                        subject: 'QR Code : ' + qrCodeVm.vpa,
                        files: [qrCodeVm.popupFolderpath],
                        url: qrCodeVm.vpa,
                        chooserTitle: 'Share'
                    };

                var onSuccess = function (result) {

                };
                var onError = function (msg) {

                }
                window.plugins.socialsharing.shareWithOptions(options, onSuccess, onError);
            } else if (!share) {
                var fileStoredAlert = $ionicPopup.show({
                    template: '<img src="img/mf/bg-approved.svg" alt="Success Screen"> <p>Image stored successfully.</p>',
                    title: '',
                    cssClass: 'dialog',
                    scope: $scope,
                    buttons: [{
                        text: 'Ok',
                        type: 'button-positive',
                        onTap: function (e) { }
                    }]
                });
            }
        }

        //this function used to share QR code image
        qrCodeVm.share = function () {
            if (qrCodeVm.vpaImage !== "" && qrCodeVm.vpaImage !== null) {
                var params = {
                    data: qrCodeVm.vpaImage,
                    format: 'JPG',
                    quality: 80,
                    mediaScanner: true
                };



                var myBaseString = qrCodeVm.vpaImage;
                var block = myBaseString.split(";");
                var dataType = block[0].split(":")[1];
                var myBase64 = block[1].split(",")[1];
                var displayTime = function () {
                    var str = "";

                    var currentTime = new Date();
                    var hours = currentTime.getHours();
                    var minutes = currentTime.getMinutes();
                    var seconds = currentTime.getSeconds();

                    if (minutes < 10) {
                        minutes = "0" + minutes;
                    }
                    if (seconds < 10) {
                        seconds = "0" + seconds;
                    }
                    str += hours + "-" + minutes + "-" + seconds + "-";
                    if (hours > 11) {
                        str += "PM";
                    } else {
                        str += "AM";
                    }
                    return str;
                };
                var contentType = "image/png";
                var folderpath = cordova.file.externalRootDirectory;
                var filename = "QR code-" + qrCodeVm.vpa + "=" + displayTime() + ".png";
                qrCodeVm.savebase64AsImageFile(folderpath, filename, myBase64, contentType, true);
            } else {
                utilityService.showErrorMessage("Kindly select the virtual address.");
            }
        };

        //this function is used to get VPA list from service
        qrCodeVm.getVpaList = function () {
            qrCodeVm.vpaLists = [{
                "vpa": ""
            }, {
                "vpa": ""
            }];
        };

        //this function is used to get QR code from service
        qrCodeVm.getQrCode = function () {
            var userName = customerInfoService.customer.name ? customerInfoService.customer.name : null;
            var qrCodeGenerate = new QRious({
                element: document.getElementById('qr'),
                value: "upi://pay?pa=" + qrCodeVm.vpa + "&pn=" + userName + "",
                mime: 'image/png',
                size: 250
            });

            qrCodeVm.qrImage = qrCodeGenerate.toDataURL('[mime type]');
            qrCodeVm.vpaImage = qrCodeVm.qrImage;
            qrCodeVm.generateQrFlag = false;
            qrCodeVm.vpaImage = qrCodeVm.qrImage;
        };

        //this function is used to generate QR code from service
        qrCodeVm.generateQrCode = function () {
            var reqParams = {};
            reqParams["accountNumber"] = qrCodeVm.account;
            reqParams["vpa"] = qrCodeVm.vpa;

            manageQrCodeService.createQRCode(reqParams).then(function (data) {
                qrCodeVm.vpaImage = data.vpaImage;
                if (qrCodeVm.vpaImage != '')
                    qrCodeVm.generateQrFlag = false;
                else qrCodeVm.generateQrFlag = true;

            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        };

        //back to prev page
        qrCodeVm.goBacktoPrevious = function () {
            $state.go('menu.settings');
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            $ionicSideMenuDelegate.canDragContent(false);
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            $ionicSideMenuDelegate.canDragContent(false);
            initPage();
        });

        //actions to done everytime the view is hidden
        $scope.$on('$ionicView.afterLeave', function () {
            //any cleanup needs to be done here: executes everytime when page is left
            $ionicSideMenuDelegate.canDragContent(true);
        });

        return this;

    }
]);