'use strict';

angularApp.controller('createVpaController', ["$timeout",
    "$state",
    "$location",
    "$scope",
    "$rootScope",
    "utilityService",
    "manageVpaService",
    "$ionicPopup",
    "$ionicSideMenuDelegate",
    "$ionicSlideBoxDelegate",
    "loggedInUserService",
    "constantConfig",


    function($timeout,
        $state,
        $location,
        $scope,
        $rootScope,
        utilityService,
        manageVpaService,
        $ionicPopup,
        $ionicSideMenuDelegate, $ionicSlideBoxDelegate, loggedInUserService, constantConfig) {

        //functions, variables that can be accessed from the HTML come here
        var createVpaVm = this;
        createVpaVm.selectedBankAccFromDD = [];
        var selectedBankAccount = '';
        createVpaVm.deviceRegStatus = $rootScope.checkDeviceInfo.deviceStatus;
        createVpaVm.simStatus = $rootScope.checkDeviceInfo.simStatus;
        createVpaVm.smsStatus = $rootScope.checkDeviceInfo.smsStatus;
        createVpaVm.oldMobNo = $rootScope.checkDeviceInfo.deviceInfo.oldMobileNo;
        createVpaVm.pspRespRefNo = '';

        createVpaVm.months = ["01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12"];
        createVpaVm.years = ["17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31", "32", "33", "34", "35", "36", "37", "38", "39", "40", "41", "42", "43", "44", "45", "46", "47", "48", "49", "50"];

        var loggedInUserDetails = loggedInUserService.getUserProfileDetails();

        //private methods section start
        function initPage() {
            //createVpaVm.getAccountList();
            createVpaVm.showBack = true;
            createVpaVm.showNext = true;
            createVpaVm.disableConfirm = true;
            createVpaVm.createVpaFlag = false;
        }

        //if($rootScope.checkDeviceInfo.userInfo && $rootScope.checkDeviceInfo.userInfo.virtualAddress){
        if ($rootScope.checkDeviceInfo.userInfo) {
            createVpaVm.vpa = $rootScope.checkDeviceInfo.userInfo.virtualAddress;
        }


        //Function for get Account list
        createVpaVm.getAccountList = function() {
            utilityService.showSpinner();
            var json = '';
            if (createVpaVm.deviceRegStatus === 'DR' && createVpaVm.simStatus === 'SNM') {
                json = JSON.stringify({
                    "addInfo": {
                        "addInfo10": constantConfig.upiConstant.addInfo10,
                        "addInfo9": constantConfig.upiConstant.addInfo9
                    },
                    "bankCode": constantConfig.upiConstant.bankCode,
                    "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                    "requestInfo": {
                        "pspId": constantConfig.upiConstant.pspId,
                        "pspRefNo": generateRandomString(27)
                    },
                    "requestType": constantConfig.upiConstant.requestType_E,
                    "updateFlag": constantConfig.upiConstant.updateFlag,
                    "userInfo": {
                        "defVPAStatus": constantConfig.upiConstant.defVPAStatus,
                        "isMerchant": constantConfig.upiConstant.isMerchant,
                        "name": $rootScope.checkDeviceInfo.userInfo.name,
                        "showMerchant": constantConfig.upiConstant.showMerchant,
                        "accountId": 0,
                        "virtualAddress": $rootScope.checkDeviceInfo.userInfo.virtualAddress
                    }
                });
            } else {
                json = JSON.stringify({
                    "addInfo": {
                        "addInfo10": constantConfig.upiConstant.addInfo10,
                        "addInfo9": constantConfig.upiConstant.addInfo9
                    },
                    "bankCode": constantConfig.upiConstant.bankCode,
                    "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                    "requestInfo": {
                        "pspId": constantConfig.upiConstant.pspId,
                        "pspRefNo": generateRandomString(27)
                    },
                    "requestType": constantConfig.upiConstant.requestType_R,
                    "updateFlag": constantConfig.upiConstant.updateFlag,
                    "userInfo": {
                        "defVPAStatus": constantConfig.upiConstant.defVPAStatus,
                        "isMerchant": constantConfig.upiConstant.isMerchant,
                        "name": loggedInUserDetails.inbUsername, //Here need to add logged in user name
                        "showMerchant": constantConfig.upiConstant.showMerchant,
                        "accountId": 0,
                        "virtualAddress": $rootScope.checkDeviceInfo.deviceInfo.mobileNo + "@sbi"
                    }
                });
            }
            getNativeData(constantConfig.upiConstant.getaccountListAPI, function(data) {
                var accObj = JSON.parse(data);
                if (accObj.status === 'S') {
                    createVpaVm.pspRespRefNo = accObj.requestInfo.pspRespRefNo;
                    createVpaVm.vpaAccounts = accObj.accountList;
                    createVpaVm.account = (accObj.accountList[0].accId).toString().trim();
                    if (createVpaVm.deviceRegStatus === 'DN' && createVpaVm.simStatus === 'SNN') {
                        createVpaVm.createVpaFlag = true;
                        utilityService.hideSpinner();
                    } else {
                        createVpaVm.getVpaListByAcc(createVpaVm.account);
                    }
                } else {
                    utilityService.hideSpinner();
                    utilityService.showErrorMessage(accObj.statusDesc);
                    $state.go('menu.settings');
                }
            }, function(msg) {
                utilityService.hideSpinner();
                createVpaVm.showVpaErrorMessage(msg);
                $state.go('menu.settings');
            }, json);
        }

        createVpaVm.getSecQueList = function() {
            utilityService.showSpinner();
            var json = JSON.stringify({
                "addInfo": {
                    "addInfo10": constantConfig.upiConstant.addInfo10,
                    "addInfo9": constantConfig.upiConstant.addInfo9
                },
                "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "updateFlag": constantConfig.upiConstant.updateFlag
            });
            getNativeData(constantConfig.upiConstant.getSecurityQuestionsList, function(data) {
                var secQueObj = JSON.parse(data);
                createVpaVm.secQuestions = secQueObj.secQuesList;
                utilityService.hideSpinner();
            }, function(msg) {
                utilityService.hideSpinner();
                createVpaVm.showVpaErrorMessage(msg);
                $state.go('menu.settings');
            }, json);
        }

        createVpaVm.getSelectedSecQue = function() {
            utilityService.showSpinner();
            var json = JSON.stringify({
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "updateFlag": constantConfig.upiConstant.updateFlag
            });
            getNativeData(constantConfig.upiConstant.getSelectedSecurityQuestion, function(data) {
                if (JSON.parse(data).status == "S") {
                    createVpaVm.selectedSecQuestion = JSON.parse(data).userInfo.secretDetails.quesName;
                    createVpaVm.selectedSecQueId = JSON.parse(data).userInfo.secretDetails.quesId;
                    utilityService.hideSpinner();
                } else {
                    utilityService.hideSpinner();
                    utilityService.showErrorMessage("Can not process now, Please try after sometime.");
                }
            }, function(msg) {
                utilityService.hideSpinner();
                createVpaVm.showVpaErrorMessage(msg);
            }, json);
        }

        createVpaVm.getVpaListByAcc = function(selectedBankId) {
            utilityService.showSpinner();
            createVpaVm.vpaListAgainstAcc = [];

            var json = JSON.stringify({
                "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "updateFlag": constantConfig.upiConstant.updateFlag
            });
            getNativeData(constantConfig.upiConstant.getProfile, function(data) {
                if (JSON.parse(data).status === "S") {
                    createVpaVm.selectedBankAccFromDD = [];
                    var profileObj = JSON.parse(data);
                    createVpaVm.vpaListByAcc = profileObj;
                    createVpaVm.vpaListAgainstAcc = profileObj.vpaAccountDetails;
                    selectedBankAccount = createVpaVm.account;
                    for (var i = 0; i < profileObj.vpaAccountDetails.length; i++) {
                        for (var j = 0; j < profileObj.vpaAccountDetails[i].accountInfo.length; j++) {
                            if (profileObj.vpaAccountDetails[i].accountInfo[j].accId == selectedBankAccount) {
                                createVpaVm.selectedBankAccFromDD.push(profileObj.vpaAccountDetails[i].accountInfo[j]);
                            }
                        }
                    }
                    manageVpaService.selectedBankAccFromDD = createVpaVm.selectedBankAccFromDD[0];
                    utilityService.hideSpinner();
                } else {
                    utilityService.hideSpinner();
                    utilityService.showErrorMessage(JSON.parse(data).statusDesc);
                }
            }, function(msg) {
                utilityService.hideSpinner();
                createVpaVm.showVpaErrorMessage(msg);
            }, json);
        }

        //Check VPA availability
        createVpaVm.confirmVpa = function() {
            utilityService.showSpinner();
            var json = JSON.stringify({
                "addInfo": {
                    "addInfo10": constantConfig.upiConstant.addInfo10,
                    "addInfo9": constantConfig.upiConstant.addInfo9
                },
                "payeeType": {
                    "virtualAddress": createVpaVm.vpaInput.toLowerCase() + "@sbi"
                },
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "vAReqType": "R"
            });
            getNativeData(constantConfig.upiConstant.checkVirtualAddressAPI, function(data) {
                utilityService.hideSpinner();
                if (JSON.parse(data).status === 'VN') {
                    var fileStoredAlert = $ionicPopup.show({
                        template: '<img src="img/mf/bg-approved.svg" alt="Success Screen"> <p>This Virtual Address is available.</p>',
                        title: '',
                        cssClass: 'dialog',
                        scope: $scope,
                        buttons: [{
                            text: 'Ok',
                            type: 'button-positive',
                            onTap: function(e) {}
                        }]
                    });
                } else if (JSON.parse(data).status === 'VE') {
                    utilityService.showErrorMessage("This Virtual address is already exists. Please try with different virtual address.");
                } else {
                    utilityService.showErrorMessage("Kindly check the Virtual Address.");
                }
            }, function(msg) {
                utilityService.hideSpinner();
                createVpaVm.showVpaErrorMessage(msg);
            }, json);
        }

        createVpaVm.checkDevice = function() {
            var json = JSON.stringify({
                "addInfo": {
                    "addInfo10": constantConfig.upiConstant.addInfo10,
                    "addInfo9": constantConfig.upiConstant.addInfo9
                },
                "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "updateFlag": constantConfig.upiConstant.updateFlag
            });
            getNativeData(constantConfig.upiConstant.checkDevice, function(data) {
                $rootScope.checkDeviceInfo = JSON.parse(data);
                createVpaVm.confirmVpadone();
            }, function(msg) {
                utilityService.hideSpinner();
                createVpaVm.showVpaErrorMessage(msg);
            }, json);
        }

        createVpaVm.drsnm = function() {
            var json = JSON.stringify({
                "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "accountList": [createVpaVm.selectedBankAccFromDD[0]],
                "updateFlag": constantConfig.upiConstant.updateFlag,
                "userInfo": {
                    "defVPAStatus": constantConfig.upiConstant.defVPAStatus,
                    "isMerchant": constantConfig.upiConstant.isMerchant,
                    "showMerchant": constantConfig.upiConstant.showMerchant,
                    "accountId": selectedBankAccount,
                    "virtualAddress": createVpaVm.vpaInput.toLowerCase() + "@sbi"
                }
            });
            getNativeData(constantConfig.upiConstant.onCreateNewVPA, function(data) {
                utilityService.hideSpinner();
                if (JSON.parse(data).status === "S") {
                    //if (manageVpaService.selectedBankAccFromDD.mpinFlag !== "N") {
                        var confirmPopup = $ionicPopup.confirm({
                            title: '',
                            templateUrl: 'pages/settings/payments/manageVPA/checkAvailability.html',
                            cssClass: 'dialog',
                            buttons: [{
                                text: 'Ok',
                                onTap: function(e) {
                                    createVpaVm.createVpaFlag = false;
                                    createVpaVm.getVpaListByAcc(selectedBankAccount);
                                }
                            }]
                        });
                    /* } else {
                        $state.go("menu.settingsSetUpiPin");
                    } */
                } else {
                    utilityService.showErrorMessage(JSON.parse(data).statusDesc);
                }
            }, function(msg) {
                utilityService.hideSpinner();
                createVpaVm.showVpaErrorMessage(msg);
            }, json);
        }

        createVpaVm.drsnn = function() {
            var json = JSON.stringify({
                "deviceInfo": {
                    "oldMobileNo": createVpaVm.oldMobNo
                },
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "requestType": constantConfig.upiConstant.requestType_M,
                "updateFlag": constantConfig.upiConstant.updateFlag,
                "userInfo": {
                    "secretDetails": {
                        "secretAnswer": createVpaVm.securityAns.toString(),
                        "quesId": createVpaVm.selectedSecQueId.toString()
                    }
                }
            });
            getNativeData(constantConfig.upiConstant.updateDevice, function(data) {
                if (data.status === 'S') {
                    createVpaVm.checkDeviceDRSNN();
                } else {
                    utilityService.showErrorMessage(data.statusDesc);
                }
            }, function(msg) {
                utilityService.hideSpinner();
                createVpaVm.showVpaErrorMessage(msg);
            }, json);
        }

        createVpaVm.sendSMSDRSNN = function() {
            utilityService.showSpinner();
            if ($rootScope.checkDeviceInfo.deviceStatus == 'DR' &&
                $rootScope.checkDeviceInfo.simStatus == 'SNN') {
                var json = JSON.stringify({
                    "smsContent": $rootScope.checkDeviceInfo.smsGateWayContent,
                    "smsEncKey": $rootScope.checkDeviceInfo.smsGateWayKey,
                    "smsGateWayNo": $rootScope.checkDeviceInfo.smsGateWayNo,
                    "slot": $rootScope.checkDeviceInfo.deviceInfo.selectedSimSlot.toString(),
                    "simNo": ""
                });
                getNativeData(constantConfig.upiConstant.sendsms, function(data) {
                    if (data.smsStatus === 'S') {
                        createVpaVm.drsnnDRSNN();
                    } else {
                        utilityService.hideSpinner();
                        utilityService.showErrorMessage("Failed to send SMS to the registered mobile number.");
                    }
                }, function(msg) {
                    utilityService.hideSpinner();
                    createVpaVm.showVpaErrorMessage(msg);
                }, json);
            } else {
                createVpaVm.drsnnDRSNN();
            }
        }

        createVpaVm.drsnnDRSNN = function() {
            var json = '';
            if ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNN') {
                json = JSON.stringify({
                    "deviceInfo": {
                        "oldMobileNo": createVpaVm.oldMobNo
                    },
                    "requestInfo": {
                        "pspId": constantConfig.upiConstant.pspId,
                        "pspRefNo": generateRandomString(27)
                    },
                    "requestType": constantConfig.upiConstant.requestType_M,
                    "updateFlag": constantConfig.upiConstant.updateFlag,
                    "userInfo": {
                        "secretDetails": {
                            "secretAnswer": createVpaVm.securityAns.toString(),
                            "quesId": createVpaVm.selectedSecQueId.toString()
                        }
                    }
                });
            } else {
                json = JSON.stringify({
                    "deviceInfo": {
                        "oldMobileNo": createVpaVm.oldMobNo
                    },
                    "requestInfo": {
                        "pspId": constantConfig.upiConstant.pspId,
                        "pspRefNo": generateRandomString(27)
                    },
                    "requestType": constantConfig.upiConstant.requestType_D,
                    "updateFlag": constantConfig.upiConstant.updateFlag,
                    "userInfo": {
                        "secretDetails": {
                            "secretAnswer": createVpaVm.securityAns.toString(),
                            "quesId": createVpaVm.selectedSecQueId.toString()
                        }
                    }
                });
            }
            getNativeData(constantConfig.upiConstant.updateDevice, function(data) {
                if (JSON.parse(data).status === 'S') {
                    createVpaVm.checkDeviceDRSNN();
                } else {
                    utilityService.hideSpinner();
                    utilityService.showErrorMessage(JSON.parse(data).statusDesc);
                }
            }, function(msg) {
                utilityService.hideSpinner();
                createVpaVm.showVpaErrorMessage(msg);
            }, json);
        }

        createVpaVm.checkDeviceDRSNN = function() {
            var json = JSON.stringify({
                "addInfo": {
                    "addInfo10": constantConfig.upiConstant.addInfo10,
                    "addInfo9": constantConfig.upiConstant.addInfo9
                },
                "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "updateFlag": constantConfig.upiConstant.updateFlag
            });
            getNativeData(constantConfig.upiConstant.checkDevice, function(data) {
                $rootScope.checkDeviceInfo = JSON.parse(data);
                utilityService.hideSpinner();
                if ($rootScope.checkDeviceInfo.status == 'S') {
                    $state.go('menu.createVPA');
                } else {
                    utilityService.showErrorMessage("Can not process now, Please try after sometime.");
                }
            }, function(msg) {
                utilityService.hideSpinner();
                createVpaVm.showVpaErrorMessage(msg);
            }, json);
        }

        createVpaVm.dnsnn = function() {
            var json = JSON.stringify({
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27),
                    "pspRespRefNo": createVpaVm.pspRespRefNo.toString()
                },
                "updateFlag": constantConfig.upiConstant.updateFlag,
                "userInfo": {
                    "altMobNo": $rootScope.checkDeviceInfo.deviceInfo.mobileNo,
                    "appPin": {
                        "credentialDataValue": constantConfig.upiConstant.credentialDataValue
                    },
                    "defVPAseStatus": constantConfig.upiConstant.defVPAseStatus,
                    //"email": "sudhirbhaskarbhujbal@gmail.com", //Here need to add email from logged in user
                    "isMerchant": constantConfig.upiConstant.isMerchant,
                    "mobileNo": $rootScope.checkDeviceInfo.deviceInfo.mobileNo,
                    "name": loggedInUserDetails.inbUsername, //Here need to add name from logged in user
                    "secretDetails": {
                        "secretAnswer": createVpaVm.secAnswer,
                        "quesId": createVpaVm.question
                    },
                    "showMerchant": constantConfig.upiConstant.showMerchant,
                    "accountId": createVpaVm.account,
                    "virtualAddress": createVpaVm.vpaInput.toLowerCase() + "@sbi"
                }
            });
            getNativeData(constantConfig.upiConstant.onRegisterSubmit, function(data) {
                if (JSON.parse(data).status === 'S') {
                    //if (manageVpaService.selectedBankAccFromDD.mpinFlag !== "N") {
                        var confirmPopup = $ionicPopup.confirm({
                            title: '',
                            templateUrl: 'pages/settings/payments/manageVPA/checkAvailability.html',
                            cssClass: 'dialog',
                            buttons: [{
                                text: 'Ok',
                                onTap: function(e) {
                                    createVpaVm.createVpaFlag = false;
                                    createVpaVm.getVpaListByAcc(selectedBankAccount);
                                }
                            }]
                        });
                    /* } else {
                        $state.go("menu.settingsSetUpiPin");
                    } */
                } else {
					utilityService.hideSpinner();
                    utilityService.showErrorMessage("VPA creation failed. Please try again.");
                }
            }, function(msg) {
				utilityService.hideSpinner();
                createVpaVm.showVpaErrorMessage(msg);
            }, json);
        }

        createVpaVm.dnsnm = function() {
            var json = JSON.stringify({
                "deviceInfo": {
                    "oldMobileNo": createVpaVm.oldMobNo
                },
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "requestType": constantConfig.upiConstant.requestType_D,
                "updateFlag": constantConfig.upiConstant.updateFlag,
                "userInfo": {
                    "secretDetails": {
                        "secretAnswer": createVpaVm.secAnswer,
                        "quesId": createVpaVm.selectedSecQuestion
                    }
                }
            });
            getNativeData(constantConfig.upiConstant.updateDevice, function(data) {
                createVpaVm.checkDevice();
            }, function(msg) {
				utilityService.hideSpinner();
                createVpaVm.showVpaErrorMessage(msg);
            }, json);
        }

        createVpaVm.sendSMS = function() {
            var json = JSON.stringify({
                "smsContent": $rootScope.checkDeviceInfo.smsGateWayContent,
                "smsEncKey": $rootScope.checkDeviceInfo.smsGateWayKey,
                "smsGateWayNo": $rootScope.checkDeviceInfo.smsGateWayNo,
                "slot": $rootScope.checkDeviceInfo.deviceInfo.selectedSimSlot.toString(),
                "simNo": ""
            });
            getNativeData(constantConfig.upiConstant.sendsms, function(data) {
                if (data.smsStatus === 'S') {
                    createVpaVm.dnsnn();
                } else {
					utilityService.hideSpinner();
                    utilityService.showErrorMessage("Failed to send SMS to the registered mobile number.");
                }
            }, function(msg) {
                utilityService.hideSpinner();
                createVpaVm.showVpaErrorMessage(msg);
            }, json);
        }

        createVpaVm.confirmVpadone = function() {
            manageVpaService.vpaForSetUpiPin = createVpaVm.vpaInput;
            utilityService.showSpinner();
            var json = JSON.stringify({
                "addInfo": {
                    "addInfo10": constantConfig.upiConstant.addInfo10,
                    "addInfo9": constantConfig.upiConstant.addInfo9
                },
                "payeeType": {
                    "virtualAddress": createVpaVm.vpaInput.toLowerCase() + "@sbi"
                },
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "vAReqType": constantConfig.upiConstant.vAReqType_R
            });
            getNativeData(constantConfig.upiConstant.checkVirtualAddressAPI, function(data) {
                if (JSON.parse(data).status === 'VN') {
                    if (createVpaVm.deviceRegStatus === 'DR') {
                        if (createVpaVm.simStatus === 'SNM') {
                            createVpaVm.drsnm();
                        } else if (createVpaVm.simStatus === 'SNN') {
                            createVpaVm.drsnn();
                        }
                    } else if (createVpaVm.deviceRegStatus === 'DN') {
                        if (createVpaVm.simStatus === 'SNN') {
                            if (createVpaVm.smsStatus === 'SN') {
                                createVpaVm.sendSMS();
                            } else {
                                createVpaVm.dnsnn();
                            }
                        } else if (createVpaVm.simStatus === 'SNM') {
                            createVpaVm.dnsnm();
                        }
                    }
                } else if (JSON.parse(data).status === 'VE') {
                    utilityService.hideSpinner();
                    utilityService.showErrorMessage("This Virtual address is already exists. Please try with different virtual address.");
                } else {
                    utilityService.hideSpinner();
                    utilityService.showErrorMessage("Kindly check the virtual address.");
                }

            }, function(msg) {
                utilityService.hideSpinner();
                createVpaVm.showVpaErrorMessage(msg);
            }, json);
        }

        createVpaVm.getSelectedBankAcc = function() {
            createVpaVm.selectedAcc = manageVpaService.selectedBankAccFromDD.maskedAccountNumber;
        }

        createVpaVm.setUpiPin = function() {
            utilityService.showSpinner();
			var json = {};
			if(createVpaVm.cardType !== 'M'){
				json = JSON.stringify({
					"accountId": manageVpaService.selectedBankAccFromDD.accId,
					"addInfo": {
						"addInfo10": constantConfig.upiConstant.addInfo10,
						"addInfo9": constantConfig.upiConstant.addInfo9
					},
					"cardType": createVpaVm.cardType,
					"expiryDate": createVpaVm.month + createVpaVm.year,
					"lastSixDigitDebitCardno": createVpaVm.dcNumber,
					"requestInfo": {
						"pspId": constantConfig.upiConstant.pspId,
						"pspRefNo": generateRandomString(27)
					},
					"virtualAddress": $rootScope.checkDeviceInfo.userInfo.virtualAddress
				});
			} else {
				json = JSON.stringify({
					"accountId": manageVpaService.selectedBankAccFromDD.accId,
					"addInfo": {
						"addInfo10": constantConfig.upiConstant.addInfo10,
						"addInfo9": constantConfig.upiConstant.addInfo9
					},
					"cardType": createVpaVm.cardType,
					"lastSixDigitDebitCardno": createVpaVm.dcNumber,
					"requestInfo": {
						"pspId": constantConfig.upiConstant.pspId,
						"pspRefNo": generateRandomString(27)
					},
					"virtualAddress": $rootScope.checkDeviceInfo.userInfo.virtualAddress
				});
			}
            getNativeData(constantConfig.upiConstant.onSetMpin, function(data) {
                utilityService.hideSpinner();
                if (JSON.parse(data).apiResp.status === 'S') {
                    var confirmPopup = $ionicPopup.confirm({
                        title: '',
                        templateUrl: 'pages/settings/payments/manageVPA/checkAvailability.html',
                        cssClass: 'dialog',
                        buttons: [{
                            text: 'Ok',
                            onTap: function(e) {
                                createVpaVm.createVpaFlag = false;
                                $state.go('menu.createVPA');
                                createVpaVm.getVpaListByAcc(selectedBankAccount);
                            }
                        }]
                    });
                } else {
                    utilityService.showErrorMessage(JSON.parse(data).apiResp.statusDesc);
                }
            }, function(msg) {
                utilityService.hideSpinner();
                createVpaVm.showVpaErrorMessage(msg);
            }, json);
        }

        createVpaVm.closeSetUpiPinView = function() {
            $state.go('menu.settings');
        }

        //delete VPA popup
        createVpaVm.deleteVpapopup = function(vpa, indexVal) {
            var confirmPopup = $ionicPopup.confirm({
                title: '',
                templateUrl: 'pages/settings/payments/manageVPA/vpaDeletePopup.html',
                cssClass: 'dialog',
                buttons: [{
                    text: 'Cancel'
                }, {
                    text: 'Ok',
                    onTap: function(e) {
                        createVpaVm.deleteVpaFun(vpa, indexVal);
                    }
                }]
            });
        }

        //Delete VPA
        createVpaVm.deleteVpaFun = function(vpaData, indexVal) {
            utilityService.showSpinner();
            var json = JSON.stringify({
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "requestType": constantConfig.upiConstant.requestType_D, //fixed
                "userInfo": {
                    "defVPAStatus": constantConfig.upiConstant.defVPAStatus,
                    "isMerchant": constantConfig.upiConstant.isMerchant,
                    "showMerchant": constantConfig.upiConstant.showMerchant,
                    "accountId": selectedBankAccount,
                    "virtualAddress": vpaData.virtualAddress
                }
            });
            getNativeData(constantConfig.upiConstant.onRemoveVPA, function(data) {
                utilityService.hideSpinner();
                if (JSON.parse(data).status == "S") {
                    createVpaVm.vpaListAgainstAcc.splice(indexVal, 1);
                } else {
                    utilityService.showErrorMessage(JSON.parse(data).statusDesc);
                }
            }, function(msg) {
                utilityService.hideSpinner();
                createVpaVm.showVpaErrorMessage(msg);
            }, json);
        }

        //Set Primary Virtual Address.
        createVpaVm.setPrimaryVpa = function() {
            utilityService.showSpinner();
            var json = JSON.stringify({
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "requestType": constantConfig.upiConstant.requestType_P, //fixed
                "userInfo": {
                    "defVPAStatus": constantConfig.upiConstant.defVPAStatus,
                    "isMerchant": constantConfig.upiConstant.isMerchant,
                    "showMerchant": constantConfig.upiConstant.showMerchant,
                    "accountId": selectedBankAccount,
                    "virtualAddress": createVpaVm.vpa
                }
            });
            getNativeData(constantConfig.upiConstant.onRemoveVPA, function(data) {
                utilityService.hideSpinner();
                if (JSON.parse(data).status == "S") {
                    var setPrimaryVpa = $ionicPopup.show({
                        template: '<img src="img/mf/bg-approved.svg" alt="Success Screen"> <p>Primary Virtual Address Set successfully.</p>',
                        title: '',
                        cssClass: 'dialog',
                        scope: $scope,
                        buttons: [{
                            text: 'Ok',
                            type: 'button-positive',
                            onTap: function(e) {}
                        }]
                    });
                } else {
                    utilityService.showErrorMessage(JSON.parse(data).statusDesc);
                }
            }, function(msg) {
                utilityService.hideSpinner();
                createVpaVm.showVpaErrorMessage(msg);
            }, json);
        };
		
		createVpaVm.isMaestroCard = false;
		createVpaVm.changeCardType = function(cardType){
			if(cardType == 'M'){
				createVpaVm.isMaestroCard = true;
			}else{
				createVpaVm.isMaestroCard = false;
			}
		};
		
		createVpaVm.showVpaErrorMessage = function(errorCode){
			switch(errorCode){
				case -1 : utilityService.showErrorMessage(constantConfig.upiConstant.minusOne);
				break;
				
				case -2 : utilityService.showErrorMessage(constantConfig.upiConstant.minusTwo);
				break;
				
				case -3 : utilityService.showErrorMessage(constantConfig.upiConstant.minusThree);
				break;
				
				case -4 : utilityService.showErrorMessage(constantConfig.upiConstant.minusFour);
				break;
				
				case -5 : utilityService.showErrorMessage(constantConfig.upiConstant.minusFive);
				break;
				
				case -6 : utilityService.showErrorMessage(constantConfig.upiConstant.minusSix);
				break;
				
				case -7 : utilityService.showErrorMessage(constantConfig.upiConstant.minusSeven);
				break;
				
				default : utilityService.showErrorMessage(constantConfig.upiConstant.someWentWrong);
			}
		};

        createVpaVm.closeQuestionView = function() {
            $state.go('menu.settings');
        }

        //open create VPA page and clear input value
        createVpaVm.confirmVPApage = function() {
            createVpaVm.vpaInput = '';
            createVpaVm.createVpaFlag = true;
        }

        //this function is define to close current page
        createVpaVm.closeView = function() {
            $state.go('menu.settings');
        }

        createVpaVm.setInputSize = function(vpaValue) {
            try {
                var vpaInput = document.querySelector('#vpaInput');
                if (vpaValue != '' && vpaValue != undefined) {
                    vpaInput.style.width = (vpaValue.length * 8) + 'px';
                    var value_length = vpaValue.length * 8;
                    if (value_length >= 63) {
                        vpaInput.style.minWidth = '63px';
                    } else {
                        vpaInput.style.minWidth = (vpaValue.length * 8) + 'px';
                    }
                } else {
                    vpaInput.style.minWidth = '63px';
                    vpaInput.style.width = '60px';
                }
            } catch (e) {}
        }

        //this function is define to check VPA availability
        createVpaVm.checkAvailability = function() {
            createVpaVm.checkAvailFun();
        }

        //to check VPA available or not on input focus out
        createVpaVm.vpaInputBlur = function(vpaValue) {
            try {
                var vpaInput = document.querySelector('#vpaInput');
                if (vpaValue == '' || vpaValue == undefined)
                    vpaInput.style.width = '60px';
            } catch (e) {}
        }

        //to check enteredOtp is valid or not based on enable next button
        createVpaVm.enteredOtp = function(isValid) {
            (isValid) ? createVpaVm.disableNext = false: createVpaVm.disableNext = true;
            return createVpaVm.disableNext;
        }

        //Auto populate OTP and enable "Next" button
        $scope.$watch("createVpaVm.getOTPNumber", function() {
            if (createVpaVm.getOTPNumber != undefined && createVpaVm.getOTPNumber.length > 0) {
                createVpaVm.disableNext = false;
            } else {
                createVpaVm.disableNext = true;
            }
        });

        //this function is used to get VPA list on account change
        createVpaVm.accountChange = function() {
            createVpaVm.getVpaList();
        }

        //this function is define to delete VPA
        createVpaVm.deleteVpa = function(vpa, indexVal) {
            createVpaVm.deleteVpaFun(vpa, indexVal);
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            $ionicSideMenuDelegate.canDragContent(false);
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(false);
            createVpaVm.createVpaFlag = false;
        });

        //actions to done everytime the view is hidden
        $scope.$on('$ionicView.afterLeave', function() {
            $ionicSideMenuDelegate.canDragContent(true);
            createVpaForm.reset();
        });

        return this;
    }
]);
