'use strict';

angularApp.controller('mmidDetailsController', 
						["$timeout",
						 "$state",
						 "$location",
						 "$scope",
						 "$rootScope",
						 "utilityService",
						 "MMservice",
						 "$ionicPopup",
						 "$ionicSideMenuDelegate",
						 "getAccountDetailsService",

				 
function ($timeout,
		 $state,
		 $location,
		 $scope,
		 $rootScope,
		 utilityService,
		 MMservice,
		 $ionicPopup,
		 $ionicSideMenuDelegate,
		 getAccountDetailsService) {
	
	//functions, variables that can be accessed from the HTML come here
	var mmidDetailsVm = this;
	
	//private methods section start
	function initPage(){
		mmidDetailsVm.showBack = false;
		mmidDetailsVm.showNext = true;
		
		//get Account details
		 if (!getAccountDetailsService.accountOverviewData) {
			MMservice.getAccountDetails().then(function(data) {  
				getAccountDetailsService.accountOverviewData = data;
				mmidDetailsVm.accounts = data.accounts;
				$timeout(function(){
					mmidDetailsVm.account =  mmidDetailsVm.accounts[0].accountNumber; //set primary account
					mmidDetailsVm.mobileNo = $rootScope.mobileNo; 
					mmidDetailsVm.customerName = $rootScope.customerName;
					mmidDetailsVm.viewMmidData();
				},1000);
			}, function(error) {
				utilityService.showErrorMessage(error.responseMessage);
				$state.go('menu.settings');
			});
		}else{
			mmidDetailsVm.accounts = getAccountDetailsService.accountOverviewData.accounts;	
			if(mmidDetailsVm.accounts){
				$timeout(function(){
					mmidDetailsVm.account =  mmidDetailsVm.accounts[0].accountNumber; //set primary account
					mmidDetailsVm.mobileNo = $rootScope.mobileNo; 
					mmidDetailsVm.customerName = $rootScope.customerName;
					mmidDetailsVm.viewMmidData();
				},1000);
			}
		}
	}
	//private methods section end
	
	//this function is define to view MMID
	mmidDetailsVm.viewMmidData = function(){
		var reqParams = {};
		reqParams["remAccntNo"] = mmidDetailsVm.account;
		reqParams["remName"] = mmidDetailsVm.customerName;
		reqParams["inbUserID"] = "";
		reqParams["remMobileNo"] =$rootScope.mobileNo;
		
		MMservice.viewMMID(reqParams).then(function(data){
				mmidDetailsVm.mmid = data.mmid; 
				if(mmidDetailsVm.mmid != null) 
					mmidDetailsVm.mmid = mmidDetailsVm.mmid.toString();
			}, function(error){
				mmidDetailsVm.mmid=[];
				utilityService.showErrorMessage(error.responseMessage);

		});
	}
	
	//this function is called when account dropdown value is change
	mmidDetailsVm.accountChange = function(){
		mmidDetailsVm.viewMmidData();
	}
	
	//this function os define to close current view
	mmidDetailsVm.closeView = function(){
		$state.go('menu.settings');
	}
	
	//back to prev page
	mmidDetailsVm.goBacktoPrevious = function(){
		$state.go('menu.settings');
	}
	
	
	//one time initialization to be done when the controller is loaded
	$scope.$on('$ionicView.loaded', function() {
		$ionicSideMenuDelegate.canDragContent(false);
	});
	
	//actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function() {
		$ionicSideMenuDelegate.canDragContent(false);
		initPage();
	});
	
	//actions to done everytime the view is hidden
	$scope.$on('$ionicView.afterLeave', function() {
		$ionicSideMenuDelegate.canDragContent(true);
		//any cleanup needs to be done here: executes everytime when page is left
	});
	return this;
}]);