'use strict';

angularApp.controller('notificationsController', 
						["$timeout",
						 "$state",
						 "$location",
						 "$scope",
						 "utilityService",
						 "notificationsService",
						 "$ionicPopup",
						 "$rootScope",
				 
function ($timeout,
		 $state,
		 $location,
		 $scope,
		 utilityService,
		 notificationsService,
		 $ionicPopup,
		 $rootScope) {
	
	//functions, variables that can be accessed from the HTML come here
	var notificationsVm = this;
	
	
	//$location.hash('setNotificationsView');
	
	//private methods section start
	function initPage(){
		notificationsVm.showBack = true;
		notificationsVm.showNext = true;
		
		notificationsVm.getAcctNotifn();
		
		
	}
	
	//account notification change
	notificationsVm.acctNotfnChange = function(){
		if(notificationsVm.accNotfn){
			notificationsVm.alertsNotfn = true;
			notificationsVm.offersNotfn = true;
		}
		else {
			notificationsVm.alertsNotfn = false;
			notificationsVm.offersNotfn = false;
		}
		
		notificationsVm.setAcctNotifn();
	}
	//Alert Notification function Change
	notificationsVm.alertsNotfnChange = function(){
		if(notificationsVm.alertsNotfn || notificationsVm.offersNotfn)
			notificationsVm.accNotfn = true;
		if(!notificationsVm.alertsNotfn && !notificationsVm.offersNotfn)
			notificationsVm.accNotfn = false;
		
		notificationsVm.setAcctNotifn();
		
	}
	//offer Notification function Change
	notificationsVm.offersNotfnChange = function(){
		if(notificationsVm.alertsNotfn || notificationsVm.offersNotfn)
			notificationsVm.accNotfn = true;
		if(!notificationsVm.alertsNotfn && !notificationsVm.offersNotfn)
			notificationsVm.accNotfn = false;
		
		notificationsVm.setAcctNotifn();
	}
	
	//set alert notifications
	notificationsVm.setAcctNotifn = function(){
		var reqParams = {};
		reqParams["alert"] = notificationsVm.alertsNotfn;
		reqParams["offers"] = notificationsVm.offersNotfn;
		
		notificationsService.setAccountNotification(reqParams).then(function(data){
				/*$ionicPopup.alert({
				   title: $rootScope.popupTitle,
				   cssClass: 'response-alert',
				   template: data.message
				});*/
			}, function(error){
				utilityService.showErrorMessage(error.responseMessage);

		});
	}
	
	//get alert notifications
	notificationsVm.getAcctNotifn = function(){
		notificationsService.getAccountNotification().then(function(data){
				notificationsVm.alertsNotfn = data.alert;
				notificationsVm.offersNotfn = data.offers;
				notificationsVm.alertsNotfnChange();
				notificationsVm.offersNotfnChange();
			}, function(error){
				utilityService.showErrorMessage(error.responseMessage);

		});
	}
	
	//private methods section end
	
	//public functions start
	
	//public functions end
	
	//close current view
	notificationsVm.closeView = function(){
		$state.go('menu.settings');
	}
	
	//back to prev page
	notificationsVm.goBacktoPrevious = function(){
		$state.go('menu.settings');
	}
	
	//go to next page
	notificationsVm.goToNextPage = function(){
		$state.go('menu.accountOverviewPopup');
	}
	
	
	//one time initialization to be done when the controller is loaded
	$scope.$on('$ionicView.loaded', function() {
	});
	
	//actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function() {
		initPage();
	});
	
	//actions to done everytime the view is hidden
	$scope.$on('$ionicView.afterLeave', function() {
		//any cleanup needs to be done here: executes everytime when page is left
	});
	return this;
}]);
