'use strict';

angularApp.controller('selPrimaryAccController', 
						["$state",
						 "$location",
						 "$scope",
						 "$rootScope",
						 "utilityService",
						 "selectPrimaryAccService",
						 "$ionicPopup",
						 "$ionicSideMenuDelegate",
						 "getAccountDetailsService",
				 
function ($state,
		 $location,
		 $scope,
		 $rootScope,
		 utilityService,
		 selectPrimaryAccService,
		 $ionicPopup,
		 $ionicSideMenuDelegate,
		 getAccountDetailsService) {
	
	//functions, variables that can be accessed from the HTML come here
	var selPrimaryAccVm = this;
	
	//private methods section start
	function initPage(){
		selPrimaryAccVm.showBack = true;
		selPrimaryAccVm.showNext = true;
		//get Account details
		selPrimaryAccVm.getAccountList();
		//set primary account
		if(selPrimaryAccVm.accounts){
			selPrimaryAccVm.accountNumber = $rootScope.customerAccNo;
			for(var acc in selPrimaryAccVm.accounts){
				if(selPrimaryAccVm.accounts[acc]['accountNumber'] == selPrimaryAccVm.accountNumber){
					selPrimaryAccVm.accountType = selPrimaryAccVm.accounts[acc]['accountType'];
					$rootScope.senderAccountType=selPrimaryAccVm.accountType;
					$rootScope.senderAccountNumber=selPrimaryAccVm.accountNumber;
				}
			}
		
		}
		
	}
	selPrimaryAccVm.getAccountList=function(){
		selPrimaryAccVm.displaySpinner=true;
		if(getAccountDetailsService.accountOverviewData==""){
			getAccountDetailsService.getAccountDetails().then(function(data){
				selPrimaryAccVm.accounts = data.accounts;
					selPrimaryAccVm.displaySpinner=false;
			}, function(error){
			selPrimaryAccVm.displaySpinner=false;
		});
		}else{
			selPrimaryAccVm.displaySpinner=false;
		selPrimaryAccVm.accounts = getAccountDetailsService.accountOverviewData.accounts;	
		}
		
	}
	//defaultAccount function on radio change
	selPrimaryAccVm.defaultAccount = function(){
		selPrimaryAccVm.setAccountType();
	}
	
	//to get account type
	selPrimaryAccVm.setAccountType = function(){
		for(var acc in selPrimaryAccVm.accounts){
			if(selPrimaryAccVm.accounts[acc]['accountNumber'] == selPrimaryAccVm.accountNumber){
				selPrimaryAccVm.accountType = selPrimaryAccVm.accounts[acc]['accountType'];
				
			}
		}
	}
	
	  /*************Confirm Primary Account start***************/
	selPrimaryAccVm.confirmPrimAcc = function(){
		var reqParams = {};
		reqParams["accountType"] = selPrimaryAccVm.accountType;
		reqParams["accountNumber"] = selPrimaryAccVm.accountNumber;
		$rootScope.receAccountType=selPrimaryAccVm.accountType;
		$rootScope.receAccountNumber=selPrimaryAccVm.accountNumber;
		
		
		selectPrimaryAccService.setDefaultAccount(reqParams).then(function(data){
			$rootScope.customerAccNo=$rootScope.receAccountNumber;
			var showPopup = $ionicPopup.show({
			templateUrl: 'pages/settings/personalisation/selPrimaryAcc/successPopup.html',
			scope: $scope,
			cssClass: 'dialog',
			buttons: [{
				text: 'Ok',
				type: 'button-positive',
				onTap: function(e) {
					showPopup.close();  
					getAccountDetailsService.accountOverviewData="";
					$state.go('menu.settings');
					e.preventDefault();
						
				}
			}]
		});
		
			
			}, function(error){
				
				utilityService.showErrorMessage(error.responseMessage);

		});
	}
	  /*************Confirm Primary Account end***************/
	
	selPrimaryAccVm.closeView = function(){
		$state.go('menu.settings');
	}
	
	//back to prev page
	selPrimaryAccVm.goBacktoPrevious = function(){
		$state.go('menu.settings');
	}
	
	//go to next page
	selPrimaryAccVm.goToNextPage = function(){
		
	}
	
	
	//one time initialization to be done when the controller is loaded
	$scope.$on('$ionicView.loaded', function() {
		$ionicSideMenuDelegate.canDragContent(false);
	});
	
	//actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function() {
	$ionicSideMenuDelegate.canDragContent(false);
		initPage();
	});
	
	//actions to done everytime the view is hidden
	$scope.$on('$ionicView.afterLeave', function() {
		$ionicSideMenuDelegate.canDragContent(true);
		//any cleanup needs to be done here: executes everytime when page is left
	});
	return this;
}]);
