'use strict';

angularApp.controller('myProfileController', 
						["$timeout",
						 "$state",
						 "$filter",
						 "$scope",
						 "$rootScope",
						 "utilityService",
						 "myProfileService",
						 "cameraService",
						 "$ionicPopup",
						 "ionicDatePicker",
						 "$http",
						 "cryptoService",
				 
function ($timeout,
		 $state,
		 $filter,
		 $scope,
		 $rootScope,
		 utilityService,
		 myProfileService,
		 cameraService,
		 $ionicPopup,
		 ionicDatePicker,
		 $http,
		 cryptoService) {
	
	//functions, variables that can be accessed from the HTML come here
	var myProfileVm = this;
	myProfileVm.selectReligionDiv=true;
	//private methods section start
	function initPage(){
		myProfileVm.showBack = false;
		myProfileVm.showNext = true;
		myProfileVm.percentage = $rootScope.profileScore;
		myProfileVm.professionalEditFlag=true;
		myProfileVm.perInfoEditClicked = false;
		myProfileVm.identificationInfoEditClicked = false;
		myProfileVm.professionalInfoEditClicked = false;
		myProfileVm.educationInfoEditClicked = false;
		myProfileVm.familyInfoEditClicked = false;
		myProfileVm.houseOwnershipInfoEditClicked = false;
		myProfileVm.twoWheelerDetailsInfoEditClicked = false;
		myProfileVm.lifeInsuranceInfoEditClicked = false;
		myProfileVm.healthInsuranceInfoEditClicked = false;
		myProfileVm.existingLoansInfoEditClicked = false;
		myProfileVm.socialInfoEditClicked = false;
		myProfileVm.marketingOffersInfoEditClicked = false;
		myProfileVm.notificationChannelsInfoEditClicked = false;
		myProfileVm.imageSizeError=true;
		myProfileVm.ckycFieldUpdated = false;
		myProfileVm.personalFieldUpdated = false;
	
		myProfileVm.getDetailFun(true);
		myProfileVm.getProfileQuestionsFun();
		myProfileVm.loadQuesKeyValJson();
		myProfileService.getProfilePercent().then(function(data){
			myProfileVm.percentage=data.profilePercentage;
			$rootScope.profileScore=data.profilePercentage;
		}, function(error){
		});
		
		//gender dropdown start
		myProfileVm.genderDropDown = function(data){
			myProfileVm.genders = data;			
			//set selected value
			for(var gender in myProfileVm.genders){
				if(myProfileVm.genders[gender]["key"] == myProfileVm.genderId){
					myProfileVm.genderValue = myProfileVm.genders[gender].title;
					myProfileVm.genderId = myProfileVm.genders[gender].key;
				}
			}
		}
		//gender dropdown end
		
		
		
		
		//maritalStatus dropdown start
		myProfileVm.maritalDropDown = function(data)
			{
				myProfileVm.maritals = data;
				//set selected value
				for(var marital in myProfileVm.maritals){
					if(myProfileVm.maritals[marital]["key"].toLowerCase() == myProfileVm.maritalId.toLowerCase()){
						myProfileVm.maritalValue = myProfileVm.maritals[marital].title;
						myProfileVm.maritalId = myProfileVm.maritals[marital].key;
						myProfileVm.maritalData = myProfileVm.maritals[marital];
					}
				}	
				
				$scope.maritalModel = myProfileVm.maritalId != '' && myProfileVm.maritalId != undefined ? {id:myProfileVm.maritalId} : {}; //use [] for multiple values
				$scope.maritalModelSettings = {
						showCheckAll : false, showUncheckAll : false,
						displayProp : 'title',
						idProp : 'key',
						selectionLimit: 1,
						smartButtonMaxItems: 1,
						closeOnSelect: true,
						styleActive: true,
						smartButtonTextConverter: function(itemText, originalItem) {
							myProfileVm.maritalValue = originalItem.title;
							return itemText;
						}
				};
				$scope.maritalModelTranslation = {buttonDefaultText: 'Please Choose'};
				//maritalStatus dropdown end
				
				//maritalStatus show other field start
				$scope.$watch("myProfileVm.maritalValue", function(value) {
					if(value == "Others")
						myProfileVm.showOtherMarital = true;
					else myProfileVm.showOtherMarital = false;
				});
			}
		//maritalStatus show other field end

		//religion dropdown start
		myProfileVm.religionDropDown = function(data){
			myProfileVm.religions = data;
			//set selected value
			for(var religion in myProfileVm.religions){
				if(myProfileVm.religions[religion]["key"] == myProfileVm.religionId){
					myProfileVm.religionValue = myProfileVm.religions[religion].title;
					myProfileVm.religionId = myProfileVm.religions[religion].key;
					myProfileVm.religionData = myProfileVm.religions[religion];
					myProfileVm.categories = myProfileVm.religionData.category;
					for(var category in myProfileVm.categories){
						if(myProfileVm.categories[category]["categoryCode"] == myProfileVm.categoryId){
							myProfileVm.categoryValue = myProfileVm.categories[category].categoryName;
							myProfileVm.categoryId = myProfileVm.categories[category].categoryCode;
							myProfileVm.categoryData = myProfileVm.categories[category];
						}
					}
				}
			}
		}
		//religion dropdown end

		//category dropdown start
		myProfileVm.categoryDropDown = function(data){
			myProfileVm.categories = data;				
			//set selected value
			for(var category in myProfileVm.categories){
				if(myProfileVm.categories[category]["key"] == myProfileVm.categoryId){
					myProfileVm.categoryValue = myProfileVm.categories[category].title;
					myProfileVm.categoryId = myProfileVm.categories[category].key;
					myProfileVm.categoryData = myProfileVm.categories[category];
				}
			}
		}
		//category dropdown end

		//birthPlace dropdown start
		myProfileVm.birthPlaceDropDown = function(data){
			myProfileVm.birthPlaceList = data;
			myProfileVm.birthPlaceId = '';				
			//set selected value
			for(var city in myProfileVm.birthPlaceList){
				if(myProfileVm.birthPlaceList[city]["title"] == myProfileVm.birthPlaceValue){
					myProfileVm.birthPlaceValue = myProfileVm.birthPlaceList[city].title;
					myProfileVm.birthPlaceId = myProfileVm.birthPlaceList[city].key;
				}
			}
		}
		//category dropdown end
		
		
		//Identidication Other dropdown start
		myProfileVm.idOtherDropDown = function(data)
			{
				myProfileVm.idOthers = data;
				//set selected value
				for(var idOtherdata in myProfileVm.idOthers){
					if(myProfileVm.idOthers[idOtherdata]["title"].toLowerCase() == myProfileVm.idOther.toLowerCase()){
						myProfileVm.idOther = myProfileVm.idOthers[idOtherdata].title;
						myProfileVm.idOtherId = myProfileVm.idOthers[idOtherdata].key;
					}
				}	
				
				$scope.idOtherModel = myProfileVm.idOtherId != '' && myProfileVm.idOtherId != undefined ? {id:myProfileVm.idOtherId} : {}; //use [] for multiple values
				$scope.idOtherModelSettings = {
						showCheckAll : false, showUncheckAll : false,
						displayProp : 'title',
						idProp : 'key',
						selectionLimit: 1,
						smartButtonMaxItems: 1,
						closeOnSelect: true,
						styleActive: true,
						smartButtonTextConverter: function(itemText, originalItem) {
							myProfileVm.idOther = originalItem.title;
							return itemText;
						}
				};
				$scope.idOtherModelTranslation = {buttonDefaultText: 'Please Choose'};
			}
		//Identidication Other field end
		
		
		
		//occupation dropdown start
		myProfileVm.occupationDropDown = function(data){
			myProfileVm.occupations = data;
			//set selected value
			for(var occupation in myProfileVm.occupations){
				if(myProfileVm.occupations[occupation]["key"] == myProfileVm.occupationId){
					myProfileVm.occupationValue = myProfileVm.occupations[occupation].title;
					myProfileVm.occupationId = myProfileVm.occupations[occupation].key;
					myProfileVm.occupationData = myProfileVm.occupations[occupation];
				}
			}		
		}
		//occupation dropdown end
		
		//occupationSubDropDown start
		myProfileVm.occupationSubDropDown = function(data){
			myProfileVm.occupationHasChild = false;
			myProfileVm.childOptions = data;
			
			if(myProfileVm.childOptions.length > 0){
				myProfileVm.occupationHasChild = true;
				myProfileVm.childOptionId = '';
				myProfileVm.childOptionValue = '';
				
				//set selected value
				for(var opt in myProfileVm.childOptions){
					if(myProfileVm.childOptions[opt]["title"] == myProfileVm.childOptionValue){
						myProfileVm.childOptionValue = myProfileVm.childOptions[opt].title;
						myProfileVm.childOptionId = myProfileVm.childOptions[opt].key;
					}
				}
				
				$scope.childOptionModel = myProfileVm.childOptionId != '' && myProfileVm.childOptionId != undefined ? {id:myProfileVm.childOptionId} : {}; //use [] for multiple values
				$scope.childOptionModelSettings = {
						showCheckAll : false, showUncheckAll : false,
						displayProp : 'title',
						idProp : 'key',
						selectionLimit: 1,
						smartButtonMaxItems: 1,
						closeOnSelect: true,
						styleActive: true,
						smartButtonTextConverter: function(itemText, originalItem) {
							myProfileVm.childOptionValue = originalItem.title;
							return itemText;
						}
				};
				$scope.childOptionModelTranslation = {buttonDefaultText: 'Please Choose'};
			}
		}
		//occupationSubDropDown end
		
		//natureOfEmp dropdown start
		myProfileVm.natureBusinessDropDown = function(data)
		{
			myProfileVm.natureOfEmps = data;
			myProfileVm.natureOfEmpId = '';
			//set selected value
			for(var natureOfEmp in myProfileVm.natureOfEmps){
				if(myProfileVm.natureOfEmps[natureOfEmp]["title"] == myProfileVm.natureOfEmpValue){
					myProfileVm.natureOfEmpValue = myProfileVm.natureOfEmps[natureOfEmp].title;
					myProfileVm.natureOfEmpId = myProfileVm.natureOfEmps[natureOfEmp].key;
				}
			}
			
			$scope.natureOfEmpModel = myProfileVm.natureOfEmpId != '' && myProfileVm.natureOfEmpId != undefined ? {id:myProfileVm.natureOfEmpId} : {}; //use [] for multiple values
			$scope.natureOfEmpModelSettings = {
					showCheckAll : false, showUncheckAll : false,
					displayProp : 'title',
					idProp : 'key',
					selectionLimit: 1,
					smartButtonMaxItems: 1,
					closeOnSelect: true,
					styleActive: true,
					smartButtonTextConverter: function(itemText, originalItem) {
						myProfileVm.natureOfEmpValue = originalItem.title;
						return itemText;
					}
			};
			$scope.natureOfEmpModelTranslation = {buttonDefaultText: 'Please Choose'};
		}
		//natureOfEmp dropdown end
		
		//anualIncome dropdown start
		myProfileVm.annualIncomeDropDown = function(data)
		{
			myProfileVm.anualIncomes = data;
			myProfileVm.anualIncomeId = '';
			//set selected value
			for(var anualIncome in myProfileVm.anualIncomes){
				if(myProfileVm.anualIncomes[anualIncome]["title"] == myProfileVm.anualIncomeValue){
					myProfileVm.anualIncomeValue = myProfileVm.anualIncomes[anualIncome].title;
					myProfileVm.anualIncomeId = myProfileVm.anualIncomes[anualIncome].key;
				}
			}
			
			$scope.anualIncomeModel = myProfileVm.anualIncomeId != '' && myProfileVm.anualIncomeId != undefined ? {id:myProfileVm.anualIncomeId} : {}; //use [] for multiple values
			$scope.anualIncomeModelSettings = {
					showCheckAll : false, showUncheckAll : false,
					displayProp : 'title',
					idProp : 'key',
					selectionLimit: 1,
					smartButtonMaxItems: 1,
					closeOnSelect: true,
					styleActive: true,
					smartButtonTextConverter: function(itemText, originalItem) {
						myProfileVm.anualIncomeValue = originalItem.title;
						return itemText;
					}
			};
			$scope.anualIncomeModelTranslation = {buttonDefaultText: 'Please Choose'};
		}
		//anualIncome dropdown end
		
		//Education dropdown start
		myProfileVm.educationDropDown = function(data){
			myProfileVm.qualifications = data;
			//set selected value
			for(var educationalDetail in myProfileVm.qualifications){
				if(myProfileVm.qualifications[educationalDetail]["key"] == parseInt(myProfileVm.educationalDetailId)){
					myProfileVm.educationalDetailsData = myProfileVm.qualifications[educationalDetail];
					myProfileVm.educationalDetailValue = myProfileVm.qualifications[educationalDetail].title;
					myProfileVm.educationalDetailId = myProfileVm.qualifications[educationalDetail].key;
					myProfileVm.educationalDetailPriority = myProfileVm.qualifications[educationalDetail].priority;
				}
			}
		}
		//Education dropdown end
		
		//house_owner Start 
		myProfileVm.houseOwnershipDropDown = function(data)
		{
				myProfileVm.residenceStatuses = data;
				myProfileVm.residenceStatusId = '';
				//set selected value
				
				for(var residenceStatus in myProfileVm.residenceStatuses){
					if(myProfileVm.residenceStatuses[residenceStatus]["title"] ==  myProfileVm.residenceStatusValue){
						myProfileVm.residenceStatusValue = myProfileVm.residenceStatuses[residenceStatus].title;
						myProfileVm.residenceStatusId = myProfileVm.residenceStatuses[residenceStatus].key;
					}
				}
				
				$scope.residenceStatusModel = myProfileVm.residenceStatusId != '' && myProfileVm.residenceStatusId != undefined ? {id:myProfileVm.residenceStatusId} : {}; //use [] for multiple values
				$scope.residenceStatusModelSettings = {
						showCheckAll : false, showUncheckAll : false,
						displayProp : 'title',
						idProp : 'key',
						selectionLimit: 1,
						smartButtonMaxItems: 1,
						closeOnSelect: true,
						styleActive: true,
						smartButtonTextConverter: function(itemText, originalItem) {
							myProfileVm.residenceStatusValue = originalItem.title;
							return itemText;
						}
				};
				$scope.residenceStatusModelTranslation = {buttonDefaultText: 'Please Choose'};
		}
		//house_owner dropdown end
		
		//car_Ownership dropdown start
		myProfileVm.carDropDown = function(data)
		{
			myProfileVm.carDetails = data;
			//myProfileVm.carDetailValue = ''; 
			myProfileVm.carDetailId = '';
			//set selected value
			
			for(var carDetail in myProfileVm.carDetails){
				if(myProfileVm.carDetails[carDetail]["title"] == myProfileVm.carDetailValue){
					myProfileVm.carDetailValue = myProfileVm.carDetails[carDetail].title;
					myProfileVm.carDetailId = myProfileVm.carDetails[carDetail].key;
				}
			}
			
			$scope.carDetailModel = myProfileVm.carDetailId != '' && myProfileVm.carDetailId != undefined ? {id:myProfileVm.carDetailId} : {}; //use [] for multiple values
			$scope.carDetailModelSettings = {
					showCheckAll : false, showUncheckAll : false,
					displayProp : 'title',
					idProp : 'key',
					selectionLimit: 1,
					smartButtonMaxItems: 1,
					closeOnSelect: true,
					styleActive: true,
					smartButtonTextConverter: function(itemText, originalItem) {
						myProfileVm.carDetailValue = originalItem.title;
						return itemText;
					}
			};
			$scope.carDetailModelTranslation = {buttonDefaultText: 'Please Choose'};
		}
		//CAR_Ownership dropdown end
		
		//two-wheeler dropdown Start 
		myProfileVm.twoWheelerDropDown = function(data)
		{
			myProfileVm.twoWheelerDetails = data; 
			myProfileVm.twoWheelerDetailId = '';
			//set selected value
			
			for(var twoWheelerDetail in myProfileVm.twoWheelerDetails){
				if(myProfileVm.twoWheelerDetails[twoWheelerDetail]["title"] == myProfileVm.twoWheelerDetailValue){
					myProfileVm.twoWheelerDetailValue = myProfileVm.twoWheelerDetails[twoWheelerDetail].title;
					myProfileVm.twoWheelerDetailId = myProfileVm.twoWheelerDetails[twoWheelerDetail].key;
				}
			}
			
			$scope.twoWheelerDetailModel = myProfileVm.twoWheelerDetailId != '' && myProfileVm.twoWheelerDetailId != undefined ? {id:myProfileVm.twoWheelerDetailId} : {}; //use [] for multiple values
			$scope.twoWheelerDetailModelSettings = {
					showCheckAll : false, showUncheckAll : false,
					displayProp : 'title',
					idProp : 'key',
					selectionLimit: 1,
					smartButtonMaxItems: 1,
					closeOnSelect: true,
					styleActive: true,
					smartButtonTextConverter: function(itemText, originalItem) {
						myProfileVm.twoWheelerDetailValue = originalItem.title;
						return itemText;
					}
			};
			$scope.twoWheelerDetailModelTranslation = {buttonDefaultText: 'Please Choose'};
		}
		//two-wheeler dropdown end 
		
		//lifeInsurance dropdown start
		myProfileVm.lifeInsuranceDropDown = function(data){
				myProfileVm.lifeInsuranceDetails = data;
				myProfileVm.lifeInsuranceDetailId = '';
				//set selected value
				
				for(var lifeInsuranceDetail in myProfileVm.lifeInsuranceDetails){
					if(myProfileVm.lifeInsuranceDetails[lifeInsuranceDetail]["title"] == myProfileVm.lifeInsuranceDetailValue){
						myProfileVm.lifeInsuranceDetailValue = myProfileVm.lifeInsuranceDetails[lifeInsuranceDetail].title;
						myProfileVm.lifeInsuranceDetailId = myProfileVm.lifeInsuranceDetails[lifeInsuranceDetail].key;
					}
				}
				
				$scope.lifeInsuranceDetailModel = myProfileVm.lifeInsuranceDetailId != '' && myProfileVm.lifeInsuranceDetailId != undefined ? {id:myProfileVm.lifeInsuranceDetailId} : {}; //use [] for multiple values
				$scope.lifeInsuranceDetailModelSettings = {
						showCheckAll : false, showUncheckAll : false,
						displayProp : 'title',
						idProp : 'key',
						selectionLimit: 1,
						smartButtonMaxItems: 1,
						closeOnSelect: true,
						styleActive: true,
						smartButtonTextConverter: function(itemText, originalItem) {
						myProfileVm.lifeInsuranceDetailValue = originalItem.title;
							return itemText;
						}
				};
				$scope.lifeInsuranceDetailModelTranslation = {buttonDefaultText: 'Please Choose'};	
		}
		//lifeInsurance dropdown end
		
		//healthInsurance dropdown start
		myProfileVm.healthInsuranceDropDown = function(data)
		{
			myProfileVm.healthInsuranceDetails = data;
			myProfileVm.healthInsuranceDetailId = '';
			//set selected value
			
			for(var healthInsuranceDetail in myProfileVm.healthInsuranceDetails){

				if(myProfileVm.healthInsuranceDetails[healthInsuranceDetail]["title"] == myProfileVm.healthInsuranceDetailValue){
					myProfileVm.healthInsuranceDetailValue = myProfileVm.healthInsuranceDetails[healthInsuranceDetail].title;
					myProfileVm.healthInsuranceDetailId = myProfileVm.healthInsuranceDetails[healthInsuranceDetail].key;
				}
			}
			
			$scope.healthInsuranceDetailModel = myProfileVm.healthInsuranceDetailId != '' && myProfileVm.healthInsuranceDetailId != undefined ? {id:myProfileVm.healthInsuranceDetailId} : {}; //use [] for multiple values
			$scope.healthInsuranceDetailModelSettings = {
					showCheckAll : false, showUncheckAll : false,
					displayProp : 'title',
					idProp : 'key',
					selectionLimit: 1,
					smartButtonMaxItems: 1,
					closeOnSelect: true,
					styleActive: true,
					smartButtonTextConverter: function(itemText, originalItem) {
					myProfileVm.healthInsuranceDetailValue = originalItem.title;
						return itemText;
					}
			};
			$scope.healthInsuranceDetailModelTranslation = {buttonDefaultText: 'Please Choose'};
		}
		//healthInsurance dropdown end
		
		//familyInsurance dropdown start
		myProfileVm.familyInsuranceDropDown = function(data)
		{
			myProfileVm.familyhealthInsuranceDetails = data;
				myProfileVm.familyhealthInsuranceDetailId = '';
				//set selected value
				
				for(var familyhealthInsuranceDetail in myProfileVm.familyhealthInsuranceDetails){
					if(myProfileVm.familyhealthInsuranceDetails[familyhealthInsuranceDetail]["title"] == myProfileVm.familyhealthInsuranceDetailValue){
						myProfileVm.familyhealthInsuranceDetailValue = myProfileVm.familyhealthInsuranceDetails[familyhealthInsuranceDetail].title;
						myProfileVm.familyhealthInsuranceDetailId = myProfileVm.familyhealthInsuranceDetails[familyhealthInsuranceDetail].key;
					}
				}
				
				$scope.familyhealthInsuranceDetailModel = myProfileVm.familyhealthInsuranceDetailId != '' && myProfileVm.familyhealthInsuranceDetailId != undefined ? {id:myProfileVm.familyhealthInsuranceDetailId} : {}; //use [] for multiple values
				$scope.familyhealthInsuranceDetailModelSettings = {
						showCheckAll : false, showUncheckAll : false,
						displayProp : 'title',
						idProp : 'key',
						selectionLimit: 1,
						smartButtonMaxItems: 1,
						closeOnSelect: true,
						styleActive: true,
						smartButtonTextConverter: function(itemText, originalItem) {
						myProfileVm.familyhealthInsuranceDetailValue = originalItem.title;
							return itemText;
						}
				};
				$scope.familyhealthInsuranceDetailModelTranslation = {buttonDefaultText: 'Please Choose'};
		}
		//familyInsurance dropdown end
		
		//EXISTING_LOANS_DETAIL dropdown start
		myProfileVm.existingLoanDetailDropDown = function(data){
			myProfileVm.existingLoanDetails = data;
			myProfileVm.existingLoanDetailId = '';
			//set selected value
			
			for(var existingLoanDetail in myProfileVm.existingLoanDetails){
				if(myProfileVm.existingLoanDetails[existingLoanDetail]["title"] == myProfileVm.existingLoanDetailValue){
					myProfileVm.existingLoanDetailValue = myProfileVm.existingLoanDetails[existingLoanDetail].title;
					myProfileVm.existingLoanDetailId = myProfileVm.existingLoanDetails[existingLoanDetail].key;
				}
			}
			
			$scope.existingLoanDetailModel = myProfileVm.existingLoanDetailId != '' && myProfileVm.existingLoanDetailId != undefined ? {id:myProfileVm.existingLoanDetailId} : {}; //use [] for multiple values
			$scope.existingLoanDetailModelSettings = {
					showCheckAll : false, showUncheckAll : false,
					displayProp : 'title',
					idProp : 'key',
					selectionLimit: 1,
					smartButtonMaxItems: 1,
					closeOnSelect: true,
					styleActive: true,
					smartButtonTextConverter: function(itemText, originalItem) {
						myProfileVm.existingLoanDetailValue = originalItem.title;
						return itemText;
					}
			};
			$scope.existingLoanDetailModelTranslation = {buttonDefaultText: 'Please Choose'};
		}
		//EXISTING_LOANS_DETAIL dropdown end
		
		//EXISTING_LOANS_TYPE dropdown start
		myProfileVm.existingLoanTypeDropDown = function(data){
			
			myProfileVm.existingLoanTypes = data;
			//set selected value
			
			for(var existingLoanType in myProfileVm.existingLoanTypes){
				if(myProfileVm.existingLoanTypes[existingLoanType]["title"] == myProfileVm.existingLoanTypeValue){
					myProfileVm.existingLoanTypeValue = myProfileVm.existingLoanTypes[existingLoanType].title;
				}
			}
			
			$scope.existingLoanTypeModel = []; //use [] for multiple values
			$scope.existingLoanTypeModelSettings = {
					showCheckAll : false, showUncheckAll : false,
					displayProp : 'title',
					idProp : 'key',
					externalIdProp: '',
					smartButtonMaxItems: myProfileVm.existingLoanTypes.length,
					closeOnSelect: false,
					styleActive: true,
					smartButtonTextConverter: function(itemText, originalItem) {
						myProfileVm.existingLoanTypeValue = '';
					
						for(var i=0;i < $scope.existingLoanTypeModel.length;i++){
							if(i==$scope.existingLoanTypeModel.length-1){
								myProfileVm.existingLoanTypeValue += $scope.existingLoanTypeModel[i].title;  
							}else{
								myProfileVm.existingLoanTypeValue += $scope.existingLoanTypeModel[i].title+", ";  
							}
						}
					
						return itemText;
					}
			};
			$scope.existingLoanTypeModelTranslation = {buttonDefaultText: 'Please Choose'};
			
		}
		//EXISTING_LOANS_TYPE dropdown end
		
		//loanDropDown dropdown start
		myProfileVm.loanDropDown = function(data){
			
			myProfileVm.loans = data;
			myProfileVm.loanValue = '';
			//set selected value

			
			
			if(!$scope.loanModel){
				$scope.loanModel = []; //use [] for multiple values
				for(var i=0;i<$scope.currentLoanValueArray.length;i++){
				
					for(var j=0;j<myProfileVm.loans.length;j++){
						if(($scope.currentLoanValueArray[i].title).trim()==myProfileVm.loans[j].title){
							$scope.currentLoanValueArray[i].key=myProfileVm.loans[j].key;
						}
					}
				}
				$timeout(function(){
					$scope.loanModel=$scope.currentLoanValueArray;
				},200);
			}
			
			
				$scope.loanModelSettings = {
						showCheckAll : false, showUncheckAll : false,
						displayProp : 'title',
						idProp : 'key',
						externalIdProp: '',
						//selectionLimit: myProfileVm.loans.length,
						smartButtonMaxItems: myProfileVm.loans.length,
						closeOnSelect: false,
						styleActive: true,
						smartButtonTextConverter: function(itemText, originalItem) {
							myProfileVm.loanValue = '';
						
							for(var i=0;i < $scope.loanModel.length;i++){
								if(i==$scope.loanModel.length-1){
									myProfileVm.loanValue += $scope.loanModel[i].title;  
								}else{
									myProfileVm.loanValue += $scope.loanModel[i].title+", ";  
								}
							}
						
							return itemText;
						}
				};
				$scope.loanModelTranslation = {buttonDefaultText: 'Please Choose'};	
			
		}
		//loanDropdown dropdown end
		
		
		//investmentsDropDown dropdown start
		myProfileVm.investmentsDropDown = function(data){
			
			myProfileVm.investments = data;
			myProfileVm.investmentValue = ''; 
			//set selected value

			
			
			if(!$scope.investmentModel){
				$scope.investmentModel = []; //use [] for multiple values
				
				for(var i=0;i<$scope.currentInvestmentsArray.length;i++){
					for(var j=0;j<myProfileVm.investments.length;j++){
						if(($scope.currentInvestmentsArray[i].title).trim()==myProfileVm.investments[j].title){
							$scope.currentInvestmentsArray[i].key=myProfileVm.investments[j].key;
						}
					}
				}
				$timeout(function(){
					$scope.investmentModel=$scope.currentInvestmentsArray;
				},500);
			}
			$scope.investmentModelSettings = {
					showCheckAll : false, showUncheckAll : false,
					displayProp : 'title',
					idProp : 'key',
					externalIdProp: '',
					
					smartButtonMaxItems: myProfileVm.investments.length,
					closeOnSelect: false,
					styleActive: true,
					smartButtonTextConverter: function(itemText, originalItem) {
						myProfileVm.investmentValue = '';
					
						for(var i=0;i < $scope.investmentModel.length;i++){
							if(i==$scope.investmentModel.length-1){
								myProfileVm.investmentValue += $scope.investmentModel[i].title;  
							}else{
								myProfileVm.investmentValue += $scope.investmentModel[i].title+", ";  
							}
						}
					
						return itemText;
					}
			};
			$scope.investmentModelTranslation = {buttonDefaultText: 'Please Choose'};
			
		}
		//investmentsDropDown dropdown end
		
		//investmentsDropDown dropdown start
		myProfileVm.insuranceDropDown = function(data){
			
			myProfileVm.insurances = data;
			myProfileVm.insuranceValue = ''; 
			//set selected value

			
			if(!$scope.insuranceModel){
				$scope.insuranceModel = []; //use [] for multiple values  //Shipra
				for(var i=0;i<$scope.currentInsuranceArray.length;i++){
				
					for(var j=0;j<myProfileVm.insurances.length;j++){
						if(($scope.currentInsuranceArray[i].title).trim()==myProfileVm.insurances[j].title){
							$scope.currentInsuranceArray[i].key=myProfileVm.insurances[j].key;
						}
					}
				}
				$timeout(function(){
					$scope.insuranceModel=$scope.currentInsuranceArray;
				},200);
			}
			$scope.insuranceModelSettings = {
					showCheckAll : false, showUncheckAll : false,
					displayProp : 'title',
					idProp : 'key',
					externalIdProp: '',
					//selectionLimit: myProfileVm.investments.length,
					smartButtonMaxItems: myProfileVm.insurances.length,
					closeOnSelect: false,
					styleActive: true,
					smartButtonTextConverter: function(itemText, originalItem) {
						myProfileVm.insuranceValue = '';
					
						for(var i=0;i < $scope.insuranceModel.length;i++){
							if(i==$scope.insuranceModel.length-1){
								myProfileVm.insuranceValue += $scope.insuranceModel[i].title;  
							}else{
								myProfileVm.insuranceValue += $scope.insuranceModel[i].title+", ";  
							}
						}
					
						return itemText;
					}
			};
			$scope.insuranceModelTranslation = {buttonDefaultText: 'Please Choose'};
			
		}
		//investmentsDropDown dropdown end
			
			
		//NOTIFICATION_CHANNEL dropdown start
		myProfileVm.notificationDropDown = function(data){
			myProfileVm.notificationChannels = data;
			myProfileVm.notificationChannelValue='';
			if(!$scope.notificationChannelModel){
				$scope.notificationChannelModel = []; //use [] for multiple values
				
				//set selected value
				for(var i=0;i<$scope.notificationChannelArray.length;i++){
					for(var j=0;j<myProfileVm.notificationChannels.length;j++){
						if(($scope.notificationChannelArray[i].title).trim()==myProfileVm.notificationChannels[j].title){
							$scope.notificationChannelArray[i].key=myProfileVm.notificationChannels[j].key;
						}
					}
				}
				$timeout(function(){
					$scope.notificationChannelModel=$scope.notificationChannelArray;
				},400);
				
			}
			
			$scope.notificationChannelModelSettings = {
					showCheckAll : false, showUncheckAll : false,
					displayProp : 'title',
					idProp : 'key',
					externalIdProp: '',
					smartButtonMaxItems: myProfileVm.notificationChannels.length,
					closeOnSelect: false,
					styleActive: true,
					smartButtonTextConverter: function(itemText, originalItem) {
						myProfileVm.notificationChannelValue='';
						
						for(var i=0;i < $scope.notificationChannelModel.length;i++){
							if(i==$scope.notificationChannelModel.length-1){
								myProfileVm.notificationChannelValue += $scope.notificationChannelModel[i].title;  
							}else{
								myProfileVm.notificationChannelValue += $scope.notificationChannelModel[i].title+", ";  
							}
							
						}
					
						return itemText;
					}
			};
			$scope.notificationChannelModelTranslation = {buttonDefaultText: 'Please Choose'};
		}
		//NOTIFICATION_CHANNEL dropdown end

		//to convert element value into array
		myProfileVm.splitValue = function(el){
			if (el == null || el == undefined) {
				el = "";
			}
			if(el != undefined){
				if(isNaN(el))
					el = el.split(',');
				else 
					el = el.toString().split(',');
			}
			
			return el;
		}
	}


	//getDetailFun
	myProfileVm.getDetailFun = function(showSpinner){
		myProfileService.getDetail(showSpinner).then(function(data){
			try{
				
				/* CBS field nonediatble start */
				myProfileVm.name = $rootScope.customerInfoForProfile.customerName;  //non editable
				myProfileVm.emailId=$rootScope.customerInfoForProfile.emailID;  //non editable
				myProfileVm.phoneNo=$rootScope.customerInfoForProfile.mobile;  //non editable
				if($rootScope.customerInfoForProfile.panNumber){
					myProfileVm.pan=$rootScope.customerInfoForProfile.panNumber;  //non editable
					myProfileVm.maskedPan=utilityService.maskData($rootScope.customerInfoForProfile.panNumber, "front", 4);
				}

				myProfileVm.aadhaarNo=$rootScope.customerInfoForProfile.adharNumber;  //non editable

				if($rootScope.customerInfoForProfile.passportNumber){
					myProfileVm.passport = $rootScope.customerInfoForProfile.passportNumber;  //non editable
					myProfileVm.maskedPassport=utilityService.maskData($rootScope.customerInfoForProfile.passportNumber, "front", 4);
				}

				if($rootScope.customerInfoForProfile.voterId){
					myProfileVm.voterId=$rootScope.customerInfoForProfile.voterId;  //non editable
					myProfileVm.maskedVoterId=utilityService.maskData($rootScope.customerInfoForProfile.voterId, "front", 4);
				}
				
				myProfileVm.address=$rootScope.customerInfoForProfile.address;  //non editable

				if($rootScope.customerInfoForProfile.drivingLicense){
					myProfileVm.drivingLicense=$rootScope.customerInfoForProfile.drivingLicense;  //non editable
					myProfileVm.maskedDrivingLicense=utilityService.maskData($rootScope.customerInfoForProfile.drivingLicense, "front", 4);
				}

				myProfileVm.anualIncomeValue=$rootScope.customerInfoForProfile.annualIncome;  //non editable
				myProfileVm.fatherName=$rootScope.customerInfoForProfile.fatherName;  //non editable
				myProfileVm.motherName=$rootScope.customerInfoForProfile.motherName;  //non editable
				myProfileVm.spouseName=$rootScope.customerInfoForProfile.spouseName;  //non editable
				myProfileVm.firstChildName=$rootScope.customerInfoForProfile.child1Name;  //non editable
				myProfileVm.secondChildName=$rootScope.customerInfoForProfile.child2Name;  //non editable
				myProfileVm.residenceStatusValue=$rootScope.customerInfoForProfile.residenceStatus;  //non editable
				/* CBS field nonediatble ends start */
				
				
				myProfileVm.personalDetails = data.personalDetail;
				myProfileVm.contactDetails = data.contactDetail;
				myProfileVm.professionalDetails = data.professionalDetail;
				myProfileVm.identificationDetails = data.identificationDetail;
				myProfileVm.educationalDetails =data.educationalDetail;
				myProfileVm.familyDetails = data.familyDetail;
				myProfileVm.houseOwnership = data.houseOwnership;
				myProfileVm.carOwnership = data.carOwnership;
				myProfileVm.twoWheelerInfo = data.twoWheelerDetail;
				myProfileVm.lifeInsurance = data.lifeInsurance;
				myProfileVm.healthInsurance = data.healthInsurance;
				myProfileVm.existingLoans = data.existingLoans;
				myProfileVm.socialMediaDetails = data.socialMediaDetail;
				myProfileVm.marketingOffer = data.marketingOffer;
				myProfileVm.notificationChannel = data.notificationChannel;

				myProfileVm.educationalDetailValue = ""
				myProfileVm.educationalDetailId = data.personalDetailsEduQual;
				if(myProfileVm.educationalDetailId){
					myProfileVm.getMasterDetailFun("Qualification",myProfileVm.educationDropDown);
				}
				myProfileVm.noOfdependent = data.personalDetailsDependents
				myProfileVm.dob = data.personalDetailsDob
				if(myProfileVm.dob){
					if(myProfileVm.dob == "00000000"){
						myProfileVm.dob = ""
					}else{
						myProfileVm.dob = $filter('date')(new Date(myProfileVm.dob.substr(2,2) + "/" + myProfileVm.dob.substr(0,2) + "/" + myProfileVm.dob.substr(4,4)), 'dd MMM yyyy');
					}
				}
				myProfileVm.genderId = data.personalDetailsGender
				if(myProfileVm.genderId){
					myProfileVm.getMasterDetailFun("Gender",myProfileVm.genderDropDown);
				}
				myProfileVm.maritalId = data.personalDetailsMaritalStatus
				if(myProfileVm.maritalId){
					myProfileVm.getMasterDetailFun("MaritalStatus",myProfileVm.maritalDropDown);
				}
				myProfileVm.occupationId = data.personalDetailsOccCode
				myProfileVm.occupationValue = data.personalDetailsOccDesc
				if(myProfileVm.occupationId){
					myProfileVm.getMasterDetailFun("OccupationType",myProfileVm.occupationDropDown);
				}
				myProfileVm.birthPlaceValue = data.personalDetailsPlaceOfBirth
				myProfileVm.personalDetailsResCountryCode = data.personalDetailsResCountryCode
				myProfileVm.monthlyIncome = data.ckycMonthlyIncome
				myProfileVm.religionValue = ""
				myProfileVm.religionData = ""
				myProfileVm.categoryData = ""
				myProfileVm.religionId = data.ckycReligion
				if(myProfileVm.religionId){
					myProfileVm.getMasterDetailFun("Religion",myProfileVm.religionDropDown);
				}
				myProfileVm.categoryValue = ""
				myProfileVm.categoryId = data.ckycCategory
				myProfileVm.personalDetailsResponseFlag = data.personalDetailsResponseFlag
				myProfileVm.ckycRespFlag = data.ckycRespFlag
				myProfileVm.cloudantResposneFlag = data.cloudantResposneFlag

				
				/* personalDetails start */
				
				myProfileVm.maritalOther = myProfileVm.personalDetails.maritalStatusOther.values.length > 0 ? myProfileVm.personalDetails.maritalStatusOther.values[0] : '';
			
				/* personalDetails end */
				
				
				
				
				/* identificationDetails start */
				
				myProfileVm.idOther = myProfileVm.identificationDetails.other.values.length > 0 ? myProfileVm.identificationDetails.other.values[0] : '';
				
				/* identificationDetails end */
				
				/* professionalDetails start */
				
				
				myProfileVm.childOptionValue = myProfileVm.professionalDetails.occupationCategory.values.length > 0 ? myProfileVm.professionalDetails.occupationCategory.values[0] : '';
				
				if(myProfileVm.occupationValue &&  (myProfileVm.childOptionValue.toLowerCase()=='retired'|| myProfileVm.childOptionValue.toLowerCase()=='housewife'|| myProfileVm.childOptionValue.toLowerCase()=='student')){
					myProfileVm.professionalEditFlag=false;
				}else{
					myProfileVm.professionalEditFlag=true;
				}
				myProfileVm.organisationName = myProfileVm.professionalDetails.organisationName.values.length > 0 ?  myProfileVm.professionalDetails.organisationName.values[0] : '';
				myProfileVm.designation = myProfileVm.professionalDetails.designation.values.length > 0 ? myProfileVm.professionalDetails.designation.values[0] : '';
				myProfileVm.natureOfBusiness = myProfileVm.professionalDetails.natureOfBusiness.values.length > 0 ?  myProfileVm.professionalDetails.natureOfBusiness.values[0] : '';
				myProfileVm.netWorth = myProfileVm.professionalDetails.netWorth.values.length > 0 ?  myProfileVm.professionalDetails.netWorth.values[0] : '';
				myProfileVm.natureOfEmpValue = myProfileVm.professionalDetails.natureOfEmployment.values.length > 0 ? myProfileVm.professionalDetails.natureOfEmployment.values[0] : '';
				
				/* FamilyDetails start */
					
					myProfileVm.fatherDOB = myProfileVm.familyDetails.fatherDOB.values.length > 0 ? myProfileVm.familyDetails.fatherDOB.values[0] : '';
					if(myProfileVm.fatherDOB){
						myProfileVm.fatherDOB =  $filter('date')(new Date(myProfileVm.fatherDOB), 'dd MMM yyyy');
					}
					
					myProfileVm.motherDOB = myProfileVm.familyDetails.motherDOB.values.length> 0 ? myProfileVm.familyDetails.motherDOB.values[0] : '';
					
					if(myProfileVm.motherDOB){
						myProfileVm.motherDOB =  $filter('date')(new Date(myProfileVm.motherDOB), 'dd MMM yyyy');
					}
					
					myProfileVm.spouseDOB = myProfileVm.familyDetails.spouseDOB.values.length> 0 ? myProfileVm.familyDetails.spouseDOB.values[0] : '';
					if(myProfileVm.spouseDOB){
						myProfileVm.spouseDOB =  $filter('date')(new Date(myProfileVm.spouseDOB), 'dd MMM yyyy');
					}
					myProfileVm.anniversary = myProfileVm.familyDetails.anniversary.values.length> 0 ? myProfileVm.familyDetails.anniversary.values[0] : '';
					if(myProfileVm.anniversary){
						myProfileVm.anniversary =  $filter('date')(new Date(myProfileVm.anniversary), 'dd MMM yyyy');
					}
				
					myProfileVm.firstChildDob = myProfileVm.familyDetails.child1DOB.values.length> 0 ? myProfileVm.familyDetails.child1DOB.values[0] : '';
					if(myProfileVm.firstChildDob){
						myProfileVm.firstChildDob =  $filter('date')(new Date(myProfileVm.firstChildDob), 'dd MMM yyyy');
					}
					
					myProfileVm.secondChildDob = myProfileVm.familyDetails.child2DOB.values.length> 0 ? myProfileVm.familyDetails.child2DOB.values[0] : '';
					if(myProfileVm.secondChildDob){
						myProfileVm.secondChildDob =  $filter('date')(new Date(myProfileVm.secondChildDob), 'dd MMM yyyy');
					}
					//Father DOB
					myProfileVm.fatherDobOptions = {
						callback: function (val) {  //Mandatory
							var date = new Date(val)
							myProfileVm.fatherDOB=date;
						},
						inputDate:  new Date(),      //Optional
		
						dateFormat: 'dd MMM yyyy',//Optional
						closeOnSelect: false,       //Optional
						templateType: 'popup' , 
						to:  new Date(),
						from:(new Date().setYear(new Date().getFullYear() - 120))
					};

					myProfileVm.openFatherDatePicker = function(){
						if(!myProfileVm.familyInfoReadonly)
							ionicDatePicker.openDatePicker(myProfileVm.fatherDobOptions);
					};
					
					//Mother DOB
					myProfileVm.motherDobOptions = {
						callback: function (val) {  //Mandatory
							var date = new Date(val)
							myProfileVm.motherDOB=date;
						},
						inputDate:  new Date(),      //Optional
		
						dateFormat: 'dd MMM yyyy',//Optional
						closeOnSelect: false,       //Optional
						templateType: 'popup' , 
						to:  new Date(),
						from:(new Date().setYear(new Date().getFullYear() - 120))
					};

					myProfileVm.openMotherDatePicker = function(){
						if(!myProfileVm.familyInfoReadonly)
							ionicDatePicker.openDatePicker(myProfileVm.motherDobOptions);
					};
					
					//spouse DOB
					myProfileVm.spouseDobOptions = {
						callback: function (val) {  //Mandatory
							var date = new Date(val)
							myProfileVm.spouseDOB=date;
						},
						inputDate: new Date(),      //Optional
						mondayFirst: true,          //Optional
						dateFormat: 'dd MMM yyyy',//Optional
						closeOnSelect: false,       //Optional
						templateType: 'popup',
						showTodayButton: false,
						to: new Date()
					};

					myProfileVm.openSpouseDatePicker = function(){
						if(!myProfileVm.familyInfoReadonly)
							ionicDatePicker.openDatePicker(myProfileVm.spouseDobOptions);
					};
					
					//anniversary DOB
					myProfileVm.anniversaryDobOptions = {
						callback: function (val) {  //Mandatory
							var date = new Date(val)
							myProfileVm.anniversary=date;
						},
						inputDate: new Date(),      //Optional
						mondayFirst: true,          //Optional
						dateFormat: 'dd MMM yyyy',//Optional
						closeOnSelect: false,       //Optional
						templateType: 'popup',
						showTodayButton: false,
						to: new Date()
					};

					myProfileVm.openAnniversaryDatePicker = function(){
						if(!myProfileVm.familyInfoReadonly)
							ionicDatePicker.openDatePicker(myProfileVm.anniversaryDobOptions);
					};
					
					//Cfirst DOB
					myProfileVm.cFirstDobOptions = {
						callback: function (val) {  //Mandatory
							var date = new Date(val)
							myProfileVm.firstChildDob=date;
						},
						inputDate: new Date(),      //Optional
						mondayFirst: true,          //Optional 
						dateFormat: 'dd MMM yyyy',//Optional
						closeOnSelect: false,       //Optional
						templateType: 'popup',
						showTodayButton: false,
						to: new Date()
					};

					myProfileVm.openCfirstDatePicker = function(){
						if(!myProfileVm.familyInfoReadonly)
							ionicDatePicker.openDatePicker(myProfileVm.cFirstDobOptions);
					};
					
					//Csecond DOB
					myProfileVm.cSecondDobOptions = {
						callback: function (val) {  //Mandatory
							var date = new Date(val)
							myProfileVm.secondChildDob=date;
						},
						inputDate: new Date(),      //Optional
						mondayFirst: true,          //Optional 
						dateFormat: 'dd MMM yyyy',//Optional
						closeOnSelect: false,       //Optional
						templateType: 'popup',
						showTodayButton: false,
						to: new Date()
					};

					myProfileVm.openCsecondDatePicker = function(){
						if(!myProfileVm.familyInfoReadonly)
							ionicDatePicker.openDatePicker(myProfileVm.cSecondDobOptions);
					};
						
					/* FamilyDetails end */
					
					/* house_owner Start */
					myProfileVm.numberOfHouses = myProfileVm.houseOwnership.numberOfHouses.values.length> 0 ? myProfileVm.houseOwnership.numberOfHouses.values[0] : '';
					
					/* house_owner end */
					
					
					/* CAR_Ownership Start */
					myProfileVm.numberOfCars = myProfileVm.carOwnership.numberOfCars.values.length> 0 ? myProfileVm.carOwnership.numberOfCars.values[0] : '';
					myProfileVm.carDetailValue = myProfileVm.carOwnership.carDetail.values.length> 0 ? myProfileVm.carOwnership.carDetail.values[0] : '';
					myProfileVm.carDetailValue = myProfileVm.carDetailValue == "true" ? "Yes" : "No";
					/* CAR_Ownership end */
					
					/* TWO_WHEELER_Ownership Start */
					myProfileVm.numberOftwoWheeler = myProfileVm.twoWheelerInfo.numberOftwoWheeler.values.length> 0 ? myProfileVm.twoWheelerInfo.numberOftwoWheeler.values[0] : '';
					myProfileVm.twoWheelerDetailValue = myProfileVm.twoWheelerInfo.twoWheelerDetail.values.length> 0 ? myProfileVm.twoWheelerInfo.twoWheelerDetail.values[0] : '';
					myProfileVm.twoWheelerDetailValue = myProfileVm.twoWheelerDetailValue == "true" ? "Yes" : "No";
					/* TWO_WHEELER_Ownership end */
					
					
					/* LIFE_INSURANCE Start */
						myProfileVm.lifeCoverAmount = myProfileVm.lifeInsurance.lifeCoverAmount.values.length> 0 ? myProfileVm.lifeInsurance.lifeCoverAmount.values[0] : '';
						myProfileVm.lifeInsuranceDetailValue = myProfileVm.lifeInsurance.lifeInsuranceDetail.values.length> 0 ? myProfileVm.lifeInsurance.lifeInsuranceDetail.values[0] : '';
						myProfileVm.lifeInsuranceDetailValue = myProfileVm.lifeInsuranceDetailValue == "true" ? "Yes" : "No";
					/* LIFE_INSURANCE end */
					
					
					/* HEALTH_INSURANCE Start */
						myProfileVm.healthInsuranceAmount = myProfileVm.healthInsurance.healthInsuranceAmount.values.length> 0 ? myProfileVm.healthInsurance.healthInsuranceAmount.values[0] : '';
						myProfileVm.healthInsuranceDetailValue = myProfileVm.healthInsurance.healthInsuranceDetail.values.length> 0 ? myProfileVm.healthInsurance.healthInsuranceDetail.values[0] : '';
						myProfileVm.healthInsuranceDetailValue = myProfileVm.healthInsuranceDetailValue == "true" ? "Yes" : "No";
						myProfileVm.familyhealthInsuranceDetailValue = myProfileVm.healthInsurance.familyHealthInsuranceDetail.values.length> 0 ? myProfileVm.healthInsurance.familyHealthInsuranceDetail.values[0] : '';
						myProfileVm.familyhealthInsuranceDetailValue = myProfileVm.familyhealthInsuranceDetailValue == "true" ? "Yes" : "No";
					/* HEALTH_INSURANCE end */
					
					
					/* EXISTING_LOANS Start */
					myProfileVm.existingLoanDetailValue = myProfileVm.existingLoans.existingLoanDetail.values.length > 0 ? myProfileVm.existingLoans.existingLoanDetail.values[0] : '';
					myProfileVm.existingLoanDetailValue = myProfileVm.existingLoanDetailValue == "true" ? "Yes" : "No";
					myProfileVm.existingLoanTypeValue = myProfileVm.existingLoans.existingLoanTypes.values.length> 0 ? myProfileVm.existingLoans.existingLoanTypes.values : '';
					/* EXISTING_LOANS end */
					
					
					/* socialInfo start */
					myProfileVm.facebook = myProfileVm.socialMediaDetails.facebook.values.length> 0 ? myProfileVm.socialMediaDetails.facebook.values[0] : '';
					myProfileVm.twitter = myProfileVm.socialMediaDetails.twitter.values.length> 0 ? myProfileVm.socialMediaDetails.twitter.values[0] : '';
					myProfileVm.linkedin = myProfileVm.socialMediaDetails.linkedin.values.length> 0 ? myProfileVm.socialMediaDetails.linkedin.values[0] : '';
					/* socialInfo end */
					
					/* marketing offers start */
					
					myProfileVm.loanValue='';
					myProfileVm.investmentValue='';
					myProfileVm.insuranceValue='';
					
					if(myProfileVm.marketingOffer.investments.values.length){
						myProfileVm.loanValue = myProfileVm.marketingOffer.loans.values[0].trim().length > 0 ? myProfileVm.marketingOffer.loans.values : '';
					}
					if(myProfileVm.marketingOffer.investments.values.length){
						myProfileVm.investmentValue = myProfileVm.marketingOffer.investments.values[0].trim().length> 0 ? myProfileVm.marketingOffer.investments.values : '';
					}
					if(myProfileVm.marketingOffer.insurance.values.length){
						myProfileVm.insuranceValue = myProfileVm.marketingOffer.insurance.values[0].trim().length> 0 ? myProfileVm.marketingOffer.insurance.values : '';
					}
				
					$scope.currentInsuranceArray=[];
					$scope.currentInvestmentsArray=[];
					$scope.currentLoanValueArray=[];
					
					
					for(var i=0;i<myProfileVm.loanValue.length;i++){
						$scope.currentLoanValueObj={};
						$scope.currentLoanValueObj={"title": myProfileVm.loanValue[i],"key": ''};
						$scope.currentLoanValueArray.push($scope.currentLoanValueObj);
					}
					for(var j=0;j<myProfileVm.insuranceValue.length;j++){
						$scope.currentLoanValueObj={};
						$scope.currentLoanValueObj={"title": myProfileVm.insuranceValue[j],"key": ''};
						$scope.currentInsuranceArray.push($scope.currentLoanValueObj);
					}
					for(var k=0;k<myProfileVm.investmentValue.length;k++){
						$scope.currentLoanValueObj={};
						$scope.currentLoanValueObj={"title": myProfileVm.investmentValue[k],"key": ''};
						$scope.currentInvestmentsArray.push($scope.currentLoanValueObj);
					}
					
					/* marketing offers end */
					
					/* Notification start */
					myProfileVm.notificationChannelValue='';
					$scope.notificationChannelArray=[];
					if(myProfileVm.notificationChannel.notifications.values.length){
						
						myProfileVm.notificationChannelValue = myProfileVm.notificationChannel.notifications.values.length> 0 ? myProfileVm.notificationChannel.notifications.values : '';
						for(var k=0;k<myProfileVm.notificationChannelValue.length;k++){
							$scope.notificationChannelObj={};
							$scope.notificationChannelObj={"title": myProfileVm.notificationChannelValue[k],"key": ''};
							$scope.notificationChannelArray.push($scope.notificationChannelObj);
						}
					}
					/* Notification end */
			}
			catch(e){}
				
			}, function(error){
				utilityService.showErrorMessage(error.responseMessage);

		});
	}
	
	
	
	//getMasterDetailFun to get all dropdown data
	myProfileVm.getMasterDetailFun = function(type,callback){
		if (type == "") {
			return;
		} else {
			var reqParams = {};
			reqParams["type"] = type;

			myProfileService.getMasterDetail(reqParams).then(function (data) {
				callback(data.masterDetails);

			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);

			});
		}
	}
	
	//common getProfileQuestion function start
	var commonGetProfileQuestion = function(type){
		//profile question dropdown
		myProfileVm.selectedValue = "";
		$scope.questionModel = type == 'DD' ? {} : []; //use [] for multiple values
		
		if(type == 'DD'){		
			$scope.questionModelSettings = {
					showCheckAll : false, showUncheckAll : false,
					displayProp : 'title',
					idProp : 'key',
					closeOnSelect: true,
					smartButtonMaxItems: 1,
					styleActive: true,
					smartButtonTextConverter: function(itemText, originalItem) {
						myProfileVm.selectedValue = originalItem.title;
						return itemText;
					}
			};
		}
		else{
			$scope.questionModelSettings = {
					showCheckAll : false, showUncheckAll : false,
					displayProp : 'title',
					idProp : 'key',
					externalIdProp: '',
					closeOnSelect: false,
					smartButtonMaxItems: 3,
					styleActive: true,
					smartButtonTextConverter: function(itemText, originalItem) {						
						myProfileVm.selectedValue = '';
						for(var i=0;i < $scope.questionModel.length;i++){
							if(i==$scope.questionModel.length-1){
								myProfileVm.selectedValue += $scope.questionModel[i].title;  
							}else{
								myProfileVm.selectedValue += $scope.questionModel[i].title+", ";  
							}
							
						}
						
						return itemText;
					}
					
			};
		}
		$scope.questionModelTranslation = {buttonDefaultText: 'Please Choose'};
	}
	//common getProfileQuestion function end
	
	//getProfileQuestionsFun
	myProfileVm.getProfileQuestionsFun = function(){
		
			myProfileService.getProfileQuestions().then(function(data){
					myProfileVm.curIndex = 0;
					myProfileVm.questions = data;
					
					myProfileVm.questionLength = myProfileVm.questions.length;
					
					var questionType = myProfileVm.questions[myProfileVm.curIndex].type;
					if(questionType != 'TB')
						commonGetProfileQuestion(questionType);
				
				}, function(error){
					utilityService.showErrorMessage(error.responseMessage);

			});
		
	};
	
	//storing values to model from questionInput field
	myProfileVm.assignVal = function(){
		$scope.questionInput = profileQuestionForm.questionInput.value;
	}
	
	//goToNextQuestion
	myProfileVm.goToNextQuestion = function(curIndex,questionObj,btnName){
		if(btnName == 'ok'){
			
			var typeCondition;
			if(questionObj.type == 'DD')
				typeCondition = $scope.questionModel["id"];
			else if(questionObj.type == 'MS')
				typeCondition = myProfileVm.selectedValue;
			else typeCondition = $scope.questionInput;
			
			
			
			if(typeCondition != undefined){
				var answer='';
				if(questionObj.type != 'TB' && questionObj.type != 'DOB'){
					answer=myProfileVm.selectedValue;
					myProfileVm.questionOkBtnClicked = false;
				}
				else{
					answer=$scope.questionInput;
					myProfileVm.inputOkBtnClicked = false;
				}
				var questionId = questionObj.questionId;
				
				var arrayflg = questionObj.arrayflg;
				myProfileVm.updateProfileQuestionsFun(questionId,answer,arrayflg,curIndex,questionObj);
				
			}
			else {
				if(questionObj.type != 'TB' && questionObj.type != 'DOB'){
					myProfileVm.questionOkBtnClicked = true;
				}
				else{
					myProfileVm.inputOkBtnClicked = true;
				}
				
			}
		}
		else { //if skip button clicked
			if(curIndex != myProfileVm.questionLength -1){
				//clear questions fields
				myProfileVm.curIndex = curIndex+1;
				if(questionObj.type != 'TB' && questionObj.type != 'DOB'){
					$scope.questionModel["id"] = undefined;
					myProfileVm.questionOkBtnClicked = false;
				}
				else{
					$scope.questionInput = '';
					myProfileVm.inputOkBtnClicked = false;
				}
				
				
				
				
				if(questionObj.type != 'TB' && questionObj.type != 'DOB')
					commonGetProfileQuestion(questionObj.type);
			}
			else if(curIndex == myProfileVm.questionLength -1){
				
				myProfileVm.curIndex = null; //to remove questions sections from page
			}
		}
		
	}
	
	
	//this function is define to load questions key value json data
	myProfileVm.loadQuesKeyValJson = function(){
		$http.get('pages/settings/profile/myProfileQuestionKey.json')
			.success(function(data) {
				myProfileVm.questionKeyVal = data.data;
			})
			.error(function() {
			
			});
	}
	
	//updateProfileQuestionsFun
	myProfileVm.updateProfileQuestionsFun = function(questionId,questionVal,arrayflg,curIndex,questionObj){
		//questionVal = arrayflg ? questionVal.replace(',',';') : questionVal;
	
		var reqParams = {
			"data": [
			  {
				"questionId": questionId,
				"questionUpdatedFlag": true,
				"answer": questionVal.split(",")
			  }
			]
		}
		
		myProfileService.updateProfileQuestions(reqParams).then(function(data){
				
				//clear questions fields
				
				if(questionObj.type != 'TB' && questionObj.type != 'DOB'){
					$scope.questionModel["id"] = undefined;
					
				}
				else{
					$scope.questionInput = '';
					
				}
				//to show next question				
				if(curIndex != myProfileVm.questionLength -1){					
					myProfileVm.curIndex = curIndex+1;
					
					if(questionObj.type != 'TB' && questionObj.type != 'DOB')
						commonGetProfileQuestion(questionObj.type);
				}
				else if(curIndex == myProfileVm.questionLength -1){
					
					myProfileVm.curIndex = null; //to remove questions sections from page
				}
				
				
				
				
				
				myProfileService.getProfilePercent().then(function(data){
					myProfileVm.percentage=data.profilePercentage;
					$rootScope.profileScore=data.profilePercentage;
				}, function(error){
				});
			
			}, function(error){
				utilityService.showErrorMessage(error.responseMessage);

		});
	};
	
	
	//common profile section update function
	myProfileVm.updateProfileSection = function(reqParams,editSectionClicked,sectionReadOnly){
		if(utilityService.isUndefined(reqParams.reqValidate)){
			reqParams.reqValidate = (cryptoService.getSHA512EncryptedData("/updateProfileQuestions")).toString()
		}
		
		myProfileService.updateProfileQuestions(reqParams).then(function(data){
			myProfileVm[editSectionClicked] = false;
			myProfileVm[sectionReadOnly] = true;
			
			 //code to update questions without calling service
			
			for(var rq in reqParams.data){
				for(var qId in myProfileVm.questions){
					if(myProfileVm.questions[qId]['questionId'] == reqParams.data[rq]["questionId"]){
						myProfileVm.questions[qId]['questionUpdatedFlag'] = true;
					}
				}
			}
			myProfileService.getProfilePercent().then(function(data){
					myProfileVm.percentage=data.profilePercentage;
					$rootScope.profileScore=data.profilePercentage;
			}, function(error){
				
				utilityService.showErrorMessage(error.responseMessage);
			});

			if((myProfileVm.personalFieldUpdated && (data.customerPersonalDetails && data.customerPersonalDetails.responseFlag == "False")) || (myProfileVm.ckycFieldUpdated && (data.ckycAdditionalDetails && data.ckycAdditionalDetails.responseFlag == "False"))){ 
				let errorMessage = '{{ "UNABLE_TO_SAVE_INPUT" | translate}}'
				myProfileService.showAlertPopup('alert', errorMessage, "", "OK", "", "", "");
				myProfileVm.getDetailFun(false);
			}
			
			}, function(error){
				utilityService.showErrorMessage(error.responseMessage);
		});
		
	}
	
	/*********************** Personal Detail start ***********************/
	//editPersonalDetail
	myProfileVm.editPersonalDetail = function(){
		if(myProfileVm.personalDetailsResponseFlag == "True" && myProfileVm.ckycRespFlag == "True"){
			myProfileVm.perInfoEditClicked = true;
			myProfileVm.perInfoReadonly = false;
			myProfileVm.ckycFieldUpdated = false;
			myProfileVm.personalFieldUpdated = false;
			myProfileVm.showCityError = false;
			myProfileVm.maritalIdUpdated = false;
			myProfileVm.birthPlaceValueUpdated = false;
			myProfileVm.noOfdependentUpdated = false;
			myProfileVm.religionIdUpdated = false;
			myProfileVm.categoryIdUpdated = false;
			myProfileVm.maritalIdOld = myProfileVm.maritalId;
			myProfileVm.birthPlaceValueOld = myProfileVm.birthPlaceValue;
			myProfileVm.noOfdependentOld = myProfileVm.noOfdependent;
			myProfileVm.religionIdOld = myProfileVm.religionId;
			myProfileVm.categoryIdOld = myProfileVm.categoryId;
			if(myProfileVm.birthPlaceValue){
				myProfileVm.disableBirthPlace = true
			}else{
				myProfileVm.getMasterDetailFun("CityMaster",myProfileVm.birthPlaceDropDown);
			}
			if(!myProfileVm.maritals){
				myProfileVm.getMasterDetailFun("MaritalStatus",myProfileVm.maritalDropDown);
			}
			if(myProfileVm.religionId){
				myProfileVm.disableReligion = true
			}
			if(myProfileVm.categoryId){
				myProfileVm.disableCategory = true
			}
			if(!myProfileVm.religions){
				myProfileVm.getMasterDetailFun("Religion",myProfileVm.religionDropDown);
			}
			if(!myProfileVm.genders){
				myProfileVm.getMasterDetailFun("Gender",myProfileVm.genderDropDown);
			}
		}else{
			let errorMessage = '{{ "UNABLE_TO_FETCH_INFO" | translate}}'
			myProfileService.showAlertPopup('alert', errorMessage, "", "OK", "", "", "")
		}
	}
	
	//updatePersonalDetail
	myProfileVm.updatePersonalDetail = function(){
		if(!myProfileVm.disableBirthPlace && myProfileVm.birthPlaceValue && !myProfileVm.validCity){
			myProfileVm.showCityError = true
			return
		}
		if(!utilityService.isUndefined(myProfileVm.religionId) && utilityService.isUndefined(myProfileVm.categoryId)){
			let errorMessage = '{{ "CATEGORY_ERROR" | translate}}'
			myProfileService.showAlertPopup('alert', errorMessage, "", "OK", "", "", "")
			return
		}
		var reqParams = {
			"data": [
			  {
				"questionId": myProfileVm.personalDetails.gender.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.genderValue)
			  },
			  {
				"questionId": myProfileVm.personalDetails.maritalStatus.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.maritalValue)
			  },
			  {
				"questionId": myProfileVm.personalDetails.maritalStatusOther.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.maritalOther)
			  }
			]
		}

		if(myProfileVm.maritalIdUpdated || myProfileVm.birthPlaceValueUpdated || myProfileVm.noOfdependentUpdated){
			if(utilityService.isUndefined(myProfileVm.dob) || utilityService.isUndefined(myProfileVm.genderId) || utilityService.isUndefined(myProfileVm.personalDetailsResCountryCode)){
				let errorMessage = '{{ "PERSONAL_BASIC_INFO_UNAVAIL" | translate}}'
				myProfileService.showAlertPopup('alert', errorMessage, "", "OK", "", "", "")
				if(!myProfileVm.religionIdUpdated && !myProfileVm.categoryIdUpdated){
					return
				}
			}else if(utilityService.isUndefined(myProfileVm.occupationId) || utilityService.isUndefined(myProfileVm.occupationValue)){
				let errorMessage = '{{"PERSONAL_OCC_ERROR" | translate}}';
				myProfileService.showAlertPopup('alert', errorMessage, "", "OK", "", "", "");
				if(!myProfileVm.religionIdUpdated && !myProfileVm.categoryIdUpdated){
					return
				}
			}else{
				if(myProfileVm.maritalIdUpdated){
					myProfileVm.personalFieldUpdated = true;
					reqParams.personalDetailsMaritalStatus = myProfileVm.maritalId
				}
				if(myProfileVm.birthPlaceValueUpdated){
					myProfileVm.personalFieldUpdated = true;
					reqParams.personalDetailsPlaceOfBirth = myProfileVm.birthPlaceValue
					reqParams.reqValidate = (cryptoService.getSHA512EncryptedData(myProfileVm.birthPlaceValue + "/updateProfileQuestions")).toString()
				}
				if(myProfileVm.noOfdependentUpdated){
					myProfileVm.personalFieldUpdated = true;
					reqParams.personalDetailsDependents = myProfileVm.noOfdependent
				}
			}
		}

		if(myProfileVm.religionIdUpdated){
			myProfileVm.ckycFieldUpdated = true;
			reqParams.ckycReligion = myProfileVm.religionId
		}
		if(myProfileVm.categoryIdUpdated){
			myProfileVm.ckycFieldUpdated = true;
			reqParams.ckycCategory = myProfileVm.categoryId
		}
		//this function is call to update profile section
		myProfileVm.updateProfileSection(reqParams,'perInfoEditClicked','perInfoReadonly');
	}
	
	//profilePopup
	var selectPopup;
	myProfileVm.profilePopup = function(){
		if(!myProfileVm.perInfoReadonly){
		selectPopup = $ionicPopup.show({
			 title: 'Select Photo',
			 templateUrl: 'pages/settings/profile/profileImagePopup.html',
			 cssClass: 'dialog acc',
			 scope: $scope,
		   });
		}
	}
	
	//close popup
	myProfileVm.closePopup = function(){
		selectPopup.close();
	}
	
	
	
	myProfileVm.upDateProfile=function(imgProfile){
		var reqParams = {};
			reqParams["documentClass"] = "LT_ProfileImage";
			reqParams["mimeType"] = "image/jpg";
			reqParams["documentTitle"] = "Profile";
			reqParams["documentData"] = imgProfile.split(',')[1];
			reqParams["cifno"] = " ";
			
		myProfileService.updateProfileImage(reqParams).then(function(data){
				myProfileVm.profilePicId=data.id;
				}, function(error){
					myProfileVm.closePopup();
					utilityService.showErrorMessage(error.responseMessage);
			
			});
	}
	//take a photo from camera service
	myProfileVm.takePhoto = function(){
		cameraService.getnewImage().then(function(data) {
				myProfileVm.closePopup();
				var blob = new Blob([data], {type: 'image/jpeg'});
				
					$rootScope.profileImageUrl = data;
					myProfileVm.upDateProfile($rootScope.profileImageUrl);
				
				
						
		}, function(error) {
			myProfileVm.imageSizeError=false;
		});	
	}
	
	
	//select image from gallery service
	myProfileVm.selectFromGallery = function(){
		cameraService.getImageFromGallery().then(function(data) {
			myProfileVm.closePopup();
			var blob = new Blob([data], {type: 'image/jpeg'});
			
				$rootScope.profileImageUrl = data;
				myProfileVm.upDateProfile($rootScope.profileImageUrl); 
			
		
		}, function(error) { myProfileVm.imageSizeError=false; });	
	}
	
	/*********************** Personal Detail end ***********************/
	
	/*********************** IdentificationDetails start **********************/
	//editIdentificationDetails
	myProfileVm.editIdentificationDetails = function(){
		 myProfileVm.identificationInfoEditClicked = true;
		 myProfileVm.identificationInfoReadonly = false;
	     myProfileVm.getMasterDetailFun("IdOther",myProfileVm.idOtherDropDown);		 
	}
	
	//updateIdentificationInfo
	myProfileVm.updateIdentificationInfo = function(){
		 var reqParams = {
			"data": [
			  {
				"questionId": myProfileVm.identificationDetails.aadhaarNumber.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.aadhaarNo)
			  },
			  {
				"questionId": myProfileVm.identificationDetails.pan.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.pan)
			  },
			  {
				"questionId": myProfileVm.identificationDetails.passportNumber.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.passport)
			  },
			  {
				"questionId": myProfileVm.identificationDetails.drivingLicense.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.drivingLicense)
			  },
			  {
				"questionId": myProfileVm.identificationDetails.voterId.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.voterId)
			  },
			  {
				"questionId": myProfileVm.identificationDetails.other.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.idOther)
			  }
			]
		}
		
		//this function is call to update profile section
		myProfileVm.updateProfileSection(reqParams,'identificationInfoEditClicked','identificationInfoReadonly');
		
		
	}
	/*********************** IdentificationDetails end **********************/
	
	/*********************** ProfessionalDetails start **********************/
	//editProfessionalDetails
	myProfileVm.editProfessionalDetails = function(){
		if(myProfileVm.personalDetailsResponseFlag == "True" && myProfileVm.ckycRespFlag == "True"){
			myProfileVm.professionalInfoEditClicked = true;
			myProfileVm.professionalInfoReadonly = false;
			myProfileVm.personalFieldUpdated = false;
			myProfileVm.ckycFieldUpdated = false;
			myProfileVm.invalidMonthlyIncome = false;
			myProfileVm.monthlyIncomeUpdated = false;
			myProfileVm.occupationUpdated = false;
			myProfileVm.occupationIdOld = myProfileVm.occupationId;
			myProfileVm.monthlyIncomeOld = myProfileVm.monthlyIncome;
			if(!myProfileVm.occupations){
				myProfileVm.getMasterDetailFun("OccupationType",myProfileVm.occupationDropDown);
			}
			myProfileVm.getMasterDetailFun("NatureOfEmployment",myProfileVm.natureBusinessDropDown);
		}else{
			let errorMessage = '{{ "UNABLE_TO_FETCH_INFO" | translate}}'
			myProfileService.showAlertPopup('alert', errorMessage, "", "OK", "", "", "")
		}
	}
	
	//updateProfessionalDetails
	myProfileVm.updateProfessionalDetails = function(){
		myProfileVm.invalidMonthlyIncome = false
		if(myProfileVm.monthlyIncome && parseInt(myProfileVm.monthlyIncome) > 1000000000){
			myProfileVm.invalidMonthlyIncome = true
			return
		}

		if(myProfileVm.monthlyIncomeUpdated){
			if(utilityService.isUndefined(myProfileVm.religionValue) || 
			utilityService.isUndefined(myProfileVm.categoryValue)){
				let errorMessage = '{{ "MONTHLY_INCOME_POPUP" | translate}}'
				myProfileService.showAlertPopup('alert', errorMessage, "", "OK", "", "", "");
				return
			}
		}

		if(myProfileVm.netWorth <=0)
			myProfileVm.netWorth = "";
		var reqParams = {
			"data": [
			  {
				"questionId": myProfileVm.professionalDetails.occupation.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.occupationValue)
			  },
			  {
				"questionId": myProfileVm.professionalDetails.organisationName.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.organisationName)
			  },
			  {
				"questionId": myProfileVm.professionalDetails.occupationCategory.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.childOptionValue)
			  },
			  {
				"questionId": myProfileVm.professionalDetails.designation.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.designation)
			  },
			  {
				"questionId": myProfileVm.professionalDetails.natureOfEmployment.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.natureOfEmpValue)
			  },
			  {
				"questionId": myProfileVm.professionalDetails.natureOfBusiness.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.natureOfBusiness)
			  },
			  {
				"questionId": myProfileVm.professionalDetails.annualIncome.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.anualIncomeValue)
			  },
			  {
				"questionId": myProfileVm.professionalDetails.netWorth.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.netWorth)
			  }
			]
		}
		if(myProfileVm.occupationUpdated && (utilityService.isUndefined(myProfileVm.dob) || utilityService.isUndefined(myProfileVm.genderId) || utilityService.isUndefined(myProfileVm.personalDetailsResCountryCode))){
			let errorMessage = '{{ "OCCUPATION_UPDATE_ERROR" | translate}}'
			myProfileService.showAlertPopup('alert', errorMessage, "", "OK", "", "", "")
			if(!myProfileVm.monthlyIncomeUpdated){
				return
			}
		} else {
			if(myProfileVm.occupationUpdated){
				myProfileVm.personalFieldUpdated = true
				reqParams.personalDetailsOccCode = myProfileVm.occupationId
				reqParams.personalDetailsOccDesc = myProfileVm.occupationValue
			}
		}
		if(myProfileVm.monthlyIncomeUpdated){
			myProfileVm.ckycFieldUpdated = true
			reqParams.ckycMonthlyIncome = myProfileVm.monthlyIncome
		}
		
		//this function is call to update profile section
		myProfileVm.updateProfileSection(reqParams,'professionalInfoEditClicked','professionalInfoReadonly');
	}
	/*********************** ProfessionalDetails end **********************/
	
	/*********************** EducationDetails start **********************/
	//editEducationDetails
	myProfileVm.editEducationDetails = function(){
		myProfileVm.educationInfoEditClicked = true;
		myProfileVm.educationInfoReadonly = false;
		myProfileVm.personalFieldUpdated = false;
		myProfileVm.educationUpdated = false;
		myProfileVm.educationalDetailIdOld = myProfileVm.educationalDetailId;
		if(!myProfileVm.qualifications){
			myProfileVm.getMasterDetailFun("Qualification",myProfileVm.educationDropDown);
		}
	}
	
	//updateEducationInfo
	myProfileVm.updateEducationInfo = function(){
		if(utilityService.isUndefined(myProfileVm.dob) || utilityService.isUndefined(myProfileVm.genderId) || utilityService.isUndefined(myProfileVm.personalDetailsResCountryCode)){
			let errorMessage = '{{"EDUCATION_BASIC_INFO_UNAVAIL" | translate}}';
            myProfileService.showAlertPopup('alert', errorMessage, "", "OK", "", "", "");
			return
		}else if(utilityService.isUndefined(myProfileVm.occupationId) || utilityService.isUndefined(myProfileVm.occupationValue)){
			let errorMessage = '{{"EDUCATION_OCC_ERROR" | translate}}';
			myProfileService.showAlertPopup('alert', errorMessage, "", "OK", "", "", "");
			return
		}
		 
		 var reqParams = {
			"data": [
			  {
				"questionId": myProfileVm.educationalDetails.qualification.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.educationalDetailValue)
			  } 
			]
		}
		if(myProfileVm.educationUpdated){
			myProfileVm.personalFieldUpdated = true;
			reqParams.personalDetailsEduQual = myProfileVm.educationalDetailId
		}
		
		//this function is call to update profile section
		myProfileVm.updateProfileSection(reqParams,'educationInfoEditClicked','educationInfoReadonly');
			
	}
	/*********************** EducationDetails end **********************/
	
	/*********************** FamilyDetails start **********************/
	//editFamilyDetails
	myProfileVm.editFamilyDetails = function(){
		myProfileVm.familyInfoEditClicked = true;
		myProfileVm.familyInfoReadonly = false;	
		myProfileVm.getMasterDetailFun("MaritalStatus",myProfileVm.maritalDropDown);
	}
	
	//updateFamilyInfo
	myProfileVm.updateFamilyInfo = function(){
		
		var reqParams = {
			"data": [
			  {
				"questionId": myProfileVm.familyDetails.fatherName.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.fatherName)
			  },
			  {
				"questionId": myProfileVm.familyDetails.fatherDOB.questionId,
				"questionUpdatedFlag": true,
				"answer":  myProfileVm.splitValue(myProfileVm.fatherDOB)
			  },
			  {
				"questionId": myProfileVm.familyDetails.motherName.questionId,
				"questionUpdatedFlag": true,
				"answer":  myProfileVm.splitValue(myProfileVm.motherName)
			  },
			  {
				"questionId": myProfileVm.familyDetails.motherDOB.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.motherDOB)
			  },
			  {
				"questionId": myProfileVm.personalDetails.maritalStatus.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.maritalValue)
			  },
			  {
				"questionId": myProfileVm.familyDetails.spouseName.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.spouseName)
			  },
			  {
				"questionId": myProfileVm.familyDetails.spouseDOB.questionId,
				"questionUpdatedFlag": true,
				"answer":  myProfileVm.splitValue(myProfileVm.spouseDOB)
			  },
			  {
				"questionId": myProfileVm.familyDetails.anniversary.questionId,
				"questionUpdatedFlag": true,
				"answer":  myProfileVm.splitValue(myProfileVm.anniversary)
			  },
			  {
				"questionId": myProfileVm.familyDetails.child1Name.questionId,
				"questionUpdatedFlag": true,
				"answer":  myProfileVm.splitValue(myProfileVm.firstChildName)
			  },
			  {
				"questionId": myProfileVm.familyDetails.child1DOB.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.firstChildDob)
			  },
			  {
				"questionId": myProfileVm.familyDetails.child2Name.questionId,
				"questionUpdatedFlag": true,
				"answer":  myProfileVm.splitValue(myProfileVm.secondChildName)
			  },
			  {
				"questionId": myProfileVm.familyDetails.child2DOB.questionId,
				"questionUpdatedFlag": true,
				"answer":  myProfileVm.splitValue(myProfileVm.secondChildDob)
			  }
			]
		}
		
		//this function is call to update profile section
		myProfileVm.updateProfileSection(reqParams,'familyInfoEditClicked','familyInfoReadonly');
		
	}
	/*********************** FamilyDetails end **********************/
	
	/*********************** HouseDetails start **********************/	
	//editHouseDetails
	myProfileVm.editHouseOwnershipDetails = function(){
		myProfileVm.houseOwnershipInfoEditClicked = true;
		myProfileVm.houseOwnershipInfoReadonly = false;
		myProfileVm.getMasterDetailFun("ResidenceStatus",myProfileVm.houseOwnershipDropDown);
	}
	
	//updateHouseInfo
	myProfileVm.updateHouseOwnershipInfo = function(){
		 
		 var reqParams = {
			"data": [
			  {
				"questionId": myProfileVm.houseOwnership.residenceStatus.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.residenceStatusValue)
			  },
			  {
				"questionId": myProfileVm.houseOwnership.numberOfHouses.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.numberOfHouses)
			  }
			]
		}
		
		//this function is call to update profile section
		myProfileVm.updateProfileSection(reqParams,'houseOwnershipInfoEditClicked','houseOwnershipInfoReadonly');
		
	}
	/*********************** HouseDetails end **********************/
	
	
	/*********************** CarDetails start **********************/
	//editCarDetails
	myProfileVm.editCarDetails = function(){
		myProfileVm.carOwnershipInfoEditClicked = true;
		myProfileVm.carOwnershipInfoReadonly = false;	
		myProfileVm.getMasterDetailFun("MCQ",myProfileVm.carDropDown);
	}
	
	//updatecarOwnershipInfo
	myProfileVm.updatecarOwnershipInfo = function(){
		var updateFlag = myProfileVm.carDetailValue == "Yes" ? "true" : "false";
		var reqParams = {
			"data": [
			  {
				"questionId": myProfileVm.carOwnership.carDetail.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(updateFlag)
			  },
			  {
				"questionId": myProfileVm.carOwnership.numberOfCars.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.numberOfCars)
			  }
			]
		}
		
		myProfileVm.updateProfileSection(reqParams,'carOwnershipInfoEditClicked','carOwnershipInfoReadonly');
	}
	/*********************** CarDetails end **********************/
	
	/*********************** TwoWheelerDetailsInfo start **********************/
	myProfileVm.editTwoWheelerDetailsDetails = function(){
		myProfileVm.twoWheelerDetailsInfoEditClicked = true;
		myProfileVm.twoWheelerDetailsInfoReadonly = false;
		myProfileVm.getMasterDetailFun("MCQ",myProfileVm.twoWheelerDropDown);
	}
	
	//updatetwoWheelerDetailsInfo
	myProfileVm.updateTwoWheelerDetailsInfo = function(){
		var updateFlag = myProfileVm.twoWheelerDetailValue == "Yes" ? "true" : "false";
		var reqParams = {
			"data": [
			  {
				"questionId": myProfileVm.twoWheelerInfo.twoWheelerDetail.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(updateFlag)
			  },
			  {
				"questionId": myProfileVm.twoWheelerInfo.numberOftwoWheeler.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.numberOftwoWheeler)
			  }
			]
		}
		
		myProfileVm.updateProfileSection(reqParams,'twoWheelerDetailsInfoEditClicked','twoWheelerDetailsInfoReadonly');
	}
	/*********************** TwoWheelerDetailsInfo end **********************/
	
	/*********************** LifeInsuranceDetails start **********************/
	//editlifeInsuranceDetails
	myProfileVm.editLifeInsuranceDetails = function(){
		myProfileVm.lifeInsuranceInfoEditClicked = true;
		myProfileVm.lifeInsuranceInfoReadonly = false;
		myProfileVm.getMasterDetailFun("MCQ",myProfileVm.lifeInsuranceDropDown);
	}
	
	//updatelifeInsuranceInfo
	myProfileVm.updateLifeInsuranceInfo = function(){
		var updateFlag = myProfileVm.lifeInsuranceDetailValue == "Yes" ? "true" : "false";
		var reqParams = {
			"data": [
			  {
				"questionId": myProfileVm.lifeInsurance.lifeInsuranceDetail.questionId,
				"questionUpdatedFlag": true,
				"answer":  myProfileVm.splitValue(updateFlag)
			  },
			  {
				"questionId": myProfileVm.lifeInsurance.lifeCoverAmount.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.lifeCoverAmount)
			  }
			]
		}
		  	myProfileVm.updateProfileSection(reqParams,'lifeInsuranceInfoEditClicked','lifeInsuranceInfoReadonly');
	}
	 /*********************** LifeInsuranceDetails end **********************/

	/*********************** HealthInsuranceDetails start **********************/
	//edithealthInsuranceDetails
	myProfileVm.edithealthInsuranceDetails = function(){
		myProfileVm.healthInsuranceInfoEditClicked = true;
		myProfileVm.healthInsuranceInfoReadonly = false;
		myProfileVm.getMasterDetailFun("MCQ",myProfileVm.healthInsuranceDropDown);
		myProfileVm.getMasterDetailFun("MCQ",myProfileVm.familyInsuranceDropDown);
	}
	
	//updatehealthInsuranceInfo
	myProfileVm.updateHealthInsuranceInfo = function(){
		var updateFlag1 = myProfileVm.healthInsuranceDetailValue == "Yes" ? "true" : "false";
		var updateFlag2 = myProfileVm.familyhealthInsuranceDetailValue == "Yes" ? "true" : "false";
		var reqParams = {
			"data": [
			  {
				"questionId": myProfileVm.healthInsurance.healthInsuranceDetail.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(updateFlag1)
			  },
			  {
				"questionId": myProfileVm.healthInsurance.healthInsuranceAmount.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.healthInsuranceAmount)
			  },
			    {
				"questionId": myProfileVm.healthInsurance.familyHealthInsuranceDetail.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(updateFlag2)
			  }
			]
		}
		
		
		myProfileVm.updateProfileSection(reqParams,'healthInsuranceInfoEditClicked','healthInsuranceInfoReadonly');
	}
	/*********************** HealthInsuranceDetails end **********************/
	
	/*********************** ExistingLoansInfo start **********************/
	//existingLoansDetails
	myProfileVm.editExistingLoansDetails = function(){
		myProfileVm.existingLoansInfoEditClicked = true;
		myProfileVm.existingLoansInfoReadonly = false;
		myProfileVm.getMasterDetailFun("MCQ",myProfileVm.existingLoanDetailDropDown);
		myProfileVm.getMasterDetailFun("ExistingLoanType",myProfileVm.existingLoanTypeDropDown);
	}
	
	//updateexistingLoansInfo
	myProfileVm.updateExistingLoansInfo = function(){
		var updateFlag = myProfileVm.existingLoanDetailValue == "Yes" ? "true" : "false";
		var reqParams = {
			"data": [
			  {
				"questionId": myProfileVm.existingLoans.existingLoanDetail.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(updateFlag)
			  },
			  {
				"questionId": myProfileVm.existingLoans.existingLoanTypes.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.existingLoanTypeValue)
			  }
			]
		}
		
		//this function is call to update profile section
		myProfileVm.updateProfileSection(reqParams,'existingLoansInfoEditClicked','existingLoansInfoReadonly');
	}
	
	/*********************** ExistingLoansInfo end **********************/
	
	/*********************** marketingOffersDetails start **********************/
	//existmarketingOffersDetails
	myProfileVm.editMarketingOffersDetails = function(){
		myProfileVm.marketingOffersInfoEditClicked = true;
		myProfileVm.marketingOffersInfoReadonly = false;
		myProfileVm.getMasterDetailFun("Loans",myProfileVm.loanDropDown);
		myProfileVm.getMasterDetailFun("Investments",myProfileVm.investmentsDropDown);
		myProfileVm.getMasterDetailFun("Insurance",myProfileVm.insuranceDropDown);
	}
	
	//marketingOffersInfo
	myProfileVm.updateMarketingOffersInfo = function(){
		
		myProfileVm.getMasterDetailFun("Loans",myProfileVm.loanDropDown);
		myProfileVm.getMasterDetailFun("Investments",myProfileVm.investmentsDropDown);
		myProfileVm.getMasterDetailFun("Insurance",myProfileVm.insuranceDropDown);
		
		$timeout(function(){
			myProfileVm.loanValue=myProfileVm.loanValue.toString().replace(/(^,)|(,$)/g,"");
			myProfileVm.loanValue=myProfileVm.loanValue.toString().trim();
			
			myProfileVm.investmentValue=myProfileVm.investmentValue.toString().replace(/(^,)|(,$)/g,"");
			myProfileVm.investmentValue=myProfileVm.investmentValue.toString().trim();
			myProfileVm.insuranceValue=myProfileVm.insuranceValue.toString().replace(/(^,)|(,$)/g,"");
			myProfileVm.insuranceValue=myProfileVm.insuranceValue.toString().trim();
		var reqParams = {
			"data": [
			  {
				"questionId": myProfileVm.marketingOffer.loans.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.loanValue)
			  },
			  {
				"questionId": myProfileVm.marketingOffer.investments.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.investmentValue)
			  },
			  {
				"questionId": myProfileVm.marketingOffer.insurance.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.insuranceValue)
			  }
			]
		}
		$timeout(function(){
		//this function is call to update profile section
			myProfileVm.updateProfileSection(reqParams,'marketingOffersInfoEditClicked','marketingOffersInfoReadonly');
		},1500);
		},1000);
	}
	/*********************** marketingOffersDetails end **********************/
	
	/*********************** SocialInfo start **********************/
	//editSocialInfo
	myProfileVm.editSocialInfo = function(){
		myProfileVm.socialInfoEditClicked = true;
		myProfileVm.socialInfoReadonly = false;	
	}
	
	//updateSocialInfo
	myProfileVm.updateSocialInfo = function(){
		var reqParams = {
			"data": [
			  {
				"questionId": myProfileVm.socialMediaDetails.facebook.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.facebook)
			  },
			  {
				"questionId": myProfileVm.socialMediaDetails.twitter.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.twitter)
			  },
			  {
				"questionId": myProfileVm.socialMediaDetails.linkedin.questionId,
				"questionUpdatedFlag": true,
				"answer": myProfileVm.splitValue(myProfileVm.linkedin)
			  }
			]
		}
		
		//this function is call to update profile section
		myProfileVm.updateProfileSection(reqParams,'socialInfoEditClicked','socialInfoReadonly');
	}
	/*********************** SocialInfo end **********************/
	
	/*********************** notificationChannels start **********************/
	//notificationChannels
	myProfileVm.editNotificationChannels = function(){
		myProfileVm.notificationChannelsInfoEditClicked = true;
		myProfileVm.notificationChannelsInfoReadonly = false;
		myProfileVm.getMasterDetailFun("NotificationChannel",myProfileVm.notificationDropDown);
	}
	
	//updatenotificationChannelsInfo
	myProfileVm.updateNotificationChannelsInfo = function(){
		myProfileVm.getMasterDetailFun("NotificationChannel",myProfileVm.notificationDropDown);
		$timeout(function(){
			var reqParams = {
				"data": [
				  {
					"questionId": myProfileVm.notificationChannel.notifications.questionId,
					"questionUpdatedFlag": true,
					"answer": myProfileVm.splitValue(myProfileVm.notificationChannelValue)
				  }
				]
			}
			
			//this function is call to update profile section
			myProfileVm.updateProfileSection(reqParams,'notificationChannelsInfoEditClicked','notificationChannelsInfoReadonly');
		},400);
		
	}
	/*********************** notificationChannels end **********************/
	/*********************** Questions DOB *************************/
	
	myProfileVm.openQuestionDatePicOptions = {
		callback: function (val) {  //Mandatory
			var date = $filter('date')(new Date(val), 'dd MMM yyyy');
			$scope.questionInput=date;
		},
		inputDate:  new Date(),      //Optional

		dateFormat: 'dd MMM yyyy',//Optional
		closeOnSelect: false,       //Optional
		templateType: 'popup' , 
		to:  new Date(),
		from:(new Date().setYear(new Date().getFullYear() - 120))
	};

	myProfileVm.openQuestionDatePicker = function(){
		ionicDatePicker.openDatePicker(myProfileVm.openQuestionDatePicOptions);
	};
	/*********************** Questions DOB Ends *************************/
	//private methods section end
	
	//back to prev page
	myProfileVm.goBacktoPrevious = function(){
		//To do
	}
	
	//go to next page
	myProfileVm.goToNextPage = function(){
		$state.go('menu.accountOverviewPopup');
	}
	myProfileVm.trimData = function(){
		if(parseInt(myProfileVm.netWorth) <= 0 || !myProfileVm.netWorth || myProfileVm.netWorth === "")
			myProfileVm.netWorth = "";
		else {
			myProfileVm.netWorth = myProfileVm.netWorth.trim();
			myProfileVm.netWorth = "" + parseInt(myProfileVm.netWorth);
		}
	}
	myProfileVm.setInputTypeText = function(e){
		e.target.type = "password";
		e.target.type = "text";
	}
	//one time initialization to be done when the controller is loaded
	$scope.$on('$ionicView.loaded', function() {
		
		
	});
	
	//actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function() {
		initPage();
	});
	
	//actions to done everytime the view is hidden
	$scope.$on('$ionicView.afterLeave', function() {
		
		//any cleanup needs to be done here: executes everytime when page is left
	});

	myProfileVm.showHideCityList = function() {
		if (!utilityService.isUndefined(myProfileVm.birthPlaceValue)) {
			myProfileVm.tCityList = true;			
		} 
		else {
			myProfileVm.tCityList = false;			
		}
		myProfileVm.validCity = false;
		myProfileVm.showCityError = false;
	}

	myProfileVm.selectedCity = function(city) {
		myProfileVm.birthPlaceValue = city.title;
		myProfileVm.birthPlaceId = city.key;
		myProfileVm.tCityList = false;
		myProfileVm.validCity = true;
		if(myProfileVm.birthPlaceValueOld != myProfileVm.birthPlaceValue){
			myProfileVm.birthPlaceValueUpdated = true;
		}else {
			myProfileVm.birthPlaceValueUpdated = false;
		}
	}

	myProfileVm.setValues = function(field,data) {
		if(field == "QUALIFICATION"){
			myProfileVm.educationalDetailPriority = myProfileVm.educationalDetailPriority ? myProfileVm.educationalDetailPriority : 0
			if(parseInt(data.priority) >= parseInt(myProfileVm.educationalDetailPriority)){
				myProfileVm.qualificationError = false
				myProfileVm.educationalDetailId = data.key
				myProfileVm.educationalDetailValue = data.title
			} else {
				myProfileVm.qualificationError = true
			}
			if(myProfileVm.educationalDetailIdOld != myProfileVm.educationalDetailId){
				myProfileVm.educationUpdated = true;
			}else {
				myProfileVm.educationUpdated = false;
			}
		}else if(field == "OCCUPATION_TYPE"){
			myProfileVm.occupationId = data.key
			myProfileVm.occupationValue = data.title
			if(myProfileVm.occupationIdOld != myProfileVm.occupationId){
				myProfileVm.occupationUpdated = true;
			}else {
				myProfileVm.occupationUpdated = false;
			}
		}else if(field == "MONTHLY_INCOME"){
			myProfileVm.invalidMonthlyIncome = myProfileVm.monthlyIncome && parseInt(myProfileVm.monthlyIncome) > 1000000000 ? true : false
			if(myProfileVm.monthlyIncomeOld != myProfileVm.monthlyIncome){
				myProfileVm.monthlyIncomeUpdated = true;
			}else {
				myProfileVm.monthlyIncomeUpdated = false;
			}
		}else if(field == "MARITAL_STATUS"){
			myProfileVm.maritalId = data.key
			myProfileVm.maritalValue = data.title
			if(myProfileVm.maritalIdOld != myProfileVm.maritalId){
				myProfileVm.maritalIdUpdated = true;
			}else {
				myProfileVm.maritalIdUpdated = false;
			}
		}else if(field == "NO_OF_DEPENDENTS"){
			if(myProfileVm.noOfdependentOld != myProfileVm.noOfdependent){
				myProfileVm.noOfdependentUpdated = true;
			}else {
				myProfileVm.noOfdependentUpdated = false;
			}
		}else if(field == "RELIGION"){
			myProfileVm.religionId = data.key
			myProfileVm.religionValue = data.title
			myProfileVm.categories = data.category
			if(myProfileVm.religionIdOld != myProfileVm.religionId){
				myProfileVm.religionIdUpdated = true;
			}else {
				myProfileVm.religionIdUpdated = false;
			}
		}else if(field == "CATEGORY"){
			myProfileVm.categoryId = data.categoryCode
			myProfileVm.categoryValue = data.categoryName
			if(myProfileVm.categoryIdOld != myProfileVm.categoryId){
				myProfileVm.categoryIdUpdated = true;
			}else {
				myProfileVm.categoryIdUpdated = false;
			}
		}
	}

	return this;
}]);
