angularApp.service('myProfileService',
	function($q,AdapterUtils, $ionicPopup, $state){
		var MPservice =this;
		
		//getDetail
		MPservice.getDetail = function(showSpinner) {
			var q = $q.defer();	
			AdapterUtils.getData("adapters/ProfileAdapter/getDetail", showSpinner).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
		};
		
		//getMasterDetail service is call to get dropdown details
		MPservice.getMasterDetail = function(reqData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/ProfileAdapter/getMasterDetail", reqData, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
		};
		
		//getProfileQuestions
		MPservice.getProfileQuestions = function() {
			var q = $q.defer();	
			AdapterUtils.getData("adapters/ProfileAdapter/getProfileQuestions", true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
		};
		
		//update profile image service
		MPservice.updateProfileImage = function(reqData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/ProfileAdapter/uploadImage", reqData, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
		};
		
		//updateProfileQuestions
		MPservice.updateProfileQuestions = function(reqData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/ProfileAdapter/updateProfileQuestions", reqData, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
		};
				
		//get profile percentages
		MPservice.getProfilePercent = function() {
			var reqData={};
			var keyArray=[""];
			reqData['keys']=keyArray;
			
			var q = $q.defer();	
			AdapterUtils.postData("adapters/ProfileAdapter/getProfilePercentage", reqData, false).then(
				function(response){
					q.resolve(response);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
		};

		MPservice.showAlertPopup = function (imageType, message, onTapgo, buttontext1, buttontext2, $scope, obj) {
            var btn_array = [];
            if (buttontext1 != "" && buttontext2 != "") {
                btn_array = [
                    {
                        text: buttontext2 || "Cancel",
                        type: 'button-negative'
                       
                    },
                    {
                        text: buttontext1 || "OK",
                        type: 'button-positive',
                        onTap: function () {
                            if (onTapgo) {
                                $state.go(onTapgo);
                            }
                        }
                    }
                ];
            }
            else {
                btn_array = [
                    {
                        text: buttontext1 || "OK",
                        type: 'button-positive',
                        onTap: function () {
                            if (onTapgo) {
                                $state.go(onTapgo);
                            }
                        }
                    }
                ];
            }

            if (imageType && imageType.toLowerCase() == 'error') {
                imageType = '<div class="align-center"><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/errorSymbol.svg"/></div>';
            } else if (imageType && imageType.toLowerCase() == 'success') {
                imageType = '<div class="align-center"><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/successSymbol.svg"/></div>';
            } else if (imageType && imageType.toLowerCase() == 'alert') {
                imageType = '<div class="align-center"><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/alertSymbol.svg"/></div>';
            } else {
                imageType = "";
            }
            var bhimErrorPopup = $ionicPopup.alert({
                template: imageType + '<div class="popupMsgPadding"><div class="align-center roboto-medium font-size-16 color-54">'
                + message + '</div></div>',
                scope: $scope,
                cssClass: 'bhim-alert-popup adgc-popup',
                buttons: btn_array,
            });
            bhimErrorPopup.then(function (res) {
                console.log('show alert popup');
            });
        };		
				
		return MPservice;
	});  