'use strict';

angularApp.controller('changeMpinController',
						["$timeout",
						 "$state",
						 "$location",
						 "$scope",
						 "$rootScope",
						 "utilityService",
						 "changeMpinService",
						 "$ionicPopup",
						 "$ionicSideMenuDelegate","internetBankingService","encryptionService","cryptoService",

function ($timeout,
		 $state,
		 $location,
		 $scope,
		 $rootScope,
		 utilityService,
		 changeMpinService,
		 $ionicPopup,
		 $ionicSideMenuDelegate,internetBankingService,encryptionService,cryptoService) {

	//functions, variables that can be accessed from the HTML come here
	var changeMpinVm = this;

	//private methods section start
	function initPage(){
		changeMpinVm.showBack = false;
		changeMpinVm.showNext = true;
		changeMpinVm.disableSubmit = true;
	}

	//user validation
	changeMpinVm.userValidate = function(){
		changeMpinVm.validateCustomerFun();
	}

	 changeMpinVm.isValid = function(formName){
		if(formName.$valid || formName=="")
			changeMpinVm.disableSubmit = false;
		else changeMpinVm.disableSubmit = true;
	 }

	changeMpinVm.closeView = function(){
		$state.go("menu.settings");
	}

	changeMpinVm.validateCustomerFun = function(){
		internetBankingService.getServiceIdAndKey().then(function(data){
			var keyId = data.keyId;
			var serviceId = data.serviceId;
			var SaltValue = "#";

			var unameAndPasswordWithSalt = changeMpinVm.userName + SaltValue + changeMpinVm.password;
			var firstStepSHA512 = cryptoService.getSHA512EncryptedData(unameAndPasswordWithSalt);
			var secondStepSHA512 = firstStepSHA512 + SaltValue + keyId;
			var finalSHA512Val = cryptoService.getSHA512EncryptedData(secondStepSHA512);

			var reqParams = {};
			reqParams["userName"] = changeMpinVm.userName;
			reqParams["sha512Password"] = finalSHA512Val.toString();
			reqParams["bankCode"] = '0';
			reqParams["osName"] = device.platform;
			reqParams["channel"] = 'LOTUS';
			reqParams["keyId"] = keyId;
			reqParams["serviceId"] = serviceId;

			changeMpinService.validateCustomer(reqParams).then(function(data){
					var responseData = data;
					var requestParams = {};
					requestParams["id"] = device.uuid;
					requestParams["fields"] = ["ckyc.dob", "ckyc.address", "profile.anniversaryDate"];
					internetBankingService.getUserDetailsForMpin(requestParams).then(function(response){
						//User details used for MPIN policies.
						var userDetails = {}
						userDetails["birthDate"] = response.payLoad.ckyc.dob;
						internetBankingService.userDetailsForMpin = userDetails;
						$state.go('menu.confirmChangeMpin');
					},  function(error){
						utilityService.showErrorMessage(error.responseMessage);
					});
				}, 	function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});
			},function(error){
				utilityService.showErrorMessage(error.responseMessage);
			})
		}

	//back to prev page
	changeMpinVm.goBacktoPrevious = function(){}

	//one time initialization to be done when the controller is loaded
	$scope.$on('$ionicView.loaded', function() {
		$ionicSideMenuDelegate.canDragContent(false);
	});

	//actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function() {
		$ionicSideMenuDelegate.canDragContent(false);
		initPage();
	});

	//actions to done everytime the view is hidden
	$scope.$on('$ionicView.afterLeave', function() {
		changeMpinVm.disableSubmit = true;
		userValidateForm.reset();
		$ionicSideMenuDelegate.canDragContent(true);
		//any cleanup needs to be done here: executes everytime when page is left
	});
	return this;
}]);
