'use strict';

angularApp.controller('confirmChangeMpinController', 
						["$timeout",
						 "$state",
						 "$location",
						 "$scope",
						 "$rootScope",
						 "$ionicPopup",
						 "utilityService",
						 "changeMpinService",
						 "$ionicSideMenuDelegate","internetBankingService","cryptoService","encryptionService","loggedInUserService",
				 
function ($timeout,
		 $state,
		 $location,
		 $scope,
		 $rootScope,
		 $ionicPopup,
		 utilityService,
		 changeMpinService,
		 $ionicSideMenuDelegate,internetBankingService, cryptoService, encryptionService,loggedInUserService) {
	
	//functions, variables that can be accessed from the HTML come here
	var confirmChangeMpinVm = this;
	
	//private methods section start
	function initPage(){
		confirmChangeMpinVm.showBack = false;
		confirmChangeMpinVm.showNext = true;
		confirmChangeMpinVm.disableConfirm = true;
		confirmChangeMpinVm.validConfirmFlag = true;
		confirmChangeMpinVm.oldNewFlag = true;
	}
	
	//to confirm change mpin
	confirmChangeMpinVm.confirmChangeMpin = function(msg){
		$scope.msg = msg;
		var confirmPopup = $ionicPopup.confirm({
		templateUrl: 'pages/settings/security/changeMpinPopupConfirm.html',
		scope: $scope,
		buttons: [
			{ text: 'Cancel' }, {
			   text: 'OK',
				onTap: function(e) {
					loggedInUserService.logoutUser();
				}
			}
		]
	    });
	}
	
	//to check change mpin is valid or not
	confirmChangeMpinVm.isValid = function(formName){
		if(formName.$valid)
			confirmChangeMpinVm.disableConfirm = false;
		else confirmChangeMpinVm.disableConfirm = true;
	 }
	 
	 //to submit mpin change
	 confirmChangeMpinVm.changeMpinSubmit = function(formName){
		if(formName.$valid){
			var oldMpin = confirmChangeMpinVm.curMpin1 + confirmChangeMpinVm.curMpin2 + confirmChangeMpinVm.curMpin3 + confirmChangeMpinVm.curMpin4 + confirmChangeMpinVm.curMpin5 + confirmChangeMpinVm.curMpin6;
			var newMpin = confirmChangeMpinVm.newMpin1 + confirmChangeMpinVm.newMpin2 + confirmChangeMpinVm.newMpin3 + confirmChangeMpinVm.newMpin4 + confirmChangeMpinVm.newMpin5 + confirmChangeMpinVm.newMpin6;
			var confirmMpin = confirmChangeMpinVm.reMpin1 + confirmChangeMpinVm.reMpin2 + confirmChangeMpinVm.reMpin3 + confirmChangeMpinVm.reMpin4 + confirmChangeMpinVm.reMpin5 + confirmChangeMpinVm.reMpin6;
			
			var mpinCondition = confirmChangeMpinVm.checkMPINConditions(oldMpin, newMpin, confirmMpin);	
			if(mpinCondition == true){
				var dataForHashing = oldMpin + loggedInUserService.deviceInfo;
				var SHA512HashedVal = cryptoService.getSHA512EncryptedData(dataForHashing);
				var aesMpin = SHA512HashedVal.toString();
				var dataWithoutHash = confirmMpin + loggedInUserService.deviceInfo;
				var SHA512HashValue = cryptoService.getSHA512EncryptedData(dataWithoutHash);
				var confirmedMpin = SHA512HashValue.toString();
				
				var reqPath={
					"currentMpin":aesMpin,
					"newMpin":confirmedMpin,
					"deviceId":device.uuid
				};
				changeMpinService.changeMPIN(reqPath).then(function(data){	
					var mpinSetPopUp = $ionicPopup.show({       
					template: '<img src="img/mf/bg-approved.svg" alt="Success Screen"><h2> Congratulations! </h2> <p>You have successfully updated MPIN.</p>',
					title: '',
					cssClass: 'dialog',
					scope: $scope,			
					buttons: [{
						text: 'Go to login',
						type: 'button-positive',
							onTap: function(e) {
								loggedInUserService.logoutUser();
							}
						}]
					}); 
				}, function(error){
					utilityService.showErrorMessage(error.responseMessage);
					confirmChangeMpinVm.resetMpinFields();
				});
			} else {
				utilityService.showErrorMessage(mpinCondition);
				confirmChangeMpinVm.resetMpinFields();
			}
		}
	};
	
	confirmChangeMpinVm.checkMPINConditions = function(oldMpin, newMpin, confirmMpin){
		//var userDetails = internetBankingService.userDetailsForMpin;
		if(oldMpin === newMpin){
			return 'Old MPIN and New MPIN should not be same';
		}
		if((newMpin.toString()).length !== 6){
			return 'New MPIN cannot be less than 6 digits';
		}
		if(newMpin !== confirmMpin){
			return 'New MPIN and confirm MPIN should be same';
		}
		if(/(.)\1\1/.test(newMpin.toString())){
			return 'Three consecutive numbers should not be same';
		}
		for(var i = 0; i < 4; i++){
			if(newMpin[i + 1] == parseInt(newMpin[i]) + 1){
				if(newMpin[i + 2] == parseInt(newMpin[i + 1]) + 1){
					return 'Three consecutive numbers should not be in sequence';
				}
			}
		}
		for(var i = 0; i < 4; i++){
			if(newMpin[i] == parseInt(newMpin[i + 1]) + 1){
				if(newMpin[i + 1] == parseInt(newMpin[i + 2]) + 1){
					return 'Three consecutive numbers should not be in sequence';
				}
			}
		}
		/* if(confirmChangeMpinVm.checkDateCombinations(newMpin, userDetails.birthDate)){
			return 'Birthdate combinations cannot be set as MPIN';
		} */
		var validArrSet =  [newMpin[0], newMpin[1], newMpin[2],newMpin[3], newMpin[4], newMpin[5]];
		var newArr = [];
	    for (var i=0;i < validArrSet.length ; i++){
			if(newArr.indexOf(validArrSet[i]) == -1){
				newArr.push(validArrSet[i]);
			}
	    }
	    if(newArr.length < 3){
			return 'Please use 3 unqiue numbers to set MPIN.';
	    }
		return true;
	};
	
	//Check B'date combinations for set MPIN.
	confirmChangeMpinVm.checkDateCombinations = function(mpin, date){
		var dd = date.substring(0,2);
		var mm = date.substring(2,4);
		var yy = date.substring(6,8);
		if(mpin == (dd + mm + yy) || mpin == (mm + dd + yy) || mpin == (yy + dd + mm) || mpin == (yy + mm + dd) || mpin == (dd + yy + mm) || mpin == (mm + yy + dd)){
			return true;
		}else{
			return false;
		}
	};
	
	confirmChangeMpinVm.resetMpinFields = function(){
		confirmChangeMpinVm.curMpin1 = '';
		confirmChangeMpinVm.curMpin2 = '';
		confirmChangeMpinVm.curMpin3 = '';
		confirmChangeMpinVm.curMpin4 = '';
		confirmChangeMpinVm.curMpin5 = '';
		confirmChangeMpinVm.curMpin6 = '';
		confirmChangeMpinVm.newMpin1 = '';
		confirmChangeMpinVm.newMpin2 = '';
		confirmChangeMpinVm.newMpin3 = '';
		confirmChangeMpinVm.newMpin4 = '';
		confirmChangeMpinVm.newMpin5 = '';
		confirmChangeMpinVm.newMpin6 = '';
		confirmChangeMpinVm.reMpin1 = '';
		confirmChangeMpinVm.reMpin2 = '';
		confirmChangeMpinVm.reMpin3 = '';
		confirmChangeMpinVm.reMpin4 = '';
		confirmChangeMpinVm.reMpin5 = '';
		confirmChangeMpinVm.reMpin6 = '';
	};
	
	//this function is used to close view
	confirmChangeMpinVm.closeView = function(){
		$state.go("menu.settings");
	}
		
	//private methods section end
	
	//one time initialization to be done when the controller is loaded
	$scope.$on('$ionicView.loaded', function() {
		$ionicSideMenuDelegate.canDragContent(false);
	});
	
	//actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function() {
		$ionicSideMenuDelegate.canDragContent(false);
		initPage();
	});
	
	//actions to done everytime the view is hidden
	$scope.$on('$ionicView.afterLeave', function() {
		setMpinForm.reset();
		$ionicSideMenuDelegate.canDragContent(true);
		//any cleanup needs to be done here: executes everytime when page is left
	});
	return this;
}]);
