'use strict';

angularApp.controller('settingsController', ["$timeout",
    "$state",
    "$location",
    "$scope",
    "$rootScope",
    "utilityService",
    "$ionicPopup",
    "getAccountDetailsService",
    "fgtProfilePwdService",
    "inbForgotPwdService",
    "constantConfig",
    "ionicToast",
    "internetBankingService",
    "cryptoService",
    "loggedInUserService",
    "fTReviewService",
    "manageTransactionRightsService",
    "mPinLoginService",
    "$filter",
    "agriMandiService",
    "quickPayService",
    "$ionicHistory",
    "registerWithSimService",
    function($timeout,
        $state,
        $location,
        $scope,
        $rootScope,
        utilityService,
        $ionicPopup,
        getAccountDetailsService,
        fgtProfilePwdService,
        inbForgotPwdService,
        constantConfig,
        ionicToast,
        internetBankingService,
        cryptoService,
        loggedInUserService,
        fTReviewService,
        manageTransactionRightsService,
        mPinLoginService,
        $filter,
        agriMandiService,
        quickPayService,
        $ionicHistory,
        registerWithSimService) {

        //functions, variables that can be accessed from the HTML template
        var settingsVm = this;
        settingsVm.isTextReadable = false;
        settingsVm.isTextReadablereEnter = false;
        settingsVm.selectedLanguage = "";
        var accOverviewData = getAccountDetailsService.accountOverviewData;
        
        loggedInUserService.mpinConsent = internetBankingService.mpinConsent;
        //if (!utilityService.isAndroidPlatform()) {
            if(loggedInUserService.mpinConsent){
                settingsVm.isMpinAbsent = false;
                settingsVm.buttonLabel = $filter('translate')("REMOVE_MPIN");
            }
            else{
                settingsVm.isMpinAbsent = true;
                settingsVm.buttonLabel = $filter('translate')("SET_MPIN");
            }
        //}
        // else{
        //     //for android
        //     if (localStorage.getItem('mpinConsent') == 'true') {
        //         settingsVm.isMpinAbsent = false;
        //         settingsVm.buttonLabel = $filter('translate')("REMOVE_MPIN");
        //     } else {
        //         settingsVm.isMpinAbsent = true;
        //         settingsVm.buttonLabel = $filter('translate')("SET_MPIN");
        //     }
        // }

        settingsVm.enableDisableMpin = function () {
            if (settingsVm.buttonLabel == 'Remove MPIN') {
                $rootScope.journeyName = $filter('translate')("REMOVE_MPIN");
                settingsVm.checkProfilePasswordFlag("menu.profilePassword");
                //$state.go('menu.profilePassword');
            } else {
                loggedInUserService.isNormalRegistration = false;
                mPinLoginService.isSetMPIN = true;
                $state.go('menu.mpinConsent', {
                    previousJourney: "settings"
                });
            }
        };

        settingsVm.enableBiometric = function(){
            //alert('Coming Soon'); return;
            $ionicHistory.clearCache().then(function(){
          $state.go('menu.quickPayBiometricSetUp',{goBackToState:'menu.settings'});
        });
            
        }
        settingsVm.resetProfilePassword = function () {
            fgtProfilePwdService.settingPage = true;
            inbForgotPwdService.resetPage = false;
            fgtProfilePwdService.type = "PROFILE";
            settingsVm.checkProfilePasswordFlag("menu.profilePwd");
            //$state.go('menu.profilePwd');
        }

        settingsVm.InternetBankingPassword = function () {
            fgtProfilePwdService.settingPage = false;
            inbForgotPwdService.resetPage = true;
            fgtProfilePwdService.type = "INB";
            settingsVm.checkProfilePasswordFlag("menu.profilePwd"); 
            //$state.go('menu.profilePwd');
        }
        settingsVm.validateProfilePass = function () {
            var loggedInUserDetails = loggedInUserService.getUserProfileDetails();
            if (settingsVm.userProfilePassword) {
                fTReviewService.getProfilePassAndSerKey().then(function (response) {
                    var options = {
                        inbUserName:loggedInUserDetails.inbUsername,
                        strPass:settingsVm.userProfilePassword,
                        keyId:response.keyId,
                        serviceId:response.serviceId,
                        osName:device.platform
                    };
                    var reqParams = utilityService.commonRequestForValidateProfilePass(options);
                    fTReviewService.getProfilePassAuth(reqParams).then(function (data) {
                        settingsVm.getSettingButton();
					}, function(error) {
                        //utilityService.showErrorMessage(error.responseMessage);
                        	if (error.responseCode == "INB.AUTH.016") {
								settingsVm.myPopup = $ionicPopup.show({
									title: '',
									cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
									templateUrl: 'pages/settings/profilePasswordUnblockPopUp.html',
									scope: $scope
								})
							} else {
								utilityService.showErrorMessage(error.responseMessage);
							}
                    });

				}, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
			}else{
                utilityService.showErrorMessage('Please enter your Internet Banking Profile Password.')
            }
        };

		settingsVm.getSettingButton = function(){
			if($rootScope.journeyName == 'Remove MPIN'){
                settingsVm.confirmPopup = $ionicPopup.confirm({
                    cssClass: 'dialog',
                    template: '<div class="button_fund fontSize-subHeading roboto-light font-dark-grey" translate="">Are you sure, you want to remove MPIN?</div>',
                    buttons: [{
                        text: '<span class="txt-blue">YES</span>',
						onTap:function(e){
                            internetBankingService.isMpinConsentConfirmed = false;
                            internetBankingService.mpinConsent = false
                            var requestParams = {};
                            requestParams["id"] = loggedInUserService.deviceInfo;
                            requestParams["mpin"] = "";

                            internetBankingService.setMPIN(requestParams).then(function (data) {
                                //if(!utilityService.isAndroidPlatform()) {
                                    loggedInUserService.fileForStorageData('{"isDeviceRegistered":true,"mpinConsent":false, "simSubscriptionId":"' + registerWithSimService.simSubscriptionId +'"}').then(function(res){
                                        localStorage.setItem('mpinConsent', false);
                                        var removeMpinPopUp = $ionicPopup.show({
                                            template: '<img src="img/mf/bg-approved.svg" alt="Success Screen"><p>You have successfully removed MPIN</p>',
                                            title: '',
                                            cssClass: 'dialog',
                                            scope: $scope,
                                            buttons: [{
                                                text: 'OK',
                                                type: 'button-positive',
                                                onTap: function (e) {
                                                    removeMpinPopUp.close();
                                                    $state.go("menu.homeScreen");
                                                    //loggedInUserService.logoutUser();
                                                }
                                            }]
                                        });
                                    },function(err){
                                        localStorage.setItem('mpinConsent', false);
                                        var removeMpinPopUp = $ionicPopup.show({
                                            template: '<img src="img/mf/bg-approved.svg" alt="Success Screen"><p>You have successfully removed MPIN</p>',
                                            title: '',
                                            cssClass: 'dialog',
                                            scope: $scope,
                                            buttons: [{
                                                text: 'OK',
                                                type: 'button-positive',
                                                onTap: function (e) {
                                                    removeMpinPopUp.close();
                                                    $state.go("menu.homeScreen");
                                                    //loggedInUserService.logoutUser();
                                                }
                                            }]
                                        });
                                    });
                                //}
                            }, function (error) {
                                utilityService.showErrorMessage(error.responseMessage);
                            });
                        }
                    }, {
                        text: 'NO',
                        type: 'button-positive',
                        onTap: function (e) {
                            settingsVm.confirmPopup.close();
                            $state.go('menu.settings');
                        }
                    }],
                });
            }
            if ($rootScope.journeyName == 'Change MPIN') {
                $state.go('menu.confirmChangeMpin');
            }
        };

		settingsVm.closeProfilePwdView = function(){
            $state.go('menu.settings');
        };

		settingsVm.goToSettingsHome = function(){
            $state.go('menu.settings');
        };

        settingsVm.setSelectedLanguage = function() {
            var lang = getAccountDetailsService.accountOverviewData.customerInformation.language;
            switch (lang) {
                case "EN":
                settingsVm.selectedLanguage = "English";
                agriMandiService.selectLanguageIndex = 0;
                    break;
                case "HI":
                settingsVm.selectedLanguage = "हिंदी";
                agriMandiService.selectLanguageIndex = 1;
                    break;
                case "MA":
                settingsVm.selectedLanguage = "മലയാളം";
                agriMandiService.selectLanguageIndex = 2;
                    break;
                case "TA":
                settingsVm.selectedLanguage = "தமிழ்";
                agriMandiService.selectLanguageIndex = 3;
                    break;
                case "TE":
                settingsVm.selectedLanguage = "తెలుగు";
                agriMandiService.selectLanguageIndex = 4;
                    break;
                default: 
                settingsVm.selectedLanguage = agriMandiService.selectLanguageText;
              }
        }

        //Private methods section start
        function initPage() {
            //settingsVm.selectedLanguage = agriMandiService.selectLanguageText;
            settingsVm.isBackCheck = true;
            settingsVm.showBack = true;
            settingsVm.showNext = true;
            settingsVm.showInProgress = true;
            settingsVm.testForgetSimSlot();
            settingsVm.setSelectedLanguage();
        }

        //Check sim slots(i.e. Single or dual sim{1/2})
        settingsVm.testForgetSimSlot = function() {
            var json = JSON.stringify({});
            getNativeData(constantConfig.upiConstant.getsimslot, function(data) {}, function(msg) {
                utilityService.showErrorMessage(msg);
            }, json);
        };

        //Function for check marshmallow permission
        settingsVm.manageVpa = function() {
            if (device.platform.toLowerCase() == 'android') {
                utilityService.showSpinner();
                var json = JSON.stringify({});
                getNativeData(constantConfig.upiConstant.getpermission, function(data) {
                    if (data.permission === 'Allowed') {
                        settingsVm.testForCheckDevice();
                    } else {
                        utilityService.hideSpinner();
                        utilityService.showErrorMessage("UPI registration requires permission to use camera, SMS and Phone calls. Please allow these permissions. If problem persists re-initiate UPI registration.");
                    }
                }, function(msg) {
                    utilityService.hideSpinner();
                    utilityService.showErrorMessage(msg);
                }, json);
            } else if (device.platform.toLowerCase() == 'windows') {
                ionicToast.show("The functionality is not available in windows currently.", 'bottom', false, 3000);
            } else {
                ionicToast.show("The functionality is not available in iOS currently.", 'bottom', false, 3000);
            }
        };

        //Check device(i.e. inital function call)
        settingsVm.testForCheckDevice = function() {
            var json = JSON.stringify({
                "addInfo": {
                    "addInfo10": constantConfig.upiConstant.addInfo10,
                    "addInfo9": constantConfig.upiConstant.addInfo9
                },
                "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "updateFlag": constantConfig.upiConstant.updateFlag
            });
            getNativeData(constantConfig.upiConstant.checkDevice, function(data) {
                $rootScope.checkDeviceInfo = JSON.parse(data);
                if ($rootScope.checkDeviceInfo.status !== 'F') {
                    if ($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNN') {
                        if ($rootScope.checkDeviceInfo.smsStatus === 'SN') {
                            settingsVm.sendSMS();
                        } else {
                            utilityService.hideSpinner();
                            $state.go('menu.createVPA');
                        }
                    } else if (($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNN') || ($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNM')) {
                        utilityService.hideSpinner();
                        $state.go('menu.question');
                    } else {
                        utilityService.hideSpinner();
                        $state.go('menu.createVPA');
                    }
                } else {
                    utilityService.hideSpinner();
                    utilityService.showErrorMessage($rootScope.checkDeviceInfo.statusDesc);
                }
            }, function(msg) {
                utilityService.hideSpinner();
                settingsVm.showUPIErrorMessage(msg);
            }, json);
        }

        //Send sms : if user is not registered at all.
        settingsVm.sendSMS = function() {
            var json = JSON.stringify({
                "smsContent": $rootScope.checkDeviceInfo.smsGateWayContent,
                "smsEncKey": $rootScope.checkDeviceInfo.smsGateWayKey,
                "smsGateWayNo": $rootScope.checkDeviceInfo.smsGateWayNo,
                "slot": $rootScope.checkDeviceInfo.deviceInfo.selectedSimSlot.toString(),
                "simNo": $rootScope.checkDeviceInfo.deviceInfo.simId.toString()
            });
            getNativeData(constantConfig.upiConstant.sendsms, function(data) {
                if (data.smsStatus === 'S') {
                    settingsVm.testForCheckDevice();
                } else {
                    utilityService.hideSpinner();
                    utilityService.showErrorMessage("Failed to send SMS to the registered mobile number.");
                }
            }, function(msg) {
                utilityService.hideSpinner();
                settingsVm.showUPIErrorMessage(msg);
            }, json);
        }

        //Send sms : If user changed the sim card.
        settingsVm.sendSMSDRSNN = function() {
            var json = JSON.stringify({
                "smsContent": $rootScope.checkDeviceInfo.smsGateWayContent,
                "smsEncKey": $rootScope.checkDeviceInfo.smsGateWayKey,
                "smsGateWayNo": $rootScope.checkDeviceInfo.smsGateWayNo,
                "slot": $rootScope.checkDeviceInfo.deviceInfo.selectedSimSlot.toString(),
                "simNo": $rootScope.checkDeviceInfo.deviceInfo.simId.toString()
            });
            getNativeData(constantConfig.upiConstant.sendsms, function(data) {
                if (data.smsStatus === 'S') {
                    settingsVm.getSelectedSecQuestion();
                } else {
                    utilityService.hideSpinner();
                    utilityService.showErrorMessage("Failed to send SMS to the registered mobile number.");
                }
            }, function(msg) {
                utilityService.hideSpinner();
                settingsVm.showUPIErrorMessage(msg);
            }, json);
        }

        settingsVm.getSelectedSecQuestion = function() {
            var json = JSON.stringify({
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "updateFlag": constantConfig.upiConstant.updateFlag
            });
            getNativeData(constantConfig.upiConstant.getSelectedSecurityQuestion, function(data) {
                settingsVm.selectedSecQuestion = JSON.parse(data).userInfo.secretDetails.quesName;
                settingsVm.selectedSecQueId = JSON.parse(data).userInfo.secretDetails.quesId;
                settingsVm.updateDeviceWithM();
            }, function(msg) {
                utilityService.hideSpinner();
                settingsVm.showUPIErrorMessage(msg);
            }, json);
        }

        settingsVm.updateDeviceWithM = function() {
            var json = JSON.stringify({
                "deviceInfo": {
                    "oldMobileNo": $rootScope.checkDeviceInfo.deviceInfo.oldMobileNo
                },
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "requestType": constantConfig.upiConstant.requestType_M,
                "updateFlag": constantConfig.upiConstant.updateFlag,
                "userInfo": {
                    "secretDetails": {
                        "secretAnswer": settingsVm.selectedSecQuestion,
                        "quesId": settingsVm.selectedSecQueId
                    }
                }
            });
            getNativeData(constantConfig.upiConstant.updateDevice, function(data) {
                settingsVm.checkDevice2();
            }, function(msg) {
                utilityService.hideSpinner();
                settingsVm.showUPIErrorMessage(msg);
            }, json);
        }

        settingsVm.checkDevice2 = function() {
            var json = JSON.stringify({
                "addInfo": {
                    "addInfo10": constantConfig.upiConstant.addInfo10,
                    "addInfo9": constantConfig.upiConstant.addInfo9
                },
                "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "updateFlag": constantConfig.upiConstant.updateFlag
            });
            getNativeData(constantConfig.upiConstant.checkDevice, function(data) {
                $rootScope.checkDeviceInfo = JSON.parse(data);
                $state.go('menu.createVPA');
            }, function(msg) {
                utilityService.hideSpinner();
                settingsVm.showUPIErrorMessage(msg);
            }, json);
        }

        //Function for get selected security question.
        settingsVm.getSelectedSecQue = function() {
            var json = JSON.stringify({
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "updateFlag": constantConfig.upiConstant.updateFlag
            });
            getNativeData(constantConfig.upiConstant.getSelectedSecurityQuestion, function(data) {
                settingsVm.testForUpdateDeviceWithM();
            }, function(msg) {
                utilityService.hideSpinner();
                settingsVm.showUPIErrorMessage(msg);
            }, json);
        }

        //this function is define to get account details
        settingsVm.getAccountInfo = function() {
            getAccountDetailsService.getAccountDetails().then(function(data) {
                getAccountDetailsService.accountOverviewData = data.accounts;
                utilityService.hideSpinner();
            }, function(error) {

            });
        }

        //to go qrCode page
        settingsVm.manageQr = function() {
            if (device.platform.toLowerCase() == 'android') {
                utilityService.showSpinner();
                var json = JSON.stringify({});
                getNativeData(constantConfig.upiConstant.getpermission, function(data) {
                    if (data.permission === 'Allowed') {
                        settingsVm.checkDeviceForQrCode();
                    } else {
                        utilityService.hideSpinner();
                        utilityService.showErrorMessage("You don't have necessary access for this transaction.");
                    }
                }, function(msg) {
                    utilityService.hideSpinner();
                    settingsVm.showUPIErrorMessage(msg);
                }, json);
            } else if (device.platform.toLowerCase() == 'windows') {
                ionicToast.show("The functionality is not available in windows currently.", 'bottom', false, 3000);
            } else {
                ionicToast.show("The functionality is not available in iOS currently.", 'bottom', false, 3000);
            }
        }

        settingsVm.checkDeviceForQrCode = function() {
            var json = JSON.stringify({
                "addInfo": {
                    "addInfo10": constantConfig.upiConstant.addInfo10,
                    "addInfo9": constantConfig.upiConstant.addInfo9
                },
                "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "updateFlag": constantConfig.upiConstant.updateFlag
            });
            getNativeData(constantConfig.upiConstant.checkDevice, function(data) {
                $rootScope.checkDeviceInfo = JSON.parse(data);
                utilityService.hideSpinner();
                if ($rootScope.checkDeviceInfo.status !== 'F') {
                    if ($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNN') {
                        utilityService.showErrorMessage("Please create a VPA to get your QR code.");
                    } else if (($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNN') || ($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNM')) {
                        utilityService.showErrorMessage("You have changed either device or sim card.Please do the registration through manage VPA option.");
                    } else {
                        $state.go('menu.qrCode');
                    }
                } else {
                    utilityService.showErrorMessage($rootScope.checkDeviceInfo.statusDesc);
                }
            }, function(msg) {
                utilityService.hideSpinner();
                settingsVm.showUPIErrorMessage(msg);
            }, json);
        }

        settingsVm.showUPIErrorMessage = function(errorCode) {
            switch(errorCode){
				case -1 : utilityService.showErrorMessage(constantConfig.upiConstant.minusOne);
				break;

				case -2 : utilityService.showErrorMessage(constantConfig.upiConstant.minusTwo);
				break;

				case -3 : utilityService.showErrorMessage(constantConfig.upiConstant.minusThree);
				break;

				case -4 : utilityService.showErrorMessage(constantConfig.upiConstant.minusFour);
				break;

				case -5 : utilityService.showErrorMessage(constantConfig.upiConstant.minusFive);
				break;

				case -6 : utilityService.showErrorMessage(constantConfig.upiConstant.minusSix);
				break;

				case -7 : utilityService.showErrorMessage(constantConfig.upiConstant.minusSeven);
				break;

				default : utilityService.showErrorMessage(constantConfig.upiConstant.someWentWrong);
			}
        };
		
        //Go to my profile
		settingsVm.openMyProfile = function(){
            $state.go('menu.myProfile');
        }

        //to go selPrimaryAcc page
        settingsVm.selPrimaryAcc = function() {
            $state.go('menu.selPrimaryAcc');
        }

        //to go settingsNotifications page
        settingsVm.setNotifications = function() {
            $state.go('menu.settingsNotifications');
        }

        //to go changeMpin page
        settingsVm.changeMpin = function() {
            $rootScope.journeyName = 'Change MPIN';
            settingsVm.checkProfilePasswordFlag("menu.profilePassword");
            //$state.go('menu.profilePassword');
        }

        
        settingsVm.checkProfilePasswordFlag = function(page){
            var profPassObj = {
                prevPage:"menu.settings",
                nextPage:page,
                goto:"menu.setProfilePassword",
                ionicPopup:$ionicPopup,
                accOverviewData:accOverviewData
            };
            getAccountDetailsService.commonfunForProfilePassCheck(profPassObj);
        }

        //to go manageTxnRights page
		var globalList = [];
        settingsVm.manageTxnRights = function () {                   
            manageTransactionRightsService.getAccounts().then(function (data) {
                    globalList = data.accList;
                    settingsVm.accListUnmask = data.accList;
                    settingsVm.accListMask = [];

                    angular.forEach(data.accList, function (value, key) {
                        settingsVm.accListMask.push({'accountNumber':utilityService.maskData(value.accountNumber, "front", 4), 'accountType': value.accountType, 'txnRight':value.txnRight});
                    });

                    settingsVm.accList = settingsVm.accListMask;

                    manageTransactionRightsService.txnData = {
                        "globalList" : globalList,
                        "accList" : settingsVm.accList,
                        "accListUnmask" : settingsVm.accListUnmask
                    }
                    $state.go('menu.manageRights');
                }, function (err) {
                    utilityService.showErrorMessage(err.responseMessage);
                });
        }
	 
        //to go mmidDetails page
        settingsVm.mmidDetails = function() {
            $state.go('menu.mmidDetails');
        }
        //to go funding page
	settingsVm.funding = function(){
            $state.go('menu.funding');
        };
        //to select agri language
        settingsVm.selectAgriLanguage = function() {
            agriMandiService.isUserFromSettings = true;
            $state.go('menu.selectLanguage');
        }

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        settingsVm.unblockProfilePass = function (){
             settingsVm.myPopup.close();
             $state.go('menu.forgotProfilePwd');
        } 

        settingsVm.cancel = function (){
            settingsVm.myPopup.close();
			$state.go('menu.homeScreen');
        }
        settingsVm.forgotPass = function (){
            $state.go('menu.forgotProfilePwd');
        }

        settingsVm.forgotpassPopup = function () {
			var havingMPINPrblmPopUp = $ionicPopup.show({
				template: "<p> If you have forgotton your profile password, you can reset the same yourself. You need to  authenticate yourself either with the hint question and answer that you had set for the Profile password or ATM Card details & PIN. You can approach branch in case you don't remember Hint Question/answer or ATM card details & PIN </p>",
				title: '',
				cssClass: 'dialog',
				scope: $scope,
				buttons: [{
					text: 'OK',
					type: 'button-positive'
				}]
			});
		};
           

           	settingsVm.toggleSecretAns = function () {
			settingsVm.isTextReadable == true ? settingsVm.isTextReadable = false : settingsVm.isTextReadable = true;
		};
		settingsVm.toggleReEnter = function () {
			settingsVm.isTextReadablereEnter == true ? settingsVm.isTextReadablereEnter = false : settingsVm.isTextReadablereEnter = true;
		};

        settingsVm.goBacktoPrevious = function (){
            $ionicHistory.goBack();
        }

        return this;
    }
]);
