'use strict';

angularApp.controller('discoverOurFeatureController', 
						["$timeout",
						 "$state",
						 "$location",
						 "$scope",
				         "$ionicPopup","supportServices", "$ionicSideMenuDelegate","$rootScope","$sce",
function ($timeout,
		 $state,
		 $location,
		 $scope,
		 $ionicPopup,supportServices,$ionicSideMenuDelegate,$rootScope,$sce) {
	
	//functions, variables that can be accessed from the HTML come here
	var discoverFeaturesVm = this;
	//private methods section start
	function initPage(){
		discoverFeaturesVm.showBack = false;
		discoverFeaturesVm.showNext = true;
		
		  /*************************Fetch all videos start************************************/	
		supportServices.getFeatureVideos().then(function(data){
			discoverFeaturesVm.featureLists = data.getFeatureVideos;
			},function(error){
			 utilityService.showErrorMessage(error.responseMessage);
			}
		); 
		discoverFeaturesVm.moreClick = function(indexVal){
			discoverFeaturesVm.moreClicked[indexVal] = true;
		}
	    /*************************Fetch all videos end************************************/	
	}
	
	  /*************************show video in popup start************************************/	
	discoverFeaturesVm.disFeaturesVideoAlert = function(videoUrl,videoTitle){
		
			$scope.videoUrl=videoUrl;
			$scope.trustSrc = function(videoUrl){
				return  $sce.trustAsResourceUrl(videoUrl)
			}
			$scope.videoTitle=videoTitle;
			$ionicPopup.alert({
			 title: '',
			 templateUrl: 'pages/support/discoverOurFeature/discoverOurFeaturePopup.html',
			 scope: $scope,
			 cssClass: 'dialog',
			 buttons: [
				 {                                                                  
				   text: 'Close',
					  onTap: function(e) {
						$state.go('menu.discoverOurFeature');
					  }
				}
			 ]
		   });
		}
	  /*************************show video in popup end************************************/	
	
	
	discoverFeaturesVm.manageVpa = function(){
		$state.go('menu.createVPA');
	}
	
	discoverFeaturesVm.manageQr = function(){
		$state.go('menu.qrCode');
	}
	discoverFeaturesVm.selPrimaryAcc = function(){
		$state.go('menu.selPrimaryAcc');
	}
	discoverFeaturesVm.setNotifications = function(){
		$state.go('menu.settingsNotifications');
	}
	
	discoverFeaturesVm.changeMpin = function(){
		$state.go('menu.changeMpin');
	}
	discoverFeaturesVm.mmidDetails = function(){
		$state.go('menu.mmidDetails');
	}
	discoverFeaturesVm.discoverFeaturesVm = function(){
		$state.go('menu.discoverFeaturesVm');
	}
	
	
	//private methods section end
	
	//public functions start
	
	//public functions end
	
	//back to prev page
	discoverFeaturesVm.gotToPreviousPage = function(){
		$state.go('menu.support');
	}
	
	//go to next page
	discoverFeaturesVm.goToNextPage = function(){
		$state.go('menu.accountOverviewPopup');
	}
	
	
	//one time initialization to be done when the controller is loaded
		$scope.$on('$ionicView.loaded', function() {
		$ionicSideMenuDelegate.canDragContent(false)
	});
	
	//actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function() {
		$ionicSideMenuDelegate.canDragContent(false)

		initPage();
	});
	
	//any cleanup needs to be done here: executes everytime when page is left
	$scope.$on('$ionicView.afterLeave', function() {
		$ionicSideMenuDelegate.canDragContent(true)

	});
	return this;
}]);