'use strict';

angularApp.controller('raiseQueryController', 
						["$timeout",
						 "$state",
						 "$location",
						 "$scope","supportServices","$ionicPopup","$rootScope","utilityService","$sce","$http",				 
function ($timeout,
		 $state,
		 $location,
		 $scope,supportServices,$ionicPopup,$rootScope,utilityService,$sce,$http) {
	
	
	var raiseQueryVm = this;
	
	//functions, variables that can be accessed from the HTML come here
	function initPage(){
		utilityService.enableShowErrorMessage();
		raiseQueryVm.getApiKey();
		raiseQueryVm.showBack = false;
		raiseQueryVm.showNext = true;
	}
	raiseQueryVm.getApiKey =function(){
		var reqParam = {};
		reqParam["linkType"] = "raise";
		supportServices.getCMSRedirectUrl(reqParam).then(function(data){
			 raiseQueryVm.dataUrl= data.url;
		},function(error){
			utilityService.showErrorMessage(error.responseMessage);
		}); 
	}
  /*************************Check queryType here start************************************/	
	raiseQueryVm.query = function(queryType){
		if(queryType=="MARKETPLACE"){	
			raiseQueryVm.queryAlert();
		}
		else {
			$state.go('menu.categoryWiseQuery',{obj:queryType});
		}
	}
	 /*************************Check queryType here end************************************/	
	 
	/*************************if queryType = marketpalce call this function start************************************/	
	raiseQueryVm.queryAlert = function(index){
		$scope.pageval=index;
		var confirmPopup = $ionicPopup.confirm({
			templateUrl:'pages/support/raiseQuery/categoryWiseQuery/marketQueryAlert.html',
			cssClass: 'dialog-market',
			buttons : false,
		});	
		
		 $rootScope.marketQueryRequired = function()
				   {
									if($rootScope.marketQueryDescription == "" || $rootScope.marketQueryDescription  == undefined)
							{
								 $rootScope.marketQueryRequiredError = true;					 
							}				  
						else { raiseQueryVm.showPopup($rootScope.marketQueryDescription);
						        confirmPopup.close();
							 } 
				   }
				   
				    $rootScope.marketCloseQueryPopup = function()
				   {
					   confirmPopup.close();
					   
				   }
		/*************************if queryType = marketpalce call this function end************************************/	
		
		
	/*************************if queryType != marketpalce call this function start************************************/	
	raiseQueryVm.showPopup = function(query){
	        supportServices.submitQuery().then(
				function(data) {
						$scope.message=data.submitQuery.message;
						$scope.queryNumber=data.data.submitQuery.queryReferenceNumber;
				},
				function(error) {
					    utilityService.showErrorMessage(error.responseMessage);
				}
			);
						$ionicPopup.alert({
						 title: '',
						 templateUrl: 'pages/support/raiseQuery/showSuccessPopup.html',
						  scope: $scope,
						  cssClass: 'dialog',
						 buttons: [
							 {                                                                  
							   text: 'OK',
								  onTap: function(e) {
									  $state.go('menu.raiseQuery'); 
								  }
							}
						 ]
					   });
					}
					
	/*************************if queryType != marketpalce call this function end************************************/	
		
	}																																		

	
	//back to prev page
	raiseQueryVm.goBacktoPrevious = function(){
		$state.go('menu.support');
	}
	
	
	//one time initialization to be done when the controller is loaded
	$scope.$on('$ionicView.loaded', function() {
		
		initPage();
	});
	
	//actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function() {
	
	});
	
	//actions to done everytime the view is hidden
	$scope.$on('$ionicView.afterLeave', function() {
		
		//any cleanup needs to be done here: executes everytime when page is left
	});
	return this;
}]);
