'use strict';
angularApp.controller('verifyDetailsController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"customerInfoService",
		"wealthService","getAccountDetailsService", "homeScreenService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, customerInfoService, wealthService,getAccountDetailsService, homeScreenService) {
			
			var verifyDetailsVm = this;
			
			function initPage() {
				// verifyDetailsVm.isSubmitEnabled = true;
				console.log("customerInfoService",customerInfoService);
				if(!customerInfoService.customer.mobile)
                {
                    homeScreenService.getCustomerInfo().then(function (data) {
                        getAccountDetailsService.accountOverviewData = data;
                        customerInfoService.customer.name = data.customerInformation.customerName;
                        customerInfoService.customer.type = data.customerInformation.customerType;
                        customerInfoService.customer.DOB = data.customerInformation.dob;
                        customerInfoService.customer.isPanAvailable = data.customerInformation.panNumber;
                        customerInfoService.customer.isStaffFlag = data.customerInformation.isStaffFlag;
                        customerInfoService.customer.emailID = data.customerInformation.emailID;
                        customerInfoService.customer.mobile = data.customerInformation.mobile;
                        customerInfoService.customer.title = data.customerInformation.title;
                        customerInfoService.customer.residentialStatus = data.customerInformation.residentialStatus;

                        verifyDetailsVm.customerName = customerInfoService.customer.name;
				verifyDetailsVm.mobilenumber = customerInfoService.customer.mobile;
				verifyDetailsVm.emailid = customerInfoService.customer.emailID;
                    },
                    function (error) {

                });
                }
                else{
                	verifyDetailsVm.customerName = customerInfoService.customer.name;
				verifyDetailsVm.mobilenumber = customerInfoService.customer.mobile;
				verifyDetailsVm.emailid = customerInfoService.customer.emailID;
                }
				

				if (verifyDetailsVm.customerName && verifyDetailsVm.mobilenumber && verifyDetailsVm.emailid) {
					verifyDetailsVm.isSubmitEnabled = false;
				} else {
					verifyDetailsVm.isSubmitEnabled = true;
				}
			};

			verifyDetailsVm.goToAO = function () {
				$state.go('menu.homeScreen');
			}

			verifyDetailsVm.fieldvalidation = function () {

				var emailValidExpr = /^([0-9a-zA-Z]([-_\\.]*[0-9a-zA-Z]+)*)@([0-9a-zA-Z]([-_\\.]*[0-9a-zA-Z]+)*)[\\.]([a-zA-Z]{2,9})$/;

				if (!emailValidExpr.test(verifyDetailsVm.emailid)) {
		            verifyDetailsVm.emailvalidFlag = true;
		        } else {
					verifyDetailsVm.emailvalidFlag = false;
				}
				if(verifyDetailsVm.mobilenumber.length < 10){
					verifyDetailsVm.mobilenumbervalidFlag = true;
				}
				else{
					verifyDetailsVm.mobilenumbervalidFlag = false;
				}

				if (!emailValidExpr.test(verifyDetailsVm.emailid) || verifyDetailsVm.mobilenumber.length < 10) {
					verifyDetailsVm.isSubmitEnabled = true;
				} else {
					verifyDetailsVm.isSubmitEnabled = false;
				}
				
			}

			verifyDetailsVm.submit = function () {
				verifyDetailsVm.isSubmitEnabled = true;
				utilityService.showSpinner();
				var obj = {
					"customerName" : verifyDetailsVm.customerName,
					"mobileNo" : verifyDetailsVm.mobilenumber,
					"emailId" : verifyDetailsVm.emailid
				}
				wealthService.WealthEligibilityApply(obj).then(function(data) {
					utilityService.hideSpinner();
					//to call customer info again
					getAccountDetailsService.accountOverviewData = "";
					homeScreenService.isNotificationDataAvail = false;
					wealthService.bannerFlag = false;
                    console.log("WealthEligibilityApply",obj,data)
					var title = '';
					var stringText = 'Thank you for your interest in SBI Wealth.<br>A representative will get in touch with you shortly.';
					var template = '<div class="text-center">'+stringText+'</div>';
					$ionicPopup.show({
						title: '',
						template: template,
						scope: $scope,
						cssClass: 'my-custom-popup',
						buttons: [{
							text: 'OK',
							type: 'button-assertive',
							onTap: function () {
								verifyDetailsVm.isSubmitEnabled = false;
								homeScreenService.isInvestmentFlag = true;
								getAccountDetailsService.tabIndex.tabIndex = 3;
								utilityService.setCsatJournies('wealthExclusif');
								$state.go("menu.accountOverviewMyBalance");
							}
						}],
					});
                },function(error) {
                	verifyDetailsVm.isSubmitEnabled = false;
                	utilityService.hideSpinner();
                    console.log("error",error)
                    utilityService.showErrorMessage(error.responseMessage);
                });
			}

			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				
			});

			return this;
		}
]);



