'use strict';
angularApp.controller('xcAadhardetailsController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"xpressCreditService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, xpressCreditService) {
			
			var xcAadhardetailsVm = this;
			
			function initPage() {

				xcAadhardetailsVm.disabledNext = true;
				
				xcAadhardetailsVm.aadharnumberErr = false;
				xcAadhardetailsVm.firstnameErr = false;
				xcAadhardetailsVm.middlenameErr = false;
				xcAadhardetailsVm.lastnameErr = false;
				xcAadhardetailsVm.titleErr = false;
				xcAadhardetailsVm.dobProperErr = false;

				xcAadhardetailsVm.dobPresent = false;

				xcAadhardetailsVm.personalDetailsYear = xpressCreditService.createXcData.aadharScanDetails.yob;

				if (xpressCreditService.createXcData.isManuallyFillDetails == false) {
					if (xpressCreditService.createXcData.aadharScanDetails.dob) {
						xcAadhardetailsVm.DOBCust = new Date(xpressCreditService.createXcData.aadharScanDetails.dob);
						xcAadhardetailsVm.dobPresent = true;
					} else {
						xcAadhardetailsVm.dobPresent = false;
					}

					xcAadhardetailsVm.aadharnumber = xpressCreditService.createXcData.aadharScanDetails.aadharnumber;
					
					if (xpressCreditService.createXcData.aadharScanDetails.gender == "F" || xpressCreditService.createXcData.aadharScanDetails.gender == "FEMALE") {
						xcAadhardetailsVm.title = "ms";
					} else if (xpressCreditService.createXcData.aadharScanDetails.gender == "M" || xpressCreditService.createXcData.aadharScanDetails.gender == "MALE") {
						xcAadhardetailsVm.title = "mr";
					} else {
						xcAadhardetailsVm.title = "";
					}

					xcAadhardetailsVm.firstname = xpressCreditService.createXcData.aadharScanDetails.firstname;
					xcAadhardetailsVm.middlename = xpressCreditService.createXcData.aadharScanDetails.middlename;
					xcAadhardetailsVm.lastname = xpressCreditService.createXcData.aadharScanDetails.lastname;
					
					if (xpressCreditService.createXcData.aadharScanDetails.gender == "F" || xpressCreditService.createXcData.aadharScanDetails.gender == "FEMALE") {
						xcAadhardetailsVm.genderValues = "FEMALE";
					} else if (xpressCreditService.createXcData.aadharScanDetails.gender == "M" || xpressCreditService.createXcData.aadharScanDetails.gender == "MALE") {
						xcAadhardetailsVm.genderValues = "MALE";
					}

					xcAadhardetailsVm.disabledAdharFields = true;
					xcAadhardetailsVm.disabledNext = false;
				} else {
					// xcAadhardetailsVm.DOBCust = new Date();
					
					if (xpressCreditService.createXcData.aadharScanDetails.gender == "F" || xpressCreditService.createXcData.aadharScanDetails.gender == "FEMALE") {
						xcAadhardetailsVm.gender = "F";
					} else if (xpressCreditService.createXcData.aadharScanDetails.gender == "M" || xpressCreditService.createXcData.aadharScanDetails.gender == "MALE") {
						xcAadhardetailsVm.gender = "M";
					} else {
						xcAadhardetailsVm.gender = xpressCreditService.createXcData.aadharScanDetails.gender;
					}

					xcAadhardetailsVm.disabledAdharFields = false;

				}
			};

			xcAadhardetailsVm.goToAO = function () {
				// xpressCreditService.initialValueStage();
				$state.go('menu.loans');
			}

			xcAadhardetailsVm.changeRadioGender = function () {
				if (xcAadhardetailsVm.firstname && xcAadhardetailsVm.lastname && xcAadhardetailsVm.aadharnumber 
					&& xcAadhardetailsVm.title && xcAadhardetailsVm.gender && xcAadhardetailsVm.personalDetailsDate 
					&& xcAadhardetailsVm.personalDetailsMonth && xcAadhardetailsVm.personalDetailsYear) {
					xcAadhardetailsVm.disabledNext = false;
				} else {
					xcAadhardetailsVm.disabledNext = true;
				}
			}

			xcAadhardetailsVm.validationFields = function (type) {
				if (xpressCreditService.createXcData.isManuallyFillDetails == true) {
					if (xcAadhardetailsVm.firstname && xcAadhardetailsVm.lastname && xcAadhardetailsVm.aadharnumber && xcAadhardetailsVm.title && xcAadhardetailsVm.gender) {
						xcAadhardetailsVm.disabledNext = false;
					} else {
						xcAadhardetailsVm.disabledNext = true;
					}
				} else {
					if (xcAadhardetailsVm.firstname && xcAadhardetailsVm.lastname && xcAadhardetailsVm.aadharnumber && xcAadhardetailsVm.title) {
						xcAadhardetailsVm.disabledNext = false;
					} else {
						xcAadhardetailsVm.disabledNext = true;
					}
				}

				if (type == "aadharnumber") {
					if (xcAadhardetailsVm.aadharnumber) {
						xcAadhardetailsVm.aadharnumberErr = false;
					} else {
						xcAadhardetailsVm.aadharnumberErr = true;
					}
				}

				if (type == "firstname") {
					if (xcAadhardetailsVm.firstname) {
						xcAadhardetailsVm.firstnameErr = false;
					} else {
						xcAadhardetailsVm.firstnameErr = true;
					}
				}

				// if (type == "middlename") {
				// 	if (xcAadhardetailsVm.middlename) {
				// 		xcAadhardetailsVm.middlenameErr = false;
				// 	} else {
				// 		xcAadhardetailsVm.middlenameErr = true;
				// 	}
				// }

				if (type == "lastname") {
					if (xcAadhardetailsVm.lastname) {
						xcAadhardetailsVm.lastnameErr = false;
					} else {
						xcAadhardetailsVm.lastnameErr = true;
					}
				}

				if (type == "title") {
					if (xcAadhardetailsVm.title) {
						xcAadhardetailsVm.titleErr = false;
					} else {
						xcAadhardetailsVm.titleErr = true;
					}
				}
			}

			xcAadhardetailsVm.validDateFormat = function() {
	            var fullDate = xcAadhardetailsVm.personalDetailsMonth + '-' + xcAadhardetailsVm.personalDetailsDate + '-' + xcAadhardetailsVm.personalDetailsYear;
	            var dobMonth = xcAadhardetailsVm.personalDetailsMonth;
	            var dobDay = xcAadhardetailsVm.personalDetailsDate;
	            var dobYr = xcAadhardetailsVm.personalDetailsYear;
	            var fullDateInMilliSeconds = Date.parse(fullDate);
	            var formattedDate = new Date();
	            var formattedDateYr = formattedDate.getFullYear();
	            var currDate = new Date();
	            var curYear = currDate.getFullYear();
	            var curDateInMilliSeconds = new Date().getTime();
	            formattedDate.setFullYear(dobYr, dobMonth - 1, dobDay);
	            var months30 = ["04", "06", "09", "11", "4", "6", "9"];
	            var monthIndex = months30.indexOf(dobMonth);
	            var d = new Date().getFullYear();

	            if (xcAadhardetailsVm.personalDetailsMonth && xcAadhardetailsVm.personalDetailsDate && xcAadhardetailsVm.personalDetailsYear 
	            	&& parseInt(xcAadhardetailsVm.personalDetailsYear) <= d) {
	            	xcAadhardetailsVm.disabledNext = false;
	            	xcAadhardetailsVm.dobProperErr = false;
	            } else {
	            	xcAadhardetailsVm.disabledNext = true;
	            	xcAadhardetailsVm.dobProperErr = true;
	            }
	        }

	        xcAadhardetailsVm.checkAge = function() {
                var todayDate = new Date();
                var currentYear = todayDate.getFullYear();
                var validYear = todayDate.setFullYear(currentYear - 18);
                var age = currentYear - parseInt(xcAadhardetailsVm.personalDetailsYear);
	        }

	        xcAadhardetailsVm.populateDobAadhaar = function() {
	            if (utilityService.isUndefined(xpressCreditService.createXcData.aadharScanDetails.dob)) {
	                // xpressCreditService.createXcData.aadharScanDetails.dob = moment(xpressCreditService.createXcData.aadharScanDetails.dob, ["DD/MM/YYYY", "MM/DD/YYYY", "DD-MM-YYYY", "MM-DD-YYYY", "YYYY-MM-DD", "YYYY-DD-MM","YYYY/MM/DD", "YYYY/DD/MM"]);
	                // var dateFormat = new Date(xpressCreditService.createXcData.aadharScanDetails.dob);
	                // var day = dateFormat.getDate();
	                // var month = dateFormat.getMonth() + 1;
	                // var year = dateFormat.getFullYear();
	                // var formattedDate = day.toString();
	                // if (formattedDate.length == 1) {
	                //     formattedDate = "0" + formattedDate;
	                //     xcAadhardetailsVm.personalDetailsDate = formattedDate;
	                // } else {
	                //     xcAadhardetailsVm.personalDetailsDate = parseInt(day);
	                // }
	                // var formattedMonth = month.toString();
	                // if (formattedMonth.length == 1) {
	                //     formattedMonth = "0" + formattedMonth;
	                //     xcAadhardetailsVm.personalDetailsMonth = formattedMonth;
	                // } else {
	                //     xcAadhardetailsVm.personalDetailsMonth = parseInt(month);
	                // }
	                // xpressCreditService.createXcData.aadharScanDetails.yob = parseInt(year);
	                xcAadhardetailsVm.personalDetailsYear = parseInt(xpressCreditService.createXcData.aadharScanDetails.yob);
	            } else if (!utilityService.isUndefined(xpressCreditService.createXcData.aadharScanDetails.yob) && utilityService.isUndefined(xpressCreditService.createXcData.aadharScanDetails.dob)) {
	                xcAadhardetailsVm.DOBCust = new Date(xpressCreditService.createXcData.aadharScanDetails.dob);
	                
	                // xcAadhardetailsVm.personalDetailsDate = "";
	                // xcAadhardetailsVm.personalDetailsMonth = "";
	                // xcAadhardetailsVm.personalDetailsYear = parseInt(year);
	                // xcAadhardetailsVm.personalDetailsDateForm.personalDetailsDate.$setPristine();
	                // xcAadhardetailsVm.personalDetailsDateForm.personalDetailsMonth.$setPristine();
	            }
	        }

			xcAadhardetailsVm.openDatePicker = function () {
				if (xpressCreditService.createXcData.isManuallyFillDetails == true) {
					ionicDatePicker.openDatePicker(xcAadhardetailsVm.ipObj1);
				}
			};

			xcAadhardetailsVm.ipObj1 = {
				callback: function (val) {
					xcAadhardetailsVm.DOBCust = new Date(val);
					var newDate = new Date(val);
					xcAadhardetailsVm.personalDetailsDate = newDate.getDate();
					xcAadhardetailsVm.personalDetailsMonth = newDate.getMonth() + 1;
					xcAadhardetailsVm.personalDetailsYear = newDate.getFullYear();	

					if (xcAadhardetailsVm.firstname && xcAadhardetailsVm.lastname 
						&& xcAadhardetailsVm.aadharnumber && xcAadhardetailsVm.title && xcAadhardetailsVm.gender
						&& xcAadhardetailsVm.personalDetailsDate && xcAadhardetailsVm.personalDetailsMonth && xcAadhardetailsVm.personalDetailsYear) {
						xcAadhardetailsVm.disabledNext = false;
					} else {
						xcAadhardetailsVm.disabledNext = true;
					}
				},
				// inputDate: new Date(),
				// from: new Date(xcAadhardetailsVm.DOBCust),
				to: new Date(),
				mondayFirst: true,
				closeOnSelect: false,
				templateType: 'popup',
			};

			xcAadhardetailsVm.showAadharNumber = function () {
				var template =  '<div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter">Aadhar Number : '+xcAadhardetailsVm.aadharnumber+'</div></div>';
				$ionicPopup.show({
					title: '',
					template: template,
					scope: $scope,
					cssClass: 'my-custom-popup',
					buttons: [{
						text: 'OK',
						type: 'button-assertive',
						onTap: function () {
							$state.go('menu.xcAadhardetails');
						}
					}],
				});
			}

			xcAadhardetailsVm.goToCancel = function () {
				$state.go('menu.xcUpdateaccount');
			}

			xcAadhardetailsVm.goToConfirm = function () {
	   			var todayDate = new Date();
                var currentYear = todayDate.getFullYear();
                var validYear = todayDate.setFullYear(currentYear - 18);
                var age = currentYear - parseInt(xcAadhardetailsVm.personalDetailsYear);
	            var dateDOB = "";

				xpressCreditService.createXcData.aadharScanDetails.aadharnumber = xcAadhardetailsVm.aadharnumber;
				xpressCreditService.createXcData.aadharScanDetails.title = xcAadhardetailsVm.title;
				xpressCreditService.createXcData.aadharScanDetails.firstname = xcAadhardetailsVm.firstname;
				xpressCreditService.createXcData.aadharScanDetails.middlename = xcAadhardetailsVm.middlename;
				xpressCreditService.createXcData.aadharScanDetails.lastname = xcAadhardetailsVm.lastname;
				if (xpressCreditService.createXcData.isManuallyFillDetails == false) {
					xpressCreditService.createXcData.aadharScanDetails.gender = xcAadhardetailsVm.genderValues;
				} else {
					xpressCreditService.createXcData.aadharScanDetails.gender = xcAadhardetailsVm.gender;
				}

				if (xpressCreditService.createXcData.aadharScanDetails.dob) {
					dateDOB = new Date(xcAadhardetailsVm.DOBCust);
					xpressCreditService.createXcData.aadharScanDetails.dob = xcAadhardetailsVm.DOBCust;			
				} else {
					var fullDate = xcAadhardetailsVm.personalDetailsMonth + '-' + xcAadhardetailsVm.personalDetailsDate + '-' + xcAadhardetailsVm.personalDetailsYear;
		            dateDOB = new Date(fullDate);
					xpressCreditService.createXcData.aadharScanDetails.dob = dateDOB;
				}

				xpressCreditService.createXcData.redirectFromKyc = true;	

				var obj = {
					"pageName": "aadharDetails",
					"progress": "10%",
					"yonoRefNo": "",
					"aadhaarValtNo": xcAadhardetailsVm.aadharnumber,
					"title": xcAadhardetailsVm.title,
					"firstName": xcAadhardetailsVm.firstname,
					"middleName": xcAadhardetailsVm.middlename,
					"lastName": xcAadhardetailsVm.lastname,
					"gender": xpressCreditService.createXcData.aadharScanDetails.gender,
					"dob": dateDOB
				}

				if (age > 18) {
					xpressCreditService.OmniCallResponse(obj).then(function(data) {
	                    console.log("OmniCallResponse",obj,data)
						$state.go('menu.xcAddressDetails');
	                },function(error) {
	                    utilityService.showErrorMessage(error.responseMessage);
	                });				
                } else {
                	var title = '';
	                var template = 'Age below 18 Years - Xpress Credit Loan not allowed for Minor, Please visit the nearest branch, in case you wish to open Minor account.';
	                var onTap = 'menu.xcAadhardetails';
	                var buttontext = '<b>OK</b>';
	                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                }

				
			}

			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {

				

				if (xpressCreditService.createXcData.aadharScanDetails.aadharnumber) {
					xcAadhardetailsVm.aadharnumber = xpressCreditService.createXcData.aadharScanDetails.aadharnumber;
				}

				if (xpressCreditService.createXcData.aadharScanDetails.title) {
					xcAadhardetailsVm.title = xpressCreditService.createXcData.aadharScanDetails.title;
				}

				if (xpressCreditService.createXcData.aadharScanDetails.firstname) {
					xcAadhardetailsVm.firstname = xpressCreditService.createXcData.aadharScanDetails.firstname;
				}

				if (xpressCreditService.createXcData.aadharScanDetails.middlename) {
					xcAadhardetailsVm.middlename = xpressCreditService.createXcData.aadharScanDetails.middlename;
				}

				if (xpressCreditService.createXcData.aadharScanDetails.lastname) {
					xcAadhardetailsVm.lastname = xpressCreditService.createXcData.aadharScanDetails.lastname;
				}

				if (xpressCreditService.createXcData.aadharScanDetails.gender == "F" || xpressCreditService.createXcData.aadharScanDetails.gender == "FEMALE") {
					xcAadhardetailsVm.title = "ms";
				} else if (xpressCreditService.createXcData.aadharScanDetails.gender == "M" || xpressCreditService.createXcData.aadharScanDetails.gender == "MALE") {
					xcAadhardetailsVm.title = "mr";
				} else {
					xcAadhardetailsVm.title = "";
				}

				if (xpressCreditService.createXcData.aadharScanDetails.dob) {
					var date = new Date(xpressCreditService.createXcData.aadharScanDetails.dob);

					xcAadhardetailsVm.personalDetailsDate = date.getDate();
					xcAadhardetailsVm.personalDetailsMonth = date.getMonth() + 1;
					xcAadhardetailsVm.personalDetailsYear = date.getFullYear();	

					if (xcAadhardetailsVm.firstname && xcAadhardetailsVm.lastname && xcAadhardetailsVm.aadharnumber && 
						xcAadhardetailsVm.title && xcAadhardetailsVm.personalDetailsDate && xcAadhardetailsVm.personalDetailsMonth 
						&& xcAadhardetailsVm.personalDetailsYear) {
						xcAadhardetailsVm.disabledNext = false;
					} else {
						xcAadhardetailsVm.disabledNext = true;
					}
				} else {
					if (xcAadhardetailsVm.firstname && xcAadhardetailsVm.lastname && xcAadhardetailsVm.aadharnumber && 
						xcAadhardetailsVm.title && xcAadhardetailsVm.personalDetailsDate && xcAadhardetailsVm.personalDetailsMonth 
						&& xcAadhardetailsVm.personalDetailsYear) {
						xcAadhardetailsVm.disabledNext = false;
					} else {
						xcAadhardetailsVm.disabledNext = true;
					}
				}
				xcAadhardetailsVm.populateDobAadhaar();
			});

			return this;
		}
]);


