'use strict';
angularApp.controller('xcAdditionalDetailsController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"xpressCreditService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, xpressCreditService) {
			
			var xcAdditionalDetailsVm = this;
			
			function initPage() {
				xcAdditionalDetailsVm.disabledNext = true;

				xcAdditionalDetailsVm.mothermaidenErr = false;
				xcAdditionalDetailsVm.selectededucationalValueErr = false;
				xcAdditionalDetailsVm.selectedhouseownerValueErr = false;
				xcAdditionalDetailsVm.monthlyincomeErr = false;
				xcAdditionalDetailsVm.monthlyincomeGreaterErr = false;
				xcAdditionalDetailsVm.selectedreligionValueErr = false;
				xcAdditionalDetailsVm.selectedcategoryValueErr = false;
				xcAdditionalDetailsVm.selecteddisabilityValueErr = false;

				xcAdditionalDetailsVm.eduQualiDetails = xpressCreditService.eduQualiArray;
				xcAdditionalDetailsVm.houseOwnerDetails = xpressCreditService.houseOwnerArray;
				xcAdditionalDetailsVm.religionDetails = xpressCreditService.religionArray;
				xcAdditionalDetailsVm.categoryDetails = xpressCreditService.categoryArray;
				xcAdditionalDetailsVm.physicalDisableDetails = xpressCreditService.physicalDisableArray;
				
			};

			xcAdditionalDetailsVm.goToAO = function () {
				$state.go('menu.loans');
			}

			xcAdditionalDetailsVm.validationAll = function () {
				if (xcAdditionalDetailsVm.mothermaiden && xcAdditionalDetailsVm.selectededucationalValue && xcAdditionalDetailsVm.selectedhouseownerValue
					&& xcAdditionalDetailsVm.monthlyincome && xcAdditionalDetailsVm.selectedreligionValue && xcAdditionalDetailsVm.selectedcategoryValue
					&& xcAdditionalDetailsVm.selecteddisabilityValue && parseInt(xcAdditionalDetailsVm.monthlyincome) > parseInt(xpressCreditService.createXcData.netMonthlyIncome)) {

					xcAdditionalDetailsVm.disabledNext = false;
				} else {
					if (xcAdditionalDetailsVm.monthlyincome) {
						if (parseInt(xcAdditionalDetailsVm.monthlyincome) > parseInt(xpressCreditService.createXcData.netMonthlyIncome)) {
							xcAdditionalDetailsVm.monthlyincomeGreaterErr = false;
						} else {
							xcAdditionalDetailsVm.monthlyincomeGreaterErr = true;
						}
					}
					xcAdditionalDetailsVm.disabledNext = true;
				}
			}

			xcAdditionalDetailsVm.validationField = function (type) {
				xcAdditionalDetailsVm.validationAll();
				if (type == "mothermaiden") {
					if (xcAdditionalDetailsVm.mothermaiden) {
						if (xcAdditionalDetailsVm.mothermaiden.length > 40) {
							xcAdditionalDetailsVm.mothermaiden = xcAdditionalDetailsVm.mothermaiden.substring(0, xcAdditionalDetailsVm.mothermaiden.length - 1)
						}
						xcAdditionalDetailsVm.mothermaidenErr = false;
					} else {
						xcAdditionalDetailsVm.mothermaidenErr = true;
					}
				}

				if (type == "selectededucationalValue") {
					if (xcAdditionalDetailsVm.selectededucationalValue) {
						xcAdditionalDetailsVm.selectededucationalValueErr = false;
					} else {
						xcAdditionalDetailsVm.selectededucationalValueErr = true;
					}
				}

				if (type == "selectedhouseownerValue") {
					if (xcAdditionalDetailsVm.selectedhouseownerValue) {
						xcAdditionalDetailsVm.selectedhouseownerValueErr = false;
					} else {
						xcAdditionalDetailsVm.selectedhouseownerValueErr = true;
					}
				}

				if (type == "monthlyincome") {
					if (xcAdditionalDetailsVm.monthlyincome) {
						xcAdditionalDetailsVm.monthlyincomeErr = false;
					} else {
						xcAdditionalDetailsVm.monthlyincomeErr = true;
					}

					if (parseInt(xcAdditionalDetailsVm.monthlyincome) > parseInt(xpressCreditService.createXcData.netMonthlyIncome)) {
						xcAdditionalDetailsVm.monthlyincomeGreaterErr = false;
					} else {
						xcAdditionalDetailsVm.monthlyincomeGreaterErr = true;
					}
				}

				if (type == "selectedreligionValue") {
					if (xcAdditionalDetailsVm.selectedreligionValue) {
						xcAdditionalDetailsVm.selectedreligionValueErr = false;
					} else {
						xcAdditionalDetailsVm.selectedreligionValueErr = true;
					}
				}

				if (type == "selectedcategoryValue") {
					if (xcAdditionalDetailsVm.selectedcategoryValue) {
						xcAdditionalDetailsVm.selectedcategoryValueErr = false;
					} else {
						xcAdditionalDetailsVm.selectedcategoryValueErr = true;
					}
				}

				if (type == "selecteddisabilityValue") {
					if (xcAdditionalDetailsVm.selecteddisabilityValue) {
						xcAdditionalDetailsVm.selecteddisabilityValueErr = false;
					} else {
						xcAdditionalDetailsVm.selecteddisabilityValueErr = true;
					}
				}
			}

			xcAdditionalDetailsVm.goToCancel = function () {
				$state.go('menu.xcAddressDetails');
			}

			xcAdditionalDetailsVm.goToConfirm = function () {
				var eduQualificationData = "";
				var eduQualificationId = "";
				var eduQualificationText = "";
				var ownershipData = "";
				var ownershipId = "";
				var ownershipText = "";
				var religionData = "";
				var religionId = "";
				var religionText = "";
				var categoryData = "";
				var categoryId = "";
				var categoryText = "";
				var physicaldisableData = "";
				var physicaldisableId = "";
				var physicaldisableText = "";

				xpressCreditService.createXcData.additionalAddress.motherMaidenName = xcAdditionalDetailsVm.mothermaiden;
				xpressCreditService.createXcData.additionalAddress.grossIncome = xcAdditionalDetailsVm.monthlyincome;

				if (xcAdditionalDetailsVm.selectededucationalValue) {
					xpressCreditService.createXcData.additionalAddress.eduQualification = xcAdditionalDetailsVm.selectededucationalValue;
					eduQualificationData = JSON.parse(xcAdditionalDetailsVm.selectededucationalValue);
					eduQualificationId = eduQualificationData.key;
					eduQualificationText = eduQualificationData.value;
				}

				if (xcAdditionalDetailsVm.selectedhouseownerValue) {
					xpressCreditService.createXcData.additionalAddress.houseOwner = xcAdditionalDetailsVm.selectedhouseownerValue;
					ownershipData = JSON.parse(xcAdditionalDetailsVm.selectedhouseownerValue);
					ownershipId = ownershipData.key;
					ownershipText = ownershipData.value;
				}


				if (xcAdditionalDetailsVm.selectedreligionValue) {
					xpressCreditService.createXcData.additionalAddress.religion = xcAdditionalDetailsVm.selectedreligionValue;
					religionData = JSON.parse(xcAdditionalDetailsVm.selectedreligionValue);
					religionId = religionData.key;
					religionText = religionData.value;
				}

				if (xcAdditionalDetailsVm.selectedcategoryValue) {
					xpressCreditService.createXcData.additionalAddress.category = xcAdditionalDetailsVm.selectedcategoryValue;
					categoryData = JSON.parse(xcAdditionalDetailsVm.selectedcategoryValue);
					categoryId = categoryData.key;
					categoryText = categoryData.value;
				}

				if (xcAdditionalDetailsVm.selecteddisabilityValue) {
					xpressCreditService.createXcData.additionalAddress.physicalDisability = xcAdditionalDetailsVm.selecteddisabilityValue;	
					physicaldisableData = JSON.parse(xcAdditionalDetailsVm.selecteddisabilityValue);
					physicaldisableId = physicaldisableData.key;
					physicaldisableText = physicaldisableData.value;	
				}

				var obj = {
					"pageName": "additionalDetails",
					"progress": "30%",
					"yonoRefNo": "",
					"maidenName": xcAdditionalDetailsVm.mothermaiden,
					"grossMonthlyIncome": xcAdditionalDetailsVm.monthlyincome,
					"qualificationId": eduQualificationId,
					"qualificationText": xcAdditionalDetailsVm.selectededucationalValue,
					"ownerShipId": ownershipId,
					"ownerShipText": xcAdditionalDetailsVm.selectedhouseownerValue,
					"religionId": religionId,
					"religionText": xcAdditionalDetailsVm.selectedreligionValue,
					"categoryId": categoryId,
					"categoryText": xcAdditionalDetailsVm.selectedcategoryValue,
					"phyDisabilityId": physicaldisableId,
					"phyDisabilityText": xcAdditionalDetailsVm.selecteddisabilityValue
				}

				xpressCreditService.OmniCallResponse(obj).then(function(data) {
                    console.log("OmniCallResponse",obj,data)
					$state.go('menu.xcWorkDetails');
                },function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });				

				
			}

			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				xcAdditionalDetailsVm.mothermaiden = xpressCreditService.createXcData.additionalAddress.motherMaidenName;
				xcAdditionalDetailsVm.selectededucationalValue = xpressCreditService.createXcData.additionalAddress.eduQualification;
				xcAdditionalDetailsVm.selectedhouseownerValue = xpressCreditService.createXcData.additionalAddress.houseOwner;
				xcAdditionalDetailsVm.monthlyincome = xpressCreditService.createXcData.additionalAddress.grossIncome;
				xcAdditionalDetailsVm.selectedreligionValue = xpressCreditService.createXcData.additionalAddress.religion;
				xcAdditionalDetailsVm.selectedcategoryValue = xpressCreditService.createXcData.additionalAddress.category;
				xcAdditionalDetailsVm.selecteddisabilityValue = xpressCreditService.createXcData.additionalAddress.physicalDisability;	

				xcAdditionalDetailsVm.validationAll();
			});

			return this;
		}
]);


