'use strict';
angularApp.controller('xcAddressDetailsController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"xpressCreditService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, xpressCreditService) {
			
			var xcAddressDetailsVm = this;
			
			function initPage() {
				xcAddressDetailsVm.residentialDiv = false;
				xcAddressDetailsVm.isCurrentcheck = true;
				xcAddressDetailsVm.disabledNext = true;

				xcAddressDetailsVm.address1Err = false;
				xcAddressDetailsVm.address2Err = false;
				xcAddressDetailsVm.address3Err = false;
				xcAddressDetailsVm.pincodeErr = false;
				xcAddressDetailsVm.cityErr = false;
				xcAddressDetailsVm.stateErr = false;
				xcAddressDetailsVm.districtErr = false;
				xcAddressDetailsVm.statePermanentValueErr = false;
				xcAddressDetailsVm.districtPermanentValueErr = false;
				xcAddressDetailsVm.cityPermanentValueErr = false;
				xcAddressDetailsVm.selectedsubdistrictValueErr = false;
				xcAddressDetailsVm.selectedvillageValueErr = false;
				xcAddressDetailsVm.isAuthcheckedErr = false;

				xcAddressDetailsVm.subDistDetails = xpressCreditService.subDistArray;
				xcAddressDetailsVm.villageDetails = xpressCreditService.villageArray;

				xcAddressDetailsVm.stateDetails = xpressCreditService.stateArray;
				xcAddressDetailsVm.districtDetails = xpressCreditService.districtArray;
				xcAddressDetailsVm.cityDetails = xpressCreditService.cityArray;

				xcAddressDetailsVm.districtpermanentDetails = xpressCreditService.districtpermanentArray;
				xcAddressDetailsVm.citypermanentDetails = xpressCreditService.citypermanentArray;

				if (!xpressCreditService.createXcData.permanentAddress) {
					xpressCreditService.customerDemographicDetails().then(function(data) {
						var address1 = data.addressLine1;
						var address2 = data.addressLine2;
						var address3 = data.addressLine3;
						var pincode = data.pinCode;
	                    console.log("customerDemographicDetails",data)
						var obj = {
							"pinCode" : data.pinCode
						}
						xpressCreditService.fetchLocationByPinCode(obj).then(function(data) {
							xcAddressDetailsVm.permanentAddress = address1 + ", " + address2 + ", " + address3 + ","  + " - " + pincode + ".";
							xpressCreditService.createXcData.permanentAddress = xcAddressDetailsVm.permanentAddress;
						},function(error) {
		                    utilityService.showErrorMessage(error.responseMessage);
		                });	

	                },function(error) {
	                    utilityService.showErrorMessage(error.responseMessage);
	                });	
				}
			};

			xcAddressDetailsVm.getCBValue = function (isChecked) {
				console.log("value")
				if (isChecked == true) {
					xcAddressDetailsVm.residentialDiv = false;
					if (xcAddressDetailsVm.cityPermanent && xcAddressDetailsVm.statePermanent
						&&  xcAddressDetailsVm.districtPermanent && xcAddressDetailsVm.isAuthchecked) {
						xcAddressDetailsVm.disabledNext = false;
					} else {
						xcAddressDetailsVm.disabledNext = true;
					}
				} else {
					xcAddressDetailsVm.isCurrentcheck = false;
					xcAddressDetailsVm.residentialDiv = true;
					if (xcAddressDetailsVm.address1 && xcAddressDetailsVm.address2 && xcAddressDetailsVm.address3 
						&& xcAddressDetailsVm.pincode && xcAddressDetailsVm.pincode.length == 6 && xcAddressDetailsVm.city && xcAddressDetailsVm.state
						&&  xcAddressDetailsVm.district && xcAddressDetailsVm.cityPermanent && xcAddressDetailsVm.statePermanent
						&&  xcAddressDetailsVm.districtPermanent && xcAddressDetailsVm.isAuthchecked) {
						xcAddressDetailsVm.disabledNext = false;
					} else {
						xcAddressDetailsVm.disabledNext = true;
					}
				}

				xpressCreditService.createXcData.isCurrentDiffAddr = xcAddressDetailsVm.isCurrentcheck;
			}

			xcAddressDetailsVm.getAuthValue = function (isChecked) {
				if (xcAddressDetailsVm.isCurrentcheck == false || xcAddressDetailsVm.isCurrentcheck == "false") {
					if (xcAddressDetailsVm.address1 && xcAddressDetailsVm.pincode 
						&& xcAddressDetailsVm.pincode.length == 6 && xcAddressDetailsVm.city && xcAddressDetailsVm.state
						&&  xcAddressDetailsVm.district && xcAddressDetailsVm.cityPermanent && xcAddressDetailsVm.statePermanent
						&&  xcAddressDetailsVm.districtPermanent && isChecked) {
						xcAddressDetailsVm.disabledNext = false;
					} else {
						xcAddressDetailsVm.disabledNext = true;
					}
				} else {
					if (xcAddressDetailsVm.cityPermanent && xcAddressDetailsVm.statePermanent
						&&  xcAddressDetailsVm.districtPermanent && xcAddressDetailsVm.isAuthchecked && isChecked) {
						xcAddressDetailsVm.disabledNext = false;
					} else {
						xcAddressDetailsVm.disabledNext = true;
					}
				}
				// if (isChecked == true) {
				// 	xcAddressDetailsVm.disabledNext = false;
				// } else {
				// 	xcAddressDetailsVm.disabledNext = true;
				// }
			}

			xcAddressDetailsVm.validationAll = function () {
				if (xcAddressDetailsVm.address1 && xcAddressDetailsVm.pincode && xcAddressDetailsVm.pincode.length == 6 && xcAddressDetailsVm.city && xcAddressDetailsVm.state
					&&  xcAddressDetailsVm.district && xcAddressDetailsVm.isAuthchecked) {
					xcAddressDetailsVm.disabledNext = false;
				} else {
					xcAddressDetailsVm.disabledNext = true;
				}
			}

			xcAddressDetailsVm.validationField = function (type) {
				if (xcAddressDetailsVm.address1 && xcAddressDetailsVm.pincode && xcAddressDetailsVm.pincode.length == 6 && xcAddressDetailsVm.city && xcAddressDetailsVm.state
					&&  xcAddressDetailsVm.district && xcAddressDetailsVm.isAuthchecked) {
					xcAddressDetailsVm.disabledNext = false;
				} else {
					xcAddressDetailsVm.disabledNext = true;
				}

				if (type == "address1") {
					if (xcAddressDetailsVm.address1) {
						xcAddressDetailsVm.address1Err = false;
					} else {
						xcAddressDetailsVm.address1Err = true;
					}
				}

				// if (type == "address2") {
				// 	if (xcAddressDetailsVm.address2) {
				// 		xcAddressDetailsVm.address2Err = false;
				// 	} else {
				// 		xcAddressDetailsVm.address2Err = true;
				// 	}
				// }

				// if (type == "address3") {
				// 	if (xcAddressDetailsVm.address3) {
				// 		xcAddressDetailsVm.address3Err = false;
				// 	} else {
				// 		xcAddressDetailsVm.address3Err = true;
				// 	}
				// }

				if (type == "pincode") {
					if (xcAddressDetailsVm.pincode && xcAddressDetailsVm.pincode.length == 6) {
						xcAddressDetailsVm.pincodeErr = false;
					} else {
						xcAddressDetailsVm.pincodeErr = true;
					}
				}

				if (type == "statePermanent") {
					if (xcAddressDetailsVm.statePermanent) {
						xcAddressDetailsVm.cityPermanent = "";
						xcAddressDetailsVm.districtPermanent = "";
						var statesObj = JSON.parse(xcAddressDetailsVm.statePermanent);
						var obj = {
							"key" : statesObj.key,
							"action" : "District"
						}
						xpressCreditService.getDistrictSubDistrict(obj).then(function(data) {
							console.log("statesObj",data)
							xcAddressDetailsVm.districtpermanentDetails = data.info;
							xpressCreditService.districtpermanentArray = xcAddressDetailsVm.districtpermanentDetails;
			            },function(error) {
			                console.log("error",error)
			                utilityService.showErrorMessage(error.responseMessage);
			            });

						xcAddressDetailsVm.statePermanentValueErr = false;
					} else {
						xcAddressDetailsVm.statePermanentValueErr = true;
					}
				}

				if (type == "districtPermanent") {
					if (xcAddressDetailsVm.districtPermanent) {
						xcAddressDetailsVm.cityPermanent = "";
						var districtObj = JSON.parse(xcAddressDetailsVm.districtPermanent);
						var obj = {
							"key" : districtObj.key,
							"action" : "SubDistrict"
						}
						xpressCreditService.getDistrictSubDistrict(obj).then(function(data) {
							console.log("districtObj",data)
							xcAddressDetailsVm.citypermanentDetails = data.info;
							xpressCreditService.citypermanentArray = xcAddressDetailsVm.citypermanentDetails;
			            },function(error) {
			                console.log("error",error)
			                utilityService.showErrorMessage(error.responseMessage);
			            });

						xcAddressDetailsVm.districtPermanentValueErr = false;
					} else {
						xcAddressDetailsVm.districtPermanentValueErr = true;
					}
				}

				if (type == "cityPermanent") {
					if (xcAddressDetailsVm.cityPermanent) {
						xcAddressDetailsVm.cityPermanentValueErr = false;
					} else {
						xcAddressDetailsVm.cityPermanentValueErr = true;
					}
				}

				if (type == "state") {
					if (xcAddressDetailsVm.state) {
						xcAddressDetailsVm.city = "";
						xcAddressDetailsVm.district = "";
						var statesObj = JSON.parse(xcAddressDetailsVm.state);
						var obj = {
							"key" : statesObj.key,
							"action" : "District"
						}
						xpressCreditService.getDistrictSubDistrict(obj).then(function(data) {
							console.log("statesObj",data)
							xcAddressDetailsVm.districtDetails = data.info;
							xpressCreditService.districtArray = xcAddressDetailsVm.districtDetails;
			            },function(error) {
			                console.log("error",error)
			                utilityService.showErrorMessage(error.responseMessage);
			            });

						xcAddressDetailsVm.stateErr = false;
					} else {
						xcAddressDetailsVm.stateErr = true;
					}
				}

				if (type == "district") {
					if (xcAddressDetailsVm.district) {
						xcAddressDetailsVm.city = "";
						var districtObj = JSON.parse(xcAddressDetailsVm.district);
						var obj = {
							"key" : districtObj.key,
							"action" : "SubDistrict"
						}
						xpressCreditService.getDistrictSubDistrict(obj).then(function(data) {
							console.log("districtObj",data)
							xcAddressDetailsVm.cityDetails = data.info;
							xpressCreditService.cityArray = xcAddressDetailsVm.cityDetails;
			            },function(error) {
			                console.log("error",error)
			                utilityService.showErrorMessage(error.responseMessage);
			            });

						xcAddressDetailsVm.districtErr = false;
					} else {
						xcAddressDetailsVm.districtErr = true;
					}
				}

				if (type == "city") {
					if (xcAddressDetailsVm.city) {
						xcAddressDetailsVm.cityErr = false;
					} else {
						xcAddressDetailsVm.cityErr = true;
					}
				}
			}

			xcAddressDetailsVm.goToAO = function () {
				xpressCreditService.initialValueStage();
				$state.go('menu.loans');
			}

			xcAddressDetailsVm.goToCancel = function () {
				
				if (xpressCreditService.createXcData.redirectFromPAN == false) {
					if (xpressCreditService.createXcData.redirectFromKyc ==  false) {
						if(xpressCreditService.createXcData.isKycUser == "N"){
							$state.go('menu.xcUpdateaccount');
						}
						else{
							$state.go('menu.xcCheckoff');
						}
						
						//$state.go('menu.xcUpdateaccount');
						
					} else {
						if (xpressCreditService.createXcData.updateAccDocType != "") {
							$state.go('menu.xcUpdateaccount');
						} else {
							$state.go('menu.xcAadhardetails');
						}
					}
				} else {
					if (xpressCreditService.createXcData.redirectFromKyc ==  false) {
						$state.go('menu.xcPanupdate');
					} else {
						if (xpressCreditService.createXcData.updateAccDocType == "" || xpressCreditService.createXcData.updateAccDocType == null) {
							$state.go('menu.xcAadhardetails');
							//$state.go('menu.xcUpdateaccount');
						} else {
							$state.go('menu.xcUpdateaccount');
						}
					}
				}
			}

			xcAddressDetailsVm.getDistrict = function(type){
				if(type == 'statePermanent'){
				if (xcAddressDetailsVm.statePermanent) {
						
						var statesObj = JSON.parse(xcAddressDetailsVm.statePermanent);
						var obj = {
							"key" : statesObj.key,
							"action" : "District"
						}
						xpressCreditService.getDistrictSubDistrict(obj).then(function(data) {
							console.log("statesObj",data)
							xcAddressDetailsVm.districtpermanentDetails = data.info;
							xpressCreditService.districtpermanentArray = xcAddressDetailsVm.districtpermanentDetails;

var districtObj = JSON.parse(xpressCreditService.createXcData.residentPermanentAddress.districtText);
							var selected_district_key = districtObj.key;
							var selected_district = '';
							

							var isKeyExists = -1;
							xcAddressDetailsVm.districtpermanentDetails.some(function(obj, i) {
  return obj.key == selected_district_key ? isKeyExists = i : false;
});
							console.log(isKeyExists);
							if(isKeyExists !== -1)
							{
								
								xcAddressDetailsVm.districtpermanentDetails.splice(isKeyExists, 1);
							}
							xcAddressDetailsVm.districtpermanentDetails.push(districtObj);

			            },function(error) {
			                console.log("error",error)
			                utilityService.showErrorMessage(error.responseMessage);
			            });

						xcAddressDetailsVm.statePermanentValueErr = false;
					} else {
						xcAddressDetailsVm.statePermanentValueErr = true;
					}
					}

else{

	if (xcAddressDetailsVm.state) {
						var statesObj = JSON.parse(xcAddressDetailsVm.state);
						var obj = {
							"key" : statesObj.key,
							"action" : "District"
						}
						xpressCreditService.getDistrictSubDistrict(obj).then(function(data) {
							console.log("statesObj",data)
							xcAddressDetailsVm.districtDetails = data.info;
							xpressCreditService.districtArray = xcAddressDetailsVm.districtDetails;

							var districtObj = JSON.parse(xpressCreditService.createXcData.residentAddress.districtText);
							var selected_district_key = districtObj.key;
							var selected_district = '';
							

							var isKeyExists = -1;
							xcAddressDetailsVm.districtDetails.some(function(obj, i) {
  return obj.key == selected_district_key ? isKeyExists = i : false;
});
							console.log(isKeyExists);
							if(isKeyExists !== -1)
							{
								
								xcAddressDetailsVm.districtDetails.splice(isKeyExists, 1);
							}
							xcAddressDetailsVm.districtDetails.push(districtObj);

			            },function(error) {
			                console.log("error",error)
			                utilityService.showErrorMessage(error.responseMessage);
			            });

						xcAddressDetailsVm.stateErr = false;
					} else {
						xcAddressDetailsVm.stateErr = true;
					}


}

				
			}

			xcAddressDetailsVm.getCity = function(type){
				if (type == "districtPermanent") {
					if (xcAddressDetailsVm.districtPermanent) {
						
						var districtObj = JSON.parse(xcAddressDetailsVm.districtPermanent);
						var obj = {
							"key" : districtObj.key,
							"action" : "SubDistrict"
						}
						xpressCreditService.getDistrictSubDistrict(obj).then(function(data) {
							console.log("districtObj",data)
							xcAddressDetailsVm.citypermanentDetails = data.info;
							xpressCreditService.citypermanentArray = xcAddressDetailsVm.citypermanentDetails;

							var districtObj = JSON.parse(xpressCreditService.createXcData.residentPermanentAddress.cityText);
							var selected_district_key = districtObj.key;
							var selected_district = '';
							

							var isKeyExists = -1;
							xcAddressDetailsVm.citypermanentDetails.some(function(obj, i) {
  return obj.key == selected_district_key ? isKeyExists = i : false;
});
							console.log(isKeyExists);
							if(isKeyExists !== -1)
							{
								
								xcAddressDetailsVm.citypermanentDetails.splice(isKeyExists, 1);
							}
							xcAddressDetailsVm.citypermanentDetails.push(districtObj);

			            },function(error) {
			                console.log("error",error)
			                utilityService.showErrorMessage(error.responseMessage);
			            });

						xcAddressDetailsVm.districtPermanentValueErr = false;
					} else {
						xcAddressDetailsVm.districtPermanentValueErr = true;
					}
				}
				else{
					if (xcAddressDetailsVm.district) {
						
						var districtObj = JSON.parse(xcAddressDetailsVm.district);
						var obj = {
							"key" : districtObj.key,
							"action" : "SubDistrict"
						}
						xpressCreditService.getDistrictSubDistrict(obj).then(function(data) {
							console.log("districtObj",data)
							xcAddressDetailsVm.cityDetails = data.info;
							xpressCreditService.cityArray = xcAddressDetailsVm.cityDetails;

							var districtObj = JSON.parse(xpressCreditService.createXcData.residentAddress.cityText);
							var selected_district_key = districtObj.key;
							var selected_district = '';
							

							var isKeyExists = -1;
							xcAddressDetailsVm.cityDetails.some(function(obj, i) {
  return obj.key == selected_district_key ? isKeyExists = i : false;
});
							console.log(isKeyExists);
							if(isKeyExists !== -1)
							{
								
								xcAddressDetailsVm.cityDetails.splice(isKeyExists, 1);
							}
							xcAddressDetailsVm.cityDetails.push(districtObj);
			            },function(error) {
			                console.log("error",error)
			                utilityService.showErrorMessage(error.responseMessage);
			            });

						xcAddressDetailsVm.districtErr = false;
					} else {
						xcAddressDetailsVm.districtErr = true;
					}
				}
			}

			xcAddressDetailsVm.goToConfirm = function () {
				var statesData = "";
				var	statesId = "";
				var	statesText = "";

				var districtData = "";
				var	districtId = "";
				var	districtText = "";

				var cityData = "";
				var	cityId = "";
				var	cityText = "";

				var statesPermanentData = "";
				var	statesPermanentId = "";
				var	statesPermanentText = "";

				var districtPermanentData = "";
				var	districtPermanentId = "";
				var	districtPermanentText = "";

				var cityPermanentData = "";
				var	cityPermanentId = "";
				var	cityPermanentText = "";

				xpressCreditService.createXcData.residentAddress.addressLine1 = xcAddressDetailsVm.address1;
				xpressCreditService.createXcData.residentAddress.addressLine2 = xcAddressDetailsVm.address2;
				xpressCreditService.createXcData.residentAddress.addressLine3 = xcAddressDetailsVm.address3;
				xpressCreditService.createXcData.residentAddress.pincode = xcAddressDetailsVm.pincode;
				// xpressCreditService.createXcData.residentAddress.cityText = xcAddressDetailsVm.city;
				// xpressCreditService.createXcData.residentAddress.stateText = xcAddressDetailsVm.state;
				// xpressCreditService.createXcData.residentAddress.districtText = xcAddressDetailsVm.district;

				xpressCreditService.createXcData.isCurrentDiffAddr = xcAddressDetailsVm.isCurrentcheck;	
				xpressCreditService.createXcData.isCibil = xcAddressDetailsVm.isAuthchecked;	

				if (xcAddressDetailsVm.isCurrentcheck == false) {
					if (xcAddressDetailsVm.state) {
						xpressCreditService.createXcData.residentAddress.stateText = xcAddressDetailsVm.state;
						statesData = JSON.parse(xcAddressDetailsVm.state);
						statesId = statesData.key;
						statesText = statesData.value;
					}

					if (xcAddressDetailsVm.district) {
						xpressCreditService.createXcData.residentAddress.districtText = xcAddressDetailsVm.district;
						districtData = JSON.parse(xcAddressDetailsVm.district);
						districtId = districtData.key;
						districtText = districtData.value;
					}

					if (xcAddressDetailsVm.city) {
						xpressCreditService.createXcData.residentAddress.cityText = xcAddressDetailsVm.city;
						cityData = JSON.parse(xcAddressDetailsVm.city);
						cityId = cityData.key;
						cityText = cityData.value;
					}
				}


				if (xcAddressDetailsVm.statePermanent) {
					xpressCreditService.createXcData.residentPermanentAddress.stateText = xcAddressDetailsVm.statePermanent;
					statesPermanentData = JSON.parse(xcAddressDetailsVm.statePermanent);
					statesPermanentId = statesPermanentData.key;
					statesPermanentText = statesPermanentData.value;
				}

				if (xcAddressDetailsVm.districtPermanent) {
					xpressCreditService.createXcData.residentPermanentAddress.districtText = xcAddressDetailsVm.districtPermanent;
					districtPermanentData = JSON.parse(xcAddressDetailsVm.districtPermanent);
					districtPermanentId = districtPermanentData.key;
					districtPermanentText = districtPermanentData.value;
				}

				if (xcAddressDetailsVm.cityPermanent) {
					xpressCreditService.createXcData.residentPermanentAddress.cityText = xcAddressDetailsVm.cityPermanent;
					cityPermanentData = JSON.parse(xcAddressDetailsVm.cityPermanent);
					cityPermanentId = cityPermanentData.key;
					cityPermanentText = cityPermanentData.value;
				}

				var obj = {
					"pageName": "residentialDetails",
					"progress": "20%",
					"yonoRefNo": "",
					"address": [
						{
							"addressType": "PERMNENT",
							"addressLine1": "",
							"addressLine2": "",
							"addressLine3": "",
							"pincode": "",
							"cityText": xcAddressDetailsVm.cityPermanent,
							"cityCode": cityPermanentId,
							"stateText": xcAddressDetailsVm.statePermanent,
							"stateCode": statesPermanentId,
							"districtText": xcAddressDetailsVm.districtPermanent,
							"districtCode": districtPermanentId
						},{
							"addressType": "CURRES",
							"addressLine1": xcAddressDetailsVm.address1,
							"addressLine2": xcAddressDetailsVm.address2,
							"addressLine3": xcAddressDetailsVm.address3,
							"pincode": xcAddressDetailsVm.pincode,
							"cityText": xcAddressDetailsVm.city,
							"cityCode": cityId,
							"stateText": xcAddressDetailsVm.state,
							"stateCode": statesId,
							"districtText": xcAddressDetailsVm.district,
							"districtCode": districtId
						}
					],
					"currentAddres" : String(xcAddressDetailsVm.isCurrentcheck),
					"cibil" : String(xcAddressDetailsVm.isAuthchecked)
				}
				xpressCreditService.OmniCallResponse(obj).then(function(data) {
                    console.log("OmniCallResponse",obj,data)
					$state.go('menu.xcAdditionalDetails');
                },function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });			
				
			}

			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				if (xpressCreditService.createXcData.isCurrentDiffAddr == "false" || xpressCreditService.createXcData.isCurrentDiffAddr == false) {
					xcAddressDetailsVm.residentialDiv = true;
					xcAddressDetailsVm.isCurrentcheck = false;
				} else {
					xcAddressDetailsVm.residentialDiv = false;
					xcAddressDetailsVm.isCurrentcheck = true;
				}

				xcAddressDetailsVm.address1 = xpressCreditService.createXcData.residentAddress.addressLine1;
				xcAddressDetailsVm.address2 = xpressCreditService.createXcData.residentAddress.addressLine2;
				xcAddressDetailsVm.address3 = xpressCreditService.createXcData.residentAddress.addressLine3;
				xcAddressDetailsVm.pincode = xpressCreditService.createXcData.residentAddress.pincode;

				xcAddressDetailsVm.permanentAddress = xpressCreditService.createXcData.permanentAddress;

				if (xpressCreditService.createXcData.residentAddress.stateText) {
					if (xpressCreditService.statusXc == 2) {
						var statesObj = JSON.parse(xpressCreditService.createXcData.residentAddress.stateText);

						// if (xcAddressDetailsVm.stateDetails.length == 0) {
							xcAddressDetailsVm.stateDetails.push(statesObj)
						// }
					}
				 	xcAddressDetailsVm.state = xpressCreditService.createXcData.residentAddress.stateText;
				 	if (xpressCreditService.statusXc == 2) {
				 	xcAddressDetailsVm.getDistrict('state');
				 }
				}

				if (xpressCreditService.createXcData.residentAddress.districtText) {
					// if (xpressCreditService.statusXc == 2) {
					// 	var districtObj = JSON.parse(xpressCreditService.createXcData.residentAddress.districtText);

					// 	if (xcAddressDetailsVm.districtDetails.length == 0) {
					// 		xcAddressDetailsVm.districtDetails.push(districtObj)
					// 	}
					// }
				 	xcAddressDetailsVm.district = xpressCreditService.createXcData.residentAddress.districtText;
				 	if (xpressCreditService.statusXc == 2) {
				 	xcAddressDetailsVm.getCity('district');
				 }
				}

				if (xpressCreditService.createXcData.residentAddress.cityText) {
					// if (xpressCreditService.statusXc == 2) {
					// 	var cityObj = JSON.parse(xpressCreditService.createXcData.residentAddress.cityText);

					// 	if (xcAddressDetailsVm.cityDetails.length == 0) {
					// 		xcAddressDetailsVm.cityDetails.push(cityObj)
					// 	}
					// }
				 	xcAddressDetailsVm.city = xpressCreditService.createXcData.residentAddress.cityText;
				}

				if (xpressCreditService.createXcData.residentPermanentAddress.stateText) {
					if (xpressCreditService.statusXc == 2) {
						var statesObj = JSON.parse(xpressCreditService.createXcData.residentPermanentAddress.stateText);

						// if (xcAddressDetailsVm.stateDetails.length == 0) {
						// 	xcAddressDetailsVm.stateDetails.push(statesObj)
						// } else {
							xcAddressDetailsVm.stateDetails.push(statesObj)
						// }
					}
				 	xcAddressDetailsVm.statePermanent = xpressCreditService.createXcData.residentPermanentAddress.stateText;
				 	if (xpressCreditService.statusXc == 2) {
				 	xcAddressDetailsVm.getDistrict('statePermanent');
				 }
				}

				if (xpressCreditService.createXcData.residentPermanentAddress.districtText) {
					// if (xpressCreditService.statusXc == 2) {
					// 	var districtpermanentObj = JSON.parse(xpressCreditService.createXcData.residentPermanentAddress.districtText);

					// 	if (xcAddressDetailsVm.districtpermanentDetails.length == 0) {
					// 		xcAddressDetailsVm.districtpermanentDetails.push(districtpermanentObj)
					// 	}
					// }
				 	xcAddressDetailsVm.districtPermanent = xpressCreditService.createXcData.residentPermanentAddress.districtText;
				 	if (xpressCreditService.statusXc == 2) {
				 	xcAddressDetailsVm.getCity('districtPermanent');
				 }
				}

				if (xpressCreditService.createXcData.residentPermanentAddress.cityText) {
					// if (xpressCreditService.statusXc == 2) {
					// 	var citypermanentObj = JSON.parse(xpressCreditService.createXcData.residentPermanentAddress.cityText);

					// 	if (xcAddressDetailsVm.citypermanentDetails.length == 0) {
					// 		xcAddressDetailsVm.citypermanentDetails.push(citypermanentObj)
					// 	}
					// }
				 	xcAddressDetailsVm.cityPermanent = xpressCreditService.createXcData.residentPermanentAddress.cityText;
				}

				xcAddressDetailsVm.validationAll();
			});

			return this;
		}
]);


