'use strict';
angularApp.controller('xcAppStatusController', [
    "$state",
    "$scope",
    "$ionicPopup",
    "$translate",
    "$ionicHistory",
    "utilityService",
    "ionicDatePicker",
    "$ionicSideMenuDelegate",
    "$ionicScrollDelegate",
    "loanConfig",
    "homeLoanService", "xpressCreditService","$interval",
    function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, $ionicScrollDelegate, loanConfig, homeLoanService, xpressCreditService,$interval) {

        var xcAppStatusVm = this;

        function initPage() {
            xcAppStatusVm.showProgress = true;
            xcAppStatusVm.showTimer();
        }

        xcAppStatusVm.triggerBureau = function(group) {
            var obj = {
                "pageName": "declarationOnAssets",
                "progress": "50%",
                "yonoRefNo": "",
                "assetDeclarations": xpressCreditService.createXcData.assests,
                "assetDecTotalAmount": xpressCreditService.createXcData.totalOfAllAssets
            }
            xpressCreditService.afterBeauroScoreValidation(obj).then(function(data) {
                if (data.cirResultflag == 'Y') {
                    $state.go('menu.xcLiable');
                } else if (data.cirResultflag == "E") {
                    xcAppStatusVm.showEStatus();
                } else if (data.cirResultflag == "P") {
                    utilityService.showErrorMessage("Application check still in progress.");
                } else if (data.cirResultflag == "N") {
                    utilityService.showErrorMessage("Can not process now, User not eligible for Loan.");
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

        }

        xcAppStatusVm.showEStatus = function(){
            var backPopup = $ionicPopup.show({
                title: null,
                cssClass: 'my-custom-popup',
                template: '<div class="button_fund font-size-14 roboto-medium color-darkgrey" translate="HL_E_STATUS"></div>',
                buttons: [
                {
                    text: 'OK',
                    type: 'button-assertive',
                    onTap: function () {
                        //service call for reject
                        backPopup.close();
                        $state.go('menu.xcWorkDetails');
                    }
                }],
            });
        }


        xcAppStatusVm.goBack = function() {
            $ionicHistory.goBack(-2);
        }

        xcAppStatusVm.goToAO = function(){
           $state.go('menu.loans');
        }


        xcAppStatusVm.showTimer = function(){
            var timeLeft = 30;
            //utilityService.showSpinner();
            xcAppStatusVm.showTimeRemaining = true;
            //var timerId = setInterval(countdown, 1000);
            $interval(function(){
                if (timeLeft == 0) {
                    //clearTimeout(timerId);
                    //doSomething();
                    //xcAppStatusVm.showProgress = false;
                    xcAppStatusVm.showTimeRemaining = false;
                    //utilityService.hideSpinner();
                } else {
                    xcAppStatusVm.timeRemaining = timeLeft + ' seconds remaining';
                    timeLeft--;
                }
            },1000)
            
        }

        $scope.$on('$ionicView.loaded', function() {

        });

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });



        return this;
    }


]);