'use strict';
angularApp.controller('xcAssetsController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"xpressCreditService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, xpressCreditService) {
			
			var xcAssetsVm = this;
			
			function initPage() {
				xcAssetsVm.disabledNext = false;
				xcAssetsVm.isExpand = false;
				xcAssetsVm.isExpandMovable = false;
				xcAssetsVm.isExpandLiquid = false;

				xcAssetsVm.amountValueDisabledHouse = true;
				xcAssetsVm.amountValueDisabledFlat = true;
				xcAssetsVm.amountValueDisabledShop = true;
				xcAssetsVm.amountValueDisabledPlot = true;
				xcAssetsVm.amountValueDisabledOthersIm = true;
				xcAssetsVm.amountValueDisabledTwoWheeler = true;
				xcAssetsVm.amountValueDisabledFourWheeler = true;
				xcAssetsVm.amountValueDisabledDeposits = true;
				xcAssetsVm.amountValueDisabledInvestments = true;
				xcAssetsVm.amountValueDisabledOthers = true;

				xcAssetsVm.isMortgagedHouse = false;
				xcAssetsVm.isMortgagedFlat = false;
				xcAssetsVm.isMortgagedShop = false;
				xcAssetsVm.isMortgagedPlot = false;
				xcAssetsVm.isMortgagedOtherim = false;
				xcAssetsVm.isHypothecatedFourwhe = false;
				xcAssetsVm.isHypothecatedTwowhe = false;

				xcAssetsVm.totalOfAllAssets = 0;
			};

			xcAssetsVm.geCheckedStatus = function (value,type) {
				if (type == "house") {
					if (value == true) {
						xcAssetsVm.amountValueDisabledHouse = false;
						if (xcAssetsVm.amountValueHouse && xcAssetsVm.address1house && xcAssetsVm.address2house && xcAssetsVm.pincodehouse && xcAssetsVm.pincodehouse.length == 6) {
							xcAssetsVm.disabledNext = false;
						} else {
							xcAssetsVm.disabledNext = true;
						}
					} else {
						xcAssetsVm.amountValueHouse = "";

						xcAssetsVm.amountValueDisabledHouse = true;
						xcAssetsVm.address1house = "";
						xcAssetsVm.address2house = "";
						xcAssetsVm.pincodehouse = "";
						xcAssetsVm.isMortgagedHouse = false;

						xcAssetsVm.disabledNext = false;
					}				
				} else if (type == "flat") {
					if (value == true) {
						xcAssetsVm.amountValueDisabledFlat = false;
						if (xcAssetsVm.amountValueFlat && xcAssetsVm.address1flat && xcAssetsVm.address2flat && xcAssetsVm.pincodeflat && xcAssetsVm.pincodeflat.length == 6) {
							xcAssetsVm.disabledNext = false;
						} else {
							xcAssetsVm.disabledNext = true;
						}
					} else {
						xcAssetsVm.amountValueFlat = "";
						xcAssetsVm.isMortgagedFlat = false;
						xcAssetsVm.address1flat = "";
						xcAssetsVm.address2flat = "";
						xcAssetsVm.pincodeflat = "";
						xcAssetsVm.amountValueDisabledFlat = true;

						xcAssetsVm.disabledNext = false;
					}
				} else if (type == "shop") {
					if (value == true) {
						xcAssetsVm.amountValueDisabledShop = false;
						if (xcAssetsVm.amountValueShop && xcAssetsVm.address1shop && xcAssetsVm.address2shop && xcAssetsVm.pincodeshop && xcAssetsVm.pincodeshop.length == 6) {
							xcAssetsVm.disabledNext = false;
						} else {
							xcAssetsVm.disabledNext = true;
						}
					} else {
						xcAssetsVm.amountValueShop = "";
						xcAssetsVm.isMortgagedShop = false;
						xcAssetsVm.address1shop = "";
						xcAssetsVm.address2shop = "";
						xcAssetsVm.pincodeshop = "";
						xcAssetsVm.amountValueDisabledShop = true;

						xcAssetsVm.disabledNext = false;
					}
				} else if (type == "plot") {
					if (value == true) {
						xcAssetsVm.amountValueDisabledPlot = false;
						if (xcAssetsVm.amountValuePlot && xcAssetsVm.address1plot && xcAssetsVm.address2plot && xcAssetsVm.pincodeplot && xcAssetsVm.pincodeplot.length == 6) {
							xcAssetsVm.disabledNext = false;
						} else {
							xcAssetsVm.disabledNext = true;
						}
					} else {
						xcAssetsVm.amountValuePlot = ""; 
						xcAssetsVm.isMortgagedPlot = false;
						xcAssetsVm.address1plot = "";
						xcAssetsVm.address2plot = "";
						xcAssetsVm.pincodeplot = "";
						xcAssetsVm.amountValueDisabledPlot = true;

						xcAssetsVm.disabledNext = false;
					}
				} else if (type == "otherim") {
					if (value == true) {
						xcAssetsVm.amountValueDisabledOthersIm = false;
						if (xcAssetsVm.amountValueOthersIm && xcAssetsVm.address1otherim && xcAssetsVm.address2otherim && xcAssetsVm.pincodeotherim && xcAssetsVm.pincodeotherim.length == 6) {
							xcAssetsVm.disabledNext = false;
						} else {
							xcAssetsVm.disabledNext = true;
						}
					} else {
						xcAssetsVm.amountValueDisabledOthersIm = true;
						xcAssetsVm.isMortgagedOtherim = false;
						xcAssetsVm.address1otherim = "";
						xcAssetsVm.address2otherim = "";
						xcAssetsVm.pincodeotherim = "";
						xcAssetsVm.amountValueOthersIm = "";

						xcAssetsVm.disabledNext = false;
					}
				} else if (type == "twowheeler") {
					if (value == true) {
						xcAssetsVm.amountValueDisabledTwoWheeler = false;
						if (xcAssetsVm.amountValueTwoWheeler && xcAssetsVm.reginumberTwoWheeler) {
							xcAssetsVm.disabledNext = false;
						} else {
							xcAssetsVm.disabledNext = true;
						}
					} else {
						xcAssetsVm.amountValueDisabledTwoWheeler = true;
						xcAssetsVm.amountValueTwoWheeler = "";
						xcAssetsVm.isHypothecatedTwowhe = false;
						xcAssetsVm.reginumberTwoWheeler = "";

						xcAssetsVm.disabledNext = false;
					}
				} else if (type == "fourwheeler") {
					if (value == true) {
						xcAssetsVm.amountValueDisabledFourWheeler = false;
						if (xcAssetsVm.amountValueFourWheeler && xcAssetsVm.reginumberFourWheeler) {
							xcAssetsVm.disabledNext = false;
						} else {
							xcAssetsVm.disabledNext = true;
						}
					} else {
						xcAssetsVm.amountValueDisabledFourWheeler = true;
						xcAssetsVm.amountValueFourWheeler = "";
						xcAssetsVm.isHypothecatedFourwhe = false;
						xcAssetsVm.reginumberFourWheeler = "";

						xcAssetsVm.disabledNext = false;
					}
				} else if (type == "deposits") {
					if (value == true) {
						xcAssetsVm.amountValueDisabledDeposits = false;
						if (xcAssetsVm.amountValueDeposits) {
							xcAssetsVm.disabledNext = false;
						} else {
							xcAssetsVm.disabledNext = true;
						}
					} else {
						xcAssetsVm.amountValueDisabledDeposits = true;
						xcAssetsVm.amountValueDeposits = "";

						xcAssetsVm.disabledNext = false;
					}
				} else if (type == "investments") {
					if (value == true) {
						xcAssetsVm.amountValueDisabledInvestments = false;
						if (xcAssetsVm.amountValueInvestments) {
							xcAssetsVm.disabledNext = false;
						} else {
							xcAssetsVm.disabledNext = true;
						}
					} else {
						xcAssetsVm.amountValueDisabledInvestments = true;
						xcAssetsVm.amountValueInvestments = "";

						xcAssetsVm.disabledNext = false;
					}
				} else if (type == "others") {
					if (value == true) {
						xcAssetsVm.amountValueDisabledOthers = false;
						if (xcAssetsVm.amountValueOthers) {
							xcAssetsVm.disabledNext = false;
						} else {
							xcAssetsVm.disabledNext = true;
						}
					} else {
						xcAssetsVm.amountValueDisabledOthers = true;
						xcAssetsVm.amountValueOthers = "";

						xcAssetsVm.disabledNext = false;
					}
				}

				xcAssetsVm.validationFields();
			}

			xcAssetsVm.validationFields = function () {

				var a = Number(xcAssetsVm.amountValueHouse || 0);
				var b = Number(xcAssetsVm.amountValueFlat || 0);
				var c = Number(xcAssetsVm.amountValueShop || 0);
				var d = Number(xcAssetsVm.amountValuePlot || 0);
				var e = Number(xcAssetsVm.amountValueOthersIm || 0);
				var f = Number(xcAssetsVm.amountValueFourWheeler || 0);
				var g = Number(xcAssetsVm.amountValueTwoWheeler || 0);
				var h = Number(xcAssetsVm.amountValueDeposits || 0);
				var i = Number(xcAssetsVm.amountValueInvestments || 0);
				var j = Number(xcAssetsVm.amountValueOthers || 0);
				
				xcAssetsVm.totalOfAllAssets = a + b + c + d + e + f + g + h + i + j;
				
				if (xcAssetsVm.isCheckedHouse) {
					if (xcAssetsVm.amountValueHouse && xcAssetsVm.address1house && xcAssetsVm.address2house && xcAssetsVm.pincodehouse && xcAssetsVm.pincodehouse.length == 6) {
						xcAssetsVm.disabledNext = false;
					} else {
						xcAssetsVm.disabledNext = true;
						return;
					}
				}

				if (xcAssetsVm.isCheckedFlat) {
					if (xcAssetsVm.amountValueFlat && xcAssetsVm.address1flat && xcAssetsVm.address2flat && xcAssetsVm.pincodeflat && xcAssetsVm.pincodeflat.length == 6) {
						xcAssetsVm.disabledNext = false;
					} else {
						xcAssetsVm.disabledNext = true;
						return;
					}
				}

				if (xcAssetsVm.isCheckedShop) {
					if (xcAssetsVm.amountValueShop && xcAssetsVm.address1shop && xcAssetsVm.address2shop && xcAssetsVm.pincodeshop && xcAssetsVm.pincodeshop.length == 6) {
						xcAssetsVm.disabledNext = false;
					} else {
						xcAssetsVm.disabledNext = true;
						return;
					}
				}

				if (xcAssetsVm.isCheckedPlot) {
					if (xcAssetsVm.amountValuePlot && xcAssetsVm.address1plot && xcAssetsVm.address2plot && xcAssetsVm.pincodeplot && xcAssetsVm.pincodeplot.length == 6) {
						xcAssetsVm.disabledNext = false;
					} else {
						xcAssetsVm.disabledNext = true;
						return;
					}
				}

				if (xcAssetsVm.isCheckedOthersIm) {
					if (xcAssetsVm.amountValueOthersIm && xcAssetsVm.address1otherim && xcAssetsVm.address2otherim && xcAssetsVm.pincodeotherim && xcAssetsVm.pincodeotherim.length == 6) {
						xcAssetsVm.disabledNext = false;
					} else {
						xcAssetsVm.disabledNext = true;
						return;
					}
				}

				if (xcAssetsVm.isCheckedFourWheeler) {
					if (xcAssetsVm.amountValueFourWheeler && xcAssetsVm.reginumberFourWheeler) {
						xcAssetsVm.disabledNext = false;
					} else {
						xcAssetsVm.disabledNext = true;
						return;
					}
				}

				if (xcAssetsVm.isCheckedTwoWheeler) {
					if (xcAssetsVm.amountValueTwoWheeler && xcAssetsVm.reginumberTwoWheeler) {
						xcAssetsVm.disabledNext = false;
					} else {
						xcAssetsVm.disabledNext = true;
						return;
					}
				}

				if (xcAssetsVm.isCheckedDeposits) {
					if (xcAssetsVm.amountValueDeposits) {
						xcAssetsVm.disabledNext = false;
					} else {
						xcAssetsVm.disabledNext = true;
						return;
					}
				}

				if (xcAssetsVm.isCheckedInvestments) {
					if (xcAssetsVm.amountValueInvestments) {
						xcAssetsVm.disabledNext = false;
					} else {
						xcAssetsVm.disabledNext = true;
						return;
					}
				}

				if (xcAssetsVm.isCheckedOthers) {
					if (xcAssetsVm.amountValueOthers) {
						xcAssetsVm.disabledNext = false;
					} else {
						xcAssetsVm.disabledNext = true;
						return;
					}
				}
			}

			xcAssetsVm.goToAO = function () {
				xpressCreditService.initialValueStage();
				$state.go('menu.loans');
			}

			xcAssetsVm.goToCancel = function () {
				$state.go('menu.xcWorkDetails');
			}

			xcAssetsVm.goToConfirm = function () {

				// if (xcAssetsVm.amountValueHouse) {
					xpressCreditService.createXcData.assests[0].presentMarketValue = xcAssetsVm.amountValueHouse; 
				// }
				xpressCreditService.createXcData.assests[0].addressLine1 = xcAssetsVm.address1house; 
				xpressCreditService.createXcData.assests[0].addressLine2 = xcAssetsVm.address2house; 
				xpressCreditService.createXcData.assests[0].pincode = xcAssetsVm.pincodehouse; 

				// if (xcAssetsVm.amountValueFlat) {
					xpressCreditService.createXcData.assests[1].presentMarketValue = xcAssetsVm.amountValueFlat; 
				// }
				xpressCreditService.createXcData.assests[1].addressLine1 = xcAssetsVm.address1flat; 
				xpressCreditService.createXcData.assests[1].addressLine2 = xcAssetsVm.address2flat; 
				xpressCreditService.createXcData.assests[1].pincode = xcAssetsVm.pincodeflat; 

				// if (xcAssetsVm.amountValueShop) {
					xpressCreditService.createXcData.assests[2].presentMarketValue = xcAssetsVm.amountValueShop; 
				// }
				xpressCreditService.createXcData.assests[2].addressLine1 = xcAssetsVm.address1shop; 
				xpressCreditService.createXcData.assests[2].addressLine2 = xcAssetsVm.address2shop; 
				xpressCreditService.createXcData.assests[2].pincode = xcAssetsVm.pincodeshop; 

				// if (xcAssetsVm.amountValuePlot) {
					xpressCreditService.createXcData.assests[3].presentMarketValue = xcAssetsVm.amountValuePlot; 
				// }
				xpressCreditService.createXcData.assests[3].addressLine1 = xcAssetsVm.address1plot; 
				xpressCreditService.createXcData.assests[3].addressLine2 = xcAssetsVm.address2plot; 
				xpressCreditService.createXcData.assests[3].pincode = xcAssetsVm.pincodeplot; 

				// if (xcAssetsVm.amountValueOthersIm) {
					xpressCreditService.createXcData.assests[4].presentMarketValue = xcAssetsVm.amountValueOthersIm; 
				// }
				xpressCreditService.createXcData.assests[4].addressLine1 = xcAssetsVm.address1otherim; 
				xpressCreditService.createXcData.assests[4].addressLine2 = xcAssetsVm.address2otherim; 
				xpressCreditService.createXcData.assests[4].pincode = xcAssetsVm.pincodeotherim; 

				// if (xcAssetsVm.amountValueFourWheeler) {
					xpressCreditService.createXcData.assests[5].presentMarketValue = xcAssetsVm.amountValueFourWheeler;
				// }
				xpressCreditService.createXcData.assests[5].registrationNo = xcAssetsVm.reginumberFourWheeler;

				// if (xcAssetsVm.amountValueTwoWheeler) {
					xpressCreditService.createXcData.assests[6].presentMarketValue = xcAssetsVm.amountValueTwoWheeler; 
				// }
				xpressCreditService.createXcData.assests[6].registrationNo = xcAssetsVm.reginumberTwoWheeler; 

				// if (xcAssetsVm.amountValueDeposits) {
					xpressCreditService.createXcData.assests[7].presentMarketValue = xcAssetsVm.amountValueDeposits; 
				// }

				// if (xcAssetsVm.amountValueInvestments) {
					xpressCreditService.createXcData.assests[8].presentMarketValue = xcAssetsVm.amountValueInvestments;
				// }

				// if (xcAssetsVm.amountValueOthers) {
					xpressCreditService.createXcData.assests[9].presentMarketValue = xcAssetsVm.amountValueOthers; 
				// }

				xpressCreditService.createXcData.assests[0].mortgagedFlag = String(xcAssetsVm.isMortgagedHouse);
				xpressCreditService.createXcData.assests[1].mortgagedFlag = String(xcAssetsVm.isMortgagedFlat);
				xpressCreditService.createXcData.assests[2].mortgagedFlag = String(xcAssetsVm.isMortgagedShop);
				xpressCreditService.createXcData.assests[3].mortgagedFlag = String(xcAssetsVm.isMortgagedPlot);
				xpressCreditService.createXcData.assests[4].mortgagedFlag = String(xcAssetsVm.isMortgagedOtherim);
				xpressCreditService.createXcData.assests[5].hypothicatedFlag = String(xcAssetsVm.isHypothecatedFourwhe);
				xpressCreditService.createXcData.assests[6].hypothicatedFlag = String(xcAssetsVm.isHypothecatedTwowhe);

				xpressCreditService.createXcData.totalOfAllAssets = xcAssetsVm.totalOfAllAssets;

				var obj = {
					"pageName": "declarationOnAssets",
					"progress": "50%",
					"yonoRefNo": "",
					"assetDeclarations": xpressCreditService.createXcData.assests,
				  	"assetDecTotalAmount": xcAssetsVm.totalOfAllAssets
				}

				xpressCreditService.afterBeauroScoreValidation(obj).then(function(data) {
                    console.log("afterBeauroScoreValidation",obj,data)
                    xpressCreditService.createXcData.eligibilityEmiFlag = data.cirResultflag;
                    if (data.cirResultflag == 'Y') {
	                   $state.go('menu.xcLiable');
	                } else if (data.cirResultflag == "E") {
	                   xcAssetsVm.showEStatus();
	                } else if (data.cirResultflag == "P") {
	                    $state.go('menu.xcAppStatus');
	                } else if (data.cirResultflag == "N") {
	                    utilityService.showErrorMessage("Can not process now, User not eligible for Loan.");
	                }
					
                },function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });		
			}

			xcAssetsVm.showEStatus = function(){
	            var backPopup = $ionicPopup.show({
	                title: null,
	                cssClass: 'my-custom-popup',
	                template: '<div class="button_fund font-size-14 roboto-medium color-darkgrey" translate="HL_E_STATUS"></div>',
	                buttons: [
	                {
	                    text: 'OK',
	                    type: 'button-assertive',
	                    onTap: function () {
	                        //service call for reject
	                        backPopup.close();
	                        $state.go('menu.xcWorkDetails');
	                    }
	                }],
	            });
	        }

			xcAssetsVm.hideShow = function() {
		      	if(xcAssetsVm.isExpand == false) {
		      		xcAssetsVm.isExpand = true;
		      	} else {
		      		xcAssetsVm.isExpand = false;
		      	}

		    }

		    xcAssetsVm.hideShowMovable = function() {
		      	if(xcAssetsVm.isExpandMovable == false) {
		      		xcAssetsVm.isExpandMovable = true;
		      	} else {
		      		xcAssetsVm.isExpandMovable = false;
		      	}

		    }

		    xcAssetsVm.hideShowLiquid = function() {
		      	if(xcAssetsVm.isExpandLiquid == false) {
		      		xcAssetsVm.isExpandLiquid = true;
		      	} else {
		      		xcAssetsVm.isExpandLiquid = false;
		      	}

		    }

			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				console.log(xpressCreditService.createXcData.assests)

				if (xpressCreditService.createXcData.totalOfAllAssets) {
					xcAssetsVm.totalOfAllAssets = xpressCreditService.createXcData.totalOfAllAssets;
				}

				if (xpressCreditService.createXcData.assests != null) {

					for (var i=0;i<xpressCreditService.createXcData.assests.length;i++) {
						if (xpressCreditService.createXcData.assests[i].assetCategory == "MA") {
							if(xpressCreditService.createXcData.assests[i].assetType == "TWOWL") {
								xcAssetsVm.amountValueTwoWheeler = xpressCreditService.createXcData.assests[i].presentMarketValue; 
								xcAssetsVm.reginumberTwoWheeler = xpressCreditService.createXcData.assests[i].registrationNo;
								if(parseInt(xcAssetsVm.amountValueTwoWheeler) > 0){
									xcAssetsVm.isCheckedTwoWheeler = true;
								}else{
									xcAssetsVm.isCheckedTwoWheeler = false;
								}

								if (xpressCreditService.createXcData.assests[i].hypothicatedFlag == "true") {
									xcAssetsVm.isHypothecatedTwowhe = true;
								} else {
									xcAssetsVm.isHypothecatedTwowhe = false;
								}
								
							} else if(xpressCreditService.createXcData.assests[i].assetType == "FOURWL") {
								xcAssetsVm.amountValueFourWheeler = xpressCreditService.createXcData.assests[i].presentMarketValue; 
								xcAssetsVm.reginumberFourWheeler = xpressCreditService.createXcData.assests[i].registrationNo;
								if(parseInt(xcAssetsVm.amountValueFourWheeler) > 0){
									xcAssetsVm.isCheckedFourWheeler = true;
								}else{
									xcAssetsVm.isCheckedFourWheeler = false;
								}

								if (xpressCreditService.createXcData.assests[i].hypothicatedFlag == "true") {
									xcAssetsVm.isHypothecatedFourwhe = true;
								} else {
									xcAssetsVm.isHypothecatedFourwhe = false;
								}
								
							}
						}

						if(xpressCreditService.createXcData.assests[i].assetCategory == "IA") {
							if(xpressCreditService.createXcData.assests[i].assetType == "HOUSE") {
								xcAssetsVm.amountValueHouse = xpressCreditService.createXcData.assests[i].presentMarketValue; 
								xcAssetsVm.address1house = xpressCreditService.createXcData.assests[i].addressLine1; 
								xcAssetsVm.address2house = xpressCreditService.createXcData.assests[i].addressLine2; 
								xcAssetsVm.pincodehouse = xpressCreditService.createXcData.assests[i].pincode; 

								if(parseInt(xcAssetsVm.amountValueHouse) > 0){
									xcAssetsVm.isCheckedHouse = true;
								}else{
									xcAssetsVm.isCheckedHouse = false;
								}

								if (xpressCreditService.createXcData.assests[i].mortgagedFlag == "true") {
									xcAssetsVm.isMortgagedHouse = true;
								} else {
									xcAssetsVm.isMortgagedHouse = false;
								}
								
							} else if(xpressCreditService.createXcData.assests[i].assetType == "FLAT") {
								xcAssetsVm.amountValueFlat = xpressCreditService.createXcData.assests[i].presentMarketValue; 
								xcAssetsVm.address1flat = xpressCreditService.createXcData.assests[i].addressLine1; 
								xcAssetsVm.address2flat = xpressCreditService.createXcData.assests[i].addressLine2; 
								xcAssetsVm.pincodeflat = xpressCreditService.createXcData.assests[i].pincode; 
								if(parseInt(xcAssetsVm.amountValueFlat) > 0){
									xcAssetsVm.isCheckedFlat = true;
								}else{
									xcAssetsVm.isCheckedFlat = false;
								}

								if (xpressCreditService.createXcData.assests[i].mortgagedFlag == "true") {
									xcAssetsVm.isMortgagedFlat = true;
								} else {
									xcAssetsVm.isMortgagedFlat = false;
								}
								
							} else if (xpressCreditService.createXcData.assests[i].assetType == "SHOP") {
								xcAssetsVm.amountValueShop = xpressCreditService.createXcData.assests[i].presentMarketValue; 
								xcAssetsVm.address1shop = xpressCreditService.createXcData.assests[i].addressLine1; 
								xcAssetsVm.address2shop = xpressCreditService.createXcData.assests[i].addressLine2; 
								xcAssetsVm.pincodeshop = xpressCreditService.createXcData.assests[i].pincode;
								if(parseInt(xcAssetsVm.amountValueShop) > 0){
									xcAssetsVm.isCheckedShop = true;
								}else{
									xcAssetsVm.isCheckedShop = false;
								}

								if (xpressCreditService.createXcData.assests[i].mortgagedFlag == "true") {
									xcAssetsVm.isMortgagedShop = true;
								} else {
									xcAssetsVm.isMortgagedShop = false;
								}
							} else if (xpressCreditService.createXcData.assests[i].assetType == "PLOT") {
								xcAssetsVm.amountValuePlot = xpressCreditService.createXcData.assests[i].presentMarketValue; 
								xcAssetsVm.address1plot = xpressCreditService.createXcData.assests[i].addressLine1; 
								xcAssetsVm.address2plot = xpressCreditService.createXcData.assests[i].addressLine2; 
								xcAssetsVm.pincodeplot = xpressCreditService.createXcData.assests[i].pincode; 
								if(parseInt(xcAssetsVm.amountValuePlot) > 0){
									xcAssetsVm.isCheckedPlot = true;
								}else{
									xcAssetsVm.isCheckedPlot = false;
								}

								if (xpressCreditService.createXcData.assests[i].mortgagedFlag == "true") {
									xcAssetsVm.isMortgagedPlot = true;
								} else {
									xcAssetsVm.isMortgagedPlot = false;
								}
							} else if (xpressCreditService.createXcData.assests[i].assetType == "OTHERS") {
								xcAssetsVm.amountValueOthersIm = xpressCreditService.createXcData.assests[i].presentMarketValue; 
								xcAssetsVm.address1otherim = xpressCreditService.createXcData.assests[i].addressLine1; 
								xcAssetsVm.address2otherim = xpressCreditService.createXcData.assests[i].addressLine2; 
								xcAssetsVm.pincodeotherim = xpressCreditService.createXcData.assests[i].pincode; 
								if(parseInt(xcAssetsVm.amountValueOthersIm) > 0){
									xcAssetsVm.isCheckedOthersIm = true;
								}else{
									xcAssetsVm.isCheckedOthersIm = false;
								}

								if (xpressCreditService.createXcData.assests[i].mortgagedFlag == "true") {
									xcAssetsVm.isMortgagedOtherim = true;
								} else {
									xcAssetsVm.isMortgagedOtherim = false;
								}
							}
						}

						if (xpressCreditService.createXcData.assests[i].assetCategory == "LA") {
							if(xpressCreditService.createXcData.assests[i].assetType == "BD") {
								xcAssetsVm.amountValueDeposits = xpressCreditService.createXcData.assests[i].presentMarketValue; 
								if(parseInt(xcAssetsVm.amountValueDeposits) > 0){
									xcAssetsVm.isCheckedDeposits = true;
								}else{
									xcAssetsVm.isCheckedDeposits = false;
								}
								
							} else if(xpressCreditService.createXcData.assests[i].assetType == "INV") {
								xcAssetsVm.amountValueInvestments = xpressCreditService.createXcData.assests[i].presentMarketValue; 
								if(parseInt(xcAssetsVm.amountValueInvestments) > 0){
									xcAssetsVm.isCheckedInvestments = true;
								}else{
									xcAssetsVm.isCheckedInvestments = false;
								}
								
							} else if(xpressCreditService.createXcData.assests[i].assetType == "OTHERS") {
								xcAssetsVm.amountValueOthers = xpressCreditService.createXcData.assests[i].presentMarketValue; 
								if(parseInt(xcAssetsVm.amountValueOthers) > 0){
									xcAssetsVm.isCheckedOthers = true;
								}else{
									xcAssetsVm.isCheckedOthers = false;
								}
								
							}
						}
					}
					
				}
			});

			return this;
		}
]);


