'use strict';
angularApp.controller('xcBranchselectController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"xpressCreditService",
		"currentLocationService",
		"selectBranchListService",
		"getAccountDetailsService",
		"homeLoanService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, xpressCreditService, currentLocationService, selectBranchListService, getAccountDetailsService, homeLoanService) {
			
			var xcBranchselectVm = this;
			
			function initPage() {
				xcBranchselectVm.viewBranchSelection = true;
				// xcBranchselectVm.viewBranchDetails = false;
			};

			xcBranchselectVm.branchDetails = function (value) {
				// xpressCreditService.createXcData.branchTypeSelection = value;

				if (value == "gps") {
					xpressCreditService.createXcData.gpsSelectOption = "gps";
					CheckGPS.check(function(){
	                currentLocationService.getCurrentPosition().then(
		                function(position) {
		                    var latitude = position.coords.latitude;
		                    var longitude = position.coords.longitude;
		                    var params = {
		                        "latitude": latitude,
		                        "longitude": longitude
		                    }
		                    console.log("params",params)
		                    if (xpressCreditService.branchGpsArray.length == 0) {
		                        selectBranchListService.getBranchesForGeo(params).then(function(data) {
		                            if(!utilityService.isUndefined(data)) {
		                            	console.log("data",data)
		                            	xpressCreditService.branchGpsArray = data.branches;
		                            	$state.go('menu.xcBranchselectdetails');
		                            }                            
		                        }, function(error) {
		                            utilityService.showErrorMessage(error.responseMessage);
		                        });
		                    } else {
		                        $state.go('menu.xcBranchselectdetails');
		                    }
		                },
		                function(err) {
		                    var title = '';
		                    var template = 'Please turn on GPS in your mobile to select branch by GPS';
		                    var onTap = '';
		                    var buttontext = '<b>OK</b>';
		                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
		                }
		            )},
		            function(){
		                var title = '';
		                var template = '{{"ENABLE_GPS" | translate}}';
		                var onTap = '';
		                var buttontext = 'OK';
		                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
		            });
				} else if (value == "areaname") {
					xpressCreditService.createXcData.gpsSelectOption = "areaname";
					$state.go('menu.xcBranchselectdetails');
				} else {
					xpressCreditService.createXcData.gpsSelectOption = "home";

					xcBranchselectVm.homeBranchesAC = [];
					// xcBranchselectVm.homeBranches = [];

					if (getAccountDetailsService.accountOverviewData) {
		                var arr = getAccountDetailsService.accountOverviewData.accounts;
		                for (var i = 0; i < arr.length; i++) {
		                    xcBranchselectVm.homeBranchesAC.push(arr[i].branchCode);	 
		                }  
		            }

		            xcBranchselectVm.homeBranchesAC = xcBranchselectVm.removeDuplicate(xcBranchselectVm.homeBranchesAC);

		            for(var i = 0;i< xcBranchselectVm.homeBranchesAC.length;i++){
		            	var request = {
						  "locality": xcBranchselectVm.homeBranchesAC[i]
						};

						if (xpressCreditService.branchHomeArray.length == 0) {
							homeLoanService.getBranchDetails(request).then(function(data) {
								console.log(data);
								xpressCreditService.branchHomeArray.push(data.branches[0]);
								$state.go('menu.xcBranchselectdetails');
							},function(error){
								utilityService.showErrorMessage(error.responseMessage);
							});
						} else {
							$state.go('menu.xcBranchselectdetails');
						}
		            }

				}
				
			}

			xcBranchselectVm.removeDuplicate = function(arr) {
				var uniqArr = [];
				for (var i =0;i<arr.length;i++) {
					if(uniqArr.indexOf(arr[i]) == -1){
						uniqArr.push(arr[i]);
					}
				}
				return uniqArr;
			}

			xcBranchselectVm.goToAO = function () {
				$state.go('menu.loans');
			}

			xcBranchselectVm.goToCancel = function () {
				$state.go('menu.xcDocupload');
			}

			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
			});

			return this;
		}
]);


