'use strict';
angularApp.controller('xcBranchselectdetailsController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"currentLocationService",
		"xpressCreditService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, currentLocationService, xpressCreditService) {
			
			var xcBranchselectdetailsVm = this;
			
			function initPage() {
				xcBranchselectdetailsVm.counter = 0;
				xcBranchselectdetailsVm.disabledNext = false;

				if (xpressCreditService.createXcData.gpsSelectOption == "gps") {
					xcBranchselectdetailsVm.homeBranchFlag = false;
					xcBranchselectdetailsVm.homeGPSFlag = true;
					xcBranchselectdetailsVm.homeAreaFlag = false;

					xcBranchselectdetailsVm.branchDetails = xpressCreditService.branchGpsArray;

					xcBranchselectdetailsVm.disabledNext = true;
				} else if (xpressCreditService.createXcData.gpsSelectOption == "areaname") {
					xcBranchselectdetailsVm.homeBranchFlag = false;
					xcBranchselectdetailsVm.homeGPSFlag = false;
					xcBranchselectdetailsVm.homeAreaFlag = true;

					xcBranchselectdetailsVm.disabledNext = true;
				} else {
					xcBranchselectdetailsVm.homeBranchFlag = true;
					xcBranchselectdetailsVm.homeGPSFlag = false;
					xcBranchselectdetailsVm.homeAreaFlag = false;

					xcBranchselectdetailsVm.branchHomeDetails = xpressCreditService.branchHomeArray;
				}

			};

xcBranchselectdetailsVm.enterCodeFunc = function() {
	var template =  '<div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter">Please enter five digit branch code.</div></div>';
				$ionicPopup.show({
					title: '',
					template: template,
					scope: $scope,
					cssClass: 'my-custom-popup',
					buttons: [{
						text: 'OK',
						type: 'button-assertive',
						onTap: function () {
							
						}
					}],
				});
	};
			xcBranchselectdetailsVm.selectedBranchByAreaCode = function() {
				if (xcBranchselectdetailsVm.branchCode.length >= 3) {
					var params = {
		                "locality": xcBranchselectdetailsVm.branchCode
		            }
		            xpressCreditService.getBranchesForLocality(params).then(function(data) {
		                console.log("getBranchesForLocality",data)
		                if (utilityService.isUndefined(data)) {
		                    var title = '';
		                    var template = '{{"BRANCH_UNAVLBL" | translate}}';
		                    var onTap = 'menu.xcBranchselectdetails';
		                    var buttontext = '<b>OK</b>';
		                    //utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
		                } else {
		                    if (data.branches.length == 0 ) {
		                    	//if (xcBranchselectdetailsVm.branchCode.length == 3) {
			                        var title = '';
			                        var template = '{{"BRANCH_UNAVLBL" | translate}}';
			                        var onTap = 'menu.xcBranchselectdetails';
			                        var buttontext = '<b>OK</b>';
			                        //utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
			                        xcBranchselectdetailsVm.branchAreaDetails = data.branches;
			                    //}
		                    } else {
                                xcBranchselectdetailsVm.branchAreaDetails = data.branches;
                                xpressCreditService.branchAreaArray = xcBranchselectdetailsVm.branchAreaDetails;
		                    }
		                }
		            }, function(error) {
		                utilityService.showErrorMessage(error.responseMessage);
		            });
		        }
			}

			xcBranchselectdetailsVm.changeBranchAddress = function (array) {
				console.log(array)
				if (xpressCreditService.createXcData.gpsSelectOption == "gps") {
					if (xcBranchselectdetailsVm.branchvalue) {
						xcBranchselectdetailsVm.disabledNext = false;
					} else {
						xcBranchselectdetailsVm.disabledNext = true;
					}
				}

				if (xpressCreditService.createXcData.gpsSelectOption == "areaname") {
					if (xcBranchselectdetailsVm.branchareavalue) {
						xcBranchselectdetailsVm.disabledNext = false;
					} else {
						xcBranchselectdetailsVm.disabledNext = true;
					}
				}
				xpressCreditService.createXcData.branchName = array.branchName;
				xpressCreditService.createXcData.branchAddress = array.address;
				xpressCreditService.createXcData.branchCode = array.id;
			}

			xcBranchselectdetailsVm.goToAO = function () {
				$state.go('menu.loans');
			}

			xcBranchselectdetailsVm.goToCancel = function () {
				$state.go('menu.xcBranchselect');
			}

			xcBranchselectdetailsVm.goToConfirm = function () {

				if (xpressCreditService.createXcData.gpsSelectOption == "gps") {
					console.log(xpressCreditService.branchGpsArray)
				} else if (xpressCreditService.createXcData.gpsSelectOption == "areaname") {
					console.log(xpressCreditService.branchHomeArray);
				} else {
					xpressCreditService.createXcData.branchName = xpressCreditService.branchHomeArray[0].branchName;
					xpressCreditService.createXcData.branchAddress = xpressCreditService.branchHomeArray[0].address;
					xpressCreditService.createXcData.branchCode = xpressCreditService.branchHomeArray[0].id;
					console.log(xpressCreditService.branchHomeArray);
				}

				var obj = {
					// "conditionBasedOmniCall" : {
						"pageName": "branchSelect",
						"progress": "90%",
						"yonoRefNo": "",
						"branchName" : xpressCreditService.createXcData.branchName,
						"branchAddress" : xpressCreditService.createXcData.branchAddress,
						"branchCode" : xpressCreditService.createXcData.branchCode,
						"branchSelecter" : xpressCreditService.createXcData.gpsSelectOption
					// }
				}

				xpressCreditService.createXpressCredit(obj).then(function(data) {
                    console.log("createXpressCredit",obj,data)			
                    xpressCreditService.createXcData.applicationId = data.refnoLos;
                    xpressCreditService.createXcData.finaltenure = data.loanCalDuration;
                    xpressCreditService.createXcData.finalAmount = data.loanCalAmount;
			        $state.go('menu.xcCreatedSuccess');
                },function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });	
				
			}

			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
			});

			return this;
		}
]);


