'use strict';
angularApp.controller('xcCheckoffController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"xpressCreditService",
		"openUrlInAppbroswerService",
		"constantConfig",
		"customerInfoService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, xpressCreditService, openUrlInAppbroswerService, constantConfig, customerInfoService) {
			
			var xcCheckoffVm = this;
			
			function initPage() {
				xcCheckoffVm.emailDisabled  = false;
				xcCheckoffVm.downloadDisabled = false;
				xcCheckoffVm.checkOffValue = "true";
				xcCheckoffVm.nextDisabled = false;
				console.log("customerInfoService",customerInfoService)
				if (xpressCreditService.wcmContent != "") {
					xcCheckoffVm.wcmContentData = xpressCreditService.wcmContent;
				} else {

					var obj = {
						"type" : "xpressCreditKnowMoreCheckOff"
					}

					xpressCreditService.xpressWcmContent(obj).then(function(data) {
						xpressCreditService.wcmContent = data;
						xcCheckoffVm.wcmContentData = data;
						if (xpressCreditService.interestCheckOffContent != "") {
							xcCheckoffVm.interestCheckOff = xpressCreditService.interestCheckOffContent;
						} else {
							var obj1 = {
								"type" : "xpressCreditCheckOffConcession"
							}
							xpressCreditService.xpressWcmContent(obj1).then(function(data) {
								xpressCreditService.interestCheckOffContent = data;
								xcCheckoffVm.interestCheckOff = data;
			                },function(error) {
			                    utilityService.showErrorMessage(error.responseMessage);
			                });	
						}
	                },function(error) {
	                    if (xpressCreditService.interestCheckOffContent != "") {
							xcCheckoffVm.interestCheckOff = xpressCreditService.interestCheckOffContent;
						} else {
							var obj1 = {
								"type" : "xpressCreditCheckOffConcession"
							}
							xpressCreditService.xpressWcmContent(obj1).then(function(data) {
								xpressCreditService.interestCheckOffContent = data;
								xcCheckoffVm.interestCheckOff = data;
			                },function(error) {
			                    utilityService.showErrorMessage(error.responseMessage);
			                });	
						}
	                });		
				}
			};

			function b64toBlob(b64Data, contentType, sliceSize) {
				contentType = contentType || '';
				sliceSize = sliceSize || 512;

				var byteCharacters = atob(b64Data);
				var byteArrays = [];

				for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
					var slice = byteCharacters.slice(offset, offset + sliceSize);

					var byteNumbers = [];
					for (var i = 0; i < slice.length; i++) {
						byteNumbers[i] = slice.charCodeAt(i);
					}

					var byteArray = new Uint8Array(byteNumbers);

					byteArrays.push(byteArray);
				}

				var blob = new Blob(byteArrays, { type: contentType });
				return blob;
			}

			function savebase64AsPDF(folderpath, filename, content, contentType) {
				// Convert the base64 string in a Blob
				var DataBlob = b64toBlob(content, contentType);
				filename = filename + ".pdf";
				window.resolveLocalFileSystemURL(folderpath, function (dir) {
					dir.getFile(filename, { create: true }, function (file) {
						file.createWriter(function (fileWriter) {
							fileWriter.write(DataBlob);

						}, function (error) {

						});
					});
				});
			}

			xcCheckoffVm.downloadPdf = function () {
				if (xcCheckoffVm.checkOffValue == "true") {
					xpressCreditService.xpressDownloadDocument().then(function(data) {
						console.log("xpressDownloadDocument",data)
						if (data.docx) {
							var content = data.docx;
							var filename = data.fileName;

							var contentStr = atob(content);
							var contentLen = contentStr.length;

							if(contentLen >= constantConfig.accOverview.pdfSize) {   
								utilityService.showErrorMessage(constantConfig.accOverview.sizeLimitMessage);
								return;
							}

							var contentType = "application/pdf";
							if (utilityService.isAndroidPlatform()) {
								xcCheckoffVm.folderpath = cordova.file.externalRootDirectory;
							}
							if (utilityService.isIOSPlatform()) {
								xcCheckoffVm.folderpath = cordova.file.documentsDirectory;
							}
							savebase64AsPDF(xcCheckoffVm.folderpath, filename, content, contentType);
							if (utilityService.isIOSPlatform()) {
								filename = filename + ".pdf";
								var finalObject = { "folderpath": xcCheckoffVm.folderpath, "filename": filename };
								openUrlInAppbroswerService.openUrl("data:application/pdf;base64," + content + "","");
								$state.go('menu.xcCheckoff');
							}
							/* to show information popup for downlaod receipt, which will tell user format of passowrd for android and ios */
							if (utilityService.isAndroidPlatform()) {
								var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="DOWNLOADFDRECEIPT" translate-values="{folderpath:xcCheckoffVm.folderpath}"></div>';
								xcCheckoffVm.downloadPopup = $ionicPopup.show({
									title: '',
									template: template,
									scope: $scope,
									cssClass: 'my-custom-popup',
									buttons: [{
										text: 'OK',
										type: 'button-assertive',
										onTap: function () {
											$state.go('menu.xcCheckoff');
										}
									}],
								});
							}
						}
					}, function (error) {
						utilityService.showErrorMessage(error.responseMessage);
					});	
				}
			}

			xcCheckoffVm.receiptEmail = function () {
				if (xcCheckoffVm.checkOffValue == "true") {
					xpressCreditService.xpressEmailReceipt().then(function (data) {
						var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="">Mail has been sent to your registered email id.</div>';
						$ionicPopup.show({
							title: '',
							template: template,
							cssClass: 'my-custom-popup',
							buttons: [{
								text:'OK',
								type: 'button-assertive',
								onTap: function() { 
								}
							}],
						});
					}, function (error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				}
			}

			xcCheckoffVm.checkOffValidation = function (value) {
				if (value == "false") {
					xcCheckoffVm.emailDisabled = true;
					xcCheckoffVm.downloadDisabled = true;
				} else {
					xcCheckoffVm.emailDisabled = false;
					xcCheckoffVm.downloadDisabled = false;
				}
				xcCheckoffVm.nextDisabled = false; 
				xcCheckoffVm.checkOffValue = value;
				xpressCreditService.createXcData.isCheckOff = value;
			}

			xcCheckoffVm.goToAO = function () {
				xpressCreditService.initialValueStage();
				$state.go('menu.loans');
			}

			xcCheckoffVm.goToCancel = function () {
				$state.go('menu.xcCreate');
			}

			xcCheckoffVm.goToConfirm = function () {
				xpressCreditService.createXcData.isCheckOff = xcCheckoffVm.checkOffValue;
				// var checkoffvalue = xcCheckoffVm.checkOffValue == 'true' ? true : false;
				var obj = {
					// "conditionBasedOmniCall" : {
						"pageName": "checkOff",
						"progress": "10%",
						"yonoRefNo": "",
						"checkOff": xcCheckoffVm.checkOffValue
					// }
				}
				console.log("objobjobj",obj)

    			xpressCreditService.xpressCreditKycCompliance(obj).then(function(data) {
                    console.log("xpressCreditKycCompliance",obj,data)
                    if (data.complianceStatus) {
                    	xpressCreditService.createXcData.isKycUser = data.complianceStatus;

                    	if (customerInfoService.customer.isPanAvailable) {
                    		xpressCreditService.createXcData.isPANAvail = "Y";
                    	} else {
                    		xpressCreditService.createXcData.isPANAvail = "N";
                    	}

                    	// if (xpressCreditService.createXcData.isKycUser == "N") {
                    	// 	$state.go('menu.xcPanupdate');
                    	// } else {
                    	// 	$state.go('menu.xcAddressDetails');
                    	// }

						if (customerInfoService.customer.isPanAvailable == "" || customerInfoService.customer.isPanAvailable == null) {
							// if (xpressCreditService.createXcData.isKycUser ==  "N") {
							// 	$state.go('menu.xcAddressDetails');
							// } else {
								$state.go('menu.xcPanupdate');
							// }
						} else {
							if (xpressCreditService.createXcData.isKycUser ==  "N") {
								$state.go('menu.xcPanupdate');
								// $state.go('menu.xcUpdateaccount');
							} else {
								$state.go('menu.xcAddressDetails');
							}
						}
                    } else {
                    	utilityService.showErrorMessage("Can not process now, Please try after sometime.");
                    }
                },function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });


			}

			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				if (xpressCreditService.createXcData.isCheckOff != "") {
					xcCheckoffVm.checkOffValue = xpressCreditService.createXcData.isCheckOff;
				}

				if (xpressCreditService.interestCheckOffContent != "") {
					xcCheckoffVm.interestCheckOff = xpressCreditService.interestCheckOffContent;
				}
			});

			return this;
		}
]);


