'use strict';
angularApp.controller('xcCreateController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"xpressCreditService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, xpressCreditService) {
			
			var xcCreateVm = this;
			
			function initPage() {
				xcCreateVm.detail = {};

				if (utilityService.isAndroidPlatform()) {
					xcCreateVm.scrollDevice = true;
				}
				if (utilityService.isIOSPlatform()) {
					xcCreateVm.scrollDevice = false;
				}

				xcCreateVm.totalEMICost = 0;

				xcCreateVm.orgDetails = xpressCreditService.organizationTypeArray;
				xcCreateVm.yearDetails = xpressCreditService.timeInOrganizationArray;
				xcCreateVm.companyDetails = xpressCreditService.companyArray;
				xcCreateVm.instituteDetails = xpressCreditService.instituteArray;
				xcCreateVm.psuNameWithOwnershipCenterDetails = xpressCreditService.psuNameWithOwnershipCentralsArray;
				xcCreateVm.psuNameWithOwnershipStatesDetails = xpressCreditService.psuNameWithOwnershipStatesArray;
				xcCreateVm.emiTypes = xpressCreditService.emiTypeArray;

				xcCreateVm.totalEMIs = [];
				xcCreateVm.comName = [];
				xcCreateVm.instName = [];
				xcCreateVm.psuNameWithOwnershipCenter = [];
				xcCreateVm.psuNameWithOwnershipStates = [];
				xcCreateVm.psuNameWithOwnership = [];

				xcCreateVm.typeSelected = "";
				xcCreateVm.govermentDiv = false;
				xcCreateVm.defenceDiv = false;
				xcCreateVm.publicDiv = false;
				xcCreateVm.educationDiv = false;
				xcCreateVm.educationDiv = false;
				xcCreateVm.corporateDiv = false;
				xcCreateVm.nextDisabled = true;
				// xcCreateVm.empTypeRadio = "2";

				xcCreateVm.amountDataFlag = false;
				xcCreateVm.selectedOrgValueErr = false;
				xcCreateVm.selectedYearMonthValueErr = false;
				xcCreateVm.selectedMonthValue12Err = false;
				xcCreateVm.selectedMonthValueLess12Err = false;
				xcCreateVm.selectedMonthValueGreater12Err = false;
				xcCreateVm.selectedGovermentValueErr = false;
				xcCreateVm.selectedDefenceValueErr = false;
				xcCreateVm.forceNumberErr = false;
				xcCreateVm.regiNumberErr = false;
				xcCreateVm.selectedValuePublicErr = false;
				xcCreateVm.statepsuErr = false;
				xcCreateVm.institutenameErr = false;
				xcCreateVm.companynameErr = false;
				xcCreateVm.companynameNotInListErr = false;

				if (xpressCreditService.companyArray.length) {
					for(var i = 0; i < xpressCreditService.companyArray.length; i++) {
						xcCreateVm.comName.push(xpressCreditService.companyArray[i].value);
					}
				}

				if (xpressCreditService.instituteArray.length) {
					for(var i = 0; i < xpressCreditService.instituteArray.length; i++) {
						xcCreateVm.instName.push(xpressCreditService.instituteArray[i].value);
					}
				}
			};

			xcCreateVm.typeOrgCheck = function(valueData) {
				// var checkOrgType = value.split(',');
				if (valueData != "") {
					xcCreateVm.selectedOrgValueErr = false;
					var checkOrgType = JSON.parse(valueData);
					if (checkOrgType.key == "CG") {
						xcCreateVm.typeSelected = "CG";

						xcCreateVm.govermentDiv = true;
						xcCreateVm.defenceDiv = false;
						xcCreateVm.publicDiv = false;
						xcCreateVm.educationDiv = false;
						xcCreateVm.educationDiv = false;
						xcCreateVm.corporateDiv = false;

						xcCreateVm.goverDetails = xpressCreditService.govermentTypeArray;
					} else if (checkOrgType.key == "DEFE") {
						xcCreateVm.typeSelected = "DEFE";

						xcCreateVm.govermentDiv = false;
						xcCreateVm.defenceDiv = true;
						xcCreateVm.publicDiv = false;
						xcCreateVm.educationDiv = false;
						xcCreateVm.educationDiv = false;
						xcCreateVm.corporateDiv = false;

						xcCreateVm.defenceDetails = xpressCreditService.defenceTypeArray;
					} else if (checkOrgType.key == "CPSU") {
						xcCreateVm.typeSelected = "CPSU";

						xcCreateVm.govermentDiv = false;
						xcCreateVm.defenceDiv = false;
						xcCreateVm.publicDiv = true;
						xcCreateVm.educationDiv = false;
						xcCreateVm.educationDiv = false;
						xcCreateVm.corporateDiv = false;

						xcCreateVm.psuDetails = xpressCreditService.psuTypeArray;
					} else if (checkOrgType.key == "EDNR") {
						xcCreateVm.typeSelected = "EDNR";

						xcCreateVm.govermentDiv = false;
						xcCreateVm.defenceDiv = false;
						xcCreateVm.publicDiv = false;
						xcCreateVm.educationDiv = false;
						xcCreateVm.educationDiv = true;
						xcCreateVm.corporateDiv = false;
					} else if (checkOrgType.key == "RCOE") {
						xcCreateVm.typeSelected = "RCOE";

						xcCreateVm.govermentDiv = false;
						xcCreateVm.defenceDiv = false;
						xcCreateVm.publicDiv = false;
						xcCreateVm.educationDiv = false;
						xcCreateVm.educationDiv = false;
						xcCreateVm.corporateDiv = true;
					}
				} else {
					xcCreateVm.selectedOrgValueErr = true;
				}
			}

			xcCreateVm.selectValueBox = function (value) {
				console.log(value)
				if (value != "") {
					xcCreateVm.selectedGovermentValue = "";
					xcCreateVm.selectedDefenceValue = "";
					xcCreateVm.forceNumber = "";
					xcCreateVm.regiNumber = "";
					xcCreateVm.selectedValuePublic = "";
					xcCreateVm.statepsu = "";
					xcCreateVm.institutename = "";
					xcCreateVm.companyname = "";

					xcCreateVm.nextDisabled = true;
					xcCreateVm.typeOrgCheck(value);
				} else {
					xcCreateVm.govermentDiv = false;
					xcCreateVm.defenceDiv = false;
					xcCreateVm.publicDiv = false;
					xcCreateVm.educationDiv = false;
					xcCreateVm.educationDiv = false;
					xcCreateVm.corporateDiv = false;
					
					xcCreateVm.selectedOrgValueErr = true;
					xcCreateVm.nextDisabled = true;
				}
			}	

			xcCreateVm.validationChange = function (value, type) {
				//year and moonth calculations
				if (xcCreateVm.selectedMonthValue && xcCreateVm.selectedYearValue) {
					var tenure = ((parseInt(xcCreateVm.selectedYearValue)*12) + (parseInt(xcCreateVm.selectedMonthValue)));
				} else if (xcCreateVm.selectedYearValue && !xcCreateVm.selectedMonthValue) {
					var tenure = (parseInt(xcCreateVm.selectedYearValue)*12) + 0;
				} else if (!xcCreateVm.selectedYearValue && xcCreateVm.selectedMonthValue) {
					var tenure = (0*12) + (parseInt(xcCreateVm.selectedMonthValue));
				} else {
					var tenure = 0;
				}

				if (parseInt(xcCreateVm.selectedMonthValue) == 12) {
					if (xcCreateVm.selectedYearValue) {
						xcCreateVm.selectedYearValue = parseInt(xcCreateVm.selectedYearValue) + 1;
					} else {
						xcCreateVm.selectedYearValue = 1;
					}
					xcCreateVm.selectedMonthValue = 0;
				}

				//validation and error message block
				if (!xcCreateVm.selectedYearValue
					|| parseInt(xcCreateVm.selectedYearValue) <= 0 || parseInt(xcCreateVm.selectedMonthValue) > 12 
					|| tenure < 12 || tenure > 999 || xcCreateVm.empTypeRadio != "2") {
					
					// if (type == "amountData") {
					// 	if (xcCreateVm.amountData < 5000) {
					// 		xcCreateVm.amountDataFlag = true;
					// 	} else {
					// 		xcCreateVm.amountDataFlag = false;
					// 	}
					// }

					if (type == "time") {
						if (parseInt(xcCreateVm.selectedMonthValue) > 12) {
							xcCreateVm.selectedMonthValue12Err = true;
						} else {
							xcCreateVm.selectedMonthValue12Err = false;
						}

						if (tenure < 12) {
							xcCreateVm.selectedMonthValueLess12Err = true;
						} else {
							xcCreateVm.selectedMonthValueLess12Err = false;
						}

						if (tenure > 999) {
							xcCreateVm.selectedMonthValueGreater12Err = true;
						} else {
							xcCreateVm.selectedMonthValueGreater12Err = false;
						}
					}

					xcCreateVm.nextDisabled = true;
				} else {
					// xcCreateVm.amountDataFlag = false;
					// xcCreateVm.selectedYearMonthValueErr = false;
					xcCreateVm.selectedMonthValue12Err = false;
					xcCreateVm.selectedMonthValueLess12Err = false;
					xcCreateVm.selectedMonthValueGreater12Err = false;

					if (xcCreateVm.typeSelected == "CG") {
						if (value) {
							xcCreateVm.nextDisabled = false;
						} else {
							xcCreateVm.nextDisabled = true;
						}
					}
					if (xcCreateVm.typeSelected == "DEFE") {
						if (value && xcCreateVm.regiNumber && xcCreateVm.forceNumber) {
							xcCreateVm.nextDisabled = false;
						} else {
							xcCreateVm.nextDisabled = true;
						}
					}

					if (xcCreateVm.typeSelected == "CPSU") {
						xcCreateVm.statepsu = "";
						// if (value && xcCreateVm.statepsu) {
						if (value) {
							var psuDetailsObj = JSON.parse(value);
							if (psuDetailsObj.value == "Central") {
								xcCreateVm.psuNameWithOwnershipDetails = xpressCreditService.psuNameWithOwnershipCentralsArray;
				
								if (xpressCreditService.psuNameWithOwnershipCentralsArray.length) {
									for(var i = 0; i < xpressCreditService.psuNameWithOwnershipCentralsArray.length; i++) {
										xcCreateVm.psuNameWithOwnership.push(xpressCreditService.psuNameWithOwnershipCentralsArray[i].value);
									}
								}
							} else {
								xcCreateVm.psuNameWithOwnershipDetails = xpressCreditService.psuNameWithOwnershipStatesArray;
								if (xpressCreditService.psuNameWithOwnershipStatesArray.length) {
									for(var i = 0; i < xpressCreditService.psuNameWithOwnershipStatesArray.length; i++) {
										xcCreateVm.psuNameWithOwnership.push(xpressCreditService.psuNameWithOwnershipStatesArray[i].value);
									}
								}
							}
							
						}

						if (value && xcCreateVm.statepsu) {
							xcCreateVm.nextDisabled = false;
						} else {
							xcCreateVm.nextDisabled = true;
						}
					}
				}

				if (type == "selectedGovermentValue") {
					if (xcCreateVm.selectedGovermentValue) {
						xcCreateVm.selectedGovermentValueErr = false;
					} else {
						xcCreateVm.selectedGovermentValueErr = true;
					}
				}

				if (type == "selectedDefenceValue") {
					if (xcCreateVm.selectedDefenceValue) {
						xcCreateVm.selectedDefenceValueErr = false;
					} else {
						xcCreateVm.selectedDefenceValueErr = true;
					}
				}

				if (type == "selectedValuePublic") {
					if (xcCreateVm.selectedValuePublic) {
						xcCreateVm.selectedValuePublicErr = false;
					} else {
						xcCreateVm.selectedValuePublicErr = true;
					}
				}

				
					// xcCreateVm.nextDisabled = false;	
			}

			xcCreateVm.validationInput = function (type) {
				if (xcCreateVm.selectedMonthValue && xcCreateVm.selectedYearValue) {
					var tenure = ((parseInt(xcCreateVm.selectedYearValue)*12) + (parseInt(xcCreateVm.selectedMonthValue)));
				} else if (xcCreateVm.selectedYearValue && !xcCreateVm.selectedMonthValue) {
					var tenure = (parseInt(xcCreateVm.selectedYearValue)*12) + 0;
				} else if (!xcCreateVm.selectedYearValue && xcCreateVm.selectedMonthValue) {
					var tenure = (0*12) + (parseInt(xcCreateVm.selectedMonthValue));
				} else {
					var tenure = 0;
				}

				if (parseInt(xcCreateVm.selectedMonthValue) == 12) {
					if (xcCreateVm.selectedYearValue) {
						xcCreateVm.selectedYearValue = parseInt(xcCreateVm.selectedYearValue) + 1;
					} else {
						xcCreateVm.selectedYearValue = 1;
					}
					xcCreateVm.selectedMonthValue = 0;
				}
				if (!xcCreateVm.selectedYearValue || parseInt(xcCreateVm.selectedYearValue) <= 0 || parseInt(xcCreateVm.selectedMonthValue) > 12 || tenure < 12 || tenure > 999 || xcCreateVm.empTypeRadio != "2") {
					
					// if (type == "amountData") {
					// 	if (xcCreateVm.amountData < 5000) {
					// 		xcCreateVm.amountDataFlag = true;
					// 	} else {
					// 		xcCreateVm.amountDataFlag = false;
					// 	}
					// }

					if (type == "time") {
						if (parseInt(xcCreateVm.selectedMonthValue) > 12) {
							xcCreateVm.selectedMonthValue12Err = true;
						} else {
							xcCreateVm.selectedMonthValue12Err = false;
						}

						if (tenure < 12) {
							xcCreateVm.selectedMonthValueLess12Err = true;
						} else {
							xcCreateVm.selectedMonthValueLess12Err = false;
						}

						if (tenure > 999) {
							xcCreateVm.selectedMonthValueGreater12Err = true;
						} else {
							xcCreateVm.selectedMonthValueGreater12Err = false;
						}
					}
					
					xcCreateVm.nextDisabled = true;
				} else {
					// xcCreateVm.amountDataFlag = false;
					// xcCreateVm.selectedYearMonthValueErr = false;
					xcCreateVm.selectedMonthValue12Err = false;
					xcCreateVm.selectedMonthValueLess12Err = false;

					if (xcCreateVm.typeSelected == "CG") {
						if (xcCreateVm.selectedGovermentValue) {
							xcCreateVm.nextDisabled = false;
						} else {
							xcCreateVm.nextDisabled = true;
						}
					}

					if (xcCreateVm.typeSelected == "DEFE") {
						if (xcCreateVm.regiNumber && xcCreateVm.forceNumber && xcCreateVm.selectedDefenceValue) {
							xcCreateVm.nextDisabled = false;
						} else {
							xcCreateVm.nextDisabled = true;
						}
					}

					if (xcCreateVm.typeSelected == "CPSU") {
						if (xcCreateVm.selectedValuePublic && xcCreateVm.statepsu) {
							xcCreateVm.nextDisabled = false;
						} else {
							xcCreateVm.nextDisabled = true;
						}
					}

					if (xcCreateVm.typeSelected == "EDNR") {
						if (xcCreateVm.institutename) {
							xcCreateVm.nextDisabled = false;
						} else {
							xcCreateVm.nextDisabled = true;
						}
					}

					if (xcCreateVm.typeSelected == "RCOE") {
						if (xcCreateVm.companyname) {
							xcCreateVm.nextDisabled = false;
						} else {
							xcCreateVm.nextDisabled = true;
						}
					}
				}

				if (type == "forceNumber") {
					if (xcCreateVm.forceNumber) {
						xcCreateVm.forceNumberErr = false;
					} else {
						xcCreateVm.forceNumberErr = true;
					}
				}

				if (type == "regiNumber") {
					if (xcCreateVm.regiNumber) {
						xcCreateVm.regiNumberErr = false;
					} else {
						xcCreateVm.regiNumberErr = true;
					}
				}

				if (type == "statepsu") {
					xcCreateVm.hideListStatePSU = false;
					if (xcCreateVm.statepsu) {
						xcCreateVm.statepsuErr = false;

						if (xcCreateVm.psuNameWithOwnership.indexOf(xcCreateVm.statepsu) > -1) {
						    xcCreateVm.statePSUNotInListErr = false;
						    xcCreateVm.nextDisabled = false;
						} else {
						    xcCreateVm.statePSUNotInListErr = true;
						    xcCreateVm.nextDisabled = true;
						}
					} else {
						xcCreateVm.statepsuErr = true;
						xcCreateVm.statePSUNotInListErr = false;
					}
				}

				if (type == "institutename") {
					xcCreateVm.hideListInstitute = false;
					if (xcCreateVm.institutename) {
						xcCreateVm.institutenameErr = false;

						if (xcCreateVm.instName.indexOf(xcCreateVm.institutename) > -1) {
						    xcCreateVm.institutenameNotInListErr = false;
						    xcCreateVm.nextDisabled = false;
						} else {
						    xcCreateVm.institutenameNotInListErr = true;
						    xcCreateVm.nextDisabled = true;
						}
					} else {
						xcCreateVm.institutenameErr = true;
						xcCreateVm.institutenameNotInListErr = false;
					}
				}

				if (type == "companyname") {
					xcCreateVm.hideListCompany = false;
					if (xcCreateVm.companyname) {
						xcCreateVm.companynameErr = false;
						
						if (xcCreateVm.comName.indexOf(xcCreateVm.companyname) > -1) {
						    xcCreateVm.companynameNotInListErr = false;
						    xcCreateVm.nextDisabled = false;
						} else {
						    xcCreateVm.companynameNotInListErr = true;
						    xcCreateVm.nextDisabled = true;
						}
					} else {
						xcCreateVm.companynameErr = true;
						xcCreateVm.companynameNotInListErr = false;
					}
				}	
			}

			xcCreateVm.afterDataValidation = function () {
				if (xpressCreditService.createXcData.selectedYearsType 
					&& xpressCreditService.createXcData.netMonthlyIncome 
					&& xpressCreditService.createXcData.organizationType) {

					// var typeCheck = xpressCreditService.createXcData.organizationType.split(',');
					var typeCheck = JSON.parse(xpressCreditService.createXcData.organizationType);
					
					if (typeCheck.key == "CG") {
						if (xcCreateVm.selectedGovermentValue) {
							xcCreateVm.nextDisabled = false;
						} else {
							xcCreateVm.nextDisabled = true;
						}
					}

					if (typeCheck.key == "DEFE") {
						if (xcCreateVm.regiNumber && xcCreateVm.forceNumber && xcCreateVm.selectedDefenceValue) {
							xcCreateVm.nextDisabled = false;
						} else {
							xcCreateVm.nextDisabled = true;
						}
					}

					if (typeCheck.key == "CPSU") {
						if (xcCreateVm.selectedValuePublic && xcCreateVm.statepsu) {
							xcCreateVm.nextDisabled = false;
						} else {
							xcCreateVm.nextDisabled = true;
						}
					}

					if (typeCheck.key == "EDNR") {
						if (xcCreateVm.institutename) {
							xcCreateVm.nextDisabled = false;
							xcCreateVm.institutenameErr = false;
						} else {
							xcCreateVm.nextDisabled = true;
						}
					}

					if (typeCheck.key == "RCOE") {
						if (xcCreateVm.companyname) {
							xcCreateVm.nextDisabled = false;
							xcCreateVm.companynameErr = false;
						} else {
							xcCreateVm.nextDisabled = true;
						}
					}
				}
			}

			xcCreateVm.changeRadioEmp = function () {
				if (xcCreateVm.empTypeRadio == "1") {
					var title = '';
					var stringText = 'Sorry! SBI Xpress Credit is only for the regular employed customers.';
					var template = '<div class="text-center">'+stringText+'</div>';
					$ionicPopup.show({
						title: '',
						template: template,
						scope: $scope,
						cssClass: 'my-custom-popup',
						buttons: [{
							text: 'OK',
							type: 'button-assertive',
							onTap: function () {
								xcCreateVm.nextDisabled = true;
							}
						}],
					});
				} else {

					if (xcCreateVm.selectedMonthValue) {
						var tenure = ((parseInt(xcCreateVm.selectedYearValue)*12) + (parseInt(xcCreateVm.selectedMonthValue)));
					} else {
						var tenure = (parseInt(xcCreateVm.selectedYearValue)*12) + 0;
					}

					if (xcCreateVm.amountData == undefined || xcCreateVm.amountData < 5000  || !xcCreateVm.selectedYearValue
						|| parseInt(xcCreateVm.selectedYearValue) <= 0 || parseInt(xcCreateVm.selectedMonthValue) > 11 || tenure < 12) {
						xcCreateVm.nextDisabled = true;
					} else {
						xcCreateVm.nextDisabled = false;
					}

					xpressCreditService.createXcData.empTypeRadio = xcCreateVm.empTypeRadio;
				}
			}

			xcCreateVm.addEMI = function() {
				xcCreateVm.emiObj = {
	                "type": "",
	                "amount": ""
	            };
	            // if(xcCreateVm.totalEMIs.length < 6) {
	            	xcCreateVm.totalEMIs.push(xcCreateVm.emiObj);
	            // }
			}

			xcCreateVm.calculateEMIs = function() {
				xcCreateVm.totalEMICost = 0;
				for (var i = 0; i< xcCreateVm.totalEMIs.length;i++) {
					if (xcCreateVm.totalEMIs[i].amount == "") {
						xcCreateVm.totalEMIs[i].amount = 0;
					}
					xcCreateVm.totalEMICost = parseInt(parseInt(xcCreateVm.totalEMICost) + parseInt(xcCreateVm.totalEMIs[i].amount)); 
				}
			}

			xcCreateVm.deleteEMI = function(emiIndex) {			
	            if (xcCreateVm.totalEMIs.length == 0) {
	            	xcCreateVm.totalEMICost = 0;
	            } else {
	            	xcCreateVm.totalEMICost = parseInt(xcCreateVm.totalEMICost) - parseInt(xcCreateVm.totalEMIs[emiIndex].amount);
	            	xcCreateVm.totalEMIs.splice(emiIndex,1);
	            }
			}

			xcCreateVm.goToAO = function () {
				xpressCreditService.initialValueStage();
				$state.go('menu.loans');
			}

			xcCreateVm.goToCancel = function () {
				$state.go('menu.loans');
			}


			xcCreateVm.selectCompanyName = function (obj) {
				xcCreateVm.companyname = obj.value;
				xcCreateVm.companyId = obj.key;
				xpressCreditService.createXcData.companyId =  xcCreateVm.companyId;
				xpressCreditService.createXcData.companyName =  JSON.stringify(obj);
				xcCreateVm.validationInput('companyname');
				xcCreateVm.hideListCompany = true;
			}

			xcCreateVm.selectInstituteName = function (obj) {
				xcCreateVm.institutename = obj.value;
				xcCreateVm.instituteId = obj.key;
				xpressCreditService.createXcData.instituteId =  xcCreateVm.instituteId;
				xpressCreditService.createXcData.instituteName =  JSON.stringify(obj);
				xcCreateVm.validationInput('institutename');
				xcCreateVm.hideListInstitute = true;
			}

			xcCreateVm.selectPSU = function (obj) {
				xcCreateVm.statepsu = obj.value;
				xcCreateVm.statepsuId = obj.key;
				xpressCreditService.createXcData.psuStateId =  xcCreateVm.statepsuId;
				xpressCreditService.createXcData.psuStateName =  JSON.stringify(obj);
				xcCreateVm.validationInput('statepsu');
				xcCreateVm.hideListStatePSU = true;
			}

			xcCreateVm.goToConfirm = function () {
				var orgData = "";
				var orgId = "";
				var orgText = "";
				var goverData = "";
				var goverId = "";
				var goverText = "";
				var defenceData = "";
				var defenceId = "";
				var defenceText = "";
				var publicData = "";
				var publicId = "";
				var publicText = "";

				xcCreateVm.detail.emiObj = [];
				if (xcCreateVm.totalEMIs.length > 0) {
					for (var i = 0; i< xcCreateVm.totalEMIs.length;i++) {
						
						var obj = {};
						obj.type = xcCreateVm.totalEMIs[i].type;
						obj.amount = xcCreateVm.totalEMIs[i].amount ? xcCreateVm.totalEMIs[i].amount : 0;
						var index = i+1;
						if(!obj.type){
							utilityService.showErrorMessage("Please select Loan type of "+ index + " in Existing EMI");
							return;
						} else if(parseInt(obj.amount) < 1){
							utilityService.showErrorMessage("Please enter EMI of "+ index + " in Existing EMI");
							return;
						}
						xcCreateVm.detail.emiObj.push(obj);
					}
				}

				xpressCreditService.createXcData.emi = xcCreateVm.detail.emiObj;
				xpressCreditService.createXcData.emiTotalCost = xcCreateVm.totalEMICost;

				xpressCreditService.createXcData.selectedYearsType = xcCreateVm.selectedYearValue;
				xpressCreditService.createXcData.selectedMonthsType = xcCreateVm.selectedMonthValue;

				if (xcCreateVm.selectedOrgValue) {
					xpressCreditService.createXcData.organizationType = xcCreateVm.selectedOrgValue;
					orgData = JSON.parse(xcCreateVm.selectedOrgValue)
					orgId = orgData.key;
					orgText = orgData.value;
				}
				
				if  (xcCreateVm.selectedGovermentValue) {
					xpressCreditService.createXcData.govOrgType = xcCreateVm.selectedGovermentValue;
					goverData = JSON.parse(xcCreateVm.selectedGovermentValue)
					goverId = goverData.key;
					goverText = goverData.value;
				}

				if (xcCreateVm.selectedValuePublic) {
					xpressCreditService.createXcData.publicStateType = xcCreateVm.selectedValuePublic;
					publicData = JSON.parse(xcCreateVm.selectedValuePublic)
					publicId = publicData.key;
					publicText = publicData.value;
				}

				if (xcCreateVm.selectedDefenceValue) {
					xpressCreditService.createXcData.defenceType = xcCreateVm.selectedDefenceValue;
					defenceData = JSON.parse(xcCreateVm.selectedDefenceValue)
					defenceId = defenceData.key;
					defenceText = defenceData.value;
				}

				xpressCreditService.createXcData.netMonthlyIncome = xcCreateVm.amountData;
				xpressCreditService.createXcData.publicStatePSU = xcCreateVm.statepsu;
				xpressCreditService.createXcData.forceNumber = xcCreateVm.forceNumber;
				xpressCreditService.createXcData.regimentNumber = xcCreateVm.regiNumber;
				// xpressCreditService.createXcData.instituteName = xcCreateVm.institutename;
				// xpressCreditService.createXcData.psuStateName = xcCreateVm.statepsu;
				// xpressCreditService.createXcData.companyName = xcCreateVm.companyname;

				var obj = {
					"xpressStatus": xpressCreditService.statusXc,
					"pageName": "incomeAndEmploymentDetails",
					"progress": "0%",
					"yonoRefNo": "",
					"netMonthlyIncome": xcCreateVm.amountData,
					"employmentType": xcCreateVm.empTypeRadio,
					"timeInOrgYears": xcCreateVm.selectedYearValue,
					"timeInOrgMonths": xcCreateVm.selectedMonthValue,
					"years": xcCreateVm.selectedYearValue,
					"months": xcCreateVm.selectedMonthValue,
					"orgTypeId": orgId,
					"orgTypeText": xcCreateVm.selectedOrgValue,
					"typeOfOrgId": goverId,
					"typeOfOrgText": xcCreateVm.selectedGovermentValue,
					"typeOfDefenceId": defenceId,
					"typeOfDefenceText": xcCreateVm.selectedDefenceValue,
					"typeOfPsuId": publicId,
					"typeOfPsuText": xcCreateVm.selectedValuePublic,
					"forceNo": xcCreateVm.forceNumber,
					"regimentNo": xcCreateVm.regiNumber,
					// "psuNameText": xcCreateVm.statepsu,
					"psuNameText": xpressCreditService.createXcData.psuStateName,
					"psuNameId": xpressCreditService.createXcData.psuStateId,
					"companyId": xpressCreditService.createXcData.companyId,
					"companyText": xpressCreditService.createXcData.companyName,
					// "companyText": xcCreateVm.companyname,
					"institutionId": xpressCreditService.createXcData.instituteId,
					// "institutionText": xcCreateVm.institutename,
					"institutionText": xpressCreditService.createXcData.instituteName,
					"emi": xcCreateVm.detail.emiObj,
					"totalExistingEMI": xcCreateVm.totalEMICost
				}

				if (xcCreateVm.amountData < 5000) {
					xcCreateVm.amountDataFlag = true;
				} else {
					xcCreateVm.amountDataFlag = false;
	    			xpressCreditService.initialEligibilityService(obj).then(function(data) {
	                    console.log("initialEligibilityService",obj,data)
	                    if (data.result == "Y") {
							$state.go('menu.xcCheckoff');
	                    } else {
	                    	utilityService.showErrorMessage("Sorry! you are not eligible for Xpress Credit.");
	                    }
	                },function(error) {
	                    utilityService.showErrorMessage(error.responseMessage);
	                });
				}

				
			}

			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				if (xpressCreditService.createXcData.netMonthlyIncome) {
					xcCreateVm.amountData = xpressCreditService.createXcData.netMonthlyIncome;
				}

				if (xpressCreditService.createXcData.selectedYearsType != "") {
					xcCreateVm.selectedYearValue = xpressCreditService.createXcData.selectedYearsType;
				} else {
					xcCreateVm.selectedYearValue = "";
				}

				if (xpressCreditService.createXcData.selectedMonthsType != "") {
					xcCreateVm.selectedMonthValue = xpressCreditService.createXcData.selectedMonthsType;
				} else {
					xcCreateVm.selectedMonthValue = "";
				}

				if (xpressCreditService.createXcData.organizationType) {
					xcCreateVm.selectedOrgValue = xpressCreditService.createXcData.organizationType;
					xcCreateVm.typeOrgCheck(xcCreateVm.selectedOrgValue);
				} else {
					xcCreateVm.selectedOrgValue = "";
				}

				if (xpressCreditService.createXcData.govOrgType) {
					xcCreateVm.selectedGovermentValue = xpressCreditService.createXcData.govOrgType;
				} else {
					xcCreateVm.selectedGovermentValue = "";
				}

				if (xpressCreditService.createXcData.publicStateType) {
					xcCreateVm.selectedValuePublic = xpressCreditService.createXcData.publicStateType;
					var psuDetailsObj1 = JSON.parse(xcCreateVm.selectedValuePublic);
					if (psuDetailsObj1.value == "Central") {
						xcCreateVm.psuNameWithOwnershipDetails = xpressCreditService.psuNameWithOwnershipCentralsArray;
						if (xpressCreditService.psuNameWithOwnershipCentralsArray.length) {
							for(var i = 0; i < xpressCreditService.psuNameWithOwnershipCentralsArray.length; i++) {
								xcCreateVm.psuNameWithOwnership.push(xpressCreditService.psuNameWithOwnershipCentralsArray[i].value);
							}
						}
					} else {
						xcCreateVm.psuNameWithOwnershipDetails = xpressCreditService.psuNameWithOwnershipStatesArray;
						if (xpressCreditService.psuNameWithOwnershipStatesArray.length) {
							for(var i = 0; i < xpressCreditService.psuNameWithOwnershipStatesArray.length; i++) {
								xcCreateVm.psuNameWithOwnership.push(xpressCreditService.psuNameWithOwnershipStatesArray[i].value);
							}
						}
					}
				} else {
					xcCreateVm.selectedValuePublic = "";
				}

				if (xpressCreditService.createXcData.psuStateName) {
					var valueDataPSU = JSON.parse(xpressCreditService.createXcData.psuStateName)
					xcCreateVm.statepsu = valueDataPSU.value;
					xcCreateVm.hideListStatePSU = true;
				}

				if (xpressCreditService.createXcData.defenceType) {
					xcCreateVm.selectedDefenceValue = xpressCreditService.createXcData.defenceType;
				} else {
					xcCreateVm.selectedDefenceValue = "";
				}

				if (xcCreateVm.totalEMIs.length == 0) {
					xcCreateVm.totalEMIs.loanType = "";
				}

				if (xpressCreditService.createXcData.forceNumber) {
					xcCreateVm.forceNumber = xpressCreditService.createXcData.forceNumber;
				}

				if (xpressCreditService.createXcData.regimentNumber) {
					xcCreateVm.regiNumber = xpressCreditService.createXcData.regimentNumber;
				}

				if (xpressCreditService.createXcData.instituteName) {
					var valueDataInstitut = JSON.parse(xpressCreditService.createXcData.instituteName)
					xcCreateVm.institutename = valueDataInstitut.value;
					xcCreateVm.hideListInstitute = true;
				}

				if (xpressCreditService.createXcData.companyName) {
					var valueDataCompany = JSON.parse(xpressCreditService.createXcData.companyName)
					xcCreateVm.companyname = valueDataCompany.value;
					xcCreateVm.hideListCompany = true;
				}

				if (xpressCreditService.createXcData.empTypeRadio) {
					xcCreateVm.empTypeRadio = xpressCreditService.createXcData.empTypeRadio;
				}
				
				if (xpressCreditService.createXcData.emi) {
					if (xpressCreditService.createXcData.emi.length > 0) { 
						xcCreateVm.totalEMIs = xpressCreditService.createXcData.emi;
					}
				}

				if (xpressCreditService.createXcData.emiTotalCost) {
					xcCreateVm.totalEMICost = xpressCreditService.createXcData.emiTotalCost;
				}

				xcCreateVm.afterDataValidation();
			});

			return this;
		}
]);


