'use strict';
angularApp.controller('xcDocuploadController', [
		"$state",
		"$scope",
		"$rootScope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"xpressCreditService",
		"customerInfoService",
		function($state, $scope, $rootScope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, xpressCreditService, customerInfoService) {
			
			var xcDocuploadVm = this;
			
			function initPage() {
				xcDocuploadVm.disabledNext = false;

				xcDocuploadVm.documentUploadDocument = [];
				
				xcDocuploadVm.showCheckOffDiv = false;
				xcDocuploadVm.showPANDiv = false;
				xcDocuploadVm.showPassportDiv = false;

				if (xpressCreditService.createXcData.updateAccDocType) {
					if (xpressCreditService.createXcData.updateAccDocType == "passport") {
						xcDocuploadVm.officialDocType = "Passport"
					} else if (xpressCreditService.createXcData.updateAccDocType == "drivingLicense") {
						xcDocuploadVm.officialDocType = "Driving License"
					} else if (xpressCreditService.createXcData.updateAccDocType == "voterIDCard") {
						xcDocuploadVm.officialDocType = "Voter ID"
					} else if (xpressCreditService.createXcData.updateAccDocType == "nregaCard") {
						xcDocuploadVm.officialDocType = "Nrega"
					}
				}

				if (xpressCreditService.createXcData.isCheckOff == "true") {
					xcDocuploadVm.showCheckOffDiv = true;
				} else {
					xcDocuploadVm.showCheckOffDiv = false;
				}

				if (customerInfoService.customer.isPanAvailable == "" || customerInfoService.customer.isPanAvailable == null || xpressCreditService.createXcData.isKycUser == "N" || xpressCreditService.createXcData.isPanReq == "Y") {
					xcDocuploadVm.showPANDiv = true;
				} else {
					xcDocuploadVm.showPANDiv = false;
				}

				if (xpressCreditService.createXcData.updateAccDocType) {
					xcDocuploadVm.showPassportDiv = true;
				} else {
					xcDocuploadVm.showPassportDiv = false;
				}
			};

			xcDocuploadVm.goToAO = function () {
				$state.go('menu.loans');
			}

			xcDocuploadVm.upDateProfile = function(imgProfile, filename, type, filesize, category, contentType, typecheck) {
				var reqParams = {};
					reqParams["docType"] = type;
					reqParams["documentFormat"] = contentType;
					reqParams["docName"] = filename; 
					reqParams["docSize"] = filesize; 
					reqParams["category"] = category;
					reqParams["base64"] = imgProfile.split(',')[1];
					reqParams["cifno"] = " ";
				console.log("reqParamsreqParams",reqParams)

				for (var i=0; i < xcDocuploadVm.documentUploadDocument.length; i++) {
					if (xcDocuploadVm.documentUploadDocument[i].docType == type) {
						xcDocuploadVm.documentUploadDocument.splice(i,1);
					}
				}
				var uploadDocument = [];
				uploadDocument.push(reqParams);
				xcDocuploadVm.documentUploadDocument.push(reqParams);
				xpressCreditService.createXcData.uploadDoc = xcDocuploadVm.documentUploadDocument;
				var obj = {
					"pageName": "uploadDocument",
					"progress": "80%",
					"yonoRefNo": "",
					"uploadDoc": uploadDocument
				}

				// xpressCreditService.OmniCallResponse(obj).then(function(data) {
				xpressCreditService.uploadDocService(obj).then(function(data) {
                    console.log("uploadDocService",obj,data)
					//$state.go('menu.xcBranchselect');
                },function(error) {
                	if (type == "profilephoto") {
						
						xcDocuploadVm.profilePhoto = "";
						xcDocuploadVm.profilePhotoSize = "";
						
					} else if (type == "salaryslip1") {
						
						xcDocuploadVm.salarySlip1 = "";
						xcDocuploadVm.salarySlip1Size = "";
						
					} else if (type == "salaryslip2") {
						
						xcDocuploadVm.salarySlip2 = "";
						xcDocuploadVm.salarySlip2Size = "";
						
					} else if (type == "salaryslip3") {
						
						xcDocuploadVm.salarySlip3 = "";
						xcDocuploadVm.salarySlip3Size = "";
						
					} else if (type == "pancard") {
						
						xcDocuploadVm.panCard = "";
						xcDocuploadVm.panCardSize = "";
						
					} else if (type == "officialDoc1") {
						
						xcDocuploadVm.officialDoc1Val = "";
						xcDocuploadVm.officialDoc1Size = "";
						xpressCreditService.isDocument1Changed = true;
						
					} else if (type == "officialDoc2") {
						
						xcDocuploadVm.officialDoc2Val = "";
						xcDocuploadVm.officialDoc2Size = "";
						xpressCreditService.isDocument2Changed = true;
					} else if (type == "checkoffdoc") {
						
						xcDocuploadVm.checkOffDoc = "";
						xcDocuploadVm.checkOffDocSize = "";
						
					}
                    utilityService.showErrorMessage(error.responseMessage);
                    xcDocuploadVm.validation();
                });
				console.log("xcDocuploadVm.documentUploadDocument",xcDocuploadVm.documentUploadDocument)
			}

			xcDocuploadVm.commanAddFile = function (blob, value, data, typecheck) {
				var imageName = "";
				var category = "";
				var sizeInMB = data.length

				if (utilityService.isIOSPlatform()) {
					if (value == "checkoffdoc") {
						var contentType = "application/pdf";
					} else {
						var block = data.split(";");
						var contentType = block[0].split(":")[1];
					}
				} else {
					var block = data.split(";");
					var contentType = block[0].split(":")[1];
				}

				var size = 0;
				
				if (sizeInMB < 3000000) {
					if (value == "profilephoto") {
						// console.log(data)
						imageName = "profilephoto" + '.' + typecheck;
						category = "KYC Documents";
						xcDocuploadVm.profilePhoto = "profilephoto" + '.' + typecheck;
						xcDocuploadVm.profilePhotoSize = (blob.size/1024).toFixed(2);
						size = (blob.size/1024).toFixed(2);
					} else if (value == "salaryslip1") {
						imageName = "salaryslip1" + '.' + typecheck;
						category = "Income proofs";
						xcDocuploadVm.salarySlip1 = "salaryslip1" + '.' + typecheck;
						xcDocuploadVm.salarySlip1Size = (blob.size/1024).toFixed(2);
						size = (blob.size/1024).toFixed(2);
					} else if (value == "salaryslip2") {
						imageName = "salaryslip2" + '.' + typecheck;
						category = "Income proofs";
						xcDocuploadVm.salarySlip2 = "salaryslip2" + '.' + typecheck;
						xcDocuploadVm.salarySlip2Size = (blob.size/1024).toFixed(2);
						size = (blob.size/1024).toFixed(2);
					} else if (value == "salaryslip3") {
						imageName = "salaryslip3" + '.' + typecheck;
						category = "Income proofs";
						xcDocuploadVm.salarySlip3 = "salaryslip3" + '.' + typecheck;
						xcDocuploadVm.salarySlip3Size = (blob.size/1024).toFixed(2);
						size = (blob.size/1024).toFixed(2);
					} else if (value == "pancard") {
						imageName = "pancard" + '.' + typecheck;
						category = "KYC Documents";
						xcDocuploadVm.panCard = "pancard" + '.' + typecheck;
						xcDocuploadVm.panCardSize = (blob.size/1024).toFixed(2);
						size = (blob.size/1024).toFixed(2);
					} else if (value == "officialDoc1") {
						imageName = "officialDoc1" + '.' + typecheck;
						category = "KYC Documents";
						xcDocuploadVm.officialDoc1Val = "officialDoc1" + '.' + typecheck;
						xcDocuploadVm.officialDoc1Size = (blob.size/1024).toFixed(2);
						size = (blob.size/1024).toFixed(2);
						xpressCreditService.isDocument1Changed = false;
					} else if (value == "officialDoc2") {
						imageName = "officialDoc2" + '.' + typecheck;
						category = "KYC Documents";
						xcDocuploadVm.officialDoc2Val = "officialDoc2" + '.' + typecheck;
						xcDocuploadVm.officialDoc2Size = (blob.size/1024).toFixed(2);
						size = (blob.size/1024).toFixed(2);
						xpressCreditService.isDocument2Changed = false;
					} else if (value == "checkoffdoc") {
						imageName = "checkoffdoc" + '.pdf';
						category = "KYC Documents";
						xcDocuploadVm.checkOffDoc = "checkoffdoc" + '.' + typecheck;
						xcDocuploadVm.checkOffDocSize = (blob.size/1024).toFixed(2);
						size = (blob.size/1024).toFixed(2);
					}

					xcDocuploadVm.profileImageUrl = data;
					xcDocuploadVm.filename = imageName;

					xcDocuploadVm.upDateProfile(xcDocuploadVm.profileImageUrl,xcDocuploadVm.filename,value,size,category,contentType, typecheck); 
				} else {
					if (type == "profilephoto") {
						
						xcDocuploadVm.profilePhoto = "";
						xcDocuploadVm.profilePhotoSize = "";
						
					} else if (type == "salaryslip1") {
						
						xcDocuploadVm.salarySlip1 = "";
						xcDocuploadVm.salarySlip1Size = "";
						
					} else if (type == "salaryslip2") {
						
						xcDocuploadVm.salarySlip2 = "";
						xcDocuploadVm.salarySlip2Size = "";
						
					} else if (type == "salaryslip3") {
						
						xcDocuploadVm.salarySlip3 = "";
						xcDocuploadVm.salarySlip3Size = "";
						
					} else if (type == "pancard") {
						
						xcDocuploadVm.panCard = "";
						xcDocuploadVm.panCardSize = "";
						
					} else if (type == "officialDoc1") {
						
						xcDocuploadVm.officialDoc1Val = "";
						xcDocuploadVm.officialDoc1Size = "";
						
					} else if (type == "officialDoc2") {
						
						xcDocuploadVm.officialDoc2Val = "";
						xcDocuploadVm.officialDoc2Size = "";
						
					} else if (type == "checkoffdoc") {
						
						xcDocuploadVm.checkOffDoc = "";
						xcDocuploadVm.checkOffDocSize = "";
						
					}
					var template = "Please upload File with size less than 3MB."
					$ionicPopup.show({
						title: '',
						template: template,
						scope: $scope,
						cssClass: 'my-custom-popup',
						buttons: [{
							text: 'OK',
							type: 'button-assertive',
							onTap: function () {
								$state.go('menu.xcDocupload');
							}
						}],
					});
				}

				xcDocuploadVm.validation();
			}

			xcDocuploadVm.validation = function() {
				if (xcDocuploadVm.profilePhoto && xcDocuploadVm.salarySlip1 && xcDocuploadVm.salarySlip2 && xcDocuploadVm.salarySlip3) {
					// if (xpressCreditService.createXcData.isCheckOff == "true" || xpressCreditService.createXcData.isPANAvail == "N" 
					// 	|| xpressCreditService.createXcData.updateAccDocType != "") {

						if (xpressCreditService.createXcData.updateAccDocType != "" && xpressCreditService.createXcData.updateAccDocType != null) {
							if (xcDocuploadVm.officialDoc1Val && xcDocuploadVm.officialDoc2Val) {
								xcDocuploadVm.disabledNext = false;

							} else {
								xcDocuploadVm.disabledNext = true;
								return;
							}

						} else {
							xcDocuploadVm.disabledNext = false;
						}

						if (xpressCreditService.createXcData.isPANAvail == "N") {
							if (xcDocuploadVm.panCard) {
								xcDocuploadVm.disabledNext = false;
							} else {
								xcDocuploadVm.disabledNext = true;
								return;
							}
						} else {
							if (!(customerInfoService.customer.isPanAvailable == "" || customerInfoService.customer.isPanAvailable == null || xpressCreditService.createXcData.isKycUser == "N" || xpressCreditService.createXcData.isPanReq == "Y")) {
								xcDocuploadVm.disabledNext = false;
							}
							else{
								if (xcDocuploadVm.panCard) {
								xcDocuploadVm.disabledNext = false;
							} else {
								xcDocuploadVm.disabledNext = true;
								return;
							}
							}
							//xcDocuploadVm.disabledNext = false;
							
						}
						
						if (xpressCreditService.createXcData.isCheckOff == "true") { 
							if (xcDocuploadVm.checkOffDoc) {
								xcDocuploadVm.disabledNext = false;
							} else {
								xcDocuploadVm.disabledNext = true;
								return;
							}
						} else {
							xcDocuploadVm.disabledNext = false;
						}


					// } else {
					// 	xcDocuploadVm.disabledNext = false;
					// }
					// xcDocuploadVm.disabledNext = false;
				} else {
					xcDocuploadVm.disabledNext = true;
					return;
				}
			}

			xcDocuploadVm.cameraClick = function (value) {
				xpressCreditService.getnewImage().then(function(data) {
					var blob = new Blob([data], {type: 'image/jpeg'});
					var typecheck = data.substring(data.indexOf('/') + 1, data.indexOf(';base64'));

					if (typecheck == "png" || typecheck == "jpg" || typecheck == "jpeg" || typecheck == "pdf" || typecheck == "gif") {
						xcDocuploadVm.commanAddFile(blob, value, data, typecheck)
					}  else {
						if (type == "profilephoto") {
						
						xcDocuploadVm.profilePhoto = "";
						xcDocuploadVm.profilePhotoSize = "";
						
					} else if (type == "salaryslip1") {
						
						xcDocuploadVm.salarySlip1 = "";
						xcDocuploadVm.salarySlip1Size = "";
						
					} else if (type == "salaryslip2") {
						
						xcDocuploadVm.salarySlip2 = "";
						xcDocuploadVm.salarySlip2Size = "";
						
					} else if (type == "salaryslip3") {
						
						xcDocuploadVm.salarySlip3 = "";
						xcDocuploadVm.salarySlip3Size = "";
						
					} else if (type == "pancard") {
						
						xcDocuploadVm.panCard = "";
						xcDocuploadVm.panCardSize = "";
						
					} else if (type == "officialDoc1") {
						
						xcDocuploadVm.officialDoc1Val = "";
						xcDocuploadVm.officialDoc1Size = "";
						
					} else if (type == "officialDoc2") {
						
						xcDocuploadVm.officialDoc2Val = "";
						xcDocuploadVm.officialDoc2Size = "";
						
					} else if (type == "checkoffdoc") {
						
						xcDocuploadVm.checkOffDoc = "";
						xcDocuploadVm.checkOffDocSize = "";
						
					}
						var template = "Upload documents can be pdf, jpeg, png, gif format only."
						$ionicPopup.show({
							title: '',
							template: template,
							scope: $scope,
							cssClass: 'my-custom-popup',
							buttons: [{
								text: 'OK',
								type: 'button-assertive',
								onTap: function () {
									$state.go('menu.xcDocupload');
								}
							}],
						});
					}	

				}, function(error) {
					xcDocuploadVm.imageSizeError=false;
				});	
			}

			xcDocuploadVm.selectFromGallery = function(value) {
				xpressCreditService.getImageFromGallery().then(function(data) {
					var blob = new Blob([data], {type: 'image/jpeg'});
					var typecheck = data.substring(data.indexOf('/') + 1, data.indexOf(';base64'));

					if (typecheck == "png" || typecheck == "jpg" || typecheck == "jpeg" || typecheck == "pdf" || typecheck == "gif") {
						xcDocuploadVm.commanAddFile(blob, value, data, typecheck) 
					} else {
						if (type == "profilephoto") {
						
						xcDocuploadVm.profilePhoto = "";
						xcDocuploadVm.profilePhotoSize = "";
						
					} else if (type == "salaryslip1") {
						
						xcDocuploadVm.salarySlip1 = "";
						xcDocuploadVm.salarySlip1Size = "";
						
					} else if (type == "salaryslip2") {
						
						xcDocuploadVm.salarySlip2 = "";
						xcDocuploadVm.salarySlip2Size = "";
						
					} else if (type == "salaryslip3") {
						
						xcDocuploadVm.salarySlip3 = "";
						xcDocuploadVm.salarySlip3Size = "";
						
					} else if (type == "pancard") {
						
						xcDocuploadVm.panCard = "";
						xcDocuploadVm.panCardSize = "";
						
					} else if (type == "officialDoc1") {
						
						xcDocuploadVm.officialDoc1Val = "";
						xcDocuploadVm.officialDoc1Size = "";
						
					} else if (type == "officialDoc2") {
						
						xcDocuploadVm.officialDoc2Val = "";
						xcDocuploadVm.officialDoc2Size = "";
						
					} else if (type == "checkoffdoc") {
						
						xcDocuploadVm.checkOffDoc = "";
						xcDocuploadVm.checkOffDocSize = "";
						
					}
						var template = "Upload documents can be pdf, jpeg, png, gif format only."
						$ionicPopup.show({
							title: '',
							template: template,
							scope: $scope,
							cssClass: 'my-custom-popup',
							buttons: [{
								text: 'OK',
								type: 'button-assertive',
								onTap: function () {
									$state.go('menu.xcDocupload');
								}
							}],
						});
					}
				
				}, function(error) { xcDocuploadVm.imageSizeError=false; });	
			}

			xcDocuploadVm.removeDocument = function(type) {
				var docType = [];
				docType = {"uploadDoc": [{"docType": type}]};
				xpressCreditService.deleteDocument(docType).then(function() {

				if (type == "profilephoto") {
					xcDocuploadVm.profilePhoto = "";
					xcDocuploadVm.profilePhotoSize = "";
				} else if (type == "salaryslip1") {
					xcDocuploadVm.salarySlip1 = "";
					xcDocuploadVm.salarySlip1Size = "";
				} else if (type == "salaryslip2") {
					xcDocuploadVm.salarySlip2 = "";
					xcDocuploadVm.salarySlip2Size = "";
				} else if (type == "salaryslip3") {
					xcDocuploadVm.salarySlip3 = "";
					xcDocuploadVm.salarySlip3Size = "";
				} else if (type == "pancard") {
					xcDocuploadVm.panCard = "";
					xcDocuploadVm.panCardSize = "";
				} else if (type == "officialDoc1") {
					xcDocuploadVm.officialDoc1Val = "";
					xcDocuploadVm.officialDoc1Size = "";
				} else if (type == "officialDoc2") {
					xcDocuploadVm.officialDoc2Val = "";
					xcDocuploadVm.officialDoc2Size = "";
				} else if (type == "checkoffdoc") {
					xcDocuploadVm.checkOffDoc = "";
					xcDocuploadVm.checkOffDocSize = "";
				}

				for (var i=0; i < xcDocuploadVm.documentUploadDocument.length; i++) {
					console.log(xcDocuploadVm.documentUploadDocument[i].docType,type)
					if (xcDocuploadVm.documentUploadDocument[i].docType == type) {
						console.log("inside")
						xcDocuploadVm.documentUploadDocument.splice(i,1);
					}
				}

				xcDocuploadVm.validation();
			}, 
			function(error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
			}

			xcDocuploadVm.goToCancel = function () {
				$state.go('menu.xcLoancalculator');
			}

			xcDocuploadVm.goToConfirm = function () {
				xpressCreditService.isDocument1Changed = false;
				xpressCreditService.isDocument1Changed = false;
				$state.go('menu.xcBranchselect');
				// xpressCreditService.createXcData.uploadDoc = xcDocuploadVm.documentUploadDocument;
				// var obj = {
				// 	"pageName": "uploadDocument",
				// 	"progress": "80%",
				// 	"yonoRefNo": "",
				// 	"uploadDoc": xcDocuploadVm.documentUploadDocument
				// }

				// // xpressCreditService.OmniCallResponse(obj).then(function(data) {
				// xpressCreditService.uploadDocService(obj).then(function(data) {
    //                 console.log("uploadDocService",obj,data)
				// 	$state.go('menu.xcBranchselect');
    //             },function(error) {
    //                 utilityService.showErrorMessage(error.responseMessage);
    //             });	
			}

			$scope.$on('$ionicView.loaded', function () {
				initPage();

			});

			$scope.$on('$ionicView.beforeEnter', function () {
				if (xpressCreditService.createXcData.uploadDoc) {
					xcDocuploadVm.documentUploadDocument = xpressCreditService.createXcData.uploadDoc;
					var myArray = xpressCreditService.createXcData.uploadDoc;
					for (var i=0; i < myArray.length; i++) {
				        if (myArray[i].docType == "profilephoto") {
				            xcDocuploadVm.profilePhoto = myArray[i].docName;
				            xcDocuploadVm.profilePhotoSize = myArray[i].docSize;
				        }

				        if (myArray[i].docType == "salaryslip1") {
				            xcDocuploadVm.salarySlip1 = myArray[i].docName;
				            xcDocuploadVm.salarySlip1Size = myArray[i].docSize;
				        }

				        if (myArray[i].docType == "salaryslip2") {
				            xcDocuploadVm.salarySlip2 = myArray[i].docName;
				            xcDocuploadVm.salarySlip2Size = myArray[i].docSize;
				        }

				        if (myArray[i].docType == "salaryslip3") {
				            xcDocuploadVm.salarySlip3 = myArray[i].docName;
				            xcDocuploadVm.salarySlip3Size = myArray[i].docSize;
				        }

				        if (myArray[i].docType == "pancard") {
				            xcDocuploadVm.panCard = myArray[i].docName;
				            xcDocuploadVm.panCardSize = myArray[i].docSize;
				        }

				        if (myArray[i].docType == "officialDoc1") {

							if(xpressCreditService.isDocument1Changed)
							{
								xcDocuploadVm.officialDoc1Val = "";
							    xcDocuploadVm.officialDoc1Size = "";
								xcDocuploadVm.disabledNext = true;
							}
							else
							{
					           
					        		xcDocuploadVm.officialDoc1Val = myArray[i].docName;
					            	xcDocuploadVm.officialDoc1Size = myArray[i].docSize;
					        	
				        	}
				        }

				        if (myArray[i].docType == "officialDoc2") {
				        	if(xpressCreditService.isDocument2Changed)
							{
								xcDocuploadVm.officialDoc2Val = "";
				            	xcDocuploadVm.officialDoc2Size = "";
				            	xcDocuploadVm.disabledNext = true;
							}
							else{
					            
					            	xcDocuploadVm.officialDoc2Val = myArray[i].docName;
					            	xcDocuploadVm.officialDoc2Size = myArray[i].docSize;
					        	
				        	}
				        }

				        if (myArray[i].docType == "checkoffdoc") {
				            xcDocuploadVm.checkOffDoc = myArray[i].docName;
				            xcDocuploadVm.checkOffDocSize = myArray[i].docSize;
				        }
				        //xcDocuploadVm.validation();
				    }
				}

				xcDocuploadVm.validation();
			});

			return this;
		}
]);


