'use strict';
angularApp.controller('xcKnowmoreController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"xpressCreditService",
		"customerInfoService",
		"homeScreenService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, xpressCreditService, customerInfoService, homeScreenService) {
			
			var xcKnowmoreVm = this;
			
			function initPage() {
                var amount = 0;
                if (xpressCreditService.statusXc) {
                	xcKnowmoreVm.buttonVisible = true;
                } else {
                	xcKnowmoreVm.buttonVisible = false;
                }

				if (xpressCreditService.statusXc == "0") {
                    xcKnowmoreVm.buttonText = "Apply Now";
                } else if (xpressCreditService.statusXc == "1") {
                    xcKnowmoreVm.buttonText = " Check Status ";
                } else if (xpressCreditService.statusXc == "2") {
                    xcKnowmoreVm.buttonText = " Retrieve ";
                }
				xcKnowmoreVm.eligibilty = xpressCreditService.knowMoreData.eligibilty; 
				xcKnowmoreVm.features = xpressCreditService.knowMoreData.features; 
				xcKnowmoreVm.documentation = xpressCreditService.knowMoreData.documentation; 
				xcKnowmoreVm.interest = xpressCreditService.knowMoreData.interest; 
		        xcKnowmoreVm.minTenure = xpressCreditService.knowMoreData.loanDetails.minimumTenure;
		        xcKnowmoreVm.maxTenure = xpressCreditService.knowMoreData.loanDetails.maximumTenure;
		        xcKnowmoreVm.minAmount = xpressCreditService.knowMoreData.loanDetails.minimumLoanAmount;
		        xcKnowmoreVm.maxAmount = xpressCreditService.knowMoreData.loanDetails.maximumLoanAmount;
		        xcKnowmoreVm.interestRate = xpressCreditService.knowMoreData.loanDetails.rate;
		        xcKnowmoreVm.emiValue = xpressCreditService.knowMoreData.loanDetails.emiCalculator;

		        xcKnowmoreVm.amountLoanValue =  xpressCreditService.knowMoreData.loanDetails.maximumLoanAmount;
		        xcKnowmoreVm.durationLoanValue = xpressCreditService.knowMoreData.loanDetails.maximumTenure;

		        xcKnowmoreVm.lookFor = {
	                value: parseInt(xpressCreditService.knowMoreData.loanDetails.maximumLoanAmount),
	                options: {
	                    ceil: parseInt(xcKnowmoreVm.maxAmount),
	                    floor: parseInt(xcKnowmoreVm.minAmount),
	                    showSelectionBar: true,
	                    step: 1000,
	                    onChange: xcKnowmoreVm.onChangeRangeAmount,
	                    translate: function(value) {
	                    	xcKnowmoreVm.amountLoanValue = value;

	                        if (!xcKnowmoreVm.emiValue) {
	                    		var exponent = parseInt(xcKnowmoreVm.durationLoanValue);
								var rateOfInterest = xcKnowmoreVm.interestRate;
								var r = ((rateOfInterest/100.0)/12.0);
								var exponentValue = Math.pow(1+r, exponent);

								xcKnowmoreVm.emiValue = (parseInt(xpressCreditService.knowMoreData.loanDetails.maximumLoanAmount) *(r*exponentValue)/(exponentValue-1)).toFixed(2);
								xpressCreditService.knowMoreData.loanDetails.emiCalculator = xcKnowmoreVm.emiValue;
	                    	}

							xpressCreditService.knowMoreData.loanDetails.maximumLoanAmount = value;
	                    	xcKnowmoreVm.amountLoanValue = parseInt(xpressCreditService.knowMoreData.loanDetails.maximumLoanAmount);
	                    	amount = value;
	                    	xcKnowmoreVm.processingFee = parseInt(parseInt(amount) * parseInt(xpressCreditService.knowMoreData.loanDetails.processingfeesPercentage) / 100);
		                    
		                    return '&#8377;' + value;
	                    }
	                }
	            };

	            xcKnowmoreVm.lookForDuration = {
	                value: parseInt(xpressCreditService.knowMoreData.loanDetails.maximumTenure),
	                options: {
	                    ceil: parseInt(xcKnowmoreVm.maxTenure),
	                    floor: parseInt(xcKnowmoreVm.minTenure),
	                    showSelectionBar: true,
	                    step: 1,
	                    onChange: xcKnowmoreVm.onChangeRangeAmount,
	                    translate: function(value) {
	                    	xcKnowmoreVm.durationLoanValue = value;

		                    return value + 'M';
	                    }
	                }
	            };
			};

			xcKnowmoreVm.onChangeRangeAmount = function () {
				var exponent = parseInt(xcKnowmoreVm.durationLoanValue);
				var rateOfInterest = xcKnowmoreVm.interestRate;
				var r = ((rateOfInterest/100.0)/12.0);
				var exponentValue = Math.pow(1+r, exponent);

				xcKnowmoreVm.emiValue = (parseInt(xcKnowmoreVm.amountLoanValue) *(r*exponentValue)/(exponentValue-1)).toFixed(2);
				xpressCreditService.knowMoreData.loanDetails.emiCalculator = xcKnowmoreVm.emiValue;
				console.log(xcKnowmoreVm.amountLoanValue,parseInt(xcKnowmoreVm.amountLoanValue))
				// xcKnowmoreVm.processingFee = parseInt(parseInt(amount) * parseInt(xpressCreditService.createXcData.processingfeesPercentage) / 100);
			}

			xcKnowmoreVm.selTab = function(sel) {
	            xcKnowmoreVm.tab = sel;
	        }

	        xcKnowmoreVm.goToAO = function () {
				$state.go('menu.loans');
			}

			xcKnowmoreVm.goToConfirm = function() {
				if(!customerInfoService.customer.isPanAvailable)
                {
                    homeScreenService.getCustomerInfo().then(function (data) {
                        getAccountDetailsService.accountOverviewData = data;
                        customerInfoService.customer.name = data.customerInformation.customerName;
                        customerInfoService.customer.type = data.customerInformation.customerType;
                        customerInfoService.customer.DOB = data.customerInformation.dob;
                        customerInfoService.customer.isPanAvailable = data.customerInformation.panNumber;
                        customerInfoService.customer.isStaffFlag = data.customerInformation.isStaffFlag;
                        customerInfoService.customer.emailID = data.customerInformation.emailID;
                        customerInfoService.customer.mobile = data.customerInformation.mobile;
                        customerInfoService.customer.title = data.customerInformation.title;
                        customerInfoService.customer.residentialStatus = data.customerInformation.residentialStatus;
                    },
                    function (error) {
                    
                });
                }
				if (xpressCreditService.statusXc == "0") {
                    xpressCreditService.getXpressMaster().then(function(data) {
                        console.log("getXpressMaster", data)
                        xpressCreditService.loanDataFetch(data, xpressCreditService.statusXc);
                        $state.go('menu.xcCreate');
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                } else if (xpressCreditService.statusXc == "1") {
                	xpressCreditService.getXpressCreditDetails().then(function(data) {
                        console.log("getXpressCreditDetails", data)
                        xpressCreditService.checkStatusData.loanAmount = data.loanAmount;
                        xpressCreditService.checkStatusData.referenceNumber = data.refnoLos;
                        xpressCreditService.checkStatusData.status = data.activityValue;
                        xpressCreditService.checkStatusData.date = data.date;
                        $state.go('menu.xcSanctionapp');
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                } else if (xpressCreditService.statusXc == "2") {
                    xpressCreditService.retrieveApplication().then(function(data) {
                        console.log("retrieveApplication", data)
                        xpressCreditService.loanDataFetch(data, xpressCreditService.statusXc);

                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }
				
			}

			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
			});

			return this;
		}
]);


