'use strict';
angularApp.controller('xcLoancalculatorController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"xpressCreditService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, xpressCreditService) {
			
			var xcLoancalculatorVm = this;
			
			function initPage() {

				if (xpressCreditService.createXcData.gstPercentage) {
	  				xcLoancalculatorVm.processingfeesPercentage = xpressCreditService.createXcData.gstPercentage;
				} else {
	  				xcLoancalculatorVm.processingfeesPercentage = 0;
				}

				if (xpressCreditService.createXcData.processingfees) {
	  				xcLoancalculatorVm.processingFees = xpressCreditService.createXcData.processingfees;
				} else {
	  				xcLoancalculatorVm.processingFees = 0;
				}

		        xcLoancalculatorVm.minTenure = xpressCreditService.createXcData.minimumLoanTenure;
		        xcLoancalculatorVm.maxTenure = xpressCreditService.createXcData.maximumLoanTenure;

		        if (xpressCreditService.createXcData.minimumLoanAmount) {
		        	xcLoancalculatorVm.minAmount = xpressCreditService.createXcData.minimumLoanAmount;
		        } else {
		        	xcLoancalculatorVm.minAmount = 0;
		        }

		        if (xpressCreditService.createXcData.maximumLoanAmount) {
		        	xcLoancalculatorVm.maxAmount = xpressCreditService.createXcData.maximumLoanAmount;
		        } else {
		        	xcLoancalculatorVm.maxAmount = 0;
		        }

		        xcLoancalculatorVm.interestRate = xpressCreditService.createXcData.rateCalculator;

		        if (xpressCreditService.createXcData.emiCalculator) {
		        	xcLoancalculatorVm.emiValue = Math.round(xpressCreditService.createXcData.emiCalculator);
		        	// xcLoancalculatorVm.emiMaxValue = Math.round(xpressCreditService.createXcData.emiCalculator);
		        	if (xpressCreditService.createXcData.productDetails.length == 1) {
			        	xcLoancalculatorVm.emiMaxValue = Math.round(xpressCreditService.createXcData.productDetails[0].emi);
			        } else {
			        	if (xpressCreditService.createXcData.loanOfferSelected == "overdraft") {
			        		xcLoancalculatorVm.emiMaxValue = Math.round(xpressCreditService.createXcData.productDetails[0].emi);
			        	} else {
			        		xcLoancalculatorVm.emiMaxValue = Math.round(xpressCreditService.createXcData.productDetails[1].emi);
			        	}
			        }
		        } else {
		        	xcLoancalculatorVm.emiValue = 0;
		        	xcLoancalculatorVm.emiMaxValue = 0;
		        }

		        xcLoancalculatorVm.amountLoanValue =  xpressCreditService.createXcData.selectedLoanAmout;
		        xcLoancalculatorVm.durationLoanValue = xpressCreditService.createXcData.selectedTenure;

		        if (xpressCreditService.createXcData.loanOfferSelected == "overdraft") {
		        	xcLoancalculatorVm.loanType = "Overdraft";
		        } else {
		        	xcLoancalculatorVm.loanType = "Term Loan";
		        }
		        
				xcLoancalculatorVm.lookFor = {
	                value: parseInt(xpressCreditService.createXcData.selectedLoanAmout),
	                options: {  
	                    ceil: parseInt(xcLoancalculatorVm.maxAmount),
	                    floor: parseInt(xcLoancalculatorVm.minAmount),
	                    showSelectionBar: true,
	                    step: 1000,
	                    onChange: xcLoancalculatorVm.onChangeRangeAmount,
	                    translate: function(value) {
	                    	xcLoancalculatorVm.amountLoanValue = value;

	                        if (!xcLoancalculatorVm.emiValue) {
	                    		var exponent = parseInt(xcLoancalculatorVm.durationLoanValue);
								var rateOfInterest = xcLoancalculatorVm.interestRate;
								var r = ((rateOfInterest/100.0)/12.0);
								var exponentValue = Math.pow(1+r, exponent);

								xcLoancalculatorVm.emiValue = Math.round(parseInt(xpressCreditService.createXcData.selectedLoanAmout) *(r*exponentValue)/(exponentValue-1));
								console.log(xcLoancalculatorVm.emiValue,xcLoancalculatorVm.emiMaxValue);
								// xcLoancalculatorVm.emiMaxValue = Math.round(parseInt(xpressCreditService.createXcData.selectedLoanAmout) *(r*exponentValue)/(exponentValue-1));
								xpressCreditService.createXcData.emiCalculator = xcLoancalculatorVm.emiValue;
	                    	}

							xpressCreditService.createXcData.selectedLoanAmout = value;
	                    	xcLoancalculatorVm.amountLoanValue = parseInt(xpressCreditService.createXcData.selectedLoanAmout);

	                    	xcLoancalculatorVm.processingFees = parseInt(parseInt(xcLoancalculatorVm.amountLoanValue) * parseInt(xpressCreditService.createXcData.processingfeesPercentage) / 100);

		                    return '&#8377;' + value;
	                    }
	                }
	            };

	            xcLoancalculatorVm.lookForDuration = {
	                value: parseInt(xpressCreditService.createXcData.selectedTenure),
	                options: {
	                    ceil: parseInt(xcLoancalculatorVm.maxTenure),
	                    floor: parseInt(xcLoancalculatorVm.minTenure),
	                    showSelectionBar: true,
	                    step: 1,
	                    onChange: xcLoancalculatorVm.onChangeRangeAmount,
	                    translate: function(value) {
	                    	xcLoancalculatorVm.durationLoanValue = value;

		                    return value + 'mths.';
	                    }
	                }
	            };
			};

			xcLoancalculatorVm.onChangeRangeAmount = function () {
				var exponent = parseInt(xcLoancalculatorVm.durationLoanValue);
				var rateOfInterest = xcLoancalculatorVm.interestRate;
				var r = ((rateOfInterest/100.0)/12.0);
				var exponentValue = Math.pow(1+r, exponent);

				xcLoancalculatorVm.emiValue = Math.round(parseInt(xpressCreditService.createXcData.selectedLoanAmout) *(r*exponentValue)/(exponentValue-1));
				console.log(xcLoancalculatorVm.emiValue,xcLoancalculatorVm.emiMaxValue);
				// xcLoancalculatorVm.emiMaxValue = Math.round(parseInt(xpressCreditService.createXcData.selectedLoanAmout) *(r*exponentValue)/(exponentValue-1));
				xpressCreditService.createXcData.emiCalculator = xcLoancalculatorVm.emiValue;

				xcLoancalculatorVm.processingFees = parseInt(parseInt(xcLoancalculatorVm.amountLoanValue) * parseInt(xpressCreditService.createXcData.processingfeesPercentage) / 100);
			}


			xcLoancalculatorVm.goToAO = function () {
				xpressCreditService.initialValueStage();
				$state.go('menu.loans');
			}

			xcLoancalculatorVm.goToCancel = function () {
				$state.go('menu.xcLoanoffer');
			}

			xcLoancalculatorVm.goToConfirm = function () {
				xpressCreditService.createXcData.gstPercentage = xcLoancalculatorVm.processingfeesPercentage;
				xpressCreditService.createXcData.processingfees = xcLoancalculatorVm.processingFees;
				xpressCreditService.createXcData.maximumLoanProcessingFees = xcLoancalculatorVm.maximumLoanProcessingFees;
		        xpressCreditService.createXcData.minimumLoanTenure = xcLoancalculatorVm.minTenure;
		        xpressCreditService.createXcData.maximumLoanTenure = xcLoancalculatorVm.maxTenure;
		        xpressCreditService.createXcData.minimumLoanAmount = xcLoancalculatorVm.minAmount;
		        xpressCreditService.createXcData.maximumLoanAmount = xcLoancalculatorVm.maxAmount;
		        xpressCreditService.createXcData.rateCalculator = xcLoancalculatorVm.interestRate;
		        xpressCreditService.createXcData.emiCalculator = xcLoancalculatorVm.emiValue;

		        xpressCreditService.createXcData.selectedLoanAmout = xcLoancalculatorVm.amountLoanValue;
		        xpressCreditService.createXcData.selectedTenure = xcLoancalculatorVm.durationLoanValue;

				var obj = {
					"pageName": "loanCalculator",
					"progress": "70%",
					"yonoRefNo": "",
				  	"loanCalMinAmount" : Number(xcLoancalculatorVm.minAmount),
					"loanCalMaxAmount" : Number(xcLoancalculatorVm.maxAmount),
					"loanCalMinTenure" : xcLoancalculatorVm.minTenure,
					"loanCalMaxTenure" : xcLoancalculatorVm.maxTenure,
					"loanCalProcessingFee" : Number(xcLoancalculatorVm.processingFees),
					"loanCalInterest" : xcLoancalculatorVm.interestRate,
					"loanCalEmiAmount" : Number(xcLoancalculatorVm.emiValue),
					"loanCalAmount" : Number(xcLoancalculatorVm.amountLoanValue),
					"loanCalDuration" : xcLoancalculatorVm.durationLoanValue,
					"gstPercentage" : xcLoancalculatorVm.processingfeesPercentage,
					"processingFeesPercentage" : xpressCreditService.createXcData.processingfeesPercentage
				}

				xpressCreditService.OmniCallResponse(obj).then(function(data) {
                    console.log("OmniCallResponse",obj,data)
                    // xpressCreditService.createXcData.eligibilityEmiFlag = data.cirResultflag;
					$state.go('menu.xcDocupload');
                },function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });		
				
			}

			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				if (xpressCreditService.createXcData.gstPercentage) {
	  				xcLoancalculatorVm.processingfeesPercentage = xpressCreditService.createXcData.gstPercentage;
				} else {
	  				xcLoancalculatorVm.processingfeesPercentage = 0;
				}

				if (xpressCreditService.createXcData.processingfees) {
	  				xcLoancalculatorVm.processingFees = xpressCreditService.createXcData.processingfees;
				} else {
	  				xcLoancalculatorVm.processingFees = 0;
				}

		        xcLoancalculatorVm.minTenure = xpressCreditService.createXcData.minimumLoanTenure;
		        xcLoancalculatorVm.maxTenure = xpressCreditService.createXcData.maximumLoanTenure;

		        if (xpressCreditService.createXcData.minimumLoanAmount) {
		        	xcLoancalculatorVm.minAmount = xpressCreditService.createXcData.minimumLoanAmount;
		        } else {
		        	xcLoancalculatorVm.minAmount = 0;
		        }

		        if (xpressCreditService.createXcData.maximumLoanAmount) {
		        	xcLoancalculatorVm.maxAmount = xpressCreditService.createXcData.maximumLoanAmount;
		        } else {
		        	xcLoancalculatorVm.maxAmount = 0;
		        }

		        xcLoancalculatorVm.interestRate = xpressCreditService.createXcData.rateCalculator;

		        if (xpressCreditService.createXcData.emiCalculator) {
		        	xcLoancalculatorVm.emiValue = Math.round(xpressCreditService.createXcData.emiCalculator);
		        	if (xpressCreditService.createXcData.productDetails.length == 1) {
			        	xcLoancalculatorVm.emiMaxValue = Math.round(xpressCreditService.createXcData.productDetails[0].emi);
			        } else {
			        	if (xpressCreditService.createXcData.loanOfferSelected == "overdraft") {
			        		xcLoancalculatorVm.emiMaxValue = Math.round(xpressCreditService.createXcData.productDetails[0].emi);
			        	} else {
			        		xcLoancalculatorVm.emiMaxValue = Math.round(xpressCreditService.createXcData.productDetails[1].emi);
			        	}
			        }
		        } else {
		        	xcLoancalculatorVm.emiValue = 0;
		        	xcLoancalculatorVm.emiMaxValue = 0;
		        }

		        xcLoancalculatorVm.amountLoanValue = xpressCreditService.createXcData.selectedLoanAmout;
		        xcLoancalculatorVm.durationLoanValue = xpressCreditService.createXcData.selectedTenure;
			});

			return this;
		}
]);


