'use strict';
angularApp.controller('xcPanupdateController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"xpressCreditService",
		"customerInfoService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, xpressCreditService, customerInfoService) {
			
			var xcPanupdateVm = this;
			
			function initPage() {
				xcPanupdateVm.disabledNext = true;
				xcPanupdateVm.panvalidationError = false;

				xcPanupdateVm.pandnumber = customerInfoService.isPanAvailable;
			};

			xcPanupdateVm.goToAO = function () {
				$state.go('menu.loans');
			}

			xcPanupdateVm.panValidation = function () {
				var regpan = /^([a-zA-Z]){5}([0-9]){4}([a-zA-Z]){1}?$/;

				if (xcPanupdateVm.pandnumber && xcPanupdateVm.pandnumber.length == 10 && regpan.test(xcPanupdateVm.pandnumber)) {
					xcPanupdateVm.disabledNext = false;
				} else {
					xcPanupdateVm.disabledNext = true;
				}

				if(regpan.test(xcPanupdateVm.pandnumber)) {
				   xcPanupdateVm.panvalidationError = false;
				} else {
				   xcPanupdateVm.panvalidationError = true;
				}
			}

			xcPanupdateVm.goToCancel = function () {
				$state.go('menu.xcCheckoff');
			}

			xcPanupdateVm.goToConfirm = function () {
				xpressCreditService.createXcData.panNumber = xcPanupdateVm.pandnumber;
				xpressCreditService.createXcData.redirectFromPAN = true;

				var obj = {
					// "conditionBasedOmniCall" : {
						"pageName": "panDetails",
						"progress": "10%",
						"yonoRefNo": "",
						"panNo": xcPanupdateVm.pandnumber,
					// }
				}

				xpressCreditService.OmniCallResponse(obj).then(function(data) {
                    console.log("OmniCallResponse",obj,data)
					if (xpressCreditService.createXcData.isKycUser == "N") {
						$state.go('menu.xcUpdateaccount');
					} else {
						$state.go('menu.xcAddressDetails');
					}
                },function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });		
				
			}

			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				if (xpressCreditService.createXcData.panNumber) {
					xcPanupdateVm.pandnumber = xpressCreditService.createXcData.panNumber;
					xcPanupdateVm.panValidation();
				}
			});

			return this;
		}
]);


