'use strict';
angularApp.controller('xcWorkDetailsController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"xpressCreditService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, xpressCreditService) {
			
			var xcWorkDetailsVm = this;
			
			function initPage() {
				xcWorkDetailsVm.disabledNext = true;

				xcWorkDetailsVm.address1Err = false;
				xcWorkDetailsVm.address2Err = false;
				xcWorkDetailsVm.pincodeErr = false;
				xcWorkDetailsVm.cityErr = false;
				xcWorkDetailsVm.stateErr = false;
				xcWorkDetailsVm.districtErr = false;
				xcWorkDetailsVm.selectedsubdistrictValueErr = false;
				xcWorkDetailsVm.selectedvillageValueErr = false;
				xcWorkDetailsVm.officephnumberErr = false;
				xcWorkDetailsVm.remainserviceErr = false;
				xcWorkDetailsVm.remainserviceNotMore360Err = false;
				xcWorkDetailsVm.addressddoErr = false;
				xcWorkDetailsVm.designationddoErr = false;

				xcWorkDetailsVm.subDistDetails = xpressCreditService.subDistWorkArray;
				xcWorkDetailsVm.villageDetails = xpressCreditService.villageWorkArray;

				xcWorkDetailsVm.stateDetails = xpressCreditService.stateWorkArray;
				xcWorkDetailsVm.districtDetails = xpressCreditService.districtWorkArray;
				xcWorkDetailsVm.cityDetails = xpressCreditService.cityWorkArray;

				if (xpressCreditService.createXcData.organizationType) {
					var orgData = JSON.parse(xpressCreditService.createXcData.organizationType)
					var orgId = orgData.key;
					var orgText = orgData.value;

					if (orgId == "CPSU") {
						var psuStateNameData = JSON.parse(xpressCreditService.createXcData.psuStateName);
						xcWorkDetailsVm.organisationWork = psuStateNameData.value;
						xcWorkDetailsVm.organisationWorkShow = true;
					} else if (orgId == "EDNR") {
						var instituteNameData = JSON.parse(xpressCreditService.createXcData.instituteName);
						xcWorkDetailsVm.organisationWork = instituteNameData.value;
						xcWorkDetailsVm.organisationWorkShow = true;
					} else if (orgId == "RCOE") {
						var companyNameData = JSON.parse(xpressCreditService.createXcData.companyName);
						xcWorkDetailsVm.organisationWork = companyNameData.value;
						xcWorkDetailsVm.organisationWorkShow = true;
					} else {
						xcWorkDetailsVm.organisationWorkShow = false;
					}
				} else {
					xcWorkDetailsVm.organisationWorkShow = false;
				}
				
			};

			xcWorkDetailsVm.goToAO = function () {
				xpressCreditService.initialValueStage();
				$state.go('menu.loans');
			}

			xcWorkDetailsVm.validationAll = function () {
				if (xcWorkDetailsVm.address1 && xcWorkDetailsVm.address2 
					&& xcWorkDetailsVm.pincode && xcWorkDetailsVm.pincode.length == 6 &&  xcWorkDetailsVm.city && xcWorkDetailsVm.state
					&&  xcWorkDetailsVm.district && xcWorkDetailsVm.officephnumber 
					&& xcWorkDetailsVm.remainservice && xcWorkDetailsVm.addressddo 
					&& xcWorkDetailsVm.designationddo) {
					xcWorkDetailsVm.disabledNext = false;
				} else {
					xcWorkDetailsVm.disabledNext = true;
				}
			}

			xcWorkDetailsVm.validationField = function (type) {
				if (type == "address1") {
					if (xcWorkDetailsVm.address1) {
						xcWorkDetailsVm.address1Err = false;
					} else {
						xcWorkDetailsVm.address1Err = true;
					}
				}

				if (type == "address2") {
					if (xcWorkDetailsVm.address2) {
						xcWorkDetailsVm.address2Err = false;
					} else {
						xcWorkDetailsVm.address2Err = true;
					}
				}

				if (type == "pincode") {
					if (xcWorkDetailsVm.pincode && xcWorkDetailsVm.pincode.length == 6) {
						xcWorkDetailsVm.pincodeErr = false;
					} else {
						xcWorkDetailsVm.pincodeErr = true;
					}
				}

				if (type == "state") {
					if (xcWorkDetailsVm.state) {
						xcWorkDetailsVm.city = "";
						xcWorkDetailsVm.district = "";
						var statesObj = JSON.parse(xcWorkDetailsVm.state);
						var obj = {
							"key" : statesObj.key,
							"action" : "District"
						}
						xpressCreditService.getDistrictSubDistrict(obj).then(function(data) {
							console.log("statesObj",data)
							xcWorkDetailsVm.districtDetails = data.info;
							xpressCreditService.districtArray = xcWorkDetailsVm.districtDetails;
			            },function(error) {
			                console.log("error",error)
			                utilityService.showErrorMessage(error.responseMessage);
			            });
						xcWorkDetailsVm.stateErr = false;
					} else {
						xcWorkDetailsVm.stateErr = true;
					}
				}

				if (type == "district") {
					if (xcWorkDetailsVm.district) {
						xcWorkDetailsVm.city = "";
						var districtObj = JSON.parse(xcWorkDetailsVm.district);
						var obj = {
							"key" : districtObj.key,
							"action" : "SubDistrict"
						}
						xpressCreditService.getDistrictSubDistrict(obj).then(function(data) {
							console.log("districtObj",data)
							xcWorkDetailsVm.cityDetails = data.info;
							xpressCreditService.cityArray = xcWorkDetailsVm.cityDetails;
			            },function(error) {
			                console.log("error",error)
			                utilityService.showErrorMessage(error.responseMessage);
			            });

						xcWorkDetailsVm.districtErr = false;
					} else {
						xcWorkDetailsVm.districtErr = true;
					}
				}

				if (type == "city") {
					if (xcWorkDetailsVm.city) {
						xcWorkDetailsVm.cityErr = false;
					} else {
						xcWorkDetailsVm.cityErr = true;
					}
				}

				if (type == "officephnumber") {
					if (xcWorkDetailsVm.officephnumber) {
						xcWorkDetailsVm.officephnumberErr = false;
					} else {
						xcWorkDetailsVm.officephnumberErr = true;
					}
				}

				if (type == "remainservice") {
					if (xcWorkDetailsVm.remainservice) {
						// if (xcWorkDetailsVm.remainservice > 360) {
						// 	xcWorkDetailsVm.remainserviceNotMore360Err = true;
						// } else {
						// 	xcWorkDetailsVm.remainserviceNotMore360Err = false;
						// }
						xcWorkDetailsVm.remainserviceErr = false;
					} else {
						xcWorkDetailsVm.remainserviceErr = true;
					}
				}

				if (type == "addressddo") {
					if (xcWorkDetailsVm.addressddo) {
						xcWorkDetailsVm.addressddoErr = false;
					} else {
						xcWorkDetailsVm.addressddoErr = true;
					}
				}

				if (type == "designationddo") {
					if (xcWorkDetailsVm.designationddo) {
						xcWorkDetailsVm.designationddoErr = false;
					} else {
						xcWorkDetailsVm.designationddoErr = true;
					}
				}

				xcWorkDetailsVm.validationAll();
			}

			xcWorkDetailsVm.goToCancel = function () {
				$state.go('menu.xcAdditionalDetails');
			}

			xcWorkDetailsVm.getDistrict = function(){
				if (xcWorkDetailsVm.state) {
						var statesObj = JSON.parse(xcWorkDetailsVm.state);
						var obj = {
							"key" : statesObj.key,
							"action" : "District"
						}
						xpressCreditService.getDistrictSubDistrict(obj).then(function(data) {
							console.log("statesObj",data)
							xcWorkDetailsVm.districtDetails = data.info;
							xpressCreditService.districtArray = xcWorkDetailsVm.districtDetails;
							var districtObj = JSON.parse(xpressCreditService.createXcData.workAddress.districtText);
							var selected_district_key = districtObj.key;
							var selected_district = '';
							

							var isKeyExists = -1;
							xcWorkDetailsVm.districtDetails.some(function(obj, i) {
  return obj.key == selected_district_key ? isKeyExists = i : false;
});
							console.log(isKeyExists);
							if(isKeyExists !== -1)
							{
								//xcWorkDetailsVm.districtDetails.pop(xcWorkDetailsVm.districtDetails[isKeyExists]);
								xcWorkDetailsVm.districtDetails.splice(isKeyExists, 1);
							}
							xcWorkDetailsVm.districtDetails.push(districtObj);


							
						
			            },function(error) {
			                console.log("error",error)
			                utilityService.showErrorMessage(error.responseMessage);
			            });
						xcWorkDetailsVm.stateErr = false;
					} else {
						xcWorkDetailsVm.stateErr = true;
					}
			}

			xcWorkDetailsVm.getCity = function(){
				if (xcWorkDetailsVm.district) {
						var districtObj = JSON.parse(xcWorkDetailsVm.district);
						var obj = {
							"key" : districtObj.key,
							"action" : "SubDistrict"
						}
						xpressCreditService.getDistrictSubDistrict(obj).then(function(data) {
							console.log("districtObj",data)
							xcWorkDetailsVm.cityDetails = data.info;
							xpressCreditService.cityArray = xcWorkDetailsVm.cityDetails;

							var cityObj = JSON.parse(xpressCreditService.createXcData.workAddress.cityText);
							var selected_city_key = cityObj.key;
							var selected_city = '';
						

							var isKeyExists = -1;
							xcWorkDetailsVm.cityDetails.some(function(obj, i) {
  return obj.key == selected_city_key ? isKeyExists = i : false;
});
							console.log(isKeyExists);
							if(isKeyExists !== -1)
							{
								//xcWorkDetailsVm.districtDetails.pop(xcWorkDetailsVm.districtDetails[isKeyExists]);
								xcWorkDetailsVm.cityDetails.splice(isKeyExists, 1);
							}
							xcWorkDetailsVm.cityDetails.push(cityObj);
			            },function(error) {
			                console.log("error",error)
			                utilityService.showErrorMessage(error.responseMessage);
			            });

						xcWorkDetailsVm.districtErr = false;
					} else {
						xcWorkDetailsVm.districtErr = true;
					}
			}
			xcWorkDetailsVm.goToConfirm = function () {
				var statesData = "";
				var	statesId = "";
				var	statesText = "";

				var districtData = "";
				var	districtId = "";
				var	districtText = "";

				var cityData = "";
				var	cityId = "";
				var	cityText = "";

				xpressCreditService.createXcData.workAddress.addressLine1 = xcWorkDetailsVm.address1;
				xpressCreditService.createXcData.workAddress.addressLine2 = xcWorkDetailsVm.address2;
				xpressCreditService.createXcData.workAddress.pincode = xcWorkDetailsVm.pincode;	

				xpressCreditService.createXcData.workAddress.officeContactNo = xcWorkDetailsVm.officephnumber;				
				xpressCreditService.createXcData.workAddress.remainingService = xcWorkDetailsVm.remainservice;				
				xpressCreditService.createXcData.workAddress.addressOfDdo = xcWorkDetailsVm.addressddo;				
				xpressCreditService.createXcData.workAddress.designationOfDdo = xcWorkDetailsVm.designationddo;

				xpressCreditService.createXcData.workAddress.organisationWork = xcWorkDetailsVm.organisationWork;

				xpressCreditService.districtWorkArray = xcWorkDetailsVm.districtDetails;
				xpressCreditService.cityWorkArray = xcWorkDetailsVm.cityDetails;

				if (xcWorkDetailsVm.state) {
					xpressCreditService.createXcData.workAddress.stateText = xcWorkDetailsVm.state;
					statesData = JSON.parse(xcWorkDetailsVm.state);
					statesId = statesData.key;
					statesText = statesData.value;
				}

				if (xcWorkDetailsVm.district) {
					xpressCreditService.createXcData.workAddress.districtText = xcWorkDetailsVm.district;
					districtData = JSON.parse(xcWorkDetailsVm.district);
					districtId = districtData.key;
					districtText = districtData.value;
				}

				if (xcWorkDetailsVm.city) {
					xpressCreditService.createXcData.workAddress.cityText = xcWorkDetailsVm.city;
					cityData = JSON.parse(xcWorkDetailsVm.city);
					cityId = cityData.key;
					cityText = cityData.value;
				}

				var obj = {
					"pageName": "workDetails",
					"progress": "40%",
					"yonoRefNo": "",
					"address": [  
						{
							"addressType": "OFFICE",
							"addressLine1": xcWorkDetailsVm.address1,
							"addressLine2": xcWorkDetailsVm.address2,
							"pincode": xcWorkDetailsVm.pincode,
							"cityText": xcWorkDetailsVm.city,
							"cityCode": cityId,
							"stateText": xcWorkDetailsVm.state,
							"stateCode": statesId,
							"districtText": xcWorkDetailsVm.district,
							"districtCode": districtId,
							"officeContactNo": xcWorkDetailsVm.officephnumber,
							"remainingService": xcWorkDetailsVm.remainservice,
							"addressOfDdo": xcWorkDetailsVm.addressddo,
							"designationOfDdo": xcWorkDetailsVm.designationddo
						}
					]
				}	

    			xpressCreditService.getBeauroScoreValidation(obj).then(function(data) {
                    console.log("getBeauroScoreValidation",data)
                    $state.go('menu.xcAssets');
                },function(error) {
                    console.log("error",error)
                    utilityService.showErrorMessage(error.responseMessage);
                });		

				
			}

			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				xcWorkDetailsVm.address1 = xpressCreditService.createXcData.workAddress.addressLine1;
				xcWorkDetailsVm.address2 = xpressCreditService.createXcData.workAddress.addressLine2;
				xcWorkDetailsVm.pincode = xpressCreditService.createXcData.workAddress.pincode;

				if (xpressCreditService.createXcData.workAddress.stateText) {
					if (xpressCreditService.statusXc == 2) {
						var statesObj = JSON.parse(xpressCreditService.createXcData.workAddress.stateText);

						// if (xcWorkDetailsVm.stateDetails.length == 0) {
							xcWorkDetailsVm.stateDetails.push(statesObj)
						// }
					}
				 	xcWorkDetailsVm.state = xpressCreditService.createXcData.workAddress.stateText;
				 	if (xpressCreditService.statusXc == 2) {
				 	xcWorkDetailsVm.getDistrict();
				 }
				}

				if (xpressCreditService.createXcData.workAddress.districtText) {
					//if (xpressCreditService.statusXc == 2) {
						// var districtObj = JSON.parse(xpressCreditService.createXcData.workAddress.districtText);

						// if (xcWorkDetailsVm.districtDetails.length == 0) {
						// 	xcWorkDetailsVm.districtDetails.push(districtObj)
						// }

					//}
				 	xcWorkDetailsVm.district = xpressCreditService.createXcData.workAddress.districtText;
				 	if (xpressCreditService.statusXc == 2) {
				 	xcWorkDetailsVm.getCity();
				 }
				}

				if (xpressCreditService.createXcData.workAddress.cityText) {
					//if (xpressCreditService.statusXc == 2) {
						// var cityObj = JSON.parse(xpressCreditService.createXcData.workAddress.cityText);

						// if (xcWorkDetailsVm.cityDetails.length == 0) {
						// 	xcWorkDetailsVm.cityDetails.push(cityObj)
						// }
					//}
				 	xcWorkDetailsVm.city = xpressCreditService.createXcData.workAddress.cityText;
				}

				xcWorkDetailsVm.officephnumber = xpressCreditService.createXcData.workAddress.officeContactNo;				
				xcWorkDetailsVm.remainservice = xpressCreditService.createXcData.workAddress.remainingService;				
				xcWorkDetailsVm.addressddo = xpressCreditService.createXcData.workAddress.addressOfDdo;				
				xcWorkDetailsVm.designationddo = xpressCreditService.createXcData.workAddress.designationOfDdo;

				// if (xpressCreditService.createXcData.workAddress.organisationWork) {	
				// 	xcWorkDetailsVm.organisationWork = xpressCreditService.createXcData.workAddress.organisationWork;		
				// }

				xcWorkDetailsVm.validationAll();
			});

			return this;
		}
]);


