/**
 *   @ngdoc config
 *   @name angularApp.config : cardConfig
 *   @description
 *  configuration file for cards module
 */

/*This function defines all the constants named  Adapters url for cards module*/
angularApp
    /*State defination with respective names, urls, controllers and templates */
    .config([
        '$stateProvider',
        function ($stateProvider) {
            //Cards start
            $stateProvider
                .state('menu.xcCreate', {
                    url: '/xcCreate',
                    data: {
                        pageId: 'XCCREATE'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/xpresscredit/xccreate/xcCreate.html',
                            controller: 'xcCreateController',
                            controllerAs: 'xcCreateVm'
                        }
                    }
                }) 
                .state('menu.xcCheckoff', {
                    url: '/xcCheckoff',
                    data: {
                        pageId: 'XCCHECKOFF'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/xpresscredit/xccheckoff/xcCheckoff.html',
                            controller: 'xcCheckoffController',
                            controllerAs: 'xcCheckoffVm'
                        }
                    }
                }) 
                .state('menu.xcAddressDetails', {
                    url: '/xcAddressDetails',
                    data: {
                        pageId: 'XCADDRESSDETAILS'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/xpresscredit/xcaddressdetails/xcAddressDetails.html',
                            controller: 'xcAddressDetailsController',
                            controllerAs: 'xcAddressDetailsVm'
                        }
                    }
                }) 
                .state('menu.xcAdditionalDetails', {
                    url: '/xcAdditionalDetails',
                    data: {
                        pageId: 'XCADDITIONALDETAILS'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/xpresscredit/xcadditionaldetails/xcAdditionalDetails.html',
                            controller: 'xcAdditionalDetailsController',
                            controllerAs: 'xcAdditionalDetailsVm'
                        }
                    }
                }) 
                .state('menu.xcWorkDetails', {
                    url: '/xcWorkDetails',
                    data: {
                        pageId: 'XCWORKDETAILS'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/xpresscredit/xcworkdetails/xcWorkDetails.html',
                            controller: 'xcWorkDetailsController',
                            controllerAs: 'xcWorkDetailsVm'
                        }
                    }
                }) 
                .state('menu.xcAssets', {
                    url: '/xcAssets',
                    data: {
                        pageId: 'XCASSETS'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/xpresscredit/xcassets/xcAssets.html',
                            controller: 'xcAssetsController',
                            controllerAs: 'xcAssetsVm'
                        }
                    }
                }) 
                .state('menu.xcLiable', {
                    url: '/xcLiable',
                    data: {
                        pageId: 'XCLIABLE'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/xpresscredit/xcliable/xcLiable.html',
                            controller: 'xcLiableController',
                            controllerAs: 'xcLiableVm'
                        }
                    }
                }) 
                .state('menu.xcLoanoffer', {
                    url: '/xcLoanoffer',
                    data: {
                        pageId: 'XCLOANOFFER'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/xpresscredit/xcloanoffer/xcLoanoffer.html',
                            controller: 'xcLoanofferController',
                            controllerAs: 'xcLoanofferVm'
                        }
                    }
                })
                .state('menu.xcAppStatus', {
                    url: '/xcAppStatus',
                    data: {
                        pageId: 'XCAPPSTATUS'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/xpresscredit/xcappstatus/xcAppStatus.html',
                            controller: 'xcAppStatusController',
                            controllerAs: 'xcAppStatusVm'
                        }
                    }
                })
                .state('menu.xcLoancalculator', {
                    url: '/xcLoancalculator',
                    data: {
                        pageId: 'XCLOANCALCULATOR'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/xpresscredit/xcloancalculator/xcLoancalculator.html',
                            controller: 'xcLoancalculatorController',
                            controllerAs: 'xcLoancalculatorVm'
                        }
                    }
                })  
                .state('menu.xcDocupload', {
                    url: '/xcDocupload',
                    data: {
                        pageId: 'XCDOCUPLOAD'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/xpresscredit/xcdocumentupload/xcDocupload.html',
                            controller: 'xcDocuploadController',
                            controllerAs: 'xcDocuploadVm'
                        }
                    }
                }) 
                .state('menu.xcBranchselect', {
                    url: '/xcBranchselect',
                    data: {
                        pageId: 'XCBRANCHSELECT'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/xpresscredit/xcbranchselect/xcBranchselect.html',
                            controller: 'xcBranchselectController',
                            controllerAs: 'xcBranchselectVm'
                        }
                    }
                })
                .state('menu.xcBranchselectdetails', {
                    url: '/xcBranchselectdetails',
                    data: {
                        pageId: 'XCBRANCHSELECTDETAILS'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/xpresscredit/xcbranchselectdetails/xcBranchselectdetails.html',
                            controller: 'xcBranchselectdetailsController',
                            controllerAs: 'xcBranchselectdetailsVm'
                        }
                    }
                })   
                .state('menu.xcPendingapp', {
                    url: '/xcPendingapp',
                    data: {
                        pageId: 'XCPENDINGAPP'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/xpresscredit/xcpendingapp/xcPendingapp.html',
                            controller: 'xcPendingappController',
                            controllerAs: 'xcPendingappVm'
                        }
                    }
                })   
                .state('menu.xcSanctionapp', {
                    url: '/xcSanctionapp',
                    data: {
                        pageId: 'XCSANCTIONAPP'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/xpresscredit/xcsanctionapp/xcSanctionapp.html',
                            controller: 'xcSanctionappController',
                            controllerAs: 'xcSanctionappVm'
                        }
                    }
                })  
                .state('menu.xcPanupdate', {
                    url: '/xcPanupdate',
                    data: {
                        pageId: 'XCPANUPDATE'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/xpresscredit/xcpanupdate/xcPanupdate.html',
                            controller: 'xcPanupdateController',
                            controllerAs: 'xcPanupdateVm'
                        }
                    }
                })   
                .state('menu.xcUpdateaccount', {
                    url: '/xcUpdateaccount',
                    data: {
                        pageId: 'XCUPDATEACCOUNT'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/xpresscredit/xcupdateaccount/xcUpdateaccount.html',
                            controller: 'xcUpdateaccountController',
                            controllerAs: 'xcUpdateaccountVm'
                        }
                    }
                })   
                .state('menu.xcAadhardetails', {
                    url: '/xcAadhardetails',
                    data: {
                        pageId: 'XCAADHARDETAILS'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/xpresscredit/xcaadhardetails/xcAadhardetails.html',
                            controller: 'xcAadhardetailsController',
                            controllerAs: 'xcAadhardetailsVm'
                        }
                    }
                }) 
                .state('menu.xcCreatedSuccess', {
                    url: '/xcCreatedSuccess',
                    data: {
                        pageId: 'XCCREATEDSUCCESS'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/xpresscredit/xcCreatedSuccess/xcCreatedSuccess.html',
                            controller: 'xcCreatedSuccessController',
                            controllerAs: 'xcCreatedSuccessVm'
                        }
                    }
                }) 
                .state('menu.xcKnowmore', {
                    url: '/xcKnowmore',
                    data: {
                        pageId: 'XCKNOWMORE'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/xpresscredit/xcknowmore/xcKnowmore.html',
                            controller: 'xcKnowmoreController',
                            controllerAs: 'xcKnowmoreVm'
                        }
                    }
                }) 
        }
    ]);
