'use strict';

angularApp.controller('cardlessAtmController', ["$state",
    "$scope",    
    "aoService",    
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "requestYCService",
    "utilityService",
    "customerInfoService",
    "landingYCService",
    
    function ($state,
        $scope,        
        aoService,       
        $ionicSideMenuDelegate,
        mPinLoginService,
        requestYCService,
        utilityService,
        customerInfoService,
        landingYCService
       ) {

        var cardlessAtmVm = this;

        function initPage() {
            cardlessAtmVm.showBack = false;
            cardlessAtmVm.showLink = true;
        }

        //Function for close view
        cardlessAtmVm.closeView = function() {
            $state.go('menu.homeScreen');
        }

        cardlessAtmVm.loadAtmGps = function() {
            cardlessAtmVm.bankListGps = landingYCService.locateByGPS;
        }

        cardlessAtmVm.navigatePage = function(param){
            var geocoords = param.latitude + ',' + param.longitude;
            if(utilityService.isUndefined(param.latitude) || utilityService.isUndefined(param.longitude)){
                 var title = '';
                 var template = '{{"NO_DIR" | translate}}';
                 var onTap = 'menu.locateBranchByLocality';
                 var buttontext = '<b>' + locateBranchGpsVm.okBtntext + '</b>';
                 utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
             }
             else{
                 if (utilityService.isIOSPlatform()) {
                   //window.open('maps://?q=' + geocoords, '_system');
                   cordova.ThemeableBrowser.open('https://www.google.com/maps/search/?api=1&query='+geocoords, '_blank',
                   {
                       statusbar: {
                           color:'#ffffffff'
                       },
                       toolbar: {
                           height: 37,
                           color: '#ffffffff',
                           image: 'share'
                       },
 
                       closeButton: {
                           image:'back',
                           height: 37,
                           width: 32,
                           align: 'left',
                           event: 'closePressed'
                       },
 
                       backButtonCanClose: true
                   });
                 }
                 else {
                   var label = encodeURI('Your Destination'); // encode the label!
                   window.open('geo:0,0?q=' + geocoords + '(' + label + ')', '_system');
                 }
             }
         }


         //one time initialization to be done when the controller is loaded
         $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        $scope.$on('$ionicView.beforeEnter', function() {
            cardlessAtmVm.loadAtmGps();
        });
        return this;
    }
]);