'use strict';

angularApp.controller('landingYCController', ["$state",
    "$scope",
    "$timeout",
    "aoService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "requestYCService",
    "utilityService",
    "customerInfoService",
    "currentLocationService",
    "landingYCService",
    "cardlessAtmService",
    "$ionicHistory",
    "homeScreenService",
    "$translate",
    "$filter",
    "$ionicScrollDelegate",
    "$rootScope",
    "$ionicPopup",
    "getAccountDetailsService",
    function ($state,
        $scope,
        $timeout,
        aoService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        requestYCService,
        utilityService,
        customerInfoService,
        currentLocationService,
        landingYCService,
        cardlessAtmService,
        $ionicHistory,
        homeScreenService,
        $translate,
        $filter,
        $ionicScrollDelegate,
        $rootScope,
        $ionicPopup,
        getAccountDetailsService
       ) {

        var landingYCVm = this;
        landingYCVm.isChallenged = false;
        landingYCVm.showBack = false;
        landingYCVm.showNext = true;
        $rootScope.isMerchantPOS = false;
        function isEmpty(obj) {
          return !Object.keys(obj).length > 0;
      }

        function initPage() {
           // landingYCVm.loadProductFeatures();
           landingYCVm.welcomeMsg();
           $translate(['YC_NO_TRANSACTIONS']).then(function (translations) {
            landingYCVm.YC_NO_TRANSACTIONS = translations['YC_NO_TRANSACTIONS'];
        });
        }



        landingYCVm.requestYonoCash = function(_channel) {
            if(_channel == 1){
                $rootScope.isMerchantPOS = true;
            }else{
                $rootScope.isMerchantPOS = false;
            }
            if(_channel == 0){
                requestYCService.ycchannel = 'ATM'; 
            }else if(_channel == 1){
                requestYCService.ycchannel = 'Merchant POS-Cash'; 
            }else if(_channel == 2){
                requestYCService.ycchannel = 'Customer Service Points (CSP)'; 
            }else if(_channel == 99){
                requestYCService.ycchannel = 'Merchant POS-Shopping'; 
            }
              var isEmptyCustomerInfo = isEmpty(customerInfoService.customer);
              if (isEmptyCustomerInfo == false) {                                
                  $state.go('menu.requestYC');
              } else {
                  var errorData = "YONO is facing an intermittent technical issue. Please try again after sometime.";
                  utilityService.showNfsAlertModal("", errorData, "menu.homeScreen", $scope, $state, "OK");
              }
            // if(_channel == 'Merchant POS'){
            //     $rootScope.isMerchantPOS = true;
            // }else{
            //     $rootScope.isMerchantPOS = false;
            // }
            //   var isEmptyCustomerInfo = isEmpty(customerInfoService.customer);
            //   if (isEmptyCustomerInfo == false) {
            //     if(_channel == 'Merchant POS'){
            //         requestYCService.ycchannel = 'Merchant POS-Sale';
            //     }else if(_channel == 'Cardless Shopping'){
            //         requestYCService.ycchannel = 'Merchant POS-Shopping';
            //     }else{
            //         requestYCService.ycchannel = _channel
            //     }                  
            //       $state.go('menu.requestYC');
            //   } else {
            //       var errorData = "Something went wrong. Please try again after sometime.";
            //       utilityService.showNfsAlertModal("", errorData, "menu.homeScreen", $scope, $state, "OK");
            //   }
        }

        landingYCVm.transactions = function() {
            $state.go('menu.transactionsYC');
        }



        landingYCVm.fetchTransaction = function () {

            utilityService.showSpinner();
            requestYCService.fetchLastTransaction().then(function (data) {
                if (data) {
                    landingYCVm.allData = data ? data : {};
                    landingYCVm.allData= $filter('orderBy')(landingYCVm.allData,'-timeStamp' );
                    // landingYCVm.activeData = [];
                    // landingYCVm.canceledData = [];
                    // landingYCVm.completedData = [];
                    // landingYCVm.expiredData = [];
                    // angular.forEach(landingYCVm.allData, function (value, key) {
                    //     if (value.status == 'INITIATED') {
                    //         landingYCVm.activeData.push(value);
                    //     } else if (value.status == 'EXPIRED') {
                    //         landingYCVm.expiredData.push(value);
                    //     } else if (value.status == 'CANCELLED') {
                    //         landingYCVm.canceledData.push(value);
                    //     } else if (value.status == 'COMPLETED') {
                    //         landingYCVm.completedData.push(value);
                    //     }
                    // });
                    // angular.forEach(landingYCVm.allData, function (value, key) {
                    //     if (value.status == 'INITIATED') {
                    //         landingYCVm.ycStatusColor = {"color":"#673391"};
                    //     } else if (value.status == 'EXPIRED') {
                    //         landingYCVm.ycStatusColor = {"color":"#3F3F3F"};
                    //     } else if (value.status == 'CANCELLED') {
                    //         landingYCVm.ycStatusColor = {"color":"#D0021B"};
                    //     } else if (value.status == 'COMPLETED') {
                    //         landingYCVm.ycStatusColor = {"color":"#417505"};
                    //     }
                    // });
                }
                utilityService.hideSpinner();

            }, function (error) {
                utilityService.hideSpinner();
                if (error.responseMessage == "No Transactions available") {
                    $ionicPopup.show({
                        template: '<p>There is no transaction for last 2 days</p>',
                        title: '',
                        cssClass: 'dialog',
                        scope: '',
                        buttons: [{
                            text: 'OK',
                            type: 'button-positive'
                        }]
                    });
                } else {
                    utilityService.showErrorMessage(error.responseMessage);
                }
                //utilityService.showErrorMessage(landingYCVm.YC_NO_TRANSACTIONS);
                //utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
            });

        }

      
		landingYCVm.welcomeMsg = function() {
		$translate(['YC_LNDGPAG_TXTDATA', 'YC_LNDGPAG_TXTDATA_ARR_DONE', 'YC_LNDGPAG_TXTDATA_ARR_DTWO', 
		'YC_LNDGPAG_TXTDATA_ARR_DTHRI', 'YC_LNDGPAG_TXTDATA_ARR_DFOR', 'YC_LNDGPAG_TXTDATA_ARR_DFIVE', 
		'YC_LNDGPAG_TXTDATA_ARR_DSIX', 'YC_LNDGPAG_TXTDATA_ARR_DSEV', 'YC_LNDGPAG_TXTDATA_ARR_DEIT' , 
		'YC_LNDGPAG_TXTDATA_ARR_PDAY' , 'YC_LNDGPAG_TXTDATA_ARR_DTWO_NA' , 'YC_LNDGPAG_TXTDATA_ARR_DFOR_NA',
		'YC_LNDGPAG_TXTDATA_ARR_DSIX_NA' , 'YC_LNDGPAG_TXTDATA_ARR_DEIT_NA']).then(function(translations) {
			landingYCVm.landingTxtData = translations['YC_LNDGPAG_TXTDATA'];
			landingYCVm.YC_LNDGPAG_TXTDATA_ARR_DONE = translations['YC_LNDGPAG_TXTDATA_ARR_DONE'];
			landingYCVm.YC_LNDGPAG_TXTDATA_ARR_DTWO = translations['YC_LNDGPAG_TXTDATA_ARR_DTWO'];
			landingYCVm.YC_LNDGPAG_TXTDATA_ARR_DTHRI = translations['YC_LNDGPAG_TXTDATA_ARR_DTHRI'];

			landingYCVm.YC_LNDGPAG_TXTDATA_ARR_DFOR = translations['YC_LNDGPAG_TXTDATA_ARR_DFOR'];
			landingYCVm.YC_LNDGPAG_TXTDATA_ARR_DFIVE = translations['YC_LNDGPAG_TXTDATA_ARR_DFIVE'];
			landingYCVm.YC_LNDGPAG_TXTDATA_ARR_DSIX = translations['YC_LNDGPAG_TXTDATA_ARR_DSIX'];

			landingYCVm.YC_LNDGPAG_TXTDATA_ARR_DSEV = translations['YC_LNDGPAG_TXTDATA_ARR_DSEV'];
			landingYCVm.YC_LNDGPAG_TXTDATA_ARR_DEIT = translations['YC_LNDGPAG_TXTDATA_ARR_DEIT'];
			landingYCVm.YC_LNDGPAG_TXTDATA_ARR_PDAY = translations['YC_LNDGPAG_TXTDATA_ARR_PDAY'];
			
			landingYCVm.YC_LNDGPAG_TXTDATA_ARR_DTWO_NA = translations['YC_LNDGPAG_TXTDATA_ARR_DTWO_NA'];
			landingYCVm.YC_LNDGPAG_TXTDATA_ARR_DFOR_NA = translations['YC_LNDGPAG_TXTDATA_ARR_DFOR_NA'];
			landingYCVm.YC_LNDGPAG_TXTDATA_ARR_DSIX_NA = translations['YC_LNDGPAG_TXTDATA_ARR_DSIX_NA'];
			landingYCVm.YC_LNDGPAG_TXTDATA_ARR_DEIT_NA = translations['YC_LNDGPAG_TXTDATA_ARR_DEIT_NA'];
			
			requestYCService.getWelcomeMessages().then(function(response) {
				//if (response.contentDetails) {
					//landingYCVm.landingTxtData = response.contentDetails
				//}
				//if (response.imgUrl) {
					landingYCVm.imgUrl = "img/yonoCash/yonoCashLanding.svg";
				//}
				//if (response.yonoCashOptions) {
					landingYCVm.yonoCashOptions = [{},{},{}]//response.yonoCashOptions;
					landingYCVm.yonoCashOptions[0].title = landingYCVm.YC_LNDGPAG_TXTDATA_ARR_DONE;
					landingYCVm.yonoCashOptions[0].desc = landingYCVm.YC_LNDGPAG_TXTDATA_ARR_DTWO + response.yonoCash.atmLimit;
					landingYCVm.yonoCashOptions[0].imgUrl = "img/yonoCash/yc_atm.svg";

					landingYCVm.yonoCashOptions[1].title = landingYCVm.YC_LNDGPAG_TXTDATA_ARR_DTHRI;
					landingYCVm.yonoCashOptions[1].desc = landingYCVm.YC_LNDGPAG_TXTDATA_ARR_DFOR + response.yonoCash.mposLimit+ landingYCVm.YC_LNDGPAG_TXTDATA_ARR_PDAY;
					landingYCVm.yonoCashOptions[1].imgUrl = "img/yonoCash/yc_POS.svg";

					landingYCVm.yonoCashOptions[2].title = landingYCVm.YC_LNDGPAG_TXTDATA_ARR_DFIVE;
					landingYCVm.yonoCashOptions[2].desc = landingYCVm.YC_LNDGPAG_TXTDATA_ARR_DSIX + response.yonoCash.cspLimit ;
					landingYCVm.yonoCashOptions[2].imgUrl = "img/yonoCash/yc_CSP.svg";

					//landingYCVm.yonoCashOptions.splice(landingYCVm.yonoCashOptions.indexOf(2), 1);
				//}
				//if (response.ycCardlessShopping) {
					landingYCVm.ycCardlessShopping = [{}]//;response.ycCardlessShopping;
					landingYCVm.ycCardlessShopping[0].title = landingYCVm.YC_LNDGPAG_TXTDATA_ARR_DSEV;
					landingYCVm.ycCardlessShopping[0].desc = landingYCVm.YC_LNDGPAG_TXTDATA_ARR_DEIT + response.yonoCash.shpLimit;
					landingYCVm.ycCardlessShopping[0].imgUrl = "img/yonoCash/yc_Shopping.svg";
				//}
			}, function(error) {
				landingYCVm.imgUrl = "img/yonoCash/yonoCashLanding.svg";
				    landingYCVm.yonoCashOptions = [{},{},{}]
					landingYCVm.yonoCashOptions[0].title = landingYCVm.YC_LNDGPAG_TXTDATA_ARR_DONE;
					landingYCVm.yonoCashOptions[0].desc = landingYCVm.YC_LNDGPAG_TXTDATA_ARR_DTWO_NA;
					landingYCVm.yonoCashOptions[0].imgUrl = "img/yonoCash/yc_atm.svg";

					landingYCVm.yonoCashOptions[1].title = landingYCVm.YC_LNDGPAG_TXTDATA_ARR_DTHRI;
					landingYCVm.yonoCashOptions[1].desc = landingYCVm.YC_LNDGPAG_TXTDATA_ARR_DFOR_NA;
					landingYCVm.yonoCashOptions[1].imgUrl = "img/yonoCash/yc_POS.svg";

					landingYCVm.yonoCashOptions[2].title = landingYCVm.YC_LNDGPAG_TXTDATA_ARR_DFIVE;
					landingYCVm.yonoCashOptions[2].desc = landingYCVm.YC_LNDGPAG_TXTDATA_ARR_DSIX_NA;
					landingYCVm.yonoCashOptions[2].imgUrl = "img/yonoCash/yc_CSP.svg";
					landingYCVm.ycCardlessShopping = [{}]
					landingYCVm.ycCardlessShopping[0].title = landingYCVm.YC_LNDGPAG_TXTDATA_ARR_DSEV;
					landingYCVm.ycCardlessShopping[0].desc = landingYCVm.YC_LNDGPAG_TXTDATA_ARR_DEIT_NA;
					landingYCVm.ycCardlessShopping[0].imgUrl = "img/yonoCash/yc_Shopping.svg";
                
                    utilityService.hideSpinner();
				// utilityService.showErrorMessage(error.responseMessage);
				//utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
			});
		});

	};



        //Find Cardless Transaction enabled ATM
        landingYCVm.cardlessAtm = function() {
            utilityService.showSpinner();
            $timeout(function () {
                currentLocationService.getCurrentPosition().then(
                    function (position) {
                        var latitude = position.coords.latitude;
                        var longitude = position.coords.longitude;
                        landingYCService.locateByGPS.length = 0;
                        var params = {
                            "latitude": latitude,
                            "longitude": longitude
                        }
                        if (utilityService.isUndefined(landingYCService.locateByGPS) ||
                        landingYCService.locateByGPS.length === 0) {
                            cardlessAtmService.getCardlessAtm(params).then(function (data) {
                                utilityService.hideSpinner();
                                if (!utilityService.isUndefined(data)) {
                                    for (var i = 0; i < data.atms.length; i++) {
                                        landingYCService.locateByGPS.push(data.atms[i]);
                                    }
                                    if (landingYCService.locateByGPS.length == 0) {
                                        var title = '';
                                        var template = 'No Cardless Transaction ATM is available within 5 km from your location';
                                        var onTap = '';
                                        var buttontext = 'OK';
                                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                                    } else {
                                        $state.go('menu.cardlessAtm');
                                    }
                                }
                            }, function (error) {
                                utilityService.hideSpinner();
                                utilityService.showErrorMessage(error.responseMessage);
                            });
                        } else {
                            utilityService.hideSpinner();
                        }
                    },
                    function (err) {
                        utilityService.hideSpinner();
                        var title = '';
                        var template = '{{"ON_GPS" | translate}}';
                        var onTap = '';
                        var buttontext = '<b>OK</b>';
                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                    });
            }, 2000);
        };


        landingYCVm.selType = function(bookingCategory){

            landingYCVm.selTab =bookingCategory;
            if(bookingCategory == 'D'){
                landingYCVm.classForMpinLoginOpt = 'tab-items tabs-style div-bottom bor-bot-active';
                landingYCVm.classForUserLoginOpt = 'tab-items tabs-style div-bottom';
            }
            if(bookingCategory == 'V'){
                landingYCVm.showDetailPage = false;
                landingYCVm.fetchTransaction();
                //landingYCVm.cdkRevList
                landingYCVm.classForMpinLoginOpt = 'tab-items tabs-style div-bottom';
                landingYCVm.classForUserLoginOpt = 'tab-items tabs-style div-bottom bor-bot-active';
                
            }
            $ionicScrollDelegate.anchorScroll();

        }

        landingYCVm.showDetailsPage = function(detailData){

            // landingYCVm.showDetailPage = true;
            // landingYCVm.selectedAccountNumber = detailData.accountNo;
            // landingYCVm.selectedDate = detailData.timeStamp
            // landingYCVm.selectedAmount = detailData.amount;
            // landingYCVm.selectedStatus = detailData.status;
            // landingYCVm.selectedChannel = detailData.status;
            $state.go('menu.ycTrnDetail', { termsObj: detailData });




        }



         //Function for close view
         landingYCVm.closeView = function() {            
           $state.go('menu.homeScreen');
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
            if (getAccountDetailsService.accessRightsData.accounts == null || getAccountDetailsService.accessRightsData.accounts == "") {
                getAccountDetailsService.getAccountsAccessRights('').then(function (data) {
                    getAccountDetailsService.accessRightsData = data;
                }, function (error) {
                    // Failure block
                });
            }
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            landingYCVm.isBackCheck = homeScreenService.isBackCheck;
            landingYCVm.showDetailPage = false;
            homeScreenService.isBackCheck = false;
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            landingYCVm.classForMpinLoginOpt = 'tab-items tabs-style div-bottom bor-bot-active';
            landingYCVm.classForUserLoginOpt = 'tab-items tabs-style div-bottom';
            
            if(requestYCService.fromDetail == 'yes'){
                requestYCService.fromDetail = '';
                landingYCVm.selType('V');
            }else{
                landingYCVm.selType('D');
            }
            requestYCService.selectedDetails = {
                accountType: '',
                accountNumber: '',
                accountBalance: '',
                intCategory: '',
                accountTypeCode: '',
                amount: '',
                pin: '',
                hashyc:'',
                selIndex: "",
                encpin:''
            };
            
        });

        $scope.$on('$ionicView.beforeLeave', function () {

        });

        return this;
    }
]);

