'use strict';

angularApp.controller('createPinYCController', ["$state",
    "$scope",
    "aoService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "$translate",
    "internetBankingService",
    "requestYCService",

    function ($state,
        $scope,
        aoService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        $translate,
        internetBankingService,
        requestYCService
    ) {

        var createPinYCVm = this;
        createPinYCVm.isChallenged = false;
        createPinYCVm.showBack = true;
        createPinYCVm.showNext = true;

        function initPage() {
            createPinYCVm.disablenext=true
            createPinYCVm.isMasked = true;
            createPinYCVm.fontFamily = 'font-family : text-security-disc !important';
            createPinYCVm.inputImg = "img/Visibility_off.svg";
            //requestYCService.selectedDetails.pin = ''
            //console.log("YC DETAILS " + JSON.stringify(requestYCService.selectedDetails))
            createPinYCVm.ErrMsg = false;
            $translate(['AMOUNT']).then(function (translations) {
                createPinYCVm.amount = translations['AMOUNT'];
            });
        }

        createPinYCVm.checkYCPINConditions = function (ycPin) {
            // var userDetails = internetBankingService.userDetailsForMpin;

            
            for (var i = 0; i < 4; i++) {
                if (ycPin[i + 1] == parseInt(ycPin[i]) + 1) {
                    if (ycPin[i + 2] == parseInt(ycPin[i + 1]) + 1) {
                        return 'Three consecutive numbers should not be in sequence';
                    }
                }
            }
            for (var i = 0; i < 4; i++) {
                if (ycPin[i] == parseInt(ycPin[i + 1]) + 1) {
                    if (ycPin[i + 1] == parseInt(ycPin[i + 2]) + 1) {
                        return 'Three consecutive numbers should not be in sequence';
                    }
                }
            }
            // if(createPinYCVm.checkDateCombinations(ycPin, userDetails.birthDate)){
            //     return 'Birthdate combinations cannot be set as MPIN';
            // }
            var validArrSet = [ycPin[0], ycPin[1], ycPin[2], ycPin[3], ycPin[4], ycPin[5]];
            var newArr = [];
            for (var i = 0; i < validArrSet.length; i++) {
                if (newArr.indexOf(validArrSet[i]) == -1) {
                    newArr.push(validArrSet[i]);
                }
            }
            if (newArr.length < 3) {
                return 'Please use 3 unqiue numbers to set PIN.';
            }
            if (/(.)\1\1/.test(ycPin.toString())) {
                return 'Three consecutive numbers should not be same';
            }
            return true;
        };

        createPinYCVm.maskUnmask = function () {
                                createPinYCVm.isMasked == true ? (createPinYCVm.isMasked = false , createPinYCVm.inputImg = "img/Visibility_on.svg" ,createPinYCVm.fontFamily = 'font-family : Roboto-Regular !important')  : (createPinYCVm.isMasked = true , createPinYCVm.inputImg = "img/Visibility_off.svg",createPinYCVm.fontFamily = 'font-family : text-security-disc !important');
                        };

        createPinYCVm.checkDateCombinations = function (pin, date) {
            var dd = date.substring(0, 2);
            var mm = date.substring(2, 4);
            var yy = date.substring(6, 8);
            if (pin == (dd + mm + yy) || pin == (mm + dd + yy) || pin == (yy + dd + mm) || pin == (yy + mm + dd) || pin == (dd + yy + mm) || pin == (mm + yy + dd)) {
                return true;
            } else {
                return false;
            }
        };

        createPinYCVm.hideShowPassword = function (param) {
			if(param == "enterPassword"){
			createPinYCVm.inputType == "password" ? (createPinYCVm.inputType = "text" , createPinYCVm.inputImg = "img/Visibility_OnPurple.svg") : (createPinYCVm.inputType = "password" , createPinYCVm.inputImg = "img/Visibility_OffPurple.svg");
			}
			else{
			createPinYCVm.reInputType == "password" ? (createPinYCVm.reInputType = "text" , createPinYCVm.reInputImg = "img/Visibility_OnPurple.svg") : (createPinYCVm.reInputType = "password" , createPinYCVm.reInputImg = "img/Visibility_OffPurple.svg");
			}
		};



        //Function for close view
        createPinYCVm.closeView = function () {
            $state.go('menu.homeScreen');
        }

        //onclick of Back button
        createPinYCVm.goBacktoPrevious = function () {            
            $state.go('menu.requestYC');
        };


        createPinYCVm.goToNextPage = function () {
             $state.go('menu.reviewYC')
        }


        //onclick of next button
        createPinYCVm.validatePIN = function (isValid) {
            createPinYCVm.ErrMsg = false;
            createPinYCVm.disablenext = true;
            if(isValid == true){
            createPinYCVm.pinCondition = "";
            createPinYCVm.pinCondition = createPinYCVm.checkYCPINConditions(createPinYCVm.pinData)
            if (createPinYCVm.pinCondition == true) {
                createPinYCVm.ErrMsg = false;
                requestYCService.selectedDetails.pin = createPinYCVm.pinData;
                 createPinYCVm.disablenext = !isValid; 
            } else {
                createPinYCVm.ErrMsg = true;
                 createPinYCVm.disablenext = true;
            }
            }
                 
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            createPinYCVm.platform = device.platform.toLowerCase();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            if(requestYCService.selectedDetails.pin && requestYCService.selectedDetails.pin !=""){
                createPinYCVm.pinData = requestYCService.selectedDetails.pin;
                createPinYCVm.validatePIN(true);
            }
        });

        $scope.$on('$ionicView.beforeLeave', function () {

        });

        return this;
    }
]);
