'use strict';

angularApp.service('requestYCService',
	function ($q, AdapterUtils, constantConfig, $ionicPopup,cardConfig) {
		var requestYCService = this;
		var accountList = [];
		requestYCService.tabIndex = { tabIndex: 0 };

		requestYCService.fromDetail = '';
		requestYCService.accDetails = [];

		requestYCService.ycchannel = '';

		requestYCService.accList = [];
		requestYCService.selDet = {
			accountNumber: '',
			selIndex:''
		}


		requestYCService.selectedDetails = {
			selIndex:'',
			accountType: '',
			accountNumber: '',
			accountBalance: '',
			intCategory: '',
			accountTypeCode: '',
			amount: '',
			pin: '',
			hashyc:'',
			encpin:''
		};

		requestYCService.customer = {
			selectedItem: '',
			indexId: 0
		}

		requestYCService.showAlertModal = function (title, template, onTapgo, $scope, $state) {
			var alertPopup = $ionicPopup.show({
				title: title,
				template: template,
				scope: $scope,
				cssClass: 'my-custom-popup',
				buttons: [{
					text: 'OK',
					type: 'button-assertive',
					onTap: function () {
						if (onTapgo !== '' && onTapgo !== null) {
							$state.go(onTapgo);
						}
					}
				}],
			});
		}

		requestYCService.addAccountDetails = function (accListObj) {
			accountList = accListObj;
		};
		requestYCService.getAccountDetails = function () {
			return accountList;
		}

		requestYCService.fetchDailyLimit = function (data) {
			var q = $q.defer();
			var obj = {
				"accountNo": data
			};
			AdapterUtils.postData("adapters/FundsTransferAdapter/fetchDailyTransactionLimit", obj, true).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		requestYCService.ycCreateReferenceNumber = function (data) {
			var q = $q.defer();
			var obj = {
				"amount": data.amount,
				"accountNo": data.accountNumber,
				"cashPIN": data.encpin,
				"createdby": "MOBILE",
				"docType":data.ycChannel,
				"ycHash":data.hashyc

			};
			AdapterUtils.postData("adapters/FundsTransferAdapter/createTransactionReferenceNo", obj, true).then(
				function (response) {
					q.resolve(response.responseMessage);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		requestYCService.fetchLastTransaction = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FundsTransferAdapter/fetchLastTransaction", true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		requestYCService.cancleTransaction = function (data) {
			var q = $q.defer();
			var docTYPE;
			if(data.docType == "Merchant POS-Cash"){
                docTYPE = "YONO_CASH_POS";
            }else if(data.docType == "CSP"){
	                docTYPE = "YONO_CASH_CSP";
            }else if(data.docType == "ATM"){
	                docTYPE = "YONO_CASH_TRAN";
            }else if(data.docType == "Merchant POS-Shopping"){
	                docTYPE = "YONO_SHOPPING";
            }

			var obj = {
				"refNo": data.refNo,
				"accountNo": data.accountNo,
				"docType":docTYPE

			};
			AdapterUtils.postData("adapters/FundsTransferAdapter/cancelTransaction", obj, true).then(
				function (response) {
					q.resolve(response.responseMessage);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		//service is used to call terms ans conditions
		requestYCService.getTermsAndConditions =function() {
			var q = $q.defer();	
				var obj = {
				"tnc": "string"
			};
			AdapterUtils.postData("adapters/FundsTransferAdapter/getTnCContent", obj, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
			
		};

		//service is used to call POS terms ans conditions
		requestYCService.getTermsAndConditionsMPOS =function() {
			var q = $q.defer();	
				var obj = {
				"tnc": "string"
			};
			AdapterUtils.postData("adapters/FundsTransferAdapter/getPosTnCContent", obj, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
			
		};

		//service is used to call Shopping terms ans conditions
		requestYCService.getTermsAndConditionsShopping =function() {
			var q = $q.defer();	
				var obj = {
				"tnc": "string"
			};
			AdapterUtils.postData("adapters/FundsTransferAdapter/getShoppingTnCContent", obj, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
			
		};

		//service is used to call CSP terms ans conditions
		requestYCService.getTermsAndConditionsCSP =function() {
			var q = $q.defer();	
				var obj = {
				"tnc": "string"
			};
			AdapterUtils.postData("adapters/FundsTransferAdapter/getCspTnCContent", obj, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
			
		};


		requestYCService.getWelcomeMessages = function() {
           var q = $q.defer();	
				var obj = {
				 "imgUrl": "string",
    			 "contentDetails": "string"
			};
			AdapterUtils.postData("adapters/FundsTransferAdapter/getYonoCashContent", obj, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
		};
		
		// requestYCService.isUserWhiteListed = function() {
		// 	var q = $q.defer();	
		// 		 var obj = {				  
		// 	 };
		// 	 AdapterUtils.postData("adapters/FundsTransferAdapter/isUserWhiteListed", obj, true).then(
		// 		 function(response){
		// 			 q.resolve(response);
		// 		 },
		// 		 function(error){
		// 			 q.reject(error);
		// 		 }
		// 		 ); 
		// 	 return q.promise;
		//  };


		requestYCService.getThankyou =function() {
			var q = $q.defer();	
				var obj = {
				 "content": "string"
			};
			AdapterUtils.postData("adapters/FundsTransferAdapter/getSuccessContent", obj, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
			
		};
		requestYCService.getThankyouCSP =function() {
			var q = $q.defer();	
				var obj = {
				 "content": "string"
			};
			AdapterUtils.postData("adapters/FundsTransferAdapter/getCSPSuccessContent", obj, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
			
		};

		requestYCService.getThankyouPOS =function() {
			var q = $q.defer();	
				var obj = {
				 "content": "string"
			};
			AdapterUtils.postData("adapters/FundsTransferAdapter/getPosSuccessContent", obj, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
			
		};

		requestYCService.getThankyouYcShopping =function() {
			var q = $q.defer();	
				var obj = {
				 "content": "string"
			};
			AdapterUtils.postData("adapters/FundsTransferAdapter/getYcShoppingSuccessContent", obj, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
			
		};

		requestYCService.displayPopUp = function (heading, css, message, buttonText, callBack) {
			var alertPopup = $ionicPopup.alert({
				title: heading,
				template: '<div class="popupTextBottomPadding  ss-popup-list fontSize-subHeading roboto-medium text-center ' + css + '">'
				+ message + '</div></div>',
				cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite ss-popup',
				buttons: [
					{
						text: buttonText,
						onTap: function (e) {
							callBack();
						}
					}
				],
			});
		};

		


		return requestYCService;

	});


// 'use strict';

// angularApp.service('requestYCService',
// 	function ($ionicPopup, $q, AdapterUtils) {

// 		var requestYCService = this;

// 		requestYCService.accDetails = [];

// 		requestYCService.selectedDetails = {
// 			accountType: '',
// 			accountNumber: '',
// 			accountBalance: '',
// 			isActive: '',
// 			isTransactional: '',
// 			branchCode: '',
// 			branchName: '',
// 			intCategory: '',
// 			accountTypeCode: ''
// 		};

// 		requestYCService.Relations = [];
// 		requestYCService.customer = {
// 			amountData: '',
// 			years: '',
// 			months: '',
// 			days: '',
// 			maturityDate: '',
// 			interestRate: '',
// 			maturityAmount: '',
// 			interestPayout: '',
// 			maturityInstruction: '',
// 			diffDays: '',
// 			maturityDateFull: '',
// 			isvalidDays: '',
// 			isTaxable: false,
// 			accountNo: '',
// 			fdAccountNumber: '',
// 			loanEligibility: '',
// 			receiptLink: '',
// 			nomineeClick: '',
// 			selectedItem: '',
// 			ODLimit: '',
// 			ODIntRate: '',
// 			ODExyDate: '',
// 			isSenior: false,
// 			custName: '',
// 			custDOB: '',
// 			nominee: '',
// 			age: '',
// 			relation: '',
// 			guardian: '',
// 			address1: '',
// 			address2: '',
// 			dob: '',
// 			showNominee: false,
// 			viewInterest: false,
// 			isPanAvailable: '',
// 			fdnumber: '',
// 			AODclick: '',
// 			intpayoutMD: '',
// 			intpayoutAMT: '',
// 			maturitydateRequest: '',
// 			nameToBePrintedFlag: '',
// 			minorFlag: '',
// 			custype: '',
// 			intpayoutservice: '',
// 			matInstService: '',
// 			indexId: 0,
// 			amountCredited: '',
// 			effectiveInterestRates: '',
// 			clickback: '',
// 			intpaycheck: '',
// 			nomIndexid: '',
// 			checkPAL: '',
// 			preApprovedLoanAmount: '',
// 			product: '',
// 			principalAmount: '',
// 			checkPage: false,
// 			maturitydateFD: '',
// 			maturitydateFDRequest: '',
// 			branchCode: '',
// 			branchName: '',
// 			intpayamount: '',
// 			intpaystring: '',
// 			checkNominee: false,
// 			fdCloseClick: '',
// 			intpayoutACCT: '',
// 			intCategory: '',
// 			accountTypeCode: '',
// 			nightMode: '',
// 			modeOfOperation: '',
// 			scheme:''
// 		};
// 		/**
// 		 * Common pop up message
// 		 * @param {string} title 
// 		 * @param {tempalte html as string} template
// 		 * @param {string} onTapgo
// 		 * @param {obejct} $scope
// 		 * @param {object} $state
// 		 */
// 		requestYCService.showAlertModal = function (title, template, onTapgo, $scope, $state) {
// 			var alertPopup = $ionicPopup.show({
// 				title: title,
// 				template: template,
// 				scope: $scope,
// 				cssClass: 'my-custom-popup',
// 				buttons: [{
// 					text: 'OK',
// 					type: 'button-assertive',
// 					onTap: function () {
// 						if (onTapgo !== '' && onTapgo !== null) {
// 							$state.go(onTapgo);
// 						}
// 					}
// 				}],
// 			});
// 		}
// 		requestYCService.showTnCAlertModal = function (title, template, onTapgo, cssClasstnc, $scope, $state) {
// 			var alertPopup = $ionicPopup.show({
// 				title: title,
// 				template: template,
// 				scope: $scope,
// 				cssClass: cssClasstnc,
// 				buttons: [{
// 					text: 'OK',
// 					type: 'button-assertive',
// 					onTap: function () {
// 						if (onTapgo !== '' && onTapgo !== null) {
// 							$state.go(onTapgo);
// 						}
// 					}
// 				}],
// 			});
// 			return alertPopup;
// 		}

// 		requestYCService.fetchInfoMessage = function (data) {
// 			var q = $q.defer();
// 			var obj = {
// 				"action": data.action
// 			};
// 			AdapterUtils.postData("adapters/FixedDepositAdapter/fetchInfoMessage", obj, true).then(
// 				function (response) {

// 					q.resolve(response.data);
// 				},
// 				function (error) {
// 					q.reject(error);
// 				}
// 			);
// 			return q.promise;
// 		};

// 		requestYCService.fetchNightModeStatus = function (data, isLoader) {
// 			var q = $q.defer();
// 			var obj = {
// 				"module": data.moduleName,
// 				"action": data.actionName,
// 				"date": ""
// 			};
// 			AdapterUtils.postData("adapters/FixedDepositAdapter/fetchNightModeStatus", obj, isLoader).then(
// 				function (response) {

// 					q.resolve(response.data);
// 				},
// 				function (error) {
// 					q.reject(error);
// 				}
// 			);
// 			return q.promise;
// 		};
// 		return requestYCService;
// 	});


