'use strict';

angularApp.controller('reviewYCController', [
    "$state",
    "$scope",
    "aoService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "$translate",
    "requestYCService",
    "utilityService",
    "cryptoService",

    function (
        $state,
        $scope,
        aoService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        $translate,
        requestYCService,
        utilityService,
        cryptoService
    ) {

        var reviewYCVm = this;
        reviewYCVm.isChallenged = false;
        reviewYCVm.showBack = true;
        reviewYCVm.showconfirm = true;
        reviewYCVm.disableconfirm = true;

        function initPage() {
            reviewYCVm.indexId = requestYCService.customer.indexId;
            reviewYCVm.selectedAccountType = requestYCService.selectedDetails.accountType;
            reviewYCVm.selectedAccountNumber = requestYCService.selectedDetails.accountNumber;
            reviewYCVm.selectedAccountAmount = requestYCService.selectedDetails.accountBalance;
            reviewYCVm.selectedIntCategory = requestYCService.selectedDetails.intCategory;
            reviewYCVm.selectedAccountTypeCode = requestYCService.selectedDetails.accountTypeCode;
            reviewYCVm.amount = requestYCService.selectedDetails.amount;
            reviewYCVm.pin = requestYCService.selectedDetails.pin;
            reviewYCVm.channel = requestYCService.ycchannel;
            reviewYCVm.isChecked = requestYCService.isChecked;
            reviewYCVm.isMasked = true;
            reviewYCVm.inputImg = "img/Visibility_off.svg";
            if (requestYCService.isChecked == true) {
                reviewYCVm.disableconfirm = false;
            } 
        }


        //Function for close view
        reviewYCVm.closeView = function () {
            $state.go('menu.homeScreen');
        }

        reviewYCVm.maskUnmask = function () {
                                reviewYCVm.isMasked == true ? (reviewYCVm.isMasked = false , reviewYCVm.inputImg = "img/Visibility_on.svg") : (reviewYCVm.isMasked = true , reviewYCVm.inputImg = "img/Visibility_off.svg");
                        };

        //onclick of Back button
        reviewYCVm.goBacktoPrevious = function () {
            $state.go('menu.createPinYC')
        };

        //onclick of next button
        reviewYCVm.goToNextPage = function () {            
            requestYCService.selectedDetails.hashyc =  cryptoService.getSHA512EncryptedData(requestYCService.selectedDetails.amount.toString()+requestYCService.selectedDetails.accountNumber.toString()+requestYCService.selectedDetails.pin.toString()+"MOBILE").toString();
            if(requestYCService.ycchannel == "Merchant POS-Cash"){
                requestYCService.selectedDetails.ycChannel = "YONO_CASH_POS";
            }else if(requestYCService.ycchannel == "Customer Service Points (CSP)"){
                requestYCService.selectedDetails.ycChannel = "YONO_CASH_CSP";
            }else if(requestYCService.ycchannel == "ATM"){
                requestYCService.selectedDetails.ycChannel = "YONO_CASH_TRAN";
            }else if(requestYCService.ycchannel == "Merchant POS-Shopping"){
                requestYCService.selectedDetails.ycChannel = "YONO_SHOPPING";
            }
            requestYCService.isChecked = false;
            requestYCService.selectedDetails.encpin =  cryptoService.encryptRSAWithPublicKey(requestYCService.selectedDetails.pin);
           
            requestYCService.ycCreateReferenceNumber(requestYCService.selectedDetails).then(function (data) {
                if (data) {
                   // requestYCService.ycchannel='';
                    $state.go('menu.thankYouYC')
                }

            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
                //utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
            });

        }

        //onclick of check box
        reviewYCVm.getCBValue = function (_check) {

            if (_check == true) {
                reviewYCVm.disableconfirm = false;
                requestYCService.isChecked = true;
            } else {
                reviewYCVm.disableconfirm = true;
                requestYCService.isChecked = false;
            }

        }

        //this function is define to call terms and conditions service
        reviewYCVm.getTermsAndConditionsFun = function () {
           


            if(reviewYCVm.channel == "Merchant POS-Cash"){
                utilityService.showSpinner();
                requestYCService.getTermsAndConditionsMPOS().then(function (data) {
                    reviewYCVm.termsConditions = data.tnc;
                    utilityService.hideSpinner();
                    $state.go('menu.ycTerms', { termsObj: reviewYCVm.termsConditions });
                },
                    function (error) {
                        utilityService.hideSpinner();
                        utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
                    });  
            }else if(reviewYCVm.channel == "Customer Service Points (CSP)"){
              utilityService.showSpinner();
            requestYCService.getTermsAndConditionsCSP().then(function (data) {
                reviewYCVm.termsConditions = data.tnc;
                utilityService.hideSpinner();
                $state.go('menu.ycTerms', { termsObj: reviewYCVm.termsConditions });
            },
                function (error) {
                    utilityService.hideSpinner();
                    utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
                });     
            }else if(reviewYCVm.channel == "ATM"){
            utilityService.showSpinner();
            requestYCService.getTermsAndConditions().then(function (data) {
                reviewYCVm.termsConditions = data.tnc;
                utilityService.hideSpinner();
                $state.go('menu.ycTerms', { termsObj: reviewYCVm.termsConditions });
            },
                function (error) {
                    utilityService.hideSpinner();
                    utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
                });    
            }else if(reviewYCVm.channel == "Merchant POS-Shopping"){
              utilityService.showSpinner();
            requestYCService.getTermsAndConditionsShopping().then(function (data) {
                reviewYCVm.termsConditions = data.tnc;
                utilityService.hideSpinner();
                $state.go('menu.ycTerms', { termsObj: reviewYCVm.termsConditions });
            },
                function (error) {
                    utilityService.hideSpinner();
                    utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
                });    
            }
                




           
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        $scope.$on('$ionicView.beforeLeave', function () {

        });

        return this;
    }
]);
