'use strict';

angularApp.controller('thankYouYCController', ["$state",
    "$scope",
    "aoService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "$translate",
    "requestYCService",
    "utilityService",
    "$timeout",
    "currentLocationService",
    "landingYCService",
    "cardlessAtmService",

    function ($state,
        $scope,
        aoService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        $translate,
        requestYCService,
        utilityService,
        $timeout,
        currentLocationService,
        landingYCService,
        cardlessAtmService
    ) {

        var thankYouYCVm = this;
        thankYouYCVm.isChallenged = false;
        thankYouYCVm.showBack = true;
        thankYouYCVm.showNext = true;

        function initPage() {
            // thankYouYCVm.loadProductFeatures();  
            //thankYouYCVm.payingFrom = requestYCService.getAccountDetails();
            thankYouYCVm.tranChannel = requestYCService.ycchannel; 
            thankYouYCVm.accDetails = [];
            thankYouYCVm.accDetails = thankYouYCVm.payingFrom;
            thankYouYCVm.thankYou();
            requestYCService.selectedDetails = {
			accountType: '',
			accountNumber: '',
			accountBalance: '',
			intCategory: '',
			accountTypeCode: '',
			amount: '',
			pin: '',
            hashyc:'',
            selIndex: "",
			encpin:''
		};

            $translate(['AMOUNT']).then(function (translations) {
                thankYouYCVm.amount = translations['AMOUNT'];
            });
        }

        thankYouYCVm.thankYou = function() {

            if(requestYCService.ycchannel == "Customer Service Points (CSP)"){
                requestYCService.getThankyouCSP().then(function(response) {               
                    if (response.content) {                    
                        thankYouYCVm.thankyouTxtData = response.content
                        requestYCService.ycchannel == ""
                    }
                }, function(error) {
                     utilityService.showErrorMessage(error.responseMessage);
                     requestYCService.ycchannel == ""
                     //utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
                });
            }else if(requestYCService.ycchannel == "Merchant POS-Cash"){
                requestYCService.getThankyouPOS().then(function(response) {               
                    if (response.content) {                    
                        thankYouYCVm.thankyouTxtData = response.content
                        requestYCService.ycchannel == ""
                    }
                }, function(error) {
                     utilityService.showErrorMessage(error.responseMessage);
                     requestYCService.ycchannel == ""
                     //utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
                });
            }else if(requestYCService.ycchannel == "Merchant POS-Shopping"){
                requestYCService.getThankyouYcShopping().then(function(response) {               
                    if (response.content) {                    
                        thankYouYCVm.thankyouTxtData = response.content
                        requestYCService.ycchannel == ""
                    }
                }, function(error) {
                     utilityService.showErrorMessage(error.responseMessage);
                     requestYCService.ycchannel == ""
                     //utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
                });
            }else{
                requestYCService.getThankyou().then(function(response) {               
                    if (response.content) {                    
                        thankYouYCVm.thankyouTxtData = response.content
                        requestYCService.ycchannel == ""
                    }
                }, function(error) {
                     utilityService.showErrorMessage(error.responseMessage);
                     requestYCService.ycchannel == ""
                     //utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
                });
            }          

        };

        thankYouYCVm.cardlessAtm = function() {
            utilityService.showSpinner();
            $timeout(function () {
                currentLocationService.getCurrentPosition().then(
                    function (position) {
                        var latitude = position.coords.latitude;
                        var longitude = position.coords.longitude;
                        landingYCService.locateByGPS.length = 0;
                        var params = {
                            "latitude": latitude,
                            "longitude": longitude
                        }
                        if (utilityService.isUndefined(landingYCService.locateByGPS) ||
                        landingYCService.locateByGPS.length === 0) {
                            cardlessAtmService.getCardlessAtm(params).then(function (data) {
                                utilityService.hideSpinner();
                                if (!utilityService.isUndefined(data)) {
                                    for (var i = 0; i < data.atms.length; i++) {
                                        landingYCService.locateByGPS.push(data.atms[i]);
                                    }
                                    if (landingYCService.locateByGPS.length == 0) {
                                        var title = '';
                                        var template = 'No Cardless Transaction ATM is available within 5 km from your location';
                                        var onTap = '';
                                        var buttontext = 'OK';
                                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                                    } else {
                                        $state.go('menu.cardlessAtm');
                                    }
                                }
                            }, function (error) {
                                utilityService.hideSpinner();
                                utilityService.showErrorMessage(error.responseMessage);
                            });
                        } else {
                            utilityService.hideSpinner();
                        }
                    },
                    function (err) {
                        utilityService.hideSpinner();
                        var title = '';
                        var template = '{{"ON_GPS" | translate}}';
                        var onTap = '';
                        var buttontext = '<b>OK</b>';
                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                    });
            }, 2000);
        };


        //Function for close view
        thankYouYCVm.closeView = function () {
            $state.go('menu.homeScreen');
        }


        //onclick of home button
        thankYouYCVm.homeClick = function () {
            $state.go('menu.homeScreen')
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        $scope.$on('$ionicView.beforeLeave', function () {

        });

        return this;
    }
]);
