'use strict';

angularApp.controller('transactionsYCController', ["$state",
    "$scope",
    "aoService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "$translate",
    "requestYCService",
    "utilityService",
    "$ionicPopup",
    "$filter",

    function ($state,
        $scope,
        aoService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        $translate,
        requestYCService,
        utilityService,
        $ionicPopup,
        $filter

    ) {

        var transactionsYCVm = this;
        transactionsYCVm.isChallenged = false;
        transactionsYCVm.showBack = true;
        transactionsYCVm.showNext = true;
        transactionsYCVm.allData = {};

        function initPage() {
            // transactionsYCVm.loadProductFeatures();  
            //transactionsYCVm.payingFrom = requestYCService.getAccountDetails();
            transactionsYCVm.accDetails = [];
            transactionsYCVm.accDetails = transactionsYCVm.payingFrom;

            $translate(['AMOUNT']).then(function (translations) {
                transactionsYCVm.amount = translations['AMOUNT'];
            });
            $translate(['YC_NO_TRANSACTIONS']).then(function (translations) {
                transactionsYCVm.YC_NO_TRANSACTIONS = translations['YC_NO_TRANSACTIONS'];
            });

            transactionsYCVm.fetchTransaction();
        }

        //function to fetch transactions

        transactionsYCVm.fetchTransaction = function () {

            utilityService.showSpinner();
            requestYCService.fetchLastTransaction().then(function (data) {
                if (data) {
                    transactionsYCVm.allData = data ? data : {};
                    transactionsYCVm.allData= $filter('orderBy')(transactionsYCVm.allData,'-timeStamp' );
                    transactionsYCVm.activeData = [];
                    transactionsYCVm.canceledData = [];
                    transactionsYCVm.completedData = [];
                    transactionsYCVm.expiredData = [];
                    angular.forEach(transactionsYCVm.allData, function (value, key) {
                        if (value.status == 'INITIATED') {
                            transactionsYCVm.activeData.push(value);
                        } else if (value.status == 'EXPIRED') {
                            transactionsYCVm.expiredData.push(value);
                        } else if (value.status == 'CANCELLED') {
                            transactionsYCVm.canceledData.push(value);
                        } else if (value.status == 'COMPLETED') {
                            transactionsYCVm.completedData.push(value);
                        }
                    });
                }
                utilityService.hideSpinner();

            }, function (error) {
                utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
                //utilityService.showErrorMessage(transactionsYCVm.YC_NO_TRANSACTIONS);
                //utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
            });

        }

        transactionsYCVm.deletTransaction = function (_data) {
            // utilityService.showSpinner();

            // requestYCService.cancleTransaction(_data).then(function (data) {
            //     if (data) {
            //         utilityService.hideSpinner();
            //         transactionsYCVm.allData = {};
            //         transactionsYCVm.fetchTransaction();

            //     }

            // }, function (error) {
            //     utilityService.hideSpinner();
            //     utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
            // });

            var upgradeInstaVm = $ionicPopup.show({
				template: '<p class="padding-bottom-20" > <span translate="YC_POPUP" ></span>   </p>',
				title: '',
				cssClass: 'dialog',
				scope: $scope,
				buttons: [{
					text: 'No',
					type: 'button-negative',
					onTap: function (e) {
						upgradeInstaVm.close();
						e.preventDefault();
					}
				},
				{
					text: 'Yes',
					type: 'button-positive',
					onTap: function (e) {
						upgradeInstaVm.close();
						e.preventDefault();
                        utilityService.showSpinner();
                        requestYCService.cancleTransaction(_data).then(function (data) {
                            if (data) {
                                utilityService.hideSpinner();
                                transactionsYCVm.allData = {};
                                transactionsYCVm.fetchTransaction();

                            }

                        }, function (error) {
                            utilityService.hideSpinner();
                            utilityService.showErrorMessage(error.responseMessage);
                            //utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
                        });
						
					}
				}]
			});

        }



        










        //Function for close view
        transactionsYCVm.closeView = function () {
            $state.go('menu.homeScreen');
        }


        //onclick of home button
        transactionsYCVm.homeClick = function () {
            $state.go('menu.homeScreen')
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        $scope.$on('$ionicView.beforeLeave', function () {

        });

        return this;
    }
]);
