/**
*   @ngdoc config
*   @name angularApp.config : ycConfig
*   @description
*	configuration file for YONO Cash module
*/

'use strict';

/*State defination with respective names, urls, controllers and templates */
angularApp.config(['$stateProvider',
	function ($stateProvider) {
		//YONO CASH start
		$stateProvider
			.state('menu.yonoCash', {
				url: '/yonoCash',
				data: {
					pageId: 'YC_HOM'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/yonoCash/landing/landingYC.html',
						controller: 'landingYCController',
						controllerAs: 'landingYCVm',
					}
				}
			})
			.state('menu.cardlessAtm', {
				url: '/cardlessAtm',
				data: {
					pageId: 'YC_CATM'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/yonoCash/cardlessAtm/cardlessAtm.html',
						controller: 'cardlessAtmController',
						controllerAs: 'cardlessAtmVm',
					}
				}
			})
			.state('menu.requestYC', {
				url: '/requestYC',
				data: {
					pageId: 'YC_REQ'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/yonoCash/request/requestYC.html',
						controller: 'requestYCController',
						controllerAs: 'requestYCVm',
					}
				}
			})
			.state('menu.createPinYC', {
				url: '/createPinYC',
				data: {
					pageId: 'YC_PIN'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/yonoCash/request/createPinYC.html',
						controller: 'createPinYCController',
						controllerAs: 'createPinYCVm',
					}
				}
			})
			.state('menu.reviewYC', {
				url: '/reviewYC',
				data: {
					pageId: 'YC_REV'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/yonoCash/request/reviewYC.html',
						controller: 'reviewYCController',
						controllerAs: 'reviewYCVm',
					}
				}
			})
			.state('menu.thankYouYC', {
				url: '/thankYouYC',
				data: {
					pageId: 'YC_TY'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/yonoCash/request/thankYouYC.html',
						controller: 'thankYouYCController',
						controllerAs: 'thankYouYCVm',
					}
				}
			})
			.state('menu.transactionsYC', {
				url: '/transactionsYC',
				data: {
					pageId: 'YC_TR'
				},
				cache: false,
				views: {
					'menuContent': {
						templateUrl: 'pages/yonoCash/transactions/transactionsYC.html',
						controller: 'transactionsYCController',
						controllerAs: 'transactionsYCVm',
					}
				}
			})
			.state('menu.ycTerms', {
				url: '/ycTerms',
				cache: false,
				data: {
					pageId: 'YC_TRM'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/yonoCash/request/termsYC.html',
						controller: 'termsYCController',
						controllerAs: 'termsYCVm',
					}
				}, params: { termsObj: null }
			})
			.state('menu.ycTrnDetail', {
				url: '/ycTrnDetail',
				cache: false,
				data: {
					pageId: 'YC_TRD'
				},
				views: {
					'menuContent': {
						templateUrl: 'pages/yonoCash/transactions/trnDetailYC.html',
						controller: 'trnDetailYCController',
						controllerAs: 'trnDetailYCVm',
					}
				}, params: { termsObj: null }
			})
	}]);