'use strict';

angularApp.controller('applyWearableController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "wearableServices",
    "clickStreamService",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        wearableServices,
        clickStreamService) {

        var applyWearableControllerVM = this;
         applyWearableControllerVM.url = wearableServices.targetURL ? wearableServices.targetURL : "";


        applyWearableControllerVM.goBack = function(){
            $ionicHistory.goBack();
        }


        applyWearableControllerVM.applyNow = function(){
            $state.go("menu.termsConditionsNPSView");
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            applyWearableControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            applyWearableControllerVM.getApplyWearableCheckpoint();
            applyWearableControllerVM.getDisclaimerWearableContent();
        });

        
        applyWearableControllerVM.declarationPopup = function () {

            //applyWearableControllerVM.getDisclaimerWearableContent();

            applyWearableControllerVM.myPopup = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark yonoWeableBackdrop',
                templateUrl: "pages/yonoWearable/applyWearable/disclaimerPopup.html",
                scope: $scope
            });
        };

        applyWearableControllerVM.goToNext = function(){
             applyWearableControllerVM.myPopup.close();

             var refInAppBrowser = cordova.ThemeableBrowser.open(applyWearableControllerVM.url, '_blank', {
                    statusbar: {
                        color: '#ffffffff'
                    },
                    toolbar: {
                        height: 37,
                        color: '#ffffffff',
                        image: 'share'
                    },

                    closeButton: {
                        image: 'back',
                        height: 37,
                        width: 32,
                        align: 'left',
                        event: 'closePressed'
                    },
                    backButtonCanClose: true
                });

                refInAppBrowser.addEventListener('loadstart', function (event) { });
                refInAppBrowser.addEventListener('loadstop', function (event) { });
                refInAppBrowser.addEventListener('closePressed', closePressedcallback);

        }
        function closePressedcallback() {

        }

        applyWearableControllerVM.disagree = function(){
             applyWearableControllerVM.myPopup.close();
        }

        applyWearableControllerVM.getApplyWearableCheckpoint = function(){

            wearableServices.getApplyWearableCheckpoint().then(function(response) {
                console.log("response" + JSON.stringify(response));
                if (response.content) {
                    applyWearableControllerVM.aboutInfo = response.content;
                }
   
            }, function(error) {
                 utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                    utilityService.disableShowErrorMessage();
            });
        }

        applyWearableControllerVM.getDisclaimerWearableContent = function(){

           wearableServices.getDisclaimerWearableContent().then(function(response) {
                if (response.content) {
                   applyWearableControllerVM.disclaimerData = response.content;
                }
            }, function(error) {
                 utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                    utilityService.disableShowErrorMessage();
            });
        }

        applyWearableControllerVM.closepopup = function(){
             applyWearableControllerVM.myPopup.close();
        }



        return this;
    }
]);
