'use strict';

angularApp.controller('landingWearableController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "wearableServices",
    "$ionicPopover",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        wearableServices,
        $ionicPopover) {

        var landingWearableControllerVM = this;
        landingWearableControllerVM.isFeaturesActive = true;
        landingWearableControllerVM.isEligibilityActive = false;
        landingWearableControllerVM.isCalculatorActive = false;

        landingWearableControllerVM.wearableListlength = 1;

        landingWearableControllerVM.goBack = function(){
            $ionicHistory.goBack();
        }

        landingWearableControllerVM.selType = function(type){
            landingWearableControllerVM.isFeaturesActive = type === "F" ? true : false;
            landingWearableControllerVM.isEligibilityActive = type === "E" ? true : false;
            landingWearableControllerVM.isCalculatorActive = type === "C" ? true : false;
        }

        landingWearableControllerVM.applyNow = function(){
            $state.go("menu.termsConditionsNPSView");
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            landingWearableControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
        });

        landingWearableControllerVM.gotoApplyWearable = function(){
            $state.go("menu.applyNewWearable")
        }

        landingWearableControllerVM.showDropdown = function(){
            document.getElementById("myDropdown").classList.toggle("show");
        }

        window.onclick = function(event) {
            if (!event.target.matches('.dropbtn')) {
                var dropdowns = document.getElementsByClassName("dropdown-content");
                var i;
                for (i = 0; i < dropdowns.length; i++) {
                    var openDropdown = dropdowns[i];
                    if (openDropdown.classList.contains('show')) {
                        openDropdown.classList.remove('show');
                    }
                }
            }
        }

        $ionicPopover.fromTemplateUrl('pages/yonoWearable/landing/blockcardPopover.html', {
            scope: $scope
        }).then(function (popover) {
            $scope.popover = popover;
        });

        landingWearableControllerVM.openPopOver = function($event){
            $scope.popover.show($event);
        }

        landingWearableControllerVM.permanentBlock = function(){
            $scope.popover.hide();
            $state.go("menu.blockingWearableReason");
        }

        landingWearableControllerVM.getCheckedVAl = function($event){

        }

        landingWearableControllerVM.linkWearable = function(){
            //service call to check for 3 wearables

            $state.go("menu.linkWearable");
        }

        landingWearableControllerVM.goToViewTransaction = function(){
            $state.go("menu.wearableTransactionList");
        }

        landingWearableControllerVM.checkClick = function(value){
            alert("this is selected" + value);
            if(value){
                $state.go("menu.wearableProfilePassword");
            }else{
                //popup of ok-cancel
            }
        }

        return this;
    }
]);
