'use strict';

angularApp.controller('linkingOTPController',
    ["$timeout", 
    "$state", 
    "$scope", 
    "$translate", 
    "$ionicSideMenuDelegate", 
    "ionicToast", 
    "$ionicPopup", 
    "$ionicScrollDelegate",
    "utilityService",
    "$ionicHistory",
    "ionicDatePicker",
    "internetBankingService",
    "wearableServices",
    "getAccountDetailsService",
    "homeScreenService",
    function (
        $timeout, 
        $state, 
        $scope, 
        $translate, 
        $ionicSideMenuDelegate, 
        ionicToast, 
        $ionicPopup, 
        $ionicScrollDelegate,
        utilityService,
        $ionicHistory,
        ionicDatePicker,
        internetBankingService,
        wearableServices,
        getAccountDetailsService,
        homeScreenService) {

        var linkingOTPControllerVm = this;
        linkingOTPControllerVm.resendOTPCout = 1;
        // var regExp =  /(?<=.)[^@\n](?=[^@\n]*?.@)|(?:(?<=@)|(?!^)\G(?=[^@\n]*$)).(?=.*\.)/;
        // var subStr = "*";
        linkingOTPControllerVm.customerDetails = getAccountDetailsService.accountOverviewData.customerInformation;
        linkingOTPControllerVm.customerDetails.mobileNumber = getAccountDetailsService.accountOverviewData.customerInformation.mobile;
        if(getAccountDetailsService.accountOverviewData.customerInformation.emailID){
            //linkingOTPControllerVm.customerDetails.customerMaskedEmail =  getAccountDetailsService.customerDetails.email;
           	var mail = getAccountDetailsService.accountOverviewData.customerInformation.emailID;
			var subStr = mail.split("@")
			var tempOne = subStr[0]
			var a = tempOne.replace(/[0-9a-zA-Z.*+?^${}()|[\]\\]/g, 'X')
			a = a.split("")
			a[a.length - 1] = (tempOne.slice(-1));
			a[0] = (tempOne.substring(0,1));
			var tempTwo = subStr[1]
			var domainArr = tempTwo.split(".")
			var domain = domainArr[domainArr .length - 1]
			var maskCharSet = tempTwo.replace(/[0-9a-zA-Z.*+?^${}()|[\]\\]/g, 'X')
			var completeDomain = maskCharSet +"."+ domain
			completeDomain = completeDomain.substr((completeDomain.length - tempTwo.length), tempTwo.length)
			var emailFirstPart =  a.toString()
			emailFirstPart =  emailFirstPart.replace(",", "")
			emailFirstPart =  emailFirstPart.replace(/,/g, "")
			var maskedEmail = emailFirstPart +"@"+ completeDomain
            linkingOTPControllerVm.customerDetails.customerMaskedEmail = maskedEmail;
            linkingOTPControllerVm.isEmail = true;
           }
        linkingOTPControllerVm.isOTPRequired = false;

        /*linkingOTPControllerVm.close = function(){
            $state.go("menu.selectSim");
        }*/
        linkingOTPControllerVm.goBack = function(){
            $ionicHistory.goBack(); 
        }
       
        linkingOTPControllerVm.otpValidate = function(){
           
            if(linkingOTPControllerVm.otp1 && linkingOTPControllerVm.otp2 && linkingOTPControllerVm.otp3 && linkingOTPControllerVm.otp4 && linkingOTPControllerVm.otp5 && linkingOTPControllerVm.otp6){
                linkingOTPControllerVm.isOTPRequired = false;
                var otp = linkingOTPControllerVm.otp1+""+linkingOTPControllerVm.otp2+""+linkingOTPControllerVm.otp3+""+linkingOTPControllerVm.otp4+""+linkingOTPControllerVm.otp5+""+linkingOTPControllerVm.otp6;
                var reqParams = {
                    "otp":otp,
                    "mobile":getAccountDetailsService.accountOverviewData.customerInformation.mobile,
                    "journeyName":"YONOWearable",
                    "data": {
                        "commonId": ""
                    }
                };
                wearableServices.validateOTP(reqParams).then(function (data) {
                   // $state.go("menu.regReviewUserDetails");

                linkingOTPControllerVm.wearableActivationRequest();


                }, function (error) {
                    linkingOTPControllerVm.otp1 = "";
                    linkingOTPControllerVm.otp2 = "";
                    linkingOTPControllerVm.otp3 = "";
                    linkingOTPControllerVm.otp4 = "";
                    linkingOTPControllerVm.otp5 = "";
                    linkingOTPControllerVm.otp6 = "";
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                    utilityService.disableShowErrorMessage();
                });
            }
            else{
                linkingOTPControllerVm.isOTPRequired = true;
            }
            
            //$state.go("menu.regReviewUserDetails");
        }

        //Resend OTP
        linkingOTPControllerVm.resendOTP = function(){
            if(!linkingOTPControllerVm.isDisabledOTPbtn){
                 var reqParams = {
                    "mobile":getAccountDetailsService.accountOverviewData.customerInformation.mobile,
                    "email":getAccountDetailsService.accountOverviewData.customerInformation.emailID,
                    "journeyName":"YONOWearable"
                };
                wearableServices.sendOTP(reqParams).then(function (data) {
                    var confirmPopup = $ionicPopup.confirm({
                        title: "",
                        template: "<div translate='LBL_STEP1_RESEND_OTP_SUCCESS_MSG'></div>",
                        cssClass: 'dialog',
                        scope: $scope,
                        buttons: [
                            {
                                text: 'OK',
                                onTap: function (e) {
                                    confirmPopup.close();
                                }
                            }
                        ]
                    });
                    if(linkingOTPControllerVm.resendOTPCout != 2){
                        linkingOTPControllerVm.resendOTPCout = linkingOTPControllerVm.resendOTPCout+1;
                    }else{
                        linkingOTPControllerVm.isDisabledOTPbtn = true;
                    }
                }, function (error) {
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                    utilityService.disableShowErrorMessage();
                });
            }
        }

        linkingOTPControllerVm.wearableActivationRequest = function(){

             wearableServices.wearableIssuance( wearableServices.linkWearable.enterUrn,wearableServices.linkWearable.cardNumber,wearableServices.linkWearable.accountNumber,wearableServices.linkWearable.nickName).then(function (data) {

                    $state.go("menu.linkSuccess");

			},  function(error) {
                    
                    var message = error.responseMessage;
                    $ionicPopup.alert({
                        title: "",
                        template: '<div class="popup-padding font-dark-grey"><div><center><img class="approvedIconPosition" src="img/FT/BhimUpi/errorSymbol.svg"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><span class="popUp-msg-color">'
                        + message + '</span></div></div></div>',
                        cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup'
                    }).then(function (res) {
                        homeScreenService.ishamburgerMenuRO = false;
                        homeScreenService.isMyWearableFlag = true;
                        getAccountDetailsService.setRewTab = true;
                        getAccountDetailsService.tabIndex.tabIndex = 6;
                        $state.go("menu.accountOverviewMyBalance");
                    });
            });
        }


         $scope.$on('$ionicView.beforeEnter', function () {
            linkingOTPControllerVm.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
        });


}]);