'use strict';

angularApp.controller('linkingWearableController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "wearableServices",
    "customerInfoService",
    "constantConfig",
    "cryptoService",
    "fTSetOTPService",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        wearableServices,
        customerInfoService,
        constantConfig,
        cryptoService,
        fTSetOTPService) {

        var linkingWearableControllerVM = this;
        linkingWearableControllerVM.URN = "VNG1234567892121";
        linkingWearableControllerVM.wearableName = "Titan Pay";
        linkingWearableControllerVM.isTextReadable = false;
        $scope.getFinalValue = "";
        $scope.getCaretFirstTxtBox = 0;
        linkingWearableControllerVM.showURNDontMatchError = false;
        linkingWearableControllerVM.isAccountTransactional = false;
        linkingWearableControllerVM.unableFetchAccountTransactional = false;
        linkingWearableControllerVM.showWrongURNError = false;
        linkingWearableControllerVM.unableFetchAccountMOPTransactional = false;
        linkingWearableControllerVM.checkPMJDYflag = false;

        $scope.isOTP = false;

        $scope.urn = { number: '', type: {}, mask: '' };
        $scope.checkurn = { number: '', type: {}, mask: '' };

        $scope.maskOptions = {
            allowInvalidValue: true //allows us to watch the value
        };
        $scope.$watch('urn.number', function (newNumber) {
            // $scope.cc.type = getCreditCardType(newNumber);
            $scope.urn.mask = "*** **** **** ***";

        });

        $scope.$watch('checkurn.number', function (newNumber) {
            // $scope.cc.type = getCreditCardType(newNumber);
            $scope.checkurn.mask = "*** **** **** ***";

        });


        linkingWearableControllerVM.goBack = function () {
            $ionicHistory.goBack();
        }


        linkingWearableControllerVM.gotoNext = function () {
            $state.go("menu.termsConditionsNPSView");
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            linkingWearableControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            linkingWearableControllerVM.reasonList = [{ val: "lost", label: "Lost" }, { val: "stolen", label: "Stolen" }];
            linkingWearableControllerVM.getAccountList();

            /* MOD changes start */
           /* if (getAccountDetailsService.accessRightsData.accounts == null || getAccountDetailsService.accessRightsData.accounts == "") {
                getAccountDetailsService.getAccountsAccessRights('').then(function (data) {
                    getAccountDetailsService.accessRightsData = data;
                    linkingWearableControllerVM.unableFetchAccountTransactional = false;
                }, function (error) {
                    linkingWearableControllerVM.unableFetchAccountTransactional = true;
                    // Failure block
                });
            }*/
            /* MOD changes end */


        });

        /*    linkingWearableControllerVM.checkVal = function(reasonObj){
               console.log("reasonObj"+ JSON.stringify(reasonObj));
           }*/

        linkingWearableControllerVM.checkPassword = function () {
            //service add


        }

        linkingWearableControllerVM.forgotpassPopup = function () {
            var havingMPINPrblmPopUp = $ionicPopup.show({
                template: "<p> If you have forgotton your profile password, you can reset the same yourself. You need to  authenticate yourself either with the hint question and answer that you had set for the Profile password or ATM Card details & PIN. You can approach branch in case you don't remember Hint Question/answer or ATM card details & PIN </p>",
                title: '',
                cssClass: 'dialog',
                scope: $scope,
                buttons: [{
                    text: 'OK',
                    type: 'button-positive'
                }]
            });
        };

        linkingWearableControllerVM.forgotPass = function () {
            $state.go('menu.forgotProfilePwd');
        }



        //Account list selectionEnd

        linkingWearableControllerVM.getAccountList = function () {

            if (!getAccountDetailsService.accountOverviewData) {
                utilityService.showSpinner();
                homeScreenService.getCustomerInfo().then(function (data) {
                    utilityService.hideSpinner();
                    getAccountDetailsService.accountOverviewData = data;
                    // wearableServices.accDetails = getAccountDetailsService.accountOverviewData.accounts
                    linkingWearableControllerVM.accDetails = getAccountDetailsService.accountOverviewData.accounts;
                    if (linkingWearableControllerVM.accDetails.length == 0) {
                        wearableServices.displayPopUp("", "padBtm25 top-padding26", "No Accounts available", "OK", function () {
                            $state.go('menu.homeScreen');
                        });
                    }
                    linkingWearableControllerVM.setPrimaryAccount();


                }, function (error) {
                    utilityService.hideSpinner();
                });
            } else {

                //wearableServices.accDetails = getAccountDetailsService.accountOverviewData.accounts
                linkingWearableControllerVM.accDetails = getAccountDetailsService.accountOverviewData.accounts;
                if (linkingWearableControllerVM.accDetails.length == 0) {
                    wearableServices.displayPopUp("", "padBtm25 top-padding26", "No Accounts available", "OK", function () {
                        $state.go('menu.homeScreen');
                    });
                }
                linkingWearableControllerVM.showSelect = false;
                if (wearableServices.selectedDetails.selIndex == "") {
                    linkingWearableControllerVM.setPrimaryAccount();
                } else {

                    linkingWearableControllerVM.close(wearableServices.selectedDetails.selIndex);

                }

            }




        }

        linkingWearableControllerVM.setPrimaryAccount = function () {

            if (getAccountDetailsService.accountOverviewData.customerInformation.accountNumber) {
                var arr = linkingWearableControllerVM.accDetails;

                for (var i = 0, j = arr.length; i < j; i++) {
                    if (arr[i].accountNumber == getAccountDetailsService.accountOverviewData.customerInformation.accountNumber) {
                        var topElement = linkingWearableControllerVM.accDetails[i];
                        linkingWearableControllerVM.close(i);
                        if (linkingWearableControllerVM.accDetails.indexOf(topElement) > 0) {
                            linkingWearableControllerVM.accDetails.splice(linkingWearableControllerVM.accDetails.indexOf(topElement), 1);
                            linkingWearableControllerVM.accDetails.unshift(topElement);
                        }
                    }
                };

                linkingWearableControllerVM.enterUrn = wearableServices.linkWearable.enterUrn;
                linkingWearableControllerVM.nickName = wearableServices.linkWearable.nickName;
                //linkingWearableControllerVM.accountNumber = wearableServices.linkWearable.accountNumber;
            } else {
                linkingWearableControllerVM.close(0);
            }



        };

        linkingWearableControllerVM.showPop = function () {
            linkingWearableControllerVM.popUp = $ionicPopup.show({
                title: '',
                cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll yonoWeableBackdrop',
                templateUrl: 'pages/yonoWearable/linkWearable/dropdownModal.html',
                scope: $scope
            });
        }


        linkingWearableControllerVM.close = function (index) {
            var title = '';
            var onTap = '';
            if (linkingWearableControllerVM.popUp) {
                linkingWearableControllerVM.popUp.close();
            }

            linkingWearableControllerVM.balance = linkingWearableControllerVM.accDetails[index].accountBalance;
            linkingWearableControllerVM.accType = linkingWearableControllerVM.accDetails[index].accountType;
            linkingWearableControllerVM.accountNumber = linkingWearableControllerVM.accDetails[index].accountNumber;
            linkingWearableControllerVM.isActive = linkingWearableControllerVM.accDetails[index].isActive;
            linkingWearableControllerVM.isTransactional = linkingWearableControllerVM.accDetails[index].isTransactional;
            wearableServices.selectedDetails.selIndex = index;
            wearableServices.selectedDetails.accountNumber = linkingWearableControllerVM.accDetails[index].accountNumber;
            wearableServices.selectedDetails.accountBalance = linkingWearableControllerVM.accDetails[index].accountBalance;
            linkingWearableControllerVM.showSelect = false;

            linkingWearableControllerVM.isAccountTransactional = false;
            linkingWearableControllerVM.unableFetchAccountTransactional = false;
            linkingWearableControllerVM.unableFetchAccountMOPTransactional = false;
            linkingWearableControllerVM.checkPMJDYflag = false;

            linkingWearableControllerVM.checkPMJDY();


        }

        linkingWearableControllerVM.checkPMJDY = function () {
            var accList = getAccountDetailsService.accountOverviewData.accounts;

            for (var i in accList) {

                if (accList[i].accountNumber == linkingWearableControllerVM.accountNumber) {
                    var pmjdycode = accList[i].accountTypeCode + " " + accList[i].intCategory;
                    if (pmjdycode == '1611 1411' || pmjdycode == '1011 1701' || pmjdycode == '1011 1601' || pmjdycode == '1611 1401') {
                        linkingWearableControllerVM.checkPMJDYflag = true;

                    } else {
                        linkingWearableControllerVM.checkPMJDYflag = false;
                        linkingWearableControllerVM.accessRightsMOD();
                    }

                }
            }


        }
        
        linkingWearableControllerVM.accessRightsMOD = function () {
            if (!getAccountDetailsService.accessRightsData.accounts) {
                getAccountDetailsService.getAccountsAccessRights('').then(function (data) {
                    getAccountDetailsService.accessRightsData = data;
                    linkingWearableControllerVM.unableFetchAccountTransactional = false;
                    linkingWearableControllerVM.getAccessRights();
                }, function (error) {
                    linkingWearableControllerVM.unableFetchAccountTransactional = true;
                    // Failure block
                });
            } else {
                linkingWearableControllerVM.getAccessRights();
            }
        }

        linkingWearableControllerVM.getAccessRights = function () {
            for (var i in getAccountDetailsService.accessRightsData.accounts) {
                if (getAccountDetailsService.accessRightsData.accounts[i].accountNumber == linkingWearableControllerVM.accountNumber) {
                    if (parseInt(getAccountDetailsService.accessRightsData.accounts[i].accessResponse) == 1) {
                        linkingWearableControllerVM.isAccountTransactional = false;
                        linkingWearableControllerVM.checkAccountOperation();
                    } else {
                        linkingWearableControllerVM.isAccountTransactional = true;
                    }
                }

            }

        }

        linkingWearableControllerVM.checkAccountOperation = function () {

            wearableServices.checkAccountOperation(linkingWearableControllerVM.accountNumber).then(function (data) {

                utilityService.hideSpinner();
                if (data.operationAllowed == 'Y') {
                    linkingWearableControllerVM.unableFetchAccountMOPTransactional = false;
                }
                if (data.operationAllowed == 'N') {
                    linkingWearableControllerVM.unableFetchAccountMOPTransactional = true;
                }
            }, function (error) {
                utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                    utilityService.disableShowErrorMessage();
            });

        }

        linkingWearableControllerVM.matchURN = function () {
            if (linkingWearableControllerVM.enterUrn && linkingWearableControllerVM.reEnterUrn) {
                if (linkingWearableControllerVM.enterUrn.toUpperCase().toString() != linkingWearableControllerVM.reEnterUrn.toUpperCase().toString()) {
                    linkingWearableControllerVM.showURNDontMatchError = true;
                    linkingWearableControllerVM.showWrongURNError = false;
                }
                else {
                    linkingWearableControllerVM.showURNDontMatchError = false;
                    linkingWearableControllerVM.urnEnquiry();
                }
            }

        };

        linkingWearableControllerVM.urnEnquiry = function () {
            var urnNumber = linkingWearableControllerVM.reEnterUrn.toUpperCase();

            wearableServices.urnEnquiry(urnNumber).then(function (data) {
                console.log("data" + JSON.stringify(data));
                if (data.responseCode == '00') {
                    wearableServices.linkWearable.enterUrn = data.urn;
                    wearableServices.linkWearable.cardNumber = data.cardNumber;
                    linkingWearableControllerVM.showWrongURNError = false;

                } else {
                    linkingWearableControllerVM.showWrongURNError = true;
                    linkingWearableControllerVM.errorMsg = "Enter correct URN.";
                }
            },
                function (error) {
                    if (error.responseCode == '0001') {
                        var noOfCount = parseInt(error.responseMessage);
                        var noOfAttempts = 3 - noOfCount;
                        if (noOfAttempts == 2) {
                            linkingWearableControllerVM.showWrongURNError = true;
                            linkingWearableControllerVM.errorMsg = "Enter correct URN. 2 attempts left.";
                        }
                        if (noOfAttempts == 1) {
                            linkingWearableControllerVM.showWrongURNError = true;
                            linkingWearableControllerVM.errorMsg = "Enter correct URN. 1 attempt left.";
                        }
                        if (noOfAttempts <= 0) {
                            linkingWearableControllerVM.showWrongURNError = false;
                            linkingWearableControllerVM.noAttemptPopup = $ionicPopup.show({
                                title: '',
                                cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll yonoWeableBackdrop',
                                templateUrl: 'pages/yonoWearable/linkWearable/linkAttemptsFailPopup.html',
                                scope: $scope
                            });
                        }
                    }

                    if (error.responseCode == '0002') {
                        linkingWearableControllerVM.showWrongURNError = false;
                        utilityService.enableShowErrorMessage();
                        utilityService.showErrorMessage(error.responseMessage);
                        utilityService.disableShowErrorMessage();
                        linkingWearableControllerVM.enterUrn ='';
                        linkingWearableControllerVM.reEnterUrn='';
                        linkingWearableControllerVM.nickName='';
                    }



                });
        }

        linkingWearableControllerVM.sendOTP = function () {
            wearableServices.linkWearable.nickName = linkingWearableControllerVM.nickName;
            wearableServices.linkWearable.accountNumber = linkingWearableControllerVM.accountNumber;


            var reqParams = {
                "mobile": getAccountDetailsService.accountOverviewData.customerInformation.mobile,
                "email": getAccountDetailsService.accountOverviewData.customerInformation.emailID,
                "journeyName": "YONOWearable"
            };

            wearableServices.sendOTP(reqParams).then(function (response) {
                $state.go('menu.linkingOTP');
            }, function (error) {
                $state.go('menu.linkingOTP');
            });

        }

        linkingWearableControllerVM.goToHome = function () {
            linkingWearableControllerVM.noAttemptPopup.close();
            homeScreenService.ishamburgerMenuRO = false;
            homeScreenService.isMyWearableFlag = true;
            getAccountDetailsService.setRewTab = true;
            getAccountDetailsService.tabIndex.tabIndex = 6;
            $state.go('menu.accountOverviewMyBalance');
        }

        return this;
    }
]);
