/**
*   @ngdoc config
*   @name angularApp.config : npsConfig
*   @description
*	configuration file for NPS module
*/




'use strict';

/*State defination with respective names, urls, controllers and templates */
angularApp.config(['$stateProvider',
	function ($stateProvider) {
		$stateProvider
        .state('menu.landingYonoWearable', {
            url: '/landingWearable',
            cache: false,
            data: {
                pageId: 'WEARABLE_LANDING_PAGE'
            },
            views: {
                'menuContent': {
                    templateUrl: 'pages/yonoWearable/landing/landingWearble.html',
                    controller: 'landingWearableController',
                    controllerAs: 'landingWearableControllerVM',
                }
            }
        })



        .state('menu.linkWearable', {
            url: '/linkWearable',
            cache: false,
            data: {
                pageId: 'LINK_WEARABLE_DATA'
            },
            views: {
                'menuContent': {
                    templateUrl: 'pages/yonoWearable/linkWearable/linkingWearble.html',
                    controller: 'linkingWearableController',
                    controllerAs: 'linkingWearableControllerVM',
                }
            }
        })

        .state('menu.linkSuccess', {
            url: '/linkSuccess',
            cache: false,
            data: {
                pageId: 'WEARABLE_LINKING_SUCCESS'
            },
            views: {
                'menuContent': {
                    templateUrl: 'pages/yonoWearable/linkSuccess/landingWearbleSuccess.html',
                    controller: 'landingWearableSuccessController',
                    controllerAs: 'landingWearableSuccessControllerVM',
                }
            }
        })

       /* .state('menu.wearableList', {
            url: '/wearableList',
            cache: false,
            data: {
                pageId: 'WEARABLE_LIST_PAGE'
            },
            views: {
                'menuContent': {
                    templateUrl: 'pages/yonoWearable/wearableList/wearableList.html',
                    controller: 'wearableListController',
                    controllerAs: 'wearableListControllerVM',
                }
            }
        }) */ 

        .state('menu.wearableTransactionList', {
            url: '/wearableTransactionList',
            cache: false,
            data: {
                pageId: 'WEARABLE_TRANSACTION_LIST'
            },
            views: {
                'menuContent': {
                    templateUrl: 'pages/yonoWearable/transactionList/transactionList.html',
                    controller: 'transactionListController',
                    controllerAs: 'transactionListControllerVM',
                }
            }
        })  

        .state('menu.blockingWearableReason', {
            url: '/blockingWearableReason',
            cache: false,
            data: {
                pageId: 'WEARABLE_BLOCKING_REASON'
            },
            views: {
                'menuContent': {
                    templateUrl: 'pages/yonoWearable/blockingWearableReason/blockingWearable.html',
                    controller: 'blockingWearableController',
                    controllerAs: 'blockingWearableControllerVM',
                }
            }
        })   

        .state('menu.applyNewWearable', {
            url: '/applyNewWearable',
            cache: false,
            data: {
                pageId: 'APPLY_NEW_WEARABLE'
            },
            views: {
                'menuContent': {
                    templateUrl: 'pages/yonoWearable/applyWearable/applyWearable.html',
                    controller: 'applyWearableController',
                    controllerAs: 'applyWearableControllerVM',
                }
            }
        })  

        .state('menu.wearableProfilePassword', {
            url: '/wearableProfilePassword',
            cache: false,
            data: {
                pageId: 'WEARABLE_PROFILE_PASSWORD'
            },
            views: {
                'menuContent': {
                    templateUrl: 'pages/yonoWearable/wearableProfilePassword/wearableProfilePassword.html',
                    controller: 'wearableProfilePasswordController',
                    controllerAs: 'wearableProfilePasswordControllerVM',
                }
            }
        })


        .state('menu.linkingOTP', {
            url: '/linkingOTP',
            cache: false,
            data: {
                pageId: 'WEARABLE_OTP'
            },
            views: {
                'menuContent': {
                    templateUrl: 'pages/yonoWearable/linkWearable/linkingOTP.html',
                    controller: 'linkingOTPController',
                    controllerAs: 'linkingOTPControllerVm',
                }
            }
        })                  
     
    }
]);