'use strict';

angularApp.controller('wearableProfilePasswordController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "wearableServices",
    "loggedInUserService",
    "fTReviewService",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        wearableServices,
        loggedInUserService,
        fTReviewService) {

        var wearableProfilePasswordControllerVM = this;
        wearableProfilePasswordControllerVM.isTextReadable = false;
        wearableProfilePasswordControllerVM.goBack = function () {
            $ionicHistory.goBack();
        }
        $scope.wearableDisplayname = $rootScope.wearableDisplayname;




        $scope.$on('$ionicView.beforeEnter', function () {
            wearableProfilePasswordControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            wearableProfilePasswordControllerVM.reasonList = [{ val: "lost", label: "Lost" }, { val: "stolen", label: "Stolen" }];
            wearableProfilePasswordControllerVM.cardNumber = wearableServices.cardNumber ? wearableServices.cardNumber : "";
            wearableProfilePasswordControllerVM.wearableName = wearableServices.wearableName ? wearableServices.wearableName : "";
        });





        wearableProfilePasswordControllerVM.forgotPass = function () {
            $state.go('menu.forgotProfilePwd');
        }

        wearableProfilePasswordControllerVM.forgotpassPopup = function () {
            var havingMPINPrblmPopUp = $ionicPopup.show({
                template: "<p> If you have forgotton your profile password, you can reset the same yourself. You need to  authenticate yourself either with the hint question and answer that you had set for the Profile password or ATM Card details & PIN. You can approach branch in case you don't remember Hint Question/answer or ATM card details & PIN </p>",
                title: '',
                cssClass: 'dialog',
                scope: $scope,
                buttons: [{
                    text: 'OK',
                    type: 'button-positive'
                }]
            });
        };

        wearableProfilePasswordControllerVM.unblockProfilePassword = function () {
            wearableProfilePasswordControllerVM.myPopup.close();
            $state.go('menu.forgotProfilePwd');
        }

        wearableProfilePasswordControllerVM.checkPassword = function () {
            var loggedInUserDetails = loggedInUserService.getUserProfileDetails();
            if (wearableProfilePasswordControllerVM.newProfilePassword) {
                fTReviewService.getProfilePassAndSerKey().then(function (response) {
                    var options = {
                        inbUserName: loggedInUserDetails.inbUsername,
                        strPass: wearableProfilePasswordControllerVM.newProfilePassword,
                        keyId: response.keyId,
                        serviceId: response.serviceId,
                        osName: device.platform
                    };
                    var reqParams = utilityService.commonRequestForValidateProfilePass(options);
                    fTReviewService.getProfilePassAuth(reqParams).then(function (data) {
                        wearableProfilePasswordControllerVM.wearableFlagUpdate();

                    }, function (error) {
                        //utilityService.showErrorMessage(error.responseMessage);
                        if (error.responseCode == "INB.AUTH.016") {
                            wearableProfilePasswordControllerVM.myPopup = $ionicPopup.show({
                                title: '',
                                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter yonoWeableBackdrop',
                                templateUrl: 'pages/fundTransfer/fundsTransfer/profilePassUnblockPopUp.html',
                                scope: $scope
                            })
                        } else {
                            utilityService.enableShowErrorMessage();
                            utilityService.showErrorMessage(error.responseMessage);
                            utilityService.disableShowErrorMessage();
                        }
                    });
                }, function (error) {
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                    utilityService.disableShowErrorMessage();
                });
            } else {
                utilityService.showErrorMessage('Please enter your Internet Banking Profile Password.');
            }
        };

        wearableProfilePasswordControllerVM.gotoNext = function () {
            wearableProfilePasswordControllerVM.enabledsuccessPopup.close();
            homeScreenService.ishamburgerMenuRO = false;
            homeScreenService.isMyWearableFlag = true;
            getAccountDetailsService.tabIndex.tabIndex = 6;
            console.log("inside goToDeposits");
            $state.go('menu.accountOverviewMyBalance');
        }

        wearableProfilePasswordControllerVM.wearableFlagUpdate = function () {
            wearableServices.wearableFlagUpdate(wearableServices.cardNumber, wearableServices.accountNumber, wearableServices.ncmcFlag).then(function (data) {
                //popup
                wearableProfilePasswordControllerVM.enabledsuccessPopup = $ionicPopup.show({
                    title: '',
                    cssClass: 'popupWidth90 popupMargin ftpopup-body popupBackgroundWhite removePopup-head textAlignCenter yonoWeableBackdrop',
                    templateUrl: "pages/yonoWearable/wearableProfilePassword/enableSuccessPopup.html",
                    scope: $scope
                });

            }, function (error) {
                utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                    utilityService.disableShowErrorMessage();
            });
        }

        wearableProfilePasswordControllerVM.toggleSecretAns = function () {
            wearableProfilePasswordControllerVM.isTextReadable == true ? wearableProfilePasswordControllerVM.isTextReadable = false : wearableProfilePasswordControllerVM.isTextReadable = true;
        };




        return this;
    }
]);
