angularApp.service('wearableServices', function ($q, $http, AdapterUtils, utilityService,$ionicPopup) {
	var wearableServices = this;
	wearableServices.selectedAccountNumber = "";
	wearableServices.cardNumber = "";
	wearableServices.accountNumber = "";
	wearableServices.ncmcFlag = "";
	wearableServices.wearableName = "";
	wearableServices.wcmContent = "";

	wearableServices.accList = [];
	wearableServices.selDet = {
		accountNumber: '',
		selIndex: ''
	}


	wearableServices.selectedDetails = {
		selIndex: '',
		accountType: '',
		accountNumber: '',
		accountBalance: '',
		intCategory: '',
		accountTypeCode: '',
		amount: '',
		pin: '',
		hashyc: '',
		encpin: ''
	};

	wearableServices.selectedDetailslanding = {
		accountNumber: '',
		selIndex: ''
	}


	wearableServices.selectedDetailslanding = {
		selIndex: '',
		accountType: '',
		accountNumber: '',
		accountBalance: '',
		intCategory: '',
		accountTypeCode: '',
		amount: '',
		pin: '',
		hashyc: '',
		encpin: ''
	};

	wearableServices.linkWearable = {
		enterUrn: '',
		nickName: '',
		accountNumber: '',
		cardNumber: ''
	};
	//About Wearable postData

	wearableServices.getAboutWearableContent = function (requestData) {
		var q = $q.defer();
		var obj = {
			"tnc": "string"
		};
		AdapterUtils.postData("adapters/FundsTransferAdapter/getAboutWearableContent", obj, false).then(
			function (response) {
				q.resolve(response.data);
			},
			function (error) {
				q.reject(error);
			}
		);
		return q.promise;
	};



	//Apply Wearable postData

	wearableServices.getApplyWearableCheckpoint = function (requestData) {
		var q = $q.defer();
		var obj = {
			"tnc": "string"
		};
		AdapterUtils.postData("adapters/FundsTransferAdapter/getApplyWearableCheckpoint", obj, true).then(
			function (response) {
				q.resolve(response.data);
			},
			function (error) {
				q.reject(error);
			}
		);
		return q.promise;
	};


	//Disclaimer Wearable postData

	wearableServices.getDisclaimerWearableContent = function (requestData) {
		var q = $q.defer();
		var obj = {
			"tnc": "string"
		};
		AdapterUtils.postData("adapters/FundsTransferAdapter/getDisclaimerWearableContent", obj, true).then(
			function (response) {
				q.resolve(response.data);
			},
			function (error) {
				q.reject(error);
			}
		);
		return q.promise;
	};

	//get transactionList
	wearableServices.getTransactions = function (accountNumber, transactionFlag) {
		var q = $q.defer();
		var obj = {
			"accountNumber": accountNumber,
			"transactionFlag": transactionFlag
		};

		AdapterUtils.postData("adapters/AccountOverViewAdapter/getTransactions", obj, true).then(
			function (response) {
				q.resolve(response.data);
			},
			function (error) {
				q.reject(error);
			}
		);
		return q.promise;
	};

	//get wearable data
	wearableServices.wearableEnquiryByAccNo = function (accountNumber) {
		var q = $q.defer();
		var obj = {
			"accountNumber": accountNumber
		};

		AdapterUtils.postData("adapters/FundsTransferAdapter/wearableEnquiryByAccNo", obj, true).then(
			function (response) {
				q.resolve(response.data);
			},
			function (error) {
				q.reject(error);
			}
		);
		return q.promise;
	};

	//URN Enquiry
	wearableServices.urnEnquiry = function (urnNumber) {
		var q = $q.defer();
		var obj = {
			"urn": urnNumber
		};

		AdapterUtils.postData("adapters/FundsTransferAdapter/urnEnquiry", obj, true).then(
			function (response) {
				q.resolve(response.data);
			},
			function (error) {
				q.reject(error);
			}
		);
		return q.promise;
	};

	// wearable update transactionFlag
	wearableServices.wearableFlagUpdate = function (cardNumber, accountNumber, ncmcFlag) {
		var q = $q.defer();
		var obj = {
			"cardNumber": cardNumber,
			"accountNumber": accountNumber,
			"ncmcFlag": ncmcFlag,
		};

		AdapterUtils.postData("adapters/FundsTransferAdapter/wearableFlagUpdate", obj, true).then(
			function (response) {
				q.resolve(response.data);
			},
			function (error) {
				q.reject(error);
			}
		);
		return q.promise;
	};

	//block Wearable Request
	wearableServices.blockWearableRequest = function (cardNumber, reason, typeOfBlock) {
		var q = $q.defer();
		var obj = {
			"cardNumber": cardNumber,
			"reason": reason,
			"typeOfBlock": typeOfBlock,
		};

		AdapterUtils.postData("adapters/FundsTransferAdapter/blockWearableRequest", obj, true).then(
			function (response) {
				q.resolve(response);
			},
			function (error) {
				q.reject(error);
			}
		);
		return q.promise;
	};


	//wearable Activation Request
	wearableServices.wearableActivationRequest = function (cardNumber) {
		var q = $q.defer();
		var obj = {
			"cardNumber": cardNumber
		};

		AdapterUtils.postData("adapters/FundsTransferAdapter/wearableActivationRequest", obj, true).then(
			function (response) {
				q.resolve(response.data);
			},
			function (error) {
				q.reject(error);
			}
		);
		return q.promise;
	};

	wearableServices.sendOTP = function (requestData) {
		var q = $q.defer();
		AdapterUtils.postData("adapters/FundsTransferAdapter/generateOTPWearable", requestData, true).then(function (response) {
			q.resolve(response);
		},
			function (error) {
				utilityService.hideSpinner();
				q.reject(error);
			});
		return q.promise;
	};



	wearableServices.validateOTP = function (requestData) {
		var q = $q.defer();
		AdapterUtils.postData("adapters/OTPAdapter/validateOTPTokenOVD", requestData, true).then(function (response) {
			q.resolve(response.data);
		},
			function (error) {
				utilityService.hideSpinner();
				q.reject(error);
			});
		return q.promise;
	};

	wearableServices.displayPopUp = function (heading, css, message, buttonText, callBack) {
		var alertPopup = $ionicPopup.alert({
			title: heading,
			template: '<div class="popupTextBottomPadding  ss-popup-list fontSize-subHeading roboto-medium text-center ' + css + '">'
			+ message + '</div></div>',
			cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite ss-popup',
			buttons: [
				{
					text: buttonText,
					onTap: function (e) {
						callBack();
					}
				}
			],
		});
	};

	wearableServices.checkKYC = function () {
		var q = $q.defer();
		var obj = {

		};
		AdapterUtils.postData("adapters/FundsTransferAdapter/checkKYC", obj, true).then(function (response) {
			q.resolve(response.data);
		},
			function (error) {
				utilityService.hideSpinner();
				q.reject(error);
			});
		return q.promise;
	};

	//wearable Issuance Request
	wearableServices.wearableIssuance = function (urn,cardNumber,accountNumber,nickname) {
		var q = $q.defer();
		var obj = {
			"urn": urn,
			"cardNumber": cardNumber,
			"accountNumber": accountNumber,
			"firstName": nickname
		};

		AdapterUtils.postData("adapters/FundsTransferAdapter/wearableIssuance", obj, true).then(
			function (response) {
				q.resolve(response.data);
			},
			function (error) {
				q.reject(error);
			}
		);
		return q.promise;
	};

		//wearable MOP
	wearableServices.checkAccountOperation = function (accountNumber) {
		var q = $q.defer();
		var obj = {
			"accountNumber": accountNumber
		};

		AdapterUtils.postData("adapters/FundsTransferAdapter/checkAccountOperation", obj, true).then(
			function (response) {
				q.resolve(response.data);
			},
			function (error) {
				q.reject(error);
			}
		);
		return q.promise;
	};

	// get url
	wearableServices.verifySecKey = function (secKey) {
		return ((secKey / 2) - 1) / 99;
	}
	wearableServices.getRedirectLink = function (requestData) {
		var q = $q.defer();
		var requestSecKey = '';
		var random_num = (window.crypto.getRandomValues(new Uint32Array(1))[0]);
		requestSecKey = (random_num * 10 + 1);
		var obj = {
			"secKey" : requestSecKey
		};
		AdapterUtils.postData("adapters/FundsTransferAdapter/getRedirectLink", obj, true).then(
			function (response) {
				var finalcalculatedKey = wearableServices.verifySecKey(parseInt(response.secKey));
				if(requestSecKey === finalcalculatedKey && response.data.url)
					q.resolve(response.data);
				else{
					q.reject("Technical error, please try later.");
				}
			},
			function (error) {
				q.reject(error);
			}
		);
		return q.promise;
	};

	//whiteListing
	wearableServices.isUserWhiteListed = function () {
			var q = $q.defer();
			var obj = {
				"tnc": "string"
			};
			AdapterUtils.postData("adapters/FundsTransferAdapter/isUserWhiteListedWearable", obj, true).then(
				function (response) {
					q.resolve(response);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

	return wearableServices;
});
