angularApp.service('covidService',["$q","AdapterUtils","$ionicPopup",
	function($q,AdapterUtils,$ionicPopup){
    
    var covidService = this;
    covidService.successMsg = {};
    covidService.wcmService = {};
    covidService.fund = {};
    covidService.amount = "";

	  covidService.displayPopUp = function(heading,message,buttonText,callBack){
        var alertPopup = $ionicPopup.alert({
            title: heading,
            template: '<div class="popupTextBottomPadding ss-p-r-f-8 ss-popup-list font-size-12 font-light ss-text-color">'
            + message + '</div></div>',
            cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite ss-popup',
            buttons: [
                {
                    text: buttonText,
                    onTap: function(e) {
                        callBack();
                    }
                }
            ],
        });
    };

    covidService.formPopUpTemplate = function(array,controllerName){
			var template = '<div class="font-dark-grey irctc">'+
					'<div ng-repeat="acc in '+ array + ' track by $index">'+
						'<div class="row  borderbtm" ng-click="'+controllerName + '.close($index)">'+
						'<div class="col padtop10 font-size-20 roboto-regular color545454">₹ {{acc.accountBalance |INR}}</div>'+
						'<div class="col padTopBTM30 font-size-12 roboto-medium color545454">{{acc.accountType}}<br><span class="font-size-14 roboto-medium color545454">{{acc.accountNumber | cardmask:"X":4}}</span></div>'+
						'</div></div></div>';
			return template;
		}

    covidService.getDonationList = function () {
        var q = $q.defer();
        AdapterUtils.postData("adapters/FundsTransferAdapter/donate/getDonationList", {}, true).then(
            function (response) {
                q.resolve(response.data);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

     covidService.getDonationDetails = function (reqData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/FundsTransferAdapter/donate/getDonationDetails", reqData, true).then(
            function (response) {
                q.resolve(response.data);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    covidService.getCustomerInfo = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/HomeAdapter/customerAndAccountInfo", {}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};


     covidService.donate = function (reqData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/FundsTransferAdapter/donate/donate", reqData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

     covidService.resentOTP = function () {
        var q = $q.defer();
        AdapterUtils.postData("adapters/FundsTransferAdapter/donate/resentOTP", {}, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

     covidService.validateOtp = function (reqData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/FundsTransferAdapter/donate/validateOTP", reqData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    covidService.getReceipt = function () {
        var q = $q.defer();
        AdapterUtils.postData("adapters/FundsTransferAdapter/donate/getReceipt", {}, true).then(
            function (response) {
                q.resolve(response.data);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

	return covidService;

}]);
