'use strict';

angularApp.controller('covidSuccessController', [
	"$state",
	"$scope",
	"$rootScope",
	"utilityService",
	"covidService",
	"ompMerchantsService",
	"$ionicPopup",
	"openUrlInAppbroswerService",
	"irctcService",
	function ($state,
		$scope,
		$rootScope,
		utilityService,
		covidService,
		ompMerchantsService,
		$ionicPopup,
		openUrlInAppbroswerService,
		irctcService) {

		var covidSuccessVm = this;

		covidSuccessVm.init = function(){
			covidSuccessVm.refNumber = covidService.successMsg.refNo;
			covidSuccessVm.amount = covidService.amount;
			covidSuccessVm.fundName = covidService.fund;
			covidSuccessVm.helpLine = covidService.wcmService.helpLine;		
		}

		covidSuccessVm.redirect = function(){
			covidSuccessVm.disclaimerPopup = $ionicPopup.show({
				template: '<p><center>You will be re-directed to "' + covidService.wcmService.extUrl + '" website.</center></p>',
				title: '',
				scope: $scope,
				cssClass: 'my-custom-popup',
				buttons: [{
					text: 'I Agree',
					type: 'button-assertive',
					onTap: function () {
						ompMerchantsService.inChromeBrowser(covidService.wcmService.extUrl);
					}
				},{
					text: 'Cancel',
					type: 'button-assertive',
					onTap: function () {
						
					}
				}],
			});
		}

		covidSuccessVm.goHome = function(){
			$state.go('menu.homeScreen');
		}

		covidSuccessVm.download = function(){
			covidService.getReceipt().then(function(data) {
				var filename =  data.fileName;
				var content =  data.pdf;
				var contentType = "application/pdf";
				if(utilityService.isAndroidPlatform()){
					covidSuccessVm.android = true;
					covidSuccessVm.folderpath = cordova.file.externalRootDirectory;
				}
				if(utilityService.isIOSPlatform()){
					covidSuccessVm.folderpath = cordova.file.applicationDirectory;
				}
				irctcService.savebase64AsPDF(covidSuccessVm.folderpath,filename,content,contentType);
				if(utilityService.isIOSPlatform()){
					var finalObject = {"folderpath":covidSuccessVm.folderpath,"filename":filename};
					openUrlInAppbroswerService.openUrl("data:application/pdf;base64,"+content+"","");
				}
				if(covidSuccessVm.android) {
					var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="DOWNLOADFDRECEIPT" translate-values="{folderpath:covidSuccessVm.folderpath}"></div>';
						covidSuccessVm.downloadPopup = $ionicPopup.show({
							title: '',
							template: template,
							scope: $scope,
							cssClass: 'my-custom-popup',
							buttons: [{
								text:'OK',
								type: 'button-assertive',
								onTap: function() { 
									covidSuccessVm.downloadPopup.close();

								}
							}],
						});
				
				}
			}, function(error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		}

		$scope.$on('$ionicView.beforeEnter', function () {
			covidSuccessVm.init();
		});

		return this;
	}
]);
