angularApp.controller('donationController', [
    "$state", 
    "$scope", 
    "validateService",
    "utilityService",
    "covidService",
    "$filter",
    "hmbrtService",
    "$ionicPopup",
    "getAccountDetailsService",
    "homeScreenService",
    "customerInfoService",
    "$timeout",
    "$ionicScrollDelegate",
    function($state, 
        $scope, 
        validateService,
        utilityService,
        covidService,
        $filter,
        hmbrtService,
        $ionicPopup,
        getAccountDetailsService,
        homeScreenService,
        customerInfoService,
        $timeout,
        $ionicScrollDelegate) {


        var donationVm = this;

        donationVm.initPage = function(){
            donationVm.details = {}
            donationVm.showDetails = false;
            donationVm.showSelect = true;
            donationVm.showMore = true;
            donationVm.isCalledOnLoad = false;
            donationVm.selectedAccount = {};
            covidService.getDonationList().then(function(data) {
				donationVm.causeList = data.donations;
                var defaultFund = donationVm.causeList.find(function(element) { 
                    return element.deflt == "true"; 
                }); 
                donationVm.funType = defaultFund;
                if(donationVm.funType){
                    donationVm.getDetails();
                }
            }, function(error) {
                 utilityService.showErrorMessage(error.responseMessage);
            });
            if(!getAccountDetailsService.accountOverviewData) {  
                donationVm.isCalledOnLoad = true;
                donationVm.getCustomerInfo();
            }else{
                donationVm.setPrimaryAccount();
                if (getAccountDetailsService.accessRightsData.accounts == null || getAccountDetailsService.accessRightsData.accounts == "") {
                    getAccountDetailsService.getAccountsAccessRights('').then(function(data){
                        getAccountDetailsService.accessRightsData = data;
                    }, function(error){
                        
                    })
                }
            }
        }

        donationVm.getDetails = function(){
            donationVm.amount = "";
            var request = {
                "code": donationVm.funType.code
            };
            covidService.getDonationDetails(request).then(function(data) {
                donationVm.details = data.donation; 
                donationVm.minAmount = parseInt(data.donation.minAmount);
                donationVm.maxAmount = parseInt(data.donation.maxAmount);
                donationVm.content = JSON.parse(data.donation.content);
                covidService.wcmService = donationVm.content;
                donationVm.showDetails = true;         
            }, function(error) {
                donationVm.showDetails = false;
                donationVm.details = {};
                donationVm.funType = {};
                utilityService.showErrorMessage(error.responseMessage);
            });
        }


         donationVm.getCustomerInfo = function() {
            if (!getAccountDetailsService.accountOverviewData) {
               // homeScreenVM.welcomeTitleSpinner = true;
                homeScreenService.isCustCalled = true;
                covidService.getCustomerInfo().then(function(data) {
					//To display message for NRI customers only [residentialStatus : 1 (India), 2(NRI)]
					// if(data.customerInformation && (data.customerInformation.residentialStatus && data.customerInformation.residentialStatus === "2")){
					// 	var getNRICounterFromLocalStorage = sessionStorage.getItem('getNRICounterFromLocalStorage');
					// 	if(!getNRICounterFromLocalStorage || getNRICounterFromLocalStorage==="0"){
					// 		homeScreenVM.msgForNRICustomers();
					// 	}
					// }

					getAccountDetailsService.accountOverviewData = data;
					if(getAccountDetailsService.isProfilePwdSet && getAccountDetailsService.accountOverviewData.profilePasswordFlag){
						getAccountDetailsService.accountOverviewData.profilePasswordFlag = true;
					}
                    homeScreenService.isCustCalled = false;

                    //homeScreenVM.data = data.customerInformation;
					customerInfoService.customerInfo = data.customerInformation;
                    // localStorage.setItem("customername", homeScreenVM.data.customerName);
                   // homeScreenVM.setCustomerInofAndAccountDetails();
                  //  homeScreenVM.welcomeTitleSpinner = false;
				//	homeScreenVM.customerAge = homeScreenVM.calculateAge(homeScreenVM.data.dob);
					//homeScreenService.offersData = data.suggestedData.offers;
					//$timeout(function() {
						// if(homeScreenService.offersData && homeScreenVM.customerAge > 55){
						// 	// for(var i=0 ; i <homeScreenService.offersData.length ; i++){
						// 	// 	if(homeScreenService.offersData[i].category == "SS"){
						// 	// 		homeScreenService.offersData.splice(i, 1);
						// 	// 		homeScreenVM.offersData.splice(i, 1);
						// 	// 		break;
						// 	// 	}
						// 	// }
						// 	// homeScreenService.offersData = homeScreenService.offersData.filter(function(offer){
						// 	// 	return offer.category !== "SS";
						// 	// });
						// 	homeScreenVM.offers = [];
						// 	homeScreenVM.offers = homeScreenService.offersData.filter(function(offer){
						// 		return offer.category !== "SS";
						// 	});
						// 	homeScreenService.offersData = homeScreenVM.offers;
						// 	homeScreenVM.offersData = homeScreenVM.offers;
						// }
					//});
                    donationVm.accData = {};
                    donationVm.accData.accList = getAccountDetailsService.accountOverviewData.accounts;
                     if(!donationVm.isCalledOnLoad){
                        donationVm.showPop();
                    }
                    donationVm.setPrimaryAccount(); 
                    if (getAccountDetailsService.accessRightsData.accounts == null || getAccountDetailsService.accessRightsData.accounts == "") {
                        getAccountDetailsService.getAccountsAccessRights('').then(function(data){
                            getAccountDetailsService.accessRightsData = data;
                            //donationVm.validateAmount();
                        }, function(error){
                            
                        })
                    }
                }, function(error) {
                    homeScreenService.isCustCalled = false;
                    if(!donationVm.isCalledOnLoad){
                        utilityService.showErrorMessage(error.responseMessage);
                    }
					//homeScreenVM.welcomeTitleSpinner = false;
					//$rootScope.profileImageUrl = 'img/profile_placeholder.svg';
                });
            } 

        }

        donationVm.donate = function(){
            if(!donationVm.funType){
                utilityService.showErrorMessage("Please select Cause");            
            }else if(!donationVm.amount){
                utilityService.showErrorMessage("Please enter amount");
            }else if(angular.equals(donationVm.selectedAccount,{})){
                utilityService.showErrorMessage("Please select account");
            }else if((parseInt(donationVm.amount) < donationVm.minAmount) || (parseInt(donationVm.amount) > donationVm.maxAmount)){
                var min = "Donation amount should be min. Rs "+donationVm.minAmount + " and max Rs." + donationVm.maxAmount + " per transaction";
                utilityService.showErrorMessage(min);
            }else{
                if (getAccountDetailsService.accessRightsData.accounts == null || getAccountDetailsService.accessRightsData.accounts == "") {
                    utilityService.showSpinner();
                    getAccountDetailsService.getAccountsAccessRights('').then(function(data){
                        utilityService.hideSpinner();
                        getAccountDetailsService.accessRightsData = data;
                        donationVm.validateAmount();
                    }, function(error){
                        utilityService.hideSpinner();
                        utilityService.showErrorMessage(error.responseMessage);
                    })
                }else{
                    donationVm.validateAmount();
                }
            }
        }

        donationVm.setPrimaryAccount = function () { 
            donationVm.accDetails = getAccountDetailsService.accountOverviewData.accounts;
            var arr = donationVm.accDetails;
            for (var i = 0, j = arr.length; i < j; i++) {
                if (arr[i].accountNumber == getAccountDetailsService.accountOverviewData.customerInformation.accountNumber) {
                    var topElement = donationVm.accDetails[i];
                    if (donationVm.accDetails.indexOf(topElement) > 0) {
                        donationVm.accDetails.splice(donationVm.accDetails.indexOf(topElement), 1);
                        donationVm.accDetails.unshift(topElement);
                    }
                }
            }; 	
		};

        donationVm.validateAmount = function () {
            var isAccountTransactional = false;
            for (var i in getAccountDetailsService.accessRightsData.accounts) {
                if (getAccountDetailsService.accessRightsData.accounts[i].accountNumber === donationVm.selectedAccount.accountNumber && 
                (parseInt(getAccountDetailsService.accessRightsData.accounts[i].accessResponse) != 0 && parseInt(getAccountDetailsService.accessRightsData.accounts[i].accessResponse) != 2)) {
                    isAccountTransactional = true;
                }
            }
            if (isAccountTransactional) {
                if (getAccountDetailsService.accessRightsData.accounts) {
                for (var i in getAccountDetailsService.accessRightsData.accounts) {
                    if (getAccountDetailsService.accessRightsData.accounts[i].accountNumber === donationVm.selectedAccount.accountNumber && getAccountDetailsService.accessRightsData.accounts[i].modBalance) {
                        donationVm.sumModAccountAmount = parseFloat(donationVm.selectedAccount.accountBalance) + parseFloat(getAccountDetailsService.accessRightsData.accounts[i].modBalance);
                        break;
                    }
                    }
                } else {
                    donationVm.sumModAccountAmount = parseFloat(donationVm.selectedAccount.accountBalance);
                }
                if (donationVm.amount) {
                    if (donationVm.sumModAccountAmount >= parseInt(donationVm.amount)) {
                        var request = {
                            "code": donationVm.funType.code,
                            "amount": donationVm.amount,
                            "accountNo": donationVm.selectedAccount.accountNumber,
                            "tnc": donationVm.tnc
                        }
                        covidService.donate(request).then(function(data) {
                            covidService.fund = donationVm.funType.name;
                            covidService.amount = donationVm.amount;
                            $state.go('menu.covidOtp');       
                        }, function(error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    }else if(parseInt(donationVm.amount) > parseInt(donationVm.selectedAccount.accountBalance)){
                        utilityService.showErrorMessage("Amount cannot be more than the availiable balance in the debit account");
                    }
                }
            }else{
                utilityService.showErrorMessage("No transaction rights for this account.");
            }
        }

        donationVm.getTNC = function(){
            var title = "Terms &amp; Conditions";
            var buttontext = "OK";
            var detail = donationVm.content.tnc;
            covidService.displayPopUp(title, detail, buttontext,function(){});
        }

        donationVm.showless = function(){
            donationVm.showMore = !donationVm.showMore;
        }

        donationVm.preAmount = function(amount){
            if(amount == "500"){
                donationVm.amount = "500";
            }else if(amount == "2000"){
                donationVm.amount = "2000";
            }else if(amount == "5000"){
                donationVm.amount = "5000";
            }else if(amount == "other"){
                donationVm.amount = "";
              $timeout(function() {
                    document.getElementById('amountFocus').focus();
                    $ionicScrollDelegate.resize();
                }, 50);
             
            }
        }

        donationVm.close = function(index){
            donationVm.popUp.close();
            donationVm.accountBalance = donationVm.accData.accList[index].accountBalance;
            donationVm.accType = donationVm.accData.accList[index].accountType;
            donationVm.accountNumber = donationVm.accData.accList[index].accountNumber;
            donationVm.selectedAccount = donationVm.accData.accList[index];
			donationVm.accountError = "";
            donationVm.showSelect = false;
        }

        donationVm.showPop = function(){
            if (!getAccountDetailsService.accountOverviewData) {
                donationVm.isCalledOnLoad = false;
                donationVm.getCustomerInfo();
            }else{
                donationVm.accData = {};
                donationVm.setPrimaryAccount();
                donationVm.accData.accList = donationVm.accDetails;
                if(donationVm.accData && donationVm.accData.accList && donationVm.accData.accList.length > 0){
                    donationVm.popUpTemplate = covidService.formPopUpTemplate("donationVm.accData.accList","donationVm");
                    donationVm.popUp = $ionicPopup.show({
                        title: '',
                        cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll donation-overflow',
                        template: donationVm.popUpTemplate,
                        scope: $scope
                    });
                }
            }
		}
        
        $scope.$on('$ionicView.beforeEnter', function() {
            donationVm.initPage();
        });

    }
]);
