'use strict';

angularApp.controller('otpCovidController', [
	"$state",
	"$scope",
	"$rootScope",
	"utilityService",
	"$filter",
	"customerInfoService",
	"covidService",
	"getAccountDetailsService",
	function ($state,
		$scope,
		$rootScope,
		utilityService,
		$filter,
		customerInfoService,
		covidService,
		getAccountDetailsService) {

		var otpCovidVm = this;

		otpCovidVm.init = function(){
			otpCovidVm.mobileNumber = $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4);
			otpCovidVm.resetPinOTP = "";
			otpCovidVm.otpCount = 0;
			otpCovidVm.clickCount = 0;
			otpCovidVm.isResendDisabled = false;
		}

		otpCovidVm.goNext = function(){			
			otpCovidVm.resetPinOTP = "";
			if(!otpCovidVm.otpNumber || otpCovidVm.otpNumber.length != 6){
				otpCovidVm.resetPinOTP = "Enter valid OTP";
			}else{
				var request = {
					"otp" : otpCovidVm.otpNumber
				}
				covidService.validateOtp(request).then(function(data) {
					covidService.successMsg = data.data;
					getAccountDetailsService.accountOverviewData = '';
					$state.go('menu.covidSuccess');
				},function(error){
					if(error.responseCode == "0002"){
						var title = '';
						var template = "<p> "+error.responseMessage +" </p>";
						var onTap = 'menu.homeScreen';
						var buttontext = "<b>OK</b>";
						utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
					}else{
						otpCovidVm.otpNumber = "";
						otpCovidVm.otpCount++;
						if(otpCovidVm.otpCount >= 3){
							var title = '';
							var template = "<p> "+error.responseMessage +" </p>";
							var onTap = 'menu.homeScreen';
							var buttontext = "<b>OK</b>";
							utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
						}else{
							utilityService.showErrorMessage(error.responseMessage);
						}
					}
				});
			}
		}

		otpCovidVm.resendOTP = function(){
			 covidService.resentOTP().then(function(data) {
				otpCovidVm.otpNumber = "";
				otpCovidVm.resetPinOTP = "";
				otpCovidVm.clickCount++;
				if(otpCovidVm.clickCount >= 2){
					otpCovidVm.isResendDisabled = true;
				}
				var template = "<p> "+ "OTP has been sent to your registered mobile number." +" </p>";
				var onTap = '';
				var buttontext = "<b>OK</b>";
				utilityService.showAlertModal('', template, onTap, $scope, $state, buttontext);
			},function(error){
				utilityService.showErrorMessage(error.responseMessage);
			});		
		}

		$scope.$on('$ionicView.beforeEnter', function () {
			otpCovidVm.init();
		});

		return this;
	}
]);




		
